package com.company;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream("input.txt"));
        PrintStream out = new PrintStream("out.txt");

        int count = scanner.nextInt();

        for (int i = 0; i < count; i++) {
            doTask(i + 1, scanner, out);
        }
    }

    private static void doTask(int id, Scanner scanner, PrintStream out) {

        int n = scanner.nextInt();
        int c = scanner.nextInt();
        int m = scanner.nextInt();

        int[] positions = new int[m];
        int[] customers = new int[m];
        int[] positionCount = new int[n];
        int[] customerCount = new int[c];
        int maxCustomerCount = -1;

        for (int i = 0; i < m; i++) {
            positions[i] = scanner.nextInt();
            customers[i] = scanner.nextInt();
            customerCount[customers[i] - 1]++;
            positionCount[positions[i] - 1]++;
            if (customerCount[customers[i] - 1] > maxCustomerCount) {
                maxCustomerCount = customerCount[customers[i] - 1];
            }
        }

        int impr = 0;
        int toMuch = 0;
        int seatsFree = 0;
        if (positionCount[0] <= maxCustomerCount) {
            seatsFree = maxCustomerCount - positionCount[0];
        } else {
            impr = toMuch = positionCount[0] - maxCustomerCount;
        }

        for (int i = 1; i < c; i++) {
            if (positionCount[i] <= maxCustomerCount) {
                seatsFree += maxCustomerCount - positionCount[i];
            } else {
                int missing = positionCount[i] - maxCustomerCount;
                if (missing <= seatsFree) {
                    seatsFree -= missing;
                } else {
                    toMuch += missing - seatsFree;
                    seatsFree = 0;
                    int newImpr = (i + toMuch) / (i + 1);
                    if (newImpr > impr) {
                        impr = newImpr;
                    }
                }
            }
        }

        int flights = maxCustomerCount + impr;
        int changes = 0;

        for (int i = 0; i < c; i++) {
            if (positionCount[i] >= flights) {
                changes += positionCount[i] - flights;
            }
        }

        out.print("Case #" + id + ": ");
        out.print(flights);
        out.print(' ');
        out.println(changes);
    }

    private static boolean find(int[] counts, int i, int sum, int p) {

        if (i == 0) return sum % p == 0;

        for (int j = 0; j < p; j++) {
            if (counts[j] > 0 && find(counts, i - 1, (sum + j) % p, p)) {
                counts[j]--;
                return true;
            }
        }
        return false;
    }

    private static boolean canBoth(int i, int j) {

        if (i > j) {
            return canBoth(j, i);
        }

        return !(j == 5 && i == 0) && Math.abs(i - j) > 1;

    }
}
