package com.company;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream("input.txt"));
        PrintStream out = new PrintStream("out.txt");

        int count = scanner.nextInt();

        for (int i = 0; i < count; i++) {
            doTask(i + 1, scanner, out);
        }
    }

    private static void doTask(int id, Scanner scanner, PrintStream out) {

        int n = scanner.nextInt();
        int q = scanner.nextInt();
        int[] mDist = new int[n];
        int[] mSpeed = new int[n];

        for (int i = 0; i < n; i++) {
            mDist[i] = scanner.nextInt();
            mSpeed[i] = scanner.nextInt();
        }

        int[][] d = new int[n][n];
        int[][] minDist = new int[n][n];

        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                d[i][j] = scanner.nextInt();
                minDist[i][j] = (i == j) ? 0 : -1;
            }
        }

        for (int i = 0; i < n; i++) {
            int start = i;
            PriorityQueue<HelpNode> queue = new PriorityQueue<>();
            queue.add(new HelpNode(start, 0));

            while (!queue.isEmpty()) {
                HelpNode node = queue.remove();
                if (minDist[start][node.id] != -1 && minDist[start][node.id] > node.dist) {
                    continue;
                }

                if (node.dist > mDist[start]) {
                    break;
                }

                for (int j = 0; j < n; j++) {
                    if (d[node.id][j] == -1) {
                        continue;
                    }
                    if (minDist[start][j] == -1 || d[node.id][j] + minDist[start][node.id] < minDist[start][j]) {
                        minDist[start][j] = d[node.id][j] + minDist[start][node.id];
                        queue.add(new HelpNode(j, minDist[start][j]));
                    }
                }
            }
        }

        double[] results = new double[q];

        for (int i = 0; i < q; i++) {
            int from = scanner.nextInt() - 1;
            int to = scanner.nextInt() - 1;

            PriorityQueue<HelpNode> queue = new PriorityQueue<>();
            queue.add(new HelpNode(from, 0));

            double time[] = new double[n];
            for (int j = 0; j < n; j++) {
                time[j] = Double.MAX_VALUE;
            }

            time[from] = 0;

            while (!queue.isEmpty()) {
                HelpNode node = queue.remove();
                if (time[node.id] > node.dist) {
                    continue;
                }

                if (node.id == to) {
                    results[i] = node.dist;
                    break;
                }

                for (int j = 0; j < n; j++) {
                    if (minDist[node.id][j] == -1 || minDist[node.id][j] > mDist[node.id]) {
                        continue;
                    }

                    if (minDist[node.id][j] / (double) mSpeed[node.id] + time[node.id] < time[j]) {
                        time[j] = time[node.id] + minDist[node.id][j] / (double) mSpeed[node.id];
                        queue.add(new HelpNode(j, time[j]));
                    }
                }
            }

        }


        out.print("Case #" + id + ":");
        for (int i = 0; i < q; i++) {
            out.print(' ');
            out.print(results[i]);
        }
        out.println();
    }

    public static class HelpNode implements Comparable<HelpNode> {

        int id;
        double dist;

        public HelpNode(int id, double dist) {
            this.id = id;
            this.dist = dist;
        }

        @Override
        public int compareTo(HelpNode o) {
            return Double.compare(dist, o.dist);
        }
    }
}
