package com.company;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Scanner;
import java.util.concurrent.LinkedBlockingQueue;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream("input.txt"));
        PrintStream out = new PrintStream("out.txt");

        int count = scanner.nextInt();

        for (int i = 0; i < count; i++) {
            doTask(i + 1, scanner, out);
        }
    }

    private static void doTask(int id, Scanner scanner, PrintStream out) {

        int c = scanner.nextInt();
        int r = scanner.nextInt();
        int m = scanner.nextInt();

        char[][] field = new char[r][c];
        Node[] solderPositions = new Node[100];
        Node[] towerPositions = new Node[100];
        int solderCount = 0;
        int towerCount = 0;
        int shootCount = 0;
        Node[] shoots = new Node[100];

        for (int i = 0; i < r; i++) {
            field[i] = scanner.next().toCharArray();
            for (int j = 0; j < c; j++) {
                if (field[i][j] == 'S') {
                    field[i][j] = ' ';
                    solderPositions[solderCount++] = new Node(i, j);
                } else if (field[i][j] == 'T') {
                    towerPositions[towerCount++] = new Node(i, j);
                }
            }
        }

        List<Integer>[] canReach = new LinkedList[solderCount];
        int[] reachCount = new int[solderCount];

        for (int solderId = 0; solderId < solderCount; solderId++) {
            int[][] dist = new int[r][c];
            Queue<Node> querry = new LinkedBlockingQueue<>();
            querry.add(solderPositions[solderId]);
            canReach[solderId] = new LinkedList<>();

            while (!querry.isEmpty()) {

                Node top = querry.remove();

                boolean can;

                can = true;
                for (int i = 1; i + top.x < r && can; i++) {
                    if (field[top.x + i][top.y] == 'T') {
                        int towerId = -1;
                        for (int j = 0; j < towerCount; j++) {
                            if (towerPositions[j].x == top.x + i && towerPositions[j].y == top.y) {
                                towerId = j;
                            }
                        }
                        reachCount[solderId]++;
                        if (!canReach[solderId].contains(towerId)) {
                            canReach[solderId].add(towerId);
                        }
                    } else if (field[top.x + i][top.y] == '#') {
                        can = false;
                    }
                }

                can = true;
                for (int i = 1; i + top.y < c && can; i++) {
                    if (field[top.x][top.y + i] == 'T') {
                        int towerId = -1;
                        for (int j = 0; j < towerCount; j++) {
                            if (towerPositions[j].x == top.x && towerPositions[j].y == top.y + i) {
                                towerId = j;
                            }
                        }
                        reachCount[solderId]++;
                        if (!canReach[solderId].contains(towerId)) {
                            canReach[solderId].add(towerId);
                        }
                    } else if (field[top.x][top.y + i] == '#') {
                        can = false;
                    }
                }

                can = true;
                for (int i = 1; top.x - i > 0 && can; i++) {
                    if (field[top.x - i][top.y] == 'T') {
                        int towerId = -1;
                        for (int j = 0; j < towerCount; j++) {
                            if (towerPositions[j].x == top.x - i && towerPositions[j].y == top.y) {
                                towerId = j;
                            }
                        }
                        reachCount[solderId]++;
                        if (!canReach[solderId].contains(towerId)) {
                            canReach[solderId].add(towerId);
                        }
                    } else if (field[top.x - i][top.y] == '#') {
                        can = false;
                    }
                }

                can = true;
                for (int i = 1; top.y - i > 0 && can; i++) {
                    if (field[top.x][top.y - i] == 'T') {
                        int towerId = -1;
                        for (int j = 0; j < towerCount; j++) {
                            if (towerPositions[j].x == top.x && towerPositions[j].y == top.y - i) {
                                towerId = j;
                            }
                        }
                        reachCount[solderId]++;
                        if (!canReach[solderId].contains(towerId)) {
                            canReach[solderId].add(towerId);
                        }
                    } else if (field[top.x][top.y - i] == '#') {
                        can = false;
                    }
                }


                if (dist[top.x][top.y] == m) {
                    continue;
                }

                if (top.x > 0) {
                    Node n = new Node(top.x - 1, top.y);
                    if (field[n.x][n.y] != '#' && dist[n.x][n.y] == 0) {
                        dist[n.x][n.y] = 1 + dist[top.x][top.y];
                        querry.add(n);
                    }
                }

                if (top.y < c - 1) {
                    Node n = new Node(top.x, top.y + 1);
                    if (field[n.x][n.y] != '#' && dist[n.x][n.y] == 0) {
                        dist[n.x][n.y] = 1 + dist[top.x][top.y];
                        querry.add(n);
                    }
                }

                if (top.x < r - 1) {
                    Node n = new Node(top.x + 1, top.y);
                    if (field[n.x][n.y] != '#' && dist[n.x][n.y] == 0) {
                        dist[n.x][n.y] = 1 + dist[top.x][top.y];
                        querry.add(n);
                    }
                }

                if (top.y > 0) {
                    Node n = new Node(top.x, top.y - 1);
                    if (field[n.x][n.y] != '#' && dist[n.x][n.y] == 0) {
                        dist[n.x][n.y] = 1 + dist[top.x][top.y];
                        querry.add(n);
                    }
                }
            }
        }

        boolean[] solShoot = new boolean[solderCount];

        while (true) {

            int maxReach = 101;
            int solderId = 0;

            for (int i = 0; i < solderCount; i++) {
                if (canReach[i].size() > 0 && canReach[i].size() < maxReach && !solShoot[i]) {
                    maxReach = canReach[solderId].size();
                    solderId = i;
                }
            }

            if (maxReach == 101) {
                break;
            }

            solShoot[solderId] = true;

            int towerId = canReach[solderId].get(0);

            shoots[shootCount++] = new Node(solderId + 1, towerId + 1);
            for (int i = 0; i < solderCount; i++) {
                if (canReach[i].contains(towerId)) {
                    canReach[i].remove((Integer) towerId);
                    reachCount[i]--;
                }
            }
        }

        out.println("Case #" + id + ": " + shootCount);
        for (int i = 0; i < shootCount; i++) {
            out.println(shoots[i].x + " " + shoots[i].y);
        }
    }

    private static boolean find(int[] counts, int i, int sum, int p) {

        if (i == 0) return sum % p == 0;

        for (int j = 0; j < p; j++) {
            if (counts[j] > 0 && find(counts, i - 1, (sum + j) % p, p)) {
                counts[j]--;
                return true;
            }
        }
        return false;
    }

    private static boolean canBoth(int i, int j) {

        if (i > j) {
            return canBoth(j, i);
        }

        return !(j == 5 && i == 0) && Math.abs(i - j) > 1;

    }

    private static class Node {
        int x, y;

        public Node(int x, int y) {
            this.x = x;
            this.y = y;
        }
    }
}
