package com.company;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream("input.txt"));
        PrintStream out = new PrintStream("out.txt");

        int count = scanner.nextInt();

        for (int i = 0; i < count; i++) {
            doTask(i + 1, scanner, out);
        }
    }

    private static void doTask(int id, Scanner scanner, PrintStream out) {

        int n = scanner.nextInt();
        int p = scanner.nextInt();

        int[] counts = new int[p];

        for (int i = 0; i < n; i++) {
            counts[scanner.nextInt() % p]++;
        }

        int erg = counts[0];
        n -= counts[0];
        counts[0] = 0;

        for (int i = 2; i <= p; i++) {
            while (find(counts, i, 0, p)) {
                erg++;
                n -= i;
            }
        }

        if (n > 0) {
            erg++;
        }

        out.print("Case #" + id + ": ");
        out.println(erg);
    }

    private static boolean find(int[] counts, int i, int sum, int p) {

        if (i == 0) return sum % p == 0;

        for (int j = 0; j < p; j++) {
            if (counts[j] > 0 && find(counts, i - 1, (sum + j) % p, p)) {
                counts[j]--;
                return true;
            }
        }
        return false;
    }

    private static boolean canBoth(int i, int j) {

        if (i > j) {
            return canBoth(j, i);
        }

        return !(j == 5 && i == 0) && Math.abs(i - j) > 1;

    }
}
