package com.company;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream("input.txt"));
        PrintStream out = new PrintStream("out.txt");

        int count = scanner.nextInt();

        for (int i = 0; i < count; i++) {
            doTask(i + 1, scanner, out);
        }
    }

    private static void doTask(int id, Scanner scanner, PrintStream out) {
        long n = scanner.nextLong();
        long k = scanner.nextLong();

        long y = 0, z = 0;

        PriorityQueue<HelperNode> queue = new PriorityQueue<>();
        queue.add(new HelperNode(1L, n));

        for (long i = 1; i < k; i++) {
            HelperNode node = queue.remove();
            queue.add(new HelperNode(node.start, node.ele() - 1));
            queue.add(new HelperNode(node.ele() + 1, node.end));
        }

        HelperNode lastNode = queue.remove();

        out.println("Case #" + id + ": " + lastNode.max() + " " + lastNode.min());
    }

    private static class HelperNode implements Comparable<HelperNode> {

        long start, end;

        HelperNode(long start, long end) {
            this.start = start;
            this.end = end;
        }


        @Override
        public int compareTo(HelperNode that) {
            int o = -Long.compare(this.min(), that.min());
            if (o == 0) {
                o = -Long.compare(this.max(), that.max());
            }
            if (o == 0) {
                o = Long.compare(this.left(), that.left());
            }
            return o;
        }

        long left() {
            return ele() - start;
        }

        long right() {
            return end - ele();
        }

        long max() {
            return Math.max(left(), right());
        }

        long min() {
            return Math.min(left(), right());
        }

        long ele() {
            return (start + end) / 2;
        }
    }
}
