package com.company;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new FileInputStream("input.txt"));
        PrintStream out = new PrintStream("out.txt");

        int count = scanner.nextInt();

        for (int i = 0; i < count; i++) {
            doTask(i + 1, scanner, out);
        }
    }

    private static void doTask(int id, Scanner scanner, PrintStream out) {

        String outputString = "ROYGBV";

        int n = scanner.nextInt();
        int[] counts = new int[6];

        for (int i = 0; i < 6; i++) {
            counts[i] = scanner.nextInt();
        }

        int[] ids = new int[n];

        int maxId = 0;

        for (int i = 0; i < 6; i++) {
            if (counts[maxId] < counts[i]) {
                maxId = i;
            }
        }
        ids[0] = maxId;
        counts[maxId]--;

        for (int i = 1; i < n; i++) {
            maxId = ids[i - 1] == 5 ? 1 : (ids[i - 1] < 2 ? 4 : 0);
            for (int j = 0; j < 6; j++) {
                if (canBoth(j, ids[i - 1]) && counts[maxId] < counts[j]) {
                    maxId = j;
                }
            }
            ids[i] = maxId;
            counts[maxId]--;
            if (counts[maxId] < 0) {
                out.println("Case #" + id + ": IMPOSSIBLE");
                return;
            }
        }
        out.print("Case #" + id + ": ");

        if (n > 3 && !canBoth(ids[0], ids[n - 1]) && canBoth(ids[n - 2], ids[0]) && canBoth(ids[n - 2], ids[0]) && canBoth(ids[n - 1], ids[n - 3])) {
            int z = ids[n - 1];
            ids[n - 1] = ids[n - 2];
            ids[n - 2] = z;
        }

        if (!canBoth(ids[0], ids[n - 1])) {
            out.println("IMPOSSIBLE");
        } else {
            for (int i = 0; i < n; i++) {
                out.print(outputString.charAt(ids[i]));
            }
            out.println();
        }
    }

    private static boolean canBoth(int i, int j) {

        if (i > j) {
            return canBoth(j, i);
        }

        return !(j == 5 && i == 0) && Math.abs(i - j) > 1;

    }
}
