import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class Consonants {
	
	private BufferedReader reader;
	private long numOfTestCases;
	char [] vowels = {'a','e','i','o','u'};
	
	public String getName(String input) {
		return input.split("\\s")[0];
	}



	public long getN(String input) {
		return Long.parseLong(input.split("\\s")[1]);
	}


	public long getNumOfTestCases() throws Exception {
		String text = reader.readLine();
		if(text!=null){
			numOfTestCases = Long.parseLong(text);
		}
		return numOfTestCases;
	}

	
	
	public BufferedReader getReader(String path) throws Exception{
		reader = new BufferedReader(new FileReader(path));
		return reader;
	}
	
	public String getNextLine() throws IOException{
		String text = reader.readLine();
		return text;
	}
	
	public List<String> getSpecifiedNumberOfLines(int num) throws Exception{
		List<String> list = new ArrayList<String>();
		String text = reader.readLine();
		int i=0;
		while(text!=null && i<=num){
			list.add(text);
			text = reader.readLine();
			i++;
		}
		return list;
	}
	
	private boolean isConsonant(char ch ){
		for(int i=0;i<vowels.length;i++){
			if(vowels[i]==ch){
				return false;
			}
		}
		return true;
	}

	public Consonants() {
		// TODO Auto-generated constructor stub
	}

	
	public boolean hasConsecutiveConsonant(String input, long n){
		long count=0;
		for(int i=0;i<input.length();i++){
			if(isConsonant(input.charAt(i))){
				++count;
				if(count==n){
					return true;
				}
			} else{
				count=0;
			}
		}
		return false;
	}
	
	public String truncateString(String str, int startIndex, int endIndex){
		return str.substring(startIndex, endIndex);
	}
	
	public void solve(String path) throws Exception{
		getReader(path);
		getNumOfTestCases();
		long i=1;
		String input = null;
		String name = null;
		long n;
		long nValue=0;
		String str = null;
		String truncatedString = null;
		while(i<=numOfTestCases){
			n=0;
			truncatedString = null;
			input = getNextLine();
			name = getName(input);
			n = getN(input);
			int j=0;
			int start = 0;
			int end = name.length();
			nValue = 0;
			do{
				str = truncateString(name, start, end);
				j=0;
				if(str.equals("")){
					break;
				}
				do{
					truncatedString = str.substring(0, str.length()-j);
					if(hasConsecutiveConsonant(truncatedString, n)){
						nValue++;
					}
					j++;
				}while(truncatedString.length()>n);
				j=1;
				do{
					truncatedString = str.substring(j);
					if(hasConsecutiveConsonant(truncatedString, n)){
						nValue++;
					}
					j++;
				}while(truncatedString.length()>n);
				start++;
				end--;
			}while(str.length()>n);
			System.out.println("Case #"+i+": "+nValue);
			writeOutput(i, String.valueOf(nValue));
			i++;			
		}
	}
	
	public void writeOutput(long caseNo, Object status) throws Exception{
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.in",true));
		try{
			writer.write("Case #"+caseNo+": "+status);
			writer.newLine();
		} catch(Exception e){
			e.printStackTrace();
		} finally{
			writer.close();
		}
		
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Consonants c = new Consonants();
		try{
			c.solve("A-small-attempt0.in");
		} catch(Exception e){
			e.printStackTrace();
		} finally{
			try {
				c.reader.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}

}
