import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class TicTacToeResultBoard {

	private String [] gameStatus = {"X won","O won","Draw","Game has not completed"};
	private int numberOfTestCases;
	private String [][] input = new String [4][4];
	public TicTacToeResultBoard() {
		// TODO Auto-generated constructor stub
	}
	
	private void readInputFile(String filePath) throws Exception{
		FileReader inputReader = null;
		BufferedWriter writer = null;
		try {
			inputReader = new FileReader(filePath);
			writer = new BufferedWriter(new FileWriter("Output.in"));
			int text = inputReader.read();
			char ch;
			int testCaseNo=0;
			String status=null;
			ch =  (char)text;
			while(!Character.isWhitespace(ch)){
				text = inputReader.read();
				ch =  (char)text;
			}
			//numberOfTestCases = Integer.parseInt(Character.toString((char)text));
			text = inputReader.read();
			while(text!=-1){
				ch = (char)text;
				if(Character.isWhitespace(ch)){
					text = inputReader.read();
					continue;
				}
				for(int i=0;i<input.length;i++){
					for(int j=0;j<input.length;j++){						
						if(!Character.isWhitespace(ch)){
							input[i][j] = Character.toString(ch);
						}						
						text = inputReader.read();
						ch = (char)text;
					}
					while(Character.isWhitespace(ch)){
						text = inputReader.read();
						ch = (char)text;
					}
				}
				status = getStatus();
				++testCaseNo;
				writeOutput(testCaseNo, status, writer);
				//text = inputReader.read();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			throw e;
		} catch (IOException e) {
			e.printStackTrace();
			throw e;
		} catch (NumberFormatException nfe){
			nfe.printStackTrace();
			throw new Exception("Invalid test case input");
		} finally{
			if(inputReader!=null){
				inputReader.close();
			}
			if(writer!=null){
				try {
					writer.close();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
		}
	}
	
	public void writeOutput(int caseNo, String status, BufferedWriter writer){
		try{
			writer.write("Case #"+caseNo+": "+status);
			writer.newLine();
		} catch(Exception e){
			e.printStackTrace();
		}
		
	}
	
	private String getStatus(){
		if(hasXWon()){
			return "X won";
		}
		if(hasOWon()){
			return "O won";
		}
		if(isGameDraw()){
			return "Draw";
		} else{
			return "Game has not completed";
		}
	}
	
	/*private void checkRowWise(){
		hasXWon();
		hasOWon();
		isGameDraw();
		isIncomplete();
	}
	
	private void checkColumnWise(){
		
	}
	
	
	private void checkDiagonally(){
		
	}*/
	
	private boolean hasXWon(){
		int ctr=0;
		for (int i = 0; i < input.length; i++) {
			for (int j = 0; j < input.length; j++) {
				if(input[i][j].equals("X") || input[i][j].equals("T")){
					++ctr;
				}
			}
			if(ctr==4){
				return true;
			}
			ctr=0;
		}
		for (int i = 0; i < input.length; i++) {
			for (int j = 0; j < input.length; j++) {
				if(input[j][i].equals("X") || input[j][i].equals("T")){
					++ctr;
				}
			}
			if(ctr==4){
				return true;
			}
			ctr=0;
		}
		for (int i = 0; i < input.length; i++) {
			for (int j = i; j <= i; j++) {
				if(input[i][j].equals("X") || input[i][j].equals("T")){
					++ctr;
				}
			}
		}
		if(ctr==4){
			return true;
		}
		ctr=0;
		for (int i = input.length-1; i >= 0; i--) {
			int j = ((input.length-1) - i);
				if(input[i][j].equals("X") || input[i][j].equals("T")){
					++ctr;
				}
		}
		if(ctr==4){
			return true;
		}
		return false;
	}

	private boolean hasOWon(){
		int ctr=0;
		for (int i = 0; i < input.length; i++) {
			for (int j = 0; j < input.length; j++) {
				if(input[i][j].equals("O") || input[i][j].equals("T")){
					++ctr;
				}
			}
			if(ctr==4){
				return true;
			}
			ctr=0;
		}
		for (int i = 0; i < input.length; i++) {
			for (int j = 0; j < input.length; j++) {
				if(input[j][i].equals("O") || input[j][i].equals("T")){
					++ctr;
				}
			}
			if(ctr==4){
				return true;
			}
			ctr=0;
		}
		for (int i = 0; i < input.length; i++) {
			for (int j = i; j <= i; j++) {
				if(input[i][j].equals("O") || input[i][j].equals("T")){
					++ctr;
				}
			}
		}
		if(ctr==4){
			return true;
		}
		ctr=0;
		for (int i = input.length-1; i >= 0; i--) {
			int j = ((input.length-1) - i);
				if(input[i][j].equals("O") || input[i][j].equals("T")){
					++ctr;
				}
		}
		if(ctr==4){
			return true;
		}
		return false;
	}

	private boolean isGameDraw(){
		int ctr=0;
		for (int i = 0; i < input.length; i++) {
			for (int j = 0; j < input.length; j++) {
				if(input[i][j].equals(".")){
					++ctr;
				}
			}
		}		
		if(ctr>0){
			return false;
		} else{
			return true;
		}		
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			new TicTacToeResultBoard().readInputFile("A-small-attempt3.in");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
