import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.PriorityQueue;
import java.util.Scanner;

public class C {
	private static Scanner scan = new Scanner(System.in);
	private static boolean[][] used;
	private static int w, h;
	private static PriorityQueue<Coords> upMoves = new PriorityQueue<Coords>();
	public static void main(String[] args) throws FileNotFoundException {
		int cases = scan.nextInt();
		PrintStream outfile = new PrintStream("C-small.out.txt");

		String result = "";
		int answer = 0;
		for (int c = 1; c <= cases; c++) {
			w = scan.nextInt();
			h = scan.nextInt();
			used = new boolean[w][h];
			int b = scan.nextInt();
			for (int i = 0; i < b; i++) {
				int x0 = scan.nextInt();
				int y0 = scan.nextInt();
				int x1 = scan.nextInt();
				int y1 = scan.nextInt();
				for (int x = x0; x <= x1; x++) {
					used[x][y0] = true;
					used[x][y1] = true;
				}
				for (int y = y0; y <= y1; y++) {
					used[x0][y] = true;
					used[x1][y] = true;
				}
			}
			//printMap();
			
			answer = 0;
			for (int x = 0; x < w; x++) {
				upMoves.clear();
				if (visit(x, 0))
					answer++;
				else while (!upMoves.isEmpty()) {
					Coords crds = upMoves.poll();
					if (visit(crds.x, crds.y)) {
						answer++;
						break;
					}
				}
			}

			result = "Case #" + c + ": " + answer;
			outfile.println(result);
			System.out.println(result);
		}
		outfile.close();
	}
	
	private static void printMap() {
		for (int y = h-1; y >= 0; y--) {
			for (int x = 0; x < w; x++)
				System.out.print(used[x][y] ? 'x' : '.');
			System.out.println();
		}
	}
	
	private static boolean canVisit(int x, int y) {
		if (x < 0 || x >= w)
			return false;
		if (y < 0 || y >= h)
			return false;
		if (used[x][y])
			return false;
		return true;
	}
	
	private static boolean visit(int x, int y) {
		if (!canVisit(x, y))
			return false;
		used[x][y] = true;
		//printMap();
		if (y == h-1)
			return true;
		if (visit(x-1, y))
			return true;
		if (visit(x, y+1))
			return true;
		if (visit(x+1, y))
			return true;
		if (canVisit(x, y-1))
			upMoves.add(new Coords(x, y-1));
		return false;
	}
	
	private static class Coords implements Comparable<Coords> {
		public final int x, y;
		public Coords(int x, int y) {
			this.x = x;
			this.y = y;
		}
		public int id() {
			return (h - y) * w + x;
		}
		public int compareTo(Coords other) {
			return ((Integer) id()).compareTo(other.id());
		}
	}
}
