import java.util.*;
import java.io.*;

class Connection implements Comparable<Connection> {

    int dist;
    int index;
    int horse;
    double time;

    public Connection(int d, int i, int h, double t){
        dist = d;
        index = i;
        horse = h;
        time = t;
    }

    @Override
    public int compareTo(Connection c){
        return Integer.compare(dist, c.dist);
    }

}

public class Main {

    public static int n, q;
    public static int[] ei, si, eiCopy;
    public static ArrayList<Integer> connections[];
    public static int[][] distance;

    public static void main(String[] args) throws Exception{
        
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out);

        int tt = Integer.parseInt(in.readLine());
        StringBuilder ans = new StringBuilder();

        for(int i = 1; i <= tt; i++) {

            String[] input = in.readLine().split("\\s+");

            n = Integer.parseInt(input[0]);
            q = Integer.parseInt(input[1]);

            ei = new int[n];
            si = new int[n];
            connections = new ArrayList[n];
            distance = new int[n][n];

            for(int j = 0; j < n; j++){
                input = in.readLine().split("\\s+");
                ei[j] = Integer.parseInt(input[0]);
                si[j] = Integer.parseInt(input[1]);
                connections[j] = new ArrayList<Integer>();
            }

            for(int j = 0; j < n; j++){
                input = in.readLine().split("\\s+");
                for(int k = 0; k < n; k++){
                    int dist = Integer.parseInt(input[k]);
                    distance[j][k] = dist;
                    if(dist != -1){
                        connections[j].add(k);
                    }
                }
            }

            ans.append("Case #" + i + ":");

            for(int j = 0; j < q; j++){
                input = in.readLine().split("\\s+");
                int uk = Integer.parseInt(input[0]) - 1;
                int vk = Integer.parseInt(input[1]) - 1;
                double minTime = calcMinTime(uk, vk);

                ans.append(" " + minTime);
            }

            ans.append("\n");
        }

        out.print(ans);

        in.close();
        out.close();

    } 

    public static double calcMinTime(int uk, int vk){

        double[] minTime = new double[n];
        for(int i = 0; i < n; i++){
            minTime[i] = Double.MAX_VALUE;
        }

        boolean[][][] visited = new boolean[n][n][n];

        PriorityQueue<Connection> queue = new PriorityQueue<Connection>();

        queue.add(new Connection(ei[uk], uk, uk, 0));

        while(queue.size() > 0){
            Connection conn = queue.poll();
            int ind = conn.index;
            int dist = conn.dist;
            int horse = conn.horse;
            double time = conn.time;


            for(int vj : connections[ind]){

                int newDist = dist - distance[ind][vj];
                if(newDist >= 0){
                    double suppTime = 1.0 * distance[ind][vj] / si[horse];
                    if(!visited[ind][vj][horse] || suppTime + time < minTime[vj]){
                        visited[ind][vj][horse] = true;
                        if(suppTime + time < minTime[vj])
                            minTime[vj] = time + suppTime;
                        queue.add(new Connection(newDist, vj, horse, time + suppTime));
                        queue.add(new Connection(ei[vj], vj, vj, minTime[vj]));
                    }
                }

            }
        }

        return minTime[vk];

    }
}
