import java.util.*;
import java.io.*;

class range implements Comparable<range> {

    public long start;
    public long end;

    public range(long s, long e){
        start = s;
        end = e;
    }

    @Override
    public int compareTo(range r){

        if(end - start > r.end - r.start)
            return -1;
        if(end - start < r.end - r.start)
            return 1;
        if(start <= r.start)
            return -1;
        return 1;

    }

}

public class Main {

    public static void main(String[] args) throws Exception{
        
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(System.out);

        int tt = Integer.parseInt(in.readLine());
        StringBuilder ans = new StringBuilder();

        for(int i = 1; i <= tt; i++) {

            String[] input = in.readLine().split("\\s+");

            long n = Long.parseLong(input[0]);
            long k = Long.parseLong(input[1]);
            
            PriorityQueue<range> queue = new PriorityQueue<range>();

            long count = 0;
            queue.add(new range(1, n));

            while(count < k-1){
                range tmp = queue.poll();
                long mid = (long) Math.ceil((tmp.end-tmp.start+1)/2.0);
                if(tmp.start <= tmp.start+mid-2){
                    queue.add(new range(tmp.start, tmp.start+mid-2));
                }
                if(tmp.start+mid <= tmp.end){
                    queue.add(new range(tmp.start+mid, tmp.end));
                }
                count++;
            }

            range last = queue.poll();
            long maxMax = (last.end - last.start) / 2;
            long maxMin = (last.end - last.start + 1) / 2;

            ans.append("Case #" + i + ": " + maxMin + " " + maxMax + "\n");

        }

        out.println(ans);

        in.close();
        out.close();

    } 
}
