package cj1a;

import static java.lang.Double.parseDouble;
import static java.lang.Integer.parseInt;
import static java.lang.Long.parseLong;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class AlphabetCake {

  private static StringTokenizer stringTokenizer;
  private static BufferedReader inputBufferReader;
  private static PrintWriter printWriter;
  private static int currentTest;

  public static void main(String[] args) {
    try {
      printWriter = new PrintWriter(new OutputStreamWriter(System.out));
      inputBufferReader = new BufferedReader(new InputStreamReader(System.in));
      int tests = nextInt();
      for (currentTest = 1; currentTest <= tests; currentTest++) {
        solve();
      }
      inputBufferReader.close();
      printWriter.close();
    } catch (Throwable e) {
      e.printStackTrace();
    }
  }

  private static void solve() throws IOException {

    int rows = nextInt();

    int columns = nextInt();

    char[][] cakeDesign = getCakeDesign(rows, columns);

    List<Character> markedChars = new ArrayList<>();

    for (int r=0; r<rows; r++) {
      for (int col = 0; col < columns; col++) {

        if (cakeDesign[r][col] != '?' && !markedChars.contains(cakeDesign[r][col])) {
          markedChars.add(cakeDesign[r][col]);
          int min=col;
          int max=col;

          for (int x=col+1; x<columns; x++) {
            if (cakeDesign[r][x] == '?') {
              cakeDesign[r][x] = cakeDesign[r][col];
              max=x;
            } else {
              break;
            }
          }

          for (int y=col-1; y>-1; y--) {
            if (cakeDesign[r][y] == '?') {
              cakeDesign[r][y] = cakeDesign[r][col];
              min=y;
            } else {
              break;
            }
          }

          for (int beforeRow=r-1; beforeRow>-1; beforeRow--) {
            boolean isAllUnfilled = true;
            for (int c=min; c<=max; c++) {
              if (cakeDesign[beforeRow][c] != '?') {
                isAllUnfilled = false;
                break;
              }
            }

            if (isAllUnfilled) {
              for (int c=min; c<=max; c++) {
                cakeDesign[beforeRow][c] = cakeDesign[r][col];
              }
            } else {
              break;
            }
          }

          for (int afterRow=r+1; afterRow<rows; afterRow++) {
            boolean isAllUnfilled = true;
            for (int c=min; c<=max; c++) {
              if (cakeDesign[afterRow][c] != '?') {
                isAllUnfilled = false;
                break;
              }
            }

            if (isAllUnfilled) {
              for (int c=min; c<=max; c++) {
                cakeDesign[afterRow][c] = cakeDesign[r][col];
              }
            } else {
              break;
            }
          }

        }
      }
    }

    printCaseln();

    printMatrix(rows, columns, cakeDesign);

  }

  private static char[][] getCakeDesign(int rows, int columns) throws IOException {
    char[][] cakeDesign = new char[rows][columns];

    for (int row=0; row<rows; row++) {
      StringBuilder inputRow = new StringBuilder(next());
      for (int column=0; column<columns; column++) {
        cakeDesign[row][column] = inputRow.charAt(column);
      }
    }
    return cakeDesign;
  }

  private static void printMatrix(int rows, int columns, char[][] cakeDesign) {
    for (int r=0; r<rows; r++) {
      for (int col=0; col<columns; col++) {
        printWriter.print(cakeDesign[r][col]);
      }
      printWriter.println();
    }
  }


  private static void printCaseln() {
    printWriter.println("Case #" + currentTest + ": ");
  }

  private static void printCase() {
    printWriter.print("Case #" + currentTest + ": ");
  }

  private static int nextInt() throws IOException {
    return parseInt(next());
  }

  static long nextLong() throws IOException {
    return parseLong(next());
  }

  static double nextDouble() throws IOException {
    return parseDouble(next());
  }

  private static String next() throws IOException {
    while (stringTokenizer == null || !stringTokenizer.hasMoreTokens()) {
      stringTokenizer = new StringTokenizer(inputBufferReader.readLine());
    }
    return stringTokenizer.nextToken();
  }

}