import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class TidyNumber {

  public static void main(String[] args) throws IOException {

    InputStream in = System.in;

    BufferedReader reader =
        new BufferedReader(new InputStreamReader(in));

    int totalTestCases = Integer.valueOf(reader.readLine());

    List<String> results = new ArrayList<>();

    for (int testcase = 1; testcase <= totalTestCases; testcase++) {

      results.add(getTidyNumber(reader.readLine()));
    }

    for (int testcase = 1; testcase <= totalTestCases; testcase++) {
      System.out.println("Case #" + testcase + ": " + results.get(testcase - 1));
    }
  }

  private static String getTidyNumber(String inputNumber) throws IOException {

    boolean isReset = false;

    StringBuilder maxNumber = new StringBuilder(inputNumber);
    int upperBound = maxNumber.length() - 1;
    for (int index = 0; index < upperBound; index++) {

      if (isReset) {
        maxNumber.setCharAt(index + 1, '9');
      } else if (!isValidPair(maxNumber, index)) {
        isReset = true;
        maxNumber.setCharAt(index, getPreviousChar(maxNumber.charAt(index)));
        maxNumber.setCharAt(index + 1, '9');
      }
    }

    maxNumber = removeLeadingZero(maxNumber);

    if (!isTidyNumber(maxNumber)) {
      return getTidyNumber(maxNumber.toString());
    }

    return maxNumber.toString();
  }

  private static StringBuilder removeLeadingZero(StringBuilder maxNumber) {

    if (maxNumber.charAt(0) == '0' && maxNumber.length() > 1) {
      maxNumber.deleteCharAt(0);
      return removeLeadingZero(maxNumber);
    }

    return maxNumber;
  }

  private static boolean isTidyNumber(StringBuilder maxNumber) {
    int upperBound = maxNumber.length() - 1;
    for (int index = 0; index < upperBound; index++) {
      if (!isValidPair(maxNumber, index)) {
        return false;
      }
    }
    return true;
  }

  private static boolean isValidPair(StringBuilder maxNumber, int index) {
    return asciiOf(maxNumber.charAt(index + 1)) >= asciiOf(maxNumber.charAt(index));
  }

  private static char getPreviousChar(char c) {

    switch (c) {
      case '0':
        return '9';
      case '1':
        return '0';
      case '2':
        return '1';
      case '3':
        return '2';
      case '4':
        return '3';
      case '5':
        return '4';
      case '6':
        return '5';
      case '7':
        return '6';
      case '8':
        return '7';
      case '9':
        return '8';
    }

    return '0';
  }

  private static int asciiOf(char c) {
    return (int) c;
  }

}

