import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.StringTokenizer;

public class FairAndSquare {

	// File
	static String inputFilePath = "C:\\gcj\\C\\C-small-attempt0.in";
	static String outputFilePath = "C:\\gcj\\C\\C-small-attempt0.out";
	static Charset charset = Charset.forName("US-ASCII");
	
	// Cases
	static int caseCount = 0;
	static int fairSquareCount = 0;
	static boolean isSquarePalindrome = false;
	static boolean isSquare = false;
	static boolean isPalindrome = false;

	
	public static void main(String[] args) throws IOException {

		// reader
		BufferedReader reader = Files.newBufferedReader(
				Paths.get(inputFilePath), charset);

		caseCount = Integer.parseInt(reader.readLine());

		// writer
		BufferedWriter writer = Files.newBufferedWriter(
				Paths.get(outputFilePath), charset);

		// for each case
		for (int i = 0; i < caseCount; i++) {
			// reset count
			fairSquareCount = 0;

			// get the range
			StringTokenizer tokens = new StringTokenizer(reader.readLine());
			int low = Integer.parseInt(tokens.nextToken());
			int high = Integer.parseInt(tokens.nextToken());

			// sweep the range and check each number if it is fair and square
			for (int sweep = low; sweep <= high; sweep++) {

				// reset booleans
				isPalindrome = false;
				isSquare = false;
				isSquarePalindrome = false;

				// check all cases

				// check if current number a palindrome
				isPalindrome = isPalindrome(sweep);

				// if true, check if it is square
				isSquare = isSquare(sweep);

				// if it is square, check if the square is a palindrome
				if (isSquare)
					isSquarePalindrome = isPalindrome((int) Math.sqrt(sweep));

				if (isPalindrome && isSquare && isSquarePalindrome) {
					// System.out.println("WOOT!!");
					fairSquareCount++;
				}

			}

			// write output
			String output = "Case #" + (i + 1) + ": " + fairSquareCount + "\n";
			// System.out.println(output);
			writer.write(output);

		}
		writer.flush();
		writer.close();
		reader.close();
	}

	/**
	 * Check if number is a palindrome
	 * 
	 * @param number
	 * @return boolean
	 */
	public static boolean isPalindrome(int number) {

		boolean result = false;
		int n = number;
		int palindrome = 0;
		int temp = 0;

		// reverse order
		while (n > 0) {
			temp = n % 10;
			n = n / 10;
			palindrome = palindrome * 10 + temp;
		}

		if (number == palindrome) {
			result = true;
		}

		return result;
	}

	/**
	 * Is square
	 * 
	 * @param number
	 * @return boolean
	 */
	public static boolean isSquare(int number) {
		boolean result = false;
		int sqrt = (int) Math.sqrt(number);

		if (sqrt * sqrt == number) {
			result = true;
		}

		return result;
	}

}
