import java.io.BufferedInputStream;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;

public class TicTacToeTomek {

	public static void main(String[] args) throws IOException {

		File file = new File("C:\\gcj\\A\\A-small-attempt1.in");
		FileInputStream fis = new FileInputStream(file);
		BufferedInputStream bis = new BufferedInputStream(fis);
		DataInputStream input = new DataInputStream(bis);
		
		
		// Number of cases
		//int caseCount = Character.getNumericValue(input.read());
		int caseCount = Integer.parseInt(input.readLine());

		
		// System.out.println("Case count: " + caseCount);

		for (int i = 0; i < caseCount; i++) {
			int turnCount = 0;
			InputCase inputCase = new InputCase();
			inputCase.caseNumber = i;

			// While not end of file
			while (input.available() > 0) {
				
				// when input limit reached start next case
				if (turnCount >= 16)
					break;

				// reader input
				char player = (char) input.read();
				//System.out.print(player);
				// Count each move and empty
				if (player == 'X') {
					// System.out.println("X moves");
					inputCase.countX++;
					inputCase.setX(turnCount);
					turnCount++;

				} else if (player == 'O') {
					// System.out.println("O moves");
					inputCase.countO++;
					inputCase.setO(turnCount);
					turnCount++;

				} else if (player == '.') {
					// System.out.println("Empty");
					inputCase.countEmpty++;
					turnCount++;
				} else if (player == 'T') {
					// System.out.println("Wild card");
					inputCase.countT++;
					// set Wild Card
					inputCase.setX(turnCount);
					inputCase.setO(turnCount);
					turnCount++;
				}
			}
			// print Matrix
			// inputCase.print();
			inputCase.checkWinner();
		}
		input.close();
	}
}

class InputCase {
	int caseNumber, countX, countO, countT, countEmpty;
	boolean playerX[][] = new boolean[4][4];
	boolean playerO[][] = new boolean[4][4];

	/**
	 * Set X position
	 * @param position
	 */
	public void setX(int position) {
		int n, m;
		n = position / 4;
		m = position % 4;
		// System.out.println("X { n:" + n + " m:" + m + " }");
		playerX[n][m] = true;
		// playerX[]
	}

	/**
	 * Set O position 
	 * @param position
	 */
	public void setO(int position) {
		int n, m;
		n = position / 4;
		m = position % 4;
		// System.out.println("Y { n:" + n + " m:" + m + " }");
		playerO[n][m] = true;
	}

	/**
	 * Print board
	 */
	public void print() {
		// print counts
		System.out.println("Counts { X:" + countX + " O: " + countO + " T: "
				+ countT + " Empty:" + countEmpty + " }");

		// print case
		for (int n = 0; n < 4; n++) {
			System.out.println();
			for (int m = 0; m < 4; m++) {

				if (playerX[n][m] == true && playerO[n][m] == false)
					System.out.print("X");

				if (playerX[n][m] == false && playerO[n][m] == true)
					System.out.print("O");

				if (playerX[n][m] == false && playerO[n][m] == false)
					System.out.print(".");

				if (playerX[n][m] == true && playerO[n][m] == true)
					System.out.print("T");
			}
		}
		System.out.println();
	}

	/**
	 * Check row for winner
	 * @param player
	 * @return boolean
	 */
	public boolean isRowFilled(boolean[][] player) {

		boolean result = false;
		for (int n = 0; n < 4; n++) {
			if (player[n][0] && player[n][1] && player[n][2] && player[n][3]) {
				result = true;
			}
		}
		return result;
	}

	/**
	 * Check columns for winner
	 * @param player
	 * @return boolean
	 */
	public boolean isColumnFilled(boolean[][] player) {

		boolean result = false;
		for (int m = 0; m < 4; m++) {
			if (player[0][m] && player[1][m] && player[2][m] && player[3][m]) {
				result = true;
			}
		}
		return result;
	}

	/**
	 * Check diagonal for winner
	 * @param player
	 * @return boolean
	 */
	public boolean isDiagonalFilled(boolean[][] player){
		boolean result = false;	
			if(player[0][0] && player[1][1] && player[2][2] && player[3][3] )
				result = true;
			if(player[0][3] && player[1][2] && player[2][1] && player[3][0])
				result = true;
		return result;
	}
	
	/**
	 * Check winner
	 */
	public void checkWinner() {

		System.out.print("Case #" + (caseNumber + 1) + ": ");
		if (isColumnFilled(playerX) || isRowFilled(playerX) || isDiagonalFilled(playerX) ) {
			System.out.println("X won");
		} else if (isColumnFilled(playerO) || isRowFilled(playerO) || isDiagonalFilled(playerO)) {
			System.out.println("O won");
		} else if (countEmpty > 0) {
			System.out.println("Game has not completed");
		} else {
			System.out.println("Draw");
		}
	}

}
