import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.StringTokenizer;

/**
 * @author Chris
 * 
 */
public class Lawnmower {

	static String filePath = "C:\\gcj\\B\\B-large.in";
	static String outputFilePath = "C:\\gcj\\B\\B-large.out";

	static Charset charset = Charset.forName("US-ASCII");
	static int caseCount = 0;

	public static void main(String[] args) throws NumberFormatException,
			IOException {

		// reader
		BufferedReader reader = Files.newBufferedReader(Paths.get(filePath),
				charset);

		// writer
		BufferedWriter writer = Files.newBufferedWriter(
				Paths.get(outputFilePath), charset);

		// set number of cases
		caseCount = Integer.parseInt(reader.readLine());

		// case loop
		for (int k = 0; k < caseCount; k++) {

			// get case array size
			StringTokenizer tokens = new StringTokenizer(reader.readLine());
			int n = Integer.parseInt(tokens.nextToken());
			int m = Integer.parseInt(tokens.nextToken());

			// create case array
			LawnPattern lawnPattern = new LawnPattern(n, m);

			// read in next n lines, and fill the case pattern
			for (int i = 0; i < n; i++) {
				tokens = new StringTokenizer(reader.readLine());
				for (int j = 0; j < m; j++) {
					lawnPattern.getPattern()[i][j] = Integer.parseInt(tokens
							.nextToken());
				}
			}

			// print lawn pattern
			lawnPattern.print();

			// create my lawn
			Lawn myLawn = new Lawn(n, m, 100);

			//myLawn.print();

			// cut the lawn
			// walk around each edge and cut through from big to small

			// for n times
			// find greatest number in row
			// cut horizontally
			for (int row = 0; row < n; row++) {

				int height = lawnPattern.pickGreatestInRow(row);

				myLawn.cutRow(row, height);
			}

			// for m times find the greatest number in the row
			// cut vertically
			for (int column = 0; column < m; column++) {

				int height = lawnPattern.pickGreatestInColumn(column);
				myLawn.cutColumn(column, height);

			}

	

			System.out.println("My cut lawn");
			myLawn.print();


			// FINAL
			// Compare my lawn to the pattern
			// RETURN result yes/no

			// write output
			String output = "Case #" + (k + 1) + ": ";
			
			CompareLawns lawns = new CompareLawns();
			boolean isSame = lawns.Compare(myLawn.getLawn(), lawnPattern.getPattern());
			
			if(isSame){
				System.out.println("YES");
				output += "YES\n";
			} else {
				System.out.println("NO");
				output += "NO\n";
			}
			
			
			
			
			System.out.println(output);
			writer.write(output);

		} // end of reading loop

		writer.flush();
		writer.close();
		reader.close();

	}
}

/**
 * Lawn Pattern
 * 
 * @author Chris
 * 
 */
class LawnPattern {
	int n, m;
	int pattern[][];

	boolean isCut[][];

	public int pickGreatestInRow(int row) {
		int greatest = 0;
		for (int i = 0; i < m; i++) {
			if (pattern[row][i] > greatest) {
				greatest = pattern[row][i];
			}
		}
		// System.out.println("greatest in row " + row + " is " + greatest);
		return greatest; // height to cut
	}

	public int pickGreatestInColumn(int column) {
		int greatest = 0;
		for (int i = 0; i < n; i++) {
			if (pattern[i][column] > greatest) {
				greatest = pattern[i][column];
			}
		}

		// System.out.println("greatest in column " + column + " is " + greatest);
		return greatest; // height to cut
	}

	/**
	 * Create lawn array
	 * 
	 * @param n
	 * @param m
	 */
	public LawnPattern(int n, int m) {
		this.n = n;
		this.m = m;
		pattern = new int[n][m];
		// isCut = new boolean[n][m];
	}

	/**
	 * Get the lawn pattern
	 * 
	 * @return the lawn pattern
	 */
	public int[][] getPattern() {
		return pattern;
	}

	/**
	 * Set the lawn pattern
	 * 
	 * @param pattern
	 */
	public void setPattern(int[][] pattern) {
		this.pattern = pattern;
	}

	/**
	 * Print the lawn pattern
	 */
	public void print() {
		for (int i = 0; i < n; i++) {
			System.out.println();
			for (int j = 0; j < m; j++) {
				System.out.print(pattern[i][j] + " ");
			}
		}
	}
}

/**
 * Personal Lawn
 * 
 * @author Chris
 * 
 */
class Lawn {
	int n, m;
	int lawn[][];
	boolean isRead[][];

	/**
	 * Create Lawn array
	 * 
	 * @param n
	 * @param m
	 */
	public Lawn(int n, int m) {
		this.n = n;
		this.m = m;
		lawn = new int[n][m];
		isRead = new boolean[n][m];
	}

	/**
	 * Create lawn array with height
	 * 
	 * @param n
	 * @param m
	 * @param height
	 */
	public Lawn(int n, int m, int height) {
		this.n = n;
		this.m = m;
		lawn = new int[n][m];
		isRead = new boolean[n][m];

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				lawn[i][j] = 100;
			}
		}
	}

	/**
	 * The lawn
	 * 
	 * @return the lawn
	 */
	public int[][] getLawn() {
		return lawn;
	}

	/**
	 * Set the lawn
	 * 
	 * @param lawn
	 */
	public void setLawn(int[][] lawn) {
		this.lawn = lawn;
	}

	/**
	 * Print lawn
	 */
	public void print() {
		for (int i = 0; i < n; i++) {
			System.out.println();
			for (int j = 0; j < m; j++) {
				System.out.print(lawn[i][j] + " ");
			}
		}
	}

	public void cutColumn(int column, int height) {
		// only cut is nothing is bigger in the column
		for (int i = 0; i < n; i++) {
			if (lawn[i][column] > height)
				lawn[i][column] = height;
		}
	}

	/**
	 * Cut row, if the height is greater or equal to all items in the row
	 * 
	 * @param row
	 * @param height
	 */
	public void cutRow(int row, int height) {
		// only cut if nothing is bigger in the row
		for (int i = 0; i < m; i++) {
			if (lawn[row][i] > height)
				lawn[row][i] = height;
		}
	}

}

class CompareLawns {

	/**
	 * Compare the two lawns
	 * @param myLawn
	 * @param pattern
	 * @return boolean
	 */
	public boolean Compare(int[][] myLawn, int[][] pattern) {
		boolean result = true;

		int n = myLawn.length;
	//	System.out.println(n);
		int m = myLawn[0].length;
	//	System.out.println(m);

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {

				if (myLawn[i][j] != pattern[i][j]) {
					result = false;
				}
			}
		}

		return result;

	}

}
