import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;


public class Swinging {

	public static void main(String[] args) throws Exception {
		Swinging object = new Swinging();
			object.solve(object.getClass().getSimpleName().toLowerCase());
		}
		
		private void solve(String filePrefix) throws Exception {
			
			StreamTokenizer st = new StreamTokenizer(new BufferedReader(new FileReader(filePrefix + ".in")));
			PrintWriter pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
			
			st.nextToken();
			int testsCount = (int) st.nval;
			
			for (int tc=0; tc<testsCount; tc++)
			{
				st.nextToken();
				int vines = (int) st.nval;
				
				int d[] = new int[vines+2];
				int l[] = new int[vines+2];
				
				for (int i=1; i<=vines; i++)
				{
					st.nextToken();
					d[i] = (int) st.nval;
					
					st.nextToken();
					l[i] = (int) st.nval;
				}
				
				d[0] = l[0] = l[vines+1] = 0;
				
				st.nextToken();
				d[vines+1] = (int) st.nval;
				
				String result = solve(vines, d, l);
				
				pw.write("Case #" + (tc+1) + ": " + result + "\n");
			}
			
			pw.flush();
			pw.close();
			
		}

		private String solve(int vines, int[] d, int[] l) {
			int n = d.length;
			
			HashSet<Long> visited = new HashSet<Long>();
			
			Queue<Long> q = new LinkedList<Long>();
			q.add(0 * 100000L + 1);
			visited.add(0 * 100000L + 1);
			
			while (!q.isEmpty())
			{				
				long current = q.poll();
				long lwhere = current / 100000L;
				long lhold = current % 100000L;
				
				int where = (int) lwhere;
				int hold = (int) lhold;
								
				//we are hanging at where, holding vine *hold*
				int holdLength = Math.abs(d[hold] - d[where]);
				if (holdLength > l[hold])
					holdLength = l[hold];
				
				int whereAreWe = d[where];
				if (Math.abs(d[hold] - d[where]) > l[hold])
				{
					if (d[where] < d[hold])
						whereAreWe = d[hold] - holdLength;
					else
						whereAreWe = d[hold] + holdLength;
				}
				
				if (Math.abs(whereAreWe - d[n-1]) <= holdLength)
					return "YES";
				
				//what can we catch by swinging left
				for (int j=hold-1; j>=0; j--)
					if (Math.abs(d[hold] - d[j]) <= holdLength)
					{						
						long nextEncoded = hold*100000L + j;
						if (!visited.contains(nextEncoded))
						{
							visited.add(nextEncoded);
							q.add(nextEncoded);
						}
					}
				
				for (int j=hold+1; j<n; j++)
					if (Math.abs(d[hold] - d[j]) <= holdLength)
					{						
						long nextEncoded = hold*100000L + j;
						if (!visited.contains(nextEncoded))
						{
							visited.add(nextEncoded);
							q.add(nextEncoded);
						}
					}
			}
						
			return "NO";
		}
}
