import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.Arrays;


public class Watersheds {
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException {
		
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(new FileReader("C:/codejam/ws/input.in")));
		PrintWriter pw = new PrintWriter(new FileWriter("C:/codejam/ws/output.out"));
		
//		StreamTokenizer st = new StreamTokenizer(new BufferedReader(new InputStreamReader(System.in)));
//		PrintWriter pw = new PrintWriter(new OutputStreamWriter(System.out));
//				
		
		st.nextToken();
		int t = (int) st.nval;
		
		for (int tc=0; tc<t; tc++)
		{
			pw.write("Case #" + (tc+1) + ":\n");
			
			st.nextToken();
			int h = (int) st.nval;
			
			st.nextToken();
			int w = (int) st.nval;
			
			int [][]array = new int[h+1][w+1];
			for (int i=0; i<h+1; i++)
				Arrays.fill(array[i], -1);
			
			int [][]map = new int[h+1][w+1];
			
			for (int i=0; i<h; i++)
				for (int j=0; j<w; j++)
				{
					st.nextToken();
					int height = (int) st.nval;
					map[i][j] = height;					
				}
			
			int counter = 0;
			
			for (int i=0; i<h; i++)
				for (int j=0; j<w; j++)
					if (array[i][j] == -1)
					{
						int info = getHeight(map, array, i, j, h, w, counter);
						if (info == counter) counter++;
					}
			
			for (int i=0; i<h; i++)
			{
				for (int j=0; j<w; j++)
				{
					char encodedChar = (char) ('a' + (char) array[i][j]);
					
					if (j == 0)
						pw.write(encodedChar);
					else
						pw.write(" " + encodedChar);
				}
					
				pw.write("\n");
			}
				
		}
		
		pw.flush();
		pw.close();
		
	}
	
	private static int getHeight(int[][] map, int [][] array, int i, int j, int h, int w, int counter)
	{
		if (array[i][j] != -1) return array[i][j];
		
		int minimum = map[i][j]; int bestx = 0, besty = 0;
		if (i > 0 && map[i-1][j] < minimum)
		{
			//north
			minimum = map[i-1][j];
			bestx = i-1;
			besty = j;
		}
		
		if (j > 0 && map[i][j-1] < minimum)
		{
			//west
			minimum = map[i][j-1];
			bestx = i;
			besty = j-1;
		}
		
		if (j+1 < w && map[i][j+1] < minimum)
		{
			//east
			minimum = map[i][j+1];
			bestx = i;
			besty = j+1;
		}
		
		if (i+1 < h && map[i+1][j] < minimum)
		{
			//south
			minimum = map[i+1][j];
			bestx = i+1;
			besty = j;
		}
		
		if (minimum == map[i][j])
		{
			//sink
			array[i][j] = counter;
			return counter;			
		}
		
		int getinfo = getHeight(map, array, bestx, besty, h, w, counter);
		array[i][j] = getinfo;
		return getinfo;				
	}
}
