import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Billingual {

	public static void main(String[] args) throws Exception {
		Billingual object = new Billingual();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase() + ".in"));
		Scanner scanner = new Scanner(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		int testCases = scanner.nextInt();

		for (int tc = 1; tc <= testCases; tc++) {

			int n = scanner.nextInt();

			String[] sentences = new String[n];

			scanner.nextLine();

			for (int i = 0; i < n; i++) {
				sentences[i] = scanner.nextLine().trim();
			}

			System.out.println("At: " + tc + " " + sentences.length + " " + sentences[0].length() + " " +sentences[1].length());
			
			wr.write("Case #" + tc + ": " + solve(sentences) + "\r\n");

		}

		scanner.close();
		wr.close();
	}

	private static int solve(String[] sentences) {

		Set<String> englishWords = new HashSet<>();
		Set<String> frenchWords = new HashSet<>();

		String[] english = sentences[0].split("[ ]+");
		String[] french = sentences[1].split("[ ]+");

		for (String word : english)
			englishWords.add(word);

		for (String word : french)
			frenchWords.add(word);

		for (int i = 2; i < sentences.length; i++) {
			sentences[i - 2] = sentences[i];
		}

		int number = sentences.length - 2;
		int output = 1000000000;
		
		Set<String> commonTop = new HashSet<>();
		
		for (String word : englishWords)
			if (frenchWords.contains(word)) {
				commonTop.add(word);
			}

		for (int i = 0; i < (1 << number); i++) {

			Set<String> common = new HashSet<>();

			Set<String> extraEnglish = new HashSet<>();
			Set<String> extraFrench = new HashSet<>();

			for (int j = 0; j < number; j++) {

				boolean englishSentence = (((1 << j) & i) != 0);

				String[] words = sentences[j].split("[ ]+");

				for (String word : words) {
					if (englishSentence) {

						if (!englishWords.contains(word)) {
							extraEnglish.add(word);
						}
					} else {
						if (!frenchWords.contains(word)) {
							extraFrench.add(word);
						}
					}
				}

				for (String word : words) {
					
					if (commonTop.contains(word)) {
						continue;
					}
					
					if (englishSentence) {

						if (frenchWords.contains(word) || extraFrench.contains(word)) {
							common.add(word);
						}
					} else {
						if (englishWords.contains(word) || extraEnglish.contains(word)) {
							common.add(word);
						}
					}
				}
			}

			output = Math.min(output, commonTop.size() + common.size());
		}

		return output;
	}

}
