import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StreamTokenizer;

public class Showdown {

	public static void main(String[] args) throws Exception {
		Showdown object = new Showdown();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase() + ".in"));
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		st.nextToken();
		int testCases = (int) st.nval;


		for (int tc = 1; tc <= testCases; tc++) {

			System.out.println("At test " + tc + "/" + testCases);

			st.nextToken();
			int N = (int) st.nval;

			st.nextToken();
			int R = (int) st.nval;
			
			st.nextToken();
			int P = (int) st.nval;
			
			st.nextToken();
			int S = (int) st.nval;

			String result = object.solve(N, P, R, S);

			wr.write("Case #" + tc + ": " + result.trim() + "\r\n");
		}

		wr.close();
	}

	String output = null;
	char[] order;
	
	public String solve(int N, int P, int R, int S) {

		output = "IMPOSSIBLE";
		order = new char[P + R + S];
		
		generate(0, P, R, S);
		
		return output;
	}
	
	public void generate(int pos, int P, int R, int S){
		
		if(P + R + S == 0){
			//all setup
			if(valid(new String(order))){
				String current = new String(order);
				if(output.equals("IMPOSSIBLE") || current.compareTo(output) < 0){
					output = current;
				}
			}
			
			return ;
		}
		
		if(P > 0){
			order[pos] = 'P';
			generate(pos + 1, P-1, R, S);
		}
		
		if(R > 0){
			order[pos] = 'R';
			generate(pos + 1, P, R-1, S);
		}
		
		if(S > 0){
			order[pos] = 'S';
			generate(pos + 1, P, R, S-1);
		}
	}

	private boolean valid(String order) {
		if(order.length() < 2){
			return true;
		}
		
		//valid
		StringBuilder next = new StringBuilder();
		
		for(int i=0; i<order.length(); i+=2){
			
			char ch1 = order.charAt(i);
			char ch2 = order.charAt(i + 1);
			
			if(ch1 == ch2){
				return false;
			}
			
			if(ch1 == 'P' && ch2 == 'R'){
				next.append(ch1);
			}
			
			if(ch1 == 'P' && ch2 == 'S'){
				next.append(ch2);
			}
			
			if(ch1 == 'R' && ch2 == 'S'){
				next.append(ch1);
			}
			
			if(ch1 == 'R' && ch2 == 'P'){
				next.append(ch2);
			}
			
			if(ch1 == 'S' && ch2 == 'P'){
				next.append(ch1);
			}
			
			if(ch1 == 'S' && ch2 == 'R'){
				next.append(ch2);
			}
		}
		
		return valid(next.toString());
	}

}
