import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StreamTokenizer;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class RedTape {

	public static void main(String[] args) throws Exception {
		RedTape object = new RedTape();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase() + ".in"));
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		st.nextToken();
		int testCases = (int) st.nval;

		List<Map<String, Object>> tests = new ArrayList<>();

		for (int tc = 1; tc <= testCases; tc++) {

			System.out.println("At test " + tc + "/" + testCases);

			st.nextToken();
			int N = (int) st.nval;

			st.nextToken();
			int K = (int) st.nval;

			double[] prob = new double[N];

			for (int i = 0; i < prob.length; i++) {
				st.nextToken();
				prob[i] = st.nval;
			}

			Map<String, Object> problem = new HashMap<>();
			problem.put("test", tc);
			problem.put("N", N);
			problem.put("K", K);
			problem.put("prob", prob);

			tests.add(problem);
		}

		tests.parallelStream().forEach(problem -> {

			int tc = (Integer) problem.get("test");
			int N = (Integer) problem.get("N");
			int K = (Integer) problem.get("K");
			double[] prob = (double[]) problem.get("prob");

			problem.put("result", object.solve(tc - 1, N, K, prob));
		});

		DecimalFormat df = new DecimalFormat("0.00000000000");

		for (int tc = 1; tc <= testCases; tc++) {
			Map<String, Object> current = tests.get(tc - 1);
			double result = (Double) current.get("result");

			wr.write("Case #" + tc + ": " + df.format(result) + "\r\n");
		}

		wr.close();
	}

	public double solve(int tc, int N, int K, double[] inputProb) {

		double[] prob = new double[K];
		double maxProb = 0.0;

		int[] choices = new int[N];
		for (int z = 0; z < (1 << N); z++)
			if (Integer.bitCount(z) == K) {

				int taken = 0;

				for (int j = 0; j < N; j++) {
					choices[j] = (((1 << j) & z) > 0) ? 1 : 0;

					if (choices[j] > 0) {
						prob[taken++] = inputProb[j];
					}
				}

				double[][] dp = new double[K + 1][K + 1];
				dp[0][0] = 1.0;

				for (int i = 0; i < K; i++)
					for (int j = 0; j <= i; j++) {

						// i + 1 votes for
						dp[i + 1][j + 1] += dp[i][j] * prob[i];

						// i + 1 votes agains
						dp[i + 1][j] += dp[i][j] * (1 - prob[i]);
					}

				maxProb = Math.max(maxProb, dp[K][K / 2]);
			}

		return maxProb;

	}

}
