import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StreamTokenizer;
import java.util.Arrays;

public class UpDown {

	public static void main(String[] args) throws Exception {
		UpDown object = new UpDown();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase()
				+ ".in"));
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		st.nextToken();
		int testCases = (int) st.nval;


		for (int tc = 1; tc <= testCases; tc++) {
			st.nextToken();
			int N = (int) st.nval;

			int arr[] = new int[N];

			for (int i = 0; i < N; i++) {
				st.nextToken();
				arr[i] = (int) st.nval;
			}

			int output1 = object.solve(arr);
			int output2 = object.solve3(arr);
			
			int output = Math.min(output1, output2);
			wr.write("Case #" + tc + ": " + output + "\r\n");
		}

		wr.close();
	}

	private boolean isUpDown(int[] arr) {
		int largest = -1;

		for (int i = 0; i < arr.length; i++)
			if (largest == -1 || arr[i] > arr[largest])
				largest = i;

		for (int i = 0; i < largest; i++)
			if (arr[i] > arr[i + 1])
				return false;

		for (int i = largest; i < arr.length - 1; i++)
			if (arr[i] < arr[i + 1])
				return false;

		return true;
	}

	int bestRes = 2000000000;

	private int solve(int arr[]) {

		bestRes = 2000000000;

		for (int i = 0; i < arr.length; i++) {
			int newarr[] = Arrays.copyOf(arr, arr.length);
			bestRes = Math.min(bestRes, solve(newarr, i));
		}

		return bestRes;
	}

	private int solve3(int arr[]) {
		
		if (isUpDown(arr))
			return 0;
		
		int smallest = -1;

		for (int i = 0; i < arr.length; i++)
			if (smallest == -1 || arr[i] < arr[smallest])
				smallest = i;
				
		int distanceLeft = smallest;
		int distanceRight = arr.length-1 - smallest;
		
		if (distanceLeft < distanceRight) {
			int req[] =	new int[arr.length-1];
			
			int pos = 0;
			for (int i=0; i<arr.length; i++)
				if (i != smallest) {
					req[pos++] = arr[i];
				}
			
			return distanceLeft + solve3(req);
		} else {
			int req[] =	new int[arr.length-1];
			
			int pos = 0;
			for (int i=0; i<arr.length; i++)
				if (i != smallest) {
					req[pos++] = arr[i];
				}
			
			return distanceRight + solve3(req);
		}
	}

	private int solve(int[] arr, int largestPosition) {

		int largest = -1;

		for (int i = 0; i < arr.length; i++)
			if (largest == -1 || arr[i] > arr[largest])
				largest = i;

		int counter = 0;
		while (largest > largestPosition) {

			int temp = arr[largest];
			arr[largest] = arr[largest - 1];
			arr[largest - 1] = temp;

			counter++;
			largest--;
		}

		while (largest < largestPosition) {

			int temp = arr[largest];
			arr[largest] = arr[largest + 1];
			arr[largest + 1] = temp;

			counter++;
			largest++;
		}

		// left part
		while (true && bestRes > counter) {

			boolean cont = false;

			for (int i = 0; i < largest - 1; i++) {
				int a = arr[i];
				int b = arr[i + 1];

				if (a > b) {
					// swap
					int temp = arr[i];
					arr[i] = arr[i + 1];
					arr[i + 1] = temp;

					cont = true;
					counter++;
				}
			}

			if (!cont)
				break;
		}

		// right part
		while (true && bestRes > counter) {

			boolean cont = false;

			for (int i = largest + 1; i < arr.length - 1; i++) {
				int a = arr[i];
				int b = arr[i + 1];

				if (a < b) {
					// swap
					int temp = arr[i];
					arr[i] = arr[i + 1];
					arr[i + 1] = temp;

					cont = true;
					counter++;
				}
			}

			if (!cont)
				break;
		}

		return counter;
	}

}
