import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StreamTokenizer;

public class ManyPrizes {

	public static void main(String[] args) throws Exception {
		ManyPrizes object = new ManyPrizes();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase()
				+ ".in"));
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		st.nextToken();
		int testCases = (int) st.nval;

		st.resetSyntax();
		st.wordChars(0, 256);
		st.whitespaceChars(0, 32);

		for (int tc = 1; tc <= testCases; tc++) {
			st.nextToken();
			int n = Integer.parseInt(st.sval);

			st.nextToken();
			long p = Long.parseLong(st.sval);

			long output1 = object.solve1(n, p);
			long output2 = object.solve2(n, p);
			wr.write("Case #" + tc + ": " + output2 + " " + output1 + "\r\n");
		}

		wr.close();
	}

	private long solve1(int n, long p) {
		long teams = (1L << n);

		for (long i = teams - 1; i >= 0; i--)
			if (canWin(n, p, i))
				return i;

		return -1;
	}

	private long solve2(int n, long p) {
		long teams = (1L << n);

		for (long i = 1; i < teams; i++)
			if (canLose(n, p, i))
				return (i - 1);

		return 0;
	}

	private boolean canWin(int n, long p, long team) {
		long teams = (1L << n);

		long lowerRankedTeams = teams - team - 1;
		
		long canWinInConsecutiveRounds = 0;
		long currentRequired = 1;

		while (lowerRankedTeams >= currentRequired) {
			canWinInConsecutiveRounds++;
			lowerRankedTeams -= currentRequired;
			currentRequired <<= 1L;
		}

		int mustWinRounds = 0;
		for (int round = 1;; round++) {
			// long teamsInRound = (teams >> (round-1));
			long teamsAfterRound = (teams >> (round));

			if (teamsAfterRound <= p) {
				mustWinRounds = round;
				break;
			}
		}

		return (canWinInConsecutiveRounds >= mustWinRounds);
	}

	private boolean canLose(int n, long p, long team) {
		long teams = (1L << n);

		long higherRankedTeams = team;

		long canLoseInConsecutiveRounds = 0;
		long currentRequired = 1;

		while (higherRankedTeams >= currentRequired) {
			canLoseInConsecutiveRounds++;
			higherRankedTeams -= currentRequired;
			currentRequired <<= 1L;
		}

		long currentPosition = 1;

		for (int z = 1; z <= canLoseInConsecutiveRounds; z++) {
			long teamsInRound = (teams >> (z - 1L));

			currentPosition += (teamsInRound / 2L);
		}

		if (currentPosition > p)
			return true;

		return false;
	}
}
