import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Pegman {

	public static void main(String[] args) throws Exception {
		Pegman object = new Pegman();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase() + ".in"));
		Scanner scanner = new Scanner(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		int testCases = scanner.nextInt();

		for (int tc = 1; tc <= testCases; tc++) {

			int r = scanner.nextInt();
			int c = scanner.nextInt();

			String[] map = new String[r];

			for (int i = 0; i < r; i++) {
				map[i] = scanner.next();
			}

			int result = solve(map);

			if (result == -1) {
				wr.write("Case #" + tc + ": " + "IMPOSSIBLE" + "\r\n");
			} else {
				wr.write("Case #" + tc + ": " + result + "\r\n");
			}
		}

		scanner.close();
		wr.close();
	}

	private static int solve(String[] map) {

		int r = map.length, c = map[0].length();

		int[][] left = new int[r][c];
		int[][] right = new int[r][c];
		int[][] up = new int[r][c];
		int[][] down = new int[r][c];

		for (int i = 0; i < r; i++) {
			Arrays.fill(left[i], 0);
			Arrays.fill(right[i], 0);
			Arrays.fill(up[i], 0);
			Arrays.fill(down[i], 0);

		}

		for (int i = 0; i < r; i++) {
			for (int j = 1; j < c; j++) {
				left[i][j] = left[i][j - 1] + ((map[i].charAt(j - 1) != '.') ? 1 : 0);
			}
		}

		for (int i = 0; i < r; i++) {
			for (int j = c - 2; j >= 0; j--) {
				right[i][j] = right[i][j + 1] + ((map[i].charAt(j + 1) != '.') ? 1 : 0);
			}
		}

		for (int j = 0; j < c; j++) {
			for (int i = 1; i < r; i++) {
				up[i][j] = up[i - 1][j] + ((map[i - 1].charAt(j) != '.') ? 1 : 0);
			}
		}

		for (int j = 0; j < c; j++) {
			for (int i = r - 2; i >= 0; i--) {
				down[i][j] = down[i + 1][j] + ((map[i + 1].charAt(j) != '.') ? 1 : 0);
			}
		}

		int changes = 0;

		for (int i = 0; i < r; i++)
			for (int j = 0; j < c; j++)
				if (map[i].charAt(j) != '.') {

					char direction = map[i].charAt(j);

					if (direction == '^' && up[i][j] == 0) {
						changes++;
					}

					if (direction == '<' && left[i][j] == 0) {
						changes++;
					}

					if (direction == '>' && right[i][j] == 0) {
						changes++;
					}

					if (direction == 'v' && down[i][j] == 0) {
						changes++;
					}

					if (up[i][j] + down[i][j] + left[i][j] + right[i][j] == 0)
						return -1;
				}

		return changes;

	}

}
