import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;


public class Vtora {
	

	public static void main(String[] args) throws Exception {
		
		Vtora main = new Vtora();
		main.doWork();
		
	}
	
	private void doWork() throws Exception
	{
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(new FileReader("b_small.in")));
		PrintWriter pw = new PrintWriter(new FileWriter("b_small.out"));
		
		st.nextToken();
		int tests = (int) st.nval;
		
		for (int i=0; i<tests; i++)
			solve(st, pw, i);
		
		pw.flush();
		pw.close();
	}
	
	public class Point
	{
		public double x;
		public double y;
		public double mass;
		
		public Point(double x, double y, double mass)
		{
			this.x = x;
			this.y = y;
			this.mass = mass;
		}	
		
		public Point()
		{
			this.x = 0;
			this.y = 0;
			this.mass = 0;
		}	
		
		@Override
		public String toString() {
			return ("(" + this.x + ", " + this.y + ", " + this.mass + ")");
		}
	}
	
	public boolean calcCenter(ArrayList<Point> points, double cx, double cy)
	{
		double sumax = 0, sumay = 0;
		
		for (Point point : points)
		{
			sumax += point.mass * (point.x - cx);
			sumay += point.mass * (point.y - cy);
		}
		
		if (Math.abs(sumax) < 1e-11)
			if (Math.abs(sumay) < 1e-11)
				return true;
		
		return false;
	}
	
	
	private void solve(StreamTokenizer st, PrintWriter pw, int test) throws Exception
	{
		int largest = -1;
		
		st.resetSyntax();
		st.wordChars(0, 256);
		st.whitespaceChars(0, 32);
		st.parseNumbers();
		
		st.nextToken();
		int r = (int)st.nval;
		
		st.nextToken();
		int c = (int)st.nval;
				
		st.nextToken();
		int d = (int)st.nval;
		
		int mat[][] = new int[r][c];
		
		st.resetSyntax();
		st.wordChars(0, 256);
		st.whitespaceChars(0, 32);
				
				
		for (int i=0; i<r; i++)
		{
			st.nextToken();
			String in = st.sval;
			
			for (int j=0; j<c; j++)
			{
				int cur = (in.charAt(j) - '0');
				
				mat[i][j] = cur;				
			}
		}
		
		for (int length=3; length<=Math.min(r, c); length++)
			for (int i=0; i+length<=r; i++)
				for (int j=0; j+length<=c; j++)
				{
					ArrayList<Point> points = new ArrayList<Point>();
					
					for (int rr=i; rr<i+length; rr++)
						for (int cc=j; cc<j+length; cc++)
						{
							if (rr==i && ((cc == j) || (cc == j+length-1)))
									continue;
							
							if (rr==i+length-1 && ((cc == j) || (cc == j+length-1)))
									continue;
							
							points.add(new Point(rr+0.5, cc+0.5, d+mat[rr][cc]));	
							
							
														
							
						}
					
					double cx = 0, cy = 0;
					
					for (Point p : points)
					{
						cx += p.x;
						cy += p.y;
					}
					
					cx /= points.size();
					cy /= points.size();
					
					if (calcCenter(points, cx, cy))
						largest = length;
				}
		
		
		if (largest == -1)
			pw.write("Case #" + (test+1) + ": " + "IMPOSSIBLE" + "\r\n");
		else
			pw.write("Case #" + (test+1) + ": " + largest + "\r\n");
	}
}

