import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;


public class Main {
	

	public static void main(String[] args) throws Exception {
		
		Main main = new Main();
		main.doWork();
		
	}
	
	private void doWork() throws Exception
	{
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(new FileReader("b_small.in")));
		PrintWriter pw = new PrintWriter(new FileWriter("b_small.out"));
		
		st.nextToken();
		int tests = (int) st.nval;
		
		for (int i=0; i<tests; i++)
			solve(st, pw, i);
		
		pw.flush();
		pw.close();
	}
	
	private void solve(StreamTokenizer st, PrintWriter pw, int test) throws Exception
	{
		pw.write("Case #" + (test+1) + ":");
		
		st.nextToken();
		int n = (int) st.nval;
		
		st.nextToken();
		int m = (int) st.nval;
		
		int contains[][] = new int[15][28];
		int current[][] = new int[n][28];
		
		ArrayList<String> dictionary = new ArrayList<String>();
						
		for (int i=0; i<n; i++)
		{
			st.nextToken();
			String str = st.sval;
			
			dictionary.add(str);
			
			Arrays.fill(current[i], 0);
			
			int len = str.length();
						
			for (int j=0; j<len; j++)
				current[i][(int)(str.charAt(j) - 'a')]++;							
		}
		
		for (int i=0; i<m; i++)
		{
			st.nextToken();
			String list = st.sval;
			
			char[] chars = list.toCharArray();
			
			String worst = dictionary.get(0);
			int value = -1, row = -1;
						
			//try each word from dictionary
			for (String word : dictionary)
			{
				row++;
				
				for (int p=0; p<15; p++)
					Arrays.fill(contains[p], 0);
				
				int len = word.length();
					
				
				LinkedList<String> toEliminate = new LinkedList<String>();
				
				for (int z=0; z<dictionary.size(); z++)
					if (z != row)
						if (dictionary.get(z).length() == len)
						{
							toEliminate.add(dictionary.get(z));
							
							for (int y=0; y<28; y++)
								if (current[z][y] > 0)
									contains[len][y]++;	
						}
				
				for (int y=0; y<28; y++)
					if (current[row][y] > 0)
						contains[len][y]++;	
				
				int currentValue = 0;
				
				for (char guess : chars)
					if (contains[len][(int)(guess-'a')] != 0)
					{
						boolean weHaveIt = current[row][(int)(guess-'a')] != 0;
						
						if (!weHaveIt)	
						{
							currentValue++;
						}
						
						Iterator<String> it = toEliminate.iterator();
						
						while (it.hasNext())
						{
							String p = it.next();
							
							if (p.contains(""+guess) != weHaveIt)
							{
								it.remove();	
								
								for (char gg='a'; gg<='z'; gg++)
									if (p.contains(gg+""))
									{																											
										contains[len][(int)(gg-'a')]--;
									}
								
								continue;
							}
							
							if (weHaveIt == true)
							{
								if (!sameSequence(word, p, guess))								
								{
									it.remove();	
									
									for (char gg='a'; gg<='z'; gg++)
										if (p.contains(gg+""))
										{																											
											contains[len][(int)(gg-'a')]--;
										}									
								}
							}
						}
						
						if (toEliminate.size() == 0)
							break;
					}
				
				if (currentValue > value)
				{
					value = currentValue;
					worst = word;
				}
			}
			
			pw.append(" " + worst);
		}
		
		
		pw.append("\r\n");
	}
	
	public boolean sameSequence(String a, String b, char c)
	{
		int len = a.length();
		
		for (int i=0; i<len; i++)
		{
			char x = a.charAt(i);
			char y = b.charAt(i);
			
			if (x != y)
				if (x == c || y == c)
					return false;
		}
		
		return true;
	}
}

