import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Arrays;


public class Speaking {

	public static void main(String[] args) throws Exception {
		Speaking object = new Speaking();
			object.solve(object.getClass().getSimpleName().toLowerCase());
		}
	
		public char[] formAsciiReverse(String original, String encoded)
		{
			char[] reversed = new char[26];
			int[] used = new int[26];
			
			Arrays.fill(reversed, ' ');
			Arrays.fill(used, 0);
			
			if (original.length() != encoded.length())
				throw new RuntimeException();
			
			for (int i=0; i<original.length(); i++)
			{
				char from = original.charAt(i);
				char to = encoded.charAt(i);
				
				if (Character.isLowerCase(from) != Character.isLowerCase(to))
					throw new RuntimeException();
				
				if (!Character.isLowerCase(from))
					continue;
				
				int id = (int)(to - 'a');
				
				if (reversed[id] != ' ' && reversed[id] != from)
					throw new RuntimeException();
				
				reversed[id] = from;
				used[(int)(from - 'a')] = 1;
			}
			
			int revPosition = -1, unset = 0;
			
			for (int i=0; i<26; i++)
				if (reversed[i] == ' ')
				{
					unset++;
					revPosition = i;
				}
			
			if (unset >= 2)
				throw new RuntimeException();
			
			for (int i=0; i<26; i++)
				if (used[i] == 0)
				{
					reversed[revPosition] = (char)('a' + i);
				}
			
			return reversed;
		}
		
		private void solve(String filePrefix) throws Exception {
			
			BufferedReader br = new BufferedReader(new FileReader(filePrefix + ".in"));
			PrintWriter pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
			
			char[] reversed = formAsciiReverse("a zoo our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up", "y qee ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv");
			
			int testsCount = Integer.parseInt(br.readLine().trim());			
			
			for (int tc=0; tc<testsCount; tc++)
			{
				String line = br.readLine();
				
				pw.write("Case #" + (tc+1) + ": " + encode(line, reversed) + "\n");
			}
			
			pw.flush();
			pw.close();
			
		}

		private String encode(String line, char[] reversed) {
			StringBuilder output = new StringBuilder();
			
			for (int i=0; i<line.length(); i++)
			{
				if (Character.isLowerCase(line.charAt(i)))
				{
					int id = (int)(line.charAt(i) - 'a');
					output.append(reversed[id]);
				} else
				{
					if (line.charAt(i) != ' ')
						throw new RuntimeException();
					
					output.append(line.charAt(i));
				}
			}
			
			return output.toString();
		}	
}
