import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class DataPacking {

	public static void main(String[] args) throws Exception {
		DataPacking object = new DataPacking();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase()
				+ ".in"));
		StreamTokenizer st = new StreamTokenizer(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		st.nextToken();
		int testCases = (int) st.nval;

		for (int tc = 1; tc <= testCases; tc++) {
			st.nextToken();
			int N = (int) st.nval;

			st.nextToken();
			int X = (int) st.nval;

			List<Integer> list = new ArrayList<>();

			for (int i = 0; i < N; i++) {
				st.nextToken();
				list.add((int) st.nval);
			}

			int output = object.solve(X, list);
			wr.write("Case #" + tc + ": " + output + "\r\n");
		}

		wr.close();
	}

	private int solve(int X, List<Integer> list) {
		Collections.sort(list);
		Collections.reverse(list);

		if (list.size() <= 0)
			return 0;

		if (list.size() == 1)
			return 1;

		int largest = list.get(0);
		int other = -1;

		// find the largest other
		for (int i = 1; i < list.size(); i++) {
			if (list.get(i) + largest <= X) {
				other = i;
				break;
			}
		}

		if (other == -1) {
			list.remove(0);
			return solve(X, list) + 1;
		}

		list.remove(other);
		list.remove(0);
		return solve(X, list) + 1;
	}

}
