import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.text.DecimalFormat;
import java.util.Scanner;

public class KiddiePool {

	public static void main(String[] args) throws Exception {
		KiddiePool object = new KiddiePool();
		String className = object.getClass().getSimpleName();

		FileReader fileReader = new FileReader(new File(className.toLowerCase() + ".in"));
		Scanner scanner = new Scanner(new BufferedReader(fileReader));

		FileWriter wr = new FileWriter(className.toLowerCase() + ".out");

		int testCases = scanner.nextInt();

		for (int tc = 1; tc <= testCases; tc++) {

			int n = scanner.nextInt();

			double v = scanner.nextDouble();
			double x = scanner.nextDouble();

			double[] ri = new double[n];
			double[] ci = new double[n];

			for (int i = 0; i < n; i++) {
				ri[i] = scanner.nextDouble();
				ci[i] = scanner.nextDouble();
			}

			wr.write("Case #" + tc + ": " + solve(v, x, ri, ci) + "\r\n");

		}

		scanner.close();
		wr.close();
	}

	private static String solve(double v, double x, double[] ri, double[] ci) {

		double result = 1e100;

		if (equal(x, ci[0])) {
			result = Math.min(result, timeToFill(ri[0], v));
		}

		if (ci.length > 1 && equal(x, ci[1])) {
			result = Math.min(result, timeToFill(ri[1], v));

			// both are the same, so use both
			if (equal(x, ci[0])) {
				result = Math.min(result, timeToFill(ri[0] + ri[1], v));
			}
		}

		if (result != 1e100) {
			return format(result);
		}

		if (ci.length <= 1)
			return "IMPOSSIBLE";

		double v0v1 = (ci[0] - x) / (x - ci[1]);

		if (v0v1 < 1e-12) {
			return "IMPOSSIBLE";
		}

		double totalToFill = v;
		double fill1 = v / (v0v1 + 1);
		double fill0 = totalToFill - fill1;

		// take v0 from 0, and v1 from 1
		result = Math.min(result, Math.max(timeToFill(ri[1], fill0), timeToFill(ri[0], fill1)));
		return format(result);

	}

	private static String format(double result) {
		DecimalFormat df = new DecimalFormat("0.0000000000");
		return df.format(result);
	}

	private static double timeToFill(double r, double v) {
		return v / r;
	}

	private static boolean equal(double a, double b) {
		return Math.abs(a - b) < 1e-9;
	}

}
