import java.io.*;
import java.util.*;

public class Road {
	public static void main(String[] args) throws FileNotFoundException {
		InputStream is = new FileInputStream("bs.in");
		Scanner sc = new Scanner(is);
		int C = sc.nextInt();
		for (int i = 0; i < C; ++i) {
			int N = sc.nextInt(), M = sc.nextInt();
			Intersection[][] G = new Intersection[N][M];
			for (int j = 0; j < N; ++j)
				for (int k = 0; k < M; ++k)
					G[j][k] = new Intersection(sc.nextInt(),
							sc.nextInt(), sc.nextInt());
			System.out.printf("Case #%d: %d\n", i+1, minTime(G, i));
		}
	}
	
	static int minTime(Intersection[][] G, int ca) {
		int R = G.length * 2, C = G[0].length * 2, t = 0;
		boolean[][] covered = new boolean[R][C];
		covered[R-1][0] = true;
		while (!covered[0][C-1]) {
			boolean[][] covered2 = new boolean[R][C];
			for (int r = 0; r < R; ++r)
				for (int c = 0; c < C; ++c) {
					if (!covered[r][c]) continue;
					covered2[r][c] = true;
					if (r % 2 == 0) // top
						covered2[r+1][c] |= G[r/2][c/2].vOpen(t);
					else // bottom
						covered2[r-1][c] |= G[r/2][c/2].vOpen(t);
					if (c % 2 == 0) // left
						covered2[r][c+1] |= G[r/2][c/2].hOpen(t);
					else // right
						covered2[r][c-1] |= G[r/2][c/2].hOpen(t);
				}
			++t;
			if (covered2[0][C-1]) break;
			for (int r = 0; r < R; ++r)
				for (int c = 0; c < C; ++c) {
					if (!covered2[r][c]) continue;
					if (r % 2 == 0) // top
						covered2[r+1][c] |= G[r/2][c/2].vOpen(t);
					else // bottom
						covered2[r-1][c] |= G[r/2][c/2].vOpen(t);
					if (c % 2 == 0) // left
						covered2[r][c+1] |= G[r/2][c/2].hOpen(t);
					else // right
						covered2[r][c-1] |= G[r/2][c/2].hOpen(t);
				}
			for (int r = 0; r < R; ++r)
				for (int c = 0; c < C; ++c) {
					if (!covered[r][c]) continue;
					try {
						if (r % 2 == 0) // top
							covered2[r-1][c] = true;
						else // bottom
							covered2[r+1][c] = true;
					}
					catch (ArrayIndexOutOfBoundsException e) {}
					try {
						if (c % 2 == 0) // left
							covered2[r][c-1] = true;
						else // right
							covered2[r][c+1] = true;
					}
					catch (ArrayIndexOutOfBoundsException e) {}
				}
			covered = covered2; ++t;
		}
		return t;
	}
	
	static class Intersection {
		int vT, hT, t0;
		
		Intersection(int vT, int hT, int t0) {
			this.vT = vT;
			this.hT = hT;
			this.t0 = t0 % (vT + hT);
		}
		
		boolean vOpen(int t) {
			int o = (((t + t0) % (vT + hT)) + vT + hT) % (vT + hT);
			return o < vT;
		}
		
		boolean hOpen(int t) {
			return !vOpen(t);
		}
	}
}

/*
2
1 1
3 2 10
1 2
1 5 3 1 5 2

*/