import java.util.*;
import java.io.*;

public class Language {
	public static void main(String[] args) throws FileNotFoundException {
		InputStream is = new FileInputStream("A-small-attempt0.in");
		Scanner sc = new Scanner(is);
		int L = sc.nextInt(), D = sc.nextInt(), N = sc.nextInt();
		sc.nextLine();
		Trie words = new Trie(null, null);
		for (int i = 0; i < D; ++i)
			words.add(sc.nextLine(), 0);
		for (int i = 0; i < N; ++i) {
			String pattern = sc.nextLine();
			List<Trie> matches = new LinkedList<Trie>();
			matches.add(words); // add the root
			
			for (int j = 0; j < pattern.length(); ++j) {
				List<Trie> newMatches = new LinkedList<Trie>();
				char c = pattern.charAt(j);
				if (c == '(') {
					List<Character> chars = new LinkedList<Character>();
					do chars.add(c = pattern.charAt(++j));
					while (c != ')');
					for (Trie match : matches)
						for (Character ch : chars)
							if (match.children.containsKey(ch))
								newMatches.add(match.children.get(ch));
				}
				else
					for (Trie match : matches)
						if (match.children.containsKey(c))
							newMatches.add(match.children.get(c));
				matches = newMatches;
			}
			
			System.out.println("Case #" + (i + 1) + ": " + matches.size());
		}
	}
	
	// A quick and dirty trie implementation with little encapsulation
	static class Trie {
		Character c;
		Trie parent;
		HashMap<Character, Trie> children;
		
		Trie(Character c, Trie parent) {
			this.c = c;
			this.parent = parent;
			children = new HashMap<Character, Trie>();
		}
		
		void add(String s, int i) {
			if (s.isEmpty() || i == s.length())
				return;
			Character c = s.charAt(i);
			if (!children.containsKey(c))
				children.put(c, new Trie(c, this));
			children.get(c).add(s, i + 1);
		}
		
		public String toString() {
			StringBuffer sb = new StringBuffer();
			Trie n = this;
			while (n.parent != null)
				sb.append((n = n.parent).c);
			return sb.toString();
		}
	}
}
