package world2015.round3;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class Fairland {

	public int solveForSmall(int N, int D, int[] S, int[] M) {
		Node[] nodes = new Node[N];
		for (int i=0; i<N; i++)
			nodes[i] = new Node(i, S[i]);
		for (int i=1; i<N; i++) {
			int m = M[i]%i;
			nodes[m].cnodes.add(nodes[i]);
		}
		int max = 0;
		for (int min=0; min+D<=1000; min++) {
			int cnt = nodes[0].count(min, min+D);
			max = Math.max(max, cnt);
		}
		return max;
	}
	
	class Node {
		
		int id;
		int s;
		List<Node> cnodes = new ArrayList<>();
		
		Node(int id, int s) {
			this.id = id;
			this.s = s;
		}
		
		int count(int min, int max) {
			if (s<min || max<s)
				return 0;
			int cnt = 1;
			for (Node node : cnodes)
				cnt += node.count(min, max);
			return cnt;
		}
	}
	
	public static void main(String args[]) throws IOException {
		String inputPath = "file/world2015/round3/A-small-attempt0.in";
		String outputPath = inputPath.substring(0, inputPath.lastIndexOf('.')) + ".out";
		BufferedReader br = new BufferedReader(new FileReader(inputPath));
		PrintWriter pw = new PrintWriter(outputPath);
		int numProblems = nextInt(br);
		Fairland fairland = new Fairland();
		for (int i=0; i<numProblems; i++) {
			int[] ND = nextIntArray(br);
			int N = ND[0], D = ND[1];
			int[] SACR = nextIntArray(br);
			int[] MACR = nextIntArray(br);
			int[] S = salaries(N, SACR[0], SACR[1], SACR[2], SACR[3]);
			int[] M = managers(N, MACR[0], MACR[1], MACR[2], MACR[3]);
			int res = fairland.solveForSmall(N, D, S, M);
			StringBuilder sb = new StringBuilder();
			sb.append("Case #" + (i+1) + ": " + res);
			System.out.println(sb);
			pw.println(sb);
		}
		br.close();
		pw.close();
	}
	
	private static int[] salaries(int N, int S0, int As, int Cs, int Rs) {
		int[] S = new int[N];
		S[0] = S0;
		for (int i=1; i<N; i++)
			S[i] = (S[i-1]*As+Cs)%Rs;
		return S;
	}
	
	private static int[] managers(int N, int M0, int Am, int Cm, int Rm) {
		int[] M = new int[N];
		M[0] = M0;
		for (int i=1; i<N; i++)
			M[i] = (M[i-1]*Am+Cm)%Rm;
		return M;
	}
	
	static int nextInt(BufferedReader br) throws IOException {
		return Integer.parseInt(br.readLine().trim());
	}
	
	static int[] nextIntArray(BufferedReader br) throws IOException {
		String[] tokens = br.readLine().trim().split(" ");
		int[] res = new int[tokens.length];
		for (int i=0; i<tokens.length; i++)
			res[i] = Integer.parseInt(tokens[i]);
		return res;
	}
	
	static String nextString(BufferedReader br) throws IOException {
		return br.readLine().trim();
	}
	
	static String[] nextStringArray(BufferedReader br) throws IOException {
		return br.readLine().trim().split(" ");
	}
	
	static long nextLong(BufferedReader br) throws IOException {
		return Long.parseLong(br.readLine().trim());
	}
	
	static long[] nextLongArray(BufferedReader br) throws IOException {
		String[] tokens = br.readLine().trim().split(" ");
		long[] res = new long[tokens.length];
		for (int i=0; i<tokens.length; i++)
			res[i] = Long.parseLong(tokens[i]);
		return res;
	}
	
	static double nextDouble(BufferedReader br) throws IOException {
		return Double.parseDouble(br.readLine().trim());
	}
	
	static double[] nextDoubleArray(BufferedReader br) throws IOException {
		String[] tokens = br.readLine().trim().split(" ");
		double[] res = new double[tokens.length];
		for (int i=0; i<tokens.length; i++)
			res[i] = Double.parseDouble(tokens[i]);
		return res;
	}
}
