package r1b3;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;

import net.lab0.tools.Pair;
import net.lab0.tools.math.MyMath;

public class Elf
{
    public static String in = "src/r1b3/in.txt";
    
    public static void main(String[] args)
    throws Exception
    {
        BufferedReader bufferedReader = new BufferedReader(new FileReader(new File(in)));
        long T = Integer.parseInt(bufferedReader.readLine());
        for (long i = 0; i < T; ++i)
        {
            String f = bufferedReader.readLine();
            long P = Long.parseLong(f.split("/")[0]);
            long Q = Long.parseLong(f.split("/")[1]);
            
            Pair<Long, Long> frac = reduce(P, Q);
            P = frac.a;
            Q = frac.b;
            
            String txt = "Case #" + (i + 1) + ": ";
            
            if (i == 0)
            {
                System.out.print("");
            }
            
            try
            {
                long res = solve(P, Q, 0);
                txt += res;
            }
            catch (Exception e)
            {
                txt += "impossible";
            }
            
            System.out.println(txt);
        }
    }
    
    public static long solve(long p, long q, long depth)
    throws Exception
    {
        if (p == 0)
        {
            // normal case for sub ancestor check
            return depth;
        }
        
        if (depth == 40)
        {
            throw new Exception();
        }
        
        // pure elf ?
        if (p >= q)
        {
            // yes
            if (p == q)
            {
                return depth;
            }
            
            // maybe, check the other part of the ancestors
            solve(p - q, q, depth + 1);
            return depth;
        }
        
        if (q % 2 == 0)
        {
            return solve(p, q / 2, depth + 1);
        }
        else
        {
            if (p > q / 2)
            {
                solve(p, q * 2, depth + 1);
                return depth;
            }
            else
            {
                throw new Exception();
            }
        }
    }
    
    // / http://stackoverflow.com/questions/6618994/simplifying-fractions-in-java
    /** @return the greatest common denominator */
    public static long gcm(long a, long b)
    {
        return b == 0 ? a : gcm(b, a % b); // Not bad for one line of code :)
    }
    
    public static Pair<Long, Long> reduce(long a, long b)
    {
        long gcm = gcm(a, b);
        return new Pair<Long, Long>((a / gcm), (b / gcm));
    }
}
