package codejam2013;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Arrays;

/**
 * @author Dzianis Siarheyeu <denser.by@gmail.com>
 *
 */
public class CJ2013T1 {
	
	static boolean DEBUG = false;

	enum TEST_VAL {
		T(3), X(71), O(1111);

		TEST_VAL(int i) {
			this.i = i;
		}

		private int i;

		public int getVal() {
			return i;
		}

		public static boolean testWonX(int sum) {
			return sum == X.i * 4 || sum == X.i * 3 + T.i;
		}

		public static boolean testWonO(int sum) {
			return sum == O.i * 4 || sum == O.i * 3 + T.i;
		}

		public static int getValByChar(char c) {
			switch (c) {
			case 'X':
				return TEST_VAL.X.getVal();

			case 'O':
				return TEST_VAL.O.getVal();

			case 'T':
				return TEST_VAL.T.getVal();

			case '.':
				return 0;

			default:
				throw new IllegalArgumentException("Wrong input char : " + c);
			}
		}

	};

	public static class TestCase {
		String lines[] = new String[] { "", "", "", "" };

		int sumLine[] = new int[] { 0, 0, 0, 0 };

		int sumRow[] = new int[] { 0, 0, 0, 0 };

		int sumDiagSlash;
		int sumDiagBkslash;

		boolean emptyCell = false;

		public boolean hasEmptyCell() {
			return emptyCell;
		}

		public boolean testWonX() {
			for (int i = 0; i < 4; i++) {
				if (TEST_VAL.testWonX(sumLine[i]))
					return true;
				if (TEST_VAL.testWonX(sumRow[i]))
					return true;
			}
			if (TEST_VAL.testWonX(sumDiagSlash))
				return true;
			if (TEST_VAL.testWonX(sumDiagBkslash))
				return true;
			return false;
		}

		public boolean testWonO() {
			for (int i = 0; i < 4; i++) {
				if (TEST_VAL.testWonO(sumLine[i]))
					return true;
				if (TEST_VAL.testWonO(sumRow[i]))
					return true;
			}
			if (TEST_VAL.testWonO(sumDiagSlash))
				return true;
			if (TEST_VAL.testWonO(sumDiagBkslash))
				return true;
			return false;
		}

		public void setLine(int lineIndex, String l) {
			lines[lineIndex] = l;

			char ch[] = new char[4];

			ch[0] = l.charAt(0);
			ch[1] = l.charAt(1);
			ch[2] = l.charAt(2);
			ch[3] = l.charAt(3);

			int chVal[] = new int[4];

			for (int i = 0; i < 4; i++) {
				chVal[i] = TEST_VAL.getValByChar(ch[i]);
				sumLine[lineIndex] += chVal[i];
				sumRow[i] += chVal[i];
			}

			if (chVal[0] == 0 || chVal[1] == 0 || chVal[2] == 0
					|| chVal[3] == 0) {
				emptyCell = true;
			}

			sumDiagSlash += chVal[lineIndex];
			sumDiagBkslash += chVal[3 - lineIndex];
		}

		@Override
		public String toString() {

			boolean wonX = testWonX();
			boolean wonO = testWonO();

			return "TestCase [lines=" + Arrays.toString(lines) + ", sumLine="
					+ Arrays.toString(sumLine) + ", sumRow="
					+ Arrays.toString(sumRow) + ", sumDiagSlash="
					+ sumDiagSlash + ", sumDiagBkslash=" + sumDiagBkslash

					+ ", wonX = " + wonX + ", wonO = " + wonO
					+ ", emptyCell = " + emptyCell

					+ "]";
		}

	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		System.out.println("Helloff");
		// TODO Auto-generated method stub

		//String filePath = "C:/123/task1-test.txt";
		String filePath = args[0];
		
		File inFile = new File(filePath);
		FileInputStream fis = new FileInputStream(inFile);

		int BUF_SIZE = 4096;
		byte[] b = new byte[BUF_SIZE];
		StringBuffer inBuf = new StringBuffer(10000);

		int readCount = -1;
		do {
			readCount = fis.read(b);
			if(DEBUG) System.out.println("readCount=" + readCount);
			if (readCount >= 1) {
				inBuf.append(new String(b));
			}
		} while (readCount > 0);

		fis.close();

		String inputStr = inBuf.toString();
		int inputStrLength = inputStr.length();
		if(DEBUG) System.out.println("------------------------------------------");
		if(DEBUG) System.out.println(inputStrLength);
		if(DEBUG) System.out.println("------------------------------------------");
		if(DEBUG) System.out.println(inputStr);
		if(DEBUG) System.out.println("------------------------------------------");

		int T = 0;
		int curTestLineIdx = 0;
		int curTestCaseIdx = 0;

		TestCase testCase[] = null;
		StringBuffer curLine = new StringBuffer();
		curLine.setLength(0);
		for (int i = 0; i < inputStrLength; i++) {
			char curChar = inputStr.charAt(i);

			switch (curChar) {
			case '\r':
				break;
			case '\n':
				String line = curLine.toString();
				if (line.trim().length() == 0) {
					if(DEBUG) System.out.println("EMPTY\n");
					if(DEBUG) System.out.println("TestCase=" + testCase[curTestCaseIdx]
							+ "\n");

					curTestCaseIdx++;
					curTestLineIdx = 0;

				} else {
					if (T == 0) {
						T = Integer.parseInt(line.trim());
						if(DEBUG) System.out.println("TESTS=" + T + "\n");

						testCase = new TestCase[T];
						for (int j = 0; j < T; j++) {
							testCase[j] = new TestCase();
						}
						curTestCaseIdx = 0;
						curTestLineIdx = 0;

					} else {
						if(DEBUG) System.out.println("line=" + line);
						testCase[curTestCaseIdx]
								.setLine(curTestLineIdx++, line);
					}
				}
				curLine.setLength(0);
				break;

			default:
				curLine.append(curChar);
				break;
			}

		}
		if(DEBUG) System.out.println("EMPTY\n");
		if(DEBUG) System.out.println("TestCase=" + testCase[curTestCaseIdx] + "\n");

		

		
		StringBuffer outBuf = new StringBuffer(1000);
		
		
		String res = "";
		for(int i = 0; i < T; i++) {
			if (testCase[i].testWonX()) {
				res = "Case #"+(i+1)+": X won";
			} else if (testCase[i].testWonO()) {
				res = "Case #"+(i+1)+": O won";
			} else if (testCase[i].hasEmptyCell()) {
				res = "Case #"+(i+1)+": Game has not completed";
			} else {
				res = "Case #"+(i+1)+": Draw";
			}

			
			System.out.println("" + res);
			outBuf.append(res).append("\r\n");
		}
		

		
		String filePathOut = filePath + ".out";
		File outFile = new File(filePathOut);
		FileOutputStream fos = new FileOutputStream(outFile);
		fos.write(outBuf.toString().getBytes());
		outBuf.setLength(0);
		fos.flush();
		fos.close();
		
		System.out.println("END");

		
		
	}

}
