package codejam2013;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.Iterator;

/**
 * @author Dzianis Siarheyeu <denser.by@gmail.com>
 * 
 */
public class CJ2013T3 {

	static boolean DEBUG = false;

	public static class MyIterator implements Iterator<java.lang.String> {

		String a;
		String b;
		String cur;

		// char aa[];
		// char bb[];

		int alen;
		int blen;

		public MyIterator(java.lang.String a, java.lang.String b) {
			super();
			this.a = a;
			this.b = b;
			alen = a.length();
			blen = b.length();
		}

		@Override
		public boolean hasNext() {
			return cur == null || b.compareToIgnoreCase(cur) != 0;
		}

		@Override
		public java.lang.String next() {

			if (cur == null) {
				cur = a;
			} else {
				int curlen = cur.length() + 1;
				int curx[] = new int[curlen];
				for (int i = 0; i < curlen - 1; i++) {
					curx[i + 1] = Integer.parseInt("" + cur.charAt(i));
				}

				curx[curlen - 1]++;

				for (int i = curlen - 1; i > 0; i--) {
					if (curx[i] > 9) {
						curx[i] = 0;
						curx[i - 1]++;
					}
				}

				StringBuffer buf = new StringBuffer();
				for (int i = 0; i < curlen; i++) {
					if (curx[i] == 0 && i == 0)
						continue;
					buf.append(curx[i]);
				}
				cur = buf.toString();
			}
			return cur;
		}

		@Override
		public void remove() {
			// TODO Auto-generated method stub

		}

	}

	public static class TestCase {

		String a;
		String b;

		long numbers;

		public void setAB(String a, String b) {
			this.a = a;
			this.b = b;
		}

		BigDecimal sq(BigDecimal l) {
			BigDecimal xk = l.divide(BigDecimal.TEN);

			while (xk.pow(2).subtract(l).abs()
					.compareTo(BigDecimal.valueOf(0.1)) > 0) {
				BigDecimal ld = l.divide(xk, 7, RoundingMode.FLOOR);
				BigDecimal ldadd = ld.add(xk);
				BigDecimal two = BigDecimal.valueOf(2);
				xk = ldadd.divide(two);
			}

			xk = xk.setScale(0, RoundingMode.FLOOR);

			return xk;

		}

		public long getNum() {

			MyIterator myIt = new MyIterator(a, b);

			while (myIt.hasNext()) {
				String ll = myIt.next();
				if (ll == null)
					break;

				int len = ll.length();
				int haf = len / 2;
				boolean wrong = false;
				for (int i = 0; i <= haf; i++) {
					if (ll.charAt(i) != ll.charAt(len - 1 - i)) {
						wrong = true;
						break;
					}
				}
				if (wrong)
					continue;

				BigDecimal lll = new BigDecimal(ll);
				BigDecimal sqlll = sq(lll);

				if (sqlll.pow(2).compareTo(lll) != 0) {
					continue;
				}
				// check sqrt

				numbers++;

				if (DEBUG)
					System.out.println(" lll = " + ll + "   sqlll=" + sqlll);
			}

			return numbers;
		}

		@Override
		public String toString() {
			return "TestCase [a=" + a + ", b=" + b + ", numbers=" + numbers
					+ "]";
		}

	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		System.out.println("Helloff");
		// TODO Auto-generated method stub

		String filePath = args[0];

		File inFile = new File(filePath);
		FileInputStream fis = new FileInputStream(inFile);

		int BUF_SIZE = 4096;
		byte[] b = new byte[BUF_SIZE];
		StringBuffer inBuf = new StringBuffer(10000);

		int readCount = -1;
		do {
			readCount = fis.read(b);
			if (DEBUG)
				System.out.println("readCount=" + readCount);
			if (readCount >= 1) {
				inBuf.append(new String(b));
			}
		} while (readCount > 0);

		fis.close();

		String inputStr = inBuf.toString().trim();
		int inputStrLength = inputStr.length();
		if (DEBUG)
			System.out.println("------------------------------------------");
		if (DEBUG)
			System.out.println("inputStrLength=" + inputStrLength);
		if (DEBUG)
			System.out.println("------------------------------------------");
		if (DEBUG)
			System.out.println(inputStr);
		if (DEBUG)
			System.out.println("------------------------------------------");

		int T = 0;
		int curTestCaseIdx = 0;

		TestCase testCase[] = null;
		StringBuffer curLine = new StringBuffer();
		curLine.setLength(0);
		for (int i = 0; i < inputStrLength; i++) {
			char curChar = inputStr.charAt(i);

			switch (curChar) {
			case '\r':
				break;
			case '\n':
				String line = curLine.toString().trim();
				if (DEBUG)
					System.out.println("line=" + line);

				if (T == 0) {
					T = Integer.parseInt(line);
					if (DEBUG)
						System.out.println("TESTS=" + T + "\n");

					testCase = new TestCase[T];
					for (int j = 0; j < T; j++) {
						testCase[j] = new TestCase();
					}
					curTestCaseIdx = 0;

				} else {

					if (line.length() == 0)
						break;

					if (curTestCaseIdx >= T)
						break;

					String[] ablist = line.split(" ");

					String A = ablist[0];
					String B = ablist[1];

					testCase[curTestCaseIdx++].setAB(A, B);

				}

				curLine.setLength(0);
				break;

			default:
				curLine.append(curChar);
				break;
			}

		}

		String line = curLine.toString().trim();
		if (DEBUG)
			System.out.println("line=" + line);
		if (line.length() > 0) {
			String[] ablist = line.split(" ");

			String A = ablist[0];
			String B = ablist[1];

			testCase[curTestCaseIdx++].setAB(A, B);
		}

		StringBuffer outBuf = new StringBuffer(1000);

		String res = "";
		for (int i = 0; i < T; i++) {

			long num = testCase[i].getNum();

			res = "Case #" + (i + 1) + ": " + num;

			if (DEBUG) {
				System.out.println("" + testCase[i].toString());
			}

			outBuf.append(res).append("\r\n");
		}

		if (DEBUG)
			System.out.println("" + outBuf.toString());

		String filePathOut = filePath + ".out";
		File outFile = new File(filePathOut);
		FileOutputStream fos = new FileOutputStream(outFile);
		fos.write(outBuf.toString().getBytes());
		outBuf.setLength(0);
		fos.flush();
		fos.close();

		System.out.println("END");

	}

}
