package codejam2013;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;

public class CJ2013T2 {

	static boolean DEBUG = false;

	public static class TestCase {

		int n;
		int m;
		int data[][];
		String lines[];
		boolean internalBorderCheck = false;

		public void setNM(int n, int m) {
			this.n = n;
			this.m = m;
			this.lines = new String[n];
			this.data = new int[n][m];
		}

		public void setLine(int i, String line) {
			if (DEBUG)
				System.out.println("setLine(" + i + " , " + line + ")");

			lines[i] = line;

			String[] xx = line.split(" ");

			for (int j = 0; j < m; j++) {
				data[i][j] = Integer.parseInt(xx[j]);
			}

			if (DEBUG)
				System.out.println("data[" + i + "]("
						+ Arrays.toString(data[i]) + ")");
		}

		public boolean check() {

			if (DEBUG) {

				StringBuffer buf = new StringBuffer();

				buf.append("{ ");
				for (int i = 0; i < n; i++) {
					buf.append(Arrays.toString(data[i])).append(", ");
				}
				buf.append(" }");

				System.out.println("check()  data=" + buf.toString());

			}

			if (internalBorderCheck == false) {
				internalBorderCheck = true;

				for (int i = 1; i < n - 1; i++) {
					for (int j = 1; j < m - 1; j++) {
						// check borders data[i][j]

						if (data[i][j] < data[i - 1][j]
								&& data[i][j] < data[i][j - 1]
								&& data[i][j] < data[i + 1][j]
								&& data[i][j] < data[i][j + 1]) {
							return false;
						}

						if (data[i][j] > data[i - 1][j]
								&& data[i][j] > data[i][j - 1]
								&& data[i][j] > data[i + 1][j]
								&& data[i][j] > data[i][j + 1]) {
							return false;
						}
					}
				}

			}

			int mx[][] = data;

			int mxN = mx.length;
			int mxM = mx[0].length;

			if (mxN < 2 || mxM < 2)
				return true;

			int similarN = 0;
			for (int i = 0; i < mxN; i++) {
				int pattern = mx[i][0];

				if (pattern == 0) {
					// search not 0 pattern
					for (int b = 0; b < mxM; b++) {
						if (mx[i][b] != 0) {
							pattern = mx[i][b];
							break;
						}
					}
				}

				if (pattern == 0)
					continue;
				boolean s = true;
				for (int j = 0; j < mxM; j++) {
					if (mx[i][j] != pattern && mx[i][j] != 0) {
						s = false;
						break;
					}
				}
				if (s) {
					similarN++;
					for (int j = 0; j < mxM; j++) {
						mx[i][j] = 0;
					}
				}
			}

			int similarM = 0;
			for (int i = 0; i < mxM; i++) {
				int pattern = mx[0][i];

				if (pattern == 0) {
					// search not 0 pattern
					for (int b = 0; b < mxN; b++) {
						if (mx[b][i] != 0) {
							pattern = mx[b][i];
							break;
						}
					}
				}

				if (pattern == 0)
					continue;
				boolean s = true;
				for (int j = 0; j < mxN; j++) {
					if (mx[j][i] != pattern && mx[j][i] != 0) {
						s = false;
						break;
					}
				}
				if (s) {
					similarM++;
					for (int j = 0; j < mxN; j++) {
						mx[j][i] = 0;
					}
				}
			}

			if (similarN + similarM < 1) {
				// check for not 0
				for (int i = 0; i < mxN; i++) {
					for (int j = 0; j < mxM; j++) {
						if (mx[i][j] != 0) {
							return false;
						}
					}
				}

			} else {
				// check again
				return check();
			}

			return true;
		}

		@Override
		public String toString() {

			StringBuffer buf = new StringBuffer();

			buf.append("{ ");
			for (int i = 0; i < n; i++) {
				buf.append(Arrays.toString(data[i])).append(", ");
			}
			buf.append(" }");

			return "TestCase [n=" + n + ", m=" + m + ", lines="
					+ Arrays.toString(lines) + ", data=" + buf.toString() + "]";
		}

	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		System.out.println("Helloff");
		// TODO Auto-generated method stub

		// String filePath = "C:/123/task1-test.txt";
		String filePath = args[0];

		File inFile = new File(filePath);
		FileInputStream fis = new FileInputStream(inFile);

		int BUF_SIZE = 4096;
		byte[] b = new byte[BUF_SIZE];
		StringBuffer inBuf = new StringBuffer(10000);

		int readCount = -1;
		do {
			readCount = fis.read(b);
			if (DEBUG)
				System.out.println("readCount=" + readCount);
			if (readCount >= 1) {
				inBuf.append(new String(b));
			}
		} while (readCount > 0);

		fis.close();

		String inputStr = inBuf.toString().trim();
		int inputStrLength = inputStr.length();
		if (DEBUG)
			System.out.println("------------------------------------------");
		if (DEBUG)
			System.out.println("inputStrLength=" + inputStrLength);
		if (DEBUG)
			System.out.println("------------------------------------------");
		if (DEBUG)
			System.out.println(inputStr);
		if (DEBUG)
			System.out.println("------------------------------------------");

		int T = 0;
		int curTestLineIdx = 0;
		int curTestCaseIdx = 0;
		int N = 0;
		int M = 0;

		TestCase testCase[] = null;
		StringBuffer curLine = new StringBuffer();
		curLine.setLength(0);
		for (int i = 0; i < inputStrLength; i++) {
			char curChar = inputStr.charAt(i);

			switch (curChar) {
			case '\r':
				break;
			case '\n':
				String line = curLine.toString().trim();
				if (DEBUG)
					System.out.println("line=" + line);

				if (T == 0) {
					T = Integer.parseInt(line.trim());
					if (DEBUG)
						System.out.println("TESTS=" + T + "\n");

					testCase = new TestCase[T];
					for (int j = 0; j < T; j++) {
						testCase[j] = new TestCase();
					}
					curTestCaseIdx = 0;
					curTestLineIdx = 0;

				} else {
					
					if(line.length() == 0)
						break;


					if (curTestLineIdx >= N && N != 0) {
						N = 0;
						M = 0;
						curTestLineIdx = 0;
						// if (DEBUG)
						// System.out.println("INCREMENT");
						curTestCaseIdx++;
					}
					
					if (curTestCaseIdx >= T)
						break;

					if (N == 0 || M == 0) {

						String[] nmlist = line.split(" ");
						if (nmlist == null || nmlist.length != 2) {
							throw new IllegalStateException("Wrong N, M pair!");
						}

						N = Integer.parseInt(nmlist[0]);
						M = Integer.parseInt(nmlist[1]);


						if (DEBUG)
							System.out.println("curTestCaseIdx = "
									+ curTestCaseIdx + " , curTestLineIdx = "
									+ curTestLineIdx + ", N = " + N + " , M = "
									+ M);
						
						testCase[curTestCaseIdx].setNM(N, M);

					} else {

						// if (DEBUG)
						// System.out.println("!!!! case = "
						// + curTestCaseIdx + ", line = "
						// + curTestLineIdx + " , data = " + line);

						testCase[curTestCaseIdx].setLine(curTestLineIdx, line);

						curTestLineIdx++;

						// if (DEBUG)
						// System.out.println("!!!!");
					}

				}

				curLine.setLength(0);
				break;

			default:
				curLine.append(curChar);
				break;
			}

		}

		if (curTestLineIdx < N) {
			String line = curLine.toString().trim();
			testCase[curTestCaseIdx].setLine(curTestLineIdx, line);
		}

		StringBuffer outBuf = new StringBuffer(1000);

		String res = "";
		for (int i = 0; i < T; i++) {

			if (testCase[i].check()) {
				res = "Case #" + (i + 1) + ": YES";
			} else {
				res = "Case #" + (i + 1) + ": NO";
			}

			if (DEBUG) {
				System.out.println("" + testCase[i].toString());
			}

			outBuf.append(res).append("\r\n");
		}

		// if (DEBUG)
		System.out.println("" + outBuf.toString());

		String filePathOut = filePath + ".out";
		File outFile = new File(filePathOut);
		FileOutputStream fos = new FileOutputStream(outFile);
		fos.write(outBuf.toString().getBytes());
		outBuf.setLength(0);
		fos.flush();
		fos.close();

		System.out.println("END");

	}

}
