package round1b.taskc;

import java.lang.*;
import java.util.*;
import java.io.*;
import java.math.*;

/**
*
* @author "Dzianis Siarheyeu" <denser.by@gmail.com>
*
*/
public class TaskC {







	public static void main(String[] args) throws Exception {

System.out.println("Hello World");

String inFileName = "C:/Users/devel/Downloads/C-small-attempt0.in";
String outFileName = inFileName.replace(".in", ".out");

File inFile = new File(inFileName);
FileInputStream inStream = new FileInputStream(inFile);
File outFile = new File(outFileName);
FileOutputStream outStream = new FileOutputStream(outFile);


int curItem;

DataReader dataReader = new DataReader();

while((curItem = inStream.read()) != -1) {
	dataReader.feedSymbol(curItem);
}
dataReader.endFileReached();

inStream.close();


dataReader.dump();



for (int i = 0; i < dataReader.testCases.length; i++) {

	Node.sumsMap.clear();
	
	TestCase curTest = dataReader.testCases[i];
	System.out.println( ">>> i=" + i + "   curTest=" + curTest);

	Node n1 = null, n2 = null;


	try {
		Node.buildTreeForValue(0, curTest.data.numbers);
	} catch(WeHaveSolutionException ex) {
		n1 = ex.n1;
		n2 = ex.n2;
	}


String s1 = "Case #" + curTest.id + ":\n";
outStream.write(s1.getBytes());


	if (n1 == null) {
		//IMPOSSIBLE
		System.out.println("\n\nIMPOSSIBLE");
outStream.write("Impossible\n".getBytes());
	} else {
		//POSSIBLE
		Integer[] subset1 = n1.getSubset(curTest.data.numbers);
		Integer[] subset2 = n2.getSubset(curTest.data.numbers);
		System.out.println(" n1=" + n1);
		System.out.println(" n2=" + n2);

Integer[][] subsets = n1.removeIntersection(subset1 , subset2 );
subset1 = subsets[0];
subset2 = subsets[1];


		System.out.println("\n\nPOSSIBLE   subset1=" + Arrays.toString(subset1) + "   subset2=" + Arrays.toString(subset2));
String l1 = Arrays.toString(subset1).replace("[", "").replace("]", "").replace(",", "") + "\n";
String l2 = Arrays.toString(subset2).replace("[", "").replace("]", "").replace(",", "") + "\n";
outStream.write(l1.getBytes());
outStream.write(l2.getBytes());
	}


	System.out.println( ">>> i  TEST finished");
}






outStream.flush();
outStream.close();

System.out.println("-------------END----------------");

	}

	static class InputData {
		int N;
		int[] numbers;
		String line;

		public InputData(String line) {
			String[] parts = line.split(" ");
			this.N = Integer.parseInt(parts[0]);
this.numbers = new int[N];
			this.line = line;
			for (int i = 1; i <= N; i++) {
			//	System.out.println(" parts[" + i + "]=" + parts[i]);
				this.numbers[i-1] = Integer.parseInt(parts[i]);
			}

		}


		public String toString() {
			return "InputData[ N=" + N + ", line=" + line + ", numbers=" + Arrays.toString(numbers) +  "]";
		}
	}


	static class TestCase {
		public int id;
		public InputData data;
		
		public TestCase(String line, int id) {
			this.id = id;
			this.data = new InputData(line);
		}

		public boolean isComplete() {
			return data != null;
		}

		public String toString() {
			return "TestCase[ id=" + id + ", data=" + data +  "]";
		}

	}

	static class DataReader {
		StringBuffer curLine = new StringBuffer();
		public int testsNum;
		TestCase[] testCases;
		int inFileLineNum = 0;
		TestCase curTestCase;
		int curTestCasesIndex = 0;

		void dump() {
			System.out.println("   testsNum=" + testsNum);
			for (int i = 0; i < testsNum; i++) {
				System.out.println("  testCases[" + i + "]=" + testCases[i]);
			}
		}
		
		void feedSymbol(int symbol) {
char ch = (char) symbol;
switch(ch) {
case '\r':
//skip it
break;

case '\n':
processLine();
curLine.setLength(0);
break;

default:
curLine.append(ch);
break;
}
		}

		void processLine() {
inFileLineNum++;
String line = curLine.toString();
System.out.println("processLine()   testsNum=" +testsNum+"  inFileLineNum="+inFileLineNum+"   line=" + line);

if (testsNum == 0) {

System.out.println("9");

	//first line
	testsNum = Integer.parseInt(line);
	testCases = new TestCase[testsNum];

} else {

System.out.println("0");

	curTestCase = new TestCase(line, curTestCasesIndex+1);

	testCases[curTestCasesIndex] = curTestCase;
	curTestCasesIndex++;
	
}
		}

		void endFileReached() {
String line = curLine.toString();
if (line.length() > 0)
processLine();
		}
		
	}


	static class WeHaveSolutionException extends Exception {
		Node n1, n2;

		public WeHaveSolutionException(Node n1, Node n2) {
			this.n1 = n1;
			this.n2 = n2;
		}

		public String toString() {
			return "Ex [" + " n1=" + n1 + ", n2=" + n2 + "]";
		}
	}
	


	static class Node {
		int curIndex; //[0..N-1] or -1
		BigDecimal curSum;
		Node parent;
		int maxChilds;
		int curAddChild = 0;

		static Map<BigDecimal, Node> sumsMap = new HashMap<BigDecimal, Node>();


		public Node(int curIndex, int curValue, BigDecimal parentSum, Node parent) throws WeHaveSolutionException {
			this.curIndex = curIndex;
			this.curSum = parentSum.add(new BigDecimal(curValue));
this.parent = parent;

			if (curSum.compareTo(new BigDecimal(0)) != 0) {

			if(sumsMap.containsKey(curSum) == false) {
				sumsMap.put(curSum, this);
			} else {
				Node firstNode = sumsMap.get(curSum);
				Node secondNode = this;
				throw new WeHaveSolutionException(firstNode, secondNode);
			}
			}

		}

		public static void buildTreeForValue(int curIndex, int[] values) throws WeHaveSolutionException  {

			
			Node root = new Node(curIndex, values[curIndex], new BigDecimal(0), null);

			for (int i = curIndex+1; i < values.length; i++) {
				buildSubTree(i, values, root);
			}
		}

		public static void buildSubTree(int curIndex, int[] values, Node parent) throws WeHaveSolutionException  {
			Node node = new Node(curIndex, values[curIndex], parent.curSum, parent);

			for (int i = curIndex+1; i < values.length; i++) {
				buildSubTree(i, values, node);
			}
			
		}

		public Integer[][] removeIntersection(Integer[] s1, Integer[] s2) {
System.out.println("removeIntersection()   s1"+ Arrays.toString(s1) + "   s2"+ Arrays.toString(s2));
			Set<Integer> set = new HashSet<Integer>();
			for (Integer iii : s1) {
				set.add(iii);
			}
			

			List<Integer> s2reduced = new ArrayList<Integer>();
			for (int i = 0; i < s2.length; i++) {
				Integer cur = s2[i];
				if (set.contains(cur)) {
					set.remove(cur);
				} else {
					s2reduced.add(cur);
				}
			}

			Integer[][] resp = new Integer[2][];
			resp[0] = set.toArray(new Integer[0]);
			resp[1] = s2reduced.toArray(new Integer[0]);
System.out.println("removeIntersection()   resp[0]"+ Arrays.toString(resp[0]) + "   resp[1]"+ Arrays.toString(resp[1]));
			return resp;
		}



		public Integer[] getSubset(int[] numbers) {
System.out.println("getSubset()   numbers=" + Arrays.toString(numbers));

			Node item = this;
			List<Integer> answer = new ArrayList<Integer>();

			while(item!= null) {
if (curSum.compareTo(new BigDecimal(0)) != 0) {
				answer.add(numbers[item.curIndex]);
}
				item = item.parent;
			}

			Integer[] resp = answer.toArray(new Integer[0]);

System.out.println("getSubset()   resp=" + Arrays.toString(resp));
			return resp;
		}

		public String toString() {
			return "NODE [" + "  curSum=" + curSum + "   curIndex=" + curIndex +"]";
		}

	}


}
