package round1C_17;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;


@SuppressWarnings("WeakerAccess")
public class C implements Callable<String> {

    //declare vars
    int N,K;
    double U;
    double[] P;


    //parse input in constructor
    public C(Scanner in) throws IOException {
        N=in.nextInt();
        K=in.nextInt();
        U=in.nextDouble();
        P=new double[N+1];
        P[N] = 1.0;
        for(int i=0;i<N;++i) P[i]=in.nextDouble();
    }
    //solve the test case in this method
    @Override
    public String call() throws Exception {
        Arrays.sort(P);
        err.println(Arrays.toString(P));
        for(int i=0; i<N;++i) {
            double diff = P[i+1]-P[i];
            if(diff*(i+1) <=U) {
                U-= diff*(i+1);
                for(int j=0; j<=i ;++j) P[j] = P[i+1];
            } else {
                double add = U/(i+1);
                for(int j=0; j<=i ;++j) P[j] += add;
                break;
            }
            err.println(Arrays.toString(P));
        }
        err.println("Final "+Arrays.toString(P));
        double res=1.0;
        for(int i=0;i<N;++i) res*= P[i];
        return ""+res;
    }

    private ByteArrayOutputStream outBuffer = new ByteArrayOutputStream();
    private PrintStream out= new PrintStream(outBuffer);
    private ByteArrayOutputStream errBuffer = new ByteArrayOutputStream();
    private PrintStream err= new PrintStream(errBuffer);

    @SuppressWarnings("unchecked")
    public static void main(String[] args) {
        int testNb=-1;
        if(args.length>0 && args[0].length()>0) { try { testNb= Integer.parseInt(args[0]);} catch (NumberFormatException nfe) {}}
        Class currentClass=new Object() { }.getClass().getEnclosingClass();
        Locale.setDefault(Locale.US);
        try {
            Constructor<?> cons = currentClass.getConstructor(Scanner.class);
            Field errBuf = currentClass.getDeclaredField("errBuffer");
            Scanner sc = new Scanner(System.in);
            ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(7);

            int tests = sc.nextInt();
            if(testNb > tests || testNb < 1) testNb=-1;
            @SuppressWarnings("unchecked")
            Future<String>[] ts = new Future[tests];
            Callable<String>[] allTests= new Callable[tests];
            for (int test = 0; test < tests; ++test) {
                allTests[test] = (Callable<String>)cons.newInstance(sc);
                if(testNb ==-1 || testNb-1 == test) ts[test] = service.submit(allTests[test]);
            }
            int start = testNb==-1?0:testNb-1, end = testNb==-1? tests : testNb;
            for (int test = start; test < end; ++test) {
                ByteArrayOutputStream errBuffer = (ByteArrayOutputStream)errBuf.get(allTests[test]);
                System.out.print("Case #" + (test + 1) + ": ");
                String res;
                try {
                    res = ts[test].get();
                } catch(ExecutionException ee) {
                    System.out.println();
                    System.err.println("======== "+(test+1)+" errors ========>" );
                    System.err.println(errBuffer.toString());
                    ee.getCause().printStackTrace();
                    continue;
                }
                if(res != null) System.out.println(res);
                String errStr = errBuffer.toString();
                if(errStr != null && errStr.length() >0) {
                    System.err.println(errStr);
                }
                System.out.flush();
            }
            service.shutdown();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

