package Qualif13;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;


public class B {
	// get Pb Letter for input/output file names.
	public static String pbLetter;
	static {
		pbLetter=new Object() { }.getClass().getEnclosingClass().getName();
		int idx = pbLetter.lastIndexOf('.');
		if(idx != -1) pbLetter = pbLetter.substring(idx+1);
		pbLetter = pbLetter.toUpperCase();
	}
	public static int[] winning = {0xF,0xF0,0xF00,0xF000,0x1111,0x2222,0x4444,0x8888,0x1248,0x8421};
	
	public static void main(String[] args) throws Throwable {
		//Scanner sc = new Scanner(new File("./"+pbLetter+"-small.in"));
		//Scanner sc = new Scanner(new File("./"+pbLetter+"-small-attempt0.in"));
		Scanner sc = new Scanner(new File("./"+pbLetter+"-large.in"));
		
		TeePrintStream out= new TeePrintStream(System.out, "./output-"+pbLetter+".txt");
		
		int testCount = sc.nextInt();
		sc.nextLine();
		for (int i = 1; i <= testCount; i++) {
			out.format("Case #%d: ",i );
			solve(sc, out);
		}
		out.close();
	}

	static void solve(Scanner sc, PrintStream out) {
		int N=sc.nextInt();
		int M=sc.nextInt();
		sc.nextLine();
		int[][] board = new int[N][M];
		int[] maxLine = new int[N];
		int[] maxCol = new int[M];
		Arrays.fill(maxLine,0);
		Arrays.fill(maxCol,0);
		
		for (int i = 0; i < N; i++) {
			for(int j=0; j<M ; j++) {
				int s = sc.nextInt();
				board[i][j] = s;
				maxLine[i] = Math.max(s, maxLine[i] );
				maxCol[j] = Math.max(s, maxCol[j] );
			}
			sc.nextLine();
		}

		for (int i = 0; i < N; i++) {
			for(int j=0; j<M ; j++) {
				if(board[i][j] < maxLine[i] && board[i][j] < maxCol[j] ) {
					out.println("NO");
					return;
				}
			}
		}
		out.println("YES");
	}


static class TeePrintStream extends PrintStream {
	  protected PrintStream parent;
	  
	  public TeePrintStream(PrintStream orig, OutputStream os, boolean flush)
	      throws IOException {
	    super(os, flush);
	    parent = orig;
	  }
	  public TeePrintStream(PrintStream orig, String fn)
	      throws IOException {
	    this(orig, new FileOutputStream(fn), true);
	  }

	  public boolean checkError() {
	    return parent.checkError() || super.checkError();
	  }
	  public void write(int x) {
	    parent.write(x);
	    super.write(x); 
	  }

	  /** override write(). This is the actual "tee" operation. */
	  public void write(byte[] x, int o, int l) {
	    parent.write(x, o, l); 
	    super.write(x, o, l);
	  }

	  /** Close both streams. */
	  public void close() {
	    parent.close();
	    super.close();
	  }
	  /** Flush both streams. */
	  public void flush() {
	    parent.flush();
	    super.flush();
	  }
	}
}