package Qualif17;

import java.io.*;
import java.lang.reflect.Method;
import java.math.BigInteger;
import java.util.Locale;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;

public class C {
	
	//private String theFile="-small.in";
	//private String theFile="-small-2-attempt0.in";
	private  String theFile="-large.in";


	//everything happens here in constructor and solve()
	static class TestCase implements Callable<String> {
		//declare vars
		BigInteger N,K,TWO=new BigInteger("2");

		
		//parse input
		TestCase(Scanner in) throws IOException {
			N = new BigInteger(in.next());
			K = new BigInteger(in.next());
		}
		String solve() {
		    char[] bdigit = K.toString(2).toCharArray();
		    char[] ndigit = N.toString(2).toCharArray();
		    if(ndigit.length == bdigit.length) return "0 0";
		    BigInteger[] first=split(N);
            if(K.equals(BigInteger.ONE)) return first[0]+" "+first[1];
            BigInteger tot=BigInteger.ONE;
            BigInteger[] state;
            if(!first[0].equals(first[1])) state=new BigInteger[] {first[0],BigInteger.ONE,first[1],BigInteger.ONE};
            else state=new BigInteger[] {first[0],TWO,BigInteger.ZERO,BigInteger.ZERO};
			for(int i=1;i<bdigit.length-1;++i) {
			    tot=tot.add(state[1]).add(state[3]);
			    split(state);
			}
			BigInteger end;
			//err.println(state[0]+","+state[1]+","+state[2]+","+state[3]+","+tot);
            tot=tot.add(state[1]);
            if(K.compareTo(tot) <=0) end = state[0];
            else end=state[2];
            BigInteger[] res= split(end);
            return res[0] + " " + res[1];
		}
		BigInteger[] split(BigInteger bi) {
			BigInteger[] div= bi.divideAndRemainder(TWO);
			BigInteger[] res=new BigInteger[2];
			if(div[1].equals(BigInteger.ZERO)) {
			    res[0] = div[0];
			    res[1] = div[0].subtract(BigInteger.ONE);
            } else {
			    res[0] = div[0];
			    res[1] = div[0];
            }
            //err.println("split "+bi+"==>"+res[0]+","+res[1]);
            return res;
		}
		void split(BigInteger[] state) {
            BigInteger[] div= state[0].divideAndRemainder(TWO);
            state[0] = div[0];
            state[2] = div[0].subtract(BigInteger.ONE);
            if(div[1].equals(BigInteger.ZERO)) state[3] = state[1].add(TWO.multiply(state[3]));
            else state[1] = state[3].add(TWO.multiply(state[1]));
            //err.println("split "+state[0]+","+state[1]+","+state[2]+","+state[3]);
        }
		ByteArrayOutputStream errBuffer = new ByteArrayOutputStream();
		PrintStream err= new PrintStream(errBuffer);

        @Override
        public String call() throws Exception {
            return solve();
        }
	}
	
	public void run() {
		try {
			Scanner sc = new Scanner( new BufferedReader(new FileReader(Folder+"/"+pbLetter+theFile)));
			PrintStream out = new TeePrintStream(System.out,Folder+"/"+pbLetter + "-output.txt");
			
			ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(7);
			
			int tests = sc.nextInt();
			@SuppressWarnings("unchecked")
			Future<String>[] ts = new Future[tests];
			TestCase[] allTests= new TestCase[tests];
			for (int test = 0; test < tests; ++test) {
			    allTests[test] = new TestCase(sc);
				ts[test] = service.submit(allTests[test]);
			}
			for (int test = 0; test < tests; ++test) {
				out.print("Case #" + (test + 1) + ": ");
				String res;
				try {
					res = ts[test].get();
				} catch(ExecutionException ee) {
					out.println();
					System.out.println("======== "+(test+1)+" errors ========>" );
					System.out.println(allTests[test].errBuffer.toString());
					ee.getCause().printStackTrace(System.out);
					continue;
				}
				if(res != null) out.println(res);
				String errStr = allTests[test].errBuffer.toString();
				if(errStr != null && errStr.length() >0) {
					System.out.println("======== "+(test+1)+" errors ========>" );
					System.out.println(errStr);
				}
				out.flush();
			}
			service.shutdown();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		Method m;
		try {
			m = currentClass.getMethod("run");
			m.invoke(currentClass.newInstance(),(Object[])null);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	static private String pbLetter;

	static private String Folder;
	
	static private Class<?> currentClass;
	static {
		currentClass = new Object() { }.getClass().getEnclosingClass();
		pbLetter=currentClass.getName();
		Folder = "src/"+currentClass.getPackage().getName();
		int idx = pbLetter.lastIndexOf('.');
		if(idx != -1) pbLetter = pbLetter.substring(idx+1);
		pbLetter = pbLetter.toUpperCase();
	}
	static class TeePrintStream extends PrintStream {
		protected PrintStream parent;

		TeePrintStream(PrintStream orig, OutputStream os, boolean flush)
				throws IOException {
			super(os, flush);
			parent = orig;
		}
		TeePrintStream(PrintStream orig, String fn)
				throws IOException {
			this(orig, new FileOutputStream(fn), true);
		}

		public boolean checkError() {
			return parent.checkError() || super.checkError();
		}
		public void write(int x) {
			parent.write(x);
			super.write(x); 
		}

		/** override write(). This is the actual "tee" operation. */
		public void write(byte[] x, int o, int l) {
			parent.write(x, o, l); 
			super.write(x, o, l);
		}

		/** Close both streams. */
		public void close() {
			parent.close();
			super.close();
		}
		/** Flush both streams. */
		public void flush() {
			parent.flush();
			super.flush();
		}
	}
}

