package round1B_17;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.util.*;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;


@SuppressWarnings("WeakerAccess")
public class C implements Callable<String> {

    //declare vars
    int N,Q;
    int[][] dist;
    int[] maxDist;
    int[] speed;
    int[] from,to;

    //parse input in constructor
    public C(Scanner in) throws IOException {
        N=in.nextInt();
        Q=in.nextInt();
        speed = new int[N];
        maxDist = new int[N];
        from = new int[Q];
        to=new int[Q];
        dist= new int[N][N];
        for(int i=0;i<N;++i) {maxDist[i] = in.nextInt(); speed[i] =in.nextInt();}
        for(int i=0;i<N;++i) for(int j=0;j<N;++j) dist[i][j] = in.nextInt();
        for(int i=0;i<Q;++i)  {from[i]=in.nextInt()-1; to[i]=in.nextInt()-1;}
    }
    //solve the test case in this method
    @Override
    public String call() throws Exception {
        double res[] = new double[Q];

        for(int i=0;i<Q ;++i) {
            Vertex start = new Vertex(from[i], from[i], maxDist[i]);
            res[i] = Dijkstra.computePaths(start,to[i],dist,speed,maxDist,err).minDistance;
        }
        out.print(res[0]);
        for(int i=1;i<Q;++i) out.print(" "+res[i]);
        return outBuffer.toString();
    }

    private ByteArrayOutputStream outBuffer = new ByteArrayOutputStream();
    private PrintStream out= new PrintStream(outBuffer);
    private ByteArrayOutputStream errBuffer = new ByteArrayOutputStream();
    private PrintStream err= new PrintStream(errBuffer);

    @SuppressWarnings("unchecked")
    public static void main(String[] args) {
        Class currentClass=new Object() { }.getClass().getEnclosingClass();
        Locale.setDefault(Locale.US);
        try {
            Constructor<?> cons = currentClass.getConstructor(Scanner.class);
            Field errBuf = currentClass.getDeclaredField("errBuffer");
            Scanner sc = new Scanner(System.in);
            ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(7);

            int tests = sc.nextInt();
            @SuppressWarnings("unchecked")
            Future<String>[] ts = new Future[tests];
            Callable<String>[] allTests= new Callable[tests];
            for (int test = 0; test < tests; ++test) {
                allTests[test] = (Callable<String>)cons.newInstance(sc);
                ts[test] = service.submit(allTests[test]);
            }
            for (int test = 0; test < tests; ++test) {
                ByteArrayOutputStream errBuffer = (ByteArrayOutputStream)errBuf.get(allTests[test]);
                System.out.print("Case #" + (test + 1) + ": ");
                String res;
                try {
                    res = ts[test].get();
                } catch(ExecutionException ee) {
                    System.out.println();
                    System.err.println("======== "+(test+1)+" errors ========>" );
                    System.err.println(errBuffer.toString());
                    ee.getCause().printStackTrace();
                    continue;
                }
                if(res != null) System.out.println(res);
                String errStr = errBuffer.toString();
                if(errStr != null && errStr.length() >0) {
                    System.err.println("======== "+(test+1)+" errors ========>" );
                    System.err.println(errStr);
                }
                System.out.flush();
            }
            service.shutdown();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static class Vertex implements Comparable<Vertex>
    {
        int city,horse,distLeft;
        public Vector<Edge> getAdjacencies(int[][] dist,int[] speed,int[]maxDist,PrintStream err) {
            Vector<Edge> res = new Vector<>();
            for(int i=0; i<speed.length;++i) {
                if(dist[city][i] != -1 && maxDist[city] >= dist[city][i] ) {

                    Vertex n = new Vertex(i, city, maxDist[city] - dist[city][i]);
                    res.add(new Edge(n,1.0*dist[city][i]/speed[city]));
                }
                if(dist[city][i] != -1 && distLeft >= dist[city][i] ) {

                    Vertex n = new Vertex(i, horse, distLeft - dist[city][i]);
                    res.add(new Edge(n,1.0*dist[city][i]/speed[horse]));
                }

            }
            err.println("From "+this);
            for(Edge e :res) err.println(""+e);
            return res;
        }
        public boolean equals(Object o) {
            Vertex other = (Vertex)o;
            return city==other.city && horse == other.horse && distLeft == other.distLeft;
        }
        public double minDistance = Double.POSITIVE_INFINITY;
        public Vertex previous; // stores result


        public Vertex(int c,int h, int d) {
            city=c; horse=h; distLeft=d;
        }

        public String toString() {
            return city+"|"+horse;
        }


        public int compareTo(Vertex other)
        {
            return Double.compare(minDistance, other.minDistance);
        }

    }


    static class Edge
    {
        public final Vertex target;
        public final double weight;

        public Edge(Vertex argTarget, double argWeight) {

            target = argTarget;
            weight = argWeight;
        }
        public String toString() {
            return weight+"=>"+target;
        }
    }


    static class Dijkstra {
        public static Vertex computePaths(Vertex source,int target,int[][] dist,int[] speed,int[]maxDist,PrintStream err) {
            source.minDistance = 0.;
            PriorityQueue<Vertex> vertexQueue = new PriorityQueue<>();
            vertexQueue.add(source);

            while (!vertexQueue.isEmpty()) {
                Vertex u = vertexQueue.poll();
                if(u.city==target) return u;
                // Visit each edge exiting u
                for (Edge e : u.getAdjacencies(dist,speed,maxDist,err)) {
                    Vertex v = e.target;
                    double distanceThroughU = u.minDistance + e.weight;
                    if (distanceThroughU < v.minDistance) {
                        vertexQueue.remove(v);

                        v.minDistance = distanceThroughU;
                        v.previous = u;
                        vertexQueue.add(v);

                    }

                }
            }
            return null;
        }
    }
}

