package Qualif17;

import java.io.*;
import java.lang.reflect.Method;
import java.util.Locale;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;

public class B {
	
	//private String theFile="-small.in";
	private String theFile="-small-attempt0.in";
	//private  String theFile="-large.in";


	//everything happens here in constructor and solve()
	static class TestCase implements Callable<String> {
		//declare vars
		String nb;

		
		//parse input
		TestCase(Scanner in) throws IOException {
			nb = in.next();
		}
		String solve() {
			int[] digit=new int[nb.length()];
			for(int i=0;i<nb.length();++i) digit[i]=nb.charAt(i)-'0';
			int cd;
			do {
				cd = check(digit);
				if (cd == -1) {
					String res="";
					int idx=0;
					while(digit[idx]==0) idx++;
					for(;idx<digit.length;idx++) res=res+digit[idx];
					return res;
				}
				for (int i = cd; i < digit.length; ++i) digit[i] = 9;
				digit[cd - 1]--;
			}
			while(true );
		}
		int check(int[] digit) {
			int cur=0;
			for(int i=0;i<digit.length;++i) {
				if(digit[i]<cur) return i;
				cur=digit[i];
			}
			return -1;
		}
		ByteArrayOutputStream errBuffer = new ByteArrayOutputStream();
		PrintStream err= new PrintStream(errBuffer);

        @Override
        public String call() throws Exception {
            return solve();
        }
	}
	
	public void run() {
		try {
			Scanner sc = new Scanner( new BufferedReader(new FileReader(Folder+"/"+pbLetter+theFile)));
			PrintStream out = new TeePrintStream(System.out,Folder+"/"+pbLetter + "-output.txt");
			
			ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(7);
			
			int tests = sc.nextInt();
			@SuppressWarnings("unchecked")
			Future<String>[] ts = new Future[tests];
			TestCase[] allTests= new TestCase[tests];
			for (int test = 0; test < tests; ++test) {
			    allTests[test] = new TestCase(sc);
				ts[test] = service.submit(allTests[test]);
			}
			for (int test = 0; test < tests; ++test) {
				out.print("Case #" + (test + 1) + ": ");
				String res;
				try {
					res = ts[test].get();
				} catch(ExecutionException ee) {
					out.println();
					System.out.println("======== "+(test+1)+" errors ========>" );
					System.out.println(allTests[test].errBuffer.toString());
					ee.getCause().printStackTrace(System.out);
					continue;
				}
				if(res != null) out.println(res);
				String errStr = allTests[test].errBuffer.toString();
				if(errStr != null && errStr.length() >0) {
					System.out.println("======== "+(test+1)+" errors ========>" );
					System.out.println(errStr);
				}
				out.flush();
			}
			service.shutdown();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		Method m;
		try {
			m = currentClass.getMethod("run");
			m.invoke(currentClass.newInstance(),(Object[])null);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	static private String pbLetter;

	static private String Folder;
	
	static private Class<?> currentClass;
	static {
		currentClass = new Object() { }.getClass().getEnclosingClass();
		pbLetter=currentClass.getName();
		Folder = "src/"+currentClass.getPackage().getName();
		int idx = pbLetter.lastIndexOf('.');
		if(idx != -1) pbLetter = pbLetter.substring(idx+1);
		pbLetter = pbLetter.toUpperCase();
	}
	static class TeePrintStream extends PrintStream {
		protected PrintStream parent;

		TeePrintStream(PrintStream orig, OutputStream os, boolean flush)
				throws IOException {
			super(os, flush);
			parent = orig;
		}
		TeePrintStream(PrintStream orig, String fn)
				throws IOException {
			this(orig, new FileOutputStream(fn), true);
		}

		public boolean checkError() {
			return parent.checkError() || super.checkError();
		}
		public void write(int x) {
			parent.write(x);
			super.write(x); 
		}

		/** override write(). This is the actual "tee" operation. */
		public void write(byte[] x, int o, int l) {
			parent.write(x, o, l); 
			super.write(x, o, l);
		}

		/** Close both streams. */
		public void close() {
			parent.close();
			super.close();
		}
		/** Flush both streams. */
		public void flush() {
			parent.flush();
			super.flush();
		}
	}
}

