package Qualif13;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Scanner;
import java.util.Vector;


public class D {
	// get Pb Letter for input/output file names.
	public static String pbLetter;
	static {
		pbLetter=new Object() { }.getClass().getEnclosingClass().getName();
		int idx = pbLetter.lastIndexOf('.');
		if(idx != -1) pbLetter = pbLetter.substring(idx+1);
		pbLetter = pbLetter.toUpperCase();
	}
	
	public static void main(String[] args) throws Throwable {
		//Scanner sc = new Scanner(new File("./"+pbLetter+"-small.in"));
		Scanner sc = new Scanner(new File("./"+pbLetter+"-small-attempt1.in"));
		//Scanner sc = new Scanner(new File("./"+pbLetter+"-large.in"));
		
		TeePrintStream out= new TeePrintStream(System.out, "./output-"+pbLetter+".txt");
		
		int testCount = sc.nextInt();
		sc.nextLine();
		for (int i = 1; i <= testCount; i++) {
			out.format("Case #%d: ",i );
			solve(sc, out);
		}
		out.close();
	}

	static void solve(Scanner sc, PrintStream out) {
			state init = new state();
			int k = sc.nextInt();
			int n = sc.nextInt();
			int[] needed = new int[201];
			
			sc.nextLine();
			for(int i=0; i<k;++i) init.addKey(sc.nextInt());
			for (int i = 0; i < init.keys.size(); i++) { needed[init.keys.get(i)]--;}
			sc.nextLine();
			chest c;
			for(int i=0; i<n; ++i) {
				c = new chest();
				c.openedBy = sc.nextInt();
				needed[c.openedBy]++;
				c.keys = new int[sc.nextInt()];
				c.idx = i+1;
				for (int j = 0; j < c.keys.length; j++) {
					c.keys[j] = sc.nextInt();
					needed[c.keys[j]]--;
				}
				Arrays.sort(c.keys);
				init.chests.add(c);
				sc.nextLine();
			}
			for (int i = 0; i < needed.length; i++) {
				if(needed[i] > 0) {
					out.println("IMPOSSIBLE");
					return;
				}
				
			}
			//out.println(k+" "+n);
			
			Vector<Integer> res = new Vector<Integer>();
			if(init.next(res) ) {
				for (Iterator iterator = res.iterator(); iterator.hasNext();) {
					Integer i = (Integer) iterator.next();
					out.print(i);
					out.print(" ");
				}
				out.println("");
			} else {
				out.println("IMPOSSIBLE");
			}
	}

static class chest {
	int openedBy;
	int[] keys;
	int idx;
}

static class state {
	
	Vector<Integer> keys = new Vector<Integer>();
	Vector<chest> chests= new Vector<chest>();
	int curChest = 0;
	void addReachable(int[] keys,boolean[] reachable) {
		int i=0;
		for(chest c:chests) {
			if(!reachable[i] && Arrays.binarySearch(keys,c.openedBy) >=0) {
				reachable[i] = true;
				addReachable(c.keys,reachable);
			}
			i++;
		}
	}
	boolean isFeasible() {
		boolean[] reachable = new boolean[chests.size()];
		Arrays.fill(reachable, false);
		int[] k = new int[keys.size()];
		for (int i = 0; i < k.length; i++) {
			k[i] = keys.get(i);
		}
		addReachable(k,reachable);
		for(boolean b:reachable) if(b==false) return false;
		return true;
	}
	
	void addKey(Integer i) {
		int idx = Collections.binarySearch(keys, i);
		if(idx >=0)
			keys.insertElementAt(i, idx);
		else 
			keys.insertElementAt(i, -idx-1);
	}
	
	@SuppressWarnings("unchecked")
	boolean next(Vector<Integer> res) {
		//System.out.println("====>"+chests.size()+","+curChest);
		while(curChest < chests.size()) {
			//System.out.println(curChest+";"+chests.size());
			int idx = Collections.binarySearch(keys,chests.get(curChest).openedBy);
			if( idx >=0 ) {
				if(chests.size() == 1) {
					res.add(chests.get(curChest).idx);
					return true;
				}
				state next = new state();
				next.keys = (Vector<Integer>) keys.clone();
				next.chests = (Vector<chest>) chests.clone();
				next.chests.removeElementAt(curChest);
				next.keys.removeElementAt(idx);
				for(Integer i: chests.get(curChest).keys) {
					next.addKey(i);
				}
				if(!next.isFeasible()) {
					//System.out.println("Not feasible");
					return false;
				}
				if(next.next(res)) {
					res.insertElementAt(chests.get(curChest).idx, 0);
					return true;
				}
			}
			curChest++;
		}
		return false;
	}
}

static class TeePrintStream extends PrintStream {
	  protected PrintStream parent;
	  
	  public TeePrintStream(PrintStream orig, OutputStream os, boolean flush)
	      throws IOException {
	    super(os, flush);
	    parent = orig;
	  }
	  public TeePrintStream(PrintStream orig, String fn)
	      throws IOException {
	    this(orig, new FileOutputStream(fn), true);
	  }

	  public boolean checkError() {
	    return parent.checkError() || super.checkError();
	  }
	  public void write(int x) {
	    parent.write(x);
	    super.write(x); 
	  }

	  /** override write(). This is the actual "tee" operation. */
	  public void write(byte[] x, int o, int l) {
	    parent.write(x, o, l); 
	    super.write(x, o, l);
	  }

	  /** Close both streams. */
	  public void close() {
	    parent.close();
	    super.close();
	  }
	  /** Flush both streams. */
	  public void flush() {
	    parent.flush();
	    super.flush();
	  }
	}
}