package round1B_16;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;
import java.util.NoSuchElementException;
import java.util.Scanner;


public class A {
	static String s[]={"ZERO","ONE","TWO","THREE","FOUR","FIVE","SIX","SEVEN","EIGHT","NINE"};
	static void solve(Scanner sc,PrintStream out) {
		String str=sc.next();
		int c[]=new int[26];
		for(char ch:str.toCharArray()) c[ch-'A']++;
		ArrayList<Integer> possible=new ArrayList<Integer>();
		int nb=0;
		for(int i=0;i<10;++i) {
			int min=10000000;
			for(char ch:s[i].toCharArray()) min=Math.min(min, c[ch-'A']);
			if(min>0) {nb+=min; for(int j=0;j<min;++j) possible.add(i);}
		}
		int sub=0;
		do {
			CombinationIterator<Integer> ci = new CombinationIterator<Integer>(possible, nb-sub);
			while(ci.hasNext()) {
				if(test(ci.next(),str,out)) {
					return;
				}
			}
			sub++;
		} while(true);
	}
	static boolean test(List<Integer> li,String str,PrintStream out) {
		int c=0;
		for(int i:li) {
			c+= s[i].length();
		}
		if(c==str.length()) {
			int chr[]=new int[26];
			for(char ch:str.toCharArray()) chr[ch-'A']++;
			for(int i:li) {
				for(char ch:s[i].toCharArray()) {
					if(--chr[ch-'A']<0) return false;
				}
			}
			for(int i:li) out.print(i);
			out.println();
			return true;
		}
		return false;
	}

	
	// find input/output file names automatically.
	public static String outputFile;
	public static File inputFile;
	static {
		Class<?> me = new Object() { }.getClass().getEnclosingClass();
		String pbLetter=me.getName();;
		String myPackage=me.getCanonicalName().substring(0, me.getCanonicalName().lastIndexOf('.'));
		int idx = pbLetter.lastIndexOf('.');
		if(idx != -1) pbLetter = pbLetter.substring(idx+1).toUpperCase();
		File[] files = new File("./"+myPackage+"/").listFiles();
		for(File f:files) {
			if(f.getName().equals(pbLetter+"-large.in")) {
				inputFile=f;
				break;
			}
			if(f.getName().matches(pbLetter+"-small.*\\.in") && 
			   (inputFile==null|| f.getName().replace(".in", "").compareTo(inputFile.getName().replace(".in", ""))>0)) {
				inputFile=f;
			}
		}
		outputFile="./"+myPackage+"/output-"+inputFile.getName().replace(".in", ".txt");
	}

	public static void main(String[] args) throws Throwable {
		Scanner sc = new Scanner(inputFile);		
		TeePrintStream out= new TeePrintStream(System.out, outputFile);

		int testCount = sc.nextInt();
		sc.nextLine();
		for (int i = 1; i <= testCount; i++) {
			out.format("Case #%d: ",i );
			solve(sc, out);
		}
		out.close();
	}
	
	static class TeePrintStream extends PrintStream {
		protected PrintStream parent;

		public TeePrintStream(PrintStream orig, OutputStream os, boolean flush)
				throws IOException {
			super(os, flush);
			parent = orig;
		}
		public TeePrintStream(PrintStream orig, String fn)
				throws IOException {
			this(orig, new FileOutputStream(fn), true);
		}

		public boolean checkError() {
			return parent.checkError() || super.checkError();
		}
		public void write(int x) {
			parent.write(x);
			super.write(x); 
		}

		/** override write(). This is the actual "tee" operation. */
		public void write(byte[] x, int o, int l) {
			parent.write(x, o, l); 
			super.write(x, o, l);
		}

		/** Close both streams. */
		public void close() {
			parent.close();
			super.close();
		}
		/** Flush both streams. */
		public void flush() {
			parent.flush();
			super.flush();
		}
	}
	public static class CombinationIterator<T>
	implements Iterable<List<T>>,
	Iterator<List<T>> {
		private List<T> items;
		private int choose;
		private boolean started;
		private boolean finished;
		private int[] current;

		public CombinationIterator(List<T> items, int choose) {
			if (items == null || items.size() == 0) {
				throw new IllegalArgumentException("items");
			}
			if (choose <= 0 || choose > items.size()) {
				throw new IllegalArgumentException("choose");
			}
			this.items = items;
			this.choose = choose;
			this.finished = false;
		}

		public  Iterator<List<T>> iterator() {
			return this;
		}

		public boolean hasNext() {
			return !finished;
		}

		public List<T> next() {
			if (!hasNext()) {
				throw new NoSuchElementException();
			}

			if (current == null) {
				current = new int[choose];
				for (int i = 0; i < choose; i++) {
					current[i] = i;
				}
			}

			List<T> result = new ArrayList<T>(choose);
			for (int i = 0; i < choose; i++) {
				result.add(items.get(current[i]));
			}

			int n = items.size();
			finished = true;
			for (int i = choose - 1; i >= 0; i--) {
				if (current[i] < n - choose + i) {
					current[i]++;
					for (int j = i + 1; j < choose; j++) {
						current[j] = current[i] - i + j;
					}
					finished = false;
					break;
				}
			}

			return result;
		}

		public void remove() {
			throw new UnsupportedOperationException();
		}
	}
}
