package round1B_17;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.lang.reflect.Constructor;
import java.lang.reflect.Field;
import java.util.*;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;

@SuppressWarnings("WeakerAccess")
public class A implements Callable<String> {
    static class Horse {
        int start,speed;
        Horse(Scanner in) { start=in.nextInt(); speed=in.nextInt();}
        static int byDist(Horse h1,Horse h2) { return h2.start - h1.start;}
        public String toString() { return start+" "+speed;}
    }
    //declare vars
    int D,N;
    Horse[] h;

    //parse input in constructor
    public A(Scanner in) throws IOException {
        D=in.nextInt();
        N=in.nextInt();
        h=new Horse[N];
        for(int i=0;i<N;++i) h[i]=new Horse(in);
    }
    //solve the test case in this method
    @Override
    public String call() throws Exception {
        Arrays.sort(h,Horse::byDist);
        System.err.println (Arrays.toString(h));
        double time =-1.0;
        for(int i=0;i<h.length;++i) {
            double newT = 1.0*(D-h[i].start)/h[i].speed;
            if(newT > time) time = newT;
        }
        return ""+(D/time);
    }

    private ByteArrayOutputStream outBuffer = new ByteArrayOutputStream();
    private PrintStream out= new PrintStream(outBuffer);
    private ByteArrayOutputStream errBuffer = new ByteArrayOutputStream();
    private PrintStream err= new PrintStream(errBuffer);

    @SuppressWarnings("unchecked")
    public static void main(String[] args) {
        Class currentClass=new Object() { }.getClass().getEnclosingClass();
        Locale.setDefault(Locale.US);
        try {
            Constructor<?> cons = currentClass.getConstructor(Scanner.class);
            Field errBuf = currentClass.getDeclaredField("errBuffer");
            Scanner sc = new Scanner(System.in);
            ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(7);

            int tests = sc.nextInt();
            @SuppressWarnings("unchecked")
            Future<String>[] ts = new Future[tests];
            Callable<String>[] allTests= new Callable[tests];
            for (int test = 0; test < tests; ++test) {
                allTests[test] = (Callable<String>)cons.newInstance(sc);
                ts[test] = service.submit(allTests[test]);
            }
            for (int test = 0; test < tests; ++test) {
                ByteArrayOutputStream errBuffer = (ByteArrayOutputStream)errBuf.get(allTests[test]);
                System.out.print("Case #" + (test + 1) + ": ");
                String res;
                try {
                    res = ts[test].get();
                } catch(ExecutionException ee) {
                    System.out.println();
                    System.err.println("======== "+(test+1)+" errors ========>" );
                    System.err.println(errBuffer.toString());
                    ee.getCause().printStackTrace();
                    continue;
                }
                if(res != null) System.out.println(res);
                String errStr = errBuffer.toString();
                if(errStr != null && errStr.length() >0) {
                    System.err.println("======== "+(test+1)+" errors ========>" );
                    System.err.println(errStr);
                }
                System.out.flush();
            }
            service.shutdown();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}

