import java.io.BufferedWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.function.Function;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class GCJ {

	public static void main(String[] args) throws IOException {
		// q2015b("B-small-attempt0");
		q2015c("C-small-attempt0");
	}

	public static void q2015c(String path) throws IOException {
		List<String[]> list = getInput("D:\\Userfiles\\ymalins\\Dropbox\\GCJ_JAVA\\Q_2015\\" + path + ".in");
		List<String> output = new ArrayList<String>();

		final int lines = Integer.parseInt(list.get(0)[0]);
		for (int line = 1; line <= lines; line++) {
			int l = Integer.parseInt(list.get(line * 2 - 1)[0]);
			int x = Integer.parseInt(list.get(line * 2 - 1)[1]);
			String text = list.get(line * 2)[0];
			System.out.println(l + " " + x + " " + text);
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < x; i++) {
				sb.append(text);
			}
			String finaltext = sb.toString();
			boolean ok = find(finaltext, 0, 0, 2);

			output.add("Case #" + line + ": " + (ok ? "YES" : "NO"));
		}
		saveOutputSingle("D:\\Userfiles\\ymalins\\Dropbox\\GCJ_JAVA\\Q_2015\\" + path + ".out", output);

	}

	public static boolean find(String path, int index, int current, int looking) {
		if (looking > 4)
			return true;

		for (int i = index; i < path.length(); i++) {
			int next = tonum(path.charAt(i));
			if (current == 5 || next == 5) {
				System.out.println("ouch");
			}
			int now = multiply(current, next);
			current = now;
			if (now == looking) {
				System.out.println(path + " " + index + " " + looking);
				return find(path, i + 1, 0, looking + 1);
			}
		}
		return false;
	}

	public static int[][] table = { { -1000 }, { -1000, 1, 2, 3, 4 }, { -1000, 2, -1, -4, 3 }, { -1000, 3, 4, -1, -2 }, { -1000, 4, -3, 2, -1 } };

	public static int tonum(char c) {
		if (c == 0)
			return 0;
		if (c == '1')
			return 1;
		if (c == 'i')
			return 2;
		if (c == 'j')
			return 3;
		if (c == 'k')
			return 4;
		else
			return -1000;
	}

	public static int multiply(int a, int b) {
		if (a == 0)
			return b;
		if (a < 0 && b < 0)
			return table[-a][-b];
		else if (a < 0)
			return -table[-a][b];
		else if (b < 0)
			return -table[a][-b];
		else
			return table[a][b];
	}

	public static void q2015b(String path) throws IOException {
		List<String[]> list = getInput("D:\\Userfiles\\ymalins\\Dropbox\\GCJ_JAVA\\Q_2015\\" + path + ".in");
		List<String> output = new ArrayList<String>();

		final int lines = Integer.parseInt(list.get(0)[0]);
		for (int line = 1; line <= lines; line++) {
			int result;
			int diners = Integer.parseInt(list.get(line * 2 - 1)[0]);
			List<Integer> plates = Stream.of(list.get(line * 2)).map(s -> Integer.parseInt(s)).collect(Collectors.toList());
			Collections.sort(plates);
			int max = plates.get(plates.size() - 1);
			result = max;
			if (max > 3) {
				int max_special = max - 2;
				int specials = 0;
				for (int i = 1; i <= max_special; i++) {
					max = plates.get(plates.size() - 1);
					int split = max / 2;
					plates.set(plates.size() - 1, split);
					plates.add(max - split);
					Collections.sort(plates);
					specials++;
					if (specials + plates.get(plates.size() - 1) < result) {
						result = specials + plates.get(plates.size() - 1);
					}
				}
			}
			output.add("Case #" + line + ": " + result);
		}

		saveOutputSingle("D:\\Userfiles\\ymalins\\Dropbox\\GCJ_JAVA\\Q_2015\\" + path + ".out", output);
	}

	public static void q2015a() throws IOException {
		List<String[]> list = getInput("D:\\Userfiles\\ymalins\\Dropbox\\GCJ_JAVA\\Q_2015\\" + "A-large" + ".in");
		List<String> output = new ArrayList<String>();
		final int lines = Integer.parseInt(list.get(0)[0]);
		for (int line = 1; line <= lines; line++) {
			int max = Integer.parseInt(list.get(line)[0]);
			String array = list.get(line)[1];
			int sum = Character.getNumericValue(array.charAt(0));
			int cheat = 0;
			if (max > 0) {
				for (int i = 1; i <= max; i++) {
					int people = Character.getNumericValue(array.charAt(i));
					if (people != 0) {
						if (sum >= i) {
							sum += people;
						} else {
							cheat += (i - sum);
							sum += (i - sum) + people;
						}
					}
				}
			}
			output.add("Case #" + line + ": " + cheat);
		}
		saveOutputSingle("D:\\Userfiles\\ymalins\\Dropbox\\GCJ_JAVA\\Q_2015\\" + "A-large" + ".out", output);
	}

	public static ArrayList<String> getInputSingle(String filename) throws IOException {
		ArrayList<String> output = new ArrayList<String>();
		try (Stream<String> lineStream = Files.lines(Paths.get(filename))) {
			lineStream.forEach(s -> output.add(s));
		}
		return output;
	}

	public static ArrayList<String[]> getInput(String filename) throws IOException {
		ArrayList<String[]> output = new ArrayList<String[]>();
		try (Stream<String> lineStream = Files.lines(Paths.get(filename))) {
			lineStream.map(s -> s.split(" ")).forEach(sA -> output.add(sA));
		}
		return output;
	}

	public static void saveOutputSingle(String filename, List<String> output) throws IOException {
		try (PrintWriter pW = new PrintWriter(filename)) {
			output.stream().forEach(s -> pW.println(s));
		}
	}

	public static void saveOutput(String filename, List<String[]> output) throws IOException {
		try (PrintWriter pW = new PrintWriter(filename)) {
			output.stream().map(sA -> String.join(" ", sA)).forEach(s -> pW.println(s));
		}
	}

}
