package fr.ivu.ttt;

import java.util.ArrayList;
import java.util.List;

public class Matrix {

	private static final int																											LINE_COUNT		= 4;
	private static final int																											COLUMN_COUNT	= 4;
	public static final String																										UNCOMPLETE		= "UNCOMPLETE";
	public static final String																										DRAW					= "DRAW";
	MatrixAxis<List<MatrixItem<String>>, MatrixAxis<String, MatrixItem<String>>>	matrix				= new MatrixAxis<List<MatrixItem<String>>, MatrixAxis<String, MatrixItem<String>>>(LINE_COUNT);

	public Matrix() {
		for (int x = 0; x < LINE_COUNT; x++) {
			MatrixAxis<String, MatrixItem<String>> matrixColumnX = new MatrixAxis<String, MatrixItem<String>>(COLUMN_COUNT);
			matrix.set(x, matrixColumnX);

			for (int y = 0; y < COLUMN_COUNT; y++) {
				MatrixItem<String> matrixItem = new MatrixItem<String>();
				matrixColumnX.set(y, matrixItem);
			}
		}
	}

	public void set(int x, int y, String value) {
		MatrixAxis<String, MatrixItem<String>> matrixColumnX = matrix.get(x);
		//		if (matrixColumnX == null) {
		//			matrixColumnX = new MatrixAxis<String, MatrixItem<String>>(COLUMN_COUNT);
		//			matrix.set(x, matrixColumnX);
		//		}

		MatrixItem<String> matrixItem = matrixColumnX.get(y);
		//		if (matrixItem == null) {
		//			matrixItem = new MatrixItem<String>();
		//			matrixColumnX.set(y, matrixItem);
		//		}

		matrixItem.value = value;
	}

	public MatrixItem<String> get(int x, int y) {
		MatrixAxis<String, MatrixItem<String>> matrixLineX = matrix.get(x);
		MatrixItem<String> matrixItem = matrixLineX.get(y);
		return matrixItem;
	}

	public String testLines(int variable, boolean vertical) {
		String current = null;
		boolean uncomplete = false;
		boolean none = false;
		for (int i = 0; i < (vertical ? LINE_COUNT : COLUMN_COUNT); i++) {
			MatrixItem<String> matrixItem = vertical ? get(variable, i) : get(i, variable);
			String value = matrixItem.value;
			if (value.equals(".")) {
				uncomplete = true;
			}

			if (!none) {
				if (current == null)
					current = value;
				else if (current.equals(value) || value.equals("T"))
					continue;
				else
					none = true;
			}
		}

		if (uncomplete)
			return UNCOMPLETE;
		if (none)
			return null;
		return current;
	}

	public String testDiagonals(boolean increasing) {
		String current = null;
		boolean uncomplete = false;
		boolean none = false;
		for (int i = 0; i < LINE_COUNT; i++) {
			MatrixItem<String> matrixItem = increasing ? get(i, i) : get(COLUMN_COUNT - (i + 1), i);
			String value = matrixItem.value;
			if (value.equals(".")) {
				uncomplete = true;
			}

			if (!none) {
				boolean joker = value.equals("T");
				if (current == null && !joker)
					current = value;
				else if ((current != null && current.equals(value)) || joker)
					continue;
				else
					none = true;
			}
		}

		if (uncomplete)
			return UNCOMPLETE;
		if (none)
			return null;
		return current;
	}

	public String testMatrix() {
		String result;
		for (int x = 0; x < LINE_COUNT; x++) {
			result = testLines(x, false);
			analyseResult(result);
		}
		for (int y = 0; y < COLUMN_COUNT; y++) {
			result = testLines(y, true);
			analyseResult(result);
		}
		result = testDiagonals(false);
		analyseResult(result);

		result = testDiagonals(true);
		analyseResult(result);

		int resultsCount = countResults();
		if (resultsCount == 0)
			return uncomplete ? "Game has not completed" : "Draw";
		else if (resultsCount > 0)
			return "X won";
		else if (resultsCount < 0)
			return "O won";

		throw new IllegalStateException("Unexpected state");
	}

	private int countResults() {
		int xCount = 0, oCount = 0;
		for (String winner : winners) {
			if (winner.equals("X"))
				xCount++;
			else if (winner.equals("O"))
				oCount++;
		}
		return xCount - oCount;
	}

	List<String>	winners	= new ArrayList<String>();
	boolean				uncomplete;

	private void analyseResult(String result) {
		if (UNCOMPLETE.equals(result))
			uncomplete = true;
		if (result != null)
			winners.add(result);
	}

}
