package fr.ivu.ttt;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 * 
 * @author Zied Hamdi - http://1vu.fr
 * 
 */
public class TestReader {

	public static void main(String[] args) throws IOException {
		File file = new File(args[0]);
		FileReader reader = new FileReader(file);
		BufferedReader bufferedReader = new BufferedReader(reader);

		String line = bufferedReader.readLine();
		System.out.println("line: " + line);
		int testCount = Integer.parseInt(line);

		StringBuilder builder = new StringBuilder();
		for (int i = 0; i < testCount; i++) {
			String testMatrixResult = testMatrix(bufferedReader);
			String resultLine = "Case #" + (i + 1) + ": " + testMatrixResult + "\n";
			builder.append(resultLine);
			System.out.println(resultLine);

			line = bufferedReader.readLine();
			if (line != null && line.length() > 0)
				throw new IllegalStateException("Line should be empty, found : '" + line + "'");
		}

		writeFile(builder);
		System.out.println(builder);
	}

	private static void writeFile(StringBuilder builder) throws IOException {
		FileWriter fileWriter = new FileWriter(new File("c:/temp/out.txt"));
		fileWriter.write(builder.toString());
		fileWriter.flush();
		fileWriter.close();
	}

	private static String testMatrix(BufferedReader bufferedReader) throws IOException {
		Matrix matrix = new Matrix();
		for (int y = 0; y < 4; y++) {
			String line = bufferedReader.readLine();
			System.out.println("testing line: " + line);
			if (line.length() != 4)
				throw new IllegalArgumentException("line invalid " + line);

			for (int x = 0; x < 4; x++) {
				matrix.set(x, y, line.substring(x, x + 1));
			}
		}

		return matrix.testMatrix();
	}
}
