package qualification;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import loader.InputReader;
import loader.OutPutWriter;

public class LanguageMapping {

	
	static String input1 = "ejp mysljylc kd kxveddknmc re jsicpdrysi";
	static String input2 = "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd";
	static String input3 = "de kr kd eoya kw aej tysr re ujdr lkgc jv";
	
	static String output1 = "our language is impossible to understand";
	static String output2 = "there are twenty six factorial possibilities";
	static String output3 = "so it is okay if you want to just give up";
	
	static Map<String, String> googleToEnglish = new TreeMap<String, String>();
	static Map<String, String> englishToGoogle = new TreeMap<String, String>();
	
	public static void buildMapping (String input, String output){
		if(input.length() != output.length())
		{
			System.err.print("Wrong length!");
			return;
		}
		
		char[] inArray = input.toCharArray();
		char[] outArray = output.toCharArray();
		for(int i=0; i<input.length(); i++){
			char[] inA = {inArray[i]};
			String in = new String(inA);
			
			char[] outA = {outArray[i]};
			String out = new String(outA);
			
			if(in.equals(" "))
				continue;
			googleToEnglish.put(in, out);
//			englishToGoogle.put(key, value);
		}
		
	}
	
	public static String translate(String input){
		String out = "";
		
		char[] inArray = input.toCharArray();
		for(int i=0; i<input.length(); i++){
			char[] inA = {inArray[i]};
			String in = new String(inA);
			
			out += googleToEnglish.get(in);
		}
		
		return out;
	}
	
	public static void start(){
		googleToEnglish.clear();
		googleToEnglish.put(" ", " ");
		googleToEnglish.put("q", "z");
		googleToEnglish.put("z", "q");
		
		buildMapping(input1, output1);
		buildMapping(input2, output2);
		buildMapping(input3, output3);

	}
	
	public static void main(String[] args){
		start();
//		System.out.println(googleToEnglish);
//		System.out.println(googleToEnglish.size());
//		List l = new ArrayList(googleToEnglish.values());
//		Collections.sort(l);
//		System.out.println("Enighsh" + l);
		
		InputReader reader = new InputReader();
		reader.read("A-small-attempt1.in");
		List<String> inputs = reader.getInputs();
		List<String> outputs = new ArrayList<String>();
		for(String input: inputs){
			outputs.add(translate(input));
		}
		
		OutPutWriter writer = new OutPutWriter();
		writer.write("question1.out", outputs);
	}
}
