package gcj;

import java.io.BufferedReader;
import java.io.IOException;
import java.net.URL;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public class Test {

    private static String inputFileName = "input.in";
    private static String outputFileName = "F:\\SpringWorkspace\\gcj\\src\\gcj\\output.out";
    private static ClassLoader classLoader;

    static {
        classLoader = Test.class.getClassLoader();
    }

    private static void writeOutputToFile(String str) {
        Path file = Paths.get(outputFileName);
        try {
            Files.write(file, str.getBytes());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {

        try {
            StringBuilder output = new StringBuilder();

            String filePath = "F:\\SpringWorkspace\\gcj\\src\\gcj\\input.in";
            BufferedReader reader = Files.newBufferedReader(Paths.get(filePath), StandardCharsets.UTF_8);
            String strLine;

            int lineNumber = 0;
            int noOfTestCases = -1;
            int activeTestCaseNumber = 0;
            while ((strLine = reader.readLine()) != null) {

                if (lineNumber == 0) {
                    noOfTestCases = Integer.parseInt(strLine);
                } else {
                    noOfTestCases ++;
                    activeTestCaseNumber ++;
                    char c[]=strLine.toCharArray();
                    String sb=new String();
                    sb=String.valueOf(c[0]);
                    
                    for(int i=1;i<c.length;i++){
                    	if(c[i]>=sb.charAt(0)){
                    		sb=String.valueOf(c[i])+sb;
                    	}else{
                    		sb=sb+String.valueOf(c[i]);
                    	}
                    }
                    
                    output.append("Case #").append(activeTestCaseNumber).append(": ").append(sb.toString());
                    output.append("\n");
                }
                lineNumber++;
            }

            writeOutputToFile(output.toString());

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    public static List printSeq(char set[], StringBuilder prefix, int k, List list) {
//        if (k == 0) {
//        	list.add(prefix.toString());
//            return list;
//        }
//        for (int i = 0; i < 2; ++i) {
//             
//            StringBuilder newPrefix = new StringBuilder();
//            newPrefix.append(prefix.toString()).append( set[i]); 
//            printSeq(set, newPrefix, k - 1,list); 
//        }
    	System.out.println((Math.pow(2,k)));
    	for(int i=0;i<Math.pow(2,k);i++){
    		list.add(Integer.toBinaryString(i));
    	}
        return list;
    }
    private static String convertStringArrayToString(String[] strArr) {
        StringBuilder sb = new StringBuilder();
        for(String str : strArr) sb.append(str);
        return sb.toString();
    }
    public static String increaseComplex(String seq, String originalSeq) {
       	String arr[]=seq.split("(?!^)");
        	for(int j=0;j<arr.length;j++){
        		if(arr[j].equals("0")){
        			StringBuilder sb=new StringBuilder();
        			for(int n=0;n<originalSeq.length();n++){
        				sb.append("0");
        			}
        			arr[j]=sb.toString();
        		}else if(arr[j].equals("1")){
        			arr[j]=originalSeq;
        		}
        	}
        return convertStringArrayToString(arr);
    }
    
    public static String getComplexList(String seq, String originalSeq,int complex) {

        if(complex==1){
        	return seq;
        }else if(complex==2){
        	return increaseComplex(seq,originalSeq);
        }
        else{
        	return getComplexList(increaseComplex(seq,originalSeq), originalSeq,(complex-2));
        }
    }
}
