import java.io.*;
import java.math.BigInteger;
import java.util.InputMismatchException;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Arthur Gazizov  [2oo7] - Kazan FU
 */
public class Main {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("input.txt");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("output.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        FastScanner in = new FastScanner(inputStream);
        FastPrinter out = new FastPrinter(outputStream);
        TaskV solver = new TaskV();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskV {
        private static final char Q = '?';
        private BigInteger MAX;
        StringBuffer s;
        StringBuffer t;

        private void solve(int index, StringBuffer first, StringBuffer second) {
            //index++;
            int length = first.length();
            StringBuffer min = null;
            StringBuffer max = null;
            for (; index < length; index++) {
                if (Character.isDigit(first.charAt(index)) && Character.isDigit(second.charAt(index))) {
                    if (first.charAt(index) == second.charAt(index)) {
                        continue;
                    } else {
                        if (first.charAt(index) < second.charAt(index)) {
                            min = first;
                            max = second;
                        } else {
                            min = second;
                            max = first;
                        }
                        break;
                    }
                } else {
                    if (Character.isDigit(first.charAt(index))) {
                        second.setCharAt(index, first.charAt(index));
                    } else if (Character.isDigit(second.charAt(index))) {
                        first.setCharAt(index, second.charAt(index));
                    } else {
                        first.setCharAt(index, '0');
                        second.setCharAt(index, '0');
                    }
                }
            }
            if (max != null && second != null) {
                for (; index < length; index++) {
                    if (max.charAt(index) == Q) {
                        max.setCharAt(index, '0');
                    }
                    if (min.charAt(index) == Q) {
                        min.setCharAt(index, '9');
                    }
                }
            }
            BigInteger a = new BigInteger(first.toString());
            BigInteger b = new BigInteger(second.toString());
            BigInteger res = (a.subtract(b)).abs();
            if (res.compareTo(MAX) < 0) {
                MAX = res;
                s = first;
                t = second;
            }
        }

        public void solve(int testNumber, FastScanner in, FastPrinter out) {
            MAX = new BigInteger("11111111111111111111111111111111111111111111111111111111111111");
            StringBuffer first = new StringBuffer(in.next());
            StringBuffer second = new StringBuffer(in.next());
            s = first;
            t = second;
            int length = first.length();
            int index = 0;
            for (int i = 0; i < length - 1; i++) {
                if (first.charAt(i) == Q && second.charAt(i) == Q &&
                        first.charAt(i + 1) == Q && second.charAt(i + 1) == Q) {
                    index = i;
                    first.setCharAt(i, '0');
                    second.setCharAt(i, '0');
                } else {
                    break;
                }
            }
            StringBuffer firstClone = new StringBuffer(first.toString());
            StringBuffer secondClone = new StringBuffer(second.toString());
            if (first.charAt(index) == Q && second.charAt(index) == Q) {
                first.setCharAt(index, '0');
                second.setCharAt(index, '0');
                solve(index, first, second);
                first = new StringBuffer(firstClone.toString());
                second = new StringBuffer(secondClone.toString());
                first.setCharAt(index, '1');
                second.setCharAt(index, '0');
                solve(index, first, second);
                first = new StringBuffer(firstClone.toString());
                second = new StringBuffer(secondClone.toString());
                first.setCharAt(index, '0');
                second.setCharAt(index, '1');
                solve(index, first, second);
            } else {
                if (first.charAt(index) == Q) {
                    first.setCharAt(index, second.charAt(index));
                } else if (second.charAt(index) == Q) {
                    second.setCharAt(index, first.charAt(index));
                }
                solve(index, first, second);
            }
            out.print("Case #");
            out.print(testNumber);
            out.print(": ");
            out.print(s.toString());
            out.print(' ');
            out.println(t.toString());
        }

    }

    static class FastPrinter extends PrintWriter {
        public FastPrinter(Writer writer) {
            super(writer);
        }

        public FastPrinter(OutputStream out) {
            super(out);
        }

        public void close() {
            super.close();
        }

    }

    static class FastScanner extends BufferedReader {
        boolean isEOF;

        public FastScanner(InputStream is) {
            super(new InputStreamReader(is));
        }

        public FastScanner(InputStreamReader inputStreamReader) {
            super(inputStreamReader);
        }

        public int read() {
            try {
                int ret = super.read();
                if (isEOF && ret < 0) {
                    throw new InputMismatchException();
                }
                isEOF = ret == -1;
                return ret;
            } catch (IOException e) {
                throw new InputMismatchException();
            }
        }

        public String next() {
            StringBuilder sb = new StringBuilder();
            int c = read();
            while (isWhiteSpace(c)) {
                c = read();
            }
            while (!isWhiteSpace(c)) {
                sb.appendCodePoint(c);
                c = read();
            }
            return sb.toString();
        }

        public static boolean isWhiteSpace(int c) {
            return c >= -1 && c <= 32;
        }

        public String readLine() {
            try {
                return super.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return null;
        }

    }
}

