import java.io.*;
import java.util.HashMap;
import java.util.InputMismatchException;
import java.util.Map;
import java.util.TreeMap;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Arthur Gazizov  [2oo7] - Kazan FU
 */
public class Main {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            inputStream = new FileInputStream("input.txt");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("output.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        FastScanner in = new FastScanner(inputStream);
        FastPrinter out = new FastPrinter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, FastScanner in, FastPrinter out) {
            Counter<Character> counter = new Counter<>();
            for (char c : in.next().toCharArray()) {
                counter.inc(c);
            }
            Map<Integer, Integer> result = new TreeMap<>();
            int count = counter.getOrDefault('Z', 0);
            counter.add('Z', -count);
            counter.add('E', -count);
            counter.add('R', -count);
            counter.add('O', -count);
            result.put(0, count);
            count = counter.getOrDefault('W', 0);
            counter.add('T', -count);
            counter.add('W', -count);
            counter.add('O', -count);
            result.put(2, count);
            count = counter.getOrDefault('G', 0);
            counter.add('E', -count);
            counter.add('I', -count);
            counter.add('G', -count);
            counter.add('H', -count);
            counter.add('T', -count);
            result.put(8, count);
            count = counter.getOrDefault('X', 0);
            counter.add('S', -count);
            counter.add('I', -count);
            counter.add('X', -count);
            result.put(6, count);
            count = counter.getOrDefault('H', 0);
            counter.add('T', -count);
            counter.add('H', -count);
            counter.add('R', -count);
            counter.add('E', -count);
            counter.add('E', -count);
            result.put(3, count);
            count = counter.getOrDefault('R', 0);
            counter.add('F', -count);
            counter.add('O', -count);
            counter.add('U', -count);
            counter.add('R', -count);
            result.put(4, count);
            count = counter.getOrDefault('O', 0);
            counter.add('O', -count);
            counter.add('N', -count);
            counter.add('E', -count);
            result.put(1, count);
            count = counter.getOrDefault('F', 0);
            counter.add('F', -count);
            counter.add('I', -count);
            counter.add('V', -count);
            counter.add('E', -count);
            result.put(5, count);
            count = counter.getOrDefault('I', 0);
            counter.add('N', -count);
            counter.add('I', -count);
            counter.add('N', -count);
            counter.add('E', -count);
            result.put(9, count);
            count = counter.getOrDefault('S', 0);
            counter.add('S', -count);
            counter.add('E', -count);
            counter.add('V', -count);
            counter.add('E', -count);
            counter.add('N', -count);
            result.put(7, count);
            for (int value : counter.values()) {
                if (value != 0) {
                    throw new RuntimeException("You are pidr");
                }
            }
            StringBuilder builder = new StringBuilder();
            for (Map.Entry<Integer, Integer> entry : result.entrySet()) {
                for (int i = 0; i < entry.getValue(); i++) {
                    builder.append(entry.getKey());
                }
            }
            out.print("Case #");
            out.print(testNumber);
            out.print(": ");
            out.println(builder);
        }

    }

    static class FastPrinter extends PrintWriter {
        public FastPrinter(Writer writer) {
            super(writer);
        }

        public FastPrinter(OutputStream out) {
            super(out);
        }

        public void close() {
            super.close();
        }

    }

    static class Counter<T> extends HashMap<T, Integer> implements Map<T, Integer> {
        public void add(T key, Integer count) {
            if (!containsKey(key)) {
                put(key, 0);
            }
            put(key, get(key) + count);
        }

        public void inc(T key) {
            add(key, 1);
        }

        public Integer get(Object key) {
            Integer ret = super.get(key);
            return ret == null ? 0 : ret;
        }

    }

    static class FastScanner extends BufferedReader {
        boolean isEOF;

        public FastScanner(InputStream is) {
            super(new InputStreamReader(is));
        }

        public FastScanner(InputStreamReader inputStreamReader) {
            super(inputStreamReader);
        }

        public int read() {
            try {
                int ret = super.read();
                if (isEOF && ret < 0) {
                    throw new InputMismatchException();
                }
                isEOF = ret == -1;
                return ret;
            } catch (IOException e) {
                throw new InputMismatchException();
            }
        }

        public String next() {
            StringBuilder sb = new StringBuilder();
            int c = read();
            while (isWhiteSpace(c)) {
                c = read();
            }
            while (!isWhiteSpace(c)) {
                sb.appendCodePoint(c);
                c = read();
            }
            return sb.toString();
        }

        public static boolean isWhiteSpace(int c) {
            return c >= -1 && c <= 32;
        }

        public String readLine() {
            try {
                return super.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return null;
        }

    }
}

