import java.io.*;
import java.util.*;

public class B_new {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 4;

	static final int MOVES = 4001;
	static final int BASE = 2000;

	void solve() throws IOException {
		int we = nextInt();
		int opp = nextInt();
		int n = nextInt();
		int[] hp = new int[n];
		int[] gold = new int[n];
		for (int i = 0; i < n; i++) {
			hp[i] = nextInt();
			gold[i] = nextInt();
		}

//		if (we >= opp) {
//			
//		}

		int[] needHits = new int[n];
		int[] finalHp = new int[n];
		for (int i = 0; i < n; i++) {
			int tmp = hp[i];
			while (tmp % opp == 0 || tmp % opp > we) {
				tmp -= we;
				needHits[i]++;
			}
			finalHp[i] = tmp;
		}

//		System.err.println(Arrays.toString(needHits));
//		System.err.println(Arrays.toString(finalHp));

		int[][] dp = new int[n + 1][MOVES];
		Arrays.fill(dp[0], -1);
		dp[0][BASE + 1] = 0;
		for (int i = 0; i < n; i++) {
			Arrays.fill(dp[i + 1], -1);
			for (int j = 0; j < MOVES; j++) {
				// don't attack
				int bonusMoves = ceilDiv(hp[i], opp);
				if (j - bonusMoves >= 0 && j - bonusMoves < MOVES
						&& dp[i][j - bonusMoves] != -1) {
					dp[i + 1][j] = Math
							.max(dp[i + 1][j], dp[i][j - bonusMoves]);
				}
				if (j >= BASE) {
					// attack

					bonusMoves = finalHp[i] / opp - needHits[i] - 1;
//					if (i == 2) {
//						System.err.println(bonusMoves);
//					}
					int oldMoves = j - bonusMoves;
					if (oldMoves >= 0 && oldMoves < MOVES
							&& dp[i][oldMoves] != -1) {
						dp[i + 1][j] = Math.max(dp[i + 1][j], dp[i][oldMoves]
								+ gold[i]);
					}
				}
			}

			// for (int j = 0; j < MOVES; j++) {
			// if (dp[i + 1][j] != -1) {
			// System.err.println(i + " " + (j - BASE) + " "
			// + dp[i + 1][j]);
			// }
			// }
		}

		int ans = 0;
		for (int i = 0; i < MOVES; i++) {
			ans = Math.max(ans, dp[n][i]);
		}

		out.println(ans);
	}

	static int ceilDiv(int a, int b) {
		return (a + b - 1) / b;
	}

	B_new() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("B-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("B-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("B-large.in"));
			out = new PrintWriter("B-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new B_new();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}