import java.io.*;
import java.util.*;

public class A {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		SAMPLE, SMALL, LARGE;
	}

	static final InputType currentInputType = InputType.LARGE;
	static final int attemptNumber = 0; // for small inputs only

	void solve() throws IOException {
		int n = nextInt();
		int[] dist = new int[n];
		int[] len = new int[n];
		
		for (int i = 0; i < n; i++) {
			dist[i] = nextInt();
			len[i] = nextInt();
		}
		
		int D = nextInt();
		
		int[] maxSwing = new int[n];
		Arrays.fill(maxSwing, Integer.MIN_VALUE);
		
		maxSwing[0] = dist[0];
		
		for (int i = 0; i < n; i++) {
			if (maxSwing[i] == Integer.MIN_VALUE)
				continue;
			if (maxSwing[i] + dist[i] >= D) {
				out.println("YES");
				return;
			}
			for (int j = i + 1; j < n && dist[j] <= dist[i] + maxSwing[i]; j++)
				maxSwing[j] = Math.max(maxSwing[j], Math.min(len[j], dist[j] - dist[i]));
		}
		
		out.println("NO");
	}

	void inp() throws IOException {
		switch (currentInputType) {
		case SAMPLE:
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		case SMALL:
			String fileName = "A-small-attempt" + attemptNumber;
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		case LARGE:
			fileName = "A-large";
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		}
		int test = nextInt();
		for (int i = 1; i <= test; i++) {
			System.err.println("Running test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A().inp();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (Exception e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}
