import java.io.*;
import java.util.*;

public class C {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		SAMPLE, SMALL, LARGE;
	}

	static final InputType currentInputType = InputType.SMALL;
	static final int attemptNumber = 0; // for small inputs only

	static final int INIT_DY = 100000;
	static final int INIT_Y = 10000;

	void solve() throws IOException {
		int n = nextInt();
		int[] next = new int[n - 1];
		for (int i = 0; i < n - 1; i++)
			next[i] = nextInt() - 1;

		for (int i = 0; i < n - 1; i++) {
			for (int j = i + 1; j < next[i]; j++)
				if (next[j] > next[i]) {
					out.println("Impossible");
					return;
				}
		}

		int[] ans = new int[n];
		Arrays.fill(ans, -1);

		int dy = INIT_DY;

		ans[0] = INIT_Y;

		for (int cur = 0; cur != n - 1;) {
			int to = next[cur];
			ans[to] = ans[cur] + (to - cur) * dy;
			dy--;
			cur = to;
		}

		for (int i = 0; i < n - 1; i++)
			if (ans[i] == -1) {
				ans[i] = ans[i - 1] - 1;
				int cur = i;
				while (ans[next[cur]] == -1) {
					int to = next[cur];
					ans[to] = ans[cur] + (to - cur) * dy;
					dy--;
					cur = to;
				}
			}

		for (int x : ans)
			out.print(x + " ");
		out.println();
	}

	void inp() throws IOException {
		switch (currentInputType) {
		case SAMPLE:
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		case SMALL:
			String fileName = "C-small-attempt" + attemptNumber;
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		case LARGE:
			fileName = "C-large";
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		}
		int test = nextInt();
		for (int i = 1; i <= test; i++) {
			System.err.println("Running test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new C().inp();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (Exception e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}
