import java.io.*;
import java.util.*;

public class A {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.LARGE;
	static final int ATTEMPT_NUMBER = 0;

	static class Pie implements Comparable<Pie> {
		int r;
		int h;

		public Pie(int r, int h) {
			this.r = r;
			this.h = h;
		}

		@Override
		public int compareTo(Pie o) {
			return Integer.compare(r, o.r);
		}

	}

	void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		Pie[] a = new Pie[n];
		for (int i = 0; i < n; i++) {
			a[i] = new Pie(nextInt(), nextInt());
		}

		Arrays.sort(a);
		PriorityQueue<Double> pq = new PriorityQueue<>();

		double ret = 0;

		for (Pie p : a) {

			double cur = Math.PI * p.r * p.r + 2 * Math.PI * p.r * p.h;

			if (pq.size() >= k - 1) {

				double[] zzz = new double[k - 1];
				for (int i = 0; i < k - 1; i++) {
					zzz[i] = pq.poll();
					cur -= zzz[i];
				}

				ret = Math.max(ret, cur);

				for (int i = 0; i < k - 1; i++) {
					pq.add(zzz[i]);
				}

			}

			pq.add(-2 * Math.PI * p.r * p.h);

		}

		out.println(ret);
	}

	A() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("A-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("A-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("A-large.in"));
			out = new PrintWriter("A-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}