import java.io.*;
import java.util.*;

public class B {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.LARGE;
	static final int ATTEMPT_NUMBER = 0;

	static final int DAY = 1440;
	static final int HALF = DAY / 2;

	static final int INF = Integer.MAX_VALUE / 3;

	void solve() throws IOException {
		int n1 = nextInt();
		int n2 = nextInt();
		boolean[][] cant = new boolean[2][DAY];

		for (int i = 0; i < n1; i++) {
			int low = nextInt();
			int high = nextInt();
			for (int j = low; j < high; j++) {
				cant[0][j] = true;
			}
		}

		for (int i = 0; i < n2; i++) {
			int low = nextInt();
			int high = nextInt();
			for (int j = low; j < high; j++) {
				cant[1][j] = true;
			}
		}

		int[][][][] dp = new int[2][2][HALF + 1][HALF + 1];
		// first, last, time0, time1
		for (int i = 0; i < 2; i++) {
			for (int j = 0; j < 2; j++) {
				for (int k = 0; k <= HALF; k++) {
					Arrays.fill(dp[i][j][k], INF);
				}
			}
		}

		if (!cant[0][0]) {
			dp[0][0][1][0] = 0;
		}
		if (!cant[1][0]) {
			dp[1][1][0][1] = 0;
		}
		
		int ret = INF;

		for (int t0 = 0; t0 <= HALF; t0++) {
			for (int t1 = 0; t1 <= HALF; t1++) {

				for (int fst = 0; fst < 2; fst++) {
					for (int lst = 0; lst < 2; lst++) {

						int now = dp[fst][lst][t0][t1];
						if (now == INF) {
							continue;
						}
						
//						System.err.println(fst + " " + lst + " " + t0 + " " + t1 + " --> " + now);
						

						int nowTime = t0 + t1;

						if (nowTime == DAY) {
							if (fst != lst) {
								now++;
							}
							ret = Math.min(ret, now);
							continue;
						}
						
						do {
							int whoNow = 0;
							if (t0 == HALF || cant[whoNow][nowTime]) {
								break;
							}
							int delta = whoNow != lst ? 1 : 0;
							dp[fst][whoNow][t0 + 1][t1] = Math.min(dp[fst][whoNow][t0 + 1][t1], now + delta);
						} while (false);
						
						do {
							int whoNow = 1;
							if (t1 == HALF ||cant[whoNow][nowTime]) {
								break;
							}
							int delta = whoNow != lst ? 1 : 0;
							dp[fst][whoNow][t0][t1 + 1] = Math.min(dp[fst][whoNow][t0][t1 + 1], now + delta);
						} while (false);
					}
				}

			}
		}
		
		if (ret == INF) {
			throw new AssertionError();
		}
		out.println(ret);
	}

	B() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("B-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("B-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("B-large.in"));
			out = new PrintWriter("B-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new B();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}