import java.io.*;
import java.util.*;

public class C {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 0;
	static final int INF = Integer.MAX_VALUE / 3;

	void solve() throws IOException {
		int w = nextInt();
		int h = nextInt();
		int nb = nextInt();
		boolean[][] f = new boolean[w][h];
		for (int i = 0; i < nb; i++) {
			int x0 = nextInt();
			int y0 = nextInt();
			int x1 = nextInt();
			int y1 = nextInt();
			for (int x = x0; x <= x1; x++)
				for (int y = y0; y <= y1; y++) {
					f[x][y] = true;
				}
		}
		int[][] d = new int[w][h];
		ArrayDeque<Integer> q = new ArrayDeque<>();
		for (int i = 0; i < w; i++) {
			Arrays.fill(d[i], INF);
		}
		for (int i = 0; i < h; i++) {
			d[0][i] = f[0][i] ? 0 : 1;
			q.add(0);
			q.add(i);
		}
		while (!q.isEmpty()) {
			int x = q.poll();
			int y = q.poll();
			int curD = d[x][y];
			
			// System.err.println(x + " " + y + " " + curD);

			for (int dx = -1; dx <= 1; dx++)
				for (int dy = -1; dy <= 1; dy++) {
					int toX = x + dx;
					int toY = y + dy;
					if (toX < 0 || toX >= w || toY < 0 || toY >= h) {
						continue;
					}
					int cost = f[toX][toY] ? 0 : 1;
					if (d[toX][toY] > curD + cost) {
						d[toX][toY] = curD + cost;
						if (cost == 0) {
							q.addFirst(toY);
							q.addFirst(toX);
						} else {
							q.add(toX);
							q.add(toY);
						}
					}
				}
		}
		int ans = Integer.MAX_VALUE;
		for (int i = 0; i < h; i++) {
			ans = Math.min(ans, d[w - 1][i]);
		}
		out.println(ans);
	}

	C() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("C-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("C-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("C-large.in"));
			out = new PrintWriter("C-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new C();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}