import java.io.*;
import java.util.*;

public class B {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.LARGE;
	static final int ATTEMPT_NUMBER = 0;

	static long sureWin(int n, long p) {
		if (p == (1L << n))
			return p - 1;

		long worstPlace = (1L << n) - 1;
		long team = (1L << (n + 1)) - 2;
		for (int i = 0; i < n; i++) {
			worstPlace -= (1L << i);
			team = (team >> 1) - 1;
//			System.err.println(worstPlace + " " + team);
			if (worstPlace < p)
				return team;
		}
		throw new AssertionError();
	}
	
	static long canWin(int n, long p) {
		if (p == (1L << n))
			return p - 1;
		
		long bestPlace = (1L << n) - 1;
		long team = (1L << n) - 1;
		for (int i = n - 1, j = 0; i >= 0; i--, j++) {
			bestPlace -= (1L << i);
			team -= (1L << j);
			if (bestPlace < p)
				return team;
		}
		throw new AssertionError();
	}

	void solve() throws IOException {
		int n = nextInt();
		long p = nextLong();

		out.println(sureWin(n, p) + " " + canWin(n, p));
	}

	B() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("B-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("B-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("B-large.in"));
			out = new PrintWriter("B-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new B();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}