import java.io.*;
import java.util.*;

public class A {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.LARGE;
	static final int ATTEMPT_NUMBER = 0;

	HashSet<Integer> set = new HashSet<>(10_000_000);
	int bigCnt = 0;

	void go(int[] cnt, char[] buf, int ptr) {
		if (ptr == buf.length) {
			f(new String(buf));
			return;
		}
		for (int i = 0; i < cnt.length; i++) {
			if (cnt[i] > 0) {
				cnt[i]--;
				buf[ptr] = (char) ('0' + i);
				go(cnt, buf, ptr + 1);
				cnt[i]++;
			}
		}
	}

	void f(String s) {
		if (set.contains(Integer.parseInt(s))) {
			return;
		}
		// System.err.println(s + " " + set.size());
		set.add(Integer.parseInt(s));
		int len = s.length();
		int sum = 0;
		for (int i = 0; i < len; i++) {
			sum += s.charAt(i) - '0';
		}
		if (sum > len) {
			return;
		}
		int[] cnt = new int[len + 1];
		for (int i = 1; i <= len; i++) {
			cnt[i] = s.charAt(i - 1) - '0';
		}
		cnt[0] = len - sum;

		int goSum = 0;
		for (int i = 0; i <= len; i++) {
			goSum += i * cnt[i];
		}

		if (goSum > len) {
			bigCnt += countBig(cnt, len);
			return;
		}

		char[] buf = new char[len];
		go(cnt, buf, 0);
	}

	static final long[] FACT = new long[12];
	static {
		FACT[0] = 1;
		for (int i = 1; i < FACT.length; i++) {
			FACT[i] = (long) i * FACT[i - 1];
		}
	}

	int countBig(int[] a, int len) {
		long ret = FACT[len];
		for (int x : a) {
			ret /= FACT[x];
		}
		return (int) ret;
	}

	static final Random rng = new Random();

	void solve() {

		// for (int tst = 0;;tst++) {
		// char[] buf = new char[9];
		// for (int i = 0; i < buf.length; i++) {
		// buf[i] = (char)('0' + rng.nextInt(2));
		// }
		// set.clear();
		// String s = new String(buf);
		// System.err.println(s);
		// f(s);
		// out.println(set.size());
		// }

//		String s = "100001000";
//		set.clear();
//		bigCnt = 0;
//		f(s);
//		out.println(set.size() + bigCnt);

		set.clear();
		bigCnt = 0;
		f(nextToken());
		out.println(set.size() + bigCnt);
	}

	A() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("A-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("A-small-attempt_new" + ATTEMPT_NUMBER
					+ ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("A-large.in"));
			out = new PrintWriter("A-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}