import java.io.*;
import java.util.*;

public class A {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final int MOD = 1_000_002_013;

	static final InputType INPUT_TYPE = InputType.LARGE;
	static final int ATTEMPT_NUMBER = 0;

	class Event implements Comparable<Event> {
		int pos;
		boolean enter;
		int cnt;

		public Event(int pos, boolean enter, int cnt) {
			this.pos = pos;
			this.enter = enter;
			this.cnt = cnt;
		}

		@Override
		public int compareTo(Event o) {
			if (pos != o.pos)
				return Integer.compare(pos, o.pos);
			if (enter != o.enter)
				return enter ? -1 : 1;
			return 0;
		}

	}

	int costMod(int x) {
		long cost = (long) x * (x - 1) / 2;
		return (int) (cost % MOD);
	}

	void solve() throws IOException {
		int n = nextInt();
		int m = nextInt();

		Event[] a = new Event[2 * m];

		int init = 0;
		for (int i = 0; i < m; i++) {
			int st = nextInt() - 1;
			int en = nextInt() - 1;
			int cnt = nextInt();
			a[2 * i] = new Event(st, true, cnt);
			a[2 * i + 1] = new Event(en, false, cnt);
			int len = en - st;
			init += (int) ((long) costMod(len) * cnt % MOD);
			if (init >= MOD)
				init -= MOD;
		}

		int best = 0;

		Arrays.sort(a);

		Deque<Event> stack = new ArrayDeque<>();

		for (int i = 0; i < 2 * m; i++) {
			if (a[i].enter) {
				stack.addLast(a[i]);
			} else {
				Event now = a[i];

				while (now.cnt > 0) {
					Event prev = stack.getLast();
					int add = Math.min(now.cnt, prev.cnt);

					now.cnt -= add;
					prev.cnt -= add;
					if (prev.cnt == 0)
						stack.pollLast();
					best += (int) ((long) costMod(now.pos - prev.pos) * add % MOD);
					if (best >= MOD)
						best -= MOD;
				}
			}
		}
		
		int ans = best - init;
		if (ans < 0)
			ans += MOD;
		out.println(ans);
		
	}

	A() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("A-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("A-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("A-large.in"));
			out = new PrintWriter("A-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}