import java.io.*;
import java.util.*;

public class D {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 0;

	void solve() throws IOException {
		int p = nextInt();
		int[] val = new int[p];
		int[] cnt = new int[p];
		int total = 0;
		for (int i = 0; i < p; i++) {
			val[i] = nextInt();
		}
		for (int i = 0; i < p; i++) {
			cnt[i] = nextInt();
			total += cnt[i];
		}

		int n = Integer.numberOfTrailingZeros(total);
		outer: for (int i = 0; i < n; i++) {
			if (cnt[0] > 1) {
				out.print("0 ");
				for (int j = 0; j < p; j++) {
					cnt[j] /= 2;
				}
				continue outer;
			}
			int x = 1;
			while (cnt[x] == 0) {
				x++;
			}
			x = val[x];
			out.print(x + " ");
			for (int j = 0; j < p; j++) {
				if (cnt[j] == 0) {
					continue;
				}
				int k = Arrays.binarySearch(val, val[j] + x);
				cnt[k] -= cnt[j];
			}
		}
		out.println();
	}

	D() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("D-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("D-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("D-large.in"));
			out = new PrintWriter("D-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new D();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}