import java.io.*;
import java.util.*;

public class D {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 0;

	void solve() throws IOException {
		int r = nextInt();
		int c = nextInt();
		int n = nextInt();
		int d = nextInt();
		
		int[] rs = new int[n];
		int[] cs = new int[n];
		int[] xs = new int[n];
		for (int i = 0; i < n; i++) {
			rs[i] = nextInt() - 1;
			cs[i] = nextInt() - 1;
			xs[i] = nextInt();
		}
		
		long[][] a = new long[r][c];
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				a[i][j] = Long.MAX_VALUE;
				for (int k = 0; k < n; k++) {
					int dist = Math.abs(i - rs[k]) + Math.abs(j - cs[k]);
					a[i][j] = Math.min(a[i][j], xs[k] + (long)dist * d);
				}
			}
		}
		
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				if (i + 1 < r && Math.abs(a[i + 1][j] - a[i][j]) > d) {
					out.println("IMPOSSIBLE");
					return;
				}
				if (j + 1 < c && Math.abs(a[i][j + 1] - a[i][j]) > d) {
					out.println("IMPOSSIBLE");
					return;
				}
			}
		}
		
		for (int i = 0; i < n; i++) {
			if (a[rs[i]][cs[i]] != xs[i]) {
				out.println("IMPOSSIBLE");
				return;
			}
		}
		long ans = 0;
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				ans += a[i][j];
				ans %= P;
			}
		}
		out.println(ans);
	}
	
	static final long P = 1_000_000_007;

	D() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("D-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("D-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("D-large.in"));
			out = new PrintWriter("D-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new D();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}