import java.io.*;
import java.util.*;

public class A {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;
	
	class Part implements Comparable<Part>{
		int len, speed;

		public Part(int len, int speed) {
			super();
			this.len = len;
			this.speed = speed;
		}

		@Override
		public int compareTo(Part o) {
			return speed - o.speed;
		}
		
	}

	void solve() throws IOException {
		int x = nextInt();
		int walk = nextInt();
		int run = nextInt();
		double runTime = nextInt();
		int n = nextInt();
		
		int boost = run - walk;
		
		Part[] path = new Part[n + 1];
		for (int i = 0; i < n; i++) {
			path[i] = new Part(-nextInt() + nextInt(), nextInt() + walk);
			x -= path[i].len;
		}
		
		path[n] = new Part(x, walk);
		
		Arrays.sort(path);
			
		double ans = 0;
		for (Part p : path)
			ans += 1.0 * p.len / p.speed;
		
		for (int i = 0; i < path.length; i++) {
			double maxBoost = 1.0 * path[i].len / (path[i].speed + boost);
			double useBoost = Math.min(maxBoost, runTime);
			
			ans -= useBoost * (path[i].speed + boost) / path[i].speed;
			ans += useBoost;
			
			runTime -= useBoost;
		}
		
		out.printf("%.12f\n", ans);
		
	}

	void preCalc() throws IOException {
	}

	void gcjSolve() throws IOException {
		preCalc();
		int tests = nextInt();
		for (int i = 1; i <= tests; i++) {
			out.print("Case #" + i + ": ");
			System.err.println("Test " + i + " started");
			solve();
		}
		System.err.println("Finished!");
	}

	void inp() throws IOException {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		gcjSolve();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A().inp();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String nextString() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken("\n");
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

}
