import java.io.*;
import java.util.*;

public class C_small {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		SAMPLE, SMALL, LARGE;
	}

	static final InputType currentInputType = InputType.SMALL;
	static final int attemptNumber = 1; // for small inputs only

	void solve() throws IOException {
		int n = nextInt();
		int[][] a = new int[n][];
		HashMap<String, Integer> easy = new HashMap<>();
		for (int i = 0; i < n; i++) {
			String[] tmp = nextString().split(" ");
			a[i] = new int[tmp.length];
			int j = 0;
			for (String s : tmp) {
				int value;
				if (!easy.containsKey(s)) {
					value = easy.size();
					easy.put(s, value);
				} else {
					value = easy.get(s);
				}
				a[i][j++] = value;
			}
		}
		
		int[] which = new int[easy.size()];
		
		int ret = Integer.MAX_VALUE;
		for (int mask = 0; mask < 1 << (n - 2); mask++) {
			Arrays.fill(which, 0);
			for (int i = 0; i < n; i++) {
				int where = (i < 2 ? i : get(mask, i - 2));
				for (int x : a[i]) {
					which[x] |= 1 << where;	
				}
			}
			int cur = 0;
			for (int i = 0; i < which.length; i++) {
				if (which[i] == 3) {
					cur++;
				}
			}
			ret = Math.min(ret, cur);
		}
		
		out.println(ret);
	}
	
	static int get(int mask, int i) {
		return ((mask >> i) & 1);
	}

	void inp() throws IOException {
		switch (currentInputType) {
		case SAMPLE:
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		case SMALL:
			String fileName = "C_small-small-attempt" + attemptNumber;
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		case LARGE:
			fileName = "C_small-large";
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		}
		int test = nextInt();
		for (int i = 1; i <= test; i++) {
			System.err.println("Running test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new C_small().inp();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (Exception e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}
