import java.io.*;
import java.util.*;

public class D {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 0;

	int ansVal, ansCnt;

	int[] where;
	String[] a;
	int m, n;

	void check() {
		int val = 0;
		Set<String>[] all = new Set[n];
		for (int i = 0; i < n; i++) {
			all[i] = new HashSet<>();
		}
		for (int i = 0; i < m; i++) {
			for (int j = 0; j <= a[i].length(); j++) {
				all[where[i]].add(a[i].substring(0, j));
			}
		}
		for (int i = 0; i < n; i++) {
			if (all[i].isEmpty()) {
				return;
			}
//			System.err.println(all[i]);
			val += all[i].size();
		}
		if (val > ansVal) {
			ansVal = val;
			ansCnt = 1;
		} else if (val == ansVal) {
			ansCnt++;
		}
	}

	void go(int i) {
		if (i == m) {
			check();
			return;
		}
		for (int j = 0; j < n; j++) {
			where[i] = j;
			go(i + 1);
		}
	}

	void solve() throws IOException {
		m = nextInt();
		n = nextInt();
		a = new String[m];
		for (int i = 0; i < m; i++) {
			a[i] = nextToken();
		}

		ansVal = -1;
		ansCnt = 0;
		where = new int[m];
		go(0);
		out.println(ansVal + " " + ansCnt);
	}

	D() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("D-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("D-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("D-large.in"));
			out = new PrintWriter("D-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new D();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}