import java.io.*;
import java.util.*;

public class A {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 0;


	HashSet<String> set = new HashSet<>();
	
	void go(int[] cnt, char[] buf, int ptr) {
		if (ptr == buf.length) {
			f(new String(buf));
			return;
		}
		for (int i = 0; i < cnt.length; i++) {
			if (cnt[i] > 0) {
				cnt[i]--;
				buf[ptr] = (char)('0' + i);
				go(cnt, buf, ptr + 1);
				cnt[i]++;
			}
		}
	}
	
	void f(String s) {
		if (set.contains(s)) {
			return;
		}
		set.add(s);
		int len = s.length();
		int sum = 0;
		for (int i = 0; i < len; i++) {
			sum += s.charAt(i) - '0';
		}
		if (sum > len) {
			return;
		}
		int[] cnt = new int[len + 1];
		for (int i = 1; i <= len; i++) {
			cnt[i] = s.charAt(i - 1) - '0';
		}
		cnt[0] = len - sum;
		char[] buf = new char[len];
		go(cnt, buf, 0);
	}
	
	void solve() {
		set.clear();
		f(nextToken());
		out.println(set.size());
	}

	A() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("A-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("A-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("A-large.in"));
			out = new PrintWriter("A-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}