import java.io.*;
import java.util.*;

public class C {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;
	
	final int ROOT = 1000010;
	
	ArrayList<Integer> primes;

	void solve() throws IOException {
		long n = nextLong();
		if (n == 1) {
			out.println(0);
			return;
		}
		
		int ans = 1;
		for (int p : primes) {
			
			if (n < (long)p * p)
				break;
			
			long tmp = n / p / p;
			while (tmp > 0) {
				ans++;
				tmp /= p;
			}
		}
		
		out.println(ans);
	}

	void preCalc(){
		boolean[] isPrime = new boolean[ROOT];
		primes = new ArrayList<Integer>();
		Arrays.fill(isPrime, true);
		for (int i = 2; i < ROOT; i++) {
			if (isPrime[i]) {
				primes.add(i);
				for (long j = (long) i * i; j < ROOT; j += i) {
					isPrime[(int) j] = false;
				}
			}
		}
		
	}

	void gcjSolve() throws IOException {
		preCalc();
		int tests = nextInt();
		for (int i = 1; i <= tests; i++) {
			out.print("Case #" + i + ": ");
			System.err.println("Test " + i + " started");
			solve();
		}
		System.err.println("Finished!");
	}

	void inp() throws IOException {
		br = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(System.out);
		gcjSolve();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new C().inp();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	String nextString() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken("\n");
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

}
