import java.io.*;
import java.util.*;

public class C {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 0;

	int[] leave, len;
	
	void solve() throws IOException {
		int c = nextInt();
		int[] from = new int[2 * c];
		int[] to = new int[2 * c];
		leave = new int[2 * c];
		len = new int[2 * c];
		
		int baseCost = 0;
		
		for (int i = 0; i < 2 * c; i++) {
			from[i] = i / 2;
			to[i] = nextInt() - 1;
			leave[i] = nextInt();
			len[i] = nextInt();
			baseCost += len[i];
		}
		
		ArrayList<Integer>[] arr = new ArrayList[c];
		ArrayList<Integer>[] dep = new ArrayList[c];
		
		for (int i = 0; i < c; i++) {
			arr[i] = new ArrayList<>();
			dep[i] = new ArrayList<>();
		}
		
		for (int i = 0; i < 2 * c; i++) {
			dep[from[i]].add(i);
			arr[to[i]].add(i);
		}
		
		int[] perm = new int[2 * c];
		Arrays.fill(perm, -1);
		
		int[] sw1 = new int[c];
		int[] sw2 = new int[c];
		int[] cost = new int[c];
		
		for (int i = 0; i < c; i++) {
			int in1 = arr[i].get(0);
			int in2 = arr[i].get(1);
			int out1 = dep[i].get(0);
			int out2 = dep[i].get(1);
			
			int justCost = getTime(in1, out1, in2, out2, i);
			int crossCost = getTime(in1, out2, in2, out1, i);
			
//			System.err.println(in1 + " " + in2 + " " + out1 + " " + out2);
//			System.err.println(justCost + " " + crossCost);
			
			sw1[i] = in1;
			sw2[i] = in2;
			cost[i] = Math.abs(crossCost - justCost);
			baseCost += Math.min(justCost, crossCost);
			
			if (justCost <= crossCost) {
				perm[in1] = out1;
				perm[in2] = out2;
			} else {
				perm[in1] = out2;
				perm[in2] = out1;
			}
		}
		
//		System.err.println(Arrays.toString(perm));
//		out.println(baseCost);
		
		int[] cycId = new int[2 * c];
		Arrays.fill(cycId, -1);
		int comps = 0;
		for (int i = 0; i < 2 * c; i++) {
			if (cycId[i] != -1) {
				continue;
			}
			comps++;
			int mark = i;
			for (int v = i; cycId[v] == -1; v = perm[v]) {
				cycId[v] = mark;
			}
		}
		
		int[] p = cycId.clone();
		Edge[] es = new Edge[c];
		for (int i = 0; i < c; i++) {
			es[i] = new Edge(sw1[i], sw2[i], cost[i]);
		}
		
		Arrays.sort(es);
		for (Edge e : es) {
			int v = get(p, e.from);
			int u = get(p, e.to);
			if (v == u) {
				continue;
			}
			comps--;
			baseCost += e.len;
			p[u] = v;
		}
		
		out.println(baseCost);
	}
	
	static class Edge implements Comparable<Edge> {
		int from, to, len;

		public Edge(int from, int to, int len) {
			this.from = from;
			this.to = to;
			this.len = len;
		}

		@Override
		public int compareTo(Edge o) {
			return Integer.compare(len, o.len);
		}
	}
	
	int get(int[] p, int v) {
		return p[v] == v ? v : (p[v] = get(p, p[v]));
	}
	
	int getTimeSimple(int in, int out) {
		int arrivalIn = leave[in] + len[in];
		int ret = leave[out] - arrivalIn;
		ret %= 24;
		if (ret < 0) {
			ret += 24;
		}
		return ret;
	}
	
	int getTime(int in1, int out1, int in2, int out2, int idx) {
		int t1 = getTimeSimple(in1, out1);
		int t2 = getTimeSimple(in2, out2);
		if (idx != 0) {
			return t1 + t2;
		}
		return Math.min(leave[out1] + t2, t1 + leave[out2]);
	}

	C() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("C-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("C-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("C-large.in"));
			out = new PrintWriter("C-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new C();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}