import java.io.*;
import java.util.*;

public class C_new {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		EXAMPLE, SMALL, LARGE
	}

	static final InputType INPUT_TYPE = InputType.SMALL;
	static final int ATTEMPT_NUMBER = 4;

	void solve() throws IOException {
		int n = nextInt();
		int[] a = new int[n];
		int[] b = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
		}
		for (int i = 0; i < n; i++) {
			b[i] = nextInt();
		}

		int[] ans = new int[n];
		Arrays.fill(ans, -1);

		int[] maxPrefA = new int[n];
		int[] maxSuffB = new int[n];

		ArrayList<Integer> pos = new ArrayList<>();

		for (int put = 1; put <= n;) {
			int curMaxPrefA = 0;
			for (int i = 0; i < n; i++) {
				if (ans[i] == -1) {
					maxPrefA[i] = curMaxPrefA;
				} else {
					curMaxPrefA = Math.max(curMaxPrefA, a[i]);
				}
			}

			int curMaxSuffB = 0;
			for (int i = n - 1; i >= 0; i--) {
				if (ans[i] == -1) {
					maxSuffB[i] = curMaxSuffB;
				} else {
					curMaxSuffB = Math.max(curMaxSuffB, b[i]);
				}
			}

			pos.clear();
			for (int i = 0; i < n; i++) {
				if (ans[i] == -1 && maxPrefA[i] + 1 == a[i]
						&& maxSuffB[i] + 1 == b[i]) {
					pos.add(i);
				}
			}

			if (pos.isEmpty())
				throw new AssertionError("No candidates");

			int low = put;

			int[] diff = new int[pos.size() - 1];
			for (int i = 0; i < pos.size() - 1; i++) {
				int p1 = pos.get(i);
				int p2 = pos.get(i + 1);
				if (a[p1] == a[p2])
					diff[i] = 1;
				if (b[p1] == b[p2])
					diff[i] = -1;
			}

			int[] arr = buildPerm(diff);

			for (int i = 0; i < pos.size(); i++)
				ans[pos.get(i)] = arr[i] + low;

			put += pos.size();

		}

		int[] resA = new int[n];
		int[] resB = new int[n];

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < i; j++)
				if (ans[j] < ans[i])
					resA[i] = Math.max(resA[i], resA[j]);
			resA[i]++;
		}

		for (int i = n - 1; i >= 0; i--) {
			for (int j = n - 1; j > i; j--)
				if (ans[j] < ans[i])
					resB[i] = Math.max(resB[i], resB[j]);
			resB[i]++;
		}

		if (!Arrays.equals(a, resA) || !Arrays.equals(b, resB))
			throw new AssertionError();
		for (int i = 0; i < n; i++)
			out.print(ans[i] + " ");
		out.println();
	}

	int[] buildPerm(int[] diff) {
		int n = diff.length + 1;

		int[] a = new int[n];

		int low = 0;

		for (int i = 0; i < n;) {

			int j = i;
			while (j < n - 1 && diff[j] == 1) {
				j++;
			}
			
			for (int k = j; k >= i; k--) {
				a[k] = low;
				low++;
			}
			
			i = j + 1;

		}

		return a;
	}

	C_new() throws IOException {
		switch (INPUT_TYPE) {
		case EXAMPLE: {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		}
		case SMALL: {
			br = new BufferedReader(new FileReader("C-small-attempt"
					+ ATTEMPT_NUMBER + ".in"));
			out = new PrintWriter("C-small-attempt" + ATTEMPT_NUMBER + ".out");
			break;
		}
		case LARGE: {
			br = new BufferedReader(new FileReader("C-large.in"));
			out = new PrintWriter("C-large.out");
			break;
		}
		}
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println("Test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new C_new();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (IOException e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}