import java.io.*;
import java.util.*;

public class B {

	BufferedReader br;
	PrintWriter out;
	StringTokenizer st;
	boolean eof;

	enum InputType {
		SAMPLE, SMALL, LARGE;
	}

	static final InputType currentInputType = InputType.LARGE;
	static final int attemptNumber = 0; // for small inputs only

	class Man implements Comparable<Man> {
		int r;
		int ind;

		public Man(int r, int ind) {
			this.r = r;
			this.ind = ind;
		}

		@Override
		public int compareTo(Man o) {
			return o.r - r;
		}
	}

	void solve() throws IOException {
		int n = nextInt();
		int w = nextInt();
		int l = nextInt();

		Man[] a = new Man[n];
		ArrayList<Man> set = new ArrayList<Man>();
		for (int i = 0; i < n; i++) {
			a[i] = new Man(nextInt(), i);
			set.add(a[i]);
		}

		Collections.sort(set);

		double[] ansX = new double[n];
		double[] ansY = new double[n];

		int curX = 0;

		while (curX <= w && !set.isEmpty()) {

			Man fat = set.get(0);
			int stripeW = fat.r;

			if (curX != 0)
				curX += stripeW;

			if (curX > w)
				break;

			int curY = 0;

			while (true) {
				Man cur = null;
				int putY = 0;
				for (int i = 0; i < set.size(); i++) {
					putY = (curY == 0 ? 0 : curY + set.get(i).r);
					if (putY <= l) {
						cur = set.get(i);
						set.remove(i);
						break;
					}
				}
				if (cur == null)
					break;
				ansX[cur.ind] = curX;
				ansY[cur.ind] = putY;

				curY = putY + cur.r;
			}

			curX += stripeW;
		}

		if (set.isEmpty()) {
			for (int i = 0; i < n; i++)
				out.printf("%.2f %.2f ", ansX[i], ansY[i]);
			out.println();
			return;
		}
		
		// flip width and length and hope for best!!!
		
		set = new ArrayList<Man>();
		for (int i = 0; i < n; i++)
			set.add(a[i]);

		Collections.sort(set);

		ansX = new double[n];
		ansY = new double[n];

		int curY = 0;

		while (curY <= l && !set.isEmpty()) {

			Man fat = set.get(0);
			int stripeW = fat.r;

			if (curY != 0)
				curY += stripeW;

			if (curY > l)
				break;

			curX = 0;

			while (true) {
				Man cur = null;
				int putX = 0;
				for (int i = 0; i < set.size(); i++) {
					putX = (curX == 0 ? 0 : curX + set.get(i).r);
					if (putX <= l) {
						cur = set.get(i);
						set.remove(i);
						break;
					}
				}
				if (cur == null)
					break;
				ansY[cur.ind] = curY;
				ansX[cur.ind] = putX;

				curX = putX + cur.r;
			}

			curY += stripeW;
		}

		if (set.isEmpty()) {
			for (int i = 0; i < n; i++)
				out.printf("%.2f %.2f ", ansX[i], ansY[i]);
			out.println();
			return;
		}
		
		out.println("FAIL!!!");
	}

	void inp() throws IOException {
		Locale.setDefault(Locale.US);
		switch (currentInputType) {
		case SAMPLE:
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			break;
		case SMALL:
			String fileName = "B-small-attempt" + attemptNumber;
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		case LARGE:
			fileName = "B-large";
			br = new BufferedReader(new FileReader(fileName + ".in"));
			out = new PrintWriter(fileName + ".out");
			break;
		}
		int test = nextInt();
		for (int i = 1; i <= test; i++) {
			System.err.println("Running test " + i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new B().inp();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return null;
			}
		}
		return st.nextToken();
	}

	String nextString() {
		try {
			return br.readLine();
		} catch (Exception e) {
			eof = true;
			return null;
		}
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}
