   import java.util.*;
   import java.io.*;
   
   public class Tictac
   {
      public static void main(String[] args) throws Exception
      {
         BufferedReader inputer = new BufferedReader(new FileReader("tictac.in"));
         PrintWriter outputer = new PrintWriter(new BufferedWriter(new FileWriter("tictac.out")));
         int N = Integer.parseInt(inputer.readLine());
      	
         char boards[][][] = new char[N][4][4];
         for(int i = 0; i < N; i++)
         {
            for(int j = 0; j < boards[i].length; j++)
            {
               boards[i][j] = inputer.readLine().toCharArray();
               //System.out.println(boards[i][j][0] + " " + boards[i][j][1] + " " + boards[i][j][2] + " " + boards[i][j][3]);
            }
            inputer.readLine();
            //System.out.println();
         }
         
         for(int i = 0; i < boards.length; i++)
         {
            String answer;
            char temp = checkCols(boards, i);
            char temp2 = checkRows(boards, i);
            char temp3 = checkDias(boards, i);
            char temp4 = checkDias2(boards, i);
            if(temp != '.')
            {
               answer = temp + " won";
            }
            else if(temp2 != '.')
            {
               answer = temp2 + " won";
            }
            else if(temp3 != '.')
            {
               answer = temp3 + " won";
            }
            else if(temp4 != '.')
            {
               answer = temp4 + " won";
            }
            else if(!isComplete(boards, i))
            {
               answer = "Game has not completed";
            }
            else
            {
               answer = "Draw";
            }
            
            outputer.println("Case #" + (i + 1) + ": " + answer);
         }
         
         inputer.close();
         outputer.close();
      }
      
      public static boolean isComplete(char[][][] boards, int in)
      {
         int r;
         for(r = 0; r < boards[in].length; r++)
         {
            int c;
            for(c = 0; c < boards[in][r].length; c++)
            {
               if(boards[in][r][c] == '.')
                  break;
            }
            if(c != boards[in][r].length)
               break;
         }
         if(r == boards[in].length)
            return true;
            
         return false;
      }
      
      public static char checkCols(char[][][] boards, int in)
      {
         for(int c = 0; c < boards[in][0].length; c++)
         {
            int r;
            for(r = 1; r < boards[in].length - 1; r++)
            {
               if(!((boards[in][r][c] == boards[in][r - 1][c] || boards[in][r][c] == 'T' || boards[in][r - 1][c] == 'T') &&
                  (boards[in][r][c] == boards[in][r + 1][c] || boards[in][r][c] == 'T' || boards[in][r + 1][c] == 'T') &&
               	(boards[in][r - 1][c] == boards[in][r + 1][c] || boards[in][r - 1][c] == 'T' || boards[in][r + 1][c] == 'T')))
               {
                  break;
               }
            }
            if(boards[in][0][c] != '.' && r == boards[in].length - 1)
            {
               return boards[in][0][c] == 'T' ? boards[in][1][c] : boards[in][0][c];
            }
         }
         
         return '.';
      }
      
      public static char checkRows(char[][][] boards, int in)
      {
         for(int r = 0; r < boards[in].length; r++)
         {
            int c;
            for(c = 1; c < boards[in][r].length - 1; c++)
            {
               if(!((boards[in][r][c] == boards[in][r][c - 1] || boards[in][r][c] == 'T' || boards[in][r][c - 1] == 'T') &&
                  (boards[in][r][c] == boards[in][r][c + 1] || boards[in][r][c] == 'T' || boards[in][r][c + 1] == 'T') &&
               	(boards[in][r][c - 1] == boards[in][r][c + 1] || boards[in][r][c - 1] == 'T' || boards[in][r][c + 1] == 'T')))
               {
                  break;
               }
            }
            if(boards[in][r][0] != '.' && c == boards[in].length - 1)
            {
               return boards[in][r][0] == 'T' ? boards[in][r][1] : boards[in][r][0];
            }
         }
         
         return '.';
      }
      
      public static char checkDias(char[][][] boards, int in)
      {
         int r;
         for(r = 1; r < boards[in].length - 1; r++)
         {
            if(!((boards[in][r][r] == boards[in][r - 1][r - 1] || boards[in][r][r] == 'T' || boards[in][r - 1][r - 1] == 'T') &&
                  (boards[in][r][r] == boards[in][r + 1][r + 1] || boards[in][r][r] == 'T' || boards[in][r + 1][r + 1] == 'T') &&
            		(boards[in][r - 1][r - 1] == boards[in][r + 1][r + 1] || boards[in][r - 1][r - 1] == 'T' || boards[in][r + 1][r + 1] == 'T')))
            {
               break;
            }
         }
         	   
         if(boards[in][0][0] != '.' && r == boards[in].length - 1)
         {
            return boards[in][0][0] == 'T' ? boards[in][1][1] : boards[in][0][0];
         }
         
         return '.';
      }
      
      public static char checkDias2(char[][][] boards, int in)
      {
         int r;
         for(r = 1; r < boards[in].length - 1; r++)
         {
            if(!((boards[in][r][3 - r] == boards[in][r - 1][4 - r] || boards[in][r][3 - r] == 'T' || boards[in][r - 1][4 - r] == 'T') &&
                  (boards[in][r][3 - r] == boards[in][r + 1][2 - r] || boards[in][r][3 - r] == 'T' || boards[in][r + 1][2 - r] == 'T') &&
            		(boards[in][r - 1][4 - r] == boards[in][r + 1][2 - r] || boards[in][r - 1][4 - r] == 'T' || boards[in][r + 1][2 - r] == 'T')))
            {
               break;
            }
         } 
         
         if(boards[in][0][3] != '.' && r == boards[in].length - 1)
         {
            return boards[in][0][3] == 'T' ? boards[in][2][2] : boards[in][0][3];
         }
         
         return '.';
      }
   }