package gcj;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class NewLotteryGame {

	public static void main(String[] args) throws Exception {
		String name = "B-large";
		Scanner scanner = new Scanner(new File("C:\\Users\\m\\Desktop\\training\\"+name+".in"));
		final int len = scanner.nextInt() + 1;
		FileWriter fw = new FileWriter("C:\\Users\\m\\Desktop\\training\\"+name+".out");
		BufferedWriter out = new BufferedWriter(fw);
		for (int i = 1; i < len; i++) {
			long A = scanner.nextLong();
			long B = scanner.nextLong();
			long K = scanner.nextLong();
			String str = "Case #" + i + ": " + solve(new RangeLess(A), new RangeLess(B), new RangeLess(K));
			System.out.println(str);
			out.write(str);
			out.newLine();
		}
		out.flush();
		out.close();
	}
	
	private static int solve(RangeLess A, RangeLess B, RangeLess K) {
		//System.out.println(A + " " + B + " " + K);
		int r = 0;
		for (int i = 0; i < A.howManyOne; i ++) {
			for (int j = 0; j < B.howManyOne; j++) {
				for (int k = 0; k < K.howManyOne; k++) {
					final int d = matchClasses(A.classes[i], B.classes[j], K.classes[k]);
					//System.out.println("r+=" + d);
					r += d;
				}
			}
		}
		return r;
	}
	
	private static final int matchClasses(NumberClass A, NumberClass B, NumberClass K) {
		int bitA = A.nbBits;
		int bitB = B.nbBits;
		int bitK = K.nbBits;
		int maxBit = Math.max(Math.max(bitA, bitB), bitK);
		int r = 1;
		for (int i = 0; i < maxBit; i++) {
			char a = A.charAt(i);
			char b = B.charAt(i);
			char k = K.charAt(i);
			int ri = match(a, b, k);
			//System.out.println(ri);
			if (ri == 0) {
				return 0;
			}
			r *= ri;
		}
		return r;
	}
	
	private static int match(char a, char b, char k) {
		//System.out.println(a + " " + b + " " + k);
		if (a == '?' && b == '?') {
			if (k == '?') {
				return 4;
			}
			if (k == '0') {
				return 3;
			}
			return 1;
		}
		if (a == '0' && b == '0') {
			if (k == '1') {
				return 0;
			}
			return 1;
		}
		if (a == '1' && b == '1') {
			if (k == '0') {
				return 0;
			}
			return 1;
		}
		if ((a == '?' && b == '0') || (a == '0' && b == '?')) {
			if (k == '1') {
				return 0;
			}
			return 2;
		}
		if ((a == '?' && b == '1') || (a == '1' && b == '?')) {
			if (k == '?') {
				return 2;
			}
			return 1;
		}
		if ((a == '0' && b == '1') || (a == '1' && b == '0')) {
			if (k == '1') {
				return 0;
			}
			return 1;
		}
		return 0;
	}

	private static final class RangeLess {
		private final long max;
		private final String binary;
		private final int howManyOne;
		private final int nbBits;
		private final NumberClass[] classes;
		RangeLess(long max) {
			this.max = max;
			binary = Long.toBinaryString(max);
			nbBits = binary.length();
			int howManyOneTmp = 0;
			for (int i = 0; i < nbBits; i++) {
				if (binary.charAt(i) == '1') {
					howManyOneTmp++;
				}
			}
			howManyOne = howManyOneTmp;
			classes = new NumberClass[howManyOne];
			int currentBit = 0;
			int i = 0;
			while (currentBit != -1) {
				classes[i] = new NumberClass(binary, currentBit, nbBits);
				currentBit = binary.indexOf('1', currentBit + 1);
				i++;
			}
		}
		@Override
		public String toString() {
			StringBuffer buff = new StringBuffer("RangeLess ");
			buff.append(max);
			buff.append(":\n");
			for (int i = 0; i < howManyOne; i++) {
				buff.append(classes[i]);
				buff.append('\n');
			}
			buff.append('\n');
			return buff.toString();
		}
	}
	
	private static final class NumberClass {
		private final int nbBits;
		private final char[] bits;
		char charAt(int i) {
			int idx = nbBits - i - 1;
			if (idx < 0) {
				return '0';
			}
			return bits[idx];
		}
		NumberClass(String binary, int bitPos, int nbBits) {
			this.nbBits = nbBits;
			bits = new char[nbBits];
			for(int i = 0; i < nbBits; i++) {
				if (i < bitPos) {
					bits[i] = binary.charAt(i);
				} else if (i == bitPos) {
					bits[i] = '0';
				} else {
					bits[i] = '?';
				}
			}
		}
		@Override
		public String toString() {
			return new String(bits);
		}
	}
	
}
