package gcj;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class ManageYourEnergy {

	public static void main(String[] args) throws Exception {
		String name = "B-small";
		Scanner scanner = new Scanner(new File("C:\\Users\\m\\Desktop\\training\\"+name+".in"));
		final int len = scanner.nextInt() + 1;
		FileWriter fw = new FileWriter("C:\\Users\\m\\Desktop\\training\\"+name+".out");
		BufferedWriter out = new BufferedWriter(fw);
		for (int i = 1; i < len; i++) {
			int e = scanner.nextInt();
			int r = scanner.nextInt();
			int n = scanner.nextInt();
			int[] activities = new int[n];
			for (int j = 0; j < n; j++) {
				activities[j] = scanner.nextInt();
			}
			String str = "Case #" + i + ": " + solve(e, r, n, activities);
			System.out.println(str);
			out.write(str);
			out.newLine();
		}
		out.flush();
		out.close();
	}
	
	private static int maxIdx(int[] activities, int start, int end) {
		int max = 0;
		int idx = -1;
		for (int i = start; i <= end; i++) {
			if (activities[i] >= max) {
				max = activities[i];
				idx = i;
			}
		}
		return idx;
	}
	
	private static int minIdx(int[] distrib, int[] activities, int start, int end) {
		int min = Integer.MAX_VALUE;
		int idx = -1;
		for (int i = start; i <= end; i++) {
			if (distrib[i] > 0 && activities[i] < min) {
				min = activities[i];
				idx = i;
			}
		}
		return idx;
	}

	private static int solve(int e, int r, int n, int[] activities) {
		int result = 0;
		if (e == r) {
			for (int i = 0; i < n; i++) {
				result += e * activities[i];
			}
		} else if (r == 0) {
			int max = activities[maxIdx(activities, 0, n - 1)];
			result = max * e;
		} else {
			int[] distrib = new int[n];
			for (int i = 0; i < n - 1; i++) {
				distrib[i] = r;
			}
			distrib[n - 1] = e;
			optim(e, result, n, activities, distrib, 0, n-1);
			//System.out.println("---------");
			for (int i = 0; i < n; i++) {
				//System.out.print(activities[i] + " ");
				result += distrib[i] * activities[i];
			}
			/*System.out.println();
			for (int i = 0; i < n; i++) {
				System.out.print(distrib[i] + " ");
			}
			System.out.println();*/
		}
		return result;
	}
	
	private static void optim(int e, int r, int n, int[] activities, int[] distrib, int start, int end) {
		if (start >= end) {
			return;
		}
		int maxIdx = maxIdx(activities, start, end);
		int impactedTill = maxIdx + e;
		if (impactedTill > end) {
			impactedTill = end;
		}
		while (distrib[maxIdx] != e) {
			int minIdx = minIdx(distrib, activities, maxIdx + 1, impactedTill);
			if (minIdx == -1) {
				break;
			}
			distrib[maxIdx]++;
			distrib[minIdx]--;
		}
		optim(e, r, n, activities, distrib, start, maxIdx - 1);
		optim(e, r, n, activities, distrib, impactedTill + 1, end);
	}
}
