package gcj;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;
import java.util.Stack;

public class Treasure {
	private static final class Solver {
		private int[] keysWeHave = new int[201];
		private int[] keysWeWouldHave = new int[201];
		private int n;
		private final class Chest {
			private final int idx;
			private final int keyToOpen;
			private final List<Integer> keysInside = new ArrayList<Integer>(400);
			private boolean sure;
			private boolean opened;
			private Chest(int keyToOpen, int idx) {
				this.keyToOpen = keyToOpen;
				keysWeWouldHave[keyToOpen]--;
				this.idx = idx;	
			}
			private boolean sure() {
				return sure;
			}
			private void add(int key) {
				if (key == keyToOpen) {
					sure = true;
				}
				keysWeWouldHave[key]++;
				keysInside.add(key);
			}
			private boolean canBeOpenedNow() {
				return (!opened && keysWeHave[keyToOpen] > 0);
			}
			private void open() {
				opened = true;
				keysWeHave[keyToOpen]--;
				for (Iterator<Integer> iterator = keysInside.iterator(); iterator.hasNext();) {
					keysWeHave[iterator.next()]++;
				}
			}
			private void close() {
				opened = false;
				keysWeHave[keyToOpen]++;
				for (Iterator<Integer> iterator = keysInside.iterator(); iterator.hasNext();) {
					keysWeHave[iterator.next()]--;
				}
			}
			public String toString() {
				return idx + "";
			}
		}
		private Chest[] trove;
		Solver(Scanner in) {
			int k = in.nextInt();
			n = in.nextInt();
			System.out.println("k = " +  k + " n=" + n);
			trove = new Chest[n];
			for (int i = 0; i < k; i++) {
				int key = in.nextInt();
				keysWeHave[key]++;
				keysWeWouldHave[key]++;
			}
			for (int i = 0; i < n; i++) {
				int keyToOpen = in.nextInt();
				int numberOfKeysInside = in.nextInt();
				trove[i] = new Chest(keyToOpen, i + 1);
				for (int j = 0; j < numberOfKeysInside; j++) {
					trove[i].add(in.nextInt());
				}
			}
		}
		public String solve() {
			for (int i = 0; i < 201; i++) {
				if (keysWeWouldHave[i] < 0) {
					System.out.println(keysWeWouldHave[i]+" impossible after preliminar check we don't have enough " + i);
					return "IMPOSSIBLE";
				}
			}
			for (int i = 0; i < keysWeHave.length; i++) {
				if (keysWeHave[i] > 0) {
					System.out.println("keyWeHave " + i + " ntimes=" + keysWeHave[i] + " out of " + keysWeWouldHave[i]);
				}
			}
			for (int i = 0; i < trove.length; i++) {
				System.out.println(trove[i] + " keyToOpen=" + trove[i].keyToOpen + " keysInside.size()=" + trove[i].keysInside.size());
			}
			Stack<Chest> stack = new Stack<Chest>();
			if (!treat(0, stack, true)) {
				return "IMPOSSIBLE";
			} else {
				StringBuilder sb = new StringBuilder();
				for (int i = 0; i < n; i++) {
					sb.append(stack.get(i));
					if (i != n -1) {
						sb.append(' ');
					}
				}
				return sb.toString();
			}
		}
		boolean treat(int rank, Stack<Chest> stack, boolean beginning) {
			rank++;
			if (stack.size() == n) {
				return true;
			}
			////////////
			for (int i = 0; i < n; i++) {
				if (!trove[i].opened && keysWeHave[trove[i].keyToOpen] == 0) {
					boolean atleastOnce = false;
					for (int j = 0; j < n; j++) {
						if (i != j && !trove[j].opened) {
							if (trove[j].keysInside.contains(trove[i].keyToOpen)) {
								atleastOnce = true;
								break;
							}
						}
					}
					if (!atleastOnce) {
						return false;
					}
				}
			}
			////////////
			/*System.out.print("stack content:" +stack.size() + ": ");
			for (Iterator<Chest> iterator = stack.iterator(); iterator.hasNext();) {
				System.out.print(iterator.next());
			}
			System.out.println();*/
			for (int i = 0; i < n; i++) {
				//System.out.println(stack.size() + " current item=" + trove[i] + " o " + trove[i].opened);
				if (trove[i].canBeOpenedNow()) {
					trove[i].open();
					stack.add(trove[i]);
					if (treat(rank, stack, beginning)) {
						return true;
					}
					stack.pop();
					trove[i].close();
					if (trove[i].sure()) {
						break;
					}
				}
			}
			return false;
		}
	}
	private static BufferedWriter out;
	public static void main(String[] args) throws Exception {
		String name = "D-small";
		Scanner in = new Scanner(new File("C:\\Users\\m\\Desktop\\training\\"+name+".in"));
		FileWriter fw = new FileWriter("C:\\Users\\m\\Desktop\\training\\"+name+".out");
		out = new BufferedWriter(fw);
		int t = in.nextInt();
		for (int k = 0; k < t; k++) {
			System.out.println("-------solve " + k);
			Solver s = new Solver(in);
			String r = s.solve();
			System.out.println("Case #" + (k + 1) + ": " + r);
			out.write("Case #" + (k + 1) + ": " + r);
			out.newLine();
		}
		out.flush();
		out.close();
	}
}
