package jam.C;

import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;

import com.google.common.base.Charsets;
import com.google.common.base.Stopwatch;
import com.google.common.io.Files;

public class C5 {
	public C5() throws Exception {
		Stopwatch globalStopWatch = new Stopwatch();
		globalStopWatch.start();
		for (String fileName : fileNames()) {
			Stopwatch localStopWatch = new Stopwatch();
			localStopWatch.start();
			// Generates the input data structure or uses the serialized data if
			// available
			int index = 0;
			List<String> input = Files.readLines(new File("resources/C/in/" + fileName + ".in"), Charsets.UTF_8);
			int cases = Integer.valueOf(input.get(index++));
			List<String> output = new ArrayList<>();
			List<BigInteger> values = values();
			for (int i = 0; i < cases; i++) {
				StringBuilder builder = new StringBuilder("Case #").append((i + 1)).append(": ");
				String[] split = input.get(index++).split("\\s");
				BigInteger min = new BigInteger(split[0]);
				BigInteger max = new BigInteger(split[1]);
				long counter = 0;
				for (BigInteger value : values) {
					if (value.min(min).equals(min) && value.max(max).equals(max)) {
						// System.out.println("palin: " + value);
						counter++;
					}
					// else if()
				}
				builder.append(counter);
				output.add(builder.toString());
			}

			writeOutput(fileName, output);
			System.out.println("run : " + fileName);
			System.out.println("testcase runtime: " + localStopWatch.stop());
			System.out.println("--------------------------");
		}
		System.out.println("global runtime: " + globalStopWatch.stop());
	}

	private List<BigInteger> values() throws IOException {
		List<String> strings = Files.readLines(new File("resources/C/out/mighty.out"), Charsets.UTF_8);

		List<BigInteger> values = new ArrayList<>();
		for (String str : strings) {
			values.add(new BigInteger(str));
		}
		// values.add(new BigInteger("121"));
		// values.add(new BigInteger("484"));
		// values.add(new BigInteger("10201"));
		// values.add(new BigInteger("12321"));
		// values.add(new BigInteger("14641"));
		// values.add(new BigInteger("40804"));
		// values.add(new BigInteger("44944"));
		// values.add(new BigInteger("1002001"));
		// values.add(new BigInteger("1234321"));
		// values.add(new BigInteger("4008004"));
		// values.add(new BigInteger("100020001"));
		// values.add(new BigInteger("102030201"));
		// values.add(new BigInteger("104060401"));
		// values.add(new BigInteger("121242121"));
		// values.add(new BigInteger("123454321"));
		// values.add(new BigInteger("125686521"));
		// values.add(new BigInteger("400080004"));
		// values.add(new BigInteger("404090404"));
		// values.add(new BigInteger("10000200001"));
		// values.add(new BigInteger("10221412201"));
		// values.add(new BigInteger("12102420121"));
		// values.add(new BigInteger("12345654321"));
		// values.add(new BigInteger("40000800004"));
		// values.add(new BigInteger("1000002000001"));
		// values.add(new BigInteger("1002003002001"));
		// values.add(new BigInteger("1004006004001"));
		// values.add(new BigInteger("1020304030201"));
		// values.add(new BigInteger("1022325232201"));
		// values.add(new BigInteger("1024348434201"));
		// values.add(new BigInteger("1210024200121"));
		// values.add(new BigInteger("1212225222121"));
		// values.add(new BigInteger("1214428244121"));
		// values.add(new BigInteger("1232346432321"));
		// values.add(new BigInteger("1234567654321"));
		// values.add(new BigInteger("4000008000004"));
		// values.add(new BigInteger("4004009004004"));
		return values;
	}

	private String[] fileNames() {
		return new String[] { "5" };
	}

	private void writeOutput(String fileName, List<String> data) throws IOException {
		// Files.newWriter(file, charset)
		BufferedWriter writer = Files.newWriter(new File("resources/C/out/" + fileName + ".out"), Charset.forName("utf8"));
		for (String line : data) {
			writer.write(line.concat("\n"));
		}
		writer.close();
	}

	public static void main(String[] args) throws Exception {
		new C5();
	}

}
