package jam.C;

import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.List;

import ch.lang.IntUtils;

import com.google.common.base.Charsets;
import com.google.common.base.Stopwatch;
import com.google.common.io.Files;

/**
 * 
 * @author Mathias
 * 
 */
public class C {

	public C() throws Exception {
		Stopwatch globalStopWatch = new Stopwatch();
		globalStopWatch.start();
		for (String fileName : fileNames()) {
			Stopwatch localStopWatch = new Stopwatch();
			localStopWatch.start();
			// Generates the input data structure or uses the serialized data if
			// available
			int index = 0;
			List<String> input = Files.readLines(new File("resources/C/in/" + fileName + ".in"), Charsets.UTF_8);
			int cases = Integer.valueOf(input.get(index++));
			List<String> output = new ArrayList<>();
			for (int i = 0; i < cases; i++) {
				System.out.println("case: " + (i + 1));
				StringBuilder builder = new StringBuilder("Case #").append((i + 1)).append(": ");
				String[] split = input.get(index++).split("\\s");
				BigInteger min = new BigInteger(split[0]);
				BigInteger max = new BigInteger(split[1]);
				BigInteger minS = sqrt(min);
				BigInteger maxS = sqrt(max);
				int pallin = 0;
				// if(min.equals(BigInteger.ONE))
				// pallin++;
				if (!minS.pow(2).equals(min))
					minS = minS.add(BigInteger.ONE);
//				if (!maxS.pow(2).equals(max))
					maxS = maxS.add(BigInteger.ONE);
				// System.out.println(minS);
				// System.out.println(maxS);
				for (BigInteger val = minS; !val.equals(maxS); val = val.add(BigInteger.ONE)) {
					// System.out.println("iteration: "+val);
					if (isPalindrom(val)) {
						BigInteger quad = val.pow(2);
						if (isPalindrom(quad)) {
							pallin++;
							System.out.println("Is paling: " + val);
						}
					}
				}
				builder.append(pallin);
				output.add(builder.toString());
			}

			writeOutput(fileName, output);
			System.out.println("run : " + fileName);
			System.out.println("testcase runtime: " + localStopWatch.stop());
			System.out.println("--------------------------");
		}
		System.out.println("global runtime: " + globalStopWatch.stop());
	}

	private boolean isPalindrom(BigInteger val) {
		String number = val.toString();
		if (number.length() != 1) {
			int length = number.length() / 2;
			char[] sub1 = number.substring(0, length).toCharArray();
			char[] sub2 = null;
			if (number.length() % 2 == 1)
				sub2 = number.substring(length + 1).toCharArray();
			else
				sub2 = number.substring(length).toCharArray();
			sub2 = reverse(sub2);
			for (int i = 0; i < length; i++) {
				if (sub1[i] != sub2[i]) {
					return false;
				}
			}
			return true;
		} else {
			return true;
		}
	}

	private char[] reverse(char[] chars) {
		char[] reverse = new char[chars.length];
		for (int i = 0; i < chars.length; i++) {
			reverse[i] = chars[chars.length - i - 1];
		}
		return reverse;
	}

	public BigInteger sqrt(BigInteger x) {
		if (x.compareTo(BigInteger.ONE) < 0)
			return BigInteger.ZERO.subtract(BigInteger.ONE);
		BigInteger low, hi, tmp, two;
		low = BigInteger.ONE;
		two = hi = tmp = new BigInteger("2");
		while (x.divide(tmp).compareTo(tmp) > 0) {
			low = tmp;
			tmp = tmp.multiply(two);
		} // verdopple tmp bis es grsser als die Wurzel ist
		if (x.divide(tmp).compareTo(tmp) == 0)
			return tmp;
		while (low.compareTo(tmp) != 0) {
			if (x.divide(tmp).compareTo(tmp) < 0)
				hi = tmp;
			else
				low = tmp;
			tmp = low.add(hi).divide(two);
		} // Binary Search abwrts
		return tmp;
	}

	private String[] fileNames() {
		return new String[] { "1" };
	}

	private void writeOutput(String fileName, List<String> data) throws IOException {
		// Files.newWriter(file, charset)
		BufferedWriter writer = Files.newWriter(new File("resources/C/out/" + fileName + ".out"), Charset.forName("utf8"));
		for (String line : data) {
			writer.write(line.concat("\n"));
		}
		writer.close();
	}

	public static void main(String[] args) throws Exception {
		new C();
	}

}
