package jam.D;

import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import org.apache.commons.lang3.mutable.MutableInt;

import ch.lang.IntUtils;

import com.google.common.base.Charsets;
import com.google.common.base.Stopwatch;
import com.google.common.io.Files;

public class D2 {
	public D2() throws Exception {
		Stopwatch globalStopWatch = new Stopwatch();
		globalStopWatch.start();
		for (String fileName : fileNames()) {
			Stopwatch localStopWatch = new Stopwatch();
			localStopWatch.start();
			// Generates the input data structure or uses the serialized data if
			// available
			int index = 0;
			List<String> input = Files.readLines(new File("resources/D/in/" + fileName + ".in"), Charsets.UTF_8);
			int cases = Integer.valueOf(input.get(index++));
			List<String> output = new ArrayList<>();
			System.out.println(cases);
			for (int i = 0; i < cases; i++) {
				this.builder = new StringBuilder();
				System.out.println("case: " + (i + 1));
				StringBuilder builder = new StringBuilder("Case #").append((i + 1)).append(":");
				int[] config = IntUtils.spaceSeparated(input.get(index++));
				int chests = config[1];
				int[] keyTypes = IntUtils.spaceSeparated(input.get(index++));
				ChestConfig chestConfig = new ChestConfig(keyTypes);
				for (int chest = 0; chest < chests; chest++) {
					int[] chestConfigArray = IntUtils.spaceSeparated(input.get(index++));
					int keysInChest = chestConfigArray[1];
					int[] keyTypesInChest = new int[keysInChest];
					for (int inChestKey = 0; inChestKey < keysInChest; inChestKey++) {
						keyTypesInChest[inChestKey] = chestConfigArray[inChestKey + 2];
					}
					Chest ch = new Chest((chest + 1), chestConfigArray[0], keyTypesInChest);
					chestConfig.getClosedChests().add(ch);
				}
				invalid = new HashMap<>();
				run(chestConfig, new MutableInt(0), 1, "", (i + 1) == 4);
				if (this.builder.length() > 0)
					builder.append(this.builder.toString());
				else
					builder.append(" IMPOSSIBLE");
				output.add(builder.toString());
			}

			writeOutput(fileName, output);
			System.out.println("run : " + fileName);
			System.out.println("testcase runtime: " + localStopWatch.stop());
			System.out.println("--------------------------");
		}
		System.out.println("global runtime: " + globalStopWatch.stop());
	}

	private StringBuilder builder = new StringBuilder();
	private HashMap<Integer, Set<BackTrackChest>> invalid = new HashMap<>();

	public boolean run(ChestConfig chestConfig, MutableInt counter, int level, String trace, boolean logging) {
		// if (logging)
		// System.out.println("trace: " + trace);
		if (!solvable(chestConfig))
			return false;
		// if (invalid.containsKey(level) &&
		// invalid.get(level).contains(chestConfig.getBackTrackChest())) {
		// counter.add(1);
		// return false;
		// }
		if (chestConfig.getClosedChests().size() == 0) {
			for (Chest chest : chestConfig.getOpendChests()) {
				builder.append(" " + chest.getId());
				System.out.print(chest.getId() + " ");
			}
			return true;
		}
		for (Chest chest : chestConfig.getClosedChests()) {
			for (int key : chestConfig.getDistinctKeys()) {
				if (chest.getRequiredkey() == key) {
					ChestConfig copy = chestConfig.copy();
					copy.getKeys().remove((Integer) key);
					copy.getKeys().addAll(chest.getKeys());
					copy.setDistinctKeys(new HashSet<>(copy.getKeys()));
					copy.getClosedChests().remove(chest);
					copy.getOpendChests().add(chest);
					if (run(copy, counter, (level + 1), trace + " " + chest.getId(), logging)) {
						return true;
					}
				}
			}
		}
		// if (!invalid.containsKey(level))
		// invalid.put(level, new HashSet<BackTrackChest>());
		// if (!invalid.get(level).contains(chestConfig.getBackTrackChest())) {
		// counter.add(1);
		// if (invalid.get(level).size() > 200000) {
		// System.out.println("COUNTER-B: " + counter);
		// invalid.get(level).clear();
		// }
		// invalid.get(level).add(chestConfig.getBackTrackChest());
		// }
		return false;
	}

	private boolean solvable(ChestConfig chestConfig) {
		List<Integer> requiredKeys = new ArrayList<>();
		List<Integer> availableKeys = new ArrayList<>();
		availableKeys.addAll(chestConfig.getKeys());
		for (Chest chest : chestConfig.getClosedChests()) {
			requiredKeys.add(chest.getRequiredkey());
			availableKeys.addAll(chest.getKeys());
		}

		for (Chest chest : chestConfig.getClosedChests()) {
			for (int chestKey : chest.getKeys()) {
				int found = 0;
				for (int key : availableKeys) {
					if (chest.getRequiredkey() == key)
						found++;
				}
				if (found == 1 && chestKey == chest.getRequiredkey())
					availableKeys.remove((Integer) chestKey);
			}
		}
		for (Integer reqKey : requiredKeys) {
			if (availableKeys.contains(reqKey)) {
				availableKeys.remove(reqKey);
			} else
				return false;
		}
		return true;

	}

	private String[] fileNames() {
		return new String[] { "1" };
	}

	private void writeOutput(String fileName, List<String> data) throws IOException {
		BufferedWriter writer = Files.newWriter(new File("resources/d/out/" + fileName + ".out"), Charset.forName("utf8"));
		for (String line : data) {
			writer.write(line.concat("\n"));
		}
		writer.close();
	}

	public static void main(String[] args) throws Exception {
		new D2();
	}
}
