package jam.B;

import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import ch.lang.IntUtils;

import com.google.common.base.Charsets;
import com.google.common.base.Stopwatch;
import com.google.common.io.Files;

/**
 * 
 * @author Mathias
 * 
 */
public class B {

	@SuppressWarnings("unchecked")
	public B() throws Exception {
		Stopwatch globalStopWatch = new Stopwatch();
		globalStopWatch.start();
		for (String fileName : fileNames()) {
			Stopwatch localStopWatch = new Stopwatch();
			localStopWatch.start();
			// Generates the input data structure or uses the serialized data if
			// available
			List<String> input = Files.readLines(new File("resources/B/in/" + fileName + ".in"), Charsets.UTF_8);
			List<String> output = new ArrayList<>();
			int index = 0;
			int testCases = Integer.valueOf(input.get(0));
			input.remove(0);
			Set<Integer> heights = new HashSet<>();
			for (int i = 0; i < testCases; i++) {
				System.out.println("case: " + i);
				StringBuilder builder = new StringBuilder("Case #").append((i + 1)).append(": ");
				int[] coords = IntUtils.spaceSeparated(input.get(index++));
				int xMax = coords[0];
				int yMax = coords[1];
				int[][] field = new int[xMax][yMax];
				boolean[][] mark = new boolean[xMax][yMax];
				boolean markError = false;
				int markCounter = 0;
				int markDone = xMax * yMax;
				for (int x = 0; x < xMax; x++) {
					field[x] = IntUtils.spaceSeparated(input.get(index++));
					for (int y = 0; y < yMax; y++) {
						heights.add(field[x][y]);
					}
				}
				List<Integer> listHeights = new ArrayList<>(heights);
				Collections.sort(listHeights);
				for (int height : listHeights) {
					for (int x = 0; x < xMax; x++) {
						boolean valid = true;
						for (int y = 0; y < yMax; y++) {
							if (field[x][y] > height)
								valid = false;
						}
						if (valid) {
							for (int y = 0; y < yMax; y++) {
								if (!mark[x][y] && height == field[x][y]) {
									mark[x][y] = true;
									markCounter++;
								}
								if (!mark[x][y] && height > field[x][y]) {
									markError = true;
								}
							}
						}
					}
					if (!markError) {
						for (int y = 0; y < yMax; y++) {
							boolean valid = true;
							for (int x = 0; x < xMax; x++) {
								if (field[x][y] > height)
									valid = false;
							}
							if (valid) {
								for (int x = 0; x < xMax; x++) {
									if (!mark[x][y] && height == field[x][y]) {
										mark[x][y] = true;
										markCounter++;
									}
									if (!mark[x][y] && height > field[x][y]) {
										markError = true;
									}
								}
							}
						}
					}
					if (markCounter == markDone || markError) {
						break;
					}
				}
				if (markCounter == markDone) {
					builder.append("YES");
				} else {
					builder.append("NO");
				}
				// System.out.println(heights);
				output.add(builder.toString());
			}
			writeOutput(fileName, output);
			System.out.println("run : " + fileName);
			System.out.println("testcase runtime: " + localStopWatch.stop());
			System.out.println("--------------------------");
		}
		System.out.println("global runtime: " + globalStopWatch.stop());
	}

	private String[] fileNames() {
		return new String[] { "1" };
	}

	private void writeOutput(String fileName, List<String> data) throws IOException {
		// Files.newWriter(file, charset)
		BufferedWriter writer = Files.newWriter(new File("resources/B/out/" + fileName + ".out"), Charset.forName("utf8"));
		for (String line : data) {
			writer.write(line.concat("\n"));
		}
		writer.close();
	}

	public static void main(String[] args) throws Exception {
		new B();
	}

}
