package jam.A;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;

import ch.tree.Tree;
import ch.tree.TreeNode;
import ch.tree.TreeNodeNodeCountComparator;

import com.google.common.base.Charsets;
import com.google.common.base.Stopwatch;
import com.google.common.io.Files;

/**
 * 
 * @author Mathias
 * 
 */
public class A {

	@SuppressWarnings("unchecked")
	public A() throws Exception {
		Stopwatch globalStopWatch = new Stopwatch();
		globalStopWatch.start();
		for (String fileName : fileNames()) {
			Stopwatch localStopWatch = new Stopwatch();
			localStopWatch.start();
			// Generates the input data structure or uses the serialized data if
			// available
			List<String> input = Files.readLines(new File("resources/A/in/" + fileName + ".in"), Charsets.UTF_8);
			int cases = Integer.valueOf(input.get(0));
			input.remove(0);
			List<String> output = new ArrayList<>();
			System.out.println(cases);
			for (int i = 0; i < cases; i++) {
				StringBuilder builder = new StringBuilder("Case #").append((i + 1)).append(": ");
				char[][] field = new char[4][4];
				for (int line = 0; line < 4; line++) {
					field[line] = input.get(0).toCharArray();
					input.remove(0);
				}
				if (input.size() > 0)
					input.remove(0);
				char won = 'N';
				for (int x = 0; x < 4; x++) {
					if (complete(field[x], 'X'))
						won = 'X';
					else if (complete(field[x], 'O'))
						won = 'O';
					if (won != 'N') {
						builder.append(won).append(" won");
						break;
					}
				}
				if (won == 'N') {
					for (int x = 0; x < 4; x++) {
						char[] row = new char[] { field[0][x], field[1][x], field[2][x], field[3][x] };
						if (complete(row, 'X'))
							won = 'X';
						else if (complete(row, 'O'))
							won = 'O';
						if (won != 'N') {
							builder.append(won).append(" won");
							break;
						}
					}
				}
				if (won == 'N') {
					char[] row = new char[] { field[0][0], field[1][1], field[2][2], field[3][3] };
					if (complete(row, 'X'))
						won = 'X';
					else if (complete(row, 'O'))
						won = 'O';
					if (won != 'N') {
						builder.append(won).append(" won");
					}
				}
				if (won == 'N') {
					char[] row = new char[] { field[0][3], field[1][2], field[2][1], field[3][0] };
					if (complete(row, 'X'))
						won = 'X';
					else if (complete(row, 'O'))
						won = 'O';
					if (won != 'N') {
						builder.append(won).append(" won");
					}
				}
				if (won == 'N') {
					for (int x = 0; x < 4; x++) {
						for (int y = 0; y < 4; y++) {
							if (field[x][y] == '.') {
								builder.append("Game has not completed");
								won = '.';
								break;
							}
						}
						if (won != 'N')
							break;
					}
				}
				if (won == 'N') {
					builder.append("Draw");
				}
				// builder.append(Arra)
				output.add(builder.toString());
			}

			writeOutput(fileName, output);
			System.out.println("run : " + fileName);
			System.out.println("testcase runtime: " + localStopWatch.stop());
			System.out.println("--------------------------");
		}
		System.out.println("global runtime: " + globalStopWatch.stop());
	}

	private boolean complete(char[] check, char verify) {
		boolean valid = true;
		for (char c : check) {
			if (c != verify && c != 'T') {
				valid = false;
			}

		}
		return valid;
	}

	private String[] fileNames() {
		return new String[] { "1" };
	}

	private void writeOutput(String fileName, List<String> data) throws IOException {
		// Files.newWriter(file, charset)
		BufferedWriter writer = Files.newWriter(new File("resources/A/out/" + fileName + ".out"), Charset.forName("utf8"));
		for (String line : data) {
			writer.write(line.concat("\n"));
		}
		writer.close();
	}

	private HashMap<Character, Character> mapping() {
		HashMap<Character, Character> mapping = new HashMap<>();
		mapping.put('f', 'c');
		mapping.put('g', 'v');
		mapping.put('e', 'o');
		mapping.put('b', 'h');
		mapping.put('f', 'c');
		mapping.put('c', 'e');
		mapping.put('a', 'y');
		mapping.put('n', 'b');
		mapping.put('o', 'k');
		mapping.put('l', 'g');
		mapping.put('m', 'l');
		mapping.put('j', 'u');
		mapping.put('k', 'i');
		mapping.put('h', 'x');
		mapping.put('i', 'd');
		mapping.put('w', 'f');
		mapping.put('v', 'p');
		mapping.put('u', 'j');
		mapping.put('t', 'w');
		mapping.put('s', 'n');
		mapping.put('r', 't');
		mapping.put('p', 'r');
		mapping.put('y', 'a');
		mapping.put('x', 'm');
		mapping.put('d', 's');
		mapping.put('z', 'q');
		mapping.put('q', 'z');
		mapping.put(' ', ' ');
		return mapping;
	}

	public static void main(String[] args) throws Exception {
		new A();
	}

}
