package tictactoe;

public class Position {

    public static final char X = 'X';
    public static final char O = 'O';
    public static final char T = 'T';
    public static final char EMPTY = '.';
    public static final char ERROR = 'e';
    public static final String TT = "T";
    public static final String OO = "O";
    public static final String XX = "X";
    public static final String EEMPTY = ".";

    private String map;

    private int countX = -1;
    private int countO = -1;
    private int countT = -1;

    public Position(String map) {
        this.map = map;
    }

    public char get(int index) {
        if (index < 0 || index > 15) {
            return ERROR;
        } else {
            return map.charAt(index);
        }
    }

    public boolean checkX(int a, int b, int c, int d) {
        return check(X, a, b, c, d);
    }

    public boolean checkO(int a, int b, int c, int d) {
        return check(O, a, b, c, d);
    }

    public boolean check(char sign, int a, int b, int c, int d) {
        int value = map.charAt(a);
        if (value != sign && value != T) {
            return false;
        }
        value = map.charAt(b);
        if (value != sign && value != T) {
            return false;
        }
        value = map.charAt(c);
        if (value != sign && value != T) {
            return false;
        }
        value = map.charAt(d);
        if (value != sign && value != T) {
            return false;
        }
        return true;
    }

    public char get(int x, int y) {
        if (x < 0 || x > 3 || y < 0 || y > 3) {
            return ERROR;
        } else {
            return map.charAt(y * 4 + x);
        }
    }

    public int count(String value) {
        if (value == XX) {
            if (countX == -1) {
                countXOT();
            }
            return countX;
        } else if (value == OO) {
            if (countO == -1) {
                countXOT();
            }
            return countO;
        } else if (value == EEMPTY) {
            if (countX == -1) {
                countXOT();
            }
            return 16 - countT - countX - countO;
        } else {
            if (countT == -1) {
                countXOT();
            }
            return countT;
        }
    }

    private void countXOT() {
        countX = 0;
        countO = 0;
        countT = 0;
        for (int i = 0; i < 16; i++) {
            if (map.charAt(i) == X) {
                countX++;
            } else if (map.charAt(i) == O) {
                countO++;
            } else if (map.charAt(i) == T) {
                countT++;
            }
        }
    }
}
