package tictactoe;

import java.io.*;

public class TicTacToeTomek {

    public static int N;

    public static void main(String[] args) {
        Position[] positions = read(new File("C:\\Dev\\GCJ\\src\\tictactoe\\A-large.in"));
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter(new File("C:\\Dev\\GCJ\\src\\tictactoe\\result.out")));
            for (int i = 0; i < N; i++) {
                String result = "Case #" + (i + 1) + ": " + resolvePosition(positions[i]) + "\n";
                out.write(result);
            }
            out.close();
        } catch (IOException e) {
            System.out.println("Error when processing file 2");
        }
    }

    public static Position[] read(File file) {
        try {
            BufferedReader br = new BufferedReader(new FileReader(file));
            String line = br.readLine();
            N = Integer.valueOf(line);
            Position[] positions = new Position[N];
            for (int i = 0; i < N; i++) {
                //read N times
                StringBuilder position = new StringBuilder();
                position.append(br.readLine()).append(br.readLine()).append(br.readLine()).append(br.readLine());
                positions[i] = new Position(position.toString());
                //read empty line
                br.readLine();
            }
            br.close();
            return positions;
        } catch (IOException e) {
            System.out.println("Error when processing file 1");
            return null;
        }
    }

    public static Status resolvePosition(Position position) {
        boolean xWinPossible = true;
        boolean oWinPossible = true;
        boolean drawPossible = true;
        boolean incompletePossible = true;
        int os = position.count(Position.OO);
        int xs = position.count(Position.XX);
        int ts = position.count(Position.TT);
        if (os + ts < 4) {
            oWinPossible = false;
        }
        if (xs + ts < 4) {
            xWinPossible = false;
        }
        if (position.count(Position.EEMPTY) > 0) {
            if (!oWinPossible && !xWinPossible) {
                return Status.INCOMPLETE;
            }
            drawPossible = false;
            //X_WIN or O_WIN
            if (xWin(position)) {
                return Status.X_WON;
            } else if (oWin(position)) {
                return Status.O_WON;
            } else {
                return Status.INCOMPLETE;
            }
        } else {
            incompletePossible = false;
            //X_WIN or O_WIN or DRAW
            if (xWin(position)) {
                return Status.X_WON;
            } else if (oWin(position)) {
                return Status.O_WON;
            } else {
                return Status.DRAW;
            }
        }
    }

    public static boolean xWin(Position position) {
        return win(position, Position.X);
    }

    public static boolean oWin(Position position) {
        return win(position, Position.O);
    }

    public static boolean win(Position position, char sign) {
        //check horizontal
        if (position.check(sign, 0, 1, 2, 3)) {
            return true;
        }
        if (position.check(sign, 4, 5, 6, 7)) {
            return true;
        }
        if (position.check(sign, 8, 9, 10, 11)) {
            return true;
        }
        if (position.check(sign, 12, 13, 14, 15)) {
            return true;
        }
        //check vertical
        if (position.check(sign, 0, 4, 8, 12)) {
            return true;
        }
        if (position.check(sign, 1, 5, 9, 13)) {
            return true;
        }
        if (position.check(sign, 2, 6, 10, 14)) {
            return true;
        }
        if (position.check(sign, 3, 7, 11, 15)) {
            return true;
        }
        //check diagonal
        if (position.check(sign, 0, 5, 10, 15)) {
            return true;
        }
        if (position.check(sign, 3, 6, 9, 12)) {
            return true;
        }
        return false;
    }


}
