package lawn;
import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class Main {

    private static int N;

    public static void main(String[] args) {
        Lawn[] lawns = read(new File("C:\\Dev\\GCJ\\src\\lawn\\B-large.in"));
        boolean[] results = process(lawns);
        write(results);
    }

    public static boolean[] process(Lawn[] lawns) {
        boolean[] results = new boolean[N];
        for (int i = 0; i < N; i++) {
            results[i] = process(lawns[i]);
        }
        return results;
    }

    public static boolean process(Lawn lawn) {
        while (true) {
            int a = 1;
            for (int j = 0; j < lawn.values.size();) {
                if (lawn.values.get(j).isEmpty()) {
                    lawn.values.remove(j);
                } else {
                    j++;
                }
            }
            if (lawn.values.isEmpty()) {
                return true;
            }
            Lawn.Min min = lawn.getMin();
            boolean okColumn = true;
            boolean okRow = true;
            int columnCount = 0;
            int rowCount = 0;
            //check row
            List<Integer> minRow = lawn.values.get(min.minRow);
            for (int i = 0; i < minRow.size(); i++) {
                if (minRow.get(i) == min.minValue) {
                    rowCount++;
                }
            }
            if (rowCount != minRow.size()) {
                okRow = false;
            }
            //check column
            for (int i = 0; i < lawn.values.size(); i++) {
                if (lawn.values.get(i).get(min.minColumn) == min.minValue) {
                    columnCount++;
                }
            }
            if (columnCount != lawn.values.size()) {
                okColumn = false;
            }
            if (!okColumn && !okRow) {
                return false;
            }
            if (okColumn) {
                lawn.removeColumn(min.minColumn);
            } else if (okRow) {
                lawn.removeRow(min.minRow);
            }
        }
    }

    public static Lawn[] read(File file) {
        try {
            BufferedReader br = new BufferedReader(new FileReader(file));
            String line = br.readLine();
            N = Integer.valueOf(line);
            Lawn[] lawns = new Lawn[N];
            //read N times
            for (int i = 0; i < N; i++) {
                String[] sides = br.readLine().split(" ");
                int a = Integer.valueOf(sides[0]);
                int b = Integer.valueOf(sides[1]);
                List<List<Integer>> values = new ArrayList<List<Integer>>();
                for (int j = 0; j < a; j++) {
                    values.add(new ArrayList<Integer>());
                    String[] side = br.readLine().split(" ");
                    for (int k = 0; k < b; k++) {
                        values.get(j).add(Integer.parseInt(side[k]));
                    }
                }
                lawns[i] = new Lawn(values);
            }
            br.close();
            return lawns;
        } catch (IOException e) {
            System.out.println("Error when processing file 1");
            return null;
        }
    }

    public static void write(boolean[] result) {
        try {
            BufferedWriter out = new BufferedWriter(new FileWriter(new File("C:\\Dev\\GCJ\\src\\lawn\\result.out")));
            for (int i = 0; i < N; i++) {
                String str = "Case #" + (i + 1) + ": " + (result[i] ? "YES" : "NO") + "\n";
                out.write(str);
            }
            out.close();
        } catch (IOException e) {
            System.out.println("Error when processing file 2");
        }
    }
}
