import java.util.*;

public class ProblemC {
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        final int T = in.nextInt();
        for (int i = 1; i <= T; i++) {
            int hD = in.nextInt();
            int aD = in.nextInt();
            int hK = in.nextInt();
            int aK = in.nextInt();
            int buff = in.nextInt();
            int debuff = in.nextInt();
            
            int result = simulate(hD, aD, hK, aK, buff, debuff);
            
            System.out.printf("Case #%d: %s%n",
                    i,
                    result > 0 ? String.valueOf(result) : "IMPOSSIBLE");
        }
    }
    
    private static int simulate(int hD, int aD, int hK, int aK, int b, int d) {
        Queue<Round> q = new ArrayDeque<>();
        Set<Round> s = new HashSet<>();
        
        Round start = new Round();
        start.roundNum = 0;
        start.dragonHealth = start.dragonMaxHealth = hD;
        start.dragonAttack = aD;
        start.knightHealth = hK;
        start.knightAttack = aK;
        start.buff = b;
        start.debuff = d;
        
        q.add(start);
        
        while (!q.isEmpty()) {
            Round r = q.remove();
            List<Round> nextRounds = r.tryTurn();
            for (Round rnd : nextRounds) {
                if (rnd.knightDead()) {
                    return rnd.roundNum;
                }
            }
            nextRounds.removeAll(s);
            if (s.addAll(nextRounds)) {
                q.addAll(nextRounds);
            }
        }
        
        return 0;
    }
    
    private static class Round {

        @Override
        public int hashCode() {
            int hash = 7;
            hash = 19 * hash + this.dragonHealth;
            hash = 19 * hash + this.knightHealth;
            hash = 19 * hash + this.dragonAttack;
            hash = 19 * hash + this.knightAttack;
            return hash;
        }

        @Override
        public boolean equals(Object obj) {
            if (this == obj) {
                return true;
            }
            if (obj == null) {
                return false;
            }
            if (getClass() != obj.getClass()) {
                return false;
            }
            final Round other = (Round) obj;
            if (this.dragonHealth != other.dragonHealth) {
                return false;
            }
            if (this.knightHealth != other.knightHealth) {
                return false;
            }
            if (this.dragonAttack != other.dragonAttack) {
                return false;
            }
            if (this.knightAttack != other.knightAttack) {
                return false;
            }
            return true;
        }
        
        public int roundNum;
        public int dragonMaxHealth;
        public int buff;
        public int debuff;
        public int dragonHealth;
        public int knightHealth;
        public int dragonAttack;
        public int knightAttack;
        
        public Round next() {
            Round r = new Round();
            r.roundNum = this.roundNum + 1;
            r.dragonMaxHealth = this.dragonMaxHealth;
            r.buff = this.buff;
            r.debuff = this.debuff;
            r.dragonHealth = this.dragonHealth;
            r.knightHealth = this.knightHealth;
            r.dragonAttack = this.dragonAttack;
            r.knightAttack = this.knightAttack;
            return r;
        }
        
        public List<Round> tryTurn() {
            List<Round> rounds = new ArrayList<>(4);
            rounds.add(next().dragonAttack().knightAttack());
            rounds.add(next().dragonBuff().knightAttack());
            rounds.add(next().dragonCure().knightAttack());
            rounds.add(next().dragonDebuff().knightAttack());
            Iterator<Round> itr = rounds.iterator();
            while (itr.hasNext()) {
                if (itr.next().dragonDead()) {
                    itr.remove();
                }
            }
            return rounds;
        }
        
        public boolean dragonDead() {
            return dragonHealth < 0;
        }
        
        public boolean knightDead() {
            return knightHealth < 0;
        }
        
        public Round dragonAttack() {
            knightHealth -= dragonAttack;
            return this;
        }
        
        public Round dragonBuff() {
            dragonAttack += buff;
            return this;
        }
        
        public Round dragonCure() {
            dragonHealth = dragonMaxHealth;
            return this;
        }
        
        public Round dragonDebuff() {
            knightAttack -= debuff;
            if (knightAttack < 0) knightAttack = 0;
            return this;
        }
        
        public Round knightAttack() {
            if (!knightDead()) {
                dragonHealth -= knightAttack;
            }
            return this;
        }
    }
}