package com.code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Main {
	public static void main(String[] args) {
		BufferedReader bufferedReader = null;
		BufferedWriter bufferedWriter = null;
		try {
			bufferedReader = new BufferedReader(new FileReader("F:\\input.in"));

			File file = new File("F:\\output.out");

			if (!file.exists()) {
				file.createNewFile();
			}

			FileWriter fileWriter = new FileWriter(file.getAbsoluteFile());
			bufferedWriter = new BufferedWriter(fileWriter);

			int T = Integer.valueOf(bufferedReader.readLine());
			for (int i = 1; i <= T; i++) {

				String line = bufferedReader.readLine();
				int N = Integer.valueOf(line);

				List<String> strings = new ArrayList<String>();
				for (int j = 0; j < N; j++) {
					strings.add(bufferedReader.readLine());
				}

				String singleWorld = null;
				List<List<Integer>> allCharCounts = new ArrayList<List<Integer>>();

				boolean isPossible = true;
				for (String string : strings) {

					Character lastChar = null;
					List<Integer> charCounts = new ArrayList<Integer>();
					String currentSingleWorld = "";

					for (int j = 0; j < string.length(); j++) {

						char charAt = string.charAt(j);
						if (lastChar == null || !lastChar.equals(charAt)) {
							lastChar = charAt;
							charCounts.add(1);
							currentSingleWorld = currentSingleWorld
									+ String.valueOf(charAt);
						} else {
							int index = charCounts.size() - 1;
							charCounts.set(index, charCounts.get(index) + 1);
						}
					}

					if (singleWorld != null
							&& !singleWorld.equals(currentSingleWorld)) {
						isPossible = false;
						break;
					} else {
						singleWorld = currentSingleWorld;
						allCharCounts.add(charCounts);
					}
				}

				if (isPossible) {
					int stepsCount = 0;
					for (int j = 0; j < singleWorld.length(); j++) {
						int sum = 0;
						for (List<Integer> list : allCharCounts) {
							sum += list.get(j);
						}

						double avg = sum * 1.0f / N;
						long roundedAvg = Math.round(avg);

						for (List<Integer> list : allCharCounts) {
							long abs = Math.abs(list.get(j) - roundedAvg);
							stepsCount += abs;
						}
					}

					System.out.println("Case #" + i + " " + stepsCount + "\n");
					bufferedWriter.write("Case #" + i + ":\n");
				} else {
					System.out.println("Case #" + i + " " + "Fegla Won");
					bufferedWriter.write("Case #" + i + "Fegla Won");
				}

			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (bufferedReader != null) {
				try {
					bufferedReader.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (bufferedWriter != null) {
				try {
					bufferedWriter.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
