package com.code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.List;

public class Main {

	public static class Quaternions {
		private Type type;
		private int sign = 1;

		public Quaternions(Type type) {
			this.type = type;
		}

		public Quaternions(Type type, int sign) {
			this.type = type;
			this.sign = sign;
		}

		private void multiply(Quaternions b) {
			this.sign *= b.sign;
			
			if (this.type == Type.l) {
				if (b.type == Type.l) {
					this.type = Type.l;
					return;
				}
				if (b.type == Type.i) {
					this.type = Type.i;
					return;
				}
				if (b.type == Type.j) {
					this.type = Type.j;
					return;
				}
				if (b.type == Type.k) {
					this.type = Type.k;
					return;
				}
			}
			if (this.type == Type.i) {
				if (b.type == Type.l) {
					this.type = Type.i;
					return;
				}
				if (b.type == Type.i) {
					this.type = Type.l;
					this.sign *= -1;
					return;
				}
				if (b.type == Type.j) {
					this.type = Type.k;
					return;
				}
				if (b.type == Type.k) {
					this.type = Type.j;
					this.sign *= -1;
					return;
				}
			}
			if (this.type == Type.j) {
				if (b.type == Type.l) {
					this.type = Type.j;
					return;
				}
				if (b.type == Type.i) {
					this.type = Type.k;
					this.sign *= -1;
					return;
				}
				if (b.type == Type.j) {
					this.type = Type.l;
					this.sign *= -1;
					return;
				}
				if (b.type == Type.k) {
					this.type = Type.i;
					return;
				}
			}
			if (this.type == Type.k) {
				if (b.type == Type.l) {
					this.type = Type.k;
					return;
				}
				if (b.type == Type.i) {
					this.type = Type.j;
					return;
				}
				if (b.type == Type.j) {
					this.type = Type.i;
					this.sign *= -1;
					return;
				}
				if (b.type == Type.k) {
					this.type = Type.l;
					return;
				}
			}
		}

	}

	private enum Type {
		i, j, k, l;
	}

	public static void main(String[] args) {
		BufferedReader bufferedReader = null;
		BufferedWriter bufferedWriter = null;
		try {
			bufferedReader = new BufferedReader(new FileReader(
					"C:\\codejam\\input.in"));
			File file = new File("C:\\codejam\\output.out");

			if (!file.exists()) {
				file.createNewFile();
			}

			FileWriter fileWriter = new FileWriter(file.getAbsoluteFile());
			bufferedWriter = new BufferedWriter(fileWriter);

			int T = Integer.valueOf(bufferedReader.readLine());
			for (int i = 1; i <= T; i++) {

				String line = bufferedReader.readLine();
				String[] input = line.split(" ");
				int l = Integer.valueOf(input[0]);
				int x = Integer.valueOf(input[1]);

				line = bufferedReader.readLine();
				String line_ = line;
				for (int j = 0; j < x - 1; j++) {
					line = line + line_;
				}

				Type[] quats = new Type[line.length()];
				for (int j = 0; j < line.length(); j++) {
					quats[j] = Type.valueOf(String.valueOf(line
							.charAt(j)));
				}

				check(bufferedWriter, i, quats);

			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (bufferedReader != null) {
				try {
					bufferedReader.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (bufferedWriter != null) {
				try {
					bufferedWriter.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private static void check(BufferedWriter bufferedWriter, int i, Type[] quats)
			throws IOException {
		Quaternions first = new Quaternions(Type.l);
		Quaternions second = new Quaternions(Type.l);
		Quaternions third = new Quaternions(Type.l);

		for (int j = 0; j < quats.length; j++) {
			first.multiply(new Quaternions(quats[j]));
			if (first.type == Type.i && first.sign == 1) {
				for (int j2 = j + 1; j2 < quats.length; j2++) {
					second.multiply(new Quaternions(quats[j2]));
					if (second.type == Type.j && second.sign == 1) {
						for (int j3 = j2 + 1; j3 < quats.length; j3++) {
							third.multiply(new Quaternions(quats[j3]));
							if (third.type == Type.k && third.sign == 1) {
								System.out.println("Case #" + i + ": "
										+ "YES" + "\n");
								bufferedWriter.write("Case #" + i
										+ ": " + "YES" + "\n");
								return;
							}
						}
					}
				}
			}
		}

		System.out.println("Case #" + i + ": " + "NO" + "\n");
		bufferedWriter.write("Case #" + i + ": " + "NO" + "\n");
	}
}
