import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class Problem3 {

	static int[][] visited;
	
	static int ret ;
	static int []sols;
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		Scanner scanner = new Scanner(new File("3.in"));
		PrintWriter writer = new PrintWriter("3.out");
		int T = scanner.nextInt();
		for (int i = 1 ; i <= T ; i++ ) {
			int M = scanner.nextInt();
			int N = scanner.nextInt();
			boolean [][]grid = new boolean[M][N];
			int count[][] = new int[M][N];
			visited = new int[M][N];
			for (int j = 0 ; j < M ; j++ ) {
				String line = scanner.next();
				for (int k = 0 ; k < N ; k+=4 ) {
					String tmp = new String();
					tmp += line.charAt(k/4);
					int tmpInt = Integer.parseInt(tmp, 16);
					grid[j][k] = (tmpInt & 8) == 8;
					grid[j][k+1] = (tmpInt & 4) == 4;
					grid[j][k+2] = (tmpInt & 2) == 2;
					grid[j][k+3] = (tmpInt & 1) == 1;
				}
			}
			
			writer.print("Case #" + i + ": ");
			solve(grid, count, M, N);
			writer.println(ret);
			for (int j = sols.length - 1 ; j >0 ; j--) {
				if (sols[j] != 0) writer.println(j + " " + sols[j]);
			}
		}
		writer.close();
		
	}

	private static void solve(boolean[][] grid, int[][] count, int m, int n) {
		
		ret = 0;
		sols = new int[Math.min(m, n) + 1];
		for (int i = 0 ; i < m ; i++) {
			for (int j = 0 ; j < n ; j++ ) {
				for (int gridSize = Math.min(m - i, n - j) ; gridSize > 0 ; gridSize-- ) {
					//get Max grid from here
					if (formBoard(grid, i, j, gridSize)) {
						count[i][j] = gridSize;
						break;
					}
				}
			}
		}
		while (true) {
			int max = -1;
			int row = -1;
			int col = -1;
			
			for (int i = 0 ; i < m ; i++) {
				for (int j = 0 ; j < n ; j++ ) {
					for (int k = count[i][j] ; k > 0 ; k-- )
						if ( k > max  && canPut(i, j, k)) {
							max = k;
							row = i;
							col = j;
							break;
						}
				}
			}
			
			if (max == -1) return;
			
			ret++;
			sols[max]++;
			for (int i = 0 ; i < max ; i++ ) {
				for (int j = 0 ; j < max ; j++ ) {
					visited[row + i][col + j] = 1;
				}
			}
		}
//		solveRecursive(0,0, count, grid, n,  m);	
	}

//	private static void solveRecursive(int row, int col, int[][] count,
//			boolean[][] grid, int n, int m) {
//		for (int i = 1 ; i < count[row][col] ; i++) {
//			boolean put = canPut(grid, n, m, row, col, i);
//			if (put) {
//				put(grid, n, m, row, col, i);
//			}
//			//put
//			if (col == n -1 )
//				solveRecursive(row+1, col, count, grid, n, m);
//			else
//				solveRecursive(row, col+1, count, grid, n, m);
//			//remove
//			if (put) {
//				remove(grid, n, m, row, col, i);
//			}
//		}
//	}

//	private static boolean canPut(boolean[][] grid, int n, int m, int row,
//			int col, int size) {
	private static boolean canPut( int row, int col, int size) {
		for (int i = 0 ; i < size ; i++ ) {
			for (int j = 0 ; j < size ; j++ ) {
				if (visited[i+row][j+col] != 0)
					return false;
			}
		}
		return true;
	}
	
	private static void put(boolean[][] grid, int n, int m, int row,
			int col, int size) {
		for (int i = 0 ; i < size ; i++ ) {
			for (int j = 0 ; j < size ; j++ ) {
				visited[i+row][j+col] = 1;
			}
		}
	}
	
	private static void remove(boolean[][] grid, int n, int m, int row,
			int col, int size) {
		for (int i = 0 ; i < size ; i++ ) {
			for (int j = 0 ; j < size ; j++ ) {
				visited[i+row][j+col] = 0;
			}
		}
	}

	private static boolean formBoard(boolean[][] grid, int row, int col,
			int gridSize) {
		
		//check for rows
		for (int i = 0 ; i < gridSize ; i++ ) {
			boolean expected = !grid[i + row][col];
			for (int j = 1 ; j < gridSize ; j++ ) {
				if (expected != grid[i+row][j+col]) return false;
				expected = !expected;
			}
		}
		
		//check for cols
		for (int i = 0 ; i < gridSize ; i++ ) {
			boolean expected = !grid[row][i + col];
			for (int j = 1 ; j < gridSize ; j++ ) {
				if (expected != grid[j+row][i+col]) return false;
				expected = !expected;
			}
		}
		return true;
	}

}
