import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import org.apache.commons.lang3.StringUtils;

public class FairAndSquare {

	static List<Long> palindromes;

	public static void main(String[] args) throws IOException {
		// A-small-attempt0.in
		Scanner sc = new Scanner(new File("data/C-large-1.in"));
		PrintWriter out = new PrintWriter(new File("src/output.txt"));

		generatePalindromes(1L, new Double(Math.pow(10, 15)).longValue());

		Integer count = sc.nextInt();
		log(count);

		for (int i = 1; i <= count; i++) {
			log(i);

			out.println("Case #" + i + ": "
					+ solve(sc.nextLong(), sc.nextLong()));
		}

		out.close();
	}

	private static void generatePalindromes(Long low, Long high) {
		log(low + " " + high);
		palindromes = new ArrayList<Long>();

		Long[] known = { 1L, 4L, 9L };
		for (Long p : known) {
			log("\t" + p);
			palindromes.add(p);
		}

		STOP: for (Long i = 1L; i <= high; i++) {
			// create palindrome
			for (Integer split = 0; split < 10; split++) {
				Long palindrome = Long.parseLong("" + i + split
						+ StringUtils.reverse(i.toString()));

				if (palindrome <= high
						&& isPalindrome(Math.sqrt(palindrome.doubleValue()))) {
					log("\t" + palindrome);
					palindromes.add(palindrome);
				}
			}
			if (Long.parseLong("" + i + "0" + StringUtils.reverse(i.toString())) > high) {
				break STOP;
			}
		}
	}

	private static int solve(Long low, Long high) {
		log(low + " " + high);
		Integer count = 0;

		for (Long p : palindromes) {
			if (p >= low && p <= high) {
				count++;
			}
			if (p > high) {
				break;
			}
		}

		return count;
	}

	private static boolean isPalindrome(Double n) {
		if (n == Math.floor(n)) {
			return isPalindrome(n.longValue());
		} else {
			return false;
		}
	}

	private static boolean isPalindrome(Long n) {
		if (n.toString().equals(StringUtils.reverse(n.toString()))) {
			return true;
		} else {
			return false;
		}
	}

	private static void log(Integer[][] input) {
		for (int ii = 0; ii < input.length; ii++) {
			for (int jj = 0; jj < input[0].length; jj++) {
				System.out.print((input[ii][jj]) + " ");
			}
			System.out.println("");
		}
	}

	private static void log(String s) {
		System.out.println(s);
	}

	private static void log(Integer i) {
		log(i.toString());
	}

	// http://stackoverflow.com/questions/295579/fastest-way-to-determine-if-an-integers-square-root-is-an-integer
	private final static boolean isPerfectSquare(long n) {
		if (n < 0)
			return false;

		switch ((int) (n & 0x3F)) {
		case 0x00:
		case 0x01:
		case 0x04:
		case 0x09:
		case 0x10:
		case 0x11:
		case 0x19:
		case 0x21:
		case 0x24:
		case 0x29:
		case 0x31:
		case 0x39:
			long sqrt;
			if (n < 410881L) {
				// John Carmack hack, converted to Java.
				// See: http://www.codemaestro.com/reviews/9
				int i;
				float x2, y;

				x2 = n * 0.5F;
				y = n;
				i = Float.floatToRawIntBits(y);
				i = 0x5f3759df - (i >> 1);
				y = Float.intBitsToFloat(i);
				y = y * (1.5F - (x2 * y * y));

				sqrt = (long) (1.0F / y);
			} else {
				// Carmack hack gives incorrect answer for n >= 410881.
				sqrt = (long) Math.sqrt(n);
			}
			return sqrt * sqrt == n;

		default:
			return false;
		}
	}
}
