import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class SpeakingInTongues {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new File("data/A-small-attempt1.in"));
		PrintWriter out = new PrintWriter(new File("data/output.txt"));

		String inputText = "qzejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv";
		String outputText = "zqour language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up";

		Map<String, String> dictionary = new HashMap<>();

		for (int c = 0; c < inputText.length(); c++) {
			dictionary.put(inputText.substring(c, c + 1),
					outputText.substring(c, c + 1));
		}

		Integer count = sc.nextInt();
		System.out.println(count);
		sc.nextLine();
		for (int i = 0; i < count; i++) {
			System.out.println(i);
			out.println("Case #" + (i + 1) + ": "
					+ translate(sc.nextLine(), dictionary));
		}

		out.close();
	}

	private static String translate(String input, Map<String, String> dictionary) {
		String output = "";

		for (int c = 0; c < input.length(); c++) {
			String Char = input.substring(c, c + 1);
			if (!dictionary.containsKey(Char)) {
				System.out.println("UNMAPPED " + Char);
				output += Char.toUpperCase();
			} else {
				output += dictionary.get(Char);
			}
		}

		return output;
	}

}
