package com.tomasz.codejam;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

import org.apache.log4j.Logger;

public class MineSweeper {
	private static Logger log = Logger.getLogger(MineSweeper.class);

	public static void main(String[] args) throws IOException {
		// A-small-attempt0.in
		Scanner sc = new Scanner(new File("data/input.txt"));
		PrintWriter out = new PrintWriter(new File("data/output.txt"));

		Integer count = sc.nextInt();
		log.info(count + " cases");

		for (int i = 1; i <= count; i++) {
			log.info(i);

			out.println("Case #" + i + ": "
					+ solve(sc.nextInt(), sc.nextInt(), sc.nextInt()));
		}

		out.close();
	}

	private static String solve(Integer R, Integer C, Integer M) {

		char[][] board = new char[R][C];
		Integer mines = M;

		for (int r = 0; r < R; r++) {
			for (int c = 0; c < C; c++) {
				if (r == R - 2 && c > C - 3) {
					board[r][c] = '.';
				} else {
					if (mines != 0) {
						board[r][c] = '*';
						mines--;
					} else {
						board[r][c] = '.';
					}
				}
			}
		}
		board[R - 1][C - 1] = 'c';

		String output = "\nImpossible";
		if ((R == 1 && C > 2 && M == 1) || //
				(R > 2 && C == 1 && M == 1) || //
				(M <= R * C - 4)) {
			output = "";
			for (int r = 0; r < R; r++) {
				output += "\n";
				for (int c = 0; c < C; c++) {
					output += board[r][c];
				}
			}
		}

		return output;
	}

}
