package com.tomasz.codejam;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

import org.apache.log4j.Logger;

public class CookieClicker {
	private static Logger log = Logger.getLogger(CookieClicker.class);

	public static void main(String[] args) throws IOException {
		// A-small-attempt0.in
		Scanner sc = new Scanner(new File("data/input.txt"));
		PrintWriter out = new PrintWriter(new File("data/output.txt"));

		Integer count = sc.nextInt();
		log.info(count + " cases");

		for (int i = 1; i <= count; i++) {
			log.info(i);

			out.println("Case #" + i + ": "
					+ solve(sc.nextDouble(), sc.nextDouble(), sc.nextDouble()));
		}

		out.close();
	}

	private static String solve(Double C, Double F, Double X) {

		Double production = 2d;
		Double currentTime = 0d;
		Double minTime = solveNoFactories(X, 0d, production);

		for (int i = 0; i < 100_000; i++) {
			currentTime += C / production;
			production += F;
			Double time = solveNoFactories(X, currentTime, production);

			log.debug("C " + C + " F " + F + " X " + X + " | minTime "
					+ minTime + " currentTime " + currentTime + " |\t" + time
					+ "\t" + production);

			if (time < minTime) {
				minTime = time;
			}
			if (time > minTime) {
				return minTime.toString();
			}
		}

		throw new UnsupportedOperationException();
	}

	private static Double solveNoFactories(Double X, Double currentTime,
			Double currentProduction) {
		return currentTime + X / currentProduction;
	}

}
