import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TikTakToe {

	public static final int[] WINNING_STATES = { 0b1111000000000000,
			0b0000111100000000, 0b0000000011110000, 0b0000000000001111,
			0b1000100010001000, 0b0100010001000100, 0b0010001000100010,
			0b0001000100010001, 0b1000010000100001, 0b0001001001001000 };

	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new File("data/A-small-attempt0.in"));
		PrintWriter out = new PrintWriter(new File("data/output.txt"));

		Integer count = sc.nextInt();
		System.out.println(count);

		for (int i = 1; i <= count; i++) {
			System.out.println(i);

			String input = "";
			while (sc.hasNextLine()) {
				for (int ii = 0; ii < 5; ii++) {
					input += sc.nextLine();
				}
				break;
			}

			out.println("Case #" + i + ": " + solve(input));
		}

		out.close();
	}

	private static String solve(String board) {
		System.out.println(board);

		int stateX = Integer.parseInt(
				board.replaceAll("X|T", "1").replaceAll("O|\\.", "0"), 2);
		int stateO = Integer.parseInt(
				board.replaceAll("O|T", "1").replaceAll("X|\\.", "0"), 2);

		log(Integer.toBinaryString(stateX));
		log(Integer.toBinaryString(stateO));

		for (int winstate : WINNING_STATES) {
			if ((winstate & stateX) == winstate) {
				return "X won";
			}
			if ((winstate & stateO) == winstate) {
				return "O won";
			}
		}

		if (board.contains(".")) {
			return "Game has not completed";
		} else {
			return "Draw";
		}

	}

	private static void log(String s) {
		System.out.println(s);
	}
}
