import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class LawnMower {

	public static final int[] WINNING_STATES = { 0b1111000000000000,
			0b0000111100000000, 0b0000000011110000, 0b0000000000001111,
			0b1000100010001000, 0b0100010001000100, 0b0010001000100010,
			0b0001000100010001, 0b1000010000100001, 0b0001001001001000 };

	public static void main(String[] args) throws IOException {
		// A-small-attempt0.in
		Scanner sc = new Scanner(new File("data/B-large.in"));
		PrintWriter out = new PrintWriter(new File("src/output.txt"));

		Integer count = sc.nextInt();
		log(count);

		for (int i = 1; i <= count; i++) {
			log(i);
			Integer N = sc.nextInt();
			Integer M = sc.nextInt();
			log(N + " " + M);
			Integer[][] input = new Integer[N][M];
			for (int ii = 0; ii < N; ii++) {
				for (int jj = 0; jj < M; jj++) {
					input[ii][jj] = sc.nextInt();
				}
			}

			out.println("Case #" + i + ": " + solve(input));
		}

		out.close();
	}

	private static String solve(Integer[][] input) {
		log(input);

		for (int i = 0; i < input.length; i++) {
			for (int j = 0; j < input[0].length; j++) {
				Boolean vPossible = true;
				Boolean hPossible = true;

				// vertical check
				for (int ii = 0; ii < input.length; ii++) {
					if (input[ii][j] > input[i][j]) {
						vPossible = false;
					}
				}
				// horizontal check
				for (int jj = 0; jj < input[0].length; jj++) {
					if (input[i][jj] > input[i][j]) {
						hPossible = false;
					}
				}

				if (!vPossible && !hPossible) {
					return "NO";
				}
			}
		}

		return "YES";
	}

	private static void log(Integer[][] input) {
		for (int ii = 0; ii < input.length; ii++) {
			for (int jj = 0; jj < input[0].length; jj++) {
				System.out.print((input[ii][jj]) + " ");
			}
			System.out.println("");
		}
	}

	private static void log(String s) {
		System.out.println(s);
	}

	private static void log(Integer i) {
		log(i.toString());
	}
}
