import java.util.*;
import java.math.*;

public class FaS
{
  public static final BigInteger []dig = new BigInteger[11];
  public static void main(String []args)
  {
    for(int i = 0; i < dig.length; i++) dig[i] = new BigInteger(Integer.toString(i));

    Scanner in = new Scanner(System.in);
    int T = Integer.valueOf(in.next());
    for(int k = 1; k <= T; k++)
    {
      String sA = in.next();
      String sB = in.next();
      BigInteger A = sqrtCeil(new BigInteger(sA));
      BigInteger B = sqrtFloor(new BigInteger(sB));
      System.out.print("Case #" + k + ": ");
      if(A.compareTo(B) > 0)
      {
        System.out.println(0);
        continue;
      }
      int lA = length(A);
      int lB = length(B);
      if(lA == lB)
      {
//System.out.println(A + " " + B + " " + dig[4].pow(dof(lA)) + " " + count(A, lA)[3] + " " + count(B, lB)[1]);
        System.out.println(dig[4].pow(dof(lA)).subtract(count(A, lA)[3]).subtract(count(B, lB)[1]));
        continue;
      }
      BigInteger c = count(A, lA)[0].add(count(B, lB)[2]).subtract(dig[4].pow(dof(lB) - 1));
//System.out.println(c);
      for(int i = lA + 1; i < lB; i++) c = c.add(dig[3].pow(dof(i)));
      System.out.println(c);
    }
  }
  
  // [ >=, >, <=, < ] bi
  public static BigInteger[] count(BigInteger bi, int l)
  {
    if(l == 0) return new BigInteger[] { dig[1], dig[0], dig[1], dig[0] };
    if(l == 1)
    {
      int i = bi.intValue();
      return new BigInteger[] { dig[getGE(i)], dig[getGT(i)], dig[getLE(i)], dig[getLT(i)] };
    }
    
    int first = getDigit(bi, l - 1);
    int last = getDigit(bi, 0);
    BigInteger GE;
    BigInteger GT;
    BigInteger LE;
    BigInteger LT;

    BigInteger []sub = count(bi.mod(BigInteger.TEN.pow(l - 1)).divide(BigInteger.TEN), l - 2);
    if(first < last)
    {
      GE = dig[getGT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[1]));
      GT = dig[getGT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[1]));
      LE = dig[getLT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[2]));
      LT = dig[getLT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[2]));
    }
    else if(first == last)
    {
      GE = dig[getGT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[0]));
      GT = dig[getGT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[1]));
      LE = dig[getLT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[2]));
      LT = dig[getLT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[3]));
    }
    else /*if(first > last)*/
    {
      GE = dig[getGT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[0]));
      GT = dig[getGT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[0]));
      LE = dig[getLT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[3]));
      LT = dig[getLT(first)].multiply(dig[4].pow(dof(l - 2))).add(dig[getEQ(first)].multiply(sub[3]));
    }
    return new BigInteger[] { GE, GT, LE, LT };
  }
  
  public static int dof(int l) { return (l + 1) / 2; }
  public static int getEQ(int i)
  {
    switch(i)
    {
      case 0: case 1: case 2: case 3: return 1;
      default: return 0;
    }
  }
  public static int getGE(int i)
  {
    return Math.max(4 - i, 0);
  }
  public static int getGT(int i)
  {
    return Math.max(3 - i, 0);
  }
  public static int getLE(int i)
  {
    return Math.min(i + 1, 4);
  }
  public static int getLT(int i)
  {
    return Math.min(i, 3);
  }
  
  public static boolean isPalindrome(int i) // for 1/2 digits
  {
    if(i < 10) return true;
    return i / 10 == i % 10;
  }
  
  public static boolean isPalindrome(BigInteger bi)
  {
    int l = length(bi);
    for(int i = 0; i < (l - 1) / 2; i++)
      if(getDigit(bi, i) != getDigit(bi, l - 1 - i))
        return false;
    return true;
  }
  
  public static int getDigit(BigInteger bi, int pow)
  {
    return bi.divide(BigInteger.TEN.pow(pow)).mod(BigInteger.TEN).intValue();
  }
  
  public static int length(BigInteger bi)
  {
    int l = 0;
    BigInteger n = BigInteger.ONE;
    while(bi.compareTo(n) >= 0)
    {
      l++;
      n = n.multiply(BigInteger.TEN);
    }
    return l;
  }
  
  public static BigInteger sqrtCeil(BigInteger bi)
  {
    BigInteger res = sqrtFloor(bi);
    switch(res.multiply(res).compareTo(bi))
    {
      case -1: return res.add(BigInteger.ONE);
      default: return res;
    }
  }
  
  public static BigInteger sqrtFloor(BigInteger bi)
  {
    BigInteger res = BigInteger.ONE;
    while(res.multiply(res).compareTo(bi) < 0) res = res.shiftLeft(1);
    return sqrtFloorBinary(bi, res.shiftRight(1).add(BigInteger.ONE), res);
  }
  
  public static BigInteger sqrtFloorBinary(BigInteger bi, BigInteger lo, BigInteger hi)
  {
    while(lo.compareTo(hi) <= 0)
    {
      BigInteger mi = lo.add(hi).shiftRight(1);
      switch(mi.multiply(mi).compareTo(bi))
      {
        case -1: lo = mi.add(BigInteger.ONE); break;
        case 1: hi = mi.subtract(BigInteger.ONE); break;
        case 0: default: return mi;
      }
    }
    return hi;
  }
}