import java.util.*;

public class Dijkstra {
  public static void main(String []args) {
    Scanner in = new Scanner(System.in);
    final int T = in.nextInt();
    for (int i = 1; i <= T; i++) {
      final int L = in.nextInt();
      final long _X = in.nextLong();
      int __X;
      if (_X < 15L) __X = (int)_X;
      else {
        switch ((int)(_X % 4L)) {
          case 0: __X = 12; break;
          case 1: __X = 13; break;
          case 2: __X = 14; break;
          case 3: __X = 11; break;
          default: __X = 0; break;
        }
      }
      final int X = __X;
      final String s = in.next();
      final char acc[] = new char[L + 1];
      acc[0] = '1';
      for (int j = 0; j < L; j++) {
        acc[j + 1] = mult(acc[j], s.charAt(j));
      }
      boolean found = false;
      for (int j = 0; j < L * X; j++) {
        int e1 = j / L;
        char a = mult(pow(acc[L], e1), acc[j % L]);
        if (a != 'i') continue;
        char ia = inv(a);
        for (int k = j + 1; k < L * X; k++) {
          int e2 = k / L;
          char b = mult(ia, mult(pow(acc[L], e2), acc[k % L]));
          if (b != 'j') continue;
          char ib = inv(b);
          int e3 = X;
          char c = mult(ib, mult(ia, pow(acc[L], e3)));
          if (c != 'k') continue;
          found = true;
        }
      }
      System.out.println("Case #" + i + (found? ": YES": ": NO"));
    }
  }

  public static char sign(char a) {
    switch (a) {
      case '1':
      case 'i':
      case 'j':
      case 'k':
        return '1';
      case '-':
      case 'I':
      case 'J':
      case 'K':
        return '-';
      default:
        return '\0';
    }
  }

  public static char abs(char a) {
    switch (a) {
      case '1':
      case '-':
        return '1';
      case 'i':
      case 'I':
        return 'i';
      case 'j':
      case 'J':
        return 'j';
      case 'k':
      case 'K':
        return 'k';
      default:
        return '\0';
    }
  }

  public static char cons(char s, char m) {
    switch (m) {
      case '1':
        return s == '1'? '1': '-';
      case 'i':
        return s == '1'? 'i': 'I';
      case 'j':
        return s == '1'? 'j': 'J';
      case 'k':
        return s == '1'? 'k': 'K';
      case '-':
        return s == '1'? '-': '1';
      case 'I':
        return s == '1'? 'I': 'i';
      case 'J':
        return s == '1'? 'J': 'j';
      case 'K':
        return s == '1'? 'K': 'k';
      default:
        return '\0';
    }
  }

  public static char inv(char a) {
    if (a == '1' || a == '-') return a;
    return cons('-', a);
  }

  public static char pow(char a, int e) {
    char res = '1';
    while (e-- > 0) res = mult(res, a);
    return res;
  }

  public static char mult(char a, char b) {
    char s = cons(sign(a), sign(b));
    a = abs(a);
    b = abs(b);
    char p;
    switch (a) {
      case '1':
        switch (b) {
          case '1': p = '1'; break;
          case 'i': p = 'i'; break;
          case 'j': p = 'j'; break;
          case 'k': p = 'k'; break;
          default: p = '\0'; break;
        }
        break;
      case 'i':
        switch (b) {
          case '1': p = 'i'; break;
          case 'i': p = '-'; break;
          case 'j': p = 'k'; break;
          case 'k': p = 'J'; break;
          default: p = '\0'; break;
        }
        break;
      case 'j':
        switch (b) {
          case '1': p = 'j'; break;
          case 'i': p = 'K'; break;
          case 'j': p = '-'; break;
          case 'k': p = 'i'; break;
          default: p = '\0'; break;
        }
        break;
      case 'k':
        switch (b) {
          case '1': p = 'k'; break;
          case 'i': p = 'j'; break;
          case 'j': p = 'I'; break;
          case 'k': p = '-'; break;
          default: p = '\0'; break;
        }
        break;
      default:
        p = '\0';
        break;
    }

    return cons(s, p);
  }
}
