import java.util.*;

public class TidyNumbers {
  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    
    int T = in.nextInt();
    for (int i = 1; i <= T; i++) {
      long N = in.nextLong();
      System.out.println("Case #" + i + ": " + tidyMax(N));
    }
  }
  
  private static int[] toArray(long N) {
    int[] n = new int[19];
    for (int j = 0; N > 0; j++, N /= 10) n[j] = (int)(N % 10);
    return n;
  }
  
  private static long fromArray(int[] n) {
    long N = 0;
    for (int i = n.length - 1; i >= 0; i--)
      N = 10 * N + n[i];
    return N;
  }
  
  private static boolean atMost(int[] m, int[] n) {
    int i = m.length - 1;
    while (m[i] == n[i]) {
      if (i == 0) return true;
      i--;
    }
    return m[i] < n[i];
  }
  
  private static long tidyMax(long N) {
    int[] n = toArray(N);
    int[] m = new int[19];
    tidyMaxHelper(m, n, m.length - 1, 0);
    return fromArray(m);
  }
  
  private static boolean tidyMaxHelper(int[] m, int[] n, int i, int k) {
    if (i < 0) return true;
    for (int j = 9; j >= k; j--) {
      m[i] = j;
      if (atMost(m, n)) {
        if (tidyMaxHelper(m, n, i - 1, j))
          return true;
      }
    }
    m[i] = 0;
    return false;
  }
}