import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Scanner;

public class CoinJam {

	public static BigInteger toNum(byte[] byteArray, Integer base){
		BigInteger answer = new BigInteger("0");
		BigInteger baseAcc = new BigInteger("1");
		BigInteger B = new BigInteger(base.toString());
		for(int i = byteArray.length - 1; i >= 0; i--) {
			BigInteger digit = byteArray[i] == 0 ? new BigInteger("0") : new BigInteger("1"); 
			answer = answer.add(baseAcc.multiply(digit));
			baseAcc = baseAcc.multiply(B);
		}
		return answer;
	}
	
	public static byte[] toByteArray(BigInteger num, int length){
		byte[] answer = new byte[length];
		for (int i = length - 1; i >= 0; i--) {
			answer[i] = num.mod(new BigInteger("2")).byteValue();
			num = num.divide(new BigInteger("2"));
		}
		return answer;
	}
	
	public static boolean check(BigInteger num, int numDigits){
		byte[] bytes = toByteArray(num, numDigits);
		BigInteger[] divisors = new BigInteger[9];
		
		for (int base = 2; base <= 10; base++){
			BigInteger newBaseNum = toNum(bytes, base);
			
			for (BigInteger i = new BigInteger("2"); i.compareTo(newBaseNum) < 0; i = i.add(BigInteger.ONE)) {
					
				if (i.pow(2).compareTo(newBaseNum) > 0)
					return false;
				if (newBaseNum.mod(i).equals(BigInteger.ZERO)) {
					divisors[base - 2] = i;
					break;
				}
			}
		}
		
		for (int i = 0; i < numDigits; i++)
			System.out.print(bytes[i]);
		System.out.print(" ");
		for (int i = 0; i <= 8; i++)
			System.out.print(divisors[i] + " ");
		
		System.out.println();
		return true;
	}
	
	public static void main(String[] args) {
		
		Scanner scan = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		//first line is useless
		scan.nextLine();
		
		int numDigits = scan.nextInt();
		int numNum = scan.nextInt();
		int count = 0;
		
		BigInteger num = (new BigInteger("2")).pow(numDigits - 1).add(BigInteger.ONE);
		
		System.out.println("Case #1:");
		
		while(count < numNum) {
			if (check(num, numDigits))
				count++;
			num = num.add(new BigInteger("2"));
		}
		
		scan.close();
	}
}
