import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;

import javax.print.attribute.standard.NumberOfInterveningJobs;


public class GoldFractal {
	
	public static int[] toDigits(long num, int numOrig, int complexity) {
		int[] result = new int[complexity];
		for (int i = complexity - 1; i >=0; i--) {
			result[i] = (int) num % numOrig;
			num /= numOrig;
		}
		return result;
	} 
	
	public static long toNum(int[] digits, int numOrig, int complexity) {
		long result = 0;
		for (int i = 0; i < complexity; i++)
			result = result * numOrig + digits[i];
		return result;
	} 
	public static boolean goldInThisPosition(long num, int numOrig, int complexity, int origPos) {
		int[] path = toDigits(num, numOrig, complexity);
		for (int i = 0; i < path.length; i++)
			if (path[i] == origPos)
				return true;
		return false;
	}
	
	public static void main(String[] args) {
		
		Scanner scan = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		
		int numRound = scan.nextInt();
		ArrayList<ArrayList<Long>> answers = new ArrayList<ArrayList<Long>>();
		
		for (int i = 0; i < numRound; i++) {
			int numOrig = scan.nextInt();
			int complexity = scan.nextInt();
			int maxStudent = scan.nextInt();
			if (maxStudent + complexity - 1 < numOrig)
				answers.add(null);
			else {
				int[] digits = new int[complexity];
				ArrayList<Long> answer = new ArrayList<Long>();
				if (complexity <= numOrig) 
					for (int j = 0; j <= numOrig - complexity; j++) {
						for (int k = 0; k < complexity; k++)
							digits[k] = j + k;
						answer.add(toNum(digits, numOrig, complexity) + 1);
					}
				else {
					for (int j = 0; j < complexity - numOrig; j++)
						digits[j] = 0;
					for (int j = complexity - numOrig; j < complexity; j++)
						digits[j] = j - (complexity - numOrig);
					answer.add(toNum(digits, numOrig, complexity) + 1);
				}
				answers.add(answer);
			}
			
		}
			
		// output answer
		for (int i = 0; i < numRound; i++) {
			System.out.printf("Case #%d: ", i + 1);
			if (answers.get(i) != null) {
				for (int j = 0; j < answers.get(i).size(); j++)
					System.out.print(answers.get(i).get(j) + " ");
				System.out.println();
			}
			else 
				System.out.println("IMPOSSIBLE");
			
		}
		scan.close();
	}
}
