import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.HashSet;
import java.util.Queue;
import java.util.Scanner;

class State {
	String cakes;
	int distance;
	State(String cakes, int distance) {
		this.cakes = cakes;
		this.distance = distance;
	}
}

public class Pancake {
	public static int stringToInt(String s) {
		int answer = 0;
		for(int i = 0; i < s.length(); i++)
			answer = answer * 10 + s.charAt(i) - '0';
		return answer;
	}
	
	public static boolean allGood(String s) {
		for (int i = 0; i < s.length(); i++)
			if (s.charAt(i) != '+')
				return false;
		return true;
	}
	
	public static String flip(String input, int index) {
		char[] original = input.toCharArray();
		char[] flip = new char[input.length()];
		for (int i = 0; i <= index; i++) 
			flip[i] = original[index - i] == '+' ? '-' : '+';
		for (int i = index + 1; i < input.length(); i++)
			flip[i] = original[i];
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < input.length(); i++) 
			sb.append(flip[i]);
		return sb.toString();
	}
	
	public static int solve(String input) {
		HashSet<String> visited = new HashSet<String>();
		Queue<State> q = new ArrayDeque<State>();
		q.add(new State(input, 0));
		State currentState;
		while (true) {
			currentState = q.poll();
			int distance = currentState.distance;
			String cakes = currentState.cakes;	
			
			if (allGood(cakes))
				break;
			
			for (int i = 0 ; i < cakes.length(); i++) {
				String next = flip(cakes, i);
				if (!visited.contains(next)) {
					q.add(new State(next, distance + 1));
					visited.add(cakes);
				}
			}
		}
		return currentState.distance;
	}
	
	public static void main(String[] args) {
		Scanner scan = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		
		String firstLine = scan.nextLine();
		int numRound = stringToInt(firstLine);
		// ignore the line break of the first lne
		
		int[] answers = new int[numRound];
		
		for (int i = 0; i < numRound; i++) {
			String oneLine = scan.nextLine();
			answers[i] = solve(oneLine);
		}
		
		//output the answer
		for (int i = 0; i < numRound; i++) {
			System.out.printf("Case #%d: %d\n", i + 1, answers[i]);
		}
		scan.close();
	}
}
