package Round1C;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

public class Evacuation {
	static class Senate implements Comparable<Senate> {
		public int index;
		public int num;
		Senate(int index, int num) {
			this.index = index;
			this.num = num;
		}
		public int compareTo(Senate another) {
			return num - another.num;
		}

	}
	public static int stringToInt(String s) {
		int answer = 0;
		for(int i = 0; i < s.length(); i++)
			answer = answer * 10 + s.charAt(i) - '0';
		return answer;
	}
	
	public static String solve(int numSenate, int[] senates) {
		ArrayList<Senate> senatesList = new ArrayList<Senate>();
		ArrayList<Senate> temp = new ArrayList<Senate>();
		for (int i = 0; i < numSenate; i++)
			temp.add(new Senate(i, senates[i]));
		Collections.sort(temp);
		for (int i = 0; i < numSenate; i++)
			senatesList.add(temp.get(numSenate - i - 1));

		int sum = 0;
		for (int i = 0; i < numSenate; i++)
			sum += senates[i];
		
		StringBuilder answer = new StringBuilder();
		
		int count = 1;
		for (int i = 0; i < sum; i++) {
			char thisSenate = (char) (senatesList.get(0).index + 'A');
			if (i == sum - 1 || i == sum - 2) {
				answer.append(thisSenate);
			}	
			else if (senatesList.get(0).num == senatesList.get(1).num && count == 1 && i != sum - 3) {
				answer.append(thisSenate);
				count++;
			}
			else {
				answer.append(thisSenate + " ");
				count = 1;
			}
			senatesList.get(0).num--;
			int index = 0;
			while(index + 1 < numSenate && senatesList.get(index).compareTo(senatesList.get(index + 1)) < 0) {
				Senate tempIndex = senatesList.get(index);
				Senate tempIndex1 = senatesList.get(index + 1);
				senatesList.set(index, tempIndex1);
				senatesList.set(index + 1, tempIndex);
				index++;
			}
		}
		return answer.toString();
	}
	
	public static void main(String[] args) {
		Scanner scan = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		ArrayList<String> answers = new ArrayList<String>();
		
		String firstLine = scan.nextLine();
		int numRound = stringToInt(firstLine);
		// ignore the line break of the first lne
		
		
		for (int i = 0; i < numRound; i++) {
			int numSenate = scan.nextInt();
			int[] senates = new int[numSenate];
			for (int j = 0; j < numSenate; j++)
				senates[j] = scan.nextInt();
			answers.add(solve(numSenate, senates));
		}
		
		//output the answer
		for (int i = 0; i < numRound; i++) {
			System.out.printf("Case #%d: %s\n", i + 1, answers.get(i));
		}
		scan.close();
	}
}
