package vraniak.igor.codejam2015.qualification.A;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class StandingOvation {
	public static final String INPUT_FILE = "A-small-attempt0.in";
	public static final String OUTPUT_FILE = "A-small-attempt0.out";
	
	private int maxShyness;
	private ArrayList<Integer> audience;
	private int invitedFriends;
	private String output;
	
	public StandingOvation() {
		this.audience = new ArrayList<Integer>();
	}
	
	public static void main(String[] args) {
		ArrayList<StandingOvation> sos = LoadInputFile(INPUT_FILE);
		// Iterate through all cases
		for (int i = 0; i < sos.size(); i++) {
			StandingOvation so = sos.get(i);
			// Set initial standing audience
			int audienceStanding = so.audience.get(0);
			
			for (int j = 1; j < so.audience.size(); j++) {
				// Check if there is anyone with current noise level
				if (so.audience.get(j) > 0) {
					// if we don't have required noise, add friend
					while (audienceStanding + so.invitedFriends < j) {
						so.invitedFriends++;
					}
					audienceStanding += so.audience.get(j);
				}
			}
			so.output = "Case #" + (i + 1) + ": " + so.invitedFriends;
		}
		
		// Log
		for (int i = 0; i < sos.size(); i++) {
			StandingOvation so = sos.get(i);
			
			System.out.print(so.maxShyness + " ");
			for (int j = 0; j < so.audience.size(); j++) {
				System.out.print(so.audience.get(j));
			}
			System.out.print(" = " + so.invitedFriends);
			System.out.println();
		}
		
		SaveOutputFile(sos, OUTPUT_FILE);
	}
	
	private static ArrayList<StandingOvation> LoadInputFile(String path) {
		ArrayList<StandingOvation> sos = new ArrayList<StandingOvation>();
		File file = new File(path);
		
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			// Read number of test cases
			int tricksCount = Integer.parseInt(br.readLine());
			
			// Loop through all lines
			for (int index = 0; index < tricksCount; index++) {
				StandingOvation so = new StandingOvation();
				
				// Split read line
				String[] input = br.readLine().split("\\s");
				
				// Save maximum shyness
				so.maxShyness = Integer.parseInt(input[0]);
				
				// Save audience
				for (int i = 0; i < input[1].length(); i++) {
					so.audience.add(Character.getNumericValue(input[1].charAt(i)));
				}

				sos.add(so);
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return sos;
	}
	
	private static void SaveOutputFile(ArrayList<StandingOvation> sos, String path) {
		File file = new File(path);
		
		try {
			FileWriter fw = new FileWriter(file);
			BufferedWriter bw = new BufferedWriter(fw);
			
			for (int i = 0; i < sos.size(); i++) {
				bw.write(sos.get(i).output);
				bw.newLine();
			}
			
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
