package vraniak.igor.codejam2015.qualification.D;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class OminousOmino {
	public static final String INPUT_FILE = "D-large.in";
	public static final String OUTPUT_FILE = "D-large.out";
	
	// N-Omino
	private int x;
	// 1st dimension
	private int r;
	// 2nd dimension
	private int c;
	
	private String result;
	private String output;
	
	public OminousOmino(int x, int r, int c) {
		this.x = x;
		this.r = r;
		this.c = c;
		
		this.result = "RICHARD";
	}
	
	public static void main(String[] args) {
		ArrayList<OminousOmino> oos = LoadInputFile(INPUT_FILE);
		
		// Log
		for (int i = 0; i < oos.size(); i++) {
			OminousOmino oo = oos.get(i);
			System.out.println(oo.x + " " + oo.r + " " + oo.c);
		}
		
		for (int i = 0; i < oos.size(); i++) {
			OminousOmino oo = oos.get(i);
			 /*
			// 1-omino
			if (oo.x == 1) {
				oo.result = "GABRIEL";
			}
			
			// 2-omino
			if (oo.x == 2 && (oo.r * oo.c) % 2 == 0) {
				oo.result = "GABRIEL";
			}
			
			// 3-omino
			if (oo.x == 3 && (oo.r * oo.c) % 3 == 0 && oo.r * oo.c > 3) {
				oo.result = "GABRIEL";
			}
			
			// 4-omino
			if (oo.x == 4 && (oo.r * oo.c) % 4 == 0 && oo.r * oo.c > 8) {
				oo.result = "GABRIEL";
			}
			*/
			
			
			if ((oo.r * oo.c) % oo.x == 0 && oo.r * oo.c > oo.x * (oo.x - 2)) {
				oo.result = "GABRIEL";
			}
			
			oo.output = "Case #" + (i + 1) + ": " + oo.result;
		}
		
		// Log
		for (int i = 0; i < oos.size(); i++) {
			OminousOmino oo = oos.get(i);
			System.out.println(oo.output);
		}
		
		SaveOutputFile(oos, OUTPUT_FILE);
	}
	
	private static ArrayList<OminousOmino> LoadInputFile(String path) {
		ArrayList<OminousOmino> oos = new ArrayList<OminousOmino>();
		File file = new File(path);
		
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			// Read number of test cases
			int cases = Integer.parseInt(br.readLine());
			
			// Loop through all lines
			for (int index = 0; index < cases; index++) {
				String line = br.readLine();
				Scanner sc = new Scanner(line);
				
				OminousOmino oo = new OminousOmino(sc.nextInt(), sc.nextInt(), sc.nextInt());
				
				sc.close();
				
				oos.add(oo);
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return oos;
	}
	
	private static void SaveOutputFile(ArrayList<OminousOmino> oos, String path) {
		File file = new File(path);
		
		try {
			FileWriter fw = new FileWriter(file);
			BufferedWriter bw = new BufferedWriter(fw);
			
			for (int i = 0; i < oos.size(); i++) {
				bw.write(oos.get(i).output);
				bw.newLine();
			}
			
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
