package vraniak.igor.codejam2015.qualification.C;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;


public class Dijkstra {
	public static final String INPUT_FILE = "C-small-attempt1.in";
	public static final String OUTPUT_FILE = "C-small-attempt1.out";
	
	// number of characters used
	private int l;
	// number of occurrences of l
	private int x;
	// ijk string
	private String ijk;
	// ijk with x occurrences
	private StringBuilder ijkFull;
	// ijk mappings
	HashMap<String,String> mappings;
	// Case result
	private String result;
	// Minus counter
	private int minusCounter;
	private String output;
	
	public Dijkstra() {
		ijkFull = new StringBuilder();
		
		mappings = new HashMap<String,String>();
		
		mappings.put("ii", "1");
		mappings.put("ij", "k");
		mappings.put("ik", "1j");
		mappings.put("ji", "1k");
		mappings.put("jj", "1");
		mappings.put("jk", "i");
		mappings.put("ki", "j");
		mappings.put("kj", "1i");
		mappings.put("kk", "1");
		
	}
	
	
	public static void main(String[] args) {
		ArrayList<Dijkstra> ds = LoadInputFile(INPUT_FILE);

		// Log
		for (int i = 0; i < ds.size(); i++) {
			Dijkstra d = ds.get(i);
			
			System.out.println(d.l + " " + d.x);
			System.out.println(d.ijk);
		}
		
		// Iterate through all cases
		for (int i = 0; i < ds.size(); i++) {
			Dijkstra d = ds.get(i);
			
			for (int j = 0; j < d.x; j++) {
				d.ijkFull.append(d.ijk);
			}
			
			boolean done = false;
			
			
			// Too short string
			if (d.ijkFull.length() < 3) {
				done = true;
				d.result = "NO";
			}
			
			while (!done) {
				// Length check
				if (d.ijkFull.length() < 3) {
					done = true;
					d.result = "NO";
					break;
				}
				
				// Process first char if it is not already i
				if (d.ijkFull.charAt(0) != 'i' && d.ijkFull.length() > 1) {					
					String match = d.mappings.get(d.ijkFull.substring(0, 2));
					
					// Match contains -1
					if (match.length() > 1) {
						d.minusCounter++;
						d.ijkFull.replace(0, 2, match.substring(1, 2));
					} else {
						if (match == "1") { // Only 1
							d.minusCounter++;
							d.ijkFull.replace(0, 2, "");
						} else { // Only letter
							d.ijkFull.replace(0, 2, match);
						}
					}
					continue;
				}
				
				// Process second char if it is not already j
				if (d.ijkFull.charAt(1) != 'j' && d.ijkFull.length() > 2) {
					String match = d.mappings.get(d.ijkFull.substring(1, 3));
					
					// Match contains -1
					if (match.length() > 1) {
						d.minusCounter++;
						d.ijkFull.replace(1, 3, match.substring(1, 2));
					} else {
						if (match == "1") { // Only 1
							d.minusCounter++;
							d.ijkFull.replace(1, 3, "");
						} else { // Only letter
							d.ijkFull.replace(1, 3, match);
						}
					}
					continue;
				}
				
				// Process third char if it is not already k
				if (d.ijkFull.charAt(2) != 'k' && d.ijkFull.length() > 3) {
					String match = d.mappings.get(d.ijkFull.substring(2, 4));
					
					// Match contains -1
					if (match.length() > 1) {
						d.minusCounter++;
						d.ijkFull.replace(2, 4, match.substring(1, 2));
					} else {
						if (match == "1") { // Only 1
							d.minusCounter++;
							d.ijkFull.replace(2, 4, "");
						} else { // Only letter
							d.ijkFull.replace(2, 4, match);
						}
					}
					continue;
				}
				
				// Too long string
				if (d.ijkFull.length() > 3) {
					String match = d.mappings.get(d.ijkFull.substring(2, 4));
					
					// Match contains -1
					if (match.length() > 1) {
						d.minusCounter++;
						d.ijkFull.replace(2, 4, match.substring(1, 2));
					} else {
						if (match == "1") { // Only 1
							d.minusCounter++;
							d.ijkFull.replace(2, 4, "");
						} else { // Only letter
							d.ijkFull.replace(2, 4, match);
						}
					}
					
					continue;
				}
				
				// Check if we are done
				if (d.ijkFull.toString().equals("ijk") && d.minusCounter % 2 == 0) {
					d.result = "YES";
					done = true;
					continue;
				}
				
				// Check if we are done
				//if (d.ijkFull.toString().equals("ijk") && d.minusCounter % 2 != 0) {
				if (d.ijkFull.length() == 3) {
					d.result = "NO";
					done = true;
				}
				
				//done = true;
				
			};
			
			d.output = "Case #" + (i + 1) + ": " + d.result;
			System.out.println(d.output);
		}
		
		SaveOutputFile(ds, OUTPUT_FILE);
	}
	
	private static ArrayList<Dijkstra> LoadInputFile(String path) {
		ArrayList<Dijkstra> ds = new ArrayList<Dijkstra>();
		File file = new File(path);
		
		try {
			FileReader fr = new FileReader(file);
			BufferedReader br = new BufferedReader(fr);
			// Read number of test cases
			int cases = Integer.parseInt(br.readLine());
			
			// Loop through all lines
			for (int index = 0; index < cases; index++) {
				Dijkstra d = new Dijkstra();
				
				String line = br.readLine();
				Scanner sc = new Scanner(line);
				
				// Read l
				d.l = sc.nextInt();
				// Read x
				d.x = sc.nextInt();
				
				sc.close();
				
				// Read ijk string
				d.ijk = br.readLine();
				
				ds.add(d);
			}
			br.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return ds;
	}
	
	private static void SaveOutputFile(ArrayList<Dijkstra> ds, String path) {
		File file = new File(path);
		
		try {
			FileWriter fw = new FileWriter(file);
			BufferedWriter bw = new BufferedWriter(fw);
			
			for (int i = 0; i < ds.size(); i++) {
				bw.write(ds.get(i).output);
				bw.newLine();
			}
			
			bw.flush();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
