import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

public class P1C extends Problem {

    public static void main(String[] args) {
        int count = in.nextInt();
        for (int i = 1; i <= count; i++) {
            p(String.format("Case #%d: %s\n", i, test()));
        }
    }

    private static String test() {
        long stalls = in.nextLong() + 2;
        long people = in.nextLong();

        Set<Long> occupied = new TreeSet<>();

        // add guards
        occupied.add(1L);
        occupied.add(stalls);

        long dlbest = 0;
        long drbest = 0;

        for (long person = 0; person < people; person++) {
            long best = -1;
            dlbest = Long.MIN_VALUE;
            drbest = Long.MIN_VALUE;

            Iterator<Long> it = occupied.iterator();
            Long left = it.next();
            while (it.hasNext()) {
                long right = it.next();

                long dleft = (right - left) / 2;
                long newbest = left + dleft;
                long dright = right - newbest;
                if (dleft > dlbest || (dleft == dlbest && dright > drbest)) {
                    dlbest = dleft;
                    drbest = dright;
                    best=newbest;
                }

                left = right;
            }

            occupied.add(best);
        }

        return String.format("%d %d", drbest - 1, dlbest - 1);
    }
}
