package com.zingler.googlecodejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Opera {
    public static void main( String[] args ) throws FileNotFoundException {
        File input = new File( "A-large.in" );
        Scanner scan = new Scanner( input );
        File output = new File( "output.txt" );
        PrintWriter out = new PrintWriter( new FileOutputStream( output ) );

        int testcases = scan.nextInt();
        for ( int testCaseId = 1; testCaseId <= testcases; testCaseId++ ) {
            int maxShyness = scan.nextInt();
            String people = scan.next();
            List<Integer> peopleCounts = new ArrayList<>();
            for ( char c : people.toCharArray() ) {
                peopleCounts.add( Integer.parseInt( "" + c ) );
            }

            int peopleNeeded = solve( peopleCounts );
            out.println( String.format( "Case #%d: %d", testCaseId, peopleNeeded ) );
        }

        scan.close();
        out.close();
        System.out.println( "DONE" );

    }

    private static int solve( List<Integer> peopleCounts ) {
        int peopleNeeded = 0;
        int standingPeople = 0;
        for ( int i = 0; i < peopleCounts.size(); i++ ) {
            if ( standingPeople < i ) {
                peopleNeeded += ( i - standingPeople );
                standingPeople += i - standingPeople;
            }
            standingPeople += peopleCounts.get( i );
        }

        return peopleNeeded;
    }
}
