package com.zingler.googlecodejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Scanner;

import com.google.common.collect.ImmutableMap;

public class Omino {
    public static void main( String[] args ) throws FileNotFoundException {
        File input = new File( "D-small-attempt1.in" );
        Scanner scan = new Scanner( input );
        File output = new File( "output.txt" );
        PrintWriter out = new PrintWriter( new FileOutputStream( output ) );

        int testcases = scan.nextInt();
        for ( int testCaseId = 1; testCaseId <= testcases; testCaseId++ ) {
            int x = scan.nextInt();
            int r = scan.nextInt();
            int c = scan.nextInt();

            System.out.println( "Starting test " + testCaseId + ": x=" + x + " r=" + r + " c=" + c );

            Boolean canForceWin = solve( x, r, c );
            out.println( String.format( "Case #%d: %s", testCaseId, canForceWin != null ? ( canForceWin ? "RICHARD" : "GABRIEL" ) : "???" ) );
        }

        scan.close();
        out.close();
        System.out.println( "DONE" );
    }

    static Map<Integer, Integer> minWidthMap = ImmutableMap.of( 1, 1, 2, 1, 3, 2, 4, 3 );

    /**
     * I'm lazy, just getting r,c,x <=4. Yay points
     */
    private static Boolean solve( int x, int r, int c ) {
        if ( x == 1 ) {
            return false;
        }

        if ( ( r * c ) % x != 0 ) {
            return true;
        }

        if ( x == 2 ) {
            return false;
        }

        if ( x == 3 ) {
            return ( r * c ) == 3;
        }

        int minwidth = minWidthMap.get( x );
        if ( r < minwidth || c < minwidth ) {
            return true;
        }

        if ( x == 4 && ( r * c == 12 || r * c == 16 ) ) {
            return false;
        }

        return null;
    }
}
