import java.util.*;

public class D {
	private static Scanner in = new Scanner(System.in);
	private static int minCost = 0;

	public static void main(String[] args) {
		int T = in.nextInt();

		for (int thisCase = 1; thisCase <= T; thisCase++) {
			System.out.printf("Case #%d: %s%n", thisCase, result());
		}
	}

	private static String result() {
		int N = in.nextInt();
		minCost = Integer.MAX_VALUE;

		in.nextLine();
		boolean grid[][] = new boolean[N][N];
		for (int i = 0; i < N; i++) {
			String line = in.nextLine();
			int j = 0;
			for (char c : line.toCharArray()) {
				grid[i][j] = (c == '1');
				j++;
			}
		}
		int minCost = minCost(grid, N);
		return String.format("%d", minCost);
	}

	private static ArrayList<Integer> iList;
	private static ArrayList<Integer> jList;
	private static int minCost(boolean grid[][], int N) {
		// compile a list of all 0's in the grid
		iList = new ArrayList<>();
		jList = new ArrayList<>();
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (!grid[i][j]) {
					iList.add(i);
					jList.add(j);
				}
			}
		}

		for (int i = 0; i < iList.size(); i++) {
			if (hasSolution(grid, N, 0, i)) {
				return i;
			}
		}

		return iList.size();
	}

	private static boolean hasSolution(boolean[][] grid, int N, int index, int slotsToFill) {
		if (slotsToFill + index > iList.size()) {
			return false;
		}
		if (slotsToFill == 0) {
			return factoryWorks(grid, N);
		}
		boolean result;
		grid[iList.get(index)][jList.get(index)] = true;
		result = hasSolution(grid, N, index+1, slotsToFill-1);

		grid[iList.get(index)][jList.get(index)] = false;
		result = result || hasSolution(grid, N, index+1, slotsToFill);

		return result;
	}

	private static boolean factoryWorks(boolean[][] grid, int N) {
		int i = 0;
		for (boolean[] line : grid) {
			boolean rowGood = false;
			String thisLine = rowToString(grid, N, i);
			int j = 0; 

			int cellCount = 0;
			int matchCount = 0;
			for (boolean cell : line) {
				if (cell) {
					cellCount++;
					matchCount = 0;
					rowGood = true;
					//a 1 is found in this cell, so each row that also has a 1 in this column must have the same layout
					for (int row = 0; row < N; row++) {
						if (grid[row][j]) {
							matchCount++;
							if (!rowToString(grid, N, row).equals(thisLine)) {
								return false;
							}
						}
					}
				}
				j++;
			}
			if (!rowGood) {
				return false;
			}
			if (cellCount != matchCount) {
				return false;
			}
			i++;
		}
		return true;
	}

	private static String rowToString(boolean[][] grid, int N, int row) {
		StringBuilder result = new StringBuilder();
		for (int i = 0; i < N; i++) {
			result.append(grid[row][i] ? '1' : '0');
		}
		return result.toString();
	}
}