import java.util.*;

public class Fractals {
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for (int thisCase = 0; thisCase < T; thisCase++) {
			int K = in.nextInt();
			int C = in.nextInt();
			int S = in.nextInt();

			System.out.printf("Case #%d: %s%n", thisCase+1, indexList(K, C, S));
		}
	}

	private static String indexList(int K, int C, int S) {
		// we will provide coverage for all of the indices in K
		int currentKIndex = 0;

		// we have S opportunities to do so
		ArrayList<Long> indices = new ArrayList<>();
		for (int thisS = 0; thisS < S && currentKIndex < K; thisS++) {
			long finalIndex = 0;
			long stepsSoFar = 0;
			long interval = 1;
			while (stepsSoFar < C && currentKIndex < K) {
				finalIndex += currentKIndex*interval;
				currentKIndex++;
				stepsSoFar++;
				interval *= K;
			}
			indices.add(finalIndex);
		}

		if (currentKIndex < K) {
			return "IMPOSSIBLE";
		}

		String result = "";
		for (long i : indices) {
			if (result.length() == 0) {
				result = String.format("%d", i+1);
			}
			else {
				result = String.format("%s %d", result, i+1);
			}
		}
		return result;
	}
}