import java.util.*;

public class A {
	private static Scanner in = new Scanner(System.in);

	public static void main(String[] args) {
		int T = in.nextInt();

		for (int thisCase = 1; thisCase <= T; thisCase++) {
			System.out.printf("Case #%d: %s%n", thisCase, result());
		}
	}

	private static String result() {
		int N = in.nextInt();
		int R = in.nextInt();
		int P = in.nextInt();
		int S = in.nextInt();
		if (!isSolvable(R, P, S)) {
			return "IMPOSSIBLE";
		}
		return solve(N, R, P, S);
	}

	
	private static String solve(int N, int R, int P, int S) {
		//base cases
		if (N == 0) {
			if (R==1) {
				return "R";
			}
			if (P == 1) {
				return "P";
			}
			if (S == 1) {
				return "S";
			}
		}

		//recursive cases
		int R1, R2, P1, P2, S1, S2;
		R1 = R2 = R/2;
		P1 = P2 = P/2;
		S1 = S2 = S/2;
		if (R%2 == 0) {
			P1++;
			S2++;
		}
		else if (P%2 == 0) {
			R1++;
			S2++;
		}
		else if (S%2 == 0) {
			R1++;
			P2++;
		}
		String t1 = solve(N-1, R1, P1, S1);
		String t2 = solve(N-1, R2, P2, S2);
		return (t1.compareTo(t2) < 0 ? t1+t2 : t2+t1);
	}

	private static boolean isSolvable(int R, int P, int S) {
		if (R == P && Math.abs(R-S) == 1) {
			return true;
		}
		if (R == S && Math.abs(R-P) == 1) {
			return true;
		}
		if (S == P && Math.abs(R-S) == 1) {
			return true;
		}
		return false;
	}
}