import java.util.*;

public class B {
	private static double maxProbability = 0;
	private static double prob[];
	private static int N;
	private static int K;

	private static Scanner in = new Scanner(System.in);

	public static void main(String[] args) {
		int T = in.nextInt();

		for (int thisCase = 1; thisCase <= T; thisCase++) {
			System.out.printf("Case #%d: %s%n", thisCase, result());
		}
	}

	private static String result() {
		N = in.nextInt();
		K = in.nextInt();
		maxProbability = 0;
		prob = new double[N];
		for (int i = 0; i < N; i++) {
			prob[i] = in.nextDouble();
		}
		
		//generate all combinations
		//evaluate each combination and maintain a max-probability thing
		genCombs(0, new LinkedList<Double>());	

		return String.format("%.8f", maxProbability);
	}


	private static void genCombs(int index, LinkedList<Double> probs) {
		if (probs.size() == K) {
			double prob = evalList(probs, 0);
			if (prob > maxProbability) {
				maxProbability = prob;
				// for (double p : probs) {
				// 	System.out.printf("%f ", p);
				// }
				// System.out.println();
			}
		}
		else {
			if (index == N) {
				return;
			}
			if (index+K-probs.size() > N) {
				return;
			}
			probs.push(prob[index]);
			genCombs(index+1, probs);
			probs.pop();
			genCombs(index+1, probs);
		}


	}


	private static double evalList(LinkedList<Double> probs, int advantage) {
		if (Math.abs(advantage) > probs.size()) {
			return 0;
		}
		if (probs.size() == 1) {
			if (advantage == 1) return probs.get(0);
			if (advantage == -1) return (1-probs.get(0));
		}
		double prob1 = probs.pop();
		double result  = 
			evalList(probs, advantage+1)*(1-prob1) + 
			evalList(probs, advantage-1)*prob1;
		probs.push(prob1);
		return result;
	}
}