import java.util.*;
import java.io.*;
import java.math.*;

public class GCJ 
{

	private Scanner input;
	private PrintWriter output;
	private int caseNumber = 1;
	private String delimiter = " ";
	private boolean beginningOfLine = true;
	private String beginningOfLineHeaderOne = "Case #";
	private String beginningOfLineHeaderTwo = ": ";
	
	public GCJ(Scanner inputScanner, PrintWriter outputPrintWriter)
	{
		input = inputScanner;
		output = outputPrintWriter;
	}
	
	
	public void dot(int[] aOne, int[] aTwo)
	{
		if (aOne.length != aTwo.length)
			throw new IllegalArgumentException("Array lengths must be the same!");
		for(int i = 0; i < aOne.length; i++)
		{
			aOne[i] *= aTwo[i];
		}
	}
	
	public void dot(long[] aOne, long[] aTwo)
	{
		if (aOne.length != aTwo.length)
			throw new IllegalArgumentException("Array lengths must be the same!");
		for(int i = 0; i < aOne.length; i++)
		{
			aOne[i] *= aTwo[i];
		}
	}
	
	public long[] scanIntArray(int size)
	{
		long[] returnValue = new long[size];
		returnValue[0] = input.nextInt();
		for(int i = 1; i < size; i++)
		{
			input.skip(delimiter);
			returnValue[i] = input.nextInt();
		}
		if (input.hasNextLine())
			input.nextLine();
		return returnValue;
		
	}
	
	
	
	public long sum(long[] toSum)
	{
		
		long sum = 0;
		for (int i = 0; i < toSum.length; i++)
		{
			
			sum += toSum[i];
		}
		return sum;
	}
	
	public void scaleArray(int[] toScale, int toMult)
	{
		for (int i = 0; i < toScale.length; i++)
		{
			toScale[i] *= toMult;
		}
	}
	
	public void scaleArray(long[] toScale, long toMult)
	{
		for (int i = 0; i < toScale.length; i++)
		{
			toScale[i] *= toMult;
		}
	}
	
	public void rSort(int[] toSort)
	{
		scaleArray(toSort, -1);
		Arrays.sort(toSort);
		scaleArray(toSort, -1);
	}
	
	public void rSort(long[] toSort)
	{
		scaleArray(toSort, -1);
		Arrays.sort(toSort);
		scaleArray(toSort, -1);
	}
	
	public long[][] scanIntMatrix(int height, int width)
	{
		long[][] returnValue = new long[height][width];
		for(int i = 0; i < height; i++)
		{
			for (int j = 0; j < width; j++)
			{
				returnValue[i][j] = input.nextInt();
				if (j != width - 1)
					input.skip(delimiter);
			}
			input.nextLine();
		}
		
		return returnValue;
	}
	
	public void printIntArray(long[] toPrint)
	{
		if (beginningOfLine)
		{
			beginningOfLine = false;
			output.print(beginningOfLineHeaderOne + caseNumber + beginningOfLineHeaderTwo);
			
		}
		
		for(int i = 0; i < toPrint.length; i++)
		{
			if (i < toPrint.length - 1)
				print(toPrint[i] + " ");
			else
				println(toPrint[i]);
			
		}
		
		caseNumber++;
		beginningOfLine = true;
	}
	
	
	
	public void print(String value)
	{
		if (beginningOfLine)
		{
			beginningOfLine = false;
			output.print(beginningOfLineHeaderOne + caseNumber + beginningOfLineHeaderTwo);
		}
		output.print(value);
	}
	
	public void print(int value) { print("" + value); }
	public void print(double value) { print("" + value); }
	public void print(float value) { print("" + value); }
	public void print(boolean value) { print("" + value); }
	public void print(char value) { print("" + value); }
	public void print(long value) { print("" + value); }
	
	
	public void println(String value)
	{
		if (beginningOfLine)
		{
			beginningOfLine = false;
			output.print(beginningOfLineHeaderOne + caseNumber + beginningOfLineHeaderTwo);
		}
		output.println(value);
		caseNumber++;
		beginningOfLine = true;
	}
	
	public void println(int value) { println("" + value); }
	public void println(double value) { println("" + value); }
	public void println(float value) { println("" + value); }
	public void println(boolean value) { println("" + value); }
	public void println(char value) { println("" + value); }
	public void println(long value) { println("" + value); }
}
