package qualification;

import java.io.*;
import java.util.HashMap;
import java.util.StringTokenizer;

/**
 * Created by Alexander on 11.04.2015.
 */
public class C {
    private BufferedReader reader;
    private StringTokenizer tokenizer;
    HashMap<Character, Integer> quatToInt = new HashMap<Character, Integer>();
    int[][] mult = new int[5][5];
    boolean[][] sign = new boolean[5][5];
    public C() throws IOException {
        reader = new BufferedReader(new FileReader(new File("c.in")));
        tokenizer = new StringTokenizer(reader.readLine());
        quatToInt.put('i', 2);
        quatToInt.put('j', 3);
        quatToInt.put('k', 4);
        mult[0] = new int[]{-1, -1, -1, -1, -1};
        mult[1] = new int[]{0, 1, 2, 3, 4};
        mult[2] = new int[]{0, 2, 1, 4, 3};
        mult[3] = new int[]{0, 3, 4, 1, 2};
        mult[4] = new int[]{0, 4, 3, 2, 1};
        sign[1] = new boolean[]{false, false, false, false, false};
        sign[2] = new boolean[]{false, false, true, false, true};
        sign[3] = new boolean[]{false, false, true, true, false};
        sign[4] = new boolean[]{false, false, false, true, true};
    }

    public static void main(String[] args) throws IOException{
        C c = new C();
        c.output(c.mainAlg());
    }

    String mainAlg() throws IOException{
        int numOfTests = nextInt();
        StringBuilder sb = new StringBuilder(numOfTests * 4);
        for (int i = 1; i < numOfTests + 1; ++i){
            int l = nextInt();
            int x = nextInt();
            int[] line = nextLine();
            int res = 1;
            int j = 0;
            boolean sgn = false;
            boolean i0 = false;
            boolean j0 = false;
            boolean k0 = false;
            boolean one0 = false;
            while (x > 0){
                int tmp = res;
                res = mult[tmp][line[j]];
                sgn ^= sign[tmp][line[j]];
                j++;
                if (j > line.length - 1){
                    j = 0;
                    x--;
                }
                if (res == 2 && sgn == false)
                    break;
            }
            if (res == 2 && sgn == false) {
                i0 = true;
                res = 1;
            }
            while (x > 0){
                int tmp = res;
                res = mult[tmp][line[j]];
                sgn ^= sign[tmp][line[j]];
                j++;
                if (j > line.length - 1){
                    j = 0;
                    x--;
                }
                if (res == 3 && sgn == false)
                    break;
            }
            if (res == 3 && sgn == false) {
                j0 = true;
                res = 1;
            }
            while (x > 0){
                int tmp = res;
                res = mult[tmp][line[j]];
                sgn ^= sign[tmp][line[j]];
                j++;
                if (j > line.length - 1){
                    j = 0;
                    x--;
                }
                if (res == 4 && sgn == false)
                    break;
            }
            if (res == 4 && sgn == false) {
                k0 = true;
                res = 1;
            }
            while (x > 0){
                int tmp = res;
                res = mult[tmp][line[j]];
                sgn ^= sign[tmp][line[j]];
                j++;
                if (j > line.length - 1){
                    j = 0;
                    x--;
                }
            }
            if (res == 1 && sgn == false)
                one0 = true;
            boolean rt = one0 & i0 & j0 & k0;
            sb.append("Case #" + i + ": ");
            sb.append(rt ? "YES\n" : "NO\n");
        }
        return sb.toString();
    }

    boolean tmpFunc(int x, int res, boolean sgn, int[] line, int j){
        while (x > 0){
            res = mult[res][line[j]];
            sgn ^= sign[res][line[j]];
            j++;
            if (j > line.length - 1){
                j = 0;
                x--;
            }
        }
        if (res == 1 && sgn == false)
            return true;
        return false;
    }

    int nextInt() throws IOException{
        if (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return Integer.valueOf(tokenizer.nextToken());
    }

    int[] nextLine() throws IOException{
        if (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        char[] tmp = tokenizer.nextToken().toCharArray();
        int[] res = new int[tmp.length];
        for (int i = 0; i < tmp.length; ++i)
            res[i] = quatToInt.get(tmp[i]);
        return res;
    }

    void output(String res) throws IOException {
        BufferedWriter bw = new BufferedWriter(new FileWriter("c.out"));
        bw.write(res);
        bw.flush();
    }
}
