package qualification;

import java.io.*;
import java.util.StringTokenizer;
import static java.lang.Math.*;

/**
 * Created by Alexander on 11.04.2015.
 */
public class D {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public D() throws IOException {
        reader = new BufferedReader(new FileReader(new File("d.in")));
        tokenizer = new StringTokenizer(reader.readLine());
    }

    public static void main(String[] args) throws IOException {
        D d = new D();
        d.output(d.mainAlg());
    }

    String mainAlg() throws IOException {
        int numOfTests = nextInt();
        StringBuilder sb = new StringBuilder(numOfTests * 10);
        for (int i = 1; i < numOfTests + 1; ++i){
            int x = nextInt();
            int r = nextInt();
            int c = nextInt();
            sb.append("Case #" + i + ": ");
            if ((c * r) % x != 0
                || (x > 6)
                || (x > max(c, r))
                || (min(c, r) < x / 2)
                || ((min(c, r) == 2 && x == 4))
                || ((min(c, r) == 1 && x == 3)))
                sb.append("RICHARD\n");
            else
                sb.append("GABRIEL\n");
        }
        return sb.toString();
    }

    int nextInt() throws IOException {
        if (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(reader.readLine());
        return Integer.valueOf(tokenizer.nextToken());
    }

    void output(String res) throws IOException {
        BufferedWriter bw = new BufferedWriter(new FileWriter("d.out"));
        bw.write(res);
        bw.flush();
    }
}
