import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

public class Magicka {

    private static class Combination {
        public String leftElement;
        public String rightElement;
        public String newElement;

        public Combination( String l, String r, String n ) {
            leftElement = l;
            rightElement = r;
            newElement = n;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Combination that = (Combination) o;

            if (leftElement != null ? !leftElement.equals(that.leftElement) : that.leftElement != null) return false;
            if (rightElement != null ? !rightElement.equals(that.rightElement) : that.rightElement != null)
                return false;

            return true;
        }

        @Override
        public int hashCode() {
            int result = leftElement != null ? leftElement.hashCode() : 0;
            result = 31 * result + (rightElement != null ? rightElement.hashCode() : 0);
            return result;
        }
    }

    private static class Opposition {
        public String leftElement;
        public String rightElement;

        public Opposition( String l, String r ) {
            leftElement = l;
            rightElement = r;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Opposition that = (Opposition) o;

            if (leftElement != null ? !leftElement.equals(that.leftElement) : that.leftElement != null) return false;
            if (rightElement != null ? !rightElement.equals(that.rightElement) : that.rightElement != null)
                return false;

            return true;
        }

        @Override
        public int hashCode() {
            int result = leftElement != null ? leftElement.hashCode() : 0;
            result = 31 * result + (rightElement != null ? rightElement.hashCode() : 0);
            return result;
        }
    }

    public static void main( String[] args ) {

        String inputFilename = "/Users/jim/IdeaProjects/GoogleCodeJam/Magicka/B-small-attempt0.in";

        try {
            BufferedReader in = new BufferedReader( new FileReader( new File( inputFilename )));

            Integer cases = Integer.valueOf( in.readLine().trim() );
            for ( int i = 0; i < cases; i++ ) {
                Set<Combination> combinations = new HashSet<Combination>();
                Set<Opposition> oppositions = new HashSet<Opposition>();
                Stack<String> elements = new Stack<String>();

                StringTokenizer st = new StringTokenizer( in.readLine().trim() );

                Integer numCombinations = Integer.valueOf( st.nextToken().trim() );
                for ( int j = 0; j < numCombinations; j++ ) {
                    String data = st.nextToken().trim().toUpperCase();
                    Combination c = new Combination( data.substring(0,1), data.substring(1,2), data.substring(2,3) );
                    combinations.add( c );
                }

                Integer numOppositions = Integer.valueOf( st.nextToken().trim() );
                for ( int j = 0; j < numOppositions; j++ ) {
                    String data = st.nextToken().trim().toUpperCase();
                    Opposition o = new Opposition( data.substring(0,1), data.substring(1,2) );
                    oppositions.add( o );
                }

                Integer numElements = Integer.valueOf( st.nextToken().trim() );
                String elementStr = st.nextToken().trim().toUpperCase();
                for ( int j = 0; j < numElements; j++ ) {
                    String nextElement = elementStr.substring(j,j+1);
                    if ( elements.empty() ) {
                        elements.push( nextElement );
                    } else {
                        // scan combinations
                        boolean combinationPerformed = false;
                        do {
                            for ( Combination c : combinations ) {
                                if ( c.equals( new Combination( elements.peek(), nextElement, "" )) || c.equals( new Combination( nextElement, elements.peek(), "" ))) {
                                    String topElement = elements.pop();
                                    nextElement = c.newElement;
                                }
                                if ( elements.empty() ) {
                                    break;
                                }
                            }
                        } while ( combinationPerformed && !elements.empty() );
                        // scan oppositions
                        for ( Opposition o : oppositions ) {
                            for ( String element : elements ) {
                                if ( o.equals( new Opposition( element, nextElement )) || o.equals( new Opposition( nextElement, element ))) {
                                    elements.clear();
                                    nextElement = null;
                                    break;
                                }
                                if ( elements.empty() ) {
                                    break;
                                }
                            }
                        }
                        if ( nextElement != null ) {
                            elements.push( nextElement );
                        }
                    }
                }

                System.out.println( String.format( "Case #%d: %s", i+1, Arrays.toString( elements.toArray() )));
            }

        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

    }
}
