import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

public class BotTrust {

    private static class Action {
        public Integer index;
        public Integer button;
    }

    public static void main( String[] args ) {

        String inputFilename = "/Users/jim/IdeaProjects/GoogleCodeJam/BotTrust/A-small-attempt0.in";

        try {
            BufferedReader in = new BufferedReader( new FileReader( new File( inputFilename )));

            Integer cases = Integer.valueOf( in.readLine().trim() );
            for ( int i = 0; i < cases; i++ ) {
                Integer orangePosition = 1;
                Integer bluePosition = 1;
                Integer nextAction = 1;

                List<Action> orangeActions = new ArrayList<Action>();
                Integer orangePointer = -1;

                List<Action> blueActions = new ArrayList<Action>();
                Integer bluePointer = -1;

                StringTokenizer st = new StringTokenizer( in.readLine().trim() );
                Integer buttons = Integer.valueOf( st.nextToken().trim() );
                for ( int j = 0; j < buttons; j++ ) {
                    String robot = st.nextToken().trim().toUpperCase();
                    Integer button = Integer.valueOf( st.nextToken().trim() );
                    Action action = new Action();
                    action.button = button;
                    action.index = j+1;
                    if ( robot.equals("O") ) {
                        orangeActions.add( action );
                        orangePointer = 0;
                    } else {
                        blueActions.add( action );
                        bluePointer = 0;
                    }
                }

                int t = 0;
                while ( true ) {
                    t++;
                    Action nextOrangeAction = null;
                    Action nextBlueAction = null;
                    Boolean orangeDone = false;
                    Boolean blueDone = false;
                    if ( orangePointer >= 0 && orangePointer < orangeActions.size() ) {
                        nextOrangeAction = orangeActions.get(orangePointer);
                    }
                    if ( bluePointer >= 0 && bluePointer < blueActions.size() ) {
                        nextBlueAction = blueActions.get(bluePointer);
                    }
                    // resolve movement
                    if ( nextOrangeAction != null ) {
                        if ( nextOrangeAction.button > orangePosition ) {
                            orangePosition++;
                            orangeDone = true;
                        } else if ( nextOrangeAction.button < orangePosition ) {
                            orangePosition--;
                            orangeDone = true;
                        }
                    }
                    if ( nextBlueAction != null ) {
                        if ( nextBlueAction.button > bluePosition ) {
                           bluePosition++;
                            blueDone = true;
                        } else if ( nextBlueAction.button < bluePosition ) {
                            bluePosition--;
                            blueDone = true;
                        }
                    }
                    if ( !orangeDone && nextOrangeAction != null && nextOrangeAction.button == orangePosition && nextOrangeAction.index == nextAction ) {
                        // orange push button
                        nextAction++;
                        orangePointer++;
                    } else if ( !blueDone && nextBlueAction != null && nextBlueAction.button == bluePosition && nextBlueAction.index == nextAction ) {
                        // blue push button
                        nextAction++;
                        bluePointer++;
                    }
                    if ( (orangePointer == -1 || orangePointer >= orangeActions.size()) && (bluePointer == -1 || bluePointer >= blueActions.size())) {
                        break;
                    }
                }

                System.out.println( String.format( "Case #%d: %d", i+1, t ));
            }
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }

    }
}
