import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.*;

public class CandySplitting {

    public static void main( String[] args ) {

        String inputFileName = "/Users/jim/IdeaProjects/GoogleCodeJam/CandySplitting/C-large.in";

        try {
            BufferedReader in = new BufferedReader( new FileReader( new File( inputFileName )));

            Integer cases = Integer.valueOf( in.readLine().trim() );
            for ( int i = 0; i < cases; i++ ) {
                Integer numCandies = Integer.valueOf( in.readLine().trim() );

                List<Long> candies = new ArrayList<Long>();
                StringTokenizer st = new StringTokenizer( in.readLine().trim() );
                for ( int j = 0; j < numCandies; j++ ) {
                    candies.add( Long.valueOf( st.nextToken().trim() ));
                }

                Collections.sort( candies, new Comparator<Long>() {
                    public int compare(Long l1, Long l2) {
                        return l1.compareTo(l2);
                    }
                });

                Integer split = 1;
                BigInteger patrick = BigInteger.ZERO;
                BigInteger seanFake = BigInteger.ZERO;
                BigInteger seanReal = BigInteger.ZERO;

                while ( split < candies.size() ) {
                    patrick = BigInteger.ZERO;
                    seanFake = BigInteger.ZERO;
                    seanReal = BigInteger.ZERO;

                    for ( int j = 0; j < split; j++ ) {
                        patrick = patrick.xor( new BigInteger( candies.get(j).toString() ));
                    }
                    for ( int j = split; j < candies.size(); j++ ) {
                        seanFake = seanFake.xor( new BigInteger( candies.get(j).toString() ));
                        seanReal = seanReal.add( new BigInteger( candies.get(j).toString() ));
                    }
                    if ( patrick.equals(seanFake) ) {
                        break;
                    }
                    split++;
                }

                if ( split < candies.size() ) {
                    System.out.println( String.format( "Case #%d: %s", i+1, seanReal.toString() ));
                } else {
                    System.out.println( String.format( "Case #%d: NO", i+1 ));
                }
            }
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }
}
