import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

public class Password {
    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("A-small-attempt0.in"));
            PrintWriter out = new PrintWriter(new FileWriter("A.out"));

            int cases = in.nextInt();
            in.nextLine();
            for (int i = 0; i < cases; i++) {
                double keystrokes = solve(in);
                out.println(String.format("Case #%d: %15.6f", i+1, keystrokes));
            }

            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static double solve(Scanner in) {
        int typed = in.nextInt();
        int total = in.nextInt();
        in.nextLine();

        double[] letterprobs = new double[typed];
        for (int i = 0; i < typed; i++) {
            letterprobs[i] = in.nextDouble();
        }
        in.nextLine();

        BigInteger combination = BigInteger.ZERO;
        BigInteger bitmaskAllCorrect = new BigInteger("2").pow(typed).add(BigInteger.ONE.negate());

        double evKeepTyping = 0.0;
        double evBackOnce = 0.0;
        double evBackTwice = 0.0;
        double evEnter = 0.0;

        BigInteger bitmaskBackOnce = bitmaskAllCorrect.clearBit(0);
        BigInteger bitmaskBackTwice = bitmaskBackOnce.clearBit(1);

        while (combination.compareTo(bitmaskAllCorrect) <= 0) {
            double prob = 1.0;
            for (int i = 0; i < typed; i++) {
                prob *= combination.testBit(typed-1-i) ? letterprobs[i] : 1.0 - letterprobs[i];
            }

            // keep typing
            int keystrokes = (total - typed) + 1 + (combination.and(bitmaskAllCorrect).equals(bitmaskAllCorrect) ? 0 : total+1);
            evKeepTyping += (keystrokes * prob);

            // backspace once
            keystrokes = 1 + (total - typed + 1) + 1 + (combination.and(bitmaskBackOnce).equals(bitmaskBackOnce) ? 0 : total+1);
            evBackOnce += (keystrokes * prob);

            // backspace twice
            keystrokes = 2 + (total - typed + 2) + 1 + (combination.and(bitmaskBackTwice).equals(bitmaskBackTwice) ? 0 : total+1);
            evBackTwice += (keystrokes * prob);

            // enter right now
            keystrokes = 1 + total + 1;
            evEnter += (keystrokes * prob);

            combination = combination.add(BigInteger.ONE);
        }

        return Math.min(Math.min(Math.min(evKeepTyping, evBackOnce), evBackTwice), evEnter);
    }
}
