import java.io.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.util.Scanner;

public class FairAndSquare {

    public static BigInteger sqrt(BigInteger n) {
        BigInteger root = null;
        BigDecimal nd = new BigDecimal(n);

        BigDecimal epsilon = new BigDecimal(0.0000000001);
        BigDecimal two = new BigDecimal(2);
        BigDecimal approx = BigDecimal.ONE;

        for (int i = 0; i < 100; i++) {
            BigDecimal newApprox = approx.add(nd.divide(approx, 9, RoundingMode.FLOOR)).divide(two, 9, RoundingMode.FLOOR);
            if (approx.subtract(newApprox).abs().compareTo(epsilon) < 0) {
                break;
            }
            approx = newApprox;
        }

        if (approx.subtract(new BigDecimal(approx.toBigInteger())).abs().compareTo(epsilon) < 0) {
            root = approx.toBigInteger();
        }

        return root;
    }

    public static boolean isPalindrome(BigInteger n) {
        String s = n.toString();
        int max = (int)Math.floor(s.length() / 2.0);
        for (int i = 0; i < max; i++) {
            if (s.charAt(i) != s.charAt(s.length() - 1 - i)) {
                return false;
            }
        }
        return true;
    }

    public static void main(String[] args) {
        try (PrintWriter out = new PrintWriter(new FileWriter("C.out"))) {
            try (Reader in = new FileReader(args[0])) {
                Scanner scanner = new Scanner(in);
                int cases = scanner.nextInt();
                for (int i = 0; i < cases; i++) {
                    int values = 0;
                    BigInteger a = new BigInteger(scanner.next());
                    BigInteger b = new BigInteger(scanner.next());
                    while (a.compareTo(b) <= 0) {
                        if (isPalindrome(a)) {
                            BigInteger root = sqrt(a);
                            if (root != null) {
                                if (isPalindrome(root)) {
                                    values++;
                                }
                            }
                        }
                        a = a.add(BigInteger.ONE);
                    }
                    scanner.nextLine();
                    out.println(String.format("Case #%d: %d", (i+1), values));
                }
            } catch (IOException e) {
                System.err.println(e);
            }
        } catch (IOException e) {
            System.err.println(e);
        }
    }
}
