import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class GoroSort {

    private static boolean isValidSplit( List<Integer> elements, int split ) {
        for ( int i = 0; i < split; i++ ) {
            for ( int j = split; j < elements.size(); j++ ) {
                if ( elements.get(i) > elements.get(j) ) {
                    return false;
                }
            }
        }
        return true;
    }

    private static Double expected( int size ) {
        Double expected = 0.0;
        for ( int i = 1; i <= 40; i++ ) {
            expected += i * ( Math.pow( factorial(size)-1, i-1 ) / Math.pow( factorial(size), i ));
        }
        return expected;
    }

    private static Double factorial( int n ) {
        Double factorial = 1.0;
        for ( int i = n; i > 1; i-- ) {
            factorial *= i;
        }
        return factorial;
    }

    public static void main( String[] args ) {

        String inputFilename = "/Users/jim/IdeaProjects/GoogleCodeJam/GoroSort/D-small-attempt0.in";
        try {

            BufferedReader in = new BufferedReader( new FileReader( new File( inputFilename )));

            Integer cases = Integer.valueOf( in.readLine().trim() );
            for ( int i = 0; i < cases; i++ ) {
                Integer numElements = Integer.valueOf( in.readLine().trim() );

                List<Integer> unsortedElements = new ArrayList<Integer>();
                StringTokenizer st = new StringTokenizer( in.readLine().trim() );
                for ( int j = 0; j < numElements; j++ ) {
                    Integer element = Integer.valueOf( st.nextToken().trim() );
                    if ( element != (j+1) ) {
                        unsortedElements.add( element );
                    }
                }

                int split = 2;
                Double bestSolution = expected( unsortedElements.size() );
                while ( split <= unsortedElements.size()-2 ) {
                    if ( isValidSplit( unsortedElements, split )) {
                        Double possibleSolution = expected( split ) + expected( unsortedElements.size() - split );
                        if ( possibleSolution < bestSolution ) {
                            bestSolution = possibleSolution;
                        }
                    }
                    split++;
                }

             System.out.println( String.format( "Case #%d: %f", i+1, bestSolution ));

            }

        } catch (IOException e) {
            e.printStackTrace();
        }


    }

}
