import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;


public class Solution {

	public static void main(String[] args) {
		new Solution();
	}

	public Solution() {
		
		// Built-in scanner to read input file
		Scanner s = null;
		try {
			s = new Scanner(new File("input.txt"));
		} catch (FileNotFoundException e) {
			System.err.println("Input file not found");
			e.printStackTrace();
			System.exit(1);
		}
		s.useDelimiter("\\n");
		
		// Number of test grids to read
		final int T = s.nextInt();
		
		String result;
		// For each test grid
		for(int test=1;test<=T;test++) {
			// Fill the corresponding array
			char[][] grid = new char[4][4];
			// Jump to the beginning of the grid
			s.nextLine();
			for(int i=0;i<4;i++) {
				String l = s.nextLine();
				for(int j=0;j<4;j++) {
					grid[i][j] = l.charAt(j);
				}
			}
			// Find the result and display it
			result = this.compute(grid);
			System.out.println("Case #"+test+": "+result);
		}
		
		s.close();
	}
	
	public final String compute(final char[][] grid) {
		
		boolean xonly,oonly,fullgrid;
		
		// True if and only if the grid is full.
		fullgrid = true;
		
		// Horizontal and vertical scan
		for(int scan=0;scan<=1;scan++) {
			for(int i=0;i<4;i++) {
				xonly = true;
				oonly = true;
				for(int j=0;j<4;j++) {
					switch(scan==0 ? grid[i][j] : grid[j][i]) {
					case '.':
						oonly = false;
						xonly = false;
						fullgrid = false;
						break;
					case 'X':
						oonly = false;
						break;
					case 'O':
						xonly = false;
						break;
					default:
						
					}
				}
				if(xonly)
					return "X won";
				if(oonly)
					return "O won";
			}
		}
		
		// Diagonal scan
		for(int scan=0;scan<=1;scan++) {
			xonly = true;
			oonly = true;
			for(int i=0;i<4;i++) {
				switch(scan==0 ? grid[i][i] : grid[i][3-i]) {
				case '.':
					oonly = false;
					xonly = false;
					break;
				case 'X':
					oonly = false;
					break;
				case 'O':
					xonly = false;
				}
			}
			if(xonly)
				return "X won";
			if(oonly)
				return "O won";
		}
		
		// Draw, the grid is full and no one won
		if(fullgrid)
			return "Draw";
		
		// No one won but the grid is incomplete
		return "Game has not completed";
	}
	
}
