import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class Solution {

	private int N;
	private int[] sizes;
	private int operations;
	
	public static void main(String[] args) {
		new Solution();
	}
	
	public Solution() {
		// Built-in scanner to read input file
		Scanner s = null;
		try {
			s = new Scanner(new File("input.txt"));
		} catch (FileNotFoundException e) {
			System.err.println("Input file not found");
			e.printStackTrace();
			System.exit(1);
		}
		s.useDelimiter(" |\\n");
		
		// Built-in writer to save the results
		PrintWriter out = null;
		try {
			out = new PrintWriter("output.txt");
		} catch (FileNotFoundException e) {
			System.err.println("Output file not writable");
			e.printStackTrace();
			System.exit(1);
		}
		
		// Number of tests
		final int T = s.nextInt();

		for(int test=1;test<=T;test++) {
			
			int startSize = s.nextInt();
			N = s.nextInt();
			
			sizes = new int[N];
			for(int i=0;i<N;i++)
				sizes[i] = s.nextInt();
			
			Arrays.sort(sizes);
			
			operations = 0;
			
			// Cannot eat anything
			if(startSize == 1)
				operations = N;
			else
				operations = operationsRequired(0,startSize);

			out.println("Case #"+test+": "+operations);
		}
		
		s.close();
		out.flush();
		out.close();
	}
	
	public int operationsRequired(final int startPos,final int startSize) {
		int operations = 0;
		int size = startSize;
		
		if(startPos>N-1)
			return 0;
		
		for(int i=startPos;i<N;i++) {
			
			if(size>sizes[i]) {
				size += sizes[i];
			}
			else {
				
				int addCount = 0;
				while(size<=sizes[i]) {
					// Add a mote of size (current size-1)
					size += size-1;
					addCount++;
				}
				size += sizes[i];
				
				// Deleting is more efficient
				if((addCount+operationsRequired(i+1,size))>N-i) {
					operations += N-i;
					break;
				}
				else {
					operations += addCount;
				}
			}
		}
		
		return operations;
	}
}