import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class Solution {

	private int X;
	private int Y;
	
	public static void main(String[] args) {
		new Solution();
	}
	
	public Solution() {
		// Built-in scanner to read input file
		Scanner s = null;
		try {
			s = new Scanner(new File("input.txt"));
		} catch (FileNotFoundException e) {
			System.err.println("Input file not found");
			e.printStackTrace();
			System.exit(1);
		}
		s.useDelimiter(" |\\n");
		
		// Built-in writer to save the results
		PrintWriter out = null;
		try {
			out = new PrintWriter("output.txt");
		} catch (FileNotFoundException e) {
			System.err.println("Output file not writable");
			e.printStackTrace();
			System.exit(1);
		}
		
		// Number of tests
		final int T = s.nextInt();

		for(int test=1;test<=T;test++) {

			final int N = s.nextInt();
			this.X = s.nextInt();
			this.Y = s.nextInt();
			
			// Maximum coordinates of diamonds
			final int width = 2*(Math.abs(X)+Y)+1;
			final int height = (Math.abs(X)+Y)+1;
			
			// Minimum number of diamonds to have P>0
			int minD = 0;
			int n = Math.abs(X)+Y-1; // h=0
			while(n>=0) {
				minD += n;
				n--;
			}
			
			// Maximum number of diamonds to have P=1
			int maxD = 0;
			n = Math.abs(X)+Y+1; // h=0
			while(n>=0) {
				maxD += n;
				n--;
			}
			
			double result;
			
			if(N<=minD)
				result = 0.0;
			else if(N>=maxD)
				result = 1.0;
			else
				result = this.compute(0,0,N-minD);
			
			out.println("Case #"+test+": "+result);
		}
		
		s.close();
		out.flush();
		out.close();
	}

	public final double compute(int leftNum,int rightNum,int diamonds) {
		
		if(X==0)
			return 0.0;
		else if(X>=0 && (X+Y-rightNum+1)<=X)
			return 1.0;
		else if(X<=0 && (-X+Y-leftNum+1)<=-X)
			return 1.0;
		else if(diamonds==0)
			return 0.0;
		else
			return 0.5*this.compute(leftNum+1,rightNum,diamonds-1)+0.5*this.compute(leftNum,rightNum+1,diamonds-1);
	}
	
}