import java.io.*;
import java.util.*;
import java.math.*;

public class Main implements Runnable {
  public static void main (String[] args)
    throws IOException
  {
    new Thread (new Main()).start ();
  }

  public void run ()
  {
    try {
      in = new BufferedReader (new FileReader (new File (filename + ".in")));
      out = new PrintWriter (new BufferedWriter (new FileWriter (new File (filename + ".out"))));

      solve ();

      in.close ();
      out.close ();
    } catch (IOException e) {
      throw new RuntimeException (e);
    }
  }

  private void solve ()
    throws IOException
  {
    int C = Integer.parseInt (in.readLine ());
    for (int test = 1; test <= C; ++test) {
      String[] data = in.readLine ().split (" ");
      int N = Integer.parseInt (data[0]);
      if (N + 1 != data.length)
        throw new RuntimeException ("Cannot parse input on test " + test);

      BigInteger[] events = new BigInteger[N];
      for (int i = 0; i < N; ++i) {
        events[i] = new BigInteger (data[i + 1]);
      }

      Arrays.sort (events);
      BigInteger T = events[1].subtract (events[0]);
      for (int i = 2; i < N; ++i) {
        T = T.gcd (events[i].subtract (events[0]));
      }

      BigInteger y = events[0].mod (T);
      if (!y.equals (BigInteger.ZERO))
        y = T.subtract (y);

      out.println ("Case #" + test + ": " + y);
    }
  }

  private BufferedReader in;
  private PrintWriter out;

  private static String filename = "B-small-attempt0";
}