import java.util.*;
import java.io.*;
import java.math.*;

class Main implements Runnable {
  
  public static void main (String[] args)
  {
    new Thread (new Main()).start ();
  }

  public void run ()
  {
    try {
      in = new BufferedReader (new FileReader (new File (filename + ".in")));
      out = new PrintWriter (new BufferedWriter (new FileWriter (new File (filename + ".out"))));

      tokenizer = new StreamTokenizer (in);

      solve ();

      in.close ();
      out.close();
    } catch (IOException e) {
      throw new RuntimeException (e);
    }
  }

  private void solve ()
    throws IOException
  {
    int T = nextInt ();
    for (int test = 1; test <= T; ++test) {
      int R, k, N;
      R = nextInt ();
      k = nextInt ();
      N = nextInt ();
      int[] g = new int[N];
      int[] next = new int[N];
      int[] ind = new int[N];
      long[] summ = new long[N];
      for (int i = 0; i < N; ++i) {
        g[i] = nextInt ();
        ind[i] = -1;
        next[i] = -1;
      }

      long total = 0;
      int i = 0, j = 0;
      while (R > 0 && ind[i] == -1) {
        int step = g[i];
        summ[i] = total;
        for (next[i] = (i + 1) % N; i != next[i] && step + g[next[i]] <= k; next[i] = (next[i] + 1) % N)
          step += g[next[i]];
        total += step;
        ind[i] = j++;
        i = next[i];
        --R;
      }
      total += (total - summ[i]) * (R / (j - ind[i]));
      R = R % (j - ind[i]);
      while (R > 0) {
        total += summ[next[i]] - summ[i];
        i = next[i];
        --R;
      }

      out.println ("Case #" + test + ": " + total);
    }
  }

  private int nextInt ()
    throws IOException
  {
    tokenizer.nextToken ();
    return (int) tokenizer.nval;
  }

  private BufferedReader in;
  private PrintWriter out;
  private StreamTokenizer tokenizer;

  private static String filename = "C-small-attempt0";
}