import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;


public class TicTacToe {

	private static final int xAddition = 'X'+'X'+'X'+'X';
	private static final int xtAddition = 'T'+'X'+'X'+'X';
	private static final int oAddition = 'O'+'O'+'O'+'O';
	private static final int otAddition = 'T'+'O'+'O'+'O';
	
	
	public static void main(String[] args) throws IOException {
		
		List<String> listOfInputStrings = FileUtils.readLines(new File("input.txt"));
		List<String> resultList = new ArrayList<String>();
		
		int count = Integer.parseInt(listOfInputStrings.get(0));
		for(int i=0; i<count; i++){
			String result = solveTheGame(listOfInputStrings.subList(1 + 5*i, 5*i+5));
			resultList.add("Case #" + (i+1) + ": " + result);
			System.out.printf("Case #%d: %s\n", (i+1), result);
		}
		
		FileUtils.forceDelete(new File("output.txt"));
		FileUtils.writeLines(new File("output.txt"), resultList);
	}

	private static String solveTheGame(List<String> input) {

		String result = null;
		
		result = checkForWon(input);
		if(result != null){
			return result;
		}

		if(containsDots(input)){
			return "Game has not completed";
		} 
		
		return "Draw";
	}

	private static boolean containsDots(List<String> input) {
		for (int i = 0; i < 4; i++) {
			for(int j=0;j<4;j++){
				if(input.get(i).charAt(j) == '.'){
					return true;
				}
			}
		}
		return false;
	}

	private static String checkForWon(List<String> input) {

		for (int i = 0; i < 4; i++) {
			int addition = 0;
			for(int j=0;j<4;j++){
				addition += input.get(i).charAt(j);
			}

			String result = checkAddition(addition);
			if(result != null){
				return result;
			}
		}

		for (int i = 0; i < 4; i++) {
			int addition = 0;
			for(int j=0;j<4;j++){
				addition += input.get(j).charAt(i);
			}
			
			String result = checkAddition(addition);
			if(result != null){
				return result;
			}
		}

		int addition = 0;
		for (int i = 0; i < 4; i++) {
			addition += input.get(i).charAt(i);
		}
		String result = checkAddition(addition);
		if(result != null){
			return result;
		}
		
		addition = 0;
		for (int i=3, j=0; i>=0 && j<4; i--,j++) {
			addition += input.get(i).charAt(j);
		}
		result = checkAddition(addition);
		if(result != null){
			return result;
		}
		
		return null;
	}

	private static String checkAddition(int addition) {
		if(addition == xAddition || addition == xtAddition){
			return "X won";
		}
		if(addition == oAddition || addition == otAddition){
			return "O won";
		}
		return null;
	}

}
