package com.google.codejam;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class MagicTrick {

    public static void main(String[] args) throws IOException {

        List<String> outputList = new ArrayList<String>();
        
        List<String> inputList = Files.readAllLines(Paths.get("/home/neo/Projects/CodeJam/resources/input.txt"), Charset.defaultCharset());
        int total = Integer.parseInt(inputList.get(0));

        for (int ctr = 0; ctr < total; ctr++) {

            int i = ctr*10+1;
            int ans1 = Integer.parseInt(inputList.get(i));
            List<Integer> cards1 = getCardArray(i + 1, ans1, inputList);
            int ans2 = Integer.parseInt(inputList.get(i + 5));
            List<Integer> cards2 = getCardArray(i + 6, ans2, inputList);

            String output = testCase(cards1, cards2);

            System.out.println(output);
            outputList.add("Case #" + (ctr+1) + ": " + output);
        }

        Files.deleteIfExists(Paths.get("/home/neo/Projects/CodeJam/resources/output.txt"));
        Files.write(Paths.get("/home/neo/Projects/CodeJam/resources/output.txt"), outputList, Charset.defaultCharset());
    }

    private static String testCase(List<Integer> cards1, List<Integer> cards2) {

        cards1.retainAll(cards2);

        if (cards1.size() == 0) {
            return "Volunteer cheated!";
        }
        if (cards1.size() == 1) {
            return cards1.get(0) + "";
        }
        if (cards1.size() > 1) {
            return "Bad magician!";
        }

        return "";
    }

    private static List<Integer> getCardArray(int c, int selected, List<String> inputList) {

        List<Integer> cards = new ArrayList<Integer>();
        String[] input = inputList.get(c + selected - 1).split(" ");
        for (int i = 0; i < 4; i++) {
            cards.add(Integer.parseInt(input[i]));
        }
        return cards;
    }


}
