package com.google.codejam;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public strictfp class CookieClickerAlpha {

    public static void main(String[] args) throws IOException {

        List<String> outputList = new ArrayList<String>();
        
        List<String> inputList = Files.readAllLines(Paths.get("/home/neo/Projects/CodeJam/resources/input.txt"), Charset.defaultCharset());
        int ct = Integer.parseInt(inputList.get(0));

        for (int i = 1; i <= ct; i++) {

            String input[] = inputList.get(i).split(" ");
            Double output = testCase(Double.parseDouble(input[0]), Double.parseDouble(input[1]), Double.parseDouble(input[2]));

            DecimalFormat df = new DecimalFormat("0.0000000");
            System.out.println(df.format(output));
            outputList.add("Case #" + i + ": " + df.format(output));
        }

        Files.deleteIfExists(Paths.get("/home/neo/Projects/CodeJam/resources/output.txt"));
        Files.write(Paths.get("/home/neo/Projects/CodeJam/resources/output.txt"), outputList, Charset.defaultCharset());
    }

    private static Double testCase(double cost, double f, double x) {

        boolean check = true;
        double ctr = 0.0f, rate = 2.0f;
        double secs = 0;


        while (ctr < x) {

            secs += ((cost - ctr) / rate);
            ctr = cost;
            if (ctr > x) {
                break;
            }

            double c2go = x - ctr;
            double secsAtCurrentRate = c2go / rate;
            double secsIfBought = (c2go + cost) / (rate + f);

            if (secsAtCurrentRate < secsIfBought) {
                return secs + secsAtCurrentRate;
            } else {
                ctr -= cost;
                rate += f;
            }
        }

        // Seconds were incrementing by 1. Time to be accurate.
        double gap = ctr - x;
        secs = secs - (gap / rate);

        return secs;
    }
}
