import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;


public class LawnMower {

	public static void main(String[] args) throws IOException {
		
		List<String> listOfInputStrings = FileUtils.readLines(new File("input.txt"));
		List<String> resultList = new ArrayList<String>();
		
		int count = Integer.parseInt(listOfInputStrings.get(0));
		
		int nextCounter=1;
		for(int i=0; i<count; i++){
			
			String[] inputStrings = listOfInputStrings.get(nextCounter++).split(" ");
			int n = Integer.parseInt(inputStrings[0]);
			int m = Integer.parseInt(inputStrings[1]);
			int[][] inputMatrix = toArray(n,m,listOfInputStrings.subList(nextCounter, nextCounter+n));
			
			String result = isPatternPossible(inputMatrix);
			resultList.add("Case #" + (i+1) + ": " + result);
			System.out.printf("Case #%d: %s\n", (i+1), result);

			nextCounter = nextCounter + n;
		}
		
		FileUtils.forceDelete(new File("output.txt"));
		FileUtils.writeLines(new File("output.txt"), resultList);
	}

	private static String isPatternPossible(int[][] inputMatrix) {

		String result = "YES";
				
		outer:
		for (int i = 0; i < inputMatrix.length; i++) {
			for (int j = 0; j < inputMatrix[0].length; j++) {
				if(!numberReachesEdge(i, j, inputMatrix)){
					result = "NO";
					break outer;
				}
			}
		}		
		return result;
	}

	private static boolean numberReachesEdge(int i, int j, int[][] a) {

		boolean leftReachable = true;
		boolean rightReachable = true;
		boolean topReachable = true;
		boolean bottomReachable = true;
		
		int number = a[i][j];
		for (int ctr = i+1; ctr < a.length; ctr++) {
			if(a[ctr][j] != number){
				bottomReachable = false;
			}
		}
		for (int ctr = i-1; ctr >= 0; ctr--) {
			if(a[ctr][j] != number){
				topReachable = false;
			}
		}
		for (int ctr = j+1; ctr < a[0].length; ctr++) {
			if(a[i][ctr] != number){
				rightReachable = false;
			}
		}
		for (int ctr = j-1; ctr >= 0; ctr--) {
			if(a[i][ctr] != number){
				leftReachable = false;
			}
		}
		return leftReachable || rightReachable || topReachable || bottomReachable;
	}

	private static int[][] toArray(int n, int m, List<String> subList) {

		int[][] array = new int[n][m];
		
		for (int i = 0; i < n; i++) {
			String[] row = subList.get(i).split(" ");
			for (int j = 0; j < m; j++) {
				array[i][j] = Integer.parseInt(row[j]);
			}
		}
		
		
		return array;
	}
}