import java.util.* ;
import java.io.* ;
import java.util.regex.* ;
import java.text.* ;
import java.math.* ;

public class Main {
	public static void main( String[] args ) {
		InputStream isObj ;
		OutputStream osObj ;
		InputReader irObj ;
		PrintWriter pwObj ;
		String inputFileName , outputFileName ;
		File fObj1 , fObj2 ;
		int T , ind ;
		boolean hasMoreInput , hasTestCases ;
		ProblemSolver psObj ;
		//only variable to be changed here is hasTestCases and osObj(optional for file output)
		hasTestCases = ProblemSolver.HAS_TEST_CASES ;
		isObj = System.in ;
		osObj = System.out ;
		inputFileName = ProblemSolver.INPUT_FILE_NAME ;
		outputFileName = ProblemSolver.OUTPUT_FILE_NAME ;
		try {
			fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\" + inputFileName ) ;
			fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\" + outputFileName ) ;
			if( fObj1.exists() == false ) {
				fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + inputFileName ) ;
				fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + outputFileName ) ;
			}
			isObj = new FileInputStream( fObj1 ) ;
			if( ProblemSolver.DO_OUTPUT_TO_FILE == true ) {
				osObj = new FileOutputStream( fObj2 ) ;
			}
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			isObj = System.in ;
			osObj = System.out ;
		}
		irObj = new InputReader( isObj ) ;
		pwObj = new PrintWriter( osObj ) ;
		try {
			psObj = new ProblemSolver() ;
			if( hasTestCases == true ) {
				//for input with test cases
				T = irObj.nextInt() ;
				for( ind = 1 ; ind <= T ; ind++ ) {        	
					psObj.clearPerCase() ;
					psObj.getInput( irObj ) ;
					psObj.solveCase( pwObj ) ;
				}
			}
			else {
				//for end of file input
				for( ind = 1 ; ; ind++ ) {        	
					psObj.clearPerCase() ;
					hasMoreInput = psObj.getInput( irObj ) ;
					if( hasMoreInput == false ) {
						break ;
					}
					psObj.solveCase( pwObj ) ;
				}
			}
			pwObj.flush() ;
			isObj.close() ;
			osObj.close() ;
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			throw new RuntimeException( ex ) ;
		}
		finally {
			pwObj.close() ;
		}
	}
}

class ProblemSolver {
	public static final boolean HAS_TEST_CASES = true ;
	public static final String INPUT_FILE_NAME = "as.in" ;
	public static final String OUTPUT_FILE_NAME = "out.txt" ;
	public static final boolean DO_OUTPUT_TO_FILE = true ;
	 
	private void solveSmall( PrintWriter pwObj ) {
		int i , j , a , b , c , k , lim , mask , u , cnt ;
		int[] zrr ;
		int res ;
		zrr = new int[ this.lim1 ] ;
		res = 0 ;
		a = this.n ;
		lim = ( 1 << a ) ;
		for( u = 0 ; u < lim ; u++ ) {
			mask = u ;
			cnt = 0 ;
			for( i = 0 ; i < this.n ; i++ ) {
				if( ( mask & ( 1 << i ) ) != 0 ) {
					zrr[ cnt ] = i ;
					cnt++ ;
				}
			}
			for( i = 0 ; i < cnt ; i++ ) {
				
			}
		}
		pwObj.println( "Case #" + this.ind + ": " + res ) ;
	}
	
	private void solveLarge( PrintWriter pwObj ) {
		int i , j , a , b , c , d , e , f , g , len , k , l ;
		char ch ;
		int res ;
		res = 0 ;
		Arrays.fill( this.arr , 0 ) ;
		Arrays.sort( this.srr , 0 , this.n ) ;
		a = Integer.MIN_VALUE ;
		for( l = 0 ; l < 110 ; l++ ) {
			if( this.arr[ 0 ] >= this.srr[ 0 ].length() ) {
				res = -1 ;
				break ;
			}
			ch = this.srr[ 0 ].charAt( this.arr[ 0 ] ) ;
			this.cn = 0 ;
			for( i = 0 ; i < this.n ; i++ ) {
				len = this.srr[ i ].length() ;
				k = this.arr[ i ] ;
				b = 0 ;
				for( j = this.arr[ i ] ; j < len ; j++ ) {
					if( this.srr[ i ].charAt( j ) != ch ) {
						break ;
					}
					k = j ;
					b++ ;
				}
				if( b == 0 ) {
					res = -1 ;
					break ;
				}
				this.brr[ this.cn ] = b ;
				this.cn++ ;
				this.arr[ i ] = k + 1 ;
			}
			if( res == -1 ) {
				break ;
			}
			e = Integer.MAX_VALUE ;
			for( j = 0 ; j <= 100 ; j++ ) {
				d = 0 ;
				for( i = 0 ; i < this.cn ; i++ ) {
					d += Math.abs( this.brr[ i ] - j ) ;
				}
				e = Math.min( e , d ) ;
			}
			res += e ;
			c = 0 ;
			for( i = 0 ; i < this.n ; i++ ) {
				if( this.arr[ i ] < this.srr[ i ].length() ) {
					c = 1 ;
					break ;
				}
			}
			if( c == 0 ) {
				break ;
			}
		}
		if( res == -1 ) {
			pwObj.println( "Case #" + this.ind + ": Fegla Won" ) ;
		}
		else {
			pwObj.println( "Case #" + this.ind + ": " + res ) ;
		}
	}
	
	public void solveCase( PrintWriter pwObj ) {
		//this.solveSmall( pwObj ) ;
		this.solveLarge( pwObj ) ;
	}
	
	private void init() {
		//default values
		this.lim1 = 1000010 ;
		this.lim2 = 110 ;		
		this.cc = 1 ;
		this.ind = 0 ;
		this.declareArrays() ;
		this.fillAllArrays() ;
	}
	
	public boolean getInput( InputReader irObj ) {
		int i ;
		try {
			this.n = irObj.nextInt() ;
		}
		catch( Exception ex ) {
			return false ;
		}
		for( i = 0 ; i < this.n ; i++ ) {
			this.srr[ i ] = irObj.nextString() ;			
		}
		return true ;
	}
	
	private int lim1 , lim2 , cn , ind , cc , n ; 
	private String[] srr ;
	private int[] arr , brr ;
	private Node[] nrr ;
	private long[] lrr ;
	private int[][] memo , done ;
	private ArrayList< Integer >[] adj_list ;
	
	public void clearPerCase() {
		this.incrementInd() ;
		this.incrementCc() ;
		this.n = 0 ;
		this.cn = 0 ;
		Arrays.fill( this.arr , 0 ) ;
	}
	
	private void declareArrays() {
		//array declarations
		this.arr = new int[ this.lim1 ] ;
		this.brr = new int[ this.lim1 ] ;
		this.lrr = new long[ this.lim1 ] ;
		this.srr = new String[ this.lim1 ] ;
		this.nrr = new Node[ this.lim1 ] ;
		this.memo = new int[ this.lim2 ][ this.lim2 ] ;
		this.done = new int[ this.lim2 ][ this.lim2 ] ;
		this.adj_list = new ArrayList[ this.lim1 ] ;
	}
	
	private void fillAllArrays() {
		int i ;
		//array initiations
		Arrays.fill( this.arr , 0 ) ;
		Arrays.fill( this.brr , 0 ) ;
		Arrays.fill( this.lrr , 0 ) ;
		for( int zrr[] : this.memo ) {
			Arrays.fill( zrr , -1 ) ;
		}
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		for( i = 0 ; i < this.lim1 ; i++ ) {
			this.srr[ i ] = new String( "" ) ;
			this.nrr[ i ] = new Node( Integer.MIN_VALUE , Integer.MIN_VALUE ) ;
			this.adj_list[ i ] = new ArrayList< Integer >() ;
		}
	}
	
	private void incrementInd() {
		this.ind++ ;
	}
	
	public void setCn( int c ) {
		this.cn = c ;  
	}
	
	public void incrementCn() {
		this.cn++ ;
	}
	
	public void incrementCc() {
		this.cc++ ;
	}
	
	public int getCn() {
		return this.cn ;
	}
	
	public ProblemSolver() {
		this.init() ;
	}
}

class Node implements Comparable< Node > {
	private int v , f ;
	
	private Node() {
	}
	
	public Node( int vParam , int fParam ) {
		this.v = vParam ;
		this.f = fParam ;
	}
	
	public void setV( int vParam ) {
		this.v = vParam ;
	}
	
	public void setF( int fParam ) {
		this.f = fParam ;
	}
	
	public int getV() {
		return this.v ;
	}
	
	public int getF() {
		return this.f ;
	}
	
	public int compareTo( Node nParam ) {
		return this.getV() - nParam.getV() ;
	}
}

class InputReader {
	private BufferedReader reader ;
	private StringTokenizer tokenizer ;

	public InputReader( InputStream stream ) {
		this.reader = new BufferedReader( new InputStreamReader( stream ) ) ;
		this.tokenizer = null ;
	}

	private String next( int fl ) {
		while( this.tokenizer == null || ! this.tokenizer.hasMoreTokens() ) {
			try {                
				this.tokenizer = new StringTokenizer( this.reader.readLine() ) ;
			}
			catch( IOException e ) {
				throw new RuntimeException( e ) ;
			}
		}
		String s ;
		s = "" ;
		if( fl == 1 ) {
			s = this.tokenizer.nextToken() ; 
		}
		return s ;
	}

	public String nextLine() {
		this.next( 0 ) ;
		int fl ;
		String line ;
		line = "" ;
		fl = 0 ;
		if( this.tokenizer != null ) {
			while( this.tokenizer.hasMoreTokens() ) {
				if( fl == 1 ) {
					line += " " ;
				}
				fl = 1 ;
				line += this.tokenizer.nextToken() ;
			}
		}
		return line ;
	}

	public int nextInt() {
		return Integer.parseInt( this.next( 1 ) ) ;
	}

	public long nextLong() {
		return Long.parseLong( this.next( 1 ) ) ;
	}

	public double nextDouble() {
		return Double.parseDouble( this.next( 1 ) ) ;
	}

	public String nextString() {
		return this.next( 1 ) ;
	}
}
