import java.util.* ;
import java.io.* ;
import java.util.regex.* ;
import java.text.* ;
import java.math.* ;

public class Main {
	public static void main( String[] args ) {
		InputStream isObj ;
		OutputStream osObj ;
		InputReader irObj ;
		PrintWriter pwObj ;
		String inputFileName , outputFileName ;
		File fObj1 , fObj2 ;
		int T , ind ;
		boolean hasMoreInput , hasTestCases ;
		ProblemSolver psObj ;
		//only variable to be changed here is hasTestCases and osObj(optional for file output)
		hasTestCases = ProblemSolver.HAS_TEST_CASES ;
		isObj = System.in ;
		osObj = System.out ;
		inputFileName = ProblemSolver.INPUT_FILE_NAME ;
		outputFileName = ProblemSolver.OUTPUT_FILE_NAME ;
		try {
			fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\" + inputFileName ) ;
			fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\" + outputFileName ) ;
			if( fObj1.exists() == false ) {
				fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + inputFileName ) ;
				fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + outputFileName ) ;
			}
			isObj = new FileInputStream( fObj1 ) ;
			if( ProblemSolver.DO_OUTPUT_TO_FILE == true ) {
				osObj = new FileOutputStream( fObj2 ) ;
			}
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			isObj = System.in ;
			osObj = System.out ;
		}
		irObj = new InputReader( isObj ) ;
		pwObj = new PrintWriter( osObj ) ;
		try {
			psObj = new ProblemSolver() ;
			if( hasTestCases == true ) {
				//for input with test cases
				T = irObj.nextInt() ;
				for( ind = 1 ; ind <= T ; ind++ ) {        	
					psObj.clearPerCase() ;
					psObj.getInput( irObj ) ;
					psObj.solveCase( pwObj ) ;
				}
			}
			else {
				//for end of file input
				for( ind = 1 ; ; ind++ ) {        	
					psObj.clearPerCase() ;
					hasMoreInput = psObj.getInput( irObj ) ;
					if( hasMoreInput == false ) {
						break ;
					}
					psObj.solveCase( pwObj ) ;
				}
			}
			pwObj.flush() ;
			isObj.close() ;
			osObj.close() ;
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			throw new RuntimeException( ex ) ;
		}
		finally {
			pwObj.close() ;
		}
	}
}

class ProblemSolver {
	public static final boolean HAS_TEST_CASES = true ;
	public static final String INPUT_FILE_NAME = "cs.in" ;
	public static final String OUTPUT_FILE_NAME = "out.txt" ;
	public static final boolean DO_OUTPUT_TO_FILE = true ;
	 
	private boolean check( int[][] zrr , int[] vis ) {
		int i , j ;
		for( i = 1 ; i <= this.n ; i++ ) {
			if( vis[ i ] == 0 ) {
				return false ;
			}
		}
		for( i = 1 ; i <= this.n ; i++ ) {
			for( j = 1 ; j <= this.n ; j++ ) {
				if( zrr[ i ][ j ] == 2 && zrr[ i ][ j ] != 2 ) {
					return false ;
				}
			}
		}
		return true ;
	}
	
	private void rec( int[][] zrr , int u , int[] vis , int startCity , String temp ) {
		int i , j , k , l , v ;
		int[][] tempZrr ;
		int[] tempVis ;
		tempVis = new int[ this.lim1 ] ;
		tempZrr = new int[ this.lim1 ][ this.lim1 ] ;
		if( this.check( zrr , vis ) == true ) {
			if( temp.compareTo( this.res ) < 0 ) {
				this.res = temp ;
			}
			return ;
		}
		//outbound flight
		for( l = 1 ; l <= this.n ; l++ ) {
			if( l != startCity && vis[ l ] == 0 && zrr[ u ][ l ] == 1 && zrr[ l ][ u ] == 1 ) {
				for( i = 1 ; i <= this.n ; i++ ) {
					tempVis[ i ] = vis[ i ] ;
					for( j = 1 ; j <= this.n ; j++ ) {
						tempZrr[ i ][ j ] = zrr[ i ][ j ] ;
					}
				}
				tempVis[ l ] = 1 ;
				tempZrr[ u ][ l ] = 2 ;
				this.rec( tempZrr , l , tempVis , startCity , temp + this.srr[ l ] ) ;
			}
		}
		//return flight
		for( l = 1 ; l <= this.n ; l++ ) {
			if( vis[ l ] == 1 && zrr[ l ][ u ] == 2 && zrr[ u ][ l ] == 1 ) {
				for( i = 1 ; i <= this.n ; i++ ) {
					tempVis[ i ] = vis[ i ] ;
					for( j = 1 ; j <= this.n ; j++ ) {
						tempZrr[ i ][ j ] = zrr[ i ][ j ] ;
					}
				}
				tempVis[ l ] = 1 ;
				tempZrr[ u ][ l ] = 2 ;
				this.rec( tempZrr , l , tempVis , startCity , temp ) ;
			}
		}
	}
	
	private void solveSmall( PrintWriter pwObj ) {
		int i , j , a , b , c , k , lim , mask , u , cnt ;
		this.res = new String( "99999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999999" ) ;
		for( i = 1 ; i <= this.n ; i++ ) {
			int[][] zrr ;
			int[] vis ;
			vis = new int[ this.lim1 ] ;
			zrr = new int[ this.lim1 ][ this.lim1 ] ;
			Arrays.fill( vis , 0 ) ;
			for( int xrr[] : zrr ) {
				Arrays.fill( xrr , 0 ) ;
			}
			for( j = 1 ; j <= this.n ; j++ ) {
				for( k = 1 ; k <= this.n ; k++ ) {
					zrr[ j ][ k ] = this.done[ j ][ k ] ;
				}
			}
			vis[ i ] = 1 ;
			this.rec( zrr , i , vis , i , "" + this.srr[ i ] ) ;
		}
		pwObj.println( "Case #" + this.ind + ": " + res ) ;
	}
	
	private void solveLarge( PrintWriter pwObj ) {
		int i , j ;
		int res ;
		res = 0 ;
		for( i = 0 ; i < this.n ; i++ ) {
			res += this.arr[ i ] ;
		}
		pwObj.println( "Case #" + this.ind + ": " + res ) ;
	}
	
	public void solveCase( PrintWriter pwObj ) {
		this.solveSmall( pwObj ) ;
		//this.solveLarge( pwObj ) ;
	}
	
	private void init() {
		//default values
		this.lim1 = 10 ;
		this.lim2 = 10 ;		
		this.cc = 1 ;
		this.ind = 0 ;
		this.declareArrays() ;
		this.fillAllArrays() ;
	}
	
	public boolean getInput( InputReader irObj ) {
		int i , u , v ;
		try {
			this.n = irObj.nextInt() ;
		}
		catch( Exception ex ) {
			return false ;
		}
		this.m = irObj.nextInt() ;
		for( i = 1 ; i <= this.n ; i++ ) {
			this.srr[ i ] = irObj.nextString() ;			
		}
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		for( i = 0 ; i < this.m ; i++ ) {
			u = irObj.nextInt() ;
			v = irObj.nextInt() ;
			this.done[ u ][ v ] = 1 ;
			this.done[ v ][ u ] = 1 ;
		}
		return true ;
	}
	
	private int lim1 , lim2 , cn , ind , cc , n , m ; 
	private String res ;
	private String[] srr ;
	private int[] arr , brr ;
	private Node[] nrr ;
	private long[] lrr ;
	private int[][] memo , done ;
	private ArrayList< Integer >[] adj_list ;
	
	public void clearPerCase() {
		this.incrementInd() ;
		this.incrementCc() ;
		this.n = 0 ;
		this.cn = 0 ;
		Arrays.fill( this.arr , 0 ) ;
		Arrays.fill( this.brr , 0 ) ;
		Arrays.fill( this.lrr , 0 ) ;
		for( int zrr[] : this.memo ) {
			Arrays.fill( zrr , -1 ) ;
		}
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		int i ;
		for( i = 0 ; i < this.lim1 ; i++ ) {
			this.adj_list[ i ].clear() ;
		}
	}
	
	private void declareArrays() {
		//array declarations
		this.arr = new int[ this.lim1 ] ;
		this.brr = new int[ this.lim1 ] ;
		this.lrr = new long[ this.lim1 ] ;
		this.srr = new String[ this.lim1 ] ;
		this.nrr = new Node[ this.lim1 ] ;
		this.memo = new int[ this.lim2 ][ this.lim2 ] ;
		this.done = new int[ this.lim2 ][ this.lim2 ] ;
		this.adj_list = new ArrayList[ this.lim1 ] ;
	}
	
	private void fillAllArrays() {
		int i ;
		//array initiations
		Arrays.fill( this.arr , 0 ) ;
		Arrays.fill( this.brr , 0 ) ;
		Arrays.fill( this.lrr , 0 ) ;
		for( int zrr[] : this.memo ) {
			Arrays.fill( zrr , -1 ) ;
		}
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		for( i = 0 ; i < this.lim1 ; i++ ) {
			this.srr[ i ] = new String( "" ) ;
			this.nrr[ i ] = new Node( Integer.MIN_VALUE , Integer.MIN_VALUE ) ;
			this.adj_list[ i ] = new ArrayList< Integer >() ;
		}
	}
	
	private void incrementInd() {
		this.ind++ ;
	}
	
	public void setCn( int c ) {
		this.cn = c ;  
	}
	
	public void incrementCn() {
		this.cn++ ;
	}
	
	public void incrementCc() {
		this.cc++ ;
	}
	
	public int getCn() {
		return this.cn ;
	}
	
	public ProblemSolver() {
		this.init() ;
	}
}

class Node implements Comparable< Node > {
	private int v , f ;
	
	private Node() {
	}
	
	public Node( int vParam , int fParam ) {
		this.v = vParam ;
		this.f = fParam ;
	}
	
	public void setV( int vParam ) {
		this.v = vParam ;
	}
	
	public void setF( int fParam ) {
		this.f = fParam ;
	}
	
	public int getV() {
		return this.v ;
	}
	
	public int getF() {
		return this.f ;
	}
	
	public int compareTo( Node nParam ) {
		return this.getV() - nParam.getV() ;
	}
}

class InputReader {
	private BufferedReader reader ;
	private StringTokenizer tokenizer ;

	public InputReader( InputStream stream ) {
		this.reader = new BufferedReader( new InputStreamReader( stream ) ) ;
		this.tokenizer = null ;
	}

	private String next( int fl ) {
		while( this.tokenizer == null || ! this.tokenizer.hasMoreTokens() ) {
			try {                
				this.tokenizer = new StringTokenizer( this.reader.readLine() ) ;
			}
			catch( IOException e ) {
				throw new RuntimeException( e ) ;
			}
		}
		String s ;
		s = "" ;
		if( fl == 1 ) {
			s = this.tokenizer.nextToken() ; 
		}
		return s ;
	}

	public String nextLine() {
		this.next( 0 ) ;
		int fl ;
		String line ;
		line = "" ;
		fl = 0 ;
		if( this.tokenizer != null ) {
			while( this.tokenizer.hasMoreTokens() ) {
				if( fl == 1 ) {
					line += " " ;
				}
				fl = 1 ;
				line += this.tokenizer.nextToken() ;
			}
		}
		return line ;
	}

	public int nextInt() {
		return Integer.parseInt( this.next( 1 ) ) ;
	}

	public long nextLong() {
		return Long.parseLong( this.next( 1 ) ) ;
	}

	public double nextDouble() {
		return Double.parseDouble( this.next( 1 ) ) ;
	}

	public String nextString() {
		return this.next( 1 ) ;
	}
}
