import java.util.* ;
import java.io.* ;
import java.util.regex.* ;
import java.text.* ;
import java.math.* ;

class ProblemSolver {
	public static final boolean HAS_TEST_CASES = true ;
	public static final String INPUT_FILE_NAME = "c14.in" ;
	public static final String OUTPUT_FILE_NAME = "out.txt" ;
	public static final boolean DO_OUTPUT_TO_FILE = true ;
	
	private void initResArray() {
		int i , j ;
		for( i = 0 ; i < this.lim2 ; i++ ) {
			for( j = 0 ; j < this.lim2 ; j++ ) {
				this.crr[ i ][ j ] = '.' ;
			}
		}
	}
	
	private void outputGrid( PrintWriter pwObj ) {
		int i , j ;
		String str ;
		str = new String( "" ) ;
		for( i = 0 ; i < this.r ; i++ ) {
			str = "" ;
			for( j = 0 ; j < this.c ; j++ ) {
				str += this.crr[ i ][ j ] ;
			}
			pwObj.println( str ) ;
		}
	}
	
	private void rec( int x , int y ) {
		this.done[ x ][ y ] = 1 ;
		int i , a , nx , ny ;
		
		if(this.checkCell(x, y) == true ) {
			for( i = 0 ; i < 8 ; i++ ) {
				nx = this.dx[ i ] + x ;
				ny = this.dy[ i ] + y ;
				if( nx >= 0 && nx < this.r && ny >= 0 && ny < this.c && this.done[ nx ][ ny ] == 0 ) {
					this.rec( nx , ny ) ;
				}
			}
		}
	}
	
	private boolean checkDone() {
		int i , j ;
		for( i = 0 ; i < this.r ; i++ ) {
			for( j = 0 ; j < this.c ; j++ ) {
				if( this.done[ i ][ j ] == 0 && this.crr[ i ][ j ] == '.' ) {
					return false ;
				}
			}
		}
		return true ;
	}
	
	private void initPerRun() {
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		this.initResArray() ;
	}
	
	private boolean checkCell( int x , int y ) {
		int i , nx , ny ;
		for( i = 0 ; i < 8 ; i++ ) {
			nx = x + this.dx[ i ] ;
			ny = y + this.dy[ i ] ;
			if( nx >= 0 && nx < this.r && ny >= 0 && ny < this.c ) {
				if( this.crr[ nx ][ ny ] == '*' ) {
					return false ;
				}
			}
		}
		return true ;
	}
	
	public void solveCase( PrintWriter pwObj ) {
		int i , j , a , lim , b , mask , k , d ;
		int res ;
		res = -1 ;
		a = this.m ;
		b = this.r * this.c ;
		if( a == b - 1 ) {
			res = 1 ;
			this.initPerRun() ;
			for( i = 0 ; i < this.r ; i++ ) {
				for( j = 0 ; j < this.c ; j++ ) {
					this.crr[ i ][ j ] = '*' ;
				}
			}
			this.crr[ 0 ][ 0 ] = 'c' ;
		}
		else {
			lim = 1 << b ;
			for( i = 0 ; i < lim ; i++ ) {
				mask = i ;
				d = 0 ;
				for(j = 1; j <= mask; j <<= 1){
					if( (i & j) != 0)
						d++;
				}
				/*
				for( j = 0 ; j < b ; j++ ) {
					if( ( mask & ( 1 << j ) ) != 0 ) {
						d++ ;
					}
				}
				*/
				if( d == a ) {
					this.initPerRun() ;
					for( j = 0 ; j < this.r ; j++ ) {
						for( k = 0 ; k < this.c ; k++ ) {
							int hb = j * this.c + k ;
							if( ( mask & ( 1 << hb ) ) != 0 ) {
								this.crr[ j ][ k ] = '*' ;
							}
						}
					}
					for( j = 0 ; j < this.r ; j++ ) {
						for( k = 0 ; k < this.c ; k++ ) {
							if( this.crr[ j ][ k ] == '.' ) {
								if( this.checkCell( j , k ) == true ) {
									for( int zrr[] : this.done ) {
										Arrays.fill( zrr , 0 ) ;
									}
									this.rec( j , k ) ;
									if( this.checkDone() == true ) {
										this.crr[ j ][ k ] = 'c' ;
										res = mask ;
										break ;
									}
								}
							}
						}
						if( res != -1 ) {
							break ;
						}
					}
					if( res != -1 ) {
						break ;
					}
				}
			}
		}
		pwObj.println( "Case #" + this.ind + ":" ) ;
		if( res == -1 ) {
			pwObj.println( "Impossible" ) ;
		}
		else {
			this.outputGrid( pwObj ) ;
		}
	}
	
	private void init() {
		//default values
		this.lim1 = 55 ;
		this.lim2 = 55 ;
		this.cc = 1 ;
		this.ind = 0 ;
		this.declareArrays() ;
		this.fillAllArrays() ;
	}
	
	public boolean getInput( InputReader irObj ) {
		try {
			this.r = irObj.nextInt() ;
		}
		catch( Exception ex ) {
			return false ;
		}
		this.c = irObj.nextInt() ;
		this.m = irObj.nextInt() ;
		return true ;
	}
	
	private int lim1 , lim2 , cn , ind , cc , n , r , c , m , resX , resY ; 
	private String[] srr ;
	private char[][] crr ;
	private int[] arr , brr , dx , dy ;
	private Node[] nrr ;
	private long[] lrr ;
	private int[][] memo , done ;
	private ArrayList< Integer >[] adj_list ;
	
	public void clearPerCase() {
		this.incrementInd() ;
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		this.initResArray() ;
	}
	
	private void declareArrays() {
		//array declarations
		this.arr = new int[ this.lim1 ] ;
		this.brr = new int[ this.lim1 ] ;
		this.dx = new int[ this.lim2 ] ;
		this.dy = new int[ this.lim2 ] ;
		this.crr = new char[ this.lim2 ][ this.lim2 ] ;
		this.lrr = new long[ this.lim1 ] ;
		this.srr = new String[ this.lim1 ] ;
		this.nrr = new Node[ this.lim1 ] ;
		this.memo = new int[ this.lim2 ][ this.lim2 ] ;
		this.done = new int[ this.lim2 ][ this.lim2 ] ;
		this.adj_list = new ArrayList[ this.lim1 ] ;
	}
	
	private void fillAllArrays() {
		int i ;
		this.cn = 0 ;
		//array initiations
		this.dx[ this.cn ] = 0 ;
		this.dy[ this.cn ] = +1 ;
		this.cn++ ;
		this.dx[ this.cn ] = 0 ;
		this.dy[ this.cn ] = -1 ;
		this.cn++ ;
		this.dx[ this.cn ] = +1 ;
		this.dy[ this.cn ] = 0 ;
		this.cn++ ;
		this.dx[ this.cn ] = +1 ;
		this.dy[ this.cn ] = +1 ;
		this.cn++ ;
		this.dx[ this.cn ] = +1 ;
		this.dy[ this.cn ] = -1 ;
		this.cn++ ;
		this.dx[ this.cn ] = -1 ;
		this.dy[ this.cn ] = 0 ;
		this.cn++ ;
		this.dx[ this.cn ] = -1 ;
		this.dy[ this.cn ] = +1 ;
		this.cn++ ;
		this.dx[ this.cn ] = -1 ;
		this.dy[ this.cn ] = -1 ;
		this.cn++ ;
		Arrays.fill( this.arr , 0 ) ;
		Arrays.fill( this.brr , 0 ) ;
		Arrays.fill( this.lrr , 0 ) ;
		for( int zrr[] : this.memo ) {
			Arrays.fill( zrr , -1 ) ;
		}
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		for( i = 0 ; i < this.lim1 ; i++ ) {
			this.srr[ i ] = new String( "" ) ;
			this.nrr[ i ] = new Node( Integer.MIN_VALUE , Integer.MIN_VALUE ) ;
			this.adj_list[ i ] = new ArrayList< Integer >() ;
		}
	}
	
	private void incrementInd() {
		this.ind++ ;
	}
	
	public void incrementCc() {
		this.cc++ ;
	}
	
	public int getCn() {
		return this.cn ;
	}
	
	public ProblemSolver() {
		this.init() ;
	}
}

public class Main {
	public static void main( String[] args ) {
		InputStream isObj ;
		OutputStream osObj ;
		InputReader irObj ;
		PrintWriter pwObj ;
		String inputFileName , outputFileName ;
		File fObj1 , fObj2 ;
		int T , ind ;
		boolean hasMoreInput , hasTestCases ;
		ProblemSolver psObj ;
		//only variable to be changed here is hasTestCases and osObj(optional for file output)
		hasTestCases = ProblemSolver.HAS_TEST_CASES ;
		isObj = System.in ;
		osObj = System.out ;
		inputFileName = ProblemSolver.INPUT_FILE_NAME ;
		outputFileName = ProblemSolver.OUTPUT_FILE_NAME ;
		try {
			fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\" + inputFileName ) ;
			fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\" + outputFileName ) ;
			if( fObj1.exists() == false ) {
				fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + inputFileName ) ;
				fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + outputFileName ) ;
			}
			isObj = new FileInputStream( fObj1 ) ;
			if( ProblemSolver.DO_OUTPUT_TO_FILE == true ) {
				osObj = new FileOutputStream( fObj2 ) ;
			}
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			isObj = System.in ;
			osObj = System.out ;
		}
		irObj = new InputReader( isObj ) ;
		pwObj = new PrintWriter( osObj ) ;
		try {
			psObj = new ProblemSolver() ;
			if( hasTestCases == true ) {
				//for input with test cases
				T = irObj.nextInt() ;
				for( ind = 1 ; ind <= T ; ind++ ) {        	
					psObj.clearPerCase() ;
					psObj.getInput( irObj ) ;
					psObj.solveCase( pwObj ) ;
				}
			}
			else {
				//for end of file input
				for( ind = 1 ; ; ind++ ) {        	
					psObj.clearPerCase() ;
					hasMoreInput = psObj.getInput( irObj ) ;
					if( hasMoreInput == false ) {
						break ;
					}
					psObj.solveCase( pwObj ) ;
				}
			}
			pwObj.flush() ;
			isObj.close() ;
			osObj.close() ;
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			throw new RuntimeException( ex ) ;
		}
		finally {
			pwObj.close() ;
		}
	}
}

class Node implements Comparable< Node > {
	private int v , f ;
	
	private Node() {
	}
	
	public Node( int vParam , int fParam ) {
		this.v = vParam ;
		this.f = fParam ;
	}
	
	public void setV( int vParam ) {
		this.v = vParam ;
	}
	
	public void setF( int fParam ) {
		this.f = fParam ;
	}
	
	public int getV() {
		return this.v ;
	}
	
	public int getF() {
		return this.f ;
	}
	
	public int compareTo( Node nParam ) {
		return this.getV() - nParam.getV() ;
	}
}

class InputReader {
	private BufferedReader reader ;
	private StringTokenizer tokenizer ;

	public InputReader( InputStream stream ) {
		this.reader = new BufferedReader( new InputStreamReader( stream ) ) ;
		this.tokenizer = null ;
	}

	private String next( int fl ) {
		while( this.tokenizer == null || ! this.tokenizer.hasMoreTokens() ) {
			try {                
				this.tokenizer = new StringTokenizer( this.reader.readLine() ) ;
			}
			catch( IOException e ) {
				throw new RuntimeException( e ) ;
			}
		}
		String s ;
		s = "" ;
		if( fl == 1 ) {
			s = this.tokenizer.nextToken() ; 
		}
		return s ;
	}

	public String nextLine() {
		this.next( 0 ) ;
		int fl ;
		String line ;
		line = "" ;
		fl = 0 ;
		if( this.tokenizer != null ) {
			while( this.tokenizer.hasMoreTokens() ) {
				if( fl == 1 ) {
					line += " " ;
				}
				fl = 1 ;
				line += this.tokenizer.nextToken() ;
			}
		}
		return line ;
	}

	public int nextInt() {
		return Integer.parseInt( this.next( 1 ) ) ;
	}

	public long nextLong() {
		return Long.parseLong( this.next( 1 ) ) ;
	}

	public double nextDouble() {
		return Double.parseDouble( this.next( 1 ) ) ;
	}

	public String nextString() {
		return this.next( 1 ) ;
	}
}
