import java.util.* ;
import java.io.* ;
import java.util.regex.* ;
import java.text.* ;
import java.math.* ;

class ProblemSolver {
	public static final boolean HAS_TEST_CASES = true ;
	public static final String INPUT_FILE_NAME = "cl.in" ;
	public static final String OUTPUT_FILE_NAME = "out_1.txt" ;
	public static final boolean DO_OUTPUT_TO_FILE = true ;
	
	private void initResArray() {
		int i , j ;
		for( i = 0 ; i < this.lim2 ; i++ ) {
			for( j = 0 ; j < this.lim2 ; j++ ) {
				this.crr[ i ][ j ] = '.' ;
			}
		}
		this.crr[ 0 ][ 0 ] = 'c' ;
	}
	
	private int assignRowFirst( int z ) {
		int i , j ;
		for( i = this.r - 1 ; i >= 0 ; i-- ) {
			if( z == 0 ) {
				break ;
			}
			for( j = this.c - 1 ; j >= 0 ; j-- ) {
				if( z == 0 ) {
					break ;
				}
				if( ! ( ( i == 0 && j == 0 ) || ( i == 0 && j == 1 ) || ( i == 1 && j == 0 ) || ( i == 1 && j == 1 ) ) ) {
					if( this.crr[ i ][ j ] != '*' ) {
						this.crr[ i ][ j ] = '*' ;
						z-- ;
					}
				}
			}
		}
		return z ;
	}
	
	private int specialRowFirst( int z ) {
		int i , j ;
		for( i = this.r - 1 ; i >= 2 ; i-- ) {
			if( z == 0 ) {
				break ;
			}
			for( j = this.c - 1 ; j >= 2 ; j-- ) {
				if( z == 0 ) {
					break ;
				}
				if( ! ( ( i == 0 && j == 0 ) || ( i == 0 && j == 1 ) || ( i == 1 && j == 0 ) || ( i == 1 && j == 1 ) ) ) {
					if( this.crr[ i ][ j ] != '*' ) {
						this.crr[ i ][ j ] = '*' ;
						z-- ;
					}
				}
			}
		}
		return z ;
	}
	
	private int assignColumnFirst( int z ) {
		int i , j ;
		for( j = this.c - 1 ; j >= 0 ; j-- ) {
			if( z == 0 ) {
				break ;
			}
			for( i = this.r - 1 ; i >= 0 ; i-- ) {	
				if( z == 0 ) {
					break ;
				}
				if( ! ( ( i == 0 && j == 0 ) || ( i == 0 && j == 1 ) || ( i == 1 && j == 0 ) || ( i == 1 && j == 1 ) ) ) {
					if( this.crr[ i ][ j ] != '*' ) {
						this.crr[ i ][ j ] = '*' ;
						z-- ;
					}
				}
			}
		}
		return z ;
	}
	
	private void outputGrid( PrintWriter pwObj ) {
		int i , j ;
		String str ;
		str = new String( "" ) ;
		for( i = 0 ; i < this.r ; i++ ) {
			str = "" ;
			for( j = 0 ; j < this.c ; j++ ) {
				str += this.crr[ i ][ j ] ;
			}
			pwObj.println( str ) ;
		}
	}
	
	private int initFirstColumnFill( int leftOverRow , int rem ) {
		int a ;
		if( rem == 0 ) {
			return rem ;
		}
		a = ( rem / leftOverRow ) ;
		if( a > this.c - 2 ) {
			a = this.c - 2 ;
		}
		this.takenColumns = a ;
		a *= leftOverRow ;
		this.assignColumnFirst( a ) ;
		return rem - a ; 
	}
	
	private int initFirstRowFill() {
		int a , leftOverRow , rem , u ;
		a = this.m ;
		if( this.m == 0 ) {
			return 0 ;
		}
		for( u = this.r - 2 ; u >= 0 ; u-- ) {
			this.initResArray() ;
			if( u * this.c <= this.m ) {
				a = u ;
				this.takenRows = a ;
				a *= this.c ;
				this.assignRowFirst( a ) ;
				leftOverRow = this.r - ( a / this.c ) ; 
				rem = this.m - a ; 
				if( rem == 0 ) {
					return 0 ;
				}
				a = this.initFirstColumnFill( leftOverRow , rem ) ;
				if( a == 0 ) {
					return 0 ;
				}
				else {
					a = this.specialRowFirst( a ) ;
					if( a == 0 ) {
						return 0 ;
					}
				}
			}
		}
		return a ; 
	}
	
	public void solveCase( PrintWriter pwObj ) {
		int i , j , a , b , d , leftOverRow , z ;
		int res ;
		res = 0 ;
		this.initResArray() ;
		if( this.m == ( this.r * this.c ) - 1 ) {
			for( i = 0 ; i < this.r ; i++ ) {
				for( j = 0 ; j < this.c ; j++ ) {
					this.crr[ i ][ j ] = '*' ;
				}
			}
			this.crr[ 0 ][ 0 ] = 'c' ;
			a = 0 ;
		}
		else if( this.r == 1 || this.c == 1 ) {
			b = 0 ;
			for( i = this.r - 1 ; i >= 0 ; i-- ) {
				for( j = this.c - 1 ; j >= 0 ; j-- ) {
					if( i == 0 && j == 0 ) {
						continue ;
					}
					if( b >= this.m ) {
						break ;
					}
					this.crr[ i ][ j ] = '*' ;
					b++ ;
				}
			}
			this.crr[ 0 ][ 0 ] = 'c' ;
			a = 0 ;
		}
		else {
			a = this.initFirstRowFill() ;
			if( a > 0 ) {
				a = this.specialRowFirst( a ) ;
			}
		}
		if( a > 0 ) {
			z = this.r ;
			this.r = this.c ;
			this.c = z ;
			this.initResArray() ;
			a = this.initFirstRowFill() ;
			if( a > 0 ) {
				a = this.specialRowFirst( a ) ;
			}
			z = this.r ;
			this.r = this.c ;
			this.c = z ;
		}
		pwObj.println( "Case #" + this.ind + ":" ) ;
		if( a > 0 ) {
			pwObj.println( "Impossible" ) ;
		}
		else {
			this.outputGrid( pwObj ) ;
		}
	}
	
	private void init() {
		//default values
		this.lim1 = 55 ;
		this.lim2 = 55 ;		
		this.cc = 1 ;
		this.ind = 0 ;
		this.declareArrays() ;
		this.fillAllArrays() ;
	}
	
	public boolean getInput( InputReader irObj ) {
		int i ;
		try {
			this.r = irObj.nextInt() ;
		}
		catch( Exception ex ) {
			return false ;
		}
		this.c = irObj.nextInt() ;
		this.m = irObj.nextInt() ;
		return true ;
	}
	
	private int lim1 , lim2 , cn , ind , cc , n , r , c , m , takenRows , takenColumns ; 
	private String[] srr ;
	private char[][] crr ;
	private int[] arr , brr ;
	private Node[] nrr ;
	private long[] lrr ;
	private int[][] memo , done ;
	private ArrayList< Integer >[] adj_list ;
	
	public void clearPerCase() {
		this.incrementInd() ;
		this.incrementCc() ;
		this.n = 0 ;
		this.cn = 0 ;
	}
	
	private void declareArrays() {
		//array declarations
		this.arr = new int[ this.lim1 ] ;
		this.brr = new int[ this.lim1 ] ;
		this.crr = new char[ this.lim2 ][ this.lim2 ] ;
		this.lrr = new long[ this.lim1 ] ;
		this.srr = new String[ this.lim1 ] ;
		this.nrr = new Node[ this.lim1 ] ;
		this.memo = new int[ this.lim2 ][ this.lim2 ] ;
		this.done = new int[ this.lim2 ][ this.lim2 ] ;
		this.adj_list = new ArrayList[ this.lim1 ] ;
	}
	
	private void fillAllArrays() {
		int i , j ;
		//array initiations
		Arrays.fill( this.arr , 0 ) ;
		Arrays.fill( this.brr , 0 ) ;
		Arrays.fill( this.lrr , 0 ) ;
		for( int zrr[] : this.memo ) {
			Arrays.fill( zrr , -1 ) ;
		}
		for( int zrr[] : this.done ) {
			Arrays.fill( zrr , 0 ) ;
		}
		for( i = 0 ; i < this.lim1 ; i++ ) {
			this.srr[ i ] = new String( "" ) ;
			this.nrr[ i ] = new Node( Integer.MIN_VALUE , Integer.MIN_VALUE ) ;
			this.adj_list[ i ] = new ArrayList< Integer >() ;
		}
	}
	
	private void incrementInd() {
		this.ind++ ;
	}
	
	public void setCn( int c ) {
		this.cn = c ;  
	}
	
	public void incrementCn() {
		this.cn++ ;
	}
	
	public void incrementCc() {
		this.cc++ ;
	}
	
	public int getCn() {
		return this.cn ;
	}
	
	public ProblemSolver() {
		this.init() ;
	}
}

public class Main {
	public static void main( String[] args ) {
		InputStream isObj ;
		OutputStream osObj ;
		InputReader irObj ;
		PrintWriter pwObj ;
		String inputFileName , outputFileName ;
		File fObj1 , fObj2 ;
		int T , ind ;
		boolean hasMoreInput , hasTestCases ;
		ProblemSolver psObj ;
		//only variable to be changed here is hasTestCases and osObj(optional for file output)
		hasTestCases = ProblemSolver.HAS_TEST_CASES ;
		isObj = System.in ;
		osObj = System.out ;
		inputFileName = ProblemSolver.INPUT_FILE_NAME ;
		outputFileName = ProblemSolver.OUTPUT_FILE_NAME ;
		try {
			fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\" + inputFileName ) ;
			fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\" + outputFileName ) ;
			if( fObj1.exists() == false ) {
				fObj1 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + inputFileName ) ;
				fObj2 = new File( System.getProperty( "user.dir" ).toString() + "\\src\\" + outputFileName ) ;
			}
			isObj = new FileInputStream( fObj1 ) ;
			if( ProblemSolver.DO_OUTPUT_TO_FILE == true ) {
				osObj = new FileOutputStream( fObj2 ) ;
			}
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			isObj = System.in ;
			osObj = System.out ;
		}
		irObj = new InputReader( isObj ) ;
		pwObj = new PrintWriter( osObj ) ;
		try {
			psObj = new ProblemSolver() ;
			if( hasTestCases == true ) {
				//for input with test cases
				T = irObj.nextInt() ;
				for( ind = 1 ; ind <= T ; ind++ ) {        	
					psObj.clearPerCase() ;
					psObj.getInput( irObj ) ;
					psObj.solveCase( pwObj ) ;
				}
			}
			else {
				//for end of file input
				for( ind = 1 ; ; ind++ ) {        	
					psObj.clearPerCase() ;
					hasMoreInput = psObj.getInput( irObj ) ;
					if( hasMoreInput == false ) {
						break ;
					}
					psObj.solveCase( pwObj ) ;
				}
			}
			pwObj.flush() ;
			isObj.close() ;
			osObj.close() ;
		}
		catch( Exception ex ) {
			ex.printStackTrace() ;
			throw new RuntimeException( ex ) ;
		}
		finally {
			pwObj.close() ;
		}
	}
}

class Node implements Comparable< Node > {
	private int v , f ;
	
	private Node() {
	}
	
	public Node( int vParam , int fParam ) {
		this.v = vParam ;
		this.f = fParam ;
	}
	
	public void setV( int vParam ) {
		this.v = vParam ;
	}
	
	public void setF( int fParam ) {
		this.f = fParam ;
	}
	
	public int getV() {
		return this.v ;
	}
	
	public int getF() {
		return this.f ;
	}
	
	public int compareTo( Node nParam ) {
		return this.getV() - nParam.getV() ;
	}
}

class InputReader {
	private BufferedReader reader ;
	private StringTokenizer tokenizer ;

	public InputReader( InputStream stream ) {
		this.reader = new BufferedReader( new InputStreamReader( stream ) ) ;
		this.tokenizer = null ;
	}

	private String next( int fl ) {
		while( this.tokenizer == null || ! this.tokenizer.hasMoreTokens() ) {
			try {                
				this.tokenizer = new StringTokenizer( this.reader.readLine() ) ;
			}
			catch( IOException e ) {
				throw new RuntimeException( e ) ;
			}
		}
		String s ;
		s = "" ;
		if( fl == 1 ) {
			s = this.tokenizer.nextToken() ; 
		}
		return s ;
	}

	public String nextLine() {
		this.next( 0 ) ;
		int fl ;
		String line ;
		line = "" ;
		fl = 0 ;
		if( this.tokenizer != null ) {
			while( this.tokenizer.hasMoreTokens() ) {
				if( fl == 1 ) {
					line += " " ;
				}
				fl = 1 ;
				line += this.tokenizer.nextToken() ;
			}
		}
		return line ;
	}

	public int nextInt() {
		return Integer.parseInt( this.next( 1 ) ) ;
	}

	public long nextLong() {
		return Long.parseLong( this.next( 1 ) ) ;
	}

	public double nextDouble() {
		return Double.parseDouble( this.next( 1 ) ) ;
	}

	public String nextString() {
		return this.next( 1 ) ;
	}
}
