import java.util.ArrayList;
import java.util.Scanner;
import java.util.PriorityQueue;

public class B{

	public static int lcm(PriorityQueue<Barber> bv, int bc){
		ArrayList<Integer> factors = new ArrayList<Integer>();
		for (Barber b : bv){
			int bmin = b.m;
			for (int factor : factors){
				if (bmin % factor == 0){
					bmin = bmin/factor;
				}
			}

			for (int prime=2; prime<=bmin; ++prime){
				while (bmin % prime == 0){
					bmin = bmin / prime;
					factors.add(prime);
				}
				if (bmin == 1){
					break;
				}
			}

		}
		
		int lcm = 1;
		for (int factor : factors){
			lcm *= factor;
		}

		return lcm;
	}
	
	public static void output(int t, int y){
		System.out.printf("Case #%d: %d\n", t+1, y);
	}

	public static void main(String[] args){
		int T;
		int N;
		int bc;
		PriorityQueue<Barber> bv = new PriorityQueue<Barber>();
		ArrayList<Integer> bcycle;
		int y;
		Scanner scan = new Scanner(System.in);

		T = scan.nextInt();
		for (int t=0; t<T; ++t){
			bc = scan.nextInt();
			N = scan.nextInt();
			for (int i=0; i<bc; ++i){
				Barber b = new Barber();
				b.k = i+1;
				b.m = scan.nextInt();
				b.next = 0;
				bv.add(b);
			}
			
			int lcm = B.lcm(bv, bc);
			int period = 0;
			for (Barber b : bv){
				period += lcm/b.m;
			}

			bcycle = new ArrayList<Integer>(period);
			for (int i=0; i<period; ++i){
				Barber b = bv.poll();
				b.next += b.m;
				bcycle.add(b.k);
				bv.add(b);
			}

			output(t, bcycle.get((N-1)%period));
			bv.clear();

		}

	}

}

class Barber implements Comparable<Barber>{
	public int k; //barber-ordinal
	public int m; //minutes per haircut
	public int next; //next available time

	@Override
	public int compareTo(Barber other){
		if (this.next > other.next){
			return 1;
		}else if(other.next > this.next){
			return -1;
		}else{
			return this.k - other.k;
		}
	}

	@Override
	public String toString(){return "(" + k + "," + m + "," + next + ")";}
}
