
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;
	
	public class A {
		BufferedReader br;
		StringTokenizer in;
		PrintWriter out;
		
		public String nextToken() throws IOException {
		    while (in == null || !in.hasMoreTokens()) {
		        in = new StringTokenizer(br.readLine());
		    }

		    return in.nextToken();
		}

		public int nextInt() throws IOException {
		    return Integer.parseInt(nextToken());
		}

		public long nextLong() throws IOException {
		    return Long.parseLong(nextToken());
		}

		public double nextDouble() throws IOException {
		    return Double.parseDouble(nextToken());
		}
		
		public void solve() throws IOException {
			br = new BufferedReader(new FileReader("A-large.in"));
	        out = new PrintWriter(System.out);
	        PrintWriter writer = new PrintWriter(" A-large.out", "UTF-8");
	        int tests = nextInt();
	        for(int c = 1 ; c <= tests ; c++) {
	        	int i = nextInt();
	        	if(i == 0) {
	        		writer.println("Case #"+c+": INSOMNIA");
					continue;
	        	}
	        	boolean [] digits = new boolean [10];
				int n = i;
				int count = update(digits,n);
				while(count != 10) {
					n += i;
					count += update(digits,n);
				}
				writer.println("Case #"+c+": "+n);
	        }
	        writer.close();
		}
	
	public static void main (String [] args) throws IOException {	
			new A().solve();
			
	}
	public int update(boolean [] digits, int n) {
		int changed = 0;
		while(n > 0) {
			int digit = n % 10;
			n /= 10;
			if(!digits[digit]) {
				changed++;
			}
			digits[digit] = true;
		}
		return changed;
	}
}
