package come.google.codejam.round1B;

import come.google.codejam.utils.FileUtils;

import java.io.BufferedWriter;
import java.util.ArrayList;
import java.util.HashSet;

/**
 * Created by qsang on 4/15/16.
 */
public class RoundOneBThree {
    public static void main(String[] args) {

        new RoundOneBThree();
    }

    private static final String SAMPLE_FILE = "round1B3.sample.in";
    private static final String SMALL_FILE = "round1B3.small.in";
    private static final String LARGE_FILE = "round1B3.large.in";

    private String problemFileName;
    private ArrayList<String> answers;

    public RoundOneBThree() {
        problemFileName = SMALL_FILE;
        try {
            ArrayList<String> inputContentLines = (ArrayList) FileUtils.readInputFile(this.problemFileName);
            BufferedWriter writer = FileUtils.createOutputFileBufferedWriter(this.problemFileName);

            int T, lineIndex = 0;
            T = Integer.parseInt(inputContentLines.get(lineIndex));

            int currentTest;
            String output;
            int N;
            String[] detail;
            for (currentTest = 1; currentTest <= T; currentTest++) {
                N = Integer.parseInt(inputContentLines.get(++lineIndex));
                detail = new String[N];
                for (int i = 0; i < N; i++) {
                    detail[i] = inputContentLines.get(++lineIndex);
                }
                answers = new ArrayList<String>();

                output = "Case #" + currentTest + ": " + solveProblem(detail, N) + "\n";
//                System.out.println(output);
                writer.write(output);
            }
            writer.flush();
            writer.close();
        } catch (Exception exception) {
            System.out.println(exception.getMessage());
        }
    }

    public int solveProblem(String[] detail, int size) {

        ArrayList<String> first = new ArrayList<String>();
        ArrayList<String> last = new ArrayList<String>();
        String[] words;
        int index;
        HashSet<Integer> fakeIndex = new HashSet<Integer>();

        boolean[][]fakes = new boolean[size][2];

        for (int i = 0; i < size; i++) {

            words = detail[i].split("\\ ");
            index = first.indexOf(words[0]);
            if (index != -1) {
                fakes[i][0] = true;
                fakes[index][0] = true;
                if (fakes[index][0] && fakes[index][1]) {
                    fakeIndex.add(index);
                }
            }
            first.add(words[0]);

            index = last.indexOf(words[1]);
            if (index != -1) {
                fakes[i][1] = true;
                fakes[index][1] = true;
                if (fakes[index][0] && fakes[index][1]) {
                    fakeIndex.add(index);
                }
            }
            last.add(words[1]);

            if (fakes[i][0] && fakes[i][1]) {
                fakeIndex.add(i);
            }
        }

        return fakeIndex.size();
    }

    static ArrayList<Integer> indexOfAll(Object obj, ArrayList list){
        ArrayList<Integer> indexList = new ArrayList<Integer>();
        for (int i = 0; i < list.size(); i++)
            if(obj.equals(list.get(i)))
                indexList.add(i);
        return indexList;
    }
}
