package come.google.codejam.round1B;

import come.google.codejam.utils.FileUtils;

import java.io.BufferedWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;

/**
 * Created by qsang on 4/15/16.
 */
public class RoundOneBTwo {
    public static void main(String[] args) {

        new RoundOneBTwo();
    }

    private static final String SAMPLE_FILE = "round1B2.sample.in";
    private static final String SMALL_FILE = "round1B2.small.in";
    private static final String LARGE_FILE = "round1B2.large.in";

    private String problemFileName;
    private ArrayList<String> answers;

    public RoundOneBTwo() {
        problemFileName = SMALL_FILE;
        try {
            ArrayList<String> inputContentLines = (ArrayList) FileUtils.readInputFile(this.problemFileName);
            BufferedWriter writer = FileUtils.createOutputFileBufferedWriter(this.problemFileName);

            int T, lineIndex = 0;
            T = Integer.parseInt(inputContentLines.get(lineIndex));

            int currentTest;
            String output;
            String detail;
            for (currentTest = 1; currentTest <= T; currentTest++) {
                detail = inputContentLines.get(++lineIndex);
                answers = new ArrayList<String>();

                output = "Case #" + currentTest + ": " + solveProblem(detail) + "\n";
                System.out.println(output);
                writer.write(output);
            }
            writer.flush();
            writer.close();
        } catch (Exception exception) {
            System.out.println(exception.getMessage());
        }
    }

    public String solveProblem(String detail) {
        String[] scores = detail.split("\\ ");

        char[] score1 = scores[0].toCharArray();
        char[] score2 = scores[1].toCharArray();

        int length = score1.length;
        char[] answer1 = new char[length];
        char[] answer2 = new char[length];

        char one = '0';
        char two = '0';
        boolean firstIndexFound = false;
        boolean numbersAreMissingInDifferentPosition = true;
        int x, y, index;


        for (int i = 0; i < length; i++) {
            if (score1[i] == '?' && score2[i] == '?') {
                answer1[i] = one;
                answer2[i] = two;
            } else if (score1[i] != '?' && score2[i] != '?') {
                x = Character.getNumericValue(score1[i]);
                y = Character.getNumericValue(score2[i]);
                if (x > y) {
                    if (numbersAreMissingInDifferentPosition) {
                        if (!firstIndexFound && (x - y) > 5) {
                            index = i - 1;
                            if (index >= 0) {
                                answer2[index] = '1';
                                one = '9';
                            } else {
                                two = '9';
                            }
                        } else {
                            two = '9';
                        }
                    }
                    numbersAreMissingInDifferentPosition = false;
                } else if (x < y) {
                    if (numbersAreMissingInDifferentPosition) {
                        if (!firstIndexFound && (y - x) > 5) {
                            index = i - 1;
                            if (index >= 0) {
                                answer1[index] = '1';
                                two = '9';
                            } else {
                                one = '9';
                            }
                        } else {
                            one = '9';
                        }
                    }
                    numbersAreMissingInDifferentPosition = false;
                }

                answer1[i] = score1[i];
                answer2[i] = score2[i];
                firstIndexFound = true;
            } else if (score1[i] == '?' && score2[i] != '?') {
                if (numbersAreMissingInDifferentPosition) {
                    answer1[i] = score2[i];
                    answer2[i] = score2[i];
                } else {
                    answer1[i] = one;
                    answer2[i] = score2[i];
                }
                firstIndexFound = true;
            } else if (score1[i] != '?' && score2[i] == '?') {
                if (numbersAreMissingInDifferentPosition) {
                    answer1[i] = score1[i];
                    answer2[i] = score1[i];
                } else {
                    answer1[i] = score1[i];
                    answer2[i] = two;
                }
                firstIndexFound = true;
            }
        }

        return new String(answer1) + " " + new String(answer2);
    }
}
