package Shadowvein.GoogleCodeJam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.net.URL;
import java.util.Arrays;

/**
 * Created with IntelliJ IDEA.
 * User: Sang
 * Date: 4/11/13
 * Time: 11:56 PM
 * To change this template use File | Settings | File Templates.
 */
public class CodeJam
{
    private String fileContent;
    private int testCaseNum;

    public CodeJam(String fileName)
    {
        this.fileContent = readFile(fileName);
    }

    private String readFile(String fileName)
    {
        String ret = "";
        FileReader fileReader = null;
        try
        {
            fileReader =  new FileReader(fileName);
            BufferedReader reader = new BufferedReader(fileReader);
            String line = "";
            line = reader.readLine();
            this.testCaseNum = Integer.parseInt(line);
            while ((line = reader.readLine()) != null)
                ret += line + "\n";
        }
        catch (Exception ex)
        {
            throw new RuntimeException(ex);
        }
        finally
        {
            if (fileReader != null)
            {
                try
                {
                    fileReader.close();
                }
                catch (Exception e)
                {
                    // Ignore issues during closing
                }
            }
        }

        return ret;
    }

    public void lawnmower()
    {
        int[][] table, anotherTable;
        String[] lines = this.fileContent.split("\\\n");

        boolean possiable;
        int lineNum = 0;
        int i, j, k;
        int m, n; // n lines, each line has m numbers
        int [] curRow, curCol;
        int curData;

        i = 0;
        while (i < this.testCaseNum)
        {
            i++;
            System.out.print("Case #" + i + ": ");

            String[] dimention = lines[lineNum].split("\\ ");
            n = Integer.parseInt(dimention[0]);
            m = Integer.parseInt(dimention[1]);
            table = new int[n][m];
            anotherTable = new int[m][n];
            possiable = true;

            for (j=0; j<n; j++)
            {
                lineNum++;
                String[] row = lines[lineNum].split("\\ ");
                for (k=0; k<m; k++)
                {
                    table[j][k] = Integer.parseInt(row[k]);
                    anotherTable[k][j] = Integer.parseInt(row[k]);
                }
            }

            for (j=0; j<n; j++)
            {
                for (k=0; k<m; k++)
                {
                    curRow = new int[m];
                    System.arraycopy( table[j], 0,curRow, 0, m);
                    curCol = new int[n];
                    System.arraycopy( anotherTable[k], 0, curCol, 0, n);
                    curData = table[j][k];

                    Arrays.sort(curRow);
                    Arrays.sort(curCol);

                    if (possiable)  possiable = (curData >= curRow[m-1]) || (curData >= curCol[n-1]);
                    if (!possiable) break;
                }
                if (!possiable) break;
            }

            lineNum++;
            System.out.println(possiable ? "YES" : "NO");
        }
    }

    public static void main(String [ ] args)
    {
        URL fileURL = CodeJam.class.getClassLoader().getResource("B-large.in");
        String fileName = fileURL.getPath();
        CodeJam codeJam = new CodeJam(fileName);
        codeJam.lawnmower();
    }
}