package Shadowvein.GoogleCodeJam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.net.URL;

/**
 * Created with IntelliJ IDEA.
 * User: Sang
 * Date: 4/11/13
 * Time: 11:56 PM
 * To change this template use File | Settings | File Templates.
 */
public class CodeJam
{
    private String fileContent;
    private int testCaseNum;

    public CodeJam(String fileName)
    {
        this.fileContent = readFile(fileName);
    }

    private String readFile(String fileName)
    {
        String ret = "";
        FileReader fileReader = null;
        try
        {
            fileReader =  new FileReader(fileName);
            BufferedReader reader = new BufferedReader(fileReader);
            String line = "";
            line = reader.readLine();
            this.testCaseNum = Integer.parseInt(line);
            while ((line = reader.readLine()) != null)
                ret += line + "\n";
        }
        catch (Exception ex)
        {
            throw new RuntimeException(ex);
        }
        finally
        {
            if (fileReader != null)
            {
                try
                {
                    fileReader.close();
                }
                catch (Exception e)
                {
                    // Ignore issues during closing
                }
            }
        }

        return ret;
    }

    public void ticTacToeTomek()
    {
        String x_won = "X won";
        String o_won = "O won";
        String draw = "Draw";
        String not_complete = "Game has not completed";

        int[][] table;
        String[] testCases = this.fileContent.split("\\\n\n");
        boolean gameCompleted;
        int[] sum_row = new int[4];
        int[] sum_col = new int[4];
        int[] sum_dia = new int[2];
        int caseNum = 0;
        for (int i=0; i<this.testCaseNum; i++)
        {
            caseNum++;
            gameCompleted = true;
            System.out.print("Case #" + caseNum + ": ");

            String[] row = testCases[i].split("\\\n");
            table = new int[4][4];
            for (int j=0; j<4; j++)
            {
                String[] element = row[j].split("");
                for (int k=0;k<4; k++)
                {
                    switch (element[k+1].charAt(0))
                    {
                        case 'X':
                            table[j][k] = 1;
                            break;
                        case 'O':
                            table[j][k] = 100;
                            break;
                        case 'T':
                            table[j][k] = 10000;
                            break;
                        case '.':
                            gameCompleted = false;
                            table[j][k] = 0;
                    }
                }
            }

            sum_row[0] = table[0][0] + table[0][1] + table[0][2] + table[0][3];
            sum_row[1] = table[1][0] + table[1][1] + table[1][2] + table[1][3];
            sum_row[2] = table[2][0] + table[2][1] + table[2][2] + table[2][3];
            sum_row[3] = table[3][0] + table[3][1] + table[3][2] + table[3][3];

            sum_col[0] = table[0][0] + table[1][0] + table[2][0] + table[3][0];
            sum_col[1] = table[0][1] + table[1][1] + table[2][1] + table[3][1];
            sum_col[2] = table[0][2] + table[1][2] + table[2][2] + table[3][2];
            sum_col[3] = table[0][3] + table[1][3] + table[2][3] + table[3][3];

            sum_dia[0] = table[0][0] + table[1][1] + table[2][2] + table[3][3];
            sum_dia[1] = table[0][3] + table[1][2] + table[2][1] + table[3][0];

            if (sum_row[0] == 4 || sum_row[1] == 4 || sum_row[2] == 4 || sum_row[3] == 4 ||
                sum_row[0] == 10003 || sum_row[1] == 10003 || sum_row[2] == 10003 || sum_row[3] == 10003 ||
                sum_col[0] == 4 || sum_col[1] == 4 || sum_col[2] == 4 || sum_col[3] == 4 ||
                sum_col[0] == 10003 || sum_col[1] == 10003 || sum_col[2] == 10003 || sum_col[3] == 10003 ||
                sum_dia[0] == 4 || sum_dia[1] == 4 || sum_dia[0] == 10003 || sum_dia[1] == 10003  )
                System.out.println(x_won);
            else if (sum_row[0] == 400 || sum_row[1] == 400 || sum_row[2] == 400 || sum_row[3] == 400 ||
                    sum_row[0] == 10300 || sum_row[1] == 10300 || sum_row[2] == 10300 || sum_row[3] == 10300 ||
                    sum_col[0] == 400 || sum_col[1] == 400 || sum_col[2] == 400 || sum_col[3] == 400 ||
                    sum_col[0] == 10300 || sum_col[1] == 10300 || sum_col[2] == 10300 || sum_col[3] == 10300 ||
                    sum_dia[0] == 400 || sum_dia[1] == 400 || sum_dia[0] == 10300 || sum_dia[1] == 10300 )
                System.out.println(o_won);
            else
                System.out.println(gameCompleted ? draw : not_complete);
        }
    }

    public static void main(String [ ] args)
    {
//        String fileName = "D:\\workspace\\GoogleCodeJam\\src\\test.txt";
        URL fileURL = CodeJam.class.getClassLoader().getResource("A-large.in");
        String fileName = fileURL.getPath();
        CodeJam codeJam = new CodeJam(fileName);
        codeJam.ticTacToeTomek();
    }
}