package come.google.codejam.round1B;

import come.google.codejam.utils.FileUtils;

import java.io.BufferedWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.StringTokenizer;

/**
 * Created by qsang on 4/15/16.
 */
public class RoundOneB {
    public static void main(String[] args) {

        new RoundOneB();
    }

    private static final String SAMPLE_FILE = "round1B.sample.in";
    private static final String SMALL_FILE = "round1B.small.in";
    private static final String LARGE_FILE = "round1B.large.in";

    private String problemFileName;

    public RoundOneB() {
        problemFileName = SMALL_FILE;
        try {
            ArrayList<String> inputContentLines = (ArrayList) FileUtils.readInputFile(this.problemFileName);
            BufferedWriter writer = FileUtils.createOutputFileBufferedWriter(this.problemFileName);

            int T, lineIndex = 0;
            T = Integer.parseInt(inputContentLines.get(lineIndex));

            int currentTest;
            String output;
            String detail;
            for (currentTest = 1; currentTest <= T; currentTest++) {
                detail = inputContentLines.get(++lineIndex);

                output = "Case #" + currentTest + ": " + solveProblem(detail) + "\n";
                writer.write(output);
            }
            writer.flush();
            writer.close();
        } catch (Exception exception) {
            System.out.println(exception.getMessage());
        }
    }

    public String solveProblem(String str) {

        str = str.toUpperCase();
        int zero = 0,
            one = 0,
            two = 0,
            three = 0,
            four = 0,
            five = 0,
            six = 0,
            seven = 0,
            eight = 0,
            nine = 0;
        while (str.contains("Z")) {
            zero++;
            str = str.replaceFirst("Z", "");
            str = str.replaceFirst("E", "");
            str = str.replaceFirst("R", "");
            str = str.replaceFirst("O", "");
        }

        while (str.contains("W")) {
            two++;
            str = str.replaceFirst("T", "");
            str = str.replaceFirst("W", "");
            str = str.replaceFirst("O", "");
        }

        while (str.contains("X")) {
            six++;
            str = str.replaceFirst("S", "");
            str = str.replaceFirst("I", "");
            str = str.replaceFirst("X", "");
        }

        while (str.contains("G")) {
            eight++;
            str = str.replaceFirst("E", "");
            str = str.replaceFirst("I", "");
            str = str.replaceFirst("G", "");
            str = str.replaceFirst("H", "");
            str = str.replaceFirst("T", "");
        }

        while (str.contains("S")) {
            seven++;
            str = str.replaceFirst("S", "");
            str = str.replaceFirst("E", "");
            str = str.replaceFirst("V", "");
            str = str.replaceFirst("E", "");
            str = str.replaceFirst("N", "");
        }

        while (str.contains("V")) {
            five++;
            str = str.replaceFirst("F", "");
            str = str.replaceFirst("I", "");
            str = str.replaceFirst("V", "");
            str = str.replaceFirst("E", "");
        }

        while (str.contains("F")) {
            four++;
            str = str.replaceFirst("F", "");
            str = str.replaceFirst("O", "");
            str = str.replaceFirst("U", "");
            str = str.replaceFirst("R", "");
        }

        while (str.contains("T")) {
            three++;
            str = str.replaceFirst("T", "");
            str = str.replaceFirst("H", "");
            str = str.replaceFirst("R", "");
            str = str.replaceFirst("E", "");
            str = str.replaceFirst("E", "");
        }

        while (str.contains("O")) {
            one++;
            str = str.replaceFirst("O", "");
            str = str.replaceFirst("N", "");
            str = str.replaceFirst("E", "");
        }

        nine = str.length() / 4;
        String answer = "";
        answer = answer + new String(new char[zero]).replace('\0', '0');
        answer = answer + new String(new char[one]).replace('\0', '1');
        answer = answer + new String(new char[two]).replace('\0', '2');
        answer = answer + new String(new char[three]).replace('\0', '3');
        answer = answer + new String(new char[four]).replace('\0', '4');
        answer = answer + new String(new char[five]).replace('\0', '5');
        answer = answer + new String(new char[six]).replace('\0', '6');
        answer = answer + new String(new char[seven]).replace('\0', '7');
        answer = answer + new String(new char[eight]).replace('\0', '8');
        answer = answer + new String(new char[nine]).replace('\0', '9');

        return answer;
    }
}
