package Shadowvein.GoogleCodeJam;

import java.io.*;
import java.net.URL;
import java.util.HashMap;

/**
 * Created with IntelliJ IDEA.
 * User: Sang
 * Date: 4/11/13
 * Time: 11:56 PM
 * To change this template use File | Settings | File Templates.
 */
public class CodeJam
{
    private String fileContent;
    private String outputContent;
    private int testCaseNum;

    public CodeJam(String fileName)
    {
        this.fileContent = readFile(fileName);
        this.outputContent = "";
    }

    private String readFile(String fileName)
    {
        String ret = "";
        FileReader fileReader = null;
        BufferedReader reader = null;
        try
        {
            fileReader =  new FileReader(fileName);
            reader = new BufferedReader(fileReader);
            String line = "";
            line = reader.readLine();
            this.testCaseNum = Integer.parseInt(line);
            while ((line = reader.readLine()) != null)
                ret += line + "\n";
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
        finally
        {
            try
            {
                reader.close();
                fileReader.close();
            }
            catch (Exception ex1)
            {
                ex1.printStackTrace();
            }
        }

        return ret;
    }

    private void outputFile(String fileName)
    {
        URL outputFileURL = CodeJam.class.getClassLoader().getResource(fileName);
        FileWriter writer = null;
        BufferedWriter out = null;
        try
        {
            writer = new FileWriter(outputFileURL.getPath());
            out = new BufferedWriter(writer);
            out.write(this.outputContent);
            out.flush();
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
        finally
        {
            try
            {
                out.close();
                writer.close();
            }
            catch (Exception ex1)
            {
                ex1.printStackTrace();
            }
        }
    }

    private HashMap<Integer, Boolean> fairNumberMap;  // number, isFair
    private void fairAndSquare()
    {
        String[] lines = this.fileContent.split("\\\n");
        this.fairNumberMap = new HashMap<Integer, Boolean>();

        int caseNUm = 0;
        int fairAndSquareNum;
        int start, end, current;
        boolean fair, square;

        while (caseNUm < this.testCaseNum)
        {
            fairAndSquareNum = 0;
            String[] points = lines[caseNUm].split("\\ ");
            start = Integer.parseInt(points[0]);
            end = Integer.parseInt(points[1]);
            caseNUm++;

            for (current = start; current <= end; current++)
            {
                fair = false;
                square = false;

                if (this.fairNumberMap.get(current) != null)
                    fair = this.fairNumberMap.get(current);
                else
                {
                    fair = isFair(current);
                    this.fairNumberMap.put(current, fair);
                }

                if (fair)
                    square = isSquare(current);

                if (fair && square)
                    fairAndSquareNum++;
            }

            this.outputContent = this.outputContent + "Case #" + caseNUm + ": " + fairAndSquareNum + "\n";
        }
    }

    private boolean isFair(int number)
    {
        boolean isFair = true;

        String numberStr = String.valueOf(number);
        int start = 0;
        int end = numberStr.length()-1;

        while ( (start < end) && isFair )
        {
            if (numberStr.charAt(start) != numberStr.charAt(end))
                isFair = false;

            start++;
            end--;
        }

        return isFair;
    }

    private boolean isSquare(int number)
    {
        boolean isSquare = false;

        double root = Math.sqrt(number);
        if (Math.rint(root) == root)
        {
            int rootInt = (int)root;
            if ( this.fairNumberMap.get(rootInt) != null )
                isSquare = this.fairNumberMap.get(rootInt);
            else
                isSquare = isFair(rootInt);
        }

        return isSquare;
    }

    public static void main(String [ ] args)
    {
        URL fileURL = CodeJam.class.getClassLoader().getResource("test.txt");
        String fileName = fileURL.getPath();
        CodeJam codeJam = new CodeJam(fileName);
        codeJam.fairAndSquare();
        codeJam.outputFile("output_small.txt");
        System.out.println("Done!!!");
    }
}