package come.google.codejam.qualification;

import come.google.codejam.utils.FileUtils;

import java.io.BufferedWriter;
import java.util.ArrayList;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created by qsang on 4/8/16.
 */
public class Pancakes {
    private static final String SAMPLE_FILE = "pancakes.sample.in";
    private static final String SMALL_FILE = "pancakes.small.in";
    private static final String LARGE_FILE = "pancakes.large.in";

    private static final Logger LOG= Logger.getLogger( Pancakes.class.getName() );

    private String problemFileName;

    public Pancakes() {
        this.problemFileName = SMALL_FILE;
        this.parseFile();
    }

    private void parseFile() {
        try {
            ArrayList<String> inputContentLines = (ArrayList) FileUtils.readInputFile(this.problemFileName);
            BufferedWriter writer = FileUtils.createOutputFileBufferedWriter(this.problemFileName);

            int T, lineIndex = 0;
            T = Integer.parseInt(inputContentLines.get(lineIndex));

            int currentTest, count;
            String detail, output;
            for (currentTest = 1; currentTest <= T; currentTest++) {
                detail = inputContentLines.get(++lineIndex);

                count = countFlips(detail);

                output = "Case #" + currentTest + ": " + count +  "\n";
//                System.out.println(output);
                writer.write(output);
            }

            writer.flush();
            writer.close();
        } catch (Exception exception) {
            LOG.log(Level.SEVERE, exception.toString(), exception);
        }
    }

    private int countFlips(String pancakes) {
        int flips = 0;

        char[] pancakesArray = pancakes.toCharArray();
        for (int i = pancakesArray.length - 1; i >= 0; i--) {
            if (pancakesArray[i] == '-') {
                flips++;
                pancakesArray = this.flip(pancakesArray, i);
            }
        }

        return flips;
    }

    private char[] flip(char[] pancakes, int index) {
        for (int i = 0; i <= index; i++) {
            switch (pancakes[i]) {
                case '+':
                    pancakes[i] = '-';
                    break;
                case '-':
                    pancakes[i] = '+';
                    break;
            }
        }
        return pancakes;
    }
}
