package come.google.codejam.qualification;

import come.google.codejam.utils.FileUtils;

import java.io.BufferedWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 * Created by qsang on 4/8/16.
 */
public class CountingSheep {
    private static final String SAMPLE_FILE = "countingSheep.sample.in";
    private static final String SMALL_FILE = "countingSheep.small.in";
    private static final String LARGE_FILE = "countingSheep.large.in";

    private static final Logger LOG= Logger.getLogger( CountingSheep.class.getName() );

    private String problemFileName;

    public CountingSheep() {
        this.problemFileName = this.LARGE_FILE;
        this.parseFile();
    }

    private void parseFile() {
        try {
            ArrayList<String> inputContentLines = (ArrayList) FileUtils.readInputFile(this.problemFileName);
            BufferedWriter writer = FileUtils.createOutputFileBufferedWriter(this.problemFileName);

            int T, N, lineIndex = 0;
            T = Integer.parseInt(inputContentLines.get(lineIndex));

            int currentTest, count;
            String output;
            for (currentTest = 1; currentTest <= T; currentTest++) {
                N = Integer.parseInt(inputContentLines.get(++lineIndex));
                count = countN(N);

                output = "Case #" + currentTest + ": " + ((count == -1)? "INSOMNIA" : count)  + "\n";
//                System.out.println(output);
                writer.write(output);
            }

            writer.flush();
            writer.close();
        } catch (Exception exception) {
            LOG.log(Level.SEVERE, exception.toString(), exception);
        }
    }

    private int countN(int N) {
        HashMap<Integer, ArrayList<Integer>> numberMap = new HashMap<Integer, ArrayList<Integer>>();
        int current = N, i, numOfCount = 1;
        char[] currentChars;
        int containsNumber = N;
        HashSet set;
        ArrayList<Integer> numberArray;
        while (this.checkMap(numberMap)) {
            currentChars = String.valueOf(current).toCharArray();

            set = new HashSet<Integer>();
            for (i = 0; i < currentChars.length; i++) {
                containsNumber = Character.getNumericValue(currentChars[i]);
                set.add(containsNumber);
            }

            Iterator it = set.iterator();
            while(it.hasNext()) {
                containsNumber = (Integer) it.next();
                numberArray = numberMap.containsKey(containsNumber) ? numberMap.get(containsNumber) : new ArrayList<Integer>();
                if (numberArray.contains(current)) {
                    return -1;
                }

                numberArray.add(current);
                numberMap.put(containsNumber, numberArray);
            }

            current = N * ++numOfCount;
        }

        return N * --numOfCount;
    }

    private boolean checkMap(HashMap map) {
        boolean flag = true;
        for (int i = 0; i < 10; i++) {
            flag = flag && map.containsKey(i);
            if (!flag) return true;
        }

        return !flag;
    }

}
