import java.util.*;
import java.io.*;

public class ProblemMain {
    
    public static void flip(StringBuffer s, int start_pos, int flip_count )
    {
        for( int i_pos = start_pos; i_pos < (start_pos + flip_count); i_pos++ )
        {
            if( s.charAt(i_pos) == '+' )
            {
                s.replace(i_pos,  i_pos+1, "-");
            }
            else
            {
                s.replace(i_pos,  i_pos+1, "+");
            }
        }
    }
    
    public static final boolean DEBUG = false;

    public static void main(String[] args) {
        try {
//            System.setIn(new FileInputStream("sample.txt"));
//            System.setIn(new FileInputStream("A-small-attempt0.in"));
            if( args.length > 0 )
            {
                System.setIn(new FileInputStream(args[0]));
            }
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return;
        }
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int test_cases = in.nextInt(); // Scanner has functions to read ints,
                                       // longs, strings, chars, etc.
        
        // test code
//        for( int i_test_code = 1; i_test_code <= 200; i_test_code++ )
//        {
//            solution(i_test_code, i_test_code);
//        }
//        
//      
        in.nextLine();
        // actual code
        for (int i_test = 1; i_test <= test_cases; ++i_test) {
            String s_string = in.nextLine().trim();
            
            // algo - fix starting from left, fix starting from right
            // result is minimum of both
                        
            String problem_strings[] = s_string.split(" ");
            
            if(DEBUG) System.out.println("Case #" + i_test + ": " + (problem_strings[0]) );
            int flipper_size = Integer.parseInt(problem_strings[1]);
            int left_flips = 0;
            {
                StringBuffer pattern = new StringBuffer();
                pattern.append(problem_strings[0]);
                
                
                for( int i_pos = 0; i_pos < pattern.length(); i_pos++ )
                {
                    int num_chars_to_end = pattern.length()-i_pos;
                    char next_char = pattern.charAt(i_pos);
                    if( next_char != '+' )
                    {
                        // check if can flip
                        if( num_chars_to_end < flipper_size )
                        {
                            // fail
                            left_flips = -1;
                            break;
                        }
                        else
                        {
                            // flip
                            flip(pattern, i_pos, flipper_size);
                            left_flips++;
                        }
                    }
                }
                
                if(DEBUG) System.out.println("Case #" + i_test + ": " + (pattern) );
            }

            int right_flips = 0;
            {
                StringBuffer pattern2 = new StringBuffer();
                pattern2.append(problem_strings[0]);
                
                for( int i_pos = pattern2.length()-1; i_pos >=0 ; i_pos-- )
                {
                    int num_chars_to_start = i_pos+1;
                    char next_char = pattern2.charAt(i_pos);
                    if( next_char != '+' )
                    {
                        // check if can flip
                        if( num_chars_to_start < flipper_size )
                        {
                            // fail
                            right_flips = -1;
                            break;
                        }
                        else
                        {
                            // flip
                            flip(pattern2, i_pos-flipper_size+1, flipper_size);
                            right_flips++;
                        }
                    }
                }
                if(DEBUG) System.out.println("Case #" + i_test + ": " + (pattern2) );
            }

            //solution(i_test, n);
            if(DEBUG) System.out.println("Case #" + i_test + ": " + (left_flips) );
            if(DEBUG) System.out.println("Case #" + i_test + ": " + (right_flips) );
            //int flips = (left_flips < right_flips ? left_flips : right_flips);
            if( left_flips != right_flips )
            {
                System.out.println("weird");
            }
            if( left_flips >= 0 )
            {
                System.out.println("Case #" + i_test + ": " + (left_flips) );
            }
            else
            {
                System.out.println("Case #" + i_test + ": " + "IMPOSSIBLE" );                
            }
        }

        in.close();
    }

}
