import java.util.*;
import java.io.*;

public class ProblemMain {
    
    public static void solution(int i_test, String pattern)
    {
        StringBuffer pancakes = new StringBuffer(pattern.trim());
        
        int flips = 0;
        
        int pancakes_wrong_length = pancakes.length();
//      
        while( pancakes_wrong_length > 0 )
        {
            // remove any that are correct from right
            for( int i_pancake = (pancakes_wrong_length-1); i_pancake >= 0; i_pancake-- )
            {
                if( pancakes.charAt(i_pancake) == '+' )
                {
                    pancakes_wrong_length--;
                }
                else
                {
                    break;
                }
            }
            
            if( pancakes_wrong_length == 0 )
            {
                break;
            }

            // decide where to flip based on max of top or bottom pancakes that are wrong
            int top_wrong_count = 0;
            int top_right_count = 0;
            int bottom_wrong_count = 0;

            // find top_wrong_count
            for( int i_pancake = 0; i_pancake < pancakes_wrong_length; i_pancake++ )
            {
                if( pancakes.charAt(i_pancake) == '-' )
                {
                    top_wrong_count++;
                }
                else
                {
                    break;
                }
            }
            
            // find top_right_count
            for( int i_pancake = 0; i_pancake < pancakes_wrong_length; i_pancake++ )
            {
                if( pancakes.charAt(i_pancake) == '+' )
                {
                    top_right_count++;
                }
                else
                {
                    break;
                }
            }
            
            // find bottom wrong count
            for( int i_pancake = (pancakes_wrong_length-1); i_pancake > top_wrong_count; i_pancake-- )
            {
                if( pancakes.charAt(i_pancake) == '-' )
                {
                    bottom_wrong_count++;
                }
                else
                {
                    break;
                }
            }

            // System.out.println(pancakes);
            // do maneuver
            if( top_wrong_count > bottom_wrong_count )
            {
                // flip entire stack
                flip_pancakes(pancakes, 0, pancakes_wrong_length);
            }
            else if( top_right_count > 0 )
            {
                // flip all front good ones
                flip_pancakes(pancakes, 0, top_right_count);
            }
            else
            {
                // wrong at front and wrong at back, flip wrong at front then
                flip_pancakes(pancakes, 0, top_wrong_count);
            }
            flips++;
        }
                    
        System.out.println("Case #" + i_test + ": " + flips);
    }

    public static void flip_pancakes(StringBuffer pancakes, int i_start, int flip_count)
    {
        for( int i_pancake=i_start, i_swap = flip_count-1-i_start; i_pancake < (flip_count+1)/2; i_pancake++, i_swap-- )
        {
            char swap = pancakes.charAt(i_pancake);
            if( pancakes.charAt(i_swap) == '+' )
            {
                pancakes.setCharAt(i_pancake, '-');
            }
            else
            {
                pancakes.setCharAt(i_pancake, '+');
            }
            if( swap == '+' )
            {
                pancakes.setCharAt(i_swap, '-');
            }
            else
            {
                pancakes.setCharAt(i_swap, '+');
            }
        }
    }
    public static void main(String[] args) {
        try {
//            System.setIn(new FileInputStream("sample.txt"));
            System.setIn(new FileInputStream("B-small-attempt0.in"));
//            System.setIn(new FileInputStream("A-large.in"));
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int test_cases = in.nextInt(); // Scanner has functions to read ints,
                                       // longs, strings, chars, etc.
        
        // test code
//        solution(0, "---------+-+-++--------------------------+++++++++++++++++++++++++++++++++++-----------------------------------------++------++----------------");
//        solution(1, "+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-");
//            
        in.nextLine();
        // actual code
        for (int i_test = 1; i_test <= test_cases; ++i_test) {
            String pattern = in.nextLine();
            
            solution(i_test, pattern);
        }

        in.close();
    }

}
