
import java.util.HashSet;
import java.util.Vector;


public class ProblemSolver {
	public ProblemSolver(TestCase testCase) {
		this.testCase = testCase;
	}
	
	void improveGuesses(Vector< Integer > productList, Vector< Integer > guesses) {
		HashSet< Integer > factors = new HashSet<Integer>();
		int factorsCount[] = {0,0,0,0,0,0,0,0,0,0};
		for( int iProductEntry = 0; iProductEntry < testCase.K_numProductsPerList; iProductEntry++ ) {
			int product = productList.elementAt(iProductEntry);
			for( int guess = 2; guess <= testCase.M_maxInteger; guess++ ) {
				int guessCount = 0;
				if( product % guess == 0 ) {
					guessCount = 1;
					factors.add(guess);
				}
				if( product % (guess*guess) == 0 ) {
					guessCount = 2;
				}
				if( product % (guess*guess*guess) == 0 ) {
					guessCount = 3;
				}
				if( product % (guess*guess*guess*guess) == 0 ) {
					guessCount = 4;
				}
				if( product % (guess*guess*guess*guess*guess) == 0 ) {
					guessCount = 5;
				}
				if( product % (guess*guess*guess*guess*guess*guess) == 0 ) {
					guessCount = 6;
				}
				if( product % (guess*guess*guess*guess*guess*guess*guess) == 0 ) {
					guessCount = 7;
				}
				if( product % (guess*guess*guess*guess*guess*guess*guess*guess) == 0 ) {
					guessCount = 8;
				}
				if( product % (guess*guess*guess*guess*guess*guess*guess*guess*guess) == 0 ) {
					guessCount = 9;
				}
				if( factorsCount[guess] < guessCount ) {
					factorsCount[guess] = guessCount;
				}
			}
		}
		// need to reduce factors
	/*
		int totalFactorsCount = 0;
		do {
			for( int i=0; i <= 9; i++ ) {
				totalFactorsCount += factorsCount[i];
			}
			if( totalFactorsCount > testCase.N_numRandomIntegers) {
				// must be a factor included too many times, remove extras

			}
		} while( totalFactorsCount > testCase.N_numRandomIntegers );
		*/
		
		int iGuess = 0;
		while(factorsCount[7] > 0  && iGuess < guesses.size()) {
			guesses.setElementAt(7, iGuess++);
			factorsCount[7]--;
		}
		while(factorsCount[5] > 0  && iGuess < guesses.size()) {
			guesses.setElementAt(5, iGuess++);
			factorsCount[5]--;
		}
		while(factorsCount[6] > 0  && iGuess < guesses.size()) {
			guesses.setElementAt(6, iGuess++);
			factorsCount[6]--;
			factorsCount[3]--;
			factorsCount[2]--;
		}
		while(factorsCount[8] > 0  && iGuess < guesses.size()) {
			guesses.setElementAt(8, iGuess++);
			factorsCount[8]--;
			factorsCount[4]--;
			factorsCount[2]--;
		}
		while(factorsCount[4] > 0  && iGuess < guesses.size()) {
			guesses.setElementAt(4, iGuess++);
			factorsCount[4]--;
			factorsCount[2]--;
			factorsCount[2]--;
		}
		for( int iFactor = 9; iFactor > 0 && iGuess < guesses.size(); iFactor-- ) {
			while(factorsCount[iFactor] > 0  && iGuess < guesses.size()) {
				guesses.setElementAt(iFactor, iGuess++);
				factorsCount[iFactor]--;
			}
		}
		
	}
	
	// returns 
	public String result() {
		// algorithm:
		StringBuffer result = new StringBuffer();
		result.append("\n");
		
		Vector< Integer > defaultGuesses = new Vector<Integer>();
		for( int iNumber = 0; iNumber < testCase.N_numRandomIntegers; iNumber++ ) {
			defaultGuesses.add(2);
		}
		
		for( int iProduct = 0; iProduct < testCase.R_numProductLists; iProduct++ ) {
			Vector< Integer > productList = testCase.products.elementAt(iProduct);
			// Each of those lines contains K space-separated integers  
			// On each of the next R 
			// lines output N digits  your guess for Maryam's hidden numbers for the corresponding set of products.
			Vector< Integer > guesses = new Vector< Integer > ();
			guesses.addAll(defaultGuesses);
			improveGuesses(productList, guesses);
			
			// You can print the numbers for each set in any order, but there must be exactly N digits, 
			// each between 2 and M, inclusive (note that M<10, so none of the numbers will be more than one digit). 
			// Do not put spaces between the digits. 
			for( int iNumber = 0; iNumber < testCase.N_numRandomIntegers; iNumber++ ) {
				result.append(guesses.elementAt(iNumber));
			}
			result.append("\n");
		}

		return result.toString();
	}
	private TestCase testCase;
	
}
