import java.util.*;
import java.io.*;

public class ProblemMain {
    
    public static class Outfit
    {
        public int jacket;
        public int pants;
        public int shirt;
    }
    
    public static class JPTuple
    {
        public int jacket;
        public int pants;
    }
    
    public static class JSTuple
    {
        public int jacket;
        public int shirt;
    }

    public static class PSTuple
    {
        public int pants;
        public int shirt;
    }

    public static Outfit remove_max_tuples_outfit(Vector<Outfit> outfits, 
            Vector<JPTuple> jp_tuples, 
            Vector<JSTuple> js_tuples, 
            Vector<PSTuple> ps_tuples)
    {
//        int max_tuple_outfit_index = -1;
//        int max_jp_tuple_count = 0;
//        int max_js_tuple_count = 0;
//        int max_ps_tuple_count = 0;
        for( int i_outfit = 0; i_outfit < outfits.size(); i_outfit++ )
        {
            Outfit outfit = outfits.elementAt(i_outfit);
            int jp_tuple_count = 0;
            int js_tuple_count = 0;
            int ps_tuple_count = 0;
            for( int i_jp = 0; i_jp < jp_tuples.size(); i_jp++ )
            {
                JPTuple jp_tuple = jp_tuples.elementAt(i_jp);
                if( jp_tuple.jacket == outfit.jacket 
                        && jp_tuple.pants == outfit.pants )
                {
                    jp_tuple_count++;
                }
            }
            for( int i_js = 0; i_js < js_tuples.size(); i_js++ )
            {
                JSTuple js_tuple = js_tuples.elementAt(i_js);
                if( js_tuple.jacket == outfit.jacket 
                        && js_tuple.shirt == outfit.shirt )
                {
                    js_tuple_count++;
                }
            }
            for( int i_ps = 0; i_ps < ps_tuples.size(); i_ps++ )
            {
                PSTuple ps_tuple = ps_tuples.elementAt(i_ps);
                if( ps_tuple.pants == outfit.pants 
                        && ps_tuple.shirt == outfit.shirt )
                {
                    ps_tuple_count++;
                }
            }
            if( jp_tuple_count >= 3
                    && js_tuple_count >= 3
                    && ps_tuple_count >= 3 )
            {
                outfits.remove(i_outfit);
                return outfit;
            }
        }
        return null;
    }

    public static void main(String[] args) {
        try {
    //      System.setIn(new FileInputStream("sample.txt"));
           System.setIn(new FileInputStream("C-small-attempt1.in"));
  //          System.setIn(new FileInputStream("A-large.in"));
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int test_cases = in.nextInt(); // Scanner has functions to read ints,
                                       // longs, strings, chars, etc.
        
        // test code
//        for( int i_test_code = 1; i_test_code <= 200; i_test_code++ )
//        {
//            solution(i_test_code, i_test_code);
//        }
//        
//      
        in.nextLine();
        
        // actual code
        for (int i_test = 1; i_test <= test_cases; ++i_test) {
            Vector<Outfit> outfits = new Vector<Outfit>();
            Vector<JPTuple> jp_tuples = new Vector<JPTuple>();
            Vector<JSTuple> js_tuples = new Vector<JSTuple>();
            Vector<PSTuple> ps_tuples = new Vector<PSTuple>();
            
            int jacket_count = in.nextInt();
            int pants_count = in.nextInt();
            int shirt_count = in.nextInt();
            int k_count = in.nextInt();
     //       System.out.println("Case #" + i_test + " j=" + jacket_count + " p=" + pants_count + " s=" + shirt_count + " k=" + k_count);

            // algo - generate Outfit sets, and Tuple sets
            //      - for each outfit set, check if tuples sets available, if so, then use and remove tuples
            //        otherwise discard outfit
            for( int i_j = 0; i_j < jacket_count; i_j++ )
            {
                for( int i_p = 0; i_p < pants_count; i_p++ )
                {
                    for( int i_s = 0; i_s < shirt_count; i_s++ )
                    {
                        Outfit outfit = new Outfit();
                        outfit.jacket = i_j;
                        outfit.pants = i_p;
                        outfit.shirt = i_s;
                        outfits.addElement(outfit);
                    }                    
                }
            }
            
            for( int i_j = 0; i_j < jacket_count; i_j++ )
            {
                for( int i_p = 0; i_p < pants_count; i_p++ )
                {
                    JPTuple jp_tuple = new JPTuple();
                    jp_tuple.jacket = i_j;
                    jp_tuple.pants = i_p;
                    for(int i_k = 0; i_k < k_count; i_k++ )
                    {
                        jp_tuples.addElement(jp_tuple);
                      //  System.out.println((jp_tuple.jacket+1) + " " + (jp_tuple.pants+1));
                    }
                }
            }
            for( int i_j = 0; i_j < jacket_count; i_j++ )
            {
                for( int i_s = 0; i_s < shirt_count; i_s++ )
                {
                    JSTuple js_tuple = new JSTuple();
                    js_tuple.jacket = i_j;
                    js_tuple.shirt = i_s;
                    for(int i_k = 0; i_k < k_count; i_k++ )
                    {
                        js_tuples.addElement(js_tuple);
                    }
                }
            }
            
            for( int i_p = 0; i_p < pants_count; i_p++ )
            {
                for( int i_s = 0; i_s < shirt_count; i_s++ )
                {
                    PSTuple ps_tuple = new PSTuple();
                    ps_tuple.pants = i_p;
                    ps_tuple.shirt = i_s;
                    for(int i_k = 0; i_k < k_count; i_k++ )
                    {
                        ps_tuples.addElement(ps_tuple);
                    }
                }                    
            }
            
            Vector<Outfit> good_outfits = new Vector<Outfit>();
            //      - for each outfit set, check if tuples sets available, if so, then use and remove tuples
            //        otherwise discard outfit
            while( outfits.size() > 0 )
            {
                // sort outfits by max of jacket pants or shirts
                Outfit outfit = remove_max_tuples_outfit(outfits, jp_tuples, js_tuples, ps_tuples);
                if( outfit == null )
                {
                    outfit = outfits.remove(0);
                }
                int jp_index = -1;
                int js_index = -1;
                int ps_index = -1;
                for( int i_jp = 0; i_jp < jp_tuples.size(); i_jp++ )
                {
                    JPTuple jp_tuple = jp_tuples.elementAt(i_jp);
                    if( jp_tuple.jacket == outfit.jacket 
                            && jp_tuple.pants == outfit.pants )
                    {
                        jp_index = i_jp;
                        break;
                    }
                }
                for( int i_js = 0; i_js < js_tuples.size(); i_js++ )
                {
                    JSTuple js_tuple = js_tuples.elementAt(i_js);
                    if( js_tuple.jacket == outfit.jacket 
                            && js_tuple.shirt == outfit.shirt )
                    {
                        js_index = i_js;
                        break;
                    }
                }
                for( int i_ps = 0; i_ps < ps_tuples.size(); i_ps++ )
                {
                    PSTuple ps_tuple = ps_tuples.elementAt(i_ps);
                    if( ps_tuple.pants == outfit.pants 
                            && ps_tuple.shirt == outfit.shirt )
                    {
                        ps_index = i_ps;
                        break;
                    }
                }
                if( jp_index != -1
                        && js_index != -1
                        && ps_index != -1 )
                {
                    good_outfits.addElement(outfit);
                    jp_tuples.remove(jp_index);
                    js_tuples.remove(js_index);
                    ps_tuples.remove(ps_index);
                }
            }
            System.out.println("Case #" + i_test + ": " + (good_outfits.size()) );
            StringBuilder result = new StringBuilder();
            for( int i_outfit = 0; i_outfit < good_outfits.size(); i_outfit++ )
            {
                Outfit outfit = good_outfits.elementAt(i_outfit);
                System.out.println((outfit.jacket+1) + " " + (outfit.pants+1) + " " + (outfit.shirt+1));

            }
            

            //solution(i_test, n);
        }

        in.close();
    }

}
