


public class ProblemSolver {
	public ProblemSolver(TestCase testCase) {
		this.testCase = testCase;
	}
	public boolean maxHeightForX(int iX, int height) {
		for( int iY = 0; iY < testCase.yCount; iY++ ) {
			if( testCase.heights.elementAt(iX).elementAt(iY) > height ) {
				return false;
			}
		}
		return true;
	}
	public boolean maxHeightForY(int iY, int height) {
		for( int iX = 0; iX < testCase.xCount; iX++ ) {
			if( testCase.heights.elementAt(iX).elementAt(iY) > height ) {
				return false;
			}
		}
		return true;
	}
	// returns either the word "YES" if it's possible or "NO"
	public String result() {
		// algorithm:
		// 1. Only possible if exists a row+height or column+height
		//    such that no greater height present on row/column
		for( int iX = 0; iX < testCase.xCount; iX++ ) {
			for( int iY = 0; iY < testCase.yCount; iY++ ) {
				int heightxy = testCase.heights.elementAt(iX).elementAt(iY);
				if( maxHeightForX(iX, heightxy) ) {
					continue;
				}
				if( maxHeightForY(iY, heightxy) ) {
					continue;
				}
				else {
					return "NO";
				}
			}
		}
		return "YES";
	}
	private TestCase testCase;
	
}
