import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class Hello {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		System.out.println("Hello Elizabeth!!");
		try {
			BufferedReader inputFile = new BufferedReader(new FileReader(
					"input.txt"));
			BufferedWriter outputFile = new BufferedWriter(new FileWriter(
					"output.txt"));

			// Input
			ProblemInput problemInput = new ProblemInput();
			// The first line of input gives the number of cases, N.
			problemInput.numberOfTestCases = Integer.parseInt(inputFile
					.readLine());
			problemInput.testCases.setSize(problemInput.numberOfTestCases);
			// N test cases follow. For each test case there will be:
			for (int iTestCase = 0; iTestCase < problemInput.numberOfTestCases; iTestCase++) {
				// a line containing two space separated integers: r and t
				TestCase testCase = new TestCase();
				StringTokenizer delimitedStringReader = new StringTokenizer(inputFile.readLine());
				testCase.whiteCircleRadiusCm = Long.parseLong(delimitedStringReader.nextToken());
				testCase.millilitresBlackPaint = Long.parseLong(delimitedStringReader.nextToken());

				problemInput.testCases.setElementAt(testCase, iTestCase);

				// Output
				ProblemSolver problemSolver = new ProblemSolver(testCase);
				// For each test case, output:
				StringBuffer stringBuffer = new StringBuffer();
				stringBuffer.append("Case #");
				stringBuffer.append(iTestCase + 1);
				stringBuffer.append(": ");
				stringBuffer.append(problemSolver.result());
				stringBuffer.append("\r\n");

				outputFile.write(stringBuffer.toString());
			}
			inputFile.close();
			outputFile.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
