import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class Hello {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		System.out.println("Hello Elizabeth!!");
		try {
			BufferedReader inputFile = new BufferedReader(new FileReader(
					"input.txt"));
			BufferedWriter outputFile = new BufferedWriter(new FileWriter(
					"output.txt"));

			// Input
			ProblemInput problemInput = new ProblemInput();
			// The first line of input gives the number of cases, N.
			problemInput.numberOfTestCases = Integer.parseInt(inputFile
					.readLine());
			problemInput.testCases.setSize(problemInput.numberOfTestCases);
			// N test cases follow. For each test case there will be:
			for (int iTestCase = 0; iTestCase < problemInput.numberOfTestCases; iTestCase++) {
				// Each test case consists of 4 lines with 4 characters each, 
				// with each character being 'X', 'O', '.' or 'T' (quotes for clarity only). 				
				TestCase testCase = new TestCase();
				String nextLine = inputFile.readLine();
				for( int iCol=0; iCol < 4; iCol++) {
					testCase.board.elementAt(0).add(String.valueOf(nextLine.charAt(iCol)));
				}
				nextLine = inputFile.readLine();
				for( int iCol=0; iCol < 4; iCol++) {
					testCase.board.elementAt(1).add(String.valueOf(nextLine.charAt(iCol)));
				}
				nextLine = inputFile.readLine();
				for( int iCol=0; iCol < 4; iCol++) {
					testCase.board.elementAt(2).add(String.valueOf(nextLine.charAt(iCol)));
				}
				nextLine = inputFile.readLine();
				for( int iCol=0; iCol < 4; iCol++) {
					testCase.board.elementAt(3).add(String.valueOf(nextLine.charAt(iCol)));
				}
				// Each test case is followed by an empty line. 
				inputFile.readLine();
				
				problemInput.testCases.setElementAt(testCase, iTestCase);

				// Output
				ProblemSolver problemSolver = new ProblemSolver(testCase);
				// For each test case, output:
				StringBuffer stringBuffer = new StringBuffer();
				stringBuffer.append("Case #");
				stringBuffer.append(iTestCase + 1);
				stringBuffer.append(": ");
				stringBuffer.append(problemSolver.result());
				stringBuffer.append("\r\n");

				outputFile.write(stringBuffer.toString());
			}
			inputFile.close();
			outputFile.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
