


public class ProblemSolver {
	public ProblemSolver(TestCase testCase) {
		this.testCase = testCase;
	}
	
	public String checkWinLossStatus(String a, String b, String c, String d) {
		if( a.equals(".") ) {
			return "";
		}
		//X', 'O', 'T' and '.' 
		if( (a.equals("X") || a.equals("T"))
				&& (b.equals("X") || b.equals("T"))
				&& (c.equals("X") || c.equals("T"))
				&& (d.equals("X") || d.equals("T"))) {
			return "X won";
		}
		if( (a.equals("O") || a.equals("T"))
				&& (b.equals("O") || b.equals("T"))
				&& (c.equals("O") || c.equals("T"))
				&& (d.equals("O") || d.equals("T"))) {
			return "O won";
		}
		return "";
	}
	// returns  y is one of the statuses 
	// 
    // "X won" (the game is over, and X won)
    // "O won" (the game is over, and O won)
    // "Draw" (the game is over, and it ended in a draw)
    // "Game has not completed" (the game is not over yet)
	public String result() {
		// algorithm:
		// check each row
		String status = "";
		for( int iRow=0; iRow < 4; iRow++ ) {
			status = checkWinLossStatus(
					testCase.board.elementAt(iRow).elementAt(0),
					testCase.board.elementAt(iRow).elementAt(1),
					testCase.board.elementAt(iRow).elementAt(2),
					testCase.board.elementAt(iRow).elementAt(3));
			if( !status.equals("") ) {
				return status;
			}
		}
		// check each column
		for( int iCol=0; iCol < 4; iCol++ ) {
			status = checkWinLossStatus(
					testCase.board.elementAt(0).elementAt(iCol),
					testCase.board.elementAt(1).elementAt(iCol),
					testCase.board.elementAt(2).elementAt(iCol),
					testCase.board.elementAt(3).elementAt(iCol));
			if( !status.equals("") ) {
				return status;
			}
		}
		// check each diagonal
		status = checkWinLossStatus(
				testCase.board.elementAt(0).elementAt(0),
				testCase.board.elementAt(1).elementAt(1),
				testCase.board.elementAt(2).elementAt(2),
				testCase.board.elementAt(3).elementAt(3));
		if( !status.equals("") ) {
			return status;
		}
		status = checkWinLossStatus(
				testCase.board.elementAt(0).elementAt(3),
				testCase.board.elementAt(1).elementAt(2),
				testCase.board.elementAt(2).elementAt(1),
				testCase.board.elementAt(3).elementAt(0));
		if( !status.equals("") ) {
			return status;
		}
		// not completed (contains a '.')
		for( int iRow=0; iRow < 4; iRow++ ) {
			for( int iCol=0; iCol < 4; iCol++ ) {
				if( testCase.board.elementAt(iRow).elementAt(iCol).equals(".") ) {
					return "Game has not completed";
				}
			}
		}
		// draw 
		return "Draw";
	}
	private TestCase testCase;
	
}
