import java.util.*;
import java.io.*;

public class ProblemMain 
{
    
    public static final boolean DEBUG = false;
    
    static boolean non_decreasing(StringBuffer pattern)
    {
        for( int i_pos = 0; i_pos < pattern.length()-1; i_pos++ )
        {
            int digit_a = pattern.charAt(i_pos) - '0';
            int digit_b = pattern.charAt(i_pos+1) - '0';
            if( digit_b < digit_a )
            {
                return false;
            }
        }
        return true;
    }
    
    static long decrease_to_next_nine(long last_number)
    {
        while( (last_number % 10) != 9 )
        {
            last_number--;
        }
        return last_number;
    }

    public static void main(String[] args) {
        try {
            if( args.length > 0 )
            {
                System.setIn(new FileInputStream(args[0]));
            }
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return;
        }
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int test_cases = in.nextInt(); // Scanner has functions to read ints,
                                       // longs, strings, chars, etc.
        
        in.nextLine();
        // actual code
        for (int i_test = 1; i_test <= test_cases; ++i_test) {
            String s_string = in.nextLine().trim();
               
            String problem_strings[] = s_string.split(" ");
            
            if(DEBUG) System.out.println("Case #" + i_test + ": " + (problem_strings[0]) );
            
            long last_number = Long.parseLong(problem_strings[0]);

            StringBuffer pattern = new StringBuffer();
            StringBuffer tidy_number = new StringBuffer();

            // algo: check if have non-decreasing number
            // if yes: done
            // if no: decrease number till right-most number is a 9
            
            while(last_number > 9)
            {
                pattern.setLength(0);
                pattern.append(String.valueOf(last_number));
                if( non_decreasing(pattern) )
                {
                    break;
                }
                else
                {
                    last_number = decrease_to_next_nine(last_number);
                    tidy_number.append('9');
                    last_number = last_number/10;
                }
            }
            if( last_number != 0 )
            {
                tidy_number.insert(0, String.valueOf(last_number));
            }

            System.out.println("Case #" + i_test + ": " + tidy_number );                
        }

        in.close();
    }

}
