package cj2016.r2;
import java.io.*;
import java.util.*;

public class D {
	Scanner sc;
	PrintWriter pw;
	int N;
	int[] skill;

	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"D-small-attempt0";

		try {
			new D().run(filePrefix);
		} catch(Exception e) {
			System.err.println(e);
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		N = sc.nextInt();
		skill = new int[N];
		for(int i=0; i<N; i++) {
			char[] s = sc.next().toCharArray();
			for(int j=0; j<N; j++)
				skill[i] |= (s[j]-'0')<<j;
		}
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		int ans = N*N;
//		boolean update = true;
//		while(update) {
//			update = false;
//			for(int i=0; i<N; i++) {
//				for(int j=0; j<i; j++) {
//					if((i&j)!=0) {
//						int or = skill[i] | skill[j];
//						int need = bitcnt(or);
//						ans += (need - bitcnt(skill[i])) + (need - bitcnt(skill[j]));
//						skill[i] = skill[j] = or;
//					}
//				}
//			}
//		}
		for(int i=0; i<1<<N*N; i++) {
			int[] ss = new int[N];
			for(int j=0; j<N; j++)
				ss[j] = skill[j] | ((i>>(j*N)&((1<<N)-1)));
			if(isOK(ss))
				ans = Math.min(ans, bitcnt(i));
		}
		
		println(ans);
	}
	
	int bitcnt(int v) {
		int ans = 0;
		while(v>0) {
			ans += v&1;
			v>>=1;
		}
		
		return ans;
	}
	
	boolean isOK(int[] s) {
		boolean[] checked = new boolean[N];
		
		for(int i=0; i<N; i++) {
			if(checked[i])
				continue;
			int skillCnt = bitcnt(s[i]);
			int workerCnt = 0;
			for(int j=i; j<N; j++) {
				if(s[i]==s[j]) {
					workerCnt++;
					checked[j] = true;
				} else if((s[i]&s[j])!=0) {
					return false;
				}
			}
			if(skillCnt!=workerCnt)
				return false;
		}
		
		return true;
	}
}
