//done
package cj2017.r2;
import java.io.*;
import java.util.*;

public class B {
	Scanner sc;
	PrintWriter pw;
	int N, C, M;
	Ticket[] t;
	public class Ticket {
		int P,B;

		public Ticket(int p, int b) {
			P = p;
			B = b;
		}
	}
	
	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"B-small-attempt0";

		try {
			new B().run(filePrefix);
		} catch(Exception e) {
			throw e;
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		N = sc.nextInt();
		C = sc.nextInt();
		M = sc.nextInt();
		t = new Ticket[M];
		for(int i=0; i<M; i++) {
			t[i] = new Ticket(sc.nextInt()-1, sc.nextInt()-1);
		}
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		int[][] seats = new int[M][N];
		boolean[][] visited = new boolean[M][C];
		for(int i=0; i<M; i++)
			Arrays.fill(seats[i], -1);
		
		Arrays.sort(t, new Comparator<Ticket>() {
			public int compare(Ticket t1, Ticket t2) {
				return t1.P-t2.P;
			}
		});
		
		int rides = 0;
		for(int i=0; i<M; i++) {
			int p = t[i].P;
			for(int j=0; j<M; j++) {
				if(visited[j][t[i].B])
					continue;
				int empty = -1;
				for(int k=p; k>=0; k--) {
					if(seats[j][k]==-1) {
						empty = k;
						break;
					}
				}
				if(empty>=0) {
					seats[j][empty] = t[i].B;
					visited[j][t[i].B]=true;
					rides = Math.max(rides, j+1);
					break;
				}
			}
		}
		
		for(int i=0; i<M; i++) {
			Arrays.fill(seats[i], -1);
			Arrays.fill(visited[i], false);
		}

		int promo = 0;
		for(int i=0; i<M; i++) {
			int p = t[i].P;
			for(int j=p; j>=0; j--) {
				boolean found = false;
				for(int k=0; k<rides; k++) {
					if(!visited[k][t[i].B] && seats[k][j]<0) {
						seats[k][j] = t[i].B;
						visited[k][t[i].B]=true;
						if(j<p)
							promo++;
						found = true;
						break;
					}
				}
				if(found)
					break;
			}
		}

		println(rides + " " + promo);
	}
}
