package cj2015.r2;
import java.io.*;
import java.util.*;

public class A {
	Scanner sc;
	PrintWriter pw;
	int R,C;
	char[][] g;
	
	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"A-large";

		try {
			new A().run(filePrefix);
		} catch(Exception e) {
			System.err.println(e);
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		R = sc.nextInt();
		C = sc.nextInt();
		g = new char[R][];
		for(int i=0; i<R; i++) {
			g[i] = sc.next().toCharArray();
		}
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		int ans = 0;
		String dir = "^>v<";
		int[] dx = {0, 1, 0, -1};
		int[] dy = {-1, 0, 1, 0};
		
		int[] cnth = new int[R];
		int[] cntv = new int[C];
		for(int i=0; i<R; i++) {
			for(int j=0; j<C; j++) {
				if(g[i][j]!= '.') {
					cnth[i]++;
					cntv[j]++;
				}
			}
		}
		
		for(int i=0; i<R; i++) {
			for(int j=0; j<C; j++) {
				int d = dir.indexOf(g[i][j]);
				if(d>=0) {
					boolean found = false;
					int ny = i+dy[d];
					int nx = j+dx[d];
					while(ny>=0 && ny<R && nx>=0 && nx<C) {
						if(g[ny][nx]!='.') {
							found = true;
							break;
						}
						ny += dy[d];
						nx += dx[d];
					}
					if(found)
						continue;
					
					if(cnth[i]>=2 || cntv[j]>=2) {
						ans++;
					} else {
						println("IMPOSSIBLE");
						return;
					}
				}
			}
		}
		println(ans);
	}
}
