package cj2014.r2;
import java.io.*;
import java.util.*;

import cj2008.WF.CodeJam2008_WF_E.MaxFlow.Edge;

public class C {

	Scanner sc;
	PrintWriter pw;
	int W,H,B;
	int[] x0,y0,x1,y1;
	
	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"C-small-attempt0";

		try {
			new C().run(filePrefix);
		} catch(Exception e) {
			throw(e);
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
	}

	void read(Scanner sc) {
		W = sc.nextInt();
		H = sc.nextInt();
		B = sc.nextInt();
		x0 = new int[B];
		y0 = new int[B];
		x1 = new int[B];
		y1 = new int[B];
		for(int i=0; i<B; i++) {
			x0[i] = sc.nextInt();
			y0[i] = sc.nextInt();
			x1[i] = sc.nextInt()+1;
			y1[i] = sc.nextInt()+1;
		}
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		boolean[][] block = new boolean[H][W];
		for(int i=0; i<B; i++) {
			for(int y=y0[i]; y<y1[i]; y++)
				for(int x=x0[i]; x<x1[i]; x++)
					block[y][x] = true;
		}
		
		int[] dx = {0,1,0,-1};
		int[] dy = {1,0,-1,0};
		
		int ans=0;
		for(int i=0; i<W; i++) {
			int cy = -1;
			int cx = i;
			int dir = 0;
			boolean end = false;
			while(!end) {
				for(int d=0; d<3; d++) {
					int nd = (dir+3+d)%4;
					int ny = cy+dy[nd];
					int nx = cx+dx[nd];
					if(ny==H) {
						ans++;
						end = true;
						break;
					}
					end = true;
					if(0<=nx && nx<W && 0<=ny && ny<H && !block[ny][nx]) {
						cy = ny;
						cx = nx;
						dir = nd;
						block[cy][cx]=true;
						end = false;
						break;
					}
				}
			}
		}
		
		println(ans);
	}
}
