package cj2014.r2;
import java.io.*;
import java.util.*;

public class B {
	Scanner sc;
	PrintWriter pw;
	int N;
	int[] A;
	
	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"B-small-attempt0";

		try {
			new B().run(filePrefix);
		} catch(Exception e) {
			System.err.println(e);
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		N = sc.nextInt();
		A = new int[N];
		for(int i=0; i<N; i++)
			A[i] = sc.nextInt();
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		int[] costl = getCost(true);
		int[] costr = getCost(false);
		int min = 100000000;
		for(int i=0; i<=N; i++) {
			min = Math.min(min, costl[i] + costr[N-i]);
		}
		println(min);
	}

	public int[] getCost(boolean asc) {
		int[] ans=new int[N+1];
		LinkedList<Integer> q = new LinkedList<Integer>();
		
		for(int i=0; i<N; i++) {
			int pos = Collections.binarySearch(q, A[asc?i:N-i-1]);
			ans[i+1] = ans[i] + (i+pos+1);
			q.add(-pos-1, A[asc?i:N-i-1]);
		}
		
		return ans;
	}

}
