import java.io.*;
import java.util.*;

public class CodeJam2013_R2_A {
	public class Pair implements Comparable<Pair>{
		int a, b;
		public Pair(int a, int b) {
			this.a = a;
			this.b = b;
		}
		public int compareTo(Pair p) {
			return this.a - p.a;
		}
	}
	
	public static void main(String[] args) throws Exception{
//		Scanner sc = new Scanner(new FileReader("testA.in"));
		Scanner sc = new Scanner(new FileReader("A-large.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("A-large.out"));

		CodeJam2013_R2_A obj = new CodeJam2013_R2_A();
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			int N = sc.nextInt();
			int M = sc.nextInt();
			int[] o = new int[M];
			int[] e = new int[M];
			int[] p = new int[M];
			for(int i=0; i<M; i++) {
				o[i] = sc.nextInt();
				e[i] = sc.nextInt();
				p[i] = sc.nextInt();
			}
			long res = obj.calc(N, M, o, e, p);
			
			pw.println("Case #" + test + ": " + res);
			System.out.println("Case #" + test + ": " + res);
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
	}
	
	public long calc(int N, int M, int[] o, int[] e, int[] p) {
		long MOD = 1000002013;
		
		long total = 0;
		for(int i=0; i<M; i++) {
			long L = e[i]-o[i];
			total = (total + (((L*N-L*(L-1)/2))%MOD)*p[i])%MOD;
		}
		
		Pair[] in = new Pair[M];
		Pair[] out = new Pair[M];
		for(int i=0; i<M; i++) {
			in[i] = new Pair(o[i], p[i]);
			out[i] = new Pair(e[i], p[i]);
		}
		Arrays.sort(in);
		Arrays.sort(out);
		
		long real = 0;
		for(int i=M-1; i>=0; i--) {
			for(int j=0; j<M; j++) {
				if(in[i].b==0)
					break;
				if(in[i].a<=out[j].a) {
					long L = out[j].a-in[i].a;
					long num = Math.min(in[i].b, out[j].b);
					real = (real + (((L*N-L*(L-1)/2))%MOD)*num)%MOD;
					in[i].b -= num;
					out[j].b -= num;
				}
			}
		}
		
		return (total-real+MOD)%MOD;
	}
}
