package cj2016.r2;
import java.io.*;
import java.util.*;

public class B {
	Scanner sc;
	PrintWriter pw;
	int N,K;
	double[] P;
	
	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"B-small-attempt0";

		try {
			new B().run(filePrefix);
		} catch(Exception e) {
			System.err.println(e);
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		N = sc.nextInt();
		K = sc.nextInt();
		P = new double[N];
		for(int i=0; i<N; i++)
			P[i] = sc.nextDouble();
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		Arrays.sort(P);
		
		double max = 0;
		double[] selectedP = new double[K];
		for(int i=0; i<=K; i++) {
			for(int j=0; j<K; j++)
				selectedP[j] = j<i ? P[j] : P[j+N-K];
			max = Math.max(max, getTiePro(selectedP));
		}
		println(max);
	}
	
	public double getTiePro(double[] p) {
		double[][] dp = new double[K+1][K+1];
		dp[0][0] = 1.0;
		for(int i=0; i<K; i++) {
			for(int j=0; j<=i; j++) {
				dp[i+1][j+1] += dp[i][j]*p[i];
				dp[i+1][j] += dp[i][j]*(1-p[i]);
			}
		}
		
		return dp[K][K/2];
	}
}
