package cj2017.qr;
import java.io.*;
import java.util.*;

public class C {
	Scanner sc;
	PrintWriter pw;
	long N,K;

	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"C-small-2-attempt0";

		try {
			new C().run(filePrefix);
		} catch(Exception e) {
			System.err.println(e);
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		N = sc.nextLong();
		K = sc.nextLong();
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		HashMap<Long, Long> space = new HashMap<>();
		space.put(N, 1l);
		
		long done = 0;
		for(int i=0; i<70; i++) {
			long num = 1l<<i;
			if(done + num >= K) {
				Long[] keys = space.keySet().toArray(new Long[0]);
				Arrays.sort(keys, Collections.reverseOrder());
				for(long key : keys) {
					if(done + space.get(key) >= K) {
						println(key/2 + " " + (key-1)/2);
						return;
					}
					done += space.get(key);
				}
			} else {
				HashMap<Long, Long> next = new HashMap<>();
				for(long key : space.keySet()) {
					long cnt = space.get(key);
					add(next, (key-1)/2, cnt);
					add(next, key/2, cnt);
				}
				space = next;
				done += num;
			}
		}
	}
	
	void add(HashMap<Long, Long> map, long key, long value) {
		long newValue = (map.containsKey(key) ? map.get(key) : 0) + value;
		map.put(key, newValue);
	}
}
