import java.io.*;
import java.util.*;

public class D {
	Scanner sc;
	PrintWriter pw;
	int N;
	boolean[] ocu;
	double[] dp;
	double[] exp;
	
	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"D-small-attempt0";

		try {
			new D().run(filePrefix);
		} catch(Exception e) {
			System.err.println("file read error");
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		String s = sc.next();
		N = s.length();
		ocu = new boolean[N];
		for(int i=0; i<N; i++) {
			ocu[i] = s.charAt(i)=='X';
		}
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		int init = 0;
		for(int i=0; i<N; i++)
			init |= (ocu[i]?1:0)<<i;
		
		dp = new double[1<<N];
		exp = new double[1<<N];
		Arrays.fill(exp, -1);
		
		println(rec(init));
	}
	
	public double rec(int state) {
		if(exp[state]>=0)
			return exp[state];
		
		if(state==(1<<N)-1)
			return 0;
		
		double ans=0;
		for(int i=0; i<N; i++) {
			int pos=i;
			int dis=0;
			while((state&(1<<pos))!=0) {
				pos = (pos+1)%N;
				dis++;
			}
			ans += (N-dis+rec(state | 1<<pos))/N;
		}
		
		return exp[state]=ans;
	}
}
