import java.io.*;
import java.util.*;

public class A {
	Scanner sc;
	PrintWriter pw;
	long budget;
	int N;
	long[] X;
	
	public static void main(String[] args) throws Exception{
		String filePrefix = args.length>0?args[0]:"A-small-attempt2";

		try {
			new A().run(filePrefix);
		} catch(Exception e) {
			System.err.println("file read error");
		}
	}
	
	public void run(String filePrefix) throws Exception {
		sc = new Scanner(new FileReader(filePrefix + ".in"));
		pw = new PrintWriter(new FileWriter(filePrefix + ".out"));
		int ntest = sc.nextInt();
		for(int test=1; test<=ntest; test++) {
			read(sc);
			pw.print("Case #" + test + ": ");
			System.out.print("Case #" + test + ": ");
			solve();
		}
		System.out.println("Finished.");
		sc.close();
		pw.close();
		
	}
	
	void read(Scanner sc) {
		budget = sc.nextLong();
		N = sc.nextInt();
		X = new long[N];
		for(int i=0; i<N; i++) {
			X[i] = sc.nextLong();
		}
	}
	
	void print(Object s) {
		pw.print(s);
		System.out.print(s);
	}
	
	void println(Object s) {
		pw.println(s);
		System.out.println(s);
	}	
	
	public void solve() {
		long[] Y = new long[37];
		for(int i=0; i<N; i++)
			Y[i] = X[i];
		Arrays.sort(Y);
		
		double max=0;
		long last=0;
		for(int i=0; i<=36; i++) {
			if(Y[i]>last) {
				if(i>0) {
					long need = 0;
					for(int j=0; j<i; j++)
						need += last-Y[j];
					
					long rest = budget-need;
					if(rest<i)
						break;
					long minbet = Math.min(Y[i]-last-1, rest/i);
					if(minbet>0)
						max = Math.max(max, (need+minbet*i)*36.0/i - (need+minbet*i));
					if(rest>=(Y[i]-last)*i) {
						int j=i;
						while(j<=36 && Y[i]==Y[j])
							j++;
						
						max = Math.max(max, (need+(Y[i]-last)*i)*36.0/j - (need+(Y[i]-last)*i));
					}
				}
				last = Y[i];
			}
		}
		
		println(max);
	}
}
