
import java.io.*;
import java.util.*;
 
public class A{
	class Pair{
		int r;
		int h;
		public Pair(int r, int h){
			this.r = r;
			this.h = h;
		}
	}

	class P2 implements Comparable<P2>{
		final int r;
		final double sum;
		public P2(int r, double sum){
			this.r = r;
			this.sum = sum;
		}
		
		public double area(){
			return sum + r * r * Math.PI;
		}
		
		@Override
		public int compareTo(P2 o) {
			return Double.compare(sum, o.sum);
		}
	}
	final P2 zero = new P2(0, 0);
	final P2 inf = new P2(0, Double.NEGATIVE_INFINITY);
	
	int T;
	int K, N;
	Pair[] pairs = new Pair[1000];
	double[][] memo = new double[1001][1001];
	public void solve(){
		
		T = nextInt();
		for(int t = 1; t <= T; t++){
			N = nextInt();
			K = nextInt();
			for(int i = 0; i < N; i++){
				pairs[i] = new Pair(nextInt(), nextInt());
			}
			Arrays.sort(pairs, 0, N, (a, b) -> Integer.compare(b.r, a.r));
			
			for(int i = 0; i < N + 1; i++){
				for(int j = 0; j < K + 1; j++){
					memo[i][j] = Double.NaN;
				}
			}
			
			/*
			memo = new P2[N+1][K+1];
			double ans = 0;
			for(int i = 0; i < N; i++){
				P2 ret = dfs(i, K - 1);
				double a2 = ret.sum
						+ 2 * Math.PI * pairs[i].r * pairs[i].h
						+ Math.PI * pairs[i].r * pairs[i].r;
				if(ans < a2) ans = a2;
			}
			*/
			out.printf("Case #%d: %.10f\n", t, dfs2(N - 1, K));
		}
	}
	/*
	public P2 dfs(int idx, int r){
		if(r == 0) return zero;
		if(idx >= N) return inf;
		if(memo[idx][r] != null) return memo[idx][r];
		P2 p1 = dfs(idx + 1, r);
		P2 p2 = new P2(pairs[idx].r, dfs(idx + 1, r - 1).sum + 2 * Math.PI * pairs[idx].r * pairs[idx].h);
		if(p1.compareTo(p2) < 0){
			return memo[idx][r] = p2;
		}else{
			return memo[idx][r] = p1;
		}
	}
	*/
	public double dfs2(int idx, int r){
		if(idx < 0) return Double.NEGATIVE_INFINITY;
		if(r <= 0) return Double.NEGATIVE_INFINITY;
		if(!Double.isNaN(memo[idx][r])){
			return memo[idx][r];
		}
		double ret = 0;
		if(r == 1){
			ret = 2 * Math.PI * pairs[idx].r * pairs[idx].h + Math.PI * pairs[idx].r * pairs[idx].r;
		}
		ret = Math.max(ret, Math.max(
				dfs2(idx - 1, r),
				dfs2(idx - 1, r - 1) + 2 * Math.PI * pairs[idx].r * pairs[idx].h
				));
		
		return /*memo[idx][r] = */ ret;
	}
	
	private static PrintWriter out;
	public static void main(String[] args){
		out = new PrintWriter(System.out);
		new A().solve();
		out.flush();
	}
	
	
	
	public static int nextInt(){
		int num = 0;
		String str = next();
		boolean minus = false;
		int i = 0;
		if(str.charAt(0) == '-'){
			minus = true;
			i++;
		}
		int len = str.length();
		for(;i < len; i++){
			char c = str.charAt(i);
			if(!('0' <= c && c <= '9')) throw new RuntimeException();
			num = num * 10 + (c - '0');
		}
		return minus ? -num : num;
	}
	
	public static long nextLong(){
		long num = 0;
		String str = next();
		boolean minus = false;
		int i = 0;
		if(str.charAt(0) == '-'){
			minus = true;
			i++;
		}
		int len = str.length();
		for(;i < len; i++){
			char c = str.charAt(i);
			if(!('0' <= c && c <= '9')) throw new RuntimeException();
			num = num * 10l + (c - '0');
		}
		return minus ? -num : num;
	}
	public static String next(){
		int c;
		while(!isAlNum(c = read())){}
		StringBuilder build = new StringBuilder();
		build.append((char)c);
		while(isAlNum(c = read())){
			build.append((char)c);
		}
		return build.toString();
	}
	
	
	private static byte[] inputBuffer = new byte[1024];
	private static int bufferLength = 0;
	private static int bufferIndex = 0;
	private static int read(){
		if(bufferLength < 0) throw new RuntimeException();
		if(bufferIndex >= bufferLength){
			try{
				bufferLength = System.in.read(inputBuffer);
				bufferIndex = 0;
			}catch(IOException e){
				throw new RuntimeException(e);
			}
			if(bufferLength <= 0) return (bufferLength = -1);
		}
		return inputBuffer[bufferIndex++];
	}
	
	private static boolean isAlNum(int c){
		return '!' <= c && c <= '~';
	}
}