import java.io.*;
import java.util.*;
import java.util.function.IntPredicate;
 
public class Main{
	int T, K, N;

	class Period implements Comparable<Period>{
		final int l,r;
		public Period(int l, int r){
			this.l = l;
			this.r = r;
		}
		
		public int ls(){
			return (r - l - 1) % 2;
		}
		
		@Override
		public int compareTo(Period o) {
			int v1 = (r - l - 1) / 2;
			int v2 = (o.r - o.l - 1) / 2;
			if(v1 != v2){
				return Integer.compare(v2, v1);
			}
			v1 = (r - l) % 2;
			v2 = (o.r - o.l ) % 2;
			if(v1 != v2){
				return Integer.compare(v1, v2);
			}
			
			return Integer.compare(l, o.l);
		}
		
		public void split(PriorityQueue<Period> queue){
			if(r - l == 1) return;
			if(r - l == 2) queue.add(new Period(l + 1, r));
			else{
				queue.add(new Period(l, l + (r - l - 1) / 2));
				queue.add(new Period(l + (r - l - 1) / 2 + 1, r));
			}
		}
		public String toString(){
			return String.format("[%d,%d]", l, r);
		}
	}
	
	public void solve(){
		T = nextInt();
		for(int t = 1; t <= T; t++){
			N = nextInt();
			K = nextInt();
			PriorityQueue<Period> queue = new PriorityQueue<>();
			queue.add(new Period(1, N + 1));
			for(int i = 0; i < K - 1; i++){
				queue.poll().split(queue);
			}
			Period p = queue.poll();
			out.printf("Case #%d: %d %d\n", t, (p.r - p.l ) / 2, (p.r - p.l - 1 ) / 2);
		}
	}

	private static PrintWriter out;
	public static void main(String[] args){
		out = new PrintWriter(System.out);
		new Main().solve();
		out.flush();
	}
	
	
	
	public static int nextInt(){
		int num = 0;
		String str = next();
		boolean minus = false;
		int i = 0;
		if(str.charAt(0) == '-'){
			minus = true;
			i++;
		}
		int len = str.length();
		for(;i < len; i++){
			char c = str.charAt(i);
			if(!('0' <= c && c <= '9')) throw new RuntimeException();
			num = num * 10 + (c - '0');
		}
		return minus ? -num : num;
	}
	
	public static long nextLong(){
		long num = 0;
		String str = next();
		boolean minus = false;
		int i = 0;
		if(str.charAt(0) == '-'){
			minus = true;
			i++;
		}
		int len = str.length();
		for(;i < len; i++){
			char c = str.charAt(i);
			if(!('0' <= c && c <= '9')) throw new RuntimeException();
			num = num * 10l + (c - '0');
		}
		return minus ? -num : num;
	}
	public static String next(){
		int c;
		while(!isAlNum(c = read())){}
		StringBuilder build = new StringBuilder();
		build.append((char)c);
		while(isAlNum(c = read())){
			build.append((char)c);
		}
		return build.toString();
	}
	
	
	private static byte[] inputBuffer = new byte[1024];
	private static int bufferLength = 0;
	private static int bufferIndex = 0;
	private static int read(){
		if(bufferLength < 0) throw new RuntimeException();
		if(bufferIndex >= bufferLength){
			try{
				bufferLength = System.in.read(inputBuffer);
				bufferIndex = 0;
			}catch(IOException e){
				throw new RuntimeException(e);
			}
			if(bufferLength <= 0) return (bufferLength = -1);
		}
		return inputBuffer[bufferIndex++];
	}
	
	private static boolean isAlNum(int c){
		return '!' <= c && c <= '~';
	}
}