import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author Iskander Akishev
 */
public class CandySplitting {

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader("input.txt"));
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));

		int numberOfTests = in.nextInt();
		for (int i = 1; i <= numberOfTests; i++) {
			new CandySplitting().solve(in, out, i);
		}

		in.close();
		out.close();
	}

	private void solve(Scanner in, PrintWriter out, int testNumber) {
		int n = in.nextInt();
		int xor = 0;
		int sum = 0;
		int min = Integer.MAX_VALUE;
		for (int i = 0; i < n; i++) {
			int c = in.nextInt();
			xor ^= c;
			sum += c;
			min = Math.min(min, c);
		}
		out.println("Case #" + testNumber + ": " + (xor != 0 ? "NO" : sum - min));
	}

}
