import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author Iskander Akishev
 */
public class BotTrust {

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader("input.txt"));
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));

		int numberOfTests = in.nextInt();
		for (int i = 1; i <= numberOfTests; i++) {
			new BotTrust().solve(in, out, i);
		}

		in.close();
		out.close();
	}

	private void solve(Scanner in, PrintWriter out, int testNumber) {
		int n = in.nextInt();

		int[] robot = new int[n];
		int[] button = new int[n];
		int[] next = new int[n + 2];
		int[] cur = {n, n + 1};

		for (int i = 0; i < n; i++) {
			robot[i] = in.next().equals("O") ? 0 : 1;
			button[i] = in.nextInt();
			next[cur[robot[i]]] = button[i];
			cur[robot[i]] = i;
		}

		int time = 0;
		int[] pos = {1, 1};
		int[] target = new int[2];
		System.arraycopy(next, n, target, 0, 2);
		for (int i = 0; i < n; i++) {
			int r = robot[i];
			while (pos[r] != button[i]) {
				for (int k = 0; k < 2; k++) {
					pos[k] += pos[k] == target[k] ? 0 : pos[k] > target[k] ? -1 : 1;
				}
				time++;
			}
			time++;
			int k = 1 - r;
			pos[k] += pos[k] == target[k] ? 0 : pos[k] > target[k] ? -1 : 1;

			target[r] = next[i];
		}

		out.println("Case #" + testNumber + ": " + time);
	}

}
