import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author Iskander Akishev
 */
public class RPI {

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader("input.txt"));
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));

		int numberOfTests = in.nextInt();
		for (int i = 1; i <= numberOfTests; i++) {
			new RPI().solve(in, out, i);
		}

		in.close();
		out.close();
	}

	private void solve(Scanner in, PrintWriter out, int testNumber) {
		int n = in.nextInt();
		char[][] a = new char[n][];
		for (int i = 0; i < n; i++) {
			a[i] = in.next().toCharArray();
		}

		int[] wins = new int[n];
		int[] games = new int[n];

		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (a[i][j] != '.') games[i]++;
				if (a[i][j] == '1') wins[i]++;
			}
		}

		double[] wp = new double[n];
		for (int i = 0; i < n; i++) {
			wp[i] = wins[i] * 1d / games[i];
		}

		double[] owp = new double[n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (a[i][j] != '.') owp[i] += (wins[j] - (a[j][i] - '0')) * 1d / (games[j] - 1);
			}
			owp[i] /= games[i];
		}

		double[] oowp = new double[n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (a[i][j] != '.') oowp[i] += owp[j];
			}
			oowp[i] /= games[i];
		}

		out.println("Case #" + testNumber + ":");
		for (int i = 0; i < n; i++) {
			out.println(wp[i] / 4 + owp[i] / 2 + oowp[i] / 4);
		}
	}

}
