import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

/**
 * @author Iskander Akishev
 */
public class Airport {

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader("input.txt"));
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));

		int numberOfTests = in.nextInt();
		for (int i = 1; i <= numberOfTests; i++) {
			new Airport().solve(in, out, i);
		}

		in.close();
		out.close();
	}

	private void solve(Scanner in, PrintWriter out, int testNumber) {
		int x = in.nextInt();
		int s = in.nextInt();
		int r = in.nextInt();
		double t = in.nextInt();
		int n = in.nextInt();
		int[][] w = new int[n + 1][2];

		w[0][0] = x;
		for (int i = 0; i < n; i++) {
			w[i + 1][0] = - in.nextInt() + in.nextInt();
			w[i + 1][1] = in.nextInt();
			w[0][0] -= w[i + 1][0];
		}

		Arrays.sort(w, new Comparator<int[]>() {
			@Override
			public int compare(int[] o1, int[] o2) {
				return o1[1] - o2[1];
			}
		});

		double ans = 0;
		for (int[] z : w) {
			double tr = z[0] * 1d / (z[1] + r);

			if (tr <= t) {
				t -= tr;
				ans += tr;
			} else {
				double dr = t * 1d * (z[1] + r);
				double ts = (z[0] - dr) / (z[1] + s);
				ans += ts + t;
				t = 0;
			}
		}

		out.println("Case #" + testNumber + ": " + ans);
	}

}
