import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author Iskander Akishev
 */
public class Magicka {

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileReader("input.txt"));
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));

		int numberOfTests = in.nextInt();
		for (int i = 1; i <= numberOfTests; i++) {
			new Magicka().solve(in, out, i);
		}

		in.close();
		out.close();
	}

	final static int K = 128;

	private void solve(Scanner in, PrintWriter out, int testNumber) {
		char[][] c = new char[K][K];
		int cNum = in.nextInt();
		for (int i = 0; i < cNum; i++) {
			char[] comb = in.next().toCharArray();
			c[comb[0]][comb[1]] = c[comb[1]][comb[0]] = comb[2];
		}
		boolean[][] d = new boolean[K][K];
		int dNum = in.nextInt();
		for (int i = 0; i < dNum; i++) {
			char[] opp = in.next().toCharArray();
			d[opp[0]][opp[1]] = d[opp[1]][opp[0]] = true;
		}

		in.nextInt();
		char[] a = in.next().toCharArray();

		StringBuilder list = new StringBuilder(" ");
		for (char e : a) {
			list.append(e);
			while (true) {
				char e1 = list.charAt(list.length() - 1);
				char e2 = list.charAt(list.length() - 2);
				if (c[e1][e2] == 0) {
					break;
				}
				list.setLength(list.length() - 2);
				list.append(c[e1][e2]);
			}

			char ee = list.charAt(list.length() - 1);
			for (int i = 1; i < list.length() - 1; i++) {
				if (d[ee][list.charAt(i)]) {
					list.setLength(1);
					break;
				}
			}
		}


		StringBuilder res = new StringBuilder();
		if (list.length() == 1) {
			res.append("[]");
		} else {
			res.append('[').append(list.charAt(1));
			for (int i = 2; i < list.length(); i++) {
				res.append(", ").append(list.charAt(i));
			}
			res.append(']');
		}

		out.println("Case #" + testNumber + ": " + res);
	}

}
