import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

public class Main2 {

	public Main2() {

	}

	public boolean isRight(StringBuffer s) {
		return isRight(convert(s));
	}

	public Elem[] convert(StringBuffer s) {
		Elem[] res = new Elem[s.length()];
		for (int i = 0; i < s.length(); i++) {
			res[i] = new Elem(s.charAt(i), false);
		}
		return res;
	}

	public boolean isRight(Elem[] array) {
		if (array.length < 3)
			return false;
		int endi = -1;
		Elem acum1 = new Elem('1', false);
		for (int i = 0; i < array.length; i++) {
			acum1 = acum1.mutli(array[i]);
			if (acum1.positiveEquals('i')) {
				endi = i;
				break;
			}
		}
		if (endi == -1) {
			return false;
		}
		int startk = -1;
		Elem acum2 = new Elem('1', false);
		for (int i = array.length - 1; i > endi; i--) {
			acum2 = array[i].mutli(acum2);
			if (acum2.positiveEquals('k')) {
				startk = i;
				break;
			}
		}
		if (startk == -1) {
			return false;
		}

		for (int i = endi + 1; i < startk; i++) {
			acum1 = acum1.mutli(array[i]);
		}
		acum1 = acum1.mutli(acum2);
		if (acum1.negativeEquals('1')) {
			return true;
		}
		return false;
	}

	public StringBuffer buildString(String s, int rep) {
		StringBuffer res = new StringBuffer();
		if (s.length() == 1) {
			return res.append(s);
		}
		for (int i = 0; i < rep; i++) {
			res = res.append(s);
		}
		return res;
	}

	public static void main(String[] args) {
		Main2 m = new Main2();
		Elem.init();
		File input = new File("input.txt");
		File output = new File("output.txt");
		PrintWriter writer = null;
		try {
			Scanner scn = new Scanner(input);
			writer = new PrintWriter(output);
			int num = scn.nextInt();
			scn.nextLine();
			int casenum = 0;
			while (scn.hasNext()) {
				casenum++;
				int currRep = Integer.parseInt(scn.nextLine().split(" ")[1]);
				String current = scn.nextLine();
				boolean res = m.isRight(m.buildString(current, currRep));
				if (res) {
					writer.println("Case #" + casenum + ": " + "YES");
				} else {
					writer.println("Case #" + casenum + ": " + "NO");
				}
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			writer.close();
		}

	}
}

class Elem {
	public static Elem[][] matr;
	public static HashMap<Character, Integer> map;
	char c;
	boolean neg;

	public Elem(char c, boolean neg) {
		this.c = c;
		this.neg = neg;
	}

	private Elem multiChar(Elem e) {
		return matr[map.get(this.c)][map.get(e.c)];
	}

	private boolean multiSign(Elem e) {
		return this.neg ^ e.neg;
	}

	public Elem mutli(Elem e) {
		Elem temp = this.multiChar(e);
		return new Elem(temp.c, this.multiSign(e) ^ temp.neg);
	}

	public boolean positiveEquals(char c) {
		return this.c == c && !this.neg;
	}

	public boolean negativeEquals(char c) {
		return this.c == c && this.neg;
	}

	public static void init() {
		map = new HashMap<Character, Integer>();
		map.put('1', 0);
		map.put('i', 1);
		map.put('j', 2);
		map.put('k', 3);
		matr = new Elem[4][4];
		matr[0][0] = new Elem('1', false);
		matr[0][1] = new Elem('i', false);
		matr[0][2] = new Elem('j', false);
		matr[0][3] = new Elem('k', false);
		matr[1][0] = new Elem('i', false);
		matr[1][1] = new Elem('1', true);
		matr[1][2] = new Elem('k', false);
		matr[1][3] = new Elem('j', true);
		matr[2][0] = new Elem('j', false);
		matr[2][1] = new Elem('k', true);
		matr[2][2] = new Elem('1', true);
		matr[2][3] = new Elem('i', false);
		matr[3][0] = new Elem('k', false);
		matr[3][1] = new Elem('j', false);
		matr[3][2] = new Elem('i', true);
		matr[3][3] = new Elem('1', true);
	}
}
