import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
 
public class CodePractice {
	
	private static StringBuilder builder = new StringBuilder();
	private static int colorStore[];
 
	public static void main(String[] args) {
		FastReader fastReader = new FastReader();
		PrintWriter printWriter = new PrintWriter(System.out, true);
		int T = fastReader.nextInt();
		for (int i = 0; i < T; i++) {
			int N = fastReader.nextInt();
			builder.setLength(0);
			colorStore = new int[95];
			colorStore['R'] = fastReader.nextInt();
			colorStore['O'] = fastReader.nextInt();
			colorStore['Y'] = fastReader.nextInt();
			colorStore['G'] = fastReader.nextInt();
			colorStore['B'] = fastReader.nextInt();
			colorStore['V'] = fastReader.nextInt();
			
			String possibilities = "RYB";
			boolean impossible = false;
			for (int j = 0; j < N; j++) {
				
				possibilities = storeStalls(possibilities);
				if(colorStore['R'] == 0 && colorStore['Y'] == 0 && colorStore['B'] == 0) {
					impossible = true;
					break;
				}
			}
			if(impossible)
				printWriter.println("Case #"+(i+1)+": IMPOSSIBLE");
			else
				printWriter.println("Case #"+(i+1)+": "+builder.toString());
		}
	}
	
	static String storeStalls(String possibilities) {
		
		for (int i = 0; i < possibilities.length(); i++) {
			if(colorStore[possibilities.charAt(i)] != 0) {
				colorStore[possibilities.charAt(i)]--;
				builder.append(possibilities.charAt(i)+"");
				
				if(possibilities.charAt(i) == 'R')
					return "YB";
				else if(possibilities.charAt(i) == 'Y')
					return "RB";
				else if(possibilities.charAt(i) == 'B')
					return "RY";
				
				break;
			}
		}
		return "";
	}
 
	static class FastReader
	{
		BufferedReader br;
		StringTokenizer st;
 
		public FastReader() {
			br = new BufferedReader(new InputStreamReader(System.in));
		}
 
		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException  e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
 
		int nextInt() {
			return Integer.parseInt(next());
		}
 
		long nextLong() {
			return Long.parseLong(next());
		}
 
		double nextDouble() {
			return Double.parseDouble(next());
		}
 
		String nextLine() {
			String str = "";
			try {
				str = br.readLine();
			}
			catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}
	}
 
}