import java.util.*;

public class CoinJam {
	public static void main(String[] args){		
		Scanner scanner = new Scanner(System.in);
		int testcases = Integer.parseInt(scanner.nextLine());
		for(int i=1; i<=testcases; i++){
			String[] line = scanner.nextLine().split(" ");
			int N = Integer.parseInt(line[0]);
			int J = Integer.parseInt(line[1]);
			System.out.println(String.format("Case #%d:", i));
			coinJam(N, J);
		}
		scanner.close();
	}
	
	public static void coinJam(int N, int J){
		int count = 0;
		
		// upper bound is 2^N
		long upperBound = (long) Math.pow(2, N);
		
		for(long i=(long) Math.pow(2,N-1); i<upperBound; i++){
			if(count == J) return;
			
			String binary = Long.toBinaryString(i);
			// Check if first and last characters are 1, continue otherwise
			if(!(binary.charAt(0) == '1' && binary.charAt(binary.length()-1) == '1'))
				continue;
			
			// Check all bases if prime
			boolean hasPrime = false;
			String output = binary;
			for(int b=2; b<=10; b++){
				long num = Long.parseLong(binary, b);
				// Check if prime
				int divisor = findDivisor(num);
				if(divisor == 1){
					// Prime so break
					hasPrime = true;
					break;
				}else{
					output += " " + divisor;
				}
			}
			
			if(hasPrime == false){
				System.out.println(output);
				count++;
			}
			
		}
	}
	
	public static int findDivisor(long num){
		int upperBound = (int) Math.sqrt(num) + 1;
		
		for(int i=2; i<=upperBound; i++){
			if(num % i == 0) return i;
		}
		
		return 1;
	}
}
