import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class Ominoes
{

    public static void main(String[] args) throws FileNotFoundException {
        Scanner input = new Scanner(new File("D-small-attempt0.in"));
        PrintStream out = new PrintStream(new File("output.txt"));

        int T = input.nextInt(); // number of test cases
        for (int i = 0; i < T; i++) {
            out.print("Case #" + (i + 1) + ": ");
            solve(input, out);
        }

    }

    /*
     * 1. Richard will choose any one of the possible X-ominoes.
     * 2. Gabriel must use at least one copy of that X-omino, along with
     * arbitrarily many copies of any X-ominoes (which can include the one
     * Richard chose), to completely fill in an R-by-C grid, with no overlaps
     * and no spillover.
     * If Gabriel can completely fill in the grid, he wins; otherwise, Richard
     * wins.
     */
    public static void solve(Scanner input, PrintStream out) {
        int X = input.nextInt();
        int R = input.nextInt();
        int C = input.nextInt();

        if (X == 1) {
            out.println("GABRIEL");
        } else if (X == 2) {
            // if grid size is divisible by 2, gabriel will always win
            if (R * C % 2 == 0) {
                out.println("GABRIEL");
            } else {
                out.println("RICHARD");
            }
        } else if (X == 3) {
            // gabriel can only win if grid contains at least one 2x3 or 3x2 or 3x3
            if ((R % 2 == 0 && C % 3 == 0) || (R % 3 == 0 && C % 2 == 0) || (R % 3 == 0 && C % 3 == 0)) {
                out.println("GABRIEL");
            } else {
                out.println("RICHARD");
            }
        } else if (X == 4) {
            if((R == 3 && C == 4) || (R == 4 && C ==3) || (R == 4 && C == 4)) {
                out.println("GABRIEL");
            } else {
                out.println("RICHARD");
            }
        }
    }
}
