import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Scanner;


public class Tetris {	
	
	public static final String INPUT_FILE = "D-small-attempt0.in";
	public static final String OUTPUT_FILE = "output_D-small-attempt0.txt";
	
	public static final String CASE_STRING_BEFORE = "Case #";
	public static final String CASE_STRING_AFTER = ": ";
	
	Scanner scanner = null;
	File outputFile;
	PrintStream pout = null;
	int totalTests;
	int testNo;
	//DecimalFormat formatter = new DecimalFormat("#0.0000000");
	int X,R,C;

	
	public static void main(String argv[]){
		
		Tetris cards = new Tetris();
		cards.setup();
		
		cards.start();
		
		cards.exit();
		
	}
	
	private void start(){
		totalTests = scanner.nextInt();
		
		for(int i=1;i<=totalTests;i++){
			testNo = i;
			reset();
			read_input();
			solve_print();
		}
	}
	
	private void reset(){
	}
	
	private void read_input(){
		X = scanner.nextInt();
		R = scanner.nextInt();
		C = scanner.nextInt();
	}
	
	private void solve_print(){
		
		int winner = 1;
		int prod = R*C;
		switch(X){
		case 1:
			// 1 cannot win
			winner =  2;
			break;
			
		case 2:
			
			if(prod%2 == 0){
				// if total cell is even 2 will always win
				winner = 2;
			}else{
				// 1 will always win for odd
				winner = 1;
			}
			break;
			
		case 3:
			if(R==1 || C == 1){
				// 2 cannot win if 1 selects L domino
				winner = 1;
				break;
			}
			
			if(prod%3 != 0){
				// not a multiple of 3, 1 will always win
				winner = 1;
				break;
			}else{
				winner = 2;
				break;
			}
						
		case 4:
			if(R <= 2  || C <=2 ){
				// 2 cannot win if 1 selects h domino
				winner = 1;
				break;
			}
			
			if(prod%4 != 0){
				// not a multiple of 4, 1 will always win
				winner = 1;
				break;
			}
			
			winner = 2;
			break;
			
		}
		
		pout.print(CASE_STRING_BEFORE + testNo + CASE_STRING_AFTER);
		
		if(winner == 1){
			pout.println("RICHARD");
		}else{
			pout.println("GABRIEL");
		}
		
	}
	
//	public class IntegerComparator implements Comparator<Integer> {
//
//	    @Override
//	    public int compare(Integer o1, Integer o2) {
//	        return o2.compareTo(o1);
//	    }
//	}
	
	private void setup(){
		try {
			scanner = new Scanner(new File(INPUT_FILE));
			outputFile = new File(OUTPUT_FILE);
			
			if(outputFile.exists()){
				outputFile.delete();
			}
			
			outputFile.createNewFile();
			
			pout = new PrintStream(outputFile);
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void exit(){
		scanner.close();
		pout.flush();
		pout.close();
		
	}
}
