import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Solution {
	
	public final String INPUT_FILE = "test_input.in";
	public final String OUTPUT_FILE = "output_16_50.txt";


	FileInputStream fis;
	FileOutputStream fos;
	PrintWriter out;
	Scanner scanner;
	int nTestCases;
	int testNo;
	
	int N, J;
	
	
	int nStringFound = 0;
	char []currStr;
	long []divisors;

	public static void main(String[] args) {

		Solution test = new Solution();
		test.solve();
	}

	public void solve() {

		try {
			fis = new FileInputStream(new File(INPUT_FILE));
			// fos = new FileOutputStream(new File("output.txt"));
			out = new PrintWriter(OUTPUT_FILE);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return;
		}

		scanner = new Scanner(fis);
		nTestCases = scanner.nextInt();

		for (testNo = 1; testNo <= nTestCases; testNo++) {
			readNSolveProblem();
		}

		out.flush();
		out.close();

		scanner.close();
		try {
			fis.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void readNSolveProblem() {
		N = scanner.nextInt();
		J = scanner.nextInt();
		solveProb();
		

		//System.out.println("[" + s2 + "]" + " lenght:" + s2.length());
		//System.out.println("[" + s1 + "]" + " lenght:" + s1.length());

		//out.write("test");
		//out.write("" + 123 + "\n");
	}
	
	public void init(){
		nStringFound = 0;
		currStr = new char [N];
		
		currStr[0] = '1';
		currStr[N-1] = '1';
		
		for(int i=1; i<N-1;i++){
			currStr[i] = '0';
		}
		
		divisors = new long[11];
	}
	
	public void solveProb(){
		
		init();
		out.println("Case #" + testNo +":");
		generateSequences(1);		
	}
	
	public void generateSequences(int start){
		
		if(start == N-1){
			//a sequence is generated
			//check the validity
			checkSequence();
			return;
		}
		
		if(nStringFound >= J){
			return;
		}
		generateSequences(start+1);
		
		if(nStringFound >= J){
			return;
		}
		
		currStr[start] = '1';
		generateSequences(start+1);
		
		currStr[start] = '0';
	}

	public void checkSequence(){
		if(nStringFound >= J){
			return;
		}
		
		String seqStr = String.valueOf(currStr);
		
	//	System.out.println(seqStr);
		
		for(int i=2; i<11;i++){
			long div = getDivisor(Long.parseLong(seqStr, i));
			if(div<0){
	//			System.out.println("no is prime:"+Long.parseLong(seqStr, i));
				return;
			}
		//	System.out.println("no:"+Long.parseLong(seqStr, i) + " div:"+div);
			divisors[i] = div;
		}
		
		nStringFound++;
		printResult(seqStr);
	}
	
	public long getDivisor(long number){
		
		long sqRt = (long)Math.sqrt((double)number);
		for(long i = 2; i<=sqRt; i++){
			if(number%i == 0){
				return i;
			}
		}
		return -1;
	}
	
	public void printResult(String str){
		
		out.print(str);
//		if(S < K){
//			 out.println(" IMPOSSIBLE");
//			 return;
//		}
		
		for(int i = 2; i < 11; i++){
			out.print(" "+divisors[i]);
		}
		out.println();
	}
}
