import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Solution {
	
	public final String INPUT_FILE = "A-large.in";
	public final String OUTPUT_FILE = "output_A-large.txt";


	FileInputStream fis;
	FileOutputStream fos;
	PrintWriter out;
	Scanner scanner;
	int nTestCases;
	int testNo;
	
	String S;
	StringBuilder sb;
	char opS[];
	int indexStart, indexEnd;
	
	long N = 0L;
	long currN;
	long currMultiplier;
	int nDigitsFound = 0;
	
	boolean []digitsCount;



	public static void main(String[] args) {

		Solution test = new Solution();
		test.solve();
	}

	public void solve() {

		try {
			fis = new FileInputStream(new File(INPUT_FILE));
			// fos = new FileOutputStream(new File("output.txt"));
			out = new PrintWriter(OUTPUT_FILE);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return;
		}

		scanner = new Scanner(fis);
		nTestCases = scanner.nextInt();
		scanner.nextLine();

		for (testNo = 1; testNo <= nTestCases; testNo++) {
			readNSolveProblem();
		}

		out.flush();
		out.close();

		scanner.close();
		try {
			fis.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void readNSolveProblem() {
		S = scanner.nextLine();
		solveProb();
		

		//System.out.println("[" + s2 + "]" + " lenght:" + s2.length());
		//System.out.println("[" + s1 + "]" + " lenght:" + s1.length());

		//out.write("test");
		//out.write("" + 123 + "\n");
	}
	
	public void init(){
		sb = new StringBuilder(2*S.length());
	}
	
	public void solveProb(){
		
		init();
		for(int i=0;i<S.length();i++){
			char currChar = S.charAt(i);
			if(sb.length() == 0 || currChar >= sb.charAt(0)){
				sb.insert(0, currChar);
			}else{
				sb.append(currChar);
			}
		}
		printResult();
	}
	
	public void updateDigits(){
		
		long tempN = currN;
		int digit;
		while(tempN>0){
			digit = (int)tempN%10;
			if(!digitsCount[digit]){
				//hurray found a new digit
				digitsCount[digit] = true;
				nDigitsFound++;
			}
			
			tempN /= 10;
		}	
	}
	
	public boolean isConditionSatisfied(){
		return nDigitsFound>=10;
	}

	public void printResult(){
		out.println("Case #" + testNo +": "+sb.toString());
	}
}
