import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Solution {
	
	public final String INPUT_FILE = "A-large.in";
	public final String OUTPUT_FILE = "output_Alarge.txt";


	FileInputStream fis;
	FileOutputStream fos;
	PrintWriter out;
	Scanner scanner;
	long N = 0L;
	long currN;
	long currMultiplier;
	int nDigitsFound = 0;
	
	boolean []digitsCount;

	int nTestCases;
	int testNo;

	public static void main(String[] args) {

		Solution test = new Solution();
		test.solve();
	}

	public void solve() {

		try {
			fis = new FileInputStream(new File(INPUT_FILE));
			// fos = new FileOutputStream(new File("output.txt"));
			out = new PrintWriter(OUTPUT_FILE);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return;
		}

		scanner = new Scanner(fis);
		nTestCases = scanner.nextInt();

		for (testNo = 1; testNo <= nTestCases; testNo++) {
			readNSolveProblem();
		}

		out.flush();
		out.close();

		scanner.close();
		try {
			fis.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void readNSolveProblem() {
		N = scanner.nextLong();
		solveProb();
		

		//System.out.println("[" + s2 + "]" + " lenght:" + s2.length());
		//System.out.println("[" + s1 + "]" + " lenght:" + s1.length());

		//out.write("test");
		//out.write("" + 123 + "\n");
	}
	
	public void init(){
		currMultiplier = 1;
		currN = N;
		nDigitsFound = 0;
		digitsCount = new boolean[10]; 
	}
	
	public void solveProb(){
		
		init();
		if(currN == 0){
			printResult(-1);
			return;
		}
		
		updateDigits();
		if(isConditionSatisfied()){
			printResult(currN);
			return;
		}
		
		for(currMultiplier = 2; ; currMultiplier++){
			
			currN += N;
			updateDigits();
			if(isConditionSatisfied()){
				printResult(currN);
				return;
			}
		}
	}
	
	public void updateDigits(){
		
		long tempN = currN;
		int digit;
		while(tempN>0){
			digit = (int)tempN%10;
			if(!digitsCount[digit]){
				//hurray found a new digit
				digitsCount[digit] = true;
				nDigitsFound++;
			}
			
			tempN /= 10;
		}	
	}
	
	public boolean isConditionSatisfied(){
		return nDigitsFound>=10;
	}

	public void printResult(long v){
		out.print("Case #" + testNo +": ");
		 if(v>=0){
			 out.println(v);
		 }else{
			 out.println("INSOMNIA");
		 }
	}
}
