import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Scanner;


public class Pie {	
	
	public static final String INPUT_FILE = "B-small-attempt2.in";
	public static final String OUTPUT_FILE = "output_B-small-attempt2.txt";
	
	public static final String CASE_STRING_BEFORE = "Case #";
	public static final String CASE_STRING_AFTER = ": ";
	
	Scanner scanner = null;
	File outputFile;
	PrintStream pout = null;
	int totalTests;
	int testNo;
	int nMins;
	//DecimalFormat formatter = new DecimalFormat("#0.0000000");
	
	ArrayList<Integer> plates = null;
	int nPlates;
	
	
	public static void main(String argv[]){
		
		Pie cards = new Pie();
		cards.setup();
		
		cards.start();
		
		cards.exit();
		
	}
	
	private void start(){
		totalTests = scanner.nextInt();
		
		for(int i=1;i<=totalTests;i++){
			testNo = i;
			reset();
			read_input();
			solve_print();
		}
	}
	
	private void reset(){
		plates = new ArrayList<Integer>();
		nPlates = 0;
		nMins = 0;
	}
	
	private void read_input(){
		nPlates = scanner.nextInt();
		for(int i=0;i<nPlates;i++){
			plates.add(scanner.nextInt());
		}
		Collections.sort(plates);
	}
	
	private void solve_print(){
		nMins = compute_recursively();
		pout.print(CASE_STRING_BEFORE + testNo + CASE_STRING_AFTER);
		
		if (testNo == totalTests) {
			pout.print(nMins);
		} else {
			pout.println(nMins);
		}
	}
	
	private int compute_recursively() {
		
		int size = plates.size();
		int index = size-1;
//		if(startIndex>=size){
//			return 0;
//		}
		
		if(size == 0){
			return 0;
		}
		
		int max = plates.get(index);
		
		if(max<4){
			// does not make sense to split sizes 1/2/3
			return max;
		}
		
		int count = 1;
		int temp;
		for(int i = index-1; i >= 0; i--){
			temp = plates.get(i);
			if(temp==max){
				count++;
			}else{
				break;
			}
		}
		
		int limit = max/2;
		if(count>=limit){
			// it does not make sense to to split
			return max;
		}
		
		//split
		
		plates.remove(index);
		int a = max/2;
		int b = max-a;
		plates.add(a);
		plates.add(b);
		
		Collections.sort(plates);
		
		int retVal = compute_recursively();	
		
		if(retVal + 1 >= max){
			return max;
		}else{
			return retVal + 1;
		}
	}
	
//	public class IntegerComparator implements Comparator<Integer> {
//
//	    @Override
//	    public int compare(Integer o1, Integer o2) {
//	        return o2.compareTo(o1);
//	    }
//	}
	
	private void setup(){
		try {
			scanner = new Scanner(new File(INPUT_FILE));
			outputFile = new File(OUTPUT_FILE);
			
			if(outputFile.exists()){
				outputFile.delete();
			}
			
			outputFile.createNewFile();
			
			pout = new PrintStream(outputFile);
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private void exit(){
		scanner.close();
		pout.flush();
		pout.close();
		
	}
}
