import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Solution_LargeInput {
	
	public final String INPUT_FILE = "test_input_large.in";
	public final String OUTPUT_FILE = "output_32_500.txt";


	FileInputStream fis;
	FileOutputStream fos;
	PrintWriter out;
	Scanner scanner;
	int nTestCases;
	int testNo;
	
	int N, J;
	
	
	int nStringFound = 0;
	char []currStr;
	BigInteger []divisors;
	BigInteger []sqRtBoundary;

	public static void main(String[] args) {

		Solution_LargeInput test = new Solution_LargeInput();
		test.solve();
	}

	public void solve() {

		try {
			fis = new FileInputStream(new File(INPUT_FILE));
			// fos = new FileOutputStream(new File("output.txt"));
			out = new PrintWriter(OUTPUT_FILE);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return;
		}

		scanner = new Scanner(fis);
		nTestCases = scanner.nextInt();

		for (testNo = 1; testNo <= nTestCases; testNo++) {
			readNSolveProblem();
		}

		out.flush();
		out.close();

		scanner.close();
		try {
			fis.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	public void readNSolveProblem() {
		N = scanner.nextInt();
		J = scanner.nextInt();
		solveProb();
		

		//System.out.println("[" + s2 + "]" + " lenght:" + s2.length());
		//System.out.println("[" + s1 + "]" + " lenght:" + s1.length());

		//out.write("test");
		//out.write("" + 123 + "\n");
	}
	
	public void init(){
		nStringFound = 0;
		currStr = new char [N];
		
		currStr[0] = '1';
		currStr[N-1] = '1';
		
		for(int i=1; i<N-1;i++){
			currStr[i] = '0';
		}
		
		divisors = new BigInteger[11];
		
		sqRtBoundary = new BigInteger[11];
		
		for(int i=2;i<11;i++){
			//long pow = (long)Math.pow(i, 17);
			//sqRtBoundary[i] = new BigInteger(String.valueOf(pow));
			sqRtBoundary[i] = new BigInteger(String.valueOf("1000"));
		}
	}
	
	public void solveProb(){
		
		init();
		out.println("Case #" + testNo +":");
		generateSequences(1);		
	}
	
	public void generateSequences(int start){
		
		if(start == N-1){
			//a sequence is generated
			//check the validity
			checkSequence();
			return;
		}
		
		if(nStringFound >= J){
			return;
		}
		generateSequences(start+1);
		
		if(nStringFound >= J){
			return;
		}
		
		currStr[start] = '1';
		generateSequences(start+1);
		
		currStr[start] = '0';
	}

	public void checkSequence(){
		if(nStringFound >= J){
			return;
		}
		
		String seqStr = String.valueOf(currStr);
		
		System.out.println(seqStr);
		
//		for(int i=21; i<=3;i++){
//			System.out.println("parsing string for index:"+i);
//			long div = getDivisor(Long.parseLong(seqStr, i));
//			if(div<0){
//				System.out.println("no is prime:"+Long.parseLong(seqStr, i));
//				return;
//			}
//			System.out.println("no:"+Long.parseLong(seqStr, i) + " div:"+div);
//			divisors[i] = new BigInteger(String.valueOf(div));
//		}
		
		for(int i=2; i<11;i++){
			System.out.println("parsing string for index:"+i);
			
			BigInteger bigNo = new BigInteger(seqStr, i);
			
			BigInteger div = getDivisor(bigNo, i);
			if(div == null){
				return;
			}
			
			
			//long div = getDivisor(Long.parseLong(seqStr, i));
		//	if(div<0){
	//			System.out.println("no is prime:"+Long.parseLong(seqStr, i));
		//		return;
		//	}
		//	System.out.println("no:"+Long.parseLong(seqStr, i) + " div:"+div);
			divisors[i] = div;
		}
		
		nStringFound++;
		printResult(seqStr);
	}
	
	public long getDivisor(long number){
		
		long sqRt = (long)Math.sqrt((double)number);
		
		if(number%2 == 0){
			return 2;
		}
		
		
		for(long i = 3; i<=sqRt; i+=2){
			if(number%i == 0){
				return i;
			}
		}
		return -1;
	}
	
	public BigInteger getDivisor(BigInteger number, int base){
		
		System.out.println("getting divisor for number:"+number);
		BigInteger big2 = new BigInteger("2");
		BigInteger [] div2 = number.divideAndRemainder(big2);
		
		if(div2[1].equals(BigInteger.ZERO)){
			//hurray divisible by 2;
			System.out.println("divisible/2 number:"+number);

			return big2;
		}
		
		BigInteger counter = big2;
		counter = counter.add(BigInteger.ONE); //3
		
		BigInteger mod = number.mod(counter);
		if(mod.equals(BigInteger.ZERO)){
			//hurray found a divisor
			System.out.println("found divisor for number:"+number + " :" + counter);
			return counter;
		}
		
		if(number.isProbablePrime(1)){
			System.out.println("probably prime number:"+number);
			return null;
		}
		
		if(number.equals(new BigInteger("1326443518324400147398873"))){
			//consider it prime
			return null;
		}
		
		counter = counter.add(BigInteger.ONE);
		counter = counter.add(BigInteger.ONE); //5
		
		BigInteger boundary = sqRtBoundary[base];
		
		while(counter.compareTo(boundary)<=0){
			System.out.println("checking divisor for number:"+number + " :" + counter);
			mod = number.mod(counter);
			if(mod.equals(BigInteger.ZERO)){
				//hurray found a divisor
				System.out.println("found divisor for number:"+number + " :" + counter);
				return counter;
			}
			counter = counter.add(BigInteger.ONE);
			counter = counter.add(BigInteger.ONE);
			
			System.out.println("checking divisor for number:"+number + " :" + counter);
			mod = number.mod(counter);
			if(mod.equals(BigInteger.ZERO)){
				//hurray found a divisor
				System.out.println("found divisor for number:"+number + " :" + counter);
				return counter;
			}
			counter = counter.add(BigInteger.ONE);
			counter = counter.add(BigInteger.ONE);
			counter = counter.add(BigInteger.ONE);
			counter = counter.add(BigInteger.ONE);
		}
		
		return null;
		
		//long sqRt = (long)Math.sqrt((double)number);
		
		
//		for(BigInteger i = BigInteger.ONE.add(BigInteger.ONE); i<=number.shiftRight(1); i++){
//			if(number%i == 0){
//				return i;
//			}
//		}
//		return -1;
	}
	
	public void printResult(String str){
		
		System.out.println("printing result for string:"+str);
		out.print(str);
//		if(S < K){
//			 out.println(" IMPOSSIBLE");
//			 return;
//		}
		
		for(int i = 2; i < 11; i++){
			out.print(" "+divisors[i]);
		}
		out.println();
		out.flush();
	}
}
