import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;

public class PanCakeFixer {
    private PrintWriter writer;
    private BufferedReader br;
    private int mNumberOfCases, mMinNumberToFlip;
    private String mCurrentCase;

    public PanCakeFixer(String file) throws Exception{
        writer = new PrintWriter("output.in", "UTF-8");
        br = new BufferedReader(new FileReader(file));
        tryToFix();
    }

    private void tryToFix() throws Exception{
        try {
            mNumberOfCases = Integer.valueOf(br.readLine());
            for (int i = 0; i < mNumberOfCases; i++) {
                mCurrentCase = br.readLine();
                mMinNumberToFlip = getNumberOfFlips(mCurrentCase);
                writer.println("Case #" + (i + 1) + ": " + mMinNumberToFlip);
            }
        } finally {
            br.close();
            writer.close();
        }
    }

    private int getNumberOfFlips(String mCurrentCase) {
        int numberOfFirstCase = 0;
        String firstCase = Character.toString(mCurrentCase.charAt(0));

        for (int i = 0; i <mCurrentCase.length(); i++) {
            if (Character.toString(mCurrentCase.charAt(i)).equals(firstCase)) {
                numberOfFirstCase++;
            } else {
                if (firstCase.equals("-"))
                    mCurrentCase = new String(new char[numberOfFirstCase]).replace("\0", "+") + mCurrentCase.substring(numberOfFirstCase, mCurrentCase.length());
                else
                    mCurrentCase = new String(new char[numberOfFirstCase]).replace("\0", "-") + mCurrentCase.substring(numberOfFirstCase,mCurrentCase.length());
                return 1 + getNumberOfFlips(mCurrentCase);
            }
        }
        if (numberOfFirstCase == mCurrentCase.length() && firstCase.equals("-"))
            return 1;
        else if (numberOfFirstCase == mCurrentCase.length())
            return 0;
        return -1;
    }

    public static void main(String[] args) throws Exception{
        new PanCakeFixer("B-small-attempt0.in");
    }
}
