import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.HashSet;

public class SheepCounting {
    private BufferedReader br;
    private int mNumberOfCases;
    private static final String insomnia = "INSOMNIA";
    private BigInteger mCurrentNumber;
    private HashSet<Integer> hashSet;
    private BigInteger minusOne = new BigInteger("-1");
    private PrintWriter writer;
    private BigInteger mFinalTimesToSleep;
    private BigInteger one = new BigInteger("1");

    public SheepCounting(String fileName) throws  Exception {
        writer = new PrintWriter("output.in", "UTF-8");
        br = new BufferedReader(new FileReader(fileName));
        processDetails();
    }
    private void processDetails() throws Exception{
        try {
            mNumberOfCases = Integer.valueOf(br.readLine());
            for (int i = 0; i < mNumberOfCases; i++) {
                mCurrentNumber = new BigInteger(br.readLine());
                mFinalTimesToSleep = getNumberOfTimesBeforeSleeping(mCurrentNumber);
                if (mFinalTimesToSleep == minusOne) {
                    writer.println("Case #" + (i + 1) + ": " + insomnia);
                } else {
                    writer.println("Case #" + (i + 1) + ": " + mFinalTimesToSleep);
                }

            }

        } finally {
            br.close();
            writer.close();
        }
    }

    private BigInteger getNumberOfTimesBeforeSleeping(BigInteger mCurrentNumber) {
        hashSet = new HashSet<>();
        BigInteger lastBig = new BigInteger("1");
        String stringNumber = mCurrentNumber.toString();

        if (stringNumber.equals("0"))
            return minusOne;
        while (hashSet.size() != 10) {
            stringNumber = mCurrentNumber.multiply(lastBig).toString();
            lastBig = lastBig.add(one);
            for (int i = 0; i <stringNumber.length(); i++) {
                hashSet.add(Integer.valueOf(stringNumber.charAt(i)));
            }
        }
        return new BigInteger(stringNumber);
    }

    public static void main (String[] args) throws Exception {
        new SheepCounting("A-large.in");
    }
}
