import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;

public class CoinJamCreator {
    private PrintWriter writer;
    private BufferedReader br;
    private int mNumberOfCases, mNumberOfValuesPrinted;
    private boolean breakIt = false;
    private ArrayList<Long> candidates;

    public CoinJamCreator(String file) throws Exception{
        writer = new PrintWriter("output.in", "UTF-8");
        br = new BufferedReader(new FileReader(file));
        coinsFinder();
    }

    private void coinsFinder() throws Exception {
        try {
            mNumberOfCases = Integer.valueOf(br.readLine());

            for (int i = 0; i < mNumberOfCases; i++) {
                String[] data = br.readLine().split(" ");
                writer.println("Case #" + (i+ 1) + ":");
                generateNumber(Integer.valueOf(data[0]), "", Integer.valueOf(data[1]));
            }
        } finally {
            br.close();
            writer.close();
        }
    }

    private void generateNumber(int N, String value, int J) {
        if (breakIt)
            return;

        if (value.length() == N - 1) {
            changeBasesAndCheckForPrime(value + "1", J);
        } else if (value.length() == 0) {
            generateNumber(N, "1", J);
        } else {
            generateNumber(N, value + "0", J);
            generateNumber(N, value + "1", J);
        }
    }

    private void changeBasesAndCheckForPrime(String value, int J) {
        boolean valid = true;
        candidates = new ArrayList<>();
        for (int i = 2; i < 11; i ++) {
            long num = Long.parseLong(Long.toString(Long.parseLong(value, i), 10));
            long candidate = isPrime(num);
            candidates.add(candidate);
            if (candidate == num && candidate != 1) {
                valid = false;
                break;
            }
        }
            if (valid) {
                writer.print(value);
                for (int i = 0; i < candidates.size(); i++) {
                    writer.print(" " + candidates.get(i));
                }
                writer.println();
                mNumberOfValuesPrinted++;
            }
            if (mNumberOfValuesPrinted == J) {
                breakIt = true;
            }
        }

    private long isPrime(long n) {
        if(n < 2) return 1;
        if(n == 2 || n == 3) return n;
        if(n%2 == 0) return 2;
        if(n%3 == 0) return 3;
        long sqrtN = (long)Math.sqrt(n)+1;
        for(long i = 6L; i <= sqrtN; i += 6) {
            if(n%(i-1) == 0) return (i-1);
            if(n%(i+1) == 0) return (i+1);
        }
        return n;
    }

    public static void main(String[] args) throws Exception{
        new CoinJamCreator("C-small-attempt0.in");
    }
}
