/*
Problem

We have come up with the best possible language here at Google, called Googlerese. To translate text into Googlerese, we take any message and replace each English letter with another English letter. This mapping is one-to-one and onto, which means that the same input letter always gets replaced with the same output letter, and different input letters always get replaced with different output letters. A letter may be replaced by itself. Spaces are left as-is.

For example (and here is a hint!), our awesome translation algorithm includes the following three mappings: 'a' -> 'y', 'o' -> 'e', and 'z' -> 'q'. This means that "a zoo" will become "y qee".

Googlerese is based on the best possible replacement mapping, and we will never change it. It will always be the same. In every test case. We will not tell you the rest of our mapping because that would make the problem too easy, but there are a few examples below that may help.

Given some text in Googlerese, can you translate it to back to normal text?

Solving this problem

Usually, Google Code Jam problems have 1 Small input and 1 Large input. This problem has only 1 Small input. Once you have solved the Small input, you have finished solving this problem.

Input

The first line of the input gives the number of test cases, T. T test cases follow, one per line.

Each line consists of a string G in Googlerese, made up of one or more words containing the letters 'a' - 'z'. There will be exactly one space (' ') character between consecutive words and no spaces at the beginning or at the end of any line.

Output

For each test case, output one line containing "Case #X: S" where X is the case number and S is the string that becomes G in Googlerese.

Limits

1 = T = 30.
G contains at most 100 characters.
None of the text is guaranteed to be valid English.
Sample

Input
3
ejp mysljylc kd kxveddknmc re jsicpdrysi
rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd
de kr kd eoya kw aej tysr re ujdr lkgc jv


Output
Case #1: our language is impossible to understand
Case #2: there are twenty six factorial possibilities
Case #3: so it is okay if you want to just give up
*/
import java.io.*;
import java.util.logging.Level;
import java.util.logging.Logger;
public class Speakingintongues

{
     BufferedReader read;
     BufferedWriter write;
    public static void main(String args[])
    {
        try {
            new Speakingintongues().init("A-small-attempt0");
        } catch (Exception ex) {
            //Logger.getLogger(StoreCredit.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
     void init(String name) throws Exception
        {
        read=new BufferedReader(new FileReader(new File(name+".in")));
        write=new BufferedWriter(new FileWriter(new File(name+".out")));
        
		String x="";
        
            try {
                   x = read.readLine();
                   int n = Integer.parseInt(x);
                   for(int i=0;i<n;i++)
                      {
					    x = read.readLine();
						String code,fcode="";
					    for(int j=0;j<x.length();j++)
						 { 
						   switch(x.charAt(j))
						    {
						      case 'a' : code = "y";break;
							  case 'b' : code = "h";break;
							  case 'c' : code = "e";break;
							  case 'd' : code = "s";break;
							  case 'e' : code = "o";break;
							  case 'f' : code = "c";break;
							  case 'g' : code = "v";break;
							  case 'h' : code = "x";break;
							  case 'i' : code = "d";break;
							  case 'j' : code = "u";break;
							  case 'k' : code = "i";break;
							  case 'l' : code = "g";break;
							  case 'm' : code = "l";break;
							  case 'n' : code = "b";break;
							  case 'o' : code = "k";break;
							  case 'p' : code = "r";break;
							  case 'q' : code = "z";break;
							  case 'r' : code = "t";break;
							  case 's' : code = "n";break;
							  case 't' : code = "w";break;
							  case 'u' : code = "j";break;
							  case 'v' : code = "p";break;
							  case 'w' : code = "f";break;
							  case 'x' : code = "m";break;
							  case 'y' : code = "a";break;
							  case 'z' : code = "q";break;
							  default : code = " ";break;
						    }
						    fcode = fcode+code;
						 }
						 write.write("Case #"+(i+1)+":"+" "+fcode+"\n");
						 System.out.println("Case #"+(i+1)+":"+" "+fcode+"\n");
					   			
                       }
					   write.flush();
				write.close();
				read.close();
                }
                
				
                  // System.out.println(a+"    "+b);

             catch (Exception ex)
			 {
                           System.exit(0);
             }
	    }
      
}
