import com.sun.deploy.util.ArrayUtil;
import com.sun.xml.internal.bind.v2.runtime.unmarshaller.XsiNilLoader;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.function.BooleanSupplier;
import java.util.stream.IntStream;

/**
 * Created by aaghi on 4/9/2016.
 */
public class PancakeFlip {

    public static void main(String[] args){
        try{
            Collection<String> inputCases = new ArrayList<String>();
            BufferedReader bufferedReader = new BufferedReader
                    (new FileReader("C:\\Users\\aaghi\\IdeaProjects\\PancakeFlip\\src\\input1.txt"));

            FileOutputStream fileOutputStream = new FileOutputStream("C:\\Users\\aaghi\\IdeaProjects\\PancakeFlip\\src\\output1.txt");
            BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(fileOutputStream));

            int numTestCases = Integer.parseInt(bufferedReader.readLine());
            String line;
            while ((line = bufferedReader.readLine()) != null) {
                inputCases.add(line);
            }
            IntStream outCaseStream = inputCases.parallelStream()
                    .mapToInt(j -> calculateMinFlips(j));

            int caseNum = 0;
            for(int minFlips:outCaseStream.toArray()){
                caseNum++;
                bufferedWriter.write("Case #" + caseNum + ": " + minFlips);
                if (caseNum < numTestCases) {
                    bufferedWriter.write("\n");
                }
            }
            bufferedWriter.close();
        }catch (Exception e){
            System.out.println(e.toString());
        }

//        List<Boolean> src = new ArrayList<Boolean>();
//        src.add(false);src.add(false);src.add(true);src.add(false);
//        List<Boolean> res = flip(src);
//        System.out.println(res.toString());
    }

    public static int calculateMinFlips(String cakes){
        int numFlips = 0;
        List<Boolean> cakePos = new ArrayList<Boolean>();
        for(char a:cakes.toCharArray()){
            cakePos.add(a=='+');
        }

        while(cakePos.size()>0){
            cakePos = shaveBottom(cakePos);
            if(cakePos.size()==0){
                break;
            }
            int i;
            for(i = 0; i < cakePos.size() && cakePos.get(i); i++);

            List<Boolean> bottom = cakePos.subList(i,cakePos.size());
            List<Boolean> top = cakePos.subList(0,i);
            if(top.size()>0){
                numFlips++;
                top = flip(top);
                bottom.addAll(top);
                cakePos = bottom;
            }
            numFlips++;
            cakePos = flip(cakePos);
        }

        return numFlips;
    }

    static List<Boolean> shaveBottom(List<Boolean> src){
        int loc = src.size();
        while(true){
            if(loc<1)
                break;
            if(src.get(loc-1))
                loc--;
            else
                break;
        }
        return src.subList(0,loc);
    }

   static List<Boolean> flip(List<Boolean> src){
       List<Boolean> ret = new ArrayList<Boolean>();
        for(int i = src.size()-1 ; i >= 0; i--){
            ret.add(!src.get(i));
        }
        return ret;
    }
}
