import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collection;
import java.util.stream.Collectors;
import java.util.stream.IntStream;
import java.util.stream.Stream;

/**
 * Created by aaghi on 4/9/2016.
 */
public class CoinJam {

    public static void main(String[] args) {
        try {
            Collection<String> inputCases = new ArrayList<String>();
            BufferedReader bufferedReader = new BufferedReader
                    (new FileReader("C:\\Users\\aaghi\\IdeaProjects\\CoinJam\\src\\input1.txt"));

            FileOutputStream fileOutputStream = new FileOutputStream("C:\\Users\\aaghi\\IdeaProjects\\CoinJam\\src\\output1.txt");
            BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(fileOutputStream));
            int numTestCases = Integer.parseInt(bufferedReader.readLine());
            String testCase = bufferedReader.readLine();
            String[] testCaseTokens = testCase.split(" ");
            Integer N = Integer.parseInt(testCaseTokens[0]);
            Integer J = Integer.parseInt(testCaseTokens[1]);
            bufferedWriter.write("Case #1:" + "\n");
            int coinsGen = 0;
            BigInteger iter = BigInteger.ZERO;
            while(coinsGen < J){
                String candidateSubCoin = iter.toString(2);
                String padding = Stream.generate(()->"0").limit((N-2)-candidateSubCoin.length()).collect(Collectors.joining());
                String candidate = "1"+padding+candidateSubCoin+"1";
                if(printIfJamCoin(candidate,bufferedWriter)){
                    coinsGen++;
                }
                iter = iter.add(BigInteger.ONE);
            }
            bufferedWriter.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static boolean printIfJamCoin(String num,BufferedWriter writer)throws IOException{
        StringBuilder out = new StringBuilder();
        out.append(num);
        for(int i = 2 ; i <= 10 ; i++){
            BigInteger valInBase = new BigInteger(num,i);
            BigInteger divisor = findDivisor(valInBase);
            if(divisor==BigInteger.ONE){
                return false;
            }
            else{
                out.append(" "+divisor.toString(10));
            }
        }
        writer.write(out.toString());
        writer.write("\n");
        return true;
    }

    public static BigInteger findDivisor(BigInteger num){
        BigInteger root = bigIntSqRootCeil(num);
        BigInteger i = BigInteger.ONE;
        i = i.add(BigInteger.ONE);
        BigInteger ret = BigInteger.ONE;
        while(i.compareTo(root) <= 0){
            if(num.mod(i) == BigInteger.ZERO){
                ret = i;
                break;
            }
            if(i.compareTo(new BigInteger("25000")) > 0){
                break;
            }
            i = i.add(BigInteger.ONE);
            if(i.compareTo(new BigInteger("3"))>0){
                i = i.add(BigInteger.ONE);
            }
        }
        return ret;
    }

    public static BigInteger bigIntSqRootCeil(BigInteger x)
            throws IllegalArgumentException {
        if (x.compareTo(BigInteger.ZERO) < 0) {
            throw new IllegalArgumentException("Negative argument.");
        }
        // square roots of 0 and 1 are trivial and
        // y == 0 will cause a divide-by-zero exception
        if (x == BigInteger.ZERO || x == BigInteger.ONE) {
            return x;
        } // end if
        BigInteger two = BigInteger.valueOf(2L);
        BigInteger y;
        // starting with y = x / 2 avoids magnitude issues with x squared
        for (y = x.divide(two);
             y.compareTo(x.divide(y)) > 0;
             y = ((x.divide(y)).add(y)).divide(two));
        if (x.compareTo(y.multiply(y)) == 0) {
            return y;
        } else {
            return y.add(BigInteger.ONE);
        }
    } // end bigIntSqRootCeil
}
