import java.io.*;
import java.util.*;

/**
 * Created by aaghi on 4/15/2016.
 */
public class RankFile {

    private static class InputCase {
        public String s;
        public String missingRow;
        public List<List<Integer>> rows;
        public int caseNum;
        HashMap<Integer,Integer> seenCount;

        public InputCase(int caseNum) {
            this.caseNum = caseNum;
        }

        public void calculateMissingRow() {
            this.seenCount = new HashMap<Integer,Integer>();
            for(List<Integer> row:rows){
                for(Integer height:row){
                    if(!seenCount.containsKey(height)){
                        seenCount.put(height,1);
                    }else{
                        seenCount.put(height,seenCount.get(height)+1);
                    }
                }
            }
            List<Integer> missingRow = new LinkedList<Integer>();
            for(Integer height:seenCount.keySet()){
                Integer count = seenCount.get(height);
                if(count%2!=0){
                    missingRow.add(height);
                }
            }
            Collections.sort(missingRow);
            StringBuilder missingRowBuilder = new StringBuilder();
            boolean isFirst = true;
            for(Integer height:missingRow){
                if(isFirst){
                    isFirst = false;
                }
                else{
                    missingRowBuilder.append(" ");
                }
                missingRowBuilder.append(height.toString());
            }
            this.missingRow = missingRowBuilder.toString();
        }
    }

        public static void main(String[] args) {
            try {
                Collection<InputCase> inputCases = new ArrayList<InputCase>();
                BufferedReader bufferedReader = new BufferedReader(new FileReader("C:\\Users\\aaghi\\IdeaProjects\\RankFile\\src\\input1.txt"));
                FileOutputStream fileOutputStream = new FileOutputStream("C:\\Users\\aaghi\\IdeaProjects\\RankFile\\src\\output1.txt");
                BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(fileOutputStream));
                int numTestCases = Integer.parseInt(bufferedReader.readLine());
                String line;
                int caseNum = 0;
                while ((line = bufferedReader.readLine()) != null) {
                    caseNum++;
                    InputCase inputCase = new InputCase(caseNum);
                    Integer N = Integer.parseInt(line);
                    Integer numRows = 2*N - 1;
                    inputCase.rows = new LinkedList<List<Integer>>();
                    for(int i = 0 ; i < numRows ; i++){
                         line = bufferedReader.readLine();
                        String[] lineTokens = line.split(" ");
                        List<Integer> row = new LinkedList<Integer>();
                        for(String lineToken:lineTokens){
                            row.add(Integer.parseInt(lineToken));
                        }
                        inputCase.rows.add(row);
                    }
                    inputCases.add(inputCase);
                }
                inputCases.parallelStream().forEach(inputCase -> inputCase.calculateMissingRow());

                for (InputCase inputCase : inputCases) {
                    bufferedWriter.write("Case #" + inputCase.caseNum + ": " + inputCase.missingRow);
                    if (inputCase.caseNum < numTestCases) {
                        bufferedWriter.write("\n");
                    }
                }
                bufferedWriter.close();
            } catch (Exception e) {
                System.out.println(e.toString());
            }
        }
    }
