import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;

public class Driver {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Scanner scanner = new Scanner(System.in);
		int T = scanner.nextInt();
		for (int i = 0; i < T; i++) {

			int R = scanner.nextInt();
			int C = scanner.nextInt();
			int mines = scanner.nextInt();
			char[][] map = new char[R][C];

			for (int j = 0; j < R; j++)
				for (int k = 0; k < C; k++)
					map[j][k] = '.';
			map[0][0] = 'c';

			System.out.println("Case #" + (i + 1) + ":");
			System.out.println(solve(R, C, mines, map));

		}
	}

	private static boolean okToFill(char[][] map, int r, int c, boolean col) {

		if (col) {

			if (map[0].length >= 2) {
				return c > 1;
			}else {
				return true;
			}
		} else {
			if (map.length >= 2)
				return r > 1;
			else
				return true;
		}

	}

	private static String solve(int R, int C, int mines, char[][] map) {

		if((R*C)<=mines){
			return "Impossible";
		}
		
		if (((R * C)-1) == mines) {
			for(int i=0;i<R;i++)
				for(int j=0;j<C;j++)
					map[i][j]='*';
			
			map[0][0] = 'c';
			mines = 0;
		} else {

			int mineCol = C - 1;
			int mineRow = R - 1;

			boolean vertical = true;

			while (mines > 0 && (mineCol >= 0 || mineRow >= 0)) {

				if (vertical) {
					int remaining = mineRow+1;

					if (mines >= remaining && mineCol > 1) {
						// fill column
						for (int i = R - 1; i >= 0; i--) {
							if (map[i][mineCol] != '*') {
								map[i][mineCol] = '*';
								mines--;
							}
						}
					} else {
						// leave 2 spots at least
						while (remaining > 2 && mines > 0
								&& okToFill(map, remaining - 1, mineCol, true)) {
							if (map[remaining - 1][mineCol] != '*') {
								map[remaining - 1][mineCol] = '*';
								mines--;
							}
							remaining--;
						}
					}
					mineCol--;
				} else {
					int remaining = mineCol+1;
					if (mines >= remaining && mineRow > 1) {
						// fill row
						for (int i = C - 1; i >= 0; i--) {
							if (map[mineRow][i] != '*') {
								map[mineRow][i] = '*';
								mines--;
							}
						}
					} else {
						// leave at least 2 spots empty
						while (remaining > 2 && mines > 0
								&& okToFill(map, mineRow, remaining - 1, false)) {
							if (map[mineRow][remaining - 1] != '*') {
								map[mineRow][remaining - 1] = '*';
								mines--;
							}
							remaining--;
						}
					}
					mineRow--;

				}

				vertical = !vertical;
			}
		}
		if (mines == 0) {
			// solved
			StringBuilder builder = new StringBuilder();
			for (int i = 0; i < R; i++) {
				for (int j = 0; j < C; j++) {
					builder.append(map[i][j]);
				}
				builder.append(System.getProperty("line.separator"));
			}
			return builder.toString();
		} else {
			return "Impossible";
		}

	}
}
