import java.io.*;

public class LanMower{

	private static int[] toIntArray(String[] tok){
		int[] arr = new int[tok.length];
		for(int i=0; i<tok.length; i++)
			arr[i] = Integer.parseInt(tok[i]);
		return arr;
	}
	
	public static String solve(int[][] lawn){
		int[] rowWiseMax = new int[lawn.length];
		int[] colWiseMax = new int[lawn[0].length];
		for(int i=0; i<rowWiseMax.length; i++){
			int max = lawn[i][0];
			for(int j=0; j<lawn[i].length; j++)
				max = Math.max(max,lawn[i][j]);
			rowWiseMax[i] = max;
		}
		for(int j=0; j<colWiseMax.length; j++){
			int max = lawn[0][j];
			for(int i=0; i<lawn.length; i++)
				max = Math.max(max,lawn[i][j]);
			colWiseMax[j] = max;
		}
		for(int i=0; i<lawn.length; i++){
			for(int j=0; j<lawn[i].length; j++){
				if(lawn[i][j]<rowWiseMax[i] && lawn[i][j]<colWiseMax[j])
					return "NO";
			}
		}
		return "YES";
	}
	
	public static void main(String... s) throws IOException{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int T = Integer.parseInt(br.readLine());
		for(int t=1; t<=T; t++){
			String[] tok = br.readLine().trim().split(" ");
			int N = Integer.parseInt(tok[0]);
			int M = Integer.parseInt(tok[1]);
			int[][] lawn = new int[N][];
			for(int i=0; i<N; i++)
				lawn[i] = toIntArray(br.readLine().trim().split(" "));
			System.out.println("Case #"+t+": "+solve(lawn));
		}
	}
}