import java.io.*;

class TicTacToe{
	private static boolean isRowWin(char[][] board, int i, char ch){
		for(int j=0; j<board[i].length; j++){
			if(board[i][j]!='T' && board[i][j]!=ch){
				return false;
			}
		}
		return true;
	}
	
	private static boolean isColWin(char[][] board, int j, char ch){
		for(int i=0; i<board.length; i++){
			if(board[i][j]!='T' && board[i][j]!=ch){
				return false;
			}
		}
		return true;
	}
				
	private static boolean isDiagWin(char[][] board, char ch){
		boolean ans1 = true;
		for(int i=0; i<board.length; i++){
			if(board[i][i]!='T' && board[i][i]!=ch){
				ans1 = false;
				break;
			}
		}
		boolean ans2 = true;
		for(int i=0; i<board.length; i++){
			if(board[i][3-i]!='T' && board[i][3-i]!=ch){
				ans2 = false;
				break;
			}
		}
		return ans1 || ans2;
	}

	public static String solve(char[][] board){
		boolean boardComp = true;
		for(int i=0; i<board.length; i++){
			for(int j=0; j<board[i].length; j++){
				if(board[i][j] == '.'){
					boardComp = false;
					break;
				}
			}
		}
		//check if any one player has won
		for(int i=0; i<board.length; i++){
			if(isRowWin(board,i,'X') || isColWin(board,i,'X'))				return "X won";
			if(isRowWin(board,i,'O') || isColWin(board,i,'O'))				return "O won";
		}
			//check diagnals
			if(isDiagWin(board,'X'))					return "X won";
			if(isDiagWin(board,'O'))					return "O won";
			
		if(boardComp)		return "Draw";
		else				return "Game has not completed";
	}
	
	public static void main(String... s) throws IOException{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int T = Integer.parseInt(br.readLine());
		for(int t=1; t<=T; t++){
			char[][] board = new char[4][4];
			for(int i=0; i<4; i++){
				board[i] = br.readLine().toCharArray();
			}
			br.readLine();
			System.out.println("Case #"+t+": "+solve(board));
		}
	}
}