package com.javanme.gcj.a;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;
import java.util.List;

public class TicTacToeTomek {

    public static void main(String[] args) {
        String fileName = "A-large";        

        Path pathin = FileSystems.getDefault().getPath("A", fileName + ".in");
        Path pathout = FileSystems.getDefault().getPath("A", fileName + ".out");
        String answerX = "X won";
        String answerO = "O won";
        String answerDraw = "Draw";
        String answerLeft = "Game has not completed";
        byte[][] xs = new byte[4][4];
        byte[][] os = new byte[4][4];

        String answer = "";
        try (PrintWriter pout = new PrintWriter(Files.newOutputStream(pathout, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING, StandardOpenOption.WRITE))) {
            List<String> lines = Files.readAllLines(pathin, Charset.forName("UTF-8"));

            int countFileLines = lines.size();
            StringBuffer strb = null;
            String str = null;
            char letter = ' ';
            byte resultX = 0;
            byte resultO = 0;
            boolean emptyCellsLeft = false;
            int caseNum = 0;
            for (int i = 1; i < countFileLines - 1; i += 5) {
                caseNum++;
                answer = "";
                letter = ' ';
                emptyCellsLeft = false;
                xs = new byte[4][4];
                os = new byte[4][4];
                //read the matrix
                for (int j = 0; j < 4; j++) {
                    str = lines.get(i + j);
                    for (int k = 0; k < str.length(); k++) {
                        letter = str.charAt(k);
                        if (letter == 'X') {
                            xs[j][k] = 1;
                        } else if (letter == 'O') {
                            os[j][k] = 1;
                        } else if (letter == 'T') {
                            xs[j][k] = 1;
                            os[j][k] = 1;
                        } else {
                            emptyCellsLeft = true;
                            continue;
                        }
                    }
                }

                //evaluate each matrix
                resultX = evaluateMatrix(xs);
                if (resultX != 1) {
                    resultO = evaluateMatrix(os);
                }

                if (resultX == 1) {
                    answer = answerX;
                } else if (resultO == 1) {
                    answer = answerO;
                } else if (resultX == resultO && !emptyCellsLeft) {
                    answer = answerDraw;
                } else if (emptyCellsLeft) {
                    answer = answerLeft;
                }

                pout.printf("Case #%d: %s\n", caseNum, answer);
            }

        } catch (IOException ex) {
            ex.printStackTrace();
        }

    }

    private static byte evaluateMatrix(byte[][] matrix) {
        byte result = 1;

        //evaluates rows
        for (int i = 0; i < matrix.length; i++) {
            result = 1;
            for (int j = 0; j < matrix.length && result == 1; j++) {
                result &= matrix[i][j];
            }
            if (result == 1) {
                return result;
            }
        }

        //evaluates cols
        for (int i = 0; i < matrix.length; i++) {
            result = 1;
            for (int j = 0; j < matrix.length && result == 1; j++) {
                result &= matrix[j][i];
            }
            if (result == 1) {
                return result;
            }
        }

        //evaluates diagonal 1
        result = 1;
        for (int i = 0; i < matrix.length; i++) {
            result &= matrix[i][i];
        }

        if (result == 1) {
            return result;
        }

        //evaluates diagonal 2
        result = 1;
        for (int i = matrix.length - 1, j = 0; i >= 0; i--, j++) {
            result &= matrix[i][j];
        }

        return result;
    }
}
