package com.acelopez.gcj.a;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by aalopez on 15/04/16.
 */
public class LastWord {
    public static void main(String args[]) throws IOException {
        String fileName = "A-small-attempt0";
        Path inputPath = Paths.get("A", "input", fileName + ".in");
        Path outputPath = Paths.get("A", "output", fileName + ".out");

        try (PrintWriter out = new PrintWriter(Files.newOutputStream(outputPath, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING, StandardOpenOption.WRITE))) {

            List<String> lines = Files.readAllLines(inputPath, Charset.forName("UTF-8"));

            //how many tests
            int tests = Integer.valueOf(lines.get(0));
            //iterate over tests
            for (int i = 1; i <= tests; i++) {

                char[] word = lines.get(i)
                                   .toCharArray();
                StringBuilder last = new StringBuilder();

                for (char c : word) {
                    if (last.length() > 0 && last.charAt(0) <= c) {
                        last.insert(0, c);
                    } else {
                        last.append(c);
                    }
                }

                out.printf("Case #%d: %s\n", i, last.toString());
            }
        }
    }
}
