package com.acelopez.codejam;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.*;
import java.util.stream.Collectors;

/**
 * Created by aalopez on 8/04/16.
 */
public class Pancakes {
    public static void main(String args[]) throws IOException {
        String fileName = "B-small-attempt0";
        Path inputPath = Paths.get("B", "input", fileName + ".in");
        Path outputPath = Paths.get("B", "output", fileName + ".out");

        try (PrintWriter out = new PrintWriter(Files.newOutputStream(outputPath, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING, StandardOpenOption.WRITE))) {

            List<String> lines = Files.readAllLines(inputPath, Charset.forName("UTF-8"));

            //how many tests
            int tests = Integer.valueOf(lines.get(0));
            //iterate over tests
            for (int i = 1; i <= tests; i++) {
                List<Integer> pancakes = lines.get(i)
                                              .chars()
                                              .map(x -> x == '-' ? 0 : 1)
                                              .boxed()
                                              .collect(Collectors.toList());
                int actual = -1;
                int flips = 0;
                int j = 0;
                do {
                    j = 0;
                    actual = pancakes.get(j);
                    //find the index where we need to flip
                    while (j < pancakes.size() && actual == pancakes.get(j)) {
                        actual = pancakes.get(j++);
                    }

                    //everything is done
                    if (j == pancakes.size() && actual == 1) {
                        break;
                    }

                    //not finished, so flip the pancakes
                    flipList(j, pancakes);
                    flips++;

                } while (true);

                out.printf("Case #%d: %d\n", i, flips);
            }
        }
    }

    //flip the list from 0 to index
    private static void flipList(int index, List<Integer> list) {
        for (int i = 0, j = index - 1; i <= j; i++, j--) {
            Integer aux = list.get(j);
            list.set(j, (list.get(i) + 1) % 2);
            list.set(i, (aux + 1) % 2);
        }
    }
}
