package com.acelopez.codejam;

import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * Created by aalopez on 8/04/16.
 */
public class Sheep {
    public static void main(String args[]) throws IOException {
        Path inputPath = Paths.get("A", "input", "A-large.in");
        Path outputPath = Paths.get("A", "output", "A-large.out");

        try (PrintWriter out = new PrintWriter(Files.newOutputStream(outputPath, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING, StandardOpenOption.WRITE))) {

            List<String> lines = Files.readAllLines(inputPath, Charset.forName("UTF-8"));

            //how many tests
            int tests = Integer.valueOf(lines.get(0));
            //iterate over tests
            for (int i = 1; i <= tests; i++) {
                long currentNumber = Long.valueOf(lines.get(i));
                Set<Integer> numbers = new HashSet<>();
                long result = -1;

                for (int j = 1; j < 100; j++) {
                    result = currentNumber * j;

                    numbers.addAll(getDigits(result));

                    if (result == 0) {
                        break;
                    }
                    if (numbers.size() == 10) {
                        break;
                    }
                }

                if (result == 0) {
                    out.printf("Case #%d: INSOMNIA\n", i);
                } else {
                    out.printf("Case #%d: %d\n", i, result);
                }

            }
        }
    }

    private static Set<Integer> getDigits(long param) {
        Set<Integer> digits = new HashSet<>();
        while (param > 0) {
            digits.add((int) (param % 10));
            param /= 10;
        }
        return digits;
    }
}
