import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.IntStream;

public class StandingOvation {
    public static void main(String... args) {
        String fileName = "A-small-attempt3";

        Path pathin = FileSystems.getDefault()
                                 .getPath("A", fileName + ".in");
        Path pathout = FileSystems.getDefault()
                                  .getPath("A", fileName + ".out");


        List<String> lines = null;
        List<Object> response = null;

        try {
            lines = getAllLines(pathin);
        }
        catch (IOException e) {
            e.printStackTrace();
            return;
        }

        try {
            response = processTestCases(lines);
        }
        catch (Exception e) {
            e.printStackTrace();
            return;
        }

        writeResponse(pathout, response);
    }

    private static List<Object> processTestCases(List<String> lines) {

        List<Object> response = null;
        int numCases = Integer.parseInt(lines.get(0));
        response = new ArrayList<>(numCases + 10);
        String[] aux = null;
        int maxShyness = -1;
        int count = 0;
        int numInvited = 0;
        int sj = 0;
        for (int i = 1; i <= numCases; i++) {
            count = 0;
            aux = lines.get(i)
                       .split(" ");
            maxShyness = Integer.parseInt(aux[0]);
            numInvited = 0;
            for (int j = 0; j <= maxShyness; j++) {
                sj = Integer.parseInt(""+aux[1].charAt(j));
                if(sj != 0)
                {
                    if(count + numInvited < j)
                    {
                        numInvited = j - count;
                    }
                }
                count += sj;

                if(count  + numInvited > maxShyness)
                {
                    break;
                }
            }

            response.add(numInvited);
        }

        return response;
    }

    private static List<String> getAllLines(Path file) throws IOException {
        return Files.readAllLines(file, Charset.forName("UTF-8"));
    }

    private static void writeResponse(Path fileOut, List<Object> response) {
        try (PrintWriter pout = new PrintWriter(Files.newOutputStream(fileOut, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING, StandardOpenOption.WRITE))) {
            IntStream.range(0, response.size())
                     .forEach(idx -> pout.printf("Case #%d: %s\n", (idx + 1), response.get(idx)));
        }
        catch (IOException ex) {
            ex.printStackTrace();
        }
    }
}
