import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Scanner;

public class P1 {

	private static final String INPUT_FILE_PATH = "p1/A-small-attempt0.in";
	private static final String OUTPUT_FILE_PATH = "p1/test.out";

	public static void main(String[] args) throws IOException {

		// Reading the input file
		Scanner in = new Scanner(new BufferedReader(new FileReader(INPUT_FILE_PATH)));

		// Writing the output
		BufferedWriter br = new BufferedWriter(new FileWriter(OUTPUT_FILE_PATH, false));

		LinkedHashMap<Integer, List<Character>> sen = new LinkedHashMap<Integer, List<Character>>();

		String letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		char[] chars = letters.toCharArray();
		System.out.println(letters.length());

		int testCases = Integer.parseInt(in.nextLine());

		for (int i = 1; i <= testCases; i++) {
			br.write("Case #" + i + ": ");
			int noOfParties = in.nextInt();

			// fill it
			for (int p = 1; p <= noOfParties; p++) {

				// read party mems
				int noOfMems = in.nextInt();

				List<Character> mem = new ArrayList<Character>();
				for (int m = 1; m <= noOfMems; m++) {
					mem.add(chars[p - 1]);
				}
				sen.put(p, mem);
			}

			while (!sen.isEmpty()) {
				String stepOut = getStepOut(sen);
				br.write(stepOut + " ");
			}

			br.newLine();

		}

		in.close();
		br.flush();
		br.close();
	}

	/**
	 * 
	 * @param sen
	 * @return
	 */
	private static String getStepOut(LinkedHashMap<Integer, List<Character>> sen) {

		int max1p = 0, max2p = 0;
		Character c1 = null , c2 = null;

		
		
		
		do {
			max1p = ((int) (Math.random() * sen.size()) + 1);
			max2p = ((int) (Math.random() * sen.size()) + 1);
			
			int index = 1;
			for(int r : sen.keySet()){
				if(max1p == index){
					max1p = r;
					break;
				}
				index++;
			}
			
			index = 1;
			for(int r : sen.keySet()){
				if(max2p == index){
					max2p = r;
					break;
				}
				index++;
			}

			List<Character> mems1 = sen.get(max1p);
			c1 = mems1.remove(0);
			sen.put(max1p, mems1);

			List<Character> mems2 = sen.get(max2p);
			c2 = null;
			if (mems2.size() > 0) {
				c2 = mems2.remove(0);
				sen.put(max2p, mems2);
			}
			
			if(!isOk(sen)){
				mems1.add(c1);
				sen.put(max1p, mems1);
				if (c2 != null) {
					mems2.add(c2);
					sen.put(max2p, mems2);
				}
			}else{
				
				if(mems1.size() == 0){
					sen.remove(max1p);
				}
				
				if(max1p != max2p){
					if(mems2.size() == 0){
						sen.remove(max2p);
					}
				}
				break;
			}	
		} while (true);
		
		String out = "" + c1 ;
		if(c2 != null){
			out += "" + c2;
		}
		
		return out;
	}

	private static boolean isOk(LinkedHashMap<Integer, List<Character>> sen) {

		int total = 0;
		for (int p : sen.keySet()) {
			total += sen.get(p).size();
		}

		for (int p : sen.keySet()) {
			List<Character> mem = sen.get(p);
			if (mem.size() > (total / 2)) {
				return false;
			}
		}

		return true;
	}

}
