import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class P3JamcoinSmall {

	public static void main(String[] args) throws IOException {
		 
	    BufferedWriter br = new BufferedWriter( new FileWriter("p3/p3.out"));
	    Scanner in = new Scanner(new BufferedReader(new FileReader("p3/C-small-attempt5.in")));
	    int testCases = in.nextInt(); 
	     
	    for(int i=1; i <= testCases; i++){
	    	int N = in.nextInt(); 
		    int J = in.nextInt();
		    
		    String jamCoinCandidate = "1";
		    for(int j=1; j<= N-1; j++){
		    	jamCoinCandidate +="0";
		    }
		     
		    int foundJamcoins = 0;
		    br.write("Case #" + i +":");
		    br.newLine();
		    
		    do{
		    	// get jamCoinCandidate
			    jamCoinCandidate = Long.toBinaryString(Long.parseLong(jamCoinCandidate, 2) + 1);
			    System.out.println("jamCoinCandidate = " + jamCoinCandidate);
			    boolean isJamcoin = checkIsJamCoinOfN(jamCoinCandidate , N);
			    
			    if(!isJamcoin){
			    	System.out.println("not-jamcoin");
			    	continue;
			    }
			    
			    System.out.println("is-jamcoin");
			    foundJamcoins++;
			    br.write(jamCoinCandidate );
			    
			    List<Long> divisors = getJamCoinDivisors(jamCoinCandidate);
			    
			    for(long  divisor: divisors){
			    	br.write(" " + divisor );
			    }
			    
			    br.newLine();
			        
		    }while(foundJamcoins < J);
	    }
	    
	    in.close();
	    br.flush();
	    br.close();
	}


	private static boolean checkIsJamCoinOfN(String jamCoinCandidate, int N) {
		
		System.out.println("checkIsJamCoinOfN");
		
		
		if(jamCoinCandidate.length() != N ||  '0' == jamCoinCandidate.charAt(0) || '0' == jamCoinCandidate.charAt(N-1)){
	    	return false;
		}
		
		for(int base=2 ; base <= 10; base++){
			
			long baseNumber = getBaseNumber(jamCoinCandidate , base);
			
			boolean isPrime = checkIsPrime(baseNumber);
			
			if(isPrime){
				// not jamCoin
				return false;
			}
		}
		
		// made it, jamcoin
		return true;
	}
	
	private static long getBaseNumber(String jamCoinCandidate, int base) {
		
		long baseNumner = 0;
		int x = 0;
		for(int i=jamCoinCandidate.length()-1 ; i >= 0 ; i--){
			int digit = Integer.parseInt(jamCoinCandidate.charAt(i) + "");
			baseNumner = baseNumner +  (digit * ((long)(Math.pow(base, x))));
			x++;
		}
		
		return baseNumner;
	}


	private static boolean checkIsPrime(long baseNumber) {
		System.out.println("checkIsPrime " + baseNumber);
		long  sq = (long) (Math.sqrt(baseNumber) + 1);
		for(long i=2; i< sq ; i++){
			if(baseNumber % i == 0){
				return false;
			}
		}
		
		// is prime
		return true;
	}


	private static List<Long> getJamCoinDivisors(String jamCoin) {
		System.out.println("getJamCoinDivisors");
		
		List<Long> divisors = new ArrayList<Long>();
				
		for(int base=2 ; base <= 10; base++){
			long baseNumber = getBaseNumber(jamCoin , base);
			divisors.add(getFirstNontrivialDivisor(baseNumber));
		}
	
		
		return divisors;
	}


	private static long getFirstNontrivialDivisor(long jamCoinAsBaseNumber) {
		for(long i=2 ; i < jamCoinAsBaseNumber ; i++ ){
			if(jamCoinAsBaseNumber % i == 0){
				return i;
			}
		}
		
		// shouldn't be accessed 
		return -1;
	}

}
