import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by Alexandru on 08.04.2017.
 */
public class Problem3 {

    public static void main(String[] args) throws FileNotFoundException {

        File initialFile = new File("C-small-1-attempt0.in");
        InputStream targetStream = new FileInputStream(initialFile);

        Scanner scanner = new Scanner(targetStream);

        PrintWriter outFile = new PrintWriter("solution3.txt");
        //PrintStream outFile = System.out;

        int t = Integer.parseInt(scanner.nextLine());

        for(int i = 0; i < t; i++){
            Integer n = scanner.nextInt();
            Integer k = scanner.nextInt();

            InspectionResult result = result(n, k);

            int min = min(result.ls, result.rs);
            int max = max(result.ls, result.rs);

            outFile.println("Case #" + (i+1) + ": " + max + " " + min);
        }

        outFile.close();
    }

    private static class InspectionResult{
        int ls;
        int rs;
        int index;
    }

    private static InspectionResult result(int n, int k){
       boolean[] stalls = new boolean[n + 2];
       stalls[0] = true;
       stalls[n + 1] = true;

       InspectionResult result = null; // will be calculated by last person

       for(int i = 0 ; i < k; i++){    //for each person

           InspectionResult chosenStall = null;

           for(int j = 1; j <=n; j++){ //for each stall

               if(stalls[j]){ // if the stall is taken just move to the next
                   continue;
               }

               //verify the free number to the left
               int leftCounter = 0;
               for(int l = j - 1; l >= 1; l--){
                   if(! stalls[l]){
                       leftCounter++;
                   } else {
                       break;
                   }
               }

               //verify the free number to the right
               int rightCounter = 0;
               for(int r = j + 1; r <=n; r++){
                   if(! stalls[r]){
                       rightCounter++;
                   } else {
                       break;
                   }
               }

               InspectionResult newStall = new InspectionResult();

               newStall.ls = leftCounter;
               newStall.rs = rightCounter;
               newStall.index = j;



               if(chosenStall == null){
                   chosenStall = newStall;
               } else {
                   int compareResult = compareStalls(chosenStall, newStall);

                   if(compareResult > 0 ) { //if this stall is better...
                       chosenStall = newStall;
                   }

               }
           }

           stalls[chosenStall.index] = true;
           result = chosenStall;
           // mark the stall as taken

       }

       return result;

    }

    private static int compareStalls(InspectionResult oldStall, InspectionResult newStall){
        int minOld = min(oldStall.ls, oldStall.rs);
        int minNew = min(newStall.ls, newStall.rs);

        if(minOld == minNew){
            int maxOld = max(oldStall.ls, oldStall.rs);
            int maxNew = max(newStall.ls, newStall.rs);

            if(maxOld == maxNew){
                return 0;
            } else if(maxOld > maxNew){
                return -1;
            } else {
                return 1;
            }

        } else if(minOld > minNew){
            return -1;
        } else {
            return 1;
        }
    }

    private static int min(int a, int b){
        if(a < b){
            return a;
        } else {
            return b;
        }
    }

    private static int max(int a, int b){
        if(a > b){
            return a;
        } else {
            return b;
        }
    }



}
