package round1;

import java.io.*;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class Problem2 {

    public static void main(String[] args) throws FileNotFoundException {

        File initialFile = new File("B-small-attempt2.in");
        InputStream targetStream = new FileInputStream(initialFile);

        Scanner scanner = new Scanner(targetStream);

        PrintWriter outFile = new PrintWriter("solution2.txt");
        //PrintStream outFile = System.out;

        int t = Integer.parseInt(scanner.nextLine());

        for (int i = 0; i < t; i++) {
            int n = scanner.nextInt();

            int r = scanner.nextInt();
            int o = scanner.nextInt();
            int y = scanner.nextInt();
            int g = scanner.nextInt();
            int b = scanner.nextInt();
            int v = scanner.nextInt();

            List<Color> colors = isPossible(r, y, b);

            if (colors.isEmpty()) {
                outFile.println("Case #" + (i + 1) + ": " + "IMPOSSIBLE");
            } else {
                outFile.print("Case #" + (i + 1) + ": ");

                colors.forEach(outFile::print);
                outFile.println();
            }


        }

        outFile.close();
    }

    private static enum Color {
        RED,
        BLUE,
        YELLOW;

        public String toString() {
            switch (this) {
                case RED:
                    return "R";
                case BLUE:
                    return "B";
                case YELLOW:
                    return "Y";
                default:
                    return "x";
            }

        }
    }

    private static Color getMin(int r, int y, int b) {
        if (r <= y && r <= b) {
            return Color.RED;
        } else if (y <= r && y <= b) {
            return Color.BLUE;
        } else {
            return Color.YELLOW;
        }
    }

    private static int  getMinInt(int r, int y, int b) {
        if (r <= y && r <= b) {
            return r;
        } else if (y <= r && y <= b) {
            return b;
        } else {
            return y;
        }
    }

    private static int getMax(int a, int b, int c) {
        if (a >= b && a >= c) {
            return a;
        } else if (b >= a && b >= c) {
            return b;
        } else {
            return c;
        }
    }

    private static int getMiddle(int a, int b, int c){
        int min1;
        int max1;

        if(a > b){
            min1 = b;
            max1 = a;
        } else {
            min1 = a;
            max1 = b;
        }

        if(c > max1){
           return max1;
        } else {
            if (c > min1){
                return c;
            } else {
                return min1;
            }
        }
    }

    private static List<Color> isPossible(int r, int y, int b) {
        //find the smallest color
        LinkedList<Color> list = new LinkedList<>();

        int min = getMinInt(r, y, b);

        Color minColor = getMin(r, y, b);

        Color maxColor;
        Color middleColor;

        if (minColor == Color.YELLOW) {
            if (r > b) {
                middleColor = Color.BLUE;
                maxColor = Color.RED;
            } else {
                middleColor = Color.RED;
                maxColor = Color.BLUE;
            }
        } else if (minColor == Color.RED) {
            if (b > y) {
                middleColor = Color.YELLOW;
                maxColor = Color.BLUE;
            } else {
                middleColor = Color.BLUE;
                maxColor = Color.YELLOW;
            }
        } else {
            if (r > y) {
                middleColor = Color.YELLOW;
                maxColor = Color.RED;
            } else {
                middleColor = Color.RED;
                maxColor = Color.YELLOW;
            }
        }

        for (int i = 0; i < min; i++) {
            list.push(minColor);
            list.push(maxColor);
            list.push(middleColor);
        }

        r = r - min;
        b = b - min;
        y = y - min;

        int max = getMax(r, b, y);
        int middle = getMiddle(r, b ,y);

        int rem = max - middle;


        if (rem >= 2) {
            return Collections.emptyList();
        } else if (rem == 1){
           list.push(maxColor);

            for (int i = 0; i < max - rem; i++) {
                list.push(middleColor);
                list.push(maxColor);
            }
        }  else {
            for (int i = 0; i < max - rem; i++) {
                list.push(maxColor);
                list.push(middleColor);
            }
        }

        return list;
    }

}
