import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Created by Alexandru on 08.04.2017.
 */
public class Problem2 {

    public static void main(String[] args) throws FileNotFoundException {

        File initialFile = new File("B-large.in");
        InputStream targetStream = new FileInputStream(initialFile);

        Scanner scanner = new Scanner(targetStream);

        PrintWriter outFile = new PrintWriter("solution2.txt");

        int t = Integer.parseInt(scanner.nextLine());

        for(int i = 0; i < t; i++){
            String line = scanner.nextLine();

            String tidyNumber = result(line);

            outFile.println("Case #" + (i+1) + ": " + tidyNumber);
        }

        outFile.close();
    }


    private static String result(String num){
        int validIndex = isValid(num);

        if(validIndex == -1){
            return num;
        }

        validIndex = adjustValidIndex(num, validIndex);

        String first = num.substring(0, validIndex);

        String rest = num.substring(validIndex);
        String toSub = replace(rest);

        Long second = Long.parseLong(toSub) - 1;


        return first + second;

    }

    private static int adjustValidIndex(String num, int validIndex){
        int validNew = validIndex;

        for(int i = validIndex - 1; i >= 0; i--){
            if(num.charAt(i) == num.charAt(validIndex)){
                validNew--;
            } else {
                break;
            }
        }

        return validNew;
    }

    private static String replace(String original){
        StringBuilder b = new StringBuilder();

        b.append(original.charAt(0));

        for(int i = 1; i < original.length(); i++){
            b.append(0);
        }

        return b.toString();
    }

    public static int isValid(String s){
        int lastCharInt = Integer.parseInt(String.valueOf(s.charAt(0)));
        for(int i = 1; i < s.length(); i++){

            int currentCharInt = Integer.parseInt(String.valueOf(s.charAt(i)));
            if(lastCharInt > currentCharInt){
                return i - 1;
            }

            lastCharInt = currentCharInt;
        }
        return -1;
    }

}
