import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.StringTokenizer;
import java.util.*;

public class FairWarning implements Runnable {
	private void solve(int cas) throws IOException {
		int n = nextInt();
		BigInteger[] nums = new BigInteger[n];
		for (int i = 0; i < n; ++i)
			nums[i] = new BigInteger(nextToken());
		Arrays.sort(nums);
		BigInteger gcd = BigInteger.ZERO;
		for (int i = 0; i < n; ++i)
			for (int j = i + 1; j < n; ++j)
				gcd = gcd.gcd(nums[j].subtract(nums[i]));
		BigInteger res = gcd.subtract(nums[0].mod(gcd));
		if (gcd.compareTo(res) == 0)
			res = BigInteger.ZERO;
		writer.println("Case #" + cas + ": " + res);
	}
	
	private int gcd(int a, int b) {
		while (a > 0 && b > 0)
			if (a > b) a %= b; else b %= a;
		return a + b;
	}
	
	private void solve2(int cas) throws IOException {
		int n = nextInt();
		int[] nums = new int[n];
		for (int i = 0; i < n; ++i)
			nums[i] = nextInt();
		int res = -1;
		int by = -1;
		for (int y = 0; y < 100000005; ++y) {
			int g = 0;
			for (int i = 0; i < n; ++i)
				g = gcd(g, nums[i]);
			if (g > res) {
				res = g;
				by = y;
			}
			for (int i = 0; i < n; ++i)
				++nums[i];
		}
		System.out.println("Case #" + cas + ": " + by);
	}
	
	public static void main(String[] args) throws InterruptedException {
		Thread thread = new Thread(new FairWarning());
		thread.start();
		thread.join();
	}
	
	static final String TASK_ID = "B-large";
	static final String IN_FILE = TASK_ID + ".in";
	static final String OUT_FILE = TASK_ID + ".out";
	BufferedReader reader;
	StringTokenizer tokenizer;
	PrintWriter writer;
	
	public void run() {
		try {
			reader = new BufferedReader(new FileReader(IN_FILE));
			tokenizer = null;
			writer = new PrintWriter(OUT_FILE);
			int cases = nextInt();
			for (int cas = 0; cas < cases; ++cas) {
				solve(cas + 1);
			}
			reader.close();
			writer.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}
}