/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package traintimetable;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.util.Vector;

/**
 *
 * @author yyc
 */
public class Main {

    private static BufferedReader bReader = null;
    private static PrintStream ps = null;
    private static int testCases = 0;
    private static Vector trains = null;
    private static int size_ATrains;
    private static int size_BTrains;
    public static final boolean STATION_A = false;
    public static final boolean STATION_B = true;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        try {
            bReader = new BufferedReader(new FileReader("input.in"));
            ps = new PrintStream("output.in");
            testCases = Integer.parseInt(bReader.readLine());

            for (int i = 1; i <= testCases; i++) {
                trains = new Vector();
                size_ATrains = 0;
                size_BTrains = 0;
                runTestCase(i);
            }
        } catch (IOException ex) {
        } catch (NumberFormatException ex) {
        } finally {
            if (bReader != null) {
                try {
                    bReader.close();
                } catch (IOException ex) {
                }
                bReader = null;
            }
            if (ps != null) {
                ps.close();
            }
        }
    }

    public static void runTestCase(int testCase)
            throws IOException, NumberFormatException {
        ps.printf("Case #%d: ", testCase);
        int turnaroundTime = Integer.parseInt(bReader.readLine());
        StringTokenizer st = new StringTokenizer(bReader.readLine(), " ");
        int na = Integer.parseInt(st.nextToken());
        int nb = Integer.parseInt(st.nextToken());
        Trip[] trips = new Trip[na + nb];

        Trip trip;
        for (int i = 0; i < na; i++) {
            st = new StringTokenizer(bReader.readLine(), " :");
            trip = new Trip(STATION_A, STATION_B,
                    Integer.parseInt(st.nextToken()),
                    Integer.parseInt(st.nextToken()),
                    Integer.parseInt(st.nextToken()),
                    Integer.parseInt(st.nextToken()));
            trips[i] = trip;
        }
        for (int i = na; i < na + nb; i++) {
            st = new StringTokenizer(bReader.readLine(), " :");
            trip = new Trip(STATION_B, STATION_A,
                    Integer.parseInt(st.nextToken()),
                    Integer.parseInt(st.nextToken()),
                    Integer.parseInt(st.nextToken()),
                    Integer.parseInt(st.nextToken()));
            trips[i] = trip;
        }
        Arrays.sort(trips);

        for (int i = 0; i < trips.length; i++) {
            boolean complete = false;
            trip = trips[i];
            //ps.printf("%s\n", trip.toString());
            if (trains.size() > 0) {
                Train[] sortedTrains = new Train[trains.size()];
                trains.toArray(sortedTrains);
                Arrays.sort(sortedTrains);
                for (int j = 0; j < sortedTrains.length; j++) {
                    //boolean removeOldTrains = false;
                    Train train = sortedTrains[j];
                    //ps.printf("%s", train.toString());
                    if (trip.sourceStation == train.station) {
                        if (!complete && train.readyForTrip(trip)) {
                            train.setNextStop(trip.targetStation, trip.arrivalTimeHour,
                                    trip.arrivalTimeMinute, turnaroundTime);
                            complete = true;
                            //removeOldTrains = true;
                            //ps.printf("-Y");
                        }
                        //if (removeOldTrains) {
                        //    trains.remove(train);
                        //}
                    }
                    //ps.printf("\n");
                }
            }
            if (!complete) {
                Train train;
                if (trip.sourceStation == STATION_A) {
                    size_ATrains++;
                } else { //STATION_B
                    size_BTrains++;
                }
                train = new Train(trip.targetStation, trip.arrivalTimeHour,
                        trip.arrivalTimeMinute, turnaroundTime);
                trains.add(train);
            }
            //ps.printf("%d %d\n", size_ATrains, size_BTrains);
        }

        ps.printf("%d %d", size_ATrains, size_BTrains);
        ps.printf("\n");
    }
}

class Trip implements Comparable {

    public boolean sourceStation;
    public boolean targetStation;
    public int departureTimeHour;
    public int departureTimeMinute;
    public int arrivalTimeHour;
    public int arrivalTimeMinute;

    public Trip(boolean sourceStation, boolean targetStation,
            int departureTimeHour, int departureTimeMinute,
            int arrivalTimeHour, int arrivalTimeMinute) {
        this.sourceStation = sourceStation;
        this.targetStation = targetStation;
        this.departureTimeHour = departureTimeHour;
        this.departureTimeMinute = departureTimeMinute;
        this.arrivalTimeHour = arrivalTimeHour;
        this.arrivalTimeMinute = arrivalTimeMinute;
    }

    public int compareTo(Object obj) {
        Trip trip = (Trip) obj;
        if (departureTimeHour < trip.departureTimeHour) {
            return -1;
        } else if (departureTimeHour > trip.departureTimeHour) {
            return 1;
        }
        if (departureTimeMinute < trip.departureTimeMinute) {
            return -1;
        } else if (departureTimeMinute > trip.departureTimeMinute) {
            return 1;
        }
        return 0;
    }

    @Override
    public String toString() {
        String sourceStr = sourceStation ? "B" : "A";
        String targetStr = targetStation ? "B" : "A";
        return departureTimeHour + ":" + departureTimeMinute +
                " " + arrivalTimeHour + ":" + arrivalTimeMinute +
                "[" + sourceStr + "-" + targetStr + "]";
    }
}

class Train implements Comparable {

    public boolean station;
    private int readyTimeHour;
    private int readyTimeMinute;

    public Train(boolean station, int arrivalTimeHour, int arrivalTimeMinute,
            int turnaroundTime) {
        this.station = station;
        readyTimeHour = arrivalTimeHour;
        readyTimeMinute = arrivalTimeMinute;
        readyTimeMinute += turnaroundTime;
        if (readyTimeMinute >= 60) {
            readyTimeMinute -= 60;
            readyTimeHour += 1;
        }
    }

    public void setNextStop(boolean station, int arrivalTimeHour,
            int arrivalTimeMinute, int turnaroundTime) {
        this.station = station;
        readyTimeHour = arrivalTimeHour;
        readyTimeMinute = arrivalTimeMinute;
        readyTimeMinute += turnaroundTime;
        if (readyTimeMinute >= 60) {
            readyTimeMinute -= 60;
            readyTimeHour += 1;
        }
    }

    public boolean readyForTrip(Trip trip) {
        if (readyTimeHour < trip.departureTimeHour) {
            return true;
        } else if (readyTimeHour == trip.departureTimeHour) {
            if (readyTimeMinute <= trip.departureTimeMinute) {
                return true;
            }
        }
        return false;
    }

    public int compareTo(Object obj) {
        Train train = (Train) obj;
        if (readyTimeHour < train.readyTimeHour) {
            return 1;
        } else if (readyTimeHour > train.readyTimeHour) {
            return -1;
        }
        if (readyTimeMinute < train.readyTimeMinute) {
            return 1;
        } else if (readyTimeMinute > train.readyTimeMinute) {
            return -1;
        }
        return 0;
    }

    @Override
    public String toString() {
        String str = station ? "B" : "A";
        return str + "-" + readyTimeHour + ":" + readyTimeMinute;
    }
}
