
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class Main {
	private BufferedReader br;
	private int numberOfCases;
	private String inputFileName = "C-small-attempt0.in";
	//private String outputFileName = "result.txt";

	public Main(){
		try {
			readInput();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Read from input file and save to a structure.
	 * @throw IOExecption
	 * */
	private void readInput() throws IOException{
			br = new BufferedReader(new FileReader(inputFileName));

		    try {
		        StringBuilder sb = new StringBuilder();
		        String line = br.readLine();
		        setCase(Integer.parseInt(line));
		        int outputIndex = 1;
		        while (line != null) {
		            sb.append(line);
		            sb.append("\n");
		            line = br.readLine();
	            	/**
	            	 * solving the square and palindromes problem
	            	 */
		            if(line != null)
		            	splitLineBySpace(line, outputIndex);
		            outputIndex++;
		        }
		        //String everything = sb.toString();
		    } finally {
		        br.close();
		    }
	}
		
	private void splitLineBySpace(String theLine, int index){	
		String[] input = theLine.split("\\s+");
		//determine square and palindromes
		int currentRowResult = sovlingProblem(input);
		System.out.println("Case #"+index+": "+ currentRowResult);
	}
	
	int sovlingProblem(String[] input){
		int start = Integer.parseInt(input[0]);
		int end = Integer.parseInt(input[1]);
		int rowCount = 0;
		for(int i = start; i<= end; i++){
			if(isPalin(i)){
				if(isSquare(i)){
					if(isSquarePalin(i)){
						++rowCount;
					}
				}
			}
		}
		return rowCount;
	}
	
	boolean isPalin(int input){
		if(input < 0){
			return false;
		}
		String original = Integer.toString(input);
		String reverse = "";
		int length = original.length();
		for ( int i = length - 1 ; i >= 0 ; i-- )
			reverse = reverse + original.charAt(i);
		if (original.equals(reverse))
			return true;
		else
			return false;
	}
	
	boolean isSquare(int input){
		int temp = (int) Math.sqrt(input);
		return temp*temp == input;
	}
	
	boolean isSquarePalin(int input){
		int temp = (int) Math.sqrt(input);
		return isPalin(temp); 
	}
	
	/***********************************************
	 * 				Helper Functions			   *
	 ***********************************************
	 ***********************************************/


	
	private void setCase(int number){
		this.numberOfCases = number;
	}
	
	public int getCase(){
		return this.numberOfCases;
	}
		
	/**
	 * start of the program
	 */
	public static void main(String[] args) {
		new Main();
	}

}
