
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class QuestionB1 {
	private BufferedReader br;
	private int numberOfCases;
	private String inputFileName = "B-small-attempt0.in";

	public QuestionB1(){
		try {
			readInput();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Read from input file and save to a structure.
	 * @throw IOExecption
	 * */
	private void readInput() throws IOException{
			br = new BufferedReader(new FileReader(inputFileName));

		    try {
		        String line = br.readLine();
		        setCase(Integer.parseInt(line));
		        int outputIndex = 1;
		        while (line != null) {
		            String lineSize = br.readLine();
		            if(lineSize != null){
		            	/**
		            	 * solving the lawnmover problem for A1 and A2
		            	 */
			            int[][] theLawn = setLawn(lineSize);
			            for(int i = 0; i< theLawn.length; i++){
			            	String eachLine = br.readLine();
			            	saveLawnLine(theLawn[i], eachLine);
			            }
			            
			            solveLawn(theLawn, outputIndex); //print the solution to console
		            }
		            outputIndex++;
		        }
		    } finally {
		        br.close();
		    }
	}
	
	int[][] setLawn(String input){
		String[] temp = input.split("\\s+");
		int[][] result = new int[Integer.parseInt(temp[0])][Integer.parseInt(temp[1])];
		return result;
	}
	
	void saveLawnLine(int[] theLawn, String input){
		String[] temp = input.split("\\s+");
		for(int index = 0; index < theLawn.length; index++){
			theLawn[index] = Integer.parseInt(temp[index]);
		}
	}
	
	void solveLawn(int[][] theLawn, int caseNumber){
		boolean currentResult = true;
		if(theLawn.length <= 2 || theLawn[0].length <= 2){
			currentResult = true;
		}
		else{
			for(int i = 0; i<theLawn.length; i++){
				for(int j = 0; j<theLawn[i].length; j++){
					if(!checkHV(theLawn[i][j],i,j,theLawn)){
						currentResult = false;
					}
				}
			}
		}
		if(currentResult){
			System.out.println("Case #"+caseNumber+": Yes");
		} else{
			System.out.println("Case #"+caseNumber+": No");
		}
		
	}
	
	boolean checkHV(int currentLawn, int currentX, int currentY, int[][] theLawn){
		int result = 0; 
		for(int xS = 0; xS <= currentX; xS++){
			if(theLawn[xS][currentY] > currentLawn){
				++result;
				break; //stop
			}
		}
		for(int xB = currentX; xB < theLawn.length; xB++){
			if(theLawn[xB][currentY] > currentLawn){
				++result;
				break; //stop
			}
		}
		for(int yS = 0; yS <= currentY; yS++){
			if(theLawn[currentX][yS] > currentLawn){
				++result;
				break; //stop
			}
		}
		for(int yB = currentY; yB < theLawn[currentX].length; yB++){
			if(theLawn[currentX][yB] > currentLawn){
				++result;
				break; //stop
			}
		}
		if(result == 4){
			return false;
		} else{
			return true;
		}	
	}
	
	/***********************************************
	 * 				Helper Functions			   *
	 ***********************************************
	 ***********************************************/
	private void setCase(int number){
		this.numberOfCases = number;
	}
	
	public int getCase(){
		return this.numberOfCases;
	}
		
	/**
	 * start of the program
	 */
	public static void main(String[] args) {
		new QuestionB1();
	}
}
