
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class QuestionA1 {
	private BufferedReader br;
	private int numberOfCases;
	//private String inputFileName = "C-small-attempt0.in";
	private String inputFileName = "A-small-attempt0.in";
	//private String outputFileName = "result.txt";

	public QuestionA1(){
		try {
			readInput();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	/**
	 * Read from input file and save to a structure.
	 * @throw IOExecption
	 * */
	private void readInput() throws IOException{
			br = new BufferedReader(new FileReader(inputFileName));

		    try {
		        StringBuilder sb = new StringBuilder();
		        String line = br.readLine();
		        setCase(Integer.parseInt(line));
		        int outputIndex = 1;
		        while (line != null) {
		            sb.append(line);
		            sb.append("\n");
		            boolean tempHasDot = false;
		            String box[][] = new String[4][4];
		            String line1 = br.readLine();
		            String line2 = br.readLine();
		            String line3 = br.readLine();
		            String line4 = br.readLine();
		            tempHasDot = setBox(box,line1,line2,line3,line4,tempHasDot);
	            	/**
	            	 * solving the tic-toe problem
	            	 */
		            if(line != null)
		            	solveBox(box, outputIndex, tempHasDot);
		            if(outputIndex == getCase())
		            	break;
		            br.readLine();
		            outputIndex++;
		        }
		    } finally {
		        br.close();
		    }
	}
	
	boolean setBox(String[][] save, String a, String b, String c, String d, boolean hasDot){
		for(int j = 0; j<4; j++){
			for(int i =0; i<4; i++){
				if (j == 0){
					save[i][j] = String.valueOf(a.charAt(i));
					if(save[i][j].equals(".")){
						hasDot = true;
					}
				}
				if (j == 1){
					save[i][j] = String.valueOf(b.charAt(i));
					if(save[i][j].equals(".")){
						hasDot = true;
					}
				}
				if (j == 2){
					save[i][j] = String.valueOf(c.charAt(i));
					if(save[i][j].equals(".")){
						hasDot = true;
					}
				}
				if (j == 3){
					save[i][j] = String.valueOf(d.charAt(i));
					if(save[i][j].equals(".")){
						hasDot = true;
					}
				}
			}
		}
		return hasDot;
	}
	
	void solveBox(String[][] box, int outputIndex, boolean flagHasDot){
		if(checkH(box,"X") || checkV(box,"X")){
			System.out.println("Case #"+outputIndex+": X won");
		}
		else if(checkH(box,"O") || checkV(box,"O")){
			System.out.println("Case #"+outputIndex+": O won");
		}
		else if(checkS(box,"X")){
			System.out.println("Case #"+outputIndex+": X won");
		}
		else if(checkS(box,"O")){
			System.out.println("Case #"+outputIndex+": O won");
		}
		else if(checkS1(box,"X")){
			System.out.println("Case #"+outputIndex+": X won");
		}
		else if(checkS1(box,"O")){
			System.out.println("Case #"+outputIndex+": O won");
		}
		else if(flagHasDot){
			System.out.println("Case #"+outputIndex+": Game has not completed");
		} else{
			System.out.println("Case #"+outputIndex+": Draw");
		}	
	}
	
	boolean checkH(String[][] box, String flag){
		boolean result = false;
		for(int i = 0; i<4; i++){
			if (box[i][0].equals(flag) || box[i][0].equals("T"))
				if (box[i][1].equals(flag) || box[i][1].equals("T"))
					if (box[i][2].equals(flag) || box[i][2].equals("T"))
						if (box[i][3].equals(flag) || box[i][3].equals("T"))
							result = true;
		}
		return result;
	}
	
	boolean checkV(String[][] box, String flag){
		boolean result = false;
		for(int i = 0; i<4; i++){
			if (box[0][i].equals(flag) || box[0][i].equals("T"))
				if (box[1][i].equals(flag) || box[1][i].equals("T"))
					if (box[2][i].equals(flag) || box[2][i].equals("T"))
						if (box[3][i].equals(flag) || box[3][i].equals("T"))
							result = true;
		}
		return result;
	}
	
	boolean checkS(String[][] box, String flag){
		boolean result = false;
		if (box[0][0].equals(flag) || box[0][0].equals("T"))
			if (box[1][1].equals(flag) || box[1][1].equals("T"))
				if (box[2][2].equals(flag) || box[2][2].equals("T"))
					if (box[3][3].equals(flag) || box[3][3].equals("T"))
						result = true;		
		return result;
	}
	
	boolean checkS1(String[][] box, String flag){
		boolean result = false;
		if (box[3][0].equals(flag) || box[3][0].equals("T"))
			if (box[2][1].equals(flag) || box[2][1].equals("T"))
				if (box[1][2].equals(flag) || box[1][2].equals("T"))
					if (box[0][3].equals(flag) || box[0][3].equals("T"))
						result = true;
		return result;
	}
		
	
	int sovlingProblem(String[] input){

		long start = Long.valueOf(input[0]).longValue();
		long end = Long.valueOf(input[1]).longValue();
		int rowCount = 0;
		for(long i = start; i<= end; i++){
			if(isPalin(i)){
				if(isSquare(i)){
					if(isSquarePalin(i)){
						++rowCount;
					}
				}
			}
		}
		return rowCount;
	}
	
	boolean isPalin(long input){
		if(input < 0){
			return false;
		}
		String original = Long.toString(input);
		String reverse = "";
		int length = original.length();
		for ( int i = length - 1 ; i >= 0 ; i-- )
			reverse = reverse + original.charAt(i);
		if (original.equals(reverse))
			return true;
		else
			return false;
	}
	
	boolean isSquare(long input){
		long temp = (long)(Math.sqrt(input) + 0.5);
		return temp*temp == input;
	}
	
	boolean isSquarePalin(long input){
		long temp = (long) (Math.sqrt(input) + 0.5);
		return isPalin(temp); 
	}
	
	/***********************************************
	 * 				Helper Functions			   *
	 ***********************************************
	 ***********************************************/


	
	private void setCase(int number){
		this.numberOfCases = number;
	}
	
	public int getCase(){
		return this.numberOfCases;
	}
		
	/**
	 * start of the program
	 */
	public static void main(String[] args) {
		new QuestionA1();
	}

}
