import java.util.*;
import java.io.*;

public class RevengeOfThePancakes {
  public static void main(String[] args) throws FileNotFoundException {
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	//Scanner in = new Scanner(new BufferedReader(new FileReader(new File("src/RevengeOfThePancakesInput.txt"))));
	
    int n = in.nextInt(); 
    int caseNumber = 1;
    String line = in.nextLine();
    
    while (in.hasNextLine()) {
    	 line = in.nextLine();
    	 int minFlips = 0;
    	 
    	 while (!isAllHappy(line)) {   	
    		 
    		 if (Character.toString(line.charAt(0)).equals("+")) {
    			 int indexOfPlusOne = lastIndexOfPlusOne(line);
    			 
    			 if (indexOfPlusOne >= line.length()) {
    				 line = flipPancakes(line);
    				 minFlips++;
    			 }
    			 else {
    				 line = flipPancakes(line.substring(0, indexOfPlusOne)) + line.substring(indexOfPlusOne);
    				 minFlips++;
    			 }
    		 }
    		 else {
    			 int indexOfNegativePlusOne = lastIndexOfNegativePlusOne(line);
    			 
    			 if (indexOfNegativePlusOne >= line.length()) {
    				 line = flipPancakes(line);
    				 minFlips++;
    			 }
    			 else {
    				 line = flipPancakes(line.substring(0, indexOfNegativePlusOne)) + line.substring(indexOfNegativePlusOne);
    				 minFlips++;
    			 }
    		 }
    	 }
    	 
    	 System.out.println("Case #" + (caseNumber) + ": " + minFlips);    	
    	 caseNumber++;
    }
  }
  
  public static int lastIndexOfPlusOne(String line) {
	  int index = 0;
	  
	  for (int i = 0; i < line.length(); i++) {
		  if (Character.toString(line.charAt(i)).equals("+")) {
			  index++;
		  }
		  else {
			  return index;
		  }
	  }
	    
	  return index;
  }
  
  public static int lastIndexOfNegativePlusOne (String line) {
	  int index = 0;
	  
	  for (int i = 0; i < line.length(); i++) {
		  if (Character.toString(line.charAt(i)).equals("-")) {
			  index++;
		  }
		  else {
			  return index;
		  }
	  }
	    
	  return index;
  }
  
  public static String flipPancakes (String s) {
	  StringBuilder sb = new StringBuilder();
	  
	  Stack<String> stack = new Stack<String>();
	  for (int i = 0; i < s.length(); i++) {
		  stack.push(Character.toString(s.charAt(i)));
	  }
	  
	  while (!stack.isEmpty()) {
		  String poppedString = stack.pop();
		  String reversedString = "";
		  
		  if (poppedString.equals("+")) {
			  reversedString = "-";
		  }
		  else {
			  reversedString = "+";
		  }
		  sb.append(reversedString);
	  }
	  
	  return sb.toString();
  }
  
  public static boolean isAllHappy (String s) {
	  boolean isAllHappy = true;
	  for (int i = 0; i < s.length(); i++) {
		  if (Character.toString(s.charAt(i)).equals("-")) {
			  isAllHappy = false;
			  return isAllHappy;
		  }
	  }
	  return isAllHappy;
  }
}

