import java.util.*;
import java.util.concurrent.ThreadLocalRandom;
import java.io.*;
import java.math.BigInteger;

//generate random binary string (within parameters)
//check if it is already used from hashset
//check if it is jamcoin
//if it is jamcoin, get non-trivial divisors, increment numOfJamCoins, and print.  

public class CoinJam {
  public static void main(String[] args) throws FileNotFoundException {
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	//Scanner in = new Scanner(new BufferedReader(new FileReader(new File("src/CoinJamInput.txt"))));
	
    int t = in.nextInt(); 
    int n = in.nextInt();
    int j = in.nextInt();	
    int numOfJamCoins = 0;
    HashSet<String> set = new HashSet<String>();
    
	System.out.println("Case #1:");
	
	while (numOfJamCoins < j) {
		//generate random binary string (within parameters)
		StringBuilder randomBString = new StringBuilder();
		randomBString.append("1");
		
		for (int i = 1; i < n - 1; i++) {
			int r = ThreadLocalRandom.current().nextInt(0, 2);
			randomBString.append(Integer.toString(r));
		}
		
		randomBString.append("1");
		String randomBinaryString = randomBString.toString();
		
		//check if it is already used from hashset
		if (!set.contains(randomBinaryString)) {
			set.add(randomBinaryString);
			
			//check if it is jamcoin
			if (isJamCoin(randomBinaryString)) {
				//get/print non-trivial divisors.
				System.out.print(randomBinaryString + " ");
				
				BigInteger[] divisors = getDivisors(randomBinaryString);
				
				for (int i = 0; i < divisors.length; i++) {
					System.out.print(divisors[i].toString() + " ");
				}
				
				System.out.println();
				numOfJamCoins++;
			}
		}
	}    
  }
  
  public static BigInteger[] getDivisors(String binaryString) {
	  BigInteger[] divisors = new BigInteger[9];
	  
	  for (int i = 2; i < 11; i++) {
		  BigInteger theInt = new BigInteger(binaryString, i);
		  divisors[i - 2] = nonTrivialDivisor(theInt);
	  }
	  return divisors;
  }
  
  public static BigInteger nonTrivialDivisor(BigInteger num) {

      for (int i = 2; num.divide(new BigInteger("2")).compareTo(BigInteger.valueOf(i)) == 1; i++) {//i <= num/2
          if (num.mod(new BigInteger(Integer.toString(i))).equals(BigInteger.ZERO)) { //num % i == 0
              return BigInteger.valueOf(i);
          }
      }
      
      return num;
  }
  
  public static boolean isJamCoin (String binaryString) {
	  
	  for (int i = 2; i < 11; i++) {
		  BigInteger theInt = new BigInteger(binaryString, i);
		  if (theInt.isProbablePrime(1)) {
			  return false;
		  }
	  }
	  
	  return true;
  }
  
  /*public static boolean isPrime(BigInteger num) {
      if (num < 2) return false;
      if (num == 2) return true;
      if (num % 2 == 0) return false;
      for (int i = 3; i * i <= num; i += 2)
          if (num % i == 0) return false;
      return true;
  }*/
}