import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;

public class Haircut {

	public static void main (String [] args) throws IOException {
		String root = "B-small-attempt3";
		String fileName = "C:\\Users\\Aaron\\Downloads\\" + root + ".in";
		BufferedReader reader = new BufferedReader (new FileReader(new File(fileName)));
		int nTestCases = Integer.parseInt(reader.readLine());
		ArrayList<String> out = new ArrayList<String>();
		for (int t = 0; t < nTestCases; t++) {
			String[] bn = reader.readLine().split(" ");
			int n = Integer.parseInt(bn[1]);
			String[] parts = reader.readLine().split(" ");
			int[] barbers = new int[parts.length];
			for (int i = 0; i < barbers.length; i++) barbers[i] = Integer.parseInt(parts[i]);
			
			int lcm = lcm(barbers);
			int numPeopleDoneAtLCM = 0;
			for (int i = 0; i < barbers.length; i++) {
				numPeopleDoneAtLCM += lcm / barbers[i];
			}
			System.out.println("Barbers: " + Arrays.toString(barbers));
			System.out.println("Num people done at LCM (" + lcm + "):  " + numPeopleDoneAtLCM);
			
			// Eliminate the unnecessary bulk
			n %= numPeopleDoneAtLCM;
			System.out.println("N: " + n);
			int ans = -1;
			if (n == 0) {ans = barbers.length;}
			else ans = simulate(barbers, n) + 1;
			
			System.out.println("CASE " + (t + 1) + ": " + ans);
			out.add("Case #" + (t+1) + ": " + ans);
			System.out.println("-----------------");
		}
		
		PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\Aaron\\Downloads\\"+ root + "-SOL.out")));
		for (String s : out) {
			writer.write(s + "\n");
		}
		
		writer.close();
		reader.close();
	}
	
	public static int simulate (int[] barbers, int n) {
		boolean[] available = new boolean[barbers.length];
		Arrays.fill(available, true);
		int[] timeLeft = barbers.clone();
		
		while (n > 0) {
			boolean foundBarber = false;
			for (int i = 0; i < barbers.length; i++) {
				if (available[i]) {
					available[i] = false;
					foundBarber = true;
					if (n == 1) return i;
					n--;
					break;
				}
			}
			if (!foundBarber) {
				int minTimeLeft = Integer.MAX_VALUE;
				for (int i = 0; i < timeLeft.length; i++) {
					if (timeLeft[i] < minTimeLeft) {
						minTimeLeft = timeLeft[i];
					}
				}
				
				int nextAvailable = -1;
				boolean foundAvailable = false;
				for (int i = 0; i < timeLeft.length; i++) {
					timeLeft[i] -= minTimeLeft;
					if (timeLeft[i] == 0) {
						if (!foundAvailable) {
							nextAvailable = i;
							foundAvailable = true;
						} else {
							available[i] = true;
						}
						timeLeft[i] = barbers[i];
					}
				}
				//System.out.println(Arrays.toString(timeLeft) + " next: " + nextAvailable);
				
				if (n == 1) {System.out.println("RETURNING"); return nextAvailable;}
				n--;
			}
		}
		return -1;
	}
	
	private static int gcd(int a, int b) {
		while (b > 0) {
			int temp = b;
			b = a % b;
			a = temp;
		}
		return a;
	}
	
	public static int lcm(int a, int b)
	{
	    return a * (b / gcd(a, b));
	}

	public static int lcm(int[] input)
	{
	    int result = input[0];
	    for(int i = 1; i < input.length; i++) 
	    	result = lcm(result, input[i]);
	    
	    return result;
	}
}
