import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
	
	public static List<Integer> getPrimes(int n){
		List<Integer> primeList = new ArrayList<>();
		for (int i = 2; i < n; ++i){
			boolean isPrime = true;
			for (int j = 2; j <= i / j; ++j){
				if (0 == i % j){
					isPrime = false;
					break;
				}
			}
			if (isPrime){
				primeList.add(i);
			}
		}
		return primeList;
	}
	
	public static long getBaseK(long n, int k){
		long temp = n, baseK = 0, co = k;
		while (temp > 0){
			baseK += co * (temp % 2);
			temp /= 2;
			co *= k;
		}
		return baseK;
	}
	

	/**
	 * @param args
	 */
	@SuppressWarnings("resource")
	public static void main(String[] args) throws IOException{
			
			FileInputStream inputStream = null;
			Scanner sc = null;
			inputStream = new FileInputStream("F:\\C-small-attempt0.in");

			FileOutputStream fs = new FileOutputStream(new File("F:\\out.txt"));
	        PrintStream p = new PrintStream(fs);
			
			sc = new Scanner(inputStream, "UTF-8");
			List<Integer> primeList = getPrimes(10000);
			int t = sc.nextInt();
			for(int x = 1; x <= t; ++x){
				p.println(String.format("Case #%d:", x));
				int N = sc.nextInt();
				int J = sc.nextInt();

				int sat = 0;
				for (long j = 0 ; j < (long)Math.pow(2, N - 2) && sat < J; ++j){
					boolean isCoinJam = true;
					long[] nontrivial = new long[9];
					for (int k = 2; k <= 10; ++k){
						long baseK = getBaseK(j, k);
						baseK += (1 + (long)Math.pow(k, N - 1));
						
						boolean isKPrime = false;
						for (int prime : primeList){
							if (0 == baseK % prime){
								isKPrime = true;
								nontrivial[k-2] = prime;
								break;
							}
						}
						
						if (!isKPrime){
							isCoinJam = false;
							break;
						}
					}
					
					if (isCoinJam){
						StringBuilder sb = new StringBuilder("1");
						long temp = j, bit = 0;
						while (temp > 0){
							++bit;
							sb.append(temp % 2);
							temp /= 2;
						}
						while (bit < (N - 2)){
							++bit;
							sb.append("0");
						}
						sb.append("1");
						
						p.print(sb.reverse().toString());
						for (int k = 0; k < 9; ++k){
							p.print(String.format(" %d", nontrivial[k]));	
						}
						p.println();
						
						++sat;
					}
				}
			}
			p.close();
	}

}