import java.io.*;
import java.math.BigInteger;
import java.util.InputMismatchException;

public class TaskA implements Runnable {
    private InputReader in;
    private PrintWriter out;

    public static void main(String[] args) {
        new Thread(new TaskA()).start();
    }

    public TaskA() 
    {
        try 
        {
            System.setIn(new FileInputStream("input.txt"));
            System.setOut(new PrintStream(new FileOutputStream("output.txt")));
        } catch (FileNotFoundException e) 
        {
            throw new RuntimeException();
        }
        in = new InputReader(System.in);
        out = new PrintWriter(System.out);
    }

    public void run() 
    {
        int numTests = in.readInt();
        for (int testNumber = 0; testNumber < numTests; testNumber++) 
        {
            out.print("Case #" + (testNumber + 1) + ": ");
            char[][] t = new char[4][4];
            int x=0,o=0,dot=0,DOT=0;
            String result="";
            for (int i = 0; i < 4; i++) 
            {
                x=o=dot=0;
                for (int j = 0; j < 4; j++)
                {
                    t[i][j] = in.readCharacter();
                    if(t[i][j]=='X')x++;
                    else if(t[i][j]=='O')o++;
                    else if(t[i][j]=='.')dot++;

                }
                DOT+=dot;
                if(x-dot>=3 && o==0)
                    result="X won";

                else if(o>=3 && x==0)result="O won";
            }
 
            
            if(result.equals(""))
            {
                for (int i = 0; i < 4; i++) 
                {
                    x=o=dot=0;
                    for (int j = 0; j < 4; j++)
                    {
                        if(t[j][i]=='X')x++;
                        else if(t[j][i]=='O')o++;
                        else if(t[j][i]=='.')dot++;
                    }
                    if(x-dot>=3 && o==0)
                    {
                        result="X won";
                        break;
                    }
                    else if(o-dot>=3 && x==0)
                    {
                        result="O won";
                        break;
                    }
                }

            }
            if(result.equals(""))
            {
                x=o=dot=0;

                for (int i = 0; i < 4; i ++)
                {
                    if(t[i][i]=='X')x++;
                    else if(t[i][i]=='O')o++;
                    else if(t[i][i]=='.')dot++;
                }

                if(x-dot>=3 && o==0)
                    result="X won";           
                else if(o-dot>=3 && x==0)
                    result="O won";

                if(result.equals(""))
                {
                    x=o=dot=0;

                    for (int i = 0; i < 4; i ++)
                    {
                        if(t[i][4-i-1]=='X')x++;
                        else if(t[i][4-i-1]=='O')o++;
                        else if(t[i][4-i-1]=='.')dot++;
                    }
                    if(x-dot>=3 && o==0)result="X won";
                    if(o-dot>=3 && x==0)result="O won";
                }

            }

            if(result.equals("X won") || result.equals("O won"));
            else if(result.equals("") && DOT==0)
                result="Draw";
            else     
                result="Game has not completed";

            out.println(result);

        }
        out.close();
    }

    private static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1000];
        private int curChar, numChars;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        private int read() {
            if (numChars == -1)
                throw new InputMismatchException();
            if (curChar >= numChars) {
                curChar = 0;
                try {
                    numChars = stream.read(buf);
                } catch (IOException e) {
                    throw new InputMismatchException();
                }
                if (numChars <= 0)
                    return -1;
            }
            return buf[curChar++];
        }

        public int readInt() {
            int c = read();
            while (isSpaceChar(c))
                c = read();
            int sgn = 1;
            if (c == '-') {
                sgn = -1;
                c = read();
            }
            int res = 0;
            do {
                if (c < '0' || c > '9')
                    throw new InputMismatchException();
                res *= 10;
                res += c - '0';
                c = read();
            } while (!isSpaceChar(c));
            return res * sgn;
        }

        public long readLong() {
            int c = read();
            while (isSpaceChar(c))
                c = read();
            int sgn = 1;
            if (c == '-') {
                sgn = -1;
                c = read();
            }
            long res = 0;
            do {
                if (c < '0' || c > '9')
                    throw new InputMismatchException();
                res *= 10;
                res += c - '0';
                c = read();
            } while (!isSpaceChar(c));
            return res * sgn;
        }

        public String readString() {
            int c = read();
            while (isSpaceChar(c))
                c = read();
            StringBuffer res = new StringBuffer();
            do {
                res.appendCodePoint(c);
                c = read();
            } while (!isSpaceChar(c));
            return res.toString();
        }

        private boolean isSpaceChar(int c) {
            return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
        }

        private String readLine0() {
            StringBuffer buf = new StringBuffer();
            int c = read();
            while (c != '\n' && c != -1) {
                buf.appendCodePoint(c);
                c = read();
            }
            return buf.toString();
        }

        public String readLine() {
            String s = readLine0();
            while (s.trim().length() == 0)
                s = readLine0();
            return s;
        }

        public String readLine(boolean ignoreEmptyLines) {
            if (ignoreEmptyLines)
                return readLine();
            else
                return readLine0();
        }

        public BigInteger readBigInteger() {
            try {
                return new BigInteger(readString());
            } catch (NumberFormatException e) {
                throw new InputMismatchException();
            }
        }

        public char readCharacter() {
            int c = read();
            while (isSpaceChar(c))
                c = read();
            return (char) c;
        }

        public double readDouble() {
            int c = read();
            while (isSpaceChar(c))
                c = read();
            int sgn = 1;
            if (c == '-') {
                sgn = -1;
                c = read();
            }
            double res = 0;
            while (!isSpaceChar(c) && c != '.') {
                if (c < '0' || c > '9')
                    throw new InputMismatchException();
                res *= 10;
                res += c - '0';
                c = read();
            }
            if (c == '.') {
                c = read();
                double m = 1;
                while (!isSpaceChar(c)) {
                    if (c < '0' || c > '9')
                        throw new InputMismatchException();
                    m /= 10;
                    res += (c - '0') * m;
                    c = read();
                }
            }
            return res * sgn;
        }
    }

}
