package com.google.codejam;

import java.io.*;
import java.util.StringTokenizer;

/**
 * @author Aayush
 * @Version 1.0, 9/4/16.
 */
public class RevengePancakes {
  FastScanner in;
  PrintWriter out;

  public static void main(String[] args) {
    new RevengePancakes().run();
  }

  void solve() {
    int tc = in.nextInt();
    for (int t = 0; t < tc; t++) {
      out.print("Case #" + (t + 1) + ": ");
      String s = in.next();
      int dpUp[] = new int[101];
      int dpDown[] = new int[101];

      if (s.charAt(0) == '+') {
        dpUp[0] = 0;
        dpDown[0] = 1;
      } else {
        dpUp[0] = 1;
        dpDown[0] = 0;
      }
      for (int i = 1; i < s.length(); i++) {
        if (s.charAt(i) == '+') {
          dpUp[i] = Math.min(dpDown[i - 1] + 1, dpUp[i - 1]);
          dpDown[i] = Math.min(dpUp[i - 1] + 1, dpDown[i - 1] + 2);
        } else {
          dpUp[i] = Math.min(dpUp[i - 1] + 2, dpDown[i - 1] + 1);
          dpDown[i] = Math.min(dpUp[i - 1] + 1, dpDown[i - 1]);
        }
      }
      out.println(dpUp[s.length() - 1]);
    }
  }

  void run() {
    try {
      in = new FastScanner(new File("B.in"));
      out = new PrintWriter(new File("B.out"));
      solve();
      out.close();
    } catch (FileNotFoundException e) {
      e.printStackTrace();
    }
  }

  void runIO() {
    in = new FastScanner(System.in);
    out = new PrintWriter(System.out);

    solve();

    out.close();
  }

  class FastScanner {
    BufferedReader br;
    StringTokenizer st;

    public FastScanner(File f) {
      try {
        br = new BufferedReader(new FileReader(f));
      } catch (FileNotFoundException e) {
        e.printStackTrace();
      }
    }

    public FastScanner(InputStream f) {
      br = new BufferedReader(new InputStreamReader(f));
    }

    String next() {
      while (st == null || !st.hasMoreTokens()) {
        String s = null;
        try {
          s = br.readLine();
        } catch (IOException e) {
          e.printStackTrace();
        }
        if (s == null)
          return null;
        st = new StringTokenizer(s);
      }
      return st.nextToken();
    }

    boolean hasMoreTokens() {
      while (st == null || !st.hasMoreTokens()) {
        String s = null;
        try {
          s = br.readLine();
        } catch (IOException e) {
          e.printStackTrace();
        }
        if (s == null)
          return false;
        st = new StringTokenizer(s);
      }
      return true;
    }

    int nextInt() {
      return Integer.parseInt(next());
    }

    long nextLong() {
      return Long.parseLong(next());
    }

    double nextDouble() {
      return Double.parseDouble(next());
    }
  }
}
