package googleCodeJam;

import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;

/**
 * Created by aayush.agarwal on 9/4/17.
 */
public class TidyNumbers {
    private FastScanner in;
    private PrintWriter out;

    private List<Long> list;
    private long cache[][][];
    private boolean visited[][][];

    public static void main(String args[]) {
        new TidyNumbers().run();
    }

    private long f(int idx, int tight, int lastDigit) {
        if (idx == list.size()) {
            return 1;
        }
        if (visited[idx][tight][lastDigit]) return cache[idx][tight][lastDigit];
        long ans = 0;
        for (int i = 0; i < 10; i++) {
            if (tight > 0 && i > list.get(idx)) break;
            if (lastDigit <= i)
                ans += f(idx + 1, tight > 0 && (i == list.get(idx)) ? 1 : 0, i);
        }
        visited[idx][tight][lastDigit] = true;
        cache[idx][tight][lastDigit] = ans;
        return ans;
    }

    private void solve() {
        //int tc = 1;
        int tc = in.nextInt();
        for (int t = 0; t < tc; t++) {
            long N = in.nextLong();
            long copy = N;
            long prev = 10;
            int f = 0;
            while (copy > 0) {
                long curr = copy % 10;
                if (curr > prev) {
                    f = 1;
                    break;
                }
                prev = curr;
                copy /= 10;
            }
            if (f == 0) {
                out.println("Case #" + (t + 1) + ": " + N);
                continue;
            }
            out.println("Case #" + (t + 1) + ": " + lookUp(N));
        }
    }

    private long lookUp(long N) {
        long totalCount = calc(N);
        long start = 1;
        long end = N;
        long ans = N;
        while (start <= end) {
            long mid = (start + end) / 2;
            long count = calc(mid);
            if (count < totalCount) {
                start = mid + 1;
            } else if (count >= totalCount) {
                end = mid - 1;
                ans = mid;
            }
        }
        return ans;
    }

    private long calc(long N) {
        if (list != null)
            list.clear();
        else
            list = new ArrayList<>();
        long copy = N;
        while (copy > 0) {
            long curr = copy % 10;
            list.add(curr);
            copy /= 10;
        }
        list.add(0L);
        Collections.reverse(list);
        cache = new long[21][2][10];
        visited = new boolean[21][2][10];
        return f(0, 1, 0) - 1;
    }

    /**
     * to run program with file
     */

    private void run() {
        try {
            in = new FastScanner(new File("/home/local/JASPERINDIA/aayush.agarwal/Downloads/B.in"));
            out = new PrintWriter(new File("/home/local/JASPERINDIA/aayush.agarwal/Downloads/B.out"));
            solve();
            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    private void runIO() {
        in = new FastScanner(System.in);
        out = new PrintWriter(new BufferedOutputStream(System.out));

        solve();

        out.close();
    }

    private static class FastScanner {

        private BufferedReader br;
        private StringTokenizer st;

        private FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        private FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        private String next() {
            while (st == null || !st.hasMoreTokens()) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null)
                    return null;
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        private int nextInt() {
            return Integer.parseInt(next());
        }

        private long nextLong() {
            return Long.parseLong(next());
        }

        private double nextDouble() {
            return Double.parseDouble(next());
        }

        private String nextLine() {
            String str = "";
            try {
                str = br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }
    }
}
