import java.io.*;
import java.util.*;

public class Test
{
	public static double solve(double flyR, double patR, double patT, 
			double stringR, double stringG)
	{
		double catchR = patR-patT-flyR;
		double catchSR = stringR+flyR;
		double catchSG = stringG-2*flyR;
		double greenArea = 0;
		double whiteArea = 0;
		double allArea = Math.PI*catchR*catchR;
		double maxArea = Math.PI*patR*patR;
		
		double xposition = catchSR;
		for(;xposition <= catchR;xposition += catchSR*2+catchSG)
		{
			double yposition = catchSR;
			for(;yposition <= catchR;yposition += catchSR*2+catchSG)
			{
			//	System.out.println("Position: " + xposition + ", " + yposition);
				double xmin = xposition;
				double xmax = xposition+catchSG;
				double ymin = yposition;
				double ymax = yposition+catchSG;
				double xupdis = getDis(catchR, ymax);
				double xdowndis = getDis(catchR, ymin);
				double yupdis = getDis(catchR, xmax);
				double ydowndis = getDis(catchR, xmin);
				double all = catchSG*catchSG;
				//System.out.println("xupdis: " + xupdis);
				//System.out.println("xdowndis: " + xdowndis);
				//System.out.println("yupdis: " + yupdis);
				//System.out.println("ydowndis: " + ydowndis);
				
				if(xupdis > xmax)
				{
				//	System.out.println("all");
					whiteArea += all;
					continue;
				}else if(xdowndis < xmin&& xdowndis != -1)
				{
				//	System.out.println("none");
				//	yposition = catchR+1;
				//	continue;
					break;
				}
				
				boolean up;
				boolean right;
				if(xupdis <= xmax&& xupdis >= xmin)
				{
					up = true;
				}else
				//if()
				{
					up = false;
				}
				if(yupdis <= ymax&& yupdis >= ymin)
				{
					right = true;
				}else
				//if()
				{
					right = false;
				}
				
				double bow;
				if(up)
				{
					if(right)
					{
						double triangle = (xmax-xupdis)*(ymax-yupdis)/2;
						whiteArea += all-triangle;
						bow = getBowArea(catchR, xupdis, ymax, xmax, yupdis);
				//		System.out.println("Triangle1: " + triangle);
					}else
					{
						double step = (xupdis-xmin+xdowndis-xmin)*catchSG/2;
						whiteArea += step;
						bow = getBowArea(catchR, xupdis, ymax, xdowndis, ymin);
				//		System.out.println("Step1: " + step);
					}
				}else
				{
					if(right)
					{
						double step = (yupdis-ymin+ydowndis-ymin)*catchSG/2;
						whiteArea += step;
						bow = getBowArea(catchR, xmin, ydowndis, xmax, yupdis);
				//		System.out.println("Step2: " + step);
					}else
					{
						double triangle = (xdowndis-xmin)*(ydowndis-ymin)/2;
						whiteArea += triangle;
						bow = getBowArea(catchR, xmin, ydowndis, xdowndis, ymin);
				//		System.out.println("Triangle2: " + triangle);
					}
				}
				whiteArea += bow;
				//System.out.println("Bow: " + bow);
				//System.out.println("Area: " + whiteArea);
			}
		}
		whiteArea = whiteArea*4;
		return 1-whiteArea/maxArea;
	}
	public static double getBowArea(double r, 
			double x1, double y1, double x2, double y2)
	{
		double angle1, angle2;
		if(x1 == 0)
		{
			angle1 = Math.PI/2;
		}else
		{
			angle1 = Math.atan(y1/x1);
		}
		if(x2 == 0)
		{
			angle2 = Math.PI/2;
		}else
		{
			angle2 = Math.atan(y2/x2);
		}
	//	//System.out.println(angle1);
	//	//System.out.println(angle2);
		double angle = Math.abs(angle1-angle2);
		return getBowArea(r, angle);
	}
	public static double getBowArea(double r, double angle)
	{
		double allArea = r*r*angle/2;
	//	//System.out.println("Radius: " + r);
	//	//System.out.println("Angle: " + angle);
	//	//System.out.println("Area: " + allArea);
		double triangleArea = Math.sin(angle)*r*r/2;
		return allArea-triangleArea;
	}
	public static double getDis(double r, double x)
	{
		if(x > r)
		{
			return -1;
		}
		double yy = r*r-x*x;
		return Math.sqrt(yy);
	}
	
	public static void main(String[] args)
	{
		/*
		if(true)
		{
			//System.out.println(getBowArea(100, 45, 45, 90, 0));
			return;
		}
		*/
		try
		{
			BufferedReader reader = new BufferedReader(new FileReader("C-small-attempt1.in"));
			BufferedWriter writer = new BufferedWriter(new FileWriter("C-small-attempt1.out"));
			int number = Integer.parseInt(reader.readLine());
		//	number = 3;
			
			for(int i = 0;i < number;i++)
			{
				System.out.println("Case #" + (i+1) + ":");
				String info = reader.readLine();
				StringTokenizer token = new StringTokenizer(info, " ");
				double f = Double.parseDouble(token.nextToken());
				double patr = Double.parseDouble(token.nextToken());
				double t = Double.parseDouble(token.nextToken());
				double r = Double.parseDouble(token.nextToken());
				double g = Double.parseDouble(token.nextToken());
				double percentage = solve(f, patr, t, r, g);
				writer.write("Case #" + (i+1) + ": " + percentage + "\n");
			}
			
			reader.close();
			writer.close();
		}catch(Exception ex)
		{
			ex.printStackTrace();
		}
	}
}