import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Vector;

import com.sun.org.apache.xml.internal.serializer.utils.StringToIntTable;

public class ProblemA {
	PrintWriter out = null;
	BufferedReader in = null;
	int[][] treesMod = new int[3][3];
//	private Vector trees = new Vector();
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			ProblemA problem = new ProblemA(new BufferedReader(new InputStreamReader(new FileInputStream(new File(args[0])))),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ProblemA(BufferedReader xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
		int num = Integer.parseInt(in.readLine());
		for (int i = 0; i< num ; i++){
			String line = in.readLine();
			StringTokenizer st = new StringTokenizer(line);
			int n = Integer.parseInt(st.nextToken());
			int A = Integer.parseInt(st.nextToken());
			int B = Integer.parseInt(st.nextToken());
			int C = Integer.parseInt(st.nextToken());
			int D = Integer.parseInt(st.nextToken());
			int x0 = Integer.parseInt(st.nextToken());
			int y0 = Integer.parseInt(st.nextToken());
			int M = Integer.parseInt(st.nextToken());
			generateTrees(n,A,B,C,D,x0,y0,M);
			int trees = 0;
			int j,k;
			for (j=0;j<3;j++){
				for(k=0;k<3;k++){
					System.out.print(treesMod[j][k]+" ");
					trees += n3(treesMod[j][k]);
				}
				System.out.println();
				trees += treesMod[j][0]*treesMod[j][1]*treesMod[j][2];
				trees += treesMod[0][j]*treesMod[1][j]*treesMod[2][j];
			}
			trees += treesMod[0][0]*treesMod[1][2]*treesMod[2][1];
			trees += treesMod[0][1]*treesMod[1][0]*treesMod[2][2];
			trees += treesMod[0][2]*treesMod[1][0]*treesMod[2][1];
			trees += treesMod[0][1]*treesMod[1][2]*treesMod[2][0];
			trees += treesMod[0][0]*treesMod[1][1]*treesMod[2][2];
			trees += treesMod[0][2]*treesMod[1][1]*treesMod[2][0];
			out.println("Case #"+(i+1)+": "+trees);
			System.out.println();
		}
	}
	
	private void generateTrees(int n, int A,int B, int C ,int D, int x0, int y0, int M){
		int i,j;
		for (i= 0;i<3;i++){
			for (j= 0;j<3;j++){
				treesMod[i][j] = 0;
			}			
		}
		long X = x0;
		long Y = y0;
		treesMod[(int)(X%3)][(int)(Y%3)]++;
		for (i = 0 ; i < n-1;i++){
			X = (A*X+B)%M;
			Y = (C*Y+D)%M;
			try{
			treesMod[(int)(X%3)][(int)(Y%3)]++;
			}catch(Exception e){
//				System.out.println("X:"+X+" Y:"+Y);
//				System.out.println("X%3:"+(X%3)+" Y%3:"+(Y%3));
				e.printStackTrace();
			}
		}
	}
	
	private long n3(int n){
		if (n<3) return 0;
		return (n*(n-1)*(n-2))/6;
	}
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
}
