import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Vector;

public class ProblemB {
	PrintWriter out = null;
	Scanner in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			ProblemB problem = new ProblemB(new Scanner(new File(args[0])),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ProblemB(Scanner xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
		int N = in.nextInt();
		for (int caseNo = 1; caseNo <= N; caseNo++){
			int H = in.nextInt();
			int W = in.nextInt();
			StringBuffer res = new StringBuffer();
			for (int i=0;i<W*H ;i++){
				res.append("0");
			}
			String result = res.toString();
			int[][] map = new int[H][W];
			for (int y = 0;y < H ;y++){
				for (int x = 0; x<W ;x++){
					map[y][x] = in.nextInt();
				}
			}

			out.println("Case #"+caseNo+": ");
			char basin = 'a';
			for (int y = 0;y < H ;y++){
				for (int x = 0; x<W ;x++){
					int a = x;
					int b = y;
					while(true){
						char c = getResultElement(result, W, H, a, b);
						if ( c == '0'){
							result = setResultElement(result, W, H, a, b, '1');
							int[] next = getNextPathElement(map, W, H, a, b);
							if (next == null ){
								result = result.replaceAll("1", ""+basin);
								basin++;
								break;
							}
							else{
								b = next[0];
								a = next[1];
							}
						}else{
							if(a!=x || b!=y){
								result = result.replaceAll("1", ""+c);
							}
							break;
						}
					}
					out.print(getResultElement(result, W, H, x, y));
					if (x!=W-1) out.print(" ");
				}
				out.println();
			}
		}
	}

	
	private int[] getNextPathElement(int[][] map, int W, int H, int x, int y){
		int[] ret = null;
		int smallest = map[y][x];
		if (y>0 && map[y-1][x]< smallest){	// NORTH
			smallest = map[y-1][x];
			ret = new int[]{y-1,x};
		}
		if (x>0 && map[y][x-1]< smallest){	// WEST
			smallest = map[y][x-1];
			ret = new int[]{y,x-1};			
		}
		if (x<W-1 && map[y][x+1]< smallest){	// EAST
			smallest = map[y][x+1];
			ret = new int[]{y,x+1};			
		}
		if (y<H-1 && map[y+1][x]< smallest){	// SOUTH
			smallest = map[y+1][x];
			ret = new int[]{y+1,x};
		}
		return ret;
	}
	
	private String setResultElement(String xResult, int W, int H, int x, int y, char c){
		String ret = "";
		/*if (y*W+x>=0)*/ ret += xResult.substring(0,y*W+x);
		ret += c;
		/*if (y*W+x<W*H)*/ ret += xResult.substring(y*W+x+1);
//		return xResult.substring(0,y*W+x-1)+c+xResult.substring(y*W+x);
		return ret;
	}
	
	private char getResultElement(String xResult, int W, int H, int x, int y){
		return xResult.charAt(y*W+x);
	}
	
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
}
