import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.StringTokenizer;
import java.util.Vector;

public class Problem2 {
	private static final int A_STATION = 0;
	private static final int B_STATION = 1;
	PrintWriter out = null;
	BufferedReader in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			Problem2 problem = new Problem2(new BufferedReader(new InputStreamReader(new FileInputStream(new File(args[0])))),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public Problem2(BufferedReader xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
		int num = Integer.parseInt(in.readLine());
		for(int i=0;i<num;i++){
			System.out.println("Case #"+(i+1)+":");
			Vector allSchedule = new Vector();
			int T = Integer.parseInt(in.readLine());
			String line = in.readLine();
			StringTokenizer st = new StringTokenizer(line);
			int NA = Integer.parseInt(st.nextToken());
			int NB = Integer.parseInt(st.nextToken());
			readSchedules(allSchedule,NA,A_STATION);
			readSchedules(allSchedule,NB,B_STATION);
			Collections.sort(allSchedule);
			int station;
			int counterA = 0;
			int counterB = 0;
			while((station = removeNextLine(allSchedule,T)) != -1){
				if (station == A_STATION) counterA++;
				else counterB++;
			}
			out.println("Case #"+(i+1)+": "+counterA+" "+counterB);
		}
	}
	
	private int removeNextLine(Vector allSchedule,int turnaround){
		if (allSchedule.size() == 0) return -1;
		ScheduleLine startLine = (ScheduleLine)allSchedule.elementAt(0);
		System.out.println("  Line from "+((startLine.station==A_STATION)?"StationA":"StationB"));
		allSchedule.removeElementAt(0);
		int starterStation =  startLine.station;
		ScheduleLine prevLine = startLine;
		ScheduleLine actLine = null;
		int nextStation = 1-prevLine.station; 
		int i=0;
		int minutes = prevLine.arrival%100 + turnaround;
		int nextDeparture = (prevLine.arrival/100 +minutes/60)*100 + minutes%60; 
		System.out.println("   "+prevLine+" nextDeparture:"+nextDeparture);
		while(i<allSchedule.size()){
			minutes = prevLine.arrival%100 + turnaround;
			nextDeparture = (prevLine.arrival/100 +minutes/60)*100 + minutes%60; 
			actLine = (ScheduleLine)allSchedule.elementAt(i);
			if (actLine.departure>=nextDeparture && actLine.station==nextStation){
				prevLine = actLine;
				System.out.println("   "+prevLine+" nextDeparture:"+nextDeparture);
				allSchedule.removeElement(prevLine);
				nextStation = 1-prevLine.station; 				
			}else{
				i++;
			}
			
		}
		return starterStation;
	}
	
	private void readSchedules(Vector v,int n,int station) throws Exception{
		for (int i=0;i<n;i++){
			String line = in.readLine();
			StringTokenizer st = new StringTokenizer(line," :");
			int departure = Integer.parseInt(st.nextToken())*100+Integer.parseInt(st.nextToken());
			int arrival = Integer.parseInt(st.nextToken())*100+Integer.parseInt(st.nextToken());
			ScheduleLine sl = new ScheduleLine(departure,arrival,station);
			v.addElement(sl);
		}
	}
	
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
	class ScheduleLine implements Comparable{
		public int departure;
		public int arrival;
		public int station;
		
		public ScheduleLine(int xDeparture,int xArrival, int xStation){
			departure = xDeparture;
			arrival = xArrival;
			station = xStation;
		}
		
		
		public int compareTo(Object o){
			ScheduleLine sl = (ScheduleLine) o;
			if (departure < sl.departure) return -1;
			else if(departure > sl.departure) return 1;
			else{
				if (arrival< sl.arrival) return -1;
				else if (arrival > sl.arrival) return 1;
				else return 0;
			}
		}
		
		public String toString(){
			return ("Train from "+((station==A_STATION)?"StationA":"StationB")+" : departure:"+departure+" , arrival:"+arrival);
		}
	}
	
}
