import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class ProblemC {
	PrintWriter out = null;
	Scanner in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			ProblemC problem = new ProblemC(new Scanner(new File(args[0])),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ProblemC(Scanner xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
		int num = in.nextInt();
		for (int caseNo = 1; caseNo <= num; caseNo++){
			int P = in.nextInt();
			int Q = in.nextInt();
			//String jail = "";
			char[] jail = new char[P];
			Arrays.fill(jail, 'x');			
			for (int i=0;i<Q;i++){
				int j = in.nextInt();
				jail[j-1] = 'O';
			}
			
			int gold1 = neededGold1(new String(jail));
			String res = ""+gold1;
			System.out.println("Case #"+caseNo+": "+res);
			
/*			int gold = neededGold(new String(jail));
			res = ""+gold;
			System.out.println("Case #"+caseNo+": "+res);*/
			out.println("Case #"+caseNo+": "+res);
		}
	}
	
	public int neededGold1(String jail){
//		System.out.println(jail);
		if (jail.indexOf("O") == -1) return 0;
		int min = Integer.MAX_VALUE;
		int breakP = -1;
		while(true){
			breakP = jail.indexOf("O", breakP+1);
			if (breakP == -1) break;
			String prevJail = jail.substring(0, breakP);
			String nextJail = jail.substring(breakP+1);
			min = Math.min(min, neededGold1(prevJail)+neededGold1(nextJail)+jail.length()-1);
//			return neededGold(prevJail)+neededGold(nextJail)+jail.length()-1;			
		}
		return min;
	}
	
	public int neededGold(String jail){
//		System.out.println("neededGold:"+jail);
		double center = (jail.length()-1) / (double)2.0;
		int centerpos = (int)Math.round(center);
//		System.out.println("centerpos"+centerpos);
		int nextPrisoner = jail.indexOf("O", centerpos);
		int prevPrisoner = jail.lastIndexOf("O", centerpos);
		if (nextPrisoner == -1 && prevPrisoner == -1) return 0;
		double nextDist = Double.MAX_VALUE;
		double prevDist = -10000000;
		if (nextPrisoner != -1)	nextDist = nextPrisoner-center; 
		if (prevPrisoner != -1)	prevDist = center-prevPrisoner; 
//		System.out.println("prevDist"+prevDist);
//		System.out.println("nextDist"+nextDist);
		int breakPoint = 0;
		if (nextPrisoner != -1 && prevPrisoner != -1){
//		if (nextDist == prevDist){
			String prevJail = jail.substring(0, prevPrisoner);
			String nextJail = jail.substring(prevPrisoner+1);
			int verA = neededGold(prevJail)+neededGold(nextJail);
			prevJail = jail.substring(0, nextPrisoner);
			nextJail = jail.substring(nextPrisoner+1);
			int verB = neededGold(prevJail)+neededGold(nextJail);
			int min = Math.min(verA, verB)+jail.length()-1;
			return min;
/*			int pD = prevJail.lastIndexOf("O");
			if (pD != -1) pD = prevJail.length()-pD;
			int nD = nextJail.indexOf("O");
			if (nD > pD) breakPoint = nextPrisoner;
			else breakPoint = prevPrisoner;*/
		}
		else{
			if (nextDist > prevDist && prevDist > 0 ) breakPoint = prevPrisoner;
			else breakPoint = nextPrisoner;
			String prevJail = jail.substring(0, breakPoint);
			String nextJail = jail.substring(breakPoint+1);
			return neededGold(prevJail)+neededGold(nextJail)+jail.length()-1;
		}
//		return 0;
	}
	

	
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
}
