import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class Problem3 {
	PrintWriter out = null;
	BufferedReader in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			Problem3 problem = new Problem3(new BufferedReader(new InputStreamReader(new FileInputStream(new File(args[0])))),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public Problem3(BufferedReader xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
//		double wA = calculateWhiteArea(14., 1., 1.)*8;
//		System.out.println("WA:"+wA);
		Point p1 = new Point();
		p1.x = 3;
		p1.y = 4;
		Point p2 = new Point();
		p2.x = 4;
		p2.y = 3;
		//System.out.println("SZELET:"+calculateArcArea(5, p1, p2));
		int num = Integer.parseInt(in.readLine());
		for (int i=0;i<num;i++){
			String line = in.readLine();
			StringTokenizer st = new StringTokenizer(line);
			double f = Double.parseDouble(st.nextToken());
			double R = Double.parseDouble(st.nextToken());
			double t = Double.parseDouble(st.nextToken());
			double r = Double.parseDouble(st.nextToken());
			double g = Double.parseDouble(st.nextToken());
			double whiteArea = calculateWhiteArea(R-t-f, r+f, g-2*f)*8;
			double circleArea = (R)*(R)*Math.PI;
			//System.out.println("WA:"+whiteArea+" , CA:"+circleArea);
			double probability = (circleArea-whiteArea) / circleArea;
			out.format(Locale.ENGLISH,"Case #"+(i+1)+": %.6f\n",new Object[]{new Double(probability)});
		}	
	}
	
	private double calculateWhiteArea(double R,double r,double g){
		double area = 0.;
		if (g<=0) return area;
		double x45intersect = R/Math.sqrt(2); 
//			Math.sin(45*Math.PI/180)*R;
//		System.out.println("45intersect:"+x45intersect);
		Point intersect45P = calculateIntersectX(R,x45intersect);
		double x = r;
		int n = 1;
		while(x<x45intersect){
			double areap = 0.;
			double areap1 = 0.;
			double iv = 0.;
			Point intersect1 = calculateIntersectX(R,x); 
			Point intersect2 = calculateIntersectX(R,x+g);
			double fullSquares = Math.floor((intersect1.y + r) / (2*r + g)) - (n);
			double div1 = Math.floor((intersect1.y - r) / (2*r + g));
			double ip1 = (intersect1.y - r)-(div1*(2*r+g));
			double div2 = Math.floor((intersect2.y - r) / (2*r + g));
			if (intersect2.y == -1) div2 = -1;
			double ip2 = (intersect2.y - r)-(div2*(2*r+g));
/*			if (intersect2.x == -1 || intersect2.x>intersect45P.x ){	// az utolso atlon levo haromszog felbevagva
				System.out.println(n+". oszlop 45fokos");
				fullSquares = -0.5;
				areap += ip1 * (intersect45P.x-intersect1.x) /2;
				areap += calculateArcArea(R, intersect1, intersect45P);
			}else{*/
				if (ip1 > g){
					if (ip2 > g && div1 == div2){	// nem metszi a kozt
//						System.out.println(n+". oszlop nem metszi");
						
					}else{ // jobb felso sarkot szedi le (felso es jobb oldalt metszi a kor)
						// kell a vizszintes metszespont is
//						System.out.println(n+". oszlop felso es jobb");
						fullSquares -= 1;
						Point temp = calculateIntersectY(R,(div1+1)*(2*r + g)-r);
//						System.out.println("   temp:"+temp.x+" , "+temp.y);
						/*areap += g* ip2;
						areap += (temp.x - intersect1.x) * (temp.y - intersect2.y);
						areap += (intersect2.x - temp.x) * (temp.y - intersect2.y) / 2;*/
						areap += (temp.x -intersect1.x)*g;
						areap += (g+ip2)/2*(intersect2.x -temp.x);		
						iv = calculateArcArea(R, temp, intersect2);
						areap += iv;
						
						
					}
				}
				else{
//					if (ip2 > g){	// bal also sarok marad meg (bal es also oldalt metszi a kor)
					if (div1 > div2 ){
//						System.out.println(n+". oszlop bal es also");
						Point temp = calculateIntersectY(R,(div1)*(2*r + g)+r);
						areap += (temp.x - intersect1.x) * ip1 / 2;
//						System.out.println("   temp:"+temp.x+" , "+temp.y);
						areap += (iv = calculateArcArea(R, intersect1, temp));
						if (temp.x>temp.y){
							fullSquares = -0.5;								
							areap /= 2;
						}
						else if (ip2 <= g){ // az alatta levo feherbe is belelog a metszes
							Point temp2 = calculateIntersectY(R,(div2)*(2*r + g)+r+g);	
//							System.out.println("   temp2:"+temp2.x+" , "+temp2.y);
							fullSquares -=1;
							areap1 += ( temp2.x - intersect1.x ) * g;
							areap1 += (ip2 +g)/2 * (intersect2.x - temp2.x);
							areap1 += (iv = calculateArcArea(R, temp2, intersect2));
							if (intersect2.x == -1 || intersect2.x>intersect45P.x ){
								areap1/=2;
								fullSquares = -0.5;								
							}
						}
						// kell a vizszintes metszespont is
					}else{			// keresztbe (bal es jobb oldalt metszi a kor)
//						System.out.println(n+". oszlop bal es jobb");
						areap += ip2*g + (ip1-ip2)*g/2;
						areap += (iv = calculateArcArea(R, intersect1, intersect2));
					}
				}
			//}
			area += g*g*(fullSquares+0.5);	// van fullsquares db teljes negyzet plusz az also fel
			area += areap;
			area += areap1;
//			System.out.println("   ----areap: "+areap+" , areap1:"+areap1+" , iv:"+iv);
//			System.out.println("   ("+intersect1.x+","+intersect1.y+") div1:"+div1+" , ip1:"+ip1+" , ("+intersect2.x+","+intersect2.y+") div2:"+div2+" , ip2:"+ip2);
//			System.out.println("   plusz "+(fullSquares+0.5)+" egesz negyzet");

			x=r+n*(2*r+g);
			n++;
		}
		return area;
	}
	
	private Point calculateIntersectX(double R, double x){
//		System.out.println("R:"+R+" , x:"+x);
		
		Point p = new Point();
		if (x>R){
			p.y = -1.;
			p.x = -1.;
//			System.out.println("Pont:"+p.x+" , y:"+p.y);
			return p;
		}
		p.x = x;
		p.y = Math.sqrt(R*R-x*x);
		return p;
	}
	
	private Point calculateIntersectY(double R, double y){
//		System.out.println("ISY R:"+R+" , y:"+y);
		Point p = new Point();
		if (y>R) {
			p.x = -1.;
			p.y = -1.;
//			System.out.println("Pont:"+p.x+" , y:"+p.y);
			return p;
		}
		p.y = y;
		p.x = Math.sqrt(R*R-y*y);
		return p;
	}

	// visszaadja ket pont kozotti hur es a koriv kozotti teruletet
	private double calculateArcArea(double R, Point p1, Point p2){
		double area = 0;
		double cosAlpha = ((p1.x*p2.x) + (p1.y*p2.y)) / (R*R);
		double alpha = Math.acos(cosAlpha);//*180;//Math.PI;
		area = (R*R)/2*(alpha-(Math.sqrt(1-cosAlpha*cosAlpha)));
				//Math.sin(alpha*Math.PI/180));
		return area;
	}
	
	public void finish() throws Exception{
		out.close();
		in.close();
	}

	class Point{
		public double x;
		public double y;
	}
}
