import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.Scanner;
import java.util.Vector;

public class ProblemA {
	PrintWriter out = null;
	Scanner in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			ProblemA problem = new ProblemA(new Scanner(new File(args[0])),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ProblemA(Scanner xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
		int num = in.nextInt();
		for (int caseNo = 1; caseNo <= num; caseNo++){
			int P = in.nextInt();
			int K = in.nextInt();
			int L = in.nextInt();
			if (P*K<L) {
				in.nextLine();
				out.println("Case #"+caseNo+": IMPOSSIBLE");
			}
			else{
				Vector v = new Vector();
				for(int i=0;i<L;i++){
					v.addElement(new Integer(in.nextInt()));
				}
				Collections.sort(v);
				Collections.reverse(v);
				long sum = 0;
				int multi = 1;
				for(int i=1;i<=L;i++){
					sum += ((Integer)v.elementAt(i-1)).intValue()*multi;
					if (i%K == 0) multi++;
				}
				out.println("Case #"+caseNo+": "+sum);
			}
			
		}
	}
	
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
}
