import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemC {
	PrintWriter out = null;
	Scanner in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			ProblemC problem = new ProblemC(new Scanner(new File(args[0])),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ProblemC(Scanner xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	private long[][] signs;
	
	public void generateSigns(long[] A,long n, long m, long X, long Y, long Z){
		signs = new long[(int)n][2];
		for (long i=0;i<n;i++){
			signs[(int)i][0] = A[(int)(i%m)];
//			System.out.print(" "+signs[(int)i][0]);
			A[(int)(i%m)] = (X * A[(int)(i%m)] + Y * (i + 1))%Z;
		}
//		System.out.println();
	}
	
	public void solve() throws Exception{
		int num = in.nextInt();
		for (int caseNo = 1; caseNo <= num; caseNo++){
			System.out.println("Case:"+caseNo);
			int n = in.nextInt();
			int m = in.nextInt();
			long X = in.nextInt();
			long Y = in.nextInt();
			long Z = in.nextInt();
			long[] A = new long[m];
			for(int i=0;i<m;i++){
				A[i] = in.nextInt();				
			}
			generateSigns(A,n,m,X,Y,Z);
			long sumTotal = 0;
			for(int i=n-1;i>=0;i--){
				long sign = signs[i][0];
				int sum = 1;
				for(int j = i+1; j<n;j++){
					if (sign<signs[j][0]){
						sum += signs[j][1];
						sum = sum%1000000007;
					}
				}
				signs[i][1] = sum;
				sumTotal += sum;
				sumTotal = sumTotal%1000000007;
			}
			out.println("Case #"+caseNo+": "+sumTotal);
		}
	}
	
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
}
