import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemA {
	PrintWriter out = null;
	Scanner in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			ProblemA problem = new ProblemA(new Scanner(new File(args[0])),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ProblemA(Scanner xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
		int L = in.nextInt();
		int D = in.nextInt();
		int N = in.nextInt();
		in.nextLine();
		String[][] languageTokens = new String[D][];
		for (int i=0;i<D;i++){
			String word = in.nextLine();
			languageTokens[i] = (new WordTokenizer(word,L)).getTokens();
		}		
		for (int caseNo = 1; caseNo <= N; caseNo++){
			String pattern = in.nextLine();
			String[] patternTokens = (new WordTokenizer(pattern,L)).getTokens(); 
			int match = 0;
			for (int j=0;j<D;j++){
				if (match(languageTokens[j],patternTokens)){
					match++;
				}
			}
			out.println("Case #"+caseNo+": "+match);
		}
	}
	
	private boolean match(String[] xWordTokens, String[] xPatternTokens){
		for(int i=0;i<xWordTokens.length;i++){
			if (xPatternTokens[i].indexOf(xWordTokens[i]) == -1) return false;
		}
		return true;
	}
	
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
	
	
	class WordTokenizer{
		private String[] mTokens = null;
		
		WordTokenizer(String xWord, int xL){
			mTokens = new String[xL];
			String token = "";
			int tokenNo = 0;
			boolean multiple = false;
			for (int i=0;i<xWord.length();i++){
				if (xWord.charAt(i)=='(') multiple = true;
				else if (xWord.charAt(i)==')') {
					multiple = false;
					mTokens[tokenNo++] = token;
					token = "";
				}
				else{
					if (!multiple) mTokens[tokenNo++]=""+xWord.charAt(i);						
					else token+=xWord.charAt(i);
				}
			}
		}
		
		String[] getTokens(){
			return mTokens;
		}		
	}
}
