import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.Vector;

public class ProblemB {
	PrintWriter out = null;
	Scanner in = null;
	
	public static void main(String[] args){
		if (args.length != 2) System.out.println("Program needs 2 arguments (input file, output file)");
		try{
			ProblemB problem = new ProblemB(new Scanner(new File(args[0])),new PrintWriter(args[1]));
			problem.solve();
			problem.finish();
		}catch(Exception e){
			e.printStackTrace();
		}
	}
	
	public ProblemB(Scanner xIn,PrintWriter xOut){
		in = xIn;
		out=xOut;
	}
	
	public void solve() throws Exception{
		int N = in.nextInt();
		in.nextLine();
		String welcome = "welcome to code jam";
		for (int caseNo = 1; caseNo <= N; caseNo++){
			String line = in.nextLine();
			line = filterLine(line, welcome);
			int res = countPossibleMatch(line, welcome);
			out.println("Case #"+caseNo+": "+lPad(""+res,"0",4));
		}
	}
	
	private int countPossibleMatch(String xLine, String xWelcome){
		Vector prev = null;
		Vector act = null;
		for (int i=xWelcome.length()-1;i>=0;i--){
			act = new Vector();
			char c = xWelcome.charAt(i);
			int pos = xLine.length();
			while(pos != -1){
				pos = xLine.lastIndexOf(c,pos-1);
				if (pos != -1){
					if (prev == null) act.addElement(new int[]{pos,1});
					else{
						int actCount = 0;
						for (int j=0;j<prev.size();j++){
							int[] prevArr = (int[])prev.elementAt(j);
							if (prevArr[0]<pos) break;
							actCount = (actCount + prevArr[1]) % 10000;
						}
						act.addElement(new int[]{pos,actCount});
					}
				}
			}
			prev = act;
		}
		int count = 0;
		for (int i=0;i<prev.size();i++){
			int[] prevArr = (int[])prev.elementAt(i);
			count = (count + prevArr[1]) % 10000;
		}
		return count;
	}
	
	private String filterLine(String xLine, String xFilter){
		StringBuffer sb = new StringBuffer();
		for (int i=0;i<xLine.length();i++){
			if (xFilter.indexOf(xLine.charAt(i))!=-1) sb.append(xLine.charAt(i));
		}
		return sb.toString();
	}
	
	private String lPad(String xStr,String xChar, int xLength){
		String ret = "";
		int l = xLength-xStr.length();
		for(int i=0;i<l;i++) ret+=xChar;
		ret += xStr;
		return ret;
	}
	
	public void finish() throws Exception{
		out.close();
		in.close();
	}
	
}
