import java.util.*;
import java.io.*;

public class Main {

	// Class

	// Main Method
	public static void main(String[] args) throws FileNotFoundException  {
		InputReader in = new InputReader("input.txt");
		// InputReader in = new InputReader(System.in);

		int T = in.readInt();
		final Solver solver = new Solver();
		for(int i = 0; i < T; i++) {
			String n = in.readString();
			IOUtils.print("Case #" + (i+1) + ": " + solver.solve(n));
		}
	}
}

class Solver {
	public String solve(String n) {
		int result = 0;
		int l = n.length();
		for(int i = 0; i < l; i++) {

			if(n.charAt(i) == '-') {
				result++;

				int lastMinus = findLast(n, i + 1, '-');
				if(lastMinus == l - 1) {
					break;
				} else {
					i = lastMinus;
				}
			} else {				
				int lastPlus = findLast(n, i + 1, '+');
				if(lastPlus == l - 1) {
					break;
				} else {
					result++;
					i = lastPlus;
				}
			}
		}

		return result + "";
	}


	private int findLast(String n, int startIdx, char toFind) {
		for(int i = startIdx; i < n.length(); i++) {
			if(n.charAt(i) != toFind) {
				return i - 1;
			}
		}

		return n.length() - 1;
	}
}






class InputReader {
 
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public InputReader(String fileName) throws FileNotFoundException {
		InputStream is = new FileInputStream(fileName);
		this.stream = is;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	public boolean isSpaceChar(int c) {
		if (filter != null)
			return filter.isSpaceChar(c);
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public String next() {
		return readString();
	}

	public interface SpaceCharFilter {
		public boolean isSpaceChar(int ch);
	}
}
 
class IOUtils {

	public static String[] readStringArray(InputReader in, int size) {
		String[] array = new String[size];
		for(int i = 0; i < size; i++) {
			array[i] = in.readString();
		}

		return array;
	}

	public static int[] readIntArray(InputReader in, int size) {
		int[] array = new int[size];
		for (int i = 0; i < size; i++)
			array[i] = in.readInt();
		return array;
	}

	public static void print(Object message) {		
		System.out.println(message);
	}
}