import java.util.*;
import java.io.*;

public class Main {

	// Class

	// Main Method
	public static void main(String[] args) throws FileNotFoundException  {
		InputReader in = new InputReader("input.in");
		// InputReader in = new InputReader(System.in);

		int T = in.readInt();
		final Solver solver = new Solver();
		for(int i = 0; i < T; i++) {
			String c = in.readString();
			String j = in.readString();
			IOUtils.print("Case #" + (i+1) + ": " + solver.solve(c, j));
		}
	}
}

	class Solver {
        public String solve(String C, String J) {
            String resultC = "";
            String resultJ = "";

            int prevC = -1;
            int prevJ = -1;

            int curC = -1;
            int curJ = -1;

            boolean cLeftOut = false;
            boolean jLeftOut = false;

            for(int i = 0; i < C.length(); i++) {
                char c = C.charAt(i);
                char j = J.charAt(i);

                if(c == '?' && j == '?') {

                    if(cLeftOut) {
                        curC = 9;
                        curJ = 0;
                    } else if (jLeftOut) {
                        curJ = 9;
                        curC = 0;
                    } else {
                        curJ = 0;
                        curC = 0;
                    }
                } else if(c == '?') {
                    curJ =  Integer.parseInt(j + "");

                    if(cLeftOut) {
                        curC = 9;
                    } else if(jLeftOut) {
                        curC = 0;
                    } else {
                        if(i < C.length() - 1) {
                            curC = getDigitConsiderNextC(C.charAt(i), J.charAt(i), curJ);
                        } else {
                            curC = curJ;
                        }
                    }
                } else if(j == '?') {
                    curC =  Integer.parseInt(c + "");

                    if(cLeftOut) {
                        curJ = 0;
                    } else if(jLeftOut) {
                        curJ = 9;
                    } else {
                        if(i < C.length() - 1) {
                            curJ = getDigitConsiderNextJ(C.charAt(i), J.charAt(i), curC);
                        } else {
                            curJ = curC;
                        }
                    }
                } else {
                    curC = Integer.parseInt(c + "");
                    curJ = Integer.parseInt(j + "");
                }

                resultC += curC;
                resultJ += curJ;

                prevC = curC;
                prevJ = curJ;

                if((!cLeftOut && !jLeftOut)) {
                    if(prevC < prevJ) {
                        cLeftOut = true;
                        jLeftOut = false;
                    } else if(prevC > prevJ) {
                        cLeftOut = false;
                        jLeftOut = true;
                    }
                }
            }

            return resultC + " " + resultJ;
        }

        private int getDigitConsiderNextC(char nextSelf, char nextPartner, int currentJ) {
            int nextC = nextSelf == '?' ? -1 : Integer.parseInt(nextSelf + "");
            int nextJ = nextPartner == '?' ? -1 : Integer.parseInt(nextPartner + "");

            if(nextC == -1 || nextJ == -1) {
                return currentJ;
            }

            if(nextC > nextJ) {
                if(nextC - nextJ >= 5 || currentJ == 0) {
                    return currentJ - 1;
                } else {
                    return currentJ;
                }
            } else {
                if(nextJ - nextC <= 5 || currentJ == 9) {
                    return currentJ;
                } else {
                    return currentJ + 1;
                }
            }
        }

        private int getDigitConsiderNextJ(char nextCCh, char nextJCh, int currentC) {
            int nextC = nextCCh == '?' ? 0 : Integer.parseInt(nextCCh + "");
            int nextJ = nextJCh == '?' ? 0 : Integer.parseInt(nextJCh + "");

            if(nextC == -1 || nextJ == -1) {
                return currentC;
            }


            if(nextC > nextJ) {
                if(nextC - nextJ > 5 && currentC < 9) {
                    return currentC + 1;
                } else {
                    return currentC;
                }
            } else {
                if(nextJ - nextC >= 5 && currentC > 0) {
                    return currentC - 1;
                } else {
                    return currentC;
                }
            }
        }
    }






class InputReader {
 
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public InputReader(String fileName) throws FileNotFoundException {
		InputStream is = new FileInputStream(fileName);
		this.stream = is;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	public boolean isSpaceChar(int c) {
		if (filter != null)
			return filter.isSpaceChar(c);
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public String next() {
		return readString();
	}

	public interface SpaceCharFilter {
		public boolean isSpaceChar(int ch);
	}
}
 
class IOUtils {

	public static String[] readStringArray(InputReader in, int size) {
		String[] array = new String[size];
		for(int i = 0; i < size; i++) {
			array[i] = in.readString();
		}

		return array;
	}

	public static int[] readIntArray(InputReader in, int size) {
		int[] array = new int[size];
		for (int i = 0; i < size; i++)
			array[i] = in.readInt();
		return array;
	}

	public static void print(Object message) {		
		System.out.println(message);
	}
}