import java.util.*;
import java.io.*;

public class Main {

	// Class

	// Main Method
	public static void main(String[] args) throws FileNotFoundException  {
		InputReader in = new InputReader("input.in");
		// InputReader in = new InputReader(System.in);

		int T = in.readInt();
		final Solver solver = new Solver();
		for(int i = 0; i < T; i++) {
			String n = in.readString();
			IOUtils.print("Case #" + (i+1) + ": " + solver.solve(n));
		}
	}
}

class Solver {

        private HashMap<Character, Integer> map = new HashMap<>();

        public String solve(String s) {
            int[] numberOfDigit = new int[10];
            char[] charArr = s.toCharArray();

            for(char a : charArr) {
                if(map.containsKey(a)) {
                    map.put(a, map.get(a) + 1);
                } else {
                    map.put(a, 1);
                }
            }

            if(map.containsKey('Z')) {
                int total = map.get('Z');
                reduceEachChar("ZERO", total);
                numberOfDigit[0] = total;
            }

            if(map.containsKey('W')) {
                int total = map.get('W');
                reduceEachChar("TWO", total);
                numberOfDigit[2] = total;
            }

            if(map.containsKey('U')) {
                int total = map.get('U');
                reduceEachChar("FOUR", total);
                numberOfDigit[4] = total;
            }

            if(map.containsKey('O')) {
                int total = map.get('O');
                reduceEachChar("ONE", total);
                numberOfDigit[1] = total;
            }

            if(map.containsKey('R')) {
                int total = map.get('R');
                reduceEachChar("THREE", total);
                numberOfDigit[3] = total;
            }

            if(map.containsKey('F')) {
                int total = map.get('F');
                reduceEachChar("FIVE", total);
                numberOfDigit[5] = total;
            }

            if(map.containsKey('X')) {
                int total = map.get('X');
                reduceEachChar("SIX", total);
                numberOfDigit[6] = total;
            }

            if(map.containsKey('V')) {
                int total = map.get('V');
                reduceEachChar("SEVEN", total);
                numberOfDigit[7] = total;
            }

            if(map.containsKey('G')) {
                int total = map.get('G');
                reduceEachChar("EIGHT", total);
                numberOfDigit[8] = total;
            }

            if(map.containsKey('I')) {
                int total = map.get('I');
                reduceEachChar("NINE", total);
                numberOfDigit[9] = total;
            }
            
            String result = "";
            for(int i = 0; i < numberOfDigit.length; i++) {
                result += repeat(i+"", numberOfDigit[i]);
            }
            
            return result;
            
        }

        private void reduceEachChar(String digit, int total) {
            for(int i = 0; i < digit.length(); i++) {
                char c = digit.charAt(i);
                map.put(c, map.get(c) - total);

                if(map.get(c) == 0) {
                	map.remove(c);
                }
            }
        }
        
        private String repeat(String string, int recurrence) {
            
            String res = "";
            for(int i = 0; i < recurrence; i++) {
                res += string;
            }

            return res;
        }
    }

class InputReader {
 
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public InputReader(String fileName) throws FileNotFoundException {
		InputStream is = new FileInputStream(fileName);
		this.stream = is;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	public boolean isSpaceChar(int c) {
		if (filter != null)
			return filter.isSpaceChar(c);
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public String next() {
		return readString();
	}

	public interface SpaceCharFilter {
		public boolean isSpaceChar(int ch);
	}
}
 
class IOUtils {

	public static String[] readStringArray(InputReader in, int size) {
		String[] array = new String[size];
		for(int i = 0; i < size; i++) {
			array[i] = in.readString();
		}

		return array;
	}

	public static int[] readIntArray(InputReader in, int size) {
		int[] array = new int[size];
		for (int i = 0; i < size; i++)
			array[i] = in.readInt();
		return array;
	}

	public static void print(Object message) {		
		System.out.println(message);
	}
}