import java.util.*;
import java.io.*;
import java.nio.charset.*;
import java.nio.file.*;

public class Main {

	// Class

	// Main Method
	public static void main(String[] args) throws FileNotFoundException  {
		InputReader in = new InputReader("input.in");
		
		int T = in.readInt();
		final Solver solver = new Solver();
		String[] ans = new String[T];
		for(int i = 0; i < T; i++) {
			int N = in.readInt();
			int[] senats = new int[N];
			int total = 0;
			for(int j = 0; j < N; j++) {
				senats[j] = in.readInt();
				total += senats[j];
			}

			ans[i] = "Case #" + (i+1) + ": " + solver.solve(total, senats);
		}

		IOUtils.write("output.out", ans);
	}
}

class Solver {
     public String solve(int total, int[] senats) {
        String result = "";
        while(true) {
            int firstIdx = getMaxIdx(senats);
            if(firstIdx == -1) {
                break;
            }
            senats[firstIdx]--;

            int secondIdx = getMaxIdx(senats);
            senats[secondIdx]--;

            if(moreThanHalf(senats)) {
                senats[secondIdx]++;
                secondIdx = -1;
            }

            result += getAlphabet(firstIdx) + "" + (secondIdx == -1 ? "" : getAlphabet(secondIdx));
            result += " ";
        }

        return result;
    }

    // 2 2 1
    // 1 1 1

    private boolean moreThanHalf(int[] senats) {
        int total = 0;
        for (int i = 0; i < senats.length; i++) {
            total += senats[i];
        }
        int half = total / 2;

        for (int i = 0; i < senats.length; i++) {
            if(senats[i] > half) {
                return true;
            }
        }

        return false;
    }

    private int getMaxIdx(int[] senats) {
        int idx = 0;
        for (int i = 1; i < senats.length; i++) {
            if(senats[idx] < senats[i]) {
                idx = i;
            }
        }

        if(senats[idx] == 0) {
            return -1;
        }

        return idx;
    }

    private char getAlphabet(int pos) {
        return (char) (65 + pos);
    }
}

class InputReader {
 
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public InputReader(String fileName) throws FileNotFoundException {
		InputStream is = new FileInputStream(fileName);
		this.stream = is;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuilder res = new StringBuilder();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	public boolean isSpaceChar(int c) {
		if (filter != null)
			return filter.isSpaceChar(c);
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public String next() {
		return readString();
	}

	public interface SpaceCharFilter {
		public boolean isSpaceChar(int ch);
	}
}
 
class IOUtils {

	public static String[] readStringArray(InputReader in, int size) {
		String[] array = new String[size];
		for(int i = 0; i < size; i++) {
			array[i] = in.readString();
		}

		return array;
	}

	public static int[] readIntArray(InputReader in, int size) {
		int[] array = new int[size];
		for (int i = 0; i < size; i++)
			array[i] = in.readInt();
		return array;
	}

	public static void print(Object message) {		
		System.out.println(message);
	}

	public static void write(String fileName, String[] contents) {
		List<String> lines = Arrays.asList(contents);
		Path file = Paths.get(fileName);
		try {
			Files.write(file, lines, Charset.forName("UTF-8"));
		} catch (IOException e) {
			print("ERROR: " + e.getMessage());
			e.printStackTrace();
		}
	}
}


