import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;



public class ProblemA {
	enum Mode {SAMPLE,SMALL,LARGE}

	static Mode mode = Mode.SMALL;

	Scanner in;
	PrintStream out;

	public static void main(String[] args) throws FileNotFoundException {
		new ProblemA().run();
	}

	public void run() throws FileNotFoundException {

		switch (mode) {
			case SAMPLE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Documents/Taktik/Sources/problems/files/ina")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/A-sample.out"));
				break;
			case SMALL:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/A-small-attempt0.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/A-small.out"));
				break;
			case LARGE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/A-large.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/A-large.out"));
				break;
			default:
				throw new IllegalStateException();
		}

		int size = in.nextInt();

		for (int p = 0 ; p < size ; p++) {
			out.print("Case #" + (p+1) + ": ");
			long distance = in.nextLong();
			long nbHorses = in.nextLong();

			List<PS> ps =new ArrayList<>();

			for (int i = 0; i < nbHorses; i++) {
				ps.add(new PS(distance-in.nextLong(), in.nextLong()));
			}

			out.println(solve(distance, ps));
		}
		out.close();
	}

	public String solve(long distance, List<PS> ps) {

		Collections.sort(ps, new Comparator<PS>() {
			@Override
			public int compare(PS o1, PS o2) {
				return Long.compare(o1.pos, o2.pos);
			}
		});

		double time = (ps.get(0).pos * 1.0) / ps.get(0).speed;

		for (int i = 1 ; i< ps.size() ; i++) {
			PS prev = ps.get(i - 1);
			PS cur = ps.get(i);
			double lastSpeed = prev.pos / time;

			if (cur.speed > lastSpeed) {
				double t = (prev.pos-cur.pos)/((prev.pos/time)-cur.speed);
				if (t > time) {
					time = (cur.pos *1.0) / cur.speed;
				} else {
					double left = prev.pos-(prev.pos/time)*t;
					time = t + (left/(prev.pos/time));
				}
			} else {
				time = (cur.pos *1.0) / cur.speed;
			}
		}
		return "" + (distance / time);
	}


	class PS {
		long pos;
		long speed;

		public PS(long pos, long speed) {
			this.pos = pos;
			this.speed = speed;
		}
	}

}
