import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;


public class ProblemC {

	static BigInteger TWO = BigInteger.valueOf(2);

	enum Mode {SAMPLE,SMALL1,SMALL2,LARGE}

	static Mode mode = Mode.LARGE;

	Scanner in;
	PrintStream out;

	public static void main(String[] args) throws FileNotFoundException {
		new ProblemC().run();
	}

	public void run() throws FileNotFoundException {

		switch (mode) {
			case SAMPLE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Documents/Taktik/Sources/problems/files/inc")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/C-sample.out"));
				break;
			case SMALL1:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/C-small-1-attempt0.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/C-small.out"));
				break;
			case SMALL2:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/C-small-2-attempt0.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/C-small-2.out"));
				break;
			case LARGE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/C-large.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/C-large.out"));
				break;
			default:
				throw new IllegalStateException();
		}

		int size = in.nextInt();

		for (int p = 0 ; p < size ; p++) {
			out.println("Case #" + (p+1) + ": " + solve(in.nextBigInteger(), in.nextBigInteger()));
		}
		out.close();
	}

	public String solve(BigInteger stalls, BigInteger p) {
		BigInteger powerOfTwo = TWO.pow(p.bitLength() - 1);
		BigInteger diff = p.subtract(powerOfTwo);
		if (!diff.equals(BigInteger.ZERO)) {
			return solve(stalls.subtract(diff), powerOfTwo);
		}
		BigInteger[] maxAndReminder = stalls.divideAndRemainder(p.multiply(TWO));
		boolean b = stalls.testBit(p.bitLength()-1);
		BigInteger max = maxAndReminder[0];
		BigInteger min = b ? max : max.subtract(BigInteger.ONE);
		return "" + max + " " + min;
	}

}
