import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.IdentityHashMap;
import java.util.Scanner;



public class ProblemA {
	enum Mode {SAMPLE,SMALL,LARGE}

	static Mode mode = Mode.SMALL;

	Scanner in;
	PrintStream out;

	public static void main(String[] args) throws FileNotFoundException {
		new ProblemA().run();
	}

	public void run() throws FileNotFoundException {

		switch (mode) {
			case SAMPLE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Documents/Taktik/Sources/problems/files/ina")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/A-sample.out"));
				break;
			case SMALL:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/A-small-attempt0.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/A-small.out"));
				break;
			case LARGE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/A-large.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/A-large.out"));
				break;
			default:
				throw new IllegalStateException();
		}

		int size = in.nextInt();

		for (int p = 0 ; p < size ; p++) {
			out.print("Case #" + (p+1) + ": ");
			String cakes = in.next();
			boolean[] state = new boolean[cakes.length()];
			char[] chars = cakes.toCharArray();
			for (int i = 0; i < chars.length; i++) {
				state[i] = chars[i] == '+';
			}
			int flipperSize = in.nextInt();
			out.println(solve(state, flipperSize));
		}
		out.close();
	}

	public String solve(boolean[] state, int flipperSize) {
		int idx = 0;
		int cs = state.length;
		int steps = 0;
		while (true) {
			while (idx<cs && state[idx]) {
				idx++;
			}
			if (idx >= cs) {
				break;
			}
			if (idx > (cs  - flipperSize)) {
				if (!state[idx]) {
							steps = -1;
							break ;
				}
			}
			for (int i = 0 ; i < flipperSize ; i++) {
				state[idx + i] = !state[idx + i];
			}
			idx++;
			steps++;
		}
		return steps == -1 ? "IMPOSSIBLE" : Integer.toString(steps);
	}



}
