import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.PrintStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Scanner;


public class ProblemB {
	enum Mode {SAMPLE,SMALL,LARGE}

	static Mode mode = Mode.SMALL;

	Scanner in;
	PrintStream out;

	public static void main(String[] args) throws FileNotFoundException {
		new ProblemB().run();
	}

	public void run() throws FileNotFoundException {

		switch (mode) {
			case SAMPLE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Documents/Taktik/Sources/problems/files/inb")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/B-sample.out"));
				break;
			case SMALL:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/B-small-attempt0.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/B-small.out"));
				break;
			case LARGE:
				in = new Scanner(new BufferedReader(new FileReader("/Users/abaudoux/Downloads/B-large.in")));
				out = new PrintStream(new FileOutputStream("/Users/abaudoux/Documents/Taktik/Sources/problems/files/B-large.out"));
				break;
			default:
				throw new IllegalStateException();
		}

		int size = in.nextInt();

		for (int p = 0 ; p < size ; p++) {
			out.println("Case #" + (p+1) + ": " + solve(in.next()));
		}
		out.close();
	}

	public String solve(String n) {

		int ds = n.length();
		int[] digits = new int[ds];
		for (int i = 0; i < n.length(); i++) {
			digits[i] = Integer.parseInt(n.substring(i, i + 1));
		}

		if (ds == 1) {
			return toString(digits);
		}

		int idx = 1;
		while (idx < ds && digits[idx] >= digits[idx - 1]) {
			idx++;
		}

		if (idx == ds) {
			return toString(digits);
		}

		idx--;
		while (idx > 0 && (digits[idx] == digits[idx - 1])) {
			idx--;
		}

		digits[idx]--;
		for (idx = idx + 1 ; idx < ds ; idx++) {
			digits[idx] = 9;
		}

		return toString(digits);
	}

	private String toString(int[] digits) {
		StringBuilder sb = new StringBuilder();
		int idx = 0;
		while (idx < digits.length && digits[idx] == 0) {
			idx++;
		}
		if (idx == digits.length) {
			return "0";
		}
		while (idx < digits.length) {
			sb.append(digits[idx++]);
		}
		return sb.toString();
	}
}
