import java.util.*;
import java.io.*;

public class ProblemA {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner input = new Scanner(new File("A-large.in"));
		
		int numberOfCases = Integer.parseInt(input.nextLine());
		for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
			
			char[][] grid = new char[4][4];
			for (int i = 0; i < 4; i++) {
				String line = input.nextLine();
				for (int letter = 0; letter < 4; letter++) {
					grid[i][letter] = line.charAt(letter);
				}
			}
			
			String winner = checkGrid(grid);
			if (winner.equals("Game has not completed") || winner.equals("Draw")) {
				System.out.println("Case #" + caseNumber + ": " + winner);
			} else {
				System.out.println("Case #" + caseNumber + ": " + winner + " won");
			}
			
			if (input.hasNextLine()) { 
				input.nextLine();
			}
		}
	}

	public static String checkGrid(char[][] grid) {
		
		String result = "Game has not completed";
		boolean winner = false;
		boolean incomplete = false;
		
		// Horizontal
		for (int row = 0; row < 4 && !winner; row++) {
			char prev = grid[row][0];
			boolean valid = true;
			char line = prev;
			for (int col = 1; col < 4; col++) {
				char cur = grid[row][col];
				
				if (prev == '.' || cur == '.') {
					incomplete = true;
				}
				
				if (prev != cur && cur != 'T' && prev != 'T' || cur == '.') {
					valid = false;
				}
				
				if ((prev == cur || cur == 'T' || prev == 'T') && col == 3 && valid) {
					if (prev != 'T') {
						result = "" + prev;
					} else {
						result = "" + cur;
					}
					winner = true;
				}
				prev = cur;
			}
		}
		
		// Vertical
		for (int col = 0; col < 4 && !winner; col++) {
			boolean valid = true;
			char prev = grid[0][col];
			for (int row = 1; row < 4; row++) {
				char cur = grid[row][col];
				
				if (prev == '.' || cur == '.') {
					incomplete = true;
				}
				
				if (prev != cur && cur != 'T' && prev != 'T' || cur == '.') {
					valid = false;
				}
				
				if ((prev == cur || cur == 'T' || prev == 'T') && row == 3 && valid) {
					if (prev != 'T') {
						result = "" + prev;
					} else {
						result = "" + cur;
					}
					winner = true;
				}
				prev = cur;
			}
		}

		List<Character> diag1 = new ArrayList<Character>();
		List<Character> diag2 = new ArrayList<Character>();

		diag1.add(grid[0][0]);
		diag1.add(grid[1][1]);
		diag1.add(grid[2][2]);
		diag1.add(grid[3][3]);
		
		diag2.add(grid[0][3]);
		diag2.add(grid[1][2]);
		diag2.add(grid[2][1]);
		diag2.add(grid[3][0]);

		if (!winner) {
			boolean valid = true;
			for (int i = 1; i < 4; i++) {
				char prev = diag1.get(i - 1);
				char cur = diag1.get(i);
				if ((prev != cur && cur != 'T' && prev != 'T') || prev == '.' || cur == '.') {
					valid = false;
				}
				if ((prev == cur || cur == 'T' || prev == 'T') && i == 3 && valid) {
					if (prev != 'T') {
						result = "" + prev;
					} else {
						result = "" + cur;
					}
					winner = true;
				}
			}
		}
		
		if (!winner) {
			boolean valid = true;
			for (int i = 1; i < 4; i++) {
				char prev = diag2.get(i - 1);
				char cur = diag2.get(i);
				if ((prev != cur && cur != 'T' && prev != 'T') || prev == '.' || cur == '.') {
					valid = false;
				}
				if ((prev == cur || cur == 'T' || prev == 'T') && i == 3 && valid) {
					if (prev != 'T') {
						result = "" + prev;
					} else {
						result = "" + cur;
					}
					winner = true;
				}
			}
		}
		
		if (incomplete && !winner) {
			return "Game has not completed";
		} else if (!incomplete && !winner) {
			return "Draw";
		}
		return result;
	}
}
