import java.util.*;
import java.io.*;

public class ProblemB {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner input = new Scanner(new File("C-small-attempt0.in"));
		int numberOfCases = input.nextInt();
		List<Integer> mins = new ArrayList<Integer>();
		List<Integer> maxes = new ArrayList<Integer>();
		
		for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
			mins.add(input.nextInt());
			maxes.add(input.nextInt());
		}
		
		Set<Integer> sieve = createSieve(1000); // Small: 1000, Large_1: 10 ^ 14, Large_2: 10 ^ 100
		
		for (int i = 0; i < numberOfCases; i++) {
			int min = mins.get(i);
			int max = maxes.get(i);
			
			int count = 0;
			
			for (int j = min; j <= max; j++) {
				if (sieve.contains(j)) {
					count++;
				}
			}	
			System.out.println("Case #" + (i + 1) + ": " + count);
		}
	}
	
	// Creates a sieve from 1 to max
	public static Set<Integer> createSieve(int max) {
		Set<Integer> sieve = new TreeSet<Integer>();
		int product = 1;
		int count = 1;
		while (product <= max) {
			if (isPalindrome(count) && isPalindrome(product)) {
				sieve.add(product);
			}
			count++;
			product = count * count;
		}
		return sieve;
	}
	
	public static boolean isPalindrome(int num) {
		String number = Integer.toString(num);
		int left = 0;
		int right = number.length() - 1;

		while (left < right) {
		    if (number.charAt(left) != number.charAt(right))
		        return false;
		    left++;
		    right--;
		}
		return true;
	}
}
