import java.util.*;
import java.io.*;
import java.math.BigInteger;

public class ProblemC {

	public static final BigInteger MAX_BOUND = new BigInteger("100000000000000");
	public static final BigInteger GOOGLE = new BigInteger(new BigInteger("10").pow(100).toString());
	
	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new File("C-large-1.in"));
		BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));
		int numberOfCases = input.nextInt();
		
		Set<BigInteger> sieve = createSieve(MAX_BOUND.divide(new BigInteger("2"))); // Small: 1000, Large_1: 10 ^ 14, Large_2: 10 ^ 100
		
		for (int i = 0; i < numberOfCases; i++) {
			BigInteger min = new BigInteger(input.next());
			BigInteger max = new BigInteger(input.next());
			
			int count = 0;
			
			for (BigInteger number : sieve) {
				int compareMin = number.compareTo(min);
				int compareMax = number.compareTo(max);
				if (compareMin >= 0 && compareMax <= 0) {
					count++;
				}
			}	
			output.write("Case #" + (i + 1) + ": " + count + "\n");
		}
		output.close();
	}
	
	// Creates a palindromic sieve from 1 to max
	public static Set<BigInteger> createSieve(BigInteger max) {
		Set<BigInteger> sieve = new HashSet<BigInteger>();
		
		BigInteger product = new BigInteger("1");
		BigInteger count = new BigInteger("1");
		BigInteger one = new BigInteger("1");
		
		while (product.compareTo(max) <= 0) {
			if (isPalindrome(count) && isPalindrome(product)) {
				sieve.add(product);
			}
			count = count.add(one);
			product = count.multiply(count);
		}
		return sieve;
	}
	
	public static boolean isPalindrome(BigInteger num) {
		String number = num.toString();
		int left = 0;
		int right = number.length() - 1;

		while (left < right) {
		    if (number.charAt(left) != number.charAt(right))
		        return false;
		    left++;
		    right--;
		}
		return true;
	}
}
