package utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * @author salami 
 * Classe utilitaire
 */
public class Utils {
	// Les fonctions lireChaine et lireEntier
	// Exemple dutilisation :
	// String nom = Utils.lireChaine("Entrez votre nom : ");
	public static String lireChaine(String question) {
		InputStreamReader ir = new InputStreamReader(System.in);
		BufferedReader br = new BufferedReader(ir);
		System.out.print(question);
		System.out.flush();
		String reponse = "";
		try {
			reponse = br.readLine();
		} catch (IOException ioe) {
		}
		return reponse;
	}

	// La lecture dun entier nest quun parseInt de plus !!
	public static int lireEntier(String question) {
		return Integer.parseInt(lireChaine(question));
	}

	// criture dune chane dans un BufferedWriter
	public static void saveString(BufferedWriter bw, String s) {
		try {
			bw.write(s);
			bw.newLine();
		} catch (IOException ioe) {
		}
	}

	// criture dun entier : on convertit en chane et on se ramne
	//  la procdure prcdente
	public static void saveInt(BufferedWriter bw, int i) {
		Integer q = new Integer(i);
		saveString(bw, q.toString());
	}

	// criture dun double : on convertit en chane et on se ramne
	//  la procdure prcdente
	public static void saveDouble(BufferedWriter bw, double d) {
		Double q = new Double(d);
		saveString(bw, q.toString());
	}

	// ouverture en criture dun fichier
	// rend un BufferedWriter -- null si pas possible de louvrir
	public static BufferedWriter openWriteFile(File f) {
		BufferedWriter bw = null;
		try {
			FileWriter fw = new FileWriter(f);
			bw = new BufferedWriter(fw);
		} catch (IOException ioe) {
		}
		if (bw == null)
			System.out.println(f.getAbsolutePath());
		return bw;
	}

	// ouverture en lecture dun fichier
	// rend un BufferedReader -- null si pas possible de louvrir
	public static BufferedReader openReadFile(File f) {
		BufferedReader br = null;
		try {
			FileReader fr = new FileReader(f);
			br = new BufferedReader(fr);
		} catch (IOException ioe) {
		}
		return br;
	}

	// lecture dans un BufferedReader dune chane de caractres
	public static String loadString(BufferedReader br) {
		String s = "";
		try {
			s = br.readLine();
		} catch (IOException ioe) {
		}
		return s;
	}

	// lecture dun entier dans un BufferedReader
	public static int loadInt(BufferedReader br) {
		return Integer.parseInt(loadString(br));
	}

	// lecture dun double dans un BufferedReader
	public static double loadDouble(BufferedReader br) {
		return Double.parseDouble(loadString(br));
	}
	//
	public static int compte(BufferedReader b){
		int j=0;
		while(b!=null){
			j++;
			try {
				b.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			
		}
		
		
		return j-1;
		}
}