package code;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class FairSquare {

	private List<ArrayList<Long>> l;
	private int gensize = 0;

	public FairSquare() {
		l = new ArrayList<ArrayList<Long>>(100);
		l.add(0, new ArrayList<Long>(0));
		ArrayList<Long> l1 = new ArrayList<Long>(10);
		for (Long i = 0L; i < 10; i++)
			l1.add(i);
		l.add(1, l1);
		gensize = 1;
	}

	public ArrayList<Long> generatePalindromes(int size) {
		return genPalindromes(size);
	}

	private ArrayList<Long> genPalindromes(int size) {
		if (size == 1) return l.get(1);
		long min = (long) Math.pow(10, size - 1);
		if (size % 2 == 0) {
			int idx = size / 2;
			Grow(idx);
			ArrayList<Long> tmp = l.get(idx);
			ArrayList<Long> gen = new ArrayList<Long>(2 * tmp.size());

			for (Long s : tmp) {
				StringBuilder ss = new StringBuilder();
				ss.append(s);
				Long sv = Long.parseLong(("" + s) + ss.reverse().toString());
				if (sv >= min) gen.add(sv);
			}
			return gen;
		} else {
			int idx = size / 2;
			Grow(idx);
			ArrayList<Long> tmp = l.get(idx);
			ArrayList<Long> gen = new ArrayList<Long>(2 * tmp.size());
			for (Long s : tmp) {
				StringBuilder ss = new StringBuilder();
				ss.append(s);
				StringBuilder sr = ss.reverse();
				for (int i = 0; i < 10; i++) {
					Long sv = Long.parseLong(("" + s + "" + i + sr.toString()));
					if (sv >= min) gen.add(sv);
				}
			}
			return gen;
		}
	}

	public void Grow(int size) {
		for (int i = gensize + 1; i <= size; i++)
			grow(i);
		size = Math.max(gensize, size);
	}

	private void grow(int size) {
		ArrayList<Long> tmp = l.get(size - 1);
		ArrayList<Long> gen = new ArrayList<Long>(10 * tmp.size());
		for (Long s : tmp) {
			for (int i = 0; i < 10; i++)
				gen.add((s * 10) + i);
		}
		l.add(size, gen);
	}

	public void Print() {
		int count = 0;
		System.out.println("<DATA>");
		for (ArrayList<Long> ll : l) {
			System.out.println("\nSIZE : " + count++);
			for (Long s : ll) {
				System.out.print(s + " , ");
			}
		}
		System.out.println("\n</END DATA>");
	}

	public void Print(ArrayList<Long> ll) {
		System.out.println("SIZE = " + ll.size());
		System.out.println("<DATA>");
		for (Long s : ll) {
			System.out.print(s + " , ");
		}
		System.out.println("\n</END DATA>");
	}

	public boolean checkPal(Long v) {
		char[] ss = v.toString().toCharArray();
		int size = ss.length;
		for (int i = 0; i <= ss.length / 2; i++) {
			if (ss[i] != ss[size - i - 1]) return false;
		}
		return true;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FairSquare f = new FairSquare();
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for (int t = 1; t <= T; t++) {
			long L = in.nextLong();
			long H = in.nextLong();
			int LL = ("" + (int) Math.floor(Math.sqrt(L))).length();
			int HL = ("" + (int) Math.floor(Math.sqrt(H))).length();
			int count = 0;
			Long value;
			for (int i = LL; i <= HL; i++) {
				ArrayList<Long> l = f.generatePalindromes(i);
				for (Long v : l) {
					value = new Long((long) Math.pow(v, 2));
					if (value >= L && value <= H && f.checkPal(value)) {
						count++;
					}
				}
			}
			System.out.println("Case #" + t + ": " + count);
		}
		in.close();
	}
}
