package qualification;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

public abstract class Problem {
	
	protected String input = "";
	protected String output = "";
	protected String ls = System.getProperty("line.separator");
	
	protected void mainFunc(String inputFilePath, String outputFilePath) {
		readInput(inputFilePath);
		solve();
		writeOut(outputFilePath);
	}

	private void readInput(String inputFilePath) {
		String currentLine;
		StringBuilder builder = new StringBuilder();
		try {

			BufferedReader reader = new BufferedReader(new FileReader(inputFilePath));
			while ((currentLine = reader.readLine()) !=  null) {
				builder.append(currentLine);
				builder.append(ls);
			}
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		input = builder.toString();
	}
	
	private void writeOut(String outputFilePath) {
		PrintStream out;
		new File(outputFilePath);
		try {
			out = new PrintStream(outputFilePath);
			out.println(output);
			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	protected abstract void solve();
	
}
