package codejam.qualification.lawnmower;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Lawnmower {
  private int height;
  private int width;

  public static void main(String[] args) {
    Lawnmower lawnmower = new Lawnmower();
    lawnmower.read(args[0]);
  }

  private void read(String filePath) {
    try {
      BufferedReader reader = new BufferedReader(new FileReader(filePath));
      BufferedWriter writer = new BufferedWriter(new FileWriter("outputBL.txt"));
      String line = reader.readLine();
      int numberOfTestCases = Integer.valueOf(line);
      for (int caseNum = 0; caseNum < numberOfTestCases; ++caseNum) {
        line = reader.readLine();
        String[] xy = line.split(" ");
        height = Integer.valueOf(xy[0]);
        width = Integer.valueOf(xy[1]);
        int[][] table = new int[height][width];
        for (int i = 0; i < height; ++i) {
          line = reader.readLine();
          String[] lineParts = line.split(" ");
          for (int j = 0; j < lineParts.length; ++j) {
            table[i][j] = Integer.valueOf(lineParts[j]);
          }
        }
        // System.err.println("Case #" + (caseNum + 1) + ": " + solve(table));
        writer.write("Case #" + (caseNum + 1) + ": " + solve(table) + "\n");
      }
      reader.close();
      writer.close();
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }

  private String solve(int[][] table) {
    int[] xMaximums = new int[height];
    for (int x = 0; x < height; ++x) {
      int max = 0;
      for (int y = 0; y < width; ++y) {
        if (max < table[x][y]) {
          max = table[x][y];
        }
      }
      xMaximums[x] = max;
    }
    int[] yMaximums = new int[width];
    for (int y = 0; y < width; ++y) {
      int max = 0;
      for (int x = 0; x < height; ++x) {
        if (max < table[x][y]) {
          max = table[x][y];
        }
      }
      yMaximums[y] = max;
    }
    for (int x = 0; x < height; ++x) {
      for (int y = 0; y < width; ++y) {
        int value = table[x][y];
        if (value < xMaximums[x] && value < yMaximums[y]) {
          return "NO";
        }
      }
    }
    return "YES";
  }
  
}
