package codejam.qualification.fairandsquare;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;

public class FairAndSquare {
  
  
  Long[] fairAndSquares;
  
  public static void main(String[] args) {
    FairAndSquare fasq = new FairAndSquare();
    fasq.read(args[0], args[1], Long.valueOf(args[2]));
  }
  
  private void read(String filePath, String outFilePath, long max) {
    try {
      BufferedReader reader = new BufferedReader(new FileReader(filePath));
      BufferedWriter writer = new BufferedWriter(new FileWriter(outFilePath));
      String line = reader.readLine();
      int numberOfTestCases = Integer.valueOf(line);
      createFairAndSquares(max);
      for (int caseNum = 0; caseNum < numberOfTestCases; ++caseNum) {
        line = reader.readLine();
        String[] xy = line.split(" ");
        int left = Integer.valueOf(xy[0]);
        int right = Integer.valueOf(xy[1]);
        // System.err.println("Case #" + (caseNum + 1) + ": " + solve(table));
        writer.write("Case #" + (caseNum + 1) + ": " + solve(left, right) + "\n");
      }
      reader.close();
      writer.close();
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }


  private void createFairAndSquares(long l) {
    double border = Math.sqrt(Math.sqrt(l));
    ArrayList<Long> fandqs = new ArrayList<Long>();
    for (long i = 0; i < border; ++i) {
      long i1 = createPalindrom(i, true);
      if (isPalindrome(i1 * i1)) {
        fandqs.add(i1 * i1);
      }
      long i2 = createPalindrom(i, false);
      if (isPalindrome(i2 * i2)) {
        fandqs.add(i2 * i2);
      }
    }
    fairAndSquares = fandqs.toArray(new Long[0]);
    Arrays.sort(fairAndSquares);
  }

  private long createPalindrom(long i, boolean doubleMid) {
    String num = i + "";
    StringBuffer buffer = new StringBuffer(num);
    int lengthToDouble = doubleMid ? num.length() : num.length() - 1;
    int j = doubleMid ? 0 : 1;
    for (; j < lengthToDouble; ++j) {
      buffer.append(num.charAt(num.length() - j - 1));
    }
    return Long.valueOf(buffer.toString());
  }

  int solve(long left, long right) {
    int leftIndex = Arrays.binarySearch(fairAndSquares, left);
    leftIndex = leftIndex >= 0 ? leftIndex : - leftIndex - 1; 
    int rightIndex = Arrays.binarySearch(fairAndSquares, right);
    rightIndex = rightIndex >= 0 ? rightIndex: - rightIndex - 2; 
    return rightIndex - leftIndex + 1;
  }

  public static boolean isPalindrome(long i) {
    String num = i + "";
    for (int j = 0; j < num.length() / 2; j++) {
      if (num.charAt(j) != num.charAt(num.length() - j - 1)) {
        return false;
      }
    }
    return true;
  }

}
