package codejam.qualification.tictactoetomek;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TicTacToeTomek {

  
  private boolean containsDot;
  private String result;

  public static void main(String[] args) {
    TicTacToeTomek tttt = new TicTacToeTomek();
    tttt.read(args[0]);
  }

  private void read(String filePath) {
    try {
      BufferedReader reader = new BufferedReader(new FileReader(filePath));
      BufferedWriter writer = new BufferedWriter(new FileWriter("output.txt"));
      String line = reader.readLine();
      int numberOfTestCases = Integer.valueOf(line);
      for (int caseNum = 0; caseNum < numberOfTestCases; ++caseNum) {
        char[][] table = new char[4][4];
        for (int i = 0; i < 4; ++i) {
          line = reader.readLine();
          for (int j = 0; j < 4; ++j) {
            table[i][j] = line.charAt(j);
          }
        }
        writer.write("Case #" + (caseNum + 1) + ": " +solve(table) + "\n");
        reader.readLine();
      }
      reader.close();
      writer.close();
    } catch (IOException e) {
      // TODO Auto-generated catch block
      e.printStackTrace();
    }
  }
  
  private String solve(char[][] table) {
    containsDot = false;
    result = "";
    checkRow(table, new int[]{0, 0, 0, 1, 0, 2, 0, 3});
    checkRow(table, new int[]{1, 0, 1, 1, 1, 2, 1, 3});
    checkRow(table, new int[]{2, 0, 2, 1, 2, 2, 2, 3});
    checkRow(table, new int[]{3, 0, 3, 1, 3, 2, 3, 3});
    checkRow(table, new int[]{0, 0, 1, 0, 2, 0, 3, 0});
    checkRow(table, new int[]{0, 1, 1, 1, 2, 1, 3, 1});
    checkRow(table, new int[]{0, 2, 1, 2, 2, 2, 3, 2});
    checkRow(table, new int[]{0, 3, 1, 3, 2, 3, 3, 3});
    checkRow(table, new int[]{0, 0, 1, 1, 2, 2, 3, 3});
    checkRow(table, new int[]{0, 3, 1, 2, 2, 1, 3, 0});
    if (result != "") {
      return result;
    }
    if (containsDot) {
      return "Game has not completed";
    }
    return "Draw";
  }

  void checkRow(char[][] table, int[] choords) {
    char first = table[choords[0]][choords[1]];
    if (first == '.') {
      containsDot = true;
      return;
    }
    char previous;
    boolean ends = true;
    if (first == 'T') {
      previous = table[choords[2]][choords[3]];
    } else {
      previous = table[choords[0]][choords[1]];
    }
    for (int i = 1; i < 4; ++i) {
      char next = table[choords[2 * i]][choords[2 * i + 1]];
      if ('.' == next) {
        containsDot = true;
        return;
      }
      if ('T' == next) {
        next = previous;
      } else if  (next != previous) {
        ends = false;
      }
      previous = next;
    }
    if (ends) {
      result = previous + " won";
    }
  }
}
