import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: mdabdul
 * Date: 5/7/11
 * Time: 5:39 PM
 */
public class Magicka {


    Hashtable<String, Character> combines = new Hashtable<String, Character>();
    ArrayList<String> opposites = new ArrayList<String>();

    LinkedList<Character> elementList = new LinkedList<Character>();

    public Magicka(String inputFileName) {
        try {
            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(inputFileName)));
            int numOfTests = Integer.parseInt(reader.readLine());
            for (int i = 0; i < numOfTests; i++) {

                StringTokenizer tokenizer = new StringTokenizer(reader.readLine(), " ", false);
                int cs = Integer.parseInt(tokenizer.nextToken().trim());

                for (int c = 0; c < cs; c++) {
                    String comb = tokenizer.nextToken();
                    addCombine(comb.charAt(0), comb.charAt(1), comb.charAt(2));
                }
                int d = Integer.parseInt(tokenizer.nextToken().trim());

                for (int c = 0; c < d; c++) {
                    String opp = tokenizer.nextToken();
                    addOpposites(opp.charAt(0), opp.charAt(1));
                }
                int n = Integer.parseInt(tokenizer.nextToken());

                String characters = tokenizer.nextToken().trim();
                for (char c : characters.toCharArray()) {
                    add(c);
                }
                System.out.println("Case #"+(i+1)+": "+elementList.toString());
                elementList.clear();
                combines.clear();
                opposites.clear();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void add(char c) {

        if (elementList.isEmpty()) {
            elementList.add(c);
            return;
        }
        char l = elementList.getLast();

        if (getCombine(c, l) != null) {
            elementList.removeLast();
            elementList.addLast(getCombine(c, l));
            return;
        }

        Iterator<Character> iter = elementList.iterator();

        while (iter.hasNext()) {
            if (isOpposite(c, iter.next())) {
                elementList.clear();
                return;
            }
        }
        elementList.addLast(c);
    }

    public void addCombine(char a, char b, char t) {
        combines.put(a + ":" + b, t);
    }

    public void addOpposites(char a, char b) {
        opposites.add(a + ":" + b);
    }

    public boolean isOpposite(char a, char b) {
        return (opposites.contains(a + ":" + b) || opposites.contains(b + ":" + a));
    }

    public Character getCombine(char a, char b) {
        if (combines.get(a + ":" + b) != null) return combines.get(a + ":" + b);
        if (combines.get(b + ":" + a) != null) return combines.get(b + ":" + a);
        return null;
    }


    public static void main(String args[]) {
        String file = args[0];
        Magicka m = new Magicka(file);

    }

    public void invoke(char c) {

    }

}
