import java.io.*;
import java.util.ArrayList;

/**
 * Created by IntelliJ IDEA.
 * User: mdabdul
 * Date: 5/21/11
 * Time: 9:41 PM
 */
public class RPI {


    public static void main(String args[])
    {
        RPI rpi = new RPI("C:\\projects\\scratchpad\\src\\in.txt");
    }

    public RPI(String file) {
        try {

            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
            int numOfTests = getInt(reader.readLine());

            for (int i = 0; i < numOfTests; i++) {
                int numOfTeams = getInt(reader.readLine());
                char[][] matrix = new char[numOfTeams][numOfTeams];
                for (int j = 0; j < numOfTeams; j++) {
                    String test = reader.readLine().trim();
                    for (int k = 0; k < numOfTeams; k++) {
                        matrix[j][k] = test.charAt(k);
                    }
                }
                System.out.println("Case #"+(i+1)+": ");
                for (int a = 0; a < numOfTeams; a++) {
                    double rpi = getRPI(a, matrix);
                    System.out.println(rpi);

                }

            }

        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public double getRPI(int teamNumber, char[][] matrix) {
        return (0.25 * getWP(teamNumber,matrix) + 0.50*getOWP(teamNumber,matrix) + 0.25*getOOWP(teamNumber,matrix));

    }

    public double getWP(int teamNumber, char[][] matrix) {
        int total = 0;
        int wins = 0;
        for (int i = 0; i < matrix.length; i++) {
            if (i == teamNumber) continue;
            if (matrix[teamNumber][i] != '.') {
                total = total + 1;
                if (matrix[teamNumber][i] == '1')
                    wins = wins + 1;
            }
        }
        return (double) wins / total;

    }

    public double getOWP(int teamNumber, char[][] matrix) {

        int owpt = 0;
        double owpw= 0;
        int oc  = 0;
        ArrayList<Integer>opponents = new ArrayList<Integer>();
        for(int m = 0 ; m < matrix.length;m++)
        {
            if(m == teamNumber ) continue;
            if(matrix[teamNumber][m] != '.')
                opponents.add(m);
        }
        for (int i: opponents) {

            int total = 0;
            int wins = 0;
            for (int j = 0; j < matrix.length; j++) {
               if (j == teamNumber || j == i) continue;
                if (matrix[i][j] != '.') {
                    total = total + 1;
                    if (matrix[i][j] == '1')
                        wins = wins + 1;

                }
            }
         owpw = owpw + (double)wins/(double)total;
            owpt ++;
        }

        return owpw/owpt;
    }

    public double getOOWP(int teamNumber, char[][] matrix) {
        double sum = 0;
        int total = 0;
        ArrayList<Integer>opponents = new ArrayList<Integer>();
        for(int m = 0 ; m < matrix.length;m++)
        {
            if(m == teamNumber ) continue;
            if(matrix[teamNumber][m] != '.')
                opponents.add(m);
        }
        for(int i: opponents)
        {
            if(i == teamNumber) continue;
            sum  = sum + getOWP(i,matrix);
            total++;
        }
        return sum/(double)total;

    }

    private int getInt(String str) {
        return Integer.parseInt(str.trim());
    }

    private double getDouble(String str) {
        return Double.valueOf(str.trim());
    }
}
