package ab.treasure;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.TreeSet;

/**
 * Created by IntelliJ IDEA.
 * User: mdabdul
 * Date: 4/14/13
 * Time: 1:21 AM
 *
 */
public class Main {

    class Node implements  Comparable{

        int id;
        TreeSet<Node> nodes ;
        boolean marked ;

        public Node(int i)
        {
            id = i;
            nodes = new TreeSet<Node>();
            marked = false;
        }

        public void addNode(Node n)
        {
            if(n.id != id)
                nodes.add(n);
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (!(o instanceof Node)) return false;

            Node node = (Node) o;

            if (id != node.id) return false;

            return true;
        }

        @Override
        public int hashCode() {
            return id;
        }

        public int compareTo(Object o) {
            Node n = (Node)o;
            if(id == n.id) return 0;
            if( id < n.id ) return -1;
            else
                return 1;
        }
    }

    TreeSet<Node> startNodes;

    public Main()
    {


        readInput();

    }

    private void readInput()
    {
        try{

            BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
            int numTests = Integer.parseInt(reader.readLine());
            for(int i = 0 ; i < numTests; i++)
            {
                startNodes  = new TreeSet<Node>();
                HashMap<Integer,Node> nodeMap = new HashMap<Integer, Node>();
                HashMap<Integer,List<Integer>> keyMap = new HashMap<Integer, List<Integer>>();
                String str[] = reader.readLine().split(" ");
                int skeys = Integer.parseInt(str[0]);
                int numChests = Integer.parseInt(str[1]);

                String keys[] = reader.readLine().split(" ");
                int startKeys[] = new int[keys.length];
                for(int b = 0; b < keys.length ; b++)
                {
                   startKeys[b] = Integer.parseInt(keys[b]);
                }

                int[] chestKey = new int[numChests+1];
                int[][]chestInKeys = new int[numChests][];

                for(int a = 0; a < numChests ; a++)
                {
                    String chests[] = reader.readLine().split(" ");
                    int t = Integer.parseInt(chests[0]);
                    List<Integer> ll = keyMap.get(t);
                    if(ll == null)
                    {
                        ll = new ArrayList<Integer>();
                        keyMap.put(t,ll);
                    }
                    ll.add(a+1);
                    chestKey[a+1] = t;
                    int kk = Integer.parseInt(chests[1]);
                    int tkeys[] = new int[kk];
                    for(int c = 0 ; c < kk ; c++)
                    {
                        tkeys[c] = Integer.parseInt(chests[c+2]);
                    }
                    chestInKeys[a] = tkeys;
                }

                for(int a = 0 ; a < numChests; a++)
                {

                    Node n;
                    if(nodeMap.containsKey(a+1))
                    {
                      n = nodeMap.get(a+1);
                    }
                    else
                    {
                        n = new Node(a+1);
                        nodeMap.put(a+1,n);

                    }
                    for(int kk : chestInKeys[a])
                    {
                        List<Integer> cc = keyMap.get(kk);
                        if(cc != null)
                        for(int m: cc)
                        {
                            Node mn;
                            if(nodeMap.containsKey(m))
                                mn = nodeMap.get(m) ;
                            else
                            {   mn = new Node(m);
                                nodeMap.put(mn.id , mn);
                            }
                            n.addNode(mn);
                        }
                    }

                }

                for(int k: startKeys)
                {
                    List<Integer> ns = keyMap.get(k);
                    if(ns != null)
                    for(int nss: ns)
                    {
                        startNodes.add(nodeMap.get(nss));
                    }
                }

               boolean found = false;
                if(startNodes.size() == numChests){
                    StringBuffer buff = new StringBuffer();
                    buff.append("Case #"+(i+1)+": ");
                    for(Node n: startNodes)
                    {
                        buff.append(n.id + " ");
                    }
                    found = true;
                    System.out.println(buff.toString());
                }
                else
                for(Node n: startNodes)
                {
                    List<Node> visited = new ArrayList<Node>();

                    visit(n,visited);
                    if(visited.size() == numChests)
                    {
                        StringBuffer buff = new StringBuffer();
                        buff.append("Case #"+(i+1)+": ");
                        for(Node e: visited)
                        {
                            buff.append(e.id + " ");

                        }
                        System.out.println(buff.toString());
                        found = true;
                        break;
                    }
                }
                if(!found)
                {
                    System.out.println("Case #"+(i+1)+": IMPOSSIBLE");
                }






            }

        }catch (Exception e)
        {
            e.printStackTrace();
        }

    }


    public void visit(Node n)
    {
        System.out.print(n.id + " ");
        for(Node nn: n.nodes)
        {
            visit(nn);
        }
    }

    public void visitg(Node n , StringBuffer graph)
    {
        graph.append(n.id + " ->");
        for(Node a: n.nodes)
        {
            visitg(a,graph);
        }
    }
    public void visit(Node n,List<Node> visited)
    {
        if(n.marked) return;
        visited.add(n);
        n.marked = true;
        for(Node a: n.nodes)
        {
            visit(a,visited);
        }

        return ;
    }

    public static void main(String args[])
    {
        Main m = new Main();
    }


}
