import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.StringTokenizer;


public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		BufferedReader br = null;
		StringBuffer result = new StringBuffer();
		 
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			String testCases = br.readLine();
			int cases = Integer.parseInt(testCases);
			for (int i = 1;i <= cases;i++){
				String caseStr = br.readLine();
				StringTokenizer tok = new StringTokenizer(caseStr," ");
				String lower = tok.nextToken();
				String upper = tok.nextToken();
				
				int count = 0;
				BigInteger low = new BigInteger(lower);
				BigInteger up = new BigInteger(upper);
				 for (BigInteger bi = low;
				            bi.compareTo(up) <= 0;
				            bi = bi.add(BigInteger.ONE)) {
					 	StringBuffer sb = new StringBuffer(bi.toString());
				        BigInteger rev = new BigInteger(sb.reverse().toString());
				        if (bi.compareTo(rev) == 0){
				        	BigInteger r = bigIntSqRootCeil(bi);
				        	if (r.toString().equals("0")){
				        		continue;
				        	}
				        	StringBuffer sb1 = new StringBuffer(r.toString());
				        	BigInteger rev2 = new BigInteger(sb1.reverse().toString());
				        	if (r.compareTo(rev2) == 0){
				        		count++;
				        	}
				        }
				    }
				 result.append("Case #"+Integer.toString(i)+": "+count);
				 result.append("\n");
				
			}
			
			String resultStr = result.toString();
			File file = new File("output.txt");
			 
			// if file doesnt exists, then create it
			if (!file.exists()) {
				try {
					file.createNewFile();
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
 
			FileWriter fw = null;
			try {
				fw = new FileWriter(file.getAbsoluteFile());
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			BufferedWriter bw = new BufferedWriter(fw);
			try {
				bw.write(resultStr);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			try {
				bw.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		
	}
		}

	

		public static BigInteger bigIntSqRootFloor(BigInteger x)
		        throws IllegalArgumentException {
		    if (x.compareTo(BigInteger.ZERO) < 0) {
		        throw new IllegalArgumentException("Negative argument.");
		    }
		    // square roots of 0 and 1 are trivial and
		    // y == 0 will cause a divide-by-zero exception
		    if (x == BigInteger.ZERO || x == BigInteger.ONE) {
		        return x;
		    } // end if
		    BigInteger two = BigInteger.valueOf(2L);
		    BigInteger y;
		    // starting with y = x / 2 avoids magnitude issues with x squared
		    for (y = x.divide(two);
		            y.compareTo(x.divide(y)) > 0;
		            y = ((x.divide(y)).add(y)).divide(two));
		    return y;
		} // end bigIntSqRootFloor

		public static BigInteger bigIntSqRootCeil(BigInteger x)
		        throws IllegalArgumentException {
		    if (x.compareTo(BigInteger.ZERO) < 0) {
		        throw new IllegalArgumentException("Negative argument.");
		    }
		    // square roots of 0 and 1 are trivial and
		    // y == 0 will cause a divide-by-zero exception
		    if (x.compareTo(BigInteger.ZERO) == 0 || x.compareTo(BigInteger.ONE) == 0) {
		        return x;
		    } // end if
		    BigInteger two = BigInteger.valueOf(2L);
		    BigInteger y;
		    // starting with y = x / 2 avoids magnitude issues with x squared
		    for (y = x.divide(two);
		            y.compareTo(x.divide(y)) > 0;
		            y = ((x.divide(y)).add(y)).divide(two));
		    if (x.compareTo(y.multiply(y)) == 0) {
		        return y;
		    } else {
		        return BigInteger.ZERO;
		    }
		} // end bigIntSqRootCeil
		
	
}
