import java.io.*;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.Comparator;

/**
 * Created by Eika on 4/30/17.
 */
public class A1C {

    static long[][] dp;
    static int[][] pancakes;
    static int K;

    public static void main(String[] args)  throws IOException {
        DecimalFormat format = new DecimalFormat("#.000000###");
        BufferedReader br = new BufferedReader(new FileReader("A-large.in"));
        BufferedWriter bw = new BufferedWriter(new FileWriter("A-large.out"));
        int T = Integer.parseInt(br.readLine());
        out:
        for (int i = 1; i <= T; i++) {
            bw.write("Case #" + i + ": ");
            String[] temp = br.readLine().split(" ");
            int N = Integer.parseInt(temp[0]);
            K = Integer.parseInt(temp[1]);
            pancakes = new int[N][2];
            dp = new long[N][K+1];
            for (long[] sub : dp) {
                Arrays.fill(sub, -1);
            }
            for (int j = 0; j < N ; j++) {
                temp = br.readLine().split(" ");
                pancakes[j][0] = Integer.parseInt(temp[0]);
                pancakes[j][1] = Integer.parseInt(temp[1]);
            }

            Arrays.sort(pancakes, new Comparator<int[]>() {
                @Override
                public int compare(int[] o1, int[] o2) {
                    if (o1[0] != o2[0])
                        return o2[0]-o1[0];
                    return o2[1] - o1[1];
                }
            });

            bw.write(format.format(Math.PI * maxAt(0, K))+"\n");
        }
        bw.close();
    }

    static long maxAt(int position, int left) {
        if (left == 0) return 0;
        if (position >= pancakes.length) return -1;
        if (dp[position][left] != -1) return dp[position][left];
        if (left > pancakes.length - position) return -1;
        long take = 2 * ((long) pancakes[position][0] * pancakes[position][1]) + maxAt(position+1, left-1);
        if (left == K) {
            take += (long)pancakes[position][0]*pancakes[position][0];
        }
        long skip = maxAt(position+1, left);
        return dp[position][left] = Math.max(take, skip);
    }
}
