package SavingTheUniverse;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


/**
 * Created by IntelliJ IDEA.
 * User: Abhishek
 * Date: Jul 16, 2008
 * Time: 9:22:09 PM
 * To change this template use File | Settings | File Templates.
 */
public class DataSet
{
    private int                       numSearchEngines;
    private int                       numQueryStrings;
    private int                       switches;
    private Map<String, SearchEngine> querySearchEngineMap = new HashMap<String, SearchEngine>(  );
    private List<QueryString>         queryStrings         = new ArrayList<QueryString>(  );
    private List<SearchEngine>        searchEngines        = new ArrayList<SearchEngine>(  );

    public DataSet ( int numSearchEngines )
    {
        this.numSearchEngines = numSearchEngines;
    }

    public void addSearchEngine ( String searchEngineName )
    {
        SearchEngine engine = new SearchEngine( searchEngineName );
        querySearchEngineMap.put( searchEngineName, engine );
        searchEngines.add( engine );
    }

    public int getNumSearchEngines (  )
    {
        return numSearchEngines;
    }

    public int getNumQueryStrings (  )
    {
        return numQueryStrings;
    }

    public void setNumQueryStrings ( int numQueryStrings )
    {
        this.numQueryStrings = numQueryStrings;
    }

    public int getSwitches (  )
    {
        return switches;
    }

    public void addQueryString ( int    index,
                                 String queryString )
    {
        QueryString query = new QueryString( index, queryString );

        if ( querySearchEngineMap.containsKey( queryString ) )
        {
            query.setCanDestroyUniverse( true );
            querySearchEngineMap.get( queryString ).add( query );
        }

        queryStrings.add( query );
    }

    private void sortSearchEngineQueryStrings (  )
    {
        for ( SearchEngine searchEngine : searchEngines )
        {
            searchEngine.sort(  );
        }
    }

    private void sortSearchEngines (  )
    {
        Collections.sort( searchEngines );
    }

    private SearchEngine getNext (  )
    {
        sortSearchEngines(  );

        return searchEngines.get( 0 );
    }

    private void removeQueryString ( QueryString queryString )
    {
        SearchEngine engine = querySearchEngineMap.get( queryString.getQueryString(  ) );
        engine.remove( queryString );
        sortSearchEngines(  );
    }

    public void process (  )
    {
        sortSearchEngineQueryStrings(  );
        sortSearchEngines(  );

        SearchEngine currentEngine = getNext(  );

        while ( !queryStrings.isEmpty(  ) )
        {
            QueryString queryString = queryStrings.get( 0 );

            if ( queryString.willDestroyUniverse( currentEngine ) )
            {
                switches++;
                currentEngine = getNext(  );
                removeQueryString( queryString );
            }
            else
            {
                removeQueryString( queryString );
            }

            queryStrings.remove( queryString );
        }
    }
}
