package SavingTheUniverse;


/**
 * Created by IntelliJ IDEA.
 * User: Abhishek
 * Date: Jul 16, 2008
 * Time: 9:23:16 PM
 * To change this template use File | Settings | File Templates.
 */
public class QueryString
    implements Comparable<QueryString>
{
    private int     index;
    private String  queryString;
    private boolean canDestroyUniverse = false;

    public QueryString ( int    index,
                         String queryString )
    {
        this.index       = index;
        this.queryString = queryString;
    }

    public int getIndex (  )
    {
        return index;
    }

    public String getQueryString (  )
    {
        return queryString;
    }

    public void setCanDestroyUniverse ( boolean canDestroyUniverse )
    {
        this.canDestroyUniverse = canDestroyUniverse;
    }

    public boolean willDestroyUniverse ( SearchEngine engine )
    {
        return queryString.equals( engine.getName(  ) );
    }

    public int compareTo ( QueryString o )
    {
        if ( index > o.index )
        {
            return 1;
        }
        else if ( index < o.index )
        {
            return -1;
        }

        return 0;
    }

    public boolean equals ( Object o )
    {
        if ( this == o )
        {
            return true;
        }

        if ( ( o == null ) || ( getClass(  ) != o.getClass(  ) ) )
        {
            return false;
        }

        QueryString that = ( QueryString ) o;

        if ( index != that.index )
        {
            return false;
        }

        if ( !queryString.equals( that.queryString ) )
        {
            return false;
        }

        return true;
    }

    public int hashCode (  )
    {
        int result;
        result = index;
        result = ( 31 * result ) + queryString.hashCode(  );

        return result;
    }

    public boolean isCanDestroyUniverse (  )
    {
        return canDestroyUniverse;
    }

    @Override
    public String toString (  )
    {
        final StringBuilder sb = new StringBuilder(  );
        sb.append( "QueryString" );
        sb.append( "{index=" ).append( index );
        sb.append( ", queryString='" ).append( queryString ).append( '\'' );
        sb.append( ", canDestroyUniverse=" ).append( canDestroyUniverse );
        sb.append( '}' );

        return sb.toString(  );
    }
}
