package TrainTimeTable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


/**
 * Created by IntelliJ IDEA.
 * User: abhishek.gupta
 * Date: Jul 17, 2008
 * Time: 8:13:27 AM
 * To change this template use File | Settings | File Templates.
 */
public class DataSet
{
    private List<TrainTime> possibleDeparturesStationA = new ArrayList<TrainTime>(  );
    private List<TrainTime> possibleDeparturesStationB = new ArrayList<TrainTime>(  );
    private List<TrainTime> trainTimes                 = new ArrayList<TrainTime>(  );
    private int             numTripsA                  = 0;
    private int             numTripssB                 = 0;
    private int             turnAroundTime             = 0;
    private int             numTrainsA                 = 0;
    private int             numTrainsB                 = 0;

    public DataSet ( int numTripsA,
                     int numTripsB,
                     int turnAroundTime )
    {
        this.numTripsA      = numTripsA;
        this.numTripssB     = numTripsB;
        this.turnAroundTime = turnAroundTime;
    }

    public int getTurnAroundTime (  )
    {
        return turnAroundTime;
    }

    public int getNumTripsA (  )
    {
        return numTripsA;
    }

    public int getNumTripssB (  )
    {
        return numTripssB;
    }

    public void addTrainTime ( TrainTime trainTime )
    {
        trainTimes.add ( trainTime );
    }

    public void addTrainTimeA ( TrainTime trainTime )
    {
        possibleDeparturesStationA.add ( trainTime );
    }

    public void addTrainTimeB ( TrainTime trainTime )
    {
        possibleDeparturesStationB.add ( trainTime );
    }

    public int getNumTrainsA (  )
    {
        return numTrainsA;
    }

    public int getNumTrainsB (  )
    {
        return numTrainsB;
    }

    public void process (  )
    {
        Collections.sort ( trainTimes );

        int index = 0;

        for ( TrainTime trainTime : trainTimes )
        {
            index++;

            if ( trainTime.getTimeType (  ) == TrainTimeType.ARRIVAL )
            {
                if ( trainTime.getStation (  ).equals ( "A" ) )
                {
                    TrainTime newTrainTime = new TrainTime( "A", trainTime.getTime (  ) + turnAroundTime, TrainTimeType.DEPARTURE, "AB" + index );
                    addTrainTimeA ( newTrainTime );
                }
                else
                {
                    TrainTime newTrainTime = new TrainTime( "B", trainTime.getTime (  ) + turnAroundTime, TrainTimeType.DEPARTURE, "BA" + index );
                    addTrainTimeB ( newTrainTime );
                }

                continue;
            }

            if ( trainTime.getStation (  ).equals ( "A" ) )
            {
                if ( canUseThisTrain ( possibleDeparturesStationA, trainTime ) )
                {
                    possibleDeparturesStationA.remove ( 0 );
                }
                else
                {
                    numTrainsA++;
                }
            }
            else
            {
                if ( canUseThisTrain ( possibleDeparturesStationB, trainTime ) )
                {
                    possibleDeparturesStationB.remove ( 0 );
                }
                else
                {
                    numTrainsB++;
                }
            }
        }
    }

    private boolean canUseThisTrain ( List<TrainTime> trainTimes,
                                      TrainTime       currentTrainTime )
    {
        if ( !trainTimes.isEmpty (  ) )
        {
            TrainTime earliestPossibleDepartureOfLastTrain = trainTimes.get ( 0 );

            if ( earliestPossibleDepartureOfLastTrain.getTime (  ) <= currentTrainTime.getTime (  ) )
            {
                return true;
            }
        }

        return false;
    }
}
