package SavingTheUniverse;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;


/**
 * Created by IntelliJ IDEA.
 * User: Abhishek
 * Date: Jul 16, 2008
 * Time: 9:22:55 PM
 * To change this template use File | Settings | File Templates.
 */
public class SearchEngine
    implements Comparable<SearchEngine>
{
    private String            name;
    private List<QueryString> inputs = new ArrayList<QueryString>(  );

    public SearchEngine ( String name )
    {
        this.name = name;
    }

    public String getName (  )
    {
        return name;
    }

    public void add ( QueryString queryString )
    {
        inputs.add( queryString );
    }

    public void remove ( QueryString queryString )
    {
        inputs.remove( queryString );
    }

    public void sort (  )
    {
        Collections.sort( inputs );
    }

    public int maxIndex (  )
    {
        return inputs.isEmpty(  ) ? ( -1 ) : inputs.get( 0 ).getIndex(  );
    }

    public int compareTo ( SearchEngine o )
    {
        int thisIndex = maxIndex(  );
        int thatIndex = o.maxIndex(  );

        if ( thisIndex == -1 )
        {
            return -1;
        }

        if ( thatIndex == -1 )
        {
            return 1;
        }

        if ( thisIndex > thatIndex )
        {
            return -1;
        }

        if ( thisIndex < thatIndex )
        {
            return 1;
        }

        return 0;
    }

    @Override
    public String toString (  )
    {
        final StringBuilder sb = new StringBuilder(  );
        sb.append( "SearchEngine" );
        sb.append( "{name='" ).append( name ).append( '\'' );
        sb.append( ", inputs=" ).append( inputs );
        sb.append( '}' );

        return sb.toString(  );
    }
}
