package TrainTimeTable;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

import java.text.MessageFormat;


/**
 * Created by IntelliJ IDEA.
 * User: abhishek.gupta
 * Date: Jul 17, 2008
 * Time: 8:20:59 AM
 * To change this template use File | Settings | File Templates.
 */
public class TrainTimeTable
{
    private static final String OUTPUT_FORMAT = "Case #{0}: {1} {2}";

    public static void main ( String [] args )
                      throws IOException
    {
        String inputFile;

        if ( args.length != 0 )
        {
            inputFile = args [ 0 ];
        }
        else
        {
            inputFile = "C:\\Documents and Settings\\abhishek.gupta\\Desktop\\test1.txt";
        }

        File           file           = new File( inputFile );
        BufferedReader bufferedReader = new BufferedReader( new FileReader( file ) );

        String         line           = bufferedReader.readLine (  );

        int            numCases       = Integer.parseInt ( line );

        for ( int i = 0; i < numCases; i++ )
        {
            line = bufferedReader.readLine (  );

            int numTotalTrains = Integer.parseInt ( line );
            line = bufferedReader.readLine (  );

            String [] parts      = line.split ( " " );
            int       numTrainsA = Integer.parseInt ( parts [ 0 ] );
            int       numTrainsB = Integer.parseInt ( parts [ 1 ] );

            DataSet   dataSet    = new DataSet( numTrainsA, numTrainsB, numTotalTrains );

            for ( int j = 0; j < numTrainsA; j++ )
            {
                line  = bufferedReader.readLine (  );
                parts = line.split ( " " );

                int       depart = parseTime ( parts [ 0 ] );
                TrainTime trainTimeA = new TrainTime( "A", depart, TrainTimeType.DEPARTURE, "AB" + j );
                dataSet.addTrainTime ( trainTimeA );

                int       arrive     = parseTime ( parts [ 1 ] );
                TrainTime trainTimeB = new TrainTime( "B", arrive, TrainTimeType.ARRIVAL, "AB" + j );
                dataSet.addTrainTime ( trainTimeB );
            }

            for ( int j = 0; j < numTrainsB; j++ )
            {
                line  = bufferedReader.readLine (  );
                parts = line.split ( " " );

                int       depart = parseTime ( parts [ 0 ] );
                TrainTime trainTimeB = new TrainTime( "B", depart, TrainTimeType.DEPARTURE, "BA" + j );
                dataSet.addTrainTime ( trainTimeB );

                int       arrive     = parseTime ( parts [ 1 ] );
                TrainTime trainTimeA = new TrainTime( "A", arrive, TrainTimeType.ARRIVAL, "BA" + j );
                dataSet.addTrainTime ( trainTimeA );
            }

            dataSet.process (  );

            String output = MessageFormat.format ( OUTPUT_FORMAT, i + 1, dataSet.getNumTrainsA (  ), dataSet.getNumTrainsB (  ) );

            System.out.println ( output );
        }
    }

    private static int parseTime ( String strTime )
    {
        String [] parts = strTime.split ( ":" );

        return ( Integer.parseInt ( parts [ 0 ] ) * 60 ) + Integer.parseInt ( parts [ 1 ] );
    }
}
