package com.gcj;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;
import java.text.NumberFormat;

public class CookieClicker {

	private static NumberFormat nf = NumberFormat.getNumberInstance();
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		double costOfCookieFarm = 0, incCookie = 0, winCookie = 0; 
		int testCaseCount = -1, testExeCount = 0;
		String[] tokenList = null;
		String timeTaken = null, result = "";
		BufferedReader fileReader = (BufferedReader)readFile("D:\\personal\\GCJ\\magician\\B-large.in");
		String inputLine = fileReader.readLine();
		
		nf.setMinimumFractionDigits(7);
		
		testCaseCount = Integer.parseInt(inputLine.trim());
		
		while(!isNullOrEmpty(inputLine = fileReader.readLine())) {
			tokenList = inputLine.split(" ");
			costOfCookieFarm = Double.parseDouble(tokenList[0]);
			incCookie = Double.parseDouble(tokenList[1]);
			winCookie = Double.parseDouble(tokenList[2]);
			
			timeTaken = timeTakenToWin(costOfCookieFarm, incCookie, winCookie);
			testExeCount++;
			
			result = result + "Case #" + testExeCount + ": " + timeTaken;
			
			if(testExeCount < testCaseCount) {
				result = result + "\n";
			}
		}
		
		System.out.println(result);
		writeToFile("D:\\personal\\GCJ\\magician\\B-large.out", result);
	}
	
	private static Reader readFile(String fileLocation) throws FileNotFoundException {
		BufferedReader fileReader = new BufferedReader(new FileReader(fileLocation));
		
		return fileReader;
	}
	
	private static void writeToFile(String fileName, String dataString) throws IOException {
		FileWriter writeFile = new FileWriter(fileName);
		
		writeFile.append(dataString);
		
		writeFile.close();
		
	}
	
	private static boolean isNullOrEmpty(String inputString) {
		boolean isEmpty = false;
		
		if(inputString == null || "".equals(inputString.trim())) {
			isEmpty = true;
		}
		
		return isEmpty;
	}
		
	private static String timeTakenToWin(double costOfCookieFarm, double incCookie, double cookiesToWin) {
		double timeTaken = 0;
		double totalTime = 0, expectedTime = 0, currentCookiePerSecond = 2, totalFarmBought = 0;
		boolean isWon = false;
		
		totalTime = cookiesToWin / currentCookiePerSecond;
		
		double timeToBuyFarm = (costOfCookieFarm / currentCookiePerSecond);
		
		if(totalTime < timeToBuyFarm) {
			expectedTime = totalTime;
		} else {
			expectedTime = totalTime;
			currentCookiePerSecond = currentCookiePerSecond + incCookie;
			totalTime = timeToBuyFarm  + (cookiesToWin / currentCookiePerSecond);
		}
		
		while(expectedTime > totalTime) {
			expectedTime = totalTime;
			timeToBuyFarm = timeToBuyFarm + (costOfCookieFarm / currentCookiePerSecond);
			currentCookiePerSecond = currentCookiePerSecond + incCookie;
			totalTime = timeToBuyFarm + (cookiesToWin / currentCookiePerSecond);
		}
		
		timeTaken = expectedTime;
				
				
		return nf.format(timeTaken);
	}
}
