
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;
import java.util.Vector;

/**
 * @author Abhimanyu Singh
 *
 */
public class FairAndSquare {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;
    private long fairNum[];

    public FairAndSquare(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    boolean isPalindrome(String str) {
        int length = str.length();
        int half = length / 2;
        for (int i = 0; i < half; i++) {
            if (str.charAt(i) != str.charAt(length - 1 - i)) {
                return false;
            }
        }
        return true;
    }

    void calculateFairNums() {
        Vector<Long> v = new Vector<Long>();
        for (long n = 1; n <= 9999; n++) {
            String halfPart = "" + n;
            String num1 = halfPart + halfPart;
            long number1 = Long.parseLong(num1);
            if (isPalindrome(number1 * number1)) {
                v.add(number1);
            }
            for (int i = 0; i <= 9; i++) {
                String num2 = halfPart + i + halfPart;
                long number2 = Long.parseLong(num2);
                if (isPalindrome(number2 * number2)) {
                    v.add(number2);
                }
            }
        }
        v.add((long) 0);
        v.add((long) 1);
        v.add((long) 2);
        v.add((long) 3);
        int size = v.size();
        fairNum = new long[size];
        for (int i = 0; i < size; i++) {
            Long l = v.elementAt(i);
            long value = l.longValue();
            fairNum[i] = value * value;
        }
        Arrays.sort(fairNum);
    }

    boolean isPalindrome(long n) {
        String str = "" + n;
        return isPalindrome(str);
    }

    public void solve() {
        calculateFairNums();
        int testCaseCount = inputSc.nextInt();
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    private void solveTestCase(int testN) {
        long a = inputSc.nextLong();
        long b = inputSc.nextLong();
        int ai = Arrays.binarySearch(fairNum, a);
        int bi = Arrays.binarySearch(fairNum, b);
        if (ai < 0) {
            ai = -(ai + 1);
        }
        if (bi < 0) {
            bi = -(bi + 1);
            bi--;
        }
        int ans = 0;
        if (ai <= bi) {
            ans = (bi - ai + 1);
        }
        output.println("Case #" + testN + ": " + ans);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        FairAndSquare fas = new FairAndSquare(System.in, System.out);
        fas.solve();
    }
}
