
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class DeceitfulWar {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;

    public DeceitfulWar(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = lineToInt(inputSc.nextLine());
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    private void solveTestCase(int testN) {
        final int MAX = 100000;
        String str = inputSc.nextLine();
        Scanner temSc = new Scanner(str);
        int N = temSc.nextInt();
        int naomi[] = new int[N];
        int ken[] = new int[N];
        str = inputSc.nextLine();
        temSc = new Scanner(str);
        for (int i = 0; i < N; i++) {
            naomi[i] = (int) (temSc.nextDouble() * MAX);
        }
        str = inputSc.nextLine();
        temSc = new Scanner(str);
        for (int i = 0; i < N; i++) {
            ken[i] = (int) (temSc.nextDouble() * MAX);

        }
        Arrays.sort(ken);
        Arrays.sort(naomi);
        int naomiWarScore = 0;
        // War game
        {
            int k[] = ken.clone();
            for (int i = 0; i < N; i++) {
                int w = naomi[i];
                boolean found = false;
                for (int j = 0; j < N; j++) {
                    if (k[j] != -1) {
                        if (k[j] > w) {
                            found = true;
                            k[j] = -1;
                            break;
                        }
                    }
                }
                if (found) {
                    naomiWarScore += 0;
                } else {
                    naomiWarScore++;
                    for (int j = 0; j < N; j++) {
                        if (k[j] != -1) {
                            k[j] = -1;
                            break;
                        }
                    }
                }
            }
        }


        int naomiDecWarScore = 0;
        // Dec War game
        {
            int left = 0;
            int right = N - 1;

            for (int i = 0; i < N; i++) {
                int w = naomi[i];
                if (w > ken[left]) {
                    /* Naomi can win by speaking biggest weight so that
                     * Ken has to move lowest
                     * biggest weight > ken[right] && ken don't have it
                     * can't speak 1 twice =>
                     * I have 1 => Ken don't have => we have something to speak
                     * Ken have it => Same as CASE2
                     * Special case: I have it this is the one
                     */
                    boolean win;
                    if (w > ken[right]) {
                        // we can just speak this
                        // It will also cover case if I have 1
                        win = true;
                    } else if (ken[right] == MAX) {
                        win = false;
                    } else {
                        // we have something to speak
                        win = true;
                    }
                    if (win) {
                        left++;
                        naomiDecWarScore++;
                        continue;
                    }
                }
                // CASE 2
                    /* Use it to dismiss Ken largest weight
                 * speak just less than largest
                 * No issue of zero because ken[right] >0
                 */
                right--;
                naomiDecWarScore += 0;
            }
        }

        output.println("Case #" + testN + ": " + naomiDecWarScore + " " + naomiWarScore);
        //System.err.println(Arrays.toString(ken));
        //System.err.println(Arrays.toString(naomi));
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        DeceitfulWar dw = new DeceitfulWar(System.in, System.out);
        dw.solve();
    }
}
