
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class TicTacToeTomek {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;
    private char board[][];

    public TicTacToeTomek(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
        board = new char[4][4];
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = lineToInt(inputSc.nextLine());
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    private void solveTestCase(int testN) {
        if (testN != 1) {
            inputSc.nextLine();
        }
        boolean empty = false;
        for (int i = 0; i < 4; i++) {
            String line = inputSc.nextLine();
            for (int j = 0; j < 4; j++) {
                board[i][j] = line.charAt(j);
                if (board[i][j] == '.') {
                    empty = true;
                }
            }
        }
        String ans = null;
        String xWin = "X won";
        String oWin = "O won";
        String draw = "Draw";
        String incomplete = "Game has not completed";

        // Check all 4 rows
        for (int row = 0; row < 4; row++) {
            int start = 1;
            char firstChar = board[row][0];
            if (firstChar == 'T') {
                firstChar = board[row][1];
                start = 2;
            }
            if (firstChar == '.') {
                continue;
            }
            boolean win = true;
            for (int i = start; i < 4; i++) {
                if (board[row][i] != 'T') {
                    if (board[row][i] != firstChar) {
                        win = false;
                        break;
                    }
                }
            }
            if (win) {
                if (firstChar == 'X') {
                    ans = xWin;
                } else {
                    ans = oWin;
                }
            }
        }
        if (ans == null) {
            // Check all 4 col
            for (int col = 0; col < 4; col++) {
                int start = 1;
                char firstChar = board[0][col];
                if (firstChar == 'T') {
                    firstChar = board[1][col];
                    start = 2;
                }
                if (firstChar == '.') {
                    continue;
                }
                boolean win = true;
                for (int i = start; i < 4; i++) {
                    if (board[i][col] != 'T') {
                        if (board[i][col] != firstChar) {
                            win = false;
                            break;
                        }
                    }
                }
                if (win) {
                    if (firstChar == 'X') {
                        ans = xWin;
                    } else {
                        ans = oWin;
                    }
                }
            }
        }
        if (ans == null) {
            //diagonal 1
            int start = 1;
            char firstChar = board[0][0];
            if (firstChar == 'T') {
                firstChar = board[1][1];
                start = 2;
            }
            if (firstChar != '.') {
                boolean win = true;
                for (int i = start; i < 4; i++) {
                    if (board[i][i] != 'T') {
                        if (board[i][i] != firstChar) {
                            win = false;
                            break;
                        }
                    }
                }
                if (win) {
                    if (firstChar == 'X') {
                        ans = xWin;
                    } else {
                        ans = oWin;
                    }
                }
            }
        }

        if (ans == null) {
            //diagonal 2
            int start = 1;
            char firstChar = board[0][3];
            if (firstChar == 'T') {
                firstChar = board[1][2];
                start = 2;
            }
            if (firstChar != '.') {
                boolean win = true;
                for (int i = start; i < 4; i++) {
                    if (board[i][3 - i] != 'T') {
                        if (board[i][3 - i] != firstChar) {
                            win = false;
                            break;
                        }
                    }
                }
                if (win) {
                    if (firstChar == 'X') {
                        ans = xWin;
                    } else {
                        ans = oWin;
                    }
                }
            }
        }

        if (ans == null) {
            if (empty) {
                ans = incomplete;
            } else {
                ans = draw;
            }
        }

        output.println("Case #" + testN + ": " + ans);
    }

    public static void main(String[] args) {
        TicTacToeTomek tttt = new TicTacToeTomek(System.in, System.out);
        tttt.solve();
    }
}
