
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class B {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;

    public B(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = inputSc.nextInt();
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    int countIncInversion(int a[], int start, int end) {
        int c = 0;
        for (int i = start; i <= end; i++) {
            for (int j = i + 1; j <= end; j++) {
                if (a[i] > a[j]) {
                    c++;
                }
            }
        }
        return c;
    }

    int countDecInversion(int a[], int start, int end) {
        int c = 0;
        for (int i = start; i <= end; i++) {
            for (int j = i + 1; j <= end; j++) {
                if (a[i] < a[j]) {
                    c++;
                }
            }
        }
        return c;
    }

    int getMaxValueIndex(int a[], int start, int end) {
        int maxI = start;
        for (int i = start + 1; i <= end; i++) {
            if (a[i] > a[maxI]) {
                maxI = i;
            }
        }
        return maxI;
    }

    boolean belong(int set, int index) {
        if ((set & (1 << index)) != 0) {
            return true;
        }
        return false;
    }

    private void solveTestCase(int testN) {
        int N = inputSc.nextInt();
        int a[] = new int[N];
        for (int i = 0; i < N; i++) {
            a[i] = inputSc.nextInt();
        }
        int b[] = new int[N];
        int c[] = new int[N];
        int minAns = Integer.MAX_VALUE;
        for (int set = 0; set < (1 << N); set++) {
            int ans = 0;
            for (int i = 0; i < N; i++) {
                if (belong(set, i)) {
                    for (int j = 0; j < i; j++) {
                        if (!belong(set, j)) {
                            ans++;
                        }
                    }
                }
            }
            for (int i = 0; i < N; i++) {
                if (belong(set, i)) {
                    for (int j = i + 1; j < N; j++) {
                        if (belong(set, j) && a[i] > a[j]) {
                            ans++;
                        }
                    }
                }
            }
            for (int i = 0; i < N; i++) {
                if (!belong(set, i)) {
                    for (int j = i + 1; j < N; j++) {
                        if (!belong(set, j) && a[i] < a[j]) {
                            ans++;
                        }
                    }
                }
            }
            minAns = Math.min(minAns, ans);

        }
        output.println("Case #" + testN + ": " + minAns);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        B b = new B(System.in, System.out);
        b.solve();
    }
}
