
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class D {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;
    int M;
    int N;
    String s[];
    int v[];
    int common[][];
    int count[];

    public D(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = lineToInt(inputSc.nextLine());
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    int commonPrefixLength(String s1, String s2) {
        int c = 1;
        int l = Math.min(s1.length(), s2.length());
        for (int i = 0; i < l; i++) {
            if (s1.charAt(i) != s2.charAt(i)) {
                break;
            }
            c++;
        }
        return c;
    }

    void doIt(int index, int coveredMask, int nodeC) {
        if (index == N) {
            if (coveredMask == ((1 << M) - 1)) {
                count[nodeC]++;
            }
            return;
        }
        int set[] = new int[M];
        for (int mask = 1; mask < (1 << M); mask++) {
            if ((mask & coveredMask) != 0) {
                continue;
            }
            int c = 0;
            int ans = 0;
            for (int i = 0; i < M; i++) {
                if ((mask & (1 << i)) != 0) {
                    set[c] = i;
                    ans += v[i];
                    int max = 0;
                    for (int j = 0; j < c; j++) {
                        max = Math.max(max, common[i][set[j]]);
                    }
                    ans -= max;
                    c++;
                }
            }
            doIt(index + 1, coveredMask | mask, nodeC + ans);
        }
    }

    private void solveTestCase(int testN) {
        Scanner tempSc = new Scanner(inputSc.nextLine());
        M = tempSc.nextInt();
        N = tempSc.nextInt();
        s = new String[M];
        for (int i = 0; i < M; i++) {
            s[i] = inputSc.nextLine().trim();
        }
        v = new int[M];
        common = new int[M][M];
        int bestAns = 0;
        for (int i = 0; i < M; i++) {
            v[i] = s[i].length() + 1;
            bestAns += v[i];
        }
        for (int i = 0; i < M; i++) {
            for (int j = i; j < M; j++) {
                int c = commonPrefixLength(s[i], s[j]);
                common[i][j] = common[j][i] = c;
            }
        }
        count = new int[bestAns + 1];
        doIt(0, 0, 0);
        int ansI = -1;
        for (int i = bestAns; i >= 1; i--) {
            if (count[i] > 0) {
                ansI = i;
                break;
            }
        }

        output.println("Case #" + testN + ": " + ansI + " " + count[ansI]);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        D d = new D(System.in, System.out);
        d.solve();
    }
}
