
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class CookieClickerAlpha {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;

    public CookieClickerAlpha(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = lineToInt(inputSc.nextLine());
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    private void solveTestCase(int testN) {
        String str = inputSc.nextLine();
        Scanner tempSc = new Scanner(str);
        double C = tempSc.nextDouble();
        double F = tempSc.nextDouble();
        double X = tempSc.nextDouble();
        final double initRate = 2;
        
        /*
         * By the time we would buy these many farms we can actually reach X in
         * that time with buying farms
         */
        int maxBuyFarmCount = (int) Math.round(X);
        
        double minTime = X/initRate;
        
        double secPerCookie[] = new double[maxBuyFarmCount + 1];
        secPerCookie[0] = 0;
        /*
         * 1/2 + 1/(2+F)  + 1/(2+2F) + 1/(2+3F) + ...
         */
        
        for (int i = 1; i <= maxBuyFarmCount; i++) {
            secPerCookie[i] = secPerCookie[i - 1] + (1.0 / (initRate + (i - 1) * F));
        }

        for (int buyCount = 0; buyCount <= maxBuyFarmCount; buyCount++) {
            double timeYet = C * secPerCookie[buyCount];
            double rateNow = initRate + buyCount * F;
            double timeNeededNow = X / rateNow;
            double totalTime = timeYet + timeNeededNow;
            minTime = Math.min(minTime, totalTime);
        }
        output.println("Case #" + testN + ": " + minTime);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        CookieClickerAlpha cca = new CookieClickerAlpha(System.in, System.out);
        cca.solve();
    }
}
