
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class A {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;

    public A(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = inputSc.nextInt();
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    private void solveTestCase(int testN) {
        int N = inputSc.nextInt();
        int X = inputSc.nextInt();
        int a[] = new int[N];
        boolean covered[] = new boolean[N];
        for (int i = 0; i < N; i++) {
            a[i] = inputSc.nextInt();
        }
        Arrays.sort(a);
        int discCount = 0;
        for (int i = N - 1; i >= 0; i--) {
            if (!covered[i]) {
                for (int j = i - 1; j >= 0; j--) {
                    if (!covered[j]) {
                        if ((a[j] + a[i]) <= X) {
                            covered[j] = true;
                            break;
                        }
                    }
                }
                covered[i] = true;
                discCount++;
            }
        }
        output.println("Case #" + testN + ": " + discCount);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        A a = new A(System.in, System.out);
        a.solve();
    }
}
