
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class Lawnmower {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;

    public Lawnmower(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = inputSc.nextInt();
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    private void solveTestCase(int testN) {
        int n = inputSc.nextInt();
        int m = inputSc.nextInt();
        int a[][] = new int[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                a[i][j] = inputSc.nextInt();
            }
        }
        int rowMax[] = new int[n];
        int colMax[] = new int[m];
        Arrays.fill(rowMax, Integer.MIN_VALUE);
        Arrays.fill(colMax, Integer.MIN_VALUE);
        for (int row = 0; row < n; row++) {
            for (int j = 0; j < m; j++) {
                rowMax[row] = Math.max(rowMax[row], a[row][j]);
            }
        }
        for (int col = 0; col < m; col++) {
            for (int i = 0; i < n; i++) {
                colMax[col] = Math.max(colMax[col], a[i][col]);
            }
        }

        boolean possible = true;
        outer:
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (a[i][j] >= rowMax[i] || a[i][j] >= colMax[j]) {
                } else {
                    possible = false;
                    break outer;
                }
            }
        }


        String ans = "NO";
        if (possible) {
            ans = "YES";
        }
        output.println("Case #" + testN + ": " + ans);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Lawnmower l = new Lawnmower(System.in, System.out);
        l.solve();
    }
}
