
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * @author Abhimanyu Singh
 *
 */
public class MagicTrick {

    private InputStream input;
    private PrintStream output;
    private Scanner inputSc;

    public MagicTrick(InputStream input, PrintStream output) {
        this.input = input;
        this.output = output;
        init();
    }

    private void init() {
        inputSc = new Scanner(input);
    }

    static int lineToInt(String line) {
        return Integer.parseInt(line);
    }

    public void solve() {
        int testCaseCount = inputSc.nextInt();
        for (int testN = 1; testN <= testCaseCount; testN++) {
            solveTestCase(testN);
        }
    }

    private void solveTestCase(int testN) {
        int a1[][] = new int[4][4];
        int a2[][] = new int[4][4];
        int row1;
        int row2;
        boolean present1[] = new boolean[16];
        boolean present2[] = new boolean[16];
        boolean common[] = new boolean[16];

        row1 = inputSc.nextInt() - 1;
        for (int row = 0; row < 4; row++) {
            for (int col = 0; col < 4; col++) {
                a1[row][col] = inputSc.nextInt() - 1;
            }
        }

        row2 = inputSc.nextInt() - 1;
        for (int row = 0; row < 4; row++) {
            for (int col = 0; col < 4; col++) {
                a2[row][col] = inputSc.nextInt() - 1;
            }
        }

        for (int col = 0; col < 4; col++) {
            present1[a1[row1][col]] = true;
        }
        for (int col = 0; col < 4; col++) {
            present2[a2[row2][col]] = true;
        }
        for (int i = 0; i < 16; i++) {
            common[i] = present1[i] && present2[i];
        }
        int count = 0;
        int index = -1;
        for (int i = 0; i < 16; i++) {
            if (common[i]) {
                count++;
                index = i;
            }
        }

        String ans;
        if (count == 0) {
            ans = "Volunteer cheated!";
        } else if (count == 1) {
            ans = "" + (index + 1);
        } else {
            ans = "Bad magician!";
        }
        output.println("Case #" + testN + ": " + ans);
    }

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        MagicTrick mt = new MagicTrick(System.in, System.out);
        mt.solve();
    }
}
