import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class RPI {
	
	public static double WP[];
	public static double OWP[];
	public static double OOWP[];
	public static int a[][];
	public static int N;
	
	public static void main(String args[]) {
		try {
			BufferedReader in = new BufferedReader(
					new FileReader(
							"C:\\Users\\Abhirama\\workspace-rcp\\GCJ11\\src\\A-small-attempt0.in"));
			BufferedWriter out = new BufferedWriter(
					new FileWriter(
							"C:\\Users\\Abhirama\\workspace-rcp\\GCJ11\\src\\A-small-attempt0.out"));
			String line = in.readLine();
			int numTestCases = Integer.parseInt(line);

			for (int z = 0; z < numTestCases; z++) {
				System.out.println("Case #" + (z + 1) + ": ");
				out.write("Case #" + (z + 1) + ": \n");

				line = in.readLine();
				N = Integer.parseInt(line);
				a = new int [N][N];
				WP = new double[N];
				OWP = new double[N];
				OOWP = new double[N];				
				
				for(int i = 0; i < N; i++)
				{
					line = in.readLine();
					for(int j = 0; j < N; j++)
					{
						if(line.charAt(j) == '1')
							a[i][j] = 1;
						else if(line.charAt(j) == '0')
							a[i][j] = 0;
						else
							a[i][j] = -1;
					}
				}
				getWP();
				getOWP();
				getOOWP();
				
				for(int i = 0; i < N; i++)
				{
					double x = getRPI(i);
					System.out.println(x);
					out.write(x + "\n");
				}
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static void getOOWP() {
		for(int i = 0; i < N; i++) // each A 
		{
			double numOOpp = 0;
			double OWPSum = 0;
			for(int j = 0; j < N; j++) // each of A's opp
			{
				if(a[i][j] == -1)
					continue;
				numOOpp++;
				OWPSum += OWP[j]; 
			}
			OOWP[i] = OWPSum / numOOpp;
		}
	}

	private static void getOWP() {
		for(int i = 0; i < N; i++) // each A 
		{
			double numOpp = 0;
			double WPSum = 0;
			for(int j = 0; j < N; j++) // each of A's opp
			{
				double played = 0;
				double won = 0;
				double wp = 0;
				if(a[i][j] == -1)
					continue;
				for(int k = 0; k < N; k++)
				{
					if(a[j][k] == -1 || k == i)
						continue;
					else
						won += a[j][k];
					played++;
				}
				wp += won / played;
				numOpp++;
				WPSum += wp; 
			}
			OWP[i] = WPSum / numOpp;
		}
	}

	private static void getWP() {
		
		for (int i = 0; i < N; i++) 
		{
			double played = 0;
			double won = 0;
			for(int j = 0; j < N; j++)
			{
				if(a[i][j] == -1)
					continue;
				else 
					won += a[i][j];
				played++;
			}
			WP[i] = won / played;
		}
	}

	private static double getRPI(int i) {
		return 0.25 * WP[i] + 0.50 * OWP[i] + 0.25 * OOWP[i];
	}
}
