import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.StringTokenizer;


public class ThemePark {
	public static void main(String args[])
	{
		try {
			BufferedReader in = new BufferedReader(new FileReader("C-small-attempt1.in"));
			String line = in.readLine();
			int numTestCases = Integer.parseInt(line);
			
			for(int z = 0; z < numTestCases; z++)
			{
				System.out.print("Case #" + (z+1) + ": ");
				line = in.readLine();
				int si1 = -1, si2 = -1;
				for(int i = 0; i < line.length(); i++)
					if(line.charAt(i) == ' ')
					{
						if(si1 == -1)
							si1 = i;
						else
							si2 = i;
					}
				int rides = Integer.parseInt(line.substring(0, si1));
				int capacity = Integer.parseInt(line.substring(si1 + 1, si2));
				int numGroups = Integer.parseInt(line.substring(si2+1));
				
				line = in.readLine();
				StringTokenizer st = new StringTokenizer(line, " ");
				int groupSize[] = new int [numGroups];
				int p = 0;
				int totalPeople = 0;
				while(st.hasMoreTokens())
				{
					groupSize[p++] = Integer.parseInt(st.nextElement().toString());
					totalPeople += groupSize[p-1];
				}
				
				if(totalPeople < capacity)
				{
					System.out.println(rides * totalPeople);
					continue;
				}
				
				// logic starts
				// LinkedList init
				HashSet<String> visited = new HashSet<String>();
				String signature = "";
				LinkedList<Integer> linkList = new LinkedList<Integer>();
				LinkedList<Integer> linkListFinal = new LinkedList<Integer>();
				for(int i = 0; i < groupSize.length; i++)
				{
					linkList.addLast(new Integer(groupSize[i]));
					linkListFinal.addLast(new Integer(groupSize[i]));
					signature += groupSize[i] + ",";
				}
				visited.add(signature);
				
				long eurosToStart = 0;
				int numRidesToStart = 0;
				String theSignature = "";
				
				exit:
				while(true)
				{
					int curCap = 0;
					
					while(curCap <= capacity)
					{
						int toAdd = linkList.getFirst().intValue();
						if(toAdd > capacity - curCap)
						{
							signature = generateSignature(linkList);
							if(!visited.add(signature)) // signature already present
							{
								theSignature = signature;
								break exit;
							}
							break; // cant add anymore
						}
						else
						{
							curCap += toAdd;
							linkList.addLast(linkList.removeFirst());
						}
					}
				}
				
				// get the repeat cycle length
				signature = "";
				while(!signature.equals(theSignature))
				{
					int curCap = 0;
					while(curCap <= capacity)
					{
						int toAdd = linkList.getFirst().intValue();
						if(toAdd > capacity - curCap)
						{
							eurosToStart += curCap;
							numRidesToStart++;
							signature = generateSignature(linkList);
							break;
						}
						else
						{
							curCap += toAdd;
							linkList.addLast(linkList.removeFirst());
						}
					}
				}
				
				signature = "";
				int ridesSoFar = 0;
				long eurosSoFar = 0;
				// pre "theSignature" part
				boolean continueFlag = false;
				nextTC1:
				while(!signature.equals(theSignature))
				{
					int curCap = 0;
					while(curCap <= capacity)
					{
						int toAdd = linkListFinal.getFirst().intValue();
						if(toAdd > capacity - curCap)
						{
							eurosSoFar += curCap;
							ridesSoFar++;
							if(ridesSoFar == rides)
							{
								System.out.println(eurosSoFar);
								continueFlag = true;
								break nextTC1;
							}
							signature = generateSignature(linkListFinal);
							break;
						}
						else
						{
							curCap += toAdd;
							linkListFinal.addLast(linkListFinal.removeFirst());
						}
					}
				}
				if(continueFlag)
					continue;
				
				int numCyclesPossible = (rides - ridesSoFar) / numRidesToStart;
				int postSignatureRides = rides - ridesSoFar - numCyclesPossible * numRidesToStart;
				
				eurosSoFar += numCyclesPossible * eurosToStart;
				ridesSoFar += numCyclesPossible * numRidesToStart;
				
				
				continueFlag = false;
				if(postSignatureRides > 0)
				{
					nextTC:
					while(true)
					{
						int curCap = 0;
						while(curCap <= capacity)
						{
							int toAdd = linkListFinal.getFirst().intValue();
							if(toAdd > capacity - curCap)
							{
								eurosSoFar += curCap;
								ridesSoFar++;
								if(ridesSoFar == rides)
								{
									System.out.println(eurosSoFar);
									continueFlag = true;
									break nextTC;
								}
								signature = generateSignature(linkListFinal);
								break;
							}
							else
							{
								curCap += toAdd;
								linkListFinal.addLast(linkListFinal.removeFirst());
							}
						}
					}
					if(continueFlag)
						continue;
				}
				else
					System.out.println(eurosSoFar);
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}

	private static String generateSignature(LinkedList<Integer> linkList) {
		int length = linkList.size();
		String signature = "";
		for(int i = 0; i < length; i++)
		{
			int first = linkList.removeFirst().intValue();
			signature += first + ",";
			linkList.addLast(new Integer(first));
		}
		return signature;
	}
}
