package qualificationRound;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.TreeSet;

public class BathroomStalls {
	
	private class ArrayIndex implements Comparable<ArrayIndex>
	{
		long startIndex;
		long endIndex;
		ArrayIndex(long x, long y)
		{
			startIndex=x;
			endIndex=y;
		}	
		
		public int compareTo(ArrayIndex ai)
		{
			long mySize = endIndex-startIndex + 1;
			long hisSize = ai.endIndex-ai.startIndex+1;
			if(mySize<hisSize){
				return 1;
			}
			else if(mySize>hisSize){
				return -1;
			}
			else if(startIndex<ai.startIndex)
			{
				return -1;
			}
			else if(startIndex>ai.startIndex){
				return 1;
			}
			else{
				return -1;
			}
		}
	}
	
	private class InputOutput
	{
		long n;
		long k;
		long min;
		long max;
		InputOutput(long x, long y)
		{
			n=x;
			k=y;
		}			
	}
	
	public static void main(String args[]) throws IOException
	{
		
		BathroomStalls bs = new BathroomStalls();
		
		//read input
		ArrayList<InputOutput> inputOutputAl = bs.readInput();
		
		//preocess input
		for(InputOutput ipout : inputOutputAl)
		{
			bs.minMax(ipout);
		}
		
		//display output
		for(int i=0;i<inputOutputAl.size();i++)
		{
			bs.display(i+1, inputOutputAl.get(i));
		}
		
	}
	
	public void display(int testCaseNo, InputOutput inout)
	{		
		System.out.println("Case #" + testCaseNo + ": " + inout.max + " " + inout.min);		
	}
	
	public ArrayList<InputOutput> readInput() throws IOException
	{
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(br.readLine());
		ArrayList<InputOutput> al = new ArrayList<InputOutput>();
		
		for(int i=0;i<t;i++){			
			String[] inputString = br.readLine().split("\\s");
			al.add(new InputOutput(Long.parseLong(inputString[0]),Long.parseLong(inputString[1])));			
		}			
		return al;				
	}
	
	public void minMax(InputOutput inputOutput)
	{
		long n = inputOutput.n;
		long k = inputOutput.k;
		
		TreeSet<ArrayIndex> set = new TreeSet<ArrayIndex>();
		set.add(new ArrayIndex(1,n));
		long currentCandidate=0;
		
		while(!set.isEmpty())
		{
			currentCandidate++;
			ArrayIndex ai  = set.pollFirst();
			long start = ai.startIndex;
			long end = ai.endIndex;
			if(start>end){
				continue;
			}
			
			
			long middle = start + (end-start)/2;
			if(currentCandidate==k)
			{
				inputOutput.min = Math.min(middle-start,end-middle);
				inputOutput.max = Math.max(middle-start,end-middle);
				break;
			}
			
			if((end-start+1)%2==0){				
				set.add(new ArrayIndex(middle+1,end));
				set.add(new ArrayIndex(start,middle-1));				
			}
			else
			{
				set.add(new ArrayIndex(start,middle-1));	
				set.add(new ArrayIndex(middle+1,end));				
			}				
		}		
	}

}
