package codeJam2016;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.LinkedHashSet;

public class CountingSheep {
	
	public static HashSet<Integer> findDigits(int n){
		
		HashSet<Integer> hs = new HashSet();
		if(n==0){
			hs.add(0);
			return hs;
		}
						
		while(n/10!=0){
			hs.add(n%10);
			n/=10;
		}
		hs.add(n%10);
		return hs;		
	}
	
	public static int findLastNumber(int n){
		
		if(n==0){
			return Integer.MAX_VALUE;
		}
		
		LinkedHashSet<Integer> hs = new LinkedHashSet();
		int multiplier =1;
		while(hs.size()<10 && multiplier<Integer.MAX_VALUE){
			
			//find all digits;
			HashSet<Integer> localhs = findDigits(multiplier *n);
			hs.addAll(localhs);
			multiplier++;			
		}
		
		if(multiplier==Integer.MAX_VALUE){
			return Integer.MAX_VALUE;
		}
		else{
			return ((multiplier-1) *n);
		}		
	}
	
	public static void main(String args[]){
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));		
		try{
			int tc = Integer.parseInt(br.readLine());
			int[] result = new int[tc];
			for(int i=0;i<tc;i++){				
				//get the number
				int n = Integer.parseInt(br.readLine());
				result[i]=findLastNumber(n);				
			}
			
			//print
			int j=0;
			for(int i=0;i<tc;i++){
				j=i+1;
				if(result[i]!=Integer.MAX_VALUE){
					System.out.println("Case #" + j + ": " + result[i]);
				}
				else{
					System.out.println("Case #" + j + ": INSOMNIA" );
				}
			}
			
			
		}
		catch(IOException e){
			System.out.println("IOException" + e);
		}
		catch(NumberFormatException e){
			System.out.println("NumberFormatException " + e);
		}
		catch(Exception e){
			System.out.println("Exception " + e);
		}
		
		
		
		
		
	}

}
