package qualificationRound;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Pancakes {

	private class InputOutput
	{
		String s;
		int k;
		int flips;
		InputOutput(String s, int k)
		{
			this.s=s;
			this.k=k;
		}		
	}
	
	public InputOutput[] readInput() throws IOException
	{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));		
		int t = Integer.parseInt(br.readLine());
		InputOutput[] inputOutput = new InputOutput[t];
		
		for(int i=0;i<t;i++)
		{
			String input[] = br.readLine().split("\\s");
			inputOutput[i] = new InputOutput(input[0],Integer.parseInt(input[1]));			
		}
		
		return inputOutput;	
	}
	
	public void display(int t, int x)
	{
		if(x==-1)
			System.out.println("Case #" + t + ": IMPOSSIBLE");
		else
			System.out.println("Case #" + t + ": " + x);		
	}
	
	
	public static void main(String args[]) throws IOException
	{
		
		//read input
		Pancakes pc = new Pancakes();
		InputOutput[] inpOut = pc.readInput();
		
		//process the input
		for(int i=0;i<inpOut.length;i++){
			inpOut[i].flips = pc.flips(inpOut[i].s,inpOut[i].k);
		}
		
		//display
		for(int i=0;i<inpOut.length;i++){
			pc.display(i+1, inpOut[i].flips);
		}		
	}
	
	
	
	public int flips(String s, int k)
	{				
		// set inputs
		int totalFlips=0;	
		boolean[] input = new boolean[s.length()];		
		for(int i=0;i<s.length();i++)
		{
			if(s.charAt(i)=='+')
				input[i] = true;
			else
				input[i] = false;
		}
		
		
		//count total flips
		for(int i=0;i<s.length();i++){
			
			if(!input[i] && k > (s.length()-i)){
				return -1;
			}
			
			if(!input[i])
			{
				for(int j=0;j<k;j++){
					input[i+j] = !input[i+j];
				}
				
				totalFlips++;					
			}
		}
		
		return totalFlips;		
	}
}
