package codeJam2016;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Fractiles {
		
	public static long[] findTiles(int K,int C,int S)
	{
		//check the impossible condition
		if(S< (K-C+1)){
			return null;
		}
		
		//truncate S
		if(S > (K-C+1)){
			if(K-C+1 > 0){
				S=K-C+1;
			}
			else{
				S=1;
			}
		}
		
		//check length of k
		if(K==1){
			long[] tiles = new long[1];
			tiles[0]=1;
			return tiles;
		}
		
		//find the tile
		int power=C-2;
		int multiplier=1;
		long result=0;
		while(power>=0){
			result+= multiplier*(Math.pow(K,power));
			multiplier++;
			power--;
		}
		
		//create list of tiles
		long[] tiles = new long[S];
		for(int i=0;i<S;i++){
			tiles[i]= result+i+1;
		}
		
		return tiles;		
	}
	
public static void main(String args[]){
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));		
		try{
			int tc = Integer.parseInt(br.readLine());
			long[][] result = new long[tc][]; 
			for(int i=0;i<tc;i++){
				String s = br.readLine();
				String inputs[] =s.split("\\s");
				int K = Integer.parseInt(inputs[0]);
				int C = Integer.parseInt(inputs[1]);
				int S = Integer.parseInt(inputs[2]);
				result[i]=findTiles(K,C,S);
			}
			
			//print
			int j=0;
			for(int i=0;i<tc;i++){
				j=i+1;
				if(result[i]==null){
					System.out.println("Case #" + j + ": IMPOSSIBLE");
				}
				else{
					System.out.print("Case #" + j + ":");
					for(int k=0;k<result[i].length;k++){
						System.out.print(" ");
						System.out.print(result[i][k]);
					}
					System.out.println();
				}
			}
		}
		catch(IOException e){
			System.out.println("IOException" + e);
		}
		catch(NumberFormatException e){
			System.out.println("NumberFormatException " + e);
		}
		catch(Exception e){
			System.out.println("Exception " + e);
		}

}
}

