package abhi;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTacToeTomek {
	
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileInputStream("A-large.in"));
		PrintWriter out = new PrintWriter(new FileWriter("A-large.out"));
		
		int totalCases = sc.nextInt();
		
		char[][] matrix = new char[4][4]; 
		char[][] transpose = new char[4][4];
		
		String line = null;

		//For each case
		for(int i = 1; i <= totalCases; i++) {
			line = sc.nextLine();
			
			//Read Matrix
			for(int x = 0; x < 4; x++) {
				line = sc.nextLine();
				for(int y = 0; y < 4; y++) {
					matrix[x][y] = line.charAt(y);
					transpose[y][x] = matrix[x][y];
				}
			}
			
			//Check if 'X' won
			if(checkIfWon(matrix, transpose, 'X')) {
				out.println("Case #" + i + ": X won");
				continue;
			}
			
			//Else Check if 'O' won
			if(checkIfWon(matrix, transpose, 'O')) {
				out.println("Case #" + i + ": O won");
				continue;
			}
			
			//Else Check if draw
			if(checkIfBoardFull(matrix)) {
				out.println("Case #" + i + ": Draw");
				continue;
			}
			
			//Else report incomplete
			out.println("Case #" + i + ": Game has not completed");
		}
		
		out.close();
	}

	private static boolean checkIfBoardFull(char[][] matrix) {
		for(int x = 0; x < 4; x++) {
			for(int y = 0; y < 4; y++) {
				if(matrix[x][y] == '.') {
					return false;
				}
			}
		}
		return true;
	}

	private static boolean checkIfWon(char[][] matrix, char[][] transpose, char c) {
		for(int x = 0; x < 4; x++) {
			if(		(matrix[x][0] == c || matrix[x][0] == 'T') &&
					(matrix[x][1] == c || matrix[x][1] == 'T') &&
					(matrix[x][2] == c || matrix[x][2] == 'T') &&
					(matrix[x][3] == c || matrix[x][3] == 'T')) {
				return true;
			}
		}
		
		for(int x = 0; x < 4; x++) {
			if(		(transpose[x][0] == c || transpose[x][0] == 'T') &&
					(transpose[x][1] == c || transpose[x][1] == 'T') &&
					(transpose[x][2] == c || transpose[x][2] == 'T') &&
					(transpose[x][3] == c || transpose[x][3] == 'T')) {
				return true;
			}
		}
		
		if(		(matrix[0][0] == c || matrix[0][0] == 'T') &&
				(matrix[1][1] == c || matrix[1][1] == 'T') &&
				(matrix[2][2] == c || matrix[2][2] == 'T') &&
				(matrix[3][3] == c || matrix[3][3] == 'T')) {
			return true;
		}

		if(		(matrix[0][3] == c || matrix[0][3] == 'T') &&
				(matrix[1][2] == c || matrix[1][2] == 'T') &&
				(matrix[2][1] == c || matrix[2][1] == 'T') &&
				(matrix[3][0] == c || matrix[3][0] == 'T')) {
			return true;
		}
		
		return false;
	}

}
