import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;


public class Dijkstra {
	
	private static Map<String, String> evaluateMap = new HashMap<String, String>();
	private static Map<String, String> multiplyMap = new HashMap<String, String>();

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		String fileName = "C-small-attempt1";
		Scanner in = new Scanner(new File(fileName + ".in"));
		PrintWriter out = new PrintWriter(new FileWriter(fileName + ".out"));
		
		int T = in.nextInt();
		
		for(int i=1; i<=T; i++) {
			try {
				System.out.println(i);
				out.println("Case #" + i + ": " + solve(in));
			} catch(Throwable t) {
				System.out.println(i + " " + t);
			}
		}
		
		in.close();
		out.close();
	}

	private static String solve(Scanner in) {
		
		int L = in.nextInt();
		int X = in.nextInt();
		in.nextLine();
		String orig = in.nextLine();
		String actual = "";
		
		for(int i=0; i<X; i++) {
			actual = actual.concat(orig);
		}
		
		if(actual.length() < 3) {
			return "NO";
		}
		
		if(evaluate(actual) != "-1") {
			return "NO";
		}
		
		for(int i=1; i<=L*X-2; i++) {
			String first = evaluate(actual.substring(0, i));
			if(!"i".equals(first)) {
				continue;
			}
//			if(evaluate(actual.substring(i)) != "i") {
//				continue;
//			}
			for(int j=1; j<=L*X-i-1; j++) {
//				System.out.println("Evaluating " + actual.substring(0, i) + ", " + actual.substring(i, i+j) + ", " + actual.substring(i+j));
				String second = evaluate(actual.substring(i, i+j));
				if(!"j".equals(second)) {
					continue;
				}
				String third = evaluate(actual.substring(i+j));
//				System.out.println("Evaluation " + first + ", " + second + ", " + third);
				
				if("i".equals(first) && "j".equals(second) && "k".equals(third)) {
					return "YES";
				} else {
					return "NO";
				}
			}
			break;
		}

		return "NO";
	}
	
	private static String evaluate(String str) {
//		System.out.println("here " + str);
		str = str.replace("iiii", "");
		str = str.replace("jjjj", "");
		str = str.replace("kkkk", "");
		if(str.length() == 0) {
			return "1";
		}
		String masterKey = str;
//		for(String key: evaluateMap.keySet()) {
//			if(!evaluateMap.get(key).startsWith("-")) {
//				str = str.replace(key, evaluateMap.get(key));
//			}
//		}
//		System.out.println(str);
		String evaluate = evaluateMap.get(str);
		if(evaluate != null ) {
			return evaluate;
		}
		
		if(str.length() == 1) {
			return str.substring(0, 1);
		}

		String last;
		if(str.length() > 2) { 
			last = multiply(str.substring(0, 1), evaluate(str.substring(1)));
		} else {
			last = multiply(str.substring(0, 1), str.substring(1));
		}
		
//		evaluateMap.put(masterKey, last);
		return last;
	}

	private static String multiply(String a, String b) {
		String key = a.concat(b);
		String multiply = multiplyMap.get(key);
		if(multiply != null) {
			return multiply;
		}
		
		String sign = "";
		if(a.startsWith("-")) {
			sign = "-";
			a = a.replace("-", "");
		}
		if(b.startsWith("-")) {
			if("-".equals(sign)) {
				sign = "";
			} else {
				sign = "-";
			}
			b = b.replace("-", "");
		}
				
		if("1".equals(a) && "1".equals(b)) {
			multiply = sign + "1";
		} else if("1".equals(a) && "i".equals(b)) {
			multiply = sign + "i";
		} else if("1".equals(a) && "j".equals(b)) {
			multiply = sign + "j";
		} else if("1".equals(a) && "k".equals(b)) {
			multiply = sign + "k";
		} else if("i".equals(a) && "1".equals(b)) {
			multiply = sign + "i";
		} else if("i".equals(a) && "i".equals(b)) {
			multiply = "-".equals(sign)? "1": "-1";
		} else if("i".equals(a) && "j".equals(b)) {
			multiply = sign + "k";
		} else if("i".equals(a) && "k".equals(b)) {
			multiply = "-".equals(sign)? "j": "-j";
		} else if("j".equals(a) && "1".equals(b)) {
			multiply = sign + "j";
		} else if("j".equals(a) && "i".equals(b)) {
			multiply = "-".equals(sign)? "k": "-k";
		} else if("j".equals(a) && "j".equals(b)) {
			multiply = "-".equals(sign)? "1": "-1";
		} else if("j".equals(a) && "k".equals(b)) {
			multiply = sign + "i";
		} else if("k".equals(a) && "1".equals(b)) {
			multiply = sign + "k";
		} else if("k".equals(a) && "i".equals(b)) {
			multiply = sign + "j";
		} else if("k".equals(a) && "j".equals(b)) {
			multiply = "-".equals(sign)? "i": "-i";
		} else if("k".equals(a) && "k".equals(b)) {
			multiply = "-".equals(sign)? "1": "-1";
		} else {
			throw new Error();
		}
		
		multiplyMap.put(key, multiply);
		return multiply;
	}
}
