package test;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;
import java.util.SortedSet;
import java.util.TreeSet;

public class RPI {
	
	static int N;
	
	static int[][] matrix;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);

		int T = sc.nextInt();

		for(int i=1;i<=T;i++)
		{
			N = sc.nextInt();
			
			matrix = new int[N][N];
			
			for(int j=0;j<N;j++)
			{
				String str = sc.next();
				
				char[] tokens = str.toCharArray();
				
				int k = 0;
				for(char c: tokens)
				{
					matrix[j][k++] = c=='.'?-1:Character.getNumericValue(c);
				}				
			}
			
			System.out.println("Case #"+i+":");
			for(int j=0;j<N;j++)
			{
				System.out.println(getWPForI(j)*0.25+getOWP(j)*0.5+getOOWP(j)*0.25);
			}
		}
	}
	
	static float getWPForI(int i)
	{
		float win = 0;
		int total = 0;
		for(int k=0;k<N;k++)
		{
			if(matrix[i][k] != -1)
			{
				total++;
			}
			if(matrix[i][k] == 1)
			{
				win++;
			}
		}

		return win/total;
	}

	static float getWPForIExcludeJ(int i, int j)
	{
		float win = 0;
		int total = 0;
		for(int k=0;k<N;k++)
		{
			if(k == j)
			{
				continue;
			}
			if(matrix[i][k] != -1)
			{
				total++;
			}
			if(matrix[i][k] == 1)
			{
				win++;
			}
		}

		return win/total;
	}	
	
	static float getOWP(int i)
	{
		float totalOWP = 0;
		int totalOps = 0;
		for(int k=0;k<N;k++)
		{
			if(matrix[i][k] != -1)
			{
				totalOWP = totalOWP + getWPForIExcludeJ(k, i);
				totalOps++;
			}
		}
		
		return totalOWP/totalOps;
	}
	
	static float getOOWP(int i)
	{
		float totalOOWP = 0;
		int totalOps = 0;
		for(int k=0;k<N;k++)
		{
			if(matrix[i][k] != -1)
			{
				totalOOWP = totalOOWP + getOWP(k);
				totalOps++;
			}
		}
		
		return totalOOWP/totalOps;		
	}
}
