package abhi;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Lawnmover {

	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileInputStream("B-large.in"));
		PrintWriter out = new PrintWriter(new FileWriter("B-large.out"));
		
		int totalCases = sc.nextInt();

		//For each case
		for(int i = 1; i <= totalCases; i++) {
			//Read dimensions
			int x = sc.nextInt();
			int y = sc.nextInt();

			//Read Matrix
			int[][] matrix = new int[x][y];
			for(int a = 0; a < x; a++) {
				for(int b = 0; b < y; b++) {
					matrix[a][b] = sc.nextInt();
				}
			}
			
			//Evaluate Possiblity
			out.println("Case #"+i+": " + isPossible(matrix));
		}
		
		out.close();
	}
	
	static String isPossible(final int[][] matrix) {
		//Check each cell
		for(int a = 0; a < matrix.length; a++) {
			for(int b = 0; b < matrix[a].length; b++) {
				boolean horizontal = true, vertical = true;

				//Traverse horizontally
				for(int m=0; m < matrix[a].length; m++) {
					if(matrix[a][m] > matrix[a][b]) {
						horizontal = false;
						break;
					}
				}
				
				//Traverse vertically
				for(int m=0; m < matrix.length; m++) {
					if(matrix[m][b] > matrix[a][b]) {
						vertical = false;
						break;
					}
				}
				
				//If both horizontal and vertical false then return false
				if (!horizontal && !vertical) {
					return "NO";
				}
			}
		}
		
		return "YES";
	}

}
