import java.util.PriorityQueue;
import java.util.Scanner;

public class C {
	
	public static class Segment implements Comparable<Segment> {
		
		public int start;
		public int end;
		
		public Segment(int start, int end) {
			this.start = start;
			this.end = end;
		}
		
		public int getSize() {
			return end-start+1;
		}

		@Override
		public int compareTo(Segment target) {
			
			if (this.getSize() != target.getSize()) {
				return target.getSize() - this.getSize(); 
			}
						
			return this.start - target.start;
		}
	}

	public static void main(String[] args) {
		
		Scanner scanner = null;

		try {
			scanner = new Scanner(System.in);
			int T = scanner.nextInt();
			
			for (int t = 1; t <= T; t++) {
				System.out.println("Case #" + t + ": " + process(scanner));
			}
		} finally {
			scanner.close();
		}
	}
	
	private static String process(Scanner scanner) {
		
		String returnVal = "";
		
		int N = scanner.nextInt();
		int K = scanner.nextInt();
		
		PriorityQueue<Segment> segments = new PriorityQueue<>();
		segments.add(new Segment(1, N));
		
		for (int k = 0; k < K; k++) {
			Segment segment = segments.poll();
			int mid = (segment.end+segment.start)/2;
			
			if (k == K-1) {
				returnVal += (segment.end-mid) + " " + (mid-segment.start);
				break;
			}
			
			if(segment.getSize() > 2) {
				segments.add(new Segment(segment.start, mid-1));
				segments.add(new Segment(mid+1, segment.end));
			} else if (segment.getSize() == 2) {
				segments.add(new Segment(mid+1, segment.end));
			}
		}
						
		return returnVal;
	}

}
