package codejam;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class CandySplit {

	public static void main(String[] args) throws  Exception{

		File inputFile = new File("./file/candy.in.txt");
		File outputFile = new File("./file/candy.out.txt");
	
		Scanner sc = new Scanner(inputFile);
		
		BufferedWriter bw = new BufferedWriter(new FileWriter(outputFile));
		
		int testcases = sc.nextInt();
		
		for(int i=0;i<testcases;i++){
			System.out.println("test case " + (i+1));
		
			int N = sc.nextInt();
			List<Integer> lst1 = new ArrayList<Integer>();
			List<Integer> lst2 = new ArrayList<Integer>();
			
			for(int j=0;j<N;j++)
				lst2.add(sc.nextInt());
			
			int max = 0;
			
			if (XORSum(lst2) != 0)
				max = -1;
			
			Collections.sort(lst2);
			
			if(max !=-1)
				max = maxSplit(lst1, lst2);
			
			if(max==-1)
				bw.write("Case #" + (i+1) + ": NO" );
			else
				bw.write("Case #" + (i+1) + ": " + max );
			bw.newLine();
		}	
		bw.close();
		sc.close();
	}
	
	public static int maxSplit(List<Integer> lst1, List<Integer> lst2){
		
		int max = -1;
		
		if(lst2.isEmpty())
			return max;
		if(XOREqual(lst1, lst2)){
			max = Math.max(max, Math.max(sum(lst1), sum(lst2)));
			System.out.println("Comparing " + lst1 +  " " + lst2 + " equal " + max);
			return max;
		}
		for(int i=lst2.size()-1;i>=0;i--){
			List<Integer> lst11 = new ArrayList<Integer>();
			List<Integer> lst21 = new ArrayList<Integer>();
			
			lst11.addAll(lst1);
			lst21.addAll(lst2);
			
			int num = lst21.get(i);
			
			lst11.add(num);
			lst21.remove(i);
			
			max = Math.max(max, maxSplit(lst11, lst21));
		}
		return max;
	}
	
	public static boolean XOREqual(List<Integer> lst1, List<Integer> lst2){
		return XORSum(lst1) == XORSum(lst2);
	}
	
	public static int XORSum(List<Integer> lst){
		if (lst.isEmpty())
			return -1;
		int xor = lst.get(0);
		for(int i=1;i<lst.size();i++)
			xor = xor ^ lst.get(i);
		
		return xor;
	}
	
	
	public static int sum(List<Integer> lst){
		int total = 0;
		for(int i: lst)
			total = total + i;
		
		return total;
	}
}
