package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class Watersheds {

	/**
	 * @param args
	 */
	static final char initChar = 'a';
	static char charSeq = initChar;
	
	public static void main(String[] args) throws Exception{
		
		File inputFile = new File("C:/watershed.in.txt");
		File outputFile = new File("C:/watershed.out.txt");

		BufferedReader br = new BufferedReader(new FileReader(inputFile));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outputFile));
		
		int maps = Integer.parseInt(br.readLine());
		
		
		for(int i=0;i<maps;i++){
			
			charSeq = initChar;
			
			int[][] height;
			char [][] sinkList;
			
			String tmp[] = br.readLine().split(" ");
			
			int H = Integer.parseInt(tmp[0]);
			int W = Integer.parseInt(tmp[1]);
			
			height = new int[H][W];
			sinkList = new char[H][W];
			
			for(int j=0;j<H;j++){
				
				tmp = br.readLine().split(" ");
				
				for(int k=0;k<W;k++){
					height[j][k] = Integer.parseInt(tmp[k]);
					sinkList[j][k] = initChar -1 ;
				}
			}
			
			sinkList = initSink(height, sinkList, H, W);
			
			bw.write("Case #" + (i+1) +":");
			bw.newLine();
			
			for(int j=0;j<H;j++){
				for(int k=0;k<W;k++){
					bw.write(sinkList[j][k] + " ");
					System.out.print(sinkList[j][k] + " ");
				}
				bw.newLine();
				System.out.println();
			}
			
		}
		
		bw.close();
		br.close();

	}

	private static char[][] initSink(int[][] height, char[][] sinkList, int H,
			int W) {
		
		for(int j=0;j<H;j++){
			
			inner:
			for(int k=0;k<W;k++){
				
				if(sinkList[j][k] != (initChar-1))
					continue inner;
				
		//		System.out.println(sinkList[j][k]+ " J:" + j + " K:" + k + " " + (initChar-1) + " " + ((initChar-1) == sinkList[j][k]));
				
				if((initChar-1) == sinkList[j][k]){  
					sinkList[j][k] = charSeq;
					charSeq ++;
					
					sinkList = flow(height, sinkList, H, W, j, k);
				}
			}
		}
		
		return sinkList;
		
	}

	private static char[][] flow(int[][] height, char[][] sinkList, int H,
			int W, int currX, int currY) {
		
		int minHeight;
		direction flowDir = direction.None;
	
		
		int heights[] = new int[4];
		
		minHeight = height[currX][currY];
		
		for(int i=0;i<4;i++)
			heights[i] = minHeight;
		
		
		
		if(currX -1 >= 0){
			//North
			heights[0] = height[currX-1][currY];
		
			if(heights[0] < minHeight){
				minHeight = heights[0];
				
				
					flowDir = direction.North;
			}
			
		}
		
		if(currY -1 >= 0){
			//West
			heights[1] = height[currX][currY-1];
			
			if(heights[1] < minHeight){
				minHeight = heights[1];
				
				
					flowDir = direction.West;
			}
		}
		
		if(currY +1 < W){
			//East
			heights[2] = height[currX][currY+1];
			
			if(heights[2] < minHeight){
				minHeight = heights[2];
				
				
					flowDir = direction.East;
			}
		}
		
		if(currX +1 < H){
			//South
			heights[3] = height[currX+1][currY];
			
			if(heights[3] < minHeight){
				minHeight = heights[3];
				
					flowDir = direction.South;
			}
		}
		
		if(flowDir != direction.None)
		{
	//		System.out.println(flowDir);
			
			if(flowDir == direction.North){
				
				if(sinkList[currX-1][currY] != (initChar-1)){
					char rep = sinkList[currX][currY];
					
					for(int j=0;j<H;j++){
						for(int k=0;k<W;k++){
							if(sinkList[j][k] == rep)
								sinkList[j][k] = sinkList[currX-1][currY];
						}
					}
					charSeq --;

					return sinkList;
				}
				
				sinkList[currX-1][currY] = sinkList[currX][currY];
				sinkList = flow(height,sinkList, H, W, currX-1, currY);
			}
			if(flowDir == direction.West){
				
				if(sinkList[currX][currY-1] != (initChar-1)){
					char rep = sinkList[currX][currY];
					
					for(int j=0;j<H;j++){
						for(int k=0;k<W;k++){
							if(sinkList[j][k] == rep)
								sinkList[j][k] = sinkList[currX][currY-1];
						}
					}
					charSeq --;

					return sinkList;
				}
				
				sinkList[currX][currY-1] = sinkList[currX][currY];
				sinkList = flow(height,sinkList, H, W, currX, currY-1);
			}
			if(flowDir == direction.East){
				
				if(sinkList[currX][currY+1] != (initChar-1)){
					char rep = sinkList[currX][currY];
					
					for(int j=0;j<H;j++){
						for(int k=0;k<W;k++){
							if(sinkList[j][k] == rep)
								sinkList[j][k] = sinkList[currX][currY+1];
						}
					}
					charSeq --;

					return sinkList;
				}
				
				sinkList[currX][currY+1] = sinkList[currX][currY];
				sinkList = flow(height,sinkList, H, W, currX, currY+1);
			}
			if(flowDir == direction.South){
				
				if(sinkList[currX+1][currY] != (initChar-1)){
					char rep = sinkList[currX][currY];
					
					for(int j=0;j<H;j++){
						for(int k=0;k<W;k++){
							if(sinkList[j][k] == rep)
								sinkList[j][k] = sinkList[currX+1][currY];
						}
					}
					charSeq --;

					return sinkList;
				}
				
				sinkList[currX+1][currY] = sinkList[currX][currY];
				sinkList = flow(height,sinkList, H, W, currX+1, currY);
			}
				
		}
		
		
		return sinkList;
	
		
	}

	enum direction{
		North,
		West,
		East,
		South,
		None
	}
}
