package server;

import java.io.File;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.Scanner;

/**
 * Created by IntelliJ IDEA.
 * User: Abhinandan
 * Date: 4/12/14
 * Time: 5:05 PM
 * To change this template use File | Settings | File Templates.
 */
public class MineSweeper {

    public static void main(String[] args) throws IOException {
        File file = new File("C:\\Users\\sony\\Downloads\\googleCode\\C-small-attempt1.in");
        File ofile = new File("C:\\Users\\sony\\Downloads\\googleCode\\output.txt");

        Scanner scanner = new Scanner(file);
        RandomAccessFile oscanner = new RandomAccessFile(ofile, "rw");
        int testCases = scanner.nextInt();
        scanner.nextLine();
        Grid currGrid;
        for (int tCase = 0; tCase < testCases; tCase++) {
            currGrid = new Grid(scanner.nextInt(),scanner.nextInt(),scanner.nextInt());
            currGrid.solvePuz(oscanner, tCase);
        }
    }
    public static class Grid{
        int[][] grid;
        int rows;
        int cols;
        int mines;

        public Grid(int rows, int cols, int mines) {
            this.rows = rows;
            this.cols = cols;
            this.mines = mines;
            this.grid  = new int[rows][cols];
        }

        public void solvePuz(RandomAccessFile oscanner,int tCase) throws IOException {
            System.out.println(tCase+" "+rows+" "+cols+" "+mines);
            oscanner.write(("Case #" + (tCase + 1) + ":").getBytes());
            oscanner.writeBytes("\r\n");
            int blocks = rows*cols;
            int availableBlks = blocks-mines;
            boolean primeNo= isPrime(availableBlks);
            if(primeNo){
                if(rows==1){
                    fillGrid(1,availableBlks,oscanner,tCase);
                    printGrid(oscanner);
                }
                else if(cols==1){
                    fillGrid(availableBlks,1,oscanner,tCase);
                    printGrid(oscanner);
                }
                else{
                    oscanner.write("Impossible".getBytes());
                    oscanner.writeBytes("\r\n");
                }
            }
            else{
                int[] subGrid = findDimOfSubGrid(availableBlks);
                if(subGrid ==null){
                    int blcksToBefilled =0;
                    if(availableBlks<rows && availableBlks%rows!=1){
                        blcksToBefilled = availableBlks - availableBlks%rows;
                    }
                    else if(availableBlks < cols && availableBlks%cols!=1){
                        blcksToBefilled = availableBlks - availableBlks%cols;
                    }
                    else{
                        oscanner.write("Impossible".getBytes());
                        oscanner.writeBytes("\r\n");
                        return;
                    }
                    int[] dims = findDimOfSubGrid(blcksToBefilled);
                    int cellsLeft = availableBlks-blcksToBefilled;
                    fillGrid(dims[0],dims[1],oscanner,tCase);
                    if(dims[1]<cols){
                        for(int i = dims[1]-1;i<cols && cellsLeft>0;i++,cellsLeft--)
                            grid[dims[0]-1][i]=-1;
                    }
                    if(cellsLeft>0){
                        for(int i = dims[0];i<rows && cellsLeft>0;i++)
                              for(int j = 0;j<cols&&cellsLeft>0;j++,cellsLeft--)
                                  grid[i][j]=-1;
                    }
                }
                else
                    fillGrid(subGrid[0],subGrid[1],oscanner,tCase);
                printGrid(oscanner);
            }
        }
        public int[] findDimOfSubGrid(int availableBlks){
            if(rows==1 && availableBlks<=cols)
                return new int[]{1,availableBlks};
            for(int i=2;i<=rows;i++){
                if(availableBlks%i==0 && availableBlks/i<=cols)
                    return new int[]{i,availableBlks/i};
            }
            return null;
        }
        public void fillGrid(int i,int j,RandomAccessFile oscanner,int tCase) throws IOException {
            if(i==0 || j==0){
                oscanner.write("Impossible".getBytes());
                oscanner.writeBytes("\r\n");
                return;
            }
            for(int k=0;k<i;k++){
                for(int q=0;q<j;q++){
                    grid[k][q]=-1;
                }
            }
        }
        public void printGrid(RandomAccessFile oscanner) throws IOException {
            for(int k=0;k<rows;k++){
                for(int q=0;q<cols;q++){
                    if(grid[k][q]==-1){
                        if(k==0&&q==0)
                            oscanner.write("c".getBytes());
                        else
                            oscanner.write(".".getBytes());
                    }
                    else{
                        oscanner.write("*".getBytes());
                    }
                }
                oscanner.writeBytes("\r\n");
            }
        }
        //checks whether an int is prime or not.
        boolean isPrime(int n) {
            //check if n is a multiple of 2
            if(n==2 || n==1) return true;
            if (n%2==0) return false;
            //if not, then just check the odds
            for(int i=3;i*i<=n;i+=2) {
                if(n%i==0)
                    return false;
            }
            return true;
        }
    }
}
