import java.io.*;

public abstract class Common{
    int T;

    int currentCase;
    String currentResult;
    String testCase;
    String inputFile;
    String outputFile;
    BufferedReader brFile;

    public Common(String fileName) throws Exception{
        this.testCase = fileName;
        this.inputFile = this.testCase + ".in";
        this.outputFile = this.testCase + ".out";
        this.brFile = new BufferedReader(new FileReader(inputFile));
    }

    public String input() throws Exception {
        String sCurrentLine = this.brFile.readLine();
        return sCurrentLine;
    }

    public void output (String content) throws Exception {
        File file = new File(this.outputFile);

        // if file doesn't exists, then create it
        if (!file.exists()) {
            file.createNewFile();
        }

        FileWriter fw = new FileWriter(file.getAbsoluteFile(), true);
        BufferedWriter bw = new BufferedWriter(fw);
        bw.write(content);
        bw.close();
    }

    public void start() throws Exception{
        this.T = Integer.parseInt(this.input());
        System.out.println("No. of Cases: " + this.T);

        for(int i=0; i<this.T; i++){
            System.out.println("\nCase #" + (this.currentCase = i+1));
            System.out.println("Result:" + (this.currentResult = this.Case()));
            this.output("Case #" + this.currentCase + ": " + this.currentResult +"\n");
        }
    }

    abstract String Case() throws Exception;
}
