package codejam;

import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class TicTac {

    public static void main(String[] a) throws Exception {
        process("TicTac.in");
    }

    public static void process(String filename) throws Exception {
        File file = new File(filename);
        Scanner in = new Scanner(file);
        numberOfCase = Integer.parseInt(in.nextLine());
        String[] results = new String[numberOfCase];
        for (int i = 0; i < numberOfCase; i++) {
            char[][] board = new char[4][4];
            for (int j = 0; j < 4; j++) {
                board[j] = in.nextLine().toCharArray();
            }
            results[i] = checkWinner(board);
            if (i < numberOfCase - 1) {
                in.nextLine();
            }
        }
        in.close();
        output(results);
    }

    static String checkWinner(char[][] board) {
        char[] pls = new char[]{'X', 'O'};
        for (char p : pls) {
            if (checkRightAndDown(board, p) || checkDiagonal(board, p)) {
                return p + " won";
            }
        }
        if (finished(board)) {
            return "Draw";
        }
        return "Game has not completed";
    }

    static boolean checkRightAndDown(char[][] board, char c) {
        for (char[] row : board) {
            if (check(row, c)) {
                return true;
            }
        }
        for (int i = 0; i < 4; i++) {
            char[] col = new char[4];
            for (int j = 0; j < 4; j++) {
                col[j] = board[j][i];
            }
            if (check(col, c)) {
                return true;
            }
        }
        return false;
    }

    static boolean checkDiagonal(char[][] board, char c) {
        char[] diag = new char[4];
        for (int i = 0; i < 4; i++) {
            diag[i] = board[i][i];
        }
        if (check(diag, c)) {
            return true;
        }
        diag = new char[4];
        for (int i = 0; i < 4; i++) {
            diag[i] = board[i][3 - i];
        }
        if (check(diag, c)) {
            return true;
        }
        return false;
    }

    static boolean check(char[] row, char c) {
        int count = 0;
        for (int i = 0; i < row.length; i++) {
            if (row[i] == c) {
                count++;
            } else if (row[i] == 'T') {
                count++;
            } else {
                break;
            }
        }
        return count > 3;
    }

    static boolean finished(char[][] board) {
        for (char[] row : board) {
            for (char c : row) {
                if (c == '.') {
                    return false;
                }
            }
        }
        return true;
    }

    public static void output(String[] results) throws Exception {
        File file = new File("TicTac.out");
        FileWriter out = new FileWriter(file);
        for (int i = 0; i < results.length; i++) {
            out.write("Case #" + (i + 1) + ": " + results[i]);
            out.write(i < results.length - 1 ? "\n" : "");
        }
        out.close();
    }
    static int numberOfCase = 0;
}
