package codejam;

import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Scanner;

public class Lawnmower {

    public static void main(String[] a) throws Exception {
        process("Lawnmower.in");
    }

    public static void process(String filename) throws Exception {
        File file = new File(filename);
        Scanner in = new Scanner(file);
        numberOfCase = Integer.parseInt(in.nextLine());
        String[] results = new String[numberOfCase];
        for (int i = 0; i < numberOfCase; i++) {
            Scanner s = new Scanner(in.nextLine());
            int[][] pattern = new int[s.nextInt()][s.nextInt()];
            for (int j = 0; j < pattern.length; j++) {
                s = new Scanner(in.nextLine());
                for (int k = 0; k < pattern[j].length; k++) {
                    pattern[j][k] = s.nextInt();
                }
            }
            results[i] = mow(pattern);
            System.out.println("case " + i + " " + results[i]);
        }
        in.close();
        output(results);
    }

    static String mow(int[][] pattern) {
        HashMap<Integer, ArrayList<int[]>> numMap = new HashMap<>();
        ArrayList<Integer> nums = new ArrayList<>();
        for (int i = 0; i < pattern.length; i++) {
            for (int j = 0; j < pattern[i].length; j++) {
                int num = pattern[i][j];
                if (i == 0 || j == 0 || i == pattern.length - 1 || j == pattern[i].length - 1) {
                    if (numMap.get(num) == null) {
                        numMap.put(num, new ArrayList<int[]>());
                    }
                    ArrayList<int[]> array = numMap.get(num);
                    if (i == pattern.length - 1 && j == pattern[i].length - 1) {
                        array.add(new int[]{0, j});
                        array.add(new int[]{i, 0});
                    }else if (i == pattern.length - 1) {
                        array.add(new int[]{0, j});
                    } else if (j == pattern[i].length - 1) {
                        array.add(new int[]{i, 0});
                    } else {
                        array.add(new int[]{i, j});
                    }
                }
                if (!nums.contains(num)) {
                    nums.add(num);
                }
            }
        }
        Integer[] numsArr = nums.toArray(new Integer[0]);
        Arrays.sort(numsArr);
        for (int n : numsArr) {
            ArrayList<int[]> list = numMap.get(n);
            if (list == null) {
                return "NO";
            }
            for (int[] l : list) {
//                System.out.println(n + " " + Arrays.toString(l) + " " + Arrays.toString(numsArr));
                if (!isPossible(n, pattern, l)) {
                    return "NO";
                }
            }
        }
        return "YES";
    }

    static boolean isPossible(int n, int[][] pattern, int[] pos) {
        if (pos[0] == 0) {
            boolean passed = true;
            for (int i = 0; i < pattern.length; i++) {
                if (n < pattern[i][pos[1]]) {
                    passed = false;
                    break;
                }
            }
            if (passed) {
                return true;
            }
        }
        if (pos[1] == 0) {
            boolean passed = true;
            for (int i = 0; i < pattern[0].length; i++) {
                if (n < pattern[pos[0]][i]) {
                    passed = false;
                    break;
                }
            }
            if (passed) {
                return true;
            }
        }
        return false;
    }

    public static void output(String[] results) throws Exception {
        File file = new File("Lawnmower.out");
        FileWriter out = new FileWriter(file);
        for (int i = 0; i < results.length; i++) {
            out.write("Case #" + (i + 1) + ": " + results[i]);
            out.write(i < results.length - 1 ? "\n" : "");
        }
        out.close();
    }
    static int numberOfCase = 0;
}
