package codejam;

import java.io.File;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.Scanner;

public class SpeakingInTongues {

    public static void main(String[] a) throws Exception {
        process("Tongues.in");
    }

    public static void process(String filename) throws Exception {
        makeMap();
        File file = new File(filename);
        Scanner in = new Scanner(file);
        numberOfCase = Integer.parseInt(in.nextLine());
        String[] results = new String[numberOfCase];
        for (int i = 0; i < numberOfCase; i++) {
            String row = in.nextLine();
            results[i] = "" + solve(row);
        }
        in.close();
        output(results);
    }

    public static void output(String[] results) throws Exception {
        File file = new File("Tongues.out");
        FileWriter out = new FileWriter(file);
        for (int i = 0; i < results.length; i++) {
            out.write("Case #" + (i + 1) + ": " + results[i]);
            out.write(i < results.length - 1 ? "\n" : "");
        }
        out.close();
    }

    public static String solve(String row) {
        char[] c = row.toCharArray();
        for (int i=0; i <row.length(); i++){
            c[i] = hashMap.get(c[i]);
        }
        return new String(c);
    }
    
    static void makeMap(){
        hashMap = new HashMap<Character, Character>();
        for (int i=0; i<tongues.length(); i++){
            hashMap.put(tongues.charAt(i), english.charAt(i));
        }
    }
    
    public static final String tongues = "z q ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv";
    public static final String english = "q z our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up";
    
    public static int numberOfCase = 0;
    public static HashMap<Character, Character> hashMap;
}
