package codejam;

import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class Palindrome {

    public static void main(String[] a) throws Exception {
        process("Palindrome.in");
    }

    public static void process(String filename) throws Exception {
        File file = new File(filename);
        Scanner in = new Scanner(file);
        numberOfCase = Integer.parseInt(in.nextLine());
        String[] results = new String[numberOfCase];
        for (int i = 0; i < numberOfCase; i++) {
            results[i] = count(in.nextInt(), in.nextInt());
            if (i < numberOfCase - 1) {
                in.nextLine();
            }
        }
//        System.out.println("==========");
        in.close();
        output(results);
    }

    static String count(int low, int high){
        int count = 0;
        for (int i=1,j=i*i; j <= high; j=++i*i){
            if (j >= low && fairAndSquare(j)){
                count++;
//                System.out.println(j);
            }
        }
        return count + "";
    }
    
    static boolean fairAndSquare(long num){
        if (!isPalindrome(num)){
            return false;
        }
        long num1 = (long) Math.sqrt(num);
        if (num1 * num1 != num){
            return false;
        }
        return isPalindrome(num1);
    }
    
    static boolean isPalindrome(long num){
        StringBuilder s = new StringBuilder(num + "");
        String orig = s.toString();
        s.reverse();
        return s.toString().equals(orig);
    }

    public static void output(String[] results) throws Exception {
        File file = new File("Palindrome.out");
        FileWriter out = new FileWriter(file);
        for (int i = 0; i < results.length; i++) {
            out.write("Case #" + (i + 1) + ": " + results[i]);
            out.write(i < results.length - 1 ? "\n" : "");
        }
        out.close();
    }
    static int numberOfCase = 0;
    
}
