import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

public class C {
	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			int[] arr = readIntArrayFromFile(4);
			int J = arr[0];
			int P = arr[1];
			int S = arr[2];
			int K = arr[3];
			String ans = combos(J, P, S, K);

			writeAnswer(i + 1, ans);
		}
		closeFiles();

	}

	private static String combos(int j, int p, int s, int k) {
		int[][] combos = new int[j * p * s][3];
		int idx = 0;
		List<CSet> l1 = new ArrayList<CSet>();

		for (int a = 0; a < j; a++) {
			for (int b = 0; b < p; b++) {
				for (int c = 0; c < s; c++) {
					combos[idx][0] = a+1;
					combos[idx][1] = b+1;
					combos[idx][2] = c+1;
					idx++;
				}
			}
		}
		int a1 = j * p;
		int a2 = p * s;
		int a3 = j * s;
		int i1 = 0;
		int i2 = 0;

		if (a1 < a2) {
			i1 = 0;
			i2 = 1;
		} else if (a2 < a3) {
			i1 = 1;
			i2 = 2;
		} else {
			i1 = 0;
			i2 = 2;
		}
		a1 = (a1 < a3) ? a1 : a3;
		a1 = a1*k;
		int count = 0;
		int ind = 0;
		String s1 = "";
		do {
			CSet cSet = new CSet();
			cSet.i1 = combos[ind][i1];
			cSet.i2 = combos[ind][i2];

			if (l1.indexOf(cSet)>= 0) {
				if(l1.get(l1.indexOf(cSet)).count < k)
				{
					l1.get(l1.indexOf(cSet)).count++;
					s1 = s1 + combos[ind][0] +" " +combos[ind][1]+" "+ combos[ind][2] + "\n";
					count++;
				}
			}
			else {
				s1 = s1 + combos[ind][0] +" " +combos[ind][1]+" "+ combos[ind][2] + "\n";
				count++;
				cSet.count++;
				l1.add(cSet);
			}
			ind++;
		} while (count < a1 && ind < combos.length);
return Integer.toString(count) + "\n"+s1;
	}

	private static int[] readIntArrayFromFile(int len) throws IOException {
		int[] in = new int[len];
		int j = 0;
		for (String s : reader.readLine().split("\\s")) {
			in[j++] = Integer.parseInt(s);
		}
		return in;
	}

	private static String[] readStringArrayFromFile(int len) throws IOException {
		return reader.readLine().split("\\s");
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine();
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, Object... ans) throws IOException {
		writer.write("Case #" + i + ":");
		for (Object a : ans)
			writer.write(" " + a);
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}

	static class CSet {
		int i1;
		int i2;
		int count = 0;

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + i1;
			result = prime * result + i2;
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			CSet other = (CSet) obj;
			if (i1 != other.i1)
				return false;
			if (i2 != other.i2)
				return false;
			return true;
		}
	}
}
