import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;


public class A {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		if (args==null || args.length != 2){
			System.out.println("Usage java A <inputfile> <ouputfile>");
			System.exit(-1);
		}

		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(args[0])));
		PrintWriter out = new PrintWriter(args[1]);
		
		int cases = Integer.parseInt(in.readLine());
		for (int c = 0; c < cases; c++){
			String[] s = in.readLine().split("\\s");
			int rows = Integer.parseInt(s[0]);
			int cols = Integer.parseInt(s[1]);
			char[][] pattern = new char[rows][cols];
			List<Point> blues = new LinkedList<Point>();
			boolean possible = true;
			for (int row = 0; row < rows; row++){
				String line = in.readLine();
				char[] tiles = line.toCharArray();
				pattern[row] = new char[cols];
				for (int col = 0; col < cols && possible; col++){
					pattern[row][col] = tiles[col];
					if (tiles[col] == '#'){
						Point tile = new Point(row, col);
						if (!blues.contains(tile)){
							if (row >= rows - 1 || col >= cols -1){
								//Border
								possible = false;
							} else {
								Point p2 = new Point(row, col + 1);
								Point p3 = new Point(row + 1, col);
								Point p4 = new Point(row + 1, col + 1);
								List<Point> redList = new ArrayList<Point>(3);
								redList.add(p2);
								redList.add(p3);
								redList.add(p4);
								if (Collections.disjoint(redList, blues)){
									tile.setRed('/');
									p2.setRed('\\');
									p3.setRed('\\');
									p4.setRed('/');
									blues.add(tile);
									blues.addAll(redList);
								} else {
									possible = false;
								}
							}
						}
					}
				}
			}
			
			if (possible){
				for (Point p: blues){
					if (pattern[p.row][p.col] == '#'){
						pattern[p.row][p.col] = p.red;
					} else {
						possible = false;
						break;
					}
				}
			}
			
			System.out.println(String.format("Case #%s:", c+1));
			out.println(String.format("Case #%s:", c+1));
			if (possible){
				for (int row = 0; row < rows; row++){
					System.out.println(new String(pattern[row]));
					out.println(new String(pattern[row]));
				}
			}else {
				System.out.println("Impossible");
				out.println("Impossible");
			}
		}		
		
		in.close();
		out.close();
	}
	
	private static class Point{
		private int row, col;
		private char red = '*';
		public Point(int row, int col){
			this.row=row;
			this.col=col;
		}
		
		@Override
		public boolean equals(Object obj){
			Point p = (Point) obj;
			return p.row==row && p.col==col;
		}

		public char getRed() {
			return red;
		}

		public void setRed(char red) {
			this.red = red;
		}
	}

}
