package com.google.codejam2011.qualification;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Collection;
import java.util.LinkedList;
import java.util.List;

public class TestB {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		if (args.length != 2){
			System.out.println("Usage: java " + TestB.class.getName() + " <inputfile> <outputfile>");
			System.exit(-1);
		}
		FileInputStream fin = new FileInputStream(args[0]);
		BufferedReader in = new BufferedReader(new InputStreamReader(fin));
		FileOutputStream fos = new FileOutputStream(args[1]); 
		PrintWriter out = new PrintWriter(new OutputStreamWriter(fos));
		int cases = Integer.valueOf(in.readLine());
		for (int i = 0; i < cases; i++){
			String line = in.readLine();
			String[] lineParts = line.split("\\s");
			int cs = Integer.parseInt(lineParts[0]);
			List<Combination> combinations = new LinkedList<TestB.Combination>();
			List<Destruction> destructions = new LinkedList<TestB.Destruction>();
			LinkedList<Character> chars = new LinkedList<Character>();
			for (int j = 0; j < cs; j++){
				combinations.add(new Combination(lineParts[j + 1]));
			}
			int ds = Integer.parseInt(lineParts[cs + 1]);
			for (int j = 0; j < ds; j++){
				destructions.add(new Destruction(lineParts[j + 1 + cs + 1]));
			}
			int ns = Integer.parseInt(lineParts[cs + 1 + ds + 1]);
			String nss = lineParts[cs + 1 + ds + 1 + 1];
			for (int j = 0; j < ns; j++){
				char cur = nss.charAt(j);
				if (!chars.isEmpty()){
					boolean combined = false;
					do {
						combined = false;
						char last = chars.peekLast();
						for (Combination comb : combinations){
							if (comb.isConvert(cur, last)){
								chars.pollLast();
								cur = comb.getResult();
								combined = true;
								break;
							}
						}
					} while (combined && !chars.isEmpty());
				}
				boolean destroyed = false;
				if (!chars.isEmpty()){
					for (Destruction dest: destructions){
						if (dest.isDestroy(chars, cur)){
							chars.clear();
							destroyed = true;
							break;
						}
					}
				}
				if (!destroyed){
					chars.add(cur);
				}
			}
			
			String result = String.format("Case #%s: %s", i+1, Arrays.toString(chars.toArray()));
			out.println(result);
			System.out.println(result);
		}
		out.close();
		in.close();
	}
	
	

	private static class Combination{
		private char a;
		private char b;
		private char c;

		public Combination(String comb) {
			this.a = comb.charAt(0);
			this.b = comb.charAt(1);
			this.c = comb.charAt(2);
		}
		
		public boolean isConvert(char x, char y){
			return (a==x && b==y || a==y && b==x);
		}
		
		public char getResult(){
			return c;
		}
	}
	
	private static class Destruction{
		private char a;
		private char b;
		
		public Destruction(String dest) {
			this.a = dest.charAt(0);
			this.b = dest.charAt(1);
		}

		public boolean isDestroy(Collection<Character> chars, char x){
			return (chars.contains(a) && x == b || chars.contains(b) && x == a);
		}
	}
}
