import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class Template {
	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	public static void main(String[] args) throws IOException {


		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			int num = readIntFromFile();
			List<String> first = new ArrayList<>();
			List<String> second = new ArrayList<>();
			for(int j = 0;j < num; j++)
			{
				String[] readStringArrayFromFile = readStringArrayFromFile(2);
				first.add(readStringArrayFromFile[0]);
				second.add(readStringArrayFromFile[1]);
				
				
			}
			int ans = fakes(first, second, num);
			writeAnswer(i + 1, ans );
			first.clear();
			second.clear();
		}
		closeFiles();
	
	}
	
	private static int fakes(List<String> first, List<String> second, int num) {
		int f = 0;
		Set<Integer> fakeIndx = new TreeSet<Integer>();
		for(int i = 0; i < num; i++)
		{
			if(findIndex(i, first, fakeIndx) && findIndex(i, second ,fakeIndx))
			{
				fakeIndx.add(i);
				f++;
			}
			
		}
		return f;
	}
	
	static boolean findIndex(int j, List<String> second, Set<Integer> fakeIndx) {
		String string = second.get(j);
		for(int i = 0 ; i < second.size(); i++)
			if(string.equalsIgnoreCase(second.get(i))){
				if(i != j && !fakeIndx.contains(i))
					return true;
			}
		return false;
	}

	private static int[] readIntArrayFromFile(int len) throws IOException {
		int[] in = new int[len];
		int j = 0;
		for (String s : reader.readLine().split("\\s")) {
			in[j++] = Integer.parseInt(s);
		}
		return in;
	}

	private static String[] readStringArrayFromFile(int len) throws IOException {
		return reader.readLine().split("\\s");
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine();
	}
	
	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, Object... ans) throws IOException {
		writer.write("Case #" + i + ":");
		for (Object a : ans)
			writer.write(" " + a);
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}
}
