import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;


public class C {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		if (args==null || args.length != 2){
			System.out.println("Usage java C <inputfile> <ouputfile>");
			System.exit(-1);
		}

		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(args[0])));
		PrintWriter out = new PrintWriter(args[1]);
		
		int cases = Integer.parseInt(in.readLine());
		for (int c = 0; c < cases; c++){
			String[] s = in.readLine().split("\\s");
			int n = Integer.parseInt(s[0]);
			long l = Long.parseLong(s[1]);
			long h = Long.parseLong(s[2]);
			
			s = in.readLine().split("\\s");
			
			long frequency = -1l;
			if (l == 1){
				frequency = 1l;
			} else {
				List<Long> tones = new ArrayList<Long>(n);
				for (int i = 0; i < n; i++){
					tones.add(Long.parseLong(s[i]));
				}
				Collections.sort(tones);
//				Collections.reverse(tones);
				Map<Long, Integer> factors = new HashMap<Long, Integer>();
				for (Long tone: tones){
					Map<Long, Integer> tf = new HashMap<Long, Integer>();
					long t = tone;
					if (t == 1l){
						add(tf, t);
					} else {
						long to = (long)Math.sqrt(t);
						for (long i = 2; i <= to; i++){
							if (t % i == 0){
								add(tf, i);
								t = t / i;
								to = (long)Math.sqrt(t);
								i--;
							}
						}
						if (t > 1){
							add(tf, t);
						}
					}
					
					for (Entry<Long, Integer> entry: tf.entrySet()){
						if (factors.containsKey(entry.getKey())){
							Integer amount = factors.get(entry.getKey());
							if (entry.getValue() > amount){
								factors.put(entry.getKey(), entry.getValue());
							}
						} else {
							factors.put(entry.getKey(), entry.getValue());							
						}
					}
				}
				
				long result = 1;
				for (Entry<Long, Integer> entry: factors.entrySet()){
//					for (int i = 0; i < entry.getValue(); i++){
						result *= entry.getKey();
//					}
				}
				
				if (result >=l && result <= h){
					frequency = result;
				}
			}
			
			if (frequency < 0){
				System.out.println(String.format("Case #%s: NO", c+1));
				out.println(String.format("Case #%s: NO", c+1));				
			} else {
				System.out.println(String.format("Case #%s: %s", c+1, frequency));
				out.println(String.format("Case #%s: %s", c+1, frequency));
			}
		}		
		
		in.close();
		out.close();
	}
	
	public static void add(Map<Long, Integer> tf, Long f){
		Integer integer = tf.get(f);
		if (integer == null){
			tf.put(f, 1);
		} else {
			tf.put(f, integer + 1);
		}
	}
}
