import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class A {
	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;
	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			int parties = readIntFromFile();
			int[] senates = readIntArrayFromFile(parties);
			String plan = evac(senates, parties);
			writeAnswer(i + 1, plan);
		}
		closeFiles();

	}

	private static String evac(int[] senates, int parties) {
		
StringBuilder sb = new StringBuilder();
int evac = 0;
		do{
			String s = "";
			int sum = sum(senates, parties);
			int mjor1= (sum - 1)/2 + 1;
			int mjor2= (sum - 2)/2 + 1;
			evac =0;
			int [] temp = Arrays.copyOf(senates, parties);
			for(int i = parties - 1; i >= 0; i--)
			{
				if(temp[i] >= mjor2)
				{
					temp[i] = temp[i] - 1;
					char a = (char) (65+i);
					s += a;
					evac++;
					i++;
				}
			}
			if(evac > 1)
			{
				temp = Arrays.copyOf(senates, parties);
				s="";
				evac =0;
				for(int i = parties - 1; i >= 0; i--)
				{
					if(temp[i] >= mjor1)
					{
						temp[i] = temp[i] - 1;
						char a = (char) (65+i);
						s += a;
						evac++;
					}
				}
			}
			if(evac == 0 )
			{
				for(int i = 0; i < parties; i++)
				{
					if(temp[i] >= 1)
					{
						temp[i] = temp[i] - 1;
						char a = (char) (65+i);
						s += a;
						evac++;
						break;
					}
				}
			}
			sb.append(s).append(" ");
			senates = Arrays.copyOf(temp, parties);
		}while(evac != 0);
		return sb.toString();
	}

	private static int sum(int[] senates, int parties) {
		int sum = 0;
		for (int s : senates)
			sum += s;
		return sum;

	}

	private static int[] readIntArrayFromFile(int len) throws IOException {
		int[] in = new int[len];
		int j = 0;
		for (String s : reader.readLine().split("\\s")) {
			in[j++] = Integer.parseInt(s);
		}
		return in;
	}

	private static String[] readStringArrayFromFile(int len) throws IOException {
		return reader.readLine().split("\\s");
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine();
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, Object... ans) throws IOException {
		writer.write("Case #" + i + ":");
		for (Object a : ans)
			writer.write(" " + a);
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}
}

