import java.util.HashSet;


public class TicTacToeTomek {

	static char X = 'X';
	static char O = 'O';
	static char DONT_CARE = 'T';
	static char VOID = '.';

	static String X_WON = ": X won"; // (the game is over, and X won)
	static String O_WON = ": O won"; // (the game is over, and O won)
	static String DRAW = ": Draw"; // (the game is over, and it ended in a draw)
	static String INCOMPLETE = ": Game has not completed"; // (the game is not
															// over yet)
	static String OUTPUT_PREF = "Case #";

	static int ROWS = 4;
	static char[][] ticTac;
	static HashSet<Integer> voidRows = new HashSet<>();
	static HashSet<Integer> voidCols = new HashSet<>();
	static int[][] diag1, diag2;

	static {
		ticTac = new char[ROWS][];
		diag1 = new int[ROWS][];
		diag2 = new int[ROWS][];
		for (int i = 0; i < ROWS; i++) {
			ticTac[i] = new char[ROWS];
			diag1[i] = new int[2];
			diag2[i] = new int[2];
			diag1[i][0] = i;
			diag1[i][1] = i;
			diag2[i][0] = i;
			diag2[i][1] = ROWS - 1 - i;
			for (int j = 0; j < ROWS; j++)
				ticTac[i][j] = VOID;
		}
	}

	static String FILE_IN = "C:\\Users\\inkrabh\\Downloads\\A-small-attempt0.in";
	static String FILE_OUT = "C:\\Users\\inkrabh\\Desktop\\A-small-attempt0.out";
	static ReadWriteUtil reader = new ReadWriteUtil(FILE_IN, 0);
	static ReadWriteUtil writer = new ReadWriteUtil(FILE_OUT, 1);

	public static void main(String[] args) {

		int testCaseNo = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= testCaseNo; i++) {
			String op;
			initTicTac();
			char msg = scanTicTac();
			if (msg == 0) {
				if (!voidCols.isEmpty())
					op = OUTPUT_PREF + i + INCOMPLETE;
				else
					op = OUTPUT_PREF + i + DRAW;
			} else {
				if (msg == 'X')
					op = OUTPUT_PREF + i + X_WON;
				else
					op = OUTPUT_PREF + i + O_WON;

			}
			writer.writeLine(op);
		}
		reader.clean();
		writer.clean();
	}

	private static char scanTicTac() {
		char winParty = scanDiagonals();
		if (winParty == 0) {
			winParty = scanRows();
			if (winParty == 0) {
				winParty = scanCols();
			}
		}
		return winParty;
	}

	private static char scanRows() {
		for (int i = 0; i < ROWS; i++) {
			if (!voidRows.contains(i)) {
				char x = ticTac[i][0];
				boolean winStatus = true;
				for (int j = 0; j < ROWS; j++) {
					char y = ticTac[i][j];
					if (x == y || y == DONT_CARE || x == DONT_CARE) {
						if (y != DONT_CARE)
							x = y;
						continue;
					} else {
						winStatus = false;
						break;
					}
				}
				if (winStatus) {
					return x;
				}
			}
		}
		return 0;
	}

	private static char scanCols() {
		for (int i = 0; i < ROWS; i++) {
			if (!voidCols.contains(i)) {
				char x = ticTac[0][i];
				boolean winStatus = true;
				for (int j = 0; j < ROWS; j++) {
					char y = ticTac[j][i];
					if (x == y || y == DONT_CARE || x == DONT_CARE) {
						if (y != DONT_CARE)
							x = y;
						continue;
					} else {
						winStatus = false;
						break;
					}
				}
				if (winStatus) {
					return x;
				}
			}
		}
		return 0;
	}

	private static char scanDiagonals() {
		boolean winStatus = true;
		char x = ticTac[diag1[0][0]][diag1[0][1]];
		for (int[] d : diag1) {
			char y = ticTac[d[0]][d[1]];
			if (y == VOID) {
				winStatus = false;
				break;
			}
			if (x == y || y == DONT_CARE || x == DONT_CARE) {
				if (y != DONT_CARE)
					x = y;
				continue;
			} else {
				winStatus = false;
				break;
			}
		}
		if (winStatus) {
			return x;
		}
		winStatus = true;
		x = ticTac[diag2[0][0]][diag2[0][1]];
		for (int[] d : diag2) {
			char y = ticTac[d[0]][d[1]];
			if (y == VOID) {
				winStatus = false;
				break;
			}
			if (x == y || y == DONT_CARE || x == DONT_CARE) {
				if (y != DONT_CARE)
					x = y;
				continue;
			} else {
				winStatus = false;
				break;
			}
		}
		if (winStatus) {
			return x;
		}
		return 0;
	}

	private static void initTicTac() {
		voidCols.clear();
		voidRows.clear();
		for (int i = 0; i < ROWS; i++) {
			String ip = reader.readLine();
			if (ip.indexOf(VOID) > -1)
				voidRows.add(i);
			for (int j = 0; j < ROWS; j++) {
				char ch = ip.charAt(j);
				ticTac[i][j] = ch;
				if (ch == VOID)
					voidCols.add(j);
			}
		}
		reader.readLine();
	}

}
