package com.google.codejam2011.qualification;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class TestA {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		if (args.length != 2){
			System.out.println("Usage: java " + TestA.class.getName() + " <inputfile> <outputfile>");
			System.exit(-1);
		}
		FileInputStream fin = new FileInputStream(args[0]);
		BufferedReader in = new BufferedReader(new InputStreamReader(fin));
		FileOutputStream fos = new FileOutputStream(args[1]); 
		PrintWriter out = new PrintWriter(new OutputStreamWriter(fos));
		int cases = Integer.valueOf(in.readLine());
		for (int i = 0; i < cases; i++){
			String line = in.readLine();
			String[] lineParts = line.split("\\s");
			int tasks = Integer.parseInt(lineParts[0]);
			Queue<Position> sequence = new LinkedList<Position>();
			Queue<Integer> bluetasks = new LinkedList<Integer>();
			Queue<Integer> orangetasks = new LinkedList<Integer>();
			for (int task = 0; task < tasks; task++){
				Robot r = Robot.valueOf(lineParts[(task * 2) + 1]);
				int pos = Integer.parseInt(lineParts[(task + 1) * 2]);
				sequence.add(new Position(r, pos));
				if (r == Robot.O){
					orangetasks.add(pos);
				} else {
					bluetasks.add(pos);
				}
			}
			
			int stepCount = 0;
			int oPos = 1;
			int bPos = 1;
			while (!sequence.isEmpty()){
				stepCount++;
				Position curStep = sequence.peek();
				if (curStep.getRobot() == Robot.O){
					if (oPos == curStep.getPos()){
						sequence.poll();
						orangetasks.poll();
						System.out.println("Press O " + oPos);
					} else if (oPos < curStep.getPos()){
						oPos++;
						System.out.println("Move O to " + oPos);
					} else {
						oPos--;
						System.out.println("Move O to " + oPos);
					}
					
					if (!bluetasks.isEmpty()){
						int bTarget = bluetasks.peek();
						if (bPos == bTarget){
							System.out.println("Wait B");
						} else if (bPos < bTarget){
							bPos++;
							System.out.println("Move B to " + bPos);
						} else {
							bPos--;
							System.out.println("Move B to " + bPos);
						}
					}
				} else {
					if (bPos == curStep.getPos()){
						sequence.poll();
						bluetasks.poll();
						System.out.println("Press B " + bPos);
					} else if (bPos < curStep.getPos()){
						bPos++;
						System.out.println("Move B to " + bPos);
					} else {
						bPos--;
						System.out.println("Move B to " + bPos);
					}
					
					if (!orangetasks.isEmpty()){
						int oTarget = orangetasks.peek();
						if (oPos == oTarget){
							System.out.println("Wait O");
						} else if (oPos < oTarget){
							oPos++;
							System.out.println("Move O to " + oPos);
						} else {
							oPos--;
							System.out.println("Move O to " + oPos);
						}
					}
				}
			}
			
			String result = String.format("Case #%s: %s", i+1, stepCount);
			out.println(result);
			System.out.println(result);
		}
		out.close();
		in.close();
	}
	
	private static enum Robot{
		O, B
	}

	private static class Position{
		private Robot robot;
		private int pos;
		public Position(Robot robot, int pos) {
			this.robot = robot;
			this.pos = pos;
		}
		public Robot getRobot() {
			return robot;
		}
		public int getPos() {
			return pos;
		}
	}
}
