import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class C {
	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	static char[] preced = { 'Z', 'W', 'U', 'X', 'O', 'F', 'V', 'N', 'G', 'R' };
	static char[][] letters = { { 'Z', 'E', 'R', 'O' }, { 'T', 'W', 'O' },
			{ 'F', 'O', 'U', 'R' }, { 'S', 'I', 'X' }, { 'O', 'N', 'E' },
			{ 'F', 'I', 'V', 'E' }, { 'S', 'E', 'V', 'E', 'N' },
			{ 'N', 'I', 'N', 'E' }, { 'E', 'I', 'G', 'H', 'T' },
			{ 'T', 'H', 'R', 'E', 'E' } };
	static int[] num = { 0, 2, 4, 6, 1, 5, 7, 9, 8, 3 };

	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			String ans = phoneNum(readStringFromFile().toCharArray());
			writeAnswer(i + 1, ans);
		}
		closeFiles();

	}

	private static String phoneNum(char[] charArray) {
		List<Integer> ph = new ArrayList<>();

		Arrays.sort(charArray);
		int i = 0;
		List<Character> l = new ArrayList<Character>();
		for (int j = 0; j < charArray.length; j++)
			l.add(charArray[j]);
		for (int j = 0; j < 10; j++) {
			while (Collections.binarySearch(l, preced[i]) >= 0) {
				ph.add(num[i]);
				for (char letter : letters[j])
					l.remove(Collections.binarySearch(l, letter));
			}
			i++;
		}
		Collections.sort(ph);
		StringBuilder s = new StringBuilder();
		for (Integer p : ph)
			s.append(p);
		return s.toString();
	}

	private static int[] readIntArrayFromFile(int len) throws IOException {
		int[] in = new int[len];
		int j = 0;
		for (String s : reader.readLine().split("\\s")) {
			in[j++] = Integer.parseInt(s);
		}
		return in;
	}

	private static String[] readStringArrayFromFile(int len) throws IOException {
		return reader.readLine().split("\\s");
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine();
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, Object... ans) throws IOException {
		writer.write("Case #" + i + ":");
		for (Object a : ans)
			writer.write(" " + a);
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}
}
