package com.google.codejam2011.qualification;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class TestC {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		if (args.length != 2){
			System.out.println("Usage: java " + TestC.class.getName() + " <inputfile> <outputfile>");
			System.exit(-1);
		}
		FileInputStream fin = new FileInputStream(args[0]);
		BufferedReader in = new BufferedReader(new InputStreamReader(fin));
		FileOutputStream fos = new FileOutputStream(args[1]); 
		PrintWriter out = new PrintWriter(new OutputStreamWriter(fos));
		int cases = Integer.valueOf(in.readLine());
		for (int i = 0; i < cases; i++){
			int pieces = Integer.parseInt(in.readLine());
			String line = in.readLine();
			String[] lineParts = line.split("\\s");
			List<Long> values = new ArrayList<Long>(pieces);
			long completeSum = 0L;
			long largeSum = 0L;
//			long smallSum = 0L;
			for (int j = 0; j < pieces; j++){
				long value = Long.parseLong(lineParts[j]);
				values.add(value);
				largeSum = largeSum ^ value;
//				smallSum += value % 4;
				completeSum += value;
			}
			Collections.sort(values);
			
			String result = String.format("Case #%s: %s", i+1, largeSum == 0L ? completeSum - values.get(0) : "NO");
			out.println(result);
			System.out.println(result);
		}
		out.close();
		in.close();
	}

}
