import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;

public class TheLastWord {

	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			String ans = lastWord(readStringFromFile());
			writeAnswer(i + 1, ans);
		}
		closeFiles();
	}

	private static String lastWord(String string) {
		char[] charArray = string.toCharArray();
		StringBuilder sb = new StringBuilder();
		sb.append(charArray[0]);
		int count = 0;
		for (int i = 1; i < charArray.length; i++) {
			if (charArray[i] >= sb.charAt(0))
				sb.insert(0, charArray[i]);
			else
				sb.append(charArray[i]);
		}
		return sb.toString();
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine();
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, String ans) throws IOException {
		writer.write("Case #" + i + ": " + (ans));
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}
}
