package com.google.codejam2011.qualification;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class TestD {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		if (args.length != 2){
			System.out.println("Usage: java " + TestD.class.getName() + " <inputfile> <outputfile>");
			System.exit(-1);
		}
		FileInputStream fin = new FileInputStream(args[0]);
		BufferedReader in = new BufferedReader(new InputStreamReader(fin));
		FileOutputStream fos = new FileOutputStream(args[1]); 
		PrintWriter out = new PrintWriter(new OutputStreamWriter(fos));
		int cases = Integer.valueOf(in.readLine());
		for (int i = 0; i < cases; i++){
			int pieces = Integer.parseInt(in.readLine());
			String line = in.readLine();
			String[] lineParts = line.split("\\s");
			List<Integer> values = new ArrayList<Integer>(pieces);
			for (int j = 0; j < pieces; j++){
				int value = Integer.parseInt(lineParts[j]);
				values.add(value);
			}
			
			List<Integer> sorted = new ArrayList<Integer>(values);
			int sortedNum = 0;
			int sortedCur = 0;
			Collections.sort(sorted);
			for (int j = 0; j < pieces; j++){
				if (sorted.get(j).intValue() == values.get(j).intValue()){
					sortedCur++;
				} else {
					if (sortedCur > sortedNum){
						sortedNum = sortedCur;
					}
					sortedCur = 0;
				}
			}
			
			
			String result = String.format("Case #%s: %s", i+1, pieces - sortedNum + ((pieces - sortedNum) % 2));
			out.println(result);
			System.out.println(result);
		}
		out.close();
		in.close();
	}
}
