import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;


public class ReadWriteUtil {
	private int mode; // READ=0 or WRITE=1
	private BufferedReader br;
	private DataInputStream in;
	private PrintStream pr;
	private FileOutputStream out;

	/**
	 * 
	 * @param fileName
	 * @param mode
	 *            0 for read; 1 from write.
	 */
	public ReadWriteUtil(String fileName, int mode) {
		this.mode = mode;
		if (mode == 0) {
			try {
				FileInputStream fileStream = new FileInputStream(fileName);
				in = new DataInputStream(fileStream);
				br = new BufferedReader(new InputStreamReader(in));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		} else {
			try {
				out = new FileOutputStream(fileName);
				pr = new PrintStream(out);
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

		}
	}

	/**
	 * Read each subsequent line. <br>
	 * Note: Use with mode 0 only;
	 * 
	 * @return
	 */
	public String readLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}

	public void writeLine(String line) {
		pr.println(line);
	}

	public void clean() {
		try {
			if (mode == 0)
				in.close();
			else
				out.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
}
