import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.BitSet;

public class CountingSheep {

	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			int start = readIntFromFile();
			String limit = countUntilMatches(start);
			writeAnswer(i + 1, limit);
		}
		closeFiles();
	}

	private static String countUntilMatches(int s) {
		BitSet digits = new BitSet(10);
		long start = s;
		setBits(start, digits);
		if(start == 0) return "INSOMNIA";
		while (digits.cardinality() != 10) {
			start += s;
			setBits(start, digits);
		}
		return Long.toString(start);
	}

	private static void setBits(long start, BitSet digits) {

		while (start > 0) {
			digits.set((int)(start % 10));
			start = start / 10;
		}
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, String b) throws IOException {
		writer.write("Case #" + i + ": " + (b));
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}

}
