import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;

public class RevengeOfThePancakes {

	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			String stack = readStringFromFile();
			int ans = calculate(stack);
			writeAnswer(i + 1, ans);
		}
		closeFiles();
	}

	private static int calculate(String stack) {
		int count = 0;
		int i = 0;
		while ((i = signChangesAt(stack, i)) < stack.length()) {
			stack = invert(stack, i);
			count++;
		}
		if (stack.charAt(0) == '-')
			count++;
		return count;
	}

	private static String invert(String stack, int upto) {
		char c = stack.charAt(0) == '+' ? '-' : '+';
		String s = stack;
		if (upto > 0) {
			char[] cArr = new char[upto];
			Arrays.fill(cArr, c);
			s = new String(cArr);
			s = s + stack.substring(upto);
		}
		return s;
	}

	private static int signChangesAt(String stack, int j) {
		char charAt = stack.charAt(j);
		while (++j < stack.length() && stack.charAt(j) == charAt)
			;
		return j;
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine().trim();
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, int ans) throws IOException {
		writer.write("Case #" + i + ": " + (ans));
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}

}
