import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class A {
	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			int[] charArray = toIntArray();
			int length = charArray.length - 1;
			// 32143290
			for (int j = 0; j < length; j++) {
				boolean b = isTidyAtPosition(charArray, j);
				if (!b) {
					charArray[j]--;
					Arrays.fill(charArray, j + 1, length + 1, 9);
					length = j;
					j = -1;
				}
			}
			char[] chars = toCharArray(charArray);
			 writeAnswer(i + 1, new Long(new String(chars)));
		}
		closeFiles();

	}

	private static char[] toCharArray(int[] charArray) {
		char[] intArray = new char[charArray.length];
		int i = 0;
		for (int c : charArray) {
			intArray[i++] = Character.forDigit(c, 10);
		}
		return intArray;
	}

	private static int[] toIntArray() throws IOException {
		
		char[] charArray = readStringFromFile().toCharArray();
		int[] intArray = new int[charArray.length];
		int i = 0;
		for (char c : charArray) {
			intArray[i++] = Character.digit(c, 10);
		}
		return intArray;
	}

	private static boolean isTidyAtPosition(int[] charArray, int j) {
		return charArray[j] <= charArray[j + 1];
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine();
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, Object... ans) throws IOException {
		writer.write("Case #" + i + ":");
		for (Object a : ans)
			writer.write(" " + a);
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}
}
