import java.awt.HeadlessException;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Set;
import java.util.TreeSet;

public class RankandFile {

	private static String infileName, outFileName;
	private static BufferedReader reader;
	private static BufferedWriter writer;

	public static void main(String[] args) throws IOException {

		infileName = args[0];
		outFileName = infileName.substring(0, infileName.indexOf('.')).concat(
				".out");
		openFileForReading();
		openFileForWriting();
		int numTests = readIntFromFile();
		for (int i = 0; i < numTests; i++) {
			int len = readIntFromFile();
			int hights[][] = readIntArrayFromFile(len);
			String ans = rankAndFile(hights, len);
			writeAnswer(i + 1, ans);
		}
		closeFiles();
	}

	private static String rankAndFile(int[][] hights, int len) {
		Map<Integer, Integer> m = new HashMap<Integer, Integer>();
		for (int i = 0; i < 2*len - 1; i++)
			for (int j = 0; j < len; j++) {
				int num = hights[i][j];
				if (m.get(num) == null)
					m.put(num, 1);
				else {
					m.put(num, m.get(num) + 1);
				}
			}
		Set<Integer> s = new TreeSet<Integer>();
		for (Entry<Integer, Integer> e : m.entrySet()) {
			if (e.getValue() % 2 != 0)
				s.add(e.getKey());
		}
		Iterator<Integer> iterator = s.iterator();
		String str = "";
		while (iterator.hasNext()) {
			str = str + iterator.next() +" ";
		}
		return str.trim();
	}

	private static int[][] readIntArrayFromFile(int len)
			throws IOException {
		int[][] in = new int[2*len - 1][len];
		int count = 0;
		int j = 0;
		for (; count < 2*len - 1; count++) {
			for (String s : reader.readLine().split("\\s")) {
				in[count][j++] = Integer.parseInt(s);
			}
			j = 0;
		}
		return in;
	}

	private static String readStringFromFile() throws IOException {
		return reader.readLine();
	}

	private static void closeFiles() throws IOException {
		reader.close();
		writer.close();
	}

	private static void writeAnswer(int i, String ans) throws IOException {
		writer.write("Case #" + i + ": " + (ans));
		writer.newLine();
	}

	private static void openFileForWriting() throws IOException {
		writer = Files.newBufferedWriter(Paths.get(outFileName));
	}

	private static int readIntFromFile() throws IOException {
		return Integer.parseInt(reader.readLine());
	}

	private static void openFileForReading() throws IOException {
		reader = Files.newBufferedReader(Paths.get(infileName));
	}
}
