import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;


public class SquareTiles {

	public static void main(String[] args) throws Exception {
		Scanner scn = new Scanner(new FileInputStream(args[0]));
		FileWriter writer = new FileWriter(
				args[0].substring(0, args[0].lastIndexOf('.') + 1) + "out");
		
		int cases = scn.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			
			int x = scn.nextInt();
			int y = scn.nextInt();
			
			char[][] matrix = new char[x][y];
			
			for (int j = 0; j < x; j++) {
				String line = scn.next();
				for (int k = 0; k < y; k++) {
					matrix[j][k] = line.toCharArray()[k];
				}
			}
			
			boolean transform = true;
			
			for (int j = 0; j < x; j++) {
				for (int k = 0; k < y; k++) {
					if (matrix[j][k] == '#') {
						transform = transformMatrix(matrix, j, k);
						if (!transform) {
							break;
						}
					}
				}
				if (!transform) {
					break;
				}
			}

			for (int j = 0; j < x; j++) {
				for (int k = 0; k < y; k++) {
					if (matrix[j][k] == '#') {
						transform = false;
						break;
					}
				}
				if (!transform) {
					break;
				}
			}
			
			if (!transform) {
				writer.write("Case #" + i + ":\nImpossible\n");
			} else {
				writer.write("Case #" + i + ":\n");
				for (int j = 0; j < x; j++) {
					StringBuilder b = new StringBuilder();
					for (int k = 0; k < y; k++) {
						b.append(matrix[j][k]);
					}
					b.append("\n");
					writer.write(b.toString());
				}
			}
		}
		writer.close();
	}

	private static boolean transformMatrix(char[][] matrix, int j, int k) {
		try {
			if (matrix[j][k] == '#' || matrix[j][k] == '/') {
				matrix[j][k] = '/';
			} else {
				return false;
			}
			
			if (matrix[j + 1][k] == '#' || matrix[j + 1][k] == '\\') {
				matrix[j + 1][k] = '\\';
			} else {
				return false;
			}
			
			if (matrix[j][k + 1] == '#' || matrix[j][k + 1] == '\\') {
				matrix[j][k + 1] = '\\';
			} else {
				return false;
			}
			if (matrix[j + 1][k + 1] == '#' || matrix[j + 1][k + 1] == '/') {
				matrix[j + 1][k + 1] = '/';
			} else {
				return false;
			}
			return true;
		} catch (Exception e) {
			return false;
		}
	}
	
}
