import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class Magicka {

	private static final int SIZE = 'z' - 'a' + 1;
	
	private static final int idx(char c) {
		return c - 'a';
	}
	
	public static void main(String[] args) throws Exception {
		Scanner scn = new Scanner(new FileInputStream(args[0]));
		FileWriter writer = new FileWriter(
				args[0].substring(0, args[0].lastIndexOf('.') + 1) + "out");
		
		int cases = scn.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			Element[] elements = new Element[SIZE];
			for (char j = 'a'; j <= 'z'; j++) {
				elements[idx(j)] = new Element(j);
			}
			int c = scn.nextInt();
			for (int j = 0; j < c; j++) {
				char[] rule = scn.next().toLowerCase().toCharArray();
				elements[idx(rule[0])].productionRules[idx(rule[1])] = rule[2];
				elements[idx(rule[1])].productionRules[idx(rule[0])] = rule[2];
			}
			
			int d = scn.nextInt();
			for (int j = 0; j < d; j++) {
				char[] rule = scn.next().toLowerCase().toCharArray();
				elements[idx(rule[0])].opposesTo.add(rule[1]);
				elements[idx(rule[1])].opposesTo.add(rule[0]);
			}
			
			int spellSize = scn.nextInt();
			String spell = spellSize == 0 ? "" : scn.next().toLowerCase();

			StringBuilder result = new StringBuilder(); 
			
			for (char elementName : spell.toCharArray()) {
				if (result.length() == 0) {
					result.append(elementName);
					elements[idx(elementName)].occur++;
					continue;
				}
				char lastEl = result.charAt(result.length()-1);
				char production = elements[idx(lastEl)].productionRules[idx(elementName)];
				if (production > 0) {
					result.deleteCharAt(result.length()-1);
					elements[idx(lastEl)].occur--;
					
					result.append(production);
					elements[idx(production)].occur++;
					continue;
				}
				
				boolean cleared = false;
				
				for (Character opposed : elements[idx(elementName)].opposesTo) {
					if (elements[idx(opposed)].occur > 0) {
						result.setLength(0);
						for (Element element : elements) {
							element.occur = 0;
						}
						cleared = true;
						break;
					}
				}
				
				if (cleared) {
					continue;
				}
				
				result.append(elementName);
				elements[idx(elementName)].occur++;
			}
			
			List<Character> resultChars = new LinkedList<Character>();
			for (Character character : result.toString().toCharArray()) {
				resultChars.add(Character.toUpperCase(character));
			}
			writer.write("Case #" + i + ": " + resultChars.toString() + "\n");
			writer.flush();
		}
		writer.close();
	}
	
	private static class Element {
		char elementName;
		int occur;
		List<Character> opposesTo = new LinkedList<Character>();
		char[] productionRules = new char[SIZE];
		
		public Element(char elementName) {
			this.elementName = elementName;
		}
	}
	
}
