import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Watersheds {

	static char curSink = 'a';
	
	public static void main(String[] args) throws IOException {
		
		Scanner scn = new Scanner(new FileInputStream(args[0]));
		FileWriter writer = new FileWriter(
				args[0].substring(0, args[0].lastIndexOf('.') + 1) + "out");
		
		
		int cases = scn.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			curSink = 'a';
			
			int h = scn.nextInt();
			int w = scn.nextInt();
			
			int[][] mat = new int[h][w];
			Character[][] charz = new Character[h][w];
			
			for (int j = 0; j < h; j++) {
				for (int k = 0; k < w; k++) {
					mat[j][k] = scn.nextInt();
				}
			}
			
			for (int j = 0; j < h; j++) {
				for (int k = 0; k < w; k++) {
					recursiveLookup(charz, mat, j, k);
				}
			}
			
			writer.write("Case #" + i +":\n");
			for (int j = 0; j < h; j++) {
				StringBuilder line = new StringBuilder();
				for (int k = 0; k < w; k++) {
					line.append(charz[j][k]).append(" ");
				}
				writer.write(line.toString().trim() + "\n");
			}
		}
		writer.close();
	}

	private static char recursiveLookup(Character[][] charz, int[][] mat,
			int j, int k) {

		if (charz[j][k] != null) {
			return charz[j][k];
		}
		
		int menorY = -1;
		int menorX = -1;
		int menorValue = mat[j][k];

		try {
			if (mat[j-1][k] < menorValue) {
				menorX = k;
				menorY = j-1;
				menorValue = mat[j-1][k];
			}
		} catch (ArrayIndexOutOfBoundsException e) {}

		try {
			if (mat[j][k-1] < menorValue) {
				menorX = k-1;
				menorY = j;
				menorValue = mat[j][k-1];
			}
		} catch (ArrayIndexOutOfBoundsException e) {}
		
		try {
			if (mat[j][k+1] < menorValue) {
				menorX = k+1;
				menorY = j;
				menorValue = mat[j][k+1];
			}
		} catch (ArrayIndexOutOfBoundsException e) {}

		try {
			if (mat[j+1][k] < menorValue) {
				menorX = k;
				menorY = j+1;
				menorValue = mat[j+1][k];
			}
		} catch (ArrayIndexOutOfBoundsException e) {}


		if ( menorY < 0 && menorX < 0) {
			charz[j][k] = curSink;
			curSink++;
			return charz[j][k];
		}

		charz[j][k] = recursiveLookup(charz, mat, menorY, menorX);
		
		return charz[j][k];
	}

}
