import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.text.DecimalFormat;
import java.util.Scanner;


public class WelcomeToCodeJam {

	static String PATTERN = "welcome to code jam";
	
	public static void main(String[] args) throws IOException {
		Scanner scn = new Scanner(new FileInputStream(args[0]));
		FileWriter writer = new FileWriter(
				args[0].substring(0, args[0].lastIndexOf('.') + 1) + "out");
		
		DecimalFormat format = new DecimalFormat("0000");
		
		int cases = scn.nextInt();
		scn.nextLine();
		
		for (int i = 1; i <= cases; i++) {
			BigInteger count = count(scn.nextLine());
			BigInteger resp = count.mod(BigInteger.valueOf(1000));
			writer.write("Case #" + i +": " + format.format(resp.longValue()) + "\n");
		}
		writer.close();
	}
	
	private static BigInteger count(String input) {
		BigInteger[][] mat = new BigInteger[PATTERN.length()+1][input.length()+1];
		
		for (int i = 0; i <= PATTERN.length(); i++) {
			for (int j = 0; j <= input.length(); j++) {
				mat[i][j] = BigInteger.ZERO;
			}
		}
		
		for (int i = 1; i <= input.length(); i++) {
			if (PATTERN.charAt(0) == input.charAt(i-1)) {
				mat[0][i] = BigInteger.ONE;
			}
		}
		
		for (int i = 1; i <= PATTERN.length(); i++) {
			for (int j = 1; j <= input.length(); j++) {
				if (PATTERN.charAt(i-1) == input.charAt(j-1)) {
					mat[i][j] = mat[i-1][j].add(mat[i][j-1]);
				} else {
					mat[i][j] = mat[i][j-1];
				}
			}
		}
		
		return mat[PATTERN.length()][input.length()];
	}
}
