import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;


public class CandySplitting {

	public static void main(String[] args) throws Exception {
		Scanner scn = new Scanner(new FileInputStream(args[0]));
		FileWriter writer = new FileWriter(
				args[0].substring(0, args[0].lastIndexOf('.') + 1) + "out");
		
		int cases = scn.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			int sacksNo = scn.nextInt();
			long[] sacks = new long[sacksNo];
			for (int j = 0; j < sacksNo; j++) {
				sacks[j] = scn.nextLong();
			}
			
			long higherSumSean = -1L;
			
			for (int r = 1; r < sacks.length; r++) {
				CombinationGenerator generator = new CombinationGenerator(sacks.length, r);
				while (generator.hasMore()) {
					int[] perm = generator.getNext();
					boolean[] permB = new boolean[sacks.length];
					
					for (int j : perm) {
						permB[j] = true;
					}
					
					long xorSean = 0L;
					long xorPatrick = 0L;
					long sumSean = 0L;
					
					for (int j = 0; j < sacks.length; j++) {
						
						long xor = xor(permB[j] ? xorSean : xorPatrick, sacks[j]);
						if (permB[j]) {
							xorSean = xor;
							sumSean += sacks[j];
						} else {
							xorPatrick = xor;
						}
						
					}
				
					if (xorSean == xorPatrick && sumSean >= higherSumSean) {
						higherSumSean = sumSean;
					}
					
				}
			}
			
			writer.write("Case #" + i + ": " + (higherSumSean == -1 ? "NO" : higherSumSean) + "\n");
			writer.flush();
			
		}
		writer.close();
	}

	private static long xor(long xor, long sack) {
		return xor ^ sack;
	}
	
}
