import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;


class SavingTheUniverse {

	public static void main(String[] args) throws IOException {
		
		Scanner scanner = new Scanner(new File(args[0]));
		BufferedWriter writer = new BufferedWriter(new FileWriter(args[1]));
		
		int cases = Integer.parseInt(scanner.nextLine());
		
		for (int i = 0; i < cases; i++) {
			
			int enginesNo = Integer.parseInt(scanner.nextLine());
			
			String[] engines = new String[enginesNo];
			
			for (int j = 0; j < engines.length; j++) {
				engines[j] = scanner.nextLine();
			}
			
			int queriesNo = Integer.parseInt(scanner.nextLine());
			
			String[] queries = new String[queriesNo];
			
			for (int j = 0; j < queries.length; j++) {
				queries[j] = scanner.nextLine();
			}
			
			writer.write("Case #" + (i+1) + ": " + getMinSwitches(engines, queries));
			writer.newLine();
			
			writer.flush();
		}

		writer.close();
		
	}

	private static int getMinSwitches(String[] engines, String[] queries) {
		
		if (queries.length == 0) {
			return 0;
		}
		
		int initial = 0;
		
		int minSwitches = 0;
		
		while (initial < queries.length) {
			
			Map<String, Integer> firsts = new HashMap<String, Integer>();
			for (String engine : engines) {
				firsts.put(engine, queries.length);
			}
			
			for (int i = initial; i < queries.length; i++) {
				if (firsts.get(queries[i]) == queries.length) {
					firsts.put(queries[i], i);
				}
			}
			
			int max = 0;
			
			for (Integer value : firsts.values()) {
				max = Math.max(max, value);
			}
			
			initial = max;
			
			minSwitches++;
		}
		
		return minSwitches - 1;
	}
	
	
}
