import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class BotTrust {

	public static void main(String[] args) throws Exception {
		Scanner scn = new Scanner(new FileInputStream(args[0]));
		FileWriter writer = new FileWriter(
				args[0].substring(0, args[0].lastIndexOf('.') + 1) + "out");
		
		int cases = scn.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			Bot oBot = new Bot();
			Bot bBot = new Bot();
			List<Task> tasks = new LinkedList<Task>();
			
			int tasksNo = scn.nextInt();
			
			for (int j = 0; j < tasksNo; j++) {
				char bot = scn.next().charAt(0);
				int button = scn.nextInt();
				
				Task task = new Task(true, button);
				if (bot == 'O') {
					oBot.tasks.add(task);
				} else {
					bBot.tasks.add(task);
				}
				tasks.add(task);
			}
			
			int sec = 0;
			while (!tasks.isEmpty()) {
				createStepTasks(oBot);
				createStepTasks(bBot);
				
				consumeTasks(bBot, tasks, 
						consumeTasks(oBot, tasks, false));
				
				sec++;
			}
			
			writer.write("Case #" + i + ": " + sec + "\n");
			writer.flush();
		}
		writer.close();
	}

	private static boolean consumeTasks(Bot oBot, List<Task> tasks, boolean hasRemoved) {
		if (!oBot.tasks.isEmpty()) {
			Task headTask = oBot.tasks.get(0);
			boolean isHeadTask = headTask == tasks.get(0) && !hasRemoved;
			if (!headTask.push || isHeadTask) {
				oBot.tasks.remove(0);
				if (isHeadTask) {
					oBot.place = headTask.button;
					tasks.remove(0);
					return true;
				}
			}
		}
		return false;
	}

	private static void createStepTasks(Bot oBot) {
		if (oBot.tasks.isEmpty()) {
			return;
		}
		Task headTask = oBot.tasks.get(0);
		if (headTask.push && headTask.button != oBot.place && !headTask.stepsGenerated) {
			for (int j = 0; j < Math.abs(oBot.place - headTask.button); j++) {
				oBot.tasks.add(0, new Task(false, j));
			}
			headTask.stepsGenerated = true;
		}
	}
	
	private static class Task {
		boolean push;
		boolean stepsGenerated;
		int button;
		
		public Task(boolean push, int button) {
			this.push = push;
			this.button = button;
		}
	}
	
	private static class Bot {
		List<Task> tasks = new LinkedList<Task>();
		int place = 1;
	}
}
