import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

public class PD {
	private File fileIN;
	private FileReader fr = null;
	private BufferedReader bIN;
	private FileWriter fw = null;
    private PrintWriter pw = null;
    
    private int T;
    private int N;
    private ArrayList<Double> WarA;
    private ArrayList<Double> WarB;


	public PD(String nomFic) {
		fileIN = new File (nomFic);
        try {
			fr = new FileReader(fileIN);
			bIN = new BufferedReader(fr);
			
			fw = new FileWriter(nomFic+".out");
	        pw = new PrintWriter(fw);
	        
	        String linea = bIN.readLine();
	        T = new Integer(linea);
	        
	        for(int i=0; i<T; i++){
		        linea = bIN.readLine();
		        N = new Integer(linea);
		        WarA = new ArrayList<Double>();
		        WarB = new ArrayList<Double>();
		        
		        linea = bIN.readLine();
		        String[] tokens = linea.split("\\p{Space}+");
		        for (int j=0; j<tokens.length; j++)
		        	WarA.add(new Double(tokens[j]));
		        
		        linea = bIN.readLine();
		        tokens = linea.split("\\p{Space}+");
		        for (int j=0; j<tokens.length; j++)
		        	WarB.add(new Double(tokens[j]));

	        	evaluarCaso(i+1);
	        }
		} 
        catch (FileNotFoundException e) {	e.printStackTrace();} 
        catch (IOException e) {e.printStackTrace(); }
        finally{
        	try {
				fr.close();
				fw.close();
			} catch (IOException e) { e.printStackTrace();}
        }
	}
	
	private boolean evaluarCaso(int caso) {
		StringBuilder sb = new StringBuilder();
    	sb.append("Case #");
    	sb.append(caso);
    	sb.append(": ");
    	Double jugadaA;
		Double jugadaB;
		int puntosWar = 0;
		int puntosDeceiful = 0;
    	
    	Collections.sort(WarA);
    	Collections.sort(WarB);
    	
    	ArrayList<Double> DeceA = new ArrayList<Double>(WarA);
    	ArrayList<Double> DeceB = new ArrayList<Double>(WarB);
    	
    	
    	//Jugar War    	
    	while(WarA.size() != 0){
    		jugadaA = WarA.get(WarA.size()-1); 
    		WarA.remove(WarA.size()-1);
    		
    		if (WarB.get(WarB.size()-1) > jugadaA){
    			jugadaB = WarB.get(WarB.size()-1);
    			WarB.remove(WarB.size()-1);
    		}
    		else{
    			jugadaB = WarB.get(0);
    			WarB.remove(0);
    		}
    		
    		if (jugadaA > jugadaB)
    			puntosWar++;
    		
    	}
    	
    	//Jugar Deceiful
    	
    	while(DeceA.size() != 0){
    		if (DeceA.size() == 1){
    			jugadaA = DeceA.get(0);
    			jugadaB = DeceB.get(0);
    			DeceA.remove(0);
    			DeceB.remove(0);
    		}
    		else{
    			jugadaA = DeceA.get(0);
    			if (jugadaA < DeceB.get(0)){
        			jugadaA = DeceB.get(DeceB.size()-1)-0.1;
        		}
    			else{
    				jugadaA = DeceB.get(DeceB.size()-1)+0.1;
    			}
    			DeceA.remove(0);
    			
    			if (DeceB.get(DeceB.size()-1) > jugadaA){
        			jugadaB = DeceB.get(DeceB.size()-1);
        			DeceB.remove(DeceB.size()-1);
        		}
        		else{
        			jugadaB = DeceB.get(0);
        			DeceB.remove(0);
        		}
    			
    		}
    		if (jugadaA > jugadaB)
    			puntosDeceiful++;
    	}
    	
    	
    	sb.append(puntosDeceiful+" "+puntosWar);
    	//System.out.println(sb.toString());
    	pw.println(sb.toString());
    	return true;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new PD(args[0]);
	}

}
