import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class PB {
	private File fileIN;
	private FileReader fr = null;
	private BufferedReader bIN;
	private FileWriter fw = null;
    private PrintWriter pw = null;
    
    private int T;
    private int E;
	private int R;
	private int[] vals;

	public PB(String nomFic) {
		fileIN = new File (nomFic);
        try {
			fr = new FileReader(fileIN);
			bIN = new BufferedReader(fr);
			
			fw = new FileWriter(nomFic+".out");
	        pw = new PrintWriter(fw);
	        
	        String linea = bIN.readLine();
	        T = new Integer(linea);
	        
	        
	        for(int i=0; i<T; i++){
	        	evaluarCaso(i+1);
	        }
		} 
        catch (FileNotFoundException e) {	e.printStackTrace();} 
        catch (IOException e) {e.printStackTrace(); }
        finally{
        	try {
				fr.close();
				fw.close();
			} catch (IOException e) { e.printStackTrace();}
        }
	}
	
	private int sol = Integer.MIN_VALUE;
	
	
	
	private void back(int n, int energia, int valor){
		int ASol;
		if (n==vals.length-1){
			ASol = valor + (energia * vals[n]);
			if (ASol > sol) sol = ASol;
		}
		else{
			int AEnergia;
			int AValor;
			for (int i=energia; i>=0; i--){
				AEnergia = energia-i+R;
				if (AEnergia > R) AEnergia = R;
				AValor = valor + (vals[n]*i); 
				back(n+1, AEnergia, AValor);
			}
		}
		
	}
	
	private boolean evaluarCaso(int caso) throws IOException {
		String ALinea;
		StringBuilder sb = new StringBuilder();
    	sb.append("Case #");
    	sb.append(caso);
    	sb.append(": ");
    	
    	ALinea = bIN.readLine();
    	String[] tokens = ALinea.split("\\p{Space}+");
    	
    	E = new Integer(tokens[0]);
    	R = new Integer(tokens[1]);
    	int N = new Integer(tokens[2]);
    	
    	ALinea = bIN.readLine();
    	tokens = ALinea.split("\\p{Space}+");
    	
    	vals = new int[tokens.length];
    	for (int i=0; i<tokens.length; i++)
    		vals[i] = new Integer(tokens[i]);
    	
    	sol = Integer.MIN_VALUE;
    	back(0, E, 0);
    	
    	sb.append(sol);    	
    	
    	
//    	System.out.println(sb.toString());
    	pw.println(sb.toString());
    	return true;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new PB(args[0]);
	}

}
