import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;


public class PA {
	
	enum Simbolo{ sX, sO, sT, sPUNTO } 
	
	private File fileIN;
	private FileReader fr = null;
	private BufferedReader bIN;
	private FileWriter fw = null;
    private PrintWriter pw = null;
    private Simbolo[][] Tablero;
    
    private int T;
    private boolean HayPunto;
    
    
    
    private void cargarTablero() throws IOException{
    	String linea;
    	Tablero = new Simbolo[4][4];
    	for(int i=0; i<4; i++){
    		linea = bIN.readLine();
    		for(int j=0; j<linea.length(); j++){
    			if (linea.charAt(j) == 'X') Tablero[i][j] = Simbolo.sX;
    			else if (linea.charAt(j) == 'O') Tablero[i][j] = Simbolo.sO;
    			else if (linea.charAt(j) == 'T') Tablero[i][j] = Simbolo.sT;
    			else if (linea.charAt(j) == '.') Tablero[i][j] = Simbolo.sPUNTO;
    		}
    	}
    	HayPunto = false;
    }
    
    
    private boolean evaluarJuego(int caso){
    	int ASol = 0;
    	StringBuilder sb = new StringBuilder();
    	sb.append("Case #");
    	sb.append(caso);
    	sb.append(": ");
    	for(int i=0; i<4; i++){
    		for(int j=0; j<4; j++){
    			ASol = buscarSolucion(i,j); 
    			if(ASol !=0){
    				if(ASol == 1){
    					sb.append("X won");
    				}
    				else if (ASol == 2){
    					sb.append("O won");
    				}
    				pw.println(sb.toString());
    				return true;
    			}
    		}
    	}
    	
    	if(HayPunto){
    		sb.append("Game has not completed");
    	}
    	else{
    		sb.append("Draw");
    	}
    	
    	
    	pw.println(sb.toString());
    	return true;
    }
    
    
    private int buscarSolucion(int x, int y){
    	int retorno = 0;
    	int AContX = 0;
    	int AContO = 0;
    	
    	for(int i=x; i<4; i++){
    		if(Tablero[i][y] == Simbolo.sX) { AContX++; AContO= 0; }
    		if(Tablero[i][y] == Simbolo.sO) { AContX=0; AContO++;  }
    		if(Tablero[i][y] == Simbolo.sT) { AContX++; AContO++;  }
    		if(Tablero[i][y] == Simbolo.sPUNTO) { AContX=0; AContO=0; HayPunto = true; }
    	}
    	
    	if(AContX == 4){
    		return 1;
    	}
    	else if(AContO == 4){
    		return 2;
    	}
    	
    	AContX = 0;
    	AContO = 0;
    	for(int i=y; i<4; i++){
    		if(Tablero[x][i] == Simbolo.sX) { AContX++; AContO= 0; }
    		if(Tablero[x][i] == Simbolo.sO) { AContX=0; AContO++;  }
    		if(Tablero[x][i] == Simbolo.sT) { AContX++; AContO++;  }
    		if(Tablero[x][i] == Simbolo.sPUNTO) { AContX=0; AContO=0; HayPunto = true; }
    	}
    	
    	if(AContX == 4){
    		return 1;
    	}
    	else if(AContO == 4){
    		return 2;
    	}
    	
    	AContX = 0;
    	AContO = 0;
    	int i=x;
    	int j=y;
    	while((i<4) && (j<4)){
    		if(Tablero[i][j] == Simbolo.sX) { AContX++; AContO= 0; }
    		if(Tablero[i][j] == Simbolo.sO) { AContX=0; AContO++;  }
    		if(Tablero[i][j] == Simbolo.sT) { AContX++; AContO++;  }
    		if(Tablero[i][j] == Simbolo.sPUNTO) { AContX=0; AContO=0; HayPunto = true; }
    		i++;
    		j++;
    	}
    	
    	
    	if(AContX == 4){
    		return 1;
    	}
    	else if(AContO == 4){
    		return 2;
    	}
    	
    	AContX = 0;
    	AContO = 0;
    	i=x;
    	j=y;
    	while((i<4) && (j>=0)){
    		if(Tablero[i][j] == Simbolo.sX) { AContX++; AContO= 0; }
    		if(Tablero[i][j] == Simbolo.sO) { AContX=0; AContO++;  }
    		if(Tablero[i][j] == Simbolo.sT) { AContX++; AContO++;  }
    		if(Tablero[i][j] == Simbolo.sPUNTO) { AContX=0; AContO=0; HayPunto = true; }
    		i++;
    		j--;
    	}
    	
    	if(AContX == 4){
    		return 1;
    	}
    	else if(AContO == 4){
    		return 2;
    	}
    	
    	return retorno;
    }
	
    
    
	public PA(String nomFic){
		fileIN = new File (nomFic);
        try {
			fr = new FileReader(fileIN);
			bIN = new BufferedReader(fr);
			
			fw = new FileWriter(nomFic+".out");
	        pw = new PrintWriter(fw);
	        
	        String linea = bIN.readLine();
	        T = new Integer(linea);
	        
	        for(int i=0; i<(T-1); i++){
	        	cargarTablero();
	        	evaluarJuego(i+1);
	        	linea = bIN.readLine();
	        }
	        cargarTablero();
	        evaluarJuego(T);
		} 
        catch (FileNotFoundException e) {	e.printStackTrace();} 
        catch (IOException e) {e.printStackTrace(); }
        finally{
        	try {
				fr.close();
				fw.close();
			} catch (IOException e) { e.printStackTrace();}
        }
	}

	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new PA(args[0]);
	}

}
