import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class PC {
	private File fileIN;
	private FileReader fr = null;
	private BufferedReader bIN;
	private FileWriter fw = null;
    private PrintWriter pw = null;
    
    private int T;
    private int R,C,M;


	public PC(String nomFic) {
		fileIN = new File (nomFic);
        try {
			fr = new FileReader(fileIN);
			bIN = new BufferedReader(fr);
			
			fw = new FileWriter(nomFic+".out");
	        pw = new PrintWriter(fw);
	        
	        String linea = bIN.readLine();
	        T = new Integer(linea);
	        
	        
	        for(int i=0; i<T; i++){
	        	linea = bIN.readLine();
	        	String[] tokens = linea.split("\\p{Space}+");
	        	R = new Integer(tokens[0]);
	        	C = new Integer(tokens[1]);
	        	M = new Integer(tokens[2]);	        	
	        	evaluarCaso(i+1);
	        }
		} 
        catch (FileNotFoundException e) {	e.printStackTrace();} 
        catch (IOException e) {e.printStackTrace(); }
        finally{
        	try {
				fr.close();
				fw.close();
			} catch (IOException e) { e.printStackTrace();}
        }
	}
	
	private boolean evaluarCaso(int caso) {
		StringBuilder sb = new StringBuilder();
    	sb.append("Case #");
    	sb.append(caso);
    	sb.append(":");
    	
    	String[][] grid = new String[R][C];
    	for (int i=0; i<R; i++)
    		for (int j=0; j<C; j++)
    			grid[i][j] = ".";
    	
    	int MRows = 0;
    	int MCols = 0;
    	int MRowSec = 0;
    	int MColSec = 0;
    	int contM = 0;
    	if (R>=C){
    		for (int i=0; i<R; i++){
    			for (int j=0; j<C; j++){
    				if (contM >= M){
    					MRows = i;
    					MCols = j;
    					break;
    				}
    				grid[i][j] = "*";
    				contM++;
    			}
    			if (contM >= M) break;
    		}
    	}
    	else{
    		for (int j=0; j<C; j++){
    			for (int i=0; i<R; i++){
    				if (contM >= M){
    					MRows = i;
    					MCols = j;
    					break;
    				}
    				grid[i][j] = "*";
    				contM++;
    			}
    			if (contM >= M) break;
    		}
    	}
    	
    	
    	grid[R-1][C-1] = "c";
    	
    	if ((grid[R-1][Math.max(C-2, 0)] == "*") || 
    		(grid[Math.max(R-2,0)][C-1] == "*") || 
    		(grid[Math.max(R-2,0)][Math.max(C-2,0)]) == "*"){
    		sb.append("\nImpossible");
    	}
    	else{
    		for (int i=0; i<R; i++){
    			sb.append("\n");
    			for (int j=0; j<C; j++){
    				sb.append(grid[i][j]);
    			}
    		}
    	}
    		
    	

    	//System.out.println(sb.toString());
    	pw.println(sb.toString());
    	return true;
	}
	
	

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new PC(args[0]);

	}

}
