import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class PB {
	private File fileIN;
	private FileReader fr = null;
	private BufferedReader bIN;
	private FileWriter fw = null;
    private PrintWriter pw = null;
    
    private int T;
    private double F;
    private double C;
    private double X;
    
		

	public PB(String nomFic) {
		fileIN = new File (nomFic);
        try {
			fr = new FileReader(fileIN);
			bIN = new BufferedReader(fr);
			
			fw = new FileWriter(nomFic+".out");
	        pw = new PrintWriter(fw);
	        
	        String linea = bIN.readLine();
	        T = new Integer(linea);
	        
	        
	        for(int i=0; i<T; i++){
	        	linea = bIN.readLine();
	        	String[] tokens = linea.split("\\p{Space}+");
	        	C = new Float(tokens[0]);
	        	F = new Float(tokens[1]);
	        	X = new Float(tokens[2]);
	        	evaluarCaso(i+1);
	        }
		} 
        catch (FileNotFoundException e) {	e.printStackTrace();} 
        catch (IOException e) {e.printStackTrace(); }
        finally{
        	try {
				fr.close();
				fw.close();
			} catch (IOException e) { e.printStackTrace();}
        }
	}
	
		
	
	
	private boolean evaluarCaso(int caso) throws IOException {
		StringBuilder sb = new StringBuilder();
    	sb.append("Case #");
    	sb.append(caso);
    	sb.append(": ");
    	
    	double tGanar;
    	double tGanarIp1;
    	double tCompra;
    	double gs;
    	double gsIp1;
    	double total = 0;
    	
    	for (int i=0; i<1000000; i++){
    		gs = 2 + (i*F);
    		gsIp1 = gs + F; 
    		tGanar = X/gs;
    		tGanarIp1 = X/gsIp1;
    		tCompra = C/gs;
    		
    		if ((tCompra+tGanarIp1)> tGanar){
    			total += tGanar;
    			break;
    		}
    		
    		total += tCompra;    		
    	}
    	
    	sb.append(total);
    	pw.println(sb.toString());
    	return true;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new PB(args[0]);
	}

}
