import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;


public class PC {
	
	private File fileIN;
	private FileReader fr = null;
	private BufferedReader bIN;
	private FileWriter fw = null;
    private PrintWriter pw = null;
    
    private int T;
    
    private boolean esPalindromo(String cadena){
    	boolean retorno = true;
    	
    	if(cadena.length() == 1) return true;
    	else{
    		int APosA = 0;
    		int APosB = cadena.length()-1;
    		while(APosA <= APosB){
    			if(cadena.charAt(APosA) != cadena.charAt(APosB)) return false;    			
    			APosA++;
    			APosB--;
    		}
    	}
    	
    	return retorno; 
    }
    
    private void evaluarCaso(int caso, int limInf, int limSup){
    	StringBuilder sb = new StringBuilder();
    	int AContador = 0;
    	sb.append("Case #");
    	sb.append(caso);
    	sb.append(": ");
    	
    	int AValorA = (int) Math.sqrt(limInf);
    	if ((AValorA*AValorA) != limInf) AValorA++;
    	int AValorB = (int) Math.sqrt(limSup);
    	String ACad;
    	
    	for(int i=AValorA; i<=AValorB; i++){
    		ACad = ""+(i*i);
    		if(esPalindromo(""+i) && esPalindromo(ACad)){
    			AContador++;
    		}
    	}
    	sb.append(AContador);
    	pw.println(sb.toString());
    }
	
	public PC(String nomFic){
		fileIN = new File (nomFic);
        try {
			fr = new FileReader(fileIN);
			bIN = new BufferedReader(fr);
			
			fw = new FileWriter(nomFic+".out");
	        pw = new PrintWriter(fw);
	        
	        String linea = bIN.readLine();
	        T = new Integer(linea);
	        
	        String[] tokens;
	        for(int i=0; i<T; i++){
	        	linea = bIN.readLine();
	        	tokens = linea.split("\\p{Space}+");
	        	evaluarCaso(i+1, new Integer(tokens[0]), new Integer(tokens[1]));
	        }
		} 
        catch (FileNotFoundException e) {	e.printStackTrace();} 
        catch (IOException e) {e.printStackTrace(); }
        finally{
        	try {
				fr.close();
				fw.close();
			} catch (IOException e) { e.printStackTrace();}
        }
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new PC(args[0]);
	}

}
