package googlecodejam2013.round1c.pogo;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Stack;

public class Pogo {
	private static final short[][] board = new short[1001][1001];
	private static final byte[][] dir = new byte[1001][1001];
	private static final int[] dirx = new int[] { -1111, 0, 1, 0, -1 },
			diry = new int[] { -1111, 1, 0, -1, 0 };
	static {
		for (int i = board.length; i-- > 0;)
			for (int j = board[i].length; j-- > 0;)
				board[i][j] = Short.MIN_VALUE;
		Stack<Integer> s = new Stack<Integer>();
		Stack<Integer> sNew = new Stack<Integer>();
		s.push(createInt((short) 500, (short) 500));
		board[500][500] = 0;
		for (short n = 1; n <= 500; ++n) {
			while (!s.isEmpty()) {
				Integer pos = s.pop();
				int x = getX(pos), y = getY(pos);
				for (byte i = 1; i < dirx.length; ++i) {
					Integer p = setBoard(x + dirx[i] * n, y + diry[i] * n, i, n);
					if (p != null) {
						sNew.push(p);
					}
				}
			}
			if (n < 7) {
				// printBoard(-5, 5, -5, 5);
			}
			s = sNew;
			sNew = new Stack<Integer>();
		}
		for (int i = board.length; i-- > 0;)
			for (int j = board[i].length; j-- > 0;)
				if (board[i][j] == Short.MIN_VALUE) {
					for (short n = 1; n < 500; ++n)
						for (byte direction = 1; direction < dirx.length; ++direction) {

							int x = i + dirx[direction] * n;
							int y = j + diry[direction] * n;
							if (x >= 0 && y >= 0 && x < board.length
									&& y < board.length) {
								if (board[x][y] == n - 1) {
									board[i][j] = n;
									dir[i][j] = direction;
								}
							}
						}
				}
		printBoard(-2, 2, -43, -37);
	}

	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(
					args[1]) : new OutputStreamWriter(System.out));
			try {
				int testCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= testCases; ++i) {
					String[] sizeLine = br.readLine().split(" ");
					int x = Integer.parseInt(sizeLine[0]);
					int y = Integer.parseInt(sizeLine[1]);
					out.write("Case #" + i + ": " + findPath(x, y) + lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static void printBoard(int minX, int maxX, int minY, int maxY) {
		for (int i = minY; i <= maxY; ++i) {
			for (int j = minX; j <= maxX; ++j) {
				short v = board[500 + j][500 + i];
				System.out.print((v == Short.MIN_VALUE ? " " : v) + " ");
			}
			System.out.println();
		}
	}

	private static Integer setBoard(int x, int y, byte direction, short n) {
		if (x >= 0 && x < board.length && y >= 0 && y < board.length) {
			if (board[x][y] == Short.MIN_VALUE) {
				board[x][y] = n;
				dir[x][y] = direction;
				return createInt((short) x, (short) y);
			}
		}
		return null;
	}

	public static int getY(Integer pos) {
		int v = pos.intValue() & 0xffff;
		return v > 30000 ? v - 65536 : v;
	}

	public static int getX(Integer pos) {
		int v = (pos.intValue() + 32768) >> 16;
		return v /* > 30000 ? v - 65536 : v */;
	}

	public static Integer createInt(short x, short y) {
		return Integer.valueOf((x << 16) + y);
	}

	private static String findPath(int x, int y) {
		StringBuilder sb = new StringBuilder();
		int xx = x + 500, yy = y + 500;
		if (board[xx][yy] == Short.MIN_VALUE) {
			sb.append('N').append('S');
		}
		yy--;
		for (int i = board[xx][yy]; i-- > 0;) {
			byte direction = dir[xx][yy];
			switch (direction) {
			case 1:
				sb.append('N');
				break;
			case 2:
				sb.append('E');
				break;
			case 3:
				sb.append('S');
				break;
			case 4:
				sb.append('W');
				break;
			}
			xx -= dirx[direction] * (i + 1);
			yy -= diry[direction] * (i + 1);
		}
		sb.reverse();
		int X = 0, Y = 0;
		for (int i = 0; i < sb.length(); ++i) {
			char c = sb.charAt(i);
			switch (c) {
			case 'S':
				Y -= (i + 1);
				break;
			case 'N':
				Y += (i + 1);
				break;
			case 'W':
				X -= (i + 1);
				break;
			case 'E':
				X += (i + 1);
				break;
			}
		}
		System.out.println(X + " " + Y);
		return sb.toString();
	}
}
