/*
 * 
 */
package codejam2015.round1c.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.AbstractMap;
import java.util.AbstractMap.SimpleImmutableEntry;
import java.util.BitSet;
import java.util.HashMap;
import java.util.Map;
import java.util.Map.Entry;

/**
 *
 * @author Gabor Bakos
 */
public class TypewriterMonkey {
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		try (BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
				Writer out = new BufferedWriter(
						args.length > 1 ? new FileWriter(args[1])
								: new OutputStreamWriter(System.out))) {
			int numCases = Integer.parseInt(br.readLine().trim());
			for (int i = 1; i <= numCases; ++i) {
				String[] parts = br.readLine().split(" ");
				int k = Integer.parseInt(parts[0]), l = Integer
						.parseInt(parts[1]), s = Integer.parseInt(parts[2]);
				String alphabet = br.readLine(), target = br.readLine();
				out.write("Case #" + i + ": "
						+ keptBananas(alphabet, target, s) + lineSep);
			}
		}
	}

	private static double keptBananas(String alphabet, String target, int s) {
		boolean containsAll = containsAll(target, alphabet);
		if (!containsAll) {
			return 0;
		}
		double minRequired = maxOccurrences(s, target);
		return minRequired - expected(target, alphabet, s, new HashMap<>());
	}

	private static double expected(String target, String alphabet, int s,
			Map<Entry<String, Integer>, Double> memo) {
		int[] frequency = freq(alphabet);
//		for (int i = 1;  i< s; ++i) {
//			expected(alphabet.length(), target, i, memo, frequency);
//		}
		double ret = expected(alphabet.length(), target, s, memo, frequency);
		System.out.println(memo);
		return ret;
	}

	/**
	 * @param k
	 * @param target
	 * @param s
	 * @param memo
	 * @param frequency
	 * @return
	 */
	static double expected(double k, String target, int s,
			Map<Entry<String, Integer>, Double> memo, int[] frequency) {
		if (target.length() == 0) {
			return 1;
		}
		if (s == 0) {
			return 0;
		}
		if (s < 0 || target.length() > s) {
			return 0;
		}
		SimpleImmutableEntry<String, Integer> key = new AbstractMap.SimpleImmutableEntry<>(
				target, s);
		if (memo.containsKey(key)) {
			return memo.get(key);
		}
		char c = target.charAt(0);
		double firstLetterOk = (frequency[c] / k)
				* expected(k, target.substring(1), target.length() - 1, memo,
						frequency);
		double restExpected = /*(frequency[c] / k) **/ expected(k, target, s - target.length(), memo, frequency);
//		double firstLetterNotOk = (k - frequency[c]) / k
//		* expected(k, target, s - 1, memo, frequency);
		double firstLetterNotOk = 0;
		double expected = firstLetterOk + restExpected
				+ firstLetterNotOk;
		memo.put(new AbstractMap.SimpleImmutableEntry<>(target, s), expected);
		return expected;
	}

	/**
	 * @param alphabet
	 * @return
	 */
	static int[] freq(String alphabet) {
		int[] frequency = new int['Z' + 1];
		for (int i = alphabet.length(); i-- > 0;) {
			frequency[alphabet.charAt(i)]++;
		}
		return frequency;
	}

	private static int maxOccurrences(int s, String target) {
		String filled = fillWithTarget(s, target);
		int count = 0, pos = 0;
		while ((pos = filled.indexOf(target, pos)) >= 0) {
			pos++;
			count++;
		}
		return count;
	}

	private static String fillWithTarget(int s, String target) {
		StringBuilder sb = new StringBuilder(s);
		while (sb.length() < s) {
			sb.append(target);
		}
		sb.setLength(s);
		return sb.toString();
	}

	private static boolean containsAll(String target, String alphabet) {
		for (int i = 0; i < target.length(); i++) {
			if (!alphabet.contains(Character.toString(target.charAt(i)))) {
				return false;
			}
		}
		return true;
	}
}