package googlecodejam2014.round1b.repeater;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Arrays;

public class Repeater {
	private static final String FEGLA_WON = "Fegla Won";
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(final String[] args) throws IOException {
		final String lineSep = System.getProperty("line.separator");
		final BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			final Writer out = new BufferedWriter(
					args.length > 1 ? new FileWriter(args[1])
							: new OutputStreamWriter(System.out));
			try {
				final int numCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= numCases; ++i) {
					final int n = Integer.parseInt(br.readLine());
					final String[] strings = new String[n];
					for (int j = n; j-- > 0;) {
						strings[j] = br.readLine().trim();
					}
					out.write("Case #" + i + ": " + minChanges(strings)
							+ lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static String minChanges(final String[] strings) {
		final char[] firstChars = findChars(strings[0]);
		// final int[] firstLengths = findLengths(strings[0],
		// firstChars.length);
		// System.out.println(strings[0] + " " + Arrays.toString(firstChars) +
		// " "
		// + Arrays.toString(firstLengths));
		for (int i = 1; i < strings.length; ++i) {
			final char[] otherChars = findChars(strings[i]);
			if (!Arrays.equals(firstChars, otherChars)) {
				return FEGLA_WON;
			}
		}
		final int[][] lengths = new int[strings.length][];
		for (int i = 0; i < strings.length; i++) {
			lengths[i] = findLengths(strings[i], firstChars.length);
		}
		int minSum = Integer.MAX_VALUE;
		if (strings.length == 2) {
			for (final int[] ref : lengths) {
				minSum = Math.min(minSum, minSum(ref, lengths));
			}
			return Integer.toString(minSum);
		}
		int[] minLengths = min(lengths), maxLengths = max(lengths);
		int[] is = minLengths.clone();
		is = addZero(is);
		minLengths = addZero(minLengths);
		maxLengths = addZero(maxLengths);
		minSum = Math.min(minSum, minSum(is, lengths));
		// System.out.println("min: " + Arrays.toString(minLengths) + " max: "
		// + Arrays.toString(maxLengths));
		while (is[is.length - 1] == 0) {
			is[0]++;
			int i = 0;
			while (is[i] > maxLengths[i] && i < is.length - 1) {
				is[++i]++;
			}
			for (int j = 0; j < i; ++j) {
				is[j] = minLengths[j];
			}
			// if (is[i] > maxLengths[i]) {
			// while (i < is.length && is[i] == maxLengths[i]) {
			// ++i;
			// }
			// for (int j = 0; j <= i; ++j) {
			// is[j] = minLengths[j];
			// }
			// int j = i + 1;
			// for (; j < is.length; ++j) {
			// if (is[j] == maxLengths[j]) {
			// continue;
			// } else {
			// is[j]++;
			// i = j;
			// break;
			// }
			// }
			// if (j == is.length) {
			// break loop;
			// }
			// // if (i == is.length - 1) {
			// // if (is[i] > maxLengths[i]) {
			// // break loop;
			// // }
			// // // if (i < is.length - 1) {
			// // // if (is[i + 1] < maxLengths[i]) {
			// // // is[i + 1]++;
			// // // } else {
			// // // minSum = Math.min(minSum, minSum(is, lengths));
			// // // }
			// // // } else {
			// // // break loop;
			// // // }
			// // } else {
			// // is[i + 1]++;
			// // }
			// } else {
			// minSum = Math.min(minSum, minSum(is, lengths));
			// break;
			// }
			// minSum = Math.min(minSum, minSum(is, lengths));
			// // }
			// System.out.println(Arrays.toString(is));
			minSum = Math.min(minSum, minSum(is, lengths));
			// if (is[is.length - 1] > maxLengths[is.length - 1]) {
			// break;
			// }
		}
		return Integer.toString(minSum);
	}

	private static int[] addZero(final int[] maxLengths) {
		final int[] ret = new int[maxLengths.length + 1];
		System.arraycopy(maxLengths, 0, ret, 0, maxLengths.length);
		return ret;
	}

	private static int[] max(final int[][] lengths) {
		final int[] ret = new int[lengths[0].length];
		for (int i = lengths.length; i-- > 0;) {
			for (int j = lengths[i].length; j-- > 0;) {
				ret[j] = Math.max(ret[j], lengths[i][j]);
			}
		}
		return ret;
	}

	private static int[] min(final int[][] lengths) {
		final int[] ret = new int[lengths[0].length];
		Arrays.fill(ret, Integer.MAX_VALUE);
		for (int i = lengths.length; i-- > 0;) {
			for (int j = lengths[i].length; j-- > 0;) {
				ret[j] = Math.min(ret[j], lengths[i][j]);
			}
		}
		return ret;
	}

	private static int minSum(final int[] ref, final int[][] lengths) {
		int sumChanges = 0;
		for (int i = lengths.length; i-- > 0;) {
			for (int j = lengths[i].length; j-- > 0;) {
				sumChanges += Math.abs(lengths[i][j] - ref[j]);
			}
		}
		return sumChanges;
	}

	private static int[] findLengths(final String string, final int length) {
		final int[] ret = new int[length];
		int pos = 0;
		ret[pos] = 1;
		char last = string.charAt(0);
		for (int i = 1; i < string.length(); ++i) {
			if (string.charAt(i) == last) {
				ret[pos]++;
			} else if (pos < length - 1) {
				last = string.charAt(i);
				ret[++pos] = 1;
			}
		}
		return ret;
	}

	private static char[] findChars(final String string) {
		int charCnt = 0;
		final char[] tmp = new char[string.length()];
		char last = tmp[charCnt++] = string.charAt(string.length() - 1);
		for (int i = string.length() - 1; i-- > 0;) {
			if (string.charAt(i) != last) {
				last = tmp[charCnt++] = string.charAt(i);
			}
		}
		final char[] ret = new char[charCnt];
		for (int i = charCnt; i-- > 0;) {
			ret[charCnt - i - 1] = tmp[i];
		}
		return ret;
	}
}
