package googlecodejam2014.round1b.newlottery;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;

public class NewLottery {
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(final String[] args) throws IOException {
		final String lineSep = System.getProperty("line.separator");
		final BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			final Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(args[1]): new OutputStreamWriter(System.out));
			try {
				final int numCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= numCases;++i) {
					final String[] lineParts = br.readLine().split(" ");
					final int a = Integer.parseInt(lineParts[0]), b = Integer
							.parseInt(lineParts[1]), k = Integer
							.parseInt(lineParts[2]);
					out.write("Case #" + i + ": "
							+ winningCombinations(a, b, k) + lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static int winningCombinations(final int a, final int b, final int k) {
		int count = 0;
		for (int i = 0; i < a; ++i) {
			for (int j = 0; j < b; ++j) {
				final int winner = i & j;
				if (winner < k) {
					++count;
				}
			}
		}
		return count;
	}
}
