package googlecodejam2014.qualification.cookieclicker;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.HashSet;
import java.util.Set;

public class CookieClickerAlpha {
	private static final double INITIAL = 2d;

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(
					args[1]) : new OutputStreamWriter(System.out));
			try {
				int numCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= numCases; ++i) {
					String line = br.readLine();
					String[] parts = line.split(" ");
					double c = Double.parseDouble(parts[0]), f = Double
							.parseDouble(parts[1]), x = Double
							.parseDouble(parts[2]);

					out.write("Case #" + i + ": " + minTime(c, f, x) + lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static double minTime(double c, double f, double x) {
		double minTime = x / INITIAL, last = minTime;
		int bought = 1;
		double spentTime = 0;
		do {
			double currentSpeed = (bought - 1) * f + INITIAL;
			double timeToBuy = c / currentSpeed;
			spentTime += timeToBuy;
			last = spentTime + x / (bought * f + INITIAL);
			//System.out.println("bought: " + bought + " in time: " + spentTime + " currentSpeed: " + currentSpeed + "\n" + (last <= minTime ? "**" : "  ") + " " + last);
			if (last < minTime) {
				minTime = last;
			}
			++bought;
		} while (last <= minTime && spentTime < minTime);
		return minTime;
	}
}
