package googlecodejam2012.round2.swingingwild;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.TreeMap;

public class SwingingWild {
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(
					args[1]) : new OutputStreamWriter(System.out));
			try {
				int numLines = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= numLines; ++i) {
					String line = br.readLine();
					int n = Integer.parseInt(line);
					int[] ds = new int[n], ls = new int[n];
					for (int j = 0; j < n; ++j) {
						String l = br.readLine();
						String[] parts = l.split(" +");
						ds[j] = Integer.parseInt(parts[0]);
						ls[j] = Integer.parseInt(parts[1]);
					}
					line = br.readLine();
					int d = Integer.parseInt(line);
					out.write("Case #" + i + ": "
							+ (isPossible(ds, ls, d) ? "YES" : "NO") + lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static boolean isPossible(int[] ds, int[] ls, int d) {
		TreeMap<Integer, Integer> reachable = new TreeMap<Integer, Integer>();
		reachable.put(Integer.valueOf(0),
				Integer.valueOf(Math.min(ds[0], ls[0])));
		while (!reachable.isEmpty()) {
			Integer next = reachable.firstKey();
			int n = next.intValue();
			int nextMax = reachable.get(next).intValue();
			reachable.remove(next);
			if (d <= ds[n] + Math.min(ls[n], nextMax)) {
				return true;
			}
			for (int i = n + 1; i < ds.length; ++i) {
				if (ds[i] <= ds[n] + Math.min(ls[n], nextMax)) {
					if (reachable.containsKey(i)) {
						reachable.put(
								i,
								Math.max(reachable.get(i),
										Math.min(ds[i] - ds[n], nextMax)));
					} else
						reachable.put(i, Math.min(ds[i] - ds[n], nextMax));
				}
			}
		}
		return false;
	}
}
