/*
 * 
 */
package codejam2015.q.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Arrays;

/**
 *
 * @author Gabor Bakos
 */
public class InfiniteHouseOfPancakes {

	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		try (BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
				Writer out = new BufferedWriter(
						args.length > 1 ? new FileWriter(args[1])
								: new OutputStreamWriter(System.out))) {
			int numCases = Integer.parseInt(br.readLine().trim());
			for (int i = 1; i <= numCases; ++i) {
				String length = br.readLine();
				String line = br.readLine();
				int[] parts = Arrays.stream(line.split(" ")).mapToInt(p -> Integer.parseInt(p)).toArray();
				assert parts.length == Integer.parseInt(length);
				out.write("Case #" + i + ": " + minTime(parts)
						+ lineSep);
			}
		}
	}

	private static int minTime(int[] pancakes) {
		return minTime(pancakes, 0);
	}
	
	private static int minTime(int[] pancakes, int timePassed) {
		Arrays.sort(pancakes);
		reverse(pancakes);
		if (pancakes[0] <= 3) {
			return pancakes[0] + timePassed;
		}
//		if (pancakes[0] == 4) {
//			return timePassed + (pancakes.length == 1 || pancakes[1] < 4 ? 3 : 4);
//		}
		int[] newArray = new int[pancakes.length + 1];
		System.arraycopy(pancakes, 0, newArray, 0, pancakes.length);
		newArray[0] = (pancakes[0] + 1) / 2;
		newArray[pancakes.length] = pancakes[0] - newArray[0];
		return Math.min(minTime(subtractOne(pancakes), timePassed + 1), minTime(newArray, timePassed + 1));
	}

	private static int[] subtractOne(int[] is) {
		for (int i = is.length; i-->0;) {
			is[i]--;
		}
		return is;
	}

	private static int[] reverse(int... pancakes) {
		for (int i = pancakes.length %2 + pancakes.length / 2 ; i < pancakes.length; ++i) {
			int from = i, to = pancakes.length - 1 - i;
			pancakes[from] ^= pancakes[to];
			pancakes[to] ^= pancakes[from];
			pancakes[from] ^= pancakes[to];
		}
		return pancakes;
	}
}
