package googlecodejam2014.qualification.magictrick;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.HashSet;
import java.util.Set;

public class MagicTrick {
	private static final String BAD_MAGICIAN = "Bad magician!";
	private static final String CHEATER = "Volunteer cheated!";
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(args[1]): new OutputStreamWriter(System.out));
			try {
				int numCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= numCases;++i) {
					int firstAnswer = Integer.parseInt(br.readLine().trim());
					int[][] firstArrangement = readArrangements(br);
					int secondAnswer = Integer.parseInt(br.readLine().trim());
					int[][] secondArrangement = readArrangements(br);
					
					out.write("Case #" + i + ": "+evaluate(firstAnswer - 1, firstArrangement, secondAnswer - 1, secondArrangement) + lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static int[][] readArrangements(BufferedReader br) throws IOException {
		int[][] ret = new int[4][4];
		for (int i = 0; i < 4; ++i) {
			String line = br.readLine();
			String[] parts = line.split(" ");
			for (int j = 4; j -->0; ) {
				ret[i][j] = Integer.parseInt(parts[j]);
			}
		}
		return ret;
	}

	private static String evaluate(int firstAnswer/*row0*/, int[][] firstArrangement,
			int secondAnswer/*row0*/, int[][] secondArrangement) {
		int[] firstOptions = firstArrangement[firstAnswer];
		int[] secondOptions = secondArrangement[secondAnswer];
		Set<Integer> common = new HashSet<>();
		for (int o : firstOptions) {
			for (int so : secondOptions) {
				if (o == so) {
					common.add(o);
				}
			}
		}
		return common.isEmpty() ? CHEATER : common.size() > 1 ? BAD_MAGICIAN : common.iterator().next().toString();
	}
}
