package googlecodejam2013.round1c.consonants;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.BitSet;

public class Consonants {
	private static boolean isConsonant(char c) {
		switch (c) {
		case 'a':
		case 'e':
		case 'i':
		case 'o':
		case 'u':
			return false;
		}
		return true;
	}

	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(
					args[1]) : new OutputStreamWriter(System.out));
			try {
				int testCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= testCases; ++i) {
					String[] line = br.readLine().split(" ");
					out.write("Case #" + i + ": "
							+ nValue(line[0], Integer.parseInt(line[1]))
							+ lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static long nValue(String string, int n) {
		boolean[] consonants = new boolean[string.length()];
		for (int i = string.length(); i-- > 0;)
			consonants[i] = isConsonant(string.charAt(i));
		BitSet startOfNConsonants = new BitSet();
		int consec = 0;
		for (int i = 0; i < consonants.length; ++i) {
			if (consonants[i])
				++consec;
			else
				consec = 0;
			if (consec >= n)
				startOfNConsonants.set(i - n + 1);
		}
		long ret = 0;
		int start = 0;
		int card = startOfNConsonants.cardinality();
		for (int i = 0; i < card; ++i) {
			start = startOfNConsonants.nextSetBit(start) + 1;
			int next;
			if (i < card - 1) {
				next = startOfNConsonants.nextSetBit(start);
			} else {
				next = string.length() - n + 1;
			}
			ret += start * (next - start + 1);
		}
		return ret;
	}
}
