/*
 * 
 */
package codejam2015.round1c.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;

/**
 *
 * @author Gabor Bakos
 */
public class Brattleship {
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		for (int c = 2; c <= 10; ++c) {
			for (int w = 1; w <= c; ++w) {
				System.out.print(minGuesses(1, c, w));
				System.out.print(" ");
			}
			System.out.println();
		}
		String lineSep = System.getProperty("line.separator");
		try (BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
				Writer out = new BufferedWriter(
						args.length > 1 ? new FileWriter(args[1])
								: new OutputStreamWriter(System.out))) {
			int numCases = Integer.parseInt(br.readLine().trim());
			for (int i = 1; i <= numCases; ++i) {
				String[] parts = br.readLine().split(" ");
				int r = Integer.parseInt(parts[0]), c = Integer.parseInt(parts[1]), w = Integer.parseInt(parts[2]);
				out.write("Case #" + i + ": " + minGuesses(r, c, w)
						+ lineSep);
			}
		}
	}

	private static int minGuesses(int r, int c, int w) {
		if (r == 1) {
			if (w == 1) {
				return c;
			}
			if (w == c) {
				return c;
			}
			
			
			//||XX|| -> 4
			//||X|X| -> 3
			//||X|O| -> 5
			//||XO|| -> 4
			//||XO|| -> 4
			
			//|O|OOXX -> 5
			//c\w 2 3 4 5 6 7 8 9 10
			//2 | 2
			//3 | 3 3
			//4 | 3 4 4          c - (c - w) / 2
			//5 | 4 4 5 5
			//6 | 4 5 5 6 6
			//7 | 5 5 6 6 7 7
			//8 | 
			//9 |
			//10|
			//c > w
			return c - (c-w) / 2;
		}
		return r * c;
	}
}
