/*
 * 
 */
package codejam2015.round1c.c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.BitSet;

/**
 *
 * @author Gabor Bakos
 */
public class MoneyProblems {
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		try (BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
				Writer out = new BufferedWriter(
						args.length > 1 ? new FileWriter(args[1])
								: new OutputStreamWriter(System.out))) {
			int numCases = Integer.parseInt(br.readLine().trim());
			for (int i = 1; i <= numCases; ++i) {
				String[] parts = br.readLine().split(" ");
				int c = Integer.parseInt(parts[0]), d = Integer.parseInt(parts[1]), v = Integer.parseInt(parts[2]);
				parts = br.readLine().split(" ");
				BitSet set = new BitSet(v + 1);
				for (String part : parts) {
					set.set(Integer.parseInt(part));
				}
				out.write("Case #" + i + ": " + minNewCoins(c, v, set)
						+ lineSep);
			}
		}
	}

	private static int minNewCoins(int c, int v, BitSet set) {
		int min = 0;
		BitSet all = new BitSet(v + 1);
		addFrom(all, set, 0, 0);
		System.out.println(all);
		while (!containsAll(all, v)) {
			int newElem = firstMissing(all, v);
			all.clear();
			min++;
			set.set(newElem);
			addFrom(all, set, 0, 0);
		}
		return min;
	}

	private static boolean containsAll(BitSet all, int v) {
		return firstMissing(all, v) == -1;
	}
	
	private static int firstMissing(BitSet all, int v) {
		for (int i = 1; i <= v; ++i) {
			if (!all.get(i)) {
				return i;
			}
		}
		return -1;
	}

	private static void addFrom(BitSet all, BitSet set, int start, int offset) {
		for (int i = set.nextSetBit(start); i >= 0; i = set.nextSetBit(i+1)) {
			all.set(i + offset);
			addFrom(all, set, i + 1, i + offset);
		}
	}

}