package googlecodejam2012.round2.aerobic;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Locale;
import java.util.Random;

public class Aerobic {
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(
					args[1]) : new OutputStreamWriter(System.out));
			try {
				int numLines = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= numLines; ++i) {
					String line = br.readLine();
					String[] parts = line.split(" +");
					int n = Integer.parseInt(parts[0]), w = Integer
							.parseInt(parts[1]), l = Integer.parseInt(parts[2]);
					String line2 = br.readLine();
					double[] radiuses = createRadiuses(line2);
					out.write("Case #" + i + ": "
							+ toString(findSolutionRandom(radiuses, w, l))
							+ lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static String toString(double[][] findSolution) {
		StringBuilder sb = new StringBuilder();
		Locale.setDefault(Locale.US);
		for (double[] ds : findSolution) {
			for (double d : ds) {
				sb.append(String.format("%f", d)).append(' ');
			}
		}
		sb.setLength(sb.length() - 1);
		return sb.toString();
	}

	private static double[][] findSolutionRandom(double[] radiuses, int w, int l) {
		double[][] ret = new double[radiuses.length][2];
		Random r = new Random();
		ret[0][0] = 0;
		ret[0][1] = 0;
		for (int i = 1; i < radiuses.length; i++) {
			double x = r.nextDouble() * w, y = r.nextDouble() * l;
			while (!isOk(x, y, radiuses, ret, i)) {
				x = r.nextDouble() * w;
				y = r.nextDouble() * l;
			}
			ret[i][0] = x;
			ret[i][1] = y;
		}
		return ret;
	}

	private static double diff(double x1, double y1, double x2, double y2) {
		return Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
	}

	private static boolean isOk(double x, double y, double[] radiuses,
			double[][] ret, int next) {
		for (int i = 0; i < next; ++i) {
			if (diff(ret[i][0], ret[i][1], x, y) <= radiuses[i]
					+ radiuses[next] + 1) {
				return false;
			}
		}
		return true;
	}

	private static double[] createRadiuses(String line) {
		String[] parts = line.split(" +");
		double[] ret = new double[parts.length];
		for (int i = parts.length; i-- > 0;) {
			ret[i] = Double.parseDouble(parts[i]);
		}
		return ret;
	}

}
