package googlecodejam2013.round1b.osmos;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Arrays;

public class Osmos {
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(
					args[1]) : new OutputStreamWriter(System.out));
			try {
				int testCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= testCases; ++i) {
					String[] sizeLine = br.readLine().split(" ");
					int moteSize = Integer.parseInt(sizeLine[0]);
					int otherMotes = Integer.parseInt(sizeLine[1]);
					String[] sizesLine = br.readLine().split(" ");
					out.write("Case #" + i + ": " + minChanges(moteSize, parseSizes(otherMotes, sizesLine)) + lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static int minChanges(int moteSize, int[] otherMotes) {
		int ret = 0;
		Arrays.sort(otherMotes);
		int newMote = merge(moteSize, otherMotes);
		if (otherMotes[otherMotes.length - 1] == 0) {
			return 0;
		}
		int lastZero = -1;
		while (otherMotes[lastZero+1] == 0) {
			lastZero++;
		}
		int[] newMoteAdded = otherMotes.clone();
		int[] deleteLargeMote = otherMotes.clone();
		if (lastZero >= 0) {
			System.arraycopy(otherMotes, 0, deleteLargeMote, 1, otherMotes.length - 1);
			int nm;
			if (newMote <= 1) {
				nm = Integer.MAX_VALUE;
			} else {
				newMoteAdded[lastZero] = newMote - 1;
				nm = minChanges(newMote, newMoteAdded);
			}
			int dm = minChanges(newMote, deleteLargeMote);
			ret = Math.min(nm, dm) + 1;
		} else {
			int nm;
			if (newMote <= 1) {
				nm = Integer.MAX_VALUE;
			} else {
				newMoteAdded = new int[otherMotes.length + 1];
				System.arraycopy(otherMotes, 0, newMoteAdded, 1, otherMotes.length);
				newMoteAdded[0] = newMote - 1;
				nm = minChanges(newMote, newMoteAdded);
			}
			deleteLargeMote[0] = 0;
			System.arraycopy(otherMotes, 0, deleteLargeMote, 1, otherMotes.length - 1);
			int dm = minChanges(newMote, deleteLargeMote);
			ret = Math.min(nm, dm) + 1;
		}
		return ret;
	}

	private static int merge(int moteSize, int[] otherMotes) {
		for (int cursor = 0; cursor < otherMotes.length && moteSize > otherMotes[cursor]; ++cursor) {
			moteSize+= otherMotes[cursor];
			otherMotes[cursor] = 0;
		}
		return moteSize;
	}

	private static int[] parseSizes(int otherMotes, String[] sizesLine) {
		int[] ret = new int[otherMotes];
		for (int i = sizesLine.length; i-->0;) {
			ret[i] = Integer.parseInt(sizesLine[i]);
		}
		return ret;
	}
}
