package googlecodejam2014.qualification.deceitfulwar;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.util.Arrays;
import java.util.SortedSet;
import java.util.TreeSet;

public class DeceitfulWar {

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		String lineSep = System.getProperty("line.separator");
		BufferedReader br = new BufferedReader(
				args.length > 0 ? new FileReader(args[0])
						: new InputStreamReader(System.in));
		try {
			Writer out = new BufferedWriter(args.length > 1 ? new FileWriter(
					args[1]) : new OutputStreamWriter(System.out));
			try {
				int numCases = Integer.parseInt(br.readLine().trim());
				for (int i = 1; i <= numCases; ++i) {
					int n = Integer.parseInt(br.readLine().trim());
					String[] parts = br.readLine().split(" ");
					double[] naomi = read(parts, n);
					Arrays.sort(naomi);
					parts = br.readLine().split(" ");
					double[] ken = read(parts, n);
					Arrays.sort(ken);
					out.write("Case #" + i + ": " + deceitfulWar(naomi, ken) + " " + war(naomi, ken) + lineSep);
				}
			} finally {
				out.close();
			}
		} finally {
			br.close();
		}
	}

	private static int war(double[] naomi, double[] ken) {
		int wins = 0;
		SortedSet<Double> n = new TreeSet<>(), k = new TreeSet<>();
		for (int i = naomi.length; i-->0;) {
			n.add(naomi[i]);
			k.add(ken[i]);
		}
		for (int i = 0; i < naomi.length; i++) {
			SortedSet<Double> tailSet = k.tailSet(naomi[i]);
			if (tailSet.isEmpty()) {
				wins++;
				k.remove(k.first());
			} else {
				k.remove(tailSet.first());
			}
		}
		return wins;
	}

	private static int deceitfulWar(double[] naomi, double[] ken) {
//		if (naomi[0] > ken[ken.length - 1]) {
//			return naomi.length;
//		}
		int lost = 0, won = 0;
		for (int i = ken.length; i-->0;) {
			if (naomi[naomi.length - 1 - won] < ken[i]) {
				lost++;
			} else {
				won++;
			}
		}
		//return naomi[0] > ken[ken.length - 1] ? naomi.length : 2*naomi.length + (Arrays.binarySearch(ken, naomi[naomi.length - 1] + 1));
//		System.out.println(won);
//		return naomi.length - Math.max(1, lost);
		return won;
	}

	private static double[] read(String[] parts, int n) {
		double[] ret = new double[n];
		assert ret.length == parts.length;
		for (int i = n; i-->0;) {
			ret[i] = Double.parseDouble(parts[i]);
		}
		return ret;
	}

}
