import java.io.*;
import java.util.*;

public class worldcup
{
	static long[][] supermemo = new long[1024][12];
	public static void main(String[] args)throws IOException
	{
		BufferedReader in = new BufferedReader(new FileReader("worldcup.in"));
		PrintStream out = new PrintStream("worldcup.out");

		int testcase = Integer.parseInt(in.readLine());

		for (int t = 1; t<= testcase; t++)
		{
			int depth = Integer.parseInt(in.readLine());
			int[] must = new int[1<<depth];
			for (long[] a : supermemo)
				Arrays.fill(a, -1);

			String[] parsed = in.readLine().split(" +");

			for (int x=0; x<must.length; x++)
				must[x] = depth - Integer.parseInt(parsed[x]);

			int idcount = 0;
			Node[] top = new Node[1<<(depth - 1)];
			ArrayList<Node> layer = new ArrayList<Node>();
			parsed = in.readLine().split(" +");
			for (int x=0; x<top.length; x++)
			{
				top[x] = new Node(null, null, Integer.parseInt(parsed[x]), Math.max(must[2*x], must[2*x+1]), idcount++);
				layer.add(top[x]);
			}
			Node bottom;
			for (int x=1; x<depth; x++)
			{
				parsed = in.readLine().split(" +");
				ArrayList<Node> next = new ArrayList<Node>();
				for (int y = 0; y<1<<(depth-x-1); y++)
				{
					Node newnode = new Node(layer.get(2*y), layer.get(2*y+1), Integer.parseInt(parsed[y]), Math.max(layer.get(2*y).must, layer.get(2*y+1).must), idcount++);
					next.add(newnode);
					layer.get(2*y).c = newnode;
					layer.get(2*y+1).c = newnode;
				}
				layer = next;
			}
			bottom = layer.get(0);

			long ans = magic(bottom, 0);
			out.printf("Case #%d: %d\n", t, ans);
		}
	}


	private static long magic(Node cur, int sat)
	{
		if (supermemo[cur.id][sat] != -1)
			return supermemo[cur.id][sat];

		if (sat >= cur.must)
		{
			return 0;
		}
		if (cur.p1 == null && sat == cur.must - 1)
			return cur.cost;
		else if (cur.p1 == null)
			return Long.MAX_VALUE;
		long a1 = magic(cur.p1, sat + 1);
		long a2 = magic(cur.p2, sat + 1);
		long try1 = Long.MAX_VALUE;
		if (a1 < Long.MAX_VALUE && a2 < Long.MAX_VALUE)
			try1 = a1 + a2 + cur.cost;

		a1 = magic(cur.p1, sat);
		a2 = magic(cur.p2, sat);
		long try2 = Long.MAX_VALUE;
		if (a1 < Long.MAX_VALUE && a2 < Long.MAX_VALUE)
			try2 = a1 + a2;
		
		supermemo[cur.id][sat] = Math.min(try1, try2);
		return supermemo[cur.id][sat];
	}
}
class Node
{
	public Node p1, p2;
	public Node c;
	public int cost;
	public int must;
	public int id;

	public Node(Node pp1, Node pp2, int co, int mu, int i)
	{
		p1 = pp1;
		p2 = pp2;
		cost = co;
		must = mu;
		id = i;
	}
}
