import java.io.*;

public class Watersheds
{
	static int h, w;
	static int[][] map;
	static char[][] labels;
	static final int N = 0, E = 1, S = 2, W = 3;
	static char curLetter;
	static int letterCount=0;
	static boolean firstrun = true;
	
	public static void main(String[] args)throws IOException
	{
		BufferedReader in = new BufferedReader(new FileReader("Watersheds.in"));
		PrintWriter out = new PrintWriter("Watersheds.out");
//		PrintStream out = System.out;
		
		int testcase = Integer.parseInt(in.readLine());
		
		for (int t=1; t<=testcase; t++)
		{
			firstrun = true;
			String[] c = in.readLine().split(" ");
			h = Integer.parseInt(c[0]);
			w = Integer.parseInt(c[1]);
			
			map = new int[w][h];
			labels = new char[w][h];
			curLetter = 'a';
			labels[0][0] = 'a';
			letterCount = 0;
			
			for (int y = 0; y < h; y++)
			{
				c = in.readLine().split(" ");
				for (int x = 0; x < w; x++)
				{
					map[x][y] = Integer.parseInt(c[x]);
				}
			}
			
			for (int y = 0; y < h; y++)
			{
				for (int x = 0; x < w; x++)
				{
					curLetter = (char)(letterCount + 97);
//					for (int j = 0; j < h; j++)
//					{
//						for (int i = 0; i < w; i++)
//						{
//							out.print(labels[i][j] + (i < w-1?" ":""));
//						}
//						out.println();
//					}
					if (labels[x][y] == '\0'||x==0&&y==0)
					{
						doWork(x, y);
						firstrun = false;
						labels[x][y] = curLetter;
					}
				}
			}
			
			out.println("Case #" + t + ": ");
			
			for (int y = 0; y < h; y++)
			{
				for (int x = 0; x < w; x++)
				{
					out.print(labels[x][y] + (x < w-1?" ":""));
				}
				out.println();
			}
		}
		out.close();
	}
	
	public static void doWork(int x, int y)
	{
//		System.out.println(x + " " + y);
		int dir = getLowest(x, y);
//		System.out.println(dir);
		if (dir == Integer.MAX_VALUE)
		{
			if (labels[x][y] != '\0')
			{
				curLetter = labels[x][y];
			}
			else if (!firstrun)
			{
				letterCount++;
				curLetter = (char)(letterCount + 97);
			}
			labels[x][y] = curLetter;
			return;
		}
		if (dir == E)
		{
			if (labels[x+1][y] != '\0')
			{
				curLetter = labels[x+1][y];
				return;
			}
			doWork(x+1, y);
			labels[x][y] = curLetter;
		}
		
		if (dir == N)
		{
			if (labels[x][y-1] != '\0')
			{
				curLetter = labels[x][y-1];
				return;
			}
			doWork(x, y-1);
			labels[x][y] = curLetter;
		}
		
		if (dir == S)
		{
			if (labels[x][y+1] != '\0')
			{
				curLetter = labels[x][y+1];
				return;
			}
			doWork(x, y+1);
			labels[x][y] = curLetter;
		}
		
		if (dir == W)
		{
			if (labels[x-1][y] != '\0')
			{
				curLetter = labels[x-1][y];
				return;
			}
			doWork(x-1, y);
			labels[x][y] = curLetter;
		}
	}
	
	public static boolean isPeak(int x, int y)
	{
		boolean ans = true;
		if (x<w-1)
			ans = (map[x][y]>=map[x+1][y]||labels[x+1][y]!='\0');
		if (y<h-1)
			ans = ans&&(map[x][y]>=map[x][y+1]||labels[x][y+1]!='\0');
		if (x>0)
			ans = ans&&(map[x][y]>=map[x-1][y]||labels[x-1][y]!='\0');
		if (y>0)
			ans = ans&&(map[x][y]>=map[x][y-1]||labels[x][y-1]!='\0');
			
		return ans;
	}
	
	public static int getLowest(int x, int y)
	{
		int lowest = map[x][y];
		int dir = Integer.MAX_VALUE;
		if (y>0)
		{

			if (lowest >map[x][y-1])
			{
				lowest = map[x][y-1];
				dir = N;
			}

		}
		
		if (x>0)
		{

			if (lowest >map[x-1][y])
			{
				lowest = map[x-1][y];
				dir = W;
			}

		}
		
		if (x<w-1)
		{

			if (lowest >map[x+1][y])
			{
				lowest = map[x+1][y];
				dir = E;
			}

		}
		if (y<h-1)
		{

			if (lowest >map[x][y+1])
			{
				lowest = map[x][y+1];
				dir = S;
			}

		}
		
		
//		System.out.println(x + " " + y + " " + dir);
			
		return dir;
	}
}