import java.io.*;
import java.util.*;

public class A {

	static String[] numbers = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};

	static HashMap<Character, int[]> charsToIntegers = new HashMap<Character, int[]>();
	
	static {
		
		charsToIntegers.put('Z', new int[]{0});
		charsToIntegers.put('E', new int[]{0, 1, 3, 5, 7, 8, 9});
		charsToIntegers.put('R', new int[]{0, 3, 4});
		charsToIntegers.put('O', new int[]{0, 1, 2, 4});
		charsToIntegers.put('N', new int[]{1, 7, 9});
		charsToIntegers.put('T', new int[]{2, 3, 8});
		charsToIntegers.put('W', new int[]{2});
		charsToIntegers.put('H', new int[]{3, 8});
		charsToIntegers.put('F', new int[]{4, 5});
		charsToIntegers.put('U', new int[]{4});
		charsToIntegers.put('I', new int[]{5, 6, 8, 9});
		charsToIntegers.put('V', new int[]{5, 7});
		charsToIntegers.put('S', new int[]{6, 7});
		charsToIntegers.put('X', new int[]{6});
		charsToIntegers.put('G', new int[]{8});
	}
	
	public static void main(String[] args) {
		try {
			Scanner in = getScanner();
			int t = getInt(in);
		
			

			TESTS_LOOP: for (int testIndex = 0; testIndex < t; testIndex++) {
				String s = getString(in);
				List<Integer> numbersList = new ArrayList<Integer>();
				int[] charsCount = new int['Z' - 'A' + 1];
				for (int i = 0; i < s.length(); i++) {
					charsCount[s.charAt(i) - 'A']++;
				}
				for (int i = 0; i < charsCount.length; i++) {
					if (charsCount[i] > 0
							&& charsToIntegers.get((char)('A' + i)).length == 1) {
						for (int j = 0; j < charsCount[i]; j++) {
							addInteger(numbersList, charsToIntegers.get((char)('A' + i))[0], charsCount);
						}
					}
				}
				int[] charsCountCopy = Arrays.copyOf(charsCount, charsCount.length);
				List<Integer> candidateIntegers = getListOfInteger(charsCountCopy, 0, 0);
				if (candidateIntegers != null) {
					numbersList.addAll(candidateIntegers);
				}
				Collections.sort(numbersList);
				String result = "";
				for (Integer i : numbersList) {
					result += i;
				}
				outResultLine(testIndex, result);
			}
		} catch (Throwable t) {
			t.printStackTrace();
		}
	}
	
	private static List<Integer> getListOfInteger(int[] charsCount, int iStart, int depth) {
		if (depth > 14) {
			return null;
		}
		List<Integer> candidateIntegers = null;
		boolean charFound = false;
		for (int i = iStart; i < charsCount.length; i++) {
			if (charsCount[i] != 0) {
				charFound = true;
				int[] possibleIntegers = charsToIntegers.get((char)('A' + i));
				int[] charsCountCopy = Arrays.copyOf(charsCount, charsCount.length);
				for (int j = 0; j < possibleIntegers.length; j++) {
					if (constructInteger(charsCountCopy, possibleIntegers[j])) {
						candidateIntegers = getListOfInteger(charsCountCopy, i, ++depth);
						if (candidateIntegers != null) {
							candidateIntegers.add(possibleIntegers[j]);
							return candidateIntegers;
						}
					}
				}
			}
		}
		if (charFound) {
			return null;
		} else {
			// reached end, all consumed.
			return new ArrayList<Integer>();
		}
	}

	private static boolean constructInteger(int[] charsCount, int integer) {
		int[] charCountCopy = Arrays.copyOf(charsCount, charsCount.length);
		for (int i = 0; i < numbers[integer].length(); i++) {
			charCountCopy[numbers[integer].charAt(i) - 'A']--;
			if (charCountCopy[numbers[integer].charAt(i) - 'A'] < 0) {
				return false;
			}
		}
		for (int i = 0; i < numbers[integer].length(); i++) {
			charsCount[numbers[integer].charAt(i) - 'A']--;
		}
		return true;
	}

	private static void addInteger(List<Integer> numbersList, int integer,
			int[] charsCount) {
		numbersList.add(integer);
		for (int i = 0; i < numbers[integer].length(); i++) {
			charsCount[numbers[integer].charAt(i) - 'A']--;
		}
	}

	private static String getString(Scanner in) {
		return in.next();
	}

	private static int getInt(Scanner in) {
		return in.nextInt();
	}

	private static Scanner getScanner() {
		return new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	}

	private static void outResultLine(int testIndex, String result) {
		System.out.println("Case #" + (testIndex + 1) + ": " + result);
	}

}
