import java.util.*;
import java.io.*;

public class QualificationQ1 {
	
	public static void main(String[] args) {
		try {
			solve();
		} catch(Throwable t) {
			t.printStackTrace();
		}
	}
	
	private static void solve() {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
	    in.nextLine();
	    for (int x = 1; x <= t; ++x) {
	      String s = in.next();
	      int k = in.nextInt();
	      
	      BitSet panCakesState = new BitSet(s.length());
	      for (int i = 0; i < s.length(); i++) {
	    	  if (s.charAt(i) == '+') {
	    		  panCakesState.set(i);
	    	  }
	      }

	      boolean impossible = false;
	      
	      // checking for the impossible
	      int overlapping = (k * 2) - s.length();
	      if (overlapping > 1) {
	    	  int startCheckIndex = k - overlapping;
	    	  boolean refValue = panCakesState.get(startCheckIndex);
	    	  for (int i = startCheckIndex + 1; i < startCheckIndex + overlapping; i++) {
	    		if (panCakesState.get(i) != refValue) {
	    			// mismatched within middle overlapping --> impossible
	    			impossible = true;
	    		}
	    	  }
	      }

	      
    	  int count = 0;
	      if (!impossible) {
	    	  for (int i = 0; i < s.length(); i++) {
	    		  if (panCakesState.get(i)) {
	    			  continue;
	    		  }
	    		  // check if we can flip
	    		  if (s.length() - i < k) {
	    			  impossible = true;
	    			  break;
	    		  } else if (s.length() - i == k) {
	    			  // last flip
	    			  for (int j = i + 1; j < s.length(); j++) {
	    				  if (panCakesState.get(j)) {
	    					  impossible = true;
	    				  }
	    			  }
	    			  count++;
	    			  break;
	    		  }
	    		  // flip
	    		  count++;
	    		  for (int j = 0; j < k; j++) {
	    			  panCakesState.set(i + j, !panCakesState.get(i + j));
	    		  }
	    		  
	    	  }
	      }
	      
	      String y = impossible ? "IMPOSSIBLE" : ("" + count);
	      
	      // write o/p
	      System.out.println("Case #" + x + ": " + y);
	    }
		
	}

}
