package code2013.quals;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Lawnmower2 {
	private boolean onlyOneFalse(boolean[] identialColFlags) {
		int count = 0;
		for (boolean flag: identialColFlags) {
			if (!flag) {
				++count;
			}
		}
		
		return count == 1;
	}
	private boolean scanColsForError(int[][] grid, boolean[] identialRowFlags, boolean[] identialColFlags, int row, int col) {
		int unusualValue = grid[row][col];
		for (int i=0; i<grid.length; ++i) {
			if (i == row)
				continue;
			if (grid[i][col] != unusualValue) {
				if (!identialRowFlags[i]) {
					return true;
				}
			}
		}
		
		if (onlyOneFalse(identialColFlags)) {
			return true;
		}
		
		return false;
	}
	
	private boolean identicalRow(int[][] grid, int rowId) {
		int prev = grid[rowId][0];
		for (int i=0; i<grid[rowId].length; ++i) {
			if (grid[rowId][i] != prev) {
				return false;
			}
		}
		return true;
		
	}
	
	private boolean identicalCol(int[][] grid, int colId) {
		int prev = grid[0][colId];
		for (int i=0; i<grid.length; ++i) {
			if (grid[i][colId] != prev) {
				return false;
			}
		}
		return true;
		
	}

	
	public boolean validPattern(int[][] grid) {
		boolean[] identialRowFlags = new boolean [grid.length];
		for (int i=0; i<grid.length; ++i) {
			if (identicalRow(grid, i)) {
				identialRowFlags[i] = true;
			}
		}
		
		boolean[] identialColFlags = new boolean [grid[0].length];
		for (int i=0; i<grid[0].length; ++i) {
			if (identicalCol(grid, i)) {
				identialColFlags[i] = true;
			}
		}
		
		for (int i=0; i<identialRowFlags.length; ++i) {
			if (!identialRowFlags[i]) {
				for(int j=0; j<identialColFlags.length; ++j) {
					if (!identialColFlags[j]) {
						if (scanColsForError(grid, identialRowFlags, identialColFlags, i, j)) {
							return false;
						}						
					}
				}
			}
		}
		
		
		return true;		
	}
	

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		Lawnmower2 lm2 = new Lawnmower2();
		Scanner sc = new Scanner(new BufferedReader(new FileReader("B-small-attempt2.in")));
		BufferedWriter bw = new BufferedWriter(new FileWriter("Lawnmower.txt"));
		int maxTestCount = sc.nextInt();
		sc.nextLine();
		for (int tc=1; tc<=maxTestCount; ++tc) {
			int N = sc.nextInt();
			int M = sc.nextInt();
			int[][] dataGrid = new int[N][M];
			for (int i=0; i<N; ++i) {
				for (int j=0; j<M; ++j) {
					dataGrid[i][j] = sc.nextInt();					
				}				
			}
			
/*			for (int i=0; i<N; ++i) {
				System.out.println(Arrays.toString(dataGrid[i]));
			}
*/			
			String outString = null; 
			if (lm2.validPattern(dataGrid)) {
				outString = "Case #" + tc + ": YES";
			} else {
				outString = "Case #" + tc + ": NO";
			}
			// System.out.println(outString);

			bw.write(outString);
			bw.newLine();
			sc.nextLine();
		}
		bw.close();
	}

}
