package com.abp.google.codejam2017;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

/**
 * Created by aby on 4/8/2017.
 */
public class ProblemC_Small {
    private static class ResultTuple {
        int max;
        int min;

        public ResultTuple(int max, int min) {
            this.max = max;
            this.min = min;
        }

        @Override
        public String toString() {
            return "ResultTuple{" +
                    "max=" + max +
                    ", min=" + min +
                    '}';
        }
    }

    private static class VaccancyTuple {
        int Ls;
        int Rs;
        int stallId;
        int min;
        int max;

        public VaccancyTuple(int ls, int rs, int stallId) {
            this.Ls = ls;
            this.Rs = rs;
            this.stallId = stallId;
            this.min = Math.min(ls, rs);
            this.max = Math.max(ls, rs);
        }

        @Override
        public String toString() {
            return "VaccancyTuple{" +
                    "Ls=" + Ls +
                    ", Rs=" + Rs +
                    ", stallId=" + stallId +
                    ", min=" + min +
                    ", max=" + max +
                    '}';
        }
    }

    private static class Compare implements Comparator<VaccancyTuple> {
        @Override
        public int compare(VaccancyTuple o1, VaccancyTuple o2) {
            int min1 = o1.min;
            int min2 = o2.min;
            if (o1.min == o2.min) {
                int max1 = o1.max;
                int max2 = o2.max;
                if (max1 == max2) {
                    if (o1.stallId < o2.stallId) {
                        return -1;
                    } else {
                        return 1;
                    }
                } else if (max1 > max2) {
                        return -1;
                } else {
                    return 1;
                }
            } else {
                if (min1 < min2) {
                    return 1;
                } else {
                    return -1;
                }
            }
        }

        public static final Compare COMPARE_HEAP_ENTRIES = new Compare();
    }


    public static ResultTuple bathRoomStalls(String input) {
        ResultTuple resultTuple = new ResultTuple(0,0);

        String[] data = input.split(" ");
        int N = Integer.parseInt(data[0].trim());
        int K = Integer.parseInt(data[1].trim());

        if (N == K) {
            return resultTuple;
        }

        boolean[] stalls = new boolean[N+2];
        stalls[0] = stalls[N+1] = true;

        for (int i = 0; i < K; i++) {
            List<VaccancyTuple> vaccancyTuples = new ArrayList<>();
            int Ls = 0;
            for (int j = 1; j <= N ; j++) {
                if (stalls[j] == false) {
                    int Rs = 0;
                    for (int k = j+1; (k <= N) && (stalls[k] == false) ; k++) {
                        Rs++;
                    }
                    vaccancyTuples.add(new VaccancyTuple(Ls, Rs, j));
                    Ls++;
                } else {
                    Ls = 0;
                }
            }

            Collections.sort(vaccancyTuples, Compare.COMPARE_HEAP_ENTRIES);
            stalls[vaccancyTuples.get(0).stallId] = true;
            if (i == K-1) {
                resultTuple.min = vaccancyTuples.get(0).min;
                resultTuple.max = vaccancyTuples.get(0).max;
            }
        }

        return resultTuple;
    }


    public static void main(String[] args) throws IOException {
        File file = new File("E:\\misc\\google\\code-jam-2017\\Problem-C\\outputCsmall.txt");
        file.createNewFile();
        FileWriter fw = new FileWriter(file.getAbsoluteFile());
        BufferedWriter bw = new BufferedWriter(fw);
        Scanner in = new Scanner(new File("E:\\misc\\google\\code-jam-2017\\Problem-C\\C-small-attempt0.in"));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        in.nextLine(); // skip the rest of the first line
        for (int i = 1; i <= t; ++i) {
            String line = in.nextLine();
            ResultTuple resultTuple = bathRoomStalls(line);
            String output = "Case #" + i + ": " + resultTuple.max + " " + resultTuple.min;
            // System.out.println(output);
            bw.write(output);
            bw.newLine();
        }

        bw.close();
    }
}
