package com.abp.google.codejam2017;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Created by aby on 4/8/2017.
 */
public class ProblemA_small {
    private static boolean isAllHappy(String panCakes) {
        int index =  panCakes.indexOf('-');
        return index == -1;
    }

    private static void buildPatterns(String[] patterns, int k) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < k; i++) {
            sb.append('-');
        }
        patterns[0] = sb.toString();

        for (int i = 1; i <k ; i++) {
            sb.setLength(0);
            for (int j = 0; j <i ; j++) {
                sb.append('-');
            }

            for (int j = 0; j <(k-i) ; j++) {
                sb.append('+');
            }

            for (int j = 0; j < i; j++) {
                sb.append('-');
            }

            patterns[i] = sb.toString();
        }

    }


    private static void flipsPancakes(char[] str, int start, int k) {
        for (int i = start; i < (start+k); i++) {
            str[i] = (str[i] == '+') ? '-' : '+';
        }
    }

    public static int countFlips(String panCakes, int k) {
        int result = 0;

        if (!isAllHappy(panCakes)) {
            String[] patterns = new String[k];
            buildPatterns(patterns, k);

            // First pattern if present - let us flip all over the place
//            System.out.println(Arrays.toString(patterns));
            while (panCakes.contains(patterns[0])) {
                int index = panCakes.indexOf(patterns[0]);
                char[] strCharArray = panCakes.toCharArray();
                flipsPancakes(strCharArray, index, k); // first flip
                panCakes = new String(strCharArray);
                result++;
            }

            for (int i = 1; i < patterns.length; i++) {
                while (panCakes.contains(patterns[i])) {
                    int index = panCakes.indexOf(patterns[i]);
                    char[] strCharArray = panCakes.toCharArray();
                    flipsPancakes(strCharArray, index, k); // first flip
                    flipsPancakes(strCharArray, index+i, k);
                    panCakes = new String(strCharArray);
                    result += 2;
                }
            }
        }

        if (isAllHappy(panCakes)) {
            return result;
        }

        return -1;
    }



    public static void main(String[] args) throws IOException {
        File file = new File("outputA.txt");
        file.createNewFile();
        FileWriter fw = new FileWriter(file.getAbsoluteFile());
        BufferedWriter bw = new BufferedWriter(fw);

//        Scanner in = new Scanner(new File(args[0]));
        Scanner in = new Scanner(new File("A-small-attempt0.in"));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        in.nextLine(); // skip the rest of the first line
        for (int i = 1; i <= t; ++i) {
            String line = in.nextLine();
            String[] data = line.split(" ");
            String panCakes =  data[0];
            int k = Integer.parseInt(data[1].trim());

            int m = countFlips(panCakes, k);
            String output = null;
            if (m != -1) {
                output = "Case #" + i + ": " + m;
            } else {
                output = "Case #" + i + ": IMPOSSIBLE";
            }
            bw.write(output);
            bw.newLine();
//            System.out.println(output);
        }
        bw.close();

    }
}
