package com.abp.google.codejam2017;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by aby on 4/8/2017.
 */
public class ProblemB_Small {
    public static List<Integer> tidyIntegers = new LinkedList<>();

    private static boolean isTidy(int num) {
        int last = num % 10, current;
        num /= 10;
        while (num != 0) {
            current = num % 10;
            if (current > last)
                return false;
            num /= 10;
            last = current;
        }

        return true;
    }

    public static void buildTidyIntegers(int max) {
        for (int i = 0; i < 10; i++) {
            tidyIntegers.add(i);
        }

        for (int i = 11; i < max; i++) {
            if (isTidy(i)) {
                tidyIntegers.add(i);
            }
        }
    }


    public static int getTidyForInteger(int num) {
        int result = 1;

        int lo = 0;
        int hi = tidyIntegers.size()-1;

        while (lo <= hi) {
            int mid = lo + (hi - lo)/2;
            int midValue = tidyIntegers.get(mid);
            if (midValue == num) {
                return num;
            } else if (midValue < num) {
                result = tidyIntegers.get(mid);
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return result;
    }



    public static void main(String[] args) throws IOException {
        File file = new File("outputB.txt");
        file.createNewFile();
        FileWriter fw = new FileWriter(file.getAbsoluteFile());
        BufferedWriter bw = new BufferedWriter(fw);

        buildTidyIntegers(1000);
        Scanner in = new Scanner(new File("B-small-attempt0.in"));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        in.nextLine(); // skip the rest of the first line
        for (int i = 1; i <= t; ++i) {
            int N = in.nextInt();
            String output = "Case #" + i + ": " + getTidyForInteger(N);
            bw.write(output);
            bw.newLine();
        }

        bw.close();
    }
}
