package com.abp.google.codejam2016;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by aby on 4/9/2016.
 */
public class ProblemC_Small {
    public static List<String> generateCandidateCoins() {
        List<String> result = new ArrayList<String>();

        String largestMiddlePattern = "11111111111111";
//        assert largestMiddlePattern.length() == 14;
        int largetstMiddleBitNum = Integer.parseInt(largestMiddlePattern,2);
        for (int i = 0; i <= largetstMiddleBitNum ; i++) {
            String binaryRep = Integer.toBinaryString(i);
            String formatted = null;
            if (binaryRep.length() < 14) {
                formatted = String.format("%0" + (14 - binaryRep.length()) + "d%s", 0, binaryRep);
            } else {
                formatted = binaryRep;
            }
            String coinString = "1" + formatted + "1";
            result.add(coinString);
        }
        return result;
    }

    public static List<Long> testJamCoin(String coinString) {
        List<Long> validDivisors = new ArrayList<Long>();
        for (int i = 2; i < 11; i++) {
            long coinValue = Long.parseLong(coinString, i);
            long smallestDivisor = getSmallestValidDivisor(coinValue);
            if (smallestDivisor == 1)
                break;
            validDivisors.add(smallestDivisor);
        }
        return validDivisors;
    }

    public static long getSmallestValidDivisor(long num) {
        for (long i=2; i <= (long) Math.sqrt((double) num) + 1; ++i) {
            if (num % i == 0) {
                return i;
            }
        }
        return 1;
    }


    public static void main(String[] args) throws IOException {
        File out = new File("outputC_Small.txt");
        out.createNewFile();
        FileWriter fw = new FileWriter(out.getAbsolutePath());
        BufferedWriter bw = new BufferedWriter(fw);
        String output =  "Case #1: ";
        bw.write(output);
        bw.newLine();

        List<String> candidateCoins = generateCandidateCoins();
        int coinCount = 0;
        for (String coin: candidateCoins) {
            List<Long> divisors = testJamCoin(coin);
            if (divisors.size() == 9) {
                StringBuilder sb = new StringBuilder();
                sb.append(coin);
                for (Long divisor: divisors) {
                    sb.append(" ");
                    sb.append(divisor);
                }
                System.out.println(sb.toString());
                bw.write(sb.toString());
                bw.newLine();
                ++coinCount;
                if (coinCount == 50)
                    break;
            }
        }

        bw.close();


    }
}
