import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Writer;
import java.io.FileReader;
import java.io.IOException;
import java.io.FileInputStream;
import java.util.HashSet;
import java.io.StringWriter;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.io.FileNotFoundException;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.File;
import java.util.Set;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "A-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("a.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		TaskA solver = new TaskA();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskA extends ChelperSolution {

    public void solve(int testNumber) {
        int n = in.nextInt();

        if (n == 0) {
            out.println("INSOMNIA");
            return;
        }

        Set<Integer> digits = new HashSet<>();

        int x = 0;
        while (digits.size() < 10) {
            x += n;

            for (char c : Integer.toString(x).toCharArray()) {
                digits.add((int)c);
            }
        }

        out.println(x);


    }
}

abstract class ChelperSolution extends AbstractSolution {
    public String postProcessTestOutput(String output, int testNumber) {
        return String.format("Case #%d: %s", testNumber, output);
    }
}

class InputReader {

	BufferedReader br;
	StringTokenizer in;

	public InputReader(InputStream inputStream) {
		br = new BufferedReader(new InputStreamReader(inputStream));
	}

	boolean hasMoreTokens() {
		while (in == null || !in.hasMoreTokens()) {
			String s = nextLine();
			if (s == null) {
				return false;
			}
			in = new StringTokenizer(s);
		}
		return true;
	}

	public String nextString() {
		return hasMoreTokens() ? in.nextToken() : null;
	}

	public String nextLine() {
		try {
			in = null;
			return br.readLine();
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	public int nextInt() {
		return Integer.parseInt(nextString());
	}

	public String next() {
		return nextString();
	}
}

abstract class AbstractSolution {

    protected InputReader in;
    protected OutputWriter out;

    private OutputWriter fileOut;

    public AbstractSolution() {
        try {
            fileOut = new OutputWriter("last_output.txt");
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    public void solve(int testNumber, InputReader in, OutputWriter out) {
        StringWriter sw = new StringWriter();

        this.in = in;
        this.out = new OutputWriter(sw);

        solve(testNumber);

        String testOutput = postProcessTestOutput(sw.toString(), testNumber);

        out.print(testOutput);
        out.flush();

        fileOut.print(testOutput);
        fileOut.flush();
    }

    abstract public void solve(int testNumber);

    abstract public String postProcessTestOutput(String output, int testNumber);
}

class OutputWriter extends PrintWriter {

	public OutputWriter(String fileName) throws FileNotFoundException {
		super(fileName);
	}

	public OutputWriter(OutputStream outputStream) {
		super(outputStream);
	}

	public OutputWriter(Writer writer) {
		super(writer);
	}

}

