import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.Writer;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.FileReader;
import java.util.Arrays;
import java.util.StringTokenizer;
import java.io.ByteArrayOutputStream;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author abra
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		B solver = new B();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class B extends SavingChelperSolution {

	public void solve() {
		int n = in.nextInt();

		int[] a = in.nextIntArray(n);

		int min = Integer.MAX_VALUE;

		int[] sorted = Arrays.copyOf(a, n);
		Arrays.sort(sorted);

		for (int i = 0; i <= n; i++) {
			int[] x = Arrays.copyOfRange(a, 0, i);
			int[] y = Arrays.copyOfRange(a, i, n);

			int res = count(x, false) + count(y, true);

			min = Math.min(min, res);
		}

		out.println(min);
//
//
//
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if (a[j] == sorted[i]) {
					a[j] = i;
				}
			}
		}
//
		System.out.println(testNumber + " " + Arrays.toString(a));

//
//		int max = sorted[n - 1];
//		int maxi = 0;
//		for (int i = 0; i < n; i++) {
//			if (a[i] == max) {
//				maxi = i;
//			}
//		}
//
//		for (int i = 0; i < n; i++) {
//			int res = 0;
//			int[] b = Arrays.copyOf(a, n);
//
//			int maxPos = maxi;
//
//			while (maxPos > i) {
//				int t = b[maxPos];
//				b[maxPos] = b[maxPos - 1];
//				b[maxPos - 1] = t;
//				maxPos--;
//				res++;
//			}
//			while (maxPos < i) {
//				int t = b[maxPos];
//				b[maxPos] = b[maxPos + 1];
//				b[maxPos + 1] = t;
//				maxPos++;
//				res++;
//			}
//
//			res += count(Arrays.copyOfRange(b, 0, i), false);
//			res += count(Arrays.copyOfRange(b, i + 1, n), true);
//
//			if (res < min) {
//				min = res;
//			}
//		}
//
//		out.println(min);

//		int res = 0;
//
//		int m = n;
//		for (int i = 0; i < m; i++) {
//			int pos = -1;
//
//			for (int j = 0; j < n; j++) {
//				if (a[j] == i) {
//					pos = j;
//				}
//			}
//
//			int left = pos;
//			int right = n - 1 - pos;
//
//			res += Math.min(left, right);
//			List<Integer> allBut = new ArrayList<>();
//
//			for (int j = 0; j < n; j++) {
//				if (a[j] != i) {
//					allBut.add(a[j]);
//				}
//			}
//
//			n--;
//
//			a = new int[n];
//			for (int j = 0; j < n; j++) {
//				a[j] = allBut.get(j);
//			}
//		}
//
//		out.println(res);
	}

	int count(int[] a, boolean reverse) {
		int res = 0;

		for (int i = 0; i < a.length; i++) {
			for (int j = i + 1; j < a.length; j++) {
				if (!reverse) {
					if (a[i] > a[j]) {
						res += 1;
					}
				} else {
					if (a[i] < a[j]) {
						res += 1;
					}
				}
			}
		}

		return res;
	}
}

abstract class SavingChelperSolution {

	protected int testNumber;

	public InputReader in;
	public OutputWriter out;

	private OutputWriter toFile;

	public SavingChelperSolution() {
		try {
			toFile = new OutputWriter("gcj-output.txt");
		} catch (FileNotFoundException e) {
			throw new RuntimeException(e);
		}
	}

	public abstract void solve();

	public void solve(int testNumber, InputReader in, OutputWriter out) {
		this.testNumber = testNumber;

		ByteArrayOutputStream saved = new ByteArrayOutputStream();

		OutputWriter savingOut = new OutputWriter(saved);

		this.in = in;
		this.out = savingOut;

		solve();
		savingOut.flush();

		String result = "Case #" + testNumber + ": " + saved.toString();
		if (!result.endsWith("\n")) {
			result += "\n";
		}

		out.write(result);
		out.flush();
		toFile.write(result);
		toFile.flush();
	}

}

class InputReader {

	BufferedReader br;
	StringTokenizer in;

	public InputReader(String fileName) {
		try {
			br = new BufferedReader(new FileReader(fileName));
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	public InputReader(InputStream inputStream) {
		br = new BufferedReader(new InputStreamReader(inputStream));
	}

	boolean hasMoreTokens() {
		while (in == null || !in.hasMoreTokens()) {
			String s = nextLine();
			if (s == null) {
				return false;
			}
			in = new StringTokenizer(s);
		}
		return true;
	}

	public String nextString() {
		return hasMoreTokens() ? in.nextToken() : null;
	}

	public String nextLine() {
		try {
			in = null; // riad legacy
			return br.readLine();
		} catch (Exception e) {
			e.printStackTrace();
			return null;
		}
	}

	public int nextInt() {
		return Integer.parseInt(nextString());
	}

	public int[] nextIntArray(int n) {
		int[] a = new int[n];
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
		}
		return a;
	}

	public String next() {
		return nextString();
	}
}

class OutputWriter extends PrintWriter {

	public OutputWriter(String fileName) throws FileNotFoundException {
		super(fileName);
	}

	public OutputWriter(OutputStream outputStream) {
		super(outputStream);
	}

	public OutputWriter(Writer writer) {
		super(writer);
	}

}

