import java.io.*;
import java.util.*;
import java.math.*;

// 5/26/12 7:32 PM
// by Abrackadabra

public class MountainView {
    public static void main(String[] args) throws IOException {
        if (args.length > 0 && args[0].equals("Abra")) debugMode = true;
        new MountainView().run();
        /*new Thread(null, new Runnable() {
            public void run() {
                try {
                    new MountainView().run();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }, "1", 1 << 24).start();*/
    }

    int IOMode = 0; //0 - consoleIO, 1 - <taskName>.in/out, 2 - input.txt/output.txt, 3 - test case generator
    String taskName = "";
    boolean testBasedProblem = true;

    int highest(int i, int[] x) {
        int res = -1;
        double max = -1;
        for (int j = i + 1; j < x.length; j++) {
            if ((x[j] - x[i] + 1d) / (j - i) > max) {
                max = (x[j] - x[i] + 1d) / (j - i);
                res = j;
            }
        }
        return res;
    }

    Random random = new Random();

    int[] solveRandom(int[] h, double time) {
        long startTime = System.nanoTime();
        int[] x = new int[h.length + 1];
        while (System.nanoTime() - startTime <= time) {
            for (int i = 0; i < h.length + 1; i++) {
                x[i] = random.nextInt(1000000);
            }
            boolean ok = true;
            for (int i = 0; i < h.length && ok; i++) {
                ok &= highest(i, x) == h[i];
            }
            if (ok) break;
        }
        if (System.nanoTime() - startTime > time) {
            return null;
        }
        return x;
    }

    int[] solveInc(int[] h, double time) {
        long startTime = System.nanoTime();
        int n = h.length + 1;
        int[] x = new int[n];
        Arrays.fill(x, 1);
        while (true) {
            boolean ok = true;
            for (int i = 0; i < n - 1 && ok; i++) {
                while (highest(i, x) != h[i]) {
                    if (System.nanoTime() - startTime > time) {
                        i = n;
                        break;
                    }
                    ok = false;
                    x[h[i]]++;
                }
            }
            if (System.nanoTime() - startTime > time) {
                break;
            }
            if (ok) break;
        }
        if (System.nanoTime() - startTime > time) {
            return null;
        }
        return x;
    }

    int[] solveDec(int[] h, double time) {
        long startTime = System.nanoTime();
        int n = h.length + 1;
        int[] x = new int[n];
        Arrays.fill(x, 500000);
        while (true) {
            boolean ok = true;
            for (int i = n - 2; i >= 0 && ok; i--) {
                while (highest(i, x) != h[i]) {
                    if (System.nanoTime() - startTime > time) {
                        i = n;
                        break;
                    }
                    ok = false;
                    for (int j = 0; j < h[i]; j++)
                        x[j]--;
                }
            }
            if (System.nanoTime() - startTime > time) {
                break;
            }
            if (ok) break;
        }
        if (System.nanoTime() - startTime > time) {
            return null;
        }
        return x;
    }

    void solve() throws IOException {
        int n = nextInt();
        int[] h = new int[n - 1];
        for (int i = 0; i < n - 1; i++) {
            h[i] = nextInt() - 1;
        }
        int[] x = solveRandom(h, 4e9);
        if (x == null)
            x = solveDec(h, 1e9);
        if (x == null)
            x = solveInc(h, 1e9);
        con.print("Case #" + testIndex + ": ");
        out.print("Case #" + testIndex + ": ");
        if (x == null) {
            con.println("Impossible");
            out.println("Impossible");
        } else {
            for (int i : x) {
                con.print(i + " ");
                out.print(i + " ");
            }
            con.println();
            out.println();
        }
    }

    long startTime = System.nanoTime(), tempTime = startTime, finishTime = startTime;
    long startMem = Runtime.getRuntime().totalMemory(), finishMem = startMem;
    int testIndex;

    void run() throws IOException {
        init();
        if (debugMode) {
            con.println("Start");
            con.println("Console:");
        }

        int tests = testBasedProblem ? nextInt() : 1;
        for (testIndex = 1; testIndex <= tests; testIndex++)
            solve();

        finishTime = System.nanoTime();
        finishMem = Runtime.getRuntime().totalMemory();
        out.flush();
        if (debugMode) {
            int maxSymbols = 1000;
            BufferedReader tbr = new BufferedReader(new FileReader("input.txt"));
            char[] a = new char[maxSymbols];
            tbr.read(a);
            if (a[0] != 0) {
                con.println("File input:");
                con.println(a);
                if (a[maxSymbols - 1] != 0) con.println("...");
            }
            tbr = new BufferedReader(new FileReader("output.txt"));
            a = new char[maxSymbols];
            tbr.read(a);
            if (a[0] != 0) {
                con.println("File output:");
                con.println(a);
                if (a[maxSymbols - 1] != 0) con.println("...");
            }
            con.println("Execution time: " + (finishTime - startTime) / 1000000000.0 + " sec");
            con.println("Used memory:    " + (finishMem - startMem) + " bytes");
            con.println("Total memory:   " + Runtime.getRuntime().totalMemory() + " bytes");
        }
    }

    boolean tick(double x) {
        if (System.nanoTime() - tempTime > x * 1e9) {
            tempTime = System.nanoTime();
            con.println("Tick at " + (tempTime - startTime) / 1000000000 + " sec");
            con.print("   ");
            return true;
        }
        return false;
    }

    static boolean debugMode = false;
    PrintStream con = System.out;

    void init() throws IOException {
        if (debugMode && IOMode != 3) {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter(new FileWriter("output.txt"));
        } else
            switch (IOMode) {
                case 0:
                    br = new BufferedReader(new InputStreamReader(System.in));
                    out = new PrintWriter(System.out);
                    break;
                case 1:
                    br = new BufferedReader(new FileReader(taskName + ".in"));
                    out = new PrintWriter(new FileWriter(taskName + ".out"));
                    break;
                case 2:
                    br = new BufferedReader(new FileReader("input.txt"));
                    out = new PrintWriter(new FileWriter("output.txt"));
                    break;
                case 3:
                    out = new PrintWriter(new FileWriter("input.txt"));
                    break;
            }
        if (!debugMode)
            con = new PrintStream(new OutputStream() {
                public void write(int b) throws IOException {
                } // to /dev/null
            });
        if ((IOMode == 1 && taskName.length() == 0) || (IOMode != 1 && taskName.length() != 0)) {
            System.err.println("Leha, check IO settings");
            System.err.flush();
            System.exit(0);
        }
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer in;

    boolean hasMoreTokens() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            String line = br.readLine();
            if (line == null) return false;
            in = new StringTokenizer(line);
        }
        return true;
    }

    String nextString() throws IOException {
        return hasMoreTokens() ? in.nextToken() : null;
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextString());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextString());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextString());
    }
}