import java.io.*;
import java.util.*;
import java.math.*;

// 6/9/12 6:17 PM
// by Abrackadabra

public class Havannah {
    public static void main(String[] args) throws IOException {
        if (args.length > 0 && args[0].equals("Abra")) debugMode = true;
        new Havannah().run();
        /*new Thread(null, new Runnable() {
            public void run() {
                try {
                    new Havannah().run();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }, "1", 1 << 24).start();*/
    }

    int IOMode = 0; //0 - consoleIO, 1 - <taskName>.in/out, 2 - input.txt/output.txt, 3 - test case generator
    String taskName = "";
    boolean testBasedProblem = true;

    int s, n, m;
    int[][] moves;

    void solve() throws IOException {
        s = nextInt();
        n = 2 * s - 1;
        m = nextInt();
        moves = new int[m][2];
        for (int i = 0; i < m; i++) {
            moves[i][0] = nextInt() - 1;
            moves[i][1] = nextInt() - 1;
        }

        //out.println(solve1());
        out.println(solve2());
    }

    String solve1() throws IOException {
        int[][] colors = new int[n][n];

        int freeColor = 1;
        HashMap<Integer, ArrayList<Integer>> map = new HashMap<Integer, ArrayList<Integer>>();
        HashMap<Integer, Integer> edges = new HashMap<Integer, Integer>();
        HashMap<Integer, Integer> corners = new HashMap<Integer, Integer>();

        boolean ring = false;
        boolean bridge = false;
        boolean fork = false;
        int move = -1;

        for (int i = 0; i < m; i++) {
            int x = moves[i][0], y = moves[i][1];

            int[] colorsAround = new int[6];
            HashSet<Integer> toUnite = new HashSet<Integer>();
            int invalid = 0;
            for (int dir = 0; dir < 6; dir++) {
                int xx = x + dirs[dir][0];
                int yy = y + dirs[dir][1];
                if (!isValid(xx, yy)) {
                    invalid++;
                    continue;
                }
                colorsAround[dir] = colors[xx][yy];
                if (colors[xx][yy] != 0) toUnite.add(colors[xx][yy]);
            }

            if (toUnite.size() == 0) {
                colors[x][y] = freeColor;

                map.put(freeColor, new ArrayList<Integer>());
                map.get(freeColor).add(x * n + y);
                edges.put(freeColor, 0);
                corners.put(freeColor, 0);

                if (invalid == 2) edges.put(freeColor, 1);
                if (invalid == 3) corners.put(freeColor, 1);

                freeColor++;
                continue;
            }

            boolean finish = false;

            int biggestColor = -1;
            int maxPopulation = -1;

            for (int c : toUnite) {
                if (map.get(c).size() > maxPopulation) {
                    maxPopulation = map.get(c).size();
                    biggestColor = c;
                }
            }

            colors[x][y] = biggestColor;

            map.get(biggestColor).add(x * n + y);

            if (invalid == 2) edges.put(biggestColor, edges.get(biggestColor) + 1);
            if (invalid == 3) corners.put(biggestColor, corners.get(biggestColor) + 1);

            for (int c : toUnite) {
                if (c != biggestColor) {
                    for (int t : map.get(c)) {
                        colors[t / n][t % n] = biggestColor;
                        map.get(biggestColor).add(t);
                    }

                    edges.put(biggestColor, edges.get(biggestColor) + edges.get(c));
                    corners.put(biggestColor, corners.get(biggestColor) + corners.get(c));
                }
            }

            if (edges.get(biggestColor) >= 3) {
                fork = true;
                finish = true;
                move = i + 1;
            }

            if (corners.get(biggestColor) >= 2) {
                bridge = true;
                finish = true;
                move = i + 1;
            }

            if (isRingy(colorsAround)) {
                ring = true;
                finish = true;
                move = i + 1;
            }

            if (finish) break;
        }

        String res = "Case #" + testIndex + ": ";

        if (move == -1) {
            res += "none";
            return res;
        }

        if (bridge) res += "bridge";
        if (fork) {
            if (bridge) res += "-";
            res += "fork";
        }
        if (ring) {
            if (bridge || fork) res += "-";
            res += "ring";
        }

        res += " in move " + move;
        return res;
    }

    String solve2() throws IOException {
        boolean[][] occupied = new boolean[n][n];
        boolean bridge = false;
        boolean fork = false;
        boolean ring = false;
        int move = -1;
        for (int i = 0; i < m; i++) {
            occupied[moves[i][0]][moves[i][1]] = true;

            boolean[][] visited = new boolean[n][n];
            boolean finish = false;
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < n; y++) {
                    if (isValid(x, y) && !visited[x][y]) {
                        if (occupied[x][y]) {
                            int corners = 0, edges = 0;
                            Queue<Integer> queue = new LinkedList<Integer>();
                            queue.add(x * n + y);
                            visited[x][y] = true;
                            while (!queue.isEmpty()) {
                                int t = queue.poll();
                                int xx = t / n;
                                int yy = t % n;
                                int invalid = 0;
                                for (int[] dir : dirs) {
                                    int xxx = xx + dir[0];
                                    int yyy = yy + dir[1];
                                    if (!isValid(xxx, yyy)) {
                                        invalid++;
                                        continue;
                                    }
                                    if (visited[xxx][yyy]) continue;
                                    if (occupied[xxx][yyy]) {
                                        queue.add(xxx * n + yyy);
                                        visited[xxx][yyy] = true;
                                    }
                                }
                                if (invalid == 2) edges++;
                                if (invalid == 3) corners++;
                            }
                            if (edges >= 3) {
                                finish = true;
                                fork = true;
                                move = i + 1;
                            }
                            if (corners >= 2) {
                                finish = true;
                                bridge = true;
                                move = i + 1;
                            }
                        } else {
                            boolean ok = true;
                            Queue<Integer> queue = new LinkedList<Integer>();
                            queue.add(x * n + y);
                            visited[x][y] = true;
                            while (!queue.isEmpty()) {
                                int t = queue.poll();
                                int xx = t / n;
                                int yy = t % n;
                                int invalid = 0;
                                for (int[] dir : dirs) {
                                    int xxx = xx + dir[0];
                                    int yyy = yy + dir[1];
                                    if (!isValid(xxx, yyy)) {
                                        invalid++;
                                        continue;
                                    }
                                    if (visited[xxx][yyy]) continue;
                                    if (!occupied[xxx][yyy]) {
                                        queue.add(xxx * n + yyy);
                                        visited[xxx][yyy] = true;
                                    }
                                }
                                if (invalid > 0) ok = false;
                            }
                            if (ok) {
                                finish = true;
                                ring = true;
                                move = i + 1;
                            }
                        }
                    }
                }
            }
            if (finish) break;
        }
        String res = "Case #" + testIndex + ": ";

        if (move == -1) {
            res += "none";
            return res;
        }

        if (bridge) res += "bridge";
        if (fork) {
            if (bridge) res += "-";
            res += "fork";
        }
        if (ring) {
            if (bridge || fork) res += "-";
            res += "ring";
        }

        res += " in move " + move;
        return res;
    }

    boolean isValid(int x, int y) {
        return !(x < 0 || y < 0 || x >= n || y >= n || Math.abs(x - y) >= s);
    }

    boolean isRingy(int[] a) {
        HashMap<Integer, Integer> components = new HashMap<Integer, Integer>();
        int n = a.length;
        for (int i = 0; i < n; i++) {
            if (a[i] > 0) {
                int color = a[i];

                if (!components.containsKey(color))
                    components.put(color, 0);
                components.put(color, components.get(color) + 1);

                int r = (i + 1) % n;
                while (a[r] == color) {
                    a[r] = 0;
                    r = (r + 1) % n;
                }
                int l = i;
                while (a[l] == color) {
                    a[l] = 0;
                    l = (l - 1 + n) % n;
                }
            }
        }
        boolean ringy = false;
        for (int i : components.values())
            if (i > 1) ringy = true;
        return ringy;
    }

    int[][] dirs = {
            {1, 1},
            {0, 1},
            {-1, 0},
            {-1, -1},
            {0, -1},
            {1, 0}
    };

    long startTime = System.nanoTime(), tempTime = startTime, finishTime = startTime;
    long startMem = Runtime.getRuntime().totalMemory(), finishMem = startMem;
    int testIndex;

    void run() throws IOException {
        init();
        if (debugMode) {
            con.println("Start");
            con.println("Console:");
        }

        int tests = testBasedProblem ? nextInt() : 1;
        for (testIndex = 1; testIndex <= tests; testIndex++)
            solve();

        finishTime = System.nanoTime();
        finishMem = Runtime.getRuntime().totalMemory();
        out.flush();
        if (debugMode) {
            int maxSymbols = 1000;
            BufferedReader tbr = new BufferedReader(new FileReader("input.txt"));
            char[] a = new char[maxSymbols];
            tbr.read(a);
            if (a[0] != 0) {
                con.println("File input:");
                con.println(a);
                if (a[maxSymbols - 1] != 0) con.println("...");
            }
            tbr = new BufferedReader(new FileReader("output.txt"));
            a = new char[maxSymbols];
            tbr.read(a);
            if (a[0] != 0) {
                con.println("File output:");
                con.println(a);
                if (a[maxSymbols - 1] != 0) con.println("...");
            }
            con.println("Execution time: " + (finishTime - startTime) / 1000000000.0 + " sec");
            con.println("Used memory:    " + (finishMem - startMem) + " bytes");
            con.println("Total memory:   " + Runtime.getRuntime().totalMemory() + " bytes");
        }
    }

    boolean tick(double x) {
        if (System.nanoTime() - tempTime > x * 1e9) {
            tempTime = System.nanoTime();
            con.println("Tick at " + (tempTime - startTime) / 1000000000 + " sec");
            con.print("   ");
            return true;
        }
        return false;
    }

    static boolean debugMode = false;
    PrintStream con = System.out;

    void init() throws IOException {
        if (debugMode && IOMode != 3) {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter(new FileWriter("output.txt"));
        } else
            switch (IOMode) {
                case 0:
                    br = new BufferedReader(new InputStreamReader(System.in));
                    out = new PrintWriter(System.out);
                    break;
                case 1:
                    br = new BufferedReader(new FileReader(taskName + ".in"));
                    out = new PrintWriter(new FileWriter(taskName + ".out"));
                    break;
                case 2:
                    br = new BufferedReader(new FileReader("input.txt"));
                    out = new PrintWriter(new FileWriter("output.txt"));
                    break;
                case 3:
                    out = new PrintWriter(new FileWriter("input.txt"));
                    break;
            }
        if (!debugMode)
            con = new PrintStream(new OutputStream() {
                public void write(int b) throws IOException {
                } // to /dev/null
            });
        if ((IOMode == 1 && taskName.length() == 0) || (IOMode != 1 && taskName.length() != 0)) {
            System.err.println("Leha, check IO settings");
            System.err.flush();
            System.exit(0);
        }
    }

    BufferedReader br;
    PrintWriter out;
    StringTokenizer in;

    boolean hasMoreTokens() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            String line = br.readLine();
            if (line == null) return false;
            in = new StringTokenizer(line);
        }
        return true;
    }

    String nextString() throws IOException {
        return hasMoreTokens() ? in.nextToken() : null;
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextString());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextString());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextString());
    }
}