import java.io.*;
import java.util.*;
import java.math.*;

public class CandySplitting {
	int sum(int a, int b) {
		return (a | b) - (a & b);
	}
	
	void solve() throws IOException {
		int T = nextInt();
		for (int Ti = 0; Ti < T; Ti++) {
			out.print("Case #" + (Ti + 1) + ": ");
			
			int n = nextInt();
			int[] a = new int[n];
			int s = 0;
			for (int i = 0; i < n; i++) {
				a[i] = nextInt();
				s += a[i];
			}
			HashSet<TreeSet<Integer>> ts = new HashSet<TreeSet<Integer>>();
			ts.add(new TreeSet<Integer>());
			for (int i = 0; i < n; i++) {
				HashSet<TreeSet<Integer>> t = new HashSet<TreeSet<Integer>>();
				for (TreeSet<Integer> tq : ts) {
					TreeSet<Integer> t1 = (TreeSet<Integer>) tq.clone();
					TreeSet<Integer> t2 = (TreeSet<Integer>) tq.clone();
					t1.add(a[i]);
					t2.add(-a[i]);
					t.add(t1);
					t.add(t2);
				}
				ts = t;
			}
			int m = -1;
			for (TreeSet<Integer> tq : ts) {
				int q = 0, w = 0, su = 0;
				for (Integer t : tq) {
					if (t < 0) w = sum(w, -t); else {
						q = sum(q, t);
						su += t;
					}
				}
				if (q == w && q != 0) m = Math.max(su, m);
			}
			if (m == -1) out.println("NO"); else out.println(m);
		}
	}

	public static void main(String[] args) throws IOException {
		new CandySplitting().run();
	}

	StreamTokenizer in;
	PrintWriter out;
	BufferedReader br;

	void init() throws IOException {
		Reader reader = new FileReader("C-small.in");
		Writer writer = new FileWriter("C-small.out");
		br = new BufferedReader(reader);
		in = new StreamTokenizer(br);
		out = new PrintWriter(writer);
	}

	void run() throws IOException {
		init();
		solve();
		out.flush();
	}

	int nextInt() throws IOException {
		in.nextToken();
		return (int) in.nval;
	}

	long nextLong() throws IOException {
		in.nextToken();
		return (long) in.nval;
	}

	String nextString() throws IOException {
		in.nextToken();
		return in.sval;
	}

	double nextDouble() throws IOException {
		in.nextToken();
		return in.nval;
	}
}
