import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.BitSet;
import java.util.Scanner;

public class A {

	static boolean DEBUG = false;
	static int T;
	static int N;
	
	static Order[] sequence;
	
	public static void main(String[] args) throws IOException {
		Scanner scan = new Scanner(new FileReader("A-small-attempt0.in"));
		BufferedWriter out = new BufferedWriter(new FileWriter("A_small.out"));
		int T = scan.nextInt();
		for (int t=0; t<T; t++) {
			N = scan.nextInt();;
			
			sequence = new Order[N];
			
			for (int i=0; i<N; i++) {
				String robot = scan.next();
				int pos = scan.nextInt();
				
				sequence[i] = new Order(robot.charAt(0)=='O'?0:1, pos);
				
			}
			
			int result = solve();
			out.write("Case #"+(t+1)+": "+ result + "\n");
			print("Case #"+(t+1)+": "+ result+"\n\n\n");
		}
		
		out.flush();
	}
	
	public static int solve() {
		int time = 1;
		State orange = new State("Orange");
		State blue = new State("Blue");
		for (int i=0; i<sequence.length; i++) {
			Order order = sequence[i];
			State current_robot = null;
			if (order.robot == 0) {	// orange
				current_robot = orange;
				orange.updateAction(order.pos);
				orange.has_priority = true;
				blue.has_priority = false;
				
				Order order_blue = getNextMove(i, 1);
				if (order_blue != null) {
					blue.updateAction(order_blue.pos);
				}
			}
			if (order.robot == 1) {	// blue
				current_robot = blue;
				blue.updateAction(order.pos);
				blue.has_priority = true;
				orange.has_priority = false;
				
				Order order_orange = getNextMove(i, 0);
				if (order_orange != null) {
					orange.updateAction(order_orange.pos);
				}
			}
			
			while (current_robot.action != null) {
				print("---Time "+time);
				orange.doAction();
				blue.doAction();
				time++;
				print("");
			}
		}
		return --time;
	}
	
	public static Order getNextMove(int i, int robot) {
		for (int j=i; j<sequence.length; j++) {
			if (sequence[j].robot == robot)
				return sequence[j];
		}
		return null;
	}
	
	static private class Order {
		int robot;
		int pos;
		private Order(int robot, int pos) {
			this.robot = robot;
			this.pos = pos;
		}
	}
	
	static private class State {
		String name;
		String action;
		int direction;
		int pos = 1;
		int button_pos;
		boolean has_priority = false;
		
		public State(String name) {
			this.name = name;
		}
		
		private void updateAction(int button_pos) {
			this.button_pos = button_pos;
			if (button_pos == pos) {
				action = "push";
			}
			else {
				action = "move";
				if (pos < button_pos)
					direction = 1;
				else
					direction = -1;
			}
		}
		
		private void doAction() {
			if (action == "push") {
				if (has_priority) {
					print("@"+name+": pushing button "+pos);
					action = null;
				}
				else
					print("@"+name+": staying at button "+pos);
			}
			if (action == "move") {
				pos += direction;
				print("@"+name+": move to button "+pos);
				updateAction(button_pos);
			}
		}
	}
	
	static void print(String s) {
		if (DEBUG)
			System.out.println(s);
	}

}
