import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;


public class A {

	static int N;
	static Player[] players;
	public static void main(String[] args) throws IOException {
		Scanner scan = new Scanner(new BufferedReader( new FileReader("A-large(1).in")));
		BufferedWriter out = new BufferedWriter(new FileWriter("out.txt"));
		int T = scan.nextInt();
		for (int i = 1; i <= T; i++) {
			N = scan.nextInt();
			players = new Player[N];

			for (int j=0; j<N; j++) {
				String line = scan.next();
				players[j] = new Player(j);
				players[j].addRecord(line);

			}

			for (int j=0; j<N; j++) {
				players[j].updateOWP();
			}

			out.write("Case #"+i+":");
			out.newLine();
			for (int j=0; j<N; j++) {
				out.write( Double.toString(0.25*players[j].WP + 0.5*players[j].OWP + 0.25*players[j].OOWP()) );
				if (j+1 < N)
					out.newLine();
			}
			if (i+1 <= T)
				out.newLine();
		}
		out.flush();
	}



	static private class Player {
		int[] records;
		int i;
		int wins;

		int games;
		double WP;
		double OWP;

		private Player(int i) {
			this.i = i;
			records = new int[N];
			WP = 0;
			OWP = 0;
			games = 0;
		}

		private void addRecord(String line) {
			for (int k=0; k<N; k++) {
				int isWin = line.charAt(k) - '0';
				if (isWin != -2) {
					games++;
					wins += isWin;
				}
				records[k] = isWin;
			}
			WP = (double)wins/games;
			//System.out.println("WP of "+i+": "+WP);
		}

		private void updateOWP() {
			int plays = 0;
			for (int k=0; k<N; k++) {
				if (k == i || players[k].records[i] == -2)
					continue;

				OWP += (double)(players[k].wins-players[k].records[i]) / (players[k].games-1);
				plays++;
			}
			OWP /= plays;
			//System.out.println("OWP of "+i+": "+OWP);
		}

		private double OOWP() {
			double OOWP = 0;
			int plays = 0;
			for (int k=0; k<N; k++) {
				if (k == i || players[k].records[i] == -2)
					continue;
				OOWP += players[k].OWP;
				plays++;
			}
			//System.out.println("OOWP of "+i+": "+OOWP/(N-1));
			return OOWP/plays;
		}
	}
}
