import java.util.Scanner;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Collections;

public class Goro
{
  public static void main(String... args)
  {
    Scanner sc = new Scanner(System.in);

    int tests = sc.nextInt();
    for (int test = 1; test <= tests; test++)
    {
      int n = sc.nextInt();
      int[] list = new int[n];
      for (int i = 0; i < n; i++)
      {
        list[i] = sc.nextInt();
      }

      double result = process(list);
      System.out.println("Case #" + test + ": " + result);
    }
  }

  public static double process(int[] list)
  {
    int[] sorted = sort(list);
    double average = 0;
    Map<Integer, Integer> targets = findTargetPositions(sorted);

    while (true)
    {
      int firstIndex = findFirstMove(list, sorted);
      if (firstIndex == -1)
      {
        break;
      }
      int swapWith = targets.get(list[firstIndex]);
      int otherSwap = targets.get(list[swapWith]);
      if (swapWith == targets.get(list[otherSwap]))
      {
        swap(list, swapWith, otherSwap);
        average += 2;
        continue;
      }
      swap(list, firstIndex, swapWith);
      average += 2;
    }

    return average;
  }

  public static int findFirstMove(int[] list, int[] sorted)
  {
    for (int i = 0; i < list.length; i++)
    {
      if (list[i] != sorted[i])
      {
        return i;
      }
    }
    return -1;
  }

  public static Map<Integer, Integer> findTargetPositions(int[] sorted)
  {
    Map<Integer, Integer> map = new HashMap<Integer, Integer>();
    for (int i = 0; i < sorted.length; i++)
    {
      map.put(sorted[i], i);
    }
    return map;
  }

  public static void swap(int[] list, int posa, int posb)
  {
    int temp = list[posa];
    list[posa] = list[posb];
    list[posb] = temp;
  }

  public static int[] sort(int[] list)
  {
    List<Integer> l = new ArrayList<Integer>(list.length);
    for (int i = 0; i < list.length; i++)
    {
      l.add(list[i]);
    }
    Collections.sort(l);
    int[] result = new int[list.length];
    for (int i = 0; i < list.length; i++)
    {
      result[i] = l.get(i);
    }
    return result;
  }
}

