import java.util.Scanner;
import java.util.LinkedList;
import java.util.Deque;

public class ThemePark
{
  public static void main(String[] args)
  {
    Scanner s = new Scanner(System.in);
    int t = s.nextInt();

    for (int i = 1; i <= t; i++)
    {
      int r = s.nextInt();
      int k = s.nextInt();
      int n = s.nextInt();

      Deque<Integer> groups = new LinkedList<Integer>();
      for (int j = 0; j < n; j++)
      {
        groups.offerLast(s.nextInt());
      }

      long euros = calculate(r, k, groups);
      System.out.println("Case #" + i + ": " + euros);
    }

  }

  public static long calculate(int runs, int capacity, Deque<Integer> groups)
  {
    long euros = 0;
    for (int i = 0; i < runs; i++)
    {
      int passengers = 0;
      int numGroups = 0;
      while (passengers + groups.peekFirst() <= capacity &&
             numGroups < groups.size())
      {
        int g = groups.removeFirst();
        passengers += g;
        groups.offerLast(g);
        numGroups++;
      }
      euros += passengers;
    }
    return euros;
  }
}

