import java.util.Scanner;

public class Robots
{
  public static void main(String... args)
  {
    Scanner sc = new Scanner(System.in);

    int tests = sc.nextInt();

    for (int test = 1; test <= tests; test++)
    {
      int n = sc.nextInt();
      boolean[] colours = new boolean[n];
      int[] numbers = new int[n];
      for (int i = 0; i < n; i++)
      {
        String colour = sc.next();
        colours[i] = colour.equals("O");
        numbers[i] = sc.nextInt();
      }
      int result = process(colours, numbers);
      System.out.println("Case #" + test + ": " + result);
    }
  }

  public static int process(boolean[] colours, int[] numbers)
  {
    int posA = 1;
    int posB = 1;

    int totalSteps = 0;

    for (int i = 0; i < colours.length; i++)
    {
      if (colours[i])
      {
        // A has the next press
        int targetA = numbers[i];
        int targetB = findNextTarget(false, i, colours, numbers);
        int steps = Math.abs(targetA - posA) + 1; // add 1 to account for the button press
        posA = targetA;
        int distB = targetB - posB;
        distB = Math.max(-steps, Math.min(distB, steps));
        posB += distB;

        totalSteps += steps;
      }
      else
      {
        // B has the next press
        int targetB = numbers[i];
        int targetA = findNextTarget(true, i, colours, numbers);
        int steps = Math.abs(targetB - posB) + 1; // add 1 to account for the button press
        posB = targetB;
        int distA = targetA - posA;
        distA = Math.max(-steps, Math.min(distA, steps));
        posA += distA;

        totalSteps += steps;
      }
    }
    
    return totalSteps;
  }

  public static int findNextTarget(boolean colour, int start, boolean[] colours, int[] numbers)
  {
    for (int i = start + 1; i < colours.length; i++)
    {
      if (colours[i] == colour)
      {
        return numbers[i];
      }
    }
    return -1;
  }

}
