import java.util.Scanner;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

public class Magicka
{
  public static void main(String... args)
  {
    Scanner sc = new Scanner(System.in);

    int tests = sc.nextInt();
    for (int test = 1; test <= tests; test++)
    {
      int c = sc.nextInt();
      Map<String, Character> combinations = new HashMap<String, Character>();
      for (int i = 0; i < c; i++)
      {
        String str = sc.next();
        char first = str.charAt(0);
        char second = str.charAt(1);
        char third = str.charAt(2);
        combinations.put(first < second ? "" + first + second : "" + second + first, third);
      }

      int d = sc.nextInt();
      Set<String> deletions = new HashSet<String>();
      for (int i = 0; i < d; i++)
      {
        String str = sc.next();
        char first = str.charAt(0);
        char second = str.charAt(1);
        deletions.add(first < second ? "" + first + second : "" + second + first);
      }

      int n = sc.nextInt();
      String invokations = sc.next();
      String result = process(combinations, deletions, invokations.toCharArray());
      char[] resultChars = result.toCharArray();
      System.out.print("Case #" + test + ": [");
      for (int i = 0; i < resultChars.length; i++)
      {
        System.out.print(resultChars[i]);
        if (i != resultChars.length - 1)
        {
          System.out.print(", ");
        }
      }
      System.out.println("]");

    }
  }

  public static String process(Map<String, Character> combinations, Set<String> deletions, char[] invokations)
  {
    StringBuffer buffer = new StringBuffer();
    for (char c : invokations)
    {
      buffer.append(c);
      int len = buffer.length();
      if (len < 2)
      {
        continue;
      }
      char first = buffer.charAt(len - 2);
      char second = buffer.charAt(len - 1);
      Character replacement = combinations.get(first < second ? "" + first + second : "" + second + first);
      if (replacement != null)
      {
        buffer.replace(len - 2, len, "" + replacement);
        continue;
      }
      for (int i = 0; i < len - 1; i++)
      {
        char other = buffer.charAt(i);
        if (deletions.contains(c < other ? "" + c + other : "" + other + c))
        {
          buffer.delete(0, len);
          break;
        }
      }
    }
    return buffer.toString();
  }
}
