import java.util.*;
import java.io.*;

public class BotTrust
{
	int N;
	Pair[] seq;
	Vector<Pair> aseq;
	Vector<Pair> bseq;
	public BotTrust() throws Exception
	{
		Scanner sc = new Scanner(new File("A.in"));
		PrintWriter out = new PrintWriter(new FileWriter("A.out"));
		
		int T = sc.nextInt();
		for(int t = 1; t <= T; t++)
		{
			N = sc.nextInt();
			seq = new Pair[N];
			aseq = new Vector<Pair>();
			bseq = new Vector<Pair>();
			
			for(int i = 0; i < N; i++)
			{
				seq[i] = new Pair(sc.next(), sc.nextInt());
				if(seq[i].robot == 'O')
					aseq.add(seq[i]);
				else
					bseq.add(seq[i]);
			}
			
			int nextButton = 0;
			int anext = 0, bnext = 0;
			
			int ca = 1, cb = 1, time = 0;
			while(nextButton < N)
			{
				int da = getDest(ca, aseq, anext), db = getDest(cb, bseq, bnext);
				
				if(ca != da && cb != db)
				{
					// Neither one at dest, move closest to destination.
					int dist = Math.min(Math.abs(da-ca), Math.abs(db-cb));
					ca += dist*signum(da-ca);
					cb += dist*signum(db-cb);
					time += dist;
				}
				else if(ca == da && cb != db)
				{
					// Orange button: orange pushes, blue moves.
					// Blue button: orange does nothing, blue moves.
					if(seq[nextButton].robot == 'O')
					{
						nextButton++;
						anext++;	
					}
					
					// Blue moves towards destination in either case.
					cb += signum(db-cb);
					
					time++;
				}
				else if(ca != da && cb == db)
				{
					// Blue button, blue pushes, orange moves.
					// Orange button: blue does nothing, orange moves.
					if(seq[nextButton].robot == 'B')
					{
						nextButton++;
						bnext++;
					}
					
					// Orange moves in either case.
					ca += signum(da-ca);
					
					time++;
				}
				else
				{
					// Both at destination.
					
					// Orange button.
					if(seq[nextButton].robot == 'O')
					{
						nextButton++;
						anext++;
					}
					else // Blue button
					{
						nextButton++;
						bnext++;
					}
					
					time++;
				}
			}
			
			
			
			out.printf("Case #%d: %d\n", t, time);
		}
		
		out.close();
	}
	
	int signum(int x) { return x == 0 ? 0 : (x > 0 ? 1 : -1); }
	
	int getDest(int pos, Vector<Pair> list, int next)
	{
		if(next == list.size()) return pos;
		return list.get(next).button;
	}
	
	class Pair
	{
		char robot;
		int button;
		public Pair(String s, int b) { robot = s.charAt(0); button = b; }
	}

	
	public static void main(String[] args) throws Exception
	{
		new BotTrust();
	}

}
