import java.util.*;
import java.io.*;

public class RPI
{

	public RPI() throws Exception
	{
		Scanner sc = new Scanner(new File("A.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("A.out")));
		
		int T = sc.nextInt();
		for(int t = 1; t <= T; t++)
		{
			input(sc);
			process();
			
			
			out.printf("Case #%d:\n", t);
			for(int i = 0; i < N; i++)
				out.printf("%.9f\n", rpi[i]);
			System.err.printf("Case %d complete\n", t);
		}
		
		out.close();
	}
	
	int[][] won;
	int[][] played;
	int N;
	int[] total, winTotal;
	
	void input(Scanner sc) throws Exception
	{
		N = sc.nextInt();
		
		won = new int[N][N];
		played = new int[N][N];
		total = new int[N];
		winTotal = new int[N];
		
		for(int i = 0; i < N; i++)
		{
			String line = sc.next();
			for(int j = 0; j < N; j++)
			{
				char ch = line.charAt(j);
				if(ch != '.')
				{
					played[i][j] = 1;
					won[i][j] = (int)(ch - '0');
				}		
			}
		}

		
		for(int i = 0; i < N; i++)
			for(int j = 0; j < N; j++)
			{
				total[i] += played[i][j];
				winTotal[i] += won[i][j];
			}
		
		
		
	
	}

	double[] wp;
	double[] owp;
	double[] oowp;
	
	double[] rpi;
	void process()
	{
		wp = new double[N];
		owp = new double[N];
		oowp = new double[N];
		
		for(int i = 0; i < N; i++)
			wp[i] = winTotal[i] * 1.0/total[i];
		
		for(int i = 0; i < N; i++)
		{
//			System.out.println(i);
			for(int j = 0; j < N; j++)
				if(played[i][j] > 0)
				{
					owp[i] += (winTotal[j] - won[j][i]) * 1.0 / (total[j] - played[j][i]);
//					System.out.printf("(%d %d) ", winTotal[j]-won[j][i], total[j]-played[j][i]);
				}
//			System.out.println();
			owp[i] /= total[i];
		}
		
//		System.out.println(Arrays.toString(wp));
//		System.out.println(Arrays.toString(owp));
		for(int i = 0; i < N; i++)
		{
			for(int j = 0; j < N; j++)
				if(played[i][j] > 0)
					oowp[i] += owp[j];
			oowp[i] /= total[i];
		}
		
		rpi = new double[N];
		for(int i = 0; i < N; i++)
			rpi[i] = 0.25*wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
	}
	
	public static void main(String[] args) throws Exception
	{
		new RPI();
	}

}
