import java.util.*;
import java.io.*;

public class StockCharts
{
    boolean FILE = true;
    public static void main(String[] args) throws Exception
    {
        new StockCharts();
    }

    boolean[][] adj;
    int N, K;
    Point[][] pts;
    Segment[][] segs;
    int[] poss;
    int P;
    public StockCharts() throws Exception
    {
        if(!FILE)
            System.out.println("DON'T FORGET TO REDIRECT TO FILE!");
        Scanner sc = new Scanner(System.in);
//        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

        if(FILE)
        {
            sc = new Scanner(new File("GCJ.in"));
//            in = new BufferedReader(new FileReader("GCJ.in"));
            out = new PrintWriter(new BufferedWriter(new FileWriter("GCJ.out")));
        }

        int T = sc.nextInt();
        for(int t = 1; t <= T; t++)
        {
            N = sc.nextInt(); K = sc.nextInt();
            pts = new Point[N][K];
            for(int i = 0; i < N; i++)
                for(int j = 0; j < K; j++)
                    pts[i][j] = new Point(j, sc.nextInt());

            segs = new Segment[N][K-1];
            for(int i = 0; i < N; i++)
                for(int j = 0; j+1 < K; j++)
                    segs[i][j] = new Segment(pts[i][j], pts[i][j+1]);

            adj = new boolean[N][N];
            for(int i = 0; i < N; i++)
                for(int j = i+1; j < N; j++)
                {
                    boolean a = false;
                    for(int k = 0; !a && k < segs[i].length; k++)
                        for(int p = 0; !a && p < segs[j].length; p++)
                            if(segs[i][k].intersects(segs[j][p]))
                                a = true;
                    adj[i][j] = adj[j][i] = a;
                }

            poss = new int[1 << N];
            P = 0;
            for(int mask = 1; mask < poss.length; mask++)
            {
                boolean ok = true;
                for(int i = 0; ok && i < N; i++)
                    if(on(mask, i))
                        for(int j = 0; ok && j < N; j++)
                            if(on(mask, j) && j != i)
                                if(adj[i][j])
                                    ok = false;
                if(ok)
                    poss[P++] = mask;
            }
            ALL = (1 << N)-1;
            memo = new int[1 << N];
            Arrays.fill(memo, -1);

            out.printf("Case #%d: %d\n", t, go(0));

            System.out.println("Case " + t + " done");
        }

        out.close();
        if(!FILE)
            System.out.println("DON'T FORGET TO REDIRECT TO FILE!");
    }


    final int INF = 987564321;
    int ALL;
    int[] memo;
    int go(int mask)
    {
        if(mask == ALL)
            return 0;
        if(memo[mask] >= 0)
            return memo[mask];
        int ret = INF;
        for(int i = 0; i < P; i++)
        {
            if(poss[i] > 0 && (mask & poss[i]) == 0)
                ret = Math.min(ret, 1 + go(mask | poss[i]));
        }
        return memo[mask] = ret;
    }


    class Point
    {
        long x, y;
        public Point(long x, long y) { this.x = x; this.y = y;}
        public Point sub(Point p) { return new Point(x-p.x, y-p.y); }
        public long dot(Point p) { return x*p.x + y*p.y; }
        public long cross(Point p) { return x*p.y - y*p.x; }
        public String toString() { return String.format("(%d, %d)", x, y); }
    }

    class Segment
    {
        Point a, b;
        public Segment(Point a, Point b) { this.a = a; this.b = b; }
        boolean ccw(Point p) { return b.sub(a).cross(p.sub(a)) > 0; }
        public String toString() { return String.format("[%s, %s]", a, b); }

        boolean intersects(Segment other)
        {
            Point A = a, B = b, C = other.a, D = other.b;
            long x1 = Math.min(A.x, B.x), x2 = Math.max(A.x, B.x);
            long y1 = Math.min(A.y, B.y), y2 = Math.max(A.y, B.y);

            long x3 = Math.min(C.x, D.x), x4 = Math.max(C.x, D.x);
            long y3 = Math.min(C.y, D.y), y4 = Math.max(C.y, D.y);

            if(x3 > x2 || x1 > x4) return false;
            if(y3 > y2 || y1 > y4) return false;

            long c1 = B.sub(A).cross(C.sub(A));
            long c2 = B.sub(A).cross(D.sub(A));

            if(Math.signum(c1) * Math.signum(c2) > 0) return false;
            c1 = D.sub(C).cross(A.sub(C));
            c2 = D.sub(C).cross(B.sub(C));

            if(Math.signum(c1) * Math.signum(c2) > 0) return false;
            return true;
        }
    }

    boolean on(int mask, int pos) { return (mask & (1 << pos)) > 0; }
}
