import java.util.*;
import java.io.*;

public class Watersheds
{
    boolean DEBUG = true;
    public static void main(String[] args) throws Exception
    {
        new Watersheds();
    }

    int[] dr = {-1, 0, 0, 1};
    int[] dc = { 0, -1, 1, 0};
    int R, C;
    int[][] alt;
    public Watersheds() throws Exception
    {
        Scanner sc = new Scanner(System.in);
        PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B.out")));
        if(DEBUG)
            sc = new Scanner(new File("B.in"));

        int T = sc.nextInt();
        for(int t = 1; t <= T; t++)
        {
            R = sc.nextInt(); C = sc.nextInt();
            alt = new int[R][C];
            for(int i = 0; i < R; i++)
                for(int j = 0; j < C; j++)
                    alt[i][j] = sc.nextInt();

            int[][] D = new int[R][C];
            for(int i = 0; i < R; i++)
                for(int j = 0; j < C; j++)
                    D[i][j] = dir(i, j);

            Queue<Integer> queue = new LinkedList<Integer>();
            int[][] basin = new int[R][C];
            for(int i = 0; i < R; i++)
                for(int j = 0; j < C; j++)
                {
                    basin[i][j] = i*C + j;
                    if(D[i][j] == -1)
                    {
                        queue.offer(i);
                        queue.offer(j);
                    }
                }

            while(!queue.isEmpty())
            {
                int r = queue.poll(), c = queue.poll();

                for(int k = 0; k < 4; k++)
                    if(ok(r+dr[k], c+dc[k]))
                    {
                        int rr = r+dr[k], cc = c+dc[k], d = D[rr][cc];
                        if(d == -1) continue;
                        if(rr+dr[d] == r && cc+dc[d] == c)
                        {
                            queue.offer(rr);
                            queue.offer(cc);
                            basin[rr][cc] = basin[r][c];
                        }
                    }
            }

            TreeMap<Integer, Character> map = new TreeMap<Integer, Character>();
            char ch = 'a';

            for(int i = 0; i < R; i++)
                for(int j = 0; j < C; j++)
                    if(!map.containsKey(basin[i][j]))
                        map.put(basin[i][j], ch++);

            out.printf("Case #%d:\n", t);
            for(int i = 0; i < R; i++, out.println())
                for(int j = 0; j < C; j++)
                    out.print(map.get(basin[i][j]) + " ");
        }
        out.close();
    }

    final int INF = 987654321;
    int dir(int r, int c)
    {
        int ret = -1, best = INF;
        for(int k = 0; k < dr.length; k++)
            if(ok(r+dr[k], c+dc[k]))
            {
                int rr = r+dr[k], cc = c+dc[k];
                if(alt[rr][cc] < alt[r][c] && alt[rr][cc] < best)
                {
                    best = alt[rr][cc];
                    ret = k;
                }
            }
        return ret;
    }

    boolean ok(int r, int c)
    {
        return 0 <= r && r < R && 0 <= c && c < C;
    }
}
