import java.util.*;
import java.io.*;
import java.math.*;

public class ChessBoards
{
    boolean FILE = true;
    public static void main(String[] args) throws Exception { new ChessBoards(); }

    String hex = "0123456789ABCDEF";
    public ChessBoards() throws Exception
    {
        if(!FILE) System.out.println("DON'T FORGET TO REDIRECT TO FILE!");
        Scanner sc = new Scanner(System.in);
//        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

        if(FILE)
        {
            sc = new Scanner(new File("GCJ.in"));
//            in = new BufferedReader(new FileReader("GCJ.in"));
            out = new PrintWriter(new BufferedWriter(new FileWriter("GCJ.out")));
        }

        int T = sc.nextInt();
        for(int t = 1; t <= T; t++)
        {
            int M = sc.nextInt(), N = sc.nextInt();
            boolean[][] grid = new boolean[M][N];
            for(int i = 0; i < M; i++)
            {
                String s = sc.next();
                for(int j = 0; j < N; j += 4)
                {
                    int d = get(s.charAt(j/4));
                    for(int k = 0; k < 4; k++)
                        grid[i][j+3-k] = on(d, k);
                }
            }

            int[][] vcnt = new int[M][N], hcnt = new int[M][N];
            int[][] size = new int[M][N];
            boolean[][] used = new boolean[M][N];
            int[] poss = new int[Math.min(M, N)+1];
            int cnt = 0;
            while(cnt < M*N)
            {
                for(int i = M-1; i >= 0; i--)
                    for(int j = N-1; j >= 0; j--)
                    {
                        if(used[i][j])
                        {
                            vcnt[i][j] = hcnt[i][j] = size[i][j] = 0;
                            continue;
                        }
                        vcnt[i][j] = hcnt[i][j] = size[i][j] = 1;
                        if(i+1 <= M-1 && grid[i][j] == !grid[i+1][j])
                            vcnt[i][j] = 1 + vcnt[i+1][j];
                        if(j+1 <= N-1 && grid[i][j] == !grid[i][j+1])
                            hcnt[i][j] = 1 + hcnt[i][j+1];

                        if(i+1 < M && j+1 < N && grid[i][j] == grid[i+1][j+1])
                            size[i][j] = Math.min(size[i+1][j+1]+1, Math.min(hcnt[i][j], vcnt[i][j]));
                    }



                int br = -1, bc = -1, best = 0;
                for(int i = 0; i < M; i++)
                    for(int j = 0; j < N; j++)
                        if(size[i][j] > best)
                        {
                            best = size[i][j];
                            br = i;
                            bc = j;
                        }

                if(br >= 0 && bc >= 0)
                {
                    for(int i = br; i < br + best; i++)
                        for(int j = bc; j < bc+best; j++)
                            used[i][j] = true;
                    cnt += best*best;
                    poss[best]++;
                }
            }

            int z = 0;
            for(int k = Math.min(M, N); k > 0; k--)
                if(poss[k] > 0)
                    z++;

            out.printf("Case #%d: %d\n", t, z);
            for(int k = Math.min(M, N); k > 0; k--)
                if(poss[k] > 0)
                    out.printf("%d %d\n", k, poss[k]);

        }



        out.close();
        if(!FILE) System.out.println("DON'T FORGET TO REDIRECT TO FILE!");
    }

    int get(char ch) { return hex.indexOf(ch); }
    boolean on(int mask, int pos) { return (mask & (1 << pos)) > 0; }
    
}
