/**
 * 
 */
import java.io.*;
import java.util.*;
/**
 * @author nadeem
 *
 */
public class Magicka
{

	public Magicka() throws Exception
	{
		Scanner sc = new Scanner(new File("B.in"));
		PrintWriter out = new PrintWriter(new FileWriter("B.out"));
	
		int T = sc.nextInt(), casenum = 1;
		
		while(T-- > 0)
		{
			C = sc.nextInt();
			combinations = new Triplet[C];
			for(int i = 0; i < C; i++)
				combinations[i] = new Triplet(sc.next());
			
			D = sc.nextInt();
			opposed = new Pair[D];
			for(int i = 0; i < D; i++)
				opposed[i] = new Pair(sc.next());
			
			N = sc.nextInt();
			elements = sc.next();
			
			list = new Stack<Character>();
			
			for(char elem: elements.toCharArray())
				add(elem);
			
			out.printf("Case #%d: %s\n", casenum++, list);	
		}
		
		out.close();
	}
	
	int C, D, N;
	String elements;
	Stack<Character> list;
	Pair[] opposed;
	Triplet[] combinations;
	
	
	void add(char ch)
	{
		list.add(ch);
		combine();
		if(conflict())
			list.clear();
	}
	
	void combine()
	{
		if(list.size() < 2) return;
		
		while(list.size() >= 2)
		{
			char first = list.pop(), second = list.pop();
			Triplet t = findCombo(first, second);
			if(t == null)
			{
				list.push(second);
				list.push(first);
				return;
			}
			else
				list.push(t.result);
		}
	}
	
	Triplet findCombo(char first, char second)
	{
		for(Triplet t: combinations)
			if(t.group.match(first, second))
				return t;
		return null;
	}
	
	boolean conflict()
	{
		char first = list.pop();
		for(char second: list)
		{
			for(Pair p: opposed)
				if(p.match(first, second))
					return true;
		}
		list.push(first);
		return false;
	}
	
	
	class Pair
	{
		char one, two;
		Pair(String s)
		{
			one = s.charAt(0);
			two = s.charAt(1);	
		}
		
		boolean has(char x)
		{
			return one == x || two == x;
		}
		
		char other(char x)
		{
			if(one == x) return two;
			return one;
		}
		
		boolean match(char x, char y)
		{
			return (one == x && two == y) || (one == y && two == x);
		}
	}
	
	class Triplet
	{
		Pair group;
		char result;
		
		public Triplet(String s)
		{
			group = new Pair(s.substring(0, 2));
			result = s.charAt(2);
		}
	}
	

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception
	{
		new Magicka();

	}

}
