import java.util.*;
import java.io.*;

public class B
{
    class Trip implements Comparable<Trip>
    {
        int start, end;
        int ind;
        
        public Trip(String a, String b, int ind)
        {
            start = parse(a);
            end = parse(b);
            this.ind = ind;
        }
        
        public int compareTo(Trip other)
        {
            if(start == other.start)
            {
                if(end == other.end)
                    return ind - other.ind;
                return end - other.end;
            }
            return start-other.start;
        }
        
        public String toString()
        {
            return "(" + start + ", " + end + ")";
        }
    }
    
    int parse(String time)
    {
        int ret = 60*Integer.parseInt(time.substring(0, 2));
        ret += Integer.parseInt(time.substring(3));
        return ret;
    }
    
    public static void main(String[] args) throws Exception
    {
        new B();
    }
    
    int N, T, A, B;
    TreeSet<Trip> atrips;
    TreeSet<Trip> btrips;
    public B() throws Exception
    {
        Scanner sc = new Scanner(new File("B.in"));
        N = sc.nextInt();
        
        for(int k = 1; k <= N; k++)
        {
            T = sc.nextInt();
            A = sc.nextInt();
            B = sc.nextInt();
            
            atrips = new TreeSet<Trip>();
            btrips = new TreeSet<Trip>();
            int ind = 0;
            
            for(int i = 0; i < A; i++)
                atrips.add(new Trip(sc.next(), sc.next(), ind++));
            for(int i = 0; i < B; i++)
                btrips.add(new Trip(sc.next(), sc.next(), ind++));
            
            System.out.printf("Case #%d: ", k);
            solve();
        }
        
        sc.close();
    }
    
    void solve()
    {
        int aret = 0, bret = 0;
        
        int a = 0, b = 0, p = 0;
        while(!atrips.isEmpty() && !btrips.isEmpty())
        {
            Trip one = atrips.first(), two = btrips.first();
            if(one.compareTo(two) < 0)
            {
                aret++;
                p = 0;
            }
            else
            {
                bret++;
                p = 1;
            }
            
            Trip train = get(p).first();
            get(p).remove(train);
            while(true)
            {
                Trip rem = null;
                for(Trip poss: get(1-p))
                    if(train.end + T <= poss.start)
                    {
                        rem = poss;
                        break;
                    }
                if(rem == null)
                    break;
                get(1-p).remove(rem);
                train = rem;
                p = 1-p;
            }
        }
        
        aret += atrips.size();
        bret += btrips.size();
        
        System.out.println(aret + " " + bret);
    }
    
    TreeSet<Trip> get(int p)
    {
        return p == 0 ? atrips : btrips;
    }
    
    void swap(TreeSet<Trip> curr, TreeSet<Trip> other)
    {
        if(curr == atrips)
        {
            curr = btrips;
            other = atrips;
        }
        else
        {
            curr = atrips;
            other = btrips;
        }
    }
}
