import java.util.*;
import java.io.*;

public class CandySplitting
{
	int N;
	int[] v;
	int[][] F = new int[2][1 << 20];
	int[][] G = new int[2][1 << 20];
	public CandySplitting() throws Exception
	{
		Scanner sc = new Scanner(new File("C.in"));
		PrintWriter out = new PrintWriter(new FileWriter("C.out"));
		
		int T = sc.nextInt();
		for(int t = 1; t <= T; t++)
		{
			N = sc.nextInt();
			v = new int[N];
			for(int i = 0; i < N; i++)
				v[i] = sc.nextInt();
			
//			for(int i = 0; i < F.length; i++)
//			{
//				Arrays.fill(F[i], -1);
//				Arrays.fill(G[i], -1);
//			}
//			
//			F[0][0] = G[0][0] = 0;
//			
//			int p = 0;
//			for(int i = 0; i < N; i++, p = 1-p)
//			{
//				Arrays.fill(F[1-p], -1);
//				Arrays.fill(G[1-p], -1);
//				for(int s = 0; s < F[p].length; s++)
//					if(F[p][s] >= 0)
//					{
//						// Add candy to other pile.
//						F[1-p][s] = F[p][s];
//						G[1-p][s] = sum(G[p][s], v[i]);
//						
//						// Add it to this pile.
//						if(F[1-p][sum(s, v[i])] < F[p][s] + v[i])
//						{
//							F[1-p][sum(s, v[i])] = F[p][s] + v[i];
//							G[1-p][sum(s, v[i])] = G[p][s];
//						}
//					}
//			}
//			
//			int best = -1;
//			for(int i = 1; i < G[p].length; i++)
//				if(G[p][i] == i)
//					best = Math.max(best, F[p][i]);
			
			int best2 = solve();
			
			out.printf("Case #%d: ", t);
//			if(best < 0) out.print("NO");
//			else out.print(best);
//			
//			out.print(" ");
			if(best2 < 0) out.print("NO");
			else out.print(best2);
			
			out.println();
		}
		
		out.close();
	}
	
	int solve()
	{
		int[] sums = new int[1 << N];
		int[] trueSums = new int[1 << N];
		for(int mask = 0; mask < (1 << N); mask++)
		{
			for(int i = 0; i < N; i++)
				if(on(mask, i))
				{
					sums[mask] = sum(sums[mask], v[i]);
					trueSums[mask] = trueSums[mask] + v[i];
				}
		}
		
		int ret = -1;
		int ALL = (1 << N)-1;
		for(int i = 1; i < (1 << N)-1; i++)
			if(sums[i] == sums[ALL ^ i])
				ret = Math.max(ret, trueSums[i]);
		
		return ret;
	}

	
	int sum(int x, int y)
	{
		int ret = 0;
		for(int i = 0; i < 20; i++)
			ret = set(ret, i, add(get(x, i), get(y, i)));
		return ret;
//		return x ^ y;
	}
	
	int add(int x, int y) { return (x + y) % 2;	}
	int set(int mask, int pos, int val) { return mask | (val << pos); }
	int get(int mask, int pos) { return b2i((mask & (1 << pos)) > 0); }
	boolean on(int mask, int pos) { return (mask & (1 << pos)) > 0; }
	
	int b2i(boolean b) { return b ? 1 : 0; }
	boolean i2b(int i) { return i != 0; }
	
	public static void main(String[] args) throws Exception
	{
		new CandySplitting();

	}

}
