import java.util.*;
import java.io.*;
import java.math.*;

public class GoroSort
{
	BigInteger[] fact = new BigInteger[1001];
	int N;
	int[] p;
	BigInteger[] best = new BigInteger[1001];
	public GoroSort() throws Exception
	{
		fact[0] = BigInteger.ONE;
		for(int i = 1; i < fact.length; i++)
			fact[i] = BigInteger.valueOf(i).multiply(fact[i-1]);

		best[1] = BigInteger.ZERO;
		best[2] = BigInteger.valueOf(2);
		for(int i = 3; i < best.length; i++)
		{
			best[i] = fact[i];
			for(int j = 1; j < i; j++)
				best[i] = min(best[i], best[j].add(best[i-j+1]));
		}
		
		
		
		Scanner sc = new Scanner(new File("D.in"));
		PrintWriter out = new PrintWriter(new FileWriter("D.out"));
		
		int T = sc.nextInt();
		for(int t = 1; t <= T; t++)
		{
			N = sc.nextInt();
			p = new int[N];
			for(int i = 0; i < N; i++)
				p[i] = sc.nextInt()-1;
			
			findCycles();
			BigInteger ret = BigInteger.ZERO;
			for(int len: cycles)
				ret = ret.add(best[len]);
			
			out.printf("Case #%d: %d\n", t, ret);
		}
		
		
		out.close();
	}
	
	BigInteger min(BigInteger a, BigInteger b) { return a.compareTo(b) < 0 ? a : b; }
	
	Vector<Integer> cycles = new Vector<Integer>();
	void findCycles()
	{
		cycles.clear();
		boolean[] seen = new boolean[N];
		for(int i = 0; i < N; i++)
			if(!seen[i])
			{
				int curr = i;
				int cnt = 0;
				while(!seen[curr])
				{
					seen[curr] = true;
					curr = p[curr];
					cnt++;
				}
				if(cnt > 1)
					cycles.add(cnt);
			}
	}


	public static void main(String[] args) throws Exception
	{
		new GoroSort();
	}

}
