import java.util.*;
import java.io.*;

public class D
{
    public static void main(String[] args) throws Exception
    {
        new D();
    }
    
    int N, K;
    String S;
    
    public D() throws Exception
    {
        Scanner sc = new Scanner(new File("D.in"));
        N = sc.nextInt();
        
        for(int k = 1; k <= N; k++)
        {
            K = sc.nextInt();
            S = sc.next();
            System.out.printf("Case #%d: %d\n", k, solve());
        }
        sc.close();
    }
    
    int solve()
    {
        int ret = S.length();
        int[] perm = new int[K];
        for(int i = 0; i < K; i++)
            perm[i] = i;
        do
        {
            StringBuffer sb = encode(perm);
            ret = Math.min(ret, size(sb));
        } while(next_permutation(perm));
        return ret;
    }
    
    StringBuffer encode(int[] perm)
    {
        StringBuffer ret = new StringBuffer();
        for(int i = 0; i < S.length(); i += K)
            for(int j = 0; j < K; j++)
                ret.append(S.charAt(i + perm[j]));
        return ret;
    }
    
    
    boolean next_permutation(int[] nums)
    {
        int n = nums.length;
        
        int i = n-2;
        while(i >= 0 && nums[i] >= nums[i+1])
            i--;
        if(i == -1) return false;
        
        int x = nums[i];
        
        int j = n-1;
        while(j > i && nums[j] <= x)
            j--;
        
        nums[i] = nums[j];
        nums[j] = x;
        
        Arrays.sort(nums, i+1, n);
        return true;
    }
    
    
    int size(StringBuffer sb)
    {
        int ret = 1;
        for(int i = 1; i < sb.length(); i++)
            if(sb.charAt(i) != sb.charAt(i-1))
                ret++;
        return ret;
    }
}
