import java.util.*;
import java.io.*;

public class C 
{
    public static void main(String[] args) throws Exception
    {
        new C();
    }
    
    int C, M, N;
    char[][] room;
    
    public C() throws Exception
    {
        Scanner sc = new Scanner(new File("C.in"));
        C = sc.nextInt();
        
        for(int k = 1; k <= C; k++)
        {
            M = sc.nextInt();
            N = sc.nextInt();
            room = new char[M][N];
            for(int i = 0; i < M; i++)
                room[i] = sc.next().toCharArray();
            memo = new int[M][N][1 << N];
            for(int i = 0; i < M; i++)
                for(int j = 0; j < N; j++)
                    Arrays.fill(memo[i][j], -1);
            int ret = go(0, 0, 0);
            System.out.printf("Case #%d: %d\n", k, ret);
        }
        sc.close();
    }
    
    int[][][] memo;
    int go(int row, int col, int mask)
    {
        if(row == M)
            return 0;
        if(col >= N)
            return go(row+1, 0, mask);
        if(memo[row][col][mask] >= 0)
            return memo[row][col][mask];
        
        int ret = 0;
        int nmask = mask;
        if(col > 0 && on(nmask, col-1))
            nmask = reset(nmask, col-1);
        if(col == N-1 && on(nmask, col))
            nmask = reset(nmask, col);
        ret = go(row, col+1, nmask);
        
        if(room[row][col] == '.' && !on(mask, col+1) && !on(mask, col-1))
        {
            nmask = set(mask, col);                
            ret = Math.max(ret, 1 + go(row, col+2, nmask));
        }
        
        return memo[row][col][mask] = ret;
    }
    
    boolean on(int mask, int pos)
    {
        if(pos < 0)
            return false;
        return (mask & (1 << pos)) > 0;
    }
    
    int set(int mask, int pos)
    {
        return mask | (1 << pos);
    }
    
    int reset(int mask, int pos)
    {
        return mask - (1 << pos);
    }
    
    StringBuilder make(int len)
    {
        StringBuilder ret = new StringBuilder();
        for(int i = 0; i < len; i++)
            ret.append('.');
        return ret;
    }
}
