import java.util.*;
import java.io.*;
import java.math.*;

public class RopeIntranet
{
    boolean FILE = true;
    public static void main(String[] args) throws Exception { new RopeIntranet(); }

    public RopeIntranet() throws Exception
    {
        if(!FILE) System.out.println("DON'T FORGET TO REDIRECT TO FILE!");
        Scanner sc = new Scanner(System.in);
//        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

        if(FILE)
        {
            sc = new Scanner(new File("GCJ.in"));
//            in = new BufferedReader(new FileReader("GCJ.in"));
            out = new PrintWriter(new BufferedWriter(new FileWriter("GCJ.out")));
        }

        int T = sc.nextInt();
        for(int t = 1; t <= T; t++)
        {
            int N = sc.nextInt();
            Segment[] segs = new Segment[N];
            for(int i = 0; i < N; i++)
                segs[i] = new Segment(new Point(0, sc.nextInt()), new Point(100, sc.nextInt()));

            int ret = 0;
            for(int i = 0; i < N; i++)
                for(int j = i+1; j < N; j++)
                    if(segs[i].intersects(segs[j]))
                        ret++;
            out.printf("Case #%d: %d\n", t, ret);
        }

        out.close();
        if(!FILE) System.out.println("DON'T FORGET TO REDIRECT TO FILE!");
    }

    class Point implements Comparable<Point>
    {
        int x, y;

        Point(int x, int y) { this.x = x; this.y = y; }
        Point sub(Point p) { return new Point(x-p.x, y-p.y); }

        int dot(Point p) { return x*p.x + y*p.y; }
        int cross(Point p) { return x*p.y - y*p.x; }
        int length2() { return dot(this); }
        double length() { return Math.sqrt(length2()); }

        public int compareTo(Point p) { return x != p.x ? x-p.x : y-p.y; }
        public boolean equals(Object o) { Point p = (Point)o; return x == p.x && y == p.y; }
        public String toString() { return String.format("(%d, %d)", x, y); }
    }


    class Segment
    {
        Point a, b;
        public Segment(Point a, Point b) { this.a = a; this.b = b; }

        boolean intersects(Segment other)
        {
            Point[] U = boundingRect(), V = other.boundingRect();
            if(U[1].x < V[0].x || U[1].y < V[0].y || V[1].x < U[0].x || V[1].y < U[0].y)
                return false;
            Point A = a, B = b, C = other.a, D = other.b;
            int p = (int)Math.signum(B.sub(A).cross(C.sub(A))), q = (int)Math.signum(B.sub(A).cross(D.sub(A)));
            if(p * q > 0) return false;
            p = (int)Math.signum(D.sub(C).cross(A.sub(C))); q = (int)Math.signum(D.sub(C).cross(B.sub(C)));
            if(p * q > 0) return false;
            return true;
        }

        Point[] boundingRect()
        {
            Point m = new Point(Math.min(a.x, b.x), Math.min(a.y, b.y));
            Point M = new Point(Math.max(a.x, b.x), Math.max(a.y, b.y));
            return new Point[] {m, M};
        }

        boolean isLeft(Point p) { return b.sub(a).cross(p.sub(b)) > 0; }
        boolean collinear(Point p) { return b.sub(a).cross(p.sub(b)) == 0; }
    }
    
}
