import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.ListIterator;


public class Rotate
{

  public static List<String> loadLines(File file) throws IOException {
    if (!file.exists()) {
      return null;
    }
    BufferedReader reader = null;
    reader = new BufferedReader(new FileReader(file));
    ArrayList<String> list = new ArrayList<String>();
    String s = null;
    while ((s = reader.readLine()) != null) {
      list.add(s);
    }
    if (reader != null)
      try {
        reader.close();
      } catch (IOException e) {
      }
    reader = null;
    return list;
  }
  
  public static void main(String[] args) throws Exception {
    List<String> lines = loadLines(new File(args[0]));
    ListIterator<String> iter = lines.listIterator();
    if (iter.hasNext())
      iter.next();
    int id = 1;
    while (iter.hasNext()){
      String line = iter.next();
      String[] flds = line.split("\\s+");

      int N = Integer.parseInt(flds[0]);
      int K = Integer.parseInt(flds[1]);
      String[] map = new String[N];
      for (int i=0; i<N; i++) {
        map[i] = iter.next();
      }
      String r = find(N, K, map);
      System.out.println("Case #" + id + ": " + r);
      System.err.println("Case #" + id + ": " + r);
      id++;
    }
  }
  static int K = 0;
  static int N = 0;
  private static String find(int n, int k, String[] map) {
    K = k;
    N = n;
//    System.err.println("N" + n + ", K"+k);
//    for (String s : map) {
//      System.err.println(s);
//    }
    for (int i=0; i<n; i++) {
      map[i] = rotate(map[i]);
//      System.err.println(map[i]);
    }
    boolean red = false;
    boolean black = false;
    String rrr = "";
    String bbb = "";
    for (int i=0; i<k; i++) {
      rrr += "R";
      bbb += "B";
    }
    for (int i=0; i<n; i++) {
      if (map[i].indexOf(rrr) >= 0) red = true;
      if (map[i].indexOf(bbb) >= 0) black = true;
      
      for (int j=0; j<map[i].length(); j++) {
        if (!red) red = judgeRed(map, i, j);
        if (!black) black = judgeBlack(map, i, j);
        if (red && black) return "Both";
      }
    }
    if (red) return "Red";
    if (black) return "Blue";
    return "Neither";
  }

  private static boolean judgeBlack(String[] map, int i, int j) {
    return judge(map, i, j, 'B');
    
  }

  private static boolean judge(String[] map, int ii, int jj, char c) {
    // \
    int i=ii;
    int j=jj;
    boolean bfound = true;
    for (int m=0; m<K; m++) {
      if (i>=N ) { bfound = false; break; }
      if (j>=map[i].length()) { bfound = false; break; }
      if (map[i].charAt(j) == c) {
        i ++; j++;
      } else {
        bfound = false;
        break;
      }
    }
    if (bfound) {
//      System.err.println("Found \\" + c + ii+ "-" + jj);
      return true;
    }
    bfound = true;
    i = ii;
    j = jj; 
    for (int m=0; m<K; m++) {
      if (i>=N ) { bfound = false; break; }
      if (map[i].charAt(j) == c) {
        i ++;
      } else {
        bfound = false;
        break;
      }
    }

    if (bfound) {
//      System.err.println("Found |" + c + ii+ "-" + jj);
      return true;
    }
    i = ii;
    j = jj;
    for (int m=0; m<K; m++) {
      if (i>=N) { return false; }
      if (j<0) { return false; }
      if (map[i].charAt(j) == c) {
        i ++; j--;
      } else {
        return false;
      }
    }
    
//      System.err.println("Found /" + c + ii+ "-" + jj);
      return true;
    
  }

  private static boolean judgeRed(String[] map, int i, int j) {
    return judge(map, i, j, 'R');    
  }

  private static String rotate(String ori) {
    StringBuffer sb = new StringBuffer(ori.length());
    for (int i=ori.length()-1; i>=0; i--) {
      if (ori.charAt(i) == 'R' || ori.charAt(i) == 'B') sb.append(ori.charAt(i));
    }
    return sb.toString();
  }

}
