import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.ListIterator;

public class Roller
{

  public static List<String> loadLines(File file) throws IOException {
    if (!file.exists()) {
      return null;
    }
    BufferedReader reader = null;
    reader = new BufferedReader(new FileReader(file));
    ArrayList<String> list = new ArrayList<String>();
    String s = null;
    while ((s = reader.readLine()) != null) {
      list.add(s);
    }
    if (reader != null) try {
      reader.close();
    } catch (IOException e) {
    }
    reader = null;
    return list;
  }

  static void dump(long[] a) {
    System.err.print("[");
    for (long i : a) {
      System.err.print("," + i);
    }
    System.err.println("]");
  }
  static void dump(int[] a) {
    System.err.print("[");
    for (int i : a) {
      System.err.print("," + i);
    }
    System.err.println("]");
  }

  public static void main(String[] args) throws Exception {
    List<String> lines = loadLines(new File(args[0]));
    ListIterator<String> iter = lines.listIterator();
    if (iter.hasNext()) iter.next();
    int id = 1;
    while (iter.hasNext()) {
      String line = iter.next();
      String[] flds = line.split("\\s+");
      if (flds.length != 3) throw new Exception("Wrong format");
      int R = Integer.parseInt(flds[0]);
      int K = Integer.parseInt(flds[1]);
      int N = Integer.parseInt(flds[2]);
      line = iter.next();
      flds = line.split("\\s+");
      if (flds.length != N) throw new Exception("Wrong groups in " + id);

      int[] g = new int[N];
      long total = 0;
      for (int i = 0; i < N; i++) {
        g[i] = Integer.parseInt(flds[i]);
        total += g[i];
      }
      int[] nextid = new int[N];
      long[] earn_since = new long[N];
      int[] earns = new int[N];
      int[] steps_since = new int[N];
      Arrays.fill(nextid, 0);
      Arrays.fill(earn_since, 0);
      Arrays.fill(earns, 0);
      Arrays.fill(steps_since, 0);
      int walker = 0;
      int cycle_size = 0;
      int cycle_begin = 0;
      long total_earn = 0;
      long cycle_earn = 0;
      boolean early_stop = false;
      // 1. find cycles
      while (true) {
        // findNext, from walker
        int earn = 0;
        int tester = walker;
        while (true) {
          earn += g[tester++];
          if (tester == N) tester = 0;
          if (tester == walker) break;
          if (earn + g[tester] > K) break;
        }
        nextid[walker] = tester;
        earns[walker] = earn;
        for (int i = 0; i < N; i++) {
          if (steps_since[i] > 0 || i == 0 || i == walker) {
            earn_since[i] += earn;
            steps_since[i]++;
          }
        }
//        dump(steps_since);
//        dump(nextid);
//        dump(earns);
//        dump(earn_since);
        // judge if find cycle
        if (steps_since[tester] > 0) {
          cycle_begin = tester;
          cycle_size = steps_since[tester];
          if (earn_since[tester] % total != 0) {
//            System.err.println(id);
//          dump(steps_since);
//          dump(nextid);
//          dump(earns);
//          dump(earn_since);
            throw new Exception("Not equal!");
          }
          cycle_earn = earn_since[tester];
          break;
        }
        if (steps_since[0] == R) {
          // end!
//          dump(steps_since);
//          dump(earn_since);
          total_earn = earn_since[0];
          early_stop = true;
          break;
        }
        walker = tester;
      }

      if (!early_stop) {
        // cycle if possible
        int steps = steps_since[0];
        int cycles = (R - steps) / cycle_size;
        total_earn = earn_since[0] + cycles * cycle_earn;
        int left = (R - steps) % cycle_size;
        while (left-- != 0) {
          total_earn += earns[cycle_begin];
          cycle_begin = nextid[cycle_begin];
        }
      }
      System.out.println("Case #" + id + ": " + total_earn);
      id++;
    }
  }

}
