import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.ListIterator;
import java.util.SortedSet;
import java.util.TreeSet;


public class Warning
{


  public static List<String> loadLines(File file) throws IOException {
    if (!file.exists()) {
      return null;
    }
    BufferedReader reader = null;
    reader = new BufferedReader(new FileReader(file));
    ArrayList<String> list = new ArrayList<String>();
    String s = null;
    while ((s = reader.readLine()) != null) {
      list.add(s);
    }
    if (reader != null)
      try {
        reader.close();
      } catch (IOException e) {
      }
    reader = null;
    return list;
  }
  
  static BigInteger leastCommonFactor(BigInteger a, BigInteger b) {
    return a.gcd(b);
  }
  
  
  public static void main(String[] args) throws Exception {
    List<String> lines = loadLines(new File(args[0]));
    ListIterator<String> iter = lines.listIterator();
    if (iter.hasNext())
      iter.next();
    int id = 1;
    while (iter.hasNext()){
//      System.err.println(id);
      String line = iter.next();
      String[] flds = line.split("\\s+");
      if (flds.length<3) throw new Exception("Wrong format");
      SortedSet<BigInteger> l = new TreeSet<BigInteger>();
      for (int i=1; i<flds.length; i++) {
        l.add(new BigInteger(flds[i]));
      }
      SortedSet<BigInteger> diff = new TreeSet<BigInteger>();
      Iterator<BigInteger> i=l.iterator();
      BigInteger last = i.next();
      BigInteger smallest = last;
      for (; i.hasNext(); ) {
        BigInteger cur = i.next();
        diff.add(cur.subtract(last));
        last = cur;
      }
//      System.err.println(diff);
      i=diff.iterator();
      BigInteger lcf = i.next();
      for (; i.hasNext();) {
        lcf = lcf.gcd(i.next());
      }
      BigInteger remain = smallest.remainder(lcf);
//      System.err.println("Reminder: " + remain + ", lcf=" + lcf);
      if (remain.equals(BigInteger.ZERO)) {
        System.out.println("Case #"+id+": 0");
      } else {
        BigInteger result = lcf.subtract(remain);
        System.out.println("Case #"+id+": "+result.toString());
      } 
      id ++;
    }
  }

}
