package round1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Collection;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;
import java.util.TreeMap;

public class ProblemA {

	Map<Character, Character> subCypher = new TreeMap<Character, Character>();

	public ProblemA() {
		addKnown();
	}

	public void addSubstitution(String encrypeted, String decripted) {
		char[] encriptedCharArray = encrypeted.toCharArray();
		char[] decriptedCharArray = decripted.toCharArray();
		for (int i = 0; i < decriptedCharArray.length; i++) {
			char c = decriptedCharArray[i];
			if (c == ' ') {
				continue;
			}
			if (subCypher.get(encriptedCharArray[i]) != null
					&& subCypher.get(encriptedCharArray[i]) != c) {
				System.out.println("found different substitution");
				break;
			}

			subCypher.put(encriptedCharArray[i], c);
		}

		if (subCypher.size() == 25) {
			Collection<Character> keySet = subCypher.keySet();
			Collection<Character> values = subCypher.values();
			char key = getMissing(keySet);

			char value = getMissing(values);
			addSubstitution(key + "", value + "");
		}
	//	System.out.println(subCypher);

	}

	private char getMissing(Collection<Character> keySet) {
		char key = 0;
		for (int i = 97; i < 123; i++) {
			char key1 = (char) i;
			if (!keySet.contains(key1)) {
				return key1;
			}
		}
		return key;

	}

	private void addKnown() {
		addSubstitution("ejp mysljylc kd kxveddknmc re jsicpdrysi",
				"our language is impossible to understand");
		addSubstitution("rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
				"there are twenty six factorial possibilities");
		addSubstitution("de kr kd eoya kw aej tysr re ujdr lkgc jv",
				"so it is okay if you want to just give up");
		addSubstitution("y qee", "a zoo");
	}

	public static void main(String[] args) {
		ProblemA a = new ProblemA();
		a.process(args[0]);
	}

	private void process(String string) {
		BufferedReader in = null;
		try {
			in = new BufferedReader(new FileReader(string));
			int lineNumber = 0;
			String line = null;
			while ((line = in.readLine()) != null) {
				if (lineNumber > 0)
					System.out.println("Case #" + lineNumber +": " + decript(line));
				lineNumber++;
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		} finally {
			try {
				if (in != null)
					in.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}

	public String decript(String encripted) {
		char[] charArray = encripted.toCharArray();
		StringBuilder builder = new StringBuilder();
		for (char c : charArray) {
			if (c == ' ') {
				builder.append(c);
			} else {
				builder.append(subCypher.get(c));
			}
		}
		return builder.toString();
	}

}
