package Google;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;
//Author : Ahmed Abuzuraiq abuzerq@gmail.com

public class OversizedPancakeFlipper {

	public static void main(String[] args) throws FileNotFoundException {

		PrintWriter out =  new PrintWriter("src/Google/A-small-attempt1.out");
		Scanner scan = new Scanner(new File("src/Google/A-small-attempt1.in"));
//		Scanner scan = new Scanner("1 +++---+ 4");

		int testCases = scan.nextInt();
		int t = 1;
		while(testCases-->0)
		{
			String row = scan.next();
			int k = scan.nextInt();
			int edits = editDistance(row,k);
			if(edits == -1)
				out.write("Case #"+t+": "+"IMPOSSIBLE\n");
			else
				out.write("Case #"+t+": "+edits+"\n");
			t++;
		}
		out.flush();
	}
	static String pluses(int n)
	{
		String str = "";
		for(int i =0 ; i < n ;i++)
		{
			str += "+";
		}
		return str;
	}
	private static int editDistance(String row, int k) 
	{
		String allPlus = pluses(k);
		Queue<State> queue = new LinkedList<State>();
		LinkedList<State> visited = new LinkedList<State>();
		State initial = new State(row,0);
		
		queue.add(initial);
		visited.add(initial);
		int num = 0;
		while(!queue.isEmpty())
		{
			State state = queue.remove();
			num++;
			//System.out.println(state.str + " :  "+state.depth);
			if(isSolution(state))
			{
				return state.depth;
			}
			for(int i = 0; i <= state.str.length()-k;i++)
			{
				if(state.str.substring(i, i+k).equals(allPlus))
					continue;
				String tmp = flip(state,i,k);
				State child = new State(tmp,state.depth+1);
				if(!visited.contains(child))
				{
				//	System.out.println("Par "+state.str+ " ,child "+child.str);
					queue.add(child);
					visited.add(child);
				}
			}
		}		
		
		return -1;
	}
	private static String flip(State state, int i, int k) {
		String newStr = state.str;
		for(int j = i;j < i+k;j++)
		{
			newStr = newStr.substring(0, j)+opposite(newStr.charAt(j))+newStr.substring(j+1);
		}
		return newStr;
	}
	static char opposite(char c)
	{
		if(c == '+')return '-';
		else return '+';
	}
	static class State
	{
		String str;
		int depth;
		State(String str,int depth)
		{
			this.str = str;
			this.depth = depth;
		}
		@Override
		public boolean equals(Object other)
		{
			State st = (State)other;
			return st.str.equals(this.str);
		}
	}
	static boolean isSolution(State st)
	{
		for(int i  = 0 ; i <st.str.length();i++)
		{
			if(st.str.charAt(i) != '+')
					return false;
		}
		return true;
	}

}
