import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;


public class Magician 
{
	static int firstBoard[][];
	static int secondBoard[][];
	static final String RES_BAD_MAGICIAN = "Bad magician!";
	static final String RES_VOLUNTEER_CHEATED = "Volunteer cheated!";
	static final int COLUMN_SIZE = 4;
	static final int ROW_SIZE = 4;
	public static void main(String args[]) throws Exception
	{
		
		boolean file = true;
		FileInputStream fis = new FileInputStream(file?"inputSmall.in":"inputSmall");
		BufferedWriter bw = new BufferedWriter(new FileWriter("magician.out"));
		BufferedReader bf = new BufferedReader(new InputStreamReader(fis));
		int cases = Integer.parseInt(bf.readLine());
		int indexCase = 0;
		Integer startRow = null;
		int endRow = -1;
		while(indexCase<cases)
		{
			startRow = Integer.parseInt(bf.readLine());
			startBoard(bf, 1);
			endRow = Integer.parseInt(bf.readLine());
			startBoard(bf, 2);
			String answer = answerBoard(startRow, endRow, indexCase);
			if(indexCase>0)
				bw.write("\n");
			if(!file)
				System.out.println(answer); 
			else 
				bw.write(answer);
			indexCase++;			
		}
		if(file)
			bw.close();
		
	}
	private static String answerBoard(int startRow, int endRow, int indexCase) 
	{
		int res = -1;
		boolean badMagician = false;
		int cambio[] = new int[1];
		int ocurrencias = ocurrencias(startRow-1, endRow-1, cambio);
		if(ocurrencias > 1)
		{
			badMagician = true;
		}
		else if(ocurrencias == 1)
		{
			res = cambio[0];
		}
		return ("Case #"+(indexCase+1)+": ")+(res==-1?(badMagician?RES_BAD_MAGICIAN:RES_VOLUNTEER_CHEATED):res);
	}
	private static int ocurrencias(int startRow, int endRow, int[] cambio) 
	{
		int ocurrencias = 0;
		for (int i = 0; i < COLUMN_SIZE; i++) 
		{
			boolean encontro = false;
			for (int j = 0; j < COLUMN_SIZE && !encontro; j++) 
			{
				if ((firstBoard[startRow][i] == secondBoard[endRow][j])) 
				{
					encontro = true;
					cambio[0] = firstBoard[startRow][i];
					ocurrencias++;
				}
			}
		}
		return ocurrencias;
	}
	private static void startBoard(BufferedReader bf, int board) throws Exception
	{
		if(board==1)
			firstBoard= new int[ROW_SIZE][COLUMN_SIZE];
		else
			secondBoard= new int[ROW_SIZE][COLUMN_SIZE];
		for (int i = 0; i < ROW_SIZE; i++) 
		{
			String line[] = bf.readLine().split(" ");
			for (int j = 0; j < COLUMN_SIZE; j++) 
			{
				if(board==1)
					firstBoard[i][j] = Integer.parseInt(line[j]);
				else
					secondBoard[i][j] = Integer.parseInt(line[j]);
			}
		}	
		//printBoard(board);		
	}
	private static void printBoard(int[][] board) 
	{
		for (int i = 0; i < ROW_SIZE; i++) 
		{
			for (int j = 0; j < COLUMN_SIZE; j++) 
			{
				System.out.print(board[i][j] + " ");
			}
			System.out.println("");
		}	
	}
}
