package com.agustin.y2017;

import java.io.*;
import java.math.BigInteger;

/**
 * @author Agustin on 4/8/2017.
 * @since x.x
 */
public class TidyNumbers {


    private static final String folder = "y2017/tidynumbers/";
    private final BigInteger N;
    private static final BigInteger _TEN = BigInteger.TEN;
    private static final BigInteger _ZERO = BigInteger.ZERO;
    private static final BigInteger _ONE = BigInteger.ONE;

    public TidyNumbers(BigInteger n) {
        this.N = n;
    }

    public static void main(String... args) {
//        String filename = "test01.txt";
//        String filename = "B-small-attempt0.in";
        String filename = "B-large.in";
        InputStream resourceAsStream = ClassLoader.getSystemClassLoader().getResourceAsStream(TidyNumbers.folder + filename);
        try (BufferedReader bf = new BufferedReader(new InputStreamReader(resourceAsStream))) {
            PrintWriter bw = new PrintWriter("tidy_Numbers_" + filename + ".out", "UTF-8");
            int numCases = HelperClass.asInt(bf.readLine());
            for (int i = 0; i < numCases; i++) {
                TidyNumbers tidyNumbers = new TidyNumbers(new BigInteger(bf.readLine()));
                String res = String.format(i == 0 ? "Case #%d: %s" : "\nCase #%d: %s", i + 1, tidyNumbers.solve());
                System.out.print(res);
                bw.write(res);
            }
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    private String solve() {
        for (BigInteger i = N; i.compareTo(_ZERO) > 0; i = i.subtract(_ONE)) {
            if (TidyNumbers.isTidy(i)) {
                return i.toString();
            }
        }
        return null;
    }

    private static boolean isTidy(BigInteger n) {
        BigInteger last = null;
        BigInteger curr;
        while(n.compareTo(_ZERO) > 0) {
            curr = BigInteger.ONE.mod(_TEN);
            n = n.divide(_TEN);
            if (last != null && last.compareTo(curr) < 0) {
                return false;
            }
            last = curr;
        }
        return true;
    }

    public static class HelperClass {

        static int asInt(String str) {
            return Integer.parseInt(str);
        }

        public static void main(String... ar) {
            String[] vals = {"8", "123", "555", "224488","20", "321", "495", "999990"};
            for(String val : vals)
                System.out.println("555: " + TidyNumbers.isTidy(new BigInteger(val)));
        }
    }
}
