package com.agustin.y2017;

import java.io.*;
import java.math.BigInteger;

/**
 * @author Agustin on 4/8/2017.
 * @since x.x
 */
public class TidyNumbers {


    private static final String folder = "y2017/tidynumbers/";
    private final BigInteger N;

    public TidyNumbers(BigInteger n) {
        this.N = n;
    }

    public static void main(String... args) {
//        String filename = "test01.txt";
        String filename = "B-small-attempt0.in";
//        String filename = "A-large.in";
        InputStream resourceAsStream = ClassLoader.getSystemClassLoader().getResourceAsStream(TidyNumbers.folder + filename);
        try (BufferedReader bf = new BufferedReader(new InputStreamReader(resourceAsStream))) {
            PrintWriter bw = new PrintWriter("tidy_Numbers_" + filename + ".out", "UTF-8");
            int numCases = HelperClass.asInt(bf.readLine());
            for (int i = 0; i < numCases; i++) {
                TidyNumbers tidyNumbers = new TidyNumbers(new BigInteger(bf.readLine()));
                //System.out.println("start: " + n);
                String res = String.format(i == 0 ? "Case #%d: %s" : "\nCase #%d: %s", i + 1, tidyNumbers.solve());
                System.out.print(res);
                bw.write(res);
            }
            bw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private String solve() {
        //System.out.println("solving: " + this.N);
        BigInteger last = BigInteger.ZERO;
        for(BigInteger i = this.N; i.compareTo(BigInteger.ZERO) > 0; i=i.subtract(BigInteger.ONE)) {
            if (TidyNumbers.isTidy(i)) {
                return i.toString();
            }
        }
        return last.toString();
    }

    public static boolean isTidy(BigInteger i) {
        String str = i.toString();
        for (int j = 0; j < str.length() -1; j++) {
            if (str.charAt(j) > str.charAt(j + 1)) {
                return false;
            }
        }
        return true;
    }


    public static class HelperClass {

        public static int asInt(String str) {
            return Integer.parseInt(str);
        }

        public static boolean[] toBoolArray(String pancakes) {
            boolean[] onThePan = new boolean[pancakes.length()];
            int index = 0;
            for(char p: pancakes.toCharArray()) {
                onThePan[index++] = p == '+';
            }
            return onThePan;
        }

        public static void main(String... ar) {
            String[] vals = {"8", "123", "555", "224488","20", "321", "495", "999990"};
            for(String val : vals)
                System.out.println("555: " + TidyNumbers.isTidy(new BigInteger(val)));
        }
    }
}
