package com.agustin;

import java.io.*;

public class CountingSheep {
    private static final String INSOMNIA = "INSOMNIA";
    private boolean [] seen;
    public CountingSheep() {}

    private void solveSheep(String fileName, boolean readFile) throws IOException {
        BufferedReader bf;
        BufferedWriter bw = null;
        String SOLUTION_STRING = "Case #%d: %s";
        if (readFile) {
            File file = new File(getClass().getClassLoader().getResource(fileName).getFile());
            File fileOut = new File(file.getName().replace(".in", ".sheep.out"));
            fileOut.createNewFile();
            bw = new BufferedWriter(new FileWriter(fileOut.getAbsoluteFile()));
            bf = new BufferedReader(new InputStreamReader(new FileInputStream(file)));
        } else {
            bf = new BufferedReader(new InputStreamReader(System.in));
        }
        int testCases = Integer.parseInt(bf.readLine());
        int currentCase = 0;
        String input = "";
        while(currentCase < testCases && (input = bf.readLine()) != null) {
            long sol = solveCurrentInput(input);
            String solution = sol < 0 ? INSOMNIA : String.valueOf(sol);
            String ans = String.format(SOLUTION_STRING, ++currentCase, solution);
            if (!readFile) {
                System.out.println(ans);
            }
            else {
                bw.write(ans + "\n");
            }
        }
        if (readFile) {
            bw.close();
        }
    }

    private long solveCurrentInput(String input) {
        long number = Long.parseLong(input);
        if (number == 0) {
            return -1;
        }
        initializeSeenNumbers();
        updateSeenNumbers(input);
        int rounds = 0;
        long next = number;
        while (!hasBleatrixFallAsleep()) {
            next = (++rounds) * number;
            updateSeenNumbers(next + "");
        }
        return next;
    }

    private void updateSeenNumbers(String input) {
        input.chars().forEach(x -> seen[x - 48] = true);
    }

    private boolean hasBleatrixFallAsleep() {
        for (int i = 0; i < seen.length; i++) {
            if (!seen[i]) {
                return false;
            }
        }
        return true;
    }

    private void initializeSeenNumbers() {
        seen = new boolean[10];
        for (int i = 0; i < seen.length; i++) {
            seen[i] = false;
        }
    }

    public static void main(String[] args) throws IOException {
        CountingSheep sheep = new CountingSheep();
        //sheep.solveSheep("", false);
        //sheep.solveSheep("sheeps/test01.txt", true);
        //sheep.solveSheep("sheeps/A-small-attempt0.in", true);
        sheep.solveSheep("sheeps/A-small-attempt1.in", true);
    }
}
