package com.company;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Main {
	static int counter = 0;

	public static void main(String[] args) {
		try {
			Scanner in = new Scanner(new File("input_file.txt"));
			String output = "";
			int amountOfTests = in.nextInt();
			for (int i = 1; i <= amountOfTests; i++) {
				String s = in.next();
				int k = in.nextInt();
				int size = s.length();
				counter = Solve(s, k);
				if (s.length() % size == 0){
					s = optimzeFlipper(s, k);
					int optimizedCounter = Solve(s, k);
					if (optimizedCounter < counter){
						counter = optimizedCounter + 1;
					}
				}
				output += "Case #" + i + ": ";
				if (counter >= 0) {
					output += counter + "\n";
				} else {
					output += "IMPOSSIBLE \n";
				}
				counter = 0;
			}
			FileWriter out = new FileWriter(new File("output_file.txt"));
			out.write(output);
			out.close();
		} catch (IOException e) {
			e.getMessage();
		}
	}
	static int Solve (String s, int k) {
		Pattern complete = Pattern.compile("[+]+{" + s.length() + "}");

		int counter = 0;
		boolean changed;
		do {
			String copyOfInput = s;
			s = flipGroupOfPaddle(s, k);
			changed = !(s.equals(copyOfInput));
			if(changed){
				counter++;
			} else {
				s = flipGroup(s, k);
				changed = !(s.equals(copyOfInput));
				if(changed){
					counter++;
				}
			}
		} while (changed);
		Matcher matcher = complete.matcher(s);
		if (matcher.matches()){
			return counter;
		} else {
			return -1;
		}

	}
	static String optimzeFlipper(String s, int size){
		if (s.length() % size == 0){
			Pattern complete = Pattern.compile("([-])+[+]+{" + size + "}[-]*");
			Matcher matcher = complete.matcher(s);

			while (matcher.find()) {
				if (matcher.group().length() != 0) {
					return flipper(s, matcher.start()+ matcher.group(1).length(), size);
				}
			}
		}
		return s;
	}

	static String flipper(String s, int index, int size) {
		StringBuilder flipped = new StringBuilder(s);
		if (index + size <= s.length()) {
			for (int i = index, n = index + size; i < n; i++) {
				if (s.charAt(i) == '-') {
					flipped.setCharAt(i, '+');
				} else {
					flipped.setCharAt(i, '-');
				}
			}
		}
		return flipped.toString();
	}

	static String flipGroupOfPaddle(String s, int size) {
		Pattern groupOfSize = Pattern.compile("-{" + size + "}");
		Matcher matcher = groupOfSize.matcher(s);
		while (matcher.find()) {
			if (matcher.group().length() != 0) {
				return flipper(s, matcher.start(), size);
			}
		}
		return s;
	}

	static String flipGroup(String s, int size) {
		Pattern groupOfSize = Pattern.compile("([-]+)([+]{0," + (size - 1) + "}[-]*)");
		Matcher matcher = groupOfSize.matcher(s);
		while (matcher.find()) {
			if (matcher.group(1).length() != 0 && matcher.group(2).length() != 0) {
				return flipper(s, matcher.start() + matcher.group(1).length(), size);
			}
		}
		return s;
	}

}