import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class B {
	Scanner sc;
	PrintWriter out;

	public static void main(String[] args) throws IOException {
		new B().run();
	}

	static int idCounter = 1;

	private String solveProblem() throws IOException {
		idCounter = 1;
		ArrayList<Unicorn> unicorns = new ArrayList<>();
		int numUnicorns = sc.nextInt();
		Stable stable = new Stable();
		for (int i = 0; i < 6; ++i) {
			int colorUnicorn = sc.nextInt();
			for (int j = 0; j < colorUnicorn; ++j) {
				switch (i) {
					case 0:
						stable.add('R');
						break;
					case 1:
						stable.add('O');
						break;
					case 2:
						stable.add('Y');
						break;
					case 3:
						stable.add('G');
						break;
					case 4:
						stable.add('B');
						break;
					case 5:
						stable.add('V');
						break;
					default:
						break;
				}
			}
		}
		char firstTry = 'B';
		System.out.println(stable);
		String result = solveTheProblem(unicorns, stable, firstTry, numUnicorns);

		if (result.equals("IMPOSSIBLE")) {
			firstTry = 'Y';
			result = solveTheProblem(unicorns, stable, firstTry, numUnicorns);
		}
		if (result.equals("IMPOSSIBLE")) {
			firstTry = 'R';
			result = solveTheProblem(unicorns, stable, firstTry, numUnicorns);
		}
		if (result.equals("IMPOSSIBLE")) {

			result = solveTheProblem(unicorns, stable, firstTry, numUnicorns);
		}
		return result;
	}

	static String solveTheProblem(ArrayList<Unicorn> unicorns, Stable stable, char firstTry, int numUnicorns) {
		int counter = 0;
		while (!stable.isEmpty()) {
			if (unicorns.size() < counter) {
				break;
			}
			if (counter == 0) {
				unicorns.add(new Unicorn(firstTry));
				stable.subtract(firstTry);
			} else if (unicorns.get(counter - 1).color == 'R') {
				char temp = getMostOfNot(stable, 'R');
				if (!unicorns.add(new Unicorn(temp))) {
					break;
				}
				stable.subtract(temp);


			} else if (unicorns.get(counter - 1).color == 'B') {
				char temp = getMostOfNot(stable, 'B');
				if (!unicorns.add(new Unicorn(temp))) {
					break;
				}
				stable.subtract(temp);

			} else if (unicorns.get(counter - 1).color == 'Y') {
				char temp = getMostOfNot(stable, 'Y');
				if (!unicorns.add(new Unicorn(temp))) {
					break;
				}
				stable.subtract(temp);


			}
			counter++;
		}
		String result = "";
		if (unicorns.size() != numUnicorns) {
			result = "IMPOSSIBLE";
		}
		boolean happyHorses = true;
		for (int i = 0; i < unicorns.size(); ++i) {
			if (i == 0) {
				happyHorses = unicorns.get(i).happyHorse(unicorns.get(unicorns.size() - 1), unicorns.get(i + 1));
			} else if (i == unicorns.size() - 1) {
				happyHorses = unicorns.get(i).happyHorse(unicorns.get(i - 1), unicorns.get(0));
			} else {
				happyHorses = unicorns.get(i).happyHorse(unicorns.get(i - 1), unicorns.get(i + 1));
			}
			if (!happyHorses) {
				break;
			}
		}
		if (happyHorses) {
			for (Unicorn u : unicorns) {
				result += u.toString() + " ";
			}
		} else {
			result = "IMPOSSIBLE";
		}

		System.out.println(unicorns.size());
		System.out.println(numUnicorns);
		if (unicorns.size() != numUnicorns) {
			return "IMPOSSIBLE";
		}
		return result;
	}

	static char getMostOf(Stable s) {
		Iterator it = s.entrySet().iterator();
		char res = ' ';
		int max = 0;
		while (it.hasNext()) {
			Map.Entry pair = (Map.Entry) it.next();
			Integer temp = (Integer) pair.getValue();
			Character tempChar = (Character) pair.getKey();
			if (temp > max) {
				max = temp;
				res = tempChar;
			}
		}
		return res;
	}

	static char getMostOfNot(Stable s, char c) {
		Iterator it = s.entrySet().iterator();
		char res = ' ';
		int max = 0;
		while (it.hasNext()) {
			Map.Entry pair = (Map.Entry) it.next();
			Integer temp = (Integer) pair.getValue();
			Character tempChar = (Character) pair.getKey();
			if (temp > max && tempChar != c) {
				max = temp;
				res = tempChar;
			}
		}
		return res;
	}

	static class Stable extends HashMap<Character, Integer> {
		public Stable() {
		}

		public void add(Character c) {
			if (this.containsKey(c)) {
				this.put(c, this.get(c) + 1);
			} else {
				this.put(c, 1);
			}
		}

		public void subtract(Character c) {
			if (this.containsKey(c)) {
				this.put(c, this.get(c) - 1);
				if (this.get(c) <= 0) {
					this.remove(c);
				}
			}

		}
	}

	private void solve() throws IOException {
		int n = sc.nextInt();
		for (int i = 0; i < n; i++) {
			String result = solveProblem();
			System.out.println("Case #" + (i + 1) + ": " + result);
			out.println("Case #" + (i + 1) + ": " + result);
		}
	}

	private void run() throws FileNotFoundException {
		sc = new Scanner(new File("B-small-attempt5.in"));
		out = new PrintWriter(this.getClass().getSimpleName().substring(0, 1) + ".out");
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.close();
	}

	static class Unicorn implements Comparable<Unicorn> {
		char color;
		int id = idCounter++;

		public Unicorn(char color) {
			this.color = color;
		}

		boolean happyHorse(Unicorn left, Unicorn right) {
			return left.color != this.color && right.color != this.color;
		}

		@Override
		public String toString() {
			return color + "";
		}

		@Override
		public int compareTo(Unicorn u) {
			return this.id - u.id;
		}
	}
}
