import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Scanner;

public class A {
	Scanner sc;
	PrintWriter out;

	public static void main(String[] args) throws IOException{
		new A().run();
	}

	private String solveProblem() throws IOException {
		double distanceToTravel = sc.nextInt();
		int numberOfHorses = sc.nextInt();
		double slowestTimes = 0;
		for(int i = 0; i < numberOfHorses; ++i) {
			double horseDistance = sc.nextInt();
			double horseSpeed = sc.nextInt();
			double difference = distanceToTravel - horseDistance;
			double timeToTravel = difference / horseSpeed;
			slowestTimes = (timeToTravel > slowestTimes) ? timeToTravel : slowestTimes;
		}
		double result = distanceToTravel / slowestTimes;
		NumberFormat formatter = new DecimalFormat("#0.000000");
		String res = formatter.format(result);
		return res;
	}

	private void solve() throws IOException{
		int n = sc.nextInt();
		for(int i = 0; i < n; i++){
			String result = solveProblem();
			System.out.println("Case #" + (i + 1) + ": " + result);
			out.println("Case #" + (i + 1) + ": " + result);
		}
	}

	private void run() throws FileNotFoundException {
		sc = new Scanner(new File("A-small-attempt0 (1).in"));
		out = new PrintWriter(this.getClass().getSimpleName().substring(0,1) + ".out");
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.close();
	}
}
