import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class CookieCounterQ2 {
	
	private static int testCases;
	
	public static void main(String[] args) {
		String [] cookieProblems = readInFile();
		String toFile = "";
		
		for (int caseNo=1;caseNo<=testCases;caseNo++) {
			String [] currentProblem = cookieProblems[caseNo-1].split(" ");
			double factoryCost = Double.parseDouble(currentProblem[0]);
			double extraCPS = Double.parseDouble(currentProblem[1]);
			double target = Double.parseDouble(currentProblem[2]);
			double CPS = 2.0;
			int cookies = 0;
			double timeTaken = 0.0;
			boolean solved = false;
			
			while (!solved) {
				double timeToComplete = target/CPS;
				double completionAfterFactory = (factoryCost/CPS)+(target/(CPS+extraCPS));
				if (timeToComplete>completionAfterFactory) {
					timeTaken +=(factoryCost/CPS);
					CPS+=extraCPS;
				} else {
					timeTaken +=(target/CPS);
					solved=true;
				}
			}
			//System.out.printf("Case #%d: %.7f%n", caseNo, timeTaken);
			toFile+=String.format("Case #%d: %.7f%n", caseNo, timeTaken);
		}				
		
		writeToFile(toFile);
	}
	
	private static void writeToFile(String toFile) {
		File nFile = new File("output.out");
		try {
			FileWriter fw = new FileWriter(nFile);
			fw.write(toFile);
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}		
	}

	private static String[] readInFile() {
		int numLines = 0;
		Scanner scanfIn = null;
		// Opens the file
		try {
			scanfIn = new Scanner(new File("file.in"));
			if (scanfIn.hasNextLine()) {
				testCases = Integer.parseInt(scanfIn.nextLine());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(0);
		}
		
		//Counts the number of lines in the file.
		while (scanfIn.hasNextLine()) {
			scanfIn.nextLine();
			numLines++;
		}
		scanfIn.close();
		
		//Initializes the array with the correct size, determined by the above counting of lines.
		String[] fileContentsHolder = new String[numLines];
		
		// Opens the text file
		try {
			scanfIn = new Scanner(new File("file.in"));
			if (scanfIn.hasNext()) {
				scanfIn.nextLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(0);
		}
		
		//Adds each line of the file to the array.
		int i = 0;
		while (scanfIn.hasNextLine()) {
			fileContentsHolder[i] = scanfIn.nextLine();
			i++;
		}
		
		scanfIn.close();
		
		return fileContentsHolder;
	}

}
