import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.Scanner;


public class DeceitfulWarQ4 {

private static int testCases;
	
	public static void main(String[] args) {
		String [] warProblems = readInFile();
		String toFile = "";
		
		for (int caseNo=1;caseNo<=testCases;caseNo++) {
			int numBlocks = Integer.parseInt(warProblems[0]);
			int warWins = 0;
			int deceptiveWarWins = 0;
			
			String[] naomiBlocks = warProblems[1].split(" ");
			double [] naomiBlocksDouble = new double[numBlocks];
			String[] kenBlocks = warProblems[2].split(" ");
			double [] kenBlocksDouble = new double[numBlocks];
			
			for (int i=0;i<numBlocks;i++) {
				naomiBlocksDouble[i] = Double.parseDouble(naomiBlocks[i]);
				kenBlocksDouble[i] = Double.parseDouble(kenBlocks[i]);
			}
			Arrays.sort(naomiBlocksDouble);
			Arrays.sort(kenBlocksDouble);
			
			ArrayList<Double> nList = new ArrayList<Double>();
			ArrayList<Double> kList = new ArrayList<Double>();
			for( int j = 0; j < numBlocks; j++ ) {
				nList.add(naomiBlocksDouble[j]);
				kList.add(kenBlocksDouble[j]);
			}
			
			Collections.reverse(nList);
			
			//System.out.println(nList+"\n"+kList);
			//real
			for (Double dN: nList){
				//System.out.print(dN);
				if (!kenHasLarger(dN, kList)) {
					warWins++;
				}
			}
			
			nList = new ArrayList<Double>();
			kList = new ArrayList<Double>();
			for( int j = 0; j < naomiBlocksDouble.length; j++ ) {
				nList.add(naomiBlocksDouble[j]);
				kList.add(kenBlocksDouble[j]);
			}
			//System.out.println(nList+"\n"+kList);
			
			//deceptive
			if (numBlocks>1) {				
				if (nList.get(0)>kList.get(0)) {
					deceptiveWarWins++;
					kList.remove(0);
				} else {
					kList.remove(numBlocks-1);
				}
				nList.remove(0);
				Iterator<Double> iterN = nList.iterator();
				while (iterN.hasNext()){
					Double current = iterN.next();
					if (kList.get(0)>current) {
						iterN.remove();
					} else {
						deceptiveWarWins++;
						kList.remove(0);
						iterN.remove();
					}
				}
			} else if (numBlocks==1) {
				deceptiveWarWins=warWins;
			}
			
			System.out.printf("Case #%d: %d %d%n", caseNo, deceptiveWarWins, warWins);
			toFile+=String.format("Case #%d: %d %d%n", caseNo, deceptiveWarWins, warWins);
			warProblems = Arrays.copyOfRange(warProblems, 3, warProblems.length);
		}				
		
		writeToFile(toFile);
	}
	
	private static boolean kenHasLarger(Double dN, ArrayList<Double> kList) {
		Iterator<Double> iterK = kList.iterator();
		while (iterK.hasNext()) {
			Double current = iterK.next();
			if (current>dN) {
				//System.out.println(" Bigger: "+current);
				iterK.remove();
				return true;
			}
		}
		kList.remove(0);
		return false;
	}

	private static void writeToFile(String toFile) {
		File nFile = new File("output.out");
		try {
			FileWriter fw = new FileWriter(nFile);
			fw.write(toFile);
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}		
	}

	private static String[] readInFile() {
		int numLines = 0;
		Scanner scanfIn = null;
		// Opens the file
		try {
			scanfIn = new Scanner(new File("file.in"));
			if (scanfIn.hasNextLine()) {
				testCases = Integer.parseInt(scanfIn.nextLine());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(0);
		}
		
		//Counts the number of lines in the file.
		while (scanfIn.hasNextLine()) {
			scanfIn.nextLine();
			numLines++;
		}
		scanfIn.close();
		
		//Initializes the array with the correct size, determined by the above counting of lines.
		String[] fileContentsHolder = new String[numLines];
		
		// Opens the text file
		try {
			scanfIn = new Scanner(new File("file.in"));
			if (scanfIn.hasNext()) {
				scanfIn.nextLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(0);
		}
		
		//Adds each line of the file to the array.
		int i = 0;
		while (scanfIn.hasNextLine()) {
			fileContentsHolder[i] = scanfIn.nextLine();
			//System.out.println(fileContentsHolder[i]);
			i++;
		}
		
		scanfIn.close();
		
		return fileContentsHolder;
	}

}
