import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;



public class MagicTrickQ1QR {
	
	private static int testCases;

	public static void main(String[] args) {
		String [] cards = readInFile();
		String toFile = "";
		
		for (int i=0;i<testCases;i++) {
			String response = "";
			int firstChoice = Integer.parseInt(cards[0]);
			String firstRow = cards[firstChoice];
			int secondChoice = Integer.parseInt(cards[5]);
			String secondRow = cards[5+secondChoice];
			
			//System.out.println("FC: "+firstChoice+" First Row: "+firstRow+" SC: "+secondChoice+" Second Row: "+secondRow);
			
			if (firstRow.equals(secondRow)) {
				response = "Bad magician!";
				if (testCases>1) {
					cards = Arrays.copyOfRange(cards, 10, cards.length);
				}
			} else {
				String [] firstRowS = firstRow.split(" ");
				String [] secondRowS = secondRow.split(" ");
				ArrayList<String> matches = new ArrayList<String>();
				
				for (String first : firstRowS) {
					int a = Integer.parseInt(first);
					for (int z=0;z<secondRowS.length;z++) {
						int b = Integer.parseInt(secondRowS[z]);
						if (a==b) {
							matches.add(first);
						}						
					}
				}
				if (matches.isEmpty()) {
					response = "Volunteer cheated!";
				} else {
					if (matches.size()==1) {
						response = matches.get(0);
					} else {
						response = "Bad magician!";
					}
				}
				if (testCases>1) {
					cards = Arrays.copyOfRange(cards, 10, cards.length);
				}
			}
			
			toFile+=String.format("Case #%d: %s%n", i+1, response);
			//System.out.println("Response: "+response);
		}
		//System.out.println(toFile);
		writeToFile(toFile);
	}

	private static void writeToFile(String toFile) {
		File nFile = new File("output.out");
		try {
			FileWriter fw = new FileWriter(nFile);
			fw.write(toFile);
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}		
	}

	private static String[] readInFile() {
		int numLines = 0;
		Scanner scanfIn = null;
		// Opens the file
		try {
			scanfIn = new Scanner(new File("file.in"));
			if (scanfIn.hasNextLine()) {
				testCases = Integer.parseInt(scanfIn.nextLine());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(0);
		}
		
		//Counts the number of lines in the file.
		while (scanfIn.hasNextLine()) {
			scanfIn.nextLine();
			numLines++;
		}
		scanfIn.close();
		
		//Initializes the array with the correct size, determined by the above counting of lines.
		String[] fileContentsHolder = new String[numLines];
		
		// Opens the text file
		try {
			scanfIn = new Scanner(new File("file.in"));
			if (scanfIn.hasNext()) {
				scanfIn.nextLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(0);
		}
		
		//Adds each line of the file to the array.
		int i = 0;
		while (scanfIn.hasNextLine()) {
			fileContentsHolder[i] = scanfIn.nextLine();
			i++;
		}
		
		scanfIn.close();
		
		return fileContentsHolder;
	}
	
	

}
