package com.codejam;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.InputStream;
import java.util.Scanner;

enum Result {
	XWon,
	OWon,
	Draw,
	NotCompleted,
}

public class QA {
	public static void main(String args[]) {
		int[][] board = new int[5][5];
		int t;
		boolean hasPoint = false;
		
		FileReader fr;
		try {
			fr = new FileReader("D:\\Development\\Android\\test\\code jam A\\bin\\A-large.in");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		}
		
		Scanner input = new Scanner(fr);
		
		t = input.nextInt();
		input.nextLine();
		String tmpStr;
		
		for(int caseNum = 1; caseNum <= t; caseNum++) {
			hasPoint = false;
			for (int i = 0; i < 4; i++) {
				board[i][4] = 0;
				board[4][i] = 0;
			}
			
			for (int i = 0; i < 4; i++) {
				tmpStr = input.nextLine();
				for (int j = 0; j < 4; j++) {
					board[i][j] = tmpStr.charAt(j);
					board[i][4] += board[i][j];
					board[4][j] += board[i][j];
					if (board[i][j] == '.') {
						hasPoint = true;
					}
				}
			}
			showResult(board, caseNum, hasPoint);
			if(caseNum != t) {
				input.nextLine();
			}
		}
		
	}

	private static void showResult(int[][] board, int num, boolean hasPoint) {
		Result result = Result.NotCompleted;
		int x, y;
		
		x = board[0][0] + board[1][1] + board[2][2] + board[3][3];
		y = board[0][3] + board[1][2] + board[2][1] + board[3][0];
		
		if (x == 352 || x == 348 || 
			y == 352 || y == 348) {
			result = Result.XWon;
		}
		else if (x == 316 || x == 321 || 
				 y == 316 || y == 321) {
			result = Result.OWon;
		}
		else {
			for (int i = 0; i < 4; i++) {
				if (board[i][4] == 352 || board[i][4] == 348 || 
					board[4][i] == 352 || board[4][i] == 348) {
					//showResult(Result.XWon, caseNum);
					result = Result.XWon;
					break;
				}
				else if(board[i][4] == 316 || board[i][4] == 321 || 
						board[4][i] == 316 || board[4][i] == 321) {
					//showResult(Result.OWon, caseNum);
					result = Result.OWon;
					break;
				}
			}
		}
		
		switch (result) {
		case XWon:
			System.out.printf("Case #%d: X won\n", num);
			break;
		case OWon:
			System.out.printf("Case #%d: O won\n", num);
			break;
		default:
			if (hasPoint) {
				System.out.printf("Case #%d: Game has not completed\n", num);
			}
			else {
				System.out.printf("Case #%d: Draw\n", num);
			}
			break;
		}
		
	}
}
