package com.ach.magicTrick;

import com.google.common.base.Function;
import com.google.common.collect.Iterables;
import com.google.common.collect.Sets;
import com.sun.istack.internal.Nullable;
import util.ParserUtil;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Set;

/**
 * Created with IntelliJ IDEA.
 * User: Alex
 * Date: 4/12/14
 * Time: 10:52 AM
 * To change this template use File | Settings | File Templates.
 */
public class MagicTrick {

    String inputFile;
    private int rowCounter;
    private Set<Integer> firstAnswerCards = Sets.newHashSet();
    private Set<Integer> secondAnswerCards = Sets.newHashSet();

    private int totalNumberOfTestCase = 1;
    private int numberOfTestCase = 1;
    private int [] answers = new int [2];
    private boolean isFirstLine = true;
    public MagicTrick(String filename) {
        this.inputFile = filename;
        answers[0] = -1;
        answers[1] = -1;
    }

    public void solve() {


        ParserUtil parserUtil = new ParserUtil(inputFile);

        BufferedReader reader = parserUtil.getReader();
        String line = null;
        try {
            while ( (line = reader.readLine()) != null) {
                String [] parsedLine = line.split(" ");
                if (isFirstLine) {
                    totalNumberOfTestCase = Integer.valueOf(parsedLine[0]);
                    isFirstLine = false;

                } else {

                    if (parsedLine.length == 1) {
                        rowCounter = 1;
                        if (answers[0] == -1) {
                            answers[0] = Integer.valueOf(parsedLine[0]);
                            answers[1] = -1;
                        } else {
                            answers[1] = Integer.valueOf(parsedLine[0]);
                            answers[0] = -1;
                        }

                    } else {
                        if (matchFirstAnswer(rowCounter)) {
                            firstAnswerCards.clear();
                            firstAnswerCards.addAll( Sets.newHashSet(Iterables.transform(Arrays.asList(parsedLine), new Function<String, Integer>() {
                                @Override
                                public Integer apply(@Nullable java.lang.String s) {
                                    return Integer.valueOf(s);
                                }
                            })));
                        } else if (matchSecondAnswer(rowCounter)) {
                            secondAnswerCards.clear();
                            secondAnswerCards.addAll( Sets.newHashSet(Iterables.transform(Arrays.asList(parsedLine), new Function<String, Integer>() {
                                @Override
                                public Integer apply(@Nullable java.lang.String s) {
                                    return Integer.valueOf(s);
                                }
                            })));
                            Set<Integer> trueAnswer = Sets.newHashSet();
                            trueAnswer = Sets.intersection(firstAnswerCards, secondAnswerCards);
                            outpuResult(trueAnswer);
                        }
                        rowCounter++;
                    }

                }
            }
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }


    private boolean matchFirstAnswer(int currentRowNum) {
        boolean result = false;
        if (answers[0] == -1 && answers[1] == -1) {
            System.out.println("logic wrong, no answers!!");
        } else if (answers[0] != -1 && answers[1] != -1) {
            System.out.println("logic wrong, has both answers!!");
        } else if (answers[0] != -1 && answers[0] == currentRowNum) {
            result = true;
        }
        return result;
    }

    private boolean matchSecondAnswer(int currentRowNum) {
        boolean result = false;
        if (answers[0] == -1 && answers[1] == -1) {
            System.out.println("logic wrong, no answers!!");
        } else if (answers[0] != -1 && answers[1] != -1) {
            System.out.println("logic wrong, has both answers!!");
        } else if (answers[1] != -1 && answers[1] == currentRowNum) {
            result = true;
        }
        return result;
    }

    private void outpuResult(Set<Integer> ans) {
        if (ans.isEmpty()) {
            System.out.println("Case #"+numberOfTestCase+": Volunteer cheated!");
        } else if (ans.size() > 1) {
            System.out.println("Case #"+numberOfTestCase+": Bad magician!");
        } else if (ans.size() == 1) {
            System.out.println("Case #"+numberOfTestCase+": "+ans.iterator().next());
        }
        numberOfTestCase++;
    }
}
