package GSIT;

import java.io.*;
import java.util.HashMap;

/**
 *
 * @author alexho
 */
public class GSIT {

    private static String [] inputArr;
    private static HashMap<Character, Character> Gl = new HashMap<Character, Character>();
  
    private static void readInput (String infn) {
        
        BufferedReader bufRdr = null;
        int testCases = 0;
        
        try {
            File file = new File(infn);
            bufRdr = new BufferedReader(new FileReader(file));            
            
            testCases = Integer.valueOf(bufRdr.readLine());
            GSIT.inputArr = new String [testCases];
            
            for (int i=0;i<testCases;i++) {
                GSIT.inputArr[i] = bufRdr.readLine();
            }
            
            bufRdr.close();
            
        } catch (IOException ex) {

        }

        
    }
    
    private static void init() {
        
        String input0 = "y qee";
        String input1 = "ejp mysljylc kd kxveddknmc re jsicpdrysi";
        String input2 = "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd";
        String input3 = "de kr kd eoya kw aej tysr re ujdr lkgc jv";
        
        String output0 = "a zoo";
        String output1 = "our language is impossible to understand";
        String output2 = "there are twenty six factorial possibilities";
        String output3 = "so it is okay if you want to just give up";
        
        for (int i=0;i<input0.length();i++) {
            if (!GSIT.Gl.containsKey(input0.charAt(i)))
                GSIT.Gl.put(input0.charAt(i), output0.charAt(i));            
        }
        
        for (int i=0;i<input1.length();i++) {
            if (!GSIT.Gl.containsKey(input1.charAt(i)))
                GSIT.Gl.put(input1.charAt(i), output1.charAt(i));            
        }
        
        for (int i=0;i<input2.length();i++) {
            if (!GSIT.Gl.containsKey(input2.charAt(i)))
                GSIT.Gl.put(input2.charAt(i), output2.charAt(i));            
        }
        
        for (int i=0;i<input3.length();i++) {
            if (!GSIT.Gl.containsKey(input3.charAt(i)))
                GSIT.Gl.put(input3.charAt(i), output3.charAt(i));            
        }

        GSIT.Gl.put('z', 'q');
    }
    
    private static void output (String outfn) throws IOException {
        PrintWriter out = new PrintWriter(new FileWriter(outfn));
        for (int i=0;i<GSIT.inputArr.length;i++) {
            out.print("Case #"+(i+1)+": ");
            for (int j=0;j<GSIT.inputArr[i].length();j++) {
                out.print(GSIT.Gl.get(GSIT.inputArr[i].charAt(j)));
            }
            out.print("\n");
        }
        out.close();        
    }
    
    /**
     * @param args the command line arguments
     * args[0]: input file name
     * args[1]: output file name
     * Example: main input.txt output.txt
     */
    public static void main(String[] args) throws IOException {
        
        String infn = args[0];
        String outfn = args[1];
        GSIT.init();                
        GSIT.readInput(infn);
        GSIT.output(outfn);
 
        
    }
}
