

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.*;

/**
 * Created by Aaron on 4/9/2016.
 */
public class ProblemC {
    public static void main(String[] args) throws FileNotFoundException {
        ProblemC problem = new ProblemC();
        Scanner in = new Scanner(new File("C:\\Users\\Aaron\\IdeaProjects\\GoogleCodeJam\\src\\inputC4.txt"));
        ArrayList<String> inputs = new ArrayList<>();
        int numcases = Integer.parseInt(in.nextLine());
        PrintWriter out = new PrintWriter("C:\\Users\\Aaron\\IdeaProjects\\GoogleCodeJam\\src\\outputC.txt");
        if (numcases > 0) {
            while (in.hasNextLine()) {
                inputs.add(in.nextLine());
            }
        }
        String command = inputs.get(0);
        String[] query = command.split(" ");
        int numoutputs = Integer.parseInt(query[1]);
        int length = Integer.parseInt(query[0]);
        List<String> answers = problem.solver(length);
        out.println("Case #"+"1"+":");

        int counter = 0;
        for (String s : answers) {
            int[] exponents = problem.getExponents(s, s.length());
            ArrayList<String> divisorsList = new ArrayList<>();
            String divisors = "";
            String actuals = "";
            for (int i = 2; i <= 10; i++) {
                divisorsList.add((problem.returnDivisor(i, exponents)).toString());
                divisors += " " + (problem.returnDivisor(i, exponents)).toString();
                actuals += " " + (problem.getNumber(i, exponents)).toString();
            }
            if (!divisorsList.contains("0") && counter < numoutputs) {
                out.println("1" + s + "1" + divisors);
                ++counter;
            }
        }
        out.flush();
        out.close();
    }
    public List<String> solver(int length) {
        char[] bits = new char[length-2];
        Arrays.fill(bits, '0');
        String number = new String(bits);
        Set<String> answers = new HashSet<>();
        for(int i = 0; i < length-2; i+=2) {
            answers.addAll(permutations(length - 2, i, number));
        }
        ArrayList<String> answerslist = new ArrayList<>();
        answerslist.addAll(answers);
        return answerslist;
    }
    public Set<String> permutations(int length, int startingPoint, String number) {
        Set<String> outputs = new HashSet<>();
        if(startingPoint >= length - 1) return outputs;
        else {
            StringBuilder numberBuilder = new StringBuilder(number);
            numberBuilder.setCharAt(startingPoint, '1');
            for(int i = startingPoint+1; i < length; ++i) {
                numberBuilder.setCharAt(i, '1');
                String testString = numberBuilder.toString();
                if (test(testString, length)) {
                    outputs.add(testString);
                }
                outputs.addAll(permutations(length, i+1, number));
                outputs.addAll(permutations(length, i+1, testString));
            }
        }
        return outputs;
    }
    public boolean test(String number, int length) {
        int[] exponents = getExponents(number, length);
        int base = 2;
        while(!checkPrime(base, exponents) && base<=10) {
            base+=1;
        }
        return base >= 10;
    }
    public int[] getExponents(String number, int length) {
        int[] exponents = new int[number.replace("0", "").length()+2];
        exponents[1] = length+1;
        exponents[0] = 0;
        int index = 2;
        for(int i = 0; i < length && index < exponents.length; ++i) {
            if(number.charAt(i) == '1') {
                exponents[index] = length-i;
                ++index;
            }
        }
        return exponents;
    }
    public boolean checkPrime(int base, int[] exponents) {
        BigInteger number = getNumber(base, exponents);
        return number.mod(new BigInteger("2")).compareTo(new BigInteger("0")) != 0 && isPrime(number);
    }
    public static boolean isPrime(BigInteger num) {
        if (num.compareTo(new BigInteger("2")) == 1 &&
                num.mod(new BigInteger("2")).compareTo(BigInteger.ZERO) == 0) {
            //System.out.println(num + " is not prime");
            return false;
        }
        BigInteger top = bigIntSqRootFloor(num).add(BigInteger.ONE);
        for (BigInteger i = new BigInteger("3"); i.compareTo(top) == -1; i = i.add(new BigInteger("2"))) {
            if (num.mod(BigInteger.ONE).compareTo(BigInteger.ZERO) == 0) {
                //System.out.println(num + " is not prime");
                return false;
            }
        }
        //System.out.println(num + " is prime");
        return true;
    }
    /*public static boolean isPrime(BigInteger num) {
        return num.compareTo(new BigInteger("2")) == 1 &&
                num.mod(new BigInteger("2")).compareTo(new BigInteger("0")) == 0;
    }*/
    public BigInteger getNumber(int base, int[] exponents) {
        BigInteger number = new BigInteger("0");
        for (int exponent : exponents) {
            number = number.add(new BigInteger(Integer.toString((int)Math.pow((double) base, (double) exponent))));
        }
        return number;
    }
    public BigInteger returnDivisor(int base, int[] exponents) {
        BigInteger number = getNumber(base, exponents);
        BigInteger sqrt = bigIntSqRootFloor(number);
        for (BigInteger i = new BigInteger("2"); i.compareTo(sqrt) == -1;
                i = i.add(new BigInteger("1"))) {
            if (number.mod(i).compareTo(new BigInteger("0")) == 0) return i;
        }
        return new BigInteger("0");
    }
    public static BigInteger bigIntSqRootFloor(BigInteger x)
            throws IllegalArgumentException {
        if (x.compareTo(BigInteger.ZERO) < 0) {
            throw new IllegalArgumentException("Negative argument.");
        }
        // square roots of 0 and 1 are trivial and
        // y == 0 will cause a divide-by-zero exception
        if (x .equals(BigInteger.ZERO) || x.equals(BigInteger.ONE)) {
            return x;
        } // end if
        BigInteger two = BigInteger.valueOf(2L);
        BigInteger y;
        // starting with y = x / 2 avoids magnitude issues with x squared
        for (y = x.divide(two);
             y.compareTo(x.divide(y)) > 0;
             y = ((x.divide(y)).add(y)).divide(two));
        return y;
    }
}
