import com.sun.deploy.util.ArrayUtil;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;
import java.util.stream.Stream;

/**
 * Created by achen on 4/7/2017.
 */
public class Qualification {
    public void A(String[] args, int num, PrintWriter writer) {
        int k = Integer.parseInt(args[1]);
        String s = args[0];
        int solution = recursiveflipper(s, k, 0, 0);
//        int count = 0;
//        int index = 0;
//        while(s.contains("+") && s.contains("-")) {
//            char[] chars = s.toCharArray();
//        }
        writer.println(String.format(Locale.ENGLISH, "Case #%d: %s", num, (solution != Integer.MAX_VALUE) ? Integer.toString(solution) : "IMPOSSIBLE"));
    }

    public int recursiveflipper(String s, int k, int i, int count) {
        if((s.contains("-"))) {
            //case: has - but flipper size = # of pancakes
            if(k==s.length()) return Integer.MAX_VALUE;
            if(i > s.length()-k) {
                return Integer.MAX_VALUE;
            } else {
                int flip = recursiveflipper(flipperHelper(s, i, i + k - 1), k, i + 1, count + 1);
                int noflip = recursiveflipper(s, k, i + 1, count);
                return Math.min(flip, noflip);
            }
        } else {
            return count;
        }
    }

    public String flipperHelper(String s, int start, int end) {
        StringBuilder builder = new StringBuilder(s);
        for(int i=start; i<=end; ++i) {
            if(builder.charAt(i) == '+') {
                builder.setCharAt(i, '-');
            } else {
                builder.setCharAt(i, '+');
            }
        }

        return builder.toString();
    }

    public void B(String N, int num, PrintWriter writer) {
        char[] n = N.toCharArray();
        int[] digits = N.chars().toArray();

        for(int i=0; i<n.length;++i){
            digits[i] = Character.getNumericValue(n[i]);
        }

        if(isTidy(n)) writer.println(String.format(Locale.ENGLISH, "Case #%d: %s", num, Integer.parseInt(N)));
        else {
            for (int i = digits.length - 1; i > 0; --i) {
                if (digits[i] < digits[i - 1]) {
                    for (int j = i; j < digits.length; ++j) {
                        digits[j] = 9;
                    }
                    digits[i - 1] -= 1;
                }
            }
            StringBuilder b = new StringBuilder();
            Arrays.stream(digits).forEach(b::append);
            writer.println(String.format(Locale.ENGLISH, "Case #%d: %d", num, Long.parseLong(b.toString())));
        }
    }

    public boolean isTidy(char[] n) {
        int i = 0;
        int largestDigit = 0;
        while(i < n.length) {
            if(Character.getNumericValue(n[i]) >= largestDigit) {
                largestDigit = n[i];
                i++;
            } else {
                return false;
            }
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        Qualification q = new Qualification();

        String inputFile = "b_small_input.txt";
        String outputFile = "solutionB.txt";

        BufferedReader reader = new BufferedReader(new FileReader(inputFile));
        PrintWriter writer = new PrintWriter(outputFile, "UTF-8");

        //# of cases
        int T = Integer.parseInt(reader.readLine());

        //Oversized Pancake Flipper
//        for (int i=0; i<T; ++i) {
//            q.A(reader.readLine().split(" "), i+1, writer);
//        }
//        writer.close();

        //Tidy Numbers
        for (int i=0; i<T; ++i) {
            q.B(reader.readLine(), i+1, writer);
        }
        writer.close();
    }
}
