import com.sun.deploy.util.ArrayUtil;

import java.io.*;
import java.util.*;
import java.util.stream.Stream;

/**
 * Created by achen on 4/7/2017.
 */
public class Qualification {
    public void A(String[] args, int num, PrintWriter writer) {
        int k = Integer.parseInt(args[1]);
        String s = args[0];
        int solution = recursiveflipper(s, k, 0, 0);

        writer.println(String.format(Locale.ENGLISH, "Case #%d: %s", num, (solution != Integer.MAX_VALUE) ? Integer.toString(solution) : "IMPOSSIBLE"));
    }

    public void largeA(String[] args, int num, PrintWriter writer) {
        int k = Integer.parseInt(args[1]);
        String s = args[0];
        ArrayList<String> list = new ArrayList<>();
        for(int i=0; i<s.length();++i) {
            list.add(String.valueOf(s.charAt(i)));
        }
        int solution = recursiveLargeA(list, k, 0);
        writer.println(String.format(Locale.ENGLISH, "Case #%d: %s", num, (solution != Integer.MAX_VALUE) ? Integer.toString(solution) : "IMPOSSIBLE"));
    }

    public int recursiveLargeA(ArrayList<String> s, int k, int count) {
        while(Objects.equals(s.get(0), "+")) {
            s.remove(0);
            if(s.size() == 0) return count;
        }
//        if(Objects.equals(s.get(0), "+")) {
//            s.remove(0);
//        }
        if(Objects.equals(s.get(s.size()-1), "+")) {
            s.remove(s.size()-1);
        }
        if(s.contains("-")) {
            if(s.size() >= k) {
                for (int i = 0; i < k; ++i) {
                    s.set(i, Objects.equals(s.get(i), "+") ? "-" : "+");
                }
                count += 1;
                return recursiveLargeA(s, k, count);
            } else {
                return Integer.MAX_VALUE;
            }
        } else {
            return count;
        }

    }

    public int recursiveflipper(String s, int k, int i, int count) {
        if((s.contains("-"))) {
            //case: has - but flipper size = # of pancakes
            if(k==s.length()) return Integer.MAX_VALUE;
            if(i > s.length()-k) {
                return Integer.MAX_VALUE;
            } else {
                int flip = recursiveflipper(flipperHelper(s, i, i + k - 1), k, i + 1, count + 1);
                int noflip = recursiveflipper(s, k, i + 1, count);
                return Math.min(flip, noflip);
            }
        } else {
            return count;
        }
    }

    public String flipperHelper(String s, int start, int end) {
        StringBuilder builder = new StringBuilder(s);
        for(int i=start; i<=end; ++i) {
            if(builder.charAt(i) == '+') {
                builder.setCharAt(i, '-');
            } else {
                builder.setCharAt(i, '+');
            }
        }

        return builder.toString();
    }

    public void B(String N, int num, PrintWriter writer) {
        char[] n = N.toCharArray();
        int[] digits = N.chars().toArray();

        for(int i=0; i<n.length;++i){
            digits[i] = Character.getNumericValue(n[i]);
        }

        if(isTidy(n)) writer.println(String.format(Locale.ENGLISH, "Case #%d: %s", num, Integer.parseInt(N)));
        else {
            for (int i = digits.length - 1; i > 0; --i) {
                if (digits[i] < digits[i - 1]) {
                    for (int j = i; j < digits.length; ++j) {
                        digits[j] = 9;
                    }
                    digits[i - 1] -= 1;
                }
            }
            StringBuilder b = new StringBuilder();
            Arrays.stream(digits).forEach(b::append);
            writer.println(String.format(Locale.ENGLISH, "Case #%d: %d", num, Long.parseLong(b.toString())));
        }
    }

    public boolean isTidy(char[] n) {
        int i = 0;
        int largestDigit = 0;
        while(i < n.length) {
            if(Character.getNumericValue(n[i]) >= largestDigit) {
                largestDigit = n[i];
                i++;
            } else {
                return false;
            }
        }
        return true;
    }

    public void C(String[] args, int num, PrintWriter writer) {
        int n = Integer.parseInt(args[0]);
        int k = Integer.parseInt(args[1]);

        ArrayList<Integer> stalls = new ArrayList<>();
        stalls.add(n);
        recursiveC(stalls, k, 1, writer, num);
//        for(int i=0; i<n; ++i) {
//            if(i == Math.floor((n-1)/2)) stalls.set(i, 0);
//            else stalls.set(i, 1);
//        }
        //1st person = Math.floor(n-1/2)
    }

    public void recursiveC(ArrayList<Integer> stalls, int k, int i, PrintWriter writer, int num) {
       if (i <= k) {
           int n = stalls.get(0);
           int min = (int)Math.floor((n-1)/2);
           int max = n%2==0 ? n/2 : min;
           if (i==k) writer.println(String.format(Locale.ENGLISH, "Case #%d: %d %d", num, max, min));
           else {
               stalls.remove(0);
               stalls.add(max);
               stalls.add(min);
               Collections.sort(stalls);
               Collections.reverse(stalls);
               recursiveC(stalls, k, i+1, writer, num);
           }
           //int level = (int)Math.floor(n/((Math.pow(2, log(i,2)))+1));
       }
    }


    public double log(int x, int base) {
        return Math.floor(Math.log(x) / Math.log(base));
    }

    public static void main(String[] args) throws IOException {
        Qualification q = new Qualification();

        String inputFile = "c_small_input.txt";
        String outputFile = "solutionC.txt";

        BufferedReader reader = new BufferedReader(new FileReader(inputFile));
        PrintWriter writer = new PrintWriter(outputFile, "UTF-8");

        //# of cases
        int T = Integer.parseInt(reader.readLine());

        //Oversized Pancake Flipper
//        for (int i=0; i<T; ++i) {
//            q.A(reader.readLine().split(" "), i+1, writer);
//        }
//        writer.close();

        //Tidy Numbers
//        for (int i=0; i<T; ++i) {
//            q.B(reader.readLine(), i+1, writer);
//        }
//        writer.close();

        //Oversized Pancake Flipper Large Data Sets
//        for (int i=0; i<T; ++i) {
//            q.largeA(reader.readLine().split(" "), i+1, writer);
//        }
//        writer.close();

        //Bathroom Stalls
        for (int i=0; i<T; ++i) {
            q.C(reader.readLine().split(" "), i+1, writer);
        }
        writer.close();
    }
}
