import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class RankAndFile {

    private static String set = "B-small-attempt0";
    private static String projectPath = "CodeJam2016Round1A/src/";
    private static String inputFile = projectPath + set + ".in";
    private static String outputFile = projectPath + set + ".out";

    private Scanner in;
    private PrintStream out;

    public static void main(String[] args) throws IOException {
        new RankAndFile().run();
    }

    private void solve() {
        int N = in.nextInt();
        int[][] rows = new int[2 * N - 1][N];
        for (int i = 0; i < 2 * N - 1; i++) {
            for (int j = 0; j < N; j++) {
                rows[i][j] = in.nextInt();
            }
        }

        int[][] board = new int[N][N];
        boolean used[] = new boolean[2 * N - 1];
        ResultWrapper resultWrapper = backtrack(board, rows, used, 0, N);
        for (int i = 0; i < resultWrapper.data.length; i++) {
            out.printf(" %d", resultWrapper.data[i]);
        }
        out.append('\n');
    }

    private ResultWrapper backtrack(int[][] board, int[][] rows, boolean[] used, int currRow, int N) {
        for (int i = 0; i < 2 * N - 1; i++) {
            if (used[i]) {
                continue;
            }
            if (currRow == 0 || smaller(board[currRow - 1], rows[i])) {
                board[currRow] = rows[i];
                used[i] = true;
                if (currRow == N - 1) {
                    ResultWrapper valid = validateBoard(board, rows);
                    if (valid.result) {
                        return valid;
                    } else {
                        used[i] = false;
                        continue;
                    }
                }
                ResultWrapper backtrack = backtrack(board, rows, used, currRow + 1, N);
                if (backtrack.result) {
                    return backtrack;
                } else {
                    used[i] = false;
                }
            }
        }
        return new ResultWrapper(false, null);
    }

    private ResultWrapper validateBoard(int[][] board, int[][] rows) {
        int notFound = -1;
        boolean founds[] = new boolean[rows.length];
        for (int i = 0; i < rows.length + 1; i++) {
            boolean found = false;
            for (int j = 0; j < rows.length; j++) {
                if (!founds[j] &&Arrays.equals(getAsRow(board, i), rows[j])) {
                    found = true;
                    founds[j] = true;
                    break;
                }
            }
            if (!found) {
                if (notFound == -1) {
                    notFound = i;
                } else {
                    return new ResultWrapper(false, null);
                }
            }
        }
        return new ResultWrapper(true, getAsRow(board, notFound));
    }

    private int[] getAsRow(int[][] board, int idx) {
        if (idx < board.length) {
            return board[idx];
        } else {
            int res[] = new int[board.length];
            for (int i = 0; i < res.length; i++) {
                res[i] = board[i][idx - board.length];
            }
            return res;
        }
    }

    static class ResultWrapper {
        boolean result;
        int[] data;

        ResultWrapper(boolean result, int[] data) {
            this.result = result;
            this.data = data;
        }
    }

    private boolean smaller(int[] A, int[] B) {
        for (int i = 0; i < A.length; i++) {
            if (A[i] >= B[i]) {
                return false;
            }
        }
        return true;
    }

    public void run() throws IOException {
        in = new Scanner(new File(inputFile));
        out = new PrintStream(new File(outputFile));
//        out = System.out;
        int cases = in.nextInt();
        in.nextLine();

        for (int i = 0; i < cases; i++) {
            out.printf("Case #%d:", i + 1);
            solve();
        }

        in.close();
        out.close();
    }
}
