import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class CloseMatch {

    private static String set = "B-small-attempt0";
    private static String projectPath = "CodeJam2016Round1B/src/";
    private static String inputFile = projectPath + set + ".in";
    private static String outputFile = projectPath + set + ".out";

    private Scanner in;
    private PrintStream out;

    public static void main(String[] args) throws IOException {
        new CloseMatch().run();
    }

    private void solve() {
        String C = in.next();
        String J = in.next();
        in.nextLine();

        StringBuilder solC = new StringBuilder();
        StringBuilder solJ = new StringBuilder();

        int status = 0; // 0 draw, + C leading, - J leading
        for (int i = 0; i < C.length(); i++) {
            char c = C.charAt(i);
            char j = J.charAt(i);

            if (c != '?' && j != '?') {
                status = status == 0 ? (c - j) : status;
                solC.append(c);
                solJ.append(j);
            } else if (c == '?' && j == '?') {
                if (status == 0) {
                    solC.append('0');
                    solJ.append('0');
                } else {
                    solC.append(status > 0 ? '0' : '9');
                    solJ.append(status > 0 ? '9' : '0');
                }
            } else {
                if (status == 0) {
                    solC.append(c == '?' ? j : c);
                    solJ.append(c == '?' ? j : c);
                } else {
                    solC.append(c == '?' ? (status > 0 ? '0' : '9') : c);
                    solJ.append(c == '?' ? j : (status > 0 ? '9' : '0'));
                }
            }
        }

        out.printf(" %s %s\n", solC.toString(), solJ.toString());
    }

    public void run() throws IOException {
        in = new Scanner(new File(inputFile));
        out = new PrintStream(new File(outputFile));
//        out = System.out;
        int cases = in.nextInt();
        in.nextLine();

        for (int i = 0; i < cases; i++) {
            out.printf("Case #%d:", i + 1);
            solve();
        }

        in.close();
        out.close();
    }
}
