import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class CoinJam {

    private static String set = "C-small";
    private static String projectPath = "CodeJam2016Qualification/src/";
    private static String inputFile = projectPath + set + ".in";
    private static String outputFile = projectPath + set + ".out";

    private Scanner in;
    private PrintStream out;

    public static void main(String[] args) throws IOException {
        new CoinJam().run();
    }

    public static Integer nontrivialDivisor(long n) {
        for (int i = 2; i <= n / i; i++) {
            if (n % i == 0) {
                return i;
            }
        }

        return null;
    }

    class JamGenerator {

        int curr;
        int n;

        JamGenerator(int n) {
            this.n = n;
            this.curr = 0;
        }

        String next() {
            StringBuilder line = new StringBuilder();

            while (true) {
                StringBuilder sb = new StringBuilder();
                sb.append('1');
                sb.append(String.format("%" + (n - 2) + "s", Integer.toBinaryString(curr++)).replace(' ', '0'));
                sb.append('1');

                String jam = sb.toString();
                line.append(jam);
                boolean isSol = true;
                for (int base = 2; base <= 10; base++) {
                    long i = Long.parseLong(jam, base);
                    Integer divisor = nontrivialDivisor(i);
                    if (divisor == null) {
                        isSol = false;
                        line.setLength(0);
                        break;
                    } else {
                        line.append(' ');
                        line.append(divisor);
                    }
                }
                if (isSol) {
                    return line.toString();
                }
            }
        }
    }

    private void solve(int n, int j, int caseNo) {
        JamGenerator jamGenerator = new JamGenerator(n);
        out.printf("Case #%d:\n", caseNo);
        for (int jamNo = 0; jamNo < j; jamNo++) {
            out.println(jamGenerator.next());
        }
    }

    public void run() throws IOException {
        in = new Scanner(new File(inputFile));
        out = new PrintStream(new File(outputFile));
//        out = System.out;
        int cases = in.nextInt();
        in.nextLine();

        for (int i = 0; i < cases; i++) {
            solve(in.nextInt(), in.nextInt(), i+1);
        }

        in.close();
        out.close();
    }
}
