import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class GettingTheDigits {

    private static String set = "A-small-attempt1";
    private static String projectPath = "CodeJam2016Round1B/src/";
    private static String inputFile = projectPath + set + ".in";
    private static String outputFile = projectPath + set + ".out";

    private Scanner in;
    private PrintStream out;

    private static String[] digitsEng;
    private static int[] digits;
    private static HashMap<Character, Set<Integer>> letterFreq;

    public static void main(String[] args) throws IOException {
        digitsEng = new String[]{
                "ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"
        };
        digits = new int[] {0,1,2,3,4,5,6,7,8,9};

        letterFreq = new HashMap<>();
        for (int i = 0; i < digits.length; i++) {
            for (char c : digitsEng[i].toCharArray()) {
                Set<Integer> set = letterFreq.getOrDefault(c, new HashSet<>());
                set.add(i);
                letterFreq.put(c, set);
            }
        }
        new GettingTheDigits().run();
    }

    private void solve() {
        String word = in.nextLine();

        String sol = backtrack(word, "");
        char[] chars = sol.toCharArray();
        Arrays.sort(chars);
        String sortedSol = new String(chars);
        out.printf(" %s\n", sortedSol);
    }

    private String backtrack(String word, String curr) {
        if (word.isEmpty()) {
            return curr;
        }
        Set<Integer> set = letterFreq.get(word.charAt(0));
        for (Integer digit : set) {
            String newWord = word;

            boolean digitNotexists = false;
            for (char digitChar : digitsEng[digit].toCharArray()) {
                if (!newWord.contains(digitChar + "")) {
                    digitNotexists = true;
                    break;
                }
                newWord = newWord.replaceFirst(digitChar + "", "");
            }
            if (digitNotexists) {
                continue;
            }
            curr += digit;
            String subSol = backtrack(newWord, curr);
            if (subSol != null) {
                return subSol;
            } else {
                curr = curr.substring(0, curr.length() - 1);
            }
        }
        return null;
    }

    public void run() throws IOException {
        in = new Scanner(new File(inputFile));
        out = new PrintStream(new File(outputFile));
//        out = System.out;
        int cases = in.nextInt();
        in.nextLine();

        for (int i = 0; i < cases; i++) {
            out.printf("Case #%d:", i + 1);
            solve();
        }

        in.close();
        out.close();
    }
}
