import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class SenateEvacuation {

    private static String set = "A-small-attempt0";
    private static String projectPath = "CodeJam2016Round1C/resources/";
    private static String inputFile = projectPath + set + ".in";
    private static String outputFile = projectPath + set + ".out";

    private Scanner in;
    private PrintStream out;

    public static void main(String[] args) throws IOException {
        new SenateEvacuation().run();
    }

    private void solve() {
        int N = in.nextInt();
        int[] arr = new int[N];

        for (int i = 0; i < N; i++) {
            arr[i] = in.nextInt();
        }

        List<Integer> maxIndex = new ArrayList<>();
        while (true) {
            int max = -1;
            maxIndex.clear();

            for (int i = 0; i < arr.length; i++) {
                int senator = arr[i];
                if (senator > 0 && senator > max) {
                    max = senator;
                    maxIndex.clear();
                    maxIndex.add(i);
                } else if (senator == max) {
                    maxIndex.add(i);
                }
            }

            int maxCount = maxIndex.size();

            if (maxCount == 0) {
                break;
            }

            if (maxCount % 2 == 1) {
                out.printf(" %s", (char)('A' + maxIndex.get(maxCount - 1)));
                arr[maxIndex.get(maxCount - 1)]--;
            }
            for (int i = 0; i < maxCount - 1; i+=2) {
                out.printf(" %s%s", (char)('A' + maxIndex.get(i)), (char)('A' + maxIndex.get(i+1)));
                arr[maxIndex.get(i)]--;
                arr[maxIndex.get(i+1)]--;
            }
        }

        out.printf("\n");
    }

    public void run() throws IOException {
        in = new Scanner(new File(inputFile));
        out = new MyPrintStream(new File(outputFile));
        int cases = in.nextInt();
        in.nextLine();

        for (int i = 0; i < cases; i++) {
            out.printf("Case #%d:", i + 1);
            solve();
        }

        in.close();
        out.close();
    }

    static class MyPrintStream extends PrintStream {

        public MyPrintStream(File file) throws FileNotFoundException {
            super(file);
        }

        @Override
        @SuppressWarnings("NullableProblems")
        public PrintStream printf(String format, Object... args) {
            System.out.printf(format, args);
            return super.printf(format, args);
        }
    }
}
