package fairandsquare;

import java.io.*;

public class FairAndSquare {

	public static void main(String[] args) {

		try (FileInputStream fstream = new FileInputStream("input");
				DataInputStream in = new DataInputStream(fstream);
				BufferedReader br = new BufferedReader(new InputStreamReader(in));
				){
			int numTestCases = Integer.parseInt(br.readLine());
			for (int i = 0; i < numTestCases; i++) {
				String testline = br.readLine();
				int space = testline.indexOf(" ");
				int lowerbound = Integer.parseInt(testline.substring(0, space));
				int upperbound = Integer.parseInt(testline.substring(space + 1));
				int numFairAndSquare = handleTestCase(lowerbound, upperbound);
				//System.out.printf("Lower bound %d, Upper bound %d\n", lowerbound, upperbound);
				System.out.printf("Case #%d: %d\n", (i+1), numFairAndSquare);
			}


		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static int handleTestCase(int lowerbound, int upperbound) {
		int numFairAndSquare = 0;
		//int numSquaresChecked = 0;
		for (int i = 1; i <= upperbound; i++) {
			int square = i*i;
			if (square < lowerbound)
				continue;
			else if (square > upperbound)
				break;
			else {
				//numSquaresChecked++;
				if (checkPalindromes(i, square)) {
					numFairAndSquare++;
				}
			}
		}
		//System.out.printf("Num squares checked %d\n", numSquaresChecked);
		return numFairAndSquare;
	}

	private static boolean checkPalindromes(int i, int square) {
		if (isPalindrome(i) && isPalindrome(square))
			return true;
		return false;
	}

	private static boolean isPalindrome(int number) {
		int original = number;
		int reverse = 0;
		while (number > 0) {
			int remain = number % 10;
			number = number / 10;
			reverse = reverse * 10 + remain;
		}
		return reverse == original;
	}
}


