package com.google.code.jam;

import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;
import java.util.stream.Stream;

import com.google.common.collect.Lists;

public class Bleatrix {

	public static void main(String[] args) throws Exception {
		String fileName = args[0];

		long startTime = System.currentTimeMillis();
		
		final AtomicInteger i = new AtomicInteger(0);
		try (Stream<String> stream = Files.lines(Paths.get(fileName))) {
			List<String> lines = stream.map(line -> consumeLine(i.incrementAndGet(), line))
					.collect(Collectors.toList());
			Files.write(Paths.get("output"), lines);
		} 
		
		long duration = System.currentTimeMillis() - startTime;
		
		System.out.println("Duration " + duration + " ms");
	}

	private static String consumeLine(int i, String line) {
		if (i != 1) {
			String outputLine = String.format("Case #%d: %s", i-1, asleep(line));
			return outputLine;
		}
		
		return "";
		
	}

	private static String asleep(String line) {
		Integer n = Integer.valueOf(line);
		Set<Integer> allDigits = new HashSet<>();
		allDigits.addAll(Arrays.asList(0,1,2,3,4,5,6,7,8,9));
		
		Set<Integer> foundDigits = new HashSet<>();
		foundDigits.addAll(getNumbers(line));
		
		int mul = 2;
		long v = n;
		while (!foundDigits.equals(allDigits))  {
			v = mul *n;
			if (v == 0)
				return "INSOMNIA";
			foundDigits.addAll(getNumbers(String.valueOf(v)));
			mul++;
		}
		
		return String.valueOf(v);
	}

	private static List<Integer> getNumbers(String line) {
		List<Integer> l = Lists.newArrayList();
		for (Character c : line.toCharArray()) {
			l.add(Character.getNumericValue(c));
		}
		
		return l;
	}
}
