package tictactoe;

public class TestData {

	private enum Assigned {
		X(1),
		O(-1),
		T(10),
		DOT(0);

		private int value;

		Assigned(int value) {
			this.value = value;
		}
	}

	private int[] rowCounter;
	private int[] colCounter;
	private int dotCounter;

	private int diagonal1;
	private int diagonal2;


	public TestData() {
		rowCounter = new int[4];
		colCounter = new int[4];
		dotCounter = 0;
		diagonal1 = 0;
		diagonal2 = 0;
	}


	public void addRow(int rowNum, String line) {
		char[] lineArr = line.toCharArray();
		for (int i = 0; i < 4; i++) {
			if (lineArr[i] == 'X') {
				updateWith(Assigned.X, rowNum, i);
			} else if (lineArr[i] == 'O') {
				updateWith(Assigned.O, rowNum, i);
			} else if (lineArr[i] == '.') {
				dotCounter++;
				updateWith(Assigned.DOT, rowNum, i);
			} else if (lineArr[i] == 'T') {
				updateWith(Assigned.T, rowNum, i);
			}
		}
	}

	public GameStatus getGameStatus() {
		if (diagonal1 == 4 || diagonal1 == 13 || diagonal2 == 4 || diagonal2 == 13)
			return GameStatus.X_WON;
		else if (diagonal1 == -4 || diagonal1 == 7 || diagonal2 == -4 || diagonal2 == 7)
			return GameStatus.O_WON;

		// check all row and counters
		for (int i = 0; i < 4; i++) {
			if (rowCounter[i] == 4 || rowCounter[i] == 13 || colCounter[i] == 4 || colCounter[i] == 13)
				return GameStatus.X_WON;
			else if (rowCounter[i] == -4 || rowCounter[i] == 7 || colCounter[i] == -4 || colCounter[i] == 7)
				return GameStatus.O_WON;
		}

		if (dotCounter == 0)
			return GameStatus.DRAW;
		else 
			return GameStatus.GAME_NOT_COMPLETED;

	}

	public void displayCounters() {
		for (int i = 0; i < 4; i++) {
			System.out.println("Row " + i + " " + rowCounter[i]);
			System.out.println("Col " + i + " " + colCounter[i]);
		}
		System.out.printf("DiagCounter1 %d, DiagCounter2 %d", diagonal1, diagonal2);
	}

	private void updateWith(Assigned val, int row, int col) {
		rowCounter[row] = rowCounter[row] + val.value;
		colCounter[col] = colCounter[col] + val.value;
		if (col == row)
			diagonal1 = diagonal1 + val.value;
		if ((col + row) == 3) 
			diagonal2 = diagonal2 + val.value;
	}
}