package com.google.code.jam;

import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.List;
import java.util.concurrent.atomic.AtomicInteger;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class Pancakes {

	public static void main(String[] args) throws Exception {
		String fileName = args[0];

		long startTime = System.currentTimeMillis();
		
		final AtomicInteger i = new AtomicInteger(0);
		try (Stream<String> stream = Files.lines(Paths.get(fileName))) {
			List<String> lines = stream.map(line -> consumeLine(i.incrementAndGet(), line))
					.collect(Collectors.toList());
			Files.write(Paths.get("output"), lines);
		} 
		
		long duration = System.currentTimeMillis() - startTime;
		
		System.out.println("Duration " + duration + " ms");
	}

	private static String consumeLine(int i, String line) {
		if (i != 1) {
			String outputLine = String.format("Case #%d: %s", i-1, getFlipCount(line));
			//System.out.println(outputLine);
			return outputLine;
		}
		
		return "";
		
	}

	private static String getFlipCount(String line) {
		int i = 0;
		String target = target(line.length());
		while (!line.equalsIgnoreCase(target)) {
			line = maneuver(findIndex(line), line);
			i++;
		}
		
		return String.valueOf(i);
	}
	
	private static int findIndex(String line) {
		char[] arr = line.toCharArray();
		int i = line.length() - 1;
		for (;i >=0; i--) {
			if (arr[i] != '+')
				break;
		}
		return i;
	}

//	private static String negate(int len) {
//		char[] target = new char[len];
//		for (int i = 0; i < len; i++) {
//			target[i] = '+';
//		}
//		return new String(target);
//	}
	
	private static String target(int len) {
		char[] target = new char[len];
		for (int i = 0; i < len; i++) {
			target[i] = '+';
		}
		return new String(target);
	}
	
	private static String maneuver(int end, String input) {
		char[] arr = input.toCharArray();
		for (int i = 0; i <= end; i++) {
			if (arr[i] == '-')
				arr[i] = '+';
			else if (arr[i] == '+')
				arr[i] = '-';
		}
		
		return new String(arr);
	}
}
