package code.jam;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.List;
import java.util.concurrent.TimeUnit;

import com.google.common.base.Function;
import com.google.common.collect.Lists;

public class CookieClicker {

	private static final Double p = new Double(2.0);
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		long startTime = System.currentTimeMillis();
		try (FileInputStream fstream = new FileInputStream("input");
				DataInputStream in = new DataInputStream(fstream);
				BufferedReader br = new BufferedReader(new InputStreamReader(in));
				PrintWriter output = new PrintWriter("output");
				){
			long numTestCases = Long.parseLong(br.readLine());
			for (long i = 0; i < numTestCases; i++) {
				String result = handleTestCase(br.readLine());
				
				System.out.printf("Case #%d: %s\n", (i+1), result);
				output.printf("Case #%d: %s\n", (i+1), result);
					
				//int space = testline.indexOf(" ");
				//long lowerbound = Long.parseLong(testline.substring(0, space));
				//long upperbound = Long.parseLong(testline.substring(space + 1));
				//long numFairAndSquare = handleTestCase(lowerbound, upperbound);
				//System.out.printf("Case #%d: %d\n", (i+1), numFairAndSquare);
				//output.printf("Case #%d: %d\n", (i+1), numFairAndSquare);
			}

		} catch (IOException e) {
			e.printStackTrace();
		}

		long duration = System.currentTimeMillis() - startTime;
		System.out.printf("Duration %d (ms)\n", duration);
		System.out.printf("Minutes %d\n", TimeUnit.MILLISECONDS.toMinutes(duration));
	}

	
	private static String handleTestCase(String line) {
		String[] rowArr = line.split(" ");
		List<Double> cfx = Lists.transform(Arrays.asList(rowArr), new Function<String, Double>() {

			@Override
			public Double apply(String arg0) {
				return Double.valueOf(arg0);
			}
		});
		
		Double C = cfx.get(0);
		Double F = cfx.get(1);
		Double X = cfx.get(2);
		
		//Double timeWithoutNextFarm = X/p;
		Double timeElapsed = new Double(0.0);
		
		for (Double accRate = p;;) {
			// buy farm
			Double timeToBuyFarm = C/accRate;
			Double timeToAccCookies = X/(accRate+F);
			Double timeWithThisFarm = timeToBuyFarm + timeToAccCookies;
			Double timeWithoutThisFram = X/accRate;
			
			if (timeWithoutThisFram < timeWithThisFarm) {
				timeElapsed += timeWithoutThisFram;
				break;
			}	
			else {
				timeElapsed += timeToBuyFarm;
				//timeWithoutNextFarm += timeToBuyFarm ;
				accRate = accRate + F;
			}
		}
		
		DecimalFormat df = new DecimalFormat("#.0000000");
		return df.format(timeElapsed);
		//return String.valueOf(timeElapsed);
	}
}
