package code.jam.magictrick;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Set;
import java.util.concurrent.TimeUnit;

import com.google.common.base.Function;
import com.google.common.collect.Lists;
import com.google.common.collect.Sets;

public class MagicTrick {

	private static String BAD_MAGICIAN = "Bad magician!";
	private static String VOLUNTEER_CHEATED = "Volunteer cheated!";
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//System.out.printf("Sum of digits, %d\n", sumDigits(9999993));

				long startTime = System.currentTimeMillis();
				try (FileInputStream fstream = new FileInputStream("input");
						DataInputStream in = new DataInputStream(fstream);
						BufferedReader br = new BufferedReader(new InputStreamReader(in));
						PrintWriter output = new PrintWriter("output");
						){
					long numTestCases = Long.parseLong(br.readLine());
					for (long i = 0; i < numTestCases; i++) {
						
						// read first set
						Set<Integer> set1 = getRow(br);
						Set<Integer> set2 = getRow(br);
						
						Set<Integer> intersect = Sets.intersection(set1, set2);
						int size = intersect.size();
						String result = "EMPTY";
						
						if (size == 0) {
							result = VOLUNTEER_CHEATED;
						} else if (size > 1) {
							result = BAD_MAGICIAN;
						} else {
							result = String.valueOf(Lists.newArrayList(intersect).get(0));
						}
						System.out.printf("Case #%d: %s\n", (i+1), result);
						output.printf("Case #%d: %s\n", (i+1), result);
 						
						//int space = testline.indexOf(" ");
						//long lowerbound = Long.parseLong(testline.substring(0, space));
						//long upperbound = Long.parseLong(testline.substring(space + 1));
						//long numFairAndSquare = handleTestCase(lowerbound, upperbound);
						//System.out.printf("Case #%d: %d\n", (i+1), numFairAndSquare);
						//output.printf("Case #%d: %d\n", (i+1), numFairAndSquare);
					}

				} catch (IOException e) {
					e.printStackTrace();
				}

				long duration = System.currentTimeMillis() - startTime;
				System.out.printf("Duration %d (ms)\n", duration);
				System.out.printf("Minutes %d\n", TimeUnit.MILLISECONDS.toMinutes(duration));
	}

	private static Set<Integer> getRow(BufferedReader br) throws NumberFormatException, IOException {
		Set<Integer> row = Sets.newHashSet();
		Integer rowIndex = Integer.valueOf(br.readLine());
		// read next 4 rows 
		for (int j = 0; j < 4; ++j) {
			String rowStr = br.readLine();
			if ((j + 1) == rowIndex) {
				String[] rowArr = rowStr.split(" ");
				row = Sets.newHashSet(Lists.transform(Arrays.asList(rowArr), new Function<String, Integer>() {

					@Override
					public Integer apply(String arg0) {
						return Integer.valueOf(arg0);
					}
				}));
			}
				
		}
		
		return row;
	}
	
	private static long handleTestCase(long lowerbound, long upperbound) {
		return 0;
	}

}
