import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;


public class DeceitfulWar {

	public static void main(String[] args) {
		try{
			// Open the file that is the first 
			// command line parameter
			FileInputStream fstream = new FileInputStream(args[0]);
			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;
			//Read File Line By Line
			int numTest = Integer.parseInt(br.readLine());
			double cps = 2.0;
			for(int i = 0; i < numTest; i ++){
				int numberOfBlocks = Integer.parseInt(br.readLine());
				ArrayList<Double> naomi = new ArrayList<Double>();
				ArrayList<Double> ken = new ArrayList<Double>();
				ArrayList<Double> naomiClone =  new ArrayList<Double>();
				ArrayList<Double> kenClone =  new ArrayList<Double>();
				String naomistr[] = br.readLine().split(" ");
				for(int sc = 0; sc < naomistr.length; sc++){
					naomi.add(new Double(naomistr[sc]));
					naomiClone.add(new Double(naomistr[sc]));
				}
				String kenstr[] = br.readLine().split(" ");
				for(int sc = 0; sc < kenstr.length; sc++){
					ken.add(new Double(kenstr[sc]));
					kenClone.add(new Double(kenstr[sc]));
				}
				Collections.sort(naomi);
				Collections.sort(ken);
				
				Collections.sort(naomiClone);
				Collections.sort(kenClone);
				
				int winFair = calculateFair(naomi, ken, numberOfBlocks, i+1);
				int winDeceit = calculateDeceit(naomiClone, kenClone, numberOfBlocks, i+1);
				System.out.println("Case #" + Integer.toString(i+1) + ": " + winDeceit + " " + winFair);
			}
			//Close the input stream
			in.close();
		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}

	}

	private static int calculateDeceit(ArrayList<Double> naomi,
			ArrayList<Double> ken, int numberOfBlocks, int testCaseNumber) {
			int winNaomi = 0;
			while(naomi.size() > 0){
				if(checkDeceit(naomi, ken)){
					winNaomi ++;
				}
			}
			return winNaomi;
		
	}

	private static boolean checkDeceit(ArrayList<Double> naomi,
			ArrayList<Double> ken) {
		double largestNaomiBlock = naomi.get(naomi.size() -1 );
		double largestKenBlock = ken.get(ken.size() -1 );
		double smallestNaomiBLock = naomi.get(0);
		double smallestKenBLock = ken.get(0);
		if(largestNaomiBlock > largestKenBlock){
			if(smallestNaomiBLock > smallestKenBLock){
				naomi.remove(0);
				ken.remove(0);
				return true;
			}
			else{
				naomi.remove(0);
				ken.remove(0);
				return false;
			}
			
		}
		else{
			naomi.remove(0);
			ken.remove(ken.size() -1);
			return false;
		}

	}

	private static int calculateFair(ArrayList<Double> naomi,
		ArrayList<Double> ken, int numberOfBlocks, int testCaseNumber) {
		int winNaomi = 0;
		while(naomi.size() > 0){
			if(checkFair(naomi, ken)){
				winNaomi ++;
			}
		}
		return winNaomi;
		
	}

	private static boolean checkFair(ArrayList<Double> naomi,
			ArrayList<Double> ken) {
		double block = naomi.get(0);
		for(int i = 0; i < ken.size(); i++){
			if(ken.get(i) > block){
				ken.remove(i);
				naomi.remove(0);
				return false;
			}
		}
		ken.remove(0);
		naomi.remove(0);
		return true;
	}

}

