import java.math.BigInteger;


public class FairAndSquare {

	private BigInteger nextPalindrome;

	public void check(String nextLine, int i) {
		String nos[] = nextLine.split(" ");
		BigInteger start = new BigInteger(nos[0]);
		BigInteger end = new BigInteger(nos[1]);
		
		BigInteger sqStart = sqrt(start);
		BigInteger sqEnd = sqrt(end);
		int count = 0;
		nextPalindrome = sqStart;
		if(isPalindrome(nextPalindrome.toString())){
			BigInteger square = nextPalindrome.multiply(nextPalindrome);
			if(isPalindrome(square.toString()) && square.compareTo(start)>=0){
				count ++;
			}
			
		}
		while(nextPalindrome.compareTo(sqEnd) <0 ){
			
			nextPalindrome = findNextPalindrome(nextPalindrome);
			BigInteger square = nextPalindrome.multiply(nextPalindrome);
			if(isPalindrome(square.toString())&& square.compareTo(end)<=0){
				count ++;
			}
		}
		
		System.out.println("Case #" + i + ": " + count);
		
	}
	
	private BigInteger findNextPalindrome(BigInteger nextPalindrome) {
		String str = nextPalindrome.toString();
		if(isPalindrome(str)){
			nextPalindrome = nextPalindrome.add(new BigInteger("1"));
		}
		str = nextPalindrome.toString();
		if(isPalindrome(str)){
			return nextPalindrome;
		}
		str = getNextPalindrome(nextPalindrome.toString());
		return new BigInteger(str);
		
	}
	
	private String getNextPalindrome(String s){
		String mirrored = mirror(s);
		 
	    //the mirror might be smaller than original, so increment it and try again.
	    if (compare(mirrored, s) <= 0) {
	      mirrored = mirror(incrementFromMiddle(s));
	    }
	    return mirrored;
	}
	
	 private int compare(String s, String t){
		    //only check second half
		    final int midpoint = s.length() / 2;
		    int i = s.length() % 2 == 0 ? midpoint : midpoint + 1;
		    for (; i < s.length(); i++) {
		      if(s.charAt(i) < t.charAt(i)){
		        return -1 ;
		      }
		      else if (s.charAt(i) > t.charAt(i)){
		        return 1;
		      }
		    }
		    return 0;
		  }
	
	private String mirror(String s) {
	    final char[] arr = s.toCharArray();
	    int midpoint = arr.length / 2;
	    int i = arr.length % 2 == 0 ? midpoint : midpoint + 1;
	    while (i < arr.length) {
	      arr[i] = arr[midpoint - 1];
	      i++;
	      midpoint--;
	    }
	    return new String(arr);
	  }
	
	private String incrementFromMiddle(String s) {
		 
	    final char[] arr = s.toCharArray();
	    final int midpoint = arr.length / 2;
	    int currPoint = arr.length % 2 == 0 ? midpoint - 1 : midpoint;
	    boolean found = false;
	 
	    while (currPoint >= 0 && !found) {
	      char c = arr[currPoint];
	      char inc;
	      if (c == '9') {
	        inc = '0';
	      }
	      else {
	        inc = (char) (c + 1);
	        found = true;
	      }
	      arr[currPoint] = inc;
	      if (!found) {
	        currPoint--;
	      }
	    }
	 
	    if (!found) {
	      // we have fallen off the start of the string
	      // example 999 has become 009. Add a one on to give: 1009
	      final char[] newarr = new char[arr.length + 1];
	      newarr[0] = '1';
	      System.arraycopy(arr, 0, newarr, 1, arr.length);
	      return new String(newarr);
	    }
	    else {
	      return new String(arr);
	    }
	  }

	private boolean isPalindrome(String str) {
		if(str.equals(new StringBuilder(str).reverse().toString())){
			return true;
		}
		else
			return false;
	}

	public static BigInteger sqrt(BigInteger n) {
	    BigInteger a = BigInteger.ONE;
	    BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
	    while(b.compareTo(a) >= 0) {
	      BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
	      if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
	      else a = mid.add(BigInteger.ONE);
	    }
	    return a.subtract(BigInteger.ONE);
	  }

}
