package com.gonnaggstudio;

import javafx.util.Pair;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.*;

public class Main {
    public static void main(String args[]) throws Exception {
        new CoreTraining("C-small-1-attempt0").run();

    }

    static class Template {
        Scanner sc;
        PrintStream out;

        Template(String fileName){
            String FILENAME = fileName;
            String IN = FILENAME + ".in";
            String OUT = FILENAME + ".out";
            sc = new Scanner(getClass().getResourceAsStream(IN));
            try {
                File f = new File(OUT);
                if(!f.exists())
                    f.createNewFile();
                out = new PrintStream(new FileOutputStream(OUT));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        void solve() {
            int ans = 0;

            out.println(ans);
        }

        void run() throws Exception {
            int t = sc.nextInt();
            for (int i = 1; i <= t; i++) {
                System.out.print("Case #" + i + ": ");
                out.print("Case #" + i + ": ");
                solve();
            }
            sc.close();
            out.close();
        }
    }

    static class CoreTraining extends Template {


        CoreTraining(String fileName) {
            super(fileName);
        }

        Integer coreNum;
        Integer succestReq;
        Double boost;
        List<Double> coresStatus;
        @Override
        void solve() {
            coreNum = sc.nextInt();
            succestReq = sc.nextInt();
            boost = sc.nextDouble();
            coresStatus = new LinkedList<>();
            for(int i = 0; i < coreNum; ++i){
                coresStatus.add(sc.nextDouble());
            }

            Collections.sort(coresStatus);
            boolean stillFlow = false;
            while(boost > 0) {
                for (int i = 0; i < coreNum - 1; ++i) {
                    double change = coresStatus.get(i + 1) - coresStatus.get(i);
                    if (change != 0.0)
                        stillFlow = true;
                    if (change > boost) {
                        boost = 0.0;
                        coresStatus.set(i, coresStatus.get(i) + boost);
                    } else {
                        coresStatus.set(i, coresStatus.get(i) + change);
                        boost -= change;
                    }
                }
                if(!stillFlow) {
                    for (int i = 0; i < coreNum; ++i) {
                        double change = boost / coreNum;
                        coresStatus.set(i, Math.min(1.0, coresStatus.get(i) + change));
                    }
                    boost = 0.0;
                }
                stillFlow = false;

            }


            Double answer = 1.0;
            for(int i = 0; i < coreNum; ++i){
                answer *= coresStatus.get(i);
            }
            System.out.println(String.format("%.6f", answer));
            out.println(String.format("%.6f", answer));
        }
    }
}
