package com.gonnaggstudio;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {
    public static void main(String args[]) throws Exception {
        new BathroomStalls("C-small-1-attempt3").run();
    }

    static class Template {
        Scanner sc;
        PrintStream out;

        Template(String fileName){
            String FILENAME = fileName;
            String IN = FILENAME + ".in";
            String OUT = FILENAME + ".out";
            sc = new Scanner(getClass().getResourceAsStream(IN));
            try {
                File f = new File(OUT);
                if(!f.exists())
                    f.createNewFile();
                out = new PrintStream(new FileOutputStream(OUT));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        void solve() {
            int ans = 0;

            out.println(ans);
        }

        void run() throws Exception {
            int t = sc.nextInt();
            for (int i = 1; i <= t; i++) {
                out.print("Case #" + i + ": ");
                solve();
            }
            sc.close();
            out.close();
        }
    }

    static class BathroomStalls extends Template {
        int stallCnt;
        int personCnt;
        ArrayList<Integer> stallsOcupation;
        BathroomStalls(String fileName) {
            super(fileName);
        }

        @Override
        void solve() {
            stallCnt = sc.nextInt();
            personCnt = sc.nextInt();
            stallsOcupation = new ArrayList<>();
            stallsOcupation.add(0);
            stallsOcupation.add(stallCnt+1);
            int lastLs = 0;
            int lastRs = 0;
            for(int i = 0; i < personCnt; ++i){
                int space = -1;
                int positionInList = -1;
                for(int j = 1; j < stallsOcupation.size(); ++j){
                    if(stallsOcupation.get(j) - stallsOcupation.get(j-1) - 1 > space) {
                        space = stallsOcupation.get(j) - stallsOcupation.get(j-1) - 1;
                        positionInList = j;
                    }
                }
                lastLs = (space%2 == 0) ? ( space/2 - 1 ):( (int)Math.floor(space / 2.0) );
                lastRs = space - lastLs - 1;
                //System.out.println("Person go to stall number: " + (stallsOcupation.get(positionInList - 1) + lastLs + 1) + ", it is at position: " + positionInList);
                stallsOcupation.add(positionInList, stallsOcupation.get(positionInList) - lastRs -1);
            }
            System.out.println("Case#"+(++count));
            out.println(Math.max(lastLs, lastRs) + " " + Math.min(lastLs, lastRs));
        }
        static int count = 0;
    }
}
