package com.gonnaggstudio;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {
    public static void main(String args[]) throws Exception {
        new OversizedPancakeFlipper("A-small-attempt1").run();
    }

    static class Template {
        Scanner sc;
        PrintStream out;

        Template(String fileName){
            String FILENAME = fileName;
            String IN = FILENAME + ".in";
            String OUT = FILENAME + ".out";
            sc = new Scanner(getClass().getResourceAsStream(IN));
            try {
                File f = new File(OUT);
                if(!f.exists())
                    f.createNewFile();
                out = new PrintStream(new FileOutputStream(OUT));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        void solve() {
            int ans = 0;

            out.println(ans);
        }

        void run() throws Exception {
            int t = sc.nextInt();
            for (int i = 1; i <= t; i++) {
                out.print("Case #" + i + ": ");
                solve();
            }
            sc.close();
            out.close();
        }
    }

    static class OversizedPancakeFlipper extends Template {

        OversizedPancakeFlipper(String fileName) {
            super(fileName);
        }

        @Override
        void solve(){
            char[] in = sc.next().toCharArray();
            int size = sc.nextInt();
            int step = 0;
            int i = 0;
            for(; i + size - 1< in.length; ++i) {
                if(in[i] == '+') {
                    continue;
                }
                for(int j = 0; j < size; ++j){
                    in[i+j] = (in[i+j] == '+')?'-':'+';
                }
                ++step;
            }
            for(; i < in.length; ++i) {
                if(in[i] == '-') {
                    out.println("IMPOSSIBLE");
                    return;
                }
            }

            out.println(step);
        }
    }
}
