package com.gonnaggstudio;

import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {
    public static void main(String args[]) throws Exception {
        new TidyNumbers("B-small-attempt0").run();
    }

    static class Template {
        protected Scanner sc;
        protected PrintStream out;

        Template(String fileName){
            String FILENAME = fileName;
            String IN = FILENAME + ".in";
            String OUT = FILENAME + ".out";
            sc = new Scanner(getClass().getResourceAsStream(IN));
            try {
                File f = new File(OUT);
                if(!f.exists())
                    f.createNewFile();
                out = new PrintStream(new FileOutputStream(OUT));
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        void solve() {
            int ans = 0;

            out.println(ans);
        }

        void run() throws Exception {
            int t = sc.nextInt();
            for (int i = 1; i <= t; i++) {
                out.print("Case #" + i + ": ");
                solve();
            }
            sc.close();
            out.close();
        }
    }

    static class TidyNumbers extends Template {

        TidyNumbers(String fileName) {
            super(fileName);
        }

        @Override
        void solve(){
            String in = sc.next();
            char[] ans = in.toCharArray();
            int untidyPlace = isTidy(ans);

            while(untidyPlace != -1){
                tidinize(ans, untidyPlace);
                untidyPlace = isTidy(ans);
            }

            out.println(new BigInteger(new String(ans)));
        }

        void tidinize(char[] in, int startFrom){
            --in[startFrom-1];
            for(int i = startFrom; i < in.length; ++i){
                in[i] = '9';
            }
        }

        int isTidy(char[] in) {
            char lastChar = in[0];
            int notTidyPlace = 1;
            boolean isTidy = true;
            for(; notTidyPlace < in.length; ++notTidyPlace){
                int diff = (int)in[notTidyPlace] - (int)lastChar;
                if(diff < 0) {
                    isTidy = false;
                    break;
                }
                lastChar = in[notTidyPlace];
            }

            if(isTidy)
                return -1;
            else
                return notTidyPlace;
        }
    }
}
