package coinjam;

import java.io.*;
import java.math.*;

public class Coinjam {
	static PrintWriter fout;
	static int length = 16;
	static int numRemaining = 50;
	
	static int[] digits = new int[32];
	
	private static void filePrint() throws IOException{
		fout = new PrintWriter(new BufferedWriter(new FileWriter("coin.out")));
	}
	
	private static BigInteger changeBase(int b){
		BigInteger output = BigInteger.valueOf(0);
		BigInteger cur = BigInteger.valueOf(1);
		for(int i = length-1; i >= 0; i--){
			output = output.add((BigInteger.valueOf(digits[i])).multiply(cur));
			cur = cur.multiply(BigInteger.valueOf(b));
		}
		return output;
	}
	
	private static void recurse(int index){
		if(numRemaining <= 0){
			return;
		}
		if(index == length-1){
			int[] divisors = new int[11];
			boolean cont = true;
			for(int base = 2; base <= 10 && cont; base++){
				BigInteger bi = changeBase(base);
				BigInteger div = BigInteger.valueOf(2);
				while(!bi.mod(div).equals(BigInteger.valueOf(0)) && (div.multiply(div)).compareTo(bi) < 0){
					div = div.add(BigInteger.valueOf(1));
				}
				if(bi.mod(div).equals(BigInteger.valueOf(0))){
					divisors[base] = div.intValue();
				}else{
					cont = false;
				}
			}
			if(cont){
				for(int i = 0; i < length; i++){
					//System.out.print(digits[i]);
					fout.write(Integer.valueOf(digits[i]).toString());
				}
				//System.out.print("\n");
				fout.write(" ");
				for(int b = 2; b <= 9; b++){
					fout.write(Integer.valueOf(divisors[b]).toString() + " ");
				}
				fout.write(Integer.valueOf(divisors[10]).toString() + "\r\n");
				
				numRemaining--;
				
				System.out.println(numRemaining);
			}
			
			return;
		}
		
		digits[index] = 0;
		recurse(index+1);
		digits[index] = 1;
		recurse(index+1);
	}
	
	public static void main(String[] args) throws IOException{
		for(int i = 0; i < length; i++){
			digits[i] = 0;
		}
		digits[0] = 1;
		digits[15] = 1;
		filePrint();
		fout.write("Case #1:\r\n");
		recurse(1);
		fout.close();
	}
	
}
