//Antares Chen
//May 4, 2013
//Google Code Jam 2013 Round 1B 
//Problem: Osmos

package codeJam2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Osmos
{
	public static long aminSize;
	public static String completeOutput = "";
	
	public static void main (String[] args)
	{
		startSolve();
	}
	
	public static void startSolve()
	{
		try
		{
			BufferedReader reader = new BufferedReader(new FileReader(new File("A-small-attempt2.in")));
			int size = Integer.parseInt(reader.readLine());
			for (int i = 0; i < size; i ++)
			{
				String output = "Case #" + (i + 1) + ": ";
				StringTokenizer tokentoken = new StringTokenizer(reader.readLine());
				aminSize = Long.parseLong(tokentoken.nextToken());
				long[] motes = new long[Integer.parseInt(tokentoken.nextToken())];
				StringTokenizer tokens = new StringTokenizer(reader.readLine());
				for (int j = 0; j < motes.length; j ++)
				{
					motes[j] = Long.parseLong(tokens.nextToken());
				}
				if (motes.length > 100)
				{
					quicksort(motes,0,motes.length - 1);
				}
				else
				{
					selectionSort(motes);
				}
				output += solve(motes);
				System.out.println(output);
				completeOutput += output + "\n";
				aminSize = 0;
			}
			reader.close();
			printResult(completeOutput);
		}
		catch (IOException e)
		{
			System.out.println("derp");
			System.exit(0);
		}
	}
	
	public static String solve(long[] motes)
	{
		System.out.println("****************************************************");
		System.out.println(Arrays.toString(motes));
		Long moves = new Long(0);
		int timesIncreased = 0;
		for (int i = 0; i < motes.length; i ++)
		{
			System.out.println("AMIN:\t" + aminSize);
			if (timesIncreased >= motes.length - i)
			{
				System.out.println("ragequit");
				moves -= timesIncreased;
				moves += motes.length - i;
				break;
			}
			if (motes[i] >= aminSize)
			{
				if (aminSize == 1)
				{
					System.out.println("REMOVING");
					moves ++;
				}
				else if (i == motes.length - 1)
				{
					System.out.println("REMOVING");
					moves ++;
					break;
				}
				else
				{
					System.out.println("INCREASING\t" + aminSize);
					increaseSize();
					moves ++;
					timesIncreased ++;
					i --;
				}
			}
			else
			{
				timesIncreased = 0;
				aminSize += motes[i];
			}
		}
		return moves.toString();
	}
	
	public static void increaseSize()
	{
		aminSize = 2*aminSize - 1;
	}
	
	public static void printResult(String string)
	{
		try
		{
			BufferedWriter printer = new BufferedWriter(new FileWriter(new File("OsmosSmall.txt")));
			printer.write(string);
			printer.close();
		}
		catch (IOException e)
		{
			System.out.println("Failure to write");
		}
	}
	
	public static void quicksort(long[] numbers, int low, int high)
	{
		int i = low;
		int j = high;
		long pivot = numbers[low + (high - low) / 2];
		while (i <= j)
		{
			while (numbers[i] < pivot)
			{
				i++;
			}
			while (numbers[j] > pivot)
			{
				j--;
			}
			if (i <= j)
			{
				exchange(numbers, i, j);
				i++;
				j--;
			}
		}
		if (low < j)
			quicksort(numbers, low, j);
		if (i < high)
			quicksort(numbers, i, high);
	}

	public static void exchange(long[] numbers, int i, int j)
	{
		long temp = numbers[i];
		numbers[i] = numbers[j];
		numbers[j] = temp;
	}

	public static void selectionSort(long[] num)
	{
		for (int i = num.length - 1; i > 0; i --)  
		{
			int first = 0;
			for(int j = 1; j <= i; j ++)
			{
				if(num[j] > num[first])         
					first = j;
			}
			long temp = num[first];
			num[first] = num[i];
			num[i] = temp; 
		}           
	}
}