//Antares Chen
//April 13, 2013
//2013 Qualifying round problem 3

package codeJam2013;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Scanner;
import java.util.StringTokenizer;

public class FairAndSquare
{
	public static void main(String[] args)
	{
		Scanner scanner = new Scanner(System.in);
		System.out.println("Name of file?");
		String file = scanner.nextLine();
		int[][] inputs = getInputs(file);
		String output = "";
		for (int i = 0; i < inputs.length; i ++)
		{
			LinkedList<Integer> squares = getSquares(inputs[i]);
			int j = getPalindromeSquares(squares);
			output += "Case #" + (i + 1) + ": ";
			output += j + "\n";
		}
		printResult(output);
		scanner.close();
	}
	
	public static int getPalindromeSquares(LinkedList<Integer> squares)
	{
		int counter = 0; 
		for (int i = 0; i < squares.size(); i ++)
		{
			boolean isPal = isPalindrome(squares.get(i).toString());
			StringBuilder string = new StringBuilder();
			string.append("");
			string.append((int)Math.sqrt(squares.get(i)));
			boolean isRootPal = isPalindrome(string.toString());
			if (isPal && isRootPal)
			{
				counter ++;
			}
		}
		return counter;
	}
	
	public static boolean isPalindrome(String s)
    {
        if(s.length() == 0 || s.length() == 1)
        {
        	return true;
        }
        if(s.charAt(0) == s.charAt(s.length()-1))
        {
        	return isPalindrome(s.substring(1, s.length()-1));
        }
        return false;
    }

	public static LinkedList<Integer> getSquares(int[] range)
	{
		int lower = (int)Math.ceil((double)Math.sqrt(range[0]));
		int upper = (int)Math.floor((double)Math.sqrt(range[1]));
		LinkedList<Integer> list = new LinkedList<Integer>();
		while (lower <= upper)
		{
			list.add(lower * lower);
			lower ++;
		}
		return list;
	}
	
	public static void printResult(String string)
	{
		try
		{
			PrintWriter printer = new PrintWriter(new File("FaSOutput.txt"));
			printer.print(string);
			printer.close();
			
		}
		catch (IOException e)
		{
			System.out.println("Failure to write");
		}
	}
	
	public static int[][] getInputs(String file)
	{
		try
		{
			BufferedReader reader = new BufferedReader(new FileReader(file));
			int inputs = Integer.parseInt(reader.readLine());
			int[][] number = new int[inputs][2];
			for (int i = 0; i < inputs; i ++)
			{
				StringTokenizer tokens = new StringTokenizer(reader.readLine());
				number[i][0] = Integer.parseInt(tokens.nextToken());
				number[i][1] = Integer.parseInt(tokens.nextToken());
			}
			reader.close();
			return number;
		}
		catch (IOException e)
		{
			System.out.println("File not found");
			System.exit(0);
			return null;
		}
	}
}