//Antares Chen
//April 26, 2013
//Manage your energy Round 1A problem 2

package codeJam2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Energy
{
	public static void main(String[] args)
	{
		long[][][] inputs = getInputs();
		String output = "";
		for (int i = 0; i < inputs.length; i ++)
		{
			if (inputs[i][1].length > 100)
				quicksort(inputs[i][1], 0, inputs[i][1].length - 1);
			else
				selectionSort(inputs[i][1]);
			output += "Case #" + (i + 1) + ": ";
			output += calculate(inputs[i]) + "\n";
		}
		System.out.println(output);
		printResult(output);
	}
	
	public static long calculate(long[][] array)
	{
		long total = 0;
		for (int i = 0; i < array[1].length; i ++)
		{
			total += array[1][array[1].length - 1 - i] * array[0][0];
			array[0][0] = array[0][1];
		}
		return total;
	}
	
	public static void quicksort(long[] numbers, int low, int high)
	{
		int i = low;
		int j = high;
		long pivot = numbers[low + (high - low) / 2];
		while (i <= j)
		{
			while (numbers[i] < pivot)
			{
				i++;
			}
			while (numbers[j] > pivot)
			{
				j--;
			}
			if (i <= j)
			{
				exchange(numbers, i, j);
				i++;
				j--;
			}
		}
		if (low < j)
			quicksort(numbers, low, j);
		if (i < high)
			quicksort(numbers, i, high);
	}

	public static void exchange(long[] numbers, int i, int j)
	{
		long temp = numbers[i];
		numbers[i] = numbers[j];
		numbers[j] = temp;
	}

	public static void selectionSort(long[] num)
	{
		for (int i = num.length - 1; i > 0; i --)  
		{
			int first = 0;
			for(int j = 1; j <= i; j ++)
			{
				if(num[j] > num[first])         
					first = j;
			}
			long temp = num[first];
			num[first] = num[i];
			num[i] = temp; 
		}           
	}
	
	public static long[][][] getInputs()
	{
		try
		{
			BufferedReader reader = new BufferedReader(new FileReader(new File("B-small-attempt0.in")));
			int size = Integer.parseInt(reader.readLine());
			long[][][] inputs = new long[size][2][];
			for (int k = 0; k < inputs.length; k ++)
			{
				inputs[k][0] = new long[3];
				StringTokenizer tokens = new StringTokenizer(reader.readLine());
				int i = 0;
				while (tokens.hasMoreTokens())
				{
					inputs[k][0][i] = Long.parseLong(tokens.nextToken());
					i ++;
				}
				inputs[k][1] = new long[(int)inputs[k][0][2]];
				tokens = new StringTokenizer(reader.readLine());
				for (int j = 0; j < inputs[k][1].length; j ++)
				{
					inputs[k][1][j] = Long.parseLong(tokens.nextToken());
				}
			}
			reader.close();
			return inputs;
		}
		catch (IOException e)
		{
			System.out.println("OH SHIT");
			System.exit(0);
		}
		return null;
	}
	
	public static void printResult(String string)
	{
		try
		{
			BufferedWriter printer = new BufferedWriter(new FileWriter(new File("1B_Small.txt")));
			printer.write(string);
			printer.close();
		}
		catch (IOException e)
		{
			System.out.println("Failure to write");
		}
	}
}