//Antares Chen
//April 13, 2013
//2013 Qualifying round problem 1

package codeJam2013;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Scanner;

public class TicTacToeToemak
{
	public static void main(String[] args)
	{
		Scanner scanner = new Scanner(System.in);
		System.out.println("Name of file?");
		String file = scanner.nextLine();
		Board[] board = getBoard(file);
		String output = "";
		for (int i = 0; i < board.length; i ++)
		{
			output += "Case #" + (i + 1) + ": ";
			output += getWinner(board[i]) + "\n";
		}
		printResult(output);
		scanner.close();
	}
	
	public static void printResult(String string)
	{
		try
		{
			PrintWriter printer = new PrintWriter(new File("output.txt"));
			printer.print(string);
			printer.close();
			
		}
		catch (IOException e)
		{
			System.out.println("Failure to write");
		}
	}
	
	public static String getWinner(Board board)
	{
		for (int i = 0; i < board.graphs.size(); i ++)
		{
			String path = checkPath(board.graphs.get(i));
			if (path != null)
			{
				return path;
			}
		}
		if (board.isFull())
		{
			return "Draw";
		}
		return "Game has not completed";
	}
	
	public static String checkPath(LinkedList<Character> list)
	{
		Character nextChar = null;
		int counter = 0;
		for (int i = 0; i < list.size(); i ++)
		{
			if (list.get(i).equals(new Character('T')))
			{
				counter ++;
				continue;
			}
			if (nextChar != null)
			{
				if (list.get(i).equals(nextChar))
				{
					counter ++;
					continue;
				}
				else
				{
					return null;
				}
			}
			else if (list.get(i) != ('.'))
			{
				nextChar = new Character(list.get(i));
			}
		}
		if (nextChar != null && counter == 3)
		{
			return nextChar.toString() + " won";
		}
		return null;
	}
	
	public static Board[] getBoard(String file)
	{
		try
		{
			BufferedReader reader = new BufferedReader(new FileReader(file));
			int inputs = Integer.parseInt(reader.readLine());
			Board[] board = new Board[inputs];
			for (int i = 0; i < inputs; i ++)
			{
				String[] pieces = new String[4];
				for (int j = 0; j < 4; j ++)
				{
					String line = reader.readLine(); 
					pieces[j] = line;
				}
				board[i] = new Board(pieces);
				reader.readLine();
			}
			reader.close();
			return board;
		}
		catch (IOException e)
		{
			System.out.println("File not found");
			System.exit(0);
			return null;
		}
	}
	
	public static class Board
	{
		private static final int[][] topLeft = {{0,1},{1,1},{1,0}};
		private static final int[][] topRight = {{0,-1},{1,-1},{1,0}};
		private static final int[][] bottomLeft = {{0,1},{-1,1},{-1,0}};
		private static final int[][] bottomRight = {{-1,0},{-1,-1},{0,-1}};
		
		private char[][] boardPiece;
		private LinkedList<LinkedList<Character>> graphs;
		
		public Board(String[] pieces)
		{
			boardPiece = new char[4][];
			for (int i = 0; i < 4; i ++)
			{
				boardPiece[i] = pieces[i].toCharArray();
			}
			graphs = new LinkedList<LinkedList<Character>>();
			getGraphs();
		}
		
		public boolean isFull()
		{
			for (int i = 0; i < 4; i ++)
			{
				for (int j = 0; j < 4; j ++)
				{
					if (boardPiece[i][j] == '.')
					{
						return false;
					}
				}
			}
			return true;
		}
		
		public void getGraphs()
		{
			for (int i = 0; i < topLeft.length; i ++)
			{
				int x = 0;
				int y = 0;
				char character;
				LinkedList<Character> list = new LinkedList<Character>();
				for (int j = 0; j < 4; j ++)
				{
//					System.out.println(Arrays.deepToString(boardPiece));
//					System.out.println("x: " + x + "\ty: " + y);
					character = boardPiece[x][y];
					list.add(character);
					x += topLeft[i][0];
					y += topLeft[i][1];
				}
				graphs.add(list);
			}
			for (int i = 0; i < topRight.length; i ++)
			{
				int x = 0;
				int y = 3;
				char character;
				LinkedList<Character> list = new LinkedList<Character>();
				for (int j = 0; j < 4; j ++)
				{
//					System.out.println("x: " + x + "\ty: " + y);
					character = boardPiece[x][y];
					list.add(character);
					x += topRight[i][0];
					y += topRight[i][1];
				}
				graphs.add(list);
			}
			for (int i = 0; i < bottomLeft.length; i ++)
			{
				int x = 3;
				int y = 0;
				char character;
				LinkedList<Character> list = new LinkedList<Character>();
				for (int j = 0; j < 4; j ++)
				{
//					System.out.println("x: " + x + "\ty: " + y);
					character = boardPiece[x][y];
					list.add(character);
					x += bottomLeft[i][0];
					y += bottomLeft[i][1];
				}
				graphs.add(list);
			}
			for (int i = 0; i < bottomRight.length; i ++)
			{
				int x = 3;
				int y = 3;
				char character;
				LinkedList<Character> list = new LinkedList<Character>();
				for (int j = 0; j < 4; j ++)
				{
//					System.out.println("x: " + x + "\ty: " + y);
					character = boardPiece[x][y];
					list.add(character);
					x += bottomRight[i][0];
					y += bottomRight[i][1];
				}
				graphs.add(list);
			}
			for (int i = 1; i < 3; i ++)
			{
				int x = 0;
				int y = i;
				char character;
				LinkedList<Character> list = new LinkedList<Character>();
				for (int j = 0; j < 4; j ++)
				{
//					System.out.println("x: " + x + "\ty: " + y);
					character = boardPiece[x][y];
					list.add(character);
					x += 1; 
				}
				graphs.add(list);
				x = i;
				y = 0;
				LinkedList<Character> list2 = new LinkedList<Character>();
				for (int j = 0; j < 4; j ++)
				{
//					System.out.println("x: " + x + "\ty: " + y);
					character = boardPiece[x][y];
					list2.add(character);
					y += 1; 
				}
				graphs.add(list2);
			}
		}
	}
}