import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class DrainageBasins {
	public static void main(String[] args) throws IOException {
		PrintStream out;
		if (args[0].contains("test")) {
			out = System.out;
		} else {
			out = new PrintStream(new File(args[0].substring(0, args[0].length()-3)) + ".out");
		}
				
				
		BufferedReader reader = new BufferedReader(new FileReader(args[0]));
		int t = Integer.parseInt(reader.readLine());
		for (int i = 0; i < t; i++) {
			String[] hw = reader.readLine().split(" ");
			int h = Integer.parseInt(hw[0]);
			int w = Integer.parseInt(hw[1]);
			int[][] altitudes = readAltitudes(h, w, reader);
			Basin[][] basins = new Basin[h][w];
			for (int j = 0; j < h; j++) {
				for (int k = 0; k < w; k++) {
					int minh = j;
					int minw = k;
					int min =  altitudes[minh][minw];
					//North
					if (j > 0 && min > altitudes[j - 1][k]) {
						minh = j - 1;
						min = altitudes[minh][minw];
					}
					//West
					if (k > 0 && min > altitudes[j][k-1]) {
						minh = j;
						minw = k-1;
						min = altitudes[minh][minw];
					}
					//East
					if (k < w-1 && min > altitudes[j][k+1]) {
						minh = j;
						minw = k+1;
						min = altitudes[minh][minw];
					}
					//South
					if (j < h-1 && min > altitudes[j+1][k]) {
						minh = j+1;
						minw = k;
						min = altitudes[minh][minw];
					}
					Basin basin = basins[minh][minw];
					if (basin == null) {
						basin = new Basin();
						basin.members = new HashSet<Integer>();
						basins[minh][minw] = basin;
					}
					if(basins[j][k]!= null && basin != basins[j][k]) {
						basin.members.addAll(basins[j][k].members);
						for (int pos : basins[j][k].members) {
							int posh = pos / 100;								
							int posw = pos % 100;
							System.out.println("Pos:" + pos+ ", posh:" + posh + ", posw:" + posw);
							basins[posh][posw] = basin;
						}
					}
							
					basin.members.add(minh*100+minw);
					basin.members.add(j*100+k);
					basins[j][k] = basin;
					if (minh==j && minw == k) {
						basin.sinkh = j;
						basin.sinkw = k;
					}
					System.err.print("h=" + j + ", w=" + k + ":");
					print(basins);
				}
			}
			StringBuilder b = new StringBuilder();
			char nextLetter = 'a';
			for (int j = 0; j < h; j++) {				
				for (int k = 0; k < w; k++) {
					char c = basins[j][k].letter;
					if (c == ' ') {
						c = nextLetter;
						nextLetter++;
						basins[j][k].letter = c;
					}
					b.append(c).append(' ');
				}
				b.setCharAt(b.length()-1, '\n');
			}
			out.println("Case #" + (i+1)+ ":");
			out.print(b);
		}
	}

	private static void print(Basin[][] basins) {
		Set<Basin> printed = new HashSet<Basin>();
		for (int i = 0; i < basins.length; i++) {
			for (int j = 0; j < basins[i].length; j++) {
				Basin basin = basins[i][j];
				if(basin!=null) {
					if(!printed.contains(basin)) {
						System.err.print(basin.members + "<" + basin.sinkh + "," + basin.sinkw + ">");
						printed.add(basin);
					}
				}
						
			}
		}
		System.err.println();
	}

	private static int[][] readAltitudes(int h, int w, BufferedReader reader) throws IOException {
		int[][] altitudes = new int[h][w];
		for (int i = 0; i < h; i++) {
			String[] strings = reader.readLine().split(" ");
			for (int j = 0; j < w; j++) {
				altitudes[i][j] = Integer.parseInt(strings[j]);
			}
		}
		return altitudes;
	}
}
