package firstround;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;

public class Problem1 {


	public static void main(final String[] args) throws NumberFormatException,
			IOException {
		final BufferedReader r = new BufferedReader(new FileReader(args[0]));
		final PrintStream out = new PrintStream(new FileOutputStream("round1/p1.out"));
		new Problem1().run(r, out);
		

	}


	private void run(BufferedReader r, PrintStream out) throws NumberFormatException, IOException {
		final int cases = Integer.parseInt(r.readLine());
		readAndProcessCases(r, out, cases);
		
	}

	private void readAndProcessCases(final BufferedReader r,
			final PrintStream out, final int cases) throws IOException {
		for (int i = 0; i < cases; i++) {
			int n = Integer.parseInt(r.readLine());
			String[] stringVector = r.readLine().split("\\s+");
			int[] vector1 = new int[n];
			for (int j = 0; j < stringVector.length; j++) {
				vector1[j] = Integer.parseInt(stringVector[j]);
			}
			stringVector = r.readLine().split("\\s+");
			int[] vector2 = new int[n];
			for (int j = 0; j < stringVector.length; j++) {
				vector2[j] = Integer.parseInt(stringVector[j]);
			}
			long result = process(vector1, vector2);			
			write(i + 1, out, result);
		}
	}

	private long process(int[] vector1, int[] vector2) {
		Arrays.sort(vector1);
		Arrays.sort(vector2);
		long sum = 0;
		int n = vector1.length;
		for (int i=0; i<n; i++) {
			sum+=vector1[i]*vector2[n-1-i];
		}
		return sum;
	}


	/**
	 * @param case
	 * @param out
	 * @param result 
	 */
	private void write(final int i, final PrintStream out, long result) {
		out.println("Case #" + i + ": " + result);

	}
}
