import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.LinkedList;
import java.util.List;
import java.util.regex.Pattern;


public class AlienLanguage {

	public static void main(String[] args) throws IOException {
		PrintStream out;
		if (args[0].contains("test")) {
			out = System.out;
		} else {
			out = new PrintStream(new File(args[0].substring(0, args[0].length()-3)) + ".out");
		}
		BufferedReader reader = new BufferedReader(new FileReader(args[0]));
		String[] ldn = reader.readLine().split(" ");
//		int l = Integer.parseInt(ldn[0]);
		int d = Integer.parseInt(ldn[1]);
		int n = Integer.parseInt(ldn[2]);
		List<String> words = new LinkedList<String>();
		for (int i = 0; i < d; i++) {
			words.add(reader.readLine());
		}
		for (int i = 0; i < n; i++) {
			int sum = 0;
			String pattern = convertPattern(reader.readLine());
//			System.out.println(pattern);
			Pattern p = Pattern.compile(pattern);
			for (String word : words) {				
				if (p.matcher(word).matches()) {
					sum++;
				}
			}
			out.println("Case #" + (i+1)+ ": " + sum);
		}
	}

	private static String convertPattern(String alienPattern) {
		StringBuilder b = new StringBuilder();
		boolean opened = false;
		boolean justOpened = false;
		for (int i = 0; i < alienPattern.length(); i++) {
			char c = alienPattern.charAt(i);
			switch (c) {
			case '(':
				b.append('(');
				opened = true;
				justOpened = true;
				break;
			case ')':
				opened = false;
				justOpened = false;
				b.append(')');
				break;
			default:
				if (opened) {
					if(justOpened) {
						b.append(c);
						justOpened = false;
					} else {
						b.append('|');						
						b.append(c);						
					}
				} else {
					b.append(c);						
				}
				break;
			}
		}
		return b.toString();
	}
}
