import java.io.IOException;
import java.io.PrintWriter;
import java.lang.reflect.Array;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;

/**
 * Created by Adam on 4/15/2016.
 */
public class Round1A {

    private final static String INPUT_FILE_NAME = "C:/Users/Adam/Desktop/C-small-attempt0.in";
    private final static String OUTPUT_FILE_NAME = "C:/Users/Adam/Desktop/output.txt";
    private static PrintWriter printwriter;

    public static void main(String[] args) throws IOException {
        Path path = Paths.get(INPUT_FILE_NAME);
        List<String> lines = Files.readAllLines(path);
        printwriter = new PrintWriter(OUTPUT_FILE_NAME);

        lines.remove(0);
        GraphWithDFS graph;

        int j = 0;
        for (int i = 1; i < lines.size(); i += 2){
            j += 1;
            graph = new GraphWithDFS(lines.get(i));
            printwriter.println("Case #" + j + ": " + graph.getLength());
        }

//        for (int i = 1; i <= lastWords.size(); i += 1){
//            String str = "Case #" + i + ": " + lastWords.get(i - 1);
//            printwriter.println(str);
//        }
        printwriter.close();
    }


    private static class GraphWithDFS{

        private HashMap<Integer, Integer> graph;
        private ArrayList<Integer> cycle;
        private ArrayList<Integer> maxCycle;
        private int longestCycle;
        private int tempCount;
        private boolean[] marked;
        private int original;
        private boolean isCycle;

        public GraphWithDFS(String bffs){
            maxCycle = new ArrayList<>();
            cycle = new ArrayList<>();
            graph = new HashMap<>();
            String[] separatedBFFS = bffs.split(" ");
            ArrayList<Integer> nums = new ArrayList<>();
            for (String s: separatedBFFS){
                nums.add(Integer.parseInt(s));
            }
            for (int i = 1; i <= nums.size(); i += 1){
                graph.put(i, nums.get(i - 1));
            }
            tempCount = 0;
            marked = new boolean[nums.size()];
            isCycle = false;

            realDFS();
        }

        int getLength()
        {
            return longestCycle;
        }

        private int lastElement = 0;
        private ArrayList<Integer> route;
        private void realDFS(){
            for (int i: graph.keySet()){
                tempCount = 1;
                Arrays.fill(marked, false);
                route = new ArrayList<>();
                lastElement = 0;

                newDepthFirstSearch(i);
                filterRoute();

                ArrayList<Integer> leftOvers = recreateLeftOvers();

                reverseDFS(leftOvers);

                longestCycle = tempCount > longestCycle ? tempCount : longestCycle;
            }
        }

        private void filterRoute(){
            boolean isClean = false;
            while (!isClean){
                if (route.size() > 1 && !Objects.equals(graph.get(route.get(route.size() - 1)), route.get(0))){
                    route.remove(route.size() - 1);
                }
                else if (route.size() >= 3 && !Objects.equals(graph.get(route.get(route.size() - 1)), route.get(route.size() - 2))){
                    route.remove(route.size() - 1);
                }
                else {
                    isClean = true;
                }
            }
        }

        private void reverseDFS(ArrayList<Integer> list){
            for (int kid: list){
                marked[kid - 1] = true;
                if (graph.get(kid) == lastElement){
                    lastElement = kid;
                    tempCount += 1;
                    reverseDFS(recreateLeftOvers());
                }
            }
        }

        private ArrayList<Integer> recreateLeftOvers(){
            ArrayList<Integer> leftOvers = new ArrayList<>();
            for (int j = 0; j < marked.length; j += 1){
                if (!marked[j]){
                    leftOvers.add(j + 1);
                }
            }
            return leftOvers;
        }

        private void newDepthFirstSearch(int child){
            route.add(child);
            lastElement = child;
            marked[child - 1] = true;
            if (!marked[graph.get(child) - 1]){
                tempCount += 1;
                newDepthFirstSearch(graph.get(child));
            }
        }

//        private void depthFirstSearch(int child){
//            original = child;
//            cycle.add(original);
//            depthFirstSearchHelper(child);
//            if (isCycle && tempCount > longestCycle){
//                for (int i : cycle){
//                    maxCycle.add(i);
//                    longestCycle = maxCycle.size();
//                }
//            }
//            isCycle = false;
//            tempCount = 0;
//            Arrays.fill(marked, false);
//        }
//
//        private void depthFirstSearchHelper(int child){
//            tempCount += 1;
//            marked[child - 1] = true;
//            int bff = graph.get(child);
//            if (bff == original){
//                isCycle = true;
//            }
//            else if (!marked[bff - 1]){
//                cycle.add(bff);
//                depthFirstSearchHelper(graph.get(child));
//            }
//        }
    }
}
