import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * Created by Adam on 4/8/2016.
 */
public class Jamcoins {

    public static void main(String[] args) throws IOException {

        //Given length N and J-number of jamcoins necessary
        String output = "C:/Users/Adam/Desktop/output.txt";
        List<String> lines = Files.readAllLines(Paths.get("C:/Users/Adam/Desktop/C-small-attempt0.in"));
        PrintWriter printWriter = new PrintWriter(output);

        String nandj = lines.get(1);
        String[] arr = nandj.split(" ");
        int n = Integer.parseInt(arr[0]);
        int j = Integer.parseInt(arr[1]);
        long starting[] = new long[n];
        Arrays.fill(starting, 0);
        starting[0] = 1;
        starting[starting.length - 1] = 1;
        HashMap<String, ArrayList<Long>> map = new HashMap<>();

        int howMany = 0;
        while (howMany < j){
            ArrayList<Long> toTest = baseXHelper(starting);

            if (allComposite(toTest)){
                ArrayList<Long> factors = findFactors(toTest);

                map.put(Long.toBinaryString(toDecimalFromBinary(starting)), factors);
                howMany += 1;
            }

            starting = toBinaryArray(toDecimalFromBinary(starting) + 2);
        }

        printWriter.println("Case #1:");
        for (String key: map.keySet()){
            printWriter.print(key + " ");
            for (long value: map.get(key)){
                printWriter.print(value + " ");
            }
            printWriter.println();
        }
        printWriter.close();
    }

    public static ArrayList<Long> findFactors(ArrayList<Long> toTest){
        ArrayList<Long> toReturn = new ArrayList<>();
        for (long i: toTest){
            for (long j = 3; j <= i / 2; j += 1){
                if (i % j == 0){
                    toReturn.add(j);
                    j = i;
                }
            }
        }
        return toReturn;
    }

    public static boolean allComposite(ArrayList<Long> toTest){
        for (long i: toTest){
            if (isPrime(i)){
                return false;
            }
        }
        return true;
    }

    public static ArrayList<Long> baseXHelper(long[] binary){
        ArrayList<Long> toReturn = new ArrayList<>();
        for (long base = 2; base <= 10; base += 1){
            long toAdd = 0;
            for (int i = 0; i < binary.length; i += 1){
                if (binary[i] == 1){
                    toAdd += Math.pow(base, binary.length - i - 1);
                }
            }
            toReturn.add(toAdd);
        }
        return toReturn;
    }

    public static long toDecimalFromBinary(long[] binary){
        long toReturn = 0;
        for (int i = 0; i < binary.length; i += 1){
            if (binary[i] == 1){
                toReturn += Math.pow(2, binary.length - i - 1);
            }
        }
        return toReturn;
    }

    public static long[] toBinaryArray(long n){
        char[] arr = Long.toBinaryString(n).toCharArray();
        long[] toReturn = new long[arr.length];
        for (int i = 0; i < arr.length; i += 1){
            toReturn[i] = arr[i] - 48;
        }
        return toReturn;
    }


    public static boolean isPrime(long n){
        if (n % 2 == 0){return false;}
        for (long i = 3; i * i <= n; i += 2){
            if (n % i == 0){
                return false;
            }
        }
        return true;
    }
}
