package qualround;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.List;

import javax.management.RuntimeErrorException;

public class C {
	// ..................................0....1....2....3....4
	static char[] values = new char[] { '0', '1', 'i', 'j', 'k' };
	static char[] charToValues = new char[255];
	static int[][] mult = new int[5][];

	public static void main(String[] args) throws IOException {
		charToValues['1'] = 1;
		charToValues['i'] = 2;
		charToValues['j'] = 3;
		charToValues['k'] = 4;

		mult[1] = new int[] { 0, 1, 2, 3, 4 };
		mult[2] = new int[] { 0, 2, -1, 4, -3 };
		mult[3] = new int[] { 0, 3, -4, -1, 2 };
		mult[4] = new int[] { 0, 4, 3, -2, -1 };

		String fileName = args[0];
		List<String> lines = Files.readAllLines(Paths.get(fileName));

		int n = Integer.parseInt(lines.get(0));

		for (int i = 0; i < n; i++) {
			int caseN = 1 + i;
			String line1 = lines.get(1 + 2 * i);
			String line2 = lines.get(2 + 2 * i);
			String[] split1 = line1.split("\\s");
			int len = Integer.parseInt(split1[0]);
			int times = Integer.parseInt(split1[1]);
			String s = line2;
			StringBuilder sb = new StringBuilder(len * times);
			for (int j = 0; j < times; j++) {
				sb.append(s);
			}
			boolean possible = testIJK(sb.toString().toCharArray());
			String result = possible ? "YES" : "NO";
			System.out.println(String.format("Case #%d: %s", caseN, result));
		}
	}

	public static boolean testIJK(char[] s) {
		int len = s.length;

		if (len < 3) {
			return false;
		}
		if (len == 3) {
			return Arrays.equals("ijk".toCharArray(), s);
		}

		int leftValue = 1;
		for (int left = 0; left < len - 2; left++) {
			int leftChar = charToValues[s[left]];
			leftValue = mult(leftValue, leftChar);

			if (leftValue != 2) {
				continue;
			}

			int rightValue = 1;
			int[] midValues = getValues(s, left + 1);
			for (int right = len - 1; right >= left + 2; right--) {
				int rightChar = charToValues[s[right]];
				rightValue = mult(rightChar, rightValue);
				if (rightValue != 4) {
					continue;
				}

				int midValue = midValues[right - 1];

				if (midValue == 3) {
					return true;
				}
			}
		}

		return false;
	}

	public static int[] getValues(char[] s, int from) {
		int[] arr = new int[s.length];
		int curr = 1;
		for (int i = from; i < s.length; i++) {
			char c = s[i];
			int v = charToValues[c];
			curr = mult(curr, v);
			arr[i] = curr;
		}

		return arr;
	}

	public static int mult(int a, int b) {
		int sign = a * b < 0 ? -1 : 1;
		a = Math.abs(a);
		b = Math.abs(b);

		int v = mult[a][b];

		return sign * v;
	}
}
