package com;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class TicTac {

	public static void main(String[] args) throws IOException {
		File file = new File(args[0]);
		BufferedReader reader = new BufferedReader(new FileReader(file));

		String line;
		line = reader.readLine();
		int n = Integer.parseInt(line);
		char[][] table = new char[4][4];

		for (int j = 0; j < n; j++) {
			for (int i = 0; i < 4; i++) {
				line = reader.readLine();
				for (int k = 0; k < 4; k++) {
					table[i][k] = line.charAt(k);
				}
			}
			solve(j, table);
			line = reader.readLine();
		}

		reader.close();
	}

	private static void solve(int j, char[][] table) {
		for (int i = 0; i < 4; i++) {
			char result = step(i, 0, 0, 1, table);
			if (result != 0 && result != 255) {
				print(j, result);
				return;
			}
			result = step(0, i, 1, 0, table);
			if (result != 0 && result != 255) {
				print(j, result);
				return;
			}
		}
		char result = step(0, 0, 1, 1, table);
		if (result != 0 && result != 255) {
			print(j, result);
			return;
		}
		result = step(3, 0, -1, 1, table);
		print(j, result);
	}

	private static char step(int x, int y, int stepx, int stepy, char[][] table) {
		char c = 'T';
		for (int i = 0; i < 4; i++) {
			char cn = table[x][y];
			if (cn == 'T') {
			} else if (c == 'T') {
				c = cn;
			} else if (cn == '.') {
				return 255;
			} else if (c != cn) {
				return 0;
			}
			x += stepx;
			y += stepy;
		}

		return c;
	}

	private static void print(int i, char result) {
		System.out.print("Case #" + (i + 1) + ": ");
		if (result == 0) {
			System.out.println("Draw");
		} else

		if (result == 255) {
			System.out.println("Game has not completed");
		} else {
			System.out.println(result + " won");
		}
	}
}
