package qualround;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.List;

import javax.management.RuntimeErrorException;

public class B2 {
	static int[][] opt;

	public static void main(String[] args) throws IOException {
		String fileName = args[0];
		List<String> lines = Files.readAllLines(Paths.get(fileName));

		int n = Integer.parseInt(lines.get(0));

		for (int i = 0; i < 2 * n; i += 2) {
			int caseN = 1 + i / 2;
			String line1 = lines.get(1 + i);
			String line2 = lines.get(2 + i);
			int d = Integer.parseInt(line1);
			String[] split = line2.split("\\s");
			int[] arr = new int[d];
			for (int j = 0; j < arr.length; j++) {
				arr[j] = Integer.parseInt(split[j]);
			}

			int steps = solve(arr, 0);

			System.out.println(String.format("Case #%d: %d", caseN, steps));
		}

//		System.out.println(solve(new int[] { 5, 20 }, 0));
//		System.out.println(solve(new int[] { 5, 5, 5, 5, 9, 9 }, 0));
//		System.out.println(solve(new int[] { 5, 9 }, 0));
//		System.out.println(solve(new int[] { 5, 10 }, 0));
		// System.out.println(findMin(new int[] { 2, 9, 9, 9, 3, 3 }));
		// System.out.println(findMin(new int[] { 2, 9, 3 }));
	}

	private static int solve(int[] arr, int steps) {
		int[] clone = arr.clone();

		if (!decreaseAll(clone)) {
			return steps;
		}

		int decreaseSteps = solve(clone, steps + 1);

		int[] split = splitLargest(arr);

		int splitSteps = Integer.MAX_VALUE;

		if (split != null) {
			splitSteps = solve(split, steps + 1);
		}

		return Math.min(decreaseSteps, splitSteps);
	}

	private static int[] splitLargest(int[] arr) {
		Arrays.sort(arr);
		int largest = arr[arr.length - 1];
		if (largest == 1) {
			return null;
		}

		int[] newArr = Arrays.copyOf(arr, arr.length + 1);
		int a = largest / 2;
		int b = largest - a;
		newArr[newArr.length - 2] = a;
		newArr[newArr.length - 1] = b;
		return newArr;
	}

	private static boolean decreaseAll(int[] arr) {
		boolean retval = false;
		for (int i = 0; i < arr.length; i++) {
			if (arr[i] > 0) {
				arr[i]--;
				retval = true;
			}
		}
		return retval;
	}
}
