package qualifier;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

public class BotTrust
{
	public static void main(String[] args) throws FileNotFoundException
	{
		File in = new File("io/qualifier/BotTrust/small.in");
		File out = new File("io/qualifier/BotTrust/small.out");
		PrintWriter pw = new PrintWriter(out);
		
		Scanner fScan = new Scanner(in);
		int numCases = fScan.nextInt();
		fScan.nextLine();
		
		for(int i = 1; i <= numCases; i++)
		{
			String s = "Case #" + i + ": " + solve(fScan.nextLine());
			pw.println(s);
			System.out.println(s);
		}
		pw.close();
	}
	
	public static int solve(String in)
	{
		Scanner s = new Scanner(in);
		int numButtons = s.nextInt();
		
		String[] robots = new String[numButtons];
		int[] buttons = new int[numButtons];
		int[] minTime = new int[numButtons];

		for(int i = 0; i < numButtons; i++)
		{
			robots[i] = s.next();
			buttons[i] = s.nextInt();
		}
		
		int oX = 1, bX = 1; // x positions of the robots
		int deltaO = 0, deltaB = 0; // distance to move
		for(int i = 0; i < minTime.length; i++)
		{
			int nextO = nextO(robots, buttons, i);
			// Distance O needs to move
			if(nextO != -1)
				deltaO = Math.abs(oX - buttons[nextO]);
				
			int nextB = nextB(robots, buttons, i);
			// Distance B needs to move
			if(nextB != -1)
				deltaB = Math.abs(bX - buttons[nextB]);

			// We need to press orange's button
			if(robots[i].equals("O"))
			{
//				System.out.println("Next press is Orange " + buttons[i] + ". O at " + oX + ", B at " + bX);
				
				// Time to move and press O's button
				if(i > 0)
					minTime[i] = minTime[i-1]; // elapsed time
				minTime[i] += deltaO + 1; // move and press
				// Update locations
				oX = buttons[i];
				if(nextB != -1)
				{
				bX = (deltaB <= deltaO + 1)
					? (nextB != -1) // if there is a nextB
						? buttons[nextB] // it moves less than orange does, so we'll put it there
						: bX // no more movement needed
					: (buttons[nextB] - bX > 0) 
						? bX + deltaO + 1 // moving right
						: bX - (deltaO + 1); // moving right
				}
			}
			// Need to press blue's button
			else
			{
//				System.out.println("Next press is Blue " + buttons[i] + ". O at " + oX + ", B at " + bX);

				// Time to move and press O's button
				if(i > 0)
					minTime[i] = minTime[i-1]; // elapsed time
				minTime[i] += deltaB + 1; // move and press
				// Update locations
				bX = buttons[i];
				if(nextO != -1)
				{
				oX = (deltaO <= deltaB + 1)
					? (nextO != -1)
						? buttons[nextO] // it moves less than orange does, so we'll put it there
						: oX
					: (buttons[nextO] - oX > 0) 
						? oX + deltaB + 1 // moving right
						: oX - (deltaB + 1); // moving right
				}
			}
//			System.out.println("After moving, O at " + oX + ", B at " + bX + ". Elapsed time: " + minTime[i]);
//			System.out.println();
		}
		return minTime[minTime.length - 1];
	}
	
	public static int nextO(String[] robot, int[] button, int index)
	{
		for(int i = index; i < robot.length; i++)
		{
			if(robot[i].equals("O"))
				return i;
		}
		return -1;
	}
	
	public static int nextB(String[] robot, int[] button, int index)
	{
		for(int i = index; i < robot.length; i++)
		{
			if(robot[i].equals("B"))
				return i;
		}
		return -1;
	}
}
