import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;


public class War {

	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner(new File("io/war.in"));
		FileWriter fw = new FileWriter(new File("io/war.out"));
		
		int cases = in.nextInt();
		for(int i = 0; i < cases; i++) {
			int blocks = in.nextInt();
			
			double[] naomi = new double[blocks];
			for(int n = 0; n < blocks; n++) {
				naomi[n] = in.nextDouble();
			}

			double[] ken = new double[blocks];
			for(int k = 0; k < blocks; k++) {
				ken[k] = in.nextDouble();
			}
			
			String out = "Case #" + (i+1) + ": " + DWar(naomi, ken) + " " + NWar(naomi, ken);
			System.out.println(out);
			fw.write(out + "\n");
		}
		in.close();
		fw.close();

	}
	
	public static int NWar(double[] nArr, double[] kArr) {
		LinkedList<Double> n = arrayToList(nArr);
		LinkedList<Double> k = arrayToList(kArr);
		
		int nWins = 0;
		
		while(n.size() > 0) {
			double nChoice = n.removeFirst();
			double kChoice = 1;
			Iterator<Double> kIter = k.iterator();
			while(kIter.hasNext()) {
				double kNext = kIter.next();
				if(kNext < kChoice && kNext > nChoice) {
					kChoice = kNext;
				}
			}
			if(kChoice == 1) {
				nWins++;
				k.removeFirst();
			}
			else {
				k.remove(kChoice);
			}
		}
		
		return nWins;
	}
	
	public static int DWar(double[] nArr, double[] kArr) throws Exception {
		LinkedList<Double> n = arrayToList(nArr);
		LinkedList<Double> k = arrayToList(kArr);
		
		int nWins = 0;
		
		while(n.size() > 1) {
			System.out.println(n.toString());
			System.out.println(k.toString());
			
			double nChoice = 0;
			double nTell = 0;
			double kChoice;
			
			// my smallest loses to his smallest, so we throw it away on his biggest
			if(n.peekFirst() < k.peekFirst()) {
				System.out.println("A");
				nChoice = n.removeFirst();
				nTell = k.peekLast() - 0.00001;
			}
			// My smallest beats his smallest, so we play my smallest and lie that it is bigger than his biggest to draw it out.
			else if(n.peekFirst() > k.peekFirst()) {
				System.out.println("C");
				nChoice = n.removeFirst();
				nTell = getSmallestBiggerThan(n, k.peekLast());;
			}
			else {
				throw new Exception();
			}
			kChoice = 1;
			Iterator<Double> kIter = k.iterator();
			while(kIter.hasNext()) {
				double kNext = kIter.next();
				if(kNext < kChoice && kNext > nTell) {
					kChoice = kNext;
				}
			}
			if(kChoice == 1) {
				nWins++;
				kChoice = k.removeFirst();
			}
			else {
				k.remove(kChoice);
			}
			
			System.out.println("Nchoice: " + nChoice + " Ntell: " + nTell + " K: " + kChoice);
			System.out.println();
			
			
		}
		
		System.out.println(n.toString());
		System.out.println(k.toString());

		if(n.removeFirst() > k.removeFirst())
			nWins++;
		
		return nWins;
	}
	
	private static double getSmallestBiggerThan(LinkedList<Double> nList, Double minBound) {
		double toTell = 1;
		Iterator<Double> nIter = nList.iterator();
		while(nIter.hasNext()) {
			double n = nIter.next();
			if(n > minBound && n < toTell) {
				toTell = n;
			}
		}
		return toTell;
	}

	private static double getHeaviestLessThan(LinkedList<Double> n, Double peekLast) {
		double toTell = 0;
		Iterator<Double> nIter = n.iterator();
		while(nIter.hasNext()) {
			double nNext = nIter.next();
			if(nNext > toTell && nNext < peekLast) {
				toTell = nNext;
			}
		}
		return toTell;
	}

	public static LinkedList<Double> arrayToList(double[] arr) {
		Arrays.sort(arr);
		LinkedList<Double> list = new LinkedList<Double>();
		for(int i = 0; i < arr.length; i++) {
			list.addLast(arr[i]);
		}
		return list;
	}
	

}
