import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;


public class Dancing {

	public static void main(String[] args) throws IOException {
		Scanner s = new Scanner(new File("io/B-small-attempt1.in"));
		FileWriter fw = new FileWriter(new File("io/B-small-attempt1.out"));
		
		int cases = s.nextInt();

		for(int i = 0; i < cases; i++) {
			int numPeople = s.nextInt(); // num people
			int numSurprising = s.nextInt(); // num surprising
			int p = s.nextInt(); // best result
			int[] totals = new int[numPeople];
			for(int j = 0; j < numPeople; j++) {
				totals[j] = s.nextInt();
			}
			
			String out = "Case #" + (i+1) + ": " + solve(numPeople, numSurprising, p, totals);
			System.out.println(out);
			fw.write(out + "\n");
		}
		fw.close();
		s.close();
	}

	private static int solve(int numPeople, int numSurprising, int p, int[] totals) {
		int count = 0;
		System.out.println();
		System.out.println("Surprising: " + numSurprising);
		System.out.println("Target: " + p);
		
		int[][] scores = new int[numPeople][7];
		for(int i = 0; i < numPeople; i++) {
			int minScore = (totals[i] % 3 == 0) ? (totals[i]-1) / 3 : totals[i] / 3;
			scores[i][0] = minScore;
			scores[i][1] = minScore;
			scores[i][2] = minScore;
			scores[i][3] = totals[i] - (minScore * 3); // points not yet allocated
			scores[i][4] = (scores[i][0] + scores[i][3] >= p) ? 1 : 0; // can surprise (0=false, 1=true)
			scores[i][5] = p - (minScore + Math.min(2, scores[i][3])); // surprised distance to p
			
			// Can surprise AND only counts if surprised -- We want to surprise as many of these as possible!
			if(minScore + 2 == p && scores[i][3] + minScore >= p) {
				scores[i][6] = 1;
			}
			
		}
		
		// We still need to surprise, Trigger the ones that MUST surprise
		for(int i = 0; i < numPeople && numSurprising > 0 && hasMustSurprise(scores); i++) {
			// Found one
			if(scores[i][6] == 1) {
				scores[i][6] = 0;  // mark "MUST surprise" as false (because we're doing it now)
				scores[i][0] += 2; // make it surprised!
				scores[i][3] -= 2; // deduct points not yet allocated
				numSurprising--;
			}
		}
		
		for(int i = 0; i < numPeople; i++)
			System.out.println(Arrays.toString(scores[i]));
		
		// Distribute points evenly from left to right
		for(int i = 0; i < numPeople; i++) {
			if(scores[i][3] == 3) {
				scores[i][0]++;
				scores[i][3]--;
			}
			if(scores[i][3] == 2) {
				scores[i][1]++;
				scores[i][3]--;
			}
			if(scores[i][3] == 1) {
				scores[i][2]++;
				scores[i][3]--;
			}
		}
		
		// We've triggered all that MUST surprise and distributed points, so now distribute the remaining surprises
		for(int i = 0; i < numPeople && numSurprising > 0; i++) {
			// Check for already surprising
			if(Math.abs(scores[i][0] - scores[i][1]) == 2
					|| Math.abs(scores[i][0] - scores[i][2]) == 2
					|| Math.abs(scores[i][1] - scores[i][2]) == 2) {
				continue;
			}
			else {
				if(scores[i][0] == scores[i][1]) {
					scores[i][0]++;
					scores[i][1]--;
					numSurprising--;
				}
				else if(scores[i][1] == scores[i][2]) {
					scores[i][1]++;
					scores[i][2]--;
					numSurprising--;
				}
				else if(scores[i][0] == scores[i][2]) {
					scores[i][0]++;
					scores[i][2]--;
					numSurprising--;
				}
			}
		}
		
		for(int i = 0; i < numPeople; i++) {
			System.out.print(totals[i] + " | " + scores[i][0] + " " + scores[i][1] + " " + scores[i][2]);
			if(Math.abs(scores[i][0] - scores[i][1]) == 2
					|| Math.abs(scores[i][0] - scores[i][2]) == 2
					|| Math.abs(scores[i][1] - scores[i][2]) == 2) {
				System.out.print(" (SURP)");
			}
			if(scores[i][0] >= p || scores[i][1] >= p || scores[i][2] >= p) {
				System.out.print(" (MAX)");
				count++;
			}
			System.out.println();
		}
		
		return count;
	}
	
	private static boolean hasMustSurprise(int[][] scores) {
		for(int i = 0; i < scores.length; i++) {
			if(scores[i][6] == 1)
				return true;
		}
		return false;
	}
	
}
