package qualifier;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.Scanner;

public class Magicka
{
	public static void main(String[] args) throws FileNotFoundException
	{
		Magicka m = new Magicka();
		File in = new File("io/qualifier/Magicka/B-small-attempt0.in");
		File out = new File("io/qualifier/Magicka/small.out");
		PrintWriter pw = new PrintWriter(out);
		
		Scanner fScan = new Scanner(in);
		int numCases = fScan.nextInt();
		fScan.nextLine();
		
		for(int i = 1; i <= numCases; i++)
		{
			String s = "Case #" + i + ": " + m.solve(fScan.nextLine()).toString();
			pw.println(s);
			System.out.println(s);
		}
		pw.close();
	}
	
	public MagicDeque solve(String in)
	{
		Scanner s = new Scanner(in);
		
		// Combine
		int numC = s.nextInt();
		// each contains three characters: two base elements followed by a non-base element.
		String[] c = new String[numC];
		for(int i = 0; i < numC; i++)
			c[i] = s.next();
		
		// Opposed
		int numD = s.nextInt();
		// each contains two characters: two base elements that are opposed to each other.
		String[] d = new String[numD];
		for(int i = 0; i < numD; i++)
			d[i] = s.next();
		
		// Base Elements to Invoke
		int numN = s.nextInt();
		String toInvoke = s.next();
		
		MagicDeque md = new MagicDeque(c, d);
		for(int i = 0; i < numN; i++)
		{
			md.offerLast(toInvoke.charAt(i));
		}
		return md;
	}
	
	private class MagicDeque
	{
		private LinkedList<Character> deque;
		private String[] combine;
		private String[] opposed;
		
		/**
		 * 
		 * @param c Combine - Sets of 3 characters (two base elements followed by a non base element)
		 * @param d Opposed - Sets of two characters that oppose each other.
		 */
		public MagicDeque(String[] c, String[] d)
		{
			deque = new LinkedList<Character>();
			combine = c;
			opposed = d;
		}
		
		public void offerLast(char c)
		{
			if(combine(c) != 0)
			{
				char newC = combine(c);
				deque.pollLast();
				deque.offerLast(newC);
			}
			else if(isOpposed(c))
				deque.clear();
			else
				deque.offerLast(c);
		}
		
		private boolean isOpposed(char c)
		{
			// For each opposed
			for(int i = 0; i < opposed.length; i++)
			{
				// Make sure it counts
				if(opposed[i].charAt(0) == c)
				{
					if(deque.contains(opposed[i].charAt(1)))
						return true;
				}
				if(opposed[i].charAt(1) == c)
				{
					if(deque.contains(opposed[i].charAt(0)))
						return true;
				}
			}
			return false;
		}

		private char combine(char c)
		{
			if(deque.size() == 0)
				return 0;
			char last = deque.peekLast();
			for(int i = 0; i < combine.length; i++)
			{
				if(  (combine[i].charAt(0) == last && combine[i].charAt(1) == c)
				  || (combine[i].charAt(1) == last && combine[i].charAt(0) == c))
				{
					return combine[i].charAt(2);
				}
			}
			return 0;
		}

		public String toString()
		{
			Iterator<Character> iter = deque.iterator();
			String s = "[";
			while(iter.hasNext())
			{
				s += iter.next();
				if(iter.hasNext())
					s += ", ";
			}
			s += "]";
			return s;
		}
	}
}
