import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Magic {
	public static final int NOT_FOUND = -1;
	public static final int BAD = -2;
	public static final int CHEAT = -3;

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new File("io/magic.in"));
		FileWriter fw = new FileWriter(new File("io/magic.out"));
		
		int cases = in.nextInt();
		for(int i = 0; i < cases; i++) {
			int rowA = in.nextInt();
			int[][] boardA = {
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()},
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()},
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()},
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()}
			};
			
			int rowB = in.nextInt();
			int[][] boardB = {
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()},
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()},
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()},
					{in.nextInt(), in.nextInt(), in.nextInt(), in.nextInt()}
			};
			
			String out = "Case #" + (i+1) + ": " + solve(boardA[rowA-1], boardB[rowB-1]);
			System.out.println(out);
			fw.write(out + "\n");
		}
		in.close();
		fw.close();

	}
	
	public static String solve(int[] rowA, int[] rowB) {
		int possible = NOT_FOUND;
		
		for(int i = 0; i < rowA.length; i++) {
			if(indexOf(rowB, rowA[i]) != -1) {
				possible = (possible == NOT_FOUND) ? rowA[i] : BAD;
			}
		}
		
		if(possible == NOT_FOUND) {
			return "Volunteer cheated!";
		}
		else if(possible == BAD) {
			return "Bad magician!";
		}
		else
			return "" + possible;
	}

	public static int indexOf(int[] arr, int n) {
		for(int i = 0; i < arr.length; i++) {
			if(arr[i] == n) {
				return i;
			}
		}
		return -1;
	}

}
