import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.File;

import java.util.Map;
import java.util.HashMap;

public class GCJ_qr_a {
	
	private static final String input1 =  "ejp mysljylc kd kxveddknmc re jsicpdrysi";
	private static final String output1 = "our language is impossible to understand";	

	private static final String input2 =  "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd";
	private static final String output2 = "there are twenty six factorial possibilities";	

	private static final String input3 =  "de kr kd eoya kw aej tysr re ujdr lkgc jv";
	private static final String output3 = "so it is okay if you want to just give up";	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Map<Character, Character> dict = new HashMap<Character, Character>();
		
		//step 1: compile the cipher dictionary
		for(int i = 0; i < input1.length(); i += 1) {
			dict.put(input1.charAt(i), output1.charAt(i));
		}
		
		for(int i = 0; i < input2.length(); i += 1) {
			dict.put(input2.charAt(i), output2.charAt(i));
		}
		
		for(int i = 0; i < input3.length(); i += 1) {
			dict.put(input3.charAt(i), output3.charAt(i));
		}				
		
		dict.put('z', 'q');
		dict.put('q', 'z');		
		dict.remove(' ');
		
		/*System.out.println("Cypher length is " + dict.size());		
		for(Map.Entry<Character, Character> e : dict.entrySet()) {
			System.out.println(e.getKey() + " " + e.getValue());
		}
		
		for(int i = (int)'a'; i < (int)'z' + 1; i+=1) {
			if(!dict.containsKey((char)i)){ 
				System.out.println("Missing cypher character is: " + (char)i);
			}
			
			if(!dict.containsValue(((char)i))){ 
				System.out.println("Missing output character is: " + (char)i);
			}
		}*/
		
		
		GCJReader in = new GCJReader(args[0]);
		GCJWriter out = new GCJWriter(args[1]);
		
		int numTestCases = Integer.parseInt(in.readLine());
		
		for(int i = 1; i <= numTestCases; i+=1) {
			char[] line = in.readLine().toCharArray();
			for(int j = 0; j < line.length; j += 1) {
				if(line[j] == ' ') continue;
				line[j] = dict.get(line[j]);
			}
			
			String outLine = new String(line);
			out.writeLine(String.format("Case #%d: %s", i, outLine));
		}
	}
	
	
	
	private static class GCJWriter {
		private String outFile = null;		
		private BufferedWriter out = null;
		
		public GCJWriter(String outFile) {
			this.outFile = outFile; 
			
			try { 
				out = new BufferedWriter(new FileWriter(outFile));
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}
		
		public void writeLine(String output) {
			try {
				out.write(output + "\n");
				out.flush();
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}			
	}
	
	private static class GCJReader {
		private String inFile = null;		
		private BufferedReader in = null;
		
		public GCJReader(String inFile) {
			this.inFile = inFile; 
			
			try { 
				in = new BufferedReader(new FileReader(inFile));
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}
		
		public String readLine() {
			try {
				return in.readLine();
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
		}		
	}	
}