package googlecodejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class CodeJam_B {

    private static final String FILEPATH = "C:\\Users\\Adam\\Downloads";
    private static final String INPUTFILE = FILEPATH + "\\B-small-attempt0.in";
    private static final String OUTPUTFILE = FILEPATH + "\\B-small-attempt0.out";
    private static final String FORMAT_STR_LAST = "Case #%d: %s";
    private static final String FORMAT_STR = FORMAT_STR_LAST + "\n";
    
    public static BufferedReader reader = null;
    public static BufferedWriter writer = null;
    
    public static String solveTest() {
        final int initialPlates = Integer.parseInt(readLine());
        final String[] plateCounts = readLine().split(" ");
        
        Integer[] initialPlateCounts = new Integer[initialPlates];
        
        for(int i = 0; i < initialPlates; i++) {
            initialPlateCounts[i] = Integer.parseInt(plateCounts[i]);
        }
        
        List<Integer> plates = new LinkedList<>(Arrays.asList(initialPlateCounts));
        Collections.sort(plates);
        int moveTime = 0;
        
        while(true) {
            int size = plates.size();
            Integer largest = plates.get(size - 1);
            
            int largestCount = 1;
            int pos  = 2;
            
            while(size - pos > 0 && plates.get(size - pos).intValue() == largest.intValue()) {
                largestCount++;
                pos++;
            }
    
            if((largest.intValue() - (int)Math.ceil(largest.doubleValue() / 2.0)) > largestCount) {
                for(int i = 0; i < largestCount; i++) {
                    Integer newVal1 = Integer.valueOf((int)Math.ceil(largest.doubleValue() / 2.0));
                    Integer newVal2 = Integer.valueOf(largest.intValue() - newVal1.intValue());
                    
                    plates.remove(plates.indexOf(largest));
                    plates.add(newVal1);
                    plates.add(newVal2);
                }
                Collections.sort(plates);
                moveTime += largestCount;
            } else {
                break; //done
            }
        }
        
        Integer largestTime = plates.get(plates.size() - 1);
        
        return Integer.toString(largestTime.intValue() + moveTime);
    }
    
    
    public static void main(String[] args) {

        getReader();
        getWriter();
        
        final int numTestCases =  Integer.parseInt(readLine());
        for(int i = 1; i <= numTestCases; i++) {
            String outputLine = solveTest();
            if(i != numTestCases) {
                write(String.format(FORMAT_STR, i, outputLine));
            } else {
                write(String.format(FORMAT_STR_LAST, i, outputLine));
            }
        }
    }

    public static String readLine() {
        try {
            return reader.readLine();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return null;
        }
    }
   
    public static void write(String s) {
        try {
            writer.write(s);
            writer.flush();
            System.out.print(s);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public static void getReader() {
        try {
            reader = new BufferedReader(new FileReader(INPUTFILE));
        } catch (FileNotFoundException e) {
            e.printStackTrace();    
        }        
    }
    
    public static void getWriter() {
        try {
            writer =  new BufferedWriter(new FileWriter(OUTPUTFILE));
        } catch (IOException e) {
            e.printStackTrace();    
        }        
    }    
}