package googlecodejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class CodeJam_A {

    private static final String FILEPATH = "C:\\Users\\Adam\\Downloads";
    private static final String INPUTFILE = FILEPATH + "\\A-large.in";
    private static final String OUTPUTFILE = FILEPATH + "\\A-large.out";
    private static final String FORMAT_STR_LAST = "Case #%d: %s";
    private static final String FORMAT_STR = FORMAT_STR_LAST + "\n";
    
    public static BufferedReader reader = null;
    public static BufferedWriter writer = null;
    
    
    public static String solveTest() {
        final String[] inputLine = readLine().split(" ");
        final int shynessMax = Integer.parseInt(inputLine[0]);
        
        int[] audience = new int[shynessMax + 1];
        final char[] c = inputLine[1].toCharArray();
        
        int invited = 0;
        
        for(int i = 0; i < shynessMax; i++) {
            audience[i] = Integer.valueOf("" + c[i]);
        }

        int standing = audience[0];
        
        for(int i = 1; i < audience.length; i++) {
            if(standing >= i) {
                standing += audience[i];
                continue;
            }
            
            int friendsNeeded = i - standing;
            invited += friendsNeeded;
            standing += (friendsNeeded + audience[i]);
        }
        
        return Integer.toString(invited);
    }
    
    
    public static void main(String[] args) {

        getReader();
        getWriter();
        
        final int numTestCases =  Integer.parseInt(readLine());
        for(int i = 1; i <= numTestCases; i++) {
            String outputLine = solveTest();
            if(i != numTestCases) {
                write(String.format(FORMAT_STR, i, outputLine));
            } else {
                write(String.format(FORMAT_STR_LAST, i, outputLine));
            }
        }
    }

    public static String readLine() {
        try {
            return reader.readLine();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
            return null;
        }
    }
   
    public static void write(String s) {
        try {
            writer.write(s);
            writer.flush();
            System.out.print(s);
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }
    
    public static void getReader() {
        try {
            reader = new BufferedReader(new FileReader(INPUTFILE));
        } catch (FileNotFoundException e) {
            e.printStackTrace();    
        }        
    }
    
    public static void getWriter() {
        try {
            writer =  new BufferedWriter(new FileWriter(OUTPUTFILE));
        } catch (IOException e) {
            e.printStackTrace();    
        }        
    }    
}