import java.io.*;
 
public class qr_a {

	private static final String IN_FILE = "A-large.in";
	private static final String OUT_FILE = "A-large.out";	
	
	private static final BufferedReader in;
	private static final PrintStream out;
	
	private static final int numCases;
	
	static {
		try {
			in = new BufferedReader(new FileReader(IN_FILE));
			out = new PrintStream(OUT_FILE);
			
			numCases = Integer.parseInt(in.readLine());
			
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
	}
	
	private static final int BOARD_LEN = 4;
	private static final char[][] board = new char[BOARD_LEN][BOARD_LEN];
	private static final char EMPTY = '.';
	private static final char T = 'T';
	private static final char X = 'X';
	private static final char O = 'O';		
	
  public static void main (String[] args) {
	  
		for(int testCase = 1; testCase <= numCases; testCase +=1) {
			try {
				//read in the board
				for(int i = 0; i < board.length; i+=1) {
					board[i] = in.readLine().toCharArray();
				}
			
				//skip the empty part
				in.readLine();
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
			
			char compChar = X;
			char boardChar = EMPTY;
			boolean win = false;
			
			//scan rows for wins			
			for(int i = 0; i < board.length && !win; i += 1) {
				compChar = board[i][0];
				
				if(compChar == EMPTY) {
					continue;
				}
				
				if (compChar == T) { 
					//if row item is T, then try and get the next non-T comparison character
					//if the rest of the row is empty, then just continue
					int k = 1;
					
					while(k < board.length && !(compChar == X || compChar == O)) {
						compChar = board[i][k];
						k += 1;
					}
					
					if(compChar != X && compChar != O) {
						continue;
					}
				}
				
				//finally, iterate through the rest
				for(int j = 1; j < board.length; j +=1) {
					boardChar = board[i][j];
					
					if (boardChar != compChar && boardChar != T) {
						win = false;
						break;
					} else {
						win = true;
					}
				}
			}
			
			for(int i = 0; i < board.length && !win; i += 1) {
				compChar = board[0][i];
				
				if(compChar == EMPTY) {
					continue;
				}
				
				if (compChar == T) { 
					//if row item is T, then try and get the next non-T comparison character
					//if the rest of the row is empty, then just continue
					int k = 1;
					
					while(k < board.length && !(compChar == X || compChar == O)) {
						compChar = board[k][i];
						k += 1;
					}
					
					if(compChar != X && compChar != O) {
						continue;
					}
				}
				
				//finally, iterate through the rest
				for(int j = 1; j < board.length; j +=1) {
					boardChar = board[j][i];
					
					if(!(boardChar == compChar || boardChar == T)) {
						win = false;
						break;
					} else {
						win = true;
					}
				}
			}			
			
			
			//scan diagonal for wins
			if(!win) {
				compChar = board[0][0];
				
				if (compChar == T) { 
					//if row item is T, then try and get the next non-T comparison character
					//if the rest of the row is empty, then just continue
					int k = 1;
					
					while(k < board.length && (compChar != X || compChar != O)) {
						compChar = board[k][k];
						k += 1;
					}
				}
				
				if(compChar != EMPTY) {
					for(int i = 1; i < board.length; i += 1) {
						boardChar = board[i][i];  
						if(!(boardChar == compChar || boardChar == T)) {
							win = false;
							break;
						} else {
							win = true;
						}
					}
				}
			}
			
			if(!win) {
				
				compChar = board[0][board.length-1];
				
				if (compChar == T) { 
					//if row item is T, then try and get the next non-T comparison character
					//if the rest of the row is empty, then just continue
					int k = 1;
					
					while(k < board.length && (compChar != X || compChar != O)) {
						compChar = board[k][board.length - k - 1];
						k += 1;
					}
				}
				
				if(compChar != EMPTY) {
					for(int i = 1; i < board.length; i += 1) {
						boardChar = board[i][board.length - i - 1];
						
						if(boardChar != compChar && boardChar != T) {
							win = false;
							break;
						} else {
							win = true;
						}
					}
				}
			}
			
			StringBuilder sb = new StringBuilder("Case #" + testCase + ": ");
			if(win) {
				sb.append(compChar + " won");
			} else {
				boolean draw = true;
					
				for(int i = 0; i < BOARD_LEN; i+=1) {
					for(int j = 0; j < BOARD_LEN; j+=1) {
						if(board[i][j] == EMPTY) {
							draw = false;
							break;
						}
					}
				}
					
				if(draw) {
					sb.append("Draw");
				} else {
					sb.append("Game has not completed");					
				}
			}
			
			try {
				out.print(sb.toString());
				System.out.println(sb.toString());
				
				if(testCase != numCases) {
					out.println();
				}
			} catch (Exception e) {
				throw new RuntimeException(e);
			}
			
			
		}
	}
}