package com.adamtron;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StringReader;
import java.util.Arrays;

public class QB {

    public static BufferedReader reader;
    public static BufferedWriter writer;
    
    public static void main(String[] args) {
        initialize("B-small-attempt0.in");
        
        final int numTestCases = Integer.valueOf(readLine());
        
        for(int testCase = 1; testCase <= numTestCases; testCase++) {
            final String input = readLine();
            final char HAPPY = '+';
            final char BLANK = '-';
            
            char currentHappy = HAPPY;
            char currentBlank = BLANK;
            
            int numFlips = 0;
            
            for(int i = input.length() - 1; i >= 0;) {
                if(input.charAt(i) == currentHappy) {
                    i--;
                    continue;
                }
                
                while(input.charAt(i) == currentBlank && i > 0) {
                    i--;
                }
                
                if(i >= 0) {
                    //found the next HAPPY, do a flip
                    numFlips++;
                    char temp = currentHappy;
                    currentHappy = currentBlank;
                    currentBlank = temp;
                }
            }
            
            writeLine(String.valueOf(numFlips), testCase, numTestCases);
        }
    }
    
    public static void initialize(String testFile) {
        try {
            reader = new BufferedReader(new FileReader("C:/Users/Adam/Downloads/" + testFile));
            writer = new BufferedWriter(new FileWriter("C:/Users/Adam/Downloads/" + testFile.replace(".in", ".out")));            
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        
    }

    public static void writeLine(String output, int testCase, int maxTestCases) {
        String toWrite = "Case #" + testCase + ": " + output + "\n";
        try {
            writer.write(toWrite);
            System.out.print(toWrite);
            System.out.flush();
            writer.flush();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    
    public static String readLine() {
        try {
            return reader.readLine();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}