package com.adamtron;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StringReader;
import java.util.Arrays;

public class QA {

    public static BufferedReader reader;
    public static BufferedWriter writer;
    
    public static void main(String[] args) {
        initialize("A-large.in");
        
        final int numTestCases = Integer.valueOf(readLine());
        
        for(int testCase = 1; testCase <= numTestCases; testCase++) {
            
            int[] digitsSeen = new int[10];
            int digitCount = 0;
            boolean stop = false;
            final int startVal = Integer.parseInt(readLine());
            
            if(startVal == 0) {
                writeLine("INSOMNIA", testCase, numTestCases);
                continue;
            }
            
            for(int mult = 1; ; mult++) {
                String inputDigits = String.valueOf(startVal * mult);
                
                if(startVal * mult < 0) {
                    writeLine("INSOMNIA", testCase, numTestCases);
                }
                
                for(int i = 0; i < inputDigits.length(); i++) {
                    int digit = Character.getNumericValue(inputDigits.charAt(i));
                    
                    if(digitsSeen[digit] == 0) {
                        digitCount++;
                    }
                    
                    digitsSeen[digit] ++;
                    
                    if(digitCount == 10) {
                        writeLine(inputDigits, testCase, numTestCases);
                        stop = true;
                        break;
                    }
                }
                
                if(stop) {
                    break;
                }                
            }
        }
    }
    
    public static void initialize(String testFile) {
        try {
            reader = new BufferedReader(new FileReader("C:/Users/Adam/Downloads/" + testFile));
            writer = new BufferedWriter(new FileWriter("C:/Users/Adam/Downloads/" + testFile.replace(".in", ".out")));            
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        
    }
    
    public static void write(String output) {
        try {
            writer.write(output);
            System.out.print(output);
            System.out.flush();
            writer.flush();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    
    public static void writeLine(String output, int testCase, int maxTestCases) {
        write("Case #" + testCase + ": " + output);
        //if(testCase != maxTestCases) {
            write("\n");
        //}
    }
    
    public static String readLine() {
        try {
            return reader.readLine();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}