package com.adamtron;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.StringReader;
import java.math.BigInteger;
import java.util.Arrays;

public class QB {

    public static BufferedReader reader;
    public static BufferedWriter writer;

    public static void main(String[] args) {
        initialize("C-small-attempt0.in");
        readLine();
        String[] inputs = readLine().split(" ");
        final int N = Integer.valueOf(inputs[0]);// Integer.parseInt(inputs[0]);
        final int J = Integer.valueOf(inputs[1]); // Integer.parseInt(inputs[1]);

        long generator = (1 << (N - 1)) + 1;
        long maxVal = 1 << N;
        
        int count = 0;
        writeLine("Case #1:\n");
        
        while (count < J && generator < maxVal) {
            final String candidate = Long.toString(generator, 2);
            BigInteger[] values = new BigInteger[9];
            
            for (int i = 2; i <= 10; i++) {
                BigInteger jam = new BigInteger(candidate, i);
                
                if(jam.isProbablePrime(32)) {
                    break;
                }
                
                values[i - 2] = jam;
            }
            
            if(values[8] == null) {
                generator = generator + 2L;
                continue;
            }
            

            StringBuilder sb = new StringBuilder(candidate);
            
            for(int i = 2; i < values.length + 2; i++) {
                long jamCoinBase10 = values[i - 2].longValue();
                long divisor = 2L;
                
                while(jamCoinBase10 % divisor != 0L) {
                    divisor = divisor + 1L;
                }
                
                sb.append(" ").append(divisor);
            }
            
            writeLine(sb.toString() + "\n");
            count++;
            generator = generator + 2L;
        }
    }
    
    public static void initialize(String testFile) {
        try {
            reader = new BufferedReader(new FileReader("C:/Users/Adam/Downloads/" + testFile));
            writer = new BufferedWriter(new FileWriter("C:/Users/Adam/Downloads/" + testFile.replace(".in", ".out")));            
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
        
    }

    public static void writeLine(String output) {
        try {
            writer.write(output);
            System.out.print(output);
            System.out.flush();
            writer.flush();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
    
    public static String readLine() {
        try {
            return reader.readLine();
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }
}