import java.io.BufferedInputStream;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Scanner;


public class Password {

	static String filename = "A-small-attempt0";
	
	public static void main(String[] args) throws Exception {
		FileInputStream fin = new FileInputStream(new File(filename + ".in"));
		BufferedInputStream bis = new BufferedInputStream(fin);

		FileWriter  fout = new FileWriter (filename+".out");
		BufferedWriter bout = new BufferedWriter (fout);
		PrintWriter p = new PrintWriter(fout);
		
		Scanner sc = new Scanner(bis);
		int t = sc.nextInt();
		
		
		for(int i = 1 ; i <= t ; i++)
		{
			int wronglen = sc.nextInt();
			int total =  sc.nextInt();
			double[] prob = new double[wronglen];
			for (int j = 0; j < wronglen; j++) {
				prob[j] = sc.nextDouble();
			}
			
			double output = perform(prob , total);
			DecimalFormat newFormat = new DecimalFormat("#.######");
			String twoDecimal =  newFormat.format(output);
			//bout.write("Case #"+ i + ": " + twoDecimal + "\n");
			p.printf("Case #"+ i + ": %.6f " , output);
			p.println();
			bout.flush();
		}

		fout.close();
		fin.close();
		
	}
	
	static double perform(double[] prob , int total)
	{
		double output= Double.MAX_VALUE;
		int len = prob.length;
		double[][] data = calcprob(prob , total);
		for (int i = 1; i < data[0].length; i++) {
			double tot = 0;
			for (int j = 0; j < data.length; j++) {
				tot += data[j][0] * data[j][i] ;
			}
			System.out.println("tot : " + tot);
			output = Math.min(tot, output);
		}
		
		
		return output;
	}
	
	static double[][] calcprob(double[] prob , int total)
	{
		int len = prob.length;
		int totallen = (int)Math.pow(2, prob.length);
		boolean[] poss = new boolean[prob.length];
			for(int j = 0 ; j < prob.length;j++)
			{
				poss[j] = false;
			}
		
		double[][] data = new double[totallen][prob.length + 3];
		for (int i = 0; i < data.length; i++) {
			boolean[] tempposs = generateperm(poss);
			//sout(tempposs);
			double tempprob = 1;
			int falsecount = 0;
			for (int j = 0; j < tempposs.length; j++) {
				if(tempposs[j])
					tempprob *= prob[j] ;
				else
				{
					tempprob *= 1 - prob[j] ;
					falsecount++;
				}
			}
			data[i][0] = tempprob;
			data[i][1] = (falsecount > 0) ? (total - len + 1 + total + 1) : (total - len + 1); // keep typing
			for (int j = 1; j <= tempposs.length; j++) {
				int falcount = 0;
				for (int j2 = 0; j2 < tempposs.length-j; j2++) {
					if(!tempposs[j2]) falcount++;
				}
				
				data[i][j+1] = (falcount > 0) ? (j + total - (len - j) + 1 + total + 1) : (j + total - (len - j) + 1);
				//sout(j+2);
			}
			//sout(len+2);
			data[i][len+2] = 1 + total + 1;
		}
		//sout(data);
		return data;
	}
	
	static boolean[] generateperm(boolean[] poss)
	{
		int len = poss.length;
		boolean temp = poss[len-1];
		poss[len-1] = poss[len-1] ^ true;
		boolean prevcarry = temp & true; 
		for(int i = len-2 ; i >= 0 ; i--)
		{
			boolean temp1 = poss[i];
			poss[i] = poss[i] ^ prevcarry;
			prevcarry = temp1 & prevcarry;
			
		}
		
		return poss;
	}
	
	static void sout(double[] data)
	{
		for (int i = 0; i < data.length; i++) {
			System.out.print(data[i] + " ");
		}
		System.out.println();
	}

	static void sout(boolean[] data)
	{
		for (int i = 0; i < data.length; i++) {
			System.out.print(data[i] + " ");
		}
		System.out.println();
	}
	
	static void sout(double[][] data)
	{
		for (int i = 0; i < data.length; i++) {
			for (int i1 = 0; i1 < data[i].length; i1++) {
				System.out.print(data[i][i1] + " ");
		}
		System.out.println();
		}
	}
	
	static void sout(double data)
	{
		System.out.println(data);
	}
}
