import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.StringTokenizer;


public class FairAndSquare {
	
	static long[] numbers = new long[10000000];
	public static void main(String[] args) throws IOException {
		
		FileReader fr = new FileReader(new File("C-small-attempt2.in"));
		FileWriter fw = new FileWriter(new File("C-small-attempt2.out"));
		BufferedReader br = new BufferedReader(fr);
		
		generateFairSquareNumbers();
		StringTokenizer st = new StringTokenizer(br.readLine());
		int t = Integer.parseInt(st.nextToken());
		for(int i = 0 ; i < t ; i++)
		{
			st = new StringTokenizer(br.readLine());
			long start = Long.parseLong(st.nextToken());
			long end = Long.parseLong(st.nextToken());
			int count = getCountOfFairnSquareNumbers(start , end);
			fw.append("Case #"+(i+1) +": "+count);
			fw.append("\n");
		}
		fw.close();
		fr.close();
	}
	private static int getCountOfFairnSquareNumbers(long start, long end) {
		int count = 0;
		int startindex = Arrays.binarySearch(numbers, start);
		int endindex = Arrays.binarySearch(numbers, end);
		if(startindex < 0)
			startindex = -(startindex+1);
		if(endindex < 0)
			endindex = -(endindex+2);
		endindex = (endindex < 0) ? 0 : endindex;
		count = endindex - startindex + 1 ;
		return count;
	}
	private static void generateFairSquareNumbers() {
		// TODO Auto-generated method stub
		int index = 0;
		for(long i = 1 ; i < 10000000 ; i++)
		{
			if(isPalin(i) && isPalin(i*i))
				numbers[index++]= i*i;
		}
		
		numbers = Arrays.copyOfRange(numbers, 0, index);
		for(int i = 0 ; i < index ; i++)
			System.out.println(numbers[i]);
	}
	private static boolean isPalin(long l) {
		boolean ispalin = true;
		String s = "" + l;
		int len = s.length();
		int mid = len/2;
		for(int i = 0 ; i <= mid;i++)
			if(s.charAt(i) != s.charAt(len-i-1))
				ispalin = false;
		return ispalin;
	}

}
