import java.io.*;
import java.math.*;
import java.util.*;

public class Main implements Runnable {
	String file = "template";

	class Walkway implements Comparable<Walkway> {
		int id;
		double length;
		double speed;

		public Walkway(int id, int length, int speed) {
			this.id = id;
			this.length = length;
			this.speed = speed;
		}

		@Override
		public String toString() {
			return "Walkway [id=" + id + ", length=" + length + ", speed="
					+ speed + "]";
		}

		@Override
		public int compareTo(Walkway arg0) {
			if (speed == arg0.speed) {
				return id - arg0.id;
			}
			return new Double(speed).compareTo(arg0.speed);
		}

	}

	int WID = 0;

	private void solve() throws IOException {
		int tN = nextInt();
		for (int testN = 1; testN <= tN; ++testN) {
			int x = nextInt();
			int s = nextInt();
			int r = nextInt();
			double t = nextInt();
			int n = nextInt();
			Walkway[] arr = new Walkway[n + 1];
			for (int i = 0; i < n; ++i) {
				int b = nextInt();
				int e = nextInt();
				int w = nextInt();
				arr[i] = new Walkway(WID++, e - b, w);
				x -= arr[i].length;
			}
			arr[n] = new Walkway(WID++, x, 0);
			Arrays.sort(arr);
			double ans = 0;
			for (int i = 0; i <= n; ++i) {
				double curT = Math.min(t, arr[i].length / (arr[i].speed + r));
				t -= curT;
				ans += curT;
				ans += (arr[i].length - curT * (arr[i].speed + r)) /(arr[i].speed + s); 
			}
			out.printf("Case #%d: %.8f\n", testN, ans);
		}
	}

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;

	@Override
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader(file + ".in"));
			out = new PrintWriter(new FileWriter(file + ".out"));
			st = new StringTokenizer("");
			while (hasNext()) {
				solve();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	boolean hasNext() throws IOException {
		while (!st.hasMoreElements()) {
			String line = br.readLine();
			if (line == null) {
				return false;
			}
			st = new StringTokenizer(line);
		}
		return true;
	}

	String next() throws IOException {
		if (hasNext()) {
			return st.nextToken();
		}
		throw new IOException("No more tokens");
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
}
