
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;

/**
 *
 * @author Luis Carlos Sanchez
 */
public class InfiniteHouseofPancakes2 {

    //static ArrayList<Integer> pancakesOnPlates;
    static int initialMax;

    public static void main(String[] args) throws FileNotFoundException, IOException {
        String filePrefix = "B-small-attempt4";
        BufferedReader br = new BufferedReader(new FileReader(filePrefix + ".in"));
        try (PrintWriter pw = new PrintWriter(filePrefix + ".out")) {
            int T = Integer.parseInt(br.readLine());
            for (int i = 1; i <= T; i++) {
                if (i != 1) {
                    pw.println();
                }
                int D = Integer.parseInt(br.readLine());
                ArrayList<PancakesStack> pancakesOnPlates = new ArrayList<>(D);
                for (String rea : br.readLine().split(" ")) {
                    pancakesOnPlates.add(new PancakesStack(Integer.parseInt(rea)));
                }
                Collections.sort(pancakesOnPlates, Collections.reverseOrder());
                System.out.println(String.format("Case #%d: %d %s", i, D, Arrays.toString(pancakesOnPlates.toArray())));
                int totalMinutes = getTotalMinutes(pancakesOnPlates, 0, initialMax = pancakesOnPlates.get(0).pancakesCount);
                pw.print(String.format("Case #%d: %d", i, totalMinutes));
            }
        }
    }

    private static int getTotalMinutes(ArrayList<PancakesStack> pancakesOnPlates, int currentTime, int maxTime) {
        ArrayList<PancakesStack> pancakesOnSpecialMinute = getPancakesAfterSpecialMinute(pancakesOnPlates);
        if (pancakesOnSpecialMinute.get(0).pancakesCount + currentTime + 1 < maxTime) {
            return getTotalMinutes(pancakesOnSpecialMinute, ++currentTime, pancakesOnSpecialMinute.get(0).pancakesCount);
        }
        return maxTime + currentTime;
    }

    private static ArrayList<PancakesStack> getPancakesAfterSpecialMinute(ArrayList<PancakesStack> pancakesOnPlates) {
        ArrayList<PancakesStack> currentPancakesOnPlates = new ArrayList<>();
        for (int i = 0; i < pancakesOnPlates.size(); i++) {
            int pancakesOnPlate = pancakesOnPlates.get(i).pancakesCount;
            if (i == 0) {
                if (pancakesOnPlate != 1) {
                    int afterSpecialMinute = (pancakesOnPlate - pancakesOnPlate / 2);
                    currentPancakesOnPlates.add(new PancakesStack(pancakesOnPlate - afterSpecialMinute, true));
                    currentPancakesOnPlates.add(new PancakesStack(afterSpecialMinute, true));
                } else {
                    currentPancakesOnPlates.add(new PancakesStack(pancakesOnPlate));
                }
            } else {
                currentPancakesOnPlates.add(new PancakesStack(pancakesOnPlate));
            }
        }
        Collections.sort(currentPancakesOnPlates, Collections.reverseOrder());
        return currentPancakesOnPlates;
    }

    static class PancakesStack implements Comparable<PancakesStack> {

        Integer pancakesCount;
        boolean splitted;

        public PancakesStack(Integer pancakesCount) {
            this.pancakesCount = pancakesCount;
        }

        public PancakesStack(Integer pancakesCount, boolean splitted) {
            this.pancakesCount = pancakesCount;
            this.splitted = splitted;
        }

        @Override
        public int compareTo(PancakesStack o) {
            return pancakesCount.compareTo(o.pancakesCount);
        }

        @Override
        public String toString() {
            return String.valueOf(pancakesCount);
        }
    }
}
