import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

/**
 * 
 * @author Adedayo Ominiyi
 */
public class ProgA {

	private enum Result {
		X, O;
	}

	public static void main(String[] args) {
		try (Scanner sc = new Scanner(System.in)) {
			int numberOfInputs = Integer.parseInt(sc.nextLine());
			char[][] inputRows = new char[4][];

			for (int i = 0; i < numberOfInputs; i++) {
				for (int j = 0; j < 4;) {
					if (sc.hasNextLine()) {
						String lineString = sc.nextLine();
						if ((lineString != null)
								&& (!lineString.trim().equals(""))) {
							char[] lineChars = lineString.toCharArray();
							inputRows[j] = lineChars;
							j++;
						}
					}
				}

				// a complete input has been read. process
				Set<Result> results = new HashSet<>();
				results.addAll(checkHorizontal(inputRows));
				results.addAll(checkVertical(inputRows));
				results.addAll(checkDiagonal(inputRows));

				if (results.isEmpty()) {
					
					if (hasEmptyCells(inputRows)) {
						System.out.println(String.format("Case #%d: %s", (i + 1),
								"Game has not completed"));
					} else {
						System.out.println(String.format("Case #%d: %s", (i + 1),
								"Draw"));
					}
				} else if (results.size() == 1) {
					System.out.println(String.format("Case #%d: %s won",
							(i + 1), results.toArray()[0]));
				} else {
					System.out.println(String.format("Case #%d: %s", (i + 1),
							"Draw"));
				}
			}

		}
	}
	
	private static boolean hasEmptyCells(char[][] inputRows) {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (inputRows[i][j] == '.') {
					return true;
				}
			}
		}
		return false;
	}

	private static Set<Result> checkHorizontal(char[][] inputRows) {
		Set<Result> results = new HashSet<>();

		for (int i = 0; i < 4; i++) {
			// change the value of the first column
			char currentValue = inputRows[i][0];
			if (currentValue == 'T') {
				inner1: for (int j = 1; j < 4; j++) {
					if (inputRows[i][j] != 'T') {
						currentValue = inputRows[i][j];
						break inner1;
					}
				}
			}

			if (currentValue != 'T' && currentValue != '.') {
				if (((currentValue == inputRows[i][1]) || (inputRows[i][1] == 'T'))
						&& ((currentValue == inputRows[i][2]) || (inputRows[i][2] == 'T'))
						&& ((currentValue == inputRows[i][3]) || (inputRows[i][3] == 'T'))) {
					if (currentValue == 'X') {
						results.add(Result.X);
					} else if (currentValue == 'O') {
						results.add(Result.O);
					}
				}
			}
		}

		return results;
	}

	private static Set<Result> checkVertical(char[][] inputRows) {
		Set<Result> results = new HashSet<>();

		for (int j = 0; j < 4; j++) {
			// change the value of the first column
			char currentValue = inputRows[0][j];
			if (currentValue == 'T') {
				inner1: for (int i = 1; i < 4; i++) {
					if (inputRows[i][j] != 'T') {
						currentValue = inputRows[i][j];
						break inner1;
					}
				}
			}

			if (currentValue != 'T' && currentValue != '.') {
				if (((currentValue == inputRows[1][j]) || (inputRows[1][j] == 'T'))
						&& ((currentValue == inputRows[2][j]) || (inputRows[2][j] == 'T'))
						&& ((currentValue == inputRows[3][j]) || (inputRows[3][j] == 'T'))) {
					if (currentValue == 'X') {
						results.add(Result.X);
					} else if (currentValue == 'O') {
						results.add(Result.O);
					}
				}
			}
		}
		return results;
	}

	private static Set<Result> checkDiagonal(char[][] inputRows) {
		Set<Result> results = new HashSet<>();

		for (int i = 0; i < inputRows.length; i++) {
			for (int j = 0; j < inputRows[i].length; j++) {
				if (i == 0 && j == 0) {
					char currentValue = inputRows[0][0];
					
					if (currentValue == 'T') {
						if (inputRows[i + 1][j + 1] != 'T') {
							currentValue = inputRows[i + 1][j + 1];
						} else if (inputRows[i + 2][j + 2] != 'T') {
							currentValue = inputRows[i + 2][j + 2];
						}  else if (inputRows[i + 3][j + 3] != 'T') {
							currentValue = inputRows[i + 3][j + 3];
						}
					}
					
					if (currentValue != 'T' && currentValue != '.') {
						if (((currentValue == inputRows[i + 1][j + 1]) || (inputRows[i + 1][j + 1] == 'T'))
								&& ((currentValue == inputRows[i + 2][j + 2]) || (inputRows[i + 2][j + 2] == 'T'))
								&& ((currentValue == inputRows[i + 3][j + 3]) || (inputRows[i + 3][j + 3] == 'T'))) {
							if (currentValue == 'X') {
								results.add(Result.X);
							} else if (currentValue == 'O') {
								results.add(Result.O);
							}
						}
					}
				}
				
				if (i == 3 && j == 0) {
					char currentValue = inputRows[3][0];
					
					if (currentValue == 'T') {
						if (inputRows[i - 1][j + 1] != 'T') {
							currentValue = inputRows[i - 1][j + 1];
						} else if (inputRows[i - 2][j + 2] != 'T') {
							currentValue = inputRows[i - 2][j + 2];
						}  else if (inputRows[i - 3][j + 3] != 'T') {
							currentValue = inputRows[i - 3][j + 3];
						}
					}
					
					if (currentValue != 'T' && currentValue != '.') {
						if (((currentValue == inputRows[i - 1][j + 1]) || (inputRows[i - 1][j + 1] == 'T'))
								&& ((currentValue == inputRows[i - 2][j + 2]) || (inputRows[i - 2][j + 2] == 'T'))
								&& ((currentValue == inputRows[i - 3][j + 3]) || (inputRows[i - 3][j + 3] == 'T'))) {
							if (currentValue == 'X') {
								results.add(Result.X);
							} else if (currentValue == 'O') {
								results.add(Result.O);
							}
						}
					}
				}
			}
		}
		return results;
	}
}
