package codejam2016;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 *
 * @author Adedayo Ominiyi
 */
public class Main3 {

    public static void main(String[] args) throws FileNotFoundException {
        String filename = "problem3";

        Scanner in = new Scanner(new File(String.format("%s.in", filename)));
        PrintStream out = new PrintStream(new File(String.format("%s.out", filename)));

        // read first line
        int inputSize = Integer.parseInt(in.nextLine());
        System.out.println("inputSize: " + inputSize);

        String line = in.nextLine();
        System.out.println("line: " + line);

        String[] lineParts = line.split(" ");
        int jamCoinMaxSize = Integer.parseInt(lineParts[0]);
        int numberOfJamCoinsToPrint = Integer.parseInt(lineParts[1]) * 2;
        //System.out.println("jamCoinMaxSize: " + jamCoinMaxSize);
        //System.out.println("numberOfJamCoinsToPrint: " + numberOfJamCoinsToPrint);

        long lowerBoundNumber = (1L << (jamCoinMaxSize - 1)) | 1L;
        //System.out.println("lowerBoundNumber: " + lowerBoundNumber);

        StringBuilder upperBoundBase2NumberBuilder = new StringBuilder("");
        for (int i = 0; i < jamCoinMaxSize; i++) {
            upperBoundBase2NumberBuilder.append('1');
        }
        long upperBoundNumber = Long.valueOf(upperBoundBase2NumberBuilder.toString(), 2);
        //System.out.println("upperBoundNumber: " + upperBoundNumber);

        List<String> jamCoinsList = new ArrayList<>(numberOfJamCoinsToPrint);

        for (long currentNumber = lowerBoundNumber; currentNumber <= upperBoundNumber; currentNumber++) {
            if ((currentNumber & 1L) != 0) {
                // At this point, in base 2 it could be a jam number
                String currentNumberString = Long.toBinaryString(currentNumber);
                if (isJamCoin(currentNumberString)) {
                    jamCoinsList.add(currentNumberString);

                    if (jamCoinsList.size() == numberOfJamCoinsToPrint) {
                        break;
                    }
                }
            }
        }
        
        //System.out.println("jamCoinsList.size(): " + jamCoinsList.size());
        
        out.println("Case #1:");
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < jamCoinsList.size(); i++) {
            boolean errorFound = false;
            builder.setLength(0);
            String jamCoin = jamCoinsList.get(i);
            System.out.println(jamCoin);
         
            builder.append(jamCoin);
            
            for (int base = 2; base <= 10; base++) {
                boolean foundOne = false;
                BigInteger numberInCurrentBase = new BigInteger(jamCoin, base);
                //System.out.println("numberInCurrentBase: " + numberInCurrentBase);
                
                BigInteger loopCounter = BigInteger.valueOf(2);
                BigInteger loopEnd = BigInteger.valueOf(10000L);
                //System.out.println("loopEnd: " + loopEnd);
                
                BigInteger currentDivisor = BigInteger.valueOf(2);
                while (loopCounter.compareTo(loopEnd) <= 0) {
                    //System.out.println("loopCounter: " + loopCounter);
                    
                    if (numberInCurrentBase.mod(loopCounter).equals(BigInteger.ZERO)) {
                        foundOne = true;
                        currentDivisor = loopCounter;
                    }
                    
                    loopCounter = loopCounter.nextProbablePrime();
                }
                
                if (foundOne) {
                    builder.append(" ");
                    builder.append(currentDivisor);
                } else {
                    errorFound = true;
                    break;
                }
            }
            
            if (!errorFound) {
                out.println(builder.toString());
            }
        }
    }
    
    private static boolean isJamCoin(String currentNumberString) {
        for (int base = 2; base <= 10; base++) {
            BigInteger numberInCurrentBase = new BigInteger(currentNumberString, base);

            boolean isPrime = numberInCurrentBase.isProbablePrime(1);
            if (isPrime) {
                return false;
            }
        }

        return true;
    }
}
