package codejam2016;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 *
 * @author Adedayo Ominiyi
 */
public class Main3 {

    public static void main(String[] args) throws FileNotFoundException {
        String filename = "problem3";

        Scanner in = new Scanner(new File(String.format("%s.in", filename)));
        PrintStream out = new PrintStream(new File(String.format("%s.out", filename)));

        // read first line
        int inputSize = Integer.parseInt(in.nextLine());
        //System.out.println("inputSize: " + inputSize);

        String line = in.nextLine();
        //System.out.println("line: " + line);

        String[] lineParts = line.split(" ");
        int jamNumberMaxSize = Integer.parseInt(lineParts[0]);
        int numberOfJamNumberToPrint = Integer.parseInt(lineParts[1]);
        //System.out.println("jamNumberMaxSize: " + jamNumberMaxSize);
        //System.out.println("numberOfJamNumberToPrint: " + numberOfJamNumberToPrint);

        StringBuilder base2NumberBuilder = new StringBuilder("");
        for (int i = 0; i < jamNumberMaxSize; i++) {
            base2NumberBuilder.append('1');
        }
        long upperBoundNumber = Long.valueOf(base2NumberBuilder.toString(), 2);
        //System.out.println("upperBoundNumber: " + upperBoundNumber);

        out.println("Case #1:");
        List<String> jamNumbersList = new ArrayList<>(3);
        for (long currentNumber = 2; currentNumber <= upperBoundNumber; currentNumber++) {
            String currentNumberString = Long.toBinaryString(currentNumber);

            // to short
            if (currentNumberString.length() != jamNumberMaxSize) {
                continue;
            }

            // first character must be a 1
            if (currentNumberString.charAt(0) != '1') {
                continue;
            }

            // last character must be a 1
            if (currentNumberString.charAt(currentNumberString.length() - 1) != '1') {
                continue;
            }

            // At this point, in base 2 it could be a jam number
            if (isJamNumber(currentNumberString)) {
                jamNumbersList.add(currentNumberString);

                if (jamNumbersList.size() == numberOfJamNumberToPrint) {
                    break;
                }
            }
        }
        //System.out.println("jamNumbersList.size(): " + jamNumbersList.size());
        for (String jamNumber : jamNumbersList) {
            out.print(jamNumber);
            for (int base = 2; base <= 10; base++) {
                long numberInCurrentBase = Long.valueOf(jamNumber, base);
                //System.out.print(" " + numberInCurrentBase);
                for (long divisor = (long) Math.sqrt(numberInCurrentBase - 1); divisor >= 2; divisor--) {
                    if (numberInCurrentBase % divisor == 0) {
                        out.print(" " + divisor);
                        break;
                    }
                }

            }
            out.println();
        }
    }

    private static boolean isJamNumber(String currentNumberString) {
        for (int base = 2; base <= 10; base++) {
            long numberInCurrentBase = Long.valueOf(currentNumberString, base);

            boolean isPrime = BigInteger.valueOf(numberInCurrentBase).isProbablePrime(1);
            if (isPrime) {
                return false;
            }
        }

        return true;
    }
}
