package ominiyi.codejam.c;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.List;

/**
 * 
 * @author Adedayo Ominiyi
 */
public class ProgC {

	public static void main(String[] args) {
		String inputFilename = "C-small-attempt0.in";
		String outputFilename = "C-small-attempt0.out";

		try {
			List<String> inputs = BoilerPlate.readLines(inputFilename);

			solveTestCases(inputs, outputFilename);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	private static String formatOutput(int testCaseNumber, String output) {
		return String.format("Case #%d: %s", testCaseNumber, output);
	}

	private static void solveTestCases(List<String> testCases, String outputFilename) throws IOException {
		FileOutputStream outputStream = new FileOutputStream(outputFilename);
		
		int counter = 1;
		int testCaseNumber = 1;
		while (counter < testCases.size()) {
			String line1 = testCases.get(counter);
			String line2 = testCases.get(counter + 1);
			String[] input1 = line1.split(" ");
			String[] input2 = line2.split(" ");
			
			long lowestNote = Long.parseLong(input1[1]);
			long highestNote = Long.parseLong(input1[2]);
			
			long i = lowestNote;
			outer: for (; i <= highestNote; i++) {
				int input2Length = input2.length;
				
				BitSet bitSet = new BitSet(input2Length);
				int actualRange = bitSet.size();
				bitSet.set(0, actualRange, false);
				
				for (int j = 0; j < input2Length; j++) {						
					long noteLong = Long.parseLong(input2[j]);
					
					if ((i % noteLong == 0) || (noteLong % i == 0)) {
						bitSet.set(j, true);
					}
				}
				
				boolean isLCD = true;
				for (int k = 0; k < input2Length; k++) {
					isLCD = isLCD & bitSet.get(k);
				}
				if (isLCD == true) {
					break outer;
				}				
			}
			String answer = (i <= highestNote ? String.valueOf(i) : "NO");
			BoilerPlate.writeLine(
					formatOutput(testCaseNumber, answer),
					outputStream);
			counter = counter + 2;
			testCaseNumber = testCaseNumber + 1;
		}
		BoilerPlate.closeQuietly(outputStream);
	}
}

class BoilerPlate {

	public static List<String> readLines(String filename) throws IOException {
		InputStream input = null;
		try {
			input = new FileInputStream(filename);
			return readLines(input);
		} finally {
			closeQuietly(input);
		}
	}

	private static List<String> readLines(InputStream input) throws IOException {
		InputStreamReader inputStreamReader = new InputStreamReader(input,
				"ASCII");

		BufferedReader bufferedReader = new BufferedReader(inputStreamReader);
		List<String> list = new ArrayList<String>();
		String line = bufferedReader.readLine();
		while (line != null) {
			list.add(line);
			line = bufferedReader.readLine();
		}
		return list;
	}

	public static void closeQuietly(InputStream input) {
		try {
			if (input != null) {
				input.close();
			}
		} catch (IOException ioe) {
			// ignore
		}
	}

	public static void closeQuietly(OutputStream output) {
		try {
			if (output != null) {
				output.close();
			}
		} catch (IOException ioe) {
			// ignore
		}
	}

	public static void writeLine(String line, OutputStream output)
			throws IOException {
		String encoding = "ASCII";
		String LINE_SEPARATOR = null;
		try {
			LINE_SEPARATOR = System.getProperty("line.separator");
		} catch (Exception ex) {
			// avoid security issues
			StringWriter buf = new StringWriter(4);
			PrintWriter out = new PrintWriter(buf);
			out.println();
			LINE_SEPARATOR = buf.toString();
		}
		output.write(line.getBytes(encoding));
		output.write(LINE_SEPARATOR.getBytes(encoding));
	}
}