import java.math.BigInteger;
import java.math.RoundingMode;
import java.util.Scanner;

import com.google.common.math.BigIntegerMath;

/**
 * 
 * @author Adedayo Ominiyi
 */
public class ProgCBig {

	public static void main(String[] args) {
		try (Scanner sc = new Scanner(System.in);) {
			// read input from standard in
			// skip first line
			String lineString = sc.nextLine();
			int counter = 0;
			while (sc.hasNextLine()) {
				lineString = sc.nextLine();
				

				if ((lineString != null) && (!lineString.trim().equals(""))) {
					String[] values = lineString.split(" ");
					int result = numberOfFairAndSquare(
							new BigInteger(values[0]),
							new BigInteger(values[1]));
					System.out.println(String.format("Case #%d: %d", ++counter, result));
				} else {
					System.exit(0);
				}
			}
		}
	}

	public static int numberOfFairAndSquare(BigInteger beginning,
			BigInteger ending) {
		int counter = 0;
		BigInteger temp = beginning;
		while (true) {
			if (isPalindrome(temp)) {
				BigInteger squareRoot = sqrt(temp);
				if ((squareRoot != null) && (isPalindrome(squareRoot))) {
					counter++;
				}
			}
			if (temp.equals(ending)) {
				break;
			}
			temp = temp.add(BigInteger.ONE);
		}

		
		return counter;
	}

	private static boolean isPalindrome(BigInteger number) {
		/*BigInteger palindrome = number; // copied number into variable
		BigInteger reverse = BigInteger.ZERO;

		BigInteger ten = new BigInteger("10");
		while (!palindrome.equals(BigInteger.ZERO)) {
			BigInteger remainder = palindrome.mod(ten);
			reverse = reverse.multiply(ten).add(remainder);
			palindrome = palindrome.divide(ten);
		}

		// if original and reverse of number is equal means
		// number is palindrome in Java
		if (number.equals(reverse)) {
			return true;
		}
		return false;*/
		String palindrome = number.toString();
		return palindrome.equals(new StringBuilder(palindrome).reverse().toString());
	}

	private static BigInteger sqrt(BigInteger number) {
		try {
			BigInteger approx =  BigIntegerMath.sqrt(number, RoundingMode.UNNECESSARY);
			
			BigInteger actualValue = approx.multiply(approx);
			if (actualValue.equals(number)) {
				return approx;
			}
		} catch (Exception ex) {
			
		}
		return null;
		
		/*BigInteger a = BigInteger.ONE;
		BigInteger b = new BigInteger(number.shiftRight(5)
				.add(new BigInteger("8")).toString());
		while (b.compareTo(a) >= 0) {
			BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
			if (mid.multiply(mid).compareTo(number) > 0)
				b = mid.subtract(BigInteger.ONE);
			else
				a = mid.add(BigInteger.ONE);
		}
		// This is an approximation at best.
		BigInteger approx = a.subtract(BigInteger.ONE);
		if (approx.multiply(approx).equals(number)) {
			return approx;
		}
		return null;*/
	}
}
