package codejam2017;

import java.io.File;
import java.io.FileInputStream;
import java.io.PrintStream;
import java.util.Collections;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 *
 * @author Adedayo Ominiyi
 */
public class Main3 {

    public static void main(String[] args) throws Exception {
        String filename = "problem3";
        try (
                FileInputStream inputStream = new FileInputStream(new File(String.format("%s.in", filename)));
                Scanner scanner = new Scanner(inputStream);
                PrintStream out = new PrintStream(new File(String.format("%s.out", filename)));) {
            scanner.useDelimiter("\\A");

            if (scanner.hasNextLine()) {
                String[] lines = scanner.next().split("\\n");
                int linesLength = lines.length;
                for (int recordIndex = 1; recordIndex < linesLength; recordIndex++) {
                    String[] lineParts = lines[recordIndex].split(" ");
                    long stalls = Long.parseLong(lineParts[0].trim(), 10);
                    long users = Long.parseLong(lineParts[1].trim(), 10);

                    PriorityQueue<Long> maxHeap = new PriorityQueue<>(Collections.reverseOrder());
                    long[] leftAndRight = splitStalls(stalls);
                    long left = leftAndRight[0];
                    long right = leftAndRight[1];
                    for (long i : leftAndRight) {
                        maxHeap.add(i);
                    }
                    for (int user = 2; user <= users; user++) {
                        long max = maxHeap.remove();
                        leftAndRight = splitStalls(max);
                        left = leftAndRight[0];
                        right = leftAndRight[1];
                        for (long i : leftAndRight) {
                            maxHeap.add(i);
                        }
                    }
                    //System.out.println(String.format("Case #%d: %s %s", recordIndex, right, left));
                    out.println(String.format("Case #%d: %s %s", recordIndex, right, left));
                }
            }
        }
    }

    private static long[] splitStalls(long freeStalls) {
        long right = freeStalls / 2;
        boolean stallsIsEven = freeStalls % 2 == 0;
        long left = stallsIsEven ? right - 1 : right;
        return new long[]{left, right};
    }
}
