package codejam2017;

import java.io.File;
import java.io.FileInputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 *
 * @author Adedayo Ominiyi
 */
public class Main2 {

    public static void main(String[] args) throws Exception {
        String filename = "problem2";
        try (
                FileInputStream inputStream = new FileInputStream(new File(String.format("%s.in", filename)));
                Scanner scanner = new Scanner(inputStream);
                PrintStream out = new PrintStream(new File(String.format("%s.out", filename)));) {
            scanner.useDelimiter("\\A");

            if (scanner.hasNextLine()) {
                String[] lines = scanner.next().split("\\n");
                int linesLength = lines.length;
                for (int recordIndex = 1; recordIndex < linesLength; recordIndex++) {
                    long currentNumber = Long.parseLong(lines[recordIndex].trim(), 10);

                    for (long i = currentNumber; i >= 0; ) {
                        if (isTidy(i)) {
                            //System.out.println(String.format("Case #%d: %s", recordIndex, i));
                            out.println(String.format("Case #%d: %s", recordIndex, i));
                            break;
                        } else {
                            i = nextNumber(i);
                        }
                    }
                }
            }
        }
    }

    private static boolean isTidy(long number) {
        if (number < 10L) {
            return true;
        }

        String numberString = String.valueOf(number);
        char[] numberStringCharArray = numberString.toCharArray();
        int numberStringCharArrayLength = numberStringCharArray.length;
        for (int i = 0; i < numberStringCharArrayLength; i++) {
            try {
                if (numberStringCharArray[i] > numberStringCharArray[i + 1]) {
                    return false;
                }
            } catch (ArrayIndexOutOfBoundsException ex) {
                return true;
            }
        }

        return false;
    }

    private static long nextNumber(long number) {
        String numberString = String.valueOf(number);
        char[] numberStringCharArray = numberString.toCharArray();
        int numberStringCharArrayLength = numberStringCharArray.length;
        int i = 0;
        for (; i < numberStringCharArrayLength; i++) {
            if (numberStringCharArray[i] > numberStringCharArray[i + 1]) {
                break;
            }
        }
        numberStringCharArray[i] = Character.forDigit(Integer.parseInt(String.valueOf(numberStringCharArray[i]), 10) - 1, 10);
        
        for (int j = i + 1; j < numberStringCharArrayLength; j++) {
            numberStringCharArray[j] = '9';
        }
        
        return Long.parseLong(new String(numberStringCharArray), 10);
    }
}
