package gcj2011.qualification.problemC.candySplitting;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

import gcj2011.qualification.solver.GenericSolver;

public class CandySplitting extends GenericSolver {
    public CandySplitting(File arquivo) throws FileNotFoundException {
        super(arquivo);
    }

    @Override
    protected String solveCase(Scanner scanner) {
        ArrayList<Integer> doces = new ArrayList<Integer>();
        int quantidadeDeDoces = scanner.nextInt();
        for (int numeroDoDoce = 0; numeroDoDoce < quantidadeDeDoces; numeroDoDoce++) {
            doces.add(scanner.nextInt());
        }

        ArrayList<PilhaDeDoces> pilhasPossiveis = montaTodasAsPilhasPossiveis(doces);
        ArrayList<PilhaDeDoces> pilhasDeDoceQueOPatrickConcorda = new ArrayList<PilhaDeDoces>();
        for (PilhaDeDoces pilhaDeDoces : pilhasPossiveis) {
            if (pilhaDeDoces.patrickConcorda()) {
                pilhasDeDoceQueOPatrickConcorda.add(pilhaDeDoces);
            }
        }

        int max = -1;
        for (PilhaDeDoces pilhaDeDoces : pilhasDeDoceQueOPatrickConcorda) {
            if (pilhaDeDoces.valorDaPilhaPorSean() > max) {
                max = pilhaDeDoces.valorDaPilhaPorSean();
            }
        }

        if (max == -1) {
            return "NO";
        } else {
            return "" + max;
        }
    }

    private ArrayList<PilhaDeDoces> montaTodasAsPilhasPossiveis(ArrayList<Integer> doces) {
        ArrayList<PilhaDeDoces> pilhas = new ArrayList<PilhaDeDoces>();

        for (int tamanho = 1; tamanho <= doces.size(); tamanho++) {
            ArrayList<Integer> docesDoSean = new ArrayList<Integer>();
            ArrayList<Integer> docesDoPatrick = copiaDoces(doces);

            CombinationGenerator generator = new CombinationGenerator(doces.size(), tamanho);
            while (generator.hasMore()) {
                int[] indices = generator.getNext();
                for (int i = 0; i < indices.length; i++) {
                    docesDoSean.add(doces.get(indices[i]));
                    docesDoPatrick.remove(doces.get(indices[i]));
                    if (docesDoSean.size() == tamanho) {
                        PilhaDeDoces pilha = new PilhaDeDoces();
                        pilha.setDocesDoSean(docesDoSean);
                        pilha.setDocesDoPatrick(docesDoPatrick);
                        pilhas.add(pilha);
                        docesDoSean = new ArrayList<Integer>();
                        docesDoPatrick = copiaDoces(doces);
                    }
                }
            }

        }

        // for (int meio = 0; meio <= doces.size() / 2 + 1; meio++) {
        // PilhaDeDoces pilha = new PilhaDeDoces();
        //
        // ArrayList<Integer> docesDoSean = new ArrayList<Integer>();
        // for (int posicao = 0; posicao < meio; posicao++) {
        // docesDoSean.add(doces.get(posicao));
        // }
        //
        // ArrayList<Integer> docesDoPatrick = new ArrayList<Integer>();
        // for (int posicao = meio; posicao < doces.size(); posicao++) {
        // docesDoPatrick.add(doces.get(posicao));
        // }
        //
        // pilha.setDocesDoSean(docesDoSean);
        // pilha.setDocesDoPatrick(docesDoPatrick);
        // pilhas.add(pilha);
        //
        // PilhaDeDoces pilha2 = new PilhaDeDoces();
        // pilha2.setDocesDoSean(docesDoPatrick);
        // pilha2.setDocesDoPatrick(docesDoSean);
        // pilhas.add(pilha2);
        // }

        return pilhas;
    }

    private ArrayList<Integer> copiaDoces(ArrayList<Integer> doces) {
        ArrayList<Integer> lista = new ArrayList<Integer>();
        for (Integer doce : doces) {
            lista.add(doce);
        }
        return lista;
    }

    private ArrayList<Integer> pegaOComplementar(ArrayList<Integer> docesDoSean, ArrayList<Integer> doces) {
        ArrayList<Integer> complementar = new ArrayList<Integer>();

        for (Integer doceNaListaOriginal : doces) {
            if (!docesDoSean.contains(doceNaListaOriginal)) {
                complementar.add(doceNaListaOriginal);
            }
        }

        return complementar;
    }
}
