package gcj2011.qualification.problemB.magicka;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

import gcj2011.qualification.solver.GenericSolver;

public class Magicka extends GenericSolver {
    List<CombinedMagic> combinacoes = new ArrayList<CombinedMagic>();
    List<OposedMagic> opostas = new ArrayList<OposedMagic>();

    public Magicka(File arquivo) throws FileNotFoundException {
        super(arquivo);
    }

    @Override
    protected String solveCase(Scanner scanner) {
        combinacoes = new ArrayList<CombinedMagic>();
        opostas = new ArrayList<OposedMagic>();
        ArrayList<Character> listaOriginal = new ArrayList<Character>();
        ArrayList<Character> resposta = new ArrayList<Character>();

        int numeroDeMagicasQueCombinam = scanner.nextInt();
        for (int combinacao = 0; combinacao < numeroDeMagicasQueCombinam; combinacao++) {
            combinacoes.add(new CombinedMagic(scanner.next()));
        }

        int numeroDeMagicasOpostas = scanner.nextInt();
        for (int combinacao = 0; combinacao < numeroDeMagicasOpostas; combinacao++) {
            opostas.add(new OposedMagic(scanner.next()));
        }

        int tamanhoDaListaInicial = scanner.nextInt();

        pegaListaOriginal(scanner, listaOriginal);

        for (int posicao = 0; posicao < tamanhoDaListaInicial; posicao++) {
            resposta.add(listaOriginal.get(posicao));
            efetuaCombinacoes(resposta);
            efetuaRemocoes(resposta);
        }

        /*
         * for (CombinedMagic c : combinacoes) { System.err.print(c.toString());
         * } System.err.print("; "); for (OposedMagic o : opostas) {
         * System.err.print(o.toString()); } System.err.println();
         */

        return resposta.toString();

    }

    private void efetuaRemocoes(ArrayList<Character> listaTemporaria) {
        int tamanhoDaLista = listaTemporaria.size();
        if (tamanhoDaLista >= 2) {
            if (listaContemAlgumaMagicaOposta(listaTemporaria)) {
                listaTemporaria.clear();
            }
        }
    }

    private boolean listaContemAlgumaMagicaOposta(ArrayList<Character> listaTemporaria) {
        for (OposedMagic oposicao : opostas) {
            for (int posicaoPrimeiraMagica = 0; posicaoPrimeiraMagica < listaTemporaria.size() - 1; posicaoPrimeiraMagica++) {
                for (int posicaoSegundaMagica = 1; posicaoSegundaMagica < listaTemporaria.size(); posicaoSegundaMagica++) {
                    if (oposicao.seOpoem(listaTemporaria.get(posicaoPrimeiraMagica),
                            listaTemporaria.get(posicaoSegundaMagica))) {
                        return true;
                    }
                }
            }
        }
        return false;
    }

    private void efetuaCombinacoes(ArrayList<Character> listaTemporaria) {
        int tamanhoDaLista = listaTemporaria.size();
        if (tamanhoDaLista >= 2) {
            Character elemento1 = listaTemporaria.get(tamanhoDaLista - 1);
            Character elemento2 = listaTemporaria.get(tamanhoDaLista - 2);

            if (elementosSeCombinam(elemento1, elemento2)) {
                listaTemporaria.remove(tamanhoDaLista - 1);
                listaTemporaria.remove(tamanhoDaLista - 2);
                listaTemporaria.add(pegaElementoCombinado(elemento1, elemento2));
            }
        }
    }

    private Character pegaElementoCombinado(Character elemento1, Character elemento2) {
        for (CombinedMagic combinacao : this.combinacoes) {
            if (combinacao.combinam(elemento1, elemento2)) {
                return combinacao.getResultado();
            }
        }

        return null;
    }

    private boolean elementosSeCombinam(Character elemento1, Character elemento2) {
        for (CombinedMagic combinacao : this.combinacoes) {
            if( combinacao.combinam(elemento1, elemento2) ) {
                return true;
            }
        }
        return false;
    }

    private void pegaListaOriginal(Scanner scanner, ArrayList<Character> listaOriginal) {
        char[] lista = scanner.next().toCharArray();
        for (char magic : lista) {
            listaOriginal.add(magic);
        }
    }
}
