package gcj2011.round1.RPI;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class RPI {
    private static String solveCase(Scanner scanner) {
        int totalDeTimes = scanner.nextInt();
        ArrayList<ArrayList<Integer>> times = new ArrayList<ArrayList<Integer>>(totalDeTimes);
        for (int i = 0; i < totalDeTimes; i++) {
            times.add(new ArrayList<Integer>(totalDeTimes));
        }

        for (int i = 0; i < totalDeTimes; i++) {
            char[] linha = scanner.next().toCharArray();
            for (int j = 0; j < linha.length; j++) {
                Integer number;
                if (linha[j] == '.') {
                    number = null;
                } else {
                    number = Integer.parseInt(Character.toString(linha[j]));
                }

                times.get(i).add(number);
            }
        }

        ArrayList<BigDecimal> wp = new ArrayList<BigDecimal>(totalDeTimes);
        for (int i = 0; i < totalDeTimes; i++) {
            wp.add(BigDecimal.ZERO);
        }
        ArrayList<BigDecimal> owp = new ArrayList<BigDecimal>(totalDeTimes);
        for (int i = 0; i < totalDeTimes; i++) {
            owp.add(BigDecimal.ZERO);
        }
        ArrayList<BigDecimal> oowp = new ArrayList<BigDecimal>(totalDeTimes);
        for (int i = 0; i < totalDeTimes; i++) {
            oowp.add(BigDecimal.ZERO);
        }

        // WP
        for (int i = 0; i < totalDeTimes; i++) {
            int totalDeJogos = 0;
            int totalDeVitorias = 0;

            ArrayList<Integer> time = times.get(i);
            for (int j = 0; j < time.size(); j++) {
                Integer val = time.get(j);
                if (val != null) {
                    totalDeJogos++;
                    if (val.equals(1)) {
                        totalDeVitorias++;
                    }
                }
            }

            BigDecimal wpVal = new BigDecimal(totalDeVitorias).divide(new BigDecimal(totalDeJogos), 6,
                    RoundingMode.DOWN);
            wp.remove(i);
            wp.add(i, wpVal);
        }

        // OWP
        for (int i = 0; i < totalDeTimes; i++) {
            ArrayList<BigDecimal> wpj = new ArrayList<BigDecimal>(totalDeTimes);
            for (int w = 0; w < totalDeTimes; w++) {
                wpj.add(BigDecimal.ZERO);
            }
            for (int j = 0; j < totalDeTimes; j++) {
                if (j != i && (times.get(i).get(j) != null)) {
                    int totalDeJogos = 0;
                    int totalDeVitorias = 0;

                    ArrayList<Integer> time = times.get(j);
                    for (int k = 0; k < time.size(); k++) {
                        if (k != i) {
                            Integer val = time.get(k);
                            if (val != null) {
                                totalDeJogos++;
                                if (val.equals(1)) {
                                    totalDeVitorias++;
                                }
                            }
                        }
                    }
                    wpj.remove(j);
                    wpj.add(j,
                            new BigDecimal(totalDeVitorias).divide(new BigDecimal(totalDeJogos), 12, RoundingMode.HALF_UP));
                }
            }

            ArrayList<Integer> time = times.get(i);
            int totalDeJogosDoTimeI = 0;
            for (int j = 0; j < time.size(); j++) {
                Integer val = time.get(j);
                if (val != null) {
                    totalDeJogosDoTimeI++;
                }
            }

            BigDecimal owpi = BigDecimal.ONE.divide(new BigDecimal(totalDeJogosDoTimeI), 12, RoundingMode.HALF_UP);
            BigDecimal sum = BigDecimal.ZERO;
            for (BigDecimal bd : wpj) {
                sum = sum.add(bd);
            }
            owpi = owpi.multiply(sum);

            owp.remove(i);
            owp.add(i, owpi);
        }

        // OOWP
        for (int i = 0; i < totalDeTimes; i++) {
            int totalDeJogosTimeI = 0;
            BigDecimal sum = BigDecimal.ZERO;
            ArrayList<Integer> time = times.get(i);
            for (int j = 0; j < totalDeTimes; j++) {
                if (j != i && (times.get(i).get(j) != null)) {
                    if(time.get(j) != null) {
                        totalDeJogosTimeI++;
                        sum = sum.add(owp.get(j));
                    }
                }
            }
            
            oowp.remove(i);
            oowp.add(i, BigDecimal.ONE.divide(new BigDecimal(totalDeJogosTimeI), 12, RoundingMode.HALF_UP).multiply(sum));
        }

        
        ArrayList<BigDecimal> rpi = new ArrayList<BigDecimal>(totalDeTimes);
        for (int i = 0; i < totalDeTimes; i++) {
            rpi.add(BigDecimal.ZERO);
            
            BigDecimal sum = BigDecimal.ZERO;
            sum = sum.add(new BigDecimal(0.25).multiply(wp.get(i)));
            sum = sum.add(new BigDecimal(0.5).multiply(owp.get(i)));
            sum = sum.add(new BigDecimal(0.25).multiply(oowp.get(i)));
            
            rpi.remove(i);
            rpi.add(i, sum);
        }
        
        String respo = "";
        for (int i = 0; i < totalDeTimes; i++) {
            BigDecimal big = rpi.get(i);
            if(big.compareTo(new BigDecimal(0.000001)) < 0) {
                big = BigDecimal.ZERO;
            }
            respo = respo.concat("\n" + big.setScale(12, RoundingMode.HALF_UP));
        }
        
        return respo;
    }

    public static List<String> solve(File arquivo) throws FileNotFoundException {
        Scanner scanner = new Scanner(arquivo);
        ArrayList<String> respostas = new ArrayList<String>();

        int totalDeCasos = scanner.nextInt();
        scanner.nextLine();
        for (int numeroDoCaso = 1; numeroDoCaso <= totalDeCasos; numeroDoCaso++) {
            respostas.add("Case #" + numeroDoCaso + ": " + solveCase(scanner));
        }

        return respostas;
    }

    public static void main(String[] args) throws IOException {
//        File entrada = new File("src/gcj2011/round1/RPI/exemploInput");
//        File output = new File("src/gcj2011/round1/RPI/exemploOutput");
//        File entrada = new File("src/gcj2011/round1/RPI/A-small-attempt4.in");
//        File output = new File("src/gcj2011/round1/RPI/A-small-attempt4.out");
        File entrada = new File("src/gcj2011/round1/RPI/A-large.in");
        File output = new File("src/gcj2011/round1/RPI/A-large.out");
        

        BufferedWriter answerWriter = new BufferedWriter(new FileWriter(output));
        List<String> respostas = solve(entrada);

        for (String resposta : respostas) {
            System.out.println(resposta);

            answerWriter.write(resposta);
            answerWriter.newLine();
        }

        answerWriter.flush();
    }

}
