package gcj2011.qualification.problemA.botTrust;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Solver {
    private Scanner scanner;

    public Solver(File arquivo) throws FileNotFoundException {
        this.scanner = new Scanner(arquivo);
    }

    public List<String> solve() {
        ArrayList<String> respostas = new ArrayList<String>();

        int totalDeCasos = scanner.nextInt();
        scanner.nextLine();
        for (int numeroDoCaso = 1; numeroDoCaso <= totalDeCasos; numeroDoCaso++) {
            respostas.add("Case #" + numeroDoCaso + ": " + solveCase(scanner));
        }

        return respostas;
    }

    private int solveCase(Scanner scannerLinha) {
        int totalDeBotoesParaSeApertar = scannerLinha.nextInt();

        ArrayList<InstrucaoPorRobo> sequenciaDeInstrucoes = new ArrayList<InstrucaoPorRobo>();
        for (int intrucaoNumero = 0; intrucaoNumero < totalDeBotoesParaSeApertar; intrucaoNumero++) {
            sequenciaDeInstrucoes.add(new InstrucaoPorRobo(scannerLinha.next(), scannerLinha.nextInt()));
        }

        int totalDeMovimentos = 0;

        int botoesApertados = 0;
        int instrucaoNumero = 0;
        Robo orange = new Robo("O");
        Robo blue = new Robo("B");
        orange.setBotaoQuePrecisaApertar(pegaProximoBotaoParaDeterminadoRobo(orange, sequenciaDeInstrucoes));
        blue.setBotaoQuePrecisaApertar(pegaProximoBotaoParaDeterminadoRobo(blue, sequenciaDeInstrucoes));

        while (botoesApertados < totalDeBotoesParaSeApertar) {
            boolean apertou = false;
            apertou = decide(sequenciaDeInstrucoes, botoesApertados, orange) || apertou;
            apertou = decide(sequenciaDeInstrucoes, botoesApertados, blue) || apertou;
            if (apertou) {
                botoesApertados++;
            }

            totalDeMovimentos++;
        }

        return totalDeMovimentos;
    }

    private boolean decide(ArrayList<InstrucaoPorRobo> sequenciaDeInstrucoes, int instrucaoNumero, Robo robo) {
        boolean apertou = false;

        if (robo.aindaTemBotoesParaApertar()) {
            if (robo.getPosicaoAtual() == robo.getBotaoQuePrecisaApertar()) {
                if (instrucaoNumero == robo.getPosicaoDaInstrucaoPega()) {
                    apertou = true;
                    robo.setBotaoQuePrecisaApertar(pegaProximoBotaoParaDeterminadoRobo(robo, sequenciaDeInstrucoes));
                }
            } else {
                if (robo.getBotaoQuePrecisaApertar() > robo.getPosicaoAtual()) {
                    robo.setPosicaoAtual(robo.getPosicaoAtual() + 1);
                } else {
                    robo.setPosicaoAtual(robo.getPosicaoAtual() - 1);
                }
            }
        }
        return apertou;
    }

    private int pegaProximoBotaoParaDeterminadoRobo(Robo robo, ArrayList<InstrucaoPorRobo> instrucoes) {
        InstrucaoPorRobo instrucaoAtual;
        for (int indice = robo.getPosicaoDaInstrucaoPega() + 1; indice < instrucoes.size(); indice++) {
            instrucaoAtual = instrucoes.get(indice);
            if (instrucaoAtual.getRobo().equals(robo.getNome())) {
                robo.setPosicaoDaInstrucaoPega(indice);
                return instrucaoAtual.getBotao();
            }

        }
        return -1;
    }

}
