import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class RevengeOfThePancakes {

	public static void main(String[] args) throws FileNotFoundException {
		File pancakesInput = new File("B-large.txt");
		printSolution(pancakesInput);
	}
	
	public static boolean[] getStack(String input) {
		boolean[] stack = new boolean[input.length()];
		String[] inputArray = input.split("");
		for (int i = 0; i < input.length(); i++) {
			if (inputArray[i].equals("+")) {
				stack[i] = true;
			}
			else {
				stack[i] = false;
			}
		}
		return stack;
	}
	
	public static boolean[] flipStack(boolean[] stack, int position) {
		boolean[] newStack = stack;
		for (int i = 0; i <= position; i++) {
			newStack[i] = !newStack[i];
		}
		return newStack;
	}
	
	public static int minFlips(boolean[] stack) {
		boolean[] currentStack = stack;
		int counter = 0;
		for (int i = 0; i < stack.length; i++) {
			if (i == stack.length - 1 && currentStack[i] == true) {
				return counter;
			}
			else if (i == stack.length - 1 && currentStack[i] == false) {
				return counter + 1;
			}
			if (currentStack[i] != currentStack[i+1]) {
				currentStack = flipStack(currentStack, i);
				counter++;
			}
		}
		return counter;
	}
	
	public static void printSolution(File inputFile) throws FileNotFoundException {
		Scanner in = new Scanner(inputFile);
		int numTestCases = Integer.parseInt(in.nextLine());
		
		for (int i = 1; i <= numTestCases; i++) {
			String currentInput = in.nextLine();
			System.out.println("Case #" + i + ": " + minFlips(getStack(currentInput)));
		}
	}
}
