
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Vector;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author Aditya
 */

enum Situations{
    KEEP_TYPING,
    PRESS_BACKSPACE,
    PRESS_ENTER 
}
class TestR1Q1{
    int typed,total;
    double[] probs;
            
    double ret;
    public TestR1Q1(int typed,int total,double[] probs){
        this.typed=typed;
        this.total=total;
        this.probs=probs;
    }
   
    //return the number of keystrokes required for a given situation
    public int getKeyStrokes(Situations sit,int typed,int total, int earliest, int numBackspaces){
        int ret=0;
        switch(sit){
            case KEEP_TYPING:
                if(earliest==-1){
                    ret=total-typed+1;
                }else{
                    ret+=total-typed+1+total+1;
                }
                break;
            case PRESS_BACKSPACE:
                ret+=numBackspaces;
                //What is newpos?
                //If there were no mistakes
                
                //let newTyped be the chars remaining on the screen
                int newTyped=typed-numBackspaces;
                    
                if(earliest==-1){
                    ret+=(total-newTyped)+1;
                }else{
                    //there are no characters left
                    if(newTyped==0){
                        ret+=total+1;
                    }else{
                        //there are chars remaining on the screen
                        //if there are not mistakes in any of the remaining chars
                        if(earliest+1>newTyped){
                            ret+=(total-newTyped)+1;
                        }else{
                            //there is a mistake in the remaining chars
                            ret+=(total-newTyped)+total+2;
                        }
                    }
                }
                
                break;
            case PRESS_ENTER:
                ret=total+2;
                break;
        }
        //System.out.println(earliest+" "+numBackspaces+" "+ret);
        return ret;
    }
    
    public double getProb(int earliest){
        double ret=1;
        if(earliest==-1){
            for(int i=0;i<typed;i++){
                ret*=probs[i];
            }
            return ret;
        }
        for(int i=0;i<earliest;i++){
            ret*=probs[i];
        }
        ret*=(1.0-probs[earliest]);
        return ret;
    }
    
    public void process(){
        //I want to save the position of the first mistake index in earliest
        double[] probs=new double[2+typed];
       
        for(int earliest=-1;earliest<typed;earliest++){
            double prob=getProb(earliest);
            
            
            probs[0]+=prob*getKeyStrokes(Situations.KEEP_TYPING, typed, total, earliest, -1);
            for(int j=1;j<=typed;j++){
                probs[j]+=prob*getKeyStrokes(Situations.PRESS_BACKSPACE, typed, total, earliest, j);
            }
            
        }
        
         probs[typed+1]=total+2;
         double min=probs[0];
         for(int i=1;i<typed+2;i++){
             if(probs[i]<min){
                 min=probs[i];
             }
         }
         
         ret=min;
        
    }
    
    public double getAnswer(){
        return ret;
    }
       
}

public class R1Q1 {
    public static int numInputs;
    
    public static Vector<TestR1Q1> cases= new Vector<TestR1Q1>();
    
    public static BufferedReader br ;   
    
    public static void readInput(){
        String s;
        try{
            br=new BufferedReader(new FileReader("f:\\test\\asdasd.in"));   
            if((s=br.readLine())!=null){
                numInputs=Integer.parseInt(s);
                
                for(int i=0;i<numInputs;i++){
                    String[] temp= br.readLine().split(" ");
                    
                    int typed=Integer.parseInt(temp[0]);
                    int total=Integer.parseInt(temp[1]);
                    
                    double[] probs=new double[typed];
                    
                    temp=br.readLine().split(" ");
                    
                    for(int j=0;j<typed;j++){
                        probs[j]=Double.parseDouble(temp[j]);
                    }
                    
                    cases.add(new TestR1Q1(typed,total,probs));
                }
            }
        }catch(IOException ioex){
            ;
        }
    }
    
    public static void process(){
        for(TestR1Q1 t:cases){
            t.process();
        }
    }
    
    public static void printOutput(){
        for(int i=0;i<cases.size();i++){
            System.out.print("Case #"+(i+1)+": ");
            System.out.printf("%.7g\n",cases.get(i).getAnswer());
        }
    }
    
    public static void main(String[] args){
        readInput();
        process();
        printOutput();
    }

}
