package a;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;
import org.apache.commons.lang3.tuple.Pair;

import java.util.Arrays;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by Adi on 30/04/2016.
 * Guava Library is available online by Google :) - https://github.com/google/guava
 * Apache common Library is available online by apache :) - https://commons.apache.org/proper/commons-lang/download_lang.cgi
 */
public class ASmall {

    public static final String ZERO = "ZERO";
    public static final String ONE = "ONE";
    public static final String TWO = "TWO";
    public static final String THREE = "THREE";
    public static final String FOUR = "FOUR";
    public static final String FIVE = "FIVE";
    public static final String SIX = "SIX";
    public static final String SEVEN = "SEVEN";
    public static final String EIGHT = "EIGHT";
    public static final String NINE = "NINE";

    private final static List<Pair<String, String>> lstPairs = Lists.newArrayList();
    private final static Map<String, String> mpChars = Maps.newHashMap();
    static
    {
        lstPairs.add(Pair.of("Z", ZERO));
        lstPairs.add(Pair.of("W", TWO));
        lstPairs.add(Pair.of("U", FOUR));
        lstPairs.add(Pair.of("O", ONE));
        lstPairs.add(Pair.of("F", FIVE));
        lstPairs.add(Pair.of("R", THREE));
        lstPairs.add(Pair.of("X", SIX));
        lstPairs.add(Pair.of("S", SEVEN));
        lstPairs.add(Pair.of("T", EIGHT));
        lstPairs.add(Pair.of("N", NINE));

        mpChars.put(ZERO, "0");
        mpChars.put(ONE, "1");
        mpChars.put(TWO, "2");
        mpChars.put(THREE, "3");
        mpChars.put(FOUR, "4");
        mpChars.put(FIVE, "5");
        mpChars.put(SIX, "6");
        mpChars.put(SEVEN, "7");
        mpChars.put(EIGHT, "8");
        mpChars.put(NINE, "9");
    }


    private List<String> lstOutput = Lists.newArrayList();

    public ASmall()
    {
        Scanner in = new Scanner(System.in);

        int T = in.nextInt();
        in.nextLine();

        for(int i=0; i < T; i++)
        {
            String S = in.nextLine();

            String sNumber = "";

            for(int j=0; j < lstPairs.size(); j++)
            {
                if(S.length() == 0)
                {
                    break;
                }
                Pair<String, String> pair = lstPairs.get(j);
                if(S.contains(pair.getLeft()))
                {
                    String currentDigit = pair.getRight();
                    for(int k = 0; k < currentDigit.length(); k++)
                    {
                        String ch = "" + currentDigit.charAt(k);
                        S = S.replaceFirst(ch, "");
                    }
                    sNumber += mpChars.get(currentDigit);
                    j = -1;
                }
            }

            if(S.length() > 0) throw new RuntimeException(i + "Not Empty for: " + S);

            char[] chars = sNumber.toCharArray();
            Arrays.sort(chars);
            ;
            lstOutput.add("Case #" + (i+1) + ": " + new String(chars));
        }

        in.close();
    }

    public void printOutput()
    {
        for(String string : lstOutput)
        {
            System.out.println(string);
        }
    }

    public static void main(String[] args)
    {
        ASmall main = new ASmall();
        main.printOutput();
    }
}
