package dijkstra;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Dijsktra_A
{
	private static final Map<String, String> mpOptimization = new HashMap<String, String>();

	private static final Map<String, String> mpDijsktra;
	static
	{
		mpDijsktra = new HashMap<String, String>();
		mpDijsktra.put("11", "1");
		mpDijsktra.put("1i", "i");
		mpDijsktra.put("1j", "j");
		mpDijsktra.put("1k", "k");
		mpDijsktra.put("i1", "i");
		mpDijsktra.put("ii", "-1");
		mpDijsktra.put("ij", "k");
		mpDijsktra.put("ik", "-j");
		mpDijsktra.put("j1", "j");
		mpDijsktra.put("ji", "-k");
		mpDijsktra.put("jj", "-1");
		mpDijsktra.put("jk", "i");
		mpDijsktra.put("k1", "k");
		mpDijsktra.put("ki", "j");
		mpDijsktra.put("kj", "-i");
		mpDijsktra.put("kk", "-1");
	}

	public static final String YES = "YES";
	public static final String NO = "NO";

	public static final String I = "i";
	public static final String J = "j";
	public static final String K = "k";

	public static String MINUS = "-";

	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);

		int T = in.nextInt();

		ArrayList<String> lstOutput = new ArrayList<String>();

		for(int i = 1; i <= T; i++)
		{
			int L = in.nextInt();
			int X = in.nextInt();
			in.nextLine();

			String sLine = in.nextLine();
			String sString = "";
			for(int j = 0; j < X; j++)
			{
				sString += sLine;
			}

			String sResult = NO;
			if(sString.length() >= 3)
			{
				int iIterator = 0;
				String stringSearch = "1";

				searchI: while(true)
				{
					while(!stringSearch.equals(I))
					{
						iIterator++;
						if(iIterator > sString.length())
						{
							break searchI;
						}

						stringSearch = dijkstra(stringSearch, sString.substring(iIterator - 1, iIterator));
					}

					if(searchJK(sString, iIterator))
					{
						sResult = YES;
						break searchI;
					}
					else
					{
						iIterator++;
						if(iIterator > sString.length())
						{
							break searchI;
						}

						stringSearch = dijkstra(stringSearch, sString.substring(iIterator - 1, iIterator));
					}
				}
			}

			String sOutput = "Case #" + i + ": ";
			sOutput += sResult;
			lstOutput.add(sOutput);
		}

		for(String string : lstOutput)
		{
			System.out.println(string);
		}

		in.close();
	}

	private static boolean searchJK(String sString, int iIterator)
	{
		int jIterator = iIterator;
		String jStringSearch = "1";

		while(true)
		{
			while(!jStringSearch.equals(J))
			{
				jIterator++;
				if(jIterator > sString.length())
				{
					return false;
				}

				jStringSearch = dijkstra(jStringSearch, sString.substring(jIterator - 1, jIterator));
			}

			String kString = sString.substring(jIterator);
			if(kString.isEmpty())
			{
				return false;
			}

			if(multiply("1", kString).equals(K))
			{
				return true;
			}

			jIterator++;
			jStringSearch = dijkstra(jStringSearch, sString.substring(jIterator - 1, jIterator));
		}
	}

	private static String multiply(String sCharA, String sCharB)
	{
		if(mpOptimization.containsKey(sCharB))
		{
			return mpOptimization.get(sCharB);
		}

		String sResult = sCharA;
		int iIterator = 0;
		while(sCharB.length() > iIterator)
		{
			sResult = dijkstra(sResult, sCharB.substring(iIterator, iIterator + 1));
			iIterator++;
		}

		if(!mpOptimization.containsKey(sCharB))
		{
			mpOptimization.put(sCharB, sResult);
		}

		return sResult;
	}

	private static String dijkstra(String charA, String charB)
	{
		boolean bMinus = false;
		String sResult;
		if(charA.startsWith(MINUS))
		{
			bMinus = true;
			sResult = mpDijsktra.get(charA.substring(1) + charB);
		}
		else
		{
			sResult = mpDijsktra.get(charA + charB);
		}

		if(bMinus)
		{
			if(sResult.startsWith(MINUS))
			{
				return sResult.substring(1, 2);
			}
			else
			{
				return MINUS + sResult;
			}
		}

		return sResult;
	}
}
