package pony_express;

import com.google.common.collect.Lists;
import javafx.util.Pair;

import java.util.List;
import java.util.Scanner;

/**
 * Created by Adi
 * Guava Library is available online by Google :) - https://github.com/google/guava
 */
public class C_Small {

    private List<String> lstOutput = Lists.newArrayList();

    public C_Small()
    {
        Scanner in = new Scanner(System.in);

        int T = in.nextInt();

        for(int i=0; i < T; i++)
        {
            int N = in.nextInt();
            int Q = in.nextInt();

            int[] E = new int[N];
            int[] S = new int[N];
            for(int n=0; n < N; n++)
            {
                E[n] = in.nextInt();
                S[n] = in.nextInt();
            }

            int[][] routes = new int[N][N];
            for(int row=0; row < N; row++)
            {
                for(int col=0; col < N; col++)
                {
                    routes[row][col] = in.nextInt();
                }
            }
            int[] U = new int[Q];
            int[] V = new int[Q];
            for(int q=0; q < Q; q++)
            {
                U[q] = in.nextInt();
                V[q] = in.nextInt();
            }

            List<Pair<Double, Pair<Integer, Integer>>> lstPreviousTimes = Lists.newArrayList();
            int distance = routes[0][1];
            double speed = S[0];
            double dTime = (double)distance/speed;
            lstPreviousTimes.add(new Pair(dTime, new Pair(0, distance)));
            for(int currentCity=1; currentCity < N - 1; currentCity++)
            {
                List<Pair<Double, Pair<Integer, Integer>>> lstTimes = Lists.newArrayList();
                distance = routes[currentCity][currentCity+1];
                for (Pair<Double, Pair<Integer, Integer>> previousTime : lstPreviousTimes) {
                    Double currentTime = previousTime.getKey();
                    Pair<Integer, Integer> horse = previousTime.getValue();
                    int horseNumber = horse.getKey();
                    int horseTravelDistance = horse.getValue();

                    if(horseTravelDistance + distance <= E[horseNumber]) {
                        speed = S[horseNumber];
                        double horseTime = (double)distance/speed;
                        Double newTime = currentTime + horseTime;
                        lstTimes.add(new Pair(newTime, new Pair(horseNumber, horseTravelDistance + distance)));
                    }

                    if(distance <= E[currentCity]) {
                        speed = S[currentCity];
                        double horseTime = (double)distance/speed;
                        Double newTime = currentTime + horseTime;
                        lstTimes.add(new Pair(newTime, new Pair(currentCity, distance)));
                    }
                }

                lstPreviousTimes = lstTimes;
            }

            double dTravelTime = lstPreviousTimes.get(0).getKey();
            for (Pair<Double, Pair<Integer, Integer>> lstPreviousTime : lstPreviousTimes) {
                if(lstPreviousTime.getKey() < dTravelTime) {
                    dTravelTime = lstPreviousTime.getKey();
                }
            }

            lstOutput.add("Case #" + (i+1) + ": " + dTravelTime);
        }

        in.close();
    }

    public void printOutput()
    {
        for(String string : lstOutput)
        {
            System.out.println(string);
        }
    }

    public static void main(String[] args)
    {
        C_Small main = new C_Small();
        main.printOutput();
    }
}
