package stable_neigh_bors;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;

import java.util.List;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by Adi
 * Guava Library is available online by Google :) - https://github.com/google/guava
 */
public class B_Small {

    private List<String> lstOutput = Lists.newArrayList();

    public static final Character RED = 'R';
    public static final Character ORANGE = 'O';
    public static final Character YELLOW = 'Y';
    public static final Character GREEN = 'G';
    public static final Character BLUE = 'B';
    public static final Character VIOLET = 'V';

    public B_Small()
    {
        Scanner in = new Scanner(System.in);

        int T = in.nextInt();

        testCase: for(int i=0; i < T; i++)
        {
            int N = in.nextInt();

            Map<Character, Integer> mpUnicorns = Maps.newHashMap();
            mpUnicorns.put(RED, in.nextInt());
            mpUnicorns.put(ORANGE, in.nextInt());
            mpUnicorns.put(YELLOW, in.nextInt());
            mpUnicorns.put(GREEN, in.nextInt());
            mpUnicorns.put(BLUE, in.nextInt());
            mpUnicorns.put(VIOLET, in.nextInt());


            char[] stalls = new char[N];
            for(int n=0; n < N; n++)
            {
                Character unicorn = getUnicorn(mpUnicorns, stalls, n);
                if(null == unicorn) {
                    lstOutput.add("Case #" + (i+1) + ": IMPOSSIBLE");
                    continue testCase;
                }

                mpUnicorns.put(unicorn, mpUnicorns.get(unicorn) - 1);
                stalls[n] = unicorn;
            }

            String sStalls = new String(stalls);
            lstOutput.add("Case #" + (i+1) + ": " + sStalls);
        }

        in.close();
    }

    private Character getUnicorn(Map<Character, Integer> mpUnicorns, char[] stalls, int n)
    {
        int iMax = 0;
        Character cColor = null;
        for (Map.Entry<Character, Integer> unicorn : mpUnicorns.entrySet())
        {
            if(unicorn.getValue() >= iMax) {
                if(isColorAllowed(unicorn.getKey(), stalls, n)) {
                    cColor = unicorn.getKey();
                    iMax = unicorn.getValue();
                }
            }
        }

        return cColor;
    }

    private boolean isColorAllowed(Character color, char[] stalls, int n)
    {
        if(n == 0) {
            return true;
        }

        if(stalls[n-1] == color) {
            return false;
        }


        if(n == stalls.length -1 && stalls[0] == color) {
            return false;
        }

        return true;
    }

    public void printOutput()
    {
        for(String string : lstOutput)
        {
            System.out.println(string);
        }
    }

    public static void main(String[] args)
    {
        B_Small main = new B_Small();
        main.printOutput();
    }
}
