package bathroom_stalls;

import com.google.common.collect.Lists;
import javafx.util.Pair;

import java.util.List;
import java.util.Scanner;

/**
 * Created by Adi on 09/04/2016.
 * Guava Library is available online by Google :) - https://github.com/google/guava
 */
public class C_small {

    private List<String> lstOutput = Lists.newArrayList();

    public C_small()
    {
        Scanner in = new Scanner(System.in);

        int T = in.nextInt();

        for(int i=0; i < T; i++)
        {
            int N = in.nextInt();
            int K = in.nextInt();

            int[] arrStalls = initStalls(N);
            int iHighestMin = -1;
            int iHighestMax = -1;

            for(int j=0; j < K; j++)
            {
                iHighestMin = -1;
                iHighestMax = -1;
                int iLocation = -1;
                List<Pair<Integer, Integer>> lstMaxMin = buildMaxMin(N, arrStalls);
                for(int k=0; k < lstMaxMin.size(); k++)
                {
                    Pair<Integer, Integer> maxMin = lstMaxMin.get(k);
                    if((maxMin.getValue() > iHighestMin) ||
                            (maxMin.getValue() == iHighestMin && maxMin.getKey() > iHighestMax))
                    {
                        iHighestMin = maxMin.getValue();
                        iHighestMax = maxMin.getKey();
                        iLocation = k+1;
                    }
                }
                arrStalls[iLocation] = 1;
            }

            lstOutput.add("Case #" + (i+1) + ": " + String.valueOf(iHighestMax) + " " + String.valueOf(iHighestMin));
        }

        in.close();
    }

    private List<Pair<Integer, Integer>> buildMaxMin(int n, int[] arrStalls)
    {
        List<Pair<Integer, Integer>> lstMaxMin = Lists.newArrayList();
        for(int k = 1; k <= n; k++)
        {
            if(arrStalls[k] == 1)
            {
                lstMaxMin.add(new Pair<>(-1, -1));
                continue;
            }

            int left = 0;
            int right = 0;
            for(int l=k-1; l>=0; l--)
            {
                if(arrStalls[l] == 1)
                {
                    left = (k-l) - 1;
                    break;
                }
            }
            for(int l = k+1; l<= n+1; l++)
            {
                if(arrStalls[l] == 1)
                {
                    right = (l-k) - 1;
                    break;
                }
            }

            int max = Math.max(left, right);
            int min = Math.min(left, right);
            lstMaxMin.add(new Pair(max, min));
        }
        return lstMaxMin;
    }

    private int[] initStalls(int n) {
        int[] arrStalls = new int[n +2];
        arrStalls[0] = 1;
        for(int j=1; j < arrStalls.length - 1; j++)
        {
            arrStalls[j] = 0;
        }
        arrStalls[arrStalls.length - 1] = 1;
        return arrStalls;
    }

    public void printOutput()
    {
        for(String string : lstOutput)
        {
            System.out.println(string);
        }
    }

    public static void main(String[] args)
    {
        C_small main = new C_small();
        main.printOutput();
    }
}
