package coin_jam;

import com.google.common.collect.Lists;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by Adi on 09/04/2016.
 */
public class CoinJamSmall {

    public static final long NO_DIVISORS = -1;

    private List<String> lstOutput = Lists.newArrayList();

    public CoinJamSmall()
    {
        Scanner in = new Scanner(System.in);

        int T = in.nextInt();
        int N = in.nextInt();
        int J = in.nextInt();
        lstOutput.add("Case #1: ");

        ArrayList<String> lstBinaryStrings = generateBinaryStrings(N);

        stringsLoop : for (String binaryString : lstBinaryStrings)
        {
            String sLine = binaryString;
            for(int i=2; i <= 10; i++)
            {
                long baseValue = Long.parseLong(binaryString, i);
                long divisor = getDivisor(baseValue);
                if(divisor == NO_DIVISORS)
                {
                    continue stringsLoop;
                }

                sLine += " " + divisor;
            }

            lstOutput.add(sLine);
            if(lstOutput.size() == J+1)
            {
                break stringsLoop;
            }
        }

        in.close();
    }

    private ArrayList<String> generateBinaryStrings(int length)
    {
        String start = "1";
        String end = "1";
        for(int i=1; i < length - 1; i++)
        {
            start += "0";
            end += "1";
        }
        start += "1";
        end += "1";
        long smallest = Long.parseLong(start, 2);
        long largest = Long.parseLong(end, 2);

        ArrayList<String> lstBinaryStrings = Lists.newArrayList();
        for(long i=smallest; i < largest; i++)
        {
            String binaryValue = Long.toBinaryString(i);
            if(binaryValue.endsWith("1"))
            {
                lstBinaryStrings.add(binaryValue);
            }
        }

        return lstBinaryStrings;
    }

    public long getDivisor(long number) {
        long sqrt = (long) Math.sqrt(number) + 1;
        for (long i = 2; i < sqrt; i++)
        {
            if (number % i == 0)
            {
                return i;
            }
        }
        return NO_DIVISORS;
    }


    public void printOutput()
    {
        for(String string : lstOutput)
        {
            System.out.println(string);
        }
    }

    public static void main(String[] args)
    {
        CoinJamSmall main = new CoinJamSmall();
        main.printOutput();
    }
}
