package revenge_of_the_pancakes;

import com.google.common.collect.Lists;

import java.util.List;
import java.util.Scanner;

/**
 * Created by Adi on 09/04/2016.
 * Guava Library is available online by Google :) - https://github.com/google/guava
 */
public class RevengeSmall {

    private List<String> lstOutput = Lists.newArrayList();

    public static final char HAPPY_SIDE = '+';
    public static final char BLANK_SIDE = '-';

    public RevengeSmall()
    {
        Scanner in = new Scanner(System.in);

        int N = in.nextInt();
        in.nextLine(); //cut the line

        for(int i=0; i < N; i++)
        {
            String sLine = in.nextLine();
            char[] pancakes = sLine.toCharArray();
            int length = pancakes.length - 1;
            int flips = 0;

            for(int j = length; j >= 0 ; j--)
            {
                if(pancakes[j] != HAPPY_SIDE)
                {
                    pancakes = flipStack(pancakes, j);
                    flips++;
                }
            }
            lstOutput.add("Case #" + (i+1) + ": " + flips);
        }

        in.close();
    }

    private char[] flipStack(char[] pancakes, int index)
    {
        for(int i =0; i <= index; i++)
        {
            pancakes[i] = (pancakes[i] == HAPPY_SIDE) ? BLANK_SIDE : HAPPY_SIDE;
        }

        return pancakes;
    }

    public void printOutput()
    {
        for(String string : lstOutput)
        {
            System.out.println(string);
        }
    }

    public static void main(String[] args)
    {
        RevengeSmall main = new RevengeSmall();
        main.printOutput();
    }
}
