import java.util.Scanner;

public class Dijkstra {

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = Integer.parseInt(in.nextLine());
		for (int t = 0; t < T; t++) {
			String[] s = in.nextLine().split(" ");
			int L = Integer.parseInt(s[0]);
			int X = Integer.parseInt(s[1]);
			char[] ch = in.nextLine().toCharArray();
			Value v = new Value('1', 1);
			for (int i = 0; i < L; i++) {
				v = multiply(v, new Value(ch[i], 1));
			}
			Value V = new Value('1', 1);
			for (int i = 0; i < (X % 4); i++) {
				V = multiply(V, v);
			}
			if (!V.equals(new Value('1', -1))) {
				System.out.println("Case #" + (t + 1) + ": " + "NO");
			} else {
				int I = 0;
				int K = X * L - 1;
				boolean IFound = false, KFound = false;
				Value Icounter = new Value('1', 1);
				Value Kcounter = new Value('1', 1);
				for (; I < Math.min(4 * L, X * L); I++) {
					Icounter = multiply(Icounter, new Value(ch[I % L], 1));
					if (Icounter.equals(new Value('i', 1))) {
						IFound = true;
						break;
					}
				}
				for (; K >= Math.max(X * L - 4 * L, 0); K--) {
					Kcounter = multiply(Kcounter, new Value(ch[K % L], 1));
					if (Kcounter.equals(new Value('k', 1))) {
						KFound = true;
						break;
					}
				}

				if (I + 1 < K && IFound && KFound)
					System.out.println("Case #" + (t + 1) + ": " + "YES");
				else
					System.out.println("Case #" + (t + 1) + ": " + "NO");
			}

		}

	}

	public static Value multiply(Value i, Value j) {
		Value v = null;
		Value first, second;
		if (i.ch == '1' || j.ch == '1') {
			if (i.ch == '1')
				v = new Value(j.ch, 1);
			else
				v = new Value(i.ch, 1);

		} else {
			if (i.ch < j.ch) {
				first = i;
				second = j;
			} else {
				first = j;
				second = i;
			}
			if (first.ch == second.ch) {
				v = new Value('1', -1);
			} else if (first.ch == 'i' && second.ch == 'j') {
				if (first.equals(i))
					v = new Value('k', 1);
				else
					v = new Value('k', -1);
			} else if (first.ch == 'i' && second.ch == 'k') {
				if (first.equals(i))
					v = new Value('j', -1);
				else
					v = new Value('j', 1);
			} else if (first.ch == 'j' && second.ch == 'k') {
				if (first.equals(i))
					v = new Value('i', 1);
				else
					v = new Value('i', -1);
			}
		}
		if (i.sign + j.sign == 0)
			v = v.reverseSign(v);

		return v;
	}

	public static class Value {
		int sign;
		char ch;

		public Value(char c, int s) {
			sign = s;
			ch = c;
		}

		public boolean equals(Value obj) {
			if (obj == null) {
				return false;
			}
			if (this.ch == obj.ch && this.sign == obj.sign)
				return true;
			return false;
		}

		public static Value reverseSign(Value v) {
			return new Value(v.ch, -1 * v.sign);
		}

		// public String toString() {
		//
		// return "[" + ch + "," + sign + "]";
		// }

	}
}
