

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;

public class Ovation {
	
	public static void main(String[] args) {
		
		//get input
		List<String> lines=getInput(args);
		
		int numberOfCases=Integer.parseInt(lines.get(0));
		List<String> outLines=new ArrayList<String>();
		for(int i=1; i<=numberOfCases; i++){
			//process input
			outLines.add(processInput(lines.get(i),i));			
		}
		//format output
		formatOutput(outLines);
		
	}
	
	private static void formatOutput(List<String> outLines) {
	
		PrintWriter writer=null;
		try {
			writer = new PrintWriter("output.txt", "UTF-8");
		} catch (FileNotFoundException | UnsupportedEncodingException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		/*writer.println("The first line");
		writer.println("The second line");*/
		
		for(String outLine: outLines){
			writer.println(outLine);
		}
		writer.close();
		
	}

	private static String processInput(String line, int caseNumber){
		
		
		int index=line.indexOf(" ");
		String firstPart=line.substring(0, index);		
		String secondPart=line.substring(index+1, line.length());
		
		int peopleSize=Integer.parseInt(firstPart)+1;
		//System.out.println(peopleSize);
		
		//create boolean array of Smax+1
		int [] people=new int[peopleSize];

		//if number greater than 1 then mark it true else false
		for(int i=0; i<secondPart.length();i++){
			//System.out.println(i+" case number "+caseNumber+" secondPart "+secondPart);
			people[i]=Integer.parseInt(secondPart.substring(i, i+1));						
		}
		
		/*for(int i=0; i<people.length; i++){
			System.out.print (people[i]+" ");			
		}
		System.out.println();*/

		 
		int counter=0;
		for(int i=people.length-1; i>=0;i--){
			
		
			int clappingPeople=0;
			for(int j=0; j<i; j++){
				clappingPeople=clappingPeople+people[j];
			}
			
			int remainder=i-clappingPeople;
			if(remainder>0){				
				if(remainder>counter){
					//counter=counter+remainder;
					counter=remainder;
				}
			}
			
		}
		
		//System.out.println("Case "+caseNumber+": "+counter);
		//Case #1: 0
		String lineOut=new String("Case #"+caseNumber+": "+counter);
		return lineOut;

		
	}
	
	private static List<String> getInput(String[] args){
		
		List<String> lines=null;
		
		try {
			lines = Files.readAllLines(Paths.get("A-large.in"), StandardCharsets.UTF_8);
			
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		return lines;
	} 

}
