import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;


public class Ominos {
	
	public static void main(String[] args) {
		//get input
		List<String> lines=getInput(args);
		
		int numberOfCases=Integer.parseInt(lines.get(0));
		List<String> outLines=new ArrayList<String>();
		
		for(int i=1; i<=numberOfCases; i++){
			//process input
			outLines.add(processInput(lines.get(i),i));			
		}
		//format output
		formatOutput(outLines);
				
	}
	private static String processInput(String line, int caseNumber){
	
	     StringTokenizer st = new StringTokenizer(line);
	     int [] xrc=new int[3];
	     int i=0;
	     while (st.hasMoreTokens()) {	    	 
	    	 String in=st.nextToken();
	         xrc[i]=Integer.parseInt(in);          
	         i++;
	     }
	     
	     String lineOut=null;
	     int rc=xrc[1]*xrc[2];

	     //System.out.println("rc/xrc[0] "+rc/xrc[0]+" rc%xrc[0] "+rc%xrc[0]);
	     if(rc/xrc[0]>1 & rc%xrc[0]==0){
	    	 lineOut=new String("Case #"+caseNumber+": GABRIEL");
	     }
	     else{	    	 

	    	 lineOut=new String("Case #"+caseNumber+": RICHARD");
	     }
		return lineOut;
	}
	
	private static List<String> getInput(String[] args){
		
		List<String> lines=null;
		
		try {
			lines = Files.readAllLines(Paths.get("D-small-attempt0.in"), StandardCharsets.UTF_8);
			
		} catch (IOException e) {
			
			e.printStackTrace();
		}
		
		return lines;
	} 
	
	private static void formatOutput(List<String> outLines) {
		
		/*for(String outLine: outLines){
			System.out.println(outLine);
		}*/
		
		PrintWriter writer=null;
		try {
			writer = new PrintWriter("OminoOutput.txt", "UTF-8");
		} catch (FileNotFoundException | UnsupportedEncodingException e) {
			
			e.printStackTrace();
		}
		
		for(String outLine: outLines){
			writer.println(outLine);
		}
		writer.close();
		
	}

}
