package abraham.google.codejam;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Minesweeper {
	public static void main(String[] args)throws IOException
	{
		File in = new File("C-small-attempt4.in");
		Scanner sc = new Scanner(in);
		File out = new File("answers-new.out");
		PrintWriter pw = new PrintWriter(out);
		
		int t = sc.nextInt();
		for(int i=0;i<t;i++)
		{
			int r = sc.nextInt();
			int c = sc.nextInt();
			int m = sc.nextInt();
			boolean feederfail = false;
			
			pw.println("Case #"+(i+1)+":");
			System.out.println("Case #"+(i+1)+":");
			
			int a[][] = new int[r][c];
			int ctr = 0;
			for(int j=0;j<r-2;j++)
			{
				for(int k=0;k<c;k++)
				{
					if(ctr<m)
					{
						a[j][k]=9;
						ctr++;
					}
				}
			}
			int l = m-ctr;
			if(l==0)
			{
				if(m!=0)
				{
					int ri = (m-1)/c;
					generalFeederCorrection(a,ri);
				}
			}
			columnArrangement(a,l);
			if(!isValidColumn(a))
			{
				int rf = feederCorrection(a,0);
				if(rf==-1)
				{	
					//System.out.println("Feeder: Impossible");
					feederfail=true;
				}
			}
			System.out.println(getArrayString(a));
			System.out.println(getFileArrayString(a));
			if(m==r*c-1)
			{
				System.out.println("Possible");
				pw.println(getFileArrayString(a));
			}
			else if(feederfail)
			{
				System.out.println("Impossible");
				pw.println("Impossible");
			}
			else if(clickPossible(a,m))
			{
				System.out.println("Possible");
				pw.print(getFileArrayString(a));
			}
			else
			{
				System.out.println("Impossible");
				pw.println("Impossible");
			}
		}
		sc.close();
		pw.flush();
		pw.close();
	}
	/**
	 * @param a
	 * @param ctr number of mines left
	 * @return
	 */
	public static int columnArrangement(int a[][], int ctr)
	{
		int result = 0;
		int tr = a.length;
		if(tr<2)
		{
			for(int j=0;j<a[0].length;j++)
			{
				if(ctr>0)
				{
					a[0][j]=9;
					ctr--;
				}
			}
		}
		for(int j=0;j<a[0].length;j++)
		{
			for(int i=a.length-2;i<a.length;i++)
			{
				if(ctr>0)
				{
					if(a[i][j]!=9)
					{
						a[i][j]=9;
						ctr--;
					}
				}
			}
		}
		return result;
	}
	public static int feederCorrection(int a[][], int ctr)
	{
		int i = a.length-3;
		if(i<0)
			return 0;
		int j = a[0].length-1;
		for(int k=0;k<a[0].length;k++)
		{
			if(a[i][k]==0)
			{
				j=k-1;
			}
		}
		if(j==-1)
			return -1;//failure
		if(a[a.length-2][j]==9&&a[a.length-1][j]==9)
		{
			return 0;//no correction
		}
		else if(a[a.length-2][j]==9)
		{
			return -1;//failure
		}
		if(j==a[0].length-1)
		{
			j=j-2;
			if(j<0)
				return -1;
			if(a[a.length-2][j]==9)
			{
				return -1;//failure
			}
			int tctr = 2;
			a[i][j+1]=0;
			a[i][j+2]=0;
			columnArrangement(a,tctr);
			if(isValidColumn(a))
				return 0;
			else
			{
				return feederCorrection(a,0);
			}
		}
		else
		{
			j=j-1;
			if(j<0)
				return -1;
			if(a[a.length-2][j]==9&&a[a.length-1][j]==9)
			{
				return -1;//failure
			}
			int tctr = 1;
			a[i][j+1]=0;
			columnArrangement(a,tctr);
			if(isValidColumn(a))
				return 0;
			else
			{
				return feederCorrection(a,0);
			}
		}
		//return r;
	}
	public static void generalFeederCorrection(int a[][], int ri)
	{
		int c = a[0].length;
		if(c<2)
			return;
		if(a[ri][c-1]==0&&a[ri][c-2]==9)
		{
			a[ri+1][0]=9;
			a[ri][c-2]=0;
		}
	}
	public static boolean isValidColumn(int a[][])
	{
		int rt = a.length;
		if(rt<2)
		{
			return true;
		}
		for(int j=0;j<a[0].length;j++)
		{
			if(a[a.length-2][j]!=a[a.length-1][j])
				return false;
		}
		return true;
	}
	public static String getArrayString(int a[][])
	{
		String s = "";
		for(int i =0;i<a.length;i++)
		{
			for(int j=0;j<a[i].length;j++)
			{
				s+=a[i][j]+" ";
			}
			s+="\n";
		}
		return s;
	}
	public static String getFileArrayString(int a[][])
	{
		String s = "";
		for(int i =0;i<a.length;i++)
		{
			for(int j=0;j<a[i].length;j++)
			{
				if(i==a.length-1&&j==a[0].length-1)
					s+='c';
				else
					s+=((a[i][j]==0)?'.':'*');
			}
			s+="\n";
		}
		return s;
	}
	public static boolean clickPossible(int a[][], int m)
	{
		int r = a.length;
		int c = a[0].length;
		int max = a.length*a[0].length;
		System.out.println("M= "+m+" max= "+max);
		if(m==max-1)
			return true;
		if(c==2)
		{
			if(m%2!=0)
				return false;
		}
		if(m>max-2)
			return false;
		if(a[r-1][c-1]==0)
		{
			if(r>1)
			{
				if(a[r-2][c-1]!=0)
				return false;
				if(c>2)
				{
					if(!isValidColumn(a))
					{
						int t = a[r-1][c-2];
						int t2 = a[r-1][c-1];
						int t3 = a[r-2][c-1];
						int t4 = a[r-2][c-2];
						a[r-1][c-2]=9;
						a[r-1][c-1]=9;
						a[r-2][c-1]=9;
						a[r-2][c-2]=9;
						if(!isValidColumn(a))
							return false;
						a[r-1][c-2]=t;
						a[r-1][c-1]=t2;
						a[r-2][c-1]=t3;
						a[r-2][c-2]=t4;
					}
				}
			}
			if(c>1)
			{
				if(a[r-1][c-2]!=0)
					return false;
					
			}
			if(r>1&&c>1)
			{
				if(a[r-2][c-2]!=0)
					return false;
			}
			return true;
		}
		else
			return false;
	}
}
