package aditsu.gcj.knight;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Knight {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}
	
	public static abstract class ADP2 {
		private final int[] val;
		private final int init;
		private final int n1;

		public ADP2(final int n1, final int n2, final int init) {
			val = new int[n1 * n2];
			this.init = init;
			this.n1 = n1;
			Arrays.fill(val, init);
		}
		
		public ADP2(final int n1, final int n2) {
			this(n1, n2, Integer.MIN_VALUE);
		}
		
		protected abstract int calc(int x1, int x2);

		public final int get(final int x1, final int x2) {
			final int i = x1 + n1 * x2;
			int r = val[i];
			if (r == init) {
				val[i] = r = calc(x1, x2);
			}
			return r;
		}
	}
	
	private void go() throws IOException {
		final BufferedReader br = getReader("D-small-attempt0.in");
		final PrintWriter wr = getWriter();
		
		final int n = toInt(br.readLine());
		for (int i = 0; i < n; ++i) {
			Scanner sc = new Scanner(br.readLine());
			final int h = sc.nextInt();
			final int w = sc.nextInt();
			final int r = sc.nextInt();
			final int[] x = new int[r];
			final int[] y = new int[r];
			for (int j = 0; j < r; ++j) {
				sc = new Scanner(br.readLine());
				y[j] = sc.nextInt() - 1;
				x[j] = sc.nextInt() - 1;
			}
			final ADP2 solver = new ADP2(w, h) {
				@Override
				protected int calc(int x1, int x2) {
					if (x1 == 0 && x2 == 0) {
						return 1;
					}
					for (int i = 0; i < r; ++i) {
						if (x1 == x[i] && x2 == y[i]) {
							return 0;
						}
					}
					int t = 0;
					if (x1 > 1 && x2 > 0) {
						t += get(x1 - 2, x2 - 1);
					}
					if (x2 > 1 && x1 > 0) {
						t += get(x1 - 1, x2 - 2);
					}
					return t % 10007;
				}
			};
			wr.println("Case #" + (i + 1) + ": " + solver.get(w - 1, h - 1));
		}
		wr.flush();
	}

	public static void main(final String... args) throws IOException {
		new Knight().go();
	}
}
