import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

public class Aerobics {
	public static class Pos {
		public int i;
		public long r;
		public double x = -1;
		public double y = -1;
		
		public Pos(final int i, final int r) {
			this.i = i;
			this.r = r;
		}
		
		public void swap() {
			double t = x;
			x = y;
			y = t;
		}
	}
	
	public static void fit(final List<Pos> l, final double x, final double y, final double w, final double h) {
		if (l.isEmpty()) {
			return;
		}
		if (w < h) {
			fit(l, y, x, h, w);
			for (Pos p : l) {
				p.swap();
			}
			return;
		}
		if (l.get(0).r * 6 > h) {
			int start = 0;
			double xx = x;
			while (start < l.size()) {
				Pos p = l.get(start);
				if (p.r * 6 < h) {
					break;
				}
				p.x = xx + p.r + 0.1;
				p.y = y + p.r + 0.1;
				xx += 2 * (p.r + 0.1);
				start++;
			}
			fit(l.subList(start, l.size()), xx, y, w + x - xx, h);
			return;
		}
		if (l.size() == 1) {
			Pos p = l.get(0);
			p.x = x + w / 2;
			p.y = y + h / 2;
			return;
		}
		long tot = 0;
		for (Pos p : l) {
			tot += p.r * p.r;
		}
		int k = 0;
		long s = 0;
		while (s * 2 < tot) {
			Pos p = l.get(k);
			s += p.r * p.r;
			k++;
		}
		double w1 = w * s / tot;
		for (int i = k; i < l.size(); ++i) {
			if (w1 + 2 * l.get(i).r > w - 0.1) {
				w1 = w - 0.1 - 2 * l.get(i).r;
			}
		}
		fit(l.subList(0, k), x, y, w1, h);
		fit(l.subList(k, l.size()), x + w1, y, w - w1, h);
	}
	
	public static void main(final String... args) throws IOException {
		final String fname = "B-small-attempt1";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		
		for (int i = 1; i <= t; ++i) {
			final int n = sc.nextInt();
			long w = sc.nextLong();
			long l = sc.nextLong();
			final List<Pos> r = new ArrayList<Pos>();
			for (int j = 0; j < n; ++j) {
				r.add(new Pos(j, sc.nextInt()));
			}
//			if (i < 8) {
//				continue;
//			}
			boolean reverse = l > w;
			if (reverse) {
				long x = w;
				w = l;
				l = x;
			}
			Collections.sort(r, new Comparator<Pos>() {
				@Override
				public int compare(Pos o1, Pos o2) {
					return (int) (o2.r - o1.r);
				}
			});
			int start = 0;
			int x = 0;
			while (start < n) {
				Pos p = r.get(start);
				if (p.r * 2 < l) {
					break;
				}
				p.x = x + p.r;
				p.y = 0;
				x += 2 * p.r;
				start++;
			}
			fit(r.subList(start, r.size()), x, 0, w - x, l);
			Collections.sort(r, new Comparator<Pos>() {
				@Override
				public int compare(Pos o1, Pos o2) {
					return o1.i - o2.i;
				}
			});
			if (reverse) {
				for (Pos p : r) {
					p.swap();
				}
			}
			pw.print("Case #" + i + ": ");
			for (Pos p : r) {
				pw.print(" " + p.x + " " + p.y);
			}
			pw.println();
		}
		pw.close();
	}
}
