import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Smooth {
	private int del;
	private int ins;
	private int m;
	private int n;
	private int[] a;
	
	public Smooth(int del, int ins, int m, int n, int[] a) {
		this.del = del;
		this.ins = ins;
		this.m = m;
		this.n = n;
		this.a = a;
	}

	public class ADP3 {
		private final int[] val;
		private final int init;
		private final int n1;
		private final int n2;

		public ADP3(final int n1, final int n2, final int n3, final int init) {
			val = new int[n1 * n2 * n3];
			this.init = init;
			this.n1 = n1;
			this.n2 = n2;
			Arrays.fill(val, init);
		}
		
		public ADP3(final int n1, final int n2, final int n3) {
			this(n1, n2, n3, Integer.MIN_VALUE);
		}
		
		protected int range(final int k, final int v1, final int v2) {
			return get(k, Math.max(v1, 0), Math.min(v2, 255));
		}
		
		protected int calc(final int k, final int v, final int v2) {
			if (v2 > v) {
				int x = Integer.MAX_VALUE;
				for (int i = v; i <= v2; ++i) {
					x = Math.min(x, get(k, i, i));
				}
				return x;
			}
			if (k == 0) {
				return 0;
			}
			int t = a[k - 1];
			int x = Integer.MAX_VALUE;
			int dif = Math.abs(t - v);
			int y = range(k - 1, v - m, v + m) + dif;
			if (y < x) {
				x = y;
			}
			y = get(k - 1, v, v) + del;
			if (y < x) {
				x = y;
			}
			if (m > 0)
			for (int i = -m; i <= m; ++i) {
				final int t1 = t + i;
				if (t1 >= 0 && t1 <= 255) {
					y = range(k - 1, t1 - m, t1 + m) + Math.abs(i) + (Math.abs(v - t1) + m - 1) / m * ins;
					if (y < x) {
						x = y;
					}
				}
				
			}
			return x;
		}

		public final int get(final int x1, final int x2, final int x3) {
			final int i = x1 + n1 * (x2 + n2 * x3);
			int r = val[i];
			if (r == init) {
				val[i] = r = calc(x1, x2, x3);
			}
			return r;
		}
	}
	
	public int calc() {
		return new ADP3(n + 1, 256, 256).range(n, 0, 255);
	}

	public static void main(final String... args) throws IOException {
		final String fname = "B-large";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		for (int i = 0; i < t; ++i) {
			final long tm = System.currentTimeMillis();
			final int del = sc.nextInt();
			final int ins = sc.nextInt();
			final int m = sc.nextInt();
			final int n = sc.nextInt();
			final int[] a = new int[n];
			for (int j = 0; j < n; ++j) {
				a[j] = sc.nextInt();
			}
			final int r = new Smooth(del, ins, m, n, a).calc();
			pw.println("Case #" + (i + 1) + ": " + r);
			System.out.println(i + " " + (System.currentTimeMillis() - tm));
		}
		pw.close();
	}
}
