import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Smooth {
	private int del;
	private int ins;
	private int m;
	private int n;
	private int[] a;
	
	public Smooth(int del, int ins, int m, int n, int[] a) {
		this.del = del;
		this.ins = ins;
		this.m = m;
		this.n = n;
		this.a = a;
	}

	public class ADP2 {
		private final int[] val;
		private final int init;
		private final int n1;

		public ADP2(final int n1, final int n2, final int init) {
			val = new int[n1 * n2];
			this.init = init;
			this.n1 = n1;
			Arrays.fill(val, init);
		}
		
		public ADP2(final int n1, final int n2) {
			this(n1, n2, Integer.MIN_VALUE);
		}
		
		protected int range(final int k, final int v1, final int v2) {
			int m = Integer.MAX_VALUE;
			for (int v = Math.max(v1, 0); v <= Math.min(v2, 255); ++v) {
				final int t = get(k, v);
				if (t < m) {
					m = t;
				}
			}
			return m;
		}
		
		protected int calc(final int k, final int v) {
			if (k == 0) {
				return 0;
			}
			int t = a[k - 1];
			int x = Integer.MAX_VALUE;
			int dif = Math.abs(t - v);
			int y = range(k - 1, v - m, v + m) + dif;
			if (y < x) {
				x = y;
			}
			y = get(k - 1, v) + del;
			if (y < x) {
				x = y;
			}
			if (m > 0)
			for (int i = -m; i <= m; ++i) {
				final int t1 = t + i;
				if (t1 >= 0 && t1 <= 255) {
					y = range(k - 1, t1 - m, t1 + m) + Math.abs(i) + (Math.abs(v - t1) + m - 1) / m * ins;
					if (y < x) {
						x = y;
					}
				}
				
			}
			return x;
		}

		public final int get(final int x1, final int x2) {
			final int i = x1 + n1 * x2;
			int r = val[i];
			if (r == init) {
				val[i] = r = calc(x1, x2);
			}
			return r;
		}
	}
	
	public int calc() {
		return new ADP2(n + 1, 256).range(n, 0, 255);
	}

	public static void main(final String... args) throws IOException {
		final String fname = "B-small-attempt0";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		for (int i = 0; i < t; ++i) {
			final int del = sc.nextInt();
			final int ins = sc.nextInt();
			final int m = sc.nextInt();
			final int n = sc.nextInt();
			final int[] a = new int[n];
			for (int j = 0; j < n; ++j) {
				a[j] = sc.nextInt();
			}
			final int r = new Smooth(del, ins, m, n, a).calc();
			pw.println("Case #" + (i + 1) + ": " + r);
		}
		pw.close();
	}
}
