import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class C_fair_and_square_big {
	private static void combi(final int n, final int s, final int i, final int k, final char[] c, final List<String> col) {
		if (i == k) {
			col.add(new String(c));
			return;
		}
		for (int j = s; j <= n - k + i; ++j) {
			c[j] = '1';
			combi(n, j + 1, i + 1, k, c, col);
			c[j] = '0';
		}
	}
	
	public static List<String> combi(final int n, final int k) {
		final List<String> col = new ArrayList<String>();
		final char[] c = new char[n];
		Arrays.fill(c, '0');
		combi(n, 0, 0, k, c, col);
		return col;
	}
	
	public static String rev(final String s) {
		final int l = s.length();
		final char[] a = new char[l];
		for (int i = 0; i < l; ++i) {
			a[i] = s.charAt(l - 1 - i);
		}
		return new String(a);
	}
	
	public static List<String> odd(final int n) {
		if (n == 1) {
			return Arrays.asList("1", "2", "3");
		}
		final List<String> col = new ArrayList<String>();
		final int n2 = n / 2 - 1;
		for (int i = 0; i < 4; ++i) {
			for (String s : combi(n2, i)) {
				col.add('1' + s + '0' + rev(s) + '1');
				col.add('1' + s + '1' + rev(s) + '1');
				if (i < 2) {
					col.add('1' + s + '2' + rev(s) + '1');
				}
				if (i == 0) {
					col.add('2' + s + '0' + rev(s) + '2');
					col.add('2' + s + '1' + rev(s) + '2');
				}
			}
		}
		return col;
	}
	
	public static List<String> even(final int n) {
		final List<String> col = new ArrayList<String>();
		final int n2 = n / 2 - 1;
		for (int i = 0; i < 4; ++i) {
			for (String s : combi(n2, i)) {
				col.add('1' + s + rev(s) + '1');
				if (i == 0) {
					col.add('2' + s + rev(s) + '2');
				}
			}
		}
		return col;
	}
	
	public static List<String> get(final int n) {
		return n % 2 == 0 ? even(n) : odd(n);
	}
	
	public static void main(final String... args) throws IOException {
		final String fname = "C-large-2";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		
		for (int i = 1; i <= t; ++i) {
			final BigInteger a = sc.nextBigInteger();
			final BigInteger b = sc.nextBigInteger();
			int n = 0;
			for (int j = 1; ; ++j) {
				final List<String> l = get(j);
				Collections.sort(l);
				boolean ok = true;
				for (String s : l) {
					BigInteger x = new BigInteger(s);
					x = x.multiply(x);
					if (x.compareTo(b) > 0) {
						ok = false;
						break;
					}
					if (x.compareTo(a) >= 0) {
						n++;
					}
				}
				if (!ok) {
					break;
				}
			}
			pw.println("Case #" + i + ": " + n);
		}
		pw.close();
	}
}
