package aditsu.gcj.flyswatter;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class FlySwatter {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}

	private static boolean inside(final double x, final double y, final double r2) {
		return x * x + y * y <= r2;
	}

	private static double chordArea(final double R, final double r) {
		return R * R * Math.acos(r / R) - r * Math.sqrt(R * R - r * r);
	}

	private void go() throws IOException {
		final BufferedReader br = getReader("C-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int n = toInt(br.readLine());
		for (int i = 0; i < n; ++i) {
			final Scanner sc = new Scanner(br.readLine());
			double f = sc.nextDouble();
			double R = sc.nextDouble();
			double t = sc.nextDouble();
			double r = sc.nextDouble();
			double g = sc.nextDouble();
			g -= 2 * f;
			double p;
			
			if (g <= 0) {
				p = 1;
			} else {
				r += f;
				double r1 = R - t - f;
				double r2 = r1 * r1;
				double area = Math.PI * R * R;
				double dist = g + 2 * r;
				double x = r;
				double miss = 0;
				while (x < r1) {
					double y = r;
					while (y <= x) {
						double a;
						if (!inside(x, y, r2)) {
							break;
						}
						double xg = x + g;
						double yg = y + g;
						if (inside(xg, yg, r2)) {
							a = g * g;
						} else if (inside(xg, y, r2)) {
							double x1 = Math.sqrt(r2 - yg * yg);
							double y1 = Math.sqrt(r2 - xg * xg);
							double x2 = (xg + x1) / 2;
							double y2 = (yg + y1) / 2;
							double rr = Math.sqrt(x2 * x2 + y2 * y2);
							double chord = chordArea(r1, rr);
							double tri = (xg - x1) * (yg - y1) / 2;
							a = g * g - tri + chord;
						} else if (inside(x, yg, r2)) {
							double x1 = Math.sqrt(r2 - y * y);
							double x2 = Math.sqrt(r2 - yg * yg);
							double x3 = (x1 + x2) / 2;
							double y3 = y + g / 2;
							double rr = Math.sqrt(x3 * x3 + y3 * y3);
							double chord = chordArea(r1, rr);
							double rect = (x2 - x) * g;
							double tri = (x1 - x2) * g / 2;
							a = rect + tri + chord;
						} else {
							double x1 = Math.sqrt(r2 - y * y);
							double y1 = Math.sqrt(r2 - x * x);
							double x2 = (x + x1) / 2;
							double y2 = (y + y1) / 2;
							double rr = Math.sqrt(x2 * x2 + y2 * y2);
							double chord = chordArea(r1, rr);
							double tri = (x1 - x) * (y1 - y) / 2;
							a = tri + chord;
						}
						
						if (x != y) {
							a *= 2;
						}
						miss += a;
						y += dist;
					}
					x += dist;
				}
				p = 1 - miss * 4 / area;
			}
			w.println("Case #" + (i + 1) + ": " + String.format("%.8f", p));
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new FlySwatter().go();
	}
}
