package aditsu.gcj.traintimetable;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class TrainTimetable {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}

	private static int parseTime(final String s) {
		final String[] a = s.split(":");
		return toInt(a[0]) * 60 + toInt(a[1]);
	}

	private static class Info {
		public int a;
		public int b;
	}

	private void go() throws IOException {
		final BufferedReader r = getReader("B-large.in");
		final PrintWriter w = getWriter();
		
		final int n = toInt(r.readLine());
		for (int i = 0; i < n; ++i) {
			final int t = toInt(r.readLine());
			final Scanner sc = new Scanner(r.readLine());
			final int na = sc.nextInt();
			final int nb = sc.nextInt();
			final Map<Integer, Info> map = new TreeMap<Integer, Info>();
			for (int j = 0; j < na; ++j) {
				final String[] a = r.readLine().split(" ");
				final int t0 = parseTime(a[0]);
				final int t1 = parseTime(a[1]);
				Info info = map.get(t0);
				if (info == null) {
					info = new Info();
					map.put(t0, info);
				}
				info.a++;
				info = map.get(t1 + t);
				if (info == null) {
					info = new Info();
					map.put(t1 + t, info);
				}
				info.b--;
			}
			for (int j = 0; j < nb; ++j) {
				final String[] a = r.readLine().split(" ");
				final int t0 = parseTime(a[0]);
				final int t1 = parseTime(a[1]);
				Info info = map.get(t0);
				if (info == null) {
					info = new Info();
					map.put(t0, info);
				}
				info.b++;
				info = map.get(t1 + t);
				if (info == null) {
					info = new Info();
					map.put(t1 + t, info);
				}
				info.a--;
			}
			int ta = 0;
			int tb = 0;
			int ma = 0;
			int mb = 0;
			for (Info info : map.values()) {
				ta += info.a;
				tb += info.b;
				if (ta > ma) {
					ma = ta;
				}
				if (tb > mb) {
					mb = tb;
				}
			}
			w.println("Case #" + (i + 1) + ": " + ma + " " + mb);
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new TrainTimetable().go();
	}
}
