package aditsu.gcj.booleantree;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class BooleanTree {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}

	static class Node {
		public int value;
		public int gate;
		public boolean chg;
		public boolean fixed;
		public int nc;
		
		public Node(int value, int gate, boolean chg) {
			this.value = value;
			this.gate = gate;
			this.chg = chg;
		}
		
		public int calc(int x, int y) {
			return gate == 1 ? (x & y) : (x | y);
		}
		
		public int calc2(int x, int y) {
			return gate == 1 ? (x | y) : (x & y);
		}
	}

	private void go() throws IOException {
		final BufferedReader br = getReader("A-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int n = toInt(br.readLine());
		for (int i = 0; i < n; ++i) {
			Scanner sc = new Scanner(br.readLine());
			final int m = sc.nextInt();
			final int v = sc.nextInt();
			final Node[] nodes = new Node[m];
			int j = 0;
			for (; j < (m - 1) / 2; ++j) {
				sc = new Scanner(br.readLine());
				final int g = sc.nextInt();
				final int c = sc.nextInt();
				nodes[j] = new Node(-1, g, c == 1);
			}
			for (; j < m; ++j) {
				nodes[j] = new Node(toInt(br.readLine()), -1, false);
				nodes[j].fixed = true;
			}
			for (j = m - 1; j >= 0; --j) {
				if (nodes[j].gate >= 0) {
					final Node nj = nodes[j];
					final int j1 = 2 * j + 1;
					final int x = nodes[j1].value;
					final int j2 = 2 * j + 2;
					final int y = nodes[j2].value;
					nj.value = nj.calc(x, y);
					nj.fixed = true;
					nj.nc = 1000000;
					for (int i1 = 0; i1 < (nodes[j1].fixed ? 1 : 2); ++i1) {
						for (int i2 = 0; i2 < (nodes[j2].fixed ? 1 : 2); ++i2) {
							if (nj.calc(x ^ i1, y ^ i2) != nj.value) {
								nj.fixed = false;
								int t = 0;
								if (i1 == 1) {
									t += nodes[j1].nc;
								}
								if (i2 == 1) {
									t += nodes[j2].nc;
								}
								if (t < nj.nc) {
									nj.nc = t;
								}
							}
							if (nj.chg) {
								if (nj.calc2(x ^ i1, y ^ i2) != nj.value) {
									nj.fixed = false;
									int t = 1;
									if (i1 == 1) {
										t += nodes[j1].nc;
									}
									if (i2 == 1) {
										t += nodes[j2].nc;
									}
									if (t < nj.nc) {
										nj.nc = t;
									}
								}
							}
						}
					}
				}
			}
			int r = -1;
			if (nodes[0].value == v) {
				r = 0;
			} else if (!nodes[0].fixed) {
				r = nodes[0].nc;
			}
			w.println("Case #" + (i + 1) + ": " + (r < 0 ? "IMPOSSIBLE" : r));
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new BooleanTree().go();
	}
}
