import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Objects;
import java.util.Scanner;

public class B_ParentingPartnering {
	private static class Point implements Comparable<Point> {
		int time;
		int parent;
		int stop;
		
		public Point(int time, int parent, int stop) {
			this.time = time;
			this.parent = parent;
			this.stop = stop;
		}

		@Override
		public int compareTo(Point o) {
			return time == o.time ? o.stop - stop : time - o.time;
		}
	}
	
	public void solve(final Scanner sc, final PrintWriter pw) {
		final int na = sc.nextInt();
		final int nb = sc.nextInt();
		
		final List<Point> l = new ArrayList<>();
		for (int i = 0; i < na; ++i) {
			l.add(new Point(sc.nextInt(), 0, 0));
			l.add(new Point(sc.nextInt(), 0, 1));
		}
		for (int i = 0; i < nb; ++i) {
			l.add(new Point(sc.nextInt(), 1, 0));
			l.add(new Point(sc.nextInt(), 1, 1));
		}
		Collections.sort(l);
		final Point p0 = l.get(0);
		l.add(new Point(p0.time + 1440, p0.parent, p0.stop));
		final List<Integer> gapA = new ArrayList<>();
		final List<Integer> gapB = new ArrayList<>();
		int spare = 0;
		int[] t = new int[2];
		int r = 0;
		for (int i = 0; i < l.size() - 1; ++i) {
			final Point p = l.get(i);
			final Point p1 = l.get(i + 1);
			final int dif = p1.time - p.time;
			if (p.parent == p1.parent) {
				t[p.parent] += dif;
				if (p.stop == 1) {
					(p.parent == 0 ? gapA : gapB).add(dif);
				}
			}
			else {
				r++;
				spare += dif;
			}
		}
		Collections.sort(gapA);
		Collections.sort(gapB);
		while (t[0] + spare < 720) {
			t[0] += gapB.remove(gapB.size() - 1);
			r += 2;
		}
		while (t[1] + spare < 720) {
			t[1] += gapA.remove(gapA.size() - 1);
			r += 2;
		}
		
		pw.println(r);
	}
	
	@SuppressWarnings("resource")
	public static void main(final String... args) throws IOException {
		final String fname = "B-large";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		sc.nextLine();
		
		for (int i = 1; i <= t; ++i) {
			System.out.println(i);
			pw.print("Case #" + i + ": ");
			new B_ParentingPartnering().solve(sc, pw);
		}
		pw.close();
		
		final File f = new File(fname + ".out.good");
		if (!f.exists()) {
			return;
		}
		System.out.println("Comparing");
		final BufferedReader r1 = new BufferedReader(new FileReader(fname + ".out"));
		final BufferedReader r2 = new BufferedReader(new FileReader(f));
		int n = 0;
		while (true) {
			n++;
			final String s1 = r1.readLine();
			final String s2 = r2.readLine();
			if (!Objects.equals(s1, s2)) {
				System.out.println("Line " + n);
				System.out.println("Expected: " + s2);
				System.out.println("Got:      " + s1);
				break;
			}
			if (s1 == null) {
				System.out.println("OK");
				break;
			}
		}
		r1.close();
		r2.close();
	}
}
