package aditsu.gcj.portal;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class Portal {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}
	
	private static class Pos {
		// x y p1x p1y d1 p2x p2y d2
		public int[] data;
		
		public Pos() {
			data = new int[8];
		}
		
		public Pos(final Pos p) {
			data = Arrays.copyOf(p.data, 8);
		}

		@Override
		public boolean equals(Object obj) {
			return Arrays.equals(data, ((Pos) obj).data);
		}

		@Override
		public int hashCode() {
			return Arrays.hashCode(data);
		}
	}

	private void go() throws IOException {
		final BufferedReader br = getReader("B-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int n = toInt(br.readLine());
		for (int i = 0; i < n; ++i) {
			System.out.println(i);
			final Scanner sc = new Scanner(br.readLine());
			final int r = sc.nextInt();
			final int c = sc.nextInt();
			final char[][] map = new char[r + 2][c + 2];
			for (int i1 = 0; i1 < r + 2; ++i1) {
				for (int i2 = 0; i2 < c + 2; ++i2) {
					map[i1][i2] = '#';
				}
			}
			int ox = 0;
			int oy = 0;
			int xx = 0;
			int xy = 0;
			for (int i1 = 0; i1 < r; ++i1) {
				final String s = br.readLine();
				for (int i2 = 0; i2 < c; ++i2) {
					char ch = s.charAt(i2);
					if (ch == 'O') {
						oy = i1 + 1;
						ox = i2 + 1;
						ch = '.';
					} else if (ch == 'X') {
						xy = i1 + 1;
						xx = i2 + 1;
						ch = '.';
					}
					map[i1 + 1][i2 + 1] = ch;
				}
			}
			final int cakex = xx;
			final int cakey = xy;
			final int[][][] wall = new int[r + 2][c + 2][4]; // U R D L
			for (int i1 = 0; i1 < r + 2; ++i1) {
				for (int i2 = 0; i2 < c + 2; ++i2) {
					if (map[i1][i2] == '.') {
						for (int t = i1;; --t) {
							if (map[t][i2] == '#') {
								wall[i1][i2][0] = t;
								break;
							}
						}
						for (int t = i2;; ++t) {
							if (map[i1][t] == '#') {
								wall[i1][i2][1] = t;
								break;
							}
						}
						for (int t = i1;; ++t) {
							if (map[t][i2] == '#') {
								wall[i1][i2][2] = t;
								break;
							}
						}
						for (int t = i2;; --t) {
							if (map[i1][t] == '#') {
								wall[i1][i2][3] = t;
								break;
							}
						}
					}
				}
			}
			final AStar<Pos> solver = new AStar<Pos>() {
				@Override
				protected boolean solved(final Pos node) {
					return node.data[0] == cakex && node.data[1] == cakey;
				}

				
				@Override
				protected int heuristic(Pos node) {
					return 0;
				}


				@Override
				protected List<Pos> expandNode(final Pos node) {
					final List<Pos> l = new ArrayList<Pos>();
					final int x = node.data[0];
					final int y = node.data[1];
					if (map[y][x - 1] == '.') {
						final Pos p = new Pos(node);
						p.data[0]--;
						l.add(p);
					}
					if (map[y][x + 1] == '.') {
						final Pos p = new Pos(node);
						p.data[0]++;
						l.add(p);
					}
					if (map[y - 1][x] == '.') {
						final Pos p = new Pos(node);
						p.data[1]--;
						l.add(p);
					}
					if (map[y + 1][x] == '.') {
						final Pos p = new Pos(node);
						p.data[1]++;
						l.add(p);
					}
					int y1 = wall[y][x][0] + 1;
					if ((x != node.data[5] || y1 != node.data[6] || 0 != node.data[7])
							&& (x != node.data[2] || y1 != node.data[3] || 0 != node.data[4])) {
						Pos p = new Pos(node);
						p.data[2] = x;
						p.data[3] = y1;
						p.data[4] = 10;
						l.add(p);
						p = new Pos(node);
						p.data[5] = x;
						p.data[6] = y1;
						p.data[7] = 0;
						l.add(p);
					}
					y1 = wall[y][x][2] - 1;
					if ((x != node.data[5] || y1 != node.data[6] || 2 != node.data[7])
							&& (x != node.data[2] || y1 != node.data[3] || 2 != node.data[4])) {
						Pos p = new Pos(node);
						p.data[2] = x;
						p.data[3] = y1;
						p.data[4] = 2;
						l.add(p);
						p = new Pos(node);
						p.data[5] = x;
						p.data[6] = y1;
						p.data[7] = 2;
						l.add(p);
					}
					int x1 = wall[y][x][1] - 1;
					if ((x1 != node.data[5] || y != node.data[6] || 1 != node.data[7])
							&& (x1 != node.data[2] || y != node.data[3] || 1 != node.data[4])) {
						Pos p = new Pos(node);
						p.data[2] = x1;
						p.data[3] = y;
						p.data[4] = 1;
						l.add(p);
						p = new Pos(node);
						p.data[5] = x1;
						p.data[6] = y;
						p.data[7] = 1;
						l.add(p);
					}
					x1 = wall[y][x][3] + 1;
					if ((x1 != node.data[5] || y != node.data[6] || 3 != node.data[7])
							&& (x1 != node.data[2] || y != node.data[3] || 3 != node.data[4])) {
						Pos p = new Pos(node);
						p.data[2] = x1;
						p.data[3] = y;
						p.data[4] = 3;
						l.add(p);
						p = new Pos(node);
						p.data[5] = x1;
						p.data[6] = y;
						p.data[7] = 3;
						l.add(p);
					}
					if (node.data[4] >= 0 && node.data[7] >= 0) {
						if (x == node.data[2] && y == node.data[3]) {
							Pos p = new Pos(node);
							p.data[0] = p.data[5];
							p.data[1] = p.data[6];
							l.add(p);
						}
						if (x == node.data[5] && y == node.data[6]) {
							Pos p = new Pos(node);
							p.data[0] = p.data[2];
							p.data[1] = p.data[3];
							l.add(p);
						}
					}
					return l;
				}

				@Override
				protected AStarInfo<Pos> makeInfo(AStarInfo<Pos> parent, Pos node) {
					int dist = 0;
					if (parent != null) {
						dist = parent.dist;
						if (node.data[0] != parent.node.data[0] || node.data[1] != parent.node.data[1]) {
							dist++;
						}
					}
					return new AStarInfo<Pos>(node, dist, heuristic(node), parent);
				}
			};
			final Pos p0 = new Pos();
			p0.data[0] = ox;
			p0.data[1] = oy;
			p0.data[4] = -1;
			p0.data[7] = -1;
			final AStarInfo<Pos> result = solver.run(p0);
			w.println("Case #" + (i + 1) + ": " + (result == null ? "THE CAKE IS A LIE" : result.dist));
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new Portal().go();
	}
}
