package aditsu.gcj.portal;

public class AStarInfo<T> implements Comparable<AStarInfo<T>> {
	public final T node;
	public final int dist;
	public final int cost;
	public final AStarInfo<T> parent;

	public AStarInfo(final T node, final int dist, final int cost, final AStarInfo<T> parent) {
		this.node = node;
		this.dist = dist;
		this.cost = cost;
		this.parent = parent;
	}

	public int total() {
		return dist + cost;
	}

	public int compareTo(final AStarInfo<T> o) {
		return total() - o.total();
	}

	@Override
	public String toString() {
		return dist + " + " + cost + " = " + total() + "\n" + node;
	}
}
