package aditsu.gcj.triangleareas;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TriangleAreas {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}
	
	private void go() throws IOException {
		final BufferedReader br = getReader("B-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int c = toInt(br.readLine());
		for (int i = 0; i < c; ++i) {
			final Scanner sc = new Scanner(br.readLine());
			final int n = sc.nextInt();
			final int m = sc.nextInt();
			final int a = sc.nextInt();
			if (a > m * n) {
				w.println("Case #" + (i + 1) + ": IMPOSSIBLE");
				continue;
			}
			boolean ok = false;
			for (int b1 = n; b1 > 0; --b1) {
				final int c2 = (a + b1 - 1) / b1;
				final int p = b1 * c2 - a;
				if (p <= m) {
					w.println("Case #" + (i + 1) + ": 0 0 " + b1 + " " + p + " 1 " + c2);
					ok = true;
					break;
				}
			}
			if (!ok) {
				System.out.println("oops!");
			}
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new TriangleAreas().go();
	}
}
