package aditsu.gcj.croptriangles;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class CropTriangles {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}
	
	private void go() throws IOException {
		final BufferedReader br = getReader("A-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int N = toInt(br.readLine());
		for (int i = 0; i < N; ++i) {
			final Scanner sc = new Scanner(br.readLine());
			final int n = sc.nextInt();
			final long a = sc.nextLong();
			final long b = sc.nextLong();
			final long c = sc.nextLong();
			final long d = sc.nextLong();
			final long x0 = sc.nextLong();
			final long y0 = sc.nextLong();
			final long m = sc.nextLong();
			final long[] xx = new long[n];
			final long[] yy = new long[n];
			long x = x0;
			long y = y0;
			for (int j = 0; j < n; ++j) {
				xx[j] = x;
				yy[j] = y;
				x = (a * x + b) % m;
				y = (c * y + d) % m;
			}
			int r = 0;
			for (int i1 = 0; i1 < n; ++i1) {
				for (int i2 = i1 + 1; i2 < n; ++i2) {
					for (int i3 = i2 + 1; i3 < n; ++i3) {
						if ((xx[i1] + xx[i2] + xx[i3]) % 3 == 0
								&& (yy[i1] + yy[i2] + yy[i3]) % 3 == 0) {
							r++;
						}
					}
				}
			}
			
			w.println("Case #" + (i + 1) + ": " + r);
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new CropTriangles().go();
	}
}
