import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class B_1_pool {
	private static boolean eq(final double x, final double y) {
		return Math.abs(x - y) < 1e-9;
	}
	
	private static boolean lt(final double x, final double y) {
		return x - y < -1e-9;
	}
	
	public void solve(final Scanner sc, final PrintWriter pw) {
		Double r = solve(sc);
		if (r == null) {
			pw.println("IMPOSSIBLE");
		}
		else {
			pw.println(r);
		}
	}
	
	private static Double solve(final Scanner sc) {
		final int n = sc.nextInt();
		final double v = sc.nextDouble();
		final double x = sc.nextDouble();
		final double[] r = new double[n];
		final double[] c = new double[n];
		for (int j = 0; j < n; ++j) {
			r[j] = sc.nextDouble();
			c[j] = sc.nextDouble();
		}
		if (n > 2) {
			return null;
		}
		if (n == 1) {
			if (eq(c[0], x)) {
				return v / r[0];
			}
			return null;
		}
		if (eq(c[0], c[1])) {
			if (eq(c[0], x)) {
				return v / (r[0] + r[1]);
			}
			return null;
		}
		if (eq(c[0], x)) {
			return v / r[0];
		}
		if (eq(c[1], x)) {
			return v / r[1];
		}
		double v0 = v*(x-c[1])/(c[0]-c[1]);
		double v1 = v - v0;
		if (lt(v0, 0) || lt(v1, 0)) {
			return null;
		}
		return Math.max(v0 / r[0], v1 / r[1]);
	}
	
	public static void main(final String... args) throws IOException {
		final String fname = "B-small-attempt3";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		
		for (int i = 1; i <= t; ++i) {
			System.out.println(i);
			pw.print("Case #" + i + ": ");
			new B_1_pool().solve(sc, pw);
		}
		pw.close();
	}
}
