import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class C_1_bilingual {
	private void add(int[] a, int[] b) {
		for (int i = 0; i < a.length; ++i) {
			a[i] |= b[i];
		}
	}
	
	public void solve(final Scanner sc, final PrintWriter pw) {
		final int n = sc.nextInt();
		sc.nextLine();
		final List<String> all = new ArrayList<String>();
		final List<List<Integer>> s = new ArrayList<List<Integer>>();
		for (int j = 0; j < n; ++j) {
			final String[] a = sc.nextLine().split(" ");
			final List<Integer> l = new ArrayList<Integer>();
			for (String t : a) {
				int x = all.indexOf(t);
				if (x < 0) {
					x = all.size();
					all.add(t);
				}
				l.add(x);
			}
			s.add(l);
		}
		int m = all.size();
		List<int[]> s1 = new ArrayList<int[]>();
		for (int i = 0; i < n; ++i) {
			int[] a = new int[m];
			for (int x : s.get(i)) {
				a[x] = 1;
			}
			s1.add(a);
		}
		final int[] eng = Arrays.copyOf(s1.get(0), m);
		final int[] fr = Arrays.copyOf(s1.get(1), m);
		int best = 1000000;
		for (int i = 0; i < 1 << (n - 2); ++i) {
			final int[] eng1 = Arrays.copyOf(eng, m);
			final int[] fr1 = Arrays.copyOf(fr, m);
			for (int j = 0; j < n - 2; ++j) {
				if ((i & (1 << j)) == 0) {
					add(eng1, s1.get(j + 2));
				}
				else {
					add(fr1, s1.get(j + 2));
				}
			}
			int k = 0;
			for (int j = 0; j < m; ++j) {
				if (eng1[j] + fr1[j] == 2) {
					k++;
				}
			}
			best = Math.min(best, k);
		}
		pw.println(best);
	}
	
	public static void main(final String... args) throws IOException {
		final String fname = "C-small-attempt1";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		
		for (int i = 1; i <= t; ++i) {
			System.out.println(i);
			pw.print("Case #" + i + ": ");
			new C_1_bilingual().solve(sc, pw);
		}
		pw.close();
	}
}
