import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Rotate {
	
	private static char[] fall(final String s, final int n) {
		final char[] a = new char[n];
		int t = 0;
		for (int i = 0; i < n; ++i) {
			final char c = s.charAt(n - 1 - i);
			if (c == '.') {
				continue;
			}
			a[t++] = c;
		}
		return a;
	}
	
	private static boolean out(final int x, final int n) {
		return x < 0 || x >= n;
	}
	
	private static boolean test(final char[][] m, final int x, final int y, final int n, final int k, final int dx, final int dy) {
		final char c = m[x][y];
		int x1 = x;
		int y1 = y;
		for (int i = 1; i < k; ++i) {
			x1 += dx;
			y1 += dy;
			if (out(x1, n) || out(y1, n)) {
				return false;
			}
			if (m[x1][y1] != c) {
				return false;
			}
		}
		return true;
	}
	
	private static boolean test(final char[][] m, final int x, final int y, final int n, final int k) {
		if (m[x][y] == 0) {
			return false;
		}
		return test(m, x, y, n, k, 1, 0) || test(m, x, y, n, k, 0, 1) ||
				test(m, x, y, n, k, 1, 1) || test(m, x, y, n, k, 1, -1);
	}
	
	public static void main(final String... args) throws IOException {
		final String fname = "A-small-attempt0";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		for (int i = 0; i < t; ++i) {
			final int n = sc.nextInt();
			final int k = sc.nextInt();
			sc.nextLine();
			final char[][] m = new char[n][n];
			for (int j = 0; j < n; ++j) {
				m[j] = fall(sc.nextLine(), n);
//				System.out.println(Arrays.toString(m[j]));
			}
			boolean b = false;
			boolean r = false;
			for (int x = 0; x < n; ++x) {
				for (int y = 0; y < n; ++y) {
					if (b && r) {
						break;
					}
					if (test(m, x, y, n, k)) {
						if (m[x][y] == 'B') {
							b = true;
						} else {
							r = true;
						}
					}
				}
			}
			final String res = b ? (r ? "Both" : "Blue") : (r ? "Red" : "Neither");
			pw.println("Case #" + (i + 1) + ": " + res);
		}
		pw.close();
	}
}
