package aditsu.gcj.savinguniverse;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;

public class SavingUniverse {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private void go() throws IOException {
		final BufferedReader r = getReader("A-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int n = Integer.parseInt(r.readLine());
		for (int i = 0; i < n; ++i) {
			final int s = Integer.parseInt(r.readLine());
			final Map<String, Integer> eng = new HashMap<String, Integer>(s);
			for (int j = 0; j < s; ++j) {
				eng.put(r.readLine(), j);
			}
			final int q = Integer.parseInt(r.readLine());
			final int[] queries = new int[q];
			for (int j = 0; j < q; ++j) {
				queries[j] = eng.get(r.readLine());
			}
			
			final ADP2 solver = new ADP2(q + 1, s) {
				@Override
				protected int calc(int qx, int ex) {
					if (qx == 0) {
						return 0;
					}
					if (ex == queries[qx - 1]) {
						return -1;
					}
					int m = Integer.MAX_VALUE;
					for (int i = 0; i < s; ++i) {
						int t = get(qx - 1, i);
						if (t >= 0) {
							t += (i == ex ? 0 : 1);
							if (t < m) {
								m = t;
							}
						}
					}
					return m;
				}
			};
			
			int m = Integer.MAX_VALUE;
			for (int j = 0; j < s; ++j) {
				int t = solver.get(q, j);
				if (t >= 0 && t < m) {
					m = t;
				}
			}
			w.println("Case #" + (i + 1) + ": " + m);
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new SavingUniverse().go();
	}
}
