import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;
import java.util.concurrent.Executor;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class B_UpAndDown_Bfs {
	private static boolean solved(final List<Integer> l) {
		boolean up = true;
		for (int i = 0; i < l.size() - 1; ++i) {
			if (up) {
				if (l.get(i) > l.get(i + 1)) {
					up = false;
				}
			}
			else {
				if (l.get(i) < l.get(i + 1)) {
					return false;
				}
			}
		}
		return true;
	}
	
	private static List<Integer> swap(final List<Integer> l, final int k) {
		final List<Integer> l1 = new ArrayList<Integer>(l);
		int t = l1.get(k);
		l1.set(k, l1.get(k + 1));
		l1.set(k + 1, t);
		return l1;
	}
	
	public static int solve(final List<Integer> l) {
		Set<List<Integer>> set = new HashSet<List<Integer>>();
		Set<List<Integer>> set2 = new HashSet<List<Integer>>();
		set.add(l);
		for (int i = 0;; ++i) {
			for (List<Integer> x : set) {
				if (solved(x)) {
					return i;
				}
				for (int j = 0; j < l.size() - 1; ++j) {
					set2.add(swap(x, j));
				}
			}
			set = set2;
			set2 = new HashSet<List<Integer>>();
		}
	}
	
	public static void main(final String... args) throws IOException {
		final String fname = "B-small-attempt4";
		final Scanner sc = new Scanner(new File(fname + ".in"));
		final PrintWriter pw = new PrintWriter(fname + ".out");
		final int t = sc.nextInt();
		
		final int[] res = new int[t];
		
		final ExecutorService ex = Executors.newFixedThreadPool(3);
		
		for (int i = 1; i <= t; ++i) {
			int n = sc.nextInt();
			final List<Integer> l = new ArrayList<Integer>();
			for (int j = 0; j < n; ++j) {
				l.add(sc.nextInt());
			}
			final int j = i;
			ex.execute(new Runnable() {
				@Override
				public void run() {
					res[j - 1] = solve(l);
					System.out.println(j);
				}
			});
		}
		ex.shutdown();
		for (int i = 1; i <= t; ++i) {
			pw.println("Case #" + i + ": " + res[i - 1]);
		}
		pw.close();
	}
}
