package aditsu.gcj.numbersets;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class NumberSets {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}
	
	private void go() throws IOException {
		final BufferedReader br = getReader("B-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int c = toInt(br.readLine());
		for (int i = 0; i < c; ++i) {
			final Scanner sc = new Scanner(br.readLine());
			final int a = sc.nextInt();
			final int b = sc.nextInt();
			final int p = sc.nextInt();
			final Map<Integer, Integer> m = new HashMap<Integer, Integer>();
			for (int j = a; j <= b; ++j) {
				m.put(j, j);
			}
			int sets = m.size();
			final Set<Integer> s = new HashSet<Integer>();
			for (int i1 = a; i1 <= b; ++i1) {
				s.clear();
				int t = i1;
				for (int j = 2; j <= t; ++j) {
					while (t % j == 0) {
						t /= j;
						if (j >= p) {
							s.add(j);
						}
					}
				}
//				System.out.println(i1 + ": " + s);
				if (!s.isEmpty()) {
					int m1 = i1;
					while (m.get(m1) != m1) {
						m1 = m.get(m1);
					}
					for (int i2 = i1 + 1; i2 <= b; ++i2) {
						for (int f : s) {
							if (i2 % f == 0) {
								int m2 = i2;
								while (m.get(m2) != m2) {
									m2 = m.get(m2);
								}
								if (m1 != m2) {
									sets--;
									m.put(m2, m1);
									break;
								}
							}
						}
					}
				}
			}
			
			w.println("Case #" + (i + 1) + ": " + sets);
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new NumberSets().go();
	}
}
