package aditsu.gcj.permrle;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class PermRLE {
	private String getPath(final String file) {
		return "src/" + getClass().getPackage().getName().replace('.', '/') + '/' + file;
	}

	private BufferedReader getReader(final String file) throws IOException {
		return new BufferedReader(new FileReader(getPath(file)));
	}

	private PrintWriter getWriter(final String file) throws IOException {
		return new PrintWriter(getPath(file));
	}

	private PrintWriter getWriter() throws IOException {
		return getWriter("result.txt");
	}

	private static int toInt(final String s) {
		return Integer.parseInt(s);
	}

	private static int calc(final int[] perm, final String s) {
		char x = '-';
		int n = 0;
		int k = perm.length;
		for (int i = 0; i < s.length(); ++i) {
			char ch = s.charAt((i / k) * k + perm[i % k]);
			if (ch != x) {
				n++;
				x = ch;
			}
		}
		return n;
	}

	private void go() throws IOException {
		final BufferedReader br = getReader("D-small-attempt0.in");
		final PrintWriter w = getWriter();
		
		final int n = toInt(br.readLine());
		for (int i = 0; i < n; ++i) {
			final int k = toInt(br.readLine());
			final String s = br.readLine();
			final int[] set = new int[k];
			Arrays.fill(set, 0);
			int pos = 0;
			final int[] perm = new int[k];
			Arrays.fill(perm, -1);
			int min = 1000000;
			while (true) {
				if (pos == k) {
					int t = calc(perm, s);
					if (t < min) {
						min = t;
					}
					pos--;
					continue;
				}
				if (perm[pos] >= 0) {
					set[perm[pos]]--;
				}
				perm[pos]++;
				if (perm[pos] == k) {
					perm[pos] = -1;
					pos--;
					if (pos < 0) {
						break;
					}
					continue;
				}
				set[perm[pos]]++;
				if (set[perm[pos]] > 1) {
					continue;
				}
				pos++;
			}
			
			w.println("Case #" + (i + 1) + ": " + min);
		}
		w.flush();
	}

	public static void main(final String... args) throws IOException {
		new PermRLE().go();
	}
}
