import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TicTacToe {
	
	char board[][];
	int n;
	public static void main(String args[]) throws Exception{
		TicTacToe t = new TicTacToe();
		BufferedReader input;
		BufferedWriter output;
		input = new BufferedReader(new FileReader("B-large-practice.in"));
		File ofile = new File("practice.out");
		if(!ofile.exists())
			ofile.createNewFile();
		FileWriter fw = new FileWriter(ofile);
		output = new BufferedWriter(fw);
		t.n = Integer.parseInt(input.readLine());
		for(int i=0;i<t.n;i++){
			t.fillBoard(input);
			char result = t.getResult();
			switch(result){
			case 'X':	output.write("Case #"+(i+1)+": X won\n");
						break;
			case 'O':	output.write("Case #"+(i+1)+": O won\n");
						break;
			case 'P':	output.write("Case #"+(i+1)+": Game has not completed\n");
						break;
			case 'D':	output.write("Case #"+(i+1)+": Draw\n");
						break;
			}
		}
		
		input.close();
		output.close();
	}
	
	private char[][] getReflection() {
		char[][] ref = new char[4][4];
		for(int i=0;i<4;i++){
			for(int j=0;j<4;j++){
				ref[i][j]=board[i][3-j];
			}
		}
		return ref;
	}

	private char getResult() {
		char r;
		if((r=checkLDiagonal())=='D')
		{	
			board = getReflection();
			if((r=checkLDiagonal())=='D'){
				board = getReflection();
				if((r=checkHorizontal())=='D'){
					board=getTranspose();
					if((r=checkHorizontal())=='D'){
						if(checkPlaying())
							return 'P';
						else
							return 'D';
					}
					else
						return r;
				}
				else
					return r;
			}
			else
				return r;
		}
		else
			return r;	
	}
	
	private boolean checkPlaying() {
		for(int i=0;i<4;i++){
			for(int j=0;j<4;j++){
				if(board[i][j]=='.')
					return true;
			}
		}
		return false;
	}

	private char[][] getTranspose() {
		char[][] trans = new char[4][4];
		for(int i=0;i<4;i++){
			for(int j=0;j<4;j++){
				trans[i][j]=board[j][i];
			}
		}
		return trans;
	}

	private char checkLDiagonal() {
		char c='D';
		if(board[0][0]=='.')
			return c;
		else{
			if(board[0][0]!='T')
				c=board[0][0];
			else{
				if(board[1][1]=='.')
					return 'D';
				else
					c=board[1][1];
			}	
		}
			
		for(int i=0;i<4;i++){
			if(board[i][i]=='.')
				return 'D';
			if(board[i][i]!=c && board[i][i]!='T')
					return 'D';
				
		}
		return c;
	}


	private char checkHorizontal(){
		char c='D';
		for(int i=0;i<4;i++){
			boolean flag = true;
			boolean temp = false;
			c='D';
			if(board[i][0]!='.'){
				if(board[i][0]=='T')
					temp = true;
				else
					c = board[i][0];
				
				for(int j=1;j<4;j++){
					if(board[i][j]=='.'){
						flag = false;
						break;
					}
					if((board[i][j]=='X' || board[i][j]=='O') && temp){
						c=board[i][j];
						temp =false;
					}
					if(board[i][j]!='T' && board[i][j]!=c){
						flag=false;	
						break;
					}
				}
				
				if(flag)
					return c;			
			}
		}
		return 'D';
	}

	private void fillBoard(BufferedReader input) throws IOException {
		String line;
		board = new char[4][4];
		for(int i=0;i<4;i++){
			line = input.readLine();
			board[i] = line.toCharArray();
		}
		input.readLine();
	}

}
