package com.google.mycodejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

public class MagicTrick {

	static BufferedWriter writer;
	static BufferedReader reader;

	public static void main(String args[]) throws IOException {
		File inFile = new File("A-small-attempt0.in"); // input file
		File outFile = new File("output.out"); // outfile
		FileWriter fwriter = new FileWriter(outFile);
		writer = new BufferedWriter(fwriter);
		FileReader freader = new FileReader(inFile);
		reader = new BufferedReader(freader);
		int numCases = Integer.parseInt(reader.readLine());
		Set<Integer> firstSet;
		Set<Integer> secondSet;
		for (int i = 0; i < numCases; i++) {
			firstSet = new HashSet<Integer>();
			secondSet = new HashSet<Integer>();
			int firstGuess = Integer.parseInt(reader.readLine());
			firstSet = MagicTrick.getRowNumbers(firstGuess - 1);
			int secondGuess = Integer.parseInt(reader.readLine());
			secondSet = MagicTrick.getRowNumbers(secondGuess - 1);
			firstSet.retainAll(secondSet);
			if (firstSet.size() == 0) {
				// Volunteer cheated!
				writer.write("Case #" + (i + 1) + ": Volunteer cheated!");
				writer.newLine();
			} else if (firstSet.size() > 1) {
				// Bad magician!
				writer.write("Case #" + (i + 1) + ": Bad magician!");
				writer.newLine();
			} else if (firstSet.size() == 1) {
				// Answer
				for (Integer answer : firstSet) {
					writer.write("Case #" + (i + 1) + ": " + answer);
					writer.newLine();
				}
			}
		}
		writer.close();
		reader.close();
	}

	public static Set<Integer> getRowNumbers(int row) throws IOException {
		Set<Integer> rowNumbers = new HashSet<Integer>();
		String line = null;
		for (int i = 0; i < 4; i++) {
			line = reader.readLine();
			if (i == row) {
				String[] numbers = line.split("\\s+");
				for (String number : numbers) {
					rowNumbers.add(Integer.parseInt(number));
				}
			}
		}
		return rowNumbers;
	}

}
