
package com.google.mycodejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;

public class CookieClicker {

    static BufferedWriter writer;
    static BufferedReader reader;

    public static void main(String args[]) throws IOException {
        File inFile = new File("input.in"); // input file
        File outFile = new File("output.out"); // outfile
        FileWriter fwriter = new FileWriter(outFile);
        writer = new BufferedWriter(fwriter);
        FileReader freader = new FileReader(inFile);
        reader = new BufferedReader(freader);
        int numCases = Integer.parseInt(reader.readLine());
        DecimalFormat outputDecimalFormat = new DecimalFormat("#.0000000");
        String line = null;
        for (int i = 0; i < numCases; i++) {
            System.out.println("TC #" +(i+1));
            line = reader.readLine();
            String[] numbers = line.split("\\s+");
            double[] cookieVariables = new double[numbers.length];
            for (int j = 0; j < numbers.length; j++) {
                cookieVariables[j] = Double.parseDouble(numbers[j]);
            }
            double time = getMinimumTime(cookieVariables[0],
                    cookieVariables[1], cookieVariables[2]);
            writer.write("Case #" + (i + 1) + ": "
                    + outputDecimalFormat.format(time));
            writer.newLine();
        }
        writer.close();
        reader.close();
    }

    public static double getMinimumTime(double cost, double rate, double target) {
        // cps: cookies per second
        double cps = 2.0;
        double currTime = 0;
        double prevTime = Double.MAX_VALUE;
        int maxFarms = (int) Math.floor(target / cost);
        currTime = target / cps;
        for (int i = 1; i <= maxFarms; i++) {
            if (currTime > prevTime) {
                currTime = prevTime;
                break;
            } else {
                // buy an extra cookie farm
                prevTime = currTime;
                currTime = timeForNextFarm(i, cost, rate);
                cps += rate;
                currTime += target / cps;
            }
        }

        return currTime < prevTime ? currTime : prevTime;
    }

    private static double timeForNextFarm(int num, double cost, double rate) {
        double t = 0;
        double init = 2.0;
        for (int i = 0; i < num; i++) {
            t += cost / (init + (i * rate));
        }
        return t;
    }
}
