package sms.gcjam;

import java.io.BufferedWriter;
import java.io.IOException;
import java.net.URISyntaxException;
import java.util.Scanner;
import java.util.function.Function;

/**
 * Created on Apr 30, 2016.
 */
public class A implements Function<String, String>
{
    @Override
    public String apply(String S)
    {
        int[] counts = new int[26];
        for (int i = 0, iSize = S.length(); i < iSize; ++i)
        {
            char ch = S.charAt(i);
            int index = ch - 'A';
            counts[index]++;
        }
        int[] numbers = new int[10];
        // zero
        int index = 'Z'-'A';
        numbers[0] = counts[index];
        index = 'W'-'A';
        numbers[2] = counts[index];
        index = 'U'-'A';
        numbers[4] = counts[index];
        index = 'X'-'A';
        numbers[6] = counts[index];
        subtract("ZERO", counts, numbers[0]);
        subtract("TWO", counts, numbers[2]);
        subtract("FOUR", counts, numbers[4]);
        subtract("SIX", counts, numbers[6]);
        index = 'R'-'A';
        numbers[3] = counts[index];
        subtract("THREE", counts, numbers[3]);
        index = 'F'-'A';
        numbers[5] = counts[index];
        subtract("FIVE", counts, numbers[5]);
        index = 'S'-'A';
        numbers[7] = counts[index];
        subtract("SEVEN", counts, numbers[7]);
        index = 'G'-'A';
        numbers[8] = counts[index];
        subtract("EIGHT", counts, numbers[8]);
        index = 'O'-'A';
        numbers[1] = counts[index];
        subtract("ONE", counts, numbers[1]);
        index = 'I'-'A';
        numbers[9] = counts[index];
        subtract("NINE", counts, numbers[9]);
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < numbers.length; ++i)
        {
            int number = numbers[i];
            for (int j = 0; j < number; ++j)
            {
                sb.append(Integer.toString(i));
            }
        }
        return sb.toString();
    }
    
    private void subtract(String number, int[] counts, int x)
    {
        for (int i = 0, iSize = number.length(); i < iSize; ++i)
        {
            char ch = number.charAt(i);
            int index = ch - 'A';
            counts[index] -= x;
            assert(counts[index]>=0);
        }
    }
    
    public String outputTestCase(int t, String strResult)
    {
        StringBuilder sb = new StringBuilder("Case #");
        sb.append(t).append(": ").append(strResult);
        return sb.toString();
    }

    public String nextResult(Scanner scanner, int t)
    {
        String input = scanner.next();
        scanner.nextLine();
        String output = apply(input);
        return outputTestCase(t, output);
    }
    
    public static void main(String[] args) throws IOException, URISyntaxException
    {
        A a = new A();
        try (Driver.ScannerWriter scannerWriter = Driver.newScannerWriter(args))
        {
            Scanner scanner = scannerWriter.scanner;
            BufferedWriter outputWriter = scannerWriter.writer;
            int T = scanner.nextInt();
            for (int t = 1; t <= T; ++t)
            {
                String result = a.nextResult(scanner, t);
                outputWriter.write(result);
                outputWriter.newLine();
            }
        }
    }
}
