package sms.gcjam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.net.URISyntaxException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.util.function.BiFunction;

/**
 * Created on Apr 9, 2016.
 */
public class Driver {

    public static void driveTextFileOfIntegers(Path inputPath, BiFunction<Integer, Integer, String> function, Path outputPath) throws IOException, URISyntaxException
    {
        try (BufferedReader inputReader = Files.newBufferedReader(inputPath);
                BufferedWriter outputWriter = Files.newBufferedWriter(outputPath);)
        {
            String inputLine = inputReader.readLine();
            int T = Integer.parseInt(inputLine);
            for (int i = 0; i < T; ++i)
            {
                inputLine = inputReader.readLine();
                int input = Integer.parseInt(inputLine);
                String result = function.apply(i, input);
                outputWriter.write(result);
                outputWriter.newLine();
            }
            outputWriter.flush();
        }
    }
    
    public static void driveFile(Path inputPath, BiFunction<Integer, String, String> function, Path outputPath) throws IOException, URISyntaxException
    {
        try (BufferedReader inputReader = Files.newBufferedReader(inputPath);
                BufferedWriter outputWriter = Files.newBufferedWriter(outputPath);)
        {
            String inputLine = inputReader.readLine();
            int T = Integer.parseInt(inputLine);
            for (int i = 0; i < T; ++i)
            {
                inputLine = inputReader.readLine();
                String result = function.apply(i, inputLine);
                outputWriter.write(result);
                outputWriter.newLine();
            }
            outputWriter.flush();
        }
    }
}
