package sms.gcjam;

import java.io.File;
import java.io.IOException;
import java.net.URISyntaxException;
import java.nio.file.Path;
import java.util.function.BiFunction;

/**
 * Created on Apr 9, 2016.
 */
public class RevengeOfThePancakes implements BiFunction<Integer, String, String>
{
    private int[][] dp;

    @Override
    public String apply(Integer caseIndex, String input)
    {
        int count = 0;
        char current = input.charAt(0);
        for (int i = 1, iSize = input.length(); i < iSize; ++i)
        {
            char next = input.charAt(i);
            if (next != current)
            {
                ++count;
                current = next;
            }
        }
        if (current != '+')
            ++count;
        return output(caseIndex, count);
    }
    
    public String apply_dp(Integer caseIndex, String input)
    {
        int n = input.length();
        if (n <= 0)
            return output(caseIndex, 0);
        dp = new int[n + 1][2];
        for (int i = 1; i < dp.length; ++i)
        {
            for (int j = 0; j < 2; ++j)
            {
                dp[i][j] = Integer.MAX_VALUE;
            }
        }
        for (int i = 1; i <= n; ++i)
        {
            char ch = input.charAt(i - 1);
            if (ch == '-')
            {
                dp[i][0] = Math.min(dp[i][0], dp[i - 1][0]);
                if (dp[i - 1][1] < Integer.MAX_VALUE)
                    dp[i][0] = Math.min(dp[i][0], dp[i - 1][1] + 1);
            }
            else
            {
                if (dp[i - 1][0] < Integer.MAX_VALUE)
                    dp[i][1] = Math.min(dp[i][1], dp[i - 1][0] + 1);
                dp[i][1] = Math.min(dp[i][1], dp[i - 1][1]);
            }
        }
        int flips = dp[n][1];
        if (dp[n][0] < Integer.MAX_VALUE)
            flips = Math.min(flips, dp[n][0] + 1);
        return output(caseIndex, flips);
    }

    private String output(int caseIndex, long result)
    {
        String strResult = Long.toString(result, 10);
        return "Case #" + (caseIndex + 1) + ": " + strResult;
    }
    
    public static void main(String[] args) throws IOException, URISyntaxException
    {
        File dir = new File("C:\\Users\\Steve\\Documents\\src\\GoogleCodeJam\\src\\main\\resources");
        String inputName = "B-small-attempt0.in";
        File fIn = new File(dir, inputName);
        Path inputPath = fIn.toPath();
        File fOut = new File(dir, inputName+".out");
        Path outputPath = fOut.toPath();
        RevengeOfThePancakes function = new RevengeOfThePancakes();
        Driver.driveFile(inputPath, function, outputPath);
    }
}
