package sms.gcjam;

import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Path;
import java.security.SecureRandom;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created on Apr 9, 2016.
 */
public class CoinJam {
    public static void main(String[] args) throws IOException
    {
        File dir = new File("C:\\Users\\Steve\\Documents\\src\\GoogleCodeJam\\src\\main\\resources");
        String inputName = "C-smallsample.txt";
        File fOut = new File(dir, inputName+".out");
        Path outputPath = fOut.toPath();
        CoinJam coinJam = new CoinJam();
        try (BufferedWriter outputWriter = Files.newBufferedWriter(outputPath);)
        {
            String result = coinJam.go(32, 500);
            outputWriter.write(result);
            outputWriter.flush();
        }
    }
    
    public String go(int N, int J)
    {
        SecureRandom secureRandom = new SecureRandom();
        Map<String, List<BigInteger>> n2divisors = new HashMap<>();
        while (n2divisors.size() < J)
        {
            StringBuilder keyBuilder = new StringBuilder(N);
            keyBuilder.append(1);
            for (int i = 0; i < N-2; ++i)
            {
                int nextInt = secureRandom.nextInt(2);
                keyBuilder.append(nextInt);
            }
            keyBuilder.append(1);
            String key = keyBuilder.toString();
            boolean composite = true;
            List<BigInteger> divisors = new ArrayList<>(9);
            for (int radix = 2; radix <= 10; ++radix)
            {
                boolean found = false;
                BigInteger bi = new BigInteger(key, radix);
                // TODO -- iterate over primes instead
                for (int j = 3; j < 32768; j += 2)
                {
                    BigInteger divisor = BigInteger.valueOf(j);
                    if (!bi.gcd(divisor).equals(BigInteger.ONE) && !divisor.equals(bi))
                    {
                        divisors.add(divisor);
                        found = true;
                        break;
                    }
                }
                if (!found)
                {
                    composite = false;
                    break;
                }
            }
            if (composite)
                n2divisors.put(key, divisors);
        }
        StringBuilder sb = new StringBuilder();
        sb.append("Case #1:\n");
        for (Map.Entry<String, List<BigInteger>> entry : n2divisors.entrySet())
        {
            sb.append(entry.getKey());
            List<BigInteger> divisors = entry.getValue();
            for (BigInteger divisor : divisors)
            {
                sb.append(" ");
                sb.append(divisor.toString(10));
            }
            sb.append("\n");
        }
        return sb.toString();
    }
}
