import java.util.*;
import java.math.*;
import java.security.*;

public class CoinJam {

    public static final BigInteger ZERO = new BigInteger("0");
	public static final BigInteger ONE = new BigInteger("1");
	public static final BigInteger TWO = new BigInteger("2");
	public static final BigInteger THREE = new BigInteger("3");
	public static final BigInteger FOUR = new BigInteger("4");
	public static final BigInteger FIVE = new BigInteger("5");
	public static final BigInteger SIX = new BigInteger("6");
	public static final BigInteger SEVEN = new BigInteger("7");
	public static final BigInteger EIGHT = new BigInteger("8");
	public static final BigInteger NINE = new BigInteger("9");
	public static final BigInteger TEN = new BigInteger("10");
	public static final BigInteger NEG_ONE = new BigInteger("-1");

	public static BigInteger sqrt(BigInteger n) {
		BigInteger r = BigInteger.ZERO;
		BigInteger m = r.setBit(2 * n.bitLength());
		BigInteger nr;

		do {
			nr = r.add(m);
			if (nr.compareTo(n) != 1) {
				n = n.subtract(nr);
				r = nr.add(m);
			}
			r = r.shiftRight(1);
			m = m.shiftRight(2);
		} while (m.bitCount() != 0);

		return r;
	}

    private final static SecureRandom random = new SecureRandom();

    public static BigInteger rho(BigInteger N) {
        BigInteger divisor;
        BigInteger c  = new BigInteger(N.bitLength(), random);
        BigInteger x  = new BigInteger(N.bitLength(), random);
        BigInteger xx = x;

        // check divisibility by 2
        if (N.mod(TWO).compareTo(ZERO) == 0) return TWO;

        do {
            x  =  x.multiply(x).mod(N).add(c).mod(N);
            xx = xx.multiply(xx).mod(N).add(c).mod(N);
            xx = xx.multiply(xx).mod(N).add(c).mod(N);
            divisor = x.subtract(xx).gcd(N);
        } while((divisor.compareTo(ONE)) == 0);

        return divisor;
    }

    public static void main(String[] args) {

        Scanner sc = new Scanner(System.in);
        BigInteger[][] pow = new BigInteger[11][32];

        for (int i = 2; i <= 10; i++) {
            pow[i][0] = BigInteger.valueOf(1);
            pow[i][1] = BigInteger.valueOf(i);
            for (int j = 2; j < 32; j++) {
                pow[i][j] = pow[i][j - 1].multiply(pow[i][1]);
            }
        }

        for (int t = sc.nextInt(); t > 0; t--) {

            int n = sc.nextInt();
            int j = sc.nextInt();

            int jr = 0;
            System.out.println("Case #1:");
            for (long i = ((long)1 << (n - 1)) | (long)1; jr < j; i += 2) {
                BigInteger[] b = new BigInteger[11];
                BigInteger[] ans = new BigInteger[11];
                boolean possible = true;
                for (int k = 2; k <= 10; k++) {
                    b[k] = ZERO;
                    int l = 0;
                    for (long m = 1; m <= i; l++, m <<= 1) {
                        if ((i & m) != 0) {
                            b[k] = b[k].add(pow[k][l]);
                        }
                    }
                    if (b[k].isProbablePrime(1000)) {
                        possible = false;
                    } else {
                        do {
                            ans[k] = rho(b[k]);
                        } while (ans[k].compareTo(b[k]) == 0);
                    }
                }
                if (possible) {
                    jr++;
                    System.out.print(b[10].toString());
                    for (int k = 2; k <= 10; k++) {
                        System.out.print(" " + ans[k].toString());
                    }
                    System.out.println();
                }
            }

        }

    }

}
