package codejam.year2016.round1b;

import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class A {

    private static Scanner in;
    private static PrintStream out;

    private static final String CASE_N = "Case #";
    private static final String COLON_SPACE = ": ";

    private static final String ZERO = "ZERO";  // EORZ
    private static final String ONE = "ONE";    // EON
    private static final String TWO = "TWO";    // OTW
    private static final String THREE = "THREE";// EEHRT
    private static final String FOUR = "FOUR";  // FORU
    private static final String FIVE = "FIVE";  // EFIV
    private static final String SIX = "SIX";    // ISX
    private static final String SEVEN = "SEVEN";// EENSV
    private static final String EIGHT = "EIGHT";// EGHIT
    private static final String NINE = "NINE";  // EINN

    public static void main(String[] args) throws Throwable {
        //findOutChars(ZERO, ONE, TWO, THREE, FOUR, FIVE, SIX, SEVEN, EIGHT, NINE);

        //in = new Scanner(System.in);
        in = new Scanner(A.class.getResourceAsStream("A-small-attempt0.in"));
        out = System.out;
        out = new PrintStream(new FileOutputStream("A-small.out"));

        int T = in.nextInt();

        for (int t = 1; t <= T; t++) {
            out.print(CASE_N);
            out.print(t);
            out.print(COLON_SPACE);

            String S = in.next();
            String result = guessNumber(S);
            out.println(result);
        }
        out.flush();
    }

    private static void findOutChars(String... numbers) {
        for (char ch = 'A'; ch <= 'Z'; ch++) {
            System.out.print(ch);
            System.out.print(" = ");
            for (String number : numbers) {
                for (int i = 0; i < number.length(); i++) {
                    if (number.charAt(i) == ch) {
                        System.out.print(number);
                        System.out.print(" ");
                    }
                }
            }
            System.out.println();
        }
    }

    private static String guessNumber(String S) {
        /*
        A = 
B = 
C = 
D = 
E = ONE THREE THREE FIVE SEVEN SEVEN NINE 
F = FIVE 
G = 
H = THREE 
I = FIVE NINE 
J = 
K = 
L = 
M = 
N = ONE SEVEN NINE NINE 
O = ONE 
P = 
Q = 
R = THREE 
S = SEVEN 
T = THREE 
U = 
V = FIVE SEVEN 
W = 
X = 
Y = 
Z = 
         */

        // Z = zero, X = six, W = two, U = four, G = eight
        char[] chars = newSortedCharArr(S);
        S = new String(chars);
        
        StringBuilder result = new StringBuilder(chars.length / 3);
        
        // 0 (Z)
        S = checkUpdateAndAppend(S, chars, result, 'Z', ZERO, '0');
        chars = newSortedCharArr(S);
        // 6 (X)
        S = checkUpdateAndAppend(S, chars, result, 'X', SIX, '6');
        chars = newSortedCharArr(S);
        // 2 (W)
        S = checkUpdateAndAppend(S, chars, result, 'W', TWO, '2');
        chars = newSortedCharArr(S);
        // 4 (U)
        S = checkUpdateAndAppend(S, chars, result, 'U', FOUR, '4');
        chars = newSortedCharArr(S);
        // 8 (G)
        S = checkUpdateAndAppend(S, chars, result, 'G', EIGHT, '8');
        chars = newSortedCharArr(S);

        // 5 (F)
        S = checkUpdateAndAppend(S, chars, result, 'F', FIVE, '5');
        chars = newSortedCharArr(S);
        // 3 (H)
        S = checkUpdateAndAppend(S, chars, result, 'H', THREE, '3');
        chars = newSortedCharArr(S);
        // 1 (O)
        S = checkUpdateAndAppend(S, chars, result, 'O', ONE, '1');
        chars = newSortedCharArr(S);
        // 7 (S)
        S = checkUpdateAndAppend(S, chars, result, 'S', SEVEN, '7');
        chars = newSortedCharArr(S);
        // 9 (I) -- or anything, is all that's left
        S = checkUpdateAndAppend(S, chars, result, 'I', NINE, '9');
        //chars = newSortedCharArr(S);

        char[] charsRes = newSortedCharArr(result.toString());

        return new String(charsRes);
    }

    private static String checkUpdateAndAppend(String S, char[] Sarr, StringBuilder result, char charToCheck, String numberAsWord, char digit) {
        while (Arrays.binarySearch(Sarr, charToCheck) > -1) {
            S = removeOneOfEach(S, numberAsWord);
            result.append(digit);
            Sarr = newSortedCharArr(S);
        }
        return S;
    }

    private static String removeOneOfEach(String S, String number) {
        for (int i = 0; i < number.length(); i++) {
            S = S.replaceFirst(String.valueOf(number.charAt(i)), "");
        }
        return S;
    }

    private static char[] newSortedCharArr(String S) {
        char[] chars = S.toCharArray();
        Arrays.sort(chars);
        return chars;
    }

}
