import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;

public class C {

    private static Scanner in;
    private static PrintStream out;

    private static final String CASE_N = "Case #";
    private static final String COLON = ":";
    private static final String SPACE = " ";

    private static final int BASE_2 = 2;
    private static final int BASE_10 = 10;

    private static final int MAX_PRIMES_TO_CHECK = 10000;

    public static void main(String[] args) throws Throwable {
        long ini = System.currentTimeMillis();

        in = new Scanner(System.in);
        //in = new Scanner(new FileInputStream("C-test.in"));
//        in = new Scanner(new FileInputStream("C-small-attempt0.in"));
        in = new Scanner(new FileInputStream("C-large.in"));
        out = System.out;
        out = new PrintStream(new FileOutputStream("C-large.out"));

        int T = in.nextInt();

        BigInteger[] numbersPerBase = new BigInteger[11];
        BigInteger[] dividersPerBase = new BigInteger[11];
        BigInteger[] primeNumbers = calculateFirstPrimeNumbers(MAX_PRIMES_TO_CHECK);

        for (int t = 1; t <= T; t++) {
            out.print(CASE_N);
            out.print(t);
            out.println(COLON);

            int N = in.nextInt();
            int J = in.nextInt();

            int j = 0;
            char[] number = new char[N];
            number[0] = number[N - 1] = '1';
            for (int i = 1; i < N - 1; i++) {
                number[i] = '0';
            }
            while (j < J) {
                String numberStr = new String(number);
                BigInteger numBase10 = new BigInteger(numberStr);
                numbersPerBase[10] = numBase10;

                boolean foundPrime = isPrime(numBase10);
                for (int base = BASE_2; base < BASE_10 && !foundPrime; base++) {
                    BigInteger thisNumber = numbersPerBase[base] = numberAsBase(numberStr, base);

                    // todo: add logic to skip when we tried too many calculations

                    if (isPrime(thisNumber)) {
                        foundPrime = true;
                    }
                }
                if (!foundPrime) {
                    // found jamcoin!!
                    boolean skip = false;
                    for (int base = BASE_2; base <= BASE_10 && !skip; base++) {
                        BigInteger numberAtBase = numbersPerBase[base];
                        BigInteger half = numberAtBase.divide(BigInteger.valueOf(2));

                        BigInteger divider = primeNumbers[0];
                        int iPrime = 0;
                        while (divider.compareTo(half) < 0) {
                            if (isDivisible(numberAtBase, divider)) {
                                // we found the first possible divider
                                dividersPerBase[base] = divider;
                                break;
                            }
                            if (iPrime >= MAX_PRIMES_TO_CHECK-1) {
                                skip = true;
                                break;
                            }
                            divider = primeNumbers[++iPrime];
                        }
                    }
                    if (!skip) {
                        // found another jamcoin! (that we could compute) print it!
                        printSingleResult(dividersPerBase, numberStr);

                        j++;

                        System.out.print(j);
                        System.out.print(": ");
                        System.out.println(numberStr);
                    }
                }

                updateToNext(number);
            }
        }
        long end = System.currentTimeMillis();
        System.out.println("Run took: " + (end-ini) + "ms");

        out.flush();
    }

    private static void printSingleResult(BigInteger[] dividersPerBase, String numberStr) {
        out.print(numberStr);
        out.print(SPACE);
        for (int base = BASE_2; base <= BASE_10; base++) {
            out.print(dividersPerBase[base]);
            if (base != BASE_10) {
                out.print(SPACE);
            }
        }
        out.println();
    }

    private static BigInteger[] calculateFirstPrimeNumbers(int amount) {
        BigInteger[] primes = new BigInteger[amount];
        primes[0] = BigInteger.valueOf(2);
        for (int i = 1; i < amount; i++) {
            primes[i] = primes[i-1].nextProbablePrime();
        }
        return primes;
    }

    private static boolean isDivisible(BigInteger numberAtBase, BigInteger divider) {
        BigInteger[] divisionAndRemainder = numberAtBase.divideAndRemainder(divider);
        return divisionAndRemainder[1].equals(BigInteger.ZERO);
    }

    private static void updateToNext(char[] number) {
        int i = number.length - 2;
        for (;;) {
            if (number[i] == '0') {
                number[i] = '1';
                return;
            } else {
                // number[i] == '1'
                number[i] = '0';
                i--;
                // and let continue, so the next digit is generated
            }
        }
    }

    static BigInteger numberAsBase(String number, int base) {
        return new BigInteger(number, base);
    }

    static boolean isPrime(BigInteger number) {
        return number.isProbablePrime(1000);
    }

}
