import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

public class B {

    private static Scanner in;
    private static PrintStream out;

    private static final String CASE_N = "Case #";
    private static final String COLON_SPACE = ": ";

    static char HAPPY = '+';
    static char SAD = '-';

    public static void main(String[] args) throws Throwable {
        //in = new Scanner(System.in);
        in = new Scanner(new FileInputStream("B-large.in"));
        //out = System.out;
        out = new PrintStream(new FileOutputStream("B-large.out"));

        int T = in.nextInt();

        for (int t = 1; t <= T; t++) {
            out.print(CASE_N);
            out.print(t);
            out.print(COLON_SPACE);

            char[] S = in.next().toCharArray();

            int length = S.length;
            int flips = 0;

            while (needsFlipping(S, length)) {
                char firstCh = S[0];
                char lastCh = S[length-1];
                int sameInStart = countFirstEquals(S, length);
                int sameInEnd = sameInStart == length ? length : countLastEquals(S, length);
                if (lastCh == HAPPY) {
                    // [1] the last is happy, so we will ignore those from now, we don't touch this part anymore
                    length = length - sameInEnd;
                } else if (sameInStart == length) {
                    // [2] all the same, all will be SAD, so just flip and we will be finished
                    flipStack(S, length);
                    flips++;
                } else if (firstCh != lastCh) {
                    // [3] first and last are different (means last is SAD, because of [1], and therefore first part is HAPPY),so we flip so that all is accumulated as sad in the end, and can be flipped together later
                    flipStack(S, length - sameInEnd);
                    flips++;
                } else {
                    // if (firstCh == lastCh) {
                    // [4] first and last are the same, and SAD (because this did not pass [1], so last is SAD, and didn't meet [3], so end and start are SAD)
                    flipStack(S, length);
                    flips++;
                }

                //if (lastCh == SAD && firstCh == HAPPY) {
                //    // we do this because otherwise we have still the same case once we flip -> and we can ignore this last part, because it will be flipped once the new SAD part is flipped (and if this is just switching over and over then means all these parts accumulating will be flipped later on when the last one does
                //    length = length - sameInEnd;
                //}
            }

            out.println(flips);
        }

    }

    private static int countFirstEquals(char[] s, int length) {
        for (int i = 1; i < length; i++) {
            if (s[0] != s[i]) {
                return i;
            }
        }
        return length;
    }

    private static int countLastEquals(char[] s, int length) {
        for (int i = length-2; i >= 0; i--) {
            if (s[length-1] != s[i]) {
                return length - i - 1;
            }
        }
        return length;
    }

    private static void flipStack(char[] cs, int untilLength) {
        for (int i = 0; i < (untilLength+1)/2; i++) {
            int ia = i;
            int ib = untilLength - i - 1;

            char ca = cs[ia];
            char cb = cs[ib];

            cs[ia] = flip(cb);
            if (ia != ib) {
                cs[ib] = flip(ca);
            }
        }
    }

    private static char flip(char c) {
        return c == HAPPY ? SAD : HAPPY;
    }

    private static boolean needsFlipping(char[] cs, int length) {
        for (int i = 0; i < length; i++) {
            if (cs[i] == SAD) return true;
        }
        return false;
    }

    static class OppositeString implements CharSequence {

        private final int increment;
        private final int length;
        private String original;

        OppositeString(String original, int increment, int length) {
            this.original = original;
            this.increment = increment;
            this.length = length;
        }

        @Override
        public int length() {
            return length;
        }

        @Override
        public char charAt(int index) {
            return 0;
        }

        @Override
        public CharSequence subSequence(int start, int end) {
            return null;
        }
    }

}
