package round1a;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class B {

	static Scanner in;
	static PrintStream out;
	
	static int N,M;
	
	static Word[] D = new Word[10020];
	static String[] L = new String[110];
	static Map<Integer, List<Word>> sizeCount = new HashMap<Integer, List<Word>>();
	
	public static void main(String[] args) throws Throwable {
		in = new Scanner(new File("in/round1a/B-small-attempt6.in"));
//		in = new Scanner(System.in);
		out = new PrintStream(new File("out/round1a/B-small.out"));
//		out = new PrintStream(System.out);
		
		int T = in.nextInt();
		for (int test = 1; test <= T; test++) {
			N = in.nextInt();
			M = in.nextInt();
			
			sizeCount.clear();
			
			for (int i = 0; i < N; i++) {
				D[i] = readWord();
			}
			for (int i = 0; i < M; i++) {
				L[i] = in.next();
			}
			
			out.print("Case #");
			out.print(test);
			out.print(": ");
			String bestWord = solve(L[0]);
			out.print(bestWord);
			for (int i = 1; i < M; i++) {
				bestWord = solve(L[i]);
				out.print(' ');
				out.print(bestWord);
			}
			out.println();
		}
	}
	
	static String[] nxtD = new String[10020];
	static int nxtDlen = 0;
	
	private static String solve(String Li) {
		int best = -1;
		int bestVal = 0;
		for (int i = 0; i < N; i++) {
			Word word = D[i];
			
			List<Word> list = sizeCount.get(word.len);
			if (list.size() == 1) {
				continue;// se soh tem ele, eh mto facil adivinhar
			}

			// usa copia para nao sujar a lista
			list = new ArrayList<B.Word>(list);
			list.remove(word);// tira a palavra pra nao dar confusao
			word.foundLetters = 0;
			for (Word word2 : list) {
				word2.foundLetters = 0;
			}
			
			char[] cur_sol = new char[word.len];
			
			boolean[] foundLetter = new boolean[list.size()];
			        
			int curVal = 0;
			for (int let = 0; let < 26; let++) {
				char ch = Li.charAt(let);
				
				boolean mayUse = false;
				boolean hasInWord =false;
				
				// verifica se a palavra tem este caracter
				if (Arrays.binarySearch(word.chars, ch) > -1) {
					mayUse = true;
					hasInWord = true;
				}
				
				// verifica se as outras palavras tem o caracter
				for (int w = 0; w < list.size(); w++) {
					Word other = list.get(w);
					foundLetter[w] = Arrays.binarySearch(other.chars, ch) > -1;
					mayUse |= foundLetter[w];
					//mayUse |= Arrays.binarySearch(other.chars, ch) > -1;
				}
				
				if (mayUse) {
					if (hasInWord) {
						word.foundLetters++;
						if (word.foundLetters >= word.chars.length) break;

						addToCurSol(word.str, cur_sol, ch);
					} else {
						curVal++;
					}
					
					for (int j = list.size()-1; j >= 0; j--) {
						Word other = list.get(j);
						if (foundLetter[j]) {
							// se achou, nao estah na palavra (nao serah escrito), entao remove
							if (!hasInWord) {
								list.remove(j);
								continue;
							}
							
							other.foundLetters++;// se ja achou todas as letras desta palavra, sabe q ela nao vale mais, pode removela
							if (other.foundLetters >= other.chars.length) {
								list.remove(j);
								continue;
							} 
						} else {
							if (hasInWord) {
								list.remove(j);
								continue;
							}
						}
						// se esta solucao nao eh mais valida, remove esta palavra
						if (!validSol(other.str, cur_sol) || !validSolOnNewChar(other.str, cur_sol, ch)){
							list.remove(j);
						}
					}
					if (list.isEmpty()) {
						break;// soh sobrou uma palavra
					}
				}
			}
			
			if (curVal > bestVal) {
				bestVal = curVal;
				best = i;
			}
		}
		
		if (best < 0) {// se nenhum eh bom, entao tanto faz, pega o primeiro
			return D[0].str;
		}
		return D[best].str;
	}

	private static boolean validSolOnNewChar(String str, char[] cur_sol, char ch) {
		for (int i = 0; i < str.length(); i++) {
			char strCh = str.charAt(i);
			if (strCh == ch) {
				if (ch != cur_sol[i]) return false;
			}
		}
		return true;
	}

	private static boolean validSol(String str, char[] cur_sol) {
		for (int i = 0; i < str.length(); i++) {
			if (cur_sol[i] == 0) continue;
			if (cur_sol[i] != str.charAt(i)) return false;
		}
		return true;
	}

	private static void addToCurSol(String str, char[] cur_sol, char ch) {
		for (int i = 0; i < str.length(); i++) {
			char strCh = str.charAt(i);
			if (strCh == ch) {
				cur_sol[i] = ch;
			}
		}
	}

	static Word readWord() {
		String str = in.next();
		int len = str.length();
		char[] chararr = str.toCharArray();
		Arrays.sort(chararr);
		int j = 0;
		for (int i = 1; i < chararr.length; i++) {
			if (chararr[i] == chararr[j]) {
				// skip i
			} else {
				chararr[j+1] = chararr[i];
				j++;
			}
		}
		j++;
		char[] chars = new char[j];
		System.arraycopy(chararr, 0, chars, 0, j);
		
		Word word = new Word(chars, len, str);
		
		addToSizeCount(word);
		
		return word;
	}
	
	private static void addToSizeCount(Word word) {
		List<Word> list = sizeCount.get(word.len);
		if (list == null) {
			list = new ArrayList<B.Word>();
			list.add(word);
			sizeCount.put(word.len, list);
		} else {
			list.add(word);
		}
	}

	static class Word {
		char[] chars;
		int len;
		String str;
		int foundLetters;
		
		public Word(char[] chars, int len, String word) {
			super();
			this.chars = chars;
			this.len = len;
			this.str = word;
		}
		
	}
}
