package qualification;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.PrintStream;
import java.util.Arrays;


public class B {
	
	private static final char[] YES = "YES".toCharArray();
	private static final char[] NO  = "NO".toCharArray();
	
	static int[][] a = new int[100][100];
	static boolean[][] visited = new boolean[100][100];
	
	static int N,M;
	
	static final Queue Q = new Queue(100 * 100);
	
	public static void main(String[] args) throws Throwable {
		in = System.in;
		out = System.out;
//		in = new FileInputStream("in/B-small-attempt1.in");
		in = new FileInputStream("in/B-large.in");
		out = new PrintStream(new FileOutputStream("out/B-large.out"));
		
		int T = readInt();
		
		for (int test = 1; test <= T; test++) {
			N = readInt();
			M = readInt();
			for (int n = 0; n < N; n++) {
				for (int m = 0; m < M; m++) {
					a[n][m] = readInt();
					visited[n][m] = false;
					Q.add(new Entry(a[n][m], n, m));
				}
			}
			
			Arrays.sort(Q.Q, 0, Q.len);
			
			writeOut(CASE);
			writeOutNumber(test);
			writeOut(':');
			writeOut(' ');
			writeOut( solve() ? YES : NO );
			writeOutLn();
			
			Q.empty();
		}
		
		flush();

	}

	private static boolean solve() {
		while (!Q.isEmpty())
		{
			Entry e = Q.take();
			if (visited[e.i][e.j]) continue;
			
			int i = e.i;
			int j = e.j;
			
			boolean yiiis = false;
			
			if ( checkAllIn(i, 0, 0, 1, e.value) ) {
				for (int j2 = 0; j2 < M; j2++) {
					visited[i][j2] = true;
				}
				yiiis = true;
			}
			
			if ( checkAllIn(0, j, 1, 0, e.value) ) {
				for (int i2 = 0; i2 < N; i2++) {
					visited[i2][j] = true;
				}
				yiiis = true;
			}
			
			if (!yiiis) 
				return false;
		}
		
		return true;
	}

	private static boolean checkAllIn(int n, int m, int in, int im, int value) {
		while (n < N && m < M)
		{
			if (a[n][m] > value) return false;
			
			n += in;
			m += im;
		}
		
		return true;
	}

	private static final char[] CASE = "Case #".toCharArray();
	
	static InputStream in;
	static PrintStream out;
	
	static byte[] buffer = new byte[8192];
	static int pos;
	static int max;

	static final int maxOut = 8192;
	static byte[] output = new byte[maxOut];
	static int posOut = 0;
	
	static char[] tmpcharr = new char[128];

	static int pow2(int v) {
		return v * v;
	}

	static boolean reachedEndOfLine() throws Throwable {
		while (true) {
			int data = read();
			if (data == -1)
				return true;
			if (data == '\r' || data == '\n') {
				return true;
			}
			if (data == ' ') {
				continue;
			}
			pos--;
			return false;
		}
	}

	// COMPARISION FUNCTIONS

	static boolean isValidChar(int v) {
		// nao verifica o 'DELETE' (127)
		return (v & 0xE0) != 0;
	}

	static boolean isNum(int v) {
		return v >= '0' && v <= '9';
	}

	static boolean isLowercase(int cur) {
		return cur >= 'a' && cur <= 'z';
	}

	static boolean isUppercase(int cur) {
		return cur >= 'A' && cur <= 'Z';
	}

	// is a letter (alphabetic)
	static boolean isAlpha(int cur) {
		return isLowercase(cur) || isUppercase(cur);
	}

	// is alphanumeric (letters and numbers)
	static boolean isAlphaNum(int cur) {
		return isAlpha(cur) || isNum(cur);
	}

	static boolean isMinus(int cur) {
		return cur == '-';
	}

	static boolean isPlus(int cur) {
		return cur == '+';
	}

	// INPUT FUNCTIONS

	static void goToBeginOfNextWord() throws Throwable {
		int cur;
		// se for -1 j sai do mtodo
		while ((cur = read()) != -1) {
			// se for um char vlido ento deixa o ponteiro nele
			if (cur > 32) {
				pos--;
				return;
			}
		}
	}

	// return the length of the string read
	static String readWord() throws Throwable {
		int len = 0;
		int cur;
		// descarta os espacos em branco primeiro
		while ((cur = read()) < 33) {
			if (cur == -1) return "";
		}

		tmpcharr[len++] = (char) cur;
		while ((cur = (char) read()) > 32) {
			tmpcharr[len++] = (char) cur;
		}

		return new String(tmpcharr, 0, len);
	}

	static void discardWord() throws Throwable {
		int cur;
		// descarta os espacos em branco primeiro
		while ((cur = read()) < 33) {
			if (cur == -1)
				return;
		}
		// descarta os valores 'validos'
		while ((cur = read()) > 32)
			;
	}

	static int readInt() throws Throwable {
		int cur;
		while (!isNum(cur = read()) && !isMinus(cur))
			if (cur == -1)
				return -1;
		int v = 0;
		boolean minus = false;
		if (isMinus(cur)) {
			minus = true;
			cur = read();
		}
		while (isNum(cur)) {
			v *= 10;
			v += (cur - '0');
			cur = read();
		}
		return minus ? -v : v;
	}

	static char readChar() throws Throwable {
		int cur;
		for (;;) {
			cur = read();
			if (cur == -1)
				return 0;
			if (cur == '\r' || cur == '\n' || cur == ' ')
				continue;

			return (char) cur;
		}
	}

	static long readLong() throws Throwable {
		int cur;
		while (!isNum(cur = read()) && !isMinus(cur))
			if (cur == -1)
				return -1;
		long v = 0;
		boolean minus = false;
		if (isMinus(cur)) {
			minus = true;
			cur = read();
		}
		while (isNum(cur)) {
			v *= 10;
			v += (cur - '0');
			cur = read();
		}
		return minus ? -v : v;
	}

	static boolean hasInput() throws Throwable {
		while (true) {
			int data = read();
			if (data == -1)
				return false;
			if ((data & 0xE0) != 0) {
				pos--;
				return true;
			}
		}
	}

	static int read() throws Throwable {
		if (pos >= max) {
			max = in.read(buffer);
			if (max < 0)
				return -1;
			pos = 0;
		}
		return buffer[pos++] & 0xff;
	}

	// OUTPUT FUNCTIONS

	// escreve um char

	static void writeOut(char c) {
		if (posOut >= maxOut) {
			writeOutToStream();
		}
		output[posOut++] = (byte) c;
	}

	// escreve a quebra de linha
	static void writeOutLn() {
		writeOut('\n');
	}

	// escreve um char[]
	static void writeOut(char[] cs) {
		writeOut(cs, 0, cs.length);
	}

	// escreve uma cadeia de caracteres
	static void writeOut(char[] chars, int offset, int length) {
		final int end = offset + length;
		for (int i = offset; i < end; i++) {
			writeOut(chars[i]);
		}
	}

	static void writeOutNumber(int value) {
		int len = 0;
		int pos = tmpcharr.length;
		if (value == 0) {
			writeOut('0');
			return;
		}
		boolean negative = value < 0;
		if (negative)
			value = -value;
		while (value > 0) {
			tmpcharr[--pos] = (char) ((value % 10) + '0');
			len++;
			value /= 10;
		}
		if (negative)
			writeOut('-');
		writeOut(tmpcharr, pos, len);
	}

	static void writeOutNumberAsBin(int num) {
		int len = 0;
		int pos = tmpcharr.length;
		if (num == 0) {
			writeOut('0');
			return;
		}
		while (num > 0) {
			tmpcharr[--pos] = ((num & 1) == 1) ? '1' : '0';
			len++;
			num >>>= 1;
		}
		writeOut(tmpcharr, pos, len);
	}

	static void flush() {
		writeOutToStream();
		out.flush();
	}

	// PRIVATE methods must be used only by the utility methods

	private static void writeOutToStream() {
		out.write(output, 0, posOut);
		posOut = 0;
	}

	static class Entry implements Comparable<Entry> {
		
		final int value;
		final int i, j;
		public Entry(int value, int i, int j) {
			this.value = value;
			this.i = i;
			this.j = j;
		}
		
		@Override
		public int compareTo(Entry o) {
			int dif = value - o.value;
			if (dif != 0) return dif;
			dif = i - o.i;
			if (dif != 0) return dif;
			return j - o.j;
		}

		@Override
		public String toString() {
			return "Entry [value=" + value + ", i=" + i + ", j=" + j + "]";
		}
		
	}
	
	static class Queue {

		Entry[] Q;
		int ini;
		int len;
		
		public Queue(int size) {
			Q = new Entry[size];
			ini = 0;
			len = 0;
		}
		
		public void add(Entry v) {
			Q[(ini+len) % Q.length] = v; 
			len++;
		}
		
		public Entry take() {
			Entry v = Q[ini];
			ini = (ini + 1) % Q.length;
			len--;
			return v;
		}
		
		public int size() {
			return len;
		}
		
		public boolean isEmpty() {
			return size() == 0;
		}
		
		public boolean isFull() {
			return size() == Q.length;
		}
		
		public void empty()
		{
			ini = 0;
			len = 0;
		}
		
	}
	
}