package codejam.year2017.qualification;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;

public class B {

    private static Scanner in;
    private static PrintStream out;

    private static final String CASE_N = "Case #";
    private static final String COLON_SPACE = ": ";

    public static void main(String[] args) throws Throwable {
        in = new Scanner(System.in);
        in = new Scanner(new FileInputStream("/home/adorow/dev/git/github/adorow/googlecodejam/src/main/resources/codejam/year2017/qualification/B/B-small-attempt0.in"));
        out = System.out;
        out = new PrintStream(new FileOutputStream("/home/adorow/dev/git/github/adorow/googlecodejam/src/main/resources/codejam/year2017/qualification/B/B-small.out"));

        int T = in.nextInt();

        for (int t = 1; t <= T; t++) {
            out.print(CASE_N);
            out.print(t);
            out.print(COLON_SPACE);

            String solution = solve();
            out.print(solution);

            out.println();
        }
        out.flush();
    }

    private static String solve() {
        String N = in.next();
        StringBuilder solution = new StringBuilder(N);

        int decreasingIndex;
        while ((decreasingIndex = findDecreasingIndex(N)) > -1) {
            for (int i = decreasingIndex; i < N.length(); i++) {
                solution.setCharAt(i, '9');
            }
            int toReduce = decreasingIndex - 1;
            while (toReduce > -1) {
                char ch = solution.charAt(toReduce);

                if (ch > '0') {
                    solution.setCharAt(toReduce, charMinusOne(ch));
                    break;
                }
                if (toReduce == 0) {
                    solution.deleteCharAt(0);
                    break;
                }
                solution.setCharAt(toReduce, '9');
                toReduce--;
            }

            // delete starting zeros
            while (solution.length() > 1 && solution.charAt(0) == '0') {
                solution.deleteCharAt(0);
            }
            N = solution.toString();
        }

        return N;
    }

    private static char charMinusOne(char c) {
        return (char) (c - 1);
    }

    private static boolean decreasing(char left, char right) {
        return right < left;
    }

    private static int findDecreasingIndex(String n) {
        for (int i = 1; i < n.length(); i++) {
            if (decreasing(n.charAt(i-1), n.charAt(i))) {
                return i;
            }
        }
        return -1;
    }

}
