import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

public class A {

    private static Scanner in;
    private static PrintStream out;

    private static final String INSOMNIA = "INSOMNIA";
    private static final String CASE_N = "Case #";
    private static final String COLON_SPACE = ": ";

    private static final boolean[] nums = new boolean[10];

    public static void main(String[] args) throws Throwable {
        //in = new Scanner(System.in);
        in = new Scanner(new FileInputStream("A-small-attempt1.in"));
        //out = System.out;
        out = new PrintStream(new FileOutputStream("A-small.out"));

        int T = in.nextInt();

        for (int t = 1; t <= T; t++) {
            out.print(CASE_N);
            out.print(t);
            out.print(COLON_SPACE);

            int N = in.nextInt();

            long result = findCount(N);
            if (result < 0) {
                out.println(INSOMNIA);
            } else {
                out.println(result);
            }
        }
        out.flush();
    }

    private static long findCount(long n) {
        if (n <= 0) {
            return -1;
        }

        long maxNum = maxNumFrom(n);

        long cur = n;
        setAll(nums, false);
        while (cur <= maxNum) {
            updateNums(cur, nums);
            if (all(nums)) {
                return cur;
            }

            cur = cur + n;
        }


        return -1;
    }

    private static long maxNumFrom(long n) {
        return n*100;
    }

    private static void updateNums(long cur, boolean[] nums) {
        while (cur > 0) {
            int thisNum = (int) (cur % 10);
            nums[thisNum] = true;
            cur /= 10;
        }
    }

    private static int numLength(long cur) {
        int len = 1;
        long pow = 10;
        while (cur >= pow) {
            pow *= 10;
            len++;
        }
        return len;
    }

    private static boolean all(boolean[] nums) {
        for (boolean bool : nums) {
            if (!bool) return false;
        }
        return true;
    }

    private static void setAll(boolean[] nums, boolean b) {
        for (int i = 0; i < nums.length; i++) {
            nums[i] = b;
        }
    }

}
