package codejam.year2017.qualification;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.BitSet;
import java.util.Scanner;

public class ALarge {

    public static final char UNHAPPY = '-';
    public static final char HAPPY = '+';

    private static Scanner in;
    private static PrintStream out;

    private static final String CASE_N = "Case #";
    private static final String COLON_SPACE = ": ";

    public static void main(String[] args) throws Throwable {
        in = new Scanner(System.in);
        in = new Scanner(new FileInputStream("./src/main/resources/codejam/year2017/qualification/A/A-large.in"));
        out = System.out;
        out = new PrintStream(new FileOutputStream("./src/main/resources/codejam/year2017/qualification/A/A-large.out"));

        int T = in.nextInt();

        for (int t = 1; t <= T; t++) {
            out.print(CASE_N);
            out.print(t);
            out.print(COLON_SPACE);

            String S = in.next();
            int K = in.nextInt();

            int solution = solve(S, K);
            if (solution < 0) {
                out.print("IMPOSSIBLE");
            } else {
                out.print(solution);
            }

            out.println();
        }
        out.flush();
    }

    private static int solve(String s, int k) {
        int flips = 0;

        int slen = s.length();
        BitSet bitSet = asBitSet(s);

        while (slen > 0) {
            // remove what's already happy
            int firstClearBit = bitSet.nextClearBit(0);
            if (firstClearBit > 0) {
                bitSet = bitSet.get(firstClearBit, slen);
                slen -= firstClearBit;
            }

            // can still flip?
            if (slen == 0) {
                break;
            }
            if (slen < k) {
                // impossibru
                return -1;
            }
            // flip
            bitSet.flip(0, k);
            flips++;
        }

        return flips;
    }

    private static BitSet asBitSet(String s) {
        int slen = s.length();
        BitSet bitSet = new BitSet(slen);

        for (int i = 0; i < slen; i++) {
            bitSet.set(i, happy(s.charAt(i)));
        }

        return bitSet;
    }

    private static boolean happy(char pancake) {
        return pancake == HAPPY;
    }

}
