import java.util.*;

public class DeceitfulWar {

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        String line0 = scanner.nextLine();
        int T = Integer.parseInt(line0.trim());
        for (int i = 1; i <= T; i++) {
            int N = scanner.nextInt();
            Double[] Na = new Double[N];
            Double[] K = new Double[N];
            for (int j = 0; j < N; j++) {
                Na[j] = scanner.nextDouble();
            }
            for (int j = 0; j < N; j++) {
                K[j] = scanner.nextDouble();
            }
            Result result = getGameResult(N, Na, K);
            System.out.println("Case #" + i + ": " + result.deceitfulWar + " " + result.war);
        }
    }

    public static Result getGameResult(int N, Double[] Na, Double[] K) {
        Result result = new Result();

        LinkedList<Double> naomi = new LinkedList<Double>(Arrays.asList(Na));
        LinkedList<Double> ken = new LinkedList<Double>(Arrays.asList(K));
        Collections.sort(naomi);
        Collections.sort(ken);

        while (!naomi.isEmpty()) {
            if (naomi.getLast() < ken.getLast()) {
                naomi.removeFirst();
                ken.removeLast();
                continue;
            }
            if (naomi.getFirst() < ken.getFirst()) {
                naomi.removeFirst();
                ken.removeLast();
                continue;
            }

            result.deceitfulWar++;
            naomi.removeFirst();
            ken.removeFirst();
        }

        naomi = new LinkedList<Double>(Arrays.asList(Na));
        ken = new LinkedList<Double>(Arrays.asList(K));
        Collections.sort(naomi);
        Collections.sort(ken);

        while (!naomi.isEmpty()) {
            Double val = naomi.getFirst();
            int index = -1;
            for (int i = 0; i < ken.size(); i++) {
                if (ken.get(i) > val) {
                    index = i;
                    break;
                }
            }
            if (index > -1) {
                naomi.removeFirst();
                ken.remove(index);
            } else {
                naomi.removeFirst();
                ken.removeFirst();
                result.war++;
            }
        }
        return result;
    }

    public static class Result {
        int war;
        int deceitfulWar;

        public Result() {}

        public Result(int deceitfulWar, int war) {
            this.deceitfulWar = deceitfulWar;
            this.war = war;
        }

        @Override
        public boolean equals(Object o) {
            if (o instanceof Result) {
                return war == ((Result) o).war
                        && deceitfulWar == ((Result) o).deceitfulWar;
            }
            return false;
        }

        @Override
        public String toString() {
            return "Result{" +
                    "war=" + war +
                    ", deceitfulWar=" + deceitfulWar +
                    '}';
        }
    }
}
