import java.io.BufferedWriter;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.BitSet;
import java.util.List;

/**
 * Created by duche on 4/7/2017.
 */
public class PancakeFlipper {
    public static void main(String[] args) throws Exception {
        String filename = "A-small-attempt0";
        List<String> lines = Files.readAllLines(Paths.get("resources/"+filename+".in"));
        try (BufferedWriter bw = Files.newBufferedWriter(Paths.get("output/"+filename+".out"))) {
            PrintWriter out = new PrintWriter(bw);
            int count = Integer.parseInt(lines.get(0));
            for (int i=1; i<=count; i++) {
                String[] params = lines.get(i).split(" ");
                BitSet input = parseInput(params[0]);
                int numPancakes = params[0].length();
                int flipperSize = Integer.parseInt(params[1]);
                int result = calculateResult(input, numPancakes, flipperSize);
                String output = String.format("Case #%d: %s", i, (result == -1) ? "IMPOSSIBLE" : Integer.toString(result));
                System.out.println(output);
                out.println(output);
            }
        }
    }

    private static BitSet parseInput(String line) {
        BitSet bs = new BitSet(line.length());
        for (int i=0; i<line.length(); i++) {
            if (line.charAt(i) == '+') bs.set(i);
        }
        return bs;
    }

    private static int calculateResult(BitSet input, int numPancakes, int flipperSize) {
        int i = input.nextClearBit(0);
        int flips = 0;
        while (i <= numPancakes - flipperSize) {
            flips++;
            input.flip(i, i+flipperSize);
            i = input.nextClearBit(i);
        }
        return (i == numPancakes) ? flips : -1;
    }
}
