import java.io.BufferedWriter;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.BitSet;
import java.util.List;

public class TidyNumbers {
    public static void main(String[] args) throws Exception {
        String filename = "B-large";
        List<String> lines = Files.readAllLines(Paths.get("tidy/"+filename+".in"));
        try (BufferedWriter bw = Files.newBufferedWriter(Paths.get("tidy/"+filename+".out"))) {
            PrintWriter out = new PrintWriter(bw);
            int count = Integer.parseInt(lines.get(0));
            for (int i=1; i<=count; i++) {
                String line = lines.get(i);
                String result = calculateResult(line);
                String output = String.format("Case #%d: %s", i, result);
                System.out.println(output);
                out.println(output);
            }
        }
    }

    private static String calculateResult(String input) {
        StringBuilder sb = new StringBuilder();
        boolean nines = false;
        for (int i=0; i<input.length(); i++) {
            if (nines) {
                sb.append('9');
            } else if (i == input.length()-1 || input.charAt(i) <= input.charAt(i+1)) {
                sb.append(input.charAt(i));
            } else {
                while (i > 0 && input.charAt(i) == input.charAt(i-1)) {
                    i--;
                    sb.deleteCharAt(i);
                }
                sb.append((char) (input.charAt(i) - 1));
                nines = true;
            }
        }
        if (sb.charAt(0) == '0') {
            sb.deleteCharAt(0);
        }
        return sb.toString();
    }
}
