import java.io.BufferedWriter;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class BathroomLong {
    public static void main(String[] args) throws Exception {
        String filename = "C-small-1-attempt1";
//        String filename = "test";
        List<String> lines = Files.readAllLines(Paths.get("bath/"+filename+".in"));
        try (BufferedWriter bw = Files.newBufferedWriter(Paths.get("bath/"+filename+".out"))) {
            PrintWriter out = new PrintWriter(bw);
            int count = Integer.parseInt(lines.get(0));
            for (int i=1; i<=count; i++) {
                String[] params = lines.get(i).split(" ");
                long numStalls = Long.parseLong(params[0]);
                long numPeople = Long.parseLong(params[1]);
                String result = calculateResult(numStalls, numPeople);
                String output = String.format("Case #%d: %s", i, result);
                System.out.println(output);
                out.println(output);
            }
        }
    }

    private static String calculateResult(long numStalls, long numPeople) {
        if (numStalls == numPeople) {
            return "0 0";
        }

        TreeMap<Long, Long> segments = new TreeMap<>();
        segments.put(numStalls, 1L);
        for (long i = 0; i < numPeople - 1; i++) {
            if (segments.isEmpty()) {
                return "1 0";
            }
            Long len = segments.lastKey();
            Long count = getAndDecrement(len, segments);
            len--;
            long split = len / 2;
            if (split >= 1) {
                increment(split, segments);
                if (split * 2 < len) {
                    increment(split + 1, segments);
                } else {
                    increment(split, segments);
                }
            }
        }
        long len = segments.lastKey() - 1;
        long right = len / 2;
        long left = right + len % 2;
        return "" + left + " " + right;
    }

    private static Long getAndDecrement(Long key, Map<Long, Long> map) {
        Long v = map.get(key);
        if (v > 1) {
            map.put(key, v - 1);
        } else {
            map.remove(key);
        }
        return v;
    }

    private static void increment(Long key, Map<Long, Long> map) {
        Long v = map.getOrDefault(key, 0L);
        map.put(key, v + 1);
    }
}
