package dev.code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class LawnMower {

	private void process(String fileName) throws Exception {

		FileInputStream fis = new FileInputStream(new File(fileName));
		BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
		String line = bis.readLine();
		int nrOfCases = Integer.parseInt(line);
		FileOutputStream fos = new FileOutputStream("output/dataB.out");
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
		StringBuffer sb = new StringBuffer();

		for (int i = 0; i < nrOfCases; i++) {

			String areaSize = bis.readLine();
			String[] areaInfo = areaSize.split("\\s+");
			int n = Integer.parseInt(areaInfo[0]);
			int m = Integer.parseInt(areaInfo[1]);

			String[] rows = new String[n];
			for (int k = 0; k < n; k++) {
				String row = bis.readLine();
				row = row.replace(" ", "");
				rows[k] = row;
			}

			if (n == 1 || m == 1) {
				sb.append("Case #").append(i + 1).append(": ").append("YES").append("\r\n");
				continue;
			}

			boolean isAvailable = true;
			for (int j = 1; j < n; j++) {
				for (int k = 1; k < m; k++) {

					// if upper and left cells different than the current cell
					if (isAvailable) {
						if (rows[j].charAt(k) < rows[j - 1].charAt(k)
								&& rows[j].charAt(k) < rows[j].charAt(k - 1)) {
							isAvailable = false;
							break;
						}
						
						else if (rows[j].charAt(k) < rows[j - 1].charAt(k)) {
							//in this case the element must be the max from the row
							char max = rows[j].charAt(k);
							for (int r=0;r<m;r++){
								if (rows[j].charAt(r)>max){
									isAvailable = false;
									break;
								}
							}
						}
						else if (rows[j].charAt(k) < rows[j].charAt(k - 1)) {
							//in this case the element must be the max from the row
							char max = rows[j].charAt(k);
							for (int r=0;r<n;r++){
								if (rows[r].charAt(k)>max){
									isAvailable = false;
									break;
								}
							}
						}
					}
				}
			}

			
			if (isAvailable) {
				sb.append("Case #").append(i + 1).append(": ").append("YES").append("\r\n");
			}else
			{
				sb.append("Case #").append(i + 1).append(": ").append("NO").append("\r\n");
			}

			for (int j = 0; j < rows.length; j++) {
				System.out.println(rows[j]);
			}

		}
		
		System.out.println("Writing to file:"+sb.toString());
		bw.write(sb.toString());
		bw.close();
		fos.close();

	}

	public static void main(String[] args) throws Exception {

		LawnMower lm = new LawnMower();
		lm.process("input/B-small-attempt0.in");
	}
}
