package dev.code.jam.season15;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.StringTokenizer;

public class Dijkstra {

	
	public void processFile(String fileName){
		try {
			FileInputStream fis = new FileInputStream(new File(fileName));
			BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
			String line = bis.readLine();
			int nrOfCases = Integer.parseInt(line);

			FileOutputStream fos = new FileOutputStream(
					"output/2015/C-small.out");
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
			StringBuffer sb = new StringBuffer();

			for (int i = 0; i < nrOfCases; i++) {
				String input = bis.readLine();
				String[] split = input.split("\\s");
				String sequence = bis.readLine();
				String isPossible = isIJK(Long.parseLong(split[0]), Long.parseLong(split[1]),sequence);
					sb.append("Case #").append(i + 1).append(": ")
							.append(isPossible).append("\r\n");

			}

			System.out.println("Writing to file:\r\n" + sb.toString());
			bw.write(sb.toString());
			bw.close();
			fos.close();
			bis.close();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private String isIJK(long l, long x, String sequence) {
		
		
		//compute intial sequence value
		String[] sequenceValues = sequence.split("");
		String initialValue = "1";
		for (String s : sequenceValues) {
			initialValue = computeTwoInputs(initialValue, s);
			
		}
//		System.out.println("Initial value is " + initialValue);
		
		//find sequences
		String iValue = "1";
		String jValue = "1";
		String kValue = "1";
		StringBuffer sb = new StringBuffer();
		for (int i = 0; i < x; i++) {
			
			if (!"i".equals(iValue) || !"j".equals(jValue)){
				for (String s : sequenceValues) {
					if (!"i".equals(iValue)){
						iValue = computeTwoInputs(iValue, s);
					} else if (!"j".equals(jValue)){
						jValue = computeTwoInputs(jValue, s);
					} else {
						sb.append(s+" ");
					}
				}
			} else {
				sb.append(initialValue +" ");
			}
		}
		
		//calculate k value
		String sequenceForKValue = sb.toString();
		if (sequenceForKValue != null){
			String[] sequencesForK = sequenceForKValue.split("\\s");
			for (String kV : sequencesForK) {
				kValue = computeTwoInputs(kValue, kV);
			}
		}
		
		if (!"k".equals(kValue)){
			return "NO";
		} else {
			return "YES";
		}
	}
	
	private String computeTwoInputs(String a, String b) {

		String result = "";
		int minusCount = 0;
		if (a.startsWith("-")){
			minusCount ++;
			a = a.substring(1);
		}
		if (b.startsWith("-")){
			minusCount ++;
			b = b.substring(1);
		}
		if ("1".equals(a) && "1".equals(b)) {
			result = "1";
		} else if (("1".equals(a) && "i".equals(b)) || ("1".equals(b) && "i".equals(a))) {
			result = "i";
		} else if (("1".equals(a) && "j".equals(b)) || ("1".equals(b) && "j".equals(a))) {
			result = "j";
		} else if (("1".equals(a) && "k".equals(b)) || ("1".equals(b) && "k".equals(a))) {
			result = "k";
		} else if (("i".equals(a) && "i".equals(b))) {
			result = "-1";
		} else if ("i".equals(a) && "j".equals(b)) {
			result = "k";
		} else if ("j".equals(a) && "i".equals(b)) {
			result = "-k";
		} else if ("i".equals(a) && "k".equals(b)) {
			result = "-j";
		} else if ("k".equals(a) && "i".equals(b)) {
			result = "j";
		} else if (("j".equals(a) && "j".equals(b))) {
			result = "-1";
		} else if ("j".equals(a) && "k".equals(b)) {
			result = "i";
		} else if ("k".equals(a) && "j".equals(b)) {
			result = "-i";
		} else if ("k".equals(a) && "k".equals(b)) {
			result = "-1";
		}
		
		if (minusCount %2 == 0){
			return result;
		} else if (result.startsWith("-")){
			return result.substring(1);
		} else {
			return "-"+result;
		}
		
	}
	
	private char computeTwoInputs(char a, char b) {

		if (a == '1' && b == '1') {
			return '1';
		} else if ((a == '1' && b == 'i') || (b == '1' && a == 'i')) {
			return 'i';
		} else if ((a == '1' && b == 'j') || (b == '1' && a == 'j')) {
			return 'j';
		} else if ((a == '1' && b == 'k') || (b == '1' && a == 'k')) {
			return 'k';
		} else if (a == 'i' && b == 'i') {
			return '1';
		} else if ((a == 'i' && b == 'j') || (b == 'i' && a == 'j')) {
			return 'k';
		} else if ((a == 'i' && b == 'k') || (b == 'i' && a == 'k')) {
			return 'j';
		} else if (a == 'j' && b == 'j') {
			return '1';
		} else if ((a == 'j' && b == 'k') || (b == 'j' && a == 'k')) {
			return 'i';
		}else if (a == 'k' && b == 'k') {
			return '1';
		} else return 'x';
	}
	public static void main(String[] args) {
		Dijkstra dj = new Dijkstra();
		dj.processFile(args[0]);
	}
}
