package dev.code.jam.c1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class PartElf {

	public void process(String fileName) {
		try {
			FileInputStream fis = new FileInputStream(new File(fileName));
			BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
			String line = bis.readLine();
			int nrOfCases = Integer.parseInt(line);

			FileOutputStream fos = new FileOutputStream(
					"output/A-large.out");
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
			StringBuffer sb = new StringBuffer();

			for (int i = 0; i < nrOfCases; i++) {
				String input = bis.readLine();

				int checkAncestor = checkAncestor(input);
				if (checkAncestor != -1) {
					sb.append("Case #").append(i + 1).append(": ")
							.append(checkAncestor).append("\r\n");
				} else {
					sb.append("Case #").append(i + 1).append(": ")
							.append("impossible").append("\r\n");
				}

			}

			System.out.println("Writing to file:\r\n" + sb.toString());
			bw.write(sb.toString());
			bw.close();
			fos.close();
			bis.close();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private int checkAncestor(String input) {

		String[] value = input.split("/");
		long v1 = Long.parseLong(value[0]);
		long v2 = Long.parseLong(value[1]);
		if ((v2 & (-v2)) != v2 && (v2 % v1) != 0) {
			return -1;
		} else if ((v2 & (-v2)) != v2 && (v2 % v1) == 0) {
			long findGCD = findGCD(v1, v2);
			long newV2 = v2 / findGCD;
			long newV1 = v1 / findGCD;
			if ((newV2 & (-newV2)) != newV2) {
				return -1;
			} else {
				// check if newV1 can be written as a number of power 2
				boolean checkSum = checkSumPow2(newV1);
				if (!checkSum) {
					return -1;
				} else {
					return getPower(newV2);
				}
			}
		} else if ((v2 & (-v2)) == v2 && (v2 % v1) != 0) {
			int powerV1 = getPower(v1);
			int powerV2 = getPower(v2);
			return Math.abs(powerV2 - powerV1);

		} else if ((v2 & (-v2)) == v2 && (v2 % v1) == 0) {
			int powerV1 = getPower(v1);
			int powerV2 = getPower(v2);
			return Math.abs(powerV2 - powerV1);
		} else {
			return -1;
		}

	}

	private boolean checkSumPow2(long newV1) {
		long pow = 1;
		boolean isPowCheckSum = false;
		while (pow != 0) {
			if ((newV1 & pow) != 0) {
				isPowCheckSum = true;
			}
			pow = pow <<= 1;
		}
		return isPowCheckSum;
	}

	private int getPower(long newV2) {
		long pow = 1;
		int p = -1;
		int intP = 0;
		while (pow != 0) {
			if ((newV2 & pow) != 0) {
				p = intP;
			}
			pow = pow <<= 1;
			intP++;
		}
		return p;
	}

	public long findGCD(long v1, long v2) {
		while (v2 > 0) {
			long temp = v2;
			v2 = v1 % v2;
			v1 = temp;
		}
		return v1;
	}

	public static void main(String[] args) {

		PartElf pe = new PartElf();
		pe.process("input/A-large.in");
	}
}
