package dev.code.jam.season16.qualifications;

import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CoinJam {
    public void process(String fileName, String outputFile) throws IOException {
        FileInputStream fis = new FileInputStream(new File(fileName));
        BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
        long nrOfCases = Long.parseLong(bis.readLine());
        FileOutputStream fos = new FileOutputStream(outputFile);
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < nrOfCases; i++) {

            sb.append("Case #").append(i + 1).append(": ").append("\r\n");
            String line = bis.readLine();

            if (line != null) {
                Map<String, List<Long>> result = processCase(line);
                if (result.size() > 0) {
                    for (Map.Entry<String, List<Long>> r : result.entrySet()) {
                        sb.append(r.getKey()).append(" ");
                        List<Long> values = r.getValue();
                        if (values != null) {
                            for (Long value : values) {
                                sb.append(value).append(" ");
                            }
                        }

                        sb.append("\r\n");
                    }
                }
            }

            System.out.println("Writing to file:");
            System.out.println(sb.toString());
            bw.write(sb.toString());
            bw.close();
            fos.close();
        }
    }

    private Map<String, List<Long>> processCase(String line) {
        Map<String, List<Long>> result = new HashMap<String, List<Long>>();
        String[] split = line.split("\\s");
        int n = Integer.valueOf(split[0]);
        int j = Integer.valueOf(split[1]);

        List<String> inputResults = new ArrayList<String>();
        long startNumber = (long) (Math.pow(2, n - 1) + 1); // 10000000....1
        long endNumber = (long) Math.pow(2, n);
        for (long i = startNumber; i < endNumber; i += 2) {
            List<Long> divisors = new ArrayList<Long>();
            String valueInBase2 = Long.toString(i, 2);

            for (int k = 2; k <= 10; k++) {
                BigInteger valueInBase = new BigInteger(Long.toString(i, 2), k);
                long divisor = checkDivisor(valueInBase);
                if (divisor == -1) {
                    break;
                } else {
                    divisors.add(divisor);
                }
            }
            if (divisors.size() == 9) {
                result.put(valueInBase2, divisors);
            }

            if (result.size() == j) {
                break;
            }
        }
        return result;
    }

    private long checkDivisor(long valueInBase) {
        if (valueInBase % 2 == 0) {
            return 2;
        }
        for (long i = 3; i <= Math.sqrt(valueInBase); i += 2) {
            if (valueInBase % i == 0) {
                return i;
            }
        }
        return -1;
    }

    private long checkDivisor(BigInteger valueInBase) {
        if (valueInBase.doubleValue() % 2 == 0) {
            return 2;
        }
        for (long i = 3; i <= Math.sqrt(valueInBase.doubleValue()); i += 2) {
            if (valueInBase.doubleValue() % i == 0) {
                return i;
            }
        }
        return -1;
    }

    public static void main(String[] args) throws IOException {
        CoinJam cj = new CoinJam();
        cj.process("input/2016/coinjam/inputLarge.in", "output/2016/coinjam/outputLarge.out");
    }
}
