package dev.code.jam.season17.qualification;

import javafx.beans.binding.StringBinding;

import java.io.*;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by adriang on 4/8/2017.
 */
public class TidyNumbers {


    private static Map<Character, Character> prevFigures = new HashMap<Character, Character>();

    static {
        prevFigures.put('0', '9');
        prevFigures.put('1', '0');
        prevFigures.put('2', '1');
        prevFigures.put('3', '2');
        prevFigures.put('4', '3');
        prevFigures.put('5', '4');
        prevFigures.put('6', '5');
        prevFigures.put('7', '6');
        prevFigures.put('8', '7');
        prevFigures.put('9', '8');

    }

    public void process(String fileName) {
        try {
            FileInputStream fis = new FileInputStream(new File(fileName));
            BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
            String line = bis.readLine();
            int nrOfCases = Integer.parseInt(line);

            FileOutputStream fos = new FileOutputStream("output/2017/tidyNumbers/B-large.out");
            BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
            StringBuffer sb = new StringBuffer();

            for (int i = 0; i < nrOfCases; i++) {
                String readLine = bis.readLine();
                String tidyNumber = findTidyNumber(readLine);
                sb.append("Case #").append(i + 1).append(": ")
                        .append(tidyNumber).append("\r\n");

            }

            System.out.println("Writing to file:\r\n" + sb.toString());
            bw.write(sb.toString());
            bw.close();
            fos.close();
            bis.close();
        } catch (NumberFormatException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }


    private String findTidyNumber(String input) {

        StringBuffer tidyNumber = new StringBuffer();
        char[] figures = input.toCharArray();

        for (int i = figures.length - 1; i > 0; i--) {
            char figure = figures[i];
            if (figure >= figures[i - 1]) {
                tidyNumber.append(figure);
            } else {
                tidyNumber.append('9');
                replacePreviousValues(tidyNumber);
                figures[i-1] = prevFigures.get(figures[i-1]);
            }
        }

        if (figures[0] > '0'){
            tidyNumber.append(figures[0]);
        }

        return tidyNumber.reverse().toString();


    }

    private void replacePreviousValues(StringBuffer tidyNumber) {
        for (int i = 0; i < tidyNumber.length(); i++) {
             tidyNumber.replace(i, i+1,"9");

        }
    }

    public static void main(String[] args) throws Exception {

        if (args == null || args.length != 1) {
            System.out.println("Input file argument needed");
            return;
        }

        TidyNumbers sc = new TidyNumbers();
        sc.process(args[0]);
    }
}
