package dev.code.jam.season15;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

public class HouseOfPancakes {

	public void processFiile(String fileName) {
		try {
			FileInputStream fis = new FileInputStream(new File(fileName));
			BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
			String line = bis.readLine();
			int nrOfCases = Integer.parseInt(line);

			FileOutputStream fos = new FileOutputStream("output/2015/B-small.out");
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
			StringBuffer sb = new StringBuffer();

			for (int i = 0; i < nrOfCases; i++) {
				String numberOfPlates = bis.readLine();

				String input = bis.readLine();
				long numberOfMinutes = findNumberOfMinutes(input);
				sb.append("Case #").append(i + 1).append(": ").append(numberOfMinutes).append("\r\n");

			}

			System.out.println("Writing to file:\r\n" + sb.toString());
			bw.write(sb.toString());
			bw.close();
			fos.close();
			bis.close();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private long findNumberOfMinutes(String input) {

		String[] plates = input.split("\\s");
		List<Long> platesWithPancakesSimple = new ArrayList<Long>();
		for (String plate : plates) {
			platesWithPancakesSimple.add(Long.valueOf(plate));
		}

		long buff = max(platesWithPancakesSimple);
		long minTime = max(platesWithPancakesSimple);
		long max = minTime;
		
		long count = countPancakes(platesWithPancakesSimple);
		long newTime = 0;
		long numberOfMoves = 0;
		for (int i = 0; i < count; i++){
			long numberOfMax = numberOfMax(platesWithPancakesSimple, max);
			
			normalizePlates(platesWithPancakesSimple, max);
			long newMax = max(platesWithPancakesSimple);
			newTime = numberOfMax + newMax + numberOfMoves;
			if (newTime < minTime){
				minTime = newTime;
			}
			max = newMax;
			numberOfMoves += numberOfMax;
		}
		
		numberOfMoves = 0;
		max = buff;
		
		List<Long> platesWithPancakesSqrt = new ArrayList<Long>();
		for (String plate : plates) {
			platesWithPancakesSqrt.add(Long.valueOf(plate));
		}
		for (int i = 0; i < count; i++){
			long numberOfMax = numberOfMax(platesWithPancakesSqrt, max);
			
			normalizePlatesWithSQRT(platesWithPancakesSqrt, max);
			long newMax = max(platesWithPancakesSqrt);
			newTime = numberOfMax + newMax + numberOfMoves;
			
			if (newTime < minTime){
				minTime = newTime;
			}
			max = newMax;
			numberOfMoves += numberOfMax;
		}
		

		return minTime;
	}

	private long countPancakes(List<Long> platesWithPancakes) {
		
		long sum = 0;
		for (Long pancake : platesWithPancakes) {
			sum += pancake;
		}
		
		return sum;
	}

	private long max(List<Long> platesWithPancakes) {
		
		long max = 0;
		
		for (Long plate : platesWithPancakes) {
			if (plate > max){
				max = plate;
			}
		}
		return max;
	}
	
	private long numberOfMax(List<Long> platesWithPancakes, long max) {
		
		long countMax = 0;
		for (Long plate : platesWithPancakes) {
			if (plate == max){
				countMax ++;
			}
		}
		return countMax;
	}
	
	private void normalizePlates(List<Long> platesWithPancakes, long max) {
		
		int initialSize = platesWithPancakes.size();
		for (int i = 0; i < platesWithPancakes.size(); i++) {
			if (platesWithPancakes.get(i).equals(max)){
				long oldValue = platesWithPancakes.get(i);
				platesWithPancakes.set(i, split(oldValue));
				platesWithPancakes.add(oldValue - platesWithPancakes.get(i));
			}
			if (i >= initialSize){
				break;
			}
		}
	}
	
	private void normalizePlatesWithSQRT(List<Long> platesWithPancakes, long max) {
		
		int initialSize = platesWithPancakes.size();
		for (int i = 0; i < platesWithPancakes.size(); i++) {
			if (platesWithPancakes.get(i).equals(max)){
				long oldValue = platesWithPancakes.get(i);
				platesWithPancakes.set(i, splitWithSQRT(oldValue));
				platesWithPancakes.add(oldValue - platesWithPancakes.get(i));
			}
			if (i >= initialSize){
				break;
			}
		}
	}

	private Long split(Long v) {
		if (v % 2 == 1){
			return v / 2 + 1;
		} else {
			return v / 2;
		}
	}
	
	private Long splitWithSQRT(Long v) {
		if (v % Math.sqrt(v) != 0){
			return (long) (v / Math.sqrt(v) + 1);
		} else {
			return (long) (v / Math.sqrt(v));
		}
	}
	
	public static void main(String[] args) {
		HouseOfPancakes hop = new HouseOfPancakes();
		if (args.length != 1){
			System.out.println("Please provide the input file");
		} else {
			hop.processFiile(args[0]);
		}
	}
}
