package dev.code.jam.season14;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class DeceitfulWar {

	public Integer winFair(String input1, String input2) {
		String[] weights1 = input1.split("\\s");
		List<Double> dWeights1 = new ArrayList<Double>();
		for (String w1 : weights1) {
			dWeights1.add(Double.parseDouble(w1));
		}

		String[] weights2 = input2.split("\\s");
		List<Double> dWeights2 = new ArrayList<Double>();
		for (String w2 : weights2) {
			dWeights2.add(Double.parseDouble(w2));
		}
		Collections.sort(dWeights1, Collections.reverseOrder());
		Collections.sort(dWeights2, Collections.reverseOrder());

		int countWin = 0;
		while (dWeights1.size()>0){
			if (dWeights1.get(0) > dWeights2.get(0)) {
				dWeights1.remove(0);
				dWeights2.remove(dWeights2.size() - 1);
				countWin++;
			} else {
				dWeights1.remove(0);
				dWeights2.remove(0);
			}
		}
		return countWin;
	}
	
	public Integer winUnfair(String input1, String input2) {
		String[] weights1 = input1.split("\\s");
		List<Double> dWeights1 = new ArrayList<Double>();
		for (String w1 : weights1) {
			dWeights1.add(Double.parseDouble(w1));
		}

		String[] weights2 = input2.split("\\s");
		List<Double> dWeights2 = new ArrayList<Double>();
		for (String w2 : weights2) {
			dWeights2.add(Double.parseDouble(w2));
		}
		Collections.sort(dWeights1);
		Collections.sort(dWeights2);

		int countWin = 0;
		while (dWeights1.size()>0){
			if (dWeights1.get(0) < dWeights2.get(0)) {
				dWeights1.remove(0);
				dWeights2.remove(dWeights2.size() - 1);
			} else {
				dWeights1.remove(0);
				dWeights2.remove(0);
				countWin++;
			}
		}
		return countWin;
	}

	public void process(String fileName) {
		try {
			FileInputStream fis = new FileInputStream(new File(fileName));
			BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
			String line = bis.readLine();
			int nrOfCases = Integer.parseInt(line);

			FileOutputStream fos = new FileOutputStream("output/D-large.out");
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
			StringBuffer sb = new StringBuffer();

			for (int i = 0; i < nrOfCases; i++) {
				bis.readLine();
				String readLine1 = bis.readLine();
				String readLine2 = bis.readLine();
				sb.append("Case #").append(i + 1).append(": ").append(winUnfair(readLine1, readLine2)).append(" ")
						.append(winFair(readLine1, readLine2)).append("\r\n");
			}

			System.out.println("Writing to file:\r\n" + sb.toString());
			bw.write(sb.toString());
			bw.close();
			fos.close();
			bis.close();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		DeceitfulWar dw = new DeceitfulWar();
		dw.process("input/D-large.in");
	}
}
