package dev.code.jam.season14;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class MinesweeperMaster {

	public boolean isValidMinesweeper(int rowsNumber, int columnsNumber,
			int minesNumber) {

		int validPositions = rowsNumber * columnsNumber - minesNumber;
		if (rowsNumber == 1 || columnsNumber == 1) {
			if (minesNumber < rowsNumber * columnsNumber) {
				return true;
			} else {
				return false;
			}
		} else if (rowsNumber == 2 || columnsNumber == 2) {
			if (validPositions % 2 == 1 || validPositions == 2) {
				return false;
			} else {
				return true;
			}
		} else {
			
			if (validPositions == 2 || validPositions == 3
					|| validPositions == 5 || minesNumber == 7) {
				return false;
			}
		}

		return true;
	}

	public String createMatrix(int rowsNumber, int columnsNumber,
			int minesNumber) {

		char[][] matrix = new char[rowsNumber][columnsNumber];

		for (int i = 0; i < rowsNumber; i++) {
			for (int j = 0; j < columnsNumber; j++) {
				matrix[i][j] = '.';
			}
		}
		boolean isPossible = true;
		boolean addedClick = false;
		if (rowsNumber > 2 && columnsNumber > 2) {
			for (int i = 0; i < rowsNumber - 2; i++) {
				for (int j = 0; j < columnsNumber - 2; j++) {
					if (minesNumber > 0) {
						matrix[i][j] = '*';
						minesNumber--;
					} else {
						matrix[i + 1][j + 2] = 'c';
						addedClick = true;
						i = rowsNumber;
						j = columnsNumber;

					}
				}
			}
			if (minesNumber > 0) {
				if (minesNumber % 2 == 1) {
					isPossible = false;
				} else {
					for (int i = 0; i < rowsNumber-2; i++) {
						for (int j = columnsNumber - 2; j < columnsNumber; j++) {
							if (minesNumber > 0) {
								matrix[i][j] = '*';
								minesNumber--;
							} else {
								matrix[rowsNumber - 1][columnsNumber - 1] = 'c';
								addedClick = true;
								i = rowsNumber;
								j = columnsNumber;
							}
						}
					}
					if (minesNumber > 0) {
						for (int j = 0; j < columnsNumber-2; j++) {
							for (int i = rowsNumber - 2; i < rowsNumber; i++) {

								if (minesNumber > 0) {
									matrix[i][j] = '*';
									minesNumber--;
								} else {
									matrix[rowsNumber - 1][columnsNumber - 1] = 'c';
									addedClick = true;
									i = rowsNumber;
									j = columnsNumber;
								}
							}
						}
					}
				}
				
			}
			if (!addedClick){
				matrix[rowsNumber - 1][columnsNumber-1] = 'c';
			}
		} else {
			if (columnsNumber <= 2){
			for (int i = 0; i < rowsNumber; i++) {
				for (int j = 0; j < columnsNumber; j++) {
					if (minesNumber > 0) {
						matrix[i][j] = '*';
						minesNumber--;
					} else {
						matrix[rowsNumber - 1][columnsNumber - 1] = 'c';
					}
				}
			}
			}else if (rowsNumber <= 2){
				for (int j = 0; j < columnsNumber; j++) {
					for (int i = 0; i < rowsNumber; i++) {
						if (minesNumber > 0) {
							matrix[i][j] = '*';
							minesNumber--;
						} else {
							matrix[rowsNumber - 1][columnsNumber - 1] = 'c';
						}
					}
				}
			}
		}

		StringBuffer sb = new StringBuffer();
		if (isPossible) {
			for (int i = 0; i < rowsNumber; i++) {
				for (int j = 0; j < columnsNumber; j++) {
					sb.append(matrix[i][j]);
				}
				sb.append("\r\n");
			}
		} else {
			sb.append("Impossible").append("\r\n");
		}

		return sb.toString();
	}

	public void process(String fileName) {
		try {
			FileInputStream fis = new FileInputStream(new File(fileName));
			BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
			String line = bis.readLine();
			int nrOfCases = Integer.parseInt(line);

			FileOutputStream fos = new FileOutputStream("output/C-small-attempt1.out");
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
			StringBuffer sb = new StringBuffer();

			for (int i = 0; i < nrOfCases; i++) {
				String readLine = bis.readLine();
				String[] values = readLine.split("\\s");
				int rowsNumber = Integer.parseInt(values[0]);
				int columnsNumber = Integer.parseInt(values[1]);
				int minesNumber = Integer.parseInt(values[2]);
				sb.append("Case #").append(i + 1).append(": ").append("\r\n");
				boolean isValid = isValidMinesweeper(rowsNumber, columnsNumber,
						minesNumber);
				if (!isValid) {
					sb.append("Impossible").append("\r\n");
				} else {
					sb.append(createMatrix(rowsNumber, columnsNumber,
							minesNumber));
				}
			}

			System.out.println("Writing to file:\r\n" + sb.toString());
			bw.write(sb.toString());
			bw.close();
			fos.close();
			bis.close();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		MinesweeperMaster mm = new MinesweeperMaster();
		mm.process("input/C-small-attempt1.in");
	}
}
