package dev.code.jam.season16.qualifications;

import java.io.*;
import java.util.HashSet;
import java.util.List;
import java.util.Set;


public class CountingSheep {


    public void process(String fileName, String outputFile) throws IOException {
        FileInputStream fis = new FileInputStream(new File(fileName));
        BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
        long nrOfCases = Long.parseLong(bis.readLine());
        FileOutputStream fos = new FileOutputStream(outputFile);
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < nrOfCases; i++) {

            sb.append("Case #").append(i + 1).append(": ");
            String line = bis.readLine();

            if (line != null) {
                long result = processCase(line);
                if (result >= 0) {
                    sb.append(result);
                } else {
                    sb.append("INSOMNIA");
                }
                sb.append("\r\n");
            }
        }

        System.out.println("Writing to file:" + sb.toString());
        bw.write(sb.toString());
        bw.close();
        fos.close();
    }

    private long processCase(String line) {
        Set<Character> allFigures = new HashSet<Character>();
        Long input = Long.valueOf(line);

        if (input == 0){
            return -1;
        }

        double limit = Math.pow(10, line.length() + 2) / input + 1;
        for (long i = 1; i < limit; i++) {
            long partialValue = input * i;
            Set<Character> figures = extractFigures(Long.toString(partialValue));
            allFigures.addAll(figures);
            if (allFigures.size() == 10){
                return partialValue;
            }
        }

        return -1;

    }

    private Set<Character> extractFigures(String line) {
        Set<Character> figures = new HashSet<Character>();
        for (Character singleChar : line.toCharArray()) {
            figures.add(singleChar);
        }
        return figures;
    }

    public static void main(String[] args) throws IOException {
        CountingSheep cp =  new CountingSheep();
        cp.process("input/2016/countingsheep/A-large.in", "output/2016/countingsheep/A-large.out");
    }
}
