package dev.code.jam.season16.qualifications;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class Fractiles {
    public void process(String fileName, String outputFile) throws IOException {
        FileInputStream fis = new FileInputStream(new File(fileName));
        BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
        long nrOfCases = Long.parseLong(bis.readLine());
        FileOutputStream fos = new FileOutputStream(outputFile);
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < nrOfCases; i++) {

            sb.append("Case #").append(i + 1).append(": ");
            String line = bis.readLine();

            if (line != null) {
                List<Long> result = processCase(line);
                if (result.size() > 0) {
                    for (Long r : result) {
                        sb.append(r).append(" ");
                    }
                } else {
                    sb.append("IMPOSSIBLE");
                }
                sb.append("\r\n");
            }
        }

        System.out.println("Writing to file:");
        System.out.println(sb.toString());
        bw.write(sb.toString());
        bw.close();
        fos.close();
    }

    private List<Long> processCase(String line) {
        List<Long> result = new ArrayList<Long>();
        String[] split = line.split("\\s");
        int k = Integer.valueOf(split[0]);
        int c = Integer.valueOf(split[1]);
        int s = Integer.valueOf(split[2]);
        if (s == k) {
            for (long i = 1; i <= s; i++) {
                result.add(i);
            }
        } else if (k == 1){
            result.add(1L);
        } else if (c == 1 && s < k) {
            return result; //empty result
        } else if (c == 1 && s >= k) {
            for (long i = 1; i <= k; i++) {
                result.add(i);
            }
        } else {
            for (long i = (k*(c-1)) - 1 ; i <= Math.pow(k, c); i+=(k+1)) {
                if (result.size() < s) {
                    result.add(i);
                } else {
                    break;
                }
            }
        }

        return result;
    }

    public static void main(String[] args) throws IOException {
        Fractiles fractiles =  new Fractiles();
        fractiles.process("input/2016/fractiles/D-large.in", "output/2016/fractiles/D-large.out");
    }
}
