package dev.code.jam.season17.qualification;

import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * Created by adriang on 4/8/2017.
 */
public class BathroomStalls {

    public void process(String fileName) {
        try {
            FileInputStream fis = new FileInputStream(new File(fileName));
            BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
            String line = bis.readLine();
            int nrOfCases = Integer.parseInt(line);

            FileOutputStream fos = new FileOutputStream("output/2017/bathroomstalls/C-small-1-attempt0.out");
            BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
            StringBuffer sb = new StringBuffer();

            for (int i = 0; i < nrOfCases; i++) {
                String readLine = bis.readLine();
                String solution = findSolution(readLine);
                sb.append("Case #").append(i + 1).append(": ")
                        .append(solution).append("\r\n");

            }

            System.out.println("Writing to file:\r\n" + sb.toString());
            bw.write(sb.toString());
            bw.close();
            fos.close();
            bis.close();
        } catch (NumberFormatException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (FileNotFoundException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    private String findSolution(String line) {

        List<Long> noStallsPerTreeLevels = new ArrayList<Long>();
        String[] inputValues = line.split("\\s");
        long noStalls = Long.parseLong(inputValues[0]);
        long noCustomers = Long.parseLong(inputValues[1]);
        noStallsPerTreeLevels.add(noStalls);
        long left = noStalls;
        long right = noStalls;
        for (int i = 0; i<noStallsPerTreeLevels.size(); i++) {
            Long noStallsPerLevel = noStallsPerTreeLevels.get(i);
            if (noCustomers > 0){
                long noStallsNotUsedPerLevel = noStallsPerLevel - 1;
                left = (noStallsNotUsedPerLevel / 2) + (noStallsNotUsedPerLevel % 2);
                right = (noStallsNotUsedPerLevel / 2);
                noStallsPerTreeLevels.add(left);
                noStallsPerTreeLevels.add(right);
                noCustomers --;
                noStallsPerTreeLevels.sort(Collections.<Long>reverseOrder());
            } else {
                break;
            }
        }
        return left + " " + right;

    }

    public static void main(String[] args) throws Exception {

        if (args == null || args.length != 1) {
            System.out.println("Input file argument needed");
            return;
        }

        BathroomStalls sc = new BathroomStalls();
        sc.process(args[0]);
    }
}
