package dev.code.jam.season15;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class StandingOvation {

	
	public void processFile(String fileName){
		try {
			FileInputStream fis = new FileInputStream(new File(fileName));
			BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
			String line = bis.readLine();
			int nrOfCases = Integer.parseInt(line);

			FileOutputStream fos = new FileOutputStream(
					"output/2015/A-large.out");
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
			StringBuffer sb = new StringBuffer();

			for (int i = 0; i < nrOfCases; i++) {
				String input = bis.readLine();

				int numberOfFriends = findNumberOfFriends(input);
					sb.append("Case #").append(i + 1).append(": ")
							.append(numberOfFriends).append("\r\n");

			}

			System.out.println("Writing to file:\r\n" + sb.toString());
			bw.write(sb.toString());
			bw.close();
			fos.close();
			bis.close();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private int findNumberOfFriends(String input) {
		
		int numberOfFriends = 0;

		String[] inputSplit = input.split("\\s");

		int maxShyness = Integer.parseInt(inputSplit[0]);
		String shyDistribution = inputSplit[1];

		int totalDistribution = 0;
		for (int i = 0; i < shyDistribution.length(); i++) {
			if (totalDistribution < i){
				numberOfFriends += (i - totalDistribution);
				totalDistribution += (i - totalDistribution);
			}
			totalDistribution += Integer.parseInt(String.valueOf(shyDistribution.charAt(i)));

		}

		return numberOfFriends;
	}
	
	public static void main(String[] args) {
		StandingOvation so = new StandingOvation();
		if (args.length != 1){
			System.out.println("Please provide the input file");
		} else {
			so.processFile(args[0]);
		}
	}
}
