package dev.code.jam.season16.qualifications;


import java.io.*;

public class PancakesRevenge {

    private static final String HAPPY_BLANK = "+-";
    private static final String BLANK_HAPPY = "-+";
    private static final String HAPPY = "+";
    private static final String BLANK = "-";

    public void process(String fileName, String outputFile) throws IOException {
        FileInputStream fis = new FileInputStream(new File(fileName));
        BufferedReader bis = new BufferedReader(new InputStreamReader(fis));
        long nrOfCases = Long.parseLong(bis.readLine());
        FileOutputStream fos = new FileOutputStream(outputFile);
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));
        StringBuffer sb = new StringBuffer();

        for (int i = 0; i < nrOfCases; i++) {

            sb.append("Case #").append(i + 1).append(": ");
            String line = bis.readLine();

            if (line != null) {
                long result = processCase(line);
                sb.append(result);
                sb.append("\r\n");
            }
        }

        System.out.println("Writing to file:");
        System.out.println(sb.toString());
        bw.write(sb.toString());
        bw.close();
        fos.close();
    }

    private long processCase(String line) {

        // particular cases
        if (line.length() == 1) {
            if ("-".equals(line)) {
                return 1;
            } else {
                return 0;
            }
        }

        if (!line.contains(HAPPY_BLANK) && !line.contains(BLANK_HAPPY)) {
            if (line.contains(BLANK)) {
                return 1;
            } else {
                return 0;
            }
        }

        //general case
        long happyBlankNumberOfChanges = countNumberOfSubstringOccurences(line, HAPPY_BLANK);
        long blankHappyNumberOfChanges = countNumberOfSubstringOccurences(line, BLANK_HAPPY);
        long result = happyBlankNumberOfChanges + blankHappyNumberOfChanges;

        if (line.lastIndexOf(HAPPY_BLANK) > line.lastIndexOf(BLANK_HAPPY)) {
            result = result + 1;
        }
        return result;


    }

    public long countNumberOfSubstringOccurences(String line, String delim) {

        int index = 0;
        int count = 0;
        while (index != -1) {
            index = line.indexOf(delim, index);
            if (index != -1) {
                index = index + delim.length();
                count++;
            }
        }
        return count;
    }

    public static void main(String[] args) throws IOException {
        PancakesRevenge pr = new PancakesRevenge();
        pr.process("input/2016/revengeofthepancakes/B-large.in", "output/2016/revengeofthepancakes/B-large.out");
    }
}
