/*
 * Main.java
 *
 * Created on 17 July 2008, 23:00
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package train;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Adrian
 */
public class Main {
    
    BufferedWriter writer;
    BufferedReader reader;

    /** Creates a new instance of Main */
    public Main(String[] args) {                
        try {
            writer = new BufferedWriter(new FileWriter(new File(args[1])));
            reader = new BufferedReader(new FileReader(new File(args[0])));
            doStuff();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {                
        new Main(args);
    }
    
        
    private void doStuff() throws IOException {                    
        int n = Integer.parseInt(reader.readLine());
        for ( int i = 1; i <= n; i++) {
            String str = processCase();
            writer.write("Case #" + i + ": " + str + "\n");
            System.out.print("Case #" + i + ": " + str + "\n");
            writer.flush();
        }
        writer.close();
    }

    private String processCase() throws IOException {
        initCase();
        doCase();
        return nTA + " " + nTB;
    }

    int turnAround, nA, nB, nTA, nTB;
    int[][] depA, depB;
    int DEPARTING = -1;
    int ARRIVING = +1;
    
    private void initCase() throws IOException {
        turnAround = Integer.parseInt(reader.readLine());
        String str[] = reader.readLine().split(" ");
        nA = Integer.parseInt(str[0]);
        nB = Integer.parseInt(str[1]);
        
        depA = new int[nA+nB][2];
        depB = new int[nA+nB][2];
        
        for ( int i = 0; i < nA; i++) {
            str = reader.readLine().split(" ");
            String[] minutes = str[0].split(":");
            depA[i][0] = Integer.parseInt(minutes[0])*60 + Integer.parseInt(minutes[1]);
            depA[i][1] = DEPARTING;
            minutes = str[1].split(":");
            depB[i][0] = Integer.parseInt(minutes[0])*60 + Integer.parseInt(minutes[1]) + turnAround;
            depB[i][1] = ARRIVING;
        }
        for ( int i = nA; i < (nA + nB); i++) {
            str = reader.readLine().split(" ");
            String[] minutes = str[0].split(":");
            depB[i][0] = Integer.parseInt(minutes[0])*60 + Integer.parseInt(minutes[1]);
            depB[i][1] = DEPARTING;
            minutes = str[1].split(":");
            depA[i][0] = Integer.parseInt(minutes[0])*60 + Integer.parseInt(minutes[1]) + turnAround;
            depA[i][1] = ARRIVING;
        }                
    }

    private void doCase() {
        sort(depA, nA+nB);
        sort(depB, nA+nB);
        countA();
        countB();
    }

    private void sort(int[][] dep, int n) {
        int a, b;
        boolean flag = true;
        while (flag) {
            flag = false;
            for ( int i = 1; i < n; i++) {
                if (    (dep[i-1][0] > dep[i][0])|
                        ((dep[i-1][0] == dep[i][0])&(dep[i-1][1] == DEPARTING)&(dep[i][1] == ARRIVING))
                        ) {
                    a = dep[i-1][0];
                    b = dep[i-1][1];
                    dep[i-1][0] = dep[i][0];
                    dep[i-1][1] = dep[i][1];
                    dep[i][0] = a;
                    dep[i][1] = b;
                    flag = true;
                }        
            }
        }
    }

    private void countA() {
        nTA = 0;
        int n = 0;
        for ( int i = 0; i < (nA + nB); i++) {
            n += depA[i][1];
            if (n < 0) {
                n = 0;
                nTA++;
            }
        }
    }

    private void countB() {
        nTB = 0;
        int n = 0;
        for ( int i = 0; i < (nA + nB); i++) {
            n += depB[i][1];
            if (n < 0) {
                n = 0;
                nTB++;
            }
        }        
    }


            

}
