/*
 * Main.java
 *
 * Created on 23 July 2008, 22:58
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package watersheds;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Adrian
 */

public class Main {
    BufferedWriter writer;
    BufferedReader reader;

    /** Creates a new instance of Main */
    public Main(String[] args) {                
        try {
            writer = new BufferedWriter(new FileWriter(new File(args[1])));
            reader = new BufferedReader(new FileReader(new File(args[0])));
            doStuff();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {                
        new Main(args);
    }
    
        
    private void doStuff() throws IOException {                    
        int n = Integer.parseInt(reader.readLine());
        for ( int i = 1; i <= n; i++) {
            String str = processCase();
            writer.write("Case #" + i + ":\n" + str );
            System.out.print("Case #" + i + ": " + str );
            writer.flush();
        }
        writer.close();
    }
 
    private String processCase() throws IOException {
        initCase();
        return getResults();
    }

   
    int X, Y;
    int[][] space;
    int[][] map;
   
    private void initCase() throws IOException {
        String input = reader.readLine();            
        String[] tokens = input.split("\\s+");
        X = Integer.parseInt(tokens[0]) + 2;
        Y = Integer.parseInt(tokens[1]) + 2;
        space = new int[X][Y];
        map = new int[X][Y];
        int xx;
        for (int i = 0; i < X; i++) {
            space[i][0] = 20000;
            space[i][Y-1] = 20000;
            map[i][0] = '.';
            map[i][Y-1] = '.';
        }
        for (int j = 0; j < Y; j++) {
            space[0][j] = 20000;
            space[X-1][j] = 20000;
            map[0][j] = '.';
            map[X-1][j] = '.';
        }
        for (int i = 1; i < (X-1); i++) {
            input = reader.readLine();
            tokens = input.split("\\s+");
            for (int j = 1; j < (Y-1); j++) {
                xx = Integer.parseInt(tokens[j-1]);
                space[i][j] = xx;
                map[i][j] = '.';
            }
        }
    }

    
    int label;
    
    private String getResults() {
       label = 'b';
        map[1][1] = 'a';
        int up, dn, rt, lt, hh;
        int x, y, z;
        for (int i = 1; i < X-1; i++) {
            for (int j = 1; j < Y-1; j++) {
                hh = space[i][j];
                up = space[i-1][j];
                dn = space[i+1][j];
                rt = space[i][j+1];
                lt = space[i][j-1];
                x = Math.min(dn, up);
                y = Math.min(rt, lt);
                x = Math.min(x, y);
                if (hh > x) {                    
                    if (x == up) {
                        setLabels(i, j, i-1, j);
                    } else if (x == lt) {
                        setLabels(i, j, i, j-1);
                    } else if (x == rt) {
                        setLabels(i, j, i, j+1);
                    } else if (x == dn) {
                        setLabels(i, j, i+1, j);
                    }
                } else {
                    if (map[i][j] == '.') {
                        map[i][j] = label;
                        label ++;
                    }
                }               
            }            
        }
        return makeDisplay();
    }
    
    private void setLabels(int x, int y, int xx, int yy) {
        if ((map[x][y] != '.')&(map[xx][yy] == '.')) {
            map[xx][yy] = map[x][y];
        } else if ((map[x][y] == '.')&(map[xx][yy] != '.')) {
            map[x][y] = map[xx][yy];
        } else if ((map[x][y] == '.')&(map[xx][yy] == '.')) {
            map[x][y] = label;
            map[xx][yy] = label;
            label ++;
        } else {
            int q1 = Math.min(map[xx][yy], map[x][y]);
            int q2 = Math.max(map[xx][yy], map[x][y]);
            replaceLabels(q2, q1);
        }
    }
    
    private void replaceLabels(int xx, int yy) {
        for (int i = 1; i < X-1; i++) {
            for (int j = 1; j < Y-1; j++) {
                if (map[i][j] == xx) {
                    map[i][j] = yy;
                }
            }            
        }
    }
    
    private String makeDisplay() {
        formatDisplay();
        StringBuffer strb = new StringBuffer(X*Y*4);
        for (int i = 1; i < X-1; i++) {
            for (int j = 1; j < Y-1; j++) {
                strb.append((char)(map[i][j]));
                strb.append(" ");
            }            
            strb.append('\n');
        }  
        
        return strb.toString();
    }
    
    private void formatDisplay() {
        int lab = 'a'-1;
        for (int i = 1; i < X-1; i++) {
            for (int j = 1; j < Y-1; j++) {
                if (map[i][j] > lab) {
                    lab++;
                    replaceLabels(map[i][j], lab);
                } 
                
            }
        }
    }
}
