/*
 * Main.java
 *
 * Created on 17 July 2008, 09:22
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package fly;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Adrian
 */
public class Main {
    
    BufferedWriter writer;
    BufferedReader reader;

    /** Creates a new instance of Main */
    public Main(String[] args) {                
        try {
            writer = new BufferedWriter(new FileWriter(new File(args[1])));
            reader = new BufferedReader(new FileReader(new File(args[0])));
            doStuff();
        } catch (IOException ex) {
            ex.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {                
        new Main(args);
    }
    
        
    private void doStuff() throws IOException {                    
        int n = Integer.parseInt(reader.readLine());
        for ( int i = 1; i <= n; i++) {
            String str = processCase(reader.readLine().split(" "));
            writer.write("Case #" + i + ": " + str + "\n");
            System.out.print("Case #" + i + ": " + str + "\n");
            writer.flush();
        }
        writer.close();
    }
    
    double flyRadius, outerRadius, thickness, stringRadius, gap;
    double innerRadius, innerRadius2, totalSurface;
    
    private String processCase(String[] string) {
        initCase(string);
        return Convert2Float(getProba());
    }

    private void initCase(String[] string) {
        flyRadius = Float.parseFloat(string[0]);
        outerRadius = Float.parseFloat(string[1]);
        thickness = Float.parseFloat(string[2]);
        stringRadius = Float.parseFloat(string[3]);
        gap = Float.parseFloat(string[4]);
        
        innerRadius = outerRadius - thickness - flyRadius;
        innerRadius2 = innerRadius*innerRadius;
        totalSurface = outerRadius*outerRadius*Math.PI/4;
    }
        
    private String Convert2Float(double d) {
        return String.format("%.6f", d);
    }
    
    private double getProba() {   
        if (gap <= (flyRadius*2))
            return 1;
          
        int n = (int)((outerRadius - thickness) / (gap + 2*stringRadius)) + 2;
        Rects rect;
        double surface = 0;
        for ( int i = 0; i < n; i++) {
            for ( int j = 0; j < n; j++) {                
                rect = new Rects(i, j);
                surface += rect.getSurface();
            }            
        }
        return 1-surface/totalSurface;
    }
    
    class Rects {
        double x1, x2, x3, x4;
        double y1, y2, y3, y4;
        
        double x5, x6;
        double y5, y6;
        
        double surface;
        boolean inside;
        boolean completelyInside;

        public Rects(int i, int j) {
            double x = i*(2*stringRadius + gap) + stringRadius + gap/2;
            double y = j*(2*stringRadius + gap) + stringRadius + gap/2;
            
            x1 = x2 = x - (gap/2 - flyRadius);
            x3 = x4 = x + (gap/2 - flyRadius);
            y1 = y4 = y - (gap/2 - flyRadius);
            y2 = y3 = y + (gap/2 - flyRadius);
            
            inside = ( (x1*x1 + y1*y1) < innerRadius2 );
            completelyInside = ( (x3*x3 + y3*y3) < innerRadius2 );
            
            if (!completelyInside)
                setCirclePoints();
            
            setSurface();
        }
        
        public double getSurface() {
            return surface;
        }

        public void setSurface() {
            if (inside) {
                if (completelyInside) {
                    surface = (x4 - x1)*(y2 - y1);
                } else {
                    surface = makeSurface();
                }
            } else {
                surface = 0;
            }
        }
        
        public boolean isInside() {
            return inside;
        }

        public boolean isWhole() {
            return completelyInside;
        }

        private void setCirclePoints() {
            if ( (x2*x2 + y2*y2) < innerRadius2 ) {
                x5 = Math.sqrt(innerRadius2 - y2*y2);
                y5 = y2;
            } else {
                x5 = x2;                
                y5 = Math.sqrt(innerRadius2 - x2*x2);
            }
            if ( (x4*x4 + y4*y4) < innerRadius2 ) {
                x6 = x4;                
                y6 = Math.sqrt(innerRadius2 - x4*x4);
            } else {
                x6 = Math.sqrt(innerRadius2 - y4*y4);
                y6 = y4;
            }
        }

        private double makeSurface() {
            if (x5 == x1)
                if (y6 == y1)
                    return trSurface(x1, y1);
                else
                    return trSurface(x1, y6) + (x4 - x1)*(y6 - y1);
                    
            if (y5 == y2)
                if (x6 == x4) {
                    double s = (x3 - x5)*(y3 - y6)/2;
                    double ss = trSurface(x3, y3);
                    s = ss - s;
                    return (x4 - x1)*(y2 - y1) - ss + 2*s;
                } else
                    return trSurface(x5, y1) + (x5 - x1)*(y2 - y1);
            
            System.out.println("Surface calculation error");
            return 0;
        }

        private double trSurface(double x, double y) {
//            if (x5 == x) 
//                return roundedTri(x, y, x6, y6, x5, y5);
//            else
//                return roundedTri(x, y, x5, y5, x6, y6);
                
            return roundedTri(x, y, x5, y5, x6, y6);
        }

        private double roundedTri(double x, double y, double x2, double y2, double x3, double y3) {
            double r1 = Math.sqrt((x2 - x)*(x2 - x) + (y2 - y)*(y2 - y));
            double r2 = Math.sqrt((x3 - x)*(x3 - x) + (y3 - y)*(y3 - y));
            double s = r1*r2/2;
            if (s > 0.0000000001) {
                double xm = (x2 + x3)/2;
                double ym = (y2 + y3)/2;
                double rm = Math.sqrt(xm*xm + ym*ym);
                double xc = xm*innerRadius/rm;
                double yc = ym*innerRadius/rm;
                s += 2*roundedTri(xm, ym, xc, yc, x2, y2);
            }
            return s;
        }
    }
}


