package gjam.round1.cookiemonster;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Locale;
import java.util.Scanner;

public class Cookie {
	static double I = 2;

	public static void main(String[] args) {
		String file = (args.length != 0) ? args[0]
				: "src/gjam/round1/cookiemonster/input";
		Path f = Paths.get(file);
		Path fout = Paths.get(file + ".out");
		try (InputStream is = Files.newInputStream(f);
				Scanner sc = new Scanner(is);
				BufferedWriter bw = Files.newBufferedWriter(fout,
						StandardCharsets.UTF_8);
				PrintWriter pw = new PrintWriter(bw)) {

			sc.useLocale(Locale.ENGLISH);

			int nbRound = sc.nextInt();
			double C, F, X, result;
			for (int i = 1; i <= nbRound; i++) {

				sc.nextLine();

				C = sc.nextDouble();
				F = sc.nextDouble();
				X = sc.nextDouble();
				result = cookieRound(C, F, X);

				pw.format(Locale.ENGLISH, "Case #%d: %.7f\n", i, result);

			}

		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("Done");

	}

	private static double cookieRound(double cost, double additionalRate,
			double target) {

		double currentTime = 0;
		double lastFactoBuildTime = cost / I;
		double currentOutputRate = I;

		// tant que c'est moins rapide de réaliser le total, que de faire une
		// factory + le total
		while (target / currentOutputRate >= lastFactoBuildTime + (target
				/ (currentOutputRate + additionalRate))) {
			// If equal, don't do!
			currentTime += lastFactoBuildTime;
			currentOutputRate += additionalRate;

			lastFactoBuildTime = cost / currentOutputRate;
		}
		currentTime += target / currentOutputRate;

		return currentTime;
	}

}
