package codejam2013.round1C.B;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

import com.google.common.io.Files;

public class ProblemB {

	private final static String prefix = "src/codejam2013/round1C/B/";
	private final static String problem = "B";
	private final static String dataset = "small-attempt1";

	private static class Coord {

		int x;
		int y;

		public Coord(int x, int y) {
			super();
			this.x = x;
			this.y = y;
		}

		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + x;
			result = prime * result + y;
			return result;
		}

		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Coord other = (Coord) obj;
			if (x != other.x)
				return false;
			if (y != other.y)
				return false;
			return true;
		}
	}

	private static class Path {

		String path = new String();
		Coord c;

		public Path(String path, Coord c) {
			super();
			this.path = path;
			this.c = c;
		}

		@Override
		public String toString() {
			return path;
		}

	}
	
	private static void addToPaths(LinkedList<Path> paths, Set<Coord> reached, Path p) {
		if (p.path.length() <= 500 && !reached.contains(p.c)) {
			paths.offer(p);
			reached.add(p.c);
		}
	}

	private static Path result(Coord obj) {
		LinkedList<Path> paths = new LinkedList<>();
		Set<Coord> reached = new HashSet<>();

		Coord zero = new Coord(0, 0);
		reached.add(zero);
		paths.offer(new Path("", zero));

		while (true) {
			Path p = paths.pop();

			Path east = new Path(p.path + "E", new Coord(p.c.x + p.path.length() + 1, p.c.y));
			if (east.c.equals(obj)) {
				return east;
			} else {
				addToPaths(paths, reached, east);
			}

			Path south = new Path(p.path + "S", new Coord(p.c.x, p.c.y - (p.path.length() + 1)));
			if (south.c.equals(obj)) {
				return south;
			} else {
				addToPaths(paths, reached, south);
			}

			Path west = new Path(p.path + "W", new Coord(p.c.x - (p.path.length() + 1), p.c.y));
			if (west.c.equals(obj)) {
				return west;
			} else {
				addToPaths(paths, reached, west);
			}

			Path north = new Path(p.path + "N", new Coord(p.c.x, p.c.y + p.path.length() + 1));
			if (north.c.equals(obj)) {
				return north;
			} else {
				addToPaths(paths, reached, north);
			}
		}
	}

	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
		Iterator<String> linesIterator = lines.iterator();
		int T = Integer.valueOf(linesIterator.next());
		File out = new File(prefix + problem + "-" + dataset + ".out");
		Files.write("", out, Charset.defaultCharset());

		for (int i = 1; i <= T; i++) {
			String line = linesIterator.next();
			String[] comps = line.split(" ");

			int X = Integer.parseInt(comps[0]);
			int Y = Integer.parseInt(comps[1]);

			Files.append("Case #" + i + ": " + result(new Coord(X, Y)) + System.getProperty("line.separator"), out, Charset.defaultCharset());
		}
	}
}
