package codejam2013.qualif;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import com.google.common.io.Files;

public class ProblemA {

	private final static String prefix = "src/codejam2013/qualif/";
	private final static String problem = "A";
	private final static String dataset = "small-attempt0";

	private final static int size = 4;

	// . : line is not full
	// C : line has conflict
	// X : XX, XT or TX
	// O : OO, OT or TO
	private static char or(char a, char b) {
		if (a == '.' || b == '.') {
			return '.';
		}
		if (a == 'C' || b == 'C') {
			return 'C';
		}
		if (a == 'T') {
			return b;
		}
		if (b == 'T') {
			return a;
		}
		if (a == b) {
			return a;
		}
		return 'C';
	}
	
	private static char match(char a, char b, char c, char d) {
		return or(a, or(b, or(c, d)));
	}

	private static boolean winner(char a) {
		return a == 'X' || a == 'O';
	}

	private static String result(char[][] table) {
		char global = 'T';
		
		// Rows
		for (int i = 0; i < size; i++) {
			char c = match(table[i][0], table[i][1], table[i][2], table[i][3]);
			if (winner(c)) {
				return c + " won";
			} else {
				global = or(global, c);
			}
		}

		// Columns
		for (int j = 0; j < size; j++) {
			char c = match(table[0][j], table[1][j], table[2][j], table[3][j]);
			if (winner(c)) {
				return c + " won";
			} else {
				global = or(global, c);
			}
		}

		// Diagonals
		char d1 = match(table[0][0], table[1][1], table[2][2], table[3][3]);
		if (winner(d1)) {
			return d1 + " won";
		} else {
			global = or(global, d1);
		}
		char d2 = match(table[3][0], table[2][1], table[1][2], table[0][3]);
		if (winner(d2)) {
			return d2 + " won";
		} else {
			global = or(global, d2);
		}

		return global == '.' ? "Game has not completed" : "Draw" ;
	}

	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
		Iterator<String> linesIterator = lines.iterator();
		int N = Integer.valueOf(linesIterator.next());
		File out = new File(prefix + problem + "-" + dataset + ".out");
		Files.write("", out, Charset.defaultCharset());
		for (int i = 1; i <= N; i++) {
			char[][] table = new char[4][4];
			for (int j = 0; j < 4; j++) {
				String line = linesIterator.next();
				for (int k = 0; k < 4; k++) {
					table[j][k] = line.charAt(k);
				}
			}
			if (linesIterator.hasNext()) {
				linesIterator.next();
			}
			Files.append("Case #" + i + ": " + result(table) + System.getProperty("line.separator"), out, Charset.defaultCharset());
		}
	}
}
