package codejam2016.qualif.D;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

public class ProblemD {

    private final static String prefix = "src/codejam2016/qualif/D/";
    private final static String problem = "D";
    private final static String dataset = "small-attempt0";

    public static void main(String[] args) throws IOException {
        File input = new File(prefix + problem + "-" + dataset + ".in");
        List<String> lines = Files.readLines(input, Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {
            String line = linesIterator.next();
            String[] values = line.split(" ");
            int K = Integer.valueOf(values[0]);
            int C = Integer.valueOf(values[1]);
            int S = Integer.valueOf(values[2]);
            appendln("Case #" + i + ": " + result(K, C, S), out);
        }
    }

    private static void appendln(String s, File file) throws IOException {
        Files.append(s + System.getProperty("line.separator"), file, Charset.defaultCharset());
    }

    private static String result(int k, int c, int s) {
        if (s != k) {
            return "IMPOSSIBLE";
        }
        StringBuilder sb = new StringBuilder();
        long scale = (long) Math.pow(k, c-1);
        for (long count = 0; count < s; count++) {
            sb.append(count * scale + 1).append(" ");
        }
        return sb.toString();
    }
}
