package codejam2013.qualif.B;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import com.google.common.io.Files;

public class ProblemB {

	private final static String prefix = "src/codejam2013/qualif/B/";
	private final static String problem = "B";
	private final static String dataset = "large";
	
	private static boolean isValid(int[][] table) {
		int[] rowsLocked = new int[table.length];
		int[] columnsLocked = new int[table[0].length];
		for (int i = 0; i < table.length; i++) {
			for (int j = 0; j < table[i].length; j++) {
				rowsLocked[i] = Math.max(rowsLocked[i], table[i][j]);
				columnsLocked[j] = Math.max(columnsLocked[j], table[i][j]);
			}
		}
		for (int i = 0; i < table.length; i++) {
			for (int j = 0; j < table[0].length; j++) {
				if (table[i][j] < rowsLocked[i] && table[i][j] < columnsLocked[j]) {
					return false;
				}
			}
		}
		return true;
	}
	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
		Iterator<String> linesIterator = lines.iterator();
		int T = Integer.valueOf(linesIterator.next());
		File out = new File(prefix + problem + "-" + dataset + ".out");
		Files.write("", out, Charset.defaultCharset());
		for (int i = 1; i <= T; i++) {
			String compsS = linesIterator.next();
			String[] comps = compsS.split(" ");
			int N = Integer.valueOf(comps[0]);
			int M = Integer.valueOf(comps[1]);
			int[][] table = new int[N][M];
			for (int j = 0; j < N; j++) {
				String line = linesIterator.next();
				String[] lineComps = line.split(" ");
				for (int k = 0; k < M; k++) {
					table[j][k] = Integer.valueOf(lineComps[k]);
				}
			}
			Files.append("Case #" + i + ": " + (isValid(table) ? "YES" : "NO") + System.getProperty("line.separator"), out, Charset.defaultCharset());
		}

	}
}
