package codejam2017.qualif.B;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

public class ProblemB {
    private final static String prefix  = "src/main/java/codejam2017/qualif/%s/";
    private final static String problem = "B";
    private final static String dataset = "B-small-attempt0";

    private static String datasetFolder() {
        return String.format(prefix, problem);
    }

    private static String formatAnswer(int number, String answer) {
        return String.format("Case #%d: %s\n", number, answer);
    }

    private static String solve(long N) {
        for (long i = N; i >= 0; i--) {
            if (isTidy(i)) {
                return String.valueOf(i);
            }
        }
        return "";
    }

    private static boolean isTidy(long i) {
        String asString = String.valueOf(i);
        for (int k = 0; k < asString.length()-1; k++) {
            if (asString.charAt(k) > asString.charAt(k+1)) {
                return false;
            }
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(datasetFolder() + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(datasetFolder() + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());

        for (int i = 1; i <= T; i++) {
            long N = Long.valueOf(linesIterator.next());
            String answer = solve(N);

            System.out.println(i + ": " + answer);
            Files.append(formatAnswer(i, answer), out, Charset.defaultCharset());
        }

    }
}
