package codejam2016.qualif.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

public class ProblemA {

    private final static String prefix = "src/codejam2016/qualif/A/";
    private final static String problem = "A";
    private final static String dataset = "small-attempt1";

    public static void main(String[] args) throws IOException {
        File input = new File(prefix + problem + "-" + dataset + ".in");
        List<String> lines = Files.readLines(input, Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {
            int N = Integer.parseInt(linesIterator.next());
            Files.append("Case #" + i + ": " + result(N) + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }

    private static void generateProblem(File file) throws IOException {
        int count = 200;
        Files.write("", file, Charset.defaultCharset());
        Files.append(String.valueOf(count + 1) + System.getProperty("line.separator"), file, Charset.defaultCharset());
        for (int i = 0; i <= count; i++) {
            Files.append(String.valueOf(i) + System.getProperty("line.separator"), file, Charset.defaultCharset());
        }
    }

    private static String result(int N) {
        if (N == 0) {
            return "INSOMNIA";
        }
        int digitsFound = 0;
        for (int k = 1; ; k++) {
            digitsFound |= parseDigits(k * N);
            if (digitsFound == ((1 << 10) - 1)) {
                return String.valueOf(k * N);
            }
        }
    }

    private static int parseDigits(int value) {
        int result = 0;
        String s = String.valueOf(value);
        for (int i = 0; i < s.length(); i++) {
            result |= 1 << (s.charAt(i) - '0');
        }
        return result;
    }
}
