package codejam2014.qualif.B;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

public class ProblemB {
    private final static String prefix = "src/codejam2014/qualif/B/";
    private final static String problem = "B";
    private final static String dataset = "small-attempt0";

    private static double result(double c, double f, double x, double income, double currentCount, double currentTime) {
        System.out.println(income + " " + currentCount + " " + currentTime);

        double timeToNextBuild = (c-currentCount) / income;
        double timeToFinish = (x - currentCount)/income;
        if (timeToFinish <= timeToNextBuild) {
            return currentTime + timeToFinish;
        }
        if (timeToNextBuild > 0) {
            return result(c, f, x, income, currentCount + income * timeToNextBuild, currentTime + timeToNextBuild);
        }
        if (f * timeToFinish > c) { // if building a new farm is worth it before we reach the objective
            return result(c, f, x, income + f, currentCount - c, currentTime);
        }

        return currentTime + timeToFinish;
    }

    private static double result(double c, double f, double x) {
        double income = 2.;
        double currentCount = 0.;
        double currentTime = 0.;

        return result(c, f, x, income, currentCount, currentTime);
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {

            String line = linesIterator.next();
            String[] components = line.split(" ");

            double C = Double.parseDouble(components[0]);
            double F = Double.parseDouble(components[1]);
            double X = Double.parseDouble(components[2]);

            System.out.println("=================");

            Files.append("Case #" + i + ": " + result(C, F, X) + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
