package codejam2017.round1B.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import static com.sun.tools.javac.main.Option.J;
import static com.sun.tools.javac.main.Option.O;
import static javax.swing.text.html.HTML.Attribute.N;

public class ProblemA {
    private final static String prefix  = "src/main/java/codejam2017/round1B/%s/";
    private final static String problem = "A";
    private final static String dataset = "A-small-attempt0";

    private static String datasetFolder() {
        return String.format(prefix, problem);
    }

    private static String formatAnswer(int number, String answer) {
        return String.format("Case #%d: %s\n", number, answer);
    }

    private static String solve(long d, int n, long[] di, long[] si) {
        double bestTime = 0.;
        for (int i = 0; i < n; i++) {
            double time = Math.max(d-di[i], 0.)/si[i];
            bestTime = Math.max(bestTime, time);
        }

        return String.valueOf(d/bestTime);
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(datasetFolder() + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(datasetFolder() + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());

        for (int i = 1; i <= T; i++) {
            String[] lineComps = linesIterator.next().split(" ");
            long D = Long.valueOf(lineComps[0]);
            int N = Integer.valueOf(lineComps[1]);
            long[] Di = new long[N];
            long[] Si = new long[N];
            for (int j = 0; j < N; j++) {
                lineComps = linesIterator.next().split(" ");
                Di[j] = Long.valueOf(lineComps[0]);
                Si[j] = Long.valueOf(lineComps[1]);

            }
            String answer = solve(D, N, Di, Si);

            System.out.println(i + ": " + answer);
            Files.append(formatAnswer(i, answer), out, Charset.defaultCharset());
        }

    }
}
