package codejam2014.round1C.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.util.*;

public class ProblemA {
    private final static String prefix = "src/codejam2014/round1C/A/";
    private final static String problem = "A";
    private final static String dataset = "small-attempt0";

    public static int log2(int n){
        if(n <= 0) throw new IllegalArgumentException();
        return 31 - Integer.numberOfLeadingZeros(n);
    }

    private static int resultInt(int p, int q) {
        if (q != 1 << log2(q)) {
            return -1;
        }

        if (p < q/2) {
            return 1+resultInt(p, q/2);
        }
        return 1;
    }

    private static String result(int p, int q) {
        int res = resultInt(p, q);
        if (res < 0) {
            return "impossible";
        }
        return String.valueOf(res);
    }

    private static int gcd(int a, int b) {
        BigInteger b1 = BigInteger.valueOf(a);
        BigInteger b2 = BigInteger.valueOf(b);
        BigInteger gcd = b1.gcd(b2);
        return gcd.intValue();
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {

            String line = linesIterator.next();
            String[] comps = line.split("/");
            int P = Integer.valueOf(comps[0]);
            int Q = Integer.valueOf(comps[1]);

            int gcd = gcd(P, Q);


            Files.append("Case #" + i + ": " + result(P/gcd, Q/gcd) + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
