package codejam2013.round1C.A;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import com.google.common.io.Files;

public class ProblemA {

	private final static String prefix = "src/codejam2013/round1C/A/";
	private final static String problem = "A";
	private final static String dataset = "small-attempt0";

	private static boolean[] consonants(String s) {
		boolean[] result = new boolean[s.length()];
		for (int i = 0; i < s.length(); i++) {
			char c = s.charAt(i);
			result[i] = c != 'a' && c != 'e' && c != 'i' && c != 'o' && c != 'u';
		}
		return result;
	}

	private static int result(String name, int n) {
		boolean[] consonants = consonants(name);
		int result = 0;
		for (int i = 0; i < name.length(); i++) {
			for (int j = i + n; j <= name.length(); j++) {
				int count = 0;
				int max = 0;
				for (int k = i; k < j; k++) {
					if (consonants[k]) {
						count++;
					} else {
						max = Math.max(max, count);
						count = 0;
					}
				}
				max = Math.max(max, count);
				if (max >= n) {
					result++;
				}
			}
		}
		return result;
	}

	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
		Iterator<String> linesIterator = lines.iterator();
		int T = Integer.valueOf(linesIterator.next());
		File out = new File(prefix + problem + "-" + dataset + ".out");
		Files.write("", out, Charset.defaultCharset());

		for (int i = 1; i <= T; i++) {
			String line = linesIterator.next();
			String[] comps = line.split(" ");
			String name = comps[0];
			int n = Integer.valueOf(comps[1]);

			Files.append("Case #" + i + ": " + result(name, n) + System.getProperty("line.separator"), out, Charset.defaultCharset());
		}
	}
}
