package codejam2014.qualif.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class ProblemA {
    private final static String prefix = "src/codejam2014/qualif/A/";
    private final static String problem = "A";
    private final static String dataset = "small-attempt0";

    private static Set<String> validCards(Iterator<String> linesIterator) {

        int pick = Integer.parseInt(linesIterator.next());

        Set<String> validCards = new HashSet<String>();
        for (int j = 1; j <= 4; j++) {
            String line = linesIterator.next();
            if (j != pick) {
                continue;
            }
            String[] cardsOnLine = line.split(" ");
            for (int k = 0; k < cardsOnLine.length; k++) {
                validCards.add(cardsOnLine[k]);
            }
        }

        return validCards;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {

            Set<String> first = validCards(linesIterator);
            Set<String> second = validCards(linesIterator);

            first.retainAll(second);

            String result;
            if (first.size() == 1) {
                result = first.iterator().next();
            } else if (first.size() > 1) {
                result = "Bad magician!";
            } else {
                result = "Volunteer cheated!";
            }

            Files.append("Case #" + i + ": " + result + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
