package codejam2013.qualif.C;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import com.google.common.io.Files;

public class ProblemC {

	private final static String prefix = "src/codejam2013/qualif/C/";
	private final static String problem = "C";
	private final static String dataset = "large-2";

	// Precalculated via generateRoots
	private final static long[] fairRoots = new long[] { 0, 1, 2, 3, 11, 22, 101, 111, 121, 202, 212, 1001, 1111, 2002, 10001, 10101, 10201, 11011, 11111, 11211, 20002, 20102, 100001, 101101, 110011, 111111, 200002, 1000001, 1001001, 1002001, 1010101, 1011101, 1012101, 1100011, 1101011, 1102011, 1110111, 1111111, 2000002, 2001002, 10000001, 10011001, 10100101, 10111101, 11000011, 11011011, 11100111, 11111111, 20000002, 100000001, 100010001, 100020001, 100101001, 100111001, 100121001, 101000101, 101010101, 101020101, 101101101, 101111101, 110000011, 110010011, 110020011, 110101011, 110111011, 111000111, 111010111, 111101111, 111111111, 200000002, 200010002, 1000000001, 1000110001, 1001001001, 1001111001, 1010000101, 1010110101, 1011001101, 1011111101, 1100000011, 1100110011, 1101001011, 1101111011, 1110000111, 1110110111, 1111001111, 2000000002 };

	private static boolean palindrome(String s) {
		for (int i = 0; i < s.length() / 2; i++) {
			if (s.charAt(i) != s.charAt(s.length() - i - 1)) {
				return false;
			}
		}
		return true;
	}

	private static boolean palindrome(long n) {
		return palindrome(String.valueOf(n));
	}

	private static boolean palindrome(BigInteger n) {
		return palindrome(n.toString());
	}

	private static void generateRoots() {
		for (long n = 0; n < Math.sqrt(Long.MAX_VALUE); n++) {
			if (palindrome(n) && palindrome(n * n)) {
				System.out.println(n);
			}
		}
	}

	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
		Iterator<String> linesIterator = lines.iterator();
		int N = Integer.valueOf(linesIterator.next());
		File out = new File(prefix + problem + "-" + dataset + ".out");
		Files.write("", out, Charset.defaultCharset());
		for (int i = 1; i <= N; i++) {
			String line = linesIterator.next();
			String[] comps = line.split(" ");
			BigInteger min = new BigInteger(comps[0]);
			BigInteger max = new BigInteger(comps[1]);
			int count = 0;
			for (int j = 0; j < fairRoots.length; j++) {
				BigInteger root = new BigInteger(String.valueOf(fairRoots[j]));
				BigInteger square = root.multiply(root);
				if (square.compareTo(max) > 0) {
					break;
				}
				if (square.compareTo(min) >= 0) {
					count++;
				}
			}
			Files.append("Case #" + i + ": " + count + System.getProperty("line.separator"), out, Charset.defaultCharset());
		}

	}
}
