package codejam2013.round1B.A;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import com.google.common.io.Files;


public class ProblemA {
	private final static String prefix = "src/codejam2013/round1B/A/";
	private final static String problem = "A";
	private final static String dataset = "small-attempt0";
	
	private static class Game {
		public int A;
		public List<Integer> motes;
		public Game(int a, List<Integer> motes) {
			super();
			A = a;
			this.motes = motes;
		}
	}
	
	private static Game absorbe(Game g) {
		System.out.println(g.A + " "+g.motes.size());
		List<Integer> result = new ArrayList<>(g.motes.size());
		int newA = g.A;
		for (Integer i : g.motes) {
			if (i < newA) {
				newA += i;
			} else {
				result.add(i);
			}
		}
		return new Game(newA, result);
	}
	
	public static int result(Game g) {
		Game solved = absorbe(g);
		if (g.A == 1 && g.motes.size() > 0) {
			return g.motes.size();
		}
		if (solved.motes.size() == 0) {
			return 0;
		}
		return Math.min(solved.motes.size(), 1+result(new Game(solved.A * 2 -1, solved.motes)));
	}
	
	public static void main(String[] args) throws IOException {
		List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
		Iterator<String> linesIterator = lines.iterator();
		int T = Integer.valueOf(linesIterator.next());
		File out = new File(prefix + problem + "-" + dataset + ".out");
		Files.write("", out, Charset.defaultCharset());
		
		for (int i = 1; i <= T; i++) {
			String[] config = linesIterator.next().split(" ");
			int A = Integer.parseInt(config[0]);
			int N = Integer.parseInt(config[1]);
			List<Integer> motes = new ArrayList<>(N);
			String[] motesSizes = linesIterator.next().split(" ");
			for (int j = 0; j < motesSizes.length; j++) {
				String moteSize = motesSizes[j];
				motes.add(Integer.parseInt(moteSize));
			}
			Collections.sort(motes);
			Files.append("Case #" + i + ": " + result(new Game(A, motes)) + System.getProperty("line.separator"), out, Charset.defaultCharset());
		}
		
	}
}
