package codejam2014.round1C.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.util.*;

public class ProblemA {
    private final static String prefix = "src/codejam2014/round1C/A/";
    private final static String problem = "A";
    private final static String dataset = "large";

    public static int log2(int n){
        if(n <= 0) throw new IllegalArgumentException();
        return 31 - Integer.numberOfLeadingZeros(n);
    }

    private static BigInteger TWO = BigInteger.valueOf(2);

    private static int resultInt(BigInteger p, BigInteger q) {
        String binary = q.toString(2);
        for (int i = 1; i < binary.length(); i++) {
            if (binary.charAt(i) != '0') {
                return Integer.MIN_VALUE;
            }
        }

        BigInteger qHalf = q.divide(TWO);
        if (p.compareTo(qHalf) < 0) {
            return 1+resultInt(p, qHalf);
        }
        return 1;
    }

    private static String result(BigInteger p, BigInteger q) {
        int res = resultInt(p, q);
        if (res < 0) {
            return "impossible";
        }
        return String.valueOf(res);
    }

    private static int gcd(int a, int b) {
        BigInteger b1 = BigInteger.valueOf(a);
        BigInteger b2 = BigInteger.valueOf(b);
        BigInteger gcd = b1.gcd(b2);
        return gcd.intValue();
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {

            String line = linesIterator.next();
            String[] comps = line.split("/");
            BigInteger P = new BigInteger(comps[0]);
            BigInteger Q = new BigInteger(comps[1]);

            BigInteger gcd = P.gcd(Q);


            Files.append("Case #" + i + ": " + result(P.divide(gcd), Q.divide(gcd)) + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
