package codejam2014.qualif.D;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.*;

public class ProblemD {
    private final static String prefix = "src/codejam2014/qualif/D/";
    private final static String problem = "D";
    private final static String dataset = "small-attempt0";

    private static List<Double> parse(String line, int N) {
        List<Double> result = new ArrayList<Double>(N);
        String[] comps = line.split(" ");
        for (int i = 0; i < comps.length; i++) {
            result.add(Double.parseDouble(comps[i]));
        }
        Collections.sort(result);
        return result;
    }

    private static String result(List<Double> naomi, List<Double> ken) {
        int deceitful = 0;
        LinkedList<Double> naomiD = new LinkedList<Double>(naomi);
        LinkedList<Double> kenD = new LinkedList<Double>(ken);
        while(naomiD.size() > 0) {
            double n = naomiD.removeFirst();
            if (n < kenD.get(0)) {
                kenD.removeLast();
            } else {
                kenD.removeFirst();
                deceitful++;
            }
        }

        int regular = 0;
        while (naomi.size() > 0) {
            double n = naomi.remove(0);
            int i;
            int optimum = 0;
            for (i = 0; i < ken.size(); i++) {
                if (ken.get(i) > n) {
                    optimum = i;
                    break;
                }
            }
            if (ken.get(optimum) < n) {
                regular++;
            }
            ken.remove(optimum);
        }

        return deceitful + " " + regular;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {

            int N = Integer.valueOf(linesIterator.next());
            List<Double> naomi = parse(linesIterator.next(), N);
            List<Double> ken = parse(linesIterator.next(), N);

            System.out.println(naomi);
            System.out.println(ken);
            System.out.println("=======");

            Files.append("Case #" + i + ": " + result(naomi, ken) + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
