package codejam2017.qualif.C;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class ProblemC {
    private final static String prefix = "src/main/java/codejam2017/qualif/%s/";
    private final static String problem = "C";
    private final static String dataset = "C-small-1-attempt1";

    private static String datasetFolder() {
        return String.format(prefix, problem);
    }

    private static String formatAnswer(int number, String answer) {
        return String.format("Case #%d: %s\n", number, answer);
    }

    private static String solve(int N, int K) {
        if (K == N) {
            return "0 0";
        }
        List<Integer> segments = new LinkedList<>();
        segments.add(N);
        String lastSegment = "";
        while (K > 0) {
            int bestIndex = bestIndex(segments);
            int value = segments.get(bestIndex);
            if (value == 1) {
                segments.remove(bestIndex);
                lastSegment = "0 0";
            } else if (value == 2) {
                segments.set(bestIndex, 1);
                lastSegment = "1 0";
            } else {
                int min = (value - 1) / 2;
                int max = value / 2;
                segments.set(bestIndex, min);
                segments.add(bestIndex + 1, max);
                lastSegment = max + " " + min;
            }
            K--;
        }
        return lastSegment;
    }

    private static int bestIndex(List<Integer> segments) {
        int i = 0;
        int best = 0;
        int bestIndex = 0;
        for (int k : segments) {
            if (k > best) {
                best = k;
                bestIndex = i;
            }
            i++;
        }
        return bestIndex;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(datasetFolder() + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(datasetFolder() + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());

        for (int i = 1; i <= T; i++) {
            String[] lineComps = linesIterator.next().split(" ");
            int N = Integer.valueOf(lineComps[0]);
            int K = Integer.valueOf(lineComps[1]);
            String answer = solve(N, K);

            System.out.println(i + ": " + answer);
            Files.append(formatAnswer(i, answer), out, Charset.defaultCharset());
        }

    }
}
