package codejam2017.qualif.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class ProblemA {
    private final static String prefix  = "src/main/java/codejam2017/qualif/%s/";
    private final static String problem = "A";
    private final static String dataset = "A-large";

    private static String datasetFolder() {
        return String.format(prefix, problem);
    }

    private static String formatAnswer(int number, String answer) {
        return String.format("Case #%d: %s\n", number, answer);
    }

    private static String solve(boolean[] pancakes, int K) {
        int cursor = 0;
        int count = 0;
        while (cursor < pancakes.length) {
            cursor = indexOfFirstPlain(pancakes);
            if (cursor == -1) {
                return String.valueOf(count);
            }
            if (cursor + K > pancakes.length) {
                return "IMPOSSIBLE";
            }
            for (int i = 0; i < K; i++) {
                pancakes[cursor + i] = !pancakes[cursor + i];
            }
            count++;
        }
        return "";
    }

    private static int indexOfFirstPlain(boolean[] pancakes) {
        for (int i = 0; i < pancakes.length; i++) {
            if (!pancakes[i]) {
                return i;
            }
        }
        return -1;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(datasetFolder() + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(datasetFolder() + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());

        for (int i = 1; i <= T; i++) {
            String line = linesIterator.next();
            String[] lineComps = line.split(" ");
            String sequence = lineComps[0];
            boolean[] pancakes = convertToPancakes(sequence);
            int K = Integer.valueOf(lineComps[1]);

            String answer = solve(pancakes, K);

            System.out.println(i + ": " + answer);
            Files.append(formatAnswer(i, answer), out, Charset.defaultCharset());
        }

    }

    private static boolean[] convertToPancakes(String sequence) {
        boolean[] pancakes = new boolean[sequence.length()];
        for (int i = 0; i < sequence.length(); i++) {
            pancakes[i] = sequence.charAt(i) == '+';
        }
        return pancakes;
    }
}
