package codejam2017.round1B.C;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

public class ProblemC {
    private final static String prefix = "src/main/java/codejam2017/round1B/%s/";
    private final static String problem = "C";
    private final static String dataset = "C-small-attempt1";

    private static String datasetFolder() {
        return String.format(prefix, problem);
    }

    private static String formatAnswer(int number, String answer) {
        return String.format("Case #%d: %s\n", number, answer);
    }

    private static double solve(int n, int q, long[] ei, int[] si, long[][] dij) {
        double[] times = new double[n];
        long[] distancesTillEnd = new long[n];
        for (int i = n - 2; i >= 0; i--) {
            int speed = si[i];
            double distance = dij[i][i + 1];
            distancesTillEnd[i] = distancesTillEnd[i + 1] + dij[i][i + 1];
            times[i] = distance / speed + times[i + 1];
            for (int k = i + 1; k < n - 1; k++) {
                distance += dij[k][k+1];
                if (ei[i] >= dij[k][k + 1]) {
                    double potentiallyBetterTime = distance / speed + times[k + 1];
                    if (potentiallyBetterTime < times[i]) {
                        times[i] = potentiallyBetterTime;
                    }
                } else {
                    break;
                }
            }
        }

        return times[0];
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(datasetFolder() + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(datasetFolder() + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());

        for (int i = 1; i <= T; i++) {
            String[] lineComps = linesIterator.next().split(" ");
            int N = Integer.valueOf(lineComps[0]);
            int Q = Integer.valueOf(lineComps[1]);
            long[] Ei = new long[N];
            int[] Si = new int[N];
            for (int j = 0; j < N; j++) {
                lineComps = linesIterator.next().split(" ");
                Ei[j] = Long.valueOf(lineComps[0]);
                Si[j] = Integer.valueOf(lineComps[1]);
            }
            long[][] Dij = new long[N][N];
            for (int j = 0; j < N; j++) {
                lineComps = linesIterator.next().split(" ");
                for (int k = 0; k < N; k++) {
                    Dij[j][k] = Long.valueOf(lineComps[k]);
                }
            }
            for (int j = 0; j < Q; j++) {
                lineComps = linesIterator.next().split(" ");
                // TODO: fill U, V
            }
            String answer = String.valueOf(solve(N, Q, Ei, Si, Dij));

            System.out.println(i + ": " + answer);
            Files.append(formatAnswer(i, answer), out, Charset.defaultCharset());
        }

    }
}
