package codejam2016.qualif.C;

import com.google.common.io.Files;
import com.google.common.math.BigIntegerMath;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.math.RoundingMode;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

import static java.math.BigInteger.ONE;
import static java.math.BigInteger.ZERO;

public class ProblemC {

    private final static String prefix = "src/codejam2016/qualif/C/";
    private final static String problem = "C";
    private final static String dataset = "large";
    private static final BigInteger TWO = new BigInteger("2");
    private static final BigInteger THREE = new BigInteger("3");
    private static final BigInteger SIX = new BigInteger("6");

    public static void main(String[] args) throws IOException {
        File input = new File(prefix + problem + "-" + dataset + ".in");
        List<String> lines = Files.readLines(input, Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {
            String line = linesIterator.next();
            String[] values = line.split(" ");
            int N = Integer.valueOf(values[0]);
            int J = Integer.valueOf(values[1]);
            appendln("Case #" + i + ":", out);
            result(out, N, J);
        }
    }

    private static void appendln(String s, File file) throws IOException {
        Files.append(s + System.getProperty("line.separator"), file, Charset.defaultCharset());
    }

    private static void result(File out, int n, int j) throws IOException {
        int count = 0;
        int maxCount = 1 << (n - 2);
        for (int i = 0; i < maxCount && count < j; i++) {
            int jamcoinValue = (1 << (n - 1)) + (i << 1) + 1;
            String jamcoin = Integer.toBinaryString(jamcoinValue);
            String result = isJamcoin(jamcoin);
            if (result != null) {
                appendln(result, out);
                count++;
            }
        }
    }

    private static String isJamcoin(String jamcoin) {
        StringBuilder sb = new StringBuilder();
        sb.append(jamcoin).append(" ");
        for (int i = 2; i <= 10; i++) {
            BigInteger value = new BigInteger(jamcoin, i);
            BigInteger divider = divider(value);
            if (divider.equals(value)) {
                return null;
            } else {
                sb.append(divider(value)).append(" ");
            }
        }
        return sb.toString();
    }

    private static BigInteger divider(BigInteger n) {
        if (n.compareTo(TWO) < 0) return n;
        if (n.equals(TWO) || n.equals(THREE)) return n;
        if (n.mod(TWO).equals(ZERO)) return TWO;
        if (n.mod(THREE).equals(ZERO)) return THREE;
        BigInteger sqrtN = BigIntegerMath.sqrt(n, RoundingMode.CEILING);
        BigInteger max = BigInteger.valueOf(1000L);
        for (BigInteger i = SIX; i.compareTo(max) <= 0; i = i.add(SIX)) {
            if (n.mod(i.subtract(ONE)).equals(ZERO)) return i.subtract(ONE);
            if (n.mod(i.add(ONE)).equals(ZERO)) return i.add(ONE);
        }
        return n;
    }

}
