package codejam2014.round1C.C;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

public class ProblemC {
    private final static String prefix = "src/codejam2014/round1C/C/";
    private final static String problem = "C";
    private final static String dataset = "small-attempt2";

    private static int enclosed(int m, int n) {
        if (m <= 2 || n <= 2) {
            return 0;
        }
        return m * n - 4;
    }

    private static int stones(int m, int n) {
        if (m <= 2 || n <= 2) {
            return m*n;
        }
        return 2 * (m - 2 + n - 2);
    }

    private static int result(int N, int M, int K) {
        if (K <= 4) {
            return K;
        }

        int best = M*N;
        for (int m = 1; m <= M; m++) {
            for (int n = 1; n <= N; n++) {
                int e = enclosed(m,n);
                int s = stones(m,n);
                int attempt = s + Math.max(K - e, 0);
                if (attempt < best) {
                    best = attempt;
                }
            }
        }
        return best;
//        int m = 1;
//        int n = 1;
//        while (enclosed(m, n) < K) {
//            if (m < n && m < M) {
//                m++;
//            } else if (n < N) {
//                n++;
//            } else if (m < M) {
//                m++;
//            } else {
//                return stones(m, n) + (K - enclosed(m, n));
//            }
//        }
//
//        return stones(m, n);
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {

            String line = linesIterator.next();
            String[] lineComps = line.split(" ");
            int N = Integer.valueOf(lineComps[0]);
            int M = Integer.valueOf(lineComps[1]);
            int K = Integer.valueOf(lineComps[2]);

            Files.append("Case #" + i + ": " + result(N, M, K) + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }

}
