package codejam2016.qualif.C;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class ProblemC {

    private final static String prefix = "src/codejam2016/qualif/C/";
    private final static String problem = "C";
    private final static String dataset = "small-attempt0";

    public static void main(String[] args) throws IOException {
        File input = new File(prefix + problem + "-" + dataset + ".in");
        List<String> lines = Files.readLines(input, Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {
            String line = linesIterator.next();
            String[] values = line.split(" ");
            int N = Integer.valueOf(values[0]);
            int J = Integer.valueOf(values[1]);
            appendln("Case #" + i + ":", out);
            result(out, N, J);
        }
    }

    private static void appendln(String s, File file) throws IOException {
        Files.append(s + System.getProperty("line.separator"), file, Charset.defaultCharset());
    }

    private static void result(File out, int n, int j) throws IOException {
        int count = 0;
        int maxCount = 1 << (n - 2);
        for (int i = 0; i < maxCount && count < j; i++) {
            int jamcoinValue = (1 << (n - 1)) + (i << 1) + 1;
            String jamcoin = Integer.toBinaryString(jamcoinValue);
            String result = isJamcoin(jamcoin);
            if (result != null) {
                appendln(result, out);
                count++;
            }
        }
    }

    private static String isJamcoin(String jamcoin) {
        StringBuilder sb = new StringBuilder();
        sb.append(jamcoin).append(" ");
        for (int i = 2; i <= 10; i++) {
            long value = Long.parseLong(jamcoin, i);
            long divider = divider(value);
            if (divider == value) {
                return null;
            } else {
                sb.append(divider(value)).append(" ");
            }
        }
        return sb.toString();
    }

    private static long divider(long n) {
        if (n < 2) return n;
        if (n == 2 || n == 3) return n;
        if (n % 2 == 0) return 2;
        if (n % 3 == 0) return 3;
        long sqrtN = (long) Math.sqrt(n) + 1;
        for (long i = 6L; i <= sqrtN; i += 6) {
            if (n % (i - 1) == 0) return i-1;
            if (n % (i + 1) == 0) return i+1;
        }
        return n;
    }

}
