package codejam2016.qualif.B;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;
import java.util.Random;

public class ProblemB {

    private final static String prefix = "src/codejam2016/qualif/B/";
    private final static String problem = "B";
    private final static String dataset = "large";

    public static void main(String[] args) throws IOException {
        File input = new File(prefix + problem + "-" + dataset + ".in");
        //generateProblem(input);
        List<String> lines = Files.readLines(input, Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int N = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= N; i++) {
            String sequence = linesIterator.next();
            appendln("Case #" + i + ": " + result(sequence), out);
        }
    }

    private static void appendln(String s, File file) throws IOException {
        Files.append(s + System.getProperty("line.separator"), file, Charset.defaultCharset());
    }

    private static void generateProblem(File file) throws IOException {
        Files.write("", file, Charset.defaultCharset());
        int count = 200;
        appendln(String.valueOf(count), file);
        for (int i = 0; i < count; i++) {
            appendln(randomItem(), file);
        }
    }

    private static String randomItem() {
        StringBuilder sb = new StringBuilder();
        Random r = new Random();
        for (int i = 0; i < 100; i++) {
            sb.append(r.nextBoolean() ? "+" : "-");
        }
        return sb.toString();
    }

    private static String result(String sequence) {
        boolean[] bitmask = parseSequence(sequence);
        int index;
        int counter = 0;
        while ((index = lastFalse(bitmask)) >= 0) {
            flip(bitmask, index);
            counter++;
        }
        return String.valueOf(counter);
    }

    private static void flip(boolean[] bitmask, int index) {
        for (int i = 0; i <= index; i++) {
            bitmask[i] = !bitmask[i];
        }
    }

    private static int lastFalse(boolean[] bitmask) {
        for (int i = bitmask.length - 1; i >= 0; i--) {
            if (!bitmask[i]) {
                return i;
            }
        }
        return -1;
    }


    private static boolean[] parseSequence(String sequence) {
        boolean[] bitmask = new boolean[sequence.length()];
        for (int i = 0; i < sequence.length(); i++) {
            bitmask[i] = sequence.charAt(i) == '+';
        }
        return bitmask;
    }
}
