package codejam2016.round1C.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class ProblemA {
    private final static String prefix  = "src/main/java/codejam2016/round1C/A/";
    private final static String problem = "A";
    private final static String dataset = "large";

    private static String solve(int[] P) {
        StringBuilder solution = new StringBuilder();
        while (count(P) > 0) {
            removeHighestPair(P, solution);
        }
        return solution.toString();
    }

    private static void removeHighestPair(int[] p, StringBuilder solution) {
        int maxValue = -1;
        for (int a : p) {
            maxValue = Math.max(maxValue, a);
        }
        List<Integer> maxIndexes = new ArrayList<>();
        for (int i = 0; i < p.length; i++) {
            if (p[i] == maxValue) {
                maxIndexes.add(i);
            }
        }
        if (maxIndexes.size() == 1) {
            appendEvac(solution, p, maxIndexes.get(0));
        } else if (maxIndexes.size() == 2) {
            appendEvac(solution, p, maxIndexes.get(0), maxIndexes.get(1));
        } else {
            appendEvac(solution, p, maxIndexes.get(0));
        }
    }

    private static void appendEvac(StringBuilder sb, int[] p, int index) {
        p[index]--;
        sb.append((char)('A' + index)).append(" ");
    }

    private static void appendEvac(StringBuilder sb, int[] p, int index1, int index2) {
        p[index1]--;
        p[index2]--;
        sb.append((char)('A' + index1)).append((char)('A' + index2)).append(" ");
    }

    private static int count(int[] p) {
        int result = 0;
        for (int aP : p) {
            result += aP;
        }
        return result;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {
            String line = linesIterator.next();
            int N = Integer.valueOf(line);

            line = linesIterator.next();
            String[] comps = line.split(" ");
            int[] P = new int[comps.length];
            for (int j = 0; j < comps.length; j++) {
                P[j] = Integer.valueOf(comps[j]);
            }

            String result = solve(P);

            System.out.println(result);
            Files.append("Case #" + i + ": " + result + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
