package codejam2014.round1C.B;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.*;

public class ProblemB {
    private final static String prefix = "src/codejam2014/round1C/B/";
    private final static String problem = "B";
    private final static String dataset = "small-attempt4";

    private static int result(List<String> cars) {
        return result(cars, "");
    }

    private static int result(List<String> cars, String current) {
        if (cars.size() == 0) {
//            Set<Character> metChars = new HashSet<Character>();
//            char currentChar = current.charAt(0);
//            for (int i = 1; i < current.length(); i++) {
//                char c = current.charAt(i);
//                if (c != currentChar) {
//                    if (metChars.contains(c)) {
//                        break;
//                    } else {
//                        metChars.add(c);
//                        currentChar = c;
//                    }
//                }
//            }
            return 1;
        }
        int count = 0;
        for (String s : cars) {
            Set<Character> metChars = new HashSet<Character>();
            for (int i = 0; i < current.length(); i++) {
                metChars.add(current.charAt(i));
            }
            char currentChar = current.length() > 0 ? current.charAt(current.length() - 1) : 0;
            for (int i = 0; i < s.length(); i++) {
                char c = s.charAt(i);
                if (c != currentChar) {
                    if (metChars.contains(c)) {
                        break;
                    } else {
                        metChars.add(c);
                        currentChar = c;
                    }
                }
                if (i == s.length() - 1) {
                    List<String> tempL = new ArrayList<String>(cars);
                    tempL.remove(s);
                    count += result(tempL, current + s);
                }
            }
        }

        return count;
    }

    public static String simplify(String s) {
        StringBuffer sb = new StringBuffer();
        for (int i = 0; i < s.length(); i++) {
            if (sb.length() > 0 && s.charAt(i) != sb.charAt(sb.length() - 1)) {
                sb.append(s.charAt(i));
            } else if (sb.length() == 0) {
                sb.append(s.charAt(i));
            }
        }
        return sb.toString();
    }

    public static List<String> simplify(List<String> input) {
        List<String> result = new ArrayList<String>(input.size());
        for (String s : input) {
            result.add(simplify(s));
        }
        return result;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {
            int N = Integer.valueOf(linesIterator.next());
            List<String> cars = Arrays.asList(linesIterator.next().split(" "));
            int result = result(simplify(cars));
            System.out.println(cars+ ": "+result);
            Files.append("Case #" + i + ": " + result + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
