package codejam2014.round1B.A;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Iterator;
import java.util.List;

public class ProblemA {
    private final static String prefix = "src/codejam2014/round1B/A/";
    private final static String problem = "A";
    private final static String dataset = "large";

    public static boolean indexesBeforeEnd(char[][] chars, int[] indexes) {
        for (int i = 0; i < indexes.length; i++) {
            if (indexes[i] >= chars[i].length) {
                return false;
            }
        }
        return true;
    }

    public static boolean allCharsIdentical(char[][] chars, int[] indexes) {
        char c = chars[0][indexes[0]];
        for (int i = 0; i < indexes.length; i++) {
            if (chars[i][indexes[i]] != c) {
                return false;
            }
        }
        return true;
    }

    public static void moveIndexesToEndOfChain(char[][] chars, int[] indexes, int[] counts) {
        for (int i = 0; i < indexes.length; i++) {
            while (indexes[i] < chars[i].length - 1 && chars[i][indexes[i]] == chars[i][indexes[i]+1]) {
                indexes[i]++;
                counts[i]++;
            }
            indexes[i]++;
        }
    }

    public static int diffCount(int[] counts) {
        int min = Integer.MAX_VALUE;
        int max = 0;
        for (int c : counts) {
            if (c < min) {
                min = c;
            }
            if (c > max) {
                max = c;
            }
        }
        return max - min;
    }

    public static String result(String[] stringArray) {
        int N = stringArray.length;
        int[] indexes = new int[N];
        char[][] chars = new char[N][];
        for (int i = 0; i < stringArray.length; i++) {
            String s = stringArray[i];
            chars[i] = s.toCharArray();
        }

        int diff = 0;
        while (indexesBeforeEnd(chars, indexes)) {
            if (!allCharsIdentical(chars, indexes)) {
                return "Fegla Won";
            }
            int[] counts = new int[N];
            moveIndexesToEndOfChain(chars, indexes, counts);
            diff += diffCount(counts);
        }
        if (indexesBeforeEnd(chars, indexes)) {
            return "Fegla Won";
        }
        return String.valueOf(diff);
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {

            int N = Integer.valueOf(linesIterator.next());
            String[] stringArray = new String[N];
            for (int k = 0; k < N; k++) {
                stringArray[k] = linesIterator.next();
            }

            Files.append("Case #" + i + ": " + result(stringArray) + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}
