package codejam2015.qualif.B;

import com.google.common.io.Files;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class ProblemB {
    private final static String prefix = "src/main/java/codejam2015/qualif/C/";
    private final static String problem = "B";
    private final static String dataset = "small-attempt3";

    private static int step(Integer[] pancakes) {
        int count = 0;
        for (int i = 0; i < pancakes.length; i++) {
            pancakes[i] = Math.max(pancakes[i] - 1, 0);
            if (pancakes[i] > 0) {
                count++;
            }
        }
        return count;
    }

    private static int result(Integer[] pancakes, int nonEmpty) {
        Arrays.sort(pancakes, Collections.reverseOrder());

        if (pancakes[0] == 0) {
            return 0;
        }
        if (pancakes[0] % 2 == 1) {
            nonEmpty = step(pancakes);
            return 1 + result(pancakes, nonEmpty);
        }

        Integer[] step = Arrays.copyOf(pancakes, nonEmpty);
        int nonEmptyStep = step(step);
        int resultStep = 1 + result(step, nonEmptyStep);

        Integer[] split = Arrays.copyOf(pancakes, nonEmpty);
        split[0] /= 2;
        int resultSplit = 1 + result(split, nonEmpty);

        return Math.min(resultSplit, resultStep);



//        int result = 0;
//        while (pancakes[0] > 0) {
//            if (pancakes[0] % 2 == 1) {
//                nonEmpty = step(pancakes);
//                result++;
//            }
//            if (pancakes[0] == 0) {
//                return result;
//            }
//            if (pancakes[0] > 2 * nonEmpty) {
//                pancakes[0] /= 2;
//                result++;
//                Arrays.sort(pancakes, Collections.reverseOrder());
//            } else {
//                nonEmpty = step(pancakes);
//                result++;
//            }
//        }
//
//        return result;
    }

    public static void main(String[] args) throws IOException {
        List<String> lines = Files.readLines(new File(prefix + problem + "-" + dataset + ".in"), Charset.defaultCharset());
        Iterator<String> linesIterator = lines.iterator();
        int T = Integer.valueOf(linesIterator.next());
        File out = new File(prefix + problem + "-" + dataset + ".out");
        Files.write("", out, Charset.defaultCharset());
        for (int i = 1; i <= T; i++) {
            int D = Integer.valueOf(linesIterator.next());
            String[] P = linesIterator.next().split(" ");
            Integer[] pancakes = new Integer[P.length];
            for (int j = 0; j < P.length; j++) {
                pancakes[j] = Integer.valueOf(P[j]);
            }

            String result = String.valueOf(result(pancakes, pancakes.length));
            System.out.println(result);

            Files.append("Case #" + i + ": " + result + System.getProperty("line.separator"), out, Charset.defaultCharset());
        }
    }
}