import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;


public class Dijkstra {

	public static void main(String[] args) throws NumberFormatException, IOException{
		
		BufferedReader br = new BufferedReader(new FileReader(args[0]));
		int cases = Integer.parseInt(br.readLine());
		for(int i=0; i<cases; i++){
			String in = br.readLine();
			String[] inSplit = in.split(" ");
			int length = Integer.parseInt(inSplit[0]);
			int reps = Integer.parseInt(inSplit[1]);
			boolean solFound = false;
			String in2 = br.readLine();
			String[] segW = in2.split("");
			String[] seg = new String[length];
			for(int j=0; j<length; j++){
				seg[j] = segW[j+1];
			}
			String current = "1";
			String next = "";
			String rest = "";
			int one=0, two=0, three = 0;
			outer: for(one=0; one<length*reps-2; one++){
				next = seg[one%length];
				current = calcCurrent(current,next);
				if (current.equals("i")){
					current="1";
					rest ="";
					for(two=one+1;two<length*reps-1;two++){
						next = seg[two%length];
						current = calcCurrent(current,next);
						if (rest.equals("")){
							rest="1";
							for(three=two+1;three<length*reps;three++){
								next = seg[three%length];
								rest = calcCurrent(rest,next);
							}
						}else{
							rest = divCurrent(rest,next);
						}
						if (current.equals("j") && rest.equals("k")){
							solFound = true;
							break outer;
						}
					}
					current="i";
				}
			}
			if (solFound == true){
				System.out.format("Case #%d: YES\n", i+1);
			}else{
				System.out.format("Case #%d: NO\n", i+1);
			}
		}
		
	}
	
	public static String calcCurrent(String current, String next){
		if (current.equals("1")) {
			current = next;
		}
		else if (current.equals("-1")){
			current = "-" + next;
		}
		else if (current.equals("i")){
			if (next.equals("1")) current = "i";
			if (next.equals("-1")) current = "-i";
			if (next.equals("i")) current = "-1";
			if (next.equals("-i")) current = "1";
			if (next.equals("j")) current = "k";
			if (next.equals("-j")) current = "-k";
			if (next.equals("k")) current = "-j";
			if (next.equals("-k")) current = "j";
		}
		else if (current.equals("-i")){
			if (next.equals("1")) current = "-i";
			if (next.equals("-1")) current = "i";
			if (next.equals("i")) current = "1";
			if (next.equals("-i")) current = "-1";
			if (next.equals("j")) current = "-k";
			if (next.equals("-j")) current = "k";
			if (next.equals("k")) current = "j";
			if (next.equals("-k")) current = "-j";
		}
		else if (current.equals("j")){
			if (next.equals("1")) current = "j";
			if (next.equals("-1")) current = "-j";
			if (next.equals("i")) current = "-k";
			if (next.equals("-i")) current = "k";
			if (next.equals("j")) current = "-1";
			if (next.equals("-j")) current = "1";
			if (next.equals("k")) current = "i";
			if (next.equals("-k")) current = "-i";
		}
		else if (current.equals("-j")){
			if (next.equals("1")) current = "-j";
			if (next.equals("-1")) current = "j";
			if (next.equals("i")) current = "k";
			if (next.equals("-i")) current = "-k";
			if (next.equals("j")) current = "1";
			if (next.equals("-j")) current = "-1";
			if (next.equals("k")) current = "-i";
			if (next.equals("-k")) current = "i";
		}
		else if (current.equals("k")){
			if (next.equals("1")) current = "k";
			if (next.equals("-1")) current = "-k";
			if (next.equals("i")) current = "j";
			if (next.equals("-i")) current = "-j";
			if (next.equals("j")) current = "-i";
			if (next.equals("-j")) current = "i";
			if (next.equals("k")) current = "-1";
			if (next.equals("-k")) current = "1";
		}
		else if (current.equals("-k")){
			if (next.equals("1")) current = "-k";
			if (next.equals("-1")) current = "k";
			if (next.equals("i")) current = "-j";
			if (next.equals("-i")) current = "j";
			if (next.equals("j")) current = "i";
			if (next.equals("-j")) current = "-i";
			if (next.equals("k")) current = "1";
			if (next.equals("-k")) current = "-1";
		}
		return current;
	}
	
	public static String divCurrent(String current, String next){
		if (current.equals("1")) {
			if (next.equals("1")) current = "1";
			if (next.equals("-1")) current = "-1";
			if (next.equals("i")) current = "-i";
			if (next.equals("-i")) current = "i";
			if (next.equals("j")) current = "-j";
			if (next.equals("-j")) current = "j";
			if (next.equals("k")) current = "-k";
			if (next.equals("-k")) current = "k";
		}
		else if (current.equals("-1")){
			if (next.equals("1")) current = "-1";
			if (next.equals("-1")) current = "1";
			if (next.equals("i")) current = "i";
			if (next.equals("-i")) current = "-i";
			if (next.equals("j")) current = "j";
			if (next.equals("-j")) current = "-j";
			if (next.equals("k")) current = "k";
			if (next.equals("-k")) current = "-k";
		}
		else if (current.equals("i")){
			if (next.equals("1")) current = "i";
			if (next.equals("-1")) current = "-i";
			if (next.equals("i")) current = "1";
			if (next.equals("-i")) current = "-1";
			if (next.equals("j")) current = "k";
			if (next.equals("-j")) current = "-k";
			if (next.equals("k")) current = "-j";
			if (next.equals("-k")) current = "j";
		}
		else if (current.equals("-i")){
			if (next.equals("1")) current = "-i";
			if (next.equals("-1")) current = "i";
			if (next.equals("i")) current = "-1";
			if (next.equals("-i")) current = "1";
			if (next.equals("j")) current = "-k";
			if (next.equals("-j")) current = "k";
			if (next.equals("k")) current = "j";
			if (next.equals("-k")) current = "-j";
		}
		else if (current.equals("j")){
			if (next.equals("1")) current = "j";
			if (next.equals("-1")) current = "-j";
			if (next.equals("i")) current = "-k";
			if (next.equals("-i")) current = "k";
			if (next.equals("j")) current = "1";
			if (next.equals("-j")) current = "-1";
			if (next.equals("k")) current = "i";
			if (next.equals("-k")) current = "-i";
		}
		else if (current.equals("-j")){
			if (next.equals("1")) current = "-j";
			if (next.equals("-1")) current = "j";
			if (next.equals("i")) current = "k";
			if (next.equals("-i")) current = "-k";
			if (next.equals("j")) current = "-1";
			if (next.equals("-j")) current = "1";
			if (next.equals("k")) current = "-i";
			if (next.equals("-k")) current = "i";
		}
		else if (current.equals("k")){
			if (next.equals("1")) current = "k";
			if (next.equals("-1")) current = "-k";
			if (next.equals("i")) current = "j";
			if (next.equals("-i")) current = "-j";
			if (next.equals("j")) current = "-i";
			if (next.equals("-j")) current = "i";
			if (next.equals("k")) current = "1";
			if (next.equals("-k")) current = "-1";
		}
		else if (current.equals("-k")){
			if (next.equals("1")) current = "-k";
			if (next.equals("-1")) current = "k";
			if (next.equals("i")) current = "-j";
			if (next.equals("-i")) current = "j";
			if (next.equals("j")) current = "i";
			if (next.equals("-j")) current = "-i";
			if (next.equals("k")) current = "-1";
			if (next.equals("-k")) current = "1";
		}
		return current;
	}
}
