import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.*;

/**
 * Created by aectann on 4/05/14.
 */
public class C {

    public static void main(String[] args) throws FileNotFoundException {
        try (PrintWriter pw = new PrintWriter(new File("/home/aectann/csmall3.out"))) {
//        try (PrintWriter pw = new PrintWriter(System.out)) {
            Scanner s = new Scanner(new File("/home/aectann/Downloads/csmall3.in"));
//            Scanner s = new Scanner(System.in);
            int t = s.nextInt();
            for (int i = 0; i < t; i++) {
                solve(i + 1, s, pw);
            }
        }
    }


    private static void solve(int caseNumber, Scanner s, PrintWriter pw) {
        int N = s.nextInt();
        int M = s.nextInt();
        int[] zip = new int[N];
        int min = Integer.MAX_VALUE;
        int start = -1;
        for (int i = 0; i < N; i++) {
            zip[i] = s.nextInt();
            if (min > zip[i]) {
                min = zip[i];
                start = i;
            }
        }
        Graph G = new Graph(N);
        for (int i = 0; i < M; i++) {
            G.addEdge(s.nextInt()-1, s.nextInt()-1);
        }
        boolean[] visited = new boolean[N];
        PriorityQueue<City> pq = new PriorityQueue<>();
        pq.add(new City(start, zip[start], 0));
        StringBuilder r = new StringBuilder();
        HashSet<Integer> onQ = new HashSet<>();
        onQ.add(start);
        while(!pq.isEmpty()) {
            City c = pq.poll();
            onQ.remove(c.index);
            if (!visited[c.index]) {
                r.append(c.zip);
                visited[c.index] = true;
                for (Integer next : G.adj(c.index)) {
                    if (!visited[next]) {
                        int back = back(G, c.index, next, visited, onQ, new boolean[N]);
                        pq.add(new City(next, zip[next], back));
                        onQ.add(next);
                    }
                }
            }

        }
        pw.println("Case #" + caseNumber + ": " + r);
    }

    private static int back(Graph g, Integer current, Integer next, boolean[] visited, HashSet<Integer> onQ, boolean[] v) {
        v[next] = true;
        for (Integer c : g.adj(next)) {
            if (c != current && !v[c]) {
                if (visited[c] || onQ.contains(c)) {
                    return 1;
                } else {
                    return back(g, current, c, visited, onQ, v);
                }
            }
        }
        return 0;
    }

    private static class City implements Comparable<City> {
        private final int index;
        int zip;
        int end;

        public City(int i, int z, int end) {
            this.index = i;
            this.zip = z;
        }

        @Override
        public int compareTo(City o) {
            int i = -(o.end - end);
            return i == 0 ? -(o.zip - zip) : i;
        }

        @Override
        public boolean equals(Object obj) {
            return index == ((City)obj).index;
        }

        @Override
        public int hashCode() {
            return index;
        }
    }
}
