import java.io.BufferedOutputStream;
import java.io.IOException;
import java.util.Scanner;

public class Magician {
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(System.in);
		BufferedOutputStream out = new BufferedOutputStream(System.out);
//		Scanner sc = new Scanner(new File("files/A-small-attempt0.in"));
//		BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream("files/A-small-attempt0.out"));
		int[][] matrix1 = new int[4][4];
		int[][] matrix2 = new int[4][4];
		
		int t = sc.nextInt(); // test cases
		for (int n = 1; n <= t; n++) {
			int a1 = sc.nextInt(); // first answer 
			getMatrix(sc, matrix1); // the first configuration
			int a2 = sc.nextInt(); // second answer
			getMatrix(sc, matrix2); // the second matrix configuration
			Search result = searchEqualItems(matrix1[a1 - 1], matrix2[a2 - 1]);

			if (result.count == 1) 
				out.write(getString("Case #" + n + ": " + result.items[0]).getBytes());
			else if (result.count > 1)
				out.write(getString("Case #" + n + ": Bad magician!").getBytes());
			else
				out.write(getString("Case #" + n + ": Volunteer cheated!").getBytes());
		}
		
		sc.close();
		out.close();
	}

	private static void getMatrix(Scanner sc, int[][] matrix) {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				matrix[i][j] = sc.nextInt();
			}
		}
	}
	
	public static String getString(String something) {
		return something + "\n";
	}
	
	public static Search searchEqualItems(int[] rx, int[] ry) {
		Search s = new Search();
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (rx[i] == ry[j]) {
					s.items[s.count++] = rx[i];
					break;
				}
			}
		}
		return s;
	}

	private static class Search {
		private int count;
		private int[] items = new int[4];
	}
}