package br.com.hastronauta;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class SheepSolution {

	public static void main(String[] args) throws IOException {
		String inputFileName = args[0];

		BufferedWriter writer = getWriter(args);
		SheepSolution solution = new SheepSolution();

		try (Scanner sc = new Scanner(new FileInputStream(inputFileName))) {
			int testCases = sc.nextInt();

			for (int T = 1; T <= testCases; T++) {

				long n = sc.nextLong();
				String count = solution.count(n);
				writer.append(String.format("Case #%d: %s\n", T, count));

			}
		}

		writer.close();
	}

	public String count(long n) {
		if (n == 0) return "INSOMNIA";

		Set<Character> digits = new HashSet<>();

		long i = 1;
		long last = 0;

		while (digits.size() < 10) {
			last = n * i++;
			char[] tmp = Long.toString(last).toCharArray();
			for (int k = 0; k < tmp.length; k++) {
				digits.add(tmp[k]);
			}
		}

		return Long.toString(last);
	}

	private static BufferedWriter getWriter(String[] args) throws IOException {
		String outputFileName = args[0].substring(0, args[0].length() - 3) + ".out";
		outputFileName = outputFileName.replaceAll("input", "output");
		File outputFile = new File(outputFileName);
//		outputFile.mkdir();

		BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
		return writer;
	}

}
