import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;
import java.util.TreeSet;

public class B {
	public static void main(String[] args) throws FileNotFoundException {
		//Scanner scan = new Scanner(System.in);
		Scanner scan = new Scanner(new FileInputStream(new File("B-small-attempt0.in")));
		int T = scan.nextInt();
		for(int t=1;t<=T;t++){
			int N = scan.nextInt();
			int C = scan.nextInt();
			int M = scan.nextInt();
			
			ArrayList<Ticket> list =new ArrayList<>();
			int[] count = new int[C];
			int minrides = 0;
			for(int i=0;i<M;i++){
				int s = scan.nextInt()-1, b = scan.nextInt()-1;
				count[b]++;
				minrides = Math.max(minrides, count[b]);
				list.add(new Ticket(s,b,i));
			}
			
			Collections.sort(list);
			
			int lo = minrides, hi = 1000, sol = -1, bestcost = -1;
			while(lo<=hi){
				int mid = lo+hi>>1;
				
				boolean valid = true;
				TreeSet<Integer>[] seats = new TreeSet[mid];
				boolean[][] used = new boolean[C][mid];
				for(int i=0;i<mid;i++)seats[i] = new TreeSet<>();
				for(int i=0;i<mid;i++)
					for(int j=0;j<N;j++)
						seats[i].add(j);
				
				int cost = 0;
				for(Ticket i : list){
					boolean found = false;
					
					for(int j=0;j<mid;j++){
						if(used[i.buyer][j])continue;
						Integer a = seats[j].floor(i.seat);
						if(a==null)continue;
						if(a==i.seat){
							found=true;
							seats[j].remove(a);
							used[i.buyer][j]=true;
							break;
						}
					}
					
					if(found)continue;
					
					for(int j=0;j<mid;j++){
						if(used[i.buyer][j])continue;
						Integer a = seats[j].floor(i.seat);
						if(a==null)continue;
						cost++;
						found=true;
						seats[j].remove(a);
						used[i.buyer][j]=true;
						break;
					}
					if(!found){
						valid=false;
						break;
					}
				}
				
				if(!valid){
					lo=mid+1;
				}else{
					sol = mid;
					bestcost = cost;
					hi=mid-1;
				}
			}
			
			System.out.println("Case #"+t+": "+sol+" "+bestcost);
			
		}
	}
	private static class Ticket implements Comparable<Ticket> {
		int seat, buyer, idx;
		public Ticket(int seat, int buyer, int idx) {
			this.seat = seat;
			this.buyer = buyer;
		}
		public int compareTo(Ticket o) {
			if(this.seat==o.seat)return Integer.compare(idx, o.idx);
			else return Integer.compare(this.seat, o.seat);
		}
	}
	
	
}
