import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

class compBigInt implements Comparator<BigInteger> {

	@Override
	public int compare(BigInteger b0, BigInteger b1) {
		return(-b0.compareTo(b1));
	}
	
}

public class CBathroomStalls {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
	    for (int i = 1; i <= t; ++i) {
	      BigInteger N = in.nextBigInteger();
	      BigInteger K = in.nextBigInteger();
	      BigInteger[] res = lsrs(N, K);
	      
	      System.out.println("Case #" + i + ": " + res[0] + " " + res[1]);
	    }
	    in.close();
	  }
	
	public static BigInteger[] lsrs(BigInteger N, BigInteger K) {
		BigInteger[] res = new BigInteger[2];
		BigInteger[] div = new BigInteger[2];
		BigInteger count = K;
		BigInteger deux = BigInteger.ONE.add(BigInteger.ONE);
		
		PriorityQueue<BigInteger> q = new PriorityQueue<BigInteger>(1, new compBigInt());
		q.add(N);
		
		while(count.compareTo(BigInteger.ZERO) > 0)
		{
			BigInteger best = q.poll();
			//System.out.println(best);
			div = best.subtract(BigInteger.ONE).divideAndRemainder(deux);
			q.add(div[0].add(div[1]));
			q.add(div[0]);
			count = count.subtract(BigInteger.ONE);
		}
		
		res[0] = div[0].add(div[1]);
		res[1] = div[0];
		
		return res;
	}
	
	
}
