/* 
 * fairwarning.java
 * Benson Khau
 */

import java.io.*;
import java.util.*;
import java.lang.Math;
import java.math.BigInteger;

public class fairwarning
{
  /* Human time is important, too!
   */
  public static boolean debug = true; // false if don't want debug print
  public static void pl(String s){if(debug)System.out.println(s);}
  public static void p(String s) {if(debug)System.out.print(s);}
  
  public static void main(String[] args) throws IOException
  {
    Scanner s = new Scanner(System.in);
    int test_cases = s.nextInt();
    for(int k = 0; k < test_cases; k++)
    {
      runAnalysis(s, k+1);
    }
  }
  
  // Does the grunt work.  Ideally it would be more modular but it isn't :)...
  public static void runAnalysis(Scanner s, int iteration) throws IOException
  {
    int events = s.nextInt();
    BigInteger[] times = new BigInteger[events];
    BigInteger max = new BigInteger("0");
    BigInteger uninit = new BigInteger("-1");
    BigInteger min = new BigInteger("-1");
    for(int j = 0; j < events; j++)
    {
      BigInteger num = new BigInteger(s.next());
      times[j] = num;
      if(max.compareTo(num)<0)
        max = num;
      if(min.compareTo(num)>0 || min.compareTo(uninit)==0)
        min = num;
    }
    
    // The maximum amount of time we're willing to spend finding the answer
    BigInteger diff = max.subtract(min);
    /* Notes:
     * Find y such that
     *   y is the minimum number of ssec until t_i + y is a multiple of
     *   largest possible integer factor T for all the times.
     * gcd(y,b) = gcd(b, y+b)
     * gcd(a,y) = gcd(a, y+a)
     */
    BigInteger max_gcd = new BigInteger("1");
    BigInteger index = new BigInteger("0");
    BigInteger zero = new BigInteger("0");
    BigInteger one = new BigInteger("1");
    BigInteger i_gcd = times[0].gcd(times[1]);
    for(int i = 2; i < times.length; i++)
    {
      if(i_gcd.compareTo(one) == 0)
        break;
      i_gcd = i_gcd.gcd(times[i]);
    }
    BigInteger gcd;
    // The secret? is adding the new gcd every time you compute it.
    // This works for things that become not-so-relatively prime eventually..
    // But it takes hella long if everything stays relatively prime..
    for(BigInteger j = zero; j.compareTo(diff)<0; j=j.add(gcd))
    {
      BigInteger gcdeven = times[0];
      BigInteger gcdodd  = times[1];
      /*
       * Find the GCD
       */
      // This takes hella long.
      for(int i = 2; i < times.length; i+=2)
      { 
        //If you ever find that you have a relatively prime pair
        if(gcdeven.compareTo(one) == 0)
          break;
        gcdeven = gcdeven.gcd(times[i]);
      }
      for(int i = 3; i < times.length; i+=2)
      { 
        //If you ever find that you have a relatively prime pair
        if(gcdodd.compareTo(one) == 0)
          break;
        gcdodd = gcdodd.gcd(times[i]);
      }
      gcd = gcdeven.gcd(gcdodd);
      /*
       * Check if it's better
       */
      if(max_gcd.compareTo(gcd) < 0)
      {
        max_gcd = gcd;
        index = j;
      }
      /*
       * Update the array for the next pass..
       */
      for(int i = 0; i < times.length; i+=2)
      {
        times[i] = times[i].add(gcd);
        if(i+1 < times.length)
          times[i+1] = times[i+1].add(gcd);
      }
    }
    System.out.println("Case #" + iteration + ": " + index);
  }
}