/* 
 * rotate.java
 * Benson Khau
 */

import java.io.*;
import java.util.*;
import java.lang.Math;

public class rotate
{
  /* Human time is important, too!
   */
  public static boolean debug = true; // false if don't want debug print
  public static void pl(String s){if(debug)System.out.println(s);}
  public static void p(String s) {if(debug)System.out.print(s);}
  
  public static void main(String[] args) throws IOException
  {
    Scanner s = new Scanner(System.in);
    int test_cases = s.nextInt();
    for(int k = 0; k < test_cases; k++)
    {
      runAnalysis(s, k+1);
    }
  }
  
  // Does the grunt work.  Ideally it would be more modular but it isn't :)...
  public static void runAnalysis(Scanner s, int iteration) throws IOException
  {
    int dim = s.nextInt();
    int join = s.nextInt();
    
    String red = "";
    String blue= "";
    for(int k = 0; k < join; k++)
    {
      red+="R";
      blue+="B";
    }
    
    /* Notes:
     * Rotation should be simple as swapping... something... right?
     * 
     */
    
    int dim2 = dim*dim;
    char[] board = new char[dim2];
    for(int j = 0; j < dim; j++)
    {
      String str = s.next();
      //pl(str);
      for(int k = 0; k < dim; k++)
      {
        board[j*dim + k] = str.charAt(k);
      }
    }
    char[][] rotated = new char[dim][dim];
    //char[][] rotatedB = new char[dim][dim];
    char[][] shiftedA = new char[dim][dim];
    char[][] shiftedB = new char[dim][dim];
    for(int c = 0; c < dim; c++)
    {
      for(int r = dim-1; r >= 0; r--)
      {
        //pl(c + "");
        shiftedA[c][dim-r-1] = '.';
        shiftedB[c][dim-r-1] = '.';
        rotated[dim-r-1][c] = board[r*dim + c];
        //rotated[c][dim-r-1] = board[r*dim + c];
        //pl("results : " + rotated[c][dim-r-1]);
      }
    }
    // Done rotating.
    for(int r = 0; r < dim; r++)
    {
      int next = dim-1;
      for(int c = dim-1; c >= 0; c--)
      {
        if(rotated[r][c] == 'R' || rotated[r][c] == 'B')
        {
          shiftedA[r][next] = rotated[r][c];
          shiftedB[next][r] = rotated[r][c];
          next--;
        }
      }
    }
    
    // Done shifting
    /*...RRBR 
     *....BRB 
     *.....BB 
     *......R 
     * 
     */ 
    boolean redflag = false;
    boolean blueflag = false;
    // Straight wins
    for(int r = 0; r < dim; r++)
    {
      String strA = new String(shiftedA[r]);
      String strB = new String(shiftedB[r]);
      if(strA.contains(red) || strB.contains(red))
      {redflag = true;}
      if(strA.contains(blue) || strB.contains(blue))
      {blueflag = true;}
    }
    
    // check for a diagonal win (positive slope)
    for (int row=0; row<dim-join+1; row++) {
      for (int column=0; column<dim-join+1; column++) {
        int altrow = row+join-1;
        String strA = "";
        String strB = "";
        for (int j = 0; j < join; j++)
        {
          strA += shiftedA[row+j][column+j];
          strB += shiftedA[altrow-j][column+j];
        }
        if(strA.contains(red) || strB.contains(red))
        {redflag = true;}
        if(strA.contains(blue) || strB.contains(blue))
        {blueflag = true;}
      }
    }
// check for a diagonal win (negative slope)
    /*for (int row=SIZE-3; row<SIZE; row++) {
      for (int column=0; column<SIZE-3; column++) {
        if (grid[column][row] != 0 &&
            grid[column][row] == grid[column+1][row-1] &&
            grid[column][row] == grid[column+2][row-2] &&
            grid[column][row] == grid[column+3][row-3])
        {
          status = -1;
        }
      }
    }*/
    
    /*
     * display code
     *
    for(int r = 0; r < dim; r++)
    {
      for(int c = 0; c < dim; c++)
      {
        p("" + shiftedA[r][c]);
      }
      pl("");
    }*/
    
    String answer = "Neither";
    if(redflag)
    {answer = "Red";}
    if(blueflag)
    {answer = "Blue";}
    if(redflag && blueflag)
    {answer = "Both";}
    System.out.println("Case #"+ iteration + ": "  + answer);
  }
}