/* 
 * themepark.java
 * Benson Khau
 */

import java.io.*;
import java.util.*;
import java.lang.Math;

public class themepark
{
  /* Human time is important, too!
  */
  public static boolean debug = false; // false if don't want debug print
  public static void pl(String s){if(debug)System.out.println(s);}
  public static void p(String s) {if(debug)System.out.print(s);}
  
  public static void main(String[] args) throws IOException
  {
    Scanner s = new Scanner(System.in);
    int test_cases = s.nextInt();
    for(int k = 0; k < test_cases; k++)
    {
      runAnalysis(s, k+1);
    }
  }
  
  // Does the grunt work.  Ideally it would be more modular but it isn't :)...
  public static void runAnalysis(Scanner s, int iteration) throws IOException
  {
    long rides    = s.nextLong();  //Number of times the RC goes
    long capacity = s.nextLong();  //How many people it carries
    int groups   = s.nextInt();  //# of groups
    
    /* Notes:
     * Groups MUST go in order
     * After a group goes, it requeues
     * The rollercoaster will go if it can't fit the next group or
     * is out of groups.
     */
    
    long[] grp_data = new long[groups];
    for(int j = 0; j < groups; j++)
    {
      grp_data[j] = s.nextLong();
      p(" " + grp_data[j]);
    }
    long counter = 0;
    int index = 0;
    for(int r = 0; r < rides; r++)
    {
      int start = index;
      int end = (index+groups-1)%groups;
      long cur_count = 0;
      while(true)
      {
        long next = grp_data[index];
        if(cur_count + next > capacity)
          break;
        //pl("next: " + next);
        cur_count += next;
 
        if(index == end)
        {
          pl("started at " + start);
          pl("reached the end: " + end);
          break;
        }       
        
        index++;
        if(index >= groups)
        { index %= groups; }
      }
      //pl("left with " + cur_count);
      counter += cur_count;
    }
    System.out.println("Case #" + iteration +
                       ": " + counter);
  }
}