import java.util.Scanner;


public class FairAndSquare {

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Scanner scanner = new Scanner(System.in);
		int T = Integer.parseInt(scanner.nextLine());
		
		for (int c = 1; c <= T; c++) {

			int A = scanner.nextInt();
			int B = scanner.nextInt();
			if (scanner.hasNextLine()) scanner.nextLine();
			
			int answer = solve(A, B);
			System.out.println(String.format("Case #%d: %d", c, answer));
		}
	}
	
	private static int solve(long a, long b) {
		int count = 0;
		
		for(long i=a; i<=b; i++) {
			if (isFairAndSquare(i)) count++;
		}
		
		return count;
	}

	private static boolean isFairAndSquare(long num) {
		double sqrt = Math.sqrt(num);
		if (!isSquare((long) sqrt, num)) return false;

		return (isFair(num) && isFair((long) sqrt));
	}

	private static boolean isFair(long num) {
		String word = Long.toString(num);
		
		for(int i=0; i<Math.ceil(word.length()/2); i++) {
			String front = word.substring(i, i+1);
			String back = word.substring(word.length()-1-i, word.length()-i);
			
			if (!front.equals(back)) {
				return false;
			}
		}
		
		return true;
	}
	
	private static boolean isSquare(long root, long answer) {
		return Math.pow(root, 2) == answer;
	}

}
