import java.util.Scanner;

public class Lawnmower {

	public static void main(String[] args) {

		Scanner scanner = new Scanner(System.in);
		int T = Integer.parseInt(scanner.nextLine());
		
		for (int c = 1; c <= T; c++) {
			int N = scanner.nextInt();
			int M = scanner.nextInt();
			scanner.nextLine();

			int[][] a = new int[N][M];
			int tallest = 0;

			for (int i = 0; i < N; i++) {
				String line = scanner.nextLine();
				String[] row = line.split(" ");

				for (int j = 0; j < row.length; j++) {
					int aij = Integer.parseInt(row[j]);
					tallest = Math.max(tallest, aij);
					a[i][j] = aij;
				}
			}

			String answer = solve(a, tallest);
			System.out.println(String.format("Case #%d: %s", c, answer));
		}
	}

	private static String solve(int[][] a, int tallest) {

		for (int i = 0; i < a.length; i++) {
			for (int j = 0; j < a[i].length; j++) {
				if (a[i][j] != tallest && !hasWayAcross(i, j, a))
					return "NO";
			}
		}

		return "YES";
	}

	private static boolean hasWayAcross(int x, int y, int[][] a) {
		boolean fromLeft = true;
		boolean fromRight = true;
		boolean fromTop = true;
		boolean fromBottom = true;

		for (int i = x; i > 0; i--) {
			fromLeft = fromLeft && (a[i][y] >= a[i - 1][y]);
		}
		
		for (int i = x; i < a.length - 1; i++) {
			fromRight = fromRight && (a[i][y] >= a[i + 1][y]);
		}
		
		for (int j = y; j > 0; j--) {
			fromTop = fromTop && (a[x][j] >= a[x][j - 1]);
		}

		for (int j = y; j < a[0].length - 1; j++) {
			fromBottom = fromBottom && (a[x][j] >= a[x][j + 1]);
		}
		
		return (fromLeft && fromRight) || (fromTop && fromBottom);
	}
}
