import java.util.Scanner;


public class TicTacToe {

	public static void main(String[] args) {

		Scanner scanner = new Scanner(System.in);
		
		int N = Integer.parseInt(scanner.nextLine());

		String[][] board = new String[4][4];
		
		for(int c=1; c<=N; c++) {
			for(int y=0; y<4; y++) {
				String line = scanner.nextLine();
				String[] row = new String[4];
				for(int x=0; x<4; x++) {
					row[x] = line.substring(x,x+1);
				}
				board[y] = row;
			}
			
			if (scanner.hasNextLine()) scanner.nextLine();
			
			String answer = solve(board);
			System.out.println(String.format("Case #%d: %s", c, answer));
		}
	}
	
	private static String solve(String[][] board) {
		String winner = "";
		String line = "";
		boolean hasEmpty = false;
		
		for(int y=0; y<4; y++) {
			line = new StringBuilder(board[0][y]).append(board[1][y]).append(board[2][y]).append(board[3][y]).toString();
			if (line.contains(".")) hasEmpty = true;
			
			winner = checkWinner(line);
			
			if (!winner.equals("")) {
				return winner + " won";
			}
		}
		
		for(int x=0; x<4; x++) {
			line = new StringBuilder(board[x][0]).append(board[x][1]).append(board[x][2]).append(board[x][3]).toString();
			winner = checkWinner(line);
			
			if (!winner.equals("")) {
				return winner + " won";
			}
		}
		
		line = new StringBuilder(board[0][0]).append(board[1][1]).append(board[2][2]).append(board[3][3]).toString();
		winner = checkWinner(line);
		
		if (!winner.equals("")) {
			return winner + " won";
		}
		
		line = new StringBuilder(board[3][0]).append(board[2][1]).append(board[1][2]).append(board[0][3]).toString();
		winner = checkWinner(line);
		
		if (!winner.equals("")) {
			return winner + " won";
		}
		
		return (hasEmpty) ? "Game has not completed":"Draw";
	}

	private static String checkWinner(String line) {
		String win = "";
		
		for(int i=0; i<line.length(); i++) {
			String cur = line.substring(i,i+1);
			if (cur.equals(".")) return "";
			
			if (!cur.equals("T")) {
				if (win.equals("")) win = cur;
				else if (!cur.equals(win)) return "";
			}
		}
		
		return win;
	}
}
