import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * @author Yaroslav
 * @since 11-Apr-15
 */
public class ProblemCDijkstra {

    /**
     * Usage: java ProblemCDijkstra < fileIn.txt > fileOut.txt
     *
     * @param args
     */


    public static void main(String[] args) throws FileNotFoundException {

        Scanner scanner = new Scanner(System.in);
        byte testCount = scanner.nextByte();

        for (byte t = 0; t < testCount; t++) {
            // read and transform inputs
            int L = scanner.nextInt();
            int X = scanner.nextInt();
            String S = scanner.next();

            // validate a string to multiply
            String[] S_arr = S.split("(?!^)");

            // if the string consists only of i j or k then return NO
            boolean valid = false;
            String prev = S_arr[0];
            for (int i = 1; i < S_arr.length; i++) {
                if (!prev.equals(S_arr[i])) {
                    valid = true;
                    break;
                }
            }
            if (!valid) {
                NO(t+1);
                continue; // proceed to the next test case
            }

            // build a string - able to solve only a small input, because capacity is int value, not long
            StringBuilder sb = new StringBuilder(X * L);
            for (int i = 0; i < X; i++) {
                sb.append(S);
            }

            String[] s = sb.toString().split("(?!^)");

            // System.out.println("Case #" + (t + 1) + ": " + "L=" + L + " X=" + X+ " s=" + Arrays.toString(s));

            if (s.length < 3) {
                NO(t + 1);
                continue; // proceed to the next test case
            }

            if (s.length == 3) {
                if ("i".equals(s[0]) && "j".equals(s[1]) && "k".equals(s[2])) {
                    YES(t+1);
                } else {
                    NO(t+1);
                }
                continue; // proceed to the next test case
            }

            int timesToSkipI = 0;
            mainLoop:
            while(true) {
                int indexI = resolve(s, "i", timesToSkipI);
                if (indexI < 0)  {
                    NO(t+1);
                    break mainLoop;
                }

                String[] s2 = new String[s.length - indexI];
                System.arraycopy(s, indexI, s2, 0, s2.length);

                // System.out.println("Found i at " + indexI + ". Looking for j in " + Arrays.toString(s2));

                int timesToSkipJ = 0;
                while(true) {
                    int indexJ = resolve(s2, "j", timesToSkipJ);
                    if (indexJ < 0) {
                        timesToSkipI++; // try to find another I
                        break;
                    }

                    String[] s3 = new String[s2.length - indexJ];
                    System.arraycopy(s2, indexJ, s3, 0, s3.length);

                    // System.out.println("Found j at " + indexJ + ". Looking for k in " + Arrays.toString(s3));

                    int indexK = resolve(s3, "k", 0);
                    if (indexK < 0) {
                        timesToSkipJ++; // try to find another J
                        continue;
                    }
                    YES(t+1);
                    break mainLoop;
                }
            }
        }
    }

    private static int resolve(String[] s, String lookup, int timesToSkip) {
        if (s.length < 2)
            return -1;

        int resolvedAtIndex = -1;

        String prev = s[0];
        for (int i = 1; i < s.length; i++) {
            if (lookup.equals(prev)) {
                timesToSkip--;
                if (timesToSkip <0)
                    return i;
            }

            prev = Q.get(prev, s[i]);
        }

        if (lookup.equals(prev))
            return s.length;

        return resolvedAtIndex;
    }

    private static void YES(int caseNum) {
        System.out.println("Case #" + caseNum + ": YES");
    }

    private static void NO(int caseNum) {
        System.out.println("Case #" + caseNum + ": NO");
    }
}




class Q {

    static Map<String, Integer> arrayIndexMap = new HashMap<String, Integer>();
    static {
        arrayIndexMap.put("1", 0);
        arrayIndexMap.put("i", 1);
        arrayIndexMap.put("j", 2);
        arrayIndexMap.put("k", 3);
        arrayIndexMap.put("-1", 4);
        arrayIndexMap.put("-i", 5);
        arrayIndexMap.put("-j", 6);
        arrayIndexMap.put("-k", 7);
    }

    static String[][] array = new String[][]
            {
                    {"1", "i", "j", "k", "-1", "-i", "-j", "-k"},
                    {"i", "-1", "k", "-j", "-i", "1", "-k", "j"},
                    {"j", "-k", "-1", "i", "-j", "k", "1", "-i"},
                    {"k", "j", "-i", "-1", "-k", "-j", "i", "1"},
                    {"-1", "-i", "-j", "-k", "1", "i", "j", "k"},
                    {"-i", "1", "-k", "j", "i", "-1", "k", "-j"},
                    {"-j", "k", "1", "-i", "j", "-k", "-1", "i"},
                    {"-k", "-j", "i", "1", "k", "j", "-i", "-1"}
            };


    public static String get(String arg1, String arg2) {
        return array[arrayIndexMap.get(arg1)] [arrayIndexMap.get(arg2)];
    }
}