import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Yaroslav
 * @since 11-Apr-15
 */
public class ProblemBInfiniteHouseOfPancakes {

    /**3
     * Usage: java ProblemBInfiniteHouseOfPancakes < fileIn.txt > fileOut.txt
     *
     * @param args
     */
    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(System.in);
        byte testCount = scanner.nextByte();

        for (byte t = 0; t < testCount; t++) {
            // read and transform inputs
            int Dnum = scanner.nextInt(); // the number of diners with non-empty plates

            int[] pancakes = new int[Dnum];
            for (int i = 0; i < Dnum; i++) {
                pancakes[i] = scanner.nextInt();
            }


            int minutesSpent = 0;

            while (true) {
                Arrays.sort(pancakes); // sort ascending

                int maxHeight = pancakes[pancakes.length - 1];
                if (maxHeight <= 3) {
                    minutesSpent += maxHeight;
                    break;
                }

                if (pancakes.length == 1 || maxHeight != pancakes[pancakes.length - 2]) {
                    // do the split
                    minutesSpent++;
                    pancakes = splitPancakes(pancakes);
                } else {
                    int maxHeightElementsCount = 1;
                    int i = pancakes.length - 2;
                    for (; i >= 0 && pancakes[i] == maxHeight; i--) {
                        maxHeightElementsCount++;
                    }

                    int maxHeightIfSplit;

                    if (isPowerOf3(maxHeight) && maxHeightElementsCount == 1 && (!contains(pancakes, (maxHeight + 1) / 2) && !contains(pancakes, (maxHeight / 2)))) {
                        maxHeightIfSplit = maxHeight / 3 * 2;
                    } else {
                        maxHeightIfSplit = (maxHeight + 1) / 2;
                    }

                    if (i >= 0) {
                        maxHeightIfSplit = Math.max(pancakes[i], maxHeightIfSplit);
                    }

                    if (maxHeightElementsCount + maxHeightIfSplit <= maxHeight) {
                        // do the split
                        minutesSpent++;
                        pancakes = splitPancakes(pancakes);
                    } else {
                        minutesSpent += maxHeight;
                        break;
                    }
                }
            }

            System.out.println("Case #" + (t + 1) + ": " + minutesSpent);
        }
    }

    private static int[] splitPancakes(int[] pancakes) {
        int[] newArray = Arrays.copyOf(pancakes, pancakes.length+1);
        int origVal = pancakes[pancakes.length-1];

        int val1, val2;
        if (isPowerOf3(origVal) && (pancakes.length == 1 || !isPowerOf3(pancakes[pancakes.length - 2]) && (!contains(pancakes, (origVal + 1) / 2) && !contains(pancakes, (origVal / 2))))) {
            val1 = origVal / 3;
            val2 = origVal / 3 * 2;
        } else {
            val1 = (origVal + 1) / 2;
            val2 = origVal / 2;
        }
        newArray[pancakes.length-1] = val1;
        newArray[pancakes.length] = val2;
        //System.out.println("Split " + Arrays.toString(pancakes) + " to " + Arrays.toString(newArray));
        return newArray;
    }

    private static boolean isPowerOf3(int n) {
        while (n % 3 == 0) {
            n /= 3;
        }
        return n == 1;
    }

    private static boolean contains(final int[] array, final int key) {
        return Arrays.binarySearch(array, key) >= 0;
    }

}