import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.Random;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

/**
 * Usage: java MainClassName < fileIn.txt > fileOut.txt
 */
public class GCJ2017QB {

    private static class InputData {
        long N;

        InputData(Scanner in) {
            N = in.nextLong();
        }

        /**
         * Main method to solve the problem
         */
        void solve(PrintWriter out) {
            out.println(solve(N));
        }


        String solve(long n) {
            String s = String.valueOf(n);
            int idx = isTidy(s);
            if (idx == -1) return s;

            long remainder = Long.valueOf(s.substring(idx));
            long m = (s.charAt(idx) - 48) * (long) Math.pow(10, s.length() - idx - 1) - 1;

            n = n - remainder + m;

            return solve(n);
        }
    }

    static class Solver implements Callable<String> {

        InputData data;

        Solver(InputData data) {
            this.data = data;
        }

        @Override
        public String call() {
            StringWriter out = new StringWriter();
            data.solve(new PrintWriter(out));
            return out.toString();
        }

    }

    public static void main(String[] args) {
        try {
            // Scanner in = new Scanner(new File("C:\\Dropbox\\java\\projects\\google-codejam-2014\\inputs\\qualification\\Problem C. Minesweeper Master - small.txt"));
            Scanner in = new Scanner(System.in);

            ExecutorService service = Executors.newFixedThreadPool(NUM_THREADS);

            int testCount = in.nextInt();
            @SuppressWarnings("unchecked")
            Future<String>[] ts = new Future[testCount];
            for (int test = 0; test < testCount; test++) {
                ts[test] = service.submit(new Solver(new InputData(in)));
            }
            for (int test = 0; test < testCount; ++test) {
                while (!ts[test].isDone()) {
                    Thread.sleep(500);
                }
                System.err.println("Test " + (test + 1));
                out.print("Case #" + (test + 1) + ": ");
                out.print(ts[test].get());
            }
            service.shutdown();

            out.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private final static PrintStream out = System.out;
    private final static int NUM_THREADS = 10;


    private static String bruteForce(long n) {
        // decrease number by one and check if it is a tidy or not

        String s = String.valueOf(n);
        while (isTidy(s) >= 0) {
            n = n - 1;
            s = String.valueOf(n);
        }

        return s;
    }

    // returns the index where it is not tidy, otherwise returns -1
    private static int isTidy(String s) {
        for (int i = 0; i < s.length() - 1; i++) {
            if (s.charAt(i) > s.charAt(i + 1)) {
                return i;
            }
        }
        return -1;
    }
}

