import java.io.FileNotFoundException;
import java.util.LinkedList;
import java.util.Scanner;

/**
 * @author Yaroslav
 * @since 12-Apr-14
 */
public class ProblemAMagicTrick {

    /**
     * Usage: java ProblemAMagicTrick < fileIn.txt > fileOut.txt
     * @param args
     * @throws FileNotFoundException
     */
    public static void main(String[] args) throws FileNotFoundException {
        Scanner input = new Scanner(System.in);
        byte testsCount = input.nextByte();

        for (byte i = 0; i < testsCount; i++) {
            byte row1 = input.nextByte();
            ByteHashSet cardSet1 = getCards(row1, input);
            byte row2 = input.nextByte();
            ByteHashSet cardSet2 = getCards(row2, input);

            LinkedList<Byte> commonCards = cardSet1.intersection(cardSet2);
            System.out.print("Case #" + (i+1) + ": ");
            switch (commonCards.size()) {
                case 0: {
                    System.out.println("Volunteer cheated!");
                    break;
                }
                case 1: {
                    System.out.println(commonCards.get(0));
                    break;
                }
                default: {
                    System.out.println("Bad magician!");
                    break;
                }
            }
        }
    }

    private static ByteHashSet getCards(byte rowNumber, Scanner scanner) {
        final byte rowSize = 4;
        ByteHashSet resultSet = new ByteHashSet((byte) (rowSize * rowSize));
        for (byte i = 0; i < rowSize; i++) {
            if (i == rowNumber - 1) {
                for (byte j = 0; j < rowSize; j++) {
                    resultSet.put(scanner.nextByte());
                }
            } else {
                for (byte j = 0; j < rowSize; j++) {
                    scanner.nextByte();
                }
            }
        }
        return resultSet;
    }
}

class ByteHashSet {

    public ByteHashSet(byte size) {
        elements = new byte[size + 1];
    }

    public void put(byte value) {
        elements[value] = value;
    }

    public byte get(byte key) {
        return elements[key];
    }

    public boolean contains(byte key) {
        return get(key) != 0;
    }

    public int size() {
        return elements.length;
    }

    public LinkedList<Byte> intersection(ByteHashSet other) {
        LinkedList<Byte> list = new LinkedList<Byte>();
        for (byte i = 0; i < size(); i++) {
            byte e = get(i);
            if (e != 0 && other.contains(e)) {
                list.add(e);
            }
        }

        return list;
    }

    private byte[] elements;
}


