import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Locale;

public class GogoB extends Thread {
	private final String _FILE_DIRECTORY = "D:\\workspace\\codejam\\";
	private final String _FILE_PATH = _FILE_DIRECTORY + "B-large";
	
	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new GogoB().start();
	}

	public void run() {
		BufferedReader br = null;
		PrintWriter pw = null;

		try {
			br = new BufferedReader(new FileReader(_FILE_PATH + ".in"));
			pw = new PrintWriter(_FILE_PATH + ".out");
	
			int caseno = Integer.parseInt(br.readLine());
		
			for (int count = 1; count <= caseno; count++) {
				pw.print("Case #" + count + ": ");
				System.out.print("Case #" + count + ": ");
				
				String inputsTmp[] = br.readLine().split(" ");
				StringBuilder inputBuf = new StringBuilder();
				for(int i=1;i<inputsTmp.length;i++) {
					if(inputBuf.indexOf(inputsTmp[i]) < 0)
						inputBuf.append(inputsTmp[i]+",");
				}
				String inputBufs = inputBuf.toString();
				inputBufs = inputBufs.substring(0,inputBufs.length()-1);
				inputsTmp = inputBufs.split(",");
				
				try{
					long inputs[] = new long[inputsTmp.length];
					for(int i=0;i<inputs.length;i++) {
						inputs[i] = Long.parseLong(inputsTmp[i]);
					}
					long inputsDiff[] = new long[inputs.length];
					for(int i=0;i<inputs.length;i++) {
						if(i == inputs.length - 1)
							inputsDiff[i] = Math.abs(inputs[i] - inputs[0]);
						else
							inputsDiff[i] = Math.abs(inputs[i] - inputs[i+1]); 
					}
					
					long gcd = 0;
					if(inputsDiff.length == 1)
						gcd = inputsDiff[0];
					else {
						gcd = gcd(inputsDiff[0],inputsDiff[1]);
						if(inputsDiff.length > 2) {
							for(int i=2;i<inputsDiff.length;i++) {
								gcd = gcd(gcd,inputsDiff[i]);
							}
						}
						
					}
					long dday = 0;
					long ddayDiff = inputs[0]%gcd;
					if(ddayDiff == 0 || gcd == 0 || gcd == 1)
						dday = 0;
					else
						dday = gcd - ddayDiff;
					pw.print(dday + "\n");
					System.out.print(dday + "\n");
				}
				catch(Exception e) {
					BigInteger inputs[] = new BigInteger[inputsTmp.length];
					for(int i=0;i<inputs.length;i++) {
						inputs[i] = new BigInteger(inputsTmp[i]);
					}
					BigInteger inputsDiff[] = new BigInteger[inputs.length];
					for(int i=0;i<inputs.length;i++) {
						BigInteger a = inputs[i];
						BigInteger b = inputs[i == inputs.length - 1 ? 0 : i + 1];
						inputsDiff[i] = a.subtract(b).abs();
					}
					
					BigInteger dday = new BigInteger("0");
					BigInteger gcd = new BigInteger("0");
					if(inputsDiff.length == 1)
						gcd = inputsDiff[0];
					else if (inputsDiff.length > 1) {
						gcd = inputsDiff[0].gcd(inputsDiff[1]);
						if(inputsDiff.length > 2) {
							for(int i=2;i<inputsDiff.length;i++) {
								gcd = gcd.gcd(inputsDiff[i]);
							}
						}
					}
					BigInteger ddayDiff = inputs[0].mod(gcd);
					if(!(ddayDiff.compareTo(BigInteger.ZERO) == 0
							|| gcd.compareTo(BigInteger.ZERO) == 0 
							|| gcd.compareTo(BigInteger.ONE) == 0))
						dday = gcd.subtract(ddayDiff);
					
					pw.print(dday + "\n");
					System.out.print(dday + "\n");
				}
			}
			br.close();
			pw.close();
		
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			try {
				if(pw != null) pw.close();
			} catch(Exception e) {}
			try {
				if(br != null) br.close();
			} catch(Exception e) {}
		}
	}
	public long gcd(long x, long y) {
		long tmp;
        while (x % y != 0) {
            tmp = y;
            y = x % y;
            x = tmp;
        }
        return y;
    }

}
