import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

public class GogoA extends Thread {
	private final String _FILE_DIRECTORY = "D:\\workspace\\codejam\\";
	private final String _FILE_PATH = _FILE_DIRECTORY + "A-small-attempt0";
	
	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new GogoA().start();
	}

	public void run() {
		BufferedReader br = null;
		PrintWriter pw = null;

		try {
			br = new BufferedReader(new FileReader(_FILE_PATH + ".in"));
			pw = new PrintWriter(_FILE_PATH + ".out");
	
			int caseno = Integer.parseInt(br.readLine());
		
			for (int count = 1; count <= caseno; count++) {
				pw.print("Case #" + count + ": ");
				System.out.print("Case #" + count + ": ");
				
				String inputs[] = br.readLine().split(" ");
				int N = Integer.parseInt(inputs[0]);
				int K = Integer.parseInt(inputs[1]);
				
				int NN[][] = new int[N][N]; //R:1 B:2
				
				//input
				for(int i=0;i<N;i++) {
					String input = br.readLine();
					for(int j=0;j<N;j++) {
						if(input.charAt(j) == '.') 
							NN[i][j] = 0;
						else if(input.charAt(j) == 'R') 
							NN[i][j] = 1;
						else if(input.charAt(j) == 'B') 
							NN[i][j] = 2;
					}
				}
				//rotate
				for(int i=0;i<N;i++) {
					int pos = N-1;
					int tmp[] = new int[N];
					for(int j=N-1;j>=0;j--) {
						if(NN[i][j] != 0) {
							tmp[pos] = NN[i][j];
							pos--;
						}
					}
					NN[i] = tmp;
				}
				
//				System.out.print("\n");
//				for(int i=0;i<N;i++) {
//					for(int j=0;j<N;j++) {
//						System.out.print(NN[i][j]);
//					}
//					System.out.print("\n");
//				}
				
				//check K
				
				boolean winR = false;
				boolean winB = false;
				
				for(int i=0;i<N;i++) {
					for(int j=0;j<N-K+1;j++) {
						if(!winR) {
							boolean tmpR = true;
							for(int p=0;p<K;p++) {
								if(NN[i][p+j] != 1) {
									tmpR = false;
									break;
								}
							}
							if(tmpR) winR = true;
						}
						if(!winB) {
							boolean tmpB = true;
							for(int p=0;p<K;p++) {
								if(NN[i][p+j] != 2) {
									tmpB = false;
									break;
								}
							}
							if(tmpB) winB = true;
						}
					}
				}
				
				for(int i=0;i<N;i++) {
					for(int j=0;j<N-K+1;j++) {
						if(!winR) {
							boolean tmpR = true;
							for(int p=0;p<K;p++) {
								if(NN[p+j][i] != 1) {
									tmpR = false;
									break;
								}
							}
							if(tmpR) winR = true;
						}
						if(!winB) {
							boolean tmpB = true;
							for(int p=0;p<K;p++) {
								if(NN[p+j][i] != 2) {
									tmpB = false;
									break;
								}
							}
							if(tmpB) winB = true;
						}
					}
				}
				
				for(int i=0;i<N-K+1;i++) {
					for(int j=0;j<N-K+1;j++) {
						if(!winR) {
							boolean tmpR = true;
							for(int p=0;p<K;p++) {
								if(NN[p+i][p+j] != 1) {
									tmpR = false;
									break;
								}
							}
							if(tmpR) winR = true;
						}
						if(!winB) {
							boolean tmpB = true;
							for(int p=0;p<K;p++) {
								if(NN[p+i][p+j] != 2) {
									tmpB = false;
									break;
								}
							}
							if(tmpB) winB = true;
						}
					}
				}
				
				for(int i=0;i<N-K+1;i++) {
					for(int j=K-1;j<N;j++) {
						if(!winR) {
							boolean tmpR = true;
							for(int p=0;p<K;p++) {
								if(NN[i+p][j-p] != 1) {
									tmpR = false;
									break;
								}
							}
							if(tmpR) winR = true;
						}
						if(!winB) {
							boolean tmpB = true;
							for(int p=0;p<K;p++) {
								if(NN[i+p][j-p] != 2) {
									tmpB = false;
									break;
								}
							}
							if(tmpB) winB = true;
						}
					}
				}
				
				if(winR && winB) {
					pw.print("Both");
					System.out.print("Both");
				}
				else if(winR) {
					pw.print("Red");
					System.out.print("Red");
				}
				else if(winB) {
					pw.print("Blue");
					System.out.print("Blue");		
				}
				else {
					pw.print("Neither");
					System.out.print("Neither");
				}

				pw.print("\n");
				System.out.print("\n");
			}
			br.close();
			pw.close();
		
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			try {
				if(pw != null) pw.close();
			} catch(Exception e) {}
			try {
				if(br != null) br.close();
			} catch(Exception e) {}
		}
	}

}
