import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Locale;
import java.util.Map;

public class GogoC extends Thread {
	private final String _FILE_DIRECTORY = "D:\\workspace\\codejam\\";
	private final String _FILE_PATH = _FILE_DIRECTORY + "C-large";
	
	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		new GogoC().start();
	}

	public void run() {
		BufferedReader br = null;
		PrintWriter pw = null;

		try {
			br = new BufferedReader(new FileReader(_FILE_PATH + ".in"));
			pw = new PrintWriter(_FILE_PATH + ".out");
	
			int caseno = Integer.parseInt(br.readLine());
		
			for (int count = 1; count <= caseno; count++) {
				pw.print("Case #" + count + ": ");
				System.out.print("Case #" + count + ": ");
				
				String inputs[] = br.readLine().split(" ");
				long R = Long.parseLong(inputs[0]);
				long K = Long.parseLong(inputs[1]);
				int N = Integer.parseInt(inputs[2]);
				
				String groupsTmp[] = br.readLine().split(" ");
				long groups[] = new long[groupsTmp.length];
				for(int i=0;i<groups.length;i++) {
					groups[i] = Long.parseLong(groupsTmp[i]);
				}
				long costs[] = new long[groupsTmp.length];
				int nextpos[] = new int[groupsTmp.length];
				
				int pos = 0;
				long cost = 0;
				for(int i=0;i<R;i++) {
					long allK = 0;
					int startPos = pos;
					if(costs[startPos] ==0) {
						while(true) {
							if(allK + groups[pos] <= K) {
								cost = cost + groups[pos];
								allK = allK + groups[pos];
								pos = ((pos +1) % N);
							}
							else {
								break;
							}
							if(pos == startPos) break;
						}
						costs[startPos] = allK;
						nextpos[startPos] = pos;
					}
					else {
						cost = cost + costs[startPos];
						pos = nextpos[startPos];
					}
				}
				
				
				pw.print(cost + "\n");
				System.out.print(cost + "\n");
			}
			br.close();
			pw.close();
		
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			try {
				if(pw != null) pw.close();
			} catch(Exception e) {}
			try {
				if(br != null) br.close();
			} catch(Exception e) {}
		}
	}

}
