import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.TreeMap;

public class BathroomStalls {

	static int caseSize;
	static long[] caseInput1;
	static long[] caseInput2;
	static long[][] caseOutput;
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
//		test();
		initialize("BathroomStalls-small2.input");
		solve();
	}

	private static void test(){
		
		long[] steps=solveCase(283959326164354076L,259644327433818749L);
		System.out.println(steps[0]+""+steps[1]);
	}
	
	private static void initialize(String path) throws IOException{
		List<String> lines=Files.readAllLines(Paths.get(path));
		caseSize=Integer.parseInt(lines.get(0));
		caseInput1=new long[caseSize];
		caseInput2=new long[caseSize];
		caseOutput=new long[caseSize][];
		for (int i = 0; i < caseSize; i++) {
			String[] caseInput = lines.get(i+1).split(" ");
			caseInput1[i]=Long.parseLong(caseInput[0]);
			caseInput2[i]=Long.parseLong(caseInput[1]);
		}
	}
	
	private static void solve(){
		for (int i = 0; i < caseInput1.length; i++) {
			caseOutput[i]=solveCase(caseInput1[i],caseInput2[i]);
			System.out.println(String.format("Case #%d: %d %d", i+1, caseOutput[i][1],caseOutput[i][0]));
		}
	}
	

	
	private static long[] solveCase0(long stalls, long users){
		//if(users>stalls-stalls/2) return new long[]{0,0};
		TreeMap<Long,Integer> sections=new TreeMap<Long,Integer>();
		sections.put(stalls, 1);
		long[] spaces=new long[2];
		for(long i=1;i<=users;i++){
			long largestSectionSpaces=sections.lastKey();
			int sapceCount=sections.get(largestSectionSpaces);
			spaces[0]=(largestSectionSpaces-1)/2;
			spaces[1]=largestSectionSpaces-1-spaces[0];
			if(sapceCount>1){
				sections.put(largestSectionSpaces, sapceCount-1);
			}
			else{
				sections.remove(largestSectionSpaces);
			}
			if(spaces[0]>0){
				sections.put(spaces[0], sections.getOrDefault(spaces[0],0)+1);
			}
			if(spaces[1]>0){
				sections.put(spaces[1], sections.getOrDefault(spaces[1],0)+1);
			}
		}
		return spaces;
	}
	
	private static long[] solveCase(long stalls, long users){
		//if(users>stalls-stalls/2) return new long[]{0,0};
		TreeMap<Long,Long> sections=new TreeMap<Long,Long>();
		sections.put(stalls, 1L);
		long[] spaces=new long[2];
		for(long i=1;i<=users;i++){
			
			long largestSectionSpaces=sections.lastKey();
			long spaceCount=sections.get(largestSectionSpaces);
			spaces[0]=(largestSectionSpaces-1)/2;
			spaces[1]=largestSectionSpaces-1-spaces[0];
			if(i+spaceCount-1>=users){
				break;
			}
			else{
				i+=(spaceCount-1);
				sections.remove(largestSectionSpaces);
				if(spaces[0]>0){
					sections.put(spaces[0], sections.getOrDefault(spaces[0],0L)+spaceCount);
				}
				if(spaces[1]>0){
					sections.put(spaces[1], sections.getOrDefault(spaces[1],0L)+spaceCount);
				}

			}
			
		}
		return spaces;
	}
	
}
