import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;

public class OversizedPancakeFlipper {

	static int caseSize;
	static String[] caseInput1;
	static int[] caseInput2;
	static int[] caseOutput;
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		initialize("OversizedPancakeFlipper.input");
		solve();
		output();
	}

	private static void test(){
		String input="+++++";
		int pfSize=4;
		int steps=solveCase(input,pfSize);
		System.out.println(steps);
	}
	
	private static void initialize(String path) throws IOException{
		List<String> lines=Files.readAllLines(Paths.get(path));
		caseSize=Integer.parseInt(lines.get(0));
		caseInput1=new String[caseSize];
		caseInput2=new int[caseSize];
		caseOutput=new int[caseSize];
		for (int i = 0; i < caseSize; i++) {
			String caseInput = lines.get(i+1);
			String[] inputs=caseInput.split(" ");
			caseInput1[i]=inputs[0];
			caseInput2[i]=Integer.parseInt(inputs[1]);
		}
	}
	
	private static void solve(){
		for (int i = 0; i < caseInput1.length; i++) {
			caseOutput[i]=solveCase(caseInput1[i],caseInput2[i]);
		}
	}
	
	private static void output(){
		for (int i = 0; i < caseOutput.length; i++) {
			String output=(caseOutput[i]==-1)?"IMPOSSIBLE":""+caseOutput[i];
			System.out.println(String.format("Case #%d: %s", i+1, output));
		}
	}
	
	private static int solveCase(String input, int pfSize){
		String targetCakePattern=input.replaceAll("-", "+");
		int cakeSize=input.length();
		int flipPointsCount=cakeSize-pfSize+1;
		HashMap<String,Integer> stateMap= new HashMap<String, Integer>();
		
		Queue<String> stateBacklog=new LinkedList<String>();
		if(input.equals(targetCakePattern)){
			return 0;
		}
		else{
			stateMap.put(input, 0);
			stateBacklog.add(input);
			while(!stateBacklog.isEmpty()){
				String currentState=stateBacklog.remove();
				int steps=stateMap.get(currentState)+1;
				for (int i = 0; i < flipPointsCount; i++) {
					String nextState=flip(currentState, i, pfSize);
					if(nextState.equals(targetCakePattern)){
						return steps;
					}
					else if(!stateMap.containsKey(nextState)){
						stateMap.put(nextState, steps);
						stateBacklog.add(nextState);
					}
				}
			}
			return -1;
		}
	}
	
	private static String flip(String str, int pos, int length){
		char[] chars=str.toCharArray();
		for (int i = pos; i < pos+length; i++) {
			chars[i]=(chars[i]=='+')?'-':'+';
		}
		return new String(chars);
	}
}
