import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;

public class CoinJam {

	static List<String> potentialCandidates = new ArrayList<String>();
	static List<String> finalCandidates = new ArrayList<String>();
	static Map<String, ArrayList<String>> finalCandidates1 = new HashMap<String, ArrayList<String>>();

	static void generateCoinJams(int n, int j) {
		char set[] = { '0', '1' };
		printAllKLength(set, n);
		int count = 0;
		for (String coin : potentialCandidates) {
			if (coin.startsWith("1") && coin.endsWith("1") && checkPrimalityOfPotentialCandidates(coin)) {
				finalCandidates.add(coin);
				count++;
				if (count == j)
					break;
			}
		}
		//System.out.println(finalCandidates1.toString());
		
	}

	static boolean checkPrimalityOfPotentialCandidates(String coin) {

		String coinBase = null;
		List<String> divisors = new ArrayList<>();

		for (int i = 2; i <= 10; i++) {
			coinBase = new BigInteger(coin, i).toString();
			BigInteger b = new BigInteger(coinBase);
			if (b.isProbablePrime(100000000))
				return false;
			 divisors.add(factor(b).toString());	
		}
		finalCandidates1.put(coin, (ArrayList<String>) divisors);
		return true;

	}

	// The method that prints all possible strings of length k. It is
	// mainly a wrapper over recursive function printAllKLengthRec()
	static void printAllKLength(char set[], int k) {
		int n = set.length;
		printAllKLengthRec(set, "", n, k);
	}

	// The main recursive method to print all possible strings of length k
	static void printAllKLengthRec(char set[], String prefix, int n, int k) {

		// Base case: k is 0, print prefix
		if (k == 0) {
			// System.out.println(prefix);

			potentialCandidates.add(prefix);
			return;

		}

		// One by one add all characters from set and recursively
		// call for k equals to k-1
		for (int i = 0; i < n; ++i) {

			// Next character of input added
			String newPrefix = prefix + set[i];

			// k is decreased, because we have added a new character
			printAllKLengthRec(set, newPrefix, n, k - 1);
		}
	}
	
	private static BigInteger smallestPrimeFactor(BigInteger n){
	     BigInteger two=new BigInteger("2");
	    if(n.mod(two).compareTo(BigInteger.ZERO)==0){
	            return two;          
	    }
	    for( BigInteger i = new BigInteger("3"); n.compareTo(i) >= 0 ; i = i.add(two) ){
	        if( n.mod(i).compareTo(BigInteger.ZERO)==0)
	            return i;
	        }
	    
	    return BigInteger.ZERO;
	}

	public static BigInteger factor(BigInteger n) {
		BigInteger result = new BigInteger("0");
		for(BigInteger i= new BigInteger("2"); n.compareTo(i) > 0;i=i.add(new BigInteger("1"))) {
			if(n.mod(i).compareTo(BigInteger.ZERO)==0) {
				result = i;
				break;
			}
		}
		return result;
	}

	public static void main(String args[]) {
		Scanner sc = new Scanner(System.in);
		int noOfTestCases = sc.nextInt();
		for(int i=1; i<=noOfTestCases; i++) {
			int n = sc.nextInt();
			int j = sc.nextInt();
			System.out.println("Case #"+i+":");
			generateCoinJams(n, j);
			for(String s: finalCandidates1.keySet()) {
				System.out.print(s+ " ");
				for(String s1 : finalCandidates1.get(s)){
					System.out.print(s1+" ");
				}
				System.out.println();
			}
			
		}
		
		//System.out.println(CoinJam.checkPrimalityOfPotentialCandidates("101"));
		//System.out.println(new BigInteger("1001", 2 ));
		
	}

}
