/**
 * @author ngel de Jess Garca Pineda
 */

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public abstract class Problem {
	protected Scanner input;
	protected PrintWriter output;

	protected void getInput() throws FileNotFoundException {
		input = new Scanner(new File("input.txt"));
	}

	protected void getOutput() throws FileNotFoundException {
		output = new PrintWriter(new File("output.txt"));
	}

	protected abstract void solve();

	protected void run() {
		try {
			getInput();
			getOutput();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		solve();
		input.close();
		output.close();
	}

}
