import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author ngel Jess Garca Pineda ~ Agedjus.com
 */

public class MinesweeperMaster {

	private static char[][] solve(int R, int C, int M) {
		char[][] grid = new char[R][C];
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid[i].length; j++) {
				if (M > 0) {
					grid[i][j] = '*';
					M--;
				} else {
					grid[i][j] = '.';
				}
			}
		}
		grid[R - 1][C - 1] = 'c';
		if (R - 2 >= 0 && grid[R - 2][C - 1] == '*') {
			return null;
		}
		if (R - 2 >= 0 && C - 2 >= 0 && grid[R - 2][C - 2] == '*') {
			return null;
		}
		if (C - 2 >= 0 && grid[R - 1][C - 2] == '*') {
			return null;
		}
		return grid;
	}

	public static void main(String[] args) {
		BufferedWriter bw = null;
		Scanner sc = null;
		try {
			sc = new Scanner(new File("input.txt"));
			bw = new BufferedWriter(new FileWriter(new File("output.txt")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		PrintWriter wr = new PrintWriter(new BufferedWriter(bw));

		// PROGRAM

		int nCases = sc.nextInt();
		for (int i = 0; i < nCases; i++) {
			char[][] grid = solve(sc.nextInt(), sc.nextInt(), sc.nextInt());
			wr.println("Case #" + (i + 1) + ":");
			if (grid == null) {
				wr.println("Impossible");
			} else {
				for (int j = 0; j < grid.length; j++) {
					for (int k = 0; k < grid[j].length; k++) {
						wr.print(grid[j][k]);
					}
					wr.println();
				}
			}
		}

		// PROGRAM

		sc.close();
		wr.close();
		try {
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
