import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * @author ngel Jess Garca Pineda ~ Agedjus.com
 */

public class DeceitfulWar {

	private static int optimallyWar(Set<Double> blocksNaomi,
			Set<Double> blocksKen) {
		int points = 0;
		for (Double chosenNaomi : blocksNaomi) {
			double min = 1;
			for (Double blockKen : blocksKen) {
				if (blockKen > chosenNaomi && blockKen < min) {
					min = blockKen;
				}
			}
			blocksKen.remove(min);
			if (min == 1) {
				points++;
			}
		}
		return points;
	}

	private static int deceitfulWar(Set<Double> blocksNaomi,
			Set<Double> blocksKen) {
		int points = 0;
		while (!blocksNaomi.isEmpty()) {
			if (Collections.min(blocksNaomi) > Collections.min(blocksKen)) {
				points++;
				blocksKen.remove(Collections.min(blocksKen));
			} else {
				blocksKen.remove(Collections.max(blocksKen));
			}
			blocksNaomi.remove(Collections.min(blocksNaomi));
		}
		return points;
	}

	public static void main(String[] args) {
		BufferedWriter bw = null;
		Scanner sc = null;
		try {
			sc = new Scanner(new File("input.txt"));
			bw = new BufferedWriter(new FileWriter(new File("output.txt")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		PrintWriter wr = new PrintWriter(new BufferedWriter(bw));

		// PROGRAM

		int nCases = sc.nextInt();

		for (int i = 0; i < nCases; i++) {
			int nBlocks = sc.nextInt();
			Double value;
			Set<Double> blocksNaomi1 = new HashSet<Double>(), blocksNaomi2 = new HashSet<Double>(), blocksKen1 = new HashSet<Double>(), blocksKen2 = new HashSet<Double>();
			for (int j = 0; j < nBlocks; j++) {
				value = new Double(sc.next());
				blocksNaomi1.add(value);
				blocksNaomi2.add(value);
			}
			for (int j = 0; j < nBlocks; j++) {
				value = new Double(sc.next());
				blocksKen1.add(value);
				blocksKen2.add(value);
			}
			wr.println("Case #" + (i + 1) + ": "
					+ deceitfulWar(blocksNaomi1, blocksKen1) + " "
					+ optimallyWar(blocksNaomi2, blocksKen2));
		}

		// PROGRAM

		sc.close();
		wr.close();
		try {
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
