package codejam;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.util.ArrayList;

public class TrainTimetable {
	FileInputStream fileInputStream;
	
	public static void main(String[] args) throws Exception {
		new TrainTimetable().init();
	}
	
	public void init() throws Exception {
		File fileIn  = new File("/home/micro36/download/B-small-attempt2.in");
		File fileOut = new File("/home/micro36/download/B-small-attempt2.out");
		
		fileInputStream = new FileInputStream( fileIn );
		
		int numberOfCases = Integer.parseInt( nextString() );
		
		String[] output = new String[numberOfCases];
		
		for( int i = 0; i < numberOfCases; i++ ) {
			
			int turnAround = Integer.parseInt( nextString() );			
			
			String s = nextString();
			int numberOfTripsAB = Integer.parseInt( s.substring(0, s.indexOf(" ")) );
			int numberOfTripsBA = Integer.parseInt( s.substring( s.indexOf(" ")+1 ) );
			
			ArrayList<Trip> tripsA = new ArrayList<Trip>( numberOfTripsAB );
			ArrayList<Trip> tripsB = new ArrayList<Trip>( numberOfTripsBA );
			for (int j = 0; j < numberOfTripsAB; j++) {
				tripsA.add( new Trip( j, nextString() ) );
			}
			for (int j = 0; j < numberOfTripsBA; j++) {
				tripsB.add( new Trip( j, nextString() ) );
			}
			
			int numberOfTrainsInA = 0;
			int numberOfTrainsInB = 0;
			
			checkReturns( tripsA, tripsB, turnAround);
			checkReturns( tripsB, tripsA, turnAround);
			
			for (int j = 0; j < numberOfTripsAB; j++) {
				if ( !tripsA.get(j).haveATrain )
					numberOfTrainsInA++;
			}
			for (int j = 0; j < numberOfTripsBA; j++) {
				if ( !tripsB.get(j).haveATrain )
					numberOfTrainsInB++;
			}
			
			output[i] = ("Case #" + (i+1) +": " + numberOfTrainsInA + " " + numberOfTrainsInB );

		}
		
		if ( ! fileOut.exists() )
			fileOut.createNewFile();
		
		FileOutputStream fileOutputStream = new FileOutputStream( fileOut );
		for (int i = 0; i < numberOfCases; i++) {
			fileOutputStream.write( output[i].getBytes() );
			if ( (i+1) < numberOfCases )
				fileOutputStream.write( '\n' );
		}
		
		fileInputStream.close();
		fileOutputStream.close();
		
		
	}
	
	public void checkReturns( ArrayList<Trip> base, ArrayList<Trip> trispToCheck, int turnAround ) {
		for (int j = 0; j < base.size(); j++) {
			Trip tripFromAtoB = base.get(j);
			Trip previous = null;
			for (int k = 0; k < trispToCheck.size(); k++) {
				Trip actual = trispToCheck.get(k);
				if ( ! actual.usedToReturn ) {
					if ( ( actual.arrival + turnAround) <= tripFromAtoB.departure ) {
						if ( previous == null || actual.arrival > previous.arrival ) {
							previous = actual;
						}
					}
				}
			}
			if ( previous != null ) {
				previous.usedToReturn = true;
				tripFromAtoB.haveATrain = true;
			}
		}
	}
	
	public String nextString() throws Exception {
		StringBuffer s = new StringBuffer("");
		for( int i = 0; i < 1000; i++ ) {
			byte[] b = new byte[1];
			fileInputStream.read(b);
			if ( b[0] == '\n') {
				break;
			} else {
				s.append( (char) b[0] );
			}
		}
		
		return s.toString();
	}
	
	
	class Trip {
		
		int departure;
		int arrival;
		int tripNumber;
		
		boolean usedToReturn = false;
		boolean haveATrain = false;
		
		public Trip( int tripNumber, String horario ) {
			String departureTime = horario.substring(0, horario.indexOf(" ") );
			String arrivalTime = horario.substring(horario.indexOf(" ")+1 );
			
			this.departure = convertToMinutes( departureTime );
			this.arrival = convertToMinutes( arrivalTime );
			this.tripNumber = tripNumber;
		}
		
		public int convertToMinutes( String horario ) {
			int result = Integer.parseInt( horario.substring(0, horario.indexOf(":") ) );
			result *= 60;
			result += Integer.parseInt( horario.substring(horario.indexOf(":")+1 ) );
			
			return result;
		}
		
	}
}
