import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class CampoMinado {

	private String folder = "/home/thiago/Downloads/";
	private String fileName = "C-small-attempt0";
	private String fileInExtension = ".in";
	private String fileOutExtension = ".out";
	private boolean demo = false;

	private static String MINE = "*";
	private static String EMPTY = ".";
	private static String CLICK = "c";

	private static String IMPOSSIBLE = "Impossible";

	public String whereTheMagicHappens( String line ) {
		String out = null;
		
		String[] split = line.split(" ");
		int lines = Integer.parseInt(split[0]);
		int columns = Integer.parseInt(split[1]);
		int mines = Integer.parseInt(split[2]);
		
		boolean impossible = false;
		
		
		String[][] field = new String[lines][columns];
		
		for (int i = 0; i < lines; i++) {
			for (int j = 0; j < columns; j++) {
				// the last one
				if ( i == lines-1 && j == columns-1 ) {
					if ( i > 0 ) {
						if ( field[i-1][j].equals(MINE) ) {
							impossible = true;
						}
					}
					if ( j > 0 ) {
						if ( field[i][j-1].equals(MINE) ) {
							impossible = true;
						}
					}
					if ( i > 0 && j > 0 ) {
						if ( field[i-1][j-1].equals(MINE) ) {
							impossible = true;
						}
					}
					field[i][j] = CLICK;
				} else if ( mines > 0 ) {
					field[i][j] = MINE;
					mines--;
				} else {
					field[i][j] = EMPTY;
				}
			}
		}
		
		if ( impossible ) {
			return IMPOSSIBLE;
		}
		
		StringBuffer sb = new StringBuffer("\n");
		for (int i = 0; i < lines; i++) {
			for (int j = 0; j < columns; j++) {
				sb.append(field[i][j]);
			}
			sb.append("\n");
		}

		return sb.toString();
	}


	public static void main(String[] args) {
		try {
			new CampoMinado().run();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public void run() throws IOException {
		File fileIn = new File( folder + fileName + fileInExtension );

		FileReader reader = new FileReader(fileIn);
		BufferedReader buffer = new BufferedReader(reader);

		String line = buffer.readLine();

		int nLines = Integer.valueOf(line);

		String[] outs = new String[nLines];

		for (int i = 0; i < nLines; i++) {
			line = buffer.readLine();

			outs[i] = whereTheMagicHappens(line);

		}

		buffer.close();
		reader.close();

		File fileOut = new File( folder + fileName + fileOutExtension );
		if ( !fileOut.exists() ) {
			fileOut.createNewFile();
		}

		FileWriter writer = new FileWriter(fileOut);
		BufferedWriter bufferWriter = new BufferedWriter(writer);

		for (int i = 0; i < outs.length; i++) {
			bufferWriter.write( "Case #" + (i+1) + ": " + outs[i] );
			
			if ( demo ) {
				System.out.println("Case #" + (i+1) + ": " + outs[i]);
			}

			if ( (i+1) < outs.length ) {
				bufferWriter.newLine();
			}
		}

		bufferWriter.close();
		writer.close();
	}

}
