import java.awt.Toolkit;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.StringSelection;
import java.awt.datatransfer.Transferable;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;


public abstract class CodeJamBase implements ClipboardOwner {

    protected File fileIn;
    protected File fileOut;
    
    private int count = 1;

    protected ArrayList<String> lines;
    protected ArrayList<String> out = new ArrayList<>();

    public CodeJamBase(String file) {
        fileIn = new File(file);
        readFile();
        doIt();
        writeFile();
    }

    public void doIt() {
    	int i = 0;
        for (String line : lines) {
        	if ( i++ == 0 ) {
        		continue;
        	}
            doIt(line);
        }
    }

    public abstract void doIt(String line);

    protected void readFile() {
        try ( FileReader reader = new FileReader(fileIn); BufferedReader br = new BufferedReader(reader) ) {
            lines = new ArrayList<String>();
            String line = null;
            while( (line = br.readLine()) != null) {
                lines.add( line );
            }
        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }

    protected void writeFile() {
        fileOut = new File( fileIn.getAbsolutePath() + ".out");
        try ( FileWriter writer = new FileWriter(fileOut); BufferedWriter wr = new BufferedWriter(writer) ) {
            for (String line : out) {
                wr.write("Case #"+ this.count++ +": " + line);
                wr.newLine();
            }
            wr.flush();
            writer.flush();

            Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
            Transferable transferable = new StringSelection(fileOut.getAbsolutePath());
            clipboard.setContents(transferable, this);

            System.out.println(fileOut.getAbsolutePath() + " done.");
            System.out.println("Press enter to end...");
            System.in.read();

        } catch ( Exception e ) {
            e.printStackTrace();
        }
    }


    @Override
    public void lostOwnership(Clipboard clipboard, Transferable contents) {
        System.out.println("hein?");
    }


}
