import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class Pockets_Small implements Runnable {

    static final int MAX = 1000000;

    static final int[] DX = { 0, 2, 0, -2 };

    static final int[] DY = { 2, 0, -2, 0 };

    int[] px, py;

    int cnt;

    boolean checkPoint(int x, int y) {
        boolean up, down, left, right;
        up = false;
        down = false;
        left = false;
        right = false;

        for (int i = 0; i < cnt; i++) {
            if (px[i] == px[i + 1] && y <= Math.max(py[i], py[i + 1])
                && y >= Math.min(py[i], py[i + 1])) {
                if (px[i] < x)
                    left = true;
                else
                    right = true;
            }
            if (py[i] == py[i + 1] && x <= Math.max(px[i], px[i + 1])
                && x >= Math.min(px[i], px[i + 1])) {
                if (py[i] < y)
                    up = true;
                else
                    down = true;
            }
        }

        return (up && down) || (left && right);
    }

    int calc() {
        int sq = 0;
        for (int i = 0; i < cnt; i++)
            sq += (px[i + 1] - px[i]) * (py[i + 1] + py[i]);
        sq = Math.abs(sq / 8);

        int ans = 0;

        for (int x = -100; x < 100; x++)
            for (int y = -100; y < 100; y++) {
                int px = x * 2 + 1;
                int py = y * 2 + 1;

                if (checkPoint(px, py)) {
                    ans++;
                }
            }
        return ans - sq;
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("pockets_small.in"));
        PrintWriter out = new PrintWriter(new File("pockets_small.out"));

        px = new int[MAX];
        py = new int[MAX];

        int total = in.nextInt();
        for (int test = 1; test <= total; test++) {
            px[0] = 0;
            py[0] = 0;
            cnt = 1;

            int x = 0;
            int y = 0;
            int d = 0;

            int L = in.nextInt();
            for (int i = 0; i < L; i++) {
                String s = in.next();
                StringBuffer buf = new StringBuffer();
                int r = in.nextInt();
                for (int step = 0; step < r; step++) {
                    buf.append(s);
                }
                s = buf.toString();
                for (int k = 0; k < s.length(); k++) {
                    char c = s.charAt(k);
                    switch (c) {
                        case 'F':
                            x += DX[d];
                            y += DY[d];
                            break;
                        case 'L':
                            if (x != px[cnt - 1] || y != py[cnt - 1]) {
                                px[cnt] = x;
                                py[cnt] = y;
                                cnt++;
                            }
                            d = (d + 3) % 4;
                            break;
                        case 'R':
                            if (x != px[cnt - 1] || y != py[cnt - 1]) {
                                px[cnt] = x;
                                py[cnt] = y;
                                cnt++;
                            }
                            d = (d + 1) % 4;
                        default:
                            break;
                    }
                }
            }

            px[cnt] = px[0];
            py[cnt] = py[0];

            out.println("Case #" + test + ": " + calc());
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        }
        catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] s) {
        Locale.setDefault(Locale.US);
        new Thread(new Pockets_Small()).start();
    }
}
