import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Scanner;

public class B {
    static final int MAX = 439;
    static final int SIZE = 10000;

    int[] from = new int[MAX];
    int[] to = new int[MAX];
    int[] c = new int[MAX];

    int[][] right = new int[SIZE][MAX];

    int[] x = new int[MAX];
    int[] y = new int[MAX];

    int m;
    int n;
    int count;

    String doIt() {
        int ans = Integer.MAX_VALUE;
        for (int c1 = 0; c1 < count; c1++)
            for (int c2 = 0; c2 < count; c2++)
                for (int c3 = 0; c3 < count; c3++) {
                    int index = 0;
                    int cnt = 0;

                    boolean ok = true;
                    while (ok && index < SIZE) {
                        int r1 = right[index][c1];
                        int r2 = right[index][c2];
                        int r3 = right[index][c3];
                        int rr = Math.max(r1, Math.max(r2, r3));

                        if (rr == -1)
                            ok = false;
                        else {
                            index = rr + 1;
                            cnt++;
                        }
                    }
                    if (ok && cnt < ans)
                        ans = cnt;
                }

        return ans == Integer.MAX_VALUE ? "IMPOSSIBLE" : Integer.toString(ans);
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new FileInputStream("b.in"));
        PrintWriter out = new PrintWriter("b.out");

        HashMap<String, Integer> map = new HashMap<String, Integer>();
        count = 0;

        int tests = in.nextInt();
        for (int test = 1; test <= tests; test++) {
            count = 0;
            map.clear();

            // read
            n = in.nextInt();
            for (int i = 0; i < n; i++) {
                String color = in.next();
                Integer value = map.get(color);
                if (value == null) {
                    value = Integer.valueOf(count++);
                    map.put(color, value);
                }

                from[i] = in.nextInt() - 1;
                to[i] = in.nextInt() - 1;
                c[i] = value.intValue();
            }

            // sort
            int tmp = 0;
            for (int i = 0; i < n; i++)
                for (int j = i + 1; j < n; j++)
                    if (from[j] < from[i]) {
                        tmp = from[i];
                        from[i] = from[j];
                        from[j] = tmp;

                        tmp = to[i];
                        to[i] = to[j];
                        to[j] = tmp;

                        tmp = c[i];
                        c[i] = c[j];
                        c[j] = tmp;
                    }

            // build right[10000, 300]
            for (int color = 0; color < count; color++) {
                int pos = -1;
                int index = 0;
                for (int i = 0; i < SIZE; i++) {
                    while (index < n && from[index] == i) {
                        if (c[index] == color && (pos == -1 || to[index] > pos))
                            pos = to[index];
                        index++;
                    }

                    if (pos < i)
                        pos = -1;
                    right[i][color] = pos;
                }
            }

            out.println("Case #" + test  + ": " + doIt());
        }

        in.close();
        out.close();
    }

    public static void main(String[] args) throws IOException {
        (new B()).solve();
    }
}
