import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class Cheating_Small implements Runnable {

    int ROWS, COLS;

    boolean[][] busy;

    int[][] path;

    boolean[][] can;

    int[] sum;

    void init() {
        sum = new int[1 << ROWS];
        for (int mask = 0; mask < (1 << ROWS); mask++) {
            sum[mask] = 0;
            for (int r = 0; r < ROWS; r++)
                if ((mask & (1 << r)) != 0)
                    sum[mask]++;
        }

        int cnt = 0;
        for (int mask1 = 0; mask1 < (1 << ROWS); mask1++) {
            for (int mask2 = 0; mask2 < (1 << ROWS); mask2++) {
                if ((mask1 & mask2) != 0)
                    continue;
                if ((mask1 & (mask2 >> 1)) != 0)
                    continue;
                if ((mask1 & (mask2 << 1)) != 0)
                    continue;
                cnt++;

                path[mask1][0]++;
                path[mask1][path[mask1][0]] = mask2;
            }
        }
        for (int mask = 0; mask < (1 << ROWS); mask++)
            for (int col = 0; col < COLS; col++) {
                can[mask][col] = true;
                for (int r = 0; r < ROWS; r++)
                    if ((mask & (1 << r)) != 0 && busy[r][col]) {
                        can[mask][col] = false;
                        break;
                    }
            }

    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("cheating_small.in"));
        PrintWriter out = new PrintWriter(new File("cheating_small.out"));

        int total = in.nextInt();

        for (int test = 1; test <= total; test++) {
            ROWS = in.nextInt();
            COLS = in.nextInt();

            busy = new boolean[ROWS][COLS];
            for (int r = 0; r < ROWS; r++) {
                String s = in.next();
                for (int c = 0; c < COLS; c++)
                    busy[r][c] = s.charAt(c) == 'x';
            }

            path = new int[1 << ROWS][1 + 1 << ROWS];
            can = new boolean[1 << ROWS][COLS];
            init();

            long[] prv = new long[1 << ROWS];
            long[] cur = new long[1 << ROWS];
            prv[0] = 1;
            for (int step = 0; step < COLS; step++) {
                for (int mask = 0; mask < (1 << ROWS); mask++) {
                    if (prv[mask] == 0)
                        continue;
                    for (int i = 1; i <= path[mask][0]; i++) {
                        int to = path[mask][i];
                        if (can[to][step] && (cur[to] < prv[mask] + sum[to]))
                            cur[to] = prv[mask] + sum[to];
                    }
                }
                for (int mask = 0; mask < (1 << ROWS); mask++) {
                    prv[mask] = cur[mask];
                    cur[mask] = 0;
                }
            }

            long ans = 0;
            for (int mask = 0; mask < (1 << ROWS); mask++)
                if (prv[mask] > ans)
                    ans = prv[mask];

            out.println("Case #" + test + ": " + (ans - 1));
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        }
        catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] s) {
        Locale.setDefault(Locale.US);
        new Thread(new Cheating_Small()).start();
    }
}
