import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Locale;

public class Main implements Runnable {
    public static final String FILENAME = "B-large";

    BufferedReader inp;
    PrintWriter out;

    int N;
    BigInteger[] t = new BigInteger[1000];

    void solve() throws Exception {
        int tests = Integer.parseInt(inp.readLine());
        for (int test = 1; test <= tests; test++) {
            String[] z = inp.readLine().split(" ");
            N = Integer.parseInt(z[0]);

            for (int i = 0; i < N; i++)
                t[i] = new BigInteger(z[i + 1]);
            Arrays.sort(t, 0, N);

            BigInteger T = t[1].subtract(t[0]);
            for (int i = 2; i < N; i++)
                T = T.gcd(t[i].subtract(t[i - 1]));
            BigInteger res = t[0].remainder(T);
            if (!res.equals(BigInteger.ZERO))
                res = T.subtract(res);

            out.println("Case #" + test + ": " + res);
        }
    }

    public void run() {
        try {
            inp = new BufferedReader(new FileReader(FILENAME + ".in"));
            out = new PrintWriter(new File(FILENAME + ".out"));
            solve();
            inp.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new Thread(new Main()).start();
    }
}
