import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Locale;

public class Main implements Runnable {
    public static final String FILENAME = "data";

    BufferedReader inp;
    PrintWriter out;

    String[] words;

    int diff(int a, int b) {
        String[] x = words[a].split("/");
        String[] y = words[b].split("/");

        int i = 0;
        while (i < x.length && i < y.length && x[i].equals(y[i]))
            i++;
        return y.length - i;
    }

    void one() throws Exception {
        String[] z = inp.readLine().split(" ");
        int N = Integer.parseInt(z[0]);
        int M = Integer.parseInt(z[1]);

        words = new String[N + M];
        for (int i = 0; i < N + M; i++)
            words[i] = inp.readLine();

        int res = 0;
        for (int i = 0; i < M; i++) {
            int min = words[N + i].split("/").length - 1;
            for (int j = 0; j < N + i; j++) {
                int cur = diff(j, N + i);
                if (cur < min)
                    min = cur;
            }
            res += min;
        }
        out.println(res);
    }

    void solve() throws Exception {
        int tests = Integer.parseInt(inp.readLine());
        for (int test = 1; test <= tests; test++) {
            out.print("Case #" + test + ": ");
            one();
        }
    }

    public void run() {
        try {
            inp = new BufferedReader(new FileReader(FILENAME + ".in"));
            out = new PrintWriter(new File(FILENAME + ".out"));
            solve();
            inp.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new Thread(new Main()).start();
    }
}
