import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class Knight_Small implements Runnable {

    static final int BASE = 10007;

    int ROWS, COLS, N;

    int[][] board, ans;

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("knight_small.in"));
        PrintWriter out = new PrintWriter(new File("knight_small.out"));

        int total = in.nextInt();

        for (int test = 1; test <= total; test++) {
            ROWS = in.nextInt();
            COLS = in.nextInt();
            N = in.nextInt();

            board = new int[ROWS][COLS];
            for (int r = 0; r < ROWS; r++)
                for (int c = 0; c < COLS; c++)
                    board[r][c] = 1;
            for (int i = 0; i < N; i++) {
                int r = in.nextInt() - 1;
                int c = in.nextInt() - 1;
                board[r][c] = 0;
            }

            ans = new int[ROWS][COLS];
            ans[0][0] = board[0][0];
            for (int r = 0; r < ROWS; r++)
                for (int c = 0; c < COLS; c++)
                    if (ans[r][c] > 0) {
                        int nr = r + 2;
                        int nc = c + 1;
                        if (nr < ROWS && nc < COLS)
                            ans[nr][nc] = (board[nr][nc] * (ans[nr][nc] + ans[r][c])) % BASE;
                        nr = r + 1;
                        nc = c + 2;
                        if (nr < ROWS && nc < COLS)
                            ans[nr][nc] = (board[nr][nc] * (ans[nr][nc] + ans[r][c])) % BASE;

                    }

            out.println("Case #" + test + ": " + ans[ROWS - 1][COLS - 1]);
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        }
        catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] s) {
        Locale.setDefault(Locale.US);
        new Thread(new Knight_Small()).start();
    }
}
