import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Locale;

public class Main implements Runnable {
    public static final String FILENAME = "B-small";

    class Node {
        double weight;
        boolean leaf;
        Node left;
        Node right;
    }

    BufferedReader inp;
    PrintWriter out;

    char[] cur;

    void swap(int i, int j) {
        char x = cur[i];
        cur[i] = cur[j];
        cur[j] = x;
    }

    void sort(int b, int e) {
        for (int i = b; i < e; i++)
            for (int j = i + 1; j < e; j++)
                if (cur[j] < cur[i])
                    swap(i, j);
    }

    String next() {
        for (int i = cur.length - 2; i >= 0; i--) {
            int p = -1;
            for (int j = i + 1; j < cur.length; j++)
                if ((cur[j] > cur[i]) && (p == -1 || cur[j] < cur[p]))
                    p = j;
            if (p != -1) {
                swap(i, p);
                sort(i + 1, cur.length);
                return new String(cur);
            }
        }
        sort(0, cur.length);

        int k = 0;
        while (cur[k] == '0')
            k++;
        String res = "" + cur[k];
        for (int i = 1; i <= k + 1; i++)
            res = res + "0";
        for (int i = k + 1; i < cur.length; i++)
            res = res + cur[i];

        return res;
    }

    void solve() throws Exception {
        int tests = Integer.parseInt(inp.readLine());

        for (int test = 1; test <= tests; test++) {
            cur = inp.readLine().toCharArray();
            out.println("Case #" + test + ": " + next());
        }
    }

    public void run() {
        try {
            inp = new BufferedReader(new FileReader(FILENAME + ".in"));
            out = new PrintWriter(new File(FILENAME + ".out"));
            solve();
            inp.close();
            out.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new Thread(new Main()).start();
    }
}
