import java.io.BufferedReader;
import java.io.FileReader;

public class Test {

    static int parseTime(String s) {
        String[] z = s.split(":");
        return Integer.parseInt(z[0]) * 60 + Integer.parseInt(z[1]);
    }

    class Trip implements Comparable<Trip> {
        int depature;

        int arrival;

        int original;

        Trip(int original, String s) {
            String[] z = s.split(" ");
            this.depature = parseTime(z[0]);
            this.arrival = parseTime(z[1]);
            this.original = original;
        }

        public int compareTo(Trip o) {
            return this.depature - o.depature;
        }

        public String toString() {
            return original + " -> [" + depature + "-" + arrival + "]";
        }

    }

    BufferedReader inp;

    void solve() throws Exception {
        int t = Integer.parseInt(inp.readLine());

        String[] z = inp.readLine().split(" ");
        int na = Integer.parseInt(z[0]);
        int nb = Integer.parseInt(z[1]);

        Trip[] trips = new Trip[na + nb];

        for (int i = 0; i < na; i++) {
            trips[i] = new Trip(0, inp.readLine());
        }
        for (int i = 0; i < nb; i++) {
            trips[na + i] = new Trip(1, inp.readLine());
        }
        int nn = na + nb;

        int[] ans = new int[2];
        int[] cur = new int[2];
        for (int time = 0; time < 1440; time++) {
            for (int i = 0; i < nn; i++)
                if (trips[i].arrival + t == time) {
                    cur[1 - trips[i].original]++;
                }
            for (int i = 0; i < nn; i++)
                if (trips[i].depature == time) {
                    if (cur[trips[i].original] > 0)
                        cur[trips[i].original]--;
                    else {
                        ans[trips[i].original]++;
                    }
                }
        }

        System.out.println(ans[0] + " " + ans[1]);
    }

    void doIt() throws Exception {
        inp = new BufferedReader(new FileReader("test.in"));

        String line = inp.readLine();
        int cnt = Integer.parseInt(line);

        for (int test = 1; test <= cnt; test++) {
            System.out.print("Case #" + test + ": ");
            solve();
        }

        inp.close();
    }

    public static void main(String[] args) throws Exception {

        Test test = new Test();
        test.doIt();
    }
}
