import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;

public class Water {
    static final int MAX = 110;
    static final int[] DR = {-1, 0, 0, 1};
    static final int[] DC = {0, -1, 1, 0};

    BufferedReader inp;
    PrintWriter out;

    int ROWS, COLS;
    int cnt;
    int[][] a = new int[MAX][MAX];
    int[][] d = new int[MAX][MAX];
    char[][] q = new char[MAX][MAX];

    void makeEdge(int r, int c) {
        d[r][c] = -1;

        int min = a[r][c];
        for (int k = 0; k < 4; k++) {
            int nr = r + DR[k];
            int nc = c + DC[k];
            if (nr < 0 || nr >= ROWS || nc < 0 || nc >= COLS)
                continue;
            if (a[nr][nc] >= a[r][c])
                continue;
            if (a[nr][nc] < min) {
                min = a[nr][nc];
                d[r][c] = k;
            }
        }
    }

    char color(int r, int c) {
        if (q[r][c] != '#')
            return q[r][c];
        if (d[r][c] == -1) {
            q[r][c] = (char) ('a' + cnt);
            cnt++;
        } else
            q[r][c] = color(r + DR[d[r][c]], c + DC[d[r][c]]);

        return q[r][c];
    }

    void solve() throws Exception {
        inp = new BufferedReader(new FileReader("water.in"));
        out = new PrintWriter(new File("water.out"));

        int T = Integer.parseInt(inp.readLine());
        for (int test = 1; test <= T; test++) {
            String[] z = inp.readLine().split(" ");
            ROWS = Integer.parseInt(z[0]);
            COLS = Integer.parseInt(z[1]);
            for (int r = 0; r < ROWS; r++) {
                z = inp.readLine().split(" ");
                for (int c = 0; c < COLS; c++)
                    a[r][c] = Integer.parseInt(z[c]);
            }

            for (int r = 0; r < ROWS; r++)
                for (int c = 0; c < COLS; c++) {
                    q[r][c] = '#';
                    makeEdge(r, c);
                }

            cnt = 0;
            for (int r = 0; r < ROWS; r++)
                for (int c = 0; c < COLS; c++)
                    if (q[r][c] == '#') {
                        color(r, c);
                    }

            out.println("Case #" + test + ":");
            for (int r = 0; r < ROWS; r++) {
                for (int c = 0; c < COLS; c++) {
                    if (c > 0)
                        out.print(' ');
                    out.print(q[r][c]);
                }
                out.println();
            }
        }

        inp.close();
        out.close();
    }

    public static void main(String[] args) throws Exception {
        Water sol = new Water();
        sol.solve();
    }
}
