package gcj2011.round1B;

/**
 * Author -
 * User: kansal
 * Date: 5/21/11
 * Time: 9:36 PM
 */
public class RPI {
    private static IOUtil.IO io;
    public static void main(String[] args) {
        String inFilePrefix = "C:\\Users\\kansal\\Downloads\\";
        String outFilePrefix = "C:\\RAJAT\\Codes\\Contests\\GCJ\\src\\gcj2011\\round1B\\";

//        String input = "A-small-attempt0.in";
//        String output = "A-small-attempt0.out";
        String input = "A-large.in";
        String output = "A-large.out";

        io = new IOUtil.IO(inFilePrefix + input, outFilePrefix + output);

        int T = io.nextInt();
        for(int i = 1; i <= T; ++i) {
            try {
                String res = new RPI().solve();
                String print = String.format("Case #%d: %s", i, res);
                io.writer.println(print);
                System.out.println(print);
            }
            catch (Exception e) {
                System.out.println("Exception thrown for case:" + i + ", " + e);
                e.printStackTrace();
            }
        }

        io.closeStreams();
    }

    public String solve() {
        int n = io.nextInt();
        String[] matches = new String[n];
        for(int i = 0; i < n; ++i) matches[i] = io.next();

        double[] wp = new double[n];
        double[] owp = new double[n];
        double[] oowp = new double[n];

        int[] played = new int[n];
        int[] won = new int[n];

        for(int i = 0; i < n; ++i) {
            for(int j = 0; j < n; ++j) {
                if (matches[i].charAt(j) != '.') {
                    ++played[i];
                    if (matches[i].charAt(j) == '1') {
                        ++won[i];
                    }
                }
            }
            wp[i] = 1.0 * won[i] / played[i];
        }

        for(int i = 0; i < n; ++i) {
            double totWP = 0.0;
            int by = 0;
            for(int j = 0; j < n; ++j) {
                if (matches[i].charAt(j) != '.') {
                    ++by;
                    if (matches[j].charAt(i) == '1') {
                        totWP += 1.0 * (won[j] - 1) / (played[j] - 1);
                    }
                    else {
                        totWP += 1.0 * (won[j]) / (played[j] - 1);
                    }
                }
            }
            owp[i] = totWP / by;
        }

        for(int i = 0; i < n; ++i) {
            int by = 0;
            for(int j = 0; j < n; ++j) {
                if (matches[i].charAt(j) != '.') {
                    ++by;
                    oowp[i] += owp[j];
                }
            }
            oowp[i] /= by;
        }

        StringBuilder res = new StringBuilder();
        for(int i = 0; i < n; ++i) {
            double rpi = 0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
            res.append("\n");
            res.append(rpi);
        }

        return res.toString();
    }

}
