package gcj2011.round2;

import java.util.*;

/**
 * Author -
 * User: kansal
 * Date: 6/4/11
 * Time: 7:19 PM
 */
public class A {
    public String solve() {
        int X = io.nextInt(), S = io.nextInt(), R = io.nextInt(), t = io.nextInt(), n = io.nextInt() + 1;
        int[] B = new int[n];
        int[] E = new int[n];
        int[] W = new int[n];
        for(int i = 0; i < n-1; ++i) {
            B[i] = io.nextInt();
            E[i] = io.nextInt();
            W[i] = io.nextInt();
        }
        B[n-1] = E[n-2];
        E[n-1] = X;
        W[n-1] = 0;

        PriorityQueue<Fraction> pq = new PriorityQueue<Fraction>();
        List<Part> parts = new ArrayList<Part>();

        int pos = 0;
        for(int i = 0; i < n; ++i) {
            int num = B[i] - pos, den = S;
            if (num > 0) {
                pq.add(new Fraction(num, den));
                parts.add(new Part(num, den));
            }
            pq.add(new Fraction(E[i] - B[i], S+W[i]));
            parts.add(new Part(E[i] - B[i], S+W[i]));
            pos = E[i];
        }

        Collections.sort(parts);

        double EPS = 1e-9;
        double res = 0.0;
        double T = t;

        for(Part p: parts) {
            double dis = p.d;
            int speed = p.s, runSpeed = p.s + (R-S);
            double runTime = dis / runSpeed;
            if (runTime > T) {
                double dd = T * runSpeed;
                res += (dis - dd) / speed;
                res += T;
                T = 0;
            }
            else {
                res += runTime;
                T -= runTime;
            }
        }

        return ""+res;
        /*
        while (pq.size() > 0) {
            Fraction f = pq.poll();
            int d = f.a, s = f.b;
            if (T > EPS) {
                double time = 1.0 * d / (s + R - S);
                if (time > T) {
                    res += T;
                    double dd = d - ((s+R-S) * T);
                    res += dd / s;
                    T = 0.0;
                }
                else {
                    res += time;
                    T -= time;
                }
            }
            else {
                res += 1.0 * d / s;
            }
        }

        return "" + res;*/
    }

    static class Part implements Comparable<Part> {
        int d, s;
        public Part(int dis, int speed) {
            d = dis;
            s = speed;
        }
        public int compareTo(Part other)  {
            if (s != other.s) {
                return s - other.s;
            }
            return other.d - d;
        }
    }

    static class Fraction implements Comparable<Fraction> {
        int a, b;

        public Fraction(int num, int den) {
            a = num;
            b = den;
        }

        public int compareTo(Fraction other) {
            return other.a * b - other.b * a;
        }
    }

    private static IOUtil.IO io;
    public static void main(String[] args) {
        String inFilePrefix = "C:\\Users\\kansal\\Downloads\\";
        String outFilePrefix = "C:\\RAJAT\\Codes\\Contests\\GCJ\\src\\gcj2011\\round2\\";

        String input = "A-small-attempt2.in";
        String output = "A-small-attempt2.out";
//        String input = "A-large.in";
//        String output = "A-large.out";

        io = new IOUtil.IO(inFilePrefix + input, outFilePrefix + output);

        int T = io.nextInt();
        for(int i = 1; i <= T; ++i) {
            try {
                String res = new A().solve();
                String print = String.format("Case #%d: %s", i, res);
                io.writer.println(print);
                System.out.println(print);
            }
            catch (Exception e) {
                System.out.println("Exception thrown for case:" + i + ", " + e);
                e.printStackTrace();
            }
        }

        io.closeStreams();
    }
}
