package gcj2011.qual;

import IOUtil.*;

import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;

/**
 * Author -
 * User: kansal
 * Date: 5/7/11
 * Time: 11:07 AM
 */
public class GoroSort {
    private static IO io;
    public static void main(String[] args) {
        String inFilePrefix = "C:\\Users\\kansal\\Downloads\\";
        String outFilePrefix = "C:\\RAJAT\\Codes\\Contests\\GCJ\\src\\IOUtil\\";

        String input = "D-small-attempt2.in";
        String output = "GoroSort-small-attempt2.out";
//        String input = "D-large.in";
//        String output = "GoroSort-large.out";

        io = new IO(inFilePrefix + input, outFilePrefix + output);

        int T = io.nextInt();
        for(int i = 1; i <= T; ++i) {
            try {
                String res = new GoroSort().solve();
                io.writer.println(String.format("Case #%d: %s", i, res));
            }
            catch (Exception e) {
                System.out.println("Exception thrown for case:" + i + ", " + e);
            }
        }

        io.closeStreams();
    }

    public String solve1() {
        int n = io.nextInt();
        final int[] nums = new int[n];
        for(int i = 0; i < n; ++i) nums[i] = io.nextInt();

        State s = new State(nums);
        cache = new HashMap<State, Double>();

        double res = rec(nums);
        return "" + res;
    }

    Map<State, Double> cache;
    public double rec(int[] nums) {
        boolean sorted = true;
        for(int i = 1; i < nums.length; ++i) {
            if (nums[i] < nums[i-1]) {
                sorted = false;
                break;
            }
        }
        if (sorted) return 0;

        State s = new State(nums);
        if (cache.containsKey(s)) {
            return cache.get(s);
        }

        return 0.0;
    }

    class State {
        int[] a;
        public State(int[] a) {
            this.a = a.clone();
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            State state = (State) o;

            if (!Arrays.equals(a, state.a)) return false;

            return true;
        }

        @Override
        public int hashCode() {
            return a != null ? Arrays.hashCode(a) : 0;
        }
    }

    public String solve() {
        int n = io.nextInt();
        final int[] nums = new int[n];
        for(int i = 0; i < n; ++i) nums[i] = io.nextInt() - 1;

        boolean[] seen = new boolean[n];

        double res = 0;
        for(int i = 0; i < n; ++i) {
            if (!seen[i]) {
                int j = i, cycle = 0;
                while (!seen[j]) {
                    seen[j] = true;
                    j = nums[j];
                    ++cycle;
                }
                res += Math.pow(2, cycle-1);
            }
        }

        return ""+res;
    }
}
