package gcj2011.round1B;

import java.util.ArrayList;
import java.util.List;

/**
 * Author -
 * User: kansal
 * Date: 5/21/11
 * Time: 10:57 PM
 */
public class KittenHouse {
    private static IOUtil.IO io;
    public static void main(String[] args) {
        String inFilePrefix = "C:\\Users\\kansal\\Downloads\\";
        String outFilePrefix = "C:\\RAJAT\\Codes\\Contests\\GCJ\\src\\gcj2011\\round1B\\";

        String input = "C-small-attempt0.in";
        String output = "C-small-attempt1.out";
//        String input = "C-large.in";
//        String output = "C-large.out";

        io = new IOUtil.IO(inFilePrefix + input, outFilePrefix + output);

        int T = io.nextInt();
        for(int i = 1; i <= T; ++i) {
            try {
                String res = new KittenHouse().solve();
                String print = String.format("Case #%d: %s", i, res);
                io.writer.println(print);
                System.out.println(print);
            }
            catch (Exception e) {
                System.out.println("Exception thrown for case:" + i + ", " + e);
                e.printStackTrace();
            }
        }

        io.closeStreams();
    }

    public String solve() {
        int n = io.nextInt(), m = io.nextInt();

        if (m == 0) {
            StringBuilder res = new StringBuilder();
            res.append(n);
            res.append("\n");
            for(int i = 1; i <= n; ++i) {
                res.append(i + " ");
            }
            return res.toString();
        }

        U = new int[m];
        V = new int[m];
        for(int i = 0; i < m; ++i) {
            U[i] = io.nextInt() - 1;
        }
        for(int i = 0; i < m; ++i) {
            V[i] = io.nextInt() - 1;
        }

        wall = new boolean[n][n];
        for(int i = 0; i < m; ++i) {
            wall[U[i]][V[i]] = true;
            wall[V[i]][U[i]] = true;
        }

        colors = new int[n];
        work = new int[n];
        work[0] = 1;
        tryAll(1, 1);

        StringBuilder res = new StringBuilder();
        res.append(best);
        res.append("\n");
        for(int x: colors) {
            res.append(x);
            res.append(" ");
        }
        return res.toString();
    }

    int best = 0;
    int[] colors;
    int[] work;
    int[] U, V;
    boolean[][] wall;

    private void tryAll(int pos, int M) {
        if (pos == colors.length) {
            do {
                if (checkColoring()) {
                    for(int i = 0; i < work.length; ++i) colors[i] = work[i];
                    best = M;
                    break;
                }
            } while (next_permutation(work, 0, work.length));
            return;
        }

        for(int c = M; c <= Math.min(M+1, work.length/2+1); ++c) {
            work[pos] = c;
            tryAll(pos+1, c);
        }
    }

    private boolean checkColoring() {
        int n = work.length;

        boolean[] pillar = new boolean[n];
        for(int i = 0; i < U.length; ++i) {
            pillar[U[i]] = pillar[V[i]] = true;
        }

        for(int set = 7; set < (1 << n); ++set) {
            int vertices = Integer.bitCount(set);
            if (vertices < 3) {
                continue;
            }
            List<Integer> v = new ArrayList<Integer>();
            for(int i = 0; i < n; ++i) {
                if (((set >> i) & 1) == 1) {
                    v.add(i);
                }
            }
            int walls = 0;
            for(int i = 0; i < vertices; ++i) {
                for(int j = i+1; j < vertices; ++j) {
                    int u1 = v.get(i), u2 = v.get(j);
                    if (wall[u1][u2]) {
                        ++walls;
                    }
                    else {
                        if (u2 - u1 == 1 || u2 - u1 == n-1) {
                            ++walls;
                        }
                    }
                }
            }
            if (walls == vertices) {
                int M = work[0];
                for(int m: work) M = Math.max(M, m);
                boolean[] has = new boolean[M+1];
                for(int vv: v) {
                    has[work[vv]] = true;
                }
                for(int i = 1; i <= M; ++i) {
                    if (!has[i]) return false;
                }
            }
        }
        return true;
    }

    public static boolean next_permutation(int[] arr, int beg, int end) {
        if (end - beg <= 1)
            return false;
        int i = end - 1;

        for (; ;) {
            int ii = i;
            --i;
            if (arr[i] < arr[ii]) {
                int j = end;
                while (!(arr[i] < arr[--j])) ;
                int tmp = arr[i];
                arr[i] = arr[j];
                arr[j] = tmp;
                for (int k = ii, l = end - 1; k < l; ++k, --l) {
                    tmp = arr[k];
                    arr[k] = arr[l];
                    arr[l] = tmp;
                }
                return true;
            }
            if (i == beg) {
                for (int k = beg, l = end - 1; k < l; ++k, --l) {
                    int tmp = arr[k];
                    arr[k] = arr[l];
                    arr[l] = tmp;
                }
                return false;
            }
        }
    }
}
