package gcj2011.round1A;

import java.util.*;

/**
 * Author -
 * User: kansal
 * Date: 5/21/11
 * Time: 7:30 AM
 */
public class HangMan {
    private static IOUtil.IO io;
    public static void main(String[] args) {
        String inFilePrefix = "C:\\Users\\kansal\\Downloads\\";
        String outFilePrefix = "C:\\RAJAT\\Codes\\Contests\\GCJ\\src\\gcj2011\\round1A\\";

        String input = "B-small-attempt1.in";
        String output = "B-small-attempt1.out";
//        String input = "B-large.in";
//        String output = "B-large.out";

        io = new IOUtil.IO(inFilePrefix + input, outFilePrefix + output);

        int T = io.nextInt();
        for(int i = 1; i <= T; ++i) {
            try {
                String res = new HangMan().solve();
                io.writer.println(String.format("Case #%d: %s", i, res));
            }
            catch (Exception e) {
                System.out.println("Exception thrown for case:" + i + ", " + e);
                e.printStackTrace();
            }
        }

        io.closeStreams();
    }

    public String solve() {
        int N = io.nextInt(), M = io.nextInt();
        String[] D = new String[N];
        String[] L = new String[M];
        for(int i = 0; i < N; ++i) D[i] = io.next();
        for(int i = 0; i < M; ++i) L[i] = io.next();

        preprocess(D);

        StringBuilder res = new StringBuilder();
        for(String list: L) {
            int worstScore = -1; String bestD = null;
            for(int d = 0; d < D.length; ++d) {
                String word = D[d];
                int score = 0;
                int mask = 0;
                for(int i = 0; i < list.length(); ++i) {
                    Map<String, MyValue> map = maps[word.length()][mask].map;
                    MyValue v = map.get(getKey(word, mask));
                    if (v.n > 0) {
                        if (v.rightGuesses.contains(list.charAt(i))) {
                            int m = f[d][list.charAt(i)-'a'];
                            if (m == 0) {
                                ++score;
                            }
                            else {
                                mask |= m;
                            }
                            if (mask == (1 << word.length())-1) {
                                break;
                            }
                        }
                    }
                }
                if (score > worstScore) {
                    worstScore = score;
                    bestD = word;
                }
            }

            res.append(bestD + " ");
        }

        return res.toString();
    }

    private String getKey(String w, int mask) {
        StringBuilder key = new StringBuilder();
        for(int i = 0; i < w.length(); ++i) {
            if (((mask >> i) & 1) == 1) {
                key.append(w.charAt(i));
            }
        }
        return key.toString();
    }

    private MyMap[][] maps;
    private int[][] f;
    private void preprocess(String[] D) {
        int n = D.length;

        f = new int[n][26];
        for(int i = 0; i < n; ++i) {
            String d = D[i];
            for(int j = 0; j < 26; ++j) {
                int m = 0;
                for(int k = 0; k < d.length(); ++k) {
                    if (d.charAt(k) == (char)('a' + j)) {
                        m |= (1 << k);
                    }
                }
                f[i][j] = m;
            }
        }

        int maxLen = 0;
        for(String d: D) {
            maxLen = Math.max(maxLen, d.length());
        }

        maps = new MyMap[11][];
        for(int len = 1; len <= maxLen; ++len) {
            maps[len] = new MyMap[1 << len];
             for(int mask = 0; mask < (1 << len); ++mask) {
                Map<String, MyValue> map = new HashMap<String, MyValue>();
                maps[len][mask] = new MyMap(map);
                for(String d: D) {
                    if (d.length() != len) {
                        continue;
                    }
                    StringBuilder key = new StringBuilder();
                    Set<Character> rG = new HashSet<Character>();
                    for(int i = 0; i < d.length(); ++i) {
                        if (((mask >> i) & 1) == 1) {
                            key.append(d.charAt(i));
                        }
                        else {
                            rG.add(d.charAt(i));
                        }
                    }
                    boolean bad = false;
                    for(Character c: rG) {
                        if (key.indexOf(""+c) >= 0) {
                            bad = true;
                            break;
                        }
                    }
                    if (bad) {
                        continue;
                    }
                    MyValue v = map.containsKey(key.toString()) ? map.get(key.toString()) : new MyValue(0, new HashSet<Character>());
                    v.n = v.n + 1;
                    v.rightGuesses.addAll(rG);
                    map.put(key.toString(), v);
                }
            }
        }
    }

    class MyMap {
        Map<String, MyValue> map;
        public MyMap(Map<String, MyValue> map) {
            this.map = map;
        }
    }

    class MyValue {
        int n;
        Set<Character> rightGuesses;
        public MyValue(int n, Set<Character> rG) {
            this.n = n;
            this.rightGuesses = rG;
        }
    }
}
