package gcj2011.round1A;

import java.io.*;
import java.util.StringTokenizer;

/**
 * Author -
 * User: kansal
 * Date: 3/15/11
 * Time: 9:12 PM
 */
public class IO {
    public BufferedReader reader;
    public PrintWriter writer;
    public StringTokenizer tokenizer = null;

    public IO() {
        this.reader = new BufferedReader(new InputStreamReader(System.in));
        this.writer = new PrintWriter(System.out);

        System.out.println("Reading input from console..");
    }

    public IO(String inFile, String outFile) {
        try {
            this.reader = new BufferedReader(new FileReader(inFile));
            this.writer = new PrintWriter(outFile);
        } catch (FileNotFoundException e) {
            this.reader = new BufferedReader(new InputStreamReader(System.in));
            this.writer = new PrintWriter(System.out);

            System.out.println("Reading input from console..");
        }
    }

    public void closeStreams() {
        try {
            reader.close();
            writer.close();
        } catch (IOException e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
        }
    }

    String nextToken() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    public long nextLong() {
        return Long.parseLong(nextToken());
    }

    public String nextLine() {
        String line = null;
        try {
            line = reader.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        return line;
    }

    public String next() {
        return nextToken();
    }

}
