package gcj2011.qual;

import IOUtil.*;

import java.util.Arrays;

/**
 * Author -
 * User: kansal
 * Date: 5/7/11
 * Time: 10:21 AM
 */
public class CandySplitting {
    private static IO io;
    public static void main(String[] args) {
        String inFilePrefix = "C:\\Users\\kansal\\Downloads\\";
        String outFilePrefix = "C:\\RAJAT\\Codes\\Contests\\GCJ\\src\\IOUtil\\";

        String input = "C-small-attempt0.in";
        String output = "CandySplitting-small-attempt0.out";
//        String input = "C-large.in";
//        String output = "CandySplitting-large.out";

        io = new IO(inFilePrefix + input, outFilePrefix + output);

        int T = io.nextInt();
        for(int i = 1; i <= T; ++i) {
            try {
                String res = new CandySplitting().solveSure();
                io.writer.println(String.format("Case #%d: %s", i, res));
            }
            catch (Exception e) {
                System.out.println("Exception thrown for case:" + i + ", " + e);
            }
        }

        io.closeStreams();
    }

    public String solveFast() {
        int n = io.nextInt();
        int[] vals = new int[n];
        for(int i = 0; i < n; ++i) vals[i] = io.nextInt();

        int f = 0;
        for(int x: vals) f ^= x;
        if (f != 0) return "NO";

        Arrays.sort(vals);
        int total = 0;
        for(int x: vals) total += x;
        total -= vals[0];

        return "" + total;
    }

    public String solveSure() {
        int n = io.nextInt();
        int[] vals = new int[n];
        for(int i = 0; i < n; ++i) vals[i] = io.nextInt();

        int f = 0;
        for(int x: vals) f ^= x;
        if (f != 0) return "NO";

        int best = -1;
        for(int set = 1; set < (1 << n)-1; ++set) {
            int[] xor = new int[2];
            int[] sum = new int[2];
            for(int i = 0; i < n; ++i) {
                int z = ((set >> i) & 1);
                xor[z] ^= vals[i];
                sum[z] += vals[i];
            }
            if (xor[0] == xor[1]) {
                best = Math.max(best, Math.max(sum[0], sum[1]));
            }
        }

        return "" + best;
    }
}
