import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;

/**
 * Created by ags on 07/05/11 at 19:00
 */
public class Magicka
{
    private int cases;
    private BufferedReader reader;

    public static void main(String[] args) throws IOException
    {
        new Magicka().solve();
    }

    private void solve() throws IOException
    {
        reader = new BufferedReader(new InputStreamReader(System.in));
        cases = Integer.parseInt(reader.readLine());
        for (int i = 1; i <= cases; i++)
        {
            List<String> solution = new Case().solve();
            System.out.print("Case #" + i + ": [");
            for(int j = 0; j < solution.size(); j++)
            {
                if(j > 0)
                    System.out.print(", ");
                System.out.print(solution.get(j));
            }
            System.out.println("]");
        }
    }

    class Case
    {
        private HashMap<String, HashMap<String, String>> combines = new HashMap<String, HashMap<String, String>>();
        private Map<String, HashSet<String>> opposed = new HashMap<String, HashSet<String>>();
        List<String> elements = new ArrayList<String>();

        int[] letters = new int[8];

        public List<String> solve() throws IOException
        {
            String[] split = reader.readLine().split("\\ ");

            int i = 0;
            int combineCount = Integer.parseInt(split[i++]);
            for(int j = 0; j < combineCount; j++)
            {
                addCombine(split[i++]);
            }
            int opposedCount = Integer.parseInt(split[i++]);
            for(int j = 0; j < opposedCount; j++)
            {
                addOpposed(split[i++]);
            }
            i++;
            List<String> strings = Arrays.asList(split[i].split("", 0));
            elements.addAll(strings);
            elements.remove(0);

            return process(elements);
        }

        private List<String> process(List<String> elements)
        {
            List<String> result = new ArrayList<String>();

            String previous = "";
            for(int i = 0; i < elements.size(); i++)
            {
                String first = elements.get(i);

                if(combine(previous, first))
                {
                    String combined = combines.get(first).get(previous);
                    result.remove(result.size() - 1);
                    result.add(combined);
                    decreaseBase(previous);
                    previous = combined;
                }
                else if(opposedCount(first) > 0)
                {
                    letters = new int[8];
                    result.clear();
                    previous = "";
                }
                else
                {
                    increaseBase(first);
                    result.add(first);
                    previous = first;
                }
            }

            return result;
        }

        private void decreaseBase(String previous)
        {
            modify(previous, -1);
        }

        private void increaseBase(String first)
        {
            modify(first, 1);
        }

        private void modify(String first, int value)
        {
            if(first.equals("Q")) letters[0]+= value;
            if(first.equals("W")) letters[1]+= value;
            if(first.equals("E")) letters[2]+= value;
            if(first.equals("R")) letters[3]+= value;
            if(first.equals("A")) letters[4]+= value;
            if(first.equals("S")) letters[5]+= value;
            if(first.equals("D")) letters[6]+= value;
            if(first.equals("F")) letters[7]+= value;
        }

        private int opposedCount(String opponent)
        {
            int result = 0;
            if(!opposed.containsKey(opponent))
                return  0;
            
            for (String first : opposed.get(opponent))
            {
                if(first.equals("Q")) result += letters[0];
                if(first.equals("W")) result += letters[1];
                if(first.equals("E")) result += letters[2];
                if(first.equals("R")) result += letters[3];
                if(first.equals("A")) result += letters[4];
                if(first.equals("S")) result += letters[5];
                if(first.equals("D")) result += letters[6];
                if(first.equals("F")) result += letters[7];
            }

            return result;
        }

        private boolean combine(String first, String second)
        {
            if (first.equals(second))
                return (combines.containsKey(first) && combines.get(first).containsKey(second));
            else
                return combines.containsKey(first) && combines.containsKey(second);
        }

        private void addCombine(String s)
        {
            String first = s.substring(0, 1);
            String second = s.substring(1, 2);
            String third = s.substring(2);

            if(!combines.containsKey(first))
            {
                combines.put(first, new HashMap<String, String>());
            }
            Map<String, String> secondLevel = combines.get(first);
            secondLevel.put(second, third);

            if(!combines.containsKey(secondLevel))
            {
                combines.put(second, new HashMap<String, String>());
            }
            secondLevel = combines.get(second);
            secondLevel.put(first, third);
        }

        private void addOpposed(String s)
        {
            String first = s.substring(0, 1);
            String second = s.substring(1, 2);

            if(!opposed.containsKey(first))
                opposed.put(first, new HashSet<String>());
            if(!opposed.containsKey(second))
                opposed.put(second, new HashSet<String>());

            opposed.get(first).add(second);
            opposed.get(second).add(first);
        }
    }
}
