import java.util.*;

public class Main {

    private Scanner scanner = new Scanner(System.in);

    public static void main(String[] args) {
        new Main().execute();
    }

    private void execute() {
        int cases = scanner.nextInt();

        for(int i = 1; i <= cases; i++)
            new TestCase(scanner, i).testCase();
    }
}

class TestCase
{
    private final int caseNo;
    private final int factor;
    private final int minPpl;
    private final int totalPpl;

    TestCase(Scanner scanner, int caseNo) {
        this.caseNo = caseNo;

        this.minPpl = scanner.nextInt();
        this.totalPpl = scanner.nextInt();
        this.factor = scanner.nextInt();
    }

    void testCase()
    {
        int result = Math.min(solve(minPpl, totalPpl), solve2());

        if (result >= 0) {
            System.out.println("Case #" + caseNo + ": " + result);
        } else {
            System.out.println("Case #" + caseNo + ": IMPOSSIBLE");
        }
    }

    private int solve2() {
        int result = 0;

        int powLowerThanMax = lowerPower(totalPpl);
        int maxPowGeqLow = higherPower(minPpl);

        Long l = null;
        int steps = 0;

        if (powLowerThanMax > maxPowGeqLow) {
            Double v = Math.sqrt(powLowerThanMax - maxPowGeqLow);
            l = Math.round(Math.floor(v));
            steps = l.intValue() + maxPowGeqLow;
        }

        int newTotal = totalPpl;
        if (steps > 1)
        {
            newTotal = pow(factor, steps);
            result += l.intValue();
        }

        result += solve(minPpl, newTotal - 1);

        return result;
    }

    private int pow(int number, int l) {
        int result = number;
        for(int i = 0; i < l; i++)
            result *= number;

        return result;
    }

    private int solve(int minPpl, int totalPpl) {
        int result = 0;

        int lowLimit = minPpl * factor;
        if(lowLimit >= totalPpl)
            return 0;

        int newHigh = (totalPpl / minPpl) * minPpl;
        int top = (newHigh == totalPpl) ? (totalPpl / factor) : newHigh;

        while(lowLimit <= top)
        {
            result++;
            top = top / factor;
        }

        return result;
    }

    public int gcd(int a, int b) {

        if (b==0)
            return a;
        else
            return gcd(b, a % b);
    }


    int lowerPower(int totalPeople) {
        int count = 0;
        int value = factor;

        while(value < totalPeople) {
            value *= factor;
            count++;
        }

        return count;
    }


    int higherPower(int min)
    {
        int count = 1;
        int value = factor;

        while(value < min) { value *= factor; count++; }

        return count;
    }
}

