import java.util.*;

public class Main {

    private Scanner scanner = new Scanner(System.in);

    public static void main(String[] args) {
        new Main().execute();
    }

    private void execute() {
        int cases = scanner.nextInt();

        for(int i = 1; i <= cases; i++)
            new TestCase(scanner, i).testCase();
    }
}

class TestCase
{
    private int caseNo;
    private List<Wire> wires = new ArrayList<Wire>();

    TestCase(Scanner scanner, int caseNo) {
        this.caseNo = caseNo;

        int wireCount = scanner.nextInt();

        for(int i = 0; i < wireCount; i++)
            this.wires.add(new Wire(scanner.nextInt(), scanner.nextInt()));
    }

    void testCase()
    {
        int result = solve();

        if (result >= 0) {
            System.out.println("Case #" + caseNo + ": " + result);
        } else {
            System.out.println("Case #" + caseNo + ": IMPOSSIBLE");
        }
    }

    private int solve() {
        int result = 0;

        for (int i = 0; i < wires.size(); i++) {
            Wire wire1 = wires.get(i);

            for (int j = (i + 1); j < wires.size(); j++) {
                Wire wire2 = wires.get(j);

                if(wire1.crosses(wire2))
                    result++;

            }
        } 

        return result;
    }
}

class Wire
{
    int start;
    int end;

    Wire(int start, int end) {
        this.start = start;
        this.end = end;
    }

    public boolean crosses(Wire that) {
        int starts = this.start - that.start;
        int ends = this.end - that.end;
        int delta = starts * ends;
        return delta < 0;
    }

    @Override
    public String toString() {
        return "Wire{" +
                 start +
                ", " + end +
                '}';
    }
}