import java.util.*;
import java.io.*;

public class BMain{
	public static void main(String[] args){
		if(args.length<1){
			System.out.println("Usage: <fnIn>");
		}
		String fn = args[0];
		String fnOut = toFnOut(fn);
		try{
			BufferedReader br = new BufferedReader(new FileReader(fn));
			BufferedWriter bw = new BufferedWriter(new FileWriter(fnOut));
			String line = null;
			int NCase = Integer.valueOf(br.readLine().trim());
			for(int icase=0;icase<NCase;icase++){
				String[] parts = br.readLine().trim().split("[\\s+]");
				//~ System.out.println(Arrays.toString(parts));
				int R = Integer.valueOf(parts[0]);
				int C = Integer.valueOf(parts[1]);
				int F = Integer.valueOf(parts[2]);
				char[][] buf = new char[R][];
				for(int i=0;i<R;i++) buf[i] = br.readLine().trim().toCharArray();
				String res = process(R,C,F,buf);
				String out = "Case #"+(icase+1)+": "+res;
				bw.write(out,0,out.length());
				bw.newLine();
				
			}
			br.close();
			bw.close();
		}catch(IOException ex){
			System.out.println(ex);
		}
	}
	
	static String process(int R, int C, int F, char[][] buf){
		int INF = 1000000;
		int[][] dp = new int[R][C];
		boolean[][] stand = new boolean[R][C];
		boolean[][] dig = new boolean[R][C];
		for(int i=0;i<R;i++){
			for(int j=0;j<C;j++){
				dp[i][j] = INF;
			}
		}
		for(int i=0;i<C;i++){
			if(buf[0][i]=='.'){
				dp[0][i] = 0;
				stand[0][i] = true;
			}else break;
		}
		for(int j=1;j<R;j++){
			for(int i=0;i<C;i++){
				int tmp = INF;
				if(buf[j][i]=='.'){
					int k=j;
					while(k>1){
						if(buf[k][i]=='#') break;
						k--;
					}
					if(j-k+1>F) tmp = INF;
					else tmp = dp[j-1][i];
				}else{
					int tmp1 = INF;
					int add = 0;
					if(buf[j-1][i]=='.'){
						add = 1;
					}else if(dp[j-1][i]<INF){
						add = 2;
					}
					if(add > 0){
						if(i>0 && stand[j-1][i-1]) tmp1 = Math.min(tmp1,dp[j-1][i-1]+add);
						if(i<C-1 && stand[j-1][i+1]) tmp1 = Math.min(tmp1,dp[j-1][i+1]+add);
						tmp = tmp1;
					}
				}
				dp[j][i] = tmp;
				if(tmp<INF){
					if(j==R-1 || buf[j+1][i]=='#'){
						stand[j][i] = true;
						for(int k=i-1;k>=0;k--){
							if(j==R-1 || buf[j+1][k]=='#') stand[j][k] = true;
							else break;
						}
						for(int k=i+1;k<C;k++){
							if(j==R-1 || buf[j+1][k]=='#') stand[j][k] = true;
							else break;
						}
					}
				}
			}
		}
		for(int i=0;i<R;i++){
			System.out.println(Arrays.toString(dp[i]));
		}
		int min = INF;
		for(int i=0;i<C;i++) min = Math.min(min,dp[R-1][i]);
		if(min>=INF) return "No";
		return "Yes "+min;
	}
	
	static String toFnOut(String fn){
		if(fn.lastIndexOf('.')!=-1){
			return fn.substring(0,fn.lastIndexOf('.'))+".out";
		}else return fn + ".out";
	}
}
