// by agus.mw
import java.util.*;
import java.io.*;

public class Main{
  public static void main(String[] args) throws Exception {
    new Main().doWork();
  }
  void doWork() throws Exception{
    BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    
    int ncase = Integer.valueOf(reader.readLine());
    for(int icase=0;icase<ncase;icase++){
      int k = Integer.valueOf(reader.readLine());
      char[][] buf = new char[k][k];
      for(int i=0;i<2*k-1;i++){
        int[] tmp = toIntArray(reader.readLine().trim());
        if(i<k){
          for(int j=0;j<tmp.length;j++) {
            buf[i-j][j] = (char)(tmp[j]+'0');
          }
        }else{
          for(int j=0;j<tmp.length;j++) {
            //~ System.out.println(Arrays.toString(new int[]{k-1-j,k-i+j}));
            //~ System.out.println(Arrays.toString(new int[]{i,j,k}));
            buf[k-1-j][i-(k-1)+j] = (char)(tmp[j]+'0');
          }
        }
      }
      //~ System.out.println("Case:"+(icase+1));
      //~ print(buf);
      String out = process(buf,k);
      out = "Case #"+(icase+1)+": "+out+"\r\n";
      writer.write(out,0,out.length());
    }
    
    writer.flush();
    writer.close();
    reader.close();
  }
  void print(char[][] buf){
    for(int i=0;i<buf.length;i++){
      System.out.println(new String(buf[i]));
    }
    System.out.println();
  }
  String process(char[][] buf,int N){
    int out = 1000000000;
    out = Math.min(out,countReq(buf,N,0));
    buf = rotate(buf,N);
    out = Math.min(out,countReq(buf,N,0));
    buf = rotate(buf,N);
    out = Math.min(out,countReq(buf,N,0));
    buf = rotate(buf,N);
    out = Math.min(out,countReq(buf,N,0));
    buf = rotate(buf,N);
    out = sqr(out+N)-sqr(N);
    return ""+out;
  }
  char[][] rotate(char[][] buf, int N){
    char[][] out = new char[N][N];
    for(int i=0;i<N;i++){
      for(int j=0;j<N;j++){
        out[i][j] = buf[j][N-1-i];
      }
    }
    //~ print(out);
    return out;
  }
  int sqr(int x){
    return x*x;
  }
  int countReq(char[][] buf, int N, int offset){
    if(isValid(buf,N,offset)){
      return 0;
    }else{
      int tmp = countReq(buf,N,offset+1);
      if(isStraight(buf,N,offset) && tmp<(N-offset-1)-1){
        return 1+tmp;
      }else{
        return (N-offset)-1;
      }
    }
  }
  boolean isValid(char[][] buf, int N, int offset){
    for(int i=offset;i<N;i++){
      int di = i-offset;
      for(int j=offset;j<N;j++){
        int dj = j-offset;
        if(buf[i][j]!=buf[offset+dj][offset+di]) return false;
        if(buf[i][j]!=buf[N-1-dj][N-1-di]) return false;
      }
    }
    return true;
  }
  boolean isStraight(char[][] buf, int N, int offset){
    for(int i=offset;i<N;i++){
      if(buf[i][offset]!=buf[offset][i]) return false;
    }
    return true;
  }
  int[] toIntArray(String line){
    String[] p = line.split("[ ]+");
    int[] out = new int[p.length];
    for(int i=0;i<p.length;i++) out[i] = Integer.valueOf(p[i]);
    return out;
  }
}