import java.util.*;
import java.io.*;

public class AMain{
	public static void main(String[] args){
		if(args.length<1){
			System.out.println("Usage: <fnIn>");
		}
		String fn = args[0];
		String fnOut = toFnOut(fn);
		try{
			BufferedReader br = new BufferedReader(new FileReader(fn));
			BufferedWriter bw = new BufferedWriter(new FileWriter(fnOut));
			String line = null;
			int NCase = Integer.valueOf(br.readLine().trim());
			for(int icase=0;icase<NCase;icase++){
				int rows = Integer.valueOf(br.readLine().trim());
				String[] buf = new String[rows];
				for(int i=0;i<buf.length;i++) buf[i] = br.readLine().trim();
				String res = process(buf);
				String out = "Case #"+(icase+1)+": "+res;
				bw.write(out,0,out.length());
				bw.newLine();
				
			}
			br.close();
			bw.close();
		}catch(IOException ex){
			System.out.println(ex);
		}
	}
	
	static String process(String[] buf){
		int[] index =new int[buf.length];
		for(int i=0;i<buf.length;i++){
			if(buf[i].indexOf('1')==-1) index[i] = -1;
			else index[i] = buf[i].lastIndexOf('1');
		}
		//~ System.out.println(Arrays.toString(index));
		int swap = 0;
		for(int i=0;i<buf.length;i++){
			int j;
			for(j=i;j<buf.length;j++){
				if(index[j]<=i) break;
			}
			swap += j-i;
			for(int k=j;k>i;k--){
				index[k] = index[k-1];
			}
		}
		return ""+swap;
	}
	
	static String toFnOut(String fn){
		if(fn.lastIndexOf('.')!=-1){
			return fn.substring(0,fn.lastIndexOf('.'))+".out";
		}else return fn + ".out";
	}
}
