import java.util.*;
import java.io.*;

public class BMain{
	public static void main(String[] args){
		if(args.length<1){
			System.out.println("Usage: <fnIn>");
		}
		String fn = args[0];
		String fnOut = toFnOut(fn);
		try{
			BufferedReader br = new BufferedReader(new FileReader(fn));
			BufferedWriter bw = new BufferedWriter(new FileWriter(fnOut));
			String line = null;
			int NCase = Integer.valueOf(br.readLine().trim());
			for(int icase=0;icase<NCase;icase++){
				String in = br.readLine().trim();
				String buf = process(in.toCharArray());
				String out = "Case #"+(icase+1)+": "+buf;
				bw.write(out,0,out.length());
				bw.newLine();
				
			}
			br.close();
			bw.close();
		}catch(IOException ex){
			System.out.println(ex);
		}
	}
	
	static String process(char[] in){
		int x = in.length-1;
		while(x>0){
			if(in[x]>in[x-1]) break;
			x--;
		}
		if(x>0){
			int min = x;
			for(int i=min+1;i<in.length;i++){
				if(in[i]>in[x-1] && in[i]<in[min]) min = i;
			}
			swap(in,x-1,min);
			Arrays.sort(in,x,in.length);
			return new String(in);
		}else{
			Arrays.sort(in);
			x = 0;
			while(x<in.length && in[x]=='0') x++;
			char c = in[x];
			in[x] = '0';
			return ""+c+new String(in);
		}
	}
	
	static void swap(char[] in, int a, int b){
		char tmp = in[a];
		in[a] = in[b];
		in[b] = tmp;
	}
	
	static String toFnOut(String fn){
		if(fn.lastIndexOf('.')!=-1){
			return fn.substring(0,fn.lastIndexOf('.'))+".out";
		}else return fn + ".out";
	}
}
