// by agus.mw
import java.util.*;
import java.io.*;

public class Main{
  public static void main(String[] args) throws Exception {
    new Main().doWork();
  }
  void doWork() throws Exception{
    BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
    BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(System.out));
    
    int ncase = Integer.valueOf(reader.readLine());
    for(int icase=0;icase<ncase;icase++){
      String out = process(reader.readLine().trim());
      out = "Case #"+(icase+1)+": "+out+"\r\n";
      writer.write(out,0,out.length());
    }
    
    writer.flush();
    writer.close();
    reader.close();
  }
  String process(String line){
    String[] parts = line.split("[ ]+");
    int pCount = Integer.valueOf(parts[0]);
    char[][] pairs = new char[256][256];
    int cIndex = 1;
    while(cIndex<pCount+1){
      String tmp = parts[cIndex];
      pairs[tmp.charAt(0)][tmp.charAt(1)] = tmp.charAt(2);
      pairs[tmp.charAt(1)][tmp.charAt(0)] = tmp.charAt(2);
      cIndex ++;
    }
    int oCount = Integer.valueOf(parts[cIndex]); cIndex++;
    int offset = cIndex;
    boolean[][] opposes = new boolean[256][256];
    while(cIndex<oCount+offset){
      String tmp = parts[cIndex];
      opposes[tmp.charAt(0)][tmp.charAt(1)] = true;
      opposes[tmp.charAt(1)][tmp.charAt(0)] = true;
      cIndex++;
    }
    String msg = parts[parts.length-1];
    ArrayList<Character> out = new ArrayList<Character>();
    for(int i=0;i<msg.length();i++){
      char sym = msg.charAt(i);
      if(out.size()==0) out.add(0,sym);
      else{
        if(pairs[out.get(0)-0][sym-0] !=0){
          char tmp = pairs[out.get(0)-0][sym-0];
          out.remove(0);
          out.add(0,tmp);
        }else{
          int j = 0;
          for(;j<out.size();j++){
            if(opposes[out.get(j)-0][sym-0]) break;
          }
          if(j==out.size()){
            out.add(0,sym);
          }else{
            out.clear();
          }
        }
      }
    }
    String buf = "[";
    for(int i=out.size()-1;i>=0;i--){
      buf+=out.get(i);
      if(i!=0){
        buf+=", ";
      }
    }
    buf += "]";
    return buf;
  }
  int[] toIntArray(String line){
    String[] p = line.split("[ ]+");
    int[] out = new int[p.length];
    for(int i=0;i<p.length;i++) out[i] = Integer.valueOf(p[i]);
    return out;
  }
}