import java.util.*;

class C {
	static Scanner in = new Scanner(System.in);

	public static void main(String[] args) {
		int T = in.nextInt();
		
		for (int t = 0; t < T; ++t) {
			int[] x = solve();
			System.out.printf("Case #%d: %d %d%n", t + 1, x[0], x[1]);
		}
	}
	
	static int[] nextBest(boolean[] stalls) {
		int[] ret = new int[] { -1, -1, -1 };
		
		int l = 1;
		
		while (stalls[l])
			l++;
		
		while (l < stalls.length - 1) {
			int r = l + 1;
			
			while (!stalls[r])
				r++;
			
			int m = (r + l - 1) / 2;
			
			int a = m - l;
			int b = r - m - 1;
			
			int x = Math.max(a, b);
			int y = Math.min(a, b);
			
			if (ret[0] < a || (ret[0] == a && ret[1] < b)) {
				//System.out.printf("%d, %d%n", a, b);
				ret[0] = x;
				ret[1] = y;
				ret[2] = m;
			}
			
			l = r;
			
			while (l < stalls.length - 1 && stalls[l])
				l++;
		}
		
		return ret;
	}
	
	static int[] solve() {
		int N = in.nextInt();
		int K = in.nextInt();
		
		boolean[] stalls = new boolean[N + 2];
		stalls[0    ] = true;
		stalls[N + 1] = true;
		
		int[] x = null;
		for (int i = 0; i < K; ++i) {
			x = nextBest(stalls);
			//System.err.println(x[2]);
			stalls[x[2]] = true;
		}
		
		return x;
	}
}