import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class CoinJam {
	public static long divisor(int[] arr, int base, int[] primes) {
		long sum = 0;
		for (int i = 1; i <= arr.length; i++) {
			double num = Math.pow(base, arr.length - i);
			sum += arr[i - 1] * num;
		}
		for (long i = 3; i * i <= sum; i += 2) {
			if (sum % i == 0) {
				return i;
			}
		}
		return sum;
	}

	public static boolean isprime(long n) {
		if (n % 2 == 0) {
			return false;
		}
		for (int i = 3; i * i <= n; i += 2) {
			if (n % i == 0) {
				return false;
			}
		}
		return true;
	}

	public static boolean test(int[] arr) {
		for (int b = 2; b <= 10; b++) {
			long sum = 0;
			for (int i = 1; i <= arr.length; i++) {
				double num = Math.pow(b, arr.length - i);
				sum += arr[i - 1] * num;
			}
			if (isprime(sum)) {
				return false;
			}
		}
		return true;
	}

	public static void main(String[] args) {
		try {
			BufferedReader primes = new BufferedReader(new FileReader("Primes.txt"));
			int[] prime = new int[1000];
			for (int i = 0; i < 1000; i++) {
				prime[i] = Integer.parseInt(primes.readLine());
			}
			primes.close();
			BufferedReader br = new BufferedReader(new FileReader("Test.in"));
			int T = Integer.parseInt(br.readLine());
			FileWriter fw = new FileWriter("Test.out");
			for (int i = 1; i <= T; i++) {
				String[] input = br.readLine().split(" ");
				int N = Integer.parseInt(input[0]);
				int J = Integer.parseInt(input[1]);
				int value = (int) Math.pow(2, N - 1);
				fw.write("Case #" + i + ":\n");
				while (J > 0) {
					value++;
					if (value % 2 == 0) {
						value++;
					}
					String[] current = Integer.toBinaryString(value).split("");
					int[] arr = new int[N];
					for (int m = 1; m < current.length; m++) {
						arr[m - 1] = Integer.parseInt(current[m]);
					}
					if (test(arr)) {
						String answer = "";
						for (int k : arr) {
							answer += k;
						}
						answer += " ";
						for (int j = 2; j <= 10; j++) {
							answer += divisor(arr, j, prime);
							if (j != 10) {
								answer += " ";
							} else {
								answer += "\n";
							}
						}
						J--;
						fw.write(answer);
					}
				}
			}
			fw.close();
			br.close();
		} catch (IOException e) {
			System.out.println(e);
		}
	}
}
