import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;


public class TicTacToe {

	ArrayList<char[][]> testCases;
	String [] decisons ;
	
	public TicTacToe() {
		this.testCases = new ArrayList<char[][]>();		
	}
	
	public void checkAllTestCases(String filePath) throws IOException{
		readFile(filePath);
		for (int i = 0; i < this.testCases.size(); i++) {
			char [][]testCase = this.testCases.get(i);
			String d = checkTestCase(testCase);
			this.decisons[i] = d;
		}
		writeFile("ticTacToeOutput.txt");
	}
	
	
	private void writeFile(String filePath) throws IOException{
		FileWriter fstream = new FileWriter(filePath);
		BufferedWriter out = new BufferedWriter(fstream);
		for (int i = 0; i < this.decisons.length; i++) {
			out.write("Case #"+(i+1)+": "+this.decisons[i] +"\n");	
		}
		out.close();
	}
	
	
	private String checkTestCase(char[][] testCase){
		boolean gameDraw = true;
		int xCounter = 0;
		int oCounter = 0;
		int  tCounter = 0;
		
		//test rows
		for (int row = 0; row < 4; row++) {
			xCounter = oCounter = tCounter =0;
			for (int col = 0; col < 4; col++) {
				if(testCase[row][col]=='X') xCounter++;
				if(testCase[row][col]=='O') oCounter++;
				if(testCase[row][col]=='T') tCounter++;
				if(testCase[row][col]=='.') gameDraw=false;
			}
			if(xCounter+tCounter==4) return "X won";
			if(oCounter+tCounter==4) return "O won";
		}
		
		//test col
		for (int col = 0; col < 4; col++) {
			xCounter = oCounter = tCounter =0;
			for (int row = 0;row < 4; row++) {
				if(testCase[row][col]=='X') xCounter++;
				if(testCase[row][col]=='O') oCounter++;
				if(testCase[row][col]=='T') tCounter++;
				if(testCase[row][col]=='.') gameDraw=false;
			}
			if(xCounter+tCounter==4) return "X won";
			if(oCounter+tCounter==4) return "O won";
		}
		
		//test diagonal
		xCounter = oCounter = tCounter =0;
		for (int i = 0; i < 4; i++) {
			if(testCase[i][i]=='X') xCounter++;
			if(testCase[i][i]=='O') oCounter++;
			if(testCase[i][i]=='T') tCounter++;
			if(testCase[i][i]=='.') gameDraw=false;			
		}
		if(xCounter+tCounter==4) return "X won";
		if(oCounter+tCounter==4) return "O won";

		//test other diagonal
		xCounter = oCounter = tCounter =0;
		for (int i = 0; i < 4; i++) {
			if(testCase[i][3-i]=='X') xCounter++;
			if(testCase[i][3-i]=='O') oCounter++;
			if(testCase[i][3-i]=='T') tCounter++;
			if(testCase[i][3-i]=='.') gameDraw=false;			
		}
		if(xCounter+tCounter==4) return "X won";
		if(oCounter+tCounter==4) return "O won";
		
		if (gameDraw) return "Draw";
		return "Game has not completed";
		
	}
	
	
	
	
	public void readFile(String filePath) throws IOException{
		FileInputStream fstream = new FileInputStream(filePath);
		DataInputStream in = new DataInputStream(fstream);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		int numberOfCases = Integer.parseInt(br.readLine());
		this.decisons = new String[numberOfCases];
		String [] testCase = new String[4];
		int index= 0;
		String str = "";
		while(((str = br.readLine()) != null)){
			if(str.length()==0){
				testCases.add(buidlTestCase(testCase));
				index= 0;
			}else{
				testCase[index] = str;
				index++;										
			}
		}
		testCases.add(buidlTestCase(testCase));		
		in.close();
	}
	
	
	public char [][] buidlTestCase(String [] testCase){
		char [][] testCaseArray = new char[4][4];
		for (int i = 0; i < testCase.length; i++) {
			char [] array = testCase[i].toCharArray();
			for (int j = 0; j < array.length; j++) {
				testCaseArray[i][j]= array[j];
			}
		}
		return testCaseArray;
	}
	

	public ArrayList<char[][]> getTestCases() {
		return testCases;
	}
	
	
	public static void main(String[] args) throws IOException {	
		TicTacToe t = new TicTacToe();
		t.checkAllTestCases("A-small-attempt0.in");

	}
}
