import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;



public class Lawnmower {
	
	ArrayList<int [][]> testCases;
	String [] decisions;
	public Lawnmower() {
		this.testCases = new ArrayList<int[][]>();
	}
	
	public void checkAllTestCases(String filePath) throws IOException{
		readFile(filePath);
		for (int i = 0; i < this.testCases.size(); i++) {
			int [][] testCase = this.testCases.get(i);
			String d = checkTestCase(testCase);
			this.decisions[i]=d;
		}
		writeFile("mower.txt");
	}
	
	private void writeFile(String filePath) throws IOException{
		FileWriter fstream = new FileWriter(filePath);
		BufferedWriter out = new BufferedWriter(fstream);
		for (int i = 0; i < this.decisions.length; i++) {
			out.write("Case #"+(i+1)+": "+this.decisions[i] +"\n");	
		}
		out.close();
	}

	
	private String checkTestCase(int [][] testCase){
		int n = testCase.length;
		int m = testCase[0].length;
		int [] rowMax = new int [n];
		int [] colMax = new int [testCase[0].length];
		int zerosCounter=0;
		//calculate rowMax
		for (int row = 0; row < n; row++) {
			int max = 0;
			for (int col = 0; col < m; col++) {
				if(testCase[row][col] > max) {
					max = testCase[row][col];
				}
			}
			rowMax[row] = max;
		}
		//calculate colMax
		for (int col = 0; col < m; col++){
			int max = 0;
			for (int row = 0; row < n; row++) {
				if(testCase[row][col] > max) {
					max = testCase[row][col];
				}
			}
			colMax[col] = max;
		}
		//check the lawn
		for (int row = 0; row < n; row++) {
			for (int col = 0; col < m; col++) {
				if(testCase[row][col] == rowMax[row] || testCase[row][col] == colMax[col] ){
					testCase[row][col] =0 ;
					zerosCounter++;
				}
			}
		}
		
		if (zerosCounter==n*m) return "YES";

		return "NO";
	}
	
	public void readFile(String filePath) throws IOException{
		FileInputStream fstream = new FileInputStream(filePath);
		DataInputStream in = new DataInputStream(fstream);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		int numberOfCases = Integer.parseInt(br.readLine());
		this.decisions = new String[numberOfCases];
		int n;
		int m;
		for (int i = 0; i < numberOfCases; i++) {
			String[] nm = br.readLine().split(" ");
			n = Integer.parseInt(nm[0]);
			m = Integer.parseInt(nm[1]);
			int [][] testCase = new int [n][m];
			for (int row = 0; row < n; row++) {
				String [] line = br.readLine().split(" ");
				for (int col = 0; col < m; col++) {
					testCase[row][col] = Integer.parseInt(line[col]);
				}
			}
			this.testCases.add(testCase);
		}
	}
	
	
	public ArrayList<int[][]> getTestCases() {
		return testCases;
	}
	
	
	public static void main(String[] args) throws IOException {
		Lawnmower mower = new Lawnmower();
		mower.checkAllTestCases("B-small-attempt0.in");
	}

}
