import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;


public class FairAndSquare implements Comparator<String>{

	String [] decisions;
	ArrayList<String[]> testCases;
	public FairAndSquare() {
		this.testCases = new ArrayList<String[]>();
	}
	
	
	public void checkAllTestCases(String filePath) throws Exception{
		readFile(filePath);
		for (int i = 0; i < testCases.size(); i++) {
			String d = checkTestCase(this.testCases.get(i));
			this.decisions[i] = d;
		}
		writeFile("output.txt");
	}

	public String checkTestCase(String [] testCase){
		String A = testCase[0];
		String B = testCase[1];
		int count = 0;
		ArrayList<String> palindromsToB = allPalindromic(B);
		Collections.sort(palindromsToB, new FairAndSquare());
		
		for (int i = 0; i < palindromsToB.size(); i++) {
			String palindrom = palindromsToB.get(i);
			String multiplied = multiply(palindrom, palindrom);
			int comparisonToB = compareTwoNumbers(multiplied, B) ;
			if(compareTwoNumbers(multiplied, A) >=0 &&  comparisonToB <=0){
				if(isPalindrom(multiplied)){
					count++;
				}
			}else if (comparisonToB > 0){
				return String.valueOf(count);
			}
		}
		return String.valueOf(count);
	}
	
	
	public ArrayList<String> allPalindromic(String limit) {
	    ArrayList<String> result = new ArrayList<String>();
	    for (int i = 0; i <= 9 ; i++)
	        result.add(String.valueOf(i));
	    boolean cont = true;
	    for (int i = 1; cont; i++) {
	        StringBuffer rev = new StringBuffer("" + i).reverse();
	        cont = false;
	        for (String d : "0123456789".split("")) {
	            String n = ("" + i + d + rev);
	            int comparison = compareTwoNumbers(n, limit);
	            if(comparison <=0){
	                cont = true;
	                result.add(n);
	           }
	        }
	    }
	    return result;
	}
	
	private void writeFile(String filePath) throws IOException{
		FileWriter fstream = new FileWriter(filePath);
		BufferedWriter out = new BufferedWriter(fstream);
		for (int i = 0; i < this.decisions.length; i++) {
			out.write("Case #"+(i+1)+": "+this.decisions[i] +"\n");	
		}
		out.close();
	}

	
	
	public void readFile(String filePath) throws IOException{
		FileInputStream fstream = new FileInputStream(filePath);
		DataInputStream in = new DataInputStream(fstream);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		int numberOfCases = Integer.parseInt(br.readLine());
		this.decisions = new String[numberOfCases];
		for (int i = 0; i < numberOfCases; i++) {
			String[] nm = br.readLine().split(" ");
			String [] testCase = new String[2];
			testCase[0] = nm[0];
			testCase[1] = nm[1];
			this.testCases.add(testCase);
		}
	}
	
	
	
	public int compareTwoNumbers(String num1, String num2){
		if(num1.length() > num2.length()){
			return 1; // num1 is bigger
		}else if (num2.length() > num1.length()){
			return -1; //num2 is bigger
		} 	
		char [] array1 = num1.toCharArray();
		char [] array2 = num2.toCharArray();
		for (int i = 0; i < array1.length; i++) {
			if(array1[i] > array2[i]){
				return 1;
			}else if(array2[i] > array1[i]){
				return -1;
			}
		}
		return 0;
	}
	
	public boolean isPalindrom(String str){
		 int n = str.length();
		  for (int i=0;i<(n / 2) + 1;++i) {
		     if (str.charAt(i) != str.charAt(n - i - 1)) {
		         return false;
		     }
		  }
		  return true;
	}
	
	public String square(String str){
		  String number1 = str;
		  String number2 = str;
		  char[] n1 = number1.toCharArray();
		  char[] n2 = number2.toCharArray();
		  int result = 0;
		  for (int i = 0; i < n1.length; i++) {
	        for (int j = 0; j < n2.length; j++) {
	            result += (n1[i] - '0') * (n2[j] - '0')* (int) Math.pow(10, n1.length * 2 - (i + j + 2));
	        }
		  }
		    System.out.println(result);
		
		
		return "";
	}
	
	
	private int[] toIntArray(String str){
		int [] intArray = new int [str.length()];
		char[] charArray = str.toCharArray();
		for (int i = 0; i < charArray.length; i++) {
			intArray[i] = Character.getNumericValue(charArray[i]);
		}
		return intArray;
	}
	
	
	public String multiply(String a, String b) {
		  int[] ca = toIntArray(a); // please write toIntArray() yourself.
		  int[] cb = toIntArray(b);
		  int[] result = new int[ca.length + cb.length + 1];
		  int[] line = new int[ca.length + cb.length + 1];
		  for (int i=0;i<cb.length;i++) {
		    for (int k=0;k<line.length;k++) line[k] = 0;
		    int residue = 0;
		    for (int k=0;k<ca.length;k++) {
		      int digit = cb[cb.length-1-i] * ca[ca.length-1-k] + residue;
		      residue = digit/10;
		      digit = digit%10;
		      line[k+i] = digit;
		    }
		    line[ca.length+i] = residue;
		    residue = 0;
		    for (int k=0;k<result.length;k++) {
		      int digit = result[k] + line[k] + residue;
		      residue = digit/10;
		      digit = digit%10;
		      result[k] = digit;
		    } 
		  }
		  StringBuffer sb = new StringBuffer();
		  boolean matter = false;
		  for (int i=0;i<result.length;i++) {
		    if (matter == true || result[result.length-1-i] > 0) {
		      sb.append(result[result.length-1-i]);
		      matter = true;
		    }
		  }
		  return sb.toString();
		}	
	
	
	public static void main(String[] args) throws Exception {
		FairAndSquare fair = new FairAndSquare();
		fair.checkAllTestCases("C-small-attempt0.in");
		
	}


	@Override
	 public int compare(String o1, String o2) {  
	      if (o1.length() > o2.length()) {
	         return 1;
	      } else if (o1.length() < o2.length()) {
	         return -1;
	      }
	      return o1.compareTo(o2);
	  }

	
	
}
