package c2012;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class Dance {

	ArrayList<DanceTestCase> testCases = new ArrayList<DanceTestCase>();
	
	public void perform(String path) throws IOException{
		readInput(path);
		for (int i = 0; i < this.testCases.size(); i++) {
			DanceTestCase t = this.testCases.get(i);
			t.outPut = caluclateMaxNumber(t);
		}
		writeOutput();
	}
	
	public int caluclateMaxNumber(DanceTestCase t){
		int count = 0;
		int surpriseCount = t.surprisingCount;
		for (int i = 0; i < t.totalScore.length; i++) {
			int score = t.totalScore[i];
			if(t.p==0){
				count++;
				continue;
			}
			int div = score/t.p;
			if(div==2){
				int rem = score%t.p;
				if(Math.abs(t.p-rem)>=3){
					if(surpriseCount>0){
						count++;
						surpriseCount--;
					}
				}else{
					count++;
				}
			}else if (div>2){
				count++;
			}
		}
		return count;
	}
	
	
	
	public void readInput(String path) throws IOException{
		FileInputStream fstream = new FileInputStream(path);
		DataInputStream in = new DataInputStream(fstream);
		BufferedReader br = new BufferedReader(new InputStreamReader(in));
		int numberOfTestCases = Integer.parseInt(br.readLine());
		for (int i = 0; i < numberOfTestCases; i++) {
			testCases.add(new DanceTestCase(br.readLine().split(" ")));
		}

	}
	
	private void writeOutput() throws IOException{
		 FileWriter fstream = new FileWriter("output_files/out.txt");
		 BufferedWriter out = new BufferedWriter(fstream);
		for (int i = 0; i < this.testCases.size(); i++) {;
			String output = "Case #"+(i+1)+ ": " + this.testCases.get(i).outPut+"\n";
			out.write(output);
		}
		 out.close();
	}

	public static void main(String[] args) throws IOException {
		Dance d = new Dance();
		d.perform("input_files/B-small-attempt1.in");
	}
	
}
