package cookie_clicker;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;


public class Solution {
	
	ArrayList<CookieClickerTestCase> testCases;
	
	public Solution() {
		this.testCases = new ArrayList<CookieClickerTestCase>();
	}
	
	public void solvePorblems(String filePath) throws IOException{
		loadTestCases(filePath);
		for(CookieClickerTestCase testcase : testCases){
			solveTestCase(testcase);
		}
		writeTheOutput();
	}
	
	private void solveTestCase(CookieClickerTestCase testCase){
		double currentCookiesNumber=0;
		double spentTime=0;
		double currentRate=2;
		while(currentCookiesNumber<testCase.x){
			if(testCase.x-currentCookiesNumber > testCase.c){
				spentTime+=testCase.c/currentRate;
				currentCookiesNumber+=testCase.c;
			}else{
				spentTime+= (testCase.x-currentCookiesNumber)/currentRate;
				break;
			}
			double timeIfBought= estimatedTimeIfFarmIsBought(spentTime, currentRate, testCase.f, testCase.x);
			double timeIfNotBought = estimatedTimeIfFarmIsNotBought(currentCookiesNumber, currentRate, spentTime, testCase.x);
			
			if(timeIfBought < timeIfNotBought) {
				currentCookiesNumber-=testCase.c;
				currentRate+=testCase.f;
			}
		}
		testCase.output = "Case #" + testCase.id+": " + String.format("%.7f", spentTime);
	}
	
	private double estimatedTimeIfFarmIsBought(double spentTime, double currentRate, double f, double x){
		double newRate = currentRate + f;
		return spentTime+(x/newRate);
	}
	
	private double estimatedTimeIfFarmIsNotBought(double currentCookiesCount, double currentRate, double spentTime, double x){
		double remaining = x - currentCookiesCount;	
		return spentTime + (remaining/currentRate);
	}
	
	private void writeTheOutput() throws FileNotFoundException, UnsupportedEncodingException{
		PrintWriter writer = new PrintWriter("output.txt", "UTF-8");
		for (CookieClickerTestCase testcase : testCases) {
			writer.println(testcase.output);
		}
		writer.close();
		
	}
	
	private void loadTestCases(String filePath) throws IOException{
		BufferedReader br = new BufferedReader(new FileReader(filePath));
	    try {
	        int numberOfTestCases = Integer.parseInt(br.readLine());
	        for (int i = 1; i <= numberOfTestCases; i++) {
	        	CookieClickerTestCase testCase = new CookieClickerTestCase();
	        	String [] tokens = br.readLine().split(" ");
	        	testCase.c = Double.parseDouble(tokens[0]);
	        	testCase.f = Double.parseDouble(tokens[1]);
	        	testCase.x = Double.parseDouble(tokens[2]);
	        	testCase.id = i;
	        	testCases.add(testCase);
			}
	    } finally {
	        br.close();

	    }
	}

	public static void main(String[] args) throws IOException {
		String filePath = "B-small-attempt0.in";
		Solution solution = new Solution();
		solution.solvePorblems(filePath);
	}

}
