package magic_trick;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;

public class Solution {
	
	private ArrayList<MagicTrickTestCase> testCases;

	public Solution(){
		testCases = new ArrayList<MagicTrickTestCase>();
	}
	
	public void solveProblems(String filePath) throws IOException{
		loadTestCases(filePath);
		for (MagicTrickTestCase testCase : testCases) {
			solveTestCase(testCase);
		}
		writeTheOutput();
	}
	
	private void solveTestCase(MagicTrickTestCase testCase){
		int card=0;
		boolean cardFound=false;
		for (int i = 0; i < 4; i++) {
			int currentCard = testCase.arrange2[testCase.answer2-1][i];
			for (int j = 0; j < 4; j++) {
				if(currentCard==testCase.arrange1[testCase.answer1-1][j]){
					if(!cardFound){
						cardFound=true;
						card = currentCard;
					}else{
						testCase.output= "Case #" + testCase.id + ": Bad magician!";
						return;
					}
				}
			}
		}
		if(cardFound){
			testCase.output= "Case #" + testCase.id + ": " + card;
		}else{
			testCase.output= "Case #" + testCase.id + ": Volunteer cheated!";			
		}
		
	}
	
	private void writeTheOutput() throws FileNotFoundException, UnsupportedEncodingException{
		PrintWriter writer = new PrintWriter("output.txt", "UTF-8");
		for (MagicTrickTestCase testcase : testCases) {
			writer.println(testcase.output);
		}
		writer.close();
		
	}
	
	private void loadTestCases(String filePath) throws IOException{
		BufferedReader br = new BufferedReader(new FileReader(filePath));
	    try {
	        int numberOfTestCases = Integer.parseInt(br.readLine());
	        for (int i = 0; i < numberOfTestCases; i++) {
	        	MagicTrickTestCase testCase = new MagicTrickTestCase();
	        	//Arrange 1
	        	testCase.answer1 = Integer.parseInt(br.readLine());
	        	for (int row = 0; row < 4; row++) {
					String [] cards = br.readLine().split(" ");
	        		for (int col = 0; col < 4; col++) {
	        			testCase.arrange1[row][col]= Integer.parseInt(cards[col]);
					}
				}
	        	//Arrange 2
	        	testCase.answer2 = Integer.parseInt(br.readLine());
	        	for (int row = 0; row < 4; row++) {
					String [] cards = br.readLine().split(" ");
	        		for (int col = 0; col < 4; col++) {
	        			testCase.arrange2[row][col]= Integer.parseInt(cards[col]);
					}
				}
	        	testCase.id = i+1;
	        	testCases.add(testCase);
			}
	    } finally {
	        br.close();

	    }
	}
	
	public static void main(String[] args) throws IOException {
		String input = "A-small-attempt0.in";
		Solution solution = new Solution();
		solution.solveProblems(input);
	}
	
}
