package codejam09;

import java.io.File;
import java.io.PrintWriter;
import java.util.*;
import java.util.Scanner;

public class Welcome {

	public void go() {
		String className = getClass().getSimpleName();
		
		try {
			//go(new Scanner(new File("in/" + className + "_test.in")), new PrintWriter("out/" + className + "_test.out"));
			
			go(new Scanner(new File("in/" + className + "_small.in")), new PrintWriter("out/" + className + "_small.out"));

			//go(new Scanner(new File("in/" + className + "_large.in")), new PrintWriter("out/" + className + "_large.out"));
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	protected static final char[] p = "welcome to code jam".toCharArray();
	
	public void go(Scanner scanner, PrintWriter out) {
		int N = Integer.parseInt(scanner.nextLine());
		for(int k = 1; k <= N; k++) {
			char[] s = scanner.nextLine().toCharArray();
			long[][] memo = new long[p.length][s.length];
			for(long[] r : memo) Arrays.fill(r, -1);
			long count = dfs(s, 0, 0, memo);
			String res = Long.toString(count % 10000);
			while(res.length() < 4) res = "0" + res;
			out.println("Case #" + k + ": " + res);
		}
		out.close();
	}
	
	protected long dfs(char[] s, int pi, int si, long[][] memo) {
		if(pi == p.length) return 1;
		if(si == s.length) return 0;
		if(memo[pi][si] > -1) return memo[pi][si];
		long count = 0;
		for(int sii = si; sii < s.length; sii++)
			if(s[sii] == p[pi]) {
				count += dfs(s, pi+1, sii+1, memo);
			}
		memo[pi][si] = count;
		return count;
	}
	
	public static void main(String[] args) {
		new Welcome().go();
	}
}
