package cj2012.two;

import java.io.File;
import java.io.PrintWriter;
import java.util.PriorityQueue;
import java.util.Scanner;

public class A {
	public static class Vine implements Comparable<Vine> {
		public int id, d, h;
		public double r;
		public Vine(int id, int d, int h, double r) {
			this.id = id;
			this.d = d;
			this.h = h;
			this.r = r;
		}
		public int compareTo(Vine v) {
			return Double.compare(v.r, r);
		}
		public double hold(Vine v) {
			int dd = Math.abs(v.d - d);
			if (dd == 0) return r;
			double hij = Math.hypot(v.h, dd);
			if (Double.compare(dd, r) > 0) return -1;
			if (Double.compare(hij, r) < 0) return v.h;
			double theta = Math.acos(dd / r);
			return Math.sin(theta) * r;
		}
	}
	
	public static void main(String[] args) throws Exception {
		String fileName = "A-large";
		Scanner scan = new Scanner(new File("in/" + fileName + ".in"));
		int T = scan.nextInt(); scan.nextLine();
		PrintWriter out = new PrintWriter(new File("out/" + fileName + ".txt"));
		for (int z = 1; z <= T; z++) {
			int N = scan.nextInt() + 1;
			Vine[] v = new Vine[N];
			for (int i = 0; i < N-1; i++)
				v[i] = new Vine(i, scan.nextInt(), scan.nextInt(), -1);
			v[N-1] = new Vine(N-1, scan.nextInt(), 0, -1);
			v[0].r = v[0].d;
			for (int x = 0; x < N; x++) {
				if (v[x].r < 0) continue;
				for (int i = x+1; i < N; i++) {
					if (Double.compare(v[x].r, Math.abs(v[x].d - v[i].d)) < 0) break;
					double xi = v[x].hold(v[i]);
					if (Double.compare(xi, v[i].r) > 0)
						v[i].r = Math.max(xi, Math.min(v[i].h, Math.abs(v[x].d - v[i].d)));
				}
			}
			System.out.println("Case #" + z + ": " + (Double.compare(v[N-1].r, 0) >= 0? "YES" : "NO"));
			out.println("Case #" + z + ": " + (Double.compare(v[N-1].r, 0) >= 0? "YES" : "NO"));
		}
		out.close();
	}
}
