package codejam09;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

public class AlienLanguage {

	public void go() {
		String className = getClass().getSimpleName();
		
		try {
			go(new Scanner(new File("in/" + className + "_small.in")), new PrintWriter("out/" + className + "_small.out"));

			go(new Scanner(new File("in/" + className + "_large.in")), new PrintWriter("out/" + className + "_large.out"));
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	
	public void go(Scanner scanner, PrintWriter out) {
		while(scanner.hasNext()) {
			int L = scanner.nextInt();
			int D = scanner.nextInt();
			int N = scanner.nextInt();
			
			ArrayList<String> dictionary = new ArrayList<String>();
			for(int i = 0; i < D; i++) dictionary.add(scanner.next());
			
			for(int k = 1; k <= N; k++) {
				ArrayList<String> matches = new ArrayList<String>(dictionary);
				
				String p = scanner.next();
				String[] parts = new String[L];
				Arrays.fill(parts, "");
				int pi = 0; boolean para = false;
				for(char c : p.toCharArray()) {
					if(c == '(') {
						para = true;
					} else if(c == ')') {
						para = false;
						pi++;
					} else {
						if(para) parts[pi] += c;
						else parts[pi++] += c;
					}
				}
				
				for(int j = 0; j < L; j++) {
					if(parts[j].length() > 0) continue;
					char c = parts[j].charAt(0);
					ArrayList<String> filteredMatches = new ArrayList<String>();
					for(String word : matches)
						if(word.charAt(j) == c)
							filteredMatches.add(word);
					matches = filteredMatches;
				}
				
				for(int j = 0; j < L; j++) {
					if(parts[j].length() == 0) continue;
					HashSet<Character> set = new HashSet<Character>();
					for(char c : parts[j].toCharArray()) set.add(c);
					ArrayList<String> filteredMatches = new ArrayList<String>();
					for(String word : matches)
						if(set.contains(word.charAt(j)))
							filteredMatches.add(word);
					matches = filteredMatches;
				}
				
				out.println("Case #" + k + ": " + matches.size());
			}
		}
		out.close();
	}
	
	public static void main(String[] args) {
		new AlienLanguage().go();
	}
}
