package codejam09;

import java.io.File;
import java.io.PrintWriter;
import java.util.*;

public class Watersheds {

	public void go() {
		String className = getClass().getSimpleName();
		
		try {
			//go(new Scanner(new File("in/" + className + "_test.in")), new PrintWriter("out/" + className + "_test.out"));
			
			go(new Scanner(new File("in/" + className + "_small.in")), new PrintWriter("out/" + className + "_small.out"));

			//go(new Scanner(new File("in/" + className + "_large.in")), new PrintWriter("out/" + className + "_large.out"));
		} catch(Exception e) {
			e.printStackTrace();
		}
	}

	protected static final int[] dx = new int[]{-1,  0,  0,  1};
	protected static final int[] dy = new int[]{ 0, -1,  1,  0};
	
	public void go(Scanner scanner, PrintWriter out) {
		int N = scanner.nextInt();
		for(int k = 1; k <= N; k++) {
			int H = scanner.nextInt();
			int W = scanner.nextInt();
			
			int[][] hmap = new int[H+2][W+2];
			for(int i = 0; i < H+2; i++)
				hmap[i][0] = hmap[i][W+1] = Integer.MAX_VALUE;
			for(int j = 0; j < W+2; j++)
				hmap[0][j] = hmap[H+1][j] = Integer.MAX_VALUE;
			for(int i = 0; i < H; i++)
				for(int j = 0; j < W; j++)
					hmap[i+1][j+1] = scanner.nextInt();
			
			int[][] to = new int[H][W];
			for(int[] r : to) Arrays.fill(r, -1);

			for(int i = 1; i <= H; i++)
				for(int j = 1; j <= W; j++) {
					int mina = hmap[i][j];
					for(int d = 0; d < 4; d++) {
						if(hmap[i+dx[d]][j+dy[d]] < mina) {
							mina = hmap[i+dx[d]][j+dy[d]];
							to[i-1][j-1] = d; 
						}
					}
				}
					
			int[][][] sink = new int[H][W][2];
			for(int i = 0; i < H; i++)
				for(int j = 0; j < W; j++) {
					int x = i, y = j;
					while(to[x][y] != -1) {
						int x2 = x + dx[to[x][y]];
						int y2 = y + dy[to[x][y]];
						x = x2; y = y2;
					}
					sink[i][j][0] = x;
					sink[i][j][1] = y;
				}

			char[][] wmap = new char[H][W];
			for(char[] r : wmap) Arrays.fill(r, '.');

			char label = 'a';
			for(int i = 0; i < H; i++)
				for(int j = 0; j < W; j++) {
					int x = sink[i][j][0];
					int y = sink[i][j][1];
					if(wmap[x][y] == '.')
						wmap[x][y] = label++;
					wmap[i][j] = wmap[x][y];
				}
			
			out.println("Case #" + k + ":");
			for(int i = 0; i < H; i++) {
				for(int j = 0; j < W; j++)
					out.print(wmap[i][j] + " ");
				out.println();
			}
		}
		out.close();
	}
	
	public static void main(String[] args) {
		new Watersheds().go();
	}
}
