import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class TrieSharding {
	static class Node {
		Node[] children = new Node[26];
	}

	static String problem = "DSmall";
	static String[] arr;
	static int m, n;
	static int[] server;
	static int worst, ways;

	static int go(ArrayList<String> list) {
		Node root = new Node();
		int res = 1;
		for (String str : list) {
			Node temp = root;
			for (char c : str.toCharArray()) {
				if (temp.children[c - 'A'] == null) {
					temp.children[c - 'A'] = new Node();
					res++;
				}
				temp = temp.children[c - 'A'];
			}
		}
		return res;
	}

	static void go(int index) {
		if (index == m) {
			ArrayList<String>[] list = new ArrayList[n];
			for (int i = 0; i < list.length; i++) {
				list[i] = new ArrayList<String>();
			}
			for (int i = 0; i < m; i++) {
				list[server[i]].add(arr[i]);
			}
			for (int i = 0; i < list.length; i++) {
				if (list[i].size() == 0)
					return;
			}
			int total = 0;
			for (ArrayList<String> a : list) {
				total += go(a);
			}
			if (total == worst)
				ways++;
			else if (total > worst) {
				worst = total;
				ways = 1;
			}
			return;
		}
		for (int k = 0; k < n; k++) {
			server[index] = k;
			go(index + 1);
		}
	}

	public static void main(String[] args) throws Exception {
//		InputReader r = new InputReader(System.in);
//		PrintWriter out = new PrintWriter(System.out);
		 InputReader r = new InputReader(new FileReader(problem +
		 ".in"));
		 PrintWriter out = new PrintWriter(new FileWriter(problem +
		 "Solution.out"));
		int T = r.nextInt();
		int test = 1;
		while (T-- > 0) {
			m = r.nextInt();
			n = r.nextInt();
			arr = new String[m];
			for (int i = 0; i < arr.length; i++) {
				arr[i] = r.next();
			}
			server = new int[m];
			worst = -1;
			ways = 0;
			go(0);
			out.printf("Case #%d: %d %d\n", test++, worst, ways);
		}
		out.close();
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader(InputStream stream) {
			reader = new BufferedReader(new InputStreamReader(stream));
			tokenizer = null;
		}

		public InputReader(FileReader stream) {
			reader = new BufferedReader(stream);
			tokenizer = null;
		}

		public String nextLine() {
			try {
				return reader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return null;
			}
		}

		public String next() {
			while (tokenizer == null || !tokenizer.hasMoreTokens()) {
				try {
					tokenizer = new StringTokenizer(reader.readLine());
				} catch (IOException e) {
					throw new RuntimeException(e);
				}
			}
			return tokenizer.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}
	}
}
