import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;


public class CountingSheep {
	
	boolean [] found = new boolean[10];
	public void markDigitsInNumber(int num){
		if(num == 0){
			found[0] = true;
		}
		while(num != 0){
			int digit = num % 10;
			found[digit] = true;
			num /= 10;
		}
	}
	
	public int count(int n){
		if(n == 0){
			return -1;
		}
		boolean done = false;
		int num = n;
		while(!done){
			done = true;
			markDigitsInNumber(n);
			for(boolean bool : found){
				done &= bool;
			}
			if(done){
				return n;
			}
			n += num;
		}
		return -1;
	}
	void markDigitsInNumber(BigInteger num){
		if(num.intValue() == 0){
			found[0] = true;
		}
		
		while(num.intValue() != 0){
			BigInteger digit = num.mod(BigInteger.TEN);
			found[digit.intValue()] = true;
			num = num.divide(BigInteger.TEN);
		}
	}
	public BigInteger countWithBigInteger(int n){
		BigInteger val = new BigInteger(String.valueOf(n));
		if(n == 0){
			return null;
		}
		boolean done = false;
		BigInteger num = new BigInteger(val.toString());
		while(!done){
			done = true;
			markDigitsInNumber(val);
			for(boolean bool : found){
				done &= bool;
			}
			if(done){
				return val;
			}
			val = val.add(num);
		}
		return null;
	}

	public static void main(String[] args) {
		try {	
			Scanner scanner = null;
			BufferedWriter bw = new BufferedWriter(new PrintWriter(new File("counting-sheep.txt")));
			
			scanner = new Scanner(new File("A-large.in"));
			int T = scanner.nextInt();
			for(int i = 0; i < T; i++){
				CountingSheep countingSheep = new CountingSheep();
				int n = scanner.nextInt();
				int result = countingSheep.count(n);
				bw.write("Case #" + (i+1) + ": ");
				if(result == -1){
					bw.write("INSOMNIA\n");
				}
				else{
					bw.write(result + "\n");
				}
			}
			scanner.close();
			bw.close();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

}
