import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;


public class Watersheds 
{
	PrintWriter pr;
	BufferedReader bf;
	cell[][] land;
	char currentChar;
	int caseNum;
	
	
	public Watersheds(PrintWriter thePr,BufferedReader theBf,int theCaseNum) throws IOException
	{
		super();
		this.currentChar = 'a';
		this.pr = thePr;
		this.bf = theBf;
		this.caseNum = theCaseNum;
		this.load();
	}
	
	public void load() throws IOException
	{
		String []data =bf.readLine().split(" ");
		int h = Integer.parseInt(data[0]);
		int w = Integer.parseInt(data[1]);
		this.land = new cell[h+2][w+2];
		
		for(int i = 1 ; i <= h ; i++)
		{
			data = bf.readLine().split(" ");
			for(int j = 1 ; j <= w ; j++)
			{
				this.land[i][j] = new cell(Integer.parseInt(data[j-1]));
			}
		}
	}
	
	public void getAnswer()
	{
		for(int i = 1 ; i < this.land.length-1; i++)
		{
			for(int j = 1 ; j < this.land[0].length-1;j++)
			{
				if(!this.land[i][j].visited)
				{
					this.getWay(i, j);
				}
			}
		}
	}

	
	public char getWay(int row , int column)
	{
		this.land[row][column].visited = true;
		int i = -1;
		int j = -1;
		int min = this.land[row][column].attitude;
		boolean isSink = true;
		//NORTH
		if(this.land[row-1][column] != null&& this.land[row-1][column].attitude < min)
		{
			min = this.land[row-1][column].attitude;
			i = row -1;
			j = column;
			isSink = false;
		}
		//WEST
		if(this.land[row][column-1] != null&& this.land[row][column-1].attitude < min)
		{
			min = this.land[row][column-1].attitude;
			i = row;
			j = column -1;
			isSink = false;
		}
		//EAST
		if(this.land[row][column+1]!= null && this.land[row][column+1].attitude < min)
		{
			min = this.land[row][column+1].attitude;
			i = row;
			j = column +1;
			isSink = false;
		}
		//SOUTH
		if(this.land[row+1][column] != null && this.land[row+1][column].attitude < min)
		{
			min = this.land[row+1][column].attitude;
			i = row +1;
			j = column;
			isSink = false;
		}
		if(!isSink)
		{
			if(! this.land[i][j].visited)
			{
				this.land[i][j].state = this.getWay(i, j);
			}
			this.land[row][column].state = this.land[i][j].state; 
		}
		
		else
		{
			this.land[row][column].state = this.currentChar++;
		}
		
		return this.land[row][column].state;
		
	}
	
	public void print()
	{
		pr.println("Case #" + this.caseNum + ":");
		for(int i = 1 ; i < this.land.length-1 ; i++)
		{
			String temp ="";
			for(int j = 1 ; j < this.land[0].length-1; j++)
			{
				temp += this.land[i][j].state+" ";
			}
			pr.println(temp.trim());
		}
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) throws IOException 
	{
		BufferedReader bf = new BufferedReader(new FileReader("B-small-attempt0.in"));
		PrintWriter pr = new PrintWriter(new BufferedWriter(new FileWriter("Watersheds.out")));
		int numOfCases = Integer.parseInt(bf.readLine());
		for(int i = 0 ; i < numOfCases ;i++)
		{
			Watersheds wa = new Watersheds(pr,bf,i+1);
			wa.getAnswer();
			wa.print();
		}
		
		
		
		
		bf.close();
		pr.close();
	}

}

class cell
{
	int attitude;
	char state;
	boolean visited;
	public cell(int attitude) 
	{
		super();
		this.attitude = attitude;
		this.state = ' ';
		this.visited = false;
	}
	
	
}