import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;


public class TiddyNumber {
	public boolean isTiddy(BigInteger num){
		long lastDigit = 11;
		while(num.compareTo(BigInteger.ZERO) > 0){
			long curdigit = Integer.parseInt(num.mod(BigInteger.TEN).toString());
			if(curdigit > lastDigit){
				return false;
			}
			lastDigit = curdigit;
			num = num.divide(BigInteger.TEN);
		}
		return true;
	}
	public void getLastTiddyNumber(BigInteger num, int caseNumber){
		BigInteger sol = new BigInteger("-1");
		while(num.compareTo(BigInteger.ZERO) > 0){
			if(isTiddy(num)){
				sol = num;
				break;
			}
			num = num.subtract(BigInteger.ONE);
		}
		System.out.println("Case #" + caseNumber + ": " + sol);
	}
	
	public static void main(String[] args) {		
		TiddyNumber tiddyNumber = new TiddyNumber();
		String inputFile = "B-small-attempt0.in";
		try{
			Scanner scanner = new Scanner(new BufferedReader(new FileReader(inputFile)));
			int n = Integer.parseInt(scanner.nextLine().trim());
			for(int i = 1; i <= n; i++){
				tiddyNumber.getLastTiddyNumber(new BigInteger(scanner.nextLine().trim()), i);
			}
			scanner.close();
		}
		catch(IOException ex){
			ex.printStackTrace();
		}
	}

}
