import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;


public class PancakeFlipperLarge {
	public void getMinFlipsWrapper(String str, int k, int caseNumber){
		int[] arr = new int [str.length()];
		for(int i = 0; i < str.length(); i++){
			if(str.charAt(i) == '+')
				arr[i] = 1;
			else
				arr[i] = -1;
		}
		int result = getMinFlips(arr, k);
		System.out.print("Case #" + caseNumber +": ");
		if(result == -1){
			System.out.println("IMPOSSIBLE");
		}
		else{
			System.out.println(result);
		}
	}
	
	public int getMinFlips(int [] arr, int k){
		int count = 0;
		int i = 0;
		while(i <= arr.length - k){
			if(arr[i] == 1){
				i++;
				continue;
			}
			//Flip the k bits
			int nextIndex = i;
			for(int j = i; j < i+k; j++){
				arr[j] *= -1;
				if(arr[j] == -1 && nextIndex == i){
					nextIndex = j;
				}
			}
			i = nextIndex;
			count += 1;
		}
		for(int num : arr){
			if (num == -1)
				return -1;
		}
		return count;
	}
	
	public static void main(String[] args) {
		PancakeFlipperLarge pancakeFlipper = new PancakeFlipperLarge();
		String inputFile = "A-large.in";
		try{
			Scanner scanner = new Scanner(new BufferedReader(new FileReader(inputFile)));
			int n = Integer.parseInt(scanner.nextLine().trim());
			for(int i = 1; i <= n; i++){
				String [] line = scanner.nextLine().trim().split(" ");
				pancakeFlipper.getMinFlipsWrapper(line[0], Integer.parseInt(line[1]), i);
			}
			scanner.close();
		}
		catch(IOException ex){
			ex.printStackTrace();
		}
	}
}
