import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;


public class BathroomStalls {
	public void computeLR(int n, int k, int caseNumber){
		boolean[] arr = new boolean [n+2];
		arr[0] = true;
		arr[n+1] = true;
		for(int i = 0; i < k; i++){
			//For every user
			int [] left = new int [n+2];
			int [] right = new int [n+2];
			for(int j = 1; j < n+1; j++){
				if(arr[j]){
					continue;
				}
				//For every stall, find the best left
				for(int l = j-1; l >= 0; l--){
					if(arr[l]){
						left[j] = j-l-1;
						break;
					}
				}
				for(int l = j+1; l < n+2; l++){
					if(arr[l]){
						right[j] = l-j-1;
						break;
					}
				}
			}
			int pos = 0;
			int optMin = Integer.MIN_VALUE;
			int optMax = Integer.MIN_VALUE;
			//For every position
			for(int j = 1; j < n+1; j++){
				int valMin = Math.min(left[j], right[j]);
				int valMax = Math.max(left[j], right[j]);
				if(valMin > optMin){
					optMin = valMin;
					optMax = valMax;
					pos = j;
				}
				else if(valMin == optMin && valMax > optMax){
					optMin = valMin;
					optMax = valMax;
					pos = j;
				}
			}
			arr[pos] = true;
			if(i == k-1)
				System.out.println("Case #" + caseNumber + ": " + optMax + " " + optMin);
		}
	}
	public static void main(String[] args) {		
		BathroomStalls bathroomStalls = new BathroomStalls();
		String inputFile = "C-small-1-attempt0.in";
//		String inputFile = "C-large.in";
//		String inputFile = "input_1_small.txt";
		try{
			Scanner scanner = new Scanner(new BufferedReader(new FileReader(inputFile)));
			int n = Integer.parseInt(scanner.nextLine().trim());
			for(int i = 1; i <= n; i++){
				bathroomStalls.computeLR(scanner.nextInt(), scanner.nextInt(), i);
			}
			scanner.close();
		}
		catch(IOException ex){
			ex.printStackTrace();
		}
	}

}
