import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;


public class TiddyNumber {
	public boolean isTiddy(BigInteger num){
		long lastDigit = 11;
		while(num.compareTo(BigInteger.ZERO) > 0){
			long curdigit = Integer.parseInt(num.mod(BigInteger.TEN).toString());
			if(curdigit > lastDigit){
				return false;
			}
			lastDigit = curdigit;
			num = num.divide(BigInteger.TEN);
		}
		return true;
	}
	public void getLastTiddyNumber(BigInteger num, int caseNumber){
		BigInteger sol = new BigInteger("-1");
		while(num.compareTo(BigInteger.ZERO) > 0){
			if(isTiddy(num)){
				sol = num;
				break;
			}
			num = num.subtract(BigInteger.ONE);
		}
		System.out.println("Case #" + caseNumber + ": " + sol);
	}
	public String arrToString(int [] arr){
		StringBuilder sb = new StringBuilder();
		boolean firstdigit = true;
		for(int i = 0; i < arr.length; i++){
			if(arr[i] == 0 && firstdigit){
				continue;
			}
			firstdigit = false;
			sb.append(arr[i]);
		}
		return sb.toString();
	}
	public void getLastTiddyNumberLarge(BigInteger num, int caseNumber){
		char [] charArr = num.toString().toCharArray();
		int [] arr = new int [charArr.length];
		for(int i = 0; i < charArr.length; i ++){
			arr[i] = (int)charArr[i] - (int)'0';
		}
		int index = arr.length -1;
		boolean needFixing = false;
		while(index > 0){
			if(arr[index] < arr[index-1] || (arr[index] <= arr[index-1] && needFixing)){
				needFixing = true;
				for(int i = index; i < arr.length; i++){
					arr[i] = 9;
				}
				for(int i = index-1; i>= 0; i--){
					if(i == 0 || arr[i] > arr[i-1]){
						arr[i] = arr[i] -1;
						index = i-1;
						needFixing = false;
						break;
					}
					else{
						arr[i] = 9;
					}
				}
			}
			else{
				index --;
			}
		}
		System.out.println("Case #" + caseNumber + ": " + arrToString(arr));
	}
	
	public static void main(String[] args) {		
		TiddyNumber tiddyNumber = new TiddyNumber();
//		String inputFile = "B-small-attempt0.in";
		String inputFile = "B-large.in";		
		try{
			Scanner scanner = new Scanner(new BufferedReader(new FileReader(inputFile)));
			int n = Integer.parseInt(scanner.nextLine().trim());
			for(int i = 1; i <= n; i++){
				tiddyNumber.getLastTiddyNumberLarge(new BigInteger(scanner.nextLine().trim()), i);
			}
			scanner.close();
		}
		catch(IOException ex){
			ex.printStackTrace();
		}
	}

}
