import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;


public class D {
	static int N;
	static char[] a;
	static int[] L, index;
	static double[] DP;
	public static void main(String[] args) throws FileNotFoundException {
		InputReader r = new InputReader("D.in");
		PrintWriter out = new PrintWriter("D.out");
		
		index = new int[1 << 20];
		for(int i = 0; i < 20; i++)
			index[1 << i] = i;
		
		L = new int[1 << 20];
		for(int m = 1; m < 1 << 20; m++)
			L[m] = index[Integer.lowestOneBit(m)];
		
		DP = new double[1 << 20];
		
		int T = r.nextInt();
		int caseNumber = 1;
		
		while(T-- > 0){
			a = r.next().toCharArray();
			N = a.length;
			
			int m = 0;
			for(int i = 0; i < N; i++)if(a[i] == '.')
				m |= 1 << i;
			
			Arrays.fill(DP, -1); 
			double ret = go(m);
			
			out.printf("Case #%d: %.15f\n", caseNumber++, ret);
		}
		out.close();
	}
	
	private static double go(int m) {
		if(m == 0)
			return 0;
		
		if(DP[m] != -1)return DP[m];
		
		double ret = 0;
		for(int p = 0; p < N; p++){
			int rm = rotate(m, p);
			int x = L[rm];
			
			ret += (N - x + go(rm & (~(1 << x))));
		}
		
		return DP[m] = ret / N;
	}

	private static int rotate(int m, int p) {
		p %= N;
		return (m >> p) | ((m & ((1 << p) - 1)) << (N - p));
	}

	static class InputReader {
	    private BufferedReader reader;
	    private StringTokenizer tokenizer;

	    public InputReader(String fileName) throws FileNotFoundException {
	        reader = new BufferedReader(new FileReader(fileName));
	        tokenizer = null;
	    }

	    public String nextLine(){
	    	try {
				return reader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return null;
			}
	    }
	    public String next() {
	        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
	            try {
	                tokenizer = new StringTokenizer(reader.readLine());
	            } catch (IOException e) {
	                throw new RuntimeException(e);
	            }
	        }
	        return tokenizer.nextToken();
	    }

	    public int nextInt() {
	        return Integer.parseInt(next());
	    }
	    public long nextLong() {
	        return Long.parseLong(next());
	    }
	}
}
