import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.PriorityQueue;
import java.util.StringTokenizer;
import java.util.TreeMap;


public class A {
	static long mod = 1000002013; 
	public static void main(String[] args) throws FileNotFoundException {
		InputReader r = new InputReader("A.in");
		PrintWriter out = new PrintWriter("A.out");
		
		int T = r.nextInt();
		int caseNumber = 1;
		
		while(T-- > 0){
			int N = r.nextInt();
			int M = r.nextInt();
			
			TreeMap<Long, Long> mp = new TreeMap<Long, Long>();
			
			long f = 0, s = 0;
			
			for(int x = 0; x < M; x++){
				long o = r.nextInt();
				long e = r.nextInt();
				long p = r.nextInt();
				
				f = (f + (calc(e - o, N) * (p % mod)) % mod) % mod;
				
				if(mp.containsKey(o))mp.put(o, mp.get(o) + p);
				else mp.put(o, p);
				
				if(mp.containsKey(e))mp.put(e, mp.get(e) - p);
				else mp.put(e, -p);
			}
			
			PriorityQueue<State> pq = new PriorityQueue<State>();
			for(long x : mp.keySet()){
				if(mp.get(x) > 0){
					pq.add(new State(x, mp.get(x)));
				}else if(mp.get(x) == 0){
					continue;
				}else if(mp.get(x) < 0){
					long rem = -mp.get(x);
					
					while(true){
						State st = pq.poll();
						
						if(st.p > rem){
							s = (s + (calc(x - st.x, N) * (rem % mod)) % mod) % mod;
							pq.add(new State(st.x, st.p - rem));
							break;
						}else if(st.p == rem){
							s = (s + (calc(x - st.x, N) * (rem % mod)) % mod) % mod;
							break;
						}else if(st.p < rem){
							s = (s + (calc(x - st.x, N) * (st.p % mod)) % mod) % mod;
							rem -= st.p;
						}
					}
				}
			}
			
			out.printf("Case #%d: %d\n", caseNumber++, (f - s + mod) % mod);
		}
		out.close();
	}
	
	private static long calc(long x, long n) {
		return ((n * (n + 1) / 2) % mod - ((n - x) * (n - x + 1) / 2) % mod) % mod;
	}
	
	static class State implements Comparable<State>{
		long x, p;
		public  State(long xi, long pi){
			x = xi;
			p = pi;
		}
		
		@Override
		public int compareTo(State b) {
			return Long.compare(b.x, x);
		}
	}

	static class InputReader {
	    private BufferedReader reader;
	    private StringTokenizer tokenizer;

	    public InputReader(String fileName) throws FileNotFoundException {
	        reader = new BufferedReader(new FileReader(fileName));
	        tokenizer = null;
	    }

	    public String nextLine(){
	    	try {
				return reader.readLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
				return null;
			}
	    }
	    public String next() {
	        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
	            try {
	                tokenizer = new StringTokenizer(reader.readLine());
	            } catch (IOException e) {
	                throw new RuntimeException(e);
	            }
	        }
	        return tokenizer.nextToken();
	    }

	    public int nextInt() {
	        return Integer.parseInt(next());
	    }
	    public long nextLong() {
	        return Long.parseLong(next());
	    }
	}
}
