import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.PriorityQueue;


public class Main {
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader r = new BufferedReader(new InputStreamReader(System.in));
		
		int T = Integer.parseInt(r.readLine());
		int caseNumber = 1;
		
		while(T-- > 0){
			int N = Integer.parseInt(r.readLine());
			
			int[][] a = new int[N][2];
			
			for(int i = 0; i < N; i++){
				String[] line = r.readLine().split("[ ]+");
				for(int j = 0; j < 2; j++)
					a[i][j] = Integer.parseInt(line[j]);
			}
			
			PriorityQueue<State> pq = new PriorityQueue<State>();
			boolean[][] v = new boolean[1 << N][1 << N];
			
			pq.add(new State(0, 0, 0, 0));
			
			int ret = -1;
			
			while(!pq.isEmpty()){
				State st = pq.poll();
				
				if(st.mII == (1 << N) - 1){
					ret = st.d;
					break;
				}
				
				if(v[st.mI][st.mII])continue;
				v[st.mI][st.mII] = true;
				
				for(int i = 0; i < N; i++){
					if((st.mI & (1 << i)) == 0 && st.s >= a[i][0]){
						int nmI = st.mI | 1 << i;
						if(!v[nmI][st.mII]){
							pq.add(new State(nmI, st.mII, st.d + 1, st.s + 1));
						}
					}
					
					if((st.mII & (1 << i)) == 0 && st.s >= a[i][1]){
						if((st.mI & (1 << i)) == 0){
							int nmI = st.mI | 1 << i;
							int nmII = st.mII | 1 << i;
							if(!v[nmI][nmII]){
								pq.add(new State(nmI, nmII, st.d + 1, st.s + 2));
							}
						}else{//one taken.
							int nmII = st.mII | 1 << i;
							if(!v[st.mI][nmII]){
								pq.add(new State(st.mI, nmII, st.d + 1, st.s + 1));
							}
						}
					}
				}
			}
			
			if(ret == -1)System.out.printf("Case #%d: Too Bad\n", caseNumber++);
			else System.out.printf("Case #%d: %d\n", caseNumber++, ret);
		}
	}
}
class State implements Comparable<State>{
	int d, s;
	int mI, mII;
	public State(int mIi, int mIIi, int di, int si){
		mI = mIi;
		mII = mIIi;
		d = di;
		s = si;
	}
	@Override
	public int compareTo(State b) {
		if(d < b.d)return -1;
		else return 1;
	}
}