import java.util.Arrays;
import java.util.Scanner;


public class Main {
	public static void main(String[] args) {
		Scanner r = new Scanner(System.in);
		
		int T = r.nextInt();
		for(int t = 1; t <= T; t++){
			int n = r.nextInt();
			
			char[][] g = new char[n][n];
			
			for(int k = 0; k < n; k++)
				g[k] =  r.next().toCharArray();
			
			double[] wp = new double[n];
			double[] owp = new double[n];
			double[] oowp = new double[n];
			double[] rpi = new double[n];
			
			
			boolean[] temp = new boolean[n];
			Arrays.fill(temp, true);
			
			calcWP(g, wp, temp, n);
			calcOWP(g, owp, n);
			calcOOWP(g, oowp, owp, n);
//			
//			System.out.println(Arrays.toString(wp));
//			System.out.println(Arrays.toString(owp));
//			System.out.println(Arrays.toString(oowp));
//			
			for(int i = 0; i < n; i++)
				rpi[i] =  0.25 * wp[i] + 0.50 * owp[i] + 0.25 * oowp[i];
			
			System.out.printf("Case #%d:\n", t);
			for(int i = 0; i < n; i++)
				System.out.println(rpi[i]);
			
		}
	}

	private static void calcOOWP(char[][] g, double[] oowp, double[] owp, int n) {
		for(int i = 0; i < n; i++){
			int nop = 0;
			
			for(int j = 0; j < n; j++)
				if(g[i][j] == '0' || g[i][j] == '1'){
					nop++;
					oowp[i] += owp[j];
				}
			
			oowp[i] /= nop;	
		}
	}

	private static void calcOWP(char[][] g, double[] owp, int n) {
		boolean[] v = new boolean[n];
		Arrays.fill(v, true);
		
		for(int i =0 ; i< n; i++){
			int nop = 0;
			v[i] = false;
			
			double[] wp = new double[n];
			calcWP(g, wp, v, n);
			
//			System.out.println(i+", "+Arrays.toString(wp));
			for(int j = 0; j < n; j++)
				if(g[i][j] == '0' || g[i][j] == '1'){
					nop++;
					owp[i] += wp[j];
				}
			
			owp[i] /= (double)nop;
			
			v[i] = true;
		}
	}

	private static void calcWP(char[][] g, double[] wp, boolean[] v, int n) {
		for(int i = 0; i < n; i ++){
			int w=0, l=0;
			for(int j =0; j < n; j++)if(v[j])
				if(g[i][j] =='0')l++;
				else if(g[i][j] == '1')w++;
			
			wp[i] = (double)w/(double)(w+l);
		}
	}
}
