import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.StringTokenizer;

public class Codejam2013_FairSquare {
	static String[] numbers = { "1", "4", "9", "121", "484", "10201", "12321",
			"14641", "40804", "44944", "1002001", "1234321", "4008004",
			"100020001", "102030201", "104060401", "121242121", "123454321",
			"125686521", "400080004", "404090404", "10000200001",
			"10221412201", "12102420121", "12345654321", "40000800004",
			"1000002000001", "1002003002001", "1004006004001", "1020304030201",
			"1022325232201", "1024348434201", "1210024200121", "1212225222121",
			"1214428244121", "1232346432321", "1234567654321", "4000008000004",
			"4004009004004", "100000020000001", "100220141022001",
			"102012040210201", "102234363432201", "121000242000121",
			"121242363242121", "123212464212321", "123456787654321",
			"400000080000004" };

	public static void main(String[] args) throws Exception {
		// Scanner scan = new Scanner(System.in);
		BufferedReader input = new BufferedReader(new FileReader("input.in"));
		BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));
		int cases = Integer.parseInt(input.readLine());
		int counter = 1;
		while (cases-- > 0) {
			String line = input.readLine();
			StringTokenizer tok = new StringTokenizer(line);
			long low = Long.parseLong(tok.nextToken());
			long hi = Long.parseLong(tok.nextToken());
			int res = 0;
			for (int i = 0; i < numbers.length; i++) {
				long num = Long.parseLong(numbers[i]);
				if (num >= low && num <= hi)
					res++;
			}
			output.write("Case #" + counter++ + ": ");
			output.write(res + "\n");
		}
		output.close();
	}

	public static boolean check(int[] array) {
		long n = 0;
		for (int i = array.length - 1; i >= 0; i--) {
			n += (long) array[i] * Math.pow(10, array.length - i - 1);
		}
		double sqrt = Math.sqrt(n);
		if (Math.round(sqrt) == sqrt) {
			if (palin(array) && palin2((int) sqrt)) {
				System.out.println("\"" + n + "\"");
				return true;
			}
		}
		return false;
	}

	public static int method(int[] array, int index) {
		if (index > (array.length / 2) && array.length % 2 != 0) {
			if (check(array))
				return 1;
			return 0;

		} else if (index >= (array.length / 2) && array.length % 2 == 0) {
			if (check(array))
				return 1;
			return 0;
		} else {
			int start = 0;
			if (index == 0)
				start = 1;
			int[] temp = array.clone();
			int res = 0;
			for (int i = start; i <= 9; i++) {
				temp[index] = i;
				temp[array.length - index - 1] = i;
				res += method(temp, index + 1);
			}
			return res;
		}
	}

	public static boolean palin(int[] array) {
		boolean palin = true;
		for (int j = 0; j < array.length; j++) {
			if (array[j] != array[array.length - j - 1]) {
				palin = false;
				break;
			}
		}
		return palin;
	}

	public static boolean palin2(int n) {
		String s = n + "";
		boolean palin = true;
		for (int j = 0; j < s.length(); j++) {
			if (s.charAt(j) != s.charAt(s.length() - j - 1)) {
				palin = false;
				break;
			}
		}
		return palin;
	}
}