import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class Main
{

	/* IO */
	InputReader in;
	StringTokenizer tok;
	StringBuilder ans;

	/* FIELDS */
	private int k;
	private int c;
	private int s;

	public static void main(String[] args) throws IOException
	{
		Main sol = new Main();
		sol.begin();

	}

	private void begin() throws IOException
	{
		// io
		boolean file = true;
		if (file)
			in = new InputReader(new FileInputStream("D-small-attempt0.in"));
		else
			in = new InputReader(System.in);
		ans = new StringBuilder();

		// read
		int nCases = Integer.parseInt(in.next());
		for (int cas = 1; cas <= nCases; cas++)
		{
			k = in.nextInt();
			c = in.nextInt();
			s = in.nextInt();
			ans.append("Case #" + cas + ": " + solve() + "\n");

		}

		// output
		System.out.println(ans.toString());
		BufferedWriter out = new BufferedWriter(new FileWriter("output.txt"));
		out.write(ans.toString());
		out.close();

	}

	private String solve()
	{
		// check if valid
		if (s > k)
			return "IMPOSSIBLE";

		// compute the increment
		long increment = 1;
		for (int i = 0; i < c - 1; i++)
			increment *= k;

		// print every index
		StringBuilder strb = new StringBuilder();
		long idx = 1;
		for (int i = 0; i < k; i++)
		{
			strb.append(idx + " ");
			idx += increment;
		}

		return strb.toString().trim();
	}
}

class InputReader
{
	BufferedReader reader;
	StringTokenizer tok;

	public InputReader(InputStream stream)
	{
		reader = new BufferedReader(new InputStreamReader(stream), 32768);
		tok = new StringTokenizer("");
	}

	public String next()
	{
		while (!tok.hasMoreTokens())
			try
			{
				tok = new StringTokenizer(reader.readLine());
			} catch (IOException e)
			{
				e.printStackTrace();
			}
		return tok.nextToken();
	}

	public int nextInt()
	{
		return Integer.parseInt(next());
	}
}