import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Main
{

	/* IO */
	InputReader in;
	StringTokenizer tok;
	StringBuilder ans;

	/* FIELDS */
	int n, r, p, s;
	private String best;

	public static void main(String[] args) throws Exception
	{
		Main sol = new Main();
		sol.begin();

	}

	private void begin() throws IOException
	{
		// io
		boolean file = true;
		if (file)
			in = new InputReader(
					new FileInputStream("A-large (1).in"));
		else
			in = new InputReader(System.in);
		ans = new StringBuilder();

		// read
		int nCases = in.nextInt();
		for (int cas = 1; cas <= nCases; cas++)
		{
			n = in.nextInt();
			r = in.nextInt();
			p = in.nextInt();
			s = in.nextInt();

			ans.append("Case #" + cas + ": ");
			ans.append(solve());
			ans.append("\n");
		}

		// output
		System.out.println("\nOutput: ");
		System.out.println(ans.toString());
		BufferedWriter out = new BufferedWriter(new FileWriter("output.txt"));
		out.write(ans.toString());
		out.close();

		// test
		System.out.println("\nTest: ");

	}

	private Object solve()
	{
		String answers[] =
		{ f('P', 1), f('R', 1), f('S', 1) };
		Arrays.sort(answers);
		for (int i = 0; i < answers.length; i++)
			if (valid(answers[i]))
				return answers[i];
		return "IMPOSSIBLE";
	}

	private boolean valid(String string)
	{
		int countP = 0;
		int countR = 0;
		int countS = 0;
		for (int i = 0; i < string.length(); i++)
			if (string.charAt(i) == 'P')
				countP++;
			else if (string.charAt(i) == 'R')
				countR++;
			else if (string.charAt(i) == 'S')
				countS++;

		return countP == p && countS == s && countR == r;
	}

	private String f(char c, int level)
	{
		// base case
		if (level == n+1)
			return "" + c;

		// get the two other chars
		char c1 = 'X';
		char c2 = 'X';
		if (c == 'P')
		{
			c1 = 'P';
			c2 = 'R';
		} else if (c == 'R')
		{
			c1 = 'R';
			c2 = 'S';
		} else if (c == 'S')
		{
			c1 = 'S';
			c2 = 'P';
		}
		String str1 = f(c1, level + 1);
		String str2 = f(c2, level + 1);
		if (str1.compareTo(str2) < 0)
			return str1 + str2;
		else
			return str2 + str1;
	}

}

class InputReader
{
	BufferedReader reader;
	StringTokenizer tok;

	public InputReader(InputStream stream)
	{
		reader = new BufferedReader(new InputStreamReader(stream), 32768);
		tok = new StringTokenizer("");
	}

	public String next()
	{
		while (!tok.hasMoreTokens())
			try
			{
				tok = new StringTokenizer(reader.readLine());
			} catch (IOException e)
			{
				e.printStackTrace();
			}
		return tok.nextToken();
	}

	public int nextInt()
	{
		return Integer.parseInt(next());
	}
}