import com.sun.deploy.util.ArrayUtil;
import com.sun.tools.javac.util.ArrayUtils;

import java.io.*;
import java.util.Arrays;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.concurrent.ThreadLocalRandom;

public class Main {

    /* IO */
    InputReader in;
    BufferedWriter out;
    StringTokenizer tok;
    StringBuilder ans;

    /* FIELDS */
    int n, k;
    double u;
    double p[];

    public static void main(String[] args) throws IOException {
        Main sol = new Main();
        sol.begin();
    }

    private void begin() throws IOException {
        // io
        boolean file = true;
        if (file)
            in = new InputReader(new FileInputStream("C-small-2-attempt1 (1).in"));
        else
            in = new InputReader(System.in);
        ans = new StringBuilder();


        int nCases = in.nextInt();
        for (int cas = 1; cas <= nCases; cas++) {
            System.out.println(cas);
            n = in.nextInt();
            k = in.nextInt();
            u = Double.parseDouble(in.next());
            p = new double[n];
            for (int i = 0; i < n; i++) {
                p[i] = Double.parseDouble(in.next());
            }
            double max = solve();
            ans.append(String.format("Case #%d: %.12f\n", cas, max));
        }
        System.out.println(ans.toString());

        // output to file
        out = new BufferedWriter(new FileWriter("output.txt"));
        out.write(ans.toString());
        out.flush();
        out.close();
    }

    private double solve() {
        double max = 0;
        Random random = new Random();
        int percentage = 1000;
        int nIdices = n * 100;
        for (int trial = 0; trial < 1000; trial++) {
            double newP[] = p.clone();
            double rem = u;
            for (int i = 0; i < nIdices; i++) {
                int idx = random.nextInt(n);
                double itsMax = 1.0 - newP[idx];
                itsMax = Math.min(itsMax, rem);
                int willGet = random.nextInt(percentage + 1);
                newP[idx] += itsMax * willGet / percentage;
                rem -= itsMax * willGet / percentage;
            }

            double dp[][] = new double[n + 1][n + 1];
            dp[0][0] = 1.0;
            for (int unit = 0; unit < n; unit++)
                for (int nWorking = 0; nWorking < n; nWorking++) {
                    dp[unit + 1][nWorking] += (1 - newP[unit]) * dp[unit][nWorking];
                    dp[unit + 1][nWorking + 1] += newP[unit] * dp[unit][nWorking];
                }
            double sum = 0;
            for (int i = k; i <= n; i++)
                sum += dp[n][i];
            max = Math.max(max, sum);
        }

        if (1 - max < 0.0001)
            max = 1;
        if (max < 0.0001)
            max = 0;
        return max;
    }


}

class InputReader {
    BufferedReader reader;
    StringTokenizer tok;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream), 32768);
        tok = new StringTokenizer("");
    }

    public String next() {
        while (!tok.hasMoreTokens())
            try {
                tok = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                e.printStackTrace();
            }
        return tok.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }
}