import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.Scanner;
import java.util.Set;

import javax.xml.ws.handler.MessageContext.Scope;


public class ProblemA {

	/**
	 * @param args
	 * Ahmed Kammorah
	 */
public static void main(String[] args) {
		
		ProblemA problem=new ProblemA();
		
		problem.MainAlgorithm();
		problem.closeFiles();
	}
	
	ReadFile readFile;
	writeOutputFile writeOutputFile;
	
	public ProblemA() {
		
		
//		readFile=new ReadFile("A-small-attempt2.in");
//		writeOutputFile = new writeOutputFile("A-small-attempt2.out");
		
		readFile=new ReadFile("A-large.in");
		writeOutputFile = new writeOutputFile("A-large.out");
		
		
	}	
	
	
	
	
	void MainAlgorithm(){
		
		
		int N= Integer.parseInt(readFile.readNextLineScan());
		
		
		
		
		int XWin1 = 4*'X';
		int XWin2 = 3*'X'+'T';
		
		int OWin1 = 4*'O';
		int OWin2 = 3*'O'+'T';
		
		for(int i=1; i <=N ; i++){  // main cases loop
			
			Boolean draw = false;
			Boolean isNotComplet = false;

			char board[][]=new char[4][4];
			
			
			for(int j=0 ; j<4 ;j++){
				board[j] = readFile.readNextLineScan().toCharArray();
			}
			
		
			int D1 = 0;
			int D2 = 0;
			
			String outResult ="";
			
			for(int j=0 ; j<4 ; j++){
				
				int columSum = 0;
				int rowSum = 0;

				for(int k=0 ; k<4 ; k++){
					 columSum += board[j][k];
					 rowSum   += board[k][j];
					 
					if(board[j][k] == '.'){
						draw = false;
						isNotComplet = true;
					}

				}
				
				
				D1 += board[j][j];
				
				D2 += board[j][3-j];
				//System.out.println("i :  "+i+"   D2:"+D2+"   "+XWin1);
				if(columSum == XWin1 || columSum == XWin2 || rowSum == XWin1 || rowSum == XWin2 || D1 == XWin1 || D1 == XWin2 || D2 == XWin1 || D2 == XWin2){
					outResult = "X won";
					break;
				}else if(columSum == OWin1 || columSum == OWin2 || rowSum == OWin1 || rowSum == OWin2 || D1 == OWin1 || D1 == OWin2 || D2 == OWin1 || D2 == OWin2){
					outResult = "O won";
					break;
				}
				
				if(isNotComplet){
					outResult = "Game has not completed";
				}else{
					outResult = "Draw";
				}
				
								
				
			}
			//System.out.println(outResult);
			writeOutputFile.writeLineToOut("Case #" + i +": "+outResult+"\n");
			
			if(readFile.hasNextLine()){
				readFile.readNextLineScan();
			}
			

			
		}
		
		
		
	}
	
	
	public void closeFiles(){
		readFile.closeFile();
		writeOutputFile.closeOutFile();
	}
	
	
}// end problem class





class writeOutputFile {
		
		BufferedWriter dataOut;
		FileWriter fileOut;
		public writeOutputFile(String fileOutput) {
			try {
				
				//File file= new File(getClass().getResourceAsStream(fileOutput).toString());
				fileOut =new FileWriter(fileOutput);
				dataOut = new BufferedWriter(fileOut);
				
			} catch (IOException e) {
				System.out.println(" constractor  out file ...");
				e.printStackTrace();
			}
			
		}
		
		public void writeLineToOut(String line){
			try {
				dataOut.write(line);
				
				
			} catch (IOException e) {
				System.out.println(" write  out file ...");
				e.printStackTrace();
			}
		}
		
		
		
		public void closeOutFile(){
			
			try {
				dataOut.close();
				fileOut.close();
			} catch (IOException e) {
				System.out.println(" close  out file ...");
				e.printStackTrace();
			}
		}
		

	}

	




class ReadFile {
	
	Scanner scanner;
	
	
	public ReadFile(String fileName) {

		scanner = new Scanner(getClass().getResourceAsStream(fileName));
		
	}
	

	
	
	public int readNextIntScan(){

		return scanner.nextInt();
		
	}
	
	public char readNextChar(){
		
		return (char)scanner.nextByte();
	}
	
	public String readNextLineScan(){
		return scanner.nextLine();
	}
	
	public boolean hasNextLine() {
		return scanner.hasNextLine();
	}
	public void closeFile(){
		scanner.close();

	}
	
	
}

