package D;

import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;
import java.util.Set;

import javax.xml.ws.handler.MessageContext.Scope;

public class ProblemD {

	/**
	 * @param args
	 *            Ahmed Kammorah
	 */
	public static void main(String[] args) {

		ProblemD problem = new ProblemD();

		problem.MainAlgorithm();

		problem.closeFiles();

	}

	ReadFile readFile;
	writeOutputFile writeOutputFile;

	public ProblemD() {

//		readFile = new ReadFile("test.in");
//		writeOutputFile = new writeOutputFile("test.out");

//		 readFile=new ReadFile("D-small-attempt0.in");
//		 writeOutputFile = new writeOutputFile("D-small-attempt0.out");

		 readFile=new ReadFile("D-large.in");
		 writeOutputFile = new writeOutputFile("D-large.out");

	}

	void MainAlgorithm() {

		int N = Integer.parseInt(readFile.readNextLineScan());

		for (int i = 1; i <= N; i++) { // main cases loop

			int blocksNum = Integer.parseInt(readFile.readNextLineScan());

			String[] lineN = readFile.readNextLineScan().split(" ");
			String[] lineK = readFile.readNextLineScan().split(" ");
			// ArrayList<Double> naomiBlocks = new ArrayList<Double>();

			double[] naomiBlocks = new double[blocksNum];
			double[] kenBlocks = new double[blocksNum];

			for (int b = 0; b < blocksNum; b++) {
				naomiBlocks[b] = Double.parseDouble(lineN[b]);
				kenBlocks[b] = Double.parseDouble(lineK[b]);
			}
			Arrays.sort(naomiBlocks);
			Arrays.sort(kenBlocks);

			double[] naomiBlocksOrig = Arrays.copyOf(naomiBlocks, blocksNum);
			double[] kenBlocksOrig = Arrays.copyOf(kenBlocks, blocksNum);

			if (blocksNum == 1) {

			}

			// war
			int nScore = war(naomiBlocksOrig, kenBlocksOrig, blocksNum);
			int nScoreDecWar = Deceitfulwar(naomiBlocksOrig, kenBlocksOrig,
					blocksNum);

			String outResult = nScoreDecWar+ " " +nScore ;

			System.out.println(outResult);
			 writeOutputFile.writeLineToOut("Case #" + i +": "+outResult+"\n");

		}

		System.out.println("---------------end--------------");

	}

	int war(double[] naomiBlocksArray, double[] kenBlocksArray, int blocksNum) {

		double[] naomiBlocks = Arrays.copyOf(naomiBlocksArray, blocksNum);
		double[] kenBlocks = Arrays.copyOf(kenBlocksArray, blocksNum);

		// war
		int nScore = 0;
		int kScore = 0;
		for (int b = 0; b < blocksNum; b++) {
			double chosenN = naomiBlocks[b];
			double chosenK = -1;
			for (int kb = 0; kb < blocksNum; kb++) {
				if (kenBlocks[kb] != -1) {

					if (kenBlocks[kb] > chosenN) {
						chosenK = kenBlocks[kb];
						kenBlocks[kb] = -1;
						break;
					}
				}
			}

			if (chosenK == -1) {
				for (int kb = 0; kb < blocksNum; kb++) {
					if (kenBlocks[kb] != -1) {
						chosenK = kenBlocks[kb];
						kenBlocks[kb] = -1;
						break;
					}
				}
			}

			if (chosenN > chosenK) {
				nScore++;
			}

		}

		return nScore;
	}

	int Deceitfulwar(double[] naomiBlocks, double[] kenBlocks, int blocksNum) {
		// Deceitful War
		int nScoreDecWar = 0;

		
		for(int i = 0; i < blocksNum; i++){
			double chosenN = -1;
			double toldN = -1;
			double chosenK = -1;
			
			Arrays.sort(naomiBlocks);
			Arrays.sort(kenBlocks);
			
//			boolean isNamieMassHigher = false;
//			outer0:for(int namB= 0 ; namB < blocksNum ;namB++){
//				
//				for(int kenB = 0 ; kenB < blocksNum ;kenB++){
//					if(naomiBlocks [namB] != -1){
//						if( naomiBlocks[namB] > kenBlocks[kenB]){
//							isNamieMassHigher = true;
//						}
//					}
//				}
//			
//			}
			
			boolean isNamieMassHigher = true;
			for(int j= 0 ; j < blocksNum ;j++){
				if(naomiBlocks[j] < kenBlocks[j]){
					isNamieMassHigher = false;
				}
			
			}

			
			if(!isNamieMassHigher){
				outer:for(int namB= blocksNum-1 ; namB>=0 ;namB--){
					
					for(int kenB = blocksNum-1 ; kenB >= 0 ;kenB--){
						if(kenBlocks[kenB] > naomiBlocks[namB]){
							if(kenB !=0){
								if(kenBlocks[kenB -1] < naomiBlocks[namB]){
									toldN = kenBlocks[kenB-1]+0.00001;//+ ((kenBlocks[kenB]-kenBlocks[kenB-1])/2);
									break outer;
								}else{
									continue;
								}
							}
								
						}else if(kenBlocks[kenB] < naomiBlocks[namB]){
							continue;
						}
					}
				
				}
			
			
			
			
			for(int nb =0 ; nb < blocksNum ; nb++){
				if(naomiBlocks[nb] != -1){
					chosenN = naomiBlocks[nb];
					naomiBlocks[nb] = -1;
					if(toldN == -1){
						toldN = chosenN;
					}
					break;
				}
			}
			
			}else{
				for(int nb = blocksNum-1 ; nb >= 0 ; nb--){
					if(naomiBlocks[nb] != -1){
						if(toldN == -1){
							toldN = naomiBlocks[nb];
						}
						break;
					}
				}
				
				
				for(int nb =0 ; nb < blocksNum ; nb++){
					if(naomiBlocks[nb] != -1){
						chosenN = naomiBlocks[nb];
						naomiBlocks[nb] = -1;
						break;
					}
				}
			}
			nScoreDecWar = kPlayWar(kenBlocks, blocksNum, toldN, chosenN, chosenK, nScoreDecWar);
			
		}
		

			
		

		return nScoreDecWar;
	}
	
	int kPlayWar(double[] kenBlocks, int blocksNum , double toldN , double chosenN , double chosenK , int nScoreDecWar){
		if (toldN != -1 && chosenN != -1) {
			for (int kb = 0; kb < blocksNum; kb++) {
				if (kenBlocks[kb] != -1) {

					if (kenBlocks[kb] > toldN) {
						chosenK = kenBlocks[kb];
						kenBlocks[kb] = -1;
						break;
					}
				}
			}

			if (chosenK == -1) {
				for (int kb = 0; kb < blocksNum; kb++) {
					if (kenBlocks[kb] != -1) {
						chosenK = kenBlocks[kb];
						kenBlocks[kb] = -1;
						break;
					}
				}
			}

			if (chosenN > chosenK) {
				nScoreDecWar++;
			}
		}
		
		return nScoreDecWar;
	}

	
	public void closeFiles() {
		readFile.closeFile();
		writeOutputFile.closeOutFile();
	}

}// end problem class

class writeOutputFile {

	BufferedWriter dataOut;
	FileWriter fileOut;

	public writeOutputFile(String fileOutput) {
		try {

			// File file= new
			// File(getClass().getResourceAsStream(fileOutput).toString());
			fileOut = new FileWriter(fileOutput);
			dataOut = new BufferedWriter(fileOut);

		} catch (IOException e) {
			System.out.println(" constractor  out file ...");
			e.printStackTrace();
		}

	}

	public void writeLineToOut(String line) {
		try {
			dataOut.write(line);

		} catch (IOException e) {
			System.out.println(" write  out file ...");
			e.printStackTrace();
		}
	}

	public void closeOutFile() {

		try {
			dataOut.close();
			fileOut.close();
		} catch (IOException e) {
			System.out.println(" close  out file ...");
			e.printStackTrace();
		}
	}

}

class ReadFile {

	Scanner scanner;

	public ReadFile(String fileName) {

		scanner = new Scanner(getClass().getResourceAsStream(fileName));

	}

	public int readNextIntScan() {

		return scanner.nextInt();

	}

	public long readNextLongScan() {

		return scanner.nextLong();

	}

	public char readNextChar() {

		return (char) scanner.nextByte();
	}

	public String readNextLineScan() {
		return scanner.nextLine();
	}

	public boolean hasNextLine() {
		return scanner.hasNextLine();
	}

	public void closeFile() {
		scanner.close();

	}

}
