import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Main {

	static int D, N;
	
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter out = new PrintWriter("output.txt");
		
		int t = sc.nextInt(), a, b, cases = 1;
		
		Pair arr[];
		
		while(t-- > 0) {
			D = sc.nextInt();
			N = sc.nextInt();
			
			arr = new Pair[N];
			
			for(int i = 0; i < N; ++i) {
				a = sc.nextInt();
				b = sc.nextInt();
				arr[i] = new Pair(a, b);
			}
			
			Arrays.sort(arr);
			
			double maxTime = (D - arr[N - 1].a) * 1.0 / arr[N - 1].b;
			
			for(int i = N - 2; i >= 0; --i) {
				if((D - arr[i].a) * 1.0 / arr[i].b > maxTime) {
					maxTime = (D - arr[i].a) * 1.0 / arr[i].b;
				}
			}
			
			out.printf("Case #%d: %.7f\n", cases++, (D * 1.0 / maxTime));
			
		}
		 
		out.flush();
		out.close();
	}
	
	static class Pair implements Comparable<Pair> {
		int a, b;
		
		public Pair(int x, int y) {
			a = x;
			b = y;
		}
		
		@Override
		public int compareTo(Pair p) {
			return Integer.compare(a,  p.a);
		}
	}
	
	static class Scanner{
		StringTokenizer st;
		BufferedReader br;

		public Scanner(InputStream s){	br = new BufferedReader(new InputStreamReader(s));}

		public Scanner(FileReader r){	br = new BufferedReader(r);}

		public String next() throws IOException 
		{
			while (st == null || !st.hasMoreTokens()) 
				st = new StringTokenizer(br.readLine());
			return st.nextToken();
		}

		public int nextInt() throws IOException {return Integer.parseInt(next());}

		public long nextLong() throws IOException {return Long.parseLong(next());}

		public String nextLine() throws IOException {return br.readLine();}

		public double nextDouble() throws IOException { return Double.parseDouble(next()); }

		public boolean ready() throws IOException {return br.ready();}
	}
	
	static boolean OJ = System.getProperty("ONLINE_JUDGE") != null;
	static void tr(Object... o) {
		if(!OJ)	System.out.println(Arrays.deepToString(o));
	}
}