import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigInteger;

public class CoinJam {

    private static int count = 0;
    private static int n = 16;
    private static int max = 50;

    private static PrintWriter out;

    public static void main(String[] args) throws Exception {
        String fileName = "c";
        BufferedReader in = new BufferedReader(new FileReader(String.format("%s.in", fileName)));

        out = new PrintWriter(new BufferedWriter(new FileWriter(String.format("%s.out", fileName))));
        out.println(String.format("Case #%d:", 1));
        Solve(n, max);
        out.close();
    }

    private static void Solve(int n, int j) {
        int[] digits = new int[n];
        digits[0] = 1;
        digits[n - 1] = 1;
        Solve(digits, 1);
    }

    private static void Solve(int[] digits, int index) {
        if (count >= max) {
            return;
        }
        if (index == digits.length - 1) {
            Validate(digits);
            return;
        }
        digits[index] = 0;
        Solve(digits, index + 1);
        digits[index] = 1;
        Solve(digits, index + 1);       
    }

    private static void Validate(int[] digits) {
        Representation[] reps = new Representation[11];
        for (int i = 2; i < reps.length; i++) {
            reps[i] = Validate(i, digits.length, digits);
            if (reps[i].isPrime || reps[i].dividor <= 1) {
                return;
            }
        }
        Show(reps);
        count++;
    }

    private static Representation Validate(int base, int n, int[] digits) {
        long val = 0;
        long mul = 1;
        for (int i = 0; i < n; i++) {
            val += digits[n - i - 1] * mul;
            mul *= base;
        }
        return Validate(val);
    }

    private static Representation Validate(long number) {

        Representation rep = new Representation();
        rep.value = number;
        rep.isPrime = false;
        if (number <= 1) {
            rep.dividor = 1;
            return rep;
        } else if (number == 2) {
            rep.isPrime = true;
            return rep;
        } else if (number % 2 == 0) {
            rep.dividor = 2;
            return rep;
        }

        for (long i = 3; i * i <= number; i += 2) {
            if (number % i == 0) {
                rep.dividor = i;
                return rep;
            }

        }
        rep.isPrime = true;
        return rep;
    }

    private static void Show(Representation[] reps) {
        StringBuilder builder = new StringBuilder();
        builder.append(reps[reps.length - 1].value);
        for (int i = 2; i < reps.length; i++) {
            builder.append(' ').append(reps[i].dividor);
        }
        String row = builder.toString();
        out.println(row);
    }

    static class Representation {

        public boolean isPrime;
        public long value;
        public long dividor;
    }
}
