
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashSet;
import javax.sound.midi.Soundbank;

public class FairVLarge {
    
    static ArrayList<BigInteger> dp = new ArrayList<BigInteger>(200000);
    static HashSet<BigInteger> mem = new HashSet<BigInteger>(200000);
    static StringBuilder builder = new StringBuilder(200);
    
    public static void main(String[] args) throws Exception {
        BufferedReader in = new BufferedReader(new FileReader("C-large-2.in"));
        BufferedWriter out = new BufferedWriter(new FileWriter("C-large-2.out"));
        Cache();

        int N = Integer.parseInt(in.readLine());
         for (int i = 1; i <= N; i++) {
            String[] temp = in.readLine().split(" ");
            BigInteger A = new BigInteger(temp[0]);
            BigInteger B  =new BigInteger(temp[1]);
            int status = getStatus(A, B);
            out.write("Case #" + i + ": " + status);
            out.newLine();
        }
        out.close();
        System.out.println(dp.size());
        
    }
    
    private static int getStatus(BigInteger A, BigInteger B) {
        int count = 0;
        for (int i = 0; i < dp.size(); i++) {
            if ((dp.get(i).compareTo(A) >=0 && dp.get(i).compareTo(B) <=0)) {
                count++;
            }
        }
        return count;
    }
    
    private static void Cache() {
        dp.add(BigInteger.ONE);
        dp.add(BigInteger.ONE.multiply(new BigInteger("4")));
        dp.add(BigInteger.ONE.multiply(new BigInteger("9")));
        for (int i = 2; i <= 51; i++) {
            int[] temp = new int[i];
            
            solve(temp, 0,0);
        }
        
    }
    
    private static void solve(int[] temp, int index, int Total) {
        if(Total>9)return;
        int middle = temp.length/2;
        if (index == middle+1) {
            builder.setLength(0);
            for (int i = 0; i < temp.length / 2; i++) {
                temp[temp.length - i - 1] = temp[i];
            }
            for (int i = 0; i < temp.length; i++) {
                builder.append(temp[i]);
            }
            BigInteger sqrt = new BigInteger(builder.toString());
            BigInteger value = sqrt.pow(2);
            if (palin(sqrt.toString()) && palin(value.toString())) {
                if (!mem.contains(value)) {
                    dp.add(value);
                    mem.add(value);
                }  
            }
            return;
        }
        if (index != 0) {
            temp[index] = 0;
            solve(temp, index + 1,Total);
        }
        temp[index] = 1;
        solve(temp, index + 1,Total+2);
        
        
        //if (index == 0 || index == middle) {
            temp[index] = 2;
            solve(temp, index + 1,Total+4);
       // }
        
        
    }
    
    private static boolean palin(String t) {
        
        for (int i = 0; i < t.length() / 2; i++) {
            if (t.charAt(i) != t.charAt(t.length() - i - 1)) {
                return false;
            }
        }
        return true;
    }
}
