import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class RevengePancakes {

    public static void main(String[] args) throws Exception {
        String fileName = "B-large";
        BufferedReader in = new BufferedReader(new FileReader(String.format("%s.in", fileName)));
        PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(String.format("%s.out", fileName))));

        int T = Integer.parseInt(in.readLine());
        for (int testId = 1; testId <= T; testId++) {

            String cakes = in.readLine();
            boolean[] groups = new boolean[cakes.length()];
            for (int i = 0; i < cakes.length(); i++) {
                char c = cakes.charAt(i);
                groups[i] = c == '+';
            }
            int value = Solve(groups, groups.length, 0);
            out.println(String.format("Case #%d: %d", testId, value));
        }
        out.close();
    }

    private static int Solve(boolean[] groups, int end, int total) {

        int hCount = 0;
        int sCount = 0;
        int fPatchOfS = -1;
        int fPatchOfH = -1;
        for (int i = 0; i < end; i++) {
            if (groups[i]) {
                hCount++;
                if (sCount == 0) {//First blocks of Happy
                    fPatchOfH = i;
                }
            } else {
                sCount++;
                if (hCount == 0) {//First blocks of Sad
                    fPatchOfS = i;
                }
            }
        }
        if (hCount == end) {
            return total;
        } else if (sCount == end) {
            return total + 1;
        }

        for (int i = 0; i <= fPatchOfH; i++) {
            groups[i] = false;
        }
        
        for (int i = 0; i <= fPatchOfS; i++) {
            groups[i] = true;
        }
        return Solve(groups, end, total + 1);
    }
}
