import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class GettingDigits {

	private static Map<Character, Tuple> numberIdendifierMap1 = new HashMap<>();
	private static Map<Character, Tuple> numberIdendifierMap2 = new HashMap<>();
	
	static {
		numberIdendifierMap1.put('Z', new Tuple("ZERO", 0));
		numberIdendifierMap1.put('W', new Tuple("TWO", 2));
		numberIdendifierMap1.put('U', new Tuple("FOUR", 4));
		numberIdendifierMap1.put('F', new Tuple("FIVE", 5));
		numberIdendifierMap1.put('X', new Tuple("SIX", 6));
		numberIdendifierMap1.put('G', new Tuple("EIGHT", 8));
		
		numberIdendifierMap2.put('I', new Tuple("NINE", 9));
		numberIdendifierMap2.put('S', new Tuple("SEVEN", 7));
		numberIdendifierMap2.put('R', new Tuple("THREE", 3));
		numberIdendifierMap2.put('O', new Tuple("ONE", 1));
	}
	
	static class Tuple {
		public String stringValue;
		public int value;
		public Tuple(String s, int i) {
			this.stringValue = s;
			this.value = i;
		}
	}
	
	
	
	public static void main(String[] args) throws IOException {
		
		BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
		
		String line = reader.readLine();
		
		int index = 1;
		
		while((line = reader.readLine()) != null) {
			System.out.println("Case #" + index + ": " + getDigits(line));
			index++;
		}
	}
	
	public static String getDigits(String s) {
		
		List<Character> digitList = new ArrayList<>();
		for(char c: s.toCharArray())
			digitList.add(c);
		List<Integer> result = new ArrayList<>();
		
		while(true) {
			boolean stillContains = false;
			for(Map.Entry<Character, Tuple> entry: numberIdendifierMap1.entrySet()) {

				if(digitList.contains(entry.getKey())) {
					for(Character c: entry.getValue().stringValue.toCharArray()) {
						digitList.remove(c);
					}
					result.add(entry.getValue().value);
					stillContains = true;
				}
				
			}
			if(!stillContains) break;
		}
		
		while(true) {
			boolean stillContains = false;
			for(Map.Entry<Character, Tuple> entry: numberIdendifierMap2.entrySet()) {
				
				if(digitList.contains(entry.getKey())) {
					for(Character c: entry.getValue().stringValue.toCharArray()) {
						digitList.remove(c);
					}
					result.add(entry.getValue().value);
					stillContains = true;
				}
				
			}
			if(!stillContains) break;
		}
		Collections.sort(result);
		StringBuilder builder = new StringBuilder();
		for(int i : result) {
			builder.append(i);
		}
		return builder.toString();
		
	}

}
