import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.PriorityQueue;
import java.util.Queue;

public class Evacuation {

	public static void main(String[] args) throws IOException {

		BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));

		String line = reader.readLine();

		int index = 1;

		while ((line = reader.readLine()) != null) {

			line = reader.readLine();
			String[] each = line.split(" ");
			char c = 'A';
			
			Queue<Party> q = new PriorityQueue<>();
			for(String s: each) {
				q.add(new Party(Integer.parseInt(s), c + ""));
				c++;
			}
			
			System.out.println("Case #" + index + ": " + getPlan(q));
			index++;
		}
	}
	
	static class Party implements Comparable<Party>{
		
		public Party(int numberOfPeople, String code) {
			this.numberOfPeople = numberOfPeople;
			this.code = code;
		}
		int numberOfPeople;
		String code;
		
		@Override
		public int compareTo(Party o) {
			// TODO Auto-generated method stub
			return numberOfPeople < o.numberOfPeople ? 1:-1;
		}

		@Override
		public String toString() {
			return "Party [numberOfPeople=" + numberOfPeople + ", code=" + code
					+ "]";
		}
		
		public void decrement()
		{
			numberOfPeople -= 1;
		}		
		
	}
	
	public static String getPlan(Queue<Party> q) {
		
		StringBuilder result = new StringBuilder();
		int total = 0;
		int max = 0;
		for(Party p: q) {
			total += p.numberOfPeople;
			if(p.numberOfPeople > max) {
				max = p.numberOfPeople;
			}
		}
		while(!q.isEmpty()) {
			Party temp = q.poll();
			result.append(temp.code);
			temp.decrement();
			total--;
			if(temp.numberOfPeople > 0)
				q.add(temp);
			max = q.peek().numberOfPeople;
			
			if(!q.isEmpty() && max-1 <= (total-1)*0.5 && total != 2) {
				
				Party temp2 = q.poll();
				result.append(temp2.code);
				temp2.decrement();
				total--;
				if(temp2.numberOfPeople > 0)
					q.add(temp2);
				if(q.peek() != null)
					max = q.peek().numberOfPeople;
				else
					max = 0;
			}
			result.append(" ");
		}
		
		return result.toString().trim();
	}

}
