import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;

public class CenterOfMass {
	private static final String inputFile = "B-small-attempt1.in";
	private static final String outputFile = "output.txt";

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(inputFile));
		
		String line = reader.readLine();
		int T = Integer.parseInt(line);
		
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
		for (int X = 1; X <= T; X++) {
			line = reader.readLine();
			int N = Integer.parseInt(line);
			int[] x = new int[N];
			int[] y = new int[N];
			int[] z = new int[N];
			int[] vx = new int[N];
			int[] vy = new int[N];
			int[] vz = new int[N];
			for (int i = 0; i < N; i++) {
				line = reader.readLine();
				String[] parts = line.split(" ");
				x[i] = Integer.parseInt(parts[0]);
				y[i] = Integer.parseInt(parts[1]);
				z[i] = Integer.parseInt(parts[2]);
				vx[i] = Integer.parseInt(parts[3]);
				vy[i] = Integer.parseInt(parts[4]);
				vz[i] = Integer.parseInt(parts[5]);
			}
			
			Double tmin = 0d;
			Double dmin = 0d;
			// t=0
			double mx = 0, my = 0, mz = 0;
			for (int i = 0; i < N; i++) {
				mx += (double)x[i];
				my += (double)y[i];
				mz += (double)z[i];
			}
			mx /= (double)N;
			my /= (double)N;
			mz /= (double)N;
			dmin = Math.sqrt(mx*mx + my*my + mz*mz);
			
			// Search for derivative zeros
			double a = 0, b = 0;
			for (int i = 0; i < N; i++)
				for (int j = 0; j < N; j++)
				{
					b += vx[i]*vx[j] + vy[i]*vy[j] + vz[i]*vz[j];
					a += x[i]*vx[j] + y[i]*vy[j] + z[i]*vz[j]; 
				}
			if (b != 0) {
				double t = -a / b;
				if (t >= 0) {
					mx = 0; my = 0; mz = 0;
					for (int i = 0; i < N; i++) {
						mx += x[i] + vx[i]*t;
						my += y[i] + vy[i]*t;
						mz += z[i] + vz[i]*t;
					}
					mx /= (double)N;
					my /= (double)N;
					mz /= (double)N;
					double d = Math.sqrt(mx*mx + my*my + mz*mz);
					if (d < dmin) {
						dmin = d;
						tmin = t;
					}
				}
			}
			
			DecimalFormat df = new DecimalFormat("#.########");
			DecimalFormatSymbols dfs = df.getDecimalFormatSymbols();
			dfs.setDecimalSeparator('.');
			df.setDecimalFormatSymbols(dfs);
			df.setMaximumFractionDigits(8);
			df.setMinimumFractionDigits(8);
			
			writer.write("Case #" + X + ": " + df.format(dmin) + " " + df.format(tmin));
			if (X < T)
				writer.write("\n");
		}
		reader.close();
		writer.close();
	}

}
