import java.util.ArrayList;

public class CountingSheep implements GCJProblem {

	private static final int INPUTS_PER_TEST_CASE = 1 ;
	
	public static String main(String origNumAsString) {
		
		// Process passed paramter:
		int origNum = Integer.parseInt(origNumAsString);
		
		int numCount = 0, currNum;
		ArrayList<Integer> numsSeen = new ArrayList<>();
		long digitsSeen = 0;;
		char currDigit;
		
		do {
			
			numCount ++;
			
			currNum = numCount * origNum;
			
			for (int i = 0; i < Integer.toString(currNum).length(); i++) {
				currDigit = Integer.toString(currNum).charAt(i);
				
				if (!numContainsDigit(digitsSeen, currDigit))
					digitsSeen = (digitsSeen * 10) + Integer.parseInt(Character.toString(currDigit));
			}
			
//			if (!digitsIdenticalToPreviousNum(numsSeen, currNum))
			if (!numsSeen.contains(currNum))
				numsSeen.add(currNum);
			else
				return "INSOMNIA";
			
		} while (!containsAllDigits(digitsSeen));
		
		return Integer.toString(currNum);
	}
	
	public static int getInputsPerTestCase() {
		return INPUTS_PER_TEST_CASE;
	}
	
	private static boolean containsAllDigits(long digitsSeen) {
		
		final char[] arrayDigits = {'1', '2', '3', '4', '5', '6', '7', '8', '9', '0'};
		
		for (int j = 0; j < arrayDigits.length; j++) {
			if (!numContainsDigit(digitsSeen, arrayDigits[j]))
				return false;
		}
		
		return true;
	}
	
	private static boolean numContainsDigit(long num, char digit) {
		
		String numString = Long.toString(num);
		
		for (int i = 0; i< numString.length(); i++) {
			if (numString.charAt(i) == digit)
				return true;
		}
		
		return false;
	}
	
	private static boolean digitsIdenticalToPreviousNum(ArrayList<Integer> previousNums, int currNum) {
		
		String currNumString = Integer.toString(currNum);
		int currPrevNum;
		
		for (int i = 0; i < previousNums.size(); i++) {
			
			currPrevNum = previousNums.get(i);
			
			// At least one match has been found:
			if (digitsIdentical(currPrevNum, currNum))
				return true;
		}
		
		// No match has been found:
		return false;
	}
	
	private static boolean digitsIdentical(int num1, int num2) {
		
		ArrayList<Character> num1Digits = new ArrayList<>();
		for (int i = 0; i < Integer.toString(num1).length(); i++) {
			num1Digits.add(Integer.toString(num1).charAt(i));
		}
		
		String num2String = Integer.toString(num2);
		
		for (int i = 0; i < num2String.length(); i++) {
			if (!num1Digits.contains(num2String.charAt(i)))
				// A mismatch was found: num1 doesn't contain the current digit in num2
				return false;
		}
		
		// No mismatches found:
		return true;
	}

}
