import java.util.LinkedList;

public class RevengePancakes {
	
	private static final int INPUTS_PER_TEST_CASE = 1;
	
	public static String main (String pancakesString) {
		
		LinkedList<Boolean> pancakes = new LinkedList<>();
		for (int i = (pancakesString.length() - 1); i >= 0; i--) {
			if (pancakesString.charAt(i) == '+')
				pancakes.push(true);
			else
				pancakes.push(false);
		}
		
		boolean plusFirst;
		int flipTill, numFlips = 0, currElemIndex;
		
		while (!allHappyFaces(pancakes)) {
			
			plusFirst = (pancakes.peek() == true);
			
			if (plusFirst) {
				
				for (currElemIndex = 0; currElemIndex < pancakes.size(); currElemIndex++) {
					// Is the current element a '-'?
					if (pancakes.get(currElemIndex) == false)
						break;
				}
				
				// Flip everything upto the current element
				flipTill = currElemIndex;
				numFlips++;
				pancakes = performFlip(pancakes, flipTill);
			}
			else {
				
				for (currElemIndex = (pancakes.size() - 1); currElemIndex >= 0; currElemIndex--) {
					// Is the current element a '-'?
					if (pancakes.get(currElemIndex) == false)
						break;
				}
				
				// Flip everything uptill and including the current element:
				flipTill = (currElemIndex + 1);
				numFlips++;
				pancakes = performFlip(pancakes, flipTill);
			}
			
		}
		
		return Integer.toString(numFlips);
	}
	
	public static int getInputsPerTestCase() {
		return INPUTS_PER_TEST_CASE;
	}
	
	private static LinkedList<Boolean> performFlip(LinkedList<Boolean> pancakes, int flipTill) {
		
		LinkedList<Boolean> flipQueue = new LinkedList<Boolean>();
		
		for (int i = 1; i <= flipTill; i++) {
			flipQueue.addFirst(pancakes.pop());
		}
		
		for (int i = 1; i <= flipTill; i++) {
			pancakes.push(!flipQueue.removeLast());
		}
		
		return pancakes;
	}
	
	private static boolean allHappyFaces(LinkedList<Boolean> pancakes) {
		return !pancakes.contains(false);
	}
}
