import java.util.Scanner;

/*
 * PROGRAM FLOW:
 * 
 * CALLING main() in MAIN, 
 * 		(1) Gets the number of test cases
 * 		(2) Gets the array of inputs, all as strings
 * 		(3) For each test case, sends the respective inputs to the RESPECTIVE PROBLEM CLASS
 * 
 * IN THE RESPECTIVE PROBLEM CLASS, 
 * 		(1) All inputs are recieved as Strings
 * 		(2) Inputs are processed and formatted/casted appropriately
 * 		(3) The solution for that test case is returned AS A STRING
 * 
 * 		(3) For each test case, sends the respective inputs to the RESPECTIVE PROBLEM CLASS
 */

public class Main {
	
	private static final Scanner keyboard = new Scanner(System.in);
	
	// ----------------------------------
	// CHANGE CLASS NAME FOR EACH PROBLEM :
			
	private static final CountingSheep currProblem = new CountingSheep();
	
	// ----------------------------------
	
	private static int NUM_TEST_CASES;
	private static String[] arrayInputs;
	private static int INPUTS_PER_TEST_CASE = currProblem.getInputsPerTestCase();
	
	public static void main(String[] args) {
		
		System.out.println("Start ...");
		
		NUM_TEST_CASES = keyboard.nextInt();
		keyboard.nextLine();	// Consume newline left-over
		arrayInputs = getInputs();
		
		for (int currTC = 1; currTC <= NUM_TEST_CASES; currTC++) {
			
			System.out.println("Case #" + currTC + ": " + solution(currTC));
 		}
	}
	
	private static String solution(int currTC) {
		
		int indexAdder = (currTC - 1) * INPUTS_PER_TEST_CASE;
		
		// Add as many variables as there are inputs to currProblem's main method:
		String input1 = arrayInputs[ 0 + indexAdder ];
		// String input2 = arrayInputs[ 1 + indexAdder ];
		// String input3 = arrayInputs[ 2 + indexAdder ];
		
		return currProblem.main(input1);
	}
	
	private static String[] getInputs() {
		
		final int INPUTS_PER_TEST_CASE = currProblem.getInputsPerTestCase();
		String[] arrayInputs = new String[NUM_TEST_CASES * INPUTS_PER_TEST_CASE];
		
		for (int currInput = 0; currInput < arrayInputs.length; currInput++) {
			
			arrayInputs[currInput] = keyboard.nextLine();
		}
		
		return arrayInputs;
	}
}