package Problems2017.Round1.Problem1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class P4 {

	private static String FILENAME = "A-large";

	public static void main(String[] args) {

		Scanner        input  = null;
		BufferedWriter output = null;
		String line = "";
		try{
			input  = new Scanner(new BufferedReader(new FileReader(FILENAME + ".in")));
			output = new BufferedWriter(new FileWriter(FILENAME + ".out"));
		} catch(IOException e) { e.printStackTrace();}

		int testCases = Integer.parseInt(input.nextLine());
		for(int i = 1; i <= testCases; i++){

			line = input.nextLine();
			String[] parameters = line.split(" ");

			int R = Integer.parseInt(parameters[0]);
			int C = Integer.parseInt(parameters[1]);

			char[][] values = new char[R][C];
			for(int j = 0; j < R; j++) {
				line = input.nextLine();
				for(int k = 0; k < C; k++) {
					values[j][k] = line.charAt(k);
				}
			}

			try {output.write(String.format("Case #%d: \n%s", i, runSolution(R, C, values)));} 
			catch (IOException e) { e.printStackTrace();}
		}

		try {
			input.close();
			output.close();
		} catch (IOException e) {e.printStackTrace();}

	}

	private static String runSolution(int R, int C, char[][] values) {
		for(int i = 0; i < values.length; i++) {
			for(int j = 0; j < values[i].length; j++) {

				// Fill Horizontals
				if(values[i][j] != '?') {
					if(j-1 >= 0)
						for(int k = j-1; k >= 0; k--)
							if(values[i][k] == '?') values[i][k] = values[i][j];
							else break;
					for(int k = j+1; k < values[i].length; k++)
						if(values[i][k] == '?') values[i][k] = values[i][j];
						else break;
				}
			}
		}

		for(int i = 0; i < values.length; i++) {
			for(int j = 0; j < values[0].length; j++) {

				// Fill Verticals
				if(values[i][j] != '?') {
					for(int k = i-1; k >= 0; k--){
						if(values[k][j] == '?') values[k][j] = values[i][j];
						else break;
					}
					for(int k = i+1; k < values.length; k++){
						if(values[k][j] == '?') values[k][j] = values[i][j];
						else break;
					}
				}
			}
		}


		StringBuilder sb = new StringBuilder();
		for(int i = 0; i < values.length; i++) {
			for(int j = 0; j < values[i].length; j++)
				sb.append(values[i][j]);
			sb.append("\n");
		}

		return sb.toString();

	}

	private static void print2DArray(char[][] values) {
		for(int i = 0; i < values.length; i++)
			System.out.println(Arrays.toString(values[i]));
	}
}
