package Problems2017.Round1B;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class Problem2 {

	private static String FILENAME = "B-small-attempt0";
	
	public static void main(String[] args) {
		
		Scanner        input  = null;
		BufferedWriter output = null;
		
		try{
			input  = new Scanner(new BufferedReader(new FileReader(FILENAME + ".in")));
			output = new BufferedWriter(new FileWriter(FILENAME + ".out"));
		} catch(IOException e) { e.printStackTrace();}
		
		int testCases = Integer.parseInt(input.nextLine());
		
		for(int i = 1; i <= testCases; i++){
			
			String[] parameters =input.nextLine().split(" ");
			int n = Integer.parseInt(parameters[0]);
			int R = Integer.parseInt(parameters[1]);
			int O = Integer.parseInt(parameters[2]);
			int Y = Integer.parseInt(parameters[3]);
			int G = Integer.parseInt(parameters[4]);
			int B = Integer.parseInt(parameters[5]);
			int V = Integer.parseInt(parameters[6]);
			
			try {output.write(String.format("Case #%d: %s\n", i, runSolution(n,R,O,Y,G,B,V)));} 
			catch (IOException e) { e.printStackTrace();}
		}
		
		try {
			input.close();
			output.close();
		} catch (IOException e) {e.printStackTrace();}
		
	}
	
	private static String runSolution(int n, int R, int O, int Y, int G, int B, int V ) {
		
		//System.out.println("n: " + n + " R: " + R + " O: " + O + " Y: " + Y + " G: " + G + " B: " + B + " V: " + V);
		
		StringBuilder sb = new StringBuilder();
		while(O > 0 || V > 0 || G > 0) {
			//System.out.println(sb.toString());
			if(O >= G && O >= V) {
				O--;
				sb.append("O");
				if(--B < 0) return "IMPOSSIBLE";
				else sb.append("B");
				continue;
			}
			
			if(G >= O && G >= V) {
				G--;
				sb.append("G");
				if(--R < 0) return "IMPOSSIBLE";
				else sb.append("R");
				continue;
			}
			
			if(V >= O && V >= G) {
				V--;
				sb.append("V");
				if(--Y < 0) return "IMPOSSIBLE";
				else sb.append("Y");
				continue;
			}
			
		}

		char last = ' ';
		if(sb.length() != 0)
			last = sb.charAt(sb.length() - 1);
		else {
			
			if(B <= Y && B <= R)
				last = 'Y';
			else if(Y <= B && Y <= R)
				last = 'B';
			else if(R <= Y && R <= B)
				last = 'Y';
			
		}
		
		while(R > 0 || Y > 0 || B > 0) {
			//System.out.println(sb.toString());
			if(last == 'R') {
				if(Y > B) {
					if(--Y < 0) return "IMPOSSIBLE";
					else sb.append("Y");
					last = 'Y';
				} else {
					if(--B < 0) return "IMPOSSIBLE";
					else sb.append("B");
					last = 'B';
				}
				continue;
			}
			
			if(last == 'Y') {
				if(R > B) {
					if(--R < 0) return "IMPOSSIBLE";
					else sb.append("R");
					last = 'R';
				} else {
					if(--B < 0) return "IMPOSSIBLE";
					else sb.append("B");
					last = 'B';
				}
				continue;
			}
			
			if(last == 'B') {
				if(Y > R) {
					if(--Y < 0) return "IMPOSSIBLE";
					else sb.append("Y");
					last = 'Y';
				} else {
					if(--R < 0) return "IMPOSSIBLE";
					else sb.append("R");
					last = 'R';
				}
				continue;
			}
			
		}
		
		char first = sb.charAt(0);
		
		if(last == 'R' && (first == 'R' || first == 'O' || first == 'V'))
			return "IMPOSSIBLE";
		else if(last == 'Y' && (first == 'Y' || first == 'O' || first == 'G'))
			return "IMPOSSIBLE";
		else if(last == 'B' && (first == 'B' || first == 'G' || first == 'V'))
			return "IMPOSSIBLE";
		else
			return sb.toString();
		
	}

}
