package Problems2017.Problem3;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Scanner;

public class Main {

	private static final boolean DEBUG = false;

	private static int min;
	private static int max;

	public static void main(String[] args) {

		Scanner input = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

		int testCount = Integer.parseInt(input.nextLine());

		for(int i = 1; i <= testCount; i++) {
			getSolution(input.nextInt(), input.nextInt());
			System.out.printf("Case #%d: %d %d\n", i, max-1, min-1);
			input.nextLine();
		}
	}

	public static void getSolution(int n, int k) {

		if(DEBUG) System.out.println("n: " + n + " k: " + k);

		int SIZE = n+2;

		int[] stalls = new int[SIZE];	// Occupied stalls

		stalls[0]      = 1;
		stalls[SIZE-1] = 1;

		int[] rDistance = new int[SIZE]; // Maintains distance to next occupied stall to the right 1 _ _ 1 rDistance = {3, 2, 1, -1}
		int[] lDistance = new int[SIZE]; // Maintains distance to next occupied stall to the left  1 _ _ 1 lDistance = {-1, 1, 2, 3}

		lDistance[0] = 0;
		for(int i = 1; i < SIZE; i++)
			lDistance[i] = i;

		rDistance[SIZE-1] = 0;
		for(int i = 0; i < SIZE - 1; i++)
			rDistance[i] = SIZE-1 - i; 

		if(DEBUG) System.out.println("Stalls:          " + Arrays.toString(stalls));
		if(DEBUG) System.out.println("Left Distances:  " + Arrays.toString(lDistance));
		if(DEBUG) System.out.println("Right Distances: " + Arrays.toString(rDistance));


		for(int j = 1; j <= k; j++) {

			int candidateStall = -1;
			int maxDistance    = -1;
			for(int i = 0; i < SIZE; i++) {

				if(stalls[i] == 1) continue;
				// Distance from candidate stall and closest neighbor
				int distance = Math.min(lDistance[i], rDistance[i]);

				if(distance > maxDistance) {
					maxDistance = distance;
					candidateStall = i;
				} else if(distance == maxDistance) {
					if(Math.max(lDistance[candidateStall], rDistance[candidateStall]) < Math.max(lDistance[i], rDistance[i]))
						candidateStall = i;
				}
			}

			if(DEBUG) System.out.println("Optimum Seat: " + candidateStall);
			stalls[candidateStall] = 1;

			int i = candidateStall;
			int counter = 0;


			counter = 0;
			while(true) {
				counter++;
				if(i + counter == SIZE) break;
				if(lDistance[i + counter] > counter) lDistance[i+counter] = counter;
				else break;
			}

			counter = 0;
			while(true) {
				counter++;
				if(i - counter < 0) break;
				if(rDistance[i - counter] > counter) rDistance[i-counter] = counter;
				else break;
			}

			if(j == k) {
				min = Math.min(lDistance[i], rDistance[i]);
				max = Math.max(lDistance[i], rDistance[i]);
			}
			
			if(DEBUG) System.out.println("Stalls:          " + Arrays.toString(stalls));
			if(DEBUG) System.out.println("Left Distances:  " + Arrays.toString(lDistance));
			if(DEBUG) System.out.println("Right Distances: " + Arrays.toString(rDistance));

		}

	}

}
