package Problems2017.Round1B;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class Problem1 {

	private static String FILENAME = "A-small-attempt0";
	
	public static void main(String[] args) {
		
		Scanner        input  = null;
		BufferedWriter output = null;
		
		try{
			input  = new Scanner(new BufferedReader(new FileReader(FILENAME + ".in")));
			output = new BufferedWriter(new FileWriter(FILENAME + ".out"));
		} catch(IOException e) { e.printStackTrace();}
		
		int testCases = Integer.parseInt(input.nextLine());
		
		for(int i = 1; i <= testCases; i++){
			
			String[] parameters =input.nextLine().split(" ");
			int distance = Integer.parseInt(parameters[0]);
			int horseCount = Integer.parseInt(parameters[1]);
			int[] startingPoints = new int[horseCount];
			int[] speeds        = new int[horseCount];
			for(int j = 0; j < horseCount; j++) {
				String[] info = input.nextLine().split(" ");
				startingPoints[j] = Integer.parseInt(info[0]);
				speeds[j] = Integer.parseInt(info[1]);
			}
			try {output.write(String.format("Case #%d: %s\n", i, runSolution(distance, horseCount, startingPoints, speeds)));} 
			catch (IOException e) { e.printStackTrace();}
		}
		
		try {
			input.close();
			output.close();
		} catch (IOException e) {e.printStackTrace();}
		
	}
	
	private static String runSolution(int distance, int horseCount, int[] startPoints, int[] speeds) {
		
		double slowestTime  = 0;
		
		for(int i = 0; i < horseCount; i++) {
			double tempTime = (distance - startPoints[i]) / (double) speeds[i];
			if(tempTime > slowestTime) {
				slowestTime = tempTime;
			}
		}

		StringBuilder sb = new StringBuilder();
		sb.append(String.format("%.6f", distance / slowestTime));
		
		return sb.toString();
		
	}

}
