import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.Queue;

public class railway {
	static int time_turnaround = 0;

	public static void main(String[] args) {
		int nb_cases = 0;

		int nb_trips = 0;
		int nb_fromA = 0, nb_fromB = 0;

		String tmp[]; // for string split

		boolean marked[];

		LinkedList<Liner> liners = new LinkedList<Liner>();

		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(
					"e:\\jam\\out2.txt"));

			FileInputStream fstream = new FileInputStream("e:\\jam\\B-small-attempt1.in");

			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;

			strLine = br.readLine();
			nb_cases = Integer.valueOf(strLine);

			for (int i = 0; i < nb_cases; i++) {
				// clean the remains of the previous test case
				liners.clear();
				trains_fromA = 0;
				trains_fromB = 0;

				// read the turning duration
				strLine = br.readLine();
				time_turnaround = Integer.valueOf(strLine);

				// read the number of trips
				strLine = br.readLine();
				tmp = strLine.split(" ");
				nb_fromA = Integer.valueOf(tmp[0]);
				nb_fromB = Integer.valueOf(tmp[1]);
				nb_trips = nb_fromA + nb_fromB;

				marked = new boolean[nb_trips];
				for (int j = 0; j < nb_trips; j++) {
					marked[j] = false;
				}

				// read the schedule
				for (int j = 0; j < nb_fromA; j++) {
					strLine = br.readLine();
					tmp = strLine.split(" ");
					addByOrder(liners, new Liner(time_format(tmp[0]),
							time_format(tmp[1]), true));
				}
				for (int j = 0; j < nb_fromB; j++) {
					strLine = br.readLine();
					tmp = strLine.split(" ");
					addByOrder(liners, new Liner(time_format(tmp[0]),
							time_format(tmp[1]), false));
				}

				System.out.println(nb_trips);
				for (int j = 0; j < nb_trips; j++) {
					System.out.println(liners.get(j).time_departure);
					liners.get(j).index = j;
				}

				Analysis(liners, marked, 0, 0);

				out.write("Case #" + (i + 1) + ": " + trains_fromA + " "
						+ trains_fromB);
				out.newLine();
			}

			in.close();
			out.close();
		} catch (IOException e) {
			// catch exception if any
			System.err.println(e);
		}
	}

	static int trains_fromA = 0, trains_fromB = 0;

	public static int Analysis(LinkedList<Liner> _liners, boolean _marked[],
			int _trainA, int _trainB) {
		if (earliest_possible(_marked) < 0) {// all marked
			trains_fromA = _trainA;
			trains_fromB = _trainB;
			return -1;
		}

		Liner _firstLiner = _liners.get(earliest_possible(_marked));
		_marked[_firstLiner.index] = true;
		LinkedList<boolean[]> timelines = new TimeLine(_liners, _marked,
				time_turnaround, _firstLiner).trainMarks;
		int ret = 0;

		for (int i = 0; i < timelines.size(); i++) {
			if (_firstLiner.fromA)
				ret = Analysis(_liners, timelines.get(i), _trainA + 1, _trainB);
			else
				ret = Analysis(_liners, timelines.get(i), _trainA, _trainB + 1);

			if (ret < 0)
				return ret;
		}
		return 0;
	}

	public static void addByOrder(LinkedList<Liner> _liners, Liner _newLiner) {
		for (int i = 0; i < _liners.size(); i++) {
			if (_newLiner.time_departure < _liners.get(i).time_departure) {
				_liners.add(i, _newLiner);
				return;
			}
		}
		_liners.addLast(_newLiner);
	}

	public static int earliest_possible(boolean _marked[]) {
		for (int i = 0; i < _marked.length; i++) {
			if (!_marked[i])
				return i;
		}
		return -1;
	}

	/**
	 * convert clock to minutes
	 * 
	 * @param str_time
	 *            in clock format
	 * @return minutes
	 */
	public static int time_format(String str_time) {
		int minutes = 0;
		minutes += (str_time.charAt(0) - 48) * 10 * 60;
		minutes += (str_time.charAt(1) - 48) * 60;
		minutes += (str_time.charAt(3) - 48) * 10;
		minutes += (str_time.charAt(4) - 48);
		return minutes;
	}
}

class TimeLine {
	int time_turnaround;
	LinkedList<boolean[]> trainMarks = new LinkedList<boolean[]>();

	public TimeLine(LinkedList<Liner> _liners, boolean _marked[],
			int _time_turnaround, Liner _firstLiner) {
		time_turnaround = _time_turnaround;
		nextLiner(_liners, _marked, _firstLiner);
	}

	public void nextLiner(LinkedList<Liner> _liners, boolean _marked[],
			Liner _firstLiner) {
		int t = _firstLiner.time_arrival + time_turnaround;
		int children = 0;
		Liner l;
		for (int i = _firstLiner.index + 1; i < _liners.size(); i++) {
			if (!_marked[i]) {
				l = _liners.get(i);
				if ((l.fromA == !_firstLiner.fromA) && (l.time_departure >= t)) {
					boolean _newMarked[] = _marked.clone();
					_newMarked[i] = true;
					nextLiner(_liners, _newMarked, l);
					children++;
				}
			}
		}
		// come to the leave node, register the "marked" array
		if (children == 0) {
			trainMarks.add(_marked);
		}
	}
}

class Liner {
	int time_departure;
	int time_arrival;

	boolean fromA;

	int index;// assigned in the main

	public Liner(int td, int ta, boolean _fromA) {
		time_departure = td;
		time_arrival = ta;
		fromA = _fromA;
	}
}
