import java.util.InputMismatchException;
import java.io.*;
import java.util.Arrays;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new Candy();
		solver.solve(1, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

    public int nextInt() {
		return Integer.parseInt(nextToken());
	}
    public String readString() {
        return readLine();
    }


    public String readLine() {
        StringBuffer res = new StringBuffer();
        int c = read();
        while (c != '\n' && c != -1) {
            if (c != '\r')
                res.appendCodePoint(c);
            c = read();
        }
        return res.toString();
    }
    public String nextToken() {
		int c = read();
		while (isSpaceChar(c)) {
			c = read();
        }
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}
    private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
        curChar = 0;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	@Override
	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class Candy implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int test = in.nextInt();
        for (int t = 0; t < test; ++t) {
            int n = in.nextInt();
            int c[] = new int[n];
            int total = 0;
            int mx = 0;
            int sm = 0;
            for (int i =0 ; i < n; ++i) {
                c[i] = in.nextInt();
                total ^= c[i];
                mx = Math.max(mx, c[i]);
                sm += c[i];
            }
            mx = 1 << 20;
            int dm[][] = new int[2][mx + 1];
            Arrays.fill(dm[0], -1);
            dm[0][0] = 0;
            for (int i =0 ; i < n; ++i) {
                Arrays.fill(dm[(i + 1) & 1], -1);
                for (int j = mx ; j >= 0; --j) {
                    if (dm[i & 1][j] != -1) {
                        if (dm[(i + 1) & 1][j ^ c[i]] == -1 || dm[(i + 1) & 1][j ^ c[i]] < dm[i & 1][j] + c[i]) {
                            dm[(i + 1) & 1][j ^ c[i]] = dm[i & 1][j] + c[i];
                        }
                    }
                }
                for (int j =0 ; j <= mx; ++j) {
                    if (dm[(i + 1) & 1][j] == -1 || dm[(i + 1) & 1][j] < dm[i & 1][j]) {
                        dm[(i + 1) & 1][j] = dm[i & 1][j];
                    }
                }
            }
            int ans = -1;
            for (int j = 0; j <= mx; ++j) {
                if (dm[n & 1][j] != sm && (total ^ j) == j && dm[n & 1][j] != -1) {
                    if (ans == -1 || ans < dm[n & 1][j]) {
                        ans = dm[n & 1][j];
                    }
                }
            }
            out.print("Case #" + (t + 1) + ": ");
            if (ans == -1) {
                out.print("NO");
            } else {
                out.print(ans);
            }
            out.println();
        }
	}
}

