import java.io.InputStreamReader;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.Set;
import java.io.PrintStream;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.util.StringTokenizer;
import java.math.BigInteger;
import java.util.HashSet;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author aircube
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("input.txt");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("output.txt");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		FastInputReader in = new FastInputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		MagicTrick solver = new MagicTrick();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class MagicTrick {
    public void solve(int testNumber, FastInputReader in, PrintWriter out) {
        Set<Integer> set1 = getSet(in);
        Set<Integer> set2 = getSet(in);
        Set<Integer> andSet = new HashSet<>();
        for (int x : set1)
            if (set2.contains(x)) andSet.add(x);
        out.print("Case #" + testNumber + ":");
        if (andSet.size() == 0) {
            out.println(" Volunteer cheated!");
        } else if (andSet.size() > 1) {
            out.println(" Bad magician!");
        } else {
            out.println(" " + andSet.toArray()[0]);
        }
    }

    private Set<Integer> getSet(FastInputReader in) {
        HashSet<Integer> set=new HashSet<>();
        int row = in.nextInt() - 1;
        for (int i = 0; i < 4; ++i) {
            for (int j = 0; j < 4; ++j) {
                int x = in.nextInt();
                if (i == row)
                    set.add(x);
            }
        }
        return set;
    }
}

class FastInputReader {
    private StringTokenizer tokenizer;
    public BufferedReader reader;

    public FastInputReader(InputStream inputStream) {
        reader = new BufferedReader(new InputStreamReader(inputStream));
        tokenizer = null;
    }

    public String nextToken() {
        try {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                tokenizer = new StringTokenizer(reader.readLine());
            }
        } catch (IOException e) {
            System.out.println("There is no more tokens");
            return null;
        }
        return tokenizer.nextToken();
    }
    public String next() {
        return nextToken();
    }
    public int nextInt() {
        return Integer.parseInt(nextToken());
    }

    }

