import java.util.InputMismatchException;
import java.io.*;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new Candy();
		solver.solve(1, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

    public int nextInt() {
		return Integer.parseInt(nextToken());
	}
    public String readString() {
        return readLine();
    }


    public String readLine() {
        StringBuffer res = new StringBuffer();
        int c = read();
        while (c != '\n' && c != -1) {
            if (c != '\r')
                res.appendCodePoint(c);
            c = read();
        }
        return res.toString();
    }
    public String nextToken() {
		int c = read();
		while (isSpaceChar(c)) {
			c = read();
        }
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}
    private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
        curChar = 0;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	@Override
	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class Candy implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int test = in.nextInt();
        for (int t = 0; t < test; ++t) {
            int n = in.nextInt();
            int c[] = new int[n];
            for (int i =0 ; i < n; ++i)
                c[i] = in.nextInt();
            ok = false;
            ans = 0;
            brute(0, 0, 0, 0, 0, c);
            out.print("Case #" + (t + 1) + ": ");
            if (!ok) {
                out.print("NO");
            } else {
                out.print(ans);
            }
            out.println();
        }
	}
    boolean ok ;
    int ans;
    void brute(int pos, int s0, int s1, int ss0, int ss1,  int[] c) {
        if (pos == c.length) {
            if (s0 == s1) {
                ok = true;
                if (ss0 == 0 || ss1 == 0) return;
                ans = Math.max(ans,  Math.max(ss0,ss1 ));
            }
        } else {
            brute(pos + 1, s0 ^ c[pos], s1,ss0 + c[pos], ss1,  c);
            brute(pos + 1, s0, s1 ^ c[pos], ss0, ss1 + c[pos], c);
        }
    }
}

