import java.util.InputMismatchException;
import java.io.*;
import java.util.Locale;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new RPI();
		int testCount = in.readInt();
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

    public int readInt() {
        return nextInt();
    }
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
    public String readString() {
        return readLine();
    }


    public String readLine() {
        StringBuffer res = new StringBuffer();
        int c = read();
        while (c != '\n' && c != -1) {
            if (c != '\r')
                res.appendCodePoint(c);
            c = read();
        }
        return res.toString();
    }
    public String nextToken() {
		int c = read();
		while (isSpaceChar(c)) {
			c = read();
        }
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}
    private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
        curChar = 0;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	@Override
	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class RPI implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        char s[][] = new char[n][];
        for (int i = 0; i < n; ++i) {
            s[i] = in.nextToken().toCharArray();
        }
        double wp[] = new double[n];
        double owp[] = new double[n];
        double oowp[] = new double[n];
        for (int i = 0; i < n; ++i) {
            int games = 0;
            int win = 0;
            for (char ch : s[i]) {
                if (ch != '.') {
                    ++ games;
                    if (ch == '1') ++ win;
                }
            }
            wp[i] = (double ) win / games;
        }
        for (int i = 0; i < n; ++i) {
            boolean used[] = new boolean[n];
            used[i] = true;
            for (int j = 0; j < n; ++j) {
                if (s[i][j] == '.') {
                    used[j] =true;
                }
            }
            int cnt = 0;
            double sum = 0;
            for (int j = 0; j < n; ++j) {
                if (s[i][j] != '.' && !used[j]) {
                    int games = 0;
                    int win = 0;
                    for (int u = 0; u < n; ++u) {
                        if (u != i) {
                            if (s[j][u] != '.') {
                                ++ games;
                                if (s[j][u] == '1') ++ win;
                            }
                        }
                    }
                    sum += (double ) win / games;
                    ++ cnt;
                }
            }
            owp[i] = sum / cnt;
        }
        for (int i = 0; i < n; ++i) {
            int cnt = 0;
            double sum = 0;
            for (int j = 0; j < n; ++j) {
                if (s[i][j] != '.') {
                    cnt ++ ;
                    sum += owp[j];
                }
            }
            oowp[i] = sum / cnt;
        }
        double ans[] = new double[n];
        out.print("Case #" + (testNumber)+ ":\n");
        for (int i = 0; i < n; ++i) {
            // RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP
            ans[i] = 0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
            out.printf(Locale.US, "%.10f\n", ans[i]);
        }
	}
}

