import java.util.InputMismatchException;
import java.io.*;
import java.util.*;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new BotTrust();
		solver.solve(1, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

    public int nextInt() {
		return Integer.parseInt(nextToken());
	}
    public String readString() {
        return readLine();
    }


    public String readLine() {
        StringBuffer res = new StringBuffer();
        int c = read();
        while (c != '\n' && c != -1) {
            if (c != '\r')
                res.appendCodePoint(c);
            c = read();
        }
        return res.toString();
    }
    public String nextToken() {
		int c = read();
		while (isSpaceChar(c)) {
			c = read();
        }
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}
    private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
        curChar = 0;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	@Override
	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class BotTrust implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int test = in.nextInt();
        for (int t =0 ; t < test; ++t) {
            int n = in.nextInt();
            Task[] tasks = new Task[n];
            for (int i = 0; i < n; ++i) {
                String robot = in.nextToken();
                int cell = in.nextInt();
                tasks[i] = new Task(robot.equals("O") ? 0 : 1, cell);
            }
            int[][][] dist = new int[100][100][n + 1];
            int dx[] = new int[] {0, -1, 1};
            for (int[][] a : dist) for (int[] b : a) Arrays.fill(b, -1);
            dist[0][0][0] = 0;
            Queue<State> Q = new LinkedList<State>() ;
            Q.add(new State(0, 0, 0));
            int ans = Integer.MAX_VALUE / 2;
            while (Q.size() > 0) {
                State p = Q.poll();
                int x = p.x;
                int y = p.y;
                int d = p.d;
                for (int i = 0; i < 3; ++i)
                    for (int j =0 ; j < 3; ++j) {
                        int nx = x + dx[i];
                        int ny = y + dx[j];
                        if (nx >= 0 && nx < 100 && ny >= 0 && ny < 100) {
                            if (d >= n) {
                                ans = Math.min(ans, dist[x][y][d]);
                                continue;
                            }
                            if (tasks[d].robot == 0 && dist[nx][ny][d + 1] == -1 && nx == tasks[d].cell - 1 && i == 0
                            || tasks[d].robot == 1 && dist[nx][ny][d + 1] == -1 && ny == tasks[d].cell - 1 && j == 0) {
                                    dist[nx][ny][d + 1] = dist[x][y][d] + 1;
                                    Q.add(new State(nx, ny, d + 1));
                            }
                            if (dist[nx][ny][d] == -1) {
                                dist[nx][ny][d] = dist[x][y][d] + 1;
                                Q.add(new State(nx, ny, d));
                            }
                        }
                    }
            }
            out.println("Case #" + (t + 1) + ": " + (ans));

        }
	}
    class State {
        int x, y, d;

        State(int x, int y, int d) {
            this.x = x;
            this.y = y;
            this.d = d;
        }
    }
    class Task {
        int robot;
        int cell;

        Task(int robot, int cell) {
            this.robot = robot;
            this.cell = cell;
        }
    }
}

