import java.util.InputMismatchException;
import java.io.*;
import java.util.Locale;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new RevengeOfTheHotDogs();
		int testCount = in.readInt();
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

    public int readInt() {
        return nextInt();
    }
	public int nextInt() {
		return Integer.parseInt(nextToken());
	}
    public String readString() {
        return readLine();
    }


    public String readLine() {
        StringBuffer res = new StringBuffer();
        int c = read();
        while (c != '\n' && c != -1) {
            if (c != '\r')
                res.appendCodePoint(c);
            c = read();
        }
        return res.toString();
    }
    public String nextToken() {
		int c = read();
		while (isSpaceChar(c)) {
			c = read();
        }
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}
    private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
        curChar = 0;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	@Override
	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class RevengeOfTheHotDogs implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int n = in.nextInt();
        int d = in.nextInt();
        int x[] = new int[n];
        int count[] = new int[n];
        int cnt = 0;
        for (int i = 0; i < n; ++i) {
            x[i] = in.nextInt();
            count[i] = in.nextInt();
            cnt += count[i];
        }
        int y[] = new int[cnt];
        cnt = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < count[i]; ++j)
                y[cnt ++] = x[i];
        }
        double l = 0, r = 10000000000000L, res = r;
        for (int iter = 0; iter < 100; ++iter) {
            double m = (l + r) / 2;
            if (check(y, count, 1.0*d, m)) {
                res = Math.min(res, m);
                r = m ;
            } else l = m;
        }
        out.print("Case #" + (testNumber) + ": ");
        out.printf(Locale.US, "%.10f\n", res );
	}

    static final double eps = 1e-9;
    private boolean check(int[] x, int[] count, double d, double m) {
        int n = x.length;

        double solve[] = new double[n];
        for (int i = 0; i < n; ++i) {
            if (i == 0) {
                solve[i] = x[i] - m;
            } else {
                if (solve[i - 1] + eps < x[i]) {
                    if (x[i] - solve[i - 1] >= d) {
                        double move = Math.min(m, x[i] - solve[i - 1] - d);
                        solve[i] = x[i] - move;
                    } else {
                        if (x[i] + m - solve[i - 1] + eps < d) return false;
                        double move = d - (x[i] - solve[i - 1]);
                        solve[i] = x[i] + move;
                    }
                } else {
                    if (x[i] + m - solve[i - 1] + eps < d) return false;
                    double move = d + solve[i - 1] - x[i];
                    solve[i] = x[i] + move;
                }
            }
        }
        return true;
    }
}

