import java.util.InputMismatchException;
import java.io.*;

/**
 * Generated by Contest helper plug-in
 * Actual solution is at the bottom
 */
public class Main {
	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (Exception e) {
			throw new RuntimeException(e);
		}
		InputReader in = new StreamInputReader(System.in);
		PrintWriter out = new PrintWriter(System.out);
		run(in, out);
	}

	public static void run(InputReader in, PrintWriter out) {
		Solver solver = new Magicka();
		solver.solve(1, in, out);
		Exit.exit(in, out);
	}
}

abstract class InputReader {
	private boolean finished = false;

	public abstract int read();

    public int nextInt() {
		return Integer.parseInt(nextToken());
	}
    public String readString() {
        return readLine();
    }


    public String readLine() {
        StringBuffer res = new StringBuffer();
        int c = read();
        while (c != '\n' && c != -1) {
            if (c != '\r')
                res.appendCodePoint(c);
            c = read();
        }
        return res.toString();
    }
    public String nextToken() {
		int c = read();
		while (isSpaceChar(c)) {
			c = read();
        }
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}
    private boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public void setFinished(boolean finished) {
		this.finished = finished;
	}

	public abstract void close();
}

class StreamInputReader extends InputReader {
	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar, numChars;

	public StreamInputReader(InputStream stream) {
		this.stream = stream;
        curChar = 0;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	@Override
	public void close() {
		try {
			stream.close();
		} catch (IOException ignored) {
		}
	}
}

class Exit {
	private Exit() {
	}

	public static void exit(InputReader in, PrintWriter out) {
		in.setFinished(true);
		in.close();
		out.close();
	}
}

interface Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out);
}

class Magicka implements Solver {
	public void solve(int testNumber, InputReader in, PrintWriter out) {
        int test = in.nextInt();
        for (int t = 0; t < test; ++t) {
            int C = in.nextInt();
            String combine[] = new String[C];
            for (int i = 0; i < C; ++i) {
                combine[i] = in.nextToken();
            }
            int D = in.nextInt();
            String opposed[] = new String[D];
            for (int i =0; i < D; ++i) {
                opposed[i] = in.nextToken();
            }
            int len = in.nextInt();
            char s[] = in.nextToken().toCharArray();
            String str = "";
            for (int i =0; i < s.length; ++i) {
                str += s[i];
                str = combine(str, combine);
                str = opposed(str, opposed);
            }
            out.print("Case #" + (t + 1) + ": ");
            out.print("[");
            for (int i = 0; i < str.length(); ++i) {
                out.print(str.charAt(i));
                if (i != str.length() - 1) {
                    out.print(", ");
                }
            }
            out.print("]");
            out.println();

        }
	}
    String opposed(String s, String[] opposed) {
        int n = s.length();
        for (int i =0 ; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                for (int u = 0; u < opposed.length; ++u) {
                    if (s.charAt(i) == opposed[u].charAt(0) && s.charAt(j) == opposed[u].charAt(1) ||
                        s.charAt(i) == opposed[u].charAt(1) && s.charAt(j) == opposed[u].charAt(0)) {
                        String ans = "";
                        /*for (int t = 0; t < i; ++t)
                            ans += s.charAt(t);
                        for (int t = j + 1; t < n; ++t)
                            ans += s.charAt(t);*/
                        return "";
                    }
                }
            }
        }
        return s;
    }
    String combine(String s, String[] combine) {
        if (s.length() <= 1) return s;
        int n = s.length();
        for (int i = 0; i < combine.length; ++i) {
            if (s.charAt(n - 2) == combine[i].charAt(0) && s.charAt(n - 1) == combine[i].charAt(1) ||
                s.charAt(n - 2) == combine[i].charAt(1) && s.charAt(n - 1) == combine[i].charAt(0)) {
                return s.substring(0, n - 2) + combine[i].charAt(2);
            }
        }
        return s;
    }
}

