import java.io.InputStreamReader;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.Locale;
import java.io.PrintStream;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.util.StringTokenizer;
import java.math.BigInteger;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author aircube
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("input.txt");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("output.txt");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		FastInputReader in = new FastInputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		CookieClickerAlpha solver = new CookieClickerAlpha();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class CookieClickerAlpha {
    public void solve(int testNumber, FastInputReader in, PrintWriter out) {
        double c = in.nextDouble();
        double f = in.nextDouble();
        double x = in.nextDouble();
        double ans = Double.MAX_VALUE;
        double curTime = 0;
        double curRate = 2;
        for (int i = 0; i < 1000000; ++i) {
            ans = Math.min(ans, curTime + x / curRate);
            curTime += c / curRate;
            curRate += f;
        }
        out.print("Case #" + testNumber + ": ");
        out.printf(Locale.US, "%.10f\n", ans);
    }
}

class FastInputReader {
    private StringTokenizer tokenizer;
    public BufferedReader reader;

    public FastInputReader(InputStream inputStream) {
        reader = new BufferedReader(new InputStreamReader(inputStream));
        tokenizer = null;
    }

    public String nextToken() {
        try {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                tokenizer = new StringTokenizer(reader.readLine());
            }
        } catch (IOException e) {
            System.out.println("There is no more tokens");
            return null;
        }
        return tokenizer.nextToken();
    }
    public String next() {
        return nextToken();
    }

    public double nextDouble() {
        return Double.parseDouble(nextToken());
    }

    }

