/*
 * Martin Tianxiong Jiang
 */
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Scanner;

public class CandySplit {
	static int T, N;
	static ArrayList<Integer> V, result, B, list;
	static Scanner input;
	public static void main(String[] args) throws IOException {
		init(args[0]);
		int t = 0;
		while(input.hasNextLine()){
			N = Integer.parseInt(input.nextLine());
			Scanner line = new Scanner(input.nextLine());
			readValue(line);
			sort(V);
			partition(V, B, list);
			int res = largest(list);
			result.set(t++, res);
			clear(V, B, list, line);
		}
		print();
	}

	static void init(String arg) throws FileNotFoundException{
		result = new ArrayList<Integer>();
		V = new ArrayList<Integer>();
		B = new ArrayList<Integer>();
		list = new ArrayList<Integer>();
		input = new Scanner(new File(arg));
		T = Integer.parseInt(input.nextLine());
		for(int i = 0; i<T; i++) result.add(-1);
	}
	
	@SuppressWarnings("unchecked")
	static void partition(ArrayList<Integer> A, ArrayList<Integer> B, ArrayList<Integer> list){
		if(A.size()==0) return;
		for(int i = 0; i<A.size(); i++){
			B.add(A.remove(i));
			int sumA = sum(A);
			if(sumA==sum(B) && !A.isEmpty() && !B.isEmpty()) list.add(realSum(A));
			//recursion
			ArrayList<Integer> copyA = (ArrayList<Integer>) A.clone();
			ArrayList<Integer> copyB = (ArrayList<Integer>) B.clone();
			partition(copyA, copyB, list);
		}
	}

	static int largest(ArrayList<Integer> A){
		int win = -1;
		for(Integer i : A) if(i>win) win = i;
		return win;
	}

	static void sort(ArrayList<Integer> A){
		Integer[] temp = new Integer[A.size()];
		temp = A.toArray(temp);
		Arrays.sort(temp);
		A.clear();
		for(Integer i : temp) A.add(i);
	}

	static int realSum(ArrayList<Integer> A){
		int sum = 0;
		for(int i : A) sum += i;
		return sum;
	}

	static int sum(ArrayList<Integer> A){
		int sum = 0;
		for(int i : A) sum = add(sum, i);
		return sum;
	}

	//In Patrick's way
	static int add(int x, int y){
		return x ^ y;
	}

	// x - y
	static int minus(int x, int y){
		return x ^ y; 
	} 
	
	public static void readValue(Scanner line){
		while(line.hasNext()) V.add(line.nextInt());
	}

	static void print() throws IOException {
		int t = 1;
		BufferedWriter out = new BufferedWriter(new FileWriter("output_candy"));
		for(Iterator<Integer> i = result.iterator(); i.hasNext();){
			int j = i.next();
			String s = (j==-1 ? "NO" : j+"");
			System.out.println("Case #" + t + ": " + s);
			out.write("Case #" + t + ": " + s+"\n");
			t++;
		}
		out.close();
	}
	
	private static void clear(ArrayList<Integer> A, ArrayList<Integer> B,
			ArrayList<Integer> C, Scanner line) {
		A.clear();
		B.clear();
		C.clear();
		line.close();
	}
}
