/*
 * Martin Tianxiong Jiang
 */
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Scanner;
import java.util.StringTokenizer;
import java.util.concurrent.Semaphore;

import botTrust.BotTrust;
import botTrust.Command;

public class Magicka {
	static int T;
	static ArrayList<String> opps;
	static ArrayList<Combine> com;
	static ArrayList<String> result;
	
	public static void main(String[] args) throws IOException{
		com = new ArrayList<Combine>();
		opps = new ArrayList<String>();
		result = new ArrayList<String>();
		readFile(args[0]);
		print();
	}
	
	private static void print() throws IOException {
		int t = 1;
		BufferedWriter out = new BufferedWriter(new FileWriter("output_Magicka"));
		for(Iterator<String> i = result.iterator(); i.hasNext();){
			char[] res = i.next().toCharArray();
			String s = Arrays.toString(res);
			System.out.println("Case #" + t + ": " + s);
			out.write("Case #" + t + ": " + s+"\n");
			t++;
		}
		out.close();
	}

	public static void readFile(String fileName) throws FileNotFoundException{
		Scanner input = new Scanner(new File(fileName));
		T = Integer.parseInt(input.nextLine());
		while(input.hasNextLine()){
			Scanner line = new Scanner(input.nextLine());
			int C = line.nextInt();
			readComb(C, line);
			int O = line.nextInt();
			readOpps(O, line);
			int N = line.nextInt();
			String inv = line.next();
			String res = invoke(inv);
			result.add(res);
			clear();
		}
	}
	
	private static String invoke(String inv) {
		char[] chas = inv.toCharArray();
		String str = "";
		for(char i : chas){
			str += i;
			String c = "";
			if(str.length()>=2){
				c = hasComb(str, com);
				if(c!=null) str = combine(str, c);
			}
			if(hasOppose(str, opps)) str = "";
		}
		return str;
	}
	
	public static boolean hasOppose(String str, ArrayList<String> A){
		int n = str.length();
		if(n<=1) return false;
		char x = str.charAt(0);
		char y = str.charAt(n-1);
		String xy = x + "" + y;
		String yx = y + "" + x;
		for(Iterator<String> i = A.iterator(); i.hasNext();){
			String t = i.next();
			if(xy.equals(t) || yx.equals(t)) return true;
		}
		String sub = str.substring(1, n);
		return hasOppose(sub, A);
	}
	
	public static String hasComb(String str, ArrayList<Combine> A){
		int n = str.length();
		char x = str.charAt(n-2);
		char y = str.charAt(n-1);
		String xy = x + "" + y;
		String yx = y + "" + x;
		for(Iterator<Combine> i = A.iterator(); i.hasNext();){
			Combine t = i.next();
			if(xy.equals(t.pair) || yx.equals(t.pair)) return t.replace;
		}
		return null;
	}
	
	public static String combine(String str, String comb){
		int n = str.length();
		str = str.substring(0, n-2);
		str += comb;
		return str;
	}

	private static void readOpps(int o, Scanner line) {
		for(int i = 0; i<o; i++){
			opps.add(line.next());
		}
	}

	public static void readComb(int C, Scanner line){
		for(int i = 0; i<C; i++){
			String s = line.next();
			com.add(new Combine(s));
		}
	}
	
	public static void clear(){
		opps.clear();
		com.clear();
	}
}
