import java.util.ArrayList;
import java.util.Iterator;

public class Robot{
	public int type;
	public BotTrust bt;
	public ArrayList<Command> com;
	public int pos = 1, dest = 1;
	public int time;
	public Iterator<Command> itr;
	Command current;
	private boolean isFinish;
	
	public Robot(int type, BotTrust bt, ArrayList<Command> com){
		this.type = type;
		this.bt = bt;
		this.com = com;
		this.itr = com.iterator();
		if(itr.hasNext()) nextCommand();
		else isFinish = true;
	}
	
	public void nextStep(){
		if(isFinish){
			waitForTurn();
			return;
		}
		if(Math.abs(pos - dest)!=0){
			walk();
		}else{
			if(bt.isTurn(type)){
				press();
			}else{
				waitForTurn();
			}
		}
	}
	
	private void nextCommand(){
		current = itr.next();
		dest = current.pos;
	}
	
	public void walk() {
		if(pos<dest) pos++;
		else if(pos>dest) pos--;
		//System.out.println("Robot" + type + " Move to button " + pos);
		resetButton();
	}

	public void press() {
		//System.out.println("Robot" + type + " Push button " + pos);
		if(type==0) bt.bottonPushed = true;
		if(itr.hasNext()) nextCommand();
		else isFinish = true;
		bt.nextCommand();
	}

	public void waitForTurn(){
		resetButton();
		//System.out.println("Robot" + type + " stay at button " + pos);
	}

	public boolean isFinish() {
		return isFinish;
	}
	
	public void resetButton(){
		if(bt.bottonPushed && type==1) bt.bottonPushed = false; 
	}
}
