import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class TicTacToe {
	static File file;
	static int[][] table;
	static int counter;
	static final int X = 0;
	static final int O = 1;
	static final int T = 2;
	static final int Dot = 3;

	public static void main(String[] args) {
		int game = 1;
		int allroundgame;
		file = new File(args[0]);
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader(file));
			String str = br.readLine();
			allroundgame = Integer.valueOf(str);
			str = br.readLine();
			while (str != null) {
				System.out.print("Case #" + String.valueOf(game) + ": ");
				table = new int[4][4];
				if (str.equals("")) {
					str = br.readLine();
				}
				for (int i = 0; i < 4; ++i) {
					parseTableLine(table[i], str);
					str = br.readLine();
				}
				solve(table);
				++game;
				if(game>allroundgame){
					break;
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private static void solve(int[][] t) {
		boolean complete = true;
		for (int i = 0; i < 4; ++i) {
			for (int j = 0; j < 4; ++j) {
				if (t[i][j] == Dot) {
					complete = false;
					break;
				}
			}
			if (!complete) {
				break;
			}
		}
		if (check(t[0][0], t[0][1], t[0][2], t[0][3])) {
			return;
		}
		if (check(t[1][0], t[1][1], t[1][2], t[1][3])) {
			return;
		}
		if (check(t[2][0], t[2][1], t[2][2], t[2][3])) {
			return;
		}
		if (check(t[3][0], t[3][1], t[3][2], t[3][3])) {
			return;
		}
		if (check(t[0][0], t[1][0], t[2][0], t[3][0])) {
			return;
		}
		if (check(t[0][1], t[1][1], t[2][1], t[3][1])) {
			return;
		}
		if (check(t[0][2], t[1][2], t[2][2], t[3][2])) {
			return;
		}
		if (check(t[0][3], t[1][3], t[2][3], t[3][3])) {
			return;
		}
		if (check(t[0][0], t[1][1], t[2][2], t[3][3])) {
			return;
		}
		if (check(t[3][0], t[2][1], t[1][2], t[0][3])) {
			return;
		}
		if (complete) {
			printDraw();
		} else {
			printNotCompleted();
		}
	}

	private static void printNotCompleted() {
		System.out.println("Game has not completed");
	}

	private static void printDraw() {
		System.out.println("Draw");
	}

	private static boolean check(int i, int j, int k, int l) {
		int[] count = new int[4];
		++count[i];
		++count[j];
		++count[k];
		++count[l];
		if (count[T] == 1) {
			if (count[X] == 3) {
				printXWon();
				return true;
			} else if (count[O] == 3) {
				printOWon();
				return true;
			}
		} else {
			if (count[X] == 4) {
				printXWon();
				return true;
			} else if (count[O] == 4) {
				printOWon();
				return true;
			}
		}
		return false;
	}

	private static void printOWon() {
		System.out.println("O won");
	}

	private static void printXWon() {
		System.out.println("X won");
	}

	private static void parseTableLine(int[] table, String str) {
		for (int i = 0; i < 4; ++i) {
			switch (str.charAt(i)) {
			case 'X':
				table[i] = X;
				break;
			case 'O':
				table[i] = O;
				break;
			case 'T':
				table[i] = T;
				break;
			case '.':
				table[i] = Dot;
				break;
			}
		}
	}
}
