import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;

public class Osmos {
	public static void main(String[] args) {
		File file;
		int rounds;
		int[] pair = new int[2]; // 最初の数・個数
		int[] list;
		int turn = 1;
		file = new File(args[0]);
		BufferedReader br = null;
		File output = new File(args[1]);
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader(file));
			bw = new BufferedWriter(new FileWriter(output));
			String str = br.readLine();
			rounds = Integer.valueOf(str);
			str = br.readLine();
			while (str != null) {
				bw.write("Case #" + String.valueOf(turn) + ": ");
				parsePairLine(pair, str);
				str = br.readLine();
				list = new int[pair[1]];
				parseLine(list, str);
				bw.write(String.valueOf(solve(pair[0], list)));
				++turn;
				if (turn > rounds) {
					break;
				}
				str = br.readLine();
				bw.newLine();
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if (bw != null) {
				try {
					bw.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private static int solve(int first, int[] list) {
		int length = list.length;
		if (first == 1) {
			return length;
		}
		Arrays.sort(list);
		int cnt = 0;
		for (int i = 0; i < length - 1; ++i) {
			if (first > list[i]) {
				first += list[i];
			} else {
				return cnt + recursionSolve(first, list, i, length);
			}
		}
		if (first <= list[length - 1]) {
			++cnt;
		}
		return cnt;
	}

	private static int recursionSolve(int first, int[] list, int start, int end) {
		for (; start < end - 1; ++start) {
			if (first > list[start]) {
				first += list[start];
			} else {
				int x = end - start;
				int y = recursionSolve(2 * first - 1, list, start, end);
				return x <= y ? x : ++y;
			}
		}
		if (first <= list[start]) {
			return 1;
		}
		return 0;
	}

	private static void parseLine(int[] list, String str) {
		String[] s = str.split(" ");
		for (int i = 0; i < s.length; ++i) {
			list[i] = Integer.valueOf(s[i]);
		}
	}

	private static void parsePairLine(int[] pair, String str) {
		String[] s = str.split(" ");
		pair[0] = Integer.valueOf(s[0]);
		pair[1] = Integer.valueOf(s[1]);
	}
}
