import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class Lawnmower {
	public static void main(String[] args) {
		File file;
		int[][] lawn;
		int allround;
		int turn = 1;
		file = new File(args[0]);
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader(file));
			String str = br.readLine();
			allround = Integer.valueOf(str);
			str = br.readLine();
			while (str != null) {
				System.out.print("Case #" + String.valueOf(turn) + ": ");
				lawn = newLawn(str);
				str = br.readLine();
				for (int i = 0; i < lawn.length; ++i) {
					parseLawnLine(lawn[i], str);
					str = br.readLine();
				}
				solve(lawn);
				++turn;
				if (turn > allround) {
					break;
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

	private static void solve(int[][] lawn) {
		for (int i = 1; i < 100; ++i) {
			if (!solving(lawn, i)) {
				printN();
				return;
			}
		}
		printY();
		return;
	}

	private static void printY() {
		System.out.println("YES");
	}

	private static void printN() {
		System.out.println("NO");
	}

	private static boolean solving(int[][] lawn, int boader) {
		boolean[][] map = new boolean[lawn.length][lawn[0].length];
		for (int i = 0; i < map.length; ++i) {
			for (int j = 0; j < map[0].length; ++j) {
				map[i][j] = lawn[i][j] <= boader;
			}
		}
		if (checkRound(map)) {
			return true;
		}
		return false;
	}

	private static boolean checkRound(boolean[][] map) {
		boolean[][] table = new boolean[map.length][map[0].length];
		boolean flag;
		for (int i = 0; i < map.length; ++i) {
			flag = true;
			for (int j = 0; j < map[0].length; ++j) {
				if (!map[i][j]) {
					flag = false;
					break;
				}
			}
			if (flag) {
				writeHorizontal(table[i]);
			}
		}
		for (int i = 0; i < map[0].length; ++i) {
			flag = true;
			for (int j = 0; j < map.length; ++j) {
				if (!map[j][i]) {
					flag = false;
					break;
				}
			}
			if (flag) {
				writeVertical(table, i);
			}
		}
		return compare(map, table);
	}

	private static boolean compare(boolean[][] map, boolean[][] table) {
		for (int i = 0; i < map.length; ++i) {
			for (int j = 0; j < map[0].length; ++j) {
				if (map[i][j] != table[i][j]) {
					return false;
				}
			}
		}
		return true;
	}

	private static void writeVertical(boolean[][] table, int i) {
		for (int j = 0; j < table.length; ++j) {
			table[j][i] = true;
		}
	}

	private static void writeHorizontal(boolean[] table) {
		for (int i = 0; i < table.length; ++i) {
			table[i] = true;
		}
	}

	private static void parseLawnLine(int[] table, String str) {
		String[] s = str.split(" ");
		for (int i = 0; i < table.length; ++i) {
			table[i] = Integer.valueOf(s[i]);
		}
	}

	private static int[][] newLawn(String str) {
		String[] s = str.split(" ");
		return new int[Integer.valueOf(s[0])][Integer.valueOf(s[1])];
	}
}
