import java.util.*;
import java.io.*;
public class Round2ProbA 
{
	public static HashMap<String,Integer> cache = new HashMap<String,Integer>();
	public static void main(String[] args) throws Exception
	{
		String file = "Round2/A-small-attempt0.in";

		BufferedReader br = new BufferedReader(new FileReader(file));
		PrintWriter writer = new PrintWriter("Round2/outputAsm.txt", "UTF-8");

		int T = Integer.parseInt(br.readLine());
		for(int test=0;test<T;test++)
		{
			String[] parts = br.readLine().split(" ");
			int R = Integer.parseInt(parts[0]);
			int C = Integer.parseInt(parts[1]);
			char[][] grid = new char[R][C];
			for(int r = 0; r<R; r++)
			{
				String line = br.readLine();
				for(int c = 0; c<C; c++)
				{
					grid[r][c] = line.charAt(c);
				}
			}
			int res = pegman(R,C,grid);
			if(res>=0)
				writer.println("Case #" + (test+1) + ": "+res);
			else
				writer.println("Case #" + (test+1) + ": IMPOSSIBLE");	
			System.out.println(test);
		}
		writer.close();
	}
	
	
	public static int pegman(int R, int C, char[][] grid)
	{
		int count = 0;
		Location.R=R;
		Location.C=C;
		for(int r=0;r<R;r++)
		{
			for(int c=0;c<C;c++)
			{
				if(grid[r][c]!='.')
				{
					List<Location> changes = canBecomeLoop(new Location(r,c,'.'),R,C,grid,new HashSet<Location>());
					if(changes==null) return -1;
					int amount = changes.size();
					//System.out.println(r+","+c+":"+amount);
					count+=amount;
					
					for(Location loc:changes)
					{
						grid[loc.row][loc.col]=loc.dir;
					}
				}
			}
		}
		return count;
	}
	public static List<Location> canBecomeLoop(Location loc, int R, int C, char[][] grid, HashSet<Location> visited) //returns number of changes made, or -1
	{
		
		int r = loc.row;
		int c = loc.col;
		//System.out.println("Entering "+r+","+c);
		if(!loc.inbounds())
		{
			return null;
		}
		if(visited.contains(loc))
		{
			return new ArrayList<Location>();
		}
		
		if(grid[r][c]=='.')
		{
			visited.add(loc);
			List<Location> res = canBecomeLoop(loc.inc(grid[r][c]),R,C,grid,visited);
			visited.remove(loc);
			return res;
		}
		else
		{
			visited.add(loc);
			List<Location> temp = canBecomeLoop(loc.inc(grid[r][c]),R,C,grid,visited);
			//System.out.println(":"+r+","+c+":"+temp);
			if(temp!=null)
			{
				visited.remove(loc);
				return temp;
			}
			else
			{
				char[] choices = new char[]{'<','>','^','v'};
				int min = -1;
				char best = ';';
				List<Location> bestSoFar = null;
				char orig = grid[r][c];
				
				for(char ch:choices)
				{
					if(ch!=orig)
					{
						grid[r][c]=ch;
						List<Location> possible = canBecomeLoop(loc.inc(grid[r][c]),R,C,grid,visited);
						if(possible!= null) 
						{
							if(ch!=orig)
								possible.add(new Location(r,c,best));;
						
							if(best==';' || possible.size()<min)
							{
								best=ch;
								bestSoFar=possible;
								min = possible.size();
							}
						}
					}
				}
				visited.remove(loc);
				grid[r][c]=orig;
				
				return bestSoFar;
			}
		}
	}
	

	/*
	public static int canBecomeLoop(int r, int c, int R, int C, char[][] grid, int[][] loops, char dir) //returns number of changes made, or -1
	{
		char ch = grid[r][c];
		if(ch!='.' && !isLoop(r,c,R,C,grid,loops))
		{
			if(r>0 && !isLoop(r-1,c,R,C,grid,loops))
			{
				count++;
			}
			else 
		}
	}
	
	public static boolean isLoop(int r, int c, char dir, int R, int C, char[][] grid, int[][][] loops) //2 is loop, 1 is not-loop, 0 is unknown
	{
		if(loops[r][c][toInt(dir)]!=0)
		{
			return loops[r][c][toInt(dir)];
		}
		int r1=r;
		int c1=c;
		int r2=r;
		int c2=c;
		int dir1=dir;
		int dir2=dir;
		int res = 0;
		do
		{
			if(loops[r2][c2][toInt(dir2)]!=0)
			{
				res = loops[r2][c2][toInt(dir2)];
				break;
			}
			if(loops[r1][c1][toInt(dir1)]!=0)
			{
				res = loops[r1][c1][toInt(dir1)];
				break;
			}
			
			char ch1 = grid[r1][c1];
			r1 = incR(r1,ch1,dir1);
			c1 = incC(c1,ch1,dir1);
			dir1=incDir(ch1,dir1);
			
			ch1 = grid[r1][c1];
			r1 = incR(r1,ch1,dir1);
			c1 = incC(c1,ch1,dir1);
			dir1=incDir(ch1,dir1);
			
			char ch2 = grid[r2][c2];
			r2 = incR(r2,ch2,dir2);
			c2 = incC(c2,ch2,dir2);
			dir2=incDir(ch2,dir2);
		}
		while(!(r1==r2 && c1==c2) && r1>=0 && c1>=0 && r1<R && c1<C && r2>=0 && c2>=0 && r12<R && c2<C);
		
		if(res==0)
		{
			if(r1==r2 && c1==c2)
			{
				res = 2;
			}
			else
			{
				res = 1;
			}
		}
		
		r1=r;
		r2=r;
		c1=c;
		c2=c;
		dir1=dir;
		dir2=dir;
		do
		{
			if(loops[r2][c2][toInt(dir)]!=0)
			{
				break;
			}
			
			loops[r2][c2]=res;
			loops[r1][c1]=res;
			
			char ch1 = grid[r1][c1];
			r1 = incR(r1,ch1,dir1);
			c1 = incC(c1,ch1,dir1);
			dir1=incDir(ch1,dir1);
			
			ch1 = grid[r1][c1];
			r1 = incR(r1,ch1,dir1);
			c1 = incC(c1,ch1,dir1);
			dir1=incDir(ch1,dir1);
			
			char ch2 = grid[r2][c2];
			r2 = incR(r2,ch2,dir2);
			c2 = incC(c2,ch2,dir2);
			dir2=incDir(ch2,dir2);
		}
		while(!(r1==r2 && c1==c2) && r1>=0 && c1>=0 && r1<R && c1<C && r2>=0 && c2>=0 && r2<R && c2<C);
		
		return res;
	}*/
}

class Location
{
	int row;
	int col;
	char dir;
	static int R;
	static int C;
	
	public boolean inbounds()
	{
		return row<R && row>=0 && col<C && col>=0;
	}
	public Location(int r, int c, char d)
	{
		row = r;
		col = c;
		dir = d;
	}
	public boolean equals(Object o)
	{
		Location l = (Location)o;
		return row==l.row && col==l.col;
	}
	public int hashCode()
	{
		return (row*100+col)*5+toInt(dir);
	}
	
	public Location inc(char ch)
	{
		return new Location(incR(row,ch,dir),incC(col,ch,dir),incDir(ch,dir));
	}
	
	public static int incR(int r, char ch, char dir)
	{
		if(ch=='v') return r+1;
		if(ch=='^') return r-1;
		if(ch=='.' && dir!='.') return incR(r,dir,dir);
		return r;
	}
	public static int incC(int c, char ch, char dir)
	{
		if(ch=='>') return c+1;
		if(ch=='<') return c-1;
		if(ch=='.' && dir!='.') return incC(c,dir,dir);
		return c;
	}
	public static char incDir(char ch, char dir)
	{
		if(ch=='.') return dir;
		return ch;
	}
	public static int toInt(char dir)
	{
		if(dir=='.')return 0;
		if(dir=='v')return 1;
		if(dir=='^')return 2;
		if(dir=='<')return 3;
		if(dir=='>')return 4;
		return -1;
	}
}