package com.ajasuja.codejam.y2016.round0;

import java.util.ArrayList;
import java.util.List;

import com.ajasuja.codejam.AbstractCodeJamSolution;

public class CoinJam extends AbstractCodeJamSolution {

	public void run(String inputFilePath, String outputFilePath) {
		List<String> positions = new ArrayList<String>();
		List<String> inputLines = this.readInput(inputFilePath);
		for (int i=1; i< inputLines.size(); i++) {
			String[] stringArray = inputLines.get(i).trim().split(" ");
			positions.add(this.jamCoins(Integer.valueOf(stringArray[0]), Integer.valueOf(stringArray[1])));
		}
		this.write(outputFilePath, this.decorateOutput(positions));
	}

	public String jamCoins(int numberSize, int numberOfJamCoins) {
		StringBuilder formattedOutputBuilder = new StringBuilder();
		List<String> jamCoinsWithDivisor = new ArrayList<String>();
		List<String> allCoins = permutationCoins(numberSize);
		for (String eachCoin : allCoins) {
			if (jamCoinsWithDivisor.size() == numberOfJamCoins) {
				break;
			}
			StringBuilder coinOutputBuilder = new StringBuilder();
			List<Long> coinValueInAllBases = calculateBases(eachCoin);
			boolean isAnyPrime = isAnyPrime(coinValueInAllBases);
			if (isAnyPrime) {
				continue;
			}
			coinOutputBuilder.append(eachCoin).append(" ");
			for (Long coinValue : coinValueInAllBases) {
				coinOutputBuilder.append(getDivisor(coinValue)).append(" ");
			}
			jamCoinsWithDivisor.add(coinOutputBuilder.toString().trim());
		}
		formattedOutputBuilder.append("\n");
		for (String jamCoinWithDivisor : jamCoinsWithDivisor) {
			formattedOutputBuilder.append(jamCoinWithDivisor).append("\n");
		}
		return formattedOutputBuilder.toString();
	}

	private boolean isAnyPrime(List<Long> coinValueInAllBases) {
		for (Long coinValueInCurrentBase : coinValueInAllBases) {
			if (isPrime(coinValueInCurrentBase)) {
				return true;
			}
		}
		return false;
	}

	private boolean isPrime(Long coinValueInCurrentBase) {
	    //check if n is a multiple of 2
	    if (coinValueInCurrentBase%2==0) return false;
	    //if not, then just check the odds
	    for(long i=3;i*i<=coinValueInCurrentBase;i+=2) {
	        if(coinValueInCurrentBase%i==0)
	            return false;
	    }
	    return true;
	}

	private long getDivisor(Long coinValue) {
	    //check if n is a multiple of 2
	    if (coinValue % 2 == 0)  {
	    	return 2;
	    }
	    //if not, then just check the odds
	    for(long i=3;i*i<=coinValue;i+=2) {
	        if(coinValue%i==0)
	            return i;
	    }
	    return -1;
	}

	private List<Long> calculateBases(String eachCoin) {
		List<Long> bases = new ArrayList<Long>();
		for (int i=2; i<=10; i++) {
			bases.add(calculateBase(eachCoin, i));
		}
		return bases;
	}

	public Long calculateBase(String coin, int base) {
		long coinValueInGivenBase = 0;
		for (int i=0,j=coin.length() - 1; i< coin.length(); i++, j--) {
			char coinValueAtIthPosition = coin.charAt(i);
			if (coinValueAtIthPosition == '1') {
				coinValueInGivenBase += Math.pow(base, j);				
			}
		}
		return coinValueInGivenBase;
	}

	private List<String> permutationCoins(int numberSize) {
		List<String> coinPermutations = new ArrayList<String>();
		if (numberSize > 16) {
			List<String> coinPermuationsExcludingBorders = permutationCoinsRecursively(14);
			for (String coinPermuationExcludingBorders  : coinPermuationsExcludingBorders) {
				StringBuilder coinPermutationBuilder = new StringBuilder();
				coinPermutationBuilder.append("1");
				for (int i= 0; i< numberSize - 16; i++) {
					coinPermutationBuilder.append("0");
				}
				coinPermutationBuilder.append(coinPermuationExcludingBorders);
				coinPermutationBuilder.append("1");
				coinPermutations.add(coinPermutationBuilder.toString());
			}
		} else {
			List<String> coinPermuationsExcludingBorders = permutationCoinsRecursively(numberSize - 2);			
			for (String coinPermuationExcludingBorders:  coinPermuationsExcludingBorders ) {
				coinPermutations.add("1" + coinPermuationExcludingBorders +"1");
			}
		}
		return coinPermutations;
	}

	private List<String> permutationCoinsRecursively(int coinSize) {
		List<String> allPermutations = new ArrayList<String>();
		if (coinSize == 1) {
			allPermutations.add("0");
			allPermutations.add("1");
			return allPermutations;
		}
		List<String> permutationsExcludingCurrentCoin = permutationCoinsRecursively(coinSize - 1);
		for (String permutationExcludingCurrentCoin : permutationsExcludingCurrentCoin) {
			allPermutations.add("0" + permutationExcludingCurrentCoin);
			allPermutations.add("1" + permutationExcludingCurrentCoin);
		}
		System.out.println(allPermutations);
		return allPermutations;
	}
}
