package com.ajasuja.codejam.y2016.round0;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.ajasuja.codejam.AbstractCodeJamSolution;

public class CountingSheep extends AbstractCodeJamSolution {

	private void init(Map<Integer, Integer> digit2Count) {
		digit2Count.put(0, 1);
		digit2Count.put(1, 1);
		digit2Count.put(2, 1);
		digit2Count.put(3, 1);
		digit2Count.put(4, 1);
		digit2Count.put(5, 1);
		digit2Count.put(6, 1);
		digit2Count.put(7, 1);
		digit2Count.put(8, 1);
		digit2Count.put(9, 1);
	}
	
	public void run(String inputFilePath, String outputFilePath) {
		List<String> positions = new ArrayList<String>();
		List<String> inputLines = this.readInput(inputFilePath);
		for (int i=1; i< inputLines.size(); i++) {
			Long originalNumber = this.toLong(inputLines.get(i).trim());
			positions.add(this.getLastNumber(originalNumber));
		}
		this.write(outputFilePath, this.decorateOutput(positions));
	}

	public String getLastNumber(long inputNumber) {
		Map<Integer, Integer> digit2Count = new HashMap<Integer, Integer>();
		this.init(digit2Count);
		long multipliedNumber = inputNumber;
		if (inputNumber == 0) {
			return "INSOMNIA";
		}
		for (int i=1; multipliedNumber < Long.MAX_VALUE; i++) {
			List<Integer> digits = this.getDigits(multipliedNumber);
			for (Integer digit : digits) {
				if(digit2Count.containsKey(digit)) {
					digit2Count.remove(digit);
					if (digit2Count.isEmpty()) {
						return String.valueOf(multipliedNumber);
					}
				}
			}
			multipliedNumber = inputNumber * i;
		}
		return "INSOMNIA";
	}

	private List<Integer> getDigits(long inputNumber) {
		List<Integer> digits = new ArrayList<Integer>();
		while(inputNumber > 0) {
			int lastDigit = (int) inputNumber % 10;
			inputNumber = inputNumber / 10;
			digits.add(lastDigit);
		}
		return digits;
	}
}
