package com.ajasuja.codejam.y2016.round1a;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.ajasuja.codejam.AbstractCodeJamSolution;

public class RankFile extends AbstractCodeJamSolution {

	public void run(String inputFilePath, String outputFilePath) {
		List<String> positions = new ArrayList<String>();
		List<String> inputLines = this.readInput(inputFilePath);
		int lineNumber = 0;
		int numberOfTest = Integer.parseInt(inputLines.get(lineNumber).trim());
		++lineNumber;
		for (int i=0; i< numberOfTest; i++) {
			int matrixSize = Integer.parseInt(inputLines.get(lineNumber).trim());
			++lineNumber;
			List<String> inputMatrixMissingOne = new ArrayList<String>(2 * matrixSize - 1);
			for (int j=0; j< 2 * matrixSize - 1; j++) {
				inputMatrixMissingOne.add(inputLines.get(lineNumber).trim());
				++lineNumber;
			}
			positions.add(this.rankFile(inputMatrixMissingOne));
		}
		this.write(outputFilePath, this.decorateOutput(positions));
	}

	private String rankFile(List<String> inputMatrixMissingOne) {
		Map<Integer, Integer> odds = new HashMap<Integer, Integer>();
		Map<Integer, Integer> evens = new HashMap<Integer, Integer>();
		for (String inputRowOrColumn : inputMatrixMissingOne) {
			List<Integer> heights = this.adapt(inputRowOrColumn);
			for (Integer height : heights) {
				if (evens.containsKey(height)) {
					odds.put(height, evens.get(height) + 1);
					evens.remove(height);
				} else if (odds.containsKey(height)) {
					evens.put(height, odds.get(height) + 1);
					odds.remove(height);
				} else {
					odds.put(height, 1);
				}
			}
		}
		StringBuilder outputBuilder = new StringBuilder();
//		Set<Integer> oddHeights = odds.keySet();
		List<Integer> oddHeightsList = new ArrayList<Integer>();
		for (Integer height : odds.keySet()) {
			oddHeightsList.add(height);
		}
		Collections.sort(oddHeightsList);
		for (Integer sortedHeight : oddHeightsList) {
			outputBuilder.append(sortedHeight).append(" ");
		}
		return outputBuilder.toString().trim();
	}

	private List<Integer> adapt(String inputRowOrColumn) {
		String[] heightsInString = inputRowOrColumn.split(" ");
		List<Integer> heights = new ArrayList<Integer>();
		for (String heightInString: heightsInString) {
			heights.add(Integer.valueOf(heightInString.trim()));
		}
		return heights;
	}

	
}
