package candysplitting;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class CandySplitting {

	private static int MAX_BINARY = 21;
	private static int MAX_SEAN_SUM = 0;
	
	public static void main(String[] args) {
		Scanner sc = null;
		try {
			sc = new Scanner(new File("bin/candysplitting/C-small-attempt0.in"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		int T = sc.nextInt();
		
		for(int i = 0; i < T; i++) {
			int N = sc.nextInt();
			int[] Ci = new int[N];
			int[][] binaryCi = new int[N][MAX_BINARY];
			
			for(int j = 0; j < N; j++)
			{
				Ci[j] = sc.nextInt();
				binaryCi[j] = getBinary(Ci[j]);
			}
			
			MAX_SEAN_SUM = 0;
			System.out.println("Case #" + (i + 1) + ": " + execute(Ci, binaryCi));
		}
	}

	private static int[] getBinary(int number) {
		int[] returnBinary = new int[MAX_BINARY];
		
		for(int i = 0; i < returnBinary.length; i++) {
			int j = number % 2;
			if(j == 0)
				number = number / 2;
			else if(j == 1)
				number = (number - 1) / 2;
			
			returnBinary[returnBinary.length - i - 1] = j;
		}
		
		return returnBinary;
	}

	private static String execute(int[] Ci, int[][] binaryCi) {
		
		// For 1 candy
		for(int i = 0; i < Ci.length; i++) {
			
			int candyCounter = 0;
			int[] patrickSum = new int[MAX_BINARY]; 
			int seanSum = 0;
			
			for(int j = 0; j < Ci.length - 1; j++) {
				while(candyCounter == i)
					candyCounter++;
				
				//Patrick Sum
				for(int k = 0; k < MAX_BINARY; k++) {
					if(patrickSum[k] + binaryCi[candyCounter][k] == 0)
						patrickSum[k] = 0; 
					else if(patrickSum[k] + binaryCi[candyCounter][k] == 1)
						patrickSum[k] = 1;
					else if(patrickSum[k] + binaryCi[candyCounter][k] == 2)
						patrickSum[k] = 0; 
				}
				// Sean Sum
				seanSum += Ci[candyCounter];
				
				candyCounter++;
			}
			
			boolean bFlag = true;
			for(int k = 0; k < MAX_BINARY; k++) {
				if(patrickSum[k] != binaryCi[i][k]) {
					bFlag = false;
					break;
				}
			}
			
			if(bFlag) {
				if(MAX_SEAN_SUM < seanSum)
					MAX_SEAN_SUM = seanSum;
			}
		}
		
		if(MAX_SEAN_SUM > 0)
			return MAX_SEAN_SUM + "";
		else
			return "NO";
	}

}
