package bottrust;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class BotTrust {

	public static void main(String[] args) {
		Scanner sc = null;
		try {
			sc = new Scanner(new File("bin/bottrust/input.in"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		int T = sc.nextInt();
		
		for(int i = 0; i < T; i++) {
			int N = sc.nextInt();
			String[] buttonSequence = new String[N];
			int[] O = new int[N];
			int[] B = new int[N];
			int counterO = 0;
			int counterB = 0;
			int counterbuttonSequence = 0;
			
			for(int j = 0; j < N; j++)
			{
				String robot = sc.next();
				buttonSequence[counterbuttonSequence++] = robot;
				
				if(robot.trim().equalsIgnoreCase("O"))
					O[counterO++] = sc.nextInt();
				else
					B[counterB++] = sc.nextInt();
			}
			
			System.out.println("Case #" + (i + 1) + ": " + execute(buttonSequence, O, B));
		}
	}

	private static int execute(String[] buttonSequence, int[] O, int[] B) {
		
		int pressCounter = 0;
		int robotPositionO = 1;
		int robotPositionB = 1;
		int counterO = 0;
		int counterB = 0;
		int timeElapsed = 0;

		do {
			String buttonToPressBy = buttonSequence[pressCounter];
			
			if(buttonToPressBy.equalsIgnoreCase("O")) {
				int buttonToPressByO = O[counterO++];
				int buttonToPressInFutureByB = 0;
				if(B.length > counterB)
					buttonToPressInFutureByB = B[counterB];
				
				if(robotPositionO == buttonToPressByO) {
					timeElapsed++;
					pressCounter++;
					
					if(buttonToPressInFutureByB != 0)
					if(robotPositionB == buttonToPressInFutureByB) {
						//Stand by B
					}
					else if(robotPositionB < buttonToPressInFutureByB) {
						//Move B by one to right
						robotPositionB++;
					}
					else if(robotPositionB > buttonToPressInFutureByB) {
						//Move B by one to left
						robotPositionB--;
					}
				}
				else if(robotPositionO < buttonToPressByO) {
					timeElapsed += buttonToPressByO - robotPositionO;
					timeElapsed++;
					pressCounter++;
					
					if(buttonToPressInFutureByB != 0)
					if(robotPositionB == buttonToPressInFutureByB) {
						//Stand by B
					}
					else if(robotPositionB < buttonToPressInFutureByB) {
						//Move B to right
						if((buttonToPressInFutureByB - robotPositionB) <=  (buttonToPressByO - robotPositionO)) {
							robotPositionB = buttonToPressInFutureByB;
						}
						else if((buttonToPressInFutureByB - robotPositionB) >  (buttonToPressByO - robotPositionO)) {
							robotPositionB += buttonToPressByO - robotPositionO;
							robotPositionB++;
						}
					}
					else if(robotPositionB > buttonToPressInFutureByB) {
						//Move B to left
						if((robotPositionB - buttonToPressInFutureByB) <=  (buttonToPressByO - robotPositionO)) {
							robotPositionB = buttonToPressInFutureByB;
						}
						else if((robotPositionB - buttonToPressInFutureByB) >  (buttonToPressByO - robotPositionO)) {
							robotPositionB -= buttonToPressByO - robotPositionO;
							robotPositionB--;
						}
					}
					
					robotPositionO = buttonToPressByO;
				}
				else if(robotPositionO > buttonToPressByO) {
					timeElapsed += robotPositionO - buttonToPressByO;
					timeElapsed++;
					pressCounter++;
					
					if(buttonToPressInFutureByB != 0)
					if(robotPositionB == buttonToPressInFutureByB) {
						//Stand by B
					}
					else if(robotPositionB < buttonToPressInFutureByB) {
						//Move B to right
						if((buttonToPressInFutureByB - robotPositionB) <=  (robotPositionO - buttonToPressByO)) {
							robotPositionB = buttonToPressInFutureByB;
						}
						else if((buttonToPressInFutureByB - robotPositionB) >  (robotPositionO - buttonToPressByO)) {
							robotPositionB += robotPositionO - buttonToPressByO;
							robotPositionB++;
						}
					}
					else if(robotPositionB > buttonToPressInFutureByB) {
						//Move B to left
						if((robotPositionB - buttonToPressInFutureByB) <=  (robotPositionO - buttonToPressByO)) {
							robotPositionB = buttonToPressInFutureByB;
						}
						else if((robotPositionB - buttonToPressInFutureByB) >  (robotPositionO - buttonToPressByO)) {
							robotPositionB -= robotPositionO - buttonToPressByO;
							robotPositionB--;
						}
					}
					
					robotPositionO = buttonToPressByO;
				}
			}
			else
			{
				int buttonToPressByB = B[counterB++];
				int buttonToPressInFutureByO = 0;
				if(O.length > counterO)
					buttonToPressInFutureByO = O[counterO];
				
				if(robotPositionB == buttonToPressByB) {
					timeElapsed++;
					pressCounter++;
					
					if(buttonToPressInFutureByO != 0)
					if(robotPositionO == buttonToPressInFutureByO) {
						//Stand by B
					}
					else if(robotPositionO < buttonToPressInFutureByO) {
						//Move B by one to right
						robotPositionO++;
					}
					else if(robotPositionO > buttonToPressInFutureByO) {
						//Move B by one to left
						robotPositionO--;
					}
				}
				else if(robotPositionB < buttonToPressByB) {
					timeElapsed += buttonToPressByB - robotPositionB;
					timeElapsed++;
					pressCounter++;
					
					if(buttonToPressInFutureByO != 0)
					if(robotPositionO == buttonToPressInFutureByO) {
						//Stand by B
					}
					else if(robotPositionO < buttonToPressInFutureByO) {
						//Move B to right
						if((buttonToPressInFutureByO - robotPositionO) <=  (buttonToPressByB - robotPositionB)) {
							robotPositionO = buttonToPressInFutureByO;
						}
						else if((buttonToPressInFutureByO - robotPositionO) >  (buttonToPressByB - robotPositionB)) {
							robotPositionO += buttonToPressByB - robotPositionB;
							robotPositionO++;
						}
					}
					else if(robotPositionO > buttonToPressInFutureByO) {
						//Move B to left
						if((robotPositionO - buttonToPressInFutureByO) <=  (buttonToPressByB - robotPositionB)) {
							robotPositionO = buttonToPressInFutureByO;
						}
						else if((robotPositionO - buttonToPressInFutureByO) >  (buttonToPressByB - robotPositionB)) {
							robotPositionO -= buttonToPressByB - robotPositionB;
							robotPositionO--;
						}
					}
					
					robotPositionB = buttonToPressByB;
				}
				else if(robotPositionB > buttonToPressByB) {
					timeElapsed += robotPositionB - buttonToPressByB;
					timeElapsed++;
					pressCounter++;
					
					if(buttonToPressInFutureByO != 0)
					if(robotPositionO == buttonToPressInFutureByO) {
						//Stand by B
					}
					else if(robotPositionO < buttonToPressInFutureByO) {
						//Move B to right
						if((buttonToPressInFutureByO - robotPositionO) <=  (robotPositionB - buttonToPressByB)) {
							robotPositionO = buttonToPressInFutureByO;
						}
						else if((buttonToPressInFutureByO - robotPositionO) >  (robotPositionB - buttonToPressByB)) {
							robotPositionO += robotPositionB - buttonToPressByB;
							robotPositionO++;
						}
					}
					else if(robotPositionO > buttonToPressInFutureByO) {
						//Move B to left
						if((robotPositionO - buttonToPressInFutureByO) <=  (robotPositionB - buttonToPressByB)) {
							robotPositionO = buttonToPressInFutureByO;
						}
						else if((robotPositionO - buttonToPressInFutureByO) >  (robotPositionB - buttonToPressByB)) {
							robotPositionO -= robotPositionB - buttonToPressByB;
							robotPositionO--;
						}
					}
					
					robotPositionB = buttonToPressByB;
				}
			}
			
		}while(pressCounter < buttonSequence.length);
		
		return timeElapsed;
	}
	

}
