import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.StandardCharsets;
import java.util.Scanner;

public class A {
    static final String file = "A-large";

    public static void main(String[] args) throws Exception {
        try (Scanner scanner = new Scanner(new FileInputStream(file + ".in"));
             Writer writer = new OutputStreamWriter(new FileOutputStream(file + ".out"), StandardCharsets.UTF_8)) {
            int T = scanner.nextInt();
            for (int t = 1; t <= T; t++) {
                writer.write("Case #" + t + ": ");
                solve(scanner, writer);
                writer.write("\n");
            }
        }
    }

    private static boolean[] parseRow(String row) {
        boolean[] result = new boolean[row.length()];
        for (int i = 0; i < result.length; i++) {
            result[i] = row.charAt(i) == '+';
        }
        return result;
    }

    private static void solve(Scanner scanner, Writer writer) throws Exception {
        boolean[] row = parseRow(scanner.next());
        int k = scanner.nextInt();
        int flips = 0;
        int i = 0;
        while (i <= row.length - k) {
            if (!row[i]) {
                flip(row, i, k);
                flips++;
            }
            i++;
        }
        if (allTrue(row)) {
            writer.write(String.valueOf(flips));
        } else {
            writer.write("IMPOSSIBLE");
        }
    }

    private static void flip(boolean[] row, int pos, int k) {
        for (int i = 0; i < k; i++) {
            row[i + pos] = !row[i + pos];
        }
    }
    private static boolean allTrue(boolean [] row) {
        for (int i = 0; i < row.length; i++) {
            if (!row[i]) {
                return false;
            }
        }
        return true;
    }
}
