import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.StandardCharsets;
import java.util.*;

public class C {
    static final String file = "C-large";

    public static void main(String[] args) throws Exception {
        try (Scanner scanner = new Scanner(new FileInputStream(file + ".in"));
             Writer writer = new OutputStreamWriter(new FileOutputStream(file + ".out"), StandardCharsets.UTF_8)) {
            int T = scanner.nextInt();
            for (int t = 1; t <= T; t++) {
                writer.write("Case #" + t + ": ");
                solve(scanner, writer);
                writer.write("\n");
            }
        }
    }

    private static void solve(Scanner scanner, Writer writer) throws Exception {
        long N = scanner.nextLong();
        long K = scanner.nextLong();
        Intervals ins = new Intervals();
        ins.addInterval(N, 1);
        long len = 0;
        long i = 0;
        while (i < K) {
            len = ins.queue.poll();
            Interval in = ins.map.remove(len);
            // split
            if (len % 2 == 0) {
                ins.addInterval(len / 2 - 1, in.count);
                ins.addInterval(len / 2, in.count);
            } else {
                ins.addInterval(len / 2, in.count * 2);
            }
            i += in.count;
        }
        if (len % 2 == 0) {
            writer.write((len / 2) + " " + (len / 2 - 1));
        } else {
            writer.write((len / 2) + " " + (len / 2));
        }
    }

    static class Intervals {
        Map<Long, Interval> map = new HashMap<>();
        PriorityQueue<Long> queue = new PriorityQueue<>(Collections.reverseOrder());
        void addInterval(long len, long count) {
            Interval in = map.get(len);
            if (in == null) {
                in = new Interval(len, count);
                map.put(len, in);
                queue.add(len);
            } else {
                in.count += count;
            }
        }
    }
    static class Interval implements Comparable<Interval> {
        final long len;
        long count;

        Interval(long len, long count) {
            this.len = len;
            this.count = count;
        }

        @Override
        public int compareTo(Interval o) {
            return Long.compare(o.len, len);
        }
    }
}
