import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.StandardCharsets;
import java.util.Scanner;

public class B {
    static final String file = "B-large";

    public static void main(String[] args) throws Exception {
        try (Scanner scanner = new Scanner(new FileInputStream(file + ".in"));
             Writer writer = new OutputStreamWriter(new FileOutputStream(file + ".out"), StandardCharsets.UTF_8)) {
            int T = scanner.nextInt();
            for (int t = 1; t <= T; t++) {
                writer.write("Case #" + t + ": ");
                solve(scanner, writer);
                writer.write("\n");
            }
        }
    }

    private static byte[] parseRow(String row) {
        byte[] result = new byte[row.length() + 1];
        for (int i = 0; i < row.length(); i++) {
            result[i + 1] = Byte.parseByte(row.substring(i, i + 1));
        }
        return result;
    }

    private static void solve(Scanner scanner, Writer writer) throws Exception {
        byte[] num = parseRow(scanner.next());
        int p = 0;
        while (p + 1 < num.length && num[p] <= num[p + 1]) {
            p++;
        }
        if (p < num.length - 1) {
            while (num[p - 1] == num[p]) {
                p--;
            }
            num[p]--;
            for (int i = p + 1; i < num.length; i++) {
                num[i] = 9;
            }
        }
        boolean printed = false;
        for (int i = 0; i < num.length; i++) {
            if (printed || num[i] != 0) {
                printed = true;
                writer.write(String.valueOf(num[i]));
            }
        }
        if (!printed) {
            writer.write("0");
        }
    }

    private static void flip(boolean[] row, int pos, int k) {
        for (int i = 0; i < k; i++) {
            row[i + pos] = !row[i + pos];
        }
    }
    private static boolean allTrue(boolean [] row) {
        for (int i = 0; i < row.length; i++) {
            if (!row[i]) {
                return false;
            }
        }
        return true;
    }
}
