import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.charset.StandardCharsets;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class A {
    static final String file = "A";

    public static void main(String[] args) throws Exception {
        try (Scanner scanner = new Scanner(new FileInputStream(file + ".in"));
             Writer writer = new OutputStreamWriter(new FileOutputStream(file + ".out"), StandardCharsets.UTF_8)) {
            int T = scanner.nextInt();
            for (int t = 1; t <= T; t++) {
                writer.write("Case #" + t + ": ");
                solve(scanner, writer);
                writer.write("\n");
            }
        }
    }

    private static double cross(Horse h1, Horse h2) {
        if (h1.S <= h2.S) {
            return Double.MAX_VALUE;
        }
        double t = (h2.K - h1.K) * 1.0 / (h1.S - h2.S);
        return t * h1.S + h1.K;
    }

    private static void solve(Scanner scanner, Writer writer) throws Exception {
        int D = scanner.nextInt();
        int N = scanner.nextInt();
        Horse[] horses = new Horse[N];
        for (int i = 0; i < N; i++) {
            int K = scanner.nextInt();
            int S = scanner.nextInt();
            horses[i] = new Horse(K, S);
        }
        Arrays.sort(horses, (h1, h2) -> Integer.compare(h1.K, h2.K));
        for (int i = N - 1; i >= 0; i--) {
            Horse h = horses[i];
            h.speedChange = D;
            for (int j = i + 1; j < N; j++) {
                double cr = cross(h, horses[j]);
                h.speedChange = Math.min(h.speedChange, cr);
            }
        }
        double maxS = Double.MAX_VALUE;
        for (int i = 0; i < N; i++) {
            Horse h = horses[i];
            double t = (h.speedChange - h.K) / h.S;
            double s = h.speedChange / t;
            maxS = Math.min(s, maxS);
        }
        Locale.setDefault(Locale.US);
        writer.write(String.format("%.6f", maxS));
    }

    private static class Horse {
        final int K;
        final int S;
        double speedChange;

        private Horse(int k, int s) {
            K = k;
            S = s;
        }
    }
}
