import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class CandySplitting {
	
	public static void main(String[] args){
		
		if(args.length == 0 || args[0].isEmpty()){
			System.out.println("please enter filename");
			System.exit(0);
		}
		
		File input = new File(args[0]);
		
		Map<Integer, List<Integer>> tasksMap = readInput(input);
			/*new HashMap<Integer, List<Integer>>(){{
				put(1, Arrays.asList(5, 5));
			}};*/
		
		List<Integer> numbers = new ArrayList<Integer>(tasksMap.keySet());
		Collections.sort(numbers);
		outer: for(Integer lineNumber: numbers) {
			Integer[] arr = tasksMap.get(lineNumber).toArray(new Integer[]{});
			if(!firstCheck(arr)){
				System.out.println(String.format("Case #%s: NO", lineNumber));
			} else {
				for(int i: arr){
					Integer[] sub = new Integer[]{i};
					Integer[] result = subArray(arr, sub);
					if(checkArr(result, sub)){
						System.out.println(String.format("Case #%s: %s", lineNumber, sum(result, true)));
						continue outer;
					}
				}
				System.out.println(String.format("Case #%s: ERROR", lineNumber));
			}			
		}		
	}

	private static Integer[] subArray(Integer[] arr, Integer[] sub) {
		List<Integer> result = new ArrayList<Integer>(Arrays.asList(arr));
		for(int i : sub){
			int index;
			if((index = result.indexOf(i)) > -1){
				result.remove(index);
			}
		}
		return result.toArray(new Integer[]{});
	}

	private static boolean checkArr(Integer[] arr1, Integer[] arr2) {
		return sum(arr1) == sum(arr2);
	}

	private static boolean firstCheck(Integer[] arr) {
		return sum(arr) == 0;
	}
	
	private static int sum(Integer[] arr) {
		return sum(arr, false);
	}
	
	private static int sum(Integer[] arr, boolean normal) {
		int result = 0;
		for(int i: arr){
			result = normal ? result + i : result ^ i;
			//System.out.println(result);
		}
		return result;
	}
	
	private static Map<Integer, List<Integer>> readInput(File input) {

		BufferedReader reader = null;

		try {
			reader = new BufferedReader(new FileReader(input));
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		Map<Integer, List<Integer>> result = new HashMap<Integer, List<Integer>>();

		try {
			String str = reader.readLine();			
			// System.out.println("reading line: " + 0 + " value:" + str);
			int lineNum = 1;
			while ((str = reader.readLine()) != null) {
				// System.out.println("reading line: " + lineNum + " value:" +
				// str);
				str = reader.readLine();
				
				List<Integer> resultList = new ArrayList<Integer>();
				String[] strArr = str.split(" ");
				for (int i = 0; i < strArr.length; i++) {
					int value = Integer.parseInt(strArr[i]);
					resultList.add(value);
				}
				result.put(lineNum, resultList);
				lineNum++;
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			try {
				reader.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		// System.out.println(result);

		return result;
	}
	
}