import java.io.*;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.*;

public class TaskB {

    static double C,F,X, countFarms, countCookies, totalSec;

    static void solveMultiTest() throws IOException {
        int testCases = nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            out.println("Case #" + testCase + ": " + solve());
        }
    }

    static String solve() throws IOException {
        TaskB ob = new TaskB();
        NumberFormat decimalFormat = new DecimalFormat("#.0000000");
        countFarms = 0;
        countCookies = 0;
        totalSec = 0;
        C = nextDouble();
        F = nextDouble();
        X = nextDouble();

        while (countCookies != X){
            if(estimate()){
                buy();
            } else {
                proccess();
            }
        }



        return decimalFormat.format(totalSec).replaceAll(",", ".");
    }


    static double cookiesPerSecond(Double farms){
        if(farms == null){
           farms = countFarms;
        }
        return 2 + farms * F;
    }

    static double estimateBuying(){
        double required = C - countCookies;
        double production = cookiesPerSecond(null);
        double seconds = required/production;
        return seconds;
    }

    static double buy(){
        double sec;
        sec = estimateBuying();
        countFarms+=1;
        totalSec += sec;
        return sec;
    }

    static boolean estimate(){
        double target, prod1, prod2, sec1, sec2;
        target = X-countCookies;
        prod1 = cookiesPerSecond(null);
        prod2 = cookiesPerSecond(countFarms + 1);
        sec1 = target/prod1;
        sec2 = estimateBuying() + (target/prod2);
        return sec1>sec2;
    }

    static double proccess(){
       double required, prod, sec;
       required = X-countCookies;
       prod = cookiesPerSecond(null);
       sec = required/prod;
       countCookies += required;
       totalSec += sec;
       return  sec;
    }

    static BufferedReader br;
    static StringTokenizer st;
    static PrintWriter out;

    public static void main(String[] args) throws IOException {
        InputStream input = System.in;
        PrintStream output = System.out;
        File file = new File("b.in");
        if (file.exists() && file.canRead()) {
            input = new FileInputStream(file);
            output = new PrintStream(new File("b.out"));
        }
        br = new BufferedReader(new InputStreamReader(input));
        out = new PrintWriter(output);
        solveMultiTest();
        out.close();
    }

    static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            String line = br.readLine();
            if (line == null) {
                return null;
            }
            st = new StringTokenizer(line);
        }
        return st.nextToken();
    }

    static String nextLine() throws IOException {
        String line=null;
        line = br.readLine();
        System.out.println(line);
        return line;
    }

}
