import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Scanner;

public class TaskB {
    public static void main(String[] args) {
        try {
            Scanner scanner = new Scanner(new FileReader("src/taskb.in"));
            FileWriter fstream = new FileWriter("taskb.out");
            BufferedWriter out = new BufferedWriter(fstream);
            int t = scanner.nextInt();
            for (int i = 0; i < t; i++) {
                String s = scanner.next();
                out.write("Case #" + (i + 1) + ": " + solution(s) + "\n");
            }
            out.close();
        } catch (Exception e) {
            System.err.println("Error:" + e.getMessage());
        }
    }


    public static String solution(String str) {
        StringBuilder result = new StringBuilder();


        int repeatIndex = findWrongIndex(str);

        if (repeatIndex == -1) return str;

        result.append(str.substring(0, repeatIndex));
        if (result.length() != 0 || (char) (str.charAt(repeatIndex) - 1) != '0') {
            result.append((char) (str.charAt(repeatIndex) - 1));
        }

        result.append(String.format("%0" + (str.length() - 1 - repeatIndex) + "d", 0).replace("0","9"));
        return result.toString();
    }

    private static int findWrongIndex(String str) {
        int index = 0;
        while (index < str.length() - 1 && (int) str.charAt(index) <= (int) str.charAt(index + 1)) {
            index++;
        }
        if (index >= str.length() - 1) {
            return -1;
        }
        int wrongIndex = (int) str.charAt(index) >= (int) str.charAt(index + 1) ? index : -1;
        while (wrongIndex > 0 && str.charAt(wrongIndex) == str.charAt(wrongIndex - 1)) {
            wrongIndex--;
        }
        return wrongIndex;
    }

}
