import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Scanner;


public class TaskA {
    public static void main(String[] args) {
        try {
            Scanner scanner = new Scanner(new FileReader("src/taska.in"));
            FileWriter fstream = new FileWriter("taska.out");
            BufferedWriter out = new BufferedWriter(fstream);

            int t = scanner.nextInt();
            assert t >= 1 && t <= 100;
            String s;
            int k;
            for (int i = 0; i < t; i++) {
                s = scanner.next();
                k = scanner.nextInt();
                out.write("Case #" + (i + 1) + ": " + solution(s, k) + "\n");

            }
            out.close();
        } catch (Exception e) {
            System.err.println("Error:" + e.getMessage());
        }
    }

    public static String solution(String str, int k) {
        int count = 0;
        String tmpStr = str;
        while (!tmpStr.isEmpty() && tmpStr.length() >= k) {
            tmpStr = getNextCycleStr(tmpStr);
            if (tmpStr.length() >= k) {
                count++;
                tmpStr = flip(tmpStr, k);
            }
        }

        return tmpStr.isEmpty() ? String.valueOf(count) : "IMPOSSIBLE";
    }


    private static String getNextCycleStr(String str) {
        int index = 0;
        while (index < str.length() && str.charAt(index) == '+') {
            index++;
        }
        return str.substring(index);
    }

    private static String flip(String str, int k) {
        char[] strArray = str.toCharArray();
        for (int i = 0; i < k; i++) {
            strArray[i] = str.charAt(i) == '+' ? '-' : '+';
        }
        return String.valueOf(strArray);
    }

}