package net.marvinseidl.gcj.qualification.pancake;

import net.marvinseidl.gcj.qualification.Case;
import net.marvinseidl.gcj.qualification.Log;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * Created by Marvin Seidl on 08.04.2017.
 */
public class Pancake {

    int T;
    int K;
    int bestFlips;


    public void run(File file) throws FileNotFoundException {
        Scanner sc = new Scanner(file);

        T = sc.nextInt();

        for (int i = 0; i < T; i++) {
            Log.d("Testcase: " + (i + 1));
            String s = sc.next();
            K = sc.nextInt();
            Log.d(s + " " + K);

            int flips = 0;

            for(int j = 0; j < s.length() - K;j++){
                if(canFlip(s,j)){
                    Log.d("Canflip at: " + j);
                    if(s.charAt(j) == '-'){
                        Log.d("Needs flip!");
                        s = flipString(s,j);
                        flips++;
                    }
                }

                Log.d(s);
            }

            if(needsFlip(s,s.length() - K)){
                s = flipString(s,s.length() - K);
                flips++;
            }

            Log.d(s);

            if(isHappy(s)){
                System.out.println(Case.string(i + 1,String.valueOf(flips)));
            }else{
                System.out.println(Case.string(i + 1,"IMPOSSIBLE"));
            }



        }


    }

    private void flips(String s){
        Log.d("Flips " + K);
        Log.d(s);





    }

    /*
    private void f(int i,int flips){
        if(bestFlips <= flips)
            return;
        if(isHappy(s)){
            if(bestFlips > flips)
                bestFlips = flips;
            return;
        }


        if(canFlip(s,i)){
            if(needsFlip(s,i)){
                String flipped = flipString(s,i);

                f(flipped,0,flips + 1);
            }else{
                f(s,i + 1,flips);
            }
        }
    }
    */

    private String flipString(String s,int index){
        Log.d("Flipping at: " + index);
        StringBuffer sb = new StringBuffer(s.length());
        sb.append(s.substring(0,index));
        for(int i = index; i < index + K;i++){
            char c = s.charAt(i);
            sb.append(c == '+' ? '-' : '+');
        }
        sb.append(s.substring(index + K));
        return sb.toString();
    }

    private boolean canFlip(String s,int index){
        return index >= 0 && index <= (s.length() - K);
    }

    private boolean needsFlip(String s,int index){
        for(int i = index; i < index + K; i++){
            if(s.charAt(i) == '-')
                return true;
        }
        return false;
    }
    private boolean isHappy(String s){
        for(int i = 0; i < s.length(); i++){
            if(s.charAt(i) == '-')
                return false;
        }
        return true;
    }
}
