package net.marvinseidl.gcj.qualification.stalls;

import net.marvinseidl.gcj.qualification.Case;
import net.marvinseidl.gcj.qualification.Log;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by Marvin Seidl on 08.04.2017.
 */
public class Stalls {

    boolean[] stalls;
    int[] distancemin;
    int[] distancemax;

    int N;

    public void run(File in, File out) throws IOException {
        Scanner scanner = new Scanner(in);
        BufferedWriter writer = new BufferedWriter(new FileWriter(out));

        int T = scanner.nextInt();

        for (int i = 0; i < T; i++) {
            Log.d("Case: " + (i+1));
            long n = scanner.nextLong();
            long k = scanner.nextLong();


            long ceiled = pow2(log2(k + 1));
            long joba = (long)Math.pow(2, Math.round(Math.ceil(Math.log(k + 0.5)/Math.log(2))));

            if(ceiled != joba)
                Log.d("ERROR!!!!!!");

             Log.d("l: " + ceiled + " ceiled: " + joba);

            n -= ceiled / 2 - 1;

            double averageSlotSize = (double)n / ((double)ceiled / 2);
            double decimal = averageSlotSize - Math.floor(averageSlotSize);

            long slotSize;

            if(decimal * ((double)ceiled / 2) < ((double)k - ((double)ceiled / 2 - 1))){
                slotSize = (long) Math.floor(averageSlotSize);
            }else{
                slotSize = (long) Math.ceil(averageSlotSize);
            }

            slotSize--;

            long min = (long) Math.floor((double)slotSize / 2);
            long max = (long) Math.ceil((double)slotSize / 2);


            writer.write(Case.string(i + 1,max + " " + min));
            writer.newLine();

        }

        writer.flush();

    }

    private long log2(long value){
        return 64 - Long.numberOfLeadingZeros(value - 1);
    }

    private long pow2(long value){
        return 1L << value;
    }


    /*
    public void run(File in,File out) throws IOException {
        Scanner scanner = new Scanner(in);
        BufferedWriter writer = new BufferedWriter(new FileWriter(out));

        int T = scanner.nextInt();

        for (int i = 0; i < T; i++) {
            System.out.println("TestCase: " + i);

            N = scanner.nextInt() + 2;
            int k = scanner.nextInt();

        //    Log.d("N: " + N + " k:" + k);

            stalls = new boolean[N];
            distancemin = new int[N];
            distancemax = new int[N];

            stalls[0] = true;
            stalls[stalls.length - 1] = true;


            printArrays();

            computeDistance(0,N-1);

            printArrays();


            for (int j = 0; j < k; j++) {
                int pos = findPos();

               // Log.d("Update: " + pos);
                stalls[pos] = true;

                if(j == k - 1){
                    Log.d("Last: " + distancemax[pos] + " " + distancemin[pos]);
                    writer.write(Case.string(i + 1,distancemax[pos] + " " + distancemin[pos]));
                    writer.newLine();
                }

               //computeDistance(0,N-1);
                updateDistance(pos);



              printArrays();



            }

            Log.d("");
            Log.d("");
        }

        writer.flush();
        writer.close();
    }
    */

    private void computeDistance(int left,int right){
        int last = left;

        for(int i = last; i < N;i++){
            if(stalls[i]){
                last = i;
            }
            distancemin[i] = i - last - 1;
            distancemax[i] = distancemin[i];
        }

        last = right;


        for(int i = last; i >= 0;i--){
            if(stalls[i]){
                last = i;
            }

            int newDis = last - i - 1;
            distancemin[i] = Math.min(distancemin[i],newDis);
            distancemax[i] = Math.max(distancemax[i],newDis);
        }
    }

    private void updateDistance(int pos){
        int left = 0;
        for(int i = pos - 1; i >= 0;i--){
            if(stalls[i]) {
                left = i;
                break;
            }
        }

        int right = 0;
        for(int i = pos + 1; i < N;i++){
            if(stalls[i]) {
                right = i;
                break;
            }
        }

        computeDistance(left,right);
    }

    private int findPos(){
        int max = -1;

        List<Integer> maxPos = new ArrayList<>();

        for(int i = 0 ; i < N;i++){
            if(distancemin[i] > max){
                max = distancemin[i];
                maxPos.clear();
                maxPos.add(i);
            }else if(distancemin[i] == max){
                maxPos.add(i);
            }
        }

        max = -1;

        int pos = 0;

        for (Integer maxPo : maxPos) {
            if(distancemax[maxPo] > max){
                max = distancemax[maxPo];
                pos = maxPo;
            }
        }

        return pos;
    }

    private void printArrays(){
        StringBuilder sb = new StringBuilder();
        for (boolean stall : stalls) {
            sb.append(' ');
            sb.append(stall ? 'o' : '.');
        }
        Log.d(sb.toString());

        sb = new StringBuilder();
        for (int i : distancemin) {
            sb.append(String.format("%2d",i));
        }

        Log.d(sb.toString());

        sb = new StringBuilder();
        for (int i : distancemax) {
            sb.append(String.format("%2d",i));
        }

        Log.d(sb.toString());
    }

}
