import java.util.*;

public class C {
    private int L, X;
    private String str;

    public C(int L, int X, String str) {
        this.L = L;
        this.X = X;
        this.str = str;
    }

    private String[][] quaternions = {{"1", "i", "j", "k"}, {"i", "-1", "k", "-j"}, {"j", "-k", "-1", "i"}, {"k", "j", "-i", "-1"}};
    private String[] letters = {"i", "j", "k"};

    public void printQuaternions() {
        for (int i = 0; i < quaternions.length; ++i) {
            for (int j = 0; j < quaternions[i].length; ++j) {
                System.out.print(quaternions[i][j]+" ");
            }
            System.out.println("");
        }
    }

    public void testQuaternions() {
        for (int i = 0; i < quaternions.length; ++i) {
            for (int j = 0; j < quaternions[i].length; ++j) {
                System.out.println(getReverseIndex(i) +" X "+ getReverseIndex(j)+" = "+quaternions[i][j]);
            }
        }
    }

    public boolean calculate() {
        if (L*X < 3) return false;
        int foundIndex = 0;
        String word = "1";
        boolean foundOnce = false;
        boolean isNegative = false;

        for (int i = 0; i < X; ++i) {
            for (int j = 0; j < L; ++j) {
                //System.out.println("LEFT: "+word);
                //System.out.println("RIGHT: "+str.charAt(j));
                word = multiply(word, String.valueOf(str.charAt(j)));  
                //System.out.println("RESULT: "+word);
                boolean negativeWord = checkNegative(word);
                if (negativeWord) {
                    word = word.substring(1);
                    isNegative = isNegative ^ negativeWord;
                }
                //System.out.println("FINAL RESULT: "+word);
                //System.out.println("BOOLEAN: "+String.valueOf(isNegative)+"\n");
                if (word.equals(letters[foundIndex])) {
                    //System.out.println("FOUND: "+letters[foundIndex]);
                    ++foundIndex;
                    word = "1";
                    if (foundIndex == 3) {
                        isNegative = !isNegative;
                        foundIndex = 0;
                        foundOnce = true;
                    }
                //System.out.println("BOOLEAN: "+String.valueOf(isNegative)+"\n");
                }
                // Final stretch
                if (i == X-1 && j == L-1) {
                    for (int k = 0; k <foundIndex; ++k) {
                        word = multiply(word, letters[k]);
                    }
                    boolean checkWord = checkNegative(word);
                    if (checkWord) {
                        word = word.substring(1);
                        isNegative = isNegative ^ checkWord;
                    }
                    //System.out.println("FINAL STRECTCH: "+word);
                    //System.out.println("FINAL BOOLEAN: "+String.valueOf(isNegative)+"\n");
                }
            }
        }
        if (foundOnce == true && isNegative == true && word.equals("1")) return true;
        return false;
    }

    int getIndex(String a) {
        switch(a) {
            case "1":
                return 0;
            case "i":
                return 1;
            case "j":
                return 2;
            case "k":
                return 3;
            default:
                return -1;
        }
    }

    String getReverseIndex(int index) {
        switch (index) {
            case 0:
                return "1";
            case 1:
                return "i";
            case 2:
                return "j";
            case 3:
                return "k";
        }
        return "INVALID INDEX";
    }

    boolean checkNegative(String a) {
        if (a.charAt(0) == '-')
            return true;
        return false;
    }

    String multiply(String a, String b) {
       boolean isANegative = checkNegative(a);
       boolean isBNegative = checkNegative(b);
       if (isANegative)
           a = a.substring(1);
       if (isBNegative)
           b = b.substring(1);
       int aIndex = getIndex(a);
       int bIndex = getIndex(b);
       String result = quaternions[aIndex][bIndex];
       boolean negative = isANegative ^ isBNegative;
       boolean isResultNegative = checkNegative(result);
       negative = negative ^ isResultNegative;
       if (isResultNegative && !negative)
           result = result.substring(1);
       else if (!isResultNegative && negative)
           result = "-"+result;
       return result;
    }

    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int t = 1; t <= T; ++t) {
            C myC = new C(in.nextInt(), in.nextInt(), in.next());
            System.out.println("Case #"+t+": "+(myC.calculate()? "YES":"NO"));
        }
    }
}
