package codejam;

import java.io.File;
import java.io.FileInputStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * Created by IntelliJ IDEA.
 * User: alan
 * Date: 5/7/11
 * Time: 11:50 AM
 * To change this template use File | Settings | File Templates.
 */
public class ProblemC {

    public static void main(String[] args) throws Exception {
      solveProblem(readFile("/home/alan/Downloads/C-large.in"));
//      solveProblem(
//          "2\n" +
//              "5\n" +
//              "1 2 3 4 5\n" +
//              "3\n" +
//              "3 5 6");

    }

  private static String readFile(String filePath) throws Exception {
    File f = new File(filePath);
    FileInputStream fios = new FileInputStream(new File(filePath));
    byte[] buffer = new byte[(int) (f.length())];
    int numRead = fios.read(buffer);
    assert(numRead == buffer.length);
    assert(fios.read(new byte[10]) == -1);
    return new String(buffer);
  }

  public static void solveProblem(String fileContents) {
    String[] lines = fileContents.split("\n");
    int numCases = Integer.parseInt(lines[0]);
    assert lines.length == (numCases * 2) + 1;
    for (int i = 1; i < lines.length; i+=2) {
      solveTestCase(lines[i], lines[i + 1], ((i - 1) / 2) + 1 );
    }
  }

  private static void solveTestCase(String line1, String line2, int caseNumber) {
    int numPieces = Integer.parseInt(line1);
    String[] values = line2.split(" ");
    assert numPieces == values.length;
    int solution = solveProblem(values);
    if (solution == -1) {
      System.out.println("Case #" + caseNumber+ ": NO");
    } else {
      System.out.println("Case #" + caseNumber+ ": " + solution);
    }
  }

  private static int solveProblem(String[] valueStrings) {
    int[] values = new int[valueStrings.length];
    for (int i = 0; i < valueStrings.length; i++) {
      values[i] = Integer.parseInt(valueStrings[i]);
    }

    int xorResult = 0;
    for (int i = 0; i < values.length; i++) {
      xorResult = xorResult ^ values[i];
    }

    if (xorResult == 0) {
      // Problem can be solved
      return reallySolveProblem(values);
    } else {
      return -1;
    }
  }

  private static int reallySolveProblem(int[] values) {
    _max = -1;
    solveScenario(values, 0, values.length);
    return _max;
  }

  private static int _max;

  private static void solveScenario(int[] pCandy, int sCandyXor, int numPiecesForPatrick) {
//    System.out.print("Looking at scenario (" +numPiecesForPatrick + "): ");
//    for (int i = 0; i < pCandy.length; i++) {
//      System.out.print("" + pCandy[i] + " ");
//    }
//    System.out.println();

    int possibleMax = computeSum(pCandy);
    // Patrick's situation can't possibly improve, so just bail out
    if (_max > possibleMax) {
      return;
    }

    if (numPiecesForPatrick < pCandy.length) {
      if (sCandyXor == computeXor(pCandy)) {
        // It's a legal scenario, so set the max
        _max = possibleMax;
      }
    }

    if (numPiecesForPatrick > 1) {
      for (int i = 0; i < pCandy.length; i++) {
        if (pCandy[i] != -1) {
          int[] candyCopy = new int[pCandy.length];
          System.arraycopy(pCandy, 0, candyCopy, 0, pCandy.length);
          int newXor = sCandyXor ^ pCandy[i];
          candyCopy[i] = -1;
          solveScenario(candyCopy, newXor, numPiecesForPatrick - 1);
        }
      }
    }
  }

  private static int computeXor(int[] candy) {
    int result = 0;
    for (int i = 0; i < candy.length; i++) {
      if (candy[i] > -1) {
        result = result ^ candy[i];
      }
    }
    return result;
  }

  private static int computeSum(int[] candy) {
    int result = 0;
    for (int i = 0; i < candy.length; i++) {
      if (candy[i] > -1) {
        result = result + candy[i];
      }
    }
    return result;
  }

  private static boolean isEqualToSean(int pCandyXor, int[] seansCandy) {
    int seanXor = 0;
    for (int i = 0; i < seansCandy.length; i++) {
      if (seansCandy[i] > -1) {
        seanXor = seanXor ^ seansCandy[i];
      }
    }

    return seanXor == pCandyXor;
  }

//  private static int solveScenario(int pCandySum, int pCandyXor, int[] remainingCandy) {
//    int max = -1;
//    if (isEqualToSean(pCandyXor, remainingCandy)) {
//      max = pCandySum;
//    }
//
//    for (int i = 0; i < remainingCandy.length; i++) {
//      if (remainingCandy[i] != -1) {
//        int[] candyCopy = new int[remainingCandy.length];
//        System.arraycopy(remainingCandy, 0, candyCopy, 0, remainingCandy.length);
//        int newSum = pCandySum + remainingCandy[i];
//        int newXor = pCandyXor ^ remainingCandy[i];
//        candyCopy[i] = -1;
//        int newMax = solveScenario(newSum, newXor, candyCopy);
//        if (newMax > max) {
//          max = newMax;
//        }
//      }
//    }
//
//    return max;
//  }
//
//  private static boolean isEqualToSean(int pCandyXor, int[] seansCandy) {
//    int seanXor = 0;
//    for (int i = 0; i < seansCandy.length; i++) {
//      if (seansCandy[i] > -1) {
//        seanXor = seanXor ^ seansCandy[i];
//      }
//    }
//
//    return seanXor == pCandyXor;
//  }
}
