package codejam;

/**
 * Created by IntelliJ IDEA.
 * User: alan
 * Date: 5/7/11
 * Time: 10:45 AM
 * To change this template use File | Settings | File Templates.
 */
public class ProblemA {

  public static void main(String[] args) {
    processInput(
        "20\n" +
            "4 O 2 B 1 B 2 O 4\n" +
            "3 O 5 O 8 B 100\n" +
            "2 B 2 B 1\n" +
            "4 O 26 B 26 B 67 O 69\n" +
            "10 O 16 B 17 O 62 B 63 B 40 O 86 O 61 B 12 O 86 B 36\n" +
            "10 B 1 B 40 B 15 O 85 O 96 B 82 B 29 B 43 O 50 O 54\n" +
            "8 O 27 B 27 O 10 B 45 B 69 O 38 O 4 B 31\n" +
            "10 O 1 B 1 O 1 O 1 O 1 B 1 B 1 O 1 O 1 B 1\n" +
            "5 B 8 B 7 B 77 O 66 O 94\n" +
            "8 O 7 O 99 B 83 B 14 O 72 O 64 B 92 O 87\n" +
            "6 B 68 B 67 B 88 B 86 O 72 O 63\n" +
            "9 B 96 O 22 O 1 B 65 B 26 O 84 O 63 O 67 O 75\n" +
            "6 B 29 O 31 B 43 O 45 O 56 B 58\n" +
            "1 B 1\n" +
            "10 O 100 O 1 O 100 O 1 O 100 O 1 O 100 O 1 O 100 O 1\n" +
            "4 B 21 O 23 B 44 O 46\n" +
            "5 B 63 O 45 B 15 O 96 O 89\n" +
            "10 O 45 B 41 O 75 B 47 O 83 B 44 O 70 B 80 O 51 B 44\n" +
            "10 B 29 O 29 O 66 B 68 O 96 B 98 B 57 O 54 O 23 B 89\n" +
            "10 O 9 B 7 O 4 B 8 O 1 B 9 O 2 B 2 O 2 B 4");
  }

  private static void processInput(String input) {
    String[] lines = input.split("\n");
    int numCases = Integer.parseInt(lines[0]);
    assert lines.length == numCases + 1;
    for (int i = 1; i < lines.length; i++) {
      System.out.println(processTestCase(lines[i], i));
    }
  }

  private static String processTestCase(String line, int caseNumber) {
    Move[] moves = parseMoves(line);
    int minTurns = solveList(moves);
    return ("Case #" + caseNumber + ": " + minTurns);
  }

  private static Move[] parseMoves(String line) {
    String[] parts = line.split(" ");
    int numMoves = Integer.parseInt(parts[0]);
    assert parts.length == (numMoves * 2) + 1;

    Move[] results = new Move[numMoves];
    for (int i = 1; i < parts.length; i+=2) {
      Move move = new Move();
      if (parts[i].equals("O")) {
        move._bot = Bot.ORANGE;
      } else if (parts[i].equals("B")) {
         move._bot = Bot.BLUE;
      } else {
        throw new IllegalArgumentException(parts[i]);
      }

      move._square = Integer.parseInt(parts[i + 1]);
      results[(i - 1) / 2] = move;
    }

    return results;
  }

  private static int solveList(Move[] moves) {
    int orangeCurrent = 1;
    int blueCurrent = 1;
    int currentTime = 0;

    for (int i = 0; i < moves.length; i++) {
      if (moves[i]._bot == Bot.ORANGE) {
        int timeToCompleteMove = timeToMoveToSquare(orangeCurrent, moves[i]._square) + 1;
        currentTime += timeToCompleteMove;
        orangeCurrent = moves[i]._square;
        blueCurrent = moveTowardNextButton(moves, i + 1, Bot.BLUE, blueCurrent, timeToCompleteMove);
      } else {
        int timeToCompleteMove = timeToMoveToSquare(blueCurrent, moves[i]._square) + 1;
        currentTime += timeToCompleteMove;
        blueCurrent = moves[i]._square;
        orangeCurrent = moveTowardNextButton(moves, i + 1, Bot.ORANGE, orangeCurrent, timeToCompleteMove);
      }
    }

    return currentTime;
  }

  private static int timeToMoveToSquare(int current, int destination) {
    if (current > destination) {
      return current - destination;
    } else {
      return destination - current;
    }
  }

  private static int moveTowardNextButton(Move[] moves, int nextMove, Bot color, int currentSpace, int time) {
    Move nextMoveForBot = null;
    for (int i = nextMove; i < moves.length; i++) {
      if (moves[i]._bot == color) {
        nextMoveForBot = moves[i];
        break;
      }
    }

    if (nextMoveForBot == null) {
      return currentSpace;
    }

    if (nextMoveForBot._square > currentSpace) {
      if (nextMoveForBot._square - currentSpace <= time) {
        return nextMoveForBot._square;
      } else {
        return currentSpace + time;
      }
    } else if (nextMoveForBot._square < currentSpace) {
      if (currentSpace - nextMoveForBot._square <= time) {
        return nextMoveForBot._square;
      } else {
        return currentSpace - time;
      }
    } else {
      return currentSpace;
    }
  }

  private static enum Bot {
    ORANGE, BLUE;
  }

  private static class Move {
    private Bot _bot;
    private int _square;
  }
}
