package codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class Vectors {

	public static void main(String[] args) throws Exception {
	   parseFile(new File("C:/Documents and Settings/Alan/Desktop/A-large.in"));
	}
		  
	
	public static void parseFile(File f) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(f));
		int numTestCases = Integer.parseInt(reader.readLine());
		for (int i = 0; i < numTestCases; i++) {
			int numVectors = Integer.parseInt(reader.readLine());
			String[] vector1 = reader.readLine().split(" ");
			String[] vector2 = reader.readLine().split(" ");
			
			long[] vector1Int = new long[vector1.length];
			for (int j = 0; j < vector1.length; j++) {
				vector1Int[j] = Long.parseLong(vector1[j]);
			}
			
			long[] vector2Int = new long[vector2.length];
			for (int j = 0; j < vector2.length; j++) {
				vector2Int[j] = Long.parseLong(vector2[j]);
			}
			
			System.out.println("Case #" + (i + 1) + ": " + computeSmallestProduct(vector1Int, vector2Int));
		}	
	}

	public static long computeSmallestProduct(long[] vector1, long[] vector2) {
		Arrays.sort(vector1);
		Arrays.sort(vector2);
		
		long sum = 0;
		for (int i = 0; i < vector1.length; i++) {
			sum += vector1[i] * vector2[vector2.length - (i + 1)];
		}
		
		return sum;
	}
	
}
