package codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class SavingTheUniverse {
  public static void main(String[] args) throws Exception {
    parseFile(new File("C:/Documents and Settings/Alan/Desktop/A-small-attempt0.in"));
  }
  
  public static int calculateMinimumSwitches(Set<String> searchEngines, List<String> queries) {
	  int minSwitches = 0;
	  Set<String> remainingEngines = new HashSet<String>(searchEngines);
	  for (String query : queries) {
	    if (remainingEngines.size() == 1 && remainingEngines.contains(query)) {
	    	minSwitches++;
	    	remainingEngines = new HashSet<String>(searchEngines);
	    	remainingEngines.remove(query);
	    } else {
	    	remainingEngines.remove(query);
	    }
	  }
	  
	  return minSwitches;
  }
  
  private static Set<String> set(String... strs) {
	return new HashSet<String>(Arrays.asList(strs));  
  }
  
  private static List<String> list(String... strs) {
	return new ArrayList<String>(Arrays.asList(strs));  
  }
  
  public static void parseFile(File f) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(f));
		int numTestCases = Integer.parseInt(reader.readLine());
		int caseNumber = 0;
		while (true) {
			String line = reader.readLine();
			caseNumber++;
			if (line == null) {
				break;
			}
			if (caseNumber > numTestCases) {
				System.out.println("Huh?");
				break;
			}
			int numEngines = Integer.parseInt(line);
			Set<String> engines = new HashSet<String>();
			for(int i = 0; i < numEngines; i++) {
				engines.add(reader.readLine());
			}
			int numQueries = Integer.parseInt(reader.readLine());
			List<String> queries = new ArrayList<String>();
			for (int i = 0; i < numQueries; i++) {
				queries.add(reader.readLine());
			}
			
			int result = calculateMinimumSwitches(engines, queries);
			System.out.println("Case #" + caseNumber + ": " + result);
		}
		
	}
}
