package codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public class PermRLE {
	public static void parseFile(File f) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(f));
		int numTestCases = Integer.parseInt(reader.readLine());
		for (int i = 0; i < numTestCases; i++) {	
			int k = Integer.parseInt(reader.readLine());
			String s = reader.readLine();

            System.out.println("Case #" + (i + 1) + ": " + processCase(k, s));
		}
		
	}
	
	public static void main(String[] args) throws Exception {
		parseFile(new File("C:/Documents and Settings/Alan/Desktop/D-small-attempt0.in"));
	}
	
	public static String processCase(int k, String s) {
	  int minValue = Integer.MAX_VALUE;
	  
	  List<Integer> initialOptions = new ArrayList<Integer>();
	  for (int i = 0; i < k; i++) {
		  initialOptions.add(Integer.valueOf(i));
	  }
	  
	  List<List<Integer>> permutations = computePermutations(initialOptions);
	  for (List<Integer> p : permutations) {
		  int value = compress(permute(p, s)); 
		  if (value < minValue) {
			  minValue = value;
		  }
	  }
	  
	  return "" + minValue;
	}
	
	public static List<List<Integer>> computePermutations(List<Integer> options) {
		List result = new ArrayList();
		
		if (options.size() == 1) {
			result.add(new ArrayList(options));
			return result;
		}
		
		for (Integer i : options) {
			List<Integer> newOptions = new ArrayList<Integer>(options);
			newOptions.remove(i);
			List<List<Integer>> results = computePermutations(newOptions);
			for (List r : results) {
			  r.add(0, i);
			  result.add(r);
			}
		}
		return result;
	}
	
	public static String permute(List<Integer> perm, String s) {
		StringBuilder output = new StringBuilder();
	  for (int i = 0; i < s.length(); i += perm.size()) {
		for (int j = 0; j < perm.size(); j++) {
			output.append(s.charAt(i + perm.get(j).intValue()));
		}
	  }
	  return output.toString();
	}
	
	public static int compress(String s) {
		int count = 0;
		char lastChar = 0;
		for (int i = 0; i < s.length(); i++) {
		  if (lastChar != s.charAt(i)) {
		    count++;
		    lastChar = s.charAt(i);
		  }
		}
		return count;
	}
}
