package com.example.darren.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class CoinJam implements ICodeJamProblem {
    ArrayList<BigInteger> primes = new ArrayList<BigInteger>();

    public boolean isCoin(String test) {
        for(int i=2; i<=10; i++) {
            BigInteger res = new BigInteger(test,i);

            if(res.isProbablePrime(1)) {
                return false;
            }
        }
        return true;
    }

    public boolean proof(String test, OutputStream output) throws IOException {
        StringBuilder sb = new StringBuilder();
        sb.append(test);
        for(int j=2; j<=10; j++) {
            boolean bFailed = true;
            BigInteger res = new BigInteger(test,j);
            int k;
            for(k=0; k<primes.size(); k++) {
                BigInteger p = primes.get(k);
                if(res.mod(p) == BigInteger.ZERO && res != p) {
                    sb.append(" "+p);
                    bFailed = false;
                    break;
                }
            }
            if(bFailed)
                return false;
        }
        sb.append("\n");
        output.write(sb.toString().getBytes());
        return true;
    }

    public void loadPrimes() throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(new File("C:\\temp\\primes.txt")));

        String line = br.readLine();
        while(line != null)
        {
            String[] nums = line.split(" ");
            for(int i=0; i<8; i++)
            {
                BigInteger p = new BigInteger(nums[i]);
                primes.add(p);
            }
            line = br.readLine();
        }
    }

    @Override
    public void run(BufferedReader input, OutputStream output) throws IOException {
        loadPrimes();
/*
        output.write(("Case #" + 101 + ": " + isCoin("101") + "\n").getBytes());
        output.write(("Case #" + 1001 + ": " + isCoin("1001") + "\n").getBytes());
        proof("1001", output);
        proof("100011", output);
        proof("111111", output);
        proof("111001", output);
*/

        input.readLine();
        String line = input.readLine();
        int N = Integer.parseInt(line.split(" ")[0]);
        int J = Integer.parseInt(line.split(" ")[1]);

        BigInteger start = new BigInteger("1000000000000001",2);
        if(N == 32) {
            start = new BigInteger("10000000000000000000000000000001",2);
        }
        output.write(("Case #1:\n").getBytes());
        BigInteger two = new BigInteger("2");
        for(int i=0; i<J; i++) {
            String test = start.toString(2);
            while(!isCoin(test)) {
                start = start.add(two);
                test = start.toString(2);
            }

            boolean res = proof(test, output);
            if(!res)
                J++;
            start = start.add(two);
        }
    }
}
