package com.example.darren.codejam;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.util.List;

/**
 * Created by Darren on 2017.04.07.
 */
class Stall {
    public boolean empty = true;
    public int L = 0;
    public int R = 0;

    public Stall left;
    public Stall right;

    public void calc() {
        L = 0;

        Stall next = left;
        while(next.empty) {
            L++;
            next = next.left;
        }

        R = 0;

        next = right;
        while(next.empty) {
            R++;
            next = next.right;
        }
    }
}

public class Stalls implements ICodeJamProblem {
    private void calc(Stall stalls[]) {
        for(int j=1; j<stalls.length-1; j++) {
            if(stalls[j].empty){
                stalls[j].calc();
            }
        }
    }

    @Override
    public void run(BufferedReader input, OutputStream output) throws IOException {
        int T = Integer.parseInt(input.readLine());
        for(int i=0; i<T; i++) {
            String S = input.readLine();
            String parts[] = S.split(" ");
            int N = Integer.parseInt(parts[0]);
            int K = Integer.parseInt(parts[1]);

            Stall stalls[] = new Stall[N+2];
            for(int j=0; j<stalls.length; j++) {
                stalls[j] = new Stall();
            }

            stalls[0].empty = false;
            stalls[stalls.length-1].empty = false;

            for(int j=0; j<stalls.length; j++) {
                if(stalls[j].empty){
                    stalls[j].left = stalls[j-1];
                    stalls[j].right = stalls[j+1];
                }
            }

            int resMin = 0, resMax = 0;
            for(int j=0; j<K; j++) {
                calc(stalls);
                int maxMin = 0;
                int maxMax = 0;

                for(int k=0; k<stalls.length; k++) {
                    if(stalls[k].empty) {
                        int temp = Math.min(stalls[k].L, stalls[k].R);
                        if(temp > maxMin) {
                            maxMin = temp;
                        }
                    }
                }

                for(int k=0; k<stalls.length; k++) {
                    if(stalls[k].empty && Math.min(stalls[k].L, stalls[k].R) == maxMin) {
                        int temp = Math.max(stalls[k].L, stalls[k].R);
                        if(temp > maxMax) {
                            maxMax = temp;
                        }
                    }
                }

                boolean bFound = false;
                for(int k=0; k<stalls.length; k++) {
                    if(stalls[k].empty && Math.min(stalls[k].L, stalls[k].R) == maxMin && Math.max(stalls[k].L, stalls[k].R) == maxMax) {
                        bFound = true;
                        stalls[k].empty = false;
                        break;
                    }
                }

                if(bFound == false) {
                    for(int k=0; k<stalls.length; k++) {
                        if(stalls[k].empty) {
                            bFound = true;
                            stalls[k].empty = false;
                            maxMin = Math.min(stalls[k].L, stalls[k].R);
                            maxMax = Math.max(stalls[k].L, stalls[k].R);
                            break;
                        }
                    }
                }

                resMin = maxMin;
                resMax = maxMax;
            }

            output.write(("Case #" + (i + 1) + ": " + resMax + " " + resMin + "\n").getBytes());
        }
    }
}