package com.example.darren.codejam;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;

/**
 * Created by Darren on 2017.04.07.
 */
public class Flipper implements ICodeJamProblem {
    private int countOnes(int x) {
        String val = Integer.toBinaryString(x);

        int count = 0;
        for(int i=0; i<val.length(); i++) {
            if(val.charAt(i) == '1')
                count++;
        }

        return count;
    }

    private int solve(int masks[], int target, int M, int L) {
        int success = (int)Math.pow(2, L) - 1;
        int t = (int)Math.pow(2, M);
        int minFlips = Integer.MAX_VALUE;

        for(int i=0; i<t; i++) {
            int mask = 0;

            String val = Integer.toBinaryString(i);
            int count = 0;
            int k=0;
            for(int j=val.length()-1; j>=0; j--) {
                if(val.charAt(j) == '1') {
                    count++;
                    mask ^= masks[k];
                }
                k++;
            }

            if((mask ^ target) == success) {
                int temp = count;
                if(temp < minFlips)
                    minFlips = temp;
            }
        }

        if(minFlips == Integer.MAX_VALUE)
            minFlips = -1;

        return minFlips;
    }

    @Override
    public void run(BufferedReader input, OutputStream output) throws IOException {
        int T = Integer.parseInt(input.readLine());
        for(int i=0; i<T; i++) {
            String S = input.readLine();
            String parts[] = S.split(" ");
            String num = parts[0];
            int K = Integer.parseInt(parts[1]);
            int L = num.length();

            StringBuilder sb = new StringBuilder();
            for(int j=0; j<L; j++) {
                if(j<K)
                    sb.append('1');
                else
                    sb.append('0');
            }
            String starter = sb.toString();

            char s[] = num.toCharArray();
            int cnt = -2;
            for(int j=0; j<L; j++) {
                if(s[j] == '-') {
                    for(int k=0; k<K; k++) {
                        s[j+k] = s[j+k] == '-' ? '+' : '-';
                    }

                    if(cnt == -2)
                        cnt=0;
                    cnt++;
                }

                if(j+K >= L)
                    break;
            }

            for(int j=0; j<L; j++) {
                if(s[j] == '-')
                    cnt = -1;
            }

            if(cnt == -2)
                cnt = 0;

            if(cnt == -1)
                output.write(("Case #" + (i + 1) + ": " + "IMPOSSIBLE" + "\n").getBytes());
            else
                output.write(("Case #" + (i + 1) + ": " + cnt + "\n").getBytes());
        }
    }
}