package com.example.darren.codejam;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by Darren on 2017.04.14.
 */
public class Cake implements ICodeJamProblem {
    @Override
    public void run(BufferedReader input, OutputStream output) throws IOException {
        int T = Integer.parseInt(input.readLine());
        for(int i=0; i<T; i++) {
            String S = input.readLine();
            String parts[] = S.split(" ");
            int R = Integer.parseInt(parts[0]);
            int C = Integer.parseInt(parts[1]);
            char table[][] = new char[R][C];

            ArrayList<Character> c = new ArrayList<Character>();

            for(int j=0; j<R; j++) {
                String row = input.readLine();
                for(int k=0; k<C; k++) {
                    table[j][k] = row.charAt(k);
                    if(table[j][k] != '?') {
                        c.add(table[j][k]);
                    }
                }
            }

            for(int j=0; j<R; j++) {
                for(int k=0; k<C; k++) {
                    if(table[j][k] != '?')
                        spreadColumn(table, j, k, R);
                }
            }

            for(int j=0; j<R; j++) {
                for(int k=0; k<C; k++) {
                    if(table[j][k] != '?')
                        spreadRow(table, j, k, C);
                }
            }

            output.write(("Case #" + (i + 1) + ":\n").getBytes());
            for(int j=0; j<R; j++) {
                StringBuilder sb = new StringBuilder();
                for(int k=0; k<C; k++) {
                    sb.append(table[j][k]);
                }
                output.write((sb + "\n").getBytes());
            }
        }
    }

    private void spreadColumn(char[][] table, int row, int column, int height) {
        int top = row, bottom = row;
        char cell = table[row][column];

        while(top > 0) {
            top--;
            if(table[top][column] == '?') {
                table[top][column] = cell;
            }
            else {
                break;
            }
        }

        while(bottom < height - 1) {
            bottom++;
            if(table[bottom][column] == '?') {
                table[bottom][column] = cell;
            }
            else {
                break;
            }
        }
    }

    private void spreadRow(char[][] table, int row, int column, int width) {
        int left = column, right = column;
        char cell = table[row][column];

        while(left > 0) {
            left--;
            if(table[row][left] == '?') {
                table[row][left] = cell;
            }
            else {
                break;
            }
        }

        while(right < width - 1) {
            right++;
            if(table[row][right] == '?') {
                table[row][right] = cell;
            }
            else {
                break;
            }
        }
    }
}
