package com.example.darren.codejam;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.OutputStream;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

class Pancake {
    public int R;
    public int H;
    public double topSA;
    public double sideSA;
    public double SA;
    public boolean bUsed = false;

    public void calc() {
        topSA = Math.PI * R * R;
        sideSA = 2 * Math.PI * R * H;
        SA = topSA + sideSA;
    }

    public static int compareByR(Pancake a, Pancake b) {
        return a.R - b.R;
    }
}

/**
 * Created by Darren on 2017.04.30.
 */
public class Syrup implements ICodeJamProblem {

    @Override
    public void run(BufferedReader input, OutputStream output) throws IOException {
        int T = Integer.parseInt(input.readLine());
        for(int i=0; i<T; i++) {
            String S = input.readLine();
            String s[] = S.split(" ");
            int N = Integer.parseInt(s[0]);
            int K = Integer.parseInt(s[1]);

            ArrayList<Pancake> pancakes = new ArrayList<Pancake>();
            for(int j=0; j<N; j++) {
                S = input.readLine();
                s = S.split(" ");
                Pancake p = new Pancake();
                p.R = Integer.parseInt(s[0]);
                p.H = Integer.parseInt(s[1]);
                p.calc();
                pancakes.add(p);
            }

            Collections.sort(pancakes, new Comparator<Pancake>(){
                public int compare(Pancake o1, Pancake o2)
                {
                    return o2.R - o1.R;
                }
            });
            Pancake[] sortedR = new Pancake[N];
            pancakes.toArray(sortedR);

            Collections.sort(pancakes, new Comparator<Pancake>(){
                public int compare(Pancake o1, Pancake o2)
                {
                    return (o2.sideSA - o1.sideSA == 0) ? 0 : (o2.sideSA - o1.sideSA < 0) ? -1 : 1;
                }
            });
            Pancake[] sortedSA = new Pancake[N];
            pancakes.toArray(sortedSA);


            ArrayList<Pancake> resList = new ArrayList<Pancake>();
            double res = 0;
            double topSA = 0;
            for(int k=0; k<K; k++) {
                double maxDiff = -1;
                int maxDiffI = -1;
                for(int j=0; j<N; j++) {
                    if(sortedSA[j].bUsed)
                        continue;

                    double diff = ((sortedSA[j].topSA - topSA) < 0 ? 0 : (sortedSA[j].topSA - topSA)) + sortedSA[j].sideSA;

                    if(diff > maxDiff) {
                        maxDiff = diff;
                        maxDiffI = j;
                    }
                }

                resList.add(sortedSA[maxDiffI]);
                res += sortedSA[maxDiffI].sideSA;
                sortedSA[maxDiffI].bUsed = true;

                if(sortedSA[maxDiffI].topSA > topSA)
                    topSA = sortedSA[maxDiffI].topSA;
            }

            res += topSA;
            NumberFormat formatter = new DecimalFormat("#0.000000000");
            String sRes = (formatter.format(res));
            output.write(("Case #" + (i + 1) + ": " + sRes + "\n").getBytes());
        }
    }
}