package com.example.darren.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class CoinJam implements ICodeJamProblem {
    ArrayList<Long> primes = new ArrayList<Long>();

    public boolean isCoin(String test) {
        for(int i=2; i<=10; i++) {
            long res = Long.parseLong(test,i);

            if(new BigInteger(Long.toString(res)).isProbablePrime(1)) {
                return false;
            }
        }
        return true;
    }

    public void proof(String test, OutputStream output) throws IOException {
        output.write(test.getBytes());
        for(int j=2; j<=10; j++) {
            long res = Long.parseLong(test,j);
            int k;
            for(k=0; k<primes.size(); k++) {
                long p = primes.get(k);
                if(res % p == 0 && res != p) {
                    output.write((" "+p).getBytes());
                    break;
                }
            }
            if(k == primes.size())
                output.write((" shite").getBytes());
        }
        output.write("\n".getBytes());
    }

    public void loadPrimes() throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(new File("C:\\temp\\primes.txt")));

        String line = br.readLine();
        while(line != null)
        {
            String[] nums = line.split(" ");
            for(int i=0; i<8; i++)
            {
                long p = Long.parseLong(nums[i]);
                primes.add(p);
            }
            line = br.readLine();
        }
    }

    @Override
    public void run(BufferedReader input, OutputStream output) throws IOException {
        loadPrimes();
/*
        output.write(("Case #" + 101 + ": " + isCoin("101") + "\n").getBytes());
        output.write(("Case #" + 1001 + ": " + isCoin("1001") + "\n").getBytes());
        proof("1001", output);
        proof("100011", output);
        proof("111111", output);
        proof("111001", output);
*/

        input.readLine();
        String line = input.readLine();
        int N = Integer.parseInt(line.split(" ")[0]);
        int J = Integer.parseInt(line.split(" ")[1]);

        long start = Long.parseLong("1000000000000001",2);
        /*if(N == 32) {
            start = ‭2147483649‬L;
        }*/
        output.write(("Case #1:\n").getBytes());
        for(int i=0; i<J; i++) {
            String test = Long.toBinaryString(start);
            while(!isCoin(test)) {
                start+=2;
                test = Long.toBinaryString(start);
            }

            proof(test, output);
            start+=2;
        }
    }
}
