import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * Created by keskinerarda on 08/04/2017.
 */
public class Solver {
    Scanner sc       = new Scanner(new File(IN));
    static final String FILENAME = "A-large";
    static final String IN       = FILENAME + ".in";
    static final String OUT      = FILENAME + ".out";
    PrintStream out      = System.out;

    public Solver() throws FileNotFoundException {
    }

    private void solve(double distance, int[][] horses) {
        double slowestTime = 0;
        for(int[] horse: horses){
            double timeTakes = (double)(distance - horse[0]) / (double)horse[1];
            if(timeTakes > slowestTime){
                slowestTime = timeTakes;
            }
        }
        double ss = distance/slowestTime;
        out.printf("%f", ss);
        out.println();
    }

    private void run() throws Exception {
         out = new PrintStream(new FileOutputStream(OUT));
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            out.print("Case #" + i + ": ");
            double distance = sc.nextDouble();
//            System.out.println("Case #" + i + ": " + distance);
            int numberOfHorses = sc.nextInt();
            int[][] horses = new int[numberOfHorses][2];
            for(int j = 0; j < numberOfHorses; j++){
                horses[j][0] = sc.nextInt();
                horses[j][1] = sc.nextInt();
            }
            solve(distance, horses);
        }
        sc.close();
        out.close();
    }

    public static void main(String args[]) throws Exception {
        new Solver().run();
    }
}
