/**
 * Created by keskinerarda on 08/04/2017.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Created by keskinerarda on 08/04/2017.
 */
public class SolverC {
    Scanner sc       = new Scanner(new File(IN));
    static final String FILENAME = "C-small";
    static final String IN       = FILENAME + ".in";
    static final String OUT      = FILENAME + ".out";
    PrintStream out      = System.out;

    public SolverC() throws FileNotFoundException {
    }

    private void solve(int[][] distances, int[][] horses) {
        System.out.println("-------------");
        double time = 0;
        int totalDistance = 0;
        for (int k = 0; k < distances.length; k++) {
            for (int l = 0; l < distances[0].length; l++) {
                if(distances[k][l] != -1){
                    totalDistance += distances[k][l];
                }
            }
        }
        System.out.println("Total Distance: " + totalDistance);
        int upToDistance = totalDistance;
//        System.out.println("Upto Distance: " + upToDistance);
        for(int city = distances.length - 1; city > 0; city--){
            System.out.println("Upto Distance: " + upToDistance);
            double travelTime = 99999999;
            for(int i=0; i<city; i++){
                if(horses[i][0] >= upToDistance){
                    double currentTime = (double)distances[city-1][city] / (double)horses[i][1];
                    if(currentTime < travelTime){
                        travelTime = currentTime;
                    }
                    System.out.println("Horse from city " +(i+1) +" can travel in " + travelTime + " minutes.");
                }
            }
            time += travelTime;
            upToDistance -= distances[city-1][city];
        }
        System.out.println();
        System.out.printf("Total Travel Time: %f", time);
        out.printf("%f", time);
        out.println();
        System.out.println();
    }

    private void run() throws Exception {
        out = new PrintStream(new FileOutputStream(OUT));
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            out.print("Case #" + i + ": ");
            int n = sc.nextInt();
            int q = sc.nextInt();
            int[][] horses = new int[n][2];
            int[][] distances = new int[n][n];
            int[][] fromTo = new int[q][2];
            for (int j = 0; j < n; j++) {
                horses[j][0] = sc.nextInt();
                horses[j][1] = sc.nextInt();
            }
            for (int k = 0; k < n; k++) {
                for (int l = 0; l < n; l++) {
                    distances[k][l] = sc.nextInt();
                }
            }
            for (int j = 0; j < q; j++) {
                fromTo[j][0] = sc.nextInt();
                fromTo[j][1] = sc.nextInt();
            }
            solve(distances,horses);
        }
        sc.close();
        out.close();
    }

    public static void main(String args[]) throws Exception {
        new SolverC().run();
    }
}
