package com.google.codejam2017.D;

import java.util.*;
import java.io.*;

/**
 * @author Anton Kharenko
 */
public class D_FashionShow {

  public static void main(String[] args) throws FileNotFoundException {
//    if (args.length > 0) {
//      System.setIn(new FileInputStream(args[0]));
//      System.setOut(new PrintStream(new FileOutputStream(args[1])));
//    }
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();
    for (int t_i = 1; t_i <= t; t_i++) {
      int n = in.nextInt();
      int m = in.nextInt();
      int[][] grid = new int[n][n];
      in.nextLine();
      for (int i = 0; i < m; i++) {
        String[] tokens = in.nextLine().split(" ");
        char sym = tokens[0].charAt(0);
        int row = Integer.valueOf(tokens[1]) - 1;
        int col = Integer.valueOf(tokens[2]) - 1;
        if (sym == 'o') {
          grid[row][col] = 2;
        } else if (sym == '+') {
          grid[row][col] = 1;
        } else if (sym == 'x') {
          grid[row][col] = -1;
        }
      }

      ArrayList<Move> moves = new ArrayList<>();

      // Put 'o' items (2)
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
          if (grid[i][j] != 2 && isValidMove(grid, i, j, 2)) {
            grid[i][j] = 2;
            moves.add(new Move('o', i, j));
          }
        }
      }

      // Put '+' items (1)
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
          if (grid[i][j] == 0 && isValidMove(grid, i, j, 1)) {
            grid[i][j] = 1;
            moves.add(new Move('+', i, j));
          }
        }
      }

      // Put 'x' items (-1)
      for (int i = 0; i < n; i++) {
        for (int j = 0; j < n; j++) {
          if (grid[i][j] == 0 && isValidMove(grid, i, j, -1)) {
            grid[i][j] = -1;
            moves.add(new Move('x', i, j));
          }
        }
      }

      // TODO

      int s = score(grid);
      System.out.println("Case #" + t_i + ": " + s + " " + moves.size());
      for (Move move : moves) {
        System.out.println(move.sym + " " + (move.row + 1) + " " + (move.col + 1));
      }
    }
  }

  private static boolean isValidMove(int[][] grid, int row, int col, int val) {
    int n = grid[0].length;
    if (val != 1) {
      for (int i = 0; i < n; i++) {
        if (i != col && grid[row][i] != 0 && grid[row][i] != 1) {
          return false;
        }
      }
      for (int j = 0; j < n; j++) {
        if (j != row && grid[j][col] != 0 && grid[j][col] != 1) {
          return false;
        }
      }
    }

    if (val != -1) {
      int s1 = row + col;
      for (int i = 0; i < n; i++) {
        if (i != row) {
          int j = s1 - i;
          if (j >= 0 && j < n) {
            if (grid[i][j] != 0 && grid[i][j] != -1) {
              return false;
            }
          }
        }
      }

      int s2 = row - col;
      for (int i = 0; i < n; i++) {
        if (i != row) {
          int j = i - s2;
          if (j >= 0 && j < n) {
            if (grid[i][j] != 0 && grid[i][j] != -1) {
              return false;
            }
          }
        }
      }
    }

    return true;
  }

  private static int score(int[][] grid) {
    int score = 0;
    for (int[] row : grid) {
      for (int val : row) {
        score += Math.abs(val);
      }
    }
    return score;
  }

  private static class Move {
    private final char sym;
    private final int row;
    private final int col;

    public Move(char sym, int row, int col) {
      this.sym = sym;
      this.row = row;
      this.col = col;
    }
  }


}
