package com.google.codejam2017.round1b.B;

import java.io.*;
import java.util.*;

/**
 * @author Anton Kharenko
 */
public class B_Solution {

  private static Character[] allColors = {'R', 'O', 'Y', 'G', 'B', 'V'};

  private static Set<Character> nullColors = new HashSet<>(Arrays.asList(allColors));
  private static Set<Character> rColors = new HashSet<>(Arrays.asList('Y', 'G', 'B'));
  private static Set<Character> oColors = new HashSet<>(Arrays.asList('B'));
  private static Set<Character> yColors = new HashSet<>(Arrays.asList('R', 'B', 'V'));
  private static Set<Character> gColors = new HashSet<>(Arrays.asList('R'));
  private static Set<Character> bColors = new HashSet<>(Arrays.asList('R', 'O', 'Y'));
  private static Set<Character> vColors = new HashSet<>(Arrays.asList('Y'));

  public static void main(String[] args) throws FileNotFoundException {
    if (args.length > 0) {
      System.setIn(new FileInputStream(args[0]));
      System.setOut(new PrintStream(new FileOutputStream(args[1])));
    }
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();
    for (int t_i = 1; t_i <= t; t_i++) {
      int n = in.nextInt();
      Map<Character, Integer> u_or = new HashMap<>();
      for (int i = 0; i < allColors.length; i++) {
        int uc = in.nextInt();
        u_or.put(allColors[i], uc);
      }

      StringBuilder res = null;
      for (Character startChar : allColors) {
        Map<Character, Integer> u = new HashMap<>(u_or);
        int uc = u.get(startChar);
        if (uc == 0) {
          continue;
        }
        res = new StringBuilder();
        res.append(startChar);
        u.put(startChar, uc - 1);

        Character prev = startChar;
        for (int i = 1; i < n; i++) {
          Set<Character> cand = compatibleColors(prev);
          if (i == n - 1) {
            cand = new HashSet<>(cand);
            Set<Character> nCand = compatibleColors(res.charAt(0));
            cand.retainAll(nCand);
          }
          Character maxU = null;
          int maxUC = 0;
          for (Character c : cand) {
            int cc = u.get(c);
            if (cc > maxUC) {
              maxU = c;
              maxUC = cc;
            }
          }

          if (maxU == null) {
            res = null;
            break;
          } else {
            res.append(maxU);
            u.put(maxU, maxUC - 1);
            prev = maxU;
          }
        }

        if (res != null) {
          break;
        }

      }

      String resS = res != null ? res.toString() : "IMPOSSIBLE";
      System.out.println("Case #" + t_i + ": " + resS);
    }
  }

  private static Set<Character> compatibleColors(Character c) {
    if (c == null) {
      return nullColors;
    }
    switch (c) {
      case 'R':
        return rColors;
      case 'O':
        return oColors;
      case 'Y':
        return yColors;
      case 'G':
        return gColors;
      case 'B':
        return bColors;
      case 'V':
        return vColors;
      default:
        throw new IllegalArgumentException("Unknown color: " + c);
    }
  }

}
