package com.google.codejam2017.round1c.A;

import java.io.*;
import java.util.*;

/**
 * @author Anton Kharenko
 */
public class A_Solution {

  public static void main(String[] args) throws FileNotFoundException {
//    if (args.length > 0) {
//      System.setIn(new FileInputStream(args[0]));
//      System.setOut(new PrintStream(new FileOutputStream(args[1])));
//    }
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();
    for (int t_i = 1; t_i <= t; t_i++) {
      int n = in.nextInt();
      int k = in.nextInt();
      Pancake[] p = new Pancake[n];
      for (int i = 0; i < n; i++) {
        int r = in.nextInt();
        int h = in.nextInt();
        p[i] = new Pancake(r, h);
      }
      Arrays.sort(p);

      if (k == 1) {
        long maxArea = 0;
        for (Pancake pi : p) {
          long curArea = 2 * pi.r * pi.h + pi.r * pi.r;
          if (curArea > maxArea) {
            maxArea = curArea;
          }
        }

        double res = Math.PI * maxArea;
        System.out.println("Case #" + t_i + ": " + res);
        continue;
      }



      List<Pancake> stack = new ArrayList<>();

      for (int i = 0; i < n; i++) {
        if (stack.size() < k) {
          stack.add(p[i]);
        } else {
          long addArea = 2 * p[i].r * p[i].h;
          int minPos = 0;
          long minArea = Long.MAX_VALUE;
          for (int j = 0; j < k; j++) {
            Pancake curP = stack.get(j);
            Pancake nextP = j + 1 < k ? stack.get(j + 1) : null;
            long curArea = 2 * curP.r * curP.h;
            if (j == 0 && nextP != null && curP.r > nextP.r) {
              curArea += curP.r * curP.r - nextP.r * nextP.r;
            }
            if (curArea < minArea) {
              minArea = curArea;
              minPos = j;
            }
          }
          if (addArea > minArea) {
            stack.set(minPos, p[i]);
            stack.sort(Comparator.naturalOrder());
          }
        }
      }

      /*
      for (int i = 0; i < n; i++) {
        if (i == 0) {
          curArea = p[i].r * p[i].r;

        }
        curArea += 2 * p[i].r * p[i].h;
        if (i < k) {
          maxArea = curArea;
        } else {
          curArea -= p[i - k].r * p[i - k].r + 2 * p[i - k].r * p[i - k].h; // remove lowest pancake
          curArea += p[i - k + 1].r * p[i - k + 1].r;
          if (curArea > maxArea) {
            maxArea = curArea;
          }
        }
      }
      */


      long maxArea = stack.get(0).r * stack.get(0).r;
      for (Pancake pi : stack) {
        maxArea += 2 * pi.r * pi.h;
      }
      double res = Math.PI * maxArea;
      System.out.println("Case #" + t_i + ": " + res);
    }
  }

  static class Pancake implements Comparable<Pancake> {
    final long r;
    final long h;

    public Pancake(int r, int h) {
      this.r = r;
      this.h = h;
    }

    @Override
    public int compareTo(Pancake o) {
      return (int) (r != o.r ? o.r - r : h - o.h);
    }

    @Override
    public String toString() {
      return "Pancake{" +
          "r=" + r +
          ", h=" + h +
          '}';
    }
  }

}
