package com.google.codejam2017.C;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * @author Anton Kharenko
 */
public class C_BathroomStallsDp {

  public static void main(String[] args) throws FileNotFoundException {
//    if (args.length > 0) {
//      System.setIn(new FileInputStream(args[0]));
//      System.setOut(new PrintStream(new FileOutputStream(args[1])));
//    }
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();
    for (int t_i = 1; t_i <= t; t_i++) {
      long n = in.nextLong();
      long k = in.nextLong();

      PriorityQueue<Long> pq = new PriorityQueue<>((o1, o2) -> Long.compare(o2, o1));
      pq.add(n);
      Map<Long, Long> dp = new HashMap<>();
      dp.put(n, 1L);

      long ls = -1, rs = -1;
      long settled = 0;
      while (!pq.isEmpty()) {
        long s = pq.remove();
        long sCount = dp.get(s);
        long s1 = s / 2;
        long s2 = s - s1 - 1;

        if (s1 > 0) {
          if (!dp.containsKey(s1)) {
            dp.put(s1, sCount);
            pq.add(s1);
          } else {
            dp.merge(s1, sCount, Long::sum);
          }
        }

        if (s2 > 0) {
          if (!dp.containsKey(s2)) {
            dp.put(s2, sCount);
            pq.add(s2);
          } else {
            dp.merge(s2, sCount, Long::sum);
          }
        }

        settled += sCount;

        if (settled >= k) {
          ls = Math.max(s1, s2);
          rs = Math.min(s1, s2);
          break;
        }
      }

      System.out.println("Case #" + t_i + ": " + ls + " " + rs);
    }
  }


}
