package com.google.codejam2017.A;

import java.util.*;
import java.io.*;

/**
 * @author Anton Kharenko
 */
public class A_OversizedPancakeFlipperBFS {

  public static void main(String[] args) throws FileNotFoundException {
//    if (args.length > 0) {
//      System.setIn(new FileInputStream(args[0]));
//      System.setOut(new PrintStream(new FileOutputStream(args[1])));
//    }
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();
    in.nextLine();
    for (int t_i = 1; t_i <= t; t_i++) {
      String[] tokens = in.nextLine().split(" ");
      String s = tokens[0];
      int n = s.length();
      int k = Integer.valueOf(tokens[1]);

      BitSet bs = new BitSet(n);
      for (int i = 0; i < s.length(); i++) {
        char c = s.charAt(i);
        if (c == '-') {
          bs.set(i);
        }
      }

      Set<BitSet> visited = new HashSet<>();
      PriorityQueue<State> pq = new PriorityQueue<>(Comparator.comparingInt(o -> o.step));
      pq.add(new State(bs, 0));
      State res = null;
      while (!pq.isEmpty()) {
        State curState = pq.remove();
        visited.add(curState.s);
        if (curState.s.isEmpty()) {
          res = curState;
          break;
        }


        for (int i = 0; i <= n - k; i++) {
          State nextState = curState.nextState(i, k);
          if (!visited.contains(nextState.s)) {
            pq.add(nextState);
          }
        }
      }

      if (res == null) {
        System.out.println("Case #" + t_i + ": IMPOSSIBLE");
      } else {
        System.out.println("Case #" + t_i + ": " + res.step);
      }
    }
  }

  private static class State {

    private final BitSet s;
    private final int step;

    public State(BitSet s, int step) {
      this.s = s;
      this.step = step;
    }

    public State nextState(int flipInd, int k) {
      BitSet copy = new BitSet();
      copy.or(s);
      copy.flip(flipInd, flipInd + k);
      return new State(copy, step + 1);
    }
  }
}
