package com.google.codejam2017.A;

import java.util.*;
import java.io.*;

/**
 * @author Anton Kharenko
 */
public class A_OversizedPancakeFlipperBFSOptimized {

  public static void main(String[] args) throws FileNotFoundException {
//    if (args.length > 0) {
//      System.setIn(new FileInputStream(args[0]));
//      System.setOut(new PrintStream(new FileOutputStream(args[1])));
//    }
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();
    in.nextLine();
    for (int t_i = 1; t_i <= t; t_i++) {
      String[] tokens = in.nextLine().split(" ");
      String s = tokens[0];
      int n = s.length();
      int k = Integer.valueOf(tokens[1]);

      BitSet bs = new BitSet(n);
      for (int i = 0; i < s.length(); i++) {
        char c = s.charAt(i);
        if (c == '-') {
          bs.set(i);
        }
      }

      State res = null;
      State curState = new State(bs, 0);
      int minGroups = Integer.MAX_VALUE;
      int minCard = Integer.MAX_VALUE;
      while (curState != null) {
        if (curState.s.isEmpty()) {
          res = curState;
          break;
        }

        int from = curState.s.nextSetBit(0);
        int to = curState.s.previousSetBit(n - 1);
        State minState = null;
        for (int i = from; i <= to + 1 - k; i++) {
          State nextState = curState.nextState(i, k);
          int groups = nextState.countGroups();
          int card = nextState.s.cardinality();
          if (groups < minGroups || (groups == minGroups && card < minCard)) {
            minState = nextState;
          }
        }
        curState = minState;
      }

      if (res == null) {
        System.out.println("Case #" + t_i + ": IMPOSSIBLE");
      } else {
        System.out.println("Case #" + t_i + ": " + res.step);
      }
    }
  }

  private static class State {

    private final BitSet s;
    private final int step;

    State(BitSet s, int step) {
      this.s = s;
      this.step = step;
    }

    State nextState(int flipInd, int k) {
      BitSet copy = new BitSet();
      copy.or(s);
      copy.flip(flipInd, flipInd + k);
      return new State(copy, step + 1);
    }

    int countGroups() {
      boolean val = s.get(0);
      int groups = 1;
      int pos = nextPos(0, !val);
      while (pos != -1) {
        groups++;
        val = s.get(pos);
        pos = nextPos(pos, !val);
      }
      return groups;
    }

    int nextPos(int from, boolean value) {
      return value ? s.nextSetBit(from) : s.nextClearBit(from);
    }
  }
}
