import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

    static BigInteger A, B;
    static PrintWriter out;
    static Scanner in;
    static int ans;
    static int tries;


    static boolean check(int k, String cur_digits) {
        StringBuffer tmp = new StringBuffer(cur_digits).reverse();
        if (k % 2 == 0) tmp.append(cur_digits); else tmp.append(cur_digits.substring(1));
        String sqr = new BigInteger(tmp.toString()).pow(2).toString();
        //if (tmp.toString().contains("4")) System.out.println(tmp);
//        System.out.println(sqr);
        boolean ans = sqr.equals(new StringBuffer(sqr).reverse().toString());
        if (ans) {
            int num2 = 0;
            for (int i = 0; i < cur_digits.length(); ++i) {
                char ch = cur_digits.charAt(i);
                if (ch != '0' && ch != '1' && ch != '2') {
                    System.out.println(tmp.toString() + " - COUNTEREXAMPLE");
                }
                if (ch == '2') ++num2;
            }
            if (num2 > 1) System.out.println(tmp.toString() + " - COUNTEREXAMPLE");
        }
        if (ans) {
            out.println(tmp.toString());
        }
        return ans;
    }

    static boolean IsInside(String expected, String min, String max) {
//        System.out.println("Checking " + expected + " " + min + " " + max);
        if (min.compareTo(max) > 0) {
            // min > max
            int n = min.length();
            StringBuffer z = new StringBuffer();
            for (int i = 0; i < n; ++i) z.append('0');
            StringBuffer o = new StringBuffer();
            for (int i = 0; i < n; ++i) o.append('9');
            return IsInside(expected, min, o.toString()) || IsInside(expected, z.toString(), max);
        }
        return min.compareTo(expected) <= 0 && max.compareTo(expected) >= 0;
    }

    static void TryIt(int k, String cur_digits, boolean was2) {
        int n = cur_digits.length();
        if (2 * n >= k) {
            ++tries;
            if (tries % 100000 == 0) System.out.println("Current found " + ans + " with " + cur_digits);
//            System.out.print("Trying " + k + " [" + cur_digits + "]");
            if (check(k, cur_digits)) {
//                System.out.println(" - OK");
                ++ans;
            } else {
 //               System.out.println(k + " [" + cur_digits + "] - FAIL");
            }
            return;
        }
        for (int first = (n == 0 ? 1 : 0); first <= (!was2 && (n == 0 || 2 * (n + 1) >= k)? 2 : 1); ++first) {
            //Trying to make something up
            String next = (char)((int)'0' + first) + cur_digits;
            //So, we know last (n+1) digits. That means we know last (n+1) digits of square.
            BigInteger tmp = new BigInteger(next);
            String last_square_digits = tmp.multiply(tmp).toString();
            last_square_digits = last_square_digits;
            while (last_square_digits.length() < (n + 1)) last_square_digits = "0" + last_square_digits;
            last_square_digits = last_square_digits.substring(last_square_digits.length() - (n + 1));
            String expected_first_digits = new StringBuffer(last_square_digits).reverse().toString();

            StringBuffer minimal_number = new StringBuffer(next).reverse();
            for (int i = 0; i < k - 2 * n - 2; ++i) minimal_number.append('0');
            if (2 * n + 2 > k) minimal_number.append(next.substring(1)); else minimal_number.append(next);

            StringBuffer maximal_number = new StringBuffer(next).reverse();
            for (int i = 0; i < k - 2 * n - 2; ++i) maximal_number.append('9');
            if (2 * n + 2 > k) maximal_number.append(next.substring(1)); else maximal_number.append(next);

//            System.out.println(minimal_number.toString() + " " + maximal_number.toString());

            BigInteger min_square = new BigInteger(minimal_number.toString()).pow(2);
            BigInteger max_square = new BigInteger(maximal_number.toString()).pow(2);

            if (IsInside(expected_first_digits, min_square.toString().substring(0, n + 1), max_square.toString().substring(0, n + 1))) {
                TryIt(k, next, was2 || (first == 2));
            }

//            System.out.println(next + " " + expected_first_digits + " " + min_square.toString() + " " + max_square.toString());
        }
    }

    static void solve(int testnum) {
        //A = in.nextBigInteger();
        //B = in.nextBigInteger();
        int t = 50;
        ans = 0;
        tries = 0;
        for (int k = 1; k <= t; ++k) {
            // Number of digits
            System.err.println(k);
            TryIt(k, "", false);
            if (k == 1) {
                out.println("3");
            }
        }
        System.out.println(ans + " with " + (tries / 1000000.0) + " m tries");
    }

    /*public static void main(String[] args) throws IOException {
        in = new Scanner(System.in);
        //int t = in.nextInt();
        int t = 1;
        out = new PrintWriter("squares.txt");
        for (int i = 0; i < t; ++i) {
            solve(i + 1);
        }
        out.close();

    }  */
    public static void main(String[] args) throws FileNotFoundException {
        in = new Scanner(new FileInputStream("input.txt"));
        out = new PrintWriter(new FileOutputStream("output.txt"));
        int t = in.nextInt();
        ArrayList<BigInteger> lst = new ArrayList<BigInteger>();
        Scanner tmp = new Scanner(new FileInputStream("squares.txt"));
        while (tmp.hasNext()) {
            BigInteger y = tmp.nextBigInteger();
            lst.add(y.multiply(y));
        }
        //t = 10000;
        for (int i = 0; i < t; ++i) {
            BigInteger A = in.nextBigInteger();
            BigInteger B = in.nextBigInteger();
            //BigInteger A = BigInteger.ONE;
            //BigInteger B = BigInteger.TEN;
            int ans = 0;
            for (BigInteger y : lst) {
                if (y.compareTo(A) >= 0 && y.compareTo(B) <= 0) {
                    ++ans;
                }
            }
            if (i % 100 == 0)
                System.out.println(i);
            out.println("Case #" + (i + 1) + ": " + ans);
        }
        out.close();
    }
}
