/****************************************************************************
 *  Name: Anand Mohan
 *  Date: 13/03/2013
 *  TicTacToeTomek.java
 *
 ****************************************************************************/
import java.io.IOException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Map;
import java.util.HashMap;
import java.util.ArrayList;

public class LawnMower {
    public void solve(String fileName, String outputFileName) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        int numTestCases = Integer.parseInt(br.readLine());
        PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(outputFileName)));
        int caseNumber = 0;
        while (numTestCases > 0) {
            caseNumber++;
            String[] s = br.readLine().split(" ");

            int N = Integer.parseInt(s[0]);
            int M = Integer.parseInt(s[1]);

            ArrayList<ArrayList<Integer>> matrix = new ArrayList<ArrayList<Integer>>();
            for (int i = 0; i < N; i++) {
              String [] mTokens = br.readLine().split(" ");
              matrix.add(new ArrayList<Integer>());
              for (int j = 0; j < M; j++) {
                matrix.get(i).add(Integer.parseInt(mTokens[j]));
              }
            }

            while(matrix.size() != 0) {
              int k = 0;
              while (k < matrix.size()) {
                if(matrix.get(k).isEmpty()) {
                  matrix.remove(k);
                  continue;
                }
                k++;
              }
              if (matrix.isEmpty())
                break;

              int min = Integer.MAX_VALUE;
              int minRow = 0;
              int minCol = 0;

              for(int i = 0; i < matrix.size(); i++) {
                for (int j = 0; j < matrix.get(0).size(); j++) {
                  if ( matrix.get(i).get(j) < min) {
                    min = matrix.get(i).get(j);
                    minRow = i;
                    minCol = j;
                  }
                }
              }

              boolean row = true;
              boolean column = true;

              for (int j = 0; j < matrix.get(minRow).size(); j++) {
                   if (matrix.get(minRow).get(j) != min) {
                      row = false;
                      break;
                   }
              }

              for(int i = 0; i < matrix.size(); i++) {
                if (matrix.get(i).get(minCol) != min) {
                    column = false;
                    break;
                }
              }

              if (!row && !column) {
                out.write("Case #"+caseNumber+": NO\n");
                break;
              }
              if (column) {
                  for(int i = 0; i < matrix.size(); i++)
                   matrix.get(i).remove(minCol);
              }
              else if(row) {
                matrix.remove(minRow);
              }
            }
            if (matrix.size() == 0)
              out.println("Case #"+caseNumber+": YES");
            numTestCases--;
        }
        out.close();
    }
    public static void main(String[] args) throws IOException {
       LawnMower lawn = new LawnMower();
       if (args[0] == null || args[0].length() == 0) {
            System.out.println("Please provide a valid file name");
       }
       else {
               String inputFileName = args[0];
               int inputFileNameLength = inputFileName.length();
               String outputFileName = inputFileName.substring(0, inputFileNameLength - 2) +"out";
               lawn.solve(inputFileName, outputFileName);
       }

    }
}