/****************************************************************************
 *  Name: Anand Mohan
 *  Date: 13/03/2013
 *  FairAndSquare.java
 *
 ****************************************************************************/
import java.io.IOException;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.math.BigInteger;

public class FairAndSquare {
    private boolean isPalindrome(String s) {
      for (int i = 0; i < s.length()/2; i++)
          if(s.charAt(i) != s.charAt(s.length() - i -1))
            return false;
      return true;
    }
    private boolean isPalindrome(BigInteger num) {
        String digits = num.toString();
        int numDigits = digits.length();
        // Consider any single digit to be as palindromic as can be
        if (numDigits == 1) return true;
        if (digits.charAt(numDigits - 1) == '0') return false;
        for (int i=0; i<numDigits/2; i++) {
            if (digits.charAt(i) != digits.charAt(numDigits - i - 1))
                return false;
        }
        return true;
      }
    public static BigInteger sqrt(BigInteger n) {
        BigInteger a = BigInteger.ONE;
        BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
        while(b.compareTo(a) >= 0) {
          BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
          if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
          else a = mid.add(BigInteger.ONE);
        }
        return a.subtract(BigInteger.ONE);
    }
    public void solve(String fileName, String outputFileName) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(fileName));
        int numTestCases = Integer.parseInt(br.readLine());
        PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(outputFileName)));
        int caseNumber = 0;
        while (numTestCases > 0) {
            caseNumber++;
            String[] tokens =  br.readLine().split(" ");
            BigInteger A = new BigInteger(tokens[0]);
            BigInteger B = new BigInteger(tokens[1]);
            long count = 0;
            BigInteger minPerfectSquare;
            long limitA = sqrt(A).longValue();
            long limitB = sqrt(B).longValue();
            for (Long i = limitA; i <= limitB; i++) {
              BigInteger b = new BigInteger(i.toString());
              BigInteger c = b.multiply(b);
              if (c.compareTo(A) < 0) continue;
              if (isPalindrome(b) && isPalindrome(c)) {
                count++;
              }
            }
            out.println("Case #" + caseNumber +": " + count);
            numTestCases--;
        }
        out.close();
    }
    public static void main(String[] args) throws IOException {
       FairAndSquare fair = new FairAndSquare();
       if (args[0] == null || args[0].length() == 0) {
            System.out.println("Please provide a valid file name");
       }
       else {
               String inputFileName = args[0];
               int inputFileNameLength = inputFileName.length();
               String outputFileName = inputFileName.substring(0, inputFileNameLength - 2) +"out";
               fair.solve(inputFileName, outputFileName);
       }

    }
}