import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class BotTrust {

	public static void main(String args[]) throws FileNotFoundException{
		
		Scanner sc = new Scanner(new File("D:\\A-small.txt"));
		String records = sc.nextLine();
		
		while(sc.hasNext()){
			String input = sc.nextLine();
			Character c = input.charAt(0);
			int numberOfButtons = getButtonNumber(input, 0); 
			int timeTaken = 0;
			int totalTime = 0;
			Integer[] currentPositionOfOrange = new Integer[1];
			Integer[] currentPositionOfBlue = new Integer[1];
			currentPositionOfOrange[0] = 1;
			currentPositionOfBlue[0] = 1;
			for(int i=1;i<numberOfButtons*2;i++){
				
				timeTaken = 0;
				char botName = input.charAt(i);
				i++;
				int buttonNumber = getButtonNumber(input, i); 
				
				if(botName == 'O'){
					timeTaken = evaluateBestTimeIncludingPush(currentPositionOfOrange, buttonNumber);
				}else{
					timeTaken = evaluateBestTimeIncludingPush(currentPositionOfBlue, buttonNumber);
				}
				
				totalTime = totalTime + timeTaken ;
				
				moveOtherBotInMeanTime(input, timeTaken, currentPositionOfOrange, currentPositionOfBlue, i, botName);
			}
			System.out.println("Test Case : "+totalTime);
		}
	}

	private static int getButtonNumber(String input, int i) {
		int count = -1;
		int buttonNumber = 0;
		int j=i;
		int k=i;
		while(input.length()>j && (input.charAt(j)=='0' || input.charAt(j)=='1' || input.charAt(j)=='2' ||
				input.charAt(j)=='3' || input.charAt(j)=='4' || input.charAt(j)=='5' ||
				input.charAt(j)=='6' || input.charAt(j)=='7' || input.charAt(j)=='8' ||
				input.charAt(j)=='9')){
			
			count++;
			j++;
		}
		
		while(input.length()>k && (input.charAt(k)=='0' || input.charAt(k)=='1' || input.charAt(k)=='2' ||
				input.charAt(k)=='3' || input.charAt(k)=='4' || input.charAt(k)=='5' ||
				input.charAt(k)=='6' || input.charAt(k)=='7' || input.charAt(k)=='8' ||
				input.charAt(k)=='9')){
			
			Character c1 = input.charAt(k);
			buttonNumber = buttonNumber + Integer.parseInt(c1.toString())*((Double)Math.pow(10, count)).intValue();
			k++;
		}
		
		
		return buttonNumber;
	}

	private static int evaluateBestTimeIncludingPush(Integer[] currentPositionOfBot, int buttonNumber) {

		int time = Math.abs(currentPositionOfBot[0] - buttonNumber) + 1;
		currentPositionOfBot[0] = buttonNumber;
		return time;
	}

	private static void moveOtherBotInMeanTime(String input, int timeTaken, Integer[] currentPositionOfOrange,
			Integer[] currentPositionOfBlue, int i, char botName) {
		char nextBotName;
		int nextButtonNumber = -1;
		
		while(input.length()>(i+1) && (input.charAt(i+1)!=' '|| input.charAt(i+1)!='\n')){
		
			nextBotName = input.charAt(++i);
			i++;
			nextButtonNumber = getButtonNumber(input, i);
			
			if(botName != nextBotName){
				if(nextBotName == 'O'){
					evaluateBestMoveExcludingPush(currentPositionOfOrange, nextButtonNumber, timeTaken);
				}else{
					evaluateBestMoveExcludingPush(currentPositionOfBlue, nextButtonNumber, timeTaken);
				}
				break;
			}
		}
	}

	private static void evaluateBestMoveExcludingPush(Integer[] currentPositionOfBot, int nextButtonNumber,
			int timeAlloted) {
		
		int movesRequired = Math.abs(currentPositionOfBot[0] - nextButtonNumber);
		if(timeAlloted < movesRequired){
			if((currentPositionOfBot[0] - nextButtonNumber)<0){
				currentPositionOfBot[0] = currentPositionOfBot[0] + timeAlloted;
			}else{
				currentPositionOfBot[0] = currentPositionOfBot[0] - timeAlloted;
			}
		}else{
			if((currentPositionOfBot[0] - nextButtonNumber)<0){
				currentPositionOfBot[0] = currentPositionOfBot[0] + movesRequired;
			}else{
				currentPositionOfBot[0] = currentPositionOfBot[0] - movesRequired;
			}
		}
		
	}
}
