package su.problems;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by Akshat on 4/12/2015.
 */
public class CodeJamDijkstra {

    final private static Map<String, String> map = new HashMap<>();

    public String evaluate(String input) {

        return recurse(input.substring(1), String.valueOf(input.charAt(0)), "ijk", new HashMap<>()) ? "YES" : "NO";
    }

    private boolean recurse(String input, String product, String lookingFor, Map<String, Boolean> memo) {

        if (lookingFor.isEmpty() || "k".equals(String.valueOf(lookingFor.charAt(0))))
        {
            return true;
        }

        if(input.isEmpty()){
            return false;
        }


        String newLookingFor = lookingFor;
        boolean result = false;

        for(int i=0;i<input.length();i++)
        {
//            System.out.print(product + " ");
            if(product.equals(String.valueOf(lookingFor.charAt(0))))
            {
//                System.out.println("");
                newLookingFor = lookingFor.substring(1);
                if(memo.get(input.substring(i+1)+"-"+newLookingFor)==null)
                {
                    boolean ans = recurse(input.substring(i + 1), String.valueOf(input.charAt(0)), newLookingFor, memo);
//                    System.out.println(input.substring(i+1)+"-"+newLookingFor+":"+ans);
                    memo.put(input.substring(i + 1) + "-" + newLookingFor, ans);
                }
                if(memo.get(input.substring(i+1)+"-"+newLookingFor))
                {
                    return true;
                }
//                System.out.println("backtracking");
            }
            product = map.get(product + input.charAt(i));
        }

        return result;
    }

    public static void main(String[] args) throws IOException {
        FileReader fileReader = new FileReader("C:\\Users\\Akshat\\Documents\\Algorithmic-Questions\\src\\su\\data\\codeJamDijkstraTestData.txt");
        FileWriter fileWriter = new FileWriter("C:\\Users\\Akshat\\Documents\\Algorithmic-Questions\\src\\su\\data\\codeJamDijkstraOutput.txt");
        Scanner scanner = new Scanner(fileReader);
        int num = scanner.nextInt();
        CodeJamDijkstra codeJamDijkstra = new CodeJamDijkstra();

        int count = 1;
        for(int i=0;i<num;i++)
        {
            scanner.nextInt();
            int X = scanner.nextInt();
            String pattern = scanner.next();
            String input = "";
            for(int j=0;j<X;j++)
            {
                input += pattern;
            }
            String result = "Case #" + count + ": " + codeJamDijkstra.evaluate(input);
            System.out.println(result);
            fileWriter.write(result+"\n");
            count++;
        }
        fileWriter.close();
        fileReader.close();
    }


    public CodeJamDijkstra() {

        map.put("11","1");
        map.put("1i","i");
        map.put("1j","j");
        map.put("1k","k");
        map.put("i1","i");
        map.put("ii","-1");
        map.put("ij","-k");
        map.put("ik","j");
        map.put("j1","j");
        map.put("ji","k");
        map.put("jj","-1");
        map.put("jk","-i");
        map.put("k1","k");
        map.put("ki","-j");
        map.put("kj","i");
        map.put("kk","-1");

        map.put("-11","-1");
        map.put("-1i","-i");
        map.put("-1j","-j");
        map.put("-1k","-k");
        map.put("-i1","-i");
        map.put("-ii","1");
        map.put("-ij","k");
        map.put("-ik","-j");
        map.put("-j1","-j");
        map.put("-ji","-k");
        map.put("-jj","1");
        map.put("-jk","i");
        map.put("-k1","-k");
        map.put("-ki","j");
        map.put("-kj","-i");
        map.put("-kk","1");
    }
}
