/**
 * Created by Meepo on 1/21/2017.
 */

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class B {
    int n;
    int R, O, Y, G, B, V;

    int[][] e;
    String res = "ROYGBV";

    StringBuilder ans;
    public void euler(int v) {
        for (int u = 0; u < e.length; u++) {
            if (e[v][u] > 0) {
                e[v][u]--;
                e[u][v]--;
                euler(u);
            }
        }
        ans.append(res.charAt(v));
    }


    String solve() {
        e = new int[6][6];
        int xR = 2 * R - 2 * G;
        e[0][3] = e[3][0] = 2 * G;

        int xY = 2 * Y - 2 * V;
        e[2][5] = e[5][2] = 2 * V;

        int xB = 2 * B - 2 * O;
        e[4][1] = e[1][4] = 2 * O;

        if ((xR + xY + xB) % 2 != 0) {
            return "IMPOSSIBLE";
        }

        e[0][2] = e[2][0] = (xR + xY - xB) / 2;
        e[2][4] = e[4][2] = (xY + xB - xR) / 2;
        e[4][0] = e[0][4] = (xB + xR - xY) / 2;

        int[] total = new int[6];
        for (int i = 0; i < 6; i++) {
            total[i] = 0;
            for (int j = 0; j < 6; j++) {
                if (e[i][j] < 0) {
                    return "IMPOSSIBLE";
                }
                total[i] += e[i][j];
            }
            if (total[i] % 2 != 0) {
                return "IMPOSSIBLE";
            }
        }

        for (int i = 0; i < 6; i++) {
            if (total[i] > 0) {
                ans = new StringBuilder();
                euler(i);
                return ans.toString().substring(1);
            }
        }
        return "";
    }

    public B(Scanner in) {
        n = in.nextInt();
        R = in.nextInt();
        O = in.nextInt();
        Y = in.nextInt();
        G = in.nextInt();
        B = in.nextInt();
        V = in.nextInt();
    }

    public static void main(String[] args) throws Exception {
        int nThreads = 4;
        String formatOut = "Case #%2$d: %1$s";
        String formatSystemOut = formatOut;

        String inputFileName = "input.txt";
        String outputFileName = "output.txt";

        Locale.setDefault(Locale.US);
        Scanner in = new Scanner(new File(inputFileName));
        PrintWriter out = new PrintWriter(outputFileName);
        int tests = in.nextInt();
        in.nextLine();//1;
        nThreads = Math.min(nThreads, tests);
        @SuppressWarnings("unchecked")
        Callable<String>[] callables = new Callable[tests];
        for (int t = 0; t < tests; t++) {
            final B testCase = new B(in);
            final int testCaseNumber = t + 1;
            callables[t] = new Callable<String>() {
                @Override
                public String call() {
                    String answer = testCase.solve();
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    return String.format(formatOut, answer, testCaseNumber);
                }
            };
        }
        try {
            if (nThreads > 1) {
                ExecutorService executor = Executors.newFixedThreadPool(4);
                @SuppressWarnings("unchecked")
                Future<String>[] outputs = new Future[tests];
                for (int t = 0; t < tests; t++) {
                    outputs[t] = executor.submit(callables[t]);
                }
                for (int t = 0; t < tests; t++) {
                    out.println(outputs[t].get());
                }
                executor.shutdown();
            } else {
                for (int t = 0; t < tests; t++) {
                    out.println(callables[t].call());
                }
            }
        } catch (Exception e) {
            System.out.flush();
            System.err.flush();
            e.printStackTrace();
            System.exit(1);
        }
        System.out.println("COMPLETE");
        in.close();
        out.close();
    }
}