import java.io.*;
import java.util.*;

public class B implements Runnable {
	public static void main(String[] args) throws IOException {
		new Thread(new B()).start();
	}

	public BufferedReader br;

	public StringTokenizer in;

	public PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}

		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	long INF = Long.MAX_VALUE / 2;

	public void solve() throws IOException {
		int n = nextInt();
		int p = nextInt() - 1;

		boolean[] win = new boolean[n];
		for (int i = 0; i < win.length; i++) {
			if ((p & (1 << (n - i - 1))) == 0)
				win[i] = true;
		}

		long f = -1;
		long l = -1;
		for (int i = 0; i < 1 << n; i++) {
			long max = i;
			long min = i;

			for (int layer = 0; layer < n; layer++) {
				long b = max;
				long a = (1L << (n - layer)) - b - 1;

				if (win[layer] && b > 0 && f == -1) {
					f = i;
					break;
				}

				if (win[layer])
					a--;
				else
					b--;

				if (b < 0)
					break;

				if (a < 0 && f == -1) {
					f = i;
					break;
				}

				if (win[layer])
					max = Math.min(b, (b + a) / 2);
				else
					max = b / 2;
			}

			boolean bad = false;

			for (int layer = 0; layer < n; layer++) {
				long b = min;
				long a = (1L << (n - layer)) - b - 1;

				if (!win[layer] && a > 0) {
					break;
				}

				if (win[layer])
					a--;
				else
					b--;

				if (a < 0) {
					bad = true;
					break;
				}

				if (b < 0) {
					break;
				}

				if (win[layer])
					min = (b + 1) / 2;
				else
					min = Math.max(0, b - Math.min(b, (a + b) / 2));
			}

			if (!bad)
				l = i;
		}

		if (f == -1)
			f = 1 << n;

		out.println((f - 1) + " " + l);
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");

			int t = nextInt();
			for (int i = 0; i < t; i++) {
				out.print("Case #" + (i + 1) + ": ");
				solve();
			}

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}
