import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class BStupid2 {
    public static void main(String[] args) {
        new BStupid2().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public class Pair implements Comparable<Pair> {
        double r, c;

        public Pair(double r, double c) {
            this.r = r;
            this.c = c;
        }

        public int compareTo(Pair p) {
            return Double.compare(c, p.c);
        }

        public String toString() {
            return r + " " + c;
        }
    }

    double eps = 0.0000000001;

    public void solve(int test) throws IOException {
        int n = nextInt();
        double V = nextDouble();
        double X = nextDouble();

        Pair[] sources = new Pair[n];

        int pos = 0;
        int neg = 0;
        for (int i = 0; i < n; i++) {
            sources[i] = new Pair(nextDouble(), nextDouble());
            if (sources[i].c > X + eps)
                pos++;
            if (sources[i].c < X - eps)
                neg++;
        }
//
//        if (test != 91) {
//            return;
//        }
//
//        System.err.println(n + " " + V + " " + X);

        if (pos == n || neg == n) {
            out.println("IMPOSSIBLE");
            return;
        }

        Arrays.sort(sources);

        for (int i = 0; i < n; i++) {
            sources[i].c /= X;
        }

        if (n == 1) {
            out.println(String.format("%.07f", V / sources[0].r));
            return;
        }

        double MAX = 0;
        if (Math.abs(sources[0].c - 1) < eps) {
            MAX += sources[0].r;
        }
        if (Math.abs(sources[1].c - 1) < eps) {
            MAX += sources[1].r;
        }

        if (MAX > 0) {
            out.println(String.format("%.07f", V / MAX));
            return;
        }

        double[] a = new double[]{1 - sources[0].c, sources[1].c - 1};

        double v0 = V / (1 + a[0] / a[1]);
        double v1 = a[0] / a[1] * v0;

        double ans = Math.max(v0 / sources[0].r, v1 / sources[1].r);
        System.err.println("Here!!!");

        out.println(String.format("%.07f", ans));
    }

    public void run() {
        try {
            Locale.setDefault(Locale.US);

            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");

            int t = nextInt();
            for (int i = 0; i < t; i++) {
                out.print(String.format("Case #%d: ", i + 1));
                solve(i);
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
