/**
 * Created by Meepo on 1/21/2017.
 */

import java.io.File;
import java.io.PrintWriter;
import java.util.*;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class A {
    int n;
    int p;
    int[] g;

    public class Count {
        int[] cnt;

        public Count(int[] c) {
            this.cnt = c;
        }

        public boolean equals(Object o) {
            Count c = (Count) o;
            return Arrays.equals(cnt, c.cnt);
        }

        public int hashCode() {
            int c = 0;
            for (int i = 0; i < cnt.length; i++) {
                c = c * 100 + cnt[i];
            }
            return c;
        }
    }

    HashMap<Count, Integer> answer;
    ArrayList<int[]> turns = new ArrayList<>();

    public void generateTurns(int p, int sum, int i, int[] now) {
        if (i == p) {
            if (sum % p != 0 || sum == 0)
                return;
            boolean override = false;
            for (int[] prev : turns) {
                boolean over = true;
                for (int k = 0; k < p; k++) {
                    over &= now[k] >= prev[k];
                }
                override |= over;
            }
            if (!override) {
                turns.add(Arrays.copyOf(now, now.length));
            }
            return;
        }
        for (int j = 0; j <= p; j++) {
            now[i] = j;
            generateTurns(p, sum + j * i, i + 1, now);
        }
    }

    public int get(Count count) {
        if (answer.containsKey(count)) {
            return answer.get(count);
        }
        int result = 1;
        for (int[] turn : turns) {
            boolean ok = true;
            for (int i = 0; i < count.cnt.length; i++) {
                ok &= count.cnt[i] >= turn[i];
            }
            if (!ok) {
                continue;
            }
            int[] c = Arrays.copyOf(count.cnt, count.cnt.length);
            for (int i = 0; i < count.cnt.length; i++) {
                c[i] -= turn[i];
            }
            result = Math.max(result, get(new Count(c)) + 1);
        }
        answer.put(count, result);
        return result;
    }

    String solve() {
        int[] cnt = new int[p];
        for (int i = 0; i < n; i++) {
            cnt[g[i] % p]++;
        }

        answer = new HashMap<>();

        int[] one = new int[p];
        one[0] = 1;
        turns.add(one);
        generateTurns(p, 0, 1, new int[p]);

        answer.put(new Count(new int[p]), 0);

        int ans = get(new Count(cnt));
        return "" + ans;
    }

    public A(Scanner in) {
        n = in.nextInt();
        p = in.nextInt();
        g = new int[n];
        for (int i = 0; i < n; i++) {
            g[i] = in.nextInt();
        }
    }

    public static void main(String[] args) throws Exception {
        int nThreads = 4;
        String formatOut = "Case #%2$d: %1$s";
        String formatSystemOut = formatOut;

        String inputFileName = "input.txt";
        String outputFileName = "output.txt";

        Locale.setDefault(Locale.US);
        Scanner in = new Scanner(new File(inputFileName));
        PrintWriter out = new PrintWriter(outputFileName);
        int tests = in.nextInt();
        in.nextLine();//1;
        nThreads = Math.min(nThreads, tests);
        @SuppressWarnings("unchecked")
        Callable<String>[] callables = new Callable[tests];
        for (int t = 0; t < tests; t++) {
            final A testCase = new A(in);
            final int testCaseNumber = t + 1;
            callables[t] = new Callable<String>() {
                @Override
                public String call() {
                    String answer = testCase.solve();
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    return String.format(formatOut, answer, testCaseNumber);
                }
            };
        }
        try {
            if (nThreads > 1) {
                ExecutorService executor = Executors.newFixedThreadPool(4);
                @SuppressWarnings("unchecked")
                Future<String>[] outputs = new Future[tests];
                for (int t = 0; t < tests; t++) {
                    outputs[t] = executor.submit(callables[t]);
                }
                for (int t = 0; t < tests; t++) {
                    out.println(outputs[t].get());
                }
                executor.shutdown();
            } else {
                for (int t = 0; t < tests; t++) {
                    out.println(callables[t].call());
                }
            }
        } catch (Exception e) {
            System.out.flush();
            System.err.flush();
            e.printStackTrace();
            System.exit(1);
        }
        System.out.println("COMPLETE");
        in.close();
        out.close();
    }
}