/**
 * Created by Meepo on 1/21/2017.
 */

import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class B {
    String n;

    String solve() {
        int[] ans = new int[n.length()];
        boolean bad = false;
        ans[0] = n.charAt(0) - '0';
        for (int i = 1; i < n.length(); i++) {
            if (bad) {
                ans[i] = 9;
            } else {
                if (n.charAt(i) >= n.charAt(i - 1)) { // still good
                    ans[i] = n.charAt(i) - '0';
                } else {
                    bad = true;
                    int decrease = ans[i - 1];
                    int j;
                    for (j = i - 1; j >= 0 && ans[j] == decrease; j--) {
                        ans[j]--;
                    }
                    j += 2;
                    while (j < i) {
                        ans[j] = 9;
                        j++;
                    }
                    ans[i] = 9;
                }
            }
        }
        long total = 0;
        for (int i = 0; i < ans.length; i++) {
            total = total * 10 + ans[i];
        }

        return "" + total;
    }

    public B(Scanner in) {
        n = in.nextLine();
    }

    public static void main(String[] args) throws Exception {
        int nThreads = 4;
        String formatOut = "Case #%2$d: %1$s";
        String formatSystemOut = formatOut;

        String inputFileName = "input.txt";
        String outputFileName = "output.txt";

        Locale.setDefault(Locale.US);
        Scanner in = new Scanner(new File(inputFileName));
        PrintWriter out = new PrintWriter(outputFileName);
        int tests = in.nextInt();
        in.nextLine();//1;
        nThreads = Math.min(nThreads, tests);
        @SuppressWarnings("unchecked")
        Callable<String>[] callables = new Callable[tests];
        for (int t = 0; t < tests; t++) {
            final B testCase = new B(in);
            final int testCaseNumber = t + 1;
            callables[t] = new Callable<String>() {
                @Override
                public String call() {
                    String answer = testCase.solve();
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    return String.format(formatOut, answer, testCaseNumber);
                }
            };
        }
        try {
            if (nThreads > 1) {
                ExecutorService executor = Executors.newFixedThreadPool(4);
                @SuppressWarnings("unchecked")
                Future<String>[] outputs = new Future[tests];
                for (int t = 0; t < tests; t++) {
                    outputs[t] = executor.submit(callables[t]);
                }
                for (int t = 0; t < tests; t++) {
                    out.println(outputs[t].get());
                }
                executor.shutdown();
            } else {
                for (int t = 0; t < tests; t++) {
                    out.println(callables[t].call());
                }
            }
        } catch (Exception e) {
            System.out.flush();
            System.err.flush();
            e.printStackTrace();
            System.exit(1);
        }
        System.out.println("COMPLETE");
        in.close();
        out.close();
    }
}