/**
 * Created by Meepo on 1/21/2017.
 */

import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class C {
    int n;
    int q;
    int[] e;
    int[] s;
    long[][] d;
    int[] u;
    int[] v;

    String solve() {
        for (int k = 0; k < n;k++) {
            for (int i= 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    d[i][j] = Math.min(d[i][j], d[i][k] + d[k][j]);
                }
            }
        }

        String ans = "";
        for (int i = 0; i < q; i++) {
            double[] best = new double[n];
            Arrays.fill(best, Double.MAX_VALUE);
            boolean[] was = new boolean[n];
            best[u[i]] = 0;
            for (int it = 0; it < n; it++) {
                int w = -1;
                for (int j = 0; j < n; j++) {
                    if (!was[j] && best[j] != Double.MAX_VALUE && (w == -1 || best[w] > best[j])) {
                        w = j;
                    }
                }
                if (w == -1)
                    break;
                was[w] = true;
                for (int t = 0; t < n; t++) {
                    if (d[w][t] <= e[w]) {
                        best[t] = Math.min(best[t], best[w] + 1. * d[w][t] / s[w]);
                    }
                }
            }
            ans += String.format("%.8f ", best[v[i]]);
        }

        return ans;
    }

    public C(Scanner in) {
        n = in.nextInt();
        q = in.nextInt();
        e = new int[n];
        s = new int[n];
        for (int i = 0; i < n; i++) {
            e[i] = in.nextInt();
            s[i] = in.nextInt();
        }
        d = new long[n][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                d[i][j] = in.nextInt();
                d[i][j] = d[i][j] == -1 ? Long.MAX_VALUE / 2 : d[i][j];
            }
            d[i][i] = 0;
        }
        u = new int[q];
        v = new int[q];
        for (int i = 0; i < q; i++) {
            u[i] = in.nextInt() - 1;
            v[i] = in.nextInt() - 1;
        }
    }

    public static void main(String[] args) throws Exception {
        int nThreads = 4;
        String formatOut = "Case #%2$d: %1$s";
        String formatSystemOut = formatOut;

        String inputFileName = "input.txt";
        String outputFileName = "output.txt";

        Locale.setDefault(Locale.US);
        Scanner in = new Scanner(new File(inputFileName));
        PrintWriter out = new PrintWriter(outputFileName);
        int tests = in.nextInt();
        in.nextLine();//1;
        nThreads = Math.min(nThreads, tests);
        @SuppressWarnings("unchecked")
        Callable<String>[] callables = new Callable[tests];
        for (int t = 0; t < tests; t++) {
            final C testCase = new C(in);
            final int testCaseNumber = t + 1;
            callables[t] = new Callable<String>() {
                @Override
                public String call() {
                    String answer = testCase.solve();
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    return String.format(formatOut, answer, testCaseNumber);
                }
            };
        }
        try {
            if (nThreads > 1) {
                ExecutorService executor = Executors.newFixedThreadPool(4);
                @SuppressWarnings("unchecked")
                Future<String>[] outputs = new Future[tests];
                for (int t = 0; t < tests; t++) {
                    outputs[t] = executor.submit(callables[t]);
                }
                for (int t = 0; t < tests; t++) {
                    out.println(outputs[t].get());
                }
                executor.shutdown();
            } else {
                for (int t = 0; t < tests; t++) {
                    out.println(callables[t].call());
                }
            }
        } catch (Exception e) {
            System.out.flush();
            System.err.flush();
            e.printStackTrace();
            System.exit(1);
        }
        System.out.println("COMPLETE");
        in.close();
        out.close();
    }
}