import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {
    public static void main(String[] args) {
        new B().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public class Pair implements Comparable<Pair> {
        double r, c;

        public Pair(double r, double c) {
            this.r = r;
            this.c = c;
        }

        public int compareTo(Pair p) {
            return Double.compare(c, p.c);
        }

        public String toString() {
            return r + " " + c;
        }
    }

    double eps = 1e-7;

    public void solve(int test) throws IOException {
        int n = nextInt();
        double V = nextDouble();
        double X = nextDouble();

        Pair[] sources = new Pair[n];

        int pos = 0;
        int neg = 0;
        for (int i = 0; i < n; i++) {
            sources[i] = new Pair(nextDouble(), nextDouble());
            if (sources[i].c > X + eps)
                pos++;
            if (sources[i].c < X - eps)
                neg++;
        }

        if (pos == n || neg == n) {
            out.println("IMPOSSIBLE");
            return;
        }

//        if (test == 81) {
//            System.err.println(n + " " + V + " " + X);
//        }

        Arrays.sort(sources);

        double l = 0;
        double r = 1e6;
        for (int it = 0; it < 200; it++) {
            double m = (l + r) / 2;
            double small = 0;
            double have = V;
            for (int i = 0; i < n; i++) {
                small += Math.min(have, m * sources[i].r) * sources[i].c / X;
                have -= Math.min(have, m * sources[i].r);
            }
            double big = 0;
            have = V;
            for (int i = n - 1; i >= 0; i--) {
                big += Math.min(have, m * sources[i].r) * sources[i].c / X;
                have -= Math.min(have, m * sources[i].r);
            }

//            System.err.println(l + " " + r + " " + small + " " + big + " " + V * X + " " + (m * sources[0].r) * sources[0].c);

            if (small >= V + 1e-13 || big <= V - 1e-13) {
                l = m;
            } else {
                r = m;
            }
        }

        if (l >= 999999.999) {
            l = 1e6;
        }

        Locale.setDefault(Locale.US);
        out.println(String.format("%.07f", l));
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");

            int t = nextInt();
            for (int i = 0; i < t; i++) {
                out.print(String.format("Case #%d: ", i + 1));
                solve(i);
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
