import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * Created by vaksenov on 16.01.2016.
 */
public class D {
    public static void main(String[] args) {
        new D().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    ArrayList<int[]>[] permutations;

    public void gen(int[] p, int k, boolean[] was) {
        if (k == p.length) {
            permutations[p.length].add(Arrays.copyOf(p, p.length));
            return;
        }
        for (int i = 0; i < p.length; i++) {
            if (was[i])
                continue;
            was[i] = true;
            p[k] = i;
            gen(p, k + 1, was);
            was[i] = false;
        }
    }

    public void precalc() {
        permutations = new ArrayList[5];
        for (int i = 1; i < 5; i++) {
            permutations[i] = new ArrayList<int[]>();
            gen(new int[i], 0, new boolean[i]);
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int bmask = 0;
        for (int i = 0; i < n; i++) {
            String s = nextToken();
            for (int j = 0; j < n; j++) {
                bmask = bmask * 2 + (s.charAt(j) - '0');
            }
        }

        int ans = Integer.MAX_VALUE;
        for (int mask = 0; mask < 1 << (n * n); mask++) {
            if ((mask & bmask) != bmask) {
                continue;
            }

            boolean[][] know = new boolean[n][n];
            int tm = mask;
            for (int i = n - 1; i >= 0; i--) {
                for (int j = n - 1; j >= 0; j--) {
                    know[i][j] = tm % 2 == 1;
                    tm >>= 1;
                }
            }

            boolean good = true;
            //System.err.println(n + " " + permutations[n]);
            for (int[] p : permutations[n]) {
                boolean[] can = new boolean[1 << n];
                can[0] = true;
                for (int i = 0; i < n; i++) {
                    for (int mask2 = 0; mask2 < 1 << n; mask2++) {
                        if (!can[mask2] || Integer.bitCount(mask2) != i) {
                            continue;
                        }
                        //Sy
                        boolean found = false;
                        for (int choose = 0; choose < n; choose++) {
                            if (know[p[i]][choose] && ((mask2 >> choose) & 1) != 1) {
                                found = true;
                                can[mask2 | (1 << choose)] = true;
                            }
                        }
                        if (!found) {
                            good = false;
                            break;
                        }
                    }
                    if (!good) {
                        break;
                    }
                }
                if (!good) {
                    break;
                }
            }
            if (good) {
                ans = Math.min(ans, Integer.bitCount(mask) - Integer.bitCount(bmask));
            }
        }
        out.println(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");

            precalc();
            int t = nextInt();
            for (int i = 0; i < t; i++) {
                out.print("Case #" + (i + 1) + ": ");
                solve();
                System.err.println("Finished " + (i + 1) + " test");
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
