import java.io.*;
import java.util.*;

public class A {
	public static void main(String[] args) {
		new A().run();
	}

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	int[] dx = new int[] { 1, 1, 0, -1, -1, -1, 0, 1 };
	int[] dy = new int[] { 0, 1, 1, 1, 0, -1, -1, -1 };

	boolean good(int x, int y, int n) {
		return x >= 0 && y >= 0 && x < n && y < n;
	}

	public void solve() throws IOException {
		char[][] z = new char[4][];
		for (int i = 0; i < z.length; i++) {
			z[i] = nextToken().toCharArray();
		}

		boolean tie = true;
		for (int i = 0; i < z.length; i++) {
			for (int j = 0; j < z.length; j++) {
				if (z[i][j] == '.') {
					tie = false;
					continue;
				}
				for (int k = 0; k < dx.length; k++) {
					int x = i + dx[k];
					int y = j + dy[k];
					int cnt = 1;
					while (good(x, y, z.length)
							&& (z[x - dx[k]][y - dy[k]] == z[x][y] || z[x
									- dx[k]][y - dy[k]] == 'T'
									&& z[x][y] != '.')) {
						x += dx[k];
						y += dy[k];
						cnt++;
					}
					if (cnt == 4) {
						out.println((z[i][j] == 'T' ? z[i + dx[k]][j + dy[k]]
								: z[i][j]) + " won");
						return;
					}
				}
			}
		}
		if (tie) {
			out.println("Draw");
		} else {
			out.println("Game has not completed");
		}
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");

			int t = nextInt();
			for (int i = 0; i < t; i++) {
				out.print(String.format("Case #%d: ", i + 1));
				solve();
			}

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
