import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Created by vaksenov on 16.01.2016.
 */
public class B {
    public static void main(String[] args) {
        new B().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public void solve() throws IOException {
        int n = nextInt();
        int k = nextInt();
        double[] p = new double[n];
        for (int i = 0; i < n; i++) {
            p[i] = nextDouble();
        }

        Arrays.sort(p);

        double[] bb = null;
        double mb = 0;
        for (int split = 0; split <= k; split++) {
            double[] best = new double[k];
            for (int i = 0; i < split; i++) {
                best[i] = p[i];
            }
            for (int i = 0; i < k - split; i++) {
                best[i + split] = p[p.length - i - 1];
            }
            Arrays.sort(best);

            double[] prob = new double[2 * k + 1];
            prob[k] = 1;
            for (int i = 0; i < k; i++) {
                double[] np = new double[2 * k + 1];
                for (int j = 1; j < prob.length - 1; j++) {
                    np[j + 1] += prob[j] * best[i];
                    np[j - 1] += prob[j] * (1 - best[i]);
                }
                prob = np;
            }

            if (mb < prob[k]) {
                bb = best;
                mb = prob[k];
            }
        }
        out.println(mb);
        System.err.println(Arrays.toString(bb));
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");

            int t = nextInt();
            for (int i = 0; i < t; i++) {
                out.print("Case #" + (i + 1) + ": ");
                solve();
                System.err.println("Finished " + (i + 1) + " test");
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
