/**
 * Created by Meepo on 1/21/2017.
 */

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class A {
    int D, n;
    int[] k;
    int[] s;

    String solve() {
        double ans = Double.MAX_VALUE;
        for (int i = 0; i < n; i++) {
            double t = 1. * (D - k[i]) / s[i];
            ans = Math.min(ans, D / t);
        }
        return String.format("%.8f", ans);

    }

    public A(Scanner in) {
        D = in.nextInt();
        n = in.nextInt();
        k = new int[n];
        s = new int[n];
        for (int i = 0; i < n; i++) {
            k[i] = in.nextInt();
            s[i] = in.nextInt();
        }
    }

    public static void main(String[] args) throws Exception {
        int nThreads = 4;
        String formatOut = "Case #%2$d: %1$s";
        String formatSystemOut = formatOut;

        String inputFileName = "input.txt";
        String outputFileName = "output.txt";

        Locale.setDefault(Locale.US);
        Scanner in = new Scanner(new File(inputFileName));
        PrintWriter out = new PrintWriter(outputFileName);
        int tests = in.nextInt();
        in.nextLine();//1;
        nThreads = Math.min(nThreads, tests);
        @SuppressWarnings("unchecked")
        Callable<String>[] callables = new Callable[tests];
        for (int t = 0; t < tests; t++) {
            final A testCase = new A(in);
            final int testCaseNumber = t + 1;
            callables[t] = new Callable<String>() {
                @Override
                public String call() {
                    String answer = testCase.solve();
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    return String.format(formatOut, answer, testCaseNumber);
                }
            };
        }
        try {
            if (nThreads > 1) {
                ExecutorService executor = Executors.newFixedThreadPool(4);
                @SuppressWarnings("unchecked")
                Future<String>[] outputs = new Future[tests];
                for (int t = 0; t < tests; t++) {
                    outputs[t] = executor.submit(callables[t]);
                }
                for (int t = 0; t < tests; t++) {
                    out.println(outputs[t].get());
                }
                executor.shutdown();
            } else {
                for (int t = 0; t < tests; t++) {
                    out.println(callables[t].call());
                }
            }
        } catch (Exception e) {
            System.out.flush();
            System.err.flush();
            e.printStackTrace();
            System.exit(1);
        }
        System.out.println("COMPLETE");
        in.close();
        out.close();
    }
}