import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.util.Arrays;

/**
 * Created by vaksenov on 16.01.2016.
 */
public class A {
    public static void main(String[] args) {
        new A().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    String[][] bests;
    int[][][] cnt;
    String moves = "RPS";

    public void precalc() {
        bests = new String[13][3];
        cnt = new int[13][3][3];

        bests[0][0] = "R";
        bests[0][1] = "P";
        bests[0][2] = "S";

        for (int i = 1; i < 12; i++) {
            for (int j = 0; j < 3; j++) {
                String left = bests[i - 1][j];
                String right = bests[i - 1][(j + 2) % 3];
                if (left.compareTo(right) < 0) {
                    bests[i][j] = left + right;
                } else {
                    bests[i][j] = right + left;
                }
                for (int k = 0; k < bests[i][j].length(); k++) {
                    cnt[i][j][moves.indexOf(bests[i][j].charAt(k))]++;
                }
            }
        }
    }

    public void solve() throws IOException {
        int n = nextInt();
        int[] now = new int[] {nextInt(), nextInt(), nextInt()};

        for (int i = 0; i < 3; i++) {
            if (Arrays.equals(now, cnt[n][i])) {
                out.println(bests[n][i]);
                return;
            }
        }
        out.println("IMPOSSIBLE");
    }


    public void run() {
        try {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");

            precalc();

            int t = nextInt();
            for (int i = 0; i < t; i++) {
                out.print("Case #" + (i + 1) + ": ");
                solve();
                System.err.println("Finished " + (i + 1) + " test");
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
