/**
 * Created by Meepo on 1/21/2017.
 */

import java.io.File;
import java.io.PrintWriter;
import java.util.*;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class C {
    long n, k;

    String solve() {
        TreeMap<Long, Long> parts = new TreeMap<>();
        parts.put(n, 1L);
        long s = 0;
        while (k > 0) {
            Map.Entry<Long, Long> entry = parts.pollLastEntry();
            s = entry.getKey();
            k -= entry.getValue();
            long sl = s / 2;
            Long nowl = parts.get(sl);
            nowl = nowl == null ? 0 : nowl;
            parts.put(sl, nowl + entry.getValue());

            long sr = (s - 1) / 2;
            Long nowr = parts.get(sr);
            nowr = nowr == null ? 0 : nowr;
            parts.put(sr, nowr + entry.getValue());
        }
        return (s / 2) + " " + ((s - 1) / 2);
    }

    public C(Scanner in) {
        n = in.nextLong();
        k = in.nextLong();
    }

    public static void main(String[] args) throws Exception {
        int nThreads = 4;
        String formatOut = "Case #%2$d: %1$s";
        String formatSystemOut = formatOut;

        String inputFileName = "input.txt";
        String outputFileName = "output.txt";

        Locale.setDefault(Locale.US);
        Scanner in = new Scanner(new File(inputFileName));
        PrintWriter out = new PrintWriter(outputFileName);
        int tests = in.nextInt();
        in.nextLine();//1;
        nThreads = Math.min(nThreads, tests);
        @SuppressWarnings("unchecked")
        Callable<String>[] callables = new Callable[tests];
        for (int t = 0; t < tests; t++) {
            final C testCase = new C(in);
            final int testCaseNumber = t + 1;
            callables[t] = new Callable<String>() {
                @Override
                public String call() {
                    String answer = testCase.solve();
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    System.out.println(String.format(formatSystemOut, answer, testCaseNumber));
                    return String.format(formatOut, answer, testCaseNumber);
                }
            };
        }
        try {
            if (nThreads > 1) {
                ExecutorService executor = Executors.newFixedThreadPool(4);
                @SuppressWarnings("unchecked")
                Future<String>[] outputs = new Future[tests];
                for (int t = 0; t < tests; t++) {
                    outputs[t] = executor.submit(callables[t]);
                }
                for (int t = 0; t < tests; t++) {
                    out.println(outputs[t].get());
                }
                executor.shutdown();
            } else {
                for (int t = 0; t < tests; t++) {
                    out.println(callables[t].call());
                }
            }
        } catch (Exception e) {
            System.out.flush();
            System.err.flush();
            e.printStackTrace();
            System.exit(1);
        }
        System.out.println("COMPLETE");
        in.close();
        out.close();
    }
}