import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class A {
    public static void main(String[] args) {
        new A().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    String arrow = "v>^<";
    int[] dx = {1, 0, -1, 0};
    int[] dy = {0, 1, 0, -1};

    public void solve() throws IOException {
        int n = nextInt();
        int m = nextInt();
        char[][] c = new char[n][m];
        for (int i  =0; i < n; i++){
            c[i] = nextToken().toCharArray();
        }

        int cnt = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (arrow.indexOf(c[i][j]) == -1) {
                    continue;
                }

                boolean[] bad = new boolean[dx.length];
                int nb = 0;
                for (int k = 0; k < dx.length; k++) {
                    int x = i + dx[k];
                    int y = j + dy[k];
                    while (0 <= x && x < c.length && 0 <= y && y < c[0].length && c[x][y] == '.') {
                        x += dx[k];
                        y += dy[k];
                    }

                    if (x < 0 || x >= c.length || y < 0 || y >= c[0].length) {
                        bad[k] = true;
                        nb++;
                    }
                }

                if (nb == 4)  {
                    out.println("IMPOSSIBLE");
                    return;
                }

                if (bad[arrow.indexOf(c[i][j])]) {
                    cnt++;
                }
            }
        }
        out.println(cnt);
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");

            int t = nextInt();
            for (int i = 0; i < t; i++) {
                out.print(String.format("Case #%d: ", i + 1));
                solve();
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
