import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.StringTokenizer;
import java.util.HashMap;

public class CSmall {
    public static void main(String[] args) {
        new CSmall().run();
    }

    BufferedReader br;
    StringTokenizer in;
    PrintWriter out;

    public String nextToken() throws IOException {
        while (in == null || !in.hasMoreTokens()) {
            in = new StringTokenizer(br.readLine());
        }
        return in.nextToken();
    }

    public int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    public long hashCode(String s) {
        long hc = 0;
        for (int i = 0; i < s.length();i++) {
            hc = hc * 239 + s.charAt(i);
        }
        return hc;
    }

    public void solve() throws IOException {
        int n = nextInt();

        HashMap<String, Integer> ids = new HashMap<String, Integer>();

        int l = 0;
        int[][] sentences = new int[n][];
        for (int i = 0; i < n; i++) {
            String[] line = br.readLine().split(" ");

            sentences[i] = new int[line.length];
            for (int j = 0; j < line.length; j++) {
                if (!ids.containsKey(line[j])) {
                    ids.put(line[j], l++);
                }
                sentences[i][j] = ids.get(line[j]);
            }
        }

        int ans = Integer.MAX_VALUE;
        for (int i = 0; i < 1 << (n - 2); i++) {
            boolean[][] lan = new boolean[2][l];

            for (int j = 0; j < n; j++) {
                int type = j <= 1 ? j : (i >> (j - 2)) & 1;
                for (int word : sentences[j]) {
                    lan[type][word] = true;
                }
            }

            int now = 0;
            for (int j = 0; j < lan[0].length; j++) {
                if (lan[0][j] && lan[1][j]) {
                    now++;
                }
            }
            ans = Math.min(ans, now);
        }
        out.println(ans);
    }

    public void run() {
        try {
            br = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");

            int t = nextInt();
            for (int i = 0; i < t; i++) {
                out.print(String.format("Case #%d: ", i + 1));
                solve();
                System.err.println("Finished: " + i);
            }

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
