/**
 * 
 */
package contest.y2016;

import java.util.ArrayList;
import java.util.List;

/**
 * @author akshay.iyer
 *
 */
public class ProblemC extends CodeJamBaseClass {

	/* (non-Javadoc)
	 * @see contest.y2016.CodeJamBaseClass#initiate()
	 */
	@Override
	public void initiate() {
		// TODO Auto-generated method stub
		int numCases = mScanner.nextInt();
		int caseNum = 0;
		
		while(caseNum < numCases) {
			int _N = mScanner.nextInt();
			int _J = mScanner.nextInt();
			
			List<String> coinList = new ArrayList<String>(); 
			
			long[][] radixMatrix = new long[_N][9];
			
			for(int i = _N - 1; i >= 0; i--)
				for(int j = 0; j < 9; j++) {
					if(i == _N - 1)
						radixMatrix[i][j] = 1;
					else {
						radixMatrix[i][j] = radixMatrix[i+1][j] * (j+2);
					}
				}
			
			//need to make J coins of length N
			
			int coinCounter = 0;
			int counter = 1;

			mPrintWriter.println("Case #" + (caseNum + 1) + ":");
			
			
			while(coinCounter < _J) {
				String coinValue = Integer.toBinaryString(counter);
				int zerosToAdd = _N - coinValue.length() - 1;
				for(int i = 0; i < zerosToAdd; i++) {
					coinValue = "0" + coinValue;
				}
				coinValue = "1" + coinValue;
				
				//we now have a jamcoin candidate
				
				long[] divisors = isJamCoin(coinValue, radixMatrix);
				
				boolean isCandidate = true;
				
				for (int i = 0; i < divisors.length; i++) {
					if(divisors[i] == 0) {
						isCandidate = false;
						break;
					}
				}
				
				if(isCandidate) {
					coinList.add(coinValue);
					coinCounter++;
					mPrintWriter.print(coinValue);
					for(int i =0; i < divisors.length; i++) {
						mPrintWriter.print(" " + divisors[i]);
					}
					mPrintWriter.println("");
				}
				counter+=2;
			}
			
			caseNum++;
		}
	}

	long[] isJamCoin(String coinValue, long[][] radixMatrix) {
		
		char[] charCoin = coinValue.toCharArray();
		long[] longCoin = new long[coinValue.length()]; 
		long[] divisors = new long[9];
		
		for (int i = 0; i < longCoin.length; i++) {
			longCoin[i] = charCoin[i] - '0';
		}
		
		for(int j = 0; j < 9; j++) {
			long number = 0;
			divisors[j] = 0;
			for(int i = 0; i < radixMatrix.length; i++) {
				number += (longCoin[i] * radixMatrix[i][j]);
			}

			long primeFactor = isPrime(number);
			
			if(primeFactor == 1)
				divisors[j] = 0;
			else {
				divisors[j] = primeFactor; 
			}
		}
		
		return divisors;
	}
	
	long isPrime(long number) {
		
		if(number < 3)
			return 1;
		
		if(number%2 == 0)
			return 1;
		
		for(long i = 2; (i*i) < number; i++) {
			if(number % i == 0) 
				return i;
		}
		
		return 1;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ProblemC solver = new ProblemC();
		solver.begin(args);
	}

}
