/**
 * 
 */
package contest;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

/**
 * @author akshay.iyer
 *
 */
public class CurrProblem {

	private static String mInputFileName;
	private static String mOutputFileName;
	private static Scanner mScanner;
	private static PrintWriter mPrintWriter;
	private static int numCases;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		mInputFileName = args[0];
		mOutputFileName = args[1];

		try {
			mScanner = new Scanner(new File(mInputFileName));
			mPrintWriter = new PrintWriter(new File(mOutputFileName));
			initiate();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	private static void initiate() {
		// TODO Auto-generated method stub
		numCases = mScanner.nextInt();
		for(int caseIdx = 0; caseIdx < numCases; caseIdx++) {
			mPrintWriter.print("Case #"+ (caseIdx+1) + ": ");
			readInputs();
		}
		mPrintWriter.close();
	}

	private static void readInputs() {
		int MAXLEVEL = mScanner.nextInt();
		
		String audienceDistribution = mScanner.nextLine();
		audienceDistribution = audienceDistribution.trim();
		
		//mPrintWriter.println(friendsRequired(0, audienceDistribution, MAXLEVEL));
		mPrintWriter.println(friendsRequired2(audienceDistribution, MAXLEVEL));
	}

	private static int friendsRequired2(String audienceDistribution, int MAXLEVEL) {
		
		int audienceSoFar = 0;
		int friendsAdded = 0;
		
		if(audienceDistribution.charAt(0)=='0') {
			friendsAdded = 1;
			audienceSoFar = 1;
		} else 
			audienceSoFar = audienceDistribution.charAt(0)-'0';
		
		for(int i = 1; i <= MAXLEVEL; i++) {
			if(audienceSoFar < i) {
				friendsAdded += (i - audienceSoFar);
				audienceSoFar = i;
			}
			audienceSoFar += (audienceDistribution.charAt(i)-'0'); 
		}
		
		return friendsAdded;
	}
	
	private static int friendsRequired(int k, String audienceDistribution, int MAXLEVEL) {
		// TODO Auto-generated method stub
		
		if(k > MAXLEVEL)
			return 0;
		
		int friends = 0;
		
		int audienceAvailable;
		
		if(audienceDistribution.length() < k)
			return 0; //no further audience available
		else
			audienceAvailable = new Integer((audienceDistribution.charAt(k))-'0').intValue();
		
		if((k == 0)&&(audienceAvailable == 0)) {
			friends = 1;
			audienceDistribution = "1" + audienceDistribution.substring(1);
		} else if(k == 0) {
			friends += friendsRequired(k+1, audienceDistribution, MAXLEVEL);
		} else {
			int totalAudience = 0;
			for(int i = 0; (i < k); i++) {
				totalAudience += (new Integer(audienceDistribution.charAt(i)-'0')).intValue(); 
			}
			if(totalAudience < k) {
				friends = (k - totalAudience);
				int audienceToBeAdded = friends;
				for(int i = 0; ((i < k)&&(audienceToBeAdded > 0)); i++) {
					int currentAudience = (new Integer(audienceDistribution.charAt(i)-'0')).intValue();
					if(audienceToBeAdded >= (9 - currentAudience)) { 
						audienceToBeAdded -= (9 - currentAudience);
						currentAudience = 9;
					} else {
						currentAudience += audienceToBeAdded;
						audienceToBeAdded = 0;
					}
					audienceDistribution = audienceDistribution.substring(0, ((i==0)?0:i-1)) + currentAudience + audienceDistribution.substring(i+1);
				}
			}
		}
		
		friends += friendsRequired(k+1, audienceDistribution, MAXLEVEL);
		
		return friends;
	}
	
	

}
