/**
 * 
 */
package practice;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author akshay.iyer
 *
 */
public class MagicTrick {

	private static String mInputFileName;
	private static String mOutputFileName;
	private static Scanner mScanner;
	private static PrintWriter mPrintWriter;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		mInputFileName = args[0];
		mOutputFileName = args[1];
		
		try {
			mScanner = new Scanner(new File(mInputFileName));
			mPrintWriter = new PrintWriter(new File(mOutputFileName));
			initiate();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	private static void initiate() {
		int numCases = readCases();
		
		for(int i = 0; i < numCases; i++)
			readCase(i+1);

		mPrintWriter.close();
	}
	
	private static int readCases() {
		int numCases = mScanner.nextInt();
		mScanner.nextLine();
		return numCases;
	}
	
	private static final int TOTALCARDS = 16;
	private static final int ROWCOLSIZE = 4;
	
	private static void readCase(int caseNum) {
		mPrintWriter.print("Case #"+caseNum+": ");
		
		//initialize to record responses
		boolean[] whichNumbers = new boolean[TOTALCARDS];
		for(int i = 0; i < TOTALCARDS; i++) {
			whichNumbers[i] = false;
		}
		
		//read first response
		int firstResponse = mScanner.nextInt();
		//start reading rows of cards
		for(int row = 1; row <= ROWCOLSIZE; row++) {
			for(int col = 1; col <= ROWCOLSIZE; col++) {
				int card = mScanner.nextInt();
				if(row == firstResponse) {
					whichNumbers[card-1] = true;
				} else
					whichNumbers[card-1] = false;
			}
		}
		
		int commonCard = 0;
		boolean badmagician = false;
		//read second response
		int secondResponse = mScanner.nextInt();
		//start reading rows of cards
		for(int row = 1; row <= ROWCOLSIZE; row++) {
			for(int col = 1; col <= ROWCOLSIZE; col++) {
				int card = mScanner.nextInt();
				if(row == secondResponse) {
					//if the card was in the previous set, then likely to be common card
					if(whichNumbers[card-1]) {
						//if common card was already assigned, then we have more than two common
						// cards. Bad magician!
						if(commonCard != 0) {
							badmagician = true;
						}
						commonCard = card;
					}
				}
			}
		}
		
		/**if no common cards, volunteer cheats
		 * if only one common card, reveal the card
		 */
		if(badmagician) mPrintWriter.println("Bad magician!");
		else if(commonCard == 0) {
			mPrintWriter.println("Volunteer cheated!");
		} else 
			mPrintWriter.println(commonCard);
	}

}
