/**
 * 
 */
package contest;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

/**
 * @author akshay.iyer
 *
 */
public class CurrProblem {

	private static String mInputFileName;
	private static String mOutputFileName;
	private static Scanner mScanner;
	private static PrintWriter mPrintWriter;
	private static int numCases;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		mInputFileName = args[0];
		mOutputFileName = args[1];

		try {
			mScanner = new Scanner(new File(mInputFileName));
			mPrintWriter = new PrintWriter(new File(mOutputFileName));
			initiate();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	private static void initiate() {
		// TODO Auto-generated method stub
		numCases = mScanner.nextInt();
		for(int caseIdx = 0; caseIdx < numCases; caseIdx++) {
			mPrintWriter.print("Case #"+ (caseIdx+1) + ": ");
			readInputs();
		}
		mPrintWriter.close();
	}

	private static void readInputs() {
		
		int numDiners = mScanner.nextInt();
		int[] pancakeDistribution = new int[numDiners];
		List<Integer> pancakeDist = new ArrayList<Integer>();
		
		for(int i = 0; i < pancakeDistribution.length; i++) {
			pancakeDistribution[i] = mScanner.nextInt();
			pancakeDist.add(pancakeDistribution[i]);
		}
		
//		mPrintWriter.println(minutesRequired(pancakeDistribution));
		//mPrintWriter.println(minutesRequired2(pancakeDistribution, 0));
		//mPrintWriter.println(requiredMinutes(pancakeDistribution, 0));
		mPrintWriter.println(MR(pancakeDist, 0));
	}

	
	
	private static int MR(List<Integer> pancakeDist, int preMoves) {
		int PMax = 0;
		int maxPos = 0, counter = 0;
		for(Iterator<Integer> iter = pancakeDist.iterator(); iter.hasNext(); ) {
			int next = iter.next().intValue();
			if(next > PMax) {
				PMax = next;
				maxPos = counter;
			}
			counter++;
		}
		
		int PowerOfTwo = 0, product = 1;
		
		while(product < PMax) {
			PowerOfTwo++;
			product *= 2;
		}
		if(product > PMax) PowerOfTwo--;
		
		int split = PowerOfTwo;
		if(split <= 1) {
			return (PMax + preMoves);
		}
		
		pancakeDist.remove(maxPos);
		pancakeDist.add(split);
		pancakeDist.add(PMax - split);
		
		int betterMoves = MR(pancakeDist, preMoves+1);
		
		if((PMax + preMoves) < betterMoves) {
			return (PMax + preMoves);
		} else {
			return betterMoves;
		}
	}
	
	private static int minutesRequired2(int[] pancakeDistribution, int minute) {
		//int minutesRequired = 0;

		int currBestScenario, newBestScenario;
		
		currBestScenario = pancakeDistribution[0];
		for(int i = 0; i < pancakeDistribution.length; i++) {
			if(pancakeDistribution[i] > currBestScenario) {
				currBestScenario = pancakeDistribution[i];
			}
		}

		newBestScenario = 1 + (currBestScenario+1)/2;
		
		if(newBestScenario < currBestScenario) {
			for(int i = 0; i < pancakeDistribution.length; i++) {
				if(pancakeDistribution[i] == currBestScenario) {
					pancakeDistribution[i] = (currBestScenario+1)/2;
					break;
				}
			}
			int nextBestScenario = minutesRequired2(pancakeDistribution, minute+1);
			if((newBestScenario+minute) > (nextBestScenario)) {
				return nextBestScenario;
			} else
				return (newBestScenario+minute);
		}
		
		return currBestScenario + minute;
	}

	
	private static int minutesRequired(int[] pancakeDistribution) {
		int minutesRequired = 0;

		int currBestScenario, newBestScenario;
		
		currBestScenario = pancakeDistribution[0];
		for(int i = 0; i < pancakeDistribution.length; i++) {
			if(pancakeDistribution[i] > currBestScenario) {
				currBestScenario = pancakeDistribution[i];
			}
		}

		newBestScenario = 1 + (currBestScenario+1)/2;
		
		while(newBestScenario < (currBestScenario+minutesRequired)) {
			minutesRequired++;
			for(int i = 0; i < pancakeDistribution.length; i++) {
				if(pancakeDistribution[i] == currBestScenario) {
					pancakeDistribution[i] = (currBestScenario+1)/2;
					break;
				}
			}

			int newCurrBestScenario = pancakeDistribution[0];
			
			for(int i = 0; i < pancakeDistribution.length; i++) {
				if(pancakeDistribution[i] > newCurrBestScenario) {
					newCurrBestScenario = pancakeDistribution[i];
				}
			}
			
			if(newCurrBestScenario >= newBestScenario) {
				currBestScenario = newCurrBestScenario;
			} else {
				//newBestScenario = newBestScenario+minutesRequired-1;
				break;
			}
			
			//currBestScenario += minutesRequired;
			
			newBestScenario = 1 + (currBestScenario+1)/2 + minutesRequired;
		}
		
		return newBestScenario;
	}
	
	private static int requiredMinutes(int[] pancakeDistribution, int minutesToAdd) {
		int currBestScenario, newBestScenario;
		
		currBestScenario = pancakeDistribution[0];
		for(int i = 0; i < pancakeDistribution.length; i++) {
			if(pancakeDistribution[i] > currBestScenario) {
				currBestScenario = pancakeDistribution[i];
			}
		}

		newBestScenario = 1 + (currBestScenario+1)/2;
		
		if(newBestScenario < currBestScenario) {
			for(int i = 0; i < pancakeDistribution.length; i++) {
				if(pancakeDistribution[i] == currBestScenario) {
					pancakeDistribution[i] = (currBestScenario+1)/2;
					break;
				}
			}
			
			int newCurrBestScenario = pancakeDistribution[0];
			
			for(int i = 0; i < pancakeDistribution.length; i++) {
				if(pancakeDistribution[i] > newCurrBestScenario) {
					newCurrBestScenario = pancakeDistribution[i];
				}
			}
			
			//int nextBestScenario = requiredMinutes(pancakeDistribution, minutesToAdd+1);
			if(newCurrBestScenario >= newBestScenario)
				return requiredMinutes(pancakeDistribution, minutesToAdd+1);
			else
				return (newBestScenario+minutesToAdd);
//			if(nextBestScenario < (newBestScenario+minutesToAdd)) {
//				return nextBestScenario;
//			} else
//				return newBestScenario+minutesToAdd;
		}
		
		return currBestScenario + minutesToAdd;
	}

}
