import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Locale;
import java.util.Scanner;

/*
 *  @author ShadowfoX
 *  
 *  The program takes the input from the program arguments if provided,
 *  otherwise the input file needs to be hard-coded in main()
 *  
 *  The program generates an output file by the name Output.txt
 *  along with printing the values in the console.
 */
public class CookieClickerAlpha {


	private static Scanner scanner;	

	private static BufferedReader br;

	private static int numberOfTestCases;

	private static long start;
	
	private static PrintWriter writer;
	
	private static double currentTime = 0.0;
	private static double currentRate = 2.0;

	// assume Unicode UTF-8 encoding
	private static final String CHARSET_NAME = "UTF-8";

	// assume language = English, country = US for consistency with System.out.
	private static final Locale LOCALE = Locale.US;
	
	public static void readStringFile(String fileName) throws IOException{   	    
    	ClassLoader classLoader = MagicTrick.class.getClassLoader();
        File classpathRoot = new File(classLoader.getResource("").getPath());
        String fileLocation = classpathRoot.getPath();        
        boolean found = false;
		try {
			br = new BufferedReader(new FileReader(fileLocation + "\\" + fileName));
			found = true;
		} catch (FileNotFoundException e) {
			try {
				br = new BufferedReader(new FileReader(fileLocation.substring(0, fileLocation.length() - 4) + "\\src\\" + fileName));
				found = true;
			}catch(FileNotFoundException e1){
				e1.printStackTrace();
			}
			if(!found)
				e.printStackTrace();
		}
    }

	public static void main(String[] args) throws IOException {
		start = System.currentTimeMillis();
		if(args.length != 0 && args[0] != null){
			readStringFile(args[0]);	
    	}else{
    		readStringFile("B-large.in");
    	}    
    	
		try {
			writer = new PrintWriter("Output.txt", "UTF-8");
		} catch (FileNotFoundException | UnsupportedEncodingException e) {			
			e.printStackTrace();
		}    		
		numberOfTestCases = Integer.valueOf(br.readLine());		
		int testCaseNumber = 1;
		while(testCaseNumber <= numberOfTestCases){
			calculateBestTime(testCaseNumber);
			testCaseNumber++;
		}
		writer.close();
		long now = System.currentTimeMillis();
//		System.out.println((now - start) / 1000.0);
	}

	private static void calculateBestTime(int testCaseNumber) throws IOException {
		double leastTime = 9999999.9;
		currentTime = 0.0;
		currentRate = 2.0;
		double time = 0.0;
		String stringInput = br.readLine();
		String[] stringInputArray = stringInput.split(" ");
		double C = Double.valueOf(stringInputArray[0]);
		double F = Double.valueOf(stringInputArray[1]);
		double X = Double.valueOf(stringInputArray[2]);
		leastTime = X/currentRate;
		while(true){			
			time = generateFarmAndCalculateLeastTime(C, F, X, leastTime);			
			if(time < leastTime){
				leastTime = time;
			}else{
				break;
			}
		}
		System.out.println("Case #" + testCaseNumber + ": " + leastTime);
		writer.println("Case #" + testCaseNumber + ": " + leastTime);
	}

	private static double generateFarmAndCalculateLeastTime(double c, double f, double x, double leastTime) {
		double timeToGenerateNextFarm = c/currentRate;
		currentRate = currentRate + f;
		currentTime = currentTime + timeToGenerateNextFarm;		
		return currentTime + x/currentRate;
	}
}
