import java.awt.List;
import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.util.Locale;
import java.util.Scanner;

/*
 *  @author ShadowfoX
 *  
 *  The program takes the input from the program arguments if provided,
 *  otherwise the input file needs to be hard-coded in main()
 *  
 *  The program generates an output file by the name Output.txt
 *  along with printing the values in the console.
 */
public class MagicTrick {

	private static Scanner scanner;	

	private static BufferedReader br;

	private static int numberOfTestCases;

	private static long start;
	
	private static PrintWriter writer;

	// assume Unicode UTF-8 encoding
	private static final String CHARSET_NAME = "UTF-8";

	// assume language = English, country = US for consistency with System.out.
	private static final Locale LOCALE = Locale.US;

	/**
	 * Create an input stream from a file.
	 */
	public void In(File file) {
		try {
			scanner = new Scanner(file, CHARSET_NAME);
			scanner.useLocale(LOCALE);
		} catch (IOException ioe) {
			System.err.println("Could not open " + file);
		}
	}

	/**
	 * Create an input stream from a filename or web page name.
	 */
	public static void getInputStream(String s) {
		try {
			// first try to read file from local file system
			File file = new File(s);
			if (file.exists()) {
				scanner = new Scanner(file, CHARSET_NAME);
				scanner.useLocale(LOCALE);
				return;
			}
			// next try for files included in jar
			URL url = StoreCredit.class.getResource(s);
			// or URL from web
			if (url == null) {
				url = new URL(s);
			}
			URLConnection site = url.openConnection();

			// in order to set User-Agent, replace above line with these two
			// HttpURLConnection site = (HttpURLConnection)
			// url.openConnection();
			// site.addRequestProperty("User-Agent", "Mozilla/4.76");

			InputStream is = site.getInputStream();
			scanner = new Scanner(new BufferedInputStream(is), CHARSET_NAME);
			scanner.useLocale(LOCALE);
		} catch (IOException ioe) {
			System.err.println("Could not open " + s);
		}
	}
	
	public static void readStringFile(String fileName) throws IOException{
    	String sCurrentLine;    	    	
    	ClassLoader classLoader = MagicTrick.class.getClassLoader();
        File classpathRoot = new File(classLoader.getResource("").getPath());
        String fileLocation = classpathRoot.getPath();        
        boolean found = false;
		try {
			br = new BufferedReader(new FileReader(fileLocation + "\\" + fileName));
			found = true;
		} catch (FileNotFoundException e) {
			try {
				br = new BufferedReader(new FileReader(fileLocation.substring(0, fileLocation.length() - 4) + "\\src\\" + fileName));
				found = true;
			}catch(FileNotFoundException e1){
				e1.printStackTrace();
			}
			if(!found)
				e.printStackTrace();
		}
    }

	public static void main(String[] args) throws IOException {
		start = System.currentTimeMillis();
		if(args.length != 0 && args[0] != null){
			readStringFile(args[0]);	
    	}else{
    		readStringFile("A-small-practice.in");
    	}    
    	
		try {
			writer = new PrintWriter("Output.txt", "UTF-8");
		} catch (FileNotFoundException | UnsupportedEncodingException e) {			
			e.printStackTrace();
		}    		
		numberOfTestCases = Integer.valueOf(br.readLine());		
		int testCaseNumber = 1;
		while(testCaseNumber <= numberOfTestCases){
			searchForTheCard(testCaseNumber);
			testCaseNumber++;
		}
		
		long now = System.currentTimeMillis();
//		System.out.println((now - start) / 1000.0);
	}

	private static void searchForTheCard(int testCaseNumber) throws NumberFormatException, IOException {
		int firstChoice = Integer.valueOf(br.readLine());
		for(int i=0; i<firstChoice-1; i++){
			br.readLine();
		}
		String firstRequiredRow = br.readLine();
		String[] firstRequiredRowArray = firstRequiredRow.split(" ");
		int[] firstIntegerArray = new int[4];
		for(int j=0; j<4; j++){
			firstIntegerArray[j] = Integer.valueOf(firstRequiredRowArray[j]);
		}
		for(int k=firstChoice; k<4; k++){
			br.readLine();
		}
		
		int secondChoice = Integer.valueOf(br.readLine());
		for(int m=0; m<secondChoice-1; m++){
			br.readLine();
		}
		String secondRequiredRow = br.readLine();
		String[] secondRequiredRowArray = secondRequiredRow.split(" ");
		int[] secondIntegerArray = new int[4];
		for(int n=0; n<4; n++){
			secondIntegerArray[n] = Integer.valueOf(secondRequiredRowArray[n]);
		}
		for(int p=secondChoice; p<4; p++){
			br.readLine();
		}
		
		int found = 0;
		int foundNumber = 0;
		for(int i=0; i<4; i++){
			for(int j=0; j<4; j++){
				if(firstIntegerArray[i] == secondIntegerArray[j]){
					found++;
					foundNumber = firstIntegerArray[i];
				}
			}
		}
		
		if(found == 0){
			System.out.println("Case #" + testCaseNumber + ": " + "Volunteer cheated!");
			writer.println("Case #" + testCaseNumber + ": " + "Volunteer cheated!");
		} else if (found ==1){
			System.out.println("Case #" + testCaseNumber + ": " + foundNumber);
			writer.println("Case #" + testCaseNumber + ": " + foundNumber);
		} else if (found > 1){
			System.out.println("Case #" + testCaseNumber + ": " + "Bad magician!");
			writer.println("Case #" + testCaseNumber + ": " + "Bad magician!");
		}
	}
}
