/*
 * Code Author: Akshay Miterani
 * DA-IICT
 */
import java.io.*;
import java.math.*;
import java.util.*;

public class MainA {

	InputReader in;
	PrintWriter out;
	MainA() throws IOException {
		in = new InputReader(System.in);
		out = new PrintWriter(System.out);
		//in = new InputReader(new FileInputStream("input_.txt"));
		//out = new PrintWriter(new File("output_.txt"));
		solve();
		out.close();
	}

	public static void main(String args[]) {
		new Thread(null, new Runnable() {
			public void run() {
				try {
					new MainA();
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		}, "1", 1 << 26).start();
	}

	//--------------------My Code Starts Here----------------------
	public void solve() throws IOException{
		
	}
	//---------------------My Code Ends Here-----------------------
	
	//---------------------All Main Methods-----------------------
	private HashMap<String, String> login_database=new HashMap<>();
	private HashMap<Integer, Complain> complain_databse=new HashMap<>();
	private HashMap<Integer, Inspector> inspector_database=new HashMap<>();
	private HashMap<Integer, Constructor> constructor_database=new HashMap<>();
	private List<Infrastructure> list=new LinkedList<>();
	
	private int complain_counter=0;
	private int inspector_counter=0;
	private int constructor_counter=0;
	
	public boolean addUser(String username, String password){
		if(login_database.containsKey(username))
			return false;
		login_database.put(username, password);
		return true;
	}
	
	public int addInspector(String value){
		inspector_database.put(inspector_counter, new Inspector(inspector_counter, value));
		return inspector_counter++;
	}
	
	public int addConstructor(String value){
		constructor_database.put(constructor_counter, new Constructor(constructor_counter, value));
		return constructor_counter++;
	}
	
	public boolean login(String username, String password){
		if(login_database.containsKey(username) && login_database.get(username).equals(password))
			return true;
		return false;
	}
	
	public int register_complain(String message){
		Complain complain_object=new Complain(complain_counter, message);
		complain_databse.put(complain_counter, complain_object);
		return complain_counter++;
	}
	
	public String complain_status(int id){
		if(!complain_databse.containsKey(id))
			return "Not Valid ID";
		return complain_databse.get(id).isStatus()?"Resolved":"Pending";
	}
	
	public void printProjects(){
		for(Infrastructure i:list)
			System.out.println(i);
	}
	
	//---------------------All my classes-----------------------
	abstract class Infrastructure{
		private int ID;
		private String name;
		public int getID() {
			return ID;
		}
		public void setID(int iD) {
			ID = iD;
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
	}
	
	class Road extends Infrastructure{
		private int road_width, travel_time, tunrarounds;
		
		public int getRoad_width() {
			return road_width;
		}

		public void setRoad_width(int road_width) {
			this.road_width = road_width;
		}

		public int getTravel_time() {
			return travel_time;
		}

		public void setTravel_time(int travel_time) {
			this.travel_time = travel_time;
		}

		public int getTunrarounds() {
			return tunrarounds;
		}

		public void setTunrarounds(int tunrarounds) {
			this.tunrarounds = tunrarounds;
		}

		public Road(int ID) {
			this.setID(ID);
		}
	}
	
	class Dam extends Infrastructure{
		private int length, height;
		private String location;
		
		public Dam(int ID) {
			this.setID(ID);
		}
		
		public int getLength() {
			return length;
		}

		public void setLength(int length) {
			this.length = length;
		}

		public int getHeight() {
			return height;
		}

		public void setHeight(int height) {
			this.height = height;
		}

		public String getLocation() {
			return location;
		}

		public void setLocation(String location) {
			this.location = location;
		}

	}
	
	class Bridge extends Infrastructure{
		private int length, height;
		private String location;
		
		public Bridge(int ID) {
			this.setID(ID);
		}
		
		public int getLength() {
			return length;
		}

		public void setLength(int length) {
			this.length = length;
		}

		public int getHeight() {
			return height;
		}

		public void setHeight(int height) {
			this.height = height;
		}

		public String getLocation() {
			return location;
		}

		public void setLocation(String location) {
			this.location = location;
		}

	}
	
	class Constructor{
		private int ID, experience;
		private String name;
		public Constructor(int ID, String name) {
			this.ID=ID;
			this.name=name;
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public int getID() {
			return ID;
		}
		public void setID(int iD) {
			ID = iD;
		}
		public int getExperience() {
			return experience;
		}
		public void setExperience(int experience) {
			this.experience = experience;
		}
		@Override
		public String toString() {
			return "Constructor [ID=" + ID + ", name=" + name + "]";
		}
	}
	
	class Inspector{
		private int ID, experience;
		private String name;
		private HashSet<Integer> busyOn;
		public Inspector(int ID, String name) {
			this.ID=ID;
			this.name=name;
			busyOn=new HashSet<Integer>();
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public int getID() {
			return ID;
		}
		public void setID(int iD) {
			ID = iD;
		}
		public int getExperience() {
			return experience;
		}
		public void setExperience(int experience) {
			this.experience = experience;
		}
		public boolean checkAvailable(int date){
			if(busyOn.contains(date))
				return false;
			return true;
		}
		public boolean assign(int date){
			return busyOn.add(date);
		}
		@Override
		public String toString() {
			return "Inspector [ID=" + ID + ", name=" + name + "]";
		}
		
	}
	
	class Complain{
		private int ID;
		private String message;
		private boolean status;
		Complain(int ID, String message){
			this.ID=ID;
			this.message=message;
			status=false;
		}
		public boolean isStatus() {
			return status;
		}
		public void setStatus(boolean status) {
			this.status = status;
		}
		public int getID() {
			return ID;
		}
		public void setID(int iD) {
			ID = iD;
		}
		public String getMessage() {
			return message;
		}
		public void setMessage(String message) {
			this.message = message;
		}
		@Override
		public String toString() {
			return "Complain [ID=" + ID + ", message=" + message + "]";
		}
	}
	
	static final class InputReader{
		private final InputStream stream;
		private final byte[] buf=new byte[1024];
		private int curChar;
		private int numChars;
		public InputReader(InputStream stream){this.stream=stream;}
		private int read()throws IOException{
			if(curChar>=numChars){
				curChar=0;
				numChars=stream.read(buf);
				if(numChars<=0)
					return -1;
			}
			return buf[curChar++];
		}
		
		public final int nextInt()throws IOException{return (int)nextLong();}
		public final long nextLong()throws IOException{
			int c=read();
			while(isSpaceChar(c)){
				c=read();
				if(c==-1) throw new IOException();
			}
			boolean negative=false;
			if(c=='-'){
				negative=true;
				c=read();
			}
			long res=0;
			do{
				if(c<'0'||c>'9')throw new InputMismatchException();
				res*=10;
				res+=(c-'0');
				c=read();
			}while(!isSpaceChar(c));
			return negative?(-res):(res);
		}
		public final int[] readIntBrray(int size)throws IOException{
			int[] arr=new int[size];
			for(int i=0;i<size;i++)arr[i]=nextInt();
			return arr;
		}
		public final String next()throws IOException{
			int c=read();
			while(isSpaceChar(c))c=read();
			StringBuilder res=new StringBuilder();
			do{
				res.append((char)c);
				c=read();
			}while(!isSpaceChar(c));
			return res.toString();
		}
		public final String nextLine()throws IOException{
			int c=read();
			while(isSpaceChar(c))c=read();
			StringBuilder res=new StringBuilder();
			do{
				res.append((char)c);
				c=read();
			}while(c!='\n'&&c!=-1);
			return res.toString();
		}
		private boolean isSpaceChar(int c){
			return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
		}
	}
} 