/*
 * Solver.java
 * 
 */

package round.two.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

/**
 * @author akz
 */
public class Solver {

    private static final String SAMPLE = "_sample.in";
    private static final String SMALL = "A-small-attempt2.in";
    private static final String LARGE = "A-large.in";
    private static final String OUT = "problem.out";

    public static void main(String[] args) throws Exception {

      File in = new File(Solver.class.getResource(SMALL).getFile());
      System.out.println(in);

      BufferedReader reader = new BufferedReader(new FileReader(in));
      String line = reader.readLine();
      int cases = Integer.valueOf(line);
      
      List results = new ArrayList();
      for (int i = 0; i < cases; i++) {
        line = reader.readLine();
        String[] tokens = line.split(" ");
        List digits = new ArrayList();
        String phone = tokens[0];
        while (phone.contains("Z")) {
          phone = phone.replaceFirst("Z", "");
          phone = phone.replaceFirst("E", "");
          phone = phone.replaceFirst("R", "");
          phone = phone.replaceFirst("O", "");
          digits.add(Integer.valueOf(0));
        }
        while (phone.contains("W")) {
          phone = phone.replaceFirst("T", "");
          phone = phone.replaceFirst("W", "");
          phone = phone.replaceFirst("O", "");
          digits.add(Integer.valueOf(2));
        }
        while (phone.contains("U")) {
          phone = phone.replaceFirst("F", "");
          phone = phone.replaceFirst("O", "");
          phone = phone.replaceFirst("U", "");
          phone = phone.replaceFirst("R", "");
          digits.add(Integer.valueOf(4));
        }
        while (phone.contains("X")) {
          phone = phone.replaceFirst("S", "");
          phone = phone.replaceFirst("I", "");
          phone = phone.replaceFirst("X", "");
          digits.add(Integer.valueOf(6));
        }
        while (phone.contains("G")) {
          phone = phone.replaceFirst("E", "");
          phone = phone.replaceFirst("I", "");
          phone = phone.replaceFirst("G", "");
          phone = phone.replaceFirst("H", "");
          phone = phone.replaceFirst("T", "");
          digits.add(Integer.valueOf(8));
        }
        while (phone.contains("O")) {
          phone = phone.replaceFirst("O", "");
          phone = phone.replaceFirst("N", "");
          phone = phone.replaceFirst("E", "");
          digits.add(Integer.valueOf(1));
        }
        while (phone.contains("S")) {
          phone = phone.replaceFirst("S", "");
          phone = phone.replaceFirst("E", "");
          phone = phone.replaceFirst("V", "");
          phone = phone.replaceFirst("E", "");
          phone = phone.replaceFirst("N", "");
          digits.add(Integer.valueOf(7));
        }
        while (phone.contains("H")) {
          phone = phone.replaceFirst("T", "");
          phone = phone.replaceFirst("H", "");
          phone = phone.replaceFirst("R", "");
          phone = phone.replaceFirst("E", "");
          phone = phone.replaceFirst("E", "");
          digits.add(Integer.valueOf(3));
        }
        while (phone.contains("F")) {
          phone = phone.replaceFirst("F", "");
          phone = phone.replaceFirst("I", "");
          phone = phone.replaceFirst("V", "");
          phone = phone.replaceFirst("E", "");
          digits.add(Integer.valueOf(5));
        }
        while (phone.contains("N")) {
          phone = phone.replaceFirst("N", "");
          phone = phone.replaceFirst("I", "");
          phone = phone.replaceFirst("N", "");
          phone = phone.replaceFirst("E", "");
          digits.add(Integer.valueOf(9));
        }
        Collections.sort(digits);
        StringBuilder result = new StringBuilder();
        for (Iterator it = digits.iterator(); it.hasNext();) {
          result.append((Integer)it.next());
        }
        results.add(result.toString());
      }
      reader.close();

      BufferedWriter writer = new BufferedWriter(
              new OutputStreamWriter(new FileOutputStream(new File(in.getParent(), OUT)), "ISO-8859-1"));

      int counter = 1;
      for (Iterator it = results.iterator(); it.hasNext();) {
        String resultLine = (String) it.next();
        writer.write("Case #" + counter + ": " + resultLine);
        if (it.hasNext()) {
          counter++;
          writer.newLine();
        }
      }
      writer.close();
    }

}
