/*
 * Solver.java
 * 
 * Created on 15 Apr 2016
 */

package round.two.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author akz
 */
public class Solver {

    private static final String SAMPLE = "_sample.in";
    private static final String SMALL = "B-small-attempt0.in";
    private static final String LARGE = "B-large.in";
    private static final String OUT = "problem.out";

    public static void main(String[] args) throws Exception {

      File in = new File(Solver.class.getResource(SMALL).getFile());

      BufferedReader reader = new BufferedReader(new FileReader(in));
      String line = reader.readLine();
      int cases = Integer.valueOf(line);
      List results = new ArrayList();
      
      for (int i = 0; i < cases; i++) {
        line = reader.readLine();
        String[] tokens = line.split(" ");
        String[] coderTokens = tokens[0].split("");
        String[] jammerTokens = tokens[1].split("");
        StringBuilder codersScore = new StringBuilder();
        StringBuilder jammersScore = new StringBuilder();
        for (int j = 0; j < coderTokens.length; j++) {
          String codersDigit = coderTokens[j];
          String jammersDigit = jammerTokens[j];
          // two question marks or same digit
          if (codersDigit.equals(jammersDigit)) {
            if (codersDigit.equals("?")) {
              // two question marks
              // if at the end and the previous digit was not the same
              if (((j+1) == coderTokens.length) && codersScore.toString().length()>0) {
                int codersScoreSoFar = Integer.valueOf(codersScore.toString());
                int jammersScoreSoFar = Integer.valueOf(jammersScore.toString());
                if (codersScoreSoFar == jammersScoreSoFar) {
                  codersScore.append("0");
                  jammersScore.append("0");
                } else if (codersScoreSoFar > jammersScoreSoFar) {
                  codersScore.append("0");
                  jammersScore.append("9");
                } else {
                  codersScore.append("9");
                  jammersScore.append("0");
                }
              } else {
                codersScore.append("0");
                jammersScore.append("0");
              }
            } else {
              // two same digits
              codersScore.append(codersDigit);
              jammersScore.append(jammersDigit);
            }
          } else {
            // coders has question mark
            if (codersDigit.equals("?")) {
              codersScore.append(jammersDigit);
              jammersScore.append(jammersDigit);
            } else if (jammersDigit.equals("?")) {
              // jammers has question mark
              codersScore.append(codersDigit);
              jammersScore.append(codersDigit);
            } else {
              // both are digits and different
              codersScore.append(codersDigit);
              jammersScore.append(jammersDigit);
            }
          }
        }

        results.add(codersScore.toString() + " " + jammersScore.toString());
      }
      reader.close();

      BufferedWriter writer = new BufferedWriter(
              new OutputStreamWriter(new FileOutputStream(new File(in.getParent(), OUT)), "ISO-8859-1"));

      int counter = 1;
      for (Iterator it = results.iterator(); it.hasNext();) {
        String resultLine = (String) it.next();
        writer.write("Case #" + counter + ": " + resultLine);
        if (it.hasNext()) {
          counter++;
          writer.newLine();
        }
      }
      
      writer.close();
    }

    private static String calculate() {
      return String.valueOf("");
    }

}
