/*
 * PancakesMinifier.java
 * 
 * Created on 9 Apr 2016
 */

package problem.c;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author akz
 */
public class JamCoinFinder {
    
    public static void main(String[] args) throws Exception {
        int digits = 16;
        int samples = 50;
        
        int max = ((int) Math.pow(2, digits));
        System.out.println(max);
        int minWithLeadingOne = ((int) Math.pow(2, (digits-1)));
        System.out.println(minWithLeadingOne);

        List results = new ArrayList();
        
        // don't iterate numbers that start with zero
        for (int i=minWithLeadingOne; i<max; i++) {
          // remove even numbers, because they don't end 1
          if (i%2 == 0) {
            continue;
          }
          // remove prime numbers, because when binary is tranformed to 2 base, we will exclude prime numbers
          long divisor = getDivisorOfNumber(i);
          if (divisor == 0) {
            continue;
          }
          
          String binary = Integer.toBinaryString(i);
          List divisors = new ArrayList();
          for (int j = 3; j <= 10; j++) {
            long number = convertToBase(binary, j);
            long anotherDivisor = getDivisorOfNumber(number);
            //System.out.println("("+j+") " + number + ": " + anotherDivisor);
            if (anotherDivisor == 0) {
              break;
            } else {
              divisors.add(anotherDivisor);
            }
          }

          if (divisors.size() == 8) {
            StringBuilder result = new StringBuilder();
            result.append(binary);
            result.append(" ");
            result.append(divisor);
            for (Iterator it = divisors.iterator(); it.hasNext();) {
              Long value = (Long) it.next();
              result.append(" ");
              result.append(value);
            }
            results.add(result.toString());
          }

          if (results.size() == samples) {
            break;
          }
        }

        for (Iterator it = results.iterator(); it.hasNext();) {
          String result = (String) it.next();
          System.out.println(result);
        }

        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("D:\\projects\\code-jam\\inputs\\c\\problem.out"), "iso-8859-1"));
        writer.write("Case #1:");
        writer.newLine();
        for (Iterator it = results.iterator(); it.hasNext();) {
          String result = (String) it.next();
          System.out.println(result);
          writer.write(result);
          if (it.hasNext()) {
            writer.newLine();
          }
        }
        writer.close();
    }

    private static long convertToBase(String input, int base) {
      return Long.parseLong(input, base);
    }

    private static long getDivisorOfNumber(long n) {
      // check if n is a multiple of 2
      if (n%2==0) return 2;
      // if not, then just check the odds
      for(long i=3; i*i<=n; i+=2) {
        if (n%i==0) {
          return i;
        }
      }
      return 0;
    }

    

}
