/*
 * Solver.java
 * 
 */

package round.three.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;

/**
 * @author akz
 */
public class Solver {

    private static final String SAMPLE = "_sample.in";
    private static final String SMALL = "A-small-attempt1.in";
    private static final String LARGE = "A-large.in";
    private static final String OUT = "problem.out";

    public static void main(String[] args) throws Exception {

      File in = new File(Solver.class.getResource(LARGE).getFile());
      System.out.println(in);

      BufferedReader reader = new BufferedReader(new FileReader(in));
      String line = reader.readLine();
      int cases = Integer.valueOf(line);

      List alphabet = Arrays.asList(new String[]{"A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"});
      List results = new ArrayList();
      for (int i = 0; i < cases; i++) {
        line = reader.readLine();
        int parties = Integer.valueOf(line);
        String senatorsCombination = reader.readLine();
        String[] senatorsPerParty = senatorsCombination.split(" ");
        int totalNumberOfSenators = 0;
        List p = new ArrayList();
        for (int j = 0; j < senatorsPerParty.length; j++) {
          int senators = Integer.valueOf(senatorsPerParty[j]);
          String party = "";
          for (int x = 0; x < senators; x++) {
            party += alphabet.get(j);
          }
          p.add(party);
          totalNumberOfSenators += senators;
        }
        p = orderParties(p);
        String evacuationPlan = "";
        while (p.size() > 0) {
          String evacuationStep = "";
          int limit = evacuationStep(p);
          for (int k = 0; k < limit; k++) {
            if (p.size()>0) {
              String partyString = (String)p.get(0);
              String letter = partyString.substring(0, 1);
              evacuationStep += letter;
              String remaining = partyString.length()>=1 ? partyString.substring(1) : "";
              p.set(0, remaining);
              p = orderParties(p);
            }
          }
          if (evacuationStep.length() > 0) {
            evacuationPlan += " " + evacuationStep;
          }
        }
        System.out.println(evacuationPlan.trim());
        results.add(evacuationPlan.trim());
      }
      reader.close();

      BufferedWriter writer = new BufferedWriter(
              new OutputStreamWriter(new FileOutputStream(new File(in.getParent(), OUT)), "ISO-8859-1"));

      int counter = 1;
      for (Iterator it = results.iterator(); it.hasNext();) {
        String resultLine = (String) it.next();
        writer.write("Case #" + counter + ": " + resultLine);
        if (it.hasNext()) {
          counter++;
          writer.newLine();
        }
      }
      writer.close();
    }

    private static List orderParties(List p) {
      List parties = new ArrayList();
      for (Iterator it = p.iterator(); it.hasNext();) {
        String party = (String) it.next();
        if (party.length() != 0) {
          parties.add(party);
        }
      }
      Collections.sort(parties, new Comparator(){
        public int compare(Object o1, Object o2) {
          return ((String) o1).length() - ((String) o2).length();
        }
      });
      Collections.reverse(parties);
      return parties;
    }

    private static int evacuationStep(List p) {
      if (p.size() % 2 != 0) {
        if (p.size() > 1) {
          String a = (String) p.get(0);
          String b = (String) p.get(1);
          if (a.length() == b.length()) {
            return 1;
          }
        }
      }
      return 2;
    }

}
