package qualification.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class Solver {

    private static final String SAMPLE = "_sample.in";
    private static final String SMALL = "B-small-attempt0.in";
    private static final String LARGE = "B-large.in";
    private static final String OUT = "problem.out";

    public static void main(String[] args) throws Exception {

        File in = new File(Solver.class.getResource(LARGE).getFile());

        BufferedReader reader = new BufferedReader(new FileReader(in));
        String line = reader.readLine();
        int cases = Integer.valueOf(line);

        List results = new ArrayList();
        for (int i = 0; i < cases; i++) {
            String input = reader.readLine();
            long number = Long.parseLong(input);
            if (input.endsWith("0")) {
                number = number - 1;
                input = String.valueOf(number);
            }
            if (number < 10) {
                results.add(input);
                continue;
            }
            if (input.replaceAll(String.valueOf(input.charAt(0)), "").length() == 0) {
                results.add(input);
                continue;
            }
            int originalInputLength = input.length();
            for (int j = originalInputLength - 1; j > 0; j--) {
                int current = Integer.valueOf(input.substring(j, j + 1));
                int previous = Integer.valueOf(input.substring(j - 1, j));
                if (previous > current) {
                    String prefix = input.substring(0, j);
                    long calc = Long.valueOf(prefix) - 1;
                    input = String.valueOf(calc) + String.join("", Collections.nCopies(input.length()-j, "9"));
                    if (originalInputLength > input.length()) {
                        j--;
                    }
                }
            }
            while (input.startsWith("0") && input.length()>1) {
                input = input.substring(1);
            }
            results.add(input);
        }
        reader.close();

        BufferedWriter writer = new BufferedWriter(
            new OutputStreamWriter(new FileOutputStream(new File(in.getParent(), OUT)), "ISO-8859-1"));

        int counter = 1;
        for (Iterator it = results.iterator(); it.hasNext();) {
            String resultLine = (String) it.next();
            writer.write("Case #" + counter + ": " + resultLine);
            if (it.hasNext()) {
                counter++;
                writer.newLine();
            }
        }
        writer.close();
    }
}
