package qualification.c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

public class Solver {

    private static final String SAMPLE = "_sample.in";
    private static final String SMALL = "C-small-1-attempt2.in";
    private static final String LARGE = "C-large.in";
    private static final String OUT = "problem.out";

    public static void main(String[] args) throws Exception {

        File in = new File(Solver.class.getResource(SMALL).getFile());

        BufferedReader reader = new BufferedReader(new FileReader(in));
        String line = reader.readLine();
        int cases = Integer.valueOf(line);

        List results = new ArrayList();
        for (int i = 0; i < cases; i++) {
            String[] tokens = reader.readLine().split(" ");
            long n = Long.parseLong(tokens[0]);
            int k = Integer.parseInt(tokens[1]);
            if (n == k) {
                results.add("0 0");
                continue;
            }
            List<Long> emptySpaces = new ArrayList<Long>();
            emptySpaces.add(Long.valueOf(n));
            for (long j = 1; j <= k; j++) {
                Collections.sort(emptySpaces); // ascending order
                long space = emptySpaces.remove(emptySpaces.size()-1);
                long leftEmpty = getLeftEmptyValue(space);
                long rightEmpty = getRightEmptyValue(space);
                if (leftEmpty>0) {
                    emptySpaces.add(leftEmpty);
                }
                if (rightEmpty>0) {
                    emptySpaces.add(rightEmpty);
                }
                if (j==k) {
                    long max = Math.max(leftEmpty, rightEmpty);
                    long min = Math.min(leftEmpty, rightEmpty);
                    results.add(max + " " + min);
                }
            }
        }
        reader.close();

        BufferedWriter writer = new BufferedWriter(
            new OutputStreamWriter(new FileOutputStream(new File(in.getParent(), OUT)), "ISO-8859-1"));

        int counter = 1;
        for (Iterator it = results.iterator(); it.hasNext();) {
            String resultLine = (String) it.next();
            writer.write("Case #" + counter + ": " + resultLine);
            if (it.hasNext()) {
                counter++;
                writer.newLine();
            }
        }
        writer.close();
    }
    
    private static final long getLeftEmptyValue(long n) {
        if (n%2 == 0) {
            return (n/2)-1;
        }
        return (n-1)/2;
    }
    
    private static final long getRightEmptyValue(long n) {
        if (n%2 == 0) {
            return n/2;
        }
        return (n-1)/2;
    }
}


