package qualification.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Solver {

    private static final String SAMPLE = "_sample.in";
    private static final String SMALL = "small.in";
    private static final String LARGE = "A-large.in";
    private static final String OUT = "problem.out";

    public static void main(String[] args) throws Exception {

        File in = new File(Solver.class.getResource(SMALL).getFile());

        BufferedReader reader = new BufferedReader(new FileReader(in));
        String line = reader.readLine();
        int cases = Integer.valueOf(line);

        List results = new ArrayList();
        for (int i = 0; i < cases; i++) {
            line = reader.readLine();
            String[] tokens = line.split(" ");
            String input = tokens[0];
            int k = Integer.valueOf(tokens[1]);
            results.add(calculateFlips(input, k));
        }
        reader.close();

        BufferedWriter writer = new BufferedWriter(
            new OutputStreamWriter(new FileOutputStream(new File(in.getParent(), OUT)), "ISO-8859-1"));

        int counter = 1;
        for (Iterator it = results.iterator(); it.hasNext();) {
            String resultLine = (String) it.next();
            writer.write("Case #" + counter + ": " + resultLine);
            if (it.hasNext()) {
                counter++;
                writer.newLine();
            }
        }
        writer.close();
    }

    private static String calculateFlips(String input, int k) {
        int s = input.length();
        if (input.replaceAll("\\+", "").length() == 0) {
            return "0";
        }
        if (input.replaceAll("-", "").length() == 0) {
            if (s%k == 0) {
                return String.valueOf(s/k);
            } else {
                return "IMPOSSIBLE";
            }
        }
        if (s==k) {
            return "IMPOSSIBLE";
        }
        int flipsRequired = 0;
        while (input.length() > 0) {
            if (input.startsWith("+")) {
                input = input.replaceFirst("\\+", "");
                continue;
            }
            if (input.length() < k) {
                return "IMPOSSIBLE";
            }
            // at this point input begins with - and we can flip
            String prefix = input.substring(0, k);
            String suffix = input.substring(k);
            String replacement = "";
            String[] tokens = prefix.split("");
            for (int i = 0; i < tokens.length; i++) {
                replacement += flip(tokens[i]);
            }
            input = replacement + suffix;
            flipsRequired++;
            
        }
        return String.valueOf(flipsRequired);
    }
    
    public static String flip(String character) {
        if (character.equals("+")) {
            return "-";
        }
        return "+";
    }
}
