import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    int n;
    double[][][] dp;

    double[] prob;

    public void solve(int testNumber, InputReader jin, PrintWriter jout) {
        n = jin.int32();
        int k = jin.int32();
        prob = new double[n];
        for(int i = 0; i < n; i++) {
            prob[i] = Double.parseDouble(jin.token());
        }

        double sol = 0;
        for(int i = 0; i < (1 << n); i++) {
            if(Integer.bitCount(i) != k) continue;
            double tsol = bt(0, i, 0);
            sol = Math.max(sol, tsol);
        }

        jout.printf("Case #%d: %.9f\n", testNumber, sol);
    }

    private double bt(int cn, int mask, int yi) {
        if(cn >= n) {
            return yi == 0? 1 : 0;
        } else {
            if(((1 << cn) & mask) > 0) {
                double d1 = prob[cn] * bt(cn + 1, mask, yi + 1);
                double d2 = (1 - prob[cn]) * bt(cn + 1, mask, yi - 1);
                return d1 + d2;
            } else {
                return bt(cn + 1, mask, yi);
            }
        }
    }

}

class InputReader {
    private static final int bufferMaxLength = 1024;
    private InputStream in;
    private byte[] buffer;
    private int currentBufferSize;
    private int currentBufferTop;
    private static final String tokenizers = " \t\r\f\n";

    public InputReader(InputStream stream) {
        this.in = stream;
        buffer = new byte[bufferMaxLength];
        currentBufferSize = 0;
        currentBufferTop = 0;
    }

    private boolean refill() {
        try {
            this.currentBufferSize = this.in.read(this.buffer);
            this.currentBufferTop = 0;
        } catch(Exception e) {}
        return this.currentBufferSize > 0;
    }

    public String line() {
        StringBuffer tok = new StringBuffer();
        Byte first;
        while((first = readChar()) != null) {
            tok.append((char)first.byteValue());
            if((char)first.byteValue() == '\n')
                break;
        }
        return tok.toString();
    }

    public Byte readChar() {
        if(currentBufferTop < currentBufferSize) {
            return this.buffer[this.currentBufferTop++];
        } else {
            if(!this.refill()) {
                return null;
            } else {
                return readChar();
            }
        }
    }

    public String token()  {
        StringBuffer tok = new StringBuffer();
        Byte first;
        while((first = readChar()) != null && (tokenizers.indexOf((char) first.byteValue()) != -1));
        if(first == null) return null;
        tok.append((char)first.byteValue());
        while((first = readChar()) != null && (tokenizers.indexOf((char) first.byteValue()) == -1)) {
            tok.append((char)first.byteValue());
        }
        return tok.toString();
    }


    public String next() {
        return token();
    }

    public Integer int32() throws NumberFormatException {
        String tok = token();
        return tok == null? null : Integer.parseInt(tok);
    }

    public Long int64() throws NumberFormatException {
        String tok = token();
        return tok == null? null : Long.parseLong(tok);
    }
}

