import java.io.OutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream = System.in;
		OutputStream outputStream = System.out;
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskA solver = new TaskA();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskA {

    int n;
    int r;
    int s;
    int p;

    public void solve(int testNumber, InputReader jin, PrintWriter jout) {
        n = jin.int32();
        r = jin.int32();
        p = jin.int32();
        s = jin.int32();

        jout.print("Case #" + testNumber + ": ");
        boolean found = false;
        for(int j = 0; j < 3; j++) {
            int[] vals = new int[]{0, 0, 0};
            vals[j] = 1;
            for (int i = 0; i < n; i++) {
                int[] tVals = new int[]{0, 0, 0};
                for(int k = 0; k < 3; k++) {
                    tVals[k] += vals[k];
                    tVals[(k + 2) % 3] += vals[k];
                }
                vals = tVals;
            }

            if(vals[0] != r) continue;
            if(vals[1] != p) continue;
            if(vals[2] != s) continue;

            found = true;
            String solution = "";
            switch(j) {
                case 0:
                    solution = solve('R', n);
                    break;
                case 1:
                    solution = solve('P', n);
                    break;
                case 2:
                    solution = solve('S', n);
            }

            jout.println(solution);
            break;
        }

        if(!found) {
            jout.println("IMPOSSIBLE");
        }
    }

    private String solve(char r, int n) {
        if(n == 0) {
            return String.valueOf(r);
        } else {
            String a = "";
            String b = "";
            switch(r) {
                case 'R':
                    a = solve('R', n - 1);
                    b = solve('S', n - 1);
                    break;
                case 'P':
                    a = solve('R', n - 1);
                    b = solve('P', n - 1);
                    break;
                case 'S':
                    a = solve('S', n - 1);
                    b = solve('P', n - 1);
                    break;
            }

            if(a.compareTo(b) <= 0) {
                return a + b;
            } else {
                return b + a;
            }
        }

    }
}

class InputReader {
    private static final int bufferMaxLength = 1024;
    private InputStream in;
    private byte[] buffer;
    private int currentBufferSize;
    private int currentBufferTop;
    private static final String tokenizers = " \t\r\f\n";

    public InputReader(InputStream stream) {
        this.in = stream;
        buffer = new byte[bufferMaxLength];
        currentBufferSize = 0;
        currentBufferTop = 0;
    }

    private boolean refill() {
        try {
            this.currentBufferSize = this.in.read(this.buffer);
            this.currentBufferTop = 0;
        } catch(Exception e) {}
        return this.currentBufferSize > 0;
    }

    public String line() {
        StringBuffer tok = new StringBuffer();
        Byte first;
        while((first = readChar()) != null) {
            tok.append((char)first.byteValue());
            if((char)first.byteValue() == '\n')
                break;
        }
        return tok.toString();
    }

    public Byte readChar() {
        if(currentBufferTop < currentBufferSize) {
            return this.buffer[this.currentBufferTop++];
        } else {
            if(!this.refill()) {
                return null;
            } else {
                return readChar();
            }
        }
    }

    public String token()  {
        StringBuffer tok = new StringBuffer();
        Byte first;
        while((first = readChar()) != null && (tokenizers.indexOf((char) first.byteValue()) != -1));
        if(first == null) return null;
        tok.append((char)first.byteValue());
        while((first = readChar()) != null && (tokenizers.indexOf((char) first.byteValue()) == -1)) {
            tok.append((char)first.byteValue());
        }
        return tok.toString();
    }


    public String next() {
        return token();
    }

    public Integer int32() throws NumberFormatException {
        String tok = token();
        return tok == null? null : Integer.parseInt(tok);
    }

    public Long int64() throws NumberFormatException {
        String tok = token();
        return tok == null? null : Long.parseLong(tok);
    }
}

