import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Palindrome {

	static final String CASE = "Case #%s: %s";

	public static void main(String[] args) throws IOException {

		BigInteger top = BigInteger.valueOf(10).pow(7);
		Set<BigInteger> set = fairAndSquareSet(top);

		// int c = count(BigInteger.TEN.pow(2), BigInteger.TEN.pow(14), set);
		// int n = 50;
		// Double c = 2* (Math.pow(10.0, n/2)-1);
		/*
		 * BigInteger c =
		 * BigInteger.TEN.pow(n / 2).subtract(BigInteger.ONE)
		 * .multiply(BigInteger.valueOf(2));
		 */
		// System.out.println(c);
		Scanner scanner = new Scanner(new File("in.txt"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("out.txt"));
		int caze = 0;
		scanner.nextLine();
		while (scanner.hasNext()) {
			String[] l = scanner.nextLine().split(" ");
			String lower = l[0];
			String upper = l[1];
			caze++;
			print(writer, lower, upper, set, caze);
		}
		scanner.close();
		writer.flush();
		writer.close();
	}

	static void print(BufferedWriter writer, String lower, String upper,
			Set<BigInteger> set, int caze) throws IOException {

		int c = count(new BigInteger(lower), new BigInteger(upper), set);
		writer.write(String.format(CASE, caze, c));
		writer.newLine();
	}

	static int count(BigInteger bot, BigInteger top, Set<BigInteger> set) {

		int count = 0;
		for (BigInteger i : set) {
			if (bot.compareTo(i) <= 0) {
				if (top.compareTo(i) >= 0) {
					count++;
				}
			}
		}
		return count;
	}

	static Set<BigInteger> fairAndSquareSet(BigInteger top) {

		Set<BigInteger> set = new HashSet<BigInteger>();
		for (BigInteger val = BigInteger.ZERO; val.compareTo(top) < 0; val =
				val.add(BigInteger.ONE)) {
			BigInteger square = val.pow(2);
			if (palindrome(square) && palindrome(val)) {
				set.add(square);
			}
		}
		return set;
	}

	static boolean palindrome(BigInteger in) {

		String num = in.toString();
		String rev = new StringBuilder(num).reverse().toString();
		return num.equals(rev);
	}
}
