import java.util.*;

public class C
{
    static Scanner in = new Scanner(System.in);


    public static int runTrialSmall(int t)
    {
        int W = in.nextInt();
        int H = in.nextInt();
        int B = in.nextInt();

        boolean[][] isFull = new boolean[W][H];
        for (int i = 0; i < B; i++)
        {
            int x0 = in.nextInt();
            int y0 = in.nextInt();
            int x1 = in.nextInt();
            int y1 = in.nextInt();

            for (int x = x0; x <= x1; x++)
            {
                for (int y = y0; y <= y1; y++)
                {
                    isFull[x][y] = true;
                }
            }
        }

//        print(isFull, W, H);

        int count = 0;
        for (int start = 0; start < W; start++)
        {
            if (isFull[start][0])
            {
                continue;
            }

            boolean success = percolate(isFull, W, H, start, 0, 0, 1);
            
//           System.out.println("trying " + start);
//            print(isFull, W, H);
            if (success)
            {
//               System.out.println("  SUCCESS!");
                count++;
            }
        }

        return count;
    }
    
    public static boolean percolate(boolean[][] b, int W, int H, int x, int y, int dx, int dy)
    {
        b[x][y] = true;

        if (y == H-1)
        {
            // reached the top!
            return true;
        }

        // left direction 
        int dx2 = -dy;
        int dy2 = dx;

        boolean success = false;

        // try turning left if possible
        if( isEmpty(b, W, H, x + dx2, y + dy2) )
        {
            success = percolate(b, W, H, x + dx2, y + dy2, dx2, dy2);
            if (success)
                return true;
        }

        // try moving forward if possible
        if( isEmpty(b, W, H, x + dx, y + dy) )
        {
            success = percolate(b, W, H, x + dx, y + dy, dx, dy);
            if (success)
                return true;
        }
        
        // try turning right if possible
        if( isEmpty(b, W, H, x - dx2, y - dy2) )
        {
            success = percolate(b, W, H, x - dx2, y - dy2, -dx2, -dy2);
            if (success)
                return true;
        }

        return false;


    }

    public static boolean isEmpty(boolean[][] b, int W, int H, int x, int y)
    {
        if (x < 0 || y < 0 || x >= W || y >= H)
        {
            return false;
        }
        else
        {
            return ! (b[x][y]);
        }
    }

    public static void print(boolean[][] b, int W, int H)
    {
        for (int y = H-1; y >= 0; y--)
        {
            for (int x = 0; x < W; x++)
            {
                if (b[x][y])
                {
                    System.out.print("1 ");
                }
                else
                {
                    System.out.print("0 ");
                }
            }
            System.out.println();
        }
    }

    public static void main(String[] args)
    {
/*
        for (int i = 1; i < 10; i++)
        {
            System.out.println(i + " : " + highestpowerof2leqa(i));
        }
*/        

        int numTrials = in.nextInt();
        
        for (int t = 1; t <= numTrials; t++)
        {
            System.out.println("Case #" + t + ": " + runTrialSmall(t));
        }
        
    }
}
