import java.util.*;

public class A
{
    static Scanner in = new Scanner(System.in);

    static int N;

    static List<Character> pat;
    static int patLen;

    static int[][] freq;

    public static void buildPat(String s)
    {
        int len = s.length();
        int prevChar = s.charAt(0);
        int repeats = 1;
        int currPatLen = 0;

        pat = new ArrayList<Character>();
        List<Integer> freq0 = new ArrayList<Integer>();

        for (int i = 1; i < len; i++)
        {
            if (s.charAt(i) == prevChar)
            {
                repeats++;
            }
            else
            {
                pat.add((char) prevChar);
                freq0.add(repeats);
                repeats = 1;
                prevChar = s.charAt(i);
            }
        }
        
        pat.add((char) prevChar);
        freq0.add(repeats);

        patLen = pat.size();

        freq = new int[N][patLen];

        for (int i = 0; i < patLen; i++)
        {
            freq[0][i] = freq0.get(i); // yes i know this is bad...
        }

     //   System.out.println(pat);
        
        //System.out.println(freq0);


    }

    public static boolean readNextString(String s, int i)
    {
        int len = s.length();
        int patPos = 0;
        int sPos = 0;

        while (sPos < len && patPos < patLen)
        {   
            if (s.charAt(sPos) == pat.get(patPos))
            {
                // good;
                int repeats = 0;
                while (sPos < len && s.charAt(sPos) == pat.get(patPos))
                {
                    repeats++;
                    sPos++;
                }
                freq[i][patPos] = repeats;
            }
            else
            {
                //System.out.println("failed!");
                return false;
            }
            patPos++;
        }

        if (patPos < patLen) 
        {
            //System.out.println("failed!");
            return false;   
        }

        if (sPos < len) 
        {
            //System.out.println("failed!");
            return false;   
        }

        return true;
    }

    public static int processPatPos(int j)
    {
        int sum = 0;
        for (int i = 0; i < N; i++)
        {
            sum += freq[i][j];
        }
        double avg = (double) sum / N;
        int target1 = (int) Math.floor(avg);
        int target2 = (int) Math.ceil(avg);

        int ret1 = 0;
        int ret2 = 0;
        for (int i = 0; i < N; i++)
        {
            ret1 += Math.abs(target1 - freq[i][j]);
            ret2 += Math.abs(target2 - freq[i][j]);
        }    

        //System.out.println(avg + " " + ret1 + " " + ret2);
        return Math.min(ret1, ret2);
    }

    public static String runTrial(int t)
    {
        N = in.nextInt();

        String s;
        s = in.next();

        buildPat(s);

        boolean isSolvable = true;
        for (int i = 1; i < N; i++)
        {
            s = in.next();
            isSolvable = readNextString(s, i);
            if (! isSolvable)
            {
                break;
            }
        }
/*

        for (int i = 0; i < N; i++)
        {
            System.out.println(Arrays.toString(freq[i]));    
        }
*/
        if (! isSolvable)
        {
            return "Fegla won";
        }
        
        int count = 0;
        for (int j = 0; j < patLen; j++)
        {
            count += processPatPos(j);
        }

        return count + "";
        
    }
    
    public static void main(String[] args)
    {

//        buildPat("aaabbcccccabcc");

        int numTrials = in.nextInt();
        
        for (int t = 1; t <= numTrials; t++)
        {
            System.out.println("Case #" + t + ": " + runTrial(t));
        }


    }
}
