import java.util.*;

public class Bsmall
{
    static Scanner in = new Scanner(System.in);


    public static boolean isValid(String s)
    {
        boolean[] hasSeenChar = new boolean[150];
        // everything originally false;

        int len = s.length();
        for (int i = 0; i < len; )
        {
            char c = s.charAt(i);
            if (hasSeenChar[c])
            {
                return false;
            }
            hasSeenChar[c] = true;
            while (i < len && c == s.charAt(i))
            {
                i++;
            }
        }
        return true;
    }

    public static int runTrial(int t)
    {
        int n = in.nextInt();

        String[] trains = new String[n];
        for (int i = 0; i < n; i++)
        {
            trains[i] = in.next();
//            System.out.println(trains[i]);
        }

        int count = 0;


        for(Iterator<int[]> it = new PermIterator(n); it.hasNext(); ) {
            int[] perm = it.next();
            String s = trains[perm[0]];
            for (int i = 1; i < n; i++)
            {
                s = s + trains[perm[i]];
            }
//            System.out.println(s);
//            System.out.println(isValid(s));
            if (isValid(s))
            {
                count++;
            }
        }
        return count;
    }


    public static void main(String[] args)
    {
        /*
        String s = "abcde";
        for(Iterator<int[]> it = new PermIterator(5); it.hasNext(); ) {
            System.out.println(Arrays.toString(it.next()));
        }*/

/*
        System.out.println(isValid("abc"));
        System.out.println(isValid("abcc"));
        System.out.println(isValid("abcccc"));
        System.out.println(isValid("abca"));
        System.out.println(isValid("aaabbbcc"));
        System.out.println(isValid("cccabbb"));
        System.out.println(isValid("cccaba"));
*/

        
        int numTrials = in.nextInt();
        
        for (int t = 1; t <= numTrials; t++)
        {
            System.out.println("Case #" + t + ": " + runTrial(t));
        }
        
    }
}


// http://stackoverflow.com/questions/2000048/stepping-through-all-permutations-one-swap-at-a-time/11916946#11916946

// Based on https://en.wikipedia.org/wiki/Steinhaus%E2%80%93Johnson%E2%80%93Trotter_algorithm#Even.27s_speedup
class PermIterator
    implements Iterator<int[]>
{
    private int[] next = null;

    private final int n;
    private int[] perm;
    private int[] dirs;

    public PermIterator(int size) {
        n = size;
        if (n <= 0) {
            perm = (dirs = null);
        } else {
            perm = new int[n];
            dirs = new int[n];
            for(int i = 0; i < n; i++) {
                perm[i] = i;
                dirs[i] = -1;
            }
            dirs[0] = 0;
        }

        next = perm;
    }

    @Override
    public int[] next() {
        int[] r = makeNext();
        next = null;
        return r;
    }

    @Override
    public boolean hasNext() {
        return (makeNext() != null);
    }

    @Override
    public void remove() {
        throw new UnsupportedOperationException();
    }

    private int[] makeNext() {
        if (next != null)
            return next;
        if (perm == null)
            return null;

        // find the largest element with != 0 direction
        int i = -1, e = -1;
        for(int j = 0; j < n; j++)
            if ((dirs[j] != 0) && (perm[j] > e)) {
                e = perm[j];
                i = j;
            }

        if (i == -1) // no such element -> no more premutations
            return (next = (perm = (dirs = null))); // no more permutations

        // swap with the element in its direction
        int k = i + dirs[i];
        swap(i, k, dirs);
        swap(i, k, perm);
        // if it's at the start/end or the next element in the direction
        // is greater, reset its direction.
        if ((k == 0) || (k == n-1) || (perm[k + dirs[k]] > e))
            dirs[k] = 0;

        // set directions to all greater elements
        for(int j = 0; j < n; j++)
            if (perm[j] > e)
                dirs[j] = (j < k) ? +1 : -1;

        return (next = perm);
    }

    protected static void swap(int i, int j, int[] arr) {
        int v = arr[i];
        arr[i] = arr[j];
        arr[j] = v;
    }


    // -----------------------------------------------------------------
    // Testing code:


}