import java.util.*;

public class C
{
    static Scanner in = new Scanner(System.in);
   
    public static String runTrial(int t)
    {
        int L = in.nextInt(); // length
        long X = in.nextLong(); // repetition
        String s = in.next();

        // System.out.println(L + " " + X + " " + s);

        int sProd= 1; // E
        for (int i = 0; i < L; i++)
        {
            sProd = UnitQ.mult(sProd,  UnitQ.charToUnitQ(s.charAt(i)));
        }

        if (UnitQ.pow(sProd, (int) (X%4)) != -1) // since ijk = -1
        {
            return "NO";
        }

        int order_sProd = (sProd == -1) ? 2 : 4; // since sProd != 1

        boolean found_i = false;
        int runProd = 1;

        long max_cycles = Math.min(2 * order_sProd, X);
        for (long j = 0; j < max_cycles; j++)
        {
            for (int i = 0; i < L; i++)
            {
                runProd = UnitQ.mult(runProd,  UnitQ.charToUnitQ(s.charAt(i)));
                if (! found_i)
                {
                    if (runProd == 2)
                    {
                        found_i = true;
                        runProd = 1; // reset prod to look for j now
                    }
                }
                else // looking for j
                {
                    if (runProd == 3)
                    {
                        return "YES";
                        // found j! rest will be k.
                    }
                }
            }            
        }

        return "NO";
    }
    

    public static void main(String[] args)
    {
        int numTrials = in.nextInt();
        
        for (int t = 1; t <= numTrials; t++)
        {
            System.out.println("Case #" + t + ": " + runTrial(t));
        }
    }
}

// unit quaternions, very dangerous!
class UnitQ 
{
    public static final int E = 1;
    public static final int I = 2;
    public static final int J = 3;
    public static final int K = 4;

    public static int[][] mult_base = 
    {{E,I,J,K}, 
    {I,E,K,J}, 
    {J,K,E,I},
    {K,J,I,E}};

    public static int[][] mult_sign =
    {{1,1,1,1},
    {1,-1,1,-1},
    {1,-1,-1,1},
    {1,1,-1,-1}};

    public static int base(int a)
    {
        return (a > 0) ? a : -a;
    }

    public static int sign(int a)
    {
        return (a > 0) ? 1 : -1;
    }

    public static int toUnitQ(int base, int sign)
    {
        return base * sign;
    }

    public static int mult(int a, int b) 
    {
        UnitQ c = new UnitQ();
        int base = mult_base[base(a)-1][base(b)-1];
        int sign = sign(a) * sign(b) * mult_sign[base(a)-1][base(b)-1];
        return toUnitQ(base,sign);
    } 

    // n >= 0
    public static int pow(int a, int n)
    {
        n = n % 4;
        if (n == 0)
        {
            return toUnitQ(UnitQ.E, 1);
        }
        else if (n == 1)
        {
            return a;
        }
        else if (n == 2)
        {
            return mult(a, a);
        }
        else // n == 3
        {
            return mult(a, mult(a,a));
        }
    }

    public static int charToUnitQ(char c)
    {
        return toUnitQ(c - 'i' + 2, 1);
    }
}
