import java.util.*;

public class D
{
    static Scanner in = new Scanner(System.in);


    public static String runTrialSmall(int t)
    {
        int M = in.nextInt(); //num strings
        int N = in.nextInt(); //num servers
        
        String[] S = new String[M];
        for (int i = 0; i < M; i++)
        {
            S[i] = in.next();
        }

        int maxSize = 0;
        int maxSizeCount = 0;


        int arrangements = (int) Math.pow(N, M);
        for (int i = 0; i < arrangements; i++)
        {
            TrieST[] trie_s = new TrieST[N]; 
            for (int j = 0; j < N; j++)
            {
                trie_s[j] = new TrieST();
            }

            int icopy = i;
            for (int k = 0; k < M; k++)
            {
                trie_s[icopy % N].put(S[k]);
                icopy /= N;
            }


            int totalSize = 0;
            boolean isGoodSplit = true;
            for (int j = 0; j < N; j++)
            {
                int thisSize = trie_s[j].size();
                if (thisSize == 0)
                {
                    isGoodSplit = false;
                    break;
                }
                totalSize += thisSize;
            }
            if (!isGoodSplit)
            {
                continue;
            }

//            System.out.println(totalSize);
            if (totalSize > maxSize)
            {
                maxSize = totalSize;
                maxSizeCount = 1;
            }
            else if (totalSize == maxSize)
            {
                maxSizeCount++;
            }

        }

        return maxSize + " " + maxSizeCount;
    }

    public static void main(String[] args)
    {
/*
        TrieST trie = new TrieST();
        System.out.println(trie.size());
        trie.put("AAA");
        System.out.println(trie.size());
        trie.put("AAB");
        System.out.println(trie.size());
        trie.put("AB");
        System.out.println(trie.size());
        trie.put("B");
        
        System.out.println(trie.size());
*/

        int numTrials = in.nextInt();
        
        for (int t = 1; t <= numTrials; t++)
        {
            System.out.println("Case #" + t + ": " + runTrialSmall(t));
        }
    }
}

// adapted from http://algs4.cs.princeton.edu/52trie/TrieST.java.html
class TrieST {
    private static final int R = 26;

    private Node root;      // root of trie
    private int N;          // number of keys in trie

    // R-way trie node
    private static class Node {
        private Node[] next = new Node[R];
    }

    public TrieST() {
        N = 0;
    }


    /**
     * Inserts the key-value pair into the symbol table, overwriting the old value
     * with the new value if the key is already in the symbol table.
     * If the value is <tt>null</tt>, this effectively deletes the key from the symbol table.
     * @param key the key
     * @param val the value
     * @throws NullPointerException if <tt>key</tt> is <tt>null</tt>
     */
    public void put(String key) {
        root = put(root, key, 0);
    }

    private Node put(Node x, String key, int d) {
        if (x == null) 
        {
            x = new Node();
            N++;
        }
        if (d == key.length()) {
            return x;
        }
        int c = key.charAt(d) - 65;
        x.next[c] = put(x.next[c], key, d+1);
        return x;
    }

    public int size()
    {
        return N;
    }

}
