import java.util.*;

public class A
{
    static Scanner in = new Scanner(System.in);
    
    // n choose 2
    public static int binom(int n)
    {
        return n * (n-1) / 2;
    }
    
    public static long runTrial(int t)
    {
        int N = in.nextInt();
        int M = in.nextInt();
        
        int[] travel = new int[N]; //travel[i] = how many people traveling from i to i + 1 where i = 1...N-1 
        
        int origSavings = 0;
        
        for (int i = 0; i < M; i++)
        {
            int o = in.nextInt();
            int e = in.nextInt();
            int p = in.nextInt();
            
            for (int j = o; j < e; j++)
            {
                travel[j] += p;
            }
            
            origSavings += p * binom(e-o);
        }
        
        for (int i = 1; i < N; i++)
        {
//            StdOut.println("from " + i + " to " + (i+1) + ": " + travel[i]);
        }
        
        int newSavings = computeNewSavings(travel, 1, N-1);
        
//        StdOut.println(origSavings);
            
        return newSavings - origSavings;
            
    }
    
    public static int computeNewSavings(int[] travel, int lo, int hi)
    {
//        StdOut.println("computeNewSavings from " + lo + " "  + hi);
        int savings = 0;
        
        int i = lo;
        
        while (i <= hi)
        {
            while (i <= hi && travel[i] == 0)
            {
                i++;
            }
            
            if (i > hi)
            {
                break;
            }
            
            // travel[i] != 0
            
            int o = i;
            
            while (i <= hi && travel[i] != 0)
            {
                i++;
                //StdOut.println(i + " " + hi);
            }
            
            int e = i;
            
            int min = travel[o];
            for (int j = o; j < e; j++)
            {
                if (travel[j] < min)
                {
                    min = travel[j];
                }
            }
            
            for (int j = o; j < e; j++)
            {
                travel[j] -= min;
            }
            
//            StdOut.println(" just saved " + min * binom(e - o));
            
            savings += min * binom(e - o);
            savings += computeNewSavings(travel, o, e-1);
        }
        
        return savings;
    }
    
    
    public static void main(String[] args)
    {

        int numTrials = in.nextInt();
        
        for (int t = 1; t <= numTrials; t++)
        {
            System.out.println("Case #" + t + ": " + runTrial(t));
        }
        
    }
    
}
