import java.util.*;

public class Csmall
{
    static Scanner in = new Scanner(System.in);
    static int N;
    static int M;
    static int NM; 
    //static int numcalls = 0;

    public static boolean check(int r, int c, int[][] grid, boolean[][] hasVisited)
    {
        //numcalls++;
        if(grid[r][c] == 1 || grid[r][c] == 3) // black stone or empty but enclosed
        {
            return false; // enclosed
        }
        else if (grid[r][c] == 2) 
        {
            return true; // free
        }
        else
        {
            if (r == 0 || r == N-1 || c == 0 || c == M-1)
            {
                grid[r][c] = 2; // i.e. free
                return true;
            }
            else
            {
                hasVisited[r][c] = true;
                if (r > 0)
                {
                    if (! hasVisited[r-1][c])
                    {
                        boolean ret = check(r-1, c, grid, hasVisited);
                        if (ret)
                        {
                            grid[r][c] = 2;
                            return true;
                        }
                    }
                }
                if (r < N-1)
                {
                    if (! hasVisited[r+1][c])
                    {
                        boolean ret = check(r+1, c, grid, hasVisited);
                        if (ret)
                        {
                            grid[r][c] = 2;
                            return true;
                        }
                    }
                }
                if (c > 0)
                {
                    if (! hasVisited[r][c-1])
                    {
                        boolean ret = check(r, c-1, grid, hasVisited);
                        if (ret)
                        {
                            grid[r][c] = 2;
                            return true;
                        }
                    }
                }
                if (c < M-1)
                {
                    if (! hasVisited[r][c+1])
                    {
                        boolean ret = check(r, c+1, grid, hasVisited);
                        if (ret)
                        {
                            grid[r][c] = 2;
                            return true;
                        }
                    }
                }
            }
        }
        grid[r][c] = 3; // enclosed 
        return false;

    }

    public static void fill(int[][] grid)
    {
        for (int r = 0; r < N; r++)
        {
            for (int c = 0; c < M; c++)
            {
                check(r, c, grid, new boolean[N][M]);
            }
        }
    }

    public static int encloses(int[][] grid)
    {
        int count = 0;
        for (int r = 0; r < N; r++)
        {
            for (int c = 0; c < M; c++)
            {
                if (grid[r][c] == 1 || grid[r][c] == 3)
                {
                    count++;
                }
                else if (grid[r][c] == 0)
                {
                    System.err.println("ERROR ERROR ERROR");
                    System.exit(0);
                }
            }
        } 
        return count;
    }

    public static int runTrial(int t)
    {
        N = in.nextInt();
        M = in.nextInt();
        NM = N * M;
        int K = in.nextInt();

/* remove comments when actually running
        if (K <= 4)
        {
            return K;
        }
*/

        int currMin = K;
        int numBoards = (1 << NM);

        for (int i = 0; i < numBoards; i++)
        {
            int[][] grid = new int[N][M];
            int stones = 0;
            int j = i;
            for (int r = 0; r < N; r++)
            {
                for (int c = 0; c < M; c++)
                {
                    grid[r][c] = (j & 1);
                    if ((j & 1) == 1)
                    {
                        stones++;
                    }
                    j = (j >> 1);
                }
            }

            if (stones >= currMin)
            {
                continue; // no need to check
            }

            fill(grid);
            //print(grid);
            
            if (encloses(grid) >= K)
            {
                currMin = stones;
            }
        }

        return currMin;
    }

    public static void print(int[][] grid)
    {
        for (int r = 0; r < N; r++)
        {
            for (int c = 0; c < M; c++)
            {
                System.out.print(grid[r][c] + " ");
            }
            System.out.println();
        }
    }

    public static void main(String[] args)
    {

/*
        N = 4;
        M = 5;
        

        int[][] grid = new int[N][M];
        grid[0][1] = 1;
        grid[0][2] = 1;
        grid[1][0] = 1;
        grid[1][3] = 1;
        grid[2][1] = 1;
        grid[2][3] = 1;
        fill(grid);
        print(grid);
        System.out.println(numcalls);

*/

        /*
        String s = "abcde";
        for(Iterator<int[]> it = new PermIterator(5); it.hasNext(); ) {
            System.out.println(Arrays.toString(it.next()));
        }*/

/*
        System.out.println(isValid("abc"));
        System.out.println(isValid("abcc"));
        System.out.println(isValid("abcccc"));
        System.out.println(isValid("abca"));
        System.out.println(isValid("aaabbbcc"));
        System.out.println(isValid("cccabbb"));
        System.out.println(isValid("cccaba"));
*/

        
        int numTrials = in.nextInt();
        
        for (int t = 1; t <= numTrials; t++)
        {
            System.out.println("Case #" + t + ": " + runTrial(t));
        }
       
    }
}

