package alanparra.codejam;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Scanner;

public final class PickingUpChicks {

	public static void main(String[] args) throws Exception {
		if (args.length != 1) {
			System.out.println("Usage: java " + PickingUpChicks.class.getName() + " <filename>");
			return;
		} else if (!new File(args[0]).exists()) {
			System.out.println("File " + args[0] + " do not exists!");
			return;
		}

		String outputName = extractOutputName(args[0]);
		System.out.println("start time = " + new Date());

		Scanner input = null;
		PrintWriter output = null;
		try {
			input = new Scanner(new FileInputStream(args[0]));
			output = new PrintWriter(outputName);

			int cases = input.nextInt();
			for (int i = 0; i < cases; i++) {
				solveNextCase(i + 1, input, output);
			}
		} finally {
			if (input != null) {
				input.close();
			}
			if (output != null) {
				output.close();
			}
		}

		System.out.println("end time = " + new Date());
	}

	private static String extractOutputName(String inputName) {
		String outputName = inputName;
		int dotIndex = outputName.lastIndexOf('.');
		if (dotIndex > 0) {
			outputName = outputName.substring(0, dotIndex);
		}
		outputName += ".out";
		return outputName;
	}

	private static void solveNextCase(int caseNumber, Scanner input, PrintWriter output) throws IOException {
		int totalChickens = input.nextInt();
		int minChickens = input.nextInt();
		final int barn = input.nextInt();
		int time = input.nextInt();

		// read chicken distance
		int[] chickens = new int[totalChickens];
		for (int i = 0; i < chickens.length; i++) {
			chickens[i] = input.nextInt();
		}

		// read and sum chicken speed
		int chickensThatCanReach = 0;
		for (int i = 0; i < chickens.length; i++) {
			chickens[i] += input.nextInt() * time;
			if (chickens[i] >= barn) {
				chickensThatCanReach++;
			}
		}

		String answer;
		if (minChickens == 0) {
			answer = "0";
		} else if (chickensThatCanReach < minChickens) {
			answer = "IMPOSSIBLE";
		} else {
			int chickenCount = 0;
			int swaps = 0;

			// "sort" chickens
			for (int i = chickens.length - 1; i >= 0; i--) {
				if (chickens[i] >= barn) {
					chickenCount++;
					int j = i + 1;
					while (j < chickens.length && chickens[j] < barn) {
						swap(chickens, j - 1, j);
						swaps++;
						j++;
					}

					if (chickenCount == minChickens) {
						break;
					}
				}
			}
			answer = String.valueOf(swaps);
		}

		// System.out.printf("Case #%d: %s\n", caseNumber, answer);
		output.printf("Case #%d: %s\n", caseNumber, answer);
	}

	private static void swap(int[] chickens, int i, int j) {
		int tmp = chickens[i];
		chickens[i] = chickens[j];
		chickens[j] = tmp;
	}

}
