package alanparra;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Snapper {

	public static void main(String[] args) throws Exception {
		if (args.length != 1) {
			System.out.println("Usage: java " + Snapper.class.getName() + " <filename>");
			return;
		} else if (!new File(args[0]).exists()) {
			System.out.println("File " + args[0] + " do not exists!");
			return;
		}

		String outputName = args[0];
		int dotIndex = outputName.lastIndexOf('.');
		if (dotIndex > 0) {
			outputName = outputName.substring(0, dotIndex);
		}
		outputName += ".out";

		Scanner input = null;
		PrintWriter output = null;
		try {
			input = new Scanner(new FileInputStream(args[0]));
			output = new PrintWriter(outputName);

			int cases = input.nextInt();
			for (int i = 0; i < cases; i++) {
				solveNextCase(i + 1, input, output);
			}
		} finally {
			if (input != null) {
				input.close();
			}
			if (output != null) {
				output.close();
			}
		}
	}

	private static void solveNextCase(int caseNumber, Scanner input, PrintWriter output) throws IOException {
		int n = input.nextInt();
		int k = input.nextInt();

		boolean snappers[] = new boolean[n];
		for (int i = 0; i < k; i++) {
			for (int j = 0; j < snappers.length; j++) {
				if (snappers[j]) {
					snappers[j] = false;
				} else {
					snappers[j] = true;
					break;
				}
			}
		}

		int i;
		for (i = 0; i < snappers.length && snappers[i]; i++) {
		}
		boolean on = (i == snappers.length);

		output.printf("Case #%d: %s\n", caseNumber, (on ? "ON" : "OFF"));
	}

}
