package alanparra;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class ThemePark {

	public static void main(String[] args) throws Exception {
		if (args.length != 1) {
			System.out.println("Usage: java " + ThemePark.class.getName() + " <filename>");
			return;
		} else if (!new File(args[0]).exists()) {
			System.out.println("File " + args[0] + " do not exists!");
			return;
		}

		String outputName = args[0];
		int dotIndex = outputName.lastIndexOf('.');
		if (dotIndex > 0) {
			outputName = outputName.substring(0, dotIndex);
		}
		outputName += ".out";

		Scanner input = null;
		PrintWriter output = null;
		try {
			input = new Scanner(new FileInputStream(args[0]));
			output = new PrintWriter(outputName);

			int cases = input.nextInt();
			for (int i = 0; i < cases; i++) {
				solveNextCase(i + 1, input, output);
			}
		} finally {
			if (input != null) {
				input.close();
			}
			if (output != null) {
				output.close();
			}
		}
	}

	private static void solveNextCase(int caseNumber, Scanner input, PrintWriter output) throws IOException {
		int r = input.nextInt();
		int k = input.nextInt();
		int n = input.nextInt();

		int [] groups = new int[n];
		for (int i = 0; i < groups.length; i++) {
			groups[i] = input.nextInt();

		}

		int euros = 0;
		int queue = 0;
		while(r > 0){
			int currentK = 0;
			int currentN = 0;
			while (currentN < n) {

				// add passengers
				currentK += groups[queue];

				// check passenger limit
				if(currentK > k){
					currentK -= groups[queue];
					break;
				}

				// increment queue and currentN
				currentN++;
				if(++queue == n){
					queue = 0;
				}
			}

			// update our money :)
			euros += currentK;
			r--;
		}

		output.printf("Case #%d: %s\n", caseNumber, euros);
	}

}
