package alanparra.codejam;

import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Date;
import java.util.Scanner;

public final class FileFixIt {

	public static void main(String[] args) throws Exception {
		if (args.length != 1) {
			System.out.println("Usage: java " + FileFixIt.class.getName() + " <filename>");
			return;
		} else if (!new File(args[0]).exists()) {
			System.out.println("File " + args[0] + " do not exists!");
			return;
		}

		String outputName = extractOutputName(args[0]);
		System.out.println("start time = " + new Date());

		Scanner input = null;
		PrintWriter output = null;
		try {
			input = new Scanner(new FileInputStream(args[0]));
			output = new PrintWriter(outputName);

			int cases = input.nextInt();
			for (int i = 0; i < cases; i++) {
				solveNextCase(i + 1, input, output);
			}
		} finally {
			if (input != null) {
				input.close();
			}
			if (output != null) {
				output.close();
			}
		}

		System.out.println("end time = " + new Date());
	}

	private static String extractOutputName(String inputName) {
		String outputName = inputName;
		int dotIndex = outputName.lastIndexOf('.');
		if (dotIndex > 0) {
			outputName = outputName.substring(0, dotIndex);
		}
		outputName += ".out";
		return outputName;
	}

	private static final File basedir = new File("fileFixIt/");

	private static void solveNextCase(int caseNumber, Scanner input, PrintWriter output) throws IOException {
		File basedir = new File("fileFixIt" + System.currentTimeMillis());
		basedir.mkdir();

		int existingDirectories = input.nextInt();
		int newDirectories = input.nextInt();
		input.skip("\\s*");

		// create existing directories
		for (int i = 0; i < existingDirectories; i++) {
			String dir = input.nextLine();
			new File(basedir, dir).mkdirs();
		}

		int mkdirCount = 0;

		// create new directories
		for (int i = 0; i < newDirectories; i++) {
			String dir = input.nextLine();
			mkdirCount += createDir(new File(basedir, dir));
		}

		output.printf("Case #%d: %d\n", caseNumber, mkdirCount);
	}

	private static int createDir(File newDir) {
		int count = 0;
		if (!newDir.exists()) {
			count = createDir(newDir.getParentFile()) + 1;
			newDir.mkdir();

		}
		return count;
	}

}
