package Round2;

import java.io.*;
import java.util.*;

public class Round2A {

	public static String problemName = "A";
	public static String inputName = "small-attempt0";
	
	public static class Pair implements Comparable<Pair> {
		Pair(double d, double s) { dist = d; speed = s; }
		double dist;
		double speed;
		public int compareTo(Pair other) {
			return ((Double)speed).compareTo(other.speed);
		}
	}
	
	public static String handleCase() {
		double length = in.nextDouble();
		double speed = in.nextDouble();
		double runningSpeed = in.nextDouble();
		double runningTime = in.nextDouble();
		
		int n = in.nextInt();
		
		ArrayList<Pair> ap = new ArrayList<Pair>();
		
		double walkDist = length;
		for(int i = 0; i < n; i++) {
			int a = in.nextInt(),b = in.nextInt(),c = in.nextInt();
			ap.add(new Pair(b-a, c));
			walkDist -= (b-a);
		}
		
		ap.add(new Pair(walkDist, 0));
		
		Collections.sort(ap);
		
		double timeUsed = 0;
		for (int i = 0; i < ap.size(); i++) {
			if (runningTime > 0) {
				if ((runningSpeed + ap.get(i).speed) * runningTime < ap.get(i).dist) {
					timeUsed += runningTime;
					double runningDist = (runningSpeed + ap.get(i).speed) * runningTime;
					double distLeft = ap.get(i).dist - runningDist;
					timeUsed += distLeft / (speed + ap.get(i).speed);
					runningTime = 0;
				} else {
					double t = ap.get(i).dist / (ap.get(i).speed + runningSpeed);
					runningTime -= t;
					timeUsed += t;
				}
			} else {
				timeUsed += ap.get(i).dist / (ap.get(i).speed + speed);
			}
		}
		
		return String.format("%.010f", timeUsed);
	}

	public static int[] readIntArr() {
		int n = in.nextInt();
		int[] res = new int[n];
		for (int i = 0; i < n; i++)
			res[i] = in.nextInt();
		return res;
	}

	public static interface Parser<T> {
		public T next();
	}

	public static <T> ArrayList<T> readList(Parser<T> p) {
		int n = in.nextInt();
		ArrayList<T> res = new ArrayList<T>();
		for (int i = 0; i < n; i++)
			res.add(p.next());
		return res;
	}

	public static Parser<Integer> intParser = new Parser<Integer>() {
		public Integer next() {
			return in.nextInt();
		}
	};

	public static void main(String[] args) throws FileNotFoundException {
		String inFilename = problemName + "-" + inputName + ".in";
		String outFilename = problemName + "-" + inputName + ".out";
		System.out.println("Reading from " + inFilename);
		System.out.println("Writing to " + outFilename);
		in = new Scanner(new File(inFilename));
		out = new PrintStream(new File(outFilename));

		int ncases = in.nextInt();

		for (int i = 0; i < ncases; i++) {
			System.out.println("Running case " + (i + 1) + "...");
			out.println("Case #" + (i + 1) + ": " + handleCase());
		}
		System.out.println("Done!");
	}

	static Scanner in;
	static PrintStream out;
}
