package Round2;

import java.io.*;
import java.util.*;

public class Round2C {

	public static String problemName = "C";
	public static String inputName = "small-attempt0";
	
	static boolean[] isPrime = new boolean[5000000];
	
	public static void init() {
		isPrime[0] = false;
		isPrime[1] = false;
		for (int i = 2; i < isPrime.length; i++)
			isPrime[i] = true;
		for (int i = 2; i < isPrime.length; i++) {
			for (int j = 2; i*j < isPrime.length; j++) {
				isPrime[i*j] = false;
			}
		}
	}
	

	public static long gcd(long a, long b) {
		while (true) {
			if (a == 0)
				return b;
			b %= a;
			if (b == 0)
				return a;
			a %= b;
		}
	}
	
	public static long lcm(long a, long b) {
		return a*b / gcd(a,b);
	}
	
	public static String handleCase() {
		
		long n = in.nextLong();
		
		if (n == 1)
			return "0";
		
		long res = 1;
		for (long i = 2; i*i <= n; i++) {
			if (!isPrime[(int)i])
				continue;
			
			long ncopy = n/i/i;
			while (ncopy > 0) {
				ncopy /= i;
				res++;
			}
		}
		
		return Long.toString(res);
		
		/*
		long n = in.nextLong();
		
		long max = 1;
		long upval = 1;
		for (long i = 2; i <= n; i++) {
			if (upval % i != 0)
				max++;
			upval = lcm(upval, i);
		}
		
		long min = 1;
		long downval = n;
		for (long i = n-1; i >= 1; i--) {
			if (downval % i != 0)
				min++;
			downval = lcm(downval, i);
		}
		
		return Long.toString(max - min);
		*/
	}

	public static int[] readIntArr() {
		int n = in.nextInt();
		int[] res = new int[n];
		for (int i = 0; i < n; i++)
			res[i] = in.nextInt();
		return res;
	}

	public static interface Parser<T> {
		public T next();
	}

	public static <T> ArrayList<T> readList(Parser<T> p) {
		int n = in.nextInt();
		ArrayList<T> res = new ArrayList<T>();
		for (int i = 0; i < n; i++)
			res.add(p.next());
		return res;
	}

	public static Parser<Integer> intParser = new Parser<Integer>() {
		public Integer next() {
			return in.nextInt();
		}
	};

	public static void main(String[] args) throws FileNotFoundException {
		String inFilename = problemName + "-" + inputName + ".in";
		String outFilename = problemName + "-" + inputName + ".out";
		System.out.println("Reading from " + inFilename);
		System.out.println("Writing to " + outFilename);
		in = new Scanner(new File(inFilename));
		out = new PrintStream(new File(outFilename));
		
		init();

		int ncases = in.nextInt();

		for (int i = 0; i < ncases; i++) {
			System.out.println("Running case " + (i + 1) + "...");
			out.println("Case #" + (i + 1) + ": " + handleCase());
		}
		System.out.println("Done!");
	}

	static Scanner in;
	static PrintStream out;
}
