package round2;

import com.google.common.collect.ImmutableList;
import com.google.common.collect.Lists;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.List;
import java.util.Scanner;

public class A {
    private static final String PROBLEM = "round2/A-small-attempt0";
    private final Scanner in;
    public A(Scanner in) {
        this.in = in;
    }

    private String runCase() {
        int numRows = in.nextInt();
        int numCols = in.nextInt();

        List<String> grid = Lists.newArrayList();
        for (int i = 0; i < numRows; i++) {
            grid.add(in.next());
        }


        int numBadCells = 0;


        for (int i = 0; i < numRows; i++) {
            for (int j = 0; j < numCols; j++) {
                if (grid.get(i).charAt(j) == '<') {
                    if (hasFallback(grid, i, j)) {
                        numBadCells++;
                    } else {
                        return "IMPOSSIBLE";
                    }
                }
                if (grid.get(i).charAt(j) != '.') {
                    break;
                }
            }

            for (int j = numCols - 1; j >= 0; j--) {
                if (grid.get(i).charAt(j) == '>') {
                    if (hasFallback(grid, i, j)) {
                        numBadCells++;
                    } else {
                        return "IMPOSSIBLE";
                    }
                }
                if (grid.get(i).charAt(j) != '.') {
                    break;
                }
            }
        }

        for (int j = 0; j < numCols; j++) {
            for (int i = 0; i < numRows; i++) {
                if (grid.get(i).charAt(j) == '^') {
                    if (hasFallback(grid, i, j)) {
                        numBadCells++;
                    } else {
                        return "IMPOSSIBLE";
                    }
                }
                if (grid.get(i).charAt(j) != '.') {
                    break;
                }
            }

            for (int i = numRows - 1; i >= 0; i--) {
                if (grid.get(i).charAt(j) == 'v') {
                    if (hasFallback(grid, i, j)) {
                        numBadCells++;
                    } else {
                        return "IMPOSSIBLE";
                    }
                }
                if (grid.get(i).charAt(j) != '.') {
                    break;
                }
            }
        }

        return String.format("%s", numBadCells);
    }

    private boolean hasFallback(List<String> grid, int r, int c) {
        for (int i = 0; i < grid.size(); i++) {
            if (i != r && grid.get(i).charAt(c) != '.') {
                return true;
            }
        }
        for (int j = 0; j < grid.get(0).length(); j++) {
            if (j != c && grid.get(r).charAt(j) != '.') {
                return true;
            }
        }
        return false;
    }

    private List<Integer> nextIntList(int n) {
        ImmutableList.Builder<Integer> builder = ImmutableList.builder();
        for (int i = 0; i < n; i++) {
            builder.add(in.nextInt());
        }
        return builder.build();
    }

    private void runCases() throws FileNotFoundException {
        int numCases = in.nextInt();
        PrintWriter writer = new PrintWriter(PROBLEM + ".out");
        for (int casenum = 1; casenum <= numCases; casenum++) {
            String result = runCase();
            System.out.printf("Case #%d: %s%n", casenum, result);
            writer.printf("Case #%d: %s%n", casenum, result);
            writer.flush();
        }
    }

    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File(PROBLEM + ".in"));
        new A(in).runCases();
    }
}
