package Round3;

import java.io.*;
import java.util.*;

public class Round3B {

	public static String problemName = "B";
	public static String inputName = "large";

	public static boolean good(int[] counts, int minStraight) {
		LinkedList<Integer> current = new LinkedList<Integer>();
		for (int i = 0; i < counts.length; i++) {
			LinkedList<Integer> old = current;
			current = new LinkedList<Integer>();
			
			for (int j = 0; j < counts[i]; j++) {
				if (old.size() > 0) {
					int val = old.getFirst();
					old.removeFirst();
					current.addLast(val-1);
				} else {
					current.addFirst(minStraight-1);
				}
			}
			
			if (old.size() > 0 && old.getFirst() > 0) {
				return false;
			}
		}
		
		return true;
	}
	
	public static String handleCase() {
		int n = in.nextInt();
		
		int[] counts = new int[20000];
		
		for (int i = 0; i < n; i++) {
			counts[in.nextInt()]++;
		}
		
		if (n == 0)
			return "0";
		
		int lo = 0;
		int hi = 20000;
		
		while (lo + 1 < hi) {
			int mid = (lo+hi)/2;
			
			if (good(counts, mid)) {
				lo = mid;
			} else {
				hi = mid;
			}
		}
		
		return Integer.toString(lo);
	}

	public static int[] readIntArr() {
		int n = in.nextInt();
		int[] res = new int[n];
		for (int i = 0; i < n; i++)
			res[i] = in.nextInt();
		return res;
	}

	public static interface Parser<T> {
		public T next();
	}

	public static <T> ArrayList<T> readList(Parser<T> p) {
		int n = in.nextInt();
		ArrayList<T> res = new ArrayList<T>();
		for (int i = 0; i < n; i++)
			res.add(p.next());
		return res;
	}

	public static Parser<Integer> intParser = new Parser<Integer>() {
		public Integer next() {
			return in.nextInt();
		}
	};

	public static void main(String[] args) throws FileNotFoundException {
		String inFilename = problemName + "-" + inputName + ".in";
		String outFilename = problemName + "-" + inputName + ".out";
		System.out.println("Reading from " + inFilename);
		System.out.println("Writing to " + outFilename);
		in = new Scanner(new File(inFilename));
		out = new PrintStream(new File(outFilename));

		int ncases = in.nextInt();

		for (int i = 0; i < ncases; i++) {
			System.out.println("Running case " + (i + 1) + "...");
			out.println("Case #" + (i + 1) + ": " + handleCase());
		}
		System.out.println("Done!");
	}

	static Scanner in;
	static PrintStream out;
}
