package Round3;

import java.io.*;
import java.util.*;

public class Round3D {

	public static String problemName = "D";
	public static String inputName = "small-attempt0";

	public static boolean isPerfectSq(long n) {
		Set<Long> seen = new HashSet<Long>();
		long guess = 1;
		while (true) {
			if (seen.contains(guess))
				break;
			seen.add(guess);
			guess = (guess + (n / guess)) / 2;
		}
		
		return guess*guess == n || (guess+1)*(guess+1) == n || (guess-1)*(guess-1) == n;
	}
	
	public static long toLong(char[] arr) {
		long res = 0;
		for(int i = 0; i < arr.length; i++) {
			res *= 2;
			if (arr[i] == '1')
				res++;
		}
		return res;
	}
	
	public static String handleCase() {
		
		char[] chars = in.next().toCharArray();
		
		ArrayList<Integer> locs = new ArrayList<Integer>();
		
		for (int i = 0; i < chars.length; i++) {
			if (chars[i] == '?')
				locs.add(i);
		}
		
		for (long i = 0; i < (1L << locs.size()); i++) {
			for (int j = 0; j < locs.size(); j++) {
				if ((i & (1<<j)) != 0)
					chars[locs.get(j)] = '1';
				else
					chars[locs.get(j)] = '0';
			}
			
			if (isPerfectSq(toLong(chars))) {
				return new String(chars);
			}
		}

		return "";
	}

	public static int[] readIntArr() {
		int n = in.nextInt();
		int[] res = new int[n];
		for (int i = 0; i < n; i++)
			res[i] = in.nextInt();
		return res;
	}

	public static interface Parser<T> {
		public T next();
	}

	public static <T> ArrayList<T> readList(Parser<T> p) {
		int n = in.nextInt();
		ArrayList<T> res = new ArrayList<T>();
		for (int i = 0; i < n; i++)
			res.add(p.next());
		return res;
	}

	public static Parser<Integer> intParser = new Parser<Integer>() {
		public Integer next() {
			return in.nextInt();
		}
	};

	public static void main(String[] args) throws FileNotFoundException {
		String inFilename = problemName + "-" + inputName + ".in";
		String outFilename = problemName + "-" + inputName + ".out";
		System.out.println("Reading from " + inFilename);
		System.out.println("Writing to " + outFilename);
		in = new Scanner(new File(inFilename));
		out = new PrintStream(new File(outFilename));

		int ncases = in.nextInt();

		for (int i = 0; i < ncases; i++) {
			System.out.println("Running case " + (i + 1) + "...");
			out.println("Case #" + (i + 1) + ": " + handleCase());
		}
		System.out.println("Done!");
	}

	static Scanner in;
	static PrintStream out;
}
