package Round2;

import java.io.*;
import java.util.*;

public class Round2B {

	public static String problemName = "B";
	public static String inputName = "small-attempt0";

	public static String handleCase() {
		int numRows = in.nextInt();
		int numCols = in.nextInt();
		int startMass = in.nextInt();
		
		int[][] grid = new int[numRows][numCols];
		
		for (int i = 0; i < numRows; i++) {
			char[] row = in.next().toCharArray();	
			
			for (int j = 0; j < numCols; j++)
				grid[i][j] = startMass + (row[j] - '0');
		}
		
		int best = -1;
		for (int startr = 0; startr + 2 < numRows; startr++) {
			for (int startc = 0; startc + 2 < numRows; startc++) {
				for (int k = 3; (startr + k - 1 < numRows) && (startc + k - 1 < numCols); k++) {
					double centerR = (double)startr + ((double)k-1.0)/2.0;
					double centerC = (double)startc + ((double)k-1.0)/2.0;
					
					double xcog = 0;
					double ycog = 0;
					
					for (int i = startr; i < startr+k; i++) {
						for (int j = startc; j < startc+k; j++) {
							
							if ((i == startr || i == startr+k-1) && (j==startc || j==startc+k-1))
								continue;
							
							xcog += (i-centerR) * (double)grid[i][j];
							ycog += (j-centerC) * (double)grid[i][j];
						}
					}
					
					if (Math.abs(xcog) < 0.000000001 && Math.abs(ycog) < 0.000000001)
						best = Math.max(best, k);
				}
			}
		}
		
		if (best < 3)
			return "IMPOSSIBLE";
		else
			return Integer.toString(best);
	}

	public static int[] readIntArr() {
		int n = in.nextInt();
		int[] res = new int[n];
		for (int i = 0; i < n; i++)
			res[i] = in.nextInt();
		return res;
	}

	public static interface Parser<T> {
		public T next();
	}

	public static <T> ArrayList<T> readList(Parser<T> p) {
		int n = in.nextInt();
		ArrayList<T> res = new ArrayList<T>();
		for (int i = 0; i < n; i++)
			res.add(p.next());
		return res;
	}

	public static Parser<Integer> intParser = new Parser<Integer>() {
		public Integer next() {
			return in.nextInt();
		}
	};

	public static void main(String[] args) throws FileNotFoundException {
		String inFilename = problemName + "-" + inputName + ".in";
		String outFilename = problemName + "-" + inputName + ".out";
		System.out.println("Reading from " + inFilename);
		System.out.println("Writing to " + outFilename);
		in = new Scanner(new File(inFilename));
		out = new PrintStream(new File(outFilename));

		int ncases = in.nextInt();

		for (int i = 0; i < ncases; i++) {
			System.out.println("Running case " + (i + 1) + "...");
			out.println("Case #" + (i + 1) + ": " + handleCase());
		}
		System.out.println("Done!");
	}

	static Scanner in;
	static PrintStream out;
}
