package round3;

import com.google.common.collect.ImmutableList;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.*;

public class B {
    private static final String PROBLEM = "round3/B-small-attempt2";
    private final Scanner in;
    public B(Scanner in) {
        this.in = in;
    }

    private String runCase() {
        int numSourceVals = in.nextInt();
        int windowSize = in.nextInt();
        List<Integer> sums = nextIntList(numSourceVals - windowSize + 1);

        List<Window> windows = new ArrayList<>();
        for (int i = 0; i < windowSize; i++) {
            int currentVal = 0;
            int minSeen = 0;
            int maxSeen = 0;
            for (int j = i; j < sums.size() - 1; j += windowSize) {
                int diff = sums.get(j + 1) - sums.get(j);
                currentVal += diff;
                minSeen = Math.min(currentVal, minSeen);
                maxSeen = Math.max(currentVal, maxSeen);
            }
            windows.add(new Window(minSeen, maxSeen));
        }


        int maxWindowSize = 0;
        int totalWindowLengths = 0;
        Set<Integer> windowLengths = new HashSet<>();
        for (Window window : windows) {
            maxWindowSize = Math.max(maxWindowSize, window.maxDiff - window.minDiff);
            totalWindowLengths += window.maxDiff - window.minDiff;
            windowLengths.add(window.maxDiff - window.minDiff);
        }

        int targetSum = sums.get(0);

        int answer;
        if (windowLengths.size() > 1 || (totalWindowLengths - targetSum) % windows.size() == 0) {
            answer = maxWindowSize;
        } else {
            answer = maxWindowSize + 1;
        }
        return String.format("%d", answer);
    }

    static class Window {
        final int minDiff;
        final int maxDiff;
        public Window(int minDiff, int maxDiff) {
            this.minDiff = minDiff;
            this.maxDiff = maxDiff;
        }
    }

    private List<Integer> nextIntList(int n) {
        ImmutableList.Builder<Integer> builder = ImmutableList.builder();
        for (int i = 0; i < n; i++) {
            builder.add(in.nextInt());
        }
        return builder.build();
    }

    private void runCases() throws FileNotFoundException {
        int numCases = in.nextInt();
        PrintWriter writer = new PrintWriter(PROBLEM + ".out");
        for (int casenum = 1; casenum <= numCases; casenum++) {
            String result = runCase();
            System.out.printf("Case #%d: %s%n", casenum, result);
            writer.printf("Case #%d: %s%n", casenum, result);
            writer.flush();
        }
    }

    public static void main(String[] args) throws FileNotFoundException {
        Scanner in = new Scanner(new File(PROBLEM + ".in"));
        new B(in).runCases();
    }
}

/*
 * Uses Google Guava: https://github.com/google/guava
 */