import java.util.*;
import java.io.*;

public class A {

    static long mod = 1000002013L;
    
    static class El implements Comparable<El> {
        int pos, number;
        boolean entry;
        
        El(int pos, int number, boolean entry) {
            this.pos = pos;
            this.number = number;
            this.entry = entry;
        }
        
        @Override
        public int compareTo(El other) {
            if (pos != other.pos) {
                return pos < other.pos ? -1 : 1;
            }
            if (entry != other.entry) {
                return entry ? -1 : 1;
            }
            if (number != other.number) {
                return number < other.number ? -1 : 1;
            }
            return 0;
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        StringTokenizer st = new StringTokenizer(br.readLine());
        int T = Integer.parseInt(st.nextToken());
        for (int I = 1; I <= T; ++I) {
            long fair = 0;
            st = new StringTokenizer(br.readLine());
            int N = Integer.parseInt(st.nextToken());
            int M = Integer.parseInt(st.nextToken());
            List<El> list = new ArrayList<El>();
            for (int i = 0; i < M; ++i) {
                st = new StringTokenizer(br.readLine());
                int a = Integer.parseInt(st.nextToken());
                int b = Integer.parseInt(st.nextToken());
                int c = Integer.parseInt(st.nextToken());

                fair += foo(a, b, c, N);
                fair %= mod;

                list.add(new El(a, c, true));
                list.add(new El(b, c, false));
            }
            Collections.sort(list);
            int[] prev = new int[list.size()];
            int j = -1;
            for (int i = 0; i < prev.length; ++i) {
                if (!list.get(i).entry) {
                    continue;
                }
                prev[i] = j;
                j = i;
            }
            long min = 0;
            int last = -1;
            for (int i = 0; i < list.size(); ++i) {
                El cur = list.get(i);
                if (cur.entry) {
                    last = i;
                    continue;
                }
//                System.err.println(i);
                int curPeople = 0;
                int clast = last;
                while ((clast >= 0) && (curPeople < cur.number)) {
                    int d = Math.min(cur.number - curPeople, list.get(clast).number);
//                    System.err.println(list.get(clast).pos + " -> " + cur.pos + " (" + d + ")");
                    min += foo(list.get(clast).pos, cur.pos, d, N);
                    min %= mod;
                    
                    curPeople += d;
                    list.get(clast).number -= d;
                    clast = prev[clast];
                }
                /*
                for (int q = firstLast; q != last; ) {
                    int to = prev[q];
                    prev[q] = last;
                    q = to;
                }
                */
            }
            long dif = (fair - min) % mod;
            if (dif < 0) {
                dif += mod;
            }
            System.out.println("Case #" + I + ": " + dif);
        }
    }

    static long foo(long a, long b, long c, long N) {
        long k = b - a + 1;
        long r = 2 * N - k + 2;
        r *= (k - 1);
        r /= 2;
        r %= mod;
        r *= c;
        r %= mod;
        return r;
    }

}
