import java.math.BigInteger;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) {

        ar[0] = BigInteger.ZERO;
        ar[1] = BigInteger.valueOf(3);
        ar[2] = BigInteger.valueOf(2);
        for (int i = 3; i < ar.length; ++i) {
            if (i % 2 == 0) {
                ar[i] = BigInteger.valueOf(2).pow(i / 2 - 1).add(BigInteger.ONE);
            } else {
                ar[i] = BigInteger.valueOf(2).pow(i / 2 - 1).multiply(BigInteger.valueOf(3)).add(BigInteger.valueOf(2));
            }
        }
        
        sr[0] = ar[0];
        for (int i = 1; i < sr.length; ++i) {
            sr[i] = sr[i - 1].add(ar[i]);
        }
        
        tr[0] = BigInteger.ONE;
        tr[1] = BigInteger.valueOf(2);
        for (int i = 2; i < tr.length; ++i) {
            if (i % 2 == 0) {
                tr[i] = BigInteger.valueOf(2).pow(i / 2);
            } else {
                tr[i] = BigInteger.valueOf(2).pow(i / 2).multiply(BigInteger.valueOf(3));
            }
        }
        
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();

        for (int i = 1; i <= t; ++i) {
            String a = sc.next();
            String b = sc.next();

            BigInteger ta = new BigInteger(a);
            BigInteger tb = new BigInteger(b);
            BigInteger tta = sqrt(ta);
            BigInteger ttb = sqrt(tb);
            if (tta.multiply(tta).compareTo(ta) < 0) {
                tta = tta.add(BigInteger.ONE);
            }

            BigInteger sa = calc(tta.toString());
            BigInteger sb = calc(ttb.toString());
//            System.err.println("calc(" + tta + ") = " + sa);
//            System.err.println("calc(" + ttb + ") = " + sb);
            if (isPal(tta.toString())) {
                sa = sa.subtract(BigInteger.ONE);
            }
            System.out.println("Case #" + i + ": " + sb.subtract(sa));
        }
    }

    static BigInteger sqrt(BigInteger x) {
        BigInteger low = BigInteger.ZERO;
        BigInteger high = x.add(BigInteger.ONE);
        while (high.subtract(low).compareTo(BigInteger.ONE) == 1) {
            BigInteger m = low.add(high).divide(BigInteger.valueOf(2));
            BigInteger p = m.multiply(m);
            int c = p.compareTo(x);
            if (c == 0) {
                return m;
            }
            if (c == -1) {
                low = m;
            } else {
                high = m;
            }
        }
        return low;
    }

    static int len = 150;
    static BigInteger[] ar = new BigInteger[len];
    static BigInteger[] sr = new BigInteger[len];
    static BigInteger[] tr = new BigInteger[len];
    
    static BigInteger calc(String s) {
        if (s.length() == 1) {
            if (s.equals("1")) return BigInteger.ONE;
            if (s.equals("2")) return BigInteger.valueOf(2);
            return BigInteger.valueOf(3);
        }
        BigInteger ans = BigInteger.ONE;
        s = makePal(s);
        int l = s.length();
        if (s.charAt(0) == '2') {
            ans = sr[s.length()];
            if ((l % 2 == 1) && (s.charAt(l / 2) == '0')) {
                ans = ans.subtract(BigInteger.ONE);
            }
            return ans;
        }
        int m = l / 2;
        for (int i = 1; i < m; ++i) {
            if (s.charAt(i) == '1') {
                ans = ans.add(tr[l - 2 * (i + 1)]);
            }
        }
        if (l % 2 == 1) {
            ans = ans.add(BigInteger.valueOf(s.charAt(l / 2) - '0'));
        }
        return ans.add(sr[l - 1]);
    }
    
    static String makePal(String s) {
        StringBuilder sb = new StringBuilder();
        int l = s.length();
        int m = (l + 1) / 2;
        boolean decreased = false;
        int last = -1;
        for (int i = 0; i < m; ++i) {
            if (s.charAt(i) < '2') {
                sb.append(s.charAt(i));
                if ((s.charAt(i) != '0') && ((s.charAt(i) != '1') || (i != 0))) {
                    last = i;
                }
                continue;
            }
            if (i == 0) {
                sb.append('2');
                last = i;
                decreased |= s.charAt(0) > '2';
                continue;
            }
            sb.append('1');
            decreased = true;
            last = i;
        }
        for (int i = m; i < l; ++i) {
            if ((s.charAt(i) < sb.charAt(l - 1 - i)) && !decreased) {
                if (last != -1) {
                    sb.setCharAt(last, (char)(sb.charAt(last) - 1));
                    for (int j = last + 1; j < i; ++j) {
                        sb.setCharAt(j, '1');
                    }
                    sb.append(sb.charAt(l - 1 - i));
                    decreased = false;
                    continue;
                }
                return maxPal(l - 1);
            }
            sb.append(sb.charAt(l - 1 - i));
        }
        if (l % 2 == 1) {
            sb.setCharAt(l / 2, '2');
        }
        while (sb.toString().compareTo(s) > 0) {
            sb.setCharAt(l / 2, (char)(sb.charAt(l / 2) - 1));
        }
//        System.err.println("maxPal(" + s + ") = " + sb.toString());
        return sb.toString();
    }
    
    static String maxPal(int len) {
        if (len == 1) {
            return "2";
        }
        StringBuilder sb = new StringBuilder(len);
        sb.append('2');
        for (int i = 1; i < len - 1; ++i) {
            sb.append('0');
        }
        sb.append('2');
        if (len % 2 == 1) {
            sb.setCharAt(len / 2, '1');
        }
        return sb.toString();
    }
    
    static boolean isPal(String s) {
        BigInteger b = new BigInteger(s);
        String t = b.multiply(b).toString();
        for (int i = 0; i < s.length() / 2; ++i) {
            if (s.charAt(i) != s.charAt(s.length() - 1 - i)) {
                return false;
            }
        }
        for (int i = 0; i < t.length() / 2; ++i) {
            if (t.charAt(i) != t.charAt(t.length() - 1 - i)) {
                return false;
            }
        }
        return true;
    }

}
