/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package permrle;


import java.io.*;
import java.util.*;


/**
 *
 * @author Alan
 */
public class PermRLE {

    public Vector getPermuations(String s){

        Vector perms = new Vector();
        if (s.length() == 2) {
            perms.add(s);
            perms.add("" + s.charAt(1) + s.charAt(0));
            return perms;
        }
        
        else {
            
            for(int i=0; i<s.length();i++){
                String newS = s.substring(0,i) + s.substring(i+1,s.length());
//                System.out.println("newS" + newS);
                Vector subPerms = getPermuations(newS);
                for(int j=0; j<subPerms.size(); j++){
//                    System.out.println("String " + s.charAt(i) + (String) subPerms.get(j));
                    perms.add(s.charAt(i) + (String) subPerms.get(j));
                }
            }
            
            
            return perms;
        }
        
        
        
        
    }
    
    public String rearrage(String s, int[] permArr){
        
        String newS = "";
        for(int i=0; i < permArr.length; i++){
//            System.out.println("i " + i + " pa " + permArr[i]);
            newS += s.charAt(permArr[i]);
        }
        
        return newS;
    }
    
    
    
    public int calculateSize(String perm, String s, int k){
        char top = '*';
        Stack stack = new Stack();
        
        int[] permArr = new int[perm.length()];
        for(int i =0; i < perm.length(); i++){
            permArr[i] = (Integer) Integer.parseInt("" + perm.charAt(i));
        }
        
        for(int i = 0; i < s.length(); i += k){
            
//            System.out.println("i" + i);
            
            String smallS = s.substring(i, i + k);
            String newSmallS = rearrage(smallS, permArr);
            
//            System.out.println("smallS " + smallS + " newsmallS" + newSmallS);
            
            for(int j =0; j < k; j++){
                char current = newSmallS.charAt(j);
//                System.out.println("Comparing " + current + " with " + top);
                if(current != top) {
                    stack.add(current);
                    top = current;
                }
                
            }
        }
        
        return stack.size();
    }

    
    public int getOptimalRLE(int k, String s){
        
        // calculate all possible permuations
        String permS = "";
        for(int i=0; i < k; i++){
            permS += i;
        }
        Vector perms = getPermuations(permS);
        
        // choose best permuation
        int ourMin = Integer.MAX_VALUE;
        for(int p =0; p < perms.size(); p++){
            int size = calculateSize((String) perms.get(p), s, k);
//            System.out.println("Size for perm " + p + " is " + size);
            if(size < ourMin) ourMin  = size;
        }
        
        return ourMin;
        
    }
    
    public void doRLEFile(String infile, String outfile){
        try {
            BufferedReader reader = new BufferedReader(new FileReader(infile));
            BufferedWriter writer = new BufferedWriter(new FileWriter(outfile));

            // Read in the text file to get the number of occurances
            String line = reader.readLine().trim();
            int num_occ = Integer.parseInt(line);
            // For each occurances
            for(int i=0; i < num_occ; i++) {

                // Read in the text file line
                line = reader.readLine().trim();
                int k = Integer.parseInt(line);
                line = reader.readLine().trim();
                String s = line;
                int min = getOptimalRLE(k,s);
                
                
                
//                String[] lineArr = line.split(" ");
                String outline = "Case #" + (i+1) + ": " + min + "\n";
                writer.write(outline);
                System.out.print(outline);                 
                
            } // for num_occurances
            
            reader.close();
            writer.close();
            
        } catch (Exception e){ 
            e.printStackTrace();
        }            

    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here

    //        String infile = "C-large.in";
//        String outfile = "C-large.out";

        String infile = "D-small-attempt1.in";
        String outfile = "D-small-attempt1.out";

//        String infile = "PermIn.txt";
//        String outfile = "PermOut.txt";
        
        PermRLE me = new PermRLE();
        me.doRLEFile(infile, outfile);
    }

}
