/*
 * SaveUniverse.java
 * @author Alan Woodley
 * A Java Program that will save the universe
 * The basic premis is to have two hashtables both contain a list of 
 * search engine's names. The first hashtable is filled at the each query log.
 * The second hash table is filled as the queries are entered into the system,
 * and contains unquie search engine names. When the second hash table is the same
 * size as the number of search engines then they have all been visted. So we need to
 * preform a swtich, by clearing the second hash table (expcet for the last visted
 * search engine), incrementing the number of switches and continuing.   
 * 
*/

package saveuniverse;

import java.io.*;
import java.util.*;

public class SaveUniverse {

            
    private void DoSaveUniverse(String infile, String outfile){
        
        try {
            BufferedReader reader = new BufferedReader(new FileReader(infile));
            BufferedWriter writer = new BufferedWriter(new FileWriter(outfile));

            // Read in the text file to get the number of query sets
            String line = reader.readLine().trim();
            int num_occ = Integer.parseInt(line);
            // For each query set 
            for(int i=0; i < num_occ; i++) {
                // for each  query sets read in the number of search engines
                line = reader.readLine().trim();
                int num_engines = Integer.parseInt(line);
                
                // then read in each search engine's name and save in a Hashtable               
                Hashtable engine_names = new Hashtable((int) (num_engines * 1.5)); 
                for(int j=0; j < num_engines; j++){
                    line = reader.readLine().trim();
                    engine_names.put(line, true);
                } // for search engine names
                
                // declare a second hash table  
                Hashtable visted_engines = new Hashtable((int) (num_engines * 1.5));

                // number of switches should be initialised to 0
                int num_switches = 0;
                
                // then read in number of queries
                line = reader.readLine().trim();
                int num_queries = Integer.parseInt(line);
                               
                // now process each query
                for(int j=0; j < num_queries; j++){
                    line = reader.readLine().trim();
                    
                    // if the query term is the same as the name (case-sensitive) of one of the search engines
                    // then the universe could be in trouble
                    if(engine_names.containsKey(line)) {

                        // if this is the first time that the query term has been a search engine name
                        // since the last switch add it to the list of visited engines                        
                        if(!visted_engines.containsKey(line)) {
                            visted_engines.put(line, true);
                        } 
                        
                        // if the all engines have been visited then we need to make a switch
                        // so empty the hash table except for the last search engine/query and 
                        // increment the  number of switches
                        if(visted_engines.size() == num_engines) {
                            visted_engines.clear();
                            visted_engines.put(line, true);
                            num_switches++;
                        }
                        
                    } // if query term is a search engine name
                        
                }  // for all queries
                
//                System.out.println("Case #" + (i+1) + ": " + num_switches);
                writer.write("Case #" + (i+1) + ": " + num_switches + "\n");
                
                
                
            } // for num_occurances
            
            reader.close();
            writer.close();
        } catch (Exception e){ 
            e.printStackTrace();
        }
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        
        String infile = "A-small-attempt1.in";
        String outfile = "A-small-attempt1.out";

//        String infile = "SUTestIn.txt";
//        String outfile = "SUTestOut.txt";
        
        SaveUniverse me = new SaveUniverse();
        me.DoSaveUniverse(infile, outfile);
        
        
    }

}
