import java.io.*;
import java.util.*;

public class Main implements Runnable {

	private void solution() throws IOException {
		for (int cas = 1, ts = in.nextInt(); cas <= ts; ++cas) {
			int n = in.nextInt();
			String[] grid = new String[n];
			for (int i = 0; i < n; ++i) {
				grid[i] = in.next();
			}
			boolean[][] isApponent = new boolean[n][n];

			double[] wp = new double[n];
			double[] owp = new double[n];
			double[] oowp = new double[n];
			for (int i = 0; i < n; ++i) {
				int cnt = 0;
				int sum = 0;
				for (int j = 0; j < n; ++j) {
					if (grid[i].charAt(j) != '.') {
						isApponent[i][j] = true;
						sum += grid[i].charAt(j) - '0';
						++cnt;
					}
				}
				wp[i] = (double) sum / cnt;
			}

			for (int i = 0; i < n; ++i) {
				double all = 0;
				int apponents = 0;
				for (int j = 0; j < n; ++j) {
					if (isApponent[i][j]) {
						++apponents;

						int cnt = 0;
						int sum = 0;
						for (int k = 0; k < n; ++k) {
							if (k != i && grid[j].charAt(k) != '.') {
								++cnt;
								sum += grid[j].charAt(k) - '0';
							}
						}
						all += (double) sum / cnt;
					}
				}
				owp[i] = all / apponents;
			}

			for (int i = 0; i < n; ++i) {
				double all = 0;
				int apponets = 0;
				for (int j = 0; j < n; ++j) {
					if (isApponent[i][j]) {
						all += owp[j];
						++apponets;
					}
				}
				oowp[i] = all / apponets;
			}

			// debug(wp);
			// debug(owp);
			// debug(oowp);
			out.printf("Case #%d:\n", cas);
			for (int i = 0; i < n; ++i) {
				out.printf("%.7f\n", rpi(i, wp, owp, oowp));
			}
		}
	}

	private double rpi(int i, double[] wp, double[] owp, double[] oowp) {
		return 0.25 * wp[i] + 0.50 * owp[i] + 0.25 * oowp[i];
	}

	private void debug(Object... o) {
		System.err.println(Arrays.deepToString(o));
	}

	@Override
	public void run() {
		try {
			String fileName = "A";
			try {
				in = new Scanner(new FileReader(fileName + ".in"));
				out = new PrintWriter(fileName + ".out");
			} catch (Exception e) {
			}
			solution();
			in.reader.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private class Scanner {
		StringTokenizer tokenizer;
		BufferedReader reader;

		public Scanner(Reader reader) {
			this.reader = new BufferedReader(reader);
			this.tokenizer = new StringTokenizer("");
		}

		public boolean hasNext() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				String line = reader.readLine();
				if (line == null) {
					return false;
				}
				tokenizer = new StringTokenizer(line);
			}
			return true;
		}

		public String next() throws IOException {
			hasNext();
			return tokenizer.nextToken();
		}

		public String nextLine() throws IOException {
			tokenizer = new StringTokenizer("");
			return reader.readLine();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		public long nextLong() throws IOException {
			return Long.parseLong(next());
		}

		public double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new Thread(null, new Main(), "", 1 << 28).start();
	}

	private Scanner in = new Scanner(new InputStreamReader(System.in));
	private PrintWriter out = new PrintWriter(new OutputStreamWriter(System.out));
}