import java.io.*;
import java.util.*;

public class Main implements Runnable {

	private void solution() throws IOException {
		for (int cas = 1, ts = in.nextInt(); cas <= ts; ++cas) {
			int n = in.nextInt();
			int d = in.nextInt();
			List<Double> pos = new ArrayList<Double>();
			for (int i = 0; i < n; ++i) {
				int p = in.nextInt();
				int cnt = in.nextInt();
				for (int j = 0; j < cnt; ++j) {
					pos.add((double) p);
				}
			}

			double left = 0;
			double right = 1e10;
			for (int it = 0; it < 100; ++it) {
				double m = (left + right) / 2.0;
				if (check(m, d, new ArrayList(pos))) {
					right = m;
				} else {
					left = m;
				}
			}
			out.printf("Case #%d: %.7f\n", cas, left);
		}
	}

	private boolean check(double time, int d, List<Double> pos) {
		double left = -1e20;
		int li = 0;
		double right = 1e20;
		int ri = pos.size() - 1;
		boolean move = true;
		while (move && li <= ri) {
			move = false;
			if (li < pos.size() && moveLeft(li, left, time, d, pos)) {
				move = true;
				left = pos.get(li);
				++li;
			} else if (ri >= 0 && moveRight(ri, right, time, d, pos)) {
				move = true;
				right = pos.get(ri);
				--ri;
			}
		}

		return check(d, pos);
	}

	private boolean moveLeft(int fromId, double to, double time, int d, List<Double> pos) {
		double dist = pos.get(fromId) - (to + d);
		if (dist < 0) {
			return false;
		} else if (dist >= time) {
			double res = pos.get(fromId);
			res -= time;
			pos.set(fromId, res);
		} else {
			double res = pos.get(fromId);
			res = (to + d);
			pos.set(fromId, res);
		}
		return true;
	}

	private boolean moveRight(int fromId, double to, double time, int d, List<Double> pos) {
		double dist = (to - d) - pos.get(fromId);
		if (dist < 0) {
			return false;
		} else if (dist >= time) {
			double res = pos.get(fromId);
			res += time;
			pos.set(fromId, res);
		} else {
			double res = pos.get(fromId);
			res = (to - d);
			pos.set(fromId, res);
		}
		return true;
	}

	private boolean check(int d, List<Double> pos) {
		for (int i = 1; i < pos.size(); ++i) {
			if (pos.get(i) - pos.get(i - 1) < d) {
				return false;
			}
		}
		return true;
	}

	private void debug(Object... o) {
		System.err.println(Arrays.deepToString(o));
	}

	@Override
	public void run() {
		try {
			String fileName = "B";
			try {
				in = new Scanner(new FileReader(fileName + ".in"));
				out = new PrintWriter(fileName + ".out");
			} catch (Exception e) {
			}
			solution();
			in.reader.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private class Scanner {
		StringTokenizer tokenizer;
		BufferedReader reader;

		public Scanner(Reader reader) {
			this.reader = new BufferedReader(reader);
			this.tokenizer = new StringTokenizer("");
		}

		public boolean hasNext() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				String line = reader.readLine();
				if (line == null) {
					return false;
				}
				tokenizer = new StringTokenizer(line);
			}
			return true;
		}

		public String next() throws IOException {
			hasNext();
			return tokenizer.nextToken();
		}

		public String nextLine() throws IOException {
			tokenizer = new StringTokenizer("");
			return reader.readLine();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		public long nextLong() throws IOException {
			return Long.parseLong(next());
		}

		public double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new Thread(null, new Main(), "", 1 << 28).start();
	}

	private Scanner in = new Scanner(new InputStreamReader(System.in));
	private PrintWriter out = new PrintWriter(new OutputStreamWriter(System.out));
}