import java.io.*;
import java.util.*;

public class Main implements Runnable {

	private void solution() throws IOException {
		for (int cas = 1, ts = in.nextInt(); cas <= ts; ++cas) {
			int n = in.nextInt();
			int[] all = new int[n];
			int exist = 0;
			for (int i = 0; i < n; ++i) {
				all[i] = in.nextInt();
				exist ^= all[i];
			}

			out.printf("Case #%d: ", cas);
			if (exist != 0) {
				out.println("NO");
			} else {
				// int res = brute(all);
				Arrays.sort(all);
				long sum = 0;
				for (int i = all.length - 1; i > 0; --i) {
					sum += all[i];
				}
				out.println(sum);
			}
		}
	}

	private int brute(int[] a) {
		int max = -1;
		for (int mask = 0; mask < (1 << a.length); ++mask) {
			int x1 = 0;
			int x2 = 0;
			int sum1 = 0;
			int sum2 = 0;
			for (int i = 0; i < a.length; ++i) {
				if (((mask >> i) & 1) == 0) {
					x1 ^= a[i];
					sum1 += a[i];
				} else {
					x2 ^= a[i];
					sum2 += a[i];
				}
			}
			if ((x1 ^ x2) == 0 && Math.min(sum1, sum2) > 0) {
				max = Math.max(max, Math.max(sum1, sum2));
			}
		}
		return max;
	}

	private void debug(Object... o) {
		System.err.println(Arrays.deepToString(o));
	}

	@Override
	public void run() {
		try {
			String fileName = "C";
			try {
				in = new Scanner(new FileReader(fileName + ".in"));
				out = new PrintWriter(fileName + ".out");
			} catch (Exception e) {
			}
			solution();
			in.reader.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private class Scanner {
		StringTokenizer tokenizer;
		BufferedReader reader;

		public Scanner(Reader reader) {
			this.reader = new BufferedReader(reader);
			this.tokenizer = new StringTokenizer("");
		}

		public boolean hasNext() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				String line = reader.readLine();
				if (line == null) {
					return false;
				}
				tokenizer = new StringTokenizer(line);
			}
			return true;
		}

		public String next() throws IOException {
			hasNext();
			return tokenizer.nextToken();
		}

		public String nextLine() throws IOException {
			tokenizer = new StringTokenizer("");
			return reader.readLine();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		public long nextLong() throws IOException {
			return Long.parseLong(next());
		}

		public double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new Thread(null, new Main(), "", 1 << 28).start();
	}

	private Scanner in = new Scanner(new InputStreamReader(System.in));
	private PrintWriter out = new PrintWriter(new OutputStreamWriter(System.out));
}