import java.io.*;
import java.util.*;

public class Main {

	Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

	private final String fileName = "e:\\Olimp\\Solutions\\Code Jam\\A";

	public void solution() throws IOException {
		in = new Scanner(new BufferedReader(new FileReader(fileName + ".in")));
		out = new PrintWriter(fileName + ".out");
		for (int cas = 1, q = in.nextInt(); q > 0; --q, ++cas) {
			int n = in.nextInt();
			int k = in.nextInt();
			char[][] grid = new char[n][];
			for (int i = 0; i < n; ++i) {
				grid[i] = in.next().toCharArray();
			}
			grid = rotate(grid);
			gravity(grid);
			boolean red = isWin('R', k, grid);
			boolean blue = isWin('B', k, grid);
			out.printf("Case #%d: ", cas);
			if (red && blue) {
				out.println("Both");
			} else if (red) {
				out.println("Red");
			} else if (blue) {
				out.println("Blue");
			} else {
				out.println("Neither");
			}

		}
		out.flush();
	}

	int[] dx = new int[] { -1, 0, 1, 1 };
	int[] dy = new int[] { 1, 1, 1, 0 };

	private boolean isWin(char c, int k, char[][] grid) {
		for (int i = 0; i < grid.length; ++i) {
			for (int j = 0; j < grid[i].length; ++j) {
				if (grid[i][j] == c) {
					for (int d = 0; d < dx.length; ++d) {
						if (isWinPos(i, j, dx[d], dy[d], c, k, grid)) {
							return true;
						}
					}
				}
			}
		}
		return false;
	}

	private boolean isWinPos(int i, int j, int dx, int dy, char c, int k, char[][] grid) {
		if (!(i >= 0 && i < grid.length && j >= 0 && j < grid[i].length) || grid[i][j] != c) {
			return false;
		}
		if (k == 1) {
			return true;
		}
		return isWinPos(i + dx, j + dy, dx, dy, c, k - 1, grid);
	}

	private void gravity(char[][] grid) {
		for (int j = 0; j < grid[0].length; ++j) {
			int lastX = grid.length;
			for (int i = grid.length - 1; i >= 0; --i) {
				if (grid[i][j] != '.' && i != lastX - 1) {
					grid[--lastX][j] = grid[i][j];
					grid[i][j] = '.';
				} else if (grid[i][j] != '.') {
					--lastX;
				}
			}
		}
	}

	private char[][] rotate(char[][] grid) {
		int n = grid.length;
		char[][] res = new char[n][n];
		for (int i = 0; i < n; ++i) {
			for (int j = 0; j < n; ++j) {
				res[j][n - i - 1] = grid[i][j];
			}
		}
		return res;
	}

	private class Scanner {

		BufferedReader reader;
		StringTokenizer tokenizer;

		public Scanner(BufferedReader reader) {
			this.reader = reader;
			this.tokenizer = new StringTokenizer("");
		}

		public boolean hasNext() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				String next = reader.readLine();
				if (next == null) {
					return false;
				}
				tokenizer = new StringTokenizer(next);
			}
			return true;
		}

		public String nextLine() throws IOException {
			tokenizer = new StringTokenizer("");
			return reader.readLine();
		}

		public String next() throws IOException {
			hasNext();
			return tokenizer.nextToken();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		public double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}

	}

	public static void main(String[] args) throws IOException {
		new Main().solution();
	}
}