import java.io.*;
import java.util.*;

public class Main implements Runnable {

	static class Command {
		String color;
		int button;

		public Command(String color, int button) {
			this.color = color;
			this.button = button;
		}
	}

	private void solution() throws IOException {
		for (int cas = 1, ts = in.nextInt(); cas <= ts; ++cas) {
			int n = in.nextInt();
			Command[] cm = new Command[n];
			for (int i = 0; i < n; ++i) {
				cm[i] = new Command(in.next(), in.nextInt());
			}
			int res = 0;
			int pos1 = 1;
			int pos2 = 1;
			int rem1 = 0;
			int rem2 = 0;

			for (Command c : cm) {
				if (c.color.equals("O")) {
					int cur = calc(pos1, c.button, rem1) + 1;
					pos1 = c.button;
					res += cur;
					rem1 = 0;
					rem2 += cur;
				} else {
					int cur = calc(pos2, c.button, rem2) + 1;
					pos2 = c.button;
					res += cur;
					rem2 = 0;
					rem1 += cur;
				}
			}
			out.printf("Case #%d: %d\n", cas, res);
		}
	}

	private int calc(int pos, int last, int rem) {
		int need = Math.abs(pos - last);
		return Math.max(0, need - rem);
	}

	private void debug(Object... o) {
		System.err.println(Arrays.deepToString(o));
	}

	@Override
	public void run() {
		try {
			String fileName = "A";
			try {
				in = new Scanner(new FileReader(fileName + ".in"));
				out = new PrintWriter(fileName + ".out");
			} catch (Exception e) {
			}
			solution();
			in.reader.close();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private class Scanner {
		StringTokenizer tokenizer;
		BufferedReader reader;

		public Scanner(Reader reader) {
			this.reader = new BufferedReader(reader);
			this.tokenizer = new StringTokenizer("");
		}

		public boolean hasNext() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				String line = reader.readLine();
				if (line == null) {
					return false;
				}
				tokenizer = new StringTokenizer(line);
			}
			return true;
		}

		public String next() throws IOException {
			hasNext();
			return tokenizer.nextToken();
		}

		public String nextLine() throws IOException {
			tokenizer = new StringTokenizer("");
			return reader.readLine();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		public long nextLong() throws IOException {
			return Long.parseLong(next());
		}

		public double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] args) {
		new Thread(null, new Main(), "", 1 << 28).start();
	}

	private Scanner in = new Scanner(new InputStreamReader(System.in));
	private PrintWriter out = new PrintWriter(new OutputStreamWriter(System.out));
}