import java.io.*;
import java.util.*;

public class Main implements Runnable {

	PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));
	Scanner in = new Scanner(new InputStreamReader(System.in));

	private void solution() throws IOException {
		in = new Scanner(new FileReader("C:\\A.in"));
		out = new PrintWriter(new FileWriter("C:\\A.out"));
		for (int cas = 1, q = in.nextInt(); q > 0; --q, ++cas) {
			int raunds = in.nextInt();
			int size = Integer.highestOneBit((1 << raunds));
			Integer[] tree = new Integer[size * 2];
			for (int i = 0; i < (1 << raunds); ++i) {
				tree[i + size] = (raunds - in.nextInt());
			}
			for (int i = raunds - 1; i >= 0; --i) {
				for (int j = 0; j < (1 << i); ++j) {
					in.nextInt();
				}
			}
			int cost = getCost(1, tree);
			out.printf("Case #%d: %d\n", cas, cost);
		}
	}

	private int getCost(int at, Integer[] tree) {
		if (isEnd(at, tree)) {
			return 0;
		}
		initAll(at, tree);
		int res = getCost(2 * at, tree) + getCost(2 * at + 1, tree) + 1;
		return res;
	}

	private boolean isEnd(int at, Integer[] tree) {
		if (tree[at] != null && tree[at] > 0) {
			return false;
		} else if (2 * at < tree.length && 2 * at + 1 < tree.length) {
			return isEnd(2 * at, tree) & isEnd(2 * at + 1, tree);
		}
		return true;
	}

	private void initAll(int at, Integer[] tree) {
		if (tree[at] != null && tree[at] > 0) {
			--tree[at];
		}
		if (2 * at < tree.length && 2 * at + 1 < tree.length) {
			initAll(2 * at, tree);
			initAll(2 * at + 1, tree);
		}
	}

	@Override
	public void run() {
		try {
			solution();
			in.reader.close();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private class Scanner {

		private StringTokenizer tokenizer;
		private BufferedReader reader;

		public Scanner(Reader in) {
			reader = new BufferedReader(in);
			tokenizer = new StringTokenizer("");
		}

		public boolean hasNext() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				String tmp = reader.readLine();
				if (tmp == null)
					return false;
				tokenizer = new StringTokenizer(tmp);
			}
			return true;
		}

		public String next() throws IOException {
			hasNext();
			return tokenizer.nextToken();
		}

		public String nextLine() throws IOException {
			tokenizer = new StringTokenizer("");
			return reader.readLine();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}
	}

	public static void main(String[] args) throws IOException {
		new Thread(null, new Main(), "Main", 1 << 28).start();
	}
}
