import java.io.*;
import java.util.*;

public class Main {

	Scanner in = new Scanner(new BufferedReader(
			new InputStreamReader(System.in)));
	PrintWriter out = new PrintWriter(new BufferedWriter(
			new OutputStreamWriter(System.out)));

	private final String fileName = "e:\\Olimp\\Solutions\\Code Jam\\A";

	private class Tree {
		private class Node {
			Map<String, Node> map;

			public Node() {
				map = new HashMap<String, Node>();
			}

			public void add(String s) {
				if (!map.containsKey(s)) {
					map.put(s, new Node());
				}
			}
		}

		Node root;

		public Tree() {
			this.root = new Node();
		}

		public int addPath(String[] directory) {
			int res = 0;
			Node cur = root;
			for (String s : directory) {
				if (!cur.map.containsKey(s)) {
					cur.add(s);
					++res;
				}
				cur = cur.map.get(s);
			}
			return res;
		}
	}

	public void solution() throws IOException {
		in = new Scanner(new BufferedReader(new FileReader(fileName + ".in")));
		out = new PrintWriter(fileName + ".out");
		for (int cas = 1, q = in.nextInt(); q > 0; --q, ++cas) {
			int n = in.nextInt();
			int m = in.nextInt();
			Tree root = new Tree();
			for (int i = 0; i < n; ++i) {
				String s = in.next().substring(1);
				root.addPath(s.split("/"));
			}
			int res = 0;
			for (int i = 0; i < m; ++i) {
				String s = in.next().substring(1);
				res += root.addPath(s.split("/"));
			}
			out.printf("Case #%d: ", cas);
			out.println(res);
		}
		out.flush();
	}

	private class Scanner {

		BufferedReader reader;
		StringTokenizer tokenizer;

		public Scanner(BufferedReader reader) {
			this.reader = reader;
			this.tokenizer = new StringTokenizer("");
		}

		public boolean hasNext() throws IOException {
			while (!tokenizer.hasMoreTokens()) {
				String next = reader.readLine();
				if (next == null) {
					return false;
				}
				tokenizer = new StringTokenizer(next);
			}
			return true;
		}

		public String nextLine() throws IOException {
			tokenizer = new StringTokenizer("");
			return reader.readLine();
		}

		public String next() throws IOException {
			hasNext();
			return tokenizer.nextToken();
		}

		public int nextInt() throws IOException {
			return Integer.parseInt(next());
		}

		public double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}

	}

	public static void main(String[] args) throws IOException {
		new Main().solution();
	}
}