import java.util.Scanner;

public class digits {

	public final String[] NUMS = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	public boolean haveFinished = false;
	public int caseNum;
	
	public digits(Scanner f, int ii) {
		
		String word = f.next();
		int[] count = new int[26];
		
		for(int i = 0; i < 26; i++) count[i] = 0;
		
		for(int i = 0; i < word.length(); i++)
			count[getIndex(word.charAt(i))]++;
		
		haveFinished = false;
		caseNum = ii;
		solve(count, new int[10], 0);
		
		
	}

	// Base case 1: count map is empty
	//		print answer, and quit
	// Base case 2: base case is not empty, and we can't make this word
	// 		return
	// Try taking some number of one number
	public void solve(int[] count, int[] used, int n) {
		if(haveFinished) return;
		
		if(isCountEmpty(count)) {
			
			System.out.printf("Case #%d: ", caseNum);
			for(int i = 0; i < 10; i++) {
				for(int j = 0; j < used[i]; j++) {
					System.out.print(i);
				}
			}
			System.out.println();
			
			haveFinished = true;
			return;
		}
		
		if(n > 9) return;
		
		String thisWord = NUMS[n];
		
		// Try taking out all of the letters of this word, and recurse
		while(canMakeWord(count, thisWord)) {
			used[n]++;
			for(int i = 0; i < thisWord.length(); i++) {
				count[getIndex(thisWord.charAt(i))]--;
			}
			solve(count, used, n+1);
		}
		
		// If we got down here and didn't find answer
		// we must not need this number at all. Sorry, bud
		for(int i = 0; i < used[n]; i++) {
			for(int j = 0; j < thisWord.length(); j++) {
				count[getIndex(thisWord.charAt(j))]++;
			}
		}
		used[n] = 0;
		solve(count, used, n+1);
	}
	
	public boolean isCountEmpty(int[] count) {
		for(int i = 0; i < 26; i++)
			if(count[i] != 0) return false;
		return true;
	}
	
	public boolean canMakeWord(int[] count, String word) {
		for(int i = 0; i < word.length(); i++) {
			if(count[getIndex(word.charAt(i))] == 0) return false;
		}
		return true;
	}

	public static void main(String[] args) {
		Scanner f = new Scanner(System.in);
		int cases = f.nextInt();
		for(int i = 1; i <= cases; i++) 
			new digits(f, i);
		f.close();
	}
	
	public int getIndex(char c) {
		return c - 'A';
	}
}