/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package qualif;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

/**
 *
 * @author Albi
 */
public class B {
    private static BufferedReader in;

    private static String processCase(int caseNum) throws IOException {
        System.out.println("case "+caseNum);
        String[] wholeLine = in.readLine().split(" ");
        char[][] combos = new char[8][8];
        for (int y=0; y<8; y++) {
            for (int x=0; x<8; x++) {
                combos[y][x] = ' ';
            }
        }
        int C = Integer.parseInt(wholeLine[0]);
        for (int i=1; i<=C; i++) {
            String combo = wholeLine[i];
            combos[charTo8(combo.charAt(0))][charTo8(combo.charAt(1))] = combo.charAt(2);
            combos[charTo8(combo.charAt(1))][charTo8(combo.charAt(0))] = combo.charAt(2);
        }
        boolean[][] oppos = new boolean[8][8];
        int D = Integer.parseInt(wholeLine[C+1]);
        for (int i=C+2; i<C+2+D; i++) {
            String opposite = wholeLine[i];
            oppos[charTo8(opposite.charAt(0))][charTo8(opposite.charAt(1))] = true;
            oppos[charTo8(opposite.charAt(1))][charTo8(opposite.charAt(0))] = true;
        }
        System.out.println("---- combos ----");
        for (int y=0; y<8; y++) {
            for (int x=0; x<8; x++) {
                System.out.print(combos[y][x]);
            }
            System.out.print('|');
            for (int x=0; x<8; x++) {
                System.out.print((oppos[y][x]?'X':' '));
            }
            System.out.println('|');
        }
        int N = Integer.parseInt(wholeLine[wholeLine.length-2]);
        String run = wholeLine[wholeLine.length-1];
        char[] res = new char[100];
        int pos = -1;
        for (int i=0; i<N; i++) {
            char c = run.charAt(i);
            int cAsInt = charTo8(c);
            int pcAsInt = -1;
            if (pos >= 0) {
                try {
                    pcAsInt = charTo8(res[pos]);
                } catch (IllegalArgumentException e) {
                    System.out.println("char "+res[pos]+" is not base, no combo possible");
                }
            }
            if (pcAsInt != -1 && combos[cAsInt][pcAsInt] != ' ') { // check combo
                System.out.println("got combo "+cAsInt+"+"+pcAsInt);
                res[pos] = combos[cAsInt][pcAsInt];
            } else {
                boolean doWeDie = false;
                System.out.println("no combo "+cAsInt+"+"+pcAsInt+" and we have pos ="+pos);
                for (int j=0; j<=pos; j++) {
                    System.out.println(" check for appos "+j);
                    try {
                        if (oppos[cAsInt][charTo8(res[j])]) {
                            System.out.println("  opposite "+cAsInt+"+"+res[j]+" we die");
                            doWeDie = true;
                            pos = -1;
                        } else {
                            System.out.println("  no opposite ("+j+")"+cAsInt+"+"+res[j]);
                        }
                    } catch (IllegalArgumentException e) {
                        System.out.println("  no opposite (e) ("+j+")"+cAsInt+"+"+res[j]);
                    }
                }
                if (!doWeDie) {
                    pos ++;
                    res[pos] = c;
                }
            }
        }
        String resString = "";
        for (int i=0; i<=pos; i++) {
            if (i>0) {
                resString += ", ";
            }
            resString += res[i];
        }
        return "Case #"+caseNum+": " + "["+resString+"]";
    }

    private static int charTo8(char c) {
        switch (c) {
            case 'Q': return 0;
            case 'W': return 1;
            case 'E': return 2;
            case 'R': return 3;
            case 'A': return 4;
            case 'S': return 5;
            case 'D': return 6;
            case 'F': return 7;
            default: throw new IllegalArgumentException("bad char "+c);
        }
    }

    private static boolean charIn8(char c) {
        switch (c) {
            case 'Q':
            case 'W':
            case 'E':
            case 'R':
            case 'A':
            case 'S':
            case 'D':
            case 'F':
                return true;
            default: return false;
        }
    }


    private static void processFile(String fileName) throws FileNotFoundException, IOException {
        File inFile = new File(fileName+".in");
        File outFile = new File(fileName+".out");
        in = new BufferedReader(new FileReader(inFile));
        PrintWriter out = new PrintWriter(outFile);
        String Tline = in.readLine();
        int T = Integer.parseInt(Tline);
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            out.println(processCase(caseNum));
        }
        out.close();
    }

    public static void main(String[] args) {

        File mainDir = new File(".");
        String prefix = "B";
        System.out.println(mainDir.getAbsolutePath());
        try {
            processFile(prefix+"-test");
            processFile(prefix+"-small");
            processFile(prefix+"-large");
        } catch (FileNotFoundException e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }

}
