/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package codejam2009.qualif.b;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

/**
 *
 * @author albi
 */
public class Main {

    private static BufferedReader in;
    private static PrintWriter out;
    public static int H;
    public static int W;
    public static MapNode[][] map;
    public static char currentLetter = 'a';

    public static void main(String[] args) {
        if (args.length == 0) {
            System.out.println("brak parametru z nazwa pliku do wczytania");
            System.exit(0);
        }
        try {
            in = new BufferedReader(new InputStreamReader(new FileInputStream(new File(args[0]+".in"))));
            out = new PrintWriter(new File(args[0]+".out"));
            String headLine = in.readLine();
            int mapCount = Integer.parseInt(headLine);
            for (int i=0; i<mapCount; i++) {
                doMap(i);
            }
            in.close();
            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    private static void doMap(int i) throws IOException {
        currentLetter = 'a';
        String sizeLine = in.readLine();
        System.out.println("sizeLine = "+sizeLine);
        String[] whStrings = sizeLine.split(" ");
        H = Integer.parseInt(whStrings[0]);
        W = Integer.parseInt(whStrings[1]);
        map = new MapNode[W][H];
        for (int y=0; y<H; y++) {
            String[] row = in.readLine().split(" ");
            for (int x=0; x<W; x++) {
                map[x][y] = new MapNode(Integer.parseInt(row[x]));
            }
        }
        for (int y=0; y<H; y++) {
            for (int x=0; x<W; x++) {
                map[x][y].init(x, y);
            }
        }
        out.print("Case #"+(i+1)+":");
        for (int y=0; y<H; y++) {
            for (int x=0; x<W; x++) {
                if (x>0) {
                    out.print(' ');
                } else {
                    out.println();
                }
                out.print(map[x][y].getRegion());
            }
        }
        out.println();
    }

    public static char getNextLetter() {
        char toReturn = currentLetter;
        currentLetter = (char)(currentLetter+1);
        return toReturn;
    }

    public static class MapNode {
        public int a;
        public Character region;
        public MapNode goesTo;
        public MapNode(int newA) {
            a = newA;
        }
        public void init(int x, int y) {
            if (y > 0) compareAndLeaveBetter(map[x][y-1]);
            if (x > 0) compareAndLeaveBetter(map[x-1][y]);
            if (x < W-1) compareAndLeaveBetter(map[x+1][y]);
            if (y < H-1) compareAndLeaveBetter(map[x][y+1]);
        }
        private void compareAndLeaveBetter(MapNode neighbour) {
            if (neighbour.a < this.a && (goesTo == null || neighbour.a < goesTo.a)) {
                goesTo = neighbour;
            }
        }
        public char getRegion() {
            if (region==null) {
                if (goesTo ==null) { // is sink
                    region = getNextLetter();
                } else { // is not sink
                    region = goesTo.getRegion();
                }
            }
            return region;
        }

    }
}
