/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package qualif;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

/**
 *
 * @author Albi
 */
public class C {

    private final BufferedReader in;
    private final PrintWriter out;
    private int caseNumber;
    
    public C(String fileName) throws FileNotFoundException {
        in = new BufferedReader(new FileReader(new File("files/"+fileName+".in")));
        out = new PrintWriter(new File("files/"+fileName+".out"));
    }
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            new C("C-example").solve();
            new C("C-small").solve();
            //new C("C-large").solve();
        } catch (FileNotFoundException e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
    
    private void solve() throws IOException {
        String line = in.readLine();
        int T = Integer.parseInt(line);
        for (caseNumber = 1; caseNumber <= T; caseNumber++) {
            System.out.println("Case #"+caseNumber+":");
            out.println("Case #"+caseNumber+":");
            solveCase();
        }
        in.close();
        out.close();
    }
    
    private void solveCase() throws IOException {
        String[] splitLine = in.readLine().split(" ");
        int R = Integer.parseInt(splitLine[0]);
        int C = Integer.parseInt(splitLine[1]);
        int M = Integer.parseInt(splitLine[2]);
        
        int field = R*C;
        int nonMines = field - M;
        int h; 
        int w;
        boolean win = false;
        if (nonMines == 1) {
            renderField(R, C, 1, 1, 0, 0, 0, 0);
            return;
        }
        if (nonMines == 0) {
            out.println("Impossible");
        }
        
        for (w = 1; w <= C; w++) {
            h = nonMines / w;
            if (h == 0) {
                continue;
            }
            if (h > R) {
                continue;
            }
            if (w == 1 && C > 1) {
                continue;
            }
            if (h == 1 && R > 1) {
                continue;
            }
            int left = nonMines - (w*h);
            System.out.println("Checking w/h "+w+"/"+h+" left "+left);
            
            if (left == 0) {
                renderField(R, C, w, h, 0, 0, 0, 0);
                return;
            }
            if (left == 1) {
                continue;
            }
            if (w < C && left <= h) {
                renderField(R, C, w, h, 0, 0, 0, left);
                return;
            }
            if (h < R && left <= w) {
                renderField(R, C, w, h, 0, left, 0, 0);
                return;
            }
        }
        out.println("Impossible");
    }
    
    private void renderField(int R, int C, int w, int h, int top, int bottom, int left, int right) {
        out.println("rendering here");
        for (int y = 0; y < R; y++) {
            for (int x = 0; x < C; x++) {
                if (x == 0 && y == 0) {
                    out.print("c");
                } else if ((x < w && y < h)
                       || (x == w && y < right)
                       || (y == h && x < bottom)) {
                    out.print(".");
                } else {
                    out.print("*");
                }
            }
            out.println();
        }
    }
    
}
