package year2017.round1b;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.util.Iterator;

public class B {
	
	public static void main(String [] args) throws IOException {
		try {
			solveFile("year2017r1b/B-example");
			solveFile("year2017r1b/B-small-attempt0");
			solveFile("year2017r1b/B-large");
		} catch (IOException e) {
			System.out.println(e);
		}
	}
	
	private static void solveFile(String fileName) throws IOException {
		Iterator<String> lines = Files.readAllLines(new File(fileName+".in").toPath()).iterator();
		PrintWriter output = new PrintWriter(fileName+".out");
		int numLines = Integer.parseInt(lines.next());
		for (int lineNum = 1; lineNum <= numLines; lineNum++) {
			String input = lines.next();
			output.println("Case #"+lineNum+": "+solve(input));
		}
		output.close();
		System.out.println("done");
	}
	
	private static void outln(String s) {
	//	System.out.println(s);		
	}
	
	private static int[] stable;
	private static int[] counts;
	
	private static String solve(String input) {
		outln("doing "+input);
		String[] line = input.split(" ");
		int N = Integer.parseInt(line[0]);
		counts = new int[7];
		for (int i = 1; i <= 6; i++) {
			counts[i] = Integer.parseInt(line[i]);
			outln("counts "+i+" = "+counts[i]);
		}
		stable = new int[N];
		for (int pos = 0; pos < N; pos++) {
			outln("pos "+pos);
			int bestColour = 0;
			int bestCount = 0;
			for (int col = 1; col <= 6; col++) {
				if ((pos == 0 || fits(col, stable[pos-1]))
					&& (pos < N-1 || pos == 0 || fits(col, stable[0]))
					&& counts[col] > 0) 
				{
					int neibs = neibs(col);
					if (pos > 0 && !fits(col, stable[0])) {
						neibs++;
					}
					if (neibs > bestCount) {
						bestColour = col;
						bestCount = neibs;
					}
				}
			}
			if (bestColour > 0) {
				outln("best  "+bestColour);
				toStable(bestColour, pos);
				continue;
			}
			return "IMPOSSIBLE";
		}
		StringBuffer buf = new StringBuffer();
		char[] colours = new char[7];
		colours[1] = 'R';
		colours[2] = 'O';
		colours[3] = 'Y';
		colours[4] = 'G';
		colours[5] = 'B';
		colours[6] = 'V'; 
		for (int pos = 0; pos < N; pos ++) {
			buf.append(colours[stable[pos]]);
		}
		return buf.toString();
	}
	
	private static int neibs(int col) {
		int colBefore = col == 1 ? 6 : col-1;
		int colAfter = col == 6 ? 1 : col+1;
		return counts[colBefore]+counts[col]+counts[colAfter];
	}
	
	private static void toStable(int colour, int pos) {
		counts[colour]--;
		stable[pos] = colour;
	}
	
	private static boolean fits(int i, int j) {
		int diff = Math.abs(i-j);
		return (diff > 1 && diff < 5);
	}
}
