package year2017.round1b;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Iterator;

public class A {
	
	public static void main(String [] args) throws IOException {
		try {
			solveFile("year2017r1b/A-example");
			solveFile("year2017r1b/A-small-attempt1");
			solveFile("year2017r1b/A-large");
		} catch (IOException e) {
			System.out.println(e);
		}
	}
	
	private static Iterator<String> lines;
	
	private static void solveFile(String fileName) throws IOException {
		lines = Files.readAllLines(new File(fileName+".in").toPath()).iterator();
		PrintWriter output = new PrintWriter(fileName+".out");
		int numLines = Integer.parseInt(lines.next());
		for (int lineNum = 1; lineNum <= numLines; lineNum++) {
			output.println("Case #"+lineNum+": "+solve());
		}
		output.close();
		System.out.println("done "+fileName);
	}
	
	private static String solve() {
		String[] line1 = lines.next().split(" ");
		double D = Double.parseDouble(line1[0]);
		int horseCount = Integer.parseInt(line1[1]);
		double latestHorse = 0;
		for (int i = 0; i < horseCount; i++) {
			String[] line = lines.next().split(" ");
			double K = Double.parseDouble(line[0]);
			double S = Double.parseDouble(line[1]);
			double time = (D - K) / S;
			if (time > latestHorse) {
				latestHorse = time;
			}
		}
		NumberFormat format = new DecimalFormat("#0.000000");
		return format.format(D / latestHorse);
	}
	
}
