package year2017.qualification;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.util.Iterator;

public class B {
	
	public static void main(String [] args) throws IOException {
		try {
			solveFile("year2017/B-example");
			solveFile("year2017/B-small-attempt0");
//			solveFile("year2017/B-large");
		} catch (IOException e) {
			System.out.println(e);
		}
	}
	
	private static void solveFile(String fileName) throws IOException {
		Iterator<String> lines = Files.readAllLines(new File(fileName+".in").toPath()).iterator();
		PrintWriter output = new PrintWriter(fileName+".out");
		int numLines = Integer.parseInt(lines.next());
		for (int lineNum = 1; lineNum <= numLines; lineNum++) {
			String input = lines.next();
			output.println("Case #"+lineNum+": "+solve(input));
		}
		output.close();
		System.out.println("done");
	}
	
	private static void outln(String s) {
		System.out.println(s);		
	}
	
	private static String solve(String input) {
		int len = input.length();
		outln("doing "+input+" len = "+len);
		byte[] digits = new byte[len];
		for (int i = 0; i < len; i++) {
			digits[i] = Byte.parseByte(""+input.charAt(i));
		}
		for (int i = len-1; i > 0; i--) {
			outln("i = "+i);
			if (digits[i] < digits[i-1]) {
				digits[i-1]--;
				for (int j = i; j < len; j++) {
					digits[j] = 9;
				}
			}
		}
		
		StringBuffer result = new StringBuffer();
		boolean leadingZeroes = true;
		for (int i = 0; i < len; i++) {
			if (digits[i] > 0) {
				leadingZeroes = false;
			}
			if (!leadingZeroes) {
				result.append(Byte.toString(digits[i]));
			}
		}
		return result.toString();
	}
}
