package year2017.qualification;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.util.Iterator;

public class A {
	
	public static void main(String [] args) throws IOException {
		try {
			solveFile("year2017/A-example");
			solveFile("year2017/A-small-attempt0");
		} catch (IOException e) {
			System.out.println(e);
		}
	}
	
	private static void solveFile(String fileName) throws IOException {
		Iterator<String> lines = Files.readAllLines(new File(fileName+".in").toPath()).iterator();
		PrintWriter output = new PrintWriter(fileName+".out");
		int numLines = Integer.parseInt(lines.next());
		for (int lineNum = 1; lineNum <= numLines; lineNum++) {
			String input = lines.next();
			output.println("Case #"+lineNum+": "+solve(input));
		}
		output.close();
		System.out.println("done");
	}
	
	private static boolean[] pattern;
	private static int width;
	
	private static String solve(String input) {
		String[] split = input.split(" ");
		int len = split[0].length();
		pattern = new boolean[len];
		for (int i = 0; i < len; i++) {
			pattern[i] = split[0].charAt(i) == '+';
		}
		width = Integer.parseInt(split[1]);
		int left = 0;
		int right = len - width;
		int flips = 0;
		while (true) {
			if (right < left) {
				break;
			}
			if (!pattern[left]) {
				flips++;
				flip(left);
			}
			if (right == left) {
				break;
			}
			if (!pattern[right+width-1]) {
				flips++;
				flip(right);
			}
			right--;
			left++;
		}
		boolean success = true;
		for (int i = 0; i < len; i++) {
			if (!pattern[i]) {
				success = false;
				break;
			}
		}
		if (success) {
			return ""+flips;
		} else {
			return "IMPOSSIBLE";
		}
	}
	
	private static void flip(int position) {
		for (int i = position; i < position+width; i++) {
			pattern[i] = !pattern[i];
		}
		
	}
}
