package year2017.qualification;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class C {
	
	public static void main(String [] args) throws IOException {
		try {
			solveFile("year2017/C-example");
			solveFile("year2017/C-small-1-attempt0");
			solveFile("year2017/C-small-2-attempt0");
			solveFile("year2017/C-large");
		} catch (IOException e) {
			System.out.println(e);
		}
	}
	
	private static void solveFile(String fileName) throws IOException {
		Iterator<String> lines = Files.readAllLines(new File(fileName+".in").toPath()).iterator();
		PrintWriter output = new PrintWriter(fileName+".out");
		int numLines = Integer.parseInt(lines.next());
		for (int lineNum = 1; lineNum <= numLines; lineNum++) {
			String input = lines.next();
			output.println("Case #"+lineNum+": "+solve(input));
		}
		output.close();
		outln("done "+fileName);
	}
	
	private static void outln(String s) {
		System.out.println(s);		
	}
	
	private static Map<Long, Long> map;
	
	private static String solve(String input) {
		String[] split = input.split(" ");
		long N = Long.parseLong(split[0]);
		long K = Long.parseLong(split[1]);
		long kLeft = K;
		outln("doing N "+N+" K "+K);
		map = new HashMap<Long, Long>();
		map.put(N, new Long(1));
		long space;
		while(true) {
			// find highest index
			space = findLargestSpace();
			long lsCount = map.get(space);
			if (kLeft <= lsCount) {
				if (space % 2 == 1) {
					long leftAndRight = (space-1) / 2;
					return ""+leftAndRight+" "+leftAndRight;
				} else {
					return ""+(space/2)+" "+((space/2)-1);
				}
			} 
			kLeft -= lsCount;
			map.remove(space);
			if (space % 2 == 1) {
				addToSpace((space - 1) / 2, lsCount * 2);
			} else {
				long rightSpace = space / 2;
				if (rightSpace > 0) {
					addToSpace(rightSpace, lsCount);
				}
				long leftSpace = (space/2)-1;
				if (leftSpace > 0) {
					addToSpace(leftSpace, lsCount);
				}
			}
		}
	}
	
	private static long findLargestSpace() {
		Iterator<Long> iterateKeys = map.keySet().iterator();
		long largestKey = 0;
		while (iterateKeys.hasNext()) {
			long keyToCheck = iterateKeys.next();
			if (keyToCheck > largestKey) {
				largestKey = keyToCheck;
			}
		}
		return largestKey;
	}
	
	private static void addToSpace(long space, long count) {
		Long existingObj = map.get(space);
		long existingNumeric = existingObj == null ? 0 : existingObj;
		map.put(space, count + existingNumeric);
	}
}
