/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package qualif;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

/**
 *
 * @author Albi
 */
public class C {

    private static String processCase(int caseNum, String line1, String line2) {
        System.out.println("CASE "+caseNum);
        String[] splitLine1 = line1.split(" ");
        BigInteger R = new BigInteger(splitLine1[0]);
        BigInteger k = new BigInteger(splitLine1[1]);
        int N = Integer.parseInt(splitLine1[2]);
        String[] splitLine2 = line2.split(" ");
        BigInteger[] g = new BigInteger[N];
        for (int i=0; i<N; i++) {
            g[i] = new BigInteger(splitLine2[i]);
        }

        BigInteger euros = new BigInteger("0");
        BigInteger runsLeft = new BigInteger(R.toByteArray());
        int pos = 0;
        int posThisCartStarted = 0;
        BigInteger spaceLeft = new BigInteger(k.toByteArray());
        while (true) {
            System.out.println("cycle : rl "+runsLeft+" pos "+posThisCartStarted+"-"+pos+" space "+spaceLeft+" group "+g[pos]+" got "+euros+"E$");
            if (spaceLeft.compareTo(g[pos]) == -1) { // it can't fit, we need another run!
                System.out.println("next run - kart full");
                posThisCartStarted = pos;
                runsLeft = runsLeft.subtract(BigInteger.ONE);
                if (runsLeft.equals(BigInteger.ZERO)) {
                    break;
                }
                spaceLeft = new BigInteger(k.toByteArray());
            }
            spaceLeft = spaceLeft.subtract(g[pos]);
            euros = euros.add(g[pos]);
            pos++;
            if (pos == N) {
                pos = 0;
            }
            if (posThisCartStarted == pos) { // full cycle, out of queue
                System.out.println("next run - out of queue");
                posThisCartStarted = pos;
                runsLeft = runsLeft.subtract(BigInteger.ONE);
                if (runsLeft.equals(BigInteger.ZERO)) {
                    break;
                }
                spaceLeft = new BigInteger(k.toByteArray());
            }
        }
        return "Case #"+caseNum+": "+euros;
    }

    private static void processFile(String fileName) throws FileNotFoundException, IOException {
        File inFile = new File(fileName+".in");
        File outFile = new File(fileName+".out");
        BufferedReader in = new BufferedReader(new FileReader(inFile));
        PrintWriter out = new PrintWriter(outFile);
        String Tline = in.readLine();
        int T = Integer.parseInt(Tline);
        for (int lineNum = 1; lineNum <= T; lineNum++) {
            out.println(processCase(lineNum, in.readLine(), in.readLine()));
        }
        out.close();
    }

    public static void main(String[] args) {
        String prefix = "C";
        try {
            processFile(prefix+"-test");
            processFile(prefix+"-small");
            processFile(prefix+"-large");
        } catch (FileNotFoundException e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
    }
}
