import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Set;
import java.util.TreeSet;


public class TheRepeater {
	
	public TheRepeater() {
		InputStream is = null;
		BufferedReader br = null;
		try {
			is = new FileInputStream("d:\\A-small-attempt0.in");
			br = new BufferedReader(new InputStreamReader(is));
			int cases = Integer.parseInt(br.readLine());
			int sols = 0;
			for (int i = 0; i < cases; i++) {
				int n = Integer.parseInt(br.readLine());
				String s1 = br.readLine();
				String s2 = br.readLine();
				String small = s1.length() < s2.length() ? s1 : s2;
				String big = s1.length() >= s2.length() ? s1 : s2;
				int v = new RepeaterSolver(small, big).solve();
				if (v == -1) {
					System.out.println("Case #" + (i + 1) + ": Fegla Won");
				} else {
					System.out.println("Case #" + (i + 1) + ": " + v);
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			if (br != null) {
				try {
					br.close();
				} catch (Exception e) {
					//pass
				}
			}
		}
	}
	
	public static void main(String[] args) {
		TheRepeater r = new TheRepeater();
	}
	
}

class RepeaterSolver {
	String big, small;
	
	public RepeaterSolver(String small, String big) {
		this.big = big;
		this.small = small;
	}
	
	private boolean sameChars(String s1, String s2) {
		Set<Character> set1 = new TreeSet<>();
		Set<Character> set2 = new TreeSet<>();
		for (int i = 0; i < s1.length(); i++) set1.add(s1.charAt(i));
		for (int j = 0; j < s2.length(); j++) set2.add(s2.charAt(j));
		return set1.equals(set2);
	}
	
	public int solve() {
		if (small.equals(big)) {
			return 0;
		}
		
		if (!sameChars(this.small, this.big)) {
			return -1;
		}
		
		int moves = 0;
		int i = 0, j = 0;
		
		do {
			
			char bigC = big.charAt(i);
			char smallC = small.charAt(j);
			
			if (bigC != smallC) {
				return -1;
			}
			int op1 = 0, op2 = 0;
			while (i < big.length() && bigC == big.charAt(i)) {
				i++; op1++;
			}
			while (j < small.length() && smallC == small.charAt(j)) {
				j++; op2++;
			}
			moves += Math.abs(op1 - op2);
		} while (i != big.length() && j != small.length());
		
		if (i != big.length()) {
			if (big.charAt(i) != small.charAt(j - 1)) {
				return -1;
			}
		}
		if (j != small.length()) {
			if (small.charAt(j) != big.charAt(i - 1)) {
				return -1;
			}
		}
		
		return moves;
		
	}
	
}
