import java.io.*;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Formatter;
import java.util.List;

public class DPCookieClicker {

    public String solve(int caseNumber, String input) { //C F X
        String[] values = input.split(" ");
        double C = Double.parseDouble(values[0]);
        double F = Double.parseDouble(values[1]);
        double X = Double.parseDouble(values[2]);
        double p = 2.0;
        double foo = dp(C, F, X, p);
        String v = new Formatter().format("Case #%d: %.7f", caseNumber, foo).toString();
        System.out.printf(v + "\n");
        return v;
    }

    public double dp(double C, double F, double X, double p) {
        List<Double> dp_x = new ArrayList<Double>();
        List<Double> dp_c = new ArrayList<Double>();

        for (int i = 0; i < X; i++) {
            double currentFactor = p + i * F;
            dp_x.add(X / currentFactor);
            if (i == 0) {
                dp_c.add(C / currentFactor);
            } else {
                dp_c.add(C / currentFactor + dp_c.get(i - 1));
            }
        }
        double sol = dp_x.get(0);
        if (dp_x.size() == 1) {
            return dp_x.get(0);
        }
        for (int i = 0; i < dp_x.size() - 1; i++) {
            double v = dp_c.get(i) + dp_x.get(i + 1);
            if (sol > v) {
                sol = v;
            }
        }
        return sol;
    }

    public static void main(String[] args) throws Exception {
        InputStream is = new FileInputStream("/tmp/input.dat");
        PrintWriter wr = new PrintWriter(new File("/tmp/output.dat"));
        DPCookieClicker cc = new DPCookieClicker();
        BufferedReader br = new BufferedReader(new InputStreamReader(is));
        int n = Integer.parseInt(br.readLine());
        for (int i = 1; i <= n; i++) {
            String line = br.readLine();
            String s = cc.solve(i, line);
            wr.println(s);
        }
//        cc.solve(1, "20.0 1.0 6.0");
//        cc.solve(2, "30.0 1.0 2.0");
        wr.close();
        br.close();
        is.close();
    }

}
