package ro.makshe.gcj;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

public class MagicTrick {

    private class Problem {
        int[][] inputData1, inputData2;
        int answer1, answer2;

        public Problem(List<String> lines) {
            answer1 = Integer.parseInt(lines.get(0));
            inputData1 = getData(lines, 1);
            answer2 = Integer.parseInt(lines.get(5));
            inputData2 = getData(lines, 6);

        }

        private int[][] getData(List<String> lines, int start) {
            int[][] d = new int[4][4];
            for (int i = 0; i < 4; i++) {
                String[] line = lines.get(start + i).split(" ");
                int j = 0;
                for (String n : line) {
                    d[i][j++] = Integer.parseInt(n);
                }
            }
            return d;
        }

        public void solve(int caseNumber) {
            int[] in1 = inputData1[answer1 - 1];
            int[] in2 = inputData2[answer2 - 1];
            int solution = -1;
            boolean sol = false;
            for (int i = 0; i < in1.length; i++) {
                for (int j = 0; j < in2.length; j++) {
                    if (in1[i] == in2[j]) {
                        if (!sol) {
                            solution = in1[i];
                            sol = true;
                        } else {
                            System.out.println("Case #" + caseNumber + ": Bad magician!");
                            return;
                        }
                    }
                }
            }
            if (!sol) {
                System.out.println("Case #" + caseNumber + ": Volunteer cheated!");
            } else {
                System.out.println("Case #" + caseNumber + ": " + solution);
            }
        }
    }

    public List<Problem> parseInput(InputStream inputStream) {
        List<Problem> problems = new ArrayList<Problem>();
        BufferedReader br = null;
        try {
            br = new BufferedReader(new InputStreamReader(inputStream));
            int n = Integer.parseInt(br.readLine());
            int i = 0;
            while (i < n) {
                List<String> lines = new ArrayList<String>();
                for (int j = 0; j < 10; j++) {
                    lines.add(br.readLine());
                }
                Problem p = new Problem(lines);
                problems.add(p);
                i++;
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (br != null) {
                try {
                    br.close();
                } catch (IOException e) {
                    //ignore
                }
            }
        }
        return problems;
    }


    public static void main(String[] args) throws IOException {
        MagicTrick mt = new MagicTrick();
        InputStream is = new FileInputStream("/home/marius/magictrick.in");
        List<Problem> problems = mt.parseInput(is);
        for (int i = 0; i < problems.size(); i++) {
            problems.get(i).solve(i + 1);
        }
        is.close();
    }

}
