import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Aldo Culquicondor
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        private static String[] numbers = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
        List<Integer>[] nL;
        List<Integer>[] nQ;
        private int[] qty;
        private int[] sol;
        private boolean found = false;
        private int q;

        public TaskA() {
            nL = new List[10];
            nQ = new List[10];
            for (int i = 0; i < 10; ++i) {
                int[] letters = new int[26];
                for (int j = 0; j < numbers[i].length(); ++j)
                    letters[(int) numbers[i].charAt(j) - (int) 'A'] += 1;
                nL[i] = new ArrayList<>();
                nQ[i] = new ArrayList<>();
                for (int j = 0; j < 26; ++j)
                    if (letters[j] > 0) {
                        nL[i].add(j);
                        nQ[i].add(letters[j]);
                    }
            }
        }

        private void bt(int d) {
            if (d == 10) {
                if (q == 0)
                    found = true;
                return;
            }
            if (found)
                return;
            bt(d + 1);
            boolean can = true;
            for (int i = 0; can && i < nL[d].size(); ++i)
                if (qty[nL[d].get(i)] < nQ[d].get(i))
                    can = false;
            if (!can)
                return;
            for (int i = 0; i < nL[d].size(); ++i) {
                qty[nL[d].get(i)] -= nQ[d].get(i);
                q -= nQ[d].get(i);
            }
            sol[d]++;
            bt(d);
            if (found)
                return;
            sol[d]--;
            for (int i = 0; i < nL[d].size(); ++i) {
                qty[nL[d].get(i)] += nQ[d].get(i);
                q += nQ[d].get(i);
            }
        }

        private String solve(String s) {
            qty = new int[26];
            sol = new int[10];
            for (int i = 0; i < s.length(); ++i) {
                ++qty[(int) s.charAt(i) - (int) 'A'];
                ++q;
            }
            found = false;
            bt(0);
            StringBuilder ans = new StringBuilder();
            for (int i = 0; i < 10; ++i)
                for (int j = 0; j < sol[i]; ++j)
                    ans.append(i);
            return ans.toString();
        }

        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.printf("Case #%d: %s\n", testNumber, solve(in.next()));
        }

    }

    static class InputReader {
        private BufferedReader reader;
        private StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 65536);
            tokenizer = null;
        }

        public String next() {
            String line;
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    line = reader.readLine();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
                if (line == null)
                    throw new UnknownError();
                tokenizer = new StringTokenizer(line);
            }
            return tokenizer.nextToken();
        }

    }
}

