import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Aldo Culquicondor
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "C-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("c.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskC solver = new TaskC();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskC {
        private static final int[] div = {3, 5, 7, 11, 13, 17, 19, 23};

        int verify(long rep, int base) {
            for (int d : div) {
                long mask = rep;
                int m = 0;
                while (mask > 0) {
                    m = (m * base + ((mask & 1) == 1 ? 1 : 0)) % d;
                    mask >>= 1;
                }
                if (m == 0)
                    return d;
            }
            return 0;
        }

        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.printf("Case #%d:\n", testNumber);
            int length = in.nextInt(), quantity = in.nextInt();
            int[] d = new int[11];
            for (long mask = 0; quantity > 0 && mask < (1L << length - 2); ++mask) {
                long mmask = 1 | (mask << 1) | (1L << length - 1);
                boolean valid = true;
                for (int b = 2; valid && b <= 10; ++b) {
                    d[b] = verify(mmask, b);
                    valid = d[b] > 0;
                }

                if (valid) {
                    out.print(new StringBuilder(Long.toBinaryString(mmask)).reverse().toString());
                    for (int b = 2; b <= 10; ++b) {
                        out.print(' ');
                        out.print(d[b]);
                    }
                    out.println();
                    --quantity;
                }
            }
        }

    }

    static class InputReader {
        private BufferedReader reader;
        private StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 65536);
            tokenizer = null;
        }

        public String next() {
            String line;
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    line = reader.readLine();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
                if (line == null)
                    throw new UnknownError();
                tokenizer = new StringTokenizer(line);
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}

