import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;
import java.util.concurrent.Callable;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;


public class Google3FS {

	//brute force approach
	/*
	public static long numberofFS2(long a, long b) {
		long n = 0;
		for (long i =a; i <= b; i++) {
			if (isPalindrome(i)) {
				long root = (long) Math.sqrt(i);
				if (root* root == i) {
				if (isPalindrome((long) root)) {
					n++;
				}
				}
			}
		}
		return n;
	}
	*/
	final static TreeSet<Long> set = new TreeSet<Long>();

	static {
		for (long i = 0; i < 100000000L; i++) {
			if (isPalindrome(i)) {
				set.add(i);
			}
		}
	}
	
	public static long numberofFS(long a, long b) {
		long result = 0;
		long a1 = (long) Math.floor(Math.sqrt(a));
		long b1 = (long) Math.ceil(Math.sqrt(b));
		Set<Long> s = new TreeSet<Long>(set.subSet(a1, true, b1, true));
		for (long i : s) {
			long number_s = i * i;
			if (number_s <= b) {
				if (number_s >= a && isPalindrome(number_s)) {
					result++;
				} else {
				}
			} else {
				break;
			}
		}
		return result;
	}

	public static boolean isPalindrome(final long a) {
		String s = Long.toString(a);
		for (int i = 0; i < s.length() >> 1; i++) {
			if (s.charAt(i) != s.charAt(s.length() - i - 1)) {
				return false;
			}
		}
		return true;
	}
	
	public static void assertThat(boolean a) {
		if (!a) {
			throw new RuntimeException("AssertError");
		}
	}

	/*
	public static void main(String[] args) {
		long l = System.currentTimeMillis();
		for (long i=0; i < 10000L; i++) {
			numberofFS(50000L, 9000000000000L);
		}
		System.out.println(System.currentTimeMillis() -l);
	}
	*/

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int t;
		t = Integer.parseInt(in.nextLine());
		ExecutorService executor = Executors.newFixedThreadPool(Runtime
				.getRuntime().availableProcessors());
		List<Future> futures = new ArrayList<Future>();
		for (int i = 0; i < t; i++) {
			String nm = in.nextLine();
			String[] nmSplit = nm.split(" ");
			final Long A = Long.parseLong(nmSplit[0]);
			final Long B = Long.parseLong(nmSplit[1]);
			futures.add(executor.submit(new Callable<Long>() {

				@Override
				public Long call() throws Exception {
					return numberofFS(A,B);
				}

			}));
		}
		int i = 1;
		for (Future future : futures) {
			try {
				System.out.println("Case #" + (i) + ": " + future.get());
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ExecutionException e) {
				e.printStackTrace();
			}
			i++;
		}
		executor.shutdown();
	}
}
