package aldo;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class Main {

    public static class StdIO {
        BufferedReader br;
        BufferedWriter bw;

        public void start() {
            br = new BufferedReader(new InputStreamReader(System.in));
            bw = new BufferedWriter(new OutputStreamWriter(System.out));
        }
        public void close() {
            try {
                br.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                bw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

        public List<Integer> readIntList() {
            List<Integer> result = null;
            try {
                String res = br.readLine();
                String[] sp = res.split(" ", -1);
                result = new ArrayList<Integer>();
                for (String s : sp) {
                    result.add(Integer.valueOf(s));
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            return result;
        }

        public List<String> readStringList() {
            List<String> result = null;
            try {
                String res = br.readLine();
                String[] sp = res.split(" ", -1);
                result = new ArrayList<String>();
                for (String s : sp) {
                    result.add(s);
                }
            } catch (IOException e) {
                e.printStackTrace();
            }
            return result;
        }
        public void writeLine(String string) {
            try {
                bw.write(string+"\r\n");
                bw.flush();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static int p201501(int[] params) {
        int friends = 0;
        int standupP = 0;
        for (int i = 0; i < params.length; i++) {
            int n = params[i];
            if (i == 0) {
                standupP += n;
            } else {
                if (standupP < i) {
                    int newFriends = i - standupP;
                    friends += newFriends;
                    standupP += newFriends;
                }
                standupP += n;
            }
        }
        return friends;
    }

    public static void p201501Test() {
        System.out.println(p201501(new int[]{1,1,1,1,1}));
        System.out.println(p201501(new int[]{0,9}));
        System.out.println(p201501(new int[]{1,1,0,0,1,1}));
        System.out.println(p201501(new int[]{1}));
    }

    public static void p201501IO() {
        StdIO stdIO = new StdIO();
        stdIO.start();
        int N = stdIO.readIntList().get(0);
        for (int n=0; n<N; n++) {
            String aux  = stdIO.readStringList().get(1);
            int[] param=new int[aux.length()];
            for (int i=0; i<aux.length(); i++) {
                param[i]=Integer.valueOf("" + aux.charAt(i));
            }
            stdIO.writeLine("Case #" + (n + 1) + ": " + p201501(param));
        }
        stdIO.close();
    }

    public static int p201502(List<Integer> params) {
        Collections.sort(params);
        int max = params.get(params.size() - 1);
        if (max == 0) {
            return 0;
        }
        if (max == 1) {
            return 1;
        }
        if (max == 2) {
            return 2;
        }
        if (max/2 > params.size()) {
            params.set(params.size() -1, max/2);
            params.add(max - max/2);
        } else {
            List<Integer> aux = new ArrayList<Integer>();
            for (int i=0; i< params.size(); i++) {
                int val = params.get(i) - 1;
                if (val > 0) {
                    aux.add(val);
                }
            }
            params = aux;
        }
        return 1 + p201502(params);
    }

    public static void p201502Test() {
        System.out.println(p201502(new ArrayList(Arrays.asList(new Integer[]{3}))));
        System.out.println(p201502(new ArrayList(Arrays.asList(new Integer[]{1,2,1,2}))));
        System.out.println(p201502(new ArrayList(Arrays.asList(new Integer[]{4}))));
        System.out.println(p201502(new ArrayList(Arrays.asList(new Integer[]{1,1,1,7}))));
        System.out.println(p201502(new ArrayList(Arrays.asList(new Integer[]{1024}))));
        List<Integer> pTest = new ArrayList<Integer>();
        for (int i=0; i<2000; i++) {
            pTest.add(i);
        }
        System.out.println(p201502(pTest));
    }

    public static void p201502IO() {
        StdIO stdIO = new StdIO();
        stdIO.start();
        int N = stdIO.readIntList().get(0);
        for (int n=0; n<N; n++) {
            stdIO.readIntList();
            stdIO.writeLine("Case #" + (n + 1) + ": " + p201502(stdIO.readIntList()));
        }
        stdIO.close();
    }

    public static void main(String[] args) {
        p201501IO();
    }

}
