import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * Grupo Fortaleza
 * Facebook
 * .GJ1CA
 * Created by: agutierrez
 * May 11, 2014 - 5:28:09 AM
 * 
 */

/**
 * @author agutierrez
 *
 */
public class GJ1CA
{

//  static Map<String, Long> cache = new ConcurrentHashMap<>();
  static Map<String, Long> cache = new LinkedHashMap<>();
  
  static {
    cache.put("1/1", 0L);
    long j = 2;
    for (int i=0; i < 42; i++) {
      cache.put("1/"+j, (long) i+1);
      j = j*2;
    }
  }
  
  public static Long nGeneration1(long a, long b, long gen)
  {
    do
    {
      if (a > b) {
        return null;
      }
      long gcm =  gcm(a,b);
      a = a /gcm;
      b = b /gcm;
      if (a == 1 && b == 1)
      {
        return gen;
      } 
      if (cache.containsKey(a+"/"+b)) {
        return cache.get(a+"/"+b) + gen;
      }
      a = a * 2;
      gen++;
      if (a > b) {
        a = a -b;
        Long otherParentG = nGeneration1(a, b, gen);
        if (otherParentG == null) {
          return null;
        }
        return gen;
      }
    } while (gen < 42);
    return null;
  }
  
  
  /** @return the greatest common denominator */
  public static long gcm(long a, long b) {
      return b == 0 ? a : gcm(b, a % b); // Not bad for one line of code :)
  }

  public static String asFraction(long a, long b) {
      long gcm = gcm(a, b);
      return (a / gcm) + "/" + (b / gcm);
  }

//  public static void main(String[] args) {
//          System.out.println(cache);
// //     System.out.println(nGeneration1(1L,1L));
//      System.out.println(nGeneration1(1L,2L, 0L));
//      System.out.println(nGeneration1(3L,4L, 0L));
//      System.out.println(nGeneration1(1L,4L, 0L));
//      System.out.println(nGeneration1(2L,23L, 0L));
//      System.out.println(nGeneration1(123L,31488L, 0L));
//
//      System.out.println(nGeneration1(123456789102L,2343456789102L, 0L));
//      
////
////      System.out.println(asFraction(500, 1000)); //  "1/2"
////      System.out.println(asFraction(17, 3));     //  "17/3"
////      System.out.println(asFraction(462, 1071)); //  "22/51"
//  }

  public static void main(String args[]) throws Exception
  {
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    String line = br.readLine();
    int T = Integer.parseInt(line);
    for (int t = 0; t < T; t++)
    {
      String A_B = br.readLine();
      String[] A_Bsplit = A_B.split("/");
      long a = Long.valueOf(A_Bsplit[0]);
      long b = Long.valueOf(A_Bsplit[1]);
      Long result = nGeneration1(a, b, 0L);
      if (result == null || result > 40) {
      System.out.println("Case #" + (t + 1) + ": impossible");
      } else {
      System.out.println("Case #" + (t + 1) + ": "+result);
      }
    }
  }
  
  
}
