import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.NavigableMap;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;


public class Google1TTT {

	public static char evalRow(String row) {
		if (row.equals("XXXX")) {
			return 'X';
		} else if (row.equals("XXXT")) {
			return 'X';
		} else if (row.equals("XXTX")) {
			return 'X';
		} else if (row.equals("XTXX")) {
			return 'X';
		} else if (row.equals("TXXX")) {
			return 'X';
		} else if (row.equals("OOOO")) {
			return 'O';
		} else if (row.equals("OOOT")) {
			return 'O';
		} else if (row.equals("OOTO")) {
			return 'O';
		} else if (row.equals("TOOO")) {
			return 'O';
		}
		return ' ';
	}
	
	public static String problemaTTT(char[][] board, String[] rows) {

		String tablero = ""+ rows[0] + rows[1] + rows[2] + rows[3];
		
		for (int i=0; i < 4; i++) {
			String row = rows[i];
			char r = evalRow(row);
			if ('X' == (r)) {
				return "X won";
			} else if ('O' == r) {
				return "O won";
			}
		}

		for (int i=0; i < 4; i++) {
			String col = ""+ board[0][i] + board[1][i] + board[2][i] + board[3][i];
			char r = evalRow(col);
			if ('X' == (r)) {
				return "X won";
			} else if ('O' == r) {
				return "O won";
			}
		}
		
		String row = ""+ board[0][0] + board[1][1] + board[2][2] + board[3][3];
		char r = evalRow(row);
		if ('X' == (r)) {
			return "X won";
		} else if ('O' == r) {
			return "O won";
		}

		row = ""+ board[0][3] + board[1][2] + board[2][1] + board[3][0];
		r = evalRow(row);
		if ("X".equals(r)) {
			return "X won";
		} else if ('O' == r) {
			return "O won";
		}
		
	    if (tablero.contains(".")) {
	    	return "Game has not completed";
	    } else {
	    	return "Draw";
	    }
		
	}
	
	

	
	public static void main(String[] args) {		
		Scanner in = new Scanner(System.in);
		int t;
		t = Integer.parseInt(in.nextLine());
		ExecutorService executor = Executors.newFixedThreadPool(Runtime.getRuntime().availableProcessors());
		List<Future> futures = new ArrayList<Future>();
		for(int i=0;i<t;i++) {
			final String row1 = in.nextLine();
			char[] row1c = new char[] {row1.charAt(0), row1.charAt(1), row1.charAt(2), row1.charAt(3)};
			final String row2 = in.nextLine();
			char[] row2c = new char[] {row2.charAt(0), row2.charAt(1), row2.charAt(2), row2.charAt(3)};
			final String row3 = in.nextLine();
			char[] row3c = new char[] {row3.charAt(0), row3.charAt(1), row3.charAt(2), row3.charAt(3)};
			final String row4 = in.nextLine();
			char[] row4c = new char[] {row4.charAt(0), row4.charAt(1), row4.charAt(2), row4.charAt(3)};

			
			final char[][] tablero = new char[4][];
			tablero[0] = row1c;
			tablero[1] = row2c;
			tablero[2] = row3c;
			tablero[3] = row4c;
			if (i<t -1) {
				in.nextLine();
			}

			


			futures.add(executor.submit(new Callable<String>() {

				@Override
				public String call() throws Exception {
					String result = problemaTTT(tablero, new String[] {row1, row2, row3, row4});
					return result;
				}
				
			}));
		}
		int i = 1;
		for (Future future: futures) {
			try {
				System.out.println("Case #" + (i) + ": " + future.get());
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (ExecutionException e) {
				e.printStackTrace();
			}
			i++;
		}
		executor.shutdown();
	}
}
