import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Grupo Fortaleza
 * Facebook
 * .GJMM
 * Created by: agutierrez
 * Apr 12, 2014 - 3:20:55 PM
 * 
 */

/**
 * @author agutierrez
 * 
 */
public class GJMM
{

  public static boolean doIt(char[][] board, int nRows, int nColumns,
      int baseRow, int baseColumn, int nMinas)
  {
    boolean result = false;
    int dimensionRows = nRows - baseRow;
    int dimesionColumns = nColumns - baseColumn;
    int dimensionGreater = Math.max(dimensionRows, dimesionColumns);
    int dimesionShorter = Math.min(dimensionRows, dimesionColumns);
    if (dimensionRows * dimesionColumns - 1== nMinas) {
      for (int i = 0; i < nRows; i++)
      {
        for (int j = 0; j < nColumns; j++) {
          if (j ==0 && i==0) {
            board[i][j] = 'c';            
          } else {
            board[i][j] = '*';
          }
        }
      }
      return true;
    }
    if (dimensionGreater <= 2 && nMinas >= 1)
    {
      result = false;
    }
//    else if (nMinas < dimesionShorter && dimensionGreater <= 4 && nMinas > (dimensionGreater - 2))
//    {
//      result = false;
//    }
//    else if (nMinas < dimesionShorter && nMinas > (dimensionGreater - 2) * (1 + ((dimesionShorter - 1) / 4)))
//    {
//      result = false;
//    }
    else if (nMinas == 0)
    {
      result = true;
    }
    else if (nMinas >= dimesionShorter)
    {
      if (dimensionRows < dimesionColumns)
      {
        for (int i = baseRow; i < nRows; i++)
        {
          board[i][baseColumn] = '*';
        }
        result = doIt(board, nRows, nColumns, baseRow, baseColumn + 1, nMinas - dimesionShorter);
      }
      else
      {
        for (int j = baseColumn; j < nColumns; j++)
        {
          board[baseRow][j] = '*';
        }
        result = doIt(board, nRows, nColumns, baseRow + 1, baseColumn, nMinas - dimesionShorter);
      }
    }
    else
    {

      int nMinasToPlace = nMinas;
      if (dimensionRows < dimesionColumns)
      {
        for (int i = baseRow; i < nRows - 2 && nMinasToPlace > 0; i ++)
        {
          for (int j = baseColumn; j < nColumns - 2 && nMinasToPlace > 0; j++)
          {
            board[i][j] = '*';
            nMinasToPlace--;
          }
        }
      }
      else
      {
        for (int j = baseColumn; j < nColumns -2 && nMinasToPlace > 0; j++)
        {
          for (int i = baseRow; i < nRows - 2 && nMinasToPlace > 0; i++)
          {
            board[i][j] = '*';
            nMinasToPlace--;
          }
        }
      }
      if (nMinasToPlace == 0)
      {
        result = true;
      }
    }

    boolean settedClick = false;

    if (!result)
    {
      return result;
    }
    for (int i = 0; i < nRows; i++)
    {
      for (int j = 0; j < nColumns; j++)
      {
        if ('*' == board[i][j])
        {

        }
        else
        {
          int nCerca = 0;
          for (int i2 = i - 1; i2 < i + 1; i2++)
          {
            for (int j2 = j - 1; j2 < j + 1; j2++)
            {
              if (i2 >= 0 && j2 >= 0 && i2 < nRows && j2 < nColumns && !(i2 == i && j2 == j))
              {
                if ('*' == board[i2][j2])
                {
                  nCerca++;
                }
              }
            }
          }
          if (nCerca == 0)
          {
            if (settedClick)
            {
              // board[i][j] = (char) ('0' + (char) nCerca);
            }
            else
            {
              board[i][j] = 'c';
              settedClick = true;
            }
          }
        }
      }
    }
    return settedClick;
  }

  public static char[][] buildBoard(int rows, int cols)
  {
    char[][] result = new char[rows][];
    for (int i2 = 0; i2 < rows; i2++)
    {
      result[i2] = new char[cols];
      for (int j2 = 0; j2 < cols; j2++)
      {
        result[i2][j2] = '.';
      }
    }
    return result;
  }

  public static void printBoard(char[][] board)
  {
    for (int i2 = 0; i2 < board.length; i2++)
    {
      for (int j2 = 0; j2 < board[i2].length; j2++)
      {
        System.out.print(board[i2][j2]);
      }
      System.out.println();
    }
  }

//   public static void main(String[] args)
//   {
//   int rows = 4;
//   int cols = 4;
//   for (int i=0; i<rows*cols+2; i++) {
//   final char[][] board = buildBoard(rows, cols);
//   System.out.println(i);
//   boolean result = doIt(board, rows, cols, 0, 0, i);
//   System.out.println(result);
//   printBoard(board);
//   }
//   }

  public static void main(String args[]) throws Exception
  {
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    String line = br.readLine();
    int T = Integer.parseInt(line);
    for (int t = 0; t < T; t++)
    {
      int[] input = getIntArray(br.readLine());
      int rows = input[0];
      int cols = input[1];
      final char[][] board = buildBoard(rows, cols);
      boolean result = doIt(board, rows, cols, 0, 0, input[2]);
      System.out.println("Case #" + (t + 1)+":");
      if (result)
      {
        printBoard(board);
      }
      else
      {
        System.out.println("Impossible");
      }
    }
  }

  /**
   * @param readLine
   * @return
   */
  private static int[] getIntArray(String readLine)
  {
    String[] stringParts = readLine.split(" ");
    int[] res = new int[stringParts.length];
    int i = 0;
    for (String s : stringParts)
    {
      res[i] = Integer.valueOf(s);
      i++;
    }
    return res;
  }

}
