import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.math.BigInteger;
import java.util.*;

/**
 * Created by agutierrez on 4/9/16.
 */
public class Main {


    //combinatoria
    public static List<List<Integer>> pickNfromM3(int N, int M) {
        List<List<Integer>> result = new ArrayList<>();
        final double pow = Math.pow(2, M);
        for (int i = 0; i < pow; i++) {
            if (Integer.bitCount(i) == N) {
                String s = Integer.toBinaryString(i);
                List<Integer> res = new ArrayList<>();
                for (int j=0; j<s.length(); j++) {
                    if (s.charAt(j) == '1') {
                        res.add(s.length()-j-1);
                    }
                }
                result.add(res);
            }
        }
        return result;
    }



    //permutaciones
    public static List<List<Integer>> pickNfromM2(int N, int M, List<Integer> skipList) {
        List<List<Integer>> result = new ArrayList<>();
        for (int i = 0; i < M; i++) {
            if (!skipList.contains(i)) {
                if (N == 1) {
                    final ArrayList<Integer> e = new ArrayList<>();
                    e.add(i);
                    result.add(e);
                } else {
                    List<Integer> skipList2 = new ArrayList<>(skipList);
                    skipList2.add(i);
                    List<List<Integer>> aux = pickNfromM2(N - 1, M, skipList2);
                    for (List<Integer> l : aux) {
                        l.add(0, i);
                    }
                    result.addAll(aux);
                }
            }
        }
        return result;
    }


    public static List<Integer> rankAndFile(int N, List<List<Integer>> listalista) {
        listalista.sort(new Comparator<List<Integer>>() {
            @Override
            public int compare(List<Integer> o1, List<Integer> o2) {
                if ((int) o1.get(0) != (int) o2.get(0)) {
                    return o1.get(0) - o2.get(0);
                } else  {
                    return 0;
                }
            }
        });
        List<Integer> indexes = new ArrayList<>();
        for (int i=0; i<N; i++) {
            indexes.add(i);
        }
        for (List<Integer> list: pickNfromM3(N, N*2 -1)) {
            Collections.sort(list);
            List<Integer> columns = new ArrayList<>(list);
            indexes.removeAll(columns);
            Integer[][] matrix  = new Integer[N][];
            for (int n=0; n<N; n++) {
                matrix[n] = listalista.get(list.get(n)).toArray(new Integer[]{});
            }
            for (int j=0; j<N; j++) {
                List<Integer> vector = new ArrayList<>();
                for (int i=0; i<N; i++) {
                    vector.add(matrix[i][j]);
                }
                boolean found = false;
                for (int i=0; i<indexes.size(); i++) {
                    List<Integer> vector2 = listalista.get(indexes.get(i));
                    if (equals(vector, vector2)) {
                        found = true;
                    }
                }
                if (!found) {
                    return vector;
                }
            }
        }
        throw new RuntimeException("NOT FOUND");
    }

    private static boolean equals(List<Integer> vector, List<Integer> vector2) {
        for (int i=0; i< vector.size(); i++) {
            if ((int)vector.get(i) != (int)vector2.get(i)) {
                return false;
            }
        }
        return true;
    }

    public static String lastWord(String s) {
        String res = "";
        for (int i=0; i < s.length(); i++) {
            char chara = s.charAt(i);
            if (i==0) {
                res += chara;
            } else {
                if (chara >= res.charAt(0)) {
                    res = chara + res;
                } else {
                    res += chara;
                }
            }
        }
        return res;
    }

    public static void testLasWord(){
        System.out.println(lastWord("CAB"));
        System.out.println(lastWord("JAM"));
        System.out.println(lastWord("CODE"));
        System.out.println(lastWord("ABAAB"));
        System.out.println(lastWord("CABCBBABC"));
        System.out.println(lastWord("ABCABCABC"));
        System.out.println(lastWord("ZXCASDQWE"));
    }


    public static Integer countingSheep(int N) {
        boolean n0 = false;
        boolean n1 = false;
        boolean n2 = false;
        boolean n3 = false;
        boolean n4 = false;
        boolean n5 = false;
        boolean n6 = false;
        boolean n7 = false;
        boolean n8 = false;
        boolean n9 = false;
        int i =1;
        do {
            int N2 = i * N;
            String sn2 = ""+N2;
            if ((!n0) && sn2.contains("0")) {
                n0 = true;
            }
            if ((!n1) && sn2.contains("1")) {
                n1 = true;
            }
            if ((!n2) && sn2.contains("2")) {
                n2 = true;
            }
            if ((!n3) && sn2.contains("3")) {
                n3 = true;
            }
            if ((!n4) && sn2.contains("4")) {
                n4 = true;
            }
            if ((!n5) && sn2.contains("5")) {
                n5 = true;
            }
            if ((!n6) && sn2.contains("6")) {
                n6 = true;
            }
            if ((!n7) && sn2.contains("7")) {
                n7 = true;
            }
            if ((!n8) && sn2.contains("8")) {
                n8 = true;
            }
            if ((!n9) && sn2.contains("9")) {
                n9 = true;
            }
            if (n0 && n1 && n2 && n3 && n4 && n5 && n6 && n7 && n8 && n9) {
                return N2;
            }
            i++;

        } while( i<100);
        return null;
    }

    public static List<String> coinJam(int N, int JMAX) {
        List result = new ArrayList();
        int Nm2 = N -2 ;
        for (int i=0; i<Math.pow(2,Nm2); i++) {
            try {
                final String s = "1" + fill(Integer.toBinaryString(i), Nm2) + "1";
                List<BigInteger> res = isNotPrimeInAllBases(s);
                final String res2 = toSpaceArray(res);
                result.add(s+ " "+res2);
                //System.out.println("---"+s+ " "+res2);
                if (result.size() == JMAX) {
                    return result;
                }
            } catch (Exception ex) {
                if (!ex.getMessage().contains("has not divisors")) {
                    System.out.println(ex.getMessage());
                }
            }
        }
        return result;
    }

    private static String toSpaceArray(List res) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < res.size(); i++) {
            sb.append(res.get(i));
            if (i < res.size() - 1) {
                sb.append(" ");
            }
        }
        return sb.toString();
    }

    private static List<BigInteger> isNotPrimeInAllBases(String s) {
        List<BigInteger> result = new ArrayList<BigInteger>();
        for (int b =2; b <= 10; b++) {
            BigInteger n = new BigInteger(s,b);
            BigInteger divisor = isNotPrime(n);
            result.add(divisor);
            if (divisor == null) {
                throw new RuntimeException("String "+s+" in base "+b+" n"+n+" has not divisors");
            }
        }
        return result;
    }

    private static BigInteger isNotPrime(BigInteger n) {
        //check if n is a multiple of 2
        if (n.divideAndRemainder(BigInteger.valueOf(2L))[1].equals(BigInteger.ZERO)) return BigInteger.valueOf(2L);
//        //if not, then just check the odds
//        for(long i=3;i*i<=n;i+=2) {
//            if(n%i==0)
//                return i;
//        }
        BigInteger i = BigInteger.valueOf(3L);
        do {
            if (n.divideAndRemainder(i)[1].equals(BigInteger.ZERO)) {
                return  i;
            }
            i = i.add(BigInteger.valueOf(2L));
        //} while (i.pow(2).compareTo(n) == -1);
        } while (i.compareTo(BigInteger.valueOf(100L)) == -1);

        return null;
    }

    public static String fill(String a, int N) {
        if (a.length() < N) {
            StringBuilder res = new StringBuilder();
            for (int i=0; i < N-a.length(); i++) {
                res = res.append("0");
            }
            res.append(a);
            return res.toString();
        } else {
            return a;
        }
    }

    public static void main(String[] args) throws Exception {
        //System.out.println(pickNfromM2(10,10, new ArrayList<>()));

        //System.out.println(gettingTheDigits("OZONETOWER"));
        //System.out.println(gettingTheDigits("WEIGHFOXTOURIST"));
        //System.out.println(gettingTheDigits("OURNEONFOE"));
        //System.out.println(gettingTheDigits("ETHER"));
        //System.out.println(pickNfromM2(2,15, new ArrayList<>()));
//        System.out.println(pankakes("-"));
//        System.out.println(pankakes("-+"));
//        System.out.println(pankakes("+-"));
//        System.out.println(pankakes("+++"));
//        System.out.println(pankakes("--+-"));

        //System.out.println("Case #1:");
        //coinJamTest();

        //testLasWord();
        //generateInputFile();
        //testFractiles();

        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));
        int testCases = Integer.parseInt(br.readLine());
        for(int t=1;t<=testCases;t++){
            bw.write("Case #" + t +": "+gettingTheDigits(br.readLine())+"\n");
        }
        br.close();
        bw.close();
    }

    public static void generateInputFile() {
        Random r = new Random();
        for (int i = 0; i < 100; i++) {
            for (int j = 0; j < 100; j++) {
                System.out.print(r.nextBoolean() ? "-" : "+");
            }
            System.out.println();
        }
    }

    public static String getOutputPankakes2(String s) {
        int changes = 0;
        for (int i = 0; i < s.length(); i++) {
            if (i > 0) {
                if (s.charAt(i) != s.charAt(i - 1)) {
                    changes++;
                }
            }
        }
        if ((s.charAt(0) == '-') && s.charAt(s.length() - 1) == '+') {
            return "" + changes;
        } else if ((s.charAt(0) == '+') && s.charAt(s.length() - 1) == '-') {
            return "" + (changes + 1);
        } else if ((s.charAt(0) == '+') && s.charAt(s.length() - 1) == '+') {
            return "" + changes;
        } else if ((s.charAt(0) == '-') && s.charAt(s.length() - 1) == '-') {
            return "" + (changes + 1);
        }
        return "" + changes;
    }

    private static String getOutputPankakes(String s) {
        return ""+pankakes(s);
    }

    public static String getOutputCountingSheep(String input) {
        int n = Integer.parseInt(input);
        Integer res = countingSheep(n);
        return (res == null) ? "INSOMNIA" : res.toString();
    }

    public static void testCountingSheep() {
        assertEquals(countingSheep(0), null);
        assertEquals(countingSheep(1), 10);
        assertEquals(countingSheep(2), 90);
        assertEquals(countingSheep(11), 110);
        assertEquals(countingSheep(1692), 5076);
        assertEquals(countingSheep(1234567890), 1234567890);
        System.out.println("---------");
        for (int i=0; i <=10000000; i++) {
            final Integer countingSheep = countingSheep(i);
            if (countingSheep == null) {
                System.out.println(i+" "+ countingSheep);
            }
        }
    }

    public static void coinJamTest() {
        List<String> r = coinJam(32 ,500);
        for (String s : r) {
            System.out.println(s);
        }
    }

    ////////////// PANKAKES /////////////

    public static String split(String s, int n) {
        String s2 = s.substring(n);
        String s1 = s.substring(0, n);
        return reverse(s1) + s2;

    }

    private static String reverse(String s1) {
        String sbr = new StringBuilder(s1).reverse().toString();
        StringBuilder sb2 = new StringBuilder();
        for (int i = 0; i < sbr.length(); i++) {
            if (sbr.charAt(i) == '+') {
                sb2.append('-');
            } else {
                sb2.append('+');
            }
        }
        return sb2.toString();
    }

    public static boolean isSolved(String s) {
        return !s.contains("-");
    }

    public static Integer isAlmostSolved(String s) {
        if (!s.contains("+")) {
            return 1;
        }
        int changes = 0;
        for (int i = 0; i < s.length(); i++) {
            if (i > 0) {
                if (s.charAt(i) != s.charAt(i - 1)) {
                    changes++;
                }
            }
        }
        if (changes == 1) {
            if (s.charAt(0) == '-') {
                return 1;
            } else {
                return 2;
            }
        }
        return null;
    }

    public static int pankakes(String pankakes){
        int res1 =  pankakesResol(pankakes, 6);
        if (res1 == Integer.MAX_VALUE) {
            res1 =  pankakesResol(pankakes, 7);
            if (res1 == Integer.MAX_VALUE) {
                res1 =  pankakesResol(pankakes, 8);
                if (res1 == Integer.MAX_VALUE) {
                    res1 =  pankakesResol(pankakes, 9);
                }
            }
        }
        return res1;
    }

    public static int pankakesResol(String pankakes, int maxlevel) {
        boolean resolved = isSolved(pankakes);
        if (resolved) {
            return 0;
        }
        Integer almostSolved = isAlmostSolved(pankakes);
        if (almostSolved != null) {
            return  almostSolved;
        }
        int n = Integer.MAX_VALUE;
        if (maxlevel - 1 > 0) {
            for (int i = 1; i <= pankakes.length(); i++) {
                String pankakesAux = split(pankakes, i);
                if (pankakesAux.equals(pankakes)) {
                    continue;
                }
                resolved = isSolved(pankakesAux);
                if (resolved) {
                    return 1;
                }
                int n2;
                almostSolved = isAlmostSolved(pankakesAux);
                if (almostSolved != null) {
                    n2 = almostSolved;
                } else {
                    n2 = pankakesResol(pankakesAux, maxlevel - 1);
                }
                //resolved = isSolved(pankakesAux);
                if (n2 < n) {
                    if (n2 == 1) {
                        return 2;
                    } else {
                        n = n2 +1;
                    }
                }
            }
        }
        return n;
    }

    ///////////////
    //Fractiles

    public static void testFractiles() {
        List<String> fractiles = getFractiles(2);
        List<String> fractilesExpanded = expandFractiles(fractiles, 3);
        System.out.println(testPositions(fractilesExpanded));
//        for (String fe: fractilesExpanded) {
//            System.out.println(fe);
//        }
    }

    public static List<Integer> testPositions(List<String> expandedFractiles) {
        List<Integer> testPositions = new ArrayList<Integer>();
        int maxI = expandedFractiles.get(0).length();
        for (int i =0; i < maxI; i++) {
            boolean found  = true;
            for (int k=0; k < expandedFractiles.size(); k++) {
                if (expandedFractiles.get(k).charAt(i) == '0') {
                    found = false;
                    break;
                }
            }
            if (found) {
                testPositions.add(i+1);
            }
        }
        return testPositions;
    }

    public static List<String> getFractiles(int N) {
        List<String> result = new ArrayList<String>();
        for (int i=1; i<Math.pow(2,N); i++) {
            result.add(fill(Integer.toBinaryString(i), N));
        }
        return result;
    }

    public static List<String> expandFractiles(List<String> fractiles, int L) {
        List<String> resultExpanded = new ArrayList<String>();
        for (String fractile: fractiles){
            resultExpanded.add(expandFractile(fractile, L));
        }
        return resultExpanded;
    }

    public static String expandFractile(String fractile, int l) {
        if (l ==1)  return fractile;
        String res = fractile;
        for (int i=1; i < l; i++) {
            StringBuilder aux = new StringBuilder();
            for (int j=0; j < res.length(); j++) {
                if (res.charAt(j) == '1') {
                    for (int k=0; k< fractile.length(); k++) {
                        aux.append("1");
                    }
                } else {
                    aux.append(fractile);
                }
            }
            res = aux.toString();
        }
        return res;
    }


    /////////////
    //Round 1B
    //Getting the Digits

    public static String[] digits = new String[] {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};

    public static String gettingTheDigits(String s) {
        String res = gettingTheDigitsA(s);
        if (res.isEmpty()) {
            res = gettingTheDigitsB(s);
        }
        if (res.isEmpty()) {
            res = gettingTheDigitsC(s);
        }
        if (res.isEmpty()) {
            System.out.println("No se encontro respuesta para "+s);
        }
        return res;
    }

    public static String gettingTheDigitsA(String s) {
            List<Integer> result = new ArrayList<>();
            StringBuilder s2 = new StringBuilder(s);
            for (int i = 9; i >= 0; ) {
//            for (int i=0; i< digits.length;) {
                String digit = digits[i];
                boolean found = true;
                List<Integer> indexesToDelete = new ArrayList<>();
                StringBuilder s3 = new StringBuilder(s2);
                for (int j = 0; j < digit.length(); j++) {
                    char c = digit.charAt(j);
                    int index = s3.indexOf(c + "");
                    if (index == -1) {
                        found = false;
                        break;
                    } else {
                        indexesToDelete.add(index);
                        s3.deleteCharAt(index);
                    }
                }
                if (found) {
                    for (Integer index : indexesToDelete) {
                        s2.deleteCharAt(index);
                    }
                    result.add(i);
                } else {
                    i--;
                }
            }
            Collections.sort(result);
            StringBuilder finalResult = new StringBuilder();
            StringBuilder finalResultAux = new StringBuilder();
            for (int i = 0; i < result.size(); i++) {
                finalResult.append("" + result.get(i));
                finalResultAux.append("" + digits[result.get(i)]);
            }
            if (!sort(s).equals(sort(finalResultAux.toString()))) {
                //System.out.println();
                //System.out.println("Different Strings " + s + " " + finalResultAux.toString() + " " + sort(s) + " " + sort(finalResultAux.toString()));
                //System.out.println();
                return "";
            }
            return finalResult.toString();
    }

    public static String gettingTheDigitsB(String s) {
        List<Integer> result = new ArrayList<>();
        StringBuilder s2 = new StringBuilder(s);
//        for (int i = 9; i >= 0; ) {
            for (int i=0; i< digits.length;) {
            String digit = digits[i];
            boolean found = true;
            List<Integer> indexesToDelete = new ArrayList<>();
            StringBuilder s3 = new StringBuilder(s2);
            for (int j = 0; j < digit.length(); j++) {
                char c = digit.charAt(j);
                int index = s3.indexOf(c + "");
                if (index == -1) {
                    found = false;
                    break;
                } else {
                    indexesToDelete.add(index);
                    s3.deleteCharAt(index);
                }
            }
            if (found) {
                for (Integer index : indexesToDelete) {
                    s2.deleteCharAt(index);
                }
                result.add(i);
            } else {
                i++;
            }
        }
        Collections.sort(result);
        StringBuilder finalResult = new StringBuilder();
        StringBuilder finalResultAux = new StringBuilder();
        for (int i = 0; i < result.size(); i++) {
            finalResult.append("" + result.get(i));
            finalResultAux.append("" + digits[result.get(i)]);
        }
        if (!sort(s).equals(sort(finalResultAux.toString()))) {
            //System.out.println();
            //System.out.println("Different Strings " + s + " " + finalResultAux.toString() + " " + sort(s) + " " + sort(finalResultAux.toString()));
            //System.out.println();
            return "";
        }
        return finalResult.toString();
    }

    public static String gettingTheDigitsC(String s) {
        List<List<Integer>> indexesR =  pickNfromM2(10,10, new ArrayList<>());

        for (List<Integer> indexR : indexesR) {
            List<Integer> result = new ArrayList<>();
            StringBuilder s2 = new StringBuilder(s);
//        for (int i = 9; i >= 0; ) {
            for (int i = 0; i < digits.length; ) {
                String digit = digits[indexR.get(i)];
                boolean found = true;
                List<Integer> indexesToDelete = new ArrayList<>();
                StringBuilder s3 = new StringBuilder(s2);
                for (int j = 0; j < digit.length(); j++) {
                    char c = digit.charAt(j);
                    int index = s3.indexOf(c + "");
                    if (index == -1) {
                        found = false;
                        break;
                    } else {
                        indexesToDelete.add(index);
                        s3.deleteCharAt(index);
                    }
                }
                if (found) {
                    for (Integer index : indexesToDelete) {
                        s2.deleteCharAt(index);
                    }
                    result.add(indexR.get(i));
                } else {
                    i++;
                }
            }
            Collections.sort(result);
            StringBuilder finalResult = new StringBuilder();
            StringBuilder finalResultAux = new StringBuilder();
            for (int i = 0; i < result.size(); i++) {
                finalResult.append("" + result.get(i));
                finalResultAux.append("" + digits[result.get(i)]);
            }
            if (!sort(s).equals(sort(finalResultAux.toString()))) {
                //System.out.println();
                //System.out.println("Different Strings " + s + " " + finalResultAux.toString() + " " + sort(s) + " " + sort(finalResultAux.toString()));
                //System.out.println();
                //return "";
            } else {
                return finalResult.toString();
            }
        }
        return  "";
    }


    public static String sort(String aux) {
        char[] chars = aux.toCharArray();
        Arrays.sort(chars);
        String sorted = new String(chars);
        return sorted;
    }

    //////////////

    public static void assertEquals(Object a, Object b) {
        System.out.println(a);
        if (a == b) {
            return;
        }
        if (a == null || b == null || !a.equals(b)) {
            throw new RuntimeException("Comparation error "+ a +" "+b);
        }
    }
}