import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * Grupo Fortaleza
 * Facebook
 * .GJCCA
 * Created by: agutierrez
 * Apr 12, 2014 - 12:08:57 PM
 * 
 */

/**
 * @author agutierrez
 *         Problem B. Cookie Clicker Alpha
 */
public class GJCCA
{

  // E
  // C,E
  // C,C,E
  // C,C,C,E

  public double X;
  public double C;
  public double F;

  public static Double wait(double currentT, double currentF, double currentX,
      double targetX)
  {
    final double result = currentT + (targetX - currentX) / (currentF);
    return result;
  }

  public Double doIt(double currentT, double currentF, double currentX)
  {
    if (currentX >= X)
    {
      return currentT;
    }
    final Double wait = wait(currentT, currentF, currentX, X);
    final Double waitToBuy = currentT + wait(0.0, currentF, 0.0, C);
    final Double waitAfterBuy = wait(waitToBuy, currentF + F, currentX, X);
    if (waitAfterBuy < wait)
    {
      final Double buy = doIt(waitToBuy, currentF + F, currentX);
      return Math.min(wait, buy);
    }
    return Math.min(wait, waitAfterBuy);
  }

  // public static void main(String[] args)
  // {
  // GJCCA a = new GJCCA();
  // a.C = 500.0;
  // a.F = 4;
  // a.X = 2000.0;
  // a.C = 30.50000;
  // a.F = 3.14159;
  // a.X = 1999.19990;
  // System.out.println(a.doIt(0.0, 2, 0.0));
  // }

  public static void main(String args[]) throws Exception
  {
    BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
    String line = br.readLine();
    int T = Integer.parseInt(line);
    for (int t = 0; t < T; t++)
    {
      double[] input = getDoubleArray(br.readLine());
      GJCCA a = new GJCCA();
      a.C = input[0];
      a.F = input[1];
      a.X = input[2];
      // System.out.println(a.doIt(0.0, 2, 0.0));
      System.out.println("Case #" + (t + 1) + ": " + a.doIt(0.0, 2.0, 0.0));
    }
  }

  /**
   * @param readLine
   * @return
   */
  private static double[] getDoubleArray(String readLine)
  {
    String[] stringParts = readLine.split(" ");
    double[] res = new double[stringParts.length];
    int i = 0;
    for (String s : stringParts)
    {
      res[i] = Double.valueOf(s);
      i++;
    }
    return res;
  }

}
