import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Stack;
import java.util.StringTokenizer;

public class Watersheds {
	static class Point {
		int x;
		int y;
		Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
	}
	
	static int H;
	static int W;
	static int[][] as;
	static int[] dx = {0, -1, 1, 0};
	static int[] dy = {-1, 0, 0, 1};
	
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader("input.in"));
		PrintWriter out = new PrintWriter("result.out");
		int T = Integer.parseInt(in.readLine());
		for(int t = 1; t <= T; t++) {
			out.printf("Case #%d:%n", t);
			StringTokenizer st = new StringTokenizer(in.readLine());
			H = Integer.parseInt(st.nextToken());
			W = Integer.parseInt(st.nextToken());
			as = new int[H][W];
			for(int y = 0; y < H; y++) {
				st = new StringTokenizer(in.readLine());
				for(int x = 0; x < W; x++)
					as[y][x] = Integer.parseInt(st.nextToken());
			}
			char[][] cs = new char[H][W];
			char letter = 'a' - 1;
			for(int y = 0; y < H; y++) {
				for(int x = 0; x < W; x++) {
					if (cs[y][x] != '\u0000')
						continue;
					letter++;
					Stack<Point> s = new Stack<Point>();
					s.push(new Point(x, y));
					while(!s.isEmpty()) {
						Point p = s.pop();
						if (cs[p.y][p.x] != '\u0000')
							continue;
						cs[p.y][p.x] = letter;
						for(int i = 0; i < 4; i++) {
							int px = p.x + dx[i];
							int py = p.y + dy[i];
							if (px < 0 || px == W || py < 0 || py == H)
								continue;
							Point b = best(px, py);
							if (b != null && b.x == p.x && b.y == p.y && cs[b.y][b.x] != '\u0000')
								s.push(new Point(px, py));
						}
						Point b = best(p.x, p.y);
						if (b != null)
							s.push(b);
					}
				}
			}
			for(int y = 0; y < H; y++) {
				for(int x = 0; x < W; x++) {
					if (x > 0)
						out.print(' ');
					out.print(cs[y][x]);
				}
				out.println();
			}
		}
		out.close();
	}
	
	static Point best(int x, int y) {
		int bx = -1;
		int by = -1;
		int bv = as[y][x];
		for(int i = 0; i < 4; i++) {
			int px = x + dx[i];
			int py = y + dy[i];
			if (px < 0 || px == W || py < 0 || py == H)
				continue;
			if (as[py][px] < bv) {
				bv = as[py][px];
				bx = px;
				by = py;
			}
		}
		if (bx == -1)
			return null;
		return new Point(bx, by);
	}
}