import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.TreeSet;

public class FairAndSquare {
	
	public static TreeSet<BigInteger> fairAndSquare = new TreeSet<BigInteger>();
	
	public static TreeSet<String> done = new TreeSet<String>();
	
	public static BigInteger superLimit = BigInteger.TEN.pow(100);
	
	public static int limit = 3;
	
	static BigInteger sqrt(BigInteger n) {
		  BigInteger a = BigInteger.ONE;
		  BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
	  while(b.compareTo(a) >= 0) {
	    BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
	    if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
	    else a = mid.add(BigInteger.ONE);
	  }
	  return a.subtract(BigInteger.ONE);
	}

	
	public static void main(String args[]) throws IOException {
		Scanner scin = new Scanner(new File("in3.txt"));
		FileWriter fw = new FileWriter(new File("out3.txt"));

		fairAndSquare.add(BigInteger.valueOf(1));
		fairAndSquare.add(BigInteger.valueOf(4));
		fairAndSquare.add(BigInteger.valueOf(9));
		
		for (int i = 0; i < limit; i++) {
			generate(""+i+""+i);
		}
		
		System.out.println(fairAndSquare.size());
		
//		System.out.println(done);
//		generate("33");
		
		System.out.println(sqrt(fairAndSquare.last()));

		System.out.println(fairAndSquare.last());
		
		System.out.println(new BigInteger("20000000000000000000000000000000000000000000000002").pow(2));
		
//		System.out.println(fairAndSquare.headSet(BigInteger.valueOf(400)));
		
//		System.out.println(fairAndSquare);
		
//		System.out.println(Math.pow(10,100) < Double.MAX_VALUE);
//		System.out.println(Double.MAX_VALUE);
//		
		int T = scin.nextInt();
		
		for (int cs = 1; cs < T+1; cs++) {
			BigInteger A = scin.nextBigInteger();
			BigInteger B = scin.nextBigInteger();
			
			fw.write("Case #" + cs + ": " + fairAndSquare.tailSet(A, true).headSet(B, true).size() + "\n");
		}
		
		fw.close();
	}

	private static void generate(String string) {
//		System.out.println("generating...");
//		System.out.println(string);
		if (!isPalindrome(string)) {
			return;
		}
		BigInteger b = new BigInteger(string);
		b = b.pow(2);
		if (!isPalindrome(b)) {
			return;
		}
		
		if (done.contains(string)) {
//			System.out.println("repeat");
			return;
		}
		
		if (string.length() > 52) {
			return;
		}
		
		if (b.compareTo(superLimit) > 0) {
			return;
		}

		fairAndSquare.add(b);
		
		StringBuilder sb = new StringBuilder(string);
		for (int i = 0; i < limit; i++) {
			sb.insert(string.length()/2, i);
//			done.add(sb.toString());
			generate(sb.toString());
			done.add(sb.toString());
//			System.out.println(sb.toString());
			sb.insert(string.length()/2, i);
//			done.add(sb.toString());
//			System.out.println(sb.toString());
			generate(sb.toString());
			done.add(sb.toString());
			sb.deleteCharAt(string.length()/2);
			sb.deleteCharAt(string.length()/2);
//			generate(sb.toString());
		}
		
//		done.add(string);
	}

	private static void generate() {
//		int check = 5;
//		for (double i = 1; i < Math.pow(10, 50); i++){
//			if (i > Math.pow(10, check)) {
//				System.out.println("10^"+check);
//				check += 10;
//			}
//		}
//		BigInteger addend = BigInteger.ONE;
//		BigInteger limit = BigInteger.TEN.pow(17);
//		BigInteger TWO =  BigInteger.valueOf(2);
//		for (BigInteger start = BigInteger.ONE; start.compareTo(limit) <= 0; start = start.add(addend)) {
//			BigInteger sqrt = BigDecimal.valueOf(Math.sqrt(start.doubleValue())).toBigInteger();
//			
//			if (isPalindrome(sqrt) && isPalindrome(start)) {
//				fairAndSquare.add(start);
//			}
//			
//			addend = addend.add(TWO);
//		}
//		System.out.println(Math.pow(10,18) < Long.MAX_VALUE);
		fairAndSquare.add(BigInteger.valueOf(3));
	}

	private static boolean isPalindrome(int start) {
		return isPalindrome(""+start);
	}
	
	private static boolean isPalindrome(BigInteger start) {
		if (start.compareTo(BigInteger.TEN) < 0) {
			return true;
		}
		
		if (start.mod(BigInteger.TEN).compareTo(BigInteger.ZERO) == 0) {
			return false;
		}
		
		return isPalindrome(start.toString());
	}

	private static boolean isPalindrome(String string) {
		for (int i = 0; i < string.length()/2; i++) {
			if (string.charAt(i) != string.charAt(string.length()-i-1)) {
				return false;
			}
		}
		
		return true;
	}
}
