package google.codejam.round2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

public class PA {
	public static final String INPUT_FILE_NAME = "data/google/round2/A-small-attempt0.in";
	public static final String OUTPUT_FILE_NAME = "data/google/round2/A-small-attempt0.out";
	
	private static int V;
	private static int M;
	private static boolean[] changable;
	private static byte[] gates;
	private static byte[] values;
	private static int BOUND;
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(INPUT_FILE_NAME));
		BufferedWriter bw = new BufferedWriter(new FileWriter(OUTPUT_FILE_NAME));
		String line = br.readLine();
		int totalCase;
		totalCase = Integer.parseInt(line);
		for (int caseId = 0; caseId < totalCase; caseId++) {
			line = br.readLine();
			String[] parts = line.split(" ");
			M = Integer.parseInt(parts[0]);
			V = Integer.parseInt(parts[1]);
			BOUND = (M - 1) / 2;
			gates = new byte[M];
			Arrays.fill(gates, (byte)0);
			values = new byte[M];
			Arrays.fill(values, (byte)0);
			changable = new boolean[M];
			Arrays.fill(changable, false);
			for (int i = 0; i < BOUND; i++) {
				parts = br.readLine().split(" ");
				gates[i] = Byte.parseByte(parts[0]);
				changable[i] = parts[1].equals("1");
			}
			for (int i = BOUND; i < M; i++) {
				line = br.readLine();
				values[i] = Byte.parseByte(line);
			}
			String result = solve();
			System.out.println("Case #" + (caseId + 1) + ": " + result);
			bw.append("Case #" + (caseId + 1) + ": " + result + "\n");
		}
		bw.close();
		br.close();
	}

	private static int min(int a, int b) {
		return Math.min(a, b);
	}
	
	private static String solve() {
		int[] F0 = new int[M];
		int[] F1 = new int[M];
		Arrays.fill(F0, 10000);
		Arrays.fill(F1, 10000);
		for (int i = BOUND; i < M; i++) {
			if (values[i] == 0)
				F0[i] = 0;
			else 
				F1[i] = 0;
		}
		for (int i = BOUND - 1; i >= 0; i--) {
			int idxLeft = i * 2 + 1;
			int idxRight = i * 2 + 2;
			if (gates[i] == 0) {
				// OR
				// 0 = 0 or 0
				F0[i] = min(F0[i], F0[idxLeft] + F0[idxRight]);
				// 1 = 1 or 0 || 1 = 1 or 1
				F1[i] = min(F1[i], F1[idxLeft] + min(F0[idxRight], F1[idxRight]));
				// 1 = 0 or 1
				F1[i] = min(F1[i], F0[idxLeft] + F1[idxRight]);
				if (changable[i]) {
					// change to AND
					// 0 = 0 and 0 || 0 = 0 and 1
					F0[i] = min(F0[i], F0[idxLeft] + min(F0[idxRight], F1[idxRight]) + 1);
					// 0 = 1 and 0
					F0[i] = min(F0[i], F1[idxLeft] + F0[idxRight] + 1);
					// 1 = 1 and 1
					F1[i] = min(F1[i], F1[idxLeft] + F1[idxRight] + 1);
				}
			} else {
				// AND
				// 0 = 0 and 0 || 0 = 0 and 1
				F0[i] = min(F0[i], F0[idxLeft] + min(F0[idxRight], F1[idxRight]));
				// 0 = 1 and 0
				F0[i] = min(F0[i], F1[idxLeft] + F0[idxRight]);
				// 1 = 1 and 1
				F1[i] = min(F1[i], F1[idxLeft] + F1[idxRight]);
				if (changable[i]) {
					// change to OR
					// 0 = 0 or 0
					F0[i] = min(F0[i], F0[idxLeft] + F0[idxRight] + 1);
					// 1 = 1 or 0 || 1 = 1 or 1
					F1[i] = min(F1[i], F1[idxLeft] + min(F0[idxRight], F1[idxRight]) + 1);
					// 1 = 0 or 1
					F1[i] = min(F1[i], F0[idxLeft] + F1[idxRight] + 1);
				}
			}
		}
		if (V == 0 && F0[0] >= 10000 || V == 1 && F1[0] >= 10000) {
			return "IMPOSSIBLE";
		} else {
			if (V == 0)
				return "" + F0[0];
			else 
				return "" + F1[0];
		}
	}

}
