package google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

public class pb {
	public static final String INPUT_FILE_NAME = "data/google/B-small-attempt1.in";
	public static final String OUTPUT_FILE_NAME = "data/google/B-small-attempt1.out";
//	public static final String INPUT_FILE_NAME = "data/google/b.in";
//	public static final String OUTPUT_FILE_NAME = "data/google/b.out";

	public static final int STATION_A = 0;
	public static final int STATION_B = 1;
	public static final int EVENT_ARRIVE = 0;
	public static final int EVENT_LEAVE = 1;
	
	public static class Event {
		// happened at which station
		public final int station;
		// event type
		public final int type;
		// time
		public final int time;
		
		public Event(final int station, final int type, final int time) {
			this.station = station;
			this.type = type;
			this.time = time;
		}
		
		public String toString() {
			return "" + time + "," + station + "," + type;
		}

		public static class EventComparator implements Comparator<Event> {
			public int compare(Event arg0, Event arg1) {
				if (arg0.time > arg1.time)
					return 1;
				else if (arg0.time < arg1.time)
					return -1;
				else 
					return 0;
			}

			public static EventComparator getInstance() {
				return INSTANCE;
			}
			
			private static EventComparator INSTANCE = new EventComparator();
		}

	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(INPUT_FILE_NAME));
		BufferedWriter bw = new BufferedWriter(new FileWriter(OUTPUT_FILE_NAME));
		String line = br.readLine();
		int totalCase, turnaround, na, nb;
		totalCase = Integer.parseInt(line);
		for (int i = 0; i < totalCase; i++) {
			turnaround = Integer.parseInt(br.readLine());
			line = br.readLine();
			String[] parts = line.split("[ \t]");
			na = Integer.parseInt(parts[0]);
			nb = Integer.parseInt(parts[1]);
			List<Event> events = new ArrayList<Event>((na + nb) * 2);
			for (int j = 0; j < na + nb; j++) {
				line = br.readLine();
				String[] times = line.split("[ \t]");
				int leaveTime = getTime(times[0]);
				int arriveTime = getTime(times[1]);
				int station = j < na ? STATION_A : STATION_B;
				events.add(new Event(station, EVENT_LEAVE, leaveTime));
				events.add(new Event(1 - station, EVENT_ARRIVE, arriveTime + turnaround));
			}
			int[] answer = solve(events);
			System.out.println("Case #" + (i + 1) + ": " + answer[0] + " " + answer[1]);
			bw.append("Case #" + (i + 1) + ": " + answer[0] + " " + answer[1] + "\n");
		}
		bw.close();
		br.close();
	}
	
	private static int[] solve(List<Event> events) {
		Collections.sort(events, google.codejam.pb.Event.EventComparator.getInstance());
		int[] trainCount = new int[2];
		int[] minCount = new int[2];
		Arrays.fill(trainCount, 0);
		Arrays.fill(minCount, 0);
		int i = 0;
		int lastTime = -1;
		while (i < events.size()) {
			Event event = events.get(i);
			if (event.type == EVENT_LEAVE)
				trainCount[event.station]--;
			else 
				trainCount[event.station]++;
			if (i + 1 < events.size() && events.get(i + 1).time != lastTime) {
				if (trainCount[0] < minCount[0])
					minCount[0] = trainCount[0];
				if (trainCount[1] < minCount[1])
					minCount[1] = trainCount[1];
				lastTime = events.get(i + 1).time;
			}
			i++;
		}
		// need not check minimume now, because the minimum number must appear in the procedure
		minCount[0] = -minCount[0];
		minCount[1] = -minCount[1];
		return minCount;
	}

	private static int getTime(String s) {
		int pos = s.indexOf(":");
		int hour = Integer.parseInt(s.substring(0, pos));
		int min = Integer.parseInt(s.substring(pos + 1));
		return hour * 60 + min;
	}
}
