package google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;

public class pc {
//	public static final String INPUT_FILE_NAME = "data/google/c.in";
//	public static final String OUTPUT_FILE_NAME = "data/google/c.out";
	public static final String INPUT_FILE_NAME = "data/google/C-small-attempt0.in";
	public static final String OUTPUT_FILE_NAME = "data/google/C-small-attempt0.out";
	private static double f;
	private static double R;
	private static double t;
	private static double r;
	private static double g;
	// new radius
	private static double nR;
	// length of the new rectangle
	private static double s;
	
	private static final DecimalFormat df = new DecimalFormat("#0.000000");
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(INPUT_FILE_NAME));
		BufferedWriter bw = new BufferedWriter(new FileWriter(OUTPUT_FILE_NAME));
		String line = br.readLine();
		int totalCase;
		totalCase = Integer.parseInt(line);
		for (int i = 0; i < totalCase; i++) {
			line = br.readLine();
			String[] parts = line.split("[ \t]");
			f = Double.parseDouble(parts[0]);
			R = Double.parseDouble(parts[1]);
			t = Double.parseDouble(parts[2]);
			r = Double.parseDouble(parts[3]);
			g = Double.parseDouble(parts[4]);
			nR = R - t - f;
			s = g - 2 * f;
			String answer = df.format(solve()); 
			System.out.println("Case #" + (i + 1) + ": " + answer);
			bw.append("Case #" + (i + 1) + ": " + answer + "\n");
		}
		bw.close();
		br.close();
	}

	public static class Point {
		public final double x;
		public final double y;
		public Point(final double x, final double y) {
			this.x = x;
			this.y = y;
		}
		public double radius() {
			return Math.sqrt(x * x + y * y);
		}
		public String toString() {
			return "(" + x + "," + y + ")";
		}
		public static Point horiInte(Point p) {
			double y = p.y;
			double x = Math.sqrt(nR * nR - y * y);
			return new Point(x, y);
		}
		public static Point vertInte(Point p) {
			double x = p.x;
			double y = Math.sqrt(nR * nR - x * x);
			return new Point(x, y);
		}
	}
	
	private static double areaTri(Point a, Point b) {
		return (b.x * a.y - a.x * b.y) / 2;
	}
	
	private static double areaArc(Point a, Point b) {
		double angA = Math.asin(a.y / nR);
		double angB = Math.asin(b.y / nR);
		return nR * nR * (angA - angB) / 2;
	}
	
	private static double areaCase1(Point a, Point b, Point c) {
		return areaArc(a, c) - areaTri(a, b) - areaTri(b, c);
	}

	private static double areaCase2(Point a, Point b, Point c, Point d) {
		return areaArc(a, d) - areaTri(a, b) - areaTri(b, c) - areaTri(c, d);
	}

	private static double areaCase3(Point a, Point b, Point c, Point d) {
		return areaArc(a, d) - areaTri(a, b) - areaTri(b, c) - areaTri(c, d);
	}

	private static double areaCase4(Point a, Point b, Point c, Point d, Point e) {
		return areaArc(a, e) - areaTri(a, b) - areaTri(b, c) - areaTri(c, d) - areaTri(d, e);
	}

	private static double areaRect(Point a, Point b, Point c, Point d) {
		if (b.radius() > nR)
			return 0;
		else if (d.radius() < nR)
			return s * s;
		else {
			if (a.radius() < nR) {
				// case 3, 4
				if (c.radius() < nR) {
					// case 4
					Point p = Point.horiInte(a);
					Point q = Point.vertInte(c);
					return areaCase4(p, a, b, c, q);
				} else {
					// case 3
					Point p = Point.horiInte(a);
					Point q = Point.horiInte(b);
					return areaCase3(p, a, b, q);
				}
			} else {
				// case 1, 2
				if (c.radius() < nR) {
					// case 2
					Point p = Point.vertInte(b);
					Point q = Point.vertInte(c);
					return areaCase2(p, b, c, q);
				} else {
					// case 1
					Point p = Point.vertInte(b);
					Point q = Point.horiInte(b);
					return areaCase1(p, b, q);
				}
			}
		}
	}
	
	private static double solve() {
		if (2 * f >= g)
			return 1;
		double blockWidth = g + 2 * r;
		double baseY = 0;
		double totalArea = 0;
		while (baseY < nR) {
			double boundUpperX;
			if (nR >= (baseY + blockWidth))
				boundUpperX = Math.sqrt(nR * nR - (baseY + blockWidth) * (baseY + blockWidth));
			else 
				boundUpperX = 0;
			int countBound = (int) (boundUpperX / blockWidth);
			totalArea += s * s * countBound;
			double baseX = countBound * blockWidth;
			double boundX = Math.sqrt(nR * nR - baseY * baseY);
			while (baseX < boundX) {
				Point a = new Point(baseX + (r + f), baseY + (r + f) + s);
				Point b = new Point(baseX + (r + f), baseY + (r + f));
				Point c = new Point(baseX + (r + f) + s, baseY + (r + f));
				Point d = new Point(baseX + (r + f) + s, baseY + (r + f) + s);
				totalArea += areaRect(a, b, c, d);
				baseX += blockWidth;
			}
			baseY += blockWidth;
		}
		return 1.0 - totalArea / (Math.PI * R * R / 4);
	}

	
}
