package google.codejam.round2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class PB {
	public static final String INPUT_FILE_NAME = "data/google/round2/B-small-attempt1.in";
	public static final String OUTPUT_FILE_NAME = "data/google/round2/B-small-attempt1.out";
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(INPUT_FILE_NAME));
		BufferedWriter bw = new BufferedWriter(new FileWriter(OUTPUT_FILE_NAME));
		String line = br.readLine();
		int totalCase;
		totalCase = Integer.parseInt(line);
		for (int caseId = 0; caseId < totalCase; caseId++) {
			line = br.readLine();
			String parts[] = line.split(" ");
			int N, M, A;
			N = Integer.parseInt(parts[0]);
			M = Integer.parseInt(parts[1]);
			A = Integer.parseInt(parts[2]);
			String result = solve(N, M, A);
			System.out.println("Case #" + (caseId + 1) + ": " + result);
			bw.append("Case #" + (caseId + 1) + ": " + result + "\n");
		}
		bw.close();
		br.close();
	}

	private static String solve(int N, int M, int A) {
		for (int x2 = 0; x2 <= N; x2++) {
			for (int y1 = 0; y1 <= M; y1++) {
				// x1 * y2 = A + x2 * y1;
				int t = A + x2 * y1;
				int bound = t / M;
				if (bound * M < t)
					bound++;
				for (int x1 = bound; x1 <= N; x1++) {
					if (t % x1 == 0) {
						int y2 = t / x1;
						return "0 0 " + x1 + " " + y1 + " " + x2 + " " + y2;
					}
				}
			}
		}
		return "IMPOSSIBLE";
	}

}
