package google.codejam.round3;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class PD {
	public static final String INPUT_FILE_NAME = "data/google/round3/D-small-attempt1.in";
	public static final String OUTPUT_FILE_NAME = "data/google/round3/D-small-attempt1.out";
	
	private static final int[] dr = {-1, -2};
	private static final int[] dc = {-2, -1};
	private static final int K = dr.length;
	
	private static boolean[][] rocks;
	private static long[][] sol;
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new File(INPUT_FILE_NAME));
		PrintStream out = new PrintStream(new File(OUTPUT_FILE_NAME));
		int totalCase = in.nextInt();
		for (int caseId = 0; caseId < totalCase; caseId++) {
			int H, W, R;
			H = in.nextInt();
			W = in.nextInt();
			R = in.nextInt();
			rocks = new boolean[H][];
			sol = new long[H][];
			for (int i = 0; i < H; i++) {
				rocks[i] = new boolean[W];
				Arrays.fill(rocks[i], false);
				sol[i] = new long[W];
				Arrays.fill(sol[i], 0);
			}
			for (int i = 0; i < R; i++) {
				int r, c;
				r = in.nextInt();
				c = in.nextInt();
				rocks[r - 1][c - 1] = true;
			}
			String result = solve(H, W);
			System.out.format("Case #%d: %s\n", caseId + 1, result);
			out.format("Case #%d: %s\n", caseId + 1, result);
		}
		out.close();
		in.close();
	}

	private static String solve(int H, int W) {
		sol[0][0] = 1;
		for (int i = 0; i < H; i++) {
			for (int j = 0; j < W; j++) {
				if (rocks[i][j]) {
					sol[i][j] = 0;
				} else {
					int r, c;
					for (int k = 0; k < K; k++) {
						r = i + dr[k];
						c = j + dc[k];
						if (r >= 0 && c >= 0) {
							sol[i][j] += sol[r][c];
						}
					}
					sol[i][j] = sol[i][j] % 10007;
				}
			}
		}
		return Long.toString(sol[H - 1][W - 1]);
	}

}
