package gcj2016.qr;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.Writer;
import java.util.Scanner;

/**
 *
 * @author alecn2002 <alecn2002@yandex.ru>
 */
public class C {
    
    private static void debug(String f, Object... args) {
        System.err.printf(f, args);
        System.err.flush();
    }
    
    private static String[] permute01s(int n, int k) throws Exception {
        if (1 == k) {
            String[] ans = new String[n];
            for (int i = 0 ; i < n ; ++i) {
                StringBuilder sb = new StringBuilder(n);
                for (int j = 0 ; j < n ; ++j) {
                    sb.append(i == j ? '1' : '0');
                }
                ans[i] = sb.toString();
            }
            return ans;
        } else if (2 == k) {
            String[] ans = new String[n*(n-1)];
            int idx = 0;
            for (int i = 0 ; i < n ; ++i) {
                for (int j = 0 ; j < n ; ++j) {
                    if (i != j) {
                        StringBuilder sb = new StringBuilder(n);
                        for (int l = 0 ; l < n ; ++l) {
                            sb.append(i == l || j == l ? '1' : '0');
                        }
                        ans[idx++] = sb.toString();
                    }
                }
            }
            return ans;
        } else {
            throw new Exception(String.format("Not implemented for k = %d", k));
        }
        
    }
    
    private static String formByPerms(int n, String perm1, String perm2) {
        StringBuilder sb = new StringBuilder(n);
        sb.append('1');
        for (int i = 0 ; i < perm1.length() && i < perm2.length() && i < (n-2) / 2 ; ++i) {
            sb.append(perm1.charAt(i));
            sb.append(perm2.charAt(i));
        }
        sb.append('1');
        
        return sb.toString();
    }
    
    private static String[] get11s(int r1, int r2) {
        final String sdigit = "11";
        
        int sz = r2 - r1 + 1;
        String[] ans = new String[sz];
        for (int i = 0 ; i < sz ; ++i) {
            ans[i] = Integer.valueOf(sdigit, i + r1).toString();
        }
        return ans;
    }
    
    private static String join(String by, String[] a) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0 ; i < a.length ; ++i) {
            if (i > 0) {
                sb.append(by);
            }
            sb.append(a[i]);
        }
        return sb.toString();
    }
    
    private static String solve(int n, int j) throws Exception {
        String dividers = join(" ", get11s(2, 10));
        String[] ans = new String[j];
        int idx = 0;
        for (int k = 1 ; k <= 2 ; ++k) {
            String[] perms = permute01s((n - 2) / 2, k);
            for (int i = 0 ; i < perms.length ; ++i) {
                for (int l = 0 ; l < perms.length ; ++l) {
                    ans[idx++] = formByPerms(n, perms[i], perms[l]) + " " + dividers;
                    if (idx >= j) {
                        return join("\n", ans);
                    }
                }
            }
        }
        return join("\n", ans);
    }

    /**
     * @param args the command line arguments
     * @throws java.lang.Exception
     */
    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new Exception("Usage: QR_20160409 filename");
        }
        File in = new File(args[0] + ".in");
        try (Scanner sc = new Scanner(new FileReader(in))) {
            File out = new File(args[0] + ".out");
            try (Writer w = new FileWriter(out)) {
                final int T = sc.nextInt();
                sc.nextLine();
                for (int i = 0 ; i < T ; ++i) {
                    int n = sc.nextInt();
                    int j = sc.nextInt();
                    String ans = solve(n, j);
                    String fullAns = String.format("Case #%d:\n%s\n", i + 1, ans);
                    debug(fullAns);
                    w.write(fullAns);
                }
            }
        }
    }
    
}
