package gcj2016.qr;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.Writer;
import java.util.Scanner;

/**
 *
 * @author alecn2002 <alecn2002@yandex.ru>
 */
public class B {
    
    private static void debug(String f, Object... args) {
        System.err.printf(f, args);
        System.err.flush();
    }
    
    private static String flip(String src) {
        debug("flip('%s')\n", src);
        StringBuilder ans = new StringBuilder();
        for (int i = 0 ; i < src.length() ; ++i) {
            ans.append(src.charAt(src.length() - i - 1) == '+' ? '-' : '+');
        }
        return ans.toString();
    }
    
    private static String flip(String src, int n) {
        debug("flip('%s', %d)\n", src, n);
        if (n > src.length()) {
            n = src.length();
        }
        return flip(src.substring(0, n+1)) + src.substring(n+1);
    }

    private static int solve(String src) {
        int ans = 0;
        while (true) {
            int pos = src.lastIndexOf('-');
            debug("src='%s' pos=%d\n", src, pos);
            if (pos < 0) {
                return ans;
            }
            if (src.charAt(0) == '+') {
                pos = 0;
                while (src.charAt(pos) == '+') {
                    pos += 1;
                }
                pos -= 1;
            }
            src = flip(src, pos);
            ans += 1;
        }
    }
    
    /**
     * @param args the command line arguments
     * @throws java.lang.Exception
     */
    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new Exception("Usage: QR_20160409 filename");
        }
        File in = new File(args[0] + ".in");
        try (Scanner sc = new Scanner(new FileReader(in))) {
            File out = new File(args[0] + ".out");
            try (Writer w = new FileWriter(out)) {
                final int T = sc.nextInt();
                sc.nextLine();
                for (int i = 0 ; i < T ; ++i) {
                    int ans = solve(sc.nextLine());
                    String fullAns = String.format("Case #%d: %d\n", i + 1, ans);
                    debug(fullAns);
                    w.write(fullAns);
                }
            }
        }
    }
    
}
