package round1cproba;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ProbA {

//	private static final String IN_FILE_NAME = "C:\\eclipse-workspace\\google-code-jam\\google-code-jam\\src\\round1cproba\\example.in";
//	private static final String IN_FILE_NAME = "C:\\eclipse-workspace\\google-code-jam\\google-code-jam\\src\\round1cproba\\extra-tests.in";
//	private static final String IN_FILE_NAME = "C:\\eclipse-workspace\\google-code-jam\\google-code-jam\\src\\round1cproba\\illegals.in";
	private static final String IN_FILE_NAME = "C:\\eclipse-workspace\\google-code-jam\\google-code-jam\\src\\round1cproba\\A-small-attempt0.in";
	
	private static final String OUT_FILE_NAME = "C:\\eclipse-workspace\\google-code-jam\\google-code-jam\\src\\round1cproba\\outfile.out";

	public static void main(String[] args) throws Exception {
		ProbA test = new ProbA();
		test.run();
	}
	
	public void run() throws Exception {
		PrintStream out = new PrintStream(OUT_FILE_NAME);
		BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream(IN_FILE_NAME)));
		try {
			int numCases = Integer.parseInt(in.readLine());
			for (int i = 1; i <= numCases; i++) {
				TestData testData = new TestData();
				testData.parse(in);
	
				String result = runTest(testData, i);
				String caseOutput = "Case #"+i+": " + result;
				System.out.println(caseOutput);
				out.println(caseOutput);
			}

			String nextLine;
			do {
				nextLine = in.readLine();
				if (nextLine != null) {
					assert nextLine.trim().length() == 0 : "Ignored line " + nextLine;
				}
			} while (nextLine != null);

		} finally {
			try {
				out.close();
			} finally {
				in.close();
			}
		}
	}

	public String runTest(TestData testData, int testNum) throws Exception {
		Arrays.sort(testData.frequencies);

		int numPresses = 0;
		int[] numLettersOnKey = new int[testData.keysAvailable];
		int nextKey = 0;
		for (int i = testData.frequencies.length-1; i >= 0; i--) {
			int numOccurrences = testData.frequencies[i];
			numLettersOnKey[nextKey]++;
			int numLettersOnThisKey = numLettersOnKey[nextKey];
			
			if (numLettersOnThisKey > testData.maxLetgersPerKey) {
				return "Impossible";
			}
			
			numPresses += numLettersOnThisKey*numOccurrences;
			nextKey = (nextKey+1) % numLettersOnKey.length;
		}
		
		return ""+numPresses;
	}
		
	private static class TestData {
		
		private int maxLetgersPerKey;
		private int keysAvailable;
		private int lettersInAlphabet;
		private int[] frequencies;
		public void parse(BufferedReader in) throws Exception {
			String firstline = in.readLine().trim();
			String[] firstsplit = firstline.split(" ");
			assert firstsplit.length == 3;
			maxLetgersPerKey = Integer.parseInt(firstsplit[0]);
			keysAvailable = Integer.parseInt(firstsplit[1]);
			lettersInAlphabet = Integer.parseInt(firstsplit[2]);
			
			String secondline = in.readLine().trim();
			frequencies = new int[lettersInAlphabet];
			String[] split = secondline.split(" ");
			assert lettersInAlphabet == split.length;
			for (int i = 0; i < split.length; i++) {
				frequencies[i] = Integer.parseInt(split[i].trim());
			}
		}
	}

	public void log(String message) {
		System.out.println("LOG: " + message);
	}
}
