/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SelectionRound.BotTrust;

import AbstractProblems.AbstractProblemSolver;
import java.util.StringTokenizer;

/**
 *
 * @author Alei
 */
public class BotTrustSolver extends AbstractProblemSolver {
    protected Instruction[] instructions;
    protected Bot[] bots;
    protected Bot orangeBot, blueBot;
    protected Bot preferenceBot,noPreferenceBot;
    protected int totalTime = 0;

    public BotTrustSolver() {
        orangeBot = new Bot(0);
        blueBot = new Bot(1);
        bots = new Bot[2];
        bots[0] = orangeBot;
        bots[1] = blueBot;
    }
    public void reset(){
        orangeBot.reset();
        blueBot.reset();
        totalTime = 0;
    }
    @Override
    public String solve() {
        orangeBot.findNearTarget(instructions);
        blueBot.findNearTarget(instructions);
        while(!orangeBot.finish || !blueBot.finish){
            preferenceBot = getPreferenceBot();
            noPreferenceBot = bots[1-preferenceBot.name];

            int time = preferenceBot.doTarget();
            totalTime +=time;
            preferenceBot.findNearTarget(instructions);
            noPreferenceBot.avanceToTarget(time);              
        }
        return "Case #" + (nProblem+1) + ": " + totalTime;
    }
    protected Bot getPreferenceBot(){
        Bot prefered = null;
        if (orangeBot.finish){
            prefered = blueBot;
        }
        if(blueBot.finish){
            prefered = orangeBot;
        }
        if(prefered==null){
            prefered = orangeBot;
            int orangeNInstruction = orangeBot.activeInstruction.nInstruction;
            int blueNInstruction   = blueBot.activeInstruction.nInstruction;
            if(orangeNInstruction>blueNInstruction){
                prefered = blueBot;
            }            
        }
        
        return  prefered;
    }
    protected void doOperationPreferedBot(){
        preferenceBot = getPreferenceBot();
        if(preferenceBot.isOnTheTarget()){
            totalTime+=1;
            bots[1-preferenceBot.name].avanceToTarget(1);
            preferenceBot.findNearTarget(instructions);
        }
        
    }
    protected void moveBotToTarget(int nBot){
        Bot bot1 = bots[nBot];//the bot to move to its target
        Bot bot2 = bots[1-nBot];//the other bot
        int operationTime=Math.abs(bot1.activeInstruction.nButton-bot1.position);
        bot1.position = bot1.activeInstruction.nButton;        
        totalTime +=operationTime;
        bot2.avanceToTarget(operationTime);
    }

    public void setInstructions(String instructionsLine) {
        StringTokenizer tokenizer = new StringTokenizer(instructionsLine);        
        int nInstructions = Integer.parseInt(tokenizer.nextToken());
        instructions = new Instruction[nInstructions];
        int nRobot,nButton;

        for(int i =0 ; i < nInstructions ; i++){
           nRobot = tokenizer.nextToken().equals("O")?0:1;
           nButton = Integer.parseInt(tokenizer.nextToken());
           Instruction instruction = new Instruction(nRobot, nButton, i);
           instructions[i] = instruction;
            /*
            currentInstuction = instructionsList.substring(cut, cut+3);
            Instruction instruction = new Instruction(currentInstuction,i);
            instructions[i] = instruction;
            cut += 4;
             *
             */
        }
    }

}
