/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SelectionRound.Magicka;

import AbstractProblems.AbstractProblemSolver;
import java.util.HashMap;
import java.util.LinkedList;

/**
 *
 * @author Alei
 */
public class MagickaSolver extends AbstractProblemSolver {
    private String strInvoke = "";
    private StringBuffer strSimplified = new StringBuffer("");
    private HashMap<Character,LinkedList<LetterPair>> combinationRulers = new HashMap<Character, LinkedList<LetterPair>>();
    private HashMap<Character,LinkedList<Character>> opositeRulers = new HashMap<Character, LinkedList<Character>>();

    @Override
    public String solve() {
        
        for(int i=0;i<strInvoke.length();i++){
            invoke(strInvoke.charAt(i));
        }
        String strPrint = getStrCsv();
        return "Case #"+(nProblem+1)+": ["+strPrint+"]";
    }
    private void invoke(char character){
        boolean clearList = false;
        Character combineCharacter = null;
        if(strSimplified.length()>0){
            char lastLetter = (strSimplified.charAt(strSimplified.length()-1));
            if(character<=lastLetter){
                combineCharacter =  getCombineCharacters(character,lastLetter);
            }
            else{
                combineCharacter =  getCombineCharacters(lastLetter,character);
            }
            
            if(combineCharacter==null){
                strSimplified.append(character);
                clearList = findOposites(character);
            }
            else{                
                strSimplified.deleteCharAt(strSimplified.length()-1);
                strSimplified.append(combineCharacter);
            }
        }
        else{
            strSimplified.append(character);
        }
        if(clearList){
            strSimplified = new StringBuffer("");
        }
    }
    protected Character getCombineCharacters(char char1,char char2){
        LinkedList<LetterPair> interchangableElements = combinationRulers.get(char1);        
        Character combination = null;
        if(interchangableElements!=null){
            LetterPair pair;
            for(int i=0;i<interchangableElements.size();i++){
                pair = interchangableElements.get(i);
                if(pair.x == char2){
                    combination = pair.y;
                }
            }   
        }        
        return combination;
    }
    protected boolean findOposites(char character){
        Character opositeTest;
        LinkedList<Character> oposites = opositeRulers.get(character);
        boolean hayOpuesto = false;
        if(oposites!=null){
            for(int i=0;i<strSimplified.length() && !hayOpuesto;i++){
                opositeTest = strSimplified.charAt(i);
                hayOpuesto = oposites.contains(opositeTest);
            }
        }
        return hayOpuesto;
    }
    protected void interchangeCharacters(){

    }
    public void reset() {
        combinationRulers = new HashMap<Character, LinkedList<LetterPair>>();
        opositeRulers = new HashMap<Character, LinkedList<Character>>();
        strInvoke = "";
        strSimplified = new StringBuffer("");
    }

    public void addInterchangeRule(String rule) {
        char baseElement1 = rule.charAt(0);
        char baseElement2 = rule.charAt(1);
        char combination = rule.charAt(2);
        if(baseElement1<=baseElement2){
            appendInterchangeRule(baseElement1,baseElement2,combination);
        }
        else{
            appendInterchangeRule(baseElement2,baseElement1,combination);
        }
    }
    protected void appendInterchangeRule(char baseElement1,char baseElement2,char combination){
        LinkedList<LetterPair> baseElements1Pairs = combinationRulers.get(baseElement1);
        LetterPair pairToAdd = new LetterPair(baseElement2, combination);
        if(baseElements1Pairs==null){
            LinkedList<LetterPair> pairsList = new LinkedList<LetterPair>();
            pairsList.add(pairToAdd);
            combinationRulers.put(baseElement1, pairsList);
        }
        else{
            baseElements1Pairs.add(pairToAdd);
        }
    }

    public void addOpositeRule(String rule) {
        Character baseElement = rule.charAt(0);
        Character oposite = rule.charAt(1);        
        appendOpositeRule(baseElement,oposite);
        appendOpositeRule(oposite,baseElement);        
    }
    protected void appendOpositeRule(Character baseElement,Character oposite){
        LinkedList<Character> baseElementOposites = opositeRulers.get(baseElement);
        if(baseElementOposites==null){
            LinkedList<Character> oposites = new LinkedList<Character>();
            oposites.add(oposite);
            opositeRulers.put(baseElement, oposites);
        }
        else{
            baseElementOposites.add(oposite);
        }
    }
    public void setStrInvoke(String str) {
        strInvoke = str;
    }

    private String getStrCsv() {
        String csv = "";
        for(int i=0;i<strSimplified.length();i++){
            csv += ", " + strSimplified.charAt(i);
        }
        if(csv.length()>0){
            csv = csv.substring(2);
        }        
        return csv;
    }

}
