/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SelectionRound.Magicka;

import AbstractProblems.AbstractProblemsManager;
import java.io.IOException;
import java.util.StringTokenizer;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Alei
 */
public class MagickaProblemManager extends AbstractProblemsManager {

    @Override
    protected void createProblemSolver() {
        problemSolver = new MagickaSolver();
    }

    @Override
    protected void prepareSolver() {
        MagickaSolver solver = (MagickaSolver) problemSolver;
        solver.reset();
        try {
            String problemLine = br.readLine();
            StringTokenizer tokenizer = new StringTokenizer(problemLine);
            int nCombinationRules = Integer.parseInt(tokenizer.nextToken());
            for(int i=0;i<nCombinationRules;i++){
                solver.addInterchangeRule(tokenizer.nextToken());
            }            
            int nOpositesRules = Integer.parseInt(tokenizer.nextToken());
            for(int i=0;i<nOpositesRules;i++){
                solver.addOpositeRule(tokenizer.nextToken());
            }
            tokenizer.nextToken();
            solver.setStrInvoke(tokenizer.nextToken());
        }
        catch (IOException ex) {
            Logger.getLogger(MagickaProblemManager.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

}
