/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package AbstractProblems;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Alei
 */
public abstract class AbstractProblemsManager {
    protected String urlInputFile;
    protected String urlOutputFile;
    protected BufferedReader br = null;
    protected BufferedWriter bw = null;
    protected AbstractProblemSolver problemSolver;
    public void setUrlInputFile(String url){
        urlInputFile = url;
    }
    public void setUrlOutputFile(String url){
        urlOutputFile = url;
    }
    protected void genReader() throws FileNotFoundException{        
        File fl = new File(urlInputFile);
        FileReader fr;
        fr = new FileReader(fl);
        br = new BufferedReader(fr);
    }
    protected void genWriter() throws IOException{
        File fl = new File(urlOutputFile);
        FileWriter fw = new FileWriter(fl);
        bw = new BufferedWriter(fw);
    }
    public void process() throws IOException{
        genReader();
        genWriter();
        createProblemSolver();
        String solution;
        String nCasosStr = br.readLine();
        int nCasos = Integer.parseInt(nCasosStr);
        for(int i=0;i<nCasos;i++){            
            problemSolver.setNProblem(i);
            prepareSolver();
            solution = problemSolver.solve();
            if(i<nCasos-1){
                solution+="\n";
            }            
            bw.write(solution);
        }
        br.close();
        bw.close();
    }
    protected abstract void createProblemSolver();
    protected abstract void prepareSolver();


}
