/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package SelectionRound.BotTrust;

/**
 *
 * @author Alei
 */
public class Bot {
    public Instruction activeInstruction = null;
    public int position = 1;
    public int name;
    public boolean finish = false;

    public Bot(int name) {
        this.name = name;
    }
    public void reset(){
        position = 1;
        activeInstruction = null;
        finish = false;
    }
    public void findNearTarget(Instruction[] instructions) {
        if(!finish){
            boolean foundTarget = false;
            int nCurrentInstruction = -1;
            if(activeInstruction!=null){
                nCurrentInstruction = activeInstruction.nInstruction;
            }
            Instruction currentInstruction;
            for(int i=nCurrentInstruction+1;i<instructions.length &&!foundTarget;i++){
                currentInstruction = instructions[i];
                if(currentInstruction.nRobot==name){
                    foundTarget = true;
                    activeInstruction = currentInstruction;
                }
            }
            if(!foundTarget){
                finish = true;
            }
        }
    }

    public int getTargetArriveTime() {
        return Math.abs(position-activeInstruction.nButton);
    }

    public void avanceToTarget(int distance) {
        int ds = 0;
        if(!finish){
            int distanceToTarget = activeInstruction.nButton-position;
            ds = Math.abs(distanceToTarget);
            int absDistance = Math.abs(distance);
            if(Math.abs(distanceToTarget)>absDistance){
                ds = absDistance;
            }
            if(distanceToTarget<0) {
                ds = -ds;
            }    
        }
        position+=ds;
    }

    @Override
    public String toString() {
        return "bot "+name+" position="+position+" finished="+finish+" target:"+activeInstruction;
    }

    public boolean isOnTheTarget() {
        boolean isOnTheTarget = false;
        if(activeInstruction.nButton == this.position){
            isOnTheTarget = true;
        }
        return isOnTheTarget;
    }

    public int doTarget() {
        int distanceToTarget = activeInstruction.nButton-position;
        position = activeInstruction.nButton;
        return Math.abs(distanceToTarget)+1;
    }

}
