package codejam;

import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;

public class Minesweeper {

    public static void main(String[] args) throws Exception {

        BufferedReader reader = null;
        reader = new BufferedReader(new FileReader("C-small-attempt2.in"));

        FileOutputStream resultFile = new FileOutputStream("C-small-attempt2.out");

        int numberCases = Integer.parseInt(reader.readLine());

        for (int caseNumber = 1; caseNumber <= numberCases; caseNumber++) {

            int r, c, m;
            String[] reading = reader.readLine().split(" ");

            r = Integer.parseInt(reading[0]);
            c = Integer.parseInt(reading[1]);
            m = Integer.parseInt(reading[2]);

            resultFile.write(("Case #" + caseNumber + ":\n").getBytes());

            if (r == 1 && c == 1) {
                if (m == 0) {
                    resultFile.write("c\n".getBytes());
                } else {
                    resultFile.write("Impossible\n".getBytes());
                }
                continue;
            }

            if (r * c == 2) {
                if (m == 0) {
                    if (r == 1) {
                        resultFile.write(".c\n".getBytes());
                    } else if (c == 1) {
                        resultFile.write(".\n".getBytes());
                        resultFile.write("c\n".getBytes());
                    }
                } else if (m == 1) {
                    if (r == 1) {
                        resultFile.write("*c\n".getBytes());
                    } else if (c == 1) {
                        resultFile.write("*\n".getBytes());
                        resultFile.write("c\n".getBytes());
                    }
                }
                continue;
            }

            if (m == r * c - 1) {

                for (int countR = 0; countR < r; countR++) {

                    String line = "";

                    for (int countC = 0; countC < c; countC++) {
                        if (m > 0) {
                            line += "*";
                            m--;
                        } else {
                            line += "c";
                        }
                    }
                    resultFile.write((line + "\n").getBytes());
                }
                continue;
            }

            int[] click = new int[]{r - 1, c - 1};

            int[][] forbiddenPoints = new int[4][];

            int forbiddenPointsCounter = 0;

            if (r - 1 > 0) {
                forbiddenPoints[forbiddenPointsCounter++] = new int[]{r - 2, c - 1};
            }
            if (c - 1 > 0) {
                forbiddenPoints[forbiddenPointsCounter++] = new int[]{r - 1, c - 2};
            }
            if (r - 1 > 0 && c - 1 > 0) {
                forbiddenPoints[forbiddenPointsCounter++] = new int[]{r - 2, c - 2};
            }

            forbiddenPoints[forbiddenPointsCounter++] = new int[]{click[0], click[1]};

            if (r * c - forbiddenPointsCounter < m) {
                resultFile.write("Impossible\n".getBytes());
                continue;
            }

            for (int countR = 0; countR < r; countR++) {

                String line = "";

                for (int countC = 0; countC < c; countC++) {

                    if (countR == click[0] && countC == click[1]) {
                        line += "c";
                    } else if (m > 0 && !pointInForbidden(forbiddenPoints, new int[]{countR, countC})) {
                        line += "*";
                        m--;
                    } else {
                        line += ".";
                    }
                }
                resultFile.write((line + "\n").getBytes());
            }
        }
    }

    private static boolean pointInForbidden(int[][] forbiddenPoints, int[] point) {

        for (int[] forbiddenPoint : forbiddenPoints) {
            if (forbiddenPoint != null) {
                if (point[0] == forbiddenPoint[0] && point[1] == forbiddenPoint[1]) {
                    return true;
                }
            }
        }

        return false;
    }

}
