import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Scanner;


public class BathroomStalls {

	public static void main(String[] args) {
		
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();
	    in.nextLine();
	    String[] cases = new String[t];
	    for (int i = 1; i <= t; ++i) {
	    	cases[i - 1] = in.nextLine();
	    }
	    
	    for(int i = 0; i < cases.length; i++){
	    	System.out.println("Case #" + (i + 1) + ": " + solveCase(cases[i]));
	    }
	}

	public static String solveCase(String c){
		
		String[] problemParts = c.split(" ");
		int n = Integer.parseInt(problemParts[0]);
		int k = Integer.parseInt(problemParts[1]);
		
		Stall[] stalls = new Stall[n + 2];
		
		for(int i = 0; i < stalls.length; i++){
			stalls[i] = new Stall();
			stalls[i].index = i;
		}

		stalls[0].o = true;		
		stalls[stalls.length - 1].o = true;
		
		int minResult = 0, maxResult = 0;
		
		for(int j = 0; j < k; j++){
			int spaces = 0;
			for(int i = 1; i < stalls.length; i++){
				if(stalls[i].o){
					spaces = 0;
				}else{
					stalls[i].ls = spaces;
					spaces++;
				}
			}
			spaces = 0;
			for(int i = stalls.length - 1; i > 0; i--){
				if(stalls[i].o){
					spaces = 0;
				}else{
					stalls[i].rs = spaces;
					spaces++;
				}
			}
			
			ArrayList<Stall> candidates = new ArrayList<Stall>();
			
			for(int i = 0; i < stalls.length; i++){
				if(!stalls[i].o){
					candidates.add(stalls[i]);
				}
			}
			
			Collections.sort(candidates, new Comparator<Stall>() {

				@Override
				public int compare(Stall o1, Stall o2) {
					return  Math.min(o2.ls, o2.rs) - Math.min(o1.ls, o1.rs);  
				}
				
			});
			
			int min = Math.min(candidates.get(0).ls, candidates.get(0).rs);
			minResult = min;
			
			for(int i = 0; i < candidates.size(); i++){
				Stall s = candidates.get(i);
				if(Math.min(s.ls, s.rs) < min){
					candidates.remove(i);
					i--;
				}
			}

			boolean selected = false;
			
			if(candidates.size() == 1){
				candidates.get(0).o = true;
				selected = true;
			}
			
			ArrayList<Stall> finals = new ArrayList<Stall>();
			
			finals.addAll(candidates);
			
			Collections.sort(finals, new Comparator<Stall>() {

				@Override
				public int compare(Stall o1, Stall o2) {
					return Math.max(o2.ls, o2.rs) - Math.max(o1.ls, o1.rs);
				}
				
			});

			int max = Math.max(finals.get(0).ls, finals.get(0).rs);
			maxResult = max;
			
			if(!selected){
				for(int i = 0; i < finals.size(); i++){
					Stall s = finals.get(i);
					if(Math.max(s.ls, s.rs) != max){
						finals.remove(i);
						i--;
					}
				}
				
				
				if(finals.size() == 1){
					finals.get(0).o = true;
				}else{
					int index = 0;
					int value = finals.get(0).index;
					for(int i = 0; i < finals.size(); i++){
						Stall s = finals.get(i);
						if(s.index < value){
							index = i;
						}
					}
					finals.get(index).o = true;
				}
			}
		}
		return maxResult + " " + minResult;
	}
	
	static class Stall{
		int ls, rs;
		int index;
		boolean o;
	}
	
}
