import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;


public class BathroomStalls {

	public static void main(String[] args) {
		
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();
	    in.nextLine();
	    String[] cases = new String[t];
	    for (int i = 1; i <= t; ++i) {
	    	cases[i - 1] = in.nextLine();
	    }
	    
	    for(int i = 0; i < cases.length; i++){
	    	System.out.println("Case #" + (i + 1) + ": " + solveCase(cases[i]));
	    }
	}

	public static String solveCase(String c){

		String[] problemParts = c.split(" ");
		List<String> steps = new ArrayList<String>(64);
		
		BigInteger n = new BigInteger(problemParts[0]);
		BigInteger k = new BigInteger(problemParts[1]);
		
		BigInteger two = new BigInteger("2");
		BigInteger three = new BigInteger("3");
		
		BigInteger[] divideResult = k.divideAndRemainder(two);
		
		while(!k.equals(BigInteger.ZERO) && !k.equals(BigInteger.ONE)){
			divideResult = k.divideAndRemainder(two); 
			k = divideResult[0];
			if(divideResult[1].equals(BigInteger.ONE)){
				steps.add("R");
			}else{
				steps.add("L");
			}
		}
		
		Collections.reverse(steps);
		
		divideResult = n.divideAndRemainder(two);
		
		BigInteger max = divideResult[0];
		BigInteger min = divideResult[1].equals(BigInteger.ZERO) ? max.subtract(BigInteger.ONE) : new BigInteger(max.toString());
		
		for(String step:steps){
			
			BigInteger number = step.equals("L") ? max : min;
			
			if(number.equals(BigInteger.ZERO)){
				min = BigInteger.ZERO;
				max = BigInteger.ZERO;
				break;
			}

			divideResult = number.divideAndRemainder(two);
			max = divideResult[0];
			min = divideResult[1].equals(BigInteger.ZERO) ? max.subtract(BigInteger.ONE) : new BigInteger(max.toString());
		}
		
		return max.toString() + " " + min.toString();
	}
}
