/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package gcjtraintimetable;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 *
 * @author alejo
 */
public class Main {
    
    public static class TimeTableItem {
        public TimeTableItem(String data) {
            String x[] = data.split(" ");
            String s[] = x[0].split(":");
            String l[] = x[1].split(":");

            this.salida = Integer.parseInt(s[1]) + Integer.parseInt(s[0]) * 60;
            this.llegada = Integer.parseInt(l[1]) + Integer.parseInt(l[0]) * 60;
        }

        @Override
        public String toString() {
            return "TimeTableItem sal: " + salida + ", lle: " + llegada;
        }

        public int salida;
        public int llegada;

        public boolean usado = false;
    }

    public static void leer(BufferedReader br, List<TimeTableItem> ab, List<TimeTableItem> ba) throws IOException {
        String[] cant = br.readLine().split(" ");
        int cant_ab = Integer.parseInt(cant[0]);
        int cant_ba = Integer.parseInt(cant[1]);

        for (int i = 0; i < cant_ab; i++)
            ab.add(new TimeTableItem(br.readLine()));

        for (int i = 0; i < cant_ba; i++)
            ba.add(new TimeTableItem(br.readLine()));

    }

    public static void ordenar(List<TimeTableItem> l, boolean porSalida) {
        if (porSalida) {
            Collections.sort(l, new Comparator() {
                public int compare(Object arg0, Object arg1) {
                    return ((TimeTableItem)arg0).salida - ((TimeTableItem)arg1).salida;
                }
            });
        } else {
            Collections.sort(l, new Comparator() {
                public int compare(Object arg0, Object arg1) {
                    return ((TimeTableItem)arg0).llegada - ((TimeTableItem)arg1).llegada;
                }
            });
        }
    }

    public static int procesar(List<TimeTableItem> ab, List<TimeTableItem> ba, int tiempoEspera) {
        int trenes_necesito = 0;

        for (TimeTableItem x : ab)
            x.usado = false;

        for (TimeTableItem x : ba)
            x.usado = false;

        ordenar(ab, true);
        ordenar(ba, false);

        for (TimeTableItem x : ab) {
            int j;

            for (j = 0; j < ba.size(); j++) {
                TimeTableItem w = ba.get(j);
                if (w.usado == false && x.salida >= w.llegada + tiempoEspera) {
                    w.usado = true;
                    break;
                }
            }

            if (j == ba.size()) {
                trenes_necesito++;
            }
        }

        return trenes_necesito;
    }

    public static void main(String[] args) {
        try {
            File f = new File(args[0]);
            FileReader fis = new FileReader(f);
            BufferedReader br = new BufferedReader(fis);

            int casos = Integer.parseInt(br.readLine());

            for (int i = 1; i <= casos; i++) {
                List<TimeTableItem> ab = new ArrayList<TimeTableItem>();
                List<TimeTableItem> ba = new ArrayList<TimeTableItem>();

                int tiempoEspera = Integer.parseInt(br.readLine());

                leer(br, ab, ba);

                /*
                System.out.println(i);
                for(TimeTableItem x : ab) System.out.println(x);
                for(TimeTableItem x : ba) System.out.println(x);
                */

                int trenes_a = procesar(ab, ba, tiempoEspera);
                int trenes_b = procesar(ba, ab, tiempoEspera);

                System.out.println("Case #" + i + ": " + trenes_a + " " + trenes_b );
            }

        } catch (Exception e) {
            e.printStackTrace();
        }

    }

}
