import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.Scanner;

/* Alejandro Santos, alejolp@alejolp.com.ar. */

public class TicTacToeTomek {

	public static boolean hasWon(String[] table, String player) {
		String otherPlayer = (player == "X") ? "O" : "X";
		
		// Horizontal
		for (int k = 0; k < 4; ++k) {
			if (!table[k].contains(".") && !table[k].contains(otherPlayer))
				return true;
		}
		
		// Vertical
		for (int k = 0; k < 4; ++k) {
			boolean found = false;
			for (int z = 0; z < 4 && !found; ++z) {
				if (table[z].charAt(k) == '.' || table[z].charAt(k) == otherPlayer.charAt(0))
					found = true;
			}
			if (!found)
				return true;
		}
		
		boolean found = false;
		// Diagonal 1
		for (int k = 0; k < 4 && !found; ++k) {
			if (table[k].charAt(k) == '.' || table[k].charAt(k) == otherPlayer.charAt(0))
				found = true;
		}
		if (!found)
			return true;
		
		found = false;
		// Diagonal 2
		for (int k = 0; k < 4 && !found; ++k) {
			if (table[k].charAt(3 - k) == '.' || table[k].charAt(3 - k) == otherPlayer.charAt(0))
				found = true;
		}
		if (!found)
			return true;

		return false;
	}
	
	public static boolean isDraw(String[] table) {
		for (int k = 0; k < 4; ++k)
			if (table[k].contains("."))
				return false;
		return true;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FileInputStream fis = null;
		
		try {
			fis = new FileInputStream("/home/alejo/Downloads/A-large.in");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		Scanner s = new Scanner(fis);
		//Scanner s = new Scanner(System.in);
		
		int N = s.nextInt();
		
		for (int k = 1; k <= N; ++k) {
			String[] table = new String[4];
			s.nextLine();
			
			for (int y = 0; y < 4; ++y) {
				table[y] = s.nextLine();
			}
			
			boolean wonX = hasWon(table, "X");
			boolean wonO = hasWon(table, "O");
			boolean draw = isDraw(table);
			
			if ((wonX && wonO)) {
				System.out.println("Case #" + k + ": Draw");
			} else if (wonX) {
				System.out.println("Case #" + k + ": X won");				
			} else if (wonO) {
				System.out.println("Case #" + k + ": O won");
			} else if (draw) {
				System.out.println("Case #" + k + ": Draw");
			} else {
				System.out.println("Case #" + k + ": Game has not completed");
			}
		}
	}
}
