import java.util.*;
import java.util.zip.ZipEntry;
import java.util.zip.ZipOutputStream;
import java.io.*;
import java.math.*;

public class Main {

	Scanner in;
	PrintWriter out;
	
	public static void main(String[] args) throws Exception {
		(new Main()).solve();
	}
	
	BigInteger ans1, ans2;
	BigInteger n, p;
	int nInt;
	
	BigInteger fPow (int val, int deg)
	{
		BigInteger res = BigInteger.ONE;
		BigInteger mul = BigInteger.valueOf(val);
		
		while (deg != 0)
		{
			if ( (deg & 1) != 0)
				res = res.multiply(mul);
			
			mul = mul.multiply(mul);
			deg >>= 1;
		}
		
		return res;
	}
	
	void getAnsGuarantee ()
	{
		if (n.compareTo(p) == 0)
		{
			ans1 = n.subtract(BigInteger.ONE);
			return ;
		}
		
		p = p.subtract(BigInteger.ONE);
		
		BigInteger nSave = n;
		
		ans1 = BigInteger.ZERO;
		BigInteger add = BigInteger.valueOf(2);
		BigInteger pCur = p;
		BigInteger half;
		
		for (int i = 0; i < nInt - 1; i++)
		{
			half = n.divide(BigInteger.valueOf(2) );
			
			if (pCur.compareTo(half) == -1)
				break;
			
			ans1 = ans1.add(add);
			add = add.multiply(BigInteger.valueOf(2) );
			pCur = pCur.subtract(half);
			n = half;
		}
		
		n = nSave;
	}
	
	void getAnsMaybe ()
	{
		ans2 = BigInteger.ZERO;
		
		BigInteger first = BigInteger.ZERO;
		BigInteger step = BigInteger.ONE;
		BigInteger am = n;
		BigInteger pCur = p;
		
		while (am.compareTo(BigInteger.ONE) != 0)
		{
			BigInteger half = am.divide(BigInteger.valueOf(2) );
			
			if (pCur.compareTo(half) == -1)
			{
				step = step.multiply(BigInteger.valueOf(2) );
				am = am.divide(BigInteger.valueOf(2) );
				continue;
			}
			
			BigInteger prevLast = first.add(step.multiply(am.subtract(BigInteger.valueOf(2) ) ) );
			
			if (prevLast.compareTo(ans2) == 1)
				ans2 = prevLast;
			
			first = first.add(step.multiply(am.divide(BigInteger.valueOf(2) ) ) );
			pCur = pCur.subtract(am.divide(BigInteger.valueOf(2) ) );
			am = am.divide(BigInteger.valueOf(2) );
		}
		
		if (first.compareTo(ans2) == 1)
			ans2 = first;
	}
	
	void getAns ()
	{
		n = fPow(2, nInt);
		
		getAnsGuarantee();
		getAnsMaybe();
		
		out.print(ans1 + " " + ans2);
	}
	
	void solve() throws Exception
	{
		in = new Scanner(new File("input.txt"));
		out = new PrintWriter(new File("output.txt"));
		
		int test, t;

		test = in.nextInt();
		for (t = 0; t < test; t++)
		{
			if (t != 0)
				out.println();

			out.printf("Case #%d: ", t + 1);

			// input
			
			nInt = in.nextInt();
			p = in.nextBigInteger();

			// #input

			getAns();
		}
		
		out.flush();
	}
}