package round1b;

import java.io.*;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class P1 {
    private static final String inputFileName = "input/round1b/p1/A-large.in";
    //private static final String inputFileName = "input/round1b/p1/test.in";
    private static final String outputFileName = "answer.out";

    public static void main(String[] args) throws Exception {
        File inputFile = new File(inputFileName);
        Scanner scanner = new Scanner(inputFile);

        File outputFile = new File(outputFileName);
        outputFile.delete();
        outputFile.createNewFile();
        FileWriter fw = new FileWriter(outputFile);
        BufferedWriter bw = new BufferedWriter(fw);

        int numOfTestCases = scanner.nextInt();

        for (int i = 1; i <= numOfTestCases; i++) {
            int n = scanner.nextInt();

            List<List<Symbol>> strings = new ArrayList<List<Symbol>>(n);

            for (int j = 0; j < n; j++) {
                char[] charArray = scanner.next().toCharArray();
                List<Symbol> string = new ArrayList<Symbol>();
                strings.add(string);

                char c = charArray[0];
                int count = 1;
                for (int k = 1; k < charArray.length; k++) {
                    if (c != charArray[k]) {
                        string.add(new Symbol(count, c));
                        count = 0;
                        c = charArray[k];
                    }
                    count++;
                }
                string.add(new Symbol(count, c));
            }


            Problem problem = new Problem(strings);

            String testCase = "Case #" + i + ": " + problem.solve(n);
            bw.append(testCase + "\n");
            System.out.println(testCase);
        }

        bw.flush();
        fw.flush();

        bw.close();
        fw.close();
    }
}


class Problem {
    private List<List<Symbol>> strings;

    Problem(List<List<Symbol>> strings) {
        this.strings = strings;
    }

    public String solve(int n) {
        int length = strings.get(0).size();

        for (List<Symbol> string : strings) {
            if (string.size() != length) {
                return "Fegla Won";
            }
        }

        long step = 0;

        List<Symbol> firstString = strings.get(0);

        for (int i = 0; i < firstString.size(); i++) {
            Symbol symbol = firstString.get(i);
            for (List<Symbol> string : strings) {
                if (symbol.getC() != string.get(i).getC()) {
                    return "Fegla Won";
                }
            }
        }

        for (int i = 0; i < firstString.size(); i++) {
            Symbol symbol = firstString.get(i);
            long delta = 0;
            long sum = 0;
            List<Integer> counter = new ArrayList<Integer>(n);
            for (List<Symbol> string : strings) {
                int count = string.get(i).getCount();
                sum += count;
                counter.add(count);
            }

            long avg = Math.round((double)sum / (double)n);

            for (Integer integer : counter) {
                delta += Math.abs(avg - integer);
            }

            step += delta;
        }

        return String.valueOf(step);
    }
}


class Symbol {
    int count;
    char c;

    Symbol(int count, char c) {
        this.count = count;
        this.c = c;
    }

    public int getCount() {
        return count;
    }

    public void setCount(int count) {
        this.count = count;
    }

    public char getC() {
        return c;
    }

    public void setC(char c) {
        this.c = c;
    }
}
