package tictactoe;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class TicTacToe {

    public static void main(String[] args) throws FileNotFoundException, IOException {
        File f = new File("src/tictactoe/output.out");
        f.createNewFile();
        FileWriter fw = new FileWriter(f);
        BufferedWriter bw = new BufferedWriter(fw);

        Scanner sc = new Scanner(new File("src/tictactoe/A-small-attempt0.in"));
        int nCasos = Integer.parseInt(sc.nextLine());
        for (int i = 1; i <= nCasos; i++) {
            char[] tablero = new char[16];

            for (int j = 0; j < 16; j += 4) {
                String linea = sc.nextLine();

                if (linea.compareTo("") != 0) {
                    tablero[j] = linea.charAt(0);
                    tablero[j + 1] = linea.charAt(1);
                    tablero[j + 2] = linea.charAt(2);
                    tablero[j + 3] = linea.charAt(3);
                }
            }

            //Linea en blanco del final de cada tablero
            if (sc.hasNext()) {
                sc.nextLine();
            }

            bw.write("Case #" + i + ": " + calcular(tablero));
            bw.newLine();
        }

        bw.close();
    }

    public static String calcular(char[] tablero) {
        int[][] lineas = {
            {0, 1, 2, 3}, 
            {4, 5, 6, 7}, 
            {8, 9, 10, 11}, 
            {12, 13, 14, 15}, 
            
            {0, 4, 8, 12},
            {1, 5, 9, 13},
            {2, 6, 10, 14},
            {3, 7, 11, 15},
            
            {0, 5, 10, 15},
            {3, 6, 9, 12},
        };
        
        int xFichas;
        int oFichas;
        for(int i = 0; i < lineas.length; i++) {
            xFichas = 0;
            oFichas = 0;
            for(int j = 0; j < lineas[0].length;j++) {
                if(tablero[lineas[i][j]] == 'T' || tablero[lineas[i][j]] == 'X') {
                    xFichas++;
                }
                
                if(tablero[lineas[i][j]] == 'T' || tablero[lineas[i][j]] == 'O') {
                    oFichas++;
                }
            }
            
            if(xFichas == 4) {
                return "X won";
            }
            
            if(oFichas == 4) {
                return "O won";
            }
        }
        
        for (char i: tablero) {
            if(i == '.') {
                return "Game has not completed";
            }
        }

        return "Draw";
    }
}
