package cn.zhoushuyan.google.codejam;

import java.util.Iterator;

public class Watersheds extends InOutWindow {

	private Iterator<String> iterCase;

	private char ch;
	private int height;
	private int width;
	private int[][] map;
	private char[][] basins;

	public Watersheds() {
		super();
	}

	private char[][] getBasins() {
		ch = 'a';
		String str = iterCase.next();
		String[] strs = str.split(" ");
		height = Integer.valueOf(strs[0]);
		width = Integer.valueOf(strs[1]);
		map = new int[height][width];
		basins = new char[height][width];
		for (int i = 0; i < height; i++) {
			str = iterCase.next();
			strs = str.split(" ");
			for (int j = 0; j < width; j++) {
				map[i][j] = Integer.valueOf(strs[j]);
			}
		}

		for (int h = 0; h < height; h++) {
			for (int w = 0; w < width; w++) {
				findBasin(h, w);
			}
		}

		return basins;
	}

	private char findBasin(int h, int w) {
		if (basins[h][w] != 0)
			return basins[h][w];
		int lowest = map[h][w];
		int lowestH = h;
		int lowestW = w;
		boolean sink = true;
		int h1 = h - 1;
		int w1 = w;
		if (exist(h1, w1) && map[h1][w1] < lowest) {
			lowest = map[h1][w1];
			lowestH = h1;
			lowestW = w1;
			sink = false;
		}
		h1 = h;
		w1 = w - 1;
		if (exist(h1, w1) && map[h1][w1] < lowest) {
			lowest = map[h1][w1];
			lowestH = h1;
			lowestW = w1;
			sink = false;
		}
		h1 = h;
		w1 = w + 1;
		if (exist(h1, w1) && map[h1][w1] < lowest) {
			lowest = map[h1][w1];
			lowestH = h1;
			lowestW = w1;
			sink = false;
		}
		h1 = h + 1;
		w1 = w;
		if (exist(h1, w1) && map[h1][w1] < lowest) {
			lowest = map[h1][w1];
			lowestH = h1;
			lowestW = w1;
			sink = false;
		}
		if (sink) {
			basins[h][w] = ch++;
		} else {
			basins[h][w] = findBasin(lowestH, lowestW);
		}
		return basins[h][w];
	}

	private boolean exist(int h, int w) {
		if (h >= 0 && h < height && w >= 0 && w < width)
			return true;
		return false;
	}

	@Override
	protected String getResult() {
		iterCase = lstCase.iterator();
		int N = Integer.valueOf(iterCase.next());
		String result = "";
		for (int i = 0; i < N; i++) {
			getBasins();
			result += "Case #" + (i + 1) + ":" + NEW_LINE;
			for (int h = 0; h < height; h++) {
				for (int w = 0; w < width; w++) {
					result += basins[h][w] + " ";
				}
				result += NEW_LINE;
			}
		}
		return result;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Watersheds();

	}

}
