package cn.zhoushuyan.google.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.jface.dialogs.MessageDialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

abstract public class InOutWindow {

	final protected String NEW_LINE = "\r\n";

	private Shell sShell = null; // @jve:decl-index=0:visual-constraint="82,41"
	private Text txtIn = null;
	private Button btnIn = null;
	private Label lblIn = null;
	private Label lblOut = null;
	private Text txtOut = null;
	private Button btnOut = null;
	private Button btnRun = null;

	protected List<String> lstCase = new ArrayList<String>(); // @jve:decl-index=0:

	public InOutWindow() {
		createSShell();
	}

	/**
	 * This method initializes sShell
	 */
	private void createSShell() {
		GridLayout gridLayout = new GridLayout();
		gridLayout.numColumns = 3;
		GridData gd = new GridData(GridData.FILL_HORIZONTAL);
		sShell = new Shell();
		sShell.setText("Shell");
		sShell.setLayout(gridLayout);
		sShell.setSize(new Point(400, 120));
		lblIn = new Label(sShell, SWT.NONE);
		lblIn.setText("Input File :");
		txtIn = new Text(sShell, SWT.BORDER);
		txtIn.setLayoutData(gd);
		btnIn = new Button(sShell, SWT.NONE);
		btnIn.setText("Browser");
		btnIn.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent arg0) {
				FileDialog fd = new FileDialog(sShell);
				txtIn.setText(fd.open());
				// fill txtOut
				String outFile;
				String inFile = txtIn.getText();
				int lastPoint = inFile.lastIndexOf('.');
				if (lastPoint != -1) {
					outFile = inFile.substring(0, lastPoint) + ".out";
				} else {
					outFile = inFile + ".out";
				}
				txtOut.setText(outFile);
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent arg0) {
				// TODO Auto-generated method stub

			}
		});
		lblOut = new Label(sShell, SWT.NONE);
		lblOut.setText("Output File :");
		txtOut = new Text(sShell, SWT.BORDER);
		txtOut.setLayoutData(gd);
		btnOut = new Button(sShell, SWT.NONE);
		btnOut.setText("Browser");
		btnOut.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent arg0) {
				FileDialog fd = new FileDialog(sShell);
				txtOut.setText(fd.open());
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent arg0) {
				// TODO Auto-generated method stub

			}
		});
		@SuppressWarnings("unused")
		Label filler = new Label(sShell, SWT.NONE);
		@SuppressWarnings("unused")
		Label filler1 = new Label(sShell, SWT.NONE);
		btnRun = new Button(sShell, SWT.NONE);
		btnRun.setText("Run");
		btnRun.setLayoutData(new GridData(GridData.HORIZONTAL_ALIGN_FILL));
		btnRun.addSelectionListener(new SelectionListener() {

			@Override
			public void widgetSelected(SelectionEvent arg0) {
				run();
			}

			@Override
			public void widgetDefaultSelected(SelectionEvent arg0) {
				// TODO Auto-generated method stub

			}
		});
		sShell.open();

		while (!sShell.isDisposed()) {
			Display d = sShell.getDisplay();
			if (d.readAndDispatch()) {
				d.sleep();
			}
		}
	}

	public void run() {
		try {
			// input
			BufferedReader br = new BufferedReader(new FileReader(txtIn
					.getText()));
			String temp;
			while ((temp = br.readLine()) != null) {
				lstCase.add(temp);
			}

			// solve & getResult
			String result = getResult();

			// output
			File fileOut = new File(txtOut.getText());
			if (fileOut.exists())
				fileOut.delete();
			fileOut.createNewFile();
			PrintWriter pw = new PrintWriter(fileOut);
			pw.print(result);
			pw.flush();
			pw.close();

			MessageDialog.openInformation(sShell, "Run Successful", txtOut
					.getText()
					+ " Generated");
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	abstract protected String getResult();
}
