import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;


public class Main {
	
	public static Scanner in;
	public static PrintWriter out;
	
	public static int MINE = -1;
	public static int CLICK = -2;
	public static int OPEN = 0;
	public static int VISITED = -3;
	
	public static int numOpen = 0;
	public static int numClickable = 0;
	
	public static void main(String[] args) throws FileNotFoundException {
		boolean sample = false;
		String input = "C-small-attempt4.in";
		String output = "C-small-output4.txt";
		if(sample){
			input = "sample.in";
			output = "sample.out";
		}
		
		in = new Scanner(new File(input));
		out  = new PrintWriter(new File(output));
		
		int t = in.nextInt();
		for(int c = 1; c <= t; c++){
			solve(c);
		}
		
		
		in.close();
		out.close();
	}
	
	
	public static void solve(int t){
		int r = in.nextInt();
		int c = in.nextInt();
		int m = in.nextInt();
		
		
		int [][] overallBoard = new int[r][c];
		
		// int borders = 0;
		
		int border = 0;
		while(2  * r + 2 * (c-2) <= m && r > 4 && c > 4){
			m -= 2  * r + 2 * (c-2);
			r -=2;
			c -= 2;
			
			for(int i = 0; i < overallBoard.length; i++){
				for(int j = 0; j < overallBoard[i].length; j++){
					if(i == border || j == border || 
							i == overallBoard[i].length - 1 - border ||
							j == overallBoard[i].length - 1 - border){
						placeMine(overallBoard, i, j);
						//overallBoard[i][j] = MINE;
					}
				}
			}
			border++;
			//borders++;
		}
		
		//printBoard(overallBoard);
		//System.out.println();
		
		int row = border;
		int col = border;
		
		while( (c > 3 || r > 3) && (m >= r || m >= c)){
			if(c >= r && m >= r){
				m -= r;
				c--;
				for(int i = row; i < overallBoard.length - border; i++){
					placeMine(overallBoard,i, col);
					//overallBoard[i][col] = MINE;
				}
				col++;
				//printBoard(overallBoard);
				//System.out.println();
			}
			else if(m >= c){
				m -= c;
				r--;
				
				for(int i = col; i < overallBoard[row].length - border; i++){
					placeMine(overallBoard,row, i);
					//overallBoard[row][i] = MINE;
				}
				row++;
				//printBoard(overallBoard);
				//System.out.println();
			}
		}
		
		
		
		
		
		int [][] board = new int [r][c];
		for(int i = 0; i < board.length; i++){
			for(int j = 0; j < board[i].length;  j++){
				board[i][j] = overallBoard[row + i][col + j];
			}
		}
		
		//printBoard(board);
		//System.out.println();
		
		
		
		
		
		/*placeMine(board, 0, 0);
		placeMine(board, 1, 0);
		placeMine(board, 1, 1);*/
		//printBoard(board);
		
		//System.out.println();
		
		boolean ok = placeMines(board, m);
		System.out.printf("Case #%d:\n", t);
		out.printf("Case #%d:\n", t);
		if(!ok){
			System.out.println("Impossible");
			out.println("Impossible");
		}
		else{
			
			for(int i = 0; i < board.length; i++){
				for(int j = 0; j < board[i].length; j++){
					overallBoard[row + i][col + j] = board[i][j];
				}
			}

			isBoardValid(board, false);
			printSolution(overallBoard);
			
			
			
			
		}
	}
	
	public static boolean placeMines(int [][] board, int m){
		
		//printBoard(board);
		//System.out.println();
		
		if(m <= 0){
			if(isBoardValid(board, false)){
				return true;
			}else{
				return false;
			}
		}
		
		/*if(isBoardValid(board, false)){
			if(m <= 0){
				
				
				return true;
			}
		}
		else{
			return false;
		}*/
		
		
		boolean done = false;
		for(int i = 0; i < board.length && !done; i++){
			for(int j = 0; j < board[i].length && !done; j++){
				if(board[i][j] >= OPEN){
					int prev = board[i][j];
					placeMine(board, i, j);
					
					done = placeMines(board, m -1);
					
					if(!done)
						removeMine(board, i, j, prev);
				}
			}
		}
		
		return done;
	}
	
	/**
	 * Adds a mine to board[x][y] and updates adjacent tiles.
	 * @param board
	 * @param x
	 * @param y
	 */
	public static void placeMine(int [][] board, int x, int y){
		board[x][y] = MINE;
		
		for(int i = x -1; i <= x+1; i++){
			for(int j = y -1; j <= y+1; j++){
				if((i != x || j != y) && inBounds(board, i, j)){
					if(board[i][j] >= 0){
						board[i][j]++;
					}
				}
			}
		}
	}
	
	/**
	 * Removes a mine from board[x][y] and updates nearby tiles
	 * @param board
	 * @param x
	 * @param y
	 * @param prev : Previous value to restore the mine spot to.
	 */
	public static void removeMine(int [][] board, int x, int y, int prev){
		board[x][y] = prev;
		
		for(int i = x -1; i <= x+1; i++){
			for(int j = y -1; j <= y+1; j++){
				if((i != x || j != y) && inBounds(board, i, j)){
					if(board[i][j] > 0){
						board[i][j]--;
					}
				}
			}
		}
	}
	
	public static int[][] copyBoard(int [][] board){
		int [][] b = new int [board.length][board[0].length];
		for(int i = 0; i < board.length; i++){
			for(int j = 0; j < board[i].length; j++){
				b[i][j] = board[i][j];
			}
		}
		return b;
	}
	
	public static boolean isBoardValid(int [][] board, boolean print){
		
		int [][] b = copyBoard(board);
		numOpen = 0;
		numClickable = 0;
		
		for(int i = 0; i < b.length; i++){
			for(int j = 0; j < b[i].length; j++){
				if(b[i][j] == OPEN){
					numOpen++;
				}
				if(b[i][j] >= OPEN){
					numClickable++;
				}
			}
		}
		
		
		
		boolean clicked = false;
		for(int i = 0; i < b.length && !clicked; i++){
			for(int j = 0; j < b[i].length && !clicked; j++){
				if(b[i][j] == OPEN){
					click(b, i, j);
					clicked = true;
				}
			}
		}
		
		//printBoard(b);
		
		if(numOpen == 0 && numClickable == 1){
			return true;
		}
		else if(!clicked)
			return false;
		else
		{
			for(int i = 0; i < b.length; i++){
				for(int j = 0; j < b[i].length; j++){
					if(b[i][j] >= OPEN)
						return false;
				}
			}
		}
		
		if(print)
			printBoard(b);
		return true;
	}
	
	public static void printBoard(int [][] board){
		for(int i = 0; i < board.length; i++){
			for(int j = 0; j < board[i].length; j++){
				if(board[i][j] > 0){
					System.out.print(board[i][j]);
				}
				else if(board[i][j] == OPEN){
					System.out.print(".");
				}
				else if(board[i][j] == MINE){
					System.out.print("*");
				}
				else{
					System.out.print("!");
				}
			}
			System.out.println();
		}
	}
	
	public static void printSolution(int [][] board){
		
		boolean printedClick = false;
		for(int i = 0; i < board.length; i++){
			for(int j = 0; j < board[i].length; j++){
				if(board[i][j] == OPEN && !printedClick){
					printedClick = true;
					System.out.print('c');
					out.print('c');
				}
				else if(board[i][j] >= OPEN){
					
					if(numOpen == 0 && numClickable == 1){
						System.out.print("c");
						out.print("c");
					}
					else{
					
						System.out.print(".");
						out.print(".");
					}
				}
				else if(board[i][j] == MINE){
					System.out.print("*");
					out.print("*");
				}
				else{
					System.out.print("!");
					out.print("!");
				}
			}
			System.out.println();
			out.println();
		}
	}
	
	public static void click(int [][] board, int x, int y){
		if(board[x][y] < OPEN){
			return;
		}
		
		if(board[x][y] > OPEN){
			
			//Mark as visited but can't go farther.
			board[x][y] = VISITED;
			return;
		}
		
		board[x][y] = VISITED;
		
		
		for(int i = x -1; i <= x+1; i++){
			for(int j = y -1; j <= y+1; j++){
				if((i != x || j != y) && inBounds(board, i, j)){
					click(board, i, j);
				}
			}
		}
		
	}
	
	
	/**
	 * True is board[x][y] is in bounds
	 * 
	 * @param board
	 * @param x
	 * @param y
	 * @return
	 */
	public static boolean inBounds(int [][]board, int x, int y){
		return x >= 0 && x < board.length && y >= 0 && y < board[x].length;
	}
	
	
	/**
	 * Returns true if board[x][y] can be discovered from one cick.
	 * @param board
	 * @param x
	 * @param y
	 * @return
	 */
	public static boolean canDiscover(int [][] board, int x, int y){
		for(int i = x -1; i <= x+1; i++){
			for(int j = y -1; j <= y+1; j++){
				if((i != x || j != y) && inBounds(board, i, j)){
					if(board[i][j] == OPEN){
						return true;
					}
				}
			}
		}
		return false;
	}
}
