import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class CoinJam 
{
    static ArrayList<Integer>primos;
    
    public static void main(String [] args) throws IOException 
    {
        BufferedReader br = new BufferedReader(new FileReader("input.txt"));
        PrintWriter pw = new PrintWriter(new FileOutputStream("output.txt"));
        
        int UNO = Integer.parseInt("1", 2);
        generarPrimos();
        
        int t = Integer.parseInt(br.readLine());
        for(int i = 1; i<=t; i++)
        {
            pw.println("Case #"+i+":");
            
            StringTokenizer st = new StringTokenizer(br.readLine());
            int n = Integer.parseInt(st.nextToken());
            int j = Integer.parseInt(st.nextToken());
            String nro = generarN(n);
            int k = 0;
            while(k<j)
            {
                String moneda = nro+"1";
                StringBuilder sb = new StringBuilder(" ");
                boolean posible = true;
                for(int d = 2; d<=10 && posible; d++)
                {
                    long nb = convertir(moneda, d);
                    String div = divisor(nb);
                    if(!div.equals("-1"))
                        sb.append(" ").append(div);
                    else
                        posible = false;
                }
                if(posible)
                {
                    pw.println(moneda+sb.toString());
                    k++;
                }
                long tmp = Long.parseLong(nro, 2);
                tmp = tmp+UNO;
                nro = Long.toBinaryString(tmp);
            }
 
        }
 
        pw.flush();
    }
    private static String generarN(int n)
    {
        String ans = "1";
        for(int i = 2; i<n; i++)
            ans += "0";
        return ans;
    }
    private static long  convertir(String s, int d)
    {
        long res = 0;
        int j = 0;
        for(int i = s.length()-1; i>=0; i--)
        {
            char c = s.charAt(i);
            if(c == '1')
                res += (Math.pow(d, j));
            j++;
            
        }
        return res;
    }

    private static String divisor(long n) 
    {
        String res = "-1";
        int i = 0;
        
        while(i<primos.size())
        {
            int v = primos.get(i);
            if(v > Math.sqrt(n))
                break;
            if(n % v == 0)
            {
                res = v+"";
                break;
            }
            i++;
            
        }
        return res;
        
    }
    private static void generarPrimos()
    {
        primos = new ArrayList<Integer>();
        
        int n = 100000000;
        boolean [] prim = new boolean[n+1];
        for (int p=2; p*p<=n; p++)
        {
            if (!prim[p])
            {
                primos.add(p);
                for (int i=p*2; i<=n; i += p)
                    prim[i] = true;
            }
        }
        }
}
