package qualification17;

import java.io.*;
import java.util.Scanner;

/**
 * Created by Alexander Schiewe on 08.04.2017.
 */
public class Stalls {

    public static void main(String[] args) throws IOException {
        String dataset = "small";
        String attempt = "0";
        String test = "1";
        Scanner in = new Scanner(new BufferedReader(new FileReader("data/qualification17/C-" + dataset + "-" + test + "-attempt" + attempt + ".in")));
        BufferedWriter writer = new BufferedWriter(new FileWriter("data/qualification17/C-" + dataset + "-" + test + "-attempt" + attempt + ".out"));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            int N = in.nextInt();
            int K = in.nextInt();
            Pair<Integer, Integer> solution = getSolution(N, K);
            writer.write("Case #" + i + ": " + solution.getValue() + " " + solution.getKey() + "\n");
            System.out.println("Case #" + i + ": " + solution.getValue() + " " + solution.getKey());
        }
        writer.close();
        in.close();
    }

    private static Pair<Integer, Integer> getSolution(int numberOfStalls, int numberOfGuests){
        boolean[] occupied = new boolean[numberOfStalls+2];
        occupied[0] = true;
        occupied[numberOfStalls+1] = true;
        for(int guest = 0; guest < numberOfGuests - 1; guest++){
            getMinMaxOfGuest(occupied);
        }
        return getMinMaxOfGuest(occupied);
    }

    private static Pair<Integer, Integer> getMinMaxOfGuest(boolean[] occupied){
        int[] bestSolution = new int[3];
        for(int stall = 0; stall < occupied.length; stall++){
            if(occupied[stall]){
                continue;
            }
            int maxMinDistance = computeMaxMinDistance(occupied, stall);
            if(bestSolution[1] < maxMinDistance){
                int maxMaxDistance = computeMaxMaxDistance(occupied, stall);
                bestSolution[0] = stall;
                bestSolution[1] = maxMinDistance;
                bestSolution[2] = maxMaxDistance;
            }
            if(bestSolution[1] == maxMinDistance){
                int maxMaxDistance = computeMaxMaxDistance(occupied, stall);
                if(maxMaxDistance > bestSolution[2]){
                    bestSolution[0] = stall;
                    bestSolution[1] = maxMinDistance;
                    bestSolution[2] = maxMaxDistance;
                }
            }
        }
        occupied[bestSolution[0]] = true;
        return new Pair<>(bestSolution[1], bestSolution[2]);
    }

    private static int computeMaxMinDistance(boolean[] occupied, int startIndex){
        int maxMinDistance = 0;
        for(int i = 1; i < occupied.length; i++){
            if(occupied[startIndex + i] || occupied[startIndex - i]){
                break;
            }
            maxMinDistance++;
        }
        return maxMinDistance;
    }

    private static int computeMaxMaxDistance(boolean[] occupied, int startIndex){
        int maxMaxDistance = 0;
        boolean foundLeft = false;
        boolean foundRight = false;
        for(int i = 1; i < occupied.length; i++){
            //Check to left
            foundLeft = foundLeft || occupied[startIndex - i];
            foundRight = foundRight || occupied[startIndex + i];
            if(foundLeft && foundRight){
                break;
            }
            maxMaxDistance++;
        }
        return maxMaxDistance;
    }

    private static class Pair<K,V>{
        K key;
        V value;
        public Pair(K key, V value){
            this.key = key;
            this.value = value;
        }
        public K getKey(){
            return key;
        }
        public V getValue(){
            return value;
        }
    }
}
