package round_1_2017;

import java.io.*;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * Created by Alexander Schiewe on 22.04.2017.
 */
public class CruiseControl {
    public static void main(String[] args) throws IOException {
        String dataset = "large";
        String attempt = "";
        Scanner in = new Scanner(new BufferedReader(new FileReader("data/round_1_2017/A-" + dataset + "" + attempt + ".in")));
        BufferedWriter writer = new BufferedWriter(new FileWriter("data/round_1_2017/A-" + dataset + "" + attempt + ".out"));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            int destination = in.nextInt();
            int numberOfHorses = in.nextInt();
            ArrayList<Pair<Integer, Integer>> horseList = new ArrayList<>(numberOfHorses);
            for(int horse = 1; horse <= numberOfHorses; horse++){
                int position = in.nextInt();
                int speed = in.nextInt();
                horseList.add(new Pair<>(position, speed));
            }
            double maxSpeed = findMaxSpeed(horseList, destination);
            writer.write("Case #" + i + ": " + maxSpeed + "\n");
            System.out.println("Case #" + i + ": " + maxSpeed);
        }
        writer.close();
        in.close();
    }

    private static double findMaxSpeed(ArrayList<Pair<Integer, Integer>> horseList, int destination){
        //Compute for each horse the arrival time
        double lowestSpeed = Double.MAX_VALUE;
        for(Pair<Integer, Integer> horse : horseList){
            int distance = destination - horse.getKey();
            double time = destination * (double) horse.getValue();
            double possibleSpeed = time / distance;
            if(lowestSpeed > possibleSpeed){
                lowestSpeed = possibleSpeed;
            }
        }
        return lowestSpeed;
    }


}
