package qualification17;

import java.io.*;
import java.math.BigInteger;
import java.util.IllegalFormatException;
import java.util.Scanner;

/**
 * Created by Alexander Schiewe on 08.04.2017.
 */
public class TidyNumbers {
    public static void main(String[] args) throws IOException {
        String dataset = "small";
        String attempt = "0";
        Scanner in = new Scanner(new BufferedReader(new FileReader("data/qualification17/B-" + dataset + "-attempt" + attempt + ".in")));
        BufferedWriter writer = new BufferedWriter(new FileWriter("data/qualification17/B-" + dataset + "-attempt" + attempt + ".out"));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            String input = in.next();
            BigInteger n = new BigInteger(input);
            BigInteger solution = getBiggestTidyNumber(n);
            writer.write("Case #" + i + ": " + solution + "\n");
            System.out.println("Case #" + i + ": " + solution);
        }
        writer.close();
        in.close();
    }

    private static BigInteger getBiggestTidyNumber(BigInteger limit){
        for(BigInteger i = limit; i.compareTo(BigInteger.ZERO) > 0; i = i.subtract(BigInteger.ONE)){
            if(isTidy(i)){
                return i;
            }
        }
        throw new IllegalArgumentException("Found no tidy number!");
    }

    private static boolean isTidy(BigInteger n){
        boolean isTidy = true;
        n.getLowestSetBit();
        int lastNumber = n.mod(BigInteger.TEN).intValue();
        n  = n.divide(BigInteger.TEN);
        while (n.compareTo(BigInteger.ZERO) > 0){
            int newLastNumber =n.mod(BigInteger.TEN).intValue();
            if(newLastNumber > lastNumber){
                return false;
            }
            lastNumber = newLastNumber;
            n = n.divide(BigInteger.TEN);
        }
        return true;
    }
}
