package qualification17;

import java.io.*;
import java.util.Scanner;

/**
 * Created by Alexander Schiewe on 08.04.2017.
 */
public class Pancakes {
    public static void main(String[] args) throws IOException {
        String dataset = "small";
        Scanner in = new Scanner(new BufferedReader(new FileReader("data/qualification17/A-" + dataset + "-qualification.in")));
        BufferedWriter writer = new BufferedWriter(new FileWriter("data/qualification17/A-" + dataset + "-qualification.out"));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            String input = in.next();
            int K = in.nextInt();
            writer.write("Case #" + i + ": " + minimalNumberOfFlips(input, K) + "\n");
            System.out.println("Case #" + i + ": " + minimalNumberOfFlips(input, K));
        }
        writer.close();
        in.close();
    }

    private static String minimalNumberOfFlips(String input, int K){
        boolean[] pancakes = new boolean[input.length()];
        boolean everythingTrue = true;
        for(int i = 0; i < input.length(); i++){
            pancakes[i] = input.charAt(i) == '+';
            everythingTrue &= pancakes[i];
        }
        if(everythingTrue){
            return "0";
        }
        int numberOfFlips = 0;
        for(int i = 0; i <= pancakes.length - K; i++){
            if(!pancakes[i]){
                //System.out.println("Flip at " + i);
                flipKPancakes(pancakes, i, K);
                //printPancakes(pancakes);
                numberOfFlips++;
            }
        }
        return everythingTrue(pancakes) ? String.valueOf(numberOfFlips) : "IMPOSSIBLE";
    }

    private static void flipKPancakes(boolean[] pancakes, int startIndex, int K){
        if(startIndex + K > pancakes.length){
            throw new IllegalArgumentException("Index out of bound!");
        }
        for(int i = startIndex; i < startIndex + K; i++){
            pancakes[i] = !pancakes[i];
        }
    }

    private static boolean everythingTrue(boolean[] pancakes){
        for (boolean pancake : pancakes){
            if(!pancake){
                return false;
            }
        }
        return true;
    }

    private static void printPancakes(boolean[] pancakes){
        for(boolean pancake : pancakes){
            System.out.print(pancake ? "+" : "-");
        }
        System.out.println();
    }


}
