import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Scanner;


public class AlphabetCake
{
	public static void main(String[] args) {
	    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  // num test cases
	    for (int i = 1; i <= t; ++i) {
	      int r = in.nextInt(); // read whatever
	      int c = in.nextInt(); // read whatever
	      char cake[][] = new char[r][c];
	      for (int j = 0; j < r; j++)
	      {
	    	  String row = in.next();
	    	  for (int k = 0; k < c; k++)
	    	  {
	    		  cake[j][k] = row.charAt(k);
	    	  }
	      }
	      System.out.println("Case #" + i + ": " + getOutput(cake, r, c));
	    }
	}
	
	public static String getOutput(char[][] cake, int r, int c) {
		char[][] finalCake = getCake(cake, r, c);
		String out = "";
		for (int i = 0; i < r; i++) {
			out += "\n";
			for (int j = 0; j < c; j++) {
				out += finalCake[i][j];
			}
		}
		return out;
	}
	
	public static char[][] getCake(char[][] cake, int r, int c) {
		HashSet<Character> seen = new HashSet<Character>();
		seen.add('?');
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				Character curr = cake[i][j];
				if(!seen.contains(curr)) {
					seen.add(curr);
					
					int leftBound = j;
					int rightBound = j;
					int topBound = i;
					int bottomBound = i;
					
					// push left
					for (leftBound--; leftBound >= 0; leftBound--) {
						if (cake[i][leftBound] != '?') {
							break;
						}
						cake[i][leftBound] = curr;
					}
					leftBound++;
					
					// push right
					for (rightBound++; rightBound < c; rightBound++) {
						if (cake[i][rightBound] != '?') {
							break;
						}
						cake[i][rightBound] = curr;
					}
					rightBound--;

					
					// push top
					for (topBound--; topBound >= 0; topBound--) {
						boolean canPush = true;
						for (int k = leftBound; k <= rightBound; k++) {
							if (cake[topBound][k] != '?')
								canPush = false;
						}
						if (!canPush) {
							break;
						}
						for (int k = leftBound; k <= rightBound; k++) {
							cake[topBound][k] = curr;
						}
					}
					topBound++;

					// push bottom
					for (bottomBound++; bottomBound < r; bottomBound++) {
						boolean canPush = true;
						for (int k = leftBound; k <= rightBound; k++) {
							if (cake[bottomBound][k] != '?')
								canPush = false;
						}
						if (!canPush) {
							break;
						}
						for (int k = leftBound; k <= rightBound; k++) {
							cake[bottomBound][k] = curr;
						}
					}
					bottomBound--;

					
				}
				
			}
		}
		
		
		
		
		return cake;
	}

}
