import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.Scanner;
import java.util.LinkedList;


public class OversizedPancakeFlipper
{
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();  // num test cases
		for (int i = 1; i <= t; ++i) {
			// read line
			String s = in.next(); 
			int k = in.nextInt();
			System.out.println("Case #" + i + ": " + getOutput(s, k));
		}
	}

	// O(n) solution!!!
	public static String getOutput(String s, int k) {
		int numFlips = 0;
		boolean wasFlipped = false;
		LinkedList<Boolean> nextK = new LinkedList<>();
		for (char c : s.substring(0, k).toCharArray()) {
			nextK.addLast((c == '+' ? true : false));
		}
		
		for (int i = k;; i++) {
			boolean head = nextK.removeFirst();
			if ((!head && !wasFlipped) || (head && wasFlipped)) { // not happy
				wasFlipped = !wasFlipped; // flip
				numFlips++;
			}
			// else already happy, don't have to flip
			
			if(i == s.length())
				break;
			
			if (wasFlipped)
				nextK.addLast(!(s.charAt(i) == '+' ? true : false));
			else
				nextK.addLast((s.charAt(i) == '+' ? true : false));
		}
		
		// check if all left are happy (can't flip them!)
		while (!nextK.isEmpty()) {
			boolean head = nextK.removeFirst();
			if ((!head && !wasFlipped) || (head && wasFlipped)) { // not happy
				return "IMPOSSIBLE";
			}
		}		
		
		return "" + numFlips;
	}


}