import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Scanner;


public class Ratatouille
{
	public static void main(String[] args) {
	    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  // num test cases
	    for (int i = 1; i <= t; ++i) {
	      int n = in.nextInt(); // read whatever
	      int p = in.nextInt(); // read whatever
	      ArrayList<LinkedList<Integer>> packetArray = new ArrayList<>(n);
	      int[] ingredientQuantities = new int[n];
	      for (int j = 0; j < n; j++) {
	    	  ingredientQuantities[j] = in.nextInt();
	    	  packetArray.add(new LinkedList<>());
	      }
	      
	      for (int j = 0; j < n; j++)
	      {
	    	  for (int k = 0; k < p; k++)
	    	  {
	    		  packetArray.get(j).add(in.nextInt());
	    	  }
	      }
	      System.out.println("Case #" + i + ": " + getOutput(packetArray, ingredientQuantities, n, p));
	    }
	}
	
	public static String getOutput(ArrayList<LinkedList<Integer>> pack, int[] quant, int n, int p) {
		int kits = 0;
		
		ArrayList<Iterator<Integer>> iters = new ArrayList<>(n);
		ArrayList<Integer> curr = new ArrayList<>(n);
		for (int i = 0; i < n; i++) {
			pack.get(i).sort(null);
			iters.add(pack.get(i).iterator());
			curr.add(iters.get(i).next());
		}
		
		
		
		while(true) {
			for (int i = 0; i < n; i++) {
				if (curr.get(i) == null) {
					if (iters.get(i).hasNext()) {
						curr.set(i, iters.get(i).next());
					} else {
						return "" + kits;
					}
				}
			}
			
			// all curr have values
			int servings = Integer.MAX_VALUE;
			for (int i = 0; i < n; i++) {
				int currServings = curr.get(i) / quant[i];
				servings = Math.min(servings, currServings);
			}
			
			boolean shouldContinue = true;
			while (shouldContinue) {
				boolean found = true;
				for (int i = 0; i < n; i++) {
					int minNeed = (int) Math.ceil(((servings * quant[i]) * .9));
					int maxNeed = (int) Math.floor(((servings * quant[i]) * 1.1));
					if (curr.get(i) < minNeed) {
						shouldContinue = false;
						found = false;
						curr.set(i, null);
						break;
					}
					if (curr.get(i) > maxNeed) {
						servings++;
						found = false;
						break;
					}
				}
				if (found) {
					for (int i = 0; i < n; i++) {
						curr.set(i, null);
					}
					kits++;
					shouldContinue = false;
				}
			}
			
		}

	}
}
