import java.util.*;
import java.io.*;
import java.util.stream.IntStream;

public class C {
    FastScanner in;
    PrintWriter out;

    public void solveTest() throws IOException {
        int n = in.nextInt();
        int k = in.nextInt();
        if (n == k) {
            double u = in.nextDouble();
            double[] p = new double[n];
            Arrays.setAll(p, i -> in.nextDouble());
            double all = Arrays.stream(p).sum() + u;
            Arrays.sort(p);
            double ans = 1;
            for (int i = p.length - 1; i >= 0; --i) {
                if (p[i] * (i + 1) <= all) {
                    double avg = all / (i + 1);
                    for (int j = 0; j < i + 1; j++) {
                        ans *= avg;
                    }
                    break;
                } else {
                    ans *= p[i];
                    all -= p[i];
                }
            }
            out.println(ans);
        } else {
            in.nextDouble();
            System.out.println(IntStream.range(0, n).mapToDouble(i-> in.nextDouble()).sum());
            out.println(-1);
        }
    }

    public void solve() throws IOException {
        int tests = in.nextInt();
        for (int test = 1; test <= tests; test++) {
            out.print("Case #" + test + ": ");
            System.out.println("test " + test);
            long start = System.currentTimeMillis();
            solveTest();
            System.out.println("passed in " + (System.currentTimeMillis() - start) + " ms");
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("C-small-1-attempt0.in"));
            out = new PrintWriter(new File("C-small-1-attempt0.out"));
            Locale.setDefault(Locale.US);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        int nextPointInt() {
            return Integer.parseInt(next().replace(".", ""));
        }

        double nextDouble() {
            return Double.parseDouble(in.next());
        }
    }

    public static void main(String[] arg) {
        new C().run();
    }
}