import java.util.*;
import java.io.*;

public class B {
    FastScanner in;
    PrintWriter out;

    double calc(double[] a) {
        double[][] d = new double[a.length + 1][a.length + 1];
        d[0][0] = 1;
        for (int i = 1; i <= a.length; i++) {
            for (int j = 0; j <= a.length; j++) {
                d[i][j] += (1 - a[i - 1]) * d[i - 1][j];
                if (j > 0) {
                    d[i][j] += a[i - 1] * d[i - 1][j - 1];
                }
            }
        }
        return d[a.length][a.length / 2];
    }

    public void solveTest() throws IOException {
        int n = in.nextInt();
        int k = in.nextInt();
        double[] p = new double[n];
        Arrays.setAll(p, i -> in.nextDouble());
        double ans = 0;
        for (int mask = 0; mask < (1 << n); mask++) {
            if (Integer.bitCount(mask) == k) {
                double[] a = new double[k];
                int cur = 0;
                for (int i = 0; i < n; i++) {
                    if ((mask & (1 << i)) != 0) {
                        a[cur++] = p[i];
                    }
                }
                ans = Math.max(calc(a), ans);
            }
        }
        out.println(ans);
    }

    public void solve() throws IOException {
        int tests = in.nextInt();
        for (int test = 1; test <= tests; test++) {
            out.print("Case #" + test + ": ");
            System.out.println("test " + test);
            long start = System.currentTimeMillis();
            solveTest();
            System.out.println("passed in " + (System.currentTimeMillis() - start) + " ms");
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("B-small-attempt0.in"));
            out = new PrintWriter(new File("B-small-attempt0.out"));
            Locale.setDefault(Locale.US);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        double nextDouble() { return Double.parseDouble(next()); }
    }

    public static void main(String[] arg) {
        new B().run();
    }
}