import java.util.*;
import java.io.*;

public class B {
    FastScanner in;
    PrintWriter out;

    class Seg implements Comparable<Seg> {
        int start, finish, tp;

        public Seg(int start, int finish, int tp) {
            this.start = start;
            this.finish = finish;
            this.tp = tp;
        }

        int time() {
            return finish - start;
        }

        @Override
        public int compareTo(Seg o) {
            return Integer.compare(start, o.start);
        }

        @Override
        public String toString() {
            return String.format("(%d,%d,%d)", start, finish, tp);
        }
    }

    public void solveTest() throws IOException {
        int n = in.nextInt();
        int m = in.nextInt();
        List<Seg> list = new ArrayList<>();
        int sum0 = 0;
        int sum1 = 0;
        for (int i = 0; i < n; i++) {
            final Seg seg = new Seg(in.nextInt(), in.nextInt(), 0);
            list.add(seg);
            sum0 += seg.time();
        }
        for (int i = 0; i < m; i++) {
            final Seg seg = new Seg(in.nextInt(), in.nextInt(), 1);
            list.add(seg);
            sum1 += seg.time();
        }
        sum0 = 12 * 60 - sum0;
        sum1 = 12 * 60 - sum1;
        Collections.sort(list);
        List<Integer> spl0 = new ArrayList<>();
        List<Integer> spl1 = new ArrayList<>();
        int good = 0;
        for (int i = 0; i < n + m - 1; i++) {
            Seg seg1 = list.get(i);
            Seg seg2 = list.get(i + 1);
            if (seg1.tp == seg2.tp) {
                if (seg1.tp == 0) {
                    spl0.add(seg2.start - seg1.finish);
                } else {
                    spl1.add(seg2.start - seg1.finish);
                }
            } else {
                good++;
            }
        }
        if (list.get(0).tp == list.get(list.size() - 1).tp) {
            final int border = list.get(0).start + 24 * 60 - list.get(list.size() - 1).finish;
            if (list.get(0).tp == 0) {
                spl0.add(border);
            } else {
                spl1.add(border);
            }
        } else {
            good++;
        }

        Collections.sort(spl0);
        Collections.sort(spl1);
        int s0 = 0, s1 = 0;
        int ans0 = spl0.size();
        for (int i = 0; i < spl0.size(); i++) {
            s0 += spl0.get(i);
            if (s0 > sum0) {
                ans0 = i;
                break;
            }
        }
        int ans1 = spl1.size();
        for (int i = 0; i < spl1.size(); i++) {
            s1 += spl1.get(i);
            if (s1 > sum1) {
                ans1 = i;
                break;
            }
        }
        out.println(good + (list.size() - good - ans0 - ans1) * 2);
    }

    public void solve() throws IOException {
        int tests = in.nextInt();
        for (int test = 1; test <= tests; test++) {
            out.print("Case #" + test + ": ");
            System.out.println("test " + test);
            long start = System.currentTimeMillis();
            solveTest();
            System.out.println("passed in " + (System.currentTimeMillis() - start) + " ms");
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("B-large.in"));
            out = new PrintWriter(new File("B-large.out"));
            Locale.setDefault(Locale.US);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new B().run();
    }
}