import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

public class D {
    FastScanner in;
    PrintWriter out;

    public boolean check(int[] a, int pos, boolean[] used, boolean[][] can) {
        if (pos == a.length) {
            return true;
        } else {
            boolean ok = true;
            boolean curOk = false;
            for (int i = 0; i < a.length; i++) {
                if (can[a[pos]][i] && !used[i]) {
                    curOk = true;
                    used[i] = true;
                    ok &= check(a, pos + 1, used, can);
                    used[i] = false;
                }
            }
            ok &= curOk;
            return ok;
        }
    }

    public void gen(int[] a, boolean[] used, int pos, boolean[][] can) {
        if (pos == a.length) {
            genOk &= check(a, 0, new boolean[a.length], can);
        } else {
            for (int i = 0; i < a.length; i++) {
                if (!used[i]) {
                    used[i] = true;
                    a[pos] = i;
                    gen(a, used, pos + 1, can);
                    used[i] = false;
                }
            }
        }
    }
    int bestCost;
    boolean genOk = true;
    public void genCan(boolean[][] can, int posx, int posy, int cost) {
        if (posx == can.length) {
            if (cost >= bestCost) return;
            genOk = true;
            gen(new int[can.length], new boolean[can.length], 0, can);
            if (genOk) {
                bestCost = cost;
            }
        } else {
            int nx = posx;
            int ny = posy + 1;
            if (ny == can.length) {
                ny = 0;
                nx++;
            }
            genCan(can, nx, ny, cost);
            if (!can[posx][posy]) {
                can[posx][posy] = true;
                genCan(can, nx, ny, cost + 1);
                can[posx][posy] = false;
            }
        }
    }

    public void solveTest() throws IOException {
        int n = in.nextInt();
        boolean[][] can = new boolean[n][n];
        for (int i = 0; i < n; i++) {
            char[] s = in.next().toCharArray();
            for (int j = 0; j < n; j++) {
                can[i][j] = s[j] == '1';
            }
        }
        bestCost = 1_000;
        genCan(can, 0, 0, 0);
        out.println(bestCost);
    }

    public void solve() throws IOException {
        int tests = in.nextInt();
        for (int test = 1; test <= tests; test++) {
            out.print("Case #" + test + ": ");
            System.out.println("test " + test);
            long start = System.currentTimeMillis();
            solveTest();
            System.out.println("passed in " + (System.currentTimeMillis() - start) + " ms");
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("D-small-attempt0.in"));
            out = new PrintWriter(new File("D-small-attempt0.out"));
            Locale.setDefault(Locale.US);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }

    public static void main(String[] arg) {
        new D().run();
    }
}