import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.StringTokenizer;

import static java.lang.Math.PI;

public class A {
    FastScanner in;
    PrintWriter out;

    public static void main(String[] arg) {
        new A().run();
    }

    public void solveTest() throws IOException {
        int n = in.nextInt();
        int k = in.nextInt() - 1;
        Pancake[] a = new Pancake[n];
        Arrays.setAll(a, i -> new Pancake(in.nextInt(), in.nextInt(), i));
        out.printf("%.15f\n",
                Arrays.stream(a)
                        .map(f ->
                                2 * Arrays.stream(a)
                                        .filter(x -> x.i != f.i && x.r <= f.r)
                                        .sorted(Comparator.comparingLong(aa -> -aa.h * aa.r))
                                        .limit(k)
                                        .mapToLong(aa -> aa.h * aa.r)
                                        .sum()
                                        + (2 * f.h + f.r) * f.r
                        ).mapToLong(x -> x).max().getAsLong() * PI);
    }

    public void solve() throws IOException {
        int tests = in.nextInt();
        for (int test = 1; test <= tests; test++) {
            out.print("Case #" + test + ": ");
            System.out.println("test " + test);
            long start = System.currentTimeMillis();
            solveTest();
            System.out.println("passed in " + (System.currentTimeMillis() - start) + " ms");
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("A-large.in"));
            out = new PrintWriter(new File("A-large.out"));
            Locale.setDefault(Locale.US);

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class Pancake {
        long r, h;
        final int i;

        public Pancake(long r, long h, int i) {
            this.r = r;
            this.h = h;
            this.i = i;
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
    }
}