package googlecodejam;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

public class CruiseControl {
	static Scanner s = new Scanner(System.in);
	static int distance;;

	static PrintWriter writer = IOHandler.createOutputFile(s);
	
	public static void main(String[] args) {
		long testCases = s.nextInt();
		for (int i = 0; i < testCases; i++) {
			distance = s.nextInt();
			int n = s.nextInt();
			List<Horse> horses = new ArrayList<Horse>(n);
			for (int j = 0; j < n; j++) {
				horses.add(new Horse(s.nextInt(), s.nextInt()));
			}
			Collections.sort(horses, new HorseComparator());
			writer.print("Case #" + (i + 1) + ": ");
			System.out.print("Case #" + (i + 1) + ": ");
			solve(horses);
		}
		s.close();
		writer.close();
	}

	private static void solve(List<Horse> horses) {
		double maxTime = horses.get(0).getTime(distance);
		for (int i = 0; i < horses.size(); i++) {
			maxTime = Math.max(maxTime, horses.get(i).getTime(distance));
		}
		writer.println(distance/maxTime);
		System.out.println(distance/maxTime);
	}

	static class HorseComparator implements Comparator<Horse> {
		public int compare(Horse a, Horse b) {

			return b.getPosition() - a.getPosition();
		}
	}

}
