package googlecodejam;

import java.io.PrintWriter;
import java.util.Scanner;

public class OversizedPancakeFlipper {
	static Scanner s = new Scanner(System.in);
	static PrintWriter writer = IOHandler.createOutputFile(s);

	public static void main(String[] args) {
		int testCases = s.nextInt();
		for (int i = 0; i < testCases; i++) {
			char[] pancakes = s.next().toCharArray();
			int flipperSize = s.nextInt();
			boolean[] happySideUp = new boolean[pancakes.length];
			for (int k = 0; k < pancakes.length; k++) {
				if (pancakes[k] == '-') {
					happySideUp[k] = false;
				} else {
					happySideUp[k] = true;
				}
			}
			writer.print("Case #" + (i + 1) + ": ");
			System.out.print("Case #" + (i + 1) + ": ");
			solve(happySideUp, flipperSize);
		}
		s.close();
		writer.close();
	}

	private static void solve(boolean[] happySideUp, int flipperSize) {
		int count = 0;
		for (int i = 0; i <= happySideUp.length-flipperSize; i++) {
			if(!happySideUp[i]){
				for (int j = i; j < flipperSize+i; j++) {
					happySideUp[j] = !happySideUp[j];
				}
				count++;
				if(isGood(happySideUp)){
					System.out.println(count);
					writer.println(count);
					return;
				}
			}
		}
		if(isGood(happySideUp)){
			System.out.println(count);
			writer.println(count);
		}
		else{
			System.out.println("IMPOSSIBLE");
			writer.println("IMPOSSIBLE");
		}
	}

	private static boolean isGood(boolean[] happySideUp) {
		for (int i = happySideUp.length-1; i >= 0 ; i--) {
			if(!happySideUp[i]){
				return false;
			}
		}
		return true;
	}
}
