import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class Main {

	int t;
	int n;
	char a[][];
	int[] count;
	float[] wp;
	float[] owp;
	float[] o2wp;
	float[] results;
	public static void main(String[] args) throws IOException {
		Main m = new Main();
		m.readInput(args[0], args[1]);
		//m.writeOutput(args[1]);
	}

	void doProcess() {
		//wp
		for(int i = 0; i < n; i++) {
			float sum = 0;
			for(int j = 0; j < n; j++) {
				sum += a[i][j] == '1' ? 1 : 0;
				count[i] += a[i][j] == '1' || a[i][j] == '0' ? 1 : 0;
			}
			wp[i] = (float) sum/count[i];
		}
		//owp
		for(int i = 0; i < n; i++) {
			float sum = 0;
			for(int j = 0; j < n; j++) {
				if(a[i][j] == '0') {
					sum += ((wp[j] * count[j]) - 1) / (count[j] - 1);	
				} else if(a[i][j] == '1') {
					sum += (wp[j] * count[j]) / (count[j] - 1);	
				}
			}
			owp[i] = (float) sum/count[i];
		}
		//o2wp
		for(int i = 0; i < n; i++) {
			float sum = 0;
			for(int j = 0; j < n; j++) {
				sum += a[i][j] == '1' || a[i][j] == '0' ? owp[j] : 0;
			}
			o2wp[i] = (float) sum/count[i];
		}
		
		for(int i = 0; i < n; i++) {
			results[i] = (float) (0.25 * wp[i] + 0.50 * owp[i] + 0.25 * o2wp[i]);
		}
		
	}

	void readInput(String in, String out) throws IOException {
		Scanner scanner = new Scanner(new File(in));
		PrintWriter writer = new PrintWriter(out);
		t = scanner.nextInt();
		for(int i = 0; i < t; i++) {
			n = scanner.nextInt();
			a = new char[n][n];
			wp = new float[n];
			owp = new float[n];
			o2wp = new float[n]; 
			count = new int[n];
			results = new float[n];
			for(int j = 0; j < n; j++) {
				String s = scanner.next();
				for(int k = 0; k < n; k++) {
					a[j][k] = s.charAt(k);
				}			
			}
			doProcess();
			writeOutput(i+1, writer);
		}
		scanner.close();
		writer.flush();
		writer.close();
	}
	
	void writeOutput(int caseNr, PrintWriter writer) throws IOException {
		writer.println("Case #" + caseNr + ": ");
		for(int i = 0; i < results.length; i++) {
			writer.println(results[i]);
		}
	}
}

class Pair {
	int start;
	int end;
	public Pair(int start, int end) {
		super();
		this.start = start;
		this.end = end;
	}
	public Pair() {
		super();
	}	
}