import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;


public class Main {

	int t;
	boolean status;
	List<List<Character>> result = new ArrayList<List<Character>>();
	Map<Character, StringBuffer> opposedList = new HashMap<Character, StringBuffer>();
	Map<String, Character> combList = new HashMap<String, Character>();
	StringBuffer elList = new StringBuffer("");
	public static void main(String[] args) throws IOException {
		Main m = new Main();
		m.readInput(args[0]);
		m.writeOutput(args[1]);
	}

	void doProcess() {
		List<Character> tempList = new ArrayList<Character>();
		status = true;
		boolean clear = false;
		for(int i = 0; i < elList.length() ; i++) {
			char current = elList.charAt(i);
			if(tempList.size() > 0) {
				if(status) {
					Character comb = combList.get(String.valueOf(current) + String.valueOf(tempList.get(tempList.size()-1)));
					if(comb != null) {
						tempList.set(tempList.size()-1, comb);
						status = false;
					} else {
						for(Character opp : tempList) {
							if(opposedList.get(current) != null 
									&& opposedList.get(current).toString().indexOf(opp) != -1) {
								clear = true;
							}
						}
						if(clear) {
							tempList.clear();
							clear = false;
							status= false;
						} else {
							tempList.add(current);
						}
					}
				} else {
					for(Character opp : tempList) {
						if(opposedList.get(current) != null 
								&& opposedList.get(current).toString().indexOf(opp) != -1) {
							clear = true;
						}
					}
					if(clear) {
						tempList.clear();
						clear = false;
						status= false;
					} else {
						tempList.add(current);
						status= true;
					}
				}
			} else {
				tempList.add(current);
				status = true;
			}
		}
		result.add(tempList);
	}

	void readInput(String in) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(in));
		String lineIn = null;
		StringTokenizer st = null;
		String token = null;
		t = Integer.parseInt(reader.readLine());
		for(int i = 0; i < t; i++) {
			opposedList.clear();
			combList.clear();
			lineIn = reader.readLine();
			st = new StringTokenizer( lineIn, " \t\r" );
			//read Combinations
			int combCount = Integer.parseInt(st.nextToken());
			for(int j = 0; j < combCount; j++) {
				token = st.nextToken();
				combList.put(token.substring(0, 2), token.charAt(2));
				combList.put(token.substring(1, 2) + token.substring(0, 1), token.charAt(2));
			}
			//read Oppositions
			int oppCount = Integer.parseInt(st.nextToken());
			for(int j = 0; j < oppCount; j++) {
				token = st.nextToken();
				if(opposedList.get(token.charAt(0)) == null) {
					opposedList.put(token.charAt(0), new StringBuffer().append(token.charAt(1)));
				} else {
					opposedList.get(token.charAt(0)).append(token.charAt(1));
				}
				if(opposedList.get(token.charAt(1)) == null) {
					opposedList.put(token.charAt(1), new StringBuffer().append(token.charAt(0)));
				} else {
					opposedList.get(token.charAt(1)).append(token.charAt(0));
				}
			}
			//read String
			st.nextToken();
			elList = new StringBuffer(st.nextToken());
			doProcess();
		}
		reader.close();
	}
	
	void writeOutput(String out) throws IOException {
		PrintWriter writer = new PrintWriter(out);

		for(int i = 0; i < result.size(); i++) {
			writer.print("Case #" + (i+1) + ": [");
			for(int j = 0; j < result.get(i).size(); j++) {
				writer.print(result.get(i).get(j));
				if(j != result.get(i).size() -1 ) {
					writer.print(", ");
				}
			}
			writer.println("]");
		}
		writer.flush();
		writer.close();
	}
}
