import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;


public class Main {

	int t;
	List<Float> results = new ArrayList<Float>();
	List<Integer> values = new ArrayList<Integer>();
	List<Boolean> checked = new ArrayList<Boolean>();
	public static void main(String[] args) throws IOException {
		Main m = new Main();
		m.readInput(args[0]);
		m.writeOutput(args[1]);
	}

	float doProcess() {
		int next;
		float steps = 0;
		while((next = getNext()) != -1) {
			if(values.get(next) == next) {
				checked.set(next, true);
			} else {
				Set<Integer> set = new HashSet<Integer>();
				while(set.add(next)) {
					checked.set(next, true);
					next = values.get(next);
				}
				steps += set.size();
			}
		}
		return steps;
	}

	int getNext() {
		for(int i = 1; i < checked.size(); i++) {
			if(!checked.get(i)) {
				return i;
			}
		}
		return -1;
	}

	void readInput(String in) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(in));
		String lineIn = null;
		StringTokenizer st = null;
		String token = null;
		t = Integer.parseInt(reader.readLine());
		for(int i = 0; i < t; i++) {
			values.clear();
			values.add(-1);
			checked.clear();
			checked.add(true);
			//read Combinations
			int count = Integer.parseInt(reader.readLine());
			lineIn = reader.readLine();
			st = new StringTokenizer( lineIn, " \t\r" );
			for(int j = 0; j < count; j++) {
				token = st.nextToken();
				values.add(Integer.parseInt(token));
				checked.add(false);
			}
			results.add(doProcess());
		}
		reader.close();
	}
	
	void writeOutput(String out) throws IOException {
		PrintWriter writer = new PrintWriter(out);

		for(int i = 0; i < results.size(); i++) {
			writer.println("Case #" + (i+1) + ": " + results.get(i) + "00000");
		}
		writer.flush();
		writer.close();
	}
}
