package A;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.Scanner;

public class Small {
    private final Charset ENCODING = StandardCharsets.UTF_8;

    public static void main(String[] args) throws IOException {
        new Small().run(Paths.get(args[0]), Paths.get(args[1]));
    }

    private void run(Path input, Path output) throws IOException{
        try (BufferedWriter writer = Files.newBufferedWriter(output, ENCODING)){
            try (Scanner scanner =  new Scanner(input, ENCODING.name())){
                int T = scanner.nextInt();
                scanner.nextLine();
                outer: for(int t=1; t<=T; t++){
                    StringBuilder line = new StringBuilder(scanner.nextLine().trim());
                    StringBuilder ans = new StringBuilder();

                    for(int x=0; x<10 && line.length() > 0; x+=2){
                        StringBuilder tmp;
                        while(line.length() > 0){
                            tmp = removeDigit(line, x);
                            if(tmp.length() < line.length()){
                                ans.append(x);
                                line = tmp;
                            } else {
                                break;
                            }
                        }
                    }

                    if(line.length() > 0) {
                        int[] odds = {1, 3, 5, 7, 9};
                        do {
                            StringBuilder tmpAns = new StringBuilder();
                            StringBuilder tmpLine = new StringBuilder(line);
                            for (int x = 0; x < odds.length && tmpLine.length() > 0; x++) {
                                StringBuilder tmp;
                                while (tmpLine.length() > 0) {
                                    tmp = removeDigit(tmpLine, odds[x]);
                                    if (tmp.length() < tmpLine.length()) {
                                        tmpAns.append(odds[x]);
                                        tmpLine = tmp;
                                    } else {
                                        break;
                                    }
                                }
                            }

                            if (tmpLine.length() == 0) {
                                ans.append(tmpAns);
                                line = tmpLine;
                                break;
                            }
                        } while ((odds = nextPermutation(odds)) != null);
                    }

                    char[] tmpAns = ans.toString().toCharArray();
                    Arrays.sort(tmpAns);

                    writer.write("Case #" + t + ": " + (new String(tmpAns)));
                    writer.newLine();
                }
            }
        }
    }

    private final String[] digits = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
    private StringBuilder removeDigit(StringBuilder input, int digit){
        StringBuilder result = new StringBuilder(input);
        char[] tmp = digits[digit].toCharArray();
        for(char c : tmp){
            int index = result.indexOf(Character.toString(c));
            if(index < 0){
                return input;
            }
            result = result.deleteCharAt(index);
        }
        return result;
    }

    int[] nextPermutation(int[] arr) {
        if(arr.length == 1) return null;
        int[] a = (int[]) arr.clone();
        int n = a.length-1;
        int j = n - 1;

        while (j>=0 && a[j] >= a[j+1]) {
            if (j==0)
                return null;
            j--;
        }

        int k = n;
        while (k>=0 && a[j] >= a[k])
            k--;

        int tmp = a[j]; a[j] = a[k]; a[k] = tmp;
        int r = n;
        int s = j + 1;

        while (r >= s) {
            tmp = a[r];
            a[r] = a[s];
            a[s] = tmp;
            r--;
            s++;
        }

        return a;
    }
}
