import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;

public class Small {
    public static void main(String[] args) throws IOException {
        new Small().run(Paths.get(args[0]), Paths.get(args[1]));
    }

    private void run(Path input, Path output) throws IOException {
        try (BufferedWriter writer = Files.newBufferedWriter(output, StandardCharsets.UTF_8)) {
            try (Scanner scanner = new Scanner(input, StandardCharsets.UTF_8.name())) {
                int T = scanner.nextInt();
                for(int t=1; t<=T; t++){
                    int n = scanner.nextInt();
                    writer.write("Case #" + t + ": " + solve(n));
                    writer.newLine();
                }
            }
        }
    }

    private int solve(int N){
        for(int n=N; n>=1; n--){
            if(isTidy(n)){
                return n;
            }
        }
        return 0;
    }

    private boolean isTidy(int n){
        int d = n%10;
        n /= 10;
        while(n > 0){
            int tmp = n%10;
            n /= 10;
            if(tmp > d){
                return false;
            }
            d=tmp;
        }
        return true;
    }
}
