import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;

public class Small {
    public static void main(String[] args) throws IOException {
        new Small().run(Paths.get(args[0]), Paths.get(args[1]));
    }

    private void run(Path input, Path output) throws IOException{
        try (BufferedWriter writer = Files.newBufferedWriter(output, StandardCharsets.UTF_8)) {
            try (Scanner scanner = new Scanner(input, StandardCharsets.UTF_8.name())) {
                int T = scanner.nextInt();
                for(int t=1; t<=T; t++) {
                    String s = scanner.next();
                    int k = scanner.nextInt();
                    writer.write("Case #" + t + ": " + solve(s, k));
                    writer.newLine();
                }
            }
        }
    }

    private String solve(String s, int k) {
        int n = s.length();
        int ans = Integer.MAX_VALUE;
        int set = 0;
        s = new StringBuilder(s).reverse().toString();
        for(int x=0; x<s.length(); x++){
            if(s.charAt(x) == '-'){
                set |= (1 << x);
            }
        }
        int mask = (1 << k) - 1;
        for(int x=0; x<(1<<n); x++){
            int tmp = set;
            int size = 0;
            for(int y=0; y<=(n-k); y++){
                if((x & (1<<y)) != 0){
                    tmp ^= (mask << y);
                    size++;
                }
            }
            if(tmp == 0){
                ans = Math.min(ans, size);
            }
        }

        return ans == Integer.MAX_VALUE ? "IMPOSSIBLE" : Integer.toString(ans);
    }
}
