package A;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;

public class Large {
    private final Charset ENCODING = StandardCharsets.UTF_8;

    public static void main(String[] args) throws IOException {
        new Large().run(Paths.get(args[0]), Paths.get(args[1]));
    }

    private void run(Path input, Path output) throws IOException{
        try (BufferedWriter writer = Files.newBufferedWriter(output, ENCODING)){
            try (Scanner scanner =  new Scanner(input, ENCODING.name())){
                int t = scanner.nextInt();
                outer: for(int x=1; x<=t; x++){
                    long n = scanner.nextLong();
                    if(n == 0){
                        writer.write("Case #" + x + ": INSOMNIA");
                        writer.newLine();
                        continue outer;
                    }
                    int[] digits = new int[10];
                    int y=1;
                    while(true) {
                        boolean finished = parse(y*n, digits);
                        if(finished){
                            writer.write("Case #" + x + ": " + y*n);
                            writer.newLine();
                            continue outer;
                        }
                        y++;
                    }
                }
            }
        }
    }

    private boolean parse(long n, int[] digits){
        if(n == 0){
            digits[0] = 1;
        }
        while(n > 0){
            digits[(int)n % 10] = 1;
            n /= 10;
        }
        for(int x=0; x<digits.length; x++){
            if(digits[x] == 0){
                return false;
            }
        }
        return true;
    }
}
