import java.io.*;
import java.util.*;

public class C {

	final static char[] sym = new char[] { '.', '*', 'c' };
	final static int[] dx = new int[] { -1, 0, 1, -1, 1, -1, 0, 1 };
	final static int[] dy = new int[] { 1, 1, 1, 0, 0, -1, -1, -1 };

	final static int[] qx = new int[25];
	final static int[] qy = new int[25];
	final static boolean[][] color = new boolean[5][5];
	final static int[][] mine = new int[5][5];

	boolean check(int x, int y, char[][] ans, int r, int c) {
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				color[i][j] = true;

				if (ans[i][j] == '*') {
					mine[i][j] = 9;
				} else {
					mine[i][j] = 0;
					for (int d = 0; d < 8; d++) {
						int id = i + dx[d];
						int jd = j + dy[d];
						if (id >= 0 && id < r && jd >= 0 && jd < c && ans[id][jd] == '*') {
							++mine[i][j];
						}
					}
				}
			}
		}

		int head = 0, tail = 1;
		color[x][y] = false;
		qx[0] = x;
		qy[0] = y;
		while (head != tail) {
			int i = qx[head], j = qy[head];
			++head;

			if (mine[i][j] == 0) {
				for (int d = 0; d < 8; d++) {
					int id = i + dx[d];
					int jd = j + dy[d];
					if (id >= 0 && id < r && jd >= 0 && jd < c && color[id][jd]) {
						qx[tail] = id;
						qy[tail] = jd;
						color[id][jd] = false;
						++tail;
					}
				}
			}
		}

		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				if (color[i][j] && ans[i][j] != '*') {
					return false;
				}
			}
		}

		return true;
	}

	char[][] solove(int r, int c, int m) {
		int n = r * c;
		int[] map = new int[n];
		map[n - 1] = 2;
		for (int i = 1; i <= m; i++) {
			map[n - i - 1] = 1;
		}

		do {
			char[][] ans = new char[r][c];
			int x = 0, y = 0;
			for (int i = 0; i < r; i++) {
				for (int j = 0; j < c; j++) {
					if ((ans[i][j] = sym[map[i * c + j]]) == 'c') {
						x = i;
						y = j;
					}
				}
			}
			if (check(x, y, ans, r, c)) {
				return ans;
			}
		} while (nextPermutation(map));
		return null;
	}

	void run() throws IOException {
		int tests = ni();

		for (int test = 1; test <= tests; test++) {
			System.out.println(test);
			pw.print("Case #" + test);
			pw.println(':');
			char[][] ans = solove(ni(), ni(), ni());
			if (ans == null) {
				pw.println("Impossible");
			} else {
				for (char[] str : ans) {
					for (char c : str) {
						pw.print(c);
					}
					pw.println();
				}
			}
		}
	}

	boolean nextPermutation(int[] array) {
		int i = array.length - 1;
		while (i > 0 && array[i - 1] >= array[i]) {
			i--;
		}
		if (i == 0) {
			return false;
		}
		int j = array.length - 1;
		while (array[j] <= array[i - 1]) {
			j--;
		}

		int temp = array[i - 1];
		array[i - 1] = array[j];
		array[j] = temp;

		j = array.length - 1;
		while (i < j) {
			temp = array[i];
			array[i] = array[j];
			array[j] = temp;
			i++;
			j--;
		}

		return true;
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(br.readLine());
		return st.nextToken();
	}

	int ni() throws IOException {
		return Integer.parseInt(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	String nl() throws IOException {
		return br.readLine();
	}

	static PrintWriter pw;
	static BufferedReader br;
	static StringTokenizer st;
	static Random rnd = new Random();

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader(new File("C-small-attempt0.in")));
		pw = new PrintWriter(new FileWriter(new File("output.txt")));
		long timeout = System.currentTimeMillis();
		new C().run();
		System.out.println(System.currentTimeMillis() - timeout);
		br.close();
		pw.close();
	}
}
