import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class A extends PrintWriter {

	private static final String input = "A-large.in";
	private static final String output = "A-output.txt";

	String solve(long n) {
		if (n == 0) {
			return "INSOMNIA";
		}
		boolean[] b = new boolean[10];
		Arrays.fill(b, true);
		int f = 0;
		long num = 0;
		while (f < 10) {
			num += n;
			long temp = num;
			while (temp > 0) {
				int x = (int) temp % 10;
				if (b[x]) {
					++f;
					b[x] = false;
				}
				temp /= 10;
			}
		}
		return Long.toString(num);
	}

	void run() {
		int tests = nextInt();

		for (int test = 1; test <= tests; test++) {
			int n = nextInt();
			String ans = solve(n);
			printf(Locale.ENGLISH, "Case #%d: %s%n", test, ans);
			System.out.printf("%2d / %2d%n", test, tests);
		}

	}

	int[][] nextMatrix(int n, int m) {
		int[][] matrix = new int[n][m];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				matrix[i][j] = nextInt();
		return matrix;
	}

	String next() {
		while (!tokenizer.hasMoreTokens())
			tokenizer = new StringTokenizer(nextLine());
		return tokenizer.nextToken();
	}

	boolean hasNext() {
		while (!tokenizer.hasMoreTokens()) {
			String line = nextLine();
			if (line == null) {
				return false;
			}
			tokenizer = new StringTokenizer(line);
		}
		return true;
	}

	int[] nextArray(int n) {
		int[] array = new int[n];
		for (int i = 0; i < n; i++) {
			array[i] = nextInt();
		}
		return array;
	}

	int nextInt() {
		return Integer.parseInt(next());
	}

	long nextLong() {
		return Long.parseLong(next());
	}

	double nextDouble() {
		return Double.parseDouble(next());
	}

	String nextLine() {
		try {
			return reader.readLine();
		} catch (IOException err) {
			return null;
		}
	}

	public A(OutputStream outputStream) {
		super(outputStream);
	}

	static BufferedReader reader;
	static StringTokenizer tokenizer = new StringTokenizer("");
	static Random rnd = new Random();
	static boolean OJ;

	public static void main(String[] args) throws IOException {
		A solution = new A(new FileOutputStream(output));
		reader = new BufferedReader(new FileReader(new File(input)));
		solution.run();
		solution.close();
		reader.close();
	}
}