import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

    private static final String input = "B-small-attempt0.in";
    private static final String output = "output.txt";

    long solve(long num, int n, int m, long[][] cnt) {
        long l = 1, r = 4700000L;

        while (r - l > 1) {
            long c = (l + r) / 2;

            if (get(c, n, m, cnt) <= num) {
                l = c;
            } else {
                r = c;
            }
        }
        return get(l, n, m, cnt);
    }

    long concat(long d, long num) {
        if (num == 0) {
            return d;
        } else {
            return concat(d, (num / 10)) * 10 + (num % 10);
        }
    }

    long get(long index, int n, int m, long[][] cnt) {
        for (int i = 1; i < n; i++) {
            for (int d = 1; d < m; d++) {
                long cur = cnt[i][d];
                if (cur < index) {
                    index -= cur;
                } else {
                    return concat(d, get(index, i - 1, m, d, cnt));
                }
            }
        }

        return 0;
    }

    long get(long index, int i, int m, int b, long[][] cnt) {
        if (index <= 0) {
            return 0;
        }

        for (int d = b; d < m; d++) {
            long cur = cnt[i][d];
            if (cur < index) {
                index -= cur;
            } else {
                return concat(d, get(index, i - 1, m, d, cnt));
            }
        }

        return 0;
    }

    void runTestsFromFile() {

        int n = 20;
        int m = 10;

        long[][] cnt = new long[n][m];

        for (int d = 1; d < m; d++) {
            cnt[1][d] = 1;
        }

        for (int i = 2; i < n; i++) {
            for (int d = 0; d < m; d++) {
                for (int b = d; b < m; b++) {
                    cnt[i][d] += cnt[i - 1][b];
                }
            }
        }

        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {
            long num = nextLong();
            long ans = solve(num, n, m, cnt);
            printf(Locale.ENGLISH, "Case #%d: %d%n", test, ans);
        }
    }

    void run() {
        // stress();
        runTestsFromFile();

    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public B(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        B solution = new B(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}