import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

	private static final String input = "B-small-attempt0.in";
	private static final String output = "B-output.txt";

	int[] dx = { 1, 0, -1, 0 };
	int[] dy = { 0, 1, 0, -1 };

	int solve(int r, int c, int n) {
		int ans = 10000;
		int m = r * c;

		if (n <= (m + 1) / 2) {
			return 0;
		}

		int[] p = new int[m];
		for (int i = 0; i < n; i++) {
			p[m - i - 1] = 1;
		}

		do {
			int cur = 0;

			for (int x = 0; x < r; x++) {
				for (int y = 0; y < c; y++) {
					for (int i = 0; i < 2; i++) {
						int tx = x + dx[i], ty = y + dy[i];

						if (tx < r && ty < c && p[x * c + y] + p[tx * c + ty] == 2) {
							++cur;
						}

					}
				}
			}

			if (cur < ans) {
				ans = cur;
			}

		} while (nextPermutation(p));

		return ans;
	}

	void run() {
		int t = nextInt();

		for (int test = 1; test <= t; test++) {
			int r = nextInt(), c = nextInt(), n = nextInt();

			printf(Locale.ENGLISH, "Case #%d: %d%n", test, solve(r, c, n));
		}
	}

	public static boolean nextPermutation(int[] permutation) {
		int n = permutation.length, a = n - 2;
		while (0 <= a && permutation[a] >= permutation[a + 1]) {
			a--;
		}
		if (a == -1) {
			return false;
		}

		int b = n - 1;
		while (permutation[b] <= permutation[a]) {
			b--;
		}

		swap(permutation, a, b);
		for (int i = a + 1, j = n - 1; i < j; i++, j--) {
			swap(permutation, i, j);
		}
		return true;
	}

	public static void swap(int[] array, int i, int j) {
		if (i == j)
			return;
		array[i] ^= array[j];
		array[j] ^= array[i];
		array[i] ^= array[j];
	}

	int[][] nextMatrix(int n, int m) {
		int[][] matrix = new int[n][m];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				matrix[i][j] = nextInt();
		return matrix;
	}

	String next() {
		while (!tokenizer.hasMoreTokens())
			tokenizer = new StringTokenizer(nextLine());
		return tokenizer.nextToken();
	}

	boolean hasNext() {
		while (!tokenizer.hasMoreTokens()) {
			String line = nextLine();
			if (line == null) {
				return false;
			}
			tokenizer = new StringTokenizer(line);
		}
		return true;
	}

	int[] nextArray(int n) {
		int[] array = new int[n];
		for (int i = 0; i < n; i++) {
			array[i] = nextInt();
		}
		return array;
	}

	int nextInt() {
		return Integer.parseInt(next());
	}

	long nextLong() {
		return Long.parseLong(next());
	}

	double nextDouble() {
		return Double.parseDouble(next());
	}

	String nextLine() {
		try {
			return reader.readLine();
		} catch (IOException err) {
			return null;
		}
	}

	public B(OutputStream outputStream) {
		super(outputStream);
	}

	static BufferedReader reader;
	static StringTokenizer tokenizer = new StringTokenizer("");
	static Random rnd = new Random();
	static boolean OJ;

	public static void main(String[] args) throws IOException {
		B solution = new B(new FileOutputStream(output));
		reader = new BufferedReader(new FileReader(new File(input)));
		solution.run();
		solution.close();
		reader.close();
	}
}