import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

    private static final String input = "B-small-attempt1.in";
    private static final String output = "output.txt";

    int[] solve(int n, int[] x, int[] y) {
        int r = 0, p = 0;

        for (int i = 0; i < n; i++) {
            while (x[i] > 0) {
                --x[i];
                int f = -1, b = -1;
                for (int j = 0; f == -1 && j < n; j++) {
                    int id = (j + i) % n;

                    if (y[id] > 0) {
                        b = id;
                        if (i != id) {
                            f = id;
                        }
                    }
                }
                if (b != -1) {
                    if (f != -1) {
                        --y[f];
                    } else {
                        if (b != 0) {
                            --y[b];
                            ++p;
                        }
                    }
                }
                ++r;
            }
        }

        for (int i = 0; i < n; i++) {
            while (y[i] > 0) {
                --y[i];
                int f = -1, b = -1;
                for (int j = 0; f == -1 && j < n; j++) {
                    int id = (j + i) % n;

                    if (x[id] > 0) {
                        b = id;
                        if (i != id) {
                            f = id;
                        }
                    }
                }
                if (b != -1) {
                    if (f != -1) {
                        --x[f];
                    } else {
                        if (b != 0) {
                            --x[b];
                            ++p;
                        }
                    }
                }
                ++r;
            }
        }

        return new int[] { r, p };
    }

    void runTestsFromFile() {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {

            int n = nextInt(), m = nextInt(), k = nextInt();
            int[][] cnt = new int[m][n];

            for (int i = 0; i < k; i++) {
                int p = nextInt() - 1;
                int c = nextInt() - 1;
                ++cnt[c][p];
            }

            int[] ans = solve(n, cnt[0].clone(), cnt[1].clone());

            printf(Locale.ENGLISH, "Case #%d: %d %d%n", test, ans[0], ans[1]);

            if (k < 20 && n < 20) {
                System.out.println(Arrays.toString(cnt[0]));
                System.out.println(Arrays.toString(cnt[1]));
                System.out.println(Arrays.toString(ans));
                System.out.println();
            }
        }
    }

    void run() {
        // stress();
        runTestsFromFile();
    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public B(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        B solution = new B(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}