import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class C extends PrintWriter {

    private static final String input = "C-small-attempt0.in";
    private static final String output = "output.txt";

    double solve(int n, double[] e, double[] s, double[] v) {
        double[] t = new double[n];
        t[0] = 0;

        for (int i = 1; i < n; i++) {
            t[i] = Double.POSITIVE_INFINITY;
            int d = 0;
            for (int j = i - 1; j >= 0; j--) {
                d += e[j];

                if (s[j] >= d) {
                    t[i] = min(t[i], t[j] + d / v[j]);
                }

            }
        }

        return t[n - 1];
    }

    void runTestsFromFile() {

        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {
            int n = nextInt(), m = nextInt();

            double[] s = new double[n];
            double[] v = new double[n];

            for (int i = 0; i < n; i++) {
                s[i] = nextInt();
                v[i] = nextInt();
            }

            int[][] d = new int[n][n];

            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    d[i][j] = nextInt();
                }
            }

            int[] f = new int[m], t = new int[m];

            for (int i = 0; i < m; i++) {
                f[i] = nextInt();
                t[i] = nextInt();
            }

            double[] e = new double[n - 1];

            for (int i = 1; i < n; i++) {
                e[i - 1] = d[i - 1][i];
            }

            double ans = solve(n, e, s, v);

            printf(Locale.ENGLISH, "Case #%d: %.9f%n", test, ans);
        }
    }

    void run() {
        // stress();
        runTestsFromFile();

    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public C(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        C solution = new C(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}