import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class C extends PrintWriter {

	private static final String input = "C-small-attempt0.in";
	private static final String output = "C-output.txt";

	int solve(int[][] s, int m) {
		int n = s.length, ans = m;

		int add = 0;
		boolean[] aia = new boolean[m];

		boolean[][] lan = new boolean[2][m];

		for (int i = 0; i < 2; i++) {
			int len = s[i].length;
			for (int j = 0; j < len; j++) {
				lan[i][s[i][j]] = true;
			}
		}

		for (int j = 0; j < m; j++) {
			if (lan[0][j] && lan[1][j]) {
				++add;
				aia[j] = true;
			}
		}

		if (n <= 2) {
			return add;
		}

		int k = 1 << (n - 2);
		for (int mask = 0; mask < k; mask++) {
			Set<Integer> e = new HashSet<Integer>(), f = new HashSet<Integer>();

			for (int i = 2; i < n; i++) {
				int len = s[i].length;
				if ((mask & (1 << (i - 2))) > 0) {
					for (int j = 0; j < len; j++) {
						e.add(s[i][j]);
					}
				} else {
					for (int j = 0; j < len; j++) {
						f.add(s[i][j]);
					}
				}
			}

			int cur = 0;
			for (Integer cw : e) {
				int w = cw;

				if (aia[w]) {
					continue;
				}
				if (f.contains(cw) || lan[1][w]) {
					++cur;
				}
			}

			for (Integer cw : f) {
				int w = cw;

				if (aia[w] || e.contains(cw)) {
					continue;
				}

				if (lan[0][w]) {
					++cur;
				}
			}

			if (cur < ans) {
				ans = cur;
			}
		}

		return ans + add;
	}

	void run() {
		int tests = nextInt();

		for (int t = 1; t <= tests; t++) {
			int n = nextInt(), m = 0;

			Map<String, Integer> id = new HashMap<String, Integer>();

			int[][] s = new int[n][];

			for (int i = 0; i < n; i++) {
				String[] line = nextLine().split(" ");
				int len = line.length;

				s[i] = new int[len];
				for (int j = 0; j < len; j++) {
					Integer cur = id.get(line[j]);
					if (cur == null) {
						id.put(line[j], m);
						cur = m++;
					}
					s[i][j] = cur;
				}
			}

			printf("Case #%d: %d%n", t, solve(s, m));

		}

	}

	int[][] nextMatrix(int n, int m) {
		int[][] matrix = new int[n][m];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				matrix[i][j] = nextInt();
		return matrix;
	}

	String next() {
		while (!tokenizer.hasMoreTokens())
			tokenizer = new StringTokenizer(nextLine());
		return tokenizer.nextToken();
	}

	boolean hasNext() {
		while (!tokenizer.hasMoreTokens()) {
			String line = nextLine();
			if (line == null) {
				return false;
			}
			tokenizer = new StringTokenizer(line);
		}
		return true;
	}

	int[] nextArray(int n) {
		int[] array = new int[n];
		for (int i = 0; i < n; i++) {
			array[i] = nextInt();
		}
		return array;
	}

	int nextInt() {
		return Integer.parseInt(next());
	}

	long nextLong() {
		return Long.parseLong(next());
	}

	double nextDouble() {
		return Double.parseDouble(next());
	}

	String nextLine() {
		try {
			return reader.readLine();
		} catch (IOException err) {
			return null;
		}
	}

	public C(OutputStream outputStream) {
		super(outputStream);
	}

	static BufferedReader reader;
	static StringTokenizer tokenizer = new StringTokenizer("");
	static Random rnd = new Random();
	static boolean OJ;

	public static void main(String[] args) throws IOException {
		C solution = new C(new FileOutputStream(output));
		reader = new BufferedReader(new FileReader(new File(input)));
		solution.run();
		solution.close();
		reader.close();
	}
}