import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

	private static final String input = "B-large.in";
	private static final String output = "B-output.txt";

	int solve(int[] p) {
		int ans = 10000;

		for (int h = 1; h <= 1000; h++) {
			int time = 0;
			for (int v : p) {
				time += (v - 1) / h;
			}

			ans = min(ans, h + time);
		}

		return ans;
	}

	void run() {
		int t = nextInt();

		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			int[] p = nextArray(n);
			printf(Locale.ENGLISH, "Case #%d: %d%n", test, solve(p));
		}
	}

	int[][] nextMatrix(int n, int m) {
		int[][] matrix = new int[n][m];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				matrix[i][j] = nextInt();
		return matrix;
	}

	String next() {
		while (!tokenizer.hasMoreTokens())
			tokenizer = new StringTokenizer(nextLine());
		return tokenizer.nextToken();
	}

	boolean hasNext() {
		while (!tokenizer.hasMoreTokens()) {
			String line = nextLine();
			if (line == null) {
				return false;
			}
			tokenizer = new StringTokenizer(line);
		}
		return true;
	}

	int[] nextArray(int n) {
		int[] array = new int[n];
		for (int i = 0; i < n; i++) {
			array[i] = nextInt();
		}
		return array;
	}

	int nextInt() {
		return Integer.parseInt(next());
	}

	long nextLong() {
		return Long.parseLong(next());
	}

	double nextDouble() {
		return Double.parseDouble(next());
	}

	String nextLine() {
		try {
			return reader.readLine();
		} catch (IOException err) {
			return null;
		}
	}

	public B(OutputStream outputStream) {
		super(outputStream);
	}

	static BufferedReader reader;
	static StringTokenizer tokenizer = new StringTokenizer("");
	static Random rnd = new Random();
	static boolean OJ;

	public static void main(String[] args) throws IOException {
		B solution = new B(new FileOutputStream(output));
		reader = new BufferedReader(new FileReader(new File(input)));
		solution.run();
		solution.close();
		reader.close();
	}
}