import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class A extends PrintWriter {

    private static final String input = "A-small-attempt0.in";
    private static final String output = "output.txt";

    int solve(int n, int m, boolean[] array) {
        int cnt = 0;

        int k = n - m;

        for (int r = m; r <= n; r++) {
            int l = r - m;

            if (array[l]) {
                for (int i = l; i < r; i++) {
                    array[i] ^= true;
                }
                ++cnt;
            }
        }

        for (int i = 0; i < n; i++) {
            if (array[i]) {
                return -1;
            }
        }

        return cnt;
    }

    void runTestsFromFile() {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {

            String str = next();
            int m = nextInt();
            int n = str.length();

            boolean[] array = new boolean[n];
            for (int i = 0; i < n; i++) {
                array[i] = str.charAt(i) == '-';
            }

            int ans = solve(n, m, array);

            if (ans < 0) {
                printf(Locale.ENGLISH, "Case #%d: %s%n", test, "IMPOSSIBLE");
            } else {
                printf(Locale.ENGLISH, "Case #%d: %d%n", test, ans);
            }

        }
    }

    void run() {
        // stress();
        runTestsFromFile();
    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public A(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        A solution = new A(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}