import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class A extends PrintWriter {

	private static final String input = "A-large.in";
	private static final String output = "A-output.txt";

	int solve(int n, int m, char[][] map) {
		int[][] l = new int[n][m];
		for (int i = 0; i < n; i++) {
			for (int j = 1; j < m; j++) {
				l[i][j] = l[i][j - 1];
				if (map[i][j - 1] != '.') {
					++l[i][j];
				}
			}
		}

		int[][] r = new int[n][m];
		for (int i = 0; i < n; i++) {
			for (int j = m - 2; j >= 0; j--) {
				r[i][j] = r[i][j + 1];
				if (map[i][j + 1] != '.') {
					++r[i][j];
				}
			}
		}

		int[][] u = new int[n][m];
		for (int j = 0; j < m; j++) {
			for (int i = 1; i < n; i++) {
				u[i][j] = u[i - 1][j];
				if (map[i - 1][j] != '.') {
					++u[i][j];
				}
			}
		}

		int[][] d = new int[n][m];
		for (int j = 0; j < m; j++) {
			for (int i = n - 2; i >= 0; i--) {
				d[i][j] = d[i + 1][j];
				if (map[i + 1][j] != '.') {
					++d[i][j];
				}
			}
		}

		int ans = 0;
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (map[i][j] != '.') {
					if (l[i][j] == 0 && r[i][j] == 0 && u[i][j] == 0 && d[i][j] == 0) {
						return -1;
					}

					if (map[i][j] == '^' && u[i][j] == 0) {
						++ans;
						continue;
					}

					if (map[i][j] == 'v' && d[i][j] == 0) {
						++ans;
						continue;
					}

					if (map[i][j] == '<' && l[i][j] == 0) {
						++ans;
						continue;
					}
					if (map[i][j] == '>' && r[i][j] == 0) {
						++ans;
						continue;
					}

				}
			}
		}

		return ans;
	}

	void run() {
		int tests = nextInt();

		for (int t = 1; t <= tests; t++) {
			int n = nextInt(), m = nextInt();
			char[][] map = new char[n][];

			for (int i = 0; i < n; i++) {
				map[i] = next().toCharArray();
			}

			int ans = solve(n, m, map);

			if (ans == -1) {
				printf("Case #%d: IMPOSSIBLE%n", t);
			} else {
				printf("Case #%d: %d%n", t, ans);
			}

		}

	}

	int[][] nextMatrix(int n, int m) {
		int[][] matrix = new int[n][m];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				matrix[i][j] = nextInt();
		return matrix;
	}

	String next() {
		while (!tokenizer.hasMoreTokens())
			tokenizer = new StringTokenizer(nextLine());
		return tokenizer.nextToken();
	}

	boolean hasNext() {
		while (!tokenizer.hasMoreTokens()) {
			String line = nextLine();
			if (line == null) {
				return false;
			}
			tokenizer = new StringTokenizer(line);
		}
		return true;
	}

	int[] nextArray(int n) {
		int[] array = new int[n];
		for (int i = 0; i < n; i++) {
			array[i] = nextInt();
		}
		return array;
	}

	int nextInt() {
		return Integer.parseInt(next());
	}

	long nextLong() {
		return Long.parseLong(next());
	}

	double nextDouble() {
		return Double.parseDouble(next());
	}

	String nextLine() {
		try {
			return reader.readLine();
		} catch (IOException err) {
			return null;
		}
	}

	public A(OutputStream outputStream) {
		super(outputStream);
	}

	static BufferedReader reader;
	static StringTokenizer tokenizer = new StringTokenizer("");
	static Random rnd = new Random();
	static boolean OJ;

	public static void main(String[] args) throws IOException {
		A solution = new A(new FileOutputStream(output));
		reader = new BufferedReader(new FileReader(new File(input)));
		solution.run();
		solution.close();
		reader.close();
	}
}