import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

    private static final String input = "B-small-attempt1.in";
    private static final String output = "B-output.txt";

    char[][] solve(char[] a, char[] b, int n) {
        char[][] ans = new char[2][n];
        Arrays.fill(ans[0], '_');
        Arrays.fill(ans[1], '_');

        long inf = 1_000_000_000_000_000_000L;

        long[][][] dp = new long[10][10][n + 1];
        int[][][] ac = new int[10][10][n + 1];
        int[][][] bc = new int[10][10][n + 1];

        for (int x = 0; x < 10; x++) {
            for (int y = 0; y < 10; y++) {
                for (int i = 0; i < n; i++) {
                    dp[x][y][i] = inf;
                }
            }
        }

        long dec = 1;

        for (int i = n - 1; i >= 0; i--) {
            for (int cx = 0; cx < 10; cx++) {
                if (a[i] == '?' || a[i] == cx + '0') {
                    for (int cy = 0; cy < 10; cy++) {
                        if (b[i] == '?' || b[i] == cy + '0') {
                            long e = (cx - cy) * dec;
                            for (int nx = 0; nx < 10; nx++) {
                                for (int ny = 0; ny < 10; ny++) {
                                    long diff = dp[nx][ny][i + 1];
                                    if (diff < inf) {
                                        long cur = e + diff;
                                        if (abs(cur) < abs(dp[cx][cy][i])) {
                                            dp[cx][cy][i] = cur;
                                            ac[cx][cy][i] = nx;
                                            bc[cx][cy][i] = ny;
                                        }
                                    }
                                }
                            }
                        }
                    }
                }
            }
            dec *= 10L;
        }

        long diff = inf;
        int curA = 0, curB = 0;

        for (int x = 0; x < 10; x++) {
            for (int y = 0; y < 10; y++) {
                if (abs(dp[x][y][0]) < abs(diff)) {
                    diff = dp[x][y][0];
                    curA = x;
                    curB = y;
                }
            }
        }

        for (int i = 0; i < n; i++) {
            int x = curA;
            int y = curB;

            ans[0][i] = (char) (x + '0');
            ans[1][i] = (char) (y + '0');

            curA = ac[x][y][i];
            curB = bc[x][y][i];
        }

        return ans;
    }

    void run() {
        int tests = nextInt();

        for (int test = 1; test <= tests; test++) {
            char[] a = next().toCharArray(), b = next().toCharArray();
            if (a.length != b.length) {
                System.err.println(test + " " + a.length + " " + b.length);
            }

            int n = a.length;

            char[][] ans = solve(a, b, n);

            printf(Locale.ENGLISH, "Case #%d: ", test, ans);
            print(new String(ans[0]));
            print(' ');
            print(new String(ans[1]));
            println();

            // printf(Locale.ENGLISH, "Case #%d: %s%n", test, ans);

            System.out.printf("%2d / %2d%n", test, tests);
        }

    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public B(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        B solution = new B(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}