import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class C extends PrintWriter {

	private static final String input = "C-small-attempt0.in";
	private static final String output = "C-output.txt";

	int[] d = new int[256];
	int[] inv = new int[8];

	int[][] mul = new int[8][];

	boolean solve(int n, int m, String s) {
		int k = n * m;
		int[] p = new int[k + 1];

		for (int i = 0; i < k; i++) {
			p[i + 1] = mul[p[i]][d[s.charAt(i % n)]];
		}

		if (p[k] != 1) {
			return false;
		}

		for (int x = 1; x <= k; x++) {
			if (p[x] == 2) {
				for (int y = x + 1; y < k; y++) {
					if (mul[inv[p[x]]][p[y]] == 4 && mul[inv[p[y]]][p[k]] == 6) {
						return true;
					}
				}
			}
		}

		return false;
	}

	void run() {
		d['i'] = 2;
		d['j'] = 4;
		d['k'] = 6;

		mul[0] = new int[] { 0, 1, 2, 3, 4, 5, 6, 7 };
		mul[1] = new int[] { 1, 0, 3, 2, 5, 4, 7, 6 };
		mul[2] = new int[] { 2, 3, 1, 0, 6, 7, 5, 4 };
		mul[3] = new int[] { 3, 2, 0, 1, 7, 6, 4, 5 };
		mul[4] = new int[] { 4, 5, 7, 6, 1, 0, 2, 3 };
		mul[5] = new int[] { 5, 4, 6, 7, 0, 1, 3, 2 };
		mul[6] = new int[] { 6, 7, 4, 5, 3, 2, 1, 0 };
		mul[7] = new int[] { 7, 6, 5, 4, 2, 3, 0, 1 };

		for (int i = 0; i < 8; i++) {
			for (int j = 0; j < 8; j++) {
				if (mul[i][j] == 0) {
					inv[i] = j;
				}
			}
		}

		int t = nextInt();
		for (int test = 1; test <= t; test++) {
			int n = nextInt(), m = nextInt();
			String s = next();
			printf(Locale.ENGLISH, "Case #%d: %s%n", test, solve(n, m, s) ? "YES" : "NO");
		}
	}

	int[][] nextMatrix(int n, int m) {
		int[][] matrix = new int[n][m];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				matrix[i][j] = nextInt();
		return matrix;
	}

	String next() {
		while (!tokenizer.hasMoreTokens())
			tokenizer = new StringTokenizer(nextLine());
		return tokenizer.nextToken();
	}

	boolean hasNext() {
		while (!tokenizer.hasMoreTokens()) {
			String line = nextLine();
			if (line == null) {
				return false;
			}
			tokenizer = new StringTokenizer(line);
		}
		return true;
	}

	int[] nextArray(int n) {
		int[] array = new int[n];
		for (int i = 0; i < n; i++) {
			array[i] = nextInt();
		}
		return array;
	}

	int nextInt() {
		return Integer.parseInt(next());
	}

	long nextLong() {
		return Long.parseLong(next());
	}

	double nextDouble() {
		return Double.parseDouble(next());
	}

	String nextLine() {
		try {
			return reader.readLine();
		} catch (IOException err) {
			return null;
		}
	}

	public C(OutputStream outputStream) {
		super(outputStream);
	}

	static BufferedReader reader;
	static StringTokenizer tokenizer = new StringTokenizer("");
	static Random rnd = new Random();
	static boolean OJ;

	public static void main(String[] args) throws IOException {
		C solution = new C(new FileOutputStream(output));
		reader = new BufferedReader(new FileReader(new File(input)));
		solution.run();
		solution.close();
		reader.close();
	}
}