import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class A extends PrintWriter {

    private static final String input = "A-small-attempt0.in";
    private static final String output = "A-output.txt";

    private List<int[]> solve(int n, int[] a) {
        List<int[]> plan = new ArrayList<int[]>();

        while (true) {
            int x = 0;
            for (int i = 1; i < n; i++) {
                if (a[i] > a[x]) {
                    x = i;
                }
            }

            if (a[x] == 0) {
                break;
            }

            int y = -1;
            for (int i = 0; i < n; i++) {
                if (i == x) {
                    continue;
                }
                if (y == -1 || a[i] > a[y]) {
                    y = i;
                }
            }

            int z = -1;
            for (int i = 0; i < n; i++) {
                if (i == x || i == y) {
                    continue;
                }
                if (z == -1 || a[i] > a[z]) {
                    z = i;
                }
            }
            if (n == 2) {
                if (a[x] > a[y]) {
                    plan.add(new int[] { x });
                    --a[x];
                } else {
                    plan.add(new int[] { x, y });
                    --a[x];
                    --a[y];
                }
            } else {
                if (a[x] > a[y] || a[z] > 0) {
                    plan.add(new int[] { x });
                    --a[x];
                } else {
                    plan.add(new int[] { x, y });
                    --a[x];
                    --a[y];
                }
            }

        }

        return plan;
    }

    void run() {
        int tests = nextInt();

        for (int test = 1; test <= tests; test++) {
            int n = nextInt();
            int[] a = nextArray(n);

            int sum = 0;
            for (int p : a) {
                sum += p;
            }

            List<int[]> plan = solve(n, a.clone());
            printf(Locale.ENGLISH, "Case #%d:", test);

            try {
                for (int[] step : plan) {
                    print(' ');
                    for (int v : step) {
                        print((char) (v + 'A'));
                        --sum;
                        --a[v];
                    }

                    for (int p : a) {
                        if (p < 0 || 2 * p > sum) {
                            throw new IllegalStateException(Arrays.toString(a));
                        }
                    }
                }
            } catch (RuntimeException error) {
                System.err.println(error.getMessage());
            }

            println();

            // printf(Locale.ENGLISH, "Case #%d: %s%n", test);
        }

    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public A(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        A solution = new A(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}