import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class A extends PrintWriter {

    private static final String input = "A-small-attempt1.in";
    private static final String output = "A-output.txt";

    int[] solve(int[] a) {
        int[] d = new int[10];

        { // Z ZERO
            int z = a['Z'];
            d[0] += z;
            a['Z'] -= z;
            a['E'] -= z;
            a['R'] -= z;
            a['O'] -= z;
        }
        { // X SIX
            int x = a['X'];
            d[6] += x;
            a['S'] -= x;
            a['I'] -= x;
            a['X'] -= x;
        }
        { // S SEVEN
            int s = a['S'];
            d[7] += s;
            a['S'] -= s;
            a['E'] -= s;
            a['V'] -= s;
            a['E'] -= s;
            a['N'] -= s;
        }
        { // U FOUR
            int u = a['U'];
            d[4] += u;
            a['F'] -= u;
            a['O'] -= u;
            a['U'] -= u;
            a['R'] -= u;
        }

        { // V FIVE
            int v = a['V'];
            d[5] += v;
            a['F'] -= v;
            a['I'] -= v;
            a['V'] -= v;
            a['E'] -= v;
        }
        { // W TWO
            int w = a['W'];
            d[2] += w;
            a['T'] -= w;
            a['W'] -= w;
            a['O'] -= w;
        }
        { // G EIGHT
            int g = a['G'];
            d[8] += g;
            a['E'] -= g;
            a['I'] -= g;
            a['G'] -= g;
            a['H'] -= g;
            a['T'] -= g;
        }
        { // H THREE
            int h = a['H'];
            d[3] += h;
            a['T'] -= h;
            a['H'] -= h;
            a['R'] -= h;
            a['E'] -= h;
            a['E'] -= h;
        }
        { // O ONE
            int o = a['O'];
            d[1] += o;
            a['O'] -= o;
            a['N'] -= o;
            a['E'] -= o;
        }
        { // N NINE
            int n = a['N'] / 2;
            d[9] += n;
            a['N'] -= n;
            a['I'] -= n;
            a['N'] -= n;
            a['E'] -= n;
        }

        for (int i = 0; i < a.length; i++) {
            int val = a[i];
            if (val != 0) {
                System.err.println(val + " " + ((char) i));

            }
        }

        return d;
    }

    void run() {
        int tests = nextInt();

        for (int test = 1; test <= tests; test++) {
            String str = nextLine().toUpperCase();
            int n = str.length();

            int[] a = new int[256];
            for (int i = 0; i < n; i++) {
                ++a[str.charAt(i)];
            }

            int[] d = solve(a);

            printf(Locale.ENGLISH, "Case #%d: ", test);
            for (int i = 0; i < d.length; i++) {
                while (--d[i] >= 0) {
                    print(i);
                }
            }

            println();
            // printf(Locale.ENGLISH, "Case #%d: %s%n", test);

            System.out.printf("%2d / %2d%n", test, tests);
        }

    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public A(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        A solution = new A(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}