import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class A extends PrintWriter {

    private static final String input = "A-small-attempt0.in";
    private static final String output = "output.txt";

    int solve(int n0, int n1) {
        return n0 + (n1 + 1) / 2;
    }

    int solve(int n0, int n1, int n2) {
        int[][][] dp = new int[n0 + 1][n1 + 1][n2 + 1];

        int inf = 1000000;

        for (int m0 = 0; m0 <= n0; m0++) {
            for (int m1 = 0; m1 <= n1; m1++) {
                for (int m2 = 0; m2 <= n2; m2++) {
                    if ((m0 | m1 | m2) == 0) {
                        dp[m0][m1][m2] = 0;
                    } else {
                        dp[m0][m1][m2] = -inf;

                        if (m0 > 0) {
                            dp[m0][m1][m2] = max(dp[m0][m1][m2], dp[m0 - 1][m1][m2] + 1);
                        }

                        if (m1 > 0) {
                            int r = (0 * m0 + 1 * (m1 - 1) + 2 * m2) % 3;

                            if (r == 0) {
                                dp[m0][m1][m2] = max(dp[m0][m1][m2], dp[m0][m1 - 1][m2] + 1);
                            } else {
                                dp[m0][m1][m2] = max(dp[m0][m1][m2], dp[m0][m1 - 1][m2] + 0);
                            }
                        }

                        if (m2 > 0) {
                            int r = (0 * m0 + 1 * m1 + 2 * (m2 - 1)) % 3;

                            if (r == 0) {
                                dp[m0][m1][m2] = max(dp[m0][m1][m2], dp[m0][m1][m2 - 1] + 1);
                            } else {
                                dp[m0][m1][m2] = max(dp[m0][m1][m2], dp[m0][m1][m2 - 1] + 0);
                            }
                        }
                    }
                }
            }
        }

        return dp[n0][n1][n2];
    }

    int solve(int n0, int n1, int n2, int n3) {
        int[][][][] dp = new int[n0 + 1][n1 + 1][n2 + 1][n3 + 1];

        int inf = 1000000;

        for (int m0 = 0; m0 <= n0; m0++) {
            for (int m2 = 0; m2 <= n2; m2++) {
                for (int m1 = 0; m1 <= n1; m1++) {
                    for (int m3 = 0; m3 <= n2; m3++) {
                        if ((m0 | m1 | m2 | m3) == 0) {
                            dp[m0][m1][m2][m3] = 0;
                        } else {
                            dp[m0][m1][m2][m3] = -inf;

                            if (m0 > 0) {
                                dp[m0][m1][m2][m3] = max(dp[m0][m1][m2][m3], dp[m0 - 1][m1][m2][m3] + 1);
                            }

                            if (m1 > 0) {
                                int r = (0 * m0 + 1 * (m1 - 1) + 2 * m2 + 3 * m3) % 4;

                                if (r == 0) {
                                    dp[m0][m1][m2][m3] = max(dp[m0][m1][m2][m3], dp[m0][m1 - 1][m2][m3] + 1);
                                } else {
                                    dp[m0][m1][m2][m3] = max(dp[m0][m1][m2][m3], dp[m0][m1 - 1][m2][m3] + 0);
                                }
                            }

                            if (m2 > 0) {
                                int r = (0 * m0 + 1 * m1 + 2 * (m2 - 1) + 3 * m3) % 4;

                                if (r == 0) {
                                    dp[m0][m1][m2][m3] = max(dp[m0][m1][m2][m3], dp[m0][m1][m2 - 1][m3] + 1);
                                } else {
                                    dp[m0][m1][m2][m3] = max(dp[m0][m1][m2][m3], dp[m0][m1][m2 - 1][m3] + 0);
                                }
                            }

                            if (m3 > 0) {
                                int r = (0 * m0 + 1 * m1 + 2 * m2 + 3 * (m3 - 1)) % 4;

                                if (r == 0) {
                                    dp[m0][m1][m2][m3] = max(dp[m0][m1][m2][m3], dp[m0][m1][m2][m3 - 1] + 1);
                                } else {
                                    dp[m0][m1][m2][m3] = max(dp[m0][m1][m2][m3], dp[m0][m1][m2][m3 - 1] + 0);
                                }
                            }
                        }
                    }
                }
            }
        }

        return dp[n0][n1][n2][n3];
    }

    int solve(int n, int p, int[] g) {
        int n0 = 0, n1 = 0, n2 = 0, n3 = 0;
        if (p == 2) {
            for (int r : g) {
                if (r % 2 == 0) {
                    ++n0;
                }
                if (r % 2 == 1) {
                    ++n1;
                }
            }
            return solve(n0, n1);
        }

        if (p == 3) {
            for (int r : g) {
                if (r % 3 == 0) {
                    ++n0;
                }
                if (r % 3 == 1) {
                    ++n1;
                }
                if (r % 3 == 2) {
                    ++n2;
                }
            }
            return solve(n0, n1, n2);
        }

        if (p == 4) {
            for (int r : g) {
                if (r % 4 == 0) {
                    ++n0;
                }
                if (r % 4 == 1) {
                    ++n1;
                }
                if (r % 4 == 2) {
                    ++n2;
                }

                if (r % 4 == 3) {
                    ++n3;
                }
            }

            return solve(n0, n1, n2, n3);
        }

        return 0;
    }

    void runTestsFromFile() {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {

            int n = nextInt(), p = nextInt();
            int[] g = nextArray(n);

            int ans = solve(n, p, g);

            printf(Locale.ENGLISH, "Case #%d: %d%n", test, ans);
        }
    }

    void run() {
        // stress();
        runTestsFromFile();
    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public A(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        A solution = new A(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}