import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class B {

	int solove(int n, int[] a, int m) {
		int[][] ll = new int[n][n];

		for (int i = 0; i < n; i++) {
			for (int j = i - 1; j >= 0; j--) {
				if (a[j] < a[i]) {
					ll[i][j] = ll[i][j + 1] + 1;
				} else {
					ll[i][j] = ll[i][j + 1];
				}
			}
		}

		int[][] lr = new int[n][n];

		for (int i = 0; i < n; i++) {
			for (int j = i + 1; j < n; j++) {
				if (a[j] < a[i]) {
					lr[i][j] = lr[i][j - 1] + 1;
				} else {
					lr[i][j] = lr[i][j - 1];
				}

			}
		}

		int ans = n * n + 123;

		for (int s = 0; s <= n; s++) {
			int cur = Math.abs(s - m);

			for (int i = 0; i < s; i++) {
				cur += lr[i][s - 1];
			}

			for (int i = s; i < n; i++) {
				cur += ll[i][s];
			}

			if (ans > cur) {
				ans = cur;
			}
		}

		return ans;
	}

	int bf(int n, int[] a) {
		boolean d = true;
		for (int i = 1; d && i < n; i++) {
			if (a[i - 1] > a[i]) {
				d = false;
			}
		}
		if (d) {
			return 0;
		}

		int[] p = new int[n];
		for (int i = 0; i < n; i++) {
			p[i] = i;
		}

		int ans = n * n + 123;

		do {
			int t = 0;
			for (int i = 0; i < n; i++) {
				for (int j = i + 1; j < n; j++) {
					if (p[i] > p[j]) {
						t++;
					}
				}
			}

			boolean ok = true;

			int m = 0;
			for (int i = 1; i < n; i++) {
				if (a[p[i]] < a[p[i - 1]]) {
					m = i;
					break;
				}
			}

			for (int i = m; ok && i < n; i++) {
				if (i > 0 && a[p[i]] > a[p[i - 1]]) {
					ok = false;
				}
			}

			if (ok && t < ans) {
				ans = t;
			}

		} while (nextPermutation(p));

		return ans;
	}

	boolean nextPermutation(int[] a) {

		int i = a.length - 1, j = i;
		while (i > 0 && a[i - 1] >= a[i]) {
			i--;
		}

		if (i == 0) {
			return false;
		}

		while (a[j] <= a[i - 1]) {
			j--;
		}

		int temp = a[i - 1];
		a[i - 1] = a[j];
		a[j] = temp;

		j = a.length - 1;
		while (i < j) {
			temp = a[i];
			a[i] = a[j];
			a[j] = temp;
			i++;
			j--;
		}

		return true;
	}

	void run() throws IOException {
		int tests = ni();
		for (int test = 1; test <= tests; test++) {
			int n = ni();
			int[] a = na(n);
			int ans = 0;

			if (n > 2) {

				int[] b = new int[n - 1];
				int m = 0;
				for (int i = 1; i < n; i++) {
					if (a[i] > a[m]) {
						m = i;
					}
				}
				int p = 0;
				for (int i = 0; i < m; i++) {
					b[p++] = a[i];
				}
				for (int i = m + 1; i < n; i++) {
					b[p++] = a[i];
				}
				ans = solove(p, b, m);
			}

			int chek = bf(n, a);
			if (ans != chek) {
				// System.err.println(ans + " " + chek);
				// System.err.println(Arrays.toString(a));
			}

			pw.println("Case #" + test + ": " + chek);
			System.out.println(test);
		}
	}

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(br.readLine());
		return st.nextToken();
	}

	int[] na(int a_len) throws IOException {
		int[] _a = new int[a_len];
		for (int i = 0; i < a_len; i++)
			_a[i] = ni();
		return _a;
	}

	int ni() throws IOException {
		return Integer.parseInt(next());
	}

	String nl() throws IOException {
		return br.readLine();
	}

	static PrintWriter pw;
	static BufferedReader br;
	static StringTokenizer st;

	public static void main(String[] args) throws IOException {
		long timeout = System.currentTimeMillis();
		br = new BufferedReader(new FileReader(new File("B-small-attempt1.in")));
		pw = new PrintWriter(new FileWriter(new File("output.txt")));
		new B().run();
		System.out.println(System.currentTimeMillis() - timeout);
		br.close();
		pw.close();
	}

}
