import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

    private static final String input = "B-small-attempt0.in";
    private static final String output = "output.txt";

    final int n = 24 * 60;
    final int k = 2;
    final int m = n / k;
    final int inf = 2 * n;
    int[][][] dp = new int[k][n][m + 1];

    private int solve(int n, boolean[][] a) {
        int k = 2;
        int m = n / k;

        int offset = 0;

        for (int i = 0; i < n; i++) {
            if (!a[0][i]) {
                offset = i;
                break;
            }
        }

        for (int p = 0; p < k; p++) {
            for (int i = 0; i < n; i++) {
                for (int x = 0; x <= m; x++) {
                    dp[p][i][x] = inf;
                }
            }
        }

        for (int i = 0; i < n; i++) {
            int u = (i + offset - 1 + n) % n;
            int v = (i + offset - 0 + n) % n;

            if (i == 0) {
                dp[1][v][0] = 0;
                continue;
            }

            for (int w = 0; w <= m; w++) {
                int x = w;
                int y = (i + 1) - w;
                if (y <= 0) {
                    continue;
                }

                if (a[0][v]) {
                    if (x == 0) {
                     //  dp[0][v][w] = 1;
                    } else {
                        if (a[0][u]) {
                            dp[0][v][w] = min(dp[0][v][w], dp[0][u][w - 1]);
                        }

                        if (a[1][u]) {
                            dp[0][v][w] = min(dp[0][v][w], dp[1][u][w - 1] + 1);
                        }
                    }
                }

                if (a[1][v]) {
                    if (a[0][u]) {
                        dp[1][v][w] = min(dp[1][v][w], dp[0][u][w] + 1);
                    }

                    if (a[1][u]) {
                        dp[1][v][w] = min(dp[1][v][w], dp[1][u][w]);
                    }
                }
            }
        }

        int i = n - 1;
        int v = (i + offset - 0 + n) % n;

        int ans = inf;

        if (a[0][v]) {
            ans = min(ans, dp[0][v][m] + 1);
        }

        if (a[1][v]) {
            ans = min(ans, dp[1][v][m]);
        }

        return ans;
    }

    void runTestsFromFile() {

        int tests = nextInt();

        for (int test = 1; test <= tests; test++) {

            long time = System.currentTimeMillis();

            int c = nextInt();
            int j = nextInt();

            boolean[] a = new boolean[n];
            boolean[] b = new boolean[n];

            Arrays.fill(a, true);
            Arrays.fill(b, true);

            for (int i = 0; i < c; i++) {
                int f = nextInt(), t = nextInt();

                for (int m = f; m < t; m++) {
                    a[m] = false;
                }
            }

            for (int i = 0; i < j; i++) {
                int f = nextInt(), t = nextInt();

                for (int m = f; m < t; m++) {
                    b[m] = false;
                }
            }

            int ans;

            if (c < j) {
                ans = solve(n, new boolean[][] { b, a });
            } else {
                ans = solve(n, new boolean[][] { a, b });
            }
            System.gc();
            printf(Locale.ENGLISH, "Case #%d: %d%n", test, ans);
            System.out.println(test + " " + (System.currentTimeMillis() - time));
        }
    }

    void run() {
        // stress();
        runTestsFromFile();

    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public B(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        B solution = new B(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}