import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

    private static final String input = "B-small-attempt0.in";
    private static final String output = "B-output.txt";

    private boolean[][] solve(int n, long m) {
        boolean[][] e = new boolean[n][n];

        if (n == 2) {
            if (m == 1) {
                e[0][n - 1] = true;
            } else {
                e = null;
            }
            return e;
        }

        if (n == 3) {
            if (m == 1) {
                e[0][n - 1] = true;
            } else if (m == 2) {
                e[0][n - 1] = true;
                e[0][1] = true;
                e[1][n - 1] = true;
            } else {
                e = null;
            }
            return e;
        }

        int l = 1;
        int r = 2;

        if (m % 2 == 1) {
            e[0][n - 1] = true;
        }

        return e;
    }

    boolean[][] solveSlow(int n, long m) {
        int p = (n * (n - 1)) / 2;
        int k = 1 << p;

        for (int mask = 1; mask < k; mask++) {
            boolean[][] e = new boolean[n][n];

            for (int i = 0, x = 0; x < n; x++) {
                for (int y = x + 1; y < n; y++, i++) {
                    if ((mask & (1 << i)) > 0) {
                        e[x][y] = true;
                    }
                }
            }

            if (check(0, n - 1, n, e, new long[n], new int[n]) == m) {
                return e;
            }

        }

        return null;
    }

    long check(int from, int to, int n, boolean[][] e, long[] dp, int[] color) {
        if (from == to) {
            return 1;
        }
        if (color[from] == 2) {
            return dp[from];
        }

        if (color[from] == 1) {
            throw new RuntimeException("LOOP");
        }

        color[from] = 1;

        for (int vertex = 0; vertex < n; vertex++) {
            if (e[from][vertex]) {
                dp[from] += check(vertex, to, n, e, dp, color);
            }
        }

        color[from] = 2;
        return dp[from];
    }

    void run() {
        int tests = nextInt();

        for (int test = 1; test <= tests; test++) {

            int n = nextInt();
            long m = nextLong();

            boolean[][] e = solveSlow(n, m);

            printf(Locale.ENGLISH, "Case #%d: ", test);
            if (e == null) {
                println("IMPOSSIBLE");
            } else {
                println("POSSIBLE");
                for (int x = 0; x < n; x++) {
                    for (int y = 0; y < n; y++) {
                        if (e[x][y]) {
                            print('1');
                        } else {
                            print('0');
                        }
                    }
                    println();
                }
                // try {
                // long k = check(0, n - 1, n, e, new long[n], new int[n]);
                // if (k != m) {
                // throw new RuntimeException(k + " " + m);
                // }
                // } catch (RuntimeException error) {
                // System.err.println(error.getMessage());
                // }
            }
            System.err.printf("%3d / %3d%n", test, tests);
        }
    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public B(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        B solution = new B(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}
