import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class A extends PrintWriter {

	private static final String input = "A-small-attempt0.in";
	private static final String output = "A-output.txt";

	int m = 1000001;
	int[] ans = new int[m];

	int reverse(int n) {
		int ans = 0;
		while (n > 0) {
			ans *= 10;
			ans += n % 10;
			n /= 10;
		}
		return ans;
	}

	long reverse(long n) {
		long ans = 0;
		while (n > 0) {
			ans *= 10;
			ans += n % 10;
			n /= 10;
		}
		return ans;
	}

	int log(long n) {
		int l = 0;
		while (n > 0) {
			n /= 10;
			++l;
		}

		return l;
	}

	int last(long n) {
		int l = 0;
		while (n > 0) {
			l = (int) (n % 10);
			n /= 10;
		}
		return l;
	}

	long powt(int n) {
		long p = 1;
		while (--n >= 0) {
			p *= 10;
		}
		return p;

	}

	long rec(long n) {
		if (n < 1001) {
			return ans[(int) n];
		}

		int v = log(n);

		int l = (v + 1) / 2;

		long mask = powt(l);

		long z = (n / mask) * mask;

		if (z == powt(v - 1)) {
			return rec(z - 1) + n - z + 1;
		}

		if (z == n) {
			return rec(z - 1) + n - z + 1;
		}

		long x = z + 1;

		if (n == x) {
			long y = reverse(x);
			if (x <= y) {
				return rec(x - 1) + 1;
			} else {
				return rec(y) + 1;
			}
		} else {
			return rec(x) + n - x;
		}
	}

	void run() {
		int t = nextInt();

		boolean[] color = new boolean[m];

		for (int i = 0; i < m; i++) {
			ans[i] = i;
		}

		Arrays.fill(color, true);

		int[] q = new int[m];

		int head = 0, tail = 0;

		q[tail++] = 1;
		color[1] = false;

		while (head < tail) {
			int v = q[head++];

			int x = v + 1, y = reverse(v);

			if (x < m && color[x]) {
				q[tail++] = x;
				color[x] = false;
				ans[x] = min(ans[x], ans[v] + 1);
			}
			if (y < m && color[y]) {
				q[tail++] = y;
				color[y] = false;
				ans[y] = min(ans[y], ans[v] + 1);
			}
		}

		for (int test = 1; test <= t; test++) {
			int n = nextInt();
			printf(Locale.ENGLISH, "Case #%d: %d%n", test, ans[n]);
		}
	}

	int[][] nextMatrix(int n, int m) {
		int[][] matrix = new int[n][m];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				matrix[i][j] = nextInt();
		return matrix;
	}

	String next() {
		while (!tokenizer.hasMoreTokens())
			tokenizer = new StringTokenizer(nextLine());
		return tokenizer.nextToken();
	}

	boolean hasNext() {
		while (!tokenizer.hasMoreTokens()) {
			String line = nextLine();
			if (line == null) {
				return false;
			}
			tokenizer = new StringTokenizer(line);
		}
		return true;
	}

	int[] nextArray(int n) {
		int[] array = new int[n];
		for (int i = 0; i < n; i++) {
			array[i] = nextInt();
		}
		return array;
	}

	int nextInt() {
		return Integer.parseInt(next());
	}

	long nextLong() {
		return Long.parseLong(next());
	}

	double nextDouble() {
		return Double.parseDouble(next());
	}

	String nextLine() {
		try {
			return reader.readLine();
		} catch (IOException err) {
			return null;
		}
	}

	public A(OutputStream outputStream) {
		super(outputStream);
	}

	static BufferedReader reader;
	static StringTokenizer tokenizer = new StringTokenizer("");
	static Random rnd = new Random();
	static boolean OJ;

	public static void main(String[] args) throws IOException {
		A solution = new A(new FileOutputStream(output));
		reader = new BufferedReader(new FileReader(new File(input)));
		solution.run();
		solution.close();
		reader.close();
	}
}