import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class B extends PrintWriter {

    private static final String input = "B-small-attempt1.in";
    private static final String output = "output.txt";

    String solve(int r, int y, int b) {
        StringBuilder builder = new StringBuilder();

        boolean t = true;
        while (r > 0 && b > 0 && y > 0) {
            --r;
            --b;
            --y;
            if (t) {
                builder.append("RBY");
            } else {
                builder.append("RYB");
            }
            t ^= true;
        }

        if (r == 0) {
            while (b > 0 && y > 0) {
                if (t) {
                    builder.append('Y');
                    --y;
                } else {
                    builder.append('B');
                    --b;
                }
                t ^= true;
            }
        } else {
            if (b == 0) {
                while (r > 0 && y > 0) {
                    builder.append("RY");
                    --r;
                    --y;
                }
            } else {
                while (r > 0 && b > 0) {
                    builder.append("RB");
                    --r;
                    --b;
                }
            }
        }

        String res = builder.toString();

        while (r > 0) {
            boolean f = true;

            if (res.contains("YB")) {
                res = res.replaceFirst("YB", "YRB");
                --r;
                f = false;
            }

            if (res.contains("BY")) {
                res = res.replaceFirst("BY", "BRY");
                --r;
                f = false;
            }

            if (f) {
                return null;
            }
        }

        while (b > 0) {
            boolean f = true;

            if (res.contains("RY")) {
                res = res.replaceFirst("RY", "RBY");
                --b;
                f = false;
            }

            if (res.contains("YR")) {
                res = res.replaceFirst("YR", "YBR");
                --b;
                f = false;
            }

            if (f) {
                return null;
            }
        }

        while (y > 0) {
            boolean f = true;

            if (res.contains("RB")) {
                res = res.replaceFirst("RB", "RYB");
                --y;
                f = false;
            }

            if (res.contains("BR")) {
                res = res.replaceFirst("BR", "BYR");
                --y;
                f = false;
            }

            if (f) {
                return null;
            }
        }

        return res;
    }

    String solveP(int r, int y, int b) {
        String ans = null;

        if ((ans = solve(r, y, b)) != null) {
            int n = ans.length();
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < n; i++) {
                if (ans.charAt(i) == 'R') {
                    builder.append('R');
                }
                if (ans.charAt(i) == 'Y') {
                    builder.append('Y');
                }
                if (ans.charAt(i) == 'B') {
                    builder.append('B');
                }
            }
            return builder.toString();
        }
        if ((ans = solve(r, b, y)) != null) {
            int n = ans.length();
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < n; i++) {
                if (ans.charAt(i) == 'R') {
                    builder.append('R');
                }
                if (ans.charAt(i) == 'Y') {
                    builder.append('B');
                }
                if (ans.charAt(i) == 'B') {
                    builder.append('Y');
                }
            }
            return builder.toString();
        }
        if ((ans = solve(y, r, b)) != null) {
            int n = ans.length();
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < n; i++) {
                if (ans.charAt(i) == 'R') {
                    builder.append('Y');
                }
                if (ans.charAt(i) == 'Y') {
                    builder.append('R');
                }
                if (ans.charAt(i) == 'B') {
                    builder.append('B');
                }
            }
            return builder.toString();
        }
        if ((ans = solve(y, b, r)) != null) {
            int n = ans.length();
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < n; i++) {
                if (ans.charAt(i) == 'R') {
                    builder.append('Y');
                }
                if (ans.charAt(i) == 'Y') {
                    builder.append('B');
                }
                if (ans.charAt(i) == 'B') {
                    builder.append('R');
                }
            }
            return builder.toString();
        }
        if ((ans = solve(b, r, y)) != null) {
            int n = ans.length();
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < n; i++) {
                if (ans.charAt(i) == 'R') {
                    builder.append('B');
                }
                if (ans.charAt(i) == 'Y') {
                    builder.append('R');
                }
                if (ans.charAt(i) == 'B') {
                    builder.append('Y');
                }
            }
            return builder.toString();
        }
        if ((ans = solve(b, y, r)) != null) {
            int n = ans.length();
            StringBuilder builder = new StringBuilder();
            for (int i = 0; i < n; i++) {
                if (ans.charAt(i) == 'R') {
                    builder.append('B');
                }
                if (ans.charAt(i) == 'Y') {
                    builder.append('Y');
                }
                if (ans.charAt(i) == 'B') {
                    builder.append('R');
                }
            }
            return builder.toString();
        }

        return null;
    }

    void runTestsFromFile() {

        int tests = nextInt();

        for (int test = 1; test <= tests; test++) {
            int n = nextInt(), r = nextInt(), o = nextInt(), y = nextInt(), g = nextInt(), b = nextInt(), v = nextInt();

            String ans = solveP(r, y, b);

            if (ans == null) {
                ans = "IMPOSSIBLE";
            }

            printf(Locale.ENGLISH, "Case #%d: %s%n", test, ans);
        }
    }

    void run() {
        // stress();
        runTestsFromFile();

    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public B(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        B solution = new B(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}