import java.io.*;
import java.util.*;
import java.math.BigInteger;
import java.util.Map.Entry;

import static java.lang.Math.*;

public class C extends PrintWriter {

    private static final String input = "C-small-attempt0.in";
    private static final String output = "output.txt";

    char[][] solve(int n, int m, char[][] map) {

        char[][] ans = new char[n][];

        for (int i = 0; i < n; i++) {
            ans[i] = map[i].clone();
        }

        boolean[][] fix = new boolean[n][m];

        for (int x = 0; x < n; x++) {
            for (int y = 0; y < m; y++) {

                if (ans[x][y] == '|' || ans[x][y] == '-') {
                    boolean ud = false, lr = false;
                    {
                        int cx = x - 1, cy = y;
                        while (cx >= 0 && ans[cx][cy] != '#') {
                            if (ans[cx][cy] != '.') {
                                ud = true;
                            }
                            --cx;
                        }
                    }

                    {
                        int cx = x + 1, cy = y;
                        while (cx < n && ans[cx][cy] != '#') {
                            if (ans[cx][cy] != '.') {
                                ud = true;
                            }
                            ++cx;
                        }
                    }

                    {
                        int cx = x, cy = y - 1;
                        while (cy >= 0 && ans[cx][cy] != '#') {
                            if (ans[cx][cy] != '.') {
                                lr = true;
                            }
                            --cy;
                        }
                    }

                    {
                        int cx = x, cy = y + 1;
                        while (cy < m && ans[cx][cy] != '#') {
                            if (ans[cx][cy] != '.') {
                                lr = true;
                            }
                            ++cy;
                        }
                    }

                    if (lr && ud) {
                        return null;
                    }

                    if (lr) {
                        ans[x][y] = '|';
                        fix[x][y] = true;
                    }

                    if (ud) {
                        ans[x][y] = '-';
                        fix[x][y] = true;
                    }
                }
            }
        }

        for (int rep = 0; rep < 10000000; rep++) {
            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    if (ans[x][y] == '.') {
                        int[][] p = new int[4][2];
                        int len = 0;

                        {
                            int cx = x - 1, cy = y;
                            while (cx >= 0 && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '|') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                --cx;
                            }
                        }

                        {
                            int cx = x + 1, cy = y;
                            while (cx < n && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '|') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                ++cx;
                            }
                        }

                        {
                            int cx = x, cy = y - 1;
                            while (cy >= 0 && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '-') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                --cy;
                            }
                        }

                        {
                            int cx = x, cy = y + 1;
                            while (cy < m && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '-') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                ++cy;
                            }
                        }

                        if (len == 0) {

                            {
                                int cx = x - 1, cy = y;
                                while (cx >= 0 && ans[cx][cy] != '#') {
                                    if (ans[cx][cy] != '.') {
                                        if (ans[cx][cy] == '|' || !fix[cx][cy]) {
                                            p[len][0] = cx;
                                            p[len][1] = cy;
                                            ++len;
                                        }
                                        break;
                                    }
                                    --cx;
                                }
                            }

                            {
                                int cx = x + 1, cy = y;
                                while (cx < n && ans[cx][cy] != '#') {
                                    if (ans[cx][cy] != '.') {
                                        if (ans[cx][cy] == '|' || !fix[cx][cy]) {
                                            p[len][0] = cx;
                                            p[len][1] = cy;
                                            ++len;
                                        }
                                        break;
                                    }
                                    ++cx;
                                }
                            }

                            {
                                int cx = x, cy = y - 1;
                                while (cy >= 0 && ans[cx][cy] != '#') {
                                    if (ans[cx][cy] != '.') {
                                        if (ans[cx][cy] == '-' || !fix[cx][cy]) {
                                            p[len][0] = cx;
                                            p[len][1] = cy;
                                            ++len;
                                        }
                                        break;
                                    }
                                    --cy;
                                }
                            }

                            {
                                int cx = x, cy = y + 1;
                                while (cy < m && ans[cx][cy] != '#') {
                                    if (ans[cx][cy] != '.') {
                                        if (ans[cx][cy] == '-' || !fix[cx][cy]) {
                                            p[len][0] = cx;
                                            p[len][1] = cy;
                                            ++len;
                                        }
                                        break;
                                    }
                                    ++cy;
                                }
                            }
                            if (len == 0) {
                                return null;
                            } else {
                                int i = rnd.nextInt(len);
                                int cx = p[i][0];
                                int cy = p[i][1];

                                if (ans[cx][cy] == '|') {
                                    ans[cx][cy] = '-';
                                } else {
                                    ans[cx][cy] = '|';
                                }

                            }

                        }

                    }
                }
            }

            boolean ok = true;

            for (int x = 0; x < n; x++) {
                for (int y = 0; y < m; y++) {
                    if (ans[x][y] == '.') {
                        int[][] p = new int[4][2];
                        int len = 0;

                        {
                            int cx = x - 1, cy = y;
                            while (cx >= 0 && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '|') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                --cx;
                            }
                        }

                        {
                            int cx = x + 1, cy = y;
                            while (cx < n && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '|') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                ++cx;
                            }
                        }

                        {
                            int cx = x, cy = y - 1;
                            while (cy >= 0 && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '-') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                --cy;
                            }
                        }

                        {
                            int cx = x, cy = y + 1;
                            while (cy < m && ans[cx][cy] != '#') {
                                if (ans[cx][cy] != '.') {
                                    if (ans[cx][cy] == '-') {
                                        p[len][0] = cx;
                                        p[len][1] = cy;
                                        ++len;
                                    }
                                    break;
                                }
                                ++cy;
                            }
                        }

                        ok &= len > 0;
                    }
                }
            }

            if (ok) {
                return ans;
            }

        }

        return null;
    }

    void runTestsFromFile() {
        int tests = nextInt();
        for (int test = 1; test <= tests; test++) {

            int n = nextInt(), m = nextInt();

            char[][] map = new char[n][];

            for (int i = 0; i < n; i++) {
                map[i] = next().toCharArray();
            }
            char[][] ans = solve(n, m, map);

            if (ans == null) {
                printf(Locale.ENGLISH, "Case #%d: IMPOSSIBLE%n", test);
            } else {
                printf(Locale.ENGLISH, "Case #%d: POSSIBLE%n", test);

                for (int i = 0; i < n; i++) {
                    println(new String(ans[i]));
                }
            }

            System.out.println("test" + test);

        }
    }

    void run() {
        // stress();
        runTestsFromFile();
    }

    int[][] nextMatrix(int n, int m) {
        int[][] matrix = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                matrix[i][j] = nextInt();
        return matrix;
    }

    String next() {
        while (!tokenizer.hasMoreTokens())
            tokenizer = new StringTokenizer(nextLine());
        return tokenizer.nextToken();
    }

    boolean hasNext() {
        while (!tokenizer.hasMoreTokens()) {
            String line = nextLine();
            if (line == null) {
                return false;
            }
            tokenizer = new StringTokenizer(line);
        }
        return true;
    }

    int[] nextArray(int n) {
        int[] array = new int[n];
        for (int i = 0; i < n; i++) {
            array[i] = nextInt();
        }
        return array;
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException err) {
            return null;
        }
    }

    public C(OutputStream outputStream) {
        super(outputStream);
    }

    static BufferedReader reader;
    static StringTokenizer tokenizer = new StringTokenizer("");
    static Random rnd = new Random();
    static boolean OJ;

    public static void main(String[] args) throws IOException {
        C solution = new C(new FileOutputStream(output));
        reader = new BufferedReader(new FileReader(new File(input)));
        solution.run();
        solution.close();
        reader.close();
    }
}