import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;

import static java.lang.Math.*;


public class Solution implements Runnable{

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}
	
	public void run() {
		try {
			br = new BufferedReader(new FileReader("1.in"));
			pw = new PrintWriter(new FileWriter("1.txt"));
			solve();
			br.close();
			pw.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private String binStr(int n) {
		String ans = Integer.toBinaryString(n);
		while (ans.length() < 22) ans = '0' + ans;
		return ans;
	}
	
	private String add(String s1, String s2) {
		StringBuilder res = new StringBuilder();
		for (int i = 0; i < s1.length(); i++) {
			if (s1.charAt(i) == s2.charAt(i)) res.append('0');
			else res.append('1');
		}
		return res.toString();
	}
	
	private void testCase(int test) throws Exception {
		int ans = 0;
		int n = nextInt();
		int a[] = new int[n];
		int as = 0;
		for (int i = 0; i < n; i++) {
			a[i] = nextInt();
			as += a[i];
		}
		for (int mask = 1; mask < (1 << n) - 1; mask++) {
			String s1 = binStr(0);
			String s2 = binStr(0);
			int sum = 0;
			for (int i = 0; i < n; i++) {
				if ((mask & (1 << i)) != 0) {
					s1 = add(s1, binStr(a[i]));
					sum += a[i];
				}
				else {
					s2 = add(s2, binStr(a[i]));
				}
			}
			if (s1.equals(s2)) {
				ans = max(ans, max(sum, as - sum));
			}
		}
		pw.format("Case #%s: %s\n", test, (ans == 0) ? "NO" : ans);
	}
	
	private void solve() throws Exception {
		int tests = nextInt();
		for (int test = 0; test < tests; test++) {
			testCase(test + 1);
		}
	}
	
	private BufferedReader br;
	private PrintWriter pw;
	private StringTokenizer tok;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreElements()){
			tok = new StringTokenizer(br.readLine());
		}
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

}
