import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;

import static java.lang.Math.*;


public class Solution implements Runnable{

	public static void main(String[] args) {
		new Thread(new Solution()).start();
	}
	
	public void run() {
		try {
			br = new BufferedReader(new FileReader("1.in"));
			pw = new PrintWriter(new FileWriter("2.txt"));
			solve();
			br.close();
			pw.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private void testCase(int test) throws Exception {
		int countCh = nextInt();
		char[][] ch = new char[2 * countCh][3];
		for (int i = 0; i < countCh; i++) {
			String s = next();
			ch[2 * i][0] = s.charAt(0);
			ch[2 * i][1] = s.charAt(1);
			ch[2 * i + 1][1] = s.charAt(0);
			ch[2 * i + 1][0] = s.charAt(1);
			ch[2 * i][2] = s.charAt(2);
			ch[2 * i + 1][2] = s.charAt(2);
		}
		int countDel = nextInt();
		char[][] del = new char[2 * countDel][2];
		for (int i = 0; i < countDel; i++) {
			String s = next();
			del[2 * i][0] = s.charAt(0);
			del[2 * i][1] = s.charAt(1);
			del[2 * i + 1][0] = s.charAt(1);
			del[2 * i + 1][1] = s.charAt(0);
		}
		nextInt();
		String txt = next();
		StringBuilder ans = new StringBuilder();
		Set<Character> chars = new HashSet<Character>(); 
		
		for (int i = 0; i < txt.length(); i++) {
			if (ans.length() == 0) {
				ans.append(txt.charAt(i));
				chars.add(txt.charAt(i));
				continue;
			}
			boolean flag = true;
			for (int j = 0; j < 2 * countCh; j++) {
				if (ans.charAt(ans.length()-1) == ch[j][0] && txt.charAt(i) == ch[j][1]) {
					ans.setCharAt(ans.length()-1, ch[j][2]);
					if (ans.indexOf("" + ch[j][0]) == -1) chars.remove(ch[j][0]);
					flag = false;
					break;
				}
			}
			for (int j = 0; j < 2 * countDel && flag; j++) {
				if (chars.contains(del[j][0]) && del[j][1] == txt.charAt(i)){
					ans = new StringBuilder();
					chars.clear();
					flag = false;
					break;
				}
			}
			if (flag) {
				ans.append(txt.charAt(i));
				chars.add(txt.charAt(i));
			}
		}
		StringBuilder ss = new StringBuilder("[");
		char[] tmp = ans.toString().toCharArray();
		for (int i = 0; i < tmp.length; i++) {
			if (i > 0) ss.append(", ");
			ss.append(tmp[i]);
		}
		ss.append("]");
		pw.format("Case #%s: %s\n", test, ss);
	}
	
	private void solve() throws Exception {
		int tests = nextInt();
		for (int test = 0; test < tests; test++) {
			testCase(test + 1);
		}
	}
	
	private BufferedReader br;
	private PrintWriter pw;
	private StringTokenizer tok;
	
	private String next() throws Exception {
		while (tok == null || !tok.hasMoreElements()){
			tok = new StringTokenizer(br.readLine());
		}
		return tok.nextToken();
	}
	
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

}
