import java.io.*;
import java.math.BigInteger;
import java.util.*;

/**
 * Created by sasha on 09.04.2016.
 */
public class C {

    private final List<Integer> primes = calculatePrimes();

    private List<Integer> calculatePrimes() {
        List<Integer> result = new ArrayList<>();
        result.add(2);
        result.add(3);
        result.add(5);
        result.add(7);
        for (int i = 11; i < 1000 * 1000; i += 2) {
            if (isPrime(i, result)) result.add(i);
        }
        return result;
    }

    private boolean isPrime(int i, List<Integer> result) {
        boolean prime = true;
        for (int j = 0; j < result.size() && result.get(j) * result.get(j) <= i; j++) {
            if (i % result.get(j) == 0) prime = false;
        }
        return prime;
    }

    private void solution() throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader("input.txt"));
        PrintWriter writer = new PrintWriter(new FileWriter("output.txt"));
        int testsCount = Integer.parseInt(reader.readLine());
        for (int test = 0; test < testsCount; test++) {
            writer.printf("Case #%d:\n", test+1);
            StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
            int n = Integer.parseInt(tokenizer.nextToken());
            int pk = Integer.parseInt(tokenizer.nextToken());
            for (int i = 0; i < (1 << (n-2)) && pk > 0; i++) {
                String s1 = Integer.toBinaryString(i);
                while (s1.length() < n-2) s1 = "0" + s1;
                String s = "1" + s1 + "1";
                boolean good = true;
                for (int j = 2; j < 11 && good; j++) {
                    BigInteger bi = new BigInteger(s, j);
                    if (bi.isProbablePrime(100)) good = false;

                }
                if (good) {
                    writer.print(s + " ");
                    for (int j = 2; j < 11; j++) {
                        BigInteger bi = new BigInteger(s, j);
                        for (Integer prime : primes) {
                            if (bi.mod(BigInteger.valueOf(prime)).equals(BigInteger.ZERO)) {
                                writer.print(prime + " ");
                                break;
                            }
                        }

                    }
                    writer.println();
                    pk--;
                }
            }
        }
        writer.close();
    }

    public static void main(String[] args) throws IOException {
        new C().solution();
    }
}
