import java.util.*;
import java.io.*;
import java.math.*;
import java.awt.geom.*;

import static java.lang.Math.*;

public class Solution implements Runnable {

	public void solve() throws Exception {
		int T = sc.nextInt();
		for (int Case = 1; Case <= T; Case++) {
			int P = sc.nextInt(), Q = sc.nextInt(), N = sc.nextInt();
			int[] H = new int[N], G = new int[N];
			int[] me = new int[N], tower = new int[N];
			for (int i = 0; i < N; i++) {
				H[i] = sc.nextInt();
				G[i] = sc.nextInt();
				me[i] = (H[i] + P - 1) / P;
				tower[i] = 0;
				for (int mei = 1; (mei - 1) * P < H[i]; mei++) {
					int left = H[i] - (mei - 1) * P;
					int toweri = (left - 1) / Q;
					int leftAfter = left - toweri * Q;
					if (toweri == 0 || leftAfter > P) {
						continue;
					} else {
						me[i] = mei;
						tower[i] = toweri;
						break;
					}
				}
			}
			int[][] dp = new int[N + 1][20 * N];
			for (int i = 0; i <= N; i++) {
				Arrays.fill(dp[i], Integer.MIN_VALUE / 3);
			}
			dp[0][1] = 0;
			for (int i = 0; i < N; i++) {
				for (int j = 0; j < 20 * N; j++) {
					if (dp[i][j] == Integer.MIN_VALUE / 3) {
						continue;
					}
					dp[i + 1][j + (H[i] + Q - 1) / Q] = max(dp[i + 1][j], dp[i][j]);
					if (j + tower[i] - me[i] >= 0) {
						dp[i + 1][j + tower[i] - me[i]] = max(dp[i + 1][j + tower[i] - me[i]], dp[i][j] + G[i]);
					}
				}
			}
			int ans = 0;
			for (int i = 0; i < 20 * N; i++) {
				ans = max(ans, dp[N][i]);
			}
			
			out.printf(Locale.US, "Case #%d: %d\n", Case, ans);
		}
	}

	static Throwable uncaught;

	BufferedReader in;
	FastScanner sc;
	PrintWriter out;

	@Override
	public void run() {
		try {
			//in = new BufferedReader(new InputStreamReader(System.in));
			//out = new PrintWriter(System.out);
			in = new BufferedReader(new FileReader("B-small-attempt0.in"));
			out = new PrintWriter("B-small-attempt0.out");
			sc = new FastScanner(in);
			solve();
		} catch (Throwable uncaught) {
			Solution.uncaught = uncaught;
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) throws Throwable {
		Thread thread = new Thread(null, new Solution(), "", (1 << 26));
		thread.start();
		thread.join();
		if (Solution.uncaught != null) {
			throw Solution.uncaught;
		}
	}

}

class FastScanner {

	BufferedReader in;
	StringTokenizer st;

	public FastScanner(BufferedReader in) {
		this.in = in;
	}

	public String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(nextToken());
	}

}