import java.util.*;
import java.io.*;
import java.math.*;
import java.awt.geom.*;

import static java.lang.Math.*;

public class Solution implements Runnable {

	public void solve() throws Exception {
		int t = sc.nextInt();
	outer:
		for (int Case = 1; Case <= t; Case++) {
			int n = sc.nextInt(), m = sc.nextInt();
			int[][] h = new int[n][m];
			int[] maxr = new int[n], maxc = new int[m];
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					h[i][j] = sc.nextInt();
					maxr[i] = max(maxr[i], h[i][j]);
					maxc[j] = max(maxc[j], h[i][j]);
				}
			}
			out.print("Case #" + Case + ": ");
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < m; j++) {
					if (h[i][j] < maxr[i] && h[i][j] < maxc[j]) {
						out.println("NO");
						continue outer;
					}
				}
			}
			out.println("YES");
		}
	}

	static Throwable uncaught;

	BufferedReader in;
	FastScanner sc;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new BufferedReader(new FileReader("B-large.in"));
			out = new PrintWriter(new FileWriter("B-large.out"));
			sc = new FastScanner(in);
			solve();
		} catch (Throwable uncaught) {
			Solution.uncaught = uncaught;
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) throws Throwable {
		Thread thread = new Thread(null, new Solution(), "", (1 << 26));
		thread.start();
		thread.join();
		if (Solution.uncaught != null) {
			throw Solution.uncaught;
		}
	}

}

class FastScanner {

	BufferedReader in;
	StringTokenizer st;

	public FastScanner(BufferedReader in) {
		this.in = in;
	}

	public String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(nextToken());
	}

	public double nextDouble() throws Exception {
		return Double.parseDouble(nextToken());
	}

}