import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.Scanner;


public class CoinJam {
	static ArrayList<String> jamcoins = new ArrayList<String>();
	
	public static void main(String args[]) throws FileNotFoundException, UnsupportedEncodingException{
		Scanner scan = new Scanner(System.in);
		PrintWriter out = new PrintWriter("output.txt", "UTF-8");
		
		System.out.println("Input Filename: ");
		String filename = scan.nextLine();
		try {scan = new Scanner(new File(filename));}
		catch(Exception e){
			System.out.println("Invalid File Input");
			return;
		}
		
		int sets = scan.nextInt();
		for(int k = 1; k <= sets; ++k){
			out.println("Case #" + k + ": ");
			int N = scan.nextInt();
			int J = scan.nextInt();
			int count = 0;
			int index = 0;
			
			findAllStrings(N, N, "");
			while(count < J && index < jamcoins.size()){
				String coin = jamcoins.get(index);
				int[] coinDivisors = new int[9];
				boolean success = true;
				//System.out.println("COIN: " + coin);
				for(int base = 2; base <= 10; ++base){
					long value = findNumBase(coin, base);
					int divisor = findNonTrivialDivisor(value);
					
					//System.out.println("BASE: " + base + " VALUE: " + value + " DIVISOR: " + divisor);
					if(value == 0 || divisor == -1){
						success = false;
						break;
					}
					else {
						coinDivisors[base-2] = divisor;
					}
				}
				
				if(success){
					out.print(coin + " ");
					for(int i = 0; i < 9; ++i){
						out.print(coinDivisors[i]);
						if(i < 8) out.print(" ");
					}
					out.println();
					++count;
				}
				++index;
			}
		}
		out.close();
	}
	
	static long findNumBase(String N, int base){
		long total = 0;
		for(int k = N.length()-1; k >= 0; --k){
			long toAdd = (long) ((long) Character.getNumericValue(N.charAt(k)) * Math.pow(base, N.length()-1-k));
			if(total > Long.MAX_VALUE - toAdd) return 0;
			total += toAdd;
		}
		return total;
	}
	
	static int findNonTrivialDivisor(long value){
		if(value <= 0) return -1;
		if(value % 2 == 0) return 2;
		for(int k = 3; k*k <= value; k+= 2){
			if(value % k == 0) return k;
		}
		return -1;
	}
	
	
	static void findAllStrings(int curN, int N, String num){
		if(curN - 1 <= 0){
			jamcoins.add(num+"1");
			return;
		}
		
		if(curN == N){
			findAllStrings(curN-1, N, "1");
		}
		else {
			findAllStrings(curN-1, N, num+"0");
			findAllStrings(curN-1, N, num+"1");
		}
		
	}
	
}
