import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Scanner;


public class RevengeOfThePancakes {
	@SuppressWarnings("resource")
	public static void main(String args[]) throws FileNotFoundException, UnsupportedEncodingException{
		Scanner scan = new Scanner(System.in);
		PrintWriter out = new PrintWriter("output.txt", "UTF-8");
		
		System.out.println("Input Filename: ");
		String filename = scan.nextLine();
		
		try {scan = new Scanner(new File(filename));}
		catch(Exception e){
			System.out.println("Invalid File Input");
			return;
		}
		
		int sets = scan.nextInt(); scan.nextLine();
		for(int k = 1; k <= sets; ++k){
			String pancakes = scan.nextLine();
			int lastCake = pancakes.length() - 1;
			int flipCount = 0;
			
			while(!isHappy(pancakes) && lastCake >= 0){
				//System.out.println(pancakes + " " + lastCake);
				if(pancakes.charAt(lastCake) == '-'){
					//System.out.println("FLIP!");
					pancakes = flip(pancakes, lastCake);
					flipCount++;
				}
				lastCake--;
			}
			out.println("Case #" + k + ": " + flipCount);
		}
		out.close();
	}
	
	static boolean isHappy(String pancakes){
		for(int k = 0; k < pancakes.length(); ++k){
			if(pancakes.charAt(k) != '+'){
				return false;
			}
		}
		return true;
	}
	
	static String flip(String pancakes, int index){
		String output = "";
		for(int k = 0; k <= index; ++k){
			output += pancakes.charAt(k) == '+' ? "-" : "+";
		}
		for(int k = index+1; k < pancakes.length(); ++k){
			output += pancakes.charAt(k);
		}
		return output;
	}
}
