import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Arrays;
import java.util.Scanner;


public class CountingSheep {

	public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
		Scanner scan = new Scanner(System.in);
		PrintWriter out = new PrintWriter("output.txt", "UTF-8");
		
		System.out.println("Input Filename: ");
		String filename = scan.nextLine();
		
		try {scan = new Scanner(new File(filename));}
		catch(Exception e){
			System.out.println("Invalid File Input");
			return;
		}
		
		int sets = scan.nextInt();
		for(int k = 1; k <= sets; ++k){
			int n = scan.nextInt();
			//Edge Case
			if(n == 0){
				out.println("Case #" + k + ": " + "INSOMNIA");
				continue;
			}
			
			int[] digits = {0, 1, 2, 3, 4, 5, 6, 7, 8, 9};
			int i = 1;
			while(findDigits(digits)){
				int num = n * i;
				while(num > 0){
					int dig = num % 10;
					int index = search(digits, dig);
					if(index >= 0 && index < digits.length) digits[index] = -1;
					num /= 10;
				}
				++i;
			}
			out.println("Case #" + k + ": " + n*(i-1));
		}
		out.close();
	}
	
	static boolean findDigits(int[] digits){
		for(int k = 0; k < digits.length; k++){
			if(digits[k] != -1) return true;
		}
		return false;
	}
	
	static int search(int[] digits, int dig){
		for(int k = 0; k < digits.length; k++){
			if(digits[k] == dig) return k;
		}
		return -1;
	}

}
