package com.company;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Task3 {
	public static void main(String[] args) throws Exception {
		String fileName = "C-small-attempt1";
		BufferedReader br = new BufferedReader(new FileReader("input/" + fileName + ".in"));
		FileWriter fileWriter = new FileWriter("output/" + fileName + ".out");

		String newLine = br.readLine();
		int count_T = Integer.parseInt(newLine);
		for (int i = 0; i < count_T; i++) {
			newLine = br.readLine();
			int J1, J2, J3;
			int S;
			String[] newLines = newLine.split(" ");
			J1 = Integer.parseInt(newLines[0]);
			J2 = Integer.parseInt(newLines[1]);
			J3 = Integer.parseInt(newLines[2]);
			S = Integer.parseInt(newLines[3]);

			List<Outfit> allOutfits = new ArrayList<Outfit>();
			for (int j1Index = 1; j1Index <= J1; j1Index++) {
				for (int j2Index = 1; j2Index <= J2; j2Index++) {
					for (int j3Index = 1; j3Index <= J3; j3Index++) {
						allOutfits.add(new Outfit(j1Index, j2Index, j3Index));
					}
				}
			}

			Map<Combination, Integer> combinations = new HashMap<Combination, Integer>();
			List<Outfit> correctOutfits = new ArrayList<Outfit>();
			for (Outfit outfit : allOutfits) {
				List<Combination> outComb = Combination.getOutfitCombinations(outfit);
				Integer comb1Count = combinations.get(outComb.get(0));
				Integer comb2Count = combinations.get(outComb.get(1));
				Integer comb3Count = combinations.get(outComb.get(2));
				comb1Count = comb1Count == null ? 0 : comb1Count;
				comb2Count = comb2Count == null ? 0 : comb2Count;
				comb3Count = comb3Count == null ? 0 : comb3Count;
				if (comb1Count < S && comb2Count < S && comb3Count < S) {
					correctOutfits.add(outfit);
					combinations.put(outComb.get(0), comb1Count + 1);
					combinations.put(outComb.get(1), comb2Count + 1);
					combinations.put(outComb.get(2), comb3Count + 1);
				}
			}


			String line = "Case #" + (i + 1) + ": " + correctOutfits.size();
			fileWriter.write(line + "\n");
			for (Outfit correctOutfit : correctOutfits) {
				fileWriter.write(correctOutfit.j1 + " " + correctOutfit.j2 + " " + correctOutfit.j3 + "\n");
			}
			fileWriter.flush();
		}
		br.close();
		fileWriter.close();
	}

	static class Outfit {
		final int j1;
		final int j2;
		final int j3;

		Outfit(int j1, int j2, int j3) {
			this.j1 = j1;
			this.j2 = j2;
			this.j3 = j3;
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || getClass() != o.getClass()) return false;

			Outfit outfit = (Outfit) o;

			if (j1 != outfit.j1) return false;
			if (j2 != outfit.j2) return false;
			if (j3 != outfit.j3) return false;

			return true;
		}

		@Override
		public int hashCode() {
			int result = j1;
			result = 31 * result + j2;
			result = 31 * result + j3;
			return result;
		}
	}

	static class Combination {
		final int index1;
		final int index2;
		final int value1;
		final int value2;

		public Combination(int index1, int index2, int value1, int value2) {
			this.index1 = index1;
			this.index2 = index2;
			this.value1 = value1;
			this.value2 = value2;
		}

		public static List<Combination> getOutfitCombinations(Outfit outfit) {
			List<Combination> outfitComb = new ArrayList<Combination>(3);
			outfitComb.add(new Combination(1, outfit.j1, 2, outfit.j2));
			outfitComb.add(new Combination(1, outfit.j1, 3, outfit.j3));
			outfitComb.add(new Combination(2, outfit.j2, 3, outfit.j3));
			return outfitComb;
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || getClass() != o.getClass()) return false;

			Combination that = (Combination) o;

			if (index1 != that.index1) return false;
			if (index2 != that.index2) return false;
			if (value1 != that.value1) return false;
			if (value2 != that.value2) return false;

			return true;
		}

		@Override
		public int hashCode() {
			int result = index1;
			result = 31 * result + index2;
			result = 31 * result + value1;
			result = 31 * result + value2;
			return result;
		}
	}
}
