package com.company;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class Task1 {

	static final char NO_SYMBOL = '_';
	static final List<Digit> DIGITS = new ArrayList<Digit>() {{
		add(new Digit('Z', "ZERO", 0));
		add(new Digit('W', "TWO", 2));
		add(new Digit('X', "SIX", 6));
		add(new Digit('G', "EIGHT", 8));
		add(new Digit('U', "FOUR", 4));
		add(new Digit('R', "THREE", 3));
		add(new Digit('O', "ONE", 1));
		add(new Digit('F', "FIVE", 5));
		add(new Digit('S', "SEVEN", 7));
		add(new Digit('E', "NINE", 9));
	}};

	static class Digit {
		final char coreDigit;
		final char[] allDigits;
		final Integer digit;

		Digit(char coreDigit, String allDigits, Integer digit) {
			this.coreDigit = coreDigit;
			this.allDigits = allDigits.toCharArray();
			this.digit = digit;
		}
	}

	public static void main(String[] args) throws Exception {

		String fileName = "A-large";
		BufferedReader br = new BufferedReader(new FileReader("input/" + fileName + ".in"));
		FileWriter fileWriter = new FileWriter("output/" + fileName + ".out");

		String newLine = br.readLine();
		int count_T = Integer.parseInt(newLine);
		for (int i = 0; i < count_T; i++) {
			newLine = br.readLine();

			List<Integer> answerArray = new ArrayList<Integer>();

			char[] chars = newLine.toCharArray();
			for (Digit nextDigit : DIGITS) {
				int howManyDigits = howManySymbolsInText(chars, nextDigit.coreDigit);
				removeDigitsFromString(chars, nextDigit, howManyDigits);
				for (int j = 0; j < howManyDigits; j++) {
					answerArray.add(nextDigit.digit);
				}
			}
			Collections.sort(answerArray);

			StringBuilder answer = new StringBuilder();
			for (Integer digit : answerArray) {
				answer.append(digit);
			}

			String line = "Case #" + (i + 1) + ": ";
			line += answer.toString();
			fileWriter.write(line + "\n");
			fileWriter.flush();
		}
		br.close();
		fileWriter.close();
	}

	static int howManySymbolsInText(char[] text, char symbolToSearch) {
		int count = 0;
		for (char nextSymbol : text) {
			if (nextSymbol == symbolToSearch) {
				count++;
			}
		}
		return count;
	}


	static void removeDigitsFromString(char[] text, Digit digit, int count) {
		for (char digitToRemove : digit.allDigits) {
			for (int k = 0; k < count; k++) {
				for (int i = 0; i < text.length; i++) {
					if (digitToRemove == text[i]) {
						text[i] = NO_SYMBOL;
						break;
					}
				}
			}
		}
	}

}
