import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws Exception {
        File testsPath = new File("input/");
        File[] testFiles = testsPath.listFiles();
        if (testFiles == null) {
            return;
        }
        for (File testFile : testFiles) {
            if (testFile.getName().contains(".in")) {

                FileWriter fileWriter = new FileWriter("output/" + testFile.getName().replace(".in", ".out"));

                Scanner scanner = new Scanner(new FileInputStream(testFile));

                System.out.println("Start reading of: " + testFile.getName());

                int casesCount = scanner.nextInt();
                for (int caseIndex = 0; caseIndex < casesCount; caseIndex++) {
                    StringBuilder answer = new StringBuilder();

                    String nextString = scanner.next();
                    if (nextString.length() == 1) {
                        answer.append(nextString);
                    } else {
                        int thresholdDigit = -1;
                        int currentDigitIndex = 1;
                        char previousDigit;
                        char currentDigit;

                        do {
                            previousDigit = nextString.charAt(currentDigitIndex - 1);
                            currentDigit = nextString.charAt(currentDigitIndex);
                            if (previousDigit > currentDigit) {
                                if (currentDigitIndex > 1) {
                                    char backwardDigitAtIth;
                                    char backwardDigitAtIthMinusOne;
                                    int backwardCurrentDigitIndex = currentDigitIndex - 1;

                                    // if we never get into break statement this means that 
                                    // we have sequence of equal digits and threshold is in zero
                                    thresholdDigit = 0;
                                    do {
                                        backwardDigitAtIth = nextString.charAt(backwardCurrentDigitIndex);
                                        backwardDigitAtIthMinusOne = nextString.charAt(backwardCurrentDigitIndex - 1);
                                        if (backwardDigitAtIthMinusOne < backwardDigitAtIth) {
                                            thresholdDigit = backwardCurrentDigitIndex;
                                            break;
                                        }
                                    } while (--backwardCurrentDigitIndex > 0);
                                    // TODO update thresholdDigit
                                } else {
                                    thresholdDigit = 0;
                                }
                            }
                        } while (++currentDigitIndex < nextString.length() && thresholdDigit == -1);

                        // rebuild answer
                        if (thresholdDigit < 0) {
                            answer.append(nextString);
                        } else if (thresholdDigit == 0 && nextString.charAt(0) == '1') {
                            // all 9s, length 1 digit smaller then input
                            answer.append(getStringWithLengthAndFilledWithCharacter(nextString.length() - 1, '9'));
                        } else {
                            // decrement threshold - rest 9s
                            answer.append(nextString.substring(0, thresholdDigit));
                            answer.append(Integer.parseInt(Character.toString(nextString.charAt(thresholdDigit))) - 1);
                            answer.append(getStringWithLengthAndFilledWithCharacter(nextString.length() - thresholdDigit - 1, '9'));
                        }
                    }

                    fileWriter.write("Case #" + (caseIndex + 1) + ": " + answer.toString());
                    fileWriter.write("\n");
                    fileWriter.flush();
                }
                fileWriter.close();
            }
        }
    }

    static String getStringWithLengthAndFilledWithCharacter(int length, char charToFill) {
        if (length > 0) {
            char[] array = new char[length];
            Arrays.fill(array, charToFill);
            return new String(array);
        }
        return "";
    }
}
