package app;

import java.util.ArrayList;

public class Lawn {

	private ArrayList<ArrayList<Integer>> lawn;
	private int width;
	private int height;
	
	public Lawn(ArrayList<ArrayList<Integer>> l) {
		lawn = new ArrayList<ArrayList<Integer>>(l);
		width = l.get(0).size();
		height = l.size();
	}
	
	public boolean checkBoard() {
		for (int i = 0; i < height; i++)
			if (!checkRow(i))
				return false;
		return true;
	}
	
	private boolean checkRow(int r) {
		ArrayList<Integer> row = new ArrayList<Integer>(lawn.get(r));

		for (int i = 0; i < row.size(); i++) {
			if (checkCellBadRow(r,i) && checkCellBadCol(r,i))
				return false;
		}
		
		return true;
	}
	
	private boolean checkCellBadRow(int r, int c) {
		int value = lawn.get(r).get(c);
		
		for (int i = 0; i < width; i++)
			if (lawn.get(r).get(i) > value)
				return true;
		return false;
	}
	
	private boolean checkCellBadCol(int r, int c) {
		int value = lawn.get(r).get(c);

		for (int i = 0; i < height; i++)
			if (lawn.get(i).get(c) > value)
				return true;
		return false;
	}
}
