package app;

import java.util.ArrayList;

public class TicTacToeBoard {
	private ArrayList<ArrayList<Piece>> board;
	
	public TicTacToeBoard(ArrayList<ArrayList<Piece>> b) {
		board = new ArrayList<ArrayList<Piece>>(b);
	}
	
	private Piece diagonals() {
		if ((XorT(0,0) && XorT(1,1) && XorT(2,2) && XorT(3,3)) ||
			(XorT(0,3) && XorT(1,2) && XorT(2,1) && XorT(3,0)))
			return Piece.X;
		else if ((OorT(0,0) && OorT(1,1) && OorT(2,2) && OorT(3,3)) ||
				 (OorT(0,3) && OorT(1,2) && OorT(2,1) && OorT(3,0)))
			return Piece.O;
		else
			return Piece.B;
	}
	
	private Piece rows() {
		for (int i = 0; i < 4; i++) {
			if (XorT(i,0) && XorT(i,1) && XorT(i,2) && XorT(i,3))
				return Piece.X;
			else if (OorT(i,0) && OorT(i,1) && OorT(i,2) && OorT(i,3))
				return Piece.O;
		}
		
		return Piece.B;
	}
	
	private Piece columns() {
		for (int i = 0; i < 4; i++) {
			if (XorT(0,i) && XorT(1,i) && XorT(2,i) && XorT(3,i))
				return Piece.X;
			else if (OorT(0,i) && OorT(1,i) && OorT(2,i) && OorT(3,i))
				return Piece.O;
		}
		
		return Piece.B;
	}
	
	public Piece winner() {
		if (this.columns() == Piece.X || this.rows() == Piece.X || this.diagonals() == Piece.X)
			return Piece.X;
		else if (this.columns() == Piece.O || this.rows() == Piece.O || this.diagonals() == Piece.O)
			return Piece.O;
		else
			return Piece.B;
	}
	
	public boolean containsBlanks() {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if (board.get(i).get(j) == Piece.B)
					return true;
			}
		}
		return false;
	}
	
	public void printBoard() {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++)
				System.out.print(board.get(i).get(j).toString());
			System.out.println();
		}
	}
	
	public boolean XorT(int r, int c) {
		return (board.get(r).get(c) == Piece.X) || (board.get(r).get(c) == Piece.T);
	}
	
	public boolean OorT(int r, int c) {
		return (board.get(r).get(c) == Piece.O) || (board.get(r).get(c) == Piece.T);
	}
}
