package app;

import java.io.*;
import java.util.ArrayList;

public class Main {

	static int numCases;
	static ArrayList<String> info;
	
	public static void main(String[] args) {
		info = new ArrayList<String>();
		readFile("Data.in");
		writeFile("results.txt");
	}
	
	public static void writeFile(String filename) {
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(filename));
			
			for (String s : info) 
				bw.write(s + "\n");
			
			bw.close();
		}
		catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void readFile(String filename) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(filename));
			
			numCases = Integer.parseInt(br.readLine());
			long radius;	// cm
			long paint;	// mL
			
			int blackRings;
			
			String[] line;
			for (int i = 0; i < numCases; i++) {
				blackRings = 0;
				line = br.readLine().split(" ");
				radius = Long.parseLong(line[0]) + 1;
				paint  = Long.parseLong(line[1]);
				
				while (paint > 0) {
					if (paint >= 2*radius - 1)
						blackRings++;
					else
						break;
					
					paint = paint - 2*radius + 1;
					radius += 2;
				}
				
				info.add("Case #" + (i+1) + ": " + blackRings);
			}
			
			br.close();
		} 
		catch (FileNotFoundException e) {
			e.printStackTrace();
		} 
		catch (IOException e) {
			e.printStackTrace();
		}
	}

}
