package app;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Main {

	private static int numCases;
	private static ArrayList<String> info;
	
	public static void main(String[] args) {
		
		info = new ArrayList<String>();
		
		try {
			BufferedReader br = new BufferedReader(new FileReader("Data.in"));
			
			numCases = Integer.parseInt(br.readLine());
			TicTacToeBoard tempBoard;
			ArrayList<ArrayList<Piece>> current;
			ArrayList<Piece> temp;
			String l;
			
			for (int i = 0; i < numCases; i++) {
				current = new ArrayList<ArrayList<Piece>>();
				
				for (int j = 0; j < 4; j++) {
					temp = new ArrayList<Piece>();
					l = br.readLine();
					
					for (char c : l.toCharArray()) {
						if (c == 'X')
							temp.add(Piece.X);
						else if (c == 'O')
							temp.add(Piece.O);
						else if (c == 'T')
							temp.add(Piece.T);
						else
							temp.add(Piece.B);
					}
					current.add(new ArrayList<Piece>(temp));
				}
				
				br.readLine();	//Throw out the extra line
				
				tempBoard = new TicTacToeBoard(current);
				tempBoard.printBoard();
				
				if (tempBoard.winner() == Piece.X)
					info.add("Case #" + (i+1) + ": X won");
				else if (tempBoard.winner() == Piece.O)
					info.add("Case #" + (i+1) + ": O won");
				else if (tempBoard.winner() == Piece.B && tempBoard.containsBlanks())
					info.add("Case #" + (i+1) + ": Game has not completed");
				else
					info.add("Case #" + (i+1) + ": Draw");
			}
			br.close();
		} 
		catch (FileNotFoundException e) {
			e.printStackTrace();
		} 
		catch (IOException e) {
			e.printStackTrace();
		}
		
		writeFile("results.txt");
	}
	
	public static void writeFile(String filename) {
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(filename));
			
			for (String s : info) {
				bw.write(s + "\n");
			}
			
			bw.close();
		}
		catch (IOException e) {
			e.printStackTrace();
		}

	}
}
