import java.util.*;
import java.util.regex.*;
import java.text.*;
import java.math.*;
import java.awt.geom.*;
import static java.util.Arrays.*;
import static java.lang.Math.*;
import static java.lang.Integer.*;
import static java.lang.Double.*;
import static java.lang.System.*;
import java.io.*;

// This solution may (or may not) use some of my libraries.
// You can check out the libraries by the following command:
//  svn checkout http://myjavatoolsandalgorithms.googlecode.com/svn/trunk/ myjavatoolsandalgorithms-read-only -r{2009-9-26}
import mylibrary.*;
import mylibrary.functions.*;
import mylibrary.myGoogleCodeJam.*;
import static mylibrary.functions.MyPermutations.*;
import static mylibrary.functions.Arena.*;
import static mylibrary.functions.MyMath.*;
import static mylibrary.functions.Geometry.*;
import static mylibrary.functions.MyPermutations.*;
import static mylibrary.Iterators.*;
import static mylibrary.functions.Data.*;
import static mylibrary.Pair.*;
import static mylibrary.ComparablePair.*;


public class B {
   private static String problemName="B";

   private Scanner sc;
   private PrintStream out;

   public static void main(String[] args) {
       //solveAll(new Scanner(System.in), System.out);
       while(true){
           GoogleCodeJamProblem problem=new GoogleCodeJamProblem(problemName);
           solveAll(problem.sc,problem.out);
           problem.close();
       }
    }

   B(Scanner sc, PrintStream out){
       this.sc=sc;  this.out=out;
   }

    /**
     * Read next line from sc.
     * Unless sc.nextLine() it skips white spaces.
     * @return
     */
    public String readln(){
        sc.skip("[ \t\n]*");
        return sc.nextLine();
    }

    /**
     * Reads all tokens from the line
     */
    public String[] readlnTokens()
     {
        return readln().split(" ");
    }

    /**
     * Reads all ints from the line
     * @return
     */
    public int[] readlnInts(){
        String[] s=readlnTokens();
        int[] res=new int[s.length];
        for (int i = 0; i < res.length; i++) {
            res[i]=Integer.parseInt(s[i]);
        }
        return res;
    }

    /**
     * Reads a number n and n tokes.
     * @return
     */
    public String[] readTokens(){
        String[] res=new String[sc.nextInt()];
        for (int i = 0; i < res.length; i++) {
            res[i]=sc.next();
        }
        return res;
    }

    /**
     * Reads a number n and n ints.
     * @return
     */
    public int[] readInts(){
        int[] res=new int[sc.nextInt()];
        for (int i = 0; i < res.length; i++) {
            res[i]=sc.nextInt();
        }
        return res;
    }

    /**
     * Reads a number n and n lines.
     * @return
     */
    public String[] readLines(){
        String[] res=new String[sc.nextInt()];
        for (int i = 0; i < res.length; i++) {
            res[i]=readln();
        }
        return res;
    }

   public static void solveAll(Scanner sc, PrintStream out) {
        int NumberOfCases = sc.nextInt();
        for (int caseN = 1; caseN <= NumberOfCases; caseN++) {
                out.print("Case #" + caseN + ": ");
                new B(sc,out).SolveCase();
        }
     }

    public void SolveCase() {
 	int N=sc.nextInt();
//	String[] s=sc.nextLine().split(" ");
//	assert N==s.length;
	BigInteger[] t=new BigInteger[N];
	for (int i=0; i<N; i++){
		t[i]=sc.nextBigInteger();
	}
	BigInteger T=t[1].subtract(t[0]).abs();
	for (int i=2; i<N; i++){
		T=T.gcd(t[i].subtract(t[0]).abs());
	}
	BigInteger y=t[0].negate().mod(T);
        out.println(y);
    } //SolveCase

}// class

