import java.io.FileInputStream;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    public void solve(int testNumber, Reader in, PrintWriter out) {
        out.printf("Case #%d: ", testNumber);
        String s = in.nextLine();
        String[] ss = s.split(" ");
        char[] a = ss[0].toCharArray();
        char[] b = ss[1].toCharArray();
        char[] aa = new char[a.length];
        char[] bb = new char[b.length];
        long[] aans = new long[2];
        long[] bans = new long[2];
        boolean f = true;
        for (int j = 0; j < 2; j++) {
            int q = 0;
            for (int i = 0; i < a.length; i++) {
                if (q == 0) {
                    if (a[i] == '?' && b[i] == '?') {
                        aa[i] = '0';
                        bb[i] = '0';
                    } else if (a[i] == '?') {
                        aa[i] = b[i];
                        bb[i] = b[i];
                    } else if (b[i] == '?') {
                        aa[i] = a[i];
                        bb[i] = a[i];
                    } else {
                        if (a[i] != b[i]) {
                            q = a[i] > b[i] ? 1 : -1;
                            aa[i] = a[i];
                            bb[i] = b[i];
                            if (j == 0) {
                            } else {
                                int ii = i - 1;
                                boolean cool = false;
                                while (ii >= 0) {
                                    while (ii >= 0 && a[ii] != '?' && b[ii] != '?') ii--;
                                    if (ii < 0) break;
                                    if (a[ii] == '?' && b[ii] == '?') {
                                        aa[ii] = q == 1 ? '0' : '1';
                                        bb[ii] = q == 1 ? '1' : '0';
                                        cool = true;
                                        break;
                                    }
                                    if (a[ii] == '?') {
                                        if (q == 1) aa[ii] = (char)(bb[ii] + 1); else aa[ii] = (char)(bb[ii] - 1);
                                        if (aa[ii] > '9' || aa[ii] < '0') { ii--; continue; }
                                        cool = true;
                                        break;
                                    } else {
                                        if (q == 1) bb[ii] = (char)(aa[ii] - 1); else bb[ii] = (char)(aa[ii] + 1);
                                        if (bb[ii] > '9' || bb[ii] < '0') { ii--; continue; }
                                        cool =true;
                                        break;
                                    }
                                }
                                if (ii < 0) { f = false; break; }
                            }
                        } else {
                            aa[i] = a[i];
                            bb[i] = b[i];
                        }
                    }
                } else {
                    if (a[i] == '?') {
                        aa[i] = q == 1 ? '0' : '9';
                    } else aa[i] = a[i];
                    if (b[i] == '?') {
                        bb[i] = q == 1 ? '9' : '0';
                    } else bb[i] = b[i];
                }
            }
            if (f) {
                for (int i = 0; i < a.length; i++) aans[j] = aans[j] * 10 + aa[i] - '0';
                for (int i = 0; i < b.length; i++) bans[j] = bans[j] * 10 + bb[i] - '0';
            }
        }
        if (f) {
            if (Math.abs(aans[1] - bans[1]) < Math.abs(aans[0] - bans[0]) || Math.abs(aans[1] - bans[1]) == Math.abs(aans[0] - bans[0]) && aans[1] < aans[0] || Math.abs(aans[1] - bans[1]) == Math.abs(aans[0] - bans[0]) && aans[1] == aans[0] && bans[1] < bans[0]) {
                aans[0] = aans[1]; bans[0] = bans[1];
            }
        }
        char[][] z = new char[a.length][2];
        for (int i = 0; i < a.length; i++) {
            z[i][0] = (char)(aans[0] % 10 + '0');
            z[i][1] = (char)(bans[0] % 10 + '0');
            aans[0] /= 10;
            bans[0] /= 10;
        }
        for (int i = a.length - 1; i >= 0; i--) out.print(z[i][0]); out.print(" ");
        for (int i = a.length - 1; i >= 0; i--) out.print(z[i][1]); out.println();
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
    public String nextLine() {
        try {
            return in.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

}

