import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	int testnum;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	class Seg implements Comparable<Seg> {
		int b, e;
		int w;
		Seg(int q, int ww, int ee) {
			b = q; e = ww; w = ee;
		}
		public int compareTo(Seg arg0) {
			if (w != arg0.w) return w - arg0.w;
			return b - arg0.b; 
		}
		
	}
	
	int[][] a;
	int[][] prea;
	int[][] prex;
	int[][] prey;
	int r, c;
	
	void precalc() {
		prea = new int[r + 1][c + 1];
		prex = new int[r + 1][c + 1];
		prey = new int[r + 1][c + 1];
		for (int i = 1; i <= r; i++) {
			for (int j = 1; j <= c; j++) {
				prea[i][j] = a[i - 1][j - 1] + prea[i - 1][j] + prea[i][j - 1] - prea[i - 1][j - 1];
				prex[i][j] = (j - 1) * a[i - 1][j - 1] + prex[i - 1][j] + prex[i][j - 1] - prex[i - 1][j - 1];
				prey[i][j] = (i - 1) * a[i - 1][j - 1] + prey[i - 1][j] + prey[i][j - 1] - prey[i - 1][j - 1];
			}
		}
	}
	
	int suma(int q, int w, int k) {
		return prea[q + k][w + k] - prea[q + k][w] - prea[q][w + k] + prea[q][w];
	}
	
	int sumx(int q, int w, int k) {
		return prex[q + k][w + k] - prex[q + k][w] - prex[q][w + k] + prex[q][w];
	}
	
	int sumy(int q, int w, int k) {
		return prey[q + k][w + k] - prey[q + k][w] - prey[q][w + k] + prey[q][w];
	}
	
	boolean sum(int q, int w, int k) {
		int resx = 0, resy = 0;
		if (k % 2 == 1) {
			resx = sumx(q, w, k) - (w + ((k % 2 == 1)? k / 2 : k - 1)) * suma(q, w, k);
			resy = sumy(q, w, k) - (q + ((k % 2 == 1)? k / 2 : k - 1)) * suma(q, w, k);
		} else {
			resx = sumx(q, w, k) * 2 - (2 * w + ((k % 2 == 1)? k / 2 : k - 1)) * suma(q, w, k);
			resy = sumy(q, w, k) * 2 - (2 * q + ((k % 2 == 1)? k / 2 : k - 1)) * suma(q, w, k);
		}
		resx += (a[q][w] + a[q + k - 1][w] - a[q][w + k - 1] - a[q + k - 1][w + k - 1]) * ((k % 2 == 1)? k / 2 : k - 1); 
		resy += (a[q][w] - a[q + k - 1][w] + a[q][w + k - 1] - a[q + k - 1][w + k - 1]) * ((k % 2 == 1)? k / 2 : k - 1); 
		return resx == 0 && resy == 0;
	}
	
	boolean sum2(int q, int w, int k) {
		int resx = 0, resy = 0;
		if (k % 2 == 1) {
			int cx = q + k / 2, cy = w + k / 2;
			for (int i = 0; i < k; i++) {
				for (int j = 0; j < k; j++) {
					if (i == 0 && j == 0) continue;
					if (i == 0 && j == k - 1) continue;
					if (i == k - 1 && j == k - 1) continue;
					if (i == k - 1 && j == 0) continue;
					resx += (j + w - cy) * a[q + i][w + j];
					resy += (i + q - cx) * a[q + i][w + j];
				}
			}
		} else {
			int c = k - 1;
			for (int i = 0; i < k; i++) {
				for (int j = 0; j < k; j++) {
					if (i == 0 && j == 0) continue;
					if (i == 0 && j == k - 1) continue;
					if (i == k - 1 && j == k - 1) continue;
					if (i == k - 1 && j == 0) continue;
					resx += (j * 2 - c) * a[q + i][w + j];
					resy += (i * 2 - c) * a[q + i][w + j];
				}
			}
		}
		return resx == 0 && resy == 0;
	}
	
	void solve() throws IOException {
		r = nextInt();
		c = nextInt();
		int d = nextInt();
		a = new int[r][c];
		for (int i = 0; i < r; i++) {
			String s = nextToken();
			for (int j = 0; j < c; j++) {
				a[i][j] = s.charAt(j) - '0';
			}
		}
		precalc();
		int bk = 2;
		int ek = Math.min(r, c);
		label: for (int k = ek; k > 2; k--) {
			for (int i = 0; i + k <= r; i++) {
				for (int j = 0; j + k <= c; j++) {
					if (sum(i, j, k) != sum2(i, j, k)) out.print("FUCK" + i + j + k + " ");
					if (sum(i, j, k)) {
						bk = k;
						break label;
					}
				}
			}
		}
		if (bk == 2) out.println("IMPOSSIBLE"); else out.println(bk);
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (testnum = 1; testnum <= t; testnum++) {
				out.print("Case #" + testnum + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
