import java.io.FileInputStream;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "A-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("a.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskA solver = new TaskA();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskA {
    public void solve(int testNumber, Reader in, PrintWriter out) {
        int r = in.nextInt();
        int c = in.nextInt();
        int[][] a = new int[r][c];
        for (int i = 0; i < r; i++) {
            String s = in.next();
            for (int j = 0; j < c; j++) {
                switch (s.charAt(j)) {
                    case '.': a[i][j] = -1; break;
                    case '<': a[i][j] = 0; break;
                    case '>': a[i][j] = 1; break;
                    case '^': a[i][j] = 2; break;
                    case 'v': a[i][j] = 3; break;
                }
            }
        }
        int[][] b = new int[r][c];
        for (int i = 0; i < r; i++) {
            int j = 0;
            while (j < c && a[i][j] == -1) j++;
            if (j < c) {
                b[i][j] |= 1;
            }
            j = c - 1;
            while (j >= 0 && a[i][j] == -1) j--;
            if (j >= 0) {
                b[i][j] |= 2;
            }
        }
        for (int i = 0; i < c; i++) {
            int j = 0;
            while (j < r && a[j][i] == -1) j++;
            if (j < r) {
                b[j][i] |= 4;
            }
            j = r - 1;
            while (j >= 0 && a[j][i] == -1) j--;
            if (j >= 0) {
                b[j][i] |= 8;
            }
        }
        int ans = 0;
        boolean p = true;
        for (int i = 0; i < r; i++) {
            for (int j = 0; j < c; j++) {
                if (a[i][j] != -1) {
                    p &= b[i][j] != 15;
                    if ((b[i][j] & (1 << a[i][j])) != 0) ans++;
                }
            }
        }
        out.printf("Case #%d: ", testNumber);
        if (!p) out.println("IMPOSSIBLE"); else out.println(ans);
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

}

