import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	void solve() throws IOException {
		int l = nextInt();
		int d = nextInt();
		int n = nextInt();
		String[] p = new String[d];
		for (int i = 0; i < d; i++) {
			p[i] = nextToken();
		}
		boolean[] b = new boolean[26];
		for (int nn = 0; nn < n; nn++) {
			String s = nextToken();
			int j = 0;
			int q;
			int w = d - 1;
			for (int i = 0; i < l; i++) {
				Arrays.fill(b, false);
				q = 0;
				if (s.charAt(j) != '(') b[s.charAt(j) - 'a'] = true; else {
					j++;
					while (s.charAt(j) != ')') {
						b[s.charAt(j) - 'a'] = true;
						j++;
					}
				}
				j++;
				while (q <= w) {
					while (q <= w && b[p[q].charAt(i) - 'a']) q++;
					while (q <= w && !b[p[w].charAt(i) - 'a']) w--;
					if (q <= w) {
						String t = p[q];
						p[q] = p[w];
						p[w] = t;
					}
				}
				if (w == -1) break; 
			}
			out.println("Case #" + (nn + 1) + ": " + (w + 1));
		}
	}

	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			if (System.getProperty("ONLINE_JUDGE") != null) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			} else {
				in = new BufferedReader(new FileReader(new File("input.txt")));
				out = new PrintWriter(new FileWriter(new File("output.txt")));
			}
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
