import java.io.FileInputStream;
import java.util.Arrays;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.OptionalLong;
import java.util.Locale;
import java.util.stream.LongStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    long readD(Reader in) {
        return Math.round(in.nextDouble() * 10000);
    }
    public void solve(int testNumber, Reader in, PrintWriter out) {
        out.printf("Case #%d: ", testNumber);
        int n = in.nextInt();
        long v = readD(in);
        long x = readD(in);
        long[] r = new long[n];
        long[] c = new long[n];
        for (int i = 0; i < n; i++) {
            r[i] = readD(in);
            c[i] = readD(in);
        }
        long minc = Arrays.stream(c).min().getAsLong();
        long maxc = Arrays.stream(c).max().getAsLong();
        if (x < minc || x > maxc) {
            out.println("IMPOSSIBLE");
        } else {
            // small only (n <= 2)
            double ans;
            if (n == 1) {
                ans = (double)v / r[0];
            } else if (x == c[0] && x == c[1]) {
                ans = (double)v / Math.max(r[0], r[1]);
            } else if (x == c[0]) {
                ans = (double)v / r[0];
            } else if (x == c[1]) {
                ans = (double)v / r[1];
            } else {
                double r1 = r[0];
                double r2 = r[1];
                double x1 = c[0];
                double x2 = c[1];
                double vv = v;
                double xx = x * vv;
                double t1 = (vv * x2 - xx) / r1 / (x2 - x1);
                double t2 = (xx - v * x1) / r2 / (x2 - x1);
                ans = Math.max(t1, t2);
            }
            out.println(ans);
        }
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public double nextDouble() {
        return Double.parseDouble(next());
    }

}

