import java.io.FileInputStream;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.math.BigInteger;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "C-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("c.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskC solver = new TaskC();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskC {
    BigInteger c(long a, int b) {
        BigInteger res = BigInteger.ZERO;
        BigInteger bb = BigInteger.ONE;
        while (a > 0) {
            if (a % 2 == 1) res = res.add(bb);
            a /= 2;
            bb = bb.multiply(BigInteger.valueOf(b));
        }
        return res;
    }
    public void solve(int testNumber, Reader in, PrintWriter out) {
        out.println("Case #1:");
        long q = (1L << 31) + 1;
        for (int i = 0; i < 500; i++) {
            long cur = q + c(i, 4).longValue() * 6;
            out.print(c(cur, 10) + " ");
            for (int j = 2; j <= 10; j++) {
                if (!c(cur, j).remainder(BigInteger.valueOf(j + 1)).equals(BigInteger.ZERO)) throw new RuntimeException("NOOOO!");
                out.print((j + 1) + " ");
            }
            out.println();
        }
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

}

