import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	void solve() throws IOException {
		int r = nextInt();
		int k = nextInt();
		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++) a[i] = nextInt();
		int[] b = new int[n];
		long[] c = new long[n];
		int bb = 0;
		int ee = 1 % n;
		long ts = a[0];
		while (bb < n) {
			if (ts == 0) {
				ts += a[ee];
				ee = (ee + 1) % n;
			}
			while (ee != bb && ts + a[ee] <= k) {
				ts += a[ee];
				ee = (ee + 1) % n;
			}
			b[bb] = ee;
			c[bb] = ts;
			ts -= a[bb];
			bb++;
		}
		int[] rr = new int[n];
		Arrays.fill(rr, -1);
		long[] rc = new long[n];
		int st = 0;
		rr[0] = 0;
		rc[0] = 0;
		int uk = 0;
		ts = 0;
		while (st < r) {
			st++;
			ts += c[uk];
			uk = b[uk];
			if (rr[uk] != -1) {
				int q = st - rr[uk];
				long qs = ts - rc[uk];
				if (r - st >= q) {
					int w = (r - st) / q;
					st += q * w;
					ts += qs * w;
				}
			}
			rr[uk] = st;
			rc[uk] = ts;
		}
		out.println(ts);
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (int nn = 1; nn <= t; nn++) {
				out.print("Case #" + nn + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
