import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	void solve() throws IOException {
		int cd = nextInt();
		int ci = nextInt();
		int m = nextInt();
		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n; i++) a[i] = nextInt();
		int[][] dp = new int[n + 1][256];
		int inf = 100000000;
		for (int i = 1; i <= n; i++) Arrays.fill(dp[i], inf);
		dp[0][0] = 0;
		for (int i = 1; i <= n; i++) {
			for (int j = 0; j < 256; j++) {
				dp[i][j] = Math.min(dp[i][j], dp[i - 1][j] + cd);
				if (Math.abs(j - a[i - 1]) <= m) 
					dp[i][a[i - 1]] = Math.min(dp[i][a[i - 1]], dp[i - 1][j]);
				else if (m != 0) {
					int qq = Math.abs(a[i - 1] - j);
					if (qq % m == 0) qq = qq / m - 1; else qq /= m;
					dp[i][a[i - 1]] = Math.min(dp[i][a[i - 1]], dp[i - 1][j] + ci * qq);
				}
				for (int nn = 0; nn < 256; nn++) {
					if (Math.abs(nn - j) <= m) dp[i][nn] = Math.min(dp[i][nn], dp[i - 1][j] + Math.abs(nn - a[i - 1]));
				}
			}
			
		}
		int ans = inf;
		for (int i = 0; i < 256; i++) ans = Math.min(ans, dp[n][i]);
		out.println(ans);
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (int nn = 1; nn <= t; nn++) {
				out.print("Case #" + nn + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
