import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	void solve() throws IOException {
		int c = nextInt();
		char[][] a = new char[100][100];
		char[][] b = new char[100][100];
		for (int i = 0; i < c; i++) {
			String s = nextToken();
			a[s.charAt(0)][s.charAt(1)] = a[s.charAt(1)][s.charAt(0)] = s.charAt(2);
		}
		int d = nextInt();
		for (int i = 0; i < d; i++) {
			String s = nextToken();
			b[s.charAt(0)][s.charAt(1)] = b[s.charAt(1)][s.charAt(0)] = 1;
		}
		int[] cur = new int[100];
		int cl = 0;
		int n = nextInt();
		String s = nextToken();
		int[] ff = new int[100];
		for (int i = 0; i < n; i++) {
			char q = s.charAt(i);
			boolean f = true;
			if (cl > 0) {
				if (a[cur[cl - 1]][q] != 0) {
					ff[cur[cl - 1]]--;
					cur[cl - 1] = a[cur[cl - 1]][q];
					ff[cur[cl - 1]]++;
					f = false;
				} else {
					for (char cc = 'A'; cc <= 'Z'; cc++) {
						if (ff[cc] > 0 && b[cc][q] != 0) {
							cl = 0;
							Arrays.fill(ff, 0);
							f = false;
							break;
						}
					}
				}
			}
			if (f) {
				cur[cl++] = q;
				ff[q]++;
			}
		}
		out.print("[");
		for (int i = 0; i < cl; i++) {
			if (i > 0) out.print(", ");
			out.print((char)cur[i]);
		}
		out.println("]");
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (int nn = 1; nn <= t; nn++) {
				out.print("Case #" + nn + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
