import java.util.LinkedList;
import java.io.FileInputStream;
import java.util.TreeMap;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Collection;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Queue;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    int nz(int z, int i) {
        int r = z;
        for (int j = 0; j < i; j++) {
            if ((z & (1 << j)) != 0) {
                r -= 1 << j;
            } else {
                r += 1 << (i - j - 1);
            }
        }
        return r;
    }
    public void solve(int testNumber, Reader in, PrintWriter out) {
        out.printf("Case #%d: ", testNumber);
        String s = in.nextLine();
        int n = s.length();
        int q = 0;
        for (int i = 0; i < n; i++) {
            if (s.charAt(i) == '-') q += (1 << i);
        }
        TreeMap<Integer, Integer> map = new TreeMap<>();
        map.put(q, 0);
        Queue<Integer> qu = new LinkedList<>();
        qu.add(q);
        while (!qu.isEmpty()) {
            int z = qu.poll();
            for (int i = 1; i <= n; i++) {
                int nz = nz(z, i);
                if (!map.containsKey(nz)) {
                    map.put(nz, map.get(z) + 1);
                    qu.add(nz);
                }
            }
        }
        out.println(map.get(0));
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
    public String nextLine() {
        try {
            return in.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

}

