import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	int testnum;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	class Seg implements Comparable<Seg> {
		int b, e;
		int w;
		Seg(int q, int ww, int ee) {
			b = q; e = ww; w = ee;
		}
		public int compareTo(Seg arg0) {
			if (w != arg0.w) return w - arg0.w;
			return b - arg0.b; 
		}
		
	}
	
	void solve() throws IOException {
		int b0 = 0;
		int x = nextInt();
		int s = nextInt();
		int r = nextInt() - s;
		int t = nextInt();
		int n = nextInt();
		Seg[] a = new Seg[2 * n + 10];
		int l = 0;
		double ans = 0;
		for (int i = 0; i < n; i++) {
			int b = nextInt();
			int e = nextInt();
			int w = nextInt();
			if (b != b0) {
				a[l++] = new Seg(b0, b, s);
				ans += (double)(b - b0) / s;
			}
			a[l++] = new Seg(b, e, w + s);
			ans += (double)(e - b) / (w + s);
			b0 = e;
		}
		if (b0 != x) {
			a[l++] = new Seg(b0, x, s);
			ans += (double)(x - b0) / s;
		}
		Arrays.sort(a, 0, l);
		double tt = t;
		int j = 0;
		while (tt > 1e-8) {
			if (j == l) break;
			double t0 = Math.min(tt, (double)(a[j].e - a[j].b) / (a[j].w + r));
			tt -= t0;
			ans -= t0 * r / a[j].w;
			j++;
		}
		out.printf("%.7f\n", ans);
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (testnum = 1; testnum <= t; testnum++) {
				out.print("Case #" + testnum + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
