import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	void solve() throws IOException {
		int n = nextInt();
		int[][][] a = new int[2][n][2];
		int[] l = new int[2];
		for (int i = 0; i < n; i++) {
			char q = nextToken().charAt(0);
			int p = nextInt();
			int r = (q == 'O')? 0 : 1;
			a[r][l[r]][0] = p;
			a[r][l[r]++][1] = i;
		}
		int ans = 0;
		int nn = 0;
		int[] u = new int[2];
		u[0] = u[1] = 1;
		int[] un = new int[2];
		while (nn < n) {
			boolean f = false;
			if (un[0] < l[0] && a[0][un[0]][0] == u[0] && nn == a[0][un[0]][1]) { un[0]++; f = true; } else {
				if (un[0] < l[0]) {
					if (u[0] < a[0][un[0]][0]) u[0]++;
					if (u[0] > a[0][un[0]][0]) u[0]--;
				}
			}
			if (un[1] < l[1] && a[1][un[1]][0] == u[1] && nn == a[1][un[1]][1]) { un[1]++; f = true; } else {
				if (un[1] < l[1]) {
					if (u[1] < a[1][un[1]][0]) u[1]++;
					if (u[1] > a[1][un[1]][0]) u[1]--;
				}
			}
			if (f) nn++;
			ans++;
		}
		out.println(ans);
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (int nn = 1; nn <= t; nn++) {
				out.print("Case #" + nn + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
