import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	int[] rep(int q) {
		int[] r = new int[10];
		while (q > 0) {
			r[q % 10]++;
			q /= 10;
		}
		r[0] = 0;
		return r;
	}
	
	void solve2(int q) {
		int[] a = rep(q);
		q++;
		while (true) {
			int[] b = rep(q);
			boolean f = true;
			for (int i = 1; i <= 9; i++) f &= (a[i] == b[i]);
			if (f) {
				out.print(q + " ");
				return;
			}
			q++;
		}
	}

	void solve() throws IOException {
		String nn = nextToken();
//		solve2(Integer.parseInt(nn));
		int[] a = new int[nn.length()];
		for (int i = 0; i < nn.length(); i++) {
			a[i] = nn.charAt(i) - '0';
		}
		int l = nn.length();
		for (int i = l - 1; i >= 1; i--) {
			if (a[i] > a[i - 1]) {
				int t = a[i - 1];
				Arrays.sort(a, i - 1, l);
				int w = i - 1;
				while (a[w] != t) w++;
				while (a[w] == t) w++;
				t = a[i - 1];
				a[i - 1] = a[w];
				a[w] = t;
				Arrays.sort(a, i, l);
				for (int j = 0; j < l; j++) out.print(a[j]);
				out.println();
				return;
			}
		}
		Arrays.sort(a);
		int q = 0;
		while (a[q] == 0) q++;
		out.print(a[q]);
		for (int i = 0; i <= q; i++) out.print(0);
		for (int i = q + 1; i < l; i++) out.print(a[i]);
		out.println();
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			if (System.getProperty("ONLINE_JUDGE") != null) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			} else {
				in = new BufferedReader(new FileReader(new File("input.txt")));
				out = new PrintWriter(new FileWriter(new File("output.txt")));
			}
			int t = nextInt();
			for (int nn = 1; nn <= t; nn++) {
				out.print("Case #" + nn + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
