import java.io.FileInputStream;
import java.util.HashSet;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.Set;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "C-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("c.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskC solver = new TaskC();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskC {
    public void solve(int testNumber, Reader in, PrintWriter out) {
        int c = in.nextInt();
        int d = in.nextInt();
        int v = in.nextInt();
        Set<Integer> may = new HashSet<>();
        int[] a = in.nextIntArray(d);
        int j = 0;
        int ans = 0;
        for (int i = 1; i <= v; i++) {
            boolean f = may.contains(i);
            if (j < a.length && a[j] == i) {
                f = true;
                j++;
                Set<Integer> mm = new HashSet<>(may);
                for (int q : may) {
                    mm.add(q);
                    mm.add(q + i);
                }
                mm.add(i);
                may = mm;
            }
            if (!f) {
                ans++;
                Set<Integer> mm = new HashSet<>(may);
                for (int q : may) {
                    mm.add(q);
                    mm.add(q + i);
                }
                mm.add(i);
                may = mm;
            }
        }
        out.printf("Case #%d: %d\n", testNumber, ans);
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
    public int nextInt() {
        return Integer.parseInt(next());
    }

    public int[] nextIntArray(int n, int offset) {
        int[] res = new int[n + offset];
        for (int i = 0; i < n; i++) res[i + offset] = nextInt();
        return res;
    }
    public int[] nextIntArray(int n) {
        return nextIntArray(n, 0);
    }
}

