import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	void solve() throws IOException {
		int n = nextInt();
		int k = nextInt();
		char[][] a = new char[n][n];
		for (int i = 0; i < n; i++) {
			String s = nextToken();
			for (int j = 0; j < n; j++) {
				a[j][n - i - 1] = s.charAt(j);
			}
		}
		for (int j = 0; j < n; j++) {
			int i = n - 1;
			for (int ii = n - 1; ii >= 0; ii--) {
				if (a[ii][j] != '.') a[i--][j] = a[ii][j];
			}
			while (i >= 0) a[i--][j] = '.';
		}
		boolean red = false, blue = false;
		for (int i = 0; i < n; i++) {
			int q = 0;
			for (int j = 0; j < n; j++) {
				if (j == 0 || a[i][j] != a[i][j - 1] || a[i][j] == '.') {
					q = 0;
					if (a[i][j] != '.') q++;
				} else q++;
				if (q == k) {
					if (a[i][j] == 'R') red = true;
					if (a[i][j] == 'B') blue = true;
				}
			}
		}
		for (int i = 0; i < n; i++) {
			int q = 0;
			for (int j = 0; j < n; j++) {
				if (j == 0 || a[j][i] != a[j - 1][i] || a[j][i] == '.') {
					q = 0;
					if (a[j][i] != '.') q++;
				} else q++;
				if (q == k) {
					if (a[j][i] == 'R') red = true;
					if (a[j][i] == 'B') blue = true;
				}
			}
		}
		int si = 0, sj = n - 1;
		while (true) {
			int q = 0;
			for (int i = si, j = sj; i < n && j >= 0; i++, j--) {
				if (j == sj || a[i][j] != a[i - 1][j + 1] || a[i][j] == '.') {
					q = 0;
					if (a[i][j] != '.') q++;
				} else q++;
				if (q == k) {
					if (a[i][j] == 'R') red = true;
					if (a[i][j] == 'B') blue = true;
				}
			}
			if (sj > 0) sj--; else si++;
			if (si == n) break;
		}
		si = n - 1; sj = 0;
		while (true) {
			int q = 0;
			for (int i = si, j = sj; i < n && j < n; i++, j++) {
				if (j == sj || a[i][j] != a[i - 1][j - 1] || a[i][j] == '.') {
					q = 0;
					if (a[i][j] != '.') q++;
				} else q++;
				if (q == k) {
					if (a[i][j] == 'R') red = true;
					if (a[i][j] == 'B') blue = true;
				}
			}
			if (si > 0) si--; else sj++;
			if (sj == n) break;
		}
		if (red && blue) out.println("Both"); else
			if (red) out.println("Red"); else
				if (blue) out.println("Blue"); else
					out.println("Neither");
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (int nn = 1; nn <= t; nn++) {
				out.print("Case #" + nn + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
