import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Solution {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }
    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    class Trie {
        class Node {
            Node[] a = new Node[26];
        }

        Node root = new Node();
        int size = 1;

        void add(String s) {
            add(s, 0, root);
        }

        void add(String s, int i, Node q) {
            if (i == s.length()) return;
            int c = s.charAt(i) - 'A';
            if (q.a[c] == null) {
                q.a[c] = new Node();
                size++;
            }
            add(s, i + 1, q.a[c]);
        }
    }

    int m, n;
    String[] s;
    int[] a;
    Map<Integer, Integer> ans;
    int mans;

    void getAns() {
        Trie[] tr = new Trie[n];
        boolean[] cc = new boolean[n];
        int ccc = 0;
        for (int i = 0; i < n; i++) tr[i] = new Trie();
        for (int i = 0; i < m; i++) {
            tr[a[i]].add(s[i]);
            if (!cc[a[i]]) ccc++;
            cc[a[i]] = true;
        }
        if (ccc == n) {
            int tmp = 0;
            for (int i = 0; i < n; i++) {
                tmp += tr[i].size;
            }
            if (!ans.containsKey(tmp)) ans.put(tmp, 0);
            ans.put(tmp, ans.get(tmp) + 1);
            mans = Math.max(mans, tmp);
        }
    }

    void rek(int q) {
        if (q == m) {
            getAns();
        } else {
            for (int i = 0; i < n; i++) {
                a[q] = i;
                rek(q + 1);
            }
        }
    }

    String solveSmall() {
        a = new int[m];
        ans = new TreeMap<Integer, Integer>();
        mans = -1;
        rek(0);
        return "" + mans + " " + ans.get(mans);
    }

    void solve() throws IOException {
        m = nextInt();
        n = nextInt();
        s = new String[m];
        for (int i = 0; i < m; i++) {
            s[i] = nextToken();
        }
        out.println(solveSmall());
    }

    void run() {
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            //in = new BufferedReader(new InputStreamReader(System.in));
            //out = new PrintWriter(System.out);
            Locale.setDefault(Locale.UK);
            int tt = nextInt();
            for (int t = 1; t <= tt; t++) {
                out.print("Case #" + t + ": ");
                System.err.println("Case " + t);
                System.err.flush();
                solve();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            out.close();
        }
    }

    public static void main(String Args[]) {
        new Solution().run();
    }
}