import java.util.ArrayList;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileInputStream;
import java.util.TreeMap;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Map;
import java.util.Locale;
import java.io.PrintStream;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "C-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("c.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskC solver = new TaskC();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskC {
    public void solve(int testNumber, Reader in, PrintWriter out) {
        System.err.println("test " + testNumber);
        int n = in.nextInt();
        String[][] a = new String[n][];
        Map<String, Integer> map = new TreeMap<>();
        int cnt = 1;
        for (int i = 0; i < n; i++) {
            String s = in.nextLine();
            a[i] = s.split(" ");
            for (String q : a[i]) {
                if (!map.containsKey(q)) map.put(q, cnt++);
            }
        }
        int[][] aa = new int[n][];
        for (int i = 0; i < n; i++) {
            aa[i] = new int[a[i].length];
            for (int j = 0; j < a[i].length; j++) {
                aa[i][j] = map.get(a[i][j]);
            }
        }
        int ans = Integer.MAX_VALUE;
        int[] e1 = new int[map.size() + 1];
        int[] e2 = new int[map.size() + 1];
        for (int q = 0; q < (1 << (n - 2)); q++) {
            int cur = 0;
            for (int j : aa[0]) e1[j] = q + 1;
            for (int j : aa[1]) {
                if (e1[j] == q + 1 && e2[j] != q + 1) cur++;
                e2[j] = q + 1;
            }
            for (int i = 0; i < n - 2; i++) {
                for (int j : aa[i + 2]) {
                    if ((q & (1 << i)) != 0) {
                        if (e1[j] != q + 1 && e2[j] == q + 1) cur++;
                        e1[j] = q + 1;
                    } else {
                        if (e2[j] != q + 1 && e1[j] == q + 1) cur++;
                        e2[j] = q + 1;
                    }
                }
            }
            ans = Math.min(ans, cur);
        }
        out.printf("Case #%d: %d\n", testNumber, ans);
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
    public String nextLine() {
        try {
            return in.readLine();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
    public int nextInt() {
        return Integer.parseInt(next());
    }

}

