import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Map;
import java.util.Queue;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;


public class Main implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	class Vert implements Comparable<Vert> {
		int x, y, q;
		Vert(int a, int b, int c) {
			x = a; y = b; q = c;
		}
		@Override
		public int compareTo(Vert a) {
			if (r[x][y][q] != r[a.x][a.y][a.q]) return r[x][y][q] - r[a.x][a.y][a.q];
			if (x != a.x) return x - a.x;
			if (y != a.y) return y - a.y;
			return q - a.q;
		}
	}
	
	final int INF = 1000000000;
	
	int h, n, m;
	int[][] c, f;
	int[][][] r;
	
	int[] dx = {1, 0, -1, 0};
	int[] dy = {0, 1, 0, -1};
	
	int makemove(int bx, int by, int ex, int ey, int wl) {
		if (bx < 0 || bx >= n || by < 0 || by >= m) return INF;
		if (ex < 0 || ex >= n || ey < 0 || ey >= m) return INF;
		if (f[bx][by] > c[ex][ey] - 50 || f[ex][ey] > c[ex][ey] - 50) return INF;
		if (f[ex][ey] > c[bx][by] - 50) return INF;
		return Math.max(0, wl - c[ex][ey] + 50);
	}
	
	void dfsfirst(int x, int y) {
		r[x][y][0] = 0;
		for (int d = 0; d < 4; d++) {
			if (makemove(x, y, x + dx[d], y + dy[d], h) == 0 && r[x + dx[d]][y + dy[d]][0] == INF) {
				dfsfirst(x + dx[d], y + dy[d]);
			}
		}
	}
	
	void solve() throws Exception {
		h = nextInt();
		n = nextInt();
		m = nextInt();
		c = new int[n][m];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				c[i][j] = nextInt();
			}
		}
		f = new int[n][m];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				f[i][j] = nextInt();
			}
		}
		r = new int[n][m][2];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				for (int q = 0; q < 2; q++) {
					r[i][j][q] = INF;
				}
			}
		}
		dfsfirst(0, 0);
		TreeSet<Vert> ts = new TreeSet<Vert>();
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				if (r[i][j][0] == 0 && h - f[i][j] < 20) {
					r[i][j][1] = r[i][j][0];
					r[i][j][0] = INF;
				}
				ts.add(new Vert(i, j, 0));
				ts.add(new Vert(i, j, 1));
			}
		}
		while (!ts.isEmpty()) {
			Vert q = ts.pollFirst();
			if (r[q.x][q.y][q.q] == INF) break;
			int wl = Math.max(0, h - r[q.x][q.y][q.q]);
			int time = q.q == 0 ? 10 : 100;
			for (int d = 0; d < 4; d++) {
				int addtime = makemove(q.x, q.y, q.x + dx[d], q.y + dy[d], wl);
				if (addtime != INF && (q.q == 1 || wl - addtime >= f[q.x][q.y] + 20)) {
					Vert nn = new Vert(q.x + dx[d], q.y + dy[d], wl - (time + addtime) - f[q.x + dx[d]][q.y + dy[d]] < 20 ? 1 : 0);
					if (r[nn.x][nn.y][nn.q] > r[q.x][q.y][q.q] + (time + addtime)) {
						ts.remove(nn);
						r[nn.x][nn.y][nn.q] = r[q.x][q.y][q.q] + (time + addtime);
						ts.add(nn);
					}
				}
			}
			if (q.q == 0) {
				time = wl - f[q.x][q.y] - 19;
				if (r[q.x][q.y][1] > r[q.x][q.y][0] + time) {
					ts.remove(new Vert(q.x, q.y, 1));
					r[q.x][q.y][1] = r[q.x][q.y][0] + time;
					ts.add(new Vert(q.x, q.y, 1));
				}
			}
		}
		int ans = Math.min(r[n - 1][m - 1][0], r[n - 1][m - 1][1]);
		out.println(ans / 10 + "." + ans % 10);
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			for (int t = nextInt(), cnt = 1; t > 0; t--, cnt++) { 
				out.print("Case #" + cnt + ": ");
				solve();
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}

}
