import java.io.FileInputStream;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Map;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.Set;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    Map<Character, Integer> f(String s) {
        Map<Character, Integer> r = new HashMap<>();
        for (int i = 0; i < s.length(); i++) {
            Integer q = r.get(s.charAt(i));
            if (q == null) q = 0;
            r.put(s.charAt(i), q + 1);
        }
        return r;
    }
    int mx(String kb, String tg, int s) {
        Map<Character, Integer> al = f(kb);
        for (int i = 0; i < tg.length(); i++) {
            if (!al.containsKey(tg.charAt(i))) return 0;
        }
        String qq = new String(tg);
        int ans = 1;
        while (qq.length() < s) {
            for (int i = 1; i <= tg.length(); i++) {
                boolean f = true;
                for (int j = 0; j < tg.length() && qq.length() - tg.length() + i + j < qq.length(); j++) {
                    f &= tg.charAt(j) == qq.charAt(qq.length() - tg.length() + i + j);
                }
                if (f) {
                    for (int j = 0; j < i; j++) {
                        qq += tg.charAt(tg.length() - i + j);
                    }
                    ans++;
                    break;
                }
            }
        }
        if (qq.length() > s) ans--;
        return ans;
    }
    double ex(String kb, String tg, int s) {
        Map<Character, Integer> al = f(kb);
        double sum = 0;
        for (Map.Entry<Character, Integer> q : al.entrySet()) {
            sum += q.getValue();
        }
        int[] pf = StringFunc.prefixFunction(tg);
        double[][][] dp = new double[s + 1][tg.length()][s + 1];
        dp[0][0][0] = 1;
        int t = 0;
        for (int i = 0; i < s; i++) {
            for (int j = 0; j < tg.length(); j++) {
                for (int k = 0; k < s; k++) {
                    for (Map.Entry<Character, Integer> e : al.entrySet()) {
                        int q = j - 1;
                        while (q > -1 && tg.charAt(q + 1) != e.getKey()) q = pf[q];
                        if (tg.charAt(q + 1) == e.getKey()) {
                            q++;
                        }
                        if (q == tg.length() - 1) {
                            dp[i + 1][pf[q] + 1][k + 1] += dp[i][j][k] * e.getValue() / sum;
                        } else {
                            dp[i + 1][q + 1][k] += dp[i][j][k] * e.getValue() / sum;
                        }
                    }
                }
            }
        }
        double ans = 0;
        for (int i = 0; i < tg.length(); i++) {
            for (int j = 0; j < s + 1; j++) {
                ans += j * dp[s][i][j];
            }
        }
        return ans;
    }
    public void solve(int testNumber, Reader in, PrintWriter out) {
        int k = in.nextInt();
        int l = in.nextInt();
        int s = in.nextInt();
        String kb = in.next();
        String tg = in.next();
        out.printf("Case #%d: %.8f\n", testNumber, mx(kb, tg, s) - ex(kb, tg, s));
    }
}

class StringFunc {
    public static int[] prefixFunction(String string) {
        char[] s = string.toCharArray();
        int n = string.length();
        int[] pr = new int[n];
        pr[0] = -1;
        for (int i = 1; i < n; i++) {
            int j = pr[i - 1];
            while (j > -1 && s[j + 1] != s[i]) j = pr[j];
            if (s[j + 1] == s[i]) j++;
            pr[i] = j;
        }
        return pr;
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }
    public int nextInt() {
        return Integer.parseInt(next());
    }

}

