import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	int[][] m;
	int h, w;
	
	int[] dr(int i, int j) {
		int[] res = new int[2];
		res[0] = res[1] = 0;
		if (i > 0 && m[i - 1][j] < m[i + res[0]][j + res[1]]) {
			res[0] = -1;
			res[1] = 0;
		}
		if (j > 0 && m[i][j - 1] < m[i + res[0]][j + res[1]]) {
			res[0] = 0;
			res[1] = -1;
		}
		if (j < w - 1 && m[i][j + 1] < m[i + res[0]][j + res[1]]) {
			res[0] = 0;
			res[1] = 1;
		}
		if (i < h - 1 && m[i + 1][j] < m[i + res[0]][j + res[1]]) {
			res[0] = 1;
			res[1] = 0;
		}
		return res;
	}
	
	int[][][] u;
	int[][] r;
	
	int[] get(int i, int j) {
		if (u[i][j][0] == i && u[i][j][1] == j) return new int[] {i, j};
		u[i][j] = get(u[i][j][0], u[i][j][1]);
		return u[i][j];
	}
	
	void un(int q, int w, int i, int j) {
		int[] qq = get(q, w);
		q = qq[0];
		w = qq[1];
		qq = get(i, j);
		i = qq[0];
		j = qq[1];
		if (r[q][w] == r[i][j]) r[q][w]++;
		if (r[q][w] > r[i][j]) {
			u[i][j][0] = q; 
			u[i][j][1] = w;
		} else {
			u[q][w][0] = i;
			u[q][w][1] = j;
		}
	}
	
	void solve() throws IOException {
		int t = nextInt();
		m = new int[150][150];
		u = new int[150][150][2];
		r = new int[150][150];
		char[][] ans = new char[150][150];
		for (int nn = 0; nn < t; nn++) {
			h = nextInt();
			w = nextInt();
			for (int i = 0; i < h; i++) {
				for (int j = 0; j < w; j++) {
					m[i][j] = nextInt();
					u[i][j][0] = i;
					u[i][j][1] = j;
					r[i][j] = 0;
					ans[i][j] = '0';
				}
			}
			for (int i = 0; i < h; i++) {
				for (int j = 0; j < w; j++) {
					int[] d = dr(i, j);
					if (d[0] != 0 || d[1] != 0) {
						un(i, j, i + d[0], j + d[1]);
					}
				}
			}
			out.println("Case #" + (nn + 1) + ":");
			char qq = 'a';
			for (int i = 0; i < h; i++) {
				for (int j = 0; j < w; j++) {
					if (ans[get(i, j)[0]][get(i, j)[1]] == '0') {
						ans[get(i, j)[0]][get(i, j)[1]] = qq++;
					}
					out.print(ans[get(i, j)[0]][get(i, j)[1]]);
					if (j < w - 1) out.print(" ");
				}
				if (i < h - 1) out.println();
			}
			if (nn < t - 1) out.println();
		}
	}

	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			if (System.getProperty("ONLINE_JUDGE") != null) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			} else {
				in = new BufferedReader(new FileReader(new File("input.txt")));
				out = new PrintWriter(new FileWriter(new File("output.txt")));
			}
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
