import java.io.FileInputStream;
import java.util.ArrayList;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "A-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("a.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Reader in = new Reader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskA solver = new TaskA();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskA {
    int N, R, P, S;
    String res;
    PrintWriter out;
    String rr(int t, int n) {
        if (n == 0) {
            if (t == 1) return "P";
            if (t == 2) return "R";
            if (t == 3) return "S";
        }
        if (t == 1) {
            String a = rr(1, n - 1);
            String b = rr(3, n - 1);
            return cmp(a, b);
        }
        if (t == 2) {
            String a = rr(2, n - 1);
            String b = rr(1, n - 1);
            return cmp(a, b);

        }
        if (t == 3) {
            String a = rr(2, n - 1);
            String b = rr(3, n - 1);
            return cmp(a, b);

        }
        return "";
    }
    String cmp(String a, String b) {
        if (a.compareTo(b) > 0) return b + a; else return a + b;
    }
    boolean check(String a, int p, int r, int s) {
        for (int i = 0; i < a.length(); i++) {
            if (a.charAt(i) == 'P') p--;
            if (a.charAt(i) == 'R') r--;
            if (a.charAt(i) == 'S') s--;
        }
        return p == 0 && r == 0 && s == 0;
    }
    public void solve(int testNumber, Reader in, PrintWriter out) {
        out.printf("Case #%d: ", testNumber);
        this.out = out;
        res = "";
        N = in.nextInt();
        R = in.nextInt();
        P = in.nextInt();
        S = in.nextInt();
        String ans1 = rr(1, N);
        if (check(ans1, P, R, S)) res = ans1;
        String ans2 = rr(2, N);
        if (check(ans2, P, R, S) && (res.equals("") || res.compareTo(ans2) > 0)) res = ans2;
        String ans3 = rr(3, N);
        if (check(ans3, P, R, S) && (res.equals("") || res.compareTo(ans3) > 0)) res = ans3;
        if (res.equals("")) out.println("IMPOSSIBLE"); else out.println(res);
    }
}

class Reader {
    private BufferedReader in;
    private StringTokenizer st;
    public Reader(InputStream is) {
        in = new BufferedReader(new InputStreamReader(is));
    }
    public String next() {
        try {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(in.readLine());
            }
            return st.nextToken();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

}

