import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Solution {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }
    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    class FenTree {
        int[] a = new int[2000];
        void add(int q) {
            for (int i = q; i < 2000; i = (i | (i + 1))) a[i]++;
        }
        int get(int q) {
            int res = 0;
            for (; q > 0; q = (q & (q + 1)) - 1) {
                res += a[q];
            }
            return res;
        }
        int sumAll() {
            return get(1999);
        }
    }

    int inv(List<Integer> c) {
        FenTree fenTree = new FenTree();
        int res = 0;
        for (int q : c) {
            res += fenTree.get(q);
            fenTree.add(q);
        }
        return res;
    }

    int sol2(int[] a) {
        int n = a.length;
        int mx = a[0];
        for (int i = 1; i < n; i++) mx = Math.max(mx, a[i]);
        int ans = 1000000000;
        for (int i = 0; i < (1 << n); i++) {
            int tmp = 0;
            for (int q = 0; q < n; q++) {
                for (int w = q + 1; w < n; w++) {
                    if (a[q] == mx) {
                        if (((1 << w) & i) == 0) tmp++;
                    } else if (a[w] == mx) {
                        if (((1 << q) & i) != 0) tmp++;
                    } else {
                        if (((1 << q) & i) == 0) {
                            if (((1 << w) & i) == 0) {
                                if (a[q] > a[w]) tmp++;
                            }
                        } else {
                            if (((1 << w) & i) == 0) {
                                tmp++;
                            } else {
                                if (a[q] < a[w]) tmp++;
                            }
                        }
                    }
                }
            }
            ans = Math.min(ans, tmp);
        }
        return ans;
    }

    void solve() throws IOException {
        int n = nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++) a[i] = nextInt();
//        int rightans = sol2(a);
        int[] b = a.clone();
        Arrays.sort(b);
        Map<Integer, Integer> mp = new TreeMap<Integer, Integer>();
        for (int i = 0; i < n; i++) mp.put(b[i], i);
        for (int i = 0; i < n; i++) b[mp.get(a[i])] = i;
        FenTree ft = new FenTree();
        int ans = 0;
        for (int i = n - 1; i >= 0; i--) {
            ans += Math.min(ft.get(b[i]), ft.sumAll() - ft.get(b[i]));
            ft.add(b[i]);
        }
        out.println(ans);
//        if (ans != rightans) System.err.println("Oh my god! " + ans + " " + rightans);
    }

    void run() {
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            //in = new BufferedReader(new InputStreamReader(System.in));
            //out = new PrintWriter(System.out);
            Locale.setDefault(Locale.UK);
            int tt = nextInt();
            for (int t = 1; t <= tt; t++) {
                out.print("Case #" + t + ": ");
                System.err.println("Case " + t);
                System.err.flush();
                solve();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            out.close();
        }
    }

    public static void main(String Args[]) {
        new Solution().run();
    }
}