import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Solution {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }
    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    void solve() throws IOException {
        int n = nextInt();
        int x = nextInt();
        int[] s = new int[n];
        for (int i = 0; i < n; i++) s[i] = nextInt();
        Arrays.sort(s);
        int b = 0;
        int e = n - 1;
        int ans = 0;
        while (b < e) {
            if (s[b] + s[e] <= x) {
                b++;
            }
            e--; ans++;
        }
        if (b == e) ans++;
        out.println(ans);
    }

    void run() {
        try {
            in = new BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            //in = new BufferedReader(new InputStreamReader(System.in));
            //out = new PrintWriter(System.out);
            Locale.setDefault(Locale.UK);
            int tt = nextInt();
            for (int t = 1; t <= tt; t++) {
                out.print("Case #" + t + ": ");
                System.err.println("Case " + t);
                System.err.flush();
                solve();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            out.close();
        }
    }

    public static void main(String Args[]) {
        new Solution().run();
    }
}