import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Map;
import java.util.Queue;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;


public class Main implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	final double eps = 1e-6;
	
	void solve() throws Exception {
		int n = nextInt();
		int[] d = new int[n];
		int[] l = new int[n];
		for (int i = 0; i < n; i++) {
			d[i] = nextInt();
			l[i] = nextInt();
		}
		int D = nextInt();
		int[] ml = new int[n];
		Arrays.fill(ml, -1);
		ml[0] = d[0];
		for (int i = 0; i < n - 1; i++) {
			int j = i + 1;
			while (j < n && ml[i] >= d[j] - d[i]) {
				int q = d[j] - d[i];
				if (q > l[j]) q = l[j];
				ml[j] = Math.max(ml[j], q);
				j++;
			}
		}
		boolean ans = false;
		for (int i = 0; i < n; i++) {
			if (ml[i] > 0 && D - d[i] <= ml[i]) ans = true;
		}
		if (ans) out.println("YES"); else out.println("NO");
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			for (int t = nextInt(), cnt = 1; t > 0; t--, cnt++) { 
				out.print("Case #" + cnt + ": ");
				solve();
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}

}
