import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	void solve() throws IOException {
		int n = nextInt();
		String q = "welcome to code jam";
		for (int nn = 0; nn < n; nn++) {
			String s = in.readLine();
			int[][] d = new int[s.length() + 1][q.length()];
			Arrays.fill(d[0], 0);
			for (int i = 1; i <= s.length(); i++) {
				for (int j = 0; j < q.length(); j++) {
					d[i][j] = d[i - 1][j];
					if (s.charAt(i - 1) ==q.charAt(j)) 
						if (j == 0) d[i][j]++; else d[i][j] += d[i - 1][j - 1];
					d[i][j] %= 10000;
				}
			}
			int ans = d[s.length()][q.length() - 1];
			out.println("Case #" + (nn + 1) + ": " + (ans / 1000) + (ans % 1000 / 100) + (ans % 100 / 10) + (ans % 10));
		}
	}

	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			if (System.getProperty("ONLINE_JUDGE") != null) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			} else {
				in = new BufferedReader(new FileReader(new File("input.txt")));
				out = new PrintWriter(new FileWriter(new File("output.txt")));
			}
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
