import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class Solution {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	void solve() throws Exception {
		String[] s = new String[4];
		for (int i = 0; i < 4; i++) {
			s[i] = nextToken();
		}
		int f = 0;
		for (int i = 0; i < 4; i++) {
			boolean resxh = true;
			boolean resxv = true;
			boolean resxd1 = true;
			boolean resxd2 = true;
			boolean resoh = true;
			boolean resov = true;
			boolean resod1 = true;
			boolean resod2 = true;
			for (int j = 0; j < 4; j++) {
				if (s[i].charAt(j) != '.') f++;
				resxh &= s[i].charAt(j) == 'X' || s[i].charAt(j) == 'T';
				resoh &= s[i].charAt(j) == 'O' || s[i].charAt(j) == 'T';
				resxv &= s[j].charAt(i) == 'X' || s[j].charAt(i) == 'T';
				resov &= s[j].charAt(i) == 'O' || s[j].charAt(i) == 'T';
				resxd1 &= s[j].charAt(j) == 'X' || s[j].charAt(j) == 'T';
				resod1 &= s[j].charAt(j) == 'O' || s[j].charAt(j) == 'T';
				resxd2 &= s[j].charAt(3 - j) == 'X' || s[j].charAt(3 - j) == 'T';
				resod2 &= s[j].charAt(3 - j) == 'O' || s[j].charAt(3 - j) == 'T';
			}
			if (resxh || resxv || resxd1 || resxd2) {
				out.println("X won");
				return;
			}
			if (resoh || resov || resod1 || resod2) {
				out.println("O won");
				return;
			}
		}
		if (f == 16) out.println("Draw"); else out.println("Game has not completed");
	}
	
	void run() {
		try {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
			int t = nextInt();
			for (int i = 1; i <= t; i++) {
				out.print("Case #" + i + ": ");
				solve();
			}
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Solution().run();
	}
	
}
