import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Map;
import java.util.Queue;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;


public class Main implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	final double EPS = 1e-8;
	
	void solve() throws Exception {
		int n = nextInt();
		double[] s = new double[n];
		double sum = 0;
		for (int i = 0; i < n; i++) {
			s[i] = nextInt();
			sum += s[i];
		}
		for (int i = 0; i < n; i++) {
			double b = 0;
			double e = 1;
			while (e - b > EPS) {
				double m = (b + e) / 2;
				double q = s[i] + sum * m;
				double ss = 0;
				for (int j = 0; j < n; j++) if (j != i) {
					double qi = (q - s[j]) / sum;
					if (qi < 0) qi = 0;
					ss += qi;
				}
				if (ss + m > 1) e = m; else b = m;
			}
			out.printf("%.7f ", b * 100);
		}
		out.println();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			for (int t = nextInt(), cnt = 1; t > 0; t--, cnt++) { 
				out.print("Case #" + cnt + ": ");
				solve();
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}

}
