import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class Solution {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	void solve() throws Exception {
		int n = nextInt();
		int m = nextInt();
		int[][] a = new int[n][m];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				a[i][j] = nextInt();
			}
		}
		boolean[] h = new boolean[n];
		boolean[] v = new boolean[m];
		while (true) {
			int mx = -1, my = -1;
			for (int i = 0; i < n; i++) if (!h[i]) {
				for (int j = 0; j < m; j++) if (!v[j]) {
					if (mx == -1 || a[mx][my] > a[i][j]) {
						mx = i; my = j;
					}
				}
			}
			if (mx == -1) break;
			boolean f = true;
			for (int i = 0; i < n; i++) if (!h[i]) {
				if (a[i][my] > a[mx][my]) f = false;
			}
			if (f) {
				v[my] = true;
				continue;
			}
			f = true;
			for (int j = 0; j < m; j++) if (!v[j]) {
				if (a[mx][j] > a[mx][my]) f = false;
			}
			if (f) {
				h[mx] = true;
				continue;
			}
			out.println("NO");
			return;
		}
		out.println("YES");
	}
	
	void run() {
		try {
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			int t = nextInt();
			for (int i = 1; i <= t; i++) {
				out.print("Case #" + i + ": ");
				solve();
			}
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Solution().run();
	}
	
}
