import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.StringTokenizer;

public class Solution {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	class Node {
		int n, x;
		Node l, r;
		Node p;
		Node(int q, int w, Node e) {
			n = q; x = w;
			p = e;
			l = r = null;
		}
	}
	
	long e, R;
	
	long ans(Node q, int l, int r, long be, long ee) {
		long res = 0;
		int n = r - l + 1;
		if (n * R <= ee - be) return 0;
		long ne = Math.max(0, ee - R * (r - q.n + 1));
		if (q.r != null) res += ans(q.r, q.n + 1, r, ne + R, ee);
		long me = Math.min(e, be + R * (q.n - l));
		if (q.l != null) res += ans(q.l, l, q.n - 1, be, me);
		res += (me - ne) * q.x;
		return res;
	}
	
	void solve() throws Exception {
		e = nextInt();
		R = nextInt();
		int n = nextInt();
		Node root = null;
		Node right = null;
		for (int i = 1; i <= n; i++) {
			if (root == null) 
				root = right = new Node(i, nextInt(), null);
			else {
				Node nw = new Node(i, nextInt(), null);
				while (right != null && right.x < nw.x) right = right.p;
				if (right == null) {
					nw.l = root;
					root.p = nw;
					root = right = nw;
				} else {
					nw.l = right.r;
					if (right.r != null) right.r.p = nw;
					right.r = nw;
					nw.p = right;
					right = nw;
				}
			}
		}
		out.println(ans(root, 1, n, e, -1));
	}
	
	void run() {
		try {
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			int t = nextInt();
			for (int i = 1; i <= t; i++) {
				out.print("Case #" + i + ": ");
				solve();
			}
		} catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Solution().run();
	}
	
}
