import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Map;
import java.util.Queue;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;


public class Main implements Runnable {
	
	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	String nextToken() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(in.readLine());
		}
		return st.nextToken();
	}
	
	int nextInt() throws Exception {
		return Integer.parseInt(nextToken());
	}
	
	class S {
		int e;
		int hmin, hmax;
		S(int q, int w, int qw) {
			e = q; hmin = w; hmax = qw;
		}
	}
	
	void solve() throws Exception {
		int n = nextInt();
		int[] a = new int[n];
		for (int i = 0; i < n - 1; i++) {
			a[i] = nextInt() - 1;
		}
		S[] st = new S[n + n];
		int stl = 0;
		st[stl] = new S(n, 0, (1 << 20));
		int[] ans = new int[n];
		Arrays.fill(ans, -1);
		for (int i = 0; i < n - 1; i++) {
			if (i == st[stl].e) stl--;
			if (a[i] > st[stl].e) {
				out.println("Impossible");
				return;
			}
			if (a[i] == st[stl].e) {
				if (ans[i] != ans[i - 1]) ans[i] = ans[i - 1] - 1;
				continue;
			}
			ans[i] = ((st[stl].hmin + st[stl].hmax) / 2);
			ans[a[i]] = ans[i];
			st[++stl] = new S(a[i], st[stl - 1].hmin, ans[i]);
		}
		for (int i = 0; i < n; i++) {
			out.print(ans[i] + " ");
		}
		out.println();
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			for (int t = nextInt(), cnt = 1; t > 0; t--, cnt++) { 
				out.print("Case #" + cnt + ": ");
				solve();
			}
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}

}
