import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Comparator;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Locale;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;

public class Solution implements Runnable {

	public static void main(String[] args) {
		(new Thread(new Solution())).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	
	BigInteger nextBigInt() throws IOException {
		return new BigInteger(nextToken());
	}
	
	void solve() throws IOException {
		int p = nextInt();
		long[][] a = new long[(1 << p) * 2 + 10][11];
		int n = (1 << p);
		int c = n - 1;
		int[] m = new int[n + 1];
		for (int i = 1; i <= n; i++) {
			m[i] = nextInt();
			for (int j = 0; j < p - m[i]; j++) a[c + i][j] = Long.MAX_VALUE / 10;
			for (int j = p - m[i]; j <= 10; j++) a[c + i][j] = 0;
		}
		c++;
		for (int i = p - 1; i >= 0; i--) {
			c = c / 2;
			for (int j = 0; j < (1 << i); j++) {
				long pr = nextInt();
				int q = c + j;
				for (int k = 0; k <= 10; k++) {
					a[q][k] = a[q * 2][k] + a[q * 2 + 1][k];
					if (k < 10) a[q][k] = Math.min(a[q][k], pr + a[q * 2][k + 1] + a[q * 2 + 1][k + 1]);
				}
				for (int k = 1; k <= 10; k++) a[q][k] = Math.min(a[q][k], a[q][k - 1]);
				for (int k = 1; k <= 10; k++) a[q][k] = Math.min(a[q][k], Long.MAX_VALUE / 10);
			}
		}
		out.println(a[1][0]);
	}
	
	public void run() {
		Locale.setDefault(Locale.UK);
		try {
			in = new BufferedReader(new FileReader(new File("input.txt")));
			out = new PrintWriter(new FileWriter(new File("output.txt")));
			int t = nextInt();
			for (int nn = 1; nn <= t; nn++) {
				out.print("Case #" + nn + ": ");
				solve();
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		out.flush();
	}

}
