package ak.tournaments.google.code_jam2014.round2;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URISyntaxException;
import java.util.Arrays;
import java.util.Comparator;

public class UpAndDown {

    static class tup {
        int v,src,tar;
        tup(int v, int i) { this.v=v; this.src=i; }
        public String toString() {return src+","+tar+","+v;}
    }
    
    static int count(tup[] t, int l, int r, final boolean asc) {
        Arrays.sort(t, l, r, new Comparator<tup>() {
            public int compare(tup o1, tup o2) {
                if(asc) {
                    return o1.v-o2.v;
                } else {
                    return o2.v-o1.v;
                }
            }
        });

        for (int i=l; i<r; i++) {
            t[i].tar=i;
        }
        Arrays.sort(t, l, r, new Comparator<tup>() {
            public int compare(tup o1, tup o2) {
                return o1.src-o2.src;
            }
        });
        
        int ret=0;
        for (int i=l; i<r; i++) {
            for (int j=l; j<r-1; j++) {
                if(t[j].tar>t[j+1].tar) {
                    tup aux=t[j]; t[j]=t[j+1]; t[j+1]=aux; ret++;
                }
            }
        }
        return ret;
    }
    
    static int solve(int[] a) {
        int n=a.length;
        if(n==1) {
            return 0;
        }
        
        int maxv=0, maxi=-1;
        for (int i=0; i<n; i++) {
            if(maxv<a[i]) {
                maxv=a[i]; maxi=i;
            }
        }

        tup[] t=new tup[n-1];
        for (int i=0, j=0; i<n; i++) {
            if(a[i]!=maxv) {
                t[j++]=new tup(a[i], i);
            }
        }
        
        
        int min=Integer.MAX_VALUE;
        for (int i=0; i<n; i++) {
            Arrays.sort(t, new Comparator<tup>() {
                public int compare(tup o1, tup o2) {
                    return o1.src-o2.src;
                }
            });
            
            int ret=Math.abs(maxi-i);
            
            ret+=count(t, 0, i, true);
            ret+=count(t, i, n-1, false);
            if(min>ret) {
                min=ret;
            }
        }
        return min;
    }
    
    static StringBuilder sb=new StringBuilder();
    static void parse(String l, int[] here) {
        sb.setLength(0);
        int len=l.length(), j=0;
        for (int i=0; i<len; i++) {
            char c=l.charAt(i);
            if(c==' ') {
                here[j++]=Integer.parseInt(sb.toString());
                sb.setLength(0);
            } else {
                sb.append(c);
            }
        }
        if(sb.length()>0) {
            here[j++]=Integer.parseInt(sb.toString());
        }
    }
    
    static void run_stream(InputStream ins) throws IOException, URISyntaxException {
        BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
        
        int T=Integer.parseInt(br.readLine());
        
        for (int i=0; i<T; i++) {
            int n=Integer.parseInt(br.readLine());
            int[] a=new int[n];
            parse(br.readLine(), a);
            long ret=solve(a);
            System.out.println("Case #"+(i+1)+": "+ret);
        }
        
    }

    public static void main(String[] args) throws IOException, URISyntaxException {
        run_stream(System.in);
    }

}
