package ak.tournaments.google.code_jam2014.qualification;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URISyntaxException;
import java.util.HashSet;

public class MinesweeperMaster2 {
    
    static boolean solve(int r, int maxc, int rem, char[][] out, HashSet<Long> memo) {
        long k=((long)r<<48)+((long)maxc<<32)+rem;
        if(memo.contains(k)) {
            return false;
        }
        
        if(rem==1||(r==out.length&&rem>0)) {
            return false;
        } 
        
        if(rem<=maxc+1) {
            for (int c=0; c<rem; c++) {
                out[r][c]='.';
            }
            return true;
        } 

        for (int new_maxc=1; r+1<out.length&&new_maxc<=maxc; new_maxc++) {
            if(solve(r+1,new_maxc,rem-(new_maxc+1),out,memo)) {
                for (int c=0; c<=new_maxc; c++) {
                    out[r][c]='.';
                }
                return true;
            }
        }
        
        memo.add(k);
        return false;
    }
    
    static void solve(int R, int C, int M, int t) {
        char[][] out=new char[R][C];
        for (int r=0; r<R; r++) {
            for (int c=0; c<C; c++) {
                out[r][c]='*';
            }
        }
        
        if(R==1) {
            for (int c=0; c<C-M; c++) {
                out[0][c]='.';
            }
        } else if(C==1) {
            for (int r=0; r<R-M; r++) {
                out[r][0]='.';
            }
        } else {
            int rem=R*C-M;
            if(rem>1) {
                boolean solved=false;;
                HashSet<Long> memo=new HashSet<Long>();
                for (int maxc=1; maxc<C&&rem-(maxc+1)*2>=0; maxc++) {
                    solved|=solve(2,maxc,rem-(maxc+1)*2,out,memo);
                    if(solved) {
                        for (int c=0; c<=maxc; c++) {
                            out[0][c]=out[1][c]='.';
                        }
                        break;
                    }
                }
                
                if(!solved) {
                    if(verify_imposible(R, C, M, t)) {
                        System.out.println("Case #"+t+": \nImpossible");
                    }
                    return;
                }
            }
        }
        out[0][0]='c';
        
        print_solution(out, t);
        
//        String msg=verify_solution(M, out);
//        if(msg!=null) {
//            throw new IllegalStateException(msg);
//        }
    }

    static void print_solution(char[][] out, int t) {
        int R=out.length, C=out[0].length;
        StringBuilder sb=new StringBuilder();
        sb.append("Case #"+t+":\n");
        for (int r=0; r<R; r++) {
            for (int c=0; c<C; c++) {
                sb.append(out[r][c]);
            }
            sb.append("\n");
        }
        
        System.out.print(sb.toString());
    }

    
    
    
    
    static StringBuilder sb=new StringBuilder();
    
    static void run_stream(InputStream ins) throws IOException, URISyntaxException {
        BufferedReader br=new BufferedReader(new InputStreamReader(System.in));
        
        int T=Integer.parseInt(br.readLine());
        
        for (int i=0; i<T; i++) {
            String[] RCM=br.readLine().split(" ");
            solve(
                    Integer.parseInt(RCM[0]),
                    Integer.parseInt(RCM[1]),
                    Integer.parseInt(RCM[2]),
                    i+1);
        }
    }

    public static void main(String[] args) throws IOException, URISyntaxException {
        run_stream(System.in);
    }

    
    
    
    
    static void visit(char[][] out, int r, int c, boolean[][] memo) {
        int R=out.length, C=out[0].length;
        if(memo[r][c]) {
            return;
        }
        memo[r][c]=true;
        
        if(r>0&&out[r-1][c]!='*') {
            visit(out, r-1, c, memo);
        }
        if(r>0&&c>0&&out[r-1][c-1]!='*') {
            visit(out, r-1, c-1, memo);
        }
        if(r>0&&c+1<C&&out[r-1][c+1]!='*') {
            visit(out, r-1, c+1, memo);
        }
        if(c+1<C&&out[r][c+1]!='*') {
            visit(out, r, c+1, memo);
        }
        if(c>0&&out[r][c-1]!='*') {
            visit(out, r, c-1, memo);
        }
        if(r+1<R&&c+1<C&&out[r+1][c+1]!='*') {
            visit(out, r+1, c+1, memo);
        }
        if(r+1<R&&c>0&&out[r+1][c-1]!='*') {
            visit(out, r+1, c-1, memo);
        }
        if(r+1<R&&out[r+1][c]!='*') {
            visit(out, r+1, c, memo);
        }
    }
    
    static boolean connected(char[][] out) {
        int R=out.length, C=out[0].length;
        boolean[][] memo=new boolean[R][C];
        boolean done=false;
        for (int i=0; i<R&&!done; i++) {
            for (int j=0; j<C; j++) {
                if(out[i][j]!='*') {
                    visit(out, i, j, memo);
                    done=true; break;
                }
            }
        }
        
        for (int i=0; i<R; i++) {
            for (int j=0; j<C; j++) {
                if(out[i][j]!='*'&&!memo[i][j]) {
                    return false;
                }
            }
        }
        
        return true;
    }
    
    static String verify_solution(int M, char[][] out, int[][] counts) {
        if(!connected(out)) {
            return "Output not connected";
        }
        
        int R=out.length, C=out[0].length;
        //validate
        int mcnt=0;
        for (int i=0; i<R; i++) {
            for (int j=0; j<C; j++) {
                if(out[i][j]=='*') {
                   mcnt++; 
                }
            }
        }
        if(mcnt!=M) {
            return "bomb count don't match, expected "+M+" got "+mcnt;
        }
        
        for (int i=0; i<R; i++) {
            for (int j=0; j<C; j++) {
                counts[i][j]=0;
            }
        }
        
        for (int i=0; i<R; i++) {
            for (int j=0; j<C; j++) {
                if(out[i][j]=='*') {
                    counts[i][j]++;
                }
                if(i>0&&out[i-1][j]=='*') {
                    counts[i][j]++;
                }
                if(i>0&&j>0&&out[i-1][j-1]=='*') {
                    counts[i][j]++;
                }
                if(i>0&&j+1<C&&out[i-1][j+1]=='*') {
                    counts[i][j]++;
                }
                if(j+1<C&&out[i][j+1]=='*') {
                    counts[i][j]++;
                }
                if(j>0&&out[i][j-1]=='*') {
                    counts[i][j]++;
                }
                if(i+1<R&&j+1<C&&out[i+1][j+1]=='*') {
                    counts[i][j]++;
                }
                if(i+1<R&&j>0&&out[i+1][j-1]=='*') {
                    counts[i][j]++;
                }
                if(i+1<R&&out[i+1][j]=='*') {
                    counts[i][j]++;
                }
            }
        }
        
        for (int i=0; i<R; i++) {
            for (int j=0; j<C; j++) {
                if(out[i][j]=='.') {
                    boolean good=false;
                    if(counts[i][j]==0) {
                        good=true;
                    }
                    if(i>0&&counts[i-1][j]==0) {
                        good=true;
                    }
                    if(i>0&&j>0&&counts[i-1][j-1]==0) {
                        good=true;
                    }
                    if(i>0&&j+1<C&&counts[i-1][j+1]==0) {
                        good=true;
                    }
                    if(j+1<C&&counts[i][j+1]==0) {
                        good=true;
                    }
                    if(j>0&&counts[i][j-1]==0) {
                        good=true;
                    }
                    if(i+1<R&&j+1<C&&counts[i+1][j+1]==0) {
                        good=true;
                    }
                    if(i+1<R&&j>0&&counts[i+1][j-1]==0) {
                        good=true;
                    }
                    if(i+1<R&&counts[i+1][j]==0) {
                        good=true;
                    }

                    if(!good) {
                        return "Not good at: "+i+","+j;
                    }
                }
            }
        }
        
        return null;
    }
    
    
    static int cnt_bits(int i) {
        int ret=0;
        while(i>0) {
            if((i&1)>0) {
                ret++;
            }
            i=i>>1;
        }
        return ret;
    }
    
    static void fill_solution(int set, char[][] out) {
        int R=out.length, C=out[0].length;
        for (int i=0; i<R; i++) {
            for (int j=0; j<C; j++) {
                out[i][j]='*';
            }
        }
        
        for (int bit=0; bit<=R*C; bit++) {
            int v=1<<bit;
            if((set&v)>0) {
                int r=bit/C, c=bit%C;
                out[r][c]='.';
            }
        }
    }
    
    static boolean verify_imposible(int R, int C, int M, int t) {
        int to=1<<(R*C)-1;
        
        char[][] out=new char[R][C];
        int[][] counts=new int[R][C];
        for (int i=1; i<=to; i++) {
            if(cnt_bits(i)==R*C-M) {
                fill_solution(i, out);
                if(verify_solution(M, out,counts)==null) {
                    boolean set_click=false;
                    for (int r=0; r<R&&!set_click; r++) {
                        for (int c=0; c<C&&!set_click; c++) {
                            if(counts[r][c]==0&&!set_click) {
                                out[r][c]='c';
                                set_click=true;
                            }
                        }
                    }
                    print_solution(out, t);
                    return false;
                }
            }
        }
        return true;
    }

}
