package problemb;

import java.util.*;
import java.io.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class ProblemB {
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();                
        for(int i = 1; i <= t; i++) {
            String answer = solveCase(in);
            System.out.println("Case #" + i + ": " + answer);
        }        
    }
    
    static final Pattern IN_PATTERN = Pattern.compile("\\d+");
    
    static final Pattern[] LESSER_DIGIT_PATTERNS = {
        Pattern.compile("X"),
        Pattern.compile("0"), 
        Pattern.compile("[01]"),
        Pattern.compile("[0-2]"),
        Pattern.compile("[0-3]"),
        Pattern.compile("[0-4]"),
        Pattern.compile("[0-5]"),
        Pattern.compile("[0-6]"),
        Pattern.compile("[0-7]"),
        Pattern.compile("[0-8]")
    };
    
    static final Pattern[] GREATER_DIGIT_PATTERNS = {
        Pattern.compile("[1-9]"), 
        Pattern.compile("[2-9]"),
        Pattern.compile("[3-9]"),
        Pattern.compile("[4-9]"),
        Pattern.compile("[5-9]"),
        Pattern.compile("[6-9]"),
        Pattern.compile("[7-9]"),
        Pattern.compile("[89]"),
        Pattern.compile("9"),
        Pattern.compile("X")
    };
    
    static String solveCase(Scanner in) {
        String n = in.next(IN_PATTERN);
        
        int cursor = 0;
        for(;;) {            
            int digit = n.charAt(cursor) - '0';
            Matcher matcher = LESSER_DIGIT_PATTERNS[digit].matcher(n);
            if(matcher.find(cursor)) {
                int pos = matcher.start();
                StringBuilder sb = new StringBuilder(n.length());
                long x = Long.parseLong(n.substring(0, pos)) - 1;
                if(x > 0)
                    sb.append(x);
                for(int i = pos; i < n.length(); i++)
                    sb.append("9");
                n = sb.toString();
                cursor = 0;
                continue;
            }
            matcher = GREATER_DIGIT_PATTERNS[digit].matcher(n);
            if(matcher.find(cursor)) {
                cursor = matcher.start();
                continue;
            }
            return n;
        }
    }
}
