import java.io.*;

public class problem2
{
    static long n;
    static boolean[][] allCakes = new boolean[100][];
    static int[] counters = new int[100];


    public static void main(String[] args)
    {
        try {
            readIn(args[0]);
            calculate();
            writeOut(args[1]);
        }
        catch (Exception e) {
            e.printStackTrace();
        }
    }


    private static void readIn(String arg) throws IOException
    {
        File in = new File(arg);
        BufferedReader inReader = new BufferedReader(new FileReader(in));
        n = new Long(inReader.readLine());
        for (int i1 = 0; i1 < n; i1++) {
            String mask = inReader.readLine().trim();
            allCakes[i1] = new boolean[mask.length()];
            for (int i2 = 0; i2 < mask.length(); i2++) {
                allCakes[i1][i2] = mask.charAt(i2) == '+';
            }
        }
    }


    private static void calculate()
    {
        for (int i1 = 0; i1 < n; i1++) {
            counters[i1] = stepsNumber(allCakes[i1]);
        }
    }

    private static int stepsNumber(boolean[] cakes)
    {
        int step = 0;
        int topBad = getTopBad(cakes);
        int[] goodFunction = new int[100];
        while (topBad != -1) {

            step ++;
            if (cakes[0]) {
                // Try to get maximum bad at the top for the next step
                goodFunction[0] = 1;
                if (cakes.length > 1) {
                    for (int i1 = 1; i1 < topBad; i1++) {
                        if (cakes[i1]) {
                            goodFunction[i1] = goodFunction[i1 - 1] + 1;
                        } else {
                            goodFunction[i1] = 0;
                        }
                    }
                }

                int maxGood = -1, wrapPosition = -1;
                for (int i1 = 0; i1 < topBad; i1++) {
                    if (goodFunction[i1] > maxGood) {

                        maxGood = goodFunction[i1];
                        wrapPosition = i1;
                    }
                }

                wrapCakes(cakes, wrapPosition);
            }
            else {
                // Wrap
                wrapCakes(cakes, topBad);
            }
            topBad = getTopBad(cakes);
        }
        return step;
    }

    private static void wrapCakes(boolean[] cakes, int tail)
    {
        for (int i1 = 0; i1 < (tail + 1) / 2; i1++) {
            boolean temp = cakes[i1];
            cakes[i1] = ! cakes[tail - i1];
            cakes[tail - i1] = ! temp;
        }

        if (tail % 2 == 0)
            cakes[tail / 2] = ! cakes[tail / 2];
    }


    private static int getTopBad(boolean[] cakes)
    {
        for (int i1 = cakes.length - 1; i1 >= 0; i1--) {
            if (! cakes[i1])
                return i1;
        }
        return -1;
    }


    private static void writeOut(String arg) throws IOException
    {
        File out = new File(arg);
        BufferedWriter outWriter = new BufferedWriter(new FileWriter(out));
        for (int i1 = 0; i1 < n; i1++) {
            if (i1 > 0)
                outWriter.newLine();
            outWriter.write("Case #" + (1+ i1) + ": " + counters[i1]);
        }
        outWriter.close();
    }

}
