package problema;

import java.util.Arrays;


public class Osmos
{
  private int a0;
  private int n;
  private int transformationsCount;

  private int[] motesA;
  private int[] motesB;

  private int inconsistencyIndex = -1;



  public Osmos(String dimensionsStr)
  {
    String[] dimensionsStrArray = dimensionsStr.trim().split(" ");
    a0 = Integer.parseInt(dimensionsStrArray[0]);
    n = Integer.parseInt(dimensionsStrArray[1]);

    motesA = new int[n + 1];
    motesA[0] = a0;
  }


  public void setMotes(String motesStr)
  {
    String[] motesStrArray = motesStr.trim().split(" ");
    for (int i1 = 0; i1 < n; i1++) {
      motesA[i1 + 1] = Integer.parseInt(motesStrArray[i1]);
    }
    Arrays.sort(motesA, 1, n + 1);
    updateCumulative();
  }


  public void transformTillConsistent()
  {
    if (a0 == 1) {
      transformationsCount = n;
      return;
    }


    while (! isConsistent()) {

      transformationsCount ++;

      int minimalIncrements = 0;
      int base = motesB[inconsistencyIndex - 1];
      while (base <= motesA[inconsistencyIndex]) {

        minimalIncrements ++;
        base += base - 1;
      }

      if (minimalIncrements == 1 ||
          n - inconsistencyIndex + 1 >= minimalIncrements) {

        int[] motesAN = new int[n + 2];
        for (int i1 = 0; i1 <= n; i1++)
          motesAN[i1] = motesA[i1];
        motesAN[n + 1] = motesB[inconsistencyIndex - 1] - 1;

        n ++;
        motesA = motesAN;
      }
      else {

        int[] motesAN = new int[n];
        for (int i1 = 0; i1 < n; i1++)
          motesAN[i1] = motesA[i1];

        n --;
        motesA = motesAN;
      }

      Arrays.sort(motesA, 1, n + 1);
      updateCumulative();
    }
  }


  private boolean isConsistent()
  {
    for (int i1 = 1; i1 <= n; i1++) {
      if (motesB[i1 - 1] <= motesA[i1]) {
        inconsistencyIndex = i1;
        return false;
      }
    }
    return true;
  }


  private void updateCumulative()
  {
    motesB = new int[n + 1];
    motesB[0] = a0;
    for (int i1 = 1; i1 <= n; i1++) {
      motesB[i1] = motesB[i1 - 1] + motesA[i1];
    }
  }


  public int getTransformationsCount()
  {
    return transformationsCount;
  }
}
