import java.io.*;
import java.util.HashMap;
import java.util.Map;

public class problem2
{
  static Map<Character, Integer> DIGITS = new HashMap();
  static {
    DIGITS.put('0', 0);
    DIGITS.put('1', 1);
    DIGITS.put('2', 2);
    DIGITS.put('3', 3);
    DIGITS.put('4', 4);
    DIGITS.put('5', 5);
    DIGITS.put('6', 6);
    DIGITS.put('7', 7);
    DIGITS.put('8', 8);
    DIGITS.put('9', 9);
  }


  static long t;
  static long n;

  static String codersScoreMask;
  static String jammersScoreMask;

  static char[] codersScore;
  static char[] jammerScore;

  public static void main(String[] args)
  {
    BufferedReader in = null;
    BufferedWriter out = null;
    try {
      in = new BufferedReader(new FileReader(args[0]));
      out = new BufferedWriter(new FileWriter(args[1]));

      t = new Long(in.readLine());
      for (int caseNumber = 1; caseNumber <= t; caseNumber++) {
        readCaseInput(in, caseNumber);
        calculateCase(caseNumber);
        if (caseNumber > 1)
          out.newLine();
        out.write("Case #" + caseNumber + ": " + getCaseResult(caseNumber));
        out.flush();
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    finally {
      closeAnyway(in);
      closeAnyway(out);
    }
  }


  private static void closeAnyway(Closeable resource)
  {
    if (resource != null) {
      try {
        resource.close();
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }
  }


  ///////////////////////////////////////////////////////////////////////////////////////////////////////


  private static void readCaseInput(BufferedReader in, int caseNumber) throws IOException
  {
    String[] data = in.readLine().split(" ");
    codersScoreMask = data[0];
    jammersScoreMask = data[1];
  }


  private static String getCaseResult(int caseNumber)
  {
    return new String(codersScore) + " " + new String(jammerScore);
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////////////


  private static void calculateCase(int caseNumber)
  {
    codersScore = new char[codersScoreMask.length()];
    jammerScore = new char[jammersScoreMask.length()];

    // 0 - equal
    // 1 - coders are greater > reduce for coders, increase for jammers
    // -1 - coders are smaller > vice versa
    int direction = 0;

    for (int i1 = 0; i1 < codersScoreMask.length(); i1++) {

      char codersDigit = codersScoreMask.charAt(i1);
      char jammersDigit = jammersScoreMask.charAt(i1);

      if (codersDigit == '?' && jammersDigit == '?') {
        if (direction == 0) {
          record(i1, '0', '0');
        }
        else if (direction == 1) {
          record(i1, '0', '9');
        }
        else {
          record(i1, '9', '0');
        }
      }
      else if (codersDigit == '?') {
        if (direction == 0) {
          record(i1, jammersDigit, jammersDigit);
        }
        else if (direction == 1) {
          record(i1, '0', jammersDigit);
        }
        else {
          record(i1, '9', jammersDigit);
        }
      }
      else if (jammersDigit == '?') {
        if (direction == 0) {
          record(i1, codersDigit, codersDigit);
        }
        else if (direction == 1) {
          record(i1, codersDigit, '9');
        }
        else {
          record(i1, codersDigit, '0');
        }
      }
      else {
        record(i1, codersDigit, jammersDigit);
      }

      if (direction == 0) {

        int codersBefore = DIGITS.get(codersScore[i1]);
        int jammersBefore = DIGITS.get(jammerScore[i1]);

        if (codersBefore != jammersBefore)
          direction = (codersBefore > jammersBefore) ? 1 : -1;
      }
    }
  }

  private static void record(int i1, char codersDigit, char jammersDigit)
  {
    codersScore[i1] = codersDigit;
    jammerScore[i1] = jammersDigit;
  }
}
