import java.io.*;
import java.util.Arrays;
import java.util.BitSet;

public class task3
{
  private static int nCases;
  private static BufferedReader in;
  private static BufferedWriter out;

  // Case input parameters
  static int k, n;
  static BitSet bath;
  static int[] ls, rs;


  public static void main(String[] args)
  {
    try {
      String inName = args[0];
      String outName = inName + "_out.txt";
      in = new BufferedReader(new FileReader(inName));
      out = new BufferedWriter(new FileWriter(outName));

      nCases = Integer.parseInt(in.readLine());

      for (int caseNumber = 1; caseNumber <= nCases; caseNumber ++) {
        parseCaseInput(caseNumber, in.readLine());
        solveTheCase(caseNumber, out);
      }
    }
    catch (Throwable e) {
      e.printStackTrace();
    }
    finally {
      try {
        if (in != null) {
          in.close();
        }
        if (out != null) {
          out.flush();
          out.close();
        }
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }
  }


  private static void parseCaseInput(int caseNumber, String caseInput)
  {
    String[] parsed = caseInput.split("\\s");
    n = 2 + Integer.parseInt(parsed[0]);
    k = Integer.parseInt(parsed[1]);

    bath = new BitSet(n);
    bath.set(0);
    bath.set(n - 1);

    ls = new int[n];
    Arrays.fill(ls, 0);
    rs = new int[n];
    Arrays.fill(rs, 0);
    
    updateLS(0);
    updateRS(n - 1);
  }

  private static void updateRS(int occupiedStallIndex)
  {
    rs[occupiedStallIndex] = -1;
    int limitIndex = bath.previousSetBit(occupiedStallIndex - 1);
    int counter = 0;
    for (int i1 = occupiedStallIndex - 1; i1 > limitIndex; i1 --)
      rs[i1] = counter ++;
  }

  private static void updateLS(int occupiedStallIndex)
  {
    ls[occupiedStallIndex] = -1;
    int limitIndex = bath.nextSetBit(occupiedStallIndex + 1);
    int counter = 0;
    for (int i1 = occupiedStallIndex + 1; i1 < limitIndex; i1 ++)
      ls[i1] = counter ++;
  }


  private static void solveTheCase(int caseNumber, BufferedWriter out) throws IOException
  {
    int minFactor = -1, maxFactor = -1;
    for (int visitor = 1; visitor <= k; visitor ++) {

      int stallIndex = -1;
      minFactor = -1; maxFactor = -1;
      for (int index = 0; index < n; index ++) {

        int minL = Math.min(ls[index], rs[index]);
        int maxL = Math.max(ls[index], rs[index]);
        if (minL > minFactor || minL == minFactor && maxL > maxFactor) {
          stallIndex = index;
          minFactor = minL;
          maxFactor = maxL;
        }
      }

      bath.set(stallIndex);
      updateLS(stallIndex);
      updateRS(stallIndex);
    }

    out.write("Case #" + caseNumber + ": " + maxFactor + " " + minFactor);
    out.newLine();
  }
}
