import java.io.*;

public class task2
{
  private static int nCases;
  private static BufferedReader in;
  private static BufferedWriter out;

  // Case input parameters
  static int[] number;


  public static void main(String[] args)
  {
    try {
      String inName = args[0];
      String outName = inName + "_out.txt";
      in = new BufferedReader(new FileReader(inName));
      out = new BufferedWriter(new FileWriter(outName));

      nCases = Integer.parseInt(in.readLine());

      for (int caseNumber = 1; caseNumber <= nCases; caseNumber ++) {
        parseCaseInput(caseNumber, in.readLine());
        solveTheCase(caseNumber, out);
      }
    }
    catch (Throwable e) {
      e.printStackTrace();
    }
    finally {
      try {
        if (in != null) {
          in.close();
        }
        if (out != null) {
          out.flush();
          out.close();
        }
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }
  }


  private static void parseCaseInput(int caseNumber, String caseInput)
  {
    number = new int[caseInput.length()];
    for (int i1 = 0; i1 < caseInput.length(); i1++)
      number[i1] = Integer.parseInt("" + caseInput.charAt(i1));
  }


  private static void solveTheCase(int caseNumber, BufferedWriter out) throws IOException
  {
    int dpIndex = dirtyPairIndex(number);
    while (dpIndex != -1) {

      if (number[dpIndex] > 1) {
        number[dpIndex] --;
        fill9(dpIndex + 1);
      }
      else {
        number[0] = 0;
        fill9(1);
      }
      dpIndex = dirtyPairIndex(number);
    }

    out.write("Case #" + caseNumber + ": " + formatNumber());
    out.newLine();
  }

  private static void fill9(int beginIndex)
  {
    for (int i1 = beginIndex; i1 < number.length; i1++)
      number[i1] = 9;
  }

  private static int dirtyPairIndex(int[] data)
  {
    for (int index = 0; index < data.length - 1; index ++) {
      if (data[index] > data[index + 1])
        return index;
    }
    return -1;
  }


  private static String formatNumber()
  {
    StringBuilder result = new StringBuilder();
    int index = 0;
    while (index < number.length - 1 && number[index] == 0)
      index++;
    for (; index < number.length; index++)
      result.append(number[index]);
    return result.toString();
  }
}
