package bcase;

import com.sun.deploy.association.Action;


public class GrassField
{
  private int rows, columns;
  private int[][] field;
  private int[] maxOfRows;
  private int[] maxOfColumns;


  public GrassField(String dimensionsStr)
  {
    String[] dimentsionsStrArray = dimensionsStr.trim().split(" ");
    rows = Integer.parseInt(dimentsionsStrArray[0]);
    columns = Integer.parseInt(dimentsionsStrArray[1]);

    field = new int[rows][];
    for (int i1 = 0; i1 < rows; i1++)
      field[i1] = new int[columns];
  }


  public int getRows()
  {
    return rows;
  }


  public void addRow(int row, String rowStr)
  {
    String[] rowDataStr = rowStr.trim().split(" ");
    for (int column = 0; column < rowDataStr.length; column++) {
      field[row][column] = Integer.parseInt(rowDataStr[column]);
    }
  }


  public PatternPossibility getPatternPossibility()
  {
    // Prepare max values
    // Max value defines a height of lawnmower at this row/column
    maxOfRows = new int[rows];
    for (int row = 0; row < rows; row++)
      maxOfRows[row] = maxOfRow(row);
    maxOfColumns = new int[columns];
    for (int column = 0; column < columns; column++)
      maxOfColumns[column] = maxOfColumn(column);

    // Check all rows
    for (int row = 0; row < rows; row++) {
      for (int column = 0; column < columns; column++) {

        // Every lawn square height must be a height of lawnmower at either this row or etiher this column
        if (field[row][column] < maxOfRows[row] && field[row][column] < maxOfColumns[column]) {
          return PatternPossibility.NO;
        }
      }
    }

    return PatternPossibility.YES;
  }


  private int maxOfRow(int row)
  {
    int max = field[row][0];
    for (int column = 1; column < columns; column++)
      if (field[row][column] > max)
        max = field[row][column];
    return max;
  }


  private int maxOfColumn(int column)
  {
    int max = field[0][column];
    for (int row = 1; row < rows; row++)
      if (field[row][column] > max)
        max = field[row][column];
    return max;
  }


  protected enum PatternPossibility
  {
    YES ("YES"),
    NO  ("NO");

    private String description;

    PatternPossibility(String description)
    {
      this.description = description;
    }

    public String getDescription()
    {
      return description;
    }
  }
}
