package round1c.problema;

import java.io.*;


public class SolveA
{
  // Launcher /////////////////////////////////////////////////////////////////////////////////

  public static void main(String[] args) throws IOException
  {
    long time = System.currentTimeMillis();

    BufferedReader in = new BufferedReader(new FileReader(args[0]));
    BufferedWriter out = new BufferedWriter(new FileWriter(args[1]));

    int testCount = Integer.parseInt(in.readLine());
    for (int testNumber = 0; testNumber < testCount; testNumber ++) {

      String dimensionsStr = in.readLine();

      SolveA solution = new SolveA(dimensionsStr);
      solution.calculate();

      StringBuilder result = new StringBuilder();
      result.append("Case #").append(testNumber + 1).append(": ").append(solution.getResult());

      out.write(result.toString());
      out.newLine();
    }

    in.close();
    out.close();

    System.out.println(System.currentTimeMillis() - time);
  }


  // Solution /////////////////////////////////////////////////////////////////////////////////


  private String name;
  private int n;

  private long nValue;


  public SolveA(String dimensionsStr)
  {
    String[] dimensionsStrArray = dimensionsStr.trim().split(" ");
    name = dimensionsStrArray[0];
    n = Integer.parseInt(dimensionsStrArray[1]);
  }


  private void calculate()
  {
    int m = name.length();

    if (m == 0 || n > m)
      return;

    int[] z = new int[m];
    z[0] = isConsonant(name.charAt(0)) ? 1 : 0;
    for (int i1 = 1; i1 < m; i1++) {
      if (isConsonant(name.charAt(i1)))
        z[i1] = z[i1 - 1] + 1;
      else
        z[i1] = 0;
    }

    int[] b = new int[m];
    for (int i1 = m-1; i1 > m - n; i1--)
      b[i1] = Integer.MAX_VALUE;

    for (int i1 = m - n; i1 >= 0; i1 --) {
      if (z[i1 + n - 1] >= n)
        b[i1] = i1 + n - 1;
      else {
        if (i1 == m - 1) {
          b[i1] = Integer.MAX_VALUE;
        }
        else {
          b[i1] = b[i1 + 1];
        }
      }
    }

    nValue = 0;
    for (int i1 = 0; i1 < m; i1++) {
      if (b[i1] != Integer.MAX_VALUE)
        nValue += m - b[i1];
    }
  }


  private boolean isConsonant(char c)
  {
    switch(c) {
      case 'a':
      case 'e':
      case 'i':
      case 'o':
      case 'u':
        return false;

      default:
        return true;
    }
  }


  private String getResult()
  {
    return String.valueOf(nValue);
  }
}
