import java.io.*;
import java.util.SortedMap;
import java.util.TreeMap;

public class task3
{
  private static int nCases;
  private static BufferedReader in;
  private static BufferedWriter out;

  // Case input parameters
  static int k, n;


  public static void main(String[] args)
  {
    try {
      String inName = args[0];
      String outName = inName + "_out.txt";
      in = new BufferedReader(new FileReader(inName));
      out = new BufferedWriter(new FileWriter(outName));

      nCases = Integer.parseInt(in.readLine());

      for (int caseNumber = 1; caseNumber <= nCases; caseNumber ++) {
        parseCaseInput(caseNumber, in.readLine());
        solveTheCase(caseNumber, out);
      }
    }
    catch (Throwable e) {
      e.printStackTrace();
    }
    finally {
      try {
        if (in != null) {
          in.close();
        }
        if (out != null) {
          out.flush();
          out.close();
        }
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }
  }


  private static void parseCaseInput(int caseNumber, String caseInput)
  {
    String[] parsed = caseInput.split("\\s");
    n = Integer.parseInt(parsed[0]);
    k = Integer.parseInt(parsed[1]);
  }



  private static void solveTheCase(int caseNumber, BufferedWriter out) throws IOException
  {
    int maxFactor = -1, minFactor = -1;
    if (k == n) {
      minFactor = maxFactor = 0;
    }
    /*else if (k > n / 2) {
      minFactor = 0;
      maxFactor = 1;
    }*/
    else {

      SortedMap<Integer, Integer> bath = new TreeMap<>();
      bath.put(n, 1);

      for (int visitor = 1; visitor < k; visitor ++) {

        Integer longestLength = bath.lastKey();
        int longestCount = bath.get(longestLength);
        if (longestCount > 1) {
          bath.put(longestLength, longestCount - 1);
        }
        else {
          bath.remove(longestLength);
        }

        int remaining = longestLength - 1;
        if (longestLength % 2 != 0) {
          addSegment(bath, longestLength / 2, 2);
        }
        else {
          addSegment(bath, longestLength / 2, 1);
          addSegment(bath, longestLength / 2 - 1, 1);
        }
      }

      int lastVisitorSegment = bath.lastKey();
      maxFactor = lastVisitorSegment / 2;
      minFactor = lastVisitorSegment % 2 == 0 ? maxFactor - 1 : maxFactor;
    }

    out.write("Case #" + caseNumber + ": " + maxFactor + " " + minFactor);
    out.newLine();
  }


  private static void addSegment(SortedMap<Integer, Integer> bath, int length, int count)
  {
    Integer oldCount = bath.get(length);
    bath.put(length, count + (oldCount == null ? 0 : oldCount));
  }
}
