import java.io.*;
import java.util.*;

public class problem1
{
  static long t;
  static String encoded;
  static StringBuilder decoded;

  static HashMap<Character, Integer> frequency = new HashMap<>();
  static HashMap<Integer, Integer> numNumber = new HashMap<>();


  public static void main(String[] args)
  {
    BufferedReader in = null;
    BufferedWriter out = null;
    try {

      in = new BufferedReader(new FileReader(args[0]));
      out = new BufferedWriter(new FileWriter(args[1]));

      t = new Long(in.readLine());
      for (int caseNumber = 1; caseNumber <= t; caseNumber++) {
        readCaseInput(in, caseNumber);
        calculateCase(caseNumber);
        if (caseNumber > 1)
          out.newLine();
        out.write("Case #" + caseNumber + ": " + getCaseResult(caseNumber));
        out.flush();
      }
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    finally {
      closeAnyway(in);
      closeAnyway(out);
    }
  }


  private static void closeAnyway(Closeable resource)
  {
    if (resource != null) {
      try {
        resource.close();
      }
      catch (IOException e) {
        e.printStackTrace();
      }
    }
  }


  ///////////////////////////////////////////////////////////////////////////////////////////////////////


  private static void readCaseInput(BufferedReader in, int caseNumber) throws IOException
  {
    encoded = in.readLine();
  }


  private static String getCaseResult(int caseNumber)
  {
    return decoded.toString();
  }

  /////////////////////////////////////////////////////////////////////////////////////////////////////////


  private static void calculateCase(int caseNumber)
  {
    frequency.clear();
    numNumber.clear();
    decoded = new StringBuilder();

    for (int i1 = 0; i1 < encoded.length(); i1++) {

      char letter = encoded.charAt(i1);
      Integer occurrences = frequency.get(letter);
      if (occurrences == null)
        occurrences = 0;
      frequency.put(letter, occurrences + 1);
    }

    handleUniqueCharacter("ZERO", 'Z', 0);
    handleUniqueCharacter("TWO", 'W', 2);
    handleUniqueCharacter("SIX", 'X', 6);
    handleUniqueCharacter("FOUR", 'U', 4);
    handleUniqueCharacter("EIGHT", 'G', 8);
    // F is taken by four
    handleUniqueCharacter("FIVE", 'F', 5);
    // S is taken by six
    handleUniqueCharacter("SEVEN", 'S', 7);
    // O is taken by zero, two, four
    handleUniqueCharacter("ONE", 'O', 1);
    // T is taken by two, eight
    handleUniqueCharacter("THREE", 'T', 3);
    // 9 is the rest
    handleUniqueCharacter("NINE", 'I', 9);

    for (int i1 = 0; i1 <= 9; i1++) {
      if (numNumber.containsKey(i1)) {
        Integer cases = numNumber.get(i1);
        for (int i2 = 0; i2 < cases; i2++) {
          decoded.append(i1);
        }
      }
    }
  }


  private static void handleUniqueCharacter(String NUMBER_STR, char unique, int num)
  {
    Integer numberOfCases = frequency.get(unique);
    if (numberOfCases != null && numberOfCases > 0) {
      numNumber.put(num, numberOfCases);
      for (int i1 = 0; i1 < NUMBER_STR.length(); i1 ++) {
        Integer oldFreq = frequency.get(NUMBER_STR.charAt(i1));
        frequency.put(NUMBER_STR.charAt(i1), oldFreq - numberOfCases);
      }
    }
  }
}
