package ccase;

import java.math.BigInteger;
import java.math.BigDecimal;


public class PalindromeObserver
{
  private BigInteger intervalBegin, intervalEnd;

  public PalindromeObserver(String intervalStr)
  {
    String[] dimentsionsStrArray = intervalStr.trim().split(" ");
    intervalBegin = new BigInteger(dimentsionsStrArray[0]);
    intervalEnd = new BigInteger(dimentsionsStrArray[1]);
  }


  public long getFairSquareCount()
  {
    final BigInteger ONE = BigInteger.valueOf(1);

    long fairSquareCount = 0;

    // Define starting point of base number
    double baseOfIntervalBegin = Math.sqrt(intervalBegin.doubleValue());
    BigDecimal baseNumberUpperBounded = new BigDecimal(baseOfIntervalBegin);

    BigInteger baseNumber = baseNumberUpperBounded.toBigInteger();
    // Make a safety buffer
    baseNumber = baseNumber.subtract(ONE);

    // Iterate through base number and check both base numbers and square numbers to be palindromes
    boolean isInInterval = false;
    for (;;) {
      if (isPalindrome(baseNumber)) {

        BigInteger number = baseNumber.multiply(baseNumber);
        if (! isInInterval && number.compareTo(intervalBegin) < 0) {
          // Cotinue is missed here to do increment below
        }
        else {
          isInInterval = true;
          if (number.compareTo(intervalEnd) > 0)
            break;

          if (isPalindrome(number))
            fairSquareCount ++;
        }

      }

      baseNumber = baseNumber.add(ONE);
    }

    return fairSquareCount;
  }


  public boolean isPalindrome(BigInteger number)
  {
    String numberStr = number.toString();
    for (int i1 = 0; i1 < numberStr.length() / 2; i1++)
      if (numberStr.charAt(i1) != numberStr.charAt(numberStr.length() - i1 - 1))
        return false;
    return true;
  }
}
