import java.io.*;
import java.text.DecimalFormat;

// Aliaksei Svittsau
public class Round1BProblemA
{
  static final DecimalFormat SPEED_FORMAT = new DecimalFormat("#.000000");

  static final boolean IS_DEBUG_MODE = false;

  static int t;
  static long n;

  static double d, tMax;


  public static void main(String[] args)
  {
    try {
      String inPathName = args[0];
      String inPathBase = inPathName.substring(0, inPathName.lastIndexOf('.'));

      File inFile = new File(inPathName);
      File outFile = new File(inPathBase + "_out.txt");

      BufferedReader in = new BufferedReader(new FileReader(inFile));
      BufferedWriter out = new BufferedWriter(new FileWriter(outFile));

      t = Integer.parseInt(in.readLine());
      for (int caseNumber = 1; caseNumber <= t; caseNumber ++) {
        readCaseInput(caseNumber, in);
        solveCase(caseNumber, out);
        if (IS_DEBUG_MODE)
          System.out.println(caseNumber);
      }
      out.close();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }


  private static void readCaseInput(int caseNumber, BufferedReader in) throws IOException
  {
    String[] dnStr = in.readLine().split(" ");
    d = Long.parseLong(dnStr[0]);
    n = Long.parseLong(dnStr[1]);

    if (IS_DEBUG_MODE) {
      System.out.println(d);
      System.out.println(n);
    }

    tMax = 0;
    for (int horseIndex = 0; horseIndex < n; horseIndex ++) {

      String[] ksStr = in.readLine().split(" ");
      double k = Long.parseLong(ksStr[0]);
      double s = Long.parseLong(ksStr[1]);

      double t = (d - k) / s;

      tMax = Math.max(tMax, t);
    }
  }


  private static void solveCase(int caseNumber, BufferedWriter out) throws IOException
  {
    double speed = d / tMax;

    out.write("Case #" + caseNumber + ": " +  SPEED_FORMAT.format(speed).replace(',', '.'));
    out.newLine();
    out.flush();
  }
}
