import java.io.InputStreamReader;
import java.io.IOException;
import java.util.Locale;
import java.io.BufferedReader;
import java.io.OutputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.File;
import java.util.StringTokenizer;
import java.math.BigInteger;
import java.io.FilenameFilter;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author AlexFetisov
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "A-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("a.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskA solver = new TaskA();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskA {

    private int n;
    private int m;
    private char[][] f;
    char[][] f2;
    
    public void solve(int testNumber, InputReader in, PrintWriter out) {
        n = in.nextInt();
        m = in.nextInt();
        f = new char[n][m];
        f2 = new char[n][m];
        for (int i = 0; i < n; ++i) {
            f[i] = in.nextString().toCharArray();
            f2[i] = f[i].clone();
        }

        best = 1000000000;
        
        // stupid
//        rec(0, 0, 0);

        int changed = 0;
        int[] amRow = new int[n];
        int[] amCol = new int[m];
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (f[i][j] != '.') {
                    ++amRow[i];
                    ++amCol[j];
                }
            }
        }

        while (true) {
            boolean was = false;
            for (int row = 0; row < n; ++row) {
                if (amRow[row] == 1) continue;
                for (int i = 0; i < m; ++i) {
                    if (f[row][i] != '.') {
                        if (f[row][i] == '<') {
                            f[row][i] = '>';
                            was = true;
                            ++changed;
                        } else if (f[row][i] == '^' || f[row][i] == 'v') {
                            if (amCol[i] == 1) {
                                f[row][i] = '>';
                                was = true;
                                ++changed;
                            }
                        }
                        break;
                    }

                }
                for (int i = m - 1; i >= 0; --i) {
                    if (f[row][i] != '.') {
                        if (f[row][i] == '>') {
                            f[row][i] = '<';
                            was = true;
                            ++changed;
                        } else if (f[row][i] == '^' || f[row][i] == 'v') {
                            if (amCol[i] == 1) {
                                f[row][i] = '<';
                                was = true;
                                ++changed;
                            }
                        }
                        break;
                    }
                }
            }

            for (int col = 0; col < m; ++col) {
                if (amCol[col] == 1) continue;
                for (int i = 0; i < n; ++i) {
                    if (f[i][col] != '.') {
                        if (f[i][col] == '^') {
                            f[i][col] = 'v';
                            ++changed;
                            was = true;
                        } else if (f[i][col] == '<' || f[i][col] == '>') {
                            if (amRow[i] == 1) {
                                f[i][col] = 'v';
                                ++changed;
                                was = true;
                            }
                        }
                        break;
                    }

                }
                for (int i = n - 1; i >= 0; --i) {
                    if (f[i][col] != '.') {
                        if (f[i][col] == 'v') {
                            f[i][col] = '^';
                            ++changed;
                        } else if (f[i][col] == '<' || f[i][col] == '>') {
                            if (amRow[i] == 1) {
                                f[i][col] = '^';
                                ++changed;
                                was = true;
                            }
                        }
                        break;
                    }
                }
            }
            if (!was) break;
        }

        for (int i = 0; i < n; ++i) {
            if (amRow[i] == 1) {
                for (int j = 0; j < m; ++j) {
                    if (f[i][j] != '.') {
                        if (f[i][j] == '>' || f[i][j] == '<') {
                            ++changed;
                            f[i][j] = 'v';
                            break;
                        }
                    }
                }
            }
        }

        for (int i = 0; i < m; ++i) {
            if (amCol[i] == 1) {
                for (int j = 0; j < n; ++j) {
                    if (f[j][i] != '.') {
                        if (f[j][i] == '^' || f[j][i] == 'v') {
                            ++changed;
                            f[j][i] = '<';
                            break;
                        }
                    }
                }
            }
        }

        if (!check(f)) {
            changed = 1000000000;
        }
        best = changed;
//        if (best != changed) {
//            throw new AssertionError("! " + best + " " + changed + " " + testNumber);
//        }
        if (best >= 1000000000) {
            out.println("Case #" + testNumber + ": IMPOSSIBLE");
        } else {
            out.println("Case #" + testNumber + ": " + best);
        }

    }

    int best = 1000000000;

    boolean check(char[][] f) {
        for (int i = 0; i < n; ++i) {
            for (int j = 0; j < m; ++j) {
                if (f[i][j] != '.') {
                    int dir = getDir(f[i][j]);
                    if (!checkDir(i, j, dir, f)) {
                        return false;
                    }
                }
            }
        }
        return true;
    }

    private boolean checkDir(int i, int j, int dir, char[][] f) {
        i += dx[dir];
        j += dy[dir];
        while (isValid(i, j)) {
            if (f[i][j] != '.') {
                if (getDir(f[i][j]) != dir) {
                    return true;
                }
            }
            i += dx[dir];
            j += dy[dir];
        }
        return false;
    }

    private boolean isValid(int x, int y) {
        return x >= 0 && y >= 0 && x < n && y < m;
    }

    final int[] dx = new int[] {0, -1, 0, 1};
    final int[] dy = new int[] {-1, 0, 1, 0};

    private int getDir(char c) {
        if (c == '<') return 0;
        if (c == '^') return 1;
        if (c == '>') return 2;
        return 3;
    }
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer stt;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
    }

    public String nextLine() {
        try {
            return reader.readLine();
        } catch (IOException e) {
            return null;
        }
    }

    public String nextString() {
        while (stt == null || !stt.hasMoreTokens()) {
            stt = new StringTokenizer(nextLine());
        }
        return stt.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(nextString());
    }

    public String next() {
        return nextString();
    }
}

