package codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.BitSet;

public class pancakeFlips {

	private static Integer minFlipsAux(boolean[] pancakes, boolean[] swapsWorkspace, int lastIndex){
		if(lastIndex == 0){
			if(pancakes[0] == false) return 1;
			else return 0;
		}
		if(lastIndex == 1){
			if(pancakes[0] == false && pancakes[1] == false) return 1;
			else if(pancakes[0] == true && pancakes[1] == true) return 0;
			else if(pancakes[0] == false && pancakes[1] == true) return 1;
			else if(pancakes[0] == true && pancakes[1] == false) return 2;
		}
		boolean allPluses = true;
		for(int i = 0; i <= lastIndex; i++){
			if(pancakes[i] == false){
				allPluses = false;
				break;
			}
		}
		if(allPluses)
			return 0;
		
		int flips = 0;
		
		// if it starts with a plus, find lastPlus after that and flip them to negative
		if(pancakes[0] == true){
		    int firstMin = 0;
		    for(; firstMin <= lastIndex; firstMin++){
		        if(pancakes[firstMin] == false)
		            break; // found the firstMin, break
		        pancakes[firstMin] = false; // flip the pluses to minus
		    }
//		    System.out.println("Flipped +s from 0 until " + (firstMin-1));
		    flips += 1;
		}
		
		
		
		int firstMinus = lastIndex;
		for(; firstMinus > 0; firstMinus--){
			if(pancakes[firstMinus] == false)
				break;
		} // point to flip after 
		
		// reverse from 0 until firstMinus, then negate their values
//		String res = "";
//        for(int i = 0; i < pancakes.length; i++){
//            if(pancakes[i] == false)
//                res += "-";
//            else
//                res += "+";
//        }
        
//		System.out.println("Flipping " + res + " from 0 until " + firstMinus);
		int i = 0;
		int j = firstMinus;
		boolean tmp;
		while(j >= i){
			tmp = pancakes[j];
			pancakes[j] = !pancakes[i];
			pancakes[i] = !tmp;
			j--;
			i++;
    	}
//		res = "";
//		for(i = 0; i < pancakes.length; i++){
//			if(pancakes[i] == false)
//				res += "-";
//			else
//				res += "+";
//		}
//		System.out.println(res);
		int lastMinus = 0;
		for(i = pancakes.length-1; i >= 0; i--){
		    if(pancakes[i] == false) {
		        lastMinus = i;
		        break;
		    }
		}
		
		return flips + 1 + minFlipsAux(pancakes, swapsWorkspace, lastMinus);
		
	}
	
	private static Integer minFlips(String pancakesString){
		boolean[] pancakes = new boolean[pancakesString.length()];
		boolean[] swapsWorkspace = new boolean[pancakesString.length()];
		for(int i = 0; i < pancakesString.length(); i++){
			if(pancakesString.charAt(i) == '+')
				pancakes[i] = true;
			else
				pancakes[i] = false;
		}
		
		return minFlipsAux(pancakes, swapsWorkspace, pancakes.length-1);
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader("/Users/alex/Downloads/B-small-attempt0.in.txt"));
			Integer testCases = Integer.parseInt(br.readLine());
			String line;
			BufferedWriter bw = new BufferedWriter(new FileWriter("/Users/alex/Downloads/outputBsmall.txt"));
			for(int i = 1; i <= testCases; i++){
				line = br.readLine();
				String output = String.format("Case #%s: %s", i, minFlips(line));
				System.out.println(output);
				bw.write(output+"\n");
			}
			br.close();
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
