package com.nus.training;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;

public class Haircut {
	
	public static class Pair {
		public Pair(Long time, Integer barbNum) {
			this.time = time;
			this.barbNum = barbNum;
		}
		@Override
		public String toString() {
			return Long.toString(time) + ":" + barbNum;
		}
		public Long time;
		public Integer barbNum;
	}
	public static void main(String[] args) throws IOException {
		// IO
		BufferedReader br = new BufferedReader(
				new FileReader(new File(args[0])));
		BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(
				new FileOutputStream(new File(args[1]))));

		// Solve
		int testCases = Integer.parseInt(br.readLine());
		for (int i = 0; i < testCases; ++i) {
			String line[] = br.readLine().split("\\s+");
			int numOfBarbars = Integer.parseInt(line[0]);
			long numOfCustomers = Long.parseLong(line[1]);
			
			String[] barbarsSpeeds = br.readLine().split("\\s+");
			long timeToCut[] = new long[numOfBarbars];
			
			double totalRate = 0.0;
			for (int barb = 0; barb < numOfBarbars; ++barb) {
				timeToCut[barb] = Long.parseLong(barbarsSpeeds[barb]);
				totalRate += 1.0 / timeToCut[barb];
			}
			
			double time =(numOfCustomers - 1) / totalRate;
			
			LinkedList<Pair> prevEndTimes = new LinkedList<Pair>();
			long totalEnded = 0;
			for (int barb = 0; barb < numOfBarbars; ++barb) {
				long prevEndTime =  new Double(Math.ceil(time / timeToCut[barb]) * timeToCut[barb]).longValue();
				prevEndTimes.add(new Pair(prevEndTime, barb));
				
				totalEnded += Math.round(prevEndTime * 1.0 / timeToCut[barb]);
			}
			
			Collections.sort(prevEndTimes, new Comparator<Pair>() {
				@Override
				public int compare(Pair o1, Pair o2) {
					if (o1.time.equals(o2.time))
						return o1.barbNum.compareTo(o2.barbNum);
					return o1.time.compareTo(o2.time);
				}
				
			});
			
			for (long remained = totalEnded; remained < (numOfCustomers-1); ++remained) {
				prevEndTimes.removeFirst();
			}
			
			writer.append("Case #" + (i + 1) + ": " + (prevEndTimes.getFirst().barbNum + 1) + "\n");

		}

		writer.close();
		br.close();
	}
}
