package com.company.fashion.show;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by alexpeptan on 09/04/17.
 */
public class FashionShow {
    private class Model{
        char type;
        int row;
        int col;

        Model(char type, int row, int col){
            this.type = type;
            this.row = row;
            this.col = col;
        }
    }

    private List<Model> addedModels = new ArrayList<>();

    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {

        Scanner sc = new Scanner(new File("/Users/alexpeptan/GoogleCodeJam2017/src/com/company/fashion/show/input.txt"));
        PrintWriter writer = new PrintWriter("/Users/alexpeptan/GoogleCodeJam2017/src/com/company/fashion/show/output.txt", "UTF-8");
        int t = sc.nextInt();

        for (int k = 0; k < t; k++) {
            int n = sc.nextInt();
            int m = sc.nextInt();
            char[][] a = new char[n+1][n+1];
            for(int i=1; i<n+1; i++){
                for(int j=1; j<n+1; j++){
                    a[i][j] = '.';
                }
            }

            for(int i=0; i<m; i++){
                char model = sc.next().charAt(0);
                int row = sc.nextInt();
                int col = sc.nextInt();

                a[row][col] = model;
            }

//            for(int i=1; i<n+1; i++){
//                for(int j=1; j<n+1; j++){
//                    System.out.print(a[i][j]);
//                }
//                System.out.println();
//            }
//            System.out.println();

            FashionShow show = new FashionShow();

            int circlePos = -1;
            int xPos = -1;
            for(int i=1; i<=n; i++){
                if(a[1][i] == 'x'){
                    xPos = i;
                    break;
                }
            }
            if(xPos != -1){
                show.addedModels.add(show.new Model('o', 1, xPos));
                a[1][xPos] = 'o';
                circlePos = xPos;
            }

            if(circlePos == -1){
                for(int i=1; i<=n; i++){
                    if(a[1][i] == 'o'){
                        circlePos = i;
                    }
                }
            }

            if(circlePos == -1){// just put it at a[1][1]
                show.addedModels.add(show.new Model('o', 1, 1));
                a[1][1] = 'o';
                circlePos = 1;
            }

            // adding the x models
            for(int j=circlePos + 1; j<=n; j++){
                // diag equation is j-i = circlePos - 1. So i = j - circlePos + 1
                int i = j - circlePos + 1;
                show.addedModels.add(show.new Model('x', i, j));
                a[i][j] = 'x';
            }
            for(int j=1; j<circlePos; j++){
                // diag equation is i + j = n+1. So i = n - j + 1
                int i = n - j + 1;
                show.addedModels.add(show.new Model('x', i, j));
                a[i][j] = 'x';
            }

//            for(int i=1; i<n+1; i++){
//                for(int j=1; j<n+1; j++){
//                    System.out.print(a[i][j]);
//                }
//                System.out.println();
//            }
//            System.out.println();

            for(int j=1; j<=n; j++){
                if(a[1][j] == '.'){
                    show.addedModels.add(show.new Model('+', 1, j));
                    a[1][j] = '+';
                }
                if(j>=2 && j<n && a[n][j] == '.'){
                    show.addedModels.add(show.new Model('+', n, j));
                    a[n][j] = '+';
                }
            }

//            for(int i=1; i<n+1; i++){
//                for(int j=1; j<n+1; j++){
//                    System.out.print(a[i][j]);
//                }
//                System.out.println();
//            }
//            System.out.println();

            //int sum = show.addedModels.stream().mapToInt(model -> model.type == 'o' ? 2 : 1).sum();
            int score = 0;//(int)show.addedModels.stream().count();
            for(int i=1; i<=n; i++){
                for(int j=1; j<=n; j++){
                    if(a[i][j] == 'o'){
                        score += 2;
                    } else {
                        if(a[i][j] != '.'){
                            score++;
                        }
                    }
                }
            }

            writer.println("Case #" + (k + 1) + ": " + score + " " + show.addedModels.size());
            show.addedModels.forEach(model -> writer.println(model.type + " " + model.row + " " + model.col));

            //show.addedModels.add(show.new Model('d', 2, 3));
        }
        writer.close();
    }
}
