package com.company.bathroom.stalls;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * Created by alexpeptan on 08/04/17.
 */
public class BathroomStalls {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {

        Scanner sc = new Scanner(new File("/Users/alexpeptan/GoogleCodeJam2017/src/com/company/bathroom/stalls/input.txt"));
        PrintWriter writer = new PrintWriter("/Users/alexpeptan/GoogleCodeJam2017/src/com/company/bathroom/stalls/output.txt", "UTF-8");
        int t = sc.nextInt();

        for (int q = 0; q < t; q++) {
            long n = sc.nextInt();
            long k = sc.nextInt();

            PriorityQueue<Long> maxHeap = new PriorityQueue<>((x, y) -> x >= y ? -1 : 1);

            maxHeap.add(n);

            for(int i=1; i<=k-1; i++){
                long x = maxHeap.remove();
                x--; // one place is occupied
                long dist1 = x/2;
                long dist2 = x - dist1;
                maxHeap.add(dist1);
                maxHeap.add(dist2);
            }

            // last extraction
            long x = maxHeap.remove();
            x--; // one place is occupied
            long dist1 = x/2;
            long dist2 = x - dist1;

            long max = Math.max(dist1, dist2);
            long min = Math.min(dist1, dist2);

            writer.println("Case #" + (q + 1) + ": " + max + " " + min);
        }
        writer.close();
    }
}
