import java.io.*;
import java.util.*;

/*

1
3 3 4
1 1
2 1
2 2
2 3

*/
public class b {
	static final int STDIO = 0, SMALL = 1, LARGE = 2;
	static int inType = STDIO;
	static int outType = SMALL;

	public static void main(String[] args) throws IOException {
		Scanner in = getScanner();
		PrintWriter out = getPrintWriter();
		int maxT = in.nextInt();
		for (int curT = 1; curT <= maxT; curT++) {
			int n = in.nextInt(), c = in.nextInt(), m = in.nextInt();
			int[][] amts = new int[n][c]; // [p][b]
			for(int i=0;i<m;i++) {
				int p = in.nextInt()-1, b = in.nextInt()-1;
				amts[p][b]++;
			}
			int minRides = 0, minCost = 0;
			int[] unmatched = new int[2];
			for(int seat=0;seat<n;seat++) {
				for(int b=0;b<2;b++) {
					if(amts[seat][b] < unmatched[1-b]) {
						unmatched[1-b] -= amts[seat][b];
						amts[seat][b] = 0;
					} else {
						amts[seat][b] -= unmatched[1-b];
						unmatched[1-b] = 0;
					}
				}
				if(seat != 0) {
					int match = Math.min(amts[seat][0], amts[seat][1]);
					minCost += match;
					minRides += match;
					amts[seat][0] -= match;
					amts[seat][1] -= match;
					unmatched[0] += amts[seat][0];
					unmatched[1] += amts[seat][1];
					minRides += amts[seat][0] + amts[seat][1];
					
				} else {
					unmatched[0] += amts[seat][0];
					unmatched[1] += amts[seat][1];
					minRides += amts[seat][0] + amts[seat][1];
				}
			}
			
			out.printf("Case #%d: ", curT);
			out.println(minRides + " " + minCost);

			//// OUTPUT

			if (inType != STDIO)
				System.out.println(curT + "/" + maxT);
		}

		out.close();
	}

	static class Ticket implements Comparable<Ticket> {
		int p, b;
		boolean used;
		public Ticket(int p, int b) {
			this.p = p;
			this.b = b;
		}

		@Override
		public int compareTo(Ticket o) {
			if(p == o.p)
				return -Integer.compare(b, o.b);
			return -Integer.compare(p, o.p);
		}

	}

	static final String PROBLEM_LETTER = "B";

	static Scanner getScanner() throws IOException {
		if (outType != STDIO)
			inType = outType;
		if (inType == SMALL)
			return new Scanner(new File(PROBLEM_LETTER + "-small-attempt1.in"));
		else if (inType == LARGE)
			return new Scanner(new File(PROBLEM_LETTER + "-large.in"));
		return new Scanner(System.in);
	}

	static PrintWriter getPrintWriter() throws IOException {
		if (outType == SMALL) {
			System.out.println("WRITING TO " + PROBLEM_LETTER + "-SMALL");
			try {
				Thread.sleep(3000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			return new PrintWriter(new File(PROBLEM_LETTER + "-small.out"));
		} else if (outType == LARGE) {
			System.out.println("WRITING TO " + PROBLEM_LETTER + "-LARGE");
			try {
				Thread.sleep(3000);
			} catch (InterruptedException e) {
				e.printStackTrace();
			}
			return new PrintWriter(new File(PROBLEM_LETTER + "-large.out"));
		}
		return new PrintWriter(System.out);
	}
}
