import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;
/*

5
1 0
2 1
o 1 2
3 0
4 0
5 0

1 5 5
+ 1 1
+ 1 2
+ 1 3
+ 1 4
o 1 5

1 1
+ 1 1



1 5 1
o 1 5


1
5 6
+ 1 1
x 1 2
+ 1 3
+ 1 4
+ 1 5
o 2 1
answer: 13

1
5 2
x 3 2
+ 2 3
answer: 12



1
8 3
o 1 1
o 2 3
o 3 5

5
100 10 100 5 100 1 100 2 100 2

*/

public class dlarge {
	static int n;
	static char[] cs = { '.', '+', 'x', 'o' };
	static int[] rev;
	static int[][] grid, ogrid;

	public static void main(String[] args) throws FileNotFoundException {
		rev = new int[256];
		rev['.'] = 0;
		rev['+'] = 1;
		rev['x'] = 2;
		rev['o'] = 3;

		Scanner in = new Scanner(System.in);
		PrintWriter out = new PrintWriter(System.out);
		 in = new Scanner(new FileInputStream("d_large.in"));
		 out = new PrintWriter(new FileOutputStream("d_large.out"));
		int T = in.nextInt();
		for (int t = 1; t <= T; t++) {
			n = in.nextInt();
			int m = in.nextInt();
			grid = new int[n][n];
			ogrid = new int[n][n];
			{
				grid[0][0] = 3;
				for (int j = 1; j < n; j++)
					grid[0][j] = 1;
				int i = 1, j = 1;
				while (i < n) {
					grid[i][j] = 2;
					i++;
					j++;
				}
				for (j = 1; j < n; j++) {
					if (grid[n - 1][j] == 0)
						grid[n - 1][j] = 1;
				}
			}
			for (int i = 0; i < m; i++) {
				char c = in.next().charAt(0);
				int v = rev[c];
				int a = in.nextInt() - 1, b = in.nextInt() - 1;
				ogrid[a][b] = v;
				add(a, b, v);
			}

			int score = 0;
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++)
					score += Integer.bitCount(grid[i][j]);
			ArrayList<String> ans = new ArrayList<>();
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					if (grid[i][j] != ogrid[i][j]) {
						ans.add(cs[grid[i][j]] + " " + (i + 1) + " " + (j + 1));
					}
				}
			}
			verify();
			out.printf("Case #%d: %d %d\n", t, score, ans.size());
			for (String s : ans)
				out.println(s);
		}

		out.close();
	}

	static void verify() {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				if ((grid[i][j] | ogrid[i][j]) != grid[i][j]) {
					System.out.println(1 / 0);
				}
			}
		}
		int sum;
		
		for (int i = 0; i < n; i++) {
			sum = 0;
			for (int j = 0; j < n; j++) {
				if ((grid[i][j] & 2) != 0) {
					sum++;
				}
			}
			if (sum > 1)
				System.out.println(1 / 0);
		}
		for (int i = 0; i < n; i++) {
			sum = 0;
			for (int j = 0; j < n; j++) {
				if ((grid[i][j] & 2) != 0) {
					sum++;
				}
			}
			if (sum > 1)
				System.out.println(1 / 0);
		}
		for (int ab = 0; ab < 2 * n - 1; ab++) {
			sum = 0;
			for (int i = 0; i < n; i++) {
				int j = ab - i;
				if (j < 0 || j >= n)
					continue;
				if ((grid[i][j] & 1) != 0) {
					sum++;
				}
			}
			if (sum > 1)
				System.out.println(1 / 0);
		}
		for (int ba = n - 1; ba >= -(n - 1); ba--) {
			sum = 0;
			for (int i = 0; i < n; i++) {
				int j = ba + i;
				if (j < 0 || j >= n)
					continue;
				if ((grid[i][j] & 1) != 0) {
					sum++;
				}
			}
			if (sum > 1)
				System.out.println(1 / 0);
		}
	}

	static void add(int a, int b, int v) {
		int ov = grid[a][b];
		ArrayDeque<Relocation> q = new ArrayDeque<>();
		if ((ov & 1) != 0 && (v & 1) == 0) {
			// System.out.println("Lost " + 1 + " bit");
			q.offer(new Relocation(a, b, 1));
		}
		if ((ov & 2) != 0 && (v & 2) == 0) {
			// System.out.println("Lost " + 2 + " bit");
			q.offer(new Relocation(a, b, 2));
		}

		if ((ov & 1) == 0 && (v & 1) != 0) {
			// System.out.println("Gained " + 1 + " bit");
			// two diagonal dudes
			for (int i = 0; i < n; i++) {
				int j = a + b - i;
				if (j < 0 || j >= n)
					continue;
				if ((grid[i][j] & 1) != 0) {
					grid[i][j] ^= 1;
					q.offer(new Relocation(i, j, 1));
				}
			}
			for (int i = 0; i < n; i++) {
				int j = b - a + i;
				if (j < 0 || j >= n)
					continue;
				if ((grid[i][j] & 1) != 0) {
					grid[i][j] ^= 1;
					q.offer(new Relocation(i, j, 1));
				}
			}
		}
		if ((ov & 2) == 0 && (v & 2) != 0) {
			// System.out.println("Gained " + 2 + " bit");
			// two column/row dudes
			for (int i = 0; i < n; i++) {
				if ((grid[i][b] & 2) != 0) {
					grid[i][b] ^= 2;
					q.offer(new Relocation(i, b, 2));
				}
			}
			for (int j = 0; j < n; j++) {
				if ((grid[a][j] & 2) != 0) {
					grid[a][j] ^= 2;
					q.offer(new Relocation(a, j, 2));
				}
			}
		}
		// System.out.println(q);
		grid[a][b] = v;
		// print(grid);
		while (!q.isEmpty()) {
			Relocation r = q.poll();
			// System.out.println("Relocate " + r.a + " " + r.b + " " +r.v);
			if (r.v == 2) {
				boolean found = false;
				for (int i = 0; i < n && !found; i++) {
					int j = r.b;
					if ((grid[i][j] & 2) == 0 && isValid(i, j, 2)) {
						grid[i][j] ^= 2;
						found = true;
					}
				}
				for (int j = 0; j < n && !found; j++) {
					int i = r.a;
					if ((grid[i][j] & 2) == 0 && isValid(i, j, 2)) {
						grid[i][j] ^= 2;
						found = true;
					}
				}
			} else {
				boolean found = false;
				for (int i = 0; i < n && !found; i++) {
					int j = r.a + r.b - i;
					if (j < 0 || j >= n)
						continue;
					if ((grid[i][j] & 1) == 0 && isValid(i, j, 1)) {
						grid[i][j] ^= 1;
						found = true;
					}
				}
				for (int i = 0; i < n && !found; i++) {
					int j = r.b - r.a + i;
					if (j < 0 || j >= n)
						continue;
					if ((grid[i][j] & 1) == 0 && isValid(i, j, 1)) {
						grid[i][j] ^= 1;
						found = true;
					}
				}
			}
			// relocate
		}

	}

	static boolean isValid(int a, int b, int bit) {
		int or = 0;
		if (bit == 2) {
			for (int i = 0; i < n; i++) {
				or |= grid[i][b];
			}
			for (int j = 0; j < n; j++) {
				or |= grid[a][j];
			}
		} else {
			for (int i = 0; i < n; i++) {
				int j = a + b - i;
				if (j < 0 || j >= n)
					continue;
				or |= grid[i][j];
			}
			for (int i = 0; i < n; i++) {
				int j = b - a + i;
				if (j < 0 || j >= n)
					continue;
				or |= grid[i][j];
			}
		}
		return (or & bit) == 0;
	}

	static class Relocation {
		int a, b, v;

		public Relocation(int a, int b, int v) {
			this.a = a;
			this.b = b;
			this.v = v;
		}

		@Override
		public String toString() {
			return "{r=" + a + ",c=" + b + ",v=" + v + "}";
		}
	}

	static void print(int[][] grid) {
		for (int i = 0; i < grid.length; i++) {
			for (int j = 0; j < grid[i].length; j++) {
				System.out.print(cs[grid[i][j]]);
			}
			System.out.println();
		}
	}

}
