import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class Solve {
	public static BufferedWriter out;
	public static String baseDir = "d:\\codejam\\";
	public static String newline = System.getProperty("line.separator");
	private static ArrayList<Character> resultList = new ArrayList<Character>();
	private static Map<Character, Set<Character>> oppositionMap;
	private static Map<Character, Map<Character, Character>> combinationsMap;

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		solve("B-small-attempt1.in");
		//solve("sample4.dat");

	}
	
	private static void solve(String inputFile) throws IOException {
		File f = new File(baseDir + inputFile);
		Scanner scanner = new Scanner(f);
		int nrOfCases = scanner.nextInt();
		beginReporting();
		for (int caseCounter = 0; caseCounter < nrOfCases; caseCounter++) {
			startSolve();

			int nrOfCombines = scanner.nextInt();
			for (int i = 0; i < nrOfCombines; i++) {
				addToCombinationList(scanner.next());
			}

			int nrOfOpposed = scanner.nextInt();
			for (int i = 0; i < nrOfOpposed; i++) {
				addToOppositionList(scanner.next());
			}

			int nrOfCharactersInput = scanner.nextInt();
			String content = scanner.next();
			resolve(nrOfCharactersInput, content);

			report(caseCounter + 1);
			endSolve();
		}
		endReporting();

		scanner.close();
	}

	private static void resolve(int nrOfCharactersInput, String content) {
		for (int i = 0; i < content.length(); i++) {
			char ch = content.charAt(i);
			resultList.add(ch);
			boolean goOn = true;
			int counter =0;
			while (goOn == true && resultList.size() > 0) {
				counter++;
				int checkResult = check();
				if (checkResult == -1) {
					clearList();
					break;
				}
				int reduceResult = reduce();
				if (reduceResult == 1) {
					
				} else {
					break;
				}
			}
			if(counter >=2) {
//				System.out.println("Interesant");
			}

		}

	}

	private static int check() {
		char lastCh = resultList.get(resultList.size() - 1);
		for (int i = resultList.size()-2; i>=0; i--) {
			char workingChar = resultList.get(i);
			if (opposed(lastCh, workingChar) || opposed(workingChar,lastCh)) 
			{
				if(i == (resultList.size()-2) && (areCombined(lastCh, workingChar)||(areCombined(workingChar,lastCh)))) return 1;
				return -1;
			}

		}
		return 1;
	}

	private static boolean opposed(char firstChar, char correspondentChar) {
		Set<Character> set = oppositionMap.get(firstChar);
		if (set == null)
			return false;
		return set.contains(correspondentChar);
	}

	private static int reduce() {
		char lastCh = resultList.get(resultList.size() - 1);
		if (resultList.size() - 2 >= 0) {
			char previousChar = resultList.get(resultList.size() - 2);
			if (areCombined(lastCh, previousChar) || areCombined(previousChar, lastCh)) {
				char replacingChar = combinationsMap.get(lastCh).get(
						previousChar);
				resultList.remove(resultList.size() - 1);
				resultList.remove(resultList.size() - 1);
				resultList.add(replacingChar);
				return 1;
			} else {
				return -1;
			}
		} else {
			// -1 means: we cannot reduce anymore;
			return -1;
		}

	}

	private static boolean areCombined(char lastCh, char previousChar) {
		Map<Character, Character> mapping = combinationsMap.get(lastCh);
		if (mapping == null)
			return false;
		if (mapping.containsKey(previousChar) == false)
			return false;
		return true;
	}

	private static void clearList() {
		resultList.clear();
	}

	private static void addToOppositionList(String oppositionPair) {
		char c = oppositionPair.charAt(0);
		char p = oppositionPair.charAt(1);
		//does this problem contains a trick?
		//if(c == p) return;
		if(oppositionMap.containsKey(c) == false) {
			oppositionMap.put(c, new HashSet<Character>());
		}
		
		if(oppositionMap.containsKey(p) == false) {
			oppositionMap.put(p, new HashSet<Character>());
		}
		
		oppositionMap.get(c).add(p);
		oppositionMap.get(p).add(c);


	}

	private static void addToCombinationList(String combinationTuple) {
		char c = combinationTuple.charAt(0);
		char p = combinationTuple.charAt(1);
		char r = combinationTuple.charAt(2);
		
		if(combinationsMap.containsKey(c) == false) {
			combinationsMap.put(c, new HashMap<Character, Character>());
		}
		
		if(combinationsMap.containsKey(p) == false) {
			combinationsMap.put(p, new HashMap<Character, Character>());
		}
		combinationsMap.get(c).put(p, r);
		combinationsMap.get(p).put(c, r);
	}

	private static void endSolve() {
		resultList = new ArrayList<Character>();
		oppositionMap = new HashMap<Character, Set<Character>>();
		combinationsMap = new HashMap<Character, Map<Character, Character>>();
	}

	private static void startSolve() {
		resultList = new ArrayList<Character>();
		oppositionMap = new HashMap<Character, Set<Character>>();
		combinationsMap = new HashMap<Character, Map<Character, Character>>();
	}

	private static void report(int caseNumber) throws IOException {
		out.write("Case #" + caseNumber + ": ");
		System.out.print("Case #" + caseNumber + ": ");
		out.write("[");
		System.out.print("[");
		for(int i=0;i<resultList.size();i++) {
			out.write(resultList.get(i));
			System.out.print(resultList.get(i));
			if(i != resultList.size()-1) {
				out.write(", ");
				System.out.print(", ");
			}
		}
		out.write("]");
		System.out.print("]");
		out.write(newline);
		System.out.print(newline);
	}

	private static void endReporting() throws IOException {
		out.close();

	}

	private static void beginReporting() throws IOException {
		out = new BufferedWriter(new FileWriter(baseDir + "outResult.txt"));
	}

}
