import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class CookieSolver {

    /**
     * @param args
     */
    public static void main(String[] args) throws Exception {
	BufferedReader br = new BufferedReader(new FileReader(new File("/Users/alexs/workspace_jam/CookieClickerAlpha/src/B-small-attempt0.in")));
	BufferedWriter bw = new BufferedWriter(new FileWriter(new File("/Users/alexs/workspace_jam/CookieClickerAlpha/src/outputSmallSolution.dat")));
	Integer nrOfTestCases = Integer.valueOf(br.readLine());
	for (int i = 0; i < nrOfTestCases; i++) {
	    String[] tokens = br.readLine().split(" ");
	    Double c = Double.valueOf(tokens[0].trim());
	    Double f = Double.valueOf(tokens[1].trim());
	    Double x = Double.valueOf(tokens[2].trim());
	    //System.out.println("Test case " + (i + 1) + "  c:" + c.toString() + "  f:" + f.toString() + " x:" + x.toString());
	    Double res = solve(c, f, x);
	    System.out.println("Case #" + (i + 1) + ": " + res);
	    bw.write("Case #" + (i + 1) + ": " + res.toString()+"\n");
	}

	br.close();
	bw.close();

    }

    public static Double solve(Double priceForFarm, Double upperRate, Double target) {
	Double currentFrameRate = 2d;
	Double totalTime = 0d;
	while (true) {
	    double timeToFinishAtCurrentFrameRate = target / currentFrameRate;
	    double timeTillBuyAFarm = (priceForFarm / currentFrameRate);
	    double timeWithHigherRate = (target / (upperRate + currentFrameRate));
	    double alternativeTimeToFinish = timeTillBuyAFarm + timeWithHigherRate;
	    
	    if (timeToFinishAtCurrentFrameRate > alternativeTimeToFinish) {
		currentFrameRate = currentFrameRate + upperRate;
		totalTime = totalTime + timeTillBuyAFarm;
	    } else {
		totalTime = totalTime + timeToFinishAtCurrentFrameRate;
		break;
	    }
	}
	return totalTime;
    }

}
