package codejam;

import java.io.RandomAccessFile;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class TrainCars {
	
	int N;
	//String[] w;
	ArrayList<String> w;
	       
	public TrainCars(RandomAccessFile rafin) throws Exception{
		String inputline;
		StringTokenizer st;
		
		inputline = rafin.readLine();
		st = new StringTokenizer(inputline," ");
		N = Integer.parseInt(st.nextToken());
		//w = new String[N];

		inputline = rafin.readLine();
		st = new StringTokenizer(inputline," ");
		w = new ArrayList<String>(N);
		for (int i=0; i<N; i++) {
			w.add(st.nextToken());
		}
		
	}
	
	public BigInteger factorial(int n) {
		BigInteger ans = new BigInteger("1");
		for (int i=2; i<=n; i++)
			ans = ans.multiply(new BigInteger(""+i));
		return ans;
	}
	
	public TrainCars() {
		// TODO Auto-generated constructor stub
	}

	public String getStatus() throws Exception{
		BigInteger ans = new BigInteger("1");
		
		for (char ch='a'; ch<='z'; ch++) {
			System.out.print("\r\n ch=" + ch);
			ArrayList<String> ss = new ArrayList<String>();
			int size = w.size();
			for (int i=size-1; i>=0; i--) {
				if (w.get(i).indexOf(ch)>=0) {
					ss.add(w.remove(i));
				}
			}
			if (ss.size()==0)
				continue;
			
			int chead=0;
			int cend=0;
			int call=0;
			String shead=null;
			String send = null;
			for (int i=0; i<ss.size(); i++) {
				String s = ss.get(i);
				System.out.print(" s=" + s);
				boolean isall = true;
				int lastid=-1;
				for (int j=0; j<s.length(); j++) {
					if (s.charAt(j) == ch) {
						if (lastid>=0 && j-lastid!=1)
							return "0";
						lastid = j;
					} else {
						isall=false;
					}
				}
				if (s.charAt(0)!=ch && s.charAt(s.length()-1)!=ch && ss.size()>1)
					return "0";
				if (s.charAt(0)!=ch) {
					chead++;
					//chhead = s.charAt(0);
					shead = s;
				}
				if (s.charAt(s.length()-1)!=ch) {
					cend++;
					//chend = s.charAt(s.length()-1);
					send = s;
				}
				if (isall)
					call++;
			}
			if (chead>1 || cend>1)
				return "0";
			ans = ans.multiply(factorial(call));
			
			//chhead = (chead==0? ch: chhead);
			//chend = (cend==0? ch: chend);
			//String s_new = ""+chhead+ch+chend;
			shead = shead==null? ""+ch: shead.substring(0, shead.indexOf(ch));
			send = send==null? ""+ch: send.substring(send.indexOf(ch));
			String s_new = shead+send;
			w.add(s_new);
		}
		
		ans = ans.multiply(factorial(w.size()));
		
		String s = ans.toString();
		StringBuffer sb = new StringBuffer("");
		int len = s.length();
		for (int i=0; i<s.length(); i++) {
			sb.append(s.charAt(i));
			if (len-i>3 && (len-i)%3==1)
				sb.append(",");
		}
		return s;
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {

			/*
			long oldtime = System.currentTimeMillis();
			readDictionary("d:/codejam/data/dict.txt");
			System.out.println(maxLen);
			long newtime = System.currentTimeMillis();
			System.out.println((newtime-oldtime)/1000 + " seconds.");
			if (true) return;
			*/
			
			String file_prefix = "B-large";

			String path="d:/codejam/data/";
			String infilename = path + file_prefix+".in";
			String outfilename = path + file_prefix+".out";
			RandomAccessFile rafin = new RandomAccessFile(infilename, "r");
			RandomAccessFile rafout = new RandomAccessFile(outfilename, "rw");
			rafout.setLength(0);
			
			int count = Integer.parseInt(rafin.readLine().trim());
			TrainCars o;
			System.out.println(count + " cases.");
			for (int i=1; i<=count; i++) {
				o = new TrainCars(rafin);
				rafout.writeBytes("Case #" + i + ": " + o.getStatus());
				if (i<count)
					rafout.writeBytes("\r\n");
				System.out.println("Case " + i + " dealed!\r\n");
				System.gc();
			}
			
			rafin.close();
			rafout.close();
		} catch (Exception e) {
			e.printStackTrace(System.out);
		}

	}


}
