package codejam;

import java.io.RandomAccessFile;
import java.util.StringTokenizer;

public class Repeater {
	int N;
	String[] ss;
	
	int[][] is;
	
	public Repeater(RandomAccessFile rafin) throws Exception{
		String inputline;
		StringTokenizer st;
		
		inputline = rafin.readLine();
		st = new StringTokenizer(inputline," ");
		N = Integer.parseInt(st.nextToken());
		
		ss = new String[N];
		is = new int[N][101];
		
		for (int i=0; i<N; i++) {
			ss[i] = rafin.readLine().trim();
		}
		//radius = Long.parseLong(st.nextToken());
	}
	
	public Repeater() {
		// TODO Auto-generated constructor stub
	}
	
	public String transfer(String s, int index) {
		char ch;
		char ch_p='0';
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<s.length(); i++) {
			ch = s.charAt(i);
			if (i==0 || ch!=ch_p) {
				sb.append(ch);
				is[index][sb.length()-1] = 1;
				ch_p = ch;
			} else {
				is[index][sb.length()-1] ++;
			}
		}
		return sb.toString();
	}
	
	public int dis(int id1, int id2, String s1, String s2) {
		if (id1>=s1.length() && id2>=s2.length()) {
			return 0;
		}
		if (id1>=s1.length()) {
			if (s2.charAt(id2) == s2.charAt(id2-1)) {
				int x = dis(id1, id2+1, s1, s2);
				return x>=0? 1+x: x; 
			} else
				return -1;
		}
		if (id2>=s2.length()) {
			if (s1.charAt(id1) == s1.charAt(id1-1)) {
				int x = dis(id1+1, id2, s1, s2);
				return x>=0? 1+x: x; 
			} else
				return -1;
		}
		char c1 = s1.charAt(id1);
		char c2 = s2.charAt(id2);
		if (c1==c2) {
			return dis(id1+1, id2+1, s1, s2);
		} else {
			if (id2>0 && c1 == s2.charAt(id2-1)) {
				int x = dis(id1+1, id2, s1, s2);
				return x>=0? 1+x: x; 
			}
			else if (id1>0 && c2 == s1.charAt(id1-1)) {
				int x = dis(id1, id2+1, s1, s2);
				return x>=0? 1+x: x; 
			} else
				return -1;
		}
	}

	public String getStatus() throws Exception{
		String seed=null;
		for (int i=0; i<N; i++) {
			String s = transfer(ss[i], i);
			if (seed!=null && seed.equals(s)==false) {
				return "Fegla Won";
			} else if (seed==null)
				seed = s;
		}
		
		int steps=0;
		for (int i=0; i<seed.length(); i++) {
			int min = Integer.MAX_VALUE;
			for (int j=1; j<100; j++) {
				int sum=0;
				for (int k=0; k<N; k++) {
					sum += Math.abs(j-is[k][i]);
				}
				min = Math.min(min, sum);
			}
			steps += min;
		}
		
		return ""+steps;
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		try {

			/*
			long oldtime = System.currentTimeMillis();
			readDictionary("d:/codejam/data/dict.txt");
			System.out.println(maxLen);
			long newtime = System.currentTimeMillis();
			System.out.println((newtime-oldtime)/1000 + " seconds.");
			if (true) return;
			*/
			
			String file_prefix = "A-large";

			String path="d:/codejam/data/";
			String infilename = path + file_prefix+".in";
			String outfilename = path + file_prefix+".out";
			RandomAccessFile rafin = new RandomAccessFile(infilename, "r");
			RandomAccessFile rafout = new RandomAccessFile(outfilename, "rw");
			rafout.setLength(0);
			
			int count = Integer.parseInt(rafin.readLine().trim());
			Repeater o;
			System.out.println(count + " cases.");
			for (int i=1; i<=count; i++) {
				o = new Repeater(rafin);
				rafout.writeBytes("Case #" + i + ": " + o.getStatus());
				if (i<count)
					rafout.writeBytes("\r\n");
				System.out.println("Case " + i + " dealed!\r\n");
				System.gc();
			}
			
			rafin.close();
			rafout.close();
		} catch (Exception e) {
			e.printStackTrace(System.out);
		}

	}


}
