import java.util.*;

public class ProblemA {
    static boolean DEBUG = false;
    static String[] nums = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};

    static String matchNum(int num, String s) throws NumberFormatException {
	if(DEBUG) System.err.println("matching " + num + " against " + s);
	if(num>9 || num<0) throw new NumberFormatException(Integer.toString(num) + " is not a digit.");
	String ret = new String(s);
	String buf = new String(s);
	int currInd = 0;
	for(int index = 0; index < nums[num].length(); index++) {
	    boolean found = false;
	    for(int i = 0; i < buf.length(); i++) {
		if(buf.charAt((i+currInd)%(buf.length())) == nums[num].charAt(index)) {
		    if(DEBUG) System.err.println("found " + nums[num].charAt(index) + " at index " + ((i+currInd)%(buf.length())));
		    if(DEBUG) System.err.print("buf: " + buf + " -> ");
		    buf = buf.substring(0, (i+currInd)%(buf.length())) + buf.substring(((i+currInd)%(buf.length()))+1);
		    if(DEBUG) System.err.println(buf);
		    if(buf.length() > 0) currInd = (i+1)%(buf.length());
		    found = true;
		}
		if(found) break;
	    }
	    if(!found) {
		if(DEBUG) System.err.println("Couldn\'t find " + nums[num].charAt(index) + ". Returning " + s);
		return s;
	    }
	    ret = buf;
	}
	if(DEBUG) System.err.println("returning " + ret);
	return ret;
    }

    static String matchRecursive(String s, int start) throws NumberFormatException {
	if(start < 0) start=0;
	if(s.equals("")) return s;
	if(start > 9) return "X"; //check if we've reached the end without an empty string
	String s1 = matchNum(start, s);
	while(s1.equals(s)) {
	    start++;
	    if(start > 9) return "X";
	    s1 = matchNum(start, s);
	}
	//Now we have a decision to make. To include start or not include start?
	//check if including works
	String ret1 = Integer.toString(start) + matchRecursive(s1, start);
	//if it worked, great!
	if(ret1.charAt(ret1.length()-1) != 'X') return ret1;
	//otherwise, don't include it and go to the next one
	else {
	    ret1 = matchRecursive(s, start+1);
	    if(ret1.charAt(ret1.length()-1) == 'X') {
		//throw new NumberFormatException("Oops. Didn\'t get through the entire string.");
	    }
	    return ret1;
	}
    }

    static String match(String s) throws NumberFormatException {
	String buf = new String(s);
	String ret = "";
	for(int i = 0; i < nums.length && buf.length() > 0; i++) {
	    String rem = matchNum(i, buf);
	    while(!(rem.equals(buf))) {
		ret += Integer.toString(i);
		buf = rem;
		rem = matchNum(i, buf);
	    }
	}
	if(buf.length() > 0) {
	    if(DEBUG) System.err.println("Oops. Going recursive");
	    ret = matchRecursive(s, 0);
	    if(ret.charAt(ret.length()-1) == 'X') throw new NumberFormatException("\"" + s + "\" did not match properly.");
	}
	return ret;
    }

    public static void main(String[] args) {
	Scanner s = new Scanner(System.in);
	int T = s.nextInt();
	s.nextLine();
	for(int i = 1; i <= T; i++) {
	    String line = s.nextLine();
	    System.out.printf("Case #%d: %s\n", i, match(line));
	}
    }
}