import java.util.*;

public class ProblemB {
    public static char opposite(char c) {
	if(c == '+') return '-';
	if(c == '-') return '+';
	return '0';
    }

    public static void swap(char[] pancakes, int a, int b) {
	if(a < 0 || a >= pancakes.length || b < 0 || b >= pancakes.length) return;
	char temp = pancakes[a];
	pancakes[a] = pancakes[b];
	pancakes[b] = temp;
    }

    public static void flip(char[] pancakes, int max) {
	char[] newArr = new char[max];
	for(int i = 0; i < max; i++) {
	    newArr[i] = opposite(pancakes[max-1-i]);
	}
	for(int i = 0; i < max; i++) {
	    pancakes[i] = newArr[i];
	}
    }

    public static void flip_bad(char[] pancakes, int max) {
	if(max > pancakes.length) max = pancakes.length;
	for(int i = 0; i < max/2; i++) {
	    if(pancakes[i] == pancakes[max-1-i]) {
		pancakes[i] = opposite(pancakes[i]);
		pancakes[max-1-i] = opposite(pancakes[max-1-i]);
	    }
	}
    }

    public static int numFlips(char[] pancakes) {
	int ret = 0;
	boolean done = false;
	while(!done) {
	    boolean happySideUp = pancakes[0] == '+';
	    if(happySideUp) {
		int i = 1;
		for(i = 1; i < pancakes.length && pancakes[i] == '+'; i++) {
		    //do nothing
		}
		if(i == pancakes.length) {
		    done = true;
		}
		else {
		    flip(pancakes, i);
		    ret++;
		}
	    }
	    else {
		int i = 1;
		for(i = 1; i < pancakes.length && pancakes[i] == '-'; i++) {
		    //do nothing
		}
		if(i == pancakes.length) {
		    flip(pancakes, i);
		    ret++;
		    done = true;
		}
		else {
		    flip(pancakes, i);
		    ret++;
		}
	    }
	}
	return ret;
    }

    public static void main(String[] args) {
	Scanner s = new Scanner(System.in);
	int T = s.nextInt();
	s.nextLine();
	for(int i = 1; i <= T; i++) {
	    System.out.printf("Case #%d: %d\n", i, numFlips(s.nextLine().toCharArray()));
	}
    }
}