import java.util.*;

public class ProblemC {
    public static long divisor(long num) {
	long sqrt = (long)Math.floor(Math.sqrt(num)+1);
	for(long i = 2; i < sqrt; i++) {
	    if(num%i == 0) {
		//System.out.println(num + "/" + i + " is " + num/i);
		return i;
	    }
	}
	return 1;
    }

    public static boolean isJamCoin(String str) {
	if(str.charAt(0) != '1') return false;
	if(str.charAt(str.length()-1) != '1') return false;
	for(int i = 2; i <= 10; i++) {
	    long x = Long.parseLong(str, i);
	    //System.out.printf("%s in base %d is %d\n", str, i, x);
	    long div = divisor(Long.parseLong(str, i));
	    if(div == 1) return false;
	}
	return true;
    }

    public static String proveJam(String str) {
	if(str.charAt(str.length()-1) != '1') {
	    return null;
	}
	String ret = new String(str);
	for(int i = 2; i <= 10; i++) {
	    long x = Long.parseLong(str, i);
	    //System.out.printf("%s in base %d is %d\n", str, i, x);
	    long div = divisor(x);
	    if(div == 1) return null;
	    ret += " " + Long.toString(div);
	}
	return ret;
    }

    //J is the number of jamcoins, N is the length
    public static String[] makeJamCoins(int N, int J) {
	String[] ret = new String[J];
	long max = (long)Math.pow(2, N);
	long k = (1 << (N-1)) + 1;
	//int l = Long.parseLong(Long.toString(k), 2);
	for(int i = 0; i < J; i++) {
	    ret[i] = "";
	    //System.out.println("k is " + k);
	    for(/*k++*/; k < max; k++) {
		String str = proveJam(Long.toBinaryString(k));
		//System.out.println(str);
		if(str != null) {
		    ret[i] = str;
		    break;
		}
	    }
	    if(k == max && i+1 != J) {
		return null;
	    }
	    k++;
	}
	return ret;
    }

    public static void main(String[] args) {
	Scanner s = new Scanner(System.in);
	int T = s.nextInt();
	s.nextLine();
	for(int i = 1; i <= T && s.hasNextLine(); i++) {
	    int N = s.nextInt();
	    int J = s.nextInt();
	    //System.out.println("makeJamCoins(" + N + ", " + J+ "):");
	    String[] stuff = makeJamCoins(N, J);
	    System.out.printf("Case #%d:\n", i);
	    for(int j = 0; j < stuff.length; j++) {
		System.out.println(stuff[j]);
	    }
	    //s.nextLine();
	}
    }
}