import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "A-small";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	
	static class Way implements Comparable <Way> {
		int low;
		int high;
		int speed;
		int dist;
		
		Way(Scanner in) {
			this.low = in.nextInt();
			this.high = in.nextInt();
			this.speed = in.nextInt();
			this.dist = high - low;
		}
		
		public int compareTo(Way second) {
			return this.speed - second.speed;
		}
		
		double time(int speedWalk) {
			return (high - low) / (speedWalk + 0.0 + speed);
		}
	}
	
	void solveOne() {
		double length = in.nextInt();
		double wSpeed = in.nextInt();
		double rSpeed = in.nextInt();
		
		double timeToRun = in.nextInt();
		int nWays = in.nextInt();
		Way []w = new Way[nWays];
		double remLen = length;
		for (int i = 0; i < w.length; i++) {
			w[i] = new Way(in);
			remLen -= w[i].high - w[i].low;
		}
		Arrays.sort(w);
		double remTime = timeToRun;
		double allTime = 0;
		
		{
			double dist = remTime * rSpeed;
			if (dist > remLen) {
				allTime += remLen / rSpeed;
				remTime -= remLen / rSpeed;
			} else {
				double remRem = remLen - dist;
				allTime += remTime + remRem / wSpeed;
				remTime = 0;
			}
		}
		
		for (int i = 0; i < w.length; i++) {
			
			double dist = remTime * (rSpeed + w[i].speed + 0.0);
			if (dist > w[i].dist) {
				allTime += w[i].dist / (rSpeed + w[i].speed + 0.0);
				remTime -= w[i].dist / (rSpeed + w[i].speed + 0.0);
			} else {
				double remRem = w[i].dist - dist;
				allTime += remTime + remRem / (wSpeed + w[i].speed + 0.0);
				remTime = 0;
			}
			
			
		}
		out.printf(Locale.US, "%.8f", allTime);
		out.println();
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 0; i < nTests; i++) {
			out.print("Case #"+(i+1)+": ");
			solveOne();
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:\\round2\\" + problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\round2\\" + problem + ".out3"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}