import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "B-small";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	static class Dist implements Comparable <Dist> {
		int prevValue;
		int currValue;
		
		Dist(int prevValue, int currValue) {
			this.prevValue = prevValue;
			this.currValue = currValue;
		}
		
		int win() {
			return prevValue - currValue;
		}
		
		public int compareTo(Dist second) {
			return second.win() - this.win(); 
		}
	}
	
	void solveOne() {
		int boostCount = in.nextInt();
		long timeToBuild = in.nextLong();
		int lastStarIdx = in.nextInt() - 1;
		int cycle = in.nextInt();
		
		int dist[] = new int[cycle];
		for (int i = 0; i < dist.length; i++) {
			dist[i] = in.nextInt();
		}
		
		int allDist[] = new int[lastStarIdx + 1];
		for (int i = 0; i < allDist.length; i++) {
			allDist[i] = dist[i % cycle];
		}
		
		int firstGoodIdx = lastStarIdx + 1;
		int sum = 0;
		for (int i = 0; i < allDist.length; i++) {
			if (sum * 2 + allDist[i] * 2 > timeToBuild) {
				firstGoodIdx = i;
				break;
			}
			sum = sum + allDist[i];
		}
		int timeBefore = sum * 2;
		if (firstGoodIdx == lastStarIdx + 1) {
			out.println(sum * 2);
			return;
		}
		Dist winTimes[] = new Dist[lastStarIdx + 1 - firstGoodIdx];
		
		
		for (int i = firstGoodIdx; i < allDist.length; i++) {
			if (i == firstGoodIdx) {
				int timeNext = (sum + allDist[i]) * 2;
				
				int way = ((int)timeToBuild - sum * 2) / 2;
				int boosted = way * 2 + (timeNext - (int)timeToBuild) / 2;
				
				winTimes[i-firstGoodIdx] = new Dist(allDist[i] * 2, boosted);
			} else {
				winTimes[i-firstGoodIdx] = new Dist(allDist[i] * 2, allDist[i]);
			}
			sum += allDist[i];
		}
		Arrays.sort(winTimes);
		int time = 0;
		for (int i = 0; i < winTimes.length; i++) {
			if (i < boostCount) {
				time += winTimes[i].currValue;
			} else {
				time += winTimes[i].prevValue;
			}
		}
		out.println(time + timeBefore);
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 0; i < nTests; i++) {
			out.print("Case #"+(i+1)+": ");
			solveOne();
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:\\roundC\\" + problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\roundC\\" + problem + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}