import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.Queue;
import java.util.Scanner;

public class B {

	private static final String path = "/home/tolstov.a.a/codejam/b/";

	private static final String problem = "B-small74";

	Scanner in;

	PrintWriter out;

	Map<String, Integer> nMoves = new HashMap<String, Integer>();

	static class Pair implements Comparable<Pair> {

		int val;

		int idx;

		Pair(int val, int idx) {
			this.val = val;
			this.idx = idx;
		}

		@Override
		public int compareTo(Pair o) {
			return this.val - o.val;
		}
	}

	boolean isGood(String s) {
		boolean less = true;
		for (int i = 0; i < s.length() - 1; i++) {
			if (less) {
				if (s.charAt(i) > s.charAt(i + 1)) {
					less = false;
				}
			} else {
				if (s.charAt(i) < s.charAt(i + 1)) {
					return false;
				}
			}
		}
		return true;
	}

	String make(int start[]) {
		char s[] = new char[start.length];
		for (int i = 0; i < start.length; i++) {
			s[i] = (char)(start[i] + '0');
		}
		return new String(s);
	}

	int genMoves(int start[]) {
		nMoves.clear();
		Queue<String> q = new LinkedList<>();
		String startString = make(start);
		q.add(startString);
		nMoves.put(startString, 0);
		char changed[] = new char[start.length];
		while (!q.isEmpty()) {
			String next = q.poll();

			int count = nMoves.get(next);

			if (isGood(next)) {
				// out.println("ANSWER STRING: " + next + ", START STRING: " +
				// startString);
				return count;
			}

			for (int i = 0; i < next.length(); i++) {
				changed[i] = next.charAt(i);
			}

			for (int i = 0; i < next.length() - 1; i++) {
				char v1 = next.charAt(i + 1);
				char v2 = next.charAt(i);
				changed[i] = v1;
				changed[i + 1] = v2;
				String newOne = new String(changed);
				if (!nMoves.containsKey(newOne)) {
					nMoves.put(newOne, count + 1);
					q.add(newOne);
				}
				changed[i + 1] = v1;
				changed[i] = v2;
			}
		}
		throw new Error("NO ANSWER FOUND");
	}

	void solveOne() {
		int n = in.nextInt();
		Pair ar[] = new Pair[n];
		for (int i = 0; i < n; i++) {
			ar[i] = new Pair(in.nextInt(), i);
		}
		Arrays.sort(ar);
		int real[] = new int[n];
		for (int i = 0; i < n; i++) {
			real[ar[i].idx] = i;
		}
		out.print(genMoves(real));
	}

	void solve() {
		int nTests = in.nextInt();
		for (int i = 1; i <= nTests; i++) {
			out.print("Case #" + i + ": ");
			solveOne();
			out.println();
			out.flush();
		}
	}

	void run() {
		try {
			in = new Scanner(new FileReader(path + problem + ".in"));
			out = new PrintWriter(path + problem + ".out");
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
			out.println("cmd>");
			out.flush();
		}
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new B().run();
	}
}
