import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	static PrintWriter out;

	static final String path = "C:/gcj/";
	static final String problem = "A";
	
	
	static class Vine {
		int pos;
		int len;
		
		Vine(Scanner in) {
			pos = in.nextInt();
			len = in.nextInt();
		}
	}
	
	int res[][];
	int dest;
	
	Vine []v;
	
	int gen(int prev, int curr) {
		if (res[prev][curr] != -1) {
			return res[prev][curr];
		}
		
		int dist = Math.min(v[curr].len, v[curr].pos - v[prev].pos);
		if (prev == curr) {
			dist = v[curr].pos;
		}
		if (dist + v[curr].pos >= dest) {
			return 1;
		}
		
		for (int next = curr + 1; next < v.length; next++) {
			if (dist + v[curr].pos < v[next].pos) {
				break;
			} else {
				int t = gen(curr, next);
				if (t != 0) {
					res[prev][curr] = 1;
					return 1;
				}
			}
		}
		
		res[prev][curr] = 0;
		return 0;
	}
	
	void solveOne() {
		v = new Vine[in.nextInt()];
		for (int i = 0; i < v.length; i++) {
			v[i] = new Vine(in);
		}
		res = new int[v.length][v.length];
		for (int ar[] : res) {
			Arrays.fill(ar, -1);
		}
		dest = in.nextInt();
		if (gen(0, 0) == 0) {
			out.print("NO");
		} else {
			out.print("YES");
		}
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 1; i <= nTests; i++) {
			out.print("Case #" + i + ": ");
			solveOne();
			out.println();
		}
	}
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	
	public void run() {
		try {
			in = new Scanner(new FileReader(path + problem + ".in"));
			out = new PrintWriter(new FileWriter(path + problem + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new Main().run();
	}

}