import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "A-small";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	static long gcd(long a, long b) {
		if (b == 0) {
			return a;
		} else {
			return gcd(b, a%b);
		}
	}
	
	static class Fract {
		long num;
		long den;
		
		Fract(long num, long den) {
			long div = gcd(num, den);
			this.num = num / div;
			this.den = den / div;
		}
		
		Fract add(Fract second) {
			return new Fract(this.num * second.den + this.den * second.num, this.den * second.den);
		}
		
		Fract mul(long x) {
			return new Fract(this.num * x, this.den);
		}
		
		Fract div(long x) {
			return new Fract(this.num, this.den * x);
		}
		
		double toDouble() {
			return (num + 0.0) / (den + 0.0); 
		}
	}
	
	void solveOne() {
		out.println();
		int nTeams = in.nextInt();
		char ar[][] = new char[nTeams][];
		for (int i = 0; i < nTeams; i++) {
			ar[i] = in.next().toCharArray();
			asserT(ar[i].length == nTeams);
		}
		Fract wp[] = new Fract[nTeams];
		
		for (int i = 0; i < wp.length; i++) {
			int win = 0;
			int lose = 0;
			for (int j = 0; j < nTeams; j++) {
				if (ar[i][j] == '1') {
					win++;
				} else if (ar[i][j] == '0') {
					lose++;
				}
			}
			wp[i] = new Fract(win, win + lose);
			
		}
		
		Fract owp[] = new Fract[nTeams];
		for (int i = 0; i < wp.length; i++) {
			Fract curr = new Fract(0, 1);
			int cnt = 0;
			for (int j = 0; j < nTeams; j++) {
				if (ar[i][j] == '.') {
					continue;
				}
				if (j == i) {
					continue;
				}
					
				int win = 0;
				int lose = 0;
				
				for (int k = 0; k < nTeams; k++) {
					if (k == i) {
						continue;
					}
					if (ar[j][k] == '1') {
						win++;
					} else if (ar[j][k] == '0') {
						lose++;
					}
				}
				
				curr = curr.add(new Fract(win, win + lose));
				cnt++;
			}
			owp[i] = curr.div(cnt);
		}
		
		Fract oowp[] = new Fract[nTeams];
		for (int i = 0; i < wp.length; i++) {
			Fract curr = new Fract(0, 1);
			int cnt = 0;
			for (int j = 0; j < nTeams; j++) {
				if (ar[i][j] == '.') {
					continue;
				}
				if (j == i) {
					continue;
				}
					
				curr = curr.add(owp[j]);
				cnt++;
			}
			oowp[i] = curr.div(cnt);
		}
		
		for (int i = 0; i < nTeams; i++) {
			Fract rpi = wp[i].div(4).add(owp[i].div(2).add(oowp[i].div(4)));
			out.printf(Locale.US, "%.8f\n", rpi.toDouble());
		}
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 0; i < nTests; i++) {
			out.print("Case #"+(i+1)+":");
			solveOne();
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:\\roundB\\" + problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\roundB\\" + problem + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}