import java.io.*;
import java.util.*;

public class RunClass {

	Scanner in;
	PrintWriter out;
	
	static final String problem = "charts";
	
	static int k;
	
	static class Chart implements Comparable <Chart>{
		int []h;
		int min=Integer.MAX_VALUE;
		
		Chart(Scanner in){
			h = new int[k];
			for (int j=0; j<k; j++){
				h[j] = in.nextInt();
				min = Math.min(min, h[j]);				
			}
		}
		
		boolean isect(Chart second){
			boolean comp = h[0] > second.h[0];
			if (h[0] == second.h[0]){
				return true;
			}
			for (int i=1; i<k; i++){
				if (h[i] == second.h[i]) {
					return true;
				}
				if ((h[i] > second.h[i]) != comp) {
					return true;
				}
			}
			return false;
		}
		
		public int compareTo(Chart arg0) {
			return this.min - arg0.min;
		}
	}
	
	Chart chart[];
	int res[][];
	boolean inter[][];
	
	int gen(int choiseIdx, int mask){
		if (mask == (1<<chart.length) - 1) {
			return 0;
		}
		if (res[choiseIdx][mask] != -1){
			return res[choiseIdx][mask];
		}
		int ans = Integer.MAX_VALUE / 2;
		for (int i = 0; i < chart.length; i++) {
			boolean contains = (mask & (1 << i)) != 0;
			if (!contains){
				int nmask = mask | (1 << i);
				ans = Math.min(ans, 1 + gen(i, nmask));
				if (i > choiseIdx && !inter[choiseIdx][i]) {
					ans = Math.min(ans, gen(i, nmask));
				}
			}
		}
		res[choiseIdx][mask] = ans;
		return ans;
	}
	
	void solveOne(){
		int n = in.nextInt();
		k = in.nextInt();
		chart = new Chart[n];
		for (int i=0; i<n; i++){
			chart[i] = new Chart(in);
		}
		Arrays.sort(chart);
		res = new int[chart.length][1<<chart.length];
		inter = new boolean[chart.length][chart.length];
		for (int i=0; i<n; i++){
			for (int j=0; j<n; j++){
				inter[i][j] = chart[i].isect(chart[j]);
			}
		}
		for (int i=0; i<res.length; i++){
			Arrays.fill(res[i], -1);
		}
		int ans = 1+gen(0, 1);
		out.println(ans);
	}
	
	void solve(){
		int t = in.nextInt();
		for (int i=1; i<=t; i++){
			out.print("Case #" + i + ": ");
			solveOne();
		}
	}
		
	public void run(){
		/*
		try {
			in = new Scanner(new FileReader("C:\\"+problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\"+problem + ".out"));
		} catch (IOException e) {
			throw new Error(e);
		}
		*/
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
		
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new RunClass().run();
	}
}