import java.io.*;
import java.util.*;
import java.math.*;

public class Main  {
	
	Scanner in;
	PrintWriter out;
	

	long size[];
	int count[];
	long euro[];
	int usedTime[];
	
	
	void solveOne(){
		int nRounds = in.nextInt();
		int cap = in.nextInt();
		int nGroups = in.nextInt();
		
		size = new long[nGroups];
		for (int i = 0; i < size.length; i++){
			size[i] = in.nextInt();
		}
		
		count = new int[nGroups];
		euro = new long[nGroups];
		usedTime = new int[nGroups];
		Arrays.fill(usedTime, -1);
		
		for (int i = 0; i < size.length; i++){
			long sum = 0;
			int cnt = size.length;
			for (int j = 0; j < size.length; j++){
				int next = (i + j) % nGroups;
				if (sum + size[next] > cap) {
					cnt = j;
					break;
				} else {
					sum = sum + size[next];
				}
			}
			count[i] = cnt;
			euro[i] = sum;
		}
		
		int cycleLen = 0;
		long sumCycle = 0;
		int start = 0;
		do {
			cycleLen++;
			sumCycle += euro[start];
			usedTime[start] = cycleLen;
			start = (start + count[start]) % nGroups;			
		} while (usedTime[start] == -1);
		
		cycleLen = cycleLen - usedTime[start] + 1;
		int preCycleCount = usedTime[start] - 1;
		/*
		if (preCycleCount >= nRounds) */{
			long ans = 0;
			start = 0;
			for (int i = 0; i < nRounds; i++){
				ans += euro[start];
				start = (start + count[start]) % nGroups;
			}
			out.println(ans);
			return;
		}
		/*
		nRounds -= preCycleCount;
		long nCycles = nRounds / cycleLen;
		long ans = nCycles * sumCycle;
		int remain = nRounds % cycleLen;
		
		for (int i = 0; i < remain; i++){
			ans += euro[start];
			start = (start + count[start]) % nGroups;
		}
		out.println(ans);*/
	}
	
	void solve(){
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			out.print("Case #"+i + ": ");
			solveOne();
		}
	}
	
	void run(){
		
		try {
			in = new Scanner(new FileReader("C:\\A-small.in"));
			out = new PrintWriter(new FileWriter("C:\\output2.txt"));
		} catch (IOException e)  {			
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}