import java.io.*;
import java.util.*;

public class Csmall {

    Scanner in;

    PrintWriter out;

    private static final String path = "/home/alex/jam1/";

    private static final String task = "C-small-attempt0";


    void solveOne() {
	int nCities = in.nextInt();
	int nPairs = in.nextInt();
	int horse[] = new int[1 + nCities];
	int speed[] = new int[1 + nCities];
	
	for (int i = 1; i <= nCities; i++) {
	    horse[i] = in.nextInt();
	    speed[i] = in.nextInt();
	}
	
	long dist[][] = new long[nCities + 1][nCities + 1];
	double time[][] = new double[nCities + 1][nCities + 1];
	for (int i = 1; i <= nCities; i++) {
	    for (int j = 1; j <= nCities; j++) {
		dist[i][j] = in.nextInt();
		if (dist[i][j] == -1) {
		    dist[i][j] = Long.MAX_VALUE / 10L;
		}
	    }
	}
	
	for (int inter = 1; inter <= nCities; inter++) {
	    for (int i = 1; i <= nCities; i++) {
		for (int j = 1; j <= nCities; j++) {
		    if (dist[i][j] > dist[i][inter] + dist[inter][j]) {
			dist[i][j] = dist[i][inter] + dist[inter][j];
		    }
		}
	    }
	}

	for (int i = 1; i <= nCities; i++) {
	    for (int j = 1; j <= nCities; j++) {
		if (horse[i] >= dist[i][j]) {
		    time[i][j] = dist[i][j] / (speed[i] + 0.0);
		} else {
		    time[i][j] = Double.MAX_VALUE / 10L;
		}
	    }
	}

	for (int inter = 1; inter <= nCities; inter++) {
	    for (int i = 1; i <= nCities; i++) {
		for (int j = 1; j <= nCities; j++) {
		    if (time[i][j] > time[i][inter] + time[inter][j]) {
			time[i][j] = time[i][inter] + time[inter][j];
		    }
		}
	    }
	}
	
	boolean first = true;
	for (int i = 0; i < nPairs; i++) {
	    int from = in.nextInt();
	    int to = in.nextInt();
	    if (!first) {
		out.print(" ");
	    }
	    first = false;
	    out.printf(Locale.US, "%.6f", time[from][to]);
	}
    }
    
    static void asserT(boolean e) {
	if (!e) {
	    throw new Error();
	}
    }

    void solve() {
	int nTests = in.nextInt();
	for (int i = 1; i <= nTests; i++) {
	    out.print("Case #" + i + ": ");
	    solveOne();
	    out.println();
	    out.flush();
	}
    }

    void run() {
	try {
	    in = new Scanner(new FileReader(path + task + ".in"));
	    out = new PrintWriter(new FileWriter(path + task + ".out_test"));
	} catch (IOException e) {
	    in = new Scanner(System.in);
	    out = new PrintWriter(System.out);
	    out.println(">");
	    out.flush();
	}

	try {
	    solve();
	} finally {
	    out.close();
	}
    }

    public static void main(String[] args) {
	new Csmall().run();
    }
}
