import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

public class CodeJam {

	Scanner in;
	PrintWriter out;

	List<String> newElements(Set<String> toAdd, Set<String> from) {
		List<String> ns = new ArrayList<String>();
		for (String f : from) {
			if (toAdd.add(f)) {
				ns.add(f);
			}
		}
		return ns;
	}
	
	int best;
	
	void gen(int j, List<HashSet<String>> linesAll, Set<String> allEng, Set<String> allFre, Set<String> common, int sz) {
		if (j == sz) {
//			HashSet<String> copy = new HashSet<String>(allEng);
//			copy.retainAll(allFre);
//			best = Math.min(best, copy.size());
			best = Math.min(best, common.size());
			return;
		}
		if (common.size() >= best) {
			return;
		}
		
		Set<String> curr = linesAll.get(j);
		List<String> last = newElements(allEng, curr);
		List<String> remCom = new ArrayList<String>();
		for (String s: curr) {
			if (allFre.contains(s)) {
				if (common.add(s)) {
					remCom.add(s);
				}
			}
		}
		
		gen(j + 1, linesAll, allEng, allFre, common, sz);
		allEng.removeAll(last);
		common.removeAll(remCom);
		
		last = newElements(allFre, curr);
		
		remCom = new ArrayList<String>();
		for (String s: curr) {
			if (allEng.contains(s)) {
				if (common.add(s)) {
					remCom.add(s);
				}
			}
		}
		gen(j + 1, linesAll, allEng, allFre, common, sz);
		allFre.removeAll(last);
		common.removeAll(remCom);
	}
	
	void solveFor() {
		int n = in.nextInt();
		in.nextLine();
		String []eng = in.nextLine().split(" ");
		Set<String> engSet = new HashSet<String>();
		for (String s : eng) {
			engSet.add(s);
		}
		
		String []fre = in.nextLine().split(" ");
		Set<String> freSet = new HashSet<String>();
		for (String s : fre) {
			freSet.add(s);
		}
		
		String [][]lines = new String[n - 2][];
		List<HashSet<String>> linesAll = new ArrayList<HashSet<String>>();
		for (int i = 0; i < lines.length; i++) {
			HashSet<String> curr = new HashSet<String>();
			lines[i] = in.nextLine().split(" ");
			for (String line : lines[i]) {
				curr.add(line);
			}
			linesAll.add(curr);
		}
		best = Integer.MAX_VALUE / 2;
		int sz = lines.length;
		Set<String> common = new HashSet<String>(engSet);
		common.retainAll(freSet);
		gen(0, linesAll, engSet, freSet,  common, sz);
//		for (int i = 0; i < (1<<sz); i++) {
//			Set<String> allEng = new HashSet<String>(engSet);
//			Set<String> allFre = new HashSet<String>(freSet);
//			
//			for (int j = 0; j < sz; j++) {
//				if (used(i, j)) {
//					allEng.addAll(linesAll.get(j));
//				} else {
//					allFre.addAll(linesAll.get(j));
//				}
//			}
//			allEng.retainAll(allFre);
//			if (allEng.size() < best) {
//				best = allEng.size();
//			}
//		}
		out.println(best);
	}
	
	boolean used(int in, int pos) {
		return (in & (1<<pos)) == (1<<pos);
	}

	void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}

	void solve() {
		int n = in.nextInt();
		for (int test = 1; test <= n; test++) {
			out.print("Case #" + test + ": ");
			solveFor();
			out.flush();
		}
	}

	static private final String path = "C:\\jam\\C\\";
	static private final String problem = "C";
	static private final String tests = "C-small";

	void run() {
		try {
			in = new Scanner(new FileReader(path + problem + "\\" + tests + ".in"));
			out = new PrintWriter(path + problem + "\\" + tests + ".out2");
		} catch (IOException e) {
//			throw new Error(e);
			
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
			out.println(">");
			out.flush();
		}
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new CodeJam().run();
	}
}