import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "B-small";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	
	static class Point implements Comparable <Point> {
		int pos;
		int count;
		
		Point(Scanner in) {
			pos = in.nextInt();
			count = in.nextInt();
		}
		
		public int compareTo(Point second) {
			return this.pos - second.pos;
		}
	}
	
	boolean solved(Point []point, int d, double dist) {
		double leftBorder = point[0].pos - dist;
		for (int i = 0; i < point.length; i++) {
			int t = point[i].count;
			while (t > 0) {
				if (leftBorder < point[i].pos - dist) {
					leftBorder = (point[i].pos - dist) + d;
				} else if (leftBorder < point[i].pos) {
					leftBorder = leftBorder + d;
				} else if (leftBorder < point[i].pos + dist) {
					leftBorder = leftBorder + d;
				} else {
					return false;
				}
				t--;
			}
		}
		return true;
	}
	
	void solveOne() {
		int nPoints = in.nextInt();
		int d = in.nextInt();
		Point point [] = new Point[nPoints];
		for (int i = 0; i < nPoints; i++) {
			point[i] = new Point(in);
		}
		Arrays.sort(point);
		double low = 0;
		double high = Integer.MAX_VALUE / 2;
		
		while (high - low >= 1e-12) {
			double mid = (low + high) / 2.0;
			if (solved(point, d, mid)) {
				high = mid;
			} else {
				low = mid;
			}
		}
		asserT(solved(point, d, high));
		out.printf(Locale.US, "%.7f", high);
		out.println();
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 0; i < nTests; i++) {
			out.print("Case #"+(i+1)+": ");
			solveOne();
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:\\roundB\\" + problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\roundB\\" + problem + ".out3"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}