import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;
import java.util.Scanner;

public class Olympic {

	Scanner in;
	PrintWriter out;

	static final int table[][] = { { 1, 2, 3, 4 }, { 2, -1, 4, -3 },
			{ 3, -4, -1, 2 }, { 4, 3, -2, -1 }, };

	static int num(char c) {
		if (c == 'i') {
			return 2;
		} else if (c == 'j') {
			return 3;
		} else if (c == 'k') {
			return 4;
		} else {
			throw new Error();
		}
	}

	static char sym(int c) {
		if (c == 2) {
			return 'i';
		} else if (c == 3) {
			return 'j';
		} else if (c == 4) {
			return 'k';
		} else {
			return 0;
		}
	}

	int mul(int prev, char c) {
		int currNum = Math.abs(prev);
		int numer = num(c);
		int res = Integer.signum(prev) * table[currNum - 1][numer - 1];
		return res;
	}

	int mulBack(char c, int prev) {
		int currNum = Math.abs(prev);
		int numer = num(c);
		int res = Integer.signum(prev) * table[numer - 1][currNum - 1];
		return res;
	}

	void solveOne() {
		int len = in.nextInt();
		int rep = in.nextInt();
		char s[] = in.next().toCharArray();
		s = Arrays.copyOf(s, len * rep);
		for (int i = 1; i < rep; i++) {
			for (int j = 0; j < len; j++) {
				s[len * i + j] = s[j];
			}
		}
		List<Integer> probableFinishI = new ArrayList<Integer>();
		{
			int prev = 1;
			for (int i = 0; i < s.length; i++) {
				int curr = mul(prev, s[i]);
				if (sym(curr) == 'i') {
					probableFinishI.add(i);
				}
				prev = curr;
			}
		}
		List<Integer> probableStartK = new ArrayList<Integer>();
		{
			int next = 1;
			for (int i = s.length - 1; i >= 0; i--) {
				int curr = mulBack(s[i], next);
				if (sym(curr) == 'k') {
					probableStartK.add(i);
				}
				next = curr;
			}
		}
		Collections.sort(probableStartK);
		for (int start : probableFinishI) {
			int prevIdx = start;
			int prev = 1;
			for (int end : probableStartK) {
				if (end < start) {
					continue;
				}

				for (int i = prevIdx + 1; i < end; i++) {
					int curr = mul(prev, s[i]);
					prev = curr;
				}
				prevIdx = end - 1;
				if (sym(prev) == 'j') {
					out.println("YES");
					return;
				}
			}
		}
		out.println("NO");
	}

	void solve() {
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			out.print("Case #" + i + ": ");
			solveOne();
			out.flush();
		}
	}

	static final String path = "C:\\jam\\qual\\C\\";
	static final String test = "small";

	void run() {
		try {
			in = new Scanner(new FileReader(path + test + ".in"));
			out = new PrintWriter(path + test + ".out2");
		} catch (IOException e) {
			//throw new Error(e);
		
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);

		}
		try {
			solve();
		} finally {
			out.close();
		}

	}

	public static void main(String[] args) {
		new Olympic().run();
	}

}
