import java.io.*;
import java.util.*;

public class Txxxx {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "basin";
	static final int MAX_ALT = 100000;
	
	enum Direction {
		NORTH,
		EAST,
		WEST,
		SOUTH,
		NONE
	}
	
	int [][]field;
	Direction [][]dir;
	int [][]sink;
	
	void asserT(boolean e){
		if (!e){
			throw new Error();
		}
	}
	
	int getSinkNumber(int line, int col){
		if (sink[line][col] != -1) {
			return sink[line][col];
		}
		if (dir[line][col] == Direction.NORTH){
			sink[line][col] = getSinkNumber(line - 1, col);
		} else if (dir[line][col] == Direction.WEST) {
			sink[line][col] = getSinkNumber(line, col - 1);
		} else if (dir[line][col] == Direction.EAST){
			sink[line][col] = getSinkNumber(line, col + 1);
		} else if (dir[line][col] == Direction.SOUTH){
			sink[line][col] = getSinkNumber(line + 1, col);
		} else {
			throw new Error();
		}
		return sink[line][col];
	}
	
	void solveOne(){
		int nLines = in.nextInt();
		int nCols = in.nextInt();
		for (int i = 0; i<field.length; i++){
			Arrays.fill(field[i], MAX_ALT);
			Arrays.fill(sink[i], -1);
		}
		for (int line = 1; line <= nLines; line++) {
			for (int col = 1; col <= nCols; col++){
				field[line][col] = in.nextInt();
			}
		}
		int sinkId = 0;
		for (int line = 1; line <= nLines; line++){
			for (int col = 1; col <= nCols; col++){
				int north = field[line - 1][col];
				int west = field[line][col - 1];
				int east = field[line][col + 1];
				int south = field[line + 1][col];
				int min1 = Math.min(north, south);
				int min2 = Math.min(west, east);
				int min = Math.min(min1, min2);
				if (min >= field[line][col]) {
					dir[line][col] = Direction.NONE;
					sink[line][col] = sinkId;
					sinkId++;
				}
				if (north == min) {
					dir[line][col] = Direction.NORTH;
				} else if (west == min){
					dir[line][col] = Direction.WEST;					
				} else if (east == min){
					dir[line][col] = Direction.EAST;
				} else if (south == min){
					dir[line][col] = Direction.SOUTH;
				} else {
					throw new Error();
				}
			}
		}
		asserT(sinkId <= 26);
		char []sinkChar = new char[sinkId];
		char maxChar = 'a';
		for (int line = 1; line <= nLines; line++){
			for (int col = 1; col <= nCols; col++){
				int t = getSinkNumber(line, col);
				if (sinkChar[t] == 0) {
					sinkChar[t] = maxChar;
					maxChar++;
				}
				out.print(sinkChar[t] + " ");
			}
			out.println();
		}
		
	}
	
	void solve(){
		int nTests = in.nextInt();
		field = new int[1 + 100 + 1][1 + 100 + 1];
		dir = new Direction[1 + 100 + 1][1 + 100 + 1];
		sink = new int[1 + 100 + 1][1 + 100 + 1];
		
		for (int i=1; i<=nTests; i++){
			out.println("Case #"+i+":");
			solveOne();
		}
	}
	
	void run() {
		
		try {
			in = new Scanner(new FileReader("C:\\"+problem + ".in"));
			out = new PrintWriter("C:\\"+problem + ".out");
		} catch (IOException e) {
			throw new Error();
		}
		/*
		in = new Scanner(System.in);
		out = new PrintWriter(System.out);
		*/
		try {
			solve();			
		} finally {
			out.close();
		}
	}
	
	public static void main(String []args) {
		new Txxxx().run();
	}
}