import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.Stack;

public class D {

	private static final String path = "/home/tolstov.a.a/codejam/d/";

	private static final String problem = "D-small";

	Scanner in;

	PrintWriter out;

	Map<String, Integer> nMoves = new HashMap<String, Integer>();

	void asserT(boolean b) {
		if (!b) {
			throw new Error();
		}
	}

	final long MOD = 1000000007;

	static class Pair implements Comparable<Pair> {

		int val;

		int idx;

		Pair(int val, int idx) {
			this.val = val;
			this.idx = idx;
		}

		@Override
		public int compareTo(Pair o) {
			return this.val - o.val;
		}
	}

	static class Trie {

		private Stack<String> strings = new Stack<>();

		void push(String s) {
			strings.push(s);
		}

		String pop() {
			return strings.pop();
		}

		boolean isEmpty() {
			return strings.isEmpty();
		}

		private int getStartEquals(String a, String b) {
			int i = 0;
			while (i < a.length() && i < b.length()) {
				if (a.charAt(i) == b.charAt(i)) {
					i++;
				} else {
					return i;
				}
			}
			return i;
		}

		int getNodeCount() {
			ArrayList<String> sorted = new ArrayList<>(strings);
			sorted.add("");
			Collections.sort(sorted);

			int nNodes = 1;

			for (int i = 1; i < sorted.size(); i++) {

				String prev = sorted.get(i - 1);
				String curr = sorted.get(i);
				int eq = getStartEquals(prev, curr);

				nNodes += curr.length() - eq;

			}

			return nNodes;
		}
	}

	Trie[] servers;

	String strings[];

	int best = -1;

	int maxNodeCount = -1;

	void calculus() {
		int curr = 0;
		for (Trie t : servers) {
			if (t.isEmpty()) {
				return;
			}
			curr += t.getNodeCount();
		}
		if (curr > maxNodeCount) {
			maxNodeCount = curr;
			best = 1;
		} else if (curr == maxNodeCount) {
			best++;
		}
	}

	void gen(int strIdx) {
		if (strIdx == strings.length) {
			calculus();
			return;
		}
		for (Trie t : servers) {
			t.push(strings[strIdx]);
			gen(strIdx + 1);
			asserT(t.pop().equals(strings[strIdx]));
		}
	}

	void solveOne() {
		best = -1;
		maxNodeCount = -1;
		int nStrings = in.nextInt();
		asserT(1 <= nStrings && nStrings <= 8);
		int nServers = in.nextInt();
		asserT(1 <= nServers && nServers <= 4);
		strings = new String[nStrings];
		for (int i = 0; i < strings.length; i++) {
			strings[i] = in.next();
			asserT(1 <= strings[i].length() && strings[i].length() <= 10);
		}
		servers = new Trie[nServers];
		for (int i = 0; i < servers.length; i++) {
			servers[i] = new Trie();
		}
		gen(0);
		out.print(maxNodeCount + " " + best);
	}

	void solve() {
		int nTests = in.nextInt();
		for (int i = 1; i <= nTests; i++) {
			out.print("Case #" + i + ": ");
			solveOne();
			out.println();
			out.flush();
		}
	}

	void run() {
		try {
			in = new Scanner(new FileReader(path + problem + ".in"));
			out = new PrintWriter(path + problem + ".out");
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
			out.println("cmd>");
			out.flush();
		}
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new D().run();
	}
}
