import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "D-smal1l";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	
	static class Perm implements Comparable <Perm> {
		int ar[];
		
		Perm(int n) {
			ar = new int[n];
		}
		
		Perm (Perm prev, int i, int j) {
			this.ar = new int[prev.ar.length];
			for (int ii = 0; ii < ar.length; ii++) {
				ar[ii] = prev.ar[ii];
			}
			int t = ar[i];
			ar[i] = ar[j];
			ar[j] = t;
		}
		
		public int compareTo(Perm second) {
			for (int i = 0; i < ar.length; i++) {
				if (this.ar[i] != second.ar[i]) {
					return this.ar[i] - second.ar[i];
				}
			}
			return 0;
		}
		
		public String toString() {
			String ans = "";
			for (int i = 0; i < ar.length; i++) {
				ans += ar[i] + " ";
			}
			return ans;
		}
	}
	
	TreeMap <Perm, Integer> map = new TreeMap<Perm, Integer>();
	
	
	void goBFS(int n) {
		Queue <Perm> q = new LinkedList <Perm>();
		
		Perm start = new Perm(n);
		for (int i = 0; i < n; i++) {
			start.ar[i] = i+1;
		}
		q.add(start);
		map.put(start, 0);
		while (!q.isEmpty()) {
			Perm curr = q.poll();
			int val = map.get(curr);
			for (int i = 0; i < n; i++) {
				for (int j = i + 1; j < n; j++) {
					Perm newPerm = new Perm(curr, i, j);
					if (!map.containsKey(newPerm)) {
						map.put(newPerm, val + 1);
						q.add(newPerm);
					}
				}
			}
		}
		Perm p = new Perm(8);

		final int ar[] = {7,6,5,8,4,1,2,3};
		for (int i = 0; i < 8; i++) {
			p.ar[i] = ar[i];
		}
		out.println(map.get(p));
		/*
		for (Perm p : map.keySet()) {
			//out.println(p + ": " + map.get(p));
		}*/
	}
	
	void solveOne() {
		int n = in.nextInt();
		int ar[] = new int[n];
		for (int i = 0; i < n; i++) {
			ar[i] = in.nextInt() - 1;
		}
		int count = 0;
		while (true) {
			boolean makePerm = false;
			for (int j = 0; j < n; j++) {
				int k = ar[j];
				if (ar[k] == j && k != j) {
					count += 1;
					ar[k] = k;
					ar[j] = j;
				}
			}
			for (int j = 0; j < n; j++) {
				int k = ar[j];
				if (k != j) {
					count += 1;
					ar[j] = ar[k];
					ar[k] = k;
					makePerm = true;
				}
			}
			if (!makePerm) {
				break;
			}
		}
		if (count == 0) {
			out.println(0);
		} else {
			out.println((1<<count) + ".00");
		}
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 0; i < nTests; i++) {
			out.print("Case #"+(i+1)+": ");
			solveOne();
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:\\" + problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\" + problem + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}