import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "B-small";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	//  capital letters
	static class Word {
		char []str;
		boolean status[] = new boolean[26];
		
		Word(String s) {
			str = s.toCharArray();
			Arrays.fill(status, false);
			for (int i = 0; i < str.length; i++) {
				status[str[i] - 'a'] = true;
			}
		}
		
		boolean contains(char c) {
			return status[c - 'a'];
		}
		
		boolean isGoodForTemplate(char []template) {
			asserT(template.length == str.length);
			for (int i = 0; i < template.length; i++) {
				if (template[i] != ' ') {
					if (template[i] != str[i]) {
						return false;
					}
				}
			}
			return true;
		}
	}
	
	static class Answer {
		String s;
		int pen;
		int idx;
		
		Answer(String s, int pen, int idx) {
			this.s = s;
			this.pen = pen;
			this.idx = idx;
		}
		
		boolean betterThan(Answer second) {
			if (this.pen == second.pen) {
				return this.idx < second.idx;
			} else {
				return this.pen > second.pen;
			}
		}
	}
	
	static class WordsByLength {
		int len;
		ArrayList <Word> list = new ArrayList<Word>();
		ArrayList <Integer> idx = new ArrayList<Integer>();
		boolean status[] = new boolean[26];
		
		WordsByLength(int len) {
			this.len = len;
		}
		
		Answer best(String seq) {
			Arrays.fill(status, false);
			for (int i = 0; i < list.size(); i++) {
				for (int j = 0; j < 26; j++) {
					status[j] = status[j] || list.get(i).status[j];
				}
			}
			Answer ans = new Answer("", -1, Integer.MAX_VALUE/2);
			boolean goodWords[] = new boolean[list.size()];
			for (int i = 0; i < list.size(); i++) {
				char[] template = new char[len];
				Arrays.fill(template, ' ');
				int rem = len;
				
				int pen = 0;
				Arrays.fill(goodWords, true);
				for (int j = 0; j < 26; j++) {
					char c = seq.charAt(j);
					
					if (!status[c - 'a']) {
						continue;
					}
					
					//   ,   
					boolean found = false;
					for (int k = 0; k < list.size(); k++) {
						Word w = list.get(k);
						if (goodWords[k] && w.contains(c) && w.isGoodForTemplate(template)) {
							found = true;
							break;
						}
					}
					
					if (found) {
						if (!list.get(i).contains(c)) {
							for (int k = 0; k < list.size(); k++) {
								Word w = list.get(k);
								if (w.contains(c)) {
									goodWords[k] = false;
								}
							}
							pen++;
						} else {
							for (int k = 0; k < list.get(i).str.length; k++) {
								if (list.get(i).str[k] == c) {
									template[k] = c;
									rem--;
								}
							}
							if (rem == 0) {
								break;
							}
						}
					}
				}
				
				asserT(rem == 0);
				if (ans.pen < pen) {
					ans.pen = pen;
					ans.idx = idx.get(i);
					ans.s = "";
					for (int j = 0; j < len; j++) {
						ans.s += template[j];
					}
				}
			}
			return ans;
		}
	}
	
	
	void solveOne() {
		int nWords = in.nextInt();
		int nSeq = in.nextInt();
		
		WordsByLength []words = new WordsByLength[11];
		for (int i = 0; i < words.length; i++) {
			words[i] = new WordsByLength(i);
		}
		
		for (int i = 0; i < nWords; i++) {
			String str = in.next();
			asserT(1 <= str.length() && str.length() <= 10);
			words[str.length()].list.add(new Word(str));
			words[str.length()].idx.add(i);
		}
		
		for (int i = 0; i < nSeq; i++) {
			String seq = in.next();
			asserT(seq.length() == 26);
			
			Answer best = new Answer("", -1, nWords);
			for (WordsByLength w : words) {
				if (w.list.size() != 0) {
					Answer curr = w.best(seq);
					if (curr.betterThan(best)) {
						best = curr;
					}
				}
			}
			asserT(best.pen != -1);
			if (i != 0) {
				out.print(" ");
			}
			out.print(best.s);
		}
		out.println();
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 0; i < nTests; i++) {
			out.print("Case #"+(i+1)+": ");
			solveOne();
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:\\round1\\" + problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\round1\\" + problem + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}