import java.io.*;
import java.util.*;

public class RunClass {

	Scanner in;
	PrintWriter out;
	
	static final String problem = "plants";
	
	static class Point {
		int x, y, r;
		
		Point(Scanner in){
			x = in.nextInt();
			y = in.nextInt();
			r = in.nextInt();
		}
		
		double distTo(Point second){
			int dx = this.x-second.x;
			int dy = this.y-second.y;
			return Math.sqrt(dx*dx+dy*dy);
		}
	}
	
	double solveOne(){
		int n = in.nextInt();
		Point []p = new Point[n];
		for (int i=0; i<p.length; i++){
			p[i] = new Point(in);
		}
		if (p.length == 1) {
			return p[0].r;			
		} else if (p.length == 2) {
			return Math.max(p[0].r, p[1].r);
		} else if (p.length==3) {
			double dist01 = (p[0].distTo(p[1]) + p[0].r + p[1].r) / 2;
			double dist02 = (p[0].distTo(p[2]) + p[0].r + p[2].r) / 2;
			double dist12 = (p[1].distTo(p[2]) + p[1].r + p[2].r) / 2;
			double ans1 = Math.max(p[2].r, dist01);
			double ans2 = Math.max(p[1].r, dist02);
			double ans3 = Math.max(p[0].r, dist12);			
			return Math.min(ans1, Math.min(ans2, ans3));
		} else {
			throw new Error();
		}
	}
	
	void solve(){
		int t = in.nextInt();
		for (int i=1; i<=t; i++){
			out.print("Case #" + i + ": ");
			out.printf(Locale.US, "%.6f%n", solveOne());
		}
	}
	
	
	public void run(){
		
		try {
			in = new Scanner(new FileReader("C:\\"+problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\"+problem + ".out"));
		} catch (IOException e) {
			throw new Error(e);
		}
		
		//in = new Scanner(System.in);
		//out = new PrintWriter(System.out);
		
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new RunClass().run();
	}
}