import java.io.*;
import java.util.*;
import java.math.*;

public class Main  {
	
	Scanner in;
	PrintWriter out;
	
	static class Path {
		String dirs[];
		
		Path(Scanner in){
			String s = in.next();
			s = s.replace('/', ' ');
			s = s.substring(1);
			dirs = s.split(" ");
		}
		
		boolean isOver(int idx){
			return idx == dirs.length;
		}
	}
	
	int ans;
	
	class Node {
		TreeMap <String, Node> next = new TreeMap<String, Node>();
		
		Node(){}
		
		Node(Path p, int idx) {
			ans++;
			if (!p.isOver(idx)) {
				next.put(p.dirs[idx], new Node(p, idx+1));
			}
		}
		
		void add(Path p, int idx){
			if (!p.isOver(idx)) {
				if (next.containsKey(p.dirs[idx])) {
					next.get(p.dirs[idx]).add(p, idx+1);
				} else {
					next.put(p.dirs[idx], new Node(p, idx+1));
				}
			}
		}
	}
	
	void solveOne(){
		int has = in.nextInt();
		int n = in.nextInt();
		Node root = new Node();
		ans = 0;
		for (int i = 0; i < has; i++){
			root.add(new Path(in), 0);
		}
		ans = 0;
		for (int i = 0; i < n; i++){
			root.add(new Path(in), 0);
		}
		out.println(ans);
	}
	
		
	void solve(){
		int t = in.nextInt();
		for (int i = 1; i <= t; i++) {
			out.print("Case #"+i + ": ");
			solveOne();
		}
	}
	
	void run(){
		
		try {
			in = new Scanner(new FileReader("C:\\A-small.in"));
			out = new PrintWriter(new FileWriter("C:\\output.txt"));
		} catch (IOException e)  {			
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	void asserT(boolean e){
		if (!e){
			throw new Error();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}