import java.io.*;
import java.util.*;


public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String path = "C:/gcj2013/";
	static final String problem = "C-small";
	
	
	
	boolean isFairNumber(String s) {
		for (int i = 0; i < s.length(); i++) {
			if (s.charAt(i) != s.charAt(s.length() - 1 - i)) {
				return false;
			}
		}
		return true;
	}
	
	ArrayList<Long> fsq = new ArrayList<Long>();
	
	void prepare() {
		int count = 100000000;
		for (int i = 1; i < count; i++) {
			long ii = i;
			String s = ii + "";
			if (isFairNumber(s) && isFairNumber("" + ii * ii)) {
				fsq.add(ii*ii);
			//	out.println(ii + " " + ii*ii);
			}
		}
		
	}
	
	int getCount(long key) {
		if (key == 0) {
			return 0;
		}
		int low = 0;
		int high = fsq.size();
		
		while (low + 1 < high) {
			int mid = (low + high) >> 1;
			if (fsq.get(mid) > key) {
				high = mid;
			} else {
				low = mid;
			}
		}
		return low + 1;
	}
	
	void solve() {
		prepare();
		int n = in.nextInt();
		for (int i = 0; i < n; i++) {
			long low = in.nextLong();
			long high = in.nextLong();
			
			int count = getCount(high) - getCount(low - 1);
			out.println("Case #" + (i+1) + ": " + count);
		}
	}
	
	
	static void check(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	
	public void run() {
		try {
			in = new Scanner(new FileReader(path + problem + ".in"));
			out = new PrintWriter(new FileWriter(path + problem + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}
	
	public static void main(String[] args) {
		new Main().run();
	}

} 