import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problemName = "A";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	char output[] = new char[256];
	
	void addExample(String key, String value) {
		asserT(key.length() == value.length());
		for (int i = 0; i < key.length(); i++) {
			char currChar = key.charAt(i);
			char mapChar = value.charAt(i);
			
			asserT(output[currChar] == '0' || output[currChar] == mapChar);
			output[currChar] = mapChar;
		}
	}
	
	void checkForConsistency() {
		for (int i = 0; i < output.length; i++) {
			char currChar = (char)i;
			if ('a' <= currChar && currChar <= 'z') {
				if (output[i] == '0') {
					out.println(currChar);
				}
				asserT(output[i] != '0');
			} else if (currChar == ' ') {
				asserT(output[i] == ' ');
			} else {
				asserT(output[i] == '0');
			}
		}
	}
	
	String map(String s) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < s.length(); i++) {
			sb.append(output[s.charAt(i)]);
		}
		return sb.toString();
	}
	
	void solve() {
		Arrays.fill(output, '0');
		addExample("ejp mysljylc kd kxveddknmc re jsicpdrysi", "our language is impossible to understand");
		addExample("rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd", "there are twenty six factorial possibilities");
		addExample("de kr kd eoya kw aej tysr re ujdr lkgc jv", "so it is okay if you want to just give up");
		addExample("y qee", "a zoo");
		addExample("z", "q");
		
		checkForConsistency();
		
		int nTests = in.nextInt();
		in.nextLine();
		for (int i = 0; i < nTests; i++) {
			out.println("Case #" + (i+1) + ": " + map(in.nextLine()));
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:/GCJ/" + problemName + ".in"));
			out = new PrintWriter(new FileWriter("C:/GCJ/" + problemName + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
			throw new Error();
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}