import java.io.*;
import java.util.*;

public class Main {
	
	Scanner in;
	PrintWriter out;
	
	static final String problem = "B-small";
	
	static void asserT(boolean e) {
		if (!e) {
			throw new Error();
		}
	}
	
	int w[][];
	double d;
	
	boolean isCenterOfMass(int lowX, int lowY, int side) {
		double centerX = lowX + side / 2.0;
		double centerY = lowY + side / 2.0;
		
		double sumX = 0;
		double sumY = 0;
		for (int dx = 0; dx < side; dx++) {
			for (int dy = 0; dy < side; dy++) {
				if ((dx == 0 && (dy == 0 || dy == side-1)) ||
					(dx == side-1 && (dy == 0 || dy == side-1))) {
					continue;
				}
				
				sumX += ((lowX + dx + 0.5) - centerX) * (d + w[lowY + dy][lowX + dx]);
				sumY += ((lowY + dy + 0.5) - centerY) * (d + w[lowY + dy][lowX + dx]);
			}
		}
		
		return Math.abs(sumX) < 1e-7f && Math.abs(sumY) < 1e-7f;
	}
	
	void solveOne() {
		int sizeY = in.nextInt();
		int sizeX = in.nextInt();
		d = in.nextInt();
		
		w = new int[sizeY][sizeX];
		for (int y = 0; y < sizeY; y++) {
			String s = in.next();
			asserT(s.length() == sizeX);
			
			for (int x = 0; x < sizeX; x++) {
				w[y][x] = s.charAt(x) - '0';
			}
		}
		

		for (int side = Math.min(sizeX, sizeY); side > 2; side--) {
			for (int lowX = 0; lowX + side <= sizeX; lowX++) {
				for (int lowY = 0; lowY + side <= sizeY; lowY++) {
					if (isCenterOfMass(lowX, lowY, side)) {
						out.println(side);
						return;
					}
				}
			}
		}
		out.println("IMPOSSIBLE");
	}
	
	void solve() {
		int nTests = in.nextInt();
		for (int i = 0; i < nTests; i++) {
			out.print("Case #"+(i+1)+": ");
			solveOne();
		}
	}
	
	void run() {
		try {
			in = new Scanner(new FileReader("C:\\round2\\" + problem + ".in"));
			out = new PrintWriter(new FileWriter("C:\\round2\\" + problem + ".out"));
		} catch (IOException e) {
			in = new Scanner(System.in);
			out = new PrintWriter(System.out);
		}
		
		try {
			solve();
		} finally {
			out.close();
		}
	}

	public static void main(String[] args) {
		new Main().run();
	}
}