import java.util.*;
import java.io.*;
import java.math.*;

public class B
{
	public static void main(String[] argv) throws IOException
	{
		new B().run();
	}
	Scanner in;
	PrintWriter out;

	int n, m;
	int[][] field;
	long[][] usum;
	long[][] dsum;
	long[][] lsum;
	long[][] rsum;
	long[][] ssum;
	long[][] tsum;

	String solve(){
		int bk = 2;
		usum = new long[n + 2][m + 2];
		dsum = new long[n + 2][m + 2];
		lsum = new long[n + 2][m + 2];
		rsum = new long[n + 2][m + 2];
		ssum = new long[n + 2][m + 2];
		tsum = new long[n + 2][m + 2];
		for (int i = 1; i <= n; i++){
			for (int j = 1; j <= m; j++){
				ssum[i][j] = ssum[i][j-1] + ssum[i-1][j] - ssum[i-1][j-1] + field[i][j];
				usum[i][j] = usum[i-1][j] + i * (ssum[i][j] - ssum[i-1][j]);
				lsum[i][j] = lsum[i][j-1] + j * (ssum[i][j] - ssum[i][j-1]);
			}
		}
		for (int i = n; i >= 1; i--){
			for (int j = m; j >= 1; j--){
				tsum[i][j] = tsum[i][j+1] + tsum[i+1][j] - tsum[i+1][j+1] + field[i][j];
				dsum[i][j] = dsum[i+1][j] + (n-i+1) * (tsum[i][j] - tsum[i+1][j]);
				rsum[i][j] = rsum[i][j+1] + (m-j+1) * (tsum[i][j] - tsum[i][j+1]);
			}
		}
		for (int i = 1; i <= n; i++){
			for (int j = 1; j <= m; j++){
				for (int k = bk + 1; (i+k-1<=n) && (j+k-1<=m); k++){
					boolean fl = (i==2 && j==2 && k==5);
					int mk = k / 2;
					int ii = i+k-1;
					int jj = j+k-1;
					long upart = dsum[i][j] - dsum[i][j+k] - dsum[i+mk][j] + dsum[i+mk][j+k];
					long upsum = tsum[i][j] - tsum[i][j+k] - tsum[i+mk][j] + tsum[i+mk][j+k];
					upart -= (n+1-(i+mk)) * upsum;
					upart -= mk * field[i][j];
					upart -= mk * field[i][jj];
					long dpart = usum[ii][jj] - usum[ii][jj-k] - usum[ii-mk][jj] + usum[ii-mk][jj-k];
					long dpsum = ssum[ii][jj] - ssum[ii][jj-k] - ssum[ii-mk][jj] + ssum[ii-mk][jj-k];
					dpart -= (ii-mk) * dpsum;
					dpart -= mk * field[ii][j];
					dpart -= mk * field[ii][jj];
					long lpart = rsum[i][j] - rsum[i+k][j] - rsum[i][j+mk] + rsum[i+k][j+mk];
					long lpsum = tsum[i][j] - tsum[i+k][j] - tsum[i][j+mk] + tsum[i+k][j+mk];
					lpart -= (m+1-(j+mk)) * lpsum;
					lpart -= mk * field[i][j];
					lpart -= mk * field[ii][j];
					long rpart = lsum[ii][jj] - lsum[ii-k][jj] - lsum[ii][jj-mk] + lsum[ii-k][jj-mk];
					long rpsum = ssum[ii][jj] - ssum[ii-k][jj] - ssum[ii][jj-mk] + ssum[ii-k][jj-mk];
					rpart -= (jj-mk) * rpsum;
					rpart -= mk * field[i][jj];
					rpart -= mk * field[ii][jj];
					if (fl){
						System.err.println(upart + " " + dpart + " " + lpart + " " + rpart);
					}
					if (upart == dpart && lpart == rpart){
						bk = k;
					}
				}
			}
		}
		return (bk >= 3) ? String.valueOf(bk) : "IMPOSSIBLE";
	}

	public void run() throws IOException
	{
		boolean oj = System.getProperty("ONLINE_JUDGE") != null;
		in = oj ? new Scanner(System.in) : new Scanner(new File("input.txt"));
		out = oj ? new PrintWriter(System.out) : new PrintWriter(new File("output.txt"));

		int testNum = in.nextInt();
		for (int tt = 0; tt < testNum; tt++){
			n = in.nextInt();
			m = in.nextInt();
			int d = in.nextInt();
			field = new int[n + 2][m + 2];
			for (int i = 1; i <= n; i++){
				String row = in.next();
				for (int j = 1; j <= m; j++){
					field[i][j] = (int)(row.charAt(j - 1) - '0');
				}
			}
			out.println("Case #" + (tt+1) + ": " + solve());
			out.flush();
		}
	}
}
