import java.util.*;
import java.io.*;
import java.math.*;

public class C
{
	public static void main(String[] argv) throws IOException
	{
		new C().run();
	}
	Scanner in;
	PrintWriter out;

	final static int P = 1048576;
	boolean[] is_composite;
	long[] primes;
	int pn;

	void runSieve(){
		is_composite = new boolean[P];
		pn = 0;
		primes = new long[P];
		for (int i = 2; i < P; i++){
			if (!is_composite[i]){
				primes[pn++] = i;
				for (int j = i + i; j < P; j+= i){
					is_composite[j] = true;
				}
			}
		}
	}

	long solve(long n){
		long ans = 1;
		int cur;
		for (int i = 0; i < pn; i++){
			long cp = primes[i] * primes[i];
			if (cp > n) break;
			cur = 1;
			while (cp <= n){
				cp *= primes[i];
				cur++;
			}
			ans += cur - 1;
		}
		return (n == 1) ? 0L : ans;
	}

	public void run() throws IOException
	{
		boolean oj = System.getProperty("ONLINE_JUDGE") != null;
		in = oj ? new Scanner(System.in) : new Scanner(new File("input.txt"));
		out = oj ? new PrintWriter(System.out) : new PrintWriter(new File("output.txt"));

		runSieve();

		int testNum = in.nextInt();
		for (int tt = 0; tt < testNum; tt++){
			out.println("Case #" + (tt+1) + ": " + solve(in.nextLong()));
			out.flush();
		}
	}
}
