import java.util.*;
import java.io.*;
import java.math.*;

public class A
{
	public static void main(String[] argv) throws IOException
	{
		new A().run();
	}
	Scanner in;
	PrintWriter out;

	public class Walkway implements Comparable<Walkway>{
        	int len, w;
		public Walkway(int _len, int _w){
			len = _len;
			w = _w;
		}
		public int compareTo(Walkway other){
			return w - other.w;
		}
	}

	int t, x, s, r, n;
	Walkway[] ways;

	double solve(){
		int len = 0;
		double tleft = t;
		double ans = 0;
		for (int i = 0; i < n; i++){
			len += ways[i].len;
			double xrun = Math.min(ways[i].len, (r + ways[i].w) * tleft);
			tleft -= xrun / (r + ways[i].w);
			double xwalk = ways[i].len - xrun;
			ans += xrun / (r + ways[i].w) + xwalk / (s + ways[i].w);
		}
		return ans;
	}

	public void run() throws IOException
	{
		boolean oj = System.getProperty("ONLINE_JUDGE") != null;
		in = oj ? new Scanner(System.in) : new Scanner(new File("input.txt"));
		out = oj ? new PrintWriter(System.out) : new PrintWriter(new File("output.txt"));

		int testNum = in.nextInt();
		for (int tt = 0; tt < testNum; tt++){
			x = in.nextInt();
			s = in.nextInt();
			r = in.nextInt();
			t = in.nextInt();
			n = in.nextInt() + 1;
			ways = new Walkway[n];
			int len = 0;
			for (int i = 0; i < n - 1; i++){
				int b = in.nextInt();
				int e = in.nextInt();
				ways[i] = new Walkway(e - b, in.nextInt());
				len += e - b;
			}
			ways[n-1] = new Walkway(x - len, 0);
			Arrays.sort(ways);
			out.println("Case #" + (tt+1) + ": " + solve());
			out.flush();
		}
	}
}
