import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.text.MessageFormat;
import java.util.Scanner;

/**
 * 
 */

/**
 * @author alfonzzz
 * 
 */
public class SquareTilesSolver {

    /**
     * @param args
     */
    public static void main(String[] args) {
	init();
	SquareTilesSolver botTrustSolver = new SquareTilesSolver();
	botTrustSolver.solve();
    }

    private static void init() {
	try {
	    System.setIn(new FileInputStream("in.txt"));
	    System.setOut(new PrintStream("out.txt"));
	} catch (FileNotFoundException e) {
	    e.printStackTrace();
	}
    }

    private final Scanner inputScanner = new Scanner(System.in);

    private int R = 0;
    private int C = 0;
    private char[][] grid = null;
    
    private void solve() {
	// Number of test cases
	int T = inputScanner.nextInt();
	inputScanner.nextLine();
	for (int i = 1; i <= T; i++) {
	    initTestCase();
	    readTestCase();
	    solveTestCase();
	    printTestCase(i);
	}
    }

    private void initTestCase() {
	R = 0;
	C = 0;
	grid = null;
    }

    private void readTestCase() {
	R = inputScanner.nextInt();
	C = inputScanner.nextInt();
	grid = new char[R][C];
	
	inputScanner.nextLine();
	for (int row=0; row<R; row++) {
	    String line = inputScanner.nextLine();
	    for (int col=0; col<C; col++) {
		grid[row][col] = line.charAt(col);
	    }
	}
    }

    private void solveTestCase() {
	int maxRow = R-1;
	int maxCol = C-1;
	for (int row=0; row<maxRow; row++) {
	    for (int col=0; col<maxCol; col++) {
		if (isBlue(row, col)) {
		    colourRed(row, col);
		}
	    }
	}
    }

    private final MessageFormat printFormat = new MessageFormat("Case #{0}: ");

    private void printTestCase(int num) {
	System.out.println(printFormat.format(new Object[] { num }));
	if (hasBlue()) {
	    System.out.println("Impossible");
	} else {
	    printGrid();
	}
    }

    private boolean hasBlue() {
	for (char[] row : grid) {
	    for (char tile : row) {
		if (isBlue(tile)) {
		    return true;
		}
	    }
	}

	return false;
    }

    private boolean isBlue(int row, int col) {
	return isBlue(grid[row][col]) && isBlue(grid[row][col + 1]) && isBlue(grid[row + 1][col]) && isBlue(grid[row + 1][col + 1]);
    }

    private static boolean isBlue(char tile) {
	return tile == '#';
    }

    private void colourRed(int row, int col) {
	grid[row][col] = '/';
	grid[row][col+1] = '\\';
	grid[row+1][col] = '\\';
	grid[row+1][col+1] = '/';
    }
    
    private void printGrid() {
	for (char[] row : grid) {
	    for (char tile : row) {
		System.out.print(tile);
	    }
	    System.out.println();
	}
    }

}
