/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package googlecodejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

/**
 *
 * @author Alfredo
 */
public class ProblemC
{
    public static void main(String args[]) throws IOException
    {
        ProblemC problemC = new ProblemC();
        ArrayList<Case> cases = problemC.read();    
        for(Case c : cases)
        {
            while(c.getSolutions().size() != c.getJ())
            {
                String sol = problemC.generate(c.getN());
                if(problemC.isJamCoin(sol))
                {
                    c.getSolutions().put(sol, sol);                    
                }
            }
        }        
        problemC.save(cases);
    }
    
    private String generate(int n)
    {
        String generate = "1";
        for(int i = 1; i < n - 1; i++)
        {
            generate += Math.random() > 0.5 ? '0' : '1';
        }
        generate += "1";
        return generate;
    }
    
    private boolean isJamCoin(String string)
    {
        for(int i = 2; i <= 10; i++)
        {
            long number = Long.parseLong(string, i);
            if(isPrime(number))
            {
                return false;
            }
        }
        return true;
    }
    
    private boolean isPrime(long number)
    {
        long to = (long) Math.sqrt(number) + 1;
        for (long i = 2; i <= to; i++) 
        {
            if (number % i == 0)
            {
                return false;
            }
        }
        return number > 1 && true;
                

        /*for(long i = 2; i < number; i++) 
        {
            if((number % i) == 0)
            {
                return false;
            }
        }
        return true;*/
        
        
    }
    
    private String getDivisors(String solution)
    {
        String divisors = "";
        for(int i = 2; i <= 10; i++)
        {
            long number = Long.parseLong(solution, i);
            for (long j = 2; j < number; j++)
            {
                if((number % j) == 0)
                {
                    divisors += j + " ";
                    break;
                }
            }
        }
        return divisors.substring(0, divisors.length() - 1);
    }
    
    private ArrayList<Case> read() throws FileNotFoundException, IOException
    {
        BufferedReader bufferedReader = new BufferedReader(new FileReader(new File(".//data//inputC.txt")));
        int cases = Integer.parseInt(bufferedReader.readLine());
        ArrayList<Case> caseList = new ArrayList<>();
        for(int i = 0; i < cases; i++)
        {
            Case c = new Case();
            String data[] = bufferedReader.readLine().split(" ");
            c.setN(Integer.parseInt(data[0]));
            c.setJ(Integer.parseInt(data[1]));
            caseList.add(c);
        }
        return caseList;
    }
    
    private void save(ArrayList<Case> cases) throws IOException
    {
        BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(new File(".//data//outputC.txt")));
        for(int i = 0; i < cases.size(); i++)
        {
            System.out.println("Case #" + (i + 1) + ":");
            for(String sol : cases.get(i).getSolutions().values())
            {
                System.out.println(sol + " " + getDivisors(sol));
            }
            bufferedWriter.write("Case #" + (i + 1) + ":\n");
            for(String sol : cases.get(i).getSolutions().values())
            {
                bufferedWriter.write(sol + " " + getDivisors(sol) + "\n");
            }
        }
        bufferedWriter.close();
    }
    
    class Case
    {        
        private HashMap<String, String> solutions = new HashMap<>();

        public HashMap<String, String> getSolutions() {
            return solutions;
        }

        public void setSolutions(HashMap<String, String> solutions) {
            this.solutions = solutions;
        }

        
        
        private int n, j;

        public int getN() {
            return n;
        }

        public void setN(int n) {
            this.n = n;
        }

        public int getJ() {
            return j;
        }

        public void setJ(int j) {
            this.j = j;
        }

        
    }
}
