import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;


public class War {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		Scanner scanner = new Scanner(new File("D-small-attempt0.in"));
		
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File("D-small-attempt0.out"),false));
		
		int cases = scanner.nextInt();
		scanner.nextLine();
		
		for (int t = 0; t < cases; t++) {
			int n = scanner.nextInt();
			ArrayList<Float> naomi = new ArrayList<Float>(n);
			ArrayList<Float> ken = new ArrayList<Float>(n);
			for (int i = 0; i < n; i++) {
				naomi.add(scanner.nextFloat());
			}
			for (int i = 0; i < n; i++) {
				ken.add(scanner.nextFloat());
			}
			
			Collections.sort(naomi);
			Collections.sort(ken);
			
			int optimalWar = calcOptimalWar(n, naomi, ken);
			int optimalDeceit = calcOptimalDeceit(n, naomi, ken);
			
			writer.write("Case #"+(t+1)+": " + optimalDeceit + " " + optimalWar + "\n");
		}
		
		scanner.close();
		writer.close();
	}

	private static int calcOptimalWar(int n, final ArrayList<Float> naomiOld, final ArrayList<Float> kenOld) {
		ArrayList<Float> naomi = new ArrayList<Float>(n);
		naomi.addAll(naomiOld);
		
		ArrayList<Float> ken = new ArrayList<Float>(n);
		ken.addAll(kenOld);
		
		int scoreNaomi = 0;
		while (naomi.size() > 0) {
			int lastIndex = naomi.size()-1;
			float naomiMinItem = naomi.get(0);
			float kenMaxItem = ken.get(lastIndex);
			
			if (naomiMinItem > kenMaxItem) {
				scoreNaomi += naomi.size();
				break;
			} else {
				for (int i = 0; i < ken.size(); i++) {
					if (ken.get(i) > naomiMinItem) {
						ken.remove(i);
						naomi.remove(0);
						break;
					}
				}
			}
		}
		return scoreNaomi;
	}

	private static int calcOptimalDeceit(int n, ArrayList<Float> naomiOld, ArrayList<Float> kenOld) {
		// Anzahl Paare, sodass Naomi > Ken?
		ArrayList<Float> naomi = new ArrayList<Float>(n);
		naomi.addAll(naomiOld);
		ArrayList<Float> ken = new ArrayList<Float>(n);
		ken.addAll(kenOld);
		int scoreNaomi = 0;
		while(naomi.size() > 0) {
			if (naomi.get(0) > ken.get(0)) {
				scoreNaomi++;
				ken.remove(0);
			}
			naomi.remove(0);
		}
		
		
		/*ArrayList<Float> naomi = new ArrayList<Float>(n);
		naomi.addAll(naomiOld);
		
		ArrayList<Float> ken = new ArrayList<Float>(n);
		ken.addAll(kenOld);
		
		int scoreNaomi = 0;
		while (naomi.size() > 0) {
			int lastIndex = naomi.size()-1;
			float naomiMaxItem = naomi.get(lastIndex);
			float kenMaxItem = ken.get(lastIndex);
			if (kenMaxItem > naomiMaxItem) {
				ken.remove(lastIndex);
			} else {
				ken.remove(0);
				scoreNaomi++;
			}
			naomi.remove(lastIndex);
		}*/
		return scoreNaomi;
	}

}
