import java.io.*;
import java.util.*;
import java.math.*;

class Interval implements Comparable<Interval> {
	int beg, end;
	char p;
	Interval(int a, int b, char s) {
		beg = a; end = b;
		p = s;
	}
	public int compareTo(Interval other) {
		if (beg > other.beg) return 1;
		return -1;
	}
}

class Interval2 implements Comparable<Interval2> {
	int beg, end;
	char p;
	Interval prev, next;
	Interval2(int a, int b, char s, Interval x, Interval y) {
		beg = a; end = b;
		p = s;
		prev = x; next = y;
	}
	public int compareTo(Interval2 other) {
		if (end - beg > other.end - other.beg) return -1;
		return 1;
	}
}

public class Test {
	static Scanner sc = new Scanner(System.in);
	
	void start(int t) {
		int ac = sc.nextInt(), aj = sc.nextInt();
		ArrayList<Interval> day = new ArrayList<Interval>();
		ArrayList<Interval2> left = new ArrayList<Interval2>();
		int timeJ = 0, timeC = 0;
		for (int i = 0; i < ac; i++) {
			int a = sc.nextInt();
			int b = sc.nextInt();
			timeC += b - a;
			day.add(new Interval(a, b, 'c'));
		}
		for (int i = 0; i < aj; i++) {
			int a = sc.nextInt();
			int b = sc.nextInt();
			timeJ += b - a;
			day.add(new Interval(a, b, 'j'));
		}
		Collections.sort(day);
		Interval prev = day.get(0);
		int sw = 0;
		for (int i = 1; i < day.size(); i++) {
			Interval cur = day.get(i);
			if (prev.p != cur.p) sw++;
			else {
				if (cur.p == 'c') timeC += cur.beg - prev.end;
				else timeJ += cur.beg - prev.end;
				left.add(new Interval2(prev.end, cur.beg, '-', prev, cur));
			}
			prev = cur;
		}
		if (day.get(day.size() - 1).p != day.get(0).p) sw++;
		else {
			left.add(new Interval2(day.get(day.size() - 1).end, day.get(0).beg, '-', day.get(day.size() - 1), day.get(0)));
			if (day.get(0).p == 'c') timeC += day.get(0).beg + 24 * 60 - day.get(day.size() - 1).end;
			else timeJ += day.get(0).beg + 24 * 60 - day.get(day.size() - 1).end;
		}
		System.out.print("Case #" + t + ": ");
		boolean done = true;
		char max = 'd';
		int val = 0;
		if (timeJ > 720) {
			max = 'j';
			done = false;
			val = timeJ;
		}
		if (timeC > 720) {
			max = 'c';
			done = false;
			val = timeC;
		}
		Collections.sort(left);
		while (!done) {
			Interval2 x = null;
			for (int i = 0; i < left.size(); i++) {
				if (left.get(i).next.p == max) {
					x = left.get(i);
					left.remove(i);
					break;
				}
			}
			int dur = x.end - x.beg;
			if (dur < 0) dur += 60 * 24;
			if (val - dur <= 720) done = true;
			val -= (dur);
			if (dur != 0) sw+= 2;
		}
		System.out.println(sw);
	}
    
    public static void main(String[] args) {
    	int t = sc.nextInt();
    	for (int i = 0; i < t; i++) new Test().start(i + 1);
    }
}