import java.math.BigInteger;
import java.util.*;

public class coinjam {

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int loopCount = in.nextInt();
		
		for(int lc = 0; lc < loopCount; lc++){
			int length = in.nextInt();
			int numCoins = in.nextInt();
			
			ArrayList<JamCoin> jamcoins = new ArrayList<JamCoin>();
			
			char[] temp = new char[length];
			Arrays.fill(temp, '0');
			temp[0] = temp[length - 1] = '1';
			String coin = new String(temp);
			
			long curNum = Long.parseLong(coin, 2);
			while(jamcoins.size() < numCoins && coin.length() == length){
				JamCoin res = checkJamCoin(coin);
				if(res != null)
					jamcoins.add(res);
				
				curNum += 2;
				coin = Long.toBinaryString(curNum);
			}
			
			System.out.printf("Case #%d:%n", lc + 1);
			for(JamCoin jc : jamcoins)
				System.out.println(jc.toString());
		}
	}
	
	static JamCoin checkJamCoin(String coin){
		JamCoin ret = new JamCoin(coin);
		
		long[] baseNum = new long[9];
		boolean prime = false;
		for(int i = 2; i <= 10; i++){
			baseNum[i - 2] = Long.parseLong(coin, i);
			BigInteger num = new BigInteger(baseNum[i - 2] + "");
			if(num.isProbablePrime(100)){
				prime = true;
				break;
			}
		}
		
		if(!prime){
			for(int i = 0; i < baseNum.length; i++){
				for(int j = 2; j < Math.sqrt(baseNum[i]) + 1; j++)
					if(baseNum[i] % j == 0){
						ret.divisors[i] = j;
						break;
					}
			}
		}
		else
			return null;
		
		return ret;
	}

	static class JamCoin{
		String val;
		int[] divisors;
		
		JamCoin(String v){
			val = v;
			divisors = new int[9];
		}
		
		@Override
		public String toString() {
			String ret = val;
			for(int i = 0; i < divisors.length; i++)
				ret += " " + divisors[i];
			
			return ret;
		}
	}
}
