import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;
import java.util.StringTokenizer;


public class RPI
{
	Scanner in;
	PrintWriter out;
	
	public void run()throws IOException
	{
		in  = new Scanner(new File("rpi.in"));
		out = new PrintWriter("rpi.out");
		
		int nt = in.nextInt();
		in.nextLine();
		for(int it=1;it<=nt;it++)
		{
			out.println("Case #" + it + ":");
			int n = in.nextInt();
			in.nextLine();
			
			int [][] a = new int[n][n];
			for(int i=0;i<n;i++)
			{
				String s = in.nextLine();
				for(int j=0;j<n;j++)
				{
					a[i][j] = s.charAt(j) == '.' ? -1 : (s.charAt(j) == '1' ? 1 : 0);
				}
			}
			
			double [] wp = new double[n];
			Arrays.fill(wp, 0);
			for(int i=0;i<n;i++)
			{
				int ng = 0, nw = 0;
				for(int j=0;j<n;j++)
				{
					if(a[i][j] != -1)
						ng++;
					if(a[i][j] == 1)
						nw++;
				}
				wp[i] = nw / (ng + 0.0);
			}
			
			double [] owp = new double[n];
			Arrays.fill(owp, 0);
			for(int i=0;i<n;i++)
			{
				
				double [] curwp = new double[n];
				Arrays.fill(curwp, 0);
				for(int k=0;k<n;k++)
				{
					if(k == i)
						continue;
					int curng = 0, curnw = 0;
					for(int l=0;l<n;l++)
					{
						if(l == i)
							continue;
						if(a[k][l] != -1)
							curng++;
						if(a[k][l] == 1)
							curnw++;
					}
					curwp[k] = curnw / (curng + 0.0);
				}
				
				double val = 0;
				int ng = 0;
				for(int j=0;j<n;j++)
				{
					if(a[i][j] != -1)
					{
						ng++;
						val += curwp[j];
					}
				}
				owp[i] = val / (ng + 0.0);
			}
			
			double [] oowp = new double[n];
			Arrays.fill(oowp, 0);
			for(int i=0;i<n;i++)
			{
				double val = 0;
				int ng = 0;
				for(int j=0;j<n;j++)
				{
					if(a[i][j] != -1)
					{
						ng++;
						val += owp[j];
					}
				}
				oowp[i] = val / (ng + 0.0);
			}
			
			for(int i=0;i<n;i++)
			{
				out.println(0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i]);
			}
			
			
		}
		out.close();
	}
	
	public static void main(String []args)throws Exception
	{
		new RPI().run();
	}
}
