import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.StringTokenizer;


public class Bot
{
	Scanner in;
	PrintWriter out;
	
	public void run()throws IOException
	{
		in  = new Scanner(new File("bot.in"));
		out = new PrintWriter("bot.out");
		
		int nt = in.nextInt();
		in.nextLine();
		for(int it=1;it<=nt;it++)
		{
			out.print("Case #" + it + ": ");
			
			StringTokenizer st = new StringTokenizer(in.nextLine());
			int n = Integer.parseInt(st.nextToken());
			int [] step = new int[n];
			int [] type = new int[n];
			for(int i=0;i<n;i++)
			{
				type[i] = st.nextToken().equals("B") ? 1 : 2;
				step[i] = Integer.parseInt(st.nextToken());
			}
			
			int next1 = -1, next2 = -1;
			for(int i=0;i<n;i++)
			{
				if(type[i] == 1 && next1 == -1)
					next1 = step[i];
				if(type[i] == 2 && next2 == -1)
					next2 = step[i];
			}
			
			int ret = 0;
			int pos1 = 1, pos2 = 1;
			
			for(int i=0;i<n;i++)
			{
				while(true)
				{
					if(type[i] == 1 && pos1 == next1)
					{
						ret++;
						
						if(next2 != -1)
						{
							if(pos2 < next2)
								pos2++;
							else if(pos2 > next2)
								pos2--;
						}
						
						next1 = -1;
						for(int j=i + 1;j<n;j++)
						{
							if(type[j] == 1 && next1 == -1)
								next1 = step[j];
						}
						break;
					}
					
					if(type[i] == 2 && pos2 == next2)
					{
						ret++;
						
						if(next1 != -1)
						{
							if(pos1 < next1)
								pos1++;
							else if(pos1 > next1)
								pos1--;
						}
						
						next2 = -1;
						for(int j=i + 1;j<n;j++)
						{
							if(type[j] == 2 && next2 == -1)
								next2 = step[j];
						}
						break;
					}
					
					if(next1 != -1)
					{
						if(pos1 < next1)
							pos1++;
						else if(pos1 > next1)
							pos1--;
					}
					
					if(next2 != -1)
					{
						if(pos2 < next2)
							pos2++;
						else if(pos2 > next2)
							pos2--;
					}
					
					ret++;
				}
			}
			
			out.println(ret);
		}
		out.close();
	}
	
	public static void main(String []args)throws Exception
	{
		new Bot().run();
	}
}
