import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Round1C
{
	int MAX = 256;
	
	private boolean correct(int n, int [] a, int [] p)
	{
		boolean [][] f = new boolean[n + 1][MAX];
		f[0][1] = true;
		for(int k=0;k<n;k++)
		{
			for(int i=0;i<MAX;i++)
			{
				if(!f[k][i])
					continue;
				
				if(i * a[k] < MAX)
					f[k + 1][i * a[k]] = true;
				
				f[k + 1][i] = true;
			}
		}
		for(int i=0;i<p.length;i++)
			if(!f[n][p[i]])
				return false;
		return true;
	}
	
	private int [] res;
	
	private void rec(int i, int n, int m, int [] a, int [] p)
	{
		if(res != null)
			return;
		
		if(i == n)
		{
			if(correct(n, a, p))
			{
				res = new int[n];
				System.arraycopy(a, 0, res, 0, n);
			}
			return;
		}
		
		for(int j=2;j<=m;j++)
		{
			a[i] = j;
			rec(i + 1, n, m, a, p);
		}
	}

	public void run()throws IOException
	{
		Scanner in = new Scanner(new File("c.in"));
		PrintWriter out = new PrintWriter("c.out");
		int nt = in.nextInt();
		for(int it = 1;it <= nt; it++)
		{
			out.println("Case #" + it + ":");
			
			int r = in.nextInt(), n = in.nextInt(), m = in.nextInt(), k = in.nextInt();
			for(int q=0;q<r;q++)
			{
				int [] p = new int[k];
				for(int i=0;i<k;i++)
					p[i] = in.nextInt();
				
				res = null;
				
				int [] a = new int[n];
				
				rec(0, n, m, a, p);
				
				if(res != null)
				{
					for(int i=0;i<n;i++)
						out.print(res[i]);
					out.println();
				}
			}
		}
		out.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args)throws IOException
	{
		new Round1C().run();
	}

}
