import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Random;
import java.util.Scanner;


public class Qual1C
{
	private Random r = new Random();
	
	private int getDiv(long k)
	{
		int c = (int)Math.sqrt(k);
		for(int i=2;i<=c;i++)
			if(k % i == 0)
				return i;
		return -1;
	}
	
	private int [] check(boolean [] a)
	{
		int [] divs = new int[9];
		for(int b=2;b<=10;b++)
		{
			long n = 0;
			for(int i=0;i<a.length;i++)
				n = n * (long)b + (a[i] ? 1 : 0);
			
			divs[b - 2] = getDiv(n);
			if(divs[b - 2] == -1)
				return null;
		}
		return divs;
	}
	
	private void rec(int i, boolean [] a, List<boolean[]> listNumbers, int m)
	{
		if(listNumbers.size() == m)
			return;
		if(i == a.length - 1)
		{
			if(check(a) != null)
			{
				boolean [] b = new boolean[a.length];
				for(int j=0;j<a.length;j++)
					b[j] = a[j];
				listNumbers.add(b);
			}
			return;
		}
		boolean q = r.nextBoolean();
		a[i] = q;
		rec(i + 1, a, listNumbers, m);
		a[i] = !q;
		rec(i + 1, a, listNumbers, m);
	}
	
	public void run()throws IOException
	{
		Scanner in = new Scanner(new File("c.in"));
		PrintWriter out = new PrintWriter("c.out");
		int nt = in.nextInt();
		for(int it = 1;it <= nt; it++)
		{
			int n = in.nextInt(), m = in.nextInt();
			
			boolean [] a = new boolean[n];
			Arrays.fill(a, false);
			a[0] = a[n - 1] = true;
			List<boolean[]> listNumbers = new ArrayList<boolean[]>();
			rec(1, a, listNumbers, m);
			
			out.println("Case #" + it + ":");
			for(boolean [] b : listNumbers)
			{
				for(int j=0;j<b.length;j++)
					out.print(b[j] ? 1 : 0);
				int [] divs = check(b);
				for(int j=0;j<divs.length;j++)
					out.print(" " + divs[j]);
				out.println();
			}
		}
		out.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args)throws IOException
	{
		new Qual1C().run();
	}

}
