import java.io.*;

public class Boundarizer {

    private long from;
    private long to;
    private int palindromes;

    private long powers_10[] = new long[19];

    public Boundarizer() {
        long base = 1;
        for(int i=0;i<powers_10.length;i++) {
            powers_10[i] = base;
            base *= 10;
        }
    }

    private long solve() {
        // unsafe but true
        long checkStart = (long) Math.sqrt(from);
        long checkEnd = (long)Math.ceil(Math.sqrt(to));
        palindromes = 0;

/*
        for(long current = checkStart;current<=checkEnd;current++) {
            if (isPalindrome(current)) {
                long square = current * current;
                if (square>=from) {
                    if (square>to) break;
                    if (isPalindrome(current*current)) palindromes++;
                }
            }
        }
*/
        generatePolyss(checkStart, checkEnd);

        return palindromes;
    }

    private void generatePolyss(long from, long to) {
        // digits in star
        int sizeFrom = digits(from);
        long cend;
        do {
            long cstart = powers_10[sizeFrom-1];
            cend = powers_10[sizeFrom]-1;
            if (cstart<from) cstart = from;
            if (cend>to) {
                cend = to;
            }
            generatePolys(cstart, cend, sizeFrom);
            sizeFrom++;
        } while(cend<to);
    }

    private static int digits(long rest) {
        // doubles and Math, huh?
        int size = 0;
        while(rest>0) {
            size++;
            rest = rest / 10;
        }
        return size;
    }

    // only works if counters have same number of digits
    private void generatePolys(long from, long to, int size) {
        //System.out.println("From : " + from + " To : " + to);
        int half = size/2;
        long base = from/powers_10[half];
        long end = to/powers_10[half]+1;
        int startInd = 0;
        if (size%2==1) {
            half++;
            startInd++;
        }
        while(base<end) {
            long result = base;
            for(int i=startInd;i<half;i++) {
                result = result * 10 + (base % powers_10[i+1])/powers_10[i];
            }
            if (result>to) break;
            if (checkPaliInRange(result)) palindromes++;
            base++;
        }
    }

    private boolean checkPaliInRange(long current) {
        long square = current * current;
        return square>=from && square<=to && isPalindrome(square);
    }

    private boolean isPalindrome(long value) {
        String string = Long.toString(value);
        int len = string.length()/2;
        int full = string.length()-1;
        for(int i=0;i<len;i++) {
            if (string.charAt(i)!=string.charAt(full-i)) return false;
        }
        return true;
    }

    private void solveAll(InputStream in, PrintStream out) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(in));
        int cases = Integer.parseInt(reader.readLine());
        for(int i=0;i<cases;i++) {
            long[] sizes = readIntLine(reader.readLine());
            from = sizes[0];
            to = sizes[1];
            out.println("Case #" + (i + 1) + ": " + solve());
        }
    }

    private long[] readIntLine(String line) {
        String[] parts = line.split(" ");
        long[] result = new long[parts.length];
        for(int i=0;i<parts.length;i++) {
            result[i] = Long.parseLong(parts[i]);
        }
        return result;
    }

    public static void main(String[] args) throws Exception {
        InputStream in;
        PrintStream out;
        if (args.length>0) {
            in = new FileInputStream(args[0]);
        } else {
            in = System.in;
        }
        if (args.length>1) {
            out = new PrintStream(new FileOutputStream(args[1]));
        } else {
            out = System.out;
        }
        new Boundarizer().solveAll(in, out);
    }

}
