import java.io.*;
import java.util.Arrays;

/**
 *
 */
public class KosarsFriend {

    int width;
    int height;
    int [][] field;
    int []maxColumn;
    int []maxRow;

    // transient
    private PrintStream out;

    private boolean solve() {
//        System.out.println("Debug solve:");
        maxColumn = new int[width];

        for(int x=0;x<width;x++) {
            int max = 0;
            for(int y=0;y<height;y++) {
                max = Math.max(max, field[y][x]);
            }
            maxColumn[x] = max;
        }

//        System.out.println("Max columns:" + Arrays.toString(maxColumn));

        maxRow = new int[height];
        for(int y=0;y<height;y++) {
            int max = 0;
            for(int x=0;x<width;x++) {
                max = Math.max(max, field[y][x]);
            }
            maxRow[y] = max;
        }

//        System.out.println("Max rows:" + Arrays.toString(maxRow));

        for(int y=0;y<height;y++) {
            for(int x=0;x<width;x++) {
                if (field[y][x]!=Math.min(maxColumn[x],maxRow[y])) {
                    return false;
                }
            }
        }

        return true;
    }

    public void solveAll(InputStream in, PrintStream out) throws IOException {
        this.out = out;
        BufferedReader reader = new BufferedReader(new InputStreamReader(in));
        int cases = Integer.parseInt(reader.readLine());
        for(int i=0;i<cases;i++) {
            int[] sizes = readIntLine(reader.readLine());
            width = sizes[1];
            height = sizes[0];
            field = new int[height][];
            for(int j=0;j<height;j++) {
                field[j] = readIntLine(reader.readLine());
            }
            out.println("Case #" + (i + 1) + ": " + (solve() ? "YES" : "NO"));

        }
    }

    private int[] readIntLine(String line) {
        String[] parts = line.split(" ");
        int[] result = new int[parts.length];
        for(int i=0;i<parts.length;i++) {
            result[i] = Integer.parseInt(parts[i]);
        }
        return result;
    }

    public static void main(String[] args) throws Exception {
        InputStream in;
        PrintStream out;
        if (args.length>0) {
            in = new FileInputStream(args[0]);
        } else {
            in = System.in;
        }
        if (args.length>1) {
            out = new PrintStream(new FileOutputStream(args[1]));
        } else {
            out = System.out;
        }
        new KosarsFriend().solveAll(in, out);
    }
}
