import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
	FileScanner in;
	PrintWriter out;
	String Filename = "C";

	public static void main(String[] args) throws Exception {
		new Main().run();
	}

	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new FileScanner(Filename + ".in");
		out = new PrintWriter(Filename + ".out");

		solve();

		out.close();
	}
	
	int maxSum;
	int sum1;
	int sum1Int;
	int sum2;
	int sum2Int;
	
	int n;
	int[] candy;
	
	void solve() throws Exception {
		int t = in.nextInt();
		
		for (int i = 0; i < t; i++) {
			n = in.nextInt();
			candy = new int[n];
			
			for (int j = 0; j < n; j++) {
				candy[j] = in.nextInt();
			}
			
			maxSum = 0;
			sum1 = candy[0];
			sum1Int = sum1;
			sum2 = 0;
			sum2Int = 0;
			for (int j = 1; j < n; j++) {
				sum2 = add(sum2, candy[j]);
				sum2Int += candy[j];
			}
			
			allSums(1);
			
			
			out.print("Case #" + (i + 1) + ": ");
			if (maxSum > 0) {
				out.println(maxSum);
				continue;
			}
			
			out.println("NO");
		}
		
	}
	
	void allSums(int j) {
		if ((sum1 == sum2) && (sum1Int != 0) && (sum2Int != 0)) {
			maxSum = Math.max(maxSum, sum1Int);
			maxSum = Math.max(maxSum, sum2Int);
		}
		
		for (int i = j; i < n; i++) {
			sum1 = add(sum1, candy[i]);
			sum2 = add(sum2, candy[i]);
			sum1Int += candy[i];
			sum2Int -= candy[i];
			allSums(i + 1);
			sum1 = add(sum1, candy[i]);
			sum2 = add(sum2, candy[i]);
			sum1Int -= candy[i];
			sum2Int += candy[i];
		}
	}
	
	int add(int x, int y) {
		int base = 1;
		int res = 0;
		while (base <= Math.max(x, y)) {
			int a = 0;
			int b = 0;
			
			if ((x % (base * 2)) > 0) {
				a = 1;
				x = x - (x % (base * 2));
			}
			
			if ((y % (base * 2)) > 0) {
				b = 1;
				y = y - (y % (base * 2));
			}
			
			if (a == b) {
				a = 0;
			} else {
				a = 1;
			}
			
			res += a * base;
			base = base * 2;
		}
		
		return res;
	}
}

class FileScanner {
	BufferedReader br;
	StringTokenizer st;

	public FileScanner(String File) throws Exception {
		br = new BufferedReader(new FileReader(File));
	}

	String next() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(next());
	}
}