import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
	FileScanner in;
	PrintWriter out;
	String Filename = "A";

	public static void main(String[] args) throws Exception {
		new Main().run();
	}

	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new FileScanner(Filename + ".in");
		out = new PrintWriter(Filename + ".out");

		solve();

		out.close();
	}
	
	class queue {
		int[] q;
		int first;
		int last;
		
		queue(int n) {
			q = new int[n];
			first = 0;
			last = -1;
		}
		
		void push(int x) {
			last++;
			q[last] = x;
		}
		
		void pop() {
			if (last >= first) {
				first++;
			}
		}
		
		int get() {
			return q[first];
		}
	}
	
	void solve() throws Exception {
		int t = in.nextInt();
		
		for (int i = 0; i < t; i++) {
			int n = in.nextInt();
			
			queue orange = new queue(n);
			queue blue = new queue(n);
			queue mainQ = new queue(n);
			String s;
			int x;
			
			for (int j = 0; j < n; j ++) {
				s = in.next();
				x = in. nextInt();
				
				if (s.charAt(0) == 'O') {
					mainQ.push(0);
					orange.push(x);
				} else {
					mainQ.push(1);
					blue.push(x);
				}
			}
			
			int time = 0;
			int oStep = 1;
			int bStep = 1;
			
			while (mainQ.last >= mainQ.first) {
				if (mainQ.get() == 0) {
					int mainStep = Math.abs(oStep - orange.get());
					int step = Math.abs(bStep - blue.get());
					oStep = orange.get();
					
					if (mainStep + 1 < step) {
						if (blue.get() > bStep) {
							bStep += mainStep + 1;
						} else {
							bStep -= mainStep + 1;
						}
					} else {
						bStep = blue.get();
					}
					
					time += mainStep + 1;
					
					mainQ.pop();
					orange.pop();
					continue;
				}
				
				
				int mainStep = Math.abs(bStep - blue.get());
				int step = Math.abs(oStep - orange.get());
				bStep = blue.get();
				
				if (mainStep + 1 < step) {
					if (orange.get() > oStep) {
						oStep += mainStep + 1;
					} else {
						oStep -= mainStep + 1;
					}
				} else {
					oStep = orange.get();
				}
				
				time += mainStep + 1;
				
				mainQ.pop();
				blue.pop();
			}
			out.println("Case #" + (i + 1) + ": " + time);
		}
	}
}

class FileScanner {
	BufferedReader br;
	StringTokenizer st;

	public FileScanner(String File) throws Exception {
		br = new BufferedReader(new FileReader(File));
	}

	String next() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(next());
	}
}