import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.StringTokenizer;

public class Main {
	FileScanner in;
	PrintWriter out;
	String Filename = "B";

	public static void main(String[] args) throws Exception {
		new Main().run();
	}

	public void run() throws Exception {
		Locale.setDefault(Locale.US);
		in = new FileScanner(Filename + ".in");
		out = new PrintWriter(Filename + ".out");

		solve();

		out.close();
	}
	class element {
		char letter;
		char[][] combine;
		int comSize;
		char[] delete;
		int delSize;
		
		element(char a) {
			letter = a;
			delete = new char[8];
			combine = new char[8][2];
			comSize = 0;
			delSize = 0;
		}
	}
	element[] letters;
	char[] list;
	int last;
	
	void solve() throws Exception {
		int t = in.nextInt();
		
		for (int i = 0; i < t; i++) {
			letters = new element[8];
			int c = in.nextInt();
			for (int j = 0; j < c; j++) {
				String s = in.next();
				add(s.charAt(0), s.charAt(1), s.charAt(2));
				add(s.charAt(1), s.charAt(0), s.charAt(2));
			}
			
			int d = in.nextInt();
			for (int j = 0; j < d; j++) {
				String s = in.next();
				add(s.charAt(0), s.charAt(1));
				add(s.charAt(1), s.charAt(0));
			}
			
			int n = in.nextInt();
			String s = in.next();
			list = new char[n];
			last = -1;
			
			for (int j = 0; j < n; j++) {
				char a = s.charAt(j);
				if (last < 0) {
					last++;
					list[last] = a;
					continue;
				}
				
				if (findC(a)) {
					continue;
				}
				
				int k = last;
				boolean flag = false;
				while (k != -1) {
					if (findD(list[k], a)) {
						last = - 1;
						flag = true;
						break;
					}
					k--;
				}
				
				if (!flag) {
					last++;
					list[last] = a;
				}
			}
			
			out.print("Case #" + (i + 1) + ": [");
			for (int j = 0; j < last; j++) {
				out.print(list[j] + ", ");
			}
			if (last > -1) {
				out.print(list[last]);
			}
			out.println("]");
		}
	}
	
	void add(char a, char b, char c) {
		int i = 0;
		while ((letters[i] != null) && (letters[i].letter != a)) {
			i++;
		}
		
		if (letters[i] == null) {
			letters[i] = new element(a);
		}
		letters[i].comSize++;
		
		int k = letters[i].comSize - 1;
		letters[i].combine[k][0] = b;
		letters[i].combine[k][1] = c;
	}
	
	void add(char a, char b) {
		int i = 0;
		while ((letters[i] != null) && (letters[i].letter != a)) {
			i++;
		}
		
		if (letters[i] == null) {
			letters[i] = new element(a);
		}
		
		letters[i].delSize++;
		
		int k = letters[i].delSize - 1;
		letters[i].delete[k] = b;
	}
	
	boolean findC(char a) {
		int i = 0;
		while ((i < 8) && (letters[i] != null) && (letters[i].letter != a)) {
			i++;
		}
		
		if ((i >= 8) || (letters[i] == null)) {
			return false;
		}
		
		for (int j = 0; j < letters[i].comSize; j++) {
			if (letters[i].combine[j][0] == list[last]) {
				list[last] = letters[i].combine[j][1];
				return true;
			}
		}
		
		return false;
	}
	
	boolean findD(char a, char b) {
		int i = 0;
		while ((i < 8) && (letters[i] != null) && (letters[i].letter != a)) {
			i++;
		}
		
		if ((i >= 8) || (letters[i] == null)) {
			return false;
		}
		
		for (int j = 0; j < letters[i].delSize; j++) {
			if (letters[i].delete[j] == b) {
				return true;
			}
		}
		
		return false;
	}
}

class FileScanner {
	BufferedReader br;
	StringTokenizer st;

	public FileScanner(String File) throws Exception {
		br = new BufferedReader(new FileReader(File));
	}

	String next() throws Exception {
		while (st == null || !st.hasMoreTokens()) {
			st = new StringTokenizer(br.readLine());
		}
		return st.nextToken();
	}

	public int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	public long nextLong() throws Exception {
		return Long.parseLong(next());
	}
}