import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

/**
 * Created by Anthony on 4/10/2015.
 */
public class OminousOmino {

	private BufferedWriter bw;
	private BufferedReader br;
	private Case[] cases;

	public OminousOmino(String fileName) throws IOException {
		FileReader fr = new FileReader(new File(fileName+".in"));
		br = new BufferedReader(fr);
		FileWriter fw = new FileWriter(fileName + ".out");
		bw = new BufferedWriter(fw);

		cases = new Case[Integer.parseInt(br.readLine())];
		for(int i = 0; i < cases.length; i++) {
			String[] str = br.readLine().split(" ");
			cases[i] = new Case(Integer.parseInt(str[0]),Integer.parseInt(str[1]),Integer.parseInt(str[2]));
		}
	}

	private class Case {
		private int ominosz;
		private int x;
		private int y;
		public Case(int size,int x, int y) {
			this.ominosz = size;
			this.x = x;
			this.y = y;
		}

		public String win() {
			boolean lose = false;

			if(ominosz > x && ominosz > y) lose = true;
			if((x*y) % ominosz != 0) lose = true;
			if((ominosz + 1)/2 > x) lose = true;
			if((ominosz + 1)/2 > y) lose = true;
			if(ominosz >= 7) lose = true;
			if(ominosz >= 4 && x <= ominosz-2 && y/2 * x <= ominosz) lose = true;
			if(ominosz >= 4 && y <= ominosz-2 && x/2 * y <= ominosz) lose = true;

			if(lose) return "RICHARD";
			else return "GABRIEL";
		}
	}

	public void result() throws IOException {
		for(int i = 0; i < cases.length; i++) {
			bw.write("Case #" + (i+1) + ": " + cases[i].win() + "\n");
		}
		br.close();
		bw.close();
	}

	public static void main(String[] args) throws IOException {
		OminousOmino rt = new OminousOmino("D-large");
		rt.result();
	}
}
