import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 * Created by Anthony on 4/10/2015.
 */
public class StandingOvation {

	private BufferedWriter bw;
	private BufferedReader br;
	private Case[] cases;

	public StandingOvation(String fileName) throws IOException {
		FileReader fr = new FileReader(new File(fileName+".in"));
		br = new BufferedReader(fr);
		FileWriter fw = new FileWriter(fileName + ".out");
		bw = new BufferedWriter(fw);

		cases = new Case[Integer.parseInt(br.readLine())];
		for(int i = 0; i < cases.length; i++) {
			String[] str = br.readLine().split(" ");

			int highestShy = Integer.parseInt(str[0]);
			int[] people = new int[highestShy+1];
			for(int j = 0; j < people.length; j++) {
				people[j] = Character.getNumericValue(str[1].charAt(j));
			}
			cases[i] = new Case(people);
		}
	}

	private class Case {
		private int[] people;

		public Case(int[] people) {
			this.people = people;
		}

		public int[] getPeople(){
			return people;
		}

		public String toString(){
			String str = "";
			for(int e: people)
				str += e;
			return str;
		}
	}

	public void minBuddies() throws IOException {
		for(int i = 0; i < cases.length; i++) {
			int[] t = cases[i].getPeople();
			int sum = t[0];
			int friends = 0;
			for(int j = 1; j < t.length; j++) {
				if(j > sum) {
					friends += j-sum;
					sum += j-sum;
				}
				sum += t[j];
			}

			bw.write("Case #" + (i + 1) + ": " + friends + "\n");
		}
		br.close();
		bw.close();
	}

	public static void main(String[] args) throws IOException {
		StandingOvation rt = new StandingOvation("A-small-attempt0");
		rt.minBuddies();
	}
}
