package c1a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

/**
 * Created by Anthony on 4/17/2015.
 */
public class MushroomMonster {

	private BufferedWriter bw;
	private BufferedReader br;
	private Case[] cases;

	public MushroomMonster(String fileName) throws IOException {
		FileReader fr = new FileReader(new File(fileName + ".in"));
		br = new BufferedReader(fr);
		FileWriter fw = new FileWriter(fileName + ".out");
		bw = new BufferedWriter(fw);

		cases = new Case[Integer.parseInt(br.readLine())];
		for (int i = 0; i < cases.length; i++) {
			int[] mushrooms = new int[Integer.parseInt(br.readLine())];
			String[] str = br.readLine().split(" ");
			for(int j = 0; j < mushrooms.length; j++) {
				mushrooms[j] = Integer.parseInt(str[j]);
			}

			cases[i] = new Case(mushrooms);
		}
	}

	private class Case {
		private int[] mushrooms;

		public Case(int[] mushrooms) {
			this.mushrooms = mushrooms;
		}

		public int[] optimize() {
			int y = 0;
			int z = 0;
			int c = 0;

			int[] mushrooms1 = new int[mushrooms.length];
			System.arraycopy(mushrooms, 0, mushrooms1, 0, mushrooms.length);

			for(int i = 1; i < mushrooms1.length; i++) {
				if(mushrooms1[i] < mushrooms1[i-1]) {
					int x = mushrooms1[i-1] - mushrooms1[i];
					y += x;
					if(x > c) c = x;
				}
			}

			System.arraycopy(mushrooms, 0, mushrooms1, 0, mushrooms.length);

			for(int i = 0; i < mushrooms1.length - 1; i++) {
				int a = mushrooms1[i];
				mushrooms1[i] -= c;
				if(mushrooms1[i] < 0) mushrooms1[i] = 0;

				z += (a - mushrooms1[i]);
			}

			return new int[] {y, z};
		}
	}

	public void result() throws IOException {
		for(int i = 0; i < cases.length; i++) {//cases.length; i++) {
			int[] a = cases[i].optimize();
			bw.write("Case #" + (i + 1) + ": " + a[0] + " " + a[1] +"\n");
		}
		br.close();
		bw.close();
	}

	public static void main(String[] args) throws IOException {
		MushroomMonster rt = new MushroomMonster("A-small-attempt0");
		rt.result();
	}
}
