import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;

/**
 * Created by Anthony on 4/10/2015.
 */
public class HouseOfPancakes {

	private BufferedWriter bw;
	private BufferedReader br;
	private Case[] cases;

	public HouseOfPancakes(String fileName) throws IOException {
		FileReader fr = new FileReader(new File(fileName+".in"));
		br = new BufferedReader(fr);
		FileWriter fw = new FileWriter(fileName + ".out");
		bw = new BufferedWriter(fw);

		cases = new Case[Integer.parseInt(br.readLine())];
		for(int i = 0; i < cases.length; i++) {
			br.readLine();
			ArrayList<Integer> arr = new ArrayList<Integer>();
			String[] str = br.readLine().split(" ");
			for(int j = 0; j < str.length; j++) {
				arr.add(Integer.parseInt(str[j]));
			}
			cases[i] = new Case(arr);
		}
	}

	private class Case {
		private ArrayList<Integer> pancake;
		public Case(ArrayList<Integer> pancake) {
			this.pancake = pancake;
		}

		public int optimize() {
			int T = 0;
			int minT;
			int max = Integer.MIN_VALUE;

			for(int e: pancake)
				if(max < e) max = e;
			minT = max;

			for(int e: pancake) System.out.print(e); System.out.println();

			while (max >= 2) {
				T++;
				pancake.set(pancake.indexOf(max), max/2);
				pancake.add(max-(max/2));
				max = Integer.MIN_VALUE;
				for(int e: pancake)
					if(max < e) max = e;
				if(T+max < minT)
					minT = T+max;
			}

			return minT;
		}
	}

	public void result() throws IOException {
		for(int i = 0; i < cases.length; i++) {//cases.length; i++) {
			bw.write("Case #" + (i+1) + ": " + cases[i].optimize() + "\n");
		}
		br.close();
		bw.close();
	}

	public static void main(String[] args) throws IOException {
		HouseOfPancakes rt = new HouseOfPancakes("B-small-attempt4");
		rt.result();
	}
}
