package RPI;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Vector;

public class Main {

	public static final byte WIN = 1;
	public static final byte LOOSE = 0;
	public static final byte NOT_PLAYED = 2;
	
    public static void main(String [] args) {
        String testCase;
        long count=0;
            
        try {
            FileWriter fstream1 = new FileWriter("out.txt");
            BufferedWriter out = new BufferedWriter(fstream1);
            
            FileInputStream fstream = new FileInputStream(args[0]);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader reader = new BufferedReader(new InputStreamReader(in));
            
            count = Long.parseLong(reader.readLine());
            for (int i = 0; i<count; i++) {
                testCase = reader.readLine();
                
                int numberOfTeams = Integer.parseInt(testCase);
                Vector<Vector<Byte>> teams = new Vector<Vector<Byte>>();
                for (int j=0; j<numberOfTeams; j++) {
                	String input = reader.readLine();
                	Vector<Byte> seq = new Vector<Byte>();
                	for (int k=0; k<numberOfTeams; k++) {
                		if (input.charAt(k) == '0') {
                			seq.add(LOOSE);
                		} else if (input.charAt(k) == '1') {
                			seq.add(WIN);
                		} else {
                			seq.add(NOT_PLAYED);
                		}
                	}
                	teams.add(seq);
                }
                //System.out.println("Case #"+(i+1)+": " + getResult(teams);
                out.write("Case #"+(i+1)+":\n");
                Vector<Double> result = getResult(teams);
                for (int j = 0; j<result.size(); j++) {
                	out.write(""+result.elementAt(j) + "\n");
                }
            }
            
            out.close();
        } catch(IOException e) {
            e.printStackTrace();
        }
    }
    
    public static Vector<Double> getResult(Vector<Vector<Byte>> input) {

    	Vector<Double> wp = new Vector<Double>();
    	Vector<Double> won = new Vector<Double>();;
    	Vector<Double> played = new Vector<Double>();
    	Vector<Vector<Integer>> playedWith = new Vector<Vector<Integer>>();
    	Vector<Double> ripReturn = new Vector<Double>();
    	
    	for (int i=0; i<input.size(); i++) {
    		double playedGames = 0;
    		double wonGames = 0;
    		double lostGames = 0;
    		Vector<Integer> playedWithTeams = new Vector<Integer>();

    		for (int j=0; j<input.size(); j++) {
    			if (input.elementAt(i).elementAt(j) != NOT_PLAYED) {
    				playedGames++;
    				playedWithTeams.add(j);
    			}
    			if (input.elementAt(i).elementAt(j) == WIN) {
    				wonGames++;
    			}
    			if (input.elementAt(i).elementAt(j) == LOOSE) {
    				lostGames++;
    			}
    		}
    		wp.add(wonGames / playedGames);
    		won.add(wonGames);
    		played.add(playedGames);
    		playedWith.add(playedWithTeams);
    	}
    	
    	for (int i=0; i<input.size(); i++) {
    		double averageOWP = 0;
    		double averageOOWP = 0;
    		Vector<Double> owp = new Vector<Double>();
    		for (int j=0; j<playedWith.elementAt(i).size(); j++) {
    			double averageOaverageOWP = 0;
    			
    			if (input.elementAt(i).elementAt(playedWith.elementAt(i).elementAt(j)) == LOOSE) {
    				averageOWP = averageOWP + ((won.elementAt(playedWith.elementAt(i).elementAt(j))-1)/(played.elementAt(playedWith.elementAt(i).elementAt(j))-1));
    			} else {
    				averageOWP = averageOWP + ((won.elementAt(playedWith.elementAt(i).elementAt(j)))/(played.elementAt(playedWith.elementAt(i).elementAt(j))-1));
    			}
    			for (int k=0; k<playedWith.elementAt(playedWith.elementAt(i).elementAt(j)).size(); k++) {
    				if (input.elementAt(playedWith.elementAt(i).elementAt(j)).elementAt(playedWith.elementAt(playedWith.elementAt(i).elementAt(j)).elementAt(k)) == LOOSE) {
    					averageOaverageOWP = averageOaverageOWP + ((won.elementAt(playedWith.elementAt(playedWith.elementAt(i).elementAt(j)).elementAt(k))-1)/(played.elementAt(playedWith.elementAt(playedWith.elementAt(i).elementAt(j)).elementAt(k))-1));
        			} else {
        				averageOaverageOWP = averageOaverageOWP + ((won.elementAt(playedWith.elementAt(playedWith.elementAt(i).elementAt(j)).elementAt(k)))/(played.elementAt(playedWith.elementAt(playedWith.elementAt(i).elementAt(j)).elementAt(k))-1));
        			}
    			}
    			averageOOWP = averageOOWP + averageOaverageOWP / playedWith.elementAt(playedWith.elementAt(i).elementAt(j)).size();
    			
    		}
    		double rip = 0.25 * wp.elementAt(i) + 0.5 * averageOWP/playedWith.elementAt(i).size() + 0.25 * averageOOWP/playedWith.elementAt(i).size();
    		ripReturn.add(rip);
    	}
    	
    	return ripReturn;
    }
}

