package SquareTiles;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Vector;

public class Main {

	public static final byte BLUE = 1;
	public static final byte WHITE = 0;
	
    public static void main(String [] args) {
        String testCase;
        long count=0;
            
        try {
            FileWriter fstream1 = new FileWriter("out.txt");
            BufferedWriter out = new BufferedWriter(fstream1);
            
            FileInputStream fstream = new FileInputStream(args[0]);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader reader = new BufferedReader(new InputStreamReader(in));
            
            count = Long.parseLong(reader.readLine());
            for (int i = 0; i<count; i++) {
                String line = reader.readLine();
                int r = Integer.parseInt(line.split(" ")[0]);
                int c = Integer.parseInt(line.split(" ")[1]);
                
                Vector<Vector<Byte>> pic = new Vector<Vector<Byte>>();
                for (int j=0; j<r; j++) {
                	String input = reader.readLine();
                	Vector<Byte> seq = new Vector<Byte>();
                	for (int k=0; k<c; k++) {
                		if (input.charAt(k) == '.') {
                			seq.add(WHITE);
                		} else {
                			seq.add(BLUE);
                		}
                	}
                	pic.add(seq);
                }
                //System.out.println(pic);
                //System.exit(0);
                //System.out.println("Case #"+(i+1)+": " + getResult(teams);
                out.write("Case #"+(i+1)+":\n");
                Vector<String> result = getResult(pic, r, c);
                for (int j = 0; j<result.size(); j++) {
                	out.write(""+result.elementAt(j) + "\n");
                }
            }
            
            out.close();
        } catch(IOException e) {
            e.printStackTrace();
        }
    }
    
    public static Vector<String> getResult(Vector<Vector<Byte>> pic, int r, int c) {

    	Vector<String> output = new Vector<String>();
    	Vector<Integer> nextLineBlue = new Vector<Integer>();
    	boolean impossible = false;
    	
    	for (int i=0; i<r; i++) {
    		String line = "";
    		boolean nextBlue = false;
    		boolean thisRowBlue = false;
    		
    		for (int k=0; k<c; k++) {
    			impossible = false;
    			if (pic.elementAt(i).elementAt(k) == WHITE) {
    				if (nextLineBlue.contains(k)) {
    					impossible = true;
    					break;
    				}
    				if (nextBlue) {
    					impossible = true;
    					break;
    				}
    				line = line + ".";
    			} else {
    				if (!nextBlue) {
    					if (k == (c-1)) {
    						impossible = true;
    						break;
    					} else if (nextLineBlue.contains(k)) {
    						line = line + "\\";
    						thisRowBlue = true;
    						nextBlue = true;
    					} else {
    						if (i == (r-1)) {
    							impossible = true;
    							break;
    						}
	    					line = line + "/";
	    					nextBlue = true;
	    					nextLineBlue.add(k);
    					}
    				} else {
    					if (nextLineBlue.contains(k)) {
    						impossible = true;
    						break;
    					} if (thisRowBlue) {
    						line = line + "/";
    						nextBlue = false;
    						nextLineBlue.remove(new Integer(k-1));
    						thisRowBlue = false;
    					} else {
    						line = line + "\\";
    						nextBlue = false;
    					}
    				}
    			}
    		}
    		output.add(line);
    		if (impossible) {
    			break;
    		}
    	}
    	
    	if (impossible) {
    		Vector<String> impossibleString = new Vector<String>();
    		impossibleString.add("Impossible");
    		return impossibleString;
    	} else {
    		return output;
    	}
    }
}

