import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.List;

public class MainClass {

	public static final String PATH_FILE = "C:/Temp/";

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		try {

			// Open the file that is the first
			// command line parameter
			FileInputStream fstream = new FileInputStream(PATH_FILE
					+ "A-small-attempt0.in");

			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));

			String strLine = br.readLine();

			int numOfTestCase = Integer.parseInt(strLine);

			if ((numOfTestCase >= 1) && (numOfTestCase <= 10)) {

				for (int i = 1; i <= numOfTestCase; i++) {

					String[][] board = new String[4][4];

					for (int j = 0; j < 4; j++) {

						String lineStr = br.readLine();

						board[j] = lineStr.split("(?!^)");
					}

					boolean isWinner = false;
					boolean isComplete = true;
					String[][] tranposeBoard = transposeBoard(board);

					for (int j = 0; j < 4; j++) {

						String[] lineX = board[j];
						List<String> lineA = Arrays.asList(tranposeBoard[j]);
						String[] lineY = tranposeBoard[j];

						String letter = getLetter(lineX);
						if (isThereARow(lineX, getLetter(lineX))) {

							isWinner = true;
							System.out.println("Case #" + i + ": "+ letter + " won");
						}

						if (!isWinner) {

							letter = getLetter(lineY);
							if (isThereARow(lineY, letter)) {

								isWinner = true;
								System.out.println("Case #" + i + ": "+ letter + " won");

							} else if (lineA.contains(".")) {

								isComplete = false;
								lineA = null;
							}

							if (!isWinner) {

								String[] diagonalLine1 = new String[4];
								String[] diagonalLine2 = new String[4];

								for (int k = 0; k < 4; k++) {

									diagonalLine1[k] = board[k][k];
									diagonalLine2[k] = board[k][3 - k];

								}

								letter = getLetter(diagonalLine1);
								if (isThereARow(diagonalLine1, letter)) {

									isWinner = true;
									System.out.println("Case #" + i + ": "+ letter + " won");

								} else {
									letter = getLetter(diagonalLine2);
									if (isThereARow(diagonalLine2, letter)) {

										isWinner = true;
										System.out.println("Case #" + i + ": "+ letter + " won");
									}
								}
							}
						} else {

							break;
						}
					}
					if (!isWinner) {
						if (isComplete) {
							System.out.println("Case #" + i + ": Draw");
//							break;
						} else {
							System.out.println("Case #" + i + ": Game has not completed");
//							break;
						}
					}
					// Space Line
					br.readLine();
				}
			} else {

				throw new Exception("Number of test case is not valid");
			}
			// Close the input stream
			in.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}

	private static String[][] transposeBoard(String[][] array) {

		String[][] newBoard = new String[4][4];

		// transpose in-place
		for (int i = 0; i < 4; i++) {
			for (int j = i; j < 4; j++) {
				String temp = array[i][j];
				newBoard[i][j] = array[j][i];
				newBoard[j][i] = temp;
			}
		}
		return newBoard;
	}

	private static String getLetter(String[] line) {

		for (int i = 0; i < line.length; i++) {

			if (!"T".equals(line[i])) {

				return line[i];
			}
		}

		return null;
	}

	private static boolean isThereARow(String[] line, String letter) {

		String[] sortLine = line.clone();
		Arrays.sort(sortLine);

		if ("X".equals(letter)) {

			if ((0 <= Arrays.binarySearch(sortLine, "O"))
					|| (0 <= Arrays.binarySearch(sortLine, "."))) {

				return false;
			}
		} else if ("O".equals(letter)) {

			if ((0 <= Arrays.binarySearch(sortLine, "X"))
					|| (0 <= Arrays.binarySearch(sortLine, "."))) {

				return false;
			}
		} else if (".".equals(letter)) {

			return false;

		}
		return true;
	}
}
