package com.spawn.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Map;
import java.util.Scanner;
import java.util.concurrent.atomic.AtomicInteger;

import com.google.common.collect.LinkedHashMultiset;
import com.google.common.collect.Multiset;

class Case {

	public int caseNumber;
	public String result;

	public Case(int i, Scanner s) {
		caseNumber = i;
		parse(s);
	}

	public String getResult() {
		return "Case #" + caseNumber + ": " + result + "\n";
	}

	int n;
	String[] strs;
	LinkedHashMultiset<Character> all;
	LinkedHashMultiset<Character> map[];

	public void parse(Scanner s) {
		n = s.nextInt();
		strs = new String[n];
		all = LinkedHashMultiset.create();
		map = new LinkedHashMultiset[n];
		for (int i = 0; i < n; i++) {
			map[i] = LinkedHashMultiset.create();
			String str = s.next();
			for (char c : str.toCharArray()) {
				map[i].add(c);
				all.add(c);
			}
		}
	}

	public void _solve() {
		for(int i=1; i<n; i++){
			Iterator<Character> a = map[0].elementSet().iterator();
			Iterator<Character> b = map[i].elementSet().iterator();
			while(a.hasNext()){
				
				Character x,y;
				if(!b.hasNext() || (x = a.next()) != (y = b.next())){
					result = "Felga Won";
					return;
				}
			}
		}

		int totalDiff = 0;
		Iterator<Character> x = all.elementSet().iterator();
		while(x.hasNext()){
			char c = x.next();
			int minDiff = Integer.MAX_VALUE;
			for(int i=1; i<=100; i++){

				int diff = 0;
				for(int j=0; j<n; j++)
				{
					diff += Math.abs(map[j].count(c) - i);
				}
				if(diff < minDiff)
					minDiff = diff;
			}
			totalDiff += minDiff;
		}
		result = Integer.toString(totalDiff);
		
	}

	public void solve() {
		_solve();
		System.out.println("#" + caseNumber + " done; "
				+ Main.casesRemaining.decrementAndGet() + " remaining");
	}
}

public class Main {

	public static AtomicInteger casesRemaining = new AtomicInteger();

	public static void main(String[] args) {
		try {
			String name = readLine();
			Scanner s = new Scanner(new File("../" + name + ".in"));

			int t = s.nextInt();
			casesRemaining.set(t);
			ArrayList<Case> cases = new ArrayList<Case>(t);
			File f = new File("../" + name + ".out");
			FileWriter output = new FileWriter(f);
			for (int i = 0; i < t; i++) {
				cases.add(i, new Case(i + 1, s));
			}
			cases.stream().forEach(Case::solve);

			for (int i = 0; i < t; i++) {
				output.write(cases.get(i).getResult());
			}
			output.close();
			s.close();

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static String readLine() throws IOException {
		if (System.console() != null) {
			return System.console().readLine();
		}
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));
		return reader.readLine();
	}

}
