package com.spawn.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.concurrent.atomic.AtomicInteger;

class Case {

	int l;
	long x;
	String str;
	byte[] block;
	public int caseNumber;
	public String result;
	/*
	 * super awesome hand calculated state table -k == 0 -j == 1 -i == 2 -1 == 3
	 * 1 == 4 i == 5 j == 6 k == 7
	 */
	private byte[][] state = {
			{ 3, 2, 6, 7, 0, 1, 5, 4 },
			{ 5, 3, 0, 6, 1, 7, 4, 2 },
			{ 1, 7, 3, 5, 2, 4, 0, 6 },
			{ 7, 6, 5, 4, 3, 2, 1, 0 },
			{ 0, 1, 2, 3, 4, 5, 6, 7 },
			{ 6, 0, 4, 2, 5, 3, 7, 1 },
			{ 2, 4, 7, 1, 6, 0, 3, 5 },
			{ 4, 5, 1, 0, 7, 6, 2, 3 }

	};

	public Case(int i, Scanner s) {
		caseNumber = i;
		parse(s);
	}

	public String getResult() {
		return "Case #" + caseNumber + ": " + result + "\n";
	}

	public void parse(Scanner s) {
		l = s.nextInt();
		x = s.nextLong();
		block = s.next().getBytes();
	}

	private long findOne(long ax, int bx) {
		ax++;
		long blocksRemaining = x - ax;
		byte trgt = 4;
		if (bx != l) // if we didn't end on a block boundary
			for (int b = bx + 1; b < l; b++)
				trgt = state[trgt][block[b]];

		if (blocksRemaining > 0) {
			while (blocksRemaining % 4 != 0) {
				trgt = state[trgt][blockRes];
				blocksRemaining--;
			}
		}
		if (trgt == 4)
			return x * l;
		else
			return -1;
	}

	private byte blockRes = 4;

	private long match(long ax, int bx, int match) {
		byte trgt = block[bx];
		int b = bx;
		for (long a = ax; a < x; a++) {
			do {
				if (trgt == match) {
					long res;
					if (match < 7) // not finished
						res = match(a + (b + 1) / l, (b + 1) % l, match + 1);
					else if (a * l + b + 1 == x * l) // finished on strEnd
						return x * l;
					else
						// finished after strEnd
						res = findOne(a, b);
					if (res == x * l)
						return res;
				}
				trgt = state[trgt][block[(b + 1) % l]];
			} while (++b < l);
			b = 0;
		}

		return -1;
	}

	public void solve() {

		for (int i = 0; i < l; i++) {
			block[i] = (byte) (block[i] - 'i' + 5);
			blockRes = state[blockRes][block[i]];
		}
		byte trgt = 4;
		for (int i = 0; i < (x%4); i++)
			trgt = state[trgt][blockRes];
		if (trgt != 3 || match(0, 0, 5) < 0)
			result = "NO";
		else
			result = "YES";
		System.out.println("#" + caseNumber + " done; "
				+ Main.casesRemaining.decrementAndGet() + " remaining: "
				+ result + "-" + trgt);
	}
}

public class Main {

	public static AtomicInteger casesRemaining = new AtomicInteger();

	public static void main(String[] args) {
		try {
			String name = readLine();
			Scanner s = new Scanner(new File("../" + name + ".in"));

			int t = s.nextInt();
			casesRemaining.set(t);
			ArrayList<Case> cases = new ArrayList<Case>(t);
			File f = new File("../" + name + ".out");
			FileWriter output = new FileWriter(f);
			for (int i = 0; i < t; i++) {
				cases.add(i, new Case(i + 1, s));
			}
			cases.stream().forEach(Case::solve);

			for (int i = 0; i < t; i++) {
				output.write(cases.get(i).getResult());
			}
			output.close();
			s.close();

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static String readLine() throws IOException {
		if (System.console() != null) {
			return System.console().readLine();
		}
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));
		return reader.readLine();
	}

}
