package com.spawn.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.concurrent.atomic.AtomicInteger;

import com.google.common.collect.Multiset.Entry;
import com.google.common.collect.Ordering;
import com.google.common.collect.TreeMultiset;

class Case {

	public int caseNumber;
	public int d;
	public Ordering<Integer> order = Ordering.natural().reverse();
	public TreeMultiset<Integer> p = TreeMultiset.create(order);
	public String result;

	public Case(int i, Scanner s) {
		caseNumber = i;
		parse(s);
	}

	public String getResult() {
		return "Case #" + caseNumber + ": " + result + "\n";
	}

	public void parse(Scanner s) {
		d = s.nextInt();
		for (int i = 0; i < d; i++)
			p.add(s.nextInt());
	}

	public void solve() {

		int minTime = p.firstEntry().getElement();
		for (int i = p.firstEntry().getElement(); i > 0; i--) {
			int cuts = 0;
			for (Entry<Integer> e : p.entrySet()) {
				Integer x = e.getElement();
				if (x <= i)
					break;
				int c = (x / i) - ((x % i) > 0 ? 0 : 1);
				cuts += c * e.getCount();
			}
			minTime = Math.min(minTime, cuts+i);
		}

		result = Integer.toString(minTime);

		System.out.println("#" + caseNumber + " done; "
				+ Main.casesRemaining.decrementAndGet() + " remaining");
	}
}

public class Main {

	public static AtomicInteger casesRemaining = new AtomicInteger();

	public static void main(String[] args) {
		try {
			String name = readLine();
			Scanner s = new Scanner(new File("../" + name + ".in"));

			int t = s.nextInt();
			casesRemaining.set(t);
			ArrayList<Case> cases = new ArrayList<Case>(t);
			File f = new File("../" + name + ".out");
			FileWriter output = new FileWriter(f);
			for (int i = 0; i < t; i++) {
				cases.add(i, new Case(i + 1, s));
			}
			cases.parallelStream().forEach(Case::solve);

			for (int i = 0; i < t; i++) {
				output.write(cases.get(i).getResult());
			}
			output.close();
			s.close();

		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static String readLine() throws IOException {
		if (System.console() != null) {
			return System.console().readLine();
		}
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));
		return reader.readLine();
	}

}
