/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package googlejam2015;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 *
 * @author Allegea
 */
public class OminousOmino {
	
	private static boolean[][] grid;
	private static int X, R, C;
	private static final int[] dx = {1, 0, -1, 0};
	private static final int[] dy = {0, 1, 0, -1};
	
	private static boolean firstMove() {
		for (int i = 0; i < R; i++)
			for (int j = 0; j < C; j++) {
				if (!DFS(1, i, j)) return false;
			}
		return true;
	}
	
	private static boolean DFS(int count, int i, int j) {
		grid[i][j] = true;
		boolean answer = false;
		if (count == X) {
			if (gridFull()) {
				grid[i][j] = false;
				return true;
			}
			for (int di = 0; di < R; di++)
				for (int dj = 0; dj < C; dj++)
					if (!grid[di][dj]) {
						answer |= DFS_2(1, di, dj);		
						//if (answer) return answer;
					}
		} else {
			for (int h = 0; h < dx.length; h++) {
				int u = i + dx[h];
				int v = j + dy[h];
				if (canGo(u, v)) answer |= DFS(count + 1, u, v); 
			}
		}
		grid[i][j] = false;
		return answer;
	}

	
	private static boolean gridFull() {
		for (int di = 0; di < R; di++)
			for (int dj = 0; dj < C; dj++)
				if (!grid[di][dj]) 
					return false;				
		return true;
	}

	private static boolean DFS_2(int count, int i, int j) {
		grid[i][j] = true;
		boolean answer = false;
		if (count == X) {
			if (gridFull()) {
				grid[i][j] = false;
				return true;
			}
			for (int di = 0; di < R; di++)
				for (int dj = 0; dj < C; dj++)
					if (!grid[di][dj]) {
						answer |= DFS_2(1, di, dj);		
						if (answer) {
							grid[i][j] = false;
							return answer;
						}
					}
		} else {
			for (int h = 0; h < dx.length; h++) {
				int u = i + dx[h];
				int v = j + dy[h];
				if (canGo(u, v)) answer |= DFS_2(count + 1, u, v);
			}
		}
		grid[i][j] = false;
		return answer;
	}

	private static boolean canGo(int i, int j) {
		return i >= 0 && i < R && j >= 0 && j < C && !grid[i][j];
	}

    public static void main(String[] args) throws FileNotFoundException, IOException
    {

    	String fileName = "D-small-attempt2";
        Scanner in = new Scanner(new File(fileName + ".in"));
        //Scanner in = new Scanner(System.in);
        FileWriter archivo = new FileWriter(fileName + ".out");

        PrintWriter out = new PrintWriter(archivo);
        out.flush();

        int cases = in.nextInt();

        for(int c = 1; c <= cases; c++)
        {
            X = in.nextInt();
            R = in.nextInt();
            C = in.nextInt();
            grid = new boolean[R][C];
            System.out.println("Case #" + c + ": " + (firstMove() ? "GABRIEL" : "RICHARD"));
        	out.println("Case #" + c + ": " + (firstMove() ? "GABRIEL" : "RICHARD"));

        }
        out.close();
    }
}
