package GCJ2016;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.BitSet;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Set;
import java.util.StringTokenizer;

/**
 *
 * @author allegea
 */
public class RevengeOfThePancakes {
	private static String createTarget(int n) {
		char[] target = new char[n];
		for (int i = 0; i < n; target[i++] = '+');
		return String.valueOf(target);
	}
	private static int solve(String input) {
		int n = input.length();
		String target = createTarget(n);
		Queue<String> plays = new LinkedList<String>();
		Queue<Integer> dist = new LinkedList<Integer>();
		HashSet<String> visited = new HashSet<String>();
		
		plays.offer(input);
		dist.offer(0);
		visited.add(input);
		while (!plays.isEmpty()) {
			String x = plays.poll();
			int move = dist.poll();
			if (x.equals(target)) return move;
			for (int i = 0; i < n; i++) {
				String y = flip(i, x);
				if (!visited.contains(y)) {
					dist.offer(move + 1);
					plays.offer(y);
					visited.add(y);
				}
			}
		}
		return 0;
	}
    private static String flip(int i, String x) {
    	char[] y = x.toCharArray();
    	for (int j = 0; j <= i; j++) {
    		if (y[j] == '+') y[j] = '-';
    		else y[j] = '+';
    	}
    	return String.valueOf(y);
	}
	public static void main(String[] args) throws IOException{
        String fileName = "B-small-attempt0";
        BufferedReader in   = new BufferedReader(new FileReader(fileName + ".in"));
        PrintWriter out = new PrintWriter(new FileWriter(fileName + ".out"));
        
        //BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int t = Integer.parseInt(in.readLine());
        for (int i = 1; i <= t; i++) {
            String line = "Case #" + i + ": " + solve(in.readLine());
            System.out.println(line);
            out.println(line);
        }
        in.close();
        out.close();
    }
}
