package com.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.StringTokenizer;

public class Jamcoin {
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("resources/small-jamcoin.in"));
		FileWriter out = new FileWriter("resources/small-jamcoin.out");
		int T = new Integer(in.readLine());
		final int START_BASE = 2;
		final int END_BASE = 10;
		final int NUMBER_OF_BASE = END_BASE - START_BASE + 1;
		
		for (int i = 1; i <= T; i++){
			out.write("Case #" + i + ": " + "\n");			
			StringTokenizer tokens = new StringTokenizer(in.readLine());
			int N = new Integer(tokens.nextToken()); //number of digits
			int J = new Integer(tokens.nextToken()); //number of jamcoins
			String lowerBound = getLowerBound(N);
			String upperBound = getUpperBound(N);
			int count = 0;
			
			for (String canJamcoin = lowerBound; canJamcoin.compareTo(upperBound) < 1 && count < J; canJamcoin=next(canJamcoin)){ 
				boolean isJamCoin = true;
				long[] divisors = new long[NUMBER_OF_BASE];
				int divisorCount = 0;
				
				for (int base = START_BASE; base <= END_BASE; base++, divisorCount++){
					BigDecimal interpretation = convertFrom(canJamcoin, base);
					long divisor = findDivisor(interpretation);
					
					if (divisor == -1){ //prime
						isJamCoin = false;
						break;
					}
					else{
						divisors[divisorCount] = divisor;
					}
				}
				
				if (isJamCoin){
					out.write(canJamcoin + " ");
					
					int v = 0;
					for (; v < NUMBER_OF_BASE - 1; v++){
						out.write(divisors[v] + " ");
					}
					
					out.write(divisors[v] + "\n");
					count++;
				}
				
				if (canJamcoin.compareTo(upperBound) == 0) break;
			}
		}
		
		out.flush();
		out.close();
	}
	
	public static BigDecimal convertFrom(String number, int base){
		BigDecimal result = new BigDecimal(0);
		for(int i = 0; i < number.length(); i++){
			int level = number.length() - i - 1;
			BigDecimal digit = BigDecimal.valueOf(number.charAt(i) - '0');
			result = result.add(digit.multiply(BigDecimal.valueOf(base).pow(level)));
		}
		return result;
	}	
	
	public static long findDivisor(BigDecimal n){		
		BigDecimal factor2 = n.remainder(BigDecimal.valueOf(2));
		if (factor2.toString().equals("0"))
			return 2;		
		
		for (long factor = 3; (new BigDecimal(factor * factor)).compareTo(n) <= 0; factor += 2){
			BigDecimal factorN = n.remainder(BigDecimal.valueOf(factor));
			if (factorN.toString().equals("0")){
				return factor;
			}
		}
		
		return -1;
	}
	
	public static String next(String jamcoin){
		String jamcoinStrMid = jamcoin.substring(0, jamcoin.length()-1);		
		StringBuilder nextJamcoinStr = new StringBuilder(jamcoinStrMid);
		
		for (int i = jamcoinStrMid.length()-1; i >= 0; i--){
			if (jamcoinStrMid.charAt(i) == '0'){
				if (i < jamcoinStrMid.length()-1){
					for (int j = i + 1; j <= jamcoinStrMid.length()-1; j++){
						nextJamcoinStr.setCharAt(j, '0');
					}
				}
				nextJamcoinStr.setCharAt(i, '1');				
				break;
			}
		}
		
		nextJamcoinStr.append("1");
		return nextJamcoinStr.toString(); 
	}
	
	public static String getUpperBound(int length){
		String upperB = "";
		
		for (int i = 0; i < length; i++){
			upperB += "1";
		}
		
		return upperB;
	}
	
	public static String getLowerBound(int length){
		String lowerB = "1";
		
		for (int i = 1; i < length - 1; i++){
			lowerB += "0";
		}
		
		lowerB += "1";
		
		return lowerB;
	}
}