package com.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;

public class A {

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("resources/A.in"));
		FileWriter fw = new FileWriter("resources/A.out");		
		int T = new Integer(in.readLine());
		
		for (int i = 1; i <= T; i++){
			int N = new Integer(in.readLine());
			StringTokenizer st = new StringTokenizer(in.readLine());
			int[] parties = new int[N];
			for (int j = 0; j < N; j++){
				int number = Integer.valueOf(st.nextToken());
				parties[j] = number;
			}
			
			//System.out.print("Case #" + i + ": ");
			fw.write("Case #" + i + ": ");
			do{
				int most = findMostParties(parties, -1);
				if (most >= 0){			
					//System.out.print(findPartName(most));
					fw.write(findPartName(most));
					parties[most]--;
				}
				
				int secondMost = findMostParties(parties, most);
				if (secondMost >= 0 && moreThanTwoPartyRemain(parties, secondMost)){
					fw.write(findPartName(secondMost));
					parties[secondMost]--;
				}
				fw.write(" ");
					
				
			} while(hasRemain(parties));
			//System.out.print("\n");
			fw.write("\n");
			//fw.write("Case #" + i + ": " + circle.size() + "\n");
		}
		
		in.close();
		fw.flush();
		fw.close();
	}
	
	public static boolean moreThanTwoPartyRemain(int[] parties, int delete){
		int count= 0;
		for (int i = 0; i < parties.length; i++){
			if (i == delete){
				if (parties[i] - 1 > 0)
					count++;
			}
			else if (parties[i] > 0)
				count ++;
		}
		
		if (count == 1) 
			return false;
		else
			return true;
	}
	
	public static int findMostParties(int[] parties, int exclude){
		int max = 0;
		int party = 0;
		for (int i = 0; i < parties.length; i++){
			if (i == exclude) continue;
			if (parties[i] > max){
				party = i;
				max = parties[i];
			}			
		}
		
		if (max > 0)
			return party;
		else if  (max == 0 && parties[exclude] > 0)
			return exclude;
		else 
			return -1;
	}
	
	public static boolean hasRemain(int[] parties){
		for (int i = 0; i < parties.length; i++){
			if (parties[i] > 0)
					return true;
		}
		return false;
	}
	
	public static char findPartName(int index){
		String name="ABCDEFGHIJKLMNOPQRSTUVWXYZ";
		return name.charAt(index);
	}
}

