package com.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class CountingSheep {
	public static void main(String[] args) throws IOException{
		BufferedReader in = new BufferedReader(new FileReader("resources/large-counting-sheep.in"));
		FileWriter fw = new FileWriter("resources/large-counting-sheep.out");
		int N = new Integer(in.readLine());
		final int SIZE = 10;
		
		
		for (int i = 1; i <= N; i++){
			int C = new Integer(in.readLine());
			int mark[] = new int[SIZE];
			markIt(mark, C);
			int sheep = 0;
			int multiplier = 2;
			boolean sleep = false;
			
			do{
				sheep = C * multiplier++;
				markIt(mark, sheep);
				if (isComplete(mark, SIZE)){
					sleep = true;
					break;
				}
			}
			while(sheep != C);
			
			fw.write("Case #" + i + ": ");
			
			if (sleep) 
				fw.write(sheep + "\n");
			else
				fw.write("INSOMNIA" + "\n");
		}
		
		fw.flush();
		fw.close();
	}
	
	private static boolean isComplete(int[] mark, int size){
		boolean complete = true;
		for (int i = 0; i < size; i++){
			if (mark[i] != 1){
				complete = false;
				break;
			}
		}
		return complete;
	}
	
	private static void markIt(int[] mark, int sheep){
		String sheepStr = String.valueOf(sheep);
		for (int i = 0; i < sheepStr.length(); i++){
			int index = sheepStr.charAt(i) - '0';
			mark[index] = 1;
		}
	}
}
