package com.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;

public class Solder {

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("resources/A-small-solder.in"));
		FileWriter fw = new FileWriter("resources/A-small-solder.out");
		int C = new Integer(in.readLine());		

		for (int i = 1; i <= C; i++){
			int N = new Integer(in.readLine());
			int[][] heights = new int [2500*2500][2];			
	    	for (int j = 0; j < 2*N - 1; j++){
	    		StringTokenizer st = new StringTokenizer(in.readLine());
	    		for (int v = 0; v < N; v++){
	    			int height = new Integer(st.nextToken());
	    			count(heights, height, N);
	    		}
	    	}	    	
	    	solve(fw, heights, i, N);
		}		
		fw.flush();
		fw.close();
	}
	
	public static void count(int[][] heights, int height, int N){
		boolean matched = false;
		int i = 0;
		for (; i < N * N && heights[i][0] > 0;  i++){
			if (height == heights[i][0]){
				heights[i][1]++;	
				matched = true;
			}
		}
		if (!matched) {
			heights[i][0] = height;
			heights[i][1]++;
		}
	}
	
	public static void solve(FileWriter fw, int[][] heights, int count, int N) throws IOException{
		ArrayList result = new ArrayList();
		for(int i = 0; i < N * N && heights[i][0] > 0; i++){
			if (heights[i][1] % 2 == 1)
				result.add(heights[i][0]);
		}		
		Collections.sort(result);
		fw.write("Case #" + count + ": ");
		for (int i = 0; i < result.size(); i++ ){
			fw.write(result.get(i) + " ");
		}
		fw.write("\n");
	}
	

}
