package com.codejam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class PancakeRevenge {
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("resources/small-pancake-revenge.in"));
		FileWriter fw = new FileWriter("resources/small-pancake-revenge.out");
		int C = new Integer(in.readLine());
		
		for (int i = 1; i <= C; i++){
			String P = in.readLine();
			
			int count = 0;
			int j = P.length() - 1;
			
			while (!isComplete(P)){
				if (P.charAt(j) == '-'){
					if (P.charAt(0) == '+'){
						int index = findLeadingPlus(P);
						P = flip(P, index);
					}
					else{
						P = flip(P, j);
						j--;
					}
					count++;
				}
				else {
					j--;
				}
			}
			
			fw.write("Case #" + i + ": " + count + "\n");
		}
		
		fw.flush();
		fw.close();
	}
	
	private static int findLeadingPlus(String P){
		int i = 0;
		
		for (; i < P.length(); i++){
			if (P.charAt(i) == '-')
				break;
		}
		
		return i-1;
	}
	
	private static String flip(String P, int from){
		String result = "";
		
		for (int i = from; i >= 0; i--){
			if (P.charAt(i) == '+'){
				result +=  '-';
			}
			else
				result += '+';
		}
		
		if (from + 1 < P.length())
			result += P.substring(from + 1);
		
		return result;
	}
	
	private static boolean isComplete(String P){
		for (int i = 0; i < P.length(); i++){
			if (P.charAt(i) == '-')
				return false;
		}
		return true;
	}
					
}
