import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;

public class FairWarning {
	public BigInteger minimumSlarboseconds(BigInteger[] t) {
		Arrays.sort(t);
		BigInteger g = BigInteger.ZERO;
		for (int i = t.length - 1; i > 0; --i)
			if (!t[i].equals(t[i - 1]))
				g = gcd(g, t[i].subtract(t[i - 1]));
		if (g.equals(BigInteger.ZERO))
			throw new AssertionError(g);
		BigInteger res = t[0].mod(g);
		if (!res.equals(BigInteger.ZERO))
			res = g.subtract(res);
		return res;
	}
	
	private BigInteger gcd(BigInteger a, BigInteger b) {
		while (!b.equals(BigInteger.ZERO)) {
			BigInteger t = a;
			a = b;
			b = t.mod(b);
		}
		return a;
	}
	
	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int C = scanner.nextInt();
		for (int icase = 1; icase <= C; ++icase) {
			int N = scanner.nextInt();
			BigInteger[] t = new BigInteger[N];
			for (int i = 0; i < N; ++i)
				t[i] = scanner.nextBigInteger();
			System.out.printf("Case #%d: %s\n", icase, new FairWarning().minimumSlarboseconds(t).toString());
		}
	}
}
