package round1b;


import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.stream.Collectors;

public class ProblemA {
	
	// Workaround for not being able to pipe a file to stdin in Eclipse.
	private static final String IN_FILE = "text/" + "A-small-attempt1.in";
	
	private static final CharBag[] DIGIT_BAGS = {
		new CharBag("ZERO"),
		new CharBag("ONE"),
		new CharBag("TWO"),
		new CharBag("THREE"),
		new CharBag("FOUR"),
		new CharBag("FIVE"),
		new CharBag("SIX"),
		new CharBag("SEVEN"),
		new CharBag("EIGHT"),
		new CharBag("NINE")
	};
	
	private static final Integer[] DIGITS = {
		6, 0, 2, 7, 5, 8, 9, 1, 3, 4
	};
	
	public static void main(String[] args) throws Exception {
		try (Scanner in = new Scanner(new BufferedReader(new FileReader(IN_FILE)))) {
			int numCases = in.nextInt();
			for (int i = 0; i < numCases; i++) {
				CharBag input = new CharBag(in.next());
				
				String result = solve(input, Arrays.stream(DIGITS).collect(Collectors.toList()));
				String resultStr = result;
				
				System.out.println(String.format("Case #%s: %s", i+1, resultStr));
			}
		}
	}

//	private static String solve(CharBag input) {
//		StringBuilder result = new StringBuilder();
//		
//		for (int digit = 0; digit < 10; digit++) {
//			while (input.isSubBag(DIGIT_BAGS[digit])) {
//				result.append(""+digit);
//				input.removeBag(DIGIT_BAGS[digit]);
//			}
//		}
//		
//		return result.toString();
//	}
	
	private static String solve(CharBag input, List<Integer> candidates) {
		if (input.bag.isEmpty()) {
			return "";
		}
		
		List<Integer> newCandidates = candidates.stream()
				.filter(digit -> input.isSubBag(DIGIT_BAGS[digit])).collect(Collectors.toList());
		
		for (int digit : newCandidates) {
			input.removeBag(DIGIT_BAGS[digit]);
			String recurseResult = solve(input, newCandidates);
			if (recurseResult != null) {
				// TODO: This could be more efficient.
				String result = ""+digit+recurseResult;
				char[] resultArr = result.toCharArray();
				Arrays.sort(resultArr);
				return new String(resultArr);
			}
			input.addBag(DIGIT_BAGS[digit]);
		}
		
//		for (int digit = 0; digit < 10; digit++) {
//			if (input.isSubBag(DIGIT_BAGS[digit])) {
//				CharBag recurseInput = input.clone();
//				recurseInput.removeBag(DIGIT_BAGS[digit]);
//				String recurseResult = solve(recurseInput);
//				if (recurseResult != null) {
//					return ""+digit+recurseResult;
//				}
//			}
//		}
		
		return null;
	}
	
	private static class CharBag implements Cloneable {
		Map<Character, Integer> bag = new HashMap<>();
		
		public CharBag(String chars) {
			chars.chars().forEach(c -> addChar((char) c, 1));
		}
		
		@Override
		public CharBag clone() {
			CharBag result = null;
			try {
				result = (CharBag) super.clone();
			}
			catch (CloneNotSupportedException e) {
				assert (false);
			}
			result.bag = new HashMap<>(result.bag);
			
			return result;
		}
		
		public void addChar(char c, int times) {
			if (bag.containsKey(c)) {
				bag.put(c, bag.get(c) + times);
			}
			else {
				bag.put(c, times);
			}
		}
		
		public void removeChar(char c, int times) {
			Integer numPresent = bag.get(c);
			if (numPresent == null || numPresent < times) {
				assert (false);
			}
			
			if (numPresent == times) {
				bag.remove(c);
			}
			else {
				bag.put(c, numPresent - times);
			}
		}
		
		public void addBag(CharBag other) {
			for (Map.Entry<Character, Integer> entry : other.bag.entrySet()) {
				addChar(entry.getKey(), entry.getValue());
			}
		}
		
		public void removeBag(CharBag other) {
			assert (isSubBag(other));
			
			for (Map.Entry<Character, Integer> entry : other.bag.entrySet()) {
				removeChar(entry.getKey(), entry.getValue());
			}
		}
		
		public boolean isSubBag(CharBag other) {
			for (Map.Entry<Character, Integer> entry : other.bag.entrySet()) {
				char key = entry.getKey();
				int num = entry.getValue();
				Integer numHere = this.bag.get(key);
				if (numHere == null || numHere < num) {
					return false;
				}
			}
			
			return true;
		}
	}
}
