package round1b;


import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Scanner;

public class ProblemB {
	
	// Workaround for not being able to pipe a file to stdin in Eclipse.
	private static final String IN_FILE = "text/" + "B-small-attempt1.in";
	
	public static void main(String[] args) throws Exception {
		try (Scanner in = new Scanner(new BufferedReader(new FileReader(IN_FILE)))) {
			int numCases = in.nextInt();
			for (int i = 0; i < numCases; i++) {
				String score1 = in.next();
				String score2 = in.next();
				
				String result = solve(score1, score2);
				String resultStr = result;
				
				System.out.println(String.format("Case #%s: %s", i+1, resultStr));
			}
		}
	}

//	private static String[] solveSimple(String score1, String score2) {
//		StringBuilder result1 = new StringBuilder();
//		StringBuilder result2 = new StringBuilder();
//		
//		int guaranteedWin = 0;
//		for (int i = 0; i < score1.length(); i++) {
//			char next1 = score1.charAt(i);
//			char next2 = score2.charAt(i);
//			
//			if (next1 == '?') {
//				if (guaranteedWin < 0) {
//					result1.append('0');
//				}
//				else if (guaranteedWin > 0) {
//					result1.append('9');
//				}
//				else if (next2 == '?') {
//					result1.append('0');
//				}
//				else {
//					result1.append(next2);
//				}
//			}
//			else {
//				if (next2 != '?' && guaranteedWin == 0) {
//					guaranteedWin = next2 - next1;
//				}
//				result1.append(next1);
//			}
//			
//			if (next2 == '?') {
//				if (guaranteedWin > 0) {
//					result2.append('0');
//				}
//				else if (guaranteedWin < 0) {
//					result2.append('9');
//				}
//				else if (next1 == '?') {
//					result2.append('0');
//				}
//				else {
//					result2.append(next1);
//				}
//			}
//			else {
//				if (next1 != '?' && guaranteedWin == 0) {
//					guaranteedWin = next2 - next1;
//				}
//				result2.append(next2);
//			}
//		}
//		
//		return new String[] { result1.toString(), result2.toString() };
//	}
	
	private static String solve(String score1, String score2) {
		String[] simpleSoln = solveSimple(score1, score2);
		String[] otherSoln = solveOther(score1, score2);
		
		String[] resultSoln = bestSoln(simpleSoln, otherSoln);
		
		return resultSoln[0] + " " + resultSoln[1];
	}
	
	private static String[] bestSoln(String[] soln1, String[] soln2) {
		if (soln1 == null) {
			return soln2;
		}
		if (soln2 == null) {
			return soln1;
		}
		
		int scoreDiff1 = scoreDiffForSoln(soln1);
		int scoreDiff2 = scoreDiffForSoln(soln2);
		
		if (scoreDiff1 < scoreDiff2) {
			return soln1;
		}
		if (scoreDiff2 < scoreDiff1) {
			return soln2;
		}
		
		int score11 = Integer.parseInt(soln1[0]);
		int score12 = Integer.parseInt(soln1[1]);
		int score21 = Integer.parseInt(soln2[0]);
		int score22 = Integer.parseInt(soln2[1]);
		
		if (score11 < score21) {
			return soln1;
		}
		if (score21 < score11) {
			return soln2;
		}
		if (score12 < score22) {
			return soln1;
		}
		if (score22 < score12) {
			return soln2;
		}
		
		return soln1;
	}
	
	private static int scoreDiffForSoln(String[] soln) {
		return Math.abs(Integer.parseInt(soln[0]) - Integer.parseInt(soln[1]));
	}
	
	private static String[] solveSimple(String score1, String score2) {
		StringBuilder result1 = new StringBuilder();
		StringBuilder result2 = new StringBuilder();
		
		int win = 0;
		for (int i = 0; i < score1.length(); i++) {
			char next1 = score1.charAt(i);
			char next2 = score2.charAt(i);
			char[] nextResult = nextCharsSimple(next1, next2, win);
			result1.append(nextResult[0]);
			result2.append(nextResult[1]);
			win = updateWin(next1, next2, win);
		}
		
		return new String[] { result1.toString(), result2.toString() };
	}
	
	private static String[] solveOther(String score1, String score2) {
		int[] choiceNums = choiceInfo(score1, score2);
		if (choiceNums == null) {
			return null;
		}
		int choiceIdx = choiceNums[0];
		int simpleWin = choiceNums[1];
		
		StringBuilder result1 = new StringBuilder();
		StringBuilder result2 = new StringBuilder();
		
		int win = 0;
		for (int i = 0; i < score1.length(); i++) {
			char[] nextResult;
			if (i == choiceIdx) {
				nextResult = makeChoice2(score1, score2, choiceIdx, simpleWin);
				win = -simpleWin;
			}
			else {
				char next1 = score1.charAt(i);
				char next2 = score2.charAt(i);
				nextResult = nextCharsSimple(next1, next2, win);
			}
			
			result1.append(nextResult[0]);
			result2.append(nextResult[1]);
		}
		
		return new String[] { result1.toString(), result2.toString() };
	}
	
	private static int updateWin(char next1, char next2, int win) {
		if (win != 0) {
			return win;
		}
		
		if (next1 == '?' || next2 == '?' || next1 == next2) {
			return 0;
		}
		
		return next2 - next1;
	}
	
	private static char[] nextCharsSimple(char next1, char next2, int win) {
		char result1;
		char result2;
		if (next1 == '?') {
			if (win < 0) {
				result1 = '0';
			}
			else if (win > 0) {
				result1 = '9';
			}
			else if (next2 == '?') {
				result1 = '0';
			}
			else {
				result1 = next2;
			}
		}
		else {
			if (next2 != '?' && win == 0) {
				win = next2 - next1;
			}
			result1 = next1;
		}
		
		if (next2 == '?') {
			if (win > 0) {
				result2 = '0';
			}
			else if (win < 0) {
				result2 = '9';
			}
			else if (next1 == '?') {
				result2 = '0';
			}
			else {
				result2 = next1;
			}
		}
		else {
			if (next1 != '?' && win == 0) {
				win = next2 - next1;
			}
			result2 = next2;
		}
		
		return new char[] { result1, result2 };
	}
	
	private static char[] makeChoice2(String score1, String score2, int choiceIdx, int simpleWin)
	{
		assert (simpleWin != 0);
		
		char next1 = score1.charAt(choiceIdx);
		char next2 = score2.charAt(choiceIdx);
		char nextLose = (simpleWin > 0) ? next1 : next2;
		char nextWin = (simpleWin > 0) ? next2 : next1;
		
		if (nextLose == '?' && nextWin == '?') {
			if (simpleWin > 0) {
				return new char[] { '1', '0' };
			}
			else {
				return new char[] { '0', '1' };
			}
		}
		else if (nextLose == '?') {
			if (simpleWin > 0) {
				return new char[] { (char) (nextWin+1), nextWin };
			}
			else {
				return new char[] { nextWin, (char) (nextWin+1) };
			}
		}
		else if (nextWin == '?') {
			if (simpleWin > 0) {
				return new char[] { nextLose, (char) (nextLose-1) };
			}
			else {
				return new char[] { (char) (nextLose-1), nextLose };
			}
		}
		else {
			assert (false);
			throw new RuntimeException();
		}
	}
	
	private static int[] choiceInfo(String score1, String score2) {
		for (int i = 0; i < score1.length(); i++) {
			char next1 = score1.charAt(i);
			char next2 = score2.charAt(i);
			if (next1 != '?' && next2 != '?' && next1 != next2) {
				int simpleWin = next2 - next1;
				for (int j = i-1; j >= 0; j--) {
					char nextLose = (simpleWin > 0) ? score1.charAt(j) : score2.charAt(j);
					char nextWin = (simpleWin > 0) ? score2.charAt(j) : score1.charAt(j);
					assert (nextLose == '?' || nextWin == '?' || nextLose == nextWin);
					if (nextWin != '9' && nextLose != '0'
							&& (nextLose == '?' || nextLose != nextWin))
					{
						return new int[] { j, simpleWin };
					}
				}
				return null;
			}
//			if (score1.charAt(i) != '?' && score2.charAt(i) != '?'
//					&& score1.charAt(i) != score2.charAt(i)) {
//				int simpleWin = score2.charAt(i) - score1.charAt(i))
//				
//				return i;
//			}
		}
		
		return null;
	}
}
