/*
 * This code is meant to run under the Java Runtime Environment, version 1.7 or
 * later.
 */

package round2.b;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Queue;
import java.util.Scanner;

public class Main0 {
	
	// This is used to work around the inability of Eclipse to use a file as
	// System.in when running a program.
	private static final String IN_FILE_NAME = "B-large.in";

	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner(new BufferedReader(new FileReader(IN_FILE_NAME)));
		
		long numCases = in.nextLong();
		
		for (long i = 1; i <= numCases; i++) {
			int numNums = in.nextInt();
			long[] nums = new long[numNums];
			for (int j = 0; j < numNums; j++) {
				nums[j] = in.nextLong();
			}
			
			long result = solve(nums);
			String resultStr = ""+result;
			
			System.out.println(String.format("Case #%s: %s", i, resultStr));
		}
		
		in.close();
	}
	
	private static long solve(long[] nums) {
		List<Long> numbers = new ArrayList<Long>(nums.length);
		for (int i = 0; i < nums.length; i++) {
			numbers.add(nums[i]);
		}
		List<Long> temp = new ArrayList<Long>(numbers);
		Collections.sort(temp);
		Queue<Long> sorted = new LinkedList<Long>(temp);
		
		// Starting with the smallest number, move numbers to the nearest outer
		// edge and then remove them from consideration.
		long result = 0;
		while (!sorted.isEmpty()) {
			long smallest = sorted.remove();
			int index = numbers.indexOf(smallest);
			int distToEdge = Math.min(index, numbers.size()-(index+1));
			result += distToEdge;
			numbers.remove(index);
		}
		assert(numbers.isEmpty());
		
		return result;
	}
}