package round1c;


import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class ProblemC {
	
	// Workaround for not being able to pipe a file to stdin in Eclipse.
	private static final String IN_FILE = "text/" + "C-small-attempt1.in";
	
	public static void main(String[] args) throws Exception {
		try (Scanner in = new Scanner(new BufferedReader(new FileReader(IN_FILE)))) {
			int numCases = in.nextInt();
			for (int i = 0; i < numCases; i++) {
				int numJs = in.nextInt();
				int numPs = in.nextInt();
				int numSs = in.nextInt();
				int k = in.nextInt();
				
				int[][] result = solve(numJs, numPs, numSs, k);
				StringBuilder resultStr = new StringBuilder();
				resultStr.append(result.length);
				for (int[] combination : result) {
					resultStr.append(String.format("\n%s %s %s", combination[0]+1, combination[1]+1,
							combination[2]+1));
				}
				
				System.out.println(String.format("Case #%s: %s", i+1, resultStr));
			}
		}
	}

	private static int[][] solve(int numJs, int numPs, int numSs, int k) {
		int[][] jpCounts = new int[numJs][numPs];
		int[][] psCounts = new int[numPs][numSs];
		int[][] jsCounts = new int[numJs][numSs];
		List<int[]> result = new ArrayList<>();
		
		for (int s = 0; s < numSs; s++) {
			for (int p = 0; p < numPs; p++) {
				if ((numPs * s + p) % 2 == 0) {
					for (int j = 0; j < numJs; j++) {
						if (jpCounts[j][p] < k && psCounts[p][s] < k && jsCounts[j][s] < k) {
							jpCounts[j][p]++;
							psCounts[p][s]++;
							jsCounts[j][s]++;
							result.add(new int[] { j, p, s });
						}
					}
				}
				else {
					for (int j = numJs - 1; j >= 0; j--) {
						if (jpCounts[j][p] < k && psCounts[p][s] < k && jsCounts[j][s] < k) {
							jpCounts[j][p]++;
							psCounts[p][s]++;
							jsCounts[j][s]++;
							result.add(new int[] { j, p, s });
						}
					}
				}
			}
		}
		
		return result.toArray(new int[result.size()][]);
	}
}
