package round1c;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Arrays;
import java.util.Scanner;

public class ProblemA {
	
	// Workaround for not being able to pipe a file to stdin in Eclipse.
	private static final String IN_FILE = "text/" + "A-small-attempt1.in";
	
	public static void main(String[] args) throws Exception {
		try (Scanner in = new Scanner(new BufferedReader(new FileReader(IN_FILE)))) {
			int numCases = in.nextInt();
			for (int i = 0; i < numCases; i++) {
				int numParties = in.nextInt();
				int[] counts = new int[numParties];
				for (int j = 0; j < numParties; j++) {
					counts[j] = in.nextInt();
				}
				
				String result = solve(counts);
				String resultStr = result;
				
				System.out.println(String.format("Case #%s: %s", i+1, resultStr));
			}
		}
	}

	private static String solve(int[] counts) {
		StringBuilder result = new StringBuilder();
		int totalCount = Arrays.stream(counts).sum();
		int numRemoved = 0;
		while (numRemoved < totalCount) {
			if (result.length() > 0) {
				result.append(" ");
			}
			
			Integer[] maxIxs = maxTwoIxs(counts);
			int ix1 = maxIxs[0];
			int ix2 = maxIxs[1];
			
			if (counts[ix1] == counts[ix2] && !(counts[ix1] == 1 && totalCount - numRemoved == 3)) {
				result.append((char) ('A' + ix1));
				result.append((char) ('A' + ix2));
				counts[ix1]--;
				counts[ix2]--;
				numRemoved += 2;
			}
			else {
				result.append((char) ('A' + ix1));
				counts[ix1]--;
				numRemoved++;
			}
		}
		
		return result.toString();
	}
	
	private static Integer[] maxTwoIxs(int[] arr) {
		Integer maxVal = null;
		Integer secondMax = null;
		Integer ix1 = null;
		Integer ix2 = null;
		
		for (int i = 0; i < arr.length; i++) {
			if (maxVal == null || arr[i] > maxVal) {
				if (maxVal != null && (secondMax == null || maxVal > secondMax)) {
					secondMax = maxVal;
					ix2 = ix1;
				}
				maxVal = arr[i];
				ix1 = i;
			}
			else if (secondMax == null || arr[i] > secondMax) {
				secondMax = arr[i];
				ix2 = i;
			}
		}
		
		assert (ix1 == null || ix1 != ix2);
		
		return new Integer[] { ix1, ix2 };
	}
}
