import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintStream;


public class TicTacToeTomek {
	
	private static final char TOMEK = 'T';
	private static final char CHAR_O = 'O';
	private static final char CHAR_X = 'X';
	private static final char CHAR_EMPTY = '.';
	
	public static String STATUS_X_WON = "X won";
	public static String STATUS_O_WON = "O won";
	public static String STATUS_DRAW = "Draw";
	public static String STATUS_NOT_COMPLETED = "Game has not completed";
	
	static int cases = 0;
	
	public static char[][] field = new char[4][4];
	private static PrintStream ps;

	public static void main(final String[] args) throws IOException {
		
		
		BufferedReader br = new BufferedReader(new FileReader(new File("sample.in")));
		ps = new PrintStream("output.out");
		
		int numberCases = Integer.parseInt(br.readLine());
		
		String line;
		String lines[] = new String[4];
		
		
		while (cases < numberCases) {
			cases++;
			
			for (int i = 0; i < 4; i++) {
				line = br.readLine();
				lines[i] = line;
			}
			
			readMe(lines);
			checkStatus();
			
			br.readLine();
		}

	}

	private static void checkStatus() {
		
		boolean anybodyWon= false;
		boolean notCompleted = false;
		
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				char c = field[j][i];
				
				if (c == CHAR_EMPTY) {
					notCompleted = true;
				}
					
				for (int k = -1; k < 2; k++) {
					for (int k2 = -1; k2 < 2; k2++) {
						if ((k!=0 || k2!=0) && j+k2>=0 && i+k>=0 && j+k2<4 &&  i+k<4) {
							char c2 = field[j+k2][i+k];
							if (c != CHAR_EMPTY && (c == c2 || c2 == TOMEK)) {
								boolean won = checkDirection(c, j, i, k, k2);
								
								if (won) {
									if (c == CHAR_X) {
										
										anybodyWon = true;
										print(STATUS_X_WON);
										
									} else if (c == CHAR_O) {
										
										anybodyWon = true;
										print(STATUS_O_WON);
										
									}
									return;
								}
								
							}
						}
					}
				}
				
				
				
			}
		}
		
		if (notCompleted) {
			print(STATUS_NOT_COMPLETED);
		} else {
			print(STATUS_DRAW);
		}
		
	}

	private static void print(final String msg) {
		System.out.println("Case #" + cases + ": " + msg);
		
		ps.println("Case #" + cases + ": " + msg);
		
	}

	// we have already 2, need 2 more
	private static boolean checkDirection(final char c, final int j, final int i, final int k, final int k2) {
		
		boolean won = false;
		
		for (int l = 2; l < 4; l++) {
			
			if ((k!=0 || k2!=0) && j+k2*l>=0 && i+k*l>=0 && j+k2*l<4 &&  i+k*l<4) {
				
				char c2 = field[j+k2*l][i+k*l];
				if (c == c2 || c2 == TOMEK) {
					won = true;
				} else {
					return false;
				}
			} else {
				return false;
			}
			
		}
		
		return won;
		
	}

	private static void readMe(final String[] line) {
		
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				char c = line[i].charAt(j);
				field[j][i] = c;
					
			}
		}
		
	}

}
