import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

public class LawnMower {

	private static final int MAX = 200;

	static int cases = 0;

	public static int[][] field = new int[MAX][MAX];
	public static int[][] ofield = new int[MAX][MAX];

	private static PrintStream ps;

	public static void main(final String[] args) throws IOException {

		BufferedReader br = new BufferedReader(new FileReader(new File("sample.in")));
		ps = new PrintStream("output.out");

		int numberCases = Integer.parseInt(br.readLine());

		String line;
		String lines[] = new String[MAX];

		while (cases < numberCases) {
			cases++;
			
			String sdim[] = br.readLine().split(" ");
			int wx = Integer.parseInt(sdim[1]);
			int wy = Integer.parseInt(sdim[0]);
			
//			System.out.println("dimensions: " + wx + ", " + wy);
			
			for (int i = 0; i < wy; i++) {
				line = br.readLine();
				lines[i] = line;
			}

			readMe(lines, wx, wy);
			checkStatus(wx, wy);
		}
		
		br.close();

	}

	private static void checkStatus(final int wx, final int wy) {
		
		for (int i = 0; i <= wy; i++) {
			for (int j = 0; j <= wx; j++) {
				int high = 0;
				
				// get highest value in cross
				for (int j2 = 0; j2 < wx; j2++) {
					if (field[j2][i] > high) {
						high = field[j2][i];
					}
				}
				for (int i2 = 0; i2 < wy; i2++) {
					if (field[j][i2] > high) {
						high = field[j][i2]; 
					}
				}
				
				// do mowing
				for (int j2 = 0; j2 < wx; j2++) {
					if (ofield[j2][i] > high) {
						ofield[j2][i] = high;
					}
				}
				for (int i2 = 0; i2 < wy; i2++) {
					if (ofield[j][i2] > high) {
						ofield[j][i2] = high;
					}
				}
				
			}
		}

		// print output field to console
//		for (int i = 0; i < wy; i++) {
//			String line = "";
//			for (int j = 0; j < wx; j++) {
//				line += ofield[j][i] + " ";
//			}
//			System.out.println(line);
//		}
		
		// compare input with output, must be equal
		for (int i = 0; i < wy; i++) {
			for (int j = 0; j < wx; j++) {
				
				if (ofield[j][i] != field[j][i]) {
//					print("NO: " + ofield[j][i] + ", " +  field[j][i]);
					print("NO");
					return;
				}
				
			}
		}
		
		print("YES");
		
		
	}

	private static void readMe(final String[] lines, final int wx, final int wy) {
		
		for (int i = 0; i <= wy; i++) {
			for (int j = 0; j <= wx; j++) {
				ofield[j][i] = 100; // init output
				if (i == wy || j == wx) {
					field[j][i] = 0;
				} else {
					field[j][i] = Integer.parseInt(lines[i].split(" ")[j]);	
				}
			}
		}
		
	}

	private static void print(final String msg) {
		System.out.println("Case #" + cases + ": " + msg);
		ps.println("Case #" + cases + ": " + msg);
	}

}
