package net.truthcontrol.gcj2014;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayDeque;
import java.util.Deque;
import java.util.Scanner;

public class MinesweeperMaster {

	private static final String IMPOSSIBLE = "\nImpossible";
	/**
	 * Use this class to implement the solution.
	 * 
	 * @author Klaus Pfeiffer
	 */
	static class Solver {

		static class Mine {
			int x;
			int y;

			public Mine(final int x, final int y) {
				super();
				this.x = x;
				this.y = y;
			}

		}

		private int wx;
		private int wy;

		String doIt(final Scanner sc) {
			wy = sc.nextInt();
			wx = sc.nextInt();
			int nmines = sc.nextInt();
			int fields = wx * wy;
			int nfree = fields - nmines - 1;

			// System.out.println("free: " + free);
			if ((Math.min(wx, wy) >= 2 && nfree < 3 && nfree > 0)) {
				return IMPOSSIBLE;
			}
			// System.out.println("mines: " + mines);
			// if (Math.min(wx, wy) == 1) {
			// free -= 1;
			// }

			if (Math.min(wx, wy) > 1) {
				nfree -= 3;
			}

			// if (free < 0) {
			// return "\nImpossible";
			// }
			// System.out.println("free: " + free);

			// way 1
			char[][] arr = new char[wx][wy];
			int mines = nmines;
			int free = nfree;
			if (wx <= wy) {

				for (int y = 0; y < wy; y++) {
					for (int x = 0; x < wx; x++) {
						char c = '.';
						if (x == 0 && y == 0) {
							c = 'c';
						} else if (x <= 1 && y <= 1 && (Math.min(wx, wy) >= 2)
								&& free >= 0) {
							c = '.';
						} else if (free <= 0) {
							c = '*';
							mines--;
						} else {
							free--;
							c = '.';
						}

						arr[x][y] = c;

					}
				}
			} else {
				for (int x = 0; x < wx; x++) {
					for (int y = 0; y < wy; y++) {
						char c = '.';
						if (x == 0 && y == 0) {
							c = 'c';
						} else if (x <= 1 && y <= 1 && (Math.min(wx, wy) >= 2)
								&& free >= 0) {
							c = '.';
						} else if (free <= 0) {
							c = '*';
							mines--;
						} else {
							free--;
							c = '.';
						}

						arr[x][y] = c;

					}
				}
			}
			String ret = check(arr, mines);
			if (!ret.contains(IMPOSSIBLE)) {
				return ret;
			}
			// way1 inverted
			arr = new char[wx][wy];
			mines = nmines;
			free = nfree;
			if (wx > wy) {

				for (int y = 0; y < wy; y++) {
					for (int x = 0; x < wx; x++) {
						char c = '.';
						if (x == 0 && y == 0) {
							c = 'c';
						} else if (x <= 1 && y <= 1 && (Math.min(wx, wy) >= 2)
								&& free >= 0) {
							c = '.';
						} else if (free <= 0) {
							c = '*';
							mines--;
						} else {
							free--;
							c = '.';
						}

						arr[x][y] = c;

					}
				}
			} else {
				for (int x = 0; x < wx; x++) {
					for (int y = 0; y < wy; y++) {
						char c = '.';
						if (x == 0 && y == 0) {
							c = 'c';
						} else if (x <= 1 && y <= 1 && (Math.min(wx, wy) >= 2)
								&& free >= 0) {
							c = '.';
						} else if (free <= 0) {
							c = '*';
							mines--;
						} else {
							free--;
							c = '.';
						}

						arr[x][y] = c;

					}
				}
			}
			ret = check(arr, mines);
			if (!ret.contains(IMPOSSIBLE)) {
				return ret;
			}

			// way1b
			arr = new char[wx][wy];
			mines = nmines;
			free = nfree;
			for (int y = 0; y < wy; y++) {
				for (int x = 0; x < wx; x++) {
					char c = '.';
					if (x == 0 && y == 0) {
						c = 'c';
					}
					arr[x][y] = c;
				}
			}
			int rm = 0;
			for (int y = wy - 1; y >= 0 && mines >= wx; y--) {
				rm++;
				for (int x = 0; x < wx; x++) {
					arr[x][y] = '*';
					mines--;
				}
				if (mines % (wy - rm) == 0) {
					break;
				}
			}
			for (int x = wx - 1; x >= 0 && mines >= wy - rm && mines > 0; x--) {
				for (int y = 0; y < wy - rm; y++) {
					arr[x][y] = '*';
					mines--;
				}
			}
			if (mines == 0) {
				ret = check(arr, mines);
				if (!ret.contains(IMPOSSIBLE)) {
					return ret;
				}
			}

			// way 1c
			arr = new char[wx][wy];
			mines = nmines;
			free = nfree;
			for (int y = 0; y < wy; y++) {
				for (int x = 0; x < wx; x++) {
					char c = '.';
					if (x == 0 && y == 0) {
						c = 'c';
					}
					arr[x][y] = c;
				}
			}
			rm = 0;
			for (int x = wx - 1; x >= 0 && mines >= wy; x--) {
				rm++;
				for (int y = 0; y < wy; y++) {
					arr[x][y] = '*';
					mines--;
				}
				if (mines % (wx - rm) == 0) {
					break;
				}

			}
			for (int y = wy - 1; y >= 0 && mines >= wx - rm; y--) {
				for (int x = 0; x < wx - rm; x++) {
					arr[x][y] = '*';
					mines--;
				}
			}
			if (mines == 0) {
				ret = check(arr, mines);
				if (!ret.contains(IMPOSSIBLE)) {
					return ret;
				}
			}

			// way xyz dont care
			arr = new char[wx][wy];
			mines = 0;
			free = fields - nmines;
			for (int y = 0; y < wy; y++) {
				for (int x = 0; x < wx; x++) {
					char c = '*';
					if (x == 0 && y == 0) {
						c = 'c';
					}
					arr[x][y] = c;
				}
			}
			// int step=0;
			for (int is = 0; is < Math.max(wx, wy); is++) {
				for (int x = 0; x < is; x++) {
					int y = is;
					if (free > 0 && x < wx && y < wy) {
						arr[x][y] = '.';
						free--;
					}
				}
				for (int y = 0; y <= is; y++) {
					int x = is;
					if (free > 0 && x < wx && y < wy) {
						arr[x][y] = '.';
						free--;
					}
				}
			}
			arr[0][0] = 'c';
			if (free == 0) {
				ret = check(arr, mines);
				if (!ret.contains(IMPOSSIBLE)) {
					return ret;
				}
			}

			// way 2
			arr = new char[wx][wy];
			mines = nmines;
			for (int y = 0; y < wy; y++) {
				for (int x = 0; x < wx; x++) {
					char c = '.';
					if (x == 0 && y == 0) {
						c = 'c';
					}
					arr[x][y] = c;
				}
			}
			if (mines > 0) {
				Deque<Mine> mineHeap = new ArrayDeque<>();
				Deque<Mine> mineHeapNext = new ArrayDeque<>();
				mineHeapNext.push(new Mine(wx - 1, wy - 1));
				while (mineHeapNext.size() > 0) {
					mineHeap = (mineHeapNext);
					mineHeapNext = new ArrayDeque<>();
					while (mineHeap.size() > 0) {
						Mine m = mineHeap.pop();
						if (m.x >= 0 && m.y >= 0 && !(m.x < 2 && m.y < 2)
								&& mines > 0 && arr[m.x][m.y] != '*') {
							arr[m.x][m.y] = '*';
							mines--;
						}
						if (mines > 0 && m.x >= 0 && m.y >= 0) {
							mineHeapNext.push(new Mine(m.x - 1, m.y));
							mineHeapNext.push(new Mine(m.x, m.y - 1));
						}
					}
				}
			}

			return check(arr, mines);
		}

		private String check(final char[][] arr, final int mines) {
			// check
			String ret = "\n";
			for (int y = 0; y < wy; y++) {
				for (int x = 0; x < wx; x++) {
					ret += arr[x][y];
				}
				ret += "\n";
			}
			if (mines != 0) {
				System.out.println(ret.substring(0, ret.length() - 1));
				System.out.println("mines: " + mines);
				throw new RuntimeException("invalid");
			}

			String aret = "";
			aret += "\n\n";
			// check
			for (int y = 0; y < wy; y++) {
				for (int x = 0; x < wx; x++) {
					if (arr[x][y] == '*') {
						break;
					}
					// check neighbors
					int mfield = 0;// mines on field
					int nullfield = 0;
					for (int ny = -1; ny <= 1; ny++) {
						for (int nx = -1; nx <= 1; nx++) {
							int px = x + nx;
							int py = y + ny;

							if (px >= 0 && py >= 0 && px < wx && py < wy
									&& Math.abs(nx) + Math.abs(ny) > 0) {
								if (arr[px][py] == '0') {
									nullfield++;
								}
								if (arr[px][py] == '*') {
									mfield++;
								}
							}
						}
					}
					if (!(mfield == 0 || nullfield > 0 || x + y == 0)) {
						aret += "I";
						aret = IMPOSSIBLE; // DEBUG
						return IMPOSSIBLE;

					} else {
						if (mfield > 9) {
							throw new RuntimeException("invalid");
						}
						arr[x][y] = Integer.toString(mfield).charAt(0);
						aret += arr[x][y];
					}
				}
				if (arr[0][y] == '*') {
					break;
				}

				aret += "\n";
			}
			return ret.substring(0, ret.length() - 1);
			// if (aret.contains(IMPOSSIBLE)) {
			// return ret.substring(0, ret.length() - 1) + aret; // DEBUG
			// } else
			// return "";

		}
	}

	/*
	 * SKELETON:
	 */
	private static int cases = 0;

	private static PrintStream ps;

	private static Scanner sc;

	public static void main(final String[] args) throws NumberFormatException,
			IOException {

		run("/home/klaus/Downloads/C-small-attempt13.in", "output.out");

	}

	public static void run(final String in, final String out)
			throws NumberFormatException, IOException {
		sc = new Scanner(new File(in));
		ps = new PrintStream(out);

		int numberCases = sc.nextInt();
		long t1, t2, t3 = 0L;

		while (cases < numberCases) {
			cases++;

			log("last run: " + t3 + " ms; now calculating test case #" + cases
					+ " ... ");

			t1 = System.currentTimeMillis();
			Solver solver = new Solver();
			print(solver.doIt(sc));

			t2 = System.currentTimeMillis();
			t3 = t2 - t1;

		}

		log("last run: " + t3 + " ms");

		sc.close();
	}

	private static void log(final String string) {
		// System.out.println(string);
	}

	private static void print(final String msg) {
		// if (msg.contains(IMPOSSIBLE)) {
		System.out.println("Case #" + cases + ":" + msg);
		ps.println("Case #" + cases + ":" + msg);
		// }
	}

}
