package util;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.Enumeration;
import java.util.Hashtable;
import java.util.List;
import java.util.Vector;
import java.util.regex.Matcher;
import java.util.regex.Pattern;



public class Util {
	public static void append2File(String outFile,String text){
	      try {
	      	File f = new File(outFile);
	      	if(!f.exists())
	      		Util.write2File(outFile,"");
//	      	System.out.println(text);
//	      	System.out.println("writing to file : " + outFile);
				BufferedWriter out = new BufferedWriter(new FileWriter(outFile,true));
				out.write(text);
				out.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
	}
	
	
	  public static void write2File(String outFile,String text) throws IOException{

//    	System.out.println(text);
//    	System.out.println("writing to file : " + outFile);
			BufferedWriter out = new BufferedWriter(new FileWriter(outFile));
			out.write(text);
			out.close();
	  }
	  public static String[] getKeys(Hashtable table) {
		String[] out;
		if (!table.containsKey("#count"))
			out = new String[table.size()];
		else out = new String[table.size() - 1];
		String temp;
		int count = 0;

		for (Enumeration e = table.keys(); e.hasMoreElements();) {
			temp = (String) e.nextElement();
			if (temp.equals("#count"))
				continue;
			out[count] = temp;
			count++;
		}
		return out;
	}
	  
	  public static int getIndex(String[] words, String word){
		  for (int i = 0; i < words.length; i++) {
			if(words[i].equals(word))
				return i;
		}
		  return -1;
	  }
	  public static String replace(String source, String pattern, String replace)
	    {
	        if (source!=null)
	        {
	        final int len = pattern.length();
	        StringBuffer sb = new StringBuffer();
	        int found = -1;
	        int start = 0;

	        while( (found = source.indexOf(pattern, start) ) != -1) {
	            sb.append(source.substring(start, found));
	            sb.append(replace);
	            start = found + len;
	        }
	        sb.append(source.substring(start));
	        return sb.toString();
	        }
	        else return "";
	    }
	  
	  public static String getFile(String fileName){
			String str,out ="";
		  	try {
				BufferedReader in = new BufferedReader(new FileReader(fileName));
//				str = in.readLine();
				while ((str = in.readLine()) != null) {
					
					out += str + "\n";
//					System.out.println(str);
				}
			} catch (Exception e) {

				e.printStackTrace();
				return e.toString();
			}
			return out;
	  }
	  public static void print(String[] str){
			for (int i = 0; i < str.length; i++) {
				System.out.print(str[i]+" ");
			}
			System.out.print("\n");
		}
	  
	  public static int getFirstIndex(String words[], String word){
		  for (int i = 0; i < words.length; i++) {
			if(words[i].equals(word))
				return i;
		}
		  return -1;
	  }
	  public static String[] loadWords(String filename, int length){
		  String str, temp[] = new String[length];
		  int count = 0;
		  FileLiner in = new FileLiner(filename);
		  while((str = in.getLine() ) != null){
			  if(str.trim().equals(""))
				  continue;
			  temp[count] = str;
			  count++;
		  }
		return temp;
	  }
	  public static String[] contents(Vector<String> vect){
		  String str[] = new String[vect.size()];
			for (int i = 0; i < vect.size(); i++) {
				str[i] = vect.get(i);
			}
			return str;
	  }
	  
	  public static String[][] loadPairs(String filename){
			String str=null,out[][] = null;
			int size, count = 0;
		  	try {
				BufferedReader in = new BufferedReader(new FileReader(filename));
				str = in.readLine();
				str = in.readLine();
				size = Integer.parseInt(str.trim());
				out = new String[size][2];
				while ((str = in.readLine()) != null) {
//					System.out.println(str);
					if(count >=size)
						break;
					str = str.trim();
					out[count][0] = str;
//					System.out.println(str);
					str = in.readLine();					
					str = str.trim();
					out[count][1] = str;
//					System.out.println(str);
					count++;
				}
			} catch (Exception e) {
				System.out.println(count);
				e.printStackTrace();
			}
			return out;
	  }
	  
	  public static int[] loadNumbers(String filename){
			String str=null;
			System.out.println("hey");
			int size, count = 0, out[] = null;
		  	try {
				BufferedReader in = new BufferedReader(new FileReader(filename));
				str = in.readLine();
				size = Integer.parseInt(str.trim());
				out = new int[size];
				System.out.println(size);
				while ((str = in.readLine()) != null) {
					out[count] = Integer.parseInt(str);
					count++;
				}
				} catch (Exception e) {
					System.out.println(count);
					e.printStackTrace();
				}
			return out;
				
	  }
	public static String toString(String[] strings) {
		String out="";
		for (int i = 0; i < strings.length; i++) {
			if(i!=strings.length -1 )
				out+=strings[i]+"\t";
			else out+=strings[i];
		}
		return out;
	}
	public static String[] delete(String[] in, int del){
		String out[] = new String[in.length - 1];
		boolean pass = false;
		for (int i = 0; i < in.length; i++) {
			if(i == del)
				{
					pass = true;
					continue;
				}
			if(pass) out[i] = in[i+1];
			else out[i] = in[i];
		}
		return out;
	}
	
	public static void delete(String filename){
		File f;
		f = new File(filename);
		if(f.exists()) f.delete();
	}
	public static String[] combine(String[] in1 , String[] in2){
		String out[] = new String[in1.length+in2.length];
		for (int i = 0; i < in1.length; i++) {
			out[i] = in1[i];
		}
		for (int i = 0; i < in2.length; i++) {
			out[i+in1.length] = in2[i];
		}
		return out;
	}
	public static String toString(int[] in) {
		String out="";
		for (int i = 0; i < in.length; i++) {
			if(i!=in.length -1 )
				out+=in[i]+"\t";
			else out+=in[i];
		}
		return out;
	}
	public static int getMaxIndex(double[] in){
		int maxIndex = 0;
		for (int i = 0; i < in.length; i++) {
			if(in[i] > in[maxIndex]){
				maxIndex = i;
			}
		}
		return maxIndex;
	}
	
	public static String[] sortString(String[] in, boolean ascending){
//		List<String> list = Arrays.asList(in);
		String[] out = in;
		if(!ascending) 
			Arrays.sort(out, Collections.reverseOrder());
		else Arrays.sort(out);
		return out;
	}

	
	
	public static int count(String filename, String word){
		FileLiner in = new FileLiner(filename);
		String temp[];
		int count = 0;
		while((temp = in.getTokenized("[ \t]")) != null){
			for (int i = 0; i < temp.length; i++) {
				if(temp[i].equals(word))
					count++;
			}
		}
		return count;
	}


	public static int countTokens(String filename) {
		FileLiner in = new FileLiner(filename);
		String temp[];
		int count = 0;
		while((temp = in.getTokenized("[ \t]")) != null){
			count += temp.length;
		}
		return count;
	}
	public static int lineCount(String filename) {
		FileLiner in = new FileLiner(filename);
		int count = 0;
		while((in.getLine()) != null)
			count++;
		return count;
	}


	public static void print(int[] is) {
		if(is.length == 0)
		{
			System.out.println("length = 0");
			return;
		}
		for (int i = 0; i < is.length; i++) {
			System.out.print(is[i]+" ");
		}
		System.out.print("\n");
	}
	public static boolean match(String regex, String text){
        
		Pattern pattern = Pattern.compile(regex);
        Matcher matcher = pattern.matcher(text);
        boolean found = false;
        while (matcher.find()) {
                found = true;
        }
		return found;
	}


	public static String appendStr(String[] str, String gap) {
		String out = "";
		for (int i = 0; i < str.length - 1; i++) {
			if(str[i].equals(""))
				continue;
			out += str[i] + gap;
		}
		out += str[str.length - 1];
		return out;
	}
	
	public static int[] convert(Vector<Integer> in){
		int[] out = new int[in.size()];
		for (int i = 0; i < out.length; i++) {
			out[i] = in.get(i);
		}
		return out;
	}


	public static String appendInt(int[] in, String gap) {
		String out = "";
		for (int i = 0; i < in.length; i++) {
			out += in[i] + gap;
		}
		return out;
	}


	public static Vector sort(Vector out) {
		Collections.sort(out);
		return out;
	}


	public static int getMaxIndex(int[] in) {
		int maxIndex = 0;
		for (int i = 0; i < in.length; i++) {
			if(in[i] > in[maxIndex]){
				maxIndex = i;
			}
		}
		return maxIndex;
	}
	
	public static void makeDir(String dir){
		File f = new File(dir);
		f.mkdir();
	}
	public static String crop(String start, String end, String str){
		if(start.equals(""))
			return str.substring(0,str.indexOf(end));
		if(end.equals(""))
			return str.substring(str.indexOf(start) + start.length() );
		else return str.substring(str.indexOf(start) + start.length() , str.indexOf(end));
			
	}


	public static Hashtable<String, String> loadHashtable(String file) {
		Hashtable<String, String> table = new Hashtable<String, String>();
		FileLiner in = new FileLiner(file);
		String temp[];
		while((temp = in.getTokenized("[ \t]") ) != null){
			table.put(temp[0], temp[1]);
		}
		
		return table;
	}


	  public static void print(double[] str){
			for (int i = 0; i < str.length; i++) {
				System.out.print(str[i]+" ");
			}
			System.out.print("\n");
		}
	  public static double[] normalize(double in[]){
		  double norm = 0;
		  for (int i = 0; i < in.length; i++) {
			norm += in[i];
		}
		  for (int i = 0; i < in.length; i++) {
			in[i] = in[i] / norm;
		}
		  
		 return in;
	  }


	public static Histogram loadHist(String file) {
		FileLiner in = new FileLiner(file);
		String line;
		Histogram hist = new Histogram();
		while((line = in.getLine() ) != null)
			hist.put(line);
		return hist;
	}

}

