package qualifier.minesweeper;

public class GameBoard {

	private char[][] gameBoard;
	
	private int numberOfRows;
	private int numberOfColumns;
	private int numberOfMines;
	private boolean hasSolution;
	
	public GameBoard( int numberOfRows, int numberOfColumns, int numberOfMines ) {
		this.numberOfRows = numberOfRows;
		this.numberOfColumns = numberOfColumns;
		this.numberOfMines = numberOfMines;
		this.gameBoard = new char[numberOfRows][numberOfColumns];
	}
	
	public void initializeBoard() {
		if ( numberOfMines == 0 ) {
			hasSolution = true;
			
			for ( int i = 0; i < numberOfRows; i++ ) {
				for ( int j = 0; j < numberOfColumns; j++ ) {
					gameBoard[i][j] = '.';
				}
			}
		} else {
			int numberOfFreeSpaces = ( numberOfColumns * numberOfRows ) - numberOfMines;
			
			if ( numberOfFreeSpaces == 0 ) {
				hasSolution = false;
			} else if ( numberOfFreeSpaces == 1 ) {
				hasSolution = true;
				for ( int i = 0; i < numberOfRows; i++ ) {
					for ( int j = 0; j < numberOfColumns; j++ ) {
						gameBoard[i][j] = '*';
					}
				}
				gameBoard[0][0] = 'c';
				
			} else if ( ( numberOfRows == 1 ) || ( numberOfColumns == 1 ) ) {
				hasSolution = true;
				for ( int i = 0; i < numberOfRows; i++ ) {
					for ( int j = 0; j < numberOfColumns; j++ ) {
						if ( numberOfFreeSpaces > 0 ) {
							gameBoard[i][j] = '.';
							numberOfFreeSpaces--;
						} else {
							gameBoard[i][j] = '*';
						}
						
					}
				}
				gameBoard[0][0] = 'c';
			} else if ( numberOfFreeSpaces < 4 ) {
				hasSolution = false;
			} else {
				hasSolution = true;
				for ( int i = 0; i < numberOfRows; i++ ) {
					for ( int j = 0; j < numberOfColumns; j++ ) {
						gameBoard[i][j] = '*';
					}
				}
				gameBoard[0][0] = '.';
				gameBoard[0][1] = '.';
				gameBoard[1][0] = '.';
				gameBoard[1][1] = '.';
				
				numberOfFreeSpaces -= 4;
				
				for ( int i = 0; i < numberOfRows; i++ ) {
					for ( int j = 0; j < numberOfColumns; j++ ) {
						if ( numberOfFreeSpaces == 0 ) {
							break;
						}
						
						if ( i == 0  || i == 1) {
							if ( j == 0|| j == 1 ) {
								// These cases were already handled manually
								continue;
							}
						}
						
						gameBoard[i][j] = '.';
						numberOfFreeSpaces--;
					}
				} // End board assignment loop
				gameBoard[0][0] = 'c';
			}
		}
	}
	
	public void getBoard() {
		
	}
	
	public String toString() {
		StringBuilder boardBuilder = new StringBuilder();
		for ( char[] row : gameBoard ) {
			for ( char col : row ) {
				boardBuilder.append( col );
			}
			boardBuilder.append( '\n' );
		}
		return hasSolution ? boardBuilder.toString() : "Impossible";
	}
}
