package qualifier.magicTrick;

public class TestCase {

	private final int firstCardRowNum;
	private final int secondCardRowNum;
	
	private final int[] firstCards;
	private final int[] secondCards;
	
	public TestCase( int firstCardRowNum, int[] firstCards, int secondCardRowNum, int[] secondCards ) {
		this.firstCardRowNum = firstCardRowNum;
		this.secondCardRowNum = secondCardRowNum;
		this.firstCards = firstCards;
		this.secondCards = secondCards;
	}
	
	/**
	 * @return	The row number that the user's card is in for the first turn
	 */
	public int getFirstCardRowNum() {
		return firstCardRowNum;
	}

	/**
	 * Return an int array representing the cards in the given row of the first card set
	 * @param firstCardRowNum	The row to get cards for
	 * @return					int[] the cards in the row
	 */
	public int[] getFirstCardRow(int firstCardRowNum) {
		int startingIndex = ( firstCardRowNum - 1 ) * 4;
		int[] cardRow = new int[4];
		
		for ( int i = 0; i < 4; i++ ) {
			cardRow[i] = firstCards[startingIndex++];
		}
		return cardRow;
	}

	/**
	 * @return	The row number that the user's card is in for the second turn
	 */
	public int getSecondCardRowNum() {
		return secondCardRowNum;
	}

	/**
	 * Return an int array representing the cards in the given row of the second card set
	 * @param firstCardRowNum	The row to get cards for
	 * @return					int[] the cards in the row
	 */
	public int[] getSecondCardRow(int secondCardRowNum) {
		int startingIndex = ( secondCardRowNum - 1 ) * 4;
		int[] cardRow = new int[4];
		
		for ( int i = 0; i < 4; i++ ) {
			cardRow[i] = secondCards[startingIndex++];
		}
		return cardRow;
	}

}
