import java.util.*;

public class C {
	
	static double[] speed;
	static double[] maxHorse;
	static double[][] dist;
	
	static double[][] timeMap;
	static int n;
	
	public static void exploreMap(int horse, int city, double remainingDistance, double traveledDistance) {
		for(int i=0; i<n; i++) {
			if(city == i) continue;
			if( dist[city][i] == -1 ) continue;
			
			if( dist[city][i] <= remainingDistance ) {
				double totalDist = dist[city][i] + traveledDistance;
				double totalTime = totalDist / speed[horse];
				if( totalTime < timeMap[horse][i] )
					timeMap[horse][i] = totalTime;
				exploreMap(horse, i, remainingDistance-dist[city][i], totalDist);
			}
		}
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for(int c=1; c<=T; c++) {
			n = in.nextInt();
			int q = in.nextInt();
			
			speed = new double[n];
			maxHorse = new double[n];
			dist = new double[n][n];
			for(int i=0; i<n; i++) {
				maxHorse[i] = in.nextInt();
				speed[i] = in.nextInt();
			}
			for(int i=0; i<n; i++) {
				for(int j=0; j<n; j++) {
					dist[i][j] = in.nextInt();
				}
			}
			
			timeMap = new double[n][n];
			for(int i=0; i<n; i++) {
				Arrays.fill( timeMap[i], Double.POSITIVE_INFINITY );
				timeMap[i][i] = 0;
			}
			
			for(int i=0; i<n; i++) {
				exploreMap(i, i, maxHorse[i], 0);
			}
			
			for(int k=0; k<n; k++) {
				for(int i=0; i<n; i++) {
					for(int j=0; j<n; j++) {
						if( timeMap[i][k] == Double.POSITIVE_INFINITY ||
							timeMap[k][j] == Double.POSITIVE_INFINITY )
							continue;
						double proposedTime = timeMap[i][k] + timeMap[k][j];
						if( timeMap[i][j] > proposedTime ) {
							timeMap[i][j] = proposedTime;
						}
					}
				}
			}
			
			System.out.print("Case #" + c + ":");
			while(q-- > 0) {
				int u = in.nextInt();
				int v = in.nextInt();
				System.out.printf(" %.6f", timeMap[u-1][v-1]);
			}
			System.out.println();
		}
	}
	
}