import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;

public class Main {

	// class MaxComp implements
	class B {
		public int id, time, remain;

		public B(int id, int time) {
			this.id = id;
			this.time = time;
			this.remain = time;
		}
		
		void awake () {
			this.remain = this.time;
		}
	}
	
	class BComparator implements Comparator<B> {
		@Override
		public int compare(B b1, B b2) {
			if (b1.time != b2.time) {
				return b1.time - b2.time;
			} else {
				return b1.id - b2.id;
			}
		}
		
	}
	
	class BBComparator implements Comparator<B> {
		@Override
		public int compare(B b1, B b2) {
			return b1.remain - b2.remain;
		}
		
	}
	
	int [] primes = {2, 3, 5, 7, 11, 13, 17, 19, 23};

	public int solve(int bCount, int [] arr, int N) throws IOException {
		PriorityQueue<B> idle = new PriorityQueue<B>(bCount, new BComparator());
		PriorityQueue<B> busy = new 
				PriorityQueue<B>(bCount, new BBComparator());
		Map<Integer, Integer> set = new HashMap<Integer, Integer>();
		/*
		for (int p : primes) {
			set.put(p, 0);
		}
		*/
		
		int lcm = 1;
		for (int i = 0; i < arr.length; i ++) {
			int m = arr[i];
			lcm *= m;
			idle.offer(new B(i + 1, m));
		}
		
		int G = 0;
		for (int i = 0; i < arr.length; i ++) {
			G += lcm/arr[i];
		}
		
		N = ((N - 1) % G) + 1;
		//System.out.println(N);
		int current = 1;
		int elapsed = 0;
		
		
		while (true) {
			if (idle.isEmpty()) {
				B ava = busy.poll();
				int minVal = ava.remain;
				idle.offer(ava);
				while (!busy.isEmpty()) {
					if (busy.peek().remain == minVal) {
						idle.offer(busy.poll());
					} else {
						break;
					}
				}
				
				elapsed += minVal;
				
			} else {
				// pick up
				if (current == N) {
					int min = Integer.MAX_VALUE;
					while (!idle.isEmpty()) {
						min = Math.min(idle.poll().id, min);
					}
					return min;
				} else {
					B serve = idle.poll();
					// System.out.println("PICK " + serve.id);
					serve.remain = serve.time + elapsed;
					busy.offer(serve);
					current += 1;
				}
			}
		}

	
	}

	public Main() throws IOException {

		String userDir = System.getProperty("user.dir");
		FileWriter fWriter = new FileWriter(new File(userDir + "\\result.txt"));

		BufferedReader reader = new BufferedReader(new FileReader(userDir +  "\\B-small-attempt1.in"));
		//BufferedReader reader = new BufferedReader(new InputStreamReader( System.in));
		final Date now = new Date();
		int count = Integer.parseInt(reader.readLine());
		StringBuilder content = new StringBuilder();
		for (int i = 0; i < count; i++) {

			String line = reader.readLine();
			String[] segs = line.split(" ");
			int bCount = Integer.parseInt(segs[0]);
			int N = Integer.parseInt(segs[1]);

			//rep = Long.parseLong(segs[1]);
			line = reader.readLine();
			int [] arr = new int[bCount];
			segs = line.split(" ");
			for (int j = 0; j < bCount; j ++) {
				arr[j] = Integer.parseInt(segs[j]);
			}
			int result = solve(bCount, arr, N);
			content.append("Case #").append(i + 1).append(": ")
					.append(result).append("\r\n");
			// System.out.println(i + "," + result);
		}

		// System.out.print(content.toString());
		//System.out.print(new Date().getTime() - now.getTime());

		fWriter.write(content.toString());
		fWriter.flush();
		fWriter.close();
	}

	public static void main(String[] args) {
		try {
			new Main();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
