package round1A2011;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import qualificationRound2011.D;

public class A {
	int numOfTeams;
	int teamIndex;
	int[][] m_WT;//winnings table;
	double[][] m_RPI;//winnings table;
	public A(String numOfTeamsString) 
	{
		this.numOfTeams = Integer.parseInt(numOfTeamsString);
		m_WT = new int[this.numOfTeams][this.numOfTeams];
		m_RPI = new double[this.numOfTeams][4];
		teamIndex = 0;
	}
		
	
	public void AddTeam(String teamScores)
	{
		int winings = 0;
		int loses 	= 0;
		for (int i=0; i<teamScores.length(); i++)
		{
			
			switch (teamScores.charAt(i))
			{
			case '.':
					m_WT[teamIndex][i] = -1;
					break;
			case '1':
					m_WT[teamIndex][i] = 1;
					winings++;
					break;
			case '0':
					m_WT[teamIndex][i] = 0;
					loses++;
					break;
			}
		}
		m_RPI[teamIndex][0] = winings + loses; //number of games played;
		m_RPI[teamIndex][1] = winings; //number of games won;
		teamIndex++;
	}
	private void calcOWP()
	{
		for (int team=0; team<numOfTeams; team++)
		{			
			double tmpOWP = 0;
			for (int oponentTeam=0; oponentTeam<numOfTeams; oponentTeam++)
			{
				
				if (m_WT[team][oponentTeam] != -1 ) //if game played
				{
					double oponentGamesPlayed = m_RPI[oponentTeam][0] - 1;
					double oponentWP = m_RPI[oponentTeam][1];
					if (m_WT[oponentTeam][team] == 1)
					{
						oponentWP -= 1;
					}
					tmpOWP += oponentWP/oponentGamesPlayed;
				}
			}
			m_RPI[team][2] = tmpOWP / m_RPI[team][0];
		}
	}

	private void calcOOWP()
	{
		for (int team=0; team<numOfTeams; team++)
		{			
			double tmpOOWP = 0;
			for (int oponentTeam=0; oponentTeam<numOfTeams; oponentTeam++)
			{

				if (m_WT[team][oponentTeam] != -1 ) //if game played
				{
					tmpOOWP += m_RPI[oponentTeam][2] ;
				}
			}
			m_RPI[team][3] = tmpOOWP / m_RPI[team][0];
		}
	}
	public void calcRPI()
	{
		calcOWP();
		calcOOWP();
	}
	
	@Override
	public String toString() {
		String result = "";
		for (int team=0; team<numOfTeams; team++)
		{			
			result += "" + (0.25 * (m_RPI[team][1] / m_RPI[team][0]) + 0.5 * m_RPI[team][2] + 0.25 * m_RPI[team][3]) + "\n";
		}
		return result;
	}
	
	public static void run()
	{
		A a = new A("4");
		a.AddTeam(".11.");
		a.AddTeam("0.00");
		a.AddTeam("01.1");
		a.AddTeam(".10.");
		a.calcRPI();
		System.out.println(a);
	}

	public static void calcFromFile(String fileName)
	{
	      
			File file = new File(fileName);
	        BufferedReader reader = null;
	        FileWriter outFile = null;
 	        PrintWriter out = null;
 	        
	        try {
	        	outFile = new FileWriter(fileName.substring(0,fileName.lastIndexOf('.')) + "_out.txt");
	 	        out = new PrintWriter(outFile);
	 	        
	            reader = new BufferedReader(new FileReader(file));

	            String InputLine = null;
	            int numOfLine = 0;
	            while ((InputLine = reader.readLine()) != null) 	            // repeat until all lines is read
	            {
	            	if (numOfLine == 0) 
	            	{//Number of tests is not importent Skip!
	            		numOfLine++;
	            		continue;
	            	}
	            	//Specific reads 

	            	
	            	//Create a new class
	            	//InputLine = reader.readLine(); //Read number of teams
	            	int numberOfTeam = Integer.parseInt(InputLine);
	            		A a = new A(InputLine);	        		
	            	for (int i = 0; i <numberOfTeam; i++)
	            	{
	            		a.AddTeam(reader.readLine());
	            	}
	            	a.calcRPI();
	            	String result = "Case #"+numOfLine++ +": " + "\n" +  a;
	            	System.out.println(result);
	            	out.println(result);
	            }

	        } catch (FileNotFoundException e) {
	            e.printStackTrace();
	        } catch (IOException e) {
	            e.printStackTrace();
	        } finally {
	            try {
	                if (reader != null) {
	                    reader.close();
	                    out.close();
	                }
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
	        }
	}
	
}
