

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

public class Q2_40_Lawnmower {
	
	private int[][] newLawn(int width,int length)
	{
		int[][] newLawn = new int[length][width];
		for (int i= 0; i<length; i++)
			for (int j= 0; j<width; j++)
				newLawn[i][j] = 100;
		return newLawn;
	}
	
	private void cutRow(int[][] lawnToCut,int row, int height)
	{
		int width = lawnToCut[0].length;
		for (int col=0; col<width; col++)
		{
			if (lawnToCut[row][col] > height)
			{
				lawnToCut[row][col] = height;
			}
		}
	}
	
	private void cutCol(int[][] lawnToCut,int col, int height)
	{
		int length = lawnToCut.length;
		
		for (int row=0; row<length; row++)
		{
			if (lawnToCut[row][col] > height)
			{
				lawnToCut[row][col] = height;
			}
		}
	}
	
	private int maxInCol(int[][] board,int col)
	{
		int length = board.length;
		int max = board[0][col];
		for (int i=0; i<length; i++)
		{
			if (board[i][col] > max)
				max = board[i][col];
		}
		return max;
	}
	private int maxInRow(int[][] board,int row)
	{
		int width = board[0].length;
		int max = board[row][0];
		for (int i=0; i<width; i++)
		{
			if (board[row][i] > max)
			{
				max = board[row][i];
			}
		}
		
		return max;
	}
	
	
	
	public String solveCase(int[][] lawn)
	{
		int length = lawn.length;
		int width = lawn[0].length;
		int[][] testBoard = newLawn(width,length);
		
		//Cut rows
		for (int row=0; row<length; row++)
		{
			cutRow(testBoard,row,maxInRow(lawn, row));
		}
		
		//cut col
		for (int col=0; col<width; col++)
		{
			cutCol(testBoard, col, maxInCol(lawn, col));
		}
		
		if (Arrays.deepEquals(lawn, testBoard))
		{
			return "YES";
		}
		return "NO";
	}
	
	public static void calcFromFile(String fileName,String outFileName)
	{
	      
			File file = new File(fileName);
			FileWriter outputStream = null; 
	        BufferedReader reader = null;
	        int testCases = 0;
	        try {
	            reader = new BufferedReader(new FileReader(file));
	            String stringToCheck = null;
	            outputStream = new FileWriter(outFileName);
	            
	            // repeat until all lines is read
	            int numOfLine = 1;
	            String solution = "";
	            Q2_40_Lawnmower Q = new Q2_40_Lawnmower();
	            
	            stringToCheck = reader.readLine();
	            testCases = Integer.parseInt(stringToCheck);
	            	//Read the n test cases
	            	for (int testCase = 1; testCase<=testCases; testCase++)
	            	{
	            		/****************/
	            		//readFileToArray
	            		String[] lawnSize;
	            		String[] lawnRow;
	            		stringToCheck = reader.readLine(); //read size of lawn
	            		lawnSize = stringToCheck.split(" ");
	            		int length = Integer.parseInt(lawnSize[0]);
	            		int width  = Integer.parseInt(lawnSize[1]);
	            		int[][] lawn = new int[length][width];
	            		for (int row=0; row<length; row++)
	            		{
	            			stringToCheck = reader.readLine();
	            			lawnRow = stringToCheck.split(" ");
	            			for (int col=0; col<width; col++)
	            			{
	            				lawn[row][col] =  Integer.parseInt(lawnRow[col]);
	            			}
	            		}
	            		
	            		/****************/
	            		solution = Q.solveCase(lawn);
	            		/****************/
	            		System.out.println("Case #" + numOfLine + ": "+ solution);
	            		outputStream.write("Case #" + numOfLine++ + ": " + solution);
	            		if (testCase<testCases)
	            		{
	            			outputStream.write("\n");
	            		}
	            	}

	        } catch (FileNotFoundException e) {
	            e.printStackTrace();
	        } catch (IOException e) {
	            e.printStackTrace();
	        } finally {
	            try {
	                if (reader != null) {
	                    reader.close();
	                    
	                }
	                if (outputStream != null) {
	                    outputStream.close();
	                }
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
	        }
	}
}
