package round1B2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

import javax.swing.text.html.MinimalHTMLWriter;

public class A_Osmos {

	public static void quickSort(int[ ] data, int first, int n) {
		int pivotIndex, n1, n2;

		if (n > 1) {
			pivotIndex = partition(data, first, n);

			n1 = pivotIndex - first;
			n2 = n - n1 - 1;

			quickSort(data, first, n1);
			quickSort(data, pivotIndex + 1, n2);
		}
	}

	private static int partition(int[ ] data, int first, int n) {
		int f = first, m = first + n / 2, l = first + n - 1;

		if(data[l] > data[f]) { int temp = data[l]; data[l] = data[f]; data[f] = temp; }
		if(data[l] > data[m]) { int temp = data[l]; data[l] = data[m]; data[m] = temp; }
		if(data[f] > data[m]) { int temp = data[f]; data[f] = data[m]; data[m] = temp; }

		int pivot = data[first];
		int i = first + 1;
		for (int j = first + 1; j < first + n; j++) {
			if(data[j] < pivot) {
				int temp = data[j];
				data[j] = data[i];
				data[i] = temp;
				i++;
			}
		}
		int temp = data[first];
		data[first] = data[i - 1];
		data[i - 1] = temp;
		return i - 1; 
	}
	
	int A, N;
	int[] motes;
	int mIdx = 0;
	int minMovesCnt = 0x7FFFFFFF;
	int curMovesCnt = 0;
	boolean endFlag = false;
	
	void processMotes() {
		
		if(endFlag) {
			return;
		}
		
		if(mIdx == N) {
			endFlag = true;
			if(minMovesCnt > curMovesCnt) {
				minMovesCnt = curMovesCnt;
			}
			return;
		}
		
		if(A > motes[mIdx]) {
			A += motes[mIdx];
			mIdx++;
			
			processMotes();
			
			mIdx--;
			A -= motes[mIdx];
		}
		else {
			if(A > 1) {
				curMovesCnt++;
				int dif = A - 1;
				A += dif;
				
				processMotes();
				
				A -= dif;
				curMovesCnt--;
			}
			
			if(minMovesCnt > curMovesCnt + (N - mIdx)) {
				minMovesCnt = curMovesCnt + (N - mIdx);
			}
		}
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader("A-small-attempt0.in"));
			BufferedWriter bw = new BufferedWriter(new FileWriter("aOutput.txt"));
			Scanner in = new Scanner(br);

			int T = in.nextInt();
			for (int i = 0; i < T; i++) {
				
				A_Osmos o = new A_Osmos();
				
				o.A = in.nextInt();
				o.N = in.nextInt();
				o.motes = new int[o.N];
				for (int n = 0; n < o.N; n++) {
					o.motes[n] = in.nextInt();
				}
				
				quickSort(o.motes, 0, o.N);
				
				o.minMovesCnt = o.N;
				
				o.processMotes();
				
				bw.write("Case #" + (i + 1) + ": " + o.minMovesCnt + "\n");
				System.out.println("Case #" + i + ": " + o.minMovesCnt);
			}

			in.close();
			br.close();
			bw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
