package qualRound2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class D_Treasure {

	static public class Chest {
		int type;
		int numOfKeys;
		int[] keys;
		boolean isOpened = false;
	}

	private static final int MAX_KEY_TYPES = 201;
	Chest[] chest;
	int numOfCurKeys;
	int[] curKeys;
	int maxType;
	int K, N;

	int maxNeededKeyType() {
		maxType = -1;
		for (int i = 0; i < N; i++) {
			if(maxType < chest[i].type) {
				maxType = chest[i].type;
			}
			for (int j = 0; j < chest[i].numOfKeys; j++) {
				if(maxType < chest[i].keys[j]) {
					maxType = chest[i].keys[j];
				}
			}
		}
		return maxType;
	}

	private int[] getCurrOpenableChestArr() {
		int currCnt = 0;
		int[] tempArr = new int[N];
		for (int i = 0; i < N; i++) {
			if((chest[i].isOpened == false) && (curKeys[chest[i].type] > 0)) {
				tempArr[currCnt++] = i;
			}
		}
		int[] valid = new int[currCnt];
		System.arraycopy(tempArr, 0, valid, 0, currCnt);
		return valid;
	}

	int depth = 0, remChests;
	int[] route = new int[200];
	boolean finishedRoute = false;

	void proceedRoute() {
		if(remChests == 0) {
			return;
		}
		
		if(depth > 17) {
			System.out.print("Depth = " + depth + " - ");
			for (int i = 0; i < depth; i++) {
				System.out.print(route[i] + " ");
			}
			System.out.println();
		}
		
		if(checkIfStillPossible() == false) {
			return;
		}

		int[] validChests =  getCurrOpenableChestArr();

		for (int i = 0; i < validChests.length; i++) {
			int idx = validChests[i];

			chest[idx].isOpened = true;
			remChests--;
			curKeys[chest[idx].type]--;
			for (int j2 = 0; j2 < chest[idx].numOfKeys; j2++) {
				curKeys[chest[idx].keys[j2]]++;
			}
			route[depth++] = idx + 1;

			proceedRoute();

			if(remChests == 0) {
				return;
			}

			route[depth--] = -1;
			for (int j2 = 0; j2 < chest[idx].numOfKeys; j2++) {
				curKeys[chest[idx].keys[j2]]--;
			}
			curKeys[chest[idx].type]++;
			remChests++;
			chest[idx].isOpened = false;
		}
	}

	private boolean checkIfStillPossible() {
		int[] totalKeys = new int[maxType + 1];
		int[] totalChests = new int[maxType + 1];

		for (int i = 1; i <= maxType; i++) {
			totalKeys[i] = curKeys[i];
		}

		for (int i = 0; i < N; i++) {
			if(chest[i].isOpened) {
				continue;
			}
			for (int j = 0; j < chest[i].numOfKeys; j++) {
				totalKeys[chest[i].keys[j]]++;
			}
		}
		
		for (int i = 0; i < N; i++) {
			totalChests[chest[i].type]++;
		}

		for (int i = 1; i <= maxType; i++) {
			if(totalChests[i] > totalKeys[i]) {
				return false;
			}
		}
		return true;
	}

	private boolean checkIfPossible() {
		int[] totalKeys = new int[maxType + 1];
		int[] totalChests = new int[maxType + 1];

		for (int i = 1; i <= maxType; i++) {
			totalKeys[i] = curKeys[i];
		}

		System.out.println("MAX Type = " + maxType);
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < chest[i].numOfKeys; j++) {
				totalKeys[chest[i].keys[j]]++;
			}
		}
		
		for (int i = 0; i < N; i++) {
			totalChests[chest[i].type]++;
		}

		System.out.print("Chests = ");
		for (int i = 1; i <= maxType; i++) {
			System.out.print(totalChests[i] + " ");
		}
		System.out.println();

		System.out.print("Keys   = ");
		for (int i = 1; i <= maxType; i++) {
			System.out.print(totalKeys[i] + " ");
		}
		System.out.println();

		for (int i = 1; i <= maxType; i++) {
			if(totalChests[i] > totalKeys[i]) {
				return false;
			}
		}
		return true;
	}

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader("D-small-attempt2.in"));
			BufferedWriter bw = new BufferedWriter(new FileWriter("dOutput.txt"));
			Scanner in = new Scanner(br);

			int T = in.nextInt();
			for (int i = 0; i < T; i++) {
				D_Treasure d = new D_Treasure();

				d.K = in.nextInt();
				d.N = in.nextInt();
				System.out.println("Keys = " + d.K + " Chests = " + d.N);

				d.numOfCurKeys = d.K;
				d.curKeys = new int[MAX_KEY_TYPES];
				for (int j = 0; j < MAX_KEY_TYPES; j++) {
					d.curKeys[j] = 0;
				}
				for (int j = 0; j < d.K; j++) {
					d.curKeys[in.nextInt()]++;
				}

				d.chest = new Chest[d.N];
				for (int j = 0; j < d.N; j++) {
					d.chest[j] = new Chest();
					d.chest[j].type = in.nextInt();
					d.chest[j].numOfKeys = in.nextInt();
					d.chest[j].keys = new int[d.chest[j].numOfKeys];
					for (int j2 = 0; j2 < d.chest[j].numOfKeys; j2++) {
						d.chest[j].keys[j2] = in.nextInt();
					}
				}

				d.remChests = d.N;
				d.maxNeededKeyType();

				if(d.checkIfPossible() == false) {
					bw.write("Case #" + (i + 1) + ": " + "IMPOSSIBLE" + "\n");
					System.out.println("Case #" + (i + 1) + ": " + "IMPOSSIBLE Already");
					System.out.println();
					continue;
				}

				d.proceedRoute();

				if(d.remChests == 0) {
					String result = new String();
					for (int j = 0; j < d.N; j++) {
						result = result + new String(d.route[j] + " ");
					}
					bw.write("Case #" + (i + 1) + ": " + result + "\n");
					System.out.println("Case #" + (i + 1) + ": " + result);
					System.out.println();
				}
				else {
					bw.write("Case #" + (i + 1) + ": " + "IMPOSSIBLE" + "\n");
					System.out.println("Case #" + (i + 1) + ": " + "IMPOSSIBLE");
					System.out.println();
				}
			}
			in.close();
			br.close();
			bw.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
