import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;

public class Task implements Runnable{

	public static void main(String[] args) throws IOException{
		br=new BufferedReader(new FileReader("input.txt"));
		out=new PrintWriter("output.txt");
		new Thread(new Task()).start();
	}


	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;
	
	String nline() {
		try {
			return br.readLine().trim();
		} catch (Exception e) {
			return null;
		}
	}
	
	String ns(){
		try{
			while(st==null || !st.hasMoreTokens()){
				st=new StringTokenizer(br.readLine());
			}
			return st.nextToken();
		}catch(Exception e){
			return null;
		}
	}
	
	int ni(){
		return Integer.valueOf(ns());
	}
	
	long nl(){
		return Long.valueOf(ns());
	}
	
	double nd(){
		return Double.valueOf(ns());
	}

	boolean ok(int cfg1, int cfg2, int C) {
		for (int c = 0; c < C; c++) 
			if ((cfg2 & (1 << c)) > 0) {
				if (c > 0) {
					if ((cfg1 & (1 << (c - 1))) > 0) return false;
					if ((cfg2 & (1 << (c - 1))) > 0) return false;
				}
				if (c + 1 < C) {
					if ((cfg1 & (1 << (c + 1))) > 0) return false;
					if ((cfg2 & (1 << (c + 1))) > 0) return false;
				}
			}
		return true;
	}
	
	public void run(){
		//Place your code here
		int T = ni();
		for (int t = 1; t <= T; t++) {
			int R = ni();
			int C = ni();
			
			char[][] map = new char[R + 1][C + 1];
			for (int r = 1; r <= R; r++) {
				String s = ns();
				for (int c = 1; c <= C; c++)
					map[r][c] = s.charAt(c - 1);
			}
			
			int[][] cfgs = new int[2][1 << C];
			int cur = 0;
			int next = 1;
			
			for (int[] tmp : cfgs)
				Arrays.fill(tmp, -1);
			
			cfgs[cur][0] = 0;
			
			for (int r = 1; r <= R; r++) {
				Arrays.fill(cfgs[next], -1);
				for (int prevCfg = 0; prevCfg < 1 << C; prevCfg++)
					if (cfgs[cur][prevCfg] != -1) {
						for (int nextCfg = 0; nextCfg < 1 << C; nextCfg++) {
							boolean ok = true;
							for (int c = 0; c < C; c++)
								if(map[r][c + 1] == 'x' && (nextCfg & (1 << c)) > 0) {
									ok = false;
									break;
								}
							if (!ok) continue;
							ok = ok(prevCfg, nextCfg, C);
							if (!ok) continue;
							cfgs[next][nextCfg] = max(cfgs[next][nextCfg], cfgs[cur][prevCfg] + Integer.bitCount(nextCfg));
						}
					}
				cur = 1 - cur;
				next = 1 - next;
			}
			
			int ans = 0;
			for (int cfg = 0; cfg < 1 << C; cfg++)
				ans = max(ans, cfgs[cur][cfg]);
			out.println("Case #" + t + ": " + ans);
		}
		out.close();
	}
	
}
