import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;

public class TaskSmpl implements Runnable {

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("input.txt"));
		// br=new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter("output.txt");
		// out=new PrintWriter(System.out);
		new Thread(new TaskSmpl()).start();
	}

	static String fileName = "input.txt";
	static String inpFile = fileName + "";
	static String outFile = fileName + "";
	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;

	String ns() {
		try {
			while (st == null || !st.hasMoreTokens()) {
				st = new StringTokenizer(br.readLine());
			}
			return st.nextToken();
		} catch (Exception e) {
			return null;
		}
	}

	int ni() {
		return Integer.valueOf(ns());
	}

	long nl() {
		return Long.valueOf(ns());
	}

	double nd() {
		return Double.valueOf(ns());
	}

	BigInteger nbi() {
		return new BigInteger(ns());
	}

	int n;
	int leafsFrom;
	int[] values;
	int[] kind; // 1==AND, 0==OR
	boolean[] canChange;

	int[][] memo;

	int fx(int x, int desVal) {
		if (x >= leafsFrom)
			return desVal == values[x] ? 0 : Integer.MAX_VALUE;

		if (memo[x][desVal] == Integer.MAX_VALUE) {
			// without change
			int res1 = getCost(x, kind[x], desVal);

			// with change
			int res2 = Integer.MAX_VALUE;
			if (canChange[x])
				res2 = getCost(x, 1 - kind[x], desVal);
			if (res2 != Integer.MAX_VALUE)
				res2++;

			memo[x][desVal] = min(res1, res2);
		}
		return memo[x][desVal];
	}

	int getCost(int x, int func, int desVal) {
		int res = Integer.MAX_VALUE;
		for (int v1 = 0; v1 <= 1; v1++)
			for (int v2 = 0; v2 <= 1; v2++) {
				int val;
				if (func == 0)
					val = v1 | v2;
				else
					val = v1 & v2;
				if (val == desVal) {
					int res1 = fx(x * 2, v1);
					int res2 = fx(x * 2 + 1, v2);
					if (res1 != Integer.MAX_VALUE && res2 != Integer.MAX_VALUE)
						res = min(res, res1 + res2);
				}
			}
		return res;
	}

	public void run() {

		int T = ni();
		for (int t = 1; t <= T; t++) {
			n = ni();
			kind = new int[n + 1];
			canChange = new boolean[n + 1];
			values = new int[n + 1];
			leafsFrom = (n - 1) / 2 + 1;
			int v = ni();
			for (int i = 1; i <= (n - 1) / 2; i++) {
				kind[i] = ni();
				canChange[i] = ni() == 1;
			}
			for (int i = (n - 1) / 2 + 1; i <= n; i++)
				values[i] = ni();

			memo = new int[n + 1][2];
			for (int i = 0; i <= n; i++)
				memo[i][0] = memo[i][1] = Integer.MAX_VALUE;

			int ans = fx(1, v);

			out.print("Case #" + t + ": ");

			if (ans == Integer.MAX_VALUE) {
				out.println("IMPOSSIBLE");
			} else {
				out.println(ans);
			}
		}

		out.close();
	}

}
