import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;

public class Task implements Runnable {
	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("input.txt"));
		out = new PrintWriter("output.txt");

		new Thread(new Task()).start();
	}

	static BufferedReader br;
	static PrintWriter out;
	StringTokenizer st;

	String nline() {
		try {
			return br.readLine().trim();
		} catch (Exception e) {
			return null;
		}
	}

	String ns() {
		try {
			while (st == null || !st.hasMoreTokens()) {
				st = new StringTokenizer(nline());
			}
			return st.nextToken();
		} catch (Exception e) {
			return null;
		}
	}

	int ni() {
		return Integer.valueOf(ns());
	}

	long nl() {
		return Long.valueOf(ns());
	}

	int[] primes;

	void initPrimes() {
		int max = 1100000;
		boolean[] isPrime = new boolean[max + 1];
		Arrays.fill(isPrime, true);
		isPrime[2] = true;
		int pCnt = 0;
		for (int i = 2; i <= max; i++)
			if (isPrime[i]) {
				pCnt++;
				for (int j = i + i; j <= max; j += i)
					isPrime[j] = false;
			}
		
		primes = new int[pCnt];
		pCnt=  0;
		for (int i = 2; i <= max; i++)
			if (isPrime[i])
				primes[pCnt++] = i;
	}

	public void run() {
		// Place your code here

		initPrimes();
		
		int T = ni();
		for (int t = 1; t <= T; t++) {
			long A = nl();
			long B = nl();
			long P = nl();

			int size = (int) (B - A + 1);

			int[] col = new int[size];
			for (int i = 0; i < size; i++)
				col[i] = i;
			int ans = size;
			for (int prime : primes) {
				if (prime > size) break;
				if (prime < P) continue;
				
				while (true) {
					int base = (int)((((A - 1) / prime) + 1) * prime - A);
					int lastCol = col[base];
					int changeTo = -1;
					for (int i = base; i + prime < size; i += prime) {
						if (lastCol == -1)
							lastCol = col[i + prime];
						else
							if (lastCol != col[i + prime]) {
								changeTo = col[i + prime];
								break;
							}
					}
					
					if (changeTo == -1) break;
					
					for (int i = 0; i < size; i++)
						if (col[i] == lastCol)
							col[i] = changeTo;
					ans--;
				}
			}
			
			
			
			out.println("Case #" + t + ": " + ans);
		}

		out.close();
	}
}