import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;

public class Task implements Runnable {
	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("input.txt"));
		out = new PrintWriter("output.txt");

		new Thread(new Task()).start();
	}

	static BufferedReader br;
	static PrintWriter out;
	StringTokenizer st;

	String nline() {
		try {
			return br.readLine().trim();
		} catch (Exception e) {
			return null;
		}
	}

	String ns() {
		try {
			while (st == null || !st.hasMoreTokens()) {
				st = new StringTokenizer(nline());
			}
			return st.nextToken();
		} catch (Exception e) {
			return null;
		}
	}

	int ni() {
		return Integer.valueOf(ns());
	}

	long p0(long x) {
		return (x * (x - 1) * (x - 2)) / 6;
	}

	long p1(long x, long y) {
		return (x * y * (y - 1)) / 2;
	}

	long p2(long x, long y, long z) {
		return x * y * z;
	}

	boolean ok(int x1, int y1, int x2, int y2, int x3, int y3) {
		return (x1 + x2 + x3) % 3 == 0 && (y1 + y2 + y3) % 3 == 0;
	}

	public void run() {
		// Place your code here
		int T = ni();
		for (int t = 1; t <= T; t++) {
			int n = ni();
			long A = ni();
			long B = ni();
			long C = ni();
			long D = ni();

			long x0 = ni();
			long y0 = ni();
			long M = ni();

			long[][] pts = new long[n][2];

			long[] cnts = new long[9];
			for (int i = 0; i < n; i++) {
				pts[i][0] = x0;
				pts[i][1] = y0;
				int pos = (int) ((x0 % 3) * 3 + (y0 % 3));
				cnts[pos]++;

				x0 = (A * x0 + B) % M;
				y0 = (C * y0 + D) % M;
			}

			long ans = 0;
			
			for (int i = 0; i < 9; i++) {
				int x1 = i / 3;
				int y1 = i % 3;
				if (ok(x1, y1, x1, y1, x1, y1))
					ans += p0(cnts[i]);

				for (int j = i + 1; j < 9; j++) {
					int x2 = j / 3;
					int y2 = j % 3;

					if (ok(x1, y1, x2, y2, x2, y2)) {
						ans += p1(cnts[i], cnts[j]);
					}
					
					if (ok(x1, y1, x1, y1, x2, y2)) {
						ans += p1(cnts[j], cnts[i]);
					}

					for (int k = j + 1; k < 9; k++) {
						int x3 = k / 3;
						int y3 = k % 3;

						if (ok(x1, y1, x2, y2, x3, y3)) {
							ans += p2(cnts[i], cnts[j], cnts[k]);
						}
					}
				}

			}

			out.println("Case #" + t + ": " + ans);
		}

		out.close();
	}
}