import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;

public class Task implements Runnable{

	public static void main(String[] args) throws IOException{
		br=new BufferedReader(new FileReader("input.txt"));
		out=new PrintWriter("output.txt");
		new Thread(new Task()).start();
	}


	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;
	
	String nline() {
		try {
			return br.readLine().trim();
		} catch (Exception e) {
			return null;
		}
	}
	
	String ns(){
		try{
			while(st==null || !st.hasMoreTokens()){
				st=new StringTokenizer(br.readLine());
			}
			return st.nextToken();
		}catch(Exception e){
			return null;
		}
	}
	
	int ni(){
		return Integer.valueOf(ns());
	}
	
	long nl(){
		return Long.valueOf(ns());
	}
	
	double nd(){
		return Double.valueOf(ns());
	}

	final int maxSize = 6100;
	boolean[][] hasLeft = new boolean[maxSize][maxSize];
	boolean[][] hasBottom = new boolean[maxSize][maxSize];
	byte[][] config = new byte[maxSize][maxSize]; 
	
	        
	//int[][] dirs = {{0, 1}, {0, -1}, {1, 0}, {-1, 0}};
	
	
	int[][] dirs = {{0, 1}, {1, 0}, {0, -1}, {-1, 0}};
	
	public void run(){
		//Place your code here
		int T = ni();
		for (int t = 1; t <= T; t++) {
			/*
			
			for (boolean[] tmp : hasLeft)
				Arrays.fill(tmp, false);
			for (boolean[] tmp : hasBottom)
				Arrays.fill(tmp, false);
			for (byte[] tmp : config)
				Arrays.fill(tmp, (byte)0);
			*/
			

			
			int L = ni();
			
			int x = maxSize / 2;
			int y = maxSize / 2;
			
			int minX = x;
			int maxX = x;
			int minY = y;
			int maxY = y;
			
			int dir = 0;
			for (int i = 0; i < L; i++) {
				char[] chars = ns().toCharArray();
				int times = ni();
				
				for (int time = 0; time < times; time++) {
					for (char ch : chars) {
						switch (ch) {
						case 'L':
							dir = (dir + 3) % 4;
							break;
						case 'R':
							dir = (dir + 1) % 4;
							break;
						case 'F':
							switch (dir) {
							case 0:
								hasLeft[x][y] = true;
								break;
							case 1:
								hasBottom[x][y] = true;
								break;
							case 2:
								hasLeft[x][y - 1] = true;
								break;
							case 3:
								hasBottom[x - 1][y] = true;
								break;
							}
							x += dirs[dir][0];
							y += dirs[dir][1];
							
							minX = min(minX, x);
							maxX = max(maxX, x);
							minY = min(minY, y);
							maxY = max(maxY, y);
							break;
						}
					}
				}
			}
			
			minY -= 20;
			maxY += 20;
			minX -= 20;
			maxX += 20;
			
			for (y = minY; y < maxY; y++) {
				boolean was = false;
				boolean inside = false;
				for (x = minX; x < maxX; x++) {
					was |= hasLeft[x][y];
					inside ^= hasLeft[x][y];
					if (was && !inside)
						config[x][y] |= 1 << 0; 
				}
				was = false;
				inside = false;
				for(x = maxX; x >= minX; x--) {
					if (was && !inside)
						config[x][y] |= 1 << 1;
					was |= hasLeft[x][y];
					inside ^= hasLeft[x][y];
				}
			}
			
			for (x = minX; x < maxX; x++) {
				boolean was = false;
				boolean inside = false;
				for (y = minY; y < maxY; y++) {
					if (was && !inside)
						config[x][y] |= 1 << 2;
					was |= hasBottom[x][y];
					inside ^= hasBottom[x][y];
				}
				was = false;
				inside = false;
				for (y = maxY + 2; y >= minY; y--) {
					was |= hasBottom[x][y];
					inside ^= hasBottom[x][y];
					if (was && !inside) 
						config[x][y] |= 1 << 3;
				}
			}
			
			int ans = 0;
			int mask = (1 << 0) | (1 << 1);
			int mask1 = (1 << 2) | (1 << 3);
			for (x = minX; x < maxX; x++)
				for (y = minY; y < maxY; y++) {
					int cfg = config[x][y];
					if ((cfg & mask) == mask || (cfg & mask1) == mask1) ans++;
				}
			out.println("Case #" + t + ": " + ans);
			
			for ( x = minX; x <= maxX; x++)
				for ( y = minY; y <= maxY; y++) {
					hasLeft[x][y] = false;
					hasBottom[x][y] = false;
					config[x][y] = 0;
				}
		}
		out.close();
	}
	
}
