import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;

public class Task implements Runnable {
	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader("input.txt"));
		out = new PrintWriter("output.txt");

		new Thread(new Task()).start();
	}

	static BufferedReader br;
	static PrintWriter out;
	StringTokenizer st;

	String nline() {
		try {
			return br.readLine().trim();
		} catch (Exception e) {
			return null;
		}
	}

	String ns() {
		try {
			while (st == null || !st.hasMoreTokens()) {
				st = new StringTokenizer(nline());
			}
			return st.nextToken();
		} catch (Exception e) {
			return null;
		}
	}

	int ni() {
		return Integer.valueOf(ns());
	}

	double nd() {
		return Double.valueOf(ns());
	}

	boolean isIn(double x, double y, double R) {
		return x * x + y * y <= R * R;
	}
	
	double Seg(double R, double r) {
		double h = sqrt(R * R - r * r);
		double alpha = acos(r / R);
		return .5 * alpha * R * R - .5 * r * h;
	}
	
	double Spart(double y1, double y2, double R) {
		return Seg(R, y2) - Seg(R, y1);
	}

	public void run() {
		// Place your code here
		int T = ni();
		for (int test = 1; test <= T; test++) {
			double f = nd();
			double R = nd();
			double t = nd();
			double r = nd();
			double g = nd();

			double totalSquare = PI * R * R / 4;
			R -= t + f;
			r += f;
			g -= 2 * f;

			double ans;

			if (g <= 0) {
				ans = 1;
			} else {
				double y1 = r;
				double goodSquare = 0;
				while (true) {
					double x1 = r;
					int cnt = 0;
					while (true) {
						double x2 = x1 + g;
						double y2 = y1 + g;
						double d1 = sqrt(x1 * x1 + y1 * y1);
						double d2 = sqrt(x2 * x2 + y2 * y2);
						if (d1 >= R)
							break; // end of row
						cnt++;
						if (d2 <= R) {
							goodSquare += g * g; // the whole square
							x1 += g + 2 * r;
							continue;
						}
						boolean in1 = isIn(x1, y2, R);
						boolean in3 = isIn(x2, y1, R);

						double dy1, dy2;
						double ds = 0;
						if (in1 && in3) {
							dy1 = y2;
							dy2 = sqrt(R * R - x2 * x2);
							ds = g * (dy2 - y1);
						} else 
							if (in1 && !in3) {
								dy1 = y2;
								dy2 = y1;
							} else 
								if (!in1 && in3) {
									dy1 = sqrt(R * R - x1 * x1);
									dy2 = sqrt(R * R - x2 * x2);
									ds =  g * (dy2 - y1);
								} else {
									dy1 = sqrt(R * R - x1 * x1);
									dy2 = y1;
								}
						ds -= (dy1 - dy2) * x1;
						double curSquare = Spart(dy1, dy2, R);
						curSquare += ds;
						goodSquare += curSquare;
						
						
						x1 += g + 2 * r;
					}
					if (cnt == 0) break;
					y1 += g + 2 * r;
				}
				
				ans = 1 - goodSquare / totalSquare;
			}
			out.print("Case #" + test + ": ");
			out.printf("%.8f", ans);
			out.println();
			
		}

		out.close();
	}
}