import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;

public class Task implements Runnable {
	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("input.txt"));
		out = new PrintWriter("output.txt");
		
		new Thread(new Task()).start();
	}
	
	static BufferedReader br;
	static PrintWriter out;
	StringTokenizer st;
	
	String nline() {
		try {
			return br.readLine();
		} catch (Exception e) {
			return null;
		}
	}
	
	String ns() {
		try { 
			while (st == null || !st.hasMoreTokens()) {
				st = new StringTokenizer(nline());
			}
			return st.nextToken();
		} catch (Exception e) {
			return null;
		}
	}
	
	int ni() {
		return Integer.valueOf(ns());
	}
	
	public void run() {
		//Place your code here
		int T = Integer.parseInt(nline().trim());
		for (int t = 0; t < T; t++) {
			HashMap<String, Integer> emap = new HashMap<String, Integer>();
			int n = Integer.parseInt(nline().trim());
			for (int i = 0; i < n; i++) {
				String name = nline();
				emap.put(name, i);
			}
			int qn = Integer.parseInt(nline().trim());
			int[][] minCost = new int[2][n];
			
			int cur = 0;
			int next = 1;

			Arrays.fill(minCost[next], Integer.MAX_VALUE);
			
			for (int q = 0; q < qn; q++) {
				String query = nline();
				int fId = -1;
				if (emap.containsKey(query)) fId = emap.get(query);
				
				for (int i = 0; i < n; i++)
					if (minCost[cur][i] != Integer.MAX_VALUE)
						for (int j = 0; j < n; j++)
							if (j != fId) {
								int newCost = minCost[cur][i];
								if (i != j) newCost++;
								minCost[next][j] = min(minCost[next][j], newCost);
							}
				Arrays.fill(minCost[cur], Integer.MAX_VALUE);
				cur = 1 - cur;
				next = 1 - next;
			}
			
			int ans = minCost[cur][0];
			for (int i = 1; i < n; i++)
				ans = min(ans, minCost[cur][i]);
			out.println("Case #" + (t + 1) +": " + ans);
			
		}
		out.close();
	}
}