import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;

public class Task implements Runnable{

	public static void main(String[] args) throws IOException{
		br=new BufferedReader(new FileReader("input.txt"));
		out=new PrintWriter("output.txt");
		new Thread(new Task()).start();
	}


	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;
	
	String nline() {
		try {
			return br.readLine().trim();
		} catch (Exception e) {
			return null;
		}
	}
	
	String ns(){
		try{
			while(st==null || !st.hasMoreTokens()){
				st=new StringTokenizer(br.readLine());
			}
			return st.nextToken();
		}catch(Exception e){
			return null;
		}
	}
	
	int ni(){
		return Integer.valueOf(ns());
	}
	
	long nl(){
		return Long.valueOf(ns());
	}
	
	double nd(){
		return Double.valueOf(ns());
	}

	
	public void run(){
		//Place your code here
		int T = ni();
		for (int t = 1; t <= T; t++) {
			int R = ni();
			int C = ni();
			
			boolean[][] bad = new boolean[R + 1][C + 1];
			int[][] memo = new int[R + 1][C + 1];
			memo[1][1] = 1;
			
			int bn = ni();
			
			for(int i = 0; i < bn; i++) {
				int r = ni();
				int c = ni();
				bad[r][c] = true;
			}
				
			
			for (int r = 1; r <= R; r++)
				for (int c = 1; c <= C; c++)
					for (int dr = 1; dr <= 2; dr++)
						for (int dc = 1; dc <= 2; dc++) {
							if (dr * dr + dc * dc != 5) continue;
							int nr = r + dr;
							int nc = c + dc;
							if (nr < 1 || nr > R || nc < 1 || nc > C) continue;
							if (bad[nr][nc]) continue;
							memo[nr][nc] = (memo[nr][nc] + memo[r][c]) % 10007;
						}
			
			out.println("Case #" + t + ": " + memo[R][C]);
		}
		out.close();
	}
	
}
