import java.io.*;
import java.util.*;
import java.math.*;
import static java.lang.Math.*;

public class Task implements Runnable {
	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new FileReader("input.txt"));
		out = new PrintWriter("output.txt");
		
		new Thread(new Task()).start();
	}
	
	static BufferedReader br;
	static PrintWriter out;
	StringTokenizer st;
	
	String nline() {
		try {
			return br.readLine().trim();
		} catch (Exception e) {
			return null;
		}
	}
	
	String ns() {
		try { 
			while (st == null || !st.hasMoreTokens()) {
				st = new StringTokenizer(nline());
			}
			return st.nextToken();
		} catch (Exception e) {
			return null;
		}
	}
	
	int ni() {
		return Integer.valueOf(ns());
	}
	
	int conv(String s) {
		return Integer.valueOf(s.substring(0, 2)) * 60 + Integer.valueOf(s.substring(3));
	}
	
	public void run() {
		//Place your code here
		int T = ni();
		for (int t = 0; t < T; t++) {
			int mx = 2000;
			int[] tableA = new int[mx];
			int[] tableB = new int[mx];
			int turnTime = ni();
			int na = ni();
			int nb = ni();
			
			for (int i = 0; i < na; i++) {
				int start = conv(ns());
				int finish = conv(ns());
				tableA[start]--;
				tableB[finish + turnTime]++;
			}
			
			for (int i = 0; i < nb; i++) {
				int start = conv(ns());
				int finish = conv(ns());
				tableB[start]--;
				tableA[finish + turnTime]++;
			}
			
			int ansA = 0;
			int acc = 0;
			for (int i = 0; i < mx; i++) {
				acc += tableA[i];
				if (acc < 0) {
					ansA += -acc;
					acc = 0;
				}
			}
			int ansB = 0;
			acc = 0;
			for (int i = 0; i < mx; i++) {
				acc += tableB[i];
				if (acc < 0) {
					ansB += -acc;
					acc = 0;
				}
			}
			out.println("Case #" + (t + 1) +": " + ansA + " " + ansB);
		}
		out.close();
	}
}