package problemb;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.StringTokenizer;

import libs.Inputer;

public class ProblemB {
	public static void main(String[] args) {
		Inputer file = new Inputer("inputs/B-small-attempt0.in");
		BufferedWriter writer = null;
		
		try {
			writer = new BufferedWriter(new FileWriter("outputs/B-small.out"));
		}
		catch(IOException ioe){}
		
		int cases = file.IntData();
		for(int cse = 0; cse < cases; ++cse) { // casos
			int delay = file.IntData(), trainsA = 0, trainsB = 0;
			int numTrips[] = {file.IntData(), file.IntData()};
			
			LinkedList<Set>[] timeTable = new LinkedList[2];
			for(int i = 0; i < timeTable.length; ++i) {
				timeTable[i] = new LinkedList<Set>();
				for(int trip = 0; trip < numTrips[i]; ++trip)
					timeTable[i].add(new Set(file.Data(), file.Data(), delay));
			}
			
			Collections.sort(timeTable[0]);
			Collections.sort(timeTable[1]);
			
			while(timeTable[0].size() > 0 || timeTable[1].size() > 0) {
				Set actual;
				boolean firstA;
				if((timeTable[0].size() > 0 ? timeTable[0].getFirst() : new Set("99:99", "99:99", 0)).compareTo((timeTable[1].size() > 0 ? timeTable[1].getFirst(): new Set("99:99", "99:99", 0))) <= 0) {
					actual = timeTable[0].getFirst();
					++trainsA;
					firstA = true;
				}
				else {
					actual = timeTable[1].getFirst();
					++trainsB;
					firstA = false;
				}
				
				Set temp = actual;
				for(int i = (firstA ? 0 : 1); true; i = ++i % 2) {
					timeTable[i].remove(temp);
					
					ListIterator<Set> iterator;
					Set check = null;
					for(iterator = timeTable[(i == 0 ? 1 : 0)].listIterator(); iterator.hasNext();) {
						check = iterator.next();
						if(temp.Arrival <= check.Departure) {
							temp = check;
							break;
						}
					}
					
					if(temp != check && !iterator.hasNext())
						break;
				}
			}
			
			/*
			while(timeTableA.size() > 0 || timeTableB.size() > 0) {
				Set earlier = null;
				boolean earlierFromA = true;
				
				if(timeTableA.size() > 0){
					earlier = timeTableA.getFirst();
					earlierFromA = true;
				}
				if(timeTableB.size() > 0) {
					if(earlier == null || earlier.compareTo(timeTableB.getFirst()) > 0) {
						earlier = timeTableB.getFirst();
						earlierFromA = false;
						++trainsB;
					}
					else
						++trainsA;
				}
				else
					++trainsA;
				
				ListIterator<Set> iterator;
				do {
					iterator = (earlierFromA ? timeTableB : timeTableA).listIterator();
					while(iterator.hasNext()) {
						Set s = iterator.next();
						if(s.Departure >= earlier.Arrival) {
							(earlierFromA ? timeTableA : timeTableB).remove(earlier);
							earlier = s;
							break;
						}
					}
					earlierFromA = !earlierFromA;
				} while(iterator.hasNext());
				(earlierFromA ? timeTableB : timeTableA).remove(earlier);
			} */
			
			// Writes the output
			try {
				writer.write("Case #" + (cse + 1) + ": " + trainsA + " " + trainsB);
				writer.newLine();				
			}
			catch(IOException ioe) {}
			
			
		} // fin del for de los casos
		
		// Closes the output file
		try {
			writer.close();
		}
		catch(IOException ioe) {}
	}
}

class Set implements Comparable<Set> {
	public int Departure, Arrival;
	
	public Set(String dep, String arr, int delay) {
		StringTokenizer tok = new StringTokenizer(dep, ":"); 
		Departure =  Integer.parseInt(tok.nextToken()) * 60 + Integer.parseInt(tok.nextToken());
		tok = new StringTokenizer(arr, ":"); 
		Arrival =  Integer.parseInt(tok.nextToken()) * 60 + Integer.parseInt(tok.nextToken()) + delay;
	}

	public int compareTo(Set comp) {
		return Departure - comp.Departure;
	}	
}