package problema;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

import libs.*;

public class ProblemA {
	public static void main(String[] args) {
		Inputer file = new Inputer("inputs/A-small-attempt1.in");
		BufferedWriter writer = null;
		
		try {
			writer = new BufferedWriter(new FileWriter("outputs/A-small.out"));
		}
		catch(IOException ioe){}
		
		int cases = file.IntData();
		for(int cse = 0; cse < cases; ++cse) { // casos
			LinkedList<String> list = new LinkedList<String>();
			int pos = 0, switches = 0;
			
			// lee search engines
			int nSE = file.IntData();
			String[] engines = new String[nSE];
			for(int engine = 0; engine < nSE; ++engine)
				engines[engine] = file.Line();
			
			// lee queries
			int nQ = file.IntData();
			String[] queries = new String[nQ];
			for(int query = 0; query < nQ; ++query)
				queries[query] = file.Line();
			
			while(pos != -1) {
				loadEngines(nSE, engines, list);
				pos = getFirstLast(pos, nQ, queries, list);
				++switches;
			}
			
			try {
				writer.write("Case #" + (cse + 1) + ": " + --switches);
				writer.newLine();				
			}
			catch(IOException ioe) {}
			
			
		} // fin del for de los casos
		
		try {
			writer.close();
		}
		catch(IOException ioe) {}
	}
	
	public static void loadEngines(int nSE, String engines[], LinkedList<String> list) {
		for(int engine = 0; engine < nSE; ++engine)
			list.add(engines[engine]);
	}
	
	public static int getFirstLast(int pos, int nQ, String queries[], LinkedList<String> list) {
		for(int query = pos; query < nQ; ++query) {			
			if(list.size() > 1)
				list.remove(queries[query]);
			if(list.size() == 1 && list.contains(queries[query])) {
				list.remove();
				return query;
			}
		}
		
		return -1;
	}
}
