package libs;

import java.io.*;
import java.util.StringTokenizer;

public class Inputer {
	private BufferedReader  mFile;
	private String          mLine;
	private String          mToken;
	private String          mDelim;
	private StringTokenizer mTokenizer;
	
	// ========================== NEEDED ===============================

	public Inputer(String path, String delim) {
		try {
			mFile      = new BufferedReader(new FileReader(path));
			mLine      = mFile.readLine();
			mDelim     = delim;
			mTokenizer = new StringTokenizer(mLine, mDelim);
			mToken     = mTokenizer.nextToken();
		}
		catch(Exception e) {
			System.out.println("File Open Error");
		}
	}
	
	public String Line() {		
		String old = mLine;
		try {
			mLine      = mFile.readLine();
			mTokenizer = new StringTokenizer(mLine, mDelim);
			mToken     = mTokenizer.nextToken();
		}
		catch(Exception e) {}
		return old;
	}
	
	public String Data() {
		String old = mToken;
		
		if(mTokenizer.hasMoreTokens())
			mToken = mTokenizer.nextToken();
		else
			Line();	
		
		return old;
	}
	
	// ========================== NOT NEEDED ===============================
	
	public Inputer(String path) {
		this(path, " ");
	}
	
	public void Close() {
		try {
			mFile.close();
		}
		catch(Exception e) {}
	}
	
	public int IntData() {
		return Integer.parseInt(Data());
	}
	
	public long LongData() {
		return Long.parseLong(Data());
	}
	
	public float FloatData() {
		return Float.parseFloat(Data());
	}
	
	public double DoubleData() {
		return Double.parseDouble(Data());
	}
	
	public String Peek() {
		return mToken;
	}
	
	public boolean Peek(String comp) {
		return (mToken.compareTo(comp) != 0);
	}
}