package codejam13;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class ManageEnergy {
	public void solve(String input, String output) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader(input));
		BufferedWriter out = new BufferedWriter(new FileWriter(output));
		String line = in.readLine();
		int T = Integer.parseInt(line);
		int index = 1;

		while (T > 0) {
			String[] dims = in.readLine().split(" ");
			int E = Integer.parseInt(dims[0]);
			int R = Integer.parseInt(dims[1]);
			int N = Integer.parseInt(dims[2]);
			int[] v = new int[N];

			dims = in.readLine().split(" ");
			for (int i = 0; i < N; ++i) {
				v[i] = Integer.parseInt(dims[i]);
			}

			long result = getMaxGain(E, R, N, v);

			out.write("Case #" + index + ": " + result);
			out.newLine();

			--T;
			++index;
		}

		in.close();
		out.close();
	}

	private long getMaxGain(int E, int R, int N, int[] v) {
		long result = 0;
		R = Math.min(E, R);
		int pre = Integer.MIN_VALUE;
		for (int i = 0; i < N; ++i) {
			if (v[i] > pre) {
				pre = v[i];
			}
		}
		for (int i = 0; i < N; ++i) {
			if (v[i] == pre) {
				result += E*v[i];
			} else {
				result += R*v[i];
			}
		}
		return result;
	}
}
