import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;



public class GoroSort {
	
	public static void main(String[] args) throws IOException {
		if (args.length < 2) {
			return;
		}
		BufferedReader reader = new BufferedReader(new FileReader(args[0]));
		BufferedWriter writer = new BufferedWriter(new FileWriter(args[1]));
		GoroSort goro = new GoroSort();
		int T = Integer.valueOf(reader.readLine());
		for (int i = 0; i < T; i++) {
			int N = Integer.valueOf(reader.readLine());
			goro.init(reader.readLine(), N);
			writer.append("Case #" + (i + 1) + ": ");
			writer.append(String.valueOf(goro.start()));
			writer.newLine();
		}
		reader.close();
		writer.close();
	}

	private boolean[] occurance = null;
	private int[] list = null;
	private int[] partition = null;
	
	private void init(String s, int n) {
		String[] seq = s.split(" ");
		assert(seq.length == n);
		occurance = new boolean[n];
		list = new int[n];
		partition = new int[n];
		for (int i = 0; i < seq.length; i++) {
			list[i] = Integer.valueOf(seq[i]) - 1; // Convert to 0-indexed array
		}
	}
	
	private double start() {
		double result = 0;
		for (int i : list) {
			if (!occurance[i]) {
				partition[partition(i)]++;
			}
		}
		for (int i = 0; i < partition.length; i++) {
			result += i * partition[i] * 2;
		}
		return result;
	}
	
	private int partition(int i) {
		int result = 0;
		while (true) {
			occurance[i] = true;
			i = list[i];
			if (i == list[i] || occurance[i]) {
				break;
			}
			result++;
		}
		return result;
	}
}
