package google;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;


public class FairSquare {
	public static void main(String[] args) 
	{
		
		ArrayList<Long> listOfSquareFareNumbers = createList(1,100000000000000L);
		for(Long i : listOfSquareFareNumbers)
			System.out.println(i);
		
		String size = "large";
		File fileToRead = new File("./data13/C-"+size+".in");
		FileReader fr;
		try 
		{

			fr = new FileReader(fileToRead);
			BufferedReader br = new BufferedReader(fr);
			String line = br.readLine();
			int nbOfInstances = Integer.parseInt(line);

			for(int ins = 0 ; ins<nbOfInstances ; ins++)
			{
				System.out.println("instance "+(ins+1));
				
				line = br.readLine();
				String[] bounds = line.split(" ");
				long a = Long.parseLong(bounds[0]);
				long b = Long.parseLong(bounds[1]);
				System.out.println(a+" " +b);
				
				int cpt = 0;
				for(Long i : listOfSquareFareNumbers )
				{	
					if(a<= i && i<= b)
						cpt++;
					if(i>b)
						break;
				}

				String toWrite = cpt+"";
				writeResults("/results/C-"+size+"-results.txt", true, "Case #"+(ins+1)+": "+toWrite+"\n");
			}


		} catch (FileNotFoundException e) {e.printStackTrace();} 
		catch (IOException e) {e.printStackTrace();}



	}

	private static ArrayList<Long> createList(long a, long l)
	{
		ArrayList<Long> list = new ArrayList<Long>();
		long minRoot = (long) Math.sqrt(a);
		long maxRoot = (long) Math.sqrt(l);
		
		for(long n = minRoot ; n<=maxRoot ; n++)
		{
			if(isPalindrom(n) && isPalindrom((int)Math.pow(n,2)))
				list.add((long)Math.pow(n, 2));
		}
		
		return list;
	}
	
	private static boolean isPalindrom(long nb) 
	{
		String[] chiffres = (nb+"").split("");
		int length = chiffres.length;
		
		for(int i=1 ; i <=length/2 ; i++)
		{
			if(!chiffres[i].contains(chiffres[length-i]))
				return false;
		}
		
		return true;
	}

	public static void writeResults(String name, boolean writeAfter, String result) {
		FileWriter writer = null;
		String path = System.getProperty("user.dir");
		try{
			writer = new FileWriter(path + name, writeAfter);
			writer.write(result);
		}catch(IOException ex){ex.printStackTrace();}
		finally{
			if(writer != null){
				try {
					writer.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
