package google;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;



public class TicTackToeTomek {



	public static void main(String[] args) 
	{
		String size = "small";
		File fileToRead = new File("./data13/A-"+size+"-practice.in");
		FileReader fr;
		try 
		{

			fr = new FileReader(fileToRead);
			BufferedReader br = new BufferedReader(fr);
			String line = br.readLine();
			int nbOfInstances = Integer.parseInt(line);

			int[][] square = new int[4][4];

			for(int i=0;i<nbOfInstances ; i++)
			{

				boolean fullSquare =true;
				for(int l=0;l<4;l++)
				{
					line = br.readLine();
					String[] row = line.split("");
					for(int k = 0 ; k < 4 ; k++)
					{
						if(row[k+1].contains(".")){
							square[l][k]=0;
							fullSquare = false;
						}
						if(row[k+1].contains("X"))
							square[l][k]=10;
						if(row[k+1].contains("O"))
							square[l][k]=-10;
						if(row[k+1].contains("T"))
							square[l][k]=1;
					}
				}
				br.readLine();

				String cs = checkSquare(square);
				
				
				String toWrite=null;
				if(cs=="X"|| cs == "O")
					toWrite =cs+" won";
				if(cs=="D" && !fullSquare)
					toWrite = "Game has not completed";
				if(cs=="D" && fullSquare)
					toWrite= "Draw";
				
				
				writeResults("/results/A-"+size+"-practice.txt", true, "Case #"+(i+1)+": "+toWrite+"\n");
			}


		} catch (FileNotFoundException e) {e.printStackTrace();} 
		catch (IOException e) {e.printStackTrace();}
	}


	private static String checkSquare(int[][] square) 
	{	
		int sum;
		//checking Rows
		for(int i=0;i<square.length;i++)
		{
			sum = square[i][0]+square[i][1]+square[i][2]+square[i][3];
			if(sum == 40|| sum == 31)
				return "X";
			if(sum == -40 || sum==-29)
				return "O";
		}
		//checking Columns
		for(int i=0;i<square.length;i++)
		{
			sum = square[0][i]+square[1][i]+square[2][i]+square[3][i];
			if(sum == 40|| sum == 31)
				return "X";
			if(sum == -40 || sum==-29)
				return "O";
		}
		//checking Diagonals
		sum = square[0][0]+square[1][1]+square[2][2]+square[3][3];
		if(sum == 40|| sum == 31)
			return "X";
		if(sum == -40 || sum==-29)
			return "O";
		sum = square[0][3]+square[1][2]+square[2][1]+square[3][0];
		if(sum == 40|| sum == 31)
			return "X";
		if(sum == -40 || sum==-29)
			return "O";
		
		return "D";

	}


	public static void writeResults(String name, boolean writeAfter, String result) {
		FileWriter writer = null;
		String path = System.getProperty("user.dir");
		try{
			writer = new FileWriter(path + name, writeAfter);
			writer.write(result);
		}catch(IOException ex){ex.printStackTrace();}
		finally{
			if(writer != null){
				try {
					writer.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}

}
