package google;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;

public class Lawnmower 
{
	public static void main(String[] args) 
	{
		int minHeight0 = 1;
		int maxHeight0 = 100;
		String size = "large";
		File fileToRead = new File("./data13/B-"+size+".in");
		FileReader fr;
		try 
		{

			fr = new FileReader(fileToRead);
			BufferedReader br = new BufferedReader(fr);
			String line = br.readLine();
			int nbOfInstances = Integer.parseInt(line);
			
			for(int ins = 0 ; ins<nbOfInstances ; ins++)
			{
				int  minHeight = minHeight0;
				int maxHeight = maxHeight0;
				
				System.out.println("instance "+(ins+1));
				line = br.readLine();
				String[] dim = line.split(" ");
				int n = Integer.parseInt(dim[0]);
				int m = Integer.parseInt(dim[1]);
			
				HashMap<Integer,ArrayList<Integer[]>> heightMap = new HashMap<Integer, ArrayList<Integer[]>>(maxHeight0-minHeight0+1);
				for(int h = minHeight ; h <= maxHeight ; h++)
				{
					ArrayList<Integer[]> als = new ArrayList<Integer[]>();
					heightMap.put(h,als);
				}
				
				int [][] rectangle = new int[n][m];
				maxHeight = 0;
				for(int i=0; i<n; i++)
				{
					line = br.readLine();
					String[] row = line.split(" ");
					
					for(int j = 0 ; j < m ; j++)
					{
						rectangle[i][j] = Integer.parseInt(row[j]);
						
						
						
						Integer[] coord = new Integer[]{i,j};
						
						heightMap.get(rectangle[i][j]).add(coord);
						
						if(rectangle[i][j] > maxHeight)
							maxHeight = rectangle[i][j];
					}
				}
				
				//printMap(heightMap);
				//printRec(rectangle);
				
				boolean b = isFeasiblePattern(heightMap,n,m,minHeight,maxHeight, rectangle);
				
				String toWrite;
				
				if(b)
					toWrite = "YES";
				else
					toWrite = "NO";
				
				writeResults("/results/B-"+size+"-results.txt", true, "Case #"+(ins+1)+": "+toWrite+"\n");
			}


		} catch (FileNotFoundException e) {e.printStackTrace();} 
		catch (IOException e) {e.printStackTrace();}
	}


	
	private static boolean isFeasiblePattern(
			HashMap<Integer, ArrayList<Integer[]>> heightMap, int n, int m,
			int minHeight, int maxHeight,int[][]rectangle) {

		if(n==1||m==1)
			return true;
		
		
		for(int h = minHeight ; h <= maxHeight ; h++ )
		{
			ArrayList<Integer[]> ali = heightMap.get(h);
			while ( ali.size() > 0 )
			{
				//check if column is possible
				int col =ali.get(0)[1];
				boolean colOK = true;
				for(int i=0 ; i<n ; i++ )
				{
					if(!(rectangle[i][col]<=h))
					{
						colOK = false;
						break;
					}
				}
				
				//if column is not ok, check if row is possible 
				int row = ali.get(0)[0];
				if(!colOK)
				{
					
					//boolean rowOK = true;
					for(int j=0;j<m;j++)
					{
						if(!(rectangle[row][j]<=h))
						{
							return false;
						}
					}
				}
				
				
				if(colOK)
				{
					int aliSize = ali.size();
					for(int k = aliSize-1 ; k>=0; k--)
					{
						if(ali.get(k)[1] == col)
							ali.remove(k);
					}
				}
				else //if rowOK == true
				{
					int aliSize = ali.size();
					for(int k = aliSize-1 ; k>=0; k--)
					{
						if(ali.get(k)[0]==row)
							ali.remove(k);
					}
				}

			}
		}
		
		return true;
	}



//	private static void printMap(HashMap<Integer,ArrayList<Integer[]>> heightMap) 
//	{
//		for(Integer h :heightMap.keySet())
//		{
//			System.out.println(h);
//			for(Integer[] s : heightMap.get(h))
//			{
//				System.out.print("x"+s[0]+"y"+s[1]+" ");	
//				
//			}
//			System.out.println("");
//		}
//		System.out.println("");
//	}

//
//	private static void printRec(int[][] rectangle) {
//
//		for(int i=0 ; i<rectangle.length ; i++)
//		{
//			for(int j=0 ; j < rectangle[0].length ; j++)
//				System.out.print(rectangle[i][j]+"\t");
//		System.out.println();
//		}
//			System.out.println();
//		
//	}



	public static void writeResults(String name, boolean writeAfter, String result) {
		FileWriter writer = null;
		String path = System.getProperty("user.dir");
		try{
			writer = new FileWriter(path + name, writeAfter);
			writer.write(result);
		}catch(IOException ex){ex.printStackTrace();}
		finally{
			if(writer != null){
				try {
					writer.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
		}
	}
}
