import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

class Entry
{
	final int L,R;
	final double position,level;
	public Entry(int L,int R,double p,double l)
	{
		this.L=L;
		this.R=R;
		this.position=p;
		this.level=l;
	}
	public Entry[] divide()
	{
		Entry[] rst = new Entry[2];
		rst[0] = new Entry((L-1)/2,L/2,position-level,level/2);
		rst[1] = new Entry((R-1)/2,R/2,position+level,level/2);
		return rst;
	}
	public boolean equals(Object o)
	{
		return o==this;
	}
	public int hashCode()
	{
		return L ^ R ^ ((Double)position).hashCode() ^ ((Double)level).hashCode();
	}
}

public class ProblemC 
{

	static int N,K;
	static void read(Scanner in)
	{
		N = in.nextInt();
		K = in.nextInt();
	}
	static Entry solve()
	{
		PriorityQueue<Entry> queue = new PriorityQueue<>(K,new Comparator<Entry>(){

			@Override
			public int compare(Entry o1, Entry o2) {
				if(o1.L!=o2.L)
					return o2.L-o1.L;
				if(o1.R!=o2.R)
					return o2.R-o1.R;
				if(o1.position<o2.position)
					return -1;
				if(o1.position>o2.position)
					return 1;
				return 0;
			}});
		queue.add(new Entry((N-1)/2,N/2,0,0.5));
		for(int i=1;i<K;i++)
		{
			Entry e = queue.poll();
			for(Entry x:e.divide())
				queue.add(x);
		}
		return queue.poll();
	}
	
	public static void main(String args[])
	{
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for(int t=1;t<=T;t++)
		{
			read(in);
			Entry e = solve();
			System.out.println("Case #"+t+": "+e.R+" "+e.L);
		}
		in.close();
	}
}
