package ru.altazar.contest2017.round1b;

import ru.altazar.Problem;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class CruiseControl extends Problem {

    @Override
    protected String solveCase(BufferedReader reader) throws IOException {

        String[] road = reader.readLine().split(" ");
        int dest = Integer.parseInt(road[0]);
        int numHorses = Integer.parseInt(road[1]);

        List<Horse> horses = new ArrayList<>();
        for (int i = 0; i < numHorses; i++) {
            horses.add(new Horse(reader.readLine().split(" ")));
        }

        double maxSpeed = Double.MAX_VALUE;
        for (Horse horse : horses) {
            double speed = ((dest * 1.) / (dest - horse.position)) * horse.speed;

            if (speed < maxSpeed) {
                maxSpeed = speed;
            }
        }


        return String.valueOf(maxSpeed);
    }


    private static class Horse {
        int position;
        int speed;

        public Horse(String[] split) {
            this.position = Integer.parseInt(split[0]);
            this.speed = Integer.parseInt(split[1]);
        }
    }
}
