import java.io.File;
import java.io.PrintWriter;
import java.util.*;

public class LoadTesting {


	public static void main(String[] args) throws Exception {
		Scanner scanner = new Scanner(new File("B-large.in"));
		PrintWriter pw = new PrintWriter(new File("output.out"));
		LoadTesting lt = new LoadTesting();

		int cases = scanner.nextInt();

		for (int i = 0; i < cases; i++) {
			int L = scanner.nextInt();
			int P = scanner.nextInt();
			int C = scanner.nextInt();

			pw.write("Case #" + (i + 1) + ": " + lt.countTests(L, P, C) + "\n");
		}

		scanner.close();
		pw.close();
	}

	private int countTests(int l, int p, int c) {
		Vector<Integer> lowerPoints = new Vector<Integer>();
		Vector<Integer> upperPoints = new Vector<Integer>();
		int lower = l;
		int upper = p;
		lowerPoints.add(l);
		upperPoints.add(p);

		while (true) {
			lower = c * lower;
			if (upperPoints.firstElement() <= lower) {
				break;
			}
			lowerPoints.add(lower);
			
			upper = (upper / c) + (upper % c > 0 ? 1 : 0);
			if (lowerPoints.lastElement() >= upper) {
				break;
			}
			upperPoints.add(0, upper);
		}
		
		List<Integer> result = new ArrayList<Integer>();
		result.addAll(lowerPoints.subList(1, lowerPoints.size()));
		result.addAll(upperPoints.subList(0, upperPoints.size() - 1));

		return calcTests(result);
	}

	private int calcTests(List<Integer> list) {
		int leftResult = 0;
		int rightResult = 0;
		
		if (list.size() == 0){
			return 0;
		}
		
		int index = list.size() / 2;
		
		if (index != 0){
			List left = list.subList(0, index);
			leftResult = calcTests(left);
		}
		if (index != list.size() - 1){
			List right = list.subList(index + 1, list.size());
			rightResult = calcTests(right);
		}
		return 1 + ((leftResult > rightResult)? leftResult : rightResult);
	}
}
