import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class FileFix {

	private static class TreeNode {
		private static int _counter = 0;
		private String _name;
		private Map<String, TreeNode> _children = new HashMap<String, TreeNode>();

		public TreeNode(String name) {
			_name = name;
		}

		public String toString() {
			return _name;
		}

		public void addPath(List<String> path) {
			if (path.size() == 0) {
				return;
			}
			if (!_children.containsKey(path.get(0))) {
				TreeNode child = new TreeNode(path.get(0));
				_children.put(child.toString(), child);
				_counter++;
			}
			_children.get(path.get(0)).addPath(path.subList(1, path.size()));
		}

		public int getCounter(){
			return _counter;
		}
		
		public void resetCounter() {
			_counter = 0;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Scanner scanner = new Scanner(new File("A-small-attempt0.in"));
		PrintWriter pw = new PrintWriter(new File("output.out"));
		FileFix ff = new FileFix();

		int cases = scanner.nextInt();

		for (int i = 0; i < cases; i++) {
			int n = scanner.nextInt();
			int m = scanner.nextInt();
			String[] exists = new String[n];
			String[] create = new String[m];

			for (int j = 0; j < n; j++) {
				exists[j] = scanner.next();
			}
			for (int j = 0; j < m; j++) {
				create[j] = scanner.next();
			}

			pw.write("Case #" + (i + 1) + ": " + ff.count(exists, create)
					+ "\n");
		}

		scanner.close();
		pw.close();

	}

	private int count(String[] exists, String[] create) {
		TreeNode root = new TreeNode("");
		int total = 0;
		
		for (int i = 0; i < exists.length; i++){
			List<String> path = Arrays.asList(exists[i].split("/"));
			path = path.subList(1, path.size());
			root.addPath(path);
		}
		
		for (int i = 0; i < create.length; i++){
			root.resetCounter();
			List<String> path = Arrays.asList(create[i].split("/"));
			path = path.subList(1, path.size());
			root.addPath(path);
			total += root.getCounter();
		}
		return total;
	}

}
