import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;


public class Qr3 {
	
	private int incoming(int r, int k, List<Integer> groups) {
		Map<Integer, Integer> leaders = new HashMap<Integer, Integer>();
		List<Integer> leaderOrder = new ArrayList<Integer>();
		
		int peoples = 0;
		int leaderIndex = 0;
		int currentIndex = leaderIndex;
		int totalcost = 0;
		int rideNum = 0;
		boolean allGroupInAction = false;
		
		while (!leaders.containsKey(leaderIndex) && rideNum < r){
			Integer group = groups.get(currentIndex);
			if (group + peoples <= k && !allGroupInAction){
				peoples += group;
				currentIndex = (currentIndex  + 1 == groups.size()) ? 0 : currentIndex + 1;
				if (currentIndex == leaderIndex){
					allGroupInAction = true; 
				}
			} else {				
				leaders.put(leaderIndex, peoples);
				leaderOrder.add(leaderIndex);
				rideNum++;
				totalcost += peoples;
				peoples = 0;
				leaderIndex = currentIndex;
				allGroupInAction = false;
			}
		}
		if (rideNum == r) {
			return totalcost;
		} else {
			int headSize = 0;
			int incoming = 0;
			for (Integer leader : leaderOrder) {
				if (leader == leaderIndex){
					break;
				}
				headSize++;
			}
			for (int i = 0; i < headSize; i++){
				Integer leaderFromHead = leaderOrder.get(i);
				incoming += leaders.get(leaderFromHead);
				leaders.remove(leaderFromHead);
			}
			leaderOrder = leaderOrder.subList(headSize, leaderOrder.size());
			
			r = r - headSize;
			totalcost = totalcost - incoming;
			
			int roundNumber = r / leaders.keySet().size();
			incoming += roundNumber * totalcost;
			
			int tailSize = r % leaders.keySet().size();
			for (int i = 0; i < tailSize; i++){
				incoming += leaders.get(leaderOrder.get(i));
			}
			return incoming;
		}
	}


	public static void main(String[] args) throws IOException {
		File input = new File("in.txt");
		BufferedWriter output = new BufferedWriter(new FileWriter("out.txt"));
		
		Qr3 calculator = new Qr3();
		
		Scanner scanner = new Scanner(input);
		int cases = scanner.nextInt();
		
		for (int i = 1; i <= cases; i++) {
			
			int r = scanner.nextInt();
			int k = scanner.nextInt();
			int n = scanner.nextInt();
			List<Integer> groups = new ArrayList<Integer>();
			for (int j = 0; j < n; j++){
				groups.add(new Integer(scanner.nextInt()));
			}
			
			int result = calculator.incoming(r, k, groups);
			output.write("Case #" + i + ": " + result + "\n");
		}
		output.close();
	}

}
