package y2017.contest.r1b;

import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * @author ashevenkov 22.04.17 19:36.
 */
public class ProblemB {

    public static final String TITLE = "B-small-attempt1";
    private static BufferedReader in = prodIn();
    private static BufferedWriter out = prodOut();

    private static BufferedWriter prodOut() {
        try {
            return new BufferedWriter(new FileWriter("codejam/output/" + TITLE + ".out"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    private static BufferedReader prodIn() {
        try {
            return new BufferedReader(new FileReader("codejam/input/" + TITLE + ".in"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        return null;
    }


    private static BufferedWriter testOut() {
        return new BufferedWriter(new OutputStreamWriter(System.out));
    }

    private static BufferedReader testIn() {
        return new BufferedReader(new InputStreamReader(System.in));
    }

    public static void main(String[] args) throws Exception {
        new ProblemB().solve(in, out);
        out.flush();
        out.close();
    }

    //implement
    private void solve(BufferedReader in, BufferedWriter out) throws Exception {
        Scanner scanner = new Scanner(in);
        int t = scanner.nextInt();
        for(int i = 0; i < t; i++) {
            int n = scanner.nextInt();
            int r = scanner.nextInt();
            int o = scanner.nextInt();
            int y = scanner.nextInt();
            int g = scanner.nextInt();
            int b = scanner.nextInt();
            int v = scanner.nextInt();
            out.write("Case #" + (i + 1) + ": " + solveCase(n, r, o, y, g, b, v));
            out.newLine();
        }
    }

    private String solveCase(int n, int r, int o, int y, int g, int b, int v) {
        StringBuilder sb = new StringBuilder();
        if(r > y + b || y > r + b || b > y + r) {
            return "IMPOSSIBLE";
        }
        if(r < b) {
            if(r < y) {
                sb = doWithMin(n, 'R', r, 'B', b, 'Y', y);
            } else {
                sb = doWithMin(n, 'Y', y, 'B', b, 'R', r);
            }
        } else {
            if(y < b) {
                sb = doWithMin(n, 'Y', y, 'B', b, 'R', r);
            } else {
                sb = doWithMin(n, 'B', b, 'Y', y, 'R', r);
            }
        }
        return sb.toString();
    }

    private StringBuilder doWithMin(int n, char rc, int r, char bc, int b, char yc, int y) {
        StringBuilder sb = new StringBuilder();
        int toLeave = (n - 2 * r) / 2;
        if((n - 2 * r) % 2 != 0) {
            if(b > y) {
                addPairs(sb, rc, bc, b - toLeave - 1);
                addPairs(sb, rc, yc, y - toLeave);
            } else {
                addPairs(sb, rc, yc, y - toLeave - 1);
                addPairs(sb, rc, bc, b - toLeave);
            }
        } else {
            addPairs(sb, rc, bc, b - toLeave);
            addPairs(sb, rc, yc, y - toLeave);
        }

        if((n - 2 * r) % 2 != 0) {
            if(b > y) {
                sb.append(bc);
                addPairs(sb, yc, bc, toLeave);
            } else {
                sb.append(yc);
                addPairs(sb, bc, yc, toLeave);
            }
        } else {
            if(sb.length() > 0 && sb.charAt(sb.length() - 1) == bc) {
                addPairs(sb, yc, bc, toLeave);
            } else {
                addPairs(sb, bc, yc, toLeave);
            }
        }
        return sb;
    }

    private void addPairs(StringBuilder sb, char r, char y, int count) {
        for(int i = 0; i < count; i++) {
            sb.append(r);
            sb.append(y);
        }
    }


}
