package jam.jam2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.*;

/**
 * Created by IntelliJ IDEA.
 * User: ashevenkov
 * Date: 13.04.13
 * Time: 16:00
 */
public class ProblemQB {

    public static void main(String[] args) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader("input/2013-RQ-B-large.in"));
        BufferedWriter bw = new BufferedWriter(new FileWriter("output/2013-RQ-B-large.out"));
        String line = br.readLine();
        int cases = Integer.parseInt(line);
        for (int i = 0; i < cases; i++) {
            line = br.readLine();
            String[] parts = line.split(" ");
            int h = Integer.parseInt(parts[0]);
            int len = Integer.parseInt(parts[1]);
            int[][] matrix = new int[h][];
            Set<Integer> nums = new HashSet<Integer>();
            for(int j = 0; j < h; j++) {
                matrix[j] = new int[len];
                line = br.readLine();
                String[] parts1 = line.split(" ");
                for (int k = 0; k < parts1.length; k++) {
                    int n = Integer.parseInt(parts1[k]);
                    nums.add(n);
                    matrix[j][k] = n;
                }
            }
            ArrayList<Integer> numsList = new ArrayList<Integer>(nums);
            Collections.sort(numsList, Collections.reverseOrder());
            String result = calculate(matrix, len, h, numsList);
            System.out.println("Case #" + (i + 1) + ": " + result);
            bw.write("Case #" + (i + 1) + ": " + result);
            bw.write("\n");
        }
        bw.flush();
        bw.close();
    }

    private static String calculate(int[][] matrix, int len, int h, ArrayList<Integer> numsList) {
        for(int i = 1; i < numsList.size(); i++) {
            int up = numsList.get(i - 1);
            int down = numsList.get(i);
            boolean check = check(matrix, len, h, up, down);
            if(!check) {
                return "NO";
            }
        }
        return "YES";
    }

    private static boolean check(int[][] matrix, int len, int h, int up, int down) {
        Set<Integer> lines = new HashSet<Integer>();
        for(int i = 0; i < h; i++) {
            if (checkLine(matrix[i], len, up)) {
                lines.add(i);
            }
        }
        Set<Integer> verts = new HashSet<Integer>();
        for(int i = 0; i < len; i++) {
            if (checkVert(matrix, h, up, i)) {
                verts.add(i);
            }
        }
        for (int i = 0; i < matrix.length; i++) {
            int[] numLines = matrix[i];
            for (int j = 0; j < numLines.length; j++) {
                int num = numLines[j];
                if(num <= down) {
                    if(!lines.contains(i) && !verts.contains(j)) {
                        return false;
                    }
                }
            }
        }
        return true;
    }

    private static boolean checkVert(int[][] matrix, int h, int up, int i) {
        boolean upper = false;
        if(matrix[0][i] >= up) {
            upper = true;
        }
        for(int j = 1; j < h; j++) {
            if(matrix[j][i] >= up) {
                if(!upper) {
                    return false;
                }
            } else {
                if(upper) {
                    return false;
                }
            }
        }
        return true;
    }

    private static boolean checkLine(int[] matrix, int len, int up) {
        boolean upper = false;
        if(matrix[0] >= up) {
            upper = true;
        }
        for(int j = 1; j < len; j++) {
            if(matrix[j] >= up) {
                if(!upper) {
                    return false;
                }
            } else {
                if(upper) {
                    return false;
                }
            }
        }
        return true;
    }

}
