package y2016.contest.qualify;

import java.io.*;
import java.util.Scanner;

/**
 * @author ashevenkov 09.04.16 12:20.
 */
public class ProblemC {

    public static final String TITLE = "C-small-attempt0";
    private static BufferedReader in = prodIn();
    private static BufferedWriter out = prodOut();

    private static BufferedWriter prodOut() {
        try {
            return new BufferedWriter(new FileWriter("codejam/output/" + TITLE + ".out"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    private static BufferedReader prodIn() {
        try {
            return new BufferedReader(new FileReader("codejam/input/" + TITLE + ".in"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        return null;
    }


    private static BufferedWriter testOut() {
        return new BufferedWriter(new OutputStreamWriter(System.out));
    }

    private static BufferedReader testIn() {
        return new BufferedReader(new InputStreamReader(System.in));
    }

    public static void main(String[] args) throws Exception {
        new ProblemC().solve(in, out);
        out.flush();
        out.close();
    }

    //implement
    private void solve(BufferedReader in, BufferedWriter out) throws Exception {
        Scanner scanner = new Scanner(in);
        int t = scanner.nextInt();
        for(int i = 0; i < t; i++) {
            int n = scanner.nextInt();
            int j = scanner.nextInt();
            out.write("Case #" + (i + 1) + ": " + solveCase(n, j));
            out.newLine();
        }
    }

    private String solveCase(int n, int j) {
        StringBuilder sb = new StringBuilder();
        long current = 0;
        int count = 0;
        while(count < j) {
            String[] forCurrent = tryCurrent(current, n);
            if(forCurrent != null) {
                count++;
                sb.append('\n');
                for (int i = 0; i < forCurrent.length; i++) {
                    String s = forCurrent[i];
                    if(i != 0) {
                        sb.append(" ");
                    }
                    sb.append(s);
                }
            }
            current++;
        }
        return sb.toString();
    }

    private String[] tryCurrent(long current, int n) {
        String[] result = new String[10];
        long first = 1L << (n - 1);
        current = current << 1;
        current += 1;
        current += first;
        String s = Long.toString(current, 2);
        result[0] = s;
        for(int i = 3; i <= 10; i++) {
            long radixCurrent = Long.parseLong(s, i);
            long divider = searchDivider(radixCurrent);
            if(divider <= 0) {
                return null;
            } else {
                result[i - 1] = Long.toString(divider);
            }
        }
        long divider = searchDivider(current);
        if(divider <= 0) {
            return null;
        } else {
            result[1] = Long.toString(divider);
        }
        return result;
    }

    private long searchDivider(long radixCurrent) {
        long divider = 2;
        while(divider <= radixCurrent / 2) {
            if(radixCurrent % divider == 0) {
                return divider;
            }
            divider++;
            if(divider > 10000) {
                return 0;
            }
        }
        return 0;
    }

}
