/**
 * Created by IntelliJ IDEA.
 * User: ashevenkov
 * Date: 11.04.15
 * Time: 11:52
 */
package y2015.contest.qualify;

import java.io.*;
import java.util.*;

/**
 * @author ashevenkov
 */
public class ProblemB {

    public static final String TITLE = "B-small-attempt2";
    private static BufferedReader in = prodIn();
    private static BufferedWriter out = prodOut();

    private static BufferedWriter prodOut() {
        try {
            return new BufferedWriter(new FileWriter("codejam/output/" + TITLE + ".out"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return null;
    }

    private static BufferedReader prodIn() {
        try {
            return new BufferedReader(new FileReader("codejam/input/" + TITLE + ".in"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        return null;
    }


    private static BufferedWriter testOut() {
        return new BufferedWriter(new OutputStreamWriter(System.out));
    }

    private static BufferedReader testIn() {
        return new BufferedReader(new InputStreamReader(System.in));
    }

    public static void main(String[] args) throws Exception {
        new ProblemB().solve(in, out);
        out.flush();
        out.close();
    }

    //implement
    private void solve(BufferedReader in, BufferedWriter out) throws Exception {
        Scanner scanner = new Scanner(in);
        int t = scanner.nextInt();
        for (int i = 0; i < t; i++) {
            int d = scanner.nextInt();
            int[] p = new int[d];
            for (int j = 0; j < d; j++) {
                p[j] = scanner.nextInt();
            }
            out.write("Case #" + (i + 1) + ": " + solveCase(p));
            out.newLine();
        }
    }

    private static class State {
        private ArrayList<Integer> pa;
        private int steps;

        private State(ArrayList<Integer> pa, int steps) {
            this.pa = pa;
            this.steps = steps;
        }
    }

    private int solveCase(int[] p) {
        ArrayList<Integer> pa = new ArrayList<>();
        for (int i = 0; i < p.length; i++) {
            pa.add(p[i]);
        }
        Collections.sort(pa);
        Queue<State> q = new LinkedList<>();
        q.add(new State(pa, 0));
        while(!q.isEmpty()) {
            State state = q.poll();
            ArrayList<Integer> clone = (ArrayList<Integer>) state.pa.clone();
            for(int i = 0; i < clone.size(); i++) {
                if(clone.get(i) > 0) {
                    clone.set(i, clone.get(i) - 1);
                }
            }
            if(clone.get(clone.size() - 1) == 0) {
                return state.steps + 1;
            } else {
                q.add(new State(clone, state.steps + 1));
            }
            for(int i = 1; i <= pa.get(pa.size() - 1) / 2; i++) {
                clone = (ArrayList<Integer>) state.pa.clone();
                Integer removed = clone.remove(clone.size() - 1);
                clone.add(removed - i);
                clone.add(i);
                Collections.sort(clone);
                q.add(new State(clone, state.steps + 1));
            }
        }
        return 0;
    }

}
