package jam.jam2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: ashevenkov
 * Date: 13.04.13
 * Time: 14:05
 */
public class ProblemQC {

    public static void main(String[] args) throws Exception {
        Set<Long> set = new HashSet<Long>();
        for(long i = 1; i <= 10000000; i++) {
            if(checkPalind(i)) {
                long j = i * i;
                if(checkPalind(j)) {
                    set.add(j);
                }
            }
        }
        System.out.println("----");
        BufferedReader br = new BufferedReader(new FileReader("input/2013-RQ-C-large1.in"));
        BufferedWriter bw = new BufferedWriter(new FileWriter("output/2013-RQ-C-large1.out"));
        String line = br.readLine();
        int cases = Integer.parseInt(line);
        for (int i = 0; i < cases; i++) {
            line = br.readLine();
            String[] parts = line.split(" ");
            String result = calculate(parts[0], parts[1], set);
            System.out.println("Case #" + (i + 1) + ": " + result);
            bw.write("Case #" + (i + 1) + ": " + result);
            bw.write("\n");
        }
        bw.flush();
        bw.close();
    }

    private static boolean checkPalind(long i) {
        String s = Long.toString(i);
        String s1 = new StringBuffer(s).reverse().toString();
        return s1.equals(s);
    }

    private static String calculate(String a, String b, Set<Long> set) {
        long from = Long.parseLong(a);
        long to = Long.parseLong(b);
        int count = 0;
        for (Long n : set) {
            if(from <= n && n <= to) {
                count++;
            }
        }
        return Integer.toString(count);
    }
}
