package qualification.A;

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;


public class Sheep implements Runnable {

    private class SmartReader {
        private BufferedReader br;
        private StringTokenizer st;

        SmartReader(String file) throws IOException {
            br = new BufferedReader(new FileReader(new File(file)));
        }

        public String nextToken() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(nextToken());
        }

        public double nextDouble() throws IOException {
            return Double.parseDouble(nextToken());
        }

        public void close() throws IOException {
            st = null;
            br.close();
        }
    }

    public static void main(String[] args) {
        new Sheep().run();
    }


    SmartReader in;
    PrintWriter out;
    final int maxN = 10 ^ 6;

    public void init() throws IOException {
        in = new SmartReader("in.txt");
        out = new PrintWriter("out.txt");
    }

    public int maxAns = -1;

    private String calc(int val) {
        long curVal = val;
        boolean checked[] = new boolean[10];
        int cnt = 0;
        Arrays.fill(checked, false);
        for (int i = 0; i < 80; i++) {
            long t = curVal;
            while (t > 0) {
                if (!checked[(int) (t % 10)]) {
                    cnt++;
                    checked[(int) (t % 10)] = true;
                }
                t /= 10;
            }
            if (cnt == 10) {
                // maxAns = Math.max(maxAns, i);
                return String.valueOf(curVal);
            } else {
                curVal += (long) val;
            }
        }
        return "INSOMNIA";
    }

    public void solve() throws IOException {
        int n = in.nextInt();
        for (int i = 0; i < n; i++) {
            int val = in.nextInt();
            //calc(i + 1);
            out.println("Case #" + (i + 1) + ": " + calc(val));
        }
        //out.println(maxAns);
    }

    private void close() throws IOException {
        out.close();
        in.close();
    }

    @Override
    public void run() {
        try {
            init();
            solve();
            close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}
