package RoundC;

import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class A {

    SmartReader in;
    PrintWriter out;

    private class SmartReader {
        private BufferedReader br;
        private StringTokenizer st;

        SmartReader(String file) throws IOException {
            br = new BufferedReader(new FileReader(new File(file)));
        }

        public String nextToken() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(nextToken());
        }

        public double nextDouble() throws IOException {
            return Double.parseDouble(nextToken());
        }

        public void close() throws IOException {
            st = null;
            br.close();
        }
    }

    public static void main(String[] args) {
        new A().run();
    }

    private class Counter implements Comparable<Counter> {
        char c;
        int num;

        public Counter(int nn, char cc) {
            c = cc;
            num = nn;
        }

        @Override
        public int compareTo(Counter that) {
            if (this.num > that.num || this.num == that.num && this.c < that.c) {
                return -1;
            } else if (this.num == that.num && this.c == that.c) {
                return 0;
            } else return 1;
        }
    }

    public void calc() throws IOException {
        int n = in.nextInt();
        Counter[] f = new Counter[n];
        int sum = 0;
        for (int i = 0; i < n; i++) {
            f[i] = new Counter(in.nextInt(), (char) ((int) 'A' + i));
            sum += f[i].num;
        }
        Arrays.sort(f);
        int last = f[0].num;
        int pos = 0;
        while (sum > 0) {
            out.print(" ");
            if (sum == 3) {
                out.print(f[pos].c);
                f[pos].num--;
                sum--;
                pos++;
                continue;
            }
            for (int i = 0; i < 2; i++) {
                if (f[pos].num == last) {
                    sum--;
                    out.print(f[pos].c);
                    f[pos].num--;
                }
                if (pos + 1 < n && f[pos + 1].num == last) {
                    pos++;
                } else {
                    pos = 0;
                    last = f[0].num;
                }
            }
        }
    }


    public void solve() throws IOException {
        in = new SmartReader("in.txt");
        out = new PrintWriter("out.txt");

        int t = in.nextInt();
        //   System.err.println(t);
        for (int i = 0; i < t; i++) {
//            System.err.println(i);
            out.print("Case #" + (i + 1) + ":");
            calc();
            out.println();
        }
        out.close();
    }

    public void run() {

        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

}
