import java.io.*;
import java.util.*;

public class C implements Runnable {

	public static void main(String[] args) {
		new Thread(new C()).start();
	}

	BufferedReader br;
	PrintWriter out;
	StringTokenizer in;

	public String nextToken() throws IOException {
		while (in == null || !in.hasMoreTokens()) {
			in = new StringTokenizer(br.readLine());
		}
		return in.nextToken();
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}

	public long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	final int base = 100003;

	public class Point implements Comparable<Point> {
		int size, num;

		public Point(int a, int b) {
			size = a;
			num = b;
		}

		@Override
		public int compareTo(Point o) {
			return o.size - size;
		}
	}

	public void solve() throws IOException {
		int n, m;
		n = nextInt();
		m = nextInt();
		int[][] maze = new int[n][m];
		for (int i = 0; i < n; i++) {
			String st = nextToken();
			for (int j = 0; j < m / 4; j++) {
				char c = st.charAt(j);
				int num;
				if (c >= 'A' && c <= 'Z')
					num = 10 + (int) (c - 'A');
				else
					num = (int) (c - '0');
				for (int k = 3; k >= 0; k--) {
					maze[i][j * 4 + k] = num & 1;
					num >>= 1;
				}
			}
		}
		int kans = 0;
		ArrayList<Point> answer = new ArrayList<Point>();
		Point pos = new Point(0, 0);
		while (true) {
			int maxsize = -1;
			for (int i = 0; i < n; i++)
				for (int j = 0; j < m; j++) {
					for (int k = 1; k <= Math.min(n - i, m - j); k++) {
						boolean ok = true;
						for (int ii = i; ii < i + k; ii++) {
							if (ii > i && maze[ii][j] == maze[ii-1][j]){
								ok = false;
								break;
							}
							for (int jj = j; jj < j + k; jj++) {
								if (maze[ii][jj] == 2) {

									ok = false;
									break;
								} else if (jj + 1 < j + k
										&& maze[ii][jj] == maze[ii][jj + 1]) {

									ok = false;
									break;
								}
							}
							if (!ok)
								break;
						}
						if (ok && k > maxsize) {
							maxsize = k;
							pos.num = i;
							pos.size = j;
						}
						if (!ok)
							break;
					}

				}
			if (maxsize == -1)
				break;
			boolean added = false;
			for (int i = 0; i < answer.size(); i++)
				if (answer.get(i).size == maxsize) {
					added = true;
					answer.set(i, new Point(answer.get(i).size,
							answer.get(i).num + 1));
				}
			if (!added)
				answer.add(new Point(maxsize, 1));
			for (int i = pos.num; i < pos.num + maxsize; i++)
				for (int j = pos.size; j < pos.size + maxsize; j++)
					maze[i][j] = 2;
		}
		out.println(answer.size());
		Point[] an = new Point[answer.size()];
		for (int i = 0; i < an.length; i++)
			an[i] = answer.get(i);
		Arrays.sort(an);
		for (int i = 0; i < an.length; i++)
			out.println(an[i].size + " " + an[i].num);
	}

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader("c.in"));
			out = new PrintWriter("c.out");
			int t = nextInt();
			for (int k = 1; k <= t; k++) {
				out.print("Case #" + k + ": ");
				solve();
			}
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

}
