package qualification.B;

import java.io.*;
import java.util.StringTokenizer;

public class Pancakes implements Runnable {
    private class SmartReader {
        private BufferedReader br;
        private StringTokenizer st;

        SmartReader(String file) throws IOException {
            br = new BufferedReader(new FileReader(new File(file)));
        }

        public String nextToken() throws IOException {
            while (st == null || !st.hasMoreTokens()) {
                st = new StringTokenizer(br.readLine());
            }
            return st.nextToken();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(nextToken());
        }

        public double nextDouble() throws IOException {
            return Double.parseDouble(nextToken());
        }

        public void close() throws IOException {
            st = null;
            br.close();
        }
    }

    public static void main(String[] args) {
        new Pancakes().run();
    }


    SmartReader in;
    PrintWriter out;
    final int maxN = 10 ^ 6;

    public void init() throws IOException {
        in = new SmartReader("in.txt");
        out = new PrintWriter("out.txt");
    }

    public int maxAns = -1;

    public int calc(String s) {
        int ans = 0;
        if (s.charAt(s.length() - 1) == '-') {
            s += '+';
        }
        int pos = s.length() - 1;

        while (pos >= 0 && s.charAt(pos) == '+') {
            pos--;
        }
        for (; pos >= 0; pos--) {
            if (s.charAt(pos) != s.charAt(pos + 1)) {
                ans++;
            }
        }
        return ans;
    }

    public void solve() throws IOException {
        int n = in.nextInt();
        for (int i = 0; i < n; i++) {
            String s = in.nextToken();
            //calc(i + 1);
            out.println("Case #" + (i + 1) + ": " + calc(s));
        }
        //out.println(maxAns);
    }

    private void close() throws IOException {
        out.close();
        in.close();
    }

    @Override
    public void run() {
        try {
            init();
            solve();
            close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }
}

