package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

// Libraries used: http://commons.apache.org/lang/, http://commons.apache.org/collections/, https://code.google.com/p/guava-libraries/
public class B {
    private static String solve(int caseNumber, Scanner scanner) {
        String string = scanner.next();
        debug(string);
        int flips = 0;

        do {
            // find pluses already in place on the right
            int inPlaceFromTheRight = 0;
            for (int i = string.length() - 1; i >= 0; i--) {
                if (string.charAt(i) == '+') {
                    inPlaceFromTheRight++;
                } else {
                    break;
                }
            }

            // stop if we are finished
            if (inPlaceFromTheRight == string.length()) {
                break;
            }

            // for the rest, if it has minuses on the left, flip all
            // otherwise, flip all the leftmost pluses
            if (string.startsWith("-")) {
                string = flip(string, string.length() - inPlaceFromTheRight);
                debug(string);
                flips++;
            } else {
                int numberOfPlusesOnTheLeft = numberOfCharsFromLeft('+', string);
                string = flip(string, numberOfPlusesOnTheLeft);
                debug(string);
                flips++;
            }

        } while (true);

        return String.valueOf(flips);
    }

    private static String flip(String string, int n) {
        char[] chars = string.toCharArray();
        char[] flipped = string.toCharArray();
        for (int i = 0; i < n; i++) {
            flipped[n - i - 1] = chars[i] == '+' ? '-' : '+';
        }
        return new String(flipped);
    }

    private static int numberOfCharsFromLeft(char c, String string) {
        int n = 0;
        for (int i = 0; i < string.length(); i++) {
            if (string.charAt(i) == c) {
                n++;
            } else {
                break;
            }
        }
        return n;
    }

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new IllegalArgumentException("Wrong run parameters: " + Arrays.deepToString(args));
        }
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        scanner.useLocale(Locale.US);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            debug("Case #" + caseNumber);
            String result = solve(caseNumber, scanner);
            String resultString = "Case #" + caseNumber + ": " + result;
            out.println(resultString);
            debug("Solution for " + resultString);
            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        scanner.close();
        out.close();
    }

    private static void debug(String text) {
        System.out.println(text);
    }
}
