package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class B {

    private static boolean debugAllowed = true;

    private static int[][] map;

    private static Character[][] labels;

    private static char nextLabel;

    private static int height;

    private static int width;

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        for (int i = 1; i <= numberOfCases; i++) {
            // Parsing the file
            debug("Case #" + i);
            nextLabel = 'a';

            height = scanner.nextInt();
            width = scanner.nextInt();
            scanner.nextLine();
            debug("    height: " + height);
            debug("    width: " + width);

            map = new int[height][width];
            for (int y = height - 1; y >= 0; y--) {
                for (int x = 0; x < width; x++) {
                    map[y][x] = scanner.nextInt();
                }
                scanner.nextLine();
            }
            debug("    map: " + Arrays.deepToString(map));

            // Now solving

            labels = new Character[height][width];
            for (int y = height - 1; y >= 0; y--) {
                for (int x = 0; x < width; x++) {
                    if (labels[y][x] == null) {
                        labels[y][x] = determineLabel(x, y);
                    }
                }
            }

            String result = "Case #" + i + ":\n";
            for (int y = height - 1; y >= 0; y--) {
                for (int x = 0; x < width; x++) {
                    result += labels[y][x] + " ";
                }
                result = result.trim() + "\n";
            }
            out.println(result);
            debug(result);

            debug("");
        }

        out.close();
    }

    private static char determineLabel(int x, int y) {
        if (labels[y][x] != null) {
            return labels[y][x];
        }

        List<int[]> neibors = findNeibors(x, y);
        int minValue = map[y][x];
        Integer minValueIndex = null;
        for (int i = 0; i < neibors.size(); i++) {
            int neiborX = neibors.get(i)[0];
            int neiborY = neibors.get(i)[1];

            if (map[neiborY][neiborX] < minValue) {
                minValue = map[neiborY][neiborX];
                minValueIndex = i;
            }
        }

        // this is a sink
        if (minValueIndex == null) {
            char label = nextLabel;
            nextLabel++;
            labels[y][x] = label;
            return label;
        }

        int nextX = neibors.get(minValueIndex)[0];
        int nextY = neibors.get(minValueIndex)[1];

        return determineLabel(nextX, nextY);
    }

    private static List<int[]> findNeibors(int x, int y) {
        List<int[]> neibors = new ArrayList<int[]>();

        int northX = x;
        int northY = y + 1;
        if (northY < height) {
            neibors.add(new int[] { northX, northY });
        }

        int westX = x - 1;
        int westY = y;
        if (westX >= 0) {
            neibors.add(new int[] { westX, westY });
        }

        int eastX = x + 1;
        int eastY = y;
        if (eastX < width) {
            neibors.add(new int[] { eastX, eastY });
        }

        int southX = x;
        int southY = y - 1;
        if (southY >= 0) {
            neibors.add(new int[] { southX, southY });
        }

        return neibors;
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
