package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

import org.apache.commons.lang.ArrayUtils;

public class B {

    private static boolean debugAllowed = true;

    private static Scanner scanner;

    private static int numberOfCases;

    private static int numberOfItems;

    private static char[] items;

    private static int numberOfCombinations;

    private static Map<String, Character> combinations;

    private static Map<Character, List<Character>> oppositions;

    private static int numberOfOppositions;

    private static void parseCase(int caseNumber) {
        debug("Case #" + caseNumber);

        numberOfCombinations = scanner.nextInt();
        combinations = new HashMap<String, Character>();
        for (int i = 0; i < numberOfCombinations; i++) {
            String combination = scanner.next();
            combinations.put(combination.charAt(0) + "" + combination.charAt(1), combination.charAt(2));
            combinations.put(combination.charAt(1) + "" + combination.charAt(0), combination.charAt(2));
        }
        debug("    combinations: " + combinations);

        numberOfOppositions = scanner.nextInt();
        oppositions = new HashMap<Character, List<Character>>();
        for (int i = 0; i < numberOfOppositions; i++) {
            String opposition = scanner.next();
            if (oppositions.containsKey(opposition.charAt(0))) {
                List<Character> list = oppositions.get(opposition.charAt(0));
                list.add(opposition.charAt(1));
            } else {
                List<Character> list = new ArrayList<Character>();
                list.add(opposition.charAt(1));
                oppositions.put(opposition.charAt(0), list);
            }
            if (oppositions.containsKey(opposition.charAt(1))) {
                List<Character> list = oppositions.get(opposition.charAt(1));
                list.add(opposition.charAt(0));
            } else {
                List<Character> list = new ArrayList<Character>();
                list.add(opposition.charAt(0));
                oppositions.put(opposition.charAt(1), list);
            }
        }
        debug("    oppositions: " + oppositions);

        numberOfItems = scanner.nextInt();
        debug("    numberOfItems: " + numberOfItems);
        String itemsString = scanner.next();
        items = new char[numberOfItems];
        for (int i = 0; i < numberOfItems; i++) {
            items[i] = itemsString.charAt(i);
        }

        debug("    items: " + Arrays.asList(ArrayUtils.toObject(items)));
    }

    private static String solveCase() {
        LinkedList<Character> solution = new LinkedList<Character>();
        outer: for (int i = 0; i < items.length; i++) {
            if (solution.isEmpty()) {
                solution.add(items[i]);
                continue;
            }
            Character last = solution.getLast();

            Character replacement = combinations.get(last + "" + items[i]);
            if (replacement != null) {
                solution.removeLast();
                solution.add(replacement);
                continue outer;
            }

            List<Character> opposedList = oppositions.get(items[i]);
            if (opposedList != null) {
                for (Character opposed : opposedList) {
                    if (solution.contains(opposed)) {
                        solution = new LinkedList<Character>();
                        continue outer;
                    }
                }
            }

            solution.add(items[i]);
        }
        return solution.toString();
    }

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        scanner = new Scanner(inputFile);
        numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            parseCase(caseNumber);

            String solution = solveCase();

            String resultString = "Case #" + caseNumber + ": " + solution;
            out.println(resultString);
            debug("Solution for " + resultString);

            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        out.close();
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
