package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;
import java.util.stream.Stream;

// Libraries used: http://commons.apache.org/lang/, http://commons.apache.org/collections/, https://code.google.com/p/guava-libraries/
public class A {
    private static String solve(int caseNumber, Scanner scanner) {
        int N = scanner.nextInt();
        int total = 0;
        Map<Character, Integer> P = new HashMap<>();
        for (int i = 0; i < N; i++) {
            int nextInt = scanner.nextInt();
            P.put((char) ('A' + i), nextInt);
            total += nextInt;
        }

        LinkedList<String> chain = new LinkedList<>();

        do {
            //debug(total + ", " + P);
            List<Entry<Character, Integer>> sorted = entriesSortedByValues(P);
            //P = sortByValue(P);
            // take 2 from the biggest party and see if it works
            Iterator<Entry<Character, Integer>> iterator = sorted.iterator();
            Character biggestParty = iterator.next().getKey();
            if (P.get(biggestParty) < 2) {
                P.put(biggestParty, P.get(biggestParty) - 1);
                chain.add(biggestParty + "");
                total--;
                if (somebodyGotMajority(total, P)) {
                    chain.removeLast();
                    Character nextBiggestParty = iterator.next().getKey();
                    P.put(nextBiggestParty, P.get(nextBiggestParty) - 1);
                    chain.add(biggestParty + "" + nextBiggestParty);
                    total--;
                    if (somebodyGotMajority(total, P)) {
                        throw new RuntimeException("Something wrong");
                    }
                }
                continue;
            }
            P.put(biggestParty, P.get(biggestParty) - 2);
            chain.add(biggestParty + "" + biggestParty);
            total -= 2;
            // if it did not work, put 1 back and try to take 1 from next biggest party
            if (somebodyGotMajority(total, P)) {
                chain.removeLast();
                P.put(biggestParty, P.get(biggestParty) + 1);
                Character nextBiggestParty = iterator.next().getKey();
                P.put(nextBiggestParty, P.get(nextBiggestParty) - 1);
                chain.add(biggestParty + "" + nextBiggestParty);

                if (somebodyGotMajority(total, P)) {
                    throw new RuntimeException("Something wrong");
                }
            }
        } while (total > 0);

        return String.join(" ", chain);
    }

    private static boolean somebodyGotMajority(int total, Map<Character, Integer> P) {
        boolean somebodyGotMajority = false;
        for (Character party : P.keySet()) {
            if (P.get(party) > total / 2) {
                somebodyGotMajority = true;
                break;
            }
        }
        return somebodyGotMajority;
    }

    public static <K, V extends Comparable<? super V>> LinkedHashMap<K, V> sortByValue(Map<K, V> map) {
        LinkedHashMap<K, V> result = new LinkedHashMap<>();
        Stream<Map.Entry<K, V>> st = map.entrySet().stream();

        st.sorted(Map.Entry.comparingByValue()).forEachOrdered(e -> result.put(e.getKey(), e.getValue()));

        return result;
    }

    static <K, V extends Comparable<? super V>> List<Entry<K, V>> entriesSortedByValues(Map<K, V> map) {

        List<Entry<K, V>> sortedEntries = new ArrayList<>(map.entrySet());

        Collections.sort(sortedEntries, new Comparator<Entry<K, V>>() {
            @Override
            public int compare(Entry<K, V> e1, Entry<K, V> e2) {
                return e2.getValue().compareTo(e1.getValue());
            }
        });

        return sortedEntries;
    }

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new IllegalArgumentException("Wrong run parameters: " + Arrays.deepToString(args));
        }
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        scanner.useLocale(Locale.US);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            debug("Case #" + caseNumber);
            String result = solve(caseNumber, scanner);
            String resultString = "Case #" + caseNumber + ": " + result;
            out.println(resultString);
            debug("Solution for " + resultString);
            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        scanner.close();
        out.close();
    }

    private static void debug(String text) {
        System.out.println(text);
    }
}
