package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;

public class B {

    private static boolean debugAllowed = true;

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new IllegalArgumentException("Wrong run parameters: " + Arrays.deepToString(args));
        }
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long start = System.currentTimeMillis();
        for (int i = 1; i <= numberOfCases; i++) {
            // Parsing the file
            debug("Case #" + i);

            BigInteger n = new BigInteger(scanner.nextLine());
            debug("    n= " + n);

            // Now solving

            String s = String.valueOf(n);
            String result = "";

            // for each position starting from the right,
            // substitute it with the smallest (>0) from the right that is
            // bigger;
            // sort remaining on the right
            for (int pos = s.length() - 2; pos >= -1; pos--) {
                int current;
                if (pos == -1) {
                    // substitute fake 0 on the left
                    current = 0;
                } else {
                    current = Integer.parseInt("" + s.charAt(pos));
                }

                // sort on the right
                String substring = s.substring(pos + 1);
                substring = sortCharsInString(substring);

                // find the smallest that is bigger than current
                int smallest = 0, smallestPos = -1;
                for (int j = 0; j < substring.length(); j++) {
                    int currentJ = Integer.parseInt("" + substring.charAt(j));
                    if (currentJ > current) {
                        smallest = currentJ;
                        smallestPos = j;
                        break;
                    }
                }

                if (smallest > 0) {
                 // substitute the current with the smallest
                    if (pos > 0) {
                        result = s.substring(0, pos) + smallest;
                    } else {
                        result = "" + smallest;
                    }
                    // sort remaining on the right (incl current)
                    substring = substring.substring(0, smallestPos) + substring.substring(smallestPos + 1);
                    substring += current;
                    substring = sortCharsInString(substring);
                    result += substring;
                    break;
                }
            }

            String resultString = "Case #" + i + ": " + result;
            out.println(resultString);
            debug(resultString);

            debug("");
        }

        out.close();
        long finish = System.currentTimeMillis();
        debug("Time: " + (finish - start) + " ms.");
    }

    private static String sortCharsInString(String string) {
        char[] content = string.toCharArray();
        Arrays.sort(content);
        return new String(content);
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
