package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

import org.apache.commons.lang.ArrayUtils;

public class A {

    private static boolean debugAllowed = true;

    private static Scanner scanner;

    private static int numberOfCases;

    private static int numberOfItems;

    private static String[][] items;

    private static void parseCase(int caseNumber) {
        debug("Case #" + caseNumber);

        numberOfItems = scanner.nextInt();
        debug("    numberOfItems: " + numberOfItems);
        items = new String[numberOfItems][2];
        for (int i = 0; i < numberOfItems; i++) {
            items[i][0] = scanner.next();
            items[i][1] = String.valueOf(scanner.nextInt());
        }
        scanner.nextLine();
        debug("    items: " + Arrays.deepToString(items));
    }

    private static String solveCase() {
        int posO = 1;
        int posB = 1;
        int i = -1;
        int j = -1;
        i = findNextGoal("O", i);
        j = findNextGoal("B", j);

        long secondsPassed = 0;
        while (i < items.length || j < items.length) {
            // action for O
            int[] resultO = action("O", posO, i, j);
            // action for B
            int[] resultB = action("B", posB, j, i);
            posO = resultO[0];
            i = resultO[1];
            posB = resultB[0];
            j = resultB[1];
            secondsPassed++;
        }

        return String.valueOf(secondsPassed);
    }

    private static int[] action(String name, int position, int myIndex, int friendIndex) {
        if (myIndex == items.length) {
            debug(name + " waits at " + position);
            return new int[] { position, myIndex };
        }
        if (position == getGoal(myIndex)) {
            // press or wait
            if (myIndex < friendIndex) {
                debug(name + " presses " + position);
                myIndex = findNextGoal(name, myIndex);
            } else {
                debug(name + " waits at " + position);
            }
        } else {
            // move
            if (getGoal(myIndex) > position) {
                position++;
            } else {
                position--;
            }
            debug(name + " moves to " + position);
        }
        return new int[] { position, myIndex };
    }

    private static int getGoal(int i) {
        return Integer.parseInt(items[i][1]);
    }

    private static int findNextGoal(String name, int oldIndex) {
        for (int t = oldIndex + 1; t < items.length; t++) {
            if (items[t][0].equals(name)) {
                return t;
            }
        }
        return items.length;
    }

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        scanner = new Scanner(inputFile);
        numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            parseCase(caseNumber);

            String solution = solveCase();

            String resultString = "Case #" + caseNumber + ": " + solution;
            out.println(resultString);
            debug("Solution for " + resultString);

            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        out.close();
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
