package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;

// Libraries used: http://commons.apache.org/lang/, http://commons.apache.org/collections/
public class A {

    private static boolean debugAllowed = true;

    private static Scanner scanner;

    private static int numberOfCases;

    private static int rows;

    private static int columns;

    private static char[][] board;

    private static void parseCase(int caseNumber) {
        debug("Case #" + caseNumber);

        rows = scanner.nextInt();
        debug("    rows: " + rows);
        columns = scanner.nextInt();
        debug("    columns: " + columns);
        board = new char[rows][columns];
        scanner.nextLine();
        for (int i = 0; i < rows; i++) {
            String line = scanner.nextLine();
            for (int j = 0; j < columns; j++) {
                board[i][j] = line.charAt(j);
            }
        }
        debug("    board: " + Arrays.deepToString(board));
    }

    private static String solveCase() {
        for (int i = 0; i < rows - 1; i++) {
            for (int j = 0; j < columns - 1; j++) {
                if (board[i][j] != '#') {
                    continue;
                }
                if (board[i][j + 1] == '#' && board[i + 1][j] == '#' && board[i + 1][j + 1] == '#') {
                    board[i][j] = '/';
                    board[i][j + 1] = '\\';
                    board[i + 1][j] = '\\';
                    board[i + 1][j + 1] = '/';
                }
            }
        }

        String solution = "\n";
        for (int i = 0; i < rows; i++) {
            for (int j = 0; j < columns; j++) {
                if (board[i][j] == '#') {
                    return "\nImpossible";
                }
                solution += board[i][j];
            }
            solution += "\n";
        }

        return solution.substring(0, solution.length() - 1);
    }

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        scanner = new Scanner(inputFile);
        numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            parseCase(caseNumber);

            String solution = solveCase();

            String resultString = "Case #" + caseNumber + ": " + solution;
            out.println(resultString);
            debug("Solution for " + resultString);

            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        out.close();
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
