package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class A {

    private static boolean debugAllowed = true;

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        int length = scanner.nextInt();
        int numberOfWords = scanner.nextInt();
        int numberOfCases = scanner.nextInt();
        scanner.nextLine();
        debug(numberOfCases + " cases");

        List<String> words = new ArrayList<String>();
        for (int i = 1; i <= numberOfWords; i++) {
            words.add(scanner.nextLine());
        }
        debug("    words: " + words);

        for (int i = 1; i <= numberOfCases; i++) {
            // Parsing the file
            debug("Case #" + i);

            String pattern = scanner.nextLine();
            debug("    pattern: " + pattern);
            pattern = pattern.replace('(', '[');
            pattern = pattern.replace(')', ']');
            debug("    pattern2: " + pattern);

            int matches = 0;
            for (String word : words) {
                if (word.matches(pattern)) {
                    matches++;
                }
            }

            String result = "Case #" + i + ": " + matches;
            out.println(result);
            debug(result);

            debug("");
        }

        out.close();
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
