package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

// Libraries used: http://commons.apache.org/lang/, http://commons.apache.org/collections/, https://code.google.com/p/guava-libraries/
public class B {
    private static String solve(int caseNumber, Scanner scanner) {
        double C = scanner.nextDouble();
        double F = scanner.nextDouble();
        double X = scanner.nextDouble();
        debug("C=" + C + ", F=" + F + ", X=" + X);
        double elapsed = 0;
        double speed = 2;
        while (true) {
            double timeToEarnX = X / speed;
            double timeToEarnFarm = C / speed;
            double timeToEarnXAfterBuyingFarm = timeToEarnFarm + X / (speed + F);
            if (timeToEarnX < timeToEarnXAfterBuyingFarm) {
                return String.format(Locale.US, "%.7f", elapsed + timeToEarnX);
            }
            elapsed += timeToEarnFarm;
            speed += F;
        }
    }

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new IllegalArgumentException("Wrong run parameters: " + Arrays.deepToString(args));
        }
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        scanner.useLocale(Locale.US);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            debug("Case #" + caseNumber);
            String result = solve(caseNumber, scanner);
            String resultString = "Case #" + caseNumber + ": " + result;
            out.println(resultString);
            debug("Solution for " + resultString);
            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        scanner.close();
        out.close();
    }

    private static void debug(String text) {
        System.out.println(text);
    }
}
