package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

// Libraries used: http://commons.apache.org/lang/, http://commons.apache.org/collections/, https://code.google.com/p/guava-libraries/
public class A {
    private static String solve(int caseNumber, Scanner scanner) {
        BigInteger N = scanner.nextBigInteger();
        boolean[] digitsSeen = new boolean[10];
        BigInteger lastNumber = N;
        do {
            String string = lastNumber.toString();
            for (int i = 0; i < string.length(); i++) {
                int digit = Integer.parseInt(String.valueOf(string.charAt(i)));
                digitsSeen[digit] = true;
                if (allSeen(digitsSeen)) {
                    return lastNumber.toString();
                }
            }
            lastNumber = lastNumber.add(N);
            if (lastNumber.equals(N)) {
                return "INSOMNIA";
            }
        } while (true);
    }

    private static boolean allSeen(boolean[] digitsSeen) {
        for (boolean seen : digitsSeen) {
            if (!seen) {
                return false;
            }
        }
        return true;
    }

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new IllegalArgumentException("Wrong run parameters: " + Arrays.deepToString(args));
        }
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        scanner.useLocale(Locale.US);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            debug("Case #" + caseNumber);
            String result = solve(caseNumber, scanner);
            String resultString = "Case #" + caseNumber + ": " + result;
            out.println(resultString);
            debug("Solution for " + resultString);
            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        scanner.close();
        out.close();
    }

    private static void debug(String text) {
        System.out.println(text);
    }
}
