package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

// Libraries used: http://commons.apache.org/lang/, http://commons.apache.org/collections/
public class A {

    private static boolean debugAllowed = true;
    private static Scanner scanner;
    private static int numberOfCases;
    private static String phrase;
    private static Map<Character, Character> mapping = new TreeMap<Character, Character>();

    static {
        // TODO Auto-generated constructor stub
        String sample =     "q aoz our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up";
        String translated = "z yeq ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv";
        for (int i = 0; i < translated.length(); i++) {
            mapping.put(translated.charAt(i), sample.charAt(i));
        }
        debug("# of mappings:" + mapping.size());
        debug("mappings:" + mapping);
    }

    private static void parseCase(int caseNumber) {
        debug("Case #" + caseNumber);

        phrase = scanner.nextLine();
        debug("    phrase: " + phrase);
    }

    private static String solveCase() {
        String solution = "";
        for (int i = 0; i < phrase.length(); i++) {
            if (!mapping.containsKey(phrase.charAt(i))) {
                throw new RuntimeException("Mapping not found for '" + phrase.charAt(i) + "'");
            }
            solution += mapping.get(phrase.charAt(i));
        }
        return solution;
    }

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        scanner = new Scanner(inputFile);
        numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            parseCase(caseNumber);

            String solution = solveCase();

            String resultString = "Case #" + caseNumber + ": " + solution;
            out.println(resultString);
            debug("Solution for " + resultString);

            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        out.close();
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
