package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Collection;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;

import org.apache.commons.collections.CollectionUtils;

import com.google.common.collect.Lists;

// Libraries used: http://commons.apache.org/lang/, http://commons.apache.org/collections/, https://code.google.com/p/guava-libraries/
public class A {
    private static String solve(int caseNumber, Scanner scanner) {
        int row1 = scanner.nextInt();
        debug("Row1: " + row1);
        List<Integer> candidates1 = Lists.newArrayList();
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                int card = scanner.nextInt();
                if (i + 1 == row1) {
                    candidates1.add(card);
                }
            }
        }
        debug("candidates1: " + candidates1);

        int row2 = scanner.nextInt();
        debug("Row2: " + row2);
        List<Integer> candidates2 = Lists.newArrayList();
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                int card = scanner.nextInt();
                if (i + 1 == row2) {
                    candidates2.add(card);
                }
            }
        }
        debug("candidates2: " + candidates2);

        Collection common = CollectionUtils.intersection(candidates1, candidates2);
        debug("common: " + common);
        if (common.isEmpty()) {
            return "Volunteer cheated!";
        }
        if (common.size() == 1) {
            return common.iterator().next().toString();
        }

        return "Bad magician!";
    }

    public static void main(String[] args) throws Exception {
        if (args.length != 1) {
            throw new IllegalArgumentException("Wrong run parameters: " + Arrays.deepToString(args));
        }
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        scanner.useLocale(Locale.US);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            debug("Case #" + caseNumber);
            String result = solve(caseNumber, scanner);
            String resultString = "Case #" + caseNumber + ": " + result;
            out.println(resultString);
            debug("Solution for " + resultString);
            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        scanner.close();
        out.close();
    }

    private static void debug(String text) {
        System.out.println(text);
    }
}
