package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;

public class C {

    private static boolean debugAllowed = true;

    private static Scanner scanner;

    private static int numberOfCases;

    private static int numberOfItems;

    private static int[] items;

    private static void parseCase(int caseNumber) {
        debug("Case #" + caseNumber);

        numberOfItems = scanner.nextInt();
        debug("    numberOfItems: " + numberOfItems);
        items = new int[numberOfItems];
        for (int i = 0; i < numberOfItems; i++) {
            items[i] = scanner.nextInt();
        }
        scanner.nextLine();
        debug("    items: " + Arrays.asList(ArrayUtils.toObject(items)));
    }

    private static String solveCase() {
        long maxValue = -1;
        String selectedItemsForMax = "";
        for (int i = 1; i < ((1 << items.length) - 1); i++) {
            long xor1 = 0;
            long xor2 = 0;
            String selectedItems = StringUtils.leftPad(Integer.toBinaryString(i), items.length, '0');
            long value1 = 0;
            for (int j = 0; j < selectedItems.length(); j++) {
                char bit = selectedItems.charAt(j);
                if (bit == '1') {
                    xor1 ^= items[j];
                    value1 += items[j];
                } else {
                    xor2 ^= items[j];
                }
            }
            if (xor1 == xor2) {
                maxValue = Math.max(maxValue, value1);
                selectedItemsForMax = selectedItems;
            }
        }
        debug("    selectedItems= " + selectedItemsForMax);
        return (maxValue == -1) ? "NO" : String.valueOf(maxValue);
    }

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        scanner = new Scanner(inputFile);
        numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long startTime = System.currentTimeMillis();
        for (int caseNumber = 1; caseNumber <= numberOfCases; caseNumber++) {
            parseCase(caseNumber);

            String solution = solveCase();

            String resultString = "Case #" + caseNumber + ": " + solution;
            out.println(resultString);
            debug("Solution for " + resultString);

            debug("");
        }
        long time = System.currentTimeMillis() - startTime;
        debug("Time: " + time + " ms (" + time / numberOfCases + " ms / case)");

        out.close();
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
