package com.google.codejam;

import java.io.File;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;

import org.apache.commons.lang.StringUtils;

public class C {

    private static boolean debugAllowed = true;

    private static String phrase = "welcome to code jam";

    private static char[] phraseArray = phrase.toCharArray();

    public static void main(String[] args) throws Exception {
        File inputFile = new File(args[0]);
        String outputFileName = inputFile.getParent() + File.separator + inputFile.getName().replace(".in", ".out");
        PrintStream out = new PrintStream(outputFileName);

        Scanner scanner = new Scanner(inputFile);
        int numberOfCases = Integer.valueOf(scanner.nextLine());
        debug(numberOfCases + " cases");

        long start = System.currentTimeMillis();
        for (int i = 1; i <= numberOfCases; i++) {
            // Parsing the file
            debug("Case #" + i);
            String text = scanner.nextLine();

            debug("    text: " + text);

            // Now solving

            // BigInteger counts = findCounts(text, 0, 0);
            int counts = findCounts(text, 0, 0);

            // String result = "Case #" + i + ": " +
            // StringUtils.leftPad(StringUtils.right(counts.toString(), 4), 4,
            // '0');
            String result = "Case #" + i + ": "
            + StringUtils.leftPad(StringUtils.right(String.valueOf(counts), 4), 4, '0');
            out.println(result);
            debug(result);

            debug("");
        }

        out.close();
        long finish = System.currentTimeMillis();
        debug("Time: " + (finish-start) + " ms.");
    }

    private static int findCounts(String text, int charNumber, int fromIndex) {
        // BigInteger count = BigInteger.ZERO;
//        debug("findCounts " + charNumber + "(" + phraseArray[charNumber] + ")" + " " + fromIndex);
        if (fromIndex > text.length()) {
            return 0;
        }
        int count = 0;
        while (true) {
            int indexOf = text.indexOf(phraseArray[charNumber], fromIndex);
            if (indexOf == -1) {
                break;
            }

            // the last char found
            if (charNumber == phraseArray.length - 1) {
                // count = count.add(BigInteger.ONE);
                count++;
            } else {
                // count = count.add(findCounts(text, charNumber + 1, indexOf +
                // 1));
                count += findCounts(text, charNumber + 1, indexOf + 1);
            }
            
            if (count > 10000) {
                count = count % 10000;
            }

            fromIndex = indexOf + 1;
        }
        return count;
    }

    private static void debug(String text) {
        if (debugAllowed) {
            System.out.println(text);
        }
    }
}
