package aluebs;

import java.io.*;
import java.util.*;

class Main {
	public static void main(String[] args) {
		try{
			FileInputStream fis = new FileInputStream(args[0]);
			DataInputStream dis = new DataInputStream(fis);
			BufferedReader br = new BufferedReader(new InputStreamReader(dis));
			Integer T = Integer.parseInt(br.readLine());
			Character[][][] boards = new Character[4][4][T]; 
			for(int t = 0; t < T; t++) {
				for(int i = 0; i < 4; i++) {
					String tmp = br.readLine();
					for(int j = 0; j < 4; j++) {
						boards[i][j][t] = tmp.charAt(j);
					}
				}
				br.readLine();
			}
			dis.close();
			String[] results = new String[T];
			for(int t = 0; t < T; t++) {
				boolean X = false;
				boolean O = false;
				boolean finished = true;
				for(int i = 0; i < 4; i++) {
					X |= check(boards[i][0][t], boards[i][1][t], boards[i][2][t], boards[i][3][t], 'X');
					X |= check(boards[0][i][t], boards[1][i][t], boards[2][i][t], boards[3][i][t], 'X');
					O |= check(boards[i][0][t], boards[i][1][t], boards[i][2][t], boards[i][3][t], 'O');
					O |= check(boards[0][i][t], boards[1][i][t], boards[2][i][t], boards[3][i][t], 'O');
					for(int j = 0; j < 4; j++) {
						finished &= (boards[i][j][t] != '.');
					}
				}
				X |= check(boards[0][0][t], boards[1][1][t], boards[2][2][t], boards[3][3][t], 'X');
				X |= check(boards[0][3][t], boards[1][2][t], boards[2][1][t], boards[3][0][t], 'X');
				O |= check(boards[0][0][t], boards[1][1][t], boards[2][2][t], boards[3][3][t], 'O');
				O |= check(boards[0][3][t], boards[1][2][t], boards[2][1][t], boards[3][0][t], 'O');
				if(X) {
					results[t] = "X won";
				} else if(O) {
					results[t] = "O won";
				} else if(finished) {
					results[t] = "Draw";
				} else {
					results[t] = "Game has not completed";
				}
			}
			FileWriter fw = new FileWriter("out.txt");
			BufferedWriter bw = new BufferedWriter(fw);
			for(int t = 0; t < T; t++) {
				bw.write("Case #" + (t + 1) + ": " + results[t]);
				bw.newLine();
			}
			bw.close();
		} catch (Exception e) {}
	}
	private static boolean check(Character c1, Character c2, Character c3, Character c4, Character player) {
		return ((c1 == player) || (c1 == 'T')) && ((c2 == player) || (c2 == 'T')) && ((c3 == player) || (c3 == 'T')) && ((c4 == player) || (c4 == 'T'));
	}
}

