package aluebs;

import java.io.*;
import java.util.*;

class Main {
	public static void main(String[] args) {
		try{
			FileInputStream fis = new FileInputStream(args[0]);
			DataInputStream dis = new DataInputStream(fis);
			BufferedReader br = new BufferedReader(new InputStreamReader(dis));
			Integer T = Integer.parseInt(br.readLine());
			List<Integer[][]> patterns = new ArrayList<Integer[][]>();
			Integer[] N = new Integer[T];
			Integer[] M = new Integer[T];
			for(int t = 0; t < T; t++) {
				StringTokenizer tmp = new StringTokenizer(br.readLine());
				N[t] = Integer.parseInt(tmp.nextToken());
				M[t] = Integer.parseInt(tmp.nextToken());
				Integer[][] pattern = new Integer[N[t]][M[t]];
				for(int i = 0; i < N[t]; i++) {
					tmp = new StringTokenizer(br.readLine());
					for(int j = 0; j < M[t]; j++) {
						pattern[i][j] = Integer.parseInt(tmp.nextToken());
					}
				}
				patterns.add(pattern);
			}
			dis.close();
			String[] results = new String[T];
			for(int t = 0; t < T; t++) {
				boolean possible = true;
				Integer[][] pattern = patterns.get(t);
				for(int i = 0; i < N[t]; i++) {
					for(int j = 0; j < M[t]; j++) {
						possible &= (pattern[i][j] >= maxRow(pattern, M[t], i)) || (pattern[i][j] >= maxColumn(pattern, N[t], j));
					}
				}
				if(possible) {
					results[t] = "YES";
				} else {
					results[t] = "NO";
				}
			}
			FileWriter fw = new FileWriter("out.txt");
			BufferedWriter bw = new BufferedWriter(fw);
			for(int t = 0; t < T; t++) {
				bw.write("Case #" + (t + 1) + ": " + results[t]);
				bw.newLine();
			}
			bw.close();
		} catch (Exception e) {}
	}
	
	private static Integer maxRow(Integer[][] pattern, Integer M, Integer i) {
		Integer max = 0;
		for(int j = 0; j < M; j++) {
			if(pattern[i][j] > max) {
				max = pattern[i][j];
			}
		}
		return max;
	}
	
	private static Integer maxColumn(Integer[][] pattern, Integer N, Integer j) {
		Integer max = 0;
		for(int i = 0; i < N; i++) {
			if(pattern[i][j] > max) {
				max = pattern[i][j];
			}
		}
		return max;
	}
}

