import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;


public class Gcj1 {

	/**
	 * @param args
	 */

	public static void main(String[] args) throws Exception{
		// TODO Auto-generated method stub
		BufferedReader In = new BufferedReader(new FileReader(new File("c:\\in.txt")));
		BufferedWriter Out = new BufferedWriter(new FileWriter(new File("c:\\out")));
		int K = Integer.parseInt(In.readLine());
		for (int num = 1; num <= K; num++) {
			int n = Integer.parseInt(In.readLine());
			Scanner sc = new Scanner(In.readLine());
			MatchKM km = new MatchKM(n, n);
			long[] A = new long[n];
			for (int i = 0; i < n; i++) {
				A[i] = sc.nextInt();
			}
			sc = new Scanner(In.readLine());
			long[] B = new long[n];
			for (int i = 0; i < n; i++) {
				B[i] = sc.nextInt();
			}
			for (int i = 0; i < n; i++) {
				Arrays.fill(km.map[i], true);
			}
			for (int i = 0; i < n; i++) {
				for (int j = 0; j < n; j++) {
					km.cost[i][j] = -A[i] * B[j];
				}
			}

			Out.write("Case #" + num + ": " + (-km.perfectMatch(n)) + "\n");
		}
		Out.flush();
	}
}
class MatchKM {
	public int[] matchx, matchy;
	public long[] labelx, labely;

	public long[][] cost;
	
	public boolean[][] map;

	public boolean[] checkx, checky;

	public int m, n;

	public MatchKM(int a, int b) {
		m = a;
		n = b;
		cost = new long[m][n];
		map = new boolean[m][n];
		labelx = new long[m];
		labely = new long[n];
		matchx = new int[m];
		matchy = new int[n];
		checkx = new boolean[m];
		checky = new boolean[n];
	}

	public boolean findPath(int cur) {
		checkx[cur] = true;
		for (int i = 0; i < n; i++) {
			if (map[cur][i] && labelx[cur] + labely[i] == cost[cur][i] && !checky[i]) {
				checky[i] = true;
				if (matchy[i] == -1 || findPath(matchy[i])) {
					matchy[i] = cur;
					matchx[cur] = i;
					return true;
				}
			}
		}
		return false;
	}

	public long perfectMatch(int max) {
		for (int i = 0; i < m; i++) {
			labelx[i] = max;
		}
		int count = 0;
		while (count < m) {
			Arrays.fill(matchx, -1);
			Arrays.fill(matchy, -1);
			count = 0;
			for (int i = 0; i < m; i++) {
				Arrays.fill(checkx, false);
				Arrays.fill(checky, false);
				if (findPath(i))
					count++;
				else {
					long min = Long.MAX_VALUE;
					for (int u = 0; u < m; u++) {
						for (int v = 0; v < n; v++) {
							if (checkx[u] && !checky[v] && map[u][v]) {
								min = Math.min(min, labelx[u] + labely[v]
										- cost[u][v]);
							}
						}
					}
					for (int k = 0; k < m; k++) {
						if (checkx[k]) {
							labelx[k] -= min;
						}
					}
					for (int k = 0; k < n; k++) {
						if (checky[k]) {
							labely[k] += min;
						}
					}
				}
			}
		}
		long res = 0;
		for (int i = 0; i < m; i++)
			if (matchx[i] >= 0)
				res += cost[i][matchx[i]];
		return res;
	}
}
