import java.io.*;
import java.util.*;

public class Solver {

	private Scanner in;
	private PrintStream out;

	public static void main(String[] args) throws Exception {
		if (args.length < 1)
			System.out.println("No input file");
		else
			new Solver(new File(args[0]), new File(args[0] + ".out"));
	}

	public Solver(File inFile, File outFile) throws Exception {
		try (final OutputStream fileOs = new FileOutputStream(outFile); Scanner in = new Scanner(inFile)) {
			this.in = in;
			out = new PrintStream(new OutputStream() {
				@Override
				public void write(int b) throws IOException {
					System.out.write(b);
					fileOs.write(b);
				}
			});
			init();
			int T = in.nextInt();
			in.nextLine();
			for (int i = 1; i <= T; i++) {
				out.print("Case #" + i + ": ");
				solve();
				out.println();
			}
		}
	}

	/* ******************************************************** */
	/* start here */
	/* ******************************************************** */

	public void init() throws Exception {
		// nothing
	}

	public Map<String, Integer> uniqueMap(Map<String, Integer> carMap) {
		Map<String, Integer> newCarMap = new HashMap<>(carMap);
		System.out.println(newCarMap);
		return newCarMap;
	}

	public String trimCar(String car) {
		Map<String, Object> map = new LinkedHashMap<>();
		for (char c : car.toCharArray())
			map.put(c + "", c);
		String trimCar = "";
		for (String c : map.keySet())
			trimCar += c;
		return trimCar;
	}

	public boolean isValidPattern(String pattern) {
		char last = 0;
		String trimPattern = "";
		Set<String> set = new HashSet<>();
		for (char c : pattern.toCharArray()) {
			if (last != c) {
				trimPattern += c;
				last = c;
				set.add(c + "");
			}
		}
		return trimPattern.length() == set.size();
	}

	public long solveSmall(String pattern, int now, String[] cars, int N) {
		long result = 0;
		if (now == N)
			return isValidPattern(pattern) ? 1 : -1;
		for (int i = 0; i < N; i++) {
			String car = cars[i];
			if (car == null)
				continue;
			cars[i] = null;
			long r = solveSmall(pattern + car, now + 1, cars, N);
			if (r > 0)
				result += r;
			cars[i] = car;
		}
		return result;
	}

	public void solve() throws Exception {
		int N = in.nextInt();
		in.nextLine();
		String[] cars = in.nextLine().split("\\s+");

		out.print(solveSmall("", 0, cars, N));

// Map<String, Integer> carMap = new HashMap<>();
// for (String car : cars) {
// car = trimCar(car);
// Integer count = carMap.get(car);
// carMap.put(car, count == null ? 1 : count + 1);
// }
//
// Map<String, Integer> newCarMap = null;
// while (true) {
// newCarMap = uniqueMap(carMap);
// if (carMap.equals(newCarMap))
// break;
// System.out.println(newCarMap);
// }
//
// System.out.print("end");

	}
}
