import java.io.*;
import java.util.*;

public class Solver {

	private Scanner in;
	private PrintStream out;

	public static void main(String[] args) throws Exception {
		if (args.length < 1)
			System.out.println("No input file");
		else
			new Solver(new File(args[0]), new File(args[0] + ".out"));
	}

	public Solver(File inFile, File outFile) throws Exception {
		try (final OutputStream fileOs = new FileOutputStream(outFile); Scanner in = new Scanner(inFile)) {
			this.in = in;
			out = new PrintStream(new OutputStream() {
				@Override
				public void write(int b) throws IOException {
					System.out.write(b);
					fileOs.write(b);
				}
			});
			init();
			int T = in.nextInt();
			in.nextLine();
			for (int i = 1; i <= T; i++) {
				out.print("Case #" + i + ": ");
				solve();
				out.println();
			}
		}
	}

	/* ******************************************************** */
	/* start here */
	/* ******************************************************** */

	public void init() throws Exception {
		// nothing
	}

	public void solve() throws Exception {
		int N = in.nextInt();
		in.nextLine();
		String[] s = new String[N];
		for (int i = 0; i < N; i++)
			s[i] = in.nextLine();

		List<List<Object[]>> dataList = new ArrayList<List<Object[]>>();

		for (int i = 0; i < N; i++) {
			List<Object[]> data = new ArrayList<Object[]>();
			char lastC = '\n';
			int index = -1;
			int count = 1;
			for (char c : s[i].toCharArray()) {
				if (lastC != c) {
					if (index != -1)
						data.add(new Object[] { lastC, count });
					lastC = c;
					index++;
					count = 1;
				} else {
					count++;
				}
			}
			data.add(new Object[] { lastC, count });
			dataList.add(data);
		}

		String lastPattern = null;
		for (int i = 0; i < N; i++) {
			char[] str = new char[dataList.get(i).size()];
			for (int j = 0; j < dataList.get(i).size(); j++) {
				Object[] d = dataList.get(i).get(j);
				str[j] = (char) d[0];
			}
			String pattern = new String(str);
			if (lastPattern == null)
				lastPattern = pattern;
			if (!pattern.equals(lastPattern)) {
				out.print("Fegla Won");
				return;
			}
		}

		int totalChange = 0;
		for (int j = 0; j < dataList.get(0).size(); j++) {
			int totalOccur = 0;
			for (int i = 0; i < N; i++) {
				totalOccur += (int) dataList.get(i).get(j)[1];
			}
			long avgOccur = Math.round(1.0 * totalOccur / N);
			long change = 0;
			for (int i = 0; i < N; i++) {
				change += Math.abs((int) dataList.get(i).get(j)[1] - avgOccur);
			}
			totalChange += change;
		}
		out.print(totalChange);
	}
}
