import java.io.*;
import java.util.*;

class Solver {

	boolean isInFile, isOutFile;
	Scanner reader;
	DataOutputStream writer;

	public Solver(String[] args) throws Exception {
		isInFile = (args.length > 0);
		if (isInFile)
			reader = new Scanner(new File(args[0]));
		else
			reader = new Scanner(System.in);
		isOutFile = (args.length > 1);
		if (isOutFile)
			writer = new DataOutputStream(new FileOutputStream(new File(args[1])));
	}

	public void write(String str) throws Exception {
		if (isOutFile)
			writer.writeBytes(str);
		System.out.print(str);
	}

	public void writeln(String str) throws Exception {
		write(str + System.lineSeparator());
	}

	public static void main(String[] args) throws Exception {
		new Solver(args).solve();
	}

	public void solve() throws Exception {
		int T = reader.nextInt();
		reader.nextLine();
		for (int i = 1; i <= T; i++) {
			write("Case #" + i + ": ");
			solveOne();
			writeln("");
		}
	}

	public void solveOne() throws Exception {
		double C = reader.nextDouble();
		double F = reader.nextDouble();
		double X = reader.nextDouble();
		reader.nextLine();

		/* solve */
		double lastSec = Double.MAX_VALUE;
		double temp = 0;
		double N = 0;
		do {
			double speed = 2 + N * F;
			double sec = temp + X / speed;
			temp += C / speed;
			if (sec >= lastSec)
				break;
			lastSec = sec;
			N++;
		} while (true);
		write(String.format("%.7f", lastSec));
	}
}