import java.io.*;
import java.util.*;

class Solver {

	boolean isInFile, isOutFile;
	Scanner reader;
	DataOutputStream writer;

	public Solver(String[] args) throws Exception {
		isInFile = (args.length > 0);
		if (isInFile)
			reader = new Scanner(new File(args[0]));
		else
			reader = new Scanner(System.in);
		isOutFile = (args.length > 1);
		if (isOutFile)
			writer = new DataOutputStream(new FileOutputStream(new File(args[1])));
	}

	public void write(String str) throws Exception {
		if (isOutFile)
			writer.writeBytes(str);
		System.out.print(str);
	}

	public void writeln(String str) throws Exception {
		write(str + System.lineSeparator());
	}

	public static void main(String[] args) throws Exception {
		new Solver(args).solve();
	}

	public void solve() throws Exception {
		int T = reader.nextInt();
		reader.nextLine();
		for (int i = 1; i <= T; i++) {
			write("Case #" + i + ": ");
			solveOne();
			writeln("");
		}
	}

	public void solveOne() throws Exception {
		Set<String> answerSet = new HashSet<String>();
		String answer = null;
		for (int r = 0; r < 2; r++) {
			int row = reader.nextInt();
			reader.nextLine();
			for (int i = 0; i < 4; i++) {
				String line = reader.nextLine();
				if (i == row - 1) {
					for (String val : line.split(" ")) {
						if (!answerSet.add(val))
							answer = val;
					}
				}
			}
		}
		if (answerSet.size() == 8)
			write("Volunteer cheated!");
		else if (answerSet.size() == 7)
			write(answer);
		else
			write("Bad magician!");
	}
}