import java.io.*;
import java.util.*;

public class Solver {

	private Scanner in;
	private PrintStream out;

	public static void main(String[] args) throws Exception {
		if (args.length < 1)
			System.out.println("No input file");
		else
			new Solver(new File(args[0]), new File(args[0] + ".out"));
	}

	public Solver(File inFile, File outFile) throws Exception {
		try (final OutputStream fileOs = new FileOutputStream(outFile); Scanner in = new Scanner(inFile)) {
			this.in = in;
			out = new PrintStream(new OutputStream() {
				@Override
				public void write(int b) throws IOException {
					System.out.write(b);
					fileOs.write(b);
				}
			});
			init();
			int T = in.nextInt();
			in.nextLine();
			for (int i = 1; i <= T; i++) {
				out.print("Case #" + i + ": ");
				solve();
				out.println();
			}
		}
	}

	/* ******************************************************** */
	/* start here */
	/* ******************************************************** */

	public void init() throws Exception {
		// nothing
	}

	public void solve() throws Exception {
		long A = in.nextLong();
		long B = in.nextLong();
		long K = in.nextLong();
		in.nextLine();

		long count = 0;
		for (long i = 0; i < A; i++) {
			for (long j = 0; j < B; j++) {
				if ((i & j) < K)
					count++;
			}
		}
		out.print(count);

	}
}
