import java.io.*;
import java.util.*;

class Solver {

	boolean isInFile, isOutFile;
	Scanner reader;
	DataOutputStream writer;

	public Solver(String[] args) throws Exception {
		isInFile = (args.length > 0);
		if (isInFile)
			reader = new Scanner(new File(args[0]));
		else
			reader = new Scanner(System.in);
		isOutFile = (args.length > 1);
		if (isOutFile)
			writer = new DataOutputStream(new FileOutputStream(new File(args[1])));
	}

	public void write(String str) throws Exception {
		if (isOutFile)
			writer.writeBytes(str);
		System.out.print(str);
	}

	public void writeln(String str) throws Exception {
		write(str + System.lineSeparator());
	}

	public static void main(String[] args) throws Exception {
		new Solver(args).solve();
	}

	public void solve() throws Exception {
		int T = reader.nextInt();
		reader.nextLine();
		for (int i = 1; i <= T; i++) {
			write("Case #" + i + ": ");
			solveOne();
			writeln("");
		}
	}

	public void solveOne() throws Exception {
		int N = reader.nextInt();
		reader.nextLine();
		TreeMap<Double, Character> map = new TreeMap<>();
		for (Character c : new Character[] { 'a', 'b' }) {
			for (int i = 0; i < N; i++)
				map.put(reader.nextDouble(), c);
			reader.nextLine();
		}
		int a_remain = 0;
		int a_mark = 0;
		int b_remain = 0;
		int b_mark = 0;
		for (Map.Entry<Double, Character> en : map.entrySet()) {
			switch (en.getValue()) {
			case 'a':
				if (a_remain > 0) {
					a_mark++;
					a_remain--;
				}
				b_remain++;
				break;
			case 'b':
				a_remain++;
				if (b_remain > 0) {
					b_mark++;
					b_remain--;
				}
				break;
			}
		}
		write(a_mark + " " + (N - b_mark));
	}
}