import java.io.*;
import java.util.*;

public class Solver {

	private Scanner in;
	private PrintStream out;

	public static void main(String[] args) throws Exception {
		if (args.length < 1)
			System.out.println("No input file");
		else
			new Solver(new File(args[0]), new File(args[0] + ".out"));
	}

	public Solver(File inFile, File outFile) throws Exception {
		try (final OutputStream fileOs = new FileOutputStream(outFile); Scanner in = new Scanner(inFile)) {
			this.in = in;
			out = new PrintStream(new OutputStream() {
				@Override
				public void write(int b) throws IOException {
					System.out.write(b);
					fileOs.write(b);
				}
			});
			init();
			int T = in.nextInt();
			in.nextLine();
			for (int i = 1; i <= T; i++) {
				out.print("Case #" + i + ": ");
				solve();
				out.println();
			}
		}
	}

	/* ******************************************************** */
	/* start here */
	/* ******************************************************** */

	public void init() throws Exception {
		// nothing
	}

	public static long findCF(long a, long b) {
		while (a != 0 && b != 0) {
			if (a >= b) {
				a = a - b;
			} else
				b = b - a;
		}
		if (a == 0)
			return b;
		else
			return a;
	}

	public static long gcd(long a, long b) {
		if (b == 0) {
			return a;
		}
		return gcd(b, a % b);
	}

	public void solve() throws Exception {
		String[] PQ = in.nextLine().split("/");
		long P = Long.parseLong(PQ[0]) * 2;
		long Q = Long.parseLong(PQ[1]);
		long CF = gcd(P, Q);
		P /= CF;
		Q /= CF;

		double log = Math.log(Q) / Math.log(2);
		if (log != (int) log) {
			out.print("impossible");
			return;
		}

		long ans = (long) Math.ceil((Math.log(Q) - Math.log(P)) / Math.log(2)) + 1;
		out.print(ans > 40 ? "impossible" : ans);

	}
}
