import java.io.*;
import java.util.*;

class Solver {

	boolean isInFile, isOutFile;
	Scanner reader;
	DataOutputStream writer;

	public Solver(String[] args) throws Exception {
		isInFile = (args.length > 0);
		if (isInFile)
			reader = new Scanner(new File(args[0]));
		else
			reader = new Scanner(System.in);
		isOutFile = (args.length > 1);
		if (isOutFile)
			writer = new DataOutputStream(new FileOutputStream(new File(args[1])));
	}

	public void write(String str) throws Exception {
		if (isOutFile)
			writer.writeBytes(str);
		System.out.print(str);
	}

	public void writeln(String str) throws Exception {
		write(str + System.lineSeparator());
	}

	public static void main(String[] args) throws Exception {
		new Solver(args).solve();
	}

	public void solve() throws Exception {
		int T = reader.nextInt();
		reader.nextLine();
		for (int i = 1; i <= T; i++) {
			write("Case #" + i + ": ");
			solveOne();
			writeln("");
		}
	}

	boolean isVowel(char c) {
		switch (c) {
		case 'a':
		case 'e':
		case 'i':
		case 'o':
		case 'u':
			return true;
		}
		return false;
	}

	boolean check(String s, int n) {
//		System.out.println(s);
		int lastVowel = -1;
		for (int i = 0; i < s.length(); i++) {
			if (isVowel(s.charAt(i))) {
				if (i - lastVowel > n) {
					// System.out.println(" true");
					return true;
				}
				lastVowel = i;
			}
		}
		if (s.length() - lastVowel > n) {
			// System.out.println(" true");
			return true;
		}
		// System.out.prsintln(" false");
		return false;
	}

	public void solveOne() throws Exception {
		/* read data */
		String[] tmp = reader.nextLine().split(" ");
		String str = tmp[0];
		int n = Integer.parseInt(tmp[1]);
		int L = str.length();

		/* solve */
		int count = 0;
		for (int i = 0; i < L; i++) {
			for (int j = i; j < L; j++) {
				String s = str.substring(i, j + 1);
				if (s.length() < n)
					continue;
				if (check(s, n))
					count++;
			}
		}

		write(count + "");
	}
}