package google.jam;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

public class ProblemASmall {
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String filein = "data/A-large.in";
		String fileout = "data/A-large.out";
		long time = System.currentTimeMillis();
		try {
			BufferedReader in = new BufferedReader(new FileReader(filein));
			PrintStream ps = new PrintStream(fileout);
			int cases = Integer.parseInt(in.readLine());
			char[][] matrix;
			StringBuilder out;
			for (int i = 0; i < cases; i++){
				matrix = new char[4][4];
				matrix[0] = in.readLine().toCharArray();
				matrix[1] = in.readLine().toCharArray();
				matrix[2] = in.readLine().toCharArray();
				matrix[3] = in.readLine().toCharArray();
				in.readLine();
				out = new StringBuilder("Case #").append(i+1).append(": ").append(test(matrix));
				ps.println(out.toString());
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println(System.currentTimeMillis()-time);
	}

	private static String test(char[][] matrix) {
		char c = won(matrix);
		if (c == 'O')
			return "O won";
		else if (c == 'X')
			return "X won";
		else if (completed(matrix))
			return "Draw";
		else
			return "Game has not completed";
	}

	private static boolean completed(char[][] matrix) {
		for (int i = 0; i < matrix.length; i++)
			for (int j = 0; j < matrix[i].length; j++)
				if (matrix[i][j] == '.')
					return false;
		return true;
	}

	private static char won(char[][] matrix) {
		char c;
		for (int i = 0; i < matrix.length; i++){
			c = checkFour(matrix[i]);
			if (c != '.')
				return c;
		}
		for (int i = 0; i < matrix[0].length; i++){
			c = checkFour(new char[] {
					matrix[0][i],
					matrix[1][i],
					matrix[2][i],
					matrix[3][i]});
			if (c != '.')
				return c;
		}
		c = checkFour(new char[] {
				matrix[0][0],
				matrix[1][1],
				matrix[2][2],
				matrix[3][3]});
		if (c != '.')
			return c;
		c = checkFour(new char[] {
				matrix[0][3],
				matrix[1][2],
				matrix[2][1],
				matrix[3][0]});
		if (c != '.')
			return c;
		return '.';
	}

	private static char checkFour(char[] four) {
		String s = new String(four);
		String tmp = s.replace('T', 'O');
		if (tmp.equals("OOOO"))
			return 'O';
		tmp = s.replace('T', 'X');
		if (tmp.equals("XXXX"))
			return 'X';
		return '.';
	}

}
