package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class CodeJam {

    public static void main(String[] args) throws FileNotFoundException, IOException {
        Scanner input = new Scanner(new File("Input.txt"));
        PrintWriter output = new PrintWriter(new File("Output.txt"));
        
        int testCases = input.nextInt();
        
        for(int count = 1; count <= testCases; count++){
            int flipCount = 0;
            String cakes = input.next();
            
            int index;
            while(!CheckCakes(cakes)){
                index = LiftIndex(cakes);
                cakes = FlipAndReverse( cakes.substring(0, index+1) ) + cakes.substring(index+1, cakes.length());
                flipCount++;
            }
            
            output.println("Case #" + count + ": " + flipCount);
        }
        
        input.close();
        output.close();
    }
    
    public static String FlipAndReverse(String cakeStack){
        String cakes = "";
        for(int index = 0; index < cakeStack.length(); index++){
            if(cakeStack.charAt(index) == '+')
                cakes = cakes + "-";
            else
                cakes = cakes + "+";
        }
        return cakes;
    }
    
    public static boolean CheckCakes(String cakes){
        for(int index = 0; index < cakes.length(); index++){
            if(cakes.charAt(index) == '-')
                return false;
        }
        return true;
    }
    
    public static int LiftIndex(String cakes){
        int index = 0;
        if(cakes.length() == 1)
            return index;
        
        char cake = cakes.charAt(index);
        while( index+1 < cakes.length() && cakes.charAt(index+1) == cake)
            index++;
        
        return index;
    }
}
