import java.io.*;
import java.util.*;

public class Q1 {
	public static void main(String[] args) {
		String inputfile = args[0];
		String outputfile = args[1];
		Scanner sc = null;
		try {
			sc = new Scanner(new FileReader(inputfile));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		String tStr = sc.nextLine();
		int t = 0;
		try{
			t = Integer.parseInt(tStr);
		}catch(NumberFormatException nfe){
			nfe.printStackTrace();
		}
		
		int [] intInput = new int[t];
		for(int i = 0; i < t ; i++){
			String intStr = sc.nextLine();
			try{
				intInput[i] = Integer.parseInt(intStr);
				//System.out.println(intInput[i]);
			}catch(NumberFormatException nfe){
				nfe.printStackTrace();
			}
		}
		
		sc.close();
		
		File out = new File(outputfile);
		if(!out.exists()){
			try {
				out.createNewFile();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		PrintWriter pw = null;
		try {
			pw = new PrintWriter(new FileWriter(out));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		for(int i = 0; i < t ; i++){
			int res = test(intInput[i]);
			if(res == -1){
				pw.write("Case #" + (i+1) + ": INSOMNIA\n");
			}else{
				pw.write("Case #" + (i+1) + ": "+ res + "\n");
			}
		}
		
		pw.close();
		
	}
	
	public static int test(int num){
		HashSet<Integer> req = new HashSet<Integer>();
		for(int i = 0; i< 10; i++){
			req.add(new Integer(i));
		}
		
		HashSet<Integer> res = new HashSet<Integer>();
		boolean done = false;
		int i = 1;
		while(!done){
			int cur = i*num;
			if(res.contains(new Integer(cur))){
				done = true;
				System.out.println("INSOMNIA");
				return -1;
			}
			while(cur > 0){
				int digit = cur % 10;
				if(req.contains(new Integer(digit))){
					req.remove(new Integer(digit));
				}
				cur /= 10;
			}
			if(req.isEmpty()){
				done = true;
				System.out.println(i*num);
				return (i*num);
			}else{
				res.add(new Integer(i*num));
				i++;
			}
			
		}
		System.out.println("failed");
		return -2;
	}
}
