import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Q3 {
	private static ArrayList<BigInteger> prime = new ArrayList<BigInteger>(); //prime < 1000
	private static File primefile = new File("prime.txt");
	private static long filerange = 1000, listrange = 0;

	public static void main(String[] args) {
		String inputfile = args[0];
		String outputfile = args[1];
		if (!primefile.exists()) {
			try {
				primefile.createNewFile();
			} catch (IOException e2) {
				e2.printStackTrace();
			}
		}
		
		Scanner sc = null;
		try {
			sc = new Scanner(new FileReader(inputfile));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

		String tStr = sc.nextLine();

		int[] intInput = new int[2];
		String[] intStr = sc.nextLine().split(" ");
		for (int i = 0; i < intStr.length; i++) {
			try {
				intInput[i] = Integer.parseInt(intStr[i]);
				// System.out.println(intInput[i]);
			} catch (NumberFormatException nfe) {
				nfe.printStackTrace();
			}
		}

		sc.close();

		File out = new File(outputfile);
		if (!out.exists()) {
			try {
				out.createNewFile();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		PrintWriter pw = null;
		try {
			pw = new PrintWriter(new FileWriter(out));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		pw.write("Case #1:\n");
		String[] res = test(intInput[0], intInput[1]);
		for (int i = 0; i < res.length; i++) {
			pw.write(res[i] + "\n");
		}

		System.out.println(prime.toString());

		pw.close();

	}

	public static String[] test(int n, int j) {
		String[] res = new String[j];
		for(int i = 2 ; i < filerange ; i++){
			BigInteger bi = new BigInteger(Integer.toString(i), 10);
			if(testPrime(bi) == -1){
				prime.add(bi);
				System.out.println(i);
			}
		}
		listrange = filerange -1;
		int pointer = 0;
		String cand = generate(n, null);
		while (pointer < j) {
			String cur = cand;
			//System.out.println(cur);
			String curRes = new String(cur);
			boolean failed = false;
			for (int b = 2; b <= 10; b++) {
				BigInteger v = new BigInteger(cur, b);

				int pr = testPrime(v);
				if (pr == -1) {
					failed = true;
					break; // stop verify
				} else {
					curRes += " " + Long.toString(pr);
				}
			}
			if (!failed) {
				res[pointer] = curRes;
				System.out.println(curRes);
				pointer++;
			}
			cand = generate(n, cur);
		}
		return res;
	}
	
	public static int testPrime(BigInteger k) {
		int p = 0;
		while (p < prime.size()) { // test prime < 10000
			BigInteger f = prime.get(p);
			if (k.mod(f).equals(new BigInteger("0"))) {
				return Integer.parseInt(f.toString());
			}
			p++;
		}
		return -1;
	}

	public static String generate(int n, String prev) {
		String minmid = "";
		for (int i = 0; i < n - 2; i++) {
			minmid += "0";
		}
		String min = "1" + minmid + "1";
		if(prev == null){
			return min;
		}
		
		long res = Long.parseLong(prev, 2);
		res += 2;
		
		return Long.toBinaryString(res);
	}
}
