import java.io.*;
import java.util.*;

public class Q3 {
	private static ArrayList<Long> prime = new ArrayList<Long>(); //prime < 500
	private static File primefile = new File("prime.txt");
	private static long filerange = 500, listrange = 0;

	public static void main(String[] args) {
		String inputfile = args[0];
		String outputfile = args[1];
		if (!primefile.exists()) {
			try {
				primefile.createNewFile();
			} catch (IOException e2) {
				e2.printStackTrace();
			}
		}
		Scanner sc = null;
		try {
			sc = new Scanner(new FileReader(inputfile));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

		String tStr = sc.nextLine();

		int[] intInput = new int[2];
		String[] intStr = sc.nextLine().split(" ");
		for (int i = 0; i < intStr.length; i++) {
			try {
				intInput[i] = Integer.parseInt(intStr[i]);
				// System.out.println(intInput[i]);
			} catch (NumberFormatException nfe) {
				nfe.printStackTrace();
			}
		}

		sc.close();

		File out = new File(outputfile);
		if (!out.exists()) {
			try {
				out.createNewFile();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		PrintWriter pw = null;
		try {
			pw = new PrintWriter(new FileWriter(out));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		pw.write("Case #1:\n");
		String[] res = test(intInput[0], intInput[1]);
		for (int i = 0; i < res.length; i++) {
			pw.write(res[i] + "\n");
		}

		System.out.println(prime.toString());

		pw.close();

	}

	public static String[] test(int n, int j) {
		String[] res = new String[j];
		for(long i = 2 ; i < filerange ; i++){
			if(isPrime(i) == 0)
				prime.add(i);
		}
		listrange = filerange -1;
		int pointer = 0;
		ArrayList<String> cand = generate(n);
		System.out.println(cand.toString());
		Iterator<String> it = cand.iterator();
		while (pointer < j) {
			String cur = it.next();
			System.out.println(cur);
			String curRes = new String(cur);
			boolean failed = false;
			for (int b = 2; b <= 10; b++) {
				long v = Long.parseLong(cur, b);

				long pr = isPrime(v);
				if (pr == 0) {
					failed = true;
					break; // stop verify
				} else {
					curRes += " " + Long.toString(pr);
				}
			}
			if (!failed) {
				res[pointer] = curRes;
				System.out.println(curRes);
				pointer++;
			}
		}
		return res;
	}

	public static long isPrime(long k) {
		if (filerange < Math.sqrt(k)) {
			for (long i = filerange+1; i < Math.sqrt(k) + 1; i++) {
				//System.out.println(filerange + " " + Math.sqrt(k) + " " + k + " " + i);
				if(isPrime(i) == 0){
					PrintWriter pw = null;
					try {
						pw = new PrintWriter(new FileWriter(primefile, true));
					} catch (IOException e) {
						e.printStackTrace();
					}
					pw.write(i + "\n");
					pw.close();
					filerange = i;
				}
			}
			
		}
		int p = 0;
		while (p < prime.size() && prime.get(p) <= Math.sqrt(k)) { // test prime < 500
			long f = prime.get(p);
			if (k % f == 0) {
				return f;
			}
			p++;
		}
		if (filerange != 500) {
			Scanner sc = null;
			try {
				sc = new Scanner(primefile);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
			while (sc.hasNext()) {
				long nextp = Long.parseLong(sc.nextLine());
				if(nextp > Math.sqrt(k))
					break;
				if (k % nextp == 0) {
					sc.close();
					return nextp;
				}
			}
			sc.close();
		}
		return 0;
	}

	public static ArrayList<String> generate(int n) {
		ArrayList<String> perm = new ArrayList<String>();
		String maxmid = "", minmid = "";
		for (int i = 0; i < n - 2; i++) {
			maxmid += "1";
			minmid += "0";
		}
		String max = "1" + maxmid + "1";
		String min = "1" + minmid + "1";
		Long maxv = Long.parseLong(max, 2);
		Long minv = Long.parseLong(min, 2);
		for (long i = minv; i <= maxv; i++) {
			if ((i & 1) == 1) // check last digit
				perm.add(Long.toBinaryString(i));
		}
		return perm;
	}
}
