import java.io.*;
import java.util.*;

public class Q4 {
	public static void main(String[] args) {
		String inputfile = args[0];
		String outputfile = args[1];
		Scanner sc = null;
		try {
			sc = new Scanner(new FileReader(inputfile));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		String tStr = sc.nextLine();
		int t = 0;
		try{
			t = Integer.parseInt(tStr);
		}catch(NumberFormatException nfe){
			nfe.printStackTrace();
		}
		
		String [] strInput = new String[t];
		for(int i = 0; i < t ; i++){
			strInput[i] = sc.nextLine();
		}
		
		sc.close();
		
		File out = new File(outputfile);
		if(!out.exists()){
			try {
				out.createNewFile();
			} catch (IOException e1) {
				e1.printStackTrace();
			}
		}
		PrintWriter pw = null;
		try {
			pw = new PrintWriter(new FileWriter(out));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		for(int i = 0; i < t ; i++){
			long [] res = test(strInput[i]);
			if(res == null){
				pw.write("Case #" + (i+1) + ": IMPOSSIBLE\n");
			}else{
				pw.write("Case #" + (i+1) + ":");
				for(long j : res)
					pw.write(" " + Long.toString(j));
				pw.write("\n");
			}
		}
		
		pw.close();
		
	}
	
	public static long [] test(String input){
		String [] in = input.split(" ");
		long [] res = null;
		int k = 0, c = 0, s = 0;
		try{
			k = Integer.parseInt(in[0]);
			c = Integer.parseInt(in[1]);
			s = Integer.parseInt(in[2]);
		}catch(NumberFormatException nfe){
			nfe.printStackTrace();
		}
		System.out.println("k=" + k + " c=" + c + " s=" + s);
		if(s < Math.ceil((double)k/c)){
			return res;
		}else if(k == 1){
			res = new long[1];
			res[0] = 1;
		}else if(c == 1){
			res = new long[k];
			for(int i = 1; i<=k; i++)
				res[i-1] = i;
		}else{
			int iter = (int) Math.ceil((double)k/c);
			res = new long[iter];
			System.out.println("k/c" + k/c);
			for(int i = 0; i < iter; i++){
				res[i] =  (long) ((long)i*(c-1)*Math.pow(k, c-1) + (long)(Math.pow(k, c)-k)/(k-1) - (long)i);
			}
		}
		return res;
	}

}

