import java.util.*;
import java.io.*;
import java.math.*;

public class CoinJam {

    private static class NonPrime {
        public BigInteger val;
        public BigInteger divider;
        public BigInteger base;

        public NonPrime(BigInteger val, BigInteger divider, BigInteger base) {
            this.val = val;
            this.divider = divider;
            this.base = base;
        }

        public boolean equals(NonPrime other) {
            return this.val.equals(other.val);
        }
    }

    public static BigInteger getDivider(BigInteger val, BigInteger base) {
        BigInteger max = val.divide(BigInteger.valueOf(2));
        if (val.isProbablePrime(10)) {
             return BigInteger.valueOf(-1);
        }
        for (BigInteger i = BigInteger.valueOf(2); i.compareTo(max) < 0; i = i.add(BigInteger.ONE)) {
            if (val.remainder(i).equals(BigInteger.ZERO)) {
                return i;
            }
        }
        return BigInteger.valueOf(-1);
    }

    public static NonPrime getNextNonPrime(BigInteger from, BigInteger base) {
        BigInteger val = from;
        BigInteger divider;

        while (true) {
            divider = getDivider(val, base);
            if (divider.equals(BigInteger.valueOf(-1))) {
                val = val.add(BigInteger.ONE).add(BigInteger.ONE);
            } else {
                break;
            }
        }
        return new NonPrime(val, divider, base);
    }


    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();    

        for (int i = 1; i <= t; ++i) {
        
            int n = in.nextInt();
            int j = in.nextInt();
            NonPrime[][] res = new NonPrime[j][11];

            BigInteger val = BigInteger.valueOf(2);
            val = val.pow(n - 1).add(BigInteger.ONE);

            int found = 0;
            while (found < j) {

                NonPrime nonPrime = getNextNonPrime(val, BigInteger.valueOf(2));
                val = nonPrime.val;
                res[found][2] = nonPrime;
                String binary = val.toString(2);

                boolean hasToTryAnother = false;
                for (int b = 3; b <= 10; b++) {
                    BigInteger value = new BigInteger(binary, b);
                    NonPrime nextNonPrime = getNextNonPrime(value, BigInteger.valueOf(b));
                    res[found][b] = nextNonPrime;
                    if (!nextNonPrime.val.toString(b).equals(nonPrime.val.toString(2))) {
                        hasToTryAnother = true;
                        break;
                    }
                }
                if (!hasToTryAnother) {
                    found += 1;
                }

                val = val.add(BigInteger.ONE).add(BigInteger.ONE);
            }


            System.out.println("Case #" + i + ": " );
            for (int k = 0; k < j; k++) {
                System.out.print(res[k][2].val.toString(2));
                for (int base = 2; base <= 10; base++) {
                    System.out.print(" " + res[k][base].divider.toString());
                }
                System.out.println();
            }
        }
    }
}