package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;

public class Water {

	int maps = 0;
	int H, W;

    int[][] map;
    char[][] flow;
    
    char nextCell;
    
	public void readWriteFiles() {
		try { 
			FileInputStream fstream = new FileInputStream("C:\\water.txt");
			DataInputStream in = new DataInputStream(fstream);
	        BufferedReader br = new BufferedReader(new InputStreamReader(in));
	        
	        FileWriter fWriter = new FileWriter("C:\\out.txt");
	        BufferedWriter out = new BufferedWriter(fWriter);
	        maps = Integer.parseInt(br.readLine());
	        for (int i=0; i<maps; i++) {
	        	out.write("Case #" + (i+1) + ":\n");
	        	nextCell = 'a';
	        	String[] hw = br.readLine().split(" ");
	        	H = Integer.parseInt(hw[0]);
	        	W = Integer.parseInt(hw[1]);
	        	map = new int[H][W];
	        	flow = new char[H][W];
	        	
	        	//populate map
	        	for (int j=0; j<H; j++) {
	        		String[] s = br.readLine().split(" ");
	        		for (int k=0; k<W; k++) {
	        			map[j][k]= Integer.parseInt(s[k]);
	        		}
	        	}
	        	
	        	//init flow
	        	for (int j=0; j<H; j++) {
	        		for (int k=0; k<W; k++) {
	        			flow[j][k] = ' ';
	        		}
	        	}
	        	for (int j=0; j<H; j++) {
	        		for (int k=0; k<W; k++) {
	        			fillMap(j, k);
	        		}
	        	}
	        	
	        	for (int j=0; j<H; j++) {
	        		for (int k=0; k<W; k++) {
	        			out.write(flow[j][k] + " ");
	        		}
	        		out.write("\n");
	        	}
	        }
	        out.close();
	        fWriter.close();
		} catch (Exception e) {
			System.err.println("Screwed for the second time!!! :D");
			e.printStackTrace();
		}		
	}
	
	private char fillMap(int h, int w) {
    	int val =  map[h][w];
    	int x = -1;
    	
    	if (flow[h][w]!=' ') {
    		return flow[h][w];
    	}
    	
    	if (h>0) {
			if (map[h-1][w]<val) {
				x = 0;
				val = map[h-1][w];
			}
		}
		if (w>0) {
			if (map[h][w-1]<val) {
				x =1;
				val = map[h][w-1];
			}
		}
		if (w<W-1) {
			if (map[h][w+1]<val) {
				x = 2;
				val = map[h][w+1];
			}
		}
		if (h<H-1) {
			if (map[h+1][w]<val) {
				x = 3;
				val = map[h+1][w];
			}
		}
		if (x > -1) {
			if (x==0) {
				flow[h][w] = fillMap(h-1, w);
			} else if (x==1) {
				flow[h][w] = fillMap(h, w-1);
			} else if (x==2) {
				flow[h][w] = fillMap(h, w+1);
			} else if (x==3) {
				flow[h][w] = fillMap(h+1, w);
			}
		} else {
			flow[h][w] = nextCell;
			nextCell++;
		}
		return flow[h][w];
	}
	
	public static void main(String[] args) {
		Water water = new Water();
		water.readWriteFiles();
	}
}
