package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;

public class Alien {
	private int L, D=0, N;
	private String[] words = null;
	private boolean[] accepted = null;
	
	public void readWriteFiles() {
		try { 
			FileInputStream fstream = new FileInputStream("C:\\alien.txt");
			DataInputStream in = new DataInputStream(fstream);
	        BufferedReader br = new BufferedReader(new InputStreamReader(in));
	        
	        FileWriter fWriter = new FileWriter("C:\\out.txt");
	        BufferedWriter out = new BufferedWriter(fWriter);
	    
	        String strLine;
	        int count = 0;
	        while ((strLine=br.readLine())!=null) {
	        	if (count==0) {
	        		String[] numbers = strLine.split(" ");
	        		L = Integer.parseInt(numbers[0]);
	        		D = Integer.parseInt(numbers[1]);
	        		N = Integer.parseInt(numbers[2]);
	        		words = new String[D];
	        		accepted = new boolean[D];
	        	} else if (count <= D) {
	        		words[count-1] = strLine;
	        	} else {
	        		out.write("Case #" + (count-D) + ": " +checkCases(strLine.toCharArray()) + "\n");
	        		
	        	}
	        	count++;
	        }
	        out.close();
		} catch (Exception e) {
			System.err.println("You are Screwed!!!");
		}
	}
	
	private int checkCases(char[] cipher) {
		for (int i=0; i<accepted.length; i++) {
			accepted[i] = true;
		}
		boolean isOpenParanthesis = false;
		int position = -1;
		String token = "";
		for (int i=0; i<cipher.length; i++) {
			if (cipher[i]=='(') {
				isOpenParanthesis = true;
				position++;
			} else if (cipher[i]==')') {
				isOpenParanthesis = false;
				acceptRelevent(position, token);
				token = "";
			} else {
				token += cipher[i];
				if (!isOpenParanthesis) {
					position++;
					acceptRelevent(position, token);
					token = "";
				}
			}
		}
		
		return getAcceptCount();
	}
	
	private void acceptRelevent(int position, String token) {
		char[] c = token.toCharArray();
		for (int i=0; i<words.length; i++) {
			if (accepted[i]) {
				boolean accept = false;
				for (int j=0; j<c.length; j++) {
					if (words[i].charAt(position)==c[j]) {
						accept = true;
						break;
					}
				}
				if (!accept) {
					accepted[i] = false;
				}
			}
		}
	}
	
	private int getAcceptCount() {
		int count = 0;
		for (int i=0; i<accepted.length; i++) {
			if (accepted[i]) count ++;
		}
		return count;
	}
	
	public static void main(String[] args) {
		Alien alien = new Alien();
		alien.readWriteFiles();
	}
}
