package a;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;

public class Main {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("input.txt");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("output.txt");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		Tongues solver = new Tongues();
		int testCases = in.nextInt();
		for (int i = 1; i <= testCases; i++)
			solver.solve(i, in, out);

		out.close();
	}
}

class InputReader {
	private BufferedReader reader;

	public InputReader(InputStream stream) {
		reader = new BufferedReader(new InputStreamReader(stream));
	}

	public String next() {
		try {
			return reader.readLine();
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}
}

class Tongues {

	public void solve(int testCase, InputReader in, PrintWriter out) {
		String s = in.next();
		out.println("Case #" + testCase + ": " + translate(s));
	}

	private static final String[] GLANG = { "y qee",
			"ejp mysljylc kd kxveddknmc re jsicpdrysi",
			"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
			"de kr kd eoya kw aej tysr re ujdr lkgc jv" };
	private static final String[] NLANG = { "a zoo",
			"our language is impossible to understand",
			"there are twenty six factorial possibilities",
			"so it is okay if you want to just give up" };
	private static final int CHAR_SIZE = 'z' - 'a' + 1;
	private static char[] dict = new char[CHAR_SIZE];

	public Tongues() {
		initializeDict();
	}

	private static String translate(String string) {
		StringBuilder sb = new StringBuilder();

		char[] s = string.toCharArray();
		for (int i = 0; i < s.length; i++) {
			char c = s[i];
			if (c < 'a' || c > 'z')
				sb.append(c);
			else
				sb.append(dict[c - 'a']);
		}

		return sb.toString();
	}

	private static void initializeDict() {
		Arrays.fill(dict, '0');

		boolean[] used = new boolean[CHAR_SIZE];

		for (int i = 0; i < GLANG.length; i++) {
			String gs = GLANG[i];
			String ns = NLANG[i];

			for (int ii = 0; ii < gs.length(); ii++) {
				char gc = gs.charAt(ii);
				char nc = ns.charAt(ii);
				if (gc < 'a' || gc > 'z')
					continue;

				dict[gc - 'a'] = nc;
				used[nc - 'a'] = true;
			}
		}

		for (int i = 0; i < used.length; i++) {
			if (!used[i]) {
				char unused = (char) ('a' + i);
				for (int ii = 0; ii < dict.length; ii++) {
					if (dict[ii] == '0') {
						dict[ii] = unused;
						break;
					}
				}
				break;
			}
		}

		System.out.println(Arrays.toString(dict));
	}

}