import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

public class AmpleSyrup {
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

		Comparator comparator = new Comparator()
		{
			public int compare(Object o1, Object o2)
			{
			if(o1 instanceof Pancake && o2 instanceof Pancake)
			{
				Pancake p1 = (Pancake)o1;
				Pancake p2 = (Pancake)o2;

				if (p1.r < p2.r) {
					return 1;
				} else if (p1.r > p2.r) {
					return -1;
				} else if (p1.h < p2.h) {
					return 1;
				} else if (p1.h > p2.h) {
					return -1;
				}
			}
			return 0;
			}
		};

		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			int n = in.nextInt();
			int k = in.nextInt();
			Queue<Pancake> availablePancakes = new PriorityQueue<Pancake>(comparator);
			List<Pancake> pancakes = new ArrayList<Pancake>(k);

			for(int ii = 1; ii <= n; ++ii) {
				int r = in.nextInt();
				int h = in.nextInt();
				availablePancakes.add(new Pancake(r, h));
			}

			for (int ii = 1; ii <= k; ++ii) {
				pancakes.add(0, availablePancakes.remove());
			}

//			System.out.println(pancakes.toString());

//			while(!availablePancakes.isEmpty()) {
//				Pancake newPancake = availablePancakes.remove();
//				Pancake previous = newPancake;
//				double min = Double.MAX_VALUE;
//				int index = -1;
//				for (int ii = 0; ii < k; ++ii) {
//					Pancake current = pancakes.get(ii);
//					double currentSurface = getSurface(previous, current);
//					if (currentSurface < min) {
//						min = currentSurface;
//						index = ii;
//					}
//					previous = current;
//				}
//				if (index != -1 && newPancake.getSideSurface() > pancakes.get(index).getSideSurface()) {
//					pancakes.remove(index);
//					pancakes.add(0, newPancake);
//				}
//			}

			while(!availablePancakes.isEmpty()) {
				Pancake newPancake = availablePancakes.remove();

				double min = Double.MAX_VALUE;
				int index = -1;
				for (int ii = 0; ii < k-1; ++ii) {
					Pancake current = pancakes.get(ii);
					double currentSurface = current.getSideSurface();
					if (currentSurface < min) {
						min = currentSurface;
						index = ii;
					}
				}

				Pancake bottomElement = pancakes.get(k - 1);
				double bottomElementTopSurfaceDiff = bottomElement.getTopSurface() - (k > 1 ? pancakes.get(k - 2).getTopSurface() : 0);
				if (bottomElement.getSideSurface() + bottomElementTopSurfaceDiff < min) {
					min = bottomElement.getSideSurface() + bottomElementTopSurfaceDiff;
					index = k - 1;
				}

				if (newPancake.getSideSurface() + (k == 1 ? newPancake.getTopSurface() : 0) > min) {
					pancakes.remove(index);
					pancakes.add(0, newPancake);
				}
			}

//			System.out.println(pancakes.toString());

			double side = 0.0d;
			for (Pancake p : pancakes) {
				side += p.getSideSurface();
			}

			System.out.printf("Case #%d: %.9f\n", i, side + pancakes.get(k-1).getTopSurface());
		}
	}

	public static double getSurface(Pancake previous, Pancake current) {
		return current.getTopSurface() - previous.getTopSurface() + current.getSideSurface();
	}
}

class Pancake {
	public long r;
	public long h;

	Pancake(long r, long h) {
		this.r = r;
		this.h = h;
	}

	public double getTopSurface () {
		return Math.PI * (double) (r * r);
	}

	public double getSideSurface () {
		return Math.PI * (double) (2l * r * h);
	}

	@Override
	public String toString() {
		return "Pancake{" +
				"r=" + r +
				", h=" + h +
				'}';
	}
}
