import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.PriorityQueue;
import java.util.Scanner;
import java.util.Comparator;

public class BathroomStalls {
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			long n = in.nextLong();
			long k = in.nextLong();

			Comparator comparator = new Comparator()
			{
				public int compare(Object o1, Object o2)
				{
					if(o1 instanceof Pair && o2 instanceof Pair)
					{
						Pair p1 = (Pair)o1;
						Pair p2 = (Pair)o2;

						if (p1.min > p2.min) {
							return -1;
						} else if (p1.min < p2.min) {
							return 1;
						} else if (p1.max > p2.max) {
							return -1;
						} else if (p1.max < p2.max) {
							return 1;
						} else if (p1.middle < p2.middle) {
							return -1;
						} else if (p1.middle > p2.middle) {
							return 1;
						}
					}
					return 0;
				}
			};

			PriorityQueue<Pair> pairs = new PriorityQueue<Pair>(comparator);
			pairs.add(new Pair(0, n - 1));

			for (int ii = 1; ii < k; ++ii) {
				Pair p = pairs.poll();
				if (p.lower != p.upper) {
					if (p.middle != p.lower) {
						pairs.add(new Pair(p.lower, p.middle - 1));
					}
					if (p.middle != p.upper) {
						pairs.add(new Pair(p.middle + 1, p.upper));
					}
				}
			}
			Pair p = pairs.poll();

			System.out.println("Case #" + i + ": " + p.max + " " + p.min);
		}
	}
}

class Pair {
	public long lower;
	public long upper;
	public long middle;
	public long min;
	public long max;

	public Pair (long lower, long upper) {
		this.lower = lower;
		this.upper = upper;

		middle = lower + (upper - lower) / 2;
		long l = middle - lower;
		long r = upper - middle;
		min = Math.min(l, r);
		max = Math.max(l, r);
	}
}