import ncst.pgdst.IOException;
import ncst.pgdst.SimpleInput;


public class WaterSheds
{
	public static void main(String[] args) throws IOException
	{
		SimpleInput sin = new SimpleInput();
		int n = (new SimpleInput(sin.readLine())).readInt();
		for(int k = 1; k <= n; k++)
		{
			int r = (new SimpleInput(sin.readWord())).readInt();
			int c = (new SimpleInput(sin.readLine())).readInt();
			int[][] matrix = new int[r][];
			char[][] output = new char[r][];
			for(int i = 0; i < r; i++)
			{
				matrix[i] = new int[c];
				output[i] = new char[c];
				for(int j = 0; j < c; j++)
				{
					matrix[i][j] = (new SimpleInput(sin.readWord())).readInt();
					output[i][j] = '!';
				}
				sin.readLine();
			}
			char nextLabel = 'a';
			for(int i = 0; i < r; i++)
				for(int j = 0; j < c; j++)
				{
					char sinkLabel = '!'; 
					char direction = 'x';
					int least = matrix[i][j];
					if(i > 0 && matrix[i - 1][j] < least)
					{
						direction = 'n';
						least = matrix[i - 1][j];
						sinkLabel = output[i - 1][j];
					}
					if(j > 0 && matrix[i][j - 1] < least)
					{
						direction = 'w';
						least = matrix[i][j - 1];
						sinkLabel = output[i][j - 1];
					}
					if(j < c - 1 && matrix[i][j + 1] < least)
					{
						direction = 'e';
						least = matrix[i][j + 1];
						sinkLabel = output[i][j + 1];
					}
					if(i < r - 1 && matrix[i + 1][j] < least)
					{
						direction = 's';
						least = matrix[i + 1][j];
						sinkLabel = output[i + 1][j];
					}
					if(direction == 'x')
					{
						if(output[i][j] == '!')
						{
							output[i][j] = nextLabel;
							nextLabel++;
						}
						continue;
					}
					if(sinkLabel == '!')
					{
						if(output[i][j] == '!')
						{
							sinkLabel = nextLabel;
							output[i][j] = sinkLabel;
							nextLabel++;
						}
						else
							sinkLabel = output[i][j];
					}
					else if(output[i][j] != '!')
						replace(output, output[i][j], sinkLabel);
					else
						output[i][j] = sinkLabel;
					switch(direction)
					{
					case 'n':
						output[i - 1][j] = sinkLabel;
						break;
					case 'w':
						output[i][j - 1] = sinkLabel;
						break;
					case 'e':
						output[i][j + 1] = sinkLabel;
						break;
					case 's':
						output[i + 1][j] = sinkLabel;
						break;
					}
				}
			nextLabel = 'a';
			for(int i = 0; i < r; i++)
				for(int j = 0; j < c; j++)
				{
					if(output[i][j] > nextLabel)
					{
						swap(output, output[i][j], nextLabel);
						nextLabel++;
					}
					else
					{
						nextLabel = output[i][j];
						nextLabel++;
					}
				}
			System.out.println("Case #" + k + ":");
			for(int i = 0; i < r; i++)
				for(int j = 0; j < c; j++)
				{
					System.out.print(output[i][j]);
					System.out.print((j != c - 1) ? ' ' : '\n');
				}
		}
	}
	private static void replace(char[][] matrix, char src, char dst)
	{
		int r = matrix.length;
		int c = matrix[0].length;
		for(int i = 0; i < r; i++)
			for(int j = 0; j < c; j++)
				if(matrix[i][j] == src)
					matrix[i][j] = dst;
	}
	private static void swap(char[][] matrix, char c1, char c2)
	{
		int r = matrix.length;
		int c = matrix[0].length;
		for(int i = 0; i < r; i++)
			for(int j = 0; j < c; j++)
				if(matrix[i][j] == c1)
					matrix[i][j] = c2;
				else if(matrix[i][j] == c2)
					matrix[i][j] = c1;
	}

}
