import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class SenateEvacuation {

	public static void main(String[] args) throws FileNotFoundException {

		String fileName = "A-large.in";
		new SenateEvacuation().execute(fileName);
	}

	private void execute(String fileName) throws FileNotFoundException {

		String inputFile = "/users/amarnathreddy/Desktop/input/" + fileName;

		String outputFile = inputFile.replace("in", "out");

		Scanner scan = new Scanner(new File(inputFile));
		PrintWriter pw = new PrintWriter(new File(outputFile));

		int T = scan.nextInt();

		int count = 0;
		for (int ind = 0; ind < T; ind++) {

			int parties = scan.nextInt();

			List<Integer> senate = new ArrayList<>();
			for (int jnd = 0; jnd < parties; jnd++) {
				senate.add(scan.nextInt());
			}

			List<String> evacuation = new ArrayList<String>();
			while (true) {

				List<Integer> remainingSenate = evacuate(2, senate, evacuation);

				if (!isSenateValid(remainingSenate)) {
					evacuation.remove(evacuation.size() - 1);
					remainingSenate = evacuate(1, senate, evacuation);
				}
				senate = remainingSenate;
				if (isEvacuated(senate)) {
					break;
				}
			}

			pw.print("Case #" + ++count + ":");
			System.out.print("Case #" + count + ":");
			for (String evac : evacuation) {
				pw.print(" " + evac);
				System.out.print(" " + evac);
			}
			pw.println();
			System.out.println();
		}
		scan.close();
		pw.close();

	}

	private List<Integer> evacuate(int count, List<Integer> senate, List<String> evacuation) {

		int countMax = 1;

		int maxInd = 0;
		int nextInd = -1;

		List<Integer> dupSenate = new ArrayList<>();

		for (int ind = 1; ind < senate.size(); ind++) {

			if (senate.get(maxInd).intValue() < senate.get(ind).intValue()) {
				nextInd = maxInd;
				maxInd = ind;
				countMax = 1;
			}
			else if (maxInd != ind && senate.get(maxInd).intValue() == senate.get(ind).intValue()) {
				nextInd = maxInd;
				maxInd = ind;
				countMax++;
			}
			else if (nextInd == -1) {
				nextInd = ind;
			}
		}

		String comb = "";
		for (int ind = 0; ind < senate.size(); ind++) {

			if (ind == maxInd || (count == 2 && ind == nextInd)) {
				dupSenate.add(senate.get(ind).intValue() - 1);
				comb += (char) (((int) 'A') + ind);
			}
			else {
				dupSenate.add(senate.get(ind));
			}
		}
		evacuation.add(comb);
		return dupSenate;
	}

	private boolean isSenateValid(List<Integer> senate) {

		int max = 0;
		int total = 0;
		for (Integer sen : senate) {
			if (sen.intValue() < 0) {
				return false;
			}
			total += sen.intValue();

			if (max < sen.intValue()) {
				max = sen.intValue();
			}
		}

		if (max > total / 2) {
			return false;
		}

		return true;

	}

	private boolean isEvacuated(List<Integer> senate) {

		for (Integer sen : senate) {
			if (sen.intValue() > 0) {
				return false;
			}
		}
		return true;
	}
}
