import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Scanner;
import java.util.Stack;

public class CoinJam {

	public static void main(String[] args) throws FileNotFoundException {
//		long startTime = System.currentTimeMillis();
//		System.out.println(startTime);
		String fileName = "C-small-attempt0.in";
		new CoinJam().execute(fileName);
//		System.out.println(startTime);
//		long endTime = System.currentTimeMillis();
//		System.out.println(endTime);
//		long totalTime = endTime - startTime;
//		System.out.println(totalTime);
//		System.out.println((int) ((totalTime / 1000) / 60));
	}

	private void execute(String fileName) throws FileNotFoundException {

		String inputFile = "/users/amarnathreddy/Desktop/input/" + fileName;

		String outputFile = inputFile.replace("in", "out");

		Scanner scan = new Scanner(new File(inputFile));

		int T = scan.nextInt();
		List<Data> input = new ArrayList<Data>();
		for (int ind = 0; ind < T; ind++) {
			Data data = new Data();
			data.N = scan.nextInt();
			data.J = scan.nextInt();
			input.add(data);
		}

		scan.close();

		PrintWriter pw = new PrintWriter(new File(outputFile));
		int count = 0;
		for (Data data : input) {
			pw.println("Case #" + ++count + ":");
			List<Out> combinations = crawl(new Stack<Character>(), data.N - 2, data.J);
			for (int index = 0; index < data.J; index++) {
				Out out = combinations.get(index);
				pw.print(out.comb);
				for (long divisor : out.nonTrivials) {
					pw.print(" " + divisor);
				}
				pw.println();
			}
		}

		pw.close();

	}

	private List<Out> crawl(Stack<Character> stack, int n, int j) {
		List<Out> combinations = new ArrayList<Out>();
		char[] bits = { '0', '1' };
		if (stack.size() < n) {

			for (int ind = 0; ind < bits.length; ind++) {
				stack.push(bits[ind]);
				combinations.addAll(crawl(stack, n, j));
				// System.out.println(combinations.size());
				if (combinations.size() >= j) {
					break;
				}
				stack.pop();
			}
		}
		else {

			StringBuffer b = new StringBuffer();
			b.append('1');
			for (Character s : stack) {
				b.append(s);
			}
			b.append('1');
			// System.out.println(stack.size());
			if (isValidCoin(b.toString())) {
				Out out = new Out();
				out.comb = b.toString();
				out.nonTrivials = getNonTrivialDivisors(b.toString());
				combinations.add(out);
			}
		}

		return combinations;
	}

	private List<Long> getNonTrivialDivisors(String comb) {
		List<Long> nonTrivials = new ArrayList<Long>();

		for (int base = 2; base <= 10; base++) {
			long real = Long.parseLong(comb, base);

			nonTrivials.add(getNonTrivialDivisor(real));
		}
		return nonTrivials;
	}

	private long getNonTrivialDivisor(long real) {
		if (real >= 2 && real % 2 == 0) {
			return 2;
		}
		int top = (int) Math.sqrt(real) + 1;
		for (int i = 3; i < top; i += 2) {
			if (real % i == 0) {
				return i;
			}
		}
		return 0;
	}

	private boolean isValidCoin(String comb) {
		for (int base = 2; base <= 10; base++) {
			// System.out.print(comb+" "+base);
			long value = Long.parseLong(comb, base);
			// System.out.println(" "+value);
			if (isPrime(value)) {
				return false;
			}
		}
		return true;
	}

	public static boolean isPrime(long num) {
		if (num > 2 && num % 2 == 0) {
			return false;
		}
		int top = (int) Math.sqrt(num) + 1;
		for (int i = 3; i < top; i += 2) {
			if (num % i == 0) {
				return false;
			}
		}
		return true;
	}

	private class Data {
		int N;

		int J;
	}

	private class Out {
		String comb;

		List<Long> nonTrivials;
	}
}
