package Qualif;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class PbCCoins {

	static int[] div = new int[]{2,3,5,7,11};
	static Scanner in = null;
	static PrintWriter out = null;

	public static void main(String[] args) {
		/** SETUP */
		String file = "C-test";//"C-small-attempt0.in";
		String folder = "CodeJam16";
		String empInput = "C:/Users/Momo/Desktop/"+folder+"/"+file;
		String empOutput = "C:/Users/Momo/Desktop/"+folder+"/Liet-Qualif-"+file+".out";


		FileInputStream toclose=null;
		try {
			toclose = new FileInputStream(empInput);
			System.setIn(toclose);
			in = new Scanner(System.in);
			out = new PrintWriter(empOutput);
		} catch (Exception e) {
			printErr("Ouverture");
			e.printStackTrace();
		}
		/** */

		/** ALGO */
		char type = 'l';// from t:test s:small l:large

		int nbBits,
		nbCoins;
		switch(type){
		case 't':
			nbBits=6;
			nbCoins=6;
			break;
		case 's':
			nbBits=16;
			nbCoins=50;
			break;
		case 'l':
			nbBits=32;
			nbCoins=500;
			break;
		default:
			nbBits=6;
			nbCoins=6;
			break;
		}

		out.println("Case #"+1+": ");
		boolean[] chiffre = new boolean[nbBits];
		Arrays.fill(chiffre, false);
		chiffre[0]=true;
		chiffre[chiffre.length-1]=true;

		int nbSol=0;
		int nbIte=0;
		int[] divider;

		while( nbSol < nbCoins ){

			if( (divider=solve(chiffre)) != null ){
				nbSol++;
				for(boolean b:chiffre)
					out.print(b?1:0);
				for(int i:divider)
					out.print(" "+i);
				out.println();
			}
			nbIte++;
			if( ! increm(chiffre) )
				break;
		}
		/** */
		
		printErr("Essais : "+nbIte);

		/** CLOSING */
		in.close();
		out.close();
		try {
			toclose.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		/** */
	}


	private static int[] solve(boolean[] chiffre) {
		int[] divider = new int[9];
		Arrays.fill(divider, 0);

		for(int base=2; base<=10; base++){
			for(int d:div){
				if(isDivider(chiffre,base,d)){
					divider[base-2] = d;
					break;
				}
			}
			if(divider[base-2]==0){
				return null;
			}
		}
		return divider;
	}


	private static boolean increm(boolean[] chiffre) {
		
		int i=chiffre.length-1;

		do{
			i--;
			if(i==0){
				printErr("loop");
				return false;
			}
			chiffre[i] = !chiffre[i];
		}while(chiffre[i]==false);
		return true;
	}

	public static boolean isDivider(boolean[] chiffre, int base, int divider){
		int remaining = 0;
		for(int i=0; i<chiffre.length; i++)
			if(chiffre[i])
				remaining += remains(base,chiffre.length-i-1,divider);
		return (remaining%divider)==0;
	}

	public static int remains(int base, int power, int divider){
		if(power==0)
			return 1;
		int renvoi=1;
		while(power>1){
			while(base>=divider)
				base-=divider;
			if(base==1)
				break;

			if(power%2 == 0){
				base*=base;
				power/=2;
			}else{
				renvoi*=base;
				power--;
				
				base*=base;
				power/=2;
			}
		}
		return (renvoi*base) % divider;
	}

	public static void printErr(String s){
		System.out.println(s);
	}

}
