import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Locale;
import java.util.Scanner;
import java.util.TreeMap;

public class CodeJam16B {
	PrintWriter out;
	Scanner in;
	String testCase = "a10";

	public static void main(String[] args) throws Exception {
		new CodeJam16B().solve();
	}

	void solve() throws Exception {
		Locale.setDefault(Locale.ENGLISH);
		out = new PrintWriter(new FileOutputStream(testCase + ".out"));
		in = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(testCase + ".in"))));
		int T = in.nextInt();
		int j = 0;
		for (j = 1; j <= T; j++) {
			String s = in.next();
			int len = s.length();
			int[] arr = new int[len];
			for (int i = 0; i < len; i++) {
				arr[i] = (s.charAt(i) == '+' ? 1 : 0);
			}
			int count1 = 0;
			int count0 = 0;
			int[] ans = new int[len];
			ans[0] = (arr[0] == 1 ? 0 : 1);
			if (arr[0] == 0)
				count0++;
			if (arr[0] == 1)
				count1++;
			for (int i = 1; i < len; i++) {
				if (arr[i - 1] == 0 && arr[i] == 0) {
					count0++;
					ans[i] = ans[i - 1];
					continue;
				}
				if (arr[i - 1] == 1 && arr[i] == 1) {
					count1++;
					ans[i] = ans[i - 1];
					continue;
				}
				if (arr[i - 1] == 0 && arr[i] == 1) {
					if (count1 == 0) {
						count1++;
						ans[i] = ans[i - 1];
						continue;
					} else {
						ans[i] = ans[i - 1];
					}
				}
				if (arr[i - 1] == 1 && arr[i] == 0) {
					ans[i] = ans[i - 1] + 2;
					count0++;
				}
//				System.out.println(Arrays.toString(ans));
			}
			out.println("Case #" + j + ": " + ans[len - 1]);
		}
		out.close();
	}

	static int gcd(int n, int r) {
		return r == 0 ? n : gcd(r, n % r);
	}

	static long gcd(long n, long r) {
		return r == 0 ? n : gcd(r, n % r);
	}

	static class Reader {
		final private int BUFFER_SIZE = 1 << 16;
		private DataInputStream din;
		private byte[] buffer;
		private int bufferPointer, bytesRead;

		public Reader() {
			din = new DataInputStream(System.in);
			buffer = new byte[BUFFER_SIZE];
			bufferPointer = bytesRead = 0;
		}

		public Reader(String file_name) throws IOException {
			din = new DataInputStream(new FileInputStream(file_name));
			buffer = new byte[BUFFER_SIZE];
			bufferPointer = bytesRead = 0;
		}

		public final String readString() throws IOException {
			int c = read();
			while (isSpaceChar(c)) {
				c = read();
			}
			StringBuilder res = new StringBuilder();
			do {
				res.append((char) c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		private boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		public int nextInt() throws IOException {
			int ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = (c == '-');
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
			} while ((c = read()) >= '0' && c <= '9');
			if (neg)
				return -ret;
			return ret;
		}

		public long nextLong() throws IOException {
			long ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = (c == '-');
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
			} while ((c = read()) >= '0' && c <= '9');
			if (neg)
				return -ret;
			return ret;
		}

		public double nextDouble() throws IOException {
			double ret = 0, div = 1;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = (c == '-');
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
			} while ((c = read()) >= '0' && c <= '9');
			if (c == '.')
				while ((c = read()) >= '0' && c <= '9')
					ret += (c - '0') / (div *= 10);
			if (neg)
				return -ret;
			return ret;
		}

		public int[] readIntArray(int size) throws IOException {
			int[] arr = new int[size];
			for (int i = 0; i < size; i++)
				arr[i] = nextInt();
			return arr;
		}

		public long[] readLongArray(int size) throws IOException {
			long[] arr = new long[size];
			for (int i = 0; i < size; i++)
				arr[i] = nextInt();
			return arr;
		}

		private void fillBuffer() throws IOException {
			bytesRead = din.read(buffer, bufferPointer = 0, BUFFER_SIZE);
			if (bytesRead == -1)
				buffer[0] = -1;
		}

		private byte read() throws IOException {
			if (bufferPointer == bytesRead)
				fillBuffer();
			return buffer[bufferPointer++];
		}

		public void close() throws IOException {
			if (din == null)
				return;
			din.close();
		}
	}
}