package round2;

import java.util.*;

class A {

  static class Sindex implements Comparable<Sindex> {
    int index;
    String str;

    public Sindex(int i, String s) {
      index = i;
      str = (s==null?"Z":s);
    }

    @Override
    public int compareTo(Sindex o) {
      return str.compareTo(o.str);
    }
  }

  static int compete(int a, int b) {
    if (a < b) {
      return compete(b, a);
    }

    if (a == 2 && b == 0) return 2;
    else return b;
  }

  static int maxletter(int ps, int rs, int ss) {
    if (ps >= rs && ps >= ss) {
      return 0;
    } else if (rs >= ps && rs >= ss) {
      return 1;
    } else return 2;
  }

  static int maxstring(String ps, String rs, String ss) {
    if (ps.compareTo(rs) >= 0 && ps.compareTo(ss) >= 0) {
      return 0;
    } else if (rs.compareTo(ps) >= 0 && rs.compareTo(ss) >= 0) {
      return 1;
    } else return 2;
  }

  static void run(Scanner scanner, int testCase) {
    int N = scanner.nextInt();
    int R = scanner.nextInt();
    int P = scanner.nextInt();
    int S = scanner.nextInt();

//    System.out.println("get: " + N + " " + R + " " + P + " " + S);

    ArrayList<PriorityQueue<String> > pr = new ArrayList<PriorityQueue<String>>(3);
    pr.add(new PriorityQueue<String>());
    pr.add(new PriorityQueue<String>());
    pr.add(new PriorityQueue<String>());
    for (int i = 0; i < R; i++) {
      pr.get(1).add("R");
    }
    for (int i = 0; i < S; i++) {
      pr.get(2).add("S");
    }
    for (int i = 0; i < P; i++) {
      pr.get(0).add("P");
    }

    String re = null;
    int sizes[] = new int[3];
    int newsizes[] = new int[3];
    for (int i = 0; i < N; i++) {
      sizes[0] = pr.get(0).size();
      sizes[1] = pr.get(1).size();
      sizes[2] = pr.get(2).size();
      int mletter = maxletter(sizes[0], sizes[1], sizes[2]);

//      System.out.println("get: " + sizes[0] + " " + sizes[1] + " " + sizes[2] + " " + sizes[mletter]);

      int sum = sizes[0] + sizes[1] + sizes[2];
      if (sizes[mletter] * 2 > sum || (sizes[mletter] * 2 == sum && sizes[mletter] > 2)) {
        re = "IMPOSSIBLE";
        break;
      }

      int half = (sum - sizes[mletter] * 2) / 2;
      newsizes[mletter] = sizes[(mletter + 1) % 3] - half;
      newsizes[(mletter + 2) % 3 ] = sizes[(mletter + 2) % 3] - half;
      newsizes[(mletter + 1) % 3 ] = half;

      ArrayList<PriorityQueue<String> > npr = new ArrayList<PriorityQueue<String>>(3);
      npr.add(new PriorityQueue<String>());
      npr.add(new PriorityQueue<String>());
      npr.add(new PriorityQueue<String>());

      sizes[0] = newsizes[0];
      sizes[1] = newsizes[1];
      sizes[2] = newsizes[2];

      String mstr[] = new String[3];
      mstr[0] = pr.get(0).poll();
      mstr[1] = pr.get(1).poll();
      mstr[2] = pr.get(2).poll();

      Sindex[] indexes = new Sindex[3];
      while (mstr[0] != null || mstr[1] != null || mstr[2] != null) {
        indexes[0] = new Sindex(0, mstr[0]);
        indexes[1] = new Sindex(1, mstr[1]);
        indexes[2] = new Sindex(2, mstr[2]);

        Arrays.sort(indexes);
        int win1 = compete(indexes[0].index, indexes[1].index);
        int win2 = compete(indexes[0].index, indexes[2].index);
        int win3 = compete(indexes[1].index, indexes[2].index);
        if (newsizes[win1] > 0) {
          npr.get(win1).add(indexes[0].str + indexes[1].str);
          newsizes[win1] --;

          mstr[indexes[0].index] = pr.get(indexes[0].index).poll();
          mstr[indexes[1].index] = pr.get(indexes[1].index).poll();
        } else if (newsizes[win2] > 0) {
          npr.get(win2).add(indexes[0].str + indexes[2].str);
          newsizes[win2] --;

          mstr[indexes[0].index] = pr.get(indexes[0].index).poll();
          mstr[indexes[2].index] = pr.get(indexes[2].index).poll();
        } else {
          npr.get(win3).add(indexes[1].str + indexes[2].str);
          newsizes[win3] --;

          mstr[indexes[1].index] = pr.get(indexes[1].index).poll();
          mstr[indexes[2].index] = pr.get(indexes[2].index).poll();
        }
      }

      pr = npr;
    }

    if (re == null) {
      for (PriorityQueue<String> ppp: pr) {
        if (ppp.size() > 0) {
          re = ppp.peek();
          break;
        }
      }
    }


    System.out.printf("Case #%d: %s\n", testCase, re);
  }

  public static void main(String[] args) {
    Scanner scanner = new Scanner(System.in);

    int T = scanner.nextInt();
    scanner.nextLine();
    for (int t = 1; t <= T; t++) {
      run(scanner, t);
    }
  }
}