import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class Tictactoe {

	private static Scanner sc;
	private static String message;
	private static BufferedWriter output;

	public static void main(String args[]) {
		String filename = args[0];

		try {
			sc = new Scanner(new FileReader(new File(filename)));
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		

		try {
			File file = new File("output");
			output = new BufferedWriter(new FileWriter(file));
		} catch (IOException ex){
		  // report
		} 

		int T = sc.nextInt();
		int counter = 1;
		while (counter <= T) {
			boolean completed = true;
			boolean hasWinner = false;
			String[] hor = { "", "", "", "" };
			String[] ver = { "", "", "", "" };
			String[] dia = { "", "" };
			sc.nextLine();
			for (int i = 0; i <= 3; i++) {
				String line = sc.nextLine();
				hor[i] = line;
				for (int j = 0; j <= 3; j++) {
					char k = line.charAt(j);
					if (k == '.') {
						completed = false;
					}
					ver[j] += k;
					if (i == j) {
						dia[0] += k;
					}
					if ((i + j) == 3) {
						dia[1] += k;
					}
				}
			}

			String[] patterns = concatAll(hor, ver, dia);

			for (String s : patterns) {
				char winner = winner(s);
				if (winner != 'D') {
					message="Case #" + counter + ": " + winner
							+ " won";
					hasWinner = true;
					break;

				}
			}

			if (!hasWinner) {
				if (completed) {
					message="Case #" + counter + ": Draw";
				} else {
					message="Case #" + counter
							+ ": Game has not completed";

				}

			}
			try {
				output.write(message+"\n");
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}

			counter++;

		}
		try {
			output.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

	private static char winner(String p) {

		//System.out.println("p:"+p);
		if (p.contains("XX") && !p.contains("O")&&!p.contains(".")) {
			return 'X';
		} else if (p.contains("OO") && !p.contains("X")&&!p.contains(".")) {
			return 'O';
		}

		return 'D';
	}

	public static <T> T[] concatAll(T[] first, T[]... rest) {
		int totalLength = first.length;
		for (T[] array : rest) {
			totalLength += array.length;
		}
		T[] result = Arrays.copyOf(first, totalLength);
		int offset = first.length;
		for (T[] array : rest) {
			System.arraycopy(array, 0, result, offset, array.length);
			offset += array.length;
		}
		return result;
	}

}
