import java.util.*;
import java.io.*;

public class Water {

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		String fileName = "B-large.in";
		String out = "";
		
		try
		{
			BufferedReader br = new BufferedReader(new FileReader(fileName));
			String line = "";
			
			line = br.readLine();
			int T = Integer.parseInt(line);
			
			int caseNum = 1;
			for(int i = 0; i < T; i++)
			{
				line = br.readLine();
				String[] coord = line.split(" ");
				int H = Integer.parseInt(coord[0]);
				int W = Integer.parseInt(coord[1]);
				int[][] map = new int[H][W];
				
				for(int j = 0; j < H; j++)
				{
					line = br.readLine();
					String[] values = line.split(" ");
					
					for(int w = 0; w < W; w++)
					{
						map[j][w] = Integer.parseInt(values[w]);
					}
				}
				
				out = out + "Case #" + caseNum + ":\n" + solve(H,W,map);
				caseNum++;
			}
			
		}
		catch(Exception e)
		{
			System.out.println(e);
		}
		
		try
		{
			Writer output = null;
		    File file = new File("B-large.out");
		    output = new BufferedWriter(new FileWriter(file));
		    output.write(out);
		    output.close();
		    System.out.println("Your file has been written");
		}
		catch(Exception e)
		{
			System.out.println(e);
		}
	}
	
	public static String solve(int h, int w, int[][] map)
	{
		//north -1
		//west -2
		//east 2
		//south 1
		
		int H = h;
		int W = w;
        int[][] intMap = map;
        String[][] stringMap = new String[H][W];
        String[] letters = {"a", "b", "c", "d", "e", "f", "g", "h", "i", "j", "k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x", "y", "z"};
        int currentLetter = 1;
        String out = "";
        
        for(int i = 0; i < H; i++)
        {
        	for(int j = 0; j < W; j++)
        	{
        		stringMap[i][j] = "-1";
        	}
        }
        stringMap[0][0] = "a";
        
        //System.out.println(isSink(2,0,intMap));
        //System.out.println(isSink(0,2,intMap));
        
        if(!isSink(0,0,intMap))
        {
        	int[] ss = getSinkPosition(0,0,intMap);
        	stringMap[ss[0]][ss[1]] = "a";
        }

        for(int i = 0; i < H; i++)
        {
            for(int j = 0; j < W; j++)
            {
            	if(stringMap[i][j] == "-1" && isSink(i,j,intMap))
            	{
            		stringMap[i][j] = letters[currentLetter++];
            	}
            }
        }
        
        for(int i = 0; i < H; i++)
        {
            for(int j = 0; j < W; j++)
            {
            	if(stringMap[i][j] == "-1" )
            	{
            		stringMap[i][j] = getSinkLetter(i, j, intMap, stringMap);
            	}
            }
        }
        
        for(int i = 0; i < H; i++)
        {
        	for(int j = 0; j < W; j++)
        	{
        		out = out + stringMap[i][j] + " ";
        	}
        	
        	out = out.trim();
        	out = out + "\n";
        }
        
        return out;
        
	}
	
	public static int[] getSinkPosition(int i, int j, int[][] map)
	{
		int[] res = new int[2];
		
		if(isSink(i,j,map))
		{
			res[0] = i;
			res[1] = j;
			
			return res;
		}
			
		int direction = direction(i,j,map);	
		//north -1
		//west -2
		//east 2
		//south 1
		
		if(direction == -1)
		{
			res = getSinkPosition(i-1, j, map);
		}
		else if(direction == -2)
		{
			res = getSinkPosition(i, j-1, map);
		}
		else if(direction == 2)
		{
			res = getSinkPosition(i, j+1, map);
		}
		else if(direction == 1)
		{
			res = getSinkPosition(i+1, j, map);
		}
		
		return res;
	}
	
	public static String getSinkLetter(int i, int j, int[][] map, String[][] smap)
	{
		String res = "-1";

		if(isSink(i,j,map))
		{
			res = smap[i][j];
			return res;
		}
			
		int direction = direction(i,j,map);
		//north -1
		//west -2
		//east 2
		//south 1
		
		if(direction == -1)
		{
			res = getSinkLetter(i-1, j, map, smap);
		}
		else if(direction == -2)
		{
			res = getSinkLetter(i, j-1, map, smap);
		}
		else if(direction == 2)
		{
			res = getSinkLetter(i, j+1, map, smap);
		}
		else if(direction == 1)
		{
			res = getSinkLetter(i+1, j, map, smap);
		}
		
		return res;
	}
	
	public static int direction(int i, int j, int[][] map)
	{
		int north = -1;
		int west = -1;
		int east = -1;
		int south = -1;
		
		try
		{
			north = map[i-1][j];
		}
		catch(Exception e)
		{
			north = 222222;
		}
		
		try
		{
			west = map[i][j-1];
		}
		catch(Exception e)
		{
			west = 222222;
		}
		
		try
		{
			east = map[i][j+1];
		}
		catch(Exception e)
		{
			east = 222222;
		}
		
		try
		{
			south = map[i+1][j];
		}
		catch(Exception e)
		{
			south = 222222;
		}
		
		int min = Math.min(south,Math.min(east,Math.min(west, north)));
		
		if(north == min)
		{
			return -1;
		}
		else if(west == min)
		{
			return -2;
		}
		else if(east == min)
		{
			return 2;
		}
		else if(south == min)
		{
			return 1;
		}

		return 0;

	}
	
	public static boolean isSink(int i, int j, int[][] map)
	{
		int count = 0;
		int error = 0;
		
		try
		{
			if(map[i-1][j] >= map[i][j])
			{
				count++;
			}
		}
		catch(Exception e)
		{
			error++;
		}
		
		try
		{
			if(map[i][j-1] >= map[i][j])
			{
				count++;
			}
		}
		catch(Exception e)
		{
			error++;
		}
		
		try
		{
			if(map[i+1][j] >= map[i][j])
			{
				count++;
			}
		}
		catch(Exception e)
		{
			error++;
		}
		
		try
		{
			if(map[i][j+1] >= map[i][j])
			{
				count++;
			}
		}
		catch(Exception e)
		{
			error++;
		}
		
		if(count + error == 4)
		{
			return true;
		}
		else
		{
			return false;
		}
	}
}
