import java.util.Scanner;
import java.math.BigInteger;

public class CoinJam {
  public static void main(String[] args){
    Scanner in = new Scanner(System.in);
    int T = in.nextInt();
    for(int t=0; t<T; t++){
      System.out.printf("Case #%d:\n", t+1);
      int N = in.nextInt();
      int J = in.nextInt();

      BigInteger num = BigInteger.valueOf(2).pow(N-1).add(BigInteger.valueOf(1));
      while(J > 0){
        BigInteger[] proof = getProof(num);
        if(proof == null){
          num = num.add(BigInteger.valueOf(2));
          continue;
        }
        System.out.printf("%s", toBinary(num));
        for(int i=0; i<proof.length; i++){
          System.out.printf(" %d", proof[i]);
        }
        System.out.printf("\n");
        --J;
        num = num.add(BigInteger.valueOf(2));
      }
    }
  }

  //return int[] if true, else null
  public static BigInteger[] getProof(BigInteger n){
    BigInteger[] proof = new BigInteger[9];
    for(int i=2; i<=10; i++){
      BigInteger divisor = isPrime(inBase(n, BigInteger.valueOf(i)));
      if(divisor.compareTo(BigInteger.valueOf(0)) < 0){
        return null;
      }
      proof[i-2] = divisor;
    }
    return proof;
  }

  public static String toBinary(BigInteger n){
    String bin = "";
    while(n.compareTo(BigInteger.valueOf(0)) > 0){
      bin = n.mod(BigInteger.valueOf(2)).intValue() + bin;
      n = n.divide(BigInteger.valueOf(2));
    }
    return bin;
  }

  public static BigInteger inBase(BigInteger n, BigInteger base){
    BigInteger val = BigInteger.valueOf(0);
    int i = 0;
    while(n.compareTo(BigInteger.valueOf(0)) > 0){
      val = val.add(n.mod(BigInteger.valueOf(2)).multiply(base.pow(i)));
      ++i;
      n = n.divide(BigInteger.valueOf(2));
    }
    return val;
  }

  //return divisor if not, else -1
  public static BigInteger isPrime(BigInteger n){
    for(BigInteger i = BigInteger.valueOf(2); i.multiply(i).compareTo(n) <= 0; i=i.add(BigInteger.valueOf(1))){
      if(n.mod(i).equals(BigInteger.valueOf(0))){
        return i;
      }
    }
    return BigInteger.valueOf(-1);
  }
}
