package Main;

public class Lawn {
	
	private int N;
	
	private int M;
	
	private int lawn[][];
	
	public Lawn(int rowSize, int columnSize, int array[][]) {
		this.N = rowSize;
		this.M = columnSize;
		lawn = new int[N][M];
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < M; j++) {
				lawn[i][j] = array[i][j];
			}
		}
	}
	
	public void print() {
		for (int i = 0; i < N; i++) {
			String lawnString = "";
			for (int j = 0; j < M; j++) {
				lawnString = lawnString + "\t" + lawn[i][j];
			}
			System.out.println(lawnString);
		}
	}
	
	public boolean validateFeasibility() {
		
		for (int i = 0; i < N ; i++) {
			for (int j = 0; j < M; j++) {
				if (!checkHorizontalFeasibility(i,j) && !checkVerticalFeasibility(i, j)) return false;
			}
		}
		return true;
	}
	
	private boolean checkHorizontalFeasibility(int row, int column) {
		for (int i = 0; i < M; i++) {
			if (lawn[row][i] > lawn[row][column]) return false;
		}
		return true;
	}
	
	private boolean checkVerticalFeasibility(int row, int column) {
		for (int i = 0; i < N; i++) {
			if (lawn[i][column] > lawn[row][column]) return false;
		}
		return true;
	}

}
