package Main;

import java.io.IOException;

public class Main {
	private int matrix[][] = new int[4][4];
	
	public static final int X = 13;
	public static final int O = 17;
	public static final int T = 19;
	public static final int BLANK = 23;
	
	
	public void initializeMatrix(int array[][]) {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				matrix[i][j] = array[i][j];
			}
		}
	}
	
	public void printMatrix() {
		for (int i = 0; i < 4; i++) {
			String line = "";
			for (int j = 0; j < 4; j++) {
				line = line + " " + matrix[i][j];
			}
			System.out.println(line);
		}
	}
	public int evaluatePosition() throws IOException {
		int finalWinner = 0;
		int winner = 0;
		// Check corner cases
			// Diagonal Check
			winner = checkWinner(matrix[0][0], matrix[1][1], matrix[2][2], matrix[3][3]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			winner = checkWinner(matrix[0][3], matrix[1][2], matrix[2][1], matrix[3][0]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			
			// Horizontal Check
			winner = checkWinner(matrix[0][0], matrix[0][1], matrix[0][2], matrix[0][3]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			winner = checkWinner(matrix[3][0], matrix[3][1], matrix[3][2], matrix[3][3]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			
			// Vertical Check
			winner = checkWinner(matrix[0][0], matrix[1][0], matrix[2][0], matrix[3][0]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			winner = checkWinner(matrix[0][3], matrix[1][3], matrix[2][3], matrix[3][3]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			
		// Middle elements check	
			// Vertical Check
			winner = checkWinner(matrix[0][1], matrix[1][1], matrix[2][1], matrix[3][1]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			winner = checkWinner(matrix[0][2], matrix[1][2], matrix[2][2], matrix[3][2]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;

			// Horizontal Check
			winner = checkWinner(matrix[1][0], matrix[1][1], matrix[1][2], matrix[1][3]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
			winner = checkWinner(matrix[2][0], matrix[2][1], matrix[2][2], matrix[2][3]);
			if (winner != 0 && winner != -1) return winner;
			if (winner != 0) finalWinner = winner;
		return finalWinner;
	}
	
	private int checkWinner(int a, int b, int c, int d) {
		if (a == BLANK || b == BLANK || c == BLANK || d == BLANK) {
			return -1;
		}
		int xSum = ((a == T) ? X : a) + ((b == T) ? X : b) + ((c == T) ? X : c) + ((d == T) ? X : d);
		int oSum = ((a == T) ? O : a) + ((b == T) ? O : b) + ((c == T) ? O : c) + ((d == T) ? O : d);
		if (oSum == 4 * O) {
			return O;
		}
		if (xSum == 4 * X) {
			return X;
		}
		return 0;
	}
}
