package jam.first;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.net.URL;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class CandySplitting {

	public final static void main(String[] args) throws Exception {
		new CandySplitting();
	}

	private CandySplitting() throws Exception {
		// Reading
		URL inURL = this.getClass().getResource("./testcandy.in");
		if (inURL == null)
			throw new FileNotFoundException("input file not found");

		File in = new File(inURL.getPath());
		FileReader reader = new FileReader(in);
		BufferedReader buffreader = new BufferedReader(reader);

		File out = new File(inURL.getPath().replace(".in", ".out"));
		FileWriter writer = new FileWriter(out);
		BufferedWriter buffwriter = new BufferedWriter(writer);

		InputTokens inputtokens = new InputTokens();
		OutputTokens outputtokens = new OutputTokens();

		inputtokens.read(buffreader);
		// End Reading

		int testcases = inputtokens.getInt(0, 0);

		for (int i = 1; i < testcases * 2 + 1; i += 2) {
			// new testcase

			// initialization
			int numccandy = inputtokens.getInt(i, 0);
			ArrayList<Integer> candy = new ArrayList<Integer>(numccandy);

			for (int k = 0; k < numccandy; k++) {
				candy.add(inputtokens.getInt(i + 1, k));
			}

			// elaboration

			// check solvability
			String result;

			int maxsolution = 0;

			boolean done = false;

			// solving permutations, powerset implementation
			BitSet permutation = new BitSet(candy.size());
			int index = 0;

			while ((index = permutation.nextClearBit(0)) < candy.size()) {
				int patrickvalue1 = 0;
				int patrickvalue2 = 0;
				int seanvalue = 0;

				permutation.set(index);
				for (int l = 0; l < index; l++) {
					permutation.clear(l);
				}

				for (int l = 0; l < candy.size(); l++) {
					if (permutation.get(l)) {
						patrickvalue1 = patrickvalue1 ^ candy.get(l);
					} else {
						patrickvalue2 = patrickvalue2 ^ candy.get(l);
					}
				}

				if (patrickvalue1 == patrickvalue2 && patrickvalue1>0) {
					for (int l = 0; l < candy.size(); l++) {
						if (permutation.get(l)) {
							seanvalue = seanvalue + candy.get(l);
						}
					}
					if (seanvalue > maxsolution) {
						maxsolution = seanvalue;
					}
				}
			}
			if(maxsolution>0)result = String.valueOf(maxsolution);
			else result = "NO";

			// output
			int testcase = ((i - 1) / 2 + 1);
			outputtokens.set(testcase - 1, 0, "Case");
			outputtokens.set(testcase - 1, 1, "#" + testcase + ":");
			outputtokens.set(testcase - 1, 2, result);
		}

		// end testcase

		// Writing
		outputtokens.write(buffwriter);
		// End Writing
	}

	// Utility class for deserializing
	class InputTokens {

		ArrayList<String[]> rawtokens = new ArrayList<String[]>();

		void read(BufferedReader reader) throws Exception {
			String line;
			while ((line = reader.readLine()) != null) {
				rawtokens.add(line.split("\\s"));
			}
			reader.close();
		}

		Integer getInt(int row, int column) {
			String token = rawtokens.get(row)[column];
			return Integer.valueOf(token);
		}

		Character getChar(int row, int column) {
			String token = rawtokens.get(row)[column];
			if (token.length() > 1)
				throw new IllegalArgumentException("Not a char");
			return token.charAt(0);
		}

		String get(int row, int column) {
			String token = rawtokens.get(row)[column];
			return token;
		}

		Integer size() {
			int total = 0;
			for (String[] row : rawtokens) {
				for (String token : row) {
					total++;
				}
			}
			return total;
		}

		Integer size(int row) {
			int total = 0;
			if (row >= rawtokens.size())
				throw new IllegalArgumentException("Row out of range");
			for (String token : rawtokens.get(row)) {
				total++;
			}
			return total;
		}

	}

	// Utility class for serializing
	class OutputTokens {

		ArrayList<ArrayList<String>> rawtokens = new ArrayList<ArrayList<String>>();

		void write(BufferedWriter writer) throws Exception {
			for (ArrayList<String> row : rawtokens) {
				boolean first = true;
				for (String token : row) {
					if (first) {
						first = false;
					} else {
						writer.write(' ');
					}
					writer.write(token);
				}
				writer.write('\n');
			}
			writer.close();
		}

		void set(int row, int column, Object value) {
			while (rawtokens.size() <= row) {
				rawtokens.add(new ArrayList<String>());
			}

			if ((rawtokens.get(row).size() > column)
					&& (rawtokens.get(row).get(column) != null))
				throw new IllegalArgumentException("Element already set");

			rawtokens.get(row).add(column, value.toString());
		}

		Integer size() {
			int total = 0;
			for (ArrayList<String> row : rawtokens) {
				for (String token : row) {
					total++;
				}
			}
			return total;
		}

		Integer size(int row) {
			int total = 0;
			if (row >= rawtokens.size())
				throw new IllegalArgumentException("Row out of range");
			for (String token : rawtokens.get(row)) {
				total++;
			}
			return total;
		}

	}

}
