package jam.first.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.net.URL;
import java.util.ArrayList;


public class SingleLineTemplate {
	
	public final static void main(String[] args) throws Exception{
		new SingleLineTemplate();
	}
	
	private SingleLineTemplate()throws Exception{
		//Reading
		URL inURL = this.getClass().getResource("./testfirsta.in");
		if(inURL == null)throw new FileNotFoundException("input file not found");
		
		File in = new File(inURL.getPath());
		FileReader reader = new FileReader(in);
		BufferedReader buffreader = new BufferedReader(reader);

		File out = new File(inURL.getPath().replace(".in", ".out"));
		FileWriter writer = new FileWriter(out);
		BufferedWriter buffwriter = new BufferedWriter(writer);
		
		InputTokens inputtokens = new InputTokens();
		OutputTokens outputtokens = new OutputTokens();
		
		inputtokens.read(buffreader);
		//End Reading
		
		
		int testcases = inputtokens.getInt(0, 0);
		
		for(int i = 1; i<testcases+1; i++ ){
			
			// new testcase
			int n = inputtokens.getInt(i, 0);
			int pd = inputtokens.getInt(i, 1);
			int pg = inputtokens.getInt(i, 2);
			
			int d = 1;
			int g = 1;
			
			boolean valid = false;
			

			System.err.println(n+" "+pd+" "+pg);
			
			for(d = 1;d<=n;d++){
				valid = false;
				
				double dfull = ((double)d/100*pd);
				
				
				if(Math.floor(dfull) == dfull){
					g = d;
					double gfull = ((double)g/100*pg);
					while(g<1000000){
						//System.err.println(g+" "+gfull);
						if((Math.floor(gfull) == gfull)){
							if(gfull>=dfull && g>=d && (g-gfull)>=(d-dfull)){
								valid = true;
								break;								
							}							
						}
						g++;
						gfull = ((double)g/100*pg);		
					}
				}
				
				if(valid)break;
			}
			
			System.err.println(g+" "+d);
			
			
			
			// end testcase
			
			// output
			outputtokens.set(i-1, 0, "Case");
			outputtokens.set(i-1, 1, "#"+i+":");
			
			
			if(valid){
				outputtokens.set(i-1, 2,"Possible");
			}
			else{
				outputtokens.set(i-1, 2,"Broken");
			}
				
		}		
		
		//Writing
		outputtokens.write(buffwriter);
		//End Writing
	}
	
	//Utility class for deserializing
	class InputTokens {
		
		ArrayList<String[]> rawtokens = new ArrayList<String[]>();
		
		void read(BufferedReader reader) throws Exception{
			String line;
			while((line=reader.readLine())!=null){
				rawtokens.add(line.split("\\s"));
			}		
			reader.close();
		}
		
		Integer getInt(int row,int column){
			String token = rawtokens.get(row)[column];
			return Integer.valueOf(token);
		}
		
		Character getChar(int row,int column){
			String token = rawtokens.get(row)[column];
			if(token.length()>1)throw new IllegalArgumentException("Not a char");
			return token.charAt(0);
		}
		
		String get(int row,int column){
			String token = rawtokens.get(row)[column];
			return token;
		}
		
		Integer size(){
			int total = 0;
			for(String[] row : rawtokens){
				for(String token : row){
					total++;
				}
			}
			return total;
		}
		
		Integer size(int row){
			int total = 0;
			if(row>=rawtokens.size())throw new IllegalArgumentException("Row out of range");
			for(String token : rawtokens.get(row)){
				total++;
			}
			return total;
		}
		
	}
	

	//Utility class for serializing
	class OutputTokens {
		
		ArrayList<ArrayList<String>> rawtokens = new ArrayList<ArrayList<String>>();
		
		void write(BufferedWriter writer) throws Exception{	
			for(ArrayList<String> row : rawtokens){
				boolean first = true;
				for(String token : row){
					if(first){
						first = false;
					}
					else{
						writer.write(' ');
					}
					writer.write(token);
				}
				writer.write('\n');
			}
			writer.close();
		}
		
		void set(int row,int column,Object value){
			while(rawtokens.size()<=row){
				rawtokens.add(new ArrayList<String>());
			}
			
			if((rawtokens.get(row).size()>column)&&(rawtokens.get(row).get(column)!=null))
				throw new IllegalArgumentException("Element already set");
			
			rawtokens.get(row).add(column,value.toString());
		}
		
		Integer size(){
			int total = 0;
			for(ArrayList<String> row : rawtokens){
				for(String token : row){
					total++;
				}
			}
			return total;
		}
		
		Integer size(int row){
			int total = 0;
			if(row>=rawtokens.size())throw new IllegalArgumentException("Row out of range");
			for(String token : rawtokens.get(row)){
				total++;
			}
			return total;
		}
		
	}

}
