package jam.first;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.net.URL;
import java.util.ArrayList;


public class Magicka {
	
	public final static void main(String[] args) throws Exception{
		new Magicka();
	}
	
	private Magicka()throws Exception{
		//Reading
		URL inURL = this.getClass().getResource("./testmagicka.in");
		if(inURL == null)throw new FileNotFoundException("input file not found");
		
		File in = new File(inURL.getPath());
		FileReader reader = new FileReader(in);
		BufferedReader buffreader = new BufferedReader(reader);

		File out = new File(inURL.getPath().replace(".in", ".out"));
		FileWriter writer = new FileWriter(out);
		BufferedWriter buffwriter = new BufferedWriter(writer);
		
		InputTokens inputtokens = new InputTokens();
		OutputTokens outputtokens = new OutputTokens();
		
		inputtokens.read(buffreader);
		//End Reading
		
		
		int testcases = inputtokens.getInt(0, 0);
		
		for(int i = 1; i<testcases+1; i++ ){
			// new testcase
			int combining;
			Combinations combinations = null;
			int opposing;
			Oppositions oppositions = null;
			int length;
			char[] sequence;
			ArrayList<Character> result = new ArrayList<Character>();
			
			//Initialization
			combining = inputtokens.getInt(i, 0);
			if(combining>0){
				combinations = new Combinations();
				combinations.parse(inputtokens.get(i, 1));	
				
				opposing = inputtokens.getInt(i, 2);
				if(opposing>0){
					oppositions = new Oppositions();
					oppositions.parse(inputtokens.get(i, 3));
					
					length = inputtokens.getInt(i, 4);
					sequence = inputtokens.get(i, 5).toCharArray();
				}
				else {

					length = inputtokens.getInt(i, 3);
					sequence = inputtokens.get(i, 4).toCharArray();
				}
				
			}
			else {
				
				opposing = inputtokens.getInt(i, 1);
				if(opposing>0){
					oppositions = new Oppositions();
					oppositions.parse(inputtokens.get(i, 2));
					
					length = inputtokens.getInt(i, 3);
					sequence = inputtokens.get(i, 4).toCharArray();
				}
				else{
					length = inputtokens.getInt(i, 2);
					sequence = inputtokens.get(i, 3).toCharArray();
				}
			}
			
			if(sequence.length!=length)
				throw new IllegalArgumentException("Invalid sequence length");
			
			//Elaboration
			for(char element : sequence){
				result.add(element);
				if(combinations!=null)
					combinations.check(result);
				if(oppositions!=null)
					oppositions.check(result);
			}
			

			String finalsequence = new String("[");
			for(int z=0;z<result.size();z++){
				finalsequence+=result.get(z);
				if(z<result.size()-1)finalsequence+=", ";
			}
			finalsequence+="]";
			
			// end testcase
			
			// output
			outputtokens.set(i-1, 0, "Case");
			outputtokens.set(i-1, 1, "#"+i+":");
			outputtokens.set(i-1, 2, finalsequence);
		}		
		
		//Writing
		outputtokens.write(buffwriter);
		//End Writing
	}
	
	//Combining class
	class Combinations{
		ArrayList<Character> bra;
		ArrayList<Character> ket;
		ArrayList<Character> result;
		
		void parse(String sequence){
			bra = new ArrayList<Character>();
			ket = new ArrayList<Character>();
			result = new ArrayList<Character>();
			
			char[] sequencechars = sequence.toCharArray();
			
			for(int i=0;i<sequencechars.length;i+=3){
				bra.add(sequencechars[i]);
				ket.add(sequencechars[i+1]);
				result.add(sequencechars[i+2]);
			}
		}
		
		void check(ArrayList<Character> sequence){
			if(sequence.size()<2)return;
			
			Character last = sequence.get(sequence.size()-1);
			Character secondlast = sequence.get(sequence.size()-2);
			
			for(int i=0;i<result.size();i++){
				if(last.equals(bra.get(i))&&secondlast.equals(ket.get(i))
					||secondlast.equals(bra.get(i))&&last.equals(ket.get(i))){
					sequence.remove(sequence.size()-1);
					sequence.remove(sequence.size()-1);
					sequence.add(result.get(i));
				}
					
			}
		}
		
	}
	
	//Opposing class
	class Oppositions{
		ArrayList<Character> bra;
		ArrayList<Character> ket;
		
		void parse(String sequence){
			bra = new ArrayList<Character>();
			ket = new ArrayList<Character>();
			
			char[] sequencechars = sequence.toCharArray();
			
			for(int i=0;i<sequencechars.length;i+=2){
				bra.add(sequencechars[i]);
				ket.add(sequencechars[i+1]);
			}
		}
		
		void check(ArrayList<Character> sequence){
			if(sequence.size()<2)return;
			
			Character last = sequence.get(sequence.size()-1);
			
			for(int i=sequence.size()-2;i>=0;i--){
				for(int k=0;k<bra.size();k++){
					Character first = bra.get(k);
					Character second = ket.get(k);
					
					if((sequence.get(i).equals(first)&&last.equals(second))
						||(sequence.get(i).equals(second)&&last.equals(first))){
						sequence.clear();
						/*while(sequence.size()>i){
							sequence.remove(sequence.size()-1);
						}*/
						return;
					}
					
				}
			}
			
		}
	}
	
	//Utility class for deserializing
	class InputTokens {
		
		ArrayList<String[]> rawtokens = new ArrayList<String[]>();
		
		void read(BufferedReader reader) throws Exception{
			String line;
			while((line=reader.readLine())!=null){
				rawtokens.add(line.split("\\s"));
			}		
			reader.close();
		}
		
		Integer getInt(int row,int column){
			String token = rawtokens.get(row)[column];
			return Integer.valueOf(token);
		}
		
		Character getChar(int row,int column){
			String token = rawtokens.get(row)[column];
			if(token.length()>1)throw new IllegalArgumentException("Not a char");
			return token.charAt(0);
		}
		
		String get(int row,int column){
			String token = rawtokens.get(row)[column];
			return token;
		}
		
		Integer size(){
			int total = 0;
			for(String[] row : rawtokens){
				for(String token : row){
					total++;
				}
			}
			return total;
		}
		
		Integer size(int row){
			int total = 0;
			if(row>=rawtokens.size())throw new IllegalArgumentException("Row out of range");
			for(String token : rawtokens.get(row)){
				total++;
			}
			return total;
		}
		
	}
	

	//Utility class for serializing
	class OutputTokens {
		
		ArrayList<ArrayList<String>> rawtokens = new ArrayList<ArrayList<String>>();
		
		void write(BufferedWriter writer) throws Exception{	
			for(ArrayList<String> row : rawtokens){
				boolean first = true;
				for(String token : row){
					if(first){
						first = false;
					}
					else{
						writer.write(' ');
					}
					writer.write(token);
				}
				writer.write('\n');
			}
			writer.close();
		}
		
		void set(int row,int column,Object value){
			while(rawtokens.size()<=row){
				rawtokens.add(new ArrayList<String>());
			}
			
			if((rawtokens.get(row).size()>column)&&(rawtokens.get(row).get(column)!=null))
				throw new IllegalArgumentException("Element already set");
			
			rawtokens.get(row).add(column,value.toString());
		}
		
		Integer size(){
			int total = 0;
			for(ArrayList<String> row : rawtokens){
				for(String token : row){
					total++;
				}
			}
			return total;
		}
		
		Integer size(int row){
			int total = 0;
			if(row>=rawtokens.size())throw new IllegalArgumentException("Row out of range");
			for(String token : rawtokens.get(row)){
				total++;
			}
			return total;
		}
		
	}

}
