/**
 * 
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;

/**
 * @author Carlos
 *
 */

class Solver {

	private StringBuffer pancakesStack;

	public Solver(BufferedReader bReader) {
		try {
			this.pancakesStack = new StringBuffer(bReader.readLine());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private int solve(String expected,  int lastIndex) {
		
		String otherC = "+".equals(expected) ? "-" : "+";
		
		int last = this.pancakesStack.lastIndexOf(otherC, lastIndex);
		
		int sol1 = 0;
		

		if (last >= 0) {
			
			if (last > 0) {
				
				if (this.pancakesStack.charAt(0) == otherC.charAt(0) )
				{
					flipStack(last);				
					sol1 = solve(expected,last)+1;
					
				} else {
					sol1 = solve(otherC,last-1)+1;
					flipStack(last);
				}
				
			} else {
				flipStack(last);	
				sol1 = 1;
			}
			

			

	
		}

		return sol1;
	}


	private void flipStack(int last) {
		
		
		for (int i = last, j=0; i >= j; i--,j++) {
			String char1 = (this.pancakesStack.charAt(i)=='+')?"-" :"+";
			String char2 = (this.pancakesStack.charAt(j)=='+')?"-":"+";	
			
			this.pancakesStack.replace(i, i+1, char2);
			this.pancakesStack.replace(j, j+1, char1);
		
		}
		
		
			
	}
	


	public String getAnswer() {

		if (this.pancakesStack.length() == 0) {
			return "0";
		}
		
		int sol1 = this.solve("+", this.pancakesStack.length()-1);

		return String.valueOf(sol1);
	}

}

public class Main {

	private File inputFile;
	private File outputFile;

	public Main(String filename) {
		this.inputFile = new File(filename);

		int lastIndex = filename.lastIndexOf('.');

		this.outputFile = new File(filename.substring(0, lastIndex) + ".out");
	}

	private void run() {
		FileReader reader = null;
		BufferedReader bReader = null;
		FileWriter writer = null;
		try {
			writer = new FileWriter(outputFile);
			reader = new FileReader(inputFile);
			bReader = new BufferedReader(reader);
			String line;
			if ((line = bReader.readLine()) != null) {

				int resting = Integer.parseInt(line);

				for (int index = 1; index <= resting; index++) {
					Solver solver = new Solver(bReader);
					String outStr = String.format("Case #%d: %s\r\n", index, solver.getAnswer());
					writer.write(outStr);
					System.out.print(outStr);
				}

			}

		} catch (Exception ex) {
			ex.printStackTrace();
		} finally {

			if (writer != null) {
				try {
					writer.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}

			safeCloseReader(bReader);
			safeCloseReader(reader);
		}

	}

	private void safeCloseReader(Reader reader) {
		if (reader != null) {
			try {
				reader.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}

	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		Main main = new Main(args[0]);

		main.run();
	}

}
