import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Reader;
import java.util.LinkedList;
import java.util.List;

/**
 * 
 */

/**
 * @author Carlos
 *
 */
class Solver {
	
	private List<Character> availableInt;
	private Long myNumber;

	public Solver(BufferedReader bReader) {
		
		this.availableInt = new LinkedList<Character>();
		for (char i='0'; i <= '9'; i++) {
			this.availableInt.add(i);
		}
		
		try {
			this.myNumber = Long.parseUnsignedLong(bReader.readLine() );
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	public String getAnswer() {

		if (this.myNumber == 0) {
			return "INSOMNIA";
		}
		
		Long iter =(long) 0;
		
		String result = String.valueOf(this.myNumber);
		
				
			while (canNotSleep(result)) {							
				result = String.valueOf((++iter*this.myNumber));				
			}			
		
		
		return result;
	}

	private boolean canNotSleep(String digits) {
		for (int i = 0; i<digits.length();i++){
			char c = digits.charAt(i);
			int index = this.availableInt.indexOf(c);
			if (index >=0) {
				this.availableInt.remove(index);
				if (this.availableInt.size()==0)
				{
					return false;
				}
			}
			
		}
		return true;
	}

}


public class Main {

	private File inputFile;
    private File outputFile;
    public Main(String filename) {
        this.inputFile = new File(filename);

        int lastIndex = filename.lastIndexOf('.');

        this.outputFile = new File (filename.substring(0, lastIndex)+".out");
    }

    private void run() {
        FileReader reader = null;
        BufferedReader bReader = null;
        FileWriter writer = null;
        try
        {
            writer = new FileWriter(outputFile);
            reader = new FileReader(inputFile);
            bReader = new BufferedReader(reader);
            String line;
            if (( line = bReader.readLine())!=null) {


                int resting = Integer.parseInt(line);

                for (int index = 1;  index <= resting; index++ ) {
                    Solver solver = new Solver(bReader);
                    String outStr = String.format("Case #%d: %s\r\n", index,solver.getAnswer());
                    writer.write(outStr);
                    System.out.print(outStr);
                }


            }

        } catch (Exception ex){
            ex.printStackTrace();
        } finally {

            if (writer != null){
                try {
                    writer.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            safeCloseReader(bReader);
            safeCloseReader(reader);
        }

    }


    private void safeCloseReader( Reader reader) {
        if (reader != null){
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

    }
    /**
     * @param args
     */
    public static void main(String[] args) {

        Main main = new Main(args[0]);
        main.run();
    }

}
