import java.io.*;

/**
 * Created by Carlos Alberto
 */

import java.io.BufferedReader;
import java.io.IOException;
import java.math.BigInteger;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.text.NumberFormat;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by Carlos Alberto on 11/04/2015.
 */


class Solver {

    private int maxShyness;

    private List<Integer> audience;

    public Solver(BufferedReader bReader) throws IOException {

        String[] tokens = bReader.readLine().split(" ");

        this.audience = new LinkedList<Integer>();

        this.maxShyness = Integer.parseInt(tokens[0]);

        for (int idx =0; idx <= this.maxShyness; idx++) {
            Character digit = tokens[1].charAt(idx);
            this.audience.add(Integer.parseInt(digit.toString()));
        }
    }

    public String getAnswer() {

        if (this.maxShyness==0)
        {
            return "0";
        }

        int missing =0;

        int accumulative = 0;

        for (int idx =1;idx <= this.maxShyness; idx++)
        {
            int previous = this.audience.get(idx-1);
            int difference = ( (idx) - ( previous + accumulative ));

            accumulative += previous;
            if (difference > 0){
                missing+=difference;
                accumulative += difference;
             }


        }


        return String.valueOf( missing );
    }

 }


public class Main {

    private File inputFile;
    private File outputFile;
    public Main(String filename) {
        this.inputFile = new File(filename);

        int lastIndex = filename.lastIndexOf('.');

        this.outputFile = new File (filename.substring(0, lastIndex)+".out");
    }

    private void run() {
        FileReader reader = null;
        BufferedReader bReader = null;
        FileWriter writer = null;
        try
        {
            writer = new FileWriter(outputFile);
            reader = new FileReader(inputFile);
            bReader = new BufferedReader(reader);
            String line;
            if (( line = bReader.readLine())!=null) {


                int resting = Integer.parseInt(line);

                for (int index = 1;  index <= resting; index++ ) {
                    Solver solver = new Solver(bReader);
                    String outStr = String.format("Case #%d: %s\r\n", index,solver.getAnswer());
                    writer.write(outStr);
                    System.out.print(outStr);
                }


            }

        } catch (Exception ex){
            ex.printStackTrace();
        } finally {

            if (writer != null){
                try {
                    writer.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            safeCloseReader(bReader);
            safeCloseReader(reader);
        }

    }


    private void safeCloseReader( Reader reader) {
        if (reader != null){
            try {
                reader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }

    }
    /**
     * @param args
     */
    public static void main(String[] args) {

        Main main = new Main(args[0]);
        main.run();
    }
}
