package com.laperradaonline.codejam.fairandsquares;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;

public class Main {

	private File inputFile;
	private File outputFile;
	
	public Main(String filename) {
		this.inputFile = new File(filename);
		
		int lastIndex = filename.lastIndexOf('.');        
        
        this.outputFile = new File (filename.substring(0, lastIndex)+".out");
	}
	
	public Main() {

	}

	private void generatePalindromeFile(){
		File palindromesFile = new File ("palindromes.db");
		FileWriter writer = null;
		
		PalindromeLord lord = new PalindromeLord();
		try
		{
			writer = new FileWriter(palindromesFile);
			
			BigDecimal iter = BigDecimal.ZERO;
			BigDecimal max = new BigDecimal("1000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000000");
			
			while (iter.compareTo(max) <= 0) {
				iter = lord.buildNextFairyPalindrome2(iter);
				writer.write(iter.toString());
				writer.write("\10");
				System.out.println(iter.toString());
				iter = iter.add(BigDecimal.ONE);
			}
			
		} catch (Exception ex){
			ex.printStackTrace();
		} finally {
			
			if (writer != null){
				try {
					writer.close();
				} catch (IOException e) {				
					e.printStackTrace();
				}
			}
			}
	}
	
	private void run() {
		FileReader reader = null;
		BufferedReader bReader = null;
		FileWriter writer = null;
		try
		{
			writer = new FileWriter(outputFile);
			reader = new FileReader(inputFile);
			bReader = new BufferedReader(reader);
			String line;
			if (( line = bReader.readLine())!=null) {
				
				
				int resting = Integer.parseInt(line);
				
				for (int index = 1;  index <= resting; index++ ) {
					line = bReader.readLine();
					String[] interval = line.split("\\s");
					
					FairAndSquareCounter counter = new FairAndSquareCounter(new BigDecimal(interval[0]), new BigDecimal(interval[1]));	
					
					String outStr = String.format("Case #%d: %s\r\n", index,counter.count());
					writer.write(outStr);
					System.out.print(outStr);
				}
				
				
			}
			
		} catch (Exception ex){
			ex.printStackTrace();
		} finally {
			
			if (writer != null){
				try {
					writer.close();
				} catch (IOException e) {				
					e.printStackTrace();
				}
			}
			
			safeCloseReader(bReader);
			safeCloseReader(reader);
		}
		
	}


		private void safeCloseReader( java.io.Reader reader) {
			if (reader != null){
				try {
					reader.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			
		}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		
		if (args.length >= 1){
			Main main = new Main(args[0]);
			main.run();
		} else {
			Main main = new Main();
			main.generatePalindromeFile();
		}
	}
	
}

