package com.laperradaonline.codejam.fairandsquares;

import java.math.BigDecimal;

public class PalindromeLord {

	public BigDecimal squareRoot(BigDecimal candidate) {
		double candRoot = Math.sqrt(candidate.doubleValue());
		double module = candRoot % 1;
		if (module == 0) {
			return new BigDecimal(candRoot);
		}
		return BigDecimal.ZERO;
	}

	public boolean isFairAndSquare(BigDecimal candidate) {
		if (!isPalindrome(candidate)) {
			return false;
		}

		BigDecimal squareRoot = this.squareRoot(candidate);

		if (BigDecimal.ZERO.compareTo(squareRoot) == 0) {
			return false;
		}

		return isPalindrome(squareRoot);
	}

	public boolean isPalindrome(BigDecimal candidate) {
		String candidateStr = candidate.toString();
		int i = 0;
		int j = candidateStr.length() - 1;

		while (i < j) {
			if (candidateStr.charAt(i) != candidateStr.charAt(j)) {
				return false;
			}

			i++;
			j--;
		}

		return true;
	}

	private static BigDecimal FOUR = new BigDecimal(4);

	public BigDecimal buildNextFairyPalindrome2(BigDecimal iter) {

		if (iter.doubleValue() <= 1) {
			return BigDecimal.ONE;
		}

		if (iter.doubleValue() <= FOUR.doubleValue()) {
			return FOUR;
		}

		if (iter.doubleValue() <= 9) {
			return new BigDecimal(9);
		}

		int power = (int) Math.floor(Math.log10(iter.doubleValue()));

		if (power % 2 == 1) {
			power++;
			return calculateMinLimit(power);
		}

		int midPower = (int) Math.floor(power / 2);
		
		
		
		BigDecimal minLimit = calculateMinLimit(power);
		
		BigDecimal candidate = minLimit;
		String nextSquareMin = new BigDecimal( Math.floor(Math.sqrt (iter.doubleValue())) ).toString();
		while (this.isPalindrome(candidate))
		{
			
			if (iter.compareTo(candidate) <= 0) {
				return candidate;
			}
			
			nextSquareMin = nextPosibleRoot(nextSquareMin);
			if (nextSquareMin == null){
				break;
			}
			candidate = new BigDecimal(nextSquareMin);
			candidate = candidate.multiply(candidate);
		}
		
		

		

		BigDecimal maxLimit1 = minLimit.multiply(FOUR);

		if ((midPower % 2 == 0)) {
			double midMidPower = (midPower / 2);
			BigDecimal maxLimit2 = new BigDecimal(4 + 4
					* Math.pow(10, midMidPower) + 9 * Math.pow(10, midPower) + 4
					* Math.pow(10, midMidPower + midPower) + 4
					* Math.pow(10, power));
			int comparison = iter.compareTo(maxLimit2);

			if (comparison > 0) {
				return calculateMinLimit(power + 2);
			}

			if (comparison <= 0 && iter.compareTo(maxLimit1) > 0) {
				return maxLimit2;
			}

		}

		int comparison = iter.compareTo(maxLimit1);
		if (comparison > 0) {
			return calculateMinLimit(power + 2);
		}
	
			return maxLimit1;
		
	}

	private String nextPosibleRoot(String nextSquareMin) {
		if ("11" .equals(nextSquareMin)){
			return null;
		}
		StringBuilder buffer = new StringBuilder(nextSquareMin);
		int length = nextSquareMin.length();
		
		int middle = (int)Math.floor((length/2)) ;
		
		char maxDigitS;
		int offsety;
		boolean doubleR;
		if (length % 2 == 1){
			offsety = 1;
			maxDigitS = '2';
			doubleR = false;
	    } else {
	    	doubleR = true;
	    	offsety = 2;
	    	maxDigitS = '1';
	    }
		
		char digit = buffer.charAt(middle);
		
		if (digit == maxDigitS){

			
			buffer.setCharAt(middle, '0');
				if (doubleR){
					buffer.setCharAt(middle-1, '0');
				}
				int x = middle +1;
				int y = middle -offsety;
				boolean changed = false;
				for (;x < length -1 ; x++,y--){
					if (buffer.charAt(x)=='0'){
						buffer.setCharAt(x,'1');
						buffer.setCharAt(y,'1');
						changed = true;
						break;
					}
				}
				
				if (!changed) {return null;}
			} else {
				
				char newDigit =String.valueOf( Integer.parseInt(Character.toString(digit)) +1).charAt(0);
				buffer.setCharAt(middle, newDigit);
				if (doubleR){
					buffer.setCharAt(middle-1, newDigit);
			
				}
			}
		

		return buffer.toString();
	}

	private BigDecimal calculateMinLimit(int power) {
		return new BigDecimal(Math.pow(10, power) + 2
				* Math.pow(10, (power / 2)) + 1);
	}

	public BigDecimal buildNextPalindrome(BigDecimal iter) {

		BigDecimal result = null;

		while (result == null) {

			StringBuilder str = new StringBuilder(iter.toString());
			int mid = (int) Math.floor(str.length() / 2);
			int length = str.length();
			int top = length - 1;
			boolean changed = false;
			if (iter.doubleValue() < 99) {
				str.setCharAt(0, str.charAt(1));
				changed = true;
			} else {
				for (int i = 0; i < mid; i++, top--) {
					char c = str.charAt(i);
					changed = changed || str.charAt(top) != c;
					str.setCharAt(top, c);
				}
			}

			if (!changed) {
				int digit = Integer
						.parseInt(Character.toString(str.charAt(mid))) + 1;
				if (digit < 10) {
					char theChar = Integer.toString(digit).charAt(0);
					str.setCharAt(mid, theChar);

					if (length % 2 == 0) {
						str.setCharAt(mid - 1, theChar);
					}
				} else {
					int power = Math.max(top, 0);
					str = new StringBuilder(iter.add(
							new BigDecimal(Math.pow(10, power))).toString());

				}
			}

			result = new BigDecimal(str.toString());

		}
		return result;
	}

}
