/**
 * 
 */
package com.laperradaonline.codejam.lawnmower;

import java.io.BufferedReader;
import java.io.IOException;

/**
 * @author Carlos Alberto
 *
 */
public class WishedPattern {

	private BufferedReader reader;
	private int n;
	private int m;
	private int[][] matrix;
	
	

	public WishedPattern(BufferedReader bReader) throws IOException {
		this.reader = bReader;
		this.initialize();
	}

	private void initialize() throws IOException {
		String line = this.reader.readLine();
		String[] dimensions = line.split("\\s");
		this.n = Integer.parseInt(dimensions[0]);
		this.m = Integer.parseInt(dimensions[1]);
		
		this.matrix = new int[this.n+1][this.m+1];
		
		for (int i =0; i < this.n; i++){
			line = this.reader.readLine();
			dimensions = line.split("\\s");
			for (int j=0; j < this.m; j++){
				int c = Integer.parseInt(dimensions[j]);
				this.matrix[i][j]= c;				
				this.matrix[i][this.m] = Math.max(this.matrix[i][this.m], c);
				this.matrix[this.n][j] = Math.max(this.matrix[this.n][j], c);
			}
		}		
	}

	public String isPossible() {
		
		for (int i =0; i < this.n; i++){

			for (int j=0; j < this.m; j++){
				int c = this.matrix[i][j];
				if (c < this.matrix[i][this.m] && c < this.matrix[this.n][j] ){
					return "NO";
				}
			}
		}
		
		return "YES";
	}

}
