/**
 * 
 */
package com.laperradaonline.codejam.manageenergy;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 * @author Carlos Alberto
 *
 */
public class Main {

	private File inputFile;
	private File outputFile;
	public Main(String filename) {
		this.inputFile = new File(filename);
		
		int lastIndex = filename.lastIndexOf('.');        
        
        this.outputFile = new File (filename.substring(0, lastIndex)+".out");
	}
	
	private void run() {
		FileReader reader = null;
		BufferedReader bReader = null;
		FileWriter writer = null;
		try
		{
			writer = new FileWriter(outputFile);
			reader = new FileReader(inputFile);
			bReader = new BufferedReader(reader);
			String line;
			if (( line = bReader.readLine())!=null) {
				
				
				int resting = Integer.parseInt(line);
				
				for (int index = 1;  index <= resting; index++ ) {
					String tok[] = bReader.readLine().split("\\s+");
					Solver solve = new Solver(Long.parseLong(tok[0]),Long.parseLong(tok[1]));	
						
					
					solve.addActivity(bReader.readLine().split("\\s+"));
					
					
					String outStr = String.format("Case #%d: %s\r\n", index,solve.calculate());
					writer.write(outStr);
					System.out.print(outStr);
				}
				
				
			}
			
		} catch (Exception ex){
			ex.printStackTrace();
		} finally {
			
			if (writer != null){
				try {
					writer.close();
				} catch (IOException e) {				
					e.printStackTrace();
				}
			}
			
			safeCloseReader(bReader);
			safeCloseReader(reader);
		}
		
	}


		private void safeCloseReader( java.io.Reader reader) {
			if (reader != null){
				try {
					reader.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			
		}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		
		Main main = new Main(args[0]);
		main.run();
	}
}
