import java.io.BufferedReader;
import java.io.IOException;

/*
 * Created on Jul 5, 2008
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

/**
 * @author amin
 *
 * TODO To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Style - Code Templates
 */

public class tools {

	public static int ReadInt(BufferedReader br) throws IOException {
		
		char ch1 = (char)br.read();
		StringBuffer sb = new StringBuffer("");
		
		while (!Character.isDigit(ch1)) {
			ch1 = (char)br.read();
		}
		
		while (Character.isDigit(ch1)) {
			sb.append(ch1);
			ch1 = (char)br.read();
		}
		
		return Integer.parseInt(sb.toString());
	}
	
	public static int[] ReadLineOfInt(BufferedReader br) throws IOException {
				
		String temps[] = br.readLine().split(" ");		
		int results[] = new int[temps.length];		
		for(int co1=0;co1<temps.length;co1++)
			results[co1] = Integer.parseInt(temps[co1]);
		
		return results;
	}
	
	public static double dist(int x1, int y1, int x2, int y2) {
		int temp1 = x1 - x2;
		int temp2 = y1 - y2;
		return Math.sqrt(temp1*temp1 + temp2*temp2);
	}
	
	static private char fmt = 'f'; // one of cdeEfgGiosxXos
	
	public static String fixed_format(double d, int precision) {
		boolean removeTrailing = (fmt == 'G' || fmt == 'g');
		// remove trailing zeroes and decimal point
		
		if (d > 0x7FFFFFFFFFFFFFFFL) return exp_format(d,precision);
		if (precision == 0) 
			return (long)(d + 0.5) + (removeTrailing ? "" : ".");
		
		long whole = (long)d;
		double fr = d - whole; // fractional part
		if (fr >= 1 || fr < 0) return exp_format(d,precision);
		
		double factor = 1;
		String leading_zeroes = "";
		for (int i = 1; i <= precision && factor <= 0x7FFFFFFFFFFFFFFFL; i++) 
		{  factor *= 10; 
		leading_zeroes = leading_zeroes + "0"; 
		}
		long l = (long) (factor * fr + 0.5);
		if (l >= factor) { l = 0; whole++; } // CSH 10-25-97
		
		String z = leading_zeroes + l;
		z = "." + z.substring(z.length() - precision, z.length());
		
		if (removeTrailing)
		{  int t = z.length() - 1;
		while (t >= 0 && z.charAt(t) == '0') t--;
		if (t >= 0 && z.charAt(t) == '.') t--;
		z = z.substring(0, t + 1);
		}
		
		return whole + z;
	}
	
	private static String exp_format(double d, int precision) {
		String f = "";
		int e = 0;
		double dd = d;
		double factor = 1;
		if (d != 0)
		{  while (dd > 10) { e++; factor /= 10; dd = dd / 10; }
		while (dd < 1) { e--; factor *= 10; dd = dd * 10; }
		}
		if ((fmt == 'g' || fmt == 'G') && e >= -4 && e < precision) 
			return fixed_format(d,precision);
		
		d = d * factor;
		f = f + fixed_format(d,precision);
		
		if (fmt == 'e' || fmt == 'g')
			f = f + "e";
		else
			f = f + "E";
		
		String p = "000";      
		if (e >= 0) 
		{  f = f + "+";
		p = p + e;
		}
		else
		{  f = f + "-";
		p = p + (-e);
		}
		
		return f + p.substring(p.length() - 3, p.length());
	}
	
	// for the graph with POSITIVE weighted edges
	// if there is no path between two nodes put 1<<30 in the graph array
	// always find the dist from the node 0 to the other ones
	public static int[] dijkstra(int graph[][]){
		int d[] = new int[ graph.length ];
		int dC[] = new int[ graph.length ];
		int p[] = new int[ graph.length ];
		for( int i = 0; i < graph.length; i++ ){ d[ i ] = 100; dC[ i ] = 100; p[ i ] = -1; }
		d[ 0 ] = 0; dC[ 0 ] = 0;
		
		int i = 0, pos = 0;
		while( i < graph.length ){
			int min = 1<<30;
			//extract minimum
			for( int j = 0; j < dC.length; j++ ){
				if( min > d[ j ] && dC[ j ] != -1 ){
					min = d[ j ]; pos = j;
				}
			}
			dC[ pos ] = -1;
			
			//relax
			for( int j = 0; j < graph.length; j++ ){
				if( d[ j ] > graph[ pos ][ j ] + d[ pos ] ){
					d[ j ] = graph[ pos ][ j ] + d[ pos ];
					p[ j ] = pos;
				}
			}
			i++;			
		}
		
		return d;
	}

	// ALL SOURCE shortest path
	// put 0 in the case that you do not have a edge between two nodes
	// after calling this function dist[i][j] will the the minimum distance
	// between i and j if it exists or 0, otherwise	
	public static int[][] floyd_warshall(int graph[][]) {
		int n=graph.length;
		int dist[][] = new int[n][n];
		for(int c1=0;c1<n;c1++)
			for(int c2=0;c2<n;c2++)
				dist[c1][c2]=graph[c1][c2];
		
		int i, j, k;
		for (k = 0; k < n; ++k) {			
			for (i = 0; i < n; ++i)
				for (j = 0; j < n; ++j)
					/* If i and j are different nodes and if the paths between i and k and between k and j exist, do */
					if ((dist[i][k] * dist[k][j] != 0) && (i != j))
						/* See if you can't get a shorter path between i and j by interspacing
						 k somewhere along the current path */
						if ((dist[i][k] + dist[k][j] < dist[i][j]) || (dist[i][j] == 0))
							dist[i][j] = dist[i][k] + dist[k][j];
		}
		
		return dist;
	}

	// suitable for graphs with some NEGETIVE weighted edges
	// put 0 for the cases that there is no edge between two nodes
	public static int[] bellman_ford(int [][] dist, int source) {

		int i, j, n = dist.length, e = 0, d[] = new int[n];
		int edges[][] = new int[n*n][3];
		for (i = 0; i < n; ++i) {
			for (j = 0; j < n; ++j) {				
				if (dist[i][j] != 0) {
					edges[e][0] = i;
					edges[e][1] = j;
					edges[e][2] = dist[i][j];
					++e;
				}			
			}
			d[i] = 1<<30;
		}
		
		d[source] = 0;

		for (i = 0; i < n - 1; ++i) {
			for (j = 0; j < e; ++j) {
				if (d[edges[j][0]] + edges[j][2] < d[edges[j][1]]) {
					d[edges[j][1]] = d[edges[j][0]] + edges[j][2];
				}
			}
		}
		
		return d;			
	}
	
	// an input array should be like a[10][11]
	public static double[] gaussElimination(double arr[][]) {		
		int i, j, k, max, n = arr.length;				
		double a[][] = new double[n][n+1];
		double t;
		
		for(int c1=0;c1<n;c1++)
			for(int c2=0;c2<=n;c2++)
				a[c1][c2] = arr[c1][c2];

		for (i = 0; i < n; ++i) {
			max = i;
			for (j = i + 1; j < n; ++j)
				if (a[j][i] > a[max][i])
					max = j;

			for (j = 0; j < n + 1; ++j) {
				t = a[max][j];
				a[max][j] = a[i][j];
				a[i][j] = t;
			}

			for (j = n; j >= i; --j)
				for (k = i + 1; k < n; ++k)
					a[k][j] -= (a[k][i]/a[i][i] * a[i][j]);
		}
		
		for (i = n - 1; i >= 0; --i) {
			a[i][n] = a[i][n] / a[i][i];
			a[i][i] = 1;
			for (j = i - 1; j >= 0; --j) {
				a[j][n] -= a[j][i] * a[i][n];
				a[j][i] = 0;
			}
		}
		
		double result[] = new double[n];
		for (int c1 = 0; c1 < n; c1++) {			
			if (!Double.isNaN(a[c1][n]) && !Double.isInfinite(a[c1][n]))
				result[c1]=Math.round(a[c1][n]*1E10)/(1E10);
			else
				result[c1]=a[c1][n];				
		}
		
		return result;
	}

	// return the objects in knapsack and the value gain as the last element of array[n+1]
	// c is the cost/weight of the objects
	// v is the value of that objects
	// W is the limit on cost/weight
	public static int[] knapsack_0_1(int c[], int v[], int W) {	
		int a[] = new int[W+1]; /* a[i] holds the maximum value that can be obtained using at most i weight */		
		int addedObj[] = new int[W+1];
		int i, j, n = c.length;
		int result[] = new int[n+1];
		int last_added[][] = new int[W+1][n]; /* I use this to calculate which object were	added */
		
		for (i = 0; i <= W; ++i) {
			a[i] = 0;			
			addedObj[i] = -1;			
		}

		a[0] = 0;
		for (j = 0; j < n; ++j) {
			for (i = W; i >= 1; --i) {			
				if ((c[j] <= i) && (a[i] < a[i - c[j]] + v[j])) {
					a[i] = a[i - c[j]] + v[j];					
					last_added[i][j] = 1;
				}
			}
		}
		
		int sum = a[W];
		int aux = W;		
		for (j=n-1; j >= 0; j--) {
			for (i=1;i<=W;i++) {				
				if (last_added[i][j] == 1) {
					a[i] = a[i] - v[j];
					if (i == aux) {
						result[j] = 1;
						aux -= c[j];
					}
				}
			}
		}

		result[n] = sum;
		return result;
	}
	
	// if result[0] be -1 means that no solution
	// 0 means not selected and 1 means selected
	// S are the input values
	// A[k] will store the smallest subscript value j 
	// s.t. there is some subset of S[1] . . . S[j-1], along with S[j], that sums to k
	public static int[] subSetSum(int inp[], int C) {

		int n = inp.length;
		int S[] = new int[n + 1];
		int result[] = new int[n];
		result[0] = -1;
		for (int c1=0;c1<n;c1++)
			S[c1+1] = inp[c1];
			
		S[0]=0;

		int i,j,k,sum;
		int A[] = new int[C + 1];
		for (i=0;i<=C;i++)
		  A[i]=(-1);  // initialize to "impossible"
	
		A[0]=0;  // This is a cute way to force the initialization in Notes 18.
		for (i=0;i<C;i++)	// Derive other cases from optimal way to get A[i]
		  if (A[i]!=(-1))	// The S[] values increase the sum in increasing subscript order.
		    for (j=A[i]+1;j<=n;j++)
		    {
		      k=i+S[j];
		      if (k>C)
		        continue;
		      // See if A[k] can be improved
		      if (A[k]==(-1) || A[k]>j)
		      	A[k]=j;		     
		    }
	
		if (A[C]!=(-1))	{
		  // traceback to get subset		  
		  sum=C;
		  result[0] = 0;
		  while (sum>0) {
		  	
		    result[A[sum]-1] = 1;
		    sum-=S[A[sum]];  // Remove last S[] value included in sum.
		  }		  		 
		}
		
		return result;
	}
}
