import java.util.*;
import java.io.*;

public class C {
	FastScanner in;
	PrintWriter out;
	int x;
	int y;
	int t;
	int[][] a;
	
	void clean(int i, int j) {
		a[i][j] = 1;
		if (i > 0) {
			if (j > 0) {
				a[i - 1][j - 1] = 1;
			}
			a[i - 1][j] = 1;
			if (j < y - 1) {
				a[i - 1][j + 1] = 1;
			}
		}
		if (j > 0) {
			a[i][j - 1] = 1;
		}
		if (j < y - 1) {
			a[i][j + 1] = 1;
		}
		if (i < x - 1) {
			if (j > 0) {
				a[i + 1][j - 1] = 1;
			}
			a[i + 1][j] = 1;
			if (j < y - 1) {
				a[i + 1][j + 1] = 1;
			}
		}
	}

	int count(int i, int j) {
		int sum = 0;
		sum += 1 - a[i][j];
		if (i > 0) {
			if (j > 0) {
				sum += 1 - a[i - 1][j - 1];
			}
			sum += 1 - a[i - 1][j];
			if (j < y - 1) {
				sum += 1 - a[i - 1][j + 1];
			}
		}
		if (j > 0) {
			sum += 1 - a[i][j - 1];
		}
		if (j < y - 1) {
			sum += 1 - a[i][j + 1];
		}
		if (i < x - 1) {
			if (j > 0) {
				sum += 1 - a[i + 1][j - 1];
			}
			sum += 1 - a[i + 1][j];
			if (j < y - 1) {
				sum += 1 - a[i + 1][j + 1];
			}
		}
		return sum;
	}
	

	public void solve() throws IOException {
		int tests = in.nextInt();
		for (int test = 0; test < tests; test++) {
			x = in.nextInt();
			y = in.nextInt();
			int k = in.nextInt();
			out.println("Case #" + (test + 1) + ":");	
			t = x * y - k;
			a = new int[x][y];
		
			while (t != 0) {
				boolean ok = true;
				int mi = 0;
				int mj = 0;
				for (int i = 0; i < x; i++) {
					for (int j = 0; j < y; j++) {
						if (t - count(i, j) >= 0 && count(mi, mj) < count(i, j)) {
							ok = false;
							mi = i;
							mj = j;
						}
					}
				}
				t -= count(mi, mj);
				clean(mi, mj);
				if (ok) {
					break;
				}
			}
			if (t != 0) {
				out.println("Impossible");
				continue;
			}
			a[0][0] = 2;
			for (int i = 0; i < x; i++) {
				for (int j = 0; j < y; j++) {
					if (a[i][j] == 0) {
						out.print("*");
					}
					if (a[i][j] == 2) {
						out.print("c");
					}
					if (a[i][j] == 1) {
						out.print(".");
					}
				}
				out.println();
			}
		}
		
	}

	public void run() {
		try {
			in = new FastScanner(new File("input.txt"));
			out = new PrintWriter(new File("output.txt"));

			solve();

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String nextLine() {
			try {
				return br.readLine();
			} catch (Exception e) {
				return null;
			}
		}

		int nextInt() {
			return Integer.parseInt(next());
		}
	}

	public static void main(String[] arg) {
		new C().run();
	}
}