/**
 * Created by amir on 09.04.16.
 */

import java.math.BigInteger;
import java.util.*;
import java.io.*;

public class C {
    FastScanner in;
    PrintWriter out;
    boolean systemIO = false;



    class Generator {
        private int n;
        private byte[] a;
        private boolean hasNext;

        public Generator(int len) {
            n = len;
            a = new byte[n - 2];
            hasNext = true;
        }

        public boolean hasNext() {
            return hasNext;
        }

        public String getNext() {
            StringBuilder sb = new StringBuilder();
            for (byte b : a) {
                sb.append(b);
            }
            int i = n - 3;
            while (i >= 0 && a[i] == 1) {
                i--;
            }
            if (i < 0) {
                hasNext = false;
            } else {
                a[i] = 1;
                for (int j = i + 1; j < n - 2; j++) {
                    a[j] = 0;
                }
            }
            return "1" + sb.toString() + "1";
        }

    }

    public boolean isJamcoin(String s) {
        for (int i = 2; i < 11; i++) {
            BigInteger bi = new BigInteger(s, i);
            if (bi.isProbablePrime(10000)) {
                return false;
            }
        }
        return true;
    }

    public List<Long> getDivisors(String s) {
        List<Long> res = new ArrayList<>();
        for (int i = 2; i < 11; i++) {
            long l = Long.valueOf(s, i);
            System.err.println(i);
            for (long div = 2; div < Math.sqrt(l); div++) {
                if (l % div == 0) {
                    res.add(div);
                    break;
                }
            }
        }
        return res;
    }

    public void solve() {
        int t = in.nextInt();
        for (int test = 0; test < t; test++) {
            out.println("case #" + (test + 1) + ": ");
            int n = in.nextInt();
            int j = in.nextInt();
            Generator g = new Generator(n);
            for (int i = 0; i < j; i++) {
                String s = g.getNext();
                System.err.println(s);
                while (!isJamcoin(s)) {
                    s = g.getNext();
                    System.err.println(s);
                }
                out.print(s + " ");
                getDivisors(s).forEach((x -> out.print(x + " ")));
                out.println();
            }
        }
    }

    public void run() {
        try {
            if (systemIO) {
                in = new FastScanner(System.in);
                out = new PrintWriter(System.out);
            } else {
                in = new FastScanner(new File("file.in"));
                out = new PrintWriter(new File("file.out"));
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;


        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String nextLine() {
            try {
                return br.readLine();
            } catch (IOException e) {
                return null;
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

    }

    public static void main(String[] arg) {
        new C().run();
    }
}
