/**
 * Created by amir on 09.04.16.
 */

import java.math.BigInteger;
import java.util.*;
import java.io.*;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class C {
    FastScanner in;
    PrintWriter out;
    boolean systemIO = false;



    class Generator {
        private int n;
        private byte[] a;
        private boolean hasNext;

        public Generator(int len) {
            n = len;
            a = new byte[n - 2];
            hasNext = true;
        }

        public boolean hasNext() {
            return hasNext;
        }

        public String getNext() {
            StringBuilder sb = new StringBuilder();
            for (byte b : a) {
                sb.append(b);
            }
            int i = n - 3;
            while (i >= 0 && a[i] == 1) {
                i--;
            }
            if (i < 0) {
                hasNext = false;
            } else {
                a[i] = 1;
                for (int j = i + 1; j < n - 2; j++) {
                    a[j] = 0;
                }
            }
            return "1" + sb.toString() + "1";
        }

    }

    public boolean isJamcoin(String s) {
        for (int i = 2; i < 11; i++) {
            BigInteger bi = new BigInteger(s, i);
            if (bi.isProbablePrime(10000)) {
                return false;
            }
        }
        return true;
    }

    public class PrinterThread implements Runnable {
        String s;

        public PrinterThread(String s) {
            super();
            this.s = s;
        }

        @Override
        public void run() {
            printWithDivisors(s);
        }
    }

    public void printWithDivisors(String s) {
        System.err.println("called");
        List<String> res = new ArrayList<>();
        for (int i = 2; i < 11; i++) {
            BigInteger l = new BigInteger(s, i);
            //System.err.println(s + " " + i);
            int p = 0;
            for (BigInteger div = new BigInteger("2"); p < 20000; div = div.add(BigInteger.ONE)) {
                //System.err.println("doing smth");
                p++;
                if (l.mod(div).equals(BigInteger.ZERO)) {
                    res.add(div.toString());
                    break;
                }
            }
        }
        if (res.size() == 9) {
            StringBuilder sb = new StringBuilder();
            sb.append(s).append(" ");
            res.forEach((x -> sb.append(x + " ")));
            sb.append('\n');
            out.print(sb.toString());
            System.err.println(sb.toString());
        }
    }

    public void checker() {
        String s = in.nextLine();
        for (int i = 0; i < 500; i++) {
            s = in.next();
            for (int j = 2; j < 11; j++) {
                BigInteger b = new BigInteger(s, j);
                if (b.mod(new BigInteger(in.next())).equals(BigInteger.ZERO)) {
                    System.err.print("OK");
                } else
                    System.err.println("WRONG");
            }
            System.err.println();
        }
    }

    public void solve() {
        checker();
        /*int t = in.nextInt();
        for (int test = 0; test < t; test++) {
            out.println("case #" + (test + 1) + ": ");
            int n = in.nextInt();
            int j = in.nextInt();
            Generator g = new Generator(n);
            ExecutorService exec = Executors.newFixedThreadPool(4);
            for (int i = 0; i < j*2; i++) {
                String s = g.getNext();
                while (!isJamcoin(s)) {
                    s = g.getNext();
                }
                exec.submit(new PrinterThread(s));
            }
            try {
                exec.awaitTermination(20, TimeUnit.SECONDS);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
            exec.shutdownNow();
            exec.shutdownNow();
        }*/
    }

    public void run() {
        try {
            if (systemIO) {
                in = new FastScanner(System.in);
                out = new PrintWriter(System.out);
            } else {
                in = new FastScanner(new File("file.in"));
                out = new PrintWriter(new File("file.out"));
            }
            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;


        FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        FastScanner(InputStream f) {
            br = new BufferedReader(new InputStreamReader(f));
        }

        String nextLine() {
            try {
                return br.readLine();
            } catch (IOException e) {
                return null;
            }
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

    }

    public static void main(String[] arg) {
        new C().run();
    }
}
