package codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Vector;

public class Main2 {
	final static Vector<String> words = new Vector<String>();
	final static Vector<String> tests = new Vector<String>();
	private static boolean debug;

	public static void main2(final String[] args) throws Exception {
		Vector<String> t = new Vector<String>();
		t.add("/home/gcj/finals");
		t.add("/home/gcj/quals");

		t = explode(t);
	}

	public static void main(final String[] args) throws Exception {
		final String inputFile = args[0];
		final BufferedReader fs = new BufferedReader(new InputStreamReader(new FileInputStream(inputFile)));

		final int C = Integer.parseInt(fs.readLine().trim());
		for (int i = 0; i < C; i++ ) {
			String[] line = fs.readLine().trim().split(" ");
			final int N = Integer.parseInt(line[0]);
			final int K = Integer.parseInt(line[1]);
			final int B = Integer.parseInt(line[2]);
			final int T = Integer.parseInt(line[3]);

			line = fs.readLine().trim().split(" ");
			final int[] X = new int[N];
			for (int j = 0; j < N; j++ )
				X[j] = Integer.parseInt(line[j]);

			line = fs.readLine().trim().split(" ");
			final int[] V = new int[N];
			for (int j = 0; j < N; j++ )
				V[j] = Integer.parseInt(line[j]);

			System.out.println("Case #" + (i + 1) + ": " + solve(X, V, K, B, T));
		}
	}

	static int numJumps(final int[] x, final int[] time, final int index, final int timeLimit) {
		int returnVal = 0;
		for (int i = index + 1; i < x.length; i++ )
			if (time[i] > time[index] && time[i] >= timeLimit - 1)
				returnVal++ ;
		return returnVal;
	}

	private static String solve(final int[] x, final int[] v, final int k, final int b, final int t) {
		final int[] time = new int[x.length];
		for (int i = 0; i < x.length; i++ )
			time[i] = (int) (((float) b - (float) x[i]) / v[i]);

		if (debug) {
			System.out.println();
			System.out.println("k=" + k + ", b=" + b + ", t=" + t);
			System.out.println("X: " + printArr(x));
			System.out.println("V: " + printArr(v));
			System.out.println("Time: " + printArr(time));
		}

		int count = 0;
		for (int i = 0; i < x.length; i++ )
			if (time[i] <= t)
				count++ ;

		if (count < k)
			return "IMPOSSIBLE";

		final int[] jumps = new int[x.length];
		for (int i = 0; i < x.length; i++ )
			jumps[i] = numJumps(x, time, i, t);

		if (debug)
			System.out.println("Jumps: " + printArr(jumps));

		Arrays.sort(jumps);

		int returnVal = 0;
		int num = 0;
		for (int i = 0; i < x.length; i++ ) {
			if (time[i] <= t) {
				returnVal += jumps[i];
				num++ ;
			}
			if (num >= k)
				break;
		}

		return "" + returnVal;
	}

	static String printArr(final int[] arr) {
		String returnVal = "";
		for (final int x : arr)
			returnVal += "," + x;
		return returnVal;
	}

	static String printArr(final Vector<String> arr) {
		String returnVal = "";
		for (final String x : arr)
			returnVal += "," + x;
		return returnVal;
	}

	private static int solve(Vector<String> folders, final Vector<String> createFolders) {
		folders = explode(folders);
		int returnVal = 0;
		for (final String c : createFolders) {
			final String[] f = c.split("/");

			int i = 1;
			String tmp = "/" + f[i];
			while (true) {
				if ( !folders.contains(tmp)) {
					folders.add(tmp);
					returnVal++ ;
				}
				if (i == f.length - 1)
					break;
				i++ ;
				tmp += "/" + f[i];
			}
		}
		return returnVal;
	}

	private static Vector<String> explode(final Vector<String> folders) {
		final Vector<String> returnVal = new Vector<String>();
		for (final String s : folders) {
			final String[] parts = s.trim().split("/");
			String temp = "";
			for (final String p : parts) {
				if (p.trim().length() > 0)
					temp += "/" + p;
				if ( !returnVal.contains(temp))
					returnVal.add(temp);
			}
		}

		return returnVal;
	}
}
