package codejam1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Random;
import java.util.Vector;

public class Qual3 {
	final static Vector<String> words = new Vector<String>();
	final static Vector<String> tests = new Vector<String>();

	static long R, k, g[];
	static int N;

	private static Foo[] cached = null;

	public static void main(final String[] args) throws Exception {
		final String inputFile = args[0];
		final BufferedReader fs = new BufferedReader(new InputStreamReader(new FileInputStream(inputFile)));

		final int T = Integer.parseInt(fs.readLine().trim());

		for (int i = 0; i < T; i++) {
			String[] line = fs.readLine().trim().split(" ");
			R = Long.parseLong(line[0]);
			k = Long.parseLong(line[1]);
			N = Integer.parseInt(line[2]);

			line = fs.readLine().trim().split(" ");

			g = new long[N];
			for (int j = 0; j < N; j++)
				g[j] = Long.parseLong(line[j]);

			System.out.println("Case #" + (i + 1) + ": " + solve());
		}
	}

	private static void generate() throws Exception {
		final BufferedWriter fs = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("large.txt")));
		fs.write("" + 50 + "\n");
		final Random r = new Random();
		for (int i = 0; i < 50; i++) {
			final long R = (long) Math.pow(10, 8);
			final long k = (long) Math.pow(10, 9);
			final int N = 1000;
			fs.write("" + R + " " + k + " " + N + "\n");
			for (int j = 0; j < N; j++) {
				final int g = r.nextInt(10000000);
				fs.write("" + g + " ");
			}
			fs.write("\n");
		}
	}
	private static String toStr() {
		String returnVal = "";
		for (final long x : g)
			returnVal += x + " ";
		return returnVal;
	}

	private static void createCache() {
		cached = new Foo[N];
		int startIndex = 0;
		int nextIndex = 0;
		long seated = 0;
		int increment = 0;

		while (startIndex < N) {
			while (seated + g[nextIndex] <= k) {
				seated += g[nextIndex++];
				nextIndex %= N;
				increment++;
				if (nextIndex == startIndex)
					break;
			}
			final Foo f = new Foo();
			f.increment = increment;
			f.seated = seated;
			cached[startIndex] = f;

			seated -= g[startIndex];
			startIndex++;
			increment--;
		}
	}

	private static long solve() {
		createCache();

		long returnVal = 0;
		int nextIndex = 0;
		for (int i = 0; i < R; i++) {
			final Foo f = cached[nextIndex];
			nextIndex += f.increment;
			nextIndex %= N;
			returnVal += f.seated;
			continue;
		}

		return returnVal;
	}
}

class Foo {
	long seated;
	int increment;
}
