package codejam;

import java.io.*;


public class Rotate {

    public static void main(String args[]){

        String input = "d:\\A-large(2).in";
        String output = "d:\\A-large(2).out";
        File input_file = null;
        File output_file = null;
        BufferedReader br = null;
        BufferedWriter bw = null;

        try{

            input_file = new File(input);
            br = new BufferedReader(new FileReader(input_file));

            output_file = new File(output);
            bw = new BufferedWriter(new FileWriter(output_file));

            int case_count = Integer.parseInt(br.readLine());
            String[] constants = null;
            for(int i=1 ; i<=case_count ; i++){
                constants = br.readLine().split(" ");
                int n = Integer.parseInt(constants[0]);
                int k = Integer.parseInt(constants[1]);
                char board[][] = new char[n][n];
                for(int j=0 ; j<n ; j++){
                    board[j] = br.readLine().toCharArray();
                }

                String win = process(board,n,k);
                bw.write("Case #"+i+": "+win+"\n");
            }

            br.close();
            bw.close();

        }catch(Exception e){
            e.printStackTrace();
        }
    }


    public static String process(char[][] board , int n, int k){
        String win = "Neither";
        boolean r=false;
        boolean b=false;
        int myb[][][][] = new int[n][n][2][4];
        //printBoard(board);
        board = rotateBoard(board,n);
        //printBoard(board);
        //System.out.println("-------------------");


        int turn =0;
        for(int i=0 ; i<n ; i++){
            for(int j=0 ; j<n ; j++){
                if(board[i][j]=='R') turn=0;
                else if(board[i][j]=='B') turn = 1;
                else continue;
                myb[i][j][turn][0] = 1;
                myb[i][j][turn][1] = 1;
                myb[i][j][turn][2] = 1;
                myb[i][j][turn][3] = 1;
                if(j-1>=0){  //H
                    myb[i][j][turn][0] += myb[i][j-1][turn][0];
                }if(i-1>=0){  //v
                    myb[i][j][turn][1] += myb[i-1][j][turn][1];
                    if(j-1>=0){ //   \
                        myb[i][j][turn][2] += myb[i-1][j-1][turn][2];
                    }if(j+1<n){ //   /
                        myb[i][j][turn][3] += myb[i-1][j+1][turn][3];
                    }
                }
            }
        }

        for(int i=n-1 ; i>=0 ; i--){
            for(int j=n-1 ; j>=0 ; j--){
                for(int l=0 ; l<4 ;l++){
                    if(myb[i][j][0][l]>=k) r=true;
                    if(myb[i][j][1][l]>=k) b=true;
                }
            }
        }


        if(b&&r){
            win = "Both";
        }else if(b){
            win = "Blue";
        }else if(r){
            win = "Red";
        }

        return win;
    }

    public static char[][] rotateBoard(char[][] board, int n){
        char rBoard[][] = new char[n][n];
        int index[] = new int[n];
        for(int i=n-1 ; i>=0 ; i--){
            for(int j=n-1,k=n-1 ; j>=0 ; j--){
                if(board[i][j]!='.'){
                    rBoard[k--][n-1-i] = board[i][j];
                    index[j]++;
                }
            }
        }
        return rBoard;
    }

    public static void printBoard(char board[][]){
        for(int i=0 ; i<board.length ; i++){
            for(int j=0 ; j<board.length ; j++){
                System.out.print(" "+board[i][j]);
            }
            System.out.println("");
        }
    }



}
