package codejam;

import java.io.*;
import java.util.Set;
import java.util.HashSet;


public class FileFix {

    public static void main(String args[]){

        String input = "d:\\A-large.in";
        String output = "d:\\A-large.out";
        File input_file = null;
        File output_file = null;
        BufferedReader br = null;
        BufferedWriter bw = null;

        try{

            input_file = new File(input);
            br = new BufferedReader(new FileReader(input_file));

            output_file = new File(output);
            bw = new BufferedWriter(new FileWriter(output_file));

            int case_count = Integer.parseInt(br.readLine());
            String[] constants = null;
            for(int i=1 ; i<=case_count ; i++){
                constants = br.readLine().split(" ");
                int n = Integer.parseInt(constants[0]);
                int m = Integer.parseInt(constants[1]);
                String olds[] = new String[n];
                String news[] = new String[m];
                for(int j=0 ; j<n ; j++){
                    olds[j] = br.readLine();
                }
                for(int j=0 ; j<m ; j++){
                    news[j] = br.readLine();
                }

                int command = process(olds,news);
                bw.write("Case #"+i+": "+command+"\n");
            }

            br.close();
            bw.close();

        }catch(Exception e){
            e.printStackTrace();
        }
    }


    public static int process(String olds[], String news[]){
        int command = 0;
        HashSet names = new HashSet();
        names.add("/");
        for(int i=0; i<olds.length ; i++){
            String paths[] = olds[i].split("/");
            String path = "";
            for(int j=0 ; j<paths.length ; j++){
                path = path+"/"+paths[j];
                names.add(path);
            }
        }


        for(int i=0; i<news.length ; i++){
            String paths[] = news[i].split("/");
            String path = "";
            for(int j=0 ; j<paths.length ; j++){
                path = path+"/"+paths[j];
                if(!names.contains(path)){
                    command++;
                    names.add(path);
                }
            }
        }

        return command;
    }

}
