import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

/**
 * @author Amit Jacob
 *
 */
public class DeceitfulWar {

	/**
	 * @param args - Input File Path
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		//Reading the input file:
		String path=args[0];
		File file = new File(path);
		BufferedReader br = new BufferedReader(new FileReader(file));
		String line;
		//Writing the output file:
		File fileout = new File("output.txt");
		fileout.createNewFile();
	    FileWriter writer = new FileWriter(fileout);
	    //var declarations:
	    int N;
	    ArrayList<Double> KenWoods,NaomiWoods,KenWoodsCopy,NaomiWoodsCopy;
	    String[] nums;
	    double naomiVal,kenVal;
	    int kenId;
	    int naomiWar,naomiDeceitfulWar;
	    //Begin reading:
  		line=br.readLine();
  		int nTests = Integer.parseInt(line);
  		for(int j=0;j<nTests;++j)
  		{
  			line=br.readLine();
  			N=Integer.parseInt(line);
  			line=br.readLine();
  			nums=line.split(" ");
  			NaomiWoods = new ArrayList<Double>();
  			for(int i=0;i<N;++i)
  			{
  				NaomiWoods.add(Double.parseDouble(nums[i]));
  			}
  			line=br.readLine();
  			nums=line.split(" ");
  			KenWoods = new ArrayList<Double>();
  			for(int i=0;i<N;++i)
  			{
  				KenWoods.add(Double.parseDouble(nums[i]));
  			}
  			Collections.sort(KenWoods);
  			Collections.sort(NaomiWoods);
  			KenWoodsCopy=(ArrayList<Double>) KenWoods.clone();
  			NaomiWoodsCopy=(ArrayList<Double>) NaomiWoods.clone();
  			naomiWar=0;
  			while(!NaomiWoodsCopy.isEmpty())
  			{
  				naomiVal=NaomiWoodsCopy.remove(NaomiWoodsCopy.size()-1);
  				
  				if(naomiVal>KenWoodsCopy.get(KenWoodsCopy.size()-1))
  				{
  					++naomiWar;
  					KenWoodsCopy.remove(0);
  				}
  				else if(naomiVal<KenWoodsCopy.get(0))
  				{
  					KenWoodsCopy.remove(0);
  				}
  				else
  				{
  					for(kenId=KenWoodsCopy.size()-1;naomiVal<KenWoodsCopy.get(kenId);--kenId);
  					++kenId;
  					KenWoodsCopy.remove(kenId);
  				}
  			}
  			naomiDeceitfulWar=getBestScore(KenWoods,NaomiWoods);
  			
  			writer.write("Case #"+(j+1)+": "+naomiDeceitfulWar + " " + naomiWar+"\n" );
  			writer.flush();
  		}
  		writer.close();
	}

	private static int getBestScore(ArrayList<Double> kenWoods,
			ArrayList<Double> naomiWoods) 
	{
		/* Two possible moves
		 * #1: Make ken remove his heaviest wood and sacrifice Naomi's most light wood
		 * #2: Make ken sacrifice his most light wood and put Naomi's most light wood that is still heavy enough
		 * The order of the moves does not matter.
		 */
		 int score=0;
		 while(!naomiWoods.isEmpty() && naomiWoods.get(naomiWoods.size()-1)>kenWoods.get(0))
		 {
			 ++score;
			 int id=0;
			 while(naomiWoods.get(id)<kenWoods.get(0))
				 ++id;
			 naomiWoods.remove(id);
			 kenWoods.remove(0);
		 }
		 return score;
	}
}
