/**
 * @author Amit Jacob
 *
 */
import java.io.*;
public class CookieClickerAlpha {

	/**
	 * @param args - Input File Path
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		//Reading the input file:
		String path=args[0];
		File file = new File(path);
		BufferedReader br = new BufferedReader(new FileReader(file));
		String line;
		//Writing the output file:
		File fileout = new File("output.txt");
		fileout.createNewFile();
	    FileWriter writer = new FileWriter(fileout);
	    //var declarations:
	    double C,F,X;
  		double minTime;
  		int maxFarms;
  		String[] nums;
	    //Begin reading:
  		line=br.readLine();
  		int nTests = Integer.parseInt(line);
  		
  		for(int j=0;j<nTests;++j)
  		{
  			line=br.readLine();
  			nums=line.split(" ");
  			C=Double.parseDouble(nums[0]);
  			F=Double.parseDouble(nums[1]);
  			X=Double.parseDouble(nums[2]);
  			/* we can bound the number of farms since
  			 * if we have no farms we will finish in X/2 seconds.
  			 * we can bound the time to get a farm by price_for_farm/minimum_coin_rate (a very not tight bound).
  			 * so in X/2 seconds we can buy at most (X/2)/timeForFarm farms.
  			 * minimum_coin_rate=2, so number of farms is bounded by X/C
  			 * 
  			 */
  			maxFarms=((int)(X/C) +1);
  			minTime=Double.MAX_VALUE;
  			for(int i=0;i<=maxFarms;++i)
  			{
  				minTime=Math.min(minTime, getTime(i,X,C,F));
  			}
  			writer.write("Case #"+(j+1)+": "+String.format("%.7f",minTime)+"\n" );
  			writer.flush();
  		}
  		writer.close();

	}
	private static double getTime(int nFarms,double x,double c,double f)
	{
		// T(n)=X/(2+n*f) + C*sum(1/(2+i*f))_{i=0}^{n-1}
		double sum =0;
		for(int i=0;i<nFarms;++i)
		{
			sum+=1/(2+i*f);
		}
		return x/(2+nFarms*f)+c*sum;
	}

}
