/**
 * @author Amit Jacob
 *
 */
import java.io.*;
public class CookieClickerAlpha {

	/**
	 * @param args - Input File Path
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		//Reading the input file:
		String path=args[0];
		File file = new File(path);
		BufferedReader br = new BufferedReader(new FileReader(file));
		String line;
		//Writing the output file:
		File fileout = new File("output.txt");
		fileout.createNewFile();
	    FileWriter writer = new FileWriter(fileout);
	    //var declarations:
	    double C,F,X;
  		double minTime;
  		int maxFarms;
  		String[] nums;
	    //Begin reading:
  		line=br.readLine();
  		int nTests = Integer.parseInt(line);
  		
  		for(int j=0;j<nTests;++j)
  		{
  			line=br.readLine();
  			nums=line.split(" ");
  			C=Double.parseDouble(nums[0]);
  			F=Double.parseDouble(nums[1]);
  			X=Double.parseDouble(nums[2]);
  			/* number of farms is bounded by (X-2)/F 
  			 * because in 1 turn we will get 2+F*n coins = 2+F*(X-2)/F=X coins 
  			 * hence there is no need for another farm.
  			 */
  			maxFarms=(int) X+1;
  			minTime=Double.MAX_VALUE;
  			for(int i=0;i<=maxFarms;++i)
  			{
  				minTime=Math.min(minTime, getTime(i,X,C,F));
  			}
  			writer.write("Case #"+(j+1)+": "+String.format("%.7f",minTime)+"\n" );
  			writer.flush();
  		}
  		writer.close();

	}
	private static double getTime(int nFarms,double x,double c,double f)
	{
		// T(n)=X/(2+n*f) + C*sum(1/(2+i*f))_{i=0}^{n-1}
		double sum =0;
		for(int i=0;i<nFarms;++i)
		{
			sum+=1/(2+i*f);
		}
		return x/(2+nFarms*f)+c*sum;
	}

}
