import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

class FileParser
{
	private ArrayList<String> lines;
	private int num;
	FileParser(String fileName) throws FileNotFoundException
	{
		Scanner in=new Scanner(new File(fileName));
		this.num=Integer.parseInt(in.nextLine());
		lines=new ArrayList<String>();
		while(in.hasNextLine())
		{
			lines.add(in.nextLine());
		}
	}
	public int getNum() {
		return num;
	}
	public ArrayList<String> getLines() {
		return lines;
	}
}
class PaternCountWriter
{
	private PrintWriter out;
	public PaternCountWriter(String file) throws FileNotFoundException
	{
		out=new PrintWriter(file.split("\\.")[0]+".out");
	}
	void write(int caseId,int count, int digits)
	{
		out.format("Case #%d: %0"+digits+"d\n", caseId,count);
	}
	void close()
	{
		out.close();
	}
}
class OccurenceCounter
{
	char pattern[];
	private int max;
	private int digits;
	
	public OccurenceCounter(String patternStr, int digits) 
	{
		this.pattern=patternStr.toCharArray();
		this.digits=digits;
		this.max=1;
		for(int i=0;i<digits;i++)
		{
			this.max*=10;
		}
	}
	int getOccurences(String line)
	{
		int count=0;
		char lineArr[]=line.toCharArray();
		int rows=pattern.length;
		int cols=lineArr.length;
		int occurance[][]=new int[rows+1][cols+1];
		for(int c=cols-1;c>=0;c--)
			occurance[rows][c]=1;
		for(int r=rows-1;r>=0;r--)
			for(int c=cols-1;c>=0;c--)
			{
				if(lineArr[c]==pattern[r])
					occurance[r][c]=(occurance[r+1][c]+occurance[r][c+1])%max;
				else
					occurance[r][c]=occurance[r][c+1];
			}
		count=occurance[0][0];
		return count;
	}
	public int getDigits() {
		return digits;
	}
}
public class PatternFinder {
	public static void main(String[] args) {
		try{
			if(args.length!=1)
			{
				System.out.print("Usage: BasinLocator <filename>");
				return;
			}
			FileParser parser=new FileParser(args[0]);
			PaternCountWriter writer=new PaternCountWriter(args[0]);
			String pattern="welcome to code jam";
			int digits=4;
			OccurenceCounter counter=new OccurenceCounter(pattern,digits);
			
			int caseId=1;
			int count;
			for(String line:parser.getLines())
			{
				count=counter.getOccurences(line);
				writer.write(caseId, count, digits);
				caseId++;
			}
			writer.close();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}

}
