import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;


public class LawnMover {
	public static void main(String[] args){
		File inFile = new File("input.txt");
		File outFile = new File("output.txt");
		try {
			System.setIn(new FileInputStream(inFile));
			System.setOut(new PrintStream(outFile));
		} catch (IOException e) {
			e.printStackTrace();
		}
		Scanner sc = new Scanner(System.in);
		int testCaseCount = sc.nextInt();
		for(int testCase=1;testCase<=testCaseCount;testCase++){
			System.out.printf("Case #%d: ",testCase);
			solve(sc);
		}
	}
	
	private static void solve(Scanner sc){
		int N = sc.nextInt(), M= sc.nextInt();
		int[][] matrix = new int[N][M];
		for(int i=0; i<N; i++){
			for(int j=0; j<M; j++){
				matrix[i][j] = sc.nextInt();
			}	
		}
		
		for(int i=0; i<N; i++){
			for(int j=0; j<M; j++){
				if(!verticalClear(matrix, j, matrix[i][j], N) && !horizontalClear(matrix, i, matrix[i][j], M)){
					System.out.println("NO");
					return;
				}
			}	
		}
		
		System.out.println("YES");
		return;
	}



	private static boolean verticalClear(int[][] matrix, int j, int height, int N) {
		for(int i=0; i< N; i++){
			if(matrix[i][j]>height){
				return false;
			}
		}
		return true;
	}	
	
	private static boolean horizontalClear(int[][] matrix, int i, int height, int M) {
		for(int j=0; j< M; j++){
			if(matrix[i][j]>height){
				return false;
			}
		}
		return true;
	}


}