import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;


public class FairSquare2 {
	public static void main(String[] args){
		File inFile = new File("input.txt");
		File outFile = new File("output.txt");
		try {
			System.setIn(new FileInputStream(inFile));
			System.setOut(new PrintStream(outFile));
		} catch (IOException e) {
			e.printStackTrace();
		}
		Scanner sc = new Scanner(System.in);
		int testCaseCount = sc.nextInt();
		for(int testCase=1;testCase<=testCaseCount;testCase++){
			System.out.printf("Case #%d: ",testCase);
			solve(sc);
		}
	}

	private static void solve(Scanner sc) {
		int A = sc.nextInt(), B = sc.nextInt();
		int start = (int) Math.ceil(Math.sqrt(A));
		int squareDifference = (start+1)*(start+1) - start*start;
		int square = start*start;
		int count = 0;
		if(isFairSquare(square)){
			count++;
		}
		while(true){
			square = getNextSquare(square, squareDifference);
			if(square<=B){
				if(isFairSquare(square)){
					count++;
				}
				squareDifference+=2;
			}else{
				break;
			}
		}
		System.out.println(count);
	}

	private static boolean isFairSquare(int square) {
		StringBuffer squareStr = new StringBuffer(String.valueOf(square));
		int sqrt = (int) Math.sqrt(square);
		if(squareStr.toString().equals(squareStr.reverse().toString())){
			squareStr = new StringBuffer(String.valueOf(sqrt));
			if(squareStr.toString().equals(squareStr.reverse().toString())){
				return true;
			}
		}
		return false;
	}

	private static int getNextSquare(int currentSquare, int squareDifference) {
		int nextSquare = currentSquare + squareDifference;
		return nextSquare;
	}
}