import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;


public class TickTacToe {
	public static void main(String[] args){
		File inFile = new File("input.txt");
		File outFile = new File("output.txt");
		try {
			System.setIn(new FileInputStream(inFile));
			System.setOut(new PrintStream(outFile));
		} catch (IOException e) {
			e.printStackTrace();
		}
		Scanner sc = new Scanner(System.in);
		int testCaseCount = sc.nextInt();
		for(int testCase=1;testCase<=testCaseCount;testCase++){
			System.out.printf("Case #%d: ",testCase);
			solve(sc);
		}
	}
	
	private static void solve(Scanner sc) {
		String[][] board = new String[4][4];
		boolean gameCompleted = true;
		String line = null;
		for(int i=0 ; i<4 ; i++){
			line = sc.next();
			if(line.contains(".")) gameCompleted = false;
			for(int j=0 ; j<4 ; j++){
				board[i][j] = String.valueOf(line.charAt(j));
			}
		}
		
		if(!checkWin(board, "X")){
			if(!checkWin(board, "O")){
				if(!gameCompleted){
					System.out.println("Game has not completed");
				}else{
					System.out.println("Draw");
				}
			}else{
				System.out.println("O won");
			}
		}else{
			System.out.println("X won");
		}
	}
	
	private static boolean checkWin(String[][] board, String player){
		for(int i=0 ; i<4 ; i++){
				if( (board[i][0].equals(player)||board[i][0].equals("T"))&&
					(board[i][1].equals(player)||board[i][1].equals("T"))&&
					(board[i][2].equals(player)||board[i][2].equals("T"))&&
					(board[i][3].equals(player)||board[i][3].equals("T"))){
					return true;
				}
		}
		
		for(int i=0 ; i<4 ; i++){
			if( (board[0][i].equals(player)||board[0][i].equals("T"))&&
				(board[1][i].equals(player)||board[1][i].equals("T"))&&
				(board[2][i].equals(player)||board[2][i].equals("T"))&&
				(board[3][i].equals(player)||board[3][i].equals("T"))){
				return true;
			}
		}
		
		if( 	(board[0][0].equals(player)||board[0][0].equals("T"))&&
				(board[1][1].equals(player)||board[1][1].equals("T"))&&
				(board[2][2].equals(player)||board[2][2].equals("T"))&&
				(board[3][3].equals(player)||board[3][3].equals("T"))){
				return true;
		}
		
		if( 	(board[0][3].equals(player)||board[0][3].equals("T"))&&
				(board[1][2].equals(player)||board[1][2].equals("T"))&&
				(board[2][1].equals(player)||board[2][1].equals("T"))&&
				(board[3][0].equals(player)||board[3][0].equals("T"))){
				return true;
		}
		
		return false;
	}
}
