package by.amitrofanov82.google.codeJam.apr_30_2016.task4;

import java.io.File;
import java.io.IOException;
import java.nio.LongBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;

import javafx.collections.ObservableList;
import javafx.collections.transformation.SortedList;

public class Main {
	private final static String FILES_ENCODING="UTF-8";
	private final static String LINE_ENDING=IOUtils.LINE_SEPARATOR_UNIX;
	private final static boolean DONT_APPEND_OUTPUT=false;
	private final static File INPUT_FILE = new File("./resources/input.txt");
	private final static File OUTPUT_FILE = new File("./resources/output.txt");
	
	
	public static void main(String[] args) throws IOException {
		List<String> inputLines = FileUtils.readLines(INPUT_FILE, "UTF-8"); 
		List<String> outputLines = new LinkedList<String>(); 
		resolveTask(inputLines, outputLines);
		FileUtils.writeLines(OUTPUT_FILE, FILES_ENCODING, outputLines, LINE_ENDING, DONT_APPEND_OUTPUT);
	}

	private static void resolveTask(List<String> inputLines, List<String> outputLines) {
		int numOfCases = Integer.parseInt(inputLines.get(0));
		String caseAnswer;
		for (int i =1; i<=numOfCases;i++){
			caseAnswer = resolveCase(inputLines.get(i));
			outputLines.add("Case #" + i + ": " + caseAnswer);
		}
	}

	public static String[] words={"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	
	//Works only in case K==S for now. Huge memory amount needed for btuteforce everything with K=100 and S<K
	private static String resolveCase(String caseInput) {
		StringBuffer caseInputBuffer = new StringBuffer("caseInput");
		List<Integer> result = new ArrayList<Integer>();
		
		while (caseInput.indexOf('Z')!=-1){
			result.add(0);
			caseInput = remove(words[0], caseInput);
		}
		while (caseInput.indexOf('W')!=-1){
			result.add(2);
			caseInput = remove(words[2], caseInput);
		}
		while (caseInput.indexOf('U')!=-1){
			result.add(4);
			caseInput = remove(words[4], caseInput);
		}
		while (caseInput.indexOf('X')!=-1){
			result.add(6);
			caseInput = remove(words[6], caseInput);
		}
		while (caseInput.indexOf('G')!=-1){
			result.add(8);
			caseInput = remove(words[8], caseInput);
		}
		while (caseInput.indexOf('O')!=-1){
			result.add(1);
			caseInput = remove(words[1], caseInput);
		}
		while (caseInput.indexOf('H')!=-1){
			result.add(3);
			caseInput = remove(words[3], caseInput);
		}
		while (caseInput.indexOf('F')!=-1){
			result.add(5);
			caseInput = remove(words[5], caseInput);
		}
		while (caseInput.indexOf('S')!=-1){
			result.add(7);
			caseInput = remove(words[7], caseInput);
		}
		while (caseInput.indexOf('N')!=-1){
			result.add(9);
			caseInput = remove(words[9], caseInput);
		}
		
		Collections.sort(result);
		
		StringBuffer strResult = new StringBuffer();
		for (int i = 0; i < result.size(); i++) {
			strResult.append(result.get(i));
		}

		System.out.println(strResult);
		return strResult.toString();
	}

	private static String remove(String stringToRemove, String caseInput) {
		for (int i = 0; i < stringToRemove.length(); i++) {
			caseInput=caseInput.replaceFirst(stringToRemove.substring(i, i+1), "");
		}
		return caseInput;
	}


}
