package by.amitrofanov82.google.codeJam.may_08_2016.task1;

import java.io.File;
import java.io.IOException;
import java.nio.LongBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;

import javafx.collections.ObservableList;
import javafx.collections.transformation.SortedList;

public class Main {
	private final static String FILES_ENCODING="UTF-8";
	private final static String LINE_ENDING=IOUtils.LINE_SEPARATOR_UNIX;
	private final static boolean DONT_APPEND_OUTPUT=false;
	private final static File INPUT_FILE = new File("./resources/input.txt");
	private final static File OUTPUT_FILE = new File("./resources/output.txt");
	
	
	public static void main(String[] args) throws IOException {
		List<String> inputLines = FileUtils.readLines(INPUT_FILE, "UTF-8"); 
		List<String> outputLines = new LinkedList<String>(); 
		resolveTask(inputLines, outputLines);
		FileUtils.writeLines(OUTPUT_FILE, FILES_ENCODING, outputLines, LINE_ENDING, DONT_APPEND_OUTPUT);
	}

	private static void resolveTask(List<String> inputLines, List<String> outputLines) {
		int numOfCases = Integer.parseInt(inputLines.get(0));
		String caseAnswer;
		for (int i =1; i<=numOfCases;i++){
			caseAnswer = resolveCase(inputLines.get(i*2-1), inputLines.get(i*2));
			outputLines.add("Case #" + i + ": " + caseAnswer);
		}
	}


	private static String resolveCase(String caseInput1, String caseInput2) {
		StringBuffer result = new StringBuffer("");
		//int N = Integer.parseInt(caseInput1);
		String[] s = caseInput2.split(" ");
		int[] senators = new int[s.length];
		for (int i=0; i< senators.length; i++) {
			senators[i] = Integer.parseInt(s[i]);
		}
		int indexToRemove;
		while((indexToRemove=takeMaxIndexAndRemoveSenator(senators, true))!=-2){
			result.append((char)('A'+indexToRemove));
			indexToRemove = takeMaxIndexAndRemoveSenator(senators, false);
			if (indexToRemove == -2) return result.toString();
			if (indexToRemove != -1) {
				result.append((char)('A'+indexToRemove));
				senators[indexToRemove] = senators[indexToRemove]-1;
			}
			result.append(" ");
		}
			

		
		
		return result.toString();
	}

	static int takeMaxIndexAndRemoveSenator(int[] senators, boolean remove){
		int max = 0;
		boolean isOnlyOneMax = true;
		System.out.print(senators[0]);
		for (int i=1; i< senators.length; i++) {
			if (senators[i] > senators[max]) {
				max = i;
				isOnlyOneMax = true;
			} else if (senators[i] == senators[max]) {
				isOnlyOneMax = false;
			}
			System.out.print(senators[i]);
		}
		if (senators[max] == 0) {
			max=-2;
		}
		if (remove && max!=-2) {
			senators[max] = senators[max]-1;
		}
		if (!isOnlyOneMax && (max!=-2) && !remove) {
			max=-1;
		}
		System.out.print("->"+ max);
		System.out.println("->"+ (char)('A'+max));

		return max;
	}
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	
	


}
