package by.amitrofanov82.google.codeJam.apr_30_2016.task4;

import java.io.File;
import java.io.IOException;
import java.nio.LongBuffer;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Collection;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;
import org.apache.commons.lang3.StringUtils;

import javafx.collections.ObservableList;
import javafx.collections.transformation.SortedList;

public class Main {
	private final static String FILES_ENCODING="UTF-8";
	private final static String LINE_ENDING=IOUtils.LINE_SEPARATOR_UNIX;
	private final static boolean DONT_APPEND_OUTPUT=false;
	private final static File INPUT_FILE = new File("./resources/input.txt");
	private final static File OUTPUT_FILE = new File("./resources/output.txt");
	
	
	public static void main(String[] args) throws IOException {
		List<String> inputLines = FileUtils.readLines(INPUT_FILE, "UTF-8"); 
		List<String> outputLines = new LinkedList<String>(); 
		resolveTask(inputLines, outputLines);
		FileUtils.writeLines(OUTPUT_FILE, FILES_ENCODING, outputLines, LINE_ENDING, DONT_APPEND_OUTPUT);
	}

	private static void resolveTask(List<String> inputLines, List<String> outputLines) {
		int numOfCases = Integer.parseInt(inputLines.get(0));
		String caseAnswer;
		for (int i =1; i<=numOfCases;i++){
			caseAnswer = resolveCase(inputLines.get(i));
			outputLines.add("Case #" + i + ": " + caseAnswer);
		}
	}

	public static String[] words={"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	
	//Works only in case K==S for now. Huge memory amount needed for btuteforce everything with K=100 and S<K
	private static String resolveCase(String caseInput) {
		char[] cscore = caseInput.split(" ")[0].toCharArray();
		char[] jscore = caseInput.split(" ")[1].toCharArray();	
		boolean isWinnerClear=false;
		boolean isCodersWin = false;
		boolean isDrawPossible = false;
		//fill zeros at beginning
		for (int i=0; i<cscore.length; i++){
			if ((cscore[i])=='?' && jscore[i] == '?'){
				cscore[i]='0';
				jscore[i]='0';
			} else break;
		}
		
		//determine winner:
		boolean flag1 = false;
		boolean flag2 = false;
		for (int i=0; i<cscore.length; i++){

			if (cscore[i]!='?' && jscore[i] == '?'){
				flag1 =true;
			}
			if (jscore[i]!='?' && cscore[i] == '?'){
				flag2 =true;
			}
			if (flag1 == true && flag2 == true) {
				System.out.println("out");
				break;
			}
			if ((cscore[i]!='?' && jscore[i] != '?')
				&& (cscore[i] != jscore[i]))
			{
				isWinnerClear = true;
				if (cscore[i] > jscore[i]){
					isCodersWin = true;
				}
			}
		}
		
		//determine if draw
		if (!isWinnerClear){
			isDrawPossible=true;
			for (int i=0; i<cscore.length; i++){
				if (!((cscore[i]=='?' || jscore[i] == '?') 
					|| (cscore[i] == jscore[i]))){
					isDrawPossible = false;
				}
			}
		}

		//case draw:
		if (isDrawPossible){
			System.out.println("draw");
			for (int i=0; i<cscore.length; i++){
				if (cscore[i] == '?' && jscore[i] == '?'){
					cscore[i] = jscore[i] = '0';
				}
				if (cscore[i] == '?'){
					cscore[i] = jscore[i];
				}
				if (jscore[i] == '?'){
					jscore[i] = cscore[i];
				}
			}
			StringBuffer sb =  new StringBuffer();
			sb.append(cscore);
			sb.append(" ");
			sb.append(jscore);
			return sb.toString();
		}
		
		//case winner clear:
		if (isWinnerClear){
			System.out.println("clear");
			if (isCodersWin){
				for (int i=0; i<cscore.length; i++){
					if (cscore[i] == '?') cscore[i]='0';
				}
				for (int i=0; i<jscore.length; i++){
					if (jscore[i] == '?') jscore[i]='9';
				}
			} else {
				for (int i=0; i<cscore.length; i++){
					if (cscore[i] == '?') cscore[i]='9';
				}
				for (int i=0; i<jscore.length; i++){
					if (jscore[i] == '?') jscore[i]='0';
				}
			}
			StringBuffer sb =  new StringBuffer();
			sb.append(cscore);
			sb.append(" ");
			sb.append(jscore);
			return sb.toString();
		}
		//rest case:
		for (int i=0; i<cscore.length; i++){
			if (cscore[i] == '?' && jscore[i] == '?'){
				cscore[i] = jscore[i] = '0';
			}
			if (cscore[i] == '?'){
				cscore[i] = jscore[i];
			}
			if (jscore[i] == '?'){
				jscore[i] = cscore[i];
			}
		}
		StringBuffer sb =  new StringBuffer();
		sb.append(cscore);
		sb.append(" ");
		sb.append(jscore);
		return sb.toString();
	}


}
