package source_root;

import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;

public class CaseResolver {
	
	static char[][] cake;
	static Set<Character> filledChars;
	
	public static List<String> resolveCase(List<String> caseInput) {
		filledChars = new HashSet<Character>();
		int R = Integer.parseInt(caseInput.get(0).split(" ")[0]);
		int C = Integer.parseInt(caseInput.get(0).split(" ")[1]);
		cake = new char[R][C];
		for (int i = 1 ; i< R+1; i++) {
			for (int j = 0 ; j< C; j++) {
				cake[i-1][j] = caseInput.get(i).charAt(j);
			}
		}
		//Utils.printMatrix(cake);
		for (int i = 0 ; i< R; i++) {
			for (int j = 0 ; j< C; j++) {
				if (cake[i][j] != '?') {
					fillCake(cake[i][j], i, j);
					filledChars.add(cake[i][j]);
					//Utils.printMatrix(cake);
				}
			}
		}
		List<String> result = new LinkedList();
		for (int i =0; i<cake.length; i++) {
			result.add(new String(cake[i]));
		}
		return result;
	}

	private static void fillCake(char c, int row, int column) {
		if (filledChars.contains(c)) return;
		boolean hasHorisontFill = false;
		boolean hasVerticalFill = false;
		int leftestFilled = column, rightestFilled = column, topFilled = row, downFilled = row;
		for (int j = column+1; j<cake[row].length; j++){
			if (cake[row][j] == '?') {
				cake[row][j]=c;
				hasHorisontFill =true;
				rightestFilled = j;
			} else {
				break;
			}
		}
		for (int j = column-1; j>=0; j--){
			if (cake[row][j] == '?') {
				cake[row][j]=c;
				hasHorisontFill =true;
				leftestFilled = j;
			} else {
				break;
			}
		}
		//vertical:
		if (!hasHorisontFill) {
			for (int i = row +1; i<cake.length; i++){
				if (cake[i][column] == '?') {
					cake[i][column]=c;
					hasVerticalFill = true;
				} else {
					break;
				}
			}
			for (int i = row-1; i >=0; i--){
				if (cake[i][column] == '?') {
					cake[i][column]=c;
					hasVerticalFill = true;
				} else {
					break;
				}
			}
		}
		
		if (hasHorisontFill) {
			int i = row;
			//int rowsBelow = 1;
			outerloop:
			for (int rowsBelow = 1; rowsBelow<=i; rowsBelow ++) {
				for (int j = leftestFilled; j<=rightestFilled; j++){
					if (cake[i-rowsBelow][j] != '?') {
						break outerloop;
					}
				}
				for (int j = leftestFilled; j<=rightestFilled; j++){
					cake[i-rowsBelow][j] = c;
				}
			}
			outerloop2:
			for (int rowsUp = 1; rowsUp+i<cake.length; rowsUp ++) {
				for (int j = leftestFilled; j<=rightestFilled; j++){
					if (cake[i+rowsUp][j] != '?') {
						break outerloop2;
					}
				}
				for (int j = leftestFilled; j<=rightestFilled; j++){
					cake[i+rowsUp][j] = c;
				}
			}
			filledChars.add(c);
		}
		
		
		
		
		
		
		
		
		
		
		
	}

}
