package source_root;

import java.text.DecimalFormat;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class CaseResolver {
	static int N;
	static int[][] cityMatrix;
	static int[] Dmax;
	static int[] S;
	static int Q;
	static int[][] pairs;
	
	public static String resolveCase(List<String> caseInput) {
		initData(caseInput);
		StringBuilder result = new StringBuilder();
		for (int i = 0; i<Q; i++) {
			result.append(" ").append(resolveCaseForPair(pairs[i][0], pairs[i][1]));
			
		}
		return result.toString();
	}	
	
	private static String resolveCaseForPair(int start, int end) {
		Set<Integer> visitedCities = new HashSet<Integer>();
		
		TreeSet<Double> times = new TreeSet<Double>();
		int currentCity = start;
		double time = 0;
		double currentHorseSpeed = S[start];
		int currentDistance = 0;
	
		timeToEnd(visitedCities, start, 0, end, currentHorseSpeed, 0, Dmax[start], times);
		
		
		return new DecimalFormat("0.000000").format(times.first()).replaceAll(",", ".");
	}

	static void timeToEnd(Set<Integer> visitedNodes, int currentNode, double currentTime,
			int end, double currentHorseSpeed, int currentHorseDistance, int maxDistance, Set<Double> times) {
		
		for (int j = 0; j < N; j++){
			if (cityMatrix[currentNode][j] == -1 || visitedNodes.contains(j)) {
				continue;
			} else if (j == end) {
				if (currentHorseDistance + cityMatrix[currentNode][j] < maxDistance) {
					currentHorseDistance =0;
					maxDistance = Dmax[currentNode];
					currentHorseSpeed = S[currentNode];
				} else if (currentHorseSpeed < S[currentNode]) {
					currentHorseDistance =0;
					maxDistance = Dmax[currentNode];
					currentHorseSpeed = S[currentNode];
				}
				currentTime  = currentTime + cityMatrix[currentNode][j]/currentHorseSpeed;
				times.add(currentTime);
				return;
			} else {
				if (currentHorseDistance + cityMatrix[currentNode][j] < maxDistance) {
					currentHorseDistance =0;
					maxDistance = Dmax[currentNode];
					currentHorseSpeed = S[currentNode];
				} else if (currentHorseSpeed < S[currentNode]) {
					currentHorseDistance =0;
					maxDistance = Dmax[currentNode];
					currentHorseSpeed = S[currentNode];
				}
				currentTime  = currentTime + cityMatrix[currentNode][j]/currentHorseSpeed;
				timeToEnd (visitedNodes, j, currentTime, end, currentHorseSpeed, currentHorseDistance, maxDistance, times);
			}
			return;
			
		}
		
		
	}
















	static void initData(List<String> caseInput){
		N = Integer.parseInt(caseInput.get(0).split(" ")[0]);
		Q = Integer.parseInt(caseInput.get(0).split(" ")[1]);
		
		cityMatrix = new int[N][N];
		Dmax = new int[N];
		S = new int[N];
		pairs = new int[Q][2];
		
		for (int i = 0; i< N; i++) {
			Dmax[i] = Integer.parseInt(caseInput.get(i+1).split(" ")[0]);
			S[i] = Integer.parseInt(caseInput.get(i+1).split(" ")[1]);
		}
		for (int i = 0; i< N; i++) {
			String[] splitRow = caseInput.get(i+1+N).split(" ");
			for (int j = 0; j<N; j++){
				cityMatrix[i][j] = Integer.parseInt(splitRow[j]);
			}
		}
		for (int i = 0; i< Q; i++) {
			pairs[i][0] = Integer.parseInt(caseInput.get(i+1+N+N).split(" ")[0]) - 1;
			pairs[i][1] = Integer.parseInt(caseInput.get(i+1+N+N).split(" ")[1]) - 1 ;
		}
	}
}
