package source_root;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

import org.apache.commons.io.FileUtils;
import org.apache.commons.io.IOUtils;

public class Main {
	private final static String FILES_ENCODING="UTF-8";
	private final static String LINE_ENDING=IOUtils.LINE_SEPARATOR_UNIX;
	private final static boolean APPEND_OUTPUT_FALSE = false;
	private final static File INPUT_FILE = new File("./resources/input.txt");
	private final static File OUTPUT_FILE = new File("./resources/output.txt");
	
	
	public static void main(String[] args) throws IOException {
		List<String> inputLines = FileUtils.readLines(INPUT_FILE, "UTF-8"); 
		List<String> outputLines = new LinkedList<String>(); 
		resolveTask(inputLines, outputLines);
		FileUtils.writeLines(OUTPUT_FILE, FILES_ENCODING, outputLines, LINE_ENDING, APPEND_OUTPUT_FALSE);
	}

	private static void resolveTask(List<String> inputLines, List<String> outputLines) {
		int numOfCases = Integer.parseInt(inputLines.get(0));
		String caseAnswer;
		int startLine = 1;
		
		for (int i =1; i<=numOfCases; i++){
			List<String> linesToResolve = new LinkedList<String>();
			linesToResolve.add(inputLines.get(startLine));
			int sequentLines = Integer.parseInt(inputLines.get(startLine).split(" ")[1]);
			for (int j = 1; j<=sequentLines; j++) linesToResolve.add(inputLines.get(startLine +j));
			caseAnswer = CaseResolver.resolveCase(linesToResolve);
			outputLines.add("Case #" + i + ": " + caseAnswer);
			startLine += sequentLines+1;
		}
	}
	
	



	


}
