package by.amitrofanov82.google.codeJam.apr_8_2017.task3;

import java.util.BitSet;

public class CaseResolver {
	public static String resolveCase(String caseInput) {
		long numOfStalls = Long.parseLong(caseInput.split(" ")[0]) +2L;
		long numOfGuests = Long.parseLong(caseInput.split(" ")[1]);
		//Won't work for 10^18 case
		BitSet stalls = new BitSet((int) (numOfStalls));
		stalls.set(0);
		stalls.set((int) (numOfStalls -1));
		int lastOccuppiedStallIdx =-1;
		for (int i=0; i< numOfGuests; i++) { 
			lastOccuppiedStallIdx = occupyNewStall(stalls);
		}	
		return ((maxNeighbourDistanceFromStall(stalls, lastOccuppiedStallIdx)-1) + " " 
				+ (minNeighbourDistanceFromStall(stalls, lastOccuppiedStallIdx)-1));
	}
	
	private static int occupyNewStall(BitSet stalls){
		int stallIdxToOccupy = 1;
		int closestNeighbourDistance = 1;
		int secondNeighbourDistance = 1;
		for (int i = stalls.length()-1-1; i >= 1; i--) {
			if (stalls.get(i)) {
				continue;
			}
			int currentMinDistance = minNeighbourDistanceFromStall(stalls, i);
			if (currentMinDistance > closestNeighbourDistance) {
				stallIdxToOccupy = i;
				closestNeighbourDistance = currentMinDistance;
				secondNeighbourDistance = maxNeighbourDistanceFromStall(stalls, i);
			} else if (currentMinDistance == closestNeighbourDistance) {
				if (maxNeighbourDistanceFromStall(stalls, i) >= secondNeighbourDistance) {
					stallIdxToOccupy = i;
					closestNeighbourDistance = currentMinDistance;
					secondNeighbourDistance = maxNeighbourDistanceFromStall(stalls, i);
				}
			}
		}
		stalls.set(stallIdxToOccupy);
		return stallIdxToOccupy;
	}
	
	private static int minNeighbourDistanceFromStall(BitSet stalls, int stallNum){
		int leftOccupiedStallIdx;
		//System.out.println(stalls.length());
		if (stallNum != 0) {
			leftOccupiedStallIdx = stalls.previousSetBit(stallNum-1); 
		} else {
			return 0;
		}
		int rightOccupiedStallIdx;		
		if (stallNum != stalls.length()-1) {
			rightOccupiedStallIdx = stalls.nextSetBit(stallNum+1); 
		} else {
			return 0;
		}
		return Math.min(stallNum-leftOccupiedStallIdx, rightOccupiedStallIdx-stallNum);
	}
	
	private static int maxNeighbourDistanceFromStall(BitSet stalls, int stallNum){
		int leftOccupiedStallIdx;
		//System.out.println(stalls.length());
		if (stallNum != 0) {
			leftOccupiedStallIdx = stalls.previousSetBit(stallNum-1); 
		} else {
			return 0;
		}
		int rightOccupiedStallIdx;		
		if (stallNum != stalls.length()-1) {
			rightOccupiedStallIdx = stalls.nextSetBit(stallNum+1); 
		} else {
			return 0;
		}
		return Math.max(stallNum-leftOccupiedStallIdx, rightOccupiedStallIdx-stallNum);
	}
	
	
	
}
