import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

import javax.print.attribute.standard.RequestingUserName;

public class RevengePancakes {
	String pancakes ;
	int caseNum ;
	final char HAPPY_SIDE = '+';
	final char BLANK_SIDE = '-';

	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		FileInputStream fis = null;
		BufferedReader br = null;
		try {
			fis = new FileInputStream("RevengePancakesIO"+File.separator+"B-small-attempt0.in");
			br = new BufferedReader(new InputStreamReader(fis));
		 
			String line = null;
			int totalCaseNum = 0 ; // total number of test cases
			
			if ((line = br.readLine()) != null)
				totalCaseNum = Integer.valueOf(line);
			
			for (int caseNum = 1 ; caseNum <= totalCaseNum ; caseNum++){
				if ((line=br.readLine())!=null){
					RevengePancakes rp = new RevengePancakes(caseNum, line);
					rp.startFlipping();
				}
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
			br.close();
		}
	}
	
	public RevengePancakes(int caseNum, String pancakes){
		this.pancakes = pancakes ;
		this.caseNum = caseNum ;
	}
	
	void startFlipping(){
		System.out.print("Case #"+caseNum+": ");
		int flipNum = 0 ; // number of flip operations
		if(pancakes.length()==1){
			if(isHappySide(pancakes.charAt(0))){
				System.out.println(0);
			}
			else
				System.out.println(1);
			return;
		}

		while (!isAllHappySides()){
			// pancakes position above/including this position will be picked and do flipping
			flipNum++ ;
			int pickFromPos = findDownMostBlankSidePosition();
			if(pickFromPos < 0)
				break;
//			System.out.println("pickFromPos="+pickFromPos); // for debug
			String topPile = pancakes.substring(0, pickFromPos+1);
			String bottomPile = pancakes.substring(pickFromPos+1);
//			System.out.println("topPile="+topPile+", bottomPile="+bottomPile);  // 
			String invertedTopPile = invertPile(topPile);
			pancakes = invertedTopPile.concat(bottomPile) ;
		}
		
		System.out.println(flipNum);
	}
	
	private int findDownMostBlankSidePosition() {
		// TODO Auto-generated method stub
		for (int position=pancakes.length() -1; position > -1 ; position--){
			if (pancakes.charAt(position)== BLANK_SIDE)
				return position;
		}
		return -1;
	}

	String invertPile(String pile){
		StringBuilder sb = new StringBuilder();
		for (int i= 0 ; i < pile.length() ; i++ ) {
			char pancake = pile.charAt(i);
			char reversedPancake = getReverseSide(pancake);
			sb.append(reversedPancake);
		}
		return sb.toString();
	}
	
	char getReverseSide(char pancake) {
		if (isHappySide(pancake))
			return BLANK_SIDE;
		else
			return HAPPY_SIDE;
	}
	
	boolean isHappySide(char pancake){
		if (pancake == HAPPY_SIDE)
			return true;
		else {
			return false;
		}
	}
	
	boolean isAllHappySides(){
		for (int i=0; i< pancakes.length() ; i++){
			if (pancakes.charAt(i)== BLANK_SIDE)
				return false;
		}
		return true ;
	}

}
