package algo;

import java.util.ArrayList;
import java.util.Scanner;

/**
 * WaterShed
 * @author ammatsun
 */
public class WaterShed {
    private static int[][] data;
    private static char[][] sink;
    private static int curr;

    /**
     * Run WaterShed.
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(System.in);
        int cases = sc.nextInt();
        for (int i = 0; i < cases; i++) {
            int h = sc.nextInt();
            int w = sc.nextInt();
            data = new int[h+2][w+2];
            for (int j = 1; j < h + 1; j++) {
                data[j][0] = 20000;
                data[j][w + 1] = 20000;
            }
            for (int k = 1; k < w + 1; k++) {
                data[0][k] = 20000;
                data[h + 1][k] = 20000;
            }
            for (int j = 1; j < h + 1; j++) {
                for (int k = 1; k < w + 1; k++) {
                    data[j][k] = sc.nextInt();
                }
            }
            compute(i + 1);
        }
    }

    private static void compute(int caseid) {
        sink = new char[data.length][data[0].length];
        curr = 0;
        for (int i = 1; i < data.length - 1; i++) {
            for (int j = 1; j < data[0].length - 1; j++) {
                ArrayList<Integer> sr = new ArrayList<Integer>();
                ArrayList<Integer> sc = new ArrayList<Integer>();
                findSink(i, j, sr, sc);
            }
        }
        System.out.println("Case #" + caseid + ":");
        for (int i = 1; i < data.length - 1; i++) {
            StringBuilder result = new StringBuilder();
            for (int j = 1; j < data[0].length - 1; j++) {
                if (1 < j) {
                    result.append(" ");
                }
                result.append(sink[i][j]);
            }
            System.out.println(result.toString());
        }
    }

    private static void findSink(int r, int c, ArrayList<Integer> sr, ArrayList<Integer> sc) {
        if ('\0' != sink[r][c]) {
            for (int i = 0; i < sr.size(); i++) {
                sink[sr.get(i)][sc.get(i)] = sink[r][c];
            }
            return;
        }
        if ((data[r][c] <= data[r-1][c]) && (data[r][c] <= data[r+1][c])
                && (data[r][c] <= data[r][c-1]) && (data[r][c] <= data[r][c+1])) {
            sink[r][c] = (char) ((int)'a' + curr);
            curr++;
            for (int i = 0; i < sr.size(); i++) {
                sink[sr.get(i)][sc.get(i)] = sink[r][c];
            }
            return;
        }
        int nextr = r - 1;
        int nextc = c;
        int min = data[r - 1][c];
        if ((data[r][c - 1] < min)) {
            nextr = r;
            nextc = c - 1;
            min = data[r][c - 1];
        }
        if ((data[r][c + 1] < min)) {
            nextr = r;
            nextc = c + 1;
            min = data[r][c + 1];
        }
        if ((data[r + 1][c] < min)) {
            nextr = r + 1;
            nextc = c;
            min = data[r + 1][c];
        }
        sr.add(r);
        sc.add(c);
        findSink(nextr, nextc, sr, sc);
    }
}

