
import java.io.FileReader;
import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.LinkedList;
import java.util.List;

public class Main {

    public static void main(String[] args) throws IOException {
        BufferedReader inputStream = null;
        PrintWriter outputStream = null;

        try {
            inputStream =
                    new BufferedReader(new FileReader("input.txt"));
            outputStream =
                    new PrintWriter(new FileWriter("output.txt"));

            String temp = new String("");
            String output = new String("");

            int numcases = Integer.parseInt(inputStream.readLine());

            for (int i = 0; i < numcases; i++) {
                String options[] = inputStream.readLine().split(" ");
                int maxLetters = Integer.parseInt(options[0]);
                int maxKeys = Integer.parseInt(options[1]);
                int totalLetters = Integer.parseInt(options[2]);
                String letters[] = inputStream.readLine().split(" ");
                ArrayList<Integer> freq = new ArrayList<Integer>();
                for (int j=0;j<letters.length; j++)
                {
                    freq.add(Integer.parseInt(letters[j]));
                }
                Collections.sort(freq);
                Collections.reverse(freq);
                
                int keysUsed = 0;
                int keyPresses = 0;
                int currentPress = 1;
                while ((freq.size() > 0))
                {
                    keyPresses += freq.get(0) * currentPress;
                    freq.remove(0);
                    keysUsed++;
                    if (keysUsed == maxKeys)
                    {
                        keysUsed = 0;
                        currentPress++;
                    }
                }
                //output = keyPresses;
                outputStream.println("Case #" + (i + 1) + ": " + keyPresses);
            }
        } finally {
            if (inputStream != null) {
                inputStream.close();
            }
            if (outputStream != null) {
                outputStream.close();
            }
        }
    }
}
