import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;


public class TrainTimetable {
	public static void main(String args[]) throws Exception{
		BufferedReader br = new BufferedReader(new FileReader("B-small-attempt2.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("B-small-attempt2.out"));
		int nCase = Integer.parseInt(br.readLine());
		for(int i=0;i<nCase;i++){
			int nATrain = 0;
			int nBTrain = 0;
			int turnaroundTime = Integer.parseInt(br.readLine());
			String[] tmp = br.readLine().split(" ");
			int nAB = Integer.parseInt(tmp[0]);
			int nBA = Integer.parseInt(tmp[1]);
			String[] tripAB = new String[nAB];
			Trip[] tripObjAB = new Trip[nAB];
			String[] tripBA = new String[nBA];
			Trip[] tripObjBA = new Trip[nBA];
			for(int j=0;j<nAB;j++){
				tripAB[j] = br.readLine();
				tripObjAB[j] = new Trip(tripAB[j]);
			}
			for(int j=0;j<nBA;j++){
				tripBA[j] = br.readLine();
				tripObjBA[j] = new Trip(tripBA[j]);
			}
			for(int j=0;j<nAB;j++){
				String trip = tripAB[j];
				// looking for BA trip that arrive time plus turnaroundTime less than start time.
				if(findArriveBeforeStart(trip,tripObjBA,turnaroundTime))
					nATrain++;
			}
			for(int j=0;j<nBA;j++){
				String trip = tripBA[j];
				// looking for BA trip that arrive time plus turnaroundTime less than start time.
				if(findArriveBeforeStart(trip,tripObjAB,turnaroundTime))
					nBTrain++;
			}
			
			pw.println("Case #"+(i+1)+": "+nATrain+" "+nBTrain);
		}
		pw.close();
	}
	
	private static boolean findArriveBeforeStart(String trip, Trip[] trips,
			int turnaroundTime) {
		
		String startTime = trip.split(" ")[0];
		String nearestTime = "00:00";
		Trip nearestTrip = null;
		for(int i=0;i<trips.length;i++){
			if(trips[i].mark){
		
				continue;
			}else{
				int diffTime = diffTimeInMinute(startTime,trips[i].arrive);
		
				if((diffTime>=0)&&(diffTime >= turnaroundTime)){
					diffTime = diffTimeInMinute(nearestTime,trips[i].arrive);
					if(diffTime<0){
						nearestTime = trips[i].arrive;
						nearestTrip = trips[i];
					}
				}
			}
		}
		if(nearestTrip != null){
		
			nearestTrip.mark = true;
			return false;
		}else{
			
			return true;
		}
	}
	private static int diffTimeInMinute(String time1, String time2){
		int time1Hr = Integer.parseInt(time1.split(":")[0]);
		int time1Min = Integer.parseInt(time1.split(":")[1]);
		int time2Hr = Integer.parseInt(time2.split(":")[0]);
		int time2Min = Integer.parseInt(time2.split(":")[1]);
		int diffHr = time1Hr - time2Hr;
		int diffMin = time1Min - time2Min;
		if(diffHr>0){
			if(diffMin>=0){
				return diffHr*60 + diffMin;
			}else{

				return (diffHr-1)*60+(60+time1Min - time2Min);
			}
		}else{
			if(diffMin <= 0){
				return (diffHr*60)+diffMin;
			}else{
				return (diffHr+1)*60 + (time1Min - (time2Min+60));
			}
		}
	}
}

class Trip{
	public String start;
	public String arrive;
	public boolean mark;
	Trip(String line){
		String[] tmp = line.split(" ");
		start = tmp[0];
		arrive = tmp[1];
	}
	public String toString(){
		return start+":"+arrive;
	}
}