import java.util.HashSet;
import java.util.Iterator;
import java.util.Scanner;
import java.util.Set;


public class CountingSheep {

  public static void main(String[] args) {
    long[] Ns = null;

    try (Scanner scanner = new Scanner(System.in)) {
      int T = scanner.nextInt();
      Ns = new long[T];

      for (int i = 0; i < T; i++) {
        Ns[i] = scanner.nextInt();
      }
    }

    Set<Integer> digits = new HashSet<>();
    for (int i = 0; i <= 9; i++) {
      digits.add(i);
    }

    for (int i = 0; i < Ns.length; i++) {
      long highestN = willSleep(Ns[i], 1, new HashSet<Integer>(digits));
      System.out.println(String.format("Case #%d: %s", i+1, highestN == -1 ? "INSOMNIA" : highestN));
    }

  }

  private static long willSleep(long N, int round, Set<Integer> remainingDigits) {
    if (N == 0) {
      return -1;
    } else if (next(N, round, remainingDigits)) {
      return N * round;
    } else {
      return willSleep(N, ++round, remainingDigits);
    }
  }

  private static boolean next(long N, int round, Set<Integer> remainingDigits) {
    long nextN = N * round;
    Iterator<Integer> itr = remainingDigits.iterator();
    while (itr.hasNext()) {
      if (contains(nextN, itr.next()))
        itr.remove();
    }
    return remainingDigits.isEmpty();
  }

  private static boolean contains(long n, int m) {
    return String.valueOf(n).contains(String.valueOf(m));
  }

}
