import java.math.BigInteger;
import java.util.Scanner;

public class CoinJam {
  public static void main(String[] args) {
    String[] Ss = null;
    try (Scanner scanner = new Scanner(System.in)) {
      int T = scanner.nextInt();
      Ss = new String[T];

      for (int i = 0; i < T; i++) {
        Ss[i] = scanner.nextInt() + " " + scanner.nextInt();
      }
    }

    for (int i = 0; i < Ss.length; i++) {
      String[] vals = Ss[i].split(" ");
      int N = Integer.valueOf(vals[0]);
      int J = Integer.valueOf(vals[1]);
      String[] jamCoins = findJamCoins(J, N);
      System.out.println(String.format("Case #%d:\n%s", i + 1, String.join("\n", jamCoins)));
    }

  }

  private static String[] findJamCoins(int j, int n) {
    String[] jamCoins = new String[j];
    int count = 0;
    int index = 0;
    while (count != j) {
      String number = next(n, index++);
      String[] divisors = findDivisors(number);
      if (divisors != null) {
        jamCoins[count++] = String.join(" ", number, String.join(" ", String.join(" ", divisors)));
      }
    }
    return jamCoins;
  }

  private static String next(int n, int index) {
    String bs = String.format("%" + (n - 2) + "s", BigInteger.valueOf(index).toString(2)).replace(' ', '0');
    return String.valueOf("1" + bs + "1");
  }

  private static String[] findDivisors(String number) {
    String[] arr = new String[9];
    for (int base = 2; base <= 10; base++) {
      double value = convert(number, base);
      long divisor = findNonTrivialDivisor(value);
      if (divisor == -1)
        return null;
      else
        arr[base - 2] = String.valueOf(divisor);
    }
    return arr;
  }

  private static double convert(String number, int base) {
    double value = 0;
    double coefficient = 1;
    for (int i = number.length() - 1; i >= 0; i--) {
      value += ((coefficient) * (number.charAt(i) == '0' ? 0 : 1));
      coefficient *= base;
    }
    return value;
  }

  private static long findNonTrivialDivisor(double number) {
    long divisor = -1;
    for (int i = 2; i <= Math.sqrt(number); i++) {
      if (number % i == 0)
        return i;
    }
    return divisor;
  }

}
