import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Task4new2 {

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        Task4new2 task4 = new Task4new2();
        for (int i = 1; i <= t; ++i) {
            int n = in.nextInt();
            int m = in.nextInt();
            char[][] grid = new char[n][n];
            int plusCount = 0;
            int exCount = 0;
            int oCount = 0;
            for (int j = 0; j < m; j++) {
                char curr = in.next().charAt(0);
                switch (curr) {
                    case '+':
                        plusCount++;
                        break;
                    case 'x':
                        exCount++;
                        break;
                    case 'o':
                        oCount++;
                        break;
                }
                int y = in.nextInt();
                int x = in.nextInt();
                grid[y - 1][x - 1] = curr;
            }
            task4.process(grid, i, plusCount, exCount, oCount);
        }
    }

    private void process(char[][] grid, int caseNr, int plusCount, int exCount, int oCount) {
        List<String> changes = new ArrayList<>();
        int i = 0;

        if (oCount < 1) {
            for (int k = 0; k < grid.length && oCount < 1; k++) {
                for (int j = 0; j < grid.length && oCount < 1; j++) {
                    if (possibleToReplaceWithO(k, j, grid)) {
                        switch (grid[k][j]) {
                            case '+':
                                plusCount--;
                                break;
                            case 'x':
                                exCount--;
                                break;
                        }
                        replaceWithO(grid, changes, k, j);
                        oCount++;
                    }
                }
            }
        }
        //All top Xs replace with Pluses
        for (int j = 1; j < grid.length; j++) {
            if (grid[i][j] == 'x') {
                if (possibleToReplaceWithPlus(i, j, grid)) {
                    replaceWithPlus(grid, changes, i, j);
                    plusCount++;
                    exCount--;
                }
            }
        }

        exCount = fillMissingX(grid, exCount, changes);
        plusCount = fillMissingP(grid, plusCount, changes);


        System.out.println("Case #" + caseNr + ": " + (oCount * 2 + exCount + plusCount) + " " + changes.size());
        for (String change : changes) {
            System.out.println(change);
        }
    }


    private void replaceWithEx(char[][] grid, List<String> changes, int i, int j) {
        grid[i][j] = 'x';
        changes.add('x' + " " + (i + 1) + " " + (j + 1));
    }


    private void replaceWithPlus(char[][] grid, List<String> changes, int i, int j) {
        grid[i][j] = '+';
        changes.add('+' + " " + (i + 1) + " " + (j + 1));
    }

    private void replaceWithO(char[][] grid, List<String> changes, int i, int j) {
        grid[i][j] = 'o';
        changes.add('o' + " " + (i + 1) + " " + (j + 1));
    }

    private boolean possibleToReplaceWithPlus(int i, int j, char[][] grid) {
        for (int k = 1; i + k < grid.length && j + k < grid.length; k++) {
            if (grid[i + k][j + k] == '+' || grid[i + k][j + k] == 'o') {
                return false;
            }
        }
        for (int k = 1; i + k < grid.length && j - k >= 0; k++) {
            if (grid[i + k][j - k] == '+' || grid[i + k][j - k] == 'o') {
                return false;
            }
        }
        for (int k = 1; i - k >= 0 && j + k < grid.length; k++) {
            if (grid[i - k][j + k] == '+' || grid[i - k][j + k] == 'o') {
                return false;
            }
        }
        for (int k = 1; i - k >= 0 && j - k >= 0; k++) {
            if (grid[i - k][j - k] == '+' || grid[i - k][j - k] == 'o') {
                return false;
            }
        }
        return true;
    }

    private boolean possibleToReplaceWithEx(int i, int j, char[][] grid) {
        for (int k = 1; i + k < grid.length; k++) {
            if (grid[i + k][j] == 'x' || grid[i + k][j] == 'o') {
                return false;
            }
        }
        for (int k = 1; j - k >= 0; k++) {
            if (grid[i][j - k] == 'x' || grid[i][j - k] == 'o') {
                return false;
            }
        }
        for (int k = 1; i - k >= 0; k++) {
            if (grid[i - k][j] == 'x' || grid[i - k][j] == 'o') {
                return false;
            }
        }
        for (int k = 1; j + k < grid.length; k++) {
            if (grid[i][j + k] == 'x' || grid[i][j + k] == 'o') {
                return false;
            }
        }
        return true;
    }

    private boolean possibleToReplaceWithO(int i, int j, char[][] grid) {
        return possibleToReplaceWithEx(i, j, grid) && possibleToReplaceWithPlus(i, j, grid);
    }

    private int fillMissingP(char[][] grid, int plusCount, List<String> changes) {
        //TOP
        int i = 0;
        for (int j = 0; j < grid.length; j++) {
            if (grid[i][j] == 0 && possibleToReplaceWithPlus(i, j, grid)) {
                replaceWithPlus(grid, changes, i, j);
                plusCount++;
            }
        }
        //BOTTOM
        i = grid.length - 1;
        for (int j = 0; j < grid.length; j++) {
            if (grid[i][j] == 0 && possibleToReplaceWithPlus(i, j, grid)) {
                replaceWithPlus(grid, changes, i, j);
                plusCount++;
            }
        }
        //REST
        for (i = 1; i < grid.length - 1; i++) {
            for (int j = 0; j < grid.length; j++) {
                if (grid[i][j] == 0 && possibleToReplaceWithPlus(i, j, grid)) {
                    replaceWithPlus(grid, changes, i, j);
                    plusCount++;
                }
            }
        }
        return plusCount;
    }

    private int fillMissingX(char[][] grid, int exCount, List<String> changes) {
        for (int i = 0; i < grid.length; i++) {
            for (int j = 0; j < grid.length; j++) {
                if (grid[i][j] == 0 && possibleToReplaceWithEx(i, j, grid)) {
                    replaceWithEx(grid, changes, i, j);
                    exCount++;
                }
            }
        }
        return exCount++;
    }
}
