package qualificationRound;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class TrainTimeTable {
	
	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		FileReader reader = new FileReader("test.in");
		BufferedReader bReader = new BufferedReader(reader);
		
		PrintWriter pWriter = new PrintWriter("test.out");
		
		int N = Integer.parseInt(bReader.readLine());
		for(int i =0; i<N; i++){
			int T = Integer.parseInt(bReader.readLine());
			String[] Ns = bReader.readLine().split(" ");
			int NA = Integer.parseInt(Ns[0]);
			int NB = Integer.parseInt(Ns[1]);
			TimeTuple[] tuples = new TimeTuple[NA+NB];
			for(int j=0; j<NA; j++){
				String[] times = bReader.readLine().split(" ");
				String[] timesDep = times[0].split(":");
				String[] timesArr = times[1].split(":");
				
				tuples[j] = new TimeTuple('A',Integer.parseInt(timesDep[0])*60+Integer.parseInt(timesDep[1]),Integer.parseInt(timesArr[0])*60+Integer.parseInt(timesArr[1]));
			}
			for(int j=0; j<NB; j++){
				String[] times = bReader.readLine().split(" ");
				String[] timesDep = times[0].split(":");
				String[] timesArr = times[1].split(":");
				
				tuples[j+NA] = new TimeTuple('B',Integer.parseInt(timesDep[0])*60+Integer.parseInt(timesDep[1]),Integer.parseInt(timesArr[0])*60+Integer.parseInt(timesArr[1]));
			}
			
			Arrays.sort(tuples);
			int resultA = 0;
			int resultB = 0;
			
			int covered = 0;
			while(covered<NA+NB){
				int firstUncovered = -1;
				int j;
				for(j=0; j<NA+NB; j++){
					if(!tuples[j].isCovered()){
						firstUncovered = j;
						covered++;
						tuples[firstUncovered].cover();
						if(tuples[firstUncovered].getSource()=='A')
							resultA++;
						else
							resultB++;
						break;
					}
				}
				while(j<NA+NB){
					//different sources and uncovered node
					if(tuples[j].getSource()!=tuples[firstUncovered].getSource() 
						&& !tuples[j].isCovered()
						&& tuples[firstUncovered].getArrival()+T <= tuples[j].getDeparture())
					{
						firstUncovered = j;
						tuples[firstUncovered].cover();
						covered++;
					}
					j++;
				}
			}
			
			pWriter.println("Case #" + (i+1)+ ": "+ resultA + " " + resultB);
//			System.out.println("Case #" + (i+1)+ ": "+ resultA + " " + resultB);

		}
		bReader.close();
		reader.close();
		
		pWriter.close();
	}

}
