package qualificationRound.savingTheUniverse;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Enumeration;
import java.util.Hashtable;

public class SavingTheUniverse {

	public static void main(String[] args) throws NumberFormatException, IOException {
		FileReader reader = new FileReader("test.in");
		BufferedReader bReader = new BufferedReader(reader);
		
		PrintWriter pWriter = new PrintWriter("test.out");
		
		int N = Integer.parseInt(bReader.readLine());
		for(int i =0; i<N; i++){
			int S = Integer.parseInt(bReader.readLine());
			Hashtable table = new Hashtable();
			String[] servers = new String[S];
			for(int j=0;j<S;j++){
				servers[j] = bReader.readLine(); 
				table.put(servers[j],new Integer(0));
			}
			
			int Q = Integer.parseInt(bReader.readLine());
	
			//initialize edges
			int[][] graph = new int[Q+1][Q+1];
			for(int m=0;m<=Q;m++)
				for(int n=0;n<=Q;n++)
					graph[m][n] = (m==n)? 0 : 1000000;
	
			//calcualte costs
			for(int k=0; k<Q; k++){
				String query = bReader.readLine();
				int lastPosition = ((Integer) table.remove(query)).intValue();
				table.put(query, new Integer(k+1));
				for(int m=lastPosition; m<k; m++)
				{
					for(int n=m+1;n<=k;n++)
						graph[m][n]=1;
				}
			}
			for(Enumeration e = table.keys();e.hasMoreElements();){
				String server = (String)(e.nextElement());
				int lastPosition = ((Integer)table.get(server)).intValue();
				for(int m=lastPosition; m<Q; m++)
				{
					for(int n=m+1;n<=Q;n++)
						graph[m][n]=1;
				}
			}
			
			int shortestPath[] = new int[Q+1];
			boolean visited[] = new boolean[Q+1];
			for(int j=0; j<=Q; j++){
				shortestPath[j] = graph[0][j];
				visited[j]=false;
			}
			visited[0]=true;
			
			 for(int j=1; j<Q; j++){
				 int min = 1000000;
				 int minNode = -1;
				 for(int k=1; k<=Q; k++){
					 if(!visited[k] && shortestPath[k]<min){
						 minNode = k;
						 min = shortestPath[k];
					 }
				 }
				 if(minNode==Q)
					 break;
				 visited[minNode] = true;
				 for(int k=1; k<=Q; k++){
					 if(!visited[k] && shortestPath[minNode]+graph[minNode][k] < shortestPath[k])
						 shortestPath[k] = shortestPath[minNode]+graph[minNode][k];
				 }
			 }
			pWriter.println("Case #" + (i+1)+ ": " + ((shortestPath[Q]<=0) ? 0 : (shortestPath[Q]-1)));

		}
		bReader.close();
		reader.close();
		
		pWriter.close();
	}

}
