import java.io.*;
import java.util.*;

public class B {

	String[] d;
	String[] l, sol;
	HashSet<String> used;

	boolean valid(char[] str, String guess, HashSet<Character> invalidChars) {

		if (str.length != guess.length())
			return false;

		for (int i = 0; i < guess.length(); i++) {
			if (invalidChars.contains(guess.charAt(i)))
				return false;
		}
		for (int i = 0; i < str.length; i++) {
			if (str[i] != '-') {
				if (str[i] != guess.charAt(i))
					return false;
			}
		}
		return true;
	}

	int cost(String guess, int list) {
		int cost = 0;
		HashSet<Character> invalidChars = new HashSet<Character>();
		char[] str = new char[guess.length()];
		Arrays.fill(str, '-');
		ArrayList<String> pd = new ArrayList<String>();
		char c = ' ';
		for (int i = 0; i < d.length; i++) {
			// have a look at dictionary, eliminate invlalid words
			if (d[i].length() == guess.length())
				pd.add(d[i]);
		}
		int count = 0;
		int k = 0;
		while (count != guess.length()) {
			ArrayList<String> ppd = new ArrayList<String>();
			for (int x = 0; x < pd.size(); x++) {
				if (valid(str, pd.get(x), invalidChars))
					ppd.add(pd.get(x));
			}
			pd = ppd;
			// choose character to guess
			boolean done = false;
			for (; !done && k < l[list].length(); k++) {
				c = l[list].charAt(k);
				for (int j = 0; !done && j < pd.size(); j++) {
					if (pd.get(j).contains(c + "")) {
						// found my char
						done = true;
					}
				}
			}
			// made a guess, calculate it's cost
			if (!guess.contains(c + "")) {
				cost++;
				invalidChars.add(c);
			} else {
				// valid, update str
				for (int i = 0; i < guess.length(); i++) {
					if (guess.charAt(i) == c) {
						str[i] = c;
						count++;
					}
				}
			}
		}
		return cost;
	}

	String getMax(int itr) {
		int max = -1;
		int maxid = -1;
		int val;
		for (int i = 0; i < d.length; i++) {
			val = cost(d[i], itr);
			if (val > max && !used.contains(d[i])) {
				max = val;
				maxid = i;
			}
		}
		return d[maxid];
	}

	void run() throws IOException {
		PrintWriter pw = new PrintWriter(new FileWriter("B.out"));
		Scanner s = new Scanner(new FileReader("B.in"));
		int t = s.nextInt();
		int n, m;
		for (int k = 1; k <= t; k++) {
			used = new HashSet<String>();
			n = s.nextInt();
			m = s.nextInt();
			d = new String[n];
			l = new String[m];
			sol = new String[m];
			while (n-- > 0) {
				d[d.length - n - 1] = s.next();
			}
			while (m-- > 0) {
				l[l.length - m - 1] = s.next();
			}

			// output here
			for (int i = 0; i < sol.length; i++) {
				sol[i] = getMax(i);
				used.add(sol[i]);
			}

			System.out.print("Case #" + k + ": ");
			pw.print("Case #" + k + ": ");
			for (int i = 0; i < l.length; i++) {
				if (i == 0) {
					System.out.print(sol[i]);
					pw.print(sol[i]);
				} else {
					System.out.print(" " + sol[i]);
					pw.print(" " + sol[i]);
				}
			}

			System.out.println();
			pw.println();

		}

		pw.close();
		s.close();

	}

	public static void main(String[] args) throws IOException {
		new B().run();
	}
}
