import java.io.*;
import java.util.Scanner;

public class Main {

	private static Cell[][] map;
	private static char[][] label;
	private static char current;


	public static  Cell getCell() {
		for (int i = 0; i < map.length; i++) {
			for (int j = 0; j < map[i].length; j++) {
				if (map[i][j].getMarker() == false)
					return map[i][j];
			}
		}
		return null;
	}

	

	public static void fill(Cell cell) {

		if (cell.getMarker())
			return;

		cell.setMarker(true);

		int r = cell.getRow();
		int c = cell.getColumn();

		int x = 0;
		int y = 0;
		int min = Integer.MAX_VALUE;

		if (r!=0 &&map[r - 1][c].getValue() < min) {
			min = map[r - 1][c].getValue();
			x = r - 1;
			y = c;
		}
		if (c!=0 && map[r][c - 1].getValue() < min) {
			min = map[r][c - 1].getValue();
			x = r;
			y = c - 1;
		}
		if ((c!=map[r].length-1)&&map[r][c + 1].getValue() < min) {
			min = map[r][c + 1].getValue();
			x = r;
			y = c + 1;
		}
		if ((r!=map.length-1)&&map[r + 1][c].getValue() < min) {
			min = map[r + 1][c].getValue();
			x = r + 1;
			y = c;
		}
		
		
		
		

		if (min >= cell.getValue()) {
			label[r][c] = current;
			current++;
			return;
		}

		fill(map[x][y]);
		if(label[x][y]=='\u0000')label[r][c] = current;
		else label[r][c] = label[x][y];
		
	}



	public static void readFile() throws IOException {
		Scanner s = new Scanner(new FileReader("B-large.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("B-large.out"));
		int t = s.nextInt();
		for (int i = 1; i <= t; i++) {
			int h = s.nextInt();
			int w = s.nextInt();

		 map = new Cell[h][w];
		 label = new char[h][w];
			for (int x = 0; x < map.length; x++) {
				for (int y = 0; y < map[x].length; y++) {
					Cell module = new Cell();
					module.setValue(s.nextInt());
					module.setColumn(y);
					module.setRow(x);
					map[x][y] = module;

				}
				

			}
			current = 'a';
			while(getCell()!=null)
			{
				fill(getCell());
				
			}
			
			pw.println("Case #"+i+":");
			for(int z = 0 ; z < label.length;z++)
			{
				for(int m = 0 ; m < label[z].length ; m++)
				{
					if(m!=label[z].length-1)pw.print(label[z][m]+" ");
					else pw.print(label[z][m]);
				}
				System.out.print('\n');
				pw.print('\n');
			}


		}
		pw.close();
	}

	public static void main(String[] args) throws NumberFormatException,
			IOException {
	
		readFile();
	}

}

class Cell {

	private int value;
	private int row;
	private char label;
	public char getLabel() {
		return label;
	}

	public void setLabel(char label) {
		this.label = label;
	}

	private int column;
	private boolean marker;

	public Cell(int value, int row, int column, boolean marker) {
		this.setValue(value);
		this.setRow(row);
		this.setColumn(column);
		this.setMarker(marker);
	}

	public Cell() {
		this(0, 0, 0, false);
	}

	public void setRow(int row) {
		this.row = row;
	}

	public int getRow() {
		return row;
	}

	public void setColumn(int column) {
		this.column = column;
	}

	public int getColumn() {
		return column;
	}

	public void setMarker(boolean marker) {
		this.marker = marker;
	}

	public boolean getMarker() {
		return marker;
	}

	public void setValue(int value) {
		this.value = value;
	}

	public int getValue() {
		return value;
	}

}
