import java.util.*;
import java.io.*;

public class A {

	int n;
	String[] ar;
	double[] sol;

	void solve() {
		double[] wp, owp, oowp;
		wp = new double[n];
		owp = new double[n];
		oowp = new double[n];

		// wp
		int total, fraction;
		for (int i = 0; i < n; i++) {
			// for each team, scan his string
			total = 0;
			fraction = 0;
			for (int j = 0; j < ar[i].length(); j++) {
				if (ar[i].charAt(j) != '.')
					total++;
				if (ar[i].charAt(j) == '1')
					fraction++;
			}
			wp[i] = fraction / (double) total;
		}
		// owp
		int num;
		double sum;
		for (int i = 0; i < n; i++) {
			// for each team
			num = 0;
			sum = 0.0;
			// scan the string
			for (int j = 0; j < ar[i].length(); j++) {
				if (ar[i].charAt(j) != '.') {
					
					double val = 0.0;
					total = 0;
					fraction = 0;
					for (int x = 0; x < ar[j].length(); x++) {
						if(x==i)continue;
						if (ar[j].charAt(x) != '.')
							total++;
						if (ar[j].charAt(x) == '1')
							fraction++;
					}
					val = fraction / (double) total;
					sum += val;// calculate the new wp here----------
					num++;
				}
			}
			owp[i] = sum / (double) num;
		}

		// oowp

		for (int i = 0; i < ar.length; i++) {
			// for each team
			num = 0;
			sum = 0.0;
			for (int j = 0; j < ar[i].length(); j++) {
				if (ar[i].charAt(j) != '.') {
					// an opponent
					sum += owp[j];
					num++;
				}
			}
			oowp[i] = sum / (double) num;
		}
		
		for(int i = 0 ; i < ar.length ;i++){
			//for each team
			sol[i] = 0.25 * wp[i] + 0.50 * owp[i] + 0.25 * oowp[i];
		}
		// OWP (Opponents' Winning Percentage) is the average WP of all your
		// opponents, after first throwing out the games they played against
		// you.
		// For example, if you throw out games played against team D, then team
		// B has WP = 0 and team C has WP = 0.5. Therefore team D has OWP = 0.5
		// * (0 + 0.5) = 0.25. Similarly, team A has OWP = 0.5, team B has OWP =
		// 0.5, and team C has OWP = 2/3.
		// OOWP (Opponents' Opponents' Winning Percentage) is the average OWP of
		// all your opponents. OWP is exactly the number computed in the
		// previous step.
		// For example, team A has OOWP = 0.5 * (0.5 + 2/3) = 7/12.
	}

	void run() throws IOException {
		Scanner s = new Scanner(new FileReader("A.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("A.out"));
		int t = s.nextInt();
		for (int k = 1; k <= t; k++) {
			n = s.nextInt();
			ar = new String[n];
			sol = new double[n];
			for (int i = 0; i < ar.length; i++) {
				ar[i] = s.next();
			}

			solve();
			//
			pw.println("Case #" + k + ":");
			for (int i = 0; i < ar.length; i++) {
				pw.println(sol[i]);
			}
		}
		pw.close();
		s.close();
	}

	public static void main(String[] args) throws IOException {
		new A().run();
	}
}
