import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;


public class CJProblem1 {

	public static void main(String[] args){
		String baseDir = "C:\\CodeJam\\Problem1\\";
	    String inputDir = baseDir + "s1.in";
	    String outputDir = baseDir + "s1.out";
	
		try 
		{
			// Set up reader and writer
			Scanner in = new Scanner(new FileReader(inputDir));
			PrintWriter out = new PrintWriter(outputDir);
			
			int T = in.nextInt();
			in.nextLine();
			for (int i = 0; i < T; i++)
			{
				out.print("Case #" + (i + 1) + ": ");
				Magic(in, out);
				out.println();
			}
			
			// Close everything
			// out.println();
			out.flush();
			out.close();
			in.close();
		}
		catch (FileNotFoundException Exception)
		{
			System.out.println("File not found!");
		}

	}
	
	// Main Function
	private static void Magic(Scanner in, PrintWriter out)
	{
		int N = in.nextInt();
		in.nextLine();
		
		ArrayList<String> stringList = new ArrayList<String>();
		
		for (int i = 0; i < N; i++)
		{
			stringList.add(in.nextLine());
		}
		
		String charOrder = "";
		int charOrderIndex = 0;
		String firstString = stringList.get(0);
		
		// Set charOrder for the first time
		for (int i = 0; i < firstString.length(); i++)
		{
			char currentChar = firstString.charAt(i);

			
			if (i == 0)
			{
				charOrder += currentChar;
			}
			else
			{
				if (charOrder.charAt(charOrderIndex) != currentChar)
				{
					charOrder += currentChar;
					charOrderIndex++;
				}
			}
		}
		
		// At this point we have the charOrder string set up!
		// Now we do the same for the rest of them
		for (int i = 1; i < N; i++)
		{
			String charOrderForCurrent = "";
			int charOrderForCurrentIndex = 0;			
			String currentString = stringList.get(i);
			
			// Set charOrder
			for (int j = 0; j < currentString.length(); j++)
			{
				char currentChar = currentString.charAt(j);

				
				if (j == 0)
				{
					charOrderForCurrent += currentChar;
				}
				else
				{
					if (charOrderForCurrent.charAt(charOrderForCurrentIndex) != currentChar)
					{
						charOrderForCurrent += currentChar;
						charOrderForCurrentIndex++;
					}
				}
			}
			
			if (!charOrder.equals(charOrderForCurrent))
			{
				out.print("Fegla Won");
				return;
			}
		}
		
		
		// Now get the differences between each string for each string, and add them up
		// EASY SOLUTION
		int charOrderDiffCount = 0;
		
		
		for (int index = 0; index < charOrder.length(); index++)
		{
			int firstStringIndex = stringList.get(0).indexOf(charOrder.charAt(index));
			int secondStringIndex = stringList.get(1).indexOf(charOrder.charAt(index));
			
			int firstStringCharCount = 0;
			int secondStringCharCount = 0;
			
			while (firstStringIndex < stringList.get(0).length() &&
					stringList.get(0).charAt(firstStringIndex) == charOrder.charAt(index))
			{
				firstStringIndex++;
				firstStringCharCount++;
			}
			
			while (secondStringIndex < stringList.get(1).length() &&
					stringList.get(1).charAt(secondStringIndex) == charOrder.charAt(index))
			{
				secondStringIndex++;
				secondStringCharCount++;
			}
			
			int diffCountForChar = firstStringCharCount - secondStringCharCount;
			
			if (diffCountForChar < 0)
			{
				diffCountForChar *= -1;
			}
			
			charOrderDiffCount += diffCountForChar;
		}
	
		out.print(charOrderDiffCount);
		// END OF EASY SOLUTION
	}

}
