import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;


public class CodeJam1 {
	
	public final static String badMagicianText = "Bad magician!";
	public final static String badVolunteerText = "Volunteer cheated!";

	public static void main(String[] args){
		String baseDir = "C:\\CodeJam\\Q1a\\";
	    String inputDir = baseDir + "s1a.in";
	    String outputDir = baseDir + "s1a.out";
	
		try 
		{
			// Set up reader and writer
			Scanner in = new Scanner(new FileReader(inputDir));
			PrintWriter out = new PrintWriter(outputDir);
			
			int T = in.nextInt();
			in.nextLine();
			for (int i = 0; i < T; i++)
			{
				out.print("Case #" + (i + 1) + ": ");
				Magic(in, out);
				out.println();
			}
			
			// Close everything
			// out.println();
			out.flush();
			out.close();
			in.close();
		}
		catch (FileNotFoundException Exception)
		{
			System.out.println("File not found!");
		}

	}
	
	// Main Function
	private static void Magic(Scanner in, PrintWriter out)
	{
		// Get first row selection index
		int firstNum = in.nextInt() - 1;
		int[][] firstArrangement = new int[4][4];
		
		// Get first arrangement
		for (int i = 0; i < firstArrangement.length; i++)
		{
			for (int j = 0; j < firstArrangement[0].length; j++)
			{
				firstArrangement[i][j] = in.nextInt();
			}
		}
		
		ArrayList<Integer> firstRowSelected = new ArrayList<Integer>();
		
		// Store selected row. 
		for (int i = 0; i < 4; i++)
		{
			firstRowSelected.add(firstArrangement[firstNum][i]);
		}
		
		int secondNum = in.nextInt() - 1;
		int[][] secondArrangement = new int[4][4];
		
		// Get second arrangement
		for (int i = 0; i < firstArrangement.length; i++)
		{
			for (int j = 0; j < firstArrangement[0].length; j++)
			{
				secondArrangement[i][j] = in.nextInt();
			}
		}
		
		//boolean badMagician = false;
		int[] filledInt = new int[4];
		int[] filled = {0, 0, 0, 0};
		
		for (int r = 0; r < secondArrangement.length; r++)
		{
			boolean numUsed = false;
			
			for (int c = 0; c < secondArrangement[0].length; c++)
			{
				if (firstRowSelected.contains(secondArrangement[r][c]))
				{
					if (!numUsed)
					{
						filledInt[r] = secondArrangement[r][c];
						numUsed = true;
						filled[r]++;
						firstRowSelected.remove((Integer) secondArrangement[r][c]);
					}
					else
					{
						filled[r]++;
					}
				}
			}
		}
		
		if (filled[secondNum] == 0)
		{
			out.print(badVolunteerText);
		}
		else if (filled[secondNum] > 1)
		{
			out.print(badMagicianText);
		}
		else
		{
			out.print(filledInt[secondNum]);
		}
	}
}
