import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;


public class CodeJam4 {

	public static void main(String[] args){
		String baseDir = "C:\\CodeJam\\Q4a\\";
	    String inputDir = baseDir + "s1a.in";
	    String outputDir = baseDir + "s1a.out";
	
		try 
		{
			// Set up reader and writer
			Scanner in = new Scanner(new FileReader(inputDir));
			PrintWriter out = new PrintWriter(outputDir);
			
			int T = in.nextInt();
			in.nextLine();
			for (int i = 0; i < T; i++)
			{
				out.print("Case #" + (i + 1) + ": ");
				Magic(in, out);
				out.println();
			}
			
			
			// Close everything
			// out.println();
			out.flush();
			out.close();
			in.close();
		}
		catch (FileNotFoundException Exception)
		{
			System.out.println("File not found!");
		}

	}
	
	// Main Function
	private static void Magic(Scanner in, PrintWriter out)
	{
		int N = in.nextInt();

		ArrayList<Integer> NaomisBlocks = new ArrayList<Integer>();
		ArrayList<Integer> KensBlocks = new ArrayList<Integer>();
		
		//Get Blocks from Naomi and Ken.
		for (int i = 0; i < N; i++)
		{
			NaomisBlocks.add((int) (in.nextFloat() * 100000));
		}
		
		for (int i = 0; i < N; i++)
		{
			KensBlocks.add((int) (in.nextFloat() * 100000));
		}
		
		Collections.sort(NaomisBlocks);
		Collections.sort(KensBlocks);
		
		// Deceitful War Counts:
		int NaomiIndexDeceitfulWar = 0;
		int KenIndexDeceitfulWar = 0;
		int NaomiScoreDeceitfulWar = 0;
		
		while (NaomiIndexDeceitfulWar < NaomisBlocks.size() && KenIndexDeceitfulWar < KensBlocks.size())
		{
			if (NaomisBlocks.get(NaomiIndexDeceitfulWar) > KensBlocks.get(KenIndexDeceitfulWar))
			{
				NaomiScoreDeceitfulWar++;
				KenIndexDeceitfulWar++;
				NaomiIndexDeceitfulWar++;
			}
			else if (NaomisBlocks.get(NaomiIndexDeceitfulWar) < KensBlocks.get(KenIndexDeceitfulWar))
			{
				NaomiIndexDeceitfulWar++;
			}
		}
		
		// War Counts:
		int NaomiIndex = 0;
		int KenIndex = 0;
		int KenScore = 0;
		
		while (NaomiIndex < NaomisBlocks.size() && KenIndex < KensBlocks.size())
		{
			if (NaomisBlocks.get(NaomiIndex) < KensBlocks.get(KenIndex))
			{
				KenScore++;
				KenIndex++;
				NaomiIndex++;
			}
			else if (NaomisBlocks.get(NaomiIndex) > KensBlocks.get(KenIndex))
			{
				KenIndex++;
			}
		}
		
		int NaomiWarScore = N - KenScore;
		
		// DWar Count :)
		out.print(NaomiScoreDeceitfulWar);
		// War Count :)
		out.print(" " + NaomiWarScore);
	}
}
