import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class BathroomStalls {

	public static void main(String[] args) {
		
		String[] arr;
		int n,k;
		try(BufferedReader br = new BufferedReader(new FileReader(args[0])) ) {
			try(BufferedWriter bw = new BufferedWriter(new FileWriter(args[1]))){
				String line = null;
				int testCases = Integer.parseInt(line = br.readLine());

				int linesRead = 0;
				while ((line = br.readLine()) != null) {
					arr = line.split(" ");
					n = Integer.parseInt(arr[0]);
					k = Integer.parseInt(arr[1]);

					//cretes array
					int[] stallsStatus = new int[n+2];
					stallsStatus[0] = 1;
					stallsStatus[n+1] = 1;

					linesRead++;

					for(int i=0;i<k-1;i++){
						Item it =	NextOptimalStall(stallsStatus,n);	
					}
					Item data = NextOptimalStall(stallsStatus, n);
					int l = data.rs - data.index -1;
					int r = data.index - data.ls -1;
					
					bw.write("Case #"+linesRead+": "+Math.max(l, r)+" "+Math.min(l, r));

					if(linesRead != testCases)
						bw.newLine();
				}
			}
		}
		catch (IOException e) {
			e.printStackTrace();
		}		
	}

	public static Item NextOptimalStall(int[] stallsStatus, int n)
	{
		int index = 0;
		ArrayList<Item> current = new ArrayList<>();
		int max = Integer.MIN_VALUE;
		for(int i=1;i<=n;i++)
		{
			if(stallsStatus[i]==1) continue;

			int ls = i;
			while(stallsStatus[ls]!=1)
			{
				ls--;
			}

			int rs = i;
			while(stallsStatus[rs]!=1)
			{
				rs++;
			} 

			if(max < Integer.min(i-ls, rs-i))
			{
				current = new ArrayList<>();
				max = Integer.min(i-ls, rs-i);
				current.add(new Item(ls,rs,i));
			}
			else if(max == Integer.min(i-ls, rs-i)){
				current.add(new Item(ls,rs,i));
			}
		}


		Item output = current.get(0);
		int maxinCurrent = Integer.MIN_VALUE;
		for(int i=0;i<current.size();i++)
		{
			Item item=current.get(i);
			if(maxinCurrent < Integer.max(Math.abs(item.ls-item.index), Math.abs(item.rs-item.index)))
			{
				output = item;
				maxinCurrent = Integer.max(Math.abs(item.ls-item.index), Math.abs(item.rs-item.index));
			}
		}
		stallsStatus[output.index] =1;
		return output;
	}
}

class Item
{
	int ls;
	int rs;
	int index;

	public Item(int l,int r,int i)
	{
		ls =l;
		rs=r;
		index =i;
	}
}
