package com.amyth.gc2012;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.BreakIterator;
import java.util.ArrayList;
import java.util.List;

public class ProblemA {

	/**
	 * @param args
	 * http://code.google.com/codejam/contest/1460488/dashboard
	 */
	
	private final static String INPUT_DIR_NM = "./Input/2012/";
	private final static String OUTPUT_DIR_NM = "./Output/2012/";
	private static Integer totalTestCase;
	private static ArrayList<String> dataList;
	private static List<String> replaceList;
	public static void main(String[] args) {
		String fileName = args[0];
		//Read and Create necessary data structures. 
		try {
			readAndBuild(INPUT_DIR_NM + fileName);
		}
		catch (IOException e) {
			e.printStackTrace();

		}
		//TODO Implement program logic
		buildProperties();
		List<String> outputList = play();
		
		
		//write in out file
		try{
			// Create file 
			FileWriter fstream = new FileWriter(OUTPUT_DIR_NM+args[0]+".out");
			BufferedWriter out = new BufferedWriter(fstream);
			for (int caseId = 0; caseId < totalTestCase; caseId++) {
				System.out.print("Case #" + (caseId+1) + ": ");
				System.out.println(outputList.get(caseId));
				out.write("Case #" + (caseId+1) + ": ");
				out.write(outputList.get(caseId)); 
				if(caseId != totalTestCase)
					out.newLine();
			}
//			Close the output stream
			out.close();
		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}
	
	private static void buildProperties(){

		// TODO Auto-generated method stub
		
		String text1 = "our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up qz";
		String text2 = "ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv zq";
		replaceList = new ArrayList<String>(26);
		for (int j = 0; j < 26; j++) {
			replaceList.add("");
			
		}
		int i=0;
		while(i<text2.length()){
			char c1 = text2.charAt(i);
			char c2 = text1.charAt(i);
			if(c1 == ' '){
				i++;
				continue;
			}
			int actualIndex = c1 - 97;
			if( replaceList.get(actualIndex) == null || replaceList.get(actualIndex).equals("")){
//				System.out.println(actualIndex+": "+c1+"->"+c2);
				replaceList.set(actualIndex, c2+"");
			}
			i++;
		}
		
		for (int j = 0; j < replaceList.size(); j++) {
			System.out.println(replaceList.get(j));
		}
	
	}
	
	private static List<String> play() {
		List <String> outList = new ArrayList<String>(totalTestCase);
		for(String data: dataList){
			int i=0;
			StringBuilder sb = new StringBuilder();
			while(i<data.length()){
				if(data.charAt(i) == ' '){
					i++;
					sb.append(" ");
					continue;
				}
				sb.append(replaceList.get(((int)data.charAt(i++)-97)));
			}
			outList.add(sb.toString());
		}
		
		return outList;
	}



		//Build input data structure
		private static void readAndBuild(String dataPath) throws IOException {
			File f = new File(dataPath);
			BufferedReader bf = new BufferedReader(new FileReader(f));
			String text = bf.readLine();

			if (text != null) {
//				first text will be number of test cases
				totalTestCase = Integer.valueOf(text);
				dataList = new ArrayList<String>(totalTestCase);
				do {
					text = bf.readLine();
					if (text != null) {
						dataList.add(text);
					}
				}while (text != null && !text.equals(""));
			}
		}

}
