package com.google.codejam.amyth;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.BreakIterator;
import java.util.ArrayList;
import java.util.List;

public class CandySplit {
	private final static String DIR_NM = "./candy/";
	private static Integer totalTestCase;
	private static ArrayList<ArrayList<Integer>> dataList;

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String fileName = args[0];

		try {
			readAndBuild(DIR_NM + fileName);
		}

		catch (IOException e) {
			e.printStackTrace();

		}
		
		try{
		    // Create file 
		    FileWriter fstream = new FileWriter(DIR_NM+args[0]+".out");
	        BufferedWriter out = new BufferedWriter(fstream);
	        for (int caseId = 1; caseId <= totalTestCase; caseId++) {
	        	int seanCandy = splitCandy(caseId);
			System.out.print("Case #" + caseId + ": ");
			if(seanCandy == 0){
				System.out.println("NO");
			}
			else {
				System.out.println(seanCandy);
			}
			out.write("Case #" + caseId + ": ");
			if(seanCandy == 0){
				out.write("NO");
			}
			else {
				out.write(seanCandy+""); //i hate this. need to convert in String
			}
			if(caseId != totalTestCase)
				out.newLine();
				
			}
//	      Close the output stream
	        out.close();
	    }catch (Exception e){//Catch exception if any
	      System.err.println("Error: " + e.getMessage());
	    }
		
	}
	private static int splitCandy(int caseId) {
		
		ArrayList<Integer> candies = dataList.get(caseId-1);
		Long totalSum = 0L;
		int xorValue=0;
		for (Integer candy : candies) {
			xorValue ^= candy;
			totalSum +=candy;
		}
		
		if(xorValue !=0)
			return 0;
		else{
			int patCandy = getMinValue(candies);
			return (int) (totalSum - patCandy);
		}
		//find the smallest number
//		return 0;
	}
	
	public static int getMinValue(List<Integer> numbers){  
	    int minValue = numbers.get(0);  
	    for(int i=1;i<numbers.size();i++){  
	        if(numbers.get(i) < minValue){  
	            minValue = numbers.get(i);  
	        }  
	    }  
	    return minValue;  
	}
	
	private static void readAndBuild(String dataPath) throws IOException {
		File f = new File(dataPath);
		int i = 0;
		BufferedReader bf = new BufferedReader(new FileReader(f));
		String text = bf.readLine();

		if (text != null) {
//			first text will be number of test cases
			totalTestCase = Integer.valueOf(text);
			dataList = new ArrayList<ArrayList<Integer>>(totalTestCase);
			ArrayList<Integer> testObj = null;
			int testObjLength=0;

			do {
				text = bf.readLine();
				if (text != null) {
					i++;
					if(i%2 !=0){
						testObjLength = Integer.valueOf(text);
						testObj = new ArrayList<Integer>(testObjLength);
						dataList.add(testObj);
					}else{
						BreakIterator bi = BreakIterator.getWordInstance();
						bi.setText(text);
						testObj.add(Integer.valueOf(text.substring(0, bi.next())));
						for(int j =1;j<testObjLength;j++){
							testObj.add(Integer.valueOf(text.substring(bi.next(), bi.next())));

						}
					}


				}
			}while (text != null && !text.equals(""));
			}
		}


}
