package com.google.codejam.amyth;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.BreakIterator;
import java.util.ArrayList;
import java.util.List;

public class BotTrust {
	private final static String DIR_NM = "./bot/";
	private static Integer totalTestCase;
	private static ArrayList<ArrayList<String>> dataList;
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String fileName = args[0];

		try {
			readAndBuild(DIR_NM + fileName);
		}

		catch (IOException e) {
			e.printStackTrace();

		}

		try{
			// Create file 
			FileWriter fstream = new FileWriter(DIR_NM+args[0]+".out");
			BufferedWriter out = new BufferedWriter(fstream);
			for (int caseId = 1; caseId <= totalTestCase; caseId++) {
				int optimumTime = calculateMoves(caseId);
				System.out.print("Case #" + caseId + ": ");
				System.out.println(optimumTime);
				out.write("Case #" + caseId + ": ");
				out.write(optimumTime+""); //i hate this. need to convert in String
				if(caseId != totalTestCase)
					out.newLine();

			}
//			Close the output stream
			out.close();
		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}

	}

	private static int calculateMoves(int caseId) {
		List<String> testList = dataList.get(caseId-1);
		Bot orange = new Bot(); orange.setName("O"); orange.setCurrPos(1);
		Bot blue = new Bot(); blue.setName("B"); blue.setCurrPos(1);
		Bot currBot = null;
		Bot previousBot = null;
		int optimumTime=0;
		// even number place is for bot name and odd one is for button number.
		for (int i=0;i<testList.size();i++) {
			String botName=testList.get(i++);
			if("B".equals(botName))
				currBot = blue;
			else
				currBot = orange;
			int buttonVal = Integer.valueOf(testList.get(i));
			if(i-1 == 0){ 
				//first move
				optimumTime += Math.abs(buttonVal - currBot.getCurrPos())+1;
				
			}else{
				if(previousBot.getName().equals(currBot.getName())){
					optimumTime += Math.abs(buttonVal - currBot.getCurrPos())+1;
				}else{
					//if(previousBot.getCurrPos() >= Math.abs(buttonVal-currBot.getCurrPos())){
					if((previousBot.getTargetTime()-currBot.getTargetTime() >= Math.abs(buttonVal-currBot.getCurrPos()))){
						optimumTime +=1;
					}else{
						if(buttonVal > currBot.getCurrPos())
							optimumTime += Math.abs(Math.abs(currBot.getTargetTime()- previousBot.getTargetTime()) + currBot.getCurrPos() - buttonVal)+1;
						else
							optimumTime += Math.abs(currBot.getCurrPos() - Math.abs(currBot.getTargetTime()- previousBot.getTargetTime())) - buttonVal +  1;
							
							//Math.abs(Math.abs((buttonVal - previousBot.getCurrPos()-1)) - currBot.getCurrPos())+1;  
					}
				}
			}
			currBot.setCurrPos(buttonVal);
			currBot.setTargetTime(optimumTime);
			previousBot = currBot;
			
		
		}
		return optimumTime;
	}

	private static void readAndBuild(String dataPath) throws IOException {
		File f = new File(dataPath);
		int i = 0;
		BufferedReader bf = new BufferedReader(new FileReader(f));
		String text = bf.readLine();

		if (text != null) {
//			first text will be number of test cases
			totalTestCase = Integer.valueOf(text);
			dataList = new ArrayList<ArrayList<String>>(totalTestCase);
			ArrayList<String> testObj = null;
			int totalMoves=0;

			do {
				text = bf.readLine();
				if (text != null) {
					i++;
					BreakIterator bi = BreakIterator.getWordInstance();
					bi.setText(text);
					totalMoves = Integer.valueOf(text.substring(0, bi.next()));
					testObj = new ArrayList<String>(totalMoves*2);
					dataList.add(testObj);
					for(int j =1;j<=totalMoves;j++){
						String botName 	= String.valueOf(text.substring(bi.next(), bi.next()));
						String button 	= String.valueOf(text.substring(bi.next(), bi.next()));
						testObj.add(botName);testObj.add(button);
					}
				}
			}while (text != null && !text.equals(""));
		}
	}


}

class Bot{
	private String name;
	private int currPos;
	private int targetTime;
	private List<Integer> moveList;
	public int getCurrPos() {
		return currPos;
	}
	public void setCurrPos(int currPos) {
		this.currPos = currPos;
	}
	public List<Integer> getMoveList() {
		return moveList;
	}
	public void setMoveList(List<Integer> moveList) {
		this.moveList = moveList;
	}
	public String getName() {
		return name;
	}
	public void setName(String name) {
		this.name = name;
	}
	public int getTargetTime() {
		return targetTime;
	}
	public void setTargetTime(int targetTime) {
		this.targetTime = targetTime;
	}

}
