package com.google.codejam.amyth;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.BreakIterator;
import java.util.ArrayList;

public class GoroSort {
	private final static String DIR_NM = "./goro/";
	private static Integer totalTestCase;
	private static ArrayList<ArrayList<Integer>> dataList;


	public static void main(String[] args) {
		String fileName = args[0];

		try {
			readAndBuild(DIR_NM + fileName);
		}

		catch (IOException e) {
			e.printStackTrace();

		}
		try{
		    // Create file 
		    FileWriter fstream = new FileWriter(DIR_NM+args[0]+".out");
	        BufferedWriter out = new BufferedWriter(fstream);
	        for (int caseId = 1; caseId <= totalTestCase; caseId++) {
			int totalProb = startGoroSort(caseId);
			System.out.print("Case #" + caseId + ": ");
			System.out.println(totalProb+".000000");
			out.write("Case #" + caseId + ": ");
			out.write(totalProb+".000000");
			if(caseId != totalTestCase)
				out.newLine();
			}
//	      Close the output stream
	        out.close();
	    }catch (Exception e){//Catch exception if any
	      System.err.println("Error: " + e.getMessage());
	    }


	}
	private static int startGoroSort(int caseId) {
		// TODO Auto-generated method stub
		ArrayList<Integer> probList = dataList.get(caseId-1);
		int hit=0;
		int smallest=probList.get(0);
		hit = sortMe(probList);//sortIt(probList,smallest,0); 
			
		return hit;
	}
	private static int sortMe(ArrayList<Integer> probList) {
		int shuffle=0;
		int perm=1;
		for(int i=0;i<probList.size();i++){
			if(probList.get(i)!= (i+1))
				shuffle ++;
		}
		/*for(int j=2;j<=shuffle;j++){
			perm *=j;
		}*/
		return shuffle;
	}
	private static int sortIt(ArrayList<Integer> probList, int smallest, int i) {
		int cost = 0;
		if(probList.size() == 1 || i >= (probList.size()-1)){
			return cost;
		}
		int index=i;
		int j;
		for( j=i+1;j < probList.size();j++){
			if(probList.get(j)<smallest){
				smallest=probList.get(j);
				index=j;
		}
		}
			
		if(index != i){
			int temp=probList.get(index);
			probList.set(index, probList.get(i));
			probList.set(i,temp);
			cost = 2;
		}
			
		
		return (cost + sortIt(probList, probList.get(i+1), ++i));
	}
	private static void readAndBuild(String dataPath) throws IOException {
		File f = new File(dataPath);
		int i = 0;
		BufferedReader bf = new BufferedReader(new FileReader(f));
		String text = bf.readLine();

		if (text != null) {
//			first text will be number of test cases
			totalTestCase = Integer.valueOf(text);
			dataList = new ArrayList<ArrayList<Integer>>(totalTestCase);
			ArrayList<Integer> testObj = null;
			int testObjLength=0;

			do {
				text = bf.readLine();
				if (text != null) {
					i++;
					if(i%2 !=0){
						testObjLength = Integer.valueOf(text);
						testObj = new ArrayList<Integer>(testObjLength);
						dataList.add(testObj);
					}else{
						BreakIterator bi = BreakIterator.getWordInstance();
						bi.setText(text);
						testObj.add(Integer.valueOf(text.substring(0, bi.next())));
						for(int j =1;j<testObjLength;j++){
							testObj.add(Integer.valueOf(text.substring(bi.next(), bi.next())));

						}
					}


				}
			}while (text != null && !text.equals(""));
			}
		}

	}
