package com.amyth.gc2012;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.BreakIterator;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class ProblemB {

	/**
	 * @param args
	 */

	private final static String INPUT_DIR_NM = "./Input/2012/";
	private final static String OUTPUT_DIR_NM = "./Output/2012/";
	private static Integer totalTestCase;
	private static ArrayList<ArrayList<Integer>> dataList;
	private static List<HashMap<Integer, Boolean>> possibleList = new ArrayList<HashMap<Integer,Boolean>>(31);
	private static List<HashMap<Integer, Boolean>> surpriseList = new ArrayList<HashMap<Integer,Boolean>>(31);
	private static List<HashMap<Integer, Boolean>> onlySurpriseList = new ArrayList<HashMap<Integer,Boolean>>(31);
	public static void main(String[] args) {
		String fileName = args[0];
		//Read and Create necessary data structures. 
		try {
			readAndBuild(INPUT_DIR_NM + fileName);
		}
		catch (IOException e) {
			e.printStackTrace();

		}
		//TODO Implement program logic
		buildProperties();
		List<Integer> outputList = play();


		//write in out file
		try{
			// Create file 
			FileWriter fstream = new FileWriter(OUTPUT_DIR_NM+args[0]+".out");
			BufferedWriter out = new BufferedWriter(fstream);
			for (int caseId = 0; caseId < totalTestCase; caseId++) {
				System.out.print("Case #" + (caseId+1) + ": ");
				System.out.println(outputList.get(caseId));
				out.write("Case #" + (caseId+1) + ": ");
				out.write(outputList.get(caseId)+""); 
				if(caseId != totalTestCase)
					out.newLine();
			}
			//			Close the output stream
			out.close();
		}catch (Exception e){//Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
	}




	private static List<Integer> play() {
		List<Integer> outList = new ArrayList<Integer>(totalTestCase);
		int k =0;
		for(ArrayList<Integer> data:dataList){
			int N = data.get(0);
			int S = data.get(1);
			int P = data.get(2);
			int possibleCount=0;
			int surpriseCount=0;
			int onlySupriseCount=0;
			for(int i=3;i<(N+3);i++){
				int p=0,s=0,os=0;
				int value = data.get(i);
				for(int j= P;j<=10;j++){

					if(getValue(possibleList, value, j)){
						p++;
						if(getValue(surpriseList, value, j)){
							s++;
							if(getValue(onlySurpriseList, value, j))
								os++;
						}
					}
				}
				
				/*if(p == os && S == 0)
					p=0;*/
				
				if(p>os)
					os=0;
				if(p>0)
					possibleCount +=1;
				if(s>0)
					surpriseCount +=1;
				if(os>0)
					onlySupriseCount +=1;
			}
			System.out.println("Case "+(k+1)+" possibleCount:"+possibleCount);
			System.out.println("Case "+(k+1)+" surpriseCount:"+surpriseCount);
			System.out.println("Case "+(k+1)+" onlySupriseCount:"+onlySupriseCount);
			if(S==0)
				possibleCount -= onlySupriseCount;
			if(onlySupriseCount > S)
				possibleCount -= S;
			outList.add(k++,possibleCount);
			System.out.println("Case "+(k)+" result: "+possibleCount);
		}
		return outList;
	}



	//Build input data structure
	private static void readAndBuild(String dataPath) throws IOException {
		File f = new File(dataPath);
		int i = 0;
		BufferedReader bf = new BufferedReader(new FileReader(f));
		String text = bf.readLine();

		if (text != null) {
			//				first text will be number of test cases
			totalTestCase = Integer.valueOf(text);
			dataList = new ArrayList<ArrayList<Integer>>(totalTestCase);
			ArrayList<Integer> testObj = null;

			do {
				text = bf.readLine();
				if (text != null) {
					BreakIterator bi = BreakIterator.getWordInstance();
					bi.setText(text);
					testObj = new ArrayList<Integer>(3);
					dataList.add(testObj);
					Integer N = Integer.valueOf(text.substring(0, bi.next()));
					testObj.add(N);
					Integer S = Integer.valueOf(text.substring(bi.next(), bi.next()));
					testObj.add(S);
					Integer P = Integer.valueOf(text.substring(bi.next(), bi.next()));
					testObj.add(P);
					for(int j=0;j<N;j++){
						Integer n = Integer.valueOf(text.substring(bi.next(), bi.next()));
						testObj.add(n);
					}

				}
			}while (text != null && !text.equals(""));
		}
	}


	private static void initializeMap(List<HashMap<Integer, Boolean>> dataList) {
		for(int i=0;i<31;i++){
			HashMap<Integer, Boolean> hm = new HashMap<Integer, Boolean>();
			dataList.add(i, hm);
		}
	}

	private static void createHashmap(List<HashMap<Integer, Boolean>> dataList,
			int i, int j) {
		HashMap<Integer, Boolean> hm = dataList.get(i);
		if(hm == null){
			hm = new HashMap<Integer, Boolean>();
			dataList.add(hm);
		}

		hm.put(j, true);
	}

	private static Boolean getValue(List<HashMap<Integer, Boolean>> dList, int n, int p) {
		return ((dList.get(n).get(p)==null)?false:(dList.get(n).get(p)));
	}

	private static void buildProperties(){

		initializeMap(possibleList);
		initializeMap(surpriseList);
		initializeMap(onlySurpriseList);
		for(int i = 0; i<=30; i++){
			System.out.println(i+":::::");
			for(int j = 0;j<=10;j++){
				Boolean onlySurprise = true;
				if(j*3 == i){
					System.out.println(j+","+j+","+j);
					createHashmap(possibleList, i, j);
					if(j<10 && j > 0){
					System.out.println(j+","+(j-1)+","+(j+1));
					createHashmap(possibleList, i, (j-1));
					createHashmap(possibleList, i, (j+1));
					createHashmap(surpriseList, i, (j+1));
					createHashmap(surpriseList, i, (j-1));
					}
					onlySurprise = false;

				}
				if(((3*j+3)==i) && j<9){
					System.out.println(j+","+(j+1)+","+(j+2));
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j+1));
					createHashmap(possibleList, i, (j+2));
					createHashmap(surpriseList, i, j);
				}
				if((3*j+4)==i){
					System.out.println(j+","+(j+2)+","+(j+2));
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j+2));
					createHashmap(surpriseList, i, j);
				}
				if((3*j+1) == i){
					System.out.println(j+","+(j)+","+(j+1));
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j+1));
					onlySurprise = false;

				}
				if((3*j+2) == i){
					System.out.println(j+","+(j)+","+(j+2));
					System.out.println(j+","+(j+1)+","+(j+1));
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j+1));
					createHashmap(possibleList, i, (j+2));
					createHashmap(surpriseList, i, j);
					createHashmap(surpriseList, i, (j+2));
					onlySurprise = false;
				}
				if((3*j-3) == i && i>0){
					System.out.println(j+","+(j-1)+","+(j-2));
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j-1));
					createHashmap(possibleList, i, (j-2));
					createHashmap(surpriseList, i, j);
					createHashmap(surpriseList, i, (j-2));
					//							createHashmap(onlySurpriseList, i, (j));
				}
				if((3*j-4) == i){
					System.out.println(j+","+(j-2)+","+(j-2));
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j-2));
					createHashmap(surpriseList, i, j);
					createHashmap(surpriseList, i, (j-2));
				}

				if((3*j-1) == i){
					System.out.println(j +","+(j)+","+(j-1));
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j-1));
					onlySurprise = false;
				}
				if((3*j-2) == i){
					System.out.println(j +","+(j-1)+","+(j-1));
					if(j>1)
						{
						System.out.println(j +","+(j)+","+(j-2));
						createHashmap(possibleList, i, (j-2));
						}
					createHashmap(possibleList, i, j);
					createHashmap(possibleList, i, (j-1));
					onlySurprise = false;
				}
				if(onlySurprise)
					createHashmap(onlySurpriseList, i, (j));
			}
		}
	}
}
