package com.google.qualificationround;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class BotTrust {

	public static void main(String[] args) throws NumberFormatException,
			IOException {
		boolean debug = false;
		BufferedReader br = new BufferedReader(
				new FileReader(new File(args[0])));

		int numberOfTestCases = Integer.valueOf(br.readLine());

		for (int testCaseCounter = 0; testCaseCounter < numberOfTestCases; testCaseCounter++) {
			String[] testCase = br.readLine().split(" ");
			int numberOfButtonsToPress = Integer.valueOf(testCase[0]);
			int buttonsPressed = 0;

			char[] sequence = new char[numberOfButtonsToPress];
			int[] buttonPositions = new int[numberOfButtonsToPress];
			int j = 0;

			List<Integer> buttonPositionsBotO = new ArrayList<Integer>();
			List<Integer> buttonPositionsBotB = new ArrayList<Integer>();

			for (int i = 1; i <= numberOfButtonsToPress * 2; i += 2) {
				sequence[j] = testCase[i].toCharArray()[0];
				buttonPositions[j] = Integer.valueOf(testCase[i + 1]);
				if (sequence[j] == 'O') {
					buttonPositionsBotO.add(buttonPositions[j]);
				} else {
					buttonPositionsBotB.add(buttonPositions[j]);
				}
				j = j + 1;

			}

			char currentBotColor = sequence[0];
			int currentLocationBotO = 1;
			int currentLocationBotB = 1;
			int buttonsPressedByBotO = 0;
			int buttonsPressedByBotB = 0;
			int stepsTaken = 0;
			int sequenceCounter = 0;
			while (!(buttonsPressed == numberOfButtonsToPress)) {
				currentBotColor = sequence[sequenceCounter++];
				if (currentBotColor == 'O') {
					int buttonPositionToPressForBotO = buttonPositionsBotO
							.get(buttonsPressedByBotO);
					int buttonPositionToPressForBotB = -100;
					if (buttonPositionsBotB.size() > 0
							&& buttonPositionsBotB.size() != buttonsPressedByBotB) {
						buttonPositionToPressForBotB = buttonPositionsBotB
								.get(buttonsPressedByBotB);
					}
					while (currentLocationBotO != buttonPositionToPressForBotO) {
						if (buttonPositionToPressForBotO < currentLocationBotO) {
							currentLocationBotO--;
						} else {
							currentLocationBotO++;
						}

						if (currentLocationBotB != buttonPositionToPressForBotB
								&& buttonPositionToPressForBotB != -100) {
							if (buttonPositionToPressForBotB < currentLocationBotB) {
								currentLocationBotB--;
							} else {
								currentLocationBotB++;
							}
						}
						stepsTaken++;

						if (debug) {
							System.out.println("Moved Bot O to:"
									+ currentLocationBotO
									+ " ; Moved Bot B to:"
									+ currentLocationBotB);
						}
					}
					if (currentLocationBotB != buttonPositionToPressForBotB
							&& buttonPositionToPressForBotB != -100) {
						if (buttonPositionToPressForBotB < currentLocationBotB) {
							currentLocationBotB--;
						} else {
							currentLocationBotB++;
						}
					}
					if (debug) {
						System.out.println("Pressed Button Bot O:"
								+ currentLocationBotO + " ; Moved Bot B to:"
								+ currentLocationBotB);
					}
					stepsTaken++;
					buttonsPressedByBotO++;
					buttonsPressed++;
				}

				if (currentBotColor == 'B') {
					int buttonPositionToPressForBotB = buttonPositionsBotB
							.get(buttonsPressedByBotB);
					int buttonPositionToPressForBotO = -100;
					if (buttonPositionsBotO.size() > 0
							&& buttonPositionsBotO.size() != buttonsPressedByBotO) {
						buttonPositionToPressForBotO = buttonPositionsBotO
								.get(buttonsPressedByBotO);
					}
					while (currentLocationBotB != buttonPositionToPressForBotB) {
						if (buttonPositionToPressForBotB < currentLocationBotB) {
							currentLocationBotB--;
						} else {
							currentLocationBotB++;
						}
						if (currentLocationBotO != buttonPositionToPressForBotO
								&& buttonPositionToPressForBotO != -100) {
							if (buttonPositionToPressForBotO < currentLocationBotO) {
								currentLocationBotO--;
							} else {
								currentLocationBotO++;
							}
						}
						stepsTaken++;

						if (debug) {
							System.out.println("Moved Bot O to:"
									+ currentLocationBotO
									+ " ; Moved Bot B to:"
									+ currentLocationBotB);
						}
					}
					if (currentLocationBotO != buttonPositionToPressForBotO
							&& buttonPositionToPressForBotO != -100) {
						if (buttonPositionToPressForBotO < currentLocationBotO) {
							currentLocationBotO--;
						} else {
							currentLocationBotO++;
						}
					}

					if (debug) {
						System.out.println("Moved BotO to:"
								+ currentLocationBotO
								+ " ; Pressed Button Bot B:"
								+ currentLocationBotB);
					}
					stepsTaken++;
					buttonsPressedByBotB++;
					buttonsPressed++;
				}

			}
			System.out.println("Case #" + (testCaseCounter + 1) + ": "
					+ stepsTaken);
		}

	}
}
