package com.google.qualificationround;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.List;

public class CandySpiltting {

	/**
	 * @param args
	 * @throws IOException
	 * @throws NumberFormatException
	 */
	public static void main(String[] args) throws NumberFormatException,
			IOException {
		boolean debug = false;
		BufferedReader br = new BufferedReader(
				new FileReader(new File(args[0])));

		int numberOfTestCases = Integer.valueOf(br.readLine());
		for (int testCaseCounter = 0; testCaseCounter < numberOfTestCases; testCaseCounter++) {
			int numberOfCandies = Integer.valueOf(br.readLine());
			String candyPrices[] = br.readLine().split(" ");
			BigInteger candyPricesLong[] = convertCandyPricesToLong(
					candyPrices, numberOfCandies);

			if (numberOfCandies == 2
					&& candyPricesLong[0].compareTo(candyPricesLong[1]) == 0) {
				System.out.println("Case #" + (testCaseCounter + 1) + ": "
						+ candyPricesLong[0]);
				continue;
			}

			int combinationCounter = candyPricesLong.length - 1;
			boolean found = false;
			while (combinationCounter >= 1 && !found) {
				List<SeansList> seansPile = CombinationGenerator.getSeansList(
						candyPricesLong, combinationCounter);

				for (int i = 0; i < seansPile.size(); i++) {
					SeansList aListOfSean = seansPile.get(i);
					PatricksList aListOfPatrick = getPatricksList(aListOfSean,
							candyPricesLong);

					BigInteger sum = aListOfSean.getSumPatrick();
					// System.out.println("Seans List: " + aListOfSean);
					// System.out.println("Patricks List: " + aListOfPatrick);
					// System.out.println("Sum Sean: " + sum);
					// System.out.println("Sum Patrick: "
					// + aListOfPatrick.getSum());
					if (sum.compareTo(aListOfPatrick.getSum()) == 0) {
						found = true;
						System.out.println("Case #" + (testCaseCounter + 1)
								+ ": " + aListOfSean.getSum() /*
															 * + " Seans list:"
															 * + aListOfSean +
															 * " Patricks list: "
															 * + aListOfPatrick
															 */);
						break;
					}
				}
				combinationCounter--;
			}

			if (!found) {
				System.out.println("Case #" + (testCaseCounter + 1) + ": "
						+ "NO");
			}
		}

	}

	private static PatricksList getPatricksList(List<SeansList> listOfSean,
			BigInteger[] candyPricesLong) {
		PatricksList patricksList = new PatricksList();
		for (int i = 0; i < candyPricesLong.length; i++) {
			if (!listOfSean.contains(candyPricesLong[i])) {
				patricksList.add(candyPricesLong[i]);
			}
		}
		return patricksList;
	}

	private static BigInteger[] convertCandyPricesToLong(String[] candyPrices,
			int numberOfCandies) {
		BigInteger candyPricesLong[] = new BigInteger[numberOfCandies];
		int i = 0;
		for (String candyPrice : candyPrices) {
			candyPricesLong[i++] = new BigInteger(candyPrice);
		}
		return candyPricesLong;
	}

}
