package com.kempf.algo.codejam2016;

import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

class Cl {
	private int J;
	private List<JamCoin> coins = new ArrayList<JamCoin>();

	void solve() throws IOException {
		System.out.println( "Case #1:" );
		generate( 32, J = 10000 );
	}

	private void generate( int len, int count ) {
		char[] jam = new char[ len ];
		jam[0] = '1';
		jam[len - 1] = '1';

		search( jam, 1, len - 1 );

		int np = 0;
		for ( JamCoin coin : coins ) {
			if ( np >= 300 ) {
				break;
			}
			List<Integer> nts = coin.nontrivial();

			if ( nts.size() == 9 ) {
				System.out.print( new BigInteger( new String( coin.jam ), 10 ) );

				for ( int nt : nts ) {
					System.out.print( " " + nt );
				}

				System.out.println();
				++np;
			}
		}
	}

	private void search( char[] num, int idx, int last1Idx ) {
		if ( idx == last1Idx ) {
			if ( check( num ) ) {
				coins.add( new JamCoin( num ) );
				--J;
			}
		} else if ( J > 0 ) {
			num[idx] = '0';
			search( num, idx + 1, last1Idx );
			num[idx] = '1';
			search( num, idx + 1, last1Idx );
		}
	}

	private boolean check( char[] num ) {
		String str = new String( num );

		for ( int b = 2; b <= 10; ++b ) {
			BigInteger based = new BigInteger( str, b );

			if ( based.isProbablePrime( 30 ) ) {
				return false;
			}
		}

		return true;
	}

	private class JamCoin {
		private char[] jam;

		public JamCoin( char[] num ) {
			jam = new char[ num.length ];
			System.arraycopy( num, 0, jam, 0, num.length );
		}

		public List<Integer> nontrivial() {
			List<Integer> nt = new ArrayList<Integer>();

			for ( int b = 2; b <= 10; ++b ) {
				BigInteger based = new BigInteger( new String( jam ), b );

				for ( int div = 2;; ++div ) {
					BigInteger bidiv = BigInteger.valueOf( div );

					if ( based.mod( bidiv ).equals( BigInteger.ZERO ) ) {
						nt.add( div );
						break;
					}

					if ( div > 10000000 ) {
						return nt;
					}
				}
			}

			return nt;
		}
	}

	public static void main( String args[] ) throws IOException {
		new Cl().solve();
	}

}
