package com.kempf.codejam.round2.A;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

class Main {
	private StringBuilder buffer = new StringBuilder( 16384 );

	private int R;
	private int C;
	private char[][] grid;

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		int T = reader.nextInt();

		for ( int t = 1; t <= T; ++t ) {
			buffer.append( "Case #" ).append( t ).append( ": " ).append( '\n' );
			R = reader.nextInt();
			C = reader.nextInt();
			grid = new char[ R ][];

			for ( int r = 0; r < R; ++r ) {
				grid[r] = reader.readln().trim().toCharArray();
			}

			fillVert();
			fillHor();

			for ( int r = 0; r < R; ++r ) {
				buffer.append( new String( grid[r] ) ).append( '\n' );
			}
		}

		System.out.print( buffer );
	}

	private void fillHor() {
		for ( int r = 0; r < R; ++r ) {
			for ( int c = 0; c < C; ++c ) {
				if ( grid[r][c] != '?' ) {
					fillLR( r, c );
				}
			}
		}
	}

	private void fillLR( int row, int col ) {
		char fill = grid[row][col];

		for ( int c = col - 1; c >= 0; --c ) {
			if ( grid[row][c] == '?' ) {
				grid[row][c] = fill;
			} else {
				break;
			}
		}

		for ( int c = col + 1; c < C; ++c ) {
			if ( grid[row][c] == '?' ) {
				grid[row][c] = fill;
			} else {
				break;
			}
		}
	}

	private void fillVert() {
		for ( int c = 0; c < C; ++c ) {
			for ( int r = 0; r < R; ++r ) {
				if ( grid[r][c] != '?' ) {
					fillUD( r, c );
				}
			}
		}
	}

	private void fillUD( int row, int col ) {
		char fill = grid[row][col];

		for ( int r = row - 1; r >= 0; --r ) {
			if ( grid[r][col] == '?' ) {
				grid[r][col] = fill;
			} else {
				break;
			}
		}

		for ( int r = row + 1; r < R; ++r ) {
			if ( grid[r][col] == '?' ) {
				grid[r][col] = fill;
			} else {
				break;
			}
		}
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}
			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	public static void main( String args[] ) throws IOException {
		new Main().solve();
	}

}
