package com.kempf.codejam.round1.C;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

class C {
	private StringBuilder buffer = new StringBuilder( 16384 );

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		int T = reader.nextInt();

		for ( int t = 0; t < T; ++t ) {
			buffer.append( "Case #" ).append( t + 1 ).append( ": " );
			int N = reader.nextInt();
			int K = reader.nextInt();

			boolean[] s = new boolean[ N + 2 ];
			s[0] = true;
			s[N + 1] = true;

			Dists ans = null;
			for ( int k = 0; k < K; ++k ) {
				Dists best = new Dists( 0, 0, 0 );

				for ( int i = 1; i <= N; ++i ) {
					if ( !s[i] ) {
						Dists pos = d( s, i );

						if ( pos.compareTo( best ) > 0 ) {
							best = pos;
						}
					}
				}

				s[best.idx] = true;
				if ( k == K - 1 ) {
					ans = best;
				}
			}

			buffer.append( ans.max() ).append( ' ' ).append( ans.min() ).append( '\n' );
		}

		System.out.print( buffer );
	}

	private Dists d( boolean[] s, int idx ) {
		int left = 0;

		for ( int i = idx - 1; i >= 0; --i ) {
			if ( s[i] ) {
				break;
			} else {
				++left;
			}
		}

		int right = 0;
		for ( int i = idx + 1; i < s.length; ++i ) {
			if ( s[i] ) {
				break;
			} else {
				++right;
			}
		}

		return new Dists( idx, left, right );
	}

	private static class Dists implements Comparable<Dists> {
		private int idx;
		private int left;
		private int right;

		public Dists( int idx, int left, int right ) {
			this.idx = idx;
			this.left = left;
			this.right = right;
		}

		public int min() {
			return Math.min( left, right );
		}

		public int max() {
			return Math.max( left, right );
		}

		@Override
		public int compareTo( Dists o ) {
			int minDif = min() - o.min();

			if ( minDif != 0 ) {
				return minDif;
			}

			int maxDif = max() - o.max();
			if ( maxDif != 0 ) {
				return maxDif;
			}

			return 0;
		}
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}
			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	public static void main( String args[] ) throws IOException {
		new C().solve();
	}

}
