package com.kempf.goog.qual;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.StringTokenizer;

public class Pancakes {

	public void solve( InputReader reader ) {
		int cases = reader.nextInt();

		for ( int i = 1; i <= cases; ++i ) {
			int diners = reader.nextInt();
			int[] flaps = new int[ diners ];

			for ( int j = 0; j < diners; ++j ) {
				flaps[j] = reader.nextInt();
			}

			System.out.println( String.format( "Case #%d: %d", i, timeDiners2( diners, flaps ) ) );
		}
	}

	private int timeDiners2( int diners, int[] flaps ) {
		int timeToBeat = getBiggest( flaps );
		int maxTime = timeToBeat;
		PriorityQueue<Integer> plates = new PriorityQueue<Integer>( 10, new LargestToSmallestLongComparator() );

		for ( int plate : flaps ) {
			plates.add( plate );
		}

		for ( int time = 1; time < maxTime; ++time ) {
			int stack = plates.remove();

			if ( stack <= 3 ) {
				break;
			}
			
			int next1 = stack / 2 + stack % 2;
			if ( next1 % 2 != 0 && next1 > 3 ) {
				++next1;
			}
			
			int next2 = stack - next1;

			plates.add( next1 );
			plates.add( next2 );

			int timeFromHere = plates.peek() + time;
			if ( timeFromHere < timeToBeat ) {
				timeToBeat = timeFromHere;
			}
		}

		return timeToBeat;
	}

	private static class LargestToSmallestLongComparator implements Comparator<Integer> {

		@Override
		public int compare( Integer o1, Integer o2 ) {
			return o2 - o1;
		}
	}

	private int timeDiners3( ) {
		
		return 0;
	}
	
	private int timeDiners( int diners, int[] flaps ) {
		int bigPlate = 0;
		int bestTime = getBiggest( flaps );
		int maxTime = bestTime;

		for ( int time = 1; time <= maxTime; ++time ) {
			bigPlate = flaps[0];
			int bigPlateIdx = 0;

			for ( int i = 1; i < flaps.length; ++i ) {
				if ( flaps[i] > bigPlate ) {
					bigPlate = flaps[i];
					bigPlateIdx = i;
				}
			}

			if ( bigPlate < 3 ) {
				break;
			}

			flaps[bigPlateIdx] = flaps[bigPlateIdx] / 2 + flaps[bigPlateIdx] % 2;
			int timeFromHere = time + getBiggest( flaps );

			if ( timeFromHere < bestTime ) {
				bestTime = timeFromHere;
			}
		}

		return bestTime;
	}

	private int getBiggest( int[] flaps ) {
		int biggest = flaps[0];

		for ( int i = 1; i < flaps.length; ++i ) {
			if ( flaps[i] > biggest ) {
				biggest = flaps[i];
			}
		}

		return biggest;
	}

	private static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( IOException e ) {
					throw new RuntimeException( e );
				}
			}
			return tokenizer.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt( next() );
		}
	}

	public static void main( String[] args ) throws FileNotFoundException {
		new Pancakes().solve( new InputReader( new FileInputStream( args[0] ) ) );
	}

}
