package com.kempf.algo.codejam2016;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

class A {
	private StringBuilder buffer = new StringBuilder( 16384 );

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		int cases = reader.nextInt();

		for ( int i = 1; i <= cases; ++i ) {
			buffer.append( "Case #" ).append( i ).append( ": " );
			int N = reader.nextInt();

			if ( N == 0 ) {
				buffer.append( "INSOMNIA\n" );
				continue;
			}

			int need = 10;
			int[] cts = new int[ 10 ];
			int j = 1;
			while ( need > 0 ) {
				int c = N * j;

				while ( c > 0 ) {
					int d = c % 10;

					if ( cts[d] == 0 ) {
						--need;
					}

					++cts[d];
					c /= 10;
				}

				if ( need == 0 ) {
					buffer.append( N * j ).append( '\n' );
				}
				++j;
			}
		}

		System.out.print( buffer );
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}

			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	static class FastIntInputReader {
		private BufferedReader reader;
		private int idx;
		private String next;
		private int len;

		public FastIntInputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
		}

		public void next() throws IOException {
			next = reader.readLine().trim();
			idx = 0;
			len = next.length();
		}

		public int nextInt() throws IOException {
			if ( next == null || idx >= len ) {
				next();
			}

			while ( idx < len && next.charAt( idx ) == ' ' ) {
				++idx;
			}

			int num = 0;
			char ch;
			boolean neg = false;
			while ( idx < len && ( ch = next.charAt( idx ) ) != ' ' ) {
				if ( ch == '-' ) {
					neg = true;
				} else {
					num *= 10;
					num += ch - 48;
				}

				++idx;
			}

			return neg ? -num : num;
		}
	}

	public static void main( String args[] ) throws IOException {
		new A().solve();
	}

}
