package com.kempf.codejam.round1.B;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

class B {
	private StringBuilder buffer = new StringBuilder( 16384 );

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		int T = reader.nextInt();

		for ( int t = 0; t < T; ++t ) {
			long N = reader.nextLong();
			buffer.append( "Case #" ).append( t + 1 ).append( ": " );
			long tidy = nextTidy( N );
			buffer.append( tidy ).append( '\n' );
		}

		System.out.print( buffer );
	}

	private long nextTidy( long N ) {
		while ( !isTidy( N ) ) {
			N = nextPossible( N );
		}

		return N;
	}

	private long nextPossible( long N ) {
		char[] ds = String.valueOf( N ).toCharArray();

		for ( int i = 0; i < ds.length - 1; ++i ) {
			if ( ds[i] > ds[i + 1] ) {
				--ds[i];

				for ( int k = i + 1; k < ds.length; ++k ) {
					ds[k] = '9';
				}

				return Long.parseLong( new String( ds ) );
			}
		}

		return N;
	}

	private boolean isTidy( long N ) {
		String n = String.valueOf( N );
		char right = n.charAt( 0 );

		for ( int i = 1, lim = n.length(); i < lim; ++i ) {
			char next = n.charAt( i );

			if ( right > next ) {
				return false;
			}

			right = next;
		}

		return true;
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}
			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	public static void main( String args[] ) throws IOException {
		new B().solve();
	}

}
