package com.kempf.algo.codejam2016;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

class Ds {
	private StringBuilder buffer = new StringBuilder( 16384 );

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		int cases = reader.nextInt();

		for ( int i = 1; i <= cases; ++i ) {
			int len = reader.nextInt();
			int complexity = reader.nextInt();
			int students = reader.nextInt();

			buffer.append( "Case #" ).append( i ).append( ':' );
			List<Long> cs = tilesToClean( len, complexity, students );

			for ( long c : cs ) {
				buffer.append( ' ' ).append( c );
			}

			buffer.append( '\n' );
		}

		System.out.print( buffer );
	}

	private List<Long> tilesToClean( int len, int complexity, int students ) {
		List<Long> cs = new ArrayList<Long>();
		cs.add( 1l );

		if ( len == 1 ) {
			return cs;
		}

		if ( complexity == 1 ) {
			for ( long i = 2; i <= len; ++i ) {
				cs.add( i );
			}

			return cs;
		}
		for ( int i = 1; i < len - 1; ++i ) {
			long idx = 0;

			for ( int level = 0; level < complexity - 1; ++level ) {
				idx += toTheLeftOnLevel( i, level, len, complexity );
			}

			cs.add( idx + i + 1 );
		}

		cs.add( (long) Math.pow( len, complexity ) );
		return cs;
	}

	protected long toTheLeftOnLevel( int idx, int level, int len, int complexity ) {
		long leaves = (long) Math.pow( len, complexity - level );

		return leaves / len * idx;
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}

			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	public static void main( String args[] ) throws IOException {
		new Ds().solve();
	}

}
