package com.kempf.algo.codejam2016;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

class Bs {
	private StringBuilder buffer = new StringBuilder( 16384 );

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		int cases = reader.nextInt();

		for ( int i = 1; i <= cases; ++i ) {
			char[] stack = reader.next().toCharArray();

			int flips = 0;
			Jack top = Jack.classify( stack[0] );
			int idx = 1;

			while ( idx < stack.length ) {
				Jack next = Jack.classify( stack[idx] );

				if ( next != top ) {
					++flips;
					top = next;
				}

				++idx;
			}

			if ( top == Jack.Plain ) {
				++flips;
			}

			buffer.append( "Case #" ).append( i ).append( ": " ).append( flips ).append( '\n' );
		}

		System.out.print( buffer );
	}

	private static enum Jack {
		Happy, Plain;

		public static Jack classify( char c ) {
			if ( c == '-' ) {
				return Plain;
			} else {
				return Happy;
			}
		}
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}

			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	static class FastIntInputReader {
		private BufferedReader reader;
		private int idx;
		private String next;
		private int len;

		public FastIntInputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
		}

		public void next() throws IOException {
			next = reader.readLine().trim();
			idx = 0;
			len = next.length();
		}

		public int nextInt() throws IOException {
			if ( next == null || idx >= len ) {
				next();
			}

			while ( idx < len && next.charAt( idx ) == ' ' ) {
				++idx;
			}

			int num = 0;
			char ch;
			boolean neg = false;
			while ( idx < len && ( ch = next.charAt( idx ) ) != ' ' ) {
				if ( ch == '-' ) {
					neg = true;
				} else {
					num *= 10;
					num += ch - 48;
				}

				++idx;
			}

			return neg ? -num : num;
		}
	}

	public static void main( String args[] ) throws IOException {
		new Bs().solve();
	}

}
