package com.kempf.algo.codejam2016;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

class Cs {
	private int J;
	private List<JamCoin> coins = new ArrayList<JamCoin>();

	void solve() throws IOException {
		System.out.println( "Case #1:" );
		generate( 16, J = 50 );
	}

	private void generate( int len, int count ) {
		byte[] jam = new byte[ len ];
		jam[0] = 1;
		jam[len - 1] = 1;

		search( jam, 1, len - 1 );

		for ( JamCoin coin : coins ) {
			System.out.print( toBase( coin.jam, 10 ) );
			for ( int nt : coin.nontrivial() ) {
				System.out.print( " " + nt );
			}

			System.out.println();
		}
	}

	private void search( byte[] num, int idx, int last1Idx ) {
		if ( idx == last1Idx ) {
			if ( check( num ) ) {
				coins.add( new JamCoin( num ) );
				--J;
			}
		} else if ( J > 0 ) {
			num[idx] = 0;
			search( num, idx + 1, last1Idx );
			num[idx] = 1;
			search( num, idx + 1, last1Idx );
		}
	}

	private boolean check( byte[] num ) {
		for ( int b = 2; b <= 10; ++b ) {
			long valInBase = toBase( num, b );

			if ( prime( valInBase ) ) {
				return false;
			}
		}

		return true;
	}

	private long toBase( byte[] num, int base ) {
		long valInBase = 0;
		long placeVal = 1;

		for ( int i = num.length - 1; i >= 0; --i ) {
			if ( num[i] == 1 ) {
				valInBase += num[i] * placeVal;
			}

			placeVal *= base;
		}

		return valInBase;
	}

	private boolean prime( long n ) {
		if ( n % 2 == 0 ) {
			return false;
		}

		int max = (int) Math.sqrt( n );
		for ( int i = 3; i <= max; i += 2 ) {
			if ( n % i == 0 ) {
				return false;
			}
		}

		return true;
	}

	private class JamCoin {
		private byte[] jam;

		public JamCoin( byte[] num ) {
			jam = new byte[ num.length ];
			System.arraycopy( num, 0, jam, 0, num.length );
		}

		public List<Integer> nontrivial() {
			List<Integer> nt = new ArrayList<Integer>();

			for ( int b = 2; b <= 10; ++b ) {
				long based = toBase( jam, b );

				for ( int div = 2;; ++div ) {
					if ( based % div == 0 ) {
						nt.add( div );
						break;
					}
				}
			}

			return nt;
		}
	}

	public static void main( String args[] ) throws IOException {
		new Cs().solve();
	}

}
