package com.kempf.codejam.round1.C;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

class C {
	private StringBuilder buffer = new StringBuilder( 16384 );
	private Dists[][] memo;

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		//		long s = System.currentTimeMillis();
		init( 2048 );
		//		System.out.println( System.currentTimeMillis() - s );

		int T = reader.nextInt();

		for ( int t = 0; t < T; ++t ) {
			buffer.append( "Case #" ).append( t + 1 ).append( ": " );
			int N = reader.nextInt();
			int K = reader.nextInt();

			Dists ans = assign( N, K );
			buffer.append( ans.max() ).append( ' ' ).append( ans.min() ).append( '\n' );
		}

		System.out.print( buffer );
	}

	private Dists assign( long N, long K ) {
		if ( K == 1 ) {
			long left = N / 2;
			long right = N / 2;

			if ( N % 2 == 0 ) {
				--left;
			}

			return new Dists( left, right );
		} else if ( N < memo.length ) {
			return memo[(int) N][(int) K];
		} else {
			long left = N / 2;
			long right = N / 2;

			if ( N % 2 == 0 ) {
				--left;
			}

			--K;
			if ( K == 1 ) {
				return assign( Math.max( left, right ), 1 );
			} else if ( K % 2 == 0 ) {
				Dists ld = assign( left, K / 2 );
				Dists rd = assign( right, K / 2 );

				if ( ld.compareTo( rd ) > 0 ) {
					return rd;
				} else {
					return ld;
				}
			} else {
				Dists ld = assign( left, K / 2 );
				Dists rd = assign( right, K / 2 + 1 );

				if ( ld.compareTo( rd ) > 0 ) {
					return rd;
				} else {
					return ld;
				}
			}
		}
	}

	private void init( int N ) {
		memo = new Dists[ N + 1 ][];

		for ( int n = 1; n <= N; ++n ) {
			boolean[] s = new boolean[ n + 2 ];
			s[0] = true;
			s[n + 1] = true;
			memo[n] = new Dists[ n + 1 ];

			for ( int k = 1; k <= n; ++k ) {
				Dists best = new Dists( 0, 0, 0 );

				for ( int i = 1; i <= n; ++i ) {
					if ( !s[i] ) {
						Dists pos = d( s, i );

						if ( pos.compareTo( best ) > 0 ) {
							best = pos;
						}
					}
				}

				s[best.idx] = true;
				memo[n][k] = best;
			}
		}
	}

	private Dists d( boolean[] s, int idx ) {
		int left = 0;

		for ( int i = idx - 1; i >= 0; --i ) {
			if ( s[i] ) {
				break;
			} else {
				++left;
			}
		}

		int right = 0;
		for ( int i = idx + 1; i < s.length; ++i ) {
			if ( s[i] ) {
				break;
			} else {
				++right;
			}
		}

		return new Dists( idx, left, right );
	}

	private static class Dists implements Comparable<Dists> {
		private int idx;
		private long left;
		private long right;

		public Dists( long left, long right ) {
			this( -1, left, right );
		}

		public Dists( int idx, long left, long right ) {
			this.idx = idx;
			this.left = left;
			this.right = right;
		}

		public long min() {
			return Math.min( left, right );
		}

		public long max() {
			return Math.max( left, right );
		}

		@Override
		public int compareTo( Dists o ) {
			long minDif = min() - o.min();

			if ( minDif != 0 ) {
				return minDif < 0 ? -1 : 1;
			}

			long maxDif = max() - o.max();
			if ( maxDif != 0 ) {
				return maxDif < 0 ? -1 : 1;
			}

			return 0;
		}
	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}
			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	public static void main( String args[] ) throws IOException {
		new C().solve();
	}

}
