import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;

class A {
	private StringBuilder buffer = new StringBuilder( 16384 );
	private static Digit[] order = new Digit[] { Digit.Zero, Digit.Two, Digit.Six, Digit.Eight, Digit.Four, Digit.One, Digit.Seven, Digit.Five,
			Digit.Three, Digit.Nine };

	void solve() throws IOException {
		InputReader reader = new InputReader( System.in );
		int cases = reader.nextInt();

		for ( int i = 1; i <= cases; ++i ) {
			String num = reader.next();
			int[] cts = cts( num );
			List<Integer> phone = new ArrayList<Integer>();

			for ( Digit d : order ) {
				int made = d.make( cts );

				if ( made > 0 ) {
					for ( int j = 0; j < made; ++j ) {
						phone.add( d.d );
					}
				}
			}

			Collections.sort( phone );
			buffer.append( "Case #" ).append( i ).append( ": " );
			for ( int d : phone ) {
				buffer.append( d );
			}

			buffer.append( '\n' );
		}

		System.out.print( buffer );
	}

	private int[] cts( String s ) {
		int[] cts = new int[ 26 ];

		for ( int i = 0, lim = s.length(); i < lim; ++i ) {
			++cts[s.charAt( i ) - 'A'];
		}

		return cts;
	}

	private static enum Digit {
		Zero( 0 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['Z' - 'A'], cts['E' - 'A'], cts['R' - 'A'], cts['O' - 'A'] } );
				cts['Z' - 'A'] -= made;
				cts['E' - 'A'] -= made;
				cts['R' - 'A'] -= made;
				cts['O' - 'A'] -= made;
				return made;
			}
		},
		One( 1 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['N' - 'A'], cts['E' - 'A'], cts['O' - 'A'] } );
				cts['N' - 'A'] -= made;
				cts['E' - 'A'] -= made;
				cts['O' - 'A'] -= made;
				return made;
			}
		},
		Two( 2 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['T' - 'A'], cts['W' - 'A'], cts['O' - 'A'] } );
				cts['T' - 'A'] -= made;
				cts['W' - 'A'] -= made;
				cts['O' - 'A'] -= made;
				return made;
			}
		},
		Three( 3 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['T' - 'A'], cts['H' - 'A'], cts['R' - 'A'], cts['E' - 'A'] / 2 } );
				cts['T' - 'A'] -= made;
				cts['H' - 'A'] -= made;
				cts['R' - 'A'] -= made;
				cts['E' - 'A'] -= made * 2;
				return made;
			}
		},
		Four( 4 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['F' - 'A'], cts['O' - 'A'], cts['R' - 'A'], cts['U' - 'A'] } );
				cts['F' - 'A'] -= made;
				cts['O' - 'A'] -= made;
				cts['R' - 'A'] -= made;
				cts['U' - 'A'] -= made;
				return made;
			}
		},
		Five( 5 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['F' - 'A'], cts['I' - 'A'], cts['V' - 'A'], cts['E' - 'A'] } );
				cts['F' - 'A'] -= made;
				cts['I' - 'A'] -= made;
				cts['V' - 'A'] -= made;
				cts['E' - 'A'] -= made;
				return made;
			}
		},
		Six( 6 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['S' - 'A'], cts['I' - 'A'], cts['X' - 'A'] } );
				cts['S' - 'A'] -= made;
				cts['I' - 'A'] -= made;
				cts['X' - 'A'] -= made;
				return made;
			}
		},
		Seven( 7 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['S' - 'A'], cts['E' - 'A'] / 2, cts['V' - 'A'], cts['N' - 'A'] } );
				cts['S' - 'A'] -= made;
				cts['E' - 'A'] -= made * 2;
				cts['V' - 'A'] -= made;
				cts['N' - 'A'] -= made;
				return made;
			}
		},
		Eight( 8 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['E' - 'A'], cts['I' - 'A'], cts['G' - 'A'], cts['H' - 'A'], cts['T' - 'A'] } );
				cts['E' - 'A'] -= made;
				cts['I' - 'A'] -= made;
				cts['G' - 'A'] -= made;
				cts['H' - 'A'] -= made;
				cts['T' - 'A'] -= made;
				return made;
			}
		},
		Nine( 9 ) {
			@Override
			public int make( int[] cts ) {
				int made = min( new int[] { cts['N' - 'A'] / 2, cts['I' - 'A'], cts['E' - 'A'] } );
				cts['N' - 'A'] -= made * 2;
				cts['I' - 'A'] -= made;
				cts['E' - 'A'] -= made;
				return made;
			}
		};

		private static int min( int[] pos ) {
			int min = Integer.MAX_VALUE;

			for ( int m : pos ) {
				if ( m < min ) {
					min = m;
				}
			}

			if ( min == Integer.MAX_VALUE ) {
				return 0;
			}
			return min;
		}

		public abstract int make( int[] cts );

		private int d;

		private Digit( int d ) {
			this.d = d;
		}

	}

	static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String readln() throws IOException {
			return reader.readLine();
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( Throwable e ) {
					return null;
				}

			}

			return tokenizer.nextToken();
		}

		public double nextDouble() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Double.parseDouble( next );
		}

		public long nextLong() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Long.parseLong( next );
		}

		public int nextInt() {
			String next = next();

			if ( next == null ) {
				return -1;
			}

			return Integer.parseInt( next );
		}
	}

	static class FastIntInputReader {
		private BufferedReader reader;
		private int idx;
		private String next;
		private int len;

		public FastIntInputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
		}

		public void next() throws IOException {
			next = reader.readLine().trim();
			idx = 0;
			len = next.length();
		}

		public int nextInt() throws IOException {
			if ( next == null || idx >= len ) {
				next();
			}

			while ( idx < len && next.charAt( idx ) == ' ' ) {
				++idx;
			}

			int num = 0;
			char ch;
			boolean neg = false;
			while ( idx < len && ( ch = next.charAt( idx ) ) != ' ' ) {
				if ( ch == '-' ) {
					neg = true;
				} else {
					num *= 10;
					num += ch - 48;
				}

				++idx;
			}

			return neg ? -num : num;
		}
	}

	public static void main( String args[] ) throws IOException {
		new A().solve();
	}

}
