package com.kempf.goog.qual;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class Opera {

	public void solve( InputReader reader ) {
		int cases = reader.nextInt();

		for ( int i = 1; i <= cases; ++i ) {
			int maxShy = reader.nextInt();
			int[] aud = new int[ maxShy + 1 ];
			char[] shyness = reader.next().toCharArray();

			for ( int j = 0; j <= maxShy; ++j ) {
				aud[j] = shyness[j] - '0';
			}

			System.out.println( String.format( "Case #%d: %d", i, getFriends( aud ) ) );
		}
	}

	private int getFriends( int[] aud ) {
		int standing = 0;
		int friends = 0;

		for ( int i = 0; i < aud.length; ++i ) {
			if ( aud[i] != 0 ) {
				int requiredStanding = i;

				if ( standing < requiredStanding ) {
					friends += requiredStanding - standing;
					standing = requiredStanding;
				}

				standing += aud[i];
			}
		}

		return friends;
	}

	private static class InputReader {
		private BufferedReader reader;
		private StringTokenizer tokenizer;

		public InputReader( InputStream stream ) {
			reader = new BufferedReader( new InputStreamReader( stream ) );
			tokenizer = null;
		}

		public String next() {
			while ( tokenizer == null || !tokenizer.hasMoreTokens() ) {
				try {
					tokenizer = new StringTokenizer( reader.readLine() );
				} catch ( IOException e ) {
					throw new RuntimeException( e );
				}
			}
			return tokenizer.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt( next() );
		}
	}

	public static void main( String[] args ) throws FileNotFoundException {
		new Opera().solve( new InputReader( new FileInputStream( args[0] ) ) );
	}

}
