import java.io.*;

/**
 * Created by anaghapanhalkar on 4/9/16.
 */
public class CountingSheep {
    private String fileName;


    public CountingSheep (String fileName){
        this.fileName = fileName;
    }

    private int check(boolean[] b){
        int ret = 0;
        for (int i=0;i<10;i++){
            if(b[i])
                ret++;
        }
        return ret;
    }

    private String count(long n){
        boolean[] digits = new boolean[10];
        long num = n;

        if(num == 0)
            return "INSOMNIA";

        while(true){
            /*If there is an overflow, just stop */
            if(num<=0)
                return "INSOMNIA";

            /* Separate the digits */
            long temp = num;
            while(temp!=0){
                digits[(int) (temp%10)] = true;
                temp = temp/10;
            }
            if(check(digits) == 10)
                return Long.toString(num);

            num=num+n;
        }
    }

    public void read(){
        BufferedReader br;
        PrintWriter writer;
        try {
            br = new BufferedReader(new FileReader(fileName));
            writer = new PrintWriter("data/output", "UTF-8");
            String line;
            line = br.readLine();
            int noOfCases = Integer.parseInt(line);

            for(int i=1;i<=noOfCases;i++){
                line = br.readLine();
                String sheep = count(Long.parseLong(line));
                //String[] result = line.split(" ");
                //int friends = count(Long.parseLong(result[1]));
                writer.println("Case #"+i+": "+sheep);
            }
            writer.close();
            br.close();

        } catch (FileNotFoundException e) {
            System.out.println("File not found!!");
        } catch (IOException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
    }

    public static void main(String[] str){

        CountingSheep countingSheep = new CountingSheep("data/A-small-attempt1.in");
        countingSheep.read();
    }
}
