import counting.sheep.InputCase;
import counting.sheep.InsomniaException;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.stream.Collectors;

public class CountingSheep {

    public void countSheep(String inputFile) throws IOException {
        InputCase inputCase = readInput(inputFile);
        StringBuffer sb = new StringBuffer();
        int index = 1;
        for (Long aNumber : inputCase.getNumbers()) {
            try {
                sb.append("Case #").append(index).append(": ");
                Long answer = resolve(aNumber);
                sb.append(answer).append("\n");
            } catch (InsomniaException e) {
                sb.append("INSOMNIA").append("\n");
            }
            index++;
        }
        Files.write(Paths.get("/Users/ana-mariamarcu/Downloads/output.txt"), Arrays.asList(sb.toString()));
    }

    public static void main(String[] args) throws IOException {
        new CountingSheep().countSheep("/Users/ana-mariamarcu/Downloads/A-small-attempt0.in.txt");
    }

    private Long resolve(Long aNumber) {
        if (aNumber == 0) {
            throw new InsomniaException();
        }
        String[] strings = aNumber.toString().split("");
        Set<String> digits = new HashSet<>(Arrays.asList(strings));
        Long newNumber = aNumber;
        for (int i = 2; digits.size() < 10; i++) {
             newNumber = i * aNumber;
            strings = newNumber.toString().split("");
            digits.addAll(Arrays.asList(strings));
        }
        return newNumber;
    }

    private InputCase readInput(String fileName) {
        try {
            List<String> lines = Files.readAllLines(Paths.get(fileName));
            long totalCases = Long.parseLong(lines.get(0));
            lines.remove(0);
            return new InputCase(totalCases, lines.stream().map(s -> Long.parseLong(s)).collect(Collectors.toList()));
        } catch (IOException e) {
            e.printStackTrace();
            System.out.println("Failure");
        }
        return null;
    }
}
