package dijkstra;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import codejam.TestCase;

public class Spelling {

	int matrix[][] = { 	{ 1, 0, 5, 6, 7, 2, 3, 4 }, 
						{ 0, 1, 2, 3, 4, 5, 6, 7 },
						{ 5, 2, 0, 4, 6, 1, 7, 3 }, 
						{ 6, 3, 7, 0, 2, 4, 1, 5 },
						{ 7, 4, 3, 5, 0, 6, 2, 1 }, 
						{ 2, 5, 1, 7, 3, 0, 4, 6 },
						{ 3, 6, 4, 1, 5, 7, 0, 2 }, 
						{ 4, 7, 6, 2, 1, 3, 5, 0 } };

	Map<Character, Integer> map = new HashMap<Character, Integer>();
	List<SpellingTestCase> testCases = new ArrayList<SpellingTestCase>();

	public static void main(String[] args) {

		Spelling s = new Spelling();
		s.map.put('i', 2);
		s.map.put('j', 3);
		s.map.put('k', 4);
		
		s.start();s.compute();
	}

	private void start() {

		try {
			System.out.println("Reading test cases");
			InputStream inputFile = this.getClass().getResourceAsStream(
					"/C-small-attempt0.in");
			BufferedReader br = new BufferedReader(new InputStreamReader(
					inputFile));
			String line = br.readLine().trim();
			int numTestCases = Integer.parseInt(line);
			String fields[];

			for (int i = 0; i < numTestCases; i++) {
				line = br.readLine().trim();
				fields = line.split("\\s");
				SpellingTestCase t = new SpellingTestCase();
				t.repeat = Integer.parseInt(fields[1]);
				t.size = Integer.parseInt(fields[0]);
				line = br.readLine().trim();
				t.s = line;
				testCases.add(t);
			}
			System.out.println("Done reading test cases");

		} catch (Exception e) {
			System.err.println("There was a problem reading the input file.");
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void compute() {
		int index = 0;
		StringBuilder results = new StringBuilder();

		for (SpellingTestCase t : this.testCases) {
			boolean isPos = this.isPossible(t.s, t.repeat);
			if (isPos)
				results.append("Case #" + (index + 1) + ": YES\n");
			else
				results.append("Case #" + (index + 1) + ": NO\n");
			index++;
		}
		writeToFile(results.toString());
	}

	boolean isPossible(String s, int l) {

		int prod = 1;
		int size = s.length();
		List<Integer> iPos = new ArrayList<Integer>();
		List<Integer> kPos = new ArrayList<Integer>();

		for (int i = 1; i <= l; i++) {
			for (int j = 0; j < s.length(); j++) {
				char c = s.charAt(j);
				prod = matrix[prod][this.map.get(c)];
				if (prod == 2)
					iPos.add((i - 1) * size + (j + 1));
			}
		}

		if (prod != 0)
			return false;

		prod = 1;
		for (int i = 1; i <= l; i++) {
			for (int j = s.length() - 1; j >= 0; j--) {
				char c = s.charAt(j);
				prod = matrix[this.map.get(c)][prod];
				if (prod == 4) {
					kPos.add((l - i) * size + (j + 1));
				}
			}
		}

		boolean isPossible = false;
		if (iPos.size() != 0 && kPos.size() != 0) {
			if (iPos.get(0) + 1 < kPos.get(0))
				isPossible = true;
		}
		return isPossible;
	}

	private void writeToFile(final String results) {
		try {
			System.out.println("Writing to file");
			FileWriter fileWriter = new FileWriter(new File("C-small-attempt0.out"));
			fileWriter.write(results);
			fileWriter.close();
			System.out.println("Done writing to file");
		} catch (IOException e) {
			System.err.println("There was a problem writing the output file.");
			e.printStackTrace();
			System.exit(1);
		}
	}
}
