package codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Ovation {
	
	List<TestCase> testCases = new ArrayList<TestCase>();
	
	public static void main(String args[]) {
		Ovation a = new Ovation();
		a.start();
		a.compute();
		
	}

	private void start() {

		try {
			System.out.println("Reading test cases");
			InputStream inputFile = this.getClass().getResourceAsStream(
					"/A-large.in");
			BufferedReader br = new BufferedReader(new InputStreamReader(
					inputFile));
			String line = br.readLine().trim();
			int numTestCases = Integer.parseInt(line);
			String fields[];
			
			for (int i = 0; i < numTestCases; i++) {
				line = br.readLine().trim();
				fields = line.split("\\s");
				TestCase t = new TestCase();
				t.maxShyLevel = Integer.parseInt(fields[0]);
				t.shyDist = new int[t.maxShyLevel + 1];
				int index = 0;
				for (char c : fields[1].toCharArray()) {
					t.shyDist[index++] = Character.getNumericValue(c);
				}
				testCases.add(t);
			}
			System.out.println("Done reading test cases");
			
		} catch (Exception e) {
			System.err.println("There was a problem reading the input file.");
			e.printStackTrace();
			System.exit(1);
		}
	}
	
	private void compute(){
		int index = 0 ;
		StringBuilder results = new StringBuilder();
		for(TestCase t : this.testCases){
			int tot = findMinimalNumber(t.shyDist);
			results.append("Case #"+ (index+1) + ": " + tot +"\n");
			index++;
		}
		writeToFile(results.toString());
	}

	int findMinimalNumber(int[] S) {
		int maxS = S.length - 1;
		int currOvation = S[0], lastShyLevel = 0;
		int tot = 0;
		for (int i = 1; i < S.length; i++) {
			int diff = i - currOvation;
			if (diff > 0) {
				tot += diff;
				currOvation += diff + S[i];
			} else {
				currOvation += S[i];
			}
		}
		return tot;
	}
	
	private void writeToFile(final String results) {
		try {
			System.out.println("Writing to file");
			FileWriter fileWriter = new FileWriter(new File("A-large.out"));
			fileWriter.write(results);
			fileWriter.close();
			System.out.println("Done writing to file");
		} catch (IOException e) {
			System.err.println("There was a problem writing the output file.");
			e.printStackTrace();
			System.exit(1);
		}
	}
}
