/*
 * Anand Oza
 * Apr 27, 2012
 */

import java.util.*;
import java.io.*;

public class B_KingdomRush {
	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();
		BufferedReader reader = new BufferedReader(new FileReader("B_KingdomRush.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B_KingdomRush.out")));
		StreamTokenizer in = new StreamTokenizer(reader);

		in.nextToken();
		int T = (int) in.nval;
		for (int testcase = 1; testcase <= T; testcase++) {
			int ans = 0;
			in.nextToken();
			int N = (int) in.nval;
			int[] A = new int[N];
			int[] B = new int[N];
			for (int i = 0; i < N; i++) {
				in.nextToken();
				A[i] = (int) in.nval;
				in.nextToken();
				B[i] = (int) in.nval;
			}

			Level[] levels = new Level[N];
			for (int i = 0; i < N; i++)
				levels[i] = new Level(A[i], B[i], i);
			Level[] byA = new Level[N];
			for (int i = 0; i < N; i++)
				byA[i] = new Level(A[i], B[i], i);
			Level[] byB = new Level[N];
			for (int i = 0; i < N; i++)
				byB[i] = new Level(A[i], B[i], i);

			Arrays.sort(byA, sortByA);
			Arrays.sort(byB, sortByB);

//			System.out.println(Arrays.toString(levels));
//			System.out.println(Arrays.toString(byA));
//			System.out.println(Arrays.toString(byB));

			// int a = 0;
			int b = 0;

			int[] stars = new int[N];
			Arrays.fill(stars, 2);
			int score = 0;

			while (score < 2 * N) {
				boolean stuck = true;
				while (b < N && byB[b].b <= score) {
					score += stars[byB[b].i];
					stars[byB[b].i] = 0;
					b++;
					ans++;
					stuck = false;
				}
				// System.out.format("%4d %4d %4d%n", a, b, score);
				// if (a < N && byA[a].a <= score) {
				// if (stars[byA[a].i] == 2) {
				// score++;
				// stars[byA[a].i] = 1;
				// ans++;
				// }
				// a++;
				// stuck = false;
				// }
				for (int a = N - 1; a >= 0; a--) {
					if (stars[byB[a].i] == 2 && byB[a].a <= score) {
						score++;
						stars[byB[a].i] = 1;
						ans++;
						stuck = false;
						break;
					}
				}
				// System.out.format("%4d %4d %4d%n", a, b, score);
				if (stuck) {
					ans = -1;
					break;
				}
			}

			out.format("Case #%d: %s%n", testcase, (ans == -1) ? "Too Bad" : ans);
		}

		out.close();
		System.out.println("Time (ms): " + (double) (System.nanoTime() - startTime) / 1000000);
		System.exit(0);
	}

	private static class Level {
		int a;
		int b;
		int i;

		public Level(int a, int b, int i) {
			this.a = a;
			this.b = b;
			this.i = i;
		}

		public String toString() {
			return String.format("(%d, %d, %d)", a, b, i);
		}
	}

	private static Comparator<Level> sortByA = new Comparator<Level>() {
		public int compare(Level o1, Level o2) {
			if (o1.a != o2.a)
				return o1.a - o2.a;
			return -sortByB.compare(o1, o2);
		}
	};
	private static Comparator<Level> sortByB = new Comparator<Level>() {
		public int compare(Level o1, Level o2) {
			return o1.b - o2.b;
		}
	};
}