/*
 * Anand Oza
 * Apr 14, 2012
 */

import java.util.*;
import java.io.*;

public class A_SpeakingInTongues {
	private static final char[] map = { 'y', 'h', 'e', 's', 'o', 'c', 'v', 'x', 'd', 'u', 'i', 'g',
			'l', 'b', 'k', 'r', 'z', 't', 'n', 'w', 'j', 'p', 'f', 'm', 'a', 'q' };

	public static void main(String[] args) throws IOException {
		// preprocess(); // this doesn't run as part of the program

		long startTime = System.nanoTime();
		BufferedReader in = new BufferedReader(new FileReader("A_SpeakingInTongues.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("A_SpeakingInTongues.out")));

		int T = Integer.parseInt(in.readLine());
		for (int testcase = 1; testcase <= T; testcase++) {
			char[] input = in.readLine().toCharArray();
			char[] output = new char[input.length];
			for (int i = 0; i < input.length; i++) {
				char a = input[i];
				if (a <= 'z' && a >= 'a')
					output[i] = map[a - 'a'];
				else
					output[i] = a;
			}

			String ans = String.valueOf(output);
			out.format("Case #%d: %s%n", testcase, ans);
		}

		out.close();
		System.out.println("Time (ms): " + (double) (System.nanoTime() - startTime) / 1000000);
		System.exit(0);
	}

	// this isn't part of the program
	private static void preprocess() {
		char[] input = "z y qee ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv".toCharArray();
		char[] output = "q a zoo our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up".toCharArray();
		char[] map = new char[26];
		for (int i = 0; i < input.length; i++) {
			char a = input[i];
			char b = output[i];
			if (a <= 'z' && a >= 'a') {
				if (map[a - 'a'] != 0 && map[a - 'a'] != b)
					System.err.println("holy crap error");
				map[a - 'a'] = b;
			}
		}
		for (int i = 0; i < map.length; i++) {
			System.out.print("\'" + map[i] + "\',");
		}
		System.out.println();
		System.out.print("unmapped: ");
		for (int i = 0; i < map.length; i++) {
			if (map[i] == 0)
				System.out.print((char) ('a' + i));
		}
		Arrays.sort(map);
		System.out.println();
		System.out.println(map);
	}
}
