/*
 * Anand Oza
 * Problem D - GoroSort
 * 5/7/2011
 */

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.Arrays;

public class GoroSort {
	private static PrintWriter out;

	private static int T;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();
		BufferedReader reader = new BufferedReader(new FileReader("D-large.in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter("D-large.out")));
		StreamTokenizer in = new StreamTokenizer(reader);

		in.nextToken();
		T = (int) in.nval;

		for (int t = 1; t <= T; t++) {
			in.nextToken();
			int N = (int) in.nval;
			int n = 0;
			for (int i = 1; i <= N; i++) {
				in.nextToken();
				int j = (int) in.nval;
				if (i != j)
					n++;
			}

			double[] factorial = new double[n + 1];
			factorial[0] = 1;
			for (int i = 1; i <= n; i++)
				factorial[i] = i * factorial[i - 1];

			double[] derangements = new double[n + 1];
			derangements[0] = 1;
			for (int i = 1; i <= n; i++)
				derangements[i] = i * derangements[i - 1] + Math.pow(-1, i);

			double[] f = new double[n + 1];
			for (int i = 2; i <= n; i++) {
				for (int k = 1; k <= i; k++)
					if ((i - k) < 50)
						f[i] += 1 / (factorial[k] * factorial[i - k]) * derangements[i - k]
								* (1 + f[i - k]);
					else
						f[i] += 1 / (factorial[k]) * Math.E * (1 + f[i - k]);
				if (i < 50) {
					f[i] += derangements[i] / factorial[i];
					f[i] /= (1 - derangements[i] / factorial[i]);
				} else {
					f[i] += Math.E;
					f[i] /= Math.E;
				}
			}

			System.out.println("Case #" + t + ": " + f[n]);
			out.println("Case #" + t + ": " + f[n]);
		}
		out.close();
		System.out.println("Time (ms): " + (double) (System.nanoTime() - startTime) / 1000000);
		System.exit(0);
	}
}
