package GCJ2016;

import com.sun.xml.internal.ws.util.StringUtils;

import java.io.*;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

/**
 * Created on 4/8/2016.
 */
public class CountingSheep
{
    private Map<Long, Long> attemptedProblemsAndSolutions;

    private CountingSheep()
    {
        attemptedProblemsAndSolutions = new HashMap<Long, Long>();
    }

    public static void main(String[] args) throws IOException
    {
        // String inputFilePath = "C:\\anand\\GCJ2016\\ASmallSample.txt";
        // String inputFilePath = "C:\\Users\\asivaramakrishnan\\Downloads\\A-small-attempt1.in";

        String inputFilePath = "C:\\Users\\asivaramakrishnan\\Downloads\\A-large.in";

        File fin = new File(inputFilePath);
        FileInputStream fis = new FileInputStream(fin);

        //Construct BufferedReader from InputStreamReader
        BufferedReader br = new BufferedReader(new InputStreamReader(fis));

        String line = null;

        int iter  = 0;
        int numberOfTestCases = 0;
        String[] output = null;
        while ((line = br.readLine()) != null) {
            String solution = "";
            if(iter == 0)
            {
                numberOfTestCases = Integer.parseInt(line);
                output = new String[numberOfTestCases];
            }
            else
            {
                output[iter-1] = "Case #" + iter + ": " + new CountingSheep().processSolution(Integer.parseInt(line));
                System.out.println(output[iter-1]);
            }
            // System.out.println(line);
            iter++;
        }

        br.close();

    }

    private String processSolution(int n)
    {
        if(n == 0)
            return "INSOMNIA";

        Set<Long> encounteredNumbers = new HashSet<Long>();
        Set<Long> encounteredInputs = new HashSet<Long>();

        int multiplier = 1;
        long currentN = n * multiplier;
        while(encounteredNumbers.size() < 10)
        {
            currentN = n * multiplier;
            if(attemptedProblemsAndSolutions.containsKey(currentN))
            {
                return Long.toString(attemptedProblemsAndSolutions.get(currentN));
            }

            encounteredInputs.add(currentN);

            long m = currentN;

            while(m >= 10)
            {
                encounteredNumbers.add(m%10);
                m = m/10;
            }

            if(m < 10)
                encounteredNumbers.add(m);

            multiplier++;
        }

        String solution = Long.toString(currentN);

        for(Long encounterInput : encounteredInputs)
        {
            attemptedProblemsAndSolutions.put(encounterInput, currentN);
        }

        attemptedProblemsAndSolutions.put(Long.valueOf(n), currentN);
        return solution;
    }
}
