// Name: Ananth Sridhar
// Date: 5/22/11
import java.io.*;
import java.util.*;

public class SquareTiles
{
	public static void main (String [] args) throws Exception
	{
		BufferedReader input = new BufferedReader (new FileReader ("SquareTilesInput.in"));
		PrintWriter output = new PrintWriter (new BufferedWriter (new FileWriter ("SquareTilesOutput.out")));
		StringTokenizer splitter = new StringTokenizer (input.readLine ());
		int numCases = Integer.parseInt (splitter.nextToken ());
		for (int i = 0; i < numCases; i++)
		{
			splitter = new StringTokenizer (input.readLine ());
			int rows = Integer.parseInt (splitter.nextToken ());
			int cols = Integer.parseInt (splitter.nextToken ());
			
			char [][] matrix = new char [rows][cols];
			for (int j = 0; j < rows; j++)
			{
				String curLine = new String (input.readLine ());
				for (int k = 0; k < cols; k++)
					matrix [j][k] = curLine.charAt (k);
			}
			
			int [] prevIndex = {-1, -1};
			while (numPounds (matrix) >= 4)
			{
				int [] index = findPound (matrix);
				if (!isValid (index, matrix) || index == prevIndex)
					{break;}
				matrix [index [0]][index [1]] = '/';
				matrix [index [0] + 1][index [1]] = '\\';
				matrix [index [0]][index [1] + 1] = '\\';
				matrix [index [0] + 1][index [1] + 1] = '/';
				prevIndex = index;
			}
						
			if (numPounds (matrix) != 0)
				{output.println ("Case #" + (i + 1) + ":"); output.println ("Impossible");}
				
			else
			{
				output.println ("Case #" + (i + 1) + ":");
				for (int j = 0; j < matrix.length; j++)
				{
					for (int k = 0; k < matrix[0].length; k++)
						output.print (matrix [j][k]);
					output.println ();
				}
			}
		}
		output.close ();
		System.exit (0);
	}
	private static int [] findPound (char [][] toFind)
	{
		for (int i = 0; i < toFind.length; i++)
			for (int j = 0; j < toFind[0].length; j++)
				if (toFind [i][j] == '#')
					return (new int [] {i, j});
		return (new int [] {-1, -1});
	}
	private static boolean isValid (int [] toCheck, char [][] isIn)
	{
		if (toCheck [0] + 1 < isIn.length &&
				toCheck [1] + 1 < isIn[0].length &&
				toCheck [0] >= 0 && toCheck [1] >= 0 &&
				isIn [toCheck [0]][toCheck[1]] == '#' &&
				isIn [toCheck [0] + 1][toCheck[1]] == '#' &&
				isIn [toCheck [0]][toCheck[1] + 1] == '#' &&
				isIn [toCheck [0] + 1][toCheck[1] + 1] == '#')
			return true;
		return false;
	}
	private static int numPounds (char [][] toFind)
	{
		int toReturn = 0;
		for (int i = 0; i < toFind.length; i++)
			for (int j = 0; j < toFind[0].length; j++)
				if (toFind [i][j] == '#')
					toReturn++;
		return toReturn;
	}
}