// Name: Ananth Sridhar
// Date: 5/7/11
import java.io.*;
import java.util.*;

public class Magicka
{
	public static void main (String [] args) throws Exception
	{
		BufferedReader input = new BufferedReader (new FileReader ("MagickaInput.in"));
		PrintWriter output = new PrintWriter (new BufferedWriter (new FileWriter ("MagickaOutput.out")));
		StringTokenizer splitter = new StringTokenizer (input.readLine ());
		int numCases = Integer.parseInt (splitter.nextToken ());
		for (int i = 0; i <  numCases; i++)
		{
			splitter = new StringTokenizer (input.readLine ());
			// Load Combining Pairs
			LinkedList <CombinePair> combinePairs = new LinkedList<CombinePair> ();
			int numCombines = Integer.parseInt (splitter.nextToken ());
			for (int j = 0; j < numCombines; j++)
			{
				String curPair = splitter.nextToken ();
				combinePairs.add (new CombinePair (curPair.charAt (0), curPair.charAt (1), curPair.charAt (2)));
			}
			// Load Opposing Pairs
			LinkedList <OpposePair> oppPairs = new LinkedList <OpposePair> ();
			int numOppositions = Integer.parseInt (splitter.nextToken ());
			for (int j = 0; j < numOppositions; j++)
			{
				String curOpp = splitter.nextToken ();
				oppPairs.add (new OpposePair (curOpp.charAt (0), curOpp.charAt (1)));
			}
			// Load Base Elements and Process
			LinkedList<String> elements = new LinkedList<String> ();
			int numElements = Integer.parseInt (splitter.nextToken ());
			String elementList = splitter.nextToken ();
			for (int j = 0; j < numElements; j++)
			{
				elements.add ("" + elementList.charAt (j));
				// Scan for combinations
				for (int k = 0; k < numCombines; k++)
				{
					if (elements.size () > 1)
					{
						String combinePair = elements.get (elements.size () - 2) + elements.getLast ();
						if (combinePair.equals (combinePairs.get (k).getElems1 ()) ||
								combinePair.equals (combinePairs.get (k).getElems2 ()))
						{
							elements.removeLast ();		elements.removeLast ();
							elements.addLast (combinePairs.get (k).getCombine ());
							break;
						}
					}
				}
				// Scan for oppositions
				for (int k = 0; k < numOppositions; k++)
					if (elements.contains (oppPairs.get (k).getElem1 ()) && 
							elements.contains (oppPairs.get (k).getElem2 ()))
						elements.clear ();
			}
			output.println ("Case #" + (i + 1) + ": " + elements);
		}
		// Exit Procedure
		output.close ();
		System.exit (0);
	}
	private static	 class CombinePair
	{
		private char myElem1, myElem2, myCombine;
		public CombinePair (char elem1, char elem2, char combine)
		{myElem1 = elem1; myElem2 = elem2; myCombine = combine;}
		public String getElems1 ()
		{return ("" + myElem1 + myElem2);}
		public String getElems2 ()
		{return ("" + myElem2 + myElem1);}
		public String getCombine ()
		{return ("" + myCombine);}
	}
	private static class OpposePair
	{
		private char myElem1, myElem2;
		public OpposePair (char elem1, char elem2)
		{myElem1 = elem1; myElem2 = elem2;}
		public String getElem1 ()
		{return ("" + myElem1);}
		public String getElem2 ()
		{return ("" + myElem2);}
	}
}