// Name: Ananth Sridhar
// Date: 5/7/11
import java.io.*;
import java.util.*;

public class BotTrust
{
	public static void main (String [] args) throws Exception
	{
		BufferedReader input = new BufferedReader (new FileReader ("BotTrustInput.in"));
		PrintWriter output = new PrintWriter (new BufferedWriter (new FileWriter ("BotTrustOutput.out")));
		StringTokenizer splitter = new StringTokenizer (input.readLine ());
		LinkedList<BotPair> botPairs = new LinkedList<BotPair> ();
		int numCases = Integer.parseInt (splitter.nextToken ());
		for (int i = 0; i < numCases; i++)
		{
			splitter = new StringTokenizer (input.readLine ());
			// Load Bot / Button Correspondence
			int numPresses = Integer.parseInt (splitter.nextToken ());
			for (int j = 0; j < numPresses; j++)
			{
				if (splitter.nextToken ().equals ("O"))
					botPairs.add (new BotPair ('O', Integer.parseInt (splitter.nextToken ())));
				else
					botPairs.add (new BotPair ('B', Integer.parseInt (splitter.nextToken ())));
			}
			int time = 0;
			int orangePos = 1, curOrangePair = findOrangePair (botPairs);
			int bluePos = 1, curBluePair = findBluePair (botPairs);
			boolean curButtonPushed = false;
			// Press Buttons / Move
			while (botPairs.size () != 0)
			{
				curButtonPushed = false;
				// Orange Checks
				if (curOrangePair != -1 && orangePos < botPairs.get (curOrangePair).getButtonPos ())
					orangePos++;
				else if (curOrangePair != -1 && orangePos > botPairs.get (curOrangePair).getButtonPos ())
					orangePos--;
				else if (curOrangePair == 0 && curButtonPushed == false)
					{botPairs.remove (curOrangePair); curOrangePair = findOrangePair (botPairs); curBluePair = findBluePair (botPairs); curButtonPushed = true;}
				// Blue Checks
				if (curBluePair != -1 && bluePos < botPairs.get (curBluePair).getButtonPos ())
					bluePos++;
				else if (curBluePair != -1 && bluePos > botPairs.get (curBluePair).getButtonPos ())
					bluePos--;
				else if (curBluePair == 0 && curButtonPushed == false)
					{botPairs.remove (curBluePair); curBluePair = findBluePair (botPairs); curOrangePair = findOrangePair (botPairs);}
				time++;
//				System.out.println (time + " " + curOrangePair + " " + curBluePair + " " + orangePos + " " + bluePos);

			}
			output.println ("Case #" + (i + 1) + ": " + time);/****************************************/
//			System.out.println ("Case #" + (i + 1) + ": " + time);/****************************************/
		}
		// Exit Procedure
		output.close ();
		System.exit (0);
	}
	private static int findOrangePair (LinkedList<BotPair> botPairs)
	{
		for (int i = 0; i < botPairs.size (); i++)
			if (botPairs.get (i).getBotType () == 'O')
				return i;
		return -1;
	}
	private static int findBluePair (LinkedList<BotPair> botPairs)
	{
		for (int i = 0; i < botPairs.size (); i++)
			if (botPairs.get (i).getBotType () == 'B')
				return i;
		return -1;
	}
	private static class BotPair
	{
		// Fields
		private char myBotType;
		private int myButton;
		private boolean isPressed;
		// Constructors
		public BotPair (char botType, int button)
		{myBotType = botType; myButton = button; isPressed = false;}
		public char getBotType ()
		{return myBotType;}
		public int getButtonPos ()
		{return myButton;}
		public boolean isPressed ()
		{return isPressed;}
		public void setPressed (boolean pressed)
		{isPressed = pressed;}
	}
}