import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;


/**
 * Created by Derick on 4/8/2016.
 */
public class Main {

  static String[] nums = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};

  public static void main(String[] args) throws IOException {
    BufferedReader input = new BufferedReader(new FileReader("inSmall"));
    BufferedWriter output = new BufferedWriter(new FileWriter("out.out"));
    ArrayList<String> answers = new ArrayList<>();
    int numCases = Integer.valueOf(input.readLine());

    for (int caseNo = 0; caseNo < numCases; caseNo++) {
      String line = input.readLine();
      StringBuilder answer = new StringBuilder();
      seekAnswer(answer, line, 0);
      answers.add(answer.toString());
    }

    for (int i = 0; i < numCases; i++) {
      output.write(String.format("Case #%d: %s", i + 1, answers.get(i)));
      output.newLine();
    }
    output.flush();
  }


  public static boolean seekAnswer(StringBuilder answer, String line, int i) {
    if (i == 10) {
      return false;
    }
    String tryThis = subtract(line, nums[i]);
    if (tryThis == null) {
      return seekAnswer(answer, line, i + 1);
    }
    answer.append(Integer.toString(i));
    if (tryThis.equals("")) {
      return true;
    }
    boolean result = seekAnswer(answer, tryThis, i);
    if (result) {
      return true;
    } else {
      result = seekAnswer(answer, tryThis, i + 1);
      if (result) {
        return true;
      } else {
        answer.deleteCharAt(answer.length() - 1);
        return seekAnswer(answer, line, i + 1);
      }
    }
  }

  public static int[] toCounts(String a) {
    int[] aI = new int[256];
    for (int i = 0; i < a.length(); i++) {
      aI[a.charAt(i)] += 1;
    }
    return aI;
  }

  public static String subtract(String a, String b) {
    int[] aI = toCounts(a);
    for (int i = 0; i< b.length(); i++) {
      aI[b.charAt(i)] -= 1;
      if (aI[b.charAt(i)] < 0) {
        return null;
      }
    }
    StringBuilder result = new StringBuilder();
    for (int i = 0; i < aI.length; i++) {
      while (aI[i] > 0) {
        result.append((char) i);
        aI[i]--;
      }
    }
    return result.toString();
  }

}
