package com.fractiles;

import java.io.IOException;
import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.LongStream;

public class Main {

    private static void writeOutput(List<List<Long>> result) throws  IOException{
        StringBuilder b = new StringBuilder();
        for(int i = 0; i < result.size(); i++) {
            b.append("Case #");
            b.append(i+1);
            b.append(":");
            List<Long> tiles = result.get(i);
            for(Long t : tiles) {
                b.append(' ');
                b.append(t);
            }
            b.append("\n");
        }

        Files.write(Paths.get("./out" + new Date().getTime() + ".txt"), b.toString().getBytes()) ;
    }

    private static List<List<Long>> calculate() throws IOException
    {
        List<List<Long>> output = new LinkedList<>();
        Path path = Paths.get("./data.txt");
        List<String> inputCases = Files.lines(path).collect(Collectors.toList());
        int cases = Integer.parseInt(inputCases.remove(0));
        int k, c, s;
        for(String inputCase: inputCases) {
            String[] data = inputCase.split(" ");
            k = Integer.parseInt(data[0]);
            c = Integer.parseInt(data[1]);
            //s = Integer.parseInt(data[2]);
            List<Long> list;

            if(k == 1) {
                list = new LinkedList<>();
                list.add(1L);
            } else {
                if(c == 1) {
                    list = LongStream.rangeClosed(1, k).collect(LinkedList<Long>::new, List<Long>::add, List<Long>::addAll);
                }else {
                    list = new LinkedList<>();
                    list.add(2L);
                    switch (k) {
                        case 3: list.add(3L);
                            break;
                        default:
                            BigInteger bi = BigInteger.valueOf(k).pow(c);
                            int range = k - 2 - 1;
                            for(int i = 0; i < range; i++) {
                                list.add(bi.longValue() - 1 - i);
                            }
                    }
                }
            }
            output.add(list);
        }
        return output;
    }

    public static void main(String[] args) throws IOException{

       writeOutput(calculate());

    }

}
