package com.sheep;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;
import java.util.function.IntConsumer;
import java.util.stream.IntStream;
import java.util.stream.Stream;

public class Main {

    private static Set<Integer> getDigits(int n) {
        Set<Integer> digits = new HashSet<>();
        while (n != 0) {
            digits.add(n % 10);
            n /= 10;
        }
        return digits;
    }

    private static String allDigitsCollected(int n) {
        if (n == 0) return "INSOMNIA";
        Set<Integer> digits = new HashSet<>();
        int i = 1;
        int k;
       do {
            k = n * i;
            digits.addAll(getDigits(k));
            i++;
        } while (digits.size() < 10);
        return Integer.toString(k);
    }

    private static void readStreamOfLinesUsingFilesWithTryBlock() throws IOException
    {
        Path path = Paths.get("./data.txt");
        //When filteredLines is closed, it closes underlying stream as well as underlying file.
        try(IntStream inputCases = Files.lines(path)
                .mapToInt(Integer::parseInt)){
//            OptionalInt cases = inputCases.findFirst();

            int [] data = inputCases.toArray();
            List<String> result = new LinkedList<>();
            for(int i = 1; i < data.length; i++){
                result.add(allDigitsCollected(data[i]));
            }

            StringBuilder b = new StringBuilder();
            for(int i = 0; i < result.size(); i++) {
                b.append("Case #");
                b.append(i+1);
                b.append(": ");
                b.append(result.get(i));
                b.append("\n");
            }

            Files.write(Paths.get("./out" + new Date().getTime() + ".txt"), b.toString().getBytes()) ;
/*            IntStream.range(1, data.length)
                    .map(i -> data[i])
                    .forEach(Main::allDigitsCollected);*/
        }
    }

    public static void main(String[] args) throws IOException{
        readStreamOfLinesUsingFilesWithTryBlock();

    }

}
