package com.pancaces;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;
import java.util.stream.Collectors;

public class Main {

    static final int MAX_TEST_CASES = 100;

    static int[] startWithPositive = new int[MAX_TEST_CASES];
    static int[] startWithNegative = new int[MAX_TEST_CASES];

    private static void writeOutput(List<Integer> result) throws  IOException{
        StringBuilder b = new StringBuilder();
        for(int i = 0; i < result.size(); i++) {
            b.append("Case #");
            b.append(i+1);
            b.append(": ");
            b.append(result.get(i));
            b.append("\n");
        }

        Files.write(Paths.get("./out" + new Date().getTime() + ".txt"), b.toString().getBytes()) ;
    }

    private static List<Boolean> reducedList(List<Boolean> signs) {
        List<Boolean> result = new LinkedList<>();
        boolean previous = signs.get(0);
        result.add(previous);
        for(int i = 1; i < signs.size(); i++) {
            if(signs.get(i) != previous) {
                previous = !previous;
                result.add(previous);
            }
        }
        return result;
    }

    private static List<Boolean> convertString(String s) {
        List<Boolean> signs = new LinkedList<>();
        for(int i = 0; i < s.length(); i++) {
            if(s.charAt(i) == '+')
                signs.add(true);
            else
                signs.add(false);
        }
        return reducedList(signs);
    }

    private static void countOperations(){
        startWithPositive[0] = 0;
        startWithNegative[0] = 1;

        for(int i = 1; i < MAX_TEST_CASES; i++) {
            startWithNegative[i] = startWithPositive[i-1] + 1;
            startWithPositive[i] = startWithNegative[i-1] + 1;
        }
    }

    private static void readStreamOfLinesUsingFilesWithTryBlock() throws IOException
    {
        Path path = Paths.get("./data.txt");
        List<String> inputCases = Files.lines(path).collect(Collectors.toList());
        int cases = Integer.parseInt(inputCases.remove(0));
        List<Integer> output = new LinkedList<>();
        countOperations();
        for(String s : inputCases) {
            List<Boolean> signs = convertString(s);
            int n = signs.size() - 1;
            if(signs.get(0)) {
                output.add(startWithPositive[n]);
            } else {
                output.add(startWithNegative[n]);
            }
        }
        writeOutput(output);

    }

    public static void main(String[] args) throws IOException{
        readStreamOfLinesUsingFilesWithTryBlock();

    }

}
