package R1B_2016;

/**
 * @author Anastasiya Solodkaya.
 */
public class Digits extends Base {

    private static final int C = 65;

    public static void main(String[] args) {
        new Digits(true);
    }

    protected Digits(boolean debug) {
        super("Digits", debug);
    }

    @Override
    protected String run() {
        String s = nextLine();

        int[] frequencies = new int[28];
        for (int i = 0; i < s.length(); i++) {
            frequencies[s.charAt(i) - C] += 1;
        }

        int[] digits = new int[10];

        remove_0(frequencies, digits);
        remove_2(frequencies, digits);
        remove_6(frequencies, digits);
        remove_8(frequencies, digits);
        remove_3(frequencies, digits);
        remove_4(frequencies, digits);
        remove_1(frequencies, digits);
        remove_5(frequencies, digits);
        remove_7(frequencies, digits);
        remove_9(frequencies, digits);

        StringBuilder builder = new StringBuilder();

        for (int i = 0; i < digits.length; i++) {
            int digit = digits[i];
            if (digit != 0) {
                for (int j = 0; j < digit; j++) {
                    builder.append(i);
                }
            }
        }

        return builder.toString();
    }

    private void remove_9(int[] frequencies, int[] digits) {
        int w_f = frequencies['N' - C] / 2;
        if (w_f > 0) {
            digits[9] = w_f;
            decrease(frequencies, 'N', w_f * 2);
            decrease(frequencies, 'I', w_f);
            decrease(frequencies, 'E', w_f);
        }
    }

    private void remove_6(int[] frequencies, int[] digits) {
        int w_f = frequencies['X' - C];
        if (w_f > 0) {
            digits[6] = w_f;
            decrease(frequencies, 'S', w_f);
            decrease(frequencies, 'I', w_f);
            decrease(frequencies, 'X', w_f);
        }
    }

    private void remove_7(int[] frequencies, int[] digits) {
        int w_f = frequencies['V' - C];
        if (w_f > 0) {
            digits[7] = w_f;
            decrease(frequencies, 'S', w_f);
            decrease(frequencies, 'E', w_f);
            decrease(frequencies, 'V', w_f);
            decrease(frequencies, 'E', w_f);
            decrease(frequencies, 'N', w_f);
        }
    }

    private void remove_5(int[] frequencies, int[] digits) {
        int w_f = frequencies['F' - C];
        if (w_f > 0) {
            digits[5] = w_f;
            decrease(frequencies, 'F', w_f);
            decrease(frequencies, 'I', w_f);
            decrease(frequencies, 'V', w_f);
            decrease(frequencies, 'E', w_f);
        }
    }

    private void remove_1(int[] frequencies, int[] digits) {
        int w_f = frequencies['O' - C];
        if (w_f > 0) {
            digits[1] = w_f;
            decrease(frequencies, 'O', w_f);
            decrease(frequencies, 'N', w_f);
            decrease(frequencies, 'E', w_f);
        }
    }

    private void remove_4(int[] frequencies, int[] digits) {
        int w_f = frequencies['R' - C];
        if (w_f > 0) {
            digits[4] = w_f;
            decrease(frequencies, 'F', w_f);
            decrease(frequencies, 'O', w_f);
            decrease(frequencies, 'U', w_f);
            decrease(frequencies, 'R', w_f);
        }
    }

    private void remove_3(int[] frequencies, int[] digits) {
        int w_f = frequencies['T' - C];
        if (w_f > 0) {
            digits[3] = w_f;
            decrease(frequencies, 'T', w_f);
            decrease(frequencies, 'H', w_f);
            decrease(frequencies, 'R', w_f);
            decrease(frequencies, 'E', w_f * 2);
        }
    }

    private void remove_8(int[] frequencies, int[] digits) {
        int w_f = frequencies['G' - C];
        if (w_f > 0) {
            digits[8] = w_f;
            decrease(frequencies, 'E', w_f);
            decrease(frequencies, 'I', w_f);
            decrease(frequencies, 'G', w_f);
            decrease(frequencies, 'H', w_f);
            decrease(frequencies, 'T', w_f);
        }
    }

    private void remove_2(int[] frequencies, int[] digits) {
        int w_f = frequencies['W' - C];
        if (w_f > 0) {
            digits[2] = w_f;
            decrease(frequencies, 'T', w_f);
            decrease(frequencies, 'O', w_f);
            decrease(frequencies, 'W', w_f);
        }
    }

    private void remove_0(int[] frequencies, int[] digits) {
        int z_f = frequencies['Z' - C];
        if (z_f > 0) {
            digits[0] = z_f;
            decrease(frequencies, 'Z', z_f);
            decrease(frequencies, 'E', z_f);
            decrease(frequencies, 'R', z_f);
            decrease(frequencies, 'O', z_f);
        }
    }

    private void decrease(int[] frequencies, char e, int z_f) {
        frequencies[e - C] -= z_f;
    }
}
