import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.Scanner;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * @author Anastasiya Solodkaya.
 */
public class FrcatilesSmall {

    public static void main(String[] args) {
        PrintStream out = out("TestFractileSmall");
        BufferedReader in = read("TestFractileSmall");
        Scanner scanner = new Scanner(in);
        int cases = scanner.nextInt();
        for (int i = 0; i < cases; i++) {
            int k = scanner.nextInt();
            int c = scanner.nextInt();
            int s = scanner.nextInt();
            if(k == s) {
                long[] select = new long[s];
                for (int j = 0; j < s; j++) {
                    select[j] = j * (long) Math.pow(k, c - 1) + 1;
                }
                out.printf("Case #%d: %s%n", i + 1, Arrays.stream(select).mapToObj(t -> t + "").collect(Collectors.joining(" ")));
            }else{
                out.printf("Case #%d: IMPOSSIBLE%n", i + 1);
            }
        }
    }

    private static BufferedReader read(String fileNameBase) {
        BufferedReader bufferedReader = null;
        try {
            bufferedReader = Files.newBufferedReader(Paths.get("samples/" + fileNameBase + ".in"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bufferedReader;
    }


    private static void test(PrintStream out, int k, int c) {
        out.println(">> " + k + ", " + c + " <<");
        int[][] arrays = new int[k][];
//
//        for (int j = 1; j < c; j++) {
//            for (int i = 0; i < (1 << (k)); i++) {
//                int[] original = toArray(k, i);
//                int[] next = generate(out, original, j);
//                out.println(Arrays.toString(original) + " --> " + Arrays.toString(next));
//                arrays[i] = next;
//            }
//        }

        for (int i = 0; i < k; i++) {
            int[] original = new int[k];
            original[i] = 1;
            int[] next = generate(out, original, c);
//            int[] next2 = generate2(out, original, c);
//            for (int p = 0; p < next.length; p++) {
//                if(next[p] != next2[p]){
//                    System.out.println("!");
//                }
//            }
//            out.println(Arrays.toString(original) + " --> " + Arrays.toString(next));
            arrays[i] = next;
        }

        out.println("!!!");
        for (int i = 0; i < k / 2; i++) {
            out.println(Arrays.toString(sum(arrays[i], arrays[k - i - 1])));
        }
        if (k % 2 == 1) {
            out.println(Arrays.toString(arrays[k / 2 + 1]));
        }
        out.println("!!!");

        int[] b = new int[arrays[0].length];
        for (int i = 0; i < arrays.length; i++) {
            for (int j = 0; j < arrays[i].length; j++) {
                if (arrays[i][j] == 1) {
                    b[j] += 1;
                }
            }
        }
        System.out.println();
        System.out.println();
        System.out.println();
        out.println(Arrays.toString(b));
        out.println(b.length);
        IntStream stream = IntStream.range(0, b.length).filter(i -> b[i] == (k));


        out.println(stream.mapToObj(i -> i + "").collect(Collectors.joining(", ")));
    }

    private static int[] generate2(PrintStream out, int size, int placeGold, int c) {
        System.out.println((int) Math.pow(size, c));
        int[] result = new int[(int) Math.pow(size, c)];
        for (int i = 1; i <= c; i++) {
            int t = 0;
            int len = (int) Math.pow(size, i - 1);
            while (t * Math.pow(size, i) + placeGold * len < result.length) {
                for (int j = 0; j < len; j++) {
                    result[(int) (t * Math.pow(size, i) + placeGold * len) + j] = 1;
                }
                t++;
            }
        }
        return result;
    }

    private static int[] toArray(int k, int i) {
        int[] result = new int[k];
        int index = 0;
        while (i > 0) {
            result[index] = i % 2;
            index++;
            i = i / 2;
        }
        return result;
    }

    private static int[] generate(PrintStream out, int[] original, int c) {
        int[] next = original;
        for (int i = 2; i <= c; i++) {
            next = next(next, original);
//            out.println(Arrays.toString(next));
        }
        return next;
    }

    private static int[] generate(PrintStream out, int len, int place, int c) {
        int[] arr = new int[len];
        arr[place] = 1;
        return generate(out, arr, c);
    }

    private static int[] next(int[] from, int[] original) {
        int[] full = new int[from.length * original.length];
        for (int i = 0; i < from.length; i++) {
            int start = original.length * i;
            if (from[i] == 0) {
                System.arraycopy(original, 0, full, start, original.length);
            } else {
                for (int j = 0; j < original.length; j++) {
                    full[start + j] = 1;
                }
            }
        }

        return full;
    }

    private static PrintStream out(String fileNameBase) {
        PrintStream printStream = null;
        try {
            printStream = new PrintStream("samples/" + fileNameBase + ".out");
        } catch (IOException e) {
            e.printStackTrace();
        }
        return printStream;
    }


    private static int[] sum(int[] o1, int[] o2) {
        int[] result = new int[o1.length];
        for (int i = 0; i < o1.length; i++) {
            int i1 = o1[i] + o2[i];
            result[i] = i1;
//            result[i] = i1 > 0 ? 1 : 0;
        }
        return result;
    }

}
