package R1B_2016;


import java.io.PrintStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Objects;
import java.util.Scanner;

/**
 * @author Anastasiya Solodkaya.
 */
public abstract class Base {
    protected static final String NEW_LINE = String.format("%n");

    private boolean debug;
    private PrintStream out;
    private PrintStream debugStream;
    private Scanner scanner;

    protected Base(String fileTemplate, boolean debug) {
        fileTemplate = "R1B_2016/" + fileTemplate;
        this.debug = debug;
        out = IO.out(fileTemplate);
//        debugStream = System.out;
        debugStream = IO.out(fileTemplate + ".debug");
        scanner = new Scanner(IO.read(fileTemplate));
        int testCase = scanner.nextInt();
        scanner.nextLine();
//        skipline();


        for (int i = 0; i < testCase; i++) {
            System.out.println("CASE #" + (i + 1));
            String result = run();
            out.println("Case #" + (i + 1) + ": " + result);
        }
    }

    protected abstract String run();

    protected char[] nextCharsFromLine() {
        return scanner.nextLine().toCharArray();
    }

    protected int[] nextIntsFromLine() {
        String[] split = scanner.nextLine().split("\\s");
        return Arrays.stream(split).mapToInt(Integer::parseInt).toArray();
    }

    protected long[] nextLongsFromLine() {
        String[] split = scanner.nextLine().split("\\s");
        return Arrays.stream(split).mapToLong(Long::parseLong).toArray();
    }

    protected String nextLine() {
        return scanner.nextLine();
    }

    protected byte nextByte() {
        return scanner.nextByte();
    }

    protected byte nextByte(int radix) {
        return scanner.nextByte(radix);
    }

    protected short nextShort() {
        return scanner.nextShort();
    }

    protected short nextShort(int radix) {
        return scanner.nextShort(radix);
    }

    protected boolean hasNextInt() {
        return scanner.hasNextInt();
    }

    protected boolean hasNextInt(int radix) {
        return scanner.hasNextInt(radix);
    }

    protected int nextInt() {
        return scanner.nextInt();
    }

    protected int nextInt(int radix) {
        return scanner.nextInt(radix);
    }

    protected long nextLong() {
        return scanner.nextLong();
    }

    protected long nextLong(int radix) {
        return scanner.nextLong(radix);
    }

    protected float nextFloat() {
        return scanner.nextFloat();
    }

    protected double nextDouble() {
        return scanner.nextDouble();
    }

    protected BigInteger nextBigInteger() {
        return scanner.nextBigInteger();
    }

    protected BigInteger nextBigInteger(int radix) {
        return scanner.nextBigInteger(radix);
    }

    protected BigDecimal nextBigDecimal() {
        return scanner.nextBigDecimal();
    }

    protected boolean nextBoolean() {
        return scanner.nextBoolean();
    }

    protected void skipline() {
        nextLine();
    }

    protected void debug(String s) {
        if (debug) {
            debugStream.println(s);
        }
    }

    protected<T> void debug(T[] arr) {
        debug(Arrays.toString(arr));
    }

    protected void debug(String template, Object... args) {
        if (debug) {
            debugStream.println(String.format(template, args));
        }
    }

    protected void debug(Object o) {
        debug(Objects.toString(o));
    }


}
