import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * @author Anastasiya Solodkaya.
 */
public class FrcatilesTest0 {

    public static void main(String[] args) {
        PrintStream out = out("T1");
        BufferedReader read = read("T1");
        // 0 - gold, 1 - lead

        Scanner scanner = new Scanner(read);
        int cases = scanner.nextInt();
        for (int i = 0; i < cases; i++) {
            int k = scanner.nextInt();
            int c = scanner.nextInt();
            int s = scanner.nextInt();
            test(out, i, k, c, s);
        }
    }

    private static BufferedReader read(String fileNameBase) {
        BufferedReader bufferedReader = null;
        try {
            bufferedReader = Files.newBufferedReader(Paths.get("samples/" + fileNameBase + ".in"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bufferedReader;
    }
    private static void test(PrintStream out, int cs,  int k, int c, int s) {
        StringBuilder result = new StringBuilder();
        result.append(String.format("Case #%d: ", cs + 1));
        if (c >= k) {
            long l = calculateApproximated(k, k);
            result.append(l + 1);
            int[] calc = calc(l, k, c);
            if(!isFull(calc)){
//                out.println("MISTAKE!!!");
            }
        } else {
            List<Long> indices = new ArrayList<>();
            int found = 0;
            int[] full = new int[k];
            while (found < k) {
                long idx = calculateNext(k, c, found);
                found += c;
                indices.add(idx);
                full = sum(full, calc(idx, k, c));
            }
            if(!isFull(full)){
//                out.println("MISTAKE!!! " + Arrays.toString(full));
            }
            if (s < indices.size()) {
                result.append("IMPOSSIBLE");
            } else {
                result.append(indices.stream().map(idx -> (idx + 1) + "").collect(Collectors.joining(" ")));
            }
        }
        out.println(result.toString());
    }

    private static boolean isFull(int[] calc) {
        return IntStream.of(calc).allMatch(value -> value == 1);
    }

    private static void test(PrintStream out, int k, int c) {
        out.println(">> " + k + ", " + c + " <<");
        long approx = calculateApproximated(k, k);
        out.println("APROXIMATING: " + approx);


        int[][] arrays = new int[k][];
//
//        for (int j = 1; j < c; j++) {
//            for (int i = 0; i < (1 << (k)); i++) {
//                int[] original = toArray(k, i);
//                int[] next = generate(out, original, j);
//                out.println(Arrays.toString(original) + " --> " + Arrays.toString(next));
//                arrays[i] = next;
//            }
//        }

        for (int i = 0; i < k; i++) {
            int[] original = new int[k];
            original[i] = 1;
            int[] next = generate(out, original, c);
//            int[] next2 = generate2(out, original, c);
//            for (int p = 0; p < next.length; p++) {
//                if(next[p] != next2[p]){
//                    System.out.println("!");
//                }
//            }
//            out.println(Arrays.toString(original) + " --> " + Arrays.toString(next));
            arrays[i] = next;
        }

        out.println("!!!");
        int[] tt = new int[arrays[0].length];
        for (int i = 0; i < arrays[0].length; i++) {
            int total = 0;
            for (int j = 0; j < arrays.length; j++) {
                total = total << 1;
                total += arrays[j][i];
            }
            tt[i] = total;
        }
//        out.println(Arrays.toString(tt));
        int[] commonBits = new int[tt.length];
        for (int i = 0; i < arrays[0].length; i += k) {
            int common = tt[i];
            for (int j = 1; j < k; j++) {
                common = common & tt[i + j];
            }
            commonBits[i / k] = common;
        }
//        out.println(Arrays.toString(commonBits));
//        out.println(Arrays.deepToString(Arrays.stream(commonBits).mapToObj(FrcatilesTest0::toBits).toArray(Integer[][]::new)));

        int found = 0;
        while (found < k) {
            int idx = (int) calculateNext(k, c, found);
            printNum(out, arrays, idx);
            found += c;
        }
//        printNum(out, arrays, (int) calculateApproximated(k, c));

        out.println("!!!");

        int[] b = new int[arrays[0].length];
        for (int i = 0; i < arrays.length; i++) {
            for (int j = 0; j < arrays[i].length; j++) {
                if (arrays[i][j] == 1) {
                    b[j] += 1;
                }
            }
        }
//        System.out.println();
//        System.out.println();
//        System.out.println();
        out.println(Arrays.toString(b));
        out.println(b.length);
        IntStream stream = IntStream.range(0, b.length).filter(i -> b[i] == (k));


        out.println(stream.mapToObj(i -> i + "").collect(Collectors.joining(", ")));
    }

    private static long calculateNext(int k, int c, int found) {
//        System.out.println("k = " + k);
//        System.out.println("c = " + c);
//        System.out.println("found = " + found);
        long value = 0;
        for (int i = 0; i <= Math.min(c, k - found) - 1; i++) {
            value += (long) Math.pow(k, c - i - 1) * (found + i);
//            System.out.println(k + " ^ (" + (c - i - 1) + ") * " + (found + i));
//            System.out.println("value = " + value);
        }
//        for (int i = 0; i < Math.min(c, c - found); i++) {
//            value += (long)Math.pow(k, c - i - 1) * (c + 1);
//        }

        return value;
    }

    private static void printNum(PrintStream out, int[][] arrays, int idx) {
//        out.println("idx = " + idx);
        if (idx < arrays[0].length) {
            for (int i = 0; i < arrays.length; i++) {
                out.print(arrays[i][idx]);
            }
        }
        out.println();
    }

    private static long calculateApproximated(int k, int c) {
        long val = 0;
        for (int i = 0; i <= k - 2; i++) {
            val += (long) Math.pow(k, c - i - 2) * (i + 1);
        }
        return val;
    }

    private static Integer[] toBits(int t) {
        List<Integer> l = new ArrayList<>();
        while (t > 0) {
            l.add(t % 2);
            t = t / 2;
        }
        List<Integer> result = new ArrayList<>();
        for (int i = 0; i < l.size(); i++) {
            if (l.get(i) == 1) {
                result.add(0, i);
            }
        }
        return result.toArray(new Integer[result.size()]);
    }

    private static int[] generate(PrintStream out, int[] original, int c) {
        int[] next = original;
        for (int i = 2; i <= c; i++) {
            next = next(next, original);
//            out.println(Arrays.toString(next));
        }
        return next;
    }

    private static int[] next(int[] from, int[] original) {
        int[] full = new int[from.length * original.length];
        for (int i = 0; i < from.length; i++) {
            int start = original.length * i;
            if (from[i] == 0) {
                System.arraycopy(original, 0, full, start, original.length);
            } else {
                for (int j = 0; j < original.length; j++) {
                    full[start + j] = 1;
                }
            }
        }

        return full;
    }

    private static PrintStream out(String fileNameBase) {
        PrintStream printStream = null;
        try {
            printStream = new PrintStream("samples/" + fileNameBase + ".out");
        } catch (IOException e) {
            e.printStackTrace();
        }
        return printStream;
    }

    private static int[] calc(long i, int size, int c) {
        double fullRange = Math.pow(size, c);
        int[] result = new int[size];
        for (int placeGold = 0; placeGold < size; placeGold++) {
            if ((i - placeGold) % size == 0) {
                result[placeGold] = 1;
                continue;
            }

            for (int j = 2; j <= c; j++) {
                boolean t = inRange(placeGold, size, c, i, j, j - 1);
                if (t) {
                    result[placeGold] = 1;
                    break;
                }
            }
        }
        return result;
    }


    private static boolean inRange(int place, int k, int c, long p, int top, int bottom) {
        long a = p - 1 + (1 - place) * (long) Math.pow(k, bottom);
        long start = a / (long) Math.pow(k, top);
        start = start * (long) Math.pow(k, top) + place * (long) Math.pow(k, bottom);

        if (p >= start && p <= (start + (long) Math.pow(k, bottom) - 1)) {
            return true;
        }
        return false;
    }

    private static int[] sum(int[] o1, int[] o2) {
        int[] result = new int[o1.length];
        for (int i = 0; i < o1.length; i++) {
            int i1 = o1[i] + o2[i];
//            result[i] = i1;
            result[i] = i1 > 0 ? 1 : 0;
        }
        return result;
    }

}
