import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Scanner;

/**
 * @author Anastasiya Solodkaya.
 */
public class Main {
    public static void main(String[] args) {
        String fileNameBase = "A-large";
        BufferedReader bufferedReader = read(fileNameBase);
        PrintStream out = out(fileNameBase);
        Scanner scanner = new Scanner(bufferedReader);
        int cases = scanner.nextInt();
        for (int i = 0; i < cases; i++) {
            int num = calculate(scanner.nextInt());
            if(num != -1) {
                out.printf("Case #%d: %d%n", i + 1, num);
            }else{
                out.printf("Case #%d: INSOMNIA%n", i + 1);
            }
        }
    }

    private static int calculate(int start) {
        int status = 0;
        int idx = 1;
        int lastNumber = start * idx;
        int number;
        while (status != 1023) {
            number = start * idx;
            while (number > 0) {
                status = set(status, number % 10);
//                System.out.println(status);
                number = number / 10;
            }
            lastNumber = start * idx;
            idx++;
            if(lastNumber == start * idx){
                return -1;
            }
        }
        return lastNumber;
    }

    private static int set(int status, int i) {
        return status | (1 << i);
    }

    private static BufferedReader read(String fileNameBase) {
        BufferedReader bufferedReader = null;
        try {
            bufferedReader = Files.newBufferedReader(Paths.get("samples/" + fileNameBase + ".in"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bufferedReader;
    }

    private static PrintStream out(String fileNameBase) {
        PrintStream printStream = null;
        try {
            printStream = new PrintStream("samples/" + fileNameBase + ".out");
        } catch (IOException e) {
            e.printStackTrace();
        }
        return printStream;
    }
}
