import java.io.BufferedReader;
import java.io.IOException;
import java.io.PrintStream;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

/**
 * @author Anastasiya Solodkaya.
 */
public class Pancakes {

    private static BufferedReader read(String fileNameBase) {
        BufferedReader bufferedReader = null;
        try {
            bufferedReader = Files.newBufferedReader(Paths.get("samples/" + fileNameBase + ".in"));
        } catch (IOException e) {
            e.printStackTrace();
        }
        return bufferedReader;
    }

    private static PrintStream out(String fileNameBase) {
        PrintStream printStream = null;
        try {
            printStream = new PrintStream("samples/" + fileNameBase + ".out");
        } catch (IOException e) {
            e.printStackTrace();
        }
        return printStream;
    }

    public static void main(String[] args) {
        PrintStream out = out("Pancakes");
        BufferedReader reader = read("Pancakes");

        Scanner scanner = new Scanner(reader);

        int cases = scanner.nextInt();

        scanner.nextLine();
        for (int i = 0; i < cases; i++) {
            String start = scanner.nextLine();
            int counter = flipAll(start);
            out.printf("Case #%d: %d%n", i + 1, counter);
        }
    }

    private static int flipAll(String start) {
        List<Boolean> stack = new LinkedList<>();
        char[] chars = start.toCharArray();
        for (int i = 0; i < chars.length; i++) {
            char c = chars[i];
            stack.add(c == '+');
        }

        int counter = 0;
        boolean state = stack.stream().allMatch(Boolean::booleanValue);
        while (!state) {

            boolean first = stack.get(0);
            int i = 1;
            while (i < stack.size() && stack.get(i) == first) {
                i++;
            }

            stack = flip(stack, i);
            counter++;
            state = stack.stream().allMatch(Boolean::booleanValue);
        }
        return counter;
    }

    private static List<Boolean> flip(List<Boolean> stack, int count) {
        List<Boolean> subList0 = stack.subList(0, count);
        List<Boolean> subList1 = stack.subList(count, stack.size());
        List<Boolean> newList = new ArrayList<>();
        for (int i = subList0.size() - 1; i >= 0; i--) {
            newList.add(!subList0.get(i));
        }
        newList.addAll(subList1);
        return newList;
    }
}
