import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.PriorityQueue;


public class TaskA {

    public static void main(String[] args) {
        String fileName = "A-large.in";
        
 
        try {
            BufferedReader br = new BufferedReader(new FileReader("data/" + fileName));
            PrintWriter out = new PrintWriter(new PrintStream(new File("data/" + fileName + ".out")));
            
            int numberOfTestCases = Integer.parseInt(br.readLine());
            for (int i = 0; i < numberOfTestCases; ++i) {
                int numberOfParties = Integer.parseInt(br.readLine());
                String[] numbersOfMembers = br.readLine().split(" ");
                PriorityQueue<Party> maxHeapParties = new PriorityQueue<TaskA.Party>();
                int counter = 0;
                int numbersOfAllMembers = 0;
                for (String str : numbersOfMembers) {
                    int numberMem = Integer.parseInt(str);
                    maxHeapParties.add(new Party(counter, numberMem));
                    numbersOfAllMembers += numberMem;
                    counter++;
                }
                
                
                
//                System.out.println("Case #" + (i+1) + ": " + solution(maxHeapParties, numbersOfAllMembers));
                out.println("Case #" + (i+1) + ": " + solution(maxHeapParties, numbersOfAllMembers));
            }
            
            out.close();
            br.close();
            
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private static String solution(PriorityQueue<Party> maxHeapParties, int numbersOfAllMembers) {
        ArrayList<String> resultArray = new ArrayList<String>();
        int currentAllMembersCounter = numbersOfAllMembers;
        while (!maxHeapParties.isEmpty()) {
            Party first = maxHeapParties.poll();
            if (first.members > 1) {
                maxHeapParties.add(new Party(first.party, first.members - 1));
            }
            currentAllMembersCounter--;
            
            if (maxHeapParties.size() > 1) {
                Party second = maxHeapParties.poll();
                Party next = maxHeapParties.peek();
                int maxMembersSameParty = next.members;
                if (second.members - 1 > maxMembersSameParty) {
                    maxMembersSameParty = second.members - 1;
                }
                currentAllMembersCounter--;
                
                if (maxMembersSameParty * 2 > currentAllMembersCounter || (maxHeapParties.size() == 1 && second.members == 1)) { // don't evacuate second
                    maxHeapParties.add(second);
                    currentAllMembersCounter++;
                    resultArray.add("" +  (char)( (int)('A') + first.party));
                } else {
                    if (second.members > 1) {
                        maxHeapParties.add(new Party(second.party, second.members - 1));
                    }
                    resultArray.add("" +  (char)( (int)('A') + first.party) + (char)( (int)('A') + second.party));
                }
            } else {
                if (maxHeapParties.size() == 1) {
                    //  hare only one last member may be
                    Party second = maxHeapParties.poll();
//                    currentAllMembersCounter--;
//                    if (second.members > 1) {
//                        maxHeapParties.add(new Party(second.party, second.members - 1));
//                    }
                    resultArray.add("" +  (char)( (int)('A') + first.party) + (char)( (int)('A') + second.party));
                } else {
                    resultArray.add("" +  (char)( (int)('A') + first.party));
                }
            }
            
            
            
            
            
        }
        StringBuilder res = new StringBuilder();
        for (String str : resultArray) {
            res.append(str + " ");
        }
        return res.toString();
    }
    
    static class Party implements Comparable<Party>{
        int party;
        int members;
        
        public Party(int numberOfParty, int numberOfMembers) {
            this.members = numberOfMembers;
            this.party = numberOfParty;
        }

        @Override
        public int compareTo(Party other) {
            return other.members - this.members;
        }
    }
}
