import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.ArrayList;


public class Task_D_Fractiles {

    public static void main(String[] args) {
        String fileName = "D-small-attempt0.in";
        
 
        try {
            BufferedReader br = new BufferedReader(new FileReader("data/" + fileName));
            PrintWriter out = new PrintWriter(new PrintStream(new File("data/" + fileName + ".out")));
            
            int numberOfTestCases = Integer.parseInt(br.readLine());
            for (int i = 0; i < numberOfTestCases; ++i) {
                String[] numbers = br.readLine().split(" ");
                int originLen = Integer.parseInt(numbers[0]);
                int complexity = Integer.parseInt(numbers[1]);
                int numOfTiles = Integer.parseInt(numbers[2]);
                
                
                System.out.println("Case #" + (i+1) + ": " + solveSmall(originLen, complexity));
                out.println("Case #" + (i+1) + ": " + solveSmall(originLen, complexity));
            }
            
            out.close();
            br.close();
            
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private static String solveSmall(int originLen, int complexity) {
        ArrayList<Long> indexes = new ArrayList<Long>();
        
        
        indexes.add(1L);
        long shift = 1;
        long prevBlockSize = 1;
        for (int i = 1; i < complexity; ++i) {
            prevBlockSize = prevBlockSize * originLen;
            shift += prevBlockSize;
        }
        long index = 1;
        for (int i = 1; i < originLen; ++i) {
            index += shift;
            indexes.add(index);
        }
        StringBuilder sb = new StringBuilder();
        for (long i : indexes) {
            sb.append(i);
            sb.append(" ");
        }
        return sb.toString();
    }

}
