import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;


public class TaskC {

    public static void main(String[] args) {
        String fileName = "C-small-attempt1.in";
        
 
        try {
            BufferedReader br = new BufferedReader(new FileReader("data/" + fileName));
            PrintWriter out = new PrintWriter(new PrintStream(new File("data/" + fileName + ".out")));
            
            int numberOfTestCases = Integer.parseInt(br.readLine());
            for (int i = 0; i < numberOfTestCases; ++i) {
                String[] numbers = br.readLine().split(" ");
                int J = Integer.parseInt(numbers[0]);
                int P = Integer.parseInt(numbers[1]);
                int S = Integer.parseInt(numbers[2]);
                int K = Integer.parseInt(numbers[3]);
                System.out.println("Case #" + (i+1) + ": " + solution(J, P, S, K));
                out.println("Case #" + (i+1) + ": " + solution(J, P, S, K));
            }
            
            out.close();
            br.close();
            
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }

    }

    private static String solution(int J, int P, int S, int repeats) {
        ArrayList<String> result = new ArrayList<String>();
        int minSK = (S < repeats) ? S : repeats;
        int counterS = 0;
        int counterP = 0;
        HashMap<Integer, Integer> used23 = new HashMap<Integer, Integer>();
        labelJ:
        for (int j = 0; j < J; j++) {
            labelP:
            for (int p1 = 0; p1 < P; p1++) {
                int p = counterP % P;
                int sStart = counterS % S;
                labelS:
                for (int s = sStart; s < sStart + minSK; ++s) {
                    int num23 = ( p+1) * 10 + (s%S+1);
                    if (used23.containsKey(num23) && used23.get(num23) >= repeats) {
                        continue labelS;
                    } else {
                        result.add("" + (j+1) + " " + (p+1) + " " + (s%S+1));
                        
                        if (used23.containsKey(num23)) {
                            int num = used23.get(num23);
                            used23.put(num23, num + 1);
                        } else {
                            used23.put(num23, 1);
                        }
                        counterS++;
                    }
                }
                counterP++;
            }
        }
            
        return printResult(result);
    }
    
    public static String printResult (ArrayList<String> result) {
        StringBuilder sb = new StringBuilder();
        sb.append(result.size());
        sb.append("\n");
        for (String str : result) {
            sb.append(str);
            sb.append("\n");
        }
        return sb.toString();
    }
}
