import sun.util.locale.AsciiUtil;

import java.io.*;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Main {

    static class Pass {

        String who;
        int where;

        Pass(String who, int where){

            this.who = who;
            this.where = where;
        }
    }

    public static void main(String args[]) throws IOException {



        int melodyLength;

        Charset charset = Charset.forName("US-ASCII");
        Path fileToRead = Paths.get("C:\\Users\\Ulyss\\Desktop\\A-small-attempt0.in");
        Path fileToWrite = Paths.get("C:\\Users\\Ulyss\\Desktop\\A-small-result.txt");




        BufferedReader br = Files.newBufferedReader(fileToRead, charset);
        PrintWriter pw = new PrintWriter(new FileWriter("C:\\Users\\Ulyss\\Desktop\\A-small-result.txt"));

        String line = br.readLine();

        int casesTotal = Integer.parseInt(line);

        for(int caseCount = 0; caseCount < casesTotal; caseCount++){

            line = br.readLine();

            StringTokenizer st = new StringTokenizer(line);

            melodyLength = Integer.parseInt(st.nextToken());

            System.out.println("Overall sounds = " + melodyLength);

            ArrayList<Pass> melody = new ArrayList<Pass>();

            for(int i = 0; i < melodyLength; i++){

                String who = st.nextToken();

                int where = Integer.parseInt(st.nextToken());

                if( who.equals("B") ){

                    melody.add(new Pass("Blue", where));
                }
                else {

                    melody.add(new Pass("Orange", where));
                }
            }

            int seconds = playSymphony(melody);

            pw.println("Case #" + (caseCount+1) + ": " + seconds);
        }

        br.close();
        pw.close();
    }

    public static int playSymphony(ArrayList<Pass> melody){

        int bluePosition = 1;
        int orangePosition = 1;

        int melodyLength = melody.size();

        int currentTone = 0;

        int seconds = 0;

        while( currentTone < melodyLength ){

            Pass pass = melody.get(currentTone);
            System.out.println("Now playing : " + pass.who + " - " + pass.where);


            // for orange

            if( pass.who.equals("Orange") ){

                if( pass.where == orangePosition ){

                    // orange play!

                    System.out.println("Orange plays!");
                    currentTone++;
                }
                else{

                    // orange goes

                    System.out.println("Orange goes from " + orangePosition + " to " + pass.where);

                    if( orangePosition < pass.where ){

                        orangePosition++;
                    }
                    else{

                        if( orangePosition > pass.where ){

                            orangePosition--;
                        }
                        else{

                            System.out.println("Error! Orange's time and place, WTF!!!");
                        }
                    }


                }
            }
            else{

                // not orange time...

                // we need to find where is next orange sound

                int nextOrangePosition = -1;

                for(int i = currentTone+1; i < melodyLength; i++){

                    if( melody.get(i).who.equals("Orange") ){

                        nextOrangePosition = melody.get(i).where;
                        break;
                    }
                }

                if( nextOrangePosition == -1 ){

                    // orange will not play anymore

                    System.out.println("Orange will not play more...");
                }
                else{

                    if( orangePosition < nextOrangePosition ){

                        System.out.println("Orange goes from " + orangePosition + " to " + nextOrangePosition);
                        orangePosition++;
                    }
                    else{

                        if( orangePosition > nextOrangePosition ){

                            System.out.println("Orange goes from " + orangePosition + " to " + nextOrangePosition);
                            orangePosition--;
                        }
                        else{

                            System.out.println("Orange wait for his time...");
                        }
                    }
                }
            }

            // for blue

            if( pass.who.equals("Blue") ){

                if( pass.where == bluePosition ){

                    // blue play!

                    System.out.println("Blue plays!");
                    currentTone++;
                }
                else{

                    // blue goes

                    if( bluePosition < pass.where ){

                        System.out.println("Blue goes from " + bluePosition + " to " + pass.where);
                        bluePosition++;
                    }
                    else{

                        if( bluePosition > pass.where ){

                            System.out.println("Blue goes from " + bluePosition + " to " + pass.where);
                            bluePosition--;
                        }
                        else{

                            System.out.println("Error! Blue's time and place, WTF!!!");
                        }


                    }
                }
            }
            else{

                // not blue time...

                // we need to find where is next blue sound

                int nextBluePosition = -1;

                for(int i = currentTone; i < melodyLength; i++){

                    if( melody.get(i).who.equals("Blue") ){

                        nextBluePosition = melody.get(i).where;
                        break;
                    }
                }

                if( nextBluePosition == -1 ){

                    // Blue will not play anymore

                    System.out.println("Blue will not play any more...");
                }
                else{

                    if( bluePosition < nextBluePosition ){

                        System.out.println("Blue goes from " + bluePosition + " to " + nextBluePosition);
                        bluePosition++;
                    }
                    else{

                        if( bluePosition > nextBluePosition ){

                            System.out.println("Blue goes from " + bluePosition + " to " + nextBluePosition);
                            bluePosition--;
                        }
                        else{

                            System.out.println("Blue wait for his time...");
                        }
                    }
                }
            }

            System.out.println("Step accomplished...");
            System.out.println();
            seconds++;
        }


        return seconds;
    }

}

















