import com.sun.xml.internal.ws.api.pipe.NextAction;

import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class Main {

    static class OppositionRule {

        char first;
        char second;

        OppositionRule(char f, char s){

            first = f;
            second = s;
        }
    }

    static class CombinationRule {

        char first;
        char second;
        char result;

        CombinationRule(char f, char s, char r){

            first = f;
            second = s;
            result = r;
        }
    }

    public static void main(String args[]) throws IOException {

        Charset charset = Charset.forName("US-ASCII");
        Path fileToRead = Paths.get("C:\\Users\\Ulyss\\Desktop\\B-small-attempt2.in");

        BufferedReader br = Files.newBufferedReader(fileToRead, charset);
        PrintWriter pw = new PrintWriter(new FileWriter("C:\\Users\\Ulyss\\Desktop\\B-small-result.txt"));

        String line = br.readLine();

        int casesTotal = Integer.parseInt(line);

        for(int caseCount = 0; caseCount < casesTotal; caseCount++){

            line = br.readLine();

            StringTokenizer st = new StringTokenizer(line);

            int combinationRules = Integer.parseInt(st.nextToken());

            ArrayList<CombinationRule> allCombinationRules = new ArrayList<CombinationRule>();

            for(int cRule = 0; cRule < combinationRules; cRule++){

                String ruleString = st.nextToken();

                allCombinationRules.add(new CombinationRule(
                    ruleString.charAt(0),
                    ruleString.charAt(1),
                    ruleString.charAt(2))
                );
            }

            int oppositionRules = Integer.parseInt(st.nextToken());

            ArrayList<OppositionRule> allOppositionRules = new ArrayList<OppositionRule>();

            for(int oRule = 0; oRule < oppositionRules; oRule++){

                String ruleString = st.nextToken();

                allOppositionRules.add(new OppositionRule(
                    ruleString.charAt(0),
                    ruleString.charAt(1))
                );
            }

            int lengthOfElementString = Integer.parseInt(st.nextToken());

            // reading sequence

            String elements = st.nextToken();

            ArrayList<Character> elementsAsArray = new ArrayList<Character>();

            for(int i = 0; i < elements.length(); i++){

                elementsAsArray.add(elements.charAt(i));
            }

            ArrayList<Character> result = solveMagic(elementsAsArray, allCombinationRules, allOppositionRules);

            pw.print("Case #" + (caseCount+1) + ": [");

            for(int i = 0; i < result.size()-1; i++){

                pw.print(result.get(i) + ", ");
            }

            if( result.size() != 0 ){

                pw.print(result.get(result.size()-1));
            }

            pw.println("]");
        }

        br.close();
        pw.close();
    }

    public static ArrayList<Character> solveMagic(  ArrayList<Character> elements,
                                                    ArrayList<CombinationRule> combinationRules,
                                                    ArrayList<OppositionRule> oppositionRules){
        System.out.println();
        System.out.println("Next call...");


        System.out.println(
            "C rules = " + combinationRules.size() +
            " O rules = " + oppositionRules.size() +
            " Elements seq length = " + elements.size());


        ArrayList<Character> result = new ArrayList<Character>();

        if( combinationRules == null && oppositionRules == null ){

            return elements;
        }

        // building step by step

        for( Character nextCall : elements ){

            // check combinations

            result.add((char) nextCall);

            if( result.size() != 1 ){


                while(true){

                    if( result.size() < 2 ) break;

                    int size = result.size();

                    char last = result.get(size-1);
                    char beforeLast = result.get(size-2);

                    boolean combinationHappened = false;

                    for( CombinationRule cRule : combinationRules ){

                        if( (cRule.first == last && cRule.second == beforeLast) ||
                            (cRule.first == beforeLast && cRule.second == last) ){

                            // change!
                            result.remove(size-1);
                            result.remove(size-2);
                            result.add(cRule.result);

                            combinationHappened = true;
                            break;
                        }
                    }

                    if( !combinationHappened ){

                        break;
                    }
                }
            }

            // check oppositions
            for( OppositionRule oRule : oppositionRules ){

                char lastElement = result.get(result.size()-1);

                if( oRule.first == lastElement || oRule.second == lastElement ){



                    for(int i = 0; i < result.size()-1; i++){

                        if( (result.get(i) == oRule.first || result.get(i) == oRule.second) && result.get(i) != lastElement ){

                            // destroy all!

                            result.clear();
                            break;

                        }
                    }
                }
            }
        }

        return result;
    }

}






































