package com.klyserv.codejam2014;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;

public class Minesweeper {
	
	private static Scanner reader;
	
	private static BufferedWriter writer;
	
	private static final int MINE=-1;
	
	private static final int C=-2;

	private static class Problem {
		private int row;
		private int column;
		private int minesCount;
		
		private String solve() {
			int[][] matrix=new int[row][column];
			for(int r=0;r<row;r++) {
				for(int c=0;c<column;c++) {
					matrix[r][c]=0;
				}
			}
			
			fill(matrix, minesCount);
			
			boolean possible=true;
			if(possible && row>1 && matrix[1][0]==MINE) possible=false; 
			if(possible && column>1 && matrix[0][1]==MINE) possible=false; 
			if(possible && row>1 && column>1 && matrix[1][1]==MINE) possible=false; 
			if(!possible) return "\nImpossible\n";
			
			matrix[0][0]=C;
			
			StringBuffer retString=new StringBuffer("\n");
			for(int r=0;r<row;r++) {
				for(int c=0;c<column;c++) {
					if(matrix[r][c]==MINE) retString.append("*");
					else if(matrix[r][c]==C) retString.append("c");
					else retString.append(".");
				}
				retString.append("\n");
			}
			
			return retString.toString();
		}
		
		private void fill(int[][] matrix, int mc) {
			int maxrc=row;
			if(column>maxrc) maxrc=column;
			for(int rc=maxrc-1;rc>=0 && mc>0;rc--) {
				for(int r=0;r<row && rc<column && mc>0 && matrix[r][rc]!=MINE;r++) {
					matrix[r][rc]=MINE; mc--;
				}
				for(int c=0;c<column && rc<row && mc>0 && matrix[rc][c]!=MINE;c++) {
					matrix[rc][c]=MINE; mc--;
				}
			}
		}

		private static Problem read() {
			Problem p=new Problem();
			p.row=reader.nextInt();
			p.column=reader.nextInt();
			p.minesCount=reader.nextInt();
			return p;
		}
		
	}
	
	public static void main(String[] args) throws Exception {
		Minesweeper ms=new Minesweeper();
		ms.openFile("small1.txt");
		int probCount=ms.readproblemCount();

		for(int probNumber=1;probNumber<=probCount;probNumber++) {
			Problem p=Problem.read();
			ms.write("Case #"+probNumber+": "+p.solve());
		}
		
		ms.closeFile();
	}

	private void writeConsole(String string) {
		System.out.print(string);
	}

	@SuppressWarnings("unused")
	private void write(String string) throws Exception {
		writer.write(string);
	}

	private int readproblemCount() {
		return reader.nextInt();
	}

	private void closeFile() throws Exception {
		reader.close();
		writer.close();
	}

	private void openFile(String fileName) throws Exception {
		File inputFile=new File(fileName);
		reader = new Scanner(inputFile);
		
		File outputFile=new File("output.txt");
		if (!outputFile.exists()) {
			outputFile.createNewFile();
		}
		FileWriter fw = new FileWriter(outputFile);
		writer=new BufferedWriter(fw);
	}

}
