package com.klyserv.codejam2014;

import java.io.File;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class MagicTrick {
	
	private Scanner reader;
	
	private static class Problem {
		private int firstAnswer;
		private Integer[][] firstArrangement;
		private int secondAnswer;
		private Integer[][] secondArrangement;
		
		private String solve() {
			Set<Integer> firstSet=new HashSet<Integer>(Arrays.asList(firstArrangement[firstAnswer-1]));
			Set<Integer> secondSet=new HashSet<Integer>(Arrays.asList(secondArrangement[secondAnswer-1]));
			
			firstSet.retainAll(secondSet);
			
			if(firstSet.size()==1) return Integer.toString(firstSet.iterator().next());
			if(firstSet.size()==0) return "Volunteer cheated!";
			return "Bad magician!";
		}
		
		
	}
	
	public static void main(String[] args) throws Exception {
		MagicTrick mt=new MagicTrick();
		mt.openFile("small1.txt");
		int probCount=mt.readproblemCount();

		for(int probNumber=1;probNumber<=probCount;probNumber++) {
			Problem p=mt.readProblem();
			System.out.println("Case #"+probNumber+": "+p.solve());
		}
	}

	private int readproblemCount() {
		return reader.nextInt();
	}

	private void closeFile() {
		reader.close();
	}

	private void openFile(String fileName) throws Exception {
		File inputFile;
		inputFile=new File(fileName);
		reader = new Scanner(inputFile);
	}

	private Problem readProblem() {
		Problem problem=new Problem();
		problem.firstAnswer=reader.nextInt();
		problem.firstArrangement=new Integer[4][];
		for(int i=0;i<4;i++){
			problem.firstArrangement[i]=new Integer[4];
			for(int j=0;j<4;j++){
				problem.firstArrangement[i][j]=reader.nextInt();
			}
		}

		problem.secondAnswer=reader.nextInt();
		problem.secondArrangement=new Integer[4][];
		for(int i=0;i<4;i++){
			problem.secondArrangement[i]=new Integer[4];
			for(int j=0;j<4;j++){
				problem.secondArrangement[i][j]=reader.nextInt();
			}
		}
		return problem;
	}

}
