import java.io.BufferedReader;
import java.io.*;
import java.io.IOException;
import java.util.*; 


class LawnMower {
    public static void main(String[] args) 
    {
        BufferedReader br = null;
        File outFile = null;
        String output = "";
 		int testCases;
 		int N;
 		int M;
 		String dimensions = "";
 		boolean isFeasible;
 		int hValue;
 		try 
 		{
 			
		 	outFile = new File("output.txt");
			br = new BufferedReader(new FileReader(args[0]));
			testCases = Integer.parseInt(br.readLine());
			for(int i = 1; i <= testCases; i++)
 			{
 				output += "Case #"+i+": ";
 				dimensions = br.readLine();
 				String[] tokens = dimensions.split(" ");
 				N = Integer.parseInt(tokens[0]);
 				M = Integer.parseInt(tokens[1]);
 				// System.out.println("Case->"+i+"|N->"+N+"|M->"+M);
 				//Create a Grid Map of the Lawn
				int lawn[][] = new int[N][M];
				for(int j = 0; j < N; j++)	
 					for(int k = 0; k < M; k++)	
 						lawn[j][k] = 0;
 				// Store the Lawn
 				String[] lawnRow = new String[N];
 				for(int j = 0; j < N; j++)	
 				{
 					lawnRow[j] = br.readLine();
 				}
 				// Try all the rows
 				for(int j = 0; j < N; j++)	
 				{
 					String[] height = lawnRow[j].split(" ");
 					//1st, check if row is feasible
 					isFeasible = false;
 					hValue = Integer.parseInt(height[0]);
 					for(int k = 0; k < M; k++)	
 					{	
 						if( hValue >= Integer.parseInt(height[k]))
 							isFeasible = true;
 						else
 						{
 							isFeasible = false;
 							break;
 						}
 					}
 					if(isFeasible)
 					{
 						//Next, if feasible, check how many can be cut
	 					for(int k = 0; k < M; k++)	
	 						if( hValue == Integer.parseInt(height[k]))
	 							lawn[j][k] = 1;
	 				}
	 			}
	 			// Try all the columns
 				for(int j = 0; j < M; j++)	
 				{
					String[] height = new String[N];
 					// Extract the column Height
 					int count=0;
 					for(int p = 0; p < N; p++)	
 					{
 						String[] tempHeight = lawnRow[p].split(" ");
 						height[count++] = tempHeight[j];
 					}
 					//1st, check if column is feasible
 					isFeasible = false;
 					hValue = Integer.parseInt(height[0]);
 					for(int k = 0; k < N; k++)	
 					{	
 						if( hValue >= Integer.parseInt(height[k]))
 							isFeasible = true;
 						else
 						{
 							isFeasible = false;
 							break;
 						}
 					}
 					if(isFeasible)
 					{
 						//Next, if feasible, check how many can be cut
	 					for(int k = 0; k < N; k++)	
	 						if( hValue == Integer.parseInt(height[k]))
	 							lawn[k][j] = 1;
	 				}
	 			}
	 			output += isFeasibleFunc(lawn,N,M);
	 			if(i != testCases)
	 				output += "\n";
 			}	
		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
		finally 
		{
			try 
			{
				if (br != null)br.close();
				save(outFile,output);
			} 	
			catch (IOException ex) 
			{
				ex.printStackTrace();
			}
		}
    }
	public static String isFeasibleFunc(int lawnMap[][],int N,int M) 
	{
		for(int i =0; i < N; i++)
			for(int j =0; j < M; j++)
				if(lawnMap[i][j] != 1)
					return "NO";			
		return "YES";
	}
    public static void save(File file, String textToSave) 
    {
	    file.delete();
	    try 
	    {
	        BufferedWriter out = new BufferedWriter(new FileWriter(file),32768);
	        out.write(textToSave);
	        out.close();
	    } 
	    catch (IOException e) 
	    {
	    }
}
}