import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
 
public class DeceitfulWar {
 
	public static void main(String[] args) {
		int testCases=0,caseNumber=1,numOfBlocks;
		String[] parameters = new String[3];
		double bestSolution,buyFarm,tempSolution;
		double cookies;
		boolean newGame,ken=false,naomi=true;
		String content="";
		ArrayList<Double> kenBlocks = new ArrayList<Double>();
		ArrayList<Double> naomiBlocks = new ArrayList<Double>();

 
		try (BufferedReader br = new BufferedReader(new FileReader("D-small-attempt0.in")))
		{
 
			String sCurrentLine;
 
			while ((sCurrentLine = br.readLine()) != null) {
				if(testCases == 0)
				{
					testCases = Integer.parseInt(sCurrentLine);
					continue;
				}
				// Let's start a new game
				newGame=true;
				// Clear the ArrayList contents (Clear is much faster than removeAll)
				kenBlocks.clear();
				naomiBlocks.clear();
				// Read the number of blocks involved in this game
				numOfBlocks = Integer.parseInt(sCurrentLine);
				while(newGame)
				{
					sCurrentLine = br.readLine();
					// Add the weights to Ken's ArrayList
					if(ken)
					{
						String[] explodedKen=sCurrentLine.split(" ");
						for(int i=0;i < numOfBlocks; i++)
							kenBlocks.add(Double.parseDouble(explodedKen[i]));
						// Reset all the states
						ken=false;
						naomi=true;
						newGame=false;

					}
					// Add the weights to Naomi's ArrayList
					else if(naomi)
					{
						String[] explodedNaomi=sCurrentLine.split(" ");
						for(int i=0;i < numOfBlocks; i++)
							naomiBlocks.add(Double.parseDouble(explodedNaomi[i]));
						// Flip the states so Ken can read his block sizes
						ken=true;
						naomi=false;
					}
				}
				
				content += "Case #"+caseNumber+": "+deceitfulWar(kenBlocks,naomiBlocks,numOfBlocks)+" "+war(kenBlocks,naomiBlocks);
				if(caseNumber != testCases)	
						content += "\n";
				caseNumber++;
			}

			System.out.println(content);
			// System.out.println("Test Cases :- "+testCases);
			try {
	 
					File file = new File("deceitfulWar.out");
		 
					// if file doesnt exists, then create it
					if (!file.exists()) {
						file.createNewFile();
					}
		 
					FileWriter fw = new FileWriter(file.getAbsoluteFile());
					BufferedWriter bw = new BufferedWriter(fw);
					bw.write(content);
					bw.close();
		 
				} catch (IOException e) {
					e.printStackTrace();
				}
 
		} catch (IOException e) {
			e.printStackTrace();
		} 
 
	}

	public static int deceitfulWar(ArrayList<Double> kenBlocks,ArrayList<Double> naomiBlocks,int numblocks)
	{
		int naomiWins = 0,naomiIndex,kenIndex,minKen,maxKen;
		double naomiTold;
		ArrayList<Double> kenBlocksClone = new ArrayList<Double>(kenBlocks);
		ArrayList<Double> naomiBlocksClone = new ArrayList<Double>(naomiBlocks);
		for(int k=0;k < numblocks; k++)
		{
			naomiIndex=-1;
			kenIndex=-1;
			// Naomi Cheating
			minKen=kenBlocksClone.indexOf(Collections.min(kenBlocksClone));
			maxKen=kenBlocksClone.indexOf(Collections.max(kenBlocksClone));

			// System.out.println("Min KEN-"+kenBlocksClone.get(minKen));
			// System.out.println("Max KEN-"+kenBlocksClone.get(maxKen));

			// Find the block for Naomi that is bigger than the smallest of Ken's Blocks
			for(int j=0;j < naomiBlocksClone.size(); j++)
				if(naomiBlocksClone.get(j) > kenBlocksClone.get(minKen))
					if(naomiIndex == -1 || naomiBlocksClone.get(j) < naomiBlocksClone.get(naomiIndex))
						naomiIndex=j;

			if(naomiIndex == -1)
			{
				naomiIndex=naomiBlocksClone.indexOf(Collections.min(naomiBlocksClone));
				naomiTold=naomiBlocksClone.get(naomiIndex);
			}
			else
				naomiTold=kenBlocksClone.get(maxKen)+((naomiWins+1)*0.0000001);
			// System.out.println("Naomi Told-"+naomiTold);
			naomiBlocksClone.remove(naomiIndex);

			// Ken plays his usual game, unsuspecting of the treachery
			for(int j=0;j < kenBlocksClone.size(); j++)
				if(naomiTold < kenBlocksClone.get(j))
					if(kenIndex == -1 || kenBlocksClone.get(j) < kenBlocksClone.get(kenIndex))
						kenIndex=j;

			if(kenIndex == -1)
			{
				naomiWins++;
				kenIndex=kenBlocksClone.indexOf(Collections.min(kenBlocksClone));
			}	
			kenBlocksClone.remove(kenIndex);
		}
		return naomiWins;
	}

	public static int war(ArrayList<Double> kenBlocks,ArrayList<Double> naomiBlocks)
	{
		int naomiWins = 0,index=-1;
		ArrayList<Double> kenBlocksClone = new ArrayList<Double>(kenBlocks);
		ArrayList<Double> naomiBlocksClone = new ArrayList<Double>(naomiBlocks);

		
		for(int i=0;i < naomiBlocksClone.size(); i++)
		{
			for(int j=0;j < kenBlocksClone.size(); j++)
				if(naomiBlocksClone.get(i) < kenBlocksClone.get(j))
					if(index == -1 || (kenBlocksClone.get(j) < kenBlocksClone.get(index)))
						index=j;
			if(index == -1)
			{
				naomiWins++;
				index=kenBlocksClone.indexOf(Collections.min(kenBlocksClone));
			}	
			kenBlocksClone.remove(index);
			index=-1;
		}
		return naomiWins;
	}
}