import java.io.BufferedReader;
import java.io.*;
import java.io.IOException;
import java.util.*; 

class FairAndSquare {
    public static void main(String[] args) 
    {
        BufferedReader br = null;
        File outFile = null;
 		int testCases;
 		String output = "";
 		String rangeString = "";
		try {
 		 	outFile = new File("output.txt");

			br = new BufferedReader(new FileReader(args[0]));
			testCases = Integer.parseInt(br.readLine());
 			for(int i = 1; i <= testCases; i++)
 			{
 				rangeString = br.readLine();
 				output += "Case #"+i+": ";
				String[] range = rangeString.split(" ");
 				long count=0;
				for(long j = Long.parseLong(range[0]); j <= Long.parseLong(range[1]); j++)
				{
					if(isSquareOfAPalindrome(j) && isPalindrome(j))
					{
						count++;
						// System.out.println("J -> "+j+"|count -> "+count);
					}
				}
				output += count;

 				if( i != testCases)
 					output += "\n";
 			}

		} 
		catch (IOException e) 
		{
			e.printStackTrace();
		}
		finally 
		{
			try 
			{
				if (br != null)br.close();
				save(outFile,output);
			} 	
			catch (IOException ex) 
			{
				ex.printStackTrace();
			}
		}
    }

	public final static boolean isSquareOfAPalindrome(long n)
	{
  		if (n < 0)
    		return false;

  		long tst = (long)(Math.sqrt(n) + 0.5);
  		if (tst*tst == n)
  			if(isPalindrome(tst))
  				return true;
  		return false;
	}

 	public static boolean isPalindrome(long number) 
 	{
        long palindrome = number; 
        long reverse = 0;

        while (palindrome != 0) 
        {
            long remainder = palindrome % 10;
            reverse = reverse * 10 + remainder;
            palindrome = palindrome / 10;
        }

        if (number == reverse) 
        {
            return true;
        }
        return false;
    }

    public static void save(File file, String textToSave) 
    {
	    file.delete();
	    try 
	    {
	        BufferedWriter out = new BufferedWriter(new FileWriter(file),32768);
	        out.write(textToSave);
	        out.close();
	    } 
	    catch (IOException e) 
	    {
	    }
}
}