import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.HashMap;

public class QualificationA {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException, IOException {
        BufferedReader br = new BufferedReader(new FileReader("input.in"));
        FileWriter fr = new FileWriter("out.txt");
        
        PrintWriter pr = new PrintWriter(fr);
        
        int cases = Integer.parseInt(br.readLine());
        
        for (int i = 0; i < cases; i++)
        {
            Line[] wins = new Line[10];
            boolean hasBlank = false;
            char[][] game = new char[4][4];
            
            for (int j = 0; j<4; j++)
            {
                game[j] = br.readLine().toCharArray();
                
                if (!hasBlank)
                {
                    for (char x : game[j])
                    {
                        if (x == '.')
                        {
                            hasBlank = true;
                        }
                    }
                }
            }
            
            for (int j = 0;j<4; j++)
            {
                char[] row = {game[j][0], game[j][1], game[j][2], game[j][3]};
                wins[j] = new Line(row);
            }
            
            for (int j = 0;j<4; j++)
            {
                char[] col = {game[0][j], game[1][j], game[2][j], game[3][j]};
                wins[j+4] = new Line(col);
            }
            
            char[] diag1 = {game[0][0], game[1][1], game[2][2], game[3][3]};
            char[] diag2 = {game[0][3], game[1][2], game[2][1], game[3][0]};
            
            wins[8] = new Line(diag1);
            wins[9] = new Line(diag2);
            
            boolean isWin = false;
                    
            for (Line l : wins)
            {
                if (l.countx == 4)
                {
                    System.out.println(String.format("Case #%d: X won", i+1));
                    pr.println(String.format("Case #%d: X won", i+1));
                    isWin = true;
                    break;
                }
                else if (l.counto == 4)
                {
                    System.out.println(String.format("Case #%d: O won", i+1));
                    pr.println(String.format("Case #%d: O won", i+1));
                    isWin = true;
                    break;
                }
            }
            
            if (!isWin)
            {
                if (hasBlank)
                {
                    System.out.println(String.format("Case #%d: Game has not completed", i+1));
                    pr.println(String.format("Case #%d: Game has not completed", i+1));
                }
                else
                {
                    System.out.println(String.format("Case #%d: Draw", i+1));
                    pr.println(String.format("Case #%d: Draw", i+1));
                }
            }
            br.readLine();
        }
        
        pr.close();
        fr.close();
    }
    

}

class Line
{
    public int countx;
    public int counto;
    
    public Line(char[] charLine)
    {
        for(char c : charLine)
        {
            if (c == 'X')
            {
                countx++;
            }
            else if (c == 'O')
            {
                counto++;
            }
            else if (c == 'T')
            {
                countx++;
                counto++;
            }
        }
    }
}
