import java.util.Iterator;
import java.util.Scanner;
import java.util.TreeSet;

public class DeceitfulWar {
	private static Scanner sc = new Scanner(System.in);
	
	public static int playWar(final TreeSet<Double> ken, final TreeSet<Double> naomi, int nBricks) {
		int naomiScore = 0;
		for (Double b: naomi) {
			Double reply = ken.higher(b);
			if (reply == null) { //if ken has no heavier brick
				naomiScore++;
				ken.pollFirst(); //ken throws his smallest brick
			} else { //if ken has a heavier brick (minimum to beat Naomi)
				ken.remove(reply);
			}
		}
		return naomiScore;
	}
	
	public static int playDeceitful(TreeSet<Double> ken, TreeSet<Double> naomi, int nBricks) {
		int naomiScore = nBricks;
		for (Double b: ken) {
			Double reply = naomi.higher(b);
			if (reply == null) { //if naomi has no heavier brick
				naomiScore--;
				naomi.pollFirst(); //naomi throws her smallest brick
			} else { //if naomi has a heavier brick (minimum to beat ken)
				naomi.remove(reply);
			}
		}
		return naomiScore;
	}

	@SuppressWarnings("unchecked")
	public static void main(String[] args) {
		int T = 0;
		int nCase = 1;
		T = sc.nextInt();
		while (T-- > 0) {
			int nBricks = sc.nextInt();
			int naomiBohong = 0, naomiJujur = 0;
			TreeSet<Double> naomi = new TreeSet<Double>();
			TreeSet<Double> ken = new TreeSet<Double>();
			for (int i = 0; i < nBricks; i++) {
				naomi.add(sc.nextDouble());
			}
			for (int i = 0; i < nBricks; i++) {
				ken.add(sc.nextDouble());
			}
			//naomiBohong = playDeceitful(ken, naomi, nBricks);
			naomiBohong = playDeceitful((TreeSet<Double>) ken.clone(), (TreeSet<Double>) naomi.clone() , nBricks);
			naomiJujur = playWar((TreeSet<Double>) ken.clone(), (TreeSet<Double>) naomi.clone(), nBricks);
			System.out.printf("Case #%d: %d %d\n", nCase++, naomiBohong, naomiJujur);
		}
	}

}
