package googleJam.qualification2016;

import java.io.*;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Set;

/**
 * Created by andi on 4/9/2016.
 */
public class B {
    public static void main(String[] args) throws Exception{

        BufferedReader buffer = null;
        BufferedWriter bw = null;
        final String insomnia = "INSOMNIA";

        buffer = new BufferedReader(new FileReader("D:\\Andrey\\jam\\preparation\\2016\\qualification\\B-small-attempt0(2).in"));
        File file = new File("D:\\Andrey\\jam\\preparation\\2016\\qualification\\Bsmall.out");
        if (!file.exists()) {
            file.createNewFile();
        }

        FileWriter fw = new FileWriter(file.getAbsoluteFile());
        bw = new BufferedWriter(fw);

        String line = buffer.readLine();
        if(line != null ){
            Integer caseCount = Integer.parseInt(line);

            for(int i=1; i<= caseCount; i++ ){
                System.out.println("-------CASE="+i+"-------------------------");
                StringBuffer output = new StringBuffer();

                line = buffer.readLine();

                long result = solve(line);

                output.append("Case #"+i+": "+result+"\n");
                System.out.println(result);



                bw.write(output.toString());
            }
            bw.close();

        }
    }

    public static long solve(String input){
        boolean[] in = new boolean[input.length()];
        Set<Integer> alreadyUsed = new HashSet<Integer>();
        Queue<Pancake> queue = new LinkedList<Pancake>();

        for(int i=0; i<input.length(); i++){
            if(input.charAt(i) == '+'){
                in[i] = true;
            }
        }

        queue.offer(new Pancake(in,0));
        while(!queue.isEmpty()){
            Pancake cake = queue.poll();
            if(isAllOver(cake.stack)) return cake.level;
            for(int i=0; i<cake.stack.length; i++){
                boolean[] tmpArr = flip(cake.stack,i);
                int hash = coverToInt(tmpArr);
                if(!alreadyUsed.contains(hash)){
                    alreadyUsed.add(hash);
                    queue.offer(new Pancake(tmpArr, cake.level+1));
                }
            }

        }


        return 0;
    }

    public static int coverToInt(boolean[] arr){
        int res = 0;
        for(int i=0; i<arr.length; i++){
            if(arr[i]) res = res|(1<<i);
        }
        return res;
    }
    public static boolean isAllOver(boolean[] arr){
        for(boolean el : arr){
            if(!el) return false;
        }
        return true;
    }

    public static boolean[] flip(boolean arr[], int pos){
        boolean[] resArray = new boolean[arr.length];
        System.arraycopy(arr,0,resArray,0,arr.length);
        int start = 0;
        int end = pos;
        while(start<end){
            boolean tmp = !resArray[start];
            resArray[start] = !resArray[end];
            resArray[end] = tmp;
            start ++;
            end --;
        }
        if(start == end) resArray[start] = !resArray[start];

        return resArray;
    }
}

class Pancake{

    public boolean[] stack;
    long level;

    public Pancake(boolean[] arr, long lev){
        this.stack = arr;
        this.level = lev;
    }
}
