package main.gjam;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by andi on 4/9/2017.
 */
public class J2017QualC {
    public static void main(String[] args) throws IOException {

        Scanner scanner = new Scanner(new File("D:\\gjam\\Qual-2017C-test.in"));
        FileWriter wr = new FileWriter(new File("D:\\gjam\\Qual-2017C-small-one.out"));

        int totalTests = scanner.nextInt();

        boolean wasPrevNextLine = false;

        for(int i=1; i<=totalTests; i++){
            if(!wasPrevNextLine) scanner.nextLine();

            String line = scanner.nextLine();
            String[] parts = line.split(" ");

            int N = Integer.parseInt(parts[0]);
            int K = Integer.parseInt(parts[1]);
            //wasPrevNextLine = false;

            wasPrevNextLine = true;

            System.out.println("Case#"+i);
            System.out.println("N="+N+" K="+K);
            String result = calculate(N, K);
            System.out.println("result="+result);
            wr.write("Case #"+i+": "+result+"\n");
        }

        wr.close();

    }

    public static String calculate(int N, int K){
        int[] left = new int[N];
        int[] right = new int[N];
        int[] stalls = new int[N];

        int maxRes = 0, minRes = 0;

        for(int i=0; i<K; i++){
            int prev = 0;
            for(int j=0; j<N; j++){
                if(stalls[j] == 0){
                    left[j] = prev;
                    prev++;
                }
                else{
                    prev = 0;
                    left[j] = -1;
                }
            }

            prev = 0;
            List<Integer> selected = new ArrayList<>();
            int max = Integer.MIN_VALUE;

            for(int j=N-1; j>=0; j--){
                if(stalls[j] == 0){
                    right[j] = prev;
                    prev ++;
                    int mx = Math.min(right[j], left[j]);
                    if(mx > max){
                        max = mx;
                        selected.clear();
                        selected.add(j);
                    }
                    else if(mx == max){
                        selected.add(j);
                    }
                }
                else{
                    prev = 0;
                    right[j] = -1;
                }
            }
            int selectedIndex = selected.get(0);
            if(selected.size() > 1){
                max = Integer.MIN_VALUE;
                for(int pos : selected){
                    if(Math.max(left[pos], right[pos])>max){
                        max = Math.max(left[pos], right[pos]);
                        selectedIndex = pos;
                    }
                    else if(Math.max(left[pos], right[pos])==max){
                        selectedIndex = Math.min(selectedIndex, pos);
                    }
                }
            }
            stalls[selectedIndex] = 1;
            if(i == K-1) {
                maxRes = Math.max(left[selectedIndex], right[selectedIndex]);
                minRes = Math.min(left[selectedIndex], right[selectedIndex]);
            }

        }

        return maxRes+" "+minRes;
    }

}
