package main.gjam;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

/**
 * Created by andi on 4/8/2017.
 */
public class J2017QualA {

    private static final String IMPOSSIBLE = "IMPOSSIBLE";
    

    public static void main(String[] args) throws IOException {

        Scanner scanner = new Scanner(new File("D:\\gjam\\Qual-2017A-test.in"));
        FileWriter wr = new FileWriter(new File("D:\\gjam\\Qual-2017A-test.out"));

        int totalTests = scanner.nextInt();

        boolean wasPrevNextLine = false;

        for(int i=1; i<=totalTests; i++){
            if(!wasPrevNextLine) scanner.nextLine();

            String line = scanner.nextLine();
            String[] parts = line.split(" ");
            String S = parts[0];
            int K = Integer.parseInt(parts[1]);
            //wasPrevNextLine = false;

            wasPrevNextLine = true;

            System.out.println("Case#"+i);
            System.out.println("S="+S+" K="+K);
            String result = calculate(S, K);
            System.out.println("result="+result);
            wr.write("Case #"+i+": "+result+"\n");
        }

        wr.close();

    }

    public static String calculate(String S, int K){
        int totalCount = 0;

        if(isCorrect(S)) return "0";
        Set<String> used = new HashSet<>();
        Queue<State> queue = new LinkedList<>();
        queue.offer(new State(S, 0));

        while(!queue.isEmpty()){
            State state = queue.poll();
            for(int i=0; i<state.S.length(); i++){
                String str = flip(state.S, K, i);
                if(!used.contains(str)){
                    if(isCorrect(str)) return (state.count+1)+"";
                    used.add(str);
                    queue.offer(new State(str, state.count+1));
                }
            }
        }

        return IMPOSSIBLE;
    }

    public static String flip(String S, int K, int index){

        StringBuilder result = new StringBuilder();
        int left = S.length()-K;
        if(left < index) index = left;

        for(int i=0; i<S.length(); i++){
            if(i>= index && i<index+K){
                result.append((S.charAt(i) == '-')?'+':'-');
            }
            else{
                result.append(S.charAt(i));
            }
        }

        return result.toString();
    }
    public static boolean isCorrect(String S){

        for(char ch : S.toCharArray()){
            if(ch == '-') return false;
        }

        return true;
    }
}
class State{
    public String S;
    int count;

    public State(String S, int count){
        this.S = S;
        this.count = count;
    }
}
