package main.gjam;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * Created by andi on 4/15/2017.
 */
public class J20171AA {

    public static void main1(String[] args){

        boolean a = isCorrect(new char[][]{{'E', 'E'}, {'E', 'E'}, {'C', 'C'}, {'B', 'D'}, {'A', 'A'}, {'A', 'A'}});

        String[] res = calculate(new String[]{"??", "?E", "C?", "BD", "??", "A?"}, 6,2);
        System.out.println(Arrays.toString(res));
    }
    public static void main(String[] args) throws IOException {

        Scanner scanner = new Scanner(new File("D:\\gjam\\A-large-practice(3).in"));
        FileWriter wr = new FileWriter(new File("D:\\gjam\\1A-2017A-large.out"));

        int totalTests = scanner.nextInt();

        boolean wasPrevNextLine = false;

        for(int i=1; i<=totalTests; i++){
            if(!wasPrevNextLine) scanner.nextLine();
            Integer R = scanner.nextInt();
            Integer C = scanner.nextInt();
            scanner.nextLine();
            String[] cake = new String[R];
            for(int j=0; j<R; j++){
                cake[j] = scanner.nextLine();
            }


            //wasPrevNextLine = false;

            wasPrevNextLine = true;

            System.out.println("Case#"+i);
            System.out.println("R="+R+" C="+C+" array="+ Arrays.toString(cake));
            String[] result = calculate(cake, R, C);
            System.out.println("result="+Arrays.toString(result));
            wr.write("Case #"+i+": "+"\n");
            for(String str : result){
                wr.write(str+"\n");
            }
        }

        wr.close();

    }

    public static String[] calculateNew(String[] cake, int R, int C){

        Set<Character> usedChars = new HashSet<>();
        char[][] map = new char[R][C];
        boolean needToProcess = false;
        for(int i=0; i<cake.length; i++){
            for(int j=0; j<C; j++){
                char ch = cake[i].charAt(j);
                map[i][j] = ch;
                if(ch != '?') usedChars.add(ch);
                else needToProcess = true;
            }
        }
        if(!needToProcess) return cake;
        String[] result = convertToString(fillForm(map, 0,0, usedChars));
        return result;
    }

    public static String[] calculate(String[] cake, int R, int C){

        Set<Character> usedChars = new HashSet<>();
        char[][] map = new char[R][C];
        boolean needToProcess = false;
        for(int i=0; i<cake.length; i++){
            for(int j=0; j<C; j++){
                char ch = cake[i].charAt(j);
                map[i][j] = ch;
                if(ch != '?') usedChars.add(ch);
                else needToProcess = true;
            }
        }
        if(!needToProcess) return cake;


        for(int i=0; i<map.length; i++){
            for(int j=0; j<map[0].length; j++){
                if(map[i][j] != '?'){
                    char ch = map[i][j];
                    while(j<map[0].length -1 && map[i][j+1] == '?'){
                        map[i][j+1] = ch;
                        j++;
                    }
                }
            }
            char last = '?';
            for(int j=map[0].length-1; j>=0; j--){
                if(map[i][j] != '?') last = map[i][j];
                map[i][j] = last;
            }
        }

        for (int j = 0; j < map[0].length; j++) {
            char last = '?';
            for (int i = 0; i < map.length; i++) {
                if (map[i][j] != '?') last = map[i][j];
                map[i][j] = last;
            }
        }
        for (int j = 0; j < map[0].length; j++) {
            char last = '?';
            for (int i = map.length - 1; i >= 0; i--) {
                if (map[i][j] != '?') last = map[i][j];
                map[i][j] = last;
            }
        }
        String[] result = convertToString(map);
        return result;
    }

    public static char[][] fillForm(char[][] map, int r, int c, Set<Character> possibleChars){
        if(r > map.length) return map;

        for(int i=r; i<map.length; i++){
            for(int j=c; j<map[0].length; j++){
                if(map[i][j] == '?'){
                    for(Character ch : possibleChars){
                        char[][] copy = deepCopy(map);
                        int tmpI = i, tmpJ = j+1;
                        if(tmpJ >map[0].length) {
                            tmpJ = 0;
                            tmpI++;
                        }
                        copy[i][j] = ch;
                        char[][] res = fillForm(copy, tmpI,tmpJ, possibleChars);
                        if(res != null && isCorrect(res)){
                            return res;
                        }
                    }
                }
            }
            c=0;
        }
        return map;
    }

    public static String[] convertToString(char[][] map){
        String[] res = new String[map.length];
        for(int i=0; i<map.length; i++){
            res[i] = new String(map[i]);
        }
        return res;
    }

    public static boolean isCorrect(char[][] map){

        Set<Character> processedChars = new HashSet<>();
        for(int i=0; i<map.length; i++){
            for(int j=0; j<map[0].length; j++){
                if(map[i][j] == '?') return false;
                if(processedChars.contains(map[i][j])) continue;
                processedChars.add(map[i][j]);
                int row = i, col=j;
                while(row<map.length-1 && map[row+1][j] == map[i][j]) row++;
                while(col<map[0].length-1 && map[i][col+1] == map[i][j]) col++;
                if(!containsInRec(map, i, row, j, col, map[i][j])) return false;

            }
        }
        return true;
    }

    public static boolean containsInRec(char[][] map, int startRow, int endRow, int startCol, int endCol, char ch){
        for(int i=startRow; i<=endRow; i++){
            for(int j = startCol; j<=endCol; j++){
                if(map[i][j] != ch) return false;
            }
        }
        for(int i=0; i<map.length; i++){
            for(int j=0; j<map[0].length; j++){
                if(map[i][j] == ch){
                    if(i>= startRow && i<=endRow && j>=startCol && j<=endCol){
                        continue;
                    }
                    return false;
                }
            }
        }
        return true;
    }
    public static char[][] deepCopy(char[][] original) {
        if (original == null) {
            return null;
        }

        final char[][] result = new char[original.length][];
        for (int i = 0; i < original.length; i++) {
            result[i] = Arrays.copyOf(original[i], original[i].length);
        }
        return result;
    }
}
