package com.andreaf.bathroom;

import java.util.TreeSet;

public class Bathroom {

    public String lastPersonResult(int size, int person) {
        boolean[] stall = new boolean[size + 2];
        stall[0] = true;
        stall[stall.length - 1] = true;
        for (int i = 0; i < person - 1; i++) {
            bookStall(stall);
        }
        return printStall(stall);

    }

    private String printStall(boolean[] stall) {
        int lastPersonStall = nextStall(stall);
        return computeLs(stall, lastPersonStall) + " " + computeRs(stall, lastPersonStall);
    }

    private void bookStall(boolean[] stall) {
        int index = nextStall(stall);
        stall[index] = true;
    }

    private int nextStall(boolean[] stall) {
        TreeSet<Position> positions = new TreeSet<>();
        for (int i = 1; i < stall.length - 1; i++) {
            if (stall[i]) {
                continue;
            }
            int ls = computeLs(stall, i);
            int rs = computeRs(stall, i);
            positions.add(new Position(Math.min(ls, rs), Math.max(ls, rs), i));
        }
        return positions.last().getPosition();
    }


    public int computeLs(boolean[] stalls, int start) {
        int count = 0;
        for (int i = start - 1; i > 0; i--) {
            if (stalls[i]) {
                return count;
            }
            count++;
        }
        return count;
    }

    public int computeRs(boolean[] stalls, int start) {
        int count = 0;
        for (int i = start + 1; i < stalls.length; i++) {
            if (stalls[i]) {
                return count;
            }
            count++;
        }
        return count;
    }
}
