package codejam2008.helper;

import java.io.*;

public class AnswerWriter {
	private int counter;
	
	private String filename;
	
	private String buffer;
	
	public AnswerWriter(String basename) {
		this.counter = 1;
		this.buffer = "";
		this.filename = basename + ".out";
	}
	
	public void answer(String answer) {
		buffer += String.format("Case #%d: %s\n", counter++, answer);
	}
	
	public void close(boolean output) throws IOException {
		FileWriter writer = null;
		
		try {
			writer = new FileWriter(filename);
		
			writer.write(buffer);
		} finally {
			if (writer != null) {
				writer.close();
			}
		}
		
		if (output) {
			System.out.print(buffer);
		}
	}
	
	public void close() throws IOException {
		close(true);
	}
}
