import java.io.*;
import java.util.Collection;
import java.util.List;
import java.util.Vector;

public class Main {
	public static void main(String[] args) {
		if (args.length == 0) {
			System.out.println("Provide a file for input as the first argument.");
			
			return;
		}
		
		BufferedReader reader = null;
		BufferedWriter writer = null;
		
		try {
			reader = new BufferedReader(new FileReader(args[0]));
			writer = new BufferedWriter(new FileWriter(args[0] + ".out"));
			
			int countTests = Integer.parseInt(reader.readLine());
			
			for (int i = 1; i <= countTests; ++i) {
				List<String> engines = new Vector<String>();
				List<String> queries = new Vector<String>();
				
				Collection<List<String>> lists = new Vector<List<String>>(2);
				
				lists.add(engines);
				lists.add(queries);
				
				for (List<String> list : lists) {
					int countElements = Integer.parseInt(reader.readLine());
					
					for (int j = 1; j <= countElements; ++j) {
						list.add(reader.readLine());
					}
				}
				
				writer.write(String.format("Case #%d: %d", i, calculateMinSwitches(engines, queries)));
				writer.newLine();
			}
		} catch (FileNotFoundException e) {
			System.out.println("File not found!");
		} catch (IOException e) {
			System.out.println(String.format("I/O error:\n%s", e.getMessage()));
		} finally {
			Collection<Closeable> closeables = new Vector<Closeable>(2);
			
			closeables.add(reader);
			closeables.add(writer);
			
			for (Closeable closeable : closeables) {
				if (closeable != null) {
					try {
						closeable.close();
					} catch (IOException e) {
						System.out.println("Error closing I/O objects!");
					}
				}
			}
		}
	}
	
	private static int calculateMinSwitches(List<String> engines, List<String> queries) {
		int greaterFirstIndex = 0;
		
		for (String engine : engines) {
			int firstIndex = queries.indexOf(engine);
			
			if (firstIndex == -1) {
				return 0;
			}
			
			if (firstIndex > greaterFirstIndex) {
				greaterFirstIndex = firstIndex;
			}
		}
		
		queries.subList(0, greaterFirstIndex).clear();
		
		return 1 + calculateMinSwitches(engines, queries);
	}
}
