package codejam2008.r1;

import java.io.*;
import java.util.*;

import codejam2008.helper.*;

public class Crop {
	private static class Point {
		public long x;
		public long y;
		
		public Point(long x, long y) {
			this.x = x;
			this.y = y;
		}
	}
	
	public static void main(String[] args) throws IOException {
		Checker.check(args);
		
		String file = args[0];
		
		java.util.List<String> lines = Parser.parse(file);
	
		AnswerWriter aw = new AnswerWriter(file);
		
		for (String line : lines) {
			aw.answer(String.valueOf(countStatisfies(parseTrees(line))));
		}
		
		aw.close();
	}
	
	private static List<Point> parseTrees(String s) {
		String[] t = s.split(" ");
		
		List<Point> trees = new ArrayList<Point>();
		
		long n = Long.parseLong(t[0]);
		
		long A = Long.parseLong(t[1]);
		long B = Long.parseLong(t[2]);
		long C = Long.parseLong(t[3]);
		long D = Long.parseLong(t[4]);
		
		long X = Long.parseLong(t[5]);
		long Y = Long.parseLong(t[6]);
		
		long M = Long.parseLong(t[7]);
		
		trees.add(new Point(X, Y));
		
		for (int i = 1; i < n; ++i) {
			X = (A * X + B) % M;
			Y = (C * Y + D) % M;
			
			trees.add(new Point(X, Y));
		}
		
		return trees;
	}

	private static boolean isOk(Point t1, Point t2, Point t3) {
		long x = t1.x + t2.x + t3.x;
		long y = t1.y + t2.y + t3.y;
		
		if ((x % 3 == 0) && (y % 3 == 0)) {
			return true;
		} else {
			return false;
		}
	}
	
	private static int countStatisfies(List<Point> trees) {
		int ok = 0;
		
		for (int i = 0; i < trees.size(); ++i) {
			for (int j = i + 1; j < trees.size(); ++j) {
				for (int k = j + 1; k < trees.size(); ++k) {
					if (isOk(trees.get(i), trees.get(j), trees.get(k))) {
						++ok;
					}
				}
			}
		}
		
		return ok;
	}
}
