package codejam2008.helper;

import java.io.*;
import java.util.*;

public class Parser {
	public static List<String> parse(String filename) throws IOException {
		BufferedReader reader = null;
		
		try {
			reader = new BufferedReader(new FileReader(filename));
			
			int numCases = Integer.parseInt(reader.readLine());
			
			List<String> lines = new ArrayList<String>(numCases);
			
			for (int i = 1; i <= numCases; ++i) {
				lines.add(reader.readLine());
			}
			
			return lines;
		} finally {
			if (reader != null) {
				reader.close();
			}
		}
	}
	
	public static List<List<String>> parseNotKnowsFilesPerCase(String filename, int lineDefinesCaseNumLines) throws IOException {
		BufferedReader reader = null;
		
		try {
			reader = new BufferedReader(new FileReader(filename));
			
			int numCases = readlineAsInt(reader);
			
			List<List<String>> kases = new ArrayList<List<String>>(numCases);
			
			for (int i = 1; i <= numCases; ++i) {
				List<String> kase = new ArrayList<String>();
				
				for (int j = 1; j < lineDefinesCaseNumLines; ++j) {
					kase.add(reader.readLine());
				}
				
				int caseNumLines = readlineAsInt(reader);
				
				kase.add(String.valueOf(caseNumLines));
				
				for (int j = 1; j <= caseNumLines; ++j) {
					kase.add(reader.readLine());
				}
				
				kases.add(kase);
			}
			
			return kases;
		} finally {
			if (reader != null) {
				reader.close();
			}
		}
	}
	
	public static List<List<String>> parseKnowsLinesPerCase(String filename, int numLinesPerCase) throws IOException {
		BufferedReader reader = null;
		
		try {
			reader = new BufferedReader(new FileReader(filename));
			
			int numCases = readlineAsInt(reader);
			
			List<List<String>> kases = new ArrayList<List<String>>(numCases);
			
			for (int i = 1; i <= numCases; ++i) {
				List<String> kase = new ArrayList<String>(numLinesPerCase);
				
				for (int j = 1; j <= numLinesPerCase; ++j) {
					kase.add(reader.readLine());
				}
				
				kases.add(kase);
			}
			
			return kases;
		} finally {
			if (reader != null) {
				reader.close();
			}
		}
	}
	
	private static int readlineAsInt(BufferedReader reader) throws IOException {
		return Integer.parseInt(reader.readLine());
	}
}
