package com.andreikkaa;

import com.sun.xml.internal.fastinfoset.util.CharArray;

import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

public class Main {
    private static Scanner in;
    private static PrintWriter out;

    public static void main(String[] args) throws FileNotFoundException {
        InputStream inputStream;
        OutputStream outputStream;
        if (args.length == 0) {
            inputStream = System.in;
            outputStream = System.out;
        } else {
            inputStream = new FileInputStream(new File("input.txt"));
            outputStream = new FileOutputStream(new File("output.txt"));
        }
        in = new Scanner(inputStream);
        out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        solver.solve();
        out.close();
    }

    private static class TaskB {
        void go(char[] s) {
            int ans = 1;
            if (s[s.length - 1] == '+')
                --ans;
            for (int i = 1; i < s.length; ++i)
                if (s[i - 1] != s[i])
                    ++ans;
            out.println(ans);
        }

        void solve() {
            int t = in.nextInt();
            for (int i = 1; i <= t; ++i) {
                out.print("Case #" + i + ": ");
                go(in.next().toCharArray());
            }
        }
    }

    private static class TaskA {
        void go(BigInteger x) {
            boolean[] used = new boolean[10];
            BigInteger to = new BigInteger("10000");
            for (BigInteger i = BigInteger.ONE; i.compareTo(to) == -1; i = i.add(BigInteger.ONE)) {
                BigInteger y = x.multiply(i);
                for (char c : y.toString().toCharArray()) {
                    used[c - '0'] = true;
                }
                boolean st = true;
                for (boolean j : used) {
                    if (!j) {
                        st = false;
                        break;
                    }
                }
                if (st) {
                    out.println(y);
                    return;
                }
            }
            out.println("INSOMNIA");
        }

        void solve() {
            int t = in.nextInt();
            for (int i = 1; i <= t; ++i) {
                out.print("Case #" + i + ": ");
                go(in.nextBigInteger());
            }
        }
    }
}
