import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;


public class OversizedPancakeFlipper {
	public static HashMap<ArrayList<Boolean>, Integer> dp;
	public static class Pattern {
		int start;
		int end;
		Pattern(int start, int end) {
			this.start = start;
			this.end = end;
		}
		public String toString() {
			return "(" + start + "," + end + ")";
		}
	}
	public static void main(String[] args) {
		Scanner sc = new Scanner(System.in);
		dp = new HashMap<ArrayList<Boolean>, Integer>();
		int t = sc.nextInt();
		for(int i=0; i<t; i++) {
			String plusMinus = sc.next();
			int k = sc.nextInt();
			ArrayList<Boolean> arr = new ArrayList<Boolean>();
			for(int l=0; l<plusMinus.length(); l++) {
				if(plusMinus.charAt(l) == '-') {
					arr.add(false);
					continue;
				}
				arr.add(true);
			}
			ArrayList<Pattern> patterns = getPatterns(k, arr.size());
			//System.out.println("The Patterns: " + patterns);
			int n = solve(arr, patterns, -1, 0);
			String printOutput = "Case #" + (i+1) + ": ";
			if(n == -1) {
				//impossible
				printOutput += "IMPOSSIBLE";
			}else {
				printOutput += n;
			}
			System.out.println(printOutput);
		}
	}
	
	private static ArrayList<Pattern> getPatterns(int k, int size) {
		//get all the possible start and end spots with a spachela of size k and size number of pancakes
		ArrayList<Pattern> patterns = new ArrayList<Pattern>();
		int start = 0;
		int end = (start+k)-1;
		patterns.add(new Pattern(start, end));
		while((end+1) < size) {
			start++;
			end++;
			patterns.add(new Pattern(start, end));
		}
		return patterns;
	}
	
	private static int solve(ArrayList<Boolean> arr, ArrayList<Pattern> patterns, int bestSoFar, int cum) {
		//if(bestSoFar != -1 && cum > bestSoFar) {
			//cut off the recursive depth here because we already have something better
			//return -1;
		//}
		if(dp.containsKey(arr)) {
			return dp.get(arr);
		}
		if(isSolved(arr)) {
			dp.put(arr, 0);
			return 0;
		}
		dp.put(arr, -1);
		int bestCount = Integer.MAX_VALUE;
		boolean foundSomething = false;
		for(Pattern nextPattern: patterns) {
			ArrayList<Boolean> arr2 = getNewArr(arr, nextPattern);
			int bestSoFar2 = bestCount;
			if(!foundSomething) {
				bestSoFar2 = -1;
			}
			int amt = solve(arr2, patterns, bestSoFar2, cum+1);
			if(amt < bestCount && amt > -1) {
				bestCount = amt;
				foundSomething = true;
			}
		}
		if(!foundSomething) {
			bestCount = -1;
		}
		if(bestCount > -1) {
			bestCount++;
		}
		dp.put(arr, bestCount);
		return bestCount;
	}
	
	private static ArrayList<Boolean> getNewArr(ArrayList<Boolean> arr, Pattern pattern) {
		ArrayList<Boolean> arr2 = new ArrayList<Boolean>();
		for(int i=0; i<arr.size(); i++) {
			Boolean oneToAdd = new Boolean(arr.get(i));
			if(i >= pattern.start && i <= pattern.end) {
				oneToAdd = !oneToAdd;
			}
			arr2.add(oneToAdd);
		}
		return arr2;
	}
	
	private static boolean isSolved(ArrayList<Boolean> arr) {
		for(Boolean item: arr) {
			if(!item) {
				return false;
			}
		}
		return true;
	}
}
