import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;


public class JamCoins {
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(System.in);
		
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));
		
		int n = sc.nextInt();
		for(int i=0; i<n; i++) {
			int digits = sc.nextInt();
			int numOfCoins = sc.nextInt();
			
			String[][] last = find(digits, numOfCoins);
			out.println("Case #" + (i+1) + ":");
			System.out.println("Case #" + (i+1) + ":");
			
			for(int t=0; t<last.length; t++) {
				for(int l=0; l<last[t].length; l++) {
					System.out.print(last[t][l]);
					out.print(last[t][l]);
					if(l != last[t].length-1) {
						//this is not last time
						System.out.print(" ");
						out.print(" ");
					}
				}
				System.out.print("\n");
				out.print("\n");
			}
			
		}
		out.close();
	}
	
	public static String[][] find(int digits, int numOfCoins) {
		ArrayList<String> nums = getAllNums(digits-2);
		for(int i=0; i<nums.size(); i++) {
			nums.set(i, "1"+nums.get(i)+"1");
		}
		
		String[][] returnStr = new String[numOfCoins][10];
		int nextCoin = 0;
		for(String myNum: nums) {
			long[] baseValues = new long[9];
			for(int i=0; i<baseValues.length; i++) {
				baseValues[i] = Long.parseLong(myNum, i+2);
				//System.out.println("val: " + baseValues[i]);
			}
			
			
			//verify if this is a coin?
			boolean continueOn = false;
			String[] factors = new String[9];
			for(int i=0; i<baseValues.length; i++) {
				factors[i] = findAFactor(baseValues[i]);
				if(factors[i].equals("-1")) {
					//this is a prime so break out and move on to the next coin
					continueOn = true;
					break;
				}
			}
			if(continueOn) {
				continue;
			}
			
			//this must be a good number, add it
			String[] coin = {myNum, factors[0], factors[1], factors[2], factors[3], factors[4], factors[5], factors[6], factors[7], factors[8]};
			returnStr[nextCoin] = coin;
			nextCoin++;
			
			if(nextCoin == numOfCoins) {
				break;
			}
		}
		return returnStr;
	}
	public static ArrayList<String> getAllNums(int numOfDigits) {
		if(numOfDigits == 0) {
			return new ArrayList<String>();
		}else if(numOfDigits == 1) {
			ArrayList<String> currentNums = new ArrayList<String>();
			currentNums.add("0");
			currentNums.add("1");
			return currentNums;
		}
		ArrayList<String> currentNums = getAllNums(numOfDigits-1);
		ArrayList<String> fullNums = new ArrayList<String>();
		for(String myStr: currentNums) {
			fullNums.add("0" + myStr);
			fullNums.add("1" + myStr);
		}
		return fullNums;
	}
	
	public static String findAFactor(long num) {
		
		if(num % 2 == 0) {
			return "2";
		}
		
		for(long i=3; i<=Math.sqrt(num); i+=2) {
			if(num % i == 0) {
				return "" + i;
			}
		}
		
		return "-1";
	}
}
