/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CodeJam;

import java.io.File;
import java.io.IOException;
import java.util.*;
import org.apache.commons.io.FileUtils;

/**
 *
 * @author Andres
 */
public class DeceitfulWar {
    public static String pathToDownloads = "C:\\Users\\Andres\\Desktop\\";
    
    public static int[] readNInts(int N, Scanner s){
        int [] arr = new int[N];
        for (int i = 0; i < N; i++) {
            arr[i] = s.nextInt();
        }
        return arr;
    }
    
    public static LinkedList<Double> readNDoubles(int N, Scanner s){
        LinkedList<Double> arr = new LinkedList<Double>();
        for (int i = 0; i < N; i++) {
            arr.add(s.nextDouble());
        }
        return arr;
    }
    
    public static String caseOutput(int caseNum, String output){
        return "Case #"+caseNum+": " + output;
    }
    
    public static void main(String [] args) throws IOException{
        String s = FileUtils.readFileToString(new File(pathToDownloads + "test.in"));
        StringBuilder retval = new StringBuilder();
        Scanner in = new Scanner(s);
        int testCases = in.nextInt();
        for(int i = 0; i < testCases; i++){
            int N = in.nextInt();
            LinkedList<Double> naomi = readNDoubles(N,in);
            LinkedList<Double> ken = readNDoubles(N,in);
            Collections.sort(naomi);
            Collections.sort(ken);
            int pointsDWar = playDWar(naomi,ken);
            int pointsWar = playWar(naomi,ken);
            retval.append(caseOutput(i+1,String.valueOf(pointsDWar) + " " + String.valueOf(pointsWar))).append("\n");
        }
        FileUtils.writeStringToFile(new File(pathToDownloads + "test.out"), retval.substring(0,retval.length()-1));
    }
    
    private static int playWar(LinkedList<Double> naomi, LinkedList<Double> ken){
        int points = 0;
        while(!naomi.isEmpty()){
            double n = naomi.removeFirst();
            int ind = getClosestWinner(n,ken);
            if(ind != -1){
                ken.remove(ind);
            } else {
                ken.removeFirst();
                points++;
            }
        }
        return points;
    }
    
    private static int playDWar(LinkedList<Double> naom, LinkedList<Double> ke){
        LinkedList<Double> naomi = new LinkedList<Double>(naom);
        LinkedList<Double> ken = new LinkedList<Double>(ke);
        int points = 0;
        while(!naomi.isEmpty()){
            int n = -1;
            int k = -1;
            for (int i = ken.size()-1; i > -1; i--) {
                int ind = getClosestWinner(ken.get(i),naomi);
                if(ind != -1){
                    n=ind;
                    k=i;
                }
            }
            if(n != -1){
                naomi.remove(n);
                ken.remove(k);
                points++;
            } else {
                ken.removeLast();
                naomi.removeFirst();
            }
        }
        return points;
    }
    
    private static int getClosestWinner(double num, List<Double> boxes){
        for (int i = 0; i < boxes.size(); i++) {
            if(num<boxes.get(i))
                return i;
            
        }
        return -1;
    }
    
    private static int getClosestLoser(double num, List<Double> boxes){
        for (int i = 0; i < boxes.size(); i++) {
            if(num<boxes.get(i))
                return i-1;
            
        }
        return -1;
    }
}
