/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package CodeJam;

import java.io.File;
import java.io.IOException;
import java.util.*;
import org.apache.commons.io.FileUtils;

/**
 *
 * @author Andres
 */
public class MineSweeper {
    public static String pathToDownloads = "C:\\Users\\Andres\\Desktop\\";
    private static char bomb = '*';
    private static char uncovered = '.';
    private static char OOB = '+';
    
    public static int[] readNInts(int N, Scanner s){
        int [] arr = new int[N];
        for (int i = 0; i < N; i++) {
            arr[i] = s.nextInt();
        }
        return arr;
    }
    
    public static String caseOutput(int caseNum, String output){
        return "Case #"+caseNum+":\n" + output;
    }
    
    public static void main(String [] args) throws IOException, InterruptedException{
        String s = FileUtils.readFileToString(new File(pathToDownloads + "test.in"));
        StringBuilder retval = new StringBuilder();
        Scanner in = new Scanner(s);
        int testCases = in.nextInt();
        for(int i = 0; i < testCases; i++){
            int R = in.nextInt();
            int C = in.nextInt();
            int M = in.nextInt();
            char [][] mat = new char[R][C];
            for (int j = 0; j < mat.length; j++) {
                for (int k = 0; k < mat[j].length; k++) {
                    mat[j][k]=bomb;
                }
            }
            putUncovered(mat,R*C-M);
            floodFill(mat);
            mat[mat.length/2][mat[0].length/2] = 'c';
            System.out.println(toString(mat));
            boolean containsUncovered = containsUncovered(mat);
            numToUncover(mat);
            if(containsUncovered){
                for (int j = 0; j < mat.length; j++) {
                    for (int k = 0; k < mat[j].length; k++) {
                        mat[j][k]=bomb;
                    }
                }
                putUncovered2(mat,R*C-M);
                floodFill(mat);
                mat[mat.length/2][mat[0].length/2] = 'c';
                containsUncovered = containsUncovered(mat);
                numToUncover(mat);
                System.out.println("V2:");
                System.out.println(toString(mat));
                if(containsUncovered){
                    retval.append(caseOutput(i+1,"Impossible")).append("\n");
                    System.out.println("Impossible");
                }
            } 
            if(!containsUncovered){
                retval.append(caseOutput(i+1,toString(mat)));
            }
        }
        FileUtils.writeStringToFile(new File(pathToDownloads + "test.out"), retval.substring(0,retval.length()-1));
    }
    
    private static void readInMat(char[][] mat){
        Scanner in = new Scanner(System.in);
        for (int i = 0; i < mat.length; i++) {
            mat[i] = in.next().toCharArray();
        }
    }
    
    private static void numToUncover(char[][] mat){
        for (int i = 0; i < mat.length; i++) {
            for (int j = 0; j < mat[0].length; j++) {
                if(mat[i][j] != bomb && mat[i][j] != 'c'){
                    mat[i][j]=uncovered;
                }
            }
        }
    }
    
    private static boolean containsUncovered(char[][] mat){
        for (int i = 0; i < mat.length; i++) {
            for (int j = 0; j < mat[0].length; j++) {
                if(mat[i][j] == uncovered){
                    return true;
                }
            }
        }
        return false;
    }
    
    private static String toString(char[][] mat){
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < mat.length; i++) {
            for (int j = 0; j < mat[0].length; j++) {
                 builder.append(mat[i][j]);
            }
            builder.append("\n");
        }
        return builder.toString();
    }
    
    private static void putUncovered(char[][] mat, int empty){
        int count = 0;
        List<Point> queue = new ArrayList<Point>();
        queue.add(new Point(mat.length/2, mat[0].length/2));
        while(!queue.isEmpty() && count < empty){
            Point p = queue.remove(0);
            if(get(mat,p) == bomb){
                set(mat,p,uncovered);
                count++;
                addNeighbors(mat,p,queue);
            }
        }
    }
    
    private static void putUncovered2(char[][] mat, int empty){
        int count = 0;
        List<Point> queue = new ArrayList<Point>();
        queue.add(new Point(mat.length/2, mat[0].length/2));
        while(!queue.isEmpty() && count < empty){
            Point p = queue.remove(0);
            if(get(mat,p) == bomb){
                set(mat,p,uncovered);
                count++;
                addNeighbors2(mat,p,queue);
            }
        }
    }
    
    private static void floodFill(char [][] mat){
        List<Point> stack = new ArrayList<Point>();
        stack.add(new Point(mat.length/2, mat[0].length/2));
        while(!stack.isEmpty()){
            Point p = stack.remove(stack.size()-1);
            if(get(mat,p) == uncovered){
                char b = bombs(mat,p);
                set(mat,p,(char)(b+'0'));
                if(b==0){
                    addNeighbors(mat,p,stack);
                } else {
                    List<Point> toAdd = new ArrayList<Point>();
                    addNeighbors(mat,p,toAdd);
                    for (Point point : toAdd) {
                        if(bombs(mat,point) == 0){
                            stack.add(point);
                        }
                    }
                }
            }
        }
    }
    
    private static void addNeighbors(char [][] mat, Point p, List<Point> stack){
        if(get(mat,p.move(1,1)) != OOB){
            stack.add(p.move(1,1));
        }
        if(get(mat,p.move(-1,1)) != OOB){
            stack.add(p.move(-1,1));
        }
        if(get(mat,p.move(-1,-1)) != OOB){
            stack.add(p.move(-1,-1));
        }
        if(get(mat,p.move(1,-1)) != OOB){
            stack.add(p.move(1,-1));
        }
        if(get(mat,p.move(1,0)) != OOB){
            stack.add(p.move(1,0));
        }
        if(get(mat,p.move(0,1)) != OOB){
            stack.add(p.move(0,1));
        }
        if(get(mat,p.move(-1,0)) != OOB){
            stack.add(p.move(-1,0));
        }
        if(get(mat,p.move(0,-1)) != OOB){
            stack.add(p.move(0,-1));
        }
    }
    
    private static void addNeighbors2(char [][] mat, Point p, List<Point> stack){
        if(get(mat,p.move(1,0)) != OOB){
            stack.add(p.move(1,0));
        }
        if(get(mat,p.move(1,1)) != OOB){
            stack.add(p.move(1,1));
        }
        if(get(mat,p.move(0,1)) != OOB){
            stack.add(p.move(0,1));
        }
        if(get(mat,p.move(-1,1)) != OOB){
            stack.add(p.move(-1,1));
        }
        if(get(mat,p.move(-1,0)) != OOB){
            stack.add(p.move(-1,0));
        }
        if(get(mat,p.move(-1,-1)) != OOB){
            stack.add(p.move(-1,-1));
        }
        if(get(mat,p.move(0,-1)) != OOB){
            stack.add(p.move(0,-1));
        }
        if(get(mat,p.move(1,-1)) != OOB){
            stack.add(p.move(1,-1));
        }
    }
    
    private static char bombs(char [][] mat, Point p){
        char ret = 0;
        if(get(mat,p.move(1,0)) == bomb){
            ret++;
        }
        if(get(mat,p.move(1,1)) == bomb){
            ret++;
        }
        if(get(mat,p.move(0,1)) == bomb){
            ret++;
        }
        if(get(mat,p.move(-1,1)) == bomb){
            ret++;
        }
        if(get(mat,p.move(-1,0)) == bomb){
            ret++;
        }
        if(get(mat,p.move(-1,-1)) == bomb){
            ret++;
        }
        if(get(mat,p.move(0,-1)) == bomb){
            ret++;
        }
        if(get(mat,p.move(1,-1)) == bomb){
            ret++;
        }
        return ret;
    }
    
    private static void set(char [][] mat, Point p, char i){
        mat[p.x][p.y] = i;
    }
    
    private static int get(char [][] mat, Point p){
        try{
            return mat[p.x][p.y];
        } catch(Exception e){
            return OOB;
        }
    }
}
class Point{
    int x;
    int y;

    public Point(int x, int y) {
        this.x = x;
        this.y = y;
    }
    
    public Point move(int x, int y){
        return new Point(this.x+x,this.y+y);
    }
}