package ve.com.andresrcb.fairandsquare;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class FairAndSquare {

	final static Charset ENCODING = StandardCharsets.UTF_8;

	final static String INPUT_FILE = "C:\\Jam2013\\Qualification\\FairAndSquare\\C-small-attempt0.in";

	final static String OUTPUT_FILE = "C:\\Jam2013\\Qualification\\FairAndSquare\\C-small-attempt0.out";


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Path inputPath = null;
		Path outputPath = null;		

		inputPath = Paths.get(INPUT_FILE);
		outputPath = Paths.get(OUTPUT_FILE);



		try (BufferedReader inputReader = Files.newBufferedReader(inputPath, ENCODING);
				BufferedWriter outputWriter = Files.newBufferedWriter(outputPath, ENCODING)){
			String inputLine = null;
			String outputLine = null;

			int result;

			inputLine = inputReader.readLine();
			int numberOfCases = Integer.parseInt(inputLine.trim());

			for(int i = 1;i<=numberOfCases;i++) {
				result = 0;				
				//READ A CASE
				inputLine = inputReader.readLine().trim();				
				BigInteger lowEnd = new BigInteger(inputLine.split(" ")[0]);
				BigInteger highEnd = new BigInteger(inputLine.split(" ")[1]);
				BigInteger powerOfNumber;
				BigInteger currentNumber = new BigInteger("1");
				powerOfNumber = currentNumber.pow(2);

				do {					
					if(powerOfNumber.compareTo(lowEnd)>=0) {
						if(isNumberPalindrome(currentNumber)) {
							if (isNumberPalindrome(powerOfNumber)) {
								result++;
							}
						}
					}
					currentNumber = currentNumber.add(BigInteger.ONE);
					powerOfNumber = currentNumber.pow(2);
				} while(powerOfNumber.compareTo(highEnd)<=0);			




				//GENERATE LINE FOR OUTPUT CASE
				outputLine = "Case #"+i+": "+result;



				//WRITE TO FILE
				outputWriter.write(outputLine);
				outputWriter.newLine();	





			}



		} catch (IOException e) {			
			e.printStackTrace();
		}


	}

	public static boolean isNumberPalindrome (BigInteger a) {
		String numberString = a.toString();
		String firstHalf = numberString.substring(0, numberString.length()/2);
		String secondHalf;
		String reverseSecondHalf;
		if(numberString.length()%2==0) {
			secondHalf = numberString.substring(numberString.length()/2,numberString.length());
		}
		else {
			secondHalf = numberString.substring(numberString.length()/2+1,numberString.length());
		}
		reverseSecondHalf = new StringBuffer(secondHalf).reverse().toString();
		if(firstHalf.equals(reverseSecondHalf)) {
			return true;
		}
		else {
			return false;			
		}

	}


}
