package ve.com.andresrcb.lawnmower;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class Lawnmower {

	final static Charset ENCODING = StandardCharsets.UTF_8;

	final static String INPUT_FILE = "C:\\Jam2013\\Qualification\\Lawnmower\\B-large.in";

	final static String OUTPUT_FILE = "C:\\Jam2013\\Qualification\\Lawnmower\\B-large.out";


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Path inputPath = null;
		Path outputPath = null;		

		inputPath = Paths.get(INPUT_FILE);
		outputPath = Paths.get(OUTPUT_FILE);



		try (BufferedReader inputReader = Files.newBufferedReader(inputPath, ENCODING);
				BufferedWriter outputWriter = Files.newBufferedWriter(outputPath, ENCODING)){
			String inputLine = null;
			String outputLine = null;

			String[] lawnRow;
			boolean possible = true;
			String result = "";

			inputLine = inputReader.readLine();
			int numberOfCases = Integer.parseInt(inputLine.trim());

			for(int i = 1;i<=numberOfCases;i++) {
				possible = true;
				//READ A CASE
				inputLine = inputReader.readLine().trim();				
				int n = Integer.parseInt(inputLine.split(" ")[0]);
				int m = Integer.parseInt(inputLine.split(" ")[1]);

				short[][] lawn = new short[n][m];

				for(int j = 0; j<n; j++) {
					inputLine = inputReader.readLine().trim();
					lawnRow = inputLine.split(" ");
					for(int k = 0; k<m; k++) {
						lawn[j][k] = Short.parseShort(lawnRow[k]);
					}
				}				

				//PROCESS DATA
				for(int j = 0; j<n; j++) {		
					if(possible) {
						for(int k = 0; k<m; k++) {
							if(!squareCheck(lawn, n, m, j, k)) {
								possible = false;
								break;
							}
						}
					}
					else{
						break;
					}
				}		
				
				if(possible) {
					result = "YES";
				}
				else {
					result = "NO";
				}



				//GENERATE LINE FOR OUTPUT CASE
				outputLine = "Case #"+i+": "+result;



				//WRITE TO FILE
				outputWriter.write(outputLine);
				outputWriter.newLine();	





			}



		} catch (IOException e) {			
			e.printStackTrace();
		}


	}

	public static boolean squareCheck(short[][] lawn, int n, int m, int j, int k) {
		boolean up = true;
		boolean down = true;
		boolean left = true;
		boolean right = true;

		//Check up
		for(int x=0;x<j;x++){
			if(lawn[x][k] > lawn[j][k]) {
				up = false;
				break;
			}
		}

		//Check down
		for(int x=j+1;x<n;x++){
			if(lawn[x][k] > lawn[j][k]) {
				down = false;
				break;
			}
		}

		//Check left
		for(int x=0;x<k;x++){
			if(lawn[j][x] > lawn[j][k]) {
				left = false;
				break;
			}
		}

		//Check right
		for(int x=k+1;x<m;x++){
			if(lawn[j][x] > lawn[j][k]) {
				right = false;
				break;
			}
		}

		if((up&&down)||(left&&right)) {
			return true;			
		}
		return false;

	}

}
