package ve.com.andresrcb.tictactoe;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class TicTacToe {


	final static Charset ENCODING = StandardCharsets.UTF_8;

	final static String INPUT_FILE = "C:\\Jam2013\\Qualification\\TicTacToe\\A-small-attempt0.in";

	final static String OUTPUT_FILE = "C:\\Jam2013\\Qualification\\TicTacToe\\A-small-attempt0.out";


	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Path inputPath = null;
		Path outputPath = null;		

		inputPath = Paths.get(INPUT_FILE);
		outputPath = Paths.get(OUTPUT_FILE);



		try (BufferedReader inputReader = Files.newBufferedReader(inputPath, ENCODING);
				BufferedWriter outputWriter = Files.newBufferedWriter(outputPath, ENCODING)){
			String inputLine = null;
			String outputLine = null;
			char[][] board = new char[4][4];
			char[][] columns = new char[4][4];
			boolean completed;
			int winner = 0;

			inputLine = inputReader.readLine();
			int numberOfCases = Integer.parseInt(inputLine.trim());

			//READ A CASE
			for(int i = 1;i<=numberOfCases;i++) {
				completed = true;
				winner = 0;
				//DIVIDE INPUT INTO CLASS
				for(int j=0;j<4;j++) {
					inputLine = inputReader.readLine().trim();
					if(inputLine.contains(".")){
						completed = false;
					}
					board[j]=inputLine.toCharArray();
					for(int k=0;k<4;k++) {
						columns[k][j] = board[j][k];
					}
				}
				inputLine = inputReader.readLine();				

				//PROCESS DATA
				for(int j=0;j<4;j++) {
					if(winner == 0) {
						winner = checkLine(board[j]);
					}
					else {
						break;
					}
				} 

				for(int j=0;j<4;j++) {
					if(winner == 0) {
						winner = checkLine(columns[j]);
					}
					else {
						break;
					}
				} 
				if(winner == 0) {
					winner = checkLine (new char[]{board[0][0],board[1][1],board[2][2],board[3][3]});
				}
				if(winner == 0) {
					winner = checkLine (new char[]{board[0][3],board[1][2],board[2][1],board[3][0]});
				}

				String result = "";
				switch(winner) {
				case 0:
					if(completed) {
						result = "Draw";
					}
					else {
						result = "Game has not completed";
					}
					break;
				case 1:
					result = "X won";
					break;
				case 2:
					result = "O won";
					break;
				}

				//GENERATE LINE FOR OUTPUT CASE
				outputLine = "Case #"+i+": " + result;



				//WRITE TO FILE
				outputWriter.write(outputLine);
				outputWriter.newLine();	

			}



		} catch (IOException e) {			
			e.printStackTrace();
		}


	}

	private static int checkLine (char[] line){
		int xCount = 0;
		boolean lineWithT = false;
		for(int i = 0;i<4;i++) {
			switch(line[i]){
			case '.':
				return 0;
			case 'X':
				xCount++;
				break;
			case 'T':
				lineWithT = true;
				break;
			}
		}
		if(xCount == 0) {
			return 2;
		}
		else if((xCount == 4) || (lineWithT && (xCount == 3))) {
			return 1;
		}
		return 0;
	}


}
