import java.io.PrintWriter;
public class QuaternionSolver{

  public String pattern;
  public int patternSize;
  public int patternRepetition;

  public QuaternionSolver(String pattern, 
    int patternSize, int patternRepetition){

    this.pattern = pattern;
    this.patternSize = patternSize ;
    this.patternRepetition = patternRepetition;
  }

  public String solve() throws  Exception  {
    try{
      String debugPath="debug.txt";
      PrintWriter writer2 = new PrintWriter(debugPath, "UTF-8");
      Quaternion q = reducePattern(this.pattern.toCharArray());
      Quaternion reducedPattern = q ;
      while (this.patternRepetition > 1){
        q = multiplyQuaternions(Quaternion.copy(q),reducedPattern);
        this.patternRepetition--;
      }

      writer2.close();
      return (Quaternion.areEqual(q, new Quaternion(true,'1')) ? "YES" : "NO");
    }catch (Exception e){
      e.printStackTrace();
    }
    return "Error";
  }

  public  Quaternion reducePattern(char[] pattern){
    Quaternion res = new Quaternion(false, '1');
    for(int i=0; i<pattern.length ; i++){
      res = multiplyQuaternions(res ,new Quaternion(false,pattern[i]));
    }
    return res;
  }

  public  Quaternion multiplyQuaternions(Quaternion a, Quaternion b){
    if(Quaternion.areEqual(a,b)){
      return new Quaternion((a.value=='1'? false: true),'1');
    }

    if(a.value=='1' && !a.isNegative ){ //one left
      return Quaternion.copy(b);
    }

    if(b.value=='1' && !b.isNegative){//one right
      return Quaternion.copy(a);
    }

    if(a.value=='1' && a.isNegative ){ //negative one left
      return new Quaternion(!b.isNegative , b.value);
    }

    if(b.value=='1' && b.isNegative ){ //negative one right
      return new Quaternion(!a.isNegative , a.value);
    }

    if(a.value != b.value){
      if(!a.isNegative && !b.isNegative || a.isNegative && b.isNegative){
        if(a.value=='j' && b.value=='k' || a.value=='k' && b.value=='j'){
          return new Quaternion( a.value!='j', 'i');
        }
        if(a.value=='i' && b.value=='k' || a.value=='k' && b.value=='i'){
          return new Quaternion( a.value=='i', 'j');
        }
        if(a.value=='i' && b.value=='j' || a.value=='j' && b.value=='i'){
          return new Quaternion( a.value!='i', 'k');
        }
      }else{
        if(a.value=='j' && b.value=='k' || a.value=='k' && b.value=='j'){
          return new Quaternion( (a.value=='j'), 'i');
        }
        if(a.value=='i' && b.value=='k' || a.value=='k' && b.value=='i'){
          return new Quaternion( (a.value!='i'), 'j');
        }
        if(a.value=='i' && b.value=='j' || a.value=='j' && b.value=='i'){
          return new Quaternion( (a.value=='i'), 'k');
        }
      }
    }else{
      return new Quaternion(false,'1');
    }
    return null;
  }


}