import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class Main {
    static boolean local = false;
    static FReader sc;
    static PrintWriter pw;

    public static void main(String args[]) throws FileNotFoundException {
        if (args.length != 0) {
            local = true;
            sc = new FReader("/Users/qjex/prj/jolymp/src/input.txt");
            try {
                pw = new PrintWriter(new FileOutputStream("/Users/qjex/prj/jolymp/src/output.txt"), false);
            } catch (Exception e) {
                e.printStackTrace();
            }
        } else {
            sc = new FReader(System.in);
            pw = new PrintWriter(System.out);
        }
        solve();
        pw.close();
        sc.close();
    }

    static long f(BigInteger x) {
        for (long d = 2; d <= 1000000 && BigInteger.valueOf(d).multiply(BigInteger.valueOf(d)).compareTo(x) != 1; d++) {
            if (x.mod(BigInteger.valueOf(d)).equals(BigInteger.ZERO)) return d;
        }
        return 0;
    }

    static BigInteger to_dec(List<Integer> v, int base) {
        BigInteger res = BigInteger.ZERO;
        for (int i = 0; i < v.size(); i++) {
            res = res.multiply(BigInteger.valueOf(base));
            res = res.add(BigInteger.valueOf(v.get(i)));
        }
        return res;
    }


    public static void solve() {
        int T = sc.nextInt();
        for (int TT = 1; TT <= T; TT++) {
            int n = sc.nextInt(), m = sc.nextInt();
            n -= 2;
            pw.println("Case #1:");
            int all = 0;
            for (int mask = 1; mask < (1 << n); mask++) {
                List<Integer> cur = new ArrayList<Integer>();
                cur.add(1);
                for (int i = 0; i < n; i++) {
                    if ((mask & (1 << i)) > 0) cur.add(1);
                    else cur.add(0);
                }
                cur.add(1);
                Collections.reverse(cur);
//                for (Integer c : cur) System.err.print(c);
//                System.err.println();
                boolean good = true;
                List<Long> ans = new ArrayList<Long>();
                for (int base = 2; base < 11; base++) {
                    BigInteger a = to_dec(cur, base);
                    long dv = f(a);
                    if (dv != 0 && a.isProbablePrime(20)) {
                        System.err.println("ALARM " + a);
                    }
                    if (dv == 0) {
                        good = false;
                        break;
                    }


                    ans.add(dv);
                }
                if (!good) continue;
                for (Integer aCur : cur) {
                    pw.print(aCur);
                }
                pw.print(" ");
                for (Long an : ans) pw.print(an + " ");
                pw.print("\n");
                all++;
                if (all == m) break;
            }
        }
    }



}


class FReader {

    BufferedReader br;
    StringTokenizer st;

    FReader(String file) {
        try {
            br = new BufferedReader(new FileReader(file));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
        st = new StringTokenizer("");
    }


    FReader(InputStream is) {
        br = new BufferedReader(new InputStreamReader(is));
        st = new StringTokenizer("");
    }

    String next() {
        try {
            while (!st.hasMoreElements()) {
                st = new StringTokenizer(br.readLine());
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }

    double nextDouble() {
        return Double.parseDouble(next());
    }

    BigInteger nextBigInteger(){ return new BigInteger(next()); }

    public void close() {
        try {
            br.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}


