package classes;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class DeceitfulWar {

	public static void main(String[] args) {
		String out = "./output.txt";
		String in = "./D-small-attempt0.in";
		PrintWriter pw = null;
		try {
			pw = new PrintWriter(new File(out));
		} catch (FileNotFoundException e) {
			System.err.println("File not found!");
		}
		Scanner sc = null;
		try {
			sc = new Scanner(new File(in));
		} catch (FileNotFoundException e) {
			System.err.println("File not found!");
		}
		int numCases = sc.nextInt();
		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			int numBlocks = sc.nextInt();
			double[] naomi = new double[numBlocks];
			double[] ken = new double[numBlocks];
			for (int i = 0; i < numBlocks; i++) {
				naomi[i] = sc.nextDouble();
			}
			for (int i = 0; i < numBlocks; i++) {
				ken[i] = sc.nextDouble();
			}
			Arrays.sort(naomi);
			Arrays.sort(ken);
			boolean[] isUsed = new boolean[numBlocks];
			int deceitPoints = 0;
			for (int i = 0; i < numBlocks; i++) {
				// deceitful
				// map N's smallest to K's largest (st, if possible, N > K)
				int marker = -1;
				boolean gotFirst = false;
				for (int j = numBlocks - 1; j >= 0; j--) {
					if (isUsed[j]) {
						continue;
					}
					if (!gotFirst) {
						marker = j;
						gotFirst = true;
					}
					if (naomi[i] > ken[j]) {
						marker = j;
						break;
					}
				}
				isUsed[marker] = true;
				if (naomi[i] > ken[marker]) {
					deceitPoints++;
				}
			}
			isUsed = new boolean[numBlocks];
			int fairPoints = 0;
			for (int i = 0; i < numBlocks; i++) {
				// fair
				// map N's smallest to K's smallest (st, if possible, K > N)
				int marker = -1;
				boolean gotFirst = false;
				for (int j = 0; j < numBlocks; j++) {
					if (isUsed[j]) {
						continue;
					}
					if (!gotFirst) {
						marker = j;
						gotFirst = true;
					}
					if (naomi[i] < ken[j]) {
						marker = j;
						break;
					}
				}
				isUsed[marker] = true;
				if (naomi[i] > ken[marker]) {
					fairPoints++;
				}
			}
			pw.println("Case #" + caseNum + ": " + deceitPoints + " " + fairPoints);
		}
		pw.flush();
		pw.close();
		sc.close();
	}

}
