import java.util.Scanner;
import java.util.List;
import java.util.ArrayList;

public class Qua {

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 0; i < t; i++) {
            int l = sc.nextInt();
            int x = sc.nextInt();
            char[] ar = new char[l*x];
            String str = sc.next();
            for (int j = 0; j < l*x; j++) {
                ar[j] = str.charAt(j%str.length());
            }
            
            String res = solvable(ar)?"YES":"NO";
            
            System.out.println("Case #"+(i+1)+": "+res);

        }
    }
    
    public static boolean solvable(char[] ar){
    	List<Integer> is = new ArrayList<Integer>();
    	List<Integer> ks = new ArrayList<Integer>();
    	
    	int curCh = 0;
    	Q q = new Q(ar[curCh],false);
    	while(curCh<ar.length-2){
    		if(q.isI()){
    			is.add(curCh);
    		}
    		curCh++;
    		q.mul(ar[curCh]);
    	}
    	
    	curCh = ar.length-1;
    	q = new Q(ar[curCh],false);
    	while(curCh>1){
    		if(q.isK()){
    			ks.add(curCh);
    		}
    		curCh--;
    		q.premul(ar[curCh]);
    	}
    	
    	if(is.isEmpty() || ks.isEmpty()){
	    	return false;
    	}
    	
    	for(int i:is){
    		int indexK = ks.size()-1;
    		while(indexK>=0 && ks.get(indexK)-i>=2){
    			if(checkJ(ar,i,ks.get(indexK))){
    				return true;
    			}
    			indexK--;
    		}
    	}
    	
    	return false;
    }

	static boolean checkJ(char[] ar, int i, int k){
		if(k-i<2){
			return false;
		}
		int cur = i+1;
		Q q = new Q(ar[cur],false);
		while(cur+1<k){
			cur++;
			q.mul(ar[cur]);
		}
		return q.isJ();
	}

}

class Q{
	char c;
	boolean minus;
	
	public Q(char ch, boolean mi){
		c = ch;
		minus = mi;
	}
	
	void mul(char x){
		if(c == '1' && x == 'i'){
			c = 'i';
		} else
		if(c == '1' && x == 'j'){
			c = 'j';
		} else
		if(c == '1' && x == 'k'){
			c = 'k';
		} else
		if(c == 'i' && x == 'i'){
			c = '1';
			minus = !minus;
		} else
		if(c == 'i' && x == 'j'){
			c = 'k';
		} else
		if(c == 'i' && x == 'k'){
			c = 'j';
			minus = !minus;
		} else
		if(c == 'j' && x == 'i'){
			c = 'k';
			minus = !minus;
		} else
		if(c == 'j' && x == 'j'){
			c = '1';
			minus = !minus;
		} else
		if(c == 'j' && x == 'k'){
			c = 'i';
		} else
		if(c == 'k' && x == 'i'){
			c = 'j';
		} else
		if(c == 'k' && x == 'j'){
			c = 'i';
			minus = !minus;
		} else
		if(c == 'k' && x == 'k'){
			c = '1';
			minus = !minus;
		}
	}
	
	void premul(char x){
		Q q = new Q(x,minus);
		q.mul(c);
		c = q.c;
		minus = q.minus;
	}
	
	boolean isI(){
		return c=='i'&&!minus;
	}
	boolean isJ(){
		return c=='j'&&!minus;
	}
	boolean isK(){
		return c=='k'&&!minus;
	}
}
