package gcj;

import java.util.*;
import java.io.*;

public class TidyNumbers {

	public static void main(String[] args) {
	    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
	    for (int i = 1; i <= t; ++i) {
	      String s = in.next();
	      String lastTidyNumber = getLastTidyNumber(s);
	      System.out.println("Case #" + i + ": " + lastTidyNumber);
	    }
	    in.close();
	}

	private static String getLastTidyNumber(String s) {
		int[] digits = getDigits(s);
		int prevDigit = 0;
		int lastGrowingDigit = -1;
		for (int i = 0; i < digits.length; i++) {
			int currentDigit = digits[i];
			if(currentDigit < prevDigit) {
				lastGrowingDigit = i-1;
				break;
			}
			prevDigit = currentDigit;
		}
		if (lastGrowingDigit == -1) {
			//tidy number
			return digitsToString(digits);
		}
		while (lastGrowingDigit > 0) {
			if (digits[lastGrowingDigit - 1] < digits[lastGrowingDigit]) {
				break;
			}
			lastGrowingDigit--;
		}
		
		digits[lastGrowingDigit]--;
		for (int i = lastGrowingDigit + 1; i < digits.length; i++) {
			digits[i] = 9;
		}
		return digitsToString(digits);
	}

	private static int[] getDigits(String s) {
		char[] chars = s.toCharArray();
		int[] digits = new int[chars.length];
		for (int i = 0; i < chars.length; i++) {
			digits[i] = Character.getNumericValue(chars[i]);
		}
		return digits;
	}
	
	private static String digitsToString(int[] digits) {
		StringBuilder sb = new StringBuilder();
		for(int d : digits) {
			if(d == 0 && sb.length() == 0) {
				continue;
			}
		    sb.append(d);
		}
		
		return sb.toString();
	}

}
