package gcj;

import java.util.*;
import java.io.*;

public class Bathroom {

	public static void main(String[] args) {
	    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
	    for (int i = 1; i <= t; ++i) {
	      long n = in.nextLong();
	      long k = in.nextLong();
	      String result = getMaxMin(n, k);
	      System.out.println("Case #" + i + ": " + result);
	    }
	    in.close();
	}

	private static String getMaxMin(long n, long k) {
		if (n == k) {
			return "0 0";
		}
		if (k == 1) {
			return getMaxMinForFinalInterval(n);
		}
		long occupied = k-1;
		long visitorsOnFilledLevels = filledLevels(occupied);
		long remainingVisitors = occupied - visitorsOnFilledLevels;
		long intervalsOnLastLevel = visitorsOnFilledLevels + 1;

		long emptyPlacesOnLastLevel = n - visitorsOnFilledLevels;
		
		long intervalSmallSize = emptyPlacesOnLastLevel / intervalsOnLastLevel;
		long intervalBigSize = intervalSmallSize + 1;
		long numberOfBigIntervals = emptyPlacesOnLastLevel - (intervalSmallSize * intervalsOnLastLevel);
		
		if (remainingVisitors < numberOfBigIntervals) {
			// final visitor divides big interval
			return getMaxMinForFinalInterval(intervalBigSize);
		} else {
			// final visitor divides small interval
			return getMaxMinForFinalInterval(intervalSmallSize);
		}
	}

	private static String getMaxMinForFinalInterval(long n) {
		long freePlaces = n-1;
		if ((freePlaces % 2) == 0) {
			return "" + (freePlaces / 2) + " " + (freePlaces / 2);
		} else {
			return "" + ((freePlaces / 2) + 1) + " " + (freePlaces / 2);
		}
	}
	
	private static long filledLevels(long k) {
		if ((k & (k + 1)) == 0) {
			return k; //k is already a filled level, bin 111...1
		}
		return Long.highestOneBit(k) - 1;
	}
}
