package gcj;

import java.util.*;
import java.io.*;

public class A {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
		for (int i = 1; i <= t; ++i) {
			int n = in.nextInt();
			int k = in.nextInt();
			int[] height = new int[n];
			int[] radius = new int[n];
			for (int j = 0; j < n; j ++){
				 radius[j] = in.nextInt();
				 height[j] = in.nextInt();
			}
			double res = maxArea(n, k, radius, height);
			System.out.println("Case #" + i + ": " + res);
		}
		in.close();
	}

	private static double maxArea(int n, int k, int[] radius, int[] height) {
		List<Pancake> pancakes = new ArrayList<>();
		for (int i = 0; i < n; i++) {
			pancakes.add(new Pancake(height[i], radius[i]));
		}
		List<Pancake> pancakesByRadius = new ArrayList<>(pancakes);
		
		pancakesByRadius.sort(new RadComparator());
		pancakes.sort(new SideComparator());
		
		double baseSolution = 0;
		int maxRad = 0;
		for (int i = 0; i < k; i ++) {
			if (pancakes.get(i).r > maxRad) {
				maxRad = pancakes.get(i).r;
			}
			baseSolution += pancakes.get(i).side;
		}
		
		double sidesWithoutLast = baseSolution - pancakes.get(k-1).side;
		
		baseSolution += Math.PI * maxRad * maxRad;

		for (Pancake p : pancakesByRadius) {
			if (p.r <= maxRad) {
				break;
			}
			double solutionWithP = sidesWithoutLast + p.side + p.surface;
			if (solutionWithP > baseSolution) {
				baseSolution = solutionWithP;
			}
		}
		
		return baseSolution;
	}

}

class Pancake {
	int h;
	int r;
	
	double surface;
	double side;
	
	public Pancake(int h, int r) {
		this.h = h;
		this.r = r;
		
		surface = Math.PI * r * r;
		side = Math.PI * 2 * r * h;
	}
}

class SideComparator implements Comparator<Pancake>
{            
     public int compare(Pancake c1, Pancake c2)
     {
    	 Double s1 = c1.side;
    	 Double s2 = c2.side;
         return -1 * s1.compareTo(s2);
     }
 }

class RadComparator implements Comparator<Pancake>
{            
     public int compare(Pancake c1, Pancake c2)
     {
    	 Integer s1 = c1.r;
    	 Integer s2 = c2.r;
         return -1 * s1.compareTo(s2);
     }
 }
