package _2013.r0.a_tictactoetomek;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;


public class TicTacToeTomek
{
	public boolean isPosition (char c, char desired)
	{
		return c == desired || c == 'T';
	}
	public static String getTTTRes (String[] board)
	{
		String res = null;
		boolean existsEmpty = false;
		String [] boardX = new String[4];
		String [] boardO = board;
		
		// Horizontals
		for (int i=0; i<4 && (res == null); i++) {
			boardX[i] = board[i].replace ('T', 'X');
			boardO[i] = board[i].replace ('T', 'O');
			
			if (boardO[i].startsWith ("OOOO")) {
				res = "O won";
			} else if (boardX[i].startsWith ("XXXX")) {
				res = "X won";
			} else if (board[i].contains (".")) {
				existsEmpty = true;
			}

		}
		
		// Verticals
		for (int i=0; i<4 && (res == null); i++) {
			if ((boardO[0].charAt(i) == 'O') && (boardO[1].charAt(i) == 'O') && (boardO[2].charAt(i) == 'O') && (boardO[3].charAt(i) == 'O')) {
				res = "O won";
			} else if ((boardX[0].charAt(i) == 'X') && (boardX[1].charAt(i) == 'X') && (boardX[2].charAt(i) == 'X') && (boardX[3].charAt(i) == 'X')) {
				res = "X won";
			}

		}
		
		// Diagonals
		if (res == null) {
			if ((boardO[0].charAt(0) == 'O') && (boardO[1].charAt(1) == 'O') && (boardO[2].charAt(2) == 'O') && (boardO[3].charAt(3) == 'O')) {
				res = "O won";
			} else if ((boardX[0].charAt(0) == 'X') && (boardX[1].charAt(1) == 'X') && (boardX[2].charAt(2) == 'X') && (boardX[3].charAt(3) == 'X')) {
				res = "X won";
			} else if ((boardO[0].charAt(3) == 'O') && (boardO[1].charAt(2) == 'O') && (boardO[2].charAt(1) == 'O') && (boardO[3].charAt(0) == 'O')) {
				res = "O won";
			} else if ((boardX[0].charAt(3) == 'X') && (boardX[1].charAt(2) == 'X') && (boardX[2].charAt(1) == 'X') && (boardX[3].charAt(0) == 'X')) {
				res = "X won";
			}
		}
		
		// End of game?
		if (res != null) {
			return res;
		} else if (existsEmpty) {
			return "Game has not completed";
		} else {
			return "Draw";
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args)
			throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/_2013/r0/a_tictactoetomek/A-large.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));

			String[] board = new String[4];
			for (int j=0; j<4; j++) {
				board[j] = in.readLine();
			}
			String res = getTTTRes (board);
			in.readLine();
			
			out.println ("Case #" + (i+1) + ": " + res);
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}

}
