package a2011_magicka;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;


public class Magicka
{
	public static List<Character> invoke (List<Character> currentList, List<String> combinaciones, List<String> opuestos, String secuencia)
	{
		if (secuencia.isEmpty())  return currentList;
System.out.println (currentList + " --- " + secuencia);
		
		Character nextE = new Character (secuencia.charAt(0));
		String nextSecuencia = (secuencia.length() == 1? "" : secuencia.substring(1));
		
		// Comprobacion combinaciones
		boolean bCombi = false;
		if (!currentList.isEmpty()) {
			for (int i=0; i<combinaciones.size() && !bCombi; i++) {
				String combi = (String) combinaciones.get(i);
				char combi0 = combi.charAt(0);
				char combi1 = combi.charAt(1);
				
				char lastElem = currentList.get(currentList.size() - 1).charValue();
				if (((combi0 == lastElem) && (combi1 == nextE.charValue())) || ((combi1 == lastElem) && (combi0 == nextE.charValue()))) {
					bCombi = true;
					secuencia = combi.charAt(2) + nextSecuencia;
					currentList.remove (currentList.size() - 1);
				}
			}
		}
		
		// Comprobacion opuestos
		boolean bOpuestos = false;
		if (!bCombi && !currentList.isEmpty()) {
			Set<Character> listElements = new HashSet<Character> (currentList);
			for (int i=0; i<opuestos.size() && !bOpuestos; i++) {
				String op = (String) opuestos.get(i);
				Character op0 = new Character (op.charAt(0));
				Character op1 = new Character (op.charAt(1));
				if ((op0.equals(nextE) && listElements.contains (op1)) || (op1.equals(nextE) && listElements.contains (op0))) {
					bOpuestos = true;
					secuencia = nextSecuencia;
					currentList.clear();
				}
			}
		}
		
		// Si nada de nada, se mete el elemento nuevo
		if (!bCombi && !bOpuestos) {
			secuencia = nextSecuencia;
			currentList.add (nextE);
		}
		
		// Se procesa el resto
		List res = invoke(currentList, combinaciones, opuestos, secuencia);
		return res;
	}
	
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/a2011_magicka/B-small-attempt0.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s = in.readLine();
			
			String[] trozos = s.split (" ");
			
			int numCombinaciones = Integer.parseInt(trozos[0]);
			List<String> combinaciones = new ArrayList<String>();
			for (int j=0; j<numCombinaciones; j++) {
				String combinacion = trozos[1+j];
				combinaciones.add (combinacion);
			}
			
			int numOpuestos = Integer.parseInt(trozos[numCombinaciones + 1]);
			List<String> opuestos = new ArrayList<String>();
			for (int j=0; j<numOpuestos; j++) {
				String opuesto = trozos[numCombinaciones + 2+ j];
				opuestos.add (opuesto);
			}
			
			String secuencia = trozos[numCombinaciones + numOpuestos + 3];
			
			List res = invoke (new LinkedList<Character>(), combinaciones, opuestos, secuencia);
			out.println ("Case #" + (i+1) + ": " + res);
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
