package a2011_candysplitting;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;


public class CandySplitting
{
	public static int getValorMaxSean (int[] valores)
	{
		if (valores.length < 2)  return -1;
		
		// Ver si es posible: XOR de todos
		int resPosible = 0;
		for (int i=0; i<valores.length; i++) {
			resPosible = resPosible ^ valores[i];
		}
		
		// XOR da distinto de 0: no posible
		if (resPosible != 0) {
			return -1;
			
		// Posible: calcular
		} else {
			// Se ordenan los valores
			List<Integer> l = new LinkedList<Integer>();
			for (int i=0; i<valores.length; i++) {
				l.add (new Integer (valores[i]));
			}
			Collections.sort (l);
			
			List<Integer> l1 = new LinkedList<Integer>();
			l1.add (l.get(0));
			l.remove (0);
			return getValorListas (l, l1);
			
//			int clave0 = (1 << valores.length) - 2;
//			int res = 0;
//			List<Integer> l0 = new LinkedList<Integer>();
//			List<Integer> l1 = new LinkedList<Integer>();
//			for (int x=clave0; x>=1 && (res <= 0); x--) {
//				l0.clear();
//				l1.clear();
//
//				for (int i=0; i<valores.length; i++) {
//					int check = 1 << i;
//					if ((x | check) == x) {
//						l0.add (l.get(i));
//					} else {
//						l1.add (l.get(i));
//					}
//				}
//				
//				int val = getValorListas (l0, l1);
//				if (val > res)  res = val;
//			}
//			
//			return res;
		}
	}
	
	public static int getValorListas (List<Integer> l0, List<Integer> l1)
	{
//		System.out.println (l0);
//		if (l0.isEmpty() || l1.isEmpty())  return -1;
//		int v0 = getValorLista (l0);
//		int v1 = getValorLista (l1);
//		if (v0 != v1)
//			return -1;
//		else {
			// Valor real lista 0
			int v = 0;
			for (int i=0; i<l0.size(); i++) {
				v += l0.get(i).intValue();
			}
			return v;
//		}
	}
	
	public static int getValorLista (List<Integer> l)
	{
		int res = 0;
		for (int i=0; i<l.size(); i++) {
			res = res ^ l.get(i).intValue();
		}
		return res;
	}
	
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/a2011_candysplitting/C-large.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s = in.readLine();
			s = in.readLine();
			String[] trozos = s.split (" ");
			int[] valores = new int[trozos.length];
			for (int j=0; j<trozos.length; j++) {
				valores[j] = Integer.parseInt (trozos[j]);
			}
			
			int res = getValorMaxSean (valores);
			out.println ("Case #" + (i+1) + ": " + (res == -1? "NO" : res));
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
