package b2011_1;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;


public class B2011_1
{
	public static class WP
	{
		public int jugados = 0;
		public int ganados = 0;
		public double getValor() {
			return ((double) ganados) / ((double) jugados);
		}
		public Object clone() {
			WP res = new WP();
			res.jugados = jugados;
			res.ganados = ganados;
			return res;
		}
		
	}
	public static WP[] calcularWPs (int[][] resultados)
	{
		WP[] res = new WP[resultados.length];
		for (int equipo = 0; equipo<resultados.length; equipo++) {
			WP wp = new WP();
			int[] partidos = resultados[equipo];
			for (int i=0; i<partidos.length; i++) {
				if (i != equipo) {
					if (partidos[i] != -1)  wp.jugados++;
					if (partidos[i] == 1)   wp.ganados++;
				}
			}
			res[equipo] = wp;
		}
		return res;
	}
	
	public static double [] calcularOWPs (int[][] resultados, WP[] wps)
	{
		double[] res = new double[resultados.length];
		for (int equipo = 0; equipo<resultados.length; equipo++) {
			int[] partidos = resultados[equipo];
			double suma = 0;
			int numOponentes = 0;
			for (int oponente=0; oponente<partidos.length; oponente++) {
				if ((oponente != equipo) && (partidos[oponente] != -1)) {
					WP owpOp = (WP) (wps[oponente].clone());
					if (partidos[oponente] != -1) { owpOp.jugados--; numOponentes++; }
					if (partidos[oponente] == 0)   owpOp.ganados--;
					suma += owpOp.getValor();
				}
			}
			res[equipo] = suma / ((double) numOponentes);
		}
		return res;
	}
	
	public static double[] calcularRPIs (int[][] resultados)
	{
		WP[] wps = calcularWPs(resultados);
		double[] owps = calcularOWPs(resultados, wps);
		
		double[] res = new double[resultados.length];
		for (int equipo = 0; equipo<resultados.length; equipo++) {
			int[] partidos = resultados[equipo];
			
			// oowp
			double suma = 0;
			int numOponentes = 0;
			for (int oponente=0; oponente<partidos.length; oponente++) {
				if (partidos[oponente] != -1) {
					suma += owps[oponente];
					numOponentes++;
				}
			}
			double oowp = suma / (double) numOponentes;
			
			double wp = wps[equipo].getValor();
			double owp = owps[equipo];
			res[equipo] = (0.25d * wp) + (0.50d * owp) + (0.25d * oowp); 
		}
		return res;
	}
	
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/b2011_1/A-small-attempt0.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s0 = in.readLine();

			int n = Integer.parseInt(s0);
			int[][] resultados = new int[n][n];
			for (int j=0; j<n; j++) {
				String s = in.readLine();
				for (int k=0; k<n; k++) {
					if (s.charAt(k) == '1')
						resultados[j][k] = 1;
					else if (s.charAt(k) == '0')
						resultados[j][k] = 0;
					else
						resultados[j][k] = -1;
				}
				
			}
			
			double[] res = calcularRPIs(resultados);
			out.println ("Case #" + (i+1) + ":");
			for (int j=0; j<n; j++) {
				out.println (res[j]);
			}
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
