package a2011.r2.b;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;


public class SpinningBlade
{
	public static int evaluateBladeSize (long[][] grid)
	{
		int minLong = Math.min (grid.length, grid[0].length);
		int maxRadio = (minLong - 1) / 2;
		for (int i=maxRadio; i>=1; i--) {
			boolean okRadio = checkPosible (grid, i);
			if (okRadio)  return (maxRadio * 2) + 1;
		}
		return -1;
	}
	
	public static boolean checkPosible (long[][] grid, int radio)
	{
System.out.println ("Prueba radio " + radio);
		int desdex = radio;
		int hastax = grid.length - radio - 1;
		int desdey = radio;
		int hastay = grid[0].length - radio - 1;
		
		for (int i=desdex; i<=hastax; i++) {
			for (int j=desdey; j<=hastay; j++) {
				if (checkPosibleCentro (grid, radio, i, j))  return true;
			}
		}
		return false;
	}
	
	public static boolean checkPosibleCentro (long[][] grid, int radio, int x, int y)
	{
System.out.println ("Prueba " + x + ", " + y);
		long centroMasasX = 0;
		long centroMasasY = 0;
		int desdex = x - radio;
		int hastax = x + radio;
		int desdey = y - radio;
		int hastay = y + radio;
		for (int i =desdex; i<=hastax; i++) {
			for (int j=desdey; j<=hastay; j++) {
				boolean iEsq = (i == desdex) || (i == hastax);
				boolean jEsq = (j == desdey) || (j == hastay);
				if (!(iEsq && jEsq)) {
					centroMasasX += (x-i) * grid[i][j];
					centroMasasY += (y-j) * grid[i][j];
				}
			}
		}
		return (centroMasasX == 0) && (centroMasasY == 0);
	}
	
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/a2011/r2/b/B-small-attempt3.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s = in.readLine();
			String [] trozos = s.split (" ");
			
			int x = Integer.parseInt (trozos[0]);
			int y = Integer.parseInt (trozos[1]);
			long mass = Integer.parseInt (trozos[2]);

			long[][] grid = new long[x][y];
			for (int j=0; j<x; j++) {
				s = in.readLine();
				for (int k=0; k<y; k++) {
					long massTrozo = Integer.parseInt (s.substring(k,k+1));
					grid[j][k] = mass + massTrozo;
				}
			}

			int res = evaluateBladeSize (grid);

			out.println ("Case #" + (i+1) + ": " + (res == -1? "IMPOSSIBLE" : res));
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
