package a2011.r2.a;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;


public class Aeropuerto
{
	public static boolean testFreq (long freq, long[] freqsOtros)
	{
		for (int i=0; i<freqsOtros.length; i++) {
			long freq0 = freqsOtros[i];
			if (!((freq == freq0)
					|| ((freq > freq0) && (freq % freq0 == 0))
					|| ((freq0 > freq) && (freq0 % freq == 0)))) {
				return false;
			}
		}
		return true;
	}
	
	public static long testAllFreqsBruta (long freq0, long freq1, long[] freqsOtros)
	{
		for (long f=freq0; f<=freq1; f++) {
			boolean bOk = testFreq (f, freqsOtros);
			if (bOk)  return f;
		}
		return -1;
	}
	
	public static class TrozoPasillo
	{
		public int longitud;
		public int velocidadSuma;
		
	}
	
	public static double calcularTiempo (int vRapida, int vLenta, int tiempoRapida, List trozos)
	{
		Collections.sort (trozos, new Comparator() {
			public int compare(Object arg0, Object arg1) {
				return ((TrozoPasillo) arg0).velocidadSuma - ((TrozoPasillo) arg1).velocidadSuma;
			}
		});
		
		// Vamos acumulando tiempos, aceleramos en partes lentas
		double res = 0.0d;
		double segsRapida = tiempoRapida;
		for (int i=0; i<trozos.size(); i++) {
			TrozoPasillo trozo = (TrozoPasillo) trozos.get (i);
			
			double tiempoTrozo;
			if (segsRapida == 0.0d) {
				tiempoTrozo = ((double) trozo.longitud) / ((double) (vLenta + trozo.velocidadSuma));
System.out.println ("Trozo: " + trozo.longitud + " - " + trozo.velocidadSuma + " - lento: " + tiempoTrozo);
				
			} else {
				// Ver si da tiempo a correr todo el rato
				double espacioCorriendo = ((double) (vRapida + trozo.velocidadSuma)) * segsRapida;
				if (espacioCorriendo == trozo.longitud) {
					tiempoTrozo = segsRapida;
					segsRapida = 0;
System.out.println ("Trozo: " + trozo.longitud + " - " + trozo.velocidadSuma + " - rápido: " + tiempoTrozo);
				} else if (espacioCorriendo > trozo.longitud) {
					// Se corre todo el rato
					tiempoTrozo = ((double) trozo.longitud) / ((double) (vRapida + trozo.velocidadSuma));
					segsRapida -= tiempoTrozo;
System.out.println ("Trozo: " + trozo.longitud + " - " + trozo.velocidadSuma + " - rápido: " + tiempoTrozo);
					
				} else {
					// Parte corriendo, parte andando
					tiempoTrozo = (espacioCorriendo / ((double) (vRapida + trozo.velocidadSuma)))
							+ ((((double) trozo.longitud) - espacioCorriendo) / ((double) (vLenta + trozo.velocidadSuma)));
					
System.out.println ("Trozo: " + trozo.longitud + " - " + trozo.velocidadSuma + " - mezcla: " + tiempoTrozo);
					segsRapida = 0.0d;
				}
			}
			res += tiempoTrozo;
		}
		
		return res;
	}
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/a2011/r2/a/A-small-attempt0.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s = in.readLine();
			String [] trozos = s.split (" ");
			
			int longitud = Integer.parseInt (trozos[0]);
			int velocidadRapida = Integer.parseInt (trozos[2]);
			int velocidadLenta = Integer.parseInt (trozos[1]);
			int tiempoRapida = Integer.parseInt (trozos[3]);
			int numPasillos = Integer.parseInt (trozos[4]);
			
			List pasillos = new ArrayList (numPasillos + 1);
			int longitudCorredores = 0;
			for (int j=0; j<numPasillos; j++) {
				s = in.readLine();
				trozos = s.split (" ");
				
				TrozoPasillo trozo = new TrozoPasillo();
				trozo.longitud = Integer.parseInt (trozos[1]) - Integer.parseInt (trozos[0]);
				trozo.velocidadSuma = Integer.parseInt (trozos[2]);
				longitudCorredores += trozo.longitud;
				pasillos.add (trozo);
			}
			TrozoPasillo trozoLento = new TrozoPasillo();
			trozoLento.longitud = longitud - longitudCorredores;
			trozoLento.velocidadSuma = 0;
			pasillos.add (trozoLento);
			
			double res = calcularTiempo (velocidadRapida, velocidadLenta, tiempoRapida, pasillos);

			out.println ("Case #" + (i+1) + ": " + res);
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
