package a2011_bottrust;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;


public class BotTrust
{
	public static int numSegundos (List movsRobot, List movsDestino, List destinosO, List destinosB, int posO, int posB)
	{
		if (movsRobot.isEmpty())  return 0;
		
		int posTargetO = (destinosO.isEmpty()? posO : ((Integer) destinosO.get(0)).intValue());
		int segundosMovO = Math.abs (posO - posTargetO);
		int posTargetB = (destinosB.isEmpty()? posB : ((Integer) destinosB.get(0)).intValue());
		int segundosMovB = Math.abs (posB - posTargetB);
		
		int numSegsPaso;
		String robot = (String) movsRobot.get(0);
		if (robot.equals ("O")) {
			if (segundosMovB > (segundosMovO + 1)) {
				posB = (posB > posTargetB? posB - segundosMovO - 1 : posB + segundosMovO + 1);
			} else {
				posB = posTargetB;
			}
			posO = posTargetO;
			destinosO.remove(0);
			numSegsPaso = segundosMovO + 1;
		} else {
			if (segundosMovO > (segundosMovB + 1)) {
				posO = (posO > posTargetO? posO - segundosMovB - 1 : posO + segundosMovB + 1);
			} else {
				posO = posTargetO;
			}
			posB = posTargetB;
			destinosB.remove(0);
			numSegsPaso = segundosMovB + 1;
		}
		
		movsRobot.remove (0);
		movsDestino.remove (0);
		
		int numSegsResto = numSegundos (movsRobot, movsDestino, destinosO, destinosB, posO, posB);
		return numSegsPaso + numSegsResto;
	}
	
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/a2011_bottrust/A-large.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s = in.readLine();
			
			String[] trozos = s.split (" ");
			int numMovs = Integer.parseInt(trozos[0]);
			
			List destinosO = new LinkedList();
			List destinosB = new LinkedList();
			List movsRobot = new LinkedList();
			List movsDestino = new LinkedList();
			for (int j=0; j<numMovs; j++) {
				String robot = trozos[(2*j) + 1];
				String sDestino = trozos[(2*j) + 2];
				Integer destino = new Integer (sDestino);
				
				if (robot.equalsIgnoreCase("O"))
					destinosO.add (destino);
				else
					destinosB.add (destino);
				
				movsRobot.add (robot);
				movsDestino.add (destino);
			}

			int res = numSegundos (movsRobot, movsDestino, destinosO, destinosB, 1, 1);
			out.println ("Case #" + (i+1) + ": " + res);
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
