package watershed;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

import alienlang.AlienPattern;

public class WaterSinker
{
	public static void main(String[] args)
		throws Exception
	{
		String sIn = "files/watershed/B-small-attempt0.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			linea0 = in.readLine();
			String [] tokens = linea0.split(" ");
			int maxY = Integer.parseInt (tokens[0]);
			int maxX = Integer.parseInt (tokens[1]);
			
			int [][] heights = new int[maxY][maxX];
			for (int j=0; j<maxY; j++) {
				linea0 = in.readLine();
				tokens = linea0.split(" ");
				for (int k=0; k<maxX; k++) {
					heights[j][k] = Integer.parseInt (tokens[k]);
				}
			}
			
			WatershedMap m = new WatershedMap (heights);
			m.fillLabels();
			
			out.print ("Case #" + (i+1) + ":");
			out.println();
			
			for (int y=0; y<=m.maxY; y++) {
				for (int x=0; x<=m.maxX; x++) {
					if (x > 0) out.print (' ');
					out.print (m.getLabel (x, y));
				}
				out.println();
			}
		}
		
		
		out.close();
		System.out.println ("OK");
	}
}
