package _2013.r0.b_lawnmower;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;


public class Lawnmower
{
	public static boolean isPositionPossible (int iPos, int jPos, int[][] board)
	{
		int ref = board[iPos][jPos];
		
		// Horizontales
		boolean impossible = false;
		for (int i=0; i<board.length && !impossible; i++) {
			impossible = (board[i][jPos] > ref);
		}
		if (!impossible)  return true;
			
		// Verticales
		impossible = false;
		for (int j=0; j<board[0].length && !impossible; j++) {
			impossible = (board[iPos][j] > ref);
		}
		return !impossible;
	}
	public static boolean isPatternPosible (int[][] board)
	{
		boolean impossible = false;
		for (int i=0; i<board.length && !impossible; i++) {
			for (int j=0; j<board[i].length && !impossible; j++) {
				impossible = !isPositionPossible (i, j, board);
			}
		}
		return !impossible;
	}

	/**
	 * @param args
	 */
	public static void main( String[] args)
			throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "src/_2013/r0/b_lawnmower/B-small-attempt0.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));

			String s = in.readLine();
			String[] trozos = s.split (" ");
			int n = Integer.parseInt(trozos[0]);
			int m = Integer.parseInt(trozos[1]);
			
			int[][] board = new int[n][m];
			for (int j=0; j<n; j++) {
				s = in.readLine();
				trozos = s.split (" ");
				for (int k=0; k<m; k++) {
					board[j][k] = Integer.parseInt (trozos[k]);
				}
			}
			boolean res = isPatternPosible (board);
			
			out.println ("Case #" + (i+1) + ": " + (res? "YES" : "NO"));
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}

}
