package themepark;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;


public class ThemePark
{
	private int genteCabe;
	private int[] grupos;
	
	private int dinero = 0;
	private int grupoToca = 0;
	private int totalGente = 0;
	
	public ThemePark (int _genteCabe, int[] _grupos)
	{
		this.genteCabe = _genteCabe;
		this.grupos = _grupos;
		for (int i=0; i<this.grupos.length; i++)  this.totalGente += this.grupos[i];
	}
	
	public int doRounds (int numVueltas)
	{
		for (int i=0; i<numVueltas; i++)  this.doRound();
		return this.dinero;
	}
	private void doRound()
	{
		int genteDentro = 0;
		while ((genteDentro < this.totalGente) && (this.genteCabe - genteDentro >= this.grupos[this.grupoToca])) {
			genteDentro += this.grupos[this.grupoToca];
			this.grupoToca++;
			if (this.grupoToca == this.grupos.length)  this.grupoToca = 0;
		}
		this.dinero += genteDentro;
	}
	
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "files/themepark/C-small-attempt0.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s = in.readLine();
			
			String[] trozos = s.split (" ");
			int r = Integer.parseInt(trozos[0]);
			int k = Integer.parseInt(trozos[1]);
			int n = Integer.parseInt(trozos[2]);
			
			String s2 = in.readLine();
			String[] trozos2 = s2.split (" ");
			int[] grupos = new int[n];
			for (int j=0; j<n; j++)  grupos[j] = Integer.parseInt (trozos2[j]);
			
			ThemePark park = new ThemePark (k, grupos);
			int res = park.doRounds(r);
			
			out.println ("Case #" + (i+1) + ": " + res);
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
