package snapperchain;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.LineNumberReader;
import java.io.PrintWriter;


public class SnapperChain
{
	private boolean[] snappers;
	
	public SnapperChain (int _numSnappers)
	{
		this.snappers = new boolean[_numSnappers];
	}
	
	public void snap()
	{
		boolean plugged = true;
		for (int i=0; i<snappers.length && plugged; i++) {
			plugged = snappers[i];
			snappers[i] = !snappers[i];
		}
	}
	
	public void snap (int num)
	{
		for (int i=0; i<num; i++)  this.snap();
	}
	
	public boolean isOn()
	{
		boolean plugged = true;
		for (int i=0; i<snappers.length && plugged; i++) {
			plugged = snappers[i];
		}
		return plugged;
	}
	
	public static boolean doChain (int n, int k)
	{
		SnapperChain chain = new SnapperChain (n);
		chain.snap(k);
		return chain.isOn();
	}
	
	public static void main(String[] args)
		throws Exception
	{
		long t0 = System.currentTimeMillis();
		String sIn = "files/snapperchain/A-small-attempt0.in";
		if (args.length > 0)  sIn = args[0];
		String sOut = sIn;
		if (sOut.endsWith (".in")) sOut = sOut.substring (0, sOut.length() - 3);
		sOut = sOut + ".out";
		
		LineNumberReader in = new LineNumberReader (new FileReader (sIn));
		PrintWriter out = new PrintWriter (new FileWriter (sOut));
	
		String linea0 = in.readLine();
		int numCasos = Integer.parseInt (linea0);
		
		for (int i=0; i<numCasos; i++) {
			System.out.println ("Case #" + (i+1));
			String s = in.readLine();
			
			String[] trozos = s.split (" ");
			int n = Integer.parseInt(trozos[0]);
			int k = Integer.parseInt(trozos[1]);
			String res = (doChain(n, k)? "ON" : "OFF");
			
			out.println ("Case #" + (i+1) + ": " + res);
		}
		
		
		out.close();
		
		long t1 = System.currentTimeMillis();
		long seg = ((t1 - t0) / 1000);
		double mins = seg / 60d;
		
		System.out.println ("OK - " + mins + " minutos");
	}
}
