import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {
    FastScanner in;
    PrintWriter out;

    class Ed {
        int s, t, ind;
        boolean init;

        public Ed(int s, int t, int ind, boolean init) {
            this.s = s;
            this.t = t;
            this.ind = ind;
            this.init = init;
        }
    }

    ArrayList<Ed>[] e;
    int[] enter;
    int[] up;
    int now;
    int[] numup;
    int[] color;
    int[] edges;

    boolean dfs(int u, int pe) {
        enter[u] = now++;
        color[u] = 1;
        up[u] = enter[u];
        for (Ed ed : e[u]) {
            int v = ed.t;
            if (color[v] == 0) {
                if (!dfs(v, ed.ind)) {
                    return false;
                }
                if (up[v] >= enter[v]) {
                    return false;
                }
                up[u] = Math.min(up[u], up[v]);
                numup[u] += numup[v];
            } else if (color[v] == 1 && ed.ind != pe) {
                up[u] = Math.min(up[u], enter[v]);
                numup[u]++;
            } else if (color[v] == 2) {
                numup[u]--;
            }
        }
        color[u] = 2;
        return true;
    }

    void dfs2(int u, int pe) {
        color[u] = 1;
        for (Ed ed : e[u]) {
            int v = ed.t;
            if (color[v] == 0) {
                dfs2(v, ed.ind);
                edges[ed.ind] = numup[v] * (ed.init ? 1 : -1);
            } else {
                if (ed.ind != pe && color[v] == 1) {
                    edges[ed.ind] = (ed.init ? 1 : -1);
                }
            }
        }
        color[u] = 2;
    }

    public void solve() throws IOException {
        int testNo = in.nextInt();

        for (int test = 1; test <= testNo; test++) {
            int f = in.nextInt();
            int p = in.nextInt();

            e = new ArrayList[f];
            for (int i = 0; i < f; i++)  {
                e[i] = new ArrayList<>();
            }

            for (int i = 0; i < p; i++) {
                int x = in.nextInt() - 1;
                int y = in.nextInt() - 1;
                e[x].add(new Ed(x, y, i, true));
                e[y].add(new Ed(y, x, i, false));
            }

            String ans = " IMPOSSIBLE";

            enter = new int[f];
            up = new int[f];
            now = 0;
            color = new int[f];
            boolean ok = true;
            numup = new int[f];
            for (int i = 0; i < f; i++) {
                if (color[i] == 0) {
                    ok &= dfs(i, -1);
                }
            }

            edges = new int[p];
            if (ok) {
                color = new int[f];
                for (int i = 0; i < f; i++) {
                    if (color[i] == 0) {
                        dfs2(i, -1);
                    }
                }
                ans = "";
                for (int i = 0; i < p; i++) {
                    ans += " " + edges[i];
                }

                for (int i = 0; i < f; i++) {
                    int sum = 0;
                    for (Ed ed : e[i])  {
                        if (ed.init) {
                            sum += edges[ed.ind];
                        } else {
                            sum -= edges[ed.ind];
                        }
                    }
                    if (sum != 0) {
                        throw new AssertionError();
                    }
                }
            }


            System.out.println("Case #" + test + ":" + ans);
            out.println("Case #" + test + ":" + ans);
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("B-large.in"));
            out = new PrintWriter(new File("B-large.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] arg) {
        Locale.setDefault(Locale.US);
        new B().run();
    }

    void out(String format, Object... s) {
        System.out.printf(format, s);
        out.printf(format, s);
        out.flush();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File file) throws IOException {
            br = new BufferedReader(new FileReader(file));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                    return "";
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
        long nextLong() {
            return Long.parseLong(next());
        }
    }
}