import java.util.*;
import java.math.*;
import java.io.*;

class B implements Runnable {
    BufferedReader in;
    StringTokenizer st;

    String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    int r, c, f;
    char[][] a;
    int[][][][] memo;

    int testFall(int x, int nx, int ny) {
        while (nx < r - 1 && a[nx + 1][ny] == '.') {
            nx++;
        }
        if (nx - x <= f) {
            while (ny > 0 &&  a[nx][ny - 1] == '.' && (nx == r - 1 || a[nx + 1][ny - 1] == '#')) {
                ny--;
            }
            int nw = 1;
            while (ny + nw < c &&  a[nx][ny + nw] == '.' && (nx == r - 1 || a[nx + 1][ny + nw] == '#')) {
                nw++;
            }
            int nz = 0;
            if (ny == 0 || a[nx][ny - 1] == '#') {
                nz |= 1;
            }
            if (ny + nw == c || a[nx][ny + nw] == '#') {
                nz |= 2;
            }
            return search(nz, nx, ny, nw);
        } else {
            return Integer.MAX_VALUE / 2;
        }
    }

    int myMin(int x, int y) {
        return x == -1 ? y : Math.min(x, y);
    }

    int search(int z, int x, int y, int w) {
        if (x == r - 1) {
            return 0;
        }
        if (memo[z][x][y][w] != -1) {
            return memo[z][x][y][w];
        }
        memo[z][x][y][w] = Integer.MAX_VALUE / 2;
//        System.out.println(x + " " + y + " " + w);
        if (y > 0 && a[x][y - 1] == '.') {
            memo[z][x][y][w] = myMin(memo[z][x][y][w], testFall(x, x, y - 1));
        }
        if (y + w < c && a[x][y + w] == '.') {
            memo[z][x][y][w] = myMin(memo[z][x][y][w], testFall(x, x, y + w));
        }
        for (int l = y; l < y + w; l++) {
            for (int r = l; r < y + w; r++) {
                a[x + 1][r] = '.';
                if (l == y && r == y + w - 1) {
                    continue;
                }

                int ddig = r - l + 1;
//                if (memo[x][y][w] != -1 && ddig > memo[x][y][w]) {
//                    continue;
//                }

//                System.out.println(" " + l + " " + r);
                memo[z][x][y][w] = myMin(memo[z][x][y][w], testFall(x, x + 1, l) + ddig);
                memo[z][x][y][w] = myMin(memo[z][x][y][w], testFall(x, x + 1, r) + ddig);
            }
            for (int r = l; r < y + w; r++) {
                a[x + 1][r] = '#';
            }
        }
//        System.out.println(x + " " + y + " " + w + " " + memo[z][x][y][w]);
        return memo[z][x][y][w];
    }

    public void solve() throws IOException {
        in = new BufferedReader(new FileReader("B-small-attempt1.in"));
        PrintWriter out = new PrintWriter(new File("B-small-attempt1.out"));

        int testn = Integer.parseInt(in.readLine());
        for (int test = 0; test < testn; test++) {
            r = nextInt();
            c = nextInt();
            f = nextInt();

            a = new char[r][];
            for (int i = 0; i < r; i++) {
                a[i] = nextToken().toCharArray();
            }

            memo = new int[4][r][c][c + 1];
            for (int z = 0; z < 4; z++) {
                for (int i = 0; i < r; i++) {
                    for (int j = 0; j < c; j++) {
                        Arrays.fill(memo[z][i][j], -1);
                    }
                }
            }


            int sx = 0;
            int sy = 0;
            int sw = 1;
            while (sw < c && a[0][sw] == '.' && a[1][sw] == '#') {
                sw++;
            }

            int ans = search(sw == c || a[0][sw] == '#' ? 3 : 1, sx, sy, sw);

            if (ans >= Integer.MAX_VALUE / 2) {
                System.out.println("Case #" + (test + 1) + ": NO");
                out.println("Case #" + (test + 1) + ": NO");
            } else {
                System.out.println("Case #" + (test + 1) + ": YES " + ans);
                out.println("Case #" + (test + 1) + ": YES " + ans);
            }
        }

        in.close();
        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
            throw new AssertionError();
        }
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new Thread(new B()).start();
    }
}