import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;

public class C {
    private static final double EPS = 1e-6;
    FastScanner in;
    PrintWriter out;


    public void solve() throws IOException {
        int testNo = in.nextInt();
        for (int test = 1; test <= testNo; test++) {
            double y = in.nextInt();
            int n = in.nextInt();
            double[] p = new double[n];
            int np = 0;
            int nn = 0;
            for (int i = 0; i < n; i++) {
                p[i] = in.nextInt();
                if (p[i] > 0) {
                    np++;
                }
                if (p[i] < 0) {
                    nn++;
                }
            }
            double[] pp = new double[np];
            double[] pn = new double[nn];
            np = nn = 0;
            for (int i = 0; i < n; i++) {
                if (p[i] > 0) {
                    pp[np++] = p[i];
                } else {
                    pn[nn++] = -p[i];
                }
            }
            double[] sp = new double[np];
            double[] sn = new double[nn];
            np = nn = 0;
            for (int i = 0; i < n; i++) {
                if (p[i] > 0) {
                    sp[np++] = in.nextInt();
                } else {
                    sn[nn++] = in.nextInt();
                }
            }

            double[][][] a = new double[2][np + 1][nn + 1];
            double[][][] prevpos = new double[2][np + 1][nn + 1];
            for (double[] z : a[0]) {
                Arrays.fill(z, Double.POSITIVE_INFINITY);
            }
            for (double[] z : a[1]) {
                Arrays.fill(z, Double.POSITIVE_INFINITY);
            }
            a[0][0][0] = a[1][0][0] = 0;
            double ans = Double.POSITIVE_INFINITY;
            for (int i = 0; i <= np; i++) {
                for (int j = 0; j <= nn; j++) {
                    if (a[0][i][j] < Double.POSITIVE_INFINITY) {
                        double st = a[0][i][j];
                        double spos = i == 0 ? 0 : pp[i - 1] + st * sp[i - 1];
                        double ppos = j == 0 ? 0 : prevpos[0][i][j];
                        double pt = st - (spos + ppos) / y;

                        boolean good = true;
                        for (int k = 0; k < np; k++) {
                            double wh = pp[k] + sp[k] * st;
                            if (wh > spos + EPS) {
                                good = false;
                            }
                        }
                        for (int k = 0; k < nn; k++) {
                            double wh = pn[k] + sn[k] * pt;
                            if (wh > ppos + EPS) {
                                good = false;
                            }
                        }

                        if (good) {
                            ans = Math.min(ans, a[0][i][j]);
                        }

                        for (int k = j; k < nn; k++) {
                            if (pn[k] + pt * sn[k] <= ppos) {
                                continue;
                            }
                            double dist = spos + pn[k] + sn[k] * st;
                            double ds = y - sn[k];
                            double time = st + dist / ds;
                            if (a[1][i][k + 1] > time) {
                                a[1][i][k + 1] = time;
                                prevpos[1][i][k + 1] = spos;
                            }
                        }
                    }
                    if (a[1][i][j] < Double.POSITIVE_INFINITY) {
                        double st = a[1][i][j];
                        double spos = j == 0 ? 0 : pn[j - 1] + st * sn[j - 1];
                        double ppos = i == 0 ? 0 : prevpos[1][i][j];
                        double pt = st - (spos + ppos) / y;

                        boolean good = true;
                        for (int k = 0; k < np; k++) {
                            double wh = pp[k] + sp[k] * pt;
                            if (wh > ppos + EPS) {
                                good = false;
                            }
                        }
                        for (int k = 0; k < nn; k++) {
                            double wh = pn[k] + sn[k] * st;
                            if (wh > spos + EPS) {
                                good = false;
                            }
                        }

                        if (good) {
                            ans = Math.min(ans, a[1][i][j]);
                        }

                        for (int k = i; k < np; k++) {
                            if (pp[k] + pt * sp[k] <= ppos) {
                                continue;
                            }
                            double dist = spos + pp[k] + sp[k] * st;
                            double ds = y - sp[k];
                            double time = st + dist / ds;
                            if (a[0][k + 1][j] > time) {
                                a[0][k + 1][j] = time;
                                prevpos[0][k + 1][j] = spos;
                            }
                        }
                    }
                }
            }


            out("Case #%d: %.10f\n", test, ans);
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("C-small-attempt0.in"));
            out = new PrintWriter(new File("C-small-attempt0.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] arg) {
        new C().run();
    }

    void out(String format, Object... s) {
        System.out.printf(format, s);
        out.printf(format, s);
        out.flush();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File file) throws IOException {
            br = new BufferedReader(new FileReader(file));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                    return "";
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }
}