import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class AEasy {
    FastScanner in;
    PrintWriter out;

    class R {
        int[] r;

        public R(int[] r) {
            this.r = r;
        }

        public R(int x, int L) {
            r = new int[L];
            for (int i = 0; i < L; i++) {
                int t = x % 10;
                x = x / 10;
                r[L - i - 1] = t;
            }
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            R r1 = (R) o;

            return Arrays.equals(r, r1.r);
        }

        @Override
        public int hashCode() {
            return Arrays.hashCode(r);
        }
    }

    R read() {
        String s = in.next();
        int[] res = new int[s.length()];
        for (int i = 0; i < s.length(); i++) {
            res[i] = s.charAt(i) - '0';
        }
        return new R(res);
    }

    boolean valid(int x, int L) {
        for (int i = 0; i < L; i++) {
            int t = x % 10;
            x /= 10;
            if (t > L) {
                return false;
            }
        }
        return x == 0;
    }

    R decay(R r) {
        int[] res = new int[r.r.length];
        for (int x : r.r) {
            if (x > 0) {
                res[x - 1]++;
            }
        }
        return new R(res);
    }

    public void solve() throws IOException {
        int testNo = in.nextInt();

        for (int test = 1; test <= testNo; test++) {
            R v = read();
            int L = v.r.length;
            int p10 = 1;
            for (int i = 0; i < L; i++) {
                p10 *= 10;
            }
            int ans = 0;

            for (int i = 0; i < p10; i++) {
                if (valid(i, L)) {
                    R cur = new R(i, L);
                    R prev = null;
                    while (!cur.equals(v) && !cur.equals(prev)) {
                        prev = cur;
                        cur = decay(cur);
                    }
                    if (cur.equals(v)) {
                        ans++;
                    }
                }
            }

            System.out.println("Case #" + test + ": " + ans);
            out.println("Case #" + test + ": " + ans);
        }
    }

    public void run() {
        try {
            in = new FastScanner(new File("A-small-attempt0.in"));
            out = new PrintWriter(new File("A-small-attempt0.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] arg) {
        Locale.setDefault(Locale.US);
        new AEasy().run();
    }

    void out(String format, Object... s) {
        System.out.printf(format, s);
        out.printf(format, s);
        out.flush();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File file) throws IOException {
            br = new BufferedReader(new FileReader(file));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                    return "";
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }
        long nextLong() {
            return Long.parseLong(next());
        }
    }
}