import java.io.IOException;
import java.io.File;
import java.io.PrintWriter;
import java.util.*;

public class DEasy implements Runnable {
    int[] nc;
    int k;
    int n;
    int p;
    private int MOD = 30031;

    class Profile {
        int[] r;

        Profile() {
            r = new int[k];
            for (int i = 0; i < k; i++) {
                r[i] = i;
            }
        }

        Profile(int[] r) {
            this.r = r;
        }

        Profile next(int z) {
            int[] v = r.clone();
            for (int i = 0; i < k; i++) {
                v[i]++;
            }
            v[z] = 0;
            for (int i = 0; i < k; i++) {
                if (v[i] >= p) {
                    return null;
                }
            }
            Arrays.sort(v);
            return new Profile(v);
        }

        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Profile profile = (Profile) o;

            if (!Arrays.equals(r, profile.r)) return false;

            return true;
        }

        boolean isValid() {
            for (int i = 0; i < k; i++) {
                if (r[i] != i) {
                    return false;
                }
            }
            return true;
        }

        public int hashCode() {
            return (r != null ? Arrays.hashCode(r) : 0);
        }
    }

    public void solve() throws IOException {
        Scanner in = new Scanner(new File("D-small-attempt0.in"));
        PrintWriter out = new PrintWriter(new File("D-small-attempt0.out"));

        int tn = in.nextInt();
        for (int test = 1; test <= tn; test++) {
            n = in.nextInt();
            k = in.nextInt();
            p = in.nextInt();
            nc = new int[p];

            Profile start = new Profile();
            ArrayList<HashMap<Profile, Integer>> d = new ArrayList<HashMap<Profile, Integer>>();
            d.add(new HashMap<Profile, Integer>());
            d.get(0).put(start, 1);
            int ind = 0;
            for (int i = k + 1; i <= n; i++) {
                HashMap<Profile, Integer> next = new HashMap<Profile, Integer>();
                d.add(next);
                HashMap<Profile, Integer> prev = d.get(ind);
                ind++;
                for (Map.Entry<Profile, Integer> p : prev.entrySet()) {
                    for (int z = 0; z < k; z++) {
                        Profile q = p.getKey().next(z);
                        if (q != null) {
                            if (next.containsKey(q)) {
                                next.put(q, (next.get(q) + p.getValue()) % MOD);
                            } else {
                                next.put(q, p.getValue());
                            }
                        }
                    }
                }
            }

            int ans = 0;
            HashMap<Profile, Integer> last = d.get(ind);
            for (Map.Entry<Profile, Integer> p : last.entrySet()) {
                if (p.getKey().isValid()) {
                    ans = (ans + p.getValue()) % MOD;
                }
            }

            System.out.println(ans);
            out.printf("Case #%d: %d\n", test, ans);
        }

        out.close();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new Thread(new DEasy()).start();
    }
}
