import java.io.*;
import java.util.StringTokenizer;

public class C {
    FastScanner in;
    PrintWriter out;

    class R {
        int x1, y1, x2, y2;

        R(int x1, int y1, int x2, int y2) {
            this.x1 = x1;
            this.y1 = y1;
            this.x2 = x2;
            this.y2 = y2;
        }

        int dist(R that) {
            int ans;
            if (that.x1 >= x2) {
                if (that.y1 >= y2) {
                    ans = Math.max(that.x1 - x2, that.y1 - y2);
                } else if (y1 >= that.y2) {
                    ans = Math.max(that.x1 - x2, y1 - that.y2);
                } else {
                    ans = that.x1 - x2;
                }
            } else if (x1 >= that.x2) {
                if (that.y1 >= y2) {
                    ans = Math.max(x1 - that.x2, that.y1 - y2);
                } else if (y1 >= that.y2) {
                    ans = Math.max(x1 - that.x2, y1 - that.y2);
                } else {
                    ans = x1 - that.x2;
                }
            } else {
                if (that.y1 >= y2) {
                    ans = that.y1 - y2;
                } else if (y1 >= that.y2) {
                    ans = y1 - that.y2;
                } else {
                    throw new AssertionError("Overlap!");
                }
            }

            return ans;
        }
    }


    public void solve() throws IOException {
        int testNo = in.nextInt();
        for (int test = 1; test <= testNo; test++) {
            System.out.println("Test " + test);
            int w = in.nextInt();
            int h = in.nextInt();
            int n = in.nextInt();

            R[] r = new R[n];
            for (int i = 0; i < n; i++) {
                r[i] = new R(in.nextInt(), in.nextInt(), in.nextInt() + 1, in.nextInt() + 1);
            }

            int[][] d = new int[n + 2][n + 2];
            d[0][1] = d[1][0] = w;
            for (int i = 0; i < n; i++) {
                d[0][i + 2] = d[i + 1][0] = r[i].x1;
                d[1][i + 2] = d[i + 2][1] = w - r[i].x2;
            }

            for (int i = 0; i < n; i++) {
                for (int j = i + 1; j < n; j++) {
                    d[i + 2][j + 2] = d[j + 2][i + 2] = r[i].dist(r[j]);
                }
            }

            for (int k = 0; k < n + 2; k++) {
                for (int i = 0; i < n + 2; i++) {
                    for (int j = 0; j < n + 2; j++) {
                        if (d[i][j] > d[i][k] + d[k][j]) {
                            d[i][j] = d[i][k] + d[k][j];
                        }
                    }
                }
            }

            out("Case #%d: %d\n", test, d[0][1]);
        }
    }

    void out(String format, Object... s) {
        System.out.printf(format, s);
        out.printf(format, s);
        out.flush();
    }

    public void run() {
        try {
            in = new FastScanner(new File("C-small-attempt0.in"));
            out = new PrintWriter(new File("C-small-attempt0.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] arg) {
        new C().run();
    }

static class FastScanner {
    BufferedReader br;
    StringTokenizer st;

    FastScanner(File file) throws IOException {
        br = new BufferedReader(new FileReader(file));
    }

    String next() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (IOException e) {
                e.printStackTrace();
                return "";
            }
        }
        return st.nextToken();
    }

    int nextInt() {
        return Integer.parseInt(next());
    }

    long nextLong() {
        return Long.parseLong(next());
    }
}
}