import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

public class C {
    FastScanner in;
    PrintWriter out;

    final static int MAX = 2000;

    class Vertex {
        int who;
        boolean type;
        int from;
        int to;
        boolean priority;

        Vertex(int who, boolean type, int from, int to, boolean priority) {
            this.who = who;
            this.type = type;
            this.from = from;
            this.to = to;
            this.priority = priority;
        }
    }

    ArrayList<Integer>[] e;
    int[] px;
    int[] py;
    boolean[] u;

    boolean dfs(int i) {
        u[i] = true;
        for (int j : e[i]) {
            if (py[j] == -1 || (!u[py[j]] && dfs(py[j]))) {
                py[j] = i;
                px[i] = j;
                return true;
            }
        }
        return false;
    }

    public void solve() throws IOException {
        int testNo = in.nextInt();
        for (int test = 1; test <= testNo; test++) {
            int n = in.nextInt();
            boolean[] type = new boolean[n];
            int[] id = new int[n];
            int nz = 0;
            for (int i = 0; i < n; i++) {
                type[i] = in.next().equals("E");
                id[i] = in.nextInt();
                if (id[i] == 0) {
                    nz++;
                }
            }

            ArrayList<Vertex> va = new ArrayList<Vertex>();
            for (int w = 1; w <= MAX; w++) {
                boolean first = true;
                int last = -1;
                for (int i = 0; i < n; i++) {
                    if (id[i] == w) {
                        if (first) {
                            first = false;
                            if (!type[i]) {
                                va.add(new Vertex(w, false, 0, i, false));
                            }
                        } else {
                            if (type[i] == type[last]) {
                                va.add(new Vertex(w, type[i], last, i, true));
                            }
                        }
                        last = i;
                    }
                }
                if (last != -1 && type[last]) {
                    va.add(new Vertex(w, true, last, n - 1, false));
                }
            }

            Vertex[] v = va.toArray(new Vertex[va.size()]);
            e = new ArrayList[va.size()];
            for (int i = 0; i < e.length; i++) {
                e[i] = new ArrayList<Integer>();
            }
            for (int i = 0; i < v.length; i++) {
                for (int j = 0; j < n; j++) {
                    if (v[i].from <= j && j <= v[i].to && id[j] == 0 && type[j] != v[i].type) {
                        e[i].add(j);
                    }
                }
            }

            px = new int[v.length];
            py = new int[n];
            Arrays.fill(px, -1);
            Arrays.fill(py, -1);
            boolean fail = false;
            u = new boolean[v.length];
            for (int i = 0; i < v.length; i++) {
                if (v[i].priority) {
                    Arrays.fill(u, false);
                    if (!dfs(i)) {
                        fail = true;
                        break;
                    }
                }
            }

            if (!fail) {
                for (int i = 0; i < v.length; i++) {
                    if (!v[i].priority) {
                        Arrays.fill(u, false);
                        dfs(i);
                    }
                }
                for (int i = 0; i < v.length; i++) {
                    if (px[i] != -1) {
                        id[px[i]] = v[i].who;
                    }
                }

                boolean[] isIn = new boolean[MAX];
                int otherIn = 0;
                for (int i = 0; i < n; i++) {
                    if (id[i] != 0) {
                        isIn[id[i]] = type[i];
                    } else {
                        otherIn += (type[i] ? 1 : -1);
                        if (otherIn < 0) {
                            otherIn = 0;
                        }
                    }
                }
                int ans = otherIn;
                for (int i = 0; i < MAX; i++) {
                    if (isIn[i]) {
                        ans++;
                    }
                }
                out("Case #%d: %d\n", test, ans);
            } else {
                out("Case #%d: CRIME TIME\n", test);
            }
        }
    }

    void out(String format, Object... s) {
        System.out.printf(format, s);
        out.printf(format, s);
        out.flush();
    }

    public void run() {
        try {
            in = new FastScanner(new File("C-small-attempt0.in"));
            out = new PrintWriter(new File("C-small-attempt0.out"));

            solve();

            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] arg) {
        new C().run();
    }

    static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        FastScanner(File file) throws IOException {
            br = new BufferedReader(new FileReader(file));
        }

        String next() {
            while (st == null || !st.hasMoreTokens()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                    return "";
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }
    }
}