import javax.crypto.Mac;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class D_as {
    Scanner in;
    PrintWriter out;

    public void solve() throws IOException {
        int M = 1000;
        double[][] a = new double[M + 1][M + 1];
        a[1][1] = 1.0;
        for (int i = 1; i < M; i++) {
            for (int j = 0; j <= i; j++) {
                a[i + 1][j + 1] += a[i][j] / (i + 1);
                a[i + 1][j] += a[i][j] * (i - j) / (i + 1);
                if (j > 0) {
                    a[i + 1][j - 1] += a[i][j] * j / (i + 1);
                }
            }
        }

        double[] l = new double[M + 1];
        for (int i = 2; i <= M; i++) {
            l[i] = Double.POSITIVE_INFINITY;
            for (int k = 1; k < i; k++) {
                double r = 2.0 + l[k] + l[i - k];
                if (r < l[i]) {
                    l[i] = r;
                }
            }
        }

        System.out.println(Arrays.toString(l));

        int tn = in.nextInt();
        for (int test = 1; test <= tn; test++) {
            int n = in.nextInt();
            int[] p = new int[n];
            int m = 0;
            for (int i = 0; i < n; i++) {
                p[i] = in.nextInt() - 1;
            }

            double ans = 0;
            boolean[] u = new boolean[n];
            for (int i = 0; i < n; i++) {
                if (!u[i]) {
                    int j = i;
                    int len = 0;
                    while (!u[j]) {
                        u[j] = true;
                        j = p[j];
                        len++;
                    }
                    ans += l[len];
                }
            }

            out.printf("Case #" + test + ": %.10f\n", ans);
        }
    }

    public void run() {
        try {
            in = new Scanner(new File("D-small-attempt0.in"));
            out = new PrintWriter(new File("D-small-attempt0.out"));

            solve();

            in.close();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] arg) {
        Locale.setDefault(Locale.US);
        new D_as().run();
    }
}