import java.io.BufferedInputStream;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.TreeSet;


public class TaskC {

    public static void main(String[] args) {
        long time = System.currentTimeMillis();
        Scanner sc = new Scanner(new BufferedInputStream(System.in));
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            int n = sc.nextInt();
            sc.nextLine();
            TreeMap<String, List<Pair>> first = new TreeMap<>();
            TreeMap<String, List<Pair>> second = new TreeMap<>();
            List<Pair> words = new LinkedList<Pair>();
            for (int j = 0; j < n; j++) {
                String s = sc.nextLine();
                String[] split = s.split(" ");
                Pair p = new Pair(split[0], split[1]);
                words.add(p);
                add(first, split[0], p);
                add(second, split[1], p);
            }
            if (n <= 2) {
                print(i, 0);
                continue;
            }
            int answer = n;
            TreeSet<String> firstWords = new TreeSet<>();
            TreeSet<String> secondWords = new TreeSet<>();
            Iterator<Entry<String, List<Pair>>> it = first.entrySet().iterator();
            while (it.hasNext()) {
                Entry<String, List<Pair>> entry = it.next();
                if (entry.getValue().size() == 1) {
                    Pair word = entry.getValue().get(0);
                    firstWords.add(word.first);
                    secondWords.add(word.second);
                    answer--;
                    it.remove();
                }
            }
            
            it = second.entrySet().iterator();
            while (it.hasNext()) {
                Entry<String, List<Pair>> entry = it.next();
                if (entry.getValue().size() == 1) {
                    Pair word = entry.getValue().get(0);
                    boolean val = firstWords.add(word.first);
                    secondWords.add(word.second);
                    if (val) answer--;
                    it.remove();
                }
            }
            
            print(i, answer - first.size());
        }
        sc.close();
        System.err.println(System.currentTimeMillis() - time);
    }
    
    private static void remove(TreeMap<String, List<Pair>> words, String word, Pair pair) {
        List<Pair> list = words.get(word);
        list.remove(pair);
        if (list.size() == 0) {
            words.remove(word);
        }
    }
    
    private static void add(TreeMap<String, List<Pair>> words, String word, Pair pair) {
        List<Pair> list = words.get(word);
        if (list == null) {
            list = new LinkedList<>();
            list.add(pair);
            words.put(word, list);
        } else {
            list.add(pair);
        }
    }
    
    private static class Pair {
        String first;
        String second;
        public Pair(String first, String second) {
            this.first = first;
            this.second = second;
        }
    }
    
    private static void print(int caseNum, int answer) {
        System.out.println("Case #" + caseNum + ": " + answer);
    }

}
