import java.io.BufferedInputStream;
import java.util.Arrays;
import java.util.Scanner;


public class TaskD2 {

    public static void main(String[] args) {
        long time = System.currentTimeMillis();
        Scanner sc = new Scanner(new BufferedInputStream(System.in));
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            int k = sc.nextInt();
            int c = sc.nextInt();
            int s = sc.nextInt();
            if (k == 1) {
                long[] ans = {1L};
                print(i, ans);
                continue;
            }
            if (s < k - c + 1) {
                print(i, null);
                continue;
            }
            long[] answer = null;
            if (s == k) {
                answer = forEqualKS(k, c);
            } else {
                if (c > k) {
                    c = k;
                }
                answer = generalCase(k, c, s);
            }
            print(i, answer);
        }
        sc.close();
        System.err.println(System.currentTimeMillis() - time);
    }
    
    private static long[] forEqualKS(int k, int c) {
        int s = k;
        long[] answer = new long[s];
        long mul = 1L;
        for (int j = 0; j < c; j++) {
            mul *= k;
        }
        mul--;
        mul /= (k - 1);
        for (int j = 0; j < s; j++) {
            answer[j] = mul * j + 1;
        }
        return answer;
    }
    
    private static long[] generalCase(int k, int c, int s) {
        long[] arr = new long[k];
        for (int i = 0; i < k; i++) {
            arr[i] = i + 1;
        }
        long pow = 1L;
        for (int i = 1; i < c; i++) {
            pow *= k; // k^i
            for (int j = i + 1; j < k; j++) {
                arr[j] += (j - i) * pow;
            }
        }
        long[] answer = Arrays.copyOfRange(arr, c - 1, k);
        return answer;
    }
    
    private static void print(int caseNum, long[] answer) {
        StringBuilder sb = new StringBuilder();
        sb.append("Case #").append(caseNum).append(':');
        if (answer == null) {
            sb.append(" IMPOSSIBLE");
        } else {
            for (long l : answer) {
                sb.append(' ').append(l);
            }
        }
        System.out.println(sb.toString());
    }

}
