
import java.io.*;
import java.util.Arrays;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.TreeMap;


public class Solution {
    private static String inputFilename = "src/input.txt";
    private static String outputFilename = "src/output.txt";
    private BufferedReader in;
    private StringTokenizer line;
    private PrintWriter out;
    private boolean isDebug;

    public Solution(boolean isDebug) {
        this.isDebug = isDebug;
    }

    public void solve() throws IOException {
        long n = nextLong();
        long k = nextLong();
        TreeMap<Long, Long> a = new TreeMap<>();
        add(a, n, 1);
        long lstLen = n;
        while (k > 0) {
            Map.Entry<Long, Long> e = a.pollLastEntry();
            lstLen = e.getKey();
            k -= e.getValue();
            add(a, lstLen / 2, e.getValue());
            add(a, lstLen - 1 - lstLen / 2, e.getValue());
        }
        long v1 = lstLen / 2;
        long v2 = lstLen - 1 - lstLen / 2;
        out.println(Math.max(v1, v2) + " " + Math.min(v1, v2));
    }

    private void add(TreeMap<Long, Long> a, long key, long value) {
        if (value == 0) return;
        Long oldValue = a.get(key);
        if (oldValue == null) {
            a.put(key, value);
        } else {
            value += oldValue;
            if (value == 0) {
                a.remove(key);
            } else {
                a.put(key, value);
            }
        }
    }

    public static void main(String[] args) throws IOException {
        new Solution(Arrays.asList(args).contains("DEBUG_MODE")).run(args);
    }

    public void run(String[] args) throws IOException {
        if (isDebug) {
            in = new BufferedReader(new InputStreamReader(new FileInputStream(inputFilename)));
//            in = new BufferedReader(new InputStreamReader(System.in));
        } else {
            in = new BufferedReader(new InputStreamReader(System.in));
        }
//        out = new PrintWriter(System.out);
        out = new PrintWriter(outputFilename);

        int t = nextInt();
//        int t = 1;
        for (int i = 0; i < t; i++) {
            out.print("Case #" + (i + 1) + ": ");
            solve();
        }

        in.close();
        out.flush();
        out.close();
    }

    private int[] nextIntArray(int n) throws IOException {
        int[] res = new int[n];
        for (int i = 0; i < n; i++) {
            res[i] = nextInt();
        }
        return res;
    }

    private long[] nextLongArray(int n) throws IOException {
        long[] res = new long[n];
        for (int i = 0; i < n; i++) {
            res[i] = nextLong();
        }
        return res;
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private String nextToken() throws IOException {
        while (line == null || !line.hasMoreTokens()) {
            line = new StringTokenizer(in.readLine());
        }
        return line.nextToken();
    }
}
