import java.io.*;
import java.util.Arrays;
import java.util.StringTokenizer;


public class Solution {
    private static String inputFilename = "input.txt";
    private static String outputFilename = "output.txt";
    private BufferedReader in;
    private StringTokenizer line;
    private PrintWriter out;
    private boolean isDebug;

    public Solution(boolean isDebug) {
        this.isDebug = isDebug;
    }

    public void solve() throws IOException {
        int n = nextInt();
        int p = nextInt();
        int[] a = new int[p];
        for (int i = 0; i < n; i++) {
            a[nextInt() % p]++;
        }
        int res = 0;
        if (p == 2) {
            res = a[0] + (a[1] + 1) / 2;
        } else if (p == 3) {
            int t = Math.min(a[1], a[2]);
            res = a[0] + t;
            a[1] -= t;
            a[2] -= t;
            t = a[1] + a[2];
            res += (t + 2) / 3;
        } else if (p == 4) {
            int t = Math.min(a[1], a[3]);
            res = a[0] + a[2] / 2 + t;
            a[2] %= 2;
            a[1] -= t;
            a[3] -= t;
            t = a[1] + a[3];
            if (a[2] > 0 && t >= 2) {
                res++;
                a[2]--;
                t -= 2;
            }
            res += (t + 3) / 4;
        }
        out.println(res);
    }

    public static void main(String[] args) throws IOException {
        new Solution(Arrays.asList(args).contains("DEBUG_MODE")).run(args);
    }

    public void run(String[] args) throws IOException {
        if (isDebug) {
            in = new BufferedReader(new InputStreamReader(new FileInputStream(inputFilename)));
//            in = new BufferedReader(new InputStreamReader(System.in));
        } else {
            in = new BufferedReader(new InputStreamReader(System.in));
        }
//        out = new PrintWriter(System.out);
        out = new PrintWriter(outputFilename);

        int t = nextInt();
//        int t = 1;
        for (int i = 0; i < t; i++) {
            out.print("Case #" + (i + 1) + ": ");
            solve();
        }

        in.close();
        out.flush();
        out.close();
    }

    private int[] nextIntArray(int n) throws IOException {
        int[] res = new int[n];
        for (int i = 0; i < n; i++) {
            res[i] = nextInt();
        }
        return res;
    }

    private long[] nextLongArray(int n) throws IOException {
        long[] res = new long[n];
        for (int i = 0; i < n; i++) {
            res[i] = nextLong();
        }
        return res;
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private String nextToken() throws IOException {
        while (line == null || !line.hasMoreTokens()) {
            line = new StringTokenizer(in.readLine());
        }
        return line.nextToken();
    }
}
