import java.io.*;
import java.math.BigInteger;
import java.util.*;


public class Solution {
    private BufferedReader in;
    private StringTokenizer line;
    private PrintWriter out;

    private static final int mm = 1000000007;

    public void solve() throws IOException {
        out.println();
        int n = nextInt();
        int cnt = nextInt();
//        BigInteger maxDigit = BigInteger.TEN.pow(n - 1);
        for (int i = 0; cnt > 0; i++) {
            String s = "" + BigInteger.valueOf(i).toString(2) + "1";
            while (s.length() <= n - 1 - 5) s = "00000" + s;
            while (s.length() < n - 1) s = "0" + s;
            s = "1" + s;
            int[] a = getDivs(s);
            if (a != null) {
                cnt--;
                out.print(s);
                for (int j : a) {
                    out.print(" " + j);
                }
                out.println();
                out.flush();
                check(n, s, a);
            }
        }
    }

    private void check(int n, String s, int[] a) {
        if (s.length() != n || a.length != 9) {
            out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 1");
            return;
        }
        for (int i = 0; i < 9; i++) {
            BigInteger b = new BigInteger(s, i + 2);
            if (a[i] <= 1 || !b.mod(BigInteger.valueOf(a[i])).equals(BigInteger.ZERO)){
                out.println("!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! 2 " + i);
                return;
            }
        }
    }

    private static int SZ = 10000;
    private static int[] primes = new int[SZ];
    private static BigInteger[] iprimes = new BigInteger[SZ];

    static {
        primes[0] = 2;
        iprimes[0] = BigInteger.valueOf(2);
        int c = 1;
        for (int i = 3; c < SZ; i += 2) {
            boolean pp = true;
            for (int j = 0; primes[j] * primes[j] <= i; j++) {
                if (i % primes[j] == 0) {
                    pp = false;
                    break;
                }
            }
            if (pp) {
                iprimes[c] = BigInteger.valueOf(i);
                primes[c++] = i;
            }
        }
    }

    private int[] getDivs(String s) {
        int[] res = new int[9];
        for (int i = 2; i <= 10; i++) {
            BigInteger j = new BigInteger(s, i);
            for (BigInteger p : iprimes) {
                if (j.mod(p).equals(BigInteger.ZERO) && p.compareTo(j) < 0) {
                    res[i - 2] = (int) p.longValue();
                    break;
                }
            }
            if (res[i - 2] == 0) {
                return null;
            }
        }
        return res;
    }

    public static void main(String[] args) throws IOException {
        new Solution().run(args);
    }

    public void run(String[] args) throws IOException {
        if (args.length > 0 && "DEBUG_MODE".equals(args[0])) {
            in = new BufferedReader(new InputStreamReader(new FileInputStream("input.txt")));
        } else {
            in = new BufferedReader(new InputStreamReader(System.in));
        }
//        out = new PrintWriter(System.out);
        out = new PrintWriter("output.txt");

        int t = nextInt();
//        int t = 1;
        for (int i = 0; i < t; i++) {
            out.print("Case #" + (i + 1) + ": ");
            solve();
        }

        in.close();
        out.flush();
        out.close();
    }

    private int[] nextIntArray(int n) throws IOException {
        int[] res = new int[n];
        for (int i = 0; i < n; i++) {
            res[i] = nextInt();
        }
        return res;
    }

    private long[] nextLongArray(int n) throws IOException {
        long[] res = new long[n];
        for (int i = 0; i < n; i++) {
            res[i] = nextInt();
        }
        return res;
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private String nextToken() throws IOException {
        while (line == null || !line.hasMoreTokens()) {
            line = new StringTokenizer(in.readLine());
        }
        return line.nextToken();
    }

    private static class Pii {
        private int key;
        private int value;

        public Pii(int key, int value) {
            this.key = key;
            this.value = value;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Pii pii = (Pii) o;

            if (key != pii.key) return false;
            return value == pii.value;

        }

        @Override
        public int hashCode() {
            int result = key;
            result = 31 * result + value;
            return result;
        }
    }

    private static class Pair<K, V> {
        private K key;
        private V value;

        public Pair(K key, V value) {
            this.key = key;
            this.value = value;
        }

        public K getKey() {
            return key;
        }

        public V getValue() {
            return value;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Pair<?, ?> pair = (Pair<?, ?>) o;

            if (key != null ? !key.equals(pair.key) : pair.key != null) return false;
            return !(value != null ? !value.equals(pair.value) : pair.value != null);

        }

        @Override
        public int hashCode() {
            int result = key != null ? key.hashCode() : 0;
            result = 31 * result + (value != null ? value.hashCode() : 0);
            return result;
        }
    }
}