import java.io.*;
import java.math.BigInteger;
import java.util.*;

@SuppressWarnings("unused")
public class Solution {
    public static void main(String[] args) throws IOException {
        boolean isDebugMode = Arrays.asList(args).contains("DEBUG_MODE");

        InputStream inputStream;
        OutputStream outputStream;

        if (isDebugMode) {
//            inputStream = new ConsoleInputStream();
            inputStream = new FileInputStream();

//            outputStream = new FileOutputStream();
            outputStream = new ConsoleOutputStream();
        } else {
            inputStream = new FileInputStream();
            outputStream = new FileOutputStream();
        }

        inputStream.open();
        outputStream.open();

        new Solution().run(inputStream, outputStream, isDebugMode);

        outputStream.close();
        inputStream.close();
    }

    @SuppressWarnings("FieldCanBeLocal")
    private InputStream in;
    private OutputStream out;
    private boolean isDebugMode;
    private Timer timer = new Timer();

    private void printInDebug(String s) throws IOException {
        if (isDebugMode) {
            out.println(s);
            out.flush();
        }
    }

    private void printTimer(String mark) throws IOException {
        printInDebug(mark + ": " + timer.getMillisAndReset() + " ms.");
    }

    private static String formatDouble(double n, int precision) {
        return String.format(Locale.ENGLISH, "%." + precision + "f", n);
    }

    private void run(InputStream in, OutputStream out, boolean isDebugMode) throws IOException {
        this.in = in;
        this.out = out;
        this.isDebugMode = isDebugMode;

        int t = in.nextInt();
        for (int i = 0; i < t; i++) {
            solve(i + 1);
            out.flush();
        }
    }
//    9
//            3 5 6 7 4 2 1 8 9

    private void solve(int testNum) throws IOException {
        out.print("Case #", testNum, ": ");

        int n = in.nextInt();
        int[] a = in.nextIntArray(n);

//        if (isDebugMode) {
//        if (solve3(a, n) != solve2(a, n)) {
//            out.println("!!!!!!! ");
//        }
//        }
//        out.println(solve3(a, n), ' ', solve2(a, n), ' ', solve1(a, n));
        out.println(solve3(a, n));
    }

    private int solve2(int[] a, int n) {
        int mx = 0;
        for (int i = 0; i < n; i++) {
            if (a[mx] < a[i]) {
                mx = i;
            }
        }
        int mxx = a[mx];

        int[] c = Arrays.copyOf(a, a.length);
        Arrays.sort(c);
        int ans = Integer.MAX_VALUE;
        int d = 0;
        while (true) {
            boolean pp = true;
            for (int i = 0; c[i] != mxx; i++) {
                if (c[i] > c[i + 1]) {
                    pp = false;
                    break;
                }
            }
            for (int i = n - 1; c[i] != mxx; i--) {
                if (c[i - 1] < c[i]) {
                    pp = false;
                    break;
                }
            }
            if (pp) {
                int t = 0;
                int[] f = Arrays.copyOf(a, a.length);
                for (int i = 0; i < n; i++) {
                    for (int j = n - 1; j > i; j--) {
                        if (f[j] == c[i]) {
                            int tt = f[j];
                            f[j] = f[j - 1];
                            f[j - 1] = tt;
                            t++;
                        }
                    }
                    if (f[i] != c[i]) throw new RuntimeException();
                }
                ans = Math.min(ans, t);
                d++;
            }

            if (!next_permutation(c)) break;
        }
//        out.println("=======", d, "==========");
        return ans;
    }

    private int solve1(int[] a, int n) {
        int mx = 0;
        for (int i = 0; i < n; i++) {
            if (a[mx] < a[i]) {
                mx = i;
            }
        }
        int ans = Integer.MAX_VALUE;
        for (int i = 0; i < n; i++) {
            int[] b = Arrays.copyOf(a, a.length);
            int t = 0;
            if (i < mx) {
                for (int j = mx - 1; j >= i; j--) {
                    t++;
                    b[j + 1] = b[j];
                }
                b[i] = a[mx];
            } else {
                for (int j = mx + 1; j <= i; j++) {
                    t++;
                    b[j - 1] = b[j];
                }
                b[i] = a[mx];
            }

            for (int j = 0; j < i; j++) {
                for (int k = 0; k < i; k++) {
                    if (b[k] > b[k + 1]) {
                        int tt = b[k + 1];
                        b[k + 1] = b[k];
                        b[k] = tt;
                        t++;
                    }
                }
            }
            for (int j = 0; j < n - i + 2; j++) {
                for (int k = n - 1; k > i; k--) {
                    if (b[k - 1] < b[k]) {
                        int tt = b[k - 1];
                        b[k - 1] = b[k];
                        b[k] = tt;
                        t++;
                    }
                }
            }

            ans = Math.min(ans, t);
        }

        return ans;
    }


    private int solve3(int[] a, int n) {
        int mx = 0;
        for (int i = 0; i < n; i++) {
            if (a[mx] < a[i]) {
                mx = i;
            }
        }

        int[] b = Arrays.copyOf(a, a.length);

        HashSet<P> bb = new HashSet<P>();
        int d = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (b[j - 1] > b[j]) {
                    bb.add(new P(b[j - 1], b[j]));
                    int t = b[j - 1];
                    b[j - 1] = b[j];
                    b[j] = t;
                    d++;
                }
            }
        }

        int mxx = a[mx];

        while (true) {
            boolean pp = false;
            for (int j = 0; b[j] != mxx; j++) {
                int t = 0;
                for (int k = j + 1; ; k++) {
                    if (b[k] == mxx) {
                        for (; k < n && b[k] > b[j]; k++) {
                            t += bb.contains(new P(b[j], b[k])) ? -1 : 1;
                        }
                        break;
                    } else {
                        t += bb.contains(new P(b[j], b[k])) ? -1 : 1;
                    }
                }

                if (t < 0) {
                    d += t;
                    
                    for (int k = j + 1; ;k++) {
                        if (b[k] == mxx) {
                            int tt = b[k-1];
                            b[k-1] = b[k];
                            b[k] = tt;
                            k++;

                            for (; k < n && b[k] > b[k-1]; k++) {
                                tt = b[k-1];
                                b[k-1] = b[k];
                                b[k] = tt;
                                if (bb.contains(new P(b[k-1], b[k]))) bb.remove(new P(b[k-1], b[k]));
                            }
                            break;
                        } else {
                            int tt = b[k-1];
                            b[k-1] = b[k];
                            b[k] = tt;
                            if (bb.contains(new P(b[k-1], b[k]))) bb.remove(new P(b[k-1], b[k]));
                        }
                    }

                    pp = true;
                }

                if (b[j] == a[mx]) break;
            }
            if (!pp) break;
        }

        return d;
    }

    private static class P {
        int a;
        int b;

        private P(int a, int b) {
            if (a < b) {
                this.a = a;
                this.b = b;
            } else {
                this.a = b;
                this.b = a;
            }
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            P p = (P) o;

            if (a != p.a) return false;
            if (b != p.b) return false;

            return true;
        }

        @Override
        public int hashCode() {
            int result = a;
            result = 31 * result + b;
            return result;
        }
    }

    private boolean next_permutation(int[] p) {
        for (int a = p.length - 2; a >= 0; --a)
            if (p[a] < p[a + 1])
                for (int b = p.length - 1; ; --b)
                    if (p[b] > p[a]) {
                        int t = p[a];
                        p[a] = p[b];
                        p[b] = t;
                        for (++a, b = p.length - 1; a < b; ++a, --b) {
                            t = p[a];
                            p[a] = p[b];
                            p[b] = t;
                        }
                        return true;
                    }
        return false;
    }

    /*
     * Template classes
     * Author: Andrey Siunov
     * Date: 29.08.2013
     * Note: all classes are inner, because some testing servers do not run code with several classes
     */

    private static class SegmentTree {
        public static interface MergeFunction {
            int calcValue(int first, int second);
        }

        public static interface UpdateFunction {
            int calcValue(int value);
        }

        private MergeFunction mergeFunction;
        private int n;
        private int[] values;

        public SegmentTree(int[] collection, MergeFunction mergeFunction) {
            this.mergeFunction = mergeFunction;
            n = collection.length;
            values = new int[n * 4];
            build(collection, 1, 0, n - 1);
        }

        private void build(int[] collection, int v, int tl, int tr) {
            if (tl == tr) {
                values[v] = collection[tl];
            } else {
                int tm = (tl + tr) >> 1;
                build(collection, v << 1, tl, tm);
                build(collection, (v << 1) + 1, tm + 1, tr);
                values[v] = mergeFunction.calcValue(values[v << 1], values[(v << 1) + 1]);
            }
        }

        private UpdateFunction updateFunction;

        public void update(int pos, UpdateFunction updateFunction) {
            this.updateFunction = updateFunction;
            update(1, 0, n - 1, pos);
        }

        public void update(int v, int tl, int tr, int pos) {
            if (tl == tr) {
                values[v] = updateFunction.calcValue(values[v]);
            } else {
                int tm = (tl + tr) >> 1;
                if (pos <= tm) {
                    update(v << 1, tl, tm, pos);
                } else {
                    update((v << 1) + 1, tm + 1, tr, pos);
                }
                values[v] = mergeFunction.calcValue(values[v << 1], values[(v << 1) + 1]);
            }
        }

        public int getValue(int index) {
            return getValue(index, index);
        }

        public int getValue(int l, int r) {
            return getValue(1, 0, n - 1, l, r);
        }

        private Integer getValue(int v, int tl, int tr, int l, int r) {
            if (l > r) {
                return null;
            }
            if (l == tl && r == tr) {
                return values[v];
            }
            int tm = (tl + tr) >> 1;
            Integer leftValue = getValue(v << 1, tl, tm, l, Math.min(r, tm));
            Integer rightValue = getValue((v << 1) + 1, tm + 1, tr, Math.max(l, tm + 1), r);
            return leftValue == null ? rightValue :
                    (rightValue == null ? leftValue : mergeFunction.calcValue(leftValue, rightValue));
        }
    }


    private static class Pair<K, V> {
        private K key;
        private V value;

        Pair(K key, V value) {
            this.key = key;
            this.value = value;
        }

        K getKey() {
            return key;
        }

        V getValue() {
            return value;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            Pair pair = (Pair) o;

            return !(key != null ? !key.equals(pair.key) : pair.key != null) && !(value != null ? !value.equals(pair.value) : pair.value != null);
        }

        @Override
        public int hashCode() {
            int result = key != null ? key.hashCode() : 0;
            result = 31 * result + (value != null ? value.hashCode() : 0);
            return result;
        }

        @Override
        public String toString() {
            return "Pair{" +
                    "key=" + key +
                    ", value=" + value +
                    '}';
        }
    }

    private static class Timer {
        private long lastTime = 0;

        private Timer() {
            lastTime = System.currentTimeMillis();
        }

        public void reset() {
            lastTime = System.currentTimeMillis();
        }

        public long getMillisAndReset() {
            long current = System.currentTimeMillis();
            long result = current - lastTime;
            lastTime = current;
            return result;
        }
    }

    // IO template {
    private static class FileInputStream extends InputStream {
        private String inputFileName;

        public FileInputStream() throws IOException {
            this("input.txt");
        }

        public FileInputStream(String inputFileName) throws IOException {
            this.inputFileName = inputFileName;
        }

        @Override
        protected Reader getReader() throws IOException {
            return new FileReader(inputFileName);
        }
    }

    private static class ConsoleInputStream extends InputStream {
        @Override
        protected Reader getReader() throws IOException {
            return new InputStreamReader(System.in);
        }
    }

    private static abstract class InputStream {
        private static String DELIMITERS = " \t\n\r\f";
        private BufferedReader in;

        public InputStream open() throws IOException {
            in = new BufferedReader(getReader());
            return this;
        }

        private class Line {
            private Line(String inputLine) {
                this.inputLine = inputLine;
                stringTokenizer = new StringTokenizer(this.inputLine, DELIMITERS);
                readCharacters = 0;
            }

            private int readCharacters;
            private String inputLine = null;
            private StringTokenizer stringTokenizer = null;

            public String nextToken() {
                String result = stringTokenizer.nextToken();
                readCharacters += result.length();
                return result;
            }

            boolean hasNextToken() {
                return stringTokenizer.hasMoreTokens();
            }

            String getLineRest() {
                int position = 0;
                for (int remain = readCharacters; remain > 0; position++) {
                    if (DELIMITERS.indexOf(inputLine.charAt(position)) < 0) {
                        remain--;
                    }
                }
                return inputLine.substring(position);
            }
        }

        private Line currentLine = null;

        abstract protected Reader getReader() throws IOException;

        /**
         * Note: may be incorrect behavior if use this method with hasNextToken method
         */
        public String nextLine() throws IOException {
            setInputLine();
            if (currentLine == null) {
                return null;
            }
            String result = currentLine.getLineRest();
            currentLine = null;
            return result;
        }

        public boolean hasNextLine() throws IOException {
            setInputLine();
            return currentLine != null;
        }

        public String nextToken() throws IOException {
            return hasNextToken() ? currentLine.nextToken() : null;
        }

        /**
         * Note: may be incorrect behavior if use this method with nextLine method
         */
        public boolean hasNextToken() throws IOException {
            while (true) {
                setInputLine();
                if (currentLine == null || currentLine.hasNextToken()) {
                    break;
                } else {
                    currentLine = null;
                }
            }
            return currentLine != null;
        }

        public int nextInt() throws IOException {
            return Integer.valueOf(this.nextToken());
        }

        public long nextLong() throws IOException {
            return Long.valueOf(this.nextToken());
        }

        public double nextDouble() throws IOException {
            return Double.valueOf(this.nextToken());
        }

        public BigInteger nextBigInteger() throws IOException {
            return new BigInteger(this.nextToken());
        }


        public String[] nextTokensArray(int n) throws IOException {
            String[] result = new String[n];
            for (int i = 0; i < n; i++) {
                result[i] = this.nextToken();
            }
            return result;
        }

        public int[] nextIntArray(int n) throws IOException {
            int[] result = new int[n];
            for (int i = 0; i < n; i++) {
                result[i] = this.nextInt();
            }
            return result;
        }

        public long[] nextLongArray(int n) throws IOException {
            long[] result = new long[n];
            for (int i = 0; i < n; i++) {
                result[i] = this.nextLong();
            }
            return result;
        }

        public void close() throws IOException {
            currentLine = null;
            in.close();
        }

        private void setInputLine() throws IOException {
            if (currentLine == null) {
                String line = in.readLine();
                if (line != null) {
                    currentLine = new Line(line);
                }
            }
        }
    }

    private static class FileOutputStream extends OutputStream {
        private String outputFileName;

        public FileOutputStream() throws IOException {
            this("output.txt");
        }

        public FileOutputStream(String outputFileName) throws IOException {
            this.outputFileName = outputFileName;
        }

        @Override
        protected Writer getWriter() throws IOException {
            return new FileWriter(outputFileName);
        }
    }

    private static class ConsoleOutputStream extends OutputStream {
        @Override
        protected Writer getWriter() throws IOException {
            return new OutputStreamWriter(System.out);
        }
    }

    private static abstract class OutputStream {
        private PrintWriter out;

        public OutputStream open() throws IOException {
            out = new PrintWriter(getWriter());
            return this;
        }

        abstract protected Writer getWriter() throws IOException;

        public void print(Object... s) {
            for (Object token : s) {
                out.print(token);
            }
        }

        public void println(Object... s) {
            print(s);
            out.println();
        }

        public void println() {
            out.println();
        }

        public void flush() throws IOException {
            out.flush();
        }

        public void close() throws IOException {
            out.flush();
            out.close();
        }
    }
    // } IO template
}