package com.andrej.lv.one.b;

import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class MainClass {
	public static void main(String[] args) throws Exception {
		Path filePath = Paths.get(args[0]);
		MainClass cl = new MainClass();
		
		int lineNum = 0;
		List<String> lines = Files.readAllLines(filePath, Charset.defaultCharset());
		
		int testCaseCount = Integer.parseInt(lines.get(lineNum++));
		Set<String> out = new LinkedHashSet<>();
		
		for (int testCase = 1; testCase <= testCaseCount; testCase++) {
			int linesCount = Integer.parseInt(lines.get(lineNum++));
			List<Map<Character, Integer>> testLines = new ArrayList<>();
			
			for (int line = 1; line <= linesCount; line++) {
				String testLine = lines.get(lineNum++);
				Map<Character, Integer> charLengths = new LinkedHashMap<>();
				
				for (int charr = 0; charr < testLine.length(); charr++) {
					Character c = testLine.charAt(charr);
					
					if (charLengths.containsKey(c)) {
						charLengths.put(c, charLengths.get(c) + 1);
					}
					else {
						charLengths.put(c, 1);
					}
				}
				
				testLines.add(charLengths);
			}
			
			String s = "Case #" + testCase + ": " + cl.solve(testLines);
			out.add(s);
			System.out.println(s);
			
		}
		
		Files.write(filePath.resolveSibling("out.txt"), out, Charset.defaultCharset());
		
	}
	
	public String solve(List<Map<Character, Integer>> testLines) {
		if (testLines.size() <= 1) {
			return "0";
		}
		
		for (int i = 0; i < testLines.size(); i++) {
			int len = testLines.get(i).size();
			for (int j = 0; j < testLines.size(); j++) {
				int len2 = testLines.get(j).size();
				
				if (len != len2) {
					return "Fegla Won";
				}
				
				if (!testLines.get(i).keySet().equals(testLines.get(j).keySet())) {
					return "Fegla Won";
				}
			}
		}
		
		Integer minNums[] = new Integer[testLines.get(0).size()];
		minNums = testLines.get(0).values().toArray(minNums);
		
		//Get the minimum
		for (int i = 0; i < testLines.size(); i++) {
			Integer newMinNums[] = new Integer[testLines.get(i).size()];
			newMinNums = testLines.get(i).values().toArray(newMinNums);
			
			for (int l = 0; l < newMinNums.length; l++) {
				if (newMinNums[l] < minNums[l]) {
					minNums[l] = newMinNums[l];
				}
			}
		}
		
		int permutationCount = 0;
		
		for (int i = 0; i < testLines.size(); i++) {
			Integer counts[] = new Integer[testLines.get(i).size()];
			counts = testLines.get(i).values().toArray(counts);
			
			for (int l = 0; l < counts.length; l++) {
				if (minNums[l] != counts[l]) {
					permutationCount += 1;
				}
				//permutationCount += Math.abs(minNums[l] - counts[l]);
			}
		}
		
		return String.valueOf(permutationCount);
	}
}
