package com.andrej.google.part1.cookie;

import java.io.File;

import com.andrej.google.part1.cookie.ParamsExtractor.Params;
import com.andrej.google.part1.cookie.ParamsExtractor.TestCase;


public class MainClass {
	public static void main(String[] args) {
		File file = new File(args[0]);

		Params params = ParamsExtractor.extractFileData(file);
		MainClass m = new MainClass();
		int i = 1;
		for (TestCase t:params.testCases) {
			System.out.println(String.format("Case #%d: " + m.doIt(t), i++));
		}
	}
	
	public String doIt(TestCase t) {
		double rate = t.initialRate;
		double farmCost = t.farmCost;
		double rateIncrease = t.rateIncrease;
		double goal = t.goal;
		
		//Initial time needed to reach cookie goal
		double timeNeeded = calculateTimeForRate(rate, goal);
		double timeNeededWithNewRate = 0;
		
		double newRateAccumulatedTime = 0;
		
		while(true) {
			double timeNeededToBuyFarm = farmCost / rate;
			double newRate = rate + rateIncrease;
			
			timeNeededWithNewRate = calculateTimeForRate(newRate, goal);
			timeNeededWithNewRate += timeNeededToBuyFarm + newRateAccumulatedTime;
			
			if (timeNeededWithNewRate < timeNeeded) {
				rate = newRate;
				timeNeeded = timeNeededWithNewRate;
				newRateAccumulatedTime += timeNeededToBuyFarm;
			}
			else {
				break;
			}
		}
		
		return String.format("%.7f", timeNeeded);
	}

	private double calculateTimeForRate(double rate, double goal) {
		return goal / rate;
	}
	
}
