package com.andrej.google.part1;

import java.io.File;
import java.util.HashSet;
import java.util.Set;

import com.andrej.google.part1.ParamsExtractor.Params;
import com.andrej.google.part1.ParamsExtractor.TestCase;


public class MainClass {
	public static void main(String[] args) {
		File file = new File(args[0]);

		Params params = ParamsExtractor.extractFileData(file);
		MainClass m = new MainClass();
		int i = 1;
		for (TestCase t:params.testCases) {
			System.out.println(String.format("Case #%d: " + m.doIt(t), i++));
		}
	}
	
	public String doIt(TestCase t) {
		int[][] grid = t.grid;
		int[][] secondGrid = t.reversedGrid;
		
		int firstRow = t.firstAnsver;
		int secondRow = t.secondAnsver;
		
		Set<Integer> firstRowSet = new HashSet<>();
		Set<Integer> secondRowSet = new HashSet<>();
		
		for (int val:grid[firstRow]) {
			firstRowSet.add(val);
		}
		
		for (int val:secondGrid[secondRow]) {
			secondRowSet.add(val);
		}
		
		firstRowSet.retainAll(secondRowSet);

		if (firstRowSet.size() == 0) {
			return "Volunteer cheated!";
		}
		
		if (firstRowSet.size() == 1) {
			return firstRowSet.toArray()[0].toString();
		}
		else {
			return "Bad magician!";
		}
	}
	
}
