package qualification_16.pancakes;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;

public class Main {

	public static void main(String[] args) throws IOException {
		Path in = Paths.get("d:\\Andrej\\B-small-attempt1.in");
//		Path in = Paths.get("d:\\Andrej\\in.txt");
		try(
//				PrintWriter w = new PrintWriter(System.out);
				PrintWriter w = new PrintWriter("d:\\Andrej\\out.txt");
				Scanner s = new Scanner(Files.newInputStream(in))) {
			
			int sampleCount = Integer.valueOf(s.nextLine());
			
			for (int caseNum = 1; caseNum <= sampleCount; caseNum++) {
				String line = s.nextLine();
//				System.out.println(line);
				
				int numbersTried = 0;
				do {
					int badPancakeStart = line.indexOf("-");
					int goodPancakeStart = line.indexOf("+");
					
					if (line.chars().allMatch(c -> c == (int)'-')) {
						//Edge case. All are bad, need to flip just once
						++numbersTried;
						break;
					};
					
					if (line.chars().allMatch(c -> c == (int)'+')) {
						//Edge case. All are good, no need to flip
						break;
					};
					
					//If there is a bad pancake before good pancake,
					//Then flip all bad pancakes before good one
					if (badPancakeStart >= 0 && badPancakeStart < goodPancakeStart) {
						int flippingPosition = goodPancakeStart + 1;
						
						line = line.replace(line.substring(0, flippingPosition),"+");
					}
					//If there is a good pancake before bad one, then flip all good ones before
					//bad one
					else if (badPancakeStart >= 0 && badPancakeStart > goodPancakeStart) {
						int flippingPosition = badPancakeStart + 1;
						
						line = line.replace(line.substring(0, flippingPosition),"-");
					}
					//Else no bad pancakes found, return
					else {
						break;
					}
					++numbersTried;
//					System.out.println(line);
				}while(true);
				
				
				w.println(String.format("Case #%d: %d", caseNum, numbersTried));
				w.flush();
			}
		}
		
	}
}