package com.andrej.lv.one.b;

import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.LinkedHashSet;
import java.util.List;
import java.util.Set;

public class MainClass {
	public static void main(String[] args) throws Exception {
		Path filePath = Paths.get(args[0]);
		MainClass cl = new MainClass();
		
		int lineNum = 0;
		List<String> lines = Files.readAllLines(filePath, Charset.defaultCharset());
		
		int testCaseCount = Integer.parseInt(lines.get(lineNum++));
		Set<String> out = new LinkedHashSet<>();
		
		for (int testCase = 1; testCase <= testCaseCount; testCase++) {
			String line = lines.get(lineNum++);
			String[] nums = line.split(" ");
			
			int A = Integer.parseInt(nums[0]);
			int B = Integer.parseInt(nums[1]);
			int K = Integer.parseInt(nums[2]);
			
			String s = "Case #" + testCase + ": " + cl.solve(A, B, K);
			out.add(s);
			System.out.println(s);
			
		}
		
		Files.write(filePath.resolveSibling("out.txt"), out, Charset.defaultCharset());
		
	}
	
	public String solve(int A, int B, int K) {
		
		int total = 0;
		
		for(int a = 0; a < A; a++) {
			for(int b = 0; b < B; b++) {
				int and = a & b;
				if (isInK(and, K)) {
					//System.out.println("<" + a + "," + b + ">");
					++total;
				}
			}
		}
		//System.out.println("-------------------");
		
//		for(int b = 1; b < B; b++) {
//			for(int a = 1; a < A; a++) {
//				int and = b & a;
//				if (isInK(and, K)) {
//					++total;
//				}
//			}
//		}
		
		return String.valueOf(total);
	}
	
	public boolean isInK(int test, int K) {
		for (int k = 0; k < K; k++) {
			if (test == k) {
				return true;
			}
		}
		
		return false;
	}
}
