package com.andrej.google.part1.cookie;

import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;


public class ParamsExtractor {

	public static class TestCase {
		public final double farmCost;
		public final double rateIncrease;
		public final double goal;
		public final double initialRate = 2.0;
		
		TestCase(double farmCost, double rateIncrease, double goal) {
			this.farmCost = farmCost;
			this.rateIncrease = rateIncrease;
			this.goal = goal;
		}
	}

	public static class Params {

		public List<TestCase> testCases;
		public int numOfTestCases;

		public Params(int numOfTestCases) {
			this.numOfTestCases = numOfTestCases;
			testCases = new ArrayList<>(numOfTestCases);

		}

		public void addTestCase(TestCase t) {
			testCases.add(t);
		}
	}


	public static Params extractFileData(File file) {
		List<String> fileLines = null;
		try
		{
			fileLines = Files.readAllLines(file.toPath(), Charset.defaultCharset());
		} 
		catch (IOException e)
		{
			e.printStackTrace();
			System.exit(-1);
		}
		
		int i = 0;
		int numOfTestCases = Integer.parseInt(fileLines.get(i++));
		
		Params params = new Params(numOfTestCases);

		for (int testCase = 1; testCase <= numOfTestCases; testCase++) {
			String[] numberLine = fileLines.get(i++).split(" ");
			double farmCost = Double.parseDouble(numberLine[0]);
			double rateIncrease = Double.parseDouble(numberLine[1]);
			double goal = Double.parseDouble(numberLine[2]);
			
			TestCase tc = new TestCase(farmCost, rateIncrease, goal);
			params.addTestCase(tc);
		}

		return params;
	}
}
