/*
 * Copyright (c) 2011, Sabre Holdings. All Rights Reserved.
 */

package com.sabre.apd.formmodel.jam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintStream;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import java.util.StringTokenizer;

import com.google.common.collect.HashMultimap;
import com.google.common.collect.Multimap;
import com.google.common.collect.Multimaps;
import com.google.common.collect.TreeMultimap;
import org.apache.commons.lang.StringUtils;

public class B {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner sc = new Scanner(new File("b.in"));

        int n = sc.nextInt();

        PrintStream printStream = new PrintStream("b.out");
        for (int i = 0; i <  n; i++) {
//            System.out.println(i);
            int ilepas = sc.nextInt();

            List<String> pas = new ArrayList<String>();
            List<String> niepas = new ArrayList<String>();

            for (int j = 0; j < ilepas; j++) {
                pas.add(sc.next());
            }
//            System.out.println("pas: " + pas);

            int ileniepas = sc.nextInt();

            for (int j = 0; j < ileniepas; j++) {
                niepas.add(sc.next());
            }
//            System.out.println("niepas: " + niepas);

            sc.nextInt();
            Kolej kolej = solve(pas, niepas, sc.next());
            System.out.println("Case #" + (i + 1) + ": " + kolej.list);
            printStream.println("Case #" + (i + 1) + ": " + kolej.list);

        }
    }

    private static Kolej solve(List<String> pas, List<String> niepas, String ciag) {
//        System.out.println(ciag);
        Map<String, String> skrot = new HashMap<String, String>();
        Multimap<String, String> niepasy = HashMultimap.create();


        for (String pa : pas) {
//            System.out.println(pa);
            String key = pa.substring(0, 2);
            String value = pa.substring(2, 3);
            skrot.put(key, value);
            skrot.put(StringUtils.reverse(key), value);
//            System.out.println(key + " " + value);
        }

        for (String niepa : niepas) {
            String a = niepa.substring(0, 1);
            String b = niepa.substring(1, 2);
            niepasy.put(a, b);
            niepasy.put(b, a);
        }
//        System.out.println(niepasy);

        Kolej kolej = new Kolej();
        for (int i = 0; i < ciag.length(); i++) {
            String znak = ciag.substring(i, i + 1);
//            System.out.println(znak);
            if (kolej.isEmpty()) {
                kolej.add(znak);
            } else if (skrot.containsKey(kolej.last() + znak)) {
                String nowy = skrot.get(kolej.last() + znak);
                kolej.removeLast();
                kolej.add(nowy);
            } else if (!niepasy.get(znak).isEmpty() && kolej.containsAny(niepasy.get(znak))) {
                kolej.clear();
            } else {
                kolej.add(znak);
            }

        }
//        System.out.println(kolej.list);
        return kolej;
    }

    private static class Kolej {
        LinkedList<String> list = new LinkedList<String>();
        Map<String, Integer> counter = new HashMap<String, Integer>();

        public String last() {
            return list.getLast();
        }

        public void removeLast() {
            String last = list.getLast();
            Integer integer = counter.get(last);
            if (integer == null) {
                integer = 1;
            }
            counter.put(last, integer - 1);
            list.removeLast();
        }

        public void add(String nowy) {
            Integer integer = counter.get(nowy);
            if (integer == null) {
                integer = 0;
            }
            counter.put(nowy, integer + 1);
            list.add(nowy);
        }

        public boolean containsAny(Collection<String> strings) {
            for (String string : strings) {
                Integer integer = counter.get(string);
                if (integer != null && integer > 0) {
                    return true;
                }
//                if (list.contains(string)) {
//                    return true;
//                }
            }
            return false;
        }

        public void clear() {
            counter.clear();
            list.clear();
        }

        public boolean isEmpty() {
            return list.isEmpty();
        }
    }
}
