import java.util.*;

public class A {

	static class PriorityButton {
		int number;
		int priority;
		public PriorityButton(int number, int priority) {
			this.number = number;
			this.priority = priority;
		}
		@Override
		public String toString() {
			return "PrioButton {number=" + number + ", priority="
					+ priority + "}";
		}		
	}
	
	/**
	 * @author And
	 *
	 */
	static class Robot {
		int currentButton = 1;
		Queue<PriorityButton> nextButton;
		
		Robot(Queue<PriorityButton> nextButton) {
			this.nextButton = nextButton;
		}
		
		void nextStep(boolean canPush) {
			if (hasNextButton() && currentButton != nextButton.peek().number) {
				// move
				currentButton += (currentButton < nextButton.peek().number) ? 1 : -1;
			} else if (canPush) {
				// push
				nextButton.poll();
			}
		}
		
		boolean hasNextButton() {
			return !nextButton.isEmpty();
		}
		
		@Override
		public String toString() {
			return "Robot [currentButton=" + currentButton + ", nextButton=" + nextButton + "]";
		}
				
	}
	
	static List<Robot> getLeadFirst(Robot a, Robot b) {
		List<Robot> ab = new ArrayList<Robot>(Arrays.asList(a, b));
		List<Robot> ba = new ArrayList<Robot>(Arrays.asList(b, a));
		if (!a.hasNextButton() || !b.hasNextButton()) {
			return a.hasNextButton() ? ab : ba;
		}	
		return (a.nextButton.peek().priority <= b.nextButton.peek().priority) ? ab : ba;
	}	

	
	static int calculateMinimumSteps(Robot o, Robot b) {
		int step = 0;
		Robot lead, second;
		do {			
			List<Robot> leadFirst = getLeadFirst(o, b);
			lead = leadFirst.get(0);
			second = leadFirst.get(1);
			lead.nextStep(true);
			second.nextStep(false);
			step += 1;
//			System.err.println("step #" + step);
//			System.err.println(o);
//			System.err.println(b);
		} while (lead.hasNextButton() || second.hasNextButton());
		return step;
	}
	
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int test = scan.nextInt();
		for (int t = 1; t <= test; t++) {
			Queue<PriorityButton> orangeQueue = new LinkedList<PriorityButton>();			
			Queue<PriorityButton> blueQueue = new LinkedList<PriorityButton>();			
			int buttons = scan.nextInt();
			for (int b = 1; b <= buttons; b++) {
				if (scan.next().equals("O")) {
					orangeQueue.add(new PriorityButton(scan.nextInt(), b));
				} else {
					blueQueue.add(new PriorityButton(scan.nextInt(), b));
				}
			}
			Robot orangeRobot = new Robot(orangeQueue);
			Robot blueRobot = new Robot(blueQueue);
			int result = calculateMinimumSteps(orangeRobot, blueRobot);
			System.out.println("Case #" + t + ": " + result);
		}
		
	}
	
}
