import static org.junit.Assert.*;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

import org.junit.Test;

import spoj.SpojTest;


public class A {
	
	static double OOOWP(List<String> teams, int forTeam) {
		String currentTeam = teams.get(forTeam);
		
		int opps = teams.get(forTeam).replaceAll("\\.", "").length();
		double res = 0;
		for (int i = 0; i < teams.size(); i++) {
			if (i != forTeam && currentTeam.charAt(i) != '.') {
				res += OWP(teams, i);
			}
		}				
		return res / opps/*?*/;
	}
	
	static double OWP(List<String> teams, int forTeam) {
		int opps = teams.get(forTeam).replaceAll("\\.", "").length();
		
		String currentTeam = teams.get(forTeam);
		
		double OWP = 0;
		for (int i = 0; i < teams.size(); i++) {
			if (i != forTeam && currentTeam.charAt(i) != '.') {
				OWP += WP(teams.get(i), forTeam);
			}
		}				
		return OWP / opps/*?*/;
	}
	
	static double WP(String shed, int withoutWinIndex) {		
		StringBuilder buf = new StringBuilder(shed);
		if (withoutWinIndex >= 0) {
			buf.deleteCharAt(withoutWinIndex);
			shed = buf.toString();
		}
		double opps = shed.replaceAll("\\.", "").length();
		return shed.replaceAll("[^1]", "").length() / opps;
	}
	
	public static void main(String[] args) {
		//System.err.println(OOOWP(Arrays.asList(".11.", "0.00", "01.1", ".10."), 0));
		// System.err.println(OWP(Arrays.asList(".11.", "0.00", "01.1", ".10."), 3));
		
		/*System.out.println(WP(".11.", -1));
		System.out.println(WP("0.00", -1));
		System.out.println(WP("01.1", -1));
		System.out.println(WP(".10.", -1));
		*/
		Scanner scan = new Scanner(System.in);
		int test = scan.nextInt();
		for (int t = 1; t <= test; t++) {
			int teamCount = scan.nextInt();
			
			List<String> teamsInfo = new ArrayList<String>();
			
			for (int team = 0; team < teamCount; team++) {
				String shed = scan.next();
				teamsInfo.add(shed);
			}
			//System.err.println(teamsInfo);
			
			System.out.println("Case #" + t + ":");
			
			// RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP
			int currentTeam = 0;
			for (String teamShed : teamsInfo) {
				double RPI = 0.25 * WP(teamShed, -1) 
					+ 0.50 * OWP(teamsInfo, currentTeam) 
					+ 0.25 * OOOWP(teamsInfo, currentTeam);
				
				System.out.println(RPI);
				
				currentTeam += 1;
			}			
		}
	}

	@Test
	public void testname() throws Exception {
		String in = "2\n"+
		"3\n"+
		".10\n"+
		"0.1\n"+
		"10.\n"+
		"4\n"+
		".11.\n"+
		"0.00\n"+
		"01.1\n"+
		".10.";
		
		String out = "Case #1:\n"+
		"0.5\n"+
		"0.5\n"+
		"0.5\n"+
		"Case #2:\n"+
		"0.645833333333\n"+
		"0.368055555556\n"+
		"0.604166666667\n"+
		"0.395833333333";
		
		SpojTest.testProblem(getClass(), in, out);
	}
	
}
