import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;


public class FairWarning {
	
	private static BigInteger gcd_div(BigInteger a, BigInteger b) {
		BigInteger t;
		while (!b.equals(BigInteger.ZERO)) {
			t = b;
			b = a.remainder(b);
			a = t;
		}
		return a;
	}
	
	public static BigInteger solve(BigInteger... numbers) {
		int N = numbers.length;
		BigInteger a = numbers[0];
		BigInteger b = numbers[1];
		BigInteger c = null;
		if (N > 2) {
			c = numbers[2];
		}
		
		BigInteger T = a.subtract(b).abs();
		if (N > 2) {
			BigInteger d1 = a.subtract(c).abs();
			BigInteger d2 = b.subtract(c).abs();
			T = gcd_div(T, gcd_div(d1, d2));
		}
		
		Arrays.sort(numbers);
		BigInteger min = numbers[0];
		
		if (min.remainder(T).equals(BigInteger.ZERO)) {
			return BigInteger.ZERO;
		}
		
		return min.divide(T).add(BigInteger.ONE).multiply(T).subtract(min);
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		/*
		System.out.println(solve(new BigInteger("26000000"), new BigInteger("11000000"), new BigInteger("6000000")));
		System.out.println(solve(new BigInteger("1"), new BigInteger("10"), new BigInteger("11")));
		System.out.println(solve(new BigInteger("800000000000000000001"), new BigInteger("900000000000000000001")));
		*/
		
		Scanner scanner = new Scanner(System.in);
		int T = scanner.nextInt();
		scanner.nextLine();
		
		for (int i = 1; i <= T; i++) {
			final int N = scanner.nextInt();
			String[] arrayStr = scanner.nextLine().trim().split("\\s+");
			BigInteger[] intArray = new BigInteger[N];
			for (int j=0; j < N; j++) {
				intArray[j] = new BigInteger(arrayStr[j]);
			}
			BigInteger y = solve(intArray);
			System.out.println("Case #" + i + ": " + y);
		}
	}

}
