import java.util.Arrays;
import java.util.Scanner;


/**
 * 
 * @author Andrey Fursenko
 */
public class ThemePark {

	private static void reverse(int[] array, int start, int end) {
		int len = (start + end) >> 1; // div 2
		for (int i=start, k=1; i < len; i++, k++) {
			int tmp = array[i];
			array[i] = array[end - k];
			array[end - k] = tmp;
		}
	}
	
	private static void shift(int[] array, int step) {
		step = step % array.length;

		reverse(array, 0, step);
		reverse(array, step, array.length);
		reverse(array, 0, array.length);
	}
	
	
	public static long solve(int R, int k, int[] groups) {
		long euroSum = 0;
		int n = groups.length;
		for (int i = 0; i < R; i++) {
			int sum = 0;
			int j = 0;
			while (j < n && (sum + groups[j]) <= k) {
				sum += groups[j];
				j++;
			}
			
			euroSum += sum;
			shift(groups, j);
		}
		return euroSum;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		/*System.out.println("sum: " + solve(4, 6, new int[] {1, 4, 2, 1}));
		System.out.println("sum: " + solve(100, 10, new int[] {1}));
		System.out.println("sum: " + solve(5, 5, new int[] {2, 4, 2, 3, 4, 2, 1, 2, 1, 3}));
		System.out.println("sum: " + solve(8, 22, new int[] {10, 5, 1, 5, 7, 6, 7, 8, 9}));
		*/
		
		Scanner scanner = new Scanner(System.in);
		int T = scanner.nextInt();
		scanner.nextLine();
		
		for (int i = 1; i <= T; i++) {
			final int R = scanner.nextInt();
			final int k = scanner.nextInt();
			final int n = scanner.nextInt();
			scanner.nextLine();
			String[] arrayStr = scanner.nextLine().split("\\s+");
			if (arrayStr.length != n)
				throw new RuntimeException("ololo");
			int[] intArray = new int[n];
			for (int j=0; j < n; j++) {
				intArray[j] = Integer.parseInt(arrayStr[j]);
			}
			long sum = solve(R, k, intArray);
			System.out.println("Case #" + i + ": " + sum);
		}
	}

}
