
import java.util.*;

/**
 * 
 * @author And
 */
public class Magicka {

	private static Map<String, Character> createCombinedMap(List<String> combinations) {
		Map<String, Character> map = new HashMap<String, Character>();
		for (String comb : combinations) {
			map.put(comb.substring(0, 2), comb.charAt(2));
			map.put("" + comb.charAt(1) + comb.charAt(0), comb.charAt(2));
		}
		return map;
	}

	private static Map<Character, String> createOpposedMap(List<String> combinations) {
		Map<Character, String> map = new HashMap<Character, String>();
		for (String oppos : combinations) {
			Character opp1 = oppos.charAt(0);
			Character opp2 = oppos.charAt(1);
			String opp1List = map.get(opp1);
			if (opp1List == null)
				opp1List = "";
			map.put(opp1, opp1List + opp2);
			
			String opp2List = map.get(opp2);
			if (opp2List == null)
				opp2List = "";
			map.put(opp2, opp2List + opp1);
		}		
		return map;
	}
	
	
	private static boolean containsAnyOf(String src, List<Character> chars) {
		for (Character ch : chars) {
			if (src.indexOf(ch) != -1) {				
				return true;
			}
		}
		return false;
	}
	
	public static void main(String[] args) {		
		Scanner scan = new Scanner(System.in);
		int test = scan.nextInt();
		for (int t = 1; t <= test; t++) {
			List<String> buffer = new ArrayList<String>();
			
			int C = scan.nextInt();
			for (int i = 0; i < C; i++) {
				buffer.add(scan.next());
			}
			Map<String, Character> combinedMap = createCombinedMap(buffer);
						
			int D = scan.nextInt();
			buffer.clear();
			for (int i = 0; i < D; i++) {
				buffer.add(scan.next());
			}
			Map<Character, String> opposedMap = createOpposedMap(buffer);
			
			scan.nextInt(); // N
			String invokeElements = scan.next();
		
			// Solution
			List<Character> resultSeq = new LinkedList<Character>();
			for (Character element: invokeElements.toCharArray()) {
				if (resultSeq.isEmpty()) {
					resultSeq.add(element);
				} else if (combinedMap.containsKey("" + resultSeq.get(0) + element)) {					
					resultSeq.set(0, combinedMap.get("" + resultSeq.get(0) + element ));
				} else if (opposedMap.containsKey(element)
						&& containsAnyOf(opposedMap.get(element), resultSeq)) {
					resultSeq.clear();					
				} else {
					resultSeq.add(0, element);
				}
			}
			Collections.reverse(resultSeq);
			System.out.println("Case #" + t + ": " + resultSeq);
		}
	}

}
