package R1_2014;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.HashMap;

public class Mining {

	public static void main(String[] args) throws IOException {

		BufferedReader in = new BufferedReader(new FileReader("data.txt"));
		PrintStream out = new PrintStream(new File("output.txt"));

		HashMap<String,char[][]> map = new HashMap<String,char[][]>();

		String p = in.readLine().trim();

		while (p != null) {

			//System.out.println(p);
			String[] dims = p.split(" ");

			int R = Integer.parseInt(dims[0]);
			int C = Integer.parseInt(dims[1]);
			//int M = Integer.parseInt(dims[2]);

			String next = in.readLine().trim();

			if (next.equals("Impossible")) {
				map.put(p.trim(), new char[0][0]);
				p = in.readLine();
			}
			else {


				char[][] arena = new char[R][C];
				for (int x = 0; x < arena.length; x++) {
					for (int y = 0; y < arena[0].length; y++) {

						arena[x][y] = next.charAt(y);

					}

					next = in.readLine();
				}

				map.put(p.trim(), arena);

				p = next;

			}



		}

		//System.out.println(Arrays.deepToString(map.get("1 3 1")));
		in.close();

		in = new BufferedReader(new FileReader("mine.txt"));

		int N = Integer.parseInt(in.readLine());

		for (int i = 1; i <= N; i++) {

			p = in.readLine();

			String[] dims = p.split(" ");

			int R = Integer.parseInt(dims[0]);
			int C = Integer.parseInt(dims[1]);
			int M = Integer.parseInt(dims[2]);

			String input = "";

			if (R > C) {
				input = C+" "+R+" "+M;
			}
			else {
				input = R+" "+C+" "+M;
			}

			//System.out.println(input);
			if (M == 0) {
				out.println("Case #"+i+":");

				for (int x = 0; x < R; x++) {
					for (int y = 0; y < C; y++) {
						if (x == 0 && y == 0)
							out.print('c');
						else
							out.print('.');
					}
					out.println();
				}
				continue;
			}
			else {
			//	System.out.println(input);
				char[][] arena = map.get(input);

				if (arena.length == 0) {
					out.println("Case #"+i+":\nImpossible");
				}
				else {

					out.println("Case #"+i+":");

					if (R > C) {
						arena = rotateMatrix(arena);
					}

					for (int x = 0; x < arena.length; x++) {
						for (int y = 0; y < arena[0].length; y++) {
							out.print(arena[x][y]);
						}
						out.println();
					}



				}
			}
		}

		out.close();


	}

	public static char[][] rotateMatrix(char[][] matrix)
	{
		int h = matrix[0].length;
		int w = matrix.length;
		char[][] ret = new char[h][w];
		for (int i = 0; i < h; ++i) {
			for (int j = 0; j < w; ++j) {
				ret[i][j] = matrix[w - j - 1][i];
			}
		}

		return ret;
	}

}
