package R2;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;

public class Repeater {

	public static void main(String[] args) throws NumberFormatException, IOException {
		
		BufferedReader in = new BufferedReader(new FileReader("repeater.txt"));
		PrintStream out = new PrintStream(new File("sol.txt"));
		
		int N = Integer.parseInt(in.readLine());
		
		for (int x = 1; x <= N; x++) {
			
			int num = Integer.parseInt(in.readLine());
			
			String[] words = new String[num];
			
			for (int i = 0; i < words.length; i++) {
				words[i] = in.readLine();
			}
			
			int ans = solve(words);
			if (ans == -1)
				out.println("Case #"+x+": Fegla Won");
			else
				out.println("Case #"+x+": "+ans);
			
		}

	}
	
	public static int solve(String[] words) {
		
		Arrays.sort(words);
		
		if (words[0] == words[words.length-1]) return 0;
		
		//String[] parts = diffuse(words[0]);
		
		String[] first = diffuse(words[0]);
		
		int len = first.length;
		
		String[][] mat = new String[words.length][len];
		
		mat[0] = first;
		
		for (int i = 1; i < words.length; i++) {
			String[] temp = diffuse(words[i]);
			
			if (temp.length != len)
				return -1;
			
			for (int x = 0; x < temp.length; x++) {
				if (temp[x].charAt(0) != first[x].charAt(0))
					return -1;
			}
			
			mat[i] = temp;
			
		}
		
	//	System.out.println(Arrays.deepToString(mat));
		
		int[] avg = new int[len];
		
		for (int c = 0; c < mat[0].length; c++) {
			int min = mat[0][c].length();
			int max =  mat[0][c].length();
			for (int r = 0; r < mat.length; r++) {
				if (mat[r][c].length() > max)
					max = mat[r][c].length();
				if (mat[r][c].length() < min)
					min = mat[r][c].length();
			}
			avg[c] = (max+min)/2;
		}
		
		//System.out.println(Arrays.toString(avg));
		
		int changes = 0;
		
		for (int c = 0; c < mat[0].length; c++) {
		
			for (int r = 0; r < mat.length; r++) {
				changes += Math.abs(mat[r][c].length() - avg[c]);
			}
		}
		
		//System.out.println(changes);
		
		return changes;
		
		
	}
	
	public static String[] diffuse(String word) {
		
		ArrayList<String> parts = new ArrayList<String>();
		int last = 0;
		for (int i = 1; i < word.length(); i++) {
			if (word.charAt(i) != word.charAt(i-1)) {
				parts.add(word.substring(last,i));
				last = i;
			}
			
		}
		String end = word.substring(last);
		if (end.length() > 0)
			parts.add(end);
		
		String[] part = parts.toArray(new String[parts.size()]);
		return part;
		
	}

}
