

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public final class A {

    private static final String NEW_LINE = "\r\n";
    
    private static final String filein = "input.txt";
    private static final String fileout = "output.txt";
    
    private static final Comparator<Integer> majorToMinor = new Comparator<Integer>() {

        @Override
        public int compare(Integer o1, Integer o2) {
            return o2 - o1;
        }
        
    };

    private static final Comparator<Integer> minorToMajor = new Comparator<Integer>() {
        
        @Override
        public int compare(Integer o1, Integer o2) {
            return o1 - o2;
        }
        
    };
    
    public static void main(String[] args) {
        Scanner reader = null;
        BufferedWriter writer = null;
        try {
            reader = new Scanner(new File(filein));
            final File outFile = new File(fileout);
            if (!outFile.exists()) {
                outFile.createNewFile();
            }
            writer = new BufferedWriter(new FileWriter(outFile));

            final A a = new A();
            int n = reader.nextInt();
            for (int caseNum = 1; caseNum <= n; caseNum++) {
                int vecSize = reader.nextInt();
                final Integer[] vec1 = new Integer[vecSize];
                final Integer[] vec2 = new Integer[vecSize];
                // populate vec1
                for (int i = 0; i < vec1.length; i++) {
                    vec1[i] = reader.nextInt();
                }
                // populate vec2
                for (int i = 0; i < vec2.length; i++) {
                    vec2[i] = reader.nextInt();
                }
                
                
                int min = a.doResolve(vec1, vec2);
                
                writer.write(a.getFormatedCase(caseNum, min));
            }

            
        } catch (Exception e) {
            System.err.println(e);
        } finally {
            try {
                reader.close();
                writer.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }


    private int doResolve(Integer[] vec1, Integer[] vec2) {
        Arrays.sort(vec1, majorToMinor);
        Arrays.sort(vec2, minorToMajor);
        
        int min = Integer.MAX_VALUE;
        
        int result = 0;
        for (int i = 0; i < vec1.length; i++) {
            result += vec1[i] * vec2[i];
        }
        
        min = result;
        
        Arrays.sort(vec2, majorToMinor);
        Arrays.sort(vec1, minorToMajor);
        result = 0;
        for (int i = 0; i < vec1.length; i++) {
            result += vec1[i] * vec2[i];
        }
        
        if (min > result) {
            min = result;
        }
//        int min = Integer.MAX_VALUE;
//        
//        int size = vec1.length;
//        
//        // iterate 'size' times
//        for (int i = 0; i < size; i++) {
//            int result = 0;
//            for (int arrIdx = 0; arrIdx < size; arrIdx++) {
//                result += (vec1[arrIdx] * vec2[(arrIdx + i) % size]); 
//            }
//            
//            if (result < min) {
//                min = result;
//            }
//        }
//        
        return min;
    }


    public String getFormatedCase(int caseNum, int result) {
        StringBuilder sb = new StringBuilder();
        sb.append(String.format("Case #%d: %d" + NEW_LINE, caseNum, result));
        return sb.toString();
    }

}
