import java.io.File;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;


public class C {

    static Scanner in;
    static int R;
    static Set<Long> set = new HashSet<Long>(1000000);
    static long[] nextLongs = new long[2000000];
    
    public static void main(String[] args) throws Throwable {
        //in = new Scanner(System.in);
        //in = new Scanner(new File("C-test.in"));
        in = new Scanner(new File("C-small-attempt0.in"));
        //in = new Scanner(new File("C-large.in"));
        
        int C = readInt();
        int x1,x2,xmin,xmax,y1,y2,ymin,ymax;
        
        for (int caseno = 1; caseno <= C; caseno++) {
            System.out.printf("Case #%d: ", caseno);
            
            R = readInt();
            for (int i = 0; i < R; i++) {
                x1 = readInt()-1;
                y1 = readInt()-1;
                x2 = readInt()-1;
                y2 = readInt()-1;
                xmin = min(x1,x2);
                xmax = max(x1,x2);
                ymin = min(y1,y2);
                ymax = max(y1,y2);
                
                for (int x = xmin; x <= xmax; x++) {
                    for (int y = ymin; y <= ymax; y++) {
                        set.add(id(x,y));
                    }
                }
            }
            
            // read input
            
            System.out.println(solve());
        }
        
    }
    
    private static int min(int x1, int x2) {
        return Math.min(x1, x2);
    }

    private static int max(int x1, int x2) {
        return Math.max(x1, x2);
    }

    static int getX(long v) {
        return (int) (v/1000000);
    }
    
    static int getY(long v) {
        return (int) (v%1000000);
    }
    
    private static long id(long x, long y) {
        return (x*1000000) + y;
    }

    private static boolean exists(int x, int y) {
        return x>=0 && y>=0 && set.contains(id(x,y));
    }

    private static boolean mustBeCreated(int x, int y) {
        // se jah existe o (x,y), ele ja serah criado na iteracao dele
        return !exists(x,y) && exists(x-1,y) && exists(x,y-1);
    }
    
    private static int solve() {
        int seconds = 0;
        
        for (;;) {
            if (set.isEmpty()) break;
            seconds++;
            int numNextLongs = 0;
            
            for (long v : set) {
                int x = getX(v);
                int y = getY(v);
                if (exists(x-1, y) || exists(x, y-1)) {
                    nextLongs[numNextLongs++] = v;
                }
                if (mustBeCreated(x+1,y)) {
                    nextLongs[numNextLongs++] = id(x+1,y);
                }
                if (mustBeCreated(x,y+1)) {
                    nextLongs[numNextLongs++] = id(x,y+1);
                }
            }
            
            set.clear();
            for (int i = 0; i < numNextLongs; i++) {
                set.add(nextLongs[i]);
            }
        }
        
        return seconds;
    }
    
    static int readInt() {
        return in.nextInt();
    }

    static long readLong() {
        return in.nextLong();
    }
    
    static String readStr() {
        return in.next();
    }
    
}
