import java.io.File;
import java.util.Scanner;


public class A {

    static Scanner in;
    
    static int N, K;
    
    static char[][] MAT = new char[64][];
    static char[][] MAT_ROTTD = new char[64][64];
    static int[][] DP_HOR = new int[64][64];
    static int[][] DP_VERT = new int[64][64];
    static int[][] DP_DIAG_UP = new int[64][64];
    static int[][] DP_DIAG_DOWN = new int[64][64];
    
    static final String RED = "Red";
    static final String BLUE = "Blue";
    static final String BOTH = "Both";
    static final String NEITHER = "Neither";
    
    public static void main(String[] args) throws Throwable {
        //in = new Scanner(System.in);
//        in = new Scanner(new File("A-test.in"));
        //in = new Scanner(new File("A-test2.in"));
//        in = new Scanner(new File("A-small-attempt0.in"));
//        in = new Scanner(new File("A-small-attempt1.in"));
        in = new Scanner(new File("A-large.in"));
        
        int T = readInt();
        for (int caseno = 1; caseno <= T; caseno++) {
            System.out.printf("Case #%d: ", caseno);
            N = readInt();
            K = readInt();
            
            for (int i = 0; i < N; i++) {
                MAT[i] = readStr().toCharArray();
            }
            for (int i = 0; i < N; i++) {
                for (int j = 0; j < N; j++) {
                    MAT_ROTTD[j][N-i-1] = MAT[i][j];
                }
            }
            
            System.out.println(solve());
        }
        
    }
    
    private static String solve() {
        // apply gravity
        for (int j = N-1; j >= 0; j--) {
            int nxtEmpty = N-1;
            for (int i = N-1; i >= 0; i--) {
                if (MAT_ROTTD[i][j] != '.') {
                    MAT_ROTTD[nxtEmpty][j] = MAT_ROTTD[i][j];
                    nxtEmpty--;
                }
            }
            for (int i = 0; i <= nxtEmpty; i++) {
                MAT_ROTTD[i][j] = '.';
            }
        }
        
        //writeMatResult();
        
        boolean r = subseq('R');
        boolean b = subseq('B');
        
        if (r&&b) return BOTH;
        if (r) return RED;
        if (b) return BLUE;
        return NEITHER;//!r && !b
    }

    private static boolean subseq(char c) {
        for (int i = 1; i <= N; i++) {
            for (int j = 1; j <= N; j++) {
                if (MAT_ROTTD[i-1][j-1] == c) {
                    DP_HOR[i][j] = DP_HOR[i][j-1] + 1;
                    if (DP_HOR[i][j] >= K) return true;
                    
                    DP_VERT[i][j] = DP_VERT[i-1][j] + 1;
                    if (DP_VERT[i][j] >= K) return true;
                    
                    DP_DIAG_DOWN[i][j] = DP_DIAG_DOWN[i-1][j-1] + 1;
                    if (DP_DIAG_DOWN[i][j] >= K) return true;

                    DP_DIAG_UP[i][j] = DP_DIAG_UP[i-1][j+1] + 1;
                    if (DP_DIAG_UP[i][j] >= K) return true;
                } else {
                    DP_DIAG_DOWN[i][j] = DP_DIAG_UP[i][j] = DP_HOR[i][j] = DP_VERT[i][j] = 0;
                }
            }
        }
        
        return false;
    }

    private static void writeMatResult() {
        System.out.println();
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                System.out.print(MAT_ROTTD[i][j]);
            }
            System.out.println();
        }

    }

    static int readInt() {
        return in.nextInt();
    }

    static long readLong() {
        return in.nextLong();
    }
    
    static String readStr() {
        return in.next();
    }
    
}
