import java.io.FileInputStream;
import java.io.InputStream;


public class Watersheds {

    static InputStream in;
    
    static byte[] buffer;
    static int pos;
    static int max;

    static boolean painted = false;
    
    static int[][] M;
    static char[][] labels;
    static int H, W;
    
    public static void main(String[] args) throws Throwable {
        //in = System.in;
        in = new FileInputStream("B-large.in");
        buffer = new byte[8192];
        
        int MH = 100;
        int MW = 100;
        M = new int[MH][MW];
        labels = new char[MH][MW];
        
        int T = readInt();
        for (int scenario = 1; scenario <= T; scenario++) {
            H = readInt();
            W = readInt();
            if (H > MH || W > MW) {
                MH = Math.max(H, MH);
                MW = Math.max(W, MW);
                M = new int[MH][MW];
                labels = new char[MH][MW];
            }
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W; j++) {
                    M[i][j] = readInt();
                    labels[i][j] = 0;
                }
            }
            char c = 'a';
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W; j++) {
                    painted = false;
                    paint(i, j, c);
                    if (painted)
                        c++;// proximo char
                }
            }
            System.out.print("Case #");
            System.out.print(scenario);
            System.out.println(":");
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W-1; j++) {
                    System.out.print(labels[i][j]);
                    System.out.print(" ");
                }
                System.out.print(labels[i][W-1]);
                System.out.println();
            }
        }
        
    }
    
    private static void paint(int i, int j, char c) {
        if (labels[i][j] > 0) return;
        labels[i][j] = c;
        painted = true;
        boolean firstH = i==(0);
        boolean lastH = i==(H-1);
        boolean firstW = j==(0);
        boolean lastW = j==(W-1);
        
        int[] fall;
        fall = getFall(i, j);
        if (fall != null) paint(fall[0], fall[1], c);
        if (!firstH) {
            if (fallsIn(i-1, j, i, j)) {
                paint(i-1, j, c);
            }
        }
        if (!firstW) {
            if (fallsIn(i, j-1, i, j)) {
                paint(i, j-1, c);
            }
        }
        if (!lastW) {
            if (fallsIn(i, j+1, i, j)) {
                paint(i, j+1, c);
            }
        }
        if (!lastH) {
            if (fallsIn(i+1, j, i, j)) {
                paint(i+1, j, c);
            }
        }
    }

    private static boolean fallsIn(int ifrom, int jfrom, int ito, int jto) {
        int[] fall = getFall(ifrom, jfrom);
        return (fall != null) && (fall[0] == ito && fall[1] == jto);
    }

    // retorna null se nao 'fall' em ningm
    static int[] getFall(int i, int j) {
        boolean firstH = i==(0);
        boolean lastH = i==(H-1);
        boolean firstW = j==(0);
        boolean lastW = j==(W-1);
        
        int v=M[i][j], h=i, w=j;
        if (!firstH) {
            if (M[i-1][j] < v) {
                v = M[i-1][j];
                h = i-1;
                w = j;
            }
        }
        if (!firstW) {
            if (M[i][j-1] < v) {
                v = M[i][j-1];
                h = i;
                w = j-1;
            }
        }
        if (!lastW) {
            if (M[i][j+1] < v) {
                v = M[i][j+1];
                h = i;
                w = j+1;
            }
        }
        if (!lastH) {
            if (M[i+1][j] < v) {
                v = M[i+1][j];
                h = i+1;
                w = j;
            }
        }
        if (h==i && w==j) return null;
        return new int[] { h, w };
    }
    
    static boolean isNum(int v) {
        return v >= '0' && v <= '9';
    }
    
    static boolean isMinus(int cur) {
        return cur == '-';
    }
    
    static int readInt() throws Throwable {
        int cur;
        while (!isNum(cur = read()) && !isMinus(cur)) if (cur==-1)return-1;
        int v = 0;
        boolean minus = false;
        if (isMinus(cur)) {
            minus=true;
            cur = read();
        }
        while (isNum(cur)) {
            v *= 10;
            v += (cur - '0');
            cur = read();
        }
        return minus ? -v : v;
    }
    
    
    static int read() throws Throwable {
        if (pos >= max) {
            max = in.read(buffer);
            if (max<0) return -1;
            pos = 0;
        }
        return buffer[pos++] & 0xff;
    }
    
}
