import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashSet;

public final class SavingTheUniverse {

    private static final File filein = new File("input.txt");
    private static final File fileout = new File("output.txt");

    public static void main(String[] args) {
        BufferedReader reader = null;
        BufferedWriter writer = null;

        try {
            if (!fileout.exists()) {
                fileout.createNewFile();
            }
            reader = new BufferedReader(new InputStreamReader(new FileInputStream(filein)));
            writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(fileout)));

            int cases = getInt(reader);

            final HashSet<String> allEngines = new HashSet<String>(100);
            final HashSet<String> usedEngines = new HashSet<String>(100);

            for (int caseNum = 1; caseNum <= cases; caseNum++) {
                allEngines.clear();
                usedEngines.clear();

                final int engines = getInt(reader);
                for (int j = 0; j < engines; j++) {
                    allEngines.add(reader.readLine());
                }
                int switches = 0;
                final int queries = getInt(reader);
                String engine;
                for (int i = 0; i < queries; i++) {
                    engine = reader.readLine();
                    if (!usedEngines.contains(engine)) {
                        if ((usedEngines.size() + 1) == engines) {
                            switches++;
                            usedEngines.clear();
                        }
                        usedEngines.add(engine);
                    }
                }

                writer.write(String.format("Case #%d: %d\r\n", caseNum, switches));
            }
        } catch (Exception e) {
            throw new RuntimeException(e);
        } finally {
            try {
                reader.close();
                writer.close();
            } catch (IOException e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }
    }

    private static int getInt(BufferedReader reader) {
        try {
            return Integer.parseInt(reader.readLine());
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

}
