package com.google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Scanner;
import java.util.Set;

import com.google.common.collect.Sets;

public class CountingSheep {

    static Set<Character> digitsFound = Sets.newHashSet();

    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
    	long startTime = System.currentTimeMillis();
        Scanner scan = new Scanner(new File("input.txt"));
        PrintWriter output = new PrintWriter("output.txt", "UTF-8");

        int numInputs = scan.nextInt();
        for (int i = 0; i < numInputs; i++) {
            int input = scan.nextInt();
            if (input == 0) {
                output.println("Case #" + (i + 1) + ": INSOMNIA");
            } else {
                output.println("Case #" + (i + 1) + ": " + countSheep(input, 1));
            }
        }
        output.close();
        scan.close();
        System.out.println(System.currentTimeMillis() - startTime);
    }

    private static long countSheep(long input, long multiplier) {
    	long currentCount = input * multiplier;
        String digits = currentCount + "";
        for (char ch : digits.toCharArray()) {
        	digitsFound.add(ch);
        }
        if (digitsFound.size() == 10) {
        	digitsFound = Sets.newHashSet();
            return currentCount;
        }
        return countSheep(input, multiplier + 1);
    }
}
