package com.google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Scanner;

public class RevengeOfThePancakes {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        long startTime = System.currentTimeMillis();
        Scanner scan = new Scanner(new File("input.txt"));
        PrintWriter output = new PrintWriter("output.txt", "UTF-8");

        int numInputs = scan.nextInt();
        scan.nextLine();
        for (int i = 0; i < numInputs; i++) {
            char[] input = scan.nextLine().toCharArray();
            System.out.println(input);
            output.println("Case #" + (i + 1) + ": " + makeHappy(input));
        }
        output.close();
        scan.close();
        System.out.println(System.currentTimeMillis() - startTime);
    }

    private static int makeHappy(char[] stack) {
        char previousTop = '-';
        int flipCount = 0;
        boolean setTop = false;
        boolean topIsHappy = false;
        for (char ch : stack) {
            if (!setTop) {
                topIsHappy = (ch == '+');
                previousTop = ch;
                setTop = true;
            }
            if (ch != previousTop) {
                previousTop = ch;
                flipCount++;
                topIsHappy = !topIsHappy;
            }
        }
        if (!topIsHappy) {
            return flipCount + 1;
        } else {
            return flipCount;
        }
    }
}
