import java.util.*;
import java.io.*;

public class TicTacToeTomek {
    final static String PROBLEM_NAME = "tttt";
    final static String WORK_DIR = "/home/adp4/GCJ/" + PROBLEM_NAME + "/";


    char [][] board = new char[4][4];
    int moves;

    static void preprocess()
    {

    }

    boolean checkWinner(char player)
    {
        //check row
        for(int row = 0; row<4; row++)
        {
            if(     (board[row][0] == player || board[row][0] == 'T' ) &&
                    (board[row][1] == player || board[row][1] == 'T' ) &&
                    (board[row][2] == player || board[row][2] == 'T' ) &&
                    (board[row][3] == player || board[row][3] == 'T' ) )
            {
                return true;
            }
        }

        //check col
        for(int col = 0; col<4; col++)
        {
            if(     (board[0][col] == player || board[0][col] == 'T' ) &&
                    (board[1][col] == player || board[1][col] == 'T' ) &&
                    (board[2][col] == player || board[2][col] == 'T' ) &&
                    (board[3][col] == player || board[3][col] == 'T' ) )
            {
                return true;
            }
        }

        //check diagonal
        if(     (board[0][0] == player || board[0][0] == 'T' ) &&
                (board[1][1] == player || board[1][1] == 'T' ) &&
                (board[2][2] == player || board[2][2] == 'T' ) &&
                (board[3][3] == player || board[3][3] == 'T' ) )
        {
            return true;
        }
        if(     (board[3][0] == player || board[3][0] == 'T' ) &&
                (board[2][1] == player || board[2][1] == 'T' ) &&
                (board[1][2] == player || board[1][2] == 'T' ) &&
                (board[0][3] == player || board[0][3] == 'T' ) )
        {
            return true;
        }

        return false;
    }

    void solve(Scanner sc, PrintWriter pw) {
        String s;
        int row, col;
        moves = 0;
        for (row = 0; row<4; row++)
        {
            s = sc.nextLine();
            for(col = 0; col<4; col++)
            {
                board[row][col] = s.charAt(col);
                //System.out.println("row:"+row+" col:"+col+" char:"+s.charAt(col));
                if(s.charAt(col) != '.')
                {
                    moves++;
                }
            }
        }
        s = sc.nextLine();
        System.out.println("Total moves: "+moves);

        if(checkWinner('X'))
        {
            pw.print("X won");
        }
        else if(checkWinner('O'))
        {
            pw.print("O won");
        }
        else if(moves == 16)
        {
            pw.print("Draw");
        }
        else
        {
            pw.print("Game has not completed");
        }
        pw.println();
    }

    public static void main(String[] args) throws Exception {
        preprocess();

        String infile;
        String outfile;

        if(args.length<2)
        {
            System.out.println("Defaulting to input.txt and output.txt");
            infile = "input.txt";
            outfile = "output.txt";
        }
        else
        {
            System.out.println("Input = "+args[0]);
            System.out.println("Output = "+args[1]);
            infile = args[0];
            outfile = args[1];
        }

        Scanner sc = new Scanner(new FileReader(WORK_DIR + infile));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + outfile));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new TicTacToeTomek().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}