import java.util.*;
import java.io.*;

public class Lawnmower {
    final static String PROBLEM_NAME = "Lawnmower";
    final static String WORK_DIR = "/home/adp4/GCJ/" + PROBLEM_NAME + "/";


    static void preprocess()
    {

    }

    void solve(Scanner sc, PrintWriter pw) {
        int rows = sc.nextInt();
        int cols = sc.nextInt();
        int row, col;
        int [][] lawn = new int[rows][cols];
        for (row = 0; row<rows; row++)
        {
            for(col = 0; col<cols; col++)
            {
                lawn[row][col] = sc.nextInt();
                //System.out.println("row:"+row+" col:"+col+" lawn:"+lawn[row][col]);
            }
        }

        //the maximum height of each row
        int [] minMowSettingRows = new int[rows];
        //the maximum height of each col
        int [] minMowSettingCols = new int[cols];

        int testSetting;
        for(row = 0; row<rows; row++)
        {
            testSetting = 0;
            for(col = 0; col<cols; col++)
            {
                if(lawn[row][col]>testSetting)
                {
                    testSetting = lawn[row][col];
                }
            }
            minMowSettingRows[row] = testSetting;
            System.out.println("Maximum height of row:"+row+" = "+minMowSettingRows[row]);
        }

        for(col = 0; col<cols; col++)
        {
            testSetting = 0;
            for(row = 0; row<rows; row++)
            {
                if(lawn[row][col]>testSetting)
                {
                    testSetting = lawn[row][col];
                }
            }
            minMowSettingCols[col] = testSetting;
            System.out.println("Maximum height of col:"+col+" = "+minMowSettingCols[col]);
        }

        for (row = 0; row<rows; row++)
        {
            for(col = 0; col<cols; col++)
            {
                if( lawn[row][col] < minMowSettingRows[row] && lawn[row][col] < minMowSettingCols[col])
                {
                    pw.print("NO");
                    pw.println();
                    System.out.println("row:"+row+" col:"+col+" lawn:"+lawn[row][col]+ " is less than " +
                            "minimum mow setting for the row ("+ minMowSettingRows[row]+") and " +
                            "minimum mow setting for the col ("+ minMowSettingCols[col]+")");
                    return;
                }
            }
        }
        pw.print("YES");
        pw.println();
    }

    public static void main(String[] args) throws Exception {
        preprocess();

        String infile;
        String outfile;

        if(args.length<2)
        {
            System.out.println("Defaulting to input.txt and output.txt");
            infile = "input.txt";
            outfile = "output.txt";
        }
        else
        {
            System.out.println("Input = "+args[0]);
            System.out.println("Output = "+args[1]);
            infile = args[0];
            outfile = args[1];
        }

        Scanner sc = new Scanner(new FileReader(WORK_DIR + infile));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + outfile));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new Lawnmower().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}