import java.io.File;
import java.io.PrintWriter;
import java.util.*;

public class ProblemC {

    private class Pair {
        public String first;
        public String second;
        public Pair(String first, String second) {
            this.first = first;
            this.second = second;
        }
    }

    private void solve(PrintWriter pw, Scanner sc, int N) {

        int solved = 0;
        List<Pair> topics = new ArrayList<>();
        int[] result = new int[N];
        Arrays.fill(result, -1);
        Map<String, Integer> firstTopics = new HashMap<>();
        Map<String, Integer> secondTopics = new HashMap<>();


        for (int k=0; k<N; k++) {
            String first = sc.next();
            String second = sc.next();
            topics.add(new Pair(first, second));
            mapAdd(firstTopics, first);
            mapAdd(secondTopics, second);
        }

        Set<String> firstUsed = new HashSet<>();
        Set<String> secondUsed = new HashSet<>();


        // find all real
        for (int k=0; k<N; k++) {
            Pair topic = topics.get(k);
            if (firstTopics.get(topic.first).equals(1) || secondTopics.get(topic.second).equals(1)) {
                result[k] = 1;
                solved++;
                firstUsed.add(topic.first);
                secondUsed.add(topic.second);
            }
        }

        int fake =0;
        /*
        while(solved<N) {
            for (int k=0; k<N; k++) {
                if (result[k] == -1 ) {
                    Pair topic = topics.get(k);
                    if (firstUsed.contains(topic.first) && secondUsed.contains(topic.second)) {
                        result[k] = 0;
                        fake++;
                        solved++;
                        firstUsed.add(topic.first);
                        secondUsed.add(topic.second);
                        decrementMap(firstTopics, topic.first);
                        decrementMap(secondTopics, topic.second);
                    }
                }
            }
        }
*/
        Set<Pair> input = new HashSet<>();
        for (int k = 0; k<N; k++) {
            if (result[k] == -1) {
                input.add(topics.get(k));
            }
        }

        fake += calculateFakes(firstUsed, secondUsed, input);



        pw.print(fake);
        pw.println();
    }


    private int calculateFakes(Set<String> firstWords, Set<String> secondWords, Set<Pair> input) {
        int fakes = 0;
        int real = 0;
        Set<Pair> legit = new HashSet<>();
        Set<Pair> unknown = new HashSet<>();
        for (Pair p: input) {
            if (firstWords.contains(p.first) && secondWords.contains(p.second)) {
                fakes++;
            } else if (firstWords.contains(p.first) && secondWords.contains(p.second)) {
                real++;
                legit.add(p);
            } else {
                unknown.add(p);
            }
        }

        if (fakes + real == input.size()) {
            return fakes;
        }

        for (Pair p : legit) {
            firstWords.add(p.first);
            secondWords.add(p.second);
        }

        fakes = unknown.size();
        for (Pair p : unknown) {
            // assume p is legit
            Set<String> firstWordsCopy = new HashSet<>(firstWords);
            firstWordsCopy.add(p.first);
            Set<String> secondWordsCopy = new HashSet<>(secondWords);
            secondWordsCopy.add(p.second);
            Set<Pair> unknownCopy = new HashSet<>(unknown);
            unknownCopy.remove(p);
            int testFakes = calculateFakes(firstWordsCopy, secondWordsCopy, unknownCopy);
            if (testFakes == 1) {
                return 1;
            }
            if (testFakes<fakes) {
                fakes = testFakes;
            }
        }
        return fakes;
    }

    private void mapAdd(Map<String, Integer> theMap, String key) {
        if (theMap.containsKey(key)) {
            int current = theMap.get(key);
            theMap.put(key, current+1);
        }
        else {
            theMap.put(key, 1);
        }
    }

    private void decrementMap(Map<String, Integer> theMap, String key) {
        int current = theMap.get(key);
        theMap.put(key, current - 1);
    }

    private void run() throws Exception {
        String name = "C-small-attempt1";
        String path = "";

        Locale.setDefault(Locale.US);

        Scanner sc = new Scanner(new File(path + name + ".in"));
        PrintWriter pw = new PrintWriter(path + name + ".out");
//		Scanner sc = new Scanner(System.in);
//		PrintWriter pw = new PrintWriter(System.out);

        int testCases = sc.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            int N = sc.nextInt();
            pw.print("Case #" + testCase + ": ");
            solve(pw, sc, N);
            pw.flush();
        }

        pw.close();
        sc.close();
    }

    public static void main(String[] args) throws Exception {
        new ProblemC().run();
    }
}