import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class ProblemA {

    private void solve(PrintWriter pw, String line) {
        char[] input = line.toCharArray();

        int[] source = new int[65536];
        Arrays.fill(source, 0);

        for (int k=0; k<input.length; k++) {
            char letter = input[k];
            source[letter]++;
        }

        int[] result = new int[10];

        result[0] = source['Z'];
        decrement(source, 'Z', result[0]);
        decrement(source, 'E', result[0]);
        decrement(source, 'R', result[0]);
        decrement(source, 'O', result[0]);

        result[6] = source['X'];
        decrement(source, 'S', result[6]);
        decrement(source, 'I', result[6]);
        decrement(source, 'X', result[6]);


        result[2] = source['W'];
        decrement(source, 'T', result[2]);
        decrement(source, 'W', result[2]);
        decrement(source, 'O', result[2]);

        result[8] = source['G'];
        decrement(source, 'E', result[8]);
        decrement(source, 'I', result[8]);
        decrement(source, 'G', result[8]);
        decrement(source, 'H', result[8]);
        decrement(source, 'T', result[8]);

        result[3] = source['H'];
        decrement(source, 'T', result[3]);
        decrement(source, 'H', result[3]);
        decrement(source, 'R', result[3]);
        decrement(source, 'E', result[3]);
        decrement(source, 'E', result[3]);

        result[4] = source['U'];
        decrement(source, 'F', result[4]);
        decrement(source, 'O', result[4]);
        decrement(source, 'U', result[4]);
        decrement(source, 'R', result[4]);

        result[1] = source['O'];
        decrement(source, 'O', result[1]);
        decrement(source, 'N', result[1]);
        decrement(source, 'E', result[1]);

        result[7] = source['S'];
        decrement(source, 'S', result[7]);
        decrement(source, 'E', result[7]);
        decrement(source, 'V', result[7]);
        decrement(source, 'E', result[7]);
        decrement(source, 'N', result[7]);

        result[5] = source['V'];
        decrement(source, 'F', result[5]);
        decrement(source, 'I', result[5]);
        decrement(source, 'V', result[5]);
        decrement(source, 'E', result[5]);

        result[9] = source['E'];

        int counter;
        for (int k = 0; k<10; k++) {
            for(counter=0; counter<result[k]; counter++) {
                pw.print(k);
            }
        }
        pw.println();
    }

    private void decrement(int[] source, char letter, int count) {
        source[letter] = source[letter] - count;
    }

    private void run() throws Exception {
        String name = "A-large";
        String path = "";

        Locale.setDefault(Locale.US);

        Scanner sc = new Scanner(new File(path + name + ".in"));
        PrintWriter pw = new PrintWriter(path + name + ".out");
//		Scanner sc = new Scanner(System.in);
//		PrintWriter pw = new PrintWriter(System.out);

        int testCases = sc.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            String testData = sc.next();
            pw.print("Case #" + testCase + ": ");
            solve(pw, testData);
            pw.flush();
        }

        pw.close();
        sc.close();
    }

    public static void main(String[] args) throws Exception {
        new ProblemA().run();
    }
}