import java.util.*;
import java.io.*;

public class Osmos {
    final static String PROBLEM_NAME = "Osmos";
    final static String WORK_DIR = "/home/adp4/GCJ/" + PROBLEM_NAME + "/";


    static void preprocess()
    {

    }

    int solveSubset(int moves, List<Integer> values, long mySize, int curIndex, int N)
    {
        if(N == curIndex)
        {
            return moves;
        }
        if(mySize>values.get(curIndex))
        {
            return solveSubset(moves, values, mySize+values.get(curIndex), curIndex+1, N);

        }
        if(mySize == 1)
        {
            return solveSubset(moves+1, values, mySize, curIndex, N-1);
        }

        return Math.min(solveSubset(moves+1, values, 2*mySize -1, curIndex, N),
                        solveSubset(moves+1, values, mySize, curIndex, N-1));
    }


    void solve(Scanner sc, PrintWriter pw) {
        long mySize = sc.nextLong();
        int N = sc.nextInt();

        long result = 0;
        System.out.println("mySize: "+mySize+"; N:"+N);

        List<Integer> values = new ArrayList<Integer>(N);

        int k;
        for(k = 0 ; k<N ; k++)
        {
            values.add(k,sc.nextInt());
        }

        Collections.sort(values);
     /*
        for (k=0; k<N ; k++)
        {
            if(values.get(k)<mySize)
            {
                mySize = mySize + values.get(k);
            }
            else if(values.get(k) < 2*mySize - 1)
            {
                mySize = 2*mySize - 1 + values.get(k);
                result++;
            }
            else
            {
                result++;
            }
        }
       */
        pw.print(solveSubset(0, values, mySize, 0, N));
        pw.println();
    }

    public static void main(String[] args) throws Exception {
        preprocess();

        String infile;
        String outfile;

        if(args.length<2)
        {
            System.out.println("Defaulting to input.txt and output.txt");
            infile = "input.txt";
            outfile = "output.txt";
        }
        else
        {
            System.out.println("Input = "+args[0]);
            System.out.println("Output = "+args[1]);
            infile = args[0];
            outfile = args[1];
        }

        Scanner sc = new Scanner(new FileReader(WORK_DIR + infile));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + outfile));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new Osmos().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}