import java.lang.String;
import java.util.*;
import java.io.*;

public class War {
    final static String PROBLEM_NAME = "War";
    final static String WORK_DIR = "/home/adp4/GCJ/" + PROBLEM_NAME + "/";


    static void preprocess()
    {

    }

    int traditional(SortedSet<Double> naomi, SortedSet<Double> ken)
    {

        SortedSet<Double> tempSet = new TreeSet<Double>(ken);

        int wins = 0;
        for (Double current : naomi)
        {
            SortedSet<Double> kensWinners = tempSet.tailSet(current);

            if (kensWinners.size() == 0)
            {
                wins++;
                tempSet.remove(tempSet.first());
            }
            else
            {
                tempSet.remove(kensWinners.first());
            }
        }
        return wins;
    }

    int deceitful(SortedSet<Double> naomi, SortedSet<Double> ken)
    {
        SortedSet<Double> kenT = new TreeSet<Double>(ken);

        int wins = 0;
        for (Double current : naomi)
        {
            if (current < kenT.first())
            {
                kenT.remove(kenT.last());
            }
            else
            {
                kenT.remove(kenT.first());
                wins++;

            }
        }
        return wins;
    }




    void solve(Scanner sc, PrintWriter pw) {
        SortedSet<Double> naomi = new TreeSet<Double>();
        SortedSet<Double> ken = new TreeSet<Double>();

        int numBlocks = sc.nextInt();
        for (int k = 0; k < numBlocks; k++)
        {
            naomi.add(sc.nextDouble());
        }

        for (int k = 0; k < numBlocks; k++)
        {
            ken.add(sc.nextDouble());
        }

        pw.print(deceitful(naomi, ken) + " " + traditional(naomi, ken));
        pw.println();
    }

    public static void main(String[] args) throws Exception {
        preprocess();

        String infile;
        String outfile;

        if(args.length<2)
        {
            System.out.println("Defaulting to input.txt and output.txt");
            infile = "input.txt";
            outfile = "output.txt";
        }
        else
        {
            System.out.println("Input = "+args[0]);
            System.out.println("Output = "+args[1]);
            infile = args[0];
            outfile = args[1];
        }

        Scanner sc = new Scanner(new FileReader(WORK_DIR + infile));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + outfile));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new War().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}