import java.lang.Integer;
import java.lang.String;
import java.util.*;
import java.io.*;
import java.util.Set;
import java.util.TreeSet;

public class MagicTrick {
    final static String PROBLEM_NAME = "MagicTrick";
    final static String WORK_DIR = "/home/adp4/GCJ/" + PROBLEM_NAME + "/";


    static void preprocess()
    {

    }

    String overlapResults(Set<Integer> firstRow, Set<Integer> secondRow)
    {
        Set<Integer> intersection = new TreeSet<Integer>();
        for (Integer item : firstRow)
        {
            if (secondRow.contains(item))
            {
                intersection.add(item);
            }
        }
        if (intersection.size() == 0)
        {
            return "Volunteer cheated!";
        }
        if (intersection.size() == 1)
        {
            return intersection.iterator().next().toString();
        }
        return "Bad magician!";
    }


    void solve(Scanner sc, PrintWriter pw) {
        String s;
        int index;
        int row;

        index = Integer.valueOf(sc.nextInt());
        sc.nextLine();

        Set<Integer> firstRow = new TreeSet();
        Set<Integer> secondRow = new TreeSet();

        for (row = 1; row<5; row++)
        {
            if (row == index)
            {
                firstRow.add(sc.nextInt());
                firstRow.add(sc.nextInt());
                firstRow.add(sc.nextInt());
                firstRow.add(sc.nextInt());
                sc.nextLine();
            }
            else
            {
                sc.nextInt();
                sc.nextInt();
                sc.nextInt();
                sc.nextInt();
                sc.nextLine();
            }
        }

        index = Integer.valueOf(sc.nextLine());

        for (row = 1; row<5; row++)
        {
            if (row == index)
            {
                secondRow.add(sc.nextInt());
                secondRow.add(sc.nextInt());
                secondRow.add(sc.nextInt());
                secondRow.add(sc.nextInt());
            }
            else
            {
                sc.nextInt();
                sc.nextInt();
                sc.nextInt();
                sc.nextInt();
            }
        }

        pw.print(overlapResults(firstRow, secondRow));
        pw.println();
    }

    public static void main(String[] args) throws Exception {
        preprocess();

        String infile;
        String outfile;

        if(args.length<2)
        {
            System.out.println("Defaulting to input.txt and output.txt");
            infile = "input.txt";
            outfile = "output.txt";
        }
        else
        {
            System.out.println("Input = "+args[0]);
            System.out.println("Output = "+args[1]);
            infile = args[0];
            outfile = args[1];
        }

        Scanner sc = new Scanner(new FileReader(WORK_DIR + infile));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + outfile));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new MagicTrick().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}