import java.io.File;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.*;

public class OversizedPancake {


    private void solve(PrintWriter pw, String line, int K) {
        pw.print(" ");

        boolean[] stack = new boolean[line.length()];
        char[] asArray = line.toCharArray();
        for (int k = 0; k < line.length(); k++) {
            if (asArray[k] == '-') {
                stack[k] = false;
            } else {
                stack[k] = true;
            }
        }

        int numberOfFlips = 0;
        for (int k = 0; k < line.length() - K + 1; k++) {
            if (!stack[k]) {
                flip(stack, k, K);
                numberOfFlips++;
            }
        }

        if (test(stack, K)) {
            pw.println(numberOfFlips);
        } else {
            pw.println("IMPOSSIBLE");
        }
    }

    private boolean test(boolean[] stack, int K) {
        for (int k = 0; k < K; k++) {
            if (!stack[stack.length - k - 1]) {
                return false;
            }
        }
        return true;
    }

    private void flip(boolean[] stack, int start, int K) {
        for (int k = 0; k < K; k++) {
            stack[start + k] = !stack[start + k];
        }
    }

    private void run() throws Exception {
        String name = "A-small-attempt0";
        String path = "";

        Locale.setDefault(Locale.US);

        Scanner sc = new Scanner(new File(path + name + ".in"));
        PrintWriter pw = new PrintWriter(path + name + ".out");
//		Scanner sc = new Scanner(System.in);
//		PrintWriter pw = new PrintWriter(System.out);

        int testCases = sc.nextInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            String line = sc.next();
            int K = sc.nextInt();
            pw.print("Case #" + testCase + ":");
            solve(pw, line, K);
            pw.flush();
        }

        pw.close();
        sc.close();
    }

    public static void main(String[] args) throws Exception {
        new OversizedPancake().run();
    }
}