import java.lang.Integer;
import java.lang.String;
import java.util.*;
import java.io.*;
import java.util.Set;
import java.util.TreeSet;

public class Cookie {
    final static String PROBLEM_NAME = "Cookie";
    final static String WORK_DIR = "/home/adp4/GCJ/" + PROBLEM_NAME + "/";


    static void preprocess()
    {

    }

    double totalTime (double C, double F, double X)
    {
        if (C>=X)
        {
            return X/2;
        }

        double factorC = 0.0;
        double rate = 2.0;
        int numBuys = 0;
        double t0 = X/2.0;
        double timeToBeat = Double.MAX_VALUE;

        for (int k = 0; k<500000; k++)
        {
            numBuys++;
            factorC += 1/(2 + (numBuys-1)*F);
            rate += F;
            double time = C*factorC + (X/rate);
            if (time < timeToBeat)
            {
                timeToBeat = time;
            }

            if (time>(X+C))
            {
                break;
            }
        }
        return Math.min(timeToBeat, t0);
    }


    void solve(Scanner sc, PrintWriter pw) {
        double C = sc.nextDouble();
        double F = sc.nextDouble();
        double X = sc.nextDouble();

        pw.print(totalTime(C,F,X));
        pw.println();
    }

    public static void main(String[] args) throws Exception {
        preprocess();

        String infile;
        String outfile;

        if(args.length<2)
        {
            System.out.println("Defaulting to input.txt and output.txt");
            infile = "input.txt";
            outfile = "output.txt";
        }
        else
        {
            System.out.println("Input = "+args[0]);
            System.out.println("Output = "+args[1]);
            infile = args[0];
            outfile = args[1];
        }

        Scanner sc = new Scanner(new FileReader(WORK_DIR + infile));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + outfile));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new Cookie().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}