import java.util.*;
import java.io.*;

public class FairSquare {
    final static String PROBLEM_NAME = "FairSquare";
    final static String WORK_DIR = "/home/adp4/GCJ/" + PROBLEM_NAME + "/";


    static void preprocess()
    {

    }

    public final static long isPerfectSquare(long n)
    {
        if (n < 0)
            return -1;

        long test = (long)(Math.sqrt(n) + 0.5);
        if(test*test == n)
        {
            return test;
        }
        return -1;
    }

    boolean isPalindrone(String toTest)
    {
        for(int k=0; k<toTest.length()/2; k++)
        {
            if(toTest.charAt(k) != toTest.charAt(toTest.length()-1-k))
            {
                return false;
            }
        }

        return true;
    }

    void solve(Scanner sc, PrintWriter pw) {
        long firstNum = sc.nextLong();
        long lastNum = sc.nextLong();

        long winners = 0;

        for(long k = firstNum; k<lastNum+1; k++)
        {
            long sqrt = isPerfectSquare(k);

            if(sqrt != -1)
            {
                if(isPalindrone(Long.toString(sqrt)))
                {
                        if(isPalindrone(Long.toString(k)))
                        {
                            System.out.println("k: "+k+" and sqrt:"+sqrt+" are palindrones");
                            winners++;
                        }
                }
            }
        }

        pw.print(winners);
        pw.println();
    }

    public static void main(String[] args) throws Exception {
        preprocess();

        String infile;
        String outfile;

        if(args.length<2)
        {
            System.out.println("Defaulting to input.txt and output.txt");
            infile = "input.txt";
            outfile = "output.txt";
        }
        else
        {
            System.out.println("Input = "+args[0]);
            System.out.println("Output = "+args[1]);
            infile = args[0];
            outfile = args[1];
        }

        Scanner sc = new Scanner(new FileReader(WORK_DIR + infile));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + outfile));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new FairSquare().solve(sc, pw);
        }
        pw.flush();
        pw.close();
        sc.close();
    }
}