import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class CLarge
{
    public static void main(String ... args) throws Exception
    {
        Scanner input = new Scanner(new File("/Users/andy/Downloads/C-large.in"));
        int numCases = input.nextInt();
        for (int i = 0; i < numCases; i++)
        {
            int N = input.nextInt();
            int J = input.nextInt();
            
            System.out.printf("Case #%d:\n", i + 1);
            
            int currentAmount = 0;
           
            //Max amount of different Strings we can achieve with the value of N
            double max = Math.pow(2,(N-2));
            for (int x = 0; x < max; x++) {
            	if(currentAmount == J) break;
            	String word = getWord(x, N-2);
            	//System.out.println("trying "+word);
				if(isJamCoin(word)){
					System.out.println(word+" "+getDivisorString(word));
					currentAmount++;
				}
			}
        }
        input.close();
    }

	private static String getWord(int value, int places) {
		String word = Integer.toString(value, 2);
		for (int i = word.length(); i < places; i++) {
			word = "0"+word;
		}
		return "1"+word+"1";
	}

	private static String getDivisorString(String jc) {
		String ret = "";
		for (int i = 2; i < 11; i++) {
			ret += getFirstDivisor(new BigInteger(jc, i))+" ";
		}
		return ret.substring(0, ret.length()-1);
	}

	private static BigInteger getFirstDivisor(BigInteger n) {
		if (n!=BigInteger.valueOf(2) && n.mod(BigInteger.valueOf(2))==BigInteger.ZERO) return BigInteger.valueOf(2);
		for(BigInteger i = BigInteger.valueOf(3);
		    	i.pow(i.intValue()).compareTo(n) <= 0;
		    	i = i.add(BigInteger.valueOf(2))) {
		        if(n != i && n.mod(i)==BigInteger.ZERO)
		        	return i;
		}
		return BigInteger.ZERO;
	}

	private static boolean isJamCoin(String jc) {
		//System.out.println("Is Jam coin "+jc);
		for (int i = 2; i < 11; i++) {
			//System.out.println("base "+i);
			BigInteger val = new BigInteger(jc, i);
			if(isPrime(val))
				return false;
		}
		return true;
	}

	private static boolean isPrime(BigInteger n) {
		//System.out.println("isPrime "+n);
		//check if n is a multiple of 2
	    if (n!=BigInteger.valueOf(2) && n.mod(BigInteger.valueOf(2))==BigInteger.ZERO) return false;
	    //if not, then just check the odds until the square root
	    for(BigInteger i = BigInteger.valueOf(3);
	    	i.pow(i.intValue()).compareTo(n) <= 0;
	    	i = i.add(BigInteger.valueOf(2))) {
	        if(n != i && n.mod(i)==BigInteger.ZERO)
	            return false;
	    }
	    return true;
	}
	
}