import java.io.*;
import java.util.*;

class F
{
	public static void main(String[] args) throws Exception
	{
		Scanner in = new Scanner(System.in);
		int nData = in.nextInt();
		in.nextLine();
		
		for (int asdf = 0; asdf < nData; asdf++)
		{
			//read in input
			int numBarbers = in.nextInt();
			int place = in.nextInt();
			int[] times = new int[numBarbers];
			
			//read in the barbers' times
			for (int i = 0; i < numBarbers; i++)
			{
				times[i] = in.nextInt();
			}
			
			//solve the problem
			int[] temp = times.clone();
			Arrays.sort(temp);
			int smallest = temp[0];
			
			long cutsused = 0;
			long timeused = 0;
			int currentPlace = 1;
			boolean optimized = false;
			
			//skip a bunch of barber cuts
			if (place - numBarbers > 0)
			{
				double cutsPerShortest = 1;
				
				for (int i = 1; i < temp.length; i++)
				{
					cutsPerShortest += smallest / (double)temp[i];
				}
				
				cutsused = (long)((place - (numBarbers + 1)) / cutsPerShortest);	//num shortest cuts used
				timeused = (long)cutsused * smallest;
//				System.out.println("cutspershortest=" + cutsPerShortest + " cutsused=" + cutsused + " timeused=" + timeused);
				
				for (int i = 0; i < numBarbers; i++)
				{
					currentPlace += (timeused / times[i]) + 1;
//					System.out.println("adding " + (timeused / times[i] + 1) + " cuts for barber " + i);
				}
				
				optimized = true;
//				System.out.println("optimizing by skipping to cut " + currentPlace + " at time " + timeused);
			}
			
			//simulate stuff
			PriorityQueue<Barber> queue = new PriorityQueue<Barber>();
			
			//add all the barbers to the queue - stop if we get to my barber
			for (int i = 0; (i < numBarbers) && ((optimized) || (currentPlace < place)); i++)
			{
//				Barber b = new Barber(i, times[i], times[i]);
				long target = ((timeused / times[i]) + 1) * times[i];
				Barber b = new Barber(i, times[i], target);
				queue.offer(b);
				
				if (!optimized)
				{
					currentPlace++;
				}
//				System.out.println("adding barber");
			}
			
//			System.out.println("currentplace=" + currentPlace);
//			System.out.println("queue=" + queue);
			
			//simulate the action
			while (currentPlace < place)
			{
				//pull out all barbers who finish now
				long now = queue.peek().doneTime;
				PriorityQueue<Barber> available = new PriorityQueue<Barber>();
				
				while ((queue.size() > 0) && (queue.peek().doneTime == now))
				{
					available.offer(queue.poll());
				}
				
				//use the barbers available
				while ((currentPlace < place) && (available.size() > 0))
				{
					Barber b = available.poll();
					b.doneTime += b.time;
					queue.offer(b);
					currentPlace++;
				}
				
				if (available.size() > 0)
				{
					queue.offer(available.poll());	//make the next available barber mine
				}
			}
			
			int answer = queue.poll().num + 1;
			
			System.out.println("Case #" + (asdf+1) + ": " + answer);
//			System.out.println("\n");
		}
	}
}

class Barber implements Comparable<Barber>
{
	int num = -1;
	int time = -1;
	long doneTime = -1;
	
	public Barber(int n, int t, long d)
	{
		num = n;
		time = t;
		doneTime = d;
	}
	
	public int compareTo(Barber other)
	{
		if (other.doneTime - doneTime > 0)
		{
			return -1;
		}
		else if (other.doneTime - doneTime < 0)
		{
			return 1;
		}
		else
		{
			//if same doneTime, make lower num first
			if (other.num - num > 0)
			{
				return -1;
			}
			else if (other.num - num < 0)
			{
				return 1;
			}
		}
		return 0;
	}
	
	public String toString()
	{
		return "" + num;
	}
}




