package round1b.problema;

import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.sql.Timestamp;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ProblemA {
    public static void main(String[] args) throws IOException {
        String inputFileName = "2016//round1b//problema//A-small-attempt0.in";
        String outputFileName = "2016//round1b//problema//output";

        List<String> inputValues = new ArrayList<String>();
        Files.lines(Paths.get(inputFileName)).skip(1).forEach(s -> inputValues.add(s));

        StringBuilder sb = new StringBuilder();

        for (int j = 0; j < inputValues.size(); j++) {
            sb.append("Case #" + (j + 1) + ": ");
            String scrambledWord = inputValues.get(j);

            Map<String, Integer> numLetters = new HashMap<String, Integer>();
            char[] scrambledLetters = scrambledWord.toCharArray();

            for (char c : scrambledLetters) {
                if (numLetters.containsKey(String.valueOf(c))) {
                    int numOccurrences = numLetters.get(String.valueOf(c));
                    numLetters.put(String.valueOf(c), numOccurrences + 1);
                } else {
                    numLetters.put(String.valueOf(c), 1);
                }
            }

            // Zero
            if (numLetters.containsKey("Z")) {
                int numZerosToRemove = numLetters.get("Z");

                for (int i = 0; i < numZerosToRemove; i++) {
                    int numOccurrences = numLetters.get("Z");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("Z", numOccurrences);
                    } else {
                        numLetters.remove("Z");
                    }

                    numOccurrences = numLetters.get("E");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("E", numOccurrences);
                    } else {
                        numLetters.remove("E");
                    }

                    numOccurrences = numLetters.get("R");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("R", numOccurrences);
                    } else {
                        numLetters.remove("R");
                    }

                    numOccurrences = numLetters.get("O");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("O", numOccurrences);
                    } else {
                        numLetters.remove("O");
                    }

                    sb.append("0");
                }
            }

            // Two
            StringBuilder twos = new StringBuilder();
            if (numLetters.containsKey("W")) {
                int numTwosToRemove = numLetters.get("W");

                for (int i = 0; i < numTwosToRemove; i++) {
                    int numOccurrences = numLetters.get("T");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("T", numOccurrences);
                    } else {
                        numLetters.remove("T");
                    }

                    numOccurrences = numLetters.get("W");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("W", numOccurrences);
                    } else {
                        numLetters.remove("W");
                    }

                    numOccurrences = numLetters.get("O");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("O", numOccurrences);
                    } else {
                        numLetters.remove("O");
                    }

                    twos.append("2");
                }
            }

            // Four
            StringBuilder fours = new StringBuilder();
            if (numLetters.containsKey("U")) {
                int numOnesToRemove = numLetters.get("U");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("U");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("U", numOccurrences);
                    } else {
                        numLetters.remove("U");
                    }

                    numOccurrences = numLetters.get("F");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("F", numOccurrences);
                    } else {
                        numLetters.remove("F");
                    }

                    numOccurrences = numLetters.get("O");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("O", numOccurrences);
                    } else {
                        numLetters.remove("O");
                    }

                    numOccurrences = numLetters.get("R");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("R", numOccurrences);
                    } else {
                        numLetters.remove("R");
                    }

                    fours.append("4");
                }
            }

            // One
            StringBuilder ones = new StringBuilder();
            if (numLetters.containsKey("O")) {
                int numOnesToRemove = numLetters.get("O");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("O");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("O", numOccurrences);
                    } else {
                        numLetters.remove("O");
                    }

                    numOccurrences = numLetters.get("N");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("N", numOccurrences);
                    } else {
                        numLetters.remove("N");
                    }

                    numOccurrences = numLetters.get("E");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("E", numOccurrences);
                    } else {
                        numLetters.remove("E");
                    }

                    ones.append("1");
                }
            }

            // Six
            StringBuilder sixes = new StringBuilder();
            if (numLetters.containsKey("X")) {
                int numOnesToRemove = numLetters.get("X");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("X");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("X", numOccurrences);
                    } else {
                        numLetters.remove("X");
                    }

                    numOccurrences = numLetters.get("S");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("S", numOccurrences);
                    } else {
                        numLetters.remove("S");
                    }

                    numOccurrences = numLetters.get("I");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("I", numOccurrences);
                    } else {
                        numLetters.remove("I");
                    }

                    sixes.append("6");
                }
            }

            // Eight
            StringBuilder eights = new StringBuilder();
            if (numLetters.containsKey("G")) {
                int numOnesToRemove = numLetters.get("G");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("G");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("G", numOccurrences);
                    } else {
                        numLetters.remove("G");
                    }

                    numOccurrences = numLetters.get("E");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("E", numOccurrences);
                    } else {
                        numLetters.remove("E");
                    }

                    numOccurrences = numLetters.get("I");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("I", numOccurrences);
                    } else {
                        numLetters.remove("I");
                    }

                    numOccurrences = numLetters.get("H");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("H", numOccurrences);
                    } else {
                        numLetters.remove("H");
                    }

                    numOccurrences = numLetters.get("T");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("T", numOccurrences);
                    } else {
                        numLetters.remove("T");
                    }

                    eights.append("8");
                }

            }

            // Three
            StringBuilder threes = new StringBuilder();
            if (numLetters.containsKey("T")) {
                int numOnesToRemove = numLetters.get("T");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("T");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("T", numOccurrences);
                    } else {
                        numLetters.remove("T");
                    }

                    numOccurrences = numLetters.get("H");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("H", numOccurrences);
                    } else {
                        numLetters.remove("H");
                    }

                    numOccurrences = numLetters.get("R");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("R", numOccurrences);
                    } else {
                        numLetters.remove("R");
                    }

                    numOccurrences = numLetters.get("E");
                    numOccurrences = numOccurrences - 2;

                    if (numOccurrences != 0) {
                        numLetters.put("E", numOccurrences);
                    } else {
                        numLetters.remove("E");
                    }

                    threes.append("3");
                }
            }

            // Fives
            StringBuilder fives = new StringBuilder();
            if (numLetters.containsKey("F")) {
                int numOnesToRemove = numLetters.get("F");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("V");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("V", numOccurrences);
                    } else {
                        numLetters.remove("V");
                    }

                    numOccurrences = numLetters.get("I");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("I", numOccurrences);
                    } else {
                        numLetters.remove("I");
                    }

                    numOccurrences = numLetters.get("F");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("F", numOccurrences);
                    } else {
                        numLetters.remove("F");
                    }

                    numOccurrences = numLetters.get("E");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("E", numOccurrences);
                    } else {
                        numLetters.remove("E");
                    }

                    fives.append("5");
                }
            }

            // Sevens
            StringBuilder sevens = new StringBuilder();
            if (numLetters.containsKey("V")) {
                int numOnesToRemove = numLetters.get("V");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("V");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("V", numOccurrences);
                    } else {
                        numLetters.remove("V");
                    }

                    numOccurrences = numLetters.get("S");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("S", numOccurrences);
                    } else {
                        numLetters.remove("S");
                    }

                    numOccurrences = numLetters.get("N");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("N", numOccurrences);
                    } else {
                        numLetters.remove("N");
                    }

                    numOccurrences = numLetters.get("E");
                    numOccurrences = numOccurrences - 2;

                    if (numOccurrences != 0) {
                        numLetters.put("E", numOccurrences);
                    } else {
                        numLetters.remove("E");
                    }

                    sevens.append("7");
                }
            }

            // Sevens
            StringBuilder nines = new StringBuilder();
            if (numLetters.containsKey("I")) {
                int numOnesToRemove = numLetters.get("I");

                for (int i = 0; i < numOnesToRemove; i++) {
                    int numOccurrences = numLetters.get("I");
                    numOccurrences = numOccurrences - 2;

                    if (numOccurrences != 0) {
                        numLetters.put("N", numOccurrences);
                    } else {
                        numLetters.remove("N");
                    }

                    numOccurrences = numLetters.get("I");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("I", numOccurrences);
                    } else {
                        numLetters.remove("I");
                    }

                    numOccurrences = numLetters.get("E");
                    numOccurrences--;

                    if (numOccurrences != 0) {
                        numLetters.put("E", numOccurrences);
                    } else {
                        numLetters.remove("E");
                    }

                    nines.append("9");
                }
            }

            sb.append(ones.toString());
            sb.append(twos.toString());
            sb.append(threes.toString());
            sb.append(fours.toString());
            sb.append(fives.toString());
            sb.append(sixes.toString());
            sb.append(sevens.toString());
            sb.append(eights.toString());
            sb.append(nines.toString());
            sb.append("\n");
        }

        Date date = new Date();
        Timestamp ts = new Timestamp(date.getTime());
        String time = new SimpleDateFormat("YYYY-MM-dd HH-mm-ss").format(ts);
        Path path = Paths.get(outputFileName + "-" + time);

        try (BufferedWriter writer = Files.newBufferedWriter(path)) {
            writer.write(sb.toString());
        }
    }
}
