//Google Code Jam 2016 Warmup 1 - Permutations
//Take 2 vectors, switch any 2 coordinates, get the smallest resultant vector

import java.io.*;
import java.util.*;

public class JamCoin {
  
  public static long checkPrime(long toCheck)
  {
    for(long i = 2; i < (long) Math.round(Math.sqrt(toCheck)); i++)
    {
      if(toCheck % i == 0)
        return i;
    }
    return -1;
  }
   
  public static void main(String[] args)
  {
    //Typical try-catch stuff. 
     try
     {
       //IO Elements
       BufferedReader in = new BufferedReader(new FileReader("in.txt"));
       PrintWriter out = new PrintWriter(new File("out.txt"));
       
       //Data Stuffs
       String[] input;
       long numInputs;
       
       in.readLine();
       input = in.readLine().split(" ");
       long length = Long.parseLong(input[0]);
       long toGenerate = Long.parseLong(input[1]);
       long generated = 0;
       
       //Max  base-10 value of the jamcoin is 2^length, since the jamcoin is always in base-2
       long maxValue = (long) Math.pow(2, length);
       long minValue = (long) Math.pow(2, length-1);
       out.println("Case #1:");
       for(long i = minValue; i < maxValue; i++)
       {
         if(generated == toGenerate)
           break;
         boolean working = true;
         long[] outputs = new long[9];
         String coinStyle = (Long.toBinaryString(i));
         if(coinStyle.charAt(coinStyle.length()-1) != '1')
           continue;
         for(int x = 2; x < 11; x++)
         {
           outputs[x-2] = checkPrime(Long.valueOf(coinStyle, x));
           if(outputs[x-2] == -1)
           {
             working = false;
             break;
           }
         }
         if(working)
         {
           out.print(coinStyle);
           for(int x = 0; x < 9; x++)
             out.print(" " + outputs[x]);
           out.println();
           generated++;
         }
       }
       
       
       out.close();
       
     }
     catch(IOException e)
     {
       System.out.println("IOEXCEPTION");
       System.out.println(e.getMessage());
     }
  }
}