package qualificationRound;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.lang.reflect.Array;
import java.util.ArrayDeque;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

public class DeceitfulWar {
	static Scanner scanner;
	static int t; //number of tests
	static int n; //number of blocks 
	static float[] naomi, ken, nao, k;
	
	public static void main(String[] args){
		String filename = "src/qualificationRound/D-large.in";
		try {
			FileReader reader = new FileReader(filename); 
			scanner = new Scanner(reader);
			//scanner = new Scanner(System.in);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		t = Integer.parseInt(scanner.nextLine());
		String message;
		
		for(int i = 1; i<= t; i++){
			n = scanner.nextInt();
			naomi = new float[n];
			ken = new float[n];
			nao = new float[n];
			k = new float[n];
			
			for (int j = 0; j < n; j++){
				naomi[j] = scanner.nextFloat();
			}
			
			for (int j = 0; j < n; j++){
				ken[j] = scanner.nextFloat();
			}
			
			sortDes();
			
			int result = deceive();
			message = "Case #"; //initialize message
			message += i + ": ";
			
			message += result;
			
			result = war();
			message += " " + result;
			
			System.out.println(message);
		} 
		scanner.close();
	}
	
	private static int war(){
		int numberOfWins = 0;
		
		int k_cur = 0;
		
		for (int i = 0; i < n; i++){
			if (nao[i] > k[k_cur]){
				numberOfWins++;
			} else {
				k_cur++;
			}
		}
		
		return numberOfWins;
	}
	
	private static void sortDes(){
		Arrays.sort(naomi);
		Arrays.sort(ken);	
		
		for (int i = 0; i < n; i++){
			nao[i] = naomi[n-i-1];
			k[i] = ken[n-i-1];
		}
	}
	
	private static int deceive(){
		int numberOfWins = n;
		
		while(!checkWin(nao, k, numberOfWins)){
			numberOfWins--;
		}
		
		return numberOfWins;
	}
	
	private static boolean checkWin(float[]nao, float[] k, int digit){
		for (int i = 0; i < digit; i++){
			if (nao[i] < k[i + (n - digit)]){
				return false;
			}
		}
		return true;
	}

		

}