package com.angyc.codejam17.codejam.aa;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.HashSet;

public class AAlphabetCake {

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(br.readLine());
		
		for (int i = 0; i < t; i++) {
			String[] input  = br.readLine().split(" ");
			
			int r = Integer.parseInt(input[0]);
			int c = Integer.parseInt(input[1]);
			char[][] grid = new char[r][c];
			int[] startX = new int[128];
			int[] startY = new int[128];
			int[] endX   = new int[128];
			int[] endY   = new int[128];
			Arrays.fill(startX, Integer.MAX_VALUE);
			Arrays.fill(startY, Integer.MAX_VALUE);
			Arrays.fill(endX, Integer.MIN_VALUE);
			Arrays.fill(endY, Integer.MIN_VALUE);
			HashSet<Character> characters = new HashSet<Character>();
			
			for (int j = 0; j < r; j++) {
				String line = br.readLine();
				grid[j] = line.toCharArray();
			}
			
			for (int j = 0; j < r; j++) {
				for (int k = 0; k < c; k++) {
					char ch = grid[j][k];
					if (ch != '?') {
						startX[ch] = Math.min(startX[ch], j);
						startY[ch] = Math.min(startY[ch], k);
						endX[ch]   = Math.max(endX[ch], j);
						endY[ch]   = Math.max(endY[ch], k);
						if (!characters.contains(ch)) {
							characters.add(ch);
						}
					}
				}
			}
			
			for (Character ch : characters) {
				int sx = startX[ch.charValue()];
				int sy = startY[ch.charValue()];
				int ex = endX[ch.charValue()];
				int ey = endY[ch.charValue()];
				
				for (int j = sx; j <= ex; j++) {
					for (int k = sy; k <= ey; k++) {
						grid[j][k] = ch;
					}
				}
			}
			
			for (int j = 0; j < r; j++) {
				for (int k = 0; k < c; k++) {
					if (grid[j][k] == '?') {
						
						for (Character ch : characters) {
							boolean ok = true;
							char cha = ch.charValue();
							
							int nsx = Math.min(startX[cha], j);
							int nsy = Math.min(startY[cha], k);
							int nex = Math.max(endX[cha], j);
							int ney = Math.max(endY[cha], k);
							
							for (int m = nsx; m <= nex; m++) {
								for (int n = nsy; n <= ney; n++) {
									if (grid[m][n] != '?' && grid[m][n] != ch) {
										ok = false;
										break;
									}
								}
							}
							
							if (ok) {
								for (int m = nsx; m <= nex; m++) {
									for (int n = nsy; n <= ney; n++) {
										grid[m][n] = ch;
									}
								}
								
								startX[cha] = Math.min(startX[cha], j);
								startY[cha] = Math.min(startY[cha], k);
								endX[cha] = Math.max(endX[cha], j);
								endY[cha] = Math.max(endY[cha], k);
							}
						}
						
					}
				}
			}
			
			StringBuilder sb = new StringBuilder("Case #");
			System.out.println(sb.append(i+1).append(": ").toString());
			
			for (int j = 0; j < r; j++) {
				for (int k = 0; k < c; k++) {
					System.out.print(grid[j][k]);
				}
				System.out.println();
			}
		}
	}
}
