package com.angyc.codejam17.codejam.qualify;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.PriorityQueue;
import java.util.Queue;

// Naive solution, not optimized for Large input yet
public class CBathroomStalls {
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(br.readLine());
		
		for (int i = 0; i < t; i++) {
			String[] input = br.readLine().split(" ");
			Long n = Long.parseLong(input[0]);
			Long k = Long.parseLong(input[1]);
			
			Range r = new Range(0, n - 1);
			Queue<Range> q = new PriorityQueue<Range>();
			q.add(r);
			
			while (k-- > 0 && !q.isEmpty()) {
				r = q.poll();
				int to1   = r.pos - 1;
				int from2 = r.pos + 1;
				
				if (r.from <= to1) q.add(new Range(r.from, to1));
				if (r.to >= from2) q.add(new Range(from2, r.to));
			}
			
			String ans = r.max + " " + r.min;
			System.out.println("Case #" + (i + 1) + ": " + ans);
		}
	}
	
	private static class Range implements Comparable<Range> {
		public final Integer from;
		public final Integer to;
		public final Integer range;
		public final Integer min;
		public final Integer max;
		public final Integer pos;
		
		public Range(Integer from, Integer to) {
			this.from  = from;
			this.to    = to;
			
			range = to - from;
			pos   = (from + to) / 2;
			
			if (range % 2 == 0) {
				min = max = range / 2;
			} else {
				min = range / 2;
				max = min + 1;
			}
		}
		
		public Range(Integer from, Long to) {
			this(from, to.intValue());
		}

		@Override
		public int compareTo(Range o) {
			int comp = o.min.compareTo(this.min);
			if (comp == 0) {
				comp = o.max.compareTo(this.max);
				if (comp == 0) {
					comp = o.pos.compareTo(this.pos);
				}
			}
			return comp;
		}
	}
	
}