package com.angyc.codejam17.codejam.ac;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class AAmpleSyrup {

	public static PanCake pancakes[];
	public static int k;
	
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(br.readLine());
		
		for (int i = 0; i < t; i++) {
			String[] input = br.readLine().split(" ");
			int n = Integer.parseInt(input[0]);
			k = Integer.parseInt(input[1]);
			
			pancakes = new PanCake[n];
			
			for (int j = 0; j < n; j++) {
				String[] input2 = br.readLine().split(" ");
				int r = Integer.parseInt(input2[0]);
				int h = Integer.parseInt(input2[1]);
				pancakes[j] = new PanCake(r, h);
			}
			
			Arrays.sort(pancakes);
			double ans = compute(n - 1, k, 0);
			
			System.out.println("Case #" + (i + 1) + ": " + ans);
		}
	}
	
	public static class PanCake implements Comparable<PanCake> {
		public Double radius;
		public Double height;
		
		public PanCake(double radius, double height) {
			this.radius = radius;
			this.height = height;
		}

		@Override
		public int compareTo(PanCake o) {
			int a = radius.compareTo(o.radius);
			if (a == 0) {
				return height.compareTo(o.height);
			}
			return a;
		}
	}
	
	public static double compute(int current, int remaining, double currentSurface) {
		if (remaining <= 0) {
			return currentSurface;
		} else if (current < 0) {
			return -1;
		} else {
			boolean first = (remaining == k);
			double a = compute(current - 1, remaining - 1, currentSurface + computeSurface(current, first));
			double b = compute(current - 1, remaining, currentSurface);
			return Math.max(Math.max(a, b), currentSurface);
		}
	}
	
	public static double computeSurface(int i, boolean first) {
		double a = 0;
		if (first) {
			a = Math.PI * pancakes[i].radius * (pancakes[i].radius + 2 * pancakes[i].height);
		} else {
			a = 2 * Math.PI * pancakes[i].radius * pancakes[i].height;
		}
		return a;
	}
}
