package round1b;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;

public class NextNumber {
	public static void main(String[] args) throws NumberFormatException, IOException {
//		 TODO Auto-generated method stub
		if(args.length == 0){
			System.err.println("No arguments");
			System.exit(1);
		}
		BufferedReader bR = new BufferedReader(new FileReader(args[0]));
		
		int numTest = Integer.parseInt(bR.readLine());
		String line;
		
		for (int i = 0; i < numTest; i++) {
			line = bR.readLine();
		
			// read number
			int n = line.length();
			int[] number = new int[n];
			for (int j = 0; j < n; j++) {
				int digit = line.charAt(j)-48;
				number[j] = digit;
			}
			
			int[] newNumber = solve(number);
			System.out.print("Case #" + (i+1) + ": ");
			for (int j = 0; j < newNumber.length; j++) {
				System.out.print(newNumber[j]);
			}
			System.out.println();
			
		}
		
	}
	
	public static int[] solve(int[] number){
		
		// min[i] store min value of number[i+1] ... number[number.length-1]
		// minPos[i] store the index of number that have min[i]
		int n = number.length;
		
		int minPos = 0;
		
		// find position to flip
		int i = n-2;
		for (; i >=0; i--) {
			int min = 10;
			minPos = -1;
			for (int j = i+1; j < number.length; j++) {
				if(number[j] > number[i]){
					if(number[j] < min){
						min = number[j];
						minPos = j;
					}
				}
			}
			
			if(minPos != -1) { // we found a position
				break;
			}
		}
		
		
		if(i >= 0){ // there's a position to flip 
			// flip number[i], number[minPos[i]]
			int tmp = number[i];
			number[i] = number[minPos];
			number[minPos] = tmp;
			
			// sort from i+1 to number.length - 1, note the end point exclusive
			Arrays.sort(number, i+1, number.length);
			return number;
		} else { // no pair to flip
			//sort array first
			Arrays.sort(number, 0, number.length);
			
			int[] newNumber = new int[number.length + 1]; // has 1 more digit 
			//find first non-zero digit
			int j = 0;
			for (; j < number.length; j++) {
				if(number[j] !=0) {
					break;
				} else {
					newNumber[j+2] = 0; // j + 2 <= number.length otherwise N = 0
				}
			}
			// newNumber has been created from [2]..[j+1]
			newNumber[0] = number[j];
			newNumber[1] = 0; // this is an extra number added
			
			// copy number[j+1] .. number[number.length-1] to newNumber[j+2] ... newNumber[number.length]
			j++;
			for(; j < number.length; j++){
				newNumber[j+1] = number[j];
			}
			
			return newNumber;
		}
	}
}
