import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;

public class UniversalSearchSwitcher {
	
	public static void main(String[] args) throws Exception{
		BufferedReader br = new BufferedReader(new FileReader("small.in"));
		File f = new File("small.out");
		f.createNewFile();
		PrintWriter pw = new PrintWriter(new FileWriter("small.out"));
		
		int noOfTestCase = Integer.parseInt(br.readLine());
		
		for (int index = 1; index <= noOfTestCase; index++){
			
			int noOfSearchEngine = Integer.parseInt(br.readLine());
			String[] searchEngine = new String[noOfSearchEngine];
			for (int j = 0; j < noOfSearchEngine; j++){
				searchEngine[j] = br.readLine();
			} // end for
			
			int noOfQueries = Integer.parseInt(br.readLine());
			String[] queries = new String[noOfQueries];
			for (int k = 0; k < noOfQueries; k++){
				queries[k] = br.readLine();
			} // end for			
			
			int minSwitch = Integer.MAX_VALUE;
			
			if (noOfQueries > 0){
				// begin dynamic algorithms
				int[][] a = new int[queries.length][searchEngine.length];
				
				for (int j = 0; j < searchEngine.length; j++){
					a[0][j] = (queries[0].equals(searchEngine[j])) ? Integer.MAX_VALUE : 0 ;
				} // end for
				
				for (int i = 1; i < queries.length; i++){
					for (int j = 0; j < searchEngine.length; j++){
						
						if (queries[i].equals(searchEngine[j])){
							a[i][j] = Integer.MAX_VALUE;
						}
						else{
							// a[i][j] = min{a[i-1][j], min{a[i-1][k]+1}}
							
							// find min of previous row 
							int minPreviousRow = a[i-1][0];
							for (int k = 1; k < searchEngine.length; k++){
								minPreviousRow = (a[i-1][k] < minPreviousRow) ? a[i-1][k] : minPreviousRow; 
							} // end for
							
							a[i][j] = (a[i-1][j] < (minPreviousRow +1)) ? a[i-1][j] : (minPreviousRow+1); 
						}
					
					} // end for
				} // end for
				
				for (int j = 0; j < searchEngine.length; j++){
					minSwitch = (a[queries.length-1][j] < minSwitch) ? a[queries.length-1][j] : minSwitch; 
				} // end for
			}
			else{
				minSwitch = 0;
			}
			pw.println("Case #"+index+": "+minSwitch);
		} // end for
		
		pw.close();
		System.exit(0);
	}
}
