import static java.util.Arrays.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;
import java.util.*;
import java.math.*;
import java.io.*;

public class A implements Runnable
{
	String file = "A-large";
	
	void init() throws IOException
	{
		input = new BufferedReader(new FileReader(file + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
	}
	
	void solve() throws IOException
	{
		int n = nextInt();
		int[] D = new int[n + 2];
		int[] L = new int[n + 2];
		for(int i = 1; i <= n; i++)
		{
			D[i] = nextInt();
			L[i] = nextInt();
		}
		D[n + 1] = nextInt();
		
		int[] dp = new int[n + 1];
		dp[0] = 1;
		
		for(int i = 0; i <= n; i++)
		{
			int k = dp[i];
			if(k >= n + 1) break;
			for(int j = i + 1; j <= k; j++)
			{
				int len = min(L[j], D[j] - D[i]);
				int low = j, high = n + 1;
				while(low < high)
				{
					int mid = (low + high + 1) / 2;
					
					if(D[j] + len >= D[mid]) low = mid;
					else high = mid - 1;
				}
				
				dp[j] = max(dp[j], low);
			}
		}
		
		boolean ok = false;
		for(int i = 0; i <= n; i++) ok |= dp[i] >= n + 1;
		
		gcj(ok ? "YES" : "NO");
	}
	
	String next() throws IOException
	{
		while(tokenizer == null || !tokenizer.hasMoreTokens()) tokenizer = new StringTokenizer(input.readLine());
		return tokenizer.nextToken();
	}
	
	int nextInt() throws IOException
	{
		return Integer.parseInt(next());
	}
	
	long nextLong() throws IOException
	{
		return Long.parseLong(next());
	}
	
	double nextDouble() throws IOException
	{
		return Double.parseDouble(next());
	}
	
	void print(Object... o)
	{
		System.out.println(deepToString(o));
	}
	
	void gcj(Object o)
	{
		String s = String.valueOf(o);
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
	
	void gcjArray(Object[] o)
	{
		out.print("Case #" + test + ": ");
		System.out.print("Case #" + test + ": ");
		for(int i = 0; i < o.length; i++)
		{
			if(i != o.length - 1) 
			{
				out.print(String.valueOf(o[i]) + " ");
				System.out.print(String.valueOf(o[i] + " "));
			}
			else
			{
				out.println(String.valueOf(o[i]));
				System.out.println(String.valueOf(o[i]));
			}
		}
	}
	
	BufferedReader input;
	PrintWriter out;
	StringTokenizer tokenizer;
	int test;
	
	public static void main(String[] args) throws IOException
	{
		new Thread(null, new A(), "", 1 << 20).start();
	}
	
	public void run()
	{
		try
		{
			init();
			int TEST = nextInt();
			for(test = 1; test <= TEST; test++)
			{
				System.out.println("Running on testcase #" + test);	
				solve();
			}	
			out.close();		
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
	}
}