import static java.util.Arrays.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;
import java.util.*;
import java.math.*;
import java.io.*;

public class A implements Runnable
{
	String file = "A-small-attempt0";
	
	void init() throws IOException
	{
		input = new BufferedReader(new FileReader(file + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
	}
	
	void solve() throws IOException
	{
		int X = nextInt();
		long S = nextLong();
		long R = nextLong();
		double T = nextDouble();
		int N = nextInt();
		
		long[] B = new long[N + 2];
		long[] E = new long[N + 2];
		long[] w = new long[N + 2];
		for(int i = 1; i <= N; i++)
		{
			B[i] = nextLong();
			E[i] = nextLong();
			w[i] = nextLong();
		}
		B[N + 1] = X;
		E[N + 1] = X;
		for(int i = 0; i < N + 2; i++)
			for(int j = i + 1; j < N + 2; j++)
				if(B[i] > B[j])
				{
					long tmp = B[i];
					B[i] = B[j];
					B[j] = tmp;
					
					tmp = E[i];
					E[i] = E[j];
					E[j] = tmp;
					
					tmp = w[i];
					w[i] = w[j];
					w[j] = tmp;
				}
		ArrayList<Pair> as = new ArrayList<Pair>();
		for(int i = 0; i < N + 1; i++)
		{
			as.add(new Pair(E[i] - B[i], w[i]));
			as.add(new Pair(B[i + 1] - E[i], 0));
		}
		Collections.sort(as);
		//print(as);
		double res = 0;
		for(Pair p : as)
		{
			//print(p, T);
			if(T > EPS)
			{
				double minT = min((double)p.len / (R + p.speed), T);
				T -= minT;
				res += minT;
				res += (p.len - minT * (R + p.speed)) / (S + p.speed);
			}
			else res += (double)p.len / (S + p.speed);
		}
		gcj(res);
	}
	
	int[] belong;
	double EPS = 1e-8;
	
	class Pair implements Comparable<Pair>
	{
		long len, speed;
		public Pair(long len, long speed)
		{
			this.len = len;
			this.speed = speed;
		}
		
		public int compareTo(Pair p)
		{
			if(speed != p.speed) return Long.signum(speed - p.speed);
			return Long.signum(len - p.len);
		}
		
		public String toString()
		{
			return len + " " + speed;
		}
	}
	String next() throws IOException
	{
		while(tokenizer == null || !tokenizer.hasMoreTokens()) tokenizer = new StringTokenizer(input.readLine());
		return tokenizer.nextToken();
	}
	
	int nextInt() throws IOException
	{
		return Integer.parseInt(next());
	}
	
	long nextLong() throws IOException
	{
		return Long.parseLong(next());
	}
	
	double nextDouble() throws IOException
	{
		return Double.parseDouble(next());
	}
	
	void print(Object... o)
	{
		System.out.println(deepToString(o));
	}
	
	void gcj(Object o)
	{
		String s = String.valueOf(o);
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
	
	void gcjArray(Object[] o)
	{
		out.print("Case #" + test + ": ");
		System.out.print("Case #" + test + ": ");
		for(int i = 0; i < o.length; i++)
		{
			if(i != o.length - 1) 
			{
				out.print(String.valueOf(o[i]) + " ");
				System.out.print(String.valueOf(o[i] + " "));
			}
			else
			{
				out.println(String.valueOf(o[i]));
				System.out.println(String.valueOf(o[i]));
				
			}
		}
	}
	
	BufferedReader input;
	PrintWriter out;
	StringTokenizer tokenizer;
	int test;
	
	public static void main(String[] args) throws IOException
	{
		new Thread(null, new A(), "", 1 << 20).start();
	}
	
	public void run()
	{
		try
		{
			init();
			int TEST = nextInt();
			for(test = 1; test <= TEST; test++)
			{
				System.out.println("Running on testcase #" + test);	
				solve();
			}	
			out.close();		
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
	}
}