
import java.io.*;
import java.util.*;

public class Watersheds
{
	static String file = "B-large";
	
	static int [][] altitude;
	static int [][] comp;
	
	static int dx[] = { 1, 0, 0, -1 };
	static int dy[] = { 0, 1, -1, 0 };
	
	static int H, W, cnt;
	
	public static void main( String [] args ) throws IOException
	{
		BufferedReader input = new BufferedReader( new FileReader( file + ".in" ));
		PrintWriter out = new PrintWriter( new BufferedWriter( new FileWriter( file + ".out" )));
		
		int T = Integer.parseInt( input.readLine() );
		for( int t = 1; t <= T; t++ )
		{
			String [] st = input.readLine().split(" ");
			H = Integer.parseInt(st[0]);
			W = Integer.parseInt(st[1]);
			
			altitude = new int[H][W];
			int min = Integer.MAX_VALUE;
			for( int i = 0; i < H; i++ )
			{
				String [] s = input.readLine().split(" ");
				for( int j = 0; j < W; j++ )
				{
					altitude[i][j] = Integer.parseInt(s[j]);
					min = Math.min( min, altitude[i][j] );
				}
			}
			
			comp = new int[H][W];
			cnt = 0;
			
			for( int i = 0; i < H; i++ ) Arrays.fill( comp[i], -1 );
			
			for( int i = 0; i < H; i++ )
				for( int j = 0; j < W; j++ )
					if( comp[i][j] == -1 )
						floodFill(i,j);
			
			/*
			for( int i = 0; i < H; i++ )
				for( int j = 0; j < W; j++ )
					System.out.print( "" + comp[i][j] + (j==W-1 ? '\n' : ' '));	
			*/
					
			char [][] res = new char[H][W];
			for( int i = 0; i < H; i++ ) Arrays.fill( res[i], '-' );
			
			char c = 'a';
			for( int i = 0; i < H; i++ )
				for( int j = 0; j < W; j++ )
					if( res[i][j] == '-' )
					{
						res[i][j] = c;
						for( int ii = 0; ii < H; ii++ )
							for( int jj = 0; jj < W; jj++ )
								if( comp[ii][jj] == comp[i][j] )
									res[ii][jj] = c;
						c++;
					}
					
			out.println( "Case #" + t + ":" );
			for( int i = 0; i < H; i++ )
				for( int j = 0; j < W; j++ )
					out.print( "" + res[i][j] + (j == W-1 ? '\n' : ' ') );
						
		}
		out.close();
	}
	
	public static int floodFill( int x, int y )
	{
		//System.out.println(x + " " + y);
		if( comp[x][y] != -1 ) return comp[x][y];
		
		int nx = -1;
		int ny = -1;
		int min = altitude[x][y];
		
		for( int k = 0; k < 4; k++ )
		{
			int tx = x+dx[k];
			int ty = y+dy[k];
		
			if( tx < 0 || tx >= H || ty < 0 || ty >= W ) continue;
			
			if( min > altitude[tx][ty] || (min == altitude[tx][ty] && altitude[tx][ty] != altitude[x][y])) 
			{
				min = altitude[tx][ty];
				nx = tx;
				ny = ty;
			}
		}
		
		if( nx == -1 ) comp[x][y] = cnt++;
		else comp[x][y] = floodFill(nx,ny);
		
		return comp[x][y];
	}
}