import static java.util.Arrays.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;
import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable
{
	String file = "B-small-attempt2";
	
	void init() throws IOException {
		input = new BufferedReader(new FileReader(file + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
	}
	
	void solve() throws IOException {
		char[] as = next().toCharArray();
		char[] bs = next().toCharArray();
		int n = as.length;
		long[][] dp = new long[n + 1][3];
		int[][] prev = new int[n + 1][3];
		int[][] px = new int[n + 1][3];
		int[][] py = new int[n + 1][3];
		for (long[] t : dp) fill(t, Long.MAX_VALUE);
		dp[0][0] = 0;
		for (int i = 0; i < n; i++)
			for (int j = 0; j < 3; j++) {
				if (dp[i][j] >= Long.MAX_VALUE) continue;

				int mina = as[i] == '?' ? 0 : (as[i] - '0');
				int maxa = as[i] == '?' ? 9 : (as[i] - '0');
				int minb = bs[i] == '?' ? 0 : (bs[i] - '0');
				int maxb = bs[i] == '?' ? 9 : (bs[i] - '0');
				
				for (int x = mina; x <= maxa; x++)
					for (int y = minb; y <= maxb; y++) {
						if (x > y) {
							int k = 0;
							if (j == 0) k = 1;
							if (j == 1) k = 1;
							if (j == 2) k = 2;
							int mul = k == 1 ? 1 : -1;
							if (dp[i + 1][k] > dp[i][j] * 10 + mul * (x - y)) {
								dp[i + 1][k] = dp[i][j] * 10 + mul * (x - y);
								prev[i + 1][k] = j;
								px[i + 1][k] = x;
								py[i + 1][k] = y;
							}
						} else if (x == y) {
							int k = j;
							if (dp[i + 1][k] > dp[i][j] * 10) {
								dp[i + 1][k] = dp[i][j] * 10;
								prev[i + 1][k] = j;
								px[i + 1][k] = x;
								py[i + 1][k] = y;
							}
						} else if (x < y) {
							int k = 0;
							if (j == 0) k = 2;
							if (j == 1) k = 1;
							if (j == 2) k = 2;
							int mul = k == 2 ? 1 : -1;
							if (dp[i + 1][k] > dp[i][j] * 10 + mul * (y - x)) {
								dp[i + 1][k] = dp[i][j] * 10 + mul * (y - x);
								prev[i + 1][k] = j;
								px[i + 1][k] = x;
								py[i + 1][k] = y;
							}
						}
					}
			}
		//debug(dp[n][0], dp[n][1], dp[n][2]);
		long ra = Long.MAX_VALUE, rb = Long.MAX_VALUE, inf = Long.MAX_VALUE;
		String sx = "", sy = "";
		for (int k = 0; k < 3; k++) {
			if (dp[n][k] >= Long.MAX_VALUE) continue;
			String sa = "", sb = "";
			int m = n, t = k;
			while (m > 0) {
				sa = px[m][t] + sa;
				sb = py[m][t] + sb;
				t = prev[m][t];
				m--;
			}
			long a = Long.parseLong(sa);
			long b = Long.parseLong(sb);
			if (abs(a - b) < inf || (abs(a - b) == inf && a < ra) || (abs(a - b) == inf && a == ra && b < rb)) {
				inf = abs(a - b);
				ra = a;
				rb = b;
				sx = sa;
				sy = sb;
			} 
		}
		gcj(sx + " " + sy);
	}
	
	String next() throws IOException {
		if(st == null || !st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
	
	void debug(Object... o) {
		System.out.println(deepToString(o));
	}
	
	void gcj(Object o) {
		String s = String.valueOf(o);
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
	
	BufferedReader input;
	PrintWriter out;
	StringTokenizer st;
	int test;
	
	public static void main(String[] args) throws IOException {
		new Thread(null, new Main(), "", 1 << 20).start();
	}
	
	public void run() {
		try {
			init();
			int TEST = nextInt();
			for(test = 1; test <= TEST; test++) {
				System.out.println("Running on testcase #" + test);	
				solve();
			}	
			out.close();		
		}
		catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}