
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.util.*;
import java.io.*;

public class B implements Runnable
{
	public static void main(String [] args) throws IOException
	{
		new Thread(null, new B(), "", 1 << 20).start();
	}
	
	String file = "B-large";
	BufferedReader input;
	PrintWriter out;
	
	public void run()
	{
		try
		{
			input = new BufferedReader(new FileReader(file + ".in"));
			out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
			
			int TEST = Integer.parseInt(input.readLine());
			for(int test = 1; test <= TEST; test++)
			{
				System.out.println("Running on testcase #" + test);	
				solve(test);
			}
				
			input.close();
			out.close();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
	}
	int P;
	int[] M;
	int[] cost;
	int[][] dp;
	void solve(int test) throws IOException
	{
		P = nextInt();
		M = new int[1 << P];
		cost = new int[1 << P];
		StringTokenizer st = tokens();
		for(int i = 0; i < 1 << P; i++) M[i] = nextInt(st);
		for(int i = 1; i <= P; i++)
		{
			int min = 1 << (P - i);
			int max = 1 << (P - i + 1);
			st = tokens();
			for(int j = min; j < max; j++) cost[j] = nextInt(st);
		}
		dp = new int[1 << P][P + 1];
		for(int[] t : dp) fill(t, -1);
		int res = get(1, 0);
		gcj(test, res + "");
	}
	int INF = 600000000;
	int get(int match, int missed)
	{
		if(match >= (1 << P))
		{
			if(missed <= M[match - (1 << P)]) return 0;
			return INF;
		}
		if(dp[match][missed] != -1) return dp[match][missed];
		
		int res = INF;
		res = get(match * 2, missed) + get(match * 2 + 1, missed) + cost[match];
		res = min(res, get(match * 2, missed + 1) + get(match * 2 + 1, missed + 1));
		if(res >= INF) res = INF;
		return dp[match][missed] = res;
	}
	
	StringTokenizer tokens() throws IOException
	{
		return new StringTokenizer(input.readLine());
	}
	
	String next(StringTokenizer st)
	{
		return st.nextToken();
	}
	
	int nextInt() throws IOException
	{
		return Integer.parseInt(input.readLine());
	}
	
	int nextInt(StringTokenizer st)
	{
		return Integer.parseInt(st.nextToken());
	}
	
	long nextLong() throws IOException
	{
		return Long.parseLong(input.readLine());
	}
	
	long nextLong(StringTokenizer st)
	{
		return Long.parseLong(st.nextToken());
	}
	
	double nextDouble() throws IOException
	{
		return Double.parseDouble(input.readLine());
	}
	
	double nextDouble(StringTokenizer st)
	{
		return Double.parseDouble(st.nextToken());
	}
	
	void print(Object... o)
	{
		System.out.println(deepToString(o));
	}
	
	void gcj(int test, String s)
	{
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
}