
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.util.*;
import java.io.*;

public class C implements Runnable
{
	public static void main(String [] args) throws IOException
	{
		new Thread(null, new C(), "", 1 << 20).start();
	}
	
	String file = "C-small-attempt0";
	BufferedReader input;
	PrintWriter out;
	
	public void run()
	{
		try
		{
			input = new BufferedReader(new FileReader(file + ".in"));
			out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
			
			int TEST = Integer.parseInt(input.readLine());
			for(int test = 1; test <= TEST; test++)
			{
				System.out.println("Running on testcase #" + test);	
				solve(test);
			}
				
			input.close();
			out.close();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
	}
	int R;
	int MAX = 200;
	void solve(int test) throws IOException
	{
		int[][] a = new int[MAX][MAX];
		R = nextInt();
		StringTokenizer st;
		for(int i = 0; i < R; i++)
		{
			st = tokens();
			int sx = nextInt(st), sy = nextInt(st), ex = nextInt(st), ey = nextInt(st);
			for(int x = sx; x <= ex; x++)
				for(int y = sy; y <= ey; y++)
					a[x][y] = 1;
		}
		for(int r = 1; ; r++)
		{
			boolean next = false;
			int[][] b = clone(a);
			for(int i = 1; i < MAX; i++)
				for(int j = 1; j < MAX; j++)
					if(a[i][j] == 1 && a[i - 1][j] == 0 && a[i][j - 1] == 0) b[i][j] = 0;
					else if(a[i][j] == 0 && a[i - 1][j] == 1 && a[i][j - 1] == 1) b[i][j] = 1;
					else b[i][j] = a[i][j];
			
			outer: for(int i = 0; i < MAX; i++)
				for(int j = 0; j < MAX; j++)
					if(b[i][j] != 0)
					{
						next = true;
						break outer;
					}
			if(!next)
			{
				gcj(test, r + "");
				return;
			}
			a = b;
		}
	}
	int[][] clone(int[][] a)
	{
		int[][] b = new int[MAX][MAX];
		for(int i = 0; i < MAX; i++) b[i] = a[i].clone();
		return b;
	}
	
	StringTokenizer tokens() throws IOException
	{
		return new StringTokenizer(input.readLine());
	}
	
	String next(StringTokenizer st)
	{
		return st.nextToken();
	}
	
	int nextInt() throws IOException
	{
		return Integer.parseInt(input.readLine());
	}
	
	int nextInt(StringTokenizer st)
	{
		return Integer.parseInt(st.nextToken());
	}
	
	long nextLong() throws IOException
	{
		return Long.parseLong(input.readLine());
	}
	
	long nextLong(StringTokenizer st)
	{
		return Long.parseLong(st.nextToken());
	}
	
	double nextDouble() throws IOException
	{
		return Double.parseDouble(input.readLine());
	}
	
	double nextDouble(StringTokenizer st)
	{
		return Double.parseDouble(st.nextToken());
	}
	
	void print(Object... o)
	{
		System.out.println(deepToString(o));
	}
	
	void gcj(int test, String s)
	{
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
}