import static java.util.Arrays.*;
import static java.lang.Math.*;
import static java.math.BigInteger.*;
import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable
{
	String file = "A-small-attempt0";
	
	void init() throws IOException {
		input = new BufferedReader(new FileReader(file + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
	}
	
	void solve() throws IOException {
		int[] count = new int[26];
		char[] cs = next().toCharArray();
		int[] res = new int[10];
		for (char c : cs) count[c - 'A']++;
		res[0] = count[toInt('Z')]; reduce("ZERO", res[0], count);
		res[2] = count[toInt('W')]; reduce("TWO", res[2], count);
		res[4] = count[toInt('U')]; reduce("FOUR", res[4], count);
		res[6] = count[toInt('X')]; reduce("SIX", res[6], count);
		res[8] = count[toInt('G')]; reduce("EIGHT", res[8], count);
		res[1] = count[toInt('O')]; reduce("ONE", res[1], count);
		res[3] = count[toInt('T')]; reduce("THREE", res[3], count);
		res[5] = count[toInt('F')]; reduce("FIVE", res[5], count);
		res[7] = count[toInt('S')]; reduce("SEVEN", res[7], count);
		res[9] = count[toInt('I')];
		
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < 10; i++) {
			while (res[i] > 0) {
				sb.append((char)(i + '0'));
				res[i]--;
			}
		}
		gcj(sb.toString());
	}
	
	void reduce(String s, int num, int[] count) {
		for (char c : s.toCharArray()) count[toInt(c)] -= num;
	}
	
	int toInt(char c) {
		return c - 'A';
	}
	
	String next() throws IOException {
		if(st == null || !st.hasMoreTokens()) st = new StringTokenizer(input.readLine());
		return st.nextToken();
	}
	
	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}
	
	long nextLong() throws IOException {
		return Long.parseLong(next());
	}
	
	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}
	
	void debug(Object... o) {
		System.out.println(deepToString(o));
	}
	
	void gcj(Object o) {
		String s = String.valueOf(o);
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
	
	BufferedReader input;
	PrintWriter out;
	StringTokenizer st;
	int test;
	
	public static void main(String[] args) throws IOException {
		new Thread(null, new Main(), "", 1 << 20).start();
	}
	
	public void run() {
		try {
			init();
			int TEST = nextInt();
			for(test = 1; test <= TEST; test++) {
				System.out.println("Running on testcase #" + test);	
				solve();
			}	
			out.close();		
		}
		catch(Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}
}