
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.util.*;
import java.io.*;

public class CrazyRow
{
	public static void main(String [] args) throws IOException
	{
		new CrazyRow().run();
	}
	
	String file = "A-small-attempt0";
	BufferedReader input;
	PrintWriter out;
	char[][] cs;
	int n;
	
	void run() throws IOException
	{
		input = new BufferedReader(new FileReader(file + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
		
		int TEST = Integer.parseInt(input.readLine());
		for(int test = 1; test <= TEST; test++)
		{
			System.out.println("Running on testcase #" + test);	
			n = Integer.parseInt(input.readLine());
			cs = new char[n][n];
			for(int i = 0; i < n; i++) cs[i] = input.readLine().toCharArray();
			HashMap<String, Integer> dist = new HashMap<String, Integer>();
			Queue<String> que = new LinkedList<String>();
			String start = "";
			for(int i = 0; i < n; i++) start += i;
			que.add(start);
			dist.put(start, 0);
			int res = 0;
			while(!que.isEmpty())
			{
				String s = que.poll();
				int d = dist.get(s);
				if(check(s)) 
				{
					res = d;
					break;
				}
				
				for(int i = 0; i < n - 1; i++)
				{
					char[] t = s.toCharArray();
					char c = t[i];
					t[i] = t[i + 1];
					t[i + 1] = c;
					String next = new String(t);
					if(!dist.containsKey(next))
					{
						dist.put(next, d + 1);
						que.add(next);
					}
				}
				
			}
			print(test, res + "");
		}
		out.close();
	}
	
	boolean check(String s)
	{
		char[] c = s.toCharArray();
		char[][] tmp = new char[n][n];
		for(int i = 0; i < c.length; i++)
			tmp[i] = cs[c[i] - '0'].clone();
		for(int i = 0; i < n; i++)
		{
			int max = 0;
			for(int j = 0; j < n; j++)
				if(tmp[i][j] == '1')
					max = j;
			if(max > i) return false;
		}
		return true;
	}
	
	public boolean next_permutation( int [] a )
	{
		int n = a.length;
		int i = n-2;
		while( i >= 0 && a[i] >= a[i+1] ) i--;
		if( i == -1 ) return false;
		int x = a[i];
		int j = n-1;
		while( a[j] <= x ) j--;
		a[i] = a[j];
		a[j] = x;
		
		i++; j = n-1;
		while( i<j ) { int t = a[i]; a[i] = a[j]; a[j] = t; i++; j--; } 
		return true;
	}

	
	void print(int test, String s)
	{
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
	
	void debug(Object... o)
	{
		System.out.println(deepToString(o));
	}
}