
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.util.*;
import java.io.*;

public class Rotate implements Runnable
{
	public static void main(String [] args) throws IOException
	{
		new Thread(null, new Rotate(), "", 1 << 20).start();
	}
	
	String file = "A-large";
	BufferedReader input;
	PrintWriter out;
	
	public void run()
	{
		try
		{
			input = new BufferedReader(new FileReader(file + ".in"));
			out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
			
			int TEST = Integer.parseInt(input.readLine());
			for(int test = 1; test <= TEST; test++)
			{
				System.out.println("Running on testcase #" + test);	
				solve(test);
			}
				
			input.close();
			out.close();
		}
		catch(Exception e)
		{
			e.printStackTrace();
			System.exit(1);
		}
	}
	int n, k;
	void solve(int test) throws IOException
	{
		StringTokenizer st = tokens();
		n = nextInt(st); k = nextInt(st);
		char[][] cs = new char[n][n];
		for(int i = 0; i < n; i++) cs[i] = input.readLine().toCharArray();
		//printm(cs);
		cs = rotate(cs);
		//printm(cs);
		gravity(cs);
		//printm(cs);
		int R = count(cs, 'R');
		int B = count(cs, 'B');
		print(R, B);
		boolean red = R >= k;
		boolean blue = B >= k;
		if(red && blue) gcj(test, "Both");
		else if(red) gcj(test, "Red");
		else if(blue) gcj(test, "Blue");
		else gcj(test, "Neither");
	}
	char[][] rotate(char[][] cs)
	{
		char[][] as = new char[n][n];
		for(int i = 0; i < n; i++)
			for(int j = 0; j < n; j++)
				as[j][n - i - 1] = cs[i][j];
		return as;
	}
	void gravity(char[][] cs)
	{
		for(int j = 0; j < n; j++)
		{
			int pos = n - 1;
			while(pos >= 0 && cs[pos][j] != '.') pos--;
			if(pos >= 0)
			{
				for(int i = pos - 1; i >= 0; i--)
					if(cs[i][j] != '.')
					{
						char t = cs[i][j];
						cs[i][j] = cs[pos][j];
						cs[pos][j] = t;
						pos--;
					}
			}
		}
	}
	int count(char[][] cs, char c)
	{
		int res = 0;
		for(int i = 0; i < n; i++)
		{
			int tmp = 0;
			for(int j = 0; j < n; j++)
				if(cs[i][j] == c)
				{
					tmp++;
					res = max(res, tmp);
				}
				else tmp = 0;
		}
		for(int j = 0; j < n; j++)
		{
			int tmp = 0;
			for(int i = 0; i < n; i++)
				if(cs[i][j] == c)
				{
					tmp++;
					res = max(res, tmp);
				}
				else tmp = 0;
		}
		//print(res);
		int t = 0;
		for(int i = 0; i < n; i++)
		{
			int y = 0, x = i;
			t = 0;
			while(x < n && y < n)
			{
				if(cs[x][y] == c)
				{
					t++;
					res = max(res, t);
				}
				else t = 0;
				//print(x, y, t);
				x++; y++;
			}
		}
		//print(res);
		t = 0;
		for(int i = 0; i < n; i++)
		{
			int y = n - 1, x = i;
			t = 0;
			while(y >= 0 && x < n)
			{
				if(cs[x][y] == c)
				{
					t++;
					res = max(res, t);
				}
				else t = 0;
				y--; x++;
			}
		}
		t = 0;
		for(int i = 0; i < n; i++)
		{
			int y = n - 1, x = i;
			t = 0;
			while(x >= 0 && y >= 0)
			{
				if(cs[x][y] == c)
				{
					t++;
					res = max(res, t);
				}
				else t = 0;
				x--; y--;
			}
		}
		t = 0;
		for(int i = 0; i < n; i++)
		{
			int y = 0, x = i;
			t = 0;
			while(x < n && y >= 0)
			{
				if(cs[x][y] == c)
				{
					t++;
					res = max(res, t);
				}
				else t = 0;
				y--; x++;
			}
		}
		return res;
	}
	
	void printm(char[][] cs)
	{
		for(int i = 0; i < n; i++)
			System.out.println(cs[i]);
		System.out.println();
	}
	StringTokenizer tokens() throws IOException
	{
		return new StringTokenizer(input.readLine());
	}
	
	String next(StringTokenizer st)
	{
		return st.nextToken();
	}
	
	int nextInt() throws IOException
	{
		return Integer.parseInt(input.readLine());
	}
	
	int nextInt(StringTokenizer st)
	{
		return Integer.parseInt(st.nextToken());
	}
	
	double nextDouble() throws IOException
	{
		return Double.parseDouble(input.readLine());
	}
	
	double nextDouble(StringTokenizer st)
	{
		return Double.parseDouble(st.nextToken());
	}
	
	void print(Object... o)
	{
		System.out.println(deepToString(o));
	}
	
	void gcj(int test, String s)
	{
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
}