
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.util.*;
import java.io.*;

public class Watering
{
	public static void main(String [] args) throws IOException
	{
		new Watering().run();
	}
	
	String file = "D-small-attempt0";
	BufferedReader input;
	PrintWriter out;
	
	void run() throws IOException
	{
		input = new BufferedReader(new FileReader(file + ".in"));
		out = new PrintWriter(new BufferedWriter(new FileWriter(file + ".out")));
		
		int TEST = Integer.parseInt(input.readLine());
		for(int test = 1; test <= TEST; test++)
		{
			System.out.println("Running on testcase #" + test);	
			int n = Integer.parseInt(input.readLine());
			double[] X = new double[n];
			double[] Y = new double[n];
			double[] R = new double[n];
			double maxR = 0;
			for(int i = 0; i < n; i++)
			{
				StringTokenizer st = new StringTokenizer(input.readLine());
				X[i] = Double.parseDouble(st.nextToken());
				Y[i] = Double.parseDouble(st.nextToken());
				R[i] = Double.parseDouble(st.nextToken());
				maxR = max(R[i], maxR);
			}
			if(n == 1 || n == 2) 
			{
				print(test, "" + maxR);
				continue;
			}
			double minD = Double.MAX_VALUE;
			for(int i = 0; i < n; i++)
				for(int j = i + 1; j < n; j++)
					minD = min(minD, (hypot(X[i] - X[j], Y[i] - Y[j]) + R[i] + R[j]) / 2);
			
			print(test, "" + max(maxR, minD));
		}
		out.close();
	}
	
	void print(int test, String s)
	{
		out.println("Case #" + test + ": " + s);
		System.out.println("Case #" + test + ": " + s);
	}
	
	void debug(Object... o)
	{
		System.out.println(deepToString(o));
	}
}