package qualifiers2013;

import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class ProblemA {
	public static final char PLAYER_X = 'X';
	public static final char PLAYER_O = 'O';
	public static final char DOT = '.';
	public static final char ALLOWED_CHAR = 'T';
	public static final int BOARD_SIZE = 4;
	
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter out = new PrintWriter(new FileWriter("C:\\Users\\Aniket\\Desktop\\output.txt"));
		int t = Integer.parseInt(br.readLine());
		for (int i = 0; i < t; i++) {
			char ip_array[][] = new char[BOARD_SIZE][BOARD_SIZE];
			takeInput(br,ip_array);
			// Debugging : printArray(ip_array);
			String op = checkRCD(ip_array);
			printStatement(i, op, out);
			br.readLine();
		}
		out.flush();
		out.close();
		br.close();
	}

	private static String checkRCD(char[][] ip_array) {
		String result = "";
		Outer : for (int i = 0; i < ip_array.length; i++) {
			for (int j = 0; j < ip_array.length; j++) {
				
				//check Player_X winning in row or columns
				String x_result = checkX(ip_array,i,j);
				if(x_result.equals(PLAYER_X + " won")){
					result = x_result;
					break Outer;
				}
				
				//check Player_O winning in row or columns
				String o_result = checkO(ip_array,i,j);
				if(o_result.equals(PLAYER_O + " won")){
					result = o_result;
					break Outer;
				}
			}
		}
		
		//check Player_X winning in one of the diaganols
		String x_diag = checkDiagonalX(ip_array);
		if(x_diag.equals(PLAYER_X + " won")){
			result = x_diag;
		}
		
		//check Player_O winning in one of the diaganols
		String o_diag = checkDiagonalO(ip_array);
		if(o_diag.equals(PLAYER_O + " won")){
			result = o_diag;
		}
		
		//remaining
		if(result.equals("") && hasDots(ip_array)){
			result = "Game has not completed";
		}
		else if(result.equals("")){
			result = "Draw";
		}
		
		return result;
	}

	private static boolean hasDots(char[][] ip_array) {
		boolean result = false;
		Outer : for (int i = 0; i < ip_array.length; i++) {
			for (int j = 0; j < ip_array.length; j++) {
				if( ip_array[i][j] == DOT){
					result = true;
					break Outer;
				}
			}
		}
		return result;
	}

	private static String checkDiagonalO(char[][] ip_array) {
		int count = 0;
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[i][i];
			if(temp == PLAYER_O || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length){
			return PLAYER_O + " won";
		}
		
		count = 0;
		
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[i][ip_array.length - i - 1];
			if(temp == PLAYER_O || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length){
			return PLAYER_O + " won";
		}
		
		return PLAYER_O + "";
	}

	private static String checkDiagonalX(char[][] ip_array) {
		int count = 0;
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[i][i];
			if(temp == PLAYER_X || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length){
			return PLAYER_X + " won";
		}
		
		count = 0;
		
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[i][ip_array.length - i - 1];
			if(temp == PLAYER_X || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length){
			return PLAYER_X + " won";
		}
		
		return PLAYER_X + "";
	}

	private static void printStatement(int caseNo, String result ,PrintWriter out) {
		// TODO Auto-generated method stub
		System.out.println("Case #" + (caseNo+1) + ": " + result);
		out.println("Case #" + (caseNo+1) + ": " + result);
	}

	private static String checkO(char[][] ip_array, int r,int c) {
		// TODO Auto-generated method stub
		int count = 0;
		
		//row wise check
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[i][c];
			if(temp == PLAYER_O || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length ){
			return PLAYER_O + " won";
		}
		
		count = 0;
		//column wise check 
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[r][i];
			if(temp == PLAYER_O || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length){
			return PLAYER_O + " won";
		}
		
		return PLAYER_O + "";
	}

	private static String checkX(char[][] ip_array, int r, int c) {
		// TODO Auto-generated method stub
		int count = 0;
		
		//row wise check
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[i][c];
			if(temp == PLAYER_X || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length){
			return PLAYER_X + " won";
		}
		
		count = 0;
		//column wise check 
		for (int i = 0; i < ip_array.length; i++) {
			char temp = ip_array[r][i];
			if(temp == PLAYER_X || temp == ALLOWED_CHAR){
				count++;
			}
			else {
				break;
			}
		}
		
		if(count == ip_array.length){
			return PLAYER_X + " won";
		}
		
		return PLAYER_X + "";
	}
	
	

	private static void takeInput(BufferedReader br, char[][] ip_array) throws IOException {
		// TODO Auto-generated method stub
		String []ip = new String[BOARD_SIZE];
		for (int i = 0; i < ip.length; i++) {
			ip[i] = br.readLine();
		}
		char temp[] = new char[BOARD_SIZE];
		for (int i = 0; i < ip_array.length; i++) {
			temp = ip[i].toCharArray();
			for (int j = 0; j < ip_array.length; j++) {
				ip_array[i][j] = temp[j];
			}
		}
	}
	
	private static void printArray(char[][] array){
		for (int i = 0; i < array.length; i++) {
			for (int j = 0; j < array.length; j++) {
				System.out.print(array[i][j]);
			}
			System.out.println();
		}
	}
}


/*
 regourous testing 
 XOXO
OXT.
.O..
O..X
 */







