import java.awt.Point;
import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;


public class B {

  int[] dx = new int[]{0, -1, 1, 0};
  int[] dy = new int[]{-1, 0, 0, 1};
  int[][] alt;
  private int height;
  private int width;

  public void doIt() throws IOException {
    String className = this.getClass().getSimpleName();
    boolean small = true;
    boolean practice = false;
    boolean outToScreen = false;

    String fileName = className + "-" + (small ? "small" : "large")
        + (practice ? "-practice" : (small ? "-attempt0" : "")) + ".in";
    String outFileName = className + "-" + (small ? "small" : "large")
        + (practice ? "-practice" : (small ? "-attempt0" : "")) + ".out";
    BufferedReader reader = new BufferedReader(new InputStreamReader(this.getClass()
        .getResourceAsStream(fileName)));

    PrintWriter writer = null;

    if (!outToScreen) {
      writer = new PrintWriter(new FileWriter(outFileName));
    }

    String o = "";


    String line = reader.readLine();
    int cases = Integer.parseInt(line);

    for (int ncase = 0; ncase < cases; ncase++) {
      line = reader.readLine();
      String[] p = line.split(" ");
      height = Integer.parseInt(p[0]);
      width = Integer.parseInt(p[1]);

      alt = new int[width][height];

      for (int i = 0; i < height; i++) {
        line = reader.readLine();
        p = line.split(" ");

        for (int j = 0; j < width; j++) {
          alt[j][i] = Integer.parseInt(p[j]);
        }
      }

      char[][] fill = new char[width][height];
      // do the fill
      for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
          fill[j][i] = ' ';
        }
      }

      int c = 0;
      for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
          if (fill[j][i] != ' ') {
            continue;
          }
          Point pp = new Point(j, i);
          List list = new LinkedList();
          list.add(pp);
          fill[pp.x][pp.y] = (char) (c + 'a');
          while (list.size() > 0) {
            pp = (Point) list.get(0);
            list.remove(0);
            int smallx = 0;
            int smally = 0;
            for (int d = 0; d < 4; d++) {
              int ddx = pp.x + dx[d];
              int ddy = pp.y + dy[d];

              if ((ddx >= width) || (ddx < 0) || (ddy >= height) || (ddy < 0)) {
                continue;
              }

              if (fill[ddx][ddy] == ' ') {
                if (check(pp.x, pp.y, ddx, ddy)) {
                  fill[ddx][ddy] = (char) (c + 'a');
                  list.add(new Point(ddx, ddy));
                } else if (check(ddx, ddy, pp.x, pp.y)) {
                  fill[ddx][ddy] = (char) (c + 'a');
                  list.add(new Point(ddx, ddy));
                }

              }

            }
          }
          c++;
        }
      }


      String[][] res = new String[width][height];

      o = "Case #" + (ncase + 1) + ":";
      if (outToScreen) {
        System.out.println(o);
      } else {
        writer.println(o);
      }

      for (int i = 0; i < height; i++) {
        for (int j = 0; j < width; j++) {
          if (j > 0) {
            if (outToScreen) {
              System.out.print(" ");
            } else {
              writer.print(" ");
            }
          }
          if (outToScreen) {
            System.out.print(fill[j][i]);
          } else {
            writer.print(fill[j][i]);
          }
        }
        if (outToScreen) {
          System.out.println();
        } else {
          writer.println();
        }
      }

    }
    if (!outToScreen) {
      writer.flush();
      writer.close();
    }

  }

  private boolean check(int x, int y, int ddx, int ddy) {
    if (alt[x][y] <= alt[ddx][ddy]) {
      return false;
    }

    boolean found = false;
    for (int d = 0; d < 4; d++) {
      int ddx1 = x + dx[d];
      int ddy1 = y + dy[d];
      if ((ddx1 >= width) || (ddx1 < 0) || (ddy1 >= height) || (ddy1 < 0)) {
        continue;
      }
      if ((ddx1 == ddx) && (ddy1 == ddy)) {
        found = true;
        continue;
      }
      if (alt[ddx1][ddy1] < alt[ddx][ddy]) {
        return false;
      }
      if (alt[ddx1][ddy1] == alt[ddx][ddy]) {
        if (!found) {
          return false;
        }
      }
    }
    return true;
  }

  public static void main(String[] args) throws IOException {
    B a = new B();
    a.doIt();
  }
}
