import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.math.BigInteger;


public class C {

  public void doIt() throws IOException {
    String className = this.getClass().getSimpleName();
    boolean small = true;
    boolean practice = false;
    String fileName = className + "-" + (small ? "small" : "large")
        + (practice ? "-practice" : (small ? "-attempt1" : "")) + ".in";
    String outFileName = className + "-" + (small ? "small" : "large")
        + (practice ? "-practice" : (small ? "-attempt1" : "")) + ".out";
    BufferedReader reader = new BufferedReader(new InputStreamReader(this.getClass()
        .getResourceAsStream(fileName)));

    boolean out = false;
    PrintWriter writer = null;

    if (!out) {
      writer = new PrintWriter(new FileWriter(outFileName));
    }

    String o = "";

    String line = reader.readLine();
    int cases = Integer.parseInt(line);

    for (int ncase = 0; ncase < cases; ncase++) {
      line = reader.readLine();
      String r = "";
      String[] parts = line.split(" ");
      int R = Integer.parseInt(parts[0]);
      int k = Integer.parseInt(parts[1]);
      int N = Integer.parseInt(parts[2]);
      
      int[] g = new int[N];
      line = reader.readLine();
      parts = line.split(" ");
      for (int i = 0; i < g.length; i++) {
        g[i] = Integer.parseInt(parts[i]);
      }
      long res = 0;
      
      long sum = 0;
      for (int i = 0; i < N; i++) {
        sum += g[i];
      }
      if (sum <= k) {
        res = R * sum;
      } else {        
        int[] step = new int[N];
        long[] stepsum = new long[N];
        step[0] = 1;
        stepsum[0] = 0;
        int start = 0;
        boolean notfound = true;
        int round = 0;
        boolean fused = false;
        while (notfound) {
          if (round >= R) {
            break;
          }
          round++;
          // find the jump
          sum = 0;
          int p = 0;
          for (int i = 0; i < N; i++) {
            if (p + g[(i + start) % N] <= k) {
              sum += g[(i + start) % N];
              p += g[(i + start) % N];
            } else {
              int next = (i + start) % N;
              if (!fused) {
                if (step[next] > 0) {
                  int steps = step[start] - step[next] + 1;
                  long ssum = stepsum[start] - stepsum[next] + sum;
                  res += ((R - round) / steps) * ssum;
                  round += (R - round) / steps * steps;
                  fused = true;
                  // found
                } else {
                  step[next] = step[start] + 1;
                  stepsum[next] = stepsum[start] + sum;
                }
                start = next;
              }
              break;
            }
          }
          res += sum;
        }        
      }
      // here

      o = "Case #" + (ncase + 1) + ": " + res;
      if (out) {
        System.out.println(o);
      } else {
        writer.println(o);
      }

    }
    if (!out) {
      writer.flush();
      writer.close();
    }

  }

  public static void main(String[] args) throws IOException {
    C a = new C();
    a.doIt();
  }

}
