import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.text.DecimalFormat;


public class A {

  public void doIt() throws IOException {
    String className = this.getClass().getSimpleName();
    boolean small = true;
    boolean practice = false;
    boolean out = false;
    
    String fileName = className + "-" + (small ? "small" : "large")
        + (practice ? "-practice" : (small ? "-attempt0" : "")) + ".in";
    String outFileName = className + "-" + (small ? "small" : "large")
        + (practice ? "-practice" : (small ? "-attempt0" : "")) + ".out";
    BufferedReader reader = new BufferedReader(new InputStreamReader(this.getClass()
        .getResourceAsStream(fileName)));

    PrintWriter writer = null;

    if (!out) {
      writer = new PrintWriter(new FileWriter(outFileName));
    }

    String o = "";
    String res = "";
    String line = reader.readLine();
    int cases = Integer.parseInt(line);

    for (int ncase = 0; ncase < cases; ncase++) {
      line = reader.readLine();
      
      int N = Integer.parseInt(line);
      
      String[] z = new String[N];
      for (int i = 0; i < N; i++) {
        z[i] = reader.readLine();
      }
      
      double[] WP = new double[N];
      for (int i = 0; i < N; i++) {
        int win = 0;
        int lose = 0;
        for (int j = 0; j < N; j++) {
          if (z[i].charAt(j) == '1') {
            win++;
          }
          if (z[i].charAt(j) == '0') {
            lose++;
          }
        }
        WP[i] = (double) win / (double) (win + lose);
      }
      
      double[] OWP = new double[N];
      for (int k = 0; k < N; k++) {
        int games = 0;
        for (int i = 0; i < N; i++) {
          if (z[k].charAt(i) == '.') {
            continue;
          } else {
            games++;
          } 
          if (i == k) {
            continue;
          }
          int win = 0;
          int lose = 0;
          for (int j = 0; j < N; j++) {
            if (j == k) {
              continue;
            }
            if (z[i].charAt(j) == '1') {
              win++;
            } else if (z[i].charAt(j) == '0') {
              lose++;
            }
          }
          OWP[k] += (double) win / (double) (win + lose);
        }
        OWP[k] /= games;
      }
      double[] OOWP = new double[N];
      for (int k = 0; k < N; k++) {
        int games = 0;
        for (int i = 0; i < N; i++) {
          if (z[k].charAt(i) == '.') {
            continue;
          } else {
            games++;
          } 
          if (i == k) {
            continue;
          }
          OOWP[k] += OWP[i];
        }
        OOWP[k] /= games;
      }

      o = "Case #"+ (ncase + 1) + ":";
      if (out) {
        System.out.println(o);
      } else {
        writer.println(o);
      }
      for (int i = 0; i < N; i++) {
        double RPI = 0.25 * WP[i] + 0.50 * OWP[i] + 0.25 * OOWP[i];
        DecimalFormat df = new DecimalFormat("#.############");
        o = df.format(RPI);
        if (out) {
          System.out.println(o);
        } else {
          writer.println(o);
        }
      }

    }
    if (!out) {
      writer.flush();
      writer.close();
    }

  }

  public static void main(String[] args) throws IOException {
    A a = new A();
    a.doIt();
  }

}
