import java.io.BufferedReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.text.NumberFormat;


public class A {
  
  public void doIt() throws IOException {
    String className = this.getClass().getSimpleName();
    boolean small = true;
    boolean practice = false;
    String fileName = className + "-" + (small ? "small" : "large") + (practice ? "-practice" : (small ? "-attempt0" : "")) + ".in";
    String outFileName = className + "-" + (small ? "small" : "large") + (practice ? "-practice" : (small ? "-attempt0" : "")) + ".out";
    BufferedReader reader = new BufferedReader(new InputStreamReader(this.getClass().getResourceAsStream(fileName)));
    
    boolean out = false;
    PrintWriter writer = null;
    
    if (!out) {
      writer = new PrintWriter(new FileWriter(outFileName));
    }
    
    String o = "";
    
    String line = reader.readLine();
    int cases = Integer.parseInt(line);
    
    for (int ncase = 0; ncase < cases; ncase++) {
      line = reader.readLine();
      String tree = "";
      int decisionlines = Integer.parseInt(line);
      for (int decisionline = 0; decisionline < decisionlines; decisionline++) {
        line = reader.readLine();
        tree = tree + line + " ";
      }
      
      X x = getTree(tree);
      
      o = "Case #" + (ncase + 1) + ":";
      if (out) {
        System.out.println(o);
      } else {
        writer.println(o);
      }
      
      line = reader.readLine();
      int animals = Integer.parseInt(line);
      for (int animal = 0; animal < animals; animal++) {
        line = reader.readLine();
        String[] p = line.split(" ");
        String[] aa = new String[p.length - 2];
        for (int i = 0; i < aa.length; i++) {
          aa[i] = p[i + 2].trim();
        }
        
        double d = pass(x, aa);
        
        DecimalFormat df = new DecimalFormat("0.0000000");
        o = df.format(d);

        if (out) {
          System.out.println(o);
        } else {
          writer.println(o);
        }
        
      }
    }
    if (!out) {
      writer.flush();
      writer.close();
    }

  }
  
  private double pass(X x, String[] aa) {
    double d = 1;
    d = d * x.p;
    if (!"".equals(x.feature) && (x.feature != null)) {
      boolean has = false;
      for (int i = 0; i < aa.length; i++) {
        if (aa[i].equals(x.feature)) {
          has = true;
        }
      }
      if (has) {
        d = d * pass(x.one, aa);
      } else {
        d = d * pass(x.two, aa);
      }
    }
    return d;
  }

  private X getTree(String tree) {
    X x = new X();
    tree = tree.trim();
    String t = tree.substring(1, tree.length() - 1).trim();
    
    int k = t.indexOf(' ');
    if (k == -1) {
      x.p = Double.parseDouble(t);
      t = "";
    } else {
      x.p = Double.parseDouble(t.substring(0, k));
      t = t.substring(k).trim();
    }
    if (t.length() != 0) {
      if (t.charAt(0) != '(') {
        k = t.indexOf(' ');
        x.feature = t.substring(0, k).trim();
        t = t.substring(k).trim();
      }
      int z = 1;
      int zz = -1;
      for (int i = 1; i < t.length(); i++) {
        if (t.charAt(i) == '(') {
          z++;
        }
        if (t.charAt(i) == ')') {
          z--;
        }
        if (z == 0) {
          zz = i;
          break;
        }
      }
      
      x.one = getTree(t.substring(0, zz + 1));
      x.two = getTree(t.substring(zz + 1));
    }
    
    
    return x;
  }

  public static void main(String[] args) throws IOException {
    A a = new A();
    a.doIt();
  }
  
  class X {
    double p = 0;
    String feature = "";
    X one, two;
  }
}
