import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;


public class Main {
    private static long GCD(long a, long b) {
        if (b == 0) {
            return a;
        }
        return GCD(b, a % b);
    }
    
    private static long LCM(long a, long b) {
        return (a * b) / GCD(a, b);
    }
    
    private static long lcm(long[] array) {
        long result = array[0];
        for (int i = 1; i < array.length; i++) {
            result = (result * array[i]) / GCD(result, array[i]);
        }
        return result;
    }
    
    private static long gcd(long[] array) {
        long result = array[0];
        for (int i = 1; i < array.length; i++) {
            result = GCD(result, array[i]);
        }
        return result;
    }
    
    private static long getMin(long[] array) {
        long result = array[0];
        for (int i = 1; i < array.length; i++) {
            result = Math.min(result, array[i]);
        }
        return result;
    }
    
    private static long getMax(long[] array) {
        long result = array[1];
        for (int i = 1; i < array.length; i++) {
            result = Math.max(result, array[i]);
        }
        return result;
    }
    
    private static String solve(long A[], long min, long max) {
        if (A.length == 1) {
            long x = A[0];
            for (long i = min; i <= max && i <= x; i++) {
                if (x % i == 0) {
                    return Long.toString(i);
                }
            }
            return "NO";
        }
        
        long mn = Math.min(min, getMin(A));
        long mx = Math.min(max, getMax(A));
        
        for (long i = mn; i <= mx; i++) {
            int count = 0;
            for (int j = 0; j < A.length; j++) {
                if (A[j] % i == 0 || i % A[j] == 0) {
                    count++;
                }
            }
            if (count == A.length) {
                return Long.toString(i);
            }
        }
        
        Arrays.sort(A);
        long[][] L = new long[A.length][];
        long[][] G = new long[A.length][];
        
        for (int i = 0; i < A.length; i++) {
            L[i] = new long[A.length];
            G[i] = new long[A.length];
            
            L[i][i] = A[i];
            G[i][i] = A[i];
        }
        
        for (int i = 0; i < A.length; i++) {
            for (int j = i + 1; j < A.length; j++) {
                L[i][j] = LCM(L[i][j - 1], A[j]);
                G[i][j] = GCD(G[i][j - 1], A[j]);
            }
        }
        
        long gcd = gcd(A);
        
        long result = Integer.MAX_VALUE;
        
        if (gcd >= min && gcd <= max) {
            result = gcd;
        }
        
        int n = A.length - 1;
        for (int i = 0; i < n; i++) {
            if ((L[0][i] % G[i + 1][n] == 0 || G[i + 1][n] % L[0][i] == 0)) {
                long temp = Math.min(L[0][i], G[i + 1][n]);
                if (temp >= min && temp <= max) {
                    result = Math.min(result, temp);
                }
            }
        }
        if (result != Integer.MAX_VALUE) {
            return Long.toString(result);
        }
        if (min == 1) {
            return Integer.toString(1);
        }
        long lcm = lcm(A);
        
        if (lcm >= min && lcm <= max) {
            return Long.toString(lcm);
        }
        return "NO";
    }

    public static void main(String[] args) throws NumberFormatException, IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        
        int T = Integer.parseInt(reader.readLine());
        
        for (int i = 1; i <= T; i++) {
            StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
            
            int N = Integer.parseInt(tokenizer.nextToken());
            long L = Long.parseLong(tokenizer.nextToken());
            long H = Long.parseLong(tokenizer.nextToken());
            long A[] = new long[N];
            
            tokenizer = new StringTokenizer(reader.readLine());
            
            for (int j = 0; j < N; j++) {
                A[j] = Integer.parseInt(tokenizer.nextToken());
            }
            
            System.out.println("Case #" + i + ": " + solve(A, L, H));
        }
    }
}
