import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

class Main {
    
    private static String solve(int[][] a, int[][] b, String s) {
        StringBuffer result = new StringBuffer();
        
        char prev = ' ';
        for (int i = 0; i < s.length(); i++) {
            char curr = s.charAt(i);
            
            boolean combined = false;
            if (prev != ' ') {
                int x = curr - 'A';
                int y = prev - 'A';
                
                if (a[x][y] != -1) {
                    if (result.length() > 0) {
                        result.deleteCharAt(result.length() - 1);
                    }
                    prev = (char) (a[x][y] + 'A');
                    result.append(prev);
                    combined = true;
                }
            }
            
            if (!combined) {
                int x = curr - 'A';
                for (int j = 0; j < result.length(); j++) {
                    char tmp = result.charAt(j);
                    
                    int y = tmp - 'A';
                    
                    if (b[x][y] != -1) {
                        result = new StringBuffer();
                        prev = ' ';
                        combined = true;
                        break;
                    }
                }
            }
            
            if (!combined) {
                prev = curr;
                result.append(prev);
            }
        }
        return Arrays.toString(result.toString().toCharArray());
    }
    
    private static int[][] createGrid() {
        int[][] result = new int[26][];
        
        for (int i = 0; i < result.length; i++) {
            result[i] = new int[26];
            for (int j = 0; j < 26; j++) {
                result[i][j] = -1;
            }
        }
        return result;
    }
    
    public static void main(String[] args) throws NumberFormatException, IOException {
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(System.in));
        
        int T = Integer.parseInt(bufferedReader.readLine());
        
        for (int i = 1; i <= T; i++) {
            StringTokenizer tokenizer = new StringTokenizer(bufferedReader.readLine());

            int[][] a = createGrid();
            int[][] b = createGrid();
            
            int C = Integer.parseInt(tokenizer.nextToken());
            
            for (int j = 0; j < C; j++) {
                String s = tokenizer.nextToken();
                int x = (int) s.charAt(0) - 'A';
                int y = (int) s.charAt(1) - 'A';
                int z = (int) s.charAt(2) - 'A';
                
                a[x][y] = z;
                a[y][x] = z;
            }
            
            int D = Integer.parseInt(tokenizer.nextToken());
            
            for (int j = 0; j < D; j++) {
                String s = tokenizer.nextToken();

                int x = (int) s.charAt(0) - 'A';
                int y = (int) s.charAt(1) - 'A';

                b[x][y] = 1;
                b[y][x] = 1;
            }
            
            int N = Integer.parseInt(tokenizer.nextToken());
            
            String s = tokenizer.nextToken();
            
            System.out.println("Case #" + i + ": " + solve(a, b, s));
        }
    }
}
