import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class Main {
    private static double[] getWP(int[][] G) {
        double[] result = new double[G.length];
        for (int i = 0; i < G.length; i++) {
            double wins = 0;
            double losses = 0;
            for (int j = 0; j < G[i].length; j++) {
                if (G[i][j] == 1) {
                    wins++;
                } else if (G[i][j] == 0) {
                    losses++;
                }
            }
            result[i] = wins / (wins + losses);
        }
        return result;
    }
    
    private static double[] getOWP(int[][] G) {
        double[] result = new double[G.length];
        for (int index = 0; index < G.length; index++) {
            double sum = 0.0;
            int count = 0;
            for (int i = 0; i < G.length; i++) {
                if (G[i][index] != -1) {
                    double wins = 0;
                    double losses = 0;
                    for (int j = 0; j < G[i].length; j++) {
                        if (j != index) {
                            if (G[i][j] == 0) {
                                losses++;
                            } else if (G[i][j] == 1) {
                                wins++;
                            }
                        }
                    }
                    sum += wins / (wins + losses);
                    count++;
                }
            }
            result[index] = sum / count;
        }
        return result;
    }
    
    private static double[] getOOWP(int[][] G, double[] OWP) {
        double[] result = new double[OWP.length];
        
        for (int i = 0; i < OWP.length; i++) {
            double sum = 0.0;
            int count = 0;
            for (int j = 0; j < OWP.length; j++) {
                if (G[i][j] != -1) {
                    sum += OWP[j];
                    count++;
                }
            }
            result[i] = sum / count;
        }
        return result;
    }
    
    private static void solve(int[][] G) {
        double[] WP = getWP(G);
        double[] OWP = getOWP(G);
        double[] OOWP = getOOWP(G, OWP);
        
        for (int i = 0; i < WP.length; i++) {
            double RPI = 0.25 * WP[i] + 0.50 * OWP[i] + 0.25 * OOWP[i];
            System.out.println(RPI);
        }
    }
    
    public static void main(String[] args) throws NumberFormatException, IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        
        int T = Integer.parseInt(reader.readLine());
        
        for (int i = 1; i <= T; i++) {
            int N = Integer.parseInt(reader.readLine());
            
            int G[][] = new int[N][];
            for (int j = 0; j < N; j++) {
                G[j] = new int[N];
                String text = reader.readLine();
                for (int k = 0; k < text.length(); k++) {
                    char ch = text.charAt(k);
                    
                    if (ch == '1') {
                        G[j][k] = 1;
                    } else if (ch == '0') {
                        G[j][k] = 0;
                    } else {
                        G[j][k] = -1;
                    }
                }
            }
            System.out.println("Case #" + i + ":");
            solve(G);
        }
    }
}