import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Main {
    private static double getMaxTime(int[] D) {
        double total = 0.0;
        for (int i = 0; i < D.length; i++) {
            total += D[i];
        }
        return total * 2;
    }
    private static long solve(int L, long T, int[] D) {
        double actualTime = getMaxTime(D);
        
        if (actualTime < T) {
            return (int) actualTime;
        }
        double boostDistance = T * 0.5;
        double distance = 0.0;
        int index = 0;
        while (distance < boostDistance && index < D.length) {
            if (distance + D[index] > boostDistance) {
                break;
            }
            distance += D[index];
            index++;
        }
        
        double[] ND = new double[D.length - index];
        int j = 0;
        if (boostDistance != distance) {
            ND[j++] = D[index] + distance - boostDistance;
            index++;
        }
        for (int k = index; k < D.length; k++, j++) {
            ND[j] = D[k];
        }
        Arrays.sort(ND);
        for (int i = ND.length - 1; i >= 0 && L > 0; i--, L--) {
            actualTime -= ND[i];
        }
        return (long) actualTime;
    }
    
    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(System.in));
        
        int T = Integer.parseInt(reader.readLine());
        
        for (int i = 1; i <= T; i++) {
            StringTokenizer tokenizer = new StringTokenizer(reader.readLine());
            int L = Integer.parseInt(tokenizer.nextToken());
            long t = Long.parseLong(tokenizer.nextToken());
            int N = Integer.parseInt(tokenizer.nextToken());
            int C = Integer.parseInt(tokenizer.nextToken());
            int a[] = new int[C];
            for (int j = 0; j < C; j++) {
                a[j] = Integer.parseInt(tokenizer.nextToken());
            }
            int[] D = new int[N];
            for (int j = 0; j < N; j++) {
                D[j] = a[j % C]; 
            }
            System.out.println("Case #" + i + ": " + solve(L, t, D));
        }
    }
}
