package qualification2017;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;


public class Small1B {
    private static void solveProblem(String input) throws IOException {
	List<String> lines = readFile(input);
	List<String> outputLines = new ArrayList<String>();
	int index = 0;
	int testCases = getInt(lines.get(index++));
	String result = null;
	for(int t = 0; t < testCases; t++) {
	    String[] tokens = lines.get(index++).split(" ");
	    String N = tokens[0];
	    result = findMax(N);
	    String testCaseOutput = "Case #" + (t+1) + ": " + result;
	    System.out.println(testCaseOutput);
	    outputLines.add(testCaseOutput);
	}
	String output = getTokenSeparatedString(outputLines, "\n");
	writeFile(output, input.replace(".in", ".out"));
    }

    private static String findMax(String N) {
	
	char[] chars = N.toCharArray();
	for(int i = N.length()-1; i >= 1; i--) {
	    char curr = chars[i];
	    char prev = chars[i-1];
	    if(curr >= prev) {
		continue;
	    }
	    for(int j = i; j < chars.length; j++) {
		chars[j] = '9';
	    }
	    if(chars[i-1] == '0') {
		chars[i-1] = (char)(prev - 1);
	    }else {
		chars[i-1] = (char) (prev - 1);
	    }
	}
	String result = new String(chars);
	while(result.startsWith("0")) {
	    result = result.substring(1);
	}
	return result;
    }



    public static void print(int[] arr) {
	StringBuffer buf = new StringBuffer("[");
	for(int curr: arr) {
	    buf = buf.append(curr).append(" ");
	}
	buf.append("]");
	System.out.println(buf);
    }

    public static void print(long[] arr) {
	StringBuffer buf = new StringBuffer("[");
	for(long curr: arr) {
	    buf = buf.append(curr).append(" ");
	}
	buf.append("]");
	System.out.println(buf);
    }

    public static String replace(String sourceString, String replace, String with) {
	if (sourceString == null || replace == null || with == null || replace.equals(with)) {
	    return sourceString;
	}
	StringBuilder buf = new StringBuilder(sourceString.length());
	int start = 0, end = 0;
	while ((end = sourceString.indexOf(replace, start)) != -1) {
	    buf.append(sourceString.substring(start, end)).append(with);
	    start = end + replace.length();
	}
	buf.append(sourceString.substring(start));
	return buf.toString();
    }

    private static int getInt(String str) {
	return Integer.parseInt(str);
    }

    private static List<String> readFile(String fileName) throws IOException {
	BufferedReader reader = new BufferedReader(new FileReader(fileName));
	String line = null;
	List<String> lines = new ArrayList<String>();
	while((line = reader.readLine()) != null) {
	    lines.add(line);
	}
	reader.close();
	return lines;
    }

    private static void writeFile(String text, String fileName) throws IOException {
	FileWriter writer = new FileWriter(fileName);
	writer.write(text);
	writer.close();
    }

    private static String getTokenSeparatedString(Collection<?> listValues, String token) {
	StringBuilder strValue = new StringBuilder("");
	if (listValues != null) {
	    int i = 0;
	    for (Object v : listValues) {
		String value = v.toString();
		if (i == 0) {
		    strValue.append(value);
		} else {
		    strValue.append(token);
		    strValue.append(value);
		}
		i++;
	    }
	}
	return strValue.toString();
    }

    public static List<String> getValueAsList(String valueStr, String delim) {
	List<String> values = new ArrayList<String>();
	if (valueStr != null) {
	    int lastIndex = 0;
	    int currIndex = 0;
	    while ((currIndex = valueStr.indexOf(delim, lastIndex)) != -1) {
		String value = valueStr.substring(lastIndex, currIndex);
		if (value.trim().length() != 0) {
		    values.add(value.trim());
		}
		lastIndex = currIndex + delim.length();
	    }
	    String value = valueStr.substring(lastIndex);
	    if (value.trim().length() != 0) {
		values.add(value.trim());
	    }
	}
	return values;
    }

    public static void main(String[] args) {
	try {
	    solveProblem("B-small-attempt0.in");
	}catch(Exception ex) {
	    ex.printStackTrace();
	}
    }


}
