import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;


public class Problem1C {
    private static Map<String, String> grid = new HashMap<String, String>();
    private static HashSet<String> istr = new HashSet<String>();
    private static HashSet<String> jstr = new HashSet<String>();
    private static HashSet<String> kstr = new HashSet<String>();
    private static void initGrid(){
	grid.put("1", "1");
	grid.put("-1", "-1");
	grid.put("i", "i");
	grid.put("j", "j");
	grid.put("k", "k");
	grid.put("-i", "-i");
	grid.put("-j", "-j");
	grid.put("-k", "-k");
	grid.put("11", "1");
	grid.put("-11", "-1");
	grid.put("1i", "i");
	grid.put("-1i", "-i");
	grid.put("1j", "j");
	grid.put("-1j", "-j");
	grid.put("1k", "k");
	grid.put("-1k", "-k");
	grid.put("ii", "-1");
	grid.put("-ii", "1");
	grid.put("ij", "k");
	grid.put("-ij", "-k");
	grid.put("ik", "-j");
	grid.put("-ik", "j");
	grid.put("ji", "-k");
	grid.put("-ji", "k");
	grid.put("jj", "-1");
	grid.put("-jj", "1");
	grid.put("jk", "i");
	grid.put("-jk", "-i");
	grid.put("ki", "j");
	grid.put("-ki", "-j");
	grid.put("kj", "-i");
	grid.put("-kj", "i");
	grid.put("kk", "-1");
	grid.put("-kk", "1");
    }
	
    private static void solveProblem(String input) throws IOException {
	initGrid();
	List<String> lines = readFile(input);
	List<String> outputLines = new ArrayList<String>();
	int index = 0;
	int testCases = getInt(lines.get(index++));
	for(int t = 0; t < testCases; t++) {
	    String[] tokens = lines.get(index++).split(" ");
	    boolean possible = false;
	    int length = getInt(tokens[0]);
	    int multiply = getInt(tokens[1]);
	    String line = lines.get(index++);
	    StringBuffer buf = new StringBuffer( length * multiply);
	    for(int x = 0; x < multiply; x++) {
		buf.append(line);
	    }
	    String str = buf.toString();
	    int iIndex = getChar(str, "i", 0, false);
	    System.out.println("iIndex: " + iIndex);
	    if(iIndex != -1) {
		int jIndex = getChar(str, "j", iIndex+1, false);
		System.out.println("jIndex: " + jIndex);
		if(jIndex != -1) {
		    int kIndex = getChar(str, "k", jIndex+1, true);
		    System.out.println("kIndex: " + kIndex);
		    if(kIndex == str.length()-1) {
			possible = true;
		    }
		}
	    }
	    String testCaseOutput = "Case #" + (t+1) + ": " + (possible ? "YES" : "NO");
	    System.out.println(testCaseOutput);
	    outputLines.add(testCaseOutput);
	}
	String output = getTokenSeparatedString(outputLines, "\n");
	writeFile(output, input.replace(".in", ".out"));
    }

    private static int getChar(String str, String findChar, int startIndex, boolean last) {
	if(startIndex >= str.length()) {
	    return -1;
	}
	int index = -1;
	String currStr = "";
	for(int i = startIndex; i < str.length(); i++) {
	    currStr += str.charAt(i);
	    System.out.println(currStr + "\t" + grid.get(currStr));
	    currStr = grid.get(currStr);
	    if(currStr.equals(findChar)) {
		index = i;
		if(!last) {
		    break;
		}
	    }
	}
	return index;
    }
    
    public static void print(int[] arr) {
	StringBuffer buf = new StringBuffer("[");
	for(int curr: arr) {
	    buf = buf.append(curr).append(" ");
	}
	buf.append("]");
	System.out.println(buf);
    }

    public static String replace(String sourceString, String replace, String with) {
	if (sourceString == null || replace == null || with == null || replace.equals(with)) {
	    return sourceString;
	}
	StringBuilder buf = new StringBuilder(sourceString.length());
	int start = 0, end = 0;
	while ((end = sourceString.indexOf(replace, start)) != -1) {
	    buf.append(sourceString.substring(start, end)).append(with);
	    start = end + replace.length();
	}
	buf.append(sourceString.substring(start));
	return buf.toString();
    }

    private static int getInt(String str) {
	return Integer.parseInt(str);
    }

    private static List<String> readFile(String fileName) throws IOException {
	BufferedReader reader = new BufferedReader(new FileReader(fileName));
	String line = null;
	List<String> lines = new ArrayList<String>();
	while((line = reader.readLine()) != null) {
	    lines.add(line);
	}
	reader.close();
	return lines;
    }

    private static void writeFile(String text, String fileName) throws IOException {
	FileWriter writer = new FileWriter(fileName);
	writer.write(text);
	writer.close();
    }

    private static String getTokenSeparatedString(Collection<?> listValues, String token) {
	StringBuilder strValue = new StringBuilder("");
	if (listValues != null) {
	    int i = 0;
	    for (Object v : listValues) {
		String value = v.toString();
		if (i == 0) {
		    strValue.append(value);
		} else {
		    strValue.append(token);
		    strValue.append(value);
		}
		i++;
	    }
	}
	return strValue.toString();
    }

    public static List<String> getValueAsList(String valueStr, String delim) {
	List<String> values = new ArrayList<String>();
	if (valueStr != null) {
	    int lastIndex = 0;
	    int currIndex = 0;
	    while ((currIndex = valueStr.indexOf(delim, lastIndex)) != -1) {
		String value = valueStr.substring(lastIndex, currIndex);
		if (value.trim().length() != 0) {
		    values.add(value.trim());
		}
		lastIndex = currIndex + delim.length();
	    }
	    String value = valueStr.substring(lastIndex);
	    if (value.trim().length() != 0) {
		values.add(value.trim());
	    }
	}
	return values;
    }

    public static void main(String[] args) {
	try {
	    //solveProblem("input.in");
	    solveProblem("C-small-attempt1.in");
	}catch(Exception ex) {
	    ex.printStackTrace();
	}
    }


}
