package round2016A;

import java.io.*;
import java.util.*;

public class CoinJam {
    public static void solveProblem(String inputFileName) throws IOException {
	Scanner sc = new Scanner(new File(inputFileName));
	List<String> outputs = new ArrayList<String>();
	int caseCount = sc.nextInt();
	int N = sc.nextInt();
	int J = sc.nextInt();
	long[] primeNumbers = generatePrimes();
	long startNumber = (long)(Math.pow(2, N-1)) + 1;
	long endNumber = (long)(Math.pow(2,N))-1;
	
	List<String> values = new ArrayList<String>();
	for(long i = startNumber; i <= endNumber; i++) {
	    String binary = Long.toBinaryString(i);
	    if(!binary.endsWith("1")) {
		continue;
	    }
	    List<String> factors = new ArrayList<String>();
	    factors.add(binary);
	    //System.out.println(binary);
	    boolean isOk = true;
	    for(int r = 2; r <= 10; r++) {
		long rValue = (long)Math.pow(r, N-1) + Long.valueOf(binary.substring(16), r);
		//System.out.println(r + ":" + rValue);
		isOk = false;
		for(int p = 0; p < primeNumbers.length; p++) {
		    long prime = primeNumbers[p];
		    if(prime == rValue) {
			continue;
		    }
		    if(rValue % prime == 0) {
			factors.add(String.valueOf(prime));
			isOk = true;
			//System.out.println("Prime: " + prime);
			break;
		    }
		}
		if(!isOk) {
		    break;
		}
	    }
	    if(isOk) {
		values.add(getTokenSeparatedString(factors, " "));
		System.out.println(values.size() + "\t"+ getTokenSeparatedString(factors, " "));
		if(values.size() >= J) {
		    break;
		}
	    }
	}
	outputs.add("\n" + getTokenSeparatedString(values, "\n"));
	writeOutput(outputs, inputFileName);
    }

    public static long[] generatePrimes(){ 
	int N = 100000000;
	// initially assume all integers are prime
	boolean[] isPrime = new boolean[N + 1];
	for (int i = 2; i <= N; i++) {
	    isPrime[i] = true;
	}

	// mark non-primes <= N using Sieve of Eratosthenes
	for (int i = 2; i*i <= N; i++) {

	    // if i is prime, then mark multiples of i as nonprime
	    // suffices to consider mutiples i, i+1, ..., N/i
	    if (isPrime[i]) {
		for (int j = i; i*j <= N; j++) {
		    isPrime[i*j] = false;
		}
	    }
	}

	// count primes
	int primes = 0;
	for (int i = 2; i <= N; i++) {
	    if (isPrime[i]) primes++;
	}
	long primeNumbers[] = new long[primes];
	int c = 0;
	for (int i = 2; i <= N; i++) {
	    if (isPrime[i]) {
		primeNumbers[c++] = i;
	    }
	}
	//System.out.println("The number of primes <= " + N + " is " + primes);
	return primeNumbers;
    }


    private static String getTokenSeparatedString(Collection<?> listValues, String token) {
   	StringBuilder strValue = new StringBuilder("");
   	if (listValues != null) {
   	    int i = 0;
   	    for (Object v : listValues) {
   		String value = v.toString();
   		if (i == 0) {
   		    strValue.append(value);
   		} else {
   		    strValue.append(token);
   		    strValue.append(value);
   		}
   		i++;
   	    }
   	}
   	return strValue.toString();
       }
    
    private static void writeOutput(List<String> outputs, String inputFileName) throws IOException {
	StringBuilder builder = new StringBuilder();
	for(int i = 0; i < outputs.size(); i++) {
	    builder.append("Case #" + (i+1)+ ": " + outputs.get(i));
	    if(i != outputs.size() -1) {
		builder.append("\n");
	    }
	}
	System.out.println(builder.toString());
	String outFileName = inputFileName.replace(".in", ".out");
	FileWriter writer = new FileWriter(outFileName);
	writer.write(builder.toString());
	writer.close();
    }

    public static void main(String args[]) throws IOException {
	solveProblem("input.in");
    }



}
