import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;


public class Problem1B {
    private static void solveProblem(String input) throws IOException {
	List<String> lines = readFile(input);
	List<String> outputLines = new ArrayList<String>();
	int index = 0;
	int testCases = getInt(lines.get(index++));
	for(int t = 0; t < testCases; t++) {
	    int dinerCount = getInt(lines.get(index++));
	    String[] tokens = lines.get(index++).split(" ");
	    int[] panCakes = new int[dinerCount];
	    for(int i = 0; i < tokens.length; i++) {
		panCakes[i] = getInt(tokens[i]);
	    }
	    int minuteNeeded = getMinuteNeeded(panCakes);
	    String testCaseOutput = "Case #" + (t+1) + ": " + minuteNeeded;
	    print(panCakes);
	    System.out.println(testCaseOutput);
	    outputLines.add(testCaseOutput);
	}
	String output = getTokenSeparatedString(outputLines, "\n");
	writeFile(output, input.replace(".in", ".out"));
    }

    private static int getMinuteNeeded(int[] pancakes) {
	int[] max = max(pancakes);
	int minuteNeeded = max[0];
	int minuteNeededIndex = max[1];
	//System.out.println("**********");
	//print(pancakes);
	if(minuteNeeded <= 3) {
	    return minuteNeeded;
	}
	int half = minuteNeeded / 2;
	if(minuteNeeded == 9) {
	    half = getSplit(pancakes);
	}
	int[] splitPanCakes = Arrays.copyOf(pancakes, pancakes.length + 1);
	splitPanCakes[splitPanCakes.length-1] = half;
	splitPanCakes[minuteNeededIndex] = splitPanCakes[minuteNeededIndex] - half;
	int[] reduced = reduceOne(pancakes);
	int splitMinuteNeeded = max(splitPanCakes)[0];
	int reducedMinute = max(reduced)[0];
	int min = Math.min(splitMinuteNeeded, reducedMinute);
	//System.out.println(pancakes);
	if(min <= 3) {
	    return min + 1;
	}
	return Math.min(getMinuteNeeded(splitPanCakes), getMinuteNeeded(reduced)) + 1;
    }

    //handle special 9 case
    private static int getSplit(int[] pancakes) {
	int nines = 0;
	for(int c: pancakes) {
	    if(c == 9) {
		nines++;
	    }else if(c > 3 && c < 6) {
		return 5;
	    }
	    if(nines > 1) {
		return 5;
	    }
	}
	return 3;
    }

    /*
     * Utility methods.
     */

    private static int[] reduceOne(int[] arr) {
	int[] arrCopy = Arrays.copyOf(arr, arr.length);
	for(int i = 0; i < arrCopy.length; i++) {
	    arrCopy[i] = Math.max(arrCopy[i] - 1, 0);
	}
	return arrCopy;
    }

    private static int[] max(int[] arr) {
	int max = arr[0];
	int index = 0;
	for(int i = 0; i < arr.length; i++) {
	    if(arr[i] > max) {
		index = i;
		max = arr[i];
	    }
	}
	return new int[]{max, index};
    }

    public static void print(int[] arr) {
	StringBuffer buf = new StringBuffer("[");
	for(int curr: arr) {
	    buf = buf.append(curr).append(" ");
	}
	buf.append("]");
	System.out.println(buf);
    }

    public static String replace(String sourceString, String replace, String with) {
	if (sourceString == null || replace == null || with == null || replace.equals(with)) {
	    return sourceString;
	}
	StringBuilder buf = new StringBuilder(sourceString.length());
	int start = 0, end = 0;
	while ((end = sourceString.indexOf(replace, start)) != -1) {
	    buf.append(sourceString.substring(start, end)).append(with);
	    start = end + replace.length();
	}
	buf.append(sourceString.substring(start));
	return buf.toString();
    }

    private static int getInt(String str) {
	return Integer.parseInt(str);
    }

    private static List<String> readFile(String fileName) throws IOException {
	BufferedReader reader = new BufferedReader(new FileReader(fileName));
	String line = null;
	List<String> lines = new ArrayList<String>();
	while((line = reader.readLine()) != null) {
	    lines.add(line);
	}
	reader.close();
	return lines;
    }

    private static void writeFile(String text, String fileName) throws IOException {
	FileWriter writer = new FileWriter(fileName);
	writer.write(text);
	writer.close();
    }

    private static String getTokenSeparatedString(Collection<?> listValues, String token) {
	StringBuilder strValue = new StringBuilder("");
	if (listValues != null) {
	    int i = 0;
	    for (Object v : listValues) {
		String value = v.toString();
		if (i == 0) {
		    strValue.append(value);
		} else {
		    strValue.append(token);
		    strValue.append(value);
		}
		i++;
	    }
	}
	return strValue.toString();
    }

    public static List<String> getValueAsList(String valueStr, String delim) {
	List<String> values = new ArrayList<String>();
	if (valueStr != null) {
	    int lastIndex = 0;
	    int currIndex = 0;
	    while ((currIndex = valueStr.indexOf(delim, lastIndex)) != -1) {
		String value = valueStr.substring(lastIndex, currIndex);
		if (value.trim().length() != 0) {
		    values.add(value.trim());
		}
		lastIndex = currIndex + delim.length();
	    }
	    String value = valueStr.substring(lastIndex);
	    if (value.trim().length() != 0) {
		values.add(value.trim());
	    }
	}
	return values;
    }

    private static void compareFiles() throws IOException {
	String[] files = {"B-small-attempt0.in", "B-small-attempt1.in", "B-small-attempt2.in", "B-small-attempt3.in"};
	Set<String> duplicates = new HashSet<String>();
	Set<String> all = new HashSet<String>();
	boolean first = true;
	for(String file: files){
	    List<String> lines = readFile(file);
	    List<String> tokens = new ArrayList<String>();
	    for(int i = 2; i < lines.size(); i+=2) {
		String line = lines.get(i);
		tokens.add(line);
	    }
	    if(first) {
		duplicates.addAll(tokens);
		first = false;
	    }else {
		duplicates.retainAll(tokens);
	    }
	    System.out.println(duplicates.size());
	}
	for(String token: duplicates) {
	    System.out.println(token.split(" ").length);
	    System.out.println(token);
	}
    }

    public static void main(String[] args) {
	try {
	    solveProblem("B-small-attempt4.in");
	    //compareFiles();
	}catch(Exception ex) {
	    ex.printStackTrace();
	}
    }


}
