package round2016A;

import java.io.*;
import java.util.*;

public class CountingSheep {
    public static void solveProblem(String inputFileName) throws IOException {
	Scanner sc = new Scanner(new File(inputFileName));
	List<String> outputs = new ArrayList<String>();
	int caseCount = sc.nextInt();
	for(int i = 0; i < caseCount; i++) {
	    long result = getLastNumber(sc.nextLong());
	    if(result == -1) {
		outputs.add("INSOMNIA");
	    }else {
		outputs.add(String.valueOf(result));
	    }
	}
	
	writeOutput(outputs, inputFileName);
    }

    
    public static long getLastNumber(long input) {
	if(input == 0) {
	    return -1;
	}
	boolean[] found = new boolean[10];
	return checkNextNumber(input, input, found);
    }
    
    public static long checkNextNumber(long input, long lastNumber, boolean[] found) {
	char[] chars = String.valueOf(lastNumber).toCharArray();
	for(char c: chars) {
	    found[c - '0'] = true;
	}
	if(isDone(found)) {
	    return lastNumber;
	}
	return checkNextNumber(input, lastNumber + input, found);
    }
    
    public static boolean isDone(boolean[] found) {
	for(boolean b: found) {
	    if(!b) {
		return false;
	    }
	}
	return true;
    }
    private static void writeOutput(List<String> outputs, String inputFileName) throws IOException {
	StringBuilder builder = new StringBuilder();
	for(int i = 0; i < outputs.size(); i++) {
	    builder.append("Case #" + (i+1)+ ": " + outputs.get(i));
	    if(i != outputs.size() -1) {
		builder.append("\n");
	    }
	}
	System.out.println(builder.toString());
	String outFileName = inputFileName.replace(".in", ".out");
	FileWriter writer = new FileWriter(outFileName);
	writer.write(builder.toString());
	writer.close();
    }

    public static void main(String args[]) throws IOException {
	solveProblem("A-small-attempt0.in");
    }
}
