package round2016A;

import java.io.*;
import java.util.*;

public class PanCakes {
    public static void solveProblem(String inputFileName) throws IOException {
	Scanner sc = new Scanner(new File(inputFileName));
	List<String> outputs = new ArrayList<String>();
	int caseCount = sc.nextInt();
	sc.nextLine();
	for(int i = 0; i < caseCount; i++) {
	    String input = sc.nextLine();
	    char[] chars = input.toCharArray();
	    boolean[] cakes = new boolean[chars.length];
	    for(int c = 0; c < chars.length; c++) {
		if(chars[c] == '+') {
		    cakes[c] = true;
		}
	    }
	    int result = getOptimal(cakes, cakes.length);
	    outputs.add(String.valueOf(result));
	}
	writeOutput(outputs, inputFileName);
    }

    
    public static int getOptimal(boolean[] cakes, int count){
	if(count == 0) {
	    return 0;
	}
	if(cakes[count-1]) {
	    return getOptimal(cakes, count -1);
	}else {
	    if(!cakes[0]) {
		flip(cakes, count);
		return getOptimal(cakes, count -1) +1;
	    }else {
		int plusCountFromTop = 0;
		for(int i = 0; i < cakes.length; i++) {
		    if(!cakes[i]) {
			break;
		    }
		    plusCountFromTop++;
		}
		flip(cakes, plusCountFromTop);
		flip(cakes, count);
		return getOptimal(cakes, count - plusCountFromTop) + 2;
	    }
	}
	
    }
    
    public static void flip(boolean cakes[], int n) {
	for(int i = 0; i < n / 2; i++) {
	    boolean t = cakes[i];
	    int ri = n - i -1;
	    cakes[i] = !cakes[ri];
	    cakes[ri] = !t;
	}
	if( n % 2 == 1) {
	    cakes[n / 2] = !cakes[n / 2];
	}
    }
    
   
    private static void writeOutput(List<String> outputs, String inputFileName) throws IOException {
	StringBuilder builder = new StringBuilder();
	for(int i = 0; i < outputs.size(); i++) {
	    builder.append("Case #" + (i+1)+ ": " + outputs.get(i));
	    if(i != outputs.size() -1) {
		builder.append("\n");
	    }
	}
	System.out.println(builder.toString());
	String outFileName = inputFileName.replace(".in", ".out");
	FileWriter writer = new FileWriter(outFileName);
	writer.write(builder.toString());
	writer.close();
    }

    public static void main(String args[]) throws IOException {
	solveProblem("B-large.in");
    }
}
