package main;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.Time;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class MainPooling {
	private static List<TrainEvent> aTimeTable;
	private static List<TrainEvent> bTimeTable;
	private static List<TrainEvent> allTrains;


	
	private static long minutesInMillis(int i) { 
		return i * 1000 * 60;
	}


	
	/**
	 * @param args
	 * @throws IOException
	 * @throws NumberFormatException
	 */
	public static void main(String[] args) throws NumberFormatException,
			IOException {

		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

		String line;

		int nCases = Integer.parseInt(in.readLine());

		for (int c = 1; c <= nCases; c++) {
			int turnaround = Integer.parseInt(in.readLine());
			line = in.readLine();
	
			String[] A = line.split("\\s+");

			int NA = Integer.parseInt(A[0]);
			int NB = Integer.parseInt(A[1]);

			aTimeTable = new ArrayList<TrainEvent>();
			bTimeTable = new ArrayList<TrainEvent>();
			for (int i = 0; i < NA; i++) {
				line = in.readLine();

				A = line.split("\\s+");
				aTimeTable.add(new TrainEvent(Time.valueOf(A[0] + ":00"), 1));
				bTimeTable.add(new TrainEvent (new Time (Time.valueOf(A[1] + ":00").getTime() 
							+ minutesInMillis(turnaround)), 0));
			}
			
			
			for (int i = 0; i < NB; i++) {
				line = in.readLine();

				A = line.split("\\s+");
				bTimeTable.add(new TrainEvent(Time.valueOf(A[0] + ":00"), 1));
				aTimeTable.add(new TrainEvent (new Time (Time.valueOf(A[1] + ":00").getTime() 
							+ minutesInMillis(turnaround)), 0));
			}

			allTrains = new ArrayList<TrainEvent>();
			allTrains.addAll(aTimeTable);
			allTrains.addAll(bTimeTable);

			
			
			Collections.sort(aTimeTable, new byTime());
			Collections.sort(bTimeTable, new byTime());
			
			System.out.print("Case #" + c + ":");
			
			int poolA = 0;
			int poolB = 0;
			
			int startA = 0;
			int startB = 0;
			
			for(TrainEvent t : aTimeTable) {
				if(t.type == 0) { // arrival
					poolA++;
				}
				
				if(t.type == 1) { // departure;
					if(poolA > 0) poolA--;
					else startA++;
				}
				//System.out.println(t.time + " " + t.type);
			}

			for(TrainEvent t : bTimeTable) {
				if(t.type == 0) { // arrival
					poolB++;
				}
				
				if(t.type == 1) { // departure;
					if(poolB > 0) poolB--;
					else startB++;
				}
			}
			
			System.out.println( " " + startA + " " + startB);
		} 
	}
}
