package main;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;

public class MainTrees {

	
	static int integer(String line) {
		return Integer.parseInt(line);
	}
	
	static BigInteger bigInteger(String line) {
		return new BigInteger(line);
	}
	
	static final BigInteger bigOne = new BigInteger("1");
	static final BigInteger bigZero = new BigInteger("0");
	
	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		// TODO Auto-generated method stub
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		
		int nCases = integer(in.readLine());
		String line;
		for(int c = 1; c <= nCases;c++) {
			line = in.readLine();
			String[] A = line.split("\\s+");
			
			int m = integer(A[0]);
			int v = integer(A[1]);
			
			TreeNode[] tree = new TreeNode[m];
			for(int i = 0 ; i < m ; i++) {
				tree[i] = new TreeNode(in.readLine());
			}
			
			for(int i = tree.length -1; i >= 0; i--) {
				if(tree[i].leaf == true) {
					if(tree[i].value == 1) {
						tree[i].changesToBeOne = 0;
						tree[i].changesToBeZero = -1;
					} else {
						tree[i].changesToBeOne = -1;
						tree[i].changesToBeZero = 0;							
					}
				} else {
					if( ! tree[i].changeable) {
						if(tree[i].and) {
							tree[i].changesToBeOne = andOne(tree, i);
							tree[i].changesToBeZero = andZero(tree, i);
						} else {
							tree[i].changesToBeOne = orOne(tree, i);
							
							int ret = orZero(tree, i);
							tree[i].changesToBeZero = ret;
						}							
					} else {
						int andZero = andZero(tree,i);
						int andOne = andOne(tree,i);
						
						int orZero = orZero(tree,i);
						int orOne = orOne(tree,i);

						
						if(tree[i].and) { 
							if(orZero != -1) orZero++;
							if(orOne != -1)orOne++;
						} else {
							if(andZero != -1)andZero++;
							if(andOne != -1)andOne++;
						}
						
						if( orZero == -1) {
							tree[i].changesToBeZero = andZero;
						} else if(andZero == -1) {
							tree[i].changesToBeZero = orZero;
						} else{
							tree[i].changesToBeZero = Math.min(andZero, orZero);			
						}
						
						if(orOne == -1) {
							tree[i].changesToBeOne = andOne;
						} else if(andOne == -1) {
							tree[i].changesToBeOne = orOne;
						} else {
							tree[i].changesToBeOne = Math.min(andOne, orOne);
						}
				
					}
				}
				
				
			}
			
			if(v == 1) {
				if (tree[0].changesToBeOne == -1) {
					System.out.println("Case #" + c + ": IMPOSSIBLE");
				} else {
					System.out.println("Case #" + c + ": " + tree[0].changesToBeOne);
				}
			} else {
				if(tree[0].changesToBeZero == -1) {
					System.out.println("Case #" + c + ": IMPOSSIBLE");
				}else {
					System.out.println("Case #" + c + ": " + tree[0].changesToBeZero);
				}
			}
		}
	}

	private static int orZero(TreeNode[] tree, int i) {
		int ret =0;
		if(tree[i*2+1].changesToBeZero == -1 || tree[i*2+2].changesToBeZero == -1 ) {
			ret = -1;
		} else {
			ret = tree[i*2+1].changesToBeZero + tree[i*2+2].changesToBeZero;
		}
		return ret;
	}

	private static int orOne(TreeNode[] tree, int i) {
		if(tree[i*2+1].changesToBeOne == -1 && tree[i*2+2].changesToBeOne == -1) {
			return -1;
		} else if(tree[i*2+2].changesToBeOne == -1) {
			return tree[i*2+1].changesToBeOne;
		} else if(tree[i*2+1].changesToBeOne == -1){
			return tree[i*2+2].changesToBeOne;
		} else {
			return Math.min(tree[i*2+1].changesToBeOne, tree[i*2+2].changesToBeOne);
		}
	}

	private static int andZero(TreeNode[] tree, int i) {
		if(tree[i*2+1].changesToBeZero == -1) {
			return tree[i*2+2].changesToBeZero;
		} else if(tree[i*2+2].changesToBeZero == -1) {
			return tree[i*2+1].changesToBeZero;
		} else {
			return Math.min(tree[i*2+1].changesToBeZero, tree[i*2+2].changesToBeZero);
		}
	}

	private static int andOne(TreeNode[] tree, int i) {
		if(tree[i*2+1].changesToBeOne == -1 ||tree[i*2+2].changesToBeOne == -1) {
			return -1;
		} else {
			return tree[i*2+1].changesToBeOne + tree[i*2+2].changesToBeOne;
		}
	}

}
