package main;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class MainEngines {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		
		int numC = Integer.parseInt(in.readLine());
		
		for(int c = 1; c <= numC; c++) {
			int numEngineNames = Integer.parseInt(in.readLine());
			String[] engines = new String[numEngineNames];
			
			Map<String, Integer> engineMap = new HashMap<String,Integer>();
			
			System.err.println("Case #" + c);
			System.err.println("Engines:");
			for(int i = 0; i < numEngineNames; i++) { 
				engines[i] = in.readLine();
				System.err.println(engines[i] + "("  + i+")");
				engineMap.put(engines[i],i);
			}
			
			List<Integer> queries = new ArrayList<Integer>();
			
			int nQueries = Integer.parseInt(in.readLine());
			
			System.err.println("Queries:");
			for(int i = 0; i < nQueries;i++) {
				String line = in.readLine();
				Integer engine = engineMap.get(line);
				if( engine != null) {
					queries.add(engine);
				} else {
					System.err.println("OhNO!");
				}
				System.err.println(i + " "+ line + " (" + engine +")");
			}
			int changes = 0;
			for(int i =0; i < queries.size();i++) {
				int[] positions = new int[numEngineNames];
				for(int e = 0 ; e < numEngineNames;e++) {
					positions[e] = 2000;
				}
				
				int found = 0;
				int lookFrom = i;
				while(found < numEngineNames && lookFrom < queries.size()) {
					if(positions[queries.get(lookFrom)] == 2000) {
						positions[queries.get(lookFrom)] = lookFrom;
						found++;
					}
					lookFrom++;
				}
				int max = 0;
				for(int p = 0; p < numEngineNames;p++) {
					if(positions[p] > max) {
						max = positions[p];
					}
				}
				
				if(max != 2000) {
					System.err.println("Changing at " + i + " to " + engines[queries.get(max)]);
					changes++;
				}
				i = max -1;
			}
			System.out.println("Case #"+c+": " + changes);
			
		}
	}

}
