import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

public class Tic_Tac_Toe_Tomek
{
	char [][] board;
	public static void main(String[] args) throws Exception 
	{
		new Tic_Tac_Toe_Tomek().solve();
	}

	private void solve() throws Exception 
	{
		String text;
		String inputFile = "A-small-attempt0.in";
		Scanner in = new Scanner(new File(inputFile)); 
		PrintWriter out = new PrintWriter(new FileWriter(inputFile+".out"),true);
		board = new char[4][4];
		int numCases = in.nextInt();
		for(int j=0; j<numCases; j++)
		{
			boolean boardFilled = true;
			for(int x=0; x<4; x++)
			{
				String row=in.next();
				board[x]=row.toCharArray();
				if(row.contains("."))
					boardFilled=false;
			}
			if(checkWinner('X'))
				text="X won";
			else if(checkWinner('O'))
				text="O won";
			else if(boardFilled)
				text="Draw";
			else
				text="Game has not completed";
			out.println("Case #" + (j+1) + ": " + text);
		}
		in.close();
		out.close();
	}
	
	private boolean checkWinner(char c)
	{
		for(int x=0; x<4; x++) 
		for(int y=0; y<4; y++) 
		for(int xdir : new int[]{-1,0,1})
		for(int ydir : new int[]{-1,0,1})
		{
			if(xdir == 0 && ydir == 0) continue;
			int xpos=x;
			int ypos=y;
			int count=0;
			while(xpos>=0 && xpos<4 && ypos>=0 && ypos<4 && 
					(board[xpos][ypos]==c || board[xpos][ypos]=='T'))
			{
				if(++count == 4)
					return true;
				xpos+=xdir;
				ypos+=ydir;
			}
		}
		return false;
	}
}
