import java.io.BufferedReader;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.HashSet;
import java.util.StringTokenizer;

public class FairAndSquare {

	HashMap<Long,Long> set = new HashMap<Long,Long>();
	
	private void init()
	{
		long bigNum2=(long)Math.pow(10, 7);
		long count=0;
		for(long i=1L;i<=bigNum2;i++)
		{

			String val = String.valueOf(i);

			int size = val.length();
			if (checkIfFullPalindrome(i, size)) {
				set.put(i, ++count);
			}
		}
	}

	
	
	private static boolean checkIfFullPalindrome(long val, int size) {
		if(checkIfPalindrome(String.valueOf( val),size ))
		{
			long squre=(long)Math.pow(val, 2);
			String val1=String.valueOf(squre);
			if(checkIfPalindrome(val1,val1.length()))
			{
				return true;
			}
		}
		
		return false;
	}
	
	
	private static boolean checkIfPalindrome(String val, int size) {
		for(int k=0;k<(size/2);k++)
		{
			if(val.charAt(k)!=val.charAt(size-(k+1)))
			{
				return false;
			}
			
		}
		return true;
	}
	
	
	
	public static void main(String args[]) throws IOException {
		BufferedReader bufferedReader = new BufferedReader(
				new InputStreamReader(System.in));
		FairAndSquare andSquare=new FairAndSquare();
		andSquare.init();
		String line = bufferedReader.readLine();
		FileWriter fileWriter=new FileWriter(new File("G:\\output.txt"));
		int T = Integer.valueOf(line);
		for (int t = 0; t < T; t++) {

			line = bufferedReader.readLine();
			StringTokenizer stringTokenizer=new StringTokenizer(line);
			
			//Double.
			long longVal1= (long)Math.ceil( Math.sqrt(Double.valueOf(stringTokenizer.nextToken())));
			long longVal2=(long) Math.sqrt(Double.valueOf(stringTokenizer.nextToken()));
			
			
			long nearest=findClosestPalindromeUpwards(longVal1,longVal2);
			if(nearest==0)
			{
				fileWriter.write("Case #" + (t + 1) + ": 0\n");
				//System.out.println("Case #" + (t + 1) + ": 0");
			}else
			{
				long farthest=findClosestPalindromeDownwards(longVal1,longVal2);
				
				fileWriter.write("Case #" + (t + 1) + ": "+(andSquare.set.get(farthest)-andSquare.set.get(nearest)+1)+"\n");
				//System.out.println("Case #" + (t + 1) + ": "+(andSquare.set.get(farthest)-andSquare.set.get(nearest)+1));
			}
			
			
		}

		fileWriter.close();
	}

	private static long findClosestPalindromeDownwards(long longVal1,
			long longVal2) {
		for(;longVal2>=longVal1;longVal2--)
		{
			String val = String.valueOf(longVal2);

			int size = val.length();
			if (checkIfFullPalindrome(longVal2, size)) {
				
				return longVal2;
			}
		}
		return 0;

		
	}

	private static long findClosestPalindromeUpwards(long longVal1,
			long longVal2) {
		for(;longVal1<=longVal2;longVal1++)
		{
			String val = String.valueOf(longVal1);

			int size = val.length();
			if (checkIfFullPalindrome(longVal1, size)) {
				
				return longVal1;
			}
		}
		return 0;
	}

	private static long findRootOf(BigInteger bigInteger) {
		
		return 0;
	}

}
