import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Calendar;
import java.util.Date;
import java.util.Scanner;

public class Minesweeper {
    
    static PrintWriter print;
    static String[][] map;
    
    public static void main(String [] args) throws Exception {
        
        Scanner input = new Scanner(new File("C:\\Users\\Atif_2\\Documents\\t33.in"));
        print = new PrintWriter(new FileWriter("C:\\Users\\Atif_2\\Documents\\t9.out"));
        
        int cases = Integer.parseInt(input.nextLine().trim());
       
        
        for(int i = 0; i < cases; i++) {
            
           String [] vals  = input.nextLine().trim().split((" "));
           
           map = new String [Integer.parseInt(vals[0])][Integer.parseInt(vals[1])];
           
           String [] mines = new String[Integer.parseInt(vals[1])];
           
           for(int s = 0; s < mines.length; s++) {
               mines[s] = "*";
           }
           
           for(int si = 0; si < map.length; si++) {
               for(int j = 0; j < map[si].length; j++) {
                   map[si][j] = ".";
               }
           }
           
           int x = Integer.parseInt(vals[2]);
           
           int rows = x / Integer.parseInt(vals[1]);
           int extra = x % Integer.parseInt(vals[1]);
           
           for(int e0 = 0; e0 < rows; e0++) {
               map[e0] = mines;
           }
           
           for(int d = 0; d < extra; d++) {
               map[rows][d] = "*";
           }
           
           algorithim(i+1);
        }
        
        print.close();
    }
    
    static int od;
    
    public static void algorithim(int pos) {
        
        int x = map.length - 1;
        int y = map[0].length - 1;
        
        if(map.length >= 2) {
            boolean one = moreDetermination(x, pos);
            
            if(one == false)
                return;
            
            boolean two = moreDetermination(x-1, pos);
        
            if(two == false)
                return;
        }
        
        if(!evenMoreDetermination(pos))
            return;
        
        if(map[x][y].equals("*")) {
            print.println("Case #" + pos + ":");
            print.println("Impossible");
            return;
        }
        
        map[x][y] = "c";
        
        od = pos;
        
        if(determine(x+1, y).equals("1")) {
            return;
        } else if(determine(x+1, y+1).equals("1")) {
            return;
        } else if(determine(x+1, y-1).equals("1")) {
            return;
        } else if(determine(x, y+1).equals("1")) {
            return;
        } else if(determine(x, y-1).equals("1")) {
            return;
        } else if(determine(x-1,y+1).equals("1")) {
            return;
        } else if(determine(x-1,y-1).equals("1")) {
            return;
        } else if(determine(x-1,y).equals("1")) {
            return;
        } else {
            print.println("Case #" + pos + ":");
            for(int si = 0; si < map.length; si++) {
               
               for(int j = 0; j < map[si].length; j++) {
                   print.print(map[si][j] + " ");
               }
               print.println("");
           }
        }
    }
    
    public static String determine(int x, int y) {
        
        try {
            String s = map[x][y];
            
            if(s.equals("*")) {
                print.println("Case #" + od + ":");
                print.println("Impossible");
                return "1";
            }
        } catch(Exception e) {
            return "0";
        }
        
        return "-1";
    }
    
    public static boolean moreDetermination(int x, int pos) {
        
        String full = "";
        String hurrah = "";
        
        for(String s: map[x]) {
            full += s;
        }
        
        for(int d = 0; d < map[0].length; d++) {
            hurrah += ".";
        }
        if(!full.equals(hurrah)) {
            print.println("Case #" + pos + ":");
            print.println("Impossible");
            return false;
        }
        
        return true;
    }
    
    static boolean evenMoreDetermination(int pos) {
        
        for(int i = 0; i < map.length - 1; i++) {
            for(int j = 0; j < map[i].length - 1; j++) {
                
                String leftTop = map[i][j];
                String leftBottom = map[i+1][j];
                String rightTop = map[i][j+1];
                String rightBottom = map[i+1][j+1];
                
                String total = leftTop + leftBottom + rightTop + rightBottom;
                
                if(total.equals("*...") && j == map[i].length - 2)   {
                    print.println("Case #" + pos + ":");
                    print.println("Impossible");
                return false;
                }   
                    
            }
        }
        
        return true;
    }
}
