//package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class FairAndSquare {

	private File inputFile = new File("C-large1-attempt.in");
	private File outputFile = new File("C-small-attempt12.out");
	
	FileReader reader;
	BufferedReader bufReader;
	FileWriter writer;
	BufferedWriter buffWriter;
	
	private int numCases;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FairAndSquare t = new FairAndSquare();
		t.generateOutput();

	}

	private void generateOutput() {
		try {
			reader = new FileReader(inputFile);
			writer = new FileWriter(outputFile);
			bufReader = new BufferedReader(reader);
			buffWriter = new BufferedWriter(writer);
			
			String caseLine = bufReader.readLine();
			numCases = Integer.parseInt(caseLine);
			
			ArrayList<Long> fns = new ArrayList<Long>();
			long minNum = 1;
			long maxNum = (long)Math.floor(Math.sqrt(100000000000000L));
			
			for(long num = 1; num <= maxNum; num++){
				
				if(IsPalindrome(num + "")){
					long square = num * num;
					if(IsPalindrome(square + "")){
						//System.out.println(num + " " + square + " ");
						fns.add(square);
					}
				}
			}
			
			int positives = 0;

			for(int i=1; i<= numCases; i++){
				
					caseLine = bufReader.readLine();
					positives = 0;
					String[] limits = caseLine.split(" ");
					minNum = Long.parseLong(limits[0]);
					maxNum = Long.parseLong(limits[1]);
					
					for(long num : fns){
						if(num >= minNum && num <= maxNum){
							positives++;
						}
					}
					
					//System.out.println("Case #" + i + ": " + positives);
					buffWriter.write("Case #" + i + ": " + positives);
					buffWriter.newLine();
			}
		
			//buffWriter.write("Case #" + caseNum + ": " + valueMap.get(nextValDiff) + " " + (i + 1));
			//buffWriter.newLine();
			
			buffWriter.close();	writer.close();
			bufReader.close();	reader.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	boolean IsPalindrome(String s) {
		int stringLength = s.length();
		int halfStringLength = stringLength;
	    for (int i = 0; i < halfStringLength; i++)
	    {
	        if (s.charAt(i) != s.charAt(stringLength - 1 - i)) return false;
	    }
	    return true;
	}

}
