//package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TicTacToeTomek {

	private File inputFile = new File("A-small-attempt1.in");
	//private File inputFile = new File("A-small-practice.in");
	private File outputFile = new File("A-small-attempt1.out");
	
	FileReader reader;
	BufferedReader bufReader;
	FileWriter writer;
	BufferedWriter buffWriter;
	
	private int numCases;
	
	private final String XWON = "X won";
	private final String OWON = "O won";
	private final String DRAW = "Draw";
	private final String INCOMPLETE = "Game has not completed";
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		TicTacToeTomek t = new TicTacToeTomek();
		t.generateOutput();

	}

	private void generateOutput() {
		try {
			reader = new FileReader(inputFile);
			writer = new FileWriter(outputFile);
			bufReader = new BufferedReader(reader);
			buffWriter = new BufferedWriter(writer);
			
			String caseLine = bufReader.readLine();
			numCases = Integer.parseInt(caseLine);

			char[][] ttt = new char[4][4];
			//int lineCount = 1;

			for(int i=1; i<= numCases; i++){
				
				for(int j = 0; j< 4;  j++){
					caseLine = bufReader.readLine();
					ttt[j] = caseLine.toCharArray();
					//System.out.println(lineCount + ". " + caseLine);
					//lineCount++;
				}
				String result = this.checkGameCondition(ttt);
				//System.out.println("Case #" + i + ": " + result);
				buffWriter.write("Case #" + i + ": " + result);
				buffWriter.newLine();
				caseLine = bufReader.readLine();
				//this.initialize(caseLine);
			}
		
			//buffWriter.write("Case #" + caseNum + ": " + valueMap.get(nextValDiff) + " " + (i + 1));
			//buffWriter.newLine();
			
			buffWriter.close();	writer.close();
			bufReader.close();	reader.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private String checkGameCondition(char[][] ttt) {
		String line;
		boolean markIncomplete = false;
		for(int i = 0; i< 4; i++){
			line = String.copyValueOf(ttt[i]);
			if(xWin(line)){
				return XWON;
			} else if(oWin(line)){
				return OWON;
			} else if(line.contains(".")){
				markIncomplete = true;
			}
		}
		
		for(int i =0; i< 4; i++){
			line = "" + ttt[0][i] + ttt[1][i] + ttt[2][i] + ttt[3][i];
			if(xWin(line)){
				return XWON;
			} else if(oWin(line)){
				return OWON;
			}
		}
		
		line = "" + ttt[0][0] + ttt[1][1] + ttt[2][2] + ttt[3][3];
		if(xWin(line)){
			return XWON;
		} else if(oWin(line)){
			return OWON;
		}
		
		line = "" + ttt[0][3] + ttt[1][2] + ttt[2][1] + ttt[3][0];
		if(xWin(line)){
			return XWON;
		} else if(oWin(line)){
			return OWON;
		}
		
		if(markIncomplete){
			return INCOMPLETE;
		} else {
			return DRAW;
		}
	}
	
	private boolean xWin(String str){
		if(str.equals("TXXX") || str.equals("XTXX") || 
				str.equals("XXTX") || str.equals("XXXT") ||
				str.equals("XXXX")){
			return true;
		}
		return false;
	}

	private boolean oWin(String str){
		if(str.equals("TOOO") || str.equals("OTOO") || 
				str.equals("OOTO") || str.equals("OOOT") ||
				str.equals("OOOO")){
			return true;
		}
		return false;
	}
}
