//package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class FairAndSquare {

	private File inputFile = new File("C-small-attempt0.in");
	private File outputFile = new File("C-small-attempt0.out");
	
	FileReader reader;
	BufferedReader bufReader;
	FileWriter writer;
	BufferedWriter buffWriter;
	
	private int numCases;
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FairAndSquare t = new FairAndSquare();
		t.generateOutput();

	}

	private void generateOutput() {
		try {
			reader = new FileReader(inputFile);
			writer = new FileWriter(outputFile);
			bufReader = new BufferedReader(reader);
			buffWriter = new BufferedWriter(writer);
			
			String caseLine = bufReader.readLine();
			numCases = Integer.parseInt(caseLine);
			
			Pattern p = Pattern.compile("\\.0*([1-9])+");
			
			int positives = 0;
			for(int i=1; i<= numCases; i++){
				
					caseLine = bufReader.readLine();
					positives = 0;
					String[] limits = caseLine.split(" ");
					int minNum = Integer.parseInt(limits[0]);
					int maxNum = Integer.parseInt(limits[1]);
					
					for(int num = minNum; num <= maxNum; num++){
						Double sqrt = Math.sqrt(num);
						String str = sqrt.toString();
						Matcher m = p.matcher(str);
						if(m.find()){
							//System.out.println(num + "pattern found");
						} else {
							str = str.substring(0, str.indexOf("."));
							if(IsPalindrome(num+"") && IsPalindrome(str)){
								//System.out.println(num + "inside");
								positives++;
							}
						}
					}
					
					//System.out.println("Case #" + i + ": " + positives);
					buffWriter.write("Case #" + i + ": " + positives);
					buffWriter.newLine();
				//this.initialize(caseLine);
			}
		
			//buffWriter.write("Case #" + caseNum + ": " + valueMap.get(nextValDiff) + " " + (i + 1));
			//buffWriter.newLine();
			
			buffWriter.close();	writer.close();
			bufReader.close();	reader.close();
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	boolean IsPalindrome(String s) {
		int stringLength = s.length();
		int halfStringLength = stringLength;
	    for (int i = 0; i < halfStringLength; i++)
	    {
	        if (s.charAt(i) != s.charAt(stringLength - 1 - i)) return false;
	    }
	    return true;
	}

}
