import java.util.*;
import java.io.*;

public class TidyNumbers {
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(
				System.in)));
		int size = in.nextInt();
		int[] nums = new int[size];
		for (int i = 0; i < size; ++i) {
			nums[i] = in.nextInt();
		}
		in.close();

		int[] tidy = findTidyNumbers(nums);

		try {
			Writer writer = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream("output.txt"), "UTF-8"));
			for (int i = 0; i < size; ++i) {
				writer.write("Case #" + (i + 1) + ": " + tidy[i]+"\n");
			}
			writer.close();
		} catch (UnsupportedEncodingException e) {
			System.out.println("Caught Exception");
		} catch (FileNotFoundException e) {
			System.out.println("Caught Exception");
		} catch (IOException e) {
			System.out.println("Caught Exception");
		}

	}

	private static int[] findTidyNumbers(int[] nums) {
		int[] tidy = new int[nums.length];
		for (int i = 0; i < nums.length; ++i) {
			tidy[i] = findTidy(nums[i]);
		}
		return tidy;
	}

	private static int findTidy(int num) {
		boolean isTidy = false;
		for (int i = num; i > 0; i--) {
			int curr = i;
			if (curr < 10) {
				return i;
			}
			int digit = 0;
			int prevDigit = curr % 10;
			curr = curr / 10;

			while (curr >= 0) {
				digit = curr % 10;
				if (digit <= prevDigit) {
					isTidy = true;
				} else {
					isTidy = false;
					break;
				}

				if (isTidy && curr < 10) {
					return i;
				}

				prevDigit = digit;
				curr = curr / 10;
			}

			if (curr <= prevDigit && isTidy && curr < 10) {
				return i;
			}
		}
		return num;
	}
}