import java.util.*;
import java.io.*;

public class BathroomStalls {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int size = in.nextInt();
		Stall[] stalls = new Stall[size];
		for (int i = 0; i < size; ++i) {
			long n = in.nextLong();
			long k = in.nextLong();
			stalls[i] = new Stall(n, k);
		}
		in.close();

		Stall[] ans = findLsRs(stalls);

		try {
			Writer writer = new BufferedWriter(new OutputStreamWriter(
					new FileOutputStream("output.txt"), "UTF-8"));
			for (int i = 0; i < size; ++i) {
				long max, min = 0;
				if (ans[i].ls >= ans[i].rs) {
					max = ans[i].ls;
					min = ans[i].rs;
				} else {
					max = ans[i].rs;
					min = ans[i].ls;
				}
				writer.write("Case #" + (i + 1) + ": " + max + " " + min + "\n");
			}
			writer.close();
		} catch (UnsupportedEncodingException e) {
			System.out.println("Caught Exception");
		} catch (FileNotFoundException e) {
			System.out.println("Caught Exception");
		} catch (IOException e) {
			System.out.println("Caught Exception");
		}
	}

	private static Stall[] findLsRs(Stall[] stalls) {
		Stall[] ans = new Stall[stalls.length];
		for (int i = 0; i < stalls.length; ++i) {
			ans[i] = getLsRs(stalls[i]);
		}
		return ans;
	}

	private static Stall getLsRs(Stall stall) {
		Deque<Long> queue = new LinkedList<Long>();
		queue.add(stall.n);
		for (long i = 0; i < stall.k - 1; i++) {
			long val = queue.poll();

			if (val % 2 == 0 && val >= 1) {
				if (queue.size() > 0) {
					long min = queue.peekLast();
					int count = 0;
					while (queue.peekLast() < (val / 2)
							&& queue.peekLast() != null) {
						count++;
						queue.removeLast();
					}
					queue.add(val / 2);
					while (count > 0) {
						queue.add(min);
						count--;
					}
				} else {
					queue.add(val / 2);
				}
			} else {
				queue.add((val - 1) / 2);
			}
			queue.add((val - 1) / 2);
		}
		long val = queue.poll();
		if (val % 2 == 0 && val >= 1) {
			queue.add(val / 2);
		} else {
			queue.add((val - 1) / 2);
		}
		queue.add((val - 1) / 2);
		stall.ls = queue.removeLast();
		stall.rs = queue.removeLast();
		return stall;
	}

}