package com.qualifiers;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class CoinJam {

  public static void getPrimes(List<BigInteger> primes) {
    BigInteger zero = new BigInteger("0");
    primes.add(new BigInteger("2"));
    for (int i = 3; i < 100000; i++) {
      boolean found = false;

      BigInteger num = new BigInteger("" + i);

      for (BigInteger p : primes) {


        if (num.mod(p).equals(zero)) {
          found = true;
          break;
        }
      }

      if (!found) {
        primes.add(num);
      }
    }

  }

  public static String getNumberInBase2(long num) {
    String val = "";
    while (num > 0) {
      val += num % 2;
      num /= 2;
    }
    return val;
  }

  public static BigInteger numberInBaseN(String num, int n) {
    BigInteger ans = new BigInteger("0");
    char[] digits = num.toCharArray();
    for (int i = digits.length - 1; i >= 0; i--) {
      ans = ans.add(new BigInteger("" + (digits[i] - '0') * (long) Math.pow(n, digits.length - 1 - i)));
    }
    return ans;
  }

  public static void main(String[] args) {
    BigInteger zero = new BigInteger("0");
    List<BigInteger> primes = new ArrayList<>();
    getPrimes(primes);

    try (InputStreamReader isr = new InputStreamReader(new FileInputStream("inputs/CSmall.txt")); BufferedReader br = new BufferedReader(isr);) {
      int t = Integer.parseInt(br.readLine()); // always 1, still taken for expandablity
      for (int i = 0; i < t; i++) {
        String[] nj = br.readLine().split(" ");
        int n = Integer.parseInt(nj[0]);
        int j = Integer.parseInt(nj[1]);
        long max = (long) Math.pow(2, n) - 1;


        long numStart = (long) ((max + 1) / 2) + 1; // move to more than half of num to avoid 0s in start
        // for 6 digit : 33 -> 63

        outer: for (; numStart <= max && !primes.contains(numStart) && j > 0; numStart += 2) { // move by 2 to avoid 0s
                                                                                               // in end
          // ; also j contains numbers
          // left && noPrime for base 10


          String num = getNumberInBase2(numStart);

          String divisors = num;

          for (int k = 2; k <= 10; k++) {
            // divide and get the details
            BigInteger myNumInBaseX = numberInBaseN(num, k);
            boolean found = false;
            long divisor = 1;
            for (BigInteger p : primes) {
              if (myNumInBaseX.mod(p).equals(zero)) {
                found = true;
                divisor = p.longValue();
                break;
              }
            }
            if (divisor == 1 || myNumInBaseX.equals(new BigInteger(divisor + ""))) {
              continue outer;
            } else {
              divisors += " " + divisor;
            }
          }
          System.out.println(divisors);
          j--;
        }
      }
    } catch (Exception ex) {
    }

  }

}
