package codejam.start;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.TreeSet;

public class Dijkstra {
	private static Map<MultiKey, String> map = new HashMap<MultiKey, String>();

	public static void main(String ar[]) throws NumberFormatException, IOException {
		// initialize the quaternions table.
		initializeQuaternioin();
		BufferedReader br = new BufferedReader(new FileReader("C-small-attempt1.in"));
		int testCases = Integer.parseInt(br.readLine());
		String str = "";
		for(int i = 0; i< testCases; i++) {
			String inputLX = br.readLine(); //taking value of L X
			String inputArray[] = inputLX.split(" ");
			String inputString = br.readLine();
			String newInputString="";
			for(int j = 0 ; j < Integer.parseInt(inputArray[1]); j++) {
				newInputString = newInputString + inputString;
			}
			String result = getResultAfterParsing(newInputString);
			str += "Case #" + (i + 1) + ": " + result + "\n";
		}
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.txt"));
		writer.write(str);
		br.close();
		writer.close();
	}

	private static String getResultAfterParsing(String inputString) {
		String inputStringArray[] = inputString.split("");
		inputStringArray = removeEmptyValueFromArray(inputStringArray);
		String newKey = "";
		List<Integer> iCount = new LinkedList<>();
		Set<Integer> jCount = new TreeSet<Integer>();
		// iterating for i
		for (int i = 0; i < inputStringArray.length; i++) {
			if (i == 0) {
				if (inputStringArray[i].equals("i")) {
					iCount.add(i + 1);
				}
				newKey = inputStringArray[i];
				continue;
			}
			newKey = getValueFromQuaternioinTable(newKey, inputStringArray[i]);
			if (newKey.equals("i")) {
				iCount.add(i + 1);
			}
		}
		// iterating for j
		if (!iCount.isEmpty()) {
			int firstValueOfI = iCount.get(0);
			for (int j = firstValueOfI; j < inputStringArray.length; j++) {
				if (j == firstValueOfI) {
					if (inputStringArray[j].equals("j")) {
						jCount.add(j + 1);
					}
					newKey = inputStringArray[j];
					continue;
				}
				newKey = getValueFromQuaternioinTable(newKey,
						inputStringArray[j]);
				if (newKey.equals("j")) {
					jCount.add(j + 1);
				}
			}
		}
		List<Integer> jCountList = new ArrayList<Integer>(jCount);
		Collections.sort(jCountList, Collections.reverseOrder());
		// Iterating for k
		if (!jCountList.isEmpty()) {
			int firstValueOfJ = jCountList.get(0);
			for (int k = firstValueOfJ; k < inputStringArray.length; k++) {
				if (k == firstValueOfJ) {
					if (inputStringArray[k].equals("k")
							&& (k == (inputStringArray.length - 1))) {
						return "YES";
					}
					newKey = inputStringArray[k];
					continue;
				}
				newKey = getValueFromQuaternioinTable(newKey,
						inputStringArray[k]);
				if (newKey.equals("k") && (k == (inputStringArray.length - 1))) {
					return "YES";
				}
			}
		}
		return "NO";
	}

	private static String[] removeEmptyValueFromArray(String[] inputArray) {
		ArrayList<String> inputArrayList = new ArrayList<String>(Arrays.asList(inputArray));
		inputArrayList.remove(inputArrayList.indexOf(""));
		String[] newArray = new String[inputArrayList.size()];
		inputArrayList.toArray(newArray);
		return newArray;
	}

	private static String getValueFromQuaternioinTable(String key1, String key2) {
		String hyphenContainer = "";
		if(key1.contains("-")) {
			hyphenContainer += "-";
			key1=key1.replace("-", "");
		}
		if(key2.contains("-")) {
			hyphenContainer += "-";
			key2=key2.replace("-", "");
		}
		String valueToReturn = map.get(new MultiKey(key1.charAt(0), key2.charAt(0)));
		// appending the old existing hyphens.
		valueToReturn = hyphenContainer + valueToReturn;
		// Replacing two consecutive hyphens by empty value.
		valueToReturn = valueToReturn.replace("--", "");
		return valueToReturn;
	}

	private static final void initializeQuaternioin() {
		map.put(new MultiKey('1', '1'), "1");
		map.put(new MultiKey('1', 'i'), "i");
		map.put(new MultiKey('1', 'j'), "j");
		map.put(new MultiKey('1', 'k'), "k");

		map.put(new MultiKey('i', '1'), "i");
		map.put(new MultiKey('i', 'i'), "-1");
		map.put(new MultiKey('i', 'j'), "k");
		map.put(new MultiKey('i', 'k'), "-j");

		map.put(new MultiKey('j', '1'), "j");
		map.put(new MultiKey('j', 'i'), "-k");
		map.put(new MultiKey('j', 'j'), "-1");
		map.put(new MultiKey('j', 'k'), "i");

		map.put(new MultiKey('k', '1'), "k");
		map.put(new MultiKey('k', 'i'), "j");
		map.put(new MultiKey('k', 'j'), "-i");
		map.put(new MultiKey('k', 'k'), "-1");
	}
}

class MultiKey {

	private final Character key1;
	private final Character key2;

	public MultiKey(Character key1, Character key2) {
		this.key1 = key1;
		this.key2 = key2;
	}

	@Override
	public boolean equals(Object o) {
		if (this == o)
			return true;
		if (!(o instanceof MultiKey))
			return false;
		MultiKey key = (MultiKey) o;
		return key1 == key.key1 && key2 == key.key2;
	}

	@Override
	public int hashCode() {
		int result = key1;
		result = 31 * result + key2;
		return result;
	}

}

