package com.nkt.evaluator;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class MineSweeper {

	static PrintWriter out;
	static BufferedReader in;

	public static void breaknums(String s, List<Integer> l) {
		String[] strs = s.split(" ");
		for (String str : strs)
			l.add(Integer.parseInt(str));
	}

	static void PrintNewLine(String s) {
		if (s == "newline")
			out.println();
		else
			out.println(s);
	}

	static void justPrint(String s) {
		out.print(s);
	}

	public static void main(String args[]) throws IOException {
		in = new BufferedReader(new FileReader("C-small-attempt3.in"));
		// Scanner in = new Scanner(in);
		out = new PrintWriter(new FileWriter("Csmalloutput3.txt"));

		String text;

		text = in.readLine();
		int times = Integer.parseInt(text);
		for (int k = 1; k <= times; k++) {
			PrintNewLine("Case #" + k + ":");
			List<Integer> l = new ArrayList<Integer>();

			text = in.readLine();
			breaknums(text, l);

			int r = l.get(0);
			int c = l.get(1);
			int m = l.get(2);

			if (r == 1) {
				if (m > c - 2)
					PrintNewLine("Impossible");
				else
					drawRow(c, m);
			} else if (c == 1) {
				if (m > r - 2)
					PrintNewLine("Impossible");
				else
					drawColumn(r, m);
			} else {
				if (m > r * c - 4)
					PrintNewLine("Impossible");
				else
					drawBoard(r, c, m);
			}

		}

		in.close();
		out.close();

	}

	private static void drawBoard(int r, int c, int m) {
		int dots = r * c - m - 4;
		for (int i = 0; i < r; i++) {
			for (int j = 0; j < c; j++) {
				if (i == 0 && j == 0)
					justPrint("c");
				else if (i == 0 && j == 1 || i == 1 && j == 0 || i == 1
						&& j == 1)
					justPrint(".");
				else if (dots-- > 0) {
					justPrint(".");
				} else
					justPrint("*");
			}
			PrintNewLine("newline");
		}
	}

	private static void drawColumn(int r, int m) {
		for (int i = 0; i < r; i++) {
			if (i == 0)
				PrintNewLine("c");
			else if (i >= r - m)
				PrintNewLine("*");
			else
				PrintNewLine(".");
		}
	}

	private static void drawRow(int c, int m) {
		for (int i = 0; i < c; i++) {
			if (i == 0)
				justPrint("c");
			else if (i >= c - m)
				justPrint("*");
			else
				justPrint(".");

		}
		PrintNewLine("newline");
	}
}