package com.nkt.cj;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

public class bullseye {

	public static BigInteger bigIntSqRootFloor(BigInteger x)
			throws IllegalArgumentException {
		if (x.compareTo(BigInteger.ZERO) < 0) {
			throw new IllegalArgumentException("Negative argument.");
		}
		// square roots of 0 and 1 are trivial and
		// y == 0 will cause a divide-by-zero exception
		if (x == BigInteger.ZERO || x == BigInteger.ONE) {
			return x;
		} // end if
		BigInteger two = BigInteger.valueOf(2L);
		BigInteger y;
		// starting with y = x / 2 avoids magnitude issues with x squared
		for (y = x.divide(two); y.compareTo(x.divide(y)) > 0; y = ((x.divide(y))
				.add(y)).divide(two))
			;
		return y;
	} // end bigIntSqRootFloor

	public static BigInteger bigIntSqRootCeil(BigInteger x)
			throws IllegalArgumentException {
		if (x.compareTo(BigInteger.ZERO) < 0) {
			throw new IllegalArgumentException("Negative argument.");
		}
		// square roots of 0 and 1 are trivial and
		// y == 0 will cause a divide-by-zero exception
		if (x == BigInteger.ZERO || x == BigInteger.ONE) {
			return x;
		} // end if
		BigInteger two = BigInteger.valueOf(2L);
		BigInteger y;
		// starting with y = x / 2 avoids magnitude issues with x squared
		for (y = x.divide(two); y.compareTo(x.divide(y)) > 0; y = ((x.divide(y))
				.add(y)).divide(two))
			;
		if (x.compareTo(y.multiply(y)) == 0) {
			return y;
		} else {
			return y.add(BigInteger.ONE);
		}
	} // end bigIntSqRootCeil

	public static void main(String args[]) throws IOException {

		BufferedReader in = new BufferedReader(new FileReader(
				"A-large.in"));
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));

		String text;

		text = in.readLine();
		int times = Integer.parseInt(text);

		for (int k = 1; k <= times; k++) {
			text = in.readLine();
			String[] rt = text.split(" ");

			String r = rt[0];
			String t = rt[1];

			BigInteger rint = new BigInteger(r);
			BigInteger tint = new BigInteger(t);

			BigInteger ans = bigIntSqRootFloor(rint.multiply(rint).add(
					((tint.add(new BigInteger("1")))).multiply(new BigInteger(
							"2")))).subtract(rint).divide(new BigInteger("2"));

			out.println("Case #" + k + ":" + " " + ans);
		}

		in.close();
		out.close();

	}
}
