package com.company;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collection;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

/**
 * Created by ankur.srivastava on 09/04/17.
 */
public class StallSimulation {

    FileInputStream fin;
    Writer fop;

    public static void main(String[] args) throws IOException {
        new StallSimulation().execute();
    }

    private void execute() throws IOException {
        fin = new FileInputStream("ip1.txt");
        fop = new FileWriter("op1.txt");

        Scanner s = new Scanner(fin);
        int n = s.nextInt();
        int caseNum = 1;
        for (int i = 1; i <=n ; i++){
            fop.write("Case #" + caseNum++ + ": ");
           process(s.nextLong(), s.nextLong());


        }
        fin.close();
        fop.flush();
        fop.close();
    }

    private void process(long stalls, long people) throws IOException {
        System.out.println(stalls +  ": "  + people);

        int[] allStalls = new int[(int)stalls+2];
        allStalls[0]= 1;
        allStalls[(int)stalls+1] = 1;

        stat lastPersonSelection = new stat();
        for (int i = 1 ; i <= people; i++) {
            ArrayList<stat> allOptions = new ArrayList<stat>();
            for (int j = 1; j <= stalls; j++) {
                if (allStalls[j] == 0) {
                    allOptions.add(new stat(countLeft(allStalls, j), countRight(allStalls, j), j));
                }
            }


            Long max = (Long) allOptions.stream().map(e -> Math.min(e.ls, e.rs))
                .reduce(Long.valueOf(0), Math::max);

            List<stat> remainingOptions =
               allOptions.stream().filter(e -> Math.min(e.ls, e.rs) == max).collect(Collectors.toList());

            if (remainingOptions.size() ==1 ) {
                stat stat = remainingOptions.get(0);
                lastPersonSelection = stat;
                allStalls[(int)stat.index] = 1;
            } else {

                Long max1 = (Long) remainingOptions.stream().map(e -> Math.max(e.ls, e.rs))
                    .reduce(Long.valueOf(0), Math::max);

                List<stat> remainingOptions1 =
                    remainingOptions.stream().filter(e -> Math.max(e.ls, e.rs) == max1).collect(Collectors.toList());
                stat stat = remainingOptions1.get(0);

                allStalls[(int)stat.index] = 1;
                lastPersonSelection = stat;
            }

        }
        fop.write(Math.max(lastPersonSelection.ls, lastPersonSelection.rs) + " " + Math.min(lastPersonSelection.ls, lastPersonSelection.rs) + "\n");
    }

    private long countRight(int[] stalls, int j) {
        int count = 0;
        for ( int p = j+1; p<stalls.length;p++) {
            if (stalls[p] == 0) {
                count++;
            } else {
                break;
            }
        }
        return count;
    }

    private long countLeft(int[] stalls, int j) {
        int count = 0;
        for ( int p = j-1; p>=0;p--) {
            if (stalls[p] == 0) {
                count++;

            } else {
                break;
            }
        }
        return count;
    }

    class stat {
        long ls;
        long rs;
        long index;

        public stat(long ls, long rs , long index) {
            this.ls = ls;
            this.rs = rs;
            this.index = index;
        }

        public stat() {

        }
    }
}
