import javafx.collections.transformation.SortedList;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Senate {

    boolean []digits;
    FileInputStream fin;
    Writer fop;

    public static void main(String[] args) throws IOException {

        new Senate().execute();
    }

    private void execute() throws IOException {
        fin = new FileInputStream("ip1.txt");
        fop = new FileWriter("op1.txt");

        Scanner s = new Scanner(fin);
        int n = s.nextInt();
        int caseNum = 1;
        for (int i = 1; i <=n ; i++){
            int numOfParties = s.nextInt();
            List<Party> parties = new ArrayList<>();
            for(int j = 1; j <= numOfParties; j++) {
                parties.add(new Party((char)(65+j-1), s.nextInt()));
            }
            process(parties, caseNum++);
        }
        fin.close();
        fop.flush();
        fop.close();
    }

    private void assertMajority(List<Party> p) {
        int sum = 0;
        for (Party ep : p) {
            sum += ep.num;
        }

        for (Party ep : p) {
            if ( ep.num > sum/2) {
                System.out.println("bad : " + p);
                System.exit(1);
            }
        }
    }

    private void process(List<Party> p, int caseNum) throws IOException {
        System.out.println("Case #" + caseNum + ":" );
        Collections.sort(p);
        System.out.println(p);
        fop.write("Case #" + caseNum + ":" );
        boolean allNotEqual = true;
        while (allNotEqual) {
            allNotEqual = false;
            for (int i = 0; i < p.size() - 1; i++) {
                if (p.get(i).num == p.get(i + 1).num) {
                    continue;
                }
                allNotEqual = true;


               // int diff = p.get(i).num - p.get(i + 1).num;


                    allEqualAndReduce(p, p.get(i + 1).num, i+1);


//                for (int k = 1; k <= (diff / 2); k++) {
//                    fop.write(" " + p.get(i).name + "" + p.get(i).name );
//                    System.out.println(p.get(i).name + "" + p.get(i).name);
//                }
//                if (diff % 2 == 1) {
//                    fop.write(" " + p.get(i).name);
//                    System.out.println(p.get(i).name);
//                }
//                p.get(i).num = p.get(i + 1).num;
                assertMajority(p);
            }
        }

        System.out.println(p);


        if (allEqualAndReduce(p, 0, p.size())) return;

        System.out.println(p);
        System.out.println();
        fop.write("\n");
    }

    private boolean allEqualAndReduce(List<Party> p, int k, int end) throws IOException {
        if (p.get(0).num == k) {
            return true;
        }
        int start = 0;
        if (end%2 == 1) {
            start = 1;
        }

        while (p.get(0).num != k) {
            if (start == 1) {
                fop.write(" " + p.get(0).name);
                System.out.println(p.get(0).name);
                p.get(0).num -= 1;
                assertMajority(p);
            }
            for (int i = start; i < end - 1; i += 2) {
                p.get(i).num -= 1;
                p.get(i + 1).num -= 1;
                fop.write(" " + p.get(i).name + "" + p.get(i+1).name );
                System.out.println(p.get(i).name + "" + p.get(i + 1).name);
                assertMajority(p);
            }
        }
        return false;
    }


    private class Party implements Comparable {
        public char name;
        public int num;
        public Party(char name, int num) {
            this.name = name;
            this.num = num;
        }

        public String toString() {
            return name + " : " + num;
        }

        @Override
        public int compareTo(Object o) {
            Party p = (Party)o;

            if (this.num < p.num) {return +11;}
            if (this.num > p.num) {return -1;}
            return 0;
        }
    }
}
