package watershed;

import java.io.File;
import java.io.FileNotFoundException;

import java.io.OutputStream;
import java.io.PrintWriter;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

class MyMap {
    int xlen;
    int ywid;
    MapPoint region[][];
    boolean mergebasinFlag = false;
    MapPoint get(int x, int y) {
        return region[y][x];
    }
    
    MyMap(int len, int wid) {
        region = new MapPoint[wid][len];
        xlen = len -1;
        ywid = wid -1;
        MapPoint.map = this;
    }
    
    void createPoint(int x, int y, int alt) {
        region[y][x] = new MapPoint(x, y, alt);
    }

    void printmap(PrintWriter op) {
        
        for (int i = 0; i <= ywid; i++) {
            for (int j = 0; j<= xlen; j++) {
                op.print(region[i][j].label);
                
                if(j < xlen) {
                    op.print(" ");
                }
            }
           op.println();
        }
    }
    MapPoint getLeastAltitudeNearMe(int xcor, int ycor) {
   
        MapPoint north, west, east, south;
        ArrayList arr = new ArrayList();
        if (ycor > 0)
        {north = region[ycor-1][xcor];
            arr.add(north);
        }else 
            north = null;
        
        if (xcor > 0) 
        {   west = region[ycor][xcor-1];
            arr.add(west);
        } else 
            west = null;
        
        if (ycor < ywid) 
        {   south = region[ycor +1][xcor];
            arr.add(south);
        } else 
            south = null;
        
        if ( xcor < xlen)
        {    east = region[ycor][xcor+1];
            arr.add(east);
        }else 
            east = null;
        if (arr.size() == 0) { return null;}
        
        Collections.sort(arr);
        if (arr.size() == 1) {
           return  ((MapPoint)(arr.get(0)));
        }
        if ( ((MapPoint)(arr.get(0))).altitude < ((MapPoint)(arr.get(1))).altitude ) 
                return ((MapPoint)(arr.get(0)));
        // there is a tie
        int tieOn = ((MapPoint)(arr.get(0))).altitude;
        for(int j = 1;j<=4 ;j++) {
            MapPoint temp = null;
            if (j==1) { temp = north;}
            if(j==2) { temp = west;}
            if (j==3) { temp = east;}
            if (j==4) { temp = south;}
            
            if (temp == null) { continue;}
            

             for(int i = 0; i<arr.size()-1;i++) {
                 if (((MapPoint)arr.get(i)).altitude == tieOn &&  arr.get(i) == temp) {
                     return temp;
                 }
                }
        }   
        return null;
    }
    
    
}
class MapPoint implements Comparable {
    int xcor;
    int ycor;
    int altitude;
    String label ="*";
    MapPoint waterTo;
    MapPoint waterFrom;
    static MyMap map;
    
    MapPoint(int x, int y, int alt) {
        xcor = x;
        ycor = y;
        altitude = alt;
    }
    
    void dropWater(String lbl) {
        label=lbl;
        setWaterDirection();
        if (waterTo != null ) {
            if (waterTo.altitude >= altitude) {
                label=lbl;
                return;
            }
            waterTo.waterFrom = this;
            if (waterTo.label != null && waterTo.label != "" && waterTo.label != "*") {
                mergeToBasinFound(waterTo.label);
                } else {
                    label = lbl;
                    waterTo.dropWater(lbl);
                }
        }
    }
    
    
    void setWaterDirection() {
        waterTo = map.getLeastAltitudeNearMe(xcor, ycor);
        
    }

    public int compareTo(Object o) {
        MapPoint t = (MapPoint)o;
      
        if (t.altitude > altitude)
            return -1;
        if (t.altitude < altitude)
            return +1;
        return 0;
    }

    private void mergeToBasinFound(String lbl) {
        map.mergebasinFlag = true;
        if (label == lbl ) {   return;}
        label = lbl;
      
        if (waterFrom != null) 
                waterFrom.mergeToBasinFound(lbl);
    }
}
public class WaterShed {
    static int numRegions;
    public static void main(String[] args) {
        Scanner scn = null;
        try {
            scn = new Scanner(new File("D:\\Test.txt"));
        } catch (FileNotFoundException e) {
            e.printStackTrace();
            System.exit(0);
        }
        
        PrintWriter op = null;

        try {
            op = new PrintWriter(new File("D:\\Result.txt"));
        } catch (FileNotFoundException e) {
          e.printStackTrace();
          System.exit(0);
        }
        numRegions = scn.nextInt();
        
        for(int i = 0;i <numRegions; i++) {
            MyMap mp;
            int y = scn.nextInt();
            int x= scn.nextInt();
            
            mp = new MyMap(x,y);
          
            for(int k = 0;k<y;k++) {
                for(int p = 0;p<x;p++) {
                    mp.createPoint(p,k,scn.nextInt());
                }
            }
           // mp.printmap();
            int count = 97;
              
            for(int k = 0;k<y;k++) {
                    for(int p = 0;p<x;p++) {
                   
                            Character c= new Character((char)count);
                          
                    if (mp.get(p,k).label.equals("*"))
                    {
                        mp.mergebasinFlag = false;
                            mp.get(p,k).dropWater(c.toString());
                    if (!mp.mergebasinFlag) {
                        count ++;
                    }
                    }
                  //  System.out.println("\n\n");
                    //mp.printmap();
                }
            }
         //   System.out.println("\n\n");
          //  mp.printmap(System.out);
            op.println("Case #" + (i+1) + ": ");
            mp.printmap(op);
            
        }
       op.close();
    }
}
