package com.company;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.Scanner;

/**
 * Created by ankur.srivastava on 09/04/17.
 */
public class TidyNumber {

    FileInputStream fin;
    Writer fop;

    public static void main(String[] args) throws IOException {
        new TidyNumber().execute();
    }

    private void execute() throws IOException {
        fin = new FileInputStream("ip1.txt");
        fop = new FileWriter("op1.txt");

        Scanner s = new Scanner(fin);
        int n = s.nextInt();
        int caseNum = 1;
        for (int i = 1; i <=n ; i++){
            System.out.println("Case #" + caseNum++ +  ": "  + process(new StringBuilder(s.next())));
        }
        fin.close();
        fop.flush();
        fop.close();
    }

    private long process(StringBuilder l) {
        int tidy = isTidy(l);

        if (tidy == -1) {
            return Long.parseLong(l.toString());
        }

        while (tidy != -1) {
           // System.out.println(l);
            int reducedDigit = Character.digit(l.charAt(tidy), 10) - 1;
            l.setCharAt(tidy, Character.forDigit(reducedDigit, 10));
            for (int i = tidy +1; i< l.length(); i++) {
                l.setCharAt(i,Character.forDigit(9, 10));
            }
            tidy = isTidy(l);
        }

        return Long.parseLong(l.toString());
    }

    private int isTidy(StringBuilder l) {
        int lastSeen = 9;
        for (int i = l.length() -1 ; i >= 0 ; i--) {
            int digit = Character.digit(l.charAt(i), 10);
            if (digit <= lastSeen) {
                lastSeen = digit;
            } else {
                return i;
            }
        }

        return -1;
    }
}
