import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.*;

public class FashionPolice {

    boolean []digits;
    FileInputStream fin;
    Writer fop;

    public static void main(String[] args) throws IOException {

        new FashionPolice().execute();
    }

    private void execute() throws IOException {
        fin = new FileInputStream("ip1.txt");
        fop = new FileWriter("op1.txt");

        Scanner s = new Scanner(fin);
        int n = s.nextInt();
        int caseNum = 1;
        for (int i = 1; i <=n ; i++){
            int jackets = s.nextInt();
            int pants = s.nextInt();
            int shirts = s.nextInt();
            int cutoff = s.nextInt();

            process(jackets, pants, shirts, cutoff, caseNum++);
        }
        fin.close();
        fop.flush();
        fop.close();
    }

    private void process(int jackets, int pants, int shirts, int cutoff, int caseNum) throws IOException {
        System.out.println("Case # " + caseNum + "\n");


        Map<String, Integer> jp = new HashMap<>();
        Map<String, Integer> ps = new HashMap<>();
        Map<String, Integer> js = new HashMap<>();


        List<String> moves = new ArrayList<>();
        for (int i = 1; i <= jackets; i++) {

            for (int j = 1; j <= pants; j++) {

                for (int k = 1; k <=shirts; k++) {


                    if ( (jp.get(i + " " + j) == null || jp.get(i + " " + j) < cutoff)
                            && (ps.get(j + " " + k) == null || ps.get(j + " " + k) < cutoff )
                            && (js.get(i + " " + k) == null || js.get(i + " " + k) <cutoff)) {
                        putInMap(jp, i,j);
                        putInMap(ps, j,k);
                        putInMap(js, i,k);
                        moves.add(i + " " + j + " " +k);
                    }

                }
            }
        }

        fop.write("Case #" + caseNum + ": " + moves.size() + "\n");
        for (String move : moves) {
            fop.write(move + "\n");
        }

    }

    private void putInMap(Map<String, Integer> jp, int i, int j) {
        Integer integer = jp.get(i + " " + j);
        if (integer == null) {
            jp.put(i + " " + j , 1);
        } else {
            jp.put(i + " " + j , integer+1);
        }
    }
}
