/*******************************************************************************
 * Copyright (c) 2009 24/7 Customer Inc. All rights reserved. 
 * Reproduction or retransmission of the materials, in whole or in part, 
 * in any manner, without the prior written consent of the copyright holder, 
 * is a violation of copyright law
 *******************************************************************************/

package cj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.GregorianCalendar;

/**
 * 
 * @author ankur.goenka
 */
public class ThemePark {

    public static String OFF = "OFF";
    public static String ON = "ON";

    public static String inputFileName = "C:/cjinput.txt";
    public static String outputFileName = "C:/cjoutput.txt";

    /**
     * @param args
     * @throws Exception
     */
    /**
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        FileReader fr = new FileReader(inputFileName);
        FileWriter fw = new FileWriter(outputFileName);
        BufferedReader br = new BufferedReader(fr);
        BufferedWriter bw = new BufferedWriter(fw);
        long t1 = System.currentTimeMillis();
        int totalNumberOfTestCases = Integer.parseInt(br.readLine());
        for (int testcaseNumber = 1; testcaseNumber <= totalNumberOfTestCases; testcaseNumber++) {
            String[] testTokens = br.readLine().split(" ");
            int totalNumberOfRoundsByRoalerCoaster = Integer.parseInt(testTokens[0]);
            int maxCoasterGroupSize = Integer.parseInt(testTokens[1]);
            int numberOfGroups = Integer.parseInt(testTokens[2]);
            String[] groupTokens = br.readLine().split(" ");
            int[] groups = new int[numberOfGroups];
            for (int groupNumber = 0; groupNumber < numberOfGroups; groupNumber++) {
                groups[groupNumber] = Integer.parseInt(groupTokens[groupNumber]);
            }
            CoasterGroup[] coasterGroups = new CoasterGroup[numberOfGroups];
            for (int groupNumber = 0; groupNumber < numberOfGroups; groupNumber++) {
                int currentCoasterGroupSize = 0;
                int currentGroupNumber = groupNumber;
                for (;;) {
                    currentCoasterGroupSize = currentCoasterGroupSize + groups[currentGroupNumber];
                    if (currentCoasterGroupSize > maxCoasterGroupSize) {
                        currentCoasterGroupSize = currentCoasterGroupSize - groups[currentGroupNumber];
                        break;
                    }
                    currentGroupNumber++;
                    if (currentGroupNumber == numberOfGroups) {
                        currentGroupNumber = 0;
                    }
                    if (currentGroupNumber == groupNumber) {
                        break;
                    }
                }
                coasterGroups[groupNumber] = new CoasterGroup(currentCoasterGroupSize, currentGroupNumber);
//                System.out.print(currentCoasterGroupSize + "," + currentGroupNumber + ":");
            }
//            System.out.println();
            long earning = 0;
            int groupNumber = 0;
            for (int rideNumber = 0; rideNumber < totalNumberOfRoundsByRoalerCoaster; rideNumber++) {
                CoasterGroup cg = coasterGroups[groupNumber];
                earning = earning+cg.size;
                groupNumber = cg.next;
            }
//            System.out.println("Case #" + testcaseNumber + ": " + earning);
            bw.write("Case #" + testcaseNumber + ": " + earning);
            bw.newLine();
        }
        bw.flush();
        bw.close();
        System.out.println((System.currentTimeMillis() - t1) );
    }

}

class CoasterGroup {
    public int size = 0;
    public int next;

    public CoasterGroup(int size, int next) {
        this.size = size;
        this.next = next;
    }
}