
package cj.round.two.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.text.DateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.StringTokenizer;

/**
 * 
 * @author ankur.goenka
 */
public class Base {
    /**
     * change problem number and create corresponding file inputfile:
     * baseDirPath + problemName+ "\\input\\" + problemName + attemptNumber +
     * ".txt"; example: C:\cj\A\input\A1.txt outputfile: baseDirPath +
     * problemName+ "\\output\\" + problemName + attemptNumber + "Out.txt";
     * example: C:\cj\A\output\A1Out.txt
     */

    public static String problemName = "C";
    public static String attemptNumber = "1";


    public void process() throws Exception {

        int totalNumberOfTests = getInt();

        for (int testCaseNumber = 1; testCaseNumber <= totalNumberOfTests; testCaseNumber++) {
            
            printTestResult(testCaseNumber, fib(getInt()));
        }

    }
    
    public static long fib(long n)
    {  
        long a = 0, b=1;
       for(long i = 1; i < n ; i++){
           long temp = b;
           b = b +a;
           a = temp;
       }
       return b;
    }



    /**
     * Dont touch code below this
     */
    public StringTokenizer tokens = null;
    public BufferedReader in = null;
    public BufferedWriter out = null;

    public String baseDirPath = "C:\\cj\\";

    public static void main(String[] args) throws Exception {
        long startTime = System.currentTimeMillis();
        System.out.println("going to solve problem: '" + problemName + "' attempt number: '" + attemptNumber + "'");
        System.out.println("Start time: " + DateFormat.getDateTimeInstance().format(new Date()));
        Base base = null;
        try {
            base = new Base();
            base.init();
            base.process();
        } finally {
            base.cleanup();

            System.out.println("End time: " + DateFormat.getDateTimeInstance().format(new Date()));
            long endTime = System.currentTimeMillis();
            System.out.println("runtime: " + (endTime - startTime));
        }

    }

    public void cleanup() throws Exception {
        if (in != null) {
            in.close();
        }
        if (out != null) {
            out.flush();
            out.close();
        }
    }

    public void init() throws Exception {
        String inputFileName = baseDirPath + problemName + "\\input\\" + problemName + attemptNumber + ".txt";
        System.out.println("inputFile: " + inputFileName);
        in = new BufferedReader(new FileReader(inputFileName));

        String outputFileName = baseDirPath + problemName + "\\output\\" + problemName + attemptNumber + "Out.txt";
        System.out.println("outputFile: " + outputFileName);
        out = new BufferedWriter(new FileWriter(outputFileName));
    }

    public void print(String line) throws Exception {
        out.write(line);
    }

    public void println() throws Exception {
        out.newLine();
    }

    public void println(String line) throws Exception {
        out.write(line);
        out.newLine();
        System.out.println(line);
    }

    public void printTestResult(int caseNumber, String result) throws Exception {
        println("Case #" + caseNumber + ": " + result);
    }

    public void printTestResult(int caseNumber, long result) throws Exception {
        println("Case #" + caseNumber + ": " + result);
    }

    public void printTestResult(int caseNumber, int result) throws Exception {
        println("Case #" + caseNumber + ": " + result);
    }

    public String getLine() throws IOException {
        return in.readLine();
    }

    public String getString() throws IOException {
        while (tokens == null || !tokens.hasMoreTokens())
            tokens = new StringTokenizer(getLine());
        return tokens.nextToken();
    }

    public int getInt() throws IOException {
        return Integer.parseInt(getString());
    }

    public long getLong() throws IOException {
        return Long.parseLong(getString());
    }

    public double getDouble() throws IOException {
        return Double.parseDouble(getString());
    }

    public BigInteger getBigInt() throws IOException {
        return new BigInteger(getString());
    }
}
