/*******************************************************************************
 * Copyright (c) 2009 24/7 Customer Inc. All rights reserved. 
 * Reproduction or retransmission of the materials, in whole or in part, 
 * in any manner, without the prior written consent of the copyright holder, 
 * is a violation of copyright law
 *******************************************************************************/

package cj;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * 
 * @author ankur.goenka
 */
public class Snapper {

    public static String OFF = "OFF";
    public static String ON = "ON";

    public static String inputFileName = "C:/cjinput.txt";
    public static String outputFileName = "C:/cjoutput.txt";

    /**
     * @param args
     * @throws Exception
     */
    public static void main(String[] args) throws Exception {
        FileReader fr = new FileReader(inputFileName);
        FileWriter fw = new FileWriter(outputFileName);
        BufferedReader br = new BufferedReader(fr);
        BufferedWriter bw = new BufferedWriter(fw);
        int totalNumberOfTestCases = Integer.parseInt(br.readLine());
        for (int testcaseNumber = 1; testcaseNumber <= totalNumberOfTestCases; testcaseNumber++) {
            String[] testTokens = br.readLine().split(" ");
            long numberOfSwitchers = Long.parseLong(testTokens[0]);
            long numberOfClaps = Long.parseLong(testTokens[1]);
            long currentNumberOfClaps = 0;
            boolean isBulbOn = false;
            do {
                currentNumberOfClaps = (long) (Math.pow(2, numberOfSwitchers) - 1) + currentNumberOfClaps;
                if (currentNumberOfClaps == numberOfClaps) {
                    isBulbOn = true;
                    break;
                }
                currentNumberOfClaps++;
            } while (currentNumberOfClaps < numberOfClaps);
            System.out.println("Case #" + testcaseNumber + ": " + (isBulbOn ? ON : OFF));
            bw.write("Case #" + testcaseNumber + ": " + (isBulbOn ? ON : OFF));
            bw.newLine();
            bw.flush();
           
        }
        bw.close();
    }

}
