package com.ankush.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;

public class Basin
{
	
	static PrintWriter pw;
	public static void main(String[] args) throws NumberFormatException, IOException
	{
		BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(new File("h:\\basin.txt"))));
		pw = new PrintWriter("h:\\basinLarge.txt");
		int numCase = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= numCase; i++)
		{
			String str = reader.readLine();
			String[] sp = str.split(" ");
			int n = Integer.parseInt(sp[0]); int m = Integer.parseInt(sp[1]);
			int[][] graph = new int[n][m];
			for (int j = 0; j < n; j++)
			{
				str = reader.readLine();
				sp = str.split(" ");
				for (int k = 0; k < sp.length; k++)
				{
					graph[j][k] = Integer.parseInt(sp[k]);
				}
			}
			pw.println("Case #" + i + ":");
			basin(graph);
		}
		pw.close();
	}

	public static void basin(int[][] data)
	{
		int[] graph = new int[data.length*data[0].length];
		
		for (int i = 0; i < data.length; i++)
		{
			for (int j = 0; j < data[0].length; j++)
			{
				int n = 10000; int w = 10000; int e = 10000; int s =10000;
				if(i-1>=0)
					n = data[i-1][j];
				if(j-1>=0)
					w = data[i][j-1];
				if(j+1<data[0].length)
					e = data[i][j+1];
				if(i+1<data.length)
					s = data[i+1][j];
				int min = Math.min(Math.min(n, w), Math.min(e, s));
				if(min >= data[i][j])
				{
					graph[i*data[0].length + j] = i*data[0].length + j;
					continue;
				}
				if(min == n)
					graph[i*data[0].length + j] = (i-1)*data[0].length + j;
				else if(min == w)
					graph[i*data[0].length + j] = i*data[0].length + j-1;
				else if(min == e)
					graph[i*data[0].length + j] = i*data[0].length + j+1;
				else if(min == s)
					graph[i*data[0].length + j] = (i+1)*data[0].length + j;
			}
		}
		
		ArrayList<Integer> currentPath = new ArrayList<Integer>();
		char[] path = new char[graph.length];
		Arrays.fill(path, '-');
		char currentChar = 'a';
		for (int i = 0; i < graph.length; i++)
		{
			if(graph[i]==i && path[i]=='-')
			{
				path[i] = currentChar;
				currentChar++;
			}
			else
			{
				currentPath.clear();
				int currentI = i;
				currentPath.add(currentI);
				while(true)
				{
					currentI = graph[currentI];
					if(graph[currentI]==currentI && path[currentI]=='-')
					{
						path[currentI] = currentChar;
						for(Integer  k : currentPath)
						{
							path[k]= currentChar;
						}
						currentChar++;
						break;
					}
					else if(path[currentI]!='-')
					{
						for(Integer  k : currentPath)
						{
							path[k]= path[currentI];
						}
						break;
					}
					currentPath.add(currentI);
				}
			}
		}
		
		for(int i=0; i<data.length; i++)
		{
			for (int j = 0; j < data[0].length; j++)
			{
				pw.print(path[i*data[0].length + j] + " ");
			}
			pw.println();
		}
	}
}
