package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;

public class Train
{
    public static class Data implements Comparable<Data>
    {
        int time; char station; int index; int arrival;
        public Data(int time, char station, int index, int arrival)
        {
            super();
            this.time = time;
            this.station = station;
            this.index = index;
            this.arrival = arrival;
        }
        public int compareTo(Data o)
        {
            if(this.time-o.time==0)
            {
                return o.arrival - this.arrival;
            }
            return this.time - o.time;
        }
    }
    
    public static int[] getNumtrains(int[][] aData, int[][] bData, int turnAround)
    {
        Data[] data = new Data[aData.length*2 + bData.length*2];
        int index = 0;
        for (int i = 0; i < aData.length; i++)
        {
            data[index++] = new Data(aData[i][0], 'A', i, 0);
            data[index++] = new Data(aData[i][1], 'A', i, 1);
        }
        
        for (int i = 0; i < bData.length; i++)
        {
            data[index++] = new Data(bData[i][0], 'B', i, 0);
            data[index++] = new Data(bData[i][1], 'B', i, 1);
        }
        
        Arrays.sort(data);
        int numA = 0; int numB = 0; int curA = 0; int curB = 0;
        for (int i = 0; i < data.length; i++)
        {
            if(data[i].arrival==1)
            {
                if(data[i].station=='A')
                    curB++;
                else
                    curA++;
            }
            else
            {
                if(data[i].station=='A')
                {
                    if(curA>0)
                        curA--;
                    else
                        numA++;
                }
                if(data[i].station=='B')
                {
                    if(curB>0)
                        curB--;
                    else
                        numB++;
                }

            }
        }
        return new int[]{numA, numB};
    }
    
    public static void main(String[] args) throws NumberFormatException, IOException
    {
        BufferedReader rd = new BufferedReader(new InputStreamReader(new FileInputStream("C:\\Documents and Settings\\ankushb\\workspace\\TopCoder\\gcj\\A-large.in")));
        PrintWriter p = new PrintWriter("C:\\Documents and Settings\\ankushb\\workspace\\TopCoder\\gcj\\A-large.out");
        int testCase = Integer.parseInt(rd.readLine().trim());
        for (int i = 0; i < testCase; i++)
        {
            int t = Integer.parseInt(rd.readLine().trim());
            String[] s = rd.readLine().split("\\s+");
            int numA = Integer.parseInt(s[0]);
            int numB = Integer.parseInt(s[1]);
            int[][] aData = new int[numA][2];
            int[][] bData = new int[numB][2];
            for (int j = 0; j < aData.length; j++)
            {
                s = rd.readLine().split("\\s+");
                aData[j][0] = Integer.parseInt(s[0].split(":")[1]) + Integer.parseInt(s[0].split(":")[0])*60;
                aData[j][1] = Integer.parseInt(s[1].split(":")[1]) + Integer.parseInt(s[1].split(":")[0])*60 + t;
            }
            for (int j = 0; j < bData.length; j++)
            {
                s = rd.readLine().split("\\s+");
                bData[j][0] = Integer.parseInt(s[0].split(":")[1]) + Integer.parseInt(s[0].split(":")[0])*60;
                bData[j][1] = Integer.parseInt(s[1].split(":")[1]) + Integer.parseInt(s[1].split(":")[0])*60 + t;
            }
            int[] ret = getNumtrains(aData, bData, t);
            p.println("Case #" + (i+1) + ": " + ret[0] + " " + ret[1]);
        }
        p.close();
    }
}
