package main.java;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Solution42 {

    public static final String IMPOSSIBLE = "IMPOSSIBLE";
    public static final String B = "B";
    public static final String R = "R";
    public static final String Y = "Y";

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(args[0]))));
        int t = sc.nextInt();
        List<String> outputLines = new ArrayList<>(t);

        for (int i = 0; i < t; i++) {
            int n = sc.nextInt();
            int r = sc.nextInt();
            int O = sc.nextInt();
            int y = sc.nextInt();
            int G = sc.nextInt();
            int b = sc.nextInt();
            int V = sc.nextInt();

            if (V + O + G == 0) {
                String e = handleSingleColors(b, r, y);

                outputLines.add(e);
            } else if (n == b + O && O > 0) {
                outputLines.add(handleTwoColors(b, O, "B", "O"));
            } else if (n == r + G && G > 0) {
                outputLines.add(handleTwoColors(r, G, "R", "G"));
            } else if (n == y + V && V > 0) {
                outputLines.add(handleTwoColors(y, V, "Y", "V"));
            } else {
                StringBuilder res = new StringBuilder("");


                outputLines.add(res.toString());
            }

        }
        writeToFile(outputLines, "src/main/java/out/out4.txt");
    }

    private static String handleTwoColors(int single, int complex, String sin, String com) {
        if (single != complex) {
            return IMPOSSIBLE;
        }
        StringBuilder res = new StringBuilder("");
        for (int i = 0; i < single; i++) {
            res.append(sin).append(com);
        }
        return res.toString();
    }

    private static String handleSingleColors(int b, int r, int y) {
        int max = Collections.max(Arrays.asList(b,r,y));
        if (max > (b+r+y)/2) {
            return IMPOSSIBLE;
        }

        Collections.sort(Arrays.asList(b, r, y));
        List<String> Bs = fill(b, B);
        List<String> Rs = fill(r, R);
        List<String> Ys = fill(y, Y);
        List<List<String>> lists = Arrays.asList(Bs, Rs, Ys);
        Collections.sort(lists, (o1, o2) -> o2.size() - o1.size());

        StringBuilder res = new StringBuilder("");
        while (lists.get(0).size() + lists.get(1).size() + lists.get(2).size() > 0) {
            if (lists.get(0).size() > 0) {
                res.append(lists.get(0).remove(0));
            }
            if (lists.get(1).size() > 0) {
                res.append(lists.get(1).remove(0));
            }
            if (lists.get(0).size() > 0) {
                res.append(lists.get(0).remove(0));
            }
            if (lists.get(2).size() > 0) {
                res.append(lists.get(2).remove(0));
            }
        }
        return res.toString();

    }

    private static List<String> fill(int r, String r2) {
        List<String> Rs = new ArrayList<>(r);
        for (int i = 0; i < r; i++) {
            Rs.add(r2);
        }
        return Rs;
    }

    private static void writeToFile(List<String> outputLines, String fileName) throws IOException {

        List<String> lines = new ArrayList<>(outputLines.size());

        for (int i = 0; i < outputLines.size(); i++) {
            lines.add(toStr(outputLines.get(i), i + 1));
        }

        Path file = Paths.get(fileName);
        Files.write(file, lines, Charset.forName("UTF-8"));
    }

    private static String toStr(String integers, int lineNumber) {
        return "Case #" + lineNumber + ": " + integers;
    }
}
