package main.java;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class Solution31 {


    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(args[0]))));
        int t = sc.nextInt();
        List<List<List<String>>> outputLines = new ArrayList<>(t);
        for (int i = 0; i < t; i++) {
            int r = sc.nextInt();
            int c = sc.nextInt();
            Map<Integer, Map<Integer, String>> map = new HashMap<>();
            for (int j = 0; j < r; j++) {
                String s = sc.next();
                if (!s.equals(String.join("", Collections.nCopies(c, "?")))) {

                    map.put(j, new HashMap<>());
                    for (int k = 0; k < c; k++) {
                        String let = "" + s.charAt(k);
                        if (!let.equals("?")) {
                            map.get(j).put(k, let);
                        }
                    }
                }
            }
            List<List<String>> res = process(r, c, map);
            System.out.println(i);
            System.out.println(res);
            outputLines.add(res);
        }
        writeToFile(outputLines, "src/main/java/out/out2.txt");
    }

    private static List<List<String>> process(int r, int c, Map<Integer, Map<Integer, String>> map) {
        List<List<String>> res = new ArrayList<>(r);
        for (int i = 0; i < r; i++) {
            res.add(new ArrayList<>(c));
        }
        Set<Integer> rows = map.keySet();
        List<Integer> rowList = new ArrayList<>(rows);
        Collections.sort(rowList);
        for (int i = 0; i < rowList.size(); i++) {

            int startRow = (i == 0) ? 0 : rowList.get(i); // incl
            int nextRow = (i == rowList.size() - 1) ? r : rowList.get(i + 1); //incl

            Set<Integer> cols = map.get(rowList.get(i)).keySet();
            List<Integer> colList = new ArrayList<>(cols);
            Collections.sort(colList);
            for (int j = 0; j < colList.size(); j++) {
                String letter = map.get(rowList.get(i)).get(colList.get(j));
                int firstCol = j == 0 ? 0 : colList.get(j);
                int lastCol = j == colList.size() - 1 ? c - 1 : colList.get(j + 1) - 1;
                int times = lastCol - firstCol + 1;
                for (int k = startRow; k < nextRow; k++) {
                    for (int l = 0; l < times; l++) {
                        res.get(k).add(letter);
                    }
                }
            }
        }
        return res;
    }


    private static void writeToFile(List<List<List<String>>> outputLines, String fileName) throws IOException {

        List<String> lines = new ArrayList<>(outputLines.size());

        for (int i = 0; i < outputLines.size(); i++) {
            lines.add("Case #" + (i + 1) + ": ");
                for (List<String> l : outputLines.get(i)) {
                   lines.add(String.join("", l));
                }
        }

        Path file = Paths.get(fileName);
        Files.write(file, lines, Charset.forName("UTF-8"));
    }

    private static String intsToString(List<List<String>> i, int lineNumber) {
        return "Case #" + lineNumber + ": " + i;
    }

}