package main.java;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigDecimal;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Solution41 {
    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(args[0]))));
        int t = sc.nextInt();
        List<BigDecimal> outputLines = new ArrayList<>(t);

        for (int i = 0; i < t; i++) {
            List<BigDecimal> times = new ArrayList<>(t);
            int d = sc.nextInt();
            int n = sc.nextInt();
            for (int j = 0; j < n; j++) {
                int ki = sc.nextInt();
                int si = sc.nextInt();
                BigDecimal time = new BigDecimal(d - ki).divide(new BigDecimal(si), 8, BigDecimal.ROUND_HALF_UP);
//                System.out.println("time: " + time);
                times.add(time);
            }
            BigDecimal maxTime = Collections.max(times);
//            System.out.println("max time: " + maxTime);
            outputLines.add(new BigDecimal(d).divide(maxTime, 8, BigDecimal.ROUND_HALF_UP));
        }
        writeToFile(outputLines, "src/main/java/out/out4.txt");
    }

    private static void writeToFile(List<BigDecimal> outputLines, String fileName) throws IOException {

        List<String> lines = new ArrayList<>(outputLines.size());

        for (int i = 0; i < outputLines.size(); i++) {
            lines.add(toStr(outputLines.get(i), i + 1));
        }

        Path file = Paths.get(fileName);
        Files.write(file, lines, Charset.forName("UTF-8"));
    }

    private static String toStr(BigDecimal integers, int lineNumber) {
        return "Case #" + lineNumber + ": " + integers;
    }
}
