package main.java;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;

public class Solution21 {
    private static final HashMap<String, String> flipMap;

    static {
        flipMap = new HashMap<>(2);
        flipMap.put("+", "-");
        flipMap.put("-", "+");
    }

    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(args[0]))));
        int t = sc.nextInt();
        List<String> outputLines = new ArrayList<>(t);
        for (int i = 0; i < t; i++) {
            String str = sc.next();
            int n = sc.nextInt();
            if (onlyPlus(str)) {
                outputLines.add("0");
            } else {
                outputLines.add(process(str, n));
            }
        }
        writeToFile(outputLines, "src/main/java/out/out2.txt");
    }

    private static String process(String str, int num) {
        String[] letters = str.split("");
        int count = 0;
        int i = 0;
        while (i <= letters.length - num) {
            if (letters[i].equals("-")) {
                flip(letters, i, num);
                count++;
            }
            i++;
        }
        return onlyPlus(String.join("", letters)) ? String.valueOf(count) : "IMPOSSIBLE";
    }

    private static void flip(String[] str, int i, int num) {
        for (int j = i; j < i+num; j++) {
            str[j] = flipMap.get(str[j]);
        }
    }

    private static boolean onlyPlus(String str) {
        String s = str.replaceAll("\\+", "");
        return s.length() == 0;
    }

    private static void writeToFile(List<String> outputLines, String fileName) throws IOException {

        List<String> lines = new ArrayList<>(outputLines.size());

        for (int i = 0; i < outputLines.size(); i++) {
            lines.add(intsToString(outputLines.get(i), i + 1));
        }

        Path file = Paths.get(fileName);
        Files.write(file, lines, Charset.forName("UTF-8"));
    }

    private static String intsToString(String i, int lineNumber) {
        return "Case #" + lineNumber + ": " + i;
    }
}
