package main.java;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

public class Solution22 {
    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(args[0]))));
        int t = sc.nextInt();
        List<String> outputLines = new ArrayList<>(t);
        for (int i = 0; i < t; i++) {
            BigInteger n = sc.nextBigInteger();
            String res = process(n);
            outputLines.add(res);
        }
        writeToFile(outputLines, "src/main/java/out/out2.txt");
    }

    private static boolean isAsc(BigInteger n) {
        String[] res = String.valueOf(n).split("");
        String[] tmp = String.valueOf(n).split("");
        Arrays.sort(res);
        return Arrays.toString(res).equals(Arrays.toString(tmp));
    }

    private static void writeToFile(List<String> outputLines, String fileName) throws IOException {

        List<String> lines = new ArrayList<>(outputLines.size());

        for (int i = 0; i < outputLines.size(); i++) {
            lines.add(intsToString(outputLines.get(i), i + 1));
        }

        Path file = Paths.get(fileName);
        Files.write(file, lines, Charset.forName("UTF-8"));
    }

    private static String intsToString(String i, int lineNumber) {
        return "Case #" + lineNumber + ": " + i;
    }

    private static String process(BigInteger num) {
        if (isAsc(num)) {
            return String.valueOf(num);
        }
        String[] digits = num.toString().split("");
        int length = digits.length;
        List<Integer> list = new ArrayList<>(length);
        for (String d : digits) {
            list.add(Integer.parseInt(d));
        }
        if (list.get(0) == 1 && list.contains(0)) {
            return String.join("", Collections.nCopies(length - 1, "9"));
        }
        int end = length - 1;
        while (end != 0) {
            for (int i = 0; i < end; i++) {
                if (list.get(i) > list.get(i + 1)) {
                    int tmp = list.remove(i);
                    list.add(i, tmp - 1);
                    int j = i + 1;
                    while (j < length) {
                        list.remove(j);
                        list.add(j, 9);
                        j++;
                    }
                    end = i;
                    i = 0;
                } else if (end == 1) {
                    end--;
                }
            }
        }
        return String.join("", list.stream().map(String::valueOf).collect(Collectors.toList()));
    }
}
