package main.java;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Objects;
import java.util.Scanner;

public class Solution23 {
    public static void main(String[] args) throws IOException {
//        System.out.println(maxpowof2(BigInteger.valueOf(2)));
//        System.out.println(maxpowof2(BigInteger.valueOf(5)));
//        System.out.println(maxpowof2(BigInteger.valueOf(100)));
//        System.out.println(maxpowof2(BigInteger.valueOf(1000)));
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(args[0]))));
        int t = sc.nextInt();
        List<String> outputLines = new ArrayList<>(t);
        for (int i = 0; i < t; i++) {
            BigInteger n = sc.nextBigInteger();
            BigInteger k = sc.nextBigInteger();
            String res = process(n, k);
            outputLines.add(res);
//            System.out.println(res);
        }
        writeToFile(outputLines, "src/main/java/out/out2.txt");
    }

    private static String process(BigInteger n, BigInteger k) {
        if (Objects.equals(n, k)) {
            return "0 0";
        }
//        if ( k.compareTo(maxpowof2(n)) > 0) {
//            return "0 0";
//        }

        BigInteger cur = bfs(n, k);

        return cur.divide(BigInteger.valueOf(2)) + " " + (cur.subtract(BigInteger.ONE)).divide(BigInteger.valueOf(2));

    }

    private static BigInteger maxpowof2(BigInteger n) {
        BigInteger pow = BigInteger.ONE;
        while (pow.multiply(BigInteger.valueOf(2)).compareTo(n) < 0) {
            pow = pow.multiply(BigInteger.valueOf(2));
        }
        return pow;
    }

    private static void writeToFile(List<String> outputLines, String fileName) throws IOException {

        List<String> lines = new ArrayList<>(outputLines.size());

        for (int i = 0; i < outputLines.size(); i++) {
            lines.add(intsToString(outputLines.get(i), i + 1));
        }

        Path file = Paths.get(fileName);
        Files.write(file, lines, Charset.forName("UTF-8"));
    }

    private static String intsToString(String i, int lineNumber) {
        return "Case #" + lineNumber + ": " + i;
    }

    private static BigInteger bfs(BigInteger n, BigInteger k) {
//        System.out.println(n + " " + k);
        List<BigInteger> queue = new LinkedList<>();
        queue.add(n);

        while(!queue.isEmpty()) {
            BigInteger cur = queue.remove(0);
//            System.out.print(cur + " ");
            if (Objects.equals(k, BigInteger.ONE)) {
//                System.out.print("   res: "  + String.valueOf(cur.divide(BigInteger.valueOf(2))) + " " + (cur.subtract(BigInteger.ONE)).divide(BigInteger.valueOf(2)));
//                System.out.println();
                return cur;
            }
            BigInteger val1 = cur.divide(BigInteger.valueOf(2));
            queue.add(val1);
            BigInteger val2 = cur.subtract(BigInteger.ONE).divide(BigInteger.valueOf(2));
            queue.add(val2);
            queue.sort((o1, o2) -> o2.compareTo(o1));
            k = k.subtract(BigInteger.ONE);
        }
        return null;
    }
}