package google;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;


/**
 * Created by Anna on 08.04.2017.
 */
public class TidyNumbers {

    private static void readData() throws IOException {
        BufferedReader br = new BufferedReader(new FileReader("test.in"));
        int numOfTests = Integer.parseInt(br.readLine());
        PrintWriter writer = new PrintWriter("data.txt", "UTF-8");
        for (int i = 1; i <= numOfTests; i++) {
            String data = br.readLine();
            long num = findLastNumber(Long.parseLong(data));
            writer.println("Case #" + i + ": " +num);
        }
        writer.close();
    }

    private static long findLastNumber(Long number) {
         for (long i = number; i >= 0; i--){
             if (checkNumber(i)){
                 return i;
             }
             String curr = String.valueOf(i);
             int length = curr.length();
             if (curr.contains("0")){
                 int index = curr.indexOf("0");
                 curr = curr.substring(0,index) + zeroStr(index, length);
             }
             i = Long.parseLong(curr);
         }
        return 0;
    }

    private static String zeroStr(int begin, int end){
        String s = "";
        for (int i = begin; i < end; i++){
            s += "0";
        }
        return s;
    }

    private static boolean checkNumber(long num){
        String str = String.valueOf(num);
        for (int i = 0; i < str.length() - 1; i++){
            if (str.charAt(i) > str.charAt(i + 1)){
                return false;
            }
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        readData();
    }
}
