package google;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Map;
import java.util.TreeMap;
import java.util.function.Function;

/**
 * Created by Anna on 08.04.2017.
 */
public class Bathroom {


    private static void readData() throws Exception {
        BufferedReader br = new BufferedReader(new FileReader("test.in"));
        String str = br.readLine();
        long numOfTest = Long.parseLong(str);
        PrintWriter writer = new PrintWriter("data.txt", "UTF-8");
        for (long i = 1; i <= numOfTest; i++) {
            String[] strFile = br.readLine().split(" ");
            Long length = Long.parseLong(strFile[0]);
            Long k = Long.parseLong(strFile[1]);
            TreeMap<Long, Long> longervalMap
                    = new TreeMap<Long, Long>();
            longervalMap.put(length, 1L);
            String answer = processlongerval(longervalMap, k);
            writer.println("Case #" + i + ": " + answer);
        }
        writer.close();
    }

    private static String processlongerval(TreeMap<Long, Long> longervalMap,
                                          long k) {
        long leftDist = 0;
        long rightDist = 0;
        while (k > 0) {
            k--;
            Map.Entry<Long, Long> lengthEntry = longervalMap.lastEntry();
            long length = lengthEntry.getKey();
            long freq = lengthEntry.getValue();
            if (length == 1) {
                clearMap(longervalMap, length, freq);
                leftDist = 0;
                rightDist = 0;
                continue;
            }
            long part = (length - 1) % 2;
            leftDist = (length - 1) / 2 + part;
            rightDist = (length - 1) / 2;

            clearMap(longervalMap, length, freq);
            addDistance(longervalMap, leftDist);
            addDistance(longervalMap, rightDist);
        }
        return leftDist + " " + rightDist;
    }

    private static void clearMap(TreeMap<Long, Long> longervalMap, long dist, long freq) {
        if (freq == 1) {
            longervalMap.remove(dist);
        } else {
            longervalMap.put(dist, freq - 1);
        }
    }

    private static void addDistance(TreeMap<Long, Long> longervalMap, long dist) {
        if (dist == 0) {
            return;
        }
        Long oldFreq = longervalMap.computeIfAbsent(dist, new Function<Long, Long>() {
            @Override
            public Long apply(Long Long) {
                return 0L;
            }
        });
        longervalMap.put(dist, oldFreq + 1);
    }


    public static void main(String[] args) throws Exception {
        readData();
    }
}
