import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Solution {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int k = 1; k <= t; ++k) {
            int n = in.nextInt();
            int q = in.nextInt();
            int[] e = new int[n];
            int[] s = new int[n];
            int[][] dist = new int[n][n];

            for (int i = 0; i < n; ++i) {
                e[i] = in.nextInt();
                s[i] = in.nextInt();
            }
            for (int i = 0; i < n; ++i) {
                for (int j = 0; j < n; ++j) {
                    dist[i][j] = in.nextInt();
                }
            }

            double[][] distNoChange = new double[n][n];
            dijkstra(dist, e, s, distNoChange, n);

            System.out.print("Case #" + k + ":");
            for (int i = 0; i < q; ++i) {
                int u = in.nextInt(), v = in.nextInt();
                System.out.print(" " + solve(n, distNoChange, u - 1, v - 1));
            }
            System.out.println();
        }
    }

    private static void dijkstra(int[][] dist, int[] e, int[] s, double[][] distNoChange, int n) {
        for (int i = 0; i < n; ++i)
            for (int j = 0; j < n; ++j)
                distNoChange[i][j] = -1;
        for (int start = 0; start < n; ++start) {
            // ride from start to every city without change a horse
            int speed = s[start];
            int strength = e[start];
            boolean[] visited = new boolean[n];
            PriorityQueue<Tuple> heap = new PriorityQueue<>();
            heap.add(new Tuple(start, 0));
            while (!heap.isEmpty()) {
                Tuple curr = heap.poll();
                int i = curr.city;
                if (visited[i] || curr.d > strength) continue;
                visited[i] = true;
                distNoChange[start][i] = curr.d / speed;
                for (int j = 0; j < n; ++j) {
                    if (dist[i][j] < 0 || visited[j]) continue;
                    heap.add(new Tuple(j, curr.d + dist[i][j]));
                }
            }
        }
    }


    private static double solve(int n, double[][] dist, int u, int v) {
        boolean[] visited = new boolean[n];
        PriorityQueue<Tuple> heap = new PriorityQueue<>();
        heap.add(new Tuple(u, 0));
        while (!heap.isEmpty()) {
            Tuple curr = heap.poll();
            int i = curr.city;
            if (i == v) return curr.d;
            if (visited[i]) continue;
            visited[i] = true;
            for (int j = 0; j < n; ++j) {
                if (dist[i][j] < 0 || visited[j]) continue;
                heap.add(new Tuple(j, curr.d + dist[i][j]));
            }
        }
        throw new IllegalStateException("Not reachable from " + u + " to " + v);
    }

}

class Tuple implements Comparable<Tuple> {
    double d;
    int city;

    Tuple(int city, double d) {
        this.city = city;
        this.d = d;
    }

    @Override
    public int compareTo(Tuple that) {
        if (this.d < that.d) return -1;
        if (this.d > that.d) return +1;
        return 0;
    }
}

