import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Solution {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            int n = in.nextInt();
            int m = in.nextInt();
            in.nextLine();
            char[][] grid = new char[n + 1][n + 1];
            for (int j = 0; j < m; ++j) {
                String[] line = in.nextLine().split(" ");
                int x = Integer.valueOf(line[1]);
                int y = Integer.valueOf(line[2]);
                grid[x][y] = line[0].charAt(0);
            }
            bestStyle(i, n, m, grid);
        }
    }

    private static void bestStyle(int case_i, int n, int m, char[][] grid) {

        List<String> list = new ArrayList<>();
        // first row, n + 1
        int oy = 1;
        for (int col = 1; col <= n; ++col) {
            if (grid[1][col] == 'o' || grid[1][col] == 'x') {
                oy = col;
                break;
            }
        }

        if (grid[1][oy] != 'o') list.add("o 1 " + oy);
        for (int col = 1; col <= n; ++col) {
            if (col != oy && grid[1][col] != '+') list.add("+ 1 " + col);
        }

        int score = n + 1;

        // last row

        for (int col = 2; col <= n - 1; ++col) {
            list.add("+ " + n + " " + col);
            score++;
        }

        // diag
        int col = n;
        for (int row = n; row >= 2; --row) {
            if (col == oy) col++;
            if (col > n) col = 1;
            list.add("x " + row + " " + col);
            col++;
            if (col > n) col = 1;
        }
        score += n - 1;

        System.out.println("Case #" + case_i + ": " + score + " " + list.size());
        for (String line : list) System.out.println(line);
    }

}
