import java.io.*;
import java.util.*;

public class Solution {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            System.out.print("Case #" + i + ": ");
            int N = in.nextInt();
            int R = in.nextInt();
            int O = in.nextInt();
            int Y = in.nextInt();
            int G = in.nextInt();
            int B = in.nextInt();
            int V = in.nextInt();
            solveSix(N, R, O, Y, G, B, V);
        }

    }

    private static void solveSix(int N, int R, int O, int Y, int G, int B, int V) {
        // special cases
        if (special(N, R, G, 'R', 'G') || special(N, Y, V, 'Y', 'V') || special(N, B, O, 'B', 'O'))
            return;
        String ans = solveThree(N, R - G, Y - V, B - O);

        int i = ans.indexOf("R");
        if (i >= 0) ans = ans.substring(0, i) + build(G, 'R', 'G') + ans.substring(i);
        i = ans.indexOf("Y");
        if (i >= 0) ans = ans.substring(0, i) + build(V, 'Y', 'V') + ans.substring(i);
        i = ans.indexOf("B");
        if (i >= 0) ans = ans.substring(0, i) + build(O, 'B', 'O') + ans.substring(i);
        System.out.println(ans);
    }

    private static boolean special(int N, int C1, int C2, char ch1, char ch2) {
        if (C1 > C2) return false;
        if (C1 < C2) System.out.println("IMPOSSIBLE");
        else {
            if (C1 == 0) return false;
            if (C1 + C2 < N) System.out.println("IMPOSSIBLE");
            System.out.println(build(C1, ch1, ch2));
        }
        return true;
    }

    private static String build(int n, char ch1, char ch2) {
        StringBuilder ans = new StringBuilder();
        for (int i = 0; i < n; ++i) ans.append(ch1).append(ch2);
        return ans.toString();
    }

    private static String solveThree(int N, int R, int Y, int B) {
        if (R + Y < B || R + B < Y || Y + B < R) return "IMPOSSIBLE";
        List<String> res = new ArrayList<>();
        if (R >= Y && R >= B) {
            return buildThree(N, R, Y, B, "R", "Y", "B");
        } else if (Y >= R && Y >= B) {
            return buildThree(N, Y, B, R, "Y", "B", "R");
        } else {
            return buildThree(N, B, R, Y, "B", "R", "Y");
        }
    }

    private static String buildThree(int N, int C1, int C2, int C3, String ch1, String ch2, String ch3) {
        List<String> res = new ArrayList<>();
        for (int i = 0; i < C1; ++i)
            res.add(ch1);
        for (int i = 0; i < N - C1; ++i) {
            if (C2-- > 0) res.add((i * 2) % (C1 * 2), ch2);
            else if (C3-- > 0) res.add((i * 2) % (C1 * 2), ch3);
        }
        return String.join("", res);
    }


}
