import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;


public class WaterShed {
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream("B-small-attempt0.in")));
		String config = br.readLine();
		int maps = Integer.parseInt(config);
		for(int mI=0;mI<maps;mI++){
			
			config = br.readLine();
			String splitConfig[] = config.split(" ");
			int H = Integer.parseInt(splitConfig[0]);
			int W = Integer.parseInt(splitConfig[1]);
			
			Cells.cells = new Cell[H+2][W+2];
			Cells.labelIndex = -1;
			for(int i=0;i<=H;i++){
				Cells.cells[i][0] = new Cell(99999);
				Cells.cells[i][W+1] = new Cell(99999);
			}
			for(int i=0;i<=W;i++){
				Cells.cells[0][i] = new Cell(99999);
				Cells.cells[H+1][i] = new Cell(99999);
			}
			for(int i=1;i<=H;i++)
			{
				String row = br.readLine();
				String splitRow[] = row.split(" ");
				for(int j=1;j<=W;j++){
					Cells.cells[i][j]= new Cell(Integer.parseInt(splitRow[j-1]));
				}
			}
			
			
			
			for(int i=1;i<=H;i++){
				for(int j=1;j<=W;j++){			
					Cells.assignLabel(i, j);
				}
			}
		
			
			
			System.out.println("Case #"+(mI+1)+":");	
			for(int i=1;i<=H;i++){
				
				for(int j=1;j<=W;j++){
					System.out.print(Cells.cells[i][j].label);
					if(j<W)
						System.out.print(' ');
				}
				System.out.println("");
			}
		}
	}

}


class Cells{
	static Cell[][] cells;
	static byte labelIndex=-1;
	static char assignLabel(int i,int j){
		if(isBasin(i,j)){
			if(cells[i][j].isLabelled())
				return cells[i][j].label;
			else{
				labelIndex++;
				cells[i][j].label=(char)(labelIndex+97);
				return cells[i][j].label;
			}
		}
		else{
			if((cells[i-1][j].altitude <= cells[i][j-1].altitude)&&(cells[i-1][j].altitude <= cells[i][j+1].altitude)&&(cells[i-1][j].altitude <= cells[i+1][j].altitude)){
				//North Min
				if(cells[i-1][j].isLabelled()){
					cells[i][j].label=cells[i-1][j].label;
					return cells[i][j].label;
				}
				else{
					cells[i][j].label = assignLabel(i-1, j);
					return cells[i][j].label;
				}
			}
			else if((cells[i][j-1].altitude <= cells[i-1][j].altitude)&&(cells[i][j-1].altitude <= cells[i][j+1].altitude)&&(cells[i][j-1].altitude <= cells[i+1][j].altitude)){
				//West Min
				if(cells[i][j-1].isLabelled()){
					cells[i][j].label=cells[i][j-1].label;
					return cells[i][j].label;
				}
				else{
					cells[i][j].label = assignLabel(i, j-1);
					return cells[i][j].label;
				}
			}
			else if((cells[i][j+1].altitude <= cells[i-1][j].altitude)&&(cells[i][j+1].altitude <= cells[i][j-1].altitude)&&(cells[i][j+1].altitude <= cells[i+1][j].altitude)){
				//East Min
				if(cells[i][j+1].isLabelled()){
					cells[i][j].label=cells[i][j+1].label;
					return cells[i][j].label;
				}
				else{
					cells[i][j].label = assignLabel(i, j+1);
					return cells[i][j].label;
				}
			}
			else
			{
				if(cells[i+1][j].isLabelled()){
					cells[i][j].label=cells[i+1][j].label;
					return cells[i][j].label;
				}
				else{
					cells[i][j].label = assignLabel(i+1, j);
					return cells[i][j].label;
				}
			}
			
		}
	}
	static boolean isBasin(int i,int j){
		if((cells[i][j].altitude <= cells[i-1][j].altitude)&&(cells[i][j].altitude <= cells[i+1][j].altitude)&&(cells[i][j].altitude <= cells[i][j-1].altitude)&&(cells[i][j].altitude <= cells[i][j+1].altitude)){
			return true;
		}
		return false;
	}
}

class Cell{
	int altitude;
	char label;	
	Cell(){
		altitude=0;
		label='*';
	}
	Cell(int altitude){
		this.altitude=altitude;
		label='*';
	}
	boolean isLabelled(){
		return label!='*';
	}
}
