package r1b;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.io.ObjectInputStream.GetField;
import java.util.ArrayList;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class DecisionTree {

	public static void main(String[] args) throws Exception{
		
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream("A-small.in")));
		int N = Integer.parseInt(br.readLine());
		for(int iN=1;iN<=N;iN++){
			System.out.println("Case #"+iN+":");
			int L = Integer.parseInt(br.readLine());
			StringBuffer sb = new StringBuffer("");
			for(int iL=1;iL<=L;iL++){
				sb.append(" "+br.readLine());
			}
			Expression e = new Expression(sb.toString());
			int A = Integer.parseInt(br.readLine());
			for(int iA=1;iA<=A;iA++){
				String aString = br.readLine();
				String baString[] = aString.split(" ");
				Animal a = new Animal();
				a.name = baString[0];
				for(int i=0;i<Integer.parseInt(baString[1]);i++){
					a.features.add(baString[i+2]);
				}
				System.out.printf("%.7f%n",getCuteness(e, a));
			}
		}

	}
	
	static float getCuteness(Expression e, Animal a){
		//System.out.println(e.expr);
		a.cuteness = e.getWeight()*a.cuteness;
		if(e.isLeaf()){
			return a.cuteness;
		}
		else{
			if(a.doesContain(e.getFeature())){
				return getCuteness(e.getLeftExpression(), a);
			}
			else{
				return getCuteness(e.getRightExpression(), a);
			}
		}
	}

}



class Animal{
	String name;
	float cuteness = 1;
	ArrayList <String> features = new ArrayList();
	
	boolean doesContain(String feature){
		return features.contains(feature);
	}
}

class Expression {
	String expr;
	
	Expression(String expr){
		this.expr = expr;
		//System.out.println(expr);
	}

	float getWeight() {
		
		int opi = expr.indexOf("(")+1+expr.substring(expr.indexOf("(")+1).indexOf("(");
		
		int cpi = expr.indexOf("(")+1+expr.substring(expr.indexOf("(")+1).indexOf(")");
		
		int pi = -1;
		if ((opi < cpi) && (opi != -1)) {
			pi = cpi;
		} else {
			pi = opi;
		}

		String temp = expr.substring(expr.indexOf("(")+1, pi);
		int i = -1;
		String[] result = temp.split("( )+");
		while (true) {
			i++;
			try {
				return Float.parseFloat(result[i]);
			} catch (Exception e) {
			}
		}
	}
	
	String getFeature(){
		int opi = expr.indexOf("(")+1+expr.substring(expr.indexOf("(")+1).indexOf("(");
		
		int cpi = expr.indexOf("(")+1+expr.substring(expr.indexOf("(")+1).indexOf(")");
		
		int pi = -1;
		if ((opi < cpi) && (opi != -1)) {
			pi = cpi;
		} else {
			pi = opi;
		}

		String temp = expr.substring(expr.indexOf("(")+1, pi);
		int i = -1;
		String[] result = temp.split("( )+");
		while (true) {
			i++;
			try{
			if(result[i].charAt(0)>='a'&&result[i].charAt(0)<='z'){
				return result[i];
			}}
			catch(Exception e){}
		}
	}
	
	boolean isLeaf(){
		return expr.substring(expr.indexOf("(")+1).indexOf("(")==-1;
	}
	
	Expression getLeftExpression(){
		int opi = expr.indexOf("(")+1+ expr.substring(expr.indexOf("(")+1).indexOf("(")+1;
		int opc = 1 ;
		while(opc!=0){
			opi++;
			if(expr.charAt(opi)=='(')
				opc++;
			else if(expr.charAt(opi)==')')
				opc--;
		}
		return new Expression(expr.substring(expr.substring(expr.indexOf("(")+1).indexOf("("),opi+1));
	}
	
	Expression getRightExpression(){	
		Expression nE = new Expression(expr.replace(getLeftExpression().expr,""));
		return nE.getLeftExpression();
	}
}