package com.walltor;

import java.io.BufferedReader;
import java.io.FileReader;
import java.math.BigInteger;
import java.util.LinkedList;

public class FairSquare {

	static LinkedList<BigInteger> fairSquares = new LinkedList<BigInteger>();

	public static boolean isPalindrome(String number) {
		return number.equals(new StringBuffer().append(number).reverse()
				.toString());
	}

	public static boolean isPalindrome(BigInteger num) {
		return isPalindrome(num.toString());
	}

	public static void main(String[] args) throws Exception {

		BigInteger MAX = new BigInteger("10000000");
		for (BigInteger i = new BigInteger("1"); MAX.compareTo(i) >= 0; i = i
				.add(BigInteger.ONE)) {
			if (fairSquares.size() > 10) {
				
				if(!i.toString().matches("^[120]+$"))
					continue;
			}
			if (isPalindrome(i)) {
				BigInteger possibleFSN = i.pow(2);
				if (isPalindrome(possibleFSN)) {
					fairSquares.add(possibleFSN);
				}
			}
		}
		
		BufferedReader in = new BufferedReader(new FileReader("in.txt"));
		int testCases = Integer.parseInt(in.readLine());
		for (int i = 1; i <= testCases; i++) {
			String input = in.readLine();
			BigInteger start = new BigInteger(new String(input.split(" ")[0]));
			BigInteger end = new BigInteger(new String(input.split(" ")[1]));
			int fsnCount = 0;
			for(BigInteger fsn : fairSquares){
				if(fsn.compareTo(end) == 1)
					break;
				if(fsn.compareTo(start) >= 0)
					fsnCount ++;
			}
			
			System.out.println("Case #"+i+": "+fsnCount);
			
		}
		in.close();
	}
	
}
