import java.util.Arrays;
import java.util.LinkedList;
import java.util.Scanner;


public class C {

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    int T = in.nextInt();
    for (int t = 1; t <= T; t++) {
      C me = new C();
      System.out.printf("Case #%d: ", t);
      me.solve(in);
    }
  }

  int m, n, B;
  int[][] coords;

  public void solve(Scanner in) {

    m = in.nextInt();
    n = in.nextInt();
    B = in.nextInt();


    coords = new int[B][4];
    for (int i = 0; i < B; i++) {
      coords[i][0] = in.nextInt();
      coords[i][1] = in.nextInt();
      coords[i][2] = in.nextInt();
      coords[i][3] = in.nextInt();
    }

    int[][] flow = new int[n][m];

    for (int i = 0; i < n; i++) {
      Arrays.fill(flow[i], 1);
    }

    for (int b = 0; b < B; b++) {
      int xlo = coords[b][1];
      int xhi = coords[b][3];
      int ylo = coords[b][0];
      int yhi = coords[b][2];
      for (int i = xlo; i <= xhi; i++) {
        for (int j = ylo; j <= yhi; j++) {
          flow[i][j] = 0;
        }
      }
    }

    // for (int i = 0; i < n; i++) {
    // for (int j = 0; j < m; j++) {
    // System.out.print(flow[i][j] + " ");
    // }
    // System.out.println();
    // }

    int res = 0;

    for (int i = 0; i < m; i++) {
      res += maxFlow(flow, i);
    }

    System.out.println(res);

  }

  public int maxFlow(int[][] flow, int start) {

    if (flow[0][start] == 0)
      return 0;

    LinkedList<Point> q = new LinkedList<Point>();
    q.add(new Point(0, start, null));


    boolean[][] visited = new boolean[n][m];


    while (!q.isEmpty()) {

      Point cur = q.poll();

      if (flow[cur.x][cur.y] == 0)
        continue;

      // System.out.println(cur.x + " " + cur.y);
      if (cur.x == n - 1) {
        while (cur != null) {
          flow[cur.x][cur.y] = 0;
          cur = cur.prev;
        }
        return 1;
      }

      visited[cur.x][cur.y] = true;

      int[][] dir = new int[][] { {0, 0, -1, 1}, {1, -1, 0, 0}};

      for (int i = 0; i < 4; i++) {


        int newx = cur.x + dir[0][i];
        int newy = cur.y + dir[1][i];
        if (newx < 0 || newy < 0 || newx >= n || newy >= m)
          continue;
        if (flow[newx][newy] == 0)
          continue;

        if (!visited[newx][newy]) {
          q.add(new Point(newx, newy, cur));
          visited[newx][newy] = true;
        }
      }

    }


    return 0;
  }

  class Point {
    int x, y;
    Point prev;

    public Point(int x, int y, Point prev) {
      this.x = x;
      this.y = y;
      this.prev = prev;
    }
  }
}
