import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

public class Round2B {

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for (int i = 0; i < T; i++) {
			String ans = solve(in);
			System.out.printf("Case #%d: %s\n", i + 1, ans);
		}

	}

	public static String solve(Scanner in) {
		int N = in.nextInt();
		double V = in.nextDouble();
		double X = in.nextDouble();

		Flow[] flows = new Flow[N];
		for (int i = 0; i < N; i++) {
			flows[i] = new Flow(in.nextDouble(), in.nextDouble());
		}
		// Reduce the flows
		for (int i = 0; i < N; i++) {
			for (int j = i + 1; j < N; j++) {
				if (flows[i].temp == flows[j].temp) {
					flows[i].rate += flows[j].rate;
					flows[j].rate = 0;
				}
			}
		}
		ArrayList<Flow> reducedFlows = new ArrayList<Flow>();
		for (Flow f : flows) {
			if (f.rate != 0) {
				reducedFlows.add(f);
			}
		}

		return solve(reducedFlows, V, X);
	}

	public static String solve1(Flow flow, double V, double X) {
		if (flow.temp != X) {
			return "IMPOSSIBLE";
		}
		double time = V / flow.rate;
		return String.format("%.8f", time);
	}

	public static String solve(ArrayList<Flow> flows, double V, double X) {
		ArrayList<Flow> belowTemp = new ArrayList<Flow>();
		ArrayList<Flow> aboveTemp = new ArrayList<Flow>();

		Flow equivalent = null;

		for (Flow f : flows) {
			if (f.temp == X) {
				equivalent = f;
			}

			if (f.temp < X) {
				belowTemp.add(f);
			} else {
				aboveTemp.add(f);
			}
		}

		if (flows.size() == 1) {
			return solve1(flows.get(0), V, X);
		}

		if (belowTemp.isEmpty() || aboveTemp.isEmpty()) {
			if (equivalent != null) {
				return solve1(equivalent, V, X);
			}

			return "IMPOSSIBLE";
		}

		Collections.sort(aboveTemp);
		Collections.sort(belowTemp);

		// Making the assumption that we should always use all sources of water
		// **shrug**

		return solve2(aboveTemp.get(0), belowTemp.get(0), V, X);
	}

	public static String solve2(Flow above, Flow below, double V, double X) {

		double volumeAbove = (V * X - V * below.temp)
				/ (above.temp - below.temp);
		double volumeBelow = V - volumeAbove;

		double result = Math.max(volumeAbove / above.rate, volumeBelow
				/ below.rate);

		return String.format("%.8f", result);
	}

	static class Flow implements Comparable<Flow> {
		double rate, temp;

		public Flow(double r, double t) {
			rate = r;
			temp = t;
		}

		// Sort by increasing temp/flow
		@Override
		public int compareTo(Flow o) {
			int compare = Double.compare(temp, o.temp);
			if (compare == 0) {
				compare = Double.compare(rate, o.rate);
			}
			return compare;
		}

	}

}
