import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTacToeTomek
{
    static PrintWriter out;


    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        try
        {
            out =
                new PrintWriter(new FileWriter(
                    "C:\\Users\\micha_000\\output.txt"));
        }
        catch (IOException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

        int N = in.nextInt();
        in.nextLine();

        int[][] board = new int[4][4];

        // For each case
        for (int i = 1; i <= N; i++)
        {
            boolean notFinished = false;

            // Input board
            for (int j = 0; j < 4; j++)
            {
                String line = in.nextLine();

                for (int k = 0; k < 4; k++)
                {
                    int next = -1;
                    switch (line.charAt(k))
                    {
                        case '.':
                            next = 0;
                            notFinished = true;
                            break;
                        case 'X':
                            next = 100;
                            break;
                        case 'O':
                            next = 1;
                            break;
                        case 'T':
                            next = 1000;
                            break;
                    }
                    board[j][k] = next;
                }
            }
            in.nextLine();
            solve(i, board, notFinished);
        }
    }


    static void solve(int caseno, int[][] board, boolean notFin)
    {
        System.out.printf("Case #%d: ", caseno);

        // Add up columns & rows
        for (int i = 0; i < 4; i++)
        {
            int rowSum = 0;
            int colSum = 0;
            for (int j = 0; j < 4; j++)
            {
                rowSum += board[i][j];
                colSum += board[j][i];
            }

            if (analyzeSum(rowSum) || analyzeSum(colSum))
                return;
        }

        int diag1 = board[0][0] + board[1][1] + board[2][2] + board[3][3];
        int diag2 = board[0][3] + board[1][2] + board[2][1] + board[3][0];

        if (analyzeSum(diag1) || analyzeSum(diag2))
        {
            return;
        }

        if (notFin)
        {
            System.out.println("Game has not completed");
        }
        else
        {
            System.out.println("Draw");
        }
    }


    static boolean analyzeSum(int sum)
    {
        switch (sum)
        {
            case 4:
            case 1003:
                System.out.println("O won");
                return true;
            case 400:
            case 1300:
                System.out.println("X won");
                return true;
            default:
                return false;
        }
    }

}
