import java.util.Collections;
import java.util.ArrayList;
import java.util.Scanner;

public class Walls
{

    static class Tribe
    {
        int d, n, w, e, s;
        int deltad, deltap, deltas;
        int attack = 0;


        public Tribe(
            int d,
            int n,
            int w,
            int e,
            int s,
            int deltad,
            int deltap,
            int deltas)
        {
            this.d = d;
            this.n = n;
            this.w = w;
            this.e = e;
            this.s = s;
            this.deltad = deltad;
            this.deltap = deltap;
            this.deltas = deltas;
        }


        public boolean hasAttack()
        {
            return attack < n;
        }


        public Attack getAttack()
        {
            if (attack == n)
            {
                return null;
            }

            int day = d + attack * deltad;
            int strength = s + attack * deltas;
            int neww = w + deltap * attack;
            int newe = e + deltap * attack;
            attack++;

            Attack ans = new Attack(neww, newe, strength, day);
            return ans;
        }


        public int lastAttack()
        {
            return d + n * deltad;
        }
    }


    public static void main(String[] args)
    {

        Scanner in = new Scanner(System.in);

        int T = in.nextInt();

        for (int i = 1; i <= T; i++)
        {
            int num_attack = in.nextInt();
            Tribe[] tribes = new Tribe[num_attack];

            for (int j = 0; j < num_attack; j++)
            {
                tribes[j] =
                    new Tribe(
                        in.nextInt(),
                        in.nextInt(),
                        in.nextInt(),
                        in.nextInt(),
                        in.nextInt(),
                        in.nextInt(),
                        in.nextInt(),
                        in.nextInt());
            }

            System.out.printf("Case #%d: %d\n", i, solve(tribes));

        }

    }


    public static class Attack
        implements Comparable
    {
        int w, e, strength;
        int day;


        public Attack(int w, int e, int strength, int day)
        {
            this.day = day;
            this.w = w;
            this.e = e;
            this.strength = strength;
        }


        @Override
        public int compareTo(Object o)
        {
            Attack other = (Attack)o;

            return -1*other.day + this.day;
        }
    }


    public static int solve(Tribe[] t)
    {
        int ans = 0;
        int[] wall = new int[2000000];
        int[] wallToBe = new int[2000000];
        ArrayList<Attack> attacks = new ArrayList<Attack>();

        for (int i = 0; i < t.length; i++)
        {
            while (t[i].hasAttack())
            {
                attacks.add(t[i].getAttack());
            }
        }

        Collections.sort(attacks);

        int curDay = attacks.get(0).day;
        for (int i = 0; i < attacks.size(); i++)
        {

            Attack next = attacks.get(i);

            if (next.day > curDay)
            {
                curDay = next.day;
                wall = wallToBe.clone();
            }
            boolean success = false;
            for (int j = next.w; j <= next.e; j++)
            {

                int current = j + 1000000;
                if (wall[current] < next.strength)
                {
                    //System.out.println("Success on day " + cu)
                    success = true;
                    wallToBe[current] = next.strength;
                }
            }

            if (success)
            {
                ans++;
            }
        }

        return ans;

    }
}
