import java.util.Scanner;

public class Round2A {

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for (int i = 0; i < T; i++) {
			String ans = solve(in);
			System.out.printf("Case #%d: %s\n", i + 1, ans);
		}

	}

	static int R, C;
	static char[][] board;

	static String BAD = "IMPOSSIBLE";

	static char[] choices = { '<', '>', 'v', '^' };

	public static String solve(Scanner in) {
		R = in.nextInt();
		C = in.nextInt();
		board = new char[R][C];

		for (int i = 0; i < R; i++) {
			String line = in.next();
			for (int j = 0; j < C; j++) {
				board[i][j] = line.charAt(j);
			}
		}

		int ans = 0;

		for (int i = 0; i < R; i++) {
			for (int j = 0; j < C; j++) {
				boolean fallsOff = fallsOff(i, j);
				if (fallsOff) {
					if (anyOthers(i, j)) {
						ans++;
					} else {
						return BAD;
					}
				}

			}
		}

		return "" + ans;
	}

	// Returns true if there are any arrows in our row/col
	// other than us
	public static boolean anyOthers(int r, int c) {
		for (int i = 0; i < R; i++) {
			if (i == r) {
				continue;
			}
			if (board[i][c] != '.') {
				return true;
			}
		}

		for (int j = 0; j < C; j++) {
			if (j == c) {
				continue;
			}
			if (board[r][j] != '.') {
				return true;
			}

		}

		return false;
	}

	// Will he fall off in one go starting at (r, c)?
	public static boolean fallsOff(int r, int c) {
		if (board[r][c] == '.') {
			return false;
		}

		int xdir = 0;
		int ydir = 0;
		switch (board[r][c]) {
		case 'v':
			ydir = 1;
			break;
		case '^':
			ydir = -1;
			break;
		case '>':
			xdir = 1;
			break;
		case '<':
			xdir = -1;
			break;
		}

		while (true) {
			r += ydir;
			c += xdir;
			if (r >= R || r < 0 || c >= C || c < 0) {
				return true;
			}
			if (board[r][c] != '.') {
				return false;
			}
		}
	}

	static class Spot {
		int r, c;

		public Spot(int r, int c) {
			this.r = r;
			this.c = c;
		}
	}

}
