import java.util.Arrays;
import java.math.BigInteger;
import java.util.List;
import java.util.Set;
import java.util.HashSet;

public class GenerateCoins {
    public static List<Integer> BASES = Arrays.asList(2, 3, 4, 5, 6, 7, 8, 9, 10);

    static void generateStrings(String prefix, int k, Set<String> strings) {
        if (k == 0) {
            String prefixP1 = prefix + "1";
            for (int base : BASES) {
                BigInteger bigInt = new BigInteger(prefixP1, base);
                if (bigInt.isProbablePrime(120)) {
                    return;
                }
            }
            strings.add(prefixP1);
            return;
        }
        generateStrings(prefix + "0", k - 1, strings);
        generateStrings(prefix + "1", k - 1, strings);
    }

    public static void main(String[] args) {
        Set<String> set = new HashSet<>();
        generateStrings("1", 14, set);
        BigInteger TWO = new BigInteger("2");
        System.out.println("Case #1: ");
        int j = 0;
        for (String string : set) {
            String answer = string + " ";
            for (int base : BASES) {
                BigInteger bigInt = new BigInteger(string, base);
                BigInteger oneHalf = bigInt.divide(TWO);
                for (BigInteger i = TWO; i.compareTo(oneHalf) == -1; i = i.add(BigInteger.ONE)) {
                    if (bigInt.remainder(i).equals(BigInteger.ZERO)) {
                        answer += i + " ";
                        break;
                    }
                }
            }
            System.out.println(answer);
            j++;
            if (j == 50) break;
        }
    }
}
