import java.util.*;

public class SheepCount {

    private static final String DIGITS = "0123456789";
    private long N;
    private Set<Character> unseenChars;

    public SheepCount(long N) {
        this.N = N;
        unseenChars = new HashSet<Character>();
        for (char c : DIGITS.toCharArray()) {
            unseenChars.add(c);
        }
    }

    String findAnswer() {
        long sum = 0;
        do {
            sum += N;
            String num = Long.toString(sum);
            for (char c : num.toCharArray()) {
                unseenChars.remove(c);
            }
        } while (unseenChars.size() > 0);
        return Long.toString(sum);
    }


    public static void main(String[] arg) {
        Scanner scanner = new Scanner(System.in);

        int T = scanner.nextInt();

        for (int i = 0; i < T; i++) {
            long N = scanner.nextLong();
            
            String answer;
            if (N == 0) {
                answer = "INSOMNIA";
            } else {
                answer = new SheepCount(N).findAnswer();
            }

            System.out.println("Case #" + (i + 1) + ": " + answer);
        }
    }
}
