import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;


public class Round2 {
	public static void main(String[] args) {
		new Round2();
	
	}
	private Scanner in;
	private HashMap<Character,String> translator = new HashMap<Character,String>();
	public Round2(){
		try {
			in = new Scanner(new File("../Text/A.in"));
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		int cases = in.nextInt();
		in.nextLine();
		for (int i = 1; i <= cases; i++) {
			solve(i);
			in.nextLine();
		}
		
		in.close();

	}

	public void solve(int caseNr) {
		String result="";
		char[][] maze = new char[4][4];
		for (int i = 0; i < maze.length; i++) {
			String line = in.nextLine();
			char[] chars = line.toCharArray();
			for (int j = 0; j < chars.length; j++) {
				maze[i][j] = chars[j];
			}
		}
		Outcome outcome = checkHorizontal(maze);
		if(outcome==Outcome.X||outcome==Outcome.O){
			result=outcome.toString();
			System.out.println("Case #"+caseNr+": "+result);
			return;
		}
		outcome = checkDiagonals(maze);
		if(outcome==Outcome.X||outcome==Outcome.O){
			result=outcome.toString();
			System.out.println("Case #"+caseNr+": "+result);
			return;
		}
		outcome=checkVertical(maze);
		result=outcome.toString();
		System.out.println("Case #"+caseNr+": "+result);
			


	}

	private Outcome checkDiagonals(char[][] maze) {
		char reference = maze[0][0];
		boolean success=true;
		boolean undone = false;
		for (int i = 1; i < 4; i++) {
			char c = maze[i][i];
			if(reference=='T'){
				reference= c;
			}
			if(!(c==reference||c=='T'))
				success=false;
			if(c=='.')
				undone=true;
		}
		if(!(interpretSuccess(reference, success)==null)){
			return interpretSuccess(reference, success);
		}		
		success=true;
		undone = false;
		reference = maze[3][0];
		for (int i = 1; i < 4; i++) {
			char c = maze[3-i][i];
			if(reference=='T'){
				reference= c;
			}
			if(!(c==reference||c=='T'))
				success=false;
			if(c=='.')
				undone=true;
		}
		if(!(interpretSuccess(reference, success)==null)){
			return interpretSuccess(reference, success);
		}		
		return interpretRest(undone);
		
	}

	private Outcome checkVertical(char[][] maze) {
		boolean undone = false;
		for (int i = 0; i < maze.length; i++) {
			char reference = maze[0][i];
			boolean success=true;
			for (int j = 1; j < maze.length; j++) {
				char c = maze[j][i];
				if(reference=='T'){
					reference= c;
				}
				if(!(c==reference||c=='T'))
					success=false;
				if(c=='.')
					undone=true;
			}
			if(!(interpretSuccess(reference, success)==null)){
				return interpretSuccess(reference, success);
			}
				
			
		}
		return interpretRest(undone);
		
	}

	private Outcome interpretRest(boolean undone) {
		if(undone)
			return Outcome.UNDONE;
		return Outcome.DRAW;
	}

	private Outcome interpretSuccess(char reference, boolean success) {
		if(success){
			if(reference=='O')
				return Outcome.O;
			else if(reference=='X')
				return Outcome.X;
		}
		return null;
	}

	private Outcome checkHorizontal(char[][] maze) {
		boolean undone = false;
		for (int i = 0; i < maze.length; i++) {
			char reference = maze[i][0];
			boolean success=true;
			for (int j = 1; j < maze.length; j++) {
				char c = maze[i][j];
				if(reference=='T'){
					reference= c;
				}
				if(!(c==reference||c=='T'))
					success=false;
				if(c=='.')
					undone=true;
			}
			if(!(interpretSuccess(reference, success)==null)){
				return interpretSuccess(reference, success);
			}

				
			
		}
		return interpretRest(undone);
	}



}
