import java.math.BigInteger;
import java.util.BitSet;
import java.util.Scanner;

/**
 * Description of this class
 *
 * @author <a href="mailto:mint.com@gmail.com">anonymint</a>
 * @since 2016-04-09
 */
public class CodeJamBigValue {

    final static int LIMIT_LOOP = 1000;

    static class BigPrimeNode {
        BigInteger value;
        long divisible;

        public BigPrimeNode(BigInteger value, long divisible) {
            this.value = value;
            this.divisible = divisible;
        }
    }


    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int testCase = sc.nextInt();
        for (int i = 1; i <= testCase; i++) {
            int bit = sc.nextInt();
            int amount = sc.nextInt();
            System.out.println(String.format("Case #%d:", i));
            findCoinJamBigValue(bit, amount);
        }
    }

    static void findCoinJamBigValue(int n, int amount) {
        //setup min bit
        BitSet min = new BitSet();
        min.set(0);
        min.set(n - 1);

        //setup max bit
        BitSet max = new BitSet();
        max.set(0, n);

        //initial value
        long start = min.toLongArray()[0];
        int loopCount = 0;
        while (loopCount < amount && start <= max.toLongArray()[0]) {
            BigPrimeNode[] nodes = new BigPrimeNode[9];
            boolean isPrime = false;
            for (int i = 2; i <= 10; i++) {
                BigPrimeNode pn = isPrimeWithNode(Long.toBinaryString(start), i);
                if (pn.divisible == 1) {
                    isPrime = true;
                    break;
                }
                nodes[i - 2] = pn;
            }
            if (!isPrime) {
                printResult(Long.toBinaryString(start), nodes);
                loopCount++;
            }
            start += 2;
        }
    }

    static BigPrimeNode isPrimeWithNode(String input, int radix) {
        BigInteger n = new BigInteger(input, radix);
        BigInteger big2 = new BigInteger("2");
        BigInteger big3 = new BigInteger("3");
        if (n.compareTo(new BigInteger("2")) < 0) return new BigPrimeNode(n, 0);
        if (n == new BigInteger("2") || n == new BigInteger("3")) new BigPrimeNode(n, 1);
        if (n.mod(big2).intValue() == 0 || n.mod(big3).intValue() == 0)
            return new BigPrimeNode(n, n.mod(big2).intValue() == 0 ? 2 : 3);

        BigPrimeNode node = new BigPrimeNode(n, 1);

        int loopLimit = LIMIT_LOOP;
        BigInteger sqr = sqrt(n).add(new BigInteger("1"));
        for (long i = 6L; i <= sqr.longValue() && loopLimit > 0; i += 6) {
            if (n.mod(new BigInteger(Long.toString(i - 1))).intValue() == 0) {
                node.divisible = i - 1;
                return node;
            } else if (n.mod(new BigInteger(Long.toString(i + 1))).intValue() == 0) {
                node.divisible = i + 1;
            }
            loopLimit--;
        }
        return node;
    }

    public static BigInteger sqrt(BigInteger x) {
        BigInteger div = BigInteger.ZERO.setBit(x.bitLength() / 2);
        BigInteger div2 = div;

        while (true) {
            BigInteger y = div.add(x.divide(div)).shiftRight(1);
            if (y.equals(div) || y.equals(div2))
                return y;
            div2 = div;
            div = y;
        }
    }

    static void printResult(String result, BigPrimeNode[] nodes) {
        System.out.print(result + " ");
        for (int i = 0; i < nodes.length; i++) {
            System.out.print(nodes[i].divisible + " ");
        }
        System.out.println();
    }
}
