import java.util.*;

public class BathroomStall {

  public static void main(String[] args) {
    Scanner sc = new Scanner(System.in);
    int n = sc.nextInt();
    for (int i = 0; i < n; i++) {
      long nn = sc.nextLong();
      long k = sc.nextLong();
      printResult(i + 1, calculateWithQueue(nn, k));
    }
  }
  
static String calculateWithQueue(long n, long k) {
    if (k >= n) {
      return "0 0";
    }

    PriorityQueue<Long> queue = new PriorityQueue<>((o1, o2) -> o2 > o1 ? 1 : -1);
    queue.add(n);
    long counter = 1;
    while (!queue.isEmpty()) {
      Long top = queue.remove();
      Long max = top / 2;
      Long min = top % 2 == 1 ? top / 2 : top / 2 - 1;
      if (k == counter) {
        return max + " " + min;
      }
      
      if (max > 0) {
        queue.add(max);
      }
      if (min > 0) {
        queue.add(min);
      }
      counter++;
    }
    return "NO WAY!";
  }

  static void printResult(int caseNum, String result) {
    System.out
        .println(String.format("Case #%d: %s", caseNum, result));
  }
}
