import java.util.*;

public class Pancake {

  public static void main(String[] args) {
    Scanner sc = new Scanner(System.in);
    int n = sc.nextInt();
    for (int i = 0; i < n; i++) {
      String in = sc.next();
      int k = sc.nextInt();
      printResult(i + 1, calculateFlip(in, k));
    }

  }

  private static int calculateFlip(String in, int k) {
    if (in == null || in.length() == 0) {
      return -1;
    }

    int index = 0;
    int count = 0;
    boolean[] input = convertToBoolean(in);
    while (index < input.length) {
      if (input[index]) {
        index++;
        continue;
      }

      //check last less than k
      if (index > input.length - k) {
        boolean check = true;
        for (int j=index; j < input.length; j++) {
          check = check & input[j];
        }
        return check ? count : -1;
      }

      for (int i = 0; i < k; i++) {
        input[index + i] = !input[index+i];
      }
      count++;
    }
    return count;
  }

  static boolean[] convertToBoolean(String in) {
    boolean[] out = new boolean[in.length()];
    for (int i = 0; i < in.length(); i++) {
      out[i] = in.charAt(i) == '+';
    }
    return out;
  }

  static void printResult(int caseNum, int result) {
    System.out
        .println(String.format("Case #%d: %s", caseNum, result == -1 ? "IMPOSSIBLE" : result));
  }

}
