import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Scanner;


public abstract class CodeJamSubmission{
	
	public CodeJamSubmission(){
		Scanner sc = null;
		BufferedWriter bw = null;
		try {
			sc = new Scanner(new File(getInputFilename()));
			bw = new BufferedWriter(new FileWriter(new File(getOutputFilename())));
			
			int numCases = sc.nextInt();
			sc.nextLine();
			
			for (int i = 1; i <= numCases; i++){
				
				String out = "Case #" + i + ": " + solve(sc);
				
				System.out.println(out);
				
				bw.write(out);
				bw.newLine();
			}
			
		} catch (Exception e){
			e.printStackTrace();
		} finally {
			try {
				if (sc != null) sc.close();
				if (bw != null) bw.close();
			} catch (Exception e){
				e.printStackTrace();
			}
		}
	}
	
	public abstract String solve(Scanner input) throws Exception;
	
	public abstract String getInputFilename();
	
	public abstract String getOutputFilename();
	
}
