import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class LawnMower {
	
	public static void main(String args[]) throws IOException{
		Scanner scan = new Scanner(new FileReader("B-large.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter("output.out"));
		
		int numCases = scan.nextInt();
		for (int caseNum = 1; caseNum <= numCases; caseNum++){
			int lawn[][] = new int[scan.nextInt()][scan.nextInt()];
			for (int row = 0; row < lawn.length; row++){
				for (int clm = 0; clm < lawn[0].length; clm++){
					lawn[row][clm] = scan.nextInt();
				}
			}
			String line = "Case #"+caseNum+": " + ( isValidLawn(lawn) ? "YES" : "NO" );
			System.out.println(line);
			bw.write(line);
			bw.newLine();
		}
		
		scan.close();
		bw.close();
	}
	
	private static boolean isValidLawn(int lawn[][]){
		for (int row = 0; row < lawn.length; row++){
			for (int clm = 0; clm < lawn[0].length; clm++){
				if (!isValidSquare(row, clm, lawn)) return false;
			}
		}
		return true;
	}
	
	private static boolean isValidSquare(int row, int clm, int lawn[][]){
		return (canMowRow(row, clm, lawn) || canMowClm(row, clm, lawn));
	}
	
	private static boolean canMowRow(int row, int clm, int lawn[][]){
		int val = lawn[row][clm];
		for (clm = 0; clm < lawn[0].length; clm++){
			if (lawn[row][clm] > val) return false;
		}
		return true;
	}
	
	private static boolean canMowClm(int row, int clm, int lawn[][]){
		int val = lawn[row][clm];
		for (row = 0; row < lawn.length; row++){
			if (lawn[row][clm] > val) return false;
		}
		return true;
	}
}
