import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class TicTacToeTomek {
	
	private static final char PLAYER_X = 'X';
	private static final char PLAYER_O = 'O';
	private static char[][] rows = new char[4][4], clms = new char[4][4], dgnls = new char[2][4];
	
	public static void main(String args[]) throws IOException{
		BufferedReader br = new BufferedReader(new FileReader("A-small-attempt0.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter("output.out"));
		
		int numCases = Integer.parseInt(br.readLine());
		for (int caseNum = 1; caseNum <= numCases; caseNum++){
			boolean gameFinished = true;
			for (int i = 0; i < 4; i++){
				for (int j = 0; j < 4; j++){
					char val = getNextSquare(br);
					if (val == '.') gameFinished = false;
					rows[i][j] = val;
					clms[j][i] = val;
					if (i == j) dgnls[0][i] = val;
					else if (i+j == 3) dgnls[1][i] = val;
				}
				br.readLine();
			}
			char winner = getWinner();
			String line = "Case #"+caseNum+": ";
			switch (winner){
			case PLAYER_X:
			case PLAYER_O:
				line += winner+" won";
				break;
			default:
				line += gameFinished ? "Draw" : "Game has not completed";
			}
			System.out.println(line);
			bw.write(line);
			bw.newLine();
		}
		
		br.close();
		bw.close();
	}
	
	private static char getNextSquare(BufferedReader br) throws IOException{
		char c;
		do { c = (char) br.read(); } while (c != 'X' && c != 'O' && c != '.' && c != 'T');
		return c;
	}
	
	private static char getWinner(){
		for (char array[][] : new char[][][]{rows, clms, dgnls}){
			for (char line[] : array){
				if (didWin(PLAYER_X, line)) return PLAYER_X;
				if (didWin(PLAYER_O, line)) return PLAYER_O;
			}
		}
		return '.';
	}
	
//	private static void print(char[][] array){
//		System.out.println("   {");
//		for (char row[] : array){
//			System.out.print("      { ");
//			for (char c : row){
//				System.out.print(c+" ");
//			}
//			System.out.println("},");
//		}
//		System.out.println("   }");
//	}
	
	private static boolean didWin(char player, char line[]){
		for (char c : line) if (c != player && c != 'T') return false;
		return true;
	}
	
}
