import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class Treasure {

	public static void main(String[] args) throws IOException {
		Scanner scan = new Scanner(new FileReader("D-small-attempt0.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter("output.out"));
		
		int numCases = scan.nextInt();
		for (int caseNum = 1; caseNum <= numCases; caseNum++){
			int keys[] = new int[201];
			int keysRequired[] = new int[201];
			
			int numKeys = scan.nextInt();
			int numChests = scan.nextInt();
			ArrayList<Chest> chests = new ArrayList<Chest>(numChests);
			
			for (int i = 0; i < numKeys; i++) keys[scan.nextInt()]++;
			
			for (int chestNumber = 0; chestNumber < numChests; chestNumber++){
				int requiredKey = scan.nextInt();
				keysRequired[requiredKey]++;
				Chest chest = new Chest(chestNumber+1, requiredKey);
				for (int nKeys = scan.nextInt(); nKeys > 0; nKeys--){
					chest.addKey(scan.nextInt());
				}
				chests.add(chest);
			}
						
			String order = "";
			int pos = 0;
			try {
				while (!chests.isEmpty()){
					Chest c = chests.get(pos);
					int reqKey = c.keyRequired;
					if ((c.contains(reqKey) && keys[reqKey] > 0) || keys[reqKey] > 1 || keys[reqKey] == keysRequired[reqKey]){
						order += c.chestNumber + " ";
						keys[reqKey]--;
						keysRequired[reqKey]--;
						for (int key : c.keysContained) keys[key]++;
						chests.remove(c);
						pos = 0;
					} else pos++;
				}
			} catch (IndexOutOfBoundsException e){ order = "IMPOSSIBLE";}
			String line = "Case #"+caseNum+": "+order;
			System.out.println(line);
			bw.write(line);
			bw.newLine();
		}
		scan.close();
		bw.close();
	}	
	
	public static void printData(List<Chest> chests, int keys[], int keysRequired[]){
		for (Chest c : chests) System.out.println("\t"+c.toString());
		System.out.print("\tKeys Held { ");
		for (int i = 0; i < keys.length; i++) if (keys[i] != 0) System.out.print(i+":"+keys[i]+" ");
		System.out.print("}\n\tKeys Required {");
		for (int i = 0; i < keys.length; i++) if (keysRequired[i] != 0) System.out.print(i+":"+keysRequired[i]+" ");
		System.out.println("}");
	}
}

class Chest{
	public final int chestNumber;
	public final int keyRequired;
	public final LinkedList<Integer> keysContained = new LinkedList<Integer>();
	
	public Chest(int chestNumber, int keyRequired){
		this.chestNumber = chestNumber;
		this.keyRequired = keyRequired;
	}
	
	public void addKey(int key){
		keysContained.add(key);
	}
	
	public boolean contains(int key){
		return keysContained.contains(key);
	}
	
	public String toString(){
		String s = "Chest #"+chestNumber+": "+"Key Type: "+keyRequired+", Contains Keys { ";
		for (int i : keysContained) s += i + " ";
		s += "}";
		return s;
	}
}