package qualifying.magic;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.*;

/**
 * Created by anothem on 12/04/2014.
 */
public class MagicTrickSolver {

    List<Integer> firstSelection;
    List<Integer> secondSelection;

    public MagicTrickSolver(List<Integer> firstSelection, List<Integer> secondSelection) {
        this.firstSelection = firstSelection;
        this.secondSelection = secondSelection;
    }

    public int solve() {
        Set<Integer> a = new HashSet<Integer>(firstSelection);
        Set<Integer> b = new HashSet<Integer>(secondSelection);
        a.retainAll(b);
        if (a.size()>1) return -1; // bad magician
        if (a.size()==0) return -2; // cheating
        return a.iterator().next();

    }

    public static void main (String[] args) throws FileNotFoundException {
        Scanner sc = new Scanner(new File("/Users/anothem/workspace/CodeJam/src/qualifying/magic/A-small-attempt0.in"));
        int numTests = sc.nextInt();
        for (int t=0; t<numTests; t++) {
            int firstAnswer = sc.nextInt();
            List<Integer> firstSelection = new ArrayList<Integer>();
            for (int i=0; i<4; i++) {
                for (int j=0; j<4; j++) {
                    int x = sc.nextInt();
                    if (i==firstAnswer - 1 ) {
                        firstSelection.add(x);
                    }
                }
            }

            int secondAnswer = sc.nextInt();
            List<Integer> secondSelection = new ArrayList<Integer>();
            for (int i=0; i<4; i++) {
                for (int j=0; j<4; j++) {
                    int x = sc.nextInt();
                    if (i==secondAnswer - 1 ) {
                        secondSelection.add(x);
                    }

                }
            }

            MagicTrickSolver solver = new MagicTrickSolver(firstSelection, secondSelection);
            int result = solver.solve();
            System.out.print("Case #"+(t+1)+": ");
            switch (result) {
                case -1 : System.out.println("Bad magician!");
                    break;
                case -2 : System.out.println("Volunteer cheated!");
                    break;
                default:
                    System.out.println(result);
            }
        }
    }
}
