package qualifying.war;

import javafx.util.Pair;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 * Created by anothem on 12/04/2014.
 */
public class WarSolver {

    TreeSet<Double> nblocksAsc;
    TreeSet<Double> kblocksAsc;

    public WarSolver(TreeSet<Double> nblocks, TreeSet<Double> kblocks) {
        nblocksAsc = nblocks;
        kblocksAsc = kblocks;
    }

    public Pair<Integer, Integer> solve() {
        // real war
        TreeSet<Double> nblocks = new TreeSet<Double>(nblocksAsc);
        TreeSet<Double> kblocks = new TreeSet<Double>(kblocksAsc);
        int nWarScore=0;
        while (!nblocks.isEmpty()) {
            if (nblocks.last() > kblocks.last()) {
                nblocks.pollLast();
                kblocks.pollFirst();
                nWarScore++;
            } else {
                nblocks.pollLast();
                kblocks.pollLast();
                // k++
            }
        }

        // deceiving war
        int nDWScore=0;
        while (!nblocksAsc.isEmpty()) {
            if (nblocksAsc.first() > kblocksAsc.first()) {
                nblocksAsc.pollFirst();
                kblocksAsc.pollFirst();
                nDWScore++;
            } else {
                nblocksAsc.pollFirst();
                kblocksAsc.pollLast();
                // k++
            }
        }

        return new Pair<Integer, Integer>(nDWScore, nWarScore);
    }

    public static void main(String [] args) throws FileNotFoundException {
        Scanner sc = new Scanner(new File("/Users/anothem/workspace/CodeJam/src/qualifying/war/D-large.in"));
        int numTests = sc.nextInt();
        for (int t=0; t<numTests; t++) {
            int n = sc.nextInt();
            TreeSet<Double> nblocks = new TreeSet<Double>();
            for (int i=0; i<n; i++) {
                nblocks.add(sc.nextDouble());
            }
            TreeSet<Double> kblocks = new TreeSet<Double>();
            for (int i=0; i<n; i++) {
                kblocks.add(sc.nextDouble());
            }

            WarSolver solver = new WarSolver(nblocks, kblocks);
            Pair<Integer, Integer> result = solver.solve();
            System.out.println("Case #"+(t+1)+": "+result.getKey()+" "+result.getValue());
        }
    }
}