import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Arrays;



public class GoroSort {

	public int origInput[];
	public T sortedArray[];
	public T origArray[];
	public String inputFile = "/goro-small-input.txt";
	public String outputFile = "/goro-small-output.txt";
	public BufferedReader reader;
	public BufferedWriter writer;
	
	class T{
		public T(int v, int c, int s)
		{
			value = v;
			currentPos = c;
			sortedPos = s;
			cycleNo=-1;
		}
		public int value;
		public int currentPos;
		public int sortedPos;
		public int cycleNo;
	}
	
	public void markCycle(T b, int cycle)
	{
		if(b.cycleNo!=-1 || cycle == b.cycleNo) return;
		b.cycleNo = cycle;
		markCycle(sortedArray[b.currentPos], cycle);
	}
	
	public int countCycles()
	{
		int cycle = 0;
		for(int i=0;i<origArray.length;i++)
		{
			if(origArray[i].cycleNo==-1)
			{
				cycle++;
				markCycle(origArray[i], cycle);
			}
		}
		return cycle;
	}
	public int initialize()
	{
		int alreadySorted = 0;
		int temp[] = Arrays.copyOf(origInput, origInput.length);
		Arrays.sort(temp);
		origArray = new T[origInput.length];
		sortedArray = new T[origArray.length];
		for(int i=0;i<origArray.length;i++)
		{
			int sortedPos = Arrays.binarySearch(temp, origInput[i]);
			if(sortedPos==i)
				alreadySorted++;
			origArray[i] = new T(origInput[i], i, sortedPos);
			sortedArray[sortedPos] = origArray[i];
		}
		return alreadySorted;
	}
		
	public int gorosort(T[] array)
	{
		return 2*(array.length - countCycles());
	}
	
	public void parseInputLine(String line){
		String values[] = line.split("\\s");
		origInput = new int[values.length];
		for(int i=0;i<values.length;i++)
			origInput[i] = Integer.parseInt(values[i]);
	}
	
	public String generateResult() throws Exception
	{
		String prefix = "Case #";
		int noOfTestCases = Integer.parseInt(reader.readLine());
		String result="";
		for(int i=0; i<noOfTestCases; i++)
		{
			reader.readLine();
			parseInputLine(reader.readLine());
			int iii = initialize();
			result+=prefix+(i+1)+": "+(origInput.length - iii)+"\n";
		}
		return result;
	}

	public static void main(String[] args) throws Exception{
		GoroSort gs = new GoroSort();
		gs.reader = new BufferedReader(new FileReader(new File(gs.inputFile)));
		gs.writer = new BufferedWriter(new FileWriter(new File(gs.outputFile)));
		gs.writer.write(gs.generateResult());
		gs.writer.close();
		gs.reader.close();
	}
}
