package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;

public class BotTrust {
	public static String inputFile = "/input.txt";
	public static String outputFile = "/output.txt";
	public static BufferedReader reader;
	public static BufferedWriter writer;
	public static java.util.List<Target> blue = new ArrayList<Target>();
	public static java.util.List<Target> orange = new ArrayList<Target>();
	public static String result;
	public static int inputSize;
	public static int blueCurrentPosition;
	public static int orangeCurrentPosition;
	
	public static void parseInputLine(String line){
		String values[] = line.split("\\s");
		inputSize = Integer.parseInt(values[0]);
		for(int i=0;i<inputSize;i++)
		{
			if(values[2*i+1].equals("B"))
				blue.add(new Target(i+1, Integer.parseInt(values[2*i+2])));
			if(values[2*i+1].equals("O"))
				orange.add(new Target(i+1, Integer.parseInt(values[2*i+2])));
		}
		blueCurrentPosition = 1;
		orangeCurrentPosition = 1;
	}
	
	public static int solve()
	{
		int j=0;
		int k=0;
		int time=0;
		for(int i=0; i<inputSize;)
		{			
			Target blueCurrentTarget = blue.isEmpty()?new Target(0,0):blue.get(0);
			Target orangeCurrentTarget = orange.isEmpty()?new Target(0,0):orange.get(0);
			boolean turn = blueCurrentTarget.index==0?true:blueCurrentTarget.index>orangeCurrentTarget.index && orangeCurrentTarget.index!=0; //false=> blue's turn true=>orange's turn
			time++;
			if(!turn) //it is blue's turn
			{
				if(blueCurrentTarget.target==blueCurrentPosition && blueCurrentPosition > 0)
				{
					i++;				
					blue.remove(0);
					j++;
				}
				else if(blueCurrentTarget.target<blueCurrentPosition)
				{
					blueCurrentPosition--;
				}
				else
				{
					blueCurrentPosition++;
				}
				if(orangeCurrentTarget.target<orangeCurrentPosition)
				{
					orangeCurrentPosition--;
				}
				else if(orangeCurrentTarget.target > orangeCurrentPosition)
				{
					orangeCurrentPosition++;
				}
			}
			else //It is orange's turn
			{
				if(orangeCurrentTarget.target==orangeCurrentPosition && orangeCurrentPosition > 0)
				{
					i++;
					orange.remove(0);
					k++;
				}
				else if(orangeCurrentTarget.target<orangeCurrentPosition)
				{
					orangeCurrentPosition--;
				}
				else
				{
					orangeCurrentPosition++;
				}
				if(blueCurrentTarget.target<blueCurrentPosition)
				{
					blueCurrentPosition--;
				}
				else if(blueCurrentTarget.target > blueCurrentPosition)
				{
					blueCurrentPosition++;
				}
			}	
		}
		return time;
	}
	
	public static String generateResult() throws Exception
	{
		String prefix = "Case #";
		int noOfTestCases = Integer.parseInt(reader.readLine());
		result="";
		for(int i=0; i<noOfTestCases; i++)
		{
			parseInputLine(reader.readLine());
			result+=prefix+(i+1)+": "+solve()+"\n";
		}
		return result;
	}
	
	public static void main(String[] args) throws Exception{
		reader = new BufferedReader(new FileReader(new File("/input.txt")));
		writer = new BufferedWriter(new FileWriter(new File("/output.txt")));
		writer.write(generateResult());
		writer.close();
		reader.close();
	}
}
