import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Stack;


public class Magicka {

	public static Map<String, String> combine;
	public static Map<String, String> opposed;
	public static String invoked;
	public static Stack<String> invocationResult;
	public static String inputFile = "/magicka-input.txt";
	public static String outputFile = "/magicka-output.txt";
	public static BufferedReader reader;
	public static BufferedWriter writer;
	
	public static void parseInputLine(String line)
	{
		combine = new HashMap<String, String>();
		opposed = new HashMap<String, String>();
		invocationResult = new Stack<String>();
		
		String[] values = line.split("\\s");
		int noOfTriplets = Integer.parseInt(values[0]);
		int noOfPairs = Integer.parseInt(values[noOfTriplets+1]);
		invoked = values[noOfTriplets + noOfPairs +3];
		for(int i=1;i<=noOfTriplets;i++)
		{
			combine.put(values[i].substring(0,2), values[i].substring(2));
			combine.put(values[i].substring(1,2)+values[i].substring(0,1), values[i].substring(2));
		}
		for(int i=noOfTriplets + 2;i<= noOfTriplets + noOfPairs + 1;i++)
		{
			opposed.put(values[i].substring(0,2), "");
			opposed.put(values[i].substring(1,2)+values[i].substring(0,1), "");
		}
		if(invoked.length()>0)
			invocationResult.add(invoked.substring(0,1));
	}
	
	public static boolean listContainsElementOpposedTo(String e)
	{
		for(int i=0; i<invocationResult.size(); i++)
		{
			String combination = invocationResult.get(i)+e;			
			if(opposed.containsKey(combination))
				return true;
		}
		return false;
	}
	
	public static void invocation(String element, int i)
	{
		if(i>=invoked.length()) return;
		String combination = "";
		if(!invocationResult.isEmpty())
			combination = invocationResult.peek()+element;
		if(combine.containsKey(combination))
		{
			invocationResult.pop();
			String result = combine.get(combination);
			invocation(result, i);
		}
		else if(listContainsElementOpposedTo(element))
		{
			invocationResult.clear();
			if(i+1<invoked.length())
				invocation(invoked.substring(i+1,i+2), i+1);
		}
		else
		{
			invocationResult.push(element);
			if(i+1<invoked.length())
				invocation(invoked.substring(i+1,i+2), i+1);
		}
	}
	
	public static String generateResult() throws Exception
	{
		String prefix = "Case #";
		int noOfTestCases = Integer.parseInt(reader.readLine());
		String result="";
		for(int i=0; i<noOfTestCases; i++)
		{
			parseInputLine(reader.readLine());
			if(invoked.length()>1)
				invocation(invoked.substring(1,2), 1);
			result+=prefix+(i+1)+": "+invocationResult.toString()+"\n";
		}
		return result;
	}
	public static void main(String[] args) throws Exception{
		reader = new BufferedReader(new FileReader(new File(inputFile)));
		writer = new BufferedWriter(new FileWriter(new File(outputFile)));
		writer.write(generateResult());
		writer.close();
		reader.close();	
	}
}
