import java.io.*;
import java.util.*;

public class A1 {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	class Group implements Comparable<Group> {
		long from, qua;

		Group(long f, long q) {
			from = f;
			qua = q;
		}

		void add(long q) {
			qua += q;
		}

		void remove(long q) {
			qua -= q;
		}

		@Override
		public int compareTo(Group o) {
			return Long.compare(from, o.from);
			// return 0;
		}

	}

	class ThreeGroup implements Comparable<ThreeGroup> {
		long from, qua, to;

		ThreeGroup(long f, long t, long q) {
			from = f;
			to = t;
			qua = q;
		}

		void add(long q) {
			qua += q;
		}

		void remove(long q) {
			qua -= q;
		}

		@Override
		public int compareTo(ThreeGroup o) {
			return Long.compare(from, o.from) != 0 ? Long.compare(from, o.from)
					: Long.compare(to, o.to);
		}

	}

	int n;

	long price(long from, long to) {
		long c = to - from;
		return (c * n - c * (c - 1) / 2) % mod;
	}

	long mod = 1000002013L;

	void solve() throws Exception {
		n = nextInt();
		int t = nextInt();
		Long q[] = new Long[t];
		Long w[] = new Long[t];
		Long c[] = new Long[t];

		// Group g[] = new Group[t];

		TreeMap<Long, ArrayList<Group>> enter = new TreeMap<Long, ArrayList<Group>>();

		long mb = 0;

		for (int i = 0; i < t; i++) {
			q[i] = nextLong();
			w[i] = nextLong();
			c[i] = nextLong();
			mb += 1L * price(q[i], w[i]) * c[i];
			mb %= mod;
			if (!enter.containsKey(q[i]))
				enter.put(q[i], new ArrayList<Group>());
			enter.get(q[i]).add(new Group(w[i], c[i]));

			// g[i] = new Group(q[i], w[i]);
		}

		TreeSet<Long> stops = new TreeSet<Long>();

		for (Long x : q)
			stops.add(x);
		for (Long x : w)
			stops.add(x);

		TreeMap<Long, Long> exit = new TreeMap<Long, Long>();

		TreeMap<Long, Long> ticket = new TreeMap<Long, Long>();
		TreeSet<Long> ticketRem = new TreeSet<Long>();

		long ans = 0;

		for (Long cur : stops) {
			if (enter.containsKey(cur)) {
				for (Group g : enter.get(cur)) {
					// ticket[g.to] += g.qua
					if (!ticket.containsKey(cur))
						ticket.put(cur, 0L);
					ticket.put(cur, ticket.get(cur) + g.qua);
					ticketRem.add(cur);

					// exit[g.from] += g.qua
					if (!exit.containsKey(g.from))
						exit.put(g.from, 0L);
					exit.put(g.from, exit.get(g.from) + g.qua);
				}
			}
			long needExit = exit.containsKey(cur) ? exit.get(cur) : 0;

			while (needExit > 0) {
				long give = ticketRem.last();
				long have = ticket.get(give);
				if (have > needExit) {
					ticket.put(give, ticket.get(give) - needExit);
					ans += 1L * needExit * price(give, cur);
					// System.err.println(needExit + "ppl_ from " + give +
					// " to "
					// + cur);
					needExit = 0;
				} else {
					ans += 1L * have * price(give, cur);
					// System.err
					// .println(have + "ppl from " + give + " to " + cur);
					needExit -= have;
					ticket.put(give, 0L);
					ticketRem.remove(give);
				}
				ans %= mod;
			}

		}

		// System.err.println(mb + " || " + ans);

		out.println((mb - ans + mod) % mod);
		// System.err.println("---");
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			//try {
				in = new BufferedReader(new FileReader("src/a-small.in"));
				out = new PrintWriter(new FileWriter("src/a-small.out"));
			//} catch (FileNotFoundException e) {
			//	in = new BufferedReader(new InputStreamReader(System.in));
			//	out = new PrintWriter(System.out);
			//}
			int tc = nextInt();
			for (int t = 0; t < tc; t++) {
				out.print("Case #" + (t + 1) + ": ");
				solve();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A1().run();

	}

}
