import java.io.*;
import java.util.*;

public class A {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	class Solve extends Thread {
		int n, m, k;

		Solve(int nn, int mm, int kk) {
			n = nn;
			m = mm;
			k = kk;
		}

		public void run() {

		}
	}

	int color(int a[][]) {
		int clr = 1;
		for (int i = 0; i < a.length; i++)
			for (int j = 0; j < a[i].length; j++)
				if (a[i][j] == 0) {
					colorOne(a, i, j, clr);
					clr++;
				}
		return clr;
	}

	private void colorOne(int[][] a, int i, int j, int c) {
		if (i < 0)
			return;
		if (i >= a.length)
			return;
		if (j < 0)
			return;
		if (j >= a[0].length)
			return;

		if (a[i][j] == 0) {
			a[i][j] = c;
			colorOne(a, i + 1, j, c);
			colorOne(a, i - 1, j, c);
			colorOne(a, i, j + 1, c);
			colorOne(a, i, j - 1, c);
		}

	}

	int get(int n, int m, int k) {
		int a[][] = new int[n][m];
		int ans = Integer.MAX_VALUE;
		int colcnt[] = new int[n * m + 1000];
		int w = n * m;
		for (int c = 0; c < (1 << w); c++) {
			int cc = c;
			int cans = 0;
			for (int i = 0; i < n; i++)
				for (int j = 0; j < m; j++) {
					a[i][j] = -(cc % 2);
					cans += cc % 2;
					cc /= 2;
				}

			int maxclr = color(a);

			Arrays.fill(colcnt, 0);

			for (int i = 0; i < n; i++)
				for (int j = 0; j < m; j++) {
					if (a[i][j] != -1) {
						colcnt[a[i][j]]++;
						if ((i == 0) || (j == 0) || (i == n - 1)
								|| (j == m - 1))
							colcnt[a[i][j]] -= 1000;
					}
				}

			int count = 0;

			for (int i = 1; i < maxclr; i++) {
				if (colcnt[i] > 0)
					count += colcnt[i];
			}

			// System.err.println(Integer.toBinaryString(c) + " " + count);

			if ((count + cans) >= k)
				ans = Math.min(ans, cans);

		}

		return ans;
	}

	void solve() throws Exception {
		int tn = nextInt();
		for (int ct = 1; ct <= tn; ct++) {
			out.println("Case #" + ct + ": "
					+ get(nextInt(), nextInt(), nextInt()));
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("a.in"));
			out = new PrintWriter(new FileWriter("a.out"));

			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A().run();

	}

}
