import java.io.*;
import java.util.*;

public class A {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	int p[], d[], g[][], n, c[][], nk[][];

	public static int[][] mult(int[][] a, int[][] b) {
		int n = a.length;
		int m = a[0].length;
		int k = b[0].length;
		int[][] res = new int[n][k];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < k; j++) {
				for (int p = 0; p < m; p++) {
					res[i][j] = res[i][j] + a[i][p] * b[p][j];
				}
			}
		}
		return res;
	}

	public static int[][] add(int[][] a, int[][] b) {
		int n = a.length;
		int m = a[0].length;
		int[][] res = new int[n][m];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				res[i][j] = a[i][j] + b[i][j];
			}
		}
		return res;
	}

	void solve() throws Exception {
		n = nextInt();
		g = new int[n][n];
		c = new int[n][n];
		nk = new int[n][n];
		p = new int[n];
		for (int i = 0; i < n; i++) {
			p[i] = nextInt();
			for (int j = 0; j < p[i]; j++) {
				int to = nextInt() - 1;
				g[i][to] = 1;
				// g[to][i] = 1;
			}
		}
		for (int i = 0; i < n; i++)
			for (int j = 0; j < n; j++)
				c[i][j] = g[i][j];
		// System.err.println(Arrays.deepToString(c));

		for (int k = 0; k <= Math.min(n, 100); k++) {
			nk = add(nk, c);
			c = mult(c, g);
			// System.err.println(Arrays.deepToString(c));
			for (int i = 0; i < n; i++)
				for (int j = 0; j < n; j++)
					if (nk[i][j] > 1) {
						out.print("Yes");
						return;
					}
		}
		out.print("No");
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter(new FileWriter("output.txt"));
			int t = nextInt();
			for (int tc = 1; tc <= t; tc++) {
				out.print("Case #" + tc + ": ");
				solve();
				out.println();
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A().run();

	}

}
