import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class A {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	long gcd(long p, long q) {
		return BigInteger.valueOf(p).gcd(BigInteger.valueOf(q)).longValue();
	}

	int get(int a[]) {
		shrink(a);
		int n = a.length;
		int[] b = new int[n];
		int toppos = -1;
		for (int i = 0; i < n; i++)
			if (a[i] == n - 1)
				toppos = i;

		int ans = 1000000;

		for (int top = 0; top < n; top++) {
			for (int i = 0; i < n; i++)
				b[i] = a[i];

			// sort 0..top ^^
			// sort top..n-1 vv

			int left[] = new int[top];
			int right[] = new int[n - top - 1];
			for (int i = 0; i < left.length; i++)
				left[i] = b[i];
			Arrays.sort(left);

			for (int i = 0; i < right.length; i++)
				right[i] = -b[n - 1 - i];
			Arrays.sort(right);

			for (int i = 0; i < left.length; i++)
				b[i] = left[i];
			b[top] = n - 1;
			for (int i = 0; i < right.length; i++)
				b[i + top + 1] = -right[i];

			int posa[] = new int[n];
			int posb[] = new int[n];
			for (int i = 0; i < n; i++)
				posa[a[i]] = i;
			for (int i = 0; i < n; i++)
				posb[b[i]] = i;

			int cans = 0;
			for (int i = 0; i < n; i++)
				for (int j = i + 1; j < n; j++)
					if ((posa[i] - posa[j]) * (posb[i] - posb[j]) < 0)
						cans++;
			ans = Math.min(ans, cans);
			// System.err.println(Arrays.toString(b) + " | " + cans/2);
		}

		return ans;
	}

	private boolean isHill(int[] a) {
		int n = a.length;
		boolean wastop = false;
		for (int i = 1; i < n; i++) {
			if ((a[i - 1] < a[i]) && wastop)
				return false;

			if (a[i - 1] > a[i])
				wastop = true;
		}
		return true;
	}

	long shift = 1L << 32;

	void shrink(int a[]) {
		long b[] = new long[a.length];
		for (int i = 0; i < a.length; i++)
			b[i] = 1L * a[i] * shift + i;
		Arrays.sort(b);
		for (int i = 0; i < a.length; i++) {
			int pos = (int) (b[i] % shift);
			int val = (int) (b[i] / shift);
			a[i] = pos;
		}
		System.err.println(Arrays.toString(a));
	}

	public static boolean nextPermutation(int[] p) {
		for (int a = p.length - 2; a >= 0; --a)
			if (p[a] < p[a + 1])
				for (int b = p.length - 1;; --b)
					if (p[b] > p[a]) {
						int t = p[a];
						p[a] = p[b];
						p[b] = t;
						for (++a, b = p.length - 1; a < b; ++a, --b) {
							t = p[a];
							p[a] = p[b];
							p[b] = t;
						}
						return true;
					}
		return false;
	}

	void solve() throws Exception {
		int tn = nextInt();
		for (int ct = 1; ct <= tn; ct++) {
			int n = nextInt();
			int a[] = new int[n];
			for (int i = 0; i < n; i++)
				a[i] = nextInt();
			out.println("Case #" + ct + ": " + get(a));
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("a.in"));
			out = new PrintWriter(new FileWriter("a.out"));

			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A().run();

	}

}
