import java.io.*;
import java.util.*;

public class Solution {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	void solve() throws Exception {
		int tn = nextInt();
		for (int ct = 1; ct <= tn; ct++) {
			out.println("Case #" + ct + ": " + test());
		}
	}

	private String test() throws Exception {
		int n = nextInt();
		String a[] = new String[n];
		for (int i = 0; i < n; i++)
			a[i] = next();

		for (int i = 1; i < n; i++)
			if (!(strip(a[i]).equals(strip(a[i - 1]))))
				return "Fegla Won";

		gl = strip(a[0]).length();

		int v[][] = new int[n][gl];
		for (int i = 0; i < n; i++)
			v[i] = groups(a[i]);

		int ans = 0;

		for (int g = 0; g < gl; g++) {
			int cv[] = new int[n];
			for (int i = 0; i < n; i++)
				cv[i] = v[i][g];
			Arrays.sort(cv);
			int req = cv[n / 2];
			for (int i = 0; i < n; i++)
				ans += Math.abs(req - cv[i]);
		}

		return ans + "";
	}

	int gl;

	private String strip(String s) {
		String ans = s.charAt(0) + "";
		for (int i = 1; i < s.length(); i++) {
			if (s.charAt(i) != s.charAt(i - 1))
				ans = ans + s.charAt(i);
		}
		System.err.println(s + " => " + ans);
		return ans;
	}

	int[] groups(String s) {
		int res[] = new int[gl];
		int cg = 0, c = 0;
		s = s + "!";
		for (int i = 1; i < s.length(); i++) {
			cg++;
			if (s.charAt(i) != s.charAt(i - 1)) {
				res[c] = cg;
				cg = 0;
				c++;
			}
		}

		System.err.println(s + " :: " + Arrays.toString(res));
		return res;
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("a.in"));
			out = new PrintWriter(new FileWriter("a.out"));

			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new Solution().run();

	}

}
