import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class A {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	long gcd(long p, long q) {
		return BigInteger.valueOf(p).gcd(BigInteger.valueOf(q)).longValue();
	}

	String get(long p, long q) {
		long ans = 0;
		long gcd = gcd(p, q);
		p /= gcd;
		q /= gcd;

		if (q != Long.highestOneBit(q))
		// if (q != (1L<<(Long.highestOneBit(q))))
		{
			return "impossible";
		}

		long pow2 = 1;
		for (int i = 1; i <= 40; i++) {
			pow2 *= 2L;
			if (BigInteger.valueOf(p).multiply(BigInteger.valueOf(pow2))
					.compareTo(BigInteger.valueOf(q)) >= 0)
				return "" + i;
		}
		// return null;

		return "impossible";
	}

	String merge(String s) {
		String ans = s.charAt(0) + "";
		for (int i = 1; i < s.length(); i++) {
			if (s.charAt(i) != s.charAt(i - 1))
				ans = ans + s.charAt(i);
		}
		return ans;
	}

	public static boolean nextPermutation(int[] p) {
		for (int a = p.length - 2; a >= 0; --a)
			if (p[a] < p[a + 1])
				for (int b = p.length - 1;; --b)
					if (p[b] > p[a]) {
						int t = p[a];
						p[a] = p[b];
						p[b] = t;
						for (++a, b = p.length - 1; a < b; ++a, --b) {
							t = p[a];
							p[a] = p[b];
							p[b] = t;
						}
						return true;
					}
		return false;
	}

	void solve() throws Exception {
		int tn = nextInt();
		for (int ct = 1; ct <= tn; ct++) {
			System.err.println(ct);
			int n = nextInt();
			String a[] = new String[n];
			for (int i = 0; i < n; i++)
				a[i] = merge(next());
			int ans = 0;
			int p[] = new int[n];
			for (int i = 0; i < n; i++)
				p[i] = i;

			do {
				String concat = "";
				for (int i = 0; i < n; i++) {
					concat += a[p[i]];
				}
				concat = merge(concat);
				int cnt[] = new int[30];
				for (char c : concat.toCharArray()) {
					cnt[c - 'a']++;
				}
				boolean flag = true;
				for (int i = 0; i < 30; i++)
					if (cnt[i] > 1)
						flag = false;
				ans += flag ? 1 : 0;
			} while (nextPermutation(p));
			out.println("Case #" + ct + ": " + ans);
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("a.in"));
			out = new PrintWriter(new FileWriter("a.out"));

			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A().run();

	}

}
