import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class D {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	int dp[];
	int need[];
	int cur[];
	int keys[][];

	int n;

	String solve() throws Exception {
		int k = nextInt();
		n = nextInt();

		dp = new int[1 << n];
		need = new int[n];
		keys = new int[n][];
		cur = new int[222];

		Arrays.fill(dp, -1);

		for (int i = 0; i < k; i++)
			cur[nextInt()]++;

		for (int i = 0; i < n; i++) {
			need[i] = nextInt();
			keys[i] = new int[nextInt()];
			for (int j = 0; j < keys[i].length; j++)
				keys[i][j] = nextInt();
		}

		rec(0, cur);

		int c = (1 << n) - 1;
		if (dp[c] == -1)
			return " IMPOSSIBLE";
		String ans = "";
		while (c != 0) {
			int d = dp[c];
			ans = " " + (d + 1) + ans;
			c ^= 1 << d;
		}
		return ans;
	}

	void rec(int v, int c[]) {
		for (int i = 0; i < n; i++)
			if ((v & (1 << i)) == 0)
				if (c[need[i]] > 0)
					if (dp[v | (1 << i)] == -1) {
						for (int j = 0; j < keys[i].length; j++)
							c[keys[i][j]]++;
						c[need[i]]--;
						dp[v | (1 << i)] = i;
						rec(v | (1 << i), c);
						c[need[i]]++;
						for (int j = 0; j < keys[i].length; j++)
							c[keys[i][j]]--;
					}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("src/D.in"));
			out = new PrintWriter(new FileWriter("src/D.out"));
			int tc = nextInt();
			for (int t = 1; t <= tc; t++) {
				out.println("Case #" + t + ":" + solve());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new D().run();

	}

}