import java.io.*;
import java.util.*;

public class Solution {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	void solve() throws Exception {
		double c = nextDouble();
		double f = nextDouble();
		double n = nextDouble();
		double best = 1e50;
		int cf = 0;
		double r = 2;
		double alr = 0;
		while (true) {
			double cur = alr + n / r;
			best = Math.min(best, cur);

			alr = alr + c / r;
			cf++;
			r += f;
			if (alr > best)
				break;
		}
		out.println(best);
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(new OutputStreamWriter(System.out));
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new Solution().run();
	}

}
