import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class C {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	TreeSet<BigInteger> n = new TreeSet<BigInteger>();

	long solve(String ls, String rs) {
		BigInteger l = new BigInteger(ls);
		BigInteger r = new BigInteger(rs);
		long ans = 0;
		for (BigInteger x : n) {
			BigInteger xx = x.multiply(x);
			if (l.compareTo(xx) <= 0 && xx.compareTo(r) <= 0)
				ans++;
		}
		return ans;
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("src/C.in"));
			BufferedReader inp = new BufferedReader(new FileReader("src/CF.in"));
			out = new PrintWriter(new FileWriter("src/C.out"));
			int cx = Integer.parseInt(inp.readLine());
			for (int i = 0; i < cx; i++) {
				n.add(new BigInteger(inp.readLine()));
			}

			int tc = nextInt();
			for (int t = 1; t <= tc; t++) {
				out.println("Case #" + t + ": " + solve(next(), next()));
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new C().run();

	}

}