import java.io.*;
import java.util.*;

public class C {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	void solve() throws Exception {
		int t = nextInt();
		for (int i = 0; i < t; i++) {
			out.println("Case #" + (i + 1) + ": " + get(nextLong(), nextLong()));
		}
	}

	String get(long n, long k) {
		PriorityQueue<Long> q = new PriorityQueue<Long>();
		q.add(-n);
		for (int i = 0; i < k - 1; i++) {
			long v = -q.poll();
			v--;
			//System.err.println(v);
			q.add(-(v / 2));
			q.add(-(v - (v / 2)));
		}
		long v = -q.poll();
		v--;
		return (v - (v / 2)) + " " + v / 2;
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			final String className = this.getClass().getName().toLowerCase();
			try {
				in = new BufferedReader(new FileReader(className + ".in"));
				out = new PrintWriter(new FileWriter(className + ".out"));
			} catch (FileNotFoundException e) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			}
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new C().run();
	}

}
