import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class A {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	long gcd(long p, long q) {
		return BigInteger.valueOf(p).gcd(BigInteger.valueOf(q)).longValue();
	}

	String get(long p, long q) {
		long ans = 0;
		long gcd = gcd(p, q);
		p /= gcd;
		q /= gcd;

		if (q != Long.highestOneBit(q))
		// if (q != (1L<<(Long.highestOneBit(q))))
		{
			return "impossible";
		}

		long pow2 = 1;
		for (int i = 1; i <= 40; i++) {
			pow2 *= 2L;
			if (BigInteger.valueOf(p).multiply(BigInteger.valueOf(pow2))
					.compareTo(BigInteger.valueOf(q)) >= 0)
				return "" + i;
		}
		// return null;

		return "impossible";
	}

	void solve() throws Exception {
		int tn = nextInt();
		for (int ct = 1; ct <= tn; ct++) {
			String s = next();
			long p = Integer.parseInt(s.split("/")[0]);
			long q = Integer.parseInt(s.split("/")[1]);

			out.println("Case #" + ct + ": " + get(p, q));
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("a.in"));
			out = new PrintWriter(new FileWriter("a.out"));

			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A().run();

	}

}
