import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class A {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	long gcd(long p, long q) {
		return BigInteger.valueOf(p).gcd(BigInteger.valueOf(q)).longValue();
	}


	void solve() throws Exception {
		int tn = nextInt();
		for (int ct = 1; ct <= tn; ct++) {
			int n = nextInt(), s = nextInt();
			int a[] = new int[n];
			for (int i = 0; i < n; i++)
				a[i] = nextInt();

			Arrays.sort(a);

			out.println("Case #" + ct + ": " + get(a, s));

		}
	}

	int get(int[] a, int s) {
		int l = 0;
		int r = a.length - 1;
		int ans = 0;
		while (true) {
			if (l > r)
				return ans;
			if (l == r)
				return ans + 1;
			if (a[l] + a[r] <= s) {
				l++;
				r--;
				ans++;
			} else {
				r--;
				ans++;
			}
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("a.in"));
			out = new PrintWriter(new FileWriter("a.out"));

			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A().run();

	}

}
