import java.io.*;
import java.util.*;

public class A {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	char rev(char x) {
		if (x == '-')
			return '+';
		return '-';
	}

	int solve(char[] s, int x, int fr) {
		int n = s.length;
		int lm = -1;
		for (int i = fr; i < n && lm == -1; i++)
			if (s[i] == '-')
				lm = i;
		if (lm == -1)
			return 0;
		if (lm + x > n)
			return 10000;
		for (int i = 0; i < x; i++) {
			s[lm + i] = rev(s[lm + i]);
		}
		return solve(s, x, lm) + 1;
	}

	void solve() throws Exception {
		int t = nextInt();
		for (int i = 0; i < t; i++) {
			int res = solve(next().toCharArray(), nextInt(), 0);
			out.println("Case #" + (i + 1) + ": " + (res >= 10000 ? "IMPOSSIBLE" : res));
		}
	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			final String className = this.getClass().getName().toLowerCase();
			try {
				in = new BufferedReader(new FileReader(className + ".in"));
				out = new PrintWriter(new FileWriter(className + ".out"));
			} catch (FileNotFoundException e) {
				in = new BufferedReader(new InputStreamReader(System.in));
				out = new PrintWriter(System.out);
			}
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new A().run();
	}

}
