import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {

	BufferedReader in;
	StringTokenizer st;
	PrintWriter out;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	int nextInt() throws Exception {
		return Integer.parseInt(next());
	}

	long nextLong() throws Exception {
		return Long.parseLong(next());
	}

	double nextDouble() throws Exception {
		return Double.parseDouble(next());
	}

	String solve() throws Exception {
		int n = nextInt(), m = nextInt();

		int a[][] = new int[n][m];

		int h[] = new int[n];
		int v[] = new int[m];

		Arrays.fill(h, 0);
		Arrays.fill(v, 0);

		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++) {
				a[i][j] = nextInt();
				v[j] = Math.max(v[j], a[i][j]);
				h[i] = Math.max(h[i], a[i][j]);
			}

		int t[][] = new int[n][m];

		for (int i = 0; i < n; i++)
			Arrays.fill(t[i], 100);

		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++) {
				t[i][j] = Math.min(t[i][j], Math.min(h[i], v[j]));
			}

		for (int i = 0; i < n; i++)
			for (int j = 0; j < m; j++)
				if (t[i][j] != a[i][j])
					return "NO";

		return "YES";

	}

	void run() {
		try {
			Locale.setDefault(Locale.US);
			in = new BufferedReader(new FileReader("src/B.in"));
			out = new PrintWriter(new FileWriter("src/B.out"));
			int tc = nextInt();
			for (int t = 1; t <= tc; t++) {
				out.println("Case #" + t + ": " + solve());
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	public static void main(String[] args) {
		new B().run();

	}

}