import java.io.*;
import java.util.Arrays;

public class Lawnmower {
    public static byte MAX_HEIGHT = 100;

    public static void main(String[] args) throws IOException {
        LineNumberReader r = new LineNumberReader(new FileReader("/Users/ant/Downloads/B-large.in"));
        PrintWriter w = new PrintWriter(new FileWriter("/Users/ant/Downloads/B-large.out"));
        int n = Integer.parseInt(r.readLine());
        for (int i = 0; i < n; i++) {
            byte[][] b = readBoard(r);
            w.println("Case #" + (i + 1) + ": " + checkBoard(b));
        }
        r.close();
        w.close();
    }

    private static String checkBoard(byte[][] b) {
        byte[][] c = new byte[b.length][b[0].length];
        for (byte[] bytes : c) {
            Arrays.fill(bytes, MAX_HEIGHT);
        }
        return checkBoardR(b, c) ? "YES" : "NO";
    }

    private static boolean checkBoardR(byte[][] b, byte[][] c) {
        if (checkEquals(b, c)) {
            return true;
        }
        int max_i, max_j;
        max_i = max_j = -1;
        byte max = 0;
        for (int i = 0; i < b.length; i++) {
            for (int j = 0; j < b[0].length; j++) {
                if (b[i][j] != MAX_HEIGHT && c[i][j] == MAX_HEIGHT && b[i][j] > max) {
                    max_i = i;
                    max_j = j;
                }
            }
        }
        if (max_i == -1) {
            return false;
        }
        byte[][] c_row = copy(c);
        boolean skip = false;
        for (int i = 0; i < b[0].length && !skip; i++) {
            if (b[max_i][i] <= b[max_i][max_j]) {
                c_row[max_i][i] = b[max_i][max_j];
            } else {
                skip = true;
            }
        }
        if (!skip) {
            if (checkBoardR(b, c_row)) {
                return true;
            }
        }
        byte[][] c_column = copy(c);
        skip = false;
        for (int i = 0; i < b.length && !skip; i++) {
            if (b[i][max_j] <= b[max_i][max_j]) {
                c_column[i][max_j] = b[max_i][max_j];
            } else {
                skip = true;
            }
        }
        if (!skip) {
            if (checkBoardR(b, c_column)) {
                return true;
            }
        }
        return false;
    }

    private static boolean checkEquals(byte[][] one, byte[][] two) {
        for (int i = 0; i < one.length; i++) {
            if (!Arrays.equals(one[i], two[i])) {
                return false;
            }
        }
        return true;
    }

    private static byte[][] copy(byte[][] source) {
        int length = source.length;
        byte[][] target = new byte[length][source[0].length];
        for (int i = 0; i < length; i++) {
            System.arraycopy(source[i], 0, target[i], 0, source[i].length);
        }
        return target;
    }

    public static byte[][] readBoard(LineNumberReader r) throws IOException {
        String dim = r.readLine();
        int n = Integer.parseInt(dim.split(" ")[0].trim());
        int m = Integer.parseInt(dim.split(" ")[1].trim());
        byte[][] board = new byte[n][m];
        for (int i = 0; i < n; i++) {
            String[] s = r.readLine().split(" ");
            for (int j = 0; j < m; j++) {
                board[i][j] = Byte.decode(s[j]);
            }
        }
        return board;
    }
}
