package round1;

import java.io.*;
import java.util.Arrays;

/**
 * @author Anton Tychyna
 */
public class Osmos {
    public static void main(String[] args) throws IOException {
        Problem p = new Problem('a', true, 0);
        LineNumberReader r = new LineNumberReader(new FileReader("/Users/ant/Downloads/" + inputFile(p)));
        PrintWriter w = new PrintWriter(new FileWriter("/Users/ant/google/" + outputFile(p)));
        int n = Integer.parseInt(r.readLine());
        for (int i = 0; i < n; i++) {
            String[] s = r.readLine().split(" ");
            int initial = Integer.parseInt(s[0]);
            int motesCount = Integer.parseInt(s[1]);
            int[] motes = readMotes(r.readLine(), motesCount);
            Arrays.sort(motes);
            w.println("Case #" + (i + 1) + ": " + solve(initial, motes));
        }
        r.close();
        w.close();
    }

    private static int solve(int initial, int[] motes) {
        return solveR(motes, initial, 0);
    }

    private static int solveR(int[] motes, int current, int i) {
        if (i >= motes.length) {
            return 0;
        }
        if (motes[i] < current) {
            return solveR(motes, current + motes[i], i + 1);
        } else {
            if (current - 1 > 0) {
                return Math.min(solveR(motes, 2 * current - 1, i) + 1, solveR(motes, current, i + 1) + 1);
            } else {
                return solveR(motes, current, i + 1) + 1;
            }
        }
    }

    private static int[] readMotes(String s, int motesCount) {
        int[] motes = new int[motesCount];
        String[] motesString = s.split(" ");
        for (int i = 0; i < motesCount; i++) {
            motes[i] = Integer.parseInt(motesString[i]);
        }
        return motes;
    }

    // helper methods, not related to problem being solved
    private static String inputFile(Problem p) {
        if (p.small) {
            return p.c + "-small-attempt" + p.attempt + ".in";
        } else {
            return p.c + "-large-" + p.attempt + ".in";
        }
    }

    private static String outputFile(Problem p) {
        if (p.small) {
            return p.c + "-small.out";
        } else {
            return p.c + "-large.out";
        }
    }

    private static class Problem {
        char c;
        boolean small;
        int attempt;

        private Problem(char c, boolean small, int attempt) {
            this.c = Character.toUpperCase(c);
            this.small = small;
            this.attempt = attempt;
        }
    }
}
