import java.io.*;
import java.util.*;

public class MinesweeperMaster{
    public static void main(String[] args){
        if (args.length == 0)
            System.out.println("No file entered on command line.");
        else{
            MinesweeperMaster mm = new MinesweeperMaster();
            mm.readFile(args[0]);
        }
    
    }
    
    public void readFile(String filename){
        int testCases, rows, cols, mines;
        Scanner sc = null;
        try{
            sc = new Scanner(new File(filename));
            testCases = sc.nextInt();
            
            for (int i = 0; i < testCases; i++){
                rows = sc.nextInt();
                cols = sc.nextInt();
                mines = sc.nextInt();
                
                boolean ifValid = checkIfValid(rows, cols, mines);
                if (ifValid){
                    writeToFile(rows, cols, mines, i+1);
                }
                else //if such a move is impossible
                    writeToFile(ifValid, i+1);
            }
            sc.close();
        }
        catch(Exception e){
            System.out.println("Error with readFile() method: " + e.getMessage());
        }
    }

    //if one dimension, need at least two free spaces
    //if two dimensions, need at least four empty spaces
    public boolean checkIfValid(int rows, int cols, int mines){
        if (rows == 1 || cols == 1)
            if (((rows*cols)-mines) < 2)
                return false;
            else
                return true;
        else //if rows and cols are both greater than or equal to two
            if (((rows*cols)-mines) < 4)
                return false;
        return true;
    }


    public void writeToFile(boolean impos, int t){
        PrintWriter pw;
        File file = new File("output");
        try{
            if (!file.exists())
                file.createNewFile();
            pw = new PrintWriter(new FileWriter(file, true));
            
            pw.println("Case #" + t + ":");
            pw.println("Impossible");
            pw.close();
            
        }
        catch(Exception e){
            System.out.println("Error with writeToFile(): " + e.getMessage());
        }
    }
    
    public void writeToFile(int rows, int cols, int mines, int t){
        int numOfMines = mines;
        PrintWriter pw;
        File file = new File("output");
        try{
            if (!file.exists())
                file.createNewFile();
            pw = new PrintWriter(new FileWriter(file, true));
            
            pw.println("Case #" + t + ":");
            
            if (rows == 1){
                for (int i = 0; i < cols; i++){
                    if (numOfMines > 0){
                        pw.print("*");
                        numOfMines--;
                    }
                    else if (cols != (i+1))
                        pw.print(".");
                    else
                        pw.print("c");
                }
                pw.println();
            }
            else if (cols == 1){
                for (int i = 0; i < rows; i++){
                    if (numOfMines > 0){
                        pw.println("*");
                        numOfMines--;
                    }
                    else if (rows != (i+1))
                        pw.println(".");
                    else
                        pw.println("c");
                }
            }
            else{
                for(int i = 0; i < rows; i++){
                    for (int j = 0; j < cols; j++){
                        if(numOfMines > 0){
                            pw.print("*");
                            numOfMines--;

                        }
                        else if(i == rows-1 && j == cols-1){
                            pw.print("c");
                        }
                        else{
                            pw.print(".");
                        }
                    }
                    pw.println();
                }
            }
            pw.close();
            
        }
        catch(Exception e){
            System.out.println("Error with writeToFile(): " + e.getMessage());
        }
    }
    
}