import java.util.*;
import java.io.*;

public class MagicTrick{
    
    public static void main(String[] args){
            //read name of file
            if (args.length == 0)
                System.out.println("No file entered! Stopping at main method");

            else{
                MagicTrick m = new MagicTrick();
                m.readFile(args[0]);
            }
    }
    
    public void readFile(String filename){
        int numOfCases;
        int firstRow;
        int[][] firstCardSet = new int[4][4];
        int secondRow;
        int[][] secondCardSet = new int[4][4];
        Scanner sc = null;


        try{
            sc = new Scanner(new File(filename));
            numOfCases = sc.nextInt();
            
            for (int n = 0; n < numOfCases; n++){

                firstRow = sc.nextInt();
                //System.out.println(firstRow);
            
                for (int i = 0; i < firstCardSet.length; i++){
                    for (int j = 0; j < firstCardSet[0].length; j++){
                        firstCardSet[i][j] = sc.nextInt();
                        //System.out.print(firstCardSet[i][j] + " " );
                    }
                    //System.out.println();
                }
            
                 secondRow = sc.nextInt();
                 //System.out.println(secondRow);

                for (int i = 0; i < secondCardSet.length; i++){
                    for (int j = 0; j < secondCardSet[0].length; j++){
                        secondCardSet[i][j] = sc.nextInt();
                        //System.out.print(secondCardSet[i][j] + " ");
                    }
                    //System.out.println();
                }

                writeResults(firstCardSet[firstRow-1], secondCardSet[secondRow-1], (n+1));
            
            }
            
        }
        catch (Exception e){
            System.out.println("Problem at readFile() method:" + e.getMessage());
        }
        finally{
            sc.close();
        }
    }

    public void writeResults(int[] a1, int[] a2, int testCase){
        PrintWriter pw;
        File file = new File("output");

        int matchingCards = 0;
        int numOfMatching = 0;

        try{
            if (!file.exists()){
                file.createNewFile();
            }

            pw = new PrintWriter(new FileWriter(file, true));
            for (int i = 0; i < a1.length; i++){
                for(int j = 0; j < a2.length; j++){
                    if (a1[i] == a2[j]){
                        matchingCards = a1[i];
                        numOfMatching++;
                    }
                }
            }

            switch(numOfMatching){
                case 0:
                    pw.println("Case #"+ testCase +": Volunteer cheated!");
                    break;
                case 1:
                    pw.println("Case #"+ testCase +": " + matchingCards);
                    break;
                default: 
                    pw.println("Case #" + testCase + ": Bad magician!");
            }
            pw.close();
        }
        catch (Exception e){
            System.out.println("Error with writing to file:" + e.getMessage());
        }
    }
   
}