import java.io.*;
import java.util.*;

public class DeceitfulWar{
    public static void main(String[] args){
        if (args.length == 0)
            System.out.println("No filename was entered in command line.");
        else{
            DeceitfulWar dw = new DeceitfulWar();
            dw.readFile(args[0]);
        }
    }

    public void readFile(String filename){
        int testCases;
        int numOfBlocks;
        double[] naomiBlocks;
        double[] kenBlocks;

        try{
            Scanner sc = new Scanner(new File(filename));
            testCases = sc.nextInt();
            
            for (int j = 0; j < testCases; j++){
                numOfBlocks = sc.nextInt();
               // System.out.println(numOfBlocks);
                //for loops to fill arrays
                naomiBlocks = new double[numOfBlocks];
                kenBlocks = new double[numOfBlocks];

                for (int i = 0; i < (numOfBlocks); i++){
                    naomiBlocks[i] = sc.nextDouble();
                }
                System.out.println();
                for (int i = 0; i < numOfBlocks; i++){
                    kenBlocks[i] = sc.nextDouble();
                }

                int deceitPoints = playDeceit(numOfBlocks, naomiBlocks, kenBlocks);
                int fairPoints = playFair(numOfBlocks, naomiBlocks, kenBlocks);
                writeToFile(deceitPoints, fairPoints, testCases);           
            }
            sc.close();

        }
        catch(Exception e ){
            System.out.println("There was a problem with readFile(): " + e.getMessage());
        }
    }
    public int playDeceit(int blocks, double[] nBlocks, double[] kBlocks){
        Arrays.sort(nBlocks);
        Arrays.sort(kBlocks);
        int nPoints = 0;
        

        int fakeBlockCounter = 0;
        int pointer = blocks-1;
        int mPointer = pointer;
        for (int i = 0; i < blocks; i++){
            if(nBlocks[pointer] < kBlocks[mPointer] && fakeBlockCounter != pointer){
                //nBlocks[fakeBlockCounter++] = 0;
                fakeBlockCounter++;
                mPointer--;
            }
            else if(nBlocks[pointer] < kBlocks[mPointer]){
                mPointer--;
                //naomi lost a trade
            }
            else{ //if(nBlocks[pointer] > kBlocks[mPointer]){
                nPoints++;
                //nBlocks[pointer] = 0;
                mPointer--;
                pointer--;
            }
        }

        return nPoints;
    }

    public int playFair(int blocks, double[] nBlocks, double[] kBlocks){
        Arrays.sort(nBlocks);
        Arrays.sort(kBlocks);
        int nPoints = 0;
        
        /*
        for(double n: nBlocks){
            System.out.print(n + " ");
        }
        System.out.println();
        for (double k: kBlocks){
            System.out.print(k + " ");
        }
        System.out.println();
        */

        for (int i = 0; i < blocks; i++){
           for (int j = 0; j < blocks; j++){
               if (kBlocks[j] > nBlocks[i]){
                   kBlocks[j] = 0;
                   break;
               }
           }
           // if (nBlocks[i] > kBlocks[i])
            //    nPoints++;
        }
        for (double k:kBlocks){
            if (k != 0)
                nPoints++;
        }
        return nPoints;
    }

    public void writeToFile(int dPoints, int fPoints, int testCases){
        PrintWriter pw;
        File file = new File("output");
        try{
            if(!file.exists())
                file.createNewFile();

            pw = new PrintWriter(new FileWriter(file, true));
            pw.println("Case #" + testCases + ": " +dPoints + " " + fPoints);
            pw.close();

        }
        catch(Exception e){
            System.out.println("Error with writing to file:");
        }
    
    }

}