import java.util.*;
import java.io.*;
public class PancakeFlipper
{
  public static void main(String[] args)
  {
    // file input
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt(); // number of test cases is at the top of the file
    for(int i = 1; i <= t; i++)
    {
      // takes input from file
      String binaryStr = in.next();
      int k = Integer.parseInt(in.next());

      System.out.print("Case #" + i + ": ");
      flipPancakes(binaryStr, k);
    }
  }

  public static void flipPancakes(String b, int k)
  {
    int numOfFlips = 0;
    // parse through each character in string except for the last k-1
    for(int i = 0; i < b.length()-(k-1); i++)
    {
      // takes k amount of pancakes at a time
      String sub= b.substring(i, i+k);

      // complements the pancakes
      String compSub= sub.replace('-', '/');
      compSub= compSub.replace('+', '-');
      compSub= compSub.replace('/', '+');

      // converts pancakes into binary string
      String subBin = sub.replace('-', '0');
      subBin = subBin.replace('+', '1');
      String compSubBin = compSub.replace('-', '0');
      compSubBin = compSubBin.replace('+', '1');

      // if the flipped pancakes result in a larger binary number, then flip
      if (Integer.parseInt(compSubBin,2) > Integer.parseInt(subBin,2))
      {
        b = b.substring(0, i) + compSub + b.substring(i+k);
        numOfFlips++;
      }
      // else don't flip
    }

    //check to see if all pancakes are flipped
    if (b.indexOf('-') == -1)
    {
      System.out.println(numOfFlips);
    }
    else
    {
      System.out.println("IMPOSSIBLE");
    }

  }
}
