import java.util.*;
import java.io.*;
import java.text.*;

public class CookieClickerAlpha{
    public static void main(String[] args){
        if (args.length == 0)
            System.out.println("No file entered on command line");
        else{
            CookieClickerAlpha c = new CookieClickerAlpha();
            c.readFile(args[0]);
        }
    
    }

    public void readFile(String filename){
        Scanner sc = null;
        int t = 0;
        double farmCost; double farmCookiePerSec; double neededCookies;

        try{
            sc = new Scanner(new File(filename));
            t = sc.nextInt();

            for (int i = 0; i < t; i++){

                farmCost = sc.nextDouble();
                farmCookiePerSec = sc.nextDouble();
                neededCookies = sc.nextDouble();
                double result = calculateStrat(farmCost, farmCookiePerSec, neededCookies);
                writeToFile(result, (i+1));
            }
            sc.close();
        }
        catch(Exception e){
            System.out.println("Error with readFile: " + e.getMessage() );
        }
    }

    public double calculateStrat(double costOfFarm, double upgradedCookiePerSec, double cookieAmtNeeded){
        double c = costOfFarm; double f = upgradedCookiePerSec; double x = cookieAmtNeeded;
        double rate = 2.0;

        double adjustedRate;

        double startingWaitTime = x/rate;//50
        double timeSpentOnFarms = c/rate;//15
        adjustedRate = rate+f;//4.0
        double timeWithFarms = x/(adjustedRate) + timeSpentOnFarms;//25+15 = 40 

        while(timeWithFarms < startingWaitTime){
            startingWaitTime = timeWithFarms;
            timeSpentOnFarms += c/adjustedRate;
            rate = adjustedRate;
            adjustedRate += f;
            timeWithFarms = x/(adjustedRate)+timeSpentOnFarms;
        }

        return startingWaitTime;
    
    }

    public void writeToFile(double winningTime, int testCase){
        PrintWriter pw;
        File file = new File("output");
        try{
            if (!file.exists()){
                file.createNewFile();
            }
            pw = new PrintWriter(new FileWriter(file, true));
            DecimalFormat df = new DecimalFormat("#.#######");
                                                                        
            pw.println("Case #"+ testCase +": " + df.format(winningTime));
            pw.close();
        }
        catch (Exception e){
        System.out.println("Error with writing to file:" + e.getMessage());
        }
    }
    
}