import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.security.NoSuchAlgorithmException;

public class ProblemB {

	private static final Path IO_DIR = Paths.get("C:\\Users\\Terje\\Downloads");

	public static void main(String... args) throws NoSuchAlgorithmException, IOException {
		Path input = IO_DIR.resolve("B-small-attempt0.in");
		try (BufferedReader in = Files.newBufferedReader(input);
				BufferedWriter out = Files.newBufferedWriter(IO_DIR.resolve("problemB.out"))) {
			int T = Integer.parseInt(in.readLine());
			for (int i = 1; i <= T; i++) {
				String stack = in.readLine();
				int solution = solve(stack);
				out.write("Case #" + i + ": " + solution);
				out.newLine();
			}
		}
	}

	public static int solve(String stack) {
		if (stack.isEmpty()) {
			return 0;
		}

		int result = 1;
		char current = stack.charAt(0);
		for (int i = 1; i < stack.length(); i++) {
			if (stack.charAt(i) != current) {
				current = stack.charAt(i);
				result++;
			}
		}
		if (current == '+') {
			result--;
		}
		return result;
	}

}
