
import java.io.*;
import java.util.*;

public class Dijkstra{
    int[][] matrix={
        {0, 0, 0, 0, 0},
        {0, 1, 2, 3, 4},
        {0, 2,-1, 4,-3},
        {0, 3,-4,-1, 2},
        {0, 4, 3,-2,-1}};
    int[][] gi = {
        {1,2},
        {2,1},
        {3,4},
        {4,-3}};
    int[][] gk={
        {1,4},
        {2,3},
        {4,1},
        {3,-2}};
    int[] p4 = new int[4];

    public static void main(String[] argin) {
        Dijkstra inst = new Dijkstra();
        try{
            BufferedReader in = new BufferedReader(new FileReader(argin[0]));
            //PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("out.txt")));
            PrintStream out = System.out;
            int T = Integer.parseInt(in.readLine().trim());
            String[] strArr;
            int L,X;
            char[] a;
            int[] b;
            for(int ii=1; ii<=T; ii++){
                strArr=in.readLine().trim().split("[\\s]+");
                L = Integer.parseInt(strArr[0]);
                X = Integer.parseInt(strArr[1]);
                a = in.readLine().trim().toCharArray();
                b = new int[L];
                for(int i=0; i<L; i++) b[i] = a[i]-'i'+2;
                out.printf("Case #%d: %s\n", ii, inst.solver(L,X,b));
            }
            in.close();
            out.close();
        }catch(Exception e){
            System.err.println(e);
        }
    }
    int times(int a, int b){
        int t = matrix[Math.abs(a)][Math.abs(b)];
        return  (a*b)>0? t:-t;
    }
    int indp4(int a){
        for(int i=0; i<4; i++)
            if(p4[i]==a) return i;
        return -1;
    }
    String solver(int L,int X, int[] a){
        int[] p0x = new int[L+1];
        int[] pxL = new int[L+1];
        int temp;
        p0x[0]=1; pxL[L]=1;
        for(int i=1; i<=L; i++){
            temp=matrix[Math.abs(p0x[i-1])][a[i-1]];
            p0x[i]= (p0x[i-1]*a[i-1]) > 0 ? temp : -temp;

            int j=L-i;
            temp=matrix[a[j]][Math.abs(pxL[j+1])];
            pxL[j]= (a[j]*pxL[j+1])>0 ? temp : -temp;
        }

        p4[0]=1;
        for(int i=1; i<4; i++){
            temp=matrix[Math.abs(p4[i-1])] [Math.abs(p0x[L])];
            p4[i]= (p4[i-1]*p0x[L]) > 0 ? temp : -temp;
        }

        int i1,i2,k1,k2,  t1,t2,  jl,jm,jr;
        for(int i=0; i<4; i++) for(int j=-1; j<=1; j+=2) if(indp4(j*gi[i][0])>-1){
            i1=j*gi[i][0]; i2=j*gi[i][1];
            for(int k=0; k<4; k++) for(int l=-1; l<=1; l+=2) if(indp4(l*gk[k][1])>-1){
                k1=l*gk[k][0]; k2=l*gk[k][1];

                for(int i2i=0; i2i<=L; i2i++) if(p0x[i2i]==i2)
                    for(int k1i=0; k1i<=L; k1i++) if(pxL[k1i]==k1)
                        for(int jmi=0; jmi<4; jmi++){
                            jl=pxL[i2i]; jm=p4[jmi]; jr=p0x[k1i];
                            if(times(times(jl,jm),jr)==3){

                                if((X-indp4(i1)-indp4(k2)-jmi)%4==0) return "YES";
                            }
                        }
            }
        }

        return "NO";
    }
}


