/*
 * @(#)TicTacToe.java $version 2013. 4. 13.
 *
 * Copyright 2011 NHN Corp. All rights Reserved. 
 * NHN PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

package topcoder.example.codejam;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author : 쇼핑관리개발팀 정용균
 * @version $Rev$, $Date$ 
 */
public class TicTacToe {
	char[][] input = new char[4][4];
	
	public static void main(String args[]) throws Exception {
		new TicTacToe().run();
	}
	
	public void run() throws Exception{
		Scanner sc = new Scanner(new FileInputStream(new File("C:\\data\\A-large.in")));
		PrintWriter out = new PrintWriter(new FileOutputStream("C:\\data\\out.txt"));
		int cases = sc.nextInt();
		
		 while(cases-- > 0) {	 
			 for(int i =0; i < 4; i++){
				 input[i] = sc.next().toCharArray();
			 }
			 
			 out.println("Case #" + String.valueOf(1000 -cases)+ ": "+ getAnswer());
			 out.flush();
		 }
	}
	
	public String getAnswer(){
		int[] resultCode = new int[10];
		int result = -1;
		for(int i = 0; i < 4 ; i++){
			resultCode[i] = getRowWin(i);
			resultCode[i + 4] = getColumnWin(i);
		}
		resultCode[8] = getLeftSideWin();
		resultCode[9] = getRightSideWin();
		
		for(int elem : resultCode){
			if(elem == 0){
				result = 0;
				break;
			}
			
			if(elem == 1){
				result = 1;
				break;
			}
			
			if(elem == 3){
				result = 3;
			}
		}
		
		if(result == 0){
			return "X won";
		}else if(result == 1){
			return "O won";
		}else if(result == 3){
			return "Game has not completed";
		}else{
			return "Draw";
		}
	}
	
	// 0 : x win, 1 : o win, 2 : draw, 3, : not completed
	public int getRowWin(int num){
		int xCount = 0;
		int oCount = 0;
		int dotCount = 0;
		int tCount = 0;
		
		for(int i = 0; i < 4; i++){
			if(input[num][i] == 'X'){
				xCount++;
			}else if(input[num][i] == 'O'){
				oCount++;
			}else if(input[num][i] == '.'){
				dotCount++;
			}else if(input[num][i] == 'T'){
				tCount++;
			}
		}
		
		if(xCount == 4 || tCount + xCount == 4){
			return 0;
		}else if(oCount == 4 || tCount + oCount == 4){
			return 1;
		}else if(dotCount > 0){
			return 3;
		}else{
			return 2;
		}
	}
	
	public int getColumnWin(int num){
		int xCount = 0;
		int oCount = 0;
		int dotCount = 0;
		int tCount = 0;
		
		for(int i = 0; i < 4; i++){
			if(input[i][num] == 'X'){
				xCount++;
			}else if(input[i][num] == 'O'){
				oCount++;
			}else if(input[i][num] == '.'){
				dotCount++;
			}else if(input[i][num] == 'T'){
				tCount++;
			}
		}
		
		if(xCount == 4 || tCount + xCount == 4){
			return 0;
		}else if(oCount == 4 || tCount + oCount == 4){
			return 1;
		}else if(dotCount > 0){
			return 3;
		}else{
			return 2;
		}
	}
	
	public int getLeftSideWin(){
		int xCount = 0;
		int oCount = 0;
		int dotCount = 0;
		int tCount = 0;
		
		for(int i = 0; i < 4; i++){
			if(input[i][i] == 'X'){
				xCount++;
			}else if(input[i][i] == 'O'){
				oCount++;
			}else if(input[i][i] == '.'){
				dotCount++;
			}else if(input[i][i] == 'T'){
				tCount++;
			}
		}
		
		if(xCount == 4 || tCount + xCount == 4){
			return 0;
		}else if(oCount == 4 || tCount + oCount == 4){
			return 1;
		}else if(dotCount > 0){
			return 3;
		}else{
			return 2;
		}
	}
	
	public int getRightSideWin(){
		int xCount = 0;
		int oCount = 0;
		int dotCount = 0;
		int tCount = 0;
		
		for(int i = 0; i < 4; i++){
			if(input[3 -i][i] == 'X'){
				xCount++;
			}else if(input[3 -i][i] == 'O'){
				oCount++;
			}else if(input[3 -i][i] == '.'){
				dotCount++;
			}else if(input[3 -i][i] == 'T'){
				tCount++;
			}
		}
		
		if(xCount == 4 || tCount + xCount == 4){
			return 0;
		}else if(oCount == 4 || tCount + oCount == 4){
			return 1;
		}else if(dotCount > 0){
			return 3;
		}else{
			return 2;
		}
	}
}	
