import java.io.*;
import java.util.*;
import java.math.*;

public class ABig {
	public static void main(String[] args) throws Throwable {
		new ABig().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		ArrayList<Long> primes = new ArrayList<Long>();
		{
			boolean[] q = new boolean[10001];
			for (int i = 2; i < q.length; i++) {
				if (!q[i]) {
					int j = 2 * i;
					while (j < q.length) {
						q[j] = true;
						j += i;
					}
					primes.add(i + 0L);
				}
			}
		}
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			System.out.println(test);
			out.print("Case #" + test + ": ");
			int d = nextInt();
			int n = 1;
			while (d-- > 0) {
				n *= 10;
			}
			int m = nextInt();
			long[] s = new long[m];
			for (int i = 0; i < s.length; i++) {
				s[i] = nextInt();
			}
			if (m == 1) {
				out.println("I don't know.");
				continue;
			}
			TreeSet<Long> next = new TreeSet<Long>();
			for (long p : primes) {
				if (p < n && s[0] < p && next.size() < 2) {
					for (int a = 0; a < p && next.size() < 2; a++) {
						boolean good = true;
						long b = ((s[1] - s[0] * a) % p + p) % p;
						long apow = 1;
						long bb = 0;
						for (int i = 1; i < s.length; i++) {
							bb = (a * bb + b) % p;
							apow = (apow * a) % p;
							if ((apow * s[0] + bb) % p != s[i]) {
								good = false;
								break;
							}
						}
						if (good) {
							bb = (a * bb + b) % p;
							apow = (apow * a) % p;
							next.add((apow * s[0] + bb) % p);
						}
					}
				}
			}
			if (next.size() != 1) {
				out.println("I don't know.");
			} else {
				out.println(next.first());
			}
		}
	}
}