import java.io.*;
import java.util.*;

public class C {

	public static void main(String[] args) {
		new C().run();
	}

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "c";

	private void solve() throws IOException {
		int testn = nextInt();
		tests:for (int test = 1; test <= testn; test++) {
			out.println("Case #" + test + ": ");
			int r = nextInt();
			int c = nextInt();
			int m = nextInt();
			int[][] a = new int[r][c];
			int[][] b = new int[r][c];
			for (int prof = 0; prof < 1 << (r * c); prof++) {
				if (Integer.bitCount(prof) != m) {
					continue;
				}
				for (int i = 0; i < a.length; i++) {
					for (int j = 0; j < a[i].length; j++) {
						int k = i * c + j;
						if (((1 << k) & prof) != 0) {
							a[i][j] = 1;
						} else {
							a[i][j] = 0;
						}
					}
				}
				for (int i = 0; i < b.length; i++) {
					for (int j = 0; j < b[i].length; j++) {
						b[i][j] = 0;
						if (a[i][j] == 1) {
							b[i][j] = -1;
							continue;
						}
						for (int dx = -1; dx <= 1; dx++) {
							for (int dy = -1; dy <= 1; dy++) {
								int x = i + dx;
								int y = j + dy;
								if (x < 0 || x >= r || y < 0 || y >= c) {
									continue;
								}
								b[i][j] += a[x][y];
							}
						}
					}
				}
				int[][] d = new int[r][c];
				for (int i = 0; i < b.length; i++) {
					for (int j = 0; j < b[i].length; j++) {
						if (b[i][j] < 0) {
							continue;
						}
						for (int k = 0; k < d.length; k++) {
							Arrays.fill(d[k], 0);
						}
						dfs(a, b, d, i, j);
						boolean good = true;
						for (int x = 0; x < d.length; x++) {
							for (int y = 0; y < d[x].length; y++) {
								if (d[x][y] == 0 && b[x][y] >= 0) {
									good = false;
								}
							}
						}
						if (good) {
							for (int x = 0; x < a.length; x++) {
								for (int y = 0; y < a[x].length; y++) {
									if (a[x][y] == 1) {
										out.print("*");
									} else if (x == i && y == j) {
										out.print("c");
									} else {
										out.print(".");
									}
								}
								out.println();
							}
							continue tests;
						}
					}
				}
			}
			out.println("Impossible");
		}
	}

	private void dfs(int[][] a, int[][] b, int[][] d, int i, int j) {
		d[i][j] = 1;
		if (b[i][j] > 0) {
			return;
		}
		for (int dx = -1; dx <= 1; dx++) {
			for (int dy = -1; dy <= 1; dy++) {
				int x = i + dx;
				int y = j + dy;
				if (x < 0 || x >= a.length || y < 0 || y >= a[x].length) {
					continue;
				}
				if (d[x][y] == 0) {
					dfs(a, b, d, x, y);
				}
			}
		}
	}

}
