import java.io.*;
import java.util.*;

public class C {
	public static void main(String[] args) {
		new C().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "c";

	int MAX = 10;

	private void solve() throws IOException {
		int tests = nextInt();
		for (int test = 1; test <= tests; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int[] x = new int[n - 1];
			for (int i = 0; i < x.length; i++) {
				x[i] = nextInt() - 1;
			}
			double[] a = new double[n];
			Arrays.fill(a, -1);
			a[0] = MAX;
			a[x[0]] = MAX;
			boolean possible = solve(a, x, 1, x[0], 0, MAX)
					&& solve(a, x, x[0], n, 0, MAX);
			long[] c = new long[a.length];
			for (int i = 0; i < c.length; i++) {
				c[i] = Math.round(a[i] * 100000);
			}
			boolean b = check(c, x);
			if (b != possible) {
				System.out.println(test + " " + b + " " + possible);
			}
			if (!possible) {
				out.println("Impossible");
			} else {
				for (int i = 0; i < a.length; i++) {
					if (i > 0) {
						out.print(" ");
					}
					out.print(c[i]);
				}
				out.println();
			}
		}
	}

	private boolean check(long[] a, int[] x) {
		int[] s = new int[x.length];
		for (int i = 0; i < s.length; i++) {
			double k = Double.NEGATIVE_INFINITY;
			s[i] = -1;
			for (int j = i + 1; j < a.length; j++) {
				double k2 = (0.0 + a[j] - a[i]) / (j - i);
				if (k2 > k) {
					k = k2;
					s[i] = j;
				}
			}
		}
		return Arrays.equals(s, x);
	}

	double eps = 1e-2;

	private boolean solve(double[] a, int[] x, int l, int r, double k, double b) {
		if (l >= r || l >= x.length) {
			return true;
		}
		if (x[l] == r) {
			if (a[l] < 0) {
				a[l] = k * l + b - eps;
			}
			return solve(a, x, l + 1, r, getK(a, l, r), getB(a, l, r));
		} else if (x[l] > r) {
			return false;
		} else {
			int q = x[l];
			a[q] = k * q + b - eps;
			if (r >= a.length) {
				a[q] = k * q + b;
			} else if (a[l] >= 0) {
				double k3 = getK(a, l, r);
				double b3 = getB(a, l, r);
				a[q] = k3 * q + b3;
			}
			double k2 = 0;
			double b2 = 0;
			if (r >= a.length) {
				k2 = 0;
				b2 = a[q];
			} else {
				k2 = getK(a, q, r);
				b2 = getB(a, q, r);
			}
			if (a[l] < 0) {
				a[l] = k2 * l + b2 - eps;
			}
			return solve(a, x, l + 1, q, getK(a, l, q), getB(a, l, q))
					&& solve(a, x, q, r, k, b);
		}
	}

	private double getK(double[] a, int l, int r) {
		return (0.0 + a[r] - a[l]) / (0.0 + r - l);
	}

	private double getB(double[] a, int l, int r) {
		double k = getK(a, l, r);
		return a[l] - l * k;
	}
}
