import java.io.*;
import java.util.*;
import java.math.*;

public class Check {

	public static void main(String[] args) {
		new Check().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(2635243643L);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	String FNAME = "check";

	private void solve() throws IOException {
		boolean[] q = new boolean[1010];
		ArrayList<Integer> prime = new ArrayList<Integer>();
		for (int i = 2; i < q.length; i++) {
			if (!q[i]) {
				prime.add(i);
				for (int j = 2 * i; j < q.length; j += i) {
					q[j] = true;
				}
			}
		}
		int[] p = new int[prime.size()];
		for (int i = 0; i < p.length; i++) {
			p[i] = prime.get(i);
		}
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			if (n == 0) {
				out.println("0");
				continue;
			}
			int sum = 0;
			for (int i = 0; i < p.length; i++) {
				int x = 1;
				int deg = 0;
				while (x * p[i] <= n) {
					x *= p[i];
					deg++;
				}
				sum += deg;
			}
			if (n > 1) {
				sum++;
			}
			int s2 = 0;
			BigInteger lcm = BigInteger.valueOf(1);
			for (int i = n; i > 0; i--) {
				if (!lcm.mod(BigInteger.valueOf(i)).equals(BigInteger.ZERO)) {
					s2++;
					BigInteger gcd = lcm.gcd(BigInteger.valueOf(i));
					lcm = lcm.divide(gcd).multiply(BigInteger.valueOf(i));
				}
			}
			int s3 = 1;
			lcm = BigInteger.valueOf(1);
			for (int i = 1; i <= n; i++) {
				if (!lcm.mod(BigInteger.valueOf(i)).equals(BigInteger.ZERO)) {
					s3++;
					BigInteger gcd = lcm.gcd(BigInteger.valueOf(i));
					lcm = lcm.divide(gcd).multiply(BigInteger.valueOf(i));
				}
			}
			sum = Math.max(sum, s3);
			out.println(sum - s2);
			System.out.println(sum + " " + s2);
		}
	}

	int gcd(int a, int b) {
		while (b != 0) {
			int t = a % b;
			a = b;
			b = t;
		}
		return a;
	}

}