import java.io.*;
import java.util.*;
import java.math.*;

public class Balde {

	public static void main(String[] args) {
		new Balde().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(2635243643L);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	String FNAME = "blade";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int m = nextInt();
			int d = nextInt();
			int[][] a = new int[n][m];
			for (int i = 0; i < a.length; i++) {
				char[] s = nextToken().toCharArray();
				for (int j = 0; j < s.length; j++) {
					a[i][j] = s[j] - '0';
				}
			}
			long[][] s = new long[n][m];
			for (int i = 0; i < s.length; i++) {
				for (int j = 0; j < s[i].length; j++) {
					s[i][j] = a[i][j];
					if (i > 0) {
						s[i][j] += s[i - 1][j];
					}
					if (j > 0) {
						s[i][j] += s[i][j - 1];
					}
					if (i > 0 && j > 0) {
						s[i][j] -= s[i - 1][j - 1];
					}
				}
			}
			long[][] sx = new long[n][m];
			for (int i = 0; i < s.length; i++) {
				for (int j = 0; j < s[i].length; j++) {
					sx[i][j] = a[i][j] * i;
					if (i > 0) {
						sx[i][j] += sx[i - 1][j];
					}
					if (j > 0) {
						sx[i][j] += sx[i][j - 1];
					}
					if (i > 0 && j > 0) {
						sx[i][j] -= sx[i - 1][j - 1];
					}
				}
			}
			long[][] sy = new long[n][m];
			for (int i = 0; i < s.length; i++) {
				for (int j = 0; j < s[i].length; j++) {
					sy[i][j] = a[i][j] * j;
					if (i > 0) {
						sy[i][j] += sy[i - 1][j];
					}
					if (j > 0) {
						sy[i][j] += sy[i][j - 1];
					}
					if (i > 0 && j > 0) {
						sy[i][j] -= sy[i - 1][j - 1];
					}
				}
			}
			int ans = 0;
			for (int k = 3; k <= Math.min(n, m); k++) {
				for (int i = 0; i + k - 1 < s.length; i++) {
					for (int j = 0; j + k - 1 < s[i].length; j++) {
						if (k == 4) {
							k += 0;
						}
						long ms = getS(s, i, j, i + k - 1, j + k - 1);
						long xs = getS(sx, i, j, i + k - 1, j + k - 1);
						long ys = getS(sy, i, j, i + k - 1, j + k - 1);
						ms -= a[i][j] + a[i + k - 1][j]
								+ a[i + k - 1][j + k - 1] + a[i][j + k - 1];
						xs -= a[i][j] * i + a[i + k - 1][j] * (i + k - 1)
								+ a[i + k - 1][j + k - 1] * (i + k - 1)
								+ a[i][j + k - 1] * i;
						ys -= a[i][j] * j + a[i + k - 1][j] * j
								+ a[i + k - 1][j + k - 1] * (j + k - 1)
								+ a[i][j + k - 1] * (j + k - 1);
						if (xs * 2 == 2 * i * ms + (k - 1) * ms) {
							if (ys * 2 == 2 * j * ms + (k - 1) * ms) {
								ans = Math.max(ans, k);
							}
						}
					}
				}
			}
			if (ans < 3) {
				out.println("IMPOSSIBLE");
			} else {
				out.println(ans);
			}
		}
	}

	private long getS(long[][] s, int i, int j, int k, int l) {
		long sum = s[k][l];
		if (i > 0) {
			sum -= s[i - 1][l];
		}
		if (j > 0) {
			sum -= s[k][j - 1];
		}
		if (i > 0 && j > 0) {
			sum += s[i - 1][j - 1];
		}
		return sum;
	}
}
