import java.io.*;
import java.util.*;
import java.math.*;

public class AHard {
	public static void main(String[] args) throws Throwable {
		new AHard().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int m = nextInt();
			Node root = new Node();
			for (int i = 0; i < n; i++) {
				String s = nextToken();
				root.add(s);
			}
			mark(root);
			for (int i = 0; i < m; i++) {
				String s = nextToken();
				root.add(s);
			}
			out.println(mark(root));
		}
	}

	private int mark(Node root) {
		int ans = 0;
		if (!root.ex) {
			root.ex = true;
			ans++;
		}
		for (Node n : root.hm.values()) {
			ans += mark(n);
		}
		return ans;
	}

	class Node {
		String name;
		HashMap<String, Node> hm = new HashMap<String, Node>();
		boolean ex;

		public void add(String s) {
			s = s.substring(1);
			String str = s;
			if (s.indexOf('/') >= 0) {
				str = s.substring(0, s.indexOf('/'));
			}
			if (!hm.containsKey(str)) {
				Node n = new Node();
				n.name = str;
				hm.put(str, n);
			}
			if (s.indexOf('/') >= 0) {
				hm.get(str).add(s.substring(s.indexOf('/')));
			}
		}
	}

}