import java.io.*;
import java.util.*;
import java.math.*;

public class StupWar {

	public static void main(String[] args) {
		new StupWar().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(2635243643L);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), "\n\t\r ,");
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	String FNAME = "war";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			System.out.println(test);
			int n = nextInt();
			int m = nextInt();
			int[] x = new int[m];
			int[] y = new int[m];
			a = new int[n][n];
			for (int i = 0; i < m; i++) {
				x[i] = nextInt();
				y[i] = nextInt();
				a[x[i]][y[i]] = 1;
				a[y[i]][x[i]] = 1;
			}
			d = new int[n];
			Arrays.fill(d, Integer.MAX_VALUE / 2);
			d[0] = 0;
			for (int i = 0; i < d.length; i++) {
				for (int j = 0; j < x.length; j++) {
					if (d[x[j]] > d[y[j]] + 1) {
						d[x[j]] = d[y[j]] + 1;
					}
					if (d[y[j]] > d[x[j]] + 1) {
						d[y[j]] = d[x[j]] + 1;
					}
				}
			}
			ans = 0;
			bf(1, 0, new ArrayList<Integer>());
			out.println(d[1] - 1 + " " + ans);
		}
	}

	private void bf(int x, int z, ArrayList<Integer> path) {
		if (x == z) {
			check(path);
			return;
		}
		for (int i = 0; i < a[x].length; i++) {
			if (a[x][i] == 1 && d[i] + 1 == d[x]) {
				path.add(i);
				bf(i, z, path);
				path.remove(path.size() - 1);
			}
		}
	}

	private void check(ArrayList<Integer> path) {
		if (q == null || q.length != a.length) {
			q = new boolean[a.length];
		}
		Arrays.fill(q, false);
		for (int i : path) {
			for (int j = 0; j < a[i].length; j++) {
				if (a[i][j] == 1) {
					q[j] = true;
				}
			}
		}
		for (int i : path) {
			q[i] = false;
		}
		int cnt = 0;
		for (int i = 0; i < q.length; i++) {
			if (q[i]) {
				cnt++;
			}
		}
		ans = Math.max(ans, cnt);
	}

	int ans = 0;
	int[][] a;
	int[] d;
	boolean[] q;
}
