import java.io.*;
import java.util.*;

public class Coaster2 implements Runnable {

	public static void main(String[] args) {
		new Thread(new Coaster2()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	@Override
	public void run() {
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(566);
		}

	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "b";

	class Customer implements Comparable<Customer> {
		ArrayList<Integer> tickets = new ArrayList<>();
		boolean[] done;
		int pointer;
		int n;

		public Customer(int i) {
			n = i;
		}

		@Override
		public int compareTo(Customer c) {
			int x = tickets.get(pointer);
			int y = c.tickets.get(c.pointer);
			if (x == y) {
				return n - c.n;
			}
			return x - y;
		}

		@Override
		public String toString() {
			return n + " -> " + (pointer < tickets.size() ? tickets.get(pointer) : "-");
		}
	}

	private void solve() {
		long time = System.currentTimeMillis();
		int testn = nextInt();
		tests: for (int test = 1; test <= testn; test++) {
			System.out.println(test + ": " + (System.currentTimeMillis() - time));
			out.print("Case #" + test + ": ");
			out.flush();

			int n = nextInt();
			int c = nextInt();
			int m = nextInt();
			Customer[] customers = new Customer[c];
			for (int i = 0; i < customers.length; i++) {
				customers[i] = new Customer(i);
			}
			for (int i = 0; i < m; i++) {
				int p = nextInt();
				int b = nextInt();
				customers[b - 1].tickets.add(p - 1);
			}
			for (int i = 0; i < customers.length; i++) {
				Collections.sort(customers[i].tickets);
				customers[i].done = new boolean[customers[i].tickets.size()];
			}
			if (customers[0].tickets.size() > customers[1].tickets.size()) {
				Customer cust = customers[0];
				customers[0] = customers[1];
				customers[1] = cust;
			}
			Customer custA = customers[0];
			Customer custB = customers[1];
			int ans = 0;
			int ans2 = 0;
			for (int i = 0; i < custA.done.length; i++) {
				for (int j = 0; j < custB.done.length; j++) {
					if (custA.tickets.get(i).equals(custB.tickets.get(j)) || custB.done[j]) {
						continue;
					}
					custA.done[i] = true;
					custB.done[j] = true;
					ans++;
				}
			}
			int firstA = 0;
			int restA = 0;
			int firstB = 0;
			int restB = 0;
			for (int i = 0; i < custA.done.length; i++) {
				if (custA.done[i]) {
					continue;
				}
				if (custA.tickets.get(i).equals(0)) {
					firstA++;
				} else {
					restA++;
				}
			}
			for (int i = 0; i < custB.done.length; i++) {
				if (custB.done[i]) {
					continue;
				}
				if (custB.tickets.get(i).equals(0)) {
					firstB++;
				} else {
					restB++;
				}
			}
			int keepo = Math.min(firstA, restB);
			ans += keepo;
			firstA -= keepo;
			restB -= keepo;
			keepo = Math.min(firstB, restA);
			ans += keepo;
			firstB -= keepo;
			restA -= keepo;
			ans += firstA + firstB + Math.max(restA, restB);
			ans2 += Math.min(restA, restB);
			out.println(ans + " " + ans2);
		}
	}

}
