import java.io.*;
import java.util.*;
import java.math.*;

import sun.security.util.BigInt;

public class A implements Runnable {

	public static void main(String[] args) {
		new Thread(new A()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		int testN = nextInt();
		for (int test = 0; test < testN; test++) {
			out.print("Case #" + (test + 1) + ": ");
			int n = nextInt();
			int A = nextInt();
			int B = nextInt();
			int C = nextInt();
			int D = nextInt();
			int x0 = nextInt();
			int y0 = nextInt();
			int M = nextInt();
			a = new long[3][3];
			long x = x0;
			long y = y0;
			a[(int) (x % 3)][(int) (y % 3)]++;
			for (int i = 0; i < n - 1; i++) {
				x = (A * x + B) % M;
				y = (C * y + D) % M;
				a[(int) (x % 3)][(int) (y % 3)]++;
			}
			ans = BigInteger.ZERO;
			DFS(new ArrayList<Pair>());
			out.println(ans.divide(BigInteger.valueOf(6)));
		}
	}

	BigInteger ans;

	long[][] a;

	private void DFS(ArrayList<Pair> al) {
		if (al.size() == 3) {
			int[][] b = new int[3][3];
			BigInteger tmp = BigInteger.ONE;
			int x = 0;
			int y = 0;
			int k = 1;
			for (Pair p : al) {
				tmp = tmp.multiply(BigInteger
						.valueOf(a[p.x][p.y] - b[p.x][p.y]));
				b[p.x][p.y]++;
				k = Math.max(k, b[p.x][p.y]);
				x += p.x;
				y += p.y;
			}
			if (x % 3 == 0 && y % 3 == 0) {
				ans = ans.add(tmp.divide(BigInteger.valueOf(1)));
			}
			return;
		}
		for (int i = 0; i < 3; i++) {
			for (int j = 0; j < 3; j++) {
				al.add(new Pair(i, j));
				DFS(al);
				al.remove(al.size() - 1);
			}
		}
	}

	class Pair {
		public Pair(int i, int j) {
			x = i;
			y = j;
		}

		int x, y;
	}

}
