import java.io.*;
import java.util.*;
import java.math.*;

public class Toilet implements Runnable {

	public static void main(String[] args) {
		new Thread(new Toilet()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	@Override
	public void run() {
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(255);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLond() {
		return Long.parseLong(nextToken());
	}

	String FNAME = "c";

	private void solve() {
		int tests = nextInt();
		nextTest: for (int test = 1; test <= tests; test++) {
			out.print("Case #" + test + ": ");
			long n = nextLond();
			long k = nextLond();
			Pair ans = compute(n, k);
			Pair stupid = stupidAns((int) n, (int) k);
			if (stupid.first != ans.first || stupid.second != ans.second) {
				System.out.println(n + " " + k);
				System.out.println(stupid.first + " " + stupid.second);
			}
			out.println(ans.first + " " + ans.second);
		}
	}

	private Pair stupidAns(int n, int k) {
		boolean[] q = new boolean[n + 2];
		q[0] = true;
		q[n + 1] = true;
		int[] left = new int[n + 2];
		int[] right = new int[n + 2];
		for (int man = 0; man < k; man++) {
			for (int i = 0; i < left.length; i++) {
				if (q[i]) {
					left[i] = 0;
				} else {
					left[i] = left[i - 1] + 1;
				}
			}
			for (int i = right.length - 1; i >= 0; i--) {
				if (q[i]) {
					right[i] = 0;
				} else {
					right[i] = right[i + 1] + 1;
				}
			}
			int best = 0;
			for (int i = 0; i < q.length; i++) {
				if (q[i]) {
					continue;
				}
				if (q[best] || Math.min(left[best], right[best]) < Math.min(left[i], right[i])
						|| Math.min(left[best], right[best]) == Math.min(left[i], right[i])
								&& Math.max(left[best], right[best]) < Math.max(left[i], right[i])) {
					best = i;
				}
			}
//			System.out.println(best);
			q[best] = true;
			if (man + 1 == k) {
				return new Pair(right[best] - 1, left[best] - 1);
			}
		}
		return null;
	}

	HashMap<String, Pair> cache = new HashMap<>();

	class Pair {
		public Pair(long l, long m) {
			first = l;
			second = m;
		}

		long first;
		long second;
	}

	private Pair compute(long n, long k) {
		long left = 0;
		long right = n;
		while (right - left > 1) {
			long m = (left + right) / 2;
			long volume = getMaxVolume(n, m, m);
			if (volume >= k) {
				left = m;
			} else {
				right = m;
			}
		}
		long min = left;
		long max = min + 1;
		while (true) {
			long volume = getMaxVolume(n, min, max);
			if (volume < k) {
				break;
			}
			max++;
		}
		return new Pair(max - 1, min);
	}
	
	HashMap<String, Long> maxVolume = new HashMap<>();
	
	long getMaxVolume(long n, long min, long max) {
		String key = n + ":" + min + ":" + max;
		if (maxVolume.containsKey(key)) {
			return maxVolume.get(key);
		}
		long ans = 0;
		if (n >= min + max + 1) {
			ans = 1 + getMaxVolume(n / 2, min, max) + getMaxVolume((n - 1) / 2, min, max);
		}
		maxVolume.put(key, ans);
		return ans;
	}

}
