import java.io.*;
import java.util.*;
import java.math.*;

public class Water implements Runnable {

	public static void main(String[] args) {
		new Thread(new Water()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "water";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int[] x = new int[3];
			int[] y = new int[3];
			int[] r = new int[3];
			for (int i = 0; i < r.length; i++) {
				if (i < n) {
					x[i] = nextInt();
					y[i] = nextInt();
					r[i] = nextInt();
				} else {
					x[i] = x[i - 1];
					y[i] = y[i - 1];
					r[i] = r[i - 1];
				}
			}
			for (int i = 0; i < r.length; i++) {
				for (int j = 0; j < i; j++) {
					if (inside(x[i], y[i], r[i], x[j], y[j], r[j])) {
						x[i] = x[j];
						y[i] = y[j];
						r[i] = r[j];
					}
				}
			}
			double ans = Double.POSITIVE_INFINITY;
			// if (n == 1) {
			// ans = r[0];
			// }
			// if (n == 2) {
			// for (int i = 0; i < r.length; i++) {
			// for (int j = 0; j < r.length; j++) {
			// if (i != j) {
			// ans = Math.min(ans, (r[i] + r[j] + dist(x[i], y[i],
			// x[j], y[j])) / 2);
			// }
			// }
			// }
			// }
			for (int i = 0; i < r.length; i++) {
				for (int j = 0; j < r.length; j++) {
					if (i != j) {
						for (int k = 0; k < r.length; k++) {
							if (i != k && j != k) {
								ans = Math.min(ans, Math.max(r[k],
										(r[i] + r[j] + dist(x[i], y[i], x[j],
												y[j])) / 2));
							}
						}
					}
				}
			}
			out.println(ans);
		}
	}

	private boolean inside(int x1, int y1, int r1, int x2, int y2, int r2) {
		return dist(x1, y1, x2, y2) + r1 <= r2;
	}

	private double dist(int x1, int y1, int x2, int y2) {
		return Math.sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
	}

}
