import java.io.*;
import java.util.*;
import java.math.*;

public class Magicka {
	public static void main(String[] args) {
		new Magicka().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(5362134);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "magicka";

	private void solve() throws IOException {
		for (int test = 1, tests = nextInt(); test <= tests; test++) {
			out.print("Case #" + test + ": ");
			int r = nextInt();
			char[][] a = new char[26][26];
			for (int i = 0; i < r; i++) {
				char[] s = nextToken().toCharArray();
				a[s[0] - 'A'][s[1] - 'A'] = s[2];
				a[s[1] - 'A'][s[0] - 'A'] = s[2];
			}
			int e = nextInt();
			boolean[][] b = new boolean[26][26];
			for (int i = 0; i < e; i++) {
				char[] s = nextToken().toCharArray();
				b[s[0] - 'A'][s[1] - 'A'] = true;
				b[s[1] - 'A'][s[0] - 'A'] = true;
			}
			int n = nextInt();
			char[] s = nextToken().toCharArray();
			char[] stack = new char[n];
			int top = 0;
			int[] u = new int[26];
			for (int i = 0; i < s.length; i++) {
				stack[top++] = s[i];
				u[s[i] - 'A']++;
				loop: while (top > 1) {
					if (top > 1
							&& a[stack[top - 1] - 'A'][stack[top - 2] - 'A'] != 0) {
						u[stack[top - 1] - 'A']--;
						u[stack[top - 2] - 'A']--;
						stack[top - 2] = a[stack[top - 1] - 'A'][stack[top - 2] - 'A'];
						top--;
					} else {
						for (int j = 0; j < u.length; j++) {
							if (u[j] > 0 && b[stack[top - 1] - 'A'][j]
									&& j != stack[top - 1] - 'A') {
								top = 0;
								Arrays.fill(u, 0);
								break loop;
							}
							if (u[j] > 1 && b[stack[top - 1] - 'A'][j]
									&& j == stack[top - 1] - 'A') {
								top = 0;
								Arrays.fill(u, 0);
								break loop;
							}
						}
						break;
					}
				}
			}
			out.print("[");
			for (int i = 0; i < top; i++) {
				if (i > 0) {
					out.print(", ");
				}
				out.print(stack[i]);
			}
			out.println("]");
		}
	}
}
