import java.io.*;
import java.util.*;
import java.math.*;

public class Football implements Runnable {

	public static void main(String[] args) {
		new Thread(new Football()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "football";

	class Point implements Comparable<Point> {
		int x, y, n;

		public Point(int i, int j, int n2) {
			x = i;
			y = j;
			n = n2;
		}

		@Override
		public int compareTo(Point p) {
			return x - p.x;
		}
	}

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			ArrayList<Point>[] a = new ArrayList[30];
			for (int i = 0; i < a.length; i++) {
				a[i] = new ArrayList<Point>();
			}
			g = new ArrayList[n];
			for (int i = 0; i < g.length; i++) {
				g[i] = new ArrayList<Integer>();
			}
			while (n-- > 0) {
				Point p = new Point(nextInt() - 1, nextInt() - 1, n);
				a[p.y].add(p);
			}
			int m = 0;
			for (int i = 0; i < a.length; i++) {
				Collections.sort(a[i]);
				for (int j = 0; j + 1 < a[i].size(); j++) {
					g[a[i].get(j).n].add(a[i].get(j + 1).n);
					g[a[i].get(j + 1).n].add(a[i].get(j).n);
					m++;
				}
			}
			for (int i = 0; i + 1 < a.length; i++) {
				int k = 0;
				for (int j = 0; j < a[i].size(); j++) {
					while (k < a[i + 1].size()
							&& a[i].get(j).x > a[i + 1].get(k).x) {
						k++;
					}
					if (k < a[i + 1].size()) {
						g[a[i].get(j).n].add(a[i + 1].get(k).n);
						g[a[i + 1].get(k).n].add(a[i].get(j).n);
						m++;
					}
				}
			}
			for (int i = 1; i < a.length; i++) {
				int k = 0;
				for (int j = 0; j < a[i].size(); j++) {
					while (k < a[i - 1].size()
							&& a[i].get(j).x > a[i - 1].get(k).x) {
						k++;
					}
					if (k < a[i - 1].size()) {
						g[a[i].get(j).n].add(a[i - 1].get(k).n);
						g[a[i - 1].get(k).n].add(a[i].get(j).n);
						m++;
					}
				}
			}
			if (m == 0) {
				out.println(1);
				continue;
			}
			u = new boolean[g.length];
			c = new int[g.length];
			boolean good = true;
			for (int i = 0; i < a.length; i++) {
				if (a[i].size() > 0 && !u[a[i].get(0).n]) {
					good &= dfs(a[i].get(0).n, 0);
				}
			}
			if (good) {
				out.println(2);
			} else {
				out.println(3);
			}
		}
	}

	boolean[] u;
	int[] c;
	ArrayList<Integer>[] g;

	private boolean dfs(int x, int j) {
		u[x] = true;
		c[x] = j;
		for (int i : g[x]) {
			if (!u[i]) {
				dfs(i, 1 - j);
			}
			if (c[x] == c[i]) {
				return false;
			}
		}
		return true;
	}

}
