import java.io.*;
import java.util.*;

public class C {
	public static void main(String[] args) {
		new C().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "c";

	private void solve() throws IOException {
		int tests = nextInt();
		for (int test = 1; test <= tests; test++) {
			out.print("Case #" + test + ": ");
			int m = nextInt();
			int f = nextInt();
			int n = nextInt();
			Food[] s = new Food[n];
			for (int i = 0; i < s.length; i++) {
				s[i] = new Food(nextInt(), nextInt(), i);
			}
			long[] money = new long[m + 1];
			Arrays.fill(money, Integer.MAX_VALUE / 2);
			money[0] = f;
			for (int i = 1; i < money.length; i++) {
				int min = Integer.MAX_VALUE / 2;
				for (int j = 0; j < s.length; j++) {
					if (s[j].s + 1 < i) {
						continue;
					}
					min = Math.min(min, s[j].p);
				}
				if (min >= Integer.MAX_VALUE / 2) {
					break;
				}
				money[i] = money[i - 1] + min;
			}
			int ans = 0;
			while (m > 0) {
				int besti = -1;
				for (int i = 1; i < money.length && money[i] <= m; i++) {
					if (besti < 0 || money[besti] * i > money[i] * besti) {
						besti = i;
					}
				}
				if (besti < 0) {
					break;
				}
				ans += (m / money[besti]) * besti;
				m %= money[besti];
			}
			out.println(ans);
		}
	}

	class Food {
		public Food(int nextInt, int nextInt2, int i) {
			p = nextInt;
			s = nextInt2;
			n = i;
		}

		int p, s, n;

	}
}
