import java.io.*;
import java.util.*;
import java.math.*;

public class BHard {
	public static void main(String[] args) throws Throwable {
		new BHard().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int l = nextInt();
			int r = nextInt();
			int c = nextInt();
			ArrayList<Long> al = new ArrayList<Long>();
			HashSet<Long> hs = new HashSet<Long>();
			long ind = l;
			while (ind < r) {
				al.add(ind);
				hs.add(ind);
				ind *= c;
			}
			ind = r;
			while (ind > l) {
				if (!hs.contains(ind)) {
					al.add(ind);
				}
				ind = (ind + c - 1) / c;
			}
			Collections.sort(al);
			long[] t = new long[al.size()];
			for (int j = 0; j < t.length; j++) {
				t[j] = al.get(j);
			}
			int[][] a = new int[t.length][t.length];
			for (int i = 0; i < a.length; i++) {
				Arrays.fill(a[i], Integer.MAX_VALUE / 2);
				for (int j = 0; j < a.length; j++) {
					if (t[i] * c >= t[j]) {
						a[i][j] = 0;
					}
				}
			}
			for (int len = 0; len < a.length; len++) {
				for (int i = 0; i + len < a.length; i++) {
					int j = i + len;
					for (int k = i + 1; k < j; k++) {
						a[i][j] = Math.min(a[i][j],
								Math.max(a[i][k], a[k][j]) + 1);
					}
				}
			}
			out.println(a[0][t.length - 1]);
		}
	}

}