import java.io.*;
import java.util.*;
import java.math.*;

public class Stones {
	public static void main(String[] args) {
		new Stones().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "c";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int m = nextInt();
			int k = nextInt();
			int min = k;
			boolean[][] a = new boolean[n][m];
			boolean[][] b = new boolean[n][m];
			for (int prof = 0; prof < 1 << (n * m); prof++) {
				int num = Integer.bitCount(prof);
				if (num > min) {
					continue;
				}
				int p = prof;
				for (int i = 0; i < a.length; i++) {
					for (int j = 0; j < a[i].length; j++) {
						a[i][j] = p % 2 == 1;
						p /= 2;
						b[i][j] = false;
					}
				}
				for (int i = 0; i < b.length; i++) {
					if (!b[i][0] && !a[i][0]) {
						dfs(a, b, i, 0);
					}
					if (!b[i][b[i].length - 1] && !a[i][b[i].length - 1]) {
						dfs(a, b, i, b[i].length - 1);
					}
				}
				for (int i = 0; i < b[0].length; i++) {
					if (!b[0][i] && !a[0][i]) {
						dfs(a, b, 0, i);
					}
					if (!b[b.length - 1][i] && !a[b.length - 1][i]) {
						dfs(a, b, b.length - 1, i);
					}
				}
				int cnt = 0;
				for (int i = 0; i < b.length; i++) {
					for (int j = 0; j < b[i].length; j++) {
						if (!b[i][j]) {
							cnt++;
						}
					}
				}
				if (cnt >= k) {
					min = Math.min(min, num);
				}
			}
			out.println(min);
		}
	}

	int[] dx = { 0, 1, 0, -1 };
	int[] dy = { 1, 0, -1, 0 };

	private void dfs(boolean[][] a, boolean[][] b, int i, int j) {
		b[i][j] = true;
		for (int k = 0; k < dx.length; k++) {
			int x = i + dx[k];
			int y = j + dy[k];
			if (x < 0 || x >= a.length || y < 0 || y >= a[x].length || a[x][y] || b[x][y]) {
				continue;
			}
			dfs(a, b, x, y);
		}

	}

}
