import java.io.*;
import java.util.*;
import java.math.*;

import sun.security.util.BigInt;

public class d_small implements Runnable {

	public static void main(String[] args) {
		new Thread(new d_small()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "d";

	private void solve() throws IOException {
		int testN = nextInt();
		for (int test = 0; test < testN; test++) {
			out.print("Case #" + (test + 1) + ": ");
			int k = nextInt();
			char[] s = nextToken().toCharArray();
			int[] a = new int[k];
			for (int i = 0; i < a.length; i++) {
				a[i] = i;
			}
			int res = s.length;
			while (a != null) {
				// System.err.println(Arrays.toString(a));
				res = Math.min(res, tryThis(s, a));
				a = next(a);
			}
			out.println(res);
		}
	}

	private int[] next(int[] a) {
		int i = a.length - 1;
		boolean[] q = new boolean[a.length];
		q[a[i]] = true;
		while (i > 0 && a[i] < a[i - 1]) {
			q[a[i]] = true;
			i--;
			q[a[i]] = true;
		}
		if (i <= 0) {
			return null;
		}
		q[a[i - 1]] = true;
		if (i <= 0) {
			return null;
		}
		int j = a[i - 1] + 1;
		while (j < q.length && !q[j]) {
			j++;
		}
		if (j >= q.length) {
			return null;
		}
		a[i - 1] = j;
		q[j] = false;
		j = 0;
		for (int k = i; k < a.length; k++) {
			while (!q[j]) {
				j++;
			}
			a[k] = j;
			q[j] = false;
		}
		return a;
	}

	private int tryThis(char[] s, int[] a) {
		char[] t = new char[s.length];
		for (int i = 0; i < s.length / a.length; i++) {
			for (int j = 0; j < a.length; j++) {
				t[i * a.length + j] = s[i * a.length + a[j]];
			}
		}
		int ans = 1;
		for (int i = 1; i < t.length; i++) {
			if (t[i] != t[i - 1]) {
				ans++;
			}
		}
		return ans;
	}
}
