import java.io.*;
import java.util.*;
import java.math.*;

public class Dig implements Runnable {

	public static void main(String[] args) {
		new Thread(new Dig()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "dig";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int m = nextInt();
			int f = nextInt();
			char[][] map = new char[n + 1][];
			// long[] base = new long[n];
			for (int i = 0; i + 1 < map.length; i++) {
				map[i] = nextToken().toCharArray();
				// base[i] = encode(map[i]);
			}
			map[n] = new char[m];
			for (int i = 0; i < map[n].length; i++) {
				map[n][i] = '.';
			}
			int[][] height = new int[n + 1][m];
			for (int i = height.length - 1; i >= 0; i--) {
				for (int j = 0; j < height[i].length; j++) {
					if (i + 1 >= height.length) {
						height[i][j] = 0;
					} else {
						height[i][j] = map[i + 1][j] == '#' ? 1
								: (1 + height[i + 1][j]);
					}
				}
			}
			HashMap<Long, Integer>[] a = new HashMap[n + 1];
			for (int i = 0; i < a.length; i++) {
				a[i] = new HashMap<Long, Integer>();
			}
			char[] b = map[0].clone();
			long qq = encode(b);
			a[0].put(qq, 0);
			for (int y = 0; y + 1 < a.length; y++) {
				for (long st : a[y].keySet()) {
					int x = (int) (st >> m);
					int d = a[y].get(st);
					decode(b, st);
					int l = x;
					while (l > 0 && b[l - 1] == '.' && map[y + 1][l - 1] != '.') {
						l--;
					}
					int r = x;
					while (r + 1 < b.length && b[r + 1] == '.'
							&& map[y + 1][r + 1] != '.') {
						r++;
					}
					int add = 0;
					b = map[y + 1].clone();
					if (b[x] == '.') {
						put(a[y + 1], b, x, d);
						continue;
					}
					if (l > 0 && b[l - 1] == '.' && map[y][l - 1] == '.'
							&& height[y + 1][l - 1] <= f) {
						put(a[y + 1], b, l - 1, d);
					}
					if (r + 1 < b.length && b[r + 1] == '.'
							&& map[y][r + 1] == '.'
							&& height[y + 1][r + 1] <= f) {
						put(a[y + 1], b, r + 1, d);
					}
					for (int i = l; i <= r; i++) {
						for (int j = 0; i + j <= r; j++) {
							// System.out.println(l + " " + r + " " + i + " " +
							// j);
							b[i + j] = '.';
							add++;
							if (j == 0 && r - l > 0 && height[y + 1][i] <= f) {
								put(a[y + 1], b, i, d + add);
							}
							if (i != l && height[y + 1][i] <= f) {
								put(a[y + 1], b, i, d + add);
							}
							if (i + j != r && height[y + 1][i + j] <= f) {
								put(a[y + 1], b, i + j, d + add);
							}
						}
						for (int j = 0; i + j <= r; j++) {
							b[i + j] = '#';
							add--;
						}
					}
				}
			}
			int ans = Integer.MAX_VALUE / 2;
			for (long l : a[n].keySet()) {
				ans = Math.min(ans, a[n].get(l));
			}
			if (ans >= Integer.MAX_VALUE / 2) {
				out.println("No");
			} else {
				out.println("Yes " + ans);
			}
			// for (int i = 0; i < a.length; i++) {
			// for (long st : a[i].keySet()) {
			// int x = (int) (st >> b.length);
			// decode(b, st);
			// b[x] = '*';
			// out.println(i + " " + Arrays.toString(b) + " " + x + " "
			// + a[i].get(st));
			// }
			// out.println();
			// }
		}
	}

	private void put(HashMap<Long, Integer> a, char[] b, long i, int d) {
		long s = encode(b);
		s |= i << b.length;
		if (!a.containsKey(s)) {
			a.put(s, Integer.MAX_VALUE / 2);
		}
		b[(int) i] = '*';
		// System.out.println(Arrays.toString(b));
		b[(int) i] = '.';
		int q = Math.min(d, a.get(s));
		a.put(s, q);
	}

	private long encode(char[] b) {
		long ans = 0;
		for (int j = 0; j < b.length; j++) {
			ans |= b[j] == '.' ? 0 : (1L << j);
		}
		return ans;
	}

	private void decode(char[] b, long st) {
		for (int j = 0; j < b.length; j++) {
			b[j] = (st & (1L << j)) != 0 ? '#' : '.';
		}
	}

}
