import java.io.*;
import java.util.*;
import java.math.*;

public class Trains {
	public static void main(String[] args) {
		new Trains().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		BigInteger[] fac = new BigInteger[101];
		fac[0] = BigInteger.ONE;
		for (int i = 1; i < fac.length; i++) {
			fac[i] = fac[i - 1].multiply(BigInteger.valueOf(i));
		}
		int testn = nextInt();
		loop: for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			char[][] a = new char[n][];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextToken().toCharArray();
			}
			int[] first = new int[n];
			int[] last = new int[n];
			int[] middle = new int[26];
			for (int i = 0; i < a.length; i++) {
				first[i] = a[i][0] - 'a';
				last[i] = a[i][a[i].length - 1] - 'a';
				int left = 0;
				while (left < a[i].length && a[i][left] == a[i][0]) {
					left++;
				}
				int right = a[i].length;
				while (right > 0 && a[i][right - 1] == a[i][a[i].length - 1]) {
					right--;
				}
				if (first[i] == last[i] && left < right) {
					out.println(0);
					continue loop;
				}
				for (int j = left; j < right; j++) {
					if (j == left || a[i][j] != a[i][j - 1]) {
						middle[a[i][j] - 'a']++;
					}
				}
			}
			for (int i = 0; i < middle.length; i++) {
				if (middle[i] > 1) {
					out.println("0");
					continue loop;
				}
			}
			for (int i = 0; i < first.length; i++) {
				if (middle[first[i]] > 0 || middle[last[i]] > 0) {
					out.println("0");
					continue loop;
				}
			}
			int[] inDeg = new int[26];
			int[] outDeg = new int[26];
			int[] loop = new int[26];
			for (int i = 0; i < first.length; i++) {
				if (first[i] == last[i]) {
					loop[first[i]]++;
				} else {
					outDeg[first[i]]++;
					inDeg[last[i]]++;
				}
			}
			for (int i = 0; i < loop.length; i++) {
				if (inDeg[i] > 1 || outDeg[i] > 1) {
					out.println("0");
					continue loop;
				}
			}
			boolean[] done = new boolean[26];
			int comps = 0;
			while (true) {
				boolean hasNotDone = false;
				int start = -1;
				for (int i = 0; i < done.length; i++) {
					if (!done[i]) {
						hasNotDone = true;
						if (inDeg[i] == 0) {
							start = i;
						}
					}
				}
				if (!hasNotDone) {
					break;
				}
				if (start < 0) {
					out.println(0);
					continue loop;
				}
				boolean nonEmpty = loop[start] > 0;
				while (start >= 0) {
					done[start] = true;
					int next = -1;
					for (int i = 0; i < first.length; i++) {
						if (first[i] != last[i] && first[i] == start) {
							next = last[i];
							nonEmpty = true;
						}
					}
					start = next;
				}
				if (nonEmpty) {
					comps++;
				}
			}
			BigInteger ans = fac[comps];
			for (int i = 0; i < loop.length; i++) {
				ans = ans.multiply(fac[loop[i]]);
			}
			out.println(ans);
		}
	}

}
