import java.io.*;
import java.util.*;
import java.math.*;

public class CBig {
	public static void main(String[] args) throws Throwable {
		new CBig().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "c";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int r = nextInt();
			int k = nextInt();
			int n = nextInt();
			long[] a = new long[n];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextInt();
			}
			long sumAll = 0;
			for (int i = 0; i < a.length; i++) {
				sumAll += a[i];
			}
			int[] next = new int[n];
			for (int i = 0; i < next.length; i++) {
				if (sumAll <= k) {
					next[i] = i;
				} else {
					long sum = 0;
					int j = i;
					while (sum + a[j] <= k) {
						sum += a[j];
						j = (j + 1) % a.length;
					}
					next[i] = j;
				}
			}
			for (int i = 1; i < a.length; i++) {
				a[i] += a[i - 1];
			}
			long[] s = new long[n];
			for (int i = 0; i < s.length; i++) {
				if (next[i] == i) {
					s[i] = sumAll;
				} else if (i < next[i]) {
					s[i] = (next[i] > 0 ? a[next[i] - 1] : 0)
							- (i > 0 ? a[i - 1] : 0);
				} else {
					s[i] = sumAll + (next[i] > 0 ? a[next[i] - 1] : 0)
							- (i > 0 ? a[i - 1] : 0);
				}
			}
			int loop = 0;
			int preloop = 0;
			long presum = 0;
			long loops = 0;
			int[] pos = new int[n];
			int st = 0;
			for (int i = 1;; i++) {
				if (pos[st] > 0) {
					loop = i - pos[st];
					preloop = pos[st] - 1;
					break;
				} else {
					pos[st] = i;
					loops += s[st];
					presum += s[st];
					st = next[st];
				}
			}
			long ans = 0;
			if (r >= preloop) {
				st = 0;
			} else {
				ans += presum;
				r -= preloop;
				ans += loops * (r / loop);
				r %= loop;
			}
			while (r-- > 0) {
				ans += s[st];
				st = next[st];
			}
			out.println(ans);
		}
	}

}