import java.io.*;
import java.util.*;
import java.math.*;

import sun.security.util.BigInt;

public class B implements Runnable {

	public static void main(String[] args) {
		new Thread(new B()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), "\n\t :");
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken("\n\t :");
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	int nextTime() {
		return nextInt() * 60 + nextInt();
	}

	String FNAME = "b";

	private void solve() throws IOException {
		int testN = nextInt();
		for (int test = 0; test < testN; test++) {
			out.print("Case #" + (test + 1) + ": ");
			int t = nextInt();
			int n = nextInt();
			int m = nextInt();
			Train[] a = new Train[n];
			for (int i = 0; i < a.length; i++) {
				a[i] = new Train(nextTime(), nextTime());
			}
			Train[] b = new Train[m];
			for (int i = 0; i < b.length; i++) {
				b[i] = new Train(nextTime(), nextTime());
			}
			Arrays.sort(a);
			Arrays.sort(b);
			PriorityQueue<Integer> pqa = new PriorityQueue<Integer>();
			PriorityQueue<Integer> pqb = new PriorityQueue<Integer>();
			int i = 0;
			int j = 0;
			int na = 0;
			int nb = 0;
			while (i < n || j < m) {
				if (j >= m || (i < n && a[i].compareTo(b[j]) <= 0)) {
					if (pqa.size() > 0 && pqa.peek() <= a[i].dep) {
						pqa.poll();
					} else {
						na++;
					}
					pqb.add(a[i].arr + t);
					i++;
				} else {
					if (pqb.size() > 0 && pqb.peek() <= b[j].dep) {
						pqb.poll();
					} else {
						nb++;
					}
					pqa.add(b[j].arr + t);
					j++;
				}
			}
			out.println(na + " " + nb);
		}
	}

	class Train implements Comparable<Train> {
		public Train(int i, int j) {
			dep = i;
			arr = j;
		}

		int dep, arr;

		public int compareTo(Train t) {
			return dep - t.dep;
		}
	}

}
