import java.io.*;
import java.util.*;
import java.math.*;

public class watersheds_aa implements Runnable {

	public static void main(String[] args) {
		new Thread(new watersheds_aa()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "watersheds";

	int[] u;

	int[] dx = new int[] { -1, 0, 0, 1 };
	int[] dy = new int[] { 0, -1, 1, 0 };

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			int n = nextInt();
			int m = nextInt();
			int[][] a = new int[n][m];
			u = new int[m * n];
			for (int i = 0; i < u.length; i++) {
				u[i] = i;
			}
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					a[i][j] = nextInt();
				}
			}
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					int mind = -1;
					int min = Integer.MAX_VALUE;
					for (int d = 0; d < dx.length; d++) {
						int x = i + dx[d];
						int y = j + dy[d];
						if (0 <= x && x < a.length && 0 <= y && y < a[x].length
								&& min > a[x][y]) {
							min = a[x][y];
							mind = d;
						}
					}
					if (min < a[i][j]) {
						int x = i + dx[mind];
						int y = j + dy[mind];
						union(x * m + y, i * m + j);
					}
				}
			}
			boolean[] used = new boolean[u.length];
			char[] c = new char[u.length];
			out.println("Case #" + test + ":");
			char min = 'a';
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					int x = get(i * m + j);
					if (!used[x]) {
						used[x] = true;
						c[x] = min++;
					}
					out.print(c[x] + " ");
				}
				out.println();
			}
		}
	}

	private void union(int i, int j) {
		u[get(j)] = get(i);
	}

	private int get(int i) {
		if (u[i] != i) {
			u[i] = get(u[i]);
		}
		return u[i];
	}
}
