import java.io.*;
import java.util.*;

public class Paths {
	public static void main(String[] args) {
		new Paths().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "c";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			System.out.println("Case #" + test + ": ");
			int n = nextInt();
			int m = nextInt();
			int p = nextInt();
			ArrayList<Edge>[] g = new ArrayList[n];
			for (int i = 0; i < g.length; i++) {
				g[i] = new ArrayList<>();
			}
			Edge[] edges = new Edge[m];
			for (int i = 0; i < m; i++) {
				int x = nextInt() - 1;
				int y = nextInt() - 1;
				int a = nextInt();
				int b = nextInt();
				edges[i] = new Edge(x, y, a, b);
				g[x].add(edges[i]);
			}
			int[] path = new int[p];
			for (int i = 0; i < path.length; i++) {
				path[i] = nextInt() - 1;
			}
			long[] dMax = new long[n];
			Arrays.fill(dMax, Long.MAX_VALUE / 2);
			dMax[0] = 0;
			for (int i = 0; i < n; i++) {
				boolean change = false;
				for (Edge e : edges) {
					if (dMax[e.y] > dMax[e.x] + e.b) {
						change = true;
						dMax[e.y] = dMax[e.x] + e.b;
					}
				}
				if (!change) {
					break;
				}
			}
			long[] din = new long[n];
			Arrays.fill(din, Long.MAX_VALUE / 2);
			din[1] = 0;
			for (int i = 0; i < n; i++) {
				boolean change = false;
				for (Edge e : edges) {
					if (din[e.x] > din[e.y] + e.a) {
						change = true;
						din[e.x] = din[e.y] + e.a;
					}
				}
				if (!change) {
					break;
				}
			}
			long[] dax = new long[n];
			Arrays.fill(dax, Long.MAX_VALUE / 2);
			dax[1] = 0;
			for (int i = 0; i < n; i++) {
				boolean change = false;
				for (Edge e : edges) {
					if (dax[e.x] > dax[e.y] + e.b) {
						change = true;
						dax[e.x] = dax[e.y] + e.b;
					}
				}
				if (!change) {
					break;
				}
			}
			boolean[] u = new boolean[n];
			int ans = Integer.MAX_VALUE / 2;
			long sum = 0;
			long msum = 0;
			long min = Long.MAX_VALUE / 2;
			for (int i = 0; i < path.length; i++) {
				Edge e = edges[path[i]];
				u[e.x] = true;
				min = Math.min(min, msum + dax[e.x]);
				if (msum + e.a > dMax[e.y]) {
					ans = Math.min(ans, i);
					break;
				}
				if (dax[e.x] < e.a + din[e.y]) {
					ans = Math.min(ans, i);
					break;
				}
				if (min < msum + e.a + din[e.y]) {
					ans = Math.min(ans, i);
					break;
				}
				if (u[e.y]) {
					ans = Math.min(ans, i);
					break;
				}
				sum += e.b;
				msum += e.a;
			}
			if (ans >= path.length) {
				out.println("Looks Good To Me");
			} else {
				out.println(path[ans] + 1);
			}

		}
	}

	class Edge {
		public Edge(int x2, int y2, int a2, int b2) {
			x = x2;
			y = y2;
			a = a2;
			b = b2;
		}

		int x, y;
		int a, b;
	}
}
