import java.io.*;
import java.util.*;
import java.math.*;

public class BHard {
	public static void main(String[] args) throws Throwable {
		new BHard().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int k = nextInt();
			b = nextInt();
			int t = nextInt();
			Chicken[] a = new Chicken[n];
			for (int i = 0; i < a.length; i++) {
				a[i] = new Chicken();
				a[i].x = nextInt();
			}
			for (int i = 0; i < a.length; i++) {
				a[i].v = nextInt();
			}
			int good = 0;
			for (int i = 0; i < a.length; i++) {
				if (a[i].time(b) <= t) {
					good++;
				}
			}
			if (good < k) {
				out.println("IMPOSSIBLE");
				continue;
			}
			int ans = 0;
			TreeSet<Double> ts = new TreeSet<Double>();
			for (int i = 0; i < a.length; i++) {
				for (int j = i + 1; j < a.length; j++) {
					if (a[i].v > a[j].v) {
						ts.add(a[i].catches(a[j]));
					}
				}
			}
			for (int i = a.length - 1; i >= 0; i--) {
				if (a[i].time(b) <= t && k > 0) {
					a[i].good = true;
					k--;
				}
			}
			while (ts.size() > 0 && ts.first() <= t) {
				double tt = ts.pollFirst();
				for (int i = 0; i + 1 < a.length; i++) {
					if (a[i].v > a[i + 1].v && a[i].catches(a[i + 1]) == tt
							&& a[i].good && !a[i + 1].good) {
						Chicken tmp = a[i];
						a[i] = a[i + 1];
						a[i + 1] = tmp;
						ans++;
					}
				}
			}
			out.println(ans);
		}
	}

	int b;

	class Chicken {
		int x, v;
		boolean good;

		@Override
		public String toString() {
			return "" + time(b);
		}

		public double time(int b) {
			return (b - x + 0.0) / v;
		}

		public double catches(Chicken c) {
			return (c.x - x + 0.0) / (v - c.v);
		}
	}

}