import java.io.*;
import java.util.*;
import java.math.*;

public class BotTrust {
	public static void main(String[] args) {
		new BotTrust().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(5362134);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "bot";

	private void solve() throws IOException {
		for (int test = 1, tests = nextInt(); test <= tests; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int[] a = new int[n];
			int o = 0;
			for (int i = 0; i < a.length; i++) {
				char c = nextToken().charAt(0);
				int x = nextInt();
				if (c == 'O') {
					x = -x;
					o++;
				}
				a[i] = x;
			}
			int[] b = new int[n - o];
			int[] c = new int[o];
			int tb = 0;
			int tc = 0;
			for (int i = 0; i < a.length; i++) {
				if (a[i] < 0) {
					c[tc++] = -a[i];
				} else {
					b[tb++] = a[i];
				}
			}
			int x = 1;
			int y = 1;
			tb = 0;
			tc = 0;
			int time = 0;
			for (int i = 0; i < a.length; i++) {
				while (true) {
					if (a[i] < 0 && -a[i] == y) {
						break;
					}
					if (a[i] > 0 && a[i] == x) {
						break;
					}
					time++;
					if (tb < b.length) {
						x += dir(b[tb] - x);
					}
					if (tc < c.length) {
						y += dir(c[tc] - y);
					}
				}
				time++;
				if (a[i] < 0) {
					tc++;
					if (tb < b.length) {
						x += dir(b[tb] - x);
					}
				} else {
					tb++;
					if (tc < c.length) {
						y += dir(c[tc] - y);
					}
				}
			}
			out.println(time);
		}
	}

	private int dir(int i) {
		return i < 0 ? -1 : i > 0 ? 1 : 0;
	}
}
