import java.io.*;
import java.util.*;

public class Tries {
	public static void main(String[] args) {
		new Tries().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "d";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int m = nextInt();
			int n = nextInt();
			char[][] s = new char[m][];
			for (int i = 0; i < s.length; i++) {
				s[i] = nextToken().toCharArray();
			}
			int max = 0;
			int cases = 0;
			int[] num = new int[m];
			loop: for (int index = 0;; index++) {
				int prof = index;
				for (int i = 0; i < num.length; i++) {
					num[i] = prof % n;
					prof /= n;
				}
				if (prof > 0) {
					break;
				}
				ArrayList<char[]>[] buckets = new ArrayList[n];
				for (int i = 0; i < buckets.length; i++) {
					buckets[i] = new ArrayList<>();
				}
				for (int i = 0; i < num.length; i++) {
					buckets[num[i]].add(s[i]);
				}
				int size = 0;
				for (ArrayList<char[]> bucket : buckets) {
					if (bucket.isEmpty()) {
						continue loop;
					}
					size += getTrieSize(bucket);
				}
				if (size > max) {
					max = size;
					cases = 0;
				}
				if (size == max) {
					cases++;
				}
			}
			out.println(max + " " + cases);
		}
	}

	int[][] a = new int[100][26];

	private int getTrieSize(ArrayList<char[]> bucket) {
		for (int i = 0; i < a.length; i++) {
			Arrays.fill(a[i], -1);
		}
		int size = 1;
		for (char[] s : bucket) {
			int x = 0;
			for (int i = 0; i < s.length; i++) {
				int c = s[i] - 'A';
				if (a[x][c] < 0) {
					a[x][c] = size++;
				}
				x = a[x][c];
			}
		}
		return size;
	}
}
