import java.io.*;
import java.util.*;

public class B {
	public static void main(String[] args) {
		new B().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		long time = System.currentTimeMillis();
		int tests = nextInt();
		for (int test = 1; test <= tests; test++) {
			System.out.println(test + "/" + tests);
			out.print("Case #" + test + ":");
			int n = nextInt();
			int w = nextInt();
			int l = nextInt();
			double[] r = new double[n];
			for (int i = 0; i < r.length; i++) {
				r[i] = nextInt();
			}
			double[] x = new double[n];
			double[] y = new double[n];
			double[] dx = new double[n];
			double[] dy = new double[n];
			boolean good = false;
			while (!good) {
				System.out.println("shuffle");
				for (int i = 0; i < x.length; i++) {
					x[i] = rand.nextInt(w) + rand.nextDouble();
					y[i] = rand.nextInt(w) + rand.nextDouble();
				}
				good = check(x, y, r, w, l);
				if (good) {
					break;
				}
				for (int step = 0; !good && step < 1000000; step++) {
					Arrays.fill(dx, 0);
					Arrays.fill(dy, 0);
					for (int i = 0; i < x.length; i++) {
						for (int j = 0; j < x.length; j++) {
							if (i == j) {
								continue;
							}
							double diff = (x[i] - x[j]) * (x[i] - x[j])
									+ (y[i] - y[j]) * (y[i] - y[j])
									- (r[i] + r[j]) * (r[i] + r[j]);
							double x1 = x[j] - x[i];
							double y1 = y[j] - y[i];
							double d = Math.sqrt(x1 * x1 + y1 * y1);
							x1 /= d;
							y1 /= d;
							if (diff < 0) {
								diff = Math.sqrt(Math.abs(diff)) / 2;
								dx[i] += -diff * x1;
								dy[i] += -diff * y1;
							}
						}
						if (x[i] < bound) {
							dx[i] = (-x[i] + 1) / 2;
						}
						if (x[i] > w - bound) {
							dx[i] = (w - 1 - x[i]) / 2;
						}
						if (y[i] < bound) {
							dy[i] = (-y[i] + 1) / 2;
						}
						if (y[i] > l - bound) {
							y[i] = (l - 1 - y[i]) / 2;
						}
					}
					for (int i = 0; i < x.length; i++) {
						x[i] += dx[i];
						y[i] += dy[i];
					}
					good = check(x, y, r, w, l);
					if (good) {
						System.out.println(step);
					}
				}
			}
			for (int i = 0; i < x.length; i++) {
				out.print(" " + x[i] + " " + y[i]);
			}
			out.println();
		}
		System.out.println((System.currentTimeMillis() - time) / 1000.0);
	}

	double bound = 1e-3;

	private boolean check(double[] x, double[] y, double[] r, int w, int l) {
		boolean good = true;
		for (int i = 0; good && i < x.length; i++) {
			good &= 0 <= x[i] && x[i] <= w && 0 <= y[i] && y[i] <= l;
		}
		if (!good) {
			// System.out.println("fail1");
		}
		for (int i = 0; good && i < x.length; i++) {
			for (int j = i + 1; good && j < x.length; j++) {
				good &= (x[i] - x[j]) * (x[i] - x[j]) + (y[i] - y[j])
						* (y[i] - y[j]) > (r[i] + r[j]) * (r[i] + r[j]);
			}
		}
		return good;
	}
}
