import java.io.*;
import java.util.*;
import java.math.*;

public class Tic {
	public static void main(String[] args) {
		new Tic().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		loop: for (int test = 0, testn = nextInt(); test < testn; test++) {
			out.print("Case #" + (test + 1) + ": ");
			char[][] a = new char[4][];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextToken().toCharArray();
			}
			int empty = 0;
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					if (a[i][j] == '.') {
						empty++;
					}
				}
			}
			String names = "XO";
			for (int player = 0; player < names.length(); player++) {
				char c = names.charAt(player);
				for (int i = 0; i < a.length; i++) {
					boolean good = true;
					for (int j = 0; j < a[i].length; j++) {
						good &= a[i][j] == c || a[i][j] == 'T';
					}
					if (good) {
						out.println(c + " won");
						continue loop;
					}
					good = true;
					for (int j = 0; j < a[i].length; j++) {
						good &= a[j][i] == c || a[j][i] == 'T';
					}
					if (good) {
						out.println(c + " won");
						continue loop;
					}
				}
				{
					boolean good = true;
					for (int i = 0; i < a.length; i++) {
						good &= a[i][i] == c || a[i][i] == 'T';
					}
					if (good) {
						out.println(c + " won");
						continue loop;
					}
				}
				{
					boolean good = true;
					for (int i = 0; i < a.length; i++) {
						good &= a[i][3 - i] == c || a[i][3 - i] == 'T';
					}
					if (good) {
						out.println(c + " won");
						continue loop;
					}
				}
			}
			if (empty == 0) {
				out.println("Draw");
			} else {
				out.println("Game has not completed");
			}
		}
	}

}
