import java.io.*;
import java.util.*;
import java.math.*;

public class Mine_simple implements Runnable {

	public static void main(String[] args) {
		new Thread(new Mine_simple()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "mine";

	private void solve() throws IOException {
		long time = System.currentTimeMillis();
		int testn = nextInt();
		for (int test = 0; test < testn; test++) {
			out.print("Case #" + (test + 1) + ": ");
			int r = nextInt();
			int c = nextInt();
			int[][] a = new int[r][c];
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					a[i][j] = nextInt();
				}
			}
			int[][] b = new int[r][c];
			int[][] d = new int[r][c];
			int ans = 0;
			int mask = ((1 << c) - 1) << (r / 2);
			for (int t = 1 << (r * c) - 1; t >= 0; t--) {
				int y = Integer.bitCount(mask & t);
				if (y < ans) {
					continue;
				}
				for (int i = 0; i < b.length; i++) {
					for (int j = 0; j < b[i].length; j++) {
						b[i][j] = (t & (1 << (j + i * c))) != 0 ? 1 : 0;
					}
					Arrays.fill(d[i], 0);
				}
				for (int i = 0; i < d.length; i++) {
					for (int di = -1; di < 2; di++) {
						if (0 <= i + di && i + di < d.length) {
							for (int j = 0; j < d[i].length; j++) {
								for (int dj = -1; dj < 2; dj++) {
									if (0 <= j + dj && j + dj < d[i].length) {
										d[i][j] += b[i + di][j + dj];
									}
								}
							}
						}
					}
				}
				boolean good = true;
				for (int i = 0; i < d.length; i++) {
					for (int j = 0; j < d[i].length; j++) {
						good &= d[i][j] == a[i][j];
					}
				}
				if (good) {
					ans = Math.max(ans, y);
				}
				if ((System.currentTimeMillis() - time) / 1000.0 > 220) {
					break;
				}
			}
			out.println(ans);
			out.flush();
			System.out.println((System.currentTimeMillis() - time) / 1000.0);
		}
	}
}
