import java.io.*;
import java.util.*;
import java.math.*;

public class CSmall {
	public static void main(String[] args) throws Throwable {
		new CSmall().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "c";

	private void solve() throws IOException {
		int[] rev = new int[16];
		for (int i = 0; i < rev.length; i++) {
			String s = Integer.toBinaryString(i);
			while (s.length() < 4) {
				s = "0" + s;
			}
			rev[i] = Integer.parseInt(
					new StringBuilder(s).reverse().toString(), 2);
		}
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int m = nextInt();
			int[][] map = new int[n][(m + 31) / 32];
			for (int i = 0; i < map.length; i++) {
				char[] s = nextToken().toCharArray();
				if (i == 14) {
					i += 0;
				}
				for (int j = 0; j < s.length; j++) {
					int q = s[j] - 'A' + 10;
					if ('0' <= s[j] && s[j] <= '9') {
						q = s[j] - '0';
					}
					q = rev[q];
					map[i][j / 8] ^= q << 4 * (j % 8);
				}
			}
			for (int i = 0; i < map.length; i++) {
				for (int j = 0; j < map[i].length; j++) {
					map[i][j] = ~map[i][j];
				}
			}
			int[][] a = new int[n][m];
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					if ((map[i][j / 32] & (1 << (j % 32))) != 0) {
						a[i][j] = 1;
					}
				}
			}
			// out.println();
			// for (int i = 0; i < map.length; i++) {
			// for (int j = 0; j < m; j++) {
			// if (a[i][j] == 1) {
			// out.print('1');
			// } else {
			// out.print('0');
			// }
			// }
			// out.println();
			// }
			int[] ans = new int[Math.max(n, m) + 1];
			loop: while (true) {
				for (int max = a.length; max > 0; max--) {
					for (int x = 0; x + max <= n; x++) {
						for (int y = 0; y + max <= m; y++) {
							if (max == 4 && x == 11 && y == 0) {
								max += 0;
							}
							boolean good = true;
							for (int i = 0; i < max && good; i++) {
								for (int j = 0; j < max && good; j++) {
									good &= a[x + i][y + j] >= 0;
									good &= (i + j) % 2 == 0 ? (a[x + i][y + j] == a[x][y])
											: (a[x + i][y + j] != a[x][y]);
								}
							}
							if (good) {
								for (int i = 0; i < max && good; i++) {
									for (int j = 0; j < max && good; j++) {
										a[x + i][y + j] = -2;
									}
								}
								ans[max]++;
								// System.out.println(max + " " + x + " " + y);
								continue loop;
							}
						}
					}
				}
				break;
			}
			// System.out.println("next");
			int ff = 0;
			for (int i = 0; i < ans.length; i++) {
				if (ans[i] > 0) {
					ff++;
				}
			}
			out.println(ff);
			for (int i = ans.length - 1; i >= 0; i--) {
				if (ans[i] > 0) {
					out.println(i + " " + ans[i]);
				}
			}
		}
	}
}