import java.io.*;
import java.util.*;

public class Monkey {
	public static void main(String[] args) {
		new Monkey().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int len1 = nextInt();
			int l = nextInt();
			int s = nextInt();
			String keys = nextToken();
			char[] pattern = nextToken().toCharArray();
			double[] p = new double[26];
			for (int i = 0; i < keys.length(); i++) {
				p[keys.charAt(i) - 'A']++;
			}
			for (int i = 0; i < p.length; i++) {
				p[i] /= keys.length();
			}
			int[] a = new int[pattern.length];
			int q = 0;
			for (int i = 1; i < a.length; i++) {
				while (q > 0 && pattern[i] != pattern[q]) {
					q = a[q - 1];
				}
				if (pattern[i] == pattern[q]) {
					q++;
				}
				a[i] = q;
			}

			int max = 0;
			q = 0;
			for (int i = 0; i < s; i++) {
				q++;
				if (q == pattern.length) {
					max++;
					q = a[q - 1];
				}
			}
			
			for (int i = 0; i < pattern.length; i++) {
				if (p[pattern[i] - 'A'] <= 1e-8) {
					max = 0;
				}
			}
			
			System.out.println(Arrays.toString(a));

			double[][][] b = new double[s + 1][pattern.length + 1][max + 1];
			b[0][0][0] = 1.0;
			for (int i = 0; i + 1 < b.length && max > 0; i++) {
				for (int j = 0; j < b[i].length; j++) {
					for (int k = 0; k < b[i][j].length; k++) {
						if (b[i][j][k] <= 0) {
							continue;
						}

						for (int next = 0; next < p.length; next++) {
							q = j;
							if (q == pattern.length) {
								q = a[pattern.length - 1];
							}
							while (q > 0 && next != pattern[q] - 'A') {
								q = a[q - 1];
							}
							if (next == pattern[q] - 'A') {
								q++;
							}
							int hits = q == pattern.length ? k + 1 : k;
							b[i + 1][q][hits] += b[i][j][k] * p[next];
						}

					}
				}
			}
			double expect = 0;
			for (int i = 0; i < b[s].length; i++) {
				for (int hits = 0; hits < b[s][i].length; hits++) {
					expect += b[s][i][hits] * hits;
				}
			}
			out.println(max - expect);
			System.out.println(expect + " " + max);
		}
	}
}
