import java.io.*;
import java.util.*;

public class UpDown {
	public static void main(String[] args) {
		new UpDown().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int[] a = new int[n];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextInt();
			}
			Item[] it = new Item[n];
			for (int i = 0; i < it.length; i++) {
				it[i] = new Item(a[i], i);
			}
			Arrays.sort(it);
			int[][] b = new int[n + 1][n + 1];
			for (int i = 0; i < b.length; i++) {
				Arrays.fill(b[i], Integer.MAX_VALUE / 2);
			}
			int ans = Integer.MAX_VALUE / 2;
			b[0][0] = 0;
			for (int i = 0; i < b.length; i++) {
				for (int j = 0; j < b[i].length; j++) {
					if (b[i][j] >= Integer.MAX_VALUE / 2) {
						continue;
					}
					int k = i + j;
					if (k == n) {
						ans = Math.min(ans, b[i][j]);
					}
					if (k >= n) {
						continue;
					}
					if (b[i + 1][j] > b[i][j] + Math.abs(i - it[k].n)) {
						b[i + 1][j] = b[i][j] + Math.abs(i - it[k].n);
					}
					if (b[i][j + 1] > b[i][j] + Math.abs(n - j - 1 - it[k].n)) {
						b[i][j + 1] = b[i][j] + Math.abs(n - j - 1 - it[k].n);
					}
				}
			}
			if (ans % 2 != 0) {
				System.err.println("oops");
			}
			ans /= 2;
			int ans2 = doAll(a);
			if (ans != ans2) {
				System.err.println(ans + " " + ans2);
				System.err.println(Arrays.toString(a));
				System.err.println(Arrays.toString(last));
			}
			out.println(ans2);
		}
	}

	class Item implements Comparable<Item> {
		int v, n;

		public Item(int i, int i2) {
			v = i;
			n = i2;
		}

		@Override
		public int compareTo(Item o) {
			return v - o.v;
		}
	}

	int[] last;

	private int doAll(int[] a) {
		Perm s = new Perm(a);
		hm = new HashMap<>();
		hm.put(s, 0);
		ArrayDeque<Perm> q = new ArrayDeque<>();
		q.add(s);
		while (!q.isEmpty()) {
			Perm p = q.pollFirst();
			int d = hm.get(p);
			if (p.good()) {
				last = p.a;
				return d;
			}
			for (int i = 0; i + 1 < a.length; i++) {
				int[] b = p.a.clone();
				int tmp = b[i];
				b[i] = b[i + 1];
				b[i + 1] = tmp;
				Perm p2 = new Perm(b);
				if (!hm.containsKey(p2)) {
					hm.put(p2, d + 1);
					q.addLast(p2);
				}
			}
		}
		return Integer.MAX_VALUE;
	}

	HashMap<Perm, Integer> hm;

	class Perm {
		int[] a;

		public Perm(int[] a2) {
			a = a2.clone();
		}

		public boolean good() {
			int i = 0;
			while (i + 1 < a.length && a[i] < a[i + 1]) {
				i++;
			}
			while (i + 1 < a.length && a[i] > a[i + 1]) {
				i++;
			}
			return i + 1 == a.length;
		}

		@Override
		public int hashCode() {
			return Arrays.hashCode(a);
		}

		@Override
		public boolean equals(Object o) {
			return (o instanceof Perm) && Arrays.equals(a, ((Perm) o).a);
		}
	}

	int[] b = new int[1000];

	private int sort(int[] a, int l, int r) {
		if (l + 1 == r || l == r) {
			return 0;
		}
		int k = (l + r) / 2;
		int ans = 0;
		ans += sort(a, l, k);
		ans += sort(a, k, r);
		int j1 = l;
		int j2 = k;
		for (int i = l; i < r; i++) {
			if (j2 >= r || (j1 < k && a[j1] < a[j2])) {
				b[i] = a[j1++];
			} else {
				b[i] = a[j2++];
				ans += (k - j1);
			}
		}
		for (int i = l; i < r; i++) {
			a[i] = b[i];
		}
		return ans;
	}
}
