import java.io.*;
import java.util.*;
import java.math.*;

import sun.security.util.BigInt;

public class C implements Runnable {

	public static void main(String[] args) {
		new Thread(new C()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "c";

	double eps = 1e-7;

	private void solve() throws IOException {
		int testN = nextInt();
		for (int test = 0; test < testN; test++) {
			out.print("Case #" + (test + 1) + ": ");
			double f = nextDouble();
			double R = nextDouble();
			double t = nextDouble();
			double r = nextDouble();
			double g = nextDouble();
			t += f;
			r += f;
			g -= 2 * f;
			int n = (int) Math.floor((R - t) / (2 * r + g));
			while ((n + 1) * (2 * r + g) < R - t + eps) {
				n++;
			}
			n += 1;
			double miss = 0;
			for (int i = -n; i <= n; i++) {
				for (int j = -n; j <= n; j++) {
					Square s = new Square(i * (2 * r + g) + r, j * (2 * r + g)
							+ r, g);
					miss += s.inside(R - t);
				}
			}
			out.println((1 - (miss / (Math.PI * R * R))));
		}
	}

	class Square {
		public Square(double d, double e, double g) {
			x = d;
			y = e;
			a = g;
		}

		public double inside(double r) {
			Point[] corners = new Point[4];
			corners[0] = new Point(x, y);
			corners[1] = new Point(x + a, y);
			corners[2] = new Point(x + a, y + a);
			corners[3] = new Point(x, y + a);
			boolean[] inside = new boolean[4];
			int k = 0;
			for (int i = 0; i < inside.length; i++) {
				inside[i] = corners[i].dsqr() < r * r;
				if (inside[i]) {
					k++;
				}
			}
			if (k == 0) {
				return 0;
			}
			if (k > 3) {
				return a * a;
			}
			ArrayList<Point> inter = new ArrayList<Point>();
			for (int i = 0; i < inside.length; i++) {
				if (inside[i] ^ inside[(i + 1) % inside.length]) {
					inter.add(new Segment(corners[i], corners[(i + 1)
							% inside.length]).intersect(r));
				}
			}
			double al1 = Math.atan2(inter.get(0).x, inter.get(0).y);
			double al2 = Math.atan2(inter.get(inter.size() - 1).x, inter
					.get(inter.size() - 1).y);
			double dal = Math.min((al1 - al2 + 4 * Math.PI) % (2 * Math.PI),
					(al2 - al1 + 4 * Math.PI) % (2 * Math.PI));
			double s1 = dal * r * r / 2;
			ArrayList<Point> pol = new ArrayList<Point>();
			pol.add(new Point(0, 0));
			pol.add(inter.get(0));
			// pol.add(inter.get(inter.size() - 1));
			// for (int i = 0; i < inside.length; i++) {
			// if (!inside[i]) {
			// pol.add(corners[i]);
			// }
			// }
			// double xc = x + a / 2;
			// double yc = y + a / 2;
			// for (Point p : pol) {
			// p.al = Math.atan2(p.x - xc, p.y - yc);
			// }
			// Collections.sort(pol, new Comparator<Point>() {
			//
			// public int compare(Point p1, Point p2) {
			// return (int) Math.signum(p1.al - p2.al);
			// }
			//
			// });
			int dir = 0;
			int st = 0;
			for (int i = 0; i < inside.length; i++) {
				if (inside[i] ^ inside[(i + 1) % inside.length]) {
					if (new Segment(corners[i],
							corners[(i + 1) % inside.length]).contains(pol
							.get(1))) {
						if (inside[i]) {
							st = (i + 1) % inside.length;
							dir = 1;
						} else {
							st = i;
							dir = inside.length - 1;
						}
					}
				}
			}
			while (!inside[st]) {
				pol.add(corners[st]);
				st = (st + dir) % inside.length;
			}
			pol.add(inter.get(inter.size() - 1));
			double s2 = 0;
			for (int i = 0; i < pol.size(); i++) {
				Point p0 = pol.get(i);
				Point p1 = pol.get((i + 1) % pol.size());
				s2 += p0.x * p1.y - p0.y * p1.x;
			}
			s2 = Math.abs(s2) / 2;
			return a * a - (s2 - s1);
		}

		double x, y, a;
	}

	class Point {
		public Point(double x2, double y2) {
			x = x2;
			y = y2;
		}

		@Override
		public String toString() {
			return x + " " + y;
		}

		public double dsqr() {
			return x * x + y * y;
		}

		double x, y, al;
	}

	class Segment {
		double x1, y1, x2, y2;

		public Segment(Point point, Point point2) {
			x1 = point.x;
			y1 = point.y;
			x2 = point2.x;
			y2 = point2.y;
		}

		public boolean contains(Point p) {
			double a = y2 - y1;
			double b = x1 - x2;
			double c = -a * x1 - b * y1;
			if (Math.abs(a * p.x + b * p.y + c) < eps) {
				if (Math.min(x1, x2) - eps < p.x
						&& p.x < Math.max(x1, x2) + eps) {
					if (Math.min(y1, y2) - eps < p.y
							&& p.y < Math.max(y1, y2) + eps) {
						return true;
					}
				}
			}
			return false;
		}

		public Point intersect(double r) {
			double x = 0;
			double y = 0;
			if (Math.abs(x1 - x2) < eps) {
				x = x1;
				y = Math.sqrt(r * r - x * x);
				if (Math.min(y1, y2) > y || y > Math.max(y1, y2)) {
					y = -y;
				}
			} else {
				y = y1;
				x = Math.sqrt(r * r - y * y);
				if (Math.min(x1, x2) > x || x > Math.max(x1, x2)) {
					x = -x;
				}
			}
			return new Point(x, y);
		}
	}

}
