import java.io.*;
import java.util.*;
import java.math.*;

public class AHard {
	public static void main(String[] args) throws Throwable {
		new AHard().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		ArrayList<Long> primes = new ArrayList<Long>();
		{
			boolean[] q = new boolean[10001];
			for (int i = 2; i < q.length; i++) {
				if (!q[i]) {
					int j = 2 * i;
					while (j < q.length) {
						q[j] = true;
						j += i;
					}
					primes.add(i + 0L);
				}
			}
		}
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			System.out.println(test);
			out.print("Case #" + test + ": ");
			int d = nextInt();
			int n = 1;
			while (d-- > 0) {
				n *= 10;
			}
			int m = nextInt();
			long[] s = new long[m];
			for (int i = 0; i < s.length; i++) {
				s[i] = nextInt();
			}
			if (m < 2) {
				out.println("I don't know.");
				continue;
			}
			TreeSet<Long> next = new TreeSet<Long>();
			if (m == 2) {
				for (long p : primes) {
					if (p < n && s[0] < p && next.size() < 2) {
						for (int a = 0; a < p && next.size() < 2; a++) {
							boolean good = true;
							long b = ((s[1] - s[0] * a) % p + p) % p;
							long apow = 1;
							long bb = 0;
							for (int i = 1; i < s.length; i++) {
								bb = (a * bb + b) % p;
								apow = (apow * a) % p;
								if ((apow * s[0] + bb) % p != s[i]) {
									good = false;
									break;
								}
							}
							if (good) {
								bb = (a * bb + b) % p;
								apow = (apow * a) % p;
								next.add((apow * s[0] + bb) % p);
							}
						}
					}
				}
			} else {
				loop: for (long p : primes) {
					for (int i = 0; i < s.length; i++) {
						if (s[i] >= p || p >= n) {
							continue loop;
						}
					}
					long[][] a = new long[m][3];
					long[] b = new long[m];
					for (int i = 0; i < m - 1; i++) {
						a[i][0] = s[i];
						a[i][1] = 1;
						b[i] = s[i + 1];
					}
					a[m - 1][0] = s[m - 1];
					a[m - 1][1] = 1;
					a[m - 1][2] = p - 1;
					for (int i = 0; i < 3; i++) {
						int j = i;
						if (a[j][i] == 0) {
							int k = j;
							while (k < a.length && a[k][i] == 0) {
								k++;
							}
							if (k >= a.length) {
								break;
							}
							for (int q = 0; q < a[k].length; q++) {
								long tmp = a[k][q];
								a[k][q] = a[j][q];
								a[j][q] = tmp;
							}
							long tmp = b[k];
							b[k] = b[j];
							b[j] = tmp;
						}
						long x = modInv(a[j][i], p);
						for (int k = 0; k < a.length; k++) {
							if (k != j) {
								long w = (x * a[k][i]) % p;
								for (int q = 0; q < a[k].length; q++) {
									a[k][q] = ((a[k][q] - w * a[j][q]) % p + p)
											% p;
								}
								b[k] = ((b[k] - w * b[j]) % p + p) % p;
							}
						}
					}
					n += 0;
					for (int i = 3; i < a.length; i++) {
						if (b[i] != 0) {
							continue loop;
						}
						for (int j = 0; j < a[i].length; j++) {
							if (a[i][j] != 0) {
								continue loop;
							}
						}
					}
					if (a[2][2] != 0) {
						long x = modInv(a[2][2], p);
						next.add((x * b[2]) % p);
					}
				}
			}
			loop: for (long p : primes) {
				for (int i = 0; i < s.length; i++) {
					if (s[i] >= p || p >= n) {
						continue loop;
					}
				}
				boolean good = true;
				long a = 0;
				long b = s[1];
				for (int i = 1; i < s.length; i++) {
					if (s[i] != (a * s[i - 1] + b) % p) {
						good = false;
						break;
					}
				}
				if (good) {
					next.add((a * s[m - 1] + b) % p);
				}
				good = true;
				a = 1;
				b = ((s[1] - s[0]) % p + p) % p;
				for (int i = 1; i < s.length; i++) {
					if (s[i] != (a * s[i - 1] + b) % p) {
						good = false;
						break;
					}
				}
				if (good) {
					next.add((a * s[m - 1] + b) % p);
				}
			}
			if (next.size() != 1) {
				out.println("I don't know.");
			} else {
				out.println(next.first());
			}
		}
	}

	private long modInv(long l, long p) {
		return BigInteger.valueOf(l).modInverse(BigInteger.valueOf(p))
				.longValue();
	}
}