import java.io.*;
import java.util.*;

public class Shrooms {
	public static void main(String[] args) {
		new Shrooms().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int[] a = new int[nextInt()];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextInt();
			}
			int sum1 = 0;
			int max = 0;
			for (int i = 1; i < a.length; i++) {
				if (a[i - 1] > a[i]) {
					sum1 += (a[i - 1] - a[i]);
					max = Math.max(max, a[i - 1] - a[i]);
				}
			}
			int sum2 = 0;
			for (int i = 1; i < a.length; i++) {
				sum2 += Math.min(max, a[i - 1]);
			}
			out.println(sum1 + " " + sum2);
			
		}
	}
}
