import java.io.*;
import java.util.*;
import java.math.*;

public class Elf {
	public static void main(String[] args) {
		new Elf().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), " \n\t\r/");
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	String FNAME = "a";

	long gcd(long a, long b) {
		while (b != 0) {
			long t = a % b;
			a = b;
			b = t;
		}
		return a;
	}

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			long p = nextLong();
			long q = nextLong();
			long gcd = gcd(p, q);
			p /= gcd;
			q /= gcd;
			if ((q & (q - 1)) != 0) {
				out.println("impossible");
				continue;
			}
			while (p > 1) {
				p /= 2;
				q /= 2;
			}
			out.println(Long.numberOfTrailingZeros(q));
		}
	}

}
