import java.io.*;
import java.util.*;
import java.math.*;

public class Lawn {
	public static void main(String[] args) {
		new Lawn().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		loop: for (int test = 0, testn = nextInt(); test < testn; test++) {
			out.print("Case #" + (test + 1) + ": ");
			int n = nextInt();
			int m = nextInt();
			int[][] a = new int[n][m];
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					a[i][j] = nextInt();
				}
			}
			int[] mx = new int[n];
			int[] my = new int[m];
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					mx[i] = Math.max(mx[i], a[i][j]);
					my[j] = Math.max(my[j], a[i][j]);
				}
			}
			boolean good = true;
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < a[i].length; j++) {
					if (a[i][j] < mx[i] && a[i][j] < my[j]) {
						good = false;
					}
				}
			}
			out.println(good ? "YES" : "NO");
		}
	}

}
