import java.io.*;
import java.util.*;
import java.math.*;

public class Candy {
	public static void main(String[] args) {
		new Candy().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(5362134);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "candy";

	private void solve() throws IOException {
		for (int test = 1, tests = nextInt(); test <= tests; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int xor = 0;
			int[] c = new int[n];
			int sum = 0;
			int min = Integer.MAX_VALUE / 2;
			for (int i = 0; i < c.length; i++) {
				c[i] = nextInt();
				xor ^= c[i];
				sum += c[i];
				min = Math.min(min, c[i]);
			}
			if (xor != 0) {
				out.println("NO");
				continue;
			}
			out.println(sum - min);
		}
	}
}
