import java.io.*;
import java.util.*;
import java.math.*;

public class BBig {
	public static void main(String[] args) throws Throwable {
		new BBig().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			BigInteger[] a = new BigInteger[n];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextBigInteger();
			}
			BigInteger x = BigInteger.ZERO;
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < i; j++) {
					if (!a[i].equals(a[j])) {
						x = x.gcd(a[i].subtract(a[j]).abs());
					}
				}
			}
			BigInteger ans = x.subtract(a[0].mod(x));
			BigInteger zero = BigInteger.ZERO;
			BigInteger nz = BigInteger.ZERO;
			for (int i = 0; i < a.length; i++) {
				zero = zero.gcd(a[i]);
				nz = nz.gcd(a[i].add(ans));
			}
			out.println(zero.compareTo(nz) >= 0 ? BigInteger.ZERO : ans);
		}
	}
}