import java.io.*;
import java.util.*;

public class Counting {
	public static void main(String[] args) {
		new Counting().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		int[] a = new int[100000001];
		Queue<Integer> q = new ArrayDeque();
		Arrays.fill(a, Integer.MAX_VALUE / 2);
		a[1] = 1;
		q.add(1);
		while (!q.isEmpty()) {
			int x = q.poll();
			if (x + 1 < a.length && a[x + 1] > a[x] + 1) {
				a[x + 1] = a[x] + 1;
				q.add(x + 1);
			}
			int y = Integer.parseInt(new StringBuilder("" + x).reverse().toString());
			if (y < a.length && a[y] > a[x] + 1) {
				a[y] = a[x] + 1;
				q.add(y);
			}
		}
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			out.println(a[n]);
		}
	}
}
