import java.io.*;
import java.util.*;
import java.math.*;

public class Fair {
	public static void main(String[] args) {
		new Fair().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "c";

	private void solve() throws IOException {
		int[] s = new int[10000001];
		for (int i = 0; i < s.length; i++) {
			String str = "" + i;
			if (!palin(str)) {
				continue;
			}
			long x = 1L * i * i;
			str = "" + x;
			if (!palin(str)) {
				continue;
			}
			s[i] = 1;
		}
		for (int i = 1; i < s.length; i++) {
			s[i] += s[i - 1];
		}
		loop: for (int test = 0, testn = nextInt(); test < testn; test++) {
			out.print("Case #" + (test + 1) + ": ");
			long a = Long.parseLong(nextToken());
			long b = Long.parseLong(nextToken());
			int left = (int) Math.round(Math.ceil(Math.sqrt(a))) - 1;
			int right = (int) Math.round(Math.floor(Math.sqrt(b)));
			out.println(s[right] - s[left]);
		}
	}

	private boolean palin(String s) {
		for (int i = 0, j = s.length() - 1; i < j; i++, j--) {
			if (s.charAt(i) != s.charAt(j)) {
				return false;
			}
		}
		return true;
	}

}
