import java.io.*;
import java.util.*;
import java.math.*;

import sun.security.util.BigInt;

public class D implements Runnable {

	public static void main(String[] args) {
		new Thread(new D()).start();
	}

	BufferedReader br;

	StringTokenizer st;

	PrintWriter out;

	boolean eof = false;

	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	String FNAME = "d";

	private void solve() throws IOException {
		int testN = nextInt();
		for (int test = 0; test < testN; test++) {
			out.print("Case #" + (test + 1) + ": ");
			int w = nextInt();
			int h = nextInt();
			long[][] a = new long[w][h];
			int r = nextInt();
			for (int i = 0; i < r; i++) {
				int x = nextInt() - 1;
				int y = nextInt() - 1;
				a[x][y] = -1;
			}
			a[0][0] = 1;
			for (int i = 1; i < a.length; i++) {
				for (int j = 1; j < a[i].length; j++) {
					if (a[i][j] >= 0) {
						if (i > 1 && a[i - 2][j - 1] >= 0) {
							a[i][j] = (a[i][j] + a[i - 2][j - 1]) % 10007;
						}
						if (j > 1 && a[i - 1][j - 2] >= 0) {
							a[i][j] = (a[i][j] + a[i - 1][j - 2]) % 10007;
						}
					}
				}
			}
			out.println(a[w - 1][h - 1]);
		}
	}

}
