import java.io.*;
import java.util.*;
import java.math.*;

public class TidyNumbers implements Runnable {

	public static void main(String[] args) {
		new Thread(new TidyNumbers()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;

	@Override
	public void run() {
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(255);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLond() {
		return Long.parseLong(nextToken());
	}

	String FNAME = "b";

	private void solve() {
		int tests = nextInt();
		nextTest: for (int test = 1; test <= tests; test++) {
			out.print("Case #" + test + ": ");
			char[] s = nextToken().toCharArray();
			for (int i = 0; i + 1 < s.length; i++) {
				if (s[i] > s[i + 1]) {
					int j = i;
					while (j >= 0 && (s[j] == s[i])) {
						j--;
					}
					if (j < 0 && s[j + 1] == '1') {
						for (int k = 0; k + 1 < s.length; k++) {
							out.print('9');
						}
						out.println();
						continue nextTest;
					} else {
						j++;
						s[j] = (char) (s[j] - 1);
						j++;
						while (j < s.length) {
							s[j++] = '9';
						}
						break;
					}
				}
			}
			for (int k = 0; k < s.length; k++) {
				out.print(s[k]);
			}
			out.println();
		}
	}

}
