import java.io.*;
import java.util.*;

public class A {
	public static void main(String[] args) {
		new A().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}
	
	String FNAME = "a";

	private void solve() throws IOException {
		int tests = nextInt();
		for (int test = 1; test <= tests; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int[] d = new int[n + 1];
			int[] l = new int[n + 1];
			for (int i = 0; i < n; i++) {
				d[i] = nextInt();
				l[i] = nextInt();
			}
			d[n] = nextInt();
			int[] a = new int[n + 1];
			Arrays.fill(a, -1);
			a[0] = d[0];
			for (int i = 0; i + 1 < a.length; i++) {
				for (int j = i + 1; j < a.length && d[j] - d[i] <= a[i]; j++) {
					a[j] = Math.max(a[j], Math.min(l[j], d[j] - d[i]));
				}
			}
			if (a[n] >= 0) {
				out.println("YES");
			} else {
				out.println("NO");
			}
		}
	}
}
