import java.io.*;
import java.util.*;

public class Disks {
	public static void main(String[] args) {
		new Disks().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			int x = nextInt();
			int[] a = new int[n];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextInt();
			}
			Arrays.sort(a);
			boolean[] b = new boolean[n];
			int ans = 0;
			int j = b.length - 1;
			for (int i = 0; i < b.length; i++) {
				if (b[i]) {
					continue;
				}
				while (j > i && (b[j] || a[j] + a[i] > x)) {
					j--;
				}
				if (j > i && a[i] + a[j] <= x) {
					b[j] = true;
				}
				b[i] = true;
				ans++;
			}
			out.println(ans);
		}
	}
}
