import java.io.*;
import java.util.*;
import java.math.*;

public class Airport {

	public static void main(String[] args) {
		new Airport().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(2635243643L);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	String FNAME = "airport";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			double x = nextInt();
			double s = nextInt();
			double r = nextInt();
			double t = nextInt();
			int n = nextInt();
			Segment[] a = new Segment[n + 1];
			double sum = 0;
			for (int i = 0; i + 1 < a.length; i++) {
				a[i] = new Segment(nextInt(), nextInt(), nextInt());
				sum += a[i].l;
			}
			a[n] = new Segment(0, x - sum, 0);
			Arrays.sort(a);
			double ans = 0;
			for (int i = 0; i < a.length; i++) {
				double time = a[i].l / (a[i].v + s);
				if (t > 0) {
					double t2 = a[i].l / (a[i].v + r);
					t2 = Math.min(t2, t);
					time = t2 + (a[i].l - (a[i].v + r) * t2) / (a[i].v + s);
					t -= t2;
				}
				ans += time;
			}
			out.println(ans);
		}
	}

	class Segment implements Comparable<Segment> {
		double l;
		double v;

		public Segment(int beg, double d, int v2) {
			l = d - beg;
			v = v2;
		}

		@Override
		public int compareTo(Segment s) {
			return v < s.v ? -1 : 1;
		}
	}
}
