import java.io.*;
import java.util.*;
import java.math.*;

public class CHard {
	public static void main(String[] args) throws Throwable {
		new CHard().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "c";

	final int P = 100003;

	private void solve() throws IOException {
		int[][] c = new int[501][501];
		for (int i = 0; i < c.length; i++) {
			c[i][0] = 1;
			c[i][i] = 1;
		}
		for (int i = 1; i < c.length; i++) {
			for (int j = 1; j < i; j++) {
				c[i][j] = (c[i - 1][j - 1] + c[i - 1][j]) % P;
			}
		}
		int n = 500;
		int[][] a = new int[n + 1][n + 1];
		for (int i = 0; i < a.length; i++) {
			a[i][1] = 1;
		}
		for (int i = 0; i < a.length; i++) {
			if (i == 4) {
				i += 0;
			}
			for (int j = 2; j < i; j++) {
				for (int l = 1; l <= i - j && l < j; l++) {
					a[i][j] = (a[i][j] + a[j][j - l] * c[i - j - 1][l - 1]) % P;
				}
			}
		}
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			n = nextInt();
			int ans = 0;
			for (int i = 0; i < a[n].length; i++) {
				ans = (ans + a[n][i]) % P;
			}
			out.println(ans);
		}
	}

}