import java.io.*;
import java.util.*;

public class Barber {
	public static void main(String[] args) {
		new Barber().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		int testn = nextInt();
		loop: for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int m = nextInt();
			int n = nextInt();
			long[] a = new long[m];
			for (int i = 0; i < a.length; i++) {
				a[i] = nextLong();
			}
			long l = 0;
			long r = Long.MAX_VALUE / m;
			while (r - l > 1) {
				long t = (l + r) / 2;
				long cnt = 0;
				for (int i = 0; i < a.length; i++) {
					cnt += (t + a[i] - 1) / a[i];
				}
				if (cnt >= n) {
					r = t;
				} else {
					l = t;
				}
			}
			for (int i = 0; i < a.length; i++) {
				n -= (r + a[i] - 2) / a[i];
			}
			for (int i = 0; i < a.length; i++) {
				if ((r - 1) % a[i] == 0) {
					if (n <= 1) {
						out.println(i + 1);
						continue loop;
					}
					n--;
				}
			}
		}
	}
}
