import java.io.*;
import java.util.*;

public class Battle {
	public static void main(String[] args) {
		new Battle().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(12345);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "a";

	private void solve() throws IOException {
		int testn = nextInt();
		for (int test = 1; test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int r = nextInt();
			int c = nextInt();
			int w = nextInt();
			int[] a = new int[c + 1]; // actions to find the ship
			int[] b = new int[c + 1]; // actions to find out there's no ship
			Arrays.fill(a, Integer.MAX_VALUE / 4);
			Arrays.fill(b, Integer.MAX_VALUE / 4);
			for (int i = 0; i < b.length; i++) {
				if (i < w) {
					b[i] = 0;
					continue;
				}
				if (i == w) {
					b[i] = 1;
					a[i] = w;
					continue;
				}
				// guess
				for (int j = 0; j < i; j++) {
					int left = j;
					int right = i - left - 1;
					int ansA = 0;
					// hit
					ansA = w + 1;
					// no hit
					ansA = Math
							.max(ansA,
									Math.min(b[left] + a[right], b[right]
											+ a[left]) + 1);
					a[i] = Math.min(a[i], ansA);

					b[i] = Math.min(b[i], b[left] + b[right] + 1);
				}
			}
			out.println(b[c] * (r - 1) + a[c]);
		}
	}
}
