import java.io.*;
import java.util.*;
import java.math.*;

public class Crazy implements Runnable {

	public static void main(String[] args) {
		new Thread(new Crazy()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	@Override
	public void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "crazy";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int n = nextInt();
			char[][] map = new char[n][];
			for (int i = 0; i < map.length; i++) {
				map[i] = nextToken().toCharArray();
			}
			int[] a = new int[n];
			for (int i = 0; i < a.length; i++) {
				for (int j = 0; j < map[i].length; j++) {
					if (map[i][j] == '1') {
						a[i] = j;
					}
				}
			}
			int ans = 0;
			for (int i = 0; i < a.length; i++) {
				if (a[i] > i) {
					int j = i + 1;
					while (a[j] > i) {
						j++;
					}
					while (j > i) {
						int tmp = a[j];
						a[j] = a[j - 1];
						a[j - 1] = tmp;
						ans++;
						j--;
					}
				}
			}
			out.println(ans);
		}
	}

}
