import java.io.*;
import java.util.*;
import java.math.*;

public class BSmall {
	public static void main(String[] args) throws Throwable {
		new BSmall().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(this.hashCode());

	private void run() throws Throwable {
		Locale.setDefault(Locale.US);
		br = new BufferedReader(new FileReader(FNAME + ".in"));
		out = new PrintWriter(FNAME + ".out");
		solve();
		out.close();
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	long nextLong() {
		return Long.parseLong(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	BigInteger nextBigInteger() {
		return new BigInteger(nextToken());
	}

	String FNAME = "b";

	private void solve() throws IOException {
		for (int test = 1, testn = nextInt(); test <= testn; test++) {
			out.print("Case #" + test + ": ");
			int l = nextInt();
			int r = nextInt();
			int c = nextInt();
			int[][] a = new int[r + 1][r + 1];
			for (int i = 0; i < a.length; i++) {
				Arrays.fill(a[i], Integer.MAX_VALUE / 2);
				for (int j = 0; j < a[i].length; j++) {
					if (c * i >= j) {
						a[i][j] = 0;
					}
				}
			}
			for (int len = 1; len < a.length; len++) {
				for (int i = 0; i + len < a[i].length; i++) {
					int j = i + len;
					int best = 0;
					for (int k = i + 1; k < j; k++) {
						int ff = a[i][j];
						a[i][j] = Math.min(a[i][j],
								Math.max(a[i][k], a[k][j]) + 1);
						if (a[i][j] < ff) {
							best = k;
						}
					}
					if (i == 4 && j == 16) {
						System.out.println(best);
					}
				}
			}
			out.println(a[l][r]);
			if (test > 10) {
				return;
			}
		}
	}

}