package ru.bobukh.problems;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 *
 * @author anton.bobukh
 */
public class ProblemA_SpeakingInTongues {
    
    public static void main(String[] args) throws IOException {
        Map<Character, Character> mapping = ProblemA_SpeakingInTongues.GetMapping();
        
        try (Scanner input = new Scanner(new BufferedReader(new FileReader("C:\\Users\\maggot\\Desktop\\A-small-attempt0.in")))) {
            int numberOfCases = input.nextInt();
            input.nextLine();
            
            try(PrintWriter output = new PrintWriter("C:\\Users\\maggot\\Desktop\\output.txt")) {
                for (int i = 0; i < numberOfCases; ++i) {
                    output.println(String.format("Case #%d: %s", i + 1, ProblemA_SpeakingInTongues.convert(mapping, input.nextLine())));
                }
            }
        }
    }
    
    public static String convert(final Map<Character, Character> mapping, final String line) {
        StringBuilder result = new StringBuilder();
        
        for(int i = 0; i < line.length(); ++i)
            result.append(mapping.get(line.charAt(i)));
        
        return result.toString();
    }
    
    public static Map<Character, Character> GetMapping() {
        Map<Character, Character> result = new HashMap<>();
        
        String googlereseInput = 
            "ejp mysljylc kd kxveddknmc re jsicpdrysi " +
            "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd " +
            "de kr kd eoya kw aej tysr re ujdr lkgc jv";
        
        String englishOutput = 
            "our language is impossible to understand " +
            "there are twenty six factorial possibilities " +
            "so it is okay if you want to just give up";
        
        for(int i = 0; i < googlereseInput.length(); ++i) {
            if(result.containsKey(googlereseInput.charAt(i))) {
                if(result.get(googlereseInput.charAt(i)) != englishOutput.charAt(i))
                    throw new RuntimeException();
                continue;
            }
            
            result.put(googlereseInput.charAt(i), englishOutput.charAt(i));
        }
        
        result.put(' ', ' ');
        result.put('q', 'z');
        result.put('z', 'q');
        
        return result;
    }
    
}
