import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.function.Supplier;
import java.util.stream.DoubleStream;
import java.util.stream.IntStream;
import java.util.stream.LongStream;
import java.util.stream.Stream;

public class BFFs {
    static void run() {
        int n = rdInt();
        int[] vs = rdInts(n);
        int res = solve(n, vs);
        wrVal(res);
    }

    private static int solve(int n, int[] vs) {
        int[][] dist = new int[n][n];
        int maxloop = 0;
        for (int i = 0; i < n; ++i) {
            boolean[] bs = new boolean[n];
            int d = 0;
            int j = i;
            for (;;) {
                if (bs[j]) {
                    if (j == i) maxloop = Math.max(maxloop, d);
                    break;
                }
                bs[j] = true;
                dist[i][j] = d;
                j = vs[j] - 1;
                ++d;
            }
        }

        int sum = 0;
        for (int i = 0; i < n; ++i) {
            for (int j = i + 1; j < n; ++j) {
                if (vs[i] == j + 1 && vs[j] == i + 1) {
                    int maxa = 0;
                    int maxb = 0;
                    for (int t = 0; t < n; ++t) {
                        if (t != i && t != j && dist[t][i] != 0) {
                            assert dist[t][j] != 0;
                            if (dist[t][i] < dist[t][j]) {
                                maxa = Math.max(maxa, dist[t][i]);
                            } else {
                                maxb = Math.max(maxb, dist[t][j]);
                            }
                        }
                    }
                    int s = 2 + maxa + maxb;
                    sum += s;
                }
            }
        }

        int res = Math.max(maxloop, sum);
        return res;
    }

    public static void main(String[] args) {
        int n = rdInt();
        for (int i = 0; i < n; ++i) {
            output.print("Case #" + (i + 1) + ":");
            outputSep = " ";
            run();
            output.print("\n");
        }
        output.flush();
    }

    static Scanner input = new Scanner(System.in);
    static int rdInt() { return rdT(() -> input.nextInt()); }
    static long rdLong() { return rdT(() -> input.nextLong()); }
    static double rdDbl() { return rdT(() -> input.nextDouble()); }
    static BigInteger rdBigInt() { return rdT(() -> input.nextBigInteger()); }
    static String rdStr() { return rdT(() -> input.next()); }
    static String rdLine() { return input.nextLine(); }
    static String[] rdStrs(int n) { return Stream.generate(() -> rdStr()).limit(n).toArray(x -> new String[x]); }
    static int[] rdInts(int n) { return IntStream.generate(() -> rdInt()).limit(n).toArray(); }
    static long[] rdLongs(int n) { return LongStream.generate(() -> rdLong()).limit(n).toArray(); }
    static double[] rdDbls(int n) { return DoubleStream.generate(() -> rdDbl()).limit(n).toArray(); }
    private static <T> T rdT(Supplier<T> supplier) { T t = supplier.get(); input.skip(" |\n|\r\n"); return t; }

    static PrintStream output = new PrintStream(System.out, true);
    static String outputSep = " ";
    static void wrVal(String v) { wrT(v); }
    static void wrVal(int v) { wrT(v); }
    static void wrVal(long v) { wrT(v); }
    static void wrVal(BigInteger v) { wrT(v); }
    static void wrVal(double v) { wrVal(v, 10); }
    static void wrVal(double v, int fracdigs) { wrT(String.format("%." + fracdigs + "f", v)); }
    static void wrVals(int[] vs) { for (int v : vs) wrVal(v); }
    static void wrVals(long[] vs) { for (long v : vs) wrVal(v); }
    static void wrVals(double[] vs) { for (double v : vs) wrVal(v); }
    static void wrVals(double[] vs, int fracdigs) { for (double v : vs) wrVal(v, fracdigs); }
    static void wrVals(String[] vs) { for (String v : vs) wrVal(v); }
    static void wrLn() { output.print("\n"); outputSep = ""; }
    private static void wrT(Object v) { output.print(outputSep); output.print(v); outputSep = " "; }
}
