import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.function.Supplier;
import java.util.stream.DoubleStream;
import java.util.stream.IntStream;
import java.util.stream.LongStream;
import java.util.stream.Stream;
import java.util.Arrays;


public class RankAndFile {
    static void run() {
        int n = rdInt();
        int[][] lines = new int[2*n - 1][];
        for (int i = 0; i < lines.length; ++i) lines[i] = rdInts(n);
        int[] res = solve(n, lines.clone());
        wrVals(res);
    }

    private static int[] solve(int n, int[][] lines) {
        int[][] table = new int[n][n];
        Arrays.sort(lines, (x, y) -> Integer.compare(x[0], y[0]));
        for (int x = 0, range = 1 << lines.length; x < range; ++x) {
            int rows = Integer.bitCount(x);
            int columns = lines.length - rows;
            if ((rows == n && columns == n - 1) || (rows == n - 1 && columns == n)) {
                boolean misr = rows < n;

                for (int mis = 0; mis < n; ++mis) {
                    for (int[] t : table) Arrays.fill(t, 0);

                    int row = misr && mis == 0 ? 1 : 0;
                    int col = !misr && mis == 0 ? 1 : 0;

                    boolean valid = true;
                    for (int i = 0; i < lines.length; ++i) {
                        if (((x >>> i) & 1) != 0) {
                            for (int j = 0; j < n; ++j) {
                                if (table[row][j] != 0 && table[row][j] != lines[i][j]) {
                                    valid = false;
                                    break;
                                }
                                table[row][j] = lines[i][j];
                            }
                            ++row;
                            if (misr && row == mis) ++row;
                        } else {
                            for (int j = 0; j < n; ++j) {
                                if (table[j][col] != 0 && table[j][col] != lines[i][j]) {
                                    valid = false;
                                    break;
                                }
                                table[j][col] = lines[i][j];
                            }
                            ++col;
                            if (!misr && col == mis) ++col;
                        }
                    }

                    if (valid) {
                        L: for (int i = 0; i < n; ++i) {
                            for (int j = 0; j < n - 1; ++j) {
                                valid &= table[i][j] < table[i][j + 1];
                                valid &= table[j][i] < table[j + 1][i];
                                if (!valid) break L;
                            }
                        }
                        if (valid) {
                            if (columns == rows + 1) {
                                return table[mis];
                            } else {
                                int[] res = new int[n];
                                for (int i = 0; i < n; ++i) res[i] = table[i][mis];
                                return res;
                            }
                        }
                    }
                }
            }
        }
        throw new IllegalStateException();
    }

    public static void main(String[] args) {
        int n = rdInt();
        for (int i = 0; i < n; ++i) {
            output.print("Case #" + (i + 1) + ":");
            outputSep = " ";
            run();
            output.print("\n");
        }
        output.flush();
    }

    static Scanner input = new Scanner(System.in);
    static int rdInt() { return rdT(() -> input.nextInt()); }
    static long rdLong() { return rdT(() -> input.nextLong()); }
    static double rdDbl() { return rdT(() -> input.nextDouble()); }
    static BigInteger rdBigInt() { return rdT(() -> input.nextBigInteger()); }
    static String rdStr() { return rdT(() -> input.next()); }
    static String rdLine() { return input.nextLine(); }
    static String[] rdStrs(int n) { return Stream.generate(() -> rdStr()).limit(n).toArray(x -> new String[x]); }
    static int[] rdInts(int n) { return IntStream.generate(() -> rdInt()).limit(n).toArray(); }
    static long[] rdLongs(int n) { return LongStream.generate(() -> rdLong()).limit(n).toArray(); }
    static double[] rdDbls(int n) { return DoubleStream.generate(() -> rdDbl()).limit(n).toArray(); }
    private static <T> T rdT(Supplier<T> supplier) { T t = supplier.get(); input.skip(" |\n|\r\n"); return t; }

    static PrintStream output = new PrintStream(System.out, true);
    static String outputSep = " ";
    static void wrVal(String v) { wrT(v); }
    static void wrVal(int v) { wrT(v); }
    static void wrVal(long v) { wrT(v); }
    static void wrVal(BigInteger v) { wrT(v); }
    static void wrVal(double v) { wrVal(v, 10); }
    static void wrVal(double v, int fracdigs) { wrT(String.format("%." + fracdigs + "f", v)); }
    static void wrVals(int[] vs) { for (int v : vs) wrVal(v); }
    static void wrVals(long[] vs) { for (long v : vs) wrVal(v); }
    static void wrVals(double[] vs) { for (double v : vs) wrVal(v); }
    static void wrVals(double[] vs, int fracdigs) { for (double v : vs) wrVal(v, fracdigs); }
    static void wrVals(String[] vs) { for (String v : vs) wrVal(v); }
    static void wrLn() { output.print("\n"); outputSep = ""; }
    private static void wrT(Object v) { output.print(outputSep); output.print(v); outputSep = " "; }
}
