import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.function.Supplier;
import java.util.stream.DoubleStream;
import java.util.stream.IntStream;
import java.util.stream.LongStream;
import java.util.stream.Stream;

public class CloseMatch {
    static void run() {
        String s1 = rdStr();
        String s2 = rdStr();
        String[] res = solve(s1, s2);
        wrVals(res);
    }

    private static String[] solve(String s1, String s2) {
        long[] res = { -1, -1 };
        recurse(s1, s2, 0, 0, 0, res);
        String r1 = String.format("%0" + s1.length() + "d", res[0]);
        String r2 = String.format("%0" + s1.length() + "d", res[1]);
        return new String[]{r1, r2};
    }

    private static void recurse(String s1, String s2, int pos, long p1, long p2, long[] res) {
        if (pos == s1.length()) {
            if (res[0] == -1) {
                res[0] = p1;
                res[1] = p2;
            } else {
                long rd = Math.abs(res[0] - res[1]);
                long pd = Math.abs(p1 - p2);
                if (pd < rd) {
                    res[0] = p1;
                    res[1] = p2;
                } else if (pd == rd) {
                    if (p1 < res[0]) {
                        res[0] = p1;
                        res[1] = p2;
                    } else if (p1 == res[0] && p2 < res[1]) {
                        res[0] = p1;
                        res[1] = p2;
                    }
                }
            }
            return;
        }

        char c1 = s1.charAt(pos);
        char c2 = s2.charAt(pos);

        if (c1 != '?' && c2 != '?') {
            int d1 = c1 - '0';
            int d2 = c2 - '0';
            recurse(s1, s2, pos + 1, p1 * 10 + d1, p2 * 10 + d2, res);
        } else if (c1 != '?') {
            int d1 = c1 - '0';
            if (p1 == p2) {
                recurse(s1, s2, pos + 1, p1 * 10 + d1, p2 * 10 + d1, res);
                recurse(s1, s2, pos + 1, p1 * 10 + d1, p2 * 10 + (d1 + 1) % 10, res);
                recurse(s1, s2, pos + 1, p1 * 10 + d1, p2 * 10 + (d1 + 9) % 10, res);
            } else if (p1 < p2) {
                recurse(s1, s2, pos + 1, p1 * 10 + d1, p2 * 10 + 0, res);
            } else {
                recurse(s1, s2, pos + 1, p1 * 10 + d1, p2 * 10 + 9, res);
            }
        } else if (c2 != '?') {
            int d2 = c2 - '0';
            if (p1 == p2) {
                recurse(s1, s2, pos + 1, p1 * 10 + d2, p2 * 10 + d2, res);
                recurse(s1, s2, pos + 1, p1 * 10 + (d2 + 1) % 10, p2 * 10 + d2, res);
                recurse(s1, s2, pos + 1, p1 * 10 + (d2 + 9) % 10, p2 * 10 + d2, res);
            } else if (p1 < p2) {
                recurse(s1, s2, pos + 1, p1 * 10 + 9, p2 * 10 + d2, res);
            } else {
                recurse(s1, s2, pos + 1, p1 * 10 + 0, p2 * 10 + d2, res);
            }
        } else {
            if (p1 == p2) {
                recurse(s1, s2, pos + 1, p1 * 10 + 0, p2 * 10 + 0, res);
                recurse(s1, s2, pos + 1, p1 * 10 + 0, p2 * 10 + 1, res);
                recurse(s1, s2, pos + 1, p1 * 10 + 1, p2 * 10 + 0, res);
            } else if (p1 < p2) {
                recurse(s1, s2, pos + 1, p1 * 10 + 9, p2 * 10 + 0, res);
            } else {
                recurse(s1, s2, pos + 1, p1 * 10 + 0, p2 * 10 + 9, res);
            }
        }
    }

    public static void main(String[] args) {
        int n = rdInt();
        for (int i = 0; i < n; ++i) {
            output.print("Case #" + (i + 1) + ":");
            outputSep = " ";
            run();
            output.print("\n");
        }
        output.flush();
    }

    static Scanner input = new Scanner(System.in);
    static int rdInt() { return rdT(() -> input.nextInt()); }
    static long rdLong() { return rdT(() -> input.nextLong()); }
    static double rdDbl() { return rdT(() -> input.nextDouble()); }
    static BigInteger rdBigInt() { return rdT(() -> input.nextBigInteger()); }
    static String rdStr() { return rdT(() -> input.next()); }
    static String rdLine() { return input.nextLine(); }
    static String[] rdStrs(int n) { return Stream.generate(() -> rdStr()).limit(n).toArray(x -> new String[x]); }
    static int[] rdInts(int n) { return IntStream.generate(() -> rdInt()).limit(n).toArray(); }
    static int[][] rdInts(int n, int m) { return Stream.generate(() -> rdInts(m)).limit(n).toArray(v -> new int[v][]); }
    static long[] rdLongs(int n) { return LongStream.generate(() -> rdLong()).limit(n).toArray(); }
    static double[] rdDbls(int n) { return DoubleStream.generate(() -> rdDbl()).limit(n).toArray(); }
    private static <T> T rdT(Supplier<T> supplier) { T t = supplier.get(); input.skip(" |\n|\r\n"); return t; }

    static PrintStream output = new PrintStream(System.out, true);
    static String outputSep = " ";
    static void wrVal(String v) { wrT(v); }
    static void wrVal(int v) { wrT(v); }
    static void wrVal(long v) { wrT(v); }
    static void wrVal(BigInteger v) { wrT(v); }
    static void wrVal(double v) { wrVal(v, 10); }
    static void wrVal(double v, int fracdigs) { wrT(String.format("%." + fracdigs + "f", v)); }
    static void wrVals(int[] vs) { for (int v : vs) wrVal(v); }
    static void wrVals(long[] vs) { for (long v : vs) wrVal(v); }
    static void wrVals(double[] vs) { for (double v : vs) wrVal(v); }
    static void wrVals(double[] vs, int fracdigs) { for (double v : vs) wrVal(v, fracdigs); }
    static void wrVals(String[] vs) { for (String v : vs) wrVal(v); }
    static void wrLn() { output.print("\n"); outputSep = ""; }
    private static void wrT(Object v) { output.print(outputSep); output.print(v); outputSep = " "; }

    static void verifyOK() {}
    static RuntimeException error() { throw new RuntimeException(); }
    static RuntimeException error(String s) { throw new RuntimeException(s); }
}
