import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.function.Supplier;
import java.util.stream.DoubleStream;
import java.util.stream.IntStream;
import java.util.stream.LongStream;
import java.util.stream.Stream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;


public class GettingTheDigits {
    private static final String[] STRINGS = { "ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE" };

    static void run() {
        String s = rdStr();
        String res = solve(s);
        wrVal(res);
    }

    private static String solve(String str) {
        Map<String, Integer> map = new HashMap<>();
        for (int i = 0; i < STRINGS.length; ++i) map.put(STRINGS[i], i);

        int[] counts = new int[128];
        for (char c : str.toCharArray()) counts[c]++;

        List<Integer> digs = new ArrayList<>();

        Set<String> set = new HashSet<>(Arrays.asList(STRINGS));
        while (!set.isEmpty()) {
            Set<Character> set2 = new HashSet<>();
            for (String s : set) for (char c : s.toCharArray()) set2.add(c);
            for (char c : set2) {
                List<String> ss = new ArrayList<>();
                for (String s : set) {
                    if (s.contains("" + c)) ss.add(s);
                }
                if (ss.size() == 1) {
                    String p = ss.get(0);
                    set.remove(p);
                    int dig = map.get(p);
                    while (counts[c] > 0) {
                        for (char c2 : p.toCharArray()) {
                            assert counts[c2] > 0;
                            --counts[c2];
                        }
                        digs.add(dig);
                    }
                    break;
                }
            }
        }

        Collections.sort(digs);
        String res = "";
        for (int dig : digs) res += dig;

        return res;
    }

    public static void main(String[] args) {
        int n = rdInt();
        for (int i = 0; i < n; ++i) {
            output.print("Case #" + (i + 1) + ":");
            outputSep = " ";
            run();
            output.print("\n");
        }
        output.flush();
    }

    static Scanner input = new Scanner(System.in);
    static int rdInt() { return rdT(() -> input.nextInt()); }
    static long rdLong() { return rdT(() -> input.nextLong()); }
    static double rdDbl() { return rdT(() -> input.nextDouble()); }
    static BigInteger rdBigInt() { return rdT(() -> input.nextBigInteger()); }
    static String rdStr() { return rdT(() -> input.next()); }
    static String rdLine() { return input.nextLine(); }
    static String[] rdStrs(int n) { return Stream.generate(() -> rdStr()).limit(n).toArray(x -> new String[x]); }
    static int[] rdInts(int n) { return IntStream.generate(() -> rdInt()).limit(n).toArray(); }
    static int[][] rdInts(int n, int m) { return Stream.generate(() -> rdInts(m)).limit(n).toArray(v -> new int[v][]); }
    static long[] rdLongs(int n) { return LongStream.generate(() -> rdLong()).limit(n).toArray(); }
    static double[] rdDbls(int n) { return DoubleStream.generate(() -> rdDbl()).limit(n).toArray(); }
    private static <T> T rdT(Supplier<T> supplier) { T t = supplier.get(); input.skip(" |\n|\r\n"); return t; }

    static PrintStream output = new PrintStream(System.out, true);
    static String outputSep = " ";
    static void wrVal(String v) { wrT(v); }
    static void wrVal(int v) { wrT(v); }
    static void wrVal(long v) { wrT(v); }
    static void wrVal(BigInteger v) { wrT(v); }
    static void wrVal(double v) { wrVal(v, 10); }
    static void wrVal(double v, int fracdigs) { wrT(String.format("%." + fracdigs + "f", v)); }
    static void wrVals(int[] vs) { for (int v : vs) wrVal(v); }
    static void wrVals(long[] vs) { for (long v : vs) wrVal(v); }
    static void wrVals(double[] vs) { for (double v : vs) wrVal(v); }
    static void wrVals(double[] vs, int fracdigs) { for (double v : vs) wrVal(v, fracdigs); }
    static void wrVals(String[] vs) { for (String v : vs) wrVal(v); }
    static void wrLn() { output.print("\n"); outputSep = ""; }
    private static void wrT(Object v) { output.print(outputSep); output.print(v); outputSep = " "; }

    static void verifyOK() {}
    static RuntimeException error() { throw new RuntimeException(); }
    static RuntimeException error(String s) { throw new RuntimeException(s); }
}
