import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.function.Supplier;
import java.util.stream.DoubleStream;
import java.util.stream.IntStream;
import java.util.stream.LongStream;
import java.util.stream.Stream;
import java.util.HashSet;
import java.util.Set;


public class Technobabble {
    static void run() {
        int n = rdInt();
        String[][] tops = new String[n][];
        for (int i = 0; i < n; ++i) tops[i] = rdStrs(2);
        int res = solve(n, tops);
        wrVal(res);
    }

    private static int solve(int n, String[][] tops) {
        int res = 0;
        for (int x = 0, end = 1 << n; x < end; ++x) {
            int w = Integer.bitCount(x);
            if (w > res) {
                Set<String> set1 = new HashSet<>();
                Set<String> set2 = new HashSet<>();
                for (int i = 0; i < n; ++i) {
                    if ((x & 1 << i) == 0) {
                        set1.add(tops[i][0]);
                        set2.add(tops[i][1]);
                    }
                }
                boolean fake = true;
                for (int i = 0; i < n; ++i) {
                    if ((x & 1 << i) != 0) {
                        if (!set1.contains(tops[i][0]) || !set2.contains(tops[i][1])) {
                            fake = false;
                            break;
                        }
                    }
                }
                if (fake) {
                    res = w;
                }
            }
        }
        return res;
    }

    public static void main(String[] args) {
        int n = rdInt();
        for (int i = 0; i < n; ++i) {
            output.print("Case #" + (i + 1) + ":");
            outputSep = " ";
            run();
            output.print("\n");
        }
        output.flush();
    }

    static Scanner input = new Scanner(System.in);
    static int rdInt() { return rdT(() -> input.nextInt()); }
    static long rdLong() { return rdT(() -> input.nextLong()); }
    static double rdDbl() { return rdT(() -> input.nextDouble()); }
    static BigInteger rdBigInt() { return rdT(() -> input.nextBigInteger()); }
    static String rdStr() { return rdT(() -> input.next()); }
    static String rdLine() { return input.nextLine(); }
    static String[] rdStrs(int n) { return Stream.generate(() -> rdStr()).limit(n).toArray(x -> new String[x]); }
    static int[] rdInts(int n) { return IntStream.generate(() -> rdInt()).limit(n).toArray(); }
    static int[][] rdInts(int n, int m) { return Stream.generate(() -> rdInts(m)).limit(n).toArray(v -> new int[v][]); }
    static long[] rdLongs(int n) { return LongStream.generate(() -> rdLong()).limit(n).toArray(); }
    static double[] rdDbls(int n) { return DoubleStream.generate(() -> rdDbl()).limit(n).toArray(); }
    private static <T> T rdT(Supplier<T> supplier) { T t = supplier.get(); input.skip(" |\n|\r\n"); return t; }

    static PrintStream output = new PrintStream(System.out, true);
    static String outputSep = " ";
    static void wrVal(String v) { wrT(v); }
    static void wrVal(int v) { wrT(v); }
    static void wrVal(long v) { wrT(v); }
    static void wrVal(BigInteger v) { wrT(v); }
    static void wrVal(double v) { wrVal(v, 10); }
    static void wrVal(double v, int fracdigs) { wrT(String.format("%." + fracdigs + "f", v)); }
    static void wrVals(int[] vs) { for (int v : vs) wrVal(v); }
    static void wrVals(long[] vs) { for (long v : vs) wrVal(v); }
    static void wrVals(double[] vs) { for (double v : vs) wrVal(v); }
    static void wrVals(double[] vs, int fracdigs) { for (double v : vs) wrVal(v, fracdigs); }
    static void wrVals(String[] vs) { for (String v : vs) wrVal(v); }
    static void wrLn() { output.print("\n"); outputSep = ""; }
    private static void wrT(Object v) { output.print(outputSep); output.print(v); outputSep = " "; }

    static void verifyOK() {}
    static RuntimeException error() { throw new RuntimeException(); }
    static RuntimeException error(String s) { throw new RuntimeException(s); }
}
