import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.function.Supplier;
import java.util.stream.DoubleStream;
import java.util.stream.IntStream;
import java.util.stream.LongStream;
import java.util.stream.Stream;

public class BFFs {
    static void run() {
        int n = rdInt();
        int[] vs = rdInts(n);
        int res = solve(n, vs);
        wrVal(res);
    }

    private static int solve(int n, int[] vs) {
        int res = 0;
        for (int x = 1; x < (1 << n); ++x) {
            int[] t = new int[Integer.bitCount(x)];
            int sz = 0;
            for (int i = 0; i < n; ++i) {
                if (((x >>> i) & 1) != 0) t[sz++] = i;
            }
            boolean b = validate(t.length, vs, t, 0);
            if (b) res = Math.max(res, t.length);
        }
        assert res > 0;
        return res;
    }

    private static boolean validate(int n, int[] vs, int[] t, int pos) {
        if (pos == n) {
            for (int i = 0; i < n; ++i) {
                int j = (i + 1) % n;
                int k = (i + n - 1) % n;
                boolean f = vs[t[i]] == t[j] + 1 || vs[t[i]] == t[k] + 1;
                if (!f) return false;
            }
            return true;
        }

        int old = t[pos];
        for (int i = pos; i < n; ++i) {
            t[pos] = t[i];
            t[i] = old;
            boolean b = validate(n, vs, t, pos + 1);
            if (b) return true;
            t[i] = t[pos];
        }
        t[pos] = old;

        return false;
    }

    public static void main(String[] args) {
        int n = rdInt();
        for (int i = 0; i < n; ++i) {
            output.print("Case #" + (i + 1) + ":");
            outputSep = " ";
            run();
            output.print("\n");
        }
        output.flush();
    }

    static Scanner input = new Scanner(System.in);
    static int rdInt() { return rdT(() -> input.nextInt()); }
    static long rdLong() { return rdT(() -> input.nextLong()); }
    static double rdDbl() { return rdT(() -> input.nextDouble()); }
    static BigInteger rdBigInt() { return rdT(() -> input.nextBigInteger()); }
    static String rdStr() { return rdT(() -> input.next()); }
    static String rdLine() { return input.nextLine(); }
    static String[] rdStrs(int n) { return Stream.generate(() -> rdStr()).limit(n).toArray(x -> new String[x]); }
    static int[] rdInts(int n) { return IntStream.generate(() -> rdInt()).limit(n).toArray(); }
    static long[] rdLongs(int n) { return LongStream.generate(() -> rdLong()).limit(n).toArray(); }
    static double[] rdDbls(int n) { return DoubleStream.generate(() -> rdDbl()).limit(n).toArray(); }
    private static <T> T rdT(Supplier<T> supplier) { T t = supplier.get(); input.skip(" |\n|\r\n"); return t; }

    static PrintStream output = new PrintStream(System.out, true);
    static String outputSep = " ";
    static void wrVal(String v) { wrT(v); }
    static void wrVal(int v) { wrT(v); }
    static void wrVal(long v) { wrT(v); }
    static void wrVal(BigInteger v) { wrT(v); }
    static void wrVal(double v) { wrVal(v, 10); }
    static void wrVal(double v, int fracdigs) { wrT(String.format("%." + fracdigs + "f", v)); }
    static void wrVals(int[] vs) { for (int v : vs) wrVal(v); }
    static void wrVals(long[] vs) { for (long v : vs) wrVal(v); }
    static void wrVals(double[] vs) { for (double v : vs) wrVal(v); }
    static void wrVals(double[] vs, int fracdigs) { for (double v : vs) wrVal(v, fracdigs); }
    static void wrVals(String[] vs) { for (String v : vs) wrVal(v); }
    static void wrLn() { output.print("\n"); outputSep = ""; }
    private static void wrT(Object v) { output.print(outputSep); output.print(v); outputSep = " "; }
}
