import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Arrays;
import java.util.Scanner;

public class Pancakes {

	private static final double delta = 0.0000001;

	private static DecimalFormat df = new DecimalFormat("#.######");

	public static void main(String[] args) throws Exception {
		try (Scanner scanner = new Scanner(new FileInputStream("A-small-attempt1.in"));
		     PrintWriter writer = new PrintWriter(new BufferedOutputStream(new FileOutputStream("output.txt")))) {
			int testCases = scanner.nextInt();
			for (int testCase = 0; testCase < testCases; testCase++) {
				solve(testCase + 1, scanner, writer);
			}
		}
	}

	private static void solve(int caseNum, Scanner scanner, PrintWriter writer) {
		int N = scanner.nextInt();
		int K = scanner.nextInt();
		long[] R = new long[N];
		long[] H = new long[N];
		Cake[] cakes = new Cake[N];
		Cake[] cakesByH = new Cake[N];
		for (int i = 0; i < N; i++) {
			R[i] = scanner.nextLong();
			H[i] = scanner.nextLong();
			cakes[i] = new Cake(i, R[i], H[i]);
			cakesByH[i] = new Cake(i, R[i], H[i]);
		}
		if (K == 1) {
			long max = 0;
			for (int i = 0; i < N; i++) {
				max = Math.max(max, R[i] * R[i] + 2 * R[i] * H[i]);
			}
			writer.println(String.format("Case #%s: %s", caseNum, df.format(max * Math.PI)));
			return;
		}

//		Arrays.sort(cakes, (cake1, cake2) -> {
//			if (cake1.getR() == cake2.getR()) {
//				return -Long.compare(cake1.getH(), cake2.getH());
//			} else {
//				return -Long.compare(cake1.getR(), cake2.getR());
//			}
//		});
		Arrays.sort(cakesByH, (cake1, cake2) -> -Long.compare(cake1.getR() * cake1.getH(), cake2.getR() * cake2.getH()));

		long answer = 0;
		for (int start = 0; start < N; start++) {
			Cake startCake = cakes[start];
			long sum = startCake.getR() * startCake.getR() + 2 * startCake.getR() * startCake.getH();
			int cnt = 0;
			for (int i = 0; i < N; i++) {
				if (cakesByH[i].getIndex() != startCake.getIndex() && cakesByH[i].getR() <= startCake.getR()) {
					sum += 2 * cakesByH[i].getR() * cakesByH[i].getH();
					cnt++;
				}

				if (cnt >= K - 1) {
					break;
				}
			}
			if (cnt < K - 1) {
				continue;
			}
			answer = Math.max(answer, sum);
		}

		writer.println(String.format("Case #%s: %s", caseNum, df.format(answer * Math.PI)));
	}

	static class Cake {
		int index;
		long R;
		long H;

		public Cake(int index, long r, long h) {
			this.index = index;
			R = r;
			H = h;
		}

		public long getR() {
			return R;
		}

		public void setR(long r) {
			R = r;
		}

		public long getH() {
			return H;
		}

		public void setH(long h) {
			H = h;
		}

		public int getIndex() {
			return index;
		}
	}

}
