import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.PriorityQueue;
import java.util.Scanner;

public class BathroomStalls {

	public static void main(String[] args) throws Exception {
		try (Scanner scanner = new Scanner(new FileInputStream("C-small-1-attempt0.in"));
		     PrintWriter writer = new PrintWriter(new BufferedOutputStream(new FileOutputStream("output.txt")))) {
			int testCases = scanner.nextInt();
			for (int testCase = 0; testCase < testCases; testCase++) {
				solve(testCase + 1, scanner, writer);
			}
		}
	}

	private static void solve(int caseNum, Scanner scanner, PrintWriter writer) {
		long N = scanner.nextLong();
		long K = scanner.nextLong();
		PriorityQueue<Long> lens = new PriorityQueue<>(Comparator.reverseOrder());
		lens.add(N);
		long stalls = N;
		long middle = stalls / 2;
		for (int i = 0; i < K; i++) {
			stalls = lens.poll();
			middle = stalls / 2L;
			lens.add(middle);
			lens.add(stalls - middle - 1);
		}

		writer.println(String.format("Case #%s: %s", caseNum, middle + " " + (stalls - middle - 1)));
	}

}
