import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Scanner;

public class CruiseControl {

	private static final double delta = 0.0000001;

	private static DecimalFormat df = new DecimalFormat(".######");

	public static void main(String[] args) throws Exception {
		df.setGroupingUsed(false);
		try (Scanner scanner = new Scanner(new FileInputStream("A-small-attempt1.in"));
		     PrintWriter writer = new PrintWriter(new BufferedOutputStream(new FileOutputStream("output.txt")))) {
			int testCases = scanner.nextInt();
			for (int testCase = 0; testCase < testCases; testCase++) {
				solve(testCase + 1, scanner, writer);
			}
		}
	}

	private static void solve(int caseNum, Scanner scanner, PrintWriter writer) {
		int D = scanner.nextInt();
		int N = scanner.nextInt();
		int[] K = new int[N];
		int[] S = new int[N];
		for (int i = 0; i < N; i++) {
			K[i] = scanner.nextInt();
			S[i] = scanner.nextInt();
		}
		double lo = 0;
		double hi = Double.MAX_VALUE;
		while (Math.abs(hi - lo) > delta) {
			double mid = lo + (hi - lo) / 2;
			if ((Math.abs(mid - lo) < delta) || Math.abs(mid - hi) < delta) {
				break;
			}
			double time = ((double) D) / mid;
			boolean ok = true;
			for (int i = 0; i < N; i++) {
				ok = (double) K[i] + S[i] * time > D;
				if (!ok) {
					break;
				}
			}
			if (ok) {
				lo = mid;
			} else {
				hi = mid;
			}
		}

		writer.println(String.format("Case #%s: %s", caseNum, df.format(lo)));
	}

}
