import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class TidyNumbers {

	public static void main(String[] args) throws Exception {
		try (Scanner scanner = new Scanner(new FileInputStream("B-large.in"));
		     PrintWriter writer = new PrintWriter(new BufferedOutputStream(new FileOutputStream("output.txt")))) {
			int testCases = scanner.nextInt();
			for (int testCase = 0; testCase < testCases; testCase++) {
				solve(testCase + 1, scanner, writer);
			}
		}
	}

	private static void solve(int caseNum, Scanner scanner, PrintWriter writer) {
		String num = scanner.next() + '9';
		int n = num.length() - 1;
		StringBuilder answer = new StringBuilder();
		int sameCnt = 0;
		int lastSameDigit = 0;
		for (int i = 0; i < n; i++) {
			int digit = num.charAt(i) - '0';
			int nextDigit = num.charAt(i + 1) - '0';
			if (digit < nextDigit) {
				for (int j = 0; j < sameCnt; j++) {
					answer.append(lastSameDigit);
				}
				answer.append(digit);
				sameCnt = 0;
			} else if (digit == nextDigit) {
				sameCnt++;
				lastSameDigit = digit;
			} else {
				answer.append(digit - 1);
				for (int j = i - sameCnt + 1; j < n; j++) {
					answer.append('9');
				}
				sameCnt = 0;
				break;
			}
		}
		for (int i = 0; i < sameCnt; i++) {
			answer.append(lastSameDigit);
		}
		if (answer.charAt(0) == '0') {
			answer.delete(0, 1);
		}
		writer.println(String.format("Case #%s: %s", caseNum, answer.toString()));
	}
}
