import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Locale;
import java.util.Scanner;

public class Main {

	private final double INIT_RATE = 2.0;

	private void solve() {
		Scanner scanner;
		PrintStream out;
		try {
			scanner = new Scanner(new File("B-large.in"));
			scanner.useLocale(Locale.US);
			out = new PrintStream("outputBlarge.txt");

			NumberFormat nf = NumberFormat.getNumberInstance(Locale.US);
			nf.setMinimumFractionDigits(7);
			nf.setMaximumFractionDigits(7);
			nf.setGroupingUsed(false);
			try {
				int numberOfCases = scanner.nextInt();

				inputs:
				for (int i = 0; i < numberOfCases; i++) {
					String res = "Case #" + Integer.toString(i + 1) + ": ";

					double C = scanner.nextDouble();
					double F = scanner.nextDouble();
					double X = scanner.nextDouble();

					double result = X / INIT_RATE;
					double previousPurchases = 0;
					for (int step = 0; ; step++) {
						double newResult = previousPurchases + X / (INIT_RATE + step * F);
						if (newResult > result) {
							break;
						} else {
							result = newResult;
						}
						previousPurchases += C / (INIT_RATE + step * F);
					}

					out.println(res + nf.format(result));
				}
			} finally {
				out.close();
				scanner.close();
			}

		} catch (IOException ex) {
			System.out.println(ex.getMessage());
		}


	}

	public static void main(String[] args) {
		new Main().solve();
	}
}
