import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Scanner;

public class Cores {

	private static final double delta = 0.0000001;

	private static DecimalFormat df = new DecimalFormat("#.######");

	public static void main(String[] args) throws Exception {
		try (Scanner scanner = new Scanner(new FileInputStream("C-small-1-attempt0.in"));
		     PrintWriter writer = new PrintWriter(new BufferedOutputStream(new FileOutputStream("output.txt")))) {
			int testCases = scanner.nextInt();
			for (int testCase = 0; testCase < testCases; testCase++) {
				solve(testCase + 1, scanner, writer);
			}
		}
	}

	private static void solve(int caseNum, Scanner scanner, PrintWriter writer) {
		int N = scanner.nextInt();
		int K = scanner.nextInt();
		double U = scanner.nextDouble();
		double[] P = new double[N];

		int ones = 0;
		boolean[] excluded = new boolean[N];
		for (int i = 0; i < N; i++) {
			P[i] = scanner.nextDouble();
			if (Math.abs(P[i] - 1.0) < delta) {
				ones++;
				excluded[i] = true;
			}
		}

		while (Math.abs(U) > delta) {
			double portion = U / (N - ones);
			for (int i = 0; i < N; i++) {
				if (!excluded[i]) {
					P[i] += portion;
					U -= portion;
					if (P[i] > 1.0) {
						excluded[i] = true;
						ones++;
						U += P[i] - 1.0;
					}
				}
			}
		}
		double answer = 1.0;
		for (int i = 0; i < N; i++) {
			if (!excluded[i]) {
				answer *= P[i];
			}
		}


		writer.println(String.format("Case #%s: %s", caseNum, df.format(answer)));
	}

}
