import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class Ratatouille {

	public static void main(String[] args) throws Exception {
		try (Scanner scanner = new Scanner(new FileInputStream("B-small-attempt1.in"));
		     PrintWriter writer = new PrintWriter(new BufferedOutputStream(new FileOutputStream("output.txt")))) {
			int testCases = scanner.nextInt();
			for (int testCase = 0; testCase < testCases; testCase++) {
				solve(testCase + 1, scanner, writer);
			}
		}
	}

	private static void solve(int caseNum, Scanner scanner, PrintWriter writer) {
		int N = scanner.nextInt();
		int P = scanner.nextInt();
		int[] R = new int[N];
		for (int i = 0; i < N; i++) {
			R[i] = scanner.nextInt();
		}
		int[][] Q = new int[N][P];
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < P; j++) {
				Q[i][j] = scanner.nextInt();
			}
		}

		int res = 0;
		if (N == 1) {
			res = count(Q[0], R[0], P);
		} else {
			int rMin = (R[0] * 9) / 10 + ((R[0] * 9) % 10 == 0 ? 0 : 1);
			int rMax = (R[0] * 11) / 10;

			int r1Min = (R[1] * 9) / 10 + ((R[1] * 9) % 10 == 0 ? 0 : 1);
			int r1Max = (R[1] * 11) / 10;

			for (int j = 0; j < P; j++) {
				int p = Q[0][j];
				int cnt = -1;
				for (int r = rMin; r <= rMax; r++) {
					if (p % r == 0) {
						cnt = p / r;
						break;
					}
				}
				int matches = 0;
				if (cnt != -1) {
					for (int j1 = 0; j1 < P; j1++) {
						if (Q[1][j1] % cnt == 0) {
							int amt = Q[1][j1] / cnt;
							if (amt >= r1Min && amt <= r1Max) {
								matches++;
							}
						}

					}
				}
				res += matches;
			}
		}
		writer.println(String.format("Case #%s: %s", caseNum, res));
	}

	private static int count(int[] Q, int R, int P) {
		int res = 0;
		for (int j = 0; j < P; j++) {
			int p = Q[j];
			int rMin = (R * 9) / 10 + ((R * 9) % 10 == 0 ? 0 : 1);
			int rMax = (R * 11) / 10;
			for (int r = rMin; r <= rMax; r++) {
				if (p % r == 0) {
					res++;
					break;
				}
			}
		}
		return res;
	}

}
