import java.io.BufferedOutputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

public class AlphabetCake {

	public static void main(String[] args) throws Exception {
		try (Scanner scanner = new Scanner(new FileInputStream("A-small-attempt0.in"));
		     PrintWriter writer = new PrintWriter(new BufferedOutputStream(new FileOutputStream("output.txt")))) {
			int testCases = scanner.nextInt();
			for (int testCase = 0; testCase < testCases; testCase++) {
				solve(testCase + 1, scanner, writer);
			}
		}
	}

	private static void solve(int caseNum, Scanner scanner, PrintWriter writer) {
		int n = scanner.nextInt();
		int m = scanner.nextInt();
		char[][] cake = new char[n][m];
		for (int i = 0; i < n; i++) {
			cake[i] = scanner.next().toCharArray();
		}
		for (int i = 0; i < n; i++) {
			char prev = '?';
			for (int j = 0; j < m; j++) {
				char ch = cake[i][j];
				if (ch == '?') {
					cake[i][j] = prev;
				} else {
					prev = ch;
				}
			}
			prev = '?';
			for (int j = m - 1; j >= 0; j--) {
				char ch = cake[i][j];
				if (ch == '?') {
					cake[i][j] = prev;
				} else {
					prev = ch;
				}
			}
		}

		char[] prevAr = empty(m);
		for (int i = 0; i < n; i++) {
			if (cake[i][0] == '?') {
				if (prevAr[0] != '?') {
					System.arraycopy(prevAr, 0, cake[i], 0, m);
				}
			} else {
				prevAr = cake[i];
			}
		}
		prevAr = empty(m);
		for (int i = n - 1; i >= 0; i--) {
			if (cake[i][0] == '?') {
				if (prevAr[0] != '?') {
					System.arraycopy(prevAr, 0, cake[i], 0, m);
				}
			} else {
				prevAr = cake[i];
			}
		}
		prevAr = empty(m);

		writer.println(String.format("Case #%s:", caseNum));
		for (int i = 0; i < n; i++) {
			writer.println(new String(cake[i]));
		}
	}

	private static char[] empty(int m) {
		char[] res = new char[m];
		Arrays.fill(res, '?');
		return res;
	}


}
