import java.util.*;
import java.io.*;

public class C {
	FastScanner in;
	PrintWriter out;

	int h, w;
	boolean[][] a;
	
	int[] di = {-1, 0, 1, 0};
	int[] dj = {0, 1,  0, -1};
	
	public void solve() throws IOException {
		w = in.nextInt();
		h = in.nextInt();
		a = new boolean[h][w];
		int b = in.nextInt();
		for (int i = 0; i < b; i++) {
			int x0 = in.nextInt();
			int y0 = in.nextInt(), x1 = in.nextInt(), y1 = in.nextInt();
			for (int y = y0; y <= y1; y++) {
				for (int x = x0; x <= x1; x++)
					a[y][x] = true;
			}
		}
		int res = 0;
		int[][] prev = new int[h][w];
		int[][] d = new int[h][w];
		int inf = Integer.MAX_VALUE / 2;
		for (int j = w - 1; j >= 0; j--) {
			for (int i = 0; i < h; i++) {
				Arrays.fill(prev[i], -1);
				Arrays.fill(d[i], inf );
			}
			if (a[0][j])
				continue;
			int[] qi = new int[h * w];
			int[] qj = new int[h * w];
			int st = 0, en = 0;
			d[0][j] = 0;
			qi[en] = 0;
			qj[en] = j;
			en++;
			while (st != en) {
				int ci = qi[st];
				int cj = qj[st];
				st++;
				
				for (int ii = 0; ii < 4; ii++) {
					int ni = ci + di[ii];
					int nj = cj + dj[ii];
					if (ni >= 0 && ni < h && nj >= 0 && nj < w && !a[ni][nj] && d[ci][cj] + 1 < d[ni][nj]) { 
						d[ni][nj] = d[ci][cj] + 1;
						prev[ni][nj] = ii;
						qi[en] = ni;
						qj[en] = nj;
						en++;
					}
				}
			}
			for (int k = w - 1; k >= 0; k--) {
				if (d[h - 1][k] != inf) {
					res++;
					int ii = h - 1, jj = k;
					a[h - 1][k] = true;
					while (prev[ii][jj] != -1) {
						int ind = prev[ii][jj];
						ii -= di[ind];
						jj -= dj[ind];
						a[ii][jj] = true;
					}
					break;
				}
			}
		}
		out.println(res);
	}

	public void run() {
		try {
			in = new FastScanner(new File("task.in"));
			out = new PrintWriter(new File("task.out"));

			int tests = in.nextInt();

			for (int i = 0; i < tests; ++i) {
				out.print("Case #" + (i + 1) + ": ");
				solve();
				System.out.println(i);
			}

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] arg) {
		new C().run();
	}
}