import java.util.*;
import java.io.*;
import java.math.BigInteger;

public class FastFairAndSquare {
	FastScanner in;
	PrintWriter out;

	ArrayList<String>[] f;
	
	final int maxLen = 100;
	TreeSet<BigInteger> goodNumbers = new TreeSet<>();
	
	boolean isPalindrome(String s) {
		int i = 0, j = s.length() - 1;
		while (i < j) {
			if (s.charAt(i) != s.charAt(j)) {
				return false;
			}
			i++;
			j--;
		}
		return true;
	}
	
	boolean check(String t) {
		BigInteger i = new BigInteger(t);
		return isPalindrome(i.multiply(i).toString());
	}
	
	public void precalc() {
		f = new ArrayList[maxLen / 2];
		for (int i = 0; i < maxLen / 2; i++) {
			f[i] = new ArrayList<String>();
		}
		f[0].add("1");
		f[0].add("2");
		f[0].add("3");
		
		f[1].add("11");
		f[1].add("22");
		
		f[2].add("101");
		f[2].add("111");
		f[2].add("121");
		f[2].add("202");
		f[2].add("212");
		
		for (int i = 3; i < maxLen / 2; i++) {
			for (String s : f[i - 2]) {
				String t = s.charAt(0) + "0" + s.substring(1, s.length() - 1) + "0" + s.charAt(s.length() - 1);
				if (check(t)) {
					f[i].add(t);
				}
				if (s.charAt(0) != '2') {
					t = s.charAt(0) + "1" + s.substring(1, s.length() - 1) + "1" + s.charAt(s.length() - 1);
					if (check(t)) {
						f[i].add(t);
					}
				}
			}
			System.out.println(i);
		}
		for (int i = 0; i < maxLen / 2; i++) {
			for (String s : f[i]) {
				BigInteger bi = new BigInteger(s);
				goodNumbers.add(bi.multiply(bi));
			}
		}
	}
	
	public void solve() throws IOException {
		BigInteger a = new BigInteger(in.next()), b = new BigInteger(in.next());
		out.println(goodNumbers.subSet(a, b.add(BigInteger.ONE)).size());
	}

	public void run() {
		try {
			in = new FastScanner(new File("a.in"));
			out = new PrintWriter(new File("a.out"));
			
			precalc();
			int tests = in.nextInt();
			for (int i = 0; i < tests; i++) {
				out.print("Case #" + (i + 1) + ": ");
				solve();
			}

			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		FastScanner(File f) {
			try {
				br = new BufferedReader(new FileReader(f));
			} catch (FileNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}

		boolean hasNext() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					String s = br.readLine();
					if (s == null) {
						return false;
					}
					st = new StringTokenizer(s);
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return true;
		}

		String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}
	}

	public static void main(String[] arg) {
		new FastFairAndSquare().run();
	}
}