package CodeJam2016QR;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.*;

public class C {
    
    public static ArrayList<BigInteger> primes;
    public static Set<BigInteger> primesSet;
    public static StringBuilder divisors; 
    
    public static void main(String[] args) throws IOException {
        
        primes = new ArrayList<>();
        primes.add(new BigInteger("2"));
        generatePrimes();
        primesSet = new TreeSet<>(primes);
        
        BufferedWriter bw = new BufferedWriter(new FileWriter(new File("C.txt")));
        BigInteger s = new BigInteger("10000000000000000000000000000001", 2);
        bw.write("Case #1:");
        bw.newLine();
        for (int i = 0; i < 500;) {
            if(isJamcoin(s.toString(2))){
                System.out.println(s.toString(2) + " " + divisors.toString());
                bw.write(s.toString(2) + " " + divisors.toString());
                bw.newLine();
                i++;
            }
            s = s.add(BigInteger.ONE);
        }
        bw.close();
    }
    
    public static void generatePrimes(){
        for (BigInteger i = new BigInteger("3"); i.compareTo(new BigInteger("1000000")) < 0 ; i = i.add(BigInteger.ONE)) {
            boolean flag = true;
            for (int j = 0; j<primes.size() && primes.get(j).longValue() <= Math.sqrt(i.longValue()); j++) {
                if(i.mod(primes.get(j)).compareTo(BigInteger.ZERO)==0){
                    flag = false;
                    break;
                }
            }
            if(flag){
                primes.add(i);
            }
        }
    }

    private static boolean isJamcoin(String s) {
        if(s.charAt(0)=='0' || s.charAt(s.length()-1)=='0')return false;
        divisors = new StringBuilder();
        for (int i = 2; i <= 10; i++) {
            BigInteger val = new BigInteger(s, i);
            if(primesSet.contains(val))return false;
            boolean b = true;
            for (BigInteger p : primes) {
                if(val.mod(p).compareTo(BigInteger.ZERO)==0){
                    if(i!=2)divisors.append(" ");
                    divisors.append(p);
                    b=false;
                    break;
                }
            }
            if(b)return false;
        }
        return true;
        
    }

}


