import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;


public class TicTacToe {
	static ArrayList<Integer[][]> tictacs = new ArrayList<Integer[][]>();
	static Integer[][] tictac = new Integer[4][4];
	static boolean isComplete = true;
	public static void main(String[] args) {
		ArrayList<String> lines = new ArrayList<String>();
		lines = readFile("C:\\Users\\Anuj\\Downloads\\A-large.in");
		populateTicTac(lines);
		for(int i = 0; i < tictacs.size(); i++) {
			isComplete = true;
			int win = getWinner(tictacs.get(i));
			System.out.print("Case #" + Integer.toString(i + 1) + ": ");
			if(win == -1 && isComplete) {
				System.out.println("Draw");
			} else if (win == -1 && !isComplete) {
				System.out.println("Game has not completed");
			} else if(win == 0) {
				System.out.println("O won");
			} else if(win == 1) {
				System.out.println("X won");
			}
		}
		
	}
	
	private static int getWinner(Integer[][] integers) {
		int winner = checkHorizontal(integers);
		winner = (winner == -1) ? checkVertical(integers) : winner;
		winner = (winner == -1) ? checkDiagnol(integers) : winner;
		return winner;
	}

	private static int checkDiagnol(Integer[][] integers) {
		int winner = checkDiagnolRight(integers);
		winner = (winner == -1) ? checkDiagnolLeft(integers) : winner;
		return winner;
	}

	private static int checkDiagnolLeft(Integer[][] integers) {
		StringBuffer sb = new StringBuffer();
		for(int i = 0; i < 4; i++) {
			for(int j = 3; j >= 0; j--) {
				if(i + j == 3) {
					sb.append(Integer.toString(integers[i][j]));
				}
			}
		}
		if(isWin(sb.toString(), "1")) {
			return 1;
		} else if(isWin(sb.toString(), "0")) {
			return 0;
		} 
		return -1;
	}

	private static int checkDiagnolRight(Integer[][] integers) {
		StringBuffer sb = new StringBuffer();
		for(int i = 0; i < 4; i++) {
			for(int j = 0; j < 4; j++) {
				if(i == j) {
					sb.append(Integer.toString(integers[i][j]));
				}
			}
		}
		if(isWin(sb.toString(), "1")) {
			return 1;
		} else if(isWin(sb.toString(), "0")) {
			return 0;
		} 
		return -1;
	}

	private static int checkVertical(Integer[][] integers) {
		for(int i = 0; i < 4; i++) {
			StringBuffer sb = new StringBuffer();
			for(int j = 0; j < 4; j++) {
				sb.append(Integer.toString(integers[j][i]));
			}
			
			if(isWin(sb.toString(), "1")) {
				return 1;
			} else if(isWin(sb.toString(), "0")) {
				return 0;
			}
		}
		return -1;
	}

	private static int checkHorizontal(Integer[][] integers) {
		for(int i = 0; i < 4; i++) {
			StringBuffer sb = new StringBuffer();
			for(int j = 0; j < 4; j++) {
				sb.append(Integer.toString(integers[i][j]));
			}
			if(sb.toString().contains("-1")) {
				isComplete = false;
			}
			if(isWin(sb.toString(), "1")) {
				return 1;
			} else if(isWin(sb.toString(), "0")) {
				return 0;
			}
		}
		return -1;
	}

	private static void populateTicTac(ArrayList<String> lines) {
		for(int i = 1; i < lines.size(); i++) {
			char[] chars = lines.get(i).toCharArray();
			int k = (i % 4 == 0) ? 3 : i % 4 -1;
			for(int j = 0; j < chars.length; j++) {
				if(".".equals(Character.toString(chars[j]))) {
					tictac[k][j] = -1;
				} else if("X".equals(Character.toString(chars[j]))) {
					tictac[k][j] = 1;
				} else if("O".equals(Character.toString(chars[j]))) {
					tictac[k][j] = 0;
				} else if("T".equals(Character.toString(chars[j]))) {
					tictac[k][j] = -2;
				}
			}
			if(i % 4 == 0) {
				tictacs.add(tictac);
				tictac = new Integer[4][4];
			}
		}
	}

	public static ArrayList<String> readFile(final String filePath) {
		BufferedReader br = null;
		ArrayList<String> sb = new ArrayList<String>();
		try {
			String sCurrentLine;
			br = new BufferedReader(new FileReader(filePath));
			while ((sCurrentLine = br.readLine()) != null) {
				
				if(!sCurrentLine.equals("\n") && !sCurrentLine.trim().equals("")) {
				 sb.add(sCurrentLine);
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
		return sb;
	}
	
	public static boolean isWin(final String value, final String key) {
		int keyCount = 0;
		int TCount = 0;
		char[] values = value.toCharArray();
		for(int i = 0; i < values.length; i++) {
			if(key.equals(Character.toString(values[i]))) {
				keyCount++;
			} else if("-".equals(Character.toString(values[i]))) {
				String s = Character.toString(values[i++]);
				s += Character.toString(values[i]);
				if("-2".equals(s)) {
					TCount++;
				}
			}
		}
		if(TCount > 1) TCount = 1;
		if(keyCount == 4 || TCount + keyCount == 4) {
			return true;
		} else {
			return false;
		}
	}
}
