import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;


public class LawnMover {
	
	static Integer[][] tictac;
	static ArrayList<String[][]> lawns = new ArrayList<String[][]>();
	public static void main(String[] args) {
		ArrayList<String> lines = new ArrayList<String>();
		lines = readFile("C:\\Users\\Anuj\\Downloads\\B-large.in");
		
		constructLawns(lines);
		for(int i = 0; i < lawns.size(); i++) {
			String[][] l = lawns.get(i);
			String[][] gardenedLawn = trimLawn(l);
			if(trimmingDone(gardenedLawn)) {
				System.out.println("Case #" + Integer.toString(i + 1) + ": YES");
			} else {
				System.out.println("Case #" + Integer.toString(i + 1) + ": NO");
			}
		}
	}

	private static boolean trimmingDone(String[][] l) {
		for(int i = 0; i < l.length; i++) {
			for(int j = 0; j < l[i].length; j++) {
				int currentH = Integer.parseInt(l[i][j].split(":")[0]);
				int reqH = Integer.parseInt(l[i][j].split(":")[1]);
				if(currentH != reqH) {
					return false;
				}
			}
		}
		return true;
	}

	private static String[][] trimLawn(String[][] l) {
		l = trimHorizontal(l);
		l = trimgVertical(l);
		return l;
	}

	private static String[][] trimgVertical(String[][] l) {
		int column = 0;
		String[] vertical = null;
		while (column < l[0].length) {
			vertical = new String[l.length];
			for(int i = 0; i < l.length; i++) {
				vertical[i] = l[i][column];
			}
			int maxH = getMaxHeight(vertical);
			for(int i = 0; i < l.length; i++) {
				int currentH = Integer.parseInt(l[i][column].split(":")[0]);
				int reqH = Integer.parseInt(l[i][column].split(":")[1]);
				if(currentH > reqH) {
					if(currentH > maxH) {
						l[i][column] = Integer.toString(maxH) + ":" + Integer.toString(reqH);
					}
				}
			}
			column++;
		}
		return l;
	}

	private static String[][] trimHorizontal(String[][] l) {
		for(int i = 0; i < l.length; i++) {
			String[] hH = new String[l[0].length] ;
			for(int j = 0; j < l[i].length; j++) {
				hH[j] = l[i][j];
			}
			int maxH = getMaxHeight(hH);
			for(int j = 0; j < l[i].length; j++) {
				int currentH = Integer.parseInt(l[i][j].split(":")[0]);
				int reqH = Integer.parseInt(l[i][j].split(":")[1]);
				if(currentH > reqH) {
					if(currentH > maxH) {
						l[i][j] = Integer.toString(maxH) + ":" + Integer.toString(reqH);
					}
				}
			}
		}
		return l;
	}

	private static int getMaxHeight(String[] strings) {
		int h = 0;
		for(int i = 0; i < strings.length; i++) {
			int reqH = Integer.parseInt(strings[i].split(":")[1]);
			if(reqH > h) 
				h = reqH;
		}
		return h;
	}

	private static void constructLawns(ArrayList<String> lines) {
		String[] splits ;
		int nextSet = 1;
		int noOfRows;
		int noOfColumns;
		int counter = 0;
		String[][] lawn = null;
		for(int i = 1; i <= lines.size(); i++) {
			if(i == nextSet) {
				if(i == lines.size()) {
					if(null != lawn)
						lawns.add(lawn);
					break;
				}
				splits = lines.get(i).split(" ");
				noOfRows = Integer.parseInt(splits[0]);
				nextSet = i + noOfRows + 1;
				noOfColumns = Integer.parseInt(splits[1]);
				if(null != lawn)
					lawns.add(lawn);
				counter = 0;
				lawn = new String[noOfRows][noOfColumns];
			} else {
				splits = lines.get(i).split(" ");
				for(int j = 0; j < splits.length; j++) {
					String h = "100:" + splits[j];
					lawn[counter][j] = h;
				}
				counter++;
			}
			
		}
		
	}

	public static ArrayList<String> readFile(final String filePath) {
		BufferedReader br = null;
		ArrayList<String> sb = new ArrayList<String>();
		try {
			String sCurrentLine;
			br = new BufferedReader(new FileReader(filePath));
			while ((sCurrentLine = br.readLine()) != null) {
				
				if(!sCurrentLine.equals("\n") && !sCurrentLine.trim().equals("")) {
				 sb.add(sCurrentLine);
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
		return sb;
	}
}
