import java.util.*;
import java.math.*;
import java.io.*;

public class Main
	{
	public static void main(String args[]) throws IOException
		{
		InputReader in=new InputReader(new FileInputStream(
				new File("input.txt")));
		PrintWriter out=new PrintWriter(System.out);
		int T=in.readInt();
		long mod=1000002013;
		for(int t=0;t<T;t++)
			{
			//System.out.println("Case "+(t+1));
			long N=in.readInt();
			int M=in.readInt();
			Point Points[]=new Point[2*M];
			long originalCost=0;
			long peopleCost=0;
			for(int i=0;i<M;i++)
				{
				long o=in.readInt();
				long e=in.readInt();
				long p=in.readInt();
				long dis=e-o;
				originalCost+=p*(N*dis-((dis-1)*dis)/2);
				originalCost%=mod;
				Points[2*i]=new Point(o,p,true);
				Points[2*i+1]=new Point(e,p,false);
				}
			//System.out.println("original Cost = "+originalCost);
			Arrays.sort(Points);
			Stack<Ticket> Tickets=new Stack<Ticket>();
			for(int i=0;i<2*M;i++)
				{
				//System.out.println("Point "+Points[i].loc+" "+Points[i].in);
				long curPos=Points[i].loc;
				if(Points[i].in)
					Tickets.push(new Ticket(curPos,Points[i].people));
				else
					{
					long ticketsRequired=Points[i].people;
					while(ticketsRequired>0)
						{
						Ticket latest=Tickets.peek();
						long dis=curPos-latest.loc;
						//System.out.println("\tdis="+dis+" people= "+latest.people);
						if(latest.people>=ticketsRequired)
							{
							peopleCost+=(ticketsRequired)*(N*dis-((dis-1)*dis)/2);
							latest.people-=ticketsRequired;
							ticketsRequired=0;
							}
						else
							{
							peopleCost+=(latest.people)*(N*dis-((dis-1)*dis)/2);
							ticketsRequired-=latest.people;
							Tickets.pop();
							}
						peopleCost%=mod;
						}
					}
				}
			out.println("Case #"+(t+1)+": "+(originalCost-peopleCost+2*mod)%mod);
			}
		out.close();
		}

	}

class Ticket
	{
	long loc;
	long people;
	public Ticket(long loc,long people)
		{
		this.loc=loc;
		this.people=people;
		}
	
	}

class Point implements Comparable<Point>
	{
	long loc,people;
	boolean in;
	public Point(long loc,long people,boolean in)
		{
		this.loc=loc;
		this.people=people;
		this.in=in;
		}
	@Override
	public int compareTo(Point o)
		{
		if(this.loc<o.loc)
			return -1;
		if(this.loc==o.loc)
			{
			if(this.in&&!o.in)
				return -1;
			if(!this.in&&o.in)
				return 1;
			return 0;
			}
		return 1;
		}
	}

class node implements Comparable<node>
	{
	int x;
	int y;

	public node(int x,int y)
		{
		this.x=x;
		this.y=y;
		}

	public int compareTo(node o)
		{
		if(this.x<o.x)
			return -1;
		else if(this.x==o.x&&this.y<o.y)
			return -1;
		else if(this.x==o.x&&this.y==o.y)
			return 0;
		return 1;
		}
	}
class InputReader
	{
	private InputStream stream;
	private byte[] buf=new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReader(InputStream stream)
		{
		this.stream=stream;
		}

	public int read()
		{
		if(numChars==-1)
			throw new InputMismatchException();
		if(curChar>=numChars)
			{
			curChar=0;
			try
				{
				numChars=stream.read(buf);
				} catch (IOException e)
				{
				throw new InputMismatchException();
				}
			if(numChars<=0)
				return -1;
			}
		return buf[curChar++];
		}

	public int readInt()
		{
		int c=read();
		while (isSpaceChar(c))
			c=read();
		int sgn=1;
		if(c=='-')
			{
			sgn=-1;
			c=read();
			}
		int res=0;
		do
			{
			if(c<'0'||c>'9')
				throw new InputMismatchException();
			res*=10;
			res+=c-'0';
			c=read();
			} while (!isSpaceChar(c));
		return res*sgn;
		}

	public boolean isSpaceChar(int c)
		{
		if(filter!=null)
			return filter.isSpaceChar(c);
		return isWhitespace(c);
		}

	public static boolean isWhitespace(int c)
		{
		return c==' '||c=='\n'||c=='\r'||c=='\t'||c==-1;
		}

	public char readCharacter()
		{
		int c=read();
		while (isSpaceChar(c))
			c=read();
		return (char) c;
		}

	public interface SpaceCharFilter
		{
		public boolean isSpaceChar(int ch);
		}
	}
