import java.io.*;
import java.util.*;

public class Dijkstra {
	static final String file = "C-small-attempt0";
	Scanner  in;
	PrintWriter out;
	
	String solve() {
		int L = in.nextInt();
		long X = in.nextLong();
		char[] S = in.next().toCharArray();
		int I = -1, K = -1;
		try {
		String p = pattern(S, X);
		if (p != null) 
			return p;
		else {
			char ch = S[0];
			if (ch == 'i') I = 0;
			for (int i=1; i<L; i++) {
				ch = op(ch, S[i]);
				if (ch == 'i') I = i;
			}
			
			if (I == -1) return "NO";
			
			ch = S[L-1];
			if (ch == 'k') K = L-1;
			for (int i=L-2; i>=0; i--) {
				ch = op(ch, S[i]);
				if (ch == 'k') K = i;
			}
			
			if (K == -1) return "NO";
			
			ch = S[I+1];
			for (int i=I+2; i<K; i++)
				ch = op(ch, S[i]);
			
			if (ch == 'j') 	return "YES";
			return "NO";
		}
		}catch (ArrayIndexOutOfBoundsException e) {
			return "NO";
		}
	}
	
	String pattern(char[] L, long X) {
		if (L.length == 1)	return "NO";
		
		long len = L.length * X;
		
		for (int i=2; i<L.length; i++)
			if (i % 2 == 0 && L[i] != L[0])
				return null;
			else if (L[i] != L[1])
				return null;
		
		
		if (L[0] == 'i') {
			if (len >= 4 && (len - 4) % 8 == 0)	return "YES";
			return "NO";
		}
		
		else if (L[0] == 'j') {
			if (L[1] == 'k') {
				if (len >= 4 && (len - 4) % 8 == 0) return "YES";
				return "NO";
			}
			if (len >= 12 && (len - 12) % 8 == 0)	return "YES";
			return "NO";
		}
		else {
			if (len >= 12 && (len -12) % 8 == 0) return "YES";
			return "NO";
		}
	}
		
	char op(char x, char y) {
		if (x == '1')	return y;
		if (x == '0')	return Character.toUpperCase(y);
		
		boolean invert = false;
		if (Character.isUpperCase(x) ^ Character.isUpperCase(y))
			invert = true;
		x = Character.toLowerCase(x);
		y = Character.toLowerCase(y);
		char ret = '\0';
		
		if (x == 'i') {
			if (y == 'j') ret = 'k';
			ret = 'J';
		}
		else if (x == 'j') {
			if (y == 'k') ret = 'y';
			ret = 'K';
		}
		else {
			if (y == 'i') ret = 'j';
			ret = 'I';
		}
		
		if (invert) {
			if (Character.isUpperCase(ret)) return Character.toLowerCase(ret);
			return Character.toUpperCase(ret);
		}
		return ret;
	}
	
	void input() throws FileNotFoundException {
//		in = new Scanner(System.in);
//		out = new PrintWriter(System.out);
		in = new Scanner(new File(file + ".in"));
		out = new PrintWriter(file + ".out");
		int T = in.nextInt();
		for (int test=1; test<=T; test++) {
			out.println("Case #" + test + ": " + solve());
//			solve();
		}
		out.close();
		in.close();
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		new Dijkstra().input();
	}

}
