package quali;

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class CountingSheep {
	private int solve(int N) {
		int digits = 0;
		for (int i = 1; i < 1000; i++) {
			int no = i * N;
			for (int a = no; a > 0; a /= 10) {
				int r = a % 10;
				digits |= 1 << r;
			}
			if (digits == 1023) {
				return no;
			}
		}
		return -1;
	}

	public static void main(String[] args) throws Exception {
		String file = "A-large";
//		String file = "input";
		Scanner in = new Scanner(new File("src/quali/" + file + ".in"));
		PrintWriter out = new PrintWriter("src/quali/" + file + ".out");
		ExecutorService executor = Executors.newFixedThreadPool(4);
		CountingSheep solver = new CountingSheep();
		int testCases = in.nextInt();
		@SuppressWarnings("unchecked")
		Future<Integer>[] futures = new Future[testCases];
//		int[] futures = new int[testCases];
		for (int testCase = 1; testCase <= testCases; testCase++) {
			int N = in.nextInt();
			futures[testCase - 1] = executor.submit(() -> solver.solve(N));
//			futures[testCase - 1] = solver.solve(N, G.clone());
		}
		for (int testCase = 1; testCase <= testCases; testCase++) {
			int x = futures[testCase - 1].get();
			out.println("Case #" + testCase + ": " + (x == -1 ? "INSOMNIA" : x));
//			out.println("Case #" + testCase + ": " + futures[testCase - 1]);
//			out.flush();
		}
		out.close();
		in.close();
		executor.shutdown();
	}
}
