package quali;

import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class RevengeOfThePancakes {
	boolean[] seen;
	int[] dp;
	private int N;
	
	private int solve(boolean[] up) {
		int brt = 0;
		N = up.length;
		for (int i = 0; i < N; i++) {
			if (up[i]) {
				brt |= 1 << i;
			}
		}
		seen = new boolean[1 << N];
		dp = new int[1 << N];
//		System.out.println(brt);
		return brt4c(brt);
	}
	
	private int brt4c(int up) {
		if (up == (1 << N) - 1) return 0;
		if (dp[up] > 0) return dp[up];
		if (seen[up]) return 1 << 30;
		seen[up] = true;
		
		int cost = 1 << 30;
		for (int i = 0; i < N; i++) {
			int x = flipNrev(up, i);
			cost = Math.min(cost, brt4c(x) + 1);
		}
		dp[up] = cost;
		return cost;
	}

	private int flipNrev(int up, int i) {
		int flip = up ^ (1 << i + 1) - 1;
		int ret = flip;
		ret &= ~((1 << i + 1) - 1);
		for (int j = 0; j <= i; j++) {
			ret |= flip & 1 << i - j;
		}
		return ret;
	}

	public static void main(String[] args) throws Exception {
		String file = "B-small-attempt0";
//		String file = "input";
		Scanner in = new Scanner(new File("src/quali/" + file + ".in"));
		PrintWriter out = new PrintWriter("src/quali/" + file + ".out");
//		ExecutorService executor = Executors.newFixedThreadPool(4);
		RevengeOfThePancakes solver = new RevengeOfThePancakes();
		int testCases = in.nextInt();
		@SuppressWarnings("unchecked")
//		Future<Integer>[] futures = new Future[testCases];
		int[] futures = new int[testCases];
		for (int testCase = 1; testCase <= testCases; testCase++) {
			char[] cakes = in.next().toCharArray();
			boolean[] up = new boolean[cakes.length];
			for (int i = 0; i < up.length; i++) {
				up[i] = cakes[i] == '+';
			}
//			futures[testCase - 1] = executor.submit(() -> solver.solve(up));
			futures[testCase - 1] = solver.solve(up);
		}
		for (int testCase = 1; testCase <= testCases; testCase++) {
//			int x = futures[testCase - 1].get();
//			out.println("Case #" + testCase + ": " + x);
			out.println("Case #" + testCase + ": " + futures[testCase - 1]);
//			out.flush();
		}
		out.close();
		in.close();
//		executor.shutdown();
		
//		RevengeOfThePancakes solver = new RevengeOfThePancakes();
////		int up = Integer.parseInt("010101", 2);
////		System.out.println(Integer.toBinaryString(solver.flipNrev(up, 6)));
//		char[] cakes = "--+-".toCharArray();
//		boolean[] b = new boolean[cakes.length];
//		for (int i = 0; i < b.length; i++) {
//			b[i] = cakes[i] == '+';
//		}
//		System.out.println(solver.solve(b));
	}

}
