package anup;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TicTacToe {
	private char[][] board = new char[4][4];
	
	public TicTacToe(String[] status) {
		for(String s:status){
		log(s);
		}
		for (int i = 0; i < 4; i++) {
			board[i] = status[i].toCharArray();
		}
	}
	public static void log(String s){
		//System.out.println(s);
	}
	public String getResult() {
		int emptyCount = 0;
		char winner = 'n';
		for (int i = 0; i < 4; i++) {
			String line = String.valueOf(board[i]);
			if (line.contains(".")) {
				emptyCount++;
				continue;
			}
			winner = getWinner(line);
			if (winner != 'n') {
				log("row");
				return winner+" won";
			}
		}
		for (int j = 0; j < 4; j++) {
			StringBuffer sb = new StringBuffer();
			for (char[] row : board) {
				char c = row[j];
				if (c == '.') {
					continue;
				}
				sb.append(c);
			}
			winner = getWinner(sb.toString());
			if (winner != 'n') {
				log("col");
				return winner+" won";
			}
		}
		StringBuffer sb = new StringBuffer();
		for (int k = 0; k < 4; k++) {
				char c = board[k][k];
				if (c == '.') {
					continue;
				}
				sb.append(c);
		}
		winner = getWinner(sb.toString());
		if (winner != 'n') {
				log("diag");
				return winner+" won";
		}
		sb = new StringBuffer();
		for (int m = 0; m < 4; m++) {
				char c = board[m][3-m];
				if (c == '.') {
					continue;
				}
				sb.append(c);
		}
			winner = getWinner(sb.toString());
			if (winner != 'n') {
				log("rev diag");
				return winner+" won";
			}
		
		if(emptyCount==0){
			return "Draw";
		}
		return "Game has not completed";
		
	}

	private char getWinner(String s) {
		char w = 'n';
		if (s.contains("T")) {
			w = whoIsWinner(s.replace('T', 'X'));
			if (w == 'n')
				w = whoIsWinner(s.replace('T', 'O'));
		} else {
			w = whoIsWinner(s);
		}
		return w;
	}

	private char whoIsWinner(String s) {
		if (s.equals("OOOO")){
			return 'O';
		}
		if(s.equals("XXXX")){
			return 'X';
		}
		return 'n';
	}

public static void main(String[] args) throws NumberFormatException, IOException{
	BufferedReader in
	   = new BufferedReader(new FileReader("E:\\T\\A-large.in"));
	File f = new File("E:\\T\\op.txt");
	if(f.exists()){
		f.delete();
	}
	f.createNewFile();
	BufferedWriter out
	   = new BufferedWriter(new FileWriter(f));
	int numOfSet = Integer.valueOf(in.readLine());
	log("Set "+numOfSet);
	for(int i=0;i<numOfSet;i++){
		String [] set = new String[4];
		for(int j=0;j<4;j++){
			set[j]=in.readLine();
		}
		TicTacToe ttt = new TicTacToe(set);
		String result = "Case #"+(i+1)+": "+ttt.getResult();
		System.out.println(result);
		out.write(result+"\n");
		
		//skip empty line
		in.readLine();
	}
	
	in.close();
	out.close();
}

}
