package com.anuragkapur.jam2013.qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 * @author anuragkapur
 *
 */
public class Lawnmower {

	private static String compute(List<String> lines) {
		
		String answer = "YES";
		int rows = lines.size();
		int columns = lines.get(0).length()/2;
		columns++;
		
		int[][] pattern = new int[rows][columns];
		for (int i = 0; i < rows; i++) {
			String rowStr = lines.get(i);
			StringTokenizer tokenizer = new StringTokenizer(rowStr," ");
			for(int j = 0; j < columns; j++) {
				pattern[i][j] = Integer.parseInt(tokenizer.nextToken());
			}
		}
		
		for(int i = 0; i < rows; i++) {
			for(int j = 0; j < columns; j++) {
				if(pattern[i][j] == 1) {
					boolean rowMatch = true;
					// check row
					for(int i1 = 0; i1 < rows; i1++) {
						if(pattern[i1][j] != 1) {
							rowMatch = false;
							break;
						}
					}
					
					boolean columnMatch = true;
					// check column
					for(int i1 = 0; i1 < columns; i1++) {
						if(pattern[i][i1] != 1) {
							columnMatch = false;
							break;
						}
					}
					
					if(rowMatch  || columnMatch) {
						
					}else {
						answer = "NO";
					}
				}
			}
		}
		
		return answer;
	}
	
	private static void writeOutputToFile(String output, String filepath)
			throws IOException {
		
		FileWriter fstream = new FileWriter(filepath);
		BufferedWriter out = new BufferedWriter(fstream);
		out.write(output);
		out.flush();
		out.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		File inputFile = new File("src/com/anuragkapur/jam2013/qr/B-small-attempt0.in");
		String inputFilePath = inputFile.getAbsolutePath();
		
		try {
			// String buffer for storing the output
			StringBuffer output = new StringBuffer();
			
			// read and parse input file
			FileInputStream fstream = new FileInputStream(inputFilePath);
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;

			int lineNumber = 0;
			int noOfTestCases = -1;
			int activeTestCaseNumber = 0;
			boolean startOfTestCase = true;
			int remainingLinesInCurrentTestCase = 0;
			List<String> lines = new ArrayList<String>();
			
			while ((strLine = br.readLine()) != null) {
				
				if (lineNumber == 0) {
					noOfTestCases = Integer.parseInt(strLine);
				} else {
					
					if(startOfTestCase) {
						noOfTestCases ++;
						activeTestCaseNumber ++;
						lines = new ArrayList<String>();
						startOfTestCase = false;
						StringTokenizer tokenizer = new StringTokenizer(strLine," ");
						remainingLinesInCurrentTestCase = Integer.parseInt(tokenizer.nextToken());
					}else {
						lines.add(strLine);
						remainingLinesInCurrentTestCase --;
						if (remainingLinesInCurrentTestCase == 0) {
							// Now that a test case has been parsed, compute output for
							// this test case
							
							// Invoke algorithm here
							String solutionToTestCase = compute(lines);

							// Prepare output string
							System.out.println("Case #" + activeTestCaseNumber + ": " + solutionToTestCase);
							output.append("Case #" + activeTestCaseNumber + ": " + solutionToTestCase);
							output.append("\n");
							
							startOfTestCase=true;
						}
					}
					
					
				}
				lineNumber++;
			}
			
			in.close();
			
			// Pass output string to method to write to file
			File outputFile = new File("src/com/anuragkapur/jam2013/qr/B-small-attempt0.output");
			String filePath = outputFile.getAbsolutePath();
			writeOutputToFile(output.toString(), filePath);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			// File read cleanup
		}
	}
}