package com.anuragkapur.jam2013.qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/**
 * @author anuragkapur
 *
 */
public class FairAndSquare {

	private static int computeFairAndSquareCount(String line) {
		System.out.println("=========");
		StringTokenizer tokenizer = new StringTokenizer(line, " ");
		int first = Integer.parseInt(tokenizer.nextToken());
		int second = Integer.parseInt(tokenizer.nextToken());
		
		int count = 0;
		
		for (int i = first; i <= second; i++) {
			String str = ""+i;
			String strRev = new StringBuilder(str).reverse().toString();
			
			if(str.equals(strRev)) {
				String strSqrRt = ""+Math.sqrt(i);
				
				if(strSqrRt.substring(strSqrRt.indexOf(".")).equals(".0")) {
					// Perfect square
					str = strSqrRt.substring(0,strSqrRt.indexOf("."));
					strRev = new StringBuilder(str).reverse().toString();
					
					if(str.equals(strRev)) {
						System.out.println("Fair and Square Number :: " + i);
						count ++;
					}
				}
			}
		}
		return count;
	}
	
	private static void writeOutputToFile(String output, String filepath)
			throws IOException {
		
		FileWriter fstream = new FileWriter(filepath);
		BufferedWriter out = new BufferedWriter(fstream);
		out.write(output);
		out.flush();
		out.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		File inputFile = new File("src/com/anuragkapur/jam2013/qr/C-small-attempt0.in");
		String inputFilePath = inputFile.getAbsolutePath();
		
		try {
			// String buffer for storing the output
			StringBuffer output = new StringBuffer();
			
			// read and parse input file
			FileInputStream fstream = new FileInputStream(inputFilePath);
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;

			int lineNumber = 0;
			int noOfTestCases = -1;
			int activeTestCaseNumber = 0;
			while ((strLine = br.readLine()) != null) {
				
				if (lineNumber == 0) {
					noOfTestCases = Integer.parseInt(strLine);
				} else {
					noOfTestCases ++;
					activeTestCaseNumber ++;
					// Now that a test case has been parsed, compute output for
					// this test case
					
					// Invoke algorithm here
					String solutionToTestCase = ""+computeFairAndSquareCount(strLine);
					
					// Prepare output string
					System.out.println("Case #" + activeTestCaseNumber + ": " + solutionToTestCase);
					output.append("Case #" + activeTestCaseNumber + ": " + solutionToTestCase);
					output.append("\n");
				}
				lineNumber++;
			}
			
			in.close();
			
			// Pass output string to method to write to file
			File outputFile = new File("src/com/anuragkapur/jam2013/qr/C-small-attempt0.output");
			String filePath = outputFile.getAbsolutePath();
			writeOutputToFile(output.toString(), filePath);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			// File read cleanup
		}
	}
}
