package com.anuragkapur.jam2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author anuragkapur
 *
 */
public class TicTacToeTomek {

	private static String computeGameState(List<String> boardLines) {
		System.out.println("============");
		char board[][] = new char[4][4];
		int row = 0;
		int column = 0;
		
		String result = "Draw";
		
		for (Iterator<String> iterator = boardLines.iterator(); iterator.hasNext();) {
			String string = (String) iterator.next();
			board[row++] = string.toCharArray();
		}
		
		// check rows
		boolean resultFound = true;
		for (int i = 0; i < 4; i++) {
			char possibleWinner = 'T';
			int matchesCount = 0;
			for(int j = 0; j < 4; j++) {
				resultFound = true;
				if(possibleWinner == 'T') {
					if(board[i][j] == 'X' || board[i][j] == 'O') {
						possibleWinner = board[i][j];
					}
				}else {
					if(board[i][j] == 'X' || board[i][j] == 'O') {
						if(possibleWinner == board[i][j]) {
							matchesCount ++;
						}else {
							resultFound = false;
							break;
						}
					}else{
						if(board[i][j] != 'T') {
							resultFound = false;
							break;
						}
					}
				}
			}
			if(resultFound && matchesCount >= 2) {
				System.out.println("Row");
				result = String.valueOf(possibleWinner) + " won";
				return result;
			}
		}
		
		// check columns
		resultFound = true;
		for (int i = 0; i < 4; i++) {
			char possibleWinner = 'T';
			int matchesCount = 0;
			for(int j = 0; j < 4; j++) {
				resultFound = true;
				if(possibleWinner == 'T') {
					if(board[j][i] == 'X' || board[j][i] == 'O') {
						possibleWinner = board[j][i];
					}
				}else {
					if(board[j][i] == 'X' || board[j][i] == 'O') {
						if(possibleWinner == board[j][i]) {
							matchesCount ++;
						}else {
							resultFound = false;
							break;
						}
					}else{
						if(board[j][i] != 'T') {
							resultFound = false;
							break;
						}
					}
				}
			}
			if(resultFound && matchesCount >= 2) {
				System.out.println("Column");
				result = String.valueOf(possibleWinner) + " won";
				return result;
			}
		}
		
		//check diagonal1
		resultFound = true;
		int matchesCount = 0;
		char possibleWinner = 'T';
		for (int i = 0; i < 4; i++) {
			if(possibleWinner == 'T') {
				if(board[i][i] == 'X' || board[i][i] == 'O') {
					possibleWinner = board[i][i];
				}
			}else {
				if(board[i][i] == 'X' || board[i][i] == 'O') {
					if(possibleWinner == board[i][i]) {
						matchesCount ++;
					}else {
						resultFound = false;
						break;
					}
				}else{
					if(board[i][i] != 'T') {
						resultFound = false;
						break;
					}
				}
			}
		}
		if(resultFound && matchesCount >= 2) {
			System.out.println("Diagnoal 1");
			result = String.valueOf(possibleWinner) + " won";
			return result;
		}
		
		//check diagonal2
		resultFound = true;
		matchesCount = 0;
		possibleWinner = 'T';
		for (int i = 0; i < 4; i++) {
			char toTry = board[i][3-i];
			System.out.println("Trying char :: " + toTry);
			if(possibleWinner == 'T') {
				if(toTry == 'X' || toTry == 'O') {
					possibleWinner = toTry;
				}
			}else {
				if(toTry == 'X' || toTry == 'O') {
					if(possibleWinner == toTry) {
						matchesCount ++;
					}else {
						resultFound = false;
						break;
					}
				}else{
					if(toTry != 'T') {
						resultFound = false;
						break;
					}
				}
			}
		}
		if(resultFound && matchesCount >= 2) {
			System.out.println("Diagnoal 2");
			result = String.valueOf(possibleWinner) + " won";
			return result;
		}
		
		// check for incomplete game
		for (int i = 0; i < 4; i++) {
			for(int j = 0; j < 4; j++) {
				if(board[i][j] == '.') {
					result = "Game has not completed";
					return result;
				}	
			}
		}
		
		return result;
	}
	
	private static void writeOutputToFile(String output, String filepath)
			throws IOException {
		
		FileWriter fstream = new FileWriter(filepath);
		BufferedWriter out = new BufferedWriter(fstream);
		out.write(output);
		out.flush();
		out.close();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		File inputFile = new File("src/com/anuragkapur/jam2013/A-small-attempt0.in");
		String inputFilePath = inputFile.getAbsolutePath();
		
		try {
			// String buffer for storing the output
			StringBuffer output = new StringBuffer();
			
			// read and parse input file
			FileInputStream fstream = new FileInputStream(inputFilePath);
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			String strLine;

			int lineNumber = 1;
			int noOfTestCases = -1;
			int activeTestCaseNumber = 0;
			
			List<String> boardLines = null;
			
			while ((strLine = br.readLine()) != null) {
				
				if (lineNumber == 1) {
					noOfTestCases = Integer.parseInt(strLine);
				} else {
					noOfTestCases ++;
					
					if(lineNumber % 5 == 2){
						boardLines = new ArrayList<String>();
						boardLines.add(strLine);
					}else if(lineNumber % 5 != 1) {
						boardLines.add(strLine);
					}else if(lineNumber % 5 == 1) {
						// Now that a test case has been parsed, compute output for
						// this test case
						activeTestCaseNumber ++;
						
						// Invoke algorithm here
						String solutionToTestCase = computeGameState(boardLines);
						
						// Prepare output string
						//System.out.println("Case #" + activeTestCaseNumber + ": " + solutionToTestCase);
						output.append("Case #" + activeTestCaseNumber + ": " + solutionToTestCase);
						output.append("\n");
					}
				}
				
				lineNumber++;
			}
			
			in.close();
			
			// Pass output string to method to write to file
			File outputFile = new File("src/com/anuragkapur/jam2013/A-small-attempt0.output");
			String filePath = outputFile.getAbsolutePath();
			writeOutputToFile(output.toString(), filePath);
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			// File read cleanup
		}
	}
}