import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TheRepeater {

	public static void main(String[] args) throws IOException {
		File inputFile = new File("F:\\CodeJam\\TheRepeater\\A-small-attempt1.in");
		File outputFile = new File("F:\\CodeJam\\TheRepeater\\A-small-attempt1.out");
		//File inputFile = new File("F:\\CodeJam\\TheRepeater\\Test.in");
		//File outputFile = new File("F:\\CodeJam\\TheRepeater\\Test.out");
		BufferedReader reader = new BufferedReader(new FileReader(inputFile));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
		int noOfTestCases = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= noOfTestCases; i++) {
			int noOfLines = Integer.parseInt(reader.readLine());
			String[] lines = new String[noOfLines];
			for (int j = 0; j < noOfLines; j++) {
				lines[j] = reader.readLine();
			}
			int minimumActions = getMinimumSteps(lines);
			String line = "Case #" + i + ": " + (minimumActions > -1 ? minimumActions : "Fegla Won") + "\n";
			writer.write(line);
		}
		reader.close();
		writer.close();
	}

	private static int getMinimumSteps(String[] lines) {
		int minimumActions = 0;
		CharacterNode[] charArray = new CharacterNode[lines.length];
		int listLength = 0;
		for (int i = 0; i < lines.length; i++) {
			CharacterNode currentList = charArray[i];
			int currentListLength = 0;
			for (int j = 0; j < lines[i].length(); j++) {
				if (currentList == null) {
					charArray[i] = new CharacterNode();
					charArray[i].character = lines[i].charAt(j);
					charArray[i].count = 1;
					charArray[i].next = currentList;
					currentList = charArray[i];
					currentListLength++;
				} else {
					if (currentList.character == lines[i].charAt(j)) {
						currentList.count++;
					} else {
						currentList.next = new CharacterNode();
						currentList = currentList.next;
						currentList.character = lines[i].charAt(j);
						currentList.count = 1;
						currentList.next = null;
						currentListLength++;
					}
				}
			}
			if (listLength == 0) {
				listLength = currentListLength;
			} else {
				if (listLength != currentListLength) {
					return -1;
				}
			}
		}

		CharacterNode[] currentPtrs = new CharacterNode[lines.length];
		for (int i = 0; i < lines.length; i++) {
			currentPtrs[i] = charArray[i];
		}
		char currentChar = currentPtrs[0].character;

		for (int i = 0; i < listLength; i++) {
			int minChars = -1;
			for (int j = 0; j < lines.length; j++) {
				if(currentChar != currentPtrs[j].character) {
					return -1;
				}
				if (minChars == -1) {
					minChars = currentPtrs[j].count;
				} else if (minChars > currentPtrs[j].count) {
					minChars = currentPtrs[j].count;
				}
			}
			for (int j = 0; j < lines.length; j++) {
				minimumActions += currentPtrs[j].count - minChars;
			}
			for (int j = 0; j < lines.length; j++) {
				currentPtrs[j] = currentPtrs[j].next;
			}
			if(currentPtrs[0] != null){
				currentChar = currentPtrs[0].character;
			}
		}

		return minimumActions;
	}
}

class CharacterNode {
	char character;
	int count;
	CharacterNode next;
}