import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class InfiniteHouseOfPancakes {

	public static void main(String[] args) throws IOException {
		int[] minTimeArray = computeMinTimeArrayForPancakes(9);
		File inputFile = new File("/Users/anurag.gupta/CodeJam/Prob2/B-small-attempt0.in");
		File outputFile = new File("/Users/anurag.gupta/CodeJam/Prob2/B-small-attempt0.out");
		BufferedReader reader = new BufferedReader(new FileReader(inputFile));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
		int noOfTestCases = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= noOfTestCases; i++) {
			int minTime = 0;
			int noOfDiners = Integer.parseInt(reader.readLine().trim());
			int[] pancakesOnPlate = new int[noOfDiners];
			String[] pancakeString = reader.readLine().split(" ");
			for (int j = 0; j < noOfDiners; j++) {
				pancakesOnPlate[j] = Integer.parseInt(pancakeString[j].trim());
				if (minTime < minTimeArray[pancakesOnPlate[j]]) {
					minTime = minTimeArray[pancakesOnPlate[j]];
				}
			}
			String line = "Case #" + i + ": " + minTime + "\n";
			writer.write(line);
		}
		reader.close();
		writer.close();
	}

	private static int[] computeMinTimeArrayForPancakes(int maxCount) {
		int[] timeArray = new int[maxCount + 1];
		timeArray[0] = 0;
		timeArray[1] = 1;
		timeArray[2] = 2;
		for (int i = 3; i <= maxCount; i++) {
			int minTime = i;
			for (int j = 1; j <= i / 2; j++) {
				int currentTime = 0;
				if (timeArray[i - j] > timeArray[j]) {
					currentTime = timeArray[i - j] + 1;
				} else {
					currentTime = timeArray[j] + 1;
				}
				if (currentTime < minTime) {
					minTime = currentTime;
				}
			}
			timeArray[i] = minTime;
		}
		return timeArray;
	}

}
