import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class CookieClickerAlpha {
	
	public static void main(String[] args) throws IOException {
		File inputFile = new File("F:\\CodeJam\\CookieClicker\\B-small-attempt0.in");
		File outputFile = new File("F:\\CodeJam\\CookieClicker\\B-small-attempt0.out");
		BufferedReader reader = new BufferedReader(new FileReader(inputFile));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
		int noOfTestCases = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= noOfTestCases; i++) {
			String[] input = reader.readLine().split(" ");
			double minimumTimeTaken = getMinimumTime(input); 				
			String line = "Case #" + i + ": " + String.format("%.7f", minimumTimeTaken) + "\n";
			writer.write(line);
		}
		reader.close();
		writer.close();
	}

	private static double getMinimumTime(String[] input) {
		double cookie = Double.parseDouble(input[0]);
		double rateIncrement = Double.parseDouble(input[1]);
		double target = Double.parseDouble(input[2]);
		double timeConsumed = 0.0;
		double currentRate = 2.0;
		double timeDirect = 0.0;
		double timeWithFarmPurchase = 0.0;
		double timeFarmPurchase = 0.0;
		
		while(true){
			timeDirect = target / currentRate;
			timeFarmPurchase = cookie / currentRate;
			timeWithFarmPurchase = timeFarmPurchase + (target / (currentRate + rateIncrement));
			
			if(timeWithFarmPurchase < timeDirect) {
				timeConsumed += timeFarmPurchase;
				currentRate += rateIncrement;
			} else {
				timeConsumed += timeDirect;
				break;
			}
		}
		
		return timeConsumed;
	}

}
