import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;


public class DeceitfulWar {
	
	public static void main(String[] args) throws IOException {
		File inputFile = new File("F:\\CodeJam\\DeceitfulWar\\D-large.in");
		File outputFile = new File("F:\\CodeJam\\DeceitfulWar\\D-large.out");
		BufferedReader reader = new BufferedReader(new FileReader(inputFile));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
		int noOfTestCases = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= noOfTestCases; i++) {
			int noOfBlocks = Integer.parseInt(reader.readLine());
			double[] naomiBlocks = new double[noOfBlocks];
			double[] kenBlocks = new double[noOfBlocks];
			String[] naomiBlockWeightsInString = reader.readLine().split(" ");
			String[] kenBlockWeightsInString = reader.readLine().split(" ");
			for(int j=0; j<noOfBlocks; j++){
				naomiBlocks[j] = Double.parseDouble(naomiBlockWeightsInString[j]);
				kenBlocks[j] = Double.parseDouble(kenBlockWeightsInString[j]);
			}
			Arrays.sort(naomiBlocks);
			Arrays.sort(kenBlocks);
			int[] maxPoints = ComputePointsBothWays(naomiBlocks, kenBlocks); 
			String line = "Case #" + i + ": " + maxPoints[0] + " " + maxPoints[1] + "\n";
			writer.write(line);
		}
		reader.close();
		writer.close();
	}

	private static int[] ComputePointsBothWays(double[] naomiBlocks, double[] kenBlocks) {
		int[] result = new int[2];
		result[0] = 0;
		result[1] = 0;
		int kenPtr = 0;
		//Compute Deceitful Game Points for Naomi
		for(int i=0; i<naomiBlocks.length; i++) {
			if(naomiBlocks[i] > kenBlocks[kenPtr]) {
				result[0]++;
				kenPtr++;
			}
		}
		kenPtr = naomiBlocks.length - 1;
		//Compute Fair Game Points for Naomi
		for(int i=naomiBlocks.length -1 ; i>=0; i--) {
			if(naomiBlocks[i] > kenBlocks[kenPtr]) {
				result[1]++;
			} else {
				kenPtr--;
			}
		}
		return result;
	}

}