import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.StringTokenizer;
import java.util.TreeMap;

public class Trains {
	static int ID = 0;
	static InputStreamReader converter = new InputStreamReader(System.in);
	static BufferedReader in = new BufferedReader(converter);
	static int turnAroundTime;
	// static TreeMap<Train, Long> Trains;
	static TreeMap<Trip, Long> StationA;
	static TreeMap<Trip, Long> StationB;
	static TreeMap<MyLong, Long> avalaiblesA;
	static TreeMap<MyLong, Long> avalaiblesB;
	static int numTrainsA = 0;
	static int numTrainsB = 0;
	static int numTrains = 0;

	static long getMilisOfMinutes(int minutes) {
		return minutes * 60000;
	}
	
	static int IDM = 0;

	static class MyLong implements Comparable<MyLong> {

		int id;
		long value;

		MyLong(long val) {
			id = IDM++;
			value = val;
		}

		@Override
		public String toString() {
			// TODO Auto-generated method stub
			return "" + value;
		}

		@Override
		public int compareTo(MyLong o) {
			if (value < o.value)
				return -1;
			else if (value > o.value)
				return 1;

			if (id < o.id)
				return -1;
			else if (id > o.id)
				return 1;
			return 0;
		}

	}

	static class Trip implements Comparable<Trip> {

		Fecha dept;
		Fecha arr;
		String fStation;
		boolean taked = false;

		int id;

		// TODO Auto-generated method stub
		Trip(Fecha dep, Fecha arr, String station) {
			this.dept = dep;
			this.arr = arr;
			this.fStation = station;
			this.id = ID++;
		}

		long duration() {
			return this.arr.getTime() - this.dept.getTime();
		}

		@Override
		public int compareTo(Trip o) {

			if (this.dept.getTime() < o.dept.getTime())
				return -1;
			else if (this.dept.getTime() > o.dept.getTime())
				return 1;

			long a = this.duration();
			long b = o.duration();
			// System.out.println(a + " " + b);
			if (a < b)
				return -1;
			else if (a > b)
				return 1;

			if (this.id > o.id)
				return 1;
			else if (this.id < o.id)
				return -1;
			else
				return 0;
		}

		@Override
		public boolean equals(Object obj) {
			return ((Trip) obj).id == this.id;
		}
	}

	static Trip getBestFirst() {

		TreeMap<Trip, Long> theBest = new TreeMap<Trip, Long>();
		Trip temp = null;
		if (!StationA.isEmpty())
			theBest.put(StationA.firstKey(), 0l);
		if (!StationB.isEmpty())
			theBest.put(StationB.firstKey(), 0l);
		temp = theBest.firstKey();
		try {
			StationA.remove(temp);
		} catch (Exception e) {
		}
		try {
			StationB.remove(temp);
		} catch (Exception e) {
		}
		if (temp.fStation.equals("B")) {
			if (!avalaiblesA.isEmpty() &&avalaiblesA.firstKey().value <= temp.dept.getTime()) {
				avalaiblesA.remove(avalaiblesA.firstKey());
			}
			else numTrainsA++;			
			avalaiblesB.put(new MyLong(temp.arr.getTime()
					+ getMilisOfMinutes(turnAroundTime)), 0L);
		} else {
			
			if (!avalaiblesB.isEmpty() &&avalaiblesB.firstKey().value <= temp.dept.getTime()) {
				avalaiblesB.remove(avalaiblesB.firstKey());
			}
			else numTrainsB++;
			avalaiblesA.put(new MyLong(temp.arr.getTime()
					+ getMilisOfMinutes(turnAroundTime)), 0L);
		}

		return temp;
	}

	public static void main(String[] args) {
		int num = 0;

		try {
			if (args.length > 0) {
				converter = new InputStreamReader(new FileInputStream(args[0]));
				in = new BufferedReader(converter);
			}
			StringTokenizer st = null;
			Fecha dept = null, arr = null;
			num = new Integer(in.readLine());
			int NA, NB;
			for (int i = 0; i < num; i++) {
				// Trains = new TreeMap<Train, Long>();
				StationA = new TreeMap<Trip, Long>();
				StationB = new TreeMap<Trip, Long>();
				avalaiblesA = new TreeMap<MyLong, Long>();
				avalaiblesB = new TreeMap<MyLong, Long>();
				turnAroundTime = new Integer(in.readLine());

				st = new StringTokenizer(in.readLine());
				NA = new Integer(st.nextToken());

				NB = new Integer(st.nextToken());
				for (int j = 0; j < NA; j++) {
					st = new StringTokenizer(in.readLine());
					dept = new Fecha(st.nextToken());
					arr = new Fecha(st.nextToken());
					StationA.put(new Trip(dept, arr, "B"), 0l);
				}
				for (int j = 0; j < NB; j++) {
					st = new StringTokenizer(in.readLine());
					dept = new Fecha(st.nextToken());
					arr = new Fecha(st.nextToken());
					StationB.put(new Trip(dept, arr, "A"), 0l);
				}		
				numTrainsA = numTrainsB = 0;
				while (!StationA.isEmpty() || !StationB.isEmpty()) {
					// takeTrip(getBestFirst());
					getBestFirst();
				}
				System.out.println("Case #" + (i + 1) + ": " + numTrainsA + " "
						+ numTrainsB);

			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	static class Fecha implements Comparable<Fecha> {

		String fecha;

		Fecha(String s) {
			this.fecha = s;
		}

		@Override
		public String toString() {
			return fecha;
		}

		long getTime() {
			StringTokenizer st = new StringTokenizer(fecha, ":");
			return ((new Long(st.nextToken()) * 60) + new Long(st.nextToken())) * 60000;
		}

		@Override
		public int compareTo(Fecha o) {
			if (this.getTime() < o.getTime())
				return -1;
			if (this.getTime() < o.getTime())
				return -1;
			return 0;
		}
	}

}
