import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;


public class FairAndSquare {

	/**
	 * @param args
	 */
	static int iTestDataCount;
	static Map<Integer, Integer> mapTestIndexToResult = new HashMap<Integer, Integer>();
	static Map<Integer, Integer[]> mapTestIndexToData = new HashMap<Integer, Integer[]>();
	
	private static void readData()
	{
		String sFilePath  = "C:/Users/Rajan/Downloads/Anwar/Java Works/FairAndSquare/Input.txt";
		FileReader fileReader;
		try 
		{
		
			fileReader = new FileReader(sFilePath);
			BufferedReader buffReader = new BufferedReader(fileReader);
			iTestDataCount =  Integer.parseInt(buffReader.readLine());
			
			for(int iTestDataIndex = 0; iTestDataIndex < iTestDataCount; iTestDataIndex++)
			{
				Integer[] iTestDataForIndex = new Integer[2];
				String[] sTestData = buffReader.readLine().split(" ");
				iTestDataForIndex[0] = Integer.parseInt(sTestData[0]);
				iTestDataForIndex[1] = Integer.parseInt(sTestData[1]);
				
				mapTestIndexToData.put(iTestDataIndex, iTestDataForIndex);		
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		readData();
		findResults();
		writeResults();
		
	}
	
	private static void writeResults() {
		
		String sFilePath = "C:/Users/Rajan/Downloads/Anwar/Java Works/FairAndSquare/Output.txt";
		
		try 
		{
			File file = new File(sFilePath);
			file.createNewFile();
			FileWriter fileWriter = new FileWriter(sFilePath);
			BufferedWriter buffWriter = new BufferedWriter(fileWriter);
			
			for(int iTestIndex = 0; iTestIndex < iTestDataCount; iTestIndex++)
			{
				//String sTestResult = mapTestIndexToResult.get(iTestIndex);
				String sLineToWrite = "Case #" + (iTestIndex+1) + ": " + Integer.toString(mapTestIndexToResult.get(iTestIndex));
				buffWriter.write(sLineToWrite);
				buffWriter.newLine();
			}
			buffWriter.flush();
			buffWriter.close();
			
		}
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// TODO Auto-generated method stub		
	}


	private static void findResults() {
		// TODO Auto-generated method stub
		for(int iTestDataIndex = 0; iTestDataIndex < iTestDataCount; iTestDataIndex++)
		{
			Integer[] TestData = mapTestIndexToData.get(iTestDataIndex);
			
			int iMinNumber = (int) Math.ceil(Math.sqrt(TestData[0]));
			int iMaxNumber =  (int) Math.floor(Math.sqrt(TestData[1]));
			
			int iTestResult = 0;
			
			for(int iNumber = iMinNumber; iNumber <= iMaxNumber; iNumber++)
			{
				if(isNumberPalindrome(iNumber))
				{
					int iSquareOfNumber = iNumber * iNumber;
					if(isNumberPalindrome(iSquareOfNumber))
					{
						iTestResult++;
					}
				}
			}
			
			mapTestIndexToResult.put(iTestDataIndex, iTestResult);
		}
	}

	private static boolean isNumberPalindrome(int iNumber) {
		// TODO Auto-generated method stub
		boolean bIsNumberPalindrome = false;
		
		int iNumberToTest = iNumber;
		int iReversedNumber = 0;
		while(iNumberToTest != 0)
		{
			int iRemainder = iNumberToTest % 10;
			iReversedNumber = iReversedNumber * 10 + iRemainder;
			iNumberToTest = iNumberToTest / 10;
		}
		
		if(iReversedNumber == iNumber)
		{
			bIsNumberPalindrome = true;
		}
		
		return bIsNumberPalindrome;
	}

}
