import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;


public class Main {

	/**
	 * @param args
	 */
	static int m_iNumberOfTestCases;
	static Map<Integer, TestData> m_mapTestCaseIndexToTestData = new HashMap<Integer, TestData>();
	static Map <Integer, String> m_mapTestCaseIndexToResult = new HashMap<Integer, String>();
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		readFile("Input.in");
		
		for(int iTestCaseIndex = 0; iTestCaseIndex < m_iNumberOfTestCases; iTestCaseIndex++)
		{
			TestData testData = m_mapTestCaseIndexToTestData.get(iTestCaseIndex);
			String sName = testData.m_sName;
			int iNValue = testData.m_iNValue;
			int iResultNvalue = 0;
			
			for(int iCharIndex = 0; iCharIndex < (sName.length()-(iNValue - 1)); iCharIndex++)
			{
				for(int iCharEndIndex = iCharIndex + (iNValue); iCharEndIndex <= sName.length(); iCharEndIndex++)
				{
					String sNameSubString = sName.substring(iCharIndex, iCharEndIndex);
					if(validCosonatString(sNameSubString, iNValue))
					{
						iResultNvalue++;
					}
				}
			}
			m_mapTestCaseIndexToResult.put(iTestCaseIndex, Integer.toString(iResultNvalue));
			
			writeResult("Ouput.in");
		}
		
	}
	
	private static void writeResult(String sFileName) {
		// TODO Auto-generated method stub
		
		File file = new File(sFileName);
		try {
			FileWriter fileWriter = new FileWriter(file);
			for(int iTestCaseIndex = 0; iTestCaseIndex < m_iNumberOfTestCases; iTestCaseIndex++)
			{
				String sLineToWrite = "Case #" + (iTestCaseIndex+1) + ": " +m_mapTestCaseIndexToResult.get(iTestCaseIndex)+ " \n";
				fileWriter.write(sLineToWrite);
			}
			
			fileWriter.flush();
			fileWriter.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}

	private static boolean validCosonatString(String sNameSubString, int iNValue) {
		// TODO Auto-generated method stub
		boolean bIsValidConsonent = true;
		for(int iCharIndex = 0; iCharIndex < sNameSubString.length()-(iNValue-1); iCharIndex++)
		{
			bIsValidConsonent = true;
			for(int iChkCharIndex = iCharIndex; iChkCharIndex < (iCharIndex + iNValue); iChkCharIndex++)
			{
				if(sNameSubString.charAt(iChkCharIndex) == 'a' ||
						sNameSubString.charAt(iChkCharIndex) == 'e' ||
						sNameSubString.charAt(iChkCharIndex) == 'i' ||
						sNameSubString.charAt(iChkCharIndex) == 'o' ||
						sNameSubString.charAt(iChkCharIndex) == 'u')
				{
					bIsValidConsonent = false;
					break;
				}
			}
			if(bIsValidConsonent)
			{
				break;
			}
		}
		return bIsValidConsonent;
	}

	static void readFile(String sFileName)
	{
		FileReader fileReader;
		try {
			fileReader = new FileReader(sFileName);
			BufferedReader buffReader = new BufferedReader(fileReader);
			m_iNumberOfTestCases = Integer.parseInt(buffReader.readLine());
			
			for(int iTestCaseIndex = 0; iTestCaseIndex < m_iNumberOfTestCases; iTestCaseIndex++)
			{
				TestData testData = new TestData();
				String sTestData = buffReader.readLine();
				String [] TestData = sTestData.split(" ");
				
				testData.m_sName = TestData[0];
				testData.m_iNValue = Integer.parseInt(TestData[1]);
				
				m_mapTestCaseIndexToTestData.put(iTestCaseIndex, testData);
			}
			
			buffReader.close();
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}

}
