import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;


class LawnData{
	public int m_iRowCount;
	public int m_iColCount;
	public Integer[][] m_iLawnShape;
	
	public LawnData(int iRowCount, int iColCount, Integer[][] iLawnShape)
	{
		m_iRowCount = iRowCount;
		m_iColCount = iColCount;
		m_iLawnShape = iLawnShape;
	}
}

public class LawnMower {

	/**
	 * @param args
	 */
	static int iTestDataCount;
	static Map<Integer, LawnData> mapTestIndexToLawnData = new HashMap<Integer, LawnData>();
	static Map<Integer, String> mapTestIndexToResult = new HashMap<Integer, String>();
	
	private static void readTestData()
	{
		String sFilePath  = "C:/Users/Rajan/Downloads/Anwar/Java Works/LawnMower/Input.txt";
				
		FileReader fileReader;
		try 
		{
		
			fileReader = new FileReader(sFilePath);
			BufferedReader buffReader = new BufferedReader(fileReader);
			iTestDataCount =  Integer.parseInt(buffReader.readLine());
			
			for(int iTestDataIndex = 0; iTestDataIndex < iTestDataCount; iTestDataIndex++)
			{
				String[] sDataSize = new String[2];
				sDataSize = buffReader.readLine().split(" ");
				
				Integer[] iDataSize = new Integer[2];
				iDataSize[0] = Integer.parseInt(sDataSize[0]);
				iDataSize[1] = Integer.parseInt(sDataSize[1]);
				
				Integer[][] iData = new Integer[iDataSize[0]][iDataSize[1]];
				for(int iRowIndex = 0; iRowIndex < iDataSize[0]; iRowIndex++)
				{
					String[] sRowData = new String[iDataSize[1]];
					sRowData = buffReader.readLine().split(" ");
					
					for(int iColIndex = 0; iColIndex < iDataSize[1]; iColIndex++)
					{
						iData[iRowIndex][iColIndex] = Integer.parseInt(sRowData[iColIndex]);
					}
				}
				
				LawnData lawnData = new LawnData(iDataSize[0], iDataSize[1], iData);
				mapTestIndexToLawnData.put(iTestDataIndex, lawnData);
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) 
	{
		// TODO Auto-generated method stub
		readTestData();
		
		for(int iTestIndex = 0; iTestIndex < iTestDataCount; iTestIndex++)
		{
			LawnData lawnData = mapTestIndexToLawnData.get(iTestIndex);
			if(isPossibleToMow(lawnData))
			{
				//YES
				mapTestIndexToResult.put(iTestIndex, "YES");
			}
			else
			{
				//NO
				mapTestIndexToResult.put(iTestIndex, "NO");
			}
		}
		
		writeResults();
	}
	
	private static void writeResults() {
		
		String sFilePath = "C:/Users/Rajan/Downloads/Anwar/Java Works/LawnMower/Output.txt";
		
		try 
		{
			File file = new File(sFilePath);
			file.createNewFile();
			FileWriter fileWriter = new FileWriter(sFilePath);
			BufferedWriter buffWriter = new BufferedWriter(fileWriter);
			
			for(int iTestIndex = 0; iTestIndex < iTestDataCount; iTestIndex++)
			{
				//String sTestResult = mapTestIndexToResult.get(iTestIndex);
				String sLineToWrite = "Case #" + (iTestIndex+1) + ": " + mapTestIndexToResult.get(iTestIndex);
				buffWriter.write(sLineToWrite);
				buffWriter.newLine();
			}
			buffWriter.flush();
			buffWriter.close();
			
		}
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// TODO Auto-generated method stub
		
	}

	private static boolean isPossibleToMow(LawnData lawnData) {
		// TODO Auto-generated method stub
		boolean bIsPossibleMow = true;

		if(lawnData.m_iColCount == 1 || lawnData.m_iRowCount == 1 )
		{
			bIsPossibleMow = true;
		}
		else
		{
			for(int iRowIndex = 0; iRowIndex < lawnData.m_iRowCount; iRowIndex++)
			{
				for(int iColIndex = 0; iColIndex < lawnData.m_iColCount; iColIndex++)
				{
					int iHeightToCut = lawnData.m_iLawnShape[iRowIndex][iColIndex];

					// Check if Row Doesn't have more than required height
					boolean bColDoesMatch = true;
					boolean bRowDoesMatch = true;
					for(int iRowIndexToCheck = 0; iRowIndexToCheck < lawnData.m_iRowCount; iRowIndexToCheck++)
					{
						if(lawnData.m_iLawnShape[iRowIndexToCheck][iColIndex] > iHeightToCut)
						{
							bColDoesMatch = false;
							break;
						}
					}

					if(bColDoesMatch == false)
					{
						for(int iColIndexToCheck = 0; iColIndexToCheck < lawnData.m_iColCount; iColIndexToCheck++)
						{
							if(lawnData.m_iLawnShape[iRowIndex][iColIndexToCheck] > iHeightToCut)
							{
								bRowDoesMatch = false;
								break;
							}
						}							
					}
					if(bColDoesMatch == false && bRowDoesMatch == false)
					{
						bIsPossibleMow = false;
						return bIsPossibleMow;
					}
				}
			}
		}
	return bIsPossibleMow;
	}

}
