import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;


public class TicTacToeTomek {

	/**
	 * @param args
	 */
	
	static int iTestDataCount;
	static Map<Integer, String> mapTestIndexToResult = new HashMap<Integer, String>();
	static int iBoardSize = 4;
	
	public static Map<Integer, String[]> readTestFile()
	{
		String sFilePath  = "C:/Users/Rajan/Downloads/Anwar/Java Works/TicTacToeTomek/A-small-attempt0.in";
		
		Map<Integer, String[]> mapTestIndexToData = new HashMap<Integer, String[]>();
		
		FileReader fileReader;
		try 
		{
		
			fileReader = new FileReader(sFilePath);
			BufferedReader buffReader = new BufferedReader(fileReader);
			iTestDataCount =  Integer.parseInt(buffReader.readLine());
			
			for(int iTestDataIndex = 0; iTestDataIndex < iTestDataCount; iTestDataIndex++)
			{
				String [] sTestDataForIndex = new String[4];
				for(int iRowIndex = 0; iRowIndex < 4; iRowIndex++)
				{
					sTestDataForIndex[iRowIndex] = buffReader.readLine();
				}
				mapTestIndexToData.put(iTestDataIndex, sTestDataForIndex);
				buffReader.readLine();
			}
			
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
		return mapTestIndexToData;
	}
	
	public static void main(String[] args) {
		// TODO Auto-generated method stub

		Map<Integer, String[]> mapTestIndexToData = new HashMap<Integer, String[]>();
		mapTestIndexToData = readTestFile();
		
		/*for(int iTestDataIndex = 0; iTestDataIndex < iTestDataCount; iTestDataIndex++)
		{
			String[] sTestData = mapTestIndexToData.get(iTestDataIndex);
			for(int iRowIndex = 0; iRowIndex < 4; iRowIndex++)
			{
				System.out.println(sTestData[iRowIndex]);
			}
			System.out.println(" ");
		}*/
		
		for(int iTestDataIndex = 0; iTestDataIndex < iTestDataCount; iTestDataIndex++)
		{
			String [] sTestData = mapTestIndexToData.get(iTestDataIndex);
			
			if(isXWon(sTestData))
			{
				mapTestIndexToResult.put(iTestDataIndex, "X won");
			}
			else if(isOWon(sTestData))
			{
				mapTestIndexToResult.put(iTestDataIndex, "O won");
			}
			else if(isGameIncomplete(sTestData))
			{
				mapTestIndexToResult.put(iTestDataIndex, "Game has not completed");
			}
			else
			{
				// Match Draw
				mapTestIndexToResult.put(iTestDataIndex, "Draw");
			}
		}
		
		writeResults();
	}

	private static void writeResults() {
		
		String sFilePath = "C:/Users/Rajan/Downloads/Anwar/Java Works/TicTacToeTomek/Output.txt";
		
		try 
		{
			File file = new File(sFilePath);
			file.createNewFile();
			FileWriter fileWriter = new FileWriter(sFilePath);
			BufferedWriter buffWriter = new BufferedWriter(fileWriter);
			
			for(int iTestIndex = 0; iTestIndex < iTestDataCount; iTestIndex++)
			{
				//String sTestResult = mapTestIndexToResult.get(iTestIndex);
				String sLineToWrite = "Case #" + (iTestIndex+1) + ": " + mapTestIndexToResult.get(iTestIndex);
				buffWriter.write(sLineToWrite);
				buffWriter.newLine();
			}
			buffWriter.flush();
			buffWriter.close();
			
		}
		catch (IOException e) 
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		// TODO Auto-generated method stub
		
	}

	private static boolean isOWon(String[] sTestData) {
		// TODO Auto-generated method stub
		boolean bIsOWon = false;
		
		// Check Row-wise
		for(int iRowIndex = 0; iRowIndex < iBoardSize; iRowIndex++)
		{
			if(sTestData[iRowIndex].contains("X") == false &&
					sTestData[iRowIndex].contains(".") == false)
			{
				bIsOWon = true;
				break;
			}
		}
		
		if(bIsOWon == false)
		{
			// Check col-wise
			for(int iColIndex = 0; iColIndex < iBoardSize; iColIndex++)
			{
				String sColumnData;
				char[] columnChars = new char[4];
				for(int iRowIndex = 0; iRowIndex < iBoardSize; iRowIndex++)
				{
					columnChars[iRowIndex] = sTestData[iRowIndex].charAt(iColIndex);
				}
				sColumnData = new String(columnChars);
				if(sColumnData.contains("X") == false &&
						sColumnData.contains(".") == false)
				{
					bIsOWon =  true;
					break;
				}
			}
		}
		
		if(bIsOWon == false)
		{
			// Check Diagonals
			char[] charFirstDiagonals = new char[4];
			for(int iRowIndex = 0; iRowIndex < 4; iRowIndex++)
			{
				charFirstDiagonals[iRowIndex] = sTestData[iRowIndex].charAt(iRowIndex);
			}
			String sFirstDiagonal = new String(charFirstDiagonals);
			if(sFirstDiagonal.contains("X") == false &&
					sFirstDiagonal.contains(".") == false)
			{
				bIsOWon = true;
			}
			else
			{
				char[] charSecondDiagonals = new char[4];
				charSecondDiagonals[0] = sTestData[3].charAt(0);
				charSecondDiagonals[1] = sTestData[2].charAt(1);
				charSecondDiagonals[2] = sTestData[1].charAt(2);
				charSecondDiagonals[3] = sTestData[0].charAt(3);
				String sSecondDiagonal = new String(charSecondDiagonals);
				if(sSecondDiagonal.contains("X") == false &&
						sSecondDiagonal.contains(".") == false)
				{
					bIsOWon = true;
				}
			}
		}
		
		return bIsOWon;
	}

	private static boolean isXWon(String[] sTestData) {
		// TODO Auto-generated method stub
		boolean bIsXWon = false;
		
		// Check Row-wise
		for(int iRowIndex = 0; iRowIndex < iBoardSize; iRowIndex++)
		{
			if((sTestData[iRowIndex].contains("O") == false) &&
			   (sTestData[iRowIndex].contains(".") == false))
			{
				bIsXWon = true;
				break;
			}
		}
		
		if(bIsXWon == false)
		{
			// Check col-wise
			for(int iColIndex = 0; iColIndex < iBoardSize; iColIndex++)
			{
				String sColumnData;
				char [] columnChars = new char [4];
				for(int iRowIndex = 0; iRowIndex < iBoardSize; iRowIndex++)
				{
					columnChars[iRowIndex] = sTestData[iRowIndex].charAt(iColIndex);
				}
				sColumnData = new String(columnChars);
				if((sColumnData.contains("O") == false) &&
				   (sColumnData.contains(".") == false))
				{
					bIsXWon =  true;
					break;
				}
			}
		}
		
		if(bIsXWon == false)
		{
			// Check Diagonals
			char[] charFirstDiagonals = new char[4];
			for(int iRowIndex = 0; iRowIndex < 4; iRowIndex++)
			{
				charFirstDiagonals[iRowIndex] = sTestData[iRowIndex].charAt(iRowIndex);
			}
			String sFirstDiagonal = new String(charFirstDiagonals);
			if((sFirstDiagonal.contains("O") == false) &&
			   (sFirstDiagonal.contains(".") == false))
			{
				bIsXWon = true;
			}
			else
			{
				char[] charSecondDiagonals = new char[4];
				charSecondDiagonals[0] = sTestData[3].charAt(0);
				charSecondDiagonals[1] = sTestData[2].charAt(1);
				charSecondDiagonals[2] = sTestData[1].charAt(2);
				charSecondDiagonals[3] = sTestData[0].charAt(3);
				String sSecondDiagonal = new String(charSecondDiagonals);
				if((sSecondDiagonal.contains("O") == false) &&
				   (sSecondDiagonal.contains(".") == false))
				{
					bIsXWon = true;
				}
			}
		}
		
		return bIsXWon;
	}

	private static boolean isGameIncomplete(String[] sTestData) {
		// TODO Auto-generated method stub
		boolean bIsGameIncomplete = false;
		
		for(int iRowIndex = 0; iRowIndex < iBoardSize; iRowIndex++)
		{
			if(sTestData[iRowIndex].contains("."))
			{
				bIsGameIncomplete = true;
				break;
			}	
		}
		return bIsGameIncomplete;
	}
}

