package code.y2017.qualA;
import java.io.*;
import java.util.StringTokenizer;

public class C {

    private static final String PATH = "y2017/qualA";

    private String solveTest() throws IOException {
        int N = nextInt();
        int Q = nextInt();

        // max distance of this horse
        int[] E = new int[N];

        // horse speed
        int[] S = new int[N];

        for (int i = 0; i < N; i++) {
            E[i] = nextInt();
            S[i] = nextInt();
        }

        int[][] D = new int[N][N];

        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                D[i][j] = nextInt();
            }
        }

        int[] U = new int[N];
        int[] V = new int[N];

        for (int i = 0; i < Q; i++) {
            U[i] = nextInt();
            V[i] = nextInt();
        }

        double[] times = new double[N];

        for (int i = 0; i < N; i++) {
            times[i] = Double.MAX_VALUE;
        }
        times[N-1] = 0;

        for (int i = N - 2; i >= 0; i--) {
            double maxHorseDistance = E[i];
            double maxHorseSpeed = S[i];

            int distanceTraveled = 0;
            int currentCityIndex = i;
            double bestTime = Double.MAX_VALUE;
            while (true) {
                currentCityIndex ++;

                if (currentCityIndex >= N) {
                    break;
                }
                distanceTraveled += D[currentCityIndex-1][currentCityIndex];

                if (distanceTraveled > maxHorseDistance || currentCityIndex >= N) {
                    break;
                }

                if (times[currentCityIndex] != Double.MAX_VALUE) {
                    double time = times[currentCityIndex] + (double)distanceTraveled/maxHorseSpeed;
                    bestTime = Math.min(bestTime, time);
                }
            }

            times[i] = bestTime;
        }

        return Double.toString(times[0]);
    }

    private void solve() throws IOException {
        int n = nextInt();
        for (int i = 0; i < n; i++) {
            String res = solveTest();
            System.out.println("Case #" + (i + 1) + ": " + res);
            out.println("Case #" + (i + 1) + ": " + res);
        }
    }


    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws FileNotFoundException {
        new C().run();
    }

    private void run() throws FileNotFoundException {
        br = new BufferedReader(new FileReader("src/resources/" + PATH + "/" + this.getClass().getSimpleName() + ".in"));
        out = new PrintWriter(this.getClass().getSimpleName().substring(0, 1) + ".out");
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
        out.close();
    }

}
