package code.y2017.qualA;

import java.io.*;
import java.util.Scanner;

public class A2 {
    public static void main(String[] args) throws IOException {
        Scanner lineScan = null;
        int size;
        File output = new File("output.txt");
        PrintWriter printer = new PrintWriter(output);
        Scanner s = new Scanner(new BufferedReader(new FileReader("input.txt")));
        size = s.nextInt();
        s.nextLine();
        for (int i = 0; i < size; i++) {
            String line = s.nextLine();
            lineScan = new Scanner(line);
            final int number = lineScan.nextInt();
            final int red = lineScan.nextInt();
            final int orange = lineScan.nextInt();
            final int yellow = lineScan.nextInt();
            final int green = lineScan.nextInt();
            final int blue = lineScan.nextInt();
            final int violet = lineScan.nextInt();
            int[] colors = new int[6];
            boolean success = true;
            colors[0] = orange;
            colors[1] = green;
            colors[2] = violet;
            colors[3] = red;
            colors[4] = yellow;
            colors[5] = blue;
            int[] results = new int[number];
            results[0] = pickColor(-1, colors);
            colors[results[0]] -= 1;
            for (int j = 1; j < number; j++) {
                results[j] = pickColor(results[j - 1], colors);
                if (results[j] == -1) {
                    success = false;
                    break;
                }
                colors[results[j]] -= 1;
            }
            printer.print("Case #" + (i + 1) + ": ");
            if (!success || isColorMatch(results[0], results[number - 1])) {
                printer.println("IMPOSSIBLE");
            } else {
                printer.println(makePretty(results));
            }
        }
        printer.close ();
    }

    private static int pickColor(final int lastColor, final int[] colors) {
        int highestValue = 0;
        int highestColor = -1;
        for (int i = 0; i < 6; i++) {
            if (!isColorMatch(lastColor, i) && (colors[i] > highestValue)) {
                highestValue = colors[i];
                highestColor = i;
            }
        }
        return highestColor;
    }

    private static String makePretty(int[] results) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < results.length; i++) {
            if (results[i] == 0) {
                sb.append("O");
            } else if (results[i] == 1) {
                sb.append("G");
            } else if (results[i] == 2) {
                sb.append("V");
            } else if (results[i] == 3) {
                sb.append("R");
            } else if (results[i] == 4) {
                sb.append("Y");
            } else if (results[i] == 5) {
                sb.append("B");
            }
        }
        return sb.toString();
    }

    private static boolean isColorMatch(final int firstColor, final int secondColor) {
        if (firstColor == secondColor) {
            return true;
        }
        if ((firstColor == 0) && ((secondColor == 3) || (secondColor == 4))) {
            return true;
        }
        if ((firstColor == 1) && ((secondColor == 4) || (secondColor == 5))) {
            return true;
        }
        if ((firstColor == 2) && ((secondColor == 3) || (secondColor == 5))) {
            return true;
        }
        if ((firstColor == 3) && ((secondColor == 0) || (secondColor == 2))) {
            return true;
        }
        if ((firstColor == 4) && ((secondColor == 0) || (secondColor == 1))) {
            return true;
        }
        return ((firstColor == 5) && ((secondColor == 1) || secondColor == 2));
    }
}
