
import java.io.*;

public class SnapperChain {

	private static final String PROBLEM = "A-small-attempt1";
	
	public static void main(String [] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(PROBLEM + ".in"));
		BufferedWriter out = new BufferedWriter(new PrintWriter(PROBLEM + ".out"));
		
		int T = Integer.parseInt(in.readLine());
		for (int i = 0; i < T; i++) {
			String[] line = in.readLine().split(" ");
			int N = Integer.parseInt(line[0]);
			int K = Integer.parseInt(line[1]);
			
			boolean lightOn = isLightOn(N, K);
			out.write("Case #" + (i+1) + ": "  + (lightOn ? "ON" : "OFF") + "\n");
		}
		out.close();
	}

	private static boolean isLightOn(int numSnappers, int numSnaps) {
		boolean snapperState[] = new boolean[numSnappers];
		int powerLength = 0;
		
		for (int snap = 0; snap < numSnaps; snap++) {
			//System.out.print("Before snap " +  (snap+1) +  "/" + numSnaps + ": ");
			//printChain(snapperPower, snapperState);
			for (int snapper = 0; snapper <= powerLength; snapper++) {
				if (snapper <= powerLength) {
					snapperState[snapper] = !snapperState[snapper];
				}
			}
			
			int newPowerLength = 0;
			while (newPowerLength < numSnappers && snapperState[newPowerLength++]);
			powerLength = newPowerLength - 1;
		}
		
		//System.out.print("In the end:      ");
		//printChain(snapperPower, snapperState);
		return snapperState[numSnappers-1] && (powerLength == numSnappers - 1);
	}
	
	public static void printChain(boolean[] snapperPower, boolean[] snapperState) {
		// Display the chain
		for (int i = 0; i < snapperPower.length; i++) {
			System.out.print("["+ (snapperPower[i] ? "1":"0") + "/" + (snapperState[i] ? "1" : "0") + "]:");
		}
		System.out.println("");
	}
}
