import java.io.*;
import java.util.*;

public class ThemePark {
	private static final String PROBLEM = "C-small-attempt0";

	public static void main(String [] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(PROBLEM + ".in"));
		BufferedWriter out = new BufferedWriter(new PrintWriter(PROBLEM + ".out"));
		
		int T = Integer.parseInt(in.readLine());
		for (int i = 0; i < T; i++) {
			String[] line1 = in.readLine().split(" ");
			String[] line2 = in.readLine().split(" ");
			
			int R = Integer.parseInt(line1[0]);
			int k = Integer.parseInt(line1[1]);
			int N = Integer.parseInt(line1[2]);
			
			int[] groups = new int[N];
			for (int g = 0; g < N; g++) {
				groups[g] = Integer.parseInt(line2[g]);
			}
			System.out.println("Case #" + (i+1) + ": " + calculateProfit(R, k, N, groups));
			out.write("Case #" + (i+1) + ": " + calculateProfit(R, k, N, groups) + "\n");
		}
		
		out.close();
	}

	private static int calculateProfit(int R, int k, int N, int[] groups) {
		Queue<Integer> queue = new LinkedList<Integer>();
		Queue<Integer> coaster = new LinkedList<Integer>();
		for (int i = 0; i < N; i++) { queue.add(groups[i]); }
		int money = 0;
		
		for (int run = 0; run < R; run++) {
			int coasterCapacity = k;
			
			// Load up coaster
			while (!queue.isEmpty() && (coasterCapacity - queue.peek() >= 0)) {
				coasterCapacity -= queue.peek();
				money += queue.peek();
				coaster.add(queue.poll());
			}
			// Yaaaaay roller coaster!
			
			// Back in line
			while (!coaster.isEmpty()) { queue.add(coaster.poll()); }
		}
		
		return money;
	}
	
}
