import java.util.*;
import java.io.*;

public class Rotate implements Runnable {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new Thread(new Rotate()).start();
	}

	public int[][] RotateAction(int N, int[][] box) {
		int[][] out = new int[N][N];

		int[] offset = new int[N];
		int change;
		for (int i = 0; i < N; i++) {
			change = 0;
			for (int j = N - 1; j >= 0; j--) {
				if (box[i][j] == 0)
					change++;

				offset[j] = change;
			}

			for (int j = N - 1; j >= 0; j--) {
				if (box[i][j] != 0) {
					box[i][j + offset[j]] = box[i][j];
					
					if(offset[j]!=0)
						box[i][j] = 0;
				}
			}
		}
		
		// box is to the rightmost
		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				out[j][N - 1 - i] = box[i][j];
			}
		}

		return out;
	}

	public boolean[] Verification(int[][] box, int N, int K) {
		boolean[] result = new boolean[2];
		result[0] = false;
		result[1] = false;

		for (int i = 0; i < N; i++) {
			for (int j = 0; j < N; j++) {
				if (box[i][j] == 0)
					continue;

				else {
					int color = box[i][j];

					if (result[color - 1] != true) {
						// horizontal
						boolean isHorizontal = true;
						if (j + K - 1 <= N - 1) {
							for (int m = j; m <= j + K - 1; m++) {
								if (box[i][m] != color)
									isHorizontal = false;
							}
							if (isHorizontal == true) {
								result[color - 1] = true;
							}
						}

						boolean isVertical = true;
						if (i + K - 1 <= N - 1) {
							for (int m = i; m <= i + K - 1; m++) {
								if (box[m][j] != color)
									isVertical = false;
							}
							if (isVertical == true)
								result[color - 1] = true;
						}

						boolean isLeft = true;
						if((i + K - 1 <= N - 1) && (j - (K - 1) >= 0)) {
							int n = j;
							for (int m = i; m <= i + K - 1; m++) {
								if (box[m][n] != color)
									isLeft = false;
								n--;
							}
							if (isLeft == true)
								result[color - 1] = true;
						}
						
						boolean isRight = true;
						if((i + K - 1 <= N - 1) && (j + (K - 1) <= N-1)) {
							int n = j;
							for (int m = i; m <= i + K - 1; m++) {
								if (box[m][n] != color)
									isRight = false;
								n++;
							}
							if (isRight == true)
								result[color - 1] = true;
						}
					}
				}
			}
		}

		return result;
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		try {
			BufferedReader br = new BufferedReader(new FileReader("A-small-attempt0.in"));

			BufferedWriter bw = new BufferedWriter(new FileWriter("small.out"));
			int nbCase = Integer.parseInt(br.readLine());

			for (int i = 0; i < nbCase; i++) {
				String line = br.readLine();
				String[] splitLine = line.split(" ");
				int N = Integer.parseInt(splitLine[0]);
				int K = Integer.parseInt(splitLine[1]);

				// 0 is dot, 1 is blue, 2 is red
				int[][] box = new int[N][N];
				for (int j = 0; j < N; j++) {
					String row = br.readLine();
					for (int k = 0; k < N; k++) {
						if (row.charAt(k) == '.')
							box[j][k] = 0;
						else if (row.charAt(k) == 'B')
							box[j][k] = 1;
						else if (row.charAt(k) == 'R')
							box[j][k] = 2;
					}
				}

				// box is done
				int[][] rotateBox =  RotateAction(N, box);
				

				for(int m=0; m<N; m++) {
					for(int n=0; n<N; n++)
						System.out.print(rotateBox[m][n]);
					System.out.println();
				}
				
				
				boolean[] results = Verification(rotateBox, N, K);
				
				if(results[0] == false && results[1] == false) 
					bw.write("Case #" + (i + 1) + ": Neither\n");
				else if(results[0] == true && results[1] == false) 
					bw.write("Case #" + (i + 1) + ": Blue\n");
				else if(results[0] == false && results[1] == true) 
					bw.write("Case #" + (i + 1) + ": Red\n");
				else if(results[0] == true && results[1] == true) 
					bw.write("Case #" + (i + 1) + ": Both\n");

				bw.flush();

				System.out.println("case " + i);
			}

			br.close();
			bw.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
