import java.util.*;
import java.io.*;

public class FileFixIt implements Runnable {
	public FileFixIt() {
		root = new File("root");
	}
	
	class File {
		public String name;
		public ArrayList<File> children;

		File(String nameIn) {
			name = nameIn;
			children = new ArrayList<File>();
		}
	}

	public File root;
	
	public int times = 0;

	public void Insert(Vector<String> input) {
		File temp = root;
		for (int i = 0; i < input.size(); i++) {
			int childIndex;
			if ((childIndex = Match(input.get(i), temp.children)) >= 0) {
				temp = temp.children.get(childIndex);
				continue;
			} else {
				times++;
				File file = new File(input.get(i));
				temp.children.add(file);
				temp = temp.children.get(temp.children.size()-1);
			}
		}
	}

	public int Match(String input, ArrayList<File> children) {
		for (int i = 0; i < children.size(); i++) {
			if (children.get(i).name.compareTo(input) == 0)
				return i;
		}

		return -1;
	}

	public Vector<String> Parse(String dir) {
		Vector<String> val = new Vector<String>();
		
		String[] dirs = dir.split("/");
		
		for(int i=1; i<dirs.length; i++) {
			val.add(dirs[i]);
		}
		return val;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		new Thread(new FileFixIt()).start();
	}

	@Override
	public void run() {
		// TODO Auto-generated method stub
		try {
			BufferedReader br = new BufferedReader(new FileReader("A-small-attempt2.in"));

			BufferedWriter bw = new BufferedWriter(new FileWriter("small.out"));
			int nbCase = Integer.parseInt(br.readLine());

			for (int i = 0; i < nbCase; i++) {
				root.children.clear();
				this.times = 0;
				String line = br.readLine();
				String[] lines = line.split(" ");
				int N = Integer.parseInt(lines[0]);
				int M = Integer.parseInt(lines[1]);
				
				for(int j=0; j<N; j++) {
					line = br.readLine();
					Vector<String> parsed = this.Parse(line);
					this.Insert(parsed);
				}
				
				int pre = this.times;
//				
				for(int j=0; j<M; j++) {
					line = br.readLine();
					Vector<String> parsed = this.Parse(line);
					this.Insert(parsed);
				}
				
				int post = this.times;
				
				System.out.println(post-pre);
				bw.write("Case #" + (i + 1) + ": " + (post-pre) + "\n");

				bw.flush();

				System.out.println("case " + i);
			}

			br.close();
			bw.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
