import java.io.*;
import java.util.*;

public class b {
    private static StringTokenizer st;
    private static BufferedReader br;
    public static long MOD = 1000000007;

    public static void print(Object x) {
        System.out.println(x + "");
    }
    public static String join(List<?> x, String space) {
        StringBuilder sb = new StringBuilder();
        for (Object elt : x) {
            sb.append(elt);
            sb.append(space);
        }
        return sb.toString();
    }

    public static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine().trim());
        }
        return st.nextToken();
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static List<Double> nextDoubles(int n) throws IOException{
        List<Double> lst = new ArrayList<Double>();
        for (int i = 0; i < n; i++) {
            lst.add(nextDouble());
        }
        return lst;
    }
    public static List<Integer> nextInts(int n) throws IOException{
        List<Integer> lst = new ArrayList<Integer>();
        for (int i = 0; i < n; i++) {
            lst.add(nextInt());
        }
        return lst;
    }
    public static List<Long> nextLongs(int n) throws IOException{
        List<Long> lst = new ArrayList<Long>();
        for (int i = 0; i < n; i++) {
            lst.add(nextLong());
        }
        return lst;
    }
    public static List<Integer> emptyList(int n, int val) {
        List<Integer> lst = new ArrayList<Integer>();
        for (int i = 0; i < n; i++) {
            lst.add(val);
        }
        return lst;
    }

    public static void main(String[] args) throws Exception {
        boolean debug = false;
        InputStream in = System.in;
        if (debug) {
            in = new FileInputStream("input.in");
        }
        br = new BufferedReader(new InputStreamReader(in));

        int T = nextInt();
        for (int CASE = 1; CASE <= T; CASE++) {
            int num_barb = nextInt();
            int n = nextInt();
            int[] b = new int[num_barb];
            for (int i = 0; i < num_barb; i++) {
                b[i] = nextInt();
            }
            System.out.println("Case #" + CASE + ": " + solve(n, num_barb, b));
        }
    }

    public static String solve(int n, int num_barb, int[] b) {
        if (n <= num_barb)
            return "" + n;
        long lo = 0; long hi = Long.MAX_VALUE / 2;
        long customers = 0;
        while (lo < hi) {
            long mid = (lo + hi) / 2;
            customers = 0;
            for (int i = 0; i < num_barb; i++) {
                customers += (int) Math.ceil((double) mid / b[i]);
            }
            if (customers == n - 1) {
                int barb = 0;
                for (int i = 1; i < num_barb; i++) {
                    if ((b[i] - (mid % b[i])) % b[i] < (b[barb] - (mid % b[barb])) % b[barb])
                        barb = i;
                }
                return "" + (barb + 1);
            } else if (customers < n - 1) {
                lo = mid + 1;
            } else {
                hi = mid - 1;
            }
        }
        customers = 0;
        for (int i = 0; i < num_barb; i++) {
            customers += (int) Math.ceil((double) lo / b[i]);
        }
        Queue<Pair> q = new PriorityQueue<>();
        for (int i = 0; i < num_barb; i++) {
            q.add(new Pair(lo + ((b[i] - (lo % b[i])) % b[i]), i));
        }
        for (long pos = customers + 1; pos <= n-1; pos++) {
            Pair p = q.poll();
            p.time += b[p.idx];
            q.add(p);
        }
        return "" + (q.poll().idx + 1);
    }

}

class Pair implements Comparable<Pair> {
    long time; int idx;
    public Pair(long t, int i) {
        time = t; idx = i;
    }
    public int compareTo(Pair other) {
        if (time == other.time)
            return idx - other.idx;
        else if (time < other.time)
            return -1;
        else if (time > other.time)
            return 1;
        else
            return 0;
    }
}
