import java.io.*;
import java.util.*;

public class b {
    private static StringTokenizer st;
    private static BufferedReader br;
    public static long MOD = 1000000007;

    public static void print(Object x) {
        System.out.println(x + "");
    }
    public static String join(List<?> x, String space) {
        StringBuilder sb = new StringBuilder();
        for (Object elt : x) {
            sb.append(elt);
            sb.append(space);
        }
        return sb.toString();
    }

    public static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine().trim());
        }
        return st.nextToken();
    }
    public static double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
    public static long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }
    public static int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    public static List<Double> nextDoubles(int n) throws IOException{
        List<Double> lst = new ArrayList<Double>();
        for (int i = 0; i < n; i++) {
            lst.add(nextDouble());
        }
        return lst;
    }
    public static List<Integer> nextInts(int n) throws IOException{
        List<Integer> lst = new ArrayList<Integer>();
        for (int i = 0; i < n; i++) {
            lst.add(nextInt());
        }
        return lst;
    }
    public static List<Long> nextLongs(int n) throws IOException{
        List<Long> lst = new ArrayList<Long>();
        for (int i = 0; i < n; i++) {
            lst.add(nextLong());
        }
        return lst;
    }
    public static List<Integer> emptyList(int n, int val) {
        List<Integer> lst = new ArrayList<Integer>();
        for (int i = 0; i < n; i++) {
            lst.add(val);
        }
        return lst;
    }

    public static void main(String[] args) throws Exception {
        boolean debug = false;
        InputStream in = System.in;
        if (debug) {
            in = new FileInputStream("input.in");
        }
        br = new BufferedReader(new InputStreamReader(in));

        int T = Integer.parseInt(br.readLine());
        for (int CASE = 1; CASE <= T; CASE++) {
            int n = Integer.parseInt(br.readLine());
            StringTokenizer st = new StringTokenizer(br.readLine());
            Queue<Pair> q = new PriorityQueue<>();
            for (int i = 0; i < n; i++) {
                q.add(new Pair(Integer.parseInt(st.nextToken())));
            }
            int minTime = q.peek().stack();
            int totalSplits = 0;
            while (q.peek().stack() >= 3) {
                Pair p = q.poll();
                p.splits++;
                totalSplits++;
                q.add(p);
                minTime = Math.min(minTime, totalSplits + q.peek().stack());
            }
            System.out.println("Case #" + CASE + ": " + minTime);
        }
    }
}

class Pair implements Comparable<Pair> {
    int pancakes; int splits;
    public Pair(int pancakes) {
        this.pancakes = pancakes;
        this.splits = 0;
    }
    public int stack() {
        return (int) Math.ceil((double) pancakes / (splits + 1));
    }
    public int compareTo(Pair other) {
        return other.stack() - this.stack();
    }
}
