import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class Main {

    private static int numberOfCases;
    private static int startSheepNumber[];
    private static int result[];


    private static void input(){
        Reader.init(System.in);
        try{
            numberOfCases = Reader.nextInt();
            startSheepNumber = new int[numberOfCases];
            result = new int[numberOfCases];
            for(int i=0;i<numberOfCases;i++){
                startSheepNumber[i] = Reader.nextInt();
            }
        }
        catch (Exception e){
            //Do nothing
        }

    }

    private static void solve(){
        for(int i=0;i<numberOfCases;i++){
            result[i] = solveSingleNumber(startSheepNumber[i]);
        }
    }

    private static int solveSingleNumber(int singleNumber){
        Set<Integer> digitalSet = new HashSet<Integer>();
        if(singleNumber==0){
            return 0;
        }
        else{
            int currentNumber = singleNumber;
            while(digitalSet.size()<10){
                digitalSet.addAll(convertIntToDigitalSet(currentNumber));
                if(digitalSet.size()>=10){
                    break;
                }
                currentNumber += singleNumber;
            }
            return currentNumber;
        }
    }

    private static Set<Integer> convertIntToDigitalSet(int number){
        int currentNumber = number;
        Set<Integer> digitalSet = new HashSet<>();
        while(currentNumber>0){
            digitalSet.add(currentNumber % 10);
            currentNumber = currentNumber/10;
        }
        //System.out.println("Current Number:"+number);
        //System.out.println("Current DigitalSet:"+digitalSet.toString());
        return digitalSet;
    }

    private static void output(){
        for(int i=0;i<numberOfCases;i++){
            if(result[i] == 0){
                System.out.printf("Case #%d: INSOMNIA\n",(i+1));
            }
            else{
                System.out.printf("Case #%d: %d\n",(i+1),result[i]);
            }
        }
    }


    public static void main(String[] args) {
        input();
        solve();
        output();
    }



    //Standard input Reader
    private static class Reader {
        static BufferedReader reader;
        static StringTokenizer tokenizer;

        /** call this method to initialize reader for InputStream */
        static void init(InputStream input) {
            reader = new BufferedReader(
                    new InputStreamReader(input) );
            tokenizer = new StringTokenizer("");
        }

        /** get next word */
        static String next() throws IOException {
            while ( ! tokenizer.hasMoreTokens() ) {
                tokenizer = new StringTokenizer(
                        reader.readLine() );
            }
            return tokenizer.nextToken();
        }

        static int nextInt() throws IOException {
            return Integer.parseInt( next() );
        }

        static double nextDouble() throws IOException {
            return Double.parseDouble( next() );
        }
    }
}
