import java.io.*;
import java.util.*;

public class TheKillerWorld {
	
	public static void main(String argsp[]) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("input.txt"));
		FileWriter fw = new FileWriter("output.txt");
		int total = Integer.parseInt(br.readLine());
		
		for(int turn = 1; turn <= total; turn++) {
			String[] split = br.readLine().split(" ");
			final int n = Integer.parseInt(split[0]);
			final int m = Integer.parseInt(split[1]);
			
			final String[] dictionary = new String[n];
			final int[][] dict = new int[n][];
			final int[][] guess = new int[m][26];
			final boolean[][] contains = new boolean[n][26];
			
			//get the dictionary
			for(int i = 0; i < n; i++) {
				dictionary[i] = br.readLine();
				char[] carr = dictionary[i].toCharArray();
				int size = carr.length;
				dict[i] = new int[size];
				if(size > 10) throw new Exception("size longer than 10");
				for(int j = 0; j < size; j++) dict[i][j] = carr[j] - 'a';
				for(int j = 0; j < size; j++) contains[i][dict[i][j]] = true;
			}
			//get the guess list
			for(int i = 0; i < m; i++) {
				char[] carr = br.readLine().toCharArray();
				if(carr.length != 26) throw new Exception("carr length not 26");
				for(int j = 0; j < 26; j++) guess[i][j] = carr[j] - 'a';
			}
			
			final StringBuilder sb = new StringBuilder();
			
			for(int list = 0; list < m; list++) { //current guess list
				int worst = -1, wIndex = -1;
				
				for(int picked = 0; picked < n; picked++) { //current picked word
					boolean[] removed = new boolean[n];
					int removeCount = 0, lose = 0;
					final int pickedLen = dict[picked].length;
					
					for(int i = 0; i < n; i++) { //filter from the length
						if(dict[i].length != pickedLen) {
							removed[i] = true;
							removeCount++;
						}
					}
					int[] charCount = new int[26];
					//create charCount
					for(int i = 0; i < n; i++) {
						if(!removed[i]) {
							for(int j : dict[i]) charCount[j]++;
						}
					}
					//guess start!
					for(int i = 0; removeCount < n-1 && i < 26; i++) {
						final int curGuess = guess[list][i];
						if(charCount[curGuess] > 0) {
							//picked word contains the guessed character
							if(contains[picked][curGuess]) {
								int[] pos = new int[pickedLen];
								int len = 0;
								for(int j = 0; j < pickedLen; j++) {
									if(dict[picked][j] == curGuess) pos[len++] = j;
								}
								for(int j = 0; j < n; j++) {
									boolean toRemove = false;
									if(!removed[j]) {
										for(int k = 0; k < len; k++) {
											if(dict[j][pos[k]] != curGuess) {
												toRemove = true;
												break;
											}
										}
									}
									if(toRemove && !removed[j]) {
										removed[j] = true;
										removeCount++;
										for(int k : dict[j]) charCount[k]--;
									}
								}
							}
							//pick word does not contain the guessed character!
							else {
								lose++;
								for(int j = 0; j < n; j++) {
									//remove all other words
									if(!removed[j] && contains[j][curGuess]) {
										removed[j] = true;
										removeCount++;
										for(int k : dict[j]) charCount[k]--;
									}
								}
							}
						}
					}
					
					for(int i = 0; i < n; i++) {
						if(i != picked && !removed[i]) throw new Exception ("not removed");
					}
					//TODO: remove this. validation...
					if(removed[picked] || removeCount != n-1) {
						throw new Exception("picked is removed");
					}
					
					if(lose > worst) {
						worst = lose;
						wIndex = picked;
					}
				}
				sb.append(" ").append(dictionary[wIndex]);// + "(" + worst + ")");
			}
			String ans = "Case #" + turn + ":" + sb.toString() + "\n";
			System.out.print(ans);
			fw.write(ans);
		}
		fw.flush();
		fw.close();
	}
}
