import java.io.*;
import java.util.*;
public class ExpensiveDinner {
	private static final int MAX = 1000000;
	private static boolean isPrime[];
	public static void main(String[] args) throws Exception {
		preprocess();
		Scanner sc = new Scanner(new File("input.txt"));
		FileWriter fw = new FileWriter("output.txt");
		int total = sc.nextInt();
		for(int turn = 1; turn <= total; turn++) {
			long num = sc.nextLong(), diff = 1;
			if(num == 1) diff = 0;
			else {
				for(long i = 2; i*i <= num; i++) {
					if(isPrime[(int)i]) diff += getCount(i, num);
				}
			}
			String ans = "Case #" + turn + ": " + diff + "\n";
			System.out.print(ans);
			fw.write(ans);
		}
		fw.flush();
		fw.close();
	}
	
	private static long getCount(long prime, long max) {
		int count = 0;
		long t = prime;
		while((t *= prime) <= max) count++;
		return count;
	}
	
	private static void preprocess() {
		isPrime = new boolean[MAX+1];
		Arrays.fill(isPrime, true);
		isPrime[0] = isPrime[1] = false;
		for(int i = 2; i <= MAX; i++) {
			if(isPrime[i]) {
				for(int j = i + i; j <= MAX; j += i) isPrime[j] = false;
			}
		}
	}
}
