import java.io.*;
import java.util.*;

public class RPI {
	
	public static void main(String argsp[]) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("input.txt"));
		FileWriter fw = new FileWriter("output.txt");
		int total = Integer.parseInt(br.readLine());
		long startTime = System.currentTimeMillis();
		for(int turn = 1; turn <= total; turn++) {
			int size = Integer.parseInt(br.readLine());
			int[] matches = new int[size], winCount = new int[size];
			double[] rpi = new double[size], wp = new double[size], owp = new double[size], oowp = new double[size];
			//[a][b]: WP of a except b
			double[][] wpExcept = new double[size][size];
			char[][] map = new char[size][];
			for(int i = 0; i < size; i++) {
				map[i] = br.readLine().toCharArray();
				for(int j = 0; j < size; j++) {
					if(map[i][j] != '.') matches[i]++;
					if(map[i][j] == '1') winCount[i]++;
				}
			}
			for(int i = 0; i < size; i++) wp[i] = winCount[i]/(double)matches[i];
			for(int i = 0; i < size; i++) {
				for(int j = 0; j < size; j++) {
					if(i != j && map[i][j] != '.') {
						//calculate individual owp
						if(map[i][j] == '1') {
							wpExcept[i][j] = (matches[i] == 1) ? 0 : (winCount[i]-1)/(double)(matches[i]-1);
						}
						else wpExcept[i][j] = (matches[i] == 1) ? 0 : winCount[i]/(double)(matches[i]-1);
					}
				}
			}
			for(int i = 0; i < size; i++) {
				for(int j = 0; j < size; j++) owp[i] += wpExcept[j][i];
				owp[i] /= matches[i];
			}
			for(int i = 0; i < size; i++) {
				for(int j = 0; j < size; j++) {
					if(map[i][j] != '.') oowp[i] += owp[j];
				}
				oowp[i] /= matches[i];
			}
			for(int i = 0; i < size; i++) rpi[i] = 0.25*wp[i] + 0.5*owp[i] + 0.25*oowp[i];
			
			String ans = "Case #" + turn + ":\n";
			fw.write(ans);
			for(int i = 0; i < size; i++) {
				System.out.println(rpi[i]);
				fw.write(rpi[i] + "\n");
			}
		}
		fw.flush();
		fw.close();
		System.out.println("execution time: " + (System.currentTimeMillis() - startTime)/1000 + "s");
	}
}
