import java.io.*;
import java.util.*;

public class WalkWays {
	private static final double EPS = 1e-8;
	private static double timeToUse;
	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new File("input.txt"));
		FileWriter fw = new FileWriter("output.txt");
		int total = sc.nextInt();
		for(int turn = 1; turn <= total; turn++) {
			int X = sc.nextInt(), S = sc.nextInt(), R = sc.nextInt();
			timeToUse = sc.nextInt();
			int N = sc.nextInt();
			int walk = X;
			Pair[] ways = new Pair[N+1];
			for(int i = 0; i < N; i++) {
				Pair p = new Pair(0, 0);
				p.dist = -(sc.nextInt() - sc.nextInt());
				p.speed = sc.nextInt();
				ways[i] = p;
				walk -= p.dist;
			}
			ways[N] = new Pair(0, walk);
			double time = 0;
			Arrays.sort(ways);
			for(int i = 0; i <= N; i++) time += processInterval(ways[i].speed, ways[i].dist, S, R);
			
			String ans = "Case #" + turn + ": " + time + "\n";
			System.out.print(ans);
			fw.write(ans);
		}
		fw.flush();
		fw.close();
	}
	
	private static double processInterval(double base, double dist, double wSpeed, double rSpeed) {
		if(timeToUse < EPS) return dist/(base+wSpeed);
		double usedTime = dist/(base+rSpeed);
		if(usedTime <= timeToUse) {
			timeToUse -= usedTime;
			return usedTime;
		}
		else { //use up all remaining running time
			double timeRan = timeToUse;
			double distRan = (base+rSpeed)*timeRan;
			double timeWalked = (dist - distRan)/(base+wSpeed);
			timeToUse = 0;
			return timeRan + timeWalked;
		}
	}
	
	private static class Pair implements Comparable<Pair> {
		public int speed, dist;
		public Pair(int x, int y) {
			this.speed = x;
			this.dist = y;
		}
	
		public int compareTo(Pair p) {
			if(speed != p.speed) return speed - p.speed;
			return dist - p.dist;
		}
	}
}
