import java.io.*;
import java.util.*;
import java.math.*;

public class Straight {
	
	public static void main(String[] args) throws Exception {
		long startTime = System.currentTimeMillis();
		Scanner sc = new Scanner(new File("input.txt"));
		FileWriter fw = new FileWriter("output.txt");
		int total = sc.nextInt();
		for(int turn = 1; turn <= total; turn++) {

			int size = sc.nextInt(), min = size;
			PriorityQueue<Pair> pq = new PriorityQueue<Pair>(), done = new PriorityQueue<Pair>();
			for(int i = 0; i < size; i++) pq.add(new Pair(sc.nextInt(), 1));
			
			while(!pq.isEmpty()) {
				if(done.isEmpty()) {
					//System.out.println("case 1");
					done.add(pq.poll());
				}
				else {
					Pair p = done.peek(), next = pq.peek();
					if(p.x + 1 < next.x) {
						//System.out.println("case 2");
						done.poll();
						min = Math.min(min, p.y);
					}
					else if(p.x == next.x) {
						//System.out.println("case 3, next: " + next + ", pq: " + pq + ", done: " + done);
						done.add(next);
						pq.poll();
						//System.out.println("after poll: " + pq + ", done : " + done);
					}
					else if(p.x + 1 == next.x) {
						//System.out.println("case 4");
						done.poll();
						next = pq.poll();
						next.y = 1 + p.y;
						done.add(next);
					}
				}
				//System.out.println("done: " + done);
			}
			for(Pair p : done) {
				min = Math.min(min, p.y);
			}
			
			
			String ansString = "Case #" + turn + ": " + min + "\n";
			System.out.print(ansString);
			fw.write(ansString);
		}
		fw.flush();
		fw.close();
		System.out.println("execution time: " + (System.currentTimeMillis() - startTime) + "ms");
	}
	
	private static int parse(String s) {
		return Integer.parseInt(s);
	}
	
	private static class Pair implements Comparable<Pair> {
		public int x, y;
		
		public Pair(int x, int y) {
			this.x = x;
			this.y = y;
		}
		
		public int compareTo(Pair p) {
			if(x != p.x) return x - p.x;
			return y - p.y;
			/*if(x < p.x) return -1;
			else if(x > p.x) return 1;
			else if(y < p.y) return -1;
			else if(y > p.y) return 1;
			else return 0;*/
		}
		
		public String toString() {
			return "(" + x + ", "+ y + ")";
		}
	}
}
