package com.google.codejam;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;

public class RevengeOfPancakes {
	static int turn = 0;
	boolean flipEntirely = false;;

	public static void main(String[] args) {

		String fileName = "rop.txt";

		// This will reference one line at a time
		String line = null;

		try {

			InputStream in = RevengeOfPancakes.class
					.getResourceAsStream(fileName);
			BufferedReader bufferedReader = new BufferedReader(
					new InputStreamReader(in));

			String temp = bufferedReader.readLine();
			int testcase = Integer.parseInt(temp);
			for (int i = 0; i < testcase; i++) {
				StringBuffer group = new StringBuffer(bufferedReader.readLine());
				/*System.out.println(group + " : " + turn);*/
				if (group.indexOf("-") == -1)
					System.out.println("Case #" + (i + 1) + ": 0");
				else {
					recurs(group, findLargestRange(group));
					System.out.println("Case #" + (i + 1) + ": " + turn);
				}
				turn = 0;
			}

			// Always close files.
			bufferedReader.close();
		} catch (FileNotFoundException ex) {
			System.out.println("Unable to open file '" + fileName + "'");
		} catch (IOException ex) {
			System.out.println("Error reading file '" + fileName + "'");
			// Or we could just do this:
			// ex.printStackTrace();
		}

	}

	private static void recurs(StringBuffer group, int largestRange) {
		/*System.out.println(group + " : " + turn);
		System.out.println("largest range in recur:" + largestRange);*/
		if (group.indexOf("-") == -1)
			return;
		else {
			doManeuver(group, largestRange);
			if (group.indexOf("-") == -1)
				return;
			recurs(group, findLargestRange(group));
		}
	}

	private static int findLargestRange(StringBuffer group) {
		int happy = 0, blank = 0, largestRange = 0;
		boolean b;
		boolean fb=true;
		int temp = 0;
		for (int i = 0; i < group.length(); i++) {
			if (group.charAt(i) == '+') {
				happy++;
				b = false;
			} else {
				blank++;
				b = true;
				if(fb){
					temp = i;
					fb = false;
				}
			}
			if ((blank > happy) && (b))
				largestRange = i;
		}
		temp = (temp > 0)? temp -1 : temp; 
		largestRange = (largestRange==0)?temp:largestRange;
		/*System.out.println("largest range: " + largestRange);*/
		return largestRange;
	}

	private static void doManeuver(StringBuffer group, int range) {
		turn++;
		StringBuffer subGroup = new StringBuffer(group.substring(0, range + 1));
		/*System.out.println("new subGroup:" + subGroup);*/
		doReverse(subGroup);
		doFlip(subGroup);
		group.replace(0, range + 1, subGroup.toString());
		//subGroup = null;
	}

	private static void doFlip(StringBuffer subGroup) {
		for (int i = 0; i < subGroup.length(); i++) {
			if (subGroup.charAt(i) == '-')
				subGroup.setCharAt(i, '+');
			else
				subGroup.setCharAt(i, '-');
		}
	}

	private static void doReverse(StringBuffer subGroup) {
		subGroup.reverse();
	}

}
