import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.Stack;


public class Magicka {
	int numTestCases = 0;
	Set<Character> baseChars = new HashSet<Character>();
	
	int [] numCombinations = new int[200];
	int [] numOppositions = new int[200];
	int [] numCharacters = new int[200];
	char [][] characters = new char[200][200];
	
	Map <Integer, Map<String, Character>> combinationSets = new HashMap<Integer, Map<String,Character>>();	
	Map <Integer, Map<Character, Set<Character>>> oppositionSets = new HashMap<Integer, Map<Character,Set<Character>>>();
	
	public Magicka() {
		baseChars.add('Q'); baseChars.add('W'); baseChars.add('E'); baseChars.add('R'); 
		baseChars.add('A'); baseChars.add('S'); baseChars.add('D'); baseChars.add('F');
	}
	
	public void init() throws Exception {
		BufferedReader a = null;
		try
		{
			a = new BufferedReader(new FileReader("B-large.in"));
			String s = a.readLine();
			int counter = 0;
			
			while (s != null) {
				if (counter == 0) {
					numTestCases = Integer.parseInt(s);					
				} else {
					int testCase = counter - 1;
					int index = 0;
					String [] tokens = s.split(" ");
					
					numCombinations[testCase] = Integer.parseInt(tokens[index++]);					
					Map<String, Character> combinationMap = new HashMap<String, Character>();
					for (int i = 0; i < numCombinations[testCase]; ++i) {
						String c = tokens[index++];
						combinationMap.put(c.substring(0, 2), c.charAt(2));
						combinationMap.put(c.substring(1, 2) + c.substring(0, 1), c.charAt(2));						
					}					
					combinationSets.put(testCase, combinationMap);
					
					
					numOppositions[testCase] = Integer.parseInt(tokens[index++]);
					Map<Character, Set<Character>> oppositionMap = new HashMap<Character, Set<Character>>();
					for (int i = 0; i < numOppositions[testCase]; ++i) {
						String t = tokens[index++];
						
						for (int j = 0; j < 2; ++j) {
							char c1 = t.charAt(j);
							char c2 = t.charAt((j + 1) % 2);
							
							Set<Character> l = oppositionMap.get(c1);
							if (l == null) {
								l = new HashSet<Character>();
								oppositionMap.put(c1, l);
							}
							
							l.add(c2);
						}
					}
					oppositionSets.put(testCase, oppositionMap);
					
					numCharacters[testCase] = Integer.parseInt(tokens[index++]);
					
					String characterSet = tokens[index++];
					for (int i = 0; i < numCharacters[testCase]; ++i) {
						characters[testCase][i] = characterSet.charAt(i);
					}
					
				}
				++counter;
				s = a.readLine();
			}
		} finally {
			if (a != null)
				a.close();
		}
	}
	
	
	public void calculate() throws Exception {
		FileWriter w = new FileWriter("output.txt");
		for (int i = 0; i < numTestCases; ++i) {
			Stack<Character> characterStack = new Stack<Character>();
			Map<String, Character> combinationMap = combinationSets.get(i);
			Map<Character, Set<Character>> oppositionMap = oppositionSets.get(i);
			Map<Character, Integer> baseCharacterOccurenceMap = new HashMap<Character, Integer>();
			for (char c: baseChars) {
				baseCharacterOccurenceMap.put(c, 0);
			}
			
			char prevCharacter = ' ';
			for (int j = 0; j < numCharacters[i]; ++j) {
				char c = characters[i][j];
				
				if (!baseChars.contains(c)) {
					characterStack.push(c);
					prevCharacter = c;
				} else {
					StringBuilder x = new StringBuilder();
					x.append(prevCharacter); x.append(c);
					String s = x.toString();
					if (combinationMap.containsKey(s)) {
						char replacement = combinationMap.get(s);
						char prior = characterStack.pop();
						baseCharacterOccurenceMap.put(prior, baseCharacterOccurenceMap.get(prior) - 1);
						characterStack.push(replacement);
						prevCharacter = replacement;
					} else {
						boolean opposed = false;
						if (oppositionMap.containsKey(c)) {
							for (char o : oppositionMap.get(c)) {
								int occurence = baseCharacterOccurenceMap.get(o);
								if (occurence > 0) {
									opposed = true;
									characterStack.clear();
									for (char d: baseChars) {
										baseCharacterOccurenceMap.put(d, 0);
									}
									prevCharacter = ' ';
									break;
								}
							}
						}
						
						if (!opposed) {
							characterStack.push(c);
							baseCharacterOccurenceMap.put(c, baseCharacterOccurenceMap.get(c) + 1);
							prevCharacter = c;
						}
					}
				}
				
			}
			
			StringBuilder b = new StringBuilder();
			b.append("]");
			while (!characterStack.isEmpty()) {
				b.insert(0, characterStack.pop());
				if (!characterStack.isEmpty()) {
					b.insert(0, ", ");
				}
			}
			b.insert(0, "[");
			w.write(String.format("Case #%d: %s\n", i + 1, b.toString()));
			
		}
		
		w.close();
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Magicka t = new Magicka();
		t.init();
		t.calculate();

	}

}
