import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;


public class CandySplitting {
	int numTestCases = 0;
	int [] numCandies = new int[200];
	int [][] candiesWeight = new int[200][2000];
	
	public void init() throws Exception {
		BufferedReader a = null;
		try
		{
			a = new BufferedReader(new FileReader("C-small-attempt0.in"));
			String s = a.readLine();
			int counter = 0;
			
			int testCase = 0;
			while (s != null) {
				if (counter == 0) {
					numTestCases = Integer.parseInt(s);					
				} else {
					numCandies[testCase] = Integer.parseInt(s);
					s = a.readLine();
					String [] tokens = s.split(" ");
					for (int i = 0; i < numCandies[testCase]; ++i) {
						candiesWeight[testCase][i] = Integer.parseInt(tokens[i]);
					}
					
					++testCase;
				}
				++counter;
				s = a.readLine();
			}
		} finally {
			if (a != null)
				a.close();
		}
	}
	
	public void calculate() throws Exception {
		FileWriter w = new FileWriter("output.txt");
		for (int i = 0; i < numTestCases; ++i) {
			// take an xor sum of all candy weights and check if it is 0
			int minWeight = Integer.MAX_VALUE;
			int runningSum = 0;
			int xorSum = 0;
			for (int j = 0; j < numCandies[i]; ++j) {
				xorSum = xorSum ^ candiesWeight[i][j];
				runningSum = runningSum + candiesWeight[i][j];
				minWeight = Math.min(minWeight, candiesWeight[i][j]);
			}
			
			// candies can be split only if xor sum is 0
			if (xorSum == 0) {
				w.write(String.format("Case #%d: %d\n", i + 1, (runningSum - minWeight)));	
			} else {
				w.write(String.format("Case #%d: %s\n", i + 1, "NO"));
			}
			
		}
		
		w.close();
	}
	
	public static void main(String[] args) throws Exception {
		CandySplitting t = new CandySplitting();
		t.init();
		t.calculate();
	}
}
