import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;


public class BotTrust {
	int numTestCases = 0;
	int [][] moves = new int[200][200];
	int numMoves[] = new int[200];
	                
	
	public void init() throws Exception {
		BufferedReader a = null;
		try
		{
			a = new BufferedReader(new FileReader("A-large.in"));
			String s = a.readLine();
			int counter = 0;
			
			while (s != null) {
				if (counter == 0) {
					numTestCases = Integer.parseInt(s);					
				} else {
					int testCase = counter - 1;
					String [] tokens = s.split(" ");
					int n = Integer.parseInt(tokens[0]);
					numMoves[testCase] = n;
					
					int i = 1;
					int moveNumber = 0;
					while (i <= 2*n) {
						String bot = tokens[i++];
						int move = Integer.parseInt(tokens[i++]);
						if ("O".equals(bot)) {
							move = move * -1;
						}
						
						moves[testCase][moveNumber++] = move;
						
					}
					
				}
				++counter;
				s = a.readLine();
			}
		} finally {
			if (a != null)
				a.close();
		}
	}
	
	public void calculate() throws Exception {
		FileWriter w = new FileWriter("output.txt");
		for (int i = 0; i < numTestCases; ++i) {
			int moveCount = numMoves[i];
			
			int timeElapsed[] = new int[2];
			int prevPositions[] = new int[2];
			int currentTime = 0;
			timeElapsed[0] = timeElapsed[1] = 0;
			prevPositions[0] = prevPositions[1] = 1;
			
			
			for  (int j = 0; j < moveCount; ++j) {
				int move = moves[i][j];
				int index = 0;
				if (move > 0) {
					index = 1;
				} else {
					move = move * -1;
				}
				
				// find distance from prev position
				int d = Math.abs(move - prevPositions[index]);
				
				// difference between current time and last elapsed time
				int elapsed = currentTime - timeElapsed[index];
				
				int newTime = Math.max(d, elapsed) + timeElapsed[index] + 1;
				timeElapsed[index] = currentTime = newTime;	
				prevPositions[index] = move;
			}
			
			w.write(String.format("Case #%d: %d\n", i + 1, currentTime));			
		}
		
		w.close();
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		BotTrust t = new BotTrust();
		t.init();
		t.calculate();
	}

}
