import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;


public class B {
	public static void main (String[] args) throws IOException {
		BufferedReader bin = new BufferedReader(new FileReader("src/B-small.in"));
		BufferedWriter bout = new BufferedWriter(new FileWriter("src/B-small.txt"));
		int cases = Integer.parseInt(bin.readLine());
		
		int c = 1;
		while (cases-- > 0) {
			String[] params = bin.readLine().split(" ");
			double C = Double.parseDouble(params[0]);
			double F = Double.parseDouble(params[1]);
			double X = Double.parseDouble(params[2]);
			
			double t = solve(C, F, X);
			String s = String.format("%.7f", t);

			bout.write("Case #" + c + ": " + s + "\n");
			c++;
		}
		
		bin.close();
		bout.close();
	}
	
	public static double solve (double C, double F, double X) {
		double numCookies = 0;
		double cookieRate = 2;
		double t = 0;
		double dt = 0.0000005;
		while(true) {
			numCookies += cookieRate * dt;
			t += dt;
			if (numCookies >= C) {
				if (X / (cookieRate + F) < (X - numCookies) / cookieRate) {
					cookieRate += F;
					numCookies -= C;
				} else {
					t += (X - numCookies) / cookieRate;
					break;
				}
			}
		}
		
		return t;
	}
}
