import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

class Sleep {

    public static void main(String[] args) {
        File file = new File("src/input.in");

        File of = new File("src/out.txt");

        try {
            Scanner sc = new Scanner(file);

            sc.nextLine(); // ignores the first line
            String[] split = sc.nextLine().split(" ");

            int length = Integer.valueOf(split[0]);
            int amt = Integer.valueOf(split[1]);

            BinIter bin = new BinIter(length, 100000);

            FileWriter fw = new FileWriter(of, true);
            PrintWriter pw = new PrintWriter(fw);

            pw.println("Case #1:");
            
            int c = 0;

            while (c < amt) {
                String next = bin.next();
                int s = next.length();
                String cur = "1" + next.substring(s - length + 2, s) + "1";
                int[] factors = new int[9];

                factors[0] = getFactor(new BigInteger(cur, 2));
                factors[1] = getFactor(new BigInteger(cur, 3));
                factors[2] = getFactor(new BigInteger(cur, 4));
                factors[3] = getFactor(new BigInteger(cur, 5));
                factors[4] = getFactor(new BigInteger(cur, 6));
                factors[5] = getFactor(new BigInteger(cur, 7));
                factors[6] = getFactor(new BigInteger(cur, 8));
                factors[7] = getFactor(new BigInteger(cur, 9));
                factors[8] = getFactor(new BigInteger(cur, 10));

                boolean andmap = true;

                for (int i = 0; i < factors.length; i++) {
                    andmap = andmap && (!(factors[i] == -1));
                }

                if (andmap) {
                    pw.print(cur + " ");
                    
                    for (int i = 0; i < factors.length; i++) {
                        pw.print(factors[i] + " ");
                    }
                    pw.println("");

                    c++;
                }

            }
            sc.close();
            pw.close();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    static int getFactor(BigInteger num) {
        int count = 1;

        BigInteger test = new BigInteger(String.valueOf(count));
        BigInteger zero = new BigInteger("0");

        while (num.compareTo(test.multiply(test)) > 0 && count < 100000) { 
            count += 1;
            test = new BigInteger(String.valueOf(count));

            if (num.remainder(test).compareTo(zero) == 0
                && !(num.compareTo(test) == 0)) {
                return count;
            }
        }

        return -1;
    }
}

class BinIter {
    int[] arrA;
    int lim;
    int cur;
    ArrayList<String> output;

    BinIter(int n, int lim) {
        this.arrA = new int[n];
        this.lim = lim;
        this.cur = 0;
        this.output = new ArrayList<String>();

        nBits(n);

        this.cur = 0;
        System.out.println("done");
    }

    String next() {
        String r = output.get(cur);
        cur += 1;
        return r;
    }

    void nBits(int n) {
        if (cur >= lim) {
            return;
        }
        else if (n <= 0) {
            print();
        }
        else {
            arrA[n - 1] = 0;
            nBits(n - 1);

            arrA[n - 1] = 1;
            nBits(n - 1);
        }
    }

    void print() {

        String res = "";
        for (int i = 0; i < arrA.length; i++) {
            res = arrA[i] + res;
        }
        
        cur++;
        
        System.out.println(res + " " + this.cur + "/" + this.lim);
        output.add(res);
    }
}
