package sleep;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.StringTokenizer;

class Sleep {
    
    public static void main(String[] args) {
        File file = new File("src/input.in");
        File of = new File("src/out.txt");
        
        try {
            Scanner sc = new Scanner(file);
            //Scanner sc = new Scanner(System.in);
            int iter = Integer.parseInt(sc.nextLine());
            
            String res = "";
            
            FileWriter fw = new FileWriter(of, true);
            PrintWriter pw = new PrintWriter(fw);
            
            int start;
            
            for (int i = 0; i < iter; i++) {
                ArrayList<Boolean> seen = reset();
                
                start = Integer.parseInt(sc.nextLine());                
                
                if (start == 0) {
                    res = "INSOMNIA";
                }
                else {
                    int k = 0;
                    while (!check(seen)) {
                        k += 1;
                        
                        int cur = start * k;
                        
                        while (cur > 0) {
                            seen.set(cur % 10, true);
                            cur = cur / 10;
                        }
                    }
                    
                    res = String.valueOf(start * k);
                }
                
                pw.println("Case #" + (i+1) + ": " + res);
                //System.out.println("Case #" + (i+1) + ": " + res);

            }
            sc.close();
            pw.close();
        } 
        catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    static boolean check(ArrayList<Boolean> seen) {
        boolean andmap = true;
        
        for(Boolean b : seen) {
            andmap = andmap && b;
        }
        
        return andmap;
    }
    
    static ArrayList<Boolean> reset() {
        ArrayList<Boolean> seen = new ArrayList<Boolean>();
        for (int j = 0; j < 10; j++) {
            seen.add(false);
        }
        
        return seen;
    }
}
