/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package traintimetable;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Time;
import java.text.ParseException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author ankitrana
 */
class Schedule implements Comparable<Schedule>
{
    Time startTime, endTime;
    int reused;
    int needNew;
    Schedule(Time st, Time en)
    {
        startTime = st;
        endTime = en;
        reused = needNew = 0;
    }
    public int compareTo(Schedule n) 
    {
        int lastCmp = startTime.compareTo(n.startTime);
        return lastCmp;
    }
};
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) 
    {
            BufferedReader br = null;
            BufferedWriter wr = null;
        try 
        {
            // TODO code application logic here
            br = new BufferedReader(new FileReader(args[0]));
            wr = new BufferedWriter(new FileWriter(args[1]));
            int testCaseCount = Integer.parseInt(br.readLine());
            ArrayList<String> trainCountResult = new ArrayList<String>();
            for(int i=0;i<testCaseCount;i++)
            {
                int turnAroundTime = Integer.parseInt(br.readLine());
                String[] scheduleCounts = br.readLine().split(" ");
                int trainAScheduleCount = Integer.parseInt(scheduleCounts[0]);
                int trainBScheduleCount = Integer.parseInt(scheduleCounts[1]);
                Schedule[] trainASchedules = new Schedule[trainAScheduleCount];
                Schedule[] trainBSchedules = new Schedule[trainBScheduleCount];
                for(int j=0;j<trainAScheduleCount;j++)
                {
                    String[] timing = br.readLine().split(" ");
                    trainASchedules[j] = new Schedule(Time.valueOf(timing[0]+":00"), Time.valueOf(timing[1]+":00"));
                }
                for(int j=0;j<trainBScheduleCount;j++)
                {
                    String[] timing = br.readLine().split(" ");
                    trainBSchedules[j] = new Schedule(Time.valueOf(timing[0]+":00"), Time.valueOf(timing[1]+":00"));
                }
                int aLoopCount = 0, bLoopCount = 0;
                //Todo Sort the schedules
                Arrays.sort(trainASchedules);
                Arrays.sort(trainBSchedules);
                
                while(aLoopCount < trainAScheduleCount || bLoopCount<trainBScheduleCount)
                {
                    if(aLoopCount== trainAScheduleCount)
                    {
                        long timeDiff=-1;
                        int prevEmpty = -1;
                        if(aLoopCount == 0)
                            timeDiff=-1;
                        else
                        {
                            int backtracker = 0;
                            while(backtracker < aLoopCount)
                            {
                                timeDiff = trainBSchedules[bLoopCount].startTime.getTime()-trainASchedules[backtracker].endTime.getTime();
                                if( timeDiff >=(turnAroundTime*60*1000) && trainASchedules[backtracker].reused == 0 )
                                {
                                    prevEmpty = backtracker;
                                    break;
                                }
                                backtracker++;
                            }
                        }
                        if(prevEmpty != -1  )
                        {
                            trainASchedules[prevEmpty].reused = 1;
                            trainBSchedules[bLoopCount].needNew = 0;
                            trainBSchedules[bLoopCount].reused = 0;
                        }
                        else
                        {
                            trainBSchedules[bLoopCount].needNew = 1;
                            trainBSchedules[bLoopCount].reused = 0;
                        }
                        bLoopCount++;
                    }
                    else if(bLoopCount == trainBScheduleCount)
                    {
                        long timeDiff=-1;
                        int prevEmpty = -1;
                        if(bLoopCount == 0)
                            timeDiff=-1;
                        else
                        {
                            int backtracker = 0;
                            while(backtracker < bLoopCount)
                            {
                                timeDiff = trainASchedules[aLoopCount].startTime.getTime()-trainBSchedules[backtracker].endTime.getTime();
                                if( timeDiff >=(turnAroundTime*60*1000) && trainBSchedules[backtracker].reused == 0 )
                                {
                                    prevEmpty = backtracker;
                                    break;
                                }
                                backtracker++;
                            }
                        }
                        if(prevEmpty != -1  )
                        {
                            trainBSchedules[prevEmpty].reused = 1;
                            trainASchedules[aLoopCount].needNew = 0;
                            trainASchedules[aLoopCount].reused = 0;
                        }
                        else
                        {
                            trainASchedules[aLoopCount].needNew = 1;
                            trainASchedules[aLoopCount].reused = 0;
                        }
                        aLoopCount++;
                    }                    
                    else
                    {
                    // look for the next departure time see if train available before that at the other side
                    // if available, mark tht schedule as reused and the current schedule as do not neednew, not used
                    // else mark the current schedule as neednew, not used
                        // process A schedule
                        if(trainASchedules[aLoopCount].startTime.compareTo(trainBSchedules[bLoopCount].startTime)<=0)
                        {
                            if(bLoopCount == 0)
                            {
                                trainASchedules[aLoopCount].needNew = 1;
                                trainASchedules[aLoopCount].reused = 0;
                            }
                            else
                            {
                                int lastEmptyRecord = -1, backtracker = 0;
                                while(backtracker < bLoopCount)
                                {
                                    long timeDiff = trainASchedules[aLoopCount].startTime.getTime()-trainBSchedules[backtracker].endTime.getTime();
                                    if( timeDiff >=(turnAroundTime*60*1000) && trainBSchedules[backtracker].reused == 0 )
                                    {
                                        lastEmptyRecord = backtracker;
                                        break;
                                    }
                                    backtracker++;
                                }
                                if(lastEmptyRecord != -1)
                                {
                                    trainBSchedules[lastEmptyRecord].reused = 1;
                                    trainASchedules[aLoopCount].needNew = 0;
                                    trainASchedules[aLoopCount].reused = 0;
                                }
                                else
                                {
                                    trainASchedules[aLoopCount].needNew = 1;
                                    trainASchedules[aLoopCount].reused = 0;
                                }
                            }
                            aLoopCount++;
                        }
                        else
                        {
                        // process b schedule
                            if(aLoopCount == 0)
                            {
                                trainBSchedules[bLoopCount].needNew = 1;
                                trainBSchedules[bLoopCount].reused = 0;
                            }
                            else
                            {
                                int lastEmptyRecord = -1, backtracker = 0;
                                while(backtracker < aLoopCount)
                                {
                                    long timeDiff = trainBSchedules[bLoopCount].startTime.getTime()-trainASchedules[backtracker].endTime.getTime();
                                    if( timeDiff >=(turnAroundTime*60*1000) && trainASchedules[backtracker].reused == 0 )
                                    {
                                        lastEmptyRecord = backtracker;
                                        break;
                                    }
                                    backtracker++;
                                }
                                if(lastEmptyRecord != -1)
                                {
                                    trainASchedules[lastEmptyRecord].reused = 1;
                                    trainBSchedules[bLoopCount].needNew = 0;
                                    trainBSchedules[bLoopCount].reused = 0;
                                }
                                else
                                {
                                    trainBSchedules[bLoopCount].needNew = 1;
                                    trainBSchedules[bLoopCount].reused = 0;
                                }
                            }
                            bLoopCount++;
                        }
                    }
                    
                }//end of while Loop
                //TODO insert result here
                int trainACount=0;
                int trainBCount=0;

                for(int at=0;at<trainASchedules.length;at++)
                {
                    if(trainASchedules[at].needNew == 1)
                        trainACount++;
                }
                for(int bt=0;bt<trainBSchedules.length;bt++)
                {
                    if(trainBSchedules[bt].needNew == 1)
                        trainBCount++;
                }
                System.out.println("done");
                trainCountResult.add(trainACount+" "+trainBCount);
            }//end of testcase for
            for(int i=0;i<trainCountResult.size();i++)
            {
                wr.write("Case #"+(i+1)+": " + trainCountResult.get(i)+"\n");
            }
        } 
        catch (IOException ex) 
        {

        }
        finally {
            try {
                br.close();
                wr.close();
            } catch (IOException ex) {
                Logger.getLogger(Main.class.getName()).log(Level.SEVERE, null, ex);
            }
        }
        
    }

}
