package zdemoclientserver.other;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class SenateEvacuation
{

    public static void main(String[] args) throws IOException
    {
        try (BufferedReader input =
                Files.newBufferedReader(FileSystems.getDefault().getPath("resources", "senateEvacuation.txt"), Charset.defaultCharset());
                BufferedWriter writer = Files.newBufferedWriter(
                        FileSystems.getDefault().getPath("resources", "out.txt"), Charset.defaultCharset()))
        {
            int T = Integer.valueOf(input.readLine()), N = 0, counter = 0;
            String line = null, result = null;
            int[] array;
            for (int i = 1; i <= T; i++)
            {
                N = Integer.valueOf(input.readLine());
                line = input.readLine();
                array = new int[N];
                counter = 0;
                for (String str : line.split(" "))
                {
                    array[counter] = Integer.parseInt(str);
                    counter++;
                }
                result = String.format("Case #%d: %s", i, getPlan(array));
                System.out.println(result);
                writer.append(result);
                if (i == T)
                {
                    writer.flush();
                }
                else
                {
                    writer.newLine();
                }
            }
        }
    }

    public static String getPlan(int[] array)
    {
        String result = null, temp = null;
        int counter = 0;
        char c;
        Map<String, Integer> map = new LinkedHashMap<String, Integer>();
        for (int i = 0; i < array.length; i++)
        {
            c = (char) (65 + i);
            map.put(String.valueOf(c), array[i]);
        }
        while (!isAllZero(map))
        {
            map = sortByValue(map);
            counter = 1;
            temp = "";
            for (String s : map.keySet())
            {
                temp = temp + s;
                counter++;
                map.put(s, map.get(s) - 1);
                if (counter > 2)
                {
                    if (nonZero(map) == 1)
                    {
                        map.put(s, map.get(s) + 1);
                        temp = temp.replace(s, "");
                    }
                    break;
                }
            }
            result = (result == null) ? temp : (result + " " + temp);
        }
        return result;
    }

    public static int getMin(int[] inputArray)
    {
        int minValue = inputArray[0];
        for (int i = 1; i < inputArray.length; i++)
        {
            if (inputArray[i] < minValue)
            {
                minValue = inputArray[i];
            }
        }
        return minValue;
    }

    public static boolean isAllZero(Map<String, Integer> map)
    {
        boolean flag = true;
        for (Integer i : map.values())
        {
            if (i != 0)
            {
                flag = false;
                break;
            }
        }
        return flag;
    }

    public static int nonZero(Map<String, Integer> map)
    {
        int flag = 0;
        for (Integer i : map.values())
        {
            if (i != 0)
            {
                flag++;
            }
        }
        return flag;
    }

    public static <K, V extends Comparable<? super V>> Map<K, V>
            sortByValue(Map<K, V> map)
    {
        List<Map.Entry<K, V>> list =
                new LinkedList<>(map.entrySet());
        Collections.sort(list, new Comparator<Map.Entry<K, V>>()
        {
            @Override
            public int compare(Map.Entry<K, V> o1, Map.Entry<K, V> o2)
            {
                return (o2.getValue()).compareTo(o1.getValue());
            }
        });

        Map<K, V> result = new LinkedHashMap<>();
        for (Map.Entry<K, V> entry : list)
        {
            result.put(entry.getKey(), entry.getValue());
        }
        return result;
    }
}
