//**********************************************************************
// Copyright (c) 2016 Telefonaktiebolaget LM Ericsson, Sweden.
// All rights reserved.
// The Copyright to the computer program(s) herein is the property of
// Telefonaktiebolaget LM Ericsson, Sweden.
// The program(s) may be used and/or copied with the written permission
// from Telefonaktiebolaget LM Ericsson or in accordance with the terms
// and conditions stipulated in the agreement/contract under which the
// program(s) have been supplied.
// **********************************************************************
package zdemoclientserver.other;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.util.TreeSet;

public class LastWord
{
    public static void main(String[] args) throws IOException
    {
        try (BufferedReader input =
                Files.newBufferedReader(FileSystems.getDefault().getPath("resources", "lastWord.txt"), Charset.defaultCharset());
                BufferedWriter writer = Files.newBufferedWriter(
                        FileSystems.getDefault().getPath("resources", "out.txt"), Charset.defaultCharset()))
        {
            long T = Integer.valueOf(input.readLine());
            String line = null, result = null;
            for (int i = 1; i <= T; i++)
            {
                line = input.readLine();
                result = String.format("Case #%d: %s", i, permuteString(line));
                System.out.println(result);
                writer.append(result);
                if (i == T)
                {
                    writer.flush();
                }
                else
                {
                    writer.newLine();
                }
            }
        }
    }

    public static String permuteString(String input)
    {
        TreeSet<String> sorted = new TreeSet<String>();
        TreeSet<String> temp = new TreeSet<String>();
        sorted.add(input.charAt(0) + "");
        for (int i = 1; i < input.length(); i++)
        {
            temp = new TreeSet<String>();
            for (String str : sorted)
            {
                temp.add(str + input.charAt(i));
                temp.add(input.charAt(i) + str);
            }
            sorted = temp;
        }
        return sorted.last();
    }
}
