//**********************************************************************
// Copyright (c) 2016 Telefonaktiebolaget LM Ericsson, Sweden.
// All rights reserved.
// The Copyright to the computer program(s) herein is the property of
// Telefonaktiebolaget LM Ericsson, Sweden.
// The program(s) may be used and/or copied with the written permission
// from Telefonaktiebolaget LM Ericsson or in accordance with the terms
// and conditions stipulated in the agreement/contract under which the
// program(s) have been supplied.
// **********************************************************************
package zdemoclientserver.other;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.FileSystems;
import java.nio.file.Files;
import java.util.Arrays;
import java.util.LinkedHashMap;

public class GettingDigits
{
    public static void main(String[] args) throws IOException
    {
        try (BufferedReader input =
                Files.newBufferedReader(FileSystems.getDefault().getPath("resources", "generateDigit.txt"), Charset.defaultCharset());
                BufferedWriter writer = Files.newBufferedWriter(
                        FileSystems.getDefault().getPath("resources", "out.txt"), Charset.defaultCharset()))
        {
            long T = Integer.valueOf(input.readLine());
            String line = null, result, old;
            char[] temp;
            String[] arr = new String[]
            { "ZERO", "TWO", "SIX", "FOUR", "ONE", "THREE", "FIVE", "SEVEN", "EIGHT", "NINE" };
            LinkedHashMap<String, String> map = new LinkedHashMap<String, String>();
            map.put("ZERO", "0");
            map.put("ONE", "1");
            map.put("TWO", "2");
            map.put("THREE", "3");
            map.put("FOUR", "4");
            map.put("FIVE", "5");
            map.put("SIX", "6");
            map.put("SEVEN", "7");
            map.put("EIGHT", "8");
            map.put("NINE", "9");
            for (int i = 1; i <= T; i++)
            {
                line = input.readLine();
                result = "";

                while (!line.isEmpty())
                {
                    for (int j = 0; j <= 9; j++)
                    {
                        old = "";
                        temp = arr[j].toCharArray();
                        while (!old.equals(line))
                        {
                            old = line;
                            for (int k = 0; k < temp.length; k++)
                            {
                                if (line.contains(temp[k] + ""))
                                {
                                    line = line.replaceFirst(temp[k] + "", "");
                                    if (k == (temp.length - 1))
                                    {
                                        result = result + map.get(arr[j]);
                                    }
                                }
                                else
                                {
                                    line = old;
                                    break;
                                }
                            }
                        }
                    }
                }

                temp = result.toCharArray();
                Arrays.sort(temp);
                System.out.println(i + " " + String.valueOf(temp));
                writer.append(String.valueOf(temp));
                if (i == T)
                {
                    writer.flush();
                }
                else
                {
                    writer.newLine();
                }
            }
        }
    }
}
