package org.motechproject.ananya.referencedata.csv.utils;

import org.apache.commons.io.FileUtils;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Problem1 {
    
      public static  void main(String[] args) throws IOException {
        List<String> lines = FileUtils.readLines(new File("/Users/aravindm/Documents/in.txt"));
        List<String> out = new ArrayList<>();
        lines.remove(0);

        List<Character> xWins = new ArrayList<>();
        xWins.add('X');
        xWins.add('T');
        List<Character> oWins = new ArrayList<>();
        oWins.add('O');
        oWins.add('T');

        int caseNumber = 1;
        for (int i = 0; i < lines.size(); i += 5) {
            List<String> grid = lines.subList(i, i + 4);
            char[][] charGrid = getCharGrid(grid);
            if (verifyVertical(charGrid, xWins) || verifyHorizontal(charGrid, xWins) || verifyDiagonal(charGrid, xWins))
                out.add(String.format("Case #%d: X won", caseNumber));
            else if (verifyVertical(charGrid, oWins) || verifyHorizontal(charGrid, oWins) || verifyDiagonal(charGrid, oWins))
                out.add(String.format("Case #%d: O won", caseNumber));
            else if (isGameIncomplete(charGrid))
                out.add(String.format("Case #%d: Game has not completed", caseNumber));
            else
                out.add(String.format("Case #%d: Draw", caseNumber));
            caseNumber++;
        }
        FileUtils.writeLines(new File("/Users/aravindm/Documents/out.txt"), out);
    }

    private static boolean isGameIncomplete(char[][] charGrid) {
        for (char[] chars : charGrid) {
            for (char aChar : chars) {
                if (aChar == '.') {
                    return true;
                }
            }
        }
        return false;
    }

    private static  char[][] getCharGrid(List<String> grid) {
        char[][] charGrid = new char[4][];
        int i = 0;
        for (String s : grid) {
            charGrid[i] = s.toCharArray();
            i++;
        }
        return charGrid;
    }

    private static boolean verifyHorizontal(char[][] charGrid, List<Character> truthCharacters) {
        for (int i = 0; i < 4; i++) {
            if (truthCharacters.contains(charGrid[i][0]) &&
                    truthCharacters.contains(charGrid[i][1]) &&
                    truthCharacters.contains(charGrid[i][2]) &&
                    truthCharacters.contains(charGrid[i][3])
                    )
                return true;
        }
        return false;
    }

    private static boolean verifyVertical(char[][] charGrid, List<Character> truthCharacters) {
        for (int i = 0; i < 4; i++) {
            if (truthCharacters.contains(charGrid[0][i]) &&
                    truthCharacters.contains(charGrid[1][i]) &&
                    truthCharacters.contains(charGrid[2][i]) &&
                    truthCharacters.contains(charGrid[3][i])
                    )
                return true;
        }
        return false;
    }

    private static  boolean verifyDiagonal(char[][] charGrid, List<Character> truthCharacters) {

        if (truthCharacters.contains(charGrid[0][0]) &&
                truthCharacters.contains(charGrid[1][1]) &&
                truthCharacters.contains(charGrid[2][2]) &&
                truthCharacters.contains(charGrid[3][3])
                )
            return true;

        if (truthCharacters.contains(charGrid[0][3]) &&
                truthCharacters.contains(charGrid[1][2]) &&
                truthCharacters.contains(charGrid[2][1]) &&
                truthCharacters.contains(charGrid[3][0])
                )
            return true;
        return false;
    }

}

