import org.apache.commons.io.FileUtils;
import org.apache.commons.lang.StringUtils;

import java.io.File;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

public class Problem2 {
    public static void main(String[] args) throws IOException {
    List<String> lines = FileUtils.readLines(new File("/Users/aravindm/Documents/in.txt"));
        List<String> out = new ArrayList<>();
        lines.remove(0);

        int caseNumber = 1;
        for (String line : lines) {
            String[] limits = line.split(" ");
            BigInteger lower = new BigInteger(limits[0]);
            BigInteger lowerSqrt = sqrt(lower);
            BigInteger startLimit = lowerSqrt.multiply(lowerSqrt).equals(lower) ? lowerSqrt : lowerSqrt.add(new BigInteger("1"));
            BigInteger endLimit = sqrt(new BigInteger(limits[1])).add(new BigInteger("1"));

            BigInteger current = startLimit;
            BigInteger numberOfFairSqrs = new BigInteger("0");
            List<BigInteger> successList = new ArrayList<>();
            while (current.compareTo(endLimit) == -1) {
                if ((isPalindrome(current) && isPalindrome(current.multiply(current)))) {
                    numberOfFairSqrs = numberOfFairSqrs.add(new BigInteger("1"));
                    successList.add(current);
                }
                current = current.add(new BigInteger("1"));
            }
            out.add(String.format("Case #%d: %s", caseNumber, numberOfFairSqrs));
            caseNumber++;
        }
        FileUtils.writeLines(new File("/Users/aravindm/Documents/out.txt"), out);
    }
    private  static boolean isPalindrome(BigInteger number) {
        String str = number.toString();
        return str.equals(StringUtils.reverse(str));
    }

    private static BigInteger sqrt(BigInteger n) {
        BigInteger a = BigInteger.ONE;
        BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
        while (b.compareTo(a) >= 0) {
            BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
            if (mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
            else a = mid.add(BigInteger.ONE);
        }
        return a.subtract(BigInteger.ONE);
    }
}

