import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Mines{
	static int t,r,c,m,color;
	static String line;
	static String[] row;
	static String[][] a;
	static int[][] b,conn;
	static int MAX = 1000;
	
	public static void main(String [ ] args) throws IOException{
		int i,j,k;
		BufferedReader br = new BufferedReader(new FileReader("input.in"));
	    try {
	    	File file = new File("aaa.out");
    		
    		if (!file.exists()) {
    			file.createNewFile();
    		}
    		
    		FileWriter fw = new FileWriter(file.getAbsoluteFile());
    		BufferedWriter bw = new BufferedWriter(fw);
    		
	        line = br.readLine();
	        t = Integer.valueOf(line);
	        
	        for(i = 0; i < t; i++){
	        	line = br.readLine();
	        	row = line.split("\\s");
	        	
	        	r = Integer.valueOf(row[0]);
	        	c = Integer.valueOf(row[1]);
	        	m = Integer.valueOf(row[2]);
	        	
    			bw.write("Case #"+(i+1)+":\n"+solve()+(i<t-1?"\n":""));
	        }
	        
			bw.close();

	    } finally {
	        br.close();
	    }
	}
	
	private static String solve() {
		if(m==r*c) return "Impossible";
		if(m==r*c-1) return fakePrint();
		init();
		boolean solvable = fill(1,0,m);
		
		if(solvable) return prettyPrint();
		else return "Impossible";
	}
	
	private static void init(){
		int i=0,j=0;
		b = new int[r+2][c+2];
		conn = new int[r+2][c+2];
		for (i=0;i<=r+1;i++){
			for (j=0;j<=c+1;j++){
				b[i][j] = 0;
				conn[i][j] = 0;
			}
		}
		for (i=0;i<=r+1;i++){
				b[i][0] = 1;
				b[i][c+1] = 1;
		}

		for (j=0;j<=c+1;j++){
			b[0][j] = 1;
			b[r+1][j] = 1;
		}
		color=1;
	}
	
	private static boolean fill(int x, int y, int left){
		int i,j;
		if(left == 0){
			if (!checkPlacement(r,c,0)){
				return false;
			} else {
				prettyPrint();
				return true;
			}
		}
		
		//no need to go further
		if (!checkPlacement(x,y,left)){
			return false;
		}	
		
		//place mine
		for (i=x;i<r+1;i++){
			j=1;
			if (i==x) j=y+1;
			for (;j<c+1;j++){
				b[i][j]+=MAX;
				b[i][j-1]++;
				b[i][j+1]++;
				b[i-1][j-1]++;
				b[i-1][j]++;
				b[i-1][j+1]++;
				b[i+1][j-1]++;
				b[i+1][j]++;
				b[i+1][j+1]++;
				boolean trySolution = fill(i,j,left-1);
				if(trySolution) return true;
				//undo mine
				b[i][j]-=MAX;
				b[i][j-1]--;
				b[i][j+1]--;
				b[i-1][j-1]--;
				b[i-1][j]--;
				b[i-1][j+1]--;
				b[i+1][j-1]--;
				b[i+1][j]--;
				b[i+1][j+1]--;
			}
		}
		return false;
	}

	private static boolean checkPlacement(int x, int y, int left) {
		int i,j;
		// Each cell must be a mine, empty, or has an empty adjacent cell
		for (i=x; i>0; i--){
			j=c;
			if(i==x) j=y;
			for (;j>0; j--){
				if(b[i][j]<MAX && b[i][j]>=1){
					//mine has empty cell adjacent
					if(!checkNeighbor(i,j)) return false;
				}
			}
		}
		
		// Are the empty cells continuous?
		if(left==0 && notConnected()) return false;
		
		return true;
	}

	private static boolean notConnected() {
		int empty = r*c-m;
		int i,j;
		color++;//refresh color
		for (i=0;i<r+2;i++){
			conn[i][0]= conn[i][c+1] = color;
		}
		for (i=0;i<c+2;i++){
			conn[0][i]= conn[r+1][i] = color;
		}
		
		//check if all empty cells are connected to the first empty cell found
		for (i=1;i<r+1;i++)
			for (j=1;j<c+1;j++) {
				if (b[i][j]==0) {
					return (empty != reachable(i,j));
				}
			}
		
		return false;
	}

	private static int reachable(int i, int j) {
		int reached = 1;
		conn[i][j] = color;
		if (b[i][j]==0){
			//color adjacent empty cells
			if(conn[i-1][j-1]!=color) reached +=reachable(i-1,j-1); 
			if(conn[i-1][j]!=color) reached +=reachable(i-1,j); 
			if(conn[i-1][j+1]!=color) reached +=reachable(i-1,j+1); 
			if(conn[i][j-1]!=color) reached +=reachable(i,j-1); 
			if(conn[i][j+1]!=color) reached +=reachable(i,j+1); 
			if(conn[i+1][j-1]!=color) reached +=reachable(i+1,j-1); 
			if(conn[i+1][j]!=color) reached +=reachable(i+1,j); 
			if(conn[i+1][j+1]!=color) reached +=reachable(i+1,j+1); 
		}
		return reached;
	}

	private static boolean checkNeighbor(int i, int j) {
		if (b[i-1][j-1]==0 || b[i-1][j]==0 || b[i-1][j+1]==0 ||
			b[i][j-1]==0 || b[i][j+1]==0 ||
			b[i+1][j-1]==0 || b[i+1][j]==0 || b[i+1][j+1]==0){
			return true;
		}
		return false;
	}

	private static String prettyPrint() {
		int i,j;
		boolean clicked = false;
		StringBuilder sb = new StringBuilder();
		for (i=0;i<r;i++){
			for (j=0;j<c;j++){
				if(b[i+1][j+1]==0){
					if (!clicked) {
						sb.append("c");
						clicked = true;
					}
					else sb.append(".");
				}
				else {
				 if(b[i+1][j+1]>=MAX)
					sb.append("*");
				 else 
					sb.append(".");
				}
			}
			if(i<r-1) sb.append("\n");
		}
		return sb.toString();
	}
	
	private static String fakePrint() {
		int i,j;
		StringBuilder sb = new StringBuilder();
		for (i=0;i<r;i++){
			for (j=0;j<c;j++){
					if(i<r-1 || (i==r-1 && j < c-1))
							sb.append("*");
					else sb.append("c");
				}
			if(i<r-1) sb.append("\n");
		}
		return sb.toString();
	}
	
}
