import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Scanner;
import java.util.Set;

/**
 * The server side implementation of the RPC service.
 */

public class War {

    final static String WORK_DIR = "C:\\Users\\aravinda\\Downloads\\D-small-attempt0.in" ;
	//final static String WORK_DIR = "C:\\Users\\aravinda\\workspace\\gcj2k14\\src\\inputs\\war.in" ;
	
    
    private void solve(Scanner sc) {
    	

    	int n = sc.nextInt();
    	ArrayList<Double> naomi = new ArrayList<Double>();
    	ArrayList<Double> ken = new ArrayList<Double>();
    	for (int i = 0; i < n; i++) 
    	{
    		naomi.add(sc.nextDouble());
		}
    	
    	for (int i = 0; i < n; i++) 
    	{
    		ken.add(sc.nextDouble());
		}
    	
    	ArrayList<Double> naomiWar = new ArrayList<Double>();
    	naomiWar.addAll(naomi);
    	ArrayList<Double> kenWar = new ArrayList<Double>();
    	kenWar.addAll(ken);

    	int naomiDeceitScore = deceitPlay(naomiWar, kenWar);
    	int naomiWarScore = warPlay(naomi, ken);
    	//System.out.println("naomi war "+naomiWarScore);
    	System.out.println(naomiDeceitScore+" "+naomiWarScore);
	}

	private int deceitPlay(ArrayList<Double> naomiWar, ArrayList<Double> kenWar) 
	{
    	Collections.sort(naomiWar);
    	Collections.sort(kenWar);
    	Collections.reverse(kenWar);
    	int count = 0;
    	int size = naomiWar.size();
    	int naomiScore = 0;
    	while(count < size) 
    	{
    		Double naomiDeal = naomiWar.get(count);
    		int kenIndex = findClosestMatch(naomiDeal, kenWar);
    		if (kenIndex != -1)
    		{
    			Double naomiPiece = naomiWar.get(count);
    			Double kenPiece = kenWar.remove(kenIndex);
    			//System.out.println("removine n:k "+naomiPiece+":"+kenPiece);
    			naomiScore++;
    		}
    		count++;			
		}		
		return naomiScore;
	}

	private int findClosestMatch(Double naomiDeal, ArrayList<Double> kenWar) {
		for (int i = 0; i < kenWar.size(); i++) 
		{
			Double kensPiece = kenWar.get(i);
			//System.out.println("checking "+naomiDeal+"-"+kensPiece);
			if(naomiDeal > kensPiece)
			{
				//System.out.println("matching piece "+naomiDeal+"-"+kensPiece);
				return i;
			}
		}
		return -1;
	}

	private int warPlay(ArrayList<Double> naomi, ArrayList<Double> ken) {
		//normalStrategy
    	Collections.sort(naomi);
    	Collections.reverse(naomi);
    	Collections.sort(ken);
    	
    	int naomiScore = play(naomi, ken);
		return naomiScore;
	}

	private int play(ArrayList<Double> naomi, ArrayList<Double> ken) {
		int naomiScore= 0;
    	int kenScore= 0;
    	while(true)
    	{
    		if (naomi.size()==0)
    			break;
    		
    		double naomiDeal = naomi.remove(0);
    		int kenIndex = kensBestMove(ken, naomiDeal);
    		Double kenDeal = ken.remove(kenIndex);
    		if(kenDeal > naomiDeal)
    		{
    			kenScore++;
    		}
    		else
    		{
    			naomiScore++;
    		}    	
    	}
		return naomiScore;
	}
	
	private int kensBestMove(ArrayList<Double> ken, double naomiDeal) {
		int kenSize = ken.size();
		if(ken.get(kenSize-1) < naomiDeal)
			return 0;
		int i;
		for (i = 0; i < ken.size(); i++) {
			if(ken.get(i) > naomiDeal)
				break;
		}
		return i;
	}

	public static void main(String args[]) throws FileNotFoundException 
	{
    	Scanner sc = new Scanner(new FileReader(WORK_DIR));
        int caseCnt = sc.nextInt();
        for (int caseNum=0; caseNum<caseCnt; caseNum++) {
            System.out.print("Case #" + (caseNum+1) + ": ");
            new War().solve(sc);
        }
        sc.close();
	}

}
