import java.io.*;
import java.util.*;

public class CodeJamQualificationA 
{
	private static void solve() throws IOException {
		int T = nextInt();
		for(int t = 1; t <= T; t++) {
			String[] board = new String[4];
			for(int i = 0; i < 4; i++) {
				board[i] = nextToken();
			}
			int[][] vertCount = new int[2][4];
			int[][] horiCount = new int[2][4];
			int[] upperLeftCount = new int[2];
			int[] upperRightCount = new int[2];
			for(int i = 0; i < 2; i++) {
				Arrays.fill(vertCount[i], 0);
				Arrays.fill(horiCount[i], 0);
				upperLeftCount[i] = 0;
				upperRightCount[i] = 0;
			}
			boolean finished = true;
			for(int i = 0; i < 4; i++) {
				for(int j = 0; j < 4; j++) {
					if(board[i].charAt(j) == 'X') {
						vertCount[0][j]++;
						horiCount[0][i]++;
						if(i == j) {
							upperLeftCount[0]++;
						}
						if(3 - i == j) {
							upperRightCount[0]++;
						}
					} else if (board[i].charAt(j) == 'O') {
						vertCount[1][j]++;
						horiCount[1][i]++;
						if(i == j) {
							upperLeftCount[1]++;
						}
						if(3 - i == j) {
							upperRightCount[1]++;
						}
					} else if (board[i].charAt(j) == 'T') {
						vertCount[0][j]++;
						horiCount[0][i]++;
						vertCount[1][j]++;
						horiCount[1][i]++;
						if(i == j) {
							upperLeftCount[0]++;
							upperLeftCount[1]++;
						}
						if(3 - i == j) {
							upperRightCount[0]++;
							upperRightCount[1]++;
						}
					} else {
						finished = false;
					}
				}
			}
			String res = "";
			for(int i = 0; i < 4; i++) {
				if(vertCount[0][i] == 4 || horiCount[0][i] == 4 || upperLeftCount[0] == 4 || upperRightCount[0] == 4) {
					res = "X won";
				}
				if(vertCount[1][i] == 4 || horiCount[1][i] == 4 || upperLeftCount[1] == 4 || upperRightCount[1] == 4) {
					res = "O won";
				}
			}
			if(res.equals("")) {
				if(finished) {
					res = "Draw";
				} else {
					res = "Game has not completed";
				}
			}
			out.println("Case #" + t + ": " + res);
		}
	}
	
	public static void main(String[] args) {
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter(new FileWriter("output.txt"));
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(239);
		}
	}

	static BufferedReader br;
	static StringTokenizer st;
	static PrintWriter out;

	static String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String line = br.readLine();
			if (line == null) {
				return null;
			}
			st = new StringTokenizer(line);
		}
		return st.nextToken();
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	static long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}

	static double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
}