import static org.apache.commons.lang3.builder.EqualsBuilder.reflectionEquals;
import static org.apache.commons.lang3.builder.HashCodeBuilder.reflectionHashCode;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class Dijkstra {

	private static Scanner scanner = new Scanner(System.in);
	private static PrintWriter sortie;

	private static char[] LETTERS = {'i', 'j', 'k'};

	private static Map<String, Number> MAP = new HashMap<>();

	public static void main(String[] args) {
		start();

		MAP.put("11", new Number('1', true));
		MAP.put("1i", new Number('i', true));
		MAP.put("1j", new Number('j', true));
		MAP.put("1k", new Number('k', true));
		MAP.put("i1", new Number('i', true));
		MAP.put("ii", new Number('1', false));
		MAP.put("ij", new Number('k', true));
		MAP.put("ik", new Number('j', false));
		MAP.put("j1", new Number('j', true));
		MAP.put("ji", new Number('k', false));
		MAP.put("jj", new Number('1', false));
		MAP.put("jk", new Number('i', true));
		MAP.put("k1", new Number('k', true));
		MAP.put("ki", new Number('j', true));
		MAP.put("kj", new Number('i', false));
		MAP.put("kk", new Number('1', false));

	    int T = scanner.nextInt();

	    for (int i = 0; i < T; i++) {
	    	int L = scanner.nextInt(), X = scanner.nextInt();
	    	scanner.nextLine();

	    	String s = scanner.nextLine();

	    	System.out.println(i + " " + s +" "+ X);
			sortie.println("Case #" + (i + 1) + ": " + dijkstra(X, s, X * s.length(), new Number('1', true), new HashSet<Calcul>(), 0, 0));
	    }

	    end();
	}

	private static String dijkstra(int x, String input, int length, Number previousChar, Set<Calcul> alreadySeen, int index, int beginI) {
		if (index == 2) {
			for (int i = beginI; i < length; i++) {
				char c = input.charAt(i % input.length());

				setNewResult(previousChar, c);

				if (i == length - 1) {
					return previousChar.positive && previousChar.num == 'k' ? "YES" : "NO";
				}
			}

		} else {
			for (int i = beginI; i < length; i++) {
				char c = input.charAt(i % input.length());

				Calcul calcul = new Calcul(new Number(previousChar.num, previousChar.positive), c);

				if (alreadySeen.contains(calcul)) {
					return "NO";
				} else {
					alreadySeen.add(calcul);
				}

				setNewResult(previousChar, c);

				if (previousChar.positive && previousChar.num == LETTERS[index]) {
					if (index == 2 && i == length - 1) {
						return "YES";
					} else if (index != 2) {
						if (dijkstra(x, input, length, new Number('1', true), new HashSet<Calcul>(), index + 1, i + 1) == "YES") {
							return "YES";
						} else {
							alreadySeen = new HashSet<>();
						}
					} else {
						alreadySeen = new HashSet<>();
					}
				}
			}
		}

		return "NO";
	}

	private static void setNewResult(Number previousChar, char c) {
		String result = previousChar.num + "" + c;

		Number res = MAP.get(result);

		previousChar.num = res.num;
		previousChar.positive = res.positive ? previousChar.positive : !previousChar.positive;
	}


	private static class Calcul {
		Number num;
		char c;

		public Calcul(Number num, char c) {
			this.num = num;
			this.c = c;
		}

		@Override public int hashCode() { return reflectionHashCode(this); }
		@Override public boolean equals(Object other) { return reflectionEquals(this, other); }

		public String toString() {
			return num.num + " " + num.positive + " " + c;
		}
	}

	private static class Number {
		char num;
		boolean positive;

		public Number(char num, boolean positive) {
			if (num != 'i' && num != 'j' && num != '1' && num != 'k') {
				throw new IllegalArgumentException(num+"");
			}
			this.num = num;
			this.positive = positive;
		}

		@Override public int hashCode() { return reflectionHashCode(this); }
		@Override public boolean equals(Object other) { return reflectionEquals(this, other); }

		public String toString() {
			return "[" + num + "," + positive + "]";
		}
	}



	//////////// UTILITIES

	private static void end() {
	    sortie.close();
	    try {
		    InputStream ips=new FileInputStream("C:\\Users\\Thomas\\Desktop\\output.txt");
			InputStreamReader ipsr=new InputStreamReader(ips);
			BufferedReader br=new BufferedReader(ipsr);
			String ligne;
			while ((ligne=br.readLine())!=null) System.out.println(">>>> " + ligne);
			br.close();
	    } catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static void start() {
		try {
			sortie =  new PrintWriter(new BufferedWriter(new FileWriter("C:\\Users\\Thomas\\Desktop\\output.txt")));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
