import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

import javafx.util.Pair;

public class BathroomStalls {

	private static final String OUTPUT_FILE = "/Users/grillett/Downloads/output.txt";
	private static Scanner scanner = new Scanner(System.in);
	private static PrintWriter out;

	public static void main(String[] args) {
		start();

        int T = scanner.nextInt();

	    for (int i = 0; i < T; i++) {
           long N = scanner.nextLong();
           long K = scanner.nextLong();

           Pair<Long, Long> result = compute(N, K);

            out.println(String.format("Case #%s: %s %s", i + 1, result.getKey(), result.getValue()));
        }

	    end();
	}

    private static Pair<Long, Long> compute(long n, long k) {
	    if (n == k) {
            return new Pair<>(0L, 0L);
        }
        List<Long> stalls = new LinkedList<>();

        stalls.add(n);

        for (int i = 0; i < k; i++) {
            int choice = -1;
            long minChoice = Long.MIN_VALUE;
            long maxChoice = Long.MAX_VALUE;

            for (int j = 0; j < stalls.size(); j++) {
                Long stall = stalls.get(j);

                long middle = (stall % 2 == 0 ? stall : stall + 1) >> 1;
                long ls = middle - 1;
                long rs = stall - middle;

                long min = Math.min(ls, rs);
                long max = Math.max(ls, rs);

                if (min > minChoice || (min == minChoice && max > maxChoice)) {
                    choice = j;
                    minChoice = min;
                    maxChoice = max;
                }
            }

            Long stall = stalls.get(choice);

            long middle = (stall % 2 == 0 ? stall : stall + 1) >> 1;
            long ls = middle - 1;
            long rs = stall - middle;

            if (i == k -1) {
                return new Pair<>(maxChoice, minChoice);
            } else {
                stalls.remove(choice);
                stalls.add(choice, rs);
                stalls.add(choice, ls);
            }
        }

	    throw new IllegalStateException("Shouldn't reach that point");
    }

	//////////// UTILITIES

	private static void end() {
	    out.close();
	    try (BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(OUTPUT_FILE)))) {
			String line;
			while ((line=br.readLine()) != null) System.out.println(line);
	    } catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static void start() {
		try {
			out = new PrintWriter(new BufferedWriter(new FileWriter(OUTPUT_FILE)));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
