import java.math.BigInteger;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

import static java.math.BigInteger.valueOf;
import static util.FileHandler.OUT;
import static util.FileHandler.end;
import static util.FileHandler.start;

public class Insomnia {
    public static final String INSOMNIA = "INSOMNIA";
    private static final int MAX = 900000;

    public static void main(String[] args) {
        start();

        Scanner scanner = new Scanner(System.in);
        int N = scanner.nextInt();

        for (int i = 1; i <= N; i++) {
            OUT.println(String.format("Case #%s: %s", i, solve(scanner.nextInt())));
        }

        end();
    }

    private static String solve(int n) {
        if (n == 0) {
            return INSOMNIA;
        }

        BigInteger initialNumber = valueOf(n);
        BigInteger number = valueOf(n);
        Set<Integer> digits = new HashSet<>();

        for (int i = 0; i < MAX; i++) {
            String s = number.toString();

            for (int j = 0; j < s.length(); j++) {
                digits.add(s.charAt(j) - '0');
            }

            if (digits.size() == 10) {
                return s;
            }

            number = number.add(initialNumber);
        }

        return INSOMNIA;
    }

}
