import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Scanner;

public class Pancakes {

	private static final String OUTPUT_FILE = "/Users/grillett/Downloads/output.txt";
	private static Scanner scanner = new Scanner(System.in);
	private static PrintWriter out;

	public static void main(String[] args) {
		start();

        int T = scanner.nextInt();
        scanner.nextLine();

	    for (int i = 0; i < T; i++) {
            String[] split = scanner.nextLine().split(" ");

            int n = flip(split[0].toCharArray(), Integer.parseInt(split[1]));

            out.println(String.format("Case #%s: %s", i + 1, n == -1 ? "IMPOSSIBLE" : n));
        }

	    end();
	}

    private static int flip(char[] s, int k) {
	    int flipCount = 0;

        for (int i = 0; i <= s.length - k; i++) {
            if (s[i] == '-') {
                flipCount++;
                for (int j = i; j < i + k; j++) {
                    s[j] = s[j] == '-' ? '+' : '-';
                }
            }
        }

        for (int i = 0; i < s.length; i++) {
            if (s[i] == '-') {
                return -1;
            }
        }

        return flipCount;
    }


    //////////// UTILITIES

	private static void end() {
	    out.close();
	    try (BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(OUTPUT_FILE)))) {
			String line;
			while ((line=br.readLine()) != null) System.out.println(line);
	    } catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static void start() {
		try {
			out = new PrintWriter(new BufferedWriter(new FileWriter(OUTPUT_FILE)));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
