import static java.lang.Long.parseLong;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Scanner;

public class TidyNumbers {

	private static final String OUTPUT_FILE = "/Users/grillett/Downloads/output.txt";
	private static Scanner scanner = new Scanner(System.in);
	private static PrintWriter out;

	public static void main(String[] args) {
		start();

        int T = scanner.nextInt();

	    for (int i = 0; i < T; i++) {
           long n = scanner.nextLong();

           while (!isTidy(n)) {
               n = findClosest(n - 1);
           }

            out.println(String.format("Case #%s: %s", i + 1, n));
        }

	    end();
	}

	private static long findClosest(long number) {
	    if (number < 10) {
	        return number;
        }

        char[] s = String.valueOf(number).toCharArray();

        boolean delete = false;
        for (int i = 1; i < s.length; i++) {
            if (s[i] < s[i - 1]) {
                delete = true;
            }

            if (delete) {
                s[i] = '0';
            }
        }

        return parseLong(new String(s));
    }

	private static boolean isTidy(long number) {
        String s = String.valueOf(number);

        int value = 0;
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) >= value) {
                value = s.charAt(i);
            } else {
                return false;
            }
        }

        return true;
    }

	//////////// UTILITIES

	private static void end() {
	    out.close();
	    try (BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(OUTPUT_FILE)))) {
			String line;
			while ((line=br.readLine()) != null) System.out.println(line);
	    } catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static void start() {
		try {
			out = new PrintWriter(new BufferedWriter(new FileWriter(OUTPUT_FILE)));
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
