package gcj2011;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Scanner;

public class QR_B_Magicka extends CodeJamBase {

	public static void main(String[] args) {
		CodeJamBase base = new QR_B_Magicka();
		base.solve(args);
	}

	@Override
	public void doSolve(BufferedReader reader, BufferedWriter writer)
			throws IOException {

		// Set up base table
		char[] baseTable = new char[] { 'Q', 'W', 'E', 'R', 'A', 'S', 'D', 'F' };
		int baseSize = baseTable.length;
		int[] baseIndexes = new int['Z' + 1];
		Arrays.fill(baseIndexes, -1);
		for (int i = 0; i < baseSize; i ++) baseIndexes[baseTable[i]] = i;

		String line = reader.readLine();
		try {
			int T = Integer.parseInt(line);
			Scanner scanner = new Scanner(reader);
			for (int t = 1; t <= T; t ++) {

				// Set up composition table
				char[][] compositionTable = new char[baseSize][baseSize];
				int C = scanner.nextInt();
				for (int c = 0; c < C; c ++) {
					String composition = scanner.next();
					int a = baseIndexes[composition.charAt(0)];
					int b = baseIndexes[composition.charAt(1)];
					char ab = composition.charAt(2);
					compositionTable[a][b] = ab;
					compositionTable[b][a] = ab;
				}

				// Set up opposite table
				boolean[][] oppositeTable = new boolean[baseSize][baseSize];
				int D = scanner.nextInt();
				for (int d = 0; d < D; d ++) {
					String pair = scanner.next();
					int a = baseIndexes[pair.charAt(0)];
					int b = baseIndexes[pair.charAt(1)];
					oppositeTable[a][b] = true;
					oppositeTable[b][a] = true;
				}

				// Invoke
				LinkedList<Character> result = new LinkedList<Character>();
				int[] baseCount = new int[baseSize];
				char lastChar = 0;
				int N = scanner.nextInt();
				String input = scanner.next();
				S: for (int n = 0; n < N; n ++) {
					char chr = input.charAt(n);
					if (baseIndexes[chr] >= 0) {
						int a = baseIndexes[chr];

						// Check composition
						if (baseIndexes[lastChar] >= 0) {
							int b = baseIndexes[lastChar];
							char c = compositionTable[a][b];
							if (c != 0) {
								result.removeLast();
								baseCount[b] --;
								result.addLast(c);
								lastChar = c;
								continue;
							}
						}

						// Check pair appearance
						for (int b = 0; b < baseSize; b ++) {
							if (oppositeTable[a][b] &&
									(baseCount[b] > 0)) {
								Arrays.fill(baseCount, 0);
								lastChar = 0;
								result.clear();
								continue S;
							}
						}
						baseCount[a] ++;
					}

					result.addLast(chr);
					lastChar = chr;
				}

				writer.write("Case #" + t + ": [");
				boolean isFirst = true;
				for (Character c : result) {
					if (isFirst) {
						isFirst = false;
					} else {
						writer.write(", ");
					}
					writer.write(c);
				}
				writer.write("]");
				writer.newLine();
			}
		} catch (NumberFormatException nfe) {}
	}
}
