import java.io.BufferedReader;

import java.io.BufferedWriter;
import java.io.IOException;


/**
 * Solver class for "Watersheds".
 *
 * @author arcatdmz
 */
public class Watersheds extends CodeJamBase {
	public static void main(String[] args) {
		new Watersheds(args);
	}
	public Watersheds(String[] args) {
		super(args);
	}

	@Override
	public void solve(BufferedReader reader, BufferedWriter writer) throws IOException {

		// Get the first line.
		String line = reader.readLine();

		try {
			int T = Integer.parseInt(line);

			// Check maps.
			for (int t = 1; t <= T; t ++) {
				writer.write("Case #"+t+":");
				writer.newLine();
				solveMap(reader, writer);
			}

		} catch (NumberFormatException nfe) {
			System.err.println("Illegal file format.");
		}
	}

	private void solveMap(BufferedReader reader, BufferedWriter writer) throws IOException, NumberFormatException {

		// Get the first line for a map.
		String line = reader.readLine();
		String[] sizeOptions = line.split(" ");
		int H = Integer.parseInt(sizeOptions[0]);
		int W = Integer.parseInt(sizeOptions[1]);

		// Construct a map.
		WatershedsMap map = new WatershedsMap(reader, H, W);
		map.write(writer);
	}
}
