import java.util.HashSet;

public class AlienCandidate {
	private AlienCandidate childToken;
	private HashSet<Character> possibleStates;

	public AlienCandidate(String string) {
		this();
		add(string);
	}

	private AlienCandidate() {
		childToken = null;
		possibleStates = new HashSet<Character>();
	}

	/**
	 * Parse pattern string and construct this object.
	 * @param string
	 */
	private void add(String string) {
		final char c = string.charAt(0);

		// Multiple possible tokens are found.
		if (c == '(') {
			for (int i = 1; i < string.length(); i++) {
				final char curc = string.charAt(i);
				if (curc == ')') {
					string = string.substring(i);
					break;
				}
				possibleStates.add(curc);
			}

		// Single possible token is found.
		} else {
			possibleStates.add(c);
		}

		// Parse the rest.
		if (string.length() > 1) {
			if (childToken == null) {
				childToken = new AlienCandidate();
			}
			childToken.add(string.substring(1));
		}
	}

	public boolean contains(char c) {
		return possibleStates.contains(c);
	}

	public AlienCandidate getChildToken() {
		return childToken;
	}
}