import java.io.BufferedReader;

import java.io.BufferedWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map.Entry;


/**
 * Solver class for "Alien Language".
 *
 * @author arcatdmz
 */
public class AlienLanguage extends CodeJamBase {
	public static void main(String[] args) {
		new AlienLanguage(args);
	}
	public AlienLanguage(String[] args) {
		super(args);
	}

	@Override
	public void solve(BufferedReader reader, BufferedWriter writer) throws IOException {

		// Get the first line.
		String line = reader.readLine();
		String[] options = line.split(" ");

		try {
			int L = Integer.parseInt(options[0]);
			int D = Integer.parseInt(options[1]);
			int N = Integer.parseInt(options[2]);

			// Construct a word library.
			AlienLibrary library = new AlienLibrary();
			for (int d = 0; d < D; d ++) {
				library.add(reader.readLine());
			}

			// Check each cases
			for (int n = 1; n <= N; n ++) {
				AlienCandidate candidate =
						new AlienCandidate(reader.readLine());
				writer.write("Case #"+n+": "+
						library.getMatched(candidate));
				writer.newLine();
			}

		} catch (NumberFormatException nfe) {
			System.err.println("Illegal file format.");
		}
	}
}
