import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class BathroomStalls {

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);

        int numOfTestCases = s.nextInt();
        for (int i = 0; i < numOfTestCases; i++) {
            int n = s.nextInt();
            int k = s.nextInt();

            boolean[] stalls = new boolean[n + 1];

            int countLs = 0;
            int countRs = 0;
            for (int j = 0; j < k; j++) {
                List<Integer> possibly = getAppropriaties(stalls);

                possibly = eliminate(stalls, possibly);

                int suitStallIndex = possibly.get(0);

                stalls[suitStallIndex] = true;

                countLs = countLs(stalls, suitStallIndex);
                countRs = countRs(stalls, suitStallIndex);
            }

            System.out.println(
                    "Case #" + i + ": " + 
                    Math.max(countLs, countRs) + " " + 
                    Math.min(countLs, countRs)
            );
        }
    }

    static List<Integer> getAppropriaties(boolean[] stalls) {
        List<Integer> possibly = new ArrayList<>();

        int min = Integer.MIN_VALUE;
        for (int i = 1; i < stalls.length; i++) {
            if (stalls[i]) {
                continue;
            }

            int currLs = countLs(stalls, i);
            int currRs = countRs(stalls, i);

            if (Math.min(currLs, currRs) > min) {
                min = Math.min(currLs, currRs);

                possibly.clear();
                possibly.add(i);
            } else if (Math.min(currLs, currRs) == min) {
                possibly.add(i);
            }
        }

        return possibly;
    }

    static List<Integer> eliminate(boolean[] stalls, List<Integer> possibly) {
        List<Integer> newPossibly = new ArrayList<>();

        int max = Integer.MIN_VALUE;
        for (Integer index : possibly) {
            int currLs = countLs(stalls, index);
            int currRs = countRs(stalls, index);

            if (Math.max(currLs, currRs) > max) {
                max = Math.max(currLs, currRs);

                newPossibly.clear();
                newPossibly.add(index);
            } else if (Math.max(currLs, currRs) == max) {
                newPossibly.add(index);
            }
        }

        return newPossibly;
    }

    static int countLs(boolean[] stalls, int i) {
        if (i == 1) {
            return 0;
        }

        int count = 0;
        for (int j = i - 1; j > 0; j--) {
            if (stalls[j]) {
                return count;
            }
            count++;
        }

        return count;
    }

    static int countRs(boolean[] stalls, int i) {
        if (i == stalls.length - 1) {
            return 0;
        }

        int count = 0;
        for (int j = i + 1; j < stalls.length; j++) {
            if (stalls[j]) {
                return count;
            }
            count++;
        }

        return count;
    }
}
