import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Scanner;
import javafx.scene.layout.Priority;

public class BathroomStalls1 {

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);

        int numOfTestCases = s.nextInt();
        for (int i = 0; i < numOfTestCases; i++) {
            int n = s.nextInt();
            int k = s.nextInt();

            int index = 1;
            PriorityQueue<Node> pQ = new PriorityQueue<>(new Comparator<Node>() {
                @Override
                public int compare(Node o1, Node o2) {
                    int len1 = o1.r - o1.l + 1;
                    int len2 = o2.r - o2.l + 1;

                    if (len1 > len2) {
                        return -1;
                    } else if (len1 < len2) {
                        return 1;
                    } else //len1 == len2
                    if (o1.l < o2.l) {
                        return -1;
                    } else {
                        return 1;
                    }
                }
            });
            
            boolean[] stalls = new boolean[n + 1];

            pQ.add(new Node(1, n, index));

            int keep = 0;
            while (k > 0 && !pQ.isEmpty()) {
                Node node = pQ.remove();

                int m = (int) ((node.l + node.r) / 2.0);
                stalls[m] = true;

//                System.out.println(m);
                Node nL = new Node(node.l, m - 1, index + 1);

                Node nR = new Node(m + 1, node.r, index + 2);

                pQ.add(nL);
                pQ.add(nR);

                index += 2;

                k--;
                
                keep = m;
            }
            
            int countLs = countLs(stalls, keep);
            int countRs = countRs(stalls, keep);
            
            System.out.println(
                    "Case #" + (i + 1) + ": " + 
                    Math.max(countLs, countRs) + " " + 
                    Math.min(countLs, countRs)
            );
        }
    }
    
    static int countLs(boolean[] stalls, int i) {
        if (i == 1) {
            return 0;
        }

        int count = 0;
        for (int j = i - 1; j > 0; j--) {
            if (stalls[j]) {
                return count;
            }
            count++;
        }

        return count;
    }

    static int countRs(boolean[] stalls, int i) {
        if (i == stalls.length - 1) {
            return 0;
        }

        int count = 0;
        for (int j = i + 1; j < stalls.length; j++) {
            if (stalls[j]) {
                return count;
            }
            count++;
        }

        return count;
    }

    public static class Node {

        int l;
        int r;
        int p;

        public Node(int l, int r, int p) {
            this.l = l;
            this.r = r;
            this.p = p;
        }
    }
}

