import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class RollerCoaster
{
	public static void main(String[] args)
	{
		File inputFile = null;
		File outputFile = null;
		BufferedReader br = null;
		BufferedWriter bw = null;
		String str = null;
		int nTestCase = 0;
		Long[] nRides = null;
		Long[] nPeopleInRide = null;
		Integer[] nGroups = null;
		Long[][] groups = null;
		List<Long> groupsOutRide = null;
		String[] spiltStr = null;
		long euro = 0;

		try
		{
			inputFile = new File("D:\\Archana\\Google Code Jam\\2010 Contest\\sample_QR_C_small.in");
			outputFile = new File("D:\\Archana\\Google Code Jam\\2010 Contest\\sample_QR_C_small.out");
			br = new BufferedReader(new FileReader(inputFile));
			bw = new BufferedWriter(new FileWriter(outputFile));

			if ((str = br.readLine()) != null)
			{
				nTestCase = Integer.valueOf(str);
				nRides = new Long[nTestCase];
				nPeopleInRide = new Long[nTestCase];
				nGroups = new Integer[nTestCase];
				groups = new Long[nTestCase][];
			}

			for (int i = 0; i < nTestCase; i++)
			{
				if ((str = br.readLine()) != null)
				{
					spiltStr = str.split(" ");
					if (spiltStr != null && spiltStr.length == 3)
					{
						nRides[i] = Long.valueOf(spiltStr[0]);
						nPeopleInRide[i] = Long.valueOf(spiltStr[1]);
						nGroups[i] = Integer.valueOf(spiltStr[2]);
						groups[i] = new Long[nGroups[i]];

						if ((str = br.readLine()) != null)
						{
							spiltStr = str.split(" ");
							if (spiltStr != null && spiltStr.length == nGroups[i])
							{
								for (int j = 0; j < nGroups[i]; j++)
								{
									groups[i][j] = Long.valueOf(spiltStr[j]);
								}
							}
						}
					}
				}
			}

			for (int i = 0; i < nTestCase; i++)
			{
				euro = 0;
				groupsOutRide = Arrays.asList(groups[i]);
				for (int j = 0; j < nRides[i]; j++)
				{
					long sumOfPeople = 0;
					int count = -1;
					while (true)
					{
						sumOfPeople += groups[i][++count];
						if (sumOfPeople > nPeopleInRide[i])
						{
							sumOfPeople -= groups[i][count];
							euro += sumOfPeople;
							break;
						}
						if (count + 1 >= nGroups[i])
						{
							euro += sumOfPeople;
							break;
						}
					}
					Collections.rotate(groupsOutRide, -(count));
				}

				bw.write("Case #" + (i + 1) + ": " + euro);
				bw.newLine();
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		finally
		{
			try
			{
				if (br != null)
				{
					br.close();
				}
				if (bw != null)
				{
					bw.flush();
					bw.close();
				}
			}
			catch (IOException e)
			{
				e.printStackTrace();
			}
		}
	}
}
