package com.jam.qualify;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Date;
import java.util.Scanner;

public class TicTacToeTomek
{
	static int[][]			board		= new int[4][4];
	static String			result		= "";
	static String			X_WON		= "X won";
	static String			O_WON		= "O won";
	static String			DRAW		= "Draw";
	static String			NOT_OVER	= "Game has not completed";
	static BufferedWriter	bw;

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		try
		{
			System.out.println("Start Time :: " + new Date());
			int X = 'X'; // 88
			int O = 'O'; // 79
			int dot = '.'; // 46
			int T = 'T'; // 84

			Scanner in = new Scanner(new BufferedReader(new FileReader(new File("IN\\sample.in"))));
			bw = new BufferedWriter(new FileWriter(new File("OUT\\sample.out")));
			int nTestCase = in.nextInt();
			for (int i = 0; i < nTestCase; i++)
			{
				board = new int[4][4];
				result = "";
				boolean mayBeDraw = false;
				System.out.println("Test Case :: #" + (i + 1));
				for (int j = 0; j < 4; j++)
				{
					String line = in.next();
					if (result.equals(""))
					{
						for (int k = 0; k < 4; k++)
						{
							char ch = line.charAt(k);
							mayBeDraw = (ch == dot) ? true : mayBeDraw;
							board[j][k] = ch;
						}
						if (checkIfHorizontal(j))
						{
							bw.write("Case #" + (i + 1) + ": " + result + "\n");
							System.out.println("Case #" + (i + 1) + ": " + result + "\n");
						}
					}
				}
				if (result.equals(""))
				{
					if (checkIfVertical())
					{
						bw.write("Case #" + (i + 1) + ": " + result + "\n");
						System.out.println("Case #" + (i + 1) + ": " + result + "\n");
						continue;
					}
					if (checkIfDiagonal())
					{
						bw.write("Case #" + (i + 1) + ": " + result + "\n");
						System.out.println("Case #" + (i + 1) + ": " + result + "\n");
						continue;
					}
					result = mayBeDraw ? NOT_OVER : DRAW;
					bw.write("Case #" + (i + 1) + ": " + result + "\n");
					System.out.println("Case #" + (i + 1) + ": " + result + "\n");
				}
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		finally
		{
			try
			{
				bw.close();
			}
			catch (IOException e)
			{
				e.printStackTrace();
			}
			System.out.println("End Time :: " + new Date());
		}
	}

	static boolean checkIfHorizontal(int row)
	{
		if (board[row][0] >= 84 && board[row][1] >= 84 && board[row][2] >= 84 && board[row][3] >= 84)
		{
			result = X_WON;
			return true;
		}
		if ((board[row][0] == 84 || board[row][0] == 79) && (board[row][1] == 84 || board[row][1] == 79) && (board[row][2] == 84 || board[row][2] == 79) && (board[row][3] == 84 || board[row][3] == 79))
		{
			result = O_WON;
			return true;
		}
		return false;
	}

	static boolean checkIfVertical()
	{
		for (int col = 0; col < 4; col++)
		{
			if (board[0][col] >= 84 && board[1][col] >= 84 && board[2][col] >= 84 && board[3][col] >= 84)
			{
				result = X_WON;
				return true;
			}
			if ((board[0][col] == 84 || board[0][col] == 79) && (board[1][col] == 84 || board[1][col] == 79) && (board[2][col] == 84 || board[2][col] == 79) && (board[3][col] == 84 || board[3][col] == 79))
			{
				result = O_WON;
				return true;
			}
		}
		return false;
	}

	static boolean checkIfDiagonal()
	{
		if (board[0][0] >= 84 && board[1][1] >= 84 && board[2][2] >= 84 && board[3][3] >= 84)
		{
			result = X_WON;
			return true;
		}
		if ((board[0][0] == 84 || board[0][0] == 79) && (board[1][1] == 84 || board[1][1] == 79) && (board[2][2] == 84 || board[2][2] == 79) && (board[3][3] == 84 || board[3][3] == 79))
		{
			result = O_WON;
			return true;
		}
		if (board[0][3] >= 84 && board[1][2] >= 84 && board[2][1] >= 84 && board[3][0] >= 84)
		{
			result = X_WON;
			return true;
		}
		if ((board[0][3] == 84 || board[0][3] == 79) && (board[1][2] == 84 || board[1][2] == 79) && (board[2][1] == 84 || board[2][1] == 79) && (board[3][0] == 84 || board[3][0] == 79))
		{
			result = O_WON;
			return true;
		}
		return false;
	}
}
