package com.archerintel.codejam;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class MagicTrick {
	
	private static final String SMALL_IN_FILE_NAME = "A-small-attempt2.in";
	private static final String SMALL_OUT_FILE_NAME = "A-small-attempt2.out";
	private static final String LARGE_IN_FILE_NAME = "B-large-practice.in";
	private static final String LARGE_OUT_FILE_NAME = "B-large-output.out";
	private static final Charset ENCODING = StandardCharsets.ISO_8859_1;
	private static final String badMagic = "Bad magician!";
	private static final String cheated = "Volunteer cheated!";
	private static final int sideLength = 4;
	
	public static List<Integer> rowMatches(int row1, int grid1[][], int row2, int grid2[][]) {
		List<Integer> matches = new ArrayList<>();
		
		for (int i : grid1[row1 - 1]) {
			for (int j : grid2[row2 -1]) {
				if (i == j) {
					matches.add(i);
				}
			}
		}
		
		
		return matches;
	}

	public static void main(String[] args) {
		Scanner inScan = null;
		PrintWriter writer = null;
		int numTestCases;
		int grid1[][] = new int[sideLength][sideLength];
		int grid2[][] = new int[sideLength][sideLength];
		int row1;
		int row2;
		String outString;
		List<Integer> rowMatches;
		
		// Set up the input and output:
		java.io.File unRead = new java.io.File(SMALL_IN_FILE_NAME);
		try {
			inScan = new Scanner(unRead);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		try {
			writer = new PrintWriter(SMALL_OUT_FILE_NAME);
		} catch (FileNotFoundException fnfExc) {
			fnfExc.printStackTrace();
		}
		
		// Read the input:
		numTestCases = inScan.nextInt();
	
		for (int i = 0; i < numTestCases; ++i) {
			
			inScan.nextLine();
			row1 = inScan.nextInt();
			
			for (int j = 0; j < sideLength; ++j) {
				inScan.nextLine();
				for (int k = 0 ; k < sideLength; ++k) {
					grid1[j][k] = inScan.nextInt();
				}
			}
		
		inScan.nextLine();
		row2 = inScan.nextInt();
		
		for (int j = 0; j < sideLength; ++j) {
			inScan.nextLine();
			for (int k = 0 ; k < sideLength; ++k) {
				grid2[j][k] = inScan.nextInt();
			}
		}
		
		rowMatches = rowMatches(row1, grid1, row2, grid2);
		switch(rowMatches.size()) {
		case 0:	
			outString = cheated;
			break;
		case 1:
			outString = rowMatches.get(0).toString();
			break;
		case 2:
		case 3:
		case 4:
		default: 
			outString = badMagic;
			break;
		}
		
		writer.println("Case #" + (i + 1) + ": " + outString);
		System.out.println("Case #" + (i + 1) + ": " + outString);

		
		
		}
		
		writer.close();
	}
}
	

