package com.archerintel.codejam;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.List;

public class ReadFile {
	private Charset m_encoding;
	private String m_fileName;
	
	ReadFile() {
		m_encoding = StandardCharsets.ISO_8859_1;
		m_fileName = "default.txt";
	}
	
	ReadFile(String fileName, Charset encoding) {
		m_encoding = encoding;
		m_fileName = fileName;
	}
	
	public List<String> readFile() throws IOException {
		Path path = Paths.get(m_fileName);
		return Files.readAllLines(path, m_encoding);
	}
	
	void SetEncoding(Charset newEncoding) {
		m_encoding = newEncoding;
	}
	
	Charset GetEncoding() {
		return m_encoding;
	}
}
