import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Set;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) throws FileNotFoundException {
//		InputStream inputStream = System.in;
		 InputStream inputStream = new
		 FileInputStream("/Users/architgoel/Downloads/A-large(1).in");
//		OutputStream outputStream = System.out;
		 OutputStream outputStream = new
		 FileOutputStream("/Users/architgoel/Downloads/output-a-large.txt");

		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskA solver = new TaskA();
		solver.solve(1, in, out);
		out.close();
	}

	static class TaskA {
		static class Node implements Comparable<Node> {
			int val;
			int lower;
			int upper;
			boolean used = false;

			@Override
			public int hashCode() {
				final int prime = 31;
				int result = 1;
				result = prime * result + val;
				return result;
			}

			@Override
			public boolean equals(Object obj) {
				if (this == obj)
					return true;
				if (obj == null)
					return false;
				if (getClass() != obj.getClass())
					return false;
				Node other = (Node) obj;
				if (val != other.val)
					return false;
				return true;
			}

			@Override
			public int compareTo(Node o) {
				return val - o.val;
			}

			@Override
			public String toString() {
				return "Node [val=" + val + ", lower=" + lower + ", upper=" + upper + ", used=" + used + "]";
			}
			

		}

		public void solve(int testNumber, InputReader in, PrintWriter out) {

			int tests = in.nextInt();

			for (int test = 1; test <= tests; test++) {
				double d = in.nextDouble();
				double n = in.nextDouble();
				double maxTime = 0;
				for(int N = 0 ;N < n;N++) {
					double k = in.nextDouble();
					double s = in.nextDouble();
					maxTime = Math.max((d-k)/s, maxTime);
				}
				double ans = d/maxTime;
				out.println("Case #" + test + ": " + ans);

				// out.println();
			}

		}

		void updateLimit(int divider, Node np) {
			np.lower = Integer.MAX_VALUE;
			np.upper = Integer.MIN_VALUE;
			for(int i = 1; divider * i <= 2000000;i++) {
				float lower = 0.9f * divider * i;
				float upper = 1.1f * divider * i;
				if (np.val >= lower && np.val <= upper) {
					np.lower = Math.min(np.lower, i);
					np.upper = Math.max(np.upper, i);
				}
			}
			if(np.lower == Integer.MAX_VALUE) np.used = true;


		}

		void populateQandMap(PriorityQueue<Long> pq, Map<Long, Long> count, Long value, Long valueCount) {
			if (!count.containsKey(value)) {
				pq.add(value);
				count.put(value, valueCount);
			} else {
				count.put(value, count.get(value) + valueCount);
			}
		}

		double getdist(double x1, double y1, double x2, double y2) {
			double p = (x2 - x1) * (x2 - x1) + (y2 - y1) * (y2 - y1);
			return Math.sqrt(p);
		}

		boolean checkPrime(long l) {
			for (long i = 2; i * i <= l; i++) {
				if (l % i == 0)
					return false;
			}
			return true;
		}

		boolean check(long a[][], long totalsum, int n) {
			long sum = 0;
			for (int i = 0; i < n; i++) {
				sum = 0;
				for (int j = 0; j < n; j++) {
					sum += a[i][j];
				}
				if (sum != totalsum)
					return false;
			}

			for (int j = 0; j < n; j++) {
				sum = 0;
				for (int i = 0; i < n; i++) {
					sum += a[i][j];
				}
				if (sum != totalsum)
					return false;
			}

			sum = 0;
			for (int i = 0; i < n; i++) {
				sum += a[i][i];
			}
			if (sum != totalsum)
				return false;

			sum = 0;
			for (int i = 0; i < n; i++) {
				sum += a[i][n - i - 1];
			}
			if (sum != totalsum)
				return false;
			return true;
		}
	}

	static class InputReader {
		public BufferedReader reader;
		public StringTokenizer tokenizer;

		public InputReader(InputStream stream) {
			reader = new BufferedReader(new InputStreamReader(stream), 32768);
			tokenizer = null;
		}

		public String next() {
			while (tokenizer == null || !tokenizer.hasMoreTokens()) {
				try {
					tokenizer = new StringTokenizer(reader.readLine());
				} catch (IOException e) {
					throw new RuntimeException(e);
				}
			}
			return tokenizer.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}

		public double nextDouble() {
			return Double.parseDouble(next());
		}

	}

}