package google.code_jam.ed2016;

import java.io.InputStream;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.LongStream;


public class Fractiles {

    public static void main(String[] args) {


        InputStream is = System.in;
        Scanner s = new Scanner(is);
        int count = s.nextInt();
        for (int i = 1; i <= count; i++) {
            int K = s.nextInt();
            int C = s.nextInt();
            int S = s.nextInt();
            List<Long> result = solve(K, C);
            String resultString = result.size() > S ? "IMPOSSIBLE"
                    : result.stream().map(n -> n.toString()).collect(Collectors.joining(" "));
            System.out.printf("Case #%d: %s%n", i, resultString);

        }

    }
    static List<Long> solve(int originalLength, int complexity) {

        if (originalLength == 1 ) {
            return Arrays.asList(1L);
        } else if (complexity == 1) {
            return LongStream.rangeClosed(1L, originalLength).mapToObj(Long::valueOf).collect(Collectors.toList());
        }

        List<Long> result = new ArrayList<>(originalLength);
        long offset = complexity == 1 ? 0 : (long) Math.pow(originalLength, complexity - 1);

        for (int i = 1; i < originalLength; i++) {
            result.add(i + 1 + (i - 1) * offset);
        }
        return result;
    }


}
