package google.code_jam.ed2016;

import java.io.InputStream;
import java.math.BigInteger;
import java.util.*;
import java.util.concurrent.ThreadLocalRandom;


public class CoinJam {

    public static void main(String[] args) {
        InputStream is = System.in;
        Scanner s = new Scanner(is);
        int count = s.nextInt();
        for (int i = 1; i <= count; i++) {
            int length = s.nextInt();
            int howMany = s.nextInt();
            List<String> result = solve(howMany, length);
            System.out.printf("Case #%d:%n", i);
            for(String line: result) {
                System.out.println(line);
            }
        }

    }

    static List<String> solve(int howMany, int length) {
        Set<String> tried = new HashSet<>();
        List<String> result = new ArrayList<>(howMany);
        long[] divisors = new long[10 - 2 + 1];
        loop:
        while (result.size() < howMany) {
            String randomCoin = randomCoin(length);
            if (!tried.add(randomCoin)) continue;

            for (int base = 2; base <= 10; base++) {
                long interpretation = Long.parseUnsignedLong(randomCoin, base);
                long divisor = findDivisor(interpretation);
                if (divisor == -1) continue loop;
                divisors[base - 2] = divisor;
            }
            StringJoiner s = new StringJoiner(" ");
            s.add(randomCoin);
            Arrays.stream(divisors).mapToObj(Long::toString).forEach(s::add);
            result.add(s.toString());
        }
        return result;
    }


    static String randomCoin(int length) {
        char[] chars = new char[length];
        chars[0] = '1';
        chars[length - 1] = '1';
        for (int i = 1; i < length - 1; i++) {
            chars[i] = Character.forDigit(ThreadLocalRandom.current().nextInt(2), 10);
        }
        return String.valueOf(chars);
    }

    static long findDivisor(long number) {
        long bound = (long) Math.sqrt(number);
        for (int i = 2; i <= bound; i++) {
            if (number % i == 0) {
                return i;
            }
        }
        return -1;
    }


}
