package google.code_jam.ed2016;

import java.io.InputStream;
import java.math.BigInteger;
import java.util.*;
import java.util.concurrent.ThreadLocalRandom;


public class CoinJam {

    public static void main(String[] args) {
        InputStream is = System.in;
        Scanner s = new Scanner(is);
        int count = s.nextInt();
        for (int i = 1; i <= count; i++) {
            int length = s.nextInt();
            int howMany = s.nextInt();
            List<String> result = solve(howMany, length);
            System.out.printf("Case #%d:%n", i);
            for(String line: result) {
                System.out.println(line);
            }
        }

    }

    static List<String> solve(int howMany, int length) {
        Set<String> tried = new HashSet<>();
        List<String> result = new ArrayList<>(howMany);
        long[] divisors = new long[10 - 2 + 1];
        BigInteger[] interpretations = new BigInteger[9];
        loop:
        while (result.size() < howMany) {
            String randomCoin = randomCoin(length);
            if (!tried.add(randomCoin)) continue;

            for (int base = 2; base <= 10; base++) {
                BigInteger interpretation = new BigInteger(randomCoin, base);
                if (interpretation.isProbablePrime(10)) {
                    continue loop;
                }
                interpretations[base - 2]  = interpretation;

            }
            for (int i = 0; i < interpretations.length; i++) {
                long divisor = findDivisor(interpretations[i]);
                if (divisor == -1) continue loop;
                divisors[i] = divisor;
            }
            StringJoiner s = new StringJoiner(" ");
            s.add(randomCoin);
            Arrays.stream(divisors).mapToObj(Long::toString).forEach(s::add);
            result.add(s.toString());
        }
        return result;
    }


    static String randomCoin(int length) {
        char[] chars = new char[length];
        chars[0] = '1';
        chars[length - 1] = '1';
        for (int i = 1; i < length - 1; i++) {
            chars[i] = Character.forDigit(ThreadLocalRandom.current().nextInt(2), 10);
        }
        return String.valueOf(chars);
    }
    static long findDivisor(BigInteger number) {
        int bound = 10000;
        for (int i = 3; i <= bound; i+=2) {
            if (number.mod(BigInteger.valueOf(i)).equals(BigInteger.ZERO)) {
                return i;
            }
        }
        return -1;
    }


}
