package CoinJam;

import java.io.File;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Locale;
import java.util.Scanner;

public class CoinJamLarge
{
	private static final String PROBLEM_NAME = CoinJamLarge.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/16-Q/" + "CoinJam" + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
//	private static final String INPUT_PATH = WORK_DIR + "C-small-attempt0.in";
	private static final String INPUT_PATH = WORK_DIR + "C-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new CoinJamLarge().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	private static final BigInteger BIG_0 = BigInteger.ZERO;
	private static final BigInteger BIG_1 = BigInteger.ONE;
	private static final BigInteger BIG_2 = BigInteger.valueOf(2L);
	private static final BigInteger BIG_3 = BigInteger.valueOf(3L);
	private static final BigInteger BIG_6 = BigInteger.valueOf(6L);
	private static final BigInteger BIG_MAX_PRIME_ITERATIONS = BigInteger.valueOf(100000);
	
	public void solve(Scanner in, PrintWriter out)
	{
		long N = in.nextInt();
		long J = in.nextInt();
		
		long jc = 1L | 1L << N - 1L;
		String jcStr = Long.toString(jc, 2);
		
		while (J > 0)
		{
			System.out.println("\n\nJC: " + jcStr);
			
			BigInteger[] divisors = new BigInteger[11];
			BigInteger divisor = BIG_0;
			for (int i = 2; i <= 10; i++)
			{
				BigInteger jcb = new BigInteger(jcStr, i);
				System.out.println("JC_" + i + ": " + jcb);
				
				divisor = getDivisor(jcb);
				divisors[i] = divisor;
				
				System.out.println("JC_" + i + " divisor: " + divisor);
				
				if (divisor.equals(BIG_0)) // prime
					break;
			}
			
			if (!divisor.equals(BIG_0))
			{
				out.println();
				out.print(jcStr + " ");
				for (int i = 2; i <= 10; i++)
				{
					out.print(divisors[i] + " ");
				}
				
				J--;
			}
			
			jc += 2;
			jcStr = Long.toString(jc, 2);
		}
	}
	
	private BigInteger getDivisor(BigInteger num)
	{
		if (num.remainder(BIG_2).equals(BIG_0))
			return BIG_2;
			
		if (num.remainder(BIG_3).equals(BIG_0))
			return BIG_3;
			
		BigInteger limit = num.divide(BIG_2);
		
		for (BigInteger k = BIG_1; k.compareTo(limit) < 0; k = k.add(BIG_1))
		{
			BigInteger divisor = k.multiply(BIG_6).subtract(BIG_1);
			if (num.remainder(divisor).equals(BIG_0) && !divisor.equals(num))
				return divisor;
				
			divisor = k.multiply(BIG_6).add(BIG_1);
			if (num.remainder(divisor).equals(BIG_0) && !divisor.equals(num))
				return divisor;
				
			if (k.compareTo(BIG_MAX_PRIME_ITERATIONS) > 0)
			{
				System.out.println("PROBABLY PRIME");
				return BIG_0; // probably prime, lets look for other numbers
			}
		}
		
		return BIG_0;
	}
}
