package PartElf;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class PartElf
{
    private static final String PROBLEM_NAME = PartElf.class.getSimpleName();
    private static final String WORK_DIR = "/Development/Projects/GCJ/Round1C/" + PROBLEM_NAME + "/";
//    private static final String INPUT_PATH = WORK_DIR + "sample.txt";
    private static final String INPUT_PATH = WORK_DIR + "small.txt";
//	private static final String INPUT_PATH = WORK_DIR + "large.txt";
    private static final String OUTPUT_PATH = INPUT_PATH.replace(".txt", "-out.txt");
    
    public static void main(String[] args) throws Exception
    {
        System.out.println("Solving " + PROBLEM_NAME + "...");
        System.out.println("Input: " + INPUT_PATH);
        System.out.println("Output: " + OUTPUT_PATH);
        
        PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
        Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
        in.useLocale(Locale.US);
        
        int testCasesNumber = in.nextInt();
        in.nextLine();
        System.out.println("Test cases: " + testCasesNumber);
        
        try
        {
            for (int testCase = 1; testCase <= testCasesNumber; testCase++)
            {
                System.out.println("Solving test case: " + testCase + "...");
                out.print("Case #" + testCase + ": ");
                new PartElf().solve(in, out);
                out.flush();
            }
        }
        finally
        {
            in.close();
            out.close();
        }
        
        System.out.println("All test cases solved!");
    }
    
    public void solve(Scanner in, PrintWriter out)
    {
        String f = in.nextLine();
        String[] p = f.split("/");
        long P = Long.parseLong(p[0]);
        long Q = Long.parseLong(p[1]);
        
        if (Q % 2 != 0)
        {
            out.println("impossible");
            return;
        }
        
//        System.out.println("P=" + P + ",Q=" + Q);
        
        for (int i = 0; i < 40; i++)
        {
            Q /= 2;
            
//            System.out.println("Q=" + Q);
//            System.out.println("P / Q=" + (P / Q) + ", P % Q=" + (P % Q));
            
            if (P % Q != 0 && Q % 2 != 0)
            {
                out.println("impossible");
                return;
            }
            
            if (P / Q >= 1)
            {
                if (verify(P % Q, Q, i))
                    out.println(i + 1);
                else
                    out.println("impossible");
                    
                return;
            }
        }
        
        out.println("impossible");
        return;
    }
    
    private boolean verify(long P, long Q, int start)
    {
        if (P == 0)
            return true;
        
        if (P % Q != 0 && Q % 2 != 0)
            return false;
        
        for (int i = start; i < 40; i++)
        {
            Q /= 2;
            
            if (P % Q != 0 && Q % 2 != 0)
                return false;
            
            if (P == 1 && Q == 1)
                return true;
            
            P %= Q;
        }
        
        return false;
    }
}
