package RevengePancakes;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class RevengePancakes
{
	private static final String PROBLEM_NAME = RevengePancakes.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/16-Q/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
//	private static final String INPUT_PATH = WORK_DIR + "B-small-attempt0.in";
	private static final String INPUT_PATH = WORK_DIR + "B-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new RevengePancakes().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	private char[] P;
	private int flips = 0;
	
	public void solve(Scanner in, PrintWriter out)
	{
		P = in.next().toCharArray();
		
		for (int i = P.length - 1; i >= 0; i--)
		{
			if (P[i] == '+')
				continue;
				
			if (P[0] == '-')
			{
				flip(i);
				continue;
			}
			
			int preFlipPos = 0;
			for (int j = 1; j < P.length; j++)
			{
				if (P[j] == '+')
				{
					preFlipPos = j;
				}
				else
				{
					break;
				}
			}
			
			flip(preFlipPos);
			
			flip(i);
		}
		
		out.println(flips);
	}
	
	private void flip(int position)
	{
		for (int i = 0; i <= position / 2; i++)
		{
			char temp = P[position - i] == '-' ? '+' : '-';
			P[position - i] = P[i] == '-' ? '+' : '-';
			P[i] = temp;
		}
		
		flips++;
	}
}
