package TheRepeater;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Scanner;

public class TheRepeater
{
    private static final String PROBLEM_NAME = TheRepeater.class.getSimpleName();
    private static final String WORK_DIR = "/Development/Projects/GCJ/Round1B/" + PROBLEM_NAME + "/";
//    private static final String INPUT_PATH = WORK_DIR + "sample.txt";
    private static final String INPUT_PATH = WORK_DIR + "small.txt";
//	private static final String INPUT_PATH = WORK_DIR + "large.txt";
    private static final String OUTPUT_PATH = INPUT_PATH.replace(".txt", "-out.txt");
    
    private int N;
    
    public static void main(String[] args) throws Exception
    {
        System.out.println("Solving " + PROBLEM_NAME + "...");
        System.out.println("Input: " + INPUT_PATH);
        System.out.println("Output: " + OUTPUT_PATH);
        
        PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
        Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
        in.useLocale(Locale.US);
        
        int testCasesNumber = in.nextInt();
        in.nextLine();
        System.out.println("Test cases: " + testCasesNumber);
        
        try
        {
            for (int testCase = 1; testCase <= testCasesNumber; testCase++)
            {
                System.out.println("Solving test case: " + testCase + "...");
                out.print("Case #" + testCase + ": ");
                new TheRepeater().solve(in, out);
                out.flush();
            }
        }
        finally
        {
            in.close();
            out.close();
        }
        
        System.out.println("All test cases solved!");
    }
    
    public void solve(Scanner in, PrintWriter out)
    {
        N = in.nextInt();
        in.nextLine();
        
        String[] strings = new String[N];
        for (int i = 0; i < N; i++)
            strings[i] = in.nextLine();
        
        String firstString = removeDuplicates(strings[0]);
        
        for (int i = 1; i < strings.length; i++)
        {
            if (!firstString.equals(removeDuplicates(strings[i])))
            {
                out.println("Fegla Won");
                return;
            }
        }
        
        /*
        int lengthSum = 0;
        
        for (int i = 0; i < strings.length; i++)
            lengthSum += strings[i].length();
        
        int mediumLength = (int) Math.round((double)lengthSum / N);
        
        int moves = 0;
        for (int i = 0; i < strings.length; i++)
            moves += Math.abs(strings[i].length() - mediumLength);
            */
        
        ArrayList<ArrayList<Integer>> groups = new ArrayList<ArrayList<Integer>>();
        
        for (int i = 0; i < N; i++)
        {
            String str = strings[i];
            ArrayList<Integer> group = new ArrayList<Integer>(str.length());
            char prev = str.charAt(0);
            group.add(1);
            
            int k = 0;
            
            for (int j = 1; j < str.length(); j++)
            {
                char cur = str.charAt(j);
                if (cur == prev)
                {
                    group.set(k, group.get(k) + 1);
                }
                else
                {
                    prev = cur;
                    group.add(1);
                    k++;
                }
            }
            
            groups.add(group);
        }
        
        int groupSize = groups.get(0).size();
        int moves = 0;
        
        for (int i = 0; i < groupSize; i++)
        {
            int lengthSum = 0;
            
            for (int j = 0; j < N; j++)
                lengthSum += groups.get(j).get(i);
            
            int mediumLength = (int) Math.round((double) lengthSum / N);
            
            for (int j = 0; j < N; j++)
                moves += Math.abs(groups.get(j).get(i) - mediumLength);
        }
        
        out.println(moves);
    }
    
    public static String removeDuplicates(String s)
    {
        if (s.length() <= 2)
            return s;
        
        StringBuilder sb = new StringBuilder();
        
        char prev = s.charAt(0);
        sb.append(prev);
        
        for (int i = 1; i < s.length(); ++i)
        {
            char cur = s.charAt(i);
            if (cur != prev)
            {
                sb.append(cur);
                prev = cur;
            }
        }
        
        return sb.toString();
    }
}
