package IHOP;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Scanner;

public class IHOP
{
	private static final String PROBLEM_NAME = IHOP.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/15-Q/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
	private static final String INPUT_PATH = WORK_DIR + "B-small-attempt2.in";
//	private static final String INPUT_PATH = WORK_DIR + "B-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new IHOP().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	public void solve(Scanner in, PrintWriter out)
	{
		int D = in.nextInt();
		ArrayList<Integer> P = new ArrayList<Integer>(D * 2);
		
		for (int i = 0; i < D; i++)
		{
			P.add(in.nextInt());
		}
		
		int specialMinutes = 0;
		
		while (true)
		{
			int max = 0;
			int maxIndex = -1;
			int secondMax = 0;
			
			for (int i = 0; i < P.size(); i++)
			{
				int val = P.get(i);
				if (val > max)
				{
					secondMax = max;
					max = val;
					maxIndex = i;
				}
				else if (val > secondMax)
				{
					secondMax = val;
				}
			}
			
			int maxSmallerHalf = max / 2;
			int maxBiggerHalf = max - maxSmallerHalf;
			int potentialEconomy = max - maxBiggerHalf - 1;
			
			int newMax = Math.max(maxBiggerHalf, secondMax);
			int currentEconomy = max - newMax - 1;
			
			if (currentEconomy <= 0 && potentialEconomy > 0)
			{
				for (int i = 0; i < P.size(); i++)
				{
					if (i == maxIndex)
						continue;
					
					if (P.get(i) > maxBiggerHalf)
						potentialEconomy--;
					
					if (potentialEconomy <= 0)
						break;
				}
			}
			
			// special minute
			if (potentialEconomy > 0 || currentEconomy > 0)
			{
				P.set(maxIndex, maxBiggerHalf);
				P.add(maxSmallerHalf);
				specialMinutes++;
			}
			else
			{
				out.println(max + specialMinutes);
				return;
			}
		}
	}
}
