package CoinJam;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class CoinJam
{
	private static final String PROBLEM_NAME = CoinJam.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/16-Q/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
	private static final String INPUT_PATH = WORK_DIR + "C-small-attempt0.in";
//	private static final String INPUT_PATH = WORK_DIR + "C-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new CoinJam().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	public void solve(Scanner in, PrintWriter out)
	{
		int N = in.nextInt();
		int J = in.nextInt();
		
		long jc = 1 | 1 << N - 1;
		String jcStr = Long.toString(jc, 2);
		
		while (J > 0)
		{
			System.out.println("\n\nJC: " + jcStr);
			
			long[] divisors = new long[11];
			long divisor = 0;
			for (int i = 2; i <= 10; i++)
			{
				long jcb = Long.parseLong(jcStr, i);
				divisor = getDivisor(jcb);
				divisors[i] = divisor;
				
				System.out.println("JC_" + i + ": " + jcb);
				System.out.println("JC_" + i + " divisor: " + divisor);
				
				if (divisor == 0) // prime
					break;
			}
			
			if (divisor != 0)
			{
				out.println();
				out.print(jcStr + " ");
				for (int i = 2; i <= 10; i++)
				{
					out.print(divisors[i] + " ");
				}
				
				J--;
			}
			
			jc += 2;
			jcStr = Long.toString(jc, 2);
		}
	}
	
	private long getDivisor(long num)
	{
		if (num % 2 == 0)
			return 2;
			
		if (num % 3 == 0)
			return 3;
			
		long root = (long) Math.sqrt(num) + 1;
		
		for (long k = 1; k <= root; k++)
		{
			long divisor = 6 * k - 1;
			if (num % divisor == 0)
				return divisor;
				
			divisor = 6 * k + 1;
			if (num % divisor == 0)
				return divisor;
		}
		
		return 0;
	}
}
