package Technobabble;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Locale;
import java.util.Scanner;

public class Technobabble
{
	private static final String PROBLEM_NAME = Technobabble.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/16-1B/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
	private static final String INPUT_PATH = WORK_DIR + "C-small-attempt1.in";
//	private static final String INPUT_PATH = WORK_DIR + "A-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new Technobabble().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	private HashMap<String, Integer> leftWordsCount = new HashMap<>();
	private HashMap<String, Integer> rightWordsCount = new HashMap<>();
	
	private HashSet<String> leftWordsSeen = new HashSet<>();
	private HashSet<String> rightWordsSeen = new HashSet<>();
	
	private ArrayList<Topic> topics = new ArrayList<>();
	
	public void solve(Scanner in, PrintWriter out)
	{
		int N = in.nextInt();
		
		for (int i = 0; i < N; i++)
		{
			String left = in.next();
			String right = in.next();
			if (!leftWordsCount.containsKey(left))
			{
				leftWordsCount.put(left, 1);
			}
			else
			{
				leftWordsCount.put(left, leftWordsCount.get(left) + 1);
			}
			
			if (!rightWordsCount.containsKey(right))
			{
				rightWordsCount.put(right, 1);
			}
			else
			{
				rightWordsCount.put(right, rightWordsCount.get(right) + 1);
			}
			
			topics.add(new Topic(left, right));
		}
		
		int result = 0;
		for (Topic topic : topics)
		{
			if (leftWordsCount.get(topic.left) > 1
				&& rightWordsCount.get(topic.right) > 1
			/*&& leftWordsSeen.contains(topic.left)
			&& rightWordsSeen.contains(topic.right) */)
			{
				result++;
			}
			
			leftWordsSeen.add(topic.left);
			rightWordsSeen.add(topic.right);
		}
		
		out.println(result);
	}
	
	public static class Topic
	{
		public String left;
		public String right;
		
		public Topic(String left, String right)
		{
			this.left = left;
			this.right = right;
		}
	}
}
