package SenateEvacuation;

import java.io.File;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Locale;
import java.util.Scanner;

public class SenateEvacuation
{
	private static final String PROBLEM_NAME = SenateEvacuation.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/16-1C/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
	private static final String INPUT_PATH = WORK_DIR + "A-small-attempt1.in";
//	private static final String INPUT_PATH = WORK_DIR + "A-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new SenateEvacuation().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	public void solve(Scanner in, PrintWriter out)
	{
		int N = in.nextInt();
		Party[] parties = new Party[N];
		for (int i = 0; i < N; i++)
			parties[i] = new Party((char) ('A' + i), in.nextInt());
		
		Arrays.sort(parties, new Comparator<Party>()
		{
			@Override
			public int compare(Party o1, Party o2)
			{
				return o2.compareTo(o1);
			}
		});
		
		boolean done = false;
		while (!done)
		{
			done = true;
			for (int i = 0; i < N - 1; i++)
			{
				while (parties[i].count > parties[i + 1].count)
				{
					done = false;
					for (int j = i; j >= 0; j--)
					{
						out.print(parties[j].name + " ");
						parties[j].count = parties[j].count - 1;
					}
				}
			}
		}
		
		boolean odd = N % 2 != 0;
		
		done = false;
		while (!done)
		{
			done = true;
			for (int i = 0; i < N; i += 2)
			{
				if (odd && parties[i].count == 1 && i == N - 3)
				{
					out.print(parties[i + 2].name + " ");
					out.print(parties[i].name + "" + parties[i + 1].name + " ");
					break;
				}
				else if (parties[i].count > 0)
				{
					if (i + 1 > N - 1)
					{
						out.print(parties[i].name + " ");
						parties[i].count = parties[i].count - 1;
					}
					else
					{
						out.print(parties[i].name + "" + parties[i + 1].name + " ");
						parties[i].count = parties[i].count - 1;
						parties[i + 1].count = parties[i + 1].count - 1;
					}
					done = false;
				}
			}
		}
		
		out.println();
	}
	
	private static class Party implements Comparable<Party>
	{
		public char name;
		public int count;
		
		public Party(char name, int count)
		{
			this.name = name;
			this.count = count;
		}
		
		@Override
		public int compareTo(Party o)
		{
			return Integer.compare(count, o.count);
		}
		
		@Override
		public String toString()
		{
			return name + ": " + count;
		}
	}
}
