package Haircut;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class Haircut
{
	private static final String PROBLEM_NAME = Haircut.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/15-1A/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
	private static final String INPUT_PATH = WORK_DIR + "B-small-attempt1.in";
//	private static final String INPUT_PATH = WORK_DIR + "B-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new Haircut().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	public void solve(Scanner in, PrintWriter out)
	{
		int B = in.nextInt();
		int N = in.nextInt();
		
		long M[] = new long[B];
		long b[] = new long[B];
		
		for (int i = 0; i < B; i++)
		{
			M[i] = in.nextInt();
			b[i] = M[i];
		}
		
		if (N <= B)
		{
			out.println(N);
			return;
		}
		
		long lcm = lcm(M);
		
		long c = 0;
		for (int i = 0; i < B; i++)
		{
			c += lcm / M[i];
		}
		
		N %= c;
		
		if (N == 0)
		{
			out.println(B);
			return;
		}
		
		if (N <= B)
		{
			out.println(N);
			return;
		}
		
		while (true)
		{
			long min = min(b);
			
			for (int i = 0; i < B; i++)
			{
				b[i] -= min;
				
				if (b[i] == 0)
				{
					b[i] = M[i];
					N--;
				}
				
				if (N == 0)
				{
					out.println(i + 1);
					return;
				}
			}
		}
	}
	
	public long min(long[] a)
	{
		long min = Long.MAX_VALUE;
		for (int i = 0; i < a.length; i++)
		{
			if (a[i] < min)
				min = a[i];
		}
		
		return min;
	}
	
	private static long gcd(long a, long b)
	{
		while (b > 0)
		{
			long temp = b;
			b = a % b; // % is remainder
			a = temp;
		}
		
		return a;
	}
	
	private static long lcm(long a, long b)
	{
		return a * (b / gcd(a, b));
	}
	
	private static long lcm(long[] input)
	{
		long result = input[0];
		for (int i = 1; i < input.length; i++)
			result = lcm(result, input[i]);
		
		return result;
	}
}
