package NewLotteryGame;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class NewLotteryGame
{
    private static final String PROBLEM_NAME = NewLotteryGame.class.getSimpleName();
    private static final String WORK_DIR = "/Development/Projects/GCJ/Round1B/" + PROBLEM_NAME + "/";
//    private static final String INPUT_PATH = WORK_DIR + "sample.txt";
    private static final String INPUT_PATH = WORK_DIR + "small.txt";
//	private static final String INPUT_PATH = WORK_DIR + "large.txt";
    private static final String OUTPUT_PATH = INPUT_PATH.replace(".txt", "-out.txt");
    
    public static void main(String[] args) throws Exception
    {
        System.out.println("Solving " + PROBLEM_NAME + "...");
        System.out.println("Input: " + INPUT_PATH);
        System.out.println("Output: " + OUTPUT_PATH);
        
        PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
        Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
        in.useLocale(Locale.US);
        
        int testCasesNumber = in.nextInt();
        in.nextLine();
        System.out.println("Test cases: " + testCasesNumber);
        
        try
        {
            for (int testCase = 1; testCase <= testCasesNumber; testCase++)
            {
                System.out.println("Solving test case: " + testCase + "...");
                out.print("Case #" + testCase + ": ");
                new NewLotteryGame().solve(in, out);
                out.flush();
            }
        }
        finally
        {
            in.close();
            out.close();
        }
        
        System.out.println("All test cases solved!");
    }
    
    public void solve(Scanner in, PrintWriter out)
    {
        int A = in.nextInt();
        int B = in.nextInt();
        int K = in.nextInt();
        
        int pairs = 0;
        
        for (int a = 0; a < A; a++)
        {
            for (int b = 0; b < B; b++)
            {
                if ((a & b) < K)
                    pairs++;
            }
        }
        
        out.println(pairs);
    }
}
