package gcj;

import java.io.*;
import java.util.*;

public class CookieClickerAlpha
{
    private static final String PROBLEM_NAME = CookieClickerAlpha.class.getSimpleName();
    private static final String WORK_DIR = "D:\\Programming\\GCJ\\Qualification\\" + PROBLEM_NAME + "\\";
//    private static final String INPUT_PATH = WORK_DIR + "sample.txt";
    private static final String INPUT_PATH = WORK_DIR + "small.txt";
//    private static final String INPUT_PATH = WORK_DIR + "large.txt";
    private static final String OUTPUT_PATH = INPUT_PATH.replace(".txt", "-out.txt");
    
    public static void main(String[] args) throws Exception
    {
        System.out.println("Solving " + PROBLEM_NAME + "...");
        System.out.println("Input: " + INPUT_PATH);
        System.out.println("Output: " + OUTPUT_PATH);
        
        PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
        Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
        in.useLocale(Locale.US);
        
        int testCasesNumber = in.nextInt();
        in.nextLine();
        System.out.println("Test cases: " + testCasesNumber);
        
        try
        {
            for (int testCase = 1; testCase <= testCasesNumber; testCase++)
            {
//                System.out.println("Solving test case: " + testCase + "...");
                out.print("Case #" + testCase + ": ");
                new CookieClickerAlpha().solve(in, out);
                out.flush();
            }
        }
        finally
        {
            in.close();
            out.close();
        }
        
        System.out.println("All test cases solved!");
    }
    
    public void solve(Scanner in, PrintWriter out)
    {
        double C = in.nextDouble(); // farm cost
        double F = in.nextDouble(); // farm production
        double X = in.nextDouble(); // target cookies
        
        double CPS = 2.0; // cookies per second
        double T = 0; // current time
        double TN = 0; // time to next farm
        double TW = 0; // time to wait until X cookies
        double TWN = 0; // time to wait until X cookies if we have another farm
        
        while (true)
        {
            TW = X / CPS;
            TN = C / CPS;
            TWN = X / (CPS + F);
            
            // is it worth to buy a new farm?
            if (TW < TN + TWN)
                break;
            
            // bought a farm
            CPS += F;
            T += TN;
        }
        
        out.println(T + TW);
    }
}
