package StandingOvation;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class StandingOvation
{
	private static final String PROBLEM_NAME = StandingOvation.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/15-Q/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.txt";
	private static final String INPUT_PATH = WORK_DIR + "small.txt";
//	private static final String INPUT_PATH = WORK_DIR + "large.txt";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".txt", "-out.txt");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new StandingOvation().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	public void solve(Scanner in, PrintWriter out)
	{
		int SMAX = in.nextInt();
		String S = in.next();
		
		int friends = 0;
		int standing = 0;
		
		for (int i = 0; i < SMAX + 1; i++)
		{
			int peopleWithSynessI = Character.getNumericValue(S.charAt(i));
			
			if (peopleWithSynessI == 0)
				continue;
			
			int additionalFriends = i - standing;
			
			if (additionalFriends < 0)
				additionalFriends = 0;
			
			friends += additionalFriends;
			standing += additionalFriends + peopleWithSynessI;
		}
		
		out.println(friends);
	}
}
