package OminousOmino;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class OminousOmino
{
	private static final String PROBLEM_NAME = OminousOmino.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/15-Q/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.txt";
	private static final String INPUT_PATH = WORK_DIR + "D-small-attempt0.in";
//	private static final String INPUT_PATH = WORK_DIR + "D-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.txt";
	private static final String OUTPUT_PATH = INPUT_PATH + "-out.txt";
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new OminousOmino().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	static final String GABRIEL = "GABRIEL";
	static final String RICHARD = "RICHARD";
	
	public void solve(Scanner in, PrintWriter out)
	{
		int X = in.nextInt();
		int R = in.nextInt();
		int C = in.nextInt();
		
		if ((R * C) % X != 0)
		{
			out.println(RICHARD);
			return;
		}
		
		if (Math.min(R, C) < (X - 1))
		{
			out.println(RICHARD);
			return;
		}
		
		out.println(GABRIEL);
	}
}
