package MushroomMonster;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class MushroomMonster
{
	private static final String PROBLEM_NAME = MushroomMonster.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/15-1A/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
	private static final String INPUT_PATH = WORK_DIR + "A-small-attempt0.in";
//	private static final String INPUT_PATH = WORK_DIR + "A-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new MushroomMonster().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	public void solve(Scanner in, PrintWriter out)
	{
		int N = in.nextInt();
		int m[] = new int[N];
		
		for (int i = 0; i < N; i++)
		{
			m[i] = in.nextInt();
		}
		
		int rate = 0;
		
		int eaten = 0;
		for (int i = 1; i < N; i++)
		{
			int diff = m[i - 1] - m[i];
			if (diff > 0)
				eaten += diff;
			
			if (diff > rate)
				rate = diff;
		}
		
		out.print(eaten + " ");
		
		if (rate == 0)
		{
			out.println(0);
			return;
		}
		
		eaten = 0;
		for (int i = 1; i < N; i++)
		{
			eaten += m[i - 1] <= rate ? m[i - 1] : rate;
		}
		
		out.println(eaten);
	}
}
