package gcj;


import java.io.*;
import java.util.*;

public class MagicTrick
{
    private static final String PROBLEM_NAME = MagicTrick.class.getSimpleName();
    private static final String WORK_DIR = "D:\\Programming\\GCJ\\Qualification\\" + PROBLEM_NAME + "\\";
    private static final String INPUT_PATH = WORK_DIR + "small.txt";
//	private static final String INPUT_PATH = WORK_DIR + "large.txt";
    private static final String OUTPUT_PATH = INPUT_PATH.replace(".txt", "-out.txt");
    
    public static void main(String[] args) throws Exception
    {
        System.out.println("Solving " + PROBLEM_NAME + "...");
        System.out.println("Input: " + INPUT_PATH);
        System.out.println("Output: " + OUTPUT_PATH);
        
        PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
        Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
        in.useLocale(Locale.US);
        
        int testCasesNumber = in.nextInt();
        in.nextLine();
        System.out.println("Test cases: " + testCasesNumber);
        
        try
        {
            for (int testCase = 1; testCase <= testCasesNumber; testCase++)
            {
                System.out.println("Solving test case: " + testCase + "...");
                out.print("Case #" + testCase + ": ");
                new MagicTrick().solve(in, out);
                out.flush();
            }
        }
        finally
        {
            in.close();
            out.close();
        }
        
        System.out.println("All test cases solved!");
    }
    
    public void solve(Scanner in, PrintWriter out)
    {
        int N = 4;
        int row1 = in.nextInt() - 1;
        int[][] arrangement1 = new int[N][N];
        
        for (int i = 0; i < N; i++)
            for (int j = 0; j < N; j++)
                arrangement1[i][j] = in.nextInt();
        
        int row2 = in.nextInt() - 1;
        int[][] arrangement2 = new int[N][N];
        
        for (int i = 0; i < N; i++)
            for (int j = 0; j < N; j++)
                arrangement2[i][j] = in.nextInt();
        
        ArrayList<Integer> cards = new ArrayList<Integer>();
        for (int i = 0; i < N; i++)
            if (contains (arrangement1[row1], arrangement2[row2][i]))
                    cards.add(arrangement2[row2][i]);
            
        if (cards.size() == 0)
            out.println("Volunteer cheated!");
        else if (cards.size() == 1)
            out.println("" + cards.get(0));
        else
            out.println("Bad magician!");
    }
    
    private boolean contains (int[] array, int value)
    {
        for (int i = 0; i < array.length; i++)
            if (array[i] == value)
                return true;
        
        return false;
    }
}
