package Fractiles;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class FractilesLarge
{
	private static final String PROBLEM_NAME = FractilesLarge.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/16-Q/" + "Fractiles" + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
//	private static final String INPUT_PATH = WORK_DIR + "D-small-attempt0.in";
	private static final String INPUT_PATH = WORK_DIR + "D-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new FractilesLarge().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	public void solve(Scanner in, PrintWriter out)
	{
		int K = in.nextInt();
		int C = in.nextInt();
		int S = in.nextInt();
		
		if (C == 1)
		{
			if (S < K)
			{
				out.println("IMPOSSIBLE");
				return;
			}
			
			for (int i = 1; i <= K; i++)
			{
				out.print(i + " ");
			}
			
			out.println();
			return;
		}
		
		if (S < K - 1 && C < K)
		{
			out.println("IMPOSSIBLE");
			return;
		}
		
		int pos = (K - 1) * K;
		for (int i = 0; i < S; i++)
		{
			out.print(pos + " ");
			pos++;
		}
		
		out.println();
	}
}
