package CountingSheep;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class CountingSheep
{
	private static final String PROBLEM_NAME = CountingSheep.class.getSimpleName();
	private static final String WORK_DIR = "/Development/Projects/GCJ/16-Q/" + PROBLEM_NAME + "/";
//	private static final String INPUT_PATH = WORK_DIR + "sample.in";
	private static final String INPUT_PATH = WORK_DIR + "A-small-attempt0.in";
//	private static final String INPUT_PATH = WORK_DIR + "A-large.in";
//	private static final String INPUT_PATH = WORK_DIR + "debug.in";
	private static final String OUTPUT_PATH = INPUT_PATH.replace(".in", ".out");
	
	public static void main(String[] args) throws Exception
	{
		System.out.println("Solving " + PROBLEM_NAME + "...");
		System.out.println("Input: " + INPUT_PATH);
		System.out.println("Output: " + OUTPUT_PATH);
		
		PrintWriter out = new PrintWriter(OUTPUT_PATH, "US-ASCII");
		Scanner in = new Scanner(new File(INPUT_PATH), "US-ASCII");
		in.useLocale(Locale.US);
		
		int testCasesNumber = in.nextInt();
		in.nextLine();
		System.out.println("Test cases: " + testCasesNumber);
		
		try
		{
			for (int testCase = 1; testCase <= testCasesNumber; testCase++)
			{
				System.out.println("Solving test case: " + testCase + "...");
				out.print("Case #" + testCase + ": ");
				new CountingSheep().solve(in, out);
				out.flush();
			}
		}
		finally
		{
			in.close();
			out.close();
		}
		
		System.out.println("All test cases solved!");
	}
	
	long N;
	int[] D;
	long current;
	
	public void solve(Scanner in, PrintWriter out)
	{
		long N = in.nextLong();
		D = new int[10];
		current = 0;
		
		for (long i = 1; i <= 100; i++)
		{
			current += N;
			
			count();
			
			if (check())
			{
				out.println(current);
				return;
			}
		}
		
		out.println("INSOMNIA");
	}
	
	private void count()
	{
		char[] digits = String.valueOf(current).toCharArray();
		for (int i = 0; i < digits.length; i++)
		{
			int digit = digits[i] - '0';
			D[digit] = 1;
		}
	}
	
	private boolean check()
	{
		for (int i = 0; i < D.length; i++)
		{
			if (D[i] == 0)
				return false;
		}
		
		return true;
	}
}
