import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Andrey Rechitsky (arechitsky@gmail.com)
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        FastScanner in = new FastScanner(inputStream);
        FastPrinter out = new FastPrinter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, FastScanner in, FastPrinter out) {
            int n = in.nextInt();
            int r = in.nextInt();
            int p = in.nextInt();
            int s = in.nextInt();
            String[][] dp1 = new String[3][n + 1];
            int[][][] dp2 = new int[2][3][n + 1];
            dp1[0][0] = "P";
            dp1[1][0] = "R";
            dp1[2][0] = "S";
            dp2[0][0][0] = dp2[1][1][0] = 1;
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < 3; j++) {
                    String l1 = dp1[j][i] + dp1[(j + 1) % 3][i];
                    String l2 = dp1[(j + 1) % 3][i] + dp1[j][i];
                    dp1[j][i + 1] = l1.compareTo(l2) > 0 ? l2 : l1;
                    for (int k = 0; k < 2; k++) {
                        dp2[k][j][i + 1] = dp2[k][j][i] + dp2[k][(j + 1) % 3][i];
                    }
                }
            }
            out.print("Case #%d: ", testNumber);
            for (int i = 0; i < 3; i++) {
                if (dp2[0][i][n] != p) continue;
                if (dp2[1][i][n] != r) continue;
                out.printLine(dp1[i][n]);
                return;
            }
            out.printLine("IMPOSSIBLE");
        }

    }

    static class FastPrinter {
        private final PrintWriter writer;

        public FastPrinter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public FastPrinter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void close() {
            writer.close();
        }

        public void printLine(String s) {
            writer.println(s);
        }

        public void print(String s) {
            writer.print(s);
        }

        public void print(String format, Object... args) {
            print(String.format(format, args));
        }

    }

    static class FastScanner {
        private BufferedReader reader;
        private StringTokenizer st;

        public FastScanner(InputStream stream) {
            this.reader = new BufferedReader(new InputStreamReader(stream));
            this.st = new StringTokenizer("");
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public String next() {
            while (!st.hasMoreTokens()) {
                st = new StringTokenizer(readLine());
            }
            return st.nextToken();
        }

        private String readLine() {
            String line = tryReadLine();
            if (line == null) throw new InputMismatchException();
            return line;
        }

        private String tryReadLine() {
            try {
                return reader.readLine();
            } catch (IOException e) {
                throw new InputMismatchException();
            }
        }

    }
}

