import java.io.InputStreamReader;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.BufferedWriter;
import java.util.Locale;
import java.util.InputMismatchException;
import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.File;
import java.io.Writer;
import java.util.StringTokenizer;
import java.io.FilenameFilter;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author Andrey Rechitsky (arechitsky@gmail.com)
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "A-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("a.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		FastScanner in = new FastScanner(inputStream);
		FastPrinter out = new FastPrinter(outputStream);
		TaskA solver = new TaskA();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskA {
    public void solve(int testNumber, FastScanner in, FastPrinter out) {
        int n = in.nextInt();
        int m = in.nextInt();
        char [][] map = new char[n][];
        for (int i = 0; i < n; i++) {
            map[i] = in.next().toCharArray();
        }
        int ans = 0;
        boolean possible = true;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                boolean ok = false;
                if (map[i][j]=='.') ok = true;
                else if (map[i][j]=='<'){
                    for (int k = 0; k < j; k++) {
                        if (map[i][k]!='.'){
                            ok = true;
                            break;
                        }
                    }

                }
                else if (map[i][j]=='>'){
                    for (int k = j+1; k < m; k++) {
                        if (map[i][k]!='.'){
                            ok = true;
                            break;
                        }
                    }

                }
                else if (map[i][j]=='v'){
                    for (int k = i+1; k < n; k++) {
                        if (map[k][j]!='.'){
                            ok = true;
                            break;
                        }
                    }

                }
                else if (map[i][j]=='^'){
                    for (int k = 0; k < i; k++) {
                        if (map[k][j]!='.'){
                            ok = true;
                            break;
                        }
                    }

                }
            if (!ok){
                ans++;
                boolean ok2 = false;
                for (int k = 0; k < n; k++) {
                    if (k==i) continue;
                    if (map[k][j]!='.'){
                        ok2 = true;
                        break;
                    }
                }
                for (int k = 0; k < m; k++) {
                    if (k==j) continue;
                    if (map[i][k]!='.'){
                        ok2 = true;
                        break;
                    }
                }
                possible &= ok2;
            }
        }
        }
        out.print("Case #%d: ",testNumber);
        if (!possible) out.printLine("IMPOSSIBLE");
        else out.printLine(ans);
    }
}

class FastScanner {

    private BufferedReader reader;
    private StringTokenizer st;

    public FastScanner(InputStream stream) {
        this.reader = new BufferedReader(new InputStreamReader(stream));
        this.st = new StringTokenizer("");
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public String next(){
        while (!st.hasMoreTokens()){
            st = new StringTokenizer(readLine());
        }
        return st.nextToken();
    }

    private String readLine() {
        try {
            String line = reader.readLine();
            if (line==null) throw new InputMismatchException();
            return line;
        } catch (IOException e) {
            throw new InputMismatchException();
        }
    }

}

class FastPrinter {
    private final PrintWriter writer;

    public FastPrinter(OutputStream outputStream) {
        writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
    }

    public void close() {
        writer.close();
    }

    public void printLine(long i) {
        writer.println(i);
    }

    public void printLine(String s) {
        writer.println(s);
    }

    public void print(String s) {
        writer.print(s);
    }

    public void print(String format, Object ... args) {
        print(String.format(format, args));
    }

}

