import java.util.*;

public class CoinJam
{
   static long N = 16;
   static long J = 50;
   
   public static void main(String[] args)
   {
      ArrayList<Long> found = new ArrayList<Long>();
      System.out.print("Case #1:\n");
      StringBuilder output = new StringBuilder();
      long index = (long) Math.pow(2,N-1) + 1;
      long test;
      while (found.size() < J) //for each test
      {
         test = toBit(index);
         if (isJamCoin(test))
         {
            found.add(test);
         }
         index += 2;
      }
      for (Long coin : found)
      {
         output.append(toBitString(coin));      
      }
      output.delete(output.length() - 1, output.length());
      System.out.print(output.toString());
   }
   
   public static StringBuilder toBitString(long l)
   {
      StringBuilder sb = new StringBuilder();
      sb.append(l + " ");
      long num;
      for (long base = 2; base <= 10; base++)
      {
         num = interpret(l, base);
         sb.append(getDivisor(num) + " ");
      }
      sb.delete(sb.length()-1, sb.length());
      sb.append("\n");
      return sb;
   }
   
   public static long getDivisor(long l)
   {
      for(long i = 2; i < l; i++)
      {
         if (l % i == 0)
         {
            return i;
         }
      }
      return -1;
   
   }
   
   public static long toBit(long l)
   {
      long num = 0;
      for(int digit = 32; digit >=0; digit--) 
      {
         if ( l / ((long) Math.pow(2,digit)) > 0)
         {
            num += Math.pow(10, digit);
            
         l -= Math.pow(2,digit);
         }
      }
      return num;
   }
   
   public static boolean isJamCoin(long l)
   {
      for(int base = 2; base <= 10; base++)
      {
         if (isPrime(interpret(l,base)))
            return false;
      }
      return true;
   }
   
   public static boolean isPrime(long l)
   {
      if (l == 2) {
         return true;
      }
      for(long i = 2; i*i <= l; i++) {
         if (l % i == 0) {
            return false;
         }
      }
      return true;
   }
   
   
   
   public static long interpret(long l, long base)
   {
      long k = 0;
      long num = 0;  
      long temp = 0;
      while (l != 0)
      {
         temp = l % 10;
         l /= 10;
         num += temp * Math.pow(base, k);
         k++;
      }
      return num;
   }

}