import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashSet;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;

public class CodeJamRoundCProbA {

	public static void main(String[] args) {
		FastScanner sc = new FastScanner();
		int T = sc.nextInt();
		StringBuilder sb = new StringBuilder();
		for (int t = 1; t <= T; t++)	{
			int N = sc.nextInt();
			int K = sc.nextInt();
			ArrayList<Pancake> temp = new ArrayList();
			for (int n = 0; n < N; n++) {
				temp.add(new Pancake(sc.nextLong(), sc.nextLong()));
			}
			Compressor<Pancake> comp = new Compressor<Pancake>(temp);//(List<Pancake>) pans.clone());
			final ArrayList<Pancake> pans = new ArrayList(temp);
			SegmentTree seg = new SegmentTree(0, pans.size()-1);
			long prevMax, next, best;
			best = 0;
			for (int n = 0; n < N; n++) {
				Pancake pan = pans.get(n);
				int compressed = comp.compress(pans.get(n));
				prevMax = seg.getVal(0, compressed);
				if (prevMax == 0) {
					prevMax += pan.rad * pan.rad;
				}
				next = /*Math.max(prevMax, pan.rad * pan.rad)*/ prevMax + 2 * pan.rad * pan.height;

				Set<Integer> clone = seg.getSet(0, compressed);
				if (clone == null) {
					clone = new HashSet<Integer>();
				} else {
					clone = new HashSet<Integer>(clone);
				}
				clone.add(n);
				seg.setVal(compressed, next, clone);
				best = Math.max(best, next);
			}
			
			Set<Integer> bestSet = seg.getSet(0, pans.size());
			ArrayList<Integer> list = new ArrayList<Integer>(bestSet);
			Collections.sort(list, new Comparator<Integer>() {
				@Override
				public int compare(Integer a, Integer b) {
					return -1 * Long.compare(pans.get(a).rad * pans.get(a).height, pans.get(b).rad * pans.get(b).height);
				}
			});
			best = 0;
			Pancake pan;
			for (int i =0; i < list.size() ; i++) {
				pan = pans.get(list.get(i));
				long currBest = pan.rad * pan.rad + 2 * pan.rad * pan.height;
				for (int j = 0;j < K - 1; j++) {
					pan = pans.get(list.get(j));
					currBest += 2 * pan.rad * pan.height;
				}
				if ( i < K - 1) {
					pan = pans.get(list.get(K-1));
					currBest += 2 * pan.rad * pan.height;
					pan = pans.get(list.get(i));
					currBest -= 2 * pan.rad * pan.height;
				}
				
				best = Math.max(best, currBest);
			}
			double ans = best *Math.PI;
			sb.append("Case #"+t+": " + ans +"\n");
		}
		System.out.print(sb.toString());

	}
	static class Pancake implements Comparable<Pancake> {
		long rad;
		long height;
		public Pancake(long rad, long height) {
			this.rad = rad;
			this.height = height;
			
		}
		@Override
		public int compareTo(Pancake other) {
			int c1 = -1 *  Long.compare(rad, other.rad );
			return c1 != 0 ? c1 : -1 * Long.compare(height, other.height);
		}
		
	}
	
	static class Compressor<T extends Comparable<T>>	{
		List<T> real;
		Compressor(List<T> real)	{
			Collections.sort(this.real = real);
		}

		//compression, usually called once per realval
		int compress(T realval) {
			return Collections.binarySearch(real, realval);
		}

		T uncompress(int compval)	{  return real.get(compval); }
	}
	
	static class SegmentTree {
		SegmentTree left, right;
		long value, k;
		int lBound, rBound;
		Set<Integer> ps = new HashSet<Integer>();
		public SegmentTree(int leftBound, int rightBound)	{
			this.lBound = leftBound;
			this.rBound = rightBound;
			if (leftBound != rightBound)	{
				left = new SegmentTree(lBound, (lBound+rBound)/2);
				right = new SegmentTree((lBound+rBound)/2+1, rBound);
			}
			value = 0;
			k = 0;
		}
		public void setVal(long key, long val, Set<Integer> set)	{
			if (key < lBound || key > rBound) { // not contained

			}
			else if (key >= lBound && key <= rBound)	{
				if (val > value) {
					value = val;
					ps = set;
				}
				//value = Math.max(value, val);
				if (lBound != rBound) {
					left.setVal(key, val, set);
					right.setVal(key, val, set);
				}
			}
		}
		public long getVal(long min, long max)	{ // find floor of the key
			if (min <= lBound && rBound <= max )	{
				return value;
			}
			else if (min > rBound || max < lBound)	{
				return 0;
			}
			else {
				return Math.max(left.getVal(min, max), right.getVal(min, max));
			}

		}
		public Set<Integer> getSet(long min, long max)	{ // find floor of the key
			if (min <= lBound && rBound <= max )	{
				return ps;
			}
			else if (min > rBound || max < lBound)	{
				return null;
			}
			else {
				long leftVal, rightVal;
				leftVal = left.getVal(min, max);
				rightVal = right.getVal(min, max);
				return leftVal > rightVal ? left.getSet(min, max) : right.getSet(min, max);
				//return Math.max(left.getVal(min, max), right.getVal(min, max));
			}

		}



	}
	

	public static class FastScanner {
		BufferedReader br;
		StringTokenizer st;

		public FastScanner(Reader in) {
			br = new BufferedReader(in);
		}

		public FastScanner() {
			this(new InputStreamReader(System.in));
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		int nextInt() {
			return Integer.parseInt(next());
		}

		long nextLong() {
			return Long.parseLong(next());
		}

		double nextDouble() {
			return Double.parseDouble(next());
		}

		String readNextLine() {
			String str = "";
			try {
				str = br.readLine();
			} catch (IOException e) {
				e.printStackTrace();
			}
			return str;
		}

		int[] readIntArray(int n) {
			int[] a = new int[n];
			for (int idx = 0; idx < n; idx++) {
				a[idx] = nextInt();
			}
			return a;
		}

		long[] readLongArray(int n) {
			long[] a = new long[n];
			for (int idx = 0; idx < n; idx++) {
				a[idx] = nextLong();
			}
			return a;
		}
	}

}
