import java.util.Scanner;
import java.util.ArrayList;
import java.util.Collections;

public class C{
	public static void main(String[] args){
		Scanner scan = new Scanner(System.in);
		int T = scan.nextInt();
		scan.nextLine();
		for(int t = 1; t <= T; t++){
			long N = scan.nextLong();
			long K = scan.nextLong();
			scan.nextLine();
			Range range = computeLeftRight(N, K);
			long l = range.mid - range.l;	
			long r = range.r - range.mid;
			System.out.println("Case #"+t+": "+Math.max(r,l)+" "+Math.min(r,l));
		}
	}

	public static class Range implements Comparable{
		Long l, r, width, mid;

		public Range(long l, long r){
			this.l = l;
			this.r = r;
			this.width = r - l + 1;
			this.mid = (r + l) >> 1;
		}

		
		public int compareTo(Object o){
			Range rang = (Range) o;
			int width_comp = width.compareTo(rang.width);
			if(width_comp == 0){
				return l.compareTo(rang.l);
			}else{
				return -width_comp;
			}
		}

		public String toString(){
			return ("("+l+","+mid+","+r+")");
		}
	}

	public static Range computeLeftRight(long N, long K){
		ArrayList<Range> ranges = new ArrayList<Range>();
		Range range = new Range(1,N);
		ranges.add(range);
		for(long i = 0; i < K; i++){
			range = ranges.remove(0);
//System.out.println(range);
			Range r1 = new Range(range.l, range.mid-1);
			if(r1.width > 0)
				ranges.add(r1);
			Range r2 = new Range(range.mid+1, range.r);
			if(r2.width > 0)
				ranges.add(r2);
			Collections.sort(ranges);	
		}		
		return range;
	}
}
