/**
 * @(#)AlienLanguage.java, 2009-9-3. Copyright 2009 Yodao, Inc. All rights
 *                                   reserved. YODAO PROPRIETARY/CONFIDENTIAL.
 *                                   Use is subject to license terms.
 */

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

/**
 * @author ares
 */
public class AlienLanguage {
    
    private static final String INPUT = "A-large.in";

    private static final String OUTPUT = "A-large.out";
    
    private static class Node {
        int dep;
        char c;
        Node[] nodes;
        Node() {
            nodes = new Node[26];
            Arrays.fill(nodes, null);
        }
    }
    
    private static void build(Node node, int dep, String word) {
        if (dep >= word.length())
            return;
        char c = word.charAt(dep);
        int ptr = c - 'a';
        Node child = node.nodes[ptr] == null ? new Node() : node.nodes[ptr];
        child.c = c;
        child.dep = dep;
        node.nodes[ptr] = child;
        build(child, dep + 1, word);
    }

    
    public static void main(String[] args) throws Exception {
        long time = System.currentTimeMillis();
        BufferedReader reader = new BufferedReader(new InputStreamReader(
                new FileInputStream(INPUT), "utf-8"));
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(OUTPUT), "utf-8")); 
        String[] tokens = reader.readLine().split(" ");
        int aL = Integer.parseInt(tokens[0]);
        int aD = Integer.parseInt(tokens[1]);
        int aN = Integer.parseInt(tokens[2]);
        
        Node root = new Node();
        root.c = '#';
        for (int i = 0; i < aD; i++) {
            build(root, 0, reader.readLine().trim());
        }
        boolean[][] data = new boolean[aL][26];
        int[] last = new int[aL];
        
        
        List<Node> nl = new ArrayList<Node>();
        List<Node> ol = new ArrayList<Node>();
        List<Node> tp = null;
        
        
        for (int i = 0; i < aN; i++) {
            for (int j = 0; j < aL; j++)
                for (int k = 0; k < 26; k++)
                    data[j][k] = false;
           // Arrays.fill(last, 0);
            char[] c = reader.readLine().trim().toCharArray();
            int p = 0;
            int l = 0;
            while (p < c.length) {
                if (c[p] != '(') {
                    int q = c[p] - 'a';
                    data[l][q] = true;
                   // if (q > last[l])
                   //     last[l] = q;
                    l++;
                    p++;
                } else {
                    p++;
                    while (c[p] != ')') {
                        int q = c[p] - 'a';
                        data[l][q] = true;
                        //if (q > last[l])
                        //   last[l] = q;
                        p++;
                    }
                    l++;
                    p++;
                }
            }
            assert(l == aL);
            
            nl.clear();
            ol.clear();
            nl.add(root);
            
            for (int j = 0; j < aL; j++) {
                tp = ol;
                ol = nl;
                nl = tp;
                nl.clear();
                for (int k = 0; k < 26; k++) {
                    //if (k > last[j])
                    //    break;
                    if (data[j][k]) {
                        for (Node node: ol) {
                            Node child = node.nodes[k];
                            if (child != null) {
                                nl.add(child);
                            }
                        }
                    }
                }
            }
            writer.write("Case #" + (i + 1) + ": " + nl.size() + "\n");
        }
        System.out.println(System.currentTimeMillis() - time);
        reader.close();
        writer.close();
    }
}
