import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

/**
 * @(#)BribethePrisoners.java, 2009-9-13. Copyright 2009 Yodao, Inc. All rights
 *                                        reserved. YODAO
 *                                        PROPRIETARY/CONFIDENTIAL. Use is
 *                                        subject to license terms.
 */

/**
 * @author ares
 */
public class BribethePrisoners {

    private static final String INPUT = "input.txt";

    private static final String OUTPUT = "output.txt";

    private static int readInt(BufferedReader reader) throws Exception {
        String line = reader.readLine();
        return Integer.parseInt(line);
    }

    private static int[] readInts(BufferedReader reader) throws Exception {
        String[] tokens = reader.readLine().split(" ");
        int[] res = new int[tokens.length];
        for (int i = 0; i < tokens.length; i++) {
            res[i] = Integer.parseInt(tokens[i]);
        }
        return res;
    }

    private static int left(int[] a, int i, int to) {
        if (to <= -1) {
            return a[i] - 1;
        } else
            return a[i] - a[to] - 1;
    }

    private static int right(int p, int[] a, int i, int to) {
        if (to >= a.length) {
            return p - a[i];
        } else {
            return a[to] - a[i] - 1;
        }
    }

    public static final int MAX = 99999999;

    public static void main(String[] args) throws Exception {
        BufferedReader reader = new BufferedReader(new InputStreamReader(
                new FileInputStream(INPUT), "utf-8"));
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(
                new FileOutputStream(OUTPUT), "utf-8"));
        int cn = readInt(reader);
        for (int t = 0; t < cn; t++) {
            int[] tmp = readInts(reader);
            int p = tmp[0];
            int q = tmp[1];
            int[] a = readInts(reader);
            int[][] f = new int[q][q];

            for (int lv = 0; lv < q; lv++) {
                for (int i = 0; i < q; i++) {
                    int j = i + lv;
                    if (j < q) {
                        f[i][j] = MAX;
                        if (i == j) {
                            f[i][j] = left(a, i, i - 1) + right(p, a, i, i + 1);
                        } else {

                            for (int k = i; k <= j; k++) {
                                int tv = left(a, k, i - 1)
                                        + right(p, a, k, j + 1);
                                if (k == i) {
                                    int v = f[k + 1][j] + tv;
                                    if (v < f[i][j])
                                        f[i][j] = v;
                                } else if (k == j) {
                                    int v = f[i][k - 1] + tv;
                                    if (v < f[i][j])
                                        f[i][j] = v;

                                } else {
                                    int v = f[i][k - 1] + f[k + 1][j] + tv;
                                    if (v < f[i][j])
                                        f[i][j] = v;
                                }
                            }
                        }
                    }
                }
            }
            writer.write("Case #" + (t + 1) + ": " + f[0][q - 1] + "\n");
        }
        reader.close();
        writer.close();
    }

}
