import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Arrays;


public class Watersheds {

    private static final String INPUT = "B-large.in";

    private static final String OUTPUT = "B-large.out";
    
    private static class Point implements Comparable<Point> {
        int x;
        int y;
        int v;
        public int compareTo(Point o) {
            int thisVal = v;
            int anotherVal = o.v;
            return (thisVal<anotherVal ? -1 : (thisVal==anotherVal ? 0 : 1));
        }
    }
    
    public static int[][] move = {{-1, 0}, {0, -1}, {0, 1}, {1, 0}};

    public static void main(String[] args) throws Exception {
        
        long time = System.currentTimeMillis();
        BufferedReader reader = new BufferedReader(new InputStreamReader(
                new FileInputStream(INPUT), "utf-8"));
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(
                new FileOutputStream(OUTPUT), "utf-8"));
        int times = Integer.parseInt(reader.readLine().trim());
        Point[] point = new Point[10000];
        for (int i = 0; i < 10000; i++)
            point[i] = new Point();
        int mark = 0;
        for (int t = 0; t < times; t++) {
            String[] token = reader.readLine().split(" ");
            int n = Integer.parseInt(token[0]);
            int m = Integer.parseInt(token[1]);
            int[][] v = new int[n][m];
            int[][] a = new int[n][m];
            int c = 0;
            for (int i = 0; i < n; i++) {
                token = reader.readLine().trim().split(" ");
                for (int j = 0; j < m; j++) {
                    v[i][j] = Integer.parseInt(token[j]);
                    point[c].x = i;
                    point[c].y = j;
                    point[c].v = v[i][j];
                    c++;
                }
            }
            Arrays.sort(point, 0, c);
            mark = 0;
            for (int i = 0; i < c; i++) {
                int x = point[i].x;
                int y = point[i].y;
                int min = 999999;
                int ptr = -1;
                for (int k = 0; k < 4; k++) {
                    int xl = x + move[k][0];
                    int yl = y + move[k][1];
                    if (xl >= 0 && xl < n && yl >= 0 && yl < m) {
                        if (v[xl][yl] < min) {
                            min = v[xl][yl];
                            ptr = k;
                        }
                    }
                }
                if (ptr != -1 && min < point[i].v) {
                    a[x][y] = a[x + move[ptr][0]][y + move[ptr][1]];
                } else {
                    a[x][y] = mark;
                    mark++;
                }
            }
            int p = 'a';
            for (int i = 0; i < n; i++)
                for (int j = 0; j < m; j++) {
                    if (a[i][j] < 'a') {
                        int te = a[i][j];
                        for (int x = 0; x < n; x++)
                            for (int y = 0; y < m; y++)
                                if (a[x][y] == te)
                                    a[x][y] = p;
                        p++;
                    }
                }
            writer.write("Case #" + (t + 1) + ":\n");
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < m; j++) {
                    writer.write((char)(a[i][j]) + " ");
                }
                writer.write("\n");
            }
        }
        System.out.println(System.currentTimeMillis() - time);
        reader.close();
        writer.close();
    }

}
