import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

/**
 * @(#)AllYourBase.java, 2009-9-13. 
 * 
 * Copyright 2009 Yodao, Inc. All rights reserved.
 * YODAO PROPRIETARY/CONFIDENTIAL. Use is subject to license terms.
 */

/**
 *
 * @author ares
 *
 */
public class AllYourBase {
    
    private static final String INPUT = "input.txt";

    private static final String OUTPUT = "output.txt";
    
    private static int readInt(BufferedReader reader) throws Exception {
        String line = reader.readLine();
        return Integer.parseInt(line);
    }
    
    private static int[] readInts(BufferedReader reader) throws Exception {
        String[] tokens = reader.readLine().split(" ");
        int[] res = new int[tokens.length];
        for (int i = 0; i < tokens.length; i++) {
            res[i] = Integer.parseInt(tokens[i]);
        }
        return res;
    }
    
    private static int fmin(boolean[] m, boolean not0) {
        int start = not0 ? 1 : 0;
        for (int i = start; i < m.length; i++) {
            if (!m[i]) {
                m[i] = true;
                return i;
            }
        }
        throw new RuntimeException();
    }
    
    private static void set(int[] a, char c, int v) {
        if (c >= '0' && c <= '9') {
            a[c - '0'] = v;
        } else {
            a[c - 'a' + 10] = v;
        }
    }
    
    private static int mark(char c) {
        if (c >= '0' && c <= '9') {
            return c - '0';
        } else {
            return c - 'a' + 10;
        }
    }
    
    public static void main(String[] args) throws Exception {
        BufferedReader reader = new BufferedReader(new InputStreamReader(
                new FileInputStream(INPUT), "utf-8"));
        BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(
                new FileOutputStream(OUTPUT), "utf-8"));
        int cn = readInt(reader);
        for (int i = 0; i < cn; i++) {
            String line = reader.readLine();
            int n = line.length();
            System.out.println(line);
            char[] c = line.toCharArray();
            int[] w = new int[n];
            int[] a = new int[36];
            for (int j = 0; j < 36; j++)
                a[j] = -1;
            int tot = 0;
            for (int j = 0; j < n; j++) {
                int m = mark(c[j]);
                if (j == 0) {
                    w[j] = 1;
                    set(a, c[j], 1);
                } else if (a[m] != -1){
                    w[j] = a[m];
                } else {
                    w[j] = tot;
                    set(a, c[j], tot);
                    if (tot == 0)
                        tot = 2;
                    else
                        tot ++;
                }
            }
            
            long t = 0;
            long v = 1;
            if (tot <= 1)
                tot = 2;
            for (int j = n - 1; j >= 0; j--) {
                t = t + v * w[j];
                v = v * tot; 
            }
            
            System.out.println();
            writer.write("Case #" + (i + 1) + ": " + t + "\n");
            System.out.println(tot);
        }
        reader.close();
        writer.close();
    }

}
