import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class Problem1 {
	
	private static final String INPUT = "d:/input.txt";
	
	private static final String OUTPUT = "d:/output.txt";
	
	private static PrintWriter output;
	
	private static Scanner input;
	
	private static int total = 0;
	
	private static class Node {
		String name;
		List<Node> children = new ArrayList<Node>();
	}
	
	private static void add(Node father, String[] token, int ptr) {
		String childName = token[ptr];
		Node pChild = null;
		for (int i = 0; i < father.children.size(); i++) {
			Node child = father.children.get(i);
			if (child.name.equals(childName)) {
				pChild = child;
				break;
			}
		}
		if (pChild == null) {
			total++;
			pChild = new Node();
			pChild.name = childName;
			father.children.add(pChild);
		}
		if (ptr == token.length - 1) {
			return;
		}
		add(pChild, token, ptr + 1);
	}
	
	private static void exec() throws Exception {
		total = 0;
		Node root = new Node();
		int n = input.nextInt();
		int m = input.nextInt();
		input.nextLine();
		for (int i = 0; i < n; i++) {
			String line = input.nextLine();
			String[] tokens = line.split("/");
			add(root, tokens, 1);
		}
		int current = total;
		for (int i = 0; i < m; i++) {
			String line = input.nextLine();
			String[] tokens = line.split("/");
			add(root, tokens, 1);
		}
		output.print(total - current);
	}
	
	public static void main(String[] args) throws Exception {
		input = new Scanner(new File(INPUT));
		output = new PrintWriter(new OutputStreamWriter(new FileOutputStream(OUTPUT)));
		int n = input.nextInt();
		for (int i = 0; i < n; i++) {
			output.print("Case #" + (i + 1) + ": ");
			exec();
			output.println();
		}
		output.close();
		input.close();
	}

}
