import java.io.*;
import java.util.*;

public class A {
	public static void main(String[] args) {
		new A().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		for (File inf : (new File(".")).listFiles()) {
			if (inf.getName().startsWith("A-") && inf.getName().endsWith(".in")) {
				System.out.println("Processing " + inf.getName() + ":");
				try {
					br = new BufferedReader(new FileReader(inf));
					File ouf = new File(inf.getName().replaceAll("\\.in",
							".out"));
					if (ouf.exists()) {
						String prefix = ouf.getName()
								.replaceAll("\\.out", ".o");
						int i = 0;
						while (new File(prefix + String.format("%02d", i))
								.exists()) {
							++i;
						}
						ouf.renameTo(new File(prefix + String.format("%02d", i)));
					}
					out = new PrintWriter(ouf);
					eof = false;
					solve();
				} catch (Throwable e) {
					e.printStackTrace();
					System.exit(-1);
				} finally {
					out.close();
				}
			}
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int testCount = nextInt();
		for (int testNumber = 1; testNumber <= testCount; ++testNumber) {
			System.out.println(testNumber + " / " + testCount);
			out.print("Case #" + testNumber + ": ");
			int n = nextInt();
			Vine[] v = new Vine[n + 1];
			for (int i = 0; i < n; ++i) {
				v[i] = new Vine(nextInt(), nextInt());
			}
			v[n] = new Vine(nextInt(), 0);
			
			Arrays.sort(v);
			
			int[] D = new int[n + 1];
			Arrays.fill(D, INF);
			
			D[0] = 0;
			
			for (int i = 0; i < D.length; ++i) {
				if (D[i] >= INF) continue;
				
				D[i] = Math.max(D[i], v[i].d - v[i].l);
				
				for (int j = i + 1; j < D.length; ++j) {
					if (v[j].d <= v[i].d + (v[i].d - D[i])) {
						D[j] = Math.min(D[j], v[i].d);
					}
				}
			}
			
			out.println(D[n] >= INF ? "NO" : "YES");
			out.flush();
		}
	}
	
	final int INF = Integer.MAX_VALUE / 2;
	
	class Vine implements Comparable<Vine> {
		int d, l;
		
		public Vine(int d, int l) {
			this.d = d;
			this.l = l;
		}

		@Override
		public int compareTo(Vine o) {			
			return d - o.d;
		}
		
	}
}
