import java.io.*;
import java.util.*;

public class B {
	public static void main(String[] args) {
		new B().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		for (File inf : (new File(".")).listFiles()) {
			if (inf.getName().startsWith("B-") && inf.getName().endsWith(".in")) {
				System.out.println("Processing " + inf.getName() + ":");
				try {
					br = new BufferedReader(new FileReader(inf));
					File ouf = new File(inf.getName().replaceAll("\\.in",
							".out"));
					if (ouf.exists()) {
						String prefix = ouf.getName()
								.replaceAll("\\.out", ".o");
						int i = 0;
						while (new File(prefix + String.format("%02d", i))
								.exists()) {
							++i;
						}
						ouf.renameTo(new File(prefix + String.format("%02d", i)));
					}
					out = new PrintWriter(ouf);
					eof = false;
					solve();
				} catch (Throwable e) {
					e.printStackTrace();
					System.exit(-1);
				} finally {
					out.close();
				}
			}
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int testCount = nextInt();
		for (int testNumber = 1; testNumber <= testCount; ++testNumber) {
			System.out.println(testNumber + " / " + testCount);
			out.print("Case #" + testNumber + ": ");

			int n = nextInt();
			int w = nextInt();
			int l = nextInt();

			Pair[] R = new Pair[n];
			for (int i = 0; i < n; ++i) {
				R[i] = new Pair(nextInt(), i);
			}

			Arrays.sort(R);

			ArrayDeque<Point> poi = new ArrayDeque<>();
			ArrayDeque<Point> np = new ArrayDeque<>();

			poi.addFirst(new Point(0, 0));

			Point[] ans = new Point[n];
			
			for (Pair pr : R) {
				int r = pr.r;
				if (poi.isEmpty()) {
					poi = np;
					np = new ArrayDeque<>();
					if (poi.isEmpty()) {
						throw new Error("fail =(");
					}
				}

				Point p = poi.pollFirst();
				ans[pr.n] = p;
				
				if (p.y + 2 * r <= l) {
					np.addLast(new Point(p.x, p.y + 2 * r));
				}

				if (p.x + 2 * r <= w) {
					int ty = p.y;
					while (!poi.isEmpty() && poi.peekFirst().x < p.x + 2 * r) {
						ty = poi.pollFirst().y;
					}
					if (poi.isEmpty()) {
						ty = 0;
					}
					poi.addFirst(new Point(p.x + 2 * r, ty));
				}
			}
				
			for (Point p : ans) {
				out.print(p.x + ".0 " + p.y + ".0 ");
			}
			out.println();
			out.flush();
		}
	}

	class Pair implements Comparable<Pair> {
		int r, n;

		public Pair(int r, int n) {
			this.r = r;
			this.n = n;
		}

		@Override
		public int compareTo(Pair o) {
			return o.r - r;
		}
		
		
	}

	class Point {
		int x, y;

		public Point(int x, int y) {
			this.x = x;
			this.y = y;
		}
		
		@Override
		public String toString() {
			return x + ".0 " + y + ".0 ";
		}
	}
}
