import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof;
    
    
    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new  BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    long nextLong() {
        return Long.parseLong(nextToken());
    }
        
    int[] p;
    boolean[] u;
    int k;
    String s;
    char[] t;
    
    int calc() {
    	for (int i = 0; i < s.length() / k; i++) {
    		for (int j = 0; j < k; j++) {
    			t[k * i + j] = s.charAt(k * i + p[j]);
    		}
    	}
    	
    	int ans = 1;    	
    	for (int i = 1; i < s.length(); i++) {
    		if (t[i - 1] != t[i]) ans++;
    	}
    	return ans;
    }
    
    
    int dfs(int c) {
    	if (c >= k) {
    		return calc();
    	}
    	int ans = Integer.MAX_VALUE;
    	for (int i = 0; i < k; i++) {
    		if (!u[i]) {
    			u[i] = true;
    			p[c] = i;
    			ans = Math.min(ans, dfs(c + 1));
    			u[i] = false;
    		}
    	}
    	return ans;
    }

    
    void solve() throws IOException {
        int N = nextInt();
        for (int tn = 1; tn <= N; tn++) {
        	k = nextInt();
        	p = new int[k];
        	u = new boolean[k];
        	s = nextToken();
        	t = new char[s.length()];
        	int ans = dfs(0);
           	out.println("Case #" + tn + ": " + ans);
        }
    }
    
}
