import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;
	
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new  BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}
	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	int toMin(String s) {
		s = s.trim();
		return (Integer.valueOf(s.substring(0, 2))) * 60 + (Integer.valueOf(s.substring(3, 5))); 
	}
	
	void solve() throws IOException {
		int n = nextInt();
		for (int tn = 1; tn <= n; tn++) {
			int t = nextInt();
			int na = nextInt();
			int nb = nextInt();
			Pair[] tab = new Pair[na + nb];
			for (int i = 0; i < na; i++) {			
				tab[i] = new Pair(toMin(nextToken()), toMin(nextToken()) + t, 0);
			}
			for (int i = na; i < na + nb; i++) {
				tab[i] = new Pair(toMin(nextToken()), toMin(nextToken()) + t, 1);
			}
			Arrays.sort(tab);
			
			int ans[] = new int[2];
			PriorityQueue<Integer>[] pq  = new PriorityQueue[2];
			pq[0] = new PriorityQueue<Integer>();
			pq[1] = new PriorityQueue<Integer>();
			for (Pair p : tab) {
				if (pq[p.type].size() == 0 || pq[p.type].peek() > p.lt) {
					ans[p.type]++;
				} else {
					pq[p.type].poll();
				}
				pq[1 - p.type].add(p.at);
			}
			out.println("Case #" + tn + ": " + ans[0] + " " + ans[1]);
		}
	}
	

	class Pair implements Comparable<Pair>{
		int lt, at, type;
		
		Pair(int a, int b, int t) {
			lt = a;
			at = b;
			type = t;
		}

		@Override
		public int compareTo(Pair o) {
			if (lt < o.lt) return -1;
			if (lt > o.lt) return 1;
			return 0;
		}
		
	}
	
}
