import java.io.*;
import java.util.*;
import java.math.*;

public class A {
	public static void main(String[] args) {
		new A().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

//	String FNAME = "A-sample";
	String FNAME = "A-small-attempt0";
	private void solve() throws IOException {
		int T = nextInt();
		for (int test = 1; test <= T; ++test) {
			double x = nextDouble();
			double s = nextDouble();
			double r = nextDouble();
			double t = nextDouble();
			int n = nextInt();
			Pair[] p = new Pair[n + 1];

			for (int i = 0; i < n; ++i) {
				double b = nextDouble();
				double e = nextDouble();
				double v = nextDouble();
				p[i] = new Pair(e - b, v);
				x -= p[i].len;
			}
			p[n] = new Pair(x, 0);
			Arrays.sort(p);

			double ans = 0;
			for (int i = 0; i < p.length; ++i) {
				double tt = p[i].len / (p[i].v + r);
				if (tt <= t) {
					ans += tt;
					t -= tt;
				} else {
					ans += t;
					double f = p[i].len - t * (p[i].v + r);
					ans += f / (p[i].v + s);
					t = 0;
				}
			}
			
			out.println("Case #" + test + ": " + ans);
		}
	}
	
	class Pair implements Comparable<Pair> {
		double len, v;
		
		public Pair(double len, double v) {
			this.len = len;
			this.v = v;
		}

		@Override
		public int compareTo(Pair o) {
			return Double.compare(v, o.v);
		}
	}
}