import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof;
    
    
    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new  BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    long nextLong() {
    	return Long.parseLong(nextToken());
    }
    
    long cnk(long n, long k) {
    	long ans = 1;
    	for (int i = 0; i < k; i++) {
    		ans *= (n - i);
    	}
    	for (int i = 1; i <= k; i++) {
    		ans /= i;
    	}
    	return ans;
    }
    
    ArrayList<Integer>[] G;
    boolean[] u;
    
    void dfs(int i) {
    	u[i] = true;
    	for (int j : G[i]) {
    		if (!u[j]) {
    			dfs(j);
    		}
    	}
    }
    
    void solve() throws IOException {
        int N = nextInt();
        for (int tn = 1; tn <= N; tn++) {
            long a = nextLong();
            long b = nextLong();
            long p = nextLong();
            int n = (int)(b - a + 1L);
            long ans = 0;
            if (p >= n) {
            	ans = n;
            } else {
            	G = new ArrayList[n];
            	for (int i = 0; i < n; i++) {
            		G[i] = new ArrayList<Integer>();
            	}
            	for (long i = p; i < n; i++) {
            		if (!BigInteger.valueOf(i).isProbablePrime(1000)) continue;
            		long j = ((a + i - 1) / i) * i;
            		j += i;
            		while (j <= b) {
            			int z = (int)(j - a - i);
            			int x = (int)(j - a);
            			G[z].add(x);
            			G[x].add(z);
            			j += i;
            		}
            	}
            	u = new boolean[n];
            	
            	for (int i = 0; i < n; i++) {
            		if (!u[i]) {
            			dfs(i);
            			ans++;
            		}
            	}
            }
            out.println("Case #" + tn + ": " + ans);
        }
    }
    
}
