import java.io.*;
import java.util.*;
import java.math.*;

public class C3 implements Runnable {

	private void solve() throws IOException {
		int T = in.nextInt();
		for (int tn = 1; tn <= T; ++tn) {
			int n = in.nextInt();
			int k = in.nextInt();
			int[][] p = new int[n][k];
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < k; ++j) {
					p[i][j] = in.nextInt();
				}
			}
			
			for (int i = 0; i < n; ++i) {
				for (int j = i + 1; j < n; ++j) {
					if (cmp(p[i], p[j]) > 0) {
						int[] t = p[i];
						p[i] = p[j];
						p[j] = t;
					}
				}
			}
			
			boolean[][] g = new boolean[n][n];
			for (int j = 0; j < k - 1; ++j) {
				for (int i = 0;i < n; ++i) {
					for (int q = 0; q < n; ++q) {
						if (i == q) continue;
						if (p[i][j] <= p[q][j] && p[i][j + 1] >= p[q][j + 1] ||
							p[i][j] >= p[q][j] && p[i][j + 1] <= p[q][j + 1]) {
							g[i][q] = true;
							g[q][i] = true;
						}
					}
				}
			}
			
			boolean[] u = new boolean[n];
			int ans = 0;
			for (int i = 0; i < n; ++i) {
				if (u[i]) continue;
				++ans;
				HashSet<Integer> hs = new HashSet<Integer>();
				loop:
				for (int q = i; q < n; ++q) {
					if (u[q]) continue;
					for (int j : hs) {
						if (g[j][q]) continue loop;
					}
					u[q] = true;
					hs.add(q);
				}
			}
			
			out.println("Case #" + tn + ": " + ans);
		}
	}

	
	int cmp(int[] a, int[] b) {
		for (int i = 0; i < a.length; ++i) {
			if (a[i] < b[i]) return -1;
			if (a[i] > b[i]) return 1;
		}
		return 0;
	}
	
	
	final String FILE_NAME = "cs2";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new C3()).start();
	}
	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}

	
}

