import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;
	
	
	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new  BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}
	
	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}
	
	int nextInt() {
		return Integer.parseInt(nextToken());
	}
	
	int toMin(String s) {
		s = s.trim();
		return (Integer.valueOf(s.substring(0, 2))) * 60 + (Integer.valueOf(s.substring(3, 5))); 
	}
	
	void solve() throws IOException {
		int n = nextInt();
		for (int tn = 1; tn <= n; tn++) {
			int t = nextInt();
			int na = nextInt();
			int nb = nextInt();
			Pair[] tab = new Pair[na + nb];
			for (int i = 0; i < na; i++) {			
				tab[i] = new Pair(toMin(nextToken()), toMin(nextToken()) + t, 0);
			}
			for (int i = na; i < na + nb; i++) {
				tab[i] = new Pair(toMin(nextToken()), toMin(nextToken()) + t, 1);
			}
			Arrays.sort(tab);
			
			int ans[] = new int[2];
			TreeSet<P2> tm[] = new TreeSet[2];
			tm[0] = new TreeSet<P2>();
			tm[1] = new TreeSet<P2>();
			int dummy = 0;
			for (Pair p : tab) {
				if (tm[p.type].size() == 0 || tm[p.type].first().a > p.lt) {
					ans[p.type]++;
				} else {
					tm[p.type].pollFirst();
				}
				tm[1 - p.type].add(new P2(p.at, dummy));
				dummy++;
			}
			out.println("Case #" + tn + ": " + ans[0] + " " + ans[1]);
		}
	}
	
	class P2 implements Comparable<P2> {
		int a, b;
		
		P2(int a, int b) {
			this.a = a;
			this.b = b;
		}

		@Override
		public int compareTo(P2 o) {
			if (a < o.a) return -1;
			if (a > o.a) return 1;
			if (b < o.b) return -1;
			if (b > o.b) return 1;
			return 0;
		}
		
		
	}
	
	class Pair implements Comparable<Pair>{
		int lt, at, type;
		
		Pair(int a, int b, int t) {
			lt = a;
			at = b;
			type = t;
		}

		@Override
		public int compareTo(Pair o) {
			if (lt < o.lt) return -1;
			if (lt > o.lt) return 1;
			return 0;
		}
		
	}
	
}
