import java.io.*;
import java.util.*;
import java.math.*;

public class D {
	public static void main(String[] args) {
		new D().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine(), " \t\n,");
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

//	String FNAME = "D-sample";
	String FNAME = "D-small-attempt2";

	private void solve() throws IOException {
		int T = nextInt();
		for (int test = 1; test <= T; ++test) {
			int n = nextInt() + 1;
			int m = nextInt();
			g = new boolean[n][n];
			for (int i = 0; i < m; ++i) {
				int a = nextInt() + 1;
				int b = nextInt() + 1;
				g[a][b] = g[b][a] = true;
			}
			
			g[1][0] = g[0][1] = true;
			
			int[] d = new int[n];
			Arrays.fill(d, INF);
			
			int[] nm = new int[n];
			int w = 0;
			d[0] = 0;
			
			ArrayDeque<Integer> q = new ArrayDeque<Integer>();
			q.addLast(0);
			
			while (!q.isEmpty()) {
				int u = q.pollFirst();
				nm[w++] = u;
				for (int v = 0; v < g[u].length; ++v) {
					if (g[u][v] && d[v] > d[u] + 1) {
						d[v] = d[u] + 1;
						q.addLast(v);
					}
				}
			}

			out.print("Case #" + test + ": " + (d[2] - 2) + " ");
			
			int[][] cross = new int[n][n];
			for (int a = 0; a < n; ++a) {
				for (int b = 0; b < n; ++b) {
					for (int c = 0; c < n; ++c) {
						if (g[a][c] && g[b][c]) ++cross[a][b];
					}
				}
			}
			
			int[][][] cross3 = new int[n][n][n];
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					for (int k = 0; k < n; ++k) {
						int tmp = 0;
						for (int l = 0; l < n; ++l) {
							if (g[i][l] && g[j][l] && g[k][l]) {
								++tmp;
							}
						}
						cross3[i][j][k] = tmp;
					}
				}
			}
			
			int[] rdeg = new int[n];
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					if (g[i][j] && d[j] + 1 == d[i]) ++rdeg[i];
				}
			}

			int[] fdeg = new int[n];
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					if (g[i][j] && d[j] - 1 == d[i]) ++fdeg[i];
				}
			}
			
			int[] deg = new int[n];
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					if (g[i][j]) ++deg[i];
				}
			}
			
			int[][] D = new int[n][n];
			
			for (int[] t : D) {
				Arrays.fill(t, -1);
			}
			
			D[1][0] = fdeg[1];
			
			for (int i = 1; i < w; ++i) {
				int u = nm[i];
				if (d[u] == d[2]) break;

				for (int j = 0; j < n; ++j) {
					if (!g[u][j] || d[j] + 1 != d[u] || D[u][j] < 0) continue;
					for (int v = 0; v < n; ++v) {
						if (!g[u][v] || d[v] != d[u] + 1) continue;
						D[v][u] = Math.max(D[v][u], D[u][j] - 1 + deg[v] - cross[v][j] - cross[v][u] + cross3[j][u][v]); 
					}
				}
			}
			
			int ans = 0;
			for (int i = 0; i < n; ++i) {
				if (g[i][2] && d[i] + 1 == d[2]) {
					for (int j = 0; j < n; ++j) {
						ans = Math.max(ans, D[i][j]);
					}
				}
			}
			
			out.println(ans);
		}
	}
	
	final int INF = Integer.MAX_VALUE / 2;
	
	boolean[][] g;
}