import java.io.*;
import java.util.*;
import java.math.*;

public class B implements Runnable {
    public static void main(String[] args) {
	new Thread(new B()).start();
    }

    @Override
    public void run() {
	try {
	    br = new BufferedReader(new FileReader("b.in"));
	    out = new PrintWriter("b.out");
	    solve();
	    out.close();
	} catch (Throwable e) {
	    e.printStackTrace();
	    System.exit(-1);
	}
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof = true;

    String cnv(String a) {
	return a.equals("") ? "0" : a;
    }

    String nextToken() {
	while (st == null || !st.hasMoreElements()) {
	    try {
		st = new StringTokenizer(br.readLine());
	    } catch (Exception e) {
		eof = true;
		return "";
	    }
	}
	return st.nextToken();
    }

    int nextInt() {
	return Integer.parseInt(cnv(nextToken()));
    }

    double nextDouble() {
	return Double.parseDouble(cnv(nextToken()));
    }

    private void solve() throws IOException {
	int t = nextInt();
	for (int tn = 1; tn <= t; ++tn) {
	    n = nextInt();
	    m = nextInt();
	    map = new int[n][m];
	    for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
		    map[i][j] = nextInt();
		}
	    }
	    
	    col = new int[n][m];
	    for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
		    if (col[i][j] == 0) {
			dfs(i, j);
		    }
		}
	    }
	                             
	    int[] p = new int[cl + 1];
	    cl = 0;
	    Arrays.fill(p, -1);
	    
	    out.println("Case #" + tn + ":");
	    
	    for (int i = 0; i < n; ++i) {
		for (int j = 0; j < m; ++j) {
		    if (j > 0) out.print(" ");
		    int q = col[i][j];
		    if (p[q] == -1) {
			p[q] = cl++; 
		    }
		    q = p[q];
		    out.print((char)('a' + q));
		}
		out.println();
	    }
	    
	}
    }

    int cl;
    
    private int dfs(int i, int j) {
	if (col[i][j] != 0) return col[i][j];
	int mx = -1;
	int my = -1;
	for (int k = 0; k < 4; ++k) {
	    int tx = i + dx[k];
	    int ty = j + dy[k];
	    if (0 <= tx && tx < n && 0 <= ty && ty < m && map[tx][ty] < map[i][j] && (mx == -1 || map[tx][ty] < map[mx][my])) {
		mx = tx;
		my = ty;
	    }
	}
	if (mx >= 0) {
	    col[i][j] = dfs(mx, my);
	} else {
	    col[i][j] = ++cl;
	}
	return col[i][j];
    }

    int[][] map, col;
    int n, m;
    
    int[] dx = {-1, 0, 0, 1};
    int[] dy = {0, -1, 1, 0};
    
}
