import java.io.*;
import java.util.*;
import java.math.*;

public class B implements Runnable {

	
	private void solve() throws IOException {
		int T = in.nextInt();
		for (int tn = 1; tn <= T; ++tn) {
			int l = in.nextInt();
			int r = in.nextInt();
			int c = in.nextInt();
			
			hm = new HashMap<Long, Integer>();
			out.println("Case #" + tn + ": " + calc(l, r, c));
		}
	}

	HashMap<Long, Integer> hm;
	
	int calc(int L, int R, long C) {
		if (L * C >= R) return 0;
		
		long h = L * (1L << 32) + R;
		Integer hv = hm.get(h);
		if (hv != null) return hv;
		
		int l = L + 1;
		int r = R;
		
		while (r - l > 1) {
			int m = (l + r) / 2;
			int lv = calc(L, m, C);
			int rv = calc(m, R, C);			
			if (lv <= rv) {
				l = m;
			} else {
				r = m;
			}
		}
		int ans = Math.max(calc(L, l, C), calc(l, R, C)) + 1;
		if (r < R) {
			ans = Math.min(ans, Math.max(calc(L, r, C), calc(r, R, C)) + 1);
		}
		hm.put(h, ans);
		return ans;
	}
	
//	
//	class Pair {
//		int l, r;
//		
//		public Pair(int l, int r) {
//			this.l = l;
//			this.r = r;
//		}
//		
//		@Override
//		public int hashCode() {
//			return l * 239017 + r;
//		}
//		
//		@Override
//		public boolean equals(Object o) {
//			if (!(o instanceof Pair)) return false;
//			Pair p = (Pair)o;
//			return l == p.l && r == p.r;
//		}
//	}
	
	final String FILE_NAME = "B-small-attempt0";

	SimpleScanner in;
	PrintWriter out;

	@Override
	public void run() {
		try {
			in = new SimpleScanner(new FileReader(FILE_NAME + ".in"));
			out = new PrintWriter(FILE_NAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	public static void main(String[] args) {
		new Thread(new B()).start();
	}

	void myAssert(boolean e) {
		if (!e) {
			throw new Error("assertion failed");
		}
	}

	int assertBounds(int l, int m, int r) {
		myAssert(l <= m && m <= r);
		return m;
	}

	class SimpleScanner extends BufferedReader {

		private StringTokenizer st;
		private boolean eof;

		public SimpleScanner(Reader a) {
			super(a);
		}

		String next() {
			while (st == null || !st.hasMoreElements()) {
				try {
					st = new StringTokenizer(readLine());
				} catch (Exception e) {
					eof = true;
					return "";
				}
			}
			return st.nextToken();
		}

		boolean seekEof() {
			String s = next();
			if ("".equals(s) && eof)
				return true;
			st = new StringTokenizer(s + " " + st.toString());
			return false;
		}

		private String cnv(String s) {
			if (s.length() == 0)
				return "0";
			return s;
		}

		int nextInt() {
			return Integer.parseInt(cnv(next()));
		}

		double nextDouble() {
			return Double.parseDouble(cnv(next()));
		}

		long nextLong() {
			return Long.parseLong(cnv(next()));
		}
	}
}