import java.io.*;
import java.util.*;

public class C {
	public static void main(String[] args) {
		new C().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		for (File inf : (new File(".")).listFiles()) {
			if (inf.getName().startsWith("C-") && inf.getName().endsWith(".in")) {
				System.out.println("Processing " + inf.getName() + ":");
				try {
					br = new BufferedReader(new FileReader(inf));
					File ouf = new File(inf.getName().replaceAll("\\.in",
							".out"));
					if (ouf.exists()) {
						String prefix = ouf.getName()
								.replaceAll("\\.out", ".o");
						int i = 0;
						while (new File(prefix + String.format("%02d", i))
								.exists()) {
							++i;
						}
						ouf.renameTo(new File(prefix + String.format("%02d", i)));
					}
					out = new PrintWriter(ouf);
					eof = false;
					solve();
				} catch (Throwable e) {
					e.printStackTrace();
					System.exit(-1);
				} finally {
					out.close();
				}
			}
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int testCount = nextInt();
		loop:
		for (int testNumber = 1; testNumber <= testCount; ++testNumber) {
			System.out.println(testNumber);
			out.print("Case #" + testNumber + ": ");
			int n = nextInt();
			int[] y = new int[n - 1];
			G = initG(n);
			boolean absurd = false;
			for (int i = 0; i < y.length; ++i) {
				y[i] = nextInt() - 1;
				absurd |= y[i] <= i;
				G[y[i]].add(i);
			}

			if (absurd) {
				out.println("Impossible");
				continue loop;
			}
				
			
			ans = new int[n];
			u = new boolean[n];
			Arrays.fill(ans, INF);
			
			int x = 0;
			u[0] = true;
			while (x < y.length) {
				u[y[x]] = true;
				if (!fill(x, y[x], 0)) {
					out.println("Impossible");
					continue loop;
				}
				x = y[x];
			}
			
			for (boolean b : u) {
				if (!b) {
					out.println("Impossible");
					continue loop;
				}
			}
			
			for (int i : ans) {
				out.print(i + " ");
			}
			
			out.println();
			out.flush();
		}
	}
	
	final int INF = 1000000000;

	ArrayList<Integer>[] G;
	int[] ans;
	boolean[] u;
	
	boolean fill(int l, int r, int k) {
		Collections.sort(G[r]);
		int p = l;
		for (int j : G[r]) {
			if (j < l) return false;
			if (j == l) continue;
			ans[j] = ans[r] - 1 - (r - j) * k;
			u[j] = true;
			if (!fill(p, j, k + 1)) return false;
			p = j;
		}
		return true;
	}
	
	ArrayList<Integer>[] initG(int n) {
		ArrayList<Integer>[] ans = new ArrayList[n];
		for (int i = 0; i < ans.length; ++i) {
			ans[i] = new ArrayList<>();
		}
		return ans;
	}
}
