import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof;
    
    
    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new  BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    long nextLong() {
        return Long.parseLong(nextToken());
    }
        
    
    void solve() throws IOException {
        int N = nextInt();
        for (int tn = 1; tn <= N; tn++) {
        	int n = nextInt();
        	int m = nextInt();
        	boolean[][] G = new boolean[n][m];
        	for (int i = 0; i < n; i++) {
        		String s = nextToken();
        		for (int j = 0; j < m; j++) {
        			G[i][j] = (s.charAt(j) == '.');
        		}
        	}
        	
        	int[] rc = new int[n + 1];
        	for (int i = 1; i <= n; i++) {
        		for (int j = 0; j < m; j++) {
        			rc[i] *= 2;
        			if (!G[i - 1][j]) {
        				rc[i]++;
        			}        			
        		}
        	}
        	
        	int[] gp = new int[1 << m];
        	int sgp = 0;
        	for (int p = 0; p < (1 << m); p++) {
        		if ((p & (p * 2)) == 0 && (p & (p / 2)) == 0) {
        			gp[sgp] = p;
        			sgp++;
        		}
        	}
        	
        	int[][] D = new int[n + 1][1 << m];
        	
        	for (int i = 1; i <= n; i++) {
        		for (int ip1 = 0; ip1 < sgp; ip1++) {
        			int p1 = gp[ip1];
        			if ((p1 & rc[i - 1]) != 0) continue;
        			for (int ip2 = 0; ip2 < sgp; ip2++) {
        				int p2 = gp[ip2];
        				if ((p2 & rc[i]) != 0) continue;
        				int q = (p2 * 2) | (p2 / 2);
        				if ((p1 & q) != 0) continue;
        				
       					D[i][p2] = Math.max(D[i][p2], D[i - 1][p1] + Integer.bitCount(p2));
        			}
        		}
        	}
        	
        	int ans = 0;
        	for (int p = 0; p < (1 << m); p++) {
        		ans = Math.max(ans, D[n][p]);
        	}
        	
        	out.println("Case #" + tn + ": " + ans);
        }
    }
    
}
