import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof;
    
    
    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new  BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    long nextLong() {
        return Long.parseLong(nextToken());
    }
        
    void solve() throws IOException {
        int N = nextInt();
        for (int tn = 1; tn <= N; tn++) {
            int m = nextInt();
            int v = nextInt();
            int in = (m - 1) / 2;
            int[] g = new int[in];
            boolean[] c = new boolean[in];
            for (int i = 0; i < in; i++) {
            	g[i] = nextInt();
            	c[i] = (nextInt() == 1);
            }
            int[][] D = new int[2][m];
            boolean[][] pd = new boolean[2][m];
            
            for (int i = in; i < m; i++) {
            	pd[nextInt()][i] = true; 
            }
            
            for (int i = in - 1; i >= 0; i--) {
            	if (i == 1) {
            		i += 0;
            	}
            	for (int t = 0; t < 2; t++) {
            		int q = 0;
            		if (t != g[i]) {
            			if (!c[i]) continue;
            			q = 1;
            		}
            		
            		int l = 2 * i + 1;
            		int r = 2 * i + 2;
            		
            		for (int ln = 0; ln < 2; ln++) {
            			if (!pd[ln][l]) continue;
            			for (int rn = 0; rn < 2; rn++) {
            				if (!pd[rn][r]) continue;
            				int a = ln | rn;
            				if (t == 1) {
            					a = ln & rn;
            				}
            				if (!pd[a][i] || D[a][i] > q + D[ln][l] + D[rn][r]) {
            					pd[a][i] = true;
            					D[a][i] = q + D[ln][l] + D[rn][r];
            				}
            			}
            		}
            	}
            }
            
            if (!pd[v][0]) {
            	out.println("Case #" + tn + ": IMPOSSIBLE");
            } else {
            	out.println("Case #" + tn + ": " + D[v][0]);
            }
        }
    }
    
}
