import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

	public static void main(String[] args) {
		new Thread(new Main()).start();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		try {
			Locale.setDefault(Locale.US);
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(-1);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	double eps = 1e-10;

	boolean in(double r, double x, double y) {
		return r * r > x * x + y * y;
	}
	
	double cross(double r, double x1, double y1, double x2, double y2) {
		if (!in(r, x1, y1)) return 0;
		if (in(r, x2, y2)) return (x2 - x1) * (y2 - y1);
		if (!in(r, x1, y2) && !in(r, x2, y1)) {
			x2 = Math.sqrt(r * r - y1 * y1);
			y2 = Math.sqrt(r * r - x1 * x1);
			double a = Math.atan2(y2, x1) - Math.atan2(y1, x2);
			return (a * r * r - x2 * y1 - x1 * y2) / 2 + x1 * y1;		
		} else {
			return cross(r, x1, y1, x1 + 2 * r, y1 + 2 * r) - 
				   cross(r, x1, y2, x1 + 2 * r, y1 + 2 * r) -
				   cross(r, x2, y1, x1 + 2 * r, y1 + 2 * r);
		}
	}
	
	void solve() throws IOException {
		int n = nextInt();
		for (int tn = 1; tn <= n; tn++) {
			double f = nextDouble();
			double R = nextDouble();
			double t = nextDouble();
			double r = nextDouble();
			double g = nextDouble();
			g -= 2 * f;
			t += f;
			r += f;

			double ans = 0;
			if (g > 0 && R - t > 0) {
				double ir = R - t;
				int i = 0;
				while (true) {
					double x1 = r + (2 * r + g) * i;
					i++;
					if (x1 > ir) break;
					int j = 0;
					while (true) {
						double y1 = r + (2 * r + g) * j;
						j++;
						if (y1 > ir) break;
						ans += cross(ir, x1, y1, x1 + g, y1 + g);
					}
				}
			}
			out.println("Case #" + tn + ": " + (1 - (4 * ans / (Math.PI * R * R))));
		}
	}

}
