import java.io.*;
import java.util.*;
import java.math.*;

public class B {
	public static void main(String[] args) {
		new B().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof = false;
	Random rand = new Random(125475452);

	private void run() {
		Locale.setDefault(Locale.US);
		try {
			br = new BufferedReader(new FileReader(FNAME + ".in"));
			out = new PrintWriter(FNAME + ".out");
			solve();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			System.exit(566);
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreTokens()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	String FNAME = "B-small-attempt0";

	private void solve() throws IOException {
		int T = nextInt();
		for (int test = 1; test <= T; ++test) {
			int n = nextInt();
			int m = nextInt();
			nextInt();
			int[][] w = new int[n][m];
			for (int i = 0; i < n; ++i) {
				String s = nextToken();
				for (int j = 0; j < m; ++j) {
					w[i][j] = s.charAt(j) - '0'; 
				}
			}
			int[][] sm = new int[n + 1][m + 1];
			int[][] sx = new int[n + 1][m + 1];
			int[][] sy = new int[n + 1][m + 1];
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < m; ++j) {
					sx[i + 1][j + 1] = sx[i][j + 1] + sx[i + 1][j] - sx[i][j] + (i + 1) * w[i][j];
					sy[i + 1][j + 1] = sy[i][j + 1] + sy[i + 1][j] - sy[i][j] + (j + 1) * w[i][j];
					sm[i + 1][j + 1] = sm[i][j + 1] + sm[i + 1][j] - sm[i][j] + w[i][j];
				}
			}
			
			int ans = 0;
			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < n; ++j) {
					for (int k = Math.min(n - i, m - j); k >= 3 && k >= ans; --k) {
//					for (int k = 3; i + k <= n && j + k <= m; ++k) {
						int rx = sx[i + k][j + k] - sx[i][j + k] - sx[i + k][j] + sx[i][j];
						rx -= w[i][j] * (i + 1) + w[i + k - 1][j] * (i + k) + w[i][j + k - 1] * (i + 1) + w[i + k - 1][j + k - 1] * (i + k);
						int ry = sy[i + k][j + k] - sy[i][j + k] - sy[i + k][j] + sy[i][j];
						ry -= w[i][j] * (j + 1) + w[i + k - 1][j] * (j + 1) + w[i][j + k - 1] * (j + k) + w[i + k - 1][j + k - 1] * (j + k);
						int ma = sm[i + k][j + k] - sm[i][j + k] - sm[i + k][j] + sm[i][j];
						ma -= w[i][j] + w[i + k - 1][j] + w[i][j + k - 1] + w[i + k - 1][j + k - 1];
						
						if (2 * rx == ma * (2 * i + k + 1) && 2 * ry == ma * (2 * j + k + 1)) {
							ans = Math.max(ans, k);
						}
					}
				}
			}
			
			out.print("Case #" + test + ": ");
			if (ans == 0) {
				out.println("IMPOSSIBLE");
			} else {
				out.println(ans);
			}
		}
	}
}