import java.io.*;
import java.util.*;

public class B {
	public static void main(String[] args) {
		new B().run();
	}

	BufferedReader br;
	StringTokenizer st;
	PrintWriter out;
	boolean eof;

	public void run() {
		for (File inf : (new File(".")).listFiles()) {
			if (inf.getName().startsWith("B-") && inf.getName().endsWith(".in")) {
				System.out.println("Processing " + inf.getName() + ":");
				try {
					br = new BufferedReader(new FileReader(inf));
					File ouf = new File(inf.getName().replaceAll("\\.in",
							".out"));
					out = new PrintWriter(ouf);
					st = null;
					eof = false;
					solve();
				} catch (Throwable e) {
					e.printStackTrace();
					System.exit(-1);
				} finally {
					out.close();
				}
			}
		}
	}

	String nextToken() {
		while (st == null || !st.hasMoreElements()) {
			try {
				st = new StringTokenizer(br.readLine());
			} catch (Exception e) {
				eof = true;
				return "0";
			}
		}
		return st.nextToken();
	}

	int nextInt() {
		return Integer.parseInt(nextToken());
	}

	double nextDouble() {
		return Double.parseDouble(nextToken());
	}

	void solve() throws IOException {
		int testCount = nextInt();
		for (int testNumber = 1; testNumber <= testCount; ++testNumber) {
			System.out.println(testNumber + " / " + testCount);
			out.print("Case #" + testNumber + ": ");
			s = nextInt();
			int m = nextInt();
			
			T = new int[2 * s][2 * s];
			u = new int[2 * s][2 * s];

			
			
			g = new HashSet[3 * s + 2 * m];
			sz = new int[3 * s + 2 * m];
			ob = new boolean[3 * s + 2 * m];
			u2 = new int[3 * s + 2 * m];
			
			free = 0;
			
			int all = 0;
			
			for (int x = 1; x <= 2 * s - 1; ++x) {
				int k = getNode();
				ob[k] = true;
				if (k > 1) {
					g[k].add(k - 1);
				}
				if (k < 2 * s - 1) {
					g[k].add(k + 1);
				}
				for (int y = 1; y <= 2 * s - 1; ++y) {
					if (Math.abs(x - y) < s) {
						T[x][y] = k;
						++sz[k];
					}
				}
				all += sz[k];
			}
			
			int[] xx = new int[m];
			int[] yy = new int[m];
			for (int i = 0; i < m; ++i) {
				xx[i] = nextInt();
				yy[i] = nextInt();
			}
			
			boolean found = false;
			
			loop:
			for (int i = 1; i <= m; ++i) {
				int x = xx[i - 1];
				int y = yy[i - 1];
				int p = T[x][y]; 
				sz[p] = 0;
				g[p] = new HashSet<>();
				T[x][y] = -1;
				corners = 0;
				Arrays.fill(edges, false);
				++cnt;
				
				dfs(x, y);
				int ecnt = 0;
				for (boolean be : edges) {
					if (be) ++ecnt;
				}
				
				
				int a = getNode();
				int b = getNode();
				ob[a] = false;
				ob[b] = false;
				for (int ty = 1; ty <= 2 * s - 1; ++ty) {
					if (T[x][ty] == p) {
						if (ty > y) {
							T[x][ty] = b;
							++sz[b];
						} else {
							T[x][ty] = a;
							++sz[a];
						}
						for (int k = 0; k < dx.length; ++k) {
							int fx = x + dx[k];
							int fy = ty + dy[k];
							if (isValid(fx, fy) && T[fx][fy] >= 0) {
								g[T[x][ty]].add(T[fx][fy]);
								g[T[fx][fy]].add(T[x][ty]);
							}
						}
						if (isEdge(x, ty)) {
							ob[T[x][ty]] = true;
						}
					}
				}
				
				
				if (i == 6) {
					i += 0;
				}
				
				int tt = all - i;
				
				for (int j = 0; j < free; ++j) {
					if (ob[j] && u2[j] != cnt) {
						tt -= getSize(j);
					}
				}
				
				boolean prev = false;
				if (corners >= 2) {
					out.print("bridge");
					prev = true;
				}
				if (ecnt >= 3) {
					if (prev) {
						out.print("-");
					}
					out.print("fork");
					prev = true;
				}
				
				if (tt > 0) {
					if (prev) {
						out.print("-");
					}
					out.print("ring");
					prev = true;
				}
				
				if (prev) {
					out.println(" in move " + i);
					found = true;
					break loop;
				}
			}
			
			
			if (!found) { 
				out.println("none");
			}
				
			
			out.flush();
		}
	}
	
	
	HashSet<Integer>[] g;
	int[] sz;
	boolean[] ob;
	int free;
	
	int getNode() {
		g[free] = new HashSet<>();
		return free++;
	}
	
	int[] u2;
	
	int getSize(int i) {
		u2[i] = cnt;
		int ans = sz[i];
		for (int j : g[i]) {
			if (u2[j] != cnt) {
				ans += getSize(j);
			}
		}
		return ans;
	}
	
	
	int s;
	int[][] T;
	int[][] u;
	int cnt = 1;
	
	int corners;
	boolean[] edges = new boolean[6];
	
	int[] dx = {1, 1, 0, -1, -1, 0};
	int[] dy = {0, 1, 1, 0, -1, -1};
	
	boolean isValid(int x, int y) {
		if (x < 1 || 2 * s - 1 < x) return false;
		if (y < 1 || 2 * s - 1 < y) return false;
		if (Math.abs(x - y) >= s) return false;
		return true;
	}
	
	boolean isEdge(int x, int y) {
		return x == 1 || x == 2 * s - 1 || y == 1 || y == 2 * s - 1 || Math.abs(x - y) == s - 1;
	}
	
	void dfs(int x, int y) {
		if (x < 1 || 2 * s - 1 < x) return;
		if (y < 1 || 2 * s - 1 < y) return;
		if (Math.abs(x - y) >= s) return;
		if (u[x][y] == cnt || T[x][y] >= 0) return;
		
		u[x][y] = cnt;
		boolean corner = 
				x == 1 && y == 1 ||
				x == 1 && y == s || 
				x == s && y == 2 * s - 1 || 
				x == 2 * s - 1 && y == 2 * s - 1 || 
				x == 2 * s - 1 && y == s || 
				x == s && y == 1;
		
		if (!corner) {
			int edge = -1;
			if (x == 1) edge = 0;
			if (x == 2 * s - 1) edge = 1;
			if (y == 1) edge = 2;
			if (y == 2 * s - 1) edge = 3;
			if (x - y == s - 1) edge = 4;
			if (y - x == s - 1) edge = 5;
			if (edge >= 0) {				
				edges[edge] = true;
			}
		} else {
			++corners;
		}
		
		
		for (int i = 0; i < dx.length; ++i) {
			dfs(x + dx[i], y + dy[i]);
		}
		
	}
	
}
