import java.util.*;
import java.math.*;
import java.io.*;

public class Main2 implements Runnable {

    public static void main(String[] args) {
        new Thread(new Main2()).start();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof;
    
    
    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new  BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    long nextLong() {
        return Long.parseLong(nextToken());
    }
    
    int P = 10007;
    
    void solve() throws IOException {
        int N = nextInt();
        for (int tn = 1; tn <= N; tn++) {
        	int n = nextInt();
        	int m = nextInt();
        	int r = nextInt();
        	boolean[][] G = new boolean[n][m];
        	
        	for (int i = 0; i < r; i++) {
        		int x = nextInt() - 1;
        		int y = nextInt() - 1;
        		G[x][y] = true;
        	}
        	
        	int[][] D = new int[n][m];
        	D[0][0] = 1;
        	for (int i = 0; i < n + m - 1; i++) {
        		for (int j = Math.max(0, i - n + 1); j <= Math.min(i, m - 1); j++) {
        			if (G[i - j][j]) continue;
        			int x = i - j;
        			int y = j;
        			if (x + 2 < n && y + 1 < m) {
        				D[x + 2][y + 1] = (D[x + 2][y + 1] + D[x][y]) % P;
        			}
        			if (x + 1 < n && y + 2 < m) {
        				D[x + 1][y + 2] = (D[x + 1][y + 2] + D[x][y]) % P;
        			}
        		}
        	}
        	
        	
        	out.println("Case #" + tn + ": " + D[n - 1][m - 1]);
        }
    }
    
}
