import java.util.*;
import java.math.*;
import java.io.*;

public class Main implements Runnable {

    public static void main(String[] args) {
        new Thread(new Main()).start();
    }

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;
    boolean eof;
    
    
    public void run() {
        try {
            Locale.setDefault(Locale.US);
            br = new  BufferedReader(new FileReader("input.txt"));
            out = new PrintWriter("output.txt");
            solve();
            out.close();
        } catch (Throwable e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    String nextToken() {
        while (st == null || !st.hasMoreElements()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return "0";
            }
        }
        return st.nextToken();
    }
    
    int nextInt() {
        return Integer.parseInt(nextToken());
    }
    
    long nextLong() {
    	return Long.parseLong(nextToken());
    }
    
  
    
    void solve() throws IOException {
        int N = nextInt();
        for (int tn = 1; tn <= N; tn++) {
        	int k = nextInt();
        	int[] a = new int[k];
        	
        	int[] b = new int[k];
        	for (int i = 0; i < k; i++) {
        		b[i] = i;
        	}
        	
        	int p = 0;
        	int s = k;
        	for (int i = 0; i < k; i++) {
        		p = (p + i) % s;
        		a[b[p]] = i;
        		for (int j = p + 1; j < s; j++) {
        			b[j - 1] = b[j];
        		}
        		s--;
        	}
        	
        	out.print("Case #" + tn + ": ");
        	int n = nextInt();
        	for (int i = 0; i < n; i++) {
        		out.print((a[nextInt() - 1] + 1) + " ");
        	}
        	out.println();
        }
    }
    
}
