import java.io.IOException;

/**
 * Copyright - Arghya Sur
 * Created by sur on 4/11/15.
 */
public class DjikstraLong {
    public static class Product {
        char character;
        int sign;

        Product(char character, int sign) {
            this.character = character;
            this.sign = sign;
        }
    }

    static Product totalProduct;
    static Product[] allProducts;
    static Product[] powers;
    static int repeatCount;

    static boolean ifound;
    static boolean jfound;
    static boolean kfound;

    static long indexi;
    static long indexj;

    public static void main(String[] args) throws IOException {

        java.io.BufferedReader r = new java.io.BufferedReader
                (new java.io.InputStreamReader (System.in));

        String line;
        long c = 0;
        long t = Long.parseLong(r.readLine());

        while(t > 0) {
            totalProduct = new Product('1', 1);
            allProducts = null;
            powers = null;
            repeatCount = -1;

            ifound = false;
            jfound = false;
            kfound = false;

            indexi = -1;
            indexj = -1;

            boolean ans = false;

            line = r.readLine();
            String[] components = line.split(" ");
            //int l = Integer.parseInt(components[0]);
            Long x = Long.parseLong(components[1]);

            line = r.readLine();

            //Product p = new Product('1', 1);
            getProducts(line);
            findPowers();

            int count = ifound? 0: 1;

            while((!ifound || !jfound) && count <= repeatCount && count < x) {
                if(!ifound) {
                    indexi = findProduct(powers[count - 1], 0, new Product('i', 1));
                    if(indexi != -1) {
                        ifound = true;
                        if(indexi == line.length() - 1) {
                            count++;
                            indexi = -1;
                        }
                    }
                }

                Product partial = (count == 0)? new Product('1', 1): powers[count - 1];

                if(ifound && !jfound) {
                    indexj = findProduct(partial, indexi + 1, new Product('k', 1));
                    indexi = -1;
                    if(indexj != -1) {
                        jfound = true;
                        if(indexj == line.length() - 1) {
                            count++;
                            indexj = -1;
                        }
                        break;
                    }
                }
                count++;
            }

            if(ifound && jfound) {
                int kcount = 1;
                Product partial = getProduct(indexj + 1, line);

                while(kcount <= repeatCount) {
                    if(partial.character == 'k' && partial.sign == 1) {
                        kfound = true;
                        break;
                    }
                    partial = evaluate(partial, totalProduct);
                    kcount++;
                }

                if(kfound && x >= (kcount + count) && (x - kcount - count) % repeatCount == 0) {
                    ans = true;
                }
            }

            System.out.println("Case #" + (c + 1) + ": " + (ans? "YES": "NO"));
            t--;
            c++;
        }
    }

    public static long findProduct(Product partial, long start, Product searched) {
        while (start >= allProducts.length) {
            start -= allProducts.length;
        }
        for(long i = start; i < allProducts.length; i++) {
            Product product =  allProducts[(int)i];
            Product p = evaluate(partial, product);
            if( p.character == searched.character && p.sign == searched.sign) {
                return i;
            }
        }

        return -1;
    }

    public static Product getProduct(long start, String pattern) {
        while (start >= pattern.length()) {
            start -= pattern.length();
        }
        Product p = new Product('1', 1);
        for(long i = start; i < pattern.length(); i++) {
            p = evaluate(p, new Product(pattern.charAt((int)i), 1));
        }

        return p;
    }

    public static void getProducts(String pattern) {
        Product p = new Product('1', 1);
        totalProduct = p;
        allProducts = new Product[pattern.length()];

        for(int i = 0; i < pattern.length(); i++) {
            Product nextChar =  new Product(pattern.charAt(i), 1);
            totalProduct = evaluate(totalProduct, nextChar);
            p = evaluate(p, nextChar);
            allProducts[i] = new Product(totalProduct.character, totalProduct.sign);
            if(!ifound) {
                if( p.character == 'i' && p.sign == 1) {
                    ifound = true;
                    indexi = i;
                    p = new Product('1', 1);
                }
            } else if(!jfound) {
                if( p.character == 'j' && p.sign == 1) {
                    jfound = true;
                    indexj = i;
                    p = new Product('1', 1);
                }
            }
        }
    }

    public static void findPowers() {
        repeatCount = 1;
        powers = new Product[]{totalProduct, null, null, null};
        while(powers[repeatCount - 1].character != '1' || powers[repeatCount - 1].sign != 1) {
            powers[repeatCount] = evaluate(powers[repeatCount - 1], totalProduct);
            repeatCount++;
        }
    }

    public static Product evaluate(Product a, Product b) {
        int sign = a.sign * b.sign;
        switch (a.character) {
            case 'i':
                switch (b.character) {
                    case 'i': return new Product('1', -sign);
                    case 'j': return new Product('k', sign);
                    case 'k': return new Product('j', -sign);
                    case '1': return new Product('i', sign);
                }

            case 'j':
                switch (b.character) {
                    case 'i': return new Product('k', -sign);
                    case 'j': return new Product('1', -sign);
                    case 'k': return new Product('i', sign);
                    case '1': return new Product('j', sign);
                }

            case 'k':
                switch (b.character) {
                    case 'i': return new Product('j', sign);
                    case 'j': return new Product('i', -sign);
                    case 'k': return new Product('1', -sign);
                    case '1': return new Product('i', sign);
                }

            case '1':
                switch (b.character) {
                    case 'i': return new Product('i', sign);
                    case 'j': return new Product('j', sign);
                    case 'k': return new Product('k', sign);
                    case '1': return new Product('1', sign);
                }
        }
        return null;
    }

}
