import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class ProblemB {
    static String in = "/home/arihayes/cj14r2/b.in";
    static String out = "/home/arihayes/cj14r2/b.out";

    public static void main(String[] args) throws FileNotFoundException, IOException {
        Scanner scan = new Scanner(new File(in));
        BufferedWriter write = new BufferedWriter(new FileWriter(out));
        int numlines = scan.nextInt();
        for(int x = 1; x <= numlines; x++) {
            int count = scan.nextInt();
            int[] nums = new int[count];
            int[] firstSteps = new int[count];
            int[] lastSteps = new int[count];
            for(int y = 0; y < count; y++) {
                nums[y] = scan.nextInt();
            }
            
            for(int y = 0; y < count; y++) {
                firstSteps[y] = stepsNeeded(nums, 0, y-1);
                lastSteps[y] = stepsNeeded(nums, y+1, count-1);
            }
            
            int best = count * count * count;
            for(int y = 0; y < count; y++) {
                int temp = firstSteps[y] + lastSteps[y];
                if(temp < best) {
                    best = temp;
                    //write.write("Split at " + y + "\n");
                }
            }
            
            write.write("Case #" + x + ": " + best);
            write.write("\n");
        }

        scan.close();
        write.close();
    }

    private static int stepsNeeded(int[] nums, int lower, int upper) {
        if(upper <= lower) {
            return 0;
        }
        boolean[] array = new boolean[upper+1];
        for(int x = lower; x <= upper; x++) {
            array[x] = false;
        }
        
        int done = 0;
        int total = 0;
        while(done < (upper - lower + 1)) {
            int min = -1;
            int minseen = -99999999;
            int seen = 0;
            for(int x = lower; x <= upper; x++) {
                if(!array[x]) {
                    if(lower > 0) {
                        if(min == -1 || nums[x] < nums[min]) {
                            minseen = seen;
                            min = x;
                        }
                    }
                    else {
                        if(min == -1 || nums[x] > nums[min]) {
                            minseen = seen;
                            min = x;
                        }
                    }
                    
                    seen++;
                }
            }
            
            array[min] = true;
            total += minseen;
            done++;
        }
        return total;
    }
}