import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Arrays;
import java.util.Scanner;


public class Main {

	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws FileNotFoundException {
//		System.out.println(solve(new int[]{2, 3, 1}));
		Scanner in = new Scanner(new BufferedReader(new FileReader(new File(args[0]))));
	    int t = in.nextInt();
	    for (int i = 1; i <= t; ++i) {
	    	int n = in.nextInt();
	    	int[] input = new int[n];
	    	for(int j=0;j<n;j++){
	    		input[j] = in.nextInt();
	    	}
	    	String s = String.format("Case #%d: %s", i, solve(input));
	    	System.out.println(s.trim());
	    }
		
		in.close();
	}
	
	private static String solve(int[] input){
		Pair[] pairs = new Pair[input.length];
		
		char c = 'A';
		
		for(int i=0;i<input.length;i++){
			pairs[i] = new Pair(input[i], c + i);
		}
		
		StringBuilder sb = new StringBuilder();
		String res = "";
		do{
			Arrays.sort(pairs);
			res = solveA(pairs);
			sb.append(res);
			
			if(!"".equals(res)){
				sb.append(" ");
			}
		}while(!"".equals(res));
		
		
		return sb.toString();
	}
	
	
	private static String solveA(Pair[] pairs){
		if(pairs[0].index == 0){
			return "";
		}
		
		StringBuilder sb = new StringBuilder();
		
		if (pairs[0].index == pairs[1].index) {
			if (pairs.length > 2 && (pairs[1].index == pairs[2].index)
					&& pairs[2].index == 1) {
				sb.append((char) pairs[0].value);
				pairs[0].index--;
			} else {
				sb.append((char) pairs[0].value).append((char) pairs[1].value);
				pairs[0].index--;
				pairs[1].index--;
			}
		}else{
			sb.append((char)pairs[0].value).append((char)pairs[0].value);
			pairs[0].index -= 2;			
		}

		return sb.toString();
	}

}

class Pair implements Comparable<Pair> {
    public int index;
    public int value;

    public Pair(int index, int value) {
        this.index = index;
        this.value = value;
    }

    @Override
    public int compareTo(Pair other) {
        return -1 * Integer.valueOf(this.index).compareTo(other.index);
    }
    
    public String toString(){
    	return index +" "+(char) value;
    }
}
