import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Problem2A1 {

	public static void main(String[] args) throws FileNotFoundException{
		Scanner in = new Scanner(new BufferedReader(new FileReader(args[0])));
		int t = in.nextInt();

		for (int i = 1; i <= t; ++i) {
			int r = in.nextInt();
			int c = in.nextInt();
			Map<Character, int[]> map = new HashMap<>();
			char[][] g = new char[r][c];
			for(int j=0;j<r;j++){
					String s = in.next();
					char[] cs = s.toCharArray();
					for(int k=0;k<c;k++){
					g[j][k] = cs[k];
					if(g[j][k] != '?'){
						map.put(g[j][k], new int[]{j, k});
					}
					}
			}
			
			System.out.println(String.format("Case #%d:\n%s", i, solve(r, c, g, map)));

		}
		in.close();

	}

	private static String solve(int r, int c, char[][] g, Map<Character, int[]> map) {
		for(Map.Entry<Character, int[]> e : map.entrySet()){
			char ch = e.getKey();
			int[] loc = e.getValue();
			for(int j=loc[1]-1;j>=0;j--){
				if(g[loc[0]][j] == '?'){
					g[loc[0]][j] = ch;
				}else{
					break;
				}				
			}
			for(int j=loc[1]+1;j<c;j++){
				if(g[loc[0]][j] == '?'){
					g[loc[0]][j] = ch;
				}else{
					break;
				}
			}
		}
		
		for(int i=0;i<r;i++){
			for(int j=0;j<c;j++){
				if(g[i][j] == '?'){
					// The whole is '?'
					char ch = '?';
					int aa = -1;
					// Try going down until you find a char
					for(int a=i+1;a<r;a++){
						if(g[a][j] != '?'){
							ch = g[a][j];
							aa = a;
							break;
						}
					}
					if (aa != -1) {
						for (int a = aa - 1; a >= i; a--) {
							g[a][j] = ch;
						}
					} else {
						// Try going up until you find a char
						for(int a=i-1;a>=0;a--){
							if(g[a][j] != '?'){
								ch = g[a][j];
								aa = a;
								break;
							}
						}
						if(aa == -1){
							throw new RuntimeException();
						}
						for(int a = aa+1;a<=i;a++){
							g[a][j] = ch;
						}
					}
					
				}
			}
		}
		
		StringBuilder sb = new StringBuilder();
		boolean firstLine = true;
		for(int i=0;i<r;i++){
			if(!firstLine){
				sb.append("\n");
			}
			firstLine = false;
			for(int j=0;j<c;j++){
				sb.append(g[i][j]);
			}
		}
		return sb.toString();
	}

}
