import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;


public class Main {
	
	private static final String INSOMNIA = "INSOMNIA";

	public static void main(String[] args) throws FileNotFoundException {
		
		Scanner in = new Scanner(new BufferedReader(new FileReader(new File(args[0]))));
	    int t = in.nextInt();
	    for (int i = 1; i <= t; ++i) {
	    	int n = in.nextInt();
	    	String s = String.format("Case #%s: %s", String.valueOf(i), countSheep(n));
	    	System.out.println(s);
	    }
		
		in.close();
	}
	
	
	private static String countSheep(int n){
		if(n == 0){
			return INSOMNIA;
		}
		Set<Integer> unSeenDigits = new HashSet<Integer>(Arrays.asList(0,1,2,3,4,5,6,7,8,9));
		
		for(int i = 1;i<=Integer.MAX_VALUE;i++){
			int lastSeenNumber = i * n;
			Set<Integer> nowISeeThese = getAllDigits(lastSeenNumber);
			unSeenDigits.removeAll(nowISeeThese);
			if(unSeenDigits.size() == 0){
				return String.valueOf(lastSeenNumber);
			}
		}
		return INSOMNIA;		
	}
	
	private static Set<Integer> getAllDigits(int n){
		Set<Integer> digits = new HashSet<Integer>();
		while(n > 0){
			int k = (int) (n % 10);
			n = n / 10;
			digits.add((int) k);
			if(digits.size() >= 10){
				break;
			}
		}
		return digits;
	}
	
	

}
