import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Scanner;

public class Problem2 {
	public static void main(String[] args) throws FileNotFoundException {
		
		Scanner in = new Scanner(new BufferedReader(new FileReader(new File(args[0]))));
	    int t = in.nextInt();
	    for (int i = 1; i <= t; ++i) {
	    	String s = in.next();
	    	String result = String.format("Case #%d: %d", i, fixMe(s.toCharArray()));
	    	System.out.println(result);
	    }
		
		in.close();

	}
	
	private static int fixMe(char[] charArray){
		char[] simplifiedCharArray = mergeConsecutiveChars(charArray).toCharArray();
		
		if(simplifiedCharArray.length == 0){
			return 0;
		}
		
		if(simplifiedCharArray.length == 1){
			if(simplifiedCharArray[0] == '-'){
				return 1;
			}else{
				return 0;
			}
		}
		
		if(simplifiedCharArray.length == 2){
			return getNoOfMovesNeeded(simplifiedCharArray[0], simplifiedCharArray[1]);
		}
		
		int totalMoves = 0;
		boolean firstIteration = true;		
		
		for(int i=2;i<simplifiedCharArray.length;){
			if(firstIteration){
				totalMoves += getNoOfMovesNeeded(simplifiedCharArray[0], simplifiedCharArray[1]);
				firstIteration = false;
			}else{
				totalMoves += getNoOfMovesNeeded('+', simplifiedCharArray[i]);
				i++;
			}
		}
		
		return totalMoves;
	}

	
	private static String mergeConsecutiveChars(char[] charArray){
		
		int length = charArray.length;
		
		if(length == 0){
			return "";
		}
		
		if(length == 1){
			return new String(charArray);
		}
		
		StringBuilder sb = new StringBuilder();
		for(int i = 0;i < length -1;i++){
			char c1 = charArray[i];
			char c2 = charArray[i + 1];
			if(c1 != c2){
				sb.append(c1);
			}
			if(i == length - 2){
				sb.append(c2);
			}
		}
		return sb.toString();
		
	}
	
	private static int getNoOfMovesNeeded(char c1, char c2){
		if(c1 == '+' && c2 == '+'){
			return 0;
		}else if(c1 == '+' && c2 == '-'){
			return 2;
		}else if(c1 == '-' && c2 == '+'){
			return 1;
		}else{
			// '--'
			return 1;
		}
	}

}
