package qual;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Scanner;
import java.util.StringTokenizer;

class Directory implements Comparable<Directory> 
{
     String dir;

	public Directory(String dir) 
	{
		super();
		this.dir = dir;
	}

	//bigger paths first
	public int compareTo(Directory o) {
		StringTokenizer st1 =new StringTokenizer(dir,"/");
		StringTokenizer st2 =new StringTokenizer(o.dir,"/");
		
		return st2.countTokens() - st1.countTokens();
		
	}
	
	
     
}
public class UnixDirectories {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		/*
		 * The first line of the input gives the number of test cases, T. T test cases follow. Each case begins with a line containing two integers N and M, separated by a space.

The next N lines each give the path of one directory that already exists on your computer. This list will include every directory already on your computer other than the root directory. (The root directory is on every computer, so there is no need to list it explicitly.)

The next M lines each give the path of one directory that you want to create.
		 */

		
        Scanner in = new Scanner(System.in);
        
		int T = in.nextInt();
		
		
	    for(int t=0;t<T;t++)
	    {
	    	int noOfDirAlreadyExists = in.nextInt();
	    	int noOfdirToCreate = in.nextInt();
	    	
	    	//map of dir vs. no. of mkdirs
	        HashMap<String, Integer> map = new HashMap<String, Integer>();
	        
	        for(int i=0;i<noOfDirAlreadyExists;i++)
	        {
	        	String s = in.next();
	        	map.put(s, 0);
	        }
	        
	        ArrayList<Directory> directoriesToCreate = new ArrayList<Directory>();
	        
	        for(int j=0;j<noOfdirToCreate;j++)
	        {
	        	String u = in.next();
	        	
	        	Directory d = new Directory(u);
	        	
	            directoriesToCreate.add(d);   	
	        }
	        
	        Collections.sort(directoriesToCreate);
	        
	        int totalMkDirs=0;
	        
	        for(Directory d:directoriesToCreate)
	        {
	        	int mkDirs=0;
	        	
	        	
	        	if(!map.containsKey(d))
	        	{
	        		//does not conatin d
	        		StringTokenizer st = new StringTokenizer(d.dir, "/");
	        		
	        		String dirPath = "";
	        	
	        		String originalDir = d.dir;
	        		
	        		int numTokens=0;
	        		
	        		
	        		int m = 0;
	        		while(st.hasMoreTokens())
	        		{
	        			//path with the first token
	        			dirPath+="/" + st.nextToken() ;
	        			
	        			if(map.containsKey(dirPath))
	        			{
	        				m=map.get(dirPath);
	        				numTokens++;
	        				continue;	        	
	        		    }
	        		    else
	        			{
	        		    	int x = new StringTokenizer(dirPath, "/").countTokens() - numTokens;
	        		    	totalMkDirs+=x;
	        		    	map.put(dirPath, x);
	        		    	
	        		    	while(st.hasMoreTokens())
	        		    	{
	        		    		dirPath+="/" + st.nextToken();
	        		    		x++;
	        		    		map.put(dirPath, m + x);
	        		    		totalMkDirs++;
	        		    	}
	        			}
	        		}
	        	}
	        }
	        
	        System.out.println("Case #" + (t+1) + ":" + " " + totalMkDirs);
	    }
	}

}
