package qual;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.Scanner;

class CoasterQueue 
{
	public ArrayList<Long> q;

	public ArrayList<Long> newQ;
	
	public long revenue = 0;
	
	public void calculateRevenue(long capacity)
	{
		ArrayList<Long> nq = new ArrayList<Long>(q);
		
		long temp=0;
		for(long i:q)
		{
			if(temp+i<=capacity)
			{
				temp=temp+i;
				nq.remove(0);
				nq.add(i);
			}
			else
				break;
		}
		
		revenue = temp;
		newQ = nq;
	}
	
	@Override
	public int hashCode() {
		final int PRIME = 31;
		int result = 1;
		result = PRIME * result + ((q == null) ? 0 : q.hashCode());
		return result;
	}


	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		final CoasterQueue other = (CoasterQueue) obj;
		
		for(int i=0;i<q.size();i++)
		{
			if(q.get(i)!=other.q.get(i))
				return false;
		}
		
		return true;
		
	}

	public CoasterQueue() {
		super();
		q = new ArrayList<Long>();
	}
}

public class ThemePark {

	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		//The first line of the input gives the number of test cases, T. T test cases follow, with each 
		//test case consisting of two lines. The first line contains three space-separated integers: R, k and N. 
		//The second line contains N space-separated integers gi, each of which is the size of a group 
		//that wants to ride. g0 is the size of the first group, g1 is the size of the second group, etc.
		Scanner in = new Scanner(System.in);
        
		int T = in.nextInt();
		
		
	    for(int t=0;t<T;t++)
	    {
	    	long repeats = in.nextLong();
	    	long capacity = in.nextLong();
	    	int noOfGroups = in.nextInt();
	    	
	    	
	    	CoasterQueue cq = new CoasterQueue();
	    	
	    	for(int i=0;i<noOfGroups;i++)
	    	{
	    		long g = in.nextLong();
	    		cq.q.add(g);
	    	}
	    	
	    	
	    	LinkedHashMap<CoasterQueue, Long> mapOfQueues = new LinkedHashMap<CoasterQueue, Long>();
	    	
	    	long totalRev = 0;
	    	
	    	
	    	while(repeats>0)
	    	{
	    		cq.calculateRevenue(capacity);
	    		
	    		if(mapOfQueues.containsKey(cq))
	    			break;
	    		
	    		mapOfQueues.put(cq, cq.revenue);
	    		totalRev+=cq.revenue;
	    		
	    		
	    		CoasterQueue newQueue = new CoasterQueue();
	    		newQueue.q=cq.newQ;
	    		
	    		cq=newQueue;
	    		repeats--;
	    	};
	    	
	    	if(repeats>0)
	    	{
	    		Iterator<CoasterQueue> iter = mapOfQueues.keySet().iterator();
	    		
	    		Iterator<CoasterQueue> iterCycleStart = mapOfQueues.keySet().iterator();
	    		
	    		while(iter.hasNext())
	    		{
	    			CoasterQueue q = iter.next();
	    			iterCycleStart.next();
	    			
	    			if(q.equals(cq))
	    			{
	    				break;
	    			}
	    		}
	    		
	    		long cycleLength = 1;
	    		long cycleRev = cq.revenue;
	    		
	    		while(iter.hasNext())
	    		{
	    			CoasterQueue q = iter.next();
	    			cycleRev+=q.revenue;
	    			cycleLength++;
	    		}
	    		
	    		long noOfCycles = repeats/cycleLength;
	    		
	    		totalRev+=noOfCycles*cycleRev;
	    		
	    		repeats = repeats%cycleLength;
	    		
    			while(repeats>0 && iterCycleStart.hasNext())
    			{
    				totalRev+=cq.revenue;
    				cq=iterCycleStart.next();
    				repeats--;
    			}
    		
	    	}
	    	
	    	System.out.println("Case #" + (t+1) + ":" + " " + totalRev);
	    	
	    	
	    }
	}

}
