package qual;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class SavingUniverse
{

   public static void main(String[] args)
   {
      BufferedReader in = null;
      BufferedWriter out = null;
      try
      {
         in = new BufferedReader(new FileReader("D:/GCJInput/A-small-attempt2.in"));
         //in = new BufferedReader(new FileReader("D:/GCJInput/foo.in"));
         
         out = new BufferedWriter(new FileWriter("D:/GCJOutput/A-small-attempt2.out"));
         
         String l = in.readLine();
         
         int noOfTestCases = Integer.parseInt(l);
         
         for(int i=0;i<noOfTestCases;i++)
         {
            l = in.readLine();
            int noOfSearchEngines = Integer.parseInt(l);
            ArrayList<String> searchEngines = new ArrayList<String>();
            ArrayList<String> queries = new ArrayList<String>();
            
            while(noOfSearchEngines-->0)
            {
               l = in.readLine();
               searchEngines.add(l);
            }
            
            l = in.readLine();
            
            int noOfQueries = Integer.parseInt(l);
            
            
            while(noOfQueries-->0)
            {
               l = in.readLine();
               queries.add(l);
            }
            
            int noOfSwitches = calculateNumberOfSwitches(searchEngines, queries);
            
            System.out.println("\\n\\n\\nTest# " + i);
            //System.out.println(noOfSwitches);
            //Write the result in file
            String result = "Case #" + (i+1) + ": " + noOfSwitches;
            out.write(result, 0, result.length());
            out.newLine();
            
          
         }
         
      }
      catch (NumberFormatException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
      catch (FileNotFoundException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
      catch (IOException e)
      {
         // TODO Auto-generated catch block
         e.printStackTrace();
      }
      finally
      {
         
         try
         {
            in.close();
            out.close();
         }
         catch (IOException e)
         {
            // TODO Auto-generated catch block
            e.printStackTrace();
         }
      }

   }

   private static int calculateNumberOfSwitches(ArrayList<String> searchEngines, ArrayList<String> queries)
   {
      if(queries.size()==0 || queries.size()==1)
         return 0;
               
      //int minOccurance = Integer.MAX_VALUE;
      int maxIndex = -1;
      int currentIndex = 0;
      int noOfSwitches = 0;
      
      ArrayList<String> listOfSearchEngines = new ArrayList<String>();
      
      for(String t : searchEngines)
      {
         if(!t.equals(queries.get(0)))//must not include the first query string search engine.
            listOfSearchEngines.add(t);
      }
      
      String selectedSearchEngine = "";
      
      while(currentIndex<queries.size())
      {
         for(String s:listOfSearchEngines)
         {
            int firstIndex = getFirstOccuranceIndex(s, queries, currentIndex);
            if(firstIndex==-1)
            {
               System.out.println(s);
               return noOfSwitches;
            }
            
            if(firstIndex>maxIndex)
            {
               maxIndex = getFirstOccuranceIndex(s, queries, currentIndex);
               selectedSearchEngine = s;
               
            }
         }

         //prepare the new list
         listOfSearchEngines.clear();
         
         for(String k:searchEngines)
         {
            if(!selectedSearchEngine.equals(k))
               listOfSearchEngines.add(k);
         }
         
         System.out.println(selectedSearchEngine);
         currentIndex = maxIndex;
         noOfSwitches++;
      }
      
      
      return noOfSwitches;
   }
   
   private static int getNumberOfOccurance(String searcEngine, ArrayList<String> queries, int startIndex)
   {
       int count = 0;
       for(int i=startIndex;i<queries.size();i++)
       {
          if(queries.get(i).equals(searcEngine))
             count++;
       }
       
       return count;
   }
   
   private static int getFirstOccuranceIndex(String searcEngine, ArrayList<String> queries, int startIndex)
   {
      for(int i=startIndex;i<queries.size();i++)
      {
         if(searcEngine.equals(queries.get(i)))
                  return i;
      }
      
      return -1;
   }
   
    
   

}
