import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

/**
 * Created by arisiru on 08.04.17.
 */
public class A {
    final class Result {
        public final int swapIndex;
        public final char[] state;
        public Result(int swapIndex, char[] state) {
            this.swapIndex = swapIndex;
            this.state = state;
        }
        public String toString() {
            return "swap at: " + swapIndex + " state: " + new String(state);
        }
    }

    public static void main (String[] args) {
        A a = new A();
        a.solve();
    }

    public void solve() {
        Scanner in = new Scanner(System.in);
        int ts  = Integer.parseInt(in.nextLine());
        for (int t = 1; t <= ts; t += 1) {
            String[] p = in.nextLine().split(" ");
            char[] chars = p[0].toCharArray();
            int k = Integer.parseInt(p[1]);
            printAnswer(t, chars, k);
        }
    }

    public void printAnswer(int t, char[] chars, int k) {
        int moves = 0;
        Result r = new Result(-1, chars);
        HashSet<String> checked = new HashSet<String>();

        while (checkRequiredMovesForOldFlipper(r.state) != 0) {
            checked.add(new String(r.state));
            r = getNextState(r.swapIndex, r.state, k);

            if (checked.contains(new String(r.state))) {
                moves = -1;
                break;
            }
            moves += 1;
        }

        if (moves < 0) {
            System.out.println("Case #" + t + ": IMPOSSIBLE");
        } else {
            System.out.println("Case #" + t + ": " + moves);
        }
    }

    public Result getNextState(int prevSwapIndex, char[] chars, int k) {
        int n = chars.length;
        int minMoves = n;
        int swapIndex = 0;
        char[] newOptimumState = Arrays.copyOf(chars, n);

        for (int i = 0, last = n - k; i <= last; i += 1) {
            if (i == prevSwapIndex) continue;

            char[] localState = Arrays.copyOf(chars, n);
            for (int j = i, jj = i + k; j < jj; j += 1) {
                localState[j] = chars[j] == '-' ? '+' : '-';
            }
            int needMoves = checkRequiredMovesForOldFlipper(localState);
            if (needMoves < minMoves) {
                newOptimumState = localState;
                minMoves = needMoves;
                swapIndex = i;
            }
        }

        return new Result(swapIndex, newOptimumState);
    }

    public int checkRequiredMovesForOldFlipper(char[] chars) {
        int moves = 0;
        int n = chars.length;
        if (chars[n-1] == '-') moves += 1;

        for (int i = 1; i < n; i += 1) {
            if (chars[i - 1] != chars[i]) moves += 1;
        }

        return moves;
    }
}
