/**
 * 
 */
package qualification_round;

import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;

/**
 * @author Armin
 *
 */
public class CandySplitting {

	
	public static int min(int a, int b){
		if(a<b) return a;
		return b;
	}
	
	public static boolean isSolvable(int[] values){
		int[] b = new int[21];
		
		for(int i = 0; i < values.length; i++){
			int n = 0;
			int v = values[i];
			
			while(v > 0){
				if(v %2 == 1) b[n] +=1;
				n++;
				v/=2;
			}
		}
		
		for(int i = 0; i < b.length;i++){
			if(b[i]%2== 1) return false;
		}
		
		return true;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		File in, out;
		Scanner sc;
		PrintWriter pr;
		
		in = new File("material.qualification/CandySplitting.in");
		out = new File("material.qualification/CandySplitting.out");
		
		try {
			sc = new Scanner(new FileReader(in));
			pr = new PrintWriter(new FileWriter(out));


			int T, N;
			
			T = sc.nextInt();
			for(int cas=1;cas<=T;cas++){
				
				pr.print("Case #" + cas + ": ");
				N = sc.nextInt();
				
				int[] can = new int[N];
				
				int min = 1000001;
				int sum = 0;
				
				for(int i = 0; i < N; i++){
					int s = sc.nextInt();
					sum+=s;
					min = min(s, min);
					can[i] = s;					
				}
				
				if(!isSolvable(can)){
					pr.println("NO");
				}else{
					int erg = sum - min;
					pr.println("" + erg);
				}
				
				pr.flush();
				
				System.out.println("Case: " + cas);
				
				
				
				}
				
			
			
		
		}catch(Exception e){
			e.printStackTrace();
			
		}
		
		
	}

}
