import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;


/**
 * @author armin
 *
 */
public class FairWarning {

	/**
	 * Main Method, solves the problem
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		
		File file, output;
		BufferedReader buffer;
		BufferedWriter writer;
		
		try{
			
			file = new File("B-large.in");
			output = new File("Solution.txt");
			
			buffer = new BufferedReader(new FileReader(file));
			writer = new BufferedWriter(new FileWriter(output));
			
			//Read the number of testcases
			int num_testcases = Integer.parseInt(buffer.readLine());
			String s;
			StringTokenizer tokenizer;
			
			//For each testcase
			for(int i = 1; i <= num_testcases; i++){
				
				s = buffer.readLine();
				tokenizer = new StringTokenizer(s);
				
				//Store the numbers
				//First is the number of numbers
				ArrayList<BigInteger> nums = new ArrayList<BigInteger>();  
				//All differences are being stored in here
				ArrayList<BigInteger> difs = new ArrayList<BigInteger>();
				
				BigInteger dif;	//Difference between two consecutive BigInts
				BigInteger gcd; //Greatest common divisor of all diferences
				BigInteger resid; //Residual in equivalence class
				
				int anz = Integer.parseInt(tokenizer.nextToken());

				//Convert to BigInt
				for(int j = 0; j < anz; j++){
					nums.add(new BigInteger(tokenizer.nextToken()));
				}
				
				//Sort big numbers in ascending order
				Collections.sort(nums);
			
				//All numbers are in the same equivalence class
				//that is why T is the minimum difference between two
				//equivalence classes (except from zero)	
				
				for(int j = 0; j < nums.size() - 1; j++){
					dif = nums.get(j + 1).subtract(nums.get(j));
					//If the current difference is different from zero
					//add to differences list
					if(dif.compareTo(BigInteger.ZERO) != 0 ){
						difs.add(dif);
					}
				}
				
				
				//Calculate gcd off all differences
				gcd = difs.get(0);
				
				for(int j = 1; j < difs.size(); j++){
					gcd = gcd.gcd(difs.get(j));
				}				
				
				//GCD is our T
				//Now calculate the seconds left
				
				BigInteger temp = nums.get(0).mod(gcd);
				resid = gcd.subtract(temp);
				resid = resid.mod(gcd);
				
				//Print to file
				writer.write("Case #" + i +  ": " + resid.toString());
				//In this case no new line is needed
				if(i != num_testcases) writer.newLine();
				writer.flush();
				
			}	
		}catch(IOException ioe){}	
	}
}