import java.util.Scanner;
import java.io.*;
import java.util.Comparator;
import java.math.BigInteger;
import java.util.Arrays;

// Presave the group values then just iterate through it
class ThemePark {
  public static void main(String[] args) {
    Scanner s = null;
    FileOutputStream out;
    PrintStream p;
    
    try {
      s = new Scanner(new BufferedReader(new FileReader("C:\\Users\\Armin\\Desktop\\test.txt")));
      out = new FileOutputStream("C:\\Users\\Armin\\Desktop\\out.txt");
      p = new PrintStream( out );
      
      int C = s.nextInt();
      
      // Go through the cases
      for (int i = 0; i < C; i++) {
        int R = s.nextInt();
        int k = s.nextInt();
        int N = s.nextInt();
        
        // Make the nodes with the group values
        ListNode[] nodes = new ListNode[N];
        for (int j = 0; j < N; j++)       
          nodes[j] = new ListNode(j, s.nextInt());                        
        
        // Index and node for which we are calculating the sum
        int currIndex = 0;
        ListNode curr = nodes[currIndex];        
        
        // Total sum for the node
        double sum = 0;
        
        // Full circle loop, let's do this in O(n)
        for (int j = 0; j < 2 * N - 1; j++) {
          int index = j % N;
          int value = nodes[index].num;
          
          // The current sum is the sum plus the value
          sum += value;          
          curr.sum = sum;
                    
          // Oops we went too far!!
          if (sum > k || (index == curr.index && j != index)) {
            
            // Retract the value since we went too far
            curr.sum -= value;
            
            // Let's do the next node
            curr.next = nodes[index % N];
            sum -= (value + curr.num);                        
            currIndex++;                          
            if (currIndex >= N)
              break;            
            curr = nodes[currIndex];
            
            // Step back!
            j--;
          }
        }
                 
        // Print out the results
        double money = 0;
        curr = nodes[0];
        for (int j = 0; j < R; j++) {
          money += curr.sum;
          
          // Case where there is only one group
          if (curr.next != null)
            curr = curr.next;
        }
        
        // Just to make sure the .0 of a double won't be rejected
        p.println("Case #" + (i + 1) + ": " + (long)money);
      }
      
      p.close();         
    } catch (Exception e) {
      e.printStackTrace();
    }
  }
  
  private static class ListNode {
    public int index;
    public int num;
    public double sum;
    public ListNode next = null;
    
    ListNode(int index, int num) {
      this.index = index;
      this.num = num;      
    }
  }
}