
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Scanner;

public class Solution {

	static char HAPPY = '+';
	static char SAD = '-';

	public static void main(String args[]) throws IOException {
		File file = new File("B-large.in");
		FileOutputStream fOut = new FileOutputStream(new File("output"));
		Scanner sc = new Scanner(file);
		int T = sc.nextInt();
		for (int i = 1; i <= T; i++) {
			int ans = solution1(sc);
			System.out.println("Case #" + i + ": " + ans);
			String result = "Case #" + i + ": " + ans + "\n";
			fOut.write(result.getBytes());
		}
		fOut.close();
	}

	static int solution(Scanner sc) {
		String cakes = sc.next();
		StringBuilder sb = new StringBuilder(cakes);
		int ans = 0;
		while (true) {
			int index = sb.indexOf("" + SAD);
			if (index == 0) {
				ans++;
				break;
			}
			ans++;
			sb = new StringBuilder(sb.toString().substring(0, index + 1))
					.reverse();
			char temp = HAPPY;
			HAPPY = SAD;
			SAD = temp;
		}
		return ans;
	}

	static int solution1(Scanner sc) {
		String cakes = sc.next();
		return getManeuver(cakes.toCharArray(), HAPPY, SAD);
	}

	static int getManeuver(char[] cakes, char needSign, char oppositeSign) {
		int i;
		for (i = cakes.length - 1; i >= 0; i--) {
			if (needSign != cakes[i]) {
				break;
			}
		}
		int j;
		for (j = i; j >= 0; j--) {
			if (oppositeSign != cakes[j]) {
				break;
			}
		}
		if (j != -1) {
			char[] newCake = new char[j + 1];
			for (int k = 0; k <= j; k++) {
				newCake[k] = cakes[k];
			}
			return 1 + getManeuver(newCake, oppositeSign, needSign);
		} else {
			if (cakes[0] == needSign) {
				return 0;
			} else {
				return 1;
			}
		}
	}
}
