package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class CruiseControl {
	
	public static class Node {
		long K;
		int S;
		Node (long y, int z)	{
			K=y;
			S=z;
		}
		public int getSpeed()	{
			return S;
		}
		public long getDistance(long D)	{
			return D-K;
		}
	}
	
	public static double findSpeed (long D, int N, ArrayList<Node> Z)	{
		double prevtime=(double)Z.get(N-1).getDistance(D)/(double)Z.get(N-1).getSpeed();
		for (int i=N-2; i>=0; i--)	{
			prevtime=(prevtime > (double)Z.get(i).getDistance(D)/(double)Z.get(i).getSpeed())?prevtime:(double)Z.get(i).getDistance(D)/(double)Z.get(i).getSpeed();
		}
		double min=(double) D/prevtime;
		return min;
	}
	
	public static void main(String [] args) throws IOException	{
		long D; int N;
		File file1 = new File("C:/TestFiles/A-small-attempt1.in");
		File file2 = new File("C:/TestFiles/A-small-attempt1.out");
		if (file2.exists())	{
		     file2.delete();
		} 
		FileReader fileReader = new FileReader(file1);
		BufferedReader bufferedReader = new BufferedReader(fileReader);
		String line = bufferedReader.readLine();
		int T = Integer.parseInt(line);
		FileWriter fileWriter = new FileWriter(file2);
		BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);
		//System.out.println(T);
		
		for (int i=0; i<T; i++)	{
			line = bufferedReader.readLine();
			D=Long.parseLong(line.split(" ")[0]);
			N=Integer.parseInt(line.split(" ")[1]);
			//System.out.println(D+" "+N);
			ArrayList<Node> Z=new ArrayList<Node> ();
			for (int j=0; j<N; j++)	{
				line = bufferedReader.readLine();
				//System.out.println(line);
				long y=Long.parseLong(line.split(" ")[0]);
				int z=Integer.parseInt(line.split(" ")[1]);
				Node x=new Node(y, z);
				Z.add(x);
			}
			String result = String.format("%.6f", findSpeed(D, N, Z));
			bufferedWriter.write("Case #" + (i+1) + ": " + result + "\n");
		}
		
		bufferedWriter.close();
		fileWriter.close();
		bufferedReader.close();
		fileReader.close();
	}

}
