package com.google.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.PriorityQueue;

public class BathroomStalls {
	
	private static class Node implements Comparable<Node>	{
		int lo, hi;
		Node (int l, int h)	{
			lo=l;
			hi=h;
		}
		int getHi ()	{
			return hi;
		}
		int getLo()	{
			return lo;
		}
		int getMid()	{
			return (lo+hi)/2;
		}
		public int compareTo(Node o) {
			if ((this.getHi()-this.getLo())<=(o.getHi()-o.getLo()))	return 1;
			else return -1;
		}
	}
	
	private static String gapMaxMin (int N, int K)	{
		PriorityQueue<Node> q=new PriorityQueue<Node>();
		q.offer(new Node(-1, N));
		Node x = null;
		K--;
		int i=1;
		//int y=0;
		
		while (K>0)	{
			for (int j=0; j<i; j++)	{
				x=q.poll();
				//y++;
				//System.out.println(x.getLo()+" "+x.getHi()+" "+x.getMid()+" "+i);
				int l=x.getLo(), m=x.getMid(), h=x.getHi();
				int l1=((h-m)>(m-l))?m:l;
				int h1=((h-m)>(m-l))?h:m;
				int l2=((h-m)>(m-l))?l:m;
				int h2=((h-m)>(m-l))?m:h;
				if (K>0 && (h1-l1)>1) { q.offer(new Node(l1,h1)); K--; }
				if (K>0 && (h2-l2)>1) { q.offer(new Node(l2,h2)); K--; }
			}
			i*=2;
		}
		
		//System.out.println(q.size());

		while (!q.isEmpty())	{
			x=q.poll();
			//System.out.println(x.getLo()+" "+x.getHi()+" "+x.getMid()+" "+i);
		}
		int max = x.getHi()-x.getMid()-1;
		int min = x.getMid()-x.getLo()-1;
		q.clear();
		return (String.valueOf(max)+" "+String.valueOf(min));
	}
	
	public static void main (String [] args) throws IOException	{
		File file1 = new File("C:/TestFiles/C-small-1-attempt7.in");
		File file2 = new File("C:/TestFiles/C-small-1-attempt7.out");
		if (file2.exists())	{
		     file2.delete();
		} 
		FileReader fileReader = new FileReader(file1);
		BufferedReader bufferedReader = new BufferedReader(fileReader);
		String line = bufferedReader.readLine();
		int tcCount = Integer.parseInt(line);
		FileWriter fileWriter = new FileWriter(file2);
		BufferedWriter bufferedWriter = new BufferedWriter(fileWriter);
		
		for (int i=0; i<tcCount; i++)	{
			line = bufferedReader.readLine();
			int N=Integer.parseInt(line.split(" ")[0]);
			int K=Integer.parseInt(line.split(" ")[1]);
			String out=gapMaxMin(N,K);
			bufferedWriter.write("Case #" + (i+1) + ": " + out + "\n");
			//System.out.println(out);
		}
		
		bufferedWriter.close();
		fileWriter.close();
		bufferedReader.close();
		fileReader.close();
		//System.out.println(gapMaxMin(1000,1000));
	}

}
