package com.denodev.round_1b.problemA;

import com.google.common.base.Strings;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * @author Arnaud DENOYELLE
 */
public class ProblemA {

  public static final String INPUT_FILE = "inputA.txt";
  public static final String OUTPUT_FILE = "/home/adenoyelle/codejam/outputA.txt";

  private String[] strings;

  public ProblemA(String[] strings) {
    this.strings = strings;
  }

  public static void main(String[] args) throws Exception {

    String inputPath = ProblemA.class.getResource(INPUT_FILE).getPath();

    try (
            BufferedReader br = new BufferedReader(new FileReader(inputPath));
            BufferedWriter out = new BufferedWriter(new FileWriter(OUTPUT_FILE))) {

      int nbProblems = Integer.valueOf(br.readLine());
      for (int problem = 1; problem <= nbProblems; problem++) {
        int nbStrings = Integer.valueOf(br.readLine());

        CharOccAnalyze[] charOccs = new CharOccAnalyze[nbStrings];
        for(int i = 0; i<nbStrings; i++) {
          charOccs[i] = new CharOccAnalyze(br.readLine());
        }

        Integer result = 0;
        while(true) {
          CharOcc[] occs = new CharOcc[nbStrings];
          for(int i=0; i<nbStrings; i++) {
            occs[i] = charOccs[i].next();
          }

          if(allNull(occs)) {
            break;
          } else if(allNotNull(occs)) {
            Integer score = score(occs);
            if(score == null) {
              result = null;
              break;
            } else {
              result += score;
            }
          } else {
            result = null;
            break;
          }

        }

        out.write(buildResultLine(problem, result == null? "Fegla Won" : Integer.toString(result)));
        System.out.print(buildResultLine(problem, result == null ? "Fegla Won" : Integer.toString(result)));

      }

    }

  }

  public static Integer score(CharOcc[] occs) {

    int min = 1_000_000_000;
    int max = 0;

    char c = occs[0].getC();

    for (CharOcc occ : occs) {
      if(occ.getC() == c) {
        min = Math.min(min, occ.getNbOccs());
        max = Math.max(max, occ.getNbOccs());
      } else {
        return null;
      }
    }
    return max - min;
  }

  public static boolean allNull(CharOcc[] occs) {
    for (CharOcc occ : occs) {
      if(occ != null) {
        return false;
      }
    }
    return true;
  }

  public static boolean allNotNull(CharOcc[] occs) {
    for (CharOcc occ : occs) {
      if(occ == null) {
        return false;
      }
    }
    return true;
  }

  public static String buildResultLine(int i, String sol) {
    return "Case #" + i + ": " + sol + "\n";
  }
}
