package com.denodev.problem4;

import com.google.common.collect.Lists;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.util.*;

/**
 * @author Le 12 avril 2014.
 */
public class Problem4 {

  public static int scoreHonnete(List<BigDecimal> lineNao, List<BigDecimal> lineKen) {
    Collections.sort(lineNao);
    Collections.sort(lineKen);

    int result = 0;

    for(BigDecimal bd : lineNao) {
      BigDecimal bg = getFirstGreater(lineKen, bd);
      if(bg == null) {
        lineKen.remove(lineKen.get(0));
        result++;
      } else {
        lineKen.remove(bg);
      }
    }
    return result;
  }

  public static int scoreMalhonnete(LinkedList<BigDecimal> lineNao, LinkedList<BigDecimal> lineKen) {
    Collections.sort(lineNao);
    Collections.sort(lineKen);

    int result = 0;

    for(BigDecimal bd : lineNao) {
      BigDecimal ken = lineKen.getFirst();
      if(bd.compareTo(ken) > 0) {
        lineKen.remove(ken);
        result++;
      } else {
        lineKen.remove(lineKen.getLast());
      }
    }

    return result;
  }

  public static BigDecimal getFirstGreater(List<BigDecimal> input, BigDecimal value) {

    for(BigDecimal bg : input) {
      if(bg.compareTo(value) >= 0) {
        return bg;
      }
    }

    return null;
  }

  public static LinkedList<BigDecimal> convertWeight(String[] parts) {

    LinkedList<BigDecimal> result = Lists.newLinkedList();
    for(String s : parts) {
      result.add(new BigDecimal(s));
    }

    return result;
  }


  public static void main(String[] args) throws Exception {
    String inputFile = "/home/adenoyelle/IdeaProjects/google-code-jam/2014/src/test/java/input4.txt";
    String outputFile = "/home/adenoyelle/codejam/output4.txt";

    try (
            BufferedReader br = new BufferedReader(new FileReader(inputFile));
            BufferedWriter output = new BufferedWriter(new FileWriter(outputFile))
    )

    {
      int nbProblems = Integer.valueOf(br.readLine());

      for (int pb = 1; pb <= nbProblems; pb++) {

        //Number of weights
        br.readLine();

        LinkedList<BigDecimal> lineNao = convertWeight(br.readLine().split(" "));
        LinkedList<BigDecimal> lineKen = convertWeight(br.readLine().split(" "));

        LinkedList<BigDecimal> lineNao2 = new LinkedList<>(lineNao);
        LinkedList<BigDecimal> lineKen2 = new LinkedList<>(lineKen);

        int scoreHonnete = scoreHonnete(lineNao, lineKen);
        int scoreMalhonnete = scoreMalhonnete(lineNao2, lineKen2);

        output.write("Case #"+pb+": "+scoreMalhonnete+" "+scoreHonnete+"\n");

      }

    }
  }
}
