package com.denodev.tour1a.a;

import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.List;

/**
 * @author Arnaud DENOYELLE
 *
 *         Le 09 avr. 2016
 */
public class ProblemA {

  public static final String WORKSPACE = "/home/adenoyelle/gcj";
  public static final String OUTPUT = "output.txt";

  public static void main(String[] args) throws Exception {
    Path outputFilePath = Paths.get(WORKSPACE, OUTPUT);
    Files.deleteIfExists(outputFilePath);
    Files.createFile(outputFilePath);

    Path inputFilePath = Files.list(Paths.get(WORKSPACE))
        .filter(path -> path.toString().endsWith(".in"))
        .findFirst().get();

    List<String> lines = Files.readAllLines(inputFilePath);
    int nbPbs = Integer.valueOf(lines.get(0));

    for (int testCase = 1; testCase <= nbPbs; testCase++) {
      writeSol(outputFilePath, testCase, ""+go(lines.get(testCase)));
    }
  }

  public static void writeSol(Path outputFile, int testCase, String solution) throws Exception {
    Files.write(outputFile, String.format("Case #%d: %s\n", testCase, solution).getBytes(), StandardOpenOption.APPEND);
  }

  public static String go(String line) {
    char[] chars = line.toCharArray();
    String current = ""+chars[0];
    for(int i = 1; i< chars.length; i++) {
      if(chars[i] >= current.charAt(0))  {
        current = chars[i] + current;
      } else {
        current = current + chars[i];
      }
    }
    return current;
  }

}
