package com.denodev.a;

import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.List;
import java.util.stream.Collectors;

/**
 * @author Arnaud DENOYELLE
 *         Le 11 avr. 2015
 */
public class ProblemA {

  public static void main(String[] args) throws Exception {

    final List<String> lines = Files.lines(Paths.get("/home/adenoyelle/GCJ/input.txt")).collect(Collectors.toList());


    final Path path = Paths.get("/home/adenoyelle/GCJ/output.txt");
    Files.deleteIfExists(path);
    Files.createFile(path);
    for(int i = 1; i< lines.size(); i++) {
      final String line = String.format("Case #%d: %d\n", i, solve(lines.get(i)));
      System.out.println(line);
      Files.write(path, line.getBytes(), StandardOpenOption.APPEND);
    }
  }

  private static int solve(String line) {
    String[] parts = line.split(" ");
    int k = Integer.valueOf(parts[0]);
    char[] s = parts[1].toCharArray();

    int nbStanding = 0;
    int nbFriends = 0;
    for(int i = 0; i< k+1; i++) {
      int nbFriendsToAdd = 0;
      if(nbStanding < i) {
        nbFriendsToAdd += (i - nbStanding);
      }
      nbFriends += nbFriendsToAdd;
      final int i1 = s[i] - '0';
      nbStanding += i1 + nbFriendsToAdd;
    }
    return nbFriends;
  }


}
