package com.denodev.gcj.problem1;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;

/**
 * @author Arnaud DENOYELLE
 *
 *         Le 08 avr. 2017
 */
public class Main {

  public static final String INPUT_FILE_NAME = "A-small-attempt0.in";
  public static final String OUTPUT_FOLDER = "/Users/arnauddenoyelle/Documents/DENODEV/gcj2017";

  public static void main(String[] args) throws Exception {
    String outputFileName = INPUT_FILE_NAME.replaceAll("\\.in$", ".txt");
    Path outputFilePath = Paths.get(OUTPUT_FOLDER, outputFileName);
    Files.deleteIfExists(outputFilePath);
    Files.createFile(outputFilePath);

    BufferedReader br = new BufferedReader(new InputStreamReader(Main.class.getResourceAsStream(INPUT_FILE_NAME)));
    String line = br.readLine();
    int nbTests = Integer.valueOf(line);
    for (int i = 1; i <= nbTests; i++) {
      line = br.readLine();
      String[] parts = line.split(" ");
      Integer d = Integer.valueOf(parts[0]);
      Integer nbChevaux = Integer.valueOf(parts[1]);
      double maxTempsRestant = 0d;
      for(int cheval = 1; cheval <= nbChevaux; cheval ++) {
        String[] chevalInfos = br.readLine().split(" ");
        int positionInitiale = Integer.valueOf(chevalInfos[0]);
        double vitesse = Double.valueOf(chevalInfos[1]);
        double distanceRestante = d - positionInitiale;
        double tempsRestant = distanceRestante / vitesse;
        maxTempsRestant = Math.max(tempsRestant, maxTempsRestant);
      }

      double vitesse = d / maxTempsRestant;
      String sol = Double.toString(vitesse);
      Files.write(outputFilePath, String.format("Case #%d: %s\n", i, sol).getBytes(), StandardOpenOption.APPEND);
      System.out.println(sol);
    }

  }

}
