package com.denodev.b;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.*;
import java.util.stream.Collectors;

/**
 * @author Arnaud DENOYELLE
 *         Le 11 avr. 2015
 */
public class ProblemB {

  private static final Logger LOGGER = LoggerFactory.getLogger(ProblemB.class);

  public static void main(String[] args) throws Exception {
    final Path path = Paths.get("/home/adenoyelle/GCJ/output.txt");
    Files.deleteIfExists(path);
    Files.createFile(path);

    BufferedReader reader = new BufferedReader(new FileReader("/home/adenoyelle/GCJ/input.txt"));
    int n = Integer.valueOf(reader.readLine());
    LOGGER.info(String.format("Il y a %d cas de test", n));

    BufferedWriter writer = new BufferedWriter(new FileWriter("/home/adenoyelle/GCJ/output.txt"));

    for (int i = 1; i <= n; i++) {
      String nbDineurs = reader.readLine();
      LOGGER.info(String.format("Dineurs : %s", nbDineurs));
      List<Integer> list = Arrays.stream(reader.readLine().split(" "))
        .map(Integer::valueOf)
        .sorted(Comparator.<Integer>reverseOrder())
        .collect(Collectors.toList());
      final String line = String.format("Case #%d: %d", i, solve(list));
      writer.write(line + "\n");
      LOGGER.info(line);
    }
    writer.flush();
  }

  private static int solve(List<Integer> elements) {
    int min = elements.get(0);
    int coups = 0;
    for (int i = 0; i < min; i++) {
      int first = elements.get(0);
      elements.remove(0);
      int transfert = first / 2;
      elements.add(transfert);
      //Avoid rounding error
      elements.add(first - transfert);
      coups++;
      Collections.sort(elements, Comparator.reverseOrder());
      min = Math.min(min, coups + elements.get(0));
    }
    return min;
  }


}
