package com.denodev.a;

import java.math.BigInteger;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.List;

/**
 * @author Arnaud DENOYELLE
 *
 *         Le 09 avr. 2016
 */
public class ProblemA {

  public static final String INPUT = "/home/adenoyelle/gcj/input.txt";
  public static final String OUTPUT = "/home/adenoyelle/gcj/output.txt";

  public static void main(String[] args) throws Exception {
    Path outputFilePath = Paths.get(OUTPUT);
    Files.deleteIfExists(outputFilePath);
    Files.createFile(outputFilePath);
    List<String> lines = Files.readAllLines(Paths.get(INPUT));
    int nbPbs = Integer.valueOf(lines.get(0));

    for(int testCase = 1; testCase<= nbPbs; testCase++) {
      System.out.println(go(Integer.valueOf(lines.get(testCase))));
      writeSol(outputFilePath, testCase, go(Integer.valueOf(lines.get(testCase))));
    }
  }

  public static void writeSol(Path outputFile, int testCase, String solution) throws Exception {
    Files.write(outputFile, String.format("Case #%d: %s\n", testCase, solution).getBytes(), StandardOpenOption.APPEND);
  }

  public static String go(int n) {
    BigInteger bign = BigInteger.valueOf(n);
    if(n == 0) {
      return "INSOMNIA";
    } else {
      boolean[] digits = new boolean[10];
      boolean done = false;
      while(!done) {
        for (char c : bign.toString().toCharArray()) {
          Integer digit = Integer.valueOf("" + c);
          digits[digit] = true;
        }
        done = check(digits);
        if(!done) {
          bign = bign.add(BigInteger.valueOf(n));
        }
      }
    }
    return bign.toString();
  }

  public static boolean check(boolean[] check) {
    for (boolean b : check) {
      if(!b) {
        return false;
      }
    }
    return true;
  }
}
