package com.denodev.problem2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;

/**
 * @author Le 12 avril 2014.
 */
public class Problem2 {

  public static final int DIVIDE_PRECISION = 10;

  private BigDecimal farmCost;
  private BigDecimal bonusRate;
  private BigDecimal objectif;

  public Problem2(BigDecimal farmCost, BigDecimal bonusRate, BigDecimal objectif) {
    this.farmCost = farmCost;
    this.bonusRate = bonusRate;
    this.objectif = objectif;
  }

  public BigDecimal solve() {
    BigDecimal productionRate = BigDecimal.valueOf(2);
    BigDecimal ellapsedTime = BigDecimal.valueOf(0);
    BigDecimal nbCookies = BigDecimal.valueOf(0);

    while(true) {
      BigDecimal timeForFarm = farmCost.divide(productionRate, DIVIDE_PRECISION, RoundingMode.HALF_UP);
      BigDecimal timeForObjectif = objectif.subtract(nbCookies).divide(productionRate, DIVIDE_PRECISION, RoundingMode.HALF_UP);

      if(timeForObjectif.compareTo(timeForFarm) <= 0) {
        return ellapsedTime.add(timeForObjectif);
      } else {
        ellapsedTime = ellapsedTime.add(timeForFarm);
        BigDecimal timeRentab = farmCost.divide(bonusRate, RoundingMode.HALF_UP);
        BigDecimal newTimeForObjectif = objectif.subtract(farmCost).divide(productionRate, DIVIDE_PRECISION, RoundingMode.HALF_UP);
        if(newTimeForObjectif.compareTo(timeRentab) <= 0) {
          return ellapsedTime.add(newTimeForObjectif);
        } else {
          productionRate = productionRate.add(bonusRate);
          nbCookies = nbCookies.subtract(farmCost);
        }
      }
    }
  }

  public static void main(String[] args) throws Exception {
    String inputFile="/home/adenoyelle/IdeaProjects/google-code-jam/problem1/src/test/java/input2.txt";
    String outputFile="/home/adenoyelle/codejam/output2.txt";

    try (BufferedReader br = new BufferedReader(new FileReader(inputFile));
            BufferedWriter output = new BufferedWriter(new FileWriter(outputFile))) {
      int nbProblems = Integer.valueOf(br.readLine());

      for(int i = 1; i <= nbProblems; i++) {
        String[] parts = br.readLine().split(" ");
        BigDecimal farmCost = new BigDecimal(parts[0], new MathContext(10));
        BigDecimal bonusRate = new BigDecimal(parts[1], new MathContext(10));
        BigDecimal objectif = new BigDecimal(parts[2], new MathContext(10));

        Problem2 pb2 = new Problem2(farmCost, bonusRate, objectif);
        output.write("Case #"+i+": "+pb2.solve().toString()+"\n");
      }

    }

  }

}
