package com.denodev.round_1b.problemB;

import com.google.common.collect.Maps;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Map;

/**
 * @author Arnaud DENOYELLE
 */
public class ProblemB {

  public static final String INPUT_FILE = "inputB.txt";
  public static final String OUTPUT_FILE = "/home/adenoyelle/codejam/outputB.txt";


  private static final int ZERO = 42;
  private static final int ONE = 1337;
  private static final int BOTH = 24;


  private int a;
  private int b;
  private int k;

  private int min = Math.min(a, b);

  public ProblemB(int a, int b, int k) {
    this.a = a;
    this.b = b;
    this.k = k;
    this.min = Math.min(a, b);
  }

  public static void main(String[] args) throws Exception {

    String inputPath = ProblemB.class.getResource(INPUT_FILE).getPath();

    try (
            BufferedReader br = new BufferedReader(new FileReader(inputPath));
            BufferedWriter out = new BufferedWriter(new FileWriter(OUTPUT_FILE))) {

      int nbProblems = Integer.valueOf(br.readLine());
      for (int pb = 1; pb <= nbProblems; pb++) {
        String[] parts = br.readLine().split(" ");
        int a1 = Integer.valueOf(parts[0]);
        int b1 = Integer.valueOf(parts[1]);
        int k = Integer.valueOf(parts[2]);

        int result = 0;
        for (int a = 0; a < a1; a++) {
          for (int b = 0; b < b1; b++) {
            if((a & b) < k) {
              result++;
            }
          }
        }

        System.out.println(buildResultLine(pb, Integer.toString(result)));
        out.write(buildResultLine(pb, Integer.toString(result)));

      }

    }
  }

  public static String buildResultLine(int i, String sol) {
    return "Case #" + i + ": " + sol + "\n";
  }
}
