import com.google.common.collect.Sets;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Set;

/**
 * @author Arnaud DENOYELLE
 *         Le 12 Avril 2014.
 */
public class Problem1 {

  public static final String BAD_MAGICIAN = "Bad magician!";
  public static final String VOLUNTEER_CHEATED = "Volunteer cheated!";
  public static final String INPUT_FILE = "/home/adenoyelle/IdeaProjects/google-code-jam/problem1/src/test/java/input.txt";


  public static void main(String[] args) {


    try (BufferedReader br = new BufferedReader(new FileReader(INPUT_FILE))) {
      int nbProblems = Integer.valueOf(br.readLine());

      for (int c = 1; c < nbProblems+1; c++) {

        //row 1

        int row1 = Integer.valueOf(br.readLine());

        skipLines(br, row1 -1);

        Set<Integer> s1 = Sets.newHashSet();
        for (String s : br.readLine().split(" ")) {
          s1.add(Integer.valueOf(s));
        }

        skipLines(br, 4 - row1);

        //row2
        int row2 = Integer.valueOf(br.readLine());
        skipLines(br, row2 - 1);

        Set<Integer> s2 = Sets.newHashSet();
        for (String s : br.readLine().split(" ")) {
          s2.add(Integer.valueOf(s));
        }

        skipLines(br, 4 - row2);

        Sets.SetView<Integer> inter = Sets.intersection(s1, s2);

        StringBuilder sb = new StringBuilder();
        sb.append("Case #").append(c).append(": ");
        switch(inter.size()) {
          case 0 :
            sb.append(VOLUNTEER_CHEATED);
            break;
          case 1 :
            sb.append(inter.iterator().next());
            break;
          default:
            sb.append(BAD_MAGICIAN);
            break;
        }
        System.out.println(sb.toString());


      }

    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  private static void skipLines(BufferedReader br, int nbLines) throws IOException {
    for (int j = 0; j < nbLines; j++) {
      br.readLine();
    }
  }

}
