package cc.wily.se;

import java.util.List;
import java.util.Set;

public class SearchOptimizer {
	SearchEngineList engines;
	List<String> searches;

	public SearchOptimizer(SearchEngineList engineList, List<String> searches) {
		this.engines = engineList;
		this.searches = searches;
	}

	public int getSwitchCount() {
		int count = 0;

		Set<String> workingEngines = engines.getListCopy();
		for (String search : searches) {
			workingEngines.remove(search);
			if (workingEngines.isEmpty()) {
				// Oh no, no single search engine can handle all of these
				// requests!
				// Switch.
				count++;
				workingEngines = engines.getListCopy();
				workingEngines.remove(search);
			}
		}

		return count;
	}
}
