package cc.wily.train;

import java.util.*;

public class TrainCountFinder {
	List<Time> arrivals;
	List<Time> departures;
	TrainAvailabilityFinder taf;
	
	public TrainCountFinder(List<Time> arrivals, List<Time> departures, int turnaround) {
		this.arrivals = arrivals;
		this.departures = departures;
		this.taf = new TrainAvailabilityFinder(turnaround);
	}
	
	public int getRequiredTrains() {
		Timeline tl = new Timeline();
		int trainCount = 0;

		// Process arrivals
		for (Time time : arrivals) {
			tl.addAvailableTime(taf.getAvailableTime(time));
		}
		
		// Find trains for departures
		for (Time time : departures) {
			if (!tl.allocateTrainFor(time.getScalar())) {
				// Was no train available at this time
				trainCount++;
			}
		}
		
		return trainCount;
	}
}
