package cc.wily.train;

import java.util.*;

public class Timeline {
	List<Integer> availableTimes;

	public Timeline() {
		availableTimes = new LinkedList<Integer>();
	}

	public void addAvailableTime(int availableTime) {
		availableTimes.add(availableTime);
		Collections.sort(availableTimes);
	}

	public boolean isTrainAvailableAt(int time) {
		if (availableTimes.isEmpty()) {
			return false;
		} else {
			// Is the earliest-available time earlier than this time?
			return availableTimes.get(0) <= time;
		}
	}

	/**
	 * @param time
	 *            Departure time
	 * @return Boolean indicating whether a train was allocated
	 */
	public boolean allocateTrainFor(int time) {
		boolean found = false;

		// Find the latest-possible train to serve this trip
		for (int i = availableTimes.size() - 1; i >= 0; i--) {
			if (availableTimes.get(i) <= time) {
				availableTimes.remove(i);
				found = true;
				break;
			}
		}

		return found;
	}
}
