package cc.wily.sms;

import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.*;

public class ProblemA {
	static long doIt(long P, long K, long L, List<Long> freq) {
		Collections.sort(freq);
		long presses = 0;
		long letterCount = 0;
		for (int i = freq.size() - 1; i >= 0; i--) {
			long x = freq.get(i);
			presses += ((letterCount / K) + 1) * x;
			letterCount++;
		}

		return presses;
	}

	public static void main(String[] args) throws IOException {
		if (args.length != 1) {
			throw new IllegalArgumentException("Input file required");
		}

		File inputFile = new File(args[0]);
		if (!inputFile.exists() || !inputFile.isFile()) {
			throw new IllegalArgumentException(args[0] + " is not a valid file");
		}
		LineNumberReader input = new LineNumberReader(new FileReader(inputFile));

		String record;

		// Throw away record count
		input.readLine();

		int count = 0;
		while ((record = input.readLine()) != null) {
			String[] elements = record.split("[ \\t]+");
			Long P = Long.valueOf(elements[0]);
			Long K = Long.valueOf(elements[1]);
			Long L = Long.valueOf(elements[2]);

			String freqline = input.readLine();
			String[] freqs = freqline.split("[ \\t]+");
			List<Long> freq = new LinkedList<Long>();
			for (String f : freqs) {
				freq.add(Long.valueOf(f));
			}

			System.out.println("Case #" + ++count + ": " + doIt(P, K, L, freq));
		}
	}
}
