package cc.wily.se;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.LinkedList;
import java.util.List;

public class Harness {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		if (args.length != 1) {
			throw new IllegalArgumentException("Pass filename");
		}

		BufferedReader reader = new BufferedReader(new FileReader(args[0]));

		// Throw away record count
		reader.readLine();

		int count = 0;
		String line;
		while ((line = reader.readLine()) != null) {
			// First line: search engine count
			int secount = Integer.valueOf(line);

			// Get search engines
			SearchEngineList sel = new SearchEngineList();
			for (int i = 0; i < secount; i++) {
				line = reader.readLine();
				sel.addSearchEngine(line);
			}

			// Next: count of queries
			line = reader.readLine();
			int querycount = Integer.valueOf(line);

			// Get queries
			List<String> queries = new LinkedList<String>();
			for (int i = 0; i < querycount; i++) {
				line = reader.readLine();
				queries.add(line);
			}

			// Get the switch count
			SearchOptimizer so = new SearchOptimizer(sel, queries);
			int switches = so.getSwitchCount();

			System.out.println("Case #" + ++count + ": " + switches);
		}
	}
}