package cc.wily.croptri;

import java.io.*;

public class Harness {

	/**
	 * @param args
	 *            Name of input file
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		if (args.length != 1) {
			throw new IllegalArgumentException("Input file required");
		}

		File inputFile = new File(args[0]);
		if (!inputFile.exists() || !inputFile.isFile()) {
			throw new IllegalArgumentException(args[0] + " is not a valid file");
		}
		LineNumberReader input = new LineNumberReader(new FileReader(inputFile));

		String record;

		// Throw away record count
		input.readLine();

		int count = 0;
		while ((record = input.readLine()) != null) {
			String[] elements = record.split("[ \\t]+");
			if (elements.length != 8) {
				System.err.println("Invalid record: " + record + "("
						+ elements.length + " records)");
				continue;
			}
			//n, A, B, C, D, x0, y0 and M
			Long n = Long.valueOf(elements[0]);
			Long A = Long.valueOf(elements[1]);
			Long B = Long.valueOf(elements[2]);
			Long C = Long.valueOf(elements[3]);
			Long D = Long.valueOf(elements[4]);
			Long x0 = Long.valueOf(elements[5]);
			Long y0 = Long.valueOf(elements[6]);
			Long M = Long.valueOf(elements[7]);
			
			long tricount = Engine.getCount(n, A, B, C, D, x0, y0, M);

			System.out.println("Case #" + ++count + ": " + tricount);
		}
	}

}
