import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;

public class ProblemB {
	public static void printVertices(int N, int M, long A) {
		if (A > (((long) N) * ((long) M))) {
			System.out.println("IMPOSSIBLE");
			return;
		}
		
		int small = Math.min(N, M);
		int big = Math.max(N, M);
		boolean rightways = small == N;
		long max = M * N;
		
		for (int i = 0; i <= small; i++) {
			for (int j = i; j <= big; j++) {
				long curr = i * j + A;
				if (curr <= max) {
					for (int x = small; x >= 1; x--) {
						if (curr % x == 0) {
							long y = curr / x;
							if (y <= big) {
								if (rightways) {
									// i & x are across
									System.out.println("0 0 " + i + " " + y + " " + x + " " + j);
								} else {
									System.out.println("0 0 " + j + " " + x + " " + y + " " + i);
								}
								return;
							}
						}
					}
				}
			}
		}

//		for (int x = 1; x <= N; x++) {
//			if (A % x == 0) {
//				long y = A / x;
//				if (y <= M) {
//					System.out.println("0 0 " + x + " 0 0 " + y);
//					return;
//				}
//			}
//		}

		System.out.println("IMPOSSIBLE");
	}

	public static void main(String[] args) throws IOException {
		if (args.length != 1) {
			throw new IllegalArgumentException("Input file required");
		}

		File inputFile = new File(args[0]);
		if (!inputFile.exists() || !inputFile.isFile()) {
			throw new IllegalArgumentException(args[0] + " is not a valid file");
		}
		LineNumberReader input = new LineNumberReader(new FileReader(inputFile));

		String record;

		// Throw away record count
		input.readLine();

		int count = 0;
		while ((record = input.readLine()) != null) {
			String[] elements = record.split("[ \\t]+");
			Integer N = Integer.valueOf(elements[0]);
			Integer M = Integer.valueOf(elements[1]);
			Long A = Long.valueOf(elements[2]);

			System.out.print("Case #" + ++count + ": ");
			printVertices(N, M, A);
		}
	}
}
