import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.*;

public class ProblemC {
	// for i = 0 to n-1
	// print A[i mod m]
	// A[i mod m] = (X * A[i mod m] + Y * (i + 1)) mod Z

	static List<Long> getSignSequence(int n, long X, long Y, long Z, long[] A) {
		List<Long> signs = new LinkedList<Long>();
		int m = A.length;

		for (int i = 0; i < n; i++) {
			signs.add(A[i % m]);
			A[i % m] = (X * A[i % m] + Y * (i + 1)) % Z;
		}

		return signs;
	}

	public static void main(String[] args) throws IOException {
		if (args.length != 1) {
			throw new IllegalArgumentException("Input file required");
		}

		File inputFile = new File(args[0]);
		if (!inputFile.exists() || !inputFile.isFile()) {
			throw new IllegalArgumentException(args[0] + " is not a valid file");
		}
		LineNumberReader input = new LineNumberReader(new FileReader(inputFile));

		String record;

		// Throw away record count
		input.readLine();

		int count = 0;
		while ((record = input.readLine()) != null) {
			String[] elements = record.split("[ \\t]+");
			Integer n = Integer.valueOf(elements[0]);
			Integer m = Integer.valueOf(elements[1]);
			Long X = Long.valueOf(elements[2]);
			Long Y = Long.valueOf(elements[3]);
			Long Z = Long.valueOf(elements[4]);

			long[] A = new long[m];
			for (int i = 0; i < m; i++) {
				String line = input.readLine();
				A[i] = Long.valueOf(line);
			}

			List<Long> signs = getSignSequence(n, X, Y, Z, A);

			List<Long> paths = new ArrayList<Long>(signs.size());
			for (int i = 0; i < signs.size(); i++) {
				paths.add(0L);
			}
			for (int i = signs.size() - 1; i >= 0; i--) {
				paths.set(i, paths.get(i) + 1);

				long val = signs.get(i);
				for (int j = i - 1; j >= 0; j--) {
					if (signs.get(j) < val) {
						// paths.set(j, paths.get(j) + 1);
						paths.set(j, (paths.get(j) + paths.get(i)) % 1000000007);
						// val = signs.get(j);
					}
				}
			}

			long sum = 0;
			for (long np : paths) {
				sum += np;
			}

			System.out.println("Case #" + ++count + ": " + sum % 1000000007);
		}
	}
}
