package cc.wily.train;

import java.io.BufferedReader;
import java.io.FileReader;
import java.util.LinkedList;
import java.util.List;

public class Harness {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		if (args.length != 1) {
			throw new IllegalArgumentException("Pass filename");
		}

		BufferedReader reader = new BufferedReader(new FileReader(args[0]));

		// Throw away record count
		reader.readLine();

		int count = 0;
		String line;
		while ((line = reader.readLine()) != null) {
			// First line: turnaround
			int turnaround = Integer.valueOf(line);

			// Second line: NA NB
			line = reader.readLine();
			String[] splitline = line.split("[ \\t]+");
			int na = Integer.valueOf(splitline[0]);
			int nb = Integer.valueOf(splitline[1]);

			// Get departure and arrival times for A->B
			List<Time> aDepartureTimes = new LinkedList<Time>();
			List<Time> bArrivalTimes = new LinkedList<Time>();
			for (int i = 0; i < na; i++) {
				line = reader.readLine();
				// Split into two times
				String[] timeStrings = line.split("[ \\t]+");

				// Get hhmm for each time
				// Departures from A
				String[] hhmm = timeStrings[0].split(":");
				int hour = Integer.valueOf(hhmm[0]);
				int min = Integer.valueOf(hhmm[1]);
				aDepartureTimes.add(new Time(hour, min));

				// Arrivals at B
				hhmm = timeStrings[1].split(":");
				hour = Integer.valueOf(hhmm[0]);
				min = Integer.valueOf(hhmm[1]);
				bArrivalTimes.add(new Time(hour, min));
			}

			// Get departure and arrival times for B->A
			List<Time> bDepartureTimes = new LinkedList<Time>();
			List<Time> aArrivalTimes = new LinkedList<Time>();
			for (int i = 0; i < nb; i++) {
				line = reader.readLine();
				// Split into two times
				String[] timeStrings = line.split("[ \\t]+");

				// Get hhmm for each time
				// Departures from B
				String[] hhmm = timeStrings[0].split(":");
				int hour = Integer.valueOf(hhmm[0]);
				int min = Integer.valueOf(hhmm[1]);
				bDepartureTimes.add(new Time(hour, min));

				// Arrivals at A
				hhmm = timeStrings[1].split(":");
				hour = Integer.valueOf(hhmm[0]);
				min = Integer.valueOf(hhmm[1]);
				aArrivalTimes.add(new Time(hour, min));
			}

			TrainCountFinder tcfA = new TrainCountFinder(aArrivalTimes,
					aDepartureTimes, turnaround);
			TrainCountFinder tcfB = new TrainCountFinder(bArrivalTimes,
					bDepartureTimes, turnaround);
			System.out
					.println("Case #" + ++count + ": "
							+ tcfA.getRequiredTrains() + " "
							+ tcfB.getRequiredTrains());
		}
	}
}