package com.codejam.ops.operations;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

import com.codejam.ops.start.Pair;

public class FileOperations {
	
	@SuppressWarnings({ "unchecked", "rawtypes" })
	public static List<Pair<Integer, Integer[]>> readInputFile(){
		
		List<Pair<Integer, Integer[]>> mapOfInputs = new ArrayList<Pair<Integer, Integer[]>>();
		try {
			FileInputStream file = new FileInputStream("/users/arpitd/inputs");
			InputStreamReader reader = new InputStreamReader(file);
			BufferedReader br = new BufferedReader(reader);
			String strLine = "";
			boolean start = false;
			while((strLine = br.readLine())!=null){
				if(!start){
					start = true;
				}
				else{
					String Smax = strLine.split(" ")[0];
					String confLevel = strLine.split(" ")[1];
					int SmaxNumber = getMeNumber(Smax);
					System.out.print(SmaxNumber + " ");
					Integer[] confLevelArray = new Integer[SmaxNumber + 1];
					for(int i = 0;i<=SmaxNumber;i++){
						confLevelArray[i] = getMeNumber(confLevel.charAt(i));
						System.out.print(confLevelArray[i]);
					}
					System.out.println(" ");
					mapOfInputs.add(new Pair(SmaxNumber, confLevelArray));
				}
			}
			br.close();
			reader.close();
			file.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return mapOfInputs;
	}
	
	public static void writeOutputFile(int[] fCounts){
		try {
			FileOutputStream file = new FileOutputStream("/users/arpitd/outputs");
			OutputStreamWriter writer = new OutputStreamWriter(file);
			BufferedWriter bw = new BufferedWriter(writer);
			for(int i = 0;i<fCounts.length;i++){
				bw.write("Case #" + (i+1) + ": " + fCounts[i]);
				bw.newLine();
			}
			bw.close();
			writer.close();
			file.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	private static int getMeNumber(String s){
		return Integer.parseInt(s);
	}
	
	private static int getMeNumber(char c){
		return Character.getNumericValue(c);
	}
}
