import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.util.StringTokenizer;




public class FairWarning {

	/**
	 * @param args
	 */
	class Data{
		double numbers[];
	}
	public static void main(String[] args) {
		FairWarning fw= new FairWarning();
		Data dat[] =fw.parseFile(new File("D:\\ARP\\newjava\\input.in"));
		double val[]= new double[dat.length];
		for(int i =0;i<dat.length;i++)
		{
			val[i]= fw.getMax(dat[i]);
		}
		fw.writeOutputFile(new File("D:\\ARP\\newjava\\output.in"),val);
		
	}
	private double getMax(Data data) {
		double hdf=calculateGCD(data.numbers);
		double[] diff=getDifference(data.numbers);
		double dhdf=calculateGCD(diff);
		return dhdf-hdf;
	}
	private double[] getDifference(double arr[])
	{
		double[] diff= new double[arr.length-1];
		for(int i=1;i<arr.length;i++)
		{
			diff[i-1]=Math.abs(arr[i-1]-arr[i]);
		}
		return diff;
	}
	double calculateGCD(double arr[])
	{
		if(arr.length==1)
		{
			return arr[0];
		}
		double gcd=gcd(arr[0],arr[1]);
		
		for(int i=2;i<arr.length;i++)
		{
			gcd=gcd(arr[i],gcd);
		}
		return gcd;
	}
	
	double gcd(double a,double b)
    {if (b == 0)
       return a;
    else
       return gcd(b, a % b);
    }
	private  void writeOutputFile(File file, double[] val) {
		try {
			PrintWriter pw = new PrintWriter(file);
			for(int i =0;i<val.length;i++)
			{
				pw.println("Case #"+(i+1)+": "+new BigDecimal(val[i]).toString() );
			}
			pw.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		
	}
	Data[] parseFile(File f)
	{
		FileReader fr = null;
		try {
			fr= new FileReader(f);
			java.io.BufferedReader br= new BufferedReader(fr);
			int lines=Integer.parseInt(br.readLine().trim());
			int i=0;
			Data[] data= new Data[lines];
			String a;
			while(i!=lines)
			{
			
				data[i]= this.new Data();
				a=br.readLine();
				StringTokenizer st= new StringTokenizer(a," ");
				int n= Integer.parseInt(st.nextToken());
				data[i].numbers=new double[n];
				for(int j=0;j<n;j++)
					data[i].numbers[j]= Double.parseDouble(st.nextToken());
				i++;
			}
			return data;
		}catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			try {
				fr.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		return null;
	}
}
