import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringReader;
import java.io.StringWriter;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Random;
import java.util.StringTokenizer;


/*
 * Take input one by one of groups and adding it till its equal or greater than capacity K.
 * take down the index u started with and the total no. of groups and the total no. of persons and store it.
 * now push index no. back into the queue. and start computing again from where u stopped  by reducing the no. persons in the group from the total count and -1 from the total group
 * when this data set is made... =N
 * just traverese it R times.. 
 * 
 * complexity
 * N+R+something
 * 
 * */
public class ThemePark {

	
	
	
	class Ride{
		 public Ride(short i) {
			index=i;
		}
		short index;
		 int noPerson;
		 short totGroup;
		 
	}
	class Data
	{
		int capacity;
		int rides;
		int totGroup;
		LinkedList<Integer> groupCount;
	}
	
public static void main(String a[])
{	
	ThemePark pk= new ThemePark();
	//createSample(new File("D:\\ARP\\newjava\\input.in"));
	//System.out.println(System.currentTimeMillis());
	Data dat[] =pk.parseFile(new File("D:\\ARP\\newjava\\input.in"));
	long costs[]= new long[dat.length];
	for(int i =0;i<dat.length;i++)
	{
		costs[i]= pk.calculateCost(dat[i]);
	}
	writeOutputFile(new File("D:\\ARP\\newjava\\output.in"),costs);
	//System.out.println(System.currentTimeMillis());

}

 private static void createSample(File file) {
	int r=(int)Math.pow(10, 8);
	int k=(int)Math.pow(10, 9);
	int n=(int)Math.pow(10, 3);
	int g=(int)Math.pow(10, 7);
	Random rand= new Random();
	try {
		PrintWriter pw = new PrintWriter(file);
		pw.println("50");
		for(int j=0;j<50;j++)
		{
		pw.println(r+" "+k+" "+n);
		StringBuffer sb= new StringBuffer();
		for(int i=0;i<n;i++)
		{
			int a=rand.nextInt(g);
			if(i==0)
			sb.append(a);
			else
				sb.append(" ").append(a);
		}
		pw.println(sb.toString());
		}
		pw.close();
	} catch (FileNotFoundException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	
}

private static void writeOutputFile(File file, long[] costs) {
	try {
		PrintWriter pw = new PrintWriter(file);
		for(int i =0;i<costs.length;i++)
		{
			pw.println("Case #"+(i+1)+": "+costs[i] );
		}
		pw.close();
	} catch (FileNotFoundException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
	
	
}

private long calculateCost(Data d) {
	 
	 	Ride[] ride= new Ride[d.totGroup];
		fillData(d,ride);
		long cost=0;
		int start=0;
		for(int i=0;i<d.rides;i++)
		{
			cost=cost+ride[start].noPerson;
			int jump=ride[start].totGroup;
			if(start+jump<d.totGroup)
				start+=jump;
			else {
				start=jump-d.totGroup+start;
			}
		}
	return cost;
}
private void fillData(Data d, Ride[] ride) {
	// TODO Auto-generated method stub
	int index=0;
	short count=0;
	int tempCount=0;
	int tempIndex=0;
	for(short i=0;i<ride.length;i++)
	{
				
		ride[i]=new Ride(i);
		ride[i].noPerson=tempCount;
		ride[i].totGroup=count;
		while( ride[i].noPerson<d.capacity&&(ride[i].totGroup<d.groupCount.size()))
		{
			ride[i].noPerson+=d.groupCount.get(index);
			index++;
			ride[i].totGroup++;
		}
		
		if(ride[i].noPerson>d.capacity)
		{
			ride[i].totGroup--;
			ride[i].noPerson-=d.groupCount.get(index-1);
			index=index-1;
		}
		Integer firstInt=d.groupCount.poll();
		tempCount=ride[i].noPerson-firstInt;
		d.groupCount.offerLast(firstInt);
		index=index-1;
		count=(short) (ride[i].totGroup-1);
		}
}
Data[] parseFile(File f)
{
	FileReader fr = null;
	try {
		fr= new FileReader(f);
		java.io.BufferedReader br= new BufferedReader(fr);
		byte lines=Byte.parseByte(br.readLine().trim());
		byte i=0;
		Data[] data= new Data[lines];
		String a;
		while(i!=lines)
		{
		
			data[i]= this.new Data();
			a=br.readLine();
			StringTokenizer st= new StringTokenizer(a," ");
			data[i].rides= Integer.parseInt(st.nextToken());
			data[i].capacity= Integer.parseInt(st.nextToken());
			data[i].totGroup=Integer.parseInt(st.nextToken());
			data[i].groupCount=this.parseInt(br.readLine());
			i++;
		}
		return data;
	}catch (Exception e) {
		e.printStackTrace();
	}
	finally {
		try {
			fr.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	return null;
}
private LinkedList<Integer> parseInt(String str) {
	StringTokenizer st= new StringTokenizer(str," ");
	LinkedList<Integer> q= new LinkedList<Integer>();
	while(st.hasMoreTokens())
	{
		q.add(Integer.parseInt(st.nextToken()));
	}
	return q;
}
}
