import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Bacteria {
    private int testCasesCount;
    private BufferedReader input;
    private BufferedWriter output;
    private int MAX = 101;

    public static void main(String[] args) {
        Bacteria bacteria = new Bacteria();
        try {
            bacteria.mainAlgo();
        } catch (Exception e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }

    }

    public void mainAlgo() throws Exception {
        readInputs();
        output = new BufferedWriter(new FileWriter("bacteria.txt"));

        for (int i = 0; i < testCasesCount; i++) {
            int time = 0;
            int R = Integer.parseInt(input.readLine());
            boolean[][] matrix = new boolean[MAX][MAX];
            int oneCount = 0;

            
            for (int j = 0; j < R; j++) {
                List<Integer> line = getSplittedIntegers(input.readLine());
                int x1 = line.get(0);
                int y1 = line.get(1);
                int x2 = line.get(2);
                int y2 = line.get(3);
                for (int k = y1; k <= y2; k++) {
                    for (int l = x1; l <= x2; l++) {
                        matrix[k][l] = true;
                        oneCount++;
                    }
                }

            }
            
            while (oneCount > 0) {
                time++;
                oneCount = 0;
                
                boolean[][] matrixCopy = new boolean[MAX][MAX];
                
                for (int j = 1; j < MAX; j++) {
                    for (int k = 1; k < MAX ; k++) {
                        if(j-1 < 1 || k-1 < 1)
                            continue;
                        if(matrix[j][k] == false && matrix[j-1][k] == true && matrix[j][k-1] == true) {
                            oneCount++;
                            matrixCopy[j][k] = true;
                        }
                        
                        else if(matrix[j][k] == true && matrix[j-1][k] == false && matrix[j][k-1] == false) {
                            
                        }
                         
                        else if(matrix[j][k] == true) {
                            matrixCopy[j][k] = true;
                            oneCount++;
                        }
                    }
                    
                }
                //System.out.println(oneCount);
                matrix = matrixCopy;
                
            }

            output.write("Case #" + (i + 1) + ": " + time + "\n");
        }
        output.close();

    }

    private void readInputs() {
        input = new BufferedReader(new InputStreamReader(System.in));

        try {
            testCasesCount = Integer.parseInt(input.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private List<Integer> getSplittedIntegers(String oneLine) {
        String[] splittedItems = oneLine.split(" ");
        List<Integer> toReturn = new ArrayList<Integer>();
        for (String splitted : splittedItems)
            toReturn.add(Integer.parseInt(splitted));

        return toReturn;
    }
}