import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;



public class Chicken {
	private int testCasesCount;
	private BufferedReader input;
	private BufferedWriter output;
	
	public static void main(String[] args) {
		Chicken chick = new Chicken();
		try {
			chick.mainAlgo();
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		
	}
	
	public void mainAlgo() throws Exception {
		readInputs();
		output = new BufferedWriter(new FileWriter("chickens.txt"));
		
		for(int i = 0; i < testCasesCount; i++) {
			int swapCounts = 0;
			String n_k_b_t = input.readLine();
			List<Long> nkbtList = getSplittedLongs(n_k_b_t);
			
			long n = nkbtList.get(0);
			long k = nkbtList.get(1);
			long b = nkbtList.get(2);
			long t = nkbtList.get(3);
			
			List<Long> positions = getSplittedLongs(input.readLine());
			List<Long> speeds = getSplittedLongs(input.readLine());
			int[] reachableChickens = new int[positions.size()];
			
			long reachableCount = 0;
			for(int p = 0; p < positions.size(); p++) {
				long position = positions.get(p);
				long speed = speeds.get(p);
				long distToCover = b - position;
				double timeReqd = distToCover / (double)speed;
				if(timeReqd > t)
					reachableChickens[p] = -1;
				else {
					reachableChickens[p] = 1;
					reachableCount++;
				}
			}
			
			if(reachableCount < k) {
				output.write("Case #" + (i+1) + ": IMPOSSIBLE" + "\n");
				continue;
			}
				
			swapCounts = getSwapCounts(reachableChickens, k);
			output.write("Case #" + (i+1) + ": " + swapCounts + "\n");
		}
		output.close();

	}
	
	
	private int getSwapCounts(int[] reachableChickens, long k) {
		int swapCount = 0;
		int minToReach = 0;
		
		for(int i = reachableChickens.length - 1; i >= 0; i--) {
			if(minToReach == k)
				break;
			
			if(reachableChickens[i] == -1)
				continue;
			
			minToReach++;
			for(int j = i; j < reachableChickens.length; j++) {
				if(j == reachableChickens.length -1 || reachableChickens[j+1] == 1 )
					break;
				reachableChickens[j] = -1;
				reachableChickens[j+1] = 1;
				swapCount++;
			}
		}
		
		return swapCount;
	}

	private void readInputs() {
		input = new BufferedReader(new InputStreamReader(System.in));
			
		try {
			testCasesCount = Integer.parseInt(input.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	

	private List<Long> getSplittedLongs(String oneLine) {
		String[] splittedItems = oneLine.split(" ");
		List<Long> toReturn = new ArrayList<Long>();
		for(String splitted : splittedItems)
			toReturn.add(Long.parseLong(splitted));
		
		return toReturn;
	}
	
}
