import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;



public class Intranet {
    private int testCasesCount;
    private BufferedReader input;
    private BufferedWriter output;
    
    public static void main(String[] args) {
        Intranet intra = new Intranet();
        try {
            intra.mainAlgo();
        } catch (Exception e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }
        
        
    }
    
    public void mainAlgo() throws Exception {
        readInputs();
        output = new BufferedWriter(new FileWriter("intersections.txt"));
        
        for(int i = 0; i < testCasesCount; i++) {
            
            int intersections = 0;
            int n = Integer.parseInt(input.readLine());
            
            Point []left_right = new Point[n];
            for(int j = 0; j < n; j++) {
                String line = input.readLine();
                List<Integer> LR = getSplittedIntegers(line);
                Point p = new Point(LR.get(0), LR.get(1));
                left_right[j] = p;
            }
            
            for(int j = 0; j < n-1; j++) {
                Point reference = left_right[j];
                for(int k = j; k < n; k++) {
                    Point compareWith = left_right[k];
                    if((reference.x > compareWith.x && reference.y < compareWith.y) ||
                            (reference.x < compareWith.x && reference.y > compareWith.y))
                        intersections++;
                }
            }
            
            output.write("Case #" + (i+1) + ": " + intersections + "\n");
        }
        output.close();

    }
    
    

    private void readInputs() {
        input = new BufferedReader(new InputStreamReader(System.in));
            
        try {
            testCasesCount = Integer.parseInt(input.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    

    private List<Integer> getSplittedIntegers(String oneLine) {
        String[] splittedItems = oneLine.split(" ");
        List<Integer> toReturn = new ArrayList<Integer>();
        for(String splitted : splittedItems)
            toReturn.add(Integer.parseInt(splitted));
        
        return toReturn;
    }
}
