import java.awt.Point;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class LoadTest {
    private long testCasesCount;
    private BufferedReader input;
    private BufferedWriter output;

    public static void main(String[] args) {
        LoadTest ltest = new LoadTest();
        try {
            ltest.mainAlgo();
        } catch (Exception e1) {
            // TODO Auto-generated catch block
            e1.printStackTrace();
        }

    }

    public void mainAlgo() throws Exception {
        readInputs();
        output = new BufferedWriter(new FileWriter("load.txt"));

        for (long i = 0; i < testCasesCount; i++) {

            String LPC = input.readLine();
            List<Long> splitted = getSplittedIntegers(LPC);
            long L = splitted.get(0);
            long P = splitted.get(1);
            long C = splitted.get(2);

            output.write("Case #" + (i + 1) + ": " + getLoad(L, P, C) + "\n");
        }
        output.close();

    }

    private long getLoad(long L, long P, long C) {

        long median = P / C;
        if (P % C != 0)
            median = median + 1;

        long elementCount = 0;
        while (median > L) {
            elementCount++;
            if (median % C == 0)
                median = median / C;
            else
                median = (median / C) + 1;
        }
        

        return getLog(elementCount);
    }
    
    private long getLog(long elementCount) {
        long load = 0;
        while (elementCount > 0) {
            load++;
            elementCount = elementCount / 2;
        }
        return load;
    }

    private void readInputs() {
        input = new BufferedReader(new InputStreamReader(System.in));

        try {
            testCasesCount = Integer.parseInt(input.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private List<Long> getSplittedIntegers(String oneLine) {
        String[] splittedItems = oneLine.split(" ");
        List<Long> toReturn = new ArrayList<Long>();
        for (String splitted : splittedItems)
            toReturn.add(Long.parseLong(splitted));

        return toReturn;
    }
}
