import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;



public class Directory {
	private int testCasesCount;
	private BufferedReader input;
	private BufferedWriter output;
	
	public static void main(String[] args) {
		Directory dir = new Directory();
		try {
			dir.mainAlgo();
		} catch (Exception e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		
		
	}
	
	public void mainAlgo() throws Exception {
		readInputs();
		output = new BufferedWriter(new FileWriter("directories.txt"));
		
		for(int i = 0; i < testCasesCount; i++) {
			
			Set<String> already = new HashSet<String>();
			Set<String> toMake = new HashSet<String>();
			int count = 0;
			
			String line1 = input.readLine();
			List<Integer> m_n = getSplittedIntegers(line1);
			int m = m_n.get(0);
			int n = m_n.get(1);
			already.add("/");
			for(int j = 0; j < m; j++) {
				String presentDir = input.readLine();
				updateDirSet(already, presentDir);
			}
			
			for(int k = 0; k < n; k++) {
				String dirToMake = input.readLine();
				updateDirSet(toMake, dirToMake);
			}
			
			for(String oneToMake: toMake)
				if(!already.contains(oneToMake))
					count++;
			
			output.write("Case #" + (i+1) + ": " + count + "\n");
		}
		output.close();

	}
	
	
	private void updateDirSet(Set<String> already, String presentDir) {
		String []splitted = presentDir.split("/");
		String oldString = "";
		for(String splitOne : splitted) {
			if(splitOne.equals(""))
				continue;
			already.add(oldString + "/" + splitOne);
			oldString = oldString + "/" + splitOne ;
		}
	}

	private void readInputs() {
		input = new BufferedReader(new InputStreamReader(System.in));
			
		try {
			testCasesCount = Integer.parseInt(input.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	

	private List<Integer> getSplittedIntegers(String oneLine) {
		String[] splittedItems = oneLine.split(" ");
		List<Integer> toReturn = new ArrayList<Integer>();
		for(String splitted : splittedItems)
			toReturn.add(Integer.parseInt(splitted));
		
		return toReturn;
	}
}
