import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.ArrayList;



public class AlienLanguage {

  /**
   * @param args
   * @throws IOException 
   */
  public static void main(String[] args) throws IOException {
    
    
    if(args.length == 0 ){
      System.out.println("syntax: AlienLanguage language_file");
      System.exit(1);
    }
          
    File ifile = new File(args[0]);
    FileInputStream istream = new FileInputStream(ifile);
    int ch;
    String line = "";
    int lineCnt = 0;
    String[] header = null;
    int L=0;
    int D=0;
    int N=0;
    int matchCase = 1;
        
    ArrayList<String> vocabulary = new ArrayList<String>(); 
        
    while( (ch = istream.read()) != -1 ){
      
      if(ch == '\n'){
        lineCnt++;
        
        
        if(lineCnt == 1){
          /*Build header*/
          
          header = line.split(" ");        
          
          L = new Integer(header[0]).intValue();
          D = new Integer(header[1]).intValue();
          N = new Integer(header[2]).intValue();
          
        }else if(lineCnt <= (D+1) ){
          
          /*Build vocabulary*/
          
          vocabulary.add(line);          
          
          
        }else{
          line = line.replaceAll("\n","");
          line = line.replaceAll("\t",""); 
          if(line.length() > 0){

            int hit = 0;
	  				String pattern = "";          

            for(String word: vocabulary){  
       
              pattern= line.replace('(', '[').replace(')', ']');
     
              if(word.matches(pattern)){
                
                hit++;
              }
                                

            }
            System.out.println("Case #" + matchCase +": " + hit);
            matchCase++;
          
          }
        }                                
        line = "";


      }else{
        line+= (char)ch;
      }
                       
    }
    
  }
  
}

