/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package contentc;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.EnumSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Random;
import java.util.Scanner;
import java.util.Set;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author blakheat
 */
public class Contentc {
    

   
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			//inputStream = new FileInputStream("D-small-practice.in");
                        inputStream = new FileInputStream("big2.in");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("gcj4.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Scanner in = new Scanner(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		GCJ4 solver = new GCJ4();
		solver.solve(1, in, out);
		out.close();
	}
        
        
        
       
}

class Arith {

  /*
    Racine carrée entière.
    Renvoie le nombre maximal dont le carré est inférieur ou égal à n
    [Méthode dite de Newton]
  */
  
  static BigInteger sqrt(BigInteger n) {
    int nb = n.bitLength() ;
    BigInteger a , b ;

    a = BigInteger.ONE;
    a = a.shiftLeft((nb+1)/2) ;

    do {
      b = a ;
      a = n.divide(a).add(a) ;
      a = a.shiftRight(1) ;
    } while (a.compareTo(b) < 0) ;

    return b ;
  }

  static BigInteger nrt(BigInteger n, int k) {
    int nb = n.bitLength() ;
    BigInteger a , b ;
    BigInteger KM1 = BigInteger.valueOf(k-1) ;
    BigInteger K = BigInteger.valueOf(k) ;

    a = BigInteger.ONE;
    a = a.shiftLeft((nb+k-1)/k) ;

    do {
      b = a ;
      a = n.divide(a.pow(k-1)).add(a.multiply(KM1)) ;
      a = a.divide(K) ;
    } while (a.compareTo(b) < 0) ;

    /*
    if (b.pow(k).compareTo(n) > 0) {
      System.err.println("BUG nrt: too big") ;
      System.exit(2) ;
    }

    if (b.add(BigInteger.ONE).pow(k).compareTo(n) <= 0) {
      System.err.println("BUG nrt: too small") ;
      System.exit(2) ;
    }
    */
    return b ;
  }

  

  /*
    Calcul du symbole de legendre, noté bizarrement (n/p)
    Pour p premier on a :
      - (n/p) = 0, ssi p divise n.
      Et sinon, 
      - (n/p) = 1  ,ssi n est un résidu quadratique modulo p.
      - (n/p) = -1 ,ssi n n'est pas un résidu quadratique modulo p.
  */

  private static int legendre(BigInteger n, int p) {
    int a = n.remainder(BigInteger.valueOf(p)).intValue() ;
    int m = p ;
    int t = 1 ;

    while (a != 0) {
      int k = m % 8 ;
      boolean zyva = k == 3 || k == 5 ;

      while (a % 2 == 0) {
        a /= 2 ;
        if (zyva)
          t = -t ;
      }
      int swap = a ; a = m ; m = swap ;
      int x = a % 4, y = m % 4 ;
      if (x == 3 && x == y)
        t = -t ;
      a = a % m ;
    }
    if (m == 1)
      return t ;
    else
      return 0 ;
  }

  static boolean isResidue(BigInteger n, int p) {
    int r = legendre(n, p) ;
    if (r == 1)
      return true ;
    else if (r == -1)
      return false ;
    else {
      throw new Error(p + " divise " + n) ;
    }
  }

  static Random random = new Random() ;
  

  // Quelques fonctions modulaires 
  private static int multMod(int x, int y, int m) {
    long w = (long)x * (long)y ;
    return (int)(w % m) ;
  }

  private static int shiftMod(int x, int n, int m) {
    long w = (long)x << n ;
    return (int)(w % m) ;
  }

  private static int powMod(int x, int k, int m) {
    if (k == 0)
      return 1 ;
    else {
      int r = powMod(x, k/2, m) ;
      r = multMod(r, r, m) ;
      if (k % 2 == 0)
        return r ;
      else
        return multMod(x, r, m) ;
    }
  }


  /*
    Calculer une solution de l'équation x^2 = n (mod p).

    Important:
    On suppose que cette solution existe, c'est dire que
    n est un résidu quadratique modulo p.
    [Algorithme de Shanks-Tonelli.]
  */

  private static int doSqrtMod(BigInteger n, int p) {
    int a = n.remainder(BigInteger.valueOf(p)).intValue() ;

    if (p % 4 == 3) {
      return powMod(a, (p+1)/4, p) ;
    } else {
      int d ;
      do {
        d = 2+random.nextInt(p-2) ;
      } while (isResidue(BigInteger.valueOf(d), p)) ;
      int s = 0 ;
      int t = p-1 ;
      while (t % 2 == 0) {
        s++ ; t /= 2 ;
      }
      int A = powMod(a, t, p) ;
      int D = powMod(d, t, p) ;
      int m = 0 ;
      int ADpowM = A ;
      int twoPowI = 1 ;
      int D2 = D ;
      for (int exp = 1 << s-1 ; exp !=0 ;
           exp >>>= 1, twoPowI <<= 1, D2 = multMod(D2, D2, p)) {
        if (powMod(ADpowM, exp, p) == p-1) {
          m += twoPowI ;
          ADpowM = multMod(ADpowM, D2, p) ;
        }
      }
      return multMod(powMod(a, (t+1)/2, p), powMod(D, m/2, p), p) ;
    }
  }

  static int sqrtMod(BigInteger n, int p) {
    int r = doSqrtMod(n, p) ;
    return r ;
  }
  
}


 class GCJ4 {
    
 
    
    public void solve(int testNumber, Scanner in, PrintWriter out) {
        
        int cases = in.nextInt();
      
      //  Set<BigInteger> indices = generatePal(out);
        for(int caseNum =0;caseNum<cases;caseNum++) {
            in.nextLine();
          
            BigInteger  min;
            BigInteger max;
            int count =0;
      
            printCase(out,caseNum+1,count);
 
        
    }
    }
    
    Boolean isPaly(BigInteger l){
        
       String lS = l.toString();
       String reverse = new StringBuffer(l.toString()).
       reverse().toString();
       if(lS.equals(reverse)){
          
           return true;
       }
        return false;
    }
    
         
     Set<BigInteger> generatePal(PrintWriter out){
         Set<BigInteger> indices = new HashSet<BigInteger>();

         //indices.addAll( palyUnpair("", ""));
         Double combi = Math.pow(10, 50);
               
              for(Integer j = 1; j< combi; j++){
                String jString = j.toString();
                  
                if(jString.charAt(0) == '0' || jString.charAt(0) == '2'  || jString.charAt(0) == '3'
                        || jString.charAt(0) == '7' || jString.charAt(0) == '8' ){continue;}
                StringBuffer tSReverse = new StringBuffer(jString).reverse();
                BigInteger indice = new BigInteger(jString +  tSReverse.toString());
                    
                if(indice.toString().length() != 2 && indice.toString().length() != 4 && indice.toString().length() != 8 && indice.toString().length() != 10
                        && indice.toString().length() != 14 && indice.toString().length() != 18 && indice.toString().length() != 20 && indice.toString().length() != 24
                        && indice.toString().length() != 30){
                BigInteger sqrt = Arith.sqrt(indice); 
                if( sqrt.pow(2).compareTo(indice) == 0 && isPaly(sqrt)){
                    String log = indice.toString() + " => " + sqrt.toString();
               // out.println(log);
               //  System.out.println(log);
                indices.add(indice);
                }
                }
                 
                
                indices.addAll( palyUnpair( jString, tSReverse.toString(), out));
              }
         return indices;
      }
     
     Set<BigInteger> palyUnpair(String tS, String tSReverse, PrintWriter out){
         Set<BigInteger> indices = new HashSet<BigInteger>();
          for(int k=0;k<10;k++ ){
              BigInteger indice =new BigInteger(tS + k +  tSReverse);
               BigInteger sqrt = Arith.sqrt(indice); 
               if( sqrt.pow(2).compareTo(indice)== 0 && isPaly(sqrt)){
                  String log = indice.toString() + " => " + sqrt.toString() + " next : " + sqrt.add(BigInteger.ONE).pow(2);
               // out.println(log);
                // System.out.println(log);
                indices.add(indice);
               }
              
           }
          return indices;
     }
    

     
    
    void printCase(PrintWriter out,int c, int count){

               out.println("Case #" + c + ": IMPOSSIBLE");
     //out.println("Case #" + c + ": " + count);
     //out.println("Case #" + new BigInteger("10").pow(100) );
        
   } 
    
 
  
    
 
    
    
    
    
    void debug(Object...os) {
    // BEGIN CUT HERE
        System.out.println(Arrays.deepToString(os));
    // END CUT HERE
    }
  }
 
        
