
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

/**
 * @author Arturs Licis
 */

public class B {
    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

        int cnt = in.nextInt();
        for (int t = 1; t <= cnt; t++) {
            int n = in.nextInt();
            List<List<Integer>> lRows = new ArrayList<List<Integer>>();
            for (int i = 0; i < 2 * n - 1; i++) {
                List<Integer> lineArr = new ArrayList<Integer>(n);
                for (int j = 0; j < n; j++) {
                    lineArr.add(in.nextInt());
                }
                lRows.add(lineArr);
            }

            lRows.sort(new Comparator<List<Integer>>() {
                @Override
                public int compare(List<Integer> o1, List<Integer> o2) {
                    for (int i = 0; i < n; i++) {
                        int cmp = Integer.compare(o1.get(i), o2.get(i));
                        if (cmp != 0) {
                            return cmp;
                        }
                    }
                    return 0;
                }
            });
            List<List<Integer>> lCols = new ArrayList<>();
            List<Integer> result = process(n, lRows, lCols, 0);

            System.out.print("Case #" + t + ":");
            for (Integer r : result) {
                System.out.print(" " + r);
            }
            System.out.println();
        }
    }

    private static List<Integer> process(int n, List<List<Integer>> lRows, List<List<Integer>> lCols, int startIndex) {
        if (lRows.size() == n) {
            List<Integer> goodCol = null;
            for (int i = 0; i < n; i++) {
                List<Integer> checkCol = new ArrayList<>();
                for (int j = 0; j < n; j++) {
                    checkCol.add(lRows.get(j).get(i));
                }
                if (!lCols.contains(checkCol)) {
                    if (goodCol == null) {
                        goodCol = checkCol;
                    } else {
                        // ups
                        return null;
                    }
                }
            }
            return goodCol;
        }

        outer: for (int i = startIndex; i < lRows.size(); i++) {
            if (i < lRows.size() - 1) {
                if (lRows.get(i).equals(lRows.get(i + 1))) {
                    // easy case.. just remove one & you're good
                    List<List<Integer>> newRows = new ArrayList<>(lRows);
                    newRows.remove(lRows.get(i));
                    List<List<Integer>> newCols = new ArrayList<>(lCols);
                    newCols.add(lRows.get(i));
                    List<Integer> result = process(n, newRows, newCols, i);
                    if (result != null) {
                        return result;
                    }
                    break outer;
                } else {
                    for (int j = 0; j < n; j++) {
                        if (lRows.get(i).get(j).equals(lRows.get(i + 1).get(j))) {
                            // case 1
                            {
                                List<List<Integer>> newRows = new ArrayList<>(lRows);
                                newRows.remove(lRows.get(i));
                                List<List<Integer>> newCols = new ArrayList<>(lCols);
                                newCols.add(lRows.get(i));
                                List<Integer> result = process(n, newRows, newCols, i);
                                if (result != null) {
                                    return result;
                                }
                            }

                            // case 2
                            {
                                List<List<Integer>> newRows = new ArrayList<>(lRows);
                                newRows.remove(lRows.get(i + 1));
                                List<List<Integer>> newCols = new ArrayList<>(lCols);
                                newCols.add(lRows.get(i + 1));
                                List<Integer> result = process(n, newRows, newCols, i);
                                if (result != null) {
                                    return result;
                                }
                            }
                            break outer;
                        }
                    }

                }
            }

            List<List<Integer>> newRows = new ArrayList<>(lRows);
            newRows.remove(lRows.get(i));
            List<List<Integer>> newCols = new ArrayList<>(lCols);
            newCols.add(lRows.get(i));
            List<Integer> result = process(n, newRows, newCols, i);
            if (result != null) {
                return result;
            }
        }

        return null;
    }
}