package today.jvm.cp.google.cj2017.r1c;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.io.PrintStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.MathContext;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Contest: Google, Code Jam 2017, Round 1C
 * Problem: A, ''
 * @see <a href=""></a>
 * 
 * @author Arturs Licis
 */
public class A {
	private static final boolean TEST = true;
	private static final String INPUT = "4\n" + 
			"2 1\n" + 
			"100 20\n" + 
			"200 10\n" + 
			"2 2\n" + 
			"100 20\n" + 
			"200 10\n" + 
			"3 2\n" + 
			"100 10\n" + 
			"100 10\n" + 
			"100 10\n" + 
			"4 4\n" + 
			"9 3\n" + 
			"7 1\n" + 
			"10 1\n" + 
			"8 4";
	private static final String EXPECTED = "Case #1: 138230.076757951\n" + 
			"Case #2: 150796.447372310\n" + 
			"Case #3: 43982.297150257\n" + 
			"Case #4: 625.176938064";

	private static final BigDecimal PI = new BigDecimal(Math.PI, MathContext.DECIMAL64);
	private static final BigInteger TWO = BigInteger.valueOf(2);
	
	private static class Pancake implements Comparable<Pancake>{
		int r;
		int h;
		public Pancake(int r, int h) {
			super();
			this.r = r;
			this.h = h;
		}
		public int compareTo(Pancake o) {
			int rC = -Integer.compare(r,  o.r);
			if (rC == 0) return -Integer.compare(h,  o.h);
			else return rC;
		}
		
		@Override
		public String toString() {
			return "R = " + r + ", h = " + h;
		}
	}

	public static void main(String[] args) throws FileNotFoundException {
		InputStream is = // TEST ? new ByteArrayInputStream(INPUT.getBytes()) : System.in;
		new FileInputStream("/home/art/Downloads/A-small-attempt4.in");
		Scanner in = new Scanner(is);
		PrintStream out = // System.out;
		new PrintStream(new File("/home/art/Downloads/A-small-attempt4.out"));

		int t = in.nextInt();
		for (int tNum = 1; tNum <= t; tNum++) {
			int n = in.nextInt();
			int k = in.nextInt();

			Pancake[] pancakes = new Pancake[n];
			for (int i = 0; i < n; i++) {
				Pancake p = new Pancake(in.nextInt(), in.nextInt());
				pancakes[i] = p;
			}
//			if (tNum != ) {
//				continue;
//			}
			Arrays.sort(pancakes);
			// out.println(n + ":" + k);
			// out.println("Case # " + tNum + ":" + Arrays.toString(pancakes));
			
			BigInteger maxArea = BigInteger.ZERO;;
			for (int i = 0; i <= n - k; i++) {
				Pancake base = pancakes[i];
				BigInteger r = BigInteger.valueOf(base.r);
				BigInteger area = r.multiply(r);
				// out.println("Base area:" + area.toString());
				area = area.add(TWO.multiply(r).multiply(BigInteger.valueOf(base.h)));
				// out.println("Base area + height: " + area.toString());
				// out.println("Calculated base area + height: " + area + " : pancake " + base);
				BigInteger tmpArea = getMaxHeightArea(BigInteger.ZERO, i + 1, n, k - 1, pancakes);
				// out.println("Tmp Area: " + tmpArea);
				// area = area.add(tmpArea);
				maxArea = maxArea.max(area.add(tmpArea));
			}
			
			out.printf("Case #%d: %s%n", tNum, new BigDecimal(maxArea).multiply(PI).toString());
			//out.printf("Case #%d: %s%n", tNum, maxArea.toString());
		}
		out.flush();
		out.close();
		in.close();
	}
	
	public static BigInteger getMaxHeightArea(BigInteger area, int pos, int n, int k, Pancake[] pancakes) {
		if (k == 0) {
			return area;
		}
		BigInteger max = BigInteger.ZERO;
		// System.out.println("Another attempt, left pancakes" + k);
		for (int i = pos; i <= n - k; i++) {
			Pancake p = pancakes[i];
			BigInteger pArea = TWO.multiply(BigInteger.valueOf(p.r)).multiply(BigInteger.valueOf(p.h));
			// System.out.println("Trying pancake : " + p + "; area:" + area);;
			BigInteger tmpArea = getMaxHeightArea(area, i + 1, n, k - 1, pancakes);
			pArea = area.add(pArea).add(tmpArea);
			max = max.max(pArea);
		}
		return max.add(area);
	}
}
