package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Pancakes {
	public static class State {
		public static Map<List<Integer>, Integer> currSolutions = new HashMap<>();
		private List<Integer> tables;
		private int minutes = 0;
		
		public State() {
		}

		public State(List<Integer> tables, int minutes) {
			this.tables = tables;
			this.minutes = minutes;
		}

		public static State fromLine(String eatersStr, String pancakesStr) {
			State state = new State();
			int eaters = Integer.parseInt(eatersStr);
			String[] pancakesSplit = pancakesStr.split("\\s+");
			state.tables = new ArrayList<Integer>();
			for (int i = 0; i < eaters; i++) {
				state.tables.add(Integer.parseInt(pancakesSplit[i]));
			}
			Collections.sort(state.tables);
			return state;
		}

		public int solve() {
			int currSolution = Integer.MAX_VALUE;
			boolean finished = true;
			for (int i = 0; i < tables.size(); i++) {
				Integer pancakes = tables.get(i);
				if (pancakes > 1) {
					finished = false;
					if (pancakes > 2) {
						List<Integer> newTables = new ArrayList<>(tables);
						//jSystem.out.println("Created new table + " + tables.size());
						newTables.remove(i);
						newTables.add(pancakes / 2);
						if (pancakes % 2 == 0) {
							newTables.add(pancakes / 2);
						} else {
							newTables.add(pancakes - (pancakes % 2));
						}
						Collections.sort(newTables);
						
						int thisSolution = -1;
						Integer cache = currSolutions.get(newTables);
						if (cache == null) {
							thisSolution = new State(newTables, minutes + 1).solve();
							currSolutions.put(newTables, thisSolution);
						} else {
							//System.out.println("Cache hit!");
							thisSolution = cache;
						}
						if (thisSolution < currSolution) {
							currSolution = thisSolution;
						}
					}
				}
			}
			if (finished) {
				return minutes + 1;
			}

			// not yet finished..
			List<Integer> reducedList = new ArrayList<Integer>();
			for (Integer pancakes : tables) {
				if (pancakes > 1) {
					reducedList.add(pancakes - 1);
				}
			}
			int thisSolution = new State(reducedList, minutes + 1).solve();
			if (thisSolution < currSolution) {
				currSolution = thisSolution;
			}
			return currSolution;
		}

		@Override
		public String toString() {
			return "State [tables=" + tables.toString() + ", minutes="
					+ minutes + "]";
		}
	}

	public static void main(String[] args) throws IOException {
		BufferedReader br = Files.newBufferedReader(
				new File("./B-small-attempt1.in").toPath(), Charset.defaultCharset());
		BufferedWriter wr = Files.newBufferedWriter(
				new File("./output.txt").toPath(), Charset.defaultCharset());
		String cntStr = br.readLine();
		int cnt = Integer.parseInt(cntStr);
		for (int i = 0; i < cnt; i++) {
			String eaters = br.readLine();
			String pancakesStr = br.readLine();
			State.currSolutions.clear();
			State state = State.fromLine(eaters, pancakesStr);

			String outputLine = "Case #" + (i+1) + ": " + state.solve();
			state=null;
			System.out.println(outputLine);
			wr.write(outputLine + "\n");
			state = null;
			System.gc();
		}
		wr.flush();
		wr.close();
	}

}
