import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Scanner;

/**
 * @author Arturs Licis
 */

public class Pancakes {
    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

        int cnt = in.nextInt();
        for (int t = 1; t <= cnt; t++) {
            byte[] s = fromString(in.next());
            int flips = 0;
            /* START: solution */
            int cursor = s.length - 1;
            while (cursor >= 0) {
                while (cursor >= 0 && s[cursor] == 1) {
                    cursor--;
                }
                if (cursor >= 0 && s[cursor] == 0) {
                    flip(s, cursor);
                    flips++;
                }
            }
            /* END: solution */
            System.out.println("Case #" + t + ": " + flips);
        }
    }

    static byte[] fromString(String s) {
        byte[] bytes = new byte[s.length()];
        for (int i = 0; i < s.length(); i++) {
            bytes[i] = (s.charAt(i) == '+') ? (byte) 1 : 0;
        }
        return bytes;
    }

    static void flip(byte[] s, int startPos) {
        for (int i = startPos; i >= 0; i--) {
            s[i] ^= 1;
        }
    }
}