

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Scanner;

/**
 * @author Arturs Licis
 */

public class CountingSheep {
    private static final int ALL = 1023;
    
    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

        int cnt = in.nextInt();
        for (int t = 1; t <= cnt; t++) {
            long num = in.nextLong();
            String solution = null;
            if (num == 0) {
                solution = "INSOMNIA";
            } else {
                int i = 1, status = 0;
                long currNum = 0;
                do {
                    currNum = num * i++;
                    status = updateStatus(status, currNum);
                } while (status != ALL);
                solution = "" + currNum;
            }
            System.out.println("Case #" + t + ": " + solution);
        }
    }
    
    private static int updateStatus(int currStatus, long number) {
        do {
            long digit = number % 10;
            currStatus |= (1 << digit);
            number /= 10;
        } while (number > 0);
        return currStatus;
    }
}