package codejam.y17.q;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.PriorityQueue;
import java.util.Scanner;

// import static java.lang.System.out;

public class C {
	static class Pair implements Comparable<Pair> {
		long closest, farthest;
		public Pair(long closest, long farthest) {
			this.closest = closest;
			this.farthest = farthest;
		}

		@Override
		public int compareTo(Pair o) {
			int c = Long.compare(o.closest, this.closest);
			if (c != 0) return c; else return Long.compare(o.farthest, this.farthest);
		}
		
		@Override
		public String toString() {
			return closest + " :: " + farthest;
		}
	}

	public static void main(String... args) throws Exception {
		Scanner in = new Scanner(new FileInputStream(
				"/Users/arthur/Downloads/C-small-2-attempt0.in"));
		PrintStream out = new PrintStream(new FileOutputStream(
				"/Users/arthur/Downloads/C-small-2-attempt0.out"));
		int numCases = in.nextInt();
		for (int t = 1; t <= numCases; t++) {
			long n = in.nextLong();
			long k = in.nextLong();
			Pair dist = solve(n, k);
			out.printf("Case #%d: %d %d\n", t, dist.farthest, dist.closest);
		}
		out.flush();
		out.close();
	}
	
	public static Pair solve(long n, long k) {
		PriorityQueue<Pair> q = new PriorityQueue<>();
		long pers = 1;
		Pair curr = createPair(n);
		q.add(curr);
		// out.println(q);
		while (pers < k) {
			curr = q.remove();
			if (curr.closest > 0) {
				q.add(createPair(curr.closest));
			}
			if (curr.farthest > 0) {
				q.add(createPair(curr.farthest));
			}
			pers++;
			//out.println(q);
		}
		curr = q.remove();
		return curr;
	}
	
	public static Pair createPair(long len) {
		long half = len >> 1;
		long closest = half;
		if (len % 2 == 0) closest--;
		return new Pair(closest, half);
	}
}
