package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.util.Arrays;

/**
 * @author Arturs Licis
 */

public class Ovation {
	private static class OvationCase {
		private int levels;
		private int[] count;

		private int cursor;
		private int standing;
		private int friends;

		public static OvationCase fromLine(String line) {
			OvationCase instance = new OvationCase();
			String[] split = line.split("\\s+");
			instance.levels = Integer.parseInt(split[0]);
			instance.count = new int[instance.levels + 1];
			for (int i = 0; i <= instance.levels; i++) {
				instance.count[i] = Integer.parseInt(new Character(split[1]
						.charAt(i)).toString());
			}
			return instance;
		}

		public void solve() {
			for (cursor = 0; cursor <= levels; cursor++) {
				if (cursor > standing) {
					int newFriends = (cursor - standing);
					standing += newFriends;
					friends += newFriends;
				}
				standing += count[cursor];
			}
			// System.out.println("Standing: " + standing + " ; friends: " + friends);
		}

		public int getFriends() {
			return friends;
		}

		@Override
		public String toString() {
			return "OvationCase [levels=" + levels + ", count="
					+ Arrays.toString(count) + ", cursor=" + cursor
					+ ", friends=" + friends + "]";
		}

	}

	public static void main(String[] args) throws IOException {
		BufferedReader br = Files.newBufferedReader(new File("./A-small-attempt1.in").toPath(), Charset.defaultCharset());
		BufferedWriter wr = Files.newBufferedWriter(new File("./output.txt").toPath(), Charset.defaultCharset());
		int cnt = Integer.parseInt(br.readLine());
		for (int i = 0; i < cnt; i++) {
			OvationCase ovationCase = OvationCase.fromLine(br.readLine());
			ovationCase.solve();
			
			String outputLine = "Case #" + (i+1) + ": " + ovationCase.getFriends();
			System.out.println(outputLine);
			wr.write(outputLine + "\n");
		}
		wr.flush();
		wr.close();
	}
}
