import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * @author Arturs Licis
 */

public class CoinJamLarge {
    // TODO: improvement - init a cache of big integers 2..1000

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));

        // only one case
        in.nextInt();
        int n = in.nextInt();
        int j = in.nextInt();

        System.out.println("Case #1:");
        long val = (1l << (n - 1)) + 1;
        String digits = Long.toBinaryString(val);

        int initialLen = digits.length();
        // for simplicity; indices 0 & 1 unused
        int[] radixDivisor = new int[11];
        int count = 0;
        while (true) {
            digits = Long.toBinaryString(val);
            if (digits.length() > initialLen) {
                break;
            }
            radixDivisor[2] = nonTrivialDivisor(val);

            boolean hit = true;
            if (radixDivisor[2] == 0) {
                hit = false;
            } else {
                for (int radix = 3; radix <= 10; radix++) {
                    BigInteger rVal = new BigInteger(digits, radix);
                    radixDivisor[radix] = nonTrivialDivisor(rVal);
                    if (radixDivisor[radix] == 0) {
                        hit = false;
                        break;
                    }
                }
            }
            if (hit) {
                System.out.print(digits);
                for (int i = 2; i <= 10; i++) {
                    System.out.print(" " + radixDivisor[i]);
                }
                System.out.println();
                if (++count == j) {
                    break;
                }
            }
            val+= 2;
        }
    }

    static int nonTrivialDivisor(long nr) {
        for (int n = 2; n < nr && n < 1000; n++) {
            if (nr % n == 0) {
                return n;
            }
        }
        return 0;
    }
    static int nonTrivialDivisor(BigInteger nr) {
        for (int n = 2; n < 1000; n++) {
            if (nr.mod(new BigInteger(n + "")).equals(BigInteger.ZERO)) {
                return n;
            }
        }
        return 0;
    }
}