import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * GCJ 2016, Round 1C
 * Problem A
 * 
 * @author Arturs Licis
 */
public class A {
    private static class Senators implements Comparable<Senators>{
        char letter;
        int members;
        public Senators(char letter, int members) {
            super();
            this.letter = letter;
            this.members = members;
        }
        @Override
        public int compareTo(Senators o) {
            if (this.members < o.members) {
                return 1;
            } else if (this.members > o.members) {
                return -1;
            }
            return 0; // Character.compare(this.letter, o.letter);
        }
        
        @Override
        public String toString() {
            return letter + "::" + members;
        }
    }

    char letters[] = new char[] {};
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int cnt = in.nextInt();
        for (int t = 1; t <= cnt; t++) {
            int n = in.nextInt();
            PriorityQueue<Senators> pq = new PriorityQueue<>();
            for (int i = 0; i < n; i++) {
                Senators senators = new Senators((char) ((int) 'A' + i), in.nextInt());
                
                pq.add(senators);
            }
            System.out.print("Case #" + t + ":");
            while(!pq.isEmpty()) {
                System.out.print(" ");
                Senators senators = pq.remove();
                System.out.print(senators.letter);
                if (senators.members == 1) {
                    if (pq.size() % 2 == 1) {
                        Senators next = pq.remove();
                        System.out.print(next.letter);
                    }
                    continue;
                }

                Senators next = pq.peek();

                if (next.members <= senators.members - 2) {
                    System.out.print(senators.letter);
                    senators.members -= 2;
                    pq.add(senators);
                    continue;
                }

                System.out.print(next.letter);
                senators.members--;
                next.members--;
                pq.add(senators);
                pq.remove(next);
                if (next.members > 0) {
                    pq.add(next);
                }
            }
            System.out.println();
        }
    }
}
