package codejam.y17.q;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.PriorityQueue;
import java.util.Scanner;

public class C_fast {
	static class Pair implements Comparable<Pair> {
		long closest, farthest;

		public Pair(long closest, long farthest) {
			this.closest = closest;
			this.farthest = farthest;
		}

		@Override
		public int compareTo(Pair o) {
			int c = Long.compare(o.closest, this.closest);
			if (c != 0)
				return c;
			else
				return Long.compare(o.farthest, this.farthest);
		}

		@Override
		public String toString() {
			return closest + " :: " + farthest;
		}
	}

	public static void main(String... args) throws Exception {
		Scanner in = new Scanner(new FileInputStream(
				"/Users/arthur/Downloads/C-large.in"));
		PrintStream out = new PrintStream(new FileOutputStream("/Users/arthur/Downloads/C-large.out"));
		int numCases = in.nextInt();
		for (int t = 1; t <= numCases; t++) {
			long n = in.nextLong();
			long k = in.nextLong();
			Pair distFast = solveFast(n, k);
			out.printf("Case #%d: %d %d\n", t, distFast.farthest, distFast.closest);
		}
		out.flush();
		out.close();
	}

	public static Pair solveFast(long n, long k) {
		long from = 1;
		long to = 1;
		long pow2 = 2;
		long max = n;
		long min = n;
		long maxCnt = 1;
		long minCnt = 0;
		while (!(k >= from && k <= to)) {
//			System.out.println("k not within ref interval [from, to] " + from + ", " + to);
			long maxmax = max / 2;
			long maxmin = (max - 1) / 2;
			if (max == min) {
//				System.out.println("Max still same as min");
				if (maxmax == maxmin) {
					maxCnt *= 2;
				} else {
					minCnt += maxCnt;
				}
			} else {
				if (maxmax == maxmin) {
//					System.out.println("new max max same as max min");
					maxCnt = maxCnt * 2 + minCnt;
				} else {
					minCnt = minCnt * 2 + maxCnt;
				}
			}
			min = (min - 1) / 2;
			max = max / 2;
//			System.out.println("New min/max: " + min + "/" + max);
//			System.out.println("Cnt min/max: " + minCnt + "/" + maxCnt);
			from = to + 1;
			pow2 *= 2;
			to = pow2 - 1;
//			System.out.println("Increasing level to " + pow2);
//			System.out.println("----------------------------");
		}
//		System.out.printf("Target value %d goes within interval [%d, %d]\n", k, from, to);
//		System.out.printf("Min/max are [%d, %d]\n", min, max);
//		System.out.printf("Min/max cnt [%d, %d]\n", minCnt, maxCnt);
		long offset = k - from + 1;
		long target = offset > maxCnt ? min : max;
//		System.out.printf("target value is %d \n", target);

		return new Pair((target - 1) / 2, target / 2);
	}
}
