import java.lang.*;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	public void run() {
		int tt = Integer.parseInt(nextLine());
		for (int t = 0; t < tt; t++) {
			int n = Integer.parseInt(nextLine());
			
			char[][] arr = new char[500][500];
			for (int i = 0; i < 500; i++) Arrays.fill(arr[i], ' ');
			int CX = 250, CY = 250;
			
			for (int i = 0; i < 2*n-1; i++) {
				String s = nextLine();
				for (int j = 0; j < s.length(); j++) {
					arr[CX-n+1+i][CY-n+1+j] = s.charAt(j);
				}
			}
			
			int bestX = 100000;
			A:
			for (int cx = CX-n-5; cx < CX+n+5; cx++) {
				for (int i = CX-n-5; i < CX+n+5; i++) {
					for (int j = CY-n-5; j < CY+n+5; j++) {
						if (arr[i][j] != ' ') {
							if (arr[i][j] != arr[cx+(cx-i)][j] && arr[cx+(cx-i)][j] != ' ') {
								continue A;
							}
						}
					}	
				}
				if (Math.abs(CX-bestX) > Math.abs(CX-cx))
					bestX = cx;
			}
			
			int bestY = 100000;
			A:
			for (int cy = CY-n-5; cy < CY+n+5; cy++) {
				for (int i = CX-n-5; i < CX+n+5; i++) {
					for (int j = CY-n-5; j < CY+n+5; j++) {
						if (arr[i][j] != ' ') {
							if (arr[i][j] != arr[i][cy+(cy-j)] && arr[i][cy+(cy-j)] != ' ') {
								continue A;
							}
						}
					}	
				}
				if (Math.abs(CY-bestY) > Math.abs(CY-cy))
					bestY = cy;
			}
			
			int prevCnt = get(n);
			int cnt = get(Math.abs(CX-bestX)+Math.abs(CY-bestY)+n);
			out.printf("Case #%d: %s\n", t+1, cnt-prevCnt);
		}
		out.flush();
	}
	
	int get(int n) {
		int ans = 0;
		for (int i = 0; i < n; i++) {
			ans += i+1;
		}
		for (int i = 0; i < n-1; i++) {
			ans += i+1;
		}
		return ans;
	}
}
