import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	public void run() {
		int tt = nextInt();
		for (int t = 0; t < tt; t++) {
			int c = nextInt();
			int[][] trans = new int[26][26];
			for (int i = 0; i < 26; i++) {
				Arrays.fill(trans[i], -1);
			}
			for (int i = 0; i < c; i++) {
				String s = nextWord();
				trans[s.charAt(0)-'A'][s.charAt(1)-'A'] = s.charAt(2)-'A';
				trans[s.charAt(1)-'A'][s.charAt(0)-'A'] = s.charAt(2)-'A';
			}
			int d = nextInt();
			boolean[][] clear = new boolean[26][26];
			for (int i = 0; i < d; i++) {
				String s = nextWord();
				clear[s.charAt(0)-'A'][s.charAt(1)-'A'] = true;
				clear[s.charAt(1)-'A'][s.charAt(0)-'A'] = true;
			}
			
			int n = nextInt();
			String s = nextWord();
			LinkedList<Integer> list = new LinkedList<Integer>();
			for (int i = 0; i < s.length(); i++) {
				list.addLast(s.charAt(i)-'A');
				
				// Reducting
				int a = 0;
				int b = 0;
				while (list.size() >= 2) {	
					a = list.removeLast();
					b = list.removeLast();
					if (trans[a][b] != -1) list.addLast(trans[a][b]);
					else {
						list.addLast(b);
						list.addLast(a);
						break;
					}
				}
				
				if (list.size() > 0) {
					int cur = list.getLast();
					for (Integer aa : list) {
						if (clear[cur][aa]) {
							list.clear();
							break;
						}
					}
				}
			}
			
			StringBuilder ans = new StringBuilder();
			for (Integer i : list) {
				ans.append((char)(i+'A') + ", ");
			}
			if (ans.length() > 0) out.println("Case #" + (t+1) + ": " + "[" + ans.toString().substring(0, ans.length()-2) + "]");
			else out.println("Case #" + (t+1) + ": " + "[" + "]");
		}
		out.flush();
	}
}
