import java.lang.*;
import java.io.*;
import java.util.*;

public class ProblemC implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
        if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new ProblemC()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }

    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }

    boolean used[];
    int n;
    char[] arr;
    int k;
    int perm[];
    int ans;
    
    void next(int pos) {
    	if (pos < k) {
    		for (int i = 0; i < k; i++) {
    			if (!used[i]) {
    				perm[pos] = i;
    				used[i] = true;
    				next(pos+1);
    				used[i] = false;
    			}
    		}
    	} else {
    		char[] nw = new char[n];
    		for (int i = 0; i < n; i++) {
    			int a = i%k;
    			nw[perm[a]+i-a] = arr[i];
    		}
    		char cur = nw[0];
    		int cnt = 1;
    		for (int i = 0; i < n; i++) {
    			if (nw[i] != cur) {
    				cnt++;
    				cur = nw[i];
    			}
    		}
    		ans = Math.min(ans, cnt);
    	}
    }
    
    public void run() {
    	int u = nextInt();
    	for (int t = 0; t < u; t++) {
    		k = nextInt();
    		arr = nextLine().toCharArray();
    		n = arr.length;
    		used = new boolean[k];
    		perm = new int[k];
    		ans = 100000000;
    		next(0);
    		out.printf("Case #%d: %d\n", t+1, ans);
    	}
    	out.flush();
    }
}

