import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
    	if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new Solution()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }
    
    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    double[][] p;
    int N, C;
    double EPS = 1e-15;
    
    public void run() {
		C = 10;
		N = 10;
		int[] cntBit = new int[1<<N];
		for (int i = 0; i < (1<<N); i++) {
			cntBit[i] = Integer.bitCount(i);
		}
		long[][] cc = new long[50][50];
		cc[0][0] = 1;
		for (int n = 1; n < 50; n++) {
			cc[n][0] = 1;
			for (int k = 1; k <= n; k++) {
				cc[n][k] = cc[n-1][k]+cc[n-1][k-1];
			}
		}
    	int T = nextInt();
    	for (int t = 0; t < T; t++) {
    		double ans = 0;
    		C = nextInt();
    		N = nextInt();
    		p = new double[C+1000+1][1<<C];
        	p[0][0] = 1.0;
	    	for (int i = 0; i < C+1000; i++) 
	    	{
	    		for (int j = 0; j < 1<<C; j++) 
	    		{
	    			if (p[i][j] > EPS) 
	    			{
	    				if (j == (1<<C)-1) {
	    					ans += p[i][j]*i;
	    				} else {
		    				for (int k = 0; k < 1<<C; k++) 
		    				{
		    					if (cntBit[k] == N) {
		    						p[i+1][j|k] += p[i][j]*1.0/cc[C][N];
		    					}
		    				}
	    				}
	    			}
	    		}
	    	}
    		out.print("Case #");
    		out.print(t+1);
    		out.print(": ");
    		out.println(ans);
    	}
    	out.flush();
    }
}
