import java.lang.*;
import java.io.*;
import java.util.*;

public class ProblemB implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
        if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new ProblemB()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }

    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    int n;
    int m;
    
    class Man implements Comparable<Man>{
    	ArrayList<O> arr;
    	Man() {
    		arr = new ArrayList<O>();
    	}
		public int compareTo(Man m) {
			return arr.size() - m.arr.size();
		}
    }
    
    class O {
    	int x, y;
    	O(int x, int y) {
    		this.x = x;
    		this.y = y;
    	}
    	public boolean compareTo(O o) {
    		return (x == o.x) && (y == o.y);
		}
    }
    
    public void run1() {
    	int u = nextInt();
    	for (int t = 0; t < u; t++) {
    		n = nextInt();
    		m = nextInt();
    		Man[] arr = new Man[n];
    		for (int i = 0; i < m; i++) {
    			arr[i] = new Man();
    			int a = nextInt();
    			for (int j = 0; j < a; j++) {
    				arr[i].arr.add(new O(nextInt(), nextInt()));
    			}
    		}
    		for (int i = 0; i < m; i++) {
    			O op = arr[i].arr.get(arr[i].arr.size()-1);
    			for (int j = i+1; j < m; j++) {
    				for (int k = 0; k < arr[j].arr.size(); k++) {
    					if (op.compareTo(arr[j].arr.get(k))) {
    					}
    				}
    			}
    		}
    	}
    }
    
    Man[] arr;
    int[] h;
    
    int[] make(int num) {
    	if (num < n) {
    		for (int i = 0; i < 2; i++) {
    			h[num] = i;
    			int[] ans = make(num+1);
    			if (ans.length != 0) return ans;
    		}
    	} else {
    		boolean f = true;
    		A:
			for (int i = 0; i < m; i++) {
				boolean fl = false;
				for (int j = 0; j < arr[i].arr.size(); j++) {
					O op = arr[i].arr.get(j);
					if (h[op.x-1] == op.y) {
						fl = true;
					}
				}
				if (!fl) {
					f = false;
					break A;
				}
			}
    		if (f) return h;
    	}
    	return new int[0];
    }
    
    public void run() {
    	int u = nextInt();
    	for (int t = 0; t < u; t++) {
    		n = nextInt();
    		m = nextInt();
    		arr = new Man[m];
    		h = new int[n];
    		for (int i = 0; i < m; i++) {
    			arr[i] = new Man();
    			int a = nextInt();
    			for (int j = 0; j < a; j++) {
    				arr[i].arr.add(new O(nextInt(), nextInt()));
    			}
    		}
    		int[] ans = make(0);
    		if (ans.length == 0) {
    			out.printf("Case #%d: IMPOSSIBLE", t+1);
    		} else {
    			out.printf("Case #%d:", t+1);
    			for (int i = 0; i < ans.length; i++) {
    				out.printf(" %d", ans[i]);
    			}
    		}
    		out.println();
    	}
    	out.flush();
    }
}