import java.lang.*;
import java.io.*;
import java.util.*;

public class ProblemB implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
        if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter("out.txt");
        new Thread(new ProblemB()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }

    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    class Way implements Comparable<Way>{
    	int a, b, t;
    	Way(int a, int b, int t) {
    		this.a = a;
    		this.b = b;
    		this.t = t;
    	}
		public int compareTo(Way o) {
			return a-o.a;
		}
    }
    
    int toInt(String s) {
    	return Integer.parseInt((s.substring(0, 2)))*60 + Integer.parseInt((s.substring(3, 5))); 
    }

	int[] ans;
	Way[] arr;
	int n, m, t;
    
    void del(int time, int st) {
    	int best = -1;
    	for (int i = 0; i < n+m; i++) {
			if (arr[i] != null && arr[i].t == st && arr[i].a >= time) {
				if (best == -1 || arr[i].b < arr[best].b) {
					best = i;
				}
			}
    	}
    	if (best == -1) return;
    	del(arr[best].b+t, (st+1)%2);
		arr[best] = null;
    }
    
    public void run() {
    	int tst = nextInt();
    	for (int u = 0; u < tst; u++) {
    		t = nextInt();
    		n = nextInt();
    		m = nextInt();
    		arr = new Way[n+m];
    		ans = new int[2];
    		for (int i = 0; i < n; i++) {
    			arr[i] = new Way(toInt(nextWord()), toInt(nextWord()), 0);
    		}
    		for (int i = n; i < n+m; i++) {
    			arr[i] = new Way(toInt(nextWord()), toInt(nextWord()), 1);
    		}
    		Arrays.sort(arr);
			for (int i = 0; i < n+m; i++) {
				if (arr[i] != null) {
					del(arr[i].b+t, (arr[i].t+1)%2);
					ans[arr[i].t]++;
					arr[i] = null;
				}
			}
    		out.print("Case #");
    		out.print(u+1);
    		out.print(": ");
    		out.print(ans[0]);
    		out.print(' ');
    		out.println(ans[1]);
    	}
        out.flush();
    }
}


