import java.lang.*;
import java.io.*;
import java.util.*;

public class ProblemA implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
        if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new ProblemA()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }

    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    A[] arr;
    long[][] h;
    
    class A {
    	int s, ch;
    	A(int s, int ch) {
    		this.s = s;
    		this.ch = ch;
    	}
    }
    
    long get(int a, int num) {
    	if (arr[a].ch == -1) {
    		if (arr[a].s != num) return 100001;
    		else return 0;
    	} else {
    		if (arr[a].ch == 0) {
    			if (arr[a].s == 1) {
    				if (num == 1) {
    					return h[a*2+1][1] + h[a*2+2][1];
    				} else {
    					return Math.min(h[a*2+1][0], h[a*2+2][0]);
    				}
    			} else {
    				if (num == 1) {
    					return Math.min(h[a*2+1][1], h[a*2+2][1]);
    				} else {
    					return h[a*2+1][0] + h[a*2+2][0];
    				}
    			}
    		} else {
    			long best = 100000000;
    			if (arr[a].s == 1) {
    				if (num == 1) {
    					best = Math.min(best, h[a*2+1][1] + h[a*2+2][1]);
    				} else {
    					best = Math.min(best, Math.min(h[a*2+1][0], h[a*2+2][0]));
    				}
    			} else {
    				if (num == 1) {
    					best = Math.min(best, Math.min(h[a*2+1][1], h[a*2+2][1]));
    				} else {
    					best = Math.min(best, h[a*2+1][0] + h[a*2+2][0]);
    				}
    			}
    			if (arr[a].s == 0) {
    				if (num == 1) {
    					best = Math.min(best, h[a*2+1][1] + h[a*2+2][1]+1);
    				} else {
    					best = Math.min(best, Math.min(h[a*2+1][0], h[a*2+2][0])+1);
    				}
    			} else {
    				if (num == 1) {
    					best = Math.min(best, Math.min(h[a*2+1][1], h[a*2+2][1])+1);
    				} else {
    					best = Math.min(best, h[a*2+1][0] + h[a*2+2][0]+1);
    				}
    			}
    			return best;
    		}
    	}
    }
    
    public void run() {
    	int u = nextInt();
    	for (int t = 0; t < u; t++) {
    		int m = nextInt();
    		int v = nextInt();
    		arr = new A[m];
    		h = new long[m][2];
    		for (int i = 0; i < m; i++) Arrays.fill(h[i], -1);
    		for (int i = 0; i < m/2; i++) {
    			arr[i] = new A(nextInt(), nextInt());
    		}
    		for (int i = m/2; i < m; i++) {
    			arr[i] = new A(nextInt(), -1);
    		}
    		for (int i = m-1; i >= 0; i--) {
    			h[i][0] = get(i, 0);
    			h[i][1] = get(i, 1);
    		}
    		if (h[0][v] > 100000) out.printf("Case #%d: IMPOSSIBLE\n", t+1);
    		else out.printf("Case #%d: %d\n", t+1, h[0][v]);
    	}
    	out.flush();
    }
}

