import java.lang.*;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	int[] arr;
	
	int dfs(int l, int r, int p) {
		if (p == 0) return 0;
		boolean f = true;
		for (int i = l; i <= r; i++) {
			if (arr[i] < p) {
				f = false;
			}
		}
		if (!f) {
			return 1 + dfs(l, (l+r)/2, p-1) + dfs((l+r)/2+1, r, p-1);
		}
		return 0;
	}
	
	public void run() {
		int tt = nextInt();
		for (int t = 0; t < tt; t++) {
			int p = nextInt();
			int n = 1 << p;
			arr = new int[n];
			for (int i = 0; i < n; i++) {
				arr[i] = nextInt();
			}
			int cnt = n/2;
			for (int i = 0; i < p; i++) {
				for (int j = 0; j < cnt; j++) {
					nextInt();
				}
				cnt /= 2;
			}
			
			out.printf("Case #%d: %d\n", t+1, dfs(0, n-1, p));
		}
		out.flush();
	}
}
