import java.lang.*;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	public void run() {
		int tt = Integer.parseInt(nextLine());
		double[] ws = new double[1000010];
		for (int ttt = 0; ttt < tt; ttt++) {
			int x = nextInt();
			int s = nextInt();
			int r = nextInt() - s;
			int t = nextInt();
			int n = nextInt();
			int[] ls = new int[n];
			int[] rs = new int[n];
			int[] wws = new int[n];
			for (int i = 0; i < n; i++) {
				ls[i] = nextInt();
				rs[i] = nextInt();
				wws[i] = nextInt();
			}
			Arrays.fill(ws, s);
			for (int i = 0; i < n; i++) {
				for (int j = ls[i]; j < rs[i]; j++) {
					ws[j] += wws[i]; 
				}
			}
			Arrays.sort(ws, 0, x);
			double EPS = 1e-13;
			double ans = 0.0;
			double runRem = t;
			for (int i = 0; i < x; i++) {
				double speed;
				if (runRem > EPS) {
					speed = ws[i] + r;
					double reqTime = 1.0 / speed;
					if (reqTime < runRem) {
						runRem -= reqTime;
						ans += reqTime;
					} else {
						double runDist = runRem * speed;
						ans += runRem;
						runRem = 0;
						double remDist = 1.0 - runDist;
						ans += remDist / ws[i];
					}
				} else {
					speed = ws[i];
					ans += 1.0 / speed; 
				}
			}
			out.printf("Case #%d: ", ttt+1);
			out.println(ans);
		}
		out.flush();
	}
}
