import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
    	if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new Solution()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }
    
    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    int[] dx = new int[] {-1,0,0,1};
    int[] dy = new int[] {0,-1,1,0};
    
    public void run() {
    	int t = nextInt();
    	for (int tt = 0; tt < t; tt++) {
    		int n = nextInt();
    		int m = nextInt();
    		int[][] h = new int[n][m];
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < m; j++) {
    				h[i][j] = nextInt();
    			}
    		}
    		int[][] type = new int[n][m];
    		int cur = 1;
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < m; j++) {
    				if (type[i][j] == 0) {
    					type[i][j] = getType(h, type, i, j, cur);
    					if (type[i][j] == cur) cur++;
    				}
    			}
    		}
    		out.print("Case #");
    		out.print(tt+1);
    		out.println(":");
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < m; j++) {
    				out.print((char)(type[i][j]+'a'-1));
    				out.print(' ');
    			}
    			out.println();
    		}
    	}
    	out.flush();
    }

	private int getType(int[][] h, int[][] type, int x, int y, int cur) {
		int n = h.length;
		int m = h[0].length;
		while (true) {
			if (type[x][y] != 0) return type[x][y];
			int best = h[x][y];
			int bestK = -1;
			for (int k = 0; k < 4; k++) {
				if (x+dx[k] >= 0 && y+dy[k] >= 0 && x+dx[k] < n 
						&& y+dy[k] < m && h[x+dx[k]][y+dy[k]] < best) {
					best = h[x+dx[k]][y+dy[k]];
					bestK = k;
				}
			}
			if (bestK != -1) {
				x = x+dx[bestK];
				y = y+dy[bestK];
			} else {
				return type[x][y] = cur;
			}
		}
	}
}
