import java.lang.*;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	public void run() {
		int tt = nextInt();
		for (int t = 0; t < tt; t++) {
			int n = 300;
			int r = nextInt();
			int[][] arr = new int[n][n];
			int[][] arr1 = new int[n][n];
			for (int i = 0; i < r; i++) {
				int x1 = nextInt()-1;
				int y1 = nextInt()-1;
				int x2 = nextInt()-1;
				int y2 = nextInt()-1;
				for (int x = x1; x <= x2; x++) {
					for (int y = y1; y <= y2; y++) {
						arr[x][y] = 1;
					}
				}
			}

			boolean f = true;
			int time = 0;
			while (f) {
				time++;
				f = false;
				for (int i = 0; i < n; i++) {
					for (int j = 0; j < n; j++) {
						if (arr[i][j] == 1) {
							if ((i!=0 && arr[i-1][j] == 1) || (j!=0 && arr[i][j-1] == 1)) {
								arr1[i][j] = 1;
							}
							f = true;
						} else {
							if (i != 0 && j != 0) {
								if (arr[i-1][j] == 1 && arr[i][j-1] == 1) {
									arr1[i][j] = 1;
								}
							}
						}
					}
				}
				for (int i = 0; i < n; i++) {
					for (int j = 0; j < n; j++) {
						arr[i][j] = arr1[i][j];
						arr1[i][j] = 0;
					}
				}
			}
			
			out.printf("Case #%d: %d\n", t+1, time-1);
		}
		out.flush();
	}
}
