import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
    	if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new Solution()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }
    
    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    boolean[][] map = new boolean[101][101];
    
    int[] g = new int[101];
    int n, best;
    
    void dfs(int gr, int pos) {
    	if (gr+1 > best) return;
    	if (pos==n) {
    		best = Math.min(gr+1, best);
    		return;
    	}
    	for (int i = 0; i <= gr; i++) {
    		boolean f = true;
			for (int j = 0; j < n; j++) {
				if (g[j] == i && !map[j][pos]) {
					f = false; break;
				}
			}
			if (f) {
				g[pos] = i;
				dfs(gr, pos+1);
				g[pos] = -1;
			}
    	}
    	g[pos] = gr+1;
    	dfs(gr+1, pos+1);
    	g[pos] = -1;
    }
    
    public void run() {
    	int T = nextInt();
    	for (int tt = 0; tt < T; tt++) {
    		n = nextInt();
    		int m = nextInt();
    		int[][] c = new int[n][m];
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < m; j++) {
    				c[i][j] = nextInt();
    			}
    		}
    		
    		for (int i = 0; i < n; i++) {
    			map[i][i] = true;
    			for (int j = i+1; j < n; j++) {
    				boolean f = true;
    				if (c[i][0] == c[j][0]) f = false;
    				for (int k = 1; k < m; k++) {
    					if (c[i][k-1] > c[j][k-1] && c[i][k] <= c[j][k]) {
    						f = false; break;
    					}
    					if (c[i][k-1] < c[j][k-1] && c[i][k] >= c[j][k]) {
    						f = false; break;
    					}
    				}
    				map[i][j] = map[j][i] = f;
    			}
    		}
    		
    		Arrays.fill(g, -1);
    		g[0] = 0;
    		best = Integer.MAX_VALUE;
    		dfs(0, 1);
    		
    		out.print("Case #");
    		out.print(tt+1);
    		out.print(": ");
    		out.println(best);
    	}
    	out.flush();
    }
}
