import java.lang.*;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	public void run() {
		int tt = nextInt();
		for (int t = 0; t < tt; t++) {
			int n = nextInt();
			int[] pos = new int[n];
			int[] rob = new int[n];
			for (int i = 0; i < n; i++) {
				rob[i] = nextWord().equals("B") ? 0 : 1;
				pos[i] = nextInt()-1;
			}
			int[][][] dp = new int[n+1][100][100];
			for (int i = 0; i <= n; i++) {
				for (int j = 0; j < 100; j++) {
					Arrays.fill(dp[i][j], -1);
				}
			}
			dp[0][0][0] = 0;
			LinkedList<Integer> list = new LinkedList<Integer>();
			list.addLast(0);
			while (list.size() > 0) {
				int k = list.removeFirst();
				int p = (k >> 16) & 0xFF;
				int a = (k >> 8) & 0xFF;
				int b = k & 0xFF;
				if (p == n) break;
				for (int da = -1; da <= 1; da++) {
					for (int db = -1; db <= 1; db++) {
						int na = a+da;
						int nb = b+db;
						if (na >= 0 && na < 100 && nb >= 0 && nb < 100) {
							if (dp[p][na][nb] == -1) {
								dp[p][na][nb] = dp[p][a][b] + 1;
								list.addLast(((p)<<16) + (na<<8) + nb);
							}
						}
					}
				}
				if (rob[p] == 0) {
					if (a == pos[p]) {
						for (int db = -1; db <= 1; db++) {
							int na = a;
							int nb = b+db;
							if (na >= 0 && na < 100 && nb >= 0 && nb < 100) {
								if (dp[p+1][na][nb] == -1) {
									dp[p+1][na][nb] = dp[p][a][b] + 1;
									list.addLast(((p+1)<<16) + (na<<8) + nb);
								}
							}
						}
					}
				} else {
					if (b == pos[p]) {
						for (int da = -1; da <= 1; da++) {
							int na = a+da;
							int nb = b;
							if (na >= 0 && na < 100 && nb >= 0 && nb < 100) {
								if (dp[p+1][na][nb] == -1) {
									dp[p+1][na][nb] = dp[p][a][b] + 1;
									list.addLast(((p+1)<<16) + (na<<8) + nb);
								}
							}
						}
					}
				}
			}
			int ans = Integer.MAX_VALUE;
			for (int i = 0; i < 100; i++) {
				for (int j = 0; j < 100; j++) {
					if (dp[n][i][j] >= 0) {
						ans = Math.min(ans, dp[n][i][j]);
					}
				}
			}
			out.printf("Case #%d: %d\n", t+1, ans);
		}
		out.flush();
	}
}
