import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
    	if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new Solution()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }
    
    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    byte[][] arr;
    boolean[] used;
    
    public void run() {
    	int T = nextInt();
    	int B = 11;
    	int N = 6100001;
    	arr = new byte[B][];
    	for (int i = 2; i < B; i++) arr[i] = new byte[N];
    	used = new boolean[N];
    	for (int b = 2; b < B; b++) {
    		Arrays.fill(arr[b], (byte)-1);
    		Arrays.fill(used, false);
    		arr[b][1] = (byte)1;
    		for (int j = 2; j < N; j++) {
    			make(j, b);
    		}
    	}
    	for (int i = 0; i < T; i++) {
    		String[] ss = nextLine().split(" ");
    		int[] bb = new int[ss.length];
    		for (int j = 0; j < ss.length; j++) {
    			bb[j] = Integer.parseInt(ss[j]);
    		}
    		int ans = 0;
    		for (int j = 2; j < N; j++) {
    			boolean f = true;
    			for (int k = 0; k < bb.length; k++) {
    				if (arr[bb[k]][j] == (byte)-1) {
    					int a = 0; out.println(1/a);
    				}
    				if (arr[bb[k]][j] == (byte)0) {
    					f = false;
    					break;
    				}
    			}
    			if (f) {
    				ans = j;
    				break;
    			}
    		}
    		out.print("Case #");
    		out.print(i+1);
    		out.print(": ");
    		out.println(ans);
    	}
    	out.flush();
    }

	private byte make(int a, int b) {
		if (arr[b][a] != (byte)-1) {
			return arr[b][a];
		}
		if (used[a]) {
			return arr[b][a] = 0;
		}
		used[a] = true;
		int sqr = 0;
		int aa = a;
		while (aa != 0) {
			sqr += (aa%b)*(aa%b);
			aa /= b;
		}
		return arr[b][a] = make(sqr, b);
	}
}
