import java.lang.*;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	public void run() {
		int tt = nextInt();
		for (int t = 0; t < tt; t++) {
			int R = nextInt();
			int k = nextInt();
			int n = nextInt();
			int[] arr = new int[n];
			for (int i = 0; i < n; i++) {
				arr[i] = nextInt();
			}
			
			int cur = 0;
			long ans = 0;
			int cyc = 0;
			long cycCost = 0;
			long[] was = new long[n];
			int[] wasCyc = new int[n];
			for (; R > 0; ) {
				cyc++; R--;
				int sum = arr[cur];
				int a = (cur+1)%n;
				while (a != cur) {
					if (sum + arr[a] <= k) {
						sum += arr[a];
						a = (a+1)%n;
					} else {
						break;
					}
				}
				ans += sum;
				cur = a;
				if (was[cur] > 0) {
					cycCost = ans-was[cur];
					cyc = cyc-wasCyc[cur];
					break;
				}
				was[cur] = ans;
				wasCyc[cur] = cyc;
			}
			
			if (cycCost > 0) {
				ans += cycCost * (R/cyc);
				R %= cyc;
			}

			for (; R > 0; R--) {
				int sum = arr[cur];
				int a = (cur+1)%n;
				while (a != cur) {
					if (sum + arr[a] <= k) {
						sum += arr[a];
						a = (a+1)%n;
					} else {
						break;
					}
				}
				ans += sum;
				cur = a;
			}
			
			out.println("Case #" + (t+1) + ": " + ans);
		}
		out.flush();
	}
}
