import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
    	if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new Solution()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }
    
    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    public void run() {
    	int T = nextInt();
    	for (int tt = 0; tt < T; tt++) {
    		int n = nextInt();
    		String[] ss = new String[n];
    		for (int i = 0; i < n; i++) {
    			ss[i] = nextWord();
    		}
    		int[] arr = new int[n];
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < n; j++) {
    				if (ss[i].charAt(j) == '1') {
    					arr[i] = j;
    				}
    			}
    		}
    		
    		int[] pl = new int[n];
    		boolean[] used = new boolean[n];
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < n; j++) {
    				if (!used[j] && arr[j] <= i) {
    					pl[j] = i;
    					used[j] = true;
    					break;
    				}
    			}
    		}
    		int cnt = 0;
    		for (int i = 0; i < n; i++) {
    			for (int j = i+1; j < n; j++) {
    				if (pl[i] > pl[j]) {
    					cnt++;
    				}
    			}
    		}
    		
    		out.print("Case #");
    		out.print(tt+1);
    		out.print(": ");
    		out.println(cnt);
    	}
    	out.flush();
    }
}
