import java.lang.*;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class ProblemC implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
        if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter("out.txt");
        new Thread(new ProblemC()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }

    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }

    BigInteger s = new BigInteger("52360679774997896964091736687313");
    BigInteger d = new BigInteger("10000000000000000000000000000000");
    
    public void run() {
    	int u = nextInt();
    	for (int t = 0; t < u; t++) {
	    	int n = nextInt();
	    	BigInteger a = BigInteger.ONE; 
	    	for (int i = 0; i < n; i++) {
	    		a = a.multiply(s);
	    	}
	    	for (int i = 0; i < n; i++) {
	    		a = a.divide(d);
	    	}
	    	String ans = a.toString();
	    	if (ans.length() > 3) ans = ans.substring(ans.length()-3);
	    	else {
	    		if (ans.length() == 2) ans = "0"+ans;
	    		if (ans.length() == 1) ans = "00"+ans;
	    	}
	    	out.printf("Case #%d: %s\n", t+1, ans);
    	}
    	out.flush();
    }
}