import java.lang.*;
import java.io.*;
import java.util.*;

public class ProblemA implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
        if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter("out.txt");
        new Thread(new ProblemA()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }

    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }

    public void run() {
    	int u = nextInt();
    	for (int t = 0; t < u; t++) {
	    	int n = nextInt();
	    	int[] arr1 = new int[n];
	    	int[] arr2 = new int[n];
	    	for (int i = 0; i < n; i++) {
	    		arr1[i] = nextInt(); 
	    	}
	    	for (int i = 0; i < n; i++) {
	    		arr2[i] = nextInt(); 
	    	}
	    	Arrays.sort(arr1);
	    	Arrays.sort(arr2);
	    	long sum = 0;
	    	for (int i = 0; i < n; i++) {
	    		sum += arr1[i]*arr2[n-i-1];
	    	}
	    	out.printf("Case #%d: %d\n", t+1, sum);
    	}
    	out.flush();
    }
}
