import java.lang.*;
import java.io.*;
import java.util.*;

public class Problem implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
        if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter("out.txt");
        new Thread(new Problem()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }

    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }

    public void run() {
    	int t = nextInt();
    	for (int u = 0; u < t; u++) {
    		int ans = 0;
    		int n = nextInt();
    		HashMap<String, Integer> map = new HashMap<String, Integer>();
    		for (int i = 0; i < n; i++) {
    			map.put(nextLine(), i);
    		}
    		HashSet<Integer> set = new HashSet<Integer>();
    		int m = nextInt();
    		for (int i = 0; i < m; i++) {
    			String cur = nextLine();
    			set.add(map.get(cur));
    			if (set.size() == n) {
    				set.clear();
    				ans++;
    				set.add(map.get(cur));
    			}
    		}
    		out.print("Case #");
    		out.print(u+1);
    		out.print(": ");
    		out.println(ans);
    	}
        out.flush();
    }
}

