import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution implements Runnable{
    public static BufferedReader br;
    public static PrintWriter out;
    public static StringTokenizer stk;
    public static boolean isStream = false;

    public static void main(String[] args) throws IOException {
    	if (isStream) {
            br = new BufferedReader(new InputStreamReader(System.in));
        } else {
            br = new BufferedReader(new FileReader("in.txt"));
        }
        out = new PrintWriter(new File("out.txt"));
        new Thread(new Solution()).start();
    }

    public void loadLine() {
        try {
            stk = new StringTokenizer(br.readLine());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public String nextLine() {
        try {
            return br.readLine();
        } catch (IOException e) {
            e.printStackTrace();
            return "";
        }
    }

    public String nextWord() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return stk.nextToken();
    }

    public Integer nextInt() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Integer.valueOf(stk.nextToken());
    }

    public Long nextLong() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Long.valueOf(stk.nextToken());
    }

    public Double nextDouble() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Double.valueOf(stk.nextToken());
    }
    
    public Float nextFloat() {
        while (stk==null||!stk.hasMoreTokens()) loadLine();
        return Float.valueOf(stk.nextToken());
    }
    
    public void run() {
    	int N = nextInt();
    	String p = "welcome to code jam";
    	int M = 10000;
    	for (int l = 0; l < N; l++) {
    		String s = nextLine();
    		int n = s.length();
    		int pn = p.length();
    		int[][] dp = new int[n+1][pn+1];
    		dp[0][0] = 1;
    		for (int i = 0; i < n; i++) {
    			for (int j = 0; j < pn; j++) {
    				if (p.charAt(j) == s.charAt(i)) {
    					dp[i+1][j+1] += dp[i][j]; 
    					dp[i+1][j+1] %= M;
    				}
    				dp[i+1][j] += dp[i][j];
    				dp[i+1][j] %= M;
    			}
    		}
    		int ans = 0;
    		for (int i = 0; i <= n; i++) {
    			ans = (ans+dp[i][pn])%M;
    		}
    		out.print("Case #");
    		out.print(l+1);
    		out.print(": ");
    		String aa = Integer.toString(ans);
    		while (aa.length() < 4) aa = "0"+aa;
    		out.println(aa);
    	}
    	out.flush();
    }
}
