import java.lang.*;
import java.math.BigInteger;
import java.io.*;
import java.util.*;

public class Solution {
	public static BufferedReader br;
	public static PrintWriter out;
	public static StringTokenizer stk;

	// ///////////////// TO CHANGE ///////////////////////////
	public static boolean isServer = false;

	// ///////////////// TO CHANGE ///////////////////////////

	public static void main(String[] args) throws IOException {
		if (isServer) {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(System.out);
		} else {
			br = new BufferedReader(new FileReader("in.txt"));
			out = new PrintWriter(new File("out.txt"));
		}

		(new Solution()).run();
	}

	public void loadLine() {
		try {
			stk = new StringTokenizer(br.readLine());
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public String nextLine() {
		try {
			return br.readLine();
		} catch (IOException e) {
			e.printStackTrace();
			return "";
		}
	}

	public String nextWord() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return stk.nextToken();
	}

	public Integer nextInt() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Integer.valueOf(stk.nextToken());
	}

	public Long nextLong() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Long.valueOf(stk.nextToken());
	}

	public Double nextDouble() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Double.valueOf(stk.nextToken());
	}

	public Float nextFloat() {
		while (stk == null || !stk.hasMoreTokens())
			loadLine();
		return Float.valueOf(stk.nextToken());
	}
	
	public void run() {
		int tt = nextInt();
		for (int t = 0; t < tt; t++) {
			int n = nextInt();
			BigInteger[] arr = new BigInteger[n];
			for (int i = 0; i < n; i++) {
				arr[i] = new BigInteger(nextWord());
			}
			Arrays.sort(arr);
			BigInteger mul = arr[1].subtract(arr[0]); 
			for (int i = 2; i < n; i++) {
				BigInteger cur = arr[i].subtract(arr[i-1]);
				mul = mul.gcd(cur);
			}
			
			BigInteger ans = BigInteger.ZERO;
			if (!arr[0].mod(mul).equals(BigInteger.ZERO)) {
				ans = mul.subtract(arr[0].mod(mul));
			}
			
			out.println("Case #" + (t+1) + ": " + ans);
		}
		out.flush();
	}
}
