import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;

public class D implements Runnable {

	private PrintWriter out;
	
	final String file = "src\\D-small";
	
	static class InputData {
		class Trie {
			int nc, trie[][];
			Trie() {
				trie = new int[1000][26];
			}
			
			void clear() {
				for (int i = 0; i < 1000; i++)
					Arrays.fill(trie[i], -1);
				nc = 0;			
			}
			
			void insert(char[] s) {
				int node = 0;
				for (char ch : s) {
					if (trie[node][ch - 'A'] == -1) {
						trie[node][ch - 'A'] = ++nc;
					}
					node = trie[node][ch - 'A'];
				}
			}
		}

        int m, n, max, mc, s[];
        char[][] lines;
        Trie[] tries;
        
		InputData(FastReader in) throws IOException {
            m = in.nextInt();
            n = in.nextInt();
            lines = new char[m][];
            for (int i = 0; i < m; i++)
            	lines[i] = in.next().toCharArray();  
            tries = new Trie[n];
            for (int i = 0; i < n; i++)
            	tries[i] = new Trie();
		}
		
		void solve(PrintWriter out) {
			max = Integer.MIN_VALUE;
			s = new int[m];
			go(0);
			out.println(max + " " + mc);
		}

		private void go(int i) {
			if (i == m) {
				check();
				return;
			}
			for (int j = 0; j < n; j++) {
				s[i] = j;
				go(i + 1);
			}
		}

		private void check() {
			for (int i = 0; i < n; i++)
				tries[i].clear();
			for (int i = 0; i < m; i++)
				tries[s[i]].insert(lines[i]);
			int cmax = 0;
			for (int i = 0; i < n; i++) {
				if (tries[i].nc > 0)
					cmax = cmax + tries[i].nc + 1;
			}
			if (cmax > max) {
				max = cmax;
				mc = 1;
			} else if (cmax == max) {
				mc++;
			}
		}

	}
	
	static class Solver implements Callable<String> {

		InputData data;
		
		Solver(InputData data) {
			this.data = data;
		}

		@Override
		public String call() throws Exception {
			StringWriter out = new StringWriter();
			data.solve(new PrintWriter(out));
			return out.toString();
		}
		
	}

	public void run() {
		try {
			FastReader in = new FastReader(new BufferedReader(new FileReader(file + ".in")));
			out = new PrintWriter(file + ".out");
			
			ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(7);
			
			int tests = in.nextInt();
			Future<String>[] ts = new Future[tests];
			for (int test = 0; test < tests; ++test) {
				ts[test] = service.submit(new Solver(new InputData(in)));
			}
			for (int test = 0; test < tests; ++test) {
				while (!ts[test].isDone()) {
					Thread.sleep(500);
				}
				System.err.println("Test " + test);
				out.print("Case #" + (test + 1) + ": ");
				out.print(ts[test].get());
			}
			service.shutdown();
			
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	static class FastReader {
		public FastReader(BufferedReader in) {
			this.in = in;
			eat("");
		}
		
		private StringTokenizer st;
		private BufferedReader in;
		
		void eat(String s) {
			st = new StringTokenizer(s);
		}
		
		String next() throws IOException {
			while (!st.hasMoreTokens()) {
				String line = in.readLine();
				if (line == null) {
					return null;
				}
				eat(line);
			}
			return st.nextToken();
		}
		
		int nextInt() throws IOException {
			return Integer.parseInt(next());
		}
		
		long nextLong() throws IOException {
			return Long.parseLong(next());
		}
		
		double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}
	
	public static void main(String[] args) {
		long t = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new D().run();
		System.err.println(System.currentTimeMillis() - t);
	}
	
}
