import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;
import java.util.TreeSet;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;
import java.util.concurrent.ScheduledThreadPoolExecutor;

public class B implements Runnable {

	private PrintWriter out;
	
	final String file = "src\\B-small";

	static class InputData {
		
        int n, a[], res;
        
		InputData(FastReader in) throws IOException {
            n = in.nextInt();
            a = new int[n];
            for (int i = 0; i < n; i++)
            	a[i] = in.nextInt();
		}
		
		void solve(PrintWriter out) {
			res = Integer.MAX_VALUE;
			for (int i = 0; i < n; i++) {
				int[] arr = a.clone();
				for (int j = i; j > 0; j--) {
					int t = arr[j];
					arr[j] = arr[j - 1];
					arr[j - 1] = t;
				}
				go(0, true, i, arr);
			}
			//go(0, true, 0, a);
			out.println(res);
		}

		private void go(int i, boolean u, int c, int[] arr) {
			if (i == n) {
				int j = 0;
				while (j < n - 1 && arr[j] < arr[j + 1])
					j++;
				while (j < n - 1 && arr[j] > arr[j + 1])
					j++;
				if (j != n - 1)
					System.err.println("WA");
				res = Math.min(res, c);
				return;
			}
			if (u) {
				for (int j = i + 1; j < n; j++)
					if (arr[i] < arr[j]) {
						int[] arr2 = arr.clone();
						int cnt = 0;
						for (int k = j; k > i + 1; k--, cnt++) {
							int t = arr2[k];
							arr2[k] = arr2[k - 1];
							arr2[k - 1] = t;
						}
						go(i + 1, u, c + cnt, arr2);
					}
				go(i, false, c, arr);
			} else {
				int mp = -1;
				for (int j = i + 1; j < n; j++) {
					if (arr[i] < arr[j])
						return;
					if (mp == -1 || arr[mp] < arr[j])
						mp = j;
				}
				int[] arr2 = arr.clone();
				int cnt = 0;
				for (int k = mp; k > i + 1; k--, cnt++) {
					int t = arr2[k];
					arr2[k] = arr2[k - 1];
					arr2[k - 1] = t;
				}
				go(i + 1, u, c + cnt, arr2);
			}
		}

	}
	
	static class Solver implements Callable<String> {

		InputData data;
		
		Solver(InputData data) {
			this.data = data;
		}

		@Override
		public String call() throws Exception {
			StringWriter out = new StringWriter();
			data.solve(new PrintWriter(out));
			return out.toString();
		}
		
	}

	public void run() {
		try {
			FastReader in = new FastReader(new BufferedReader(new FileReader(file + ".in")));
			out = new PrintWriter(file + ".out");
			
			ScheduledThreadPoolExecutor service = new ScheduledThreadPoolExecutor(7);
			
			int tests = in.nextInt();
			Future<String>[] ts = new Future[tests];
			for (int test = 0; test < tests; ++test) {
				ts[test] = service.submit(new Solver(new InputData(in)));
			}
			for (int test = 0; test < tests; ++test) {
				while (!ts[test].isDone()) {
					Thread.sleep(500);
				}
				System.err.println("Test " + test);
				out.print("Case #" + (test + 1) + ": ");
				out.print(ts[test].get());
			}
			service.shutdown();
			
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	static class FastReader {
		public FastReader(BufferedReader in) {
			this.in = in;
			eat("");
		}
		
		private StringTokenizer st;
		private BufferedReader in;
		
		void eat(String s) {
			st = new StringTokenizer(s);
		}
		
		String next() throws IOException {
			while (!st.hasMoreTokens()) {
				String line = in.readLine();
				if (line == null) {
					return null;
				}
				eat(line);
			}
			return st.nextToken();
		}
		
		int nextInt() throws IOException {
			return Integer.parseInt(next());
		}
		
		long nextLong() throws IOException {
			return Long.parseLong(next());
		}
		
		double nextDouble() throws IOException {
			return Double.parseDouble(next());
		}
	}
	
	public static void main(String[] args) {
		long t = System.currentTimeMillis();
		Locale.setDefault(Locale.US);
		new B().run();
		System.err.println(System.currentTimeMillis() - t);
	}
	
}
