import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Locale;
import java.util.StringTokenizer;


public class A {
	public static void main(String[] args) throws Exception {
		new A().run();
	}
	
	public class Node {
		double weight;
		Node left;
		Node right;
		String feature;
		boolean hasFeature;
	}
	
	String[] tokens;
	int len, cur;
	HashSet<String> features;

	private void run() throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("a.in"));
		PrintWriter pw = new PrintWriter("a.out");
		int tc = Integer.parseInt(br.readLine().trim());
		features = new HashSet<String>();
		for (int cs = 1; cs <= tc; cs++) {
			StringBuilder sb = new StringBuilder();
			int lines = Integer.parseInt(br.readLine().trim());
			for (int i = 0; i < lines; i++) {
				sb.append(br.readLine());
				sb.append(' ');
			}
			StringTokenizer treeTokenizer = new StringTokenizer(sb.toString(), "() ");
			tokens = new String[treeTokenizer.countTokens()];
			len = 0;
			while (treeTokenizer.hasMoreTokens()) {
				tokens[len] = treeTokenizer.nextToken();
				//System.out.println(tokens[len]);
				len++;
			}
			cur = 0;
			Node root = readTree();
			int animals = Integer.parseInt(br.readLine().trim());
			pw.printf("Case #%d:\n", cs);
			for (int i = 0; i < animals; i++) {
				features.clear();
				String[] f = br.readLine().split(" +");
				int fc = Integer.parseInt(f[1]);
				for (int j = 0; j < fc; j++)
					features.add(f[j + 2]);
				double result = getResult(root, 1.0);
				//System.out.println(result);
				pw.printf(Locale.US, "%.7f\n", result);
			}
		}
		pw.close();
	}

	private double getResult(Node node, double p) {
		p *= node.weight;
		if (node.hasFeature) {
			if (features.contains(node.feature))
				return getResult(node.left, p);
			else
				return getResult(node.right, p);
		}
		return p;
	}

	private Node readTree() {
		Node result = new Node();
		result.weight = Double.parseDouble(tokens[cur++]);
		if (cur == len || Character.isDigit(tokens[cur].charAt(0))) {
			result.hasFeature = false;
			return result;
		}
		result.feature = tokens[cur++];
		result.hasFeature = true;
		result.left = readTree();
		result.right = readTree();
		return result;
	}
}