import java.io.*;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashMap;
import java.util.PriorityQueue;

public class Bathroom
{

	static Comparator<Long> maxFirst = new Comparator<Long>()
	{
		@Override
		public int compare(Long o1, Long o2)
		{
			if (o2 > o1)
			{
				return 1;
			}
			else if (o2 < o1)
			{
				return -1;
			}
			return 0;
		}
	};

	public static void main(String[] args) throws IOException
	{
//		BufferedReader f = new BufferedReader(new FileReader("test.in"));
		BufferedReader f = new BufferedReader(new FileReader("C-large.in"));

		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("bathroom.out")));

		int cases = Integer.parseInt(f.readLine());
		long start = System.nanoTime();

		for (long caseNo = 1; caseNo <= cases; caseNo++)
		{
			String[] theCase = f.readLine().split("\\s");
//			System.out.println(Arrays.toString(theCase));

			long k = Long.parseLong(theCase[0]);
			long n = Long.parseLong(theCase[1]);

			HashMap<Long, Long> hash = new HashMap<Long, Long>();
			hash.put(k, 1l);
			PriorityQueue<Long> sizes = new PriorityQueue<Long>(maxFirst);
			sizes.add(k);

			// cases * n(2log(n) + 1)

			for (long i = 0; i < n-1; i++)
			{
				long space = sizes.remove();
				long amount = hash.remove(space);

				if (i + amount > n - 1)
				{
					amount = n - 1 - i;
					sizes.add(space);
				}

				i += amount - 1;

				if ((space - 1) / 2 > 0)
				{
					Long already = hash.get((space - 1) / 2);
					hash.put((space - 1) / 2, amount + (already != null ? already : 0));
					if (!sizes.contains((space-1)/2))
					{
						sizes.add((space-1)/2);
					}
				}
				if ((space) / 2 > 0)
				{
					Long already = hash.get(space / 2);
					hash.put((space) / 2, amount + (already != null ? already : 0));
					if (!sizes.contains(space/2))
					{
						sizes.add(space/2);
					}
				}

//				System.out.println(hash1.toString());
			}

			long space = sizes.remove();

			String s = "Case #" + caseNo + ": " + (space/2) + " " + ((space-1)/2);
//			System.out.println(s);
			out.println(s);
			System.out.println((System.nanoTime() - start) / caseNo / 1000000000.0 * cases);
//			System.out.println("-----------------------");
		}

		out.close();
	}
}
