import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/*
 Tic-Tac-Toe-Tomek is a game played on a 4 x 4 square board. 
 The board starts empty, except that a single 'T' symbol may appear in one of the 16 squares. 
 There are two players: X and O. They take turns to make moves, with X starting. 
 'In each move a player puts her symbol in one of the empty squares. 
 Player X's symbol is 'X', and player O's symbol is 'O'.
 After a player's move, if there is a row, column or a diagonal containing 4 of that player's symbols, 
 or containing 3 of her symbols and the 'T' symbol, she wins and the game ends. 
 Otherwise the game continues with the other player's move. 
 If all of the fields are filled with symbols and nobody won, the game ends in a draw. See the sample input for examples of various winning positions.

 Given a 4 x 4 board description containing 'X', 'O', 'T' and '.' characters (where '.' represents an empty square), 
 describing the current state of a game, determine the status of the Tic-Tac-Toe-Tomek game going on. The statuses to choose from are:

 "X won" (the game is over, and X won)
 "O won" (the game is over, and O won)
 "Draw" (the game is over, and it ended in a draw)
 "Game has not completed" (the game is not over yet)

 If there are empty cells, and the game is not over, you should output "Game has not completed", even if the outcome of the game is inevitable.


 */
public class Main {

	public static void main(String[] args) {

		Scanner sc = null;
		PrintWriter out = null;

		try {
			sc = new Scanner(new FileReader("input3.txt"));
			out = new PrintWriter(new FileWriter(
					"C:\\Users\\M&M\\workspace\\Tic-Tac-Toe-Tomek\\output3.txt"));
		} catch (FileNotFoundException e) {
			System.out.println("File not found");
		} catch (IOException e) {
			e.printStackTrace();
			System.out.println("error");
		}

		int numberOfCases = sc.nextInt();
		sc.nextLine();
		int i = 0;
		System.out.println(numberOfCases);
		System.out.println();
		while (sc.hasNext()) {
			String fr = sc.nextLine();
			char[] firstRow = fr.toCharArray();
			// System.out.println(firstRow);

			String sr = sc.nextLine();
			char[] secondRow = sr.toCharArray();

			String tr = sc.nextLine();
			char[] thirdRow = tr.toCharArray();

			String foRo = sc.nextLine();
			char[] forthRow = foRo.toCharArray();

			char[] firstColumn = { firstRow[0], secondRow[0], thirdRow[0],
					forthRow[0] };
			char[] secondColumn = { firstRow[1], secondRow[1], thirdRow[1],
					forthRow[1] };
			char[] thirdColumn = { firstRow[2], secondRow[2], thirdRow[2],
					forthRow[2] };
			char[] forthColumn = { firstRow[3], secondRow[3], thirdRow[3],
					forthRow[3] };

			char[] diag1 = { firstRow[0], secondRow[1], thirdRow[2],
					forthRow[3] };
			char[] diag2 = { firstRow[3], secondRow[2], thirdRow[1],
					forthRow[0] };

			Case thisCase = new Case(firstRow, secondRow, thirdRow, forthRow,
					firstColumn, secondColumn, thirdColumn, forthColumn, diag1,
					diag2);
			thisCase.solve(i + 1, out);
//			int caseNr = i+1;
//			if (draw) {
//				out.println("Case #" + caseNr + ": Draw");
//			} else {
//				out.println("Case #" + caseNr + ": Game has not completed");
//			}
			if (sc.hasNext()) {
				sc.nextLine();
			}
			i++;
			// break;

		}
		out.close();
	}

}
