import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Solution {

	public static void main(String[] args) throws IOException {
		String file = "C-small-attempt4";
		Scanner sc = new Scanner(new FileReader(file + ".in"));
		PrintWriter out = new PrintWriter(new FileWriter(file + ".out"));

		int numOfCases = sc.nextInt(); 
		for(int testCase = 1; testCase <= numOfCases; testCase++) {
			//System.out.println("=================================");
			int pileSize = sc.nextInt();
			int[] pile = new int[pileSize];
			int[] pile1indices;
			int[] pile2indices;
			long SeanMaxPileSum = -1;
			boolean isPatrickCrying = true;
			
			for(int i = 0; i < pileSize; i++){
				pile[i] = sc.nextInt();
			}

			
			// for each group size
			for(int size = 1; size < pile.length; size++){
				//System.out.println("pile1size = "+size+", pile2size = "+(pile.length-size));
				CombinationGenerator x = new CombinationGenerator (pile.length, size);
				
				while (x.hasMore ()) {
					pile1indices = x.getNext ();
				  	pile2indices = x.getComplementSet(pile1indices);
				  
				  	
				  	int PatrickPile1Sum = getPatrickSum(pile1indices,pile);
				  	int PatrickPile2Sum = getPatrickSum(pile2indices,pile);
				  	
				  	
				  	if (PatrickPile1Sum == PatrickPile2Sum){
				  		long SeanPile1Sum = getSeanSum(pile1indices, pile);
				  		long SeanPile2Sum = getSeanSum(pile2indices, pile);
				  		
				  		if (SeanPile1Sum >= SeanPile2Sum && SeanPile1Sum > SeanMaxPileSum){
				  			SeanMaxPileSum = SeanPile1Sum;
				  		}
				  		else if (SeanPile2Sum >= SeanPile1Sum && SeanPile2Sum > SeanMaxPileSum){
				  			SeanMaxPileSum = SeanPile2Sum;
				  		}
				  		
				  		isPatrickCrying = false;
				  	}
				  	
				  	
//					System.out.print("Pile1: ");
//					for(int i = 0 ; i < pile1indices.length; i++){
//						System.out.print(pile[pile1indices[i]]+" ");
//					}
//					System.out.print("Pile2: ");
//					for(int i = 0 ; i < pile2indices.length; i++){
//						System.out.print(pile[pile2indices[i]]+" ");
//					}
//					System.out.println();
				  
				}
				
			}
			if (isPatrickCrying){
				//System.out.println("Case #"+testCase+": NO");
				out.println("Case #"+testCase+": NO");
			}
			else{
				//System.out.println("Case #"+testCase+": "+SeanMaxPileSum);
				out.println("Case #"+testCase+": "+SeanMaxPileSum);
			}
		}
		
		out.close();
		System.exit(0);
	}

	private static long getSeanSum(int[] indices, int[] pile) {
		long ret = 0;
		for(int i = 0; i < indices.length; i++){
			ret += pile[indices[i]];
		}
		return ret;
	}

	private static int getPatrickSum(int[] indices, int[] pile) {
		int ret = pile[indices[0]];
		for(int i = 1; i < indices.length; i++){
			ret ^= pile[indices[i]];
		}
		return ret;
	}
}
