package com.artyom.contest.codejam.y2013.round1c;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.SortedMap;
import java.util.TreeMap;

public class CTheGreatWall {
	
	public int getNumAttacks(List<Tribe> tribes) {
		SortedMap<Integer, List<Tribe>> days = new TreeMap<Integer, List<Tribe>>();
		for (Tribe tribe : tribes) {
			for (int i = 0; i < tribe.n; i++) {
				int day = tribe.d + i * tribe.deltaD;
				if (days.get(day) == null) {
					days.put(day, new LinkedList<Tribe>());
				}
				days.get(day).add(tribe);
			}
		}
		
		int[] wall = new int[1000];
		int count = 0;
		for (Map.Entry<Integer, List<Tribe>> day : days.entrySet()) {
			int[] wallCopy = wall.clone();
			for (Tribe tribe : day.getValue()) {
				int n = (day.getKey() - tribe.d) / tribe.deltaD;
				boolean success = false;
				for (int point = tribe.points[0] + n * tribe.deltaP; point < tribe.points[1] + n * tribe.deltaP; point++) {
					if (tribe.s > wall[point + 500]) {
						count++;
						success = true;
						break;
					}
				}
				if (success) {
					for (int point = tribe.points[0] + n * tribe.deltaP; point < tribe.points[1] + n * tribe.deltaP; point++) {
						wallCopy[point + 500] = Math.max(wallCopy[point + 500], tribe.s);
					}
					tribe.s += tribe.deltaS;
				} else tribe.s -= tribe.deltaS;
			}
			wall = wallCopy;
		}
		return count;
	}
	
	public static class Tribe {
		public int d;
		public int n;
		public int[] points;
		public int s;
		public int deltaD;
		public int deltaP;
		public int deltaS;
		public Tribe(int d, int n, int[] points, int s, int deltaD, int deltaP, int deltaS) {
			this.d = d;
			this.n = n;
			this.points = points;
			this.s = s;
			this.deltaD = deltaD;
			this.deltaP = deltaP;
			this.deltaS = deltaS;
		}
	}
	
	public static void main(String[] args) {
		if (args.length != 2) {
			System.err.println("Arguments: input_file output_file");
			System.exit(1);
		}
		
		Scanner input = null;
		PrintWriter output = null;
		try {
			input = new Scanner(new FileReader(args[0]));
			output = new PrintWriter(new BufferedWriter(new FileWriter(args[1])));
			int t = Integer.parseInt(input.nextLine());
			for (int i = 1; i <= t; i++) {
				int N = Integer.parseInt(input.nextLine());
				List<Tribe> tribes = new LinkedList<Tribe>();
				for (int j = 0; j < N; j++) {
					String[] tokens = input.nextLine().split(" ");
					int d = Integer.parseInt(tokens[0]);
					int n = Integer.parseInt(tokens[1]);
					int[] points = new int[] { Integer.parseInt(tokens[2]), Integer.parseInt(tokens[3]) };
					int s = Integer.parseInt(tokens[4]);
					int deltaD = Integer.parseInt(tokens[5]);
					int deltaP = Integer.parseInt(tokens[6]);
					int deltaS = Integer.parseInt(tokens[7]);
					tribes.add(new Tribe(d, n, points, s, deltaD, deltaP, deltaS));
				}
				String out = String.format("Case #%s: %s", i, new CTheGreatWall().getNumAttacks(tribes));
				System.out.println(out);
				output.println(out);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			input.close();
			output.close();
		}
	}
}
