package com.artyom.contest.codejam.y2013.round1c;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class AConsonants {
	
	public BigInteger getNValue(String name, int n) {
		BigInteger val = BigInteger.ZERO;
		for (int b = 0, e = n, bp = -1; e <= name.length(); b++, e++) {
			String sub = name.substring(b, e);
			if (!sub.contains("a") && !sub.contains("e") && !sub.contains("i") && !sub.contains("o") && !sub.contains("u")) {
				val = val.add(BigInteger.valueOf(b).subtract(BigInteger.valueOf(bp)).multiply(BigInteger.valueOf(name.length() - e + 1)));
				bp = b;
			}
		}
		return val;
	}
	
	public static void main(String[] args) {
		if (args.length != 2) {
			System.err.println("Arguments: input_file output_file");
			System.exit(1);
		}
		
		Scanner input = null;
		PrintWriter output = null;
		try {
			input = new Scanner(new FileReader(args[0]));
			output = new PrintWriter(new BufferedWriter(new FileWriter(args[1])));
			int t = Integer.parseInt(input.nextLine());
			for (int i = 1; i <= t; i++) {
				String[] tokens = input.nextLine().split(" ");
				int n = Integer.parseInt(tokens[1]);
				String out = String.format("Case #%s: %s", i, new AConsonants().getNValue(tokens[0], n));
				System.out.println(out);
				output.println(out);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			input.close();
			output.close();
		}
	}
}
