import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class MagicTrick {
	public Set<Integer> getNum(int a1, int[][] b1, int a2, int[][] b2) {
		final Set<Integer> ans1 = new HashSet<>(), ans2 = new HashSet<>();
		for (int n : b1[a1 - 1]) ans1.add(n);
		for (int n : b2[a2 - 1]) ans2.add(n);
		ans1.retainAll(ans2);
		return ans1;
	}
	public static void main(String[] args) {
		try (final Scanner in = new Scanner(System.in)) {
			final int t = Integer.parseInt(in.nextLine());
			for (int i = 1; i <= t; i++) {
				final int a1 = Integer.parseInt(in.nextLine());
				final int[][] b1 = readBoard(in);
				final int a2 = Integer.parseInt(in.nextLine());
				final int[][] b2 = readBoard(in);
				final Set<Integer> ans = new MagicTrick().getNum(a1, b1, a2, b2);
				System.out.printf(
						"Case #%s: %s%n",
						i,
						ans.size() == 1 ?
								ans.iterator().next() : ans.isEmpty() ?
										"Volunteer cheated!" : "Bad magician!"
						);
			}
		}
	}
	private static int[][] readBoard(Scanner in) {
		int[][] board = new int[4][4];
		for (int l = 0; l < 4; l++) {
			String[] toks = in.nextLine().split(" ");
			for (int c = 0; c < 4; c++) {
				board[l][c] = Integer.parseInt(toks[c]);
			}
		}
		return board;
	}
}