import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Minesweeper {
	public String isPossible(final int r, final int c, final int m) {
		String row = "";
		for (int i = 0; i < c; i++) row += '*';
		final List<String> board = new ArrayList<>();
		for (int i = 0; i < r; i++) board.add(row);
		int rr = -1, cc = -1; // "rectangle" to uncover
		boolean flag = false; // uncover column by column?
		final int e = r * c - m;
		if (m == 0) { // uncover everything
			rr = r;
			cc = c;
		} else if (e == 1) { // uncover only one cell?
			rr = 1;
			cc = 1;
		} else if (r == 1 || c == 1) { // board has only one row or only one column?
			rr = Math.min(r, e);
			cc = Math.min(c, e);
		} else {
			boolean found = false;
			for (int rrr = 2; rrr <= r && !found; rrr++) {
				final int ccc = (e + rrr - 1) / rrr;
				if (ccc > 1 && ccc <= c && (rrr * ccc == e || (e / ccc > 1 && e % ccc > 1))) {
					rr = rrr;
					cc = ccc;
					found = true;
					break;
				}
			}
			for (int ccc = 2; ccc <= c && !found; ccc++) {
				final int rrr = (e + ccc - 1) / ccc;
				if (rrr > 1 && rrr <= r && (rrr * ccc == e || (e / rrr > 1 && e % rrr > 1))) {
					rr = rrr;
					cc = ccc;
					found = true;
					flag = true;
					break;
				}
			}
		}
		if (rr == -1 && cc == -1) return String.format("%n%s", "Impossible");
		else { // do uncovering
			for (int rrr = 0; rrr < rr && !flag; rrr++) {
				String rrow = "";
				for (int ccc = 0; ccc < cc && rrr * cc + ccc < e; ccc++) rrow += '.';
				for (int rem = rrow.length(); rem < c; rem++) rrow += '*';
				board.set(rrr, rrow);
			}
			for (int ccc = 0; ccc < cc && flag; ccc++) {
				for (int rrr = 0; rrr < rr && ccc * rr + rrr < e; rrr++) {
					board.set(rrr, board.get(rrr).substring(0, ccc) + '.' + board.get(rrr).substring(ccc + 1));
				}
				
			}
			board.set(0, 'c' + board.get(0).substring(1)); // always shoot first cell
			String ret = "";
			for (String rrow : board) ret += String.format("%n%s", rrow);
			return ret;
		}
	}
	public static void main(final String[] args) {
		try (final Scanner in = new Scanner(System.in)) {
			final int t = Integer.parseInt(in.nextLine());
			for (int i = 1; i <= t; i++) {
				final String[] toks = in.nextLine().split(" ");
				final int r = Integer.parseInt(toks[0]);
				final int c = Integer.parseInt(toks[1]);
				final int m = Integer.parseInt(toks[2]);
				System.out.printf("Case #%s: %s%n", i, new Minesweeper().isPossible(r, c, m));
			}
		}
	}
}
