package com.artyom.contest.codejam.y2013.round1b;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

public class AOsmos {
	
	public int getMin(int a, List<Integer> motes) {
		if (a == 1) return motes.size();
		Collections.sort(motes);
		int add = 0;
		int max = motes.size();
		while (true) {
			for (Iterator<Integer> it = motes.iterator(); it.hasNext(); ) {
				int mote = it.next();
				if (a > mote) {
					a += mote;
					it.remove();
				} else break;
			}
			if (motes.size() == 0) return add;
			max = Math.min(max, add + motes.size());
			int toAdd = 0;
			while (a <= motes.get(0)) {
				a += a - 1;
				toAdd++;
			}
			if (add + toAdd >= max) return max;
			add += toAdd;
		}
	}
	
	public static void main(String[] args) {
		if (args.length != 2) {
			System.err.println("Arguments: input_file output_file");
			System.exit(1);
		}
		
		Scanner input = null;
		PrintWriter output = null;
		try {
			input = new Scanner(new FileReader(args[0]));
			output = new PrintWriter(new BufferedWriter(new FileWriter(args[1])));
			int t = Integer.parseInt(input.nextLine());
			for (int i = 1; i <= t; i++) {
				String[] tokens = input.nextLine().split(" ");
				int a = Integer.parseInt(tokens[0]);
				int n = Integer.parseInt(tokens[1]);
				tokens = input.nextLine().split(" ");
				List<Integer> motes = new ArrayList<Integer>();
				for (int j = 0; j < n; j++) {
					motes.add(Integer.parseInt(tokens[j]));
				}
				String out = String.format("Case #%s: %s", i, new AOsmos().getMin(a, motes));
				System.out.println(out);
				output.println(out);
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			input.close();
			output.close();
		}
	}
}
