import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

public class UpAndDown {
	public int minMoves(int[] array) {
		int n = array.length;
		Queue<Pair> q = new LinkedList<>();
		q.add(new Pair(array, 0));
		while (!q.isEmpty()) {
			Pair pair = q.remove();
			if (isUpAndDown(pair.array)) return pair.num;
			array = pair.array;
			for (int i = 1; i < n - 1; i++) {
				if (array[i] < array[i - 1] && array[i] < array[i + 1]) {
					int[] array1 = array.clone();
					swap(array1, i - 1, i);
					q.add(new Pair(array1, pair.num + 1));
					int[] array2 = array.clone();
					swap(array2, i + 1, i);
					q.add(new Pair(array2, pair.num + 1));
					break;
				}
			}
		}
		return -1;
	}
	private static class Pair {
		public final int[] array;
		public final int num;
		public Pair(int[] array, int num) {
			this.array = array;
			this.num = num;
		}
	}
	private static boolean isUpAndDown(int[] array) {
		boolean switched = false;
		for (int i = 1; i < array.length; i++) {
			if (!switched && array[i - 1] > array[i]) switched = true;
			else if (switched && array[i - 1] < array[i]) return false;
		}
		return true;
	}
	private static void swap(int[] array, int i, int j) {
		int temp = array[i];
		array[i] = array[j];
		array[j] = temp;
	}
	/*public int minMoves(int[] array) {
		int n = array.length;
		int min = Integer.MAX_VALUE;
		for (int i = n; i >= 0; i--) {
			int[] array1 = new int[i];
			for (int j = 0; j < i; j++) array1[j] = array[j];
			int[] array2 = new int[n - i];
			for (int j = 0; j < n - i; j++) array2[j] = array[n - 1 - j];
			min = Math.min(min, bubbleSort(array1) + bubbleSort(array2));
		}
		return min;
	}
	private static int bubbleSort(int[] array) {
		int n = array.length;
		int count = 0;
		boolean done;
		do {
			done = true;
			for (int i = 1; i < n; i++) {
				if (array[i] < array[i - 1]) {
					done = false;
					int t = array[i];
					array[i] = array[i - 1];
					array[i - 1] = t;
					count++;
				}
			}
			n--;
		} while (!done);
		return count;
	}*/

	public static void main(String[] args) {
		try (Scanner in = new Scanner(System.in)) {
			int t = in.nextInt();
			for (int i = 1; i <= t; i++) {
				int n = in.nextInt();
				int[] array = new int[n];
				for (int j = 0; j < n; j++) array[j] = in.nextInt();
				System.out.printf("Case #%s: %s%n", i, new UpAndDown().minMoves(array));
			}
		}
	}
}
