import java.util.*;
import java.io.*;
public class Main {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
		in.nextLine();
		for (int x = 1; x <= t; ++x) 
		{
			int n = in.nextInt();
			int k = in.nextInt();
			//System.out.println("case " + x + ": k: " + k + "; n: " + n);

			MaxHeap m = new MaxHeap(k);
			m.insert(n);

			//m.show();
			int max_slot, min, max;
			for(int i=0; i<k-1; i++){
				max_slot = m.pop();
				min = (max_slot-1) / 2;
				max = max_slot % 2 == 0 ? min + 1: min;
				m.insert(min);
				m.insert(max);

				//m.show();

			}


			max_slot = m.pop();
			min = (max_slot-1) / 2;
			max = max_slot % 2 == 0 ? min + 1: min;

			//System.out.println(x + " max_slot : " + max_slot);

			System.out.println("Case #" + x + ": " + max + " " + min);
		}

	}

	static class MaxHeap{
		int[] heap;
		final int root = 1;
		int idx = 1;

		MaxHeap(int k){
			heap = new int[k+1];
		}

		void insert(int v){
			//System.out.println("insert " + v);
			heap[idx] = v;
			idx++;
			siftup(idx-1);
		}

		int pop(){
			int ret = heap[root];
			//System.out.println("pop " + ret);

			heap[root] = heap[idx-1];
			idx--;
			siftdown();

			return ret;
		}

		void siftup(int i){
			//int count = 0;
			while(i != root && heap[p(i)] < heap[i]){
				swap(i, p(i));
				i = p(i);
				/*
				System.out.print("siftup " + count + ": ");
				show();
				count++;
				*/
			}
		}

		void siftdown(){
			//int count = 0;
			int i=root;
			while(lc(i) < idx){
				int child = lc(i);
				if(rc(i) < idx)
					child = heap[lc(i)] > heap[rc(i)] ? lc(i) : rc(i);

				if(heap[i] > heap[child])
					return;

				swap(child, i);
				i = child;
				/*
				System.out.print("siftdown " + count + ": ");
				show();
				count++;
				*/
			}
		}

		int p(int c){ return c / 2; }
		int lc(int p){ return 2 * p; }
		int rc(int p){ return 2 * p + 1; }

		void swap(int a, int b){
			int tmp = heap[a];
			heap[a] = heap[b];
			heap[b] = tmp;
		}

		void show(){
			System.out.printf("[ ");
			for(int i=1; i<idx; i++){
				System.out.printf("%d ", heap[i]);
			}
			System.out.printf("]\n");
		}

	}

}

