package com.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BathroomStalls {

	private static Integer N = null;

	public static void main(String[] args) {
		try (BufferedReader br = new BufferedReader(
				new FileReader(new File("/home/arungz/Drive/Workspace/Eclipse_Workspace/GoogleCodeJam/C-small-1-attempt0.in")));
				BufferedWriter bw = new BufferedWriter(new FileWriter(
						new File("/home/arungz/Drive/Workspace/Eclipse_Workspace/GoogleCodeJam/output.txt")));) {
			Integer count = Integer.parseInt(br.readLine());
			for (int c = 1; c <= count; c++) {
				bw.write("Case #" + c + ": ");
				String[] input = br.readLine().split(" ");
				N = Integer.parseInt(input[0]);
				Integer K = Integer.parseInt(input[1]);

				// Preparing the list containing the status of the Stalls -
				// Start
				List<Boolean> lst = new ArrayList<Boolean>();
				lst.add(true);
				for (int i = 0; i < N; i++) {
					lst.add(false);
				}
				lst.add(true);
				// Preparing the list containing the status of the Stalls - End

				for (int i = 0; i < K; i++) {
					Map<Integer, Integer> leftMap = new HashMap<Integer, Integer>();
					Map<Integer, Integer> rightMap = new HashMap<Integer, Integer>();
					// For each and every stall compute Min(L,R) and Max(L,R)
					for (int j = 1; j <= N; j++) {
						if (!lst.get(j)) {
							leftMap.put(j, Math.min(getLeftMost(lst, j), getRightMost(lst, j)));
							rightMap.put(j, Math.max(getLeftMost(lst, j), getRightMost(lst, j)));
						}
					}

					// Choosing max from the minMap
					Map<Integer, Integer> minMap1 = getMaxMap(leftMap);
					int stall = 0;
					if (minMap1.size() > 1) {
						// Choosing the max from MaxMap
						Map<Integer, Integer> maxMapTemp = getNewMap(minMap1, rightMap);
						Map<Integer, Integer> maxMap1 = getMaxMap(maxMapTemp);
						if (maxMap1.size() > 1) {
							// Choose the leftmost seat;
							stall = Collections.min(maxMap1.keySet());
							lst.set(stall, true);
						} else {
							// Its the seat
							for (Integer key : maxMap1.keySet()) {
								stall = key;
								lst.set(key, true);
							}
						}
					} else {
						// Its the seat
						for (Integer key : minMap1.keySet()) {
							stall = key;
							lst.set(key, true);
						}
					}

					System.out.println(lst);
					if (i == K - 1) {
						int min = 0;
						for (int b = stall-1; b > 0; b--) {
							if (!lst.get(b)) {
								min += 1;
							} else {
								break;
							}
						}
						int max = 0;
						for (int b = stall+1; b < N+1; b++) {
							if (!lst.get(b)) {
								max += 1;
							} else {
								break;
							}
						}
						System.out.println(max + " " + min);
						bw.write(max + " " + min);
					}
				}
				bw.write("\n");
				bw.flush();
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			System.out.println("Complete");
		}

	}

	private static int getLeftMost(List<Boolean> lst, int index) {
		int retVal = 0;
		for (int i = index - 1; i >= 0; i--) {
			if (!lst.get(i)) {
				retVal += 1;
			} else {
				break;
			}
		}
		return retVal;
	}

	private static int getRightMost(List<Boolean> lst, int index) {
		int retVal = 0;
		for (int i = index + 1; i <= N + 1; i++) {
			if (!lst.get(i)) {
				retVal += 1;
			} else {
				break;
			}
		}
		return retVal;
	}

	private static Map<Integer, Integer> getMaxMap(Map<Integer, Integer> minMap) {
		Map<Integer, Integer> retMap = new HashMap<Integer, Integer>();
		int max = 0;
		for (Integer key : minMap.keySet()) {
			if (minMap.get(key) > max) {
				max = minMap.get(key);
			}
		}

		for (Integer key : minMap.keySet()) {
			if (minMap.get(key) == max) {
				retMap.put(key, max);
			}
		}

		return retMap;
	}
	
	private static Map<Integer, Integer> getNewMap(Map<Integer, Integer> leftMap, Map<Integer, Integer> rightMap) {
		Map<Integer, Integer> retMap = new HashMap<Integer, Integer>();
		for(Integer key : leftMap.keySet()) {
			retMap.put(key, rightMap.get(key));
		}
			
		return retMap;
	}

}
