package com.google.CodeJam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class CoinJam {
	public static void main(String[] args) {
		BufferedReader br = null;
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader(new File("/home/arung/Workspaces/CordovaWorkSpace/GoogleCodeJam/input.txt")));
			bw = new BufferedWriter(new FileWriter(new File("/home/arung/Workspaces/CordovaWorkSpace/GoogleCodeJam/output.txt")));
			Long noOfCases = Long.parseLong(br.readLine());

			for(int t=1; t<= noOfCases; t++) {
				bw.write("Case #" +t + ":" + "\n");
				String[] inp = br.readLine().split(" ");
				int legthOfJamCoin = Integer.parseInt(inp[0]);
				int noOfOutput = Integer.parseInt(inp[1]);
				String jamCoin = formJamCoin(legthOfJamCoin);
				int count=0;
				while(true) {
					if(isJamCoin(jamCoin)) {
						String val= findNonTrivialVal(jamCoin);
						if(!("fal".equals(val))) {
							count++;
							System.out.println(count+":"+val);
							bw.write(jamCoin +" "+ val +"\n");
							bw.flush();
						} else {
							System.out.println("Exception");
						}
						
					}
					String tempVal = String.valueOf(Long.parseLong(jamCoin, 2) + Long.parseLong("10", 2));
					jamCoin=String.valueOf(Long.toString(Long.parseLong(tempVal, 10), 2));
					
					if(count == noOfOutput || jamCoin.length()>legthOfJamCoin) {
						break;
					}
					
				}
			}
		} catch(Exception e) {
			e.printStackTrace();
		} finally {
			if(br != null) {
				try {
					br.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			if(bw!=null){
				try {
					bw.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
			}
			System.out.println("Completed");
		}
	}
	
	private static boolean isJamCoin(String jamCoin) {
		boolean retVal = true;

		for (int i = 2; i <= 10; i++) {
			try {
				Long num = Long.parseLong(jamCoin, i);
				if (isPrime(num)) {
					return false;
				}
			} catch (Exception e) {
				return false;
			}
		}
		return retVal;
	}
	
	private static boolean isPrime(Long num) {
		boolean retVal = true;
		for(int i=2; i<num; i++) {
			if(num %i == 0) {
				retVal = false;
				break;
			}
		}
		return retVal;
	}
	
	private static String formJamCoin(int length) {
		StringBuffer jamCoin = new StringBuffer();
		for(int i=0; i<length; i++) {
			if(i == 0 || i == length-1) {
				jamCoin.append("1");
			} else {
				jamCoin.append("0");
			}
		}
		return jamCoin.toString();
	}
	
	private static String findNonTrivialVal(String jamCoin){
		StringBuffer retVal = new StringBuffer();
		try{
			for (int i = 2; i <= 10; i++) {
				Long num = Long.parseLong(jamCoin, i);
				if(num == -1) {
					return "fal";
				}
				for (int j = 2; j <= num /2; j++) {
					if (num % j == 0) {
						if(j == -1) {
							return "fal";
						}
						retVal.append(j);
						if (i != 10) {
							retVal.append(" ");
						}
						break;
					}
				}
			}
		} catch(Exception e) {
			return "fal";
		}
		return retVal.toString();
	}
}
