import java.util.*;

class radius implements Comparable<radius> {

	public int r;
	public int rank;

	public radius(int a, int b) {
		r = a;
		rank = b;
	}

	public int compareTo(radius other) {
		return this.r - other.r;
	}
}

public class b2 {

	public static void main(String[] args) {

		Scanner stdin = new Scanner(System.in);

		int T = stdin.nextInt();

		for (int loop=1; loop<=T; loop++) {

			int N, W, L;
			N = stdin.nextInt();
			W = stdin.nextInt();
			L = stdin.nextInt();

			radius[] r = new radius[N];
			for (int i=0; i<N; i++) {
				int thisr = stdin.nextInt();
				r[i] = new radius(thisr, i);
			}

			Arrays.sort(r);
			for (int i=0; i<N/2; i++) {
				radius temp = r[i];
				r[i] = r[N-1-i];
				r[N-1-i] = temp;
			}

			solve(loop, N, W, L, r);
		}

	}

	public static void solve(int casenum, int N, int W, int L, radius[] r) {

		double[] x = new double[N];
		double[] y = new double[N];
		Arrays.fill(x, -1);
		Arrays.fill(y, -1);

		// Do down first row.
		int row = 0;
		int index = 0;
		double tryval = 0; // edge of last circle
		double curY = 0;
		int lastradius = -1;
		for (row = 0; index < N; row++) {

			if (row == 0) {
				x[0] = 0;
				y[0] = 0;
				tryval = r[0].r;
				index = 1;
				lastradius = r[0].r;
			}
			else {
				curY = curY + lastradius + r[index].r;
				lastradius = r[index].r;
				x[index] = 0;
				y[index] = curY;
				tryval = r[index].r;
				index++;
			}

			while (index < N && tryval + r[index].r <= W) {
				x[index] = tryval + r[index].r;
				y[index] = curY;
				tryval = x[index] + r[index].r;
				index++;
			}
		}


		System.out.printf("Case #%d: ", casenum);
		for (int i=0; i<N; i++) {
			for (int j=0; j<N; j++) {
				if (r[j].rank == i) {
					System.out.printf("%f %f ", x[j], y[j]);
					break;
				}
			}
		}
		System.out.printf("\n");

	}

}