import java.util.*;

public class b {

	final public static int NOT_FOUND = -1;

	public static void main(String[] args) {

		Scanner stdin = new Scanner(System.in);
		int n = stdin.nextInt();

		for (int loop=1; loop<=n; loop++) {

			int numR = stdin.nextInt();
			int numC = stdin.nextInt();

			int[][] grid = new int[numR][numC];
			for (int i=0; i<grid.length; i++)
				for (int j=0; j<grid[i].length; j++)
					grid[i][j] = stdin.nextInt();

			System.out.println("Case #"+loop+": "+solve(grid));
		}

	}

	public static String solve(int[][] grid) {

		int[] maxRow = new int[grid.length];
		int[] maxCol = new int[grid[0].length];

		// Set up max values in each row and column.
		for (int i=0; i<grid.length; i++)
			maxRow[i] = getMaxRow(grid, i);
		for (int i=0; i<grid[0].length; i++)
			maxCol[i] = getMaxCol(grid, i);

		int[][] lawn = new int[grid.length][grid[0].length];
		for (int i=0; i<lawn.length; i++)
			Arrays.fill(lawn[i], 101);

		for (int i=0; i<grid.length; i++)
			cutRow(lawn, i, maxRow[i]);
		for (int i=0; i<grid[0].length; i++)
			cutCol(lawn, i, maxCol[i]);

		if (equal(lawn, grid))
			return "YES";
		else
			return "NO";
	}

	public static void print(int[][] a) {

		for (int i=0; i<a.length; i++) {
			for (int j=0; j<a[0].length; j++)
				System.out.print(a[i][j]+" ");
			System.out.println();
		}
	}

	public static boolean equal(int[][] a, int[][] b) {

		if (a.length != b.length || a[0].length != b[0].length) return false;

		for (int i=0; i<a.length; i++)
			for (int j=0; j<a[0].length; j++)
				if (a[i][j] != b[i][j])
					return false;

		return true;
	}

	public static void cutRow(int[][] lawn, int row, int level) {
		for (int i=0; i<lawn[row].length; i++)
			lawn[row][i] = Math.min(lawn[row][i], level);
	}

	public static void cutCol(int[][] lawn, int col, int level) {
		for (int i=0; i<lawn.length; i++)
			lawn[i][col] = Math.min(lawn[i][col], level);
	}

	public static int getMaxRow(int[][] grid, int row) {
		int ans = grid[row][0];
		for (int i=0; i<grid[row].length; i++)
			if (grid[row][i] > ans)
				ans = grid[row][i];
		return ans;
	}

	public static int getMaxCol(int[][] grid, int col) {
		int ans = grid[0][col];
		for (int i=0; i<grid.length; i++)
			if (grid[i][col] > ans)
					ans = grid[i][col];
		return ans;
	}

	public static boolean sameRow(int[][] grid, int row) {
		int ref = grid[row][0];
		for (int i=1; i<grid[row].length; i++)
			if (grid[row][i] != ref)
				return false;
		return true;
	}

	public static boolean sameCol(int[][] grid, int col) {
		int ref = grid[0][col];
		for (int i=1; i<grid.length; i++)
			if (grid[i][col] != ref)
				return false;
		return true;
	}
}