import java.util.*;

public class c {

	public static int W;
	public static int H;

	public static void main(String[] args) {

		Scanner stdin = new Scanner(System.in);
		int numCases = stdin.nextInt();

		for (int loop = 1; loop<=numCases; loop++) {

			W = stdin.nextInt();
			H = stdin.nextInt();
			int n = stdin.nextInt();
			boolean[][] grid = new boolean[W][H];
			for (int i=0; i<n; i++) {
				int sx = stdin.nextInt();
				int sy = stdin.nextInt();
				int ex = stdin.nextInt();
				int ey = stdin.nextInt();

				// True means can't go there.
				for (int j=sx; j<=ex; j++)
					for (int k=sy; k<=ey; k++)
						grid[j][k] = true;
			}

			System.out.println("Case #"+loop+": "+solve(grid));
		}
	}

	public static int solve(boolean[][] grid) {
		int cnt = 0;
		for (int i=0; i<grid.length; i++) {
			if (bfs(grid,i,0)) cnt++;
		}
		return cnt;
	}

	public static boolean inbounds(int x, int y) {
		return x >= 0 && x < W && y >= 0 && y < H;
	}

	public static boolean[][] copy(boolean[][] a) {
		boolean[][] ans = new boolean[W][H];
		for (int i=0; i<W; i++)
			for (int j=0; j<H; j++)
				ans[i][j] = a[i][j];
		return ans;
	}

	public static boolean bfs(boolean[][] grid, int x, int y) {



		// Can't start.
		if (grid[x][y]) return false;

		boolean[][] cp = copy(grid);

		LinkedList<Integer> callStack = new LinkedList<Integer>();
		callStack.push(1000*x+y);
		grid[x][y] = true;

		while (callStack.size() > 0) {

			int cur = callStack.peek();
			int curx = cur/1000;
			int cury = cur%1000;

			if (cury == grid[0].length-1) return true;

			if (inbounds(curx-1,cury) && !grid[curx-1][cury]) {
				callStack.push(1000*(curx-1)+cury);
				grid[curx-1][cury] = true;
			}
			else if (inbounds(curx,cury+1) && !grid[curx][cury+1]) {
				callStack.push(1000*(curx)+cury+1);
				grid[curx][cury+1]  = true;
			}
			else if (inbounds(curx+1,cury) && !grid[curx+1][cury]) {
				callStack.push(1000*(curx+1)+cury+1);
				grid[curx+1][cury] = true;
			}
			else if (inbounds(curx,cury-1) && !grid[curx][cury-1]) {
				callStack.push(1000*(curx+1)+cury-1);
				grid[curx][cury-1] = true;
			}
			else
				callStack.pop();

		}

		for (int i=0; i<W; i++)
			for (int j=0; j<H; j++)
				grid[i][j] = cp[i][j];

		return false;
	}
}