import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.util.Scanner;


public class Problem1
{

	static PrintWriter writer;
	static String inputFile = "D:/Study/GeeksForGeeks/Code_Room/src/input.txt";
	static String outputFile = "D:/Study/GeeksForGeeks/Code_Room/src/outputNew.txt";
	static int splTime;
	public static void main(String[] args) 
	{
		BufferedReader br = null;
		try {
			Scanner scIn = new Scanner(new File(inputFile));
			writer = new PrintWriter(outputFile, "UTF-8");
			int noOfTestCases = scIn.nextInt();
			for(int caseNo=1;caseNo<=noOfTestCases;caseNo++)
			{
				long totalDistance = scIn.nextLong();
				int noOfHorses = scIn.nextInt();
				long distance[] = new long[noOfHorses];
				double speed[] =  new double[noOfHorses];
				for(int horseNo =noOfHorses-1;horseNo>=0;horseNo--)
				{
					long dist = scIn.nextLong();
					double spd = scIn.nextInt();
					distance[horseNo]=dist;
					speed[horseNo]= spd;
				}
				
				double ans = findSolution(totalDistance,noOfHorses,distance,speed);
				System.out.println("Case #" + caseNo+": "+ans);
				writer.println("Case #" + caseNo+": "+ans);
			}
			writer.close();

		} catch (IOException e) 
		{
			e.printStackTrace();
		} finally 
		{
			try {
				if (br != null)br.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}

	}
	
	private static double findSolution(long totalDist, int noOfHorses, long[] distance, double[] speed)
	{
		double time[] = new double[noOfHorses];
		
		int lastHorse = noOfHorses-1;
		double tt =  (totalDist-distance[lastHorse]) / speed[lastHorse];
		 time[lastHorse] = tt ;
		for(int horseNo = lastHorse-1;horseNo>=0;horseNo--)
		{
			long distDiff = distance[horseNo+1] - distance[horseNo]; 
			double speedDiff = speed[horseNo]- speed[horseNo+1];
			
			if(speedDiff<0)
			{
				time[horseNo]= (totalDist-distance[horseNo])/speed[horseNo];
				continue;
			}
			
			double time1 = distDiff/speedDiff;
			double time2 = (totalDist-distance[horseNo])/speed[horseNo];
			
			double exactTime = 0.0;
			
			if(time1>time2)
			{
				exactTime = time2;
			}else
			{
				
				exactTime = time[horseNo+1];
			}
			
			time[horseNo]= exactTime;
			
		}
		
		DecimalFormat dformat = new DecimalFormat("0.000000");
		dformat.setMaximumFractionDigits(6);
				
		String val = dformat.format(totalDist/time[0]);
		
		double annieSpeed = Double.valueOf(val);
		
		return annieSpeed;
	}

	

}
