import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class PanCakeNew
{

	static PrintWriter writer;
	static String inputFile = "D:/Study/GeeksForGeeks/Code_Room/src/input.txt";
	static String outputFile = "D:/Study/GeeksForGeeks/Code_Room/src/outputNew.txt";
	static int splTime;
	public static void main(String[] args) 
	{
		BufferedReader br = null;
		try {
			Scanner scIn = new Scanner(new File(inputFile));
			writer = new PrintWriter(outputFile, "UTF-8");
			int noOfTestCases = scIn.nextInt();
			for(int caseNo=1;caseNo<=noOfTestCases;caseNo++)
			{				
				String inputStr = scIn.next();
				int k = scIn.nextInt();
				
				String ans = findSolution(inputStr,k);
				writer.println("Case #" + caseNo+": "+ans);
			}
			writer.close();

		} catch (IOException e) 
		{
			e.printStackTrace();
		} finally 
		{
			try {
				if (br != null)br.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}

	}
	
	private static String findSolution(String inputStr,int k)
	{
		char[] input = inputStr.toCharArray();
		
		boolean isChanged=true;
		int flipCount = 0;
		while(!isDone(input) && isChanged)
		{
			isChanged = false;
			for(int i=0;i<input.length;i++)
			{
				char []subStr = getSubStr(input, i, k);
				if(subStr!=null)
				{
					if(fullPattern(subStr))
					{
						input = flip(input, i, k);
						isChanged= true;
						flipCount++;
						break;
					}
					
					if(endPattern(subStr) || reverseMidPattern(subStr))
					{
						input = flip(input, i, k);
						isChanged= true;
						flipCount++;
						break;
					}
					
//					if(middPattern(subStr) && validMidPattern(input, i, k))
//					{
//						input = flip(input, i, k);
//						isChanged= true;
//						flipCount++;
//						break;
//					}
//					
//					if(halfPattern(subStr) || reverseMidPattern(subStr) || endPattern(subStr))
//					{
//						input = flip(input, i, k);
//						isChanged= true;
//						flipCount++;
//						break;
//					}
					
				}
			}
			
		}
		
		if(isDone(input))
		{
			return String.valueOf(flipCount);
		}
		else
			return "IMPOSSIBLE";
		
		
	}
	
	
	private static char[] getSubStr(char[] input,int start,int size)
	{
		char [] subStr = new char[size];
		int i=0;
		while(i<size && start <input.length)
		{
			subStr[i] = input[start];
			i++;start++;
		}
		
		if(i==size)
		{
			return subStr;
		}
		
		return null;
				
	}
	
	private static char[] flip(char[] input,int start,int size)
	{
		int i=0;
		while(i<size)
		{
			if(input[start] == '-')
			{
				input[start]='+';
			}else
				input[start]='-';
			
			i++;start++;
		}
		
		return input;
	}
	
	private static boolean endPattern(char[] input)
	{
		int i =0;
	
		boolean hasMinus = false;
		while(i<input.length && input[i]=='-')
		{
			hasMinus = true;
			i++;
		}
		
		if(!hasMinus)
			return false;
		
		if(i==input.length)
			return false;
		
		
		
		while(i<input.length && input[i]=='+')
		{
			i++;
		}
		
		if(i==input.length)
			return true;
	
		return false;
	}
	
	private static boolean validEndPattern(char[] input,int start,int k)
	{
		int i =0;
		int j=start;
		while(input[j]=='-')
		{
			i++;j++;
		}
		
		j=start+k;
		
		while(j<input.length && input[j]=='-' && i!=0)
		{
			i--;
			j++;
		}
		
		if(i==0)
			return true;
	
		return false;
	}
	
	private static boolean middPattern(char[] input)
	{
		
		int i =0;
		while(i<input.length && input[i]=='+')
		{
			i++;
		}
		
		if(i==input.length)
			return false;
		
		boolean hasMinus = false;
		while(i<input.length && input[i]=='-')
		{
			hasMinus=true;
			i++;
		}
		
		if(!hasMinus)
			return false;
		
		if(i==input.length)
			return false;
	
		while(i<input.length && input[i]=='+')
		{
			i++;
		}
		
		if(i==input.length)
			return true;
		
		return false;
	}
	
	private static boolean validMidPattern(char[] input,int start,int k)
	{
		int i =0;
		int j=start;
		while(input[j]=='+')
		{
			i++;j++;
		}
		
		j=start-1;
		i = k-i;
		
		while(j>=0 && input[j]=='-' && i!=0)
		{
			i--;
			j--;
		}
		
		if(i!=0)
			return false;
	
		i =0;
		j=start+k-1;
		while(input[j]=='+')
		{
			i++;j--;
		}
		
		j=start+k;
		i = k-i;
		
		while(j<input.length && input[j]=='-' && i!=0)
		{
			i--;
			j++;
		}
		
		if(i==0)
			return true;
		
		return false;
	}
	
	
	private static boolean fullPattern(char[] input)
	{
		int i =0;
		while(i<input.length && input[i]=='-')
		{
			i++;
		}
		
		if(i==input.length)
			return true;
		
		return false;
	}
	
	private static boolean halfPattern(char[] input)
	{
		int i =0;
		while(i<input.length && input[i]=='-')
		{
			i++;
		}
		
		if(i==input.length/2)
			return true;
		
		return false;
	}
	
	private static boolean reverseMidPattern(char[] input)
	{
			
			int i =0;
			boolean hasMinus = false;
			while(i<input.length && input[i]=='-')
			{
				hasMinus = true;
				i++;
			}
			
			if(!hasMinus)
				return false;
			
			if(i==input.length)
				return false;
			
			
			while(i<input.length && input[i]=='+')
			{
				i++;
			}
			
			
			if(i==input.length)
				return false;
		
			hasMinus = false;
			while(i<input.length && input[i]=='-')
			{
				hasMinus = true;
				i++;
			}
			
			if(!hasMinus)
				return false;
			
			if(i==input.length)
				return true;
			
			return false;
		
	}
		
	private static boolean isDone(char[] input)
	{
		int i =0;
		while(i<input.length && input[i]=='+')
		{
			i++;
		}
		
		if(i==input.length)
			return true;
		
		return false;
	}
	

}
