package welcomeToCodeJam;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class C {
	final static String welcome = "welcome to code jam";
	final static String welcomeReversed = "maj edoc ot emoclew";
	
	private int combinations[] = null;
	private String testCase;
	
	
	public C(String testCase) {
		this.testCase = testCase;
		combinations = new int[testCase.length()];
		for (int index = 0; index<testCase.length(); index++) {
			combinations[index] = 1;
		}
	}
	
	public int getMaches() {
		for (char c : welcomeReversed.toCharArray()) {
			findCharsAndSpread(c);	
		}
		return combinations[0];
	}

	
	private void findCharsAndSpread(char aChar) {
		for (int index = 0; index<testCase.length(); index++) {
			if (testCase.charAt(index) != aChar) {
				combinations[index] = 0;
			}
		}
		
		int soFar = 0;
		for (int reverse = testCase.length()-1; reverse >= 0; reverse--) {
			if (combinations[reverse] != 0) {
				soFar += combinations[reverse];
				soFar = soFar % 10000;
			}
			combinations[reverse] = soFar;
		}
	}

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		String fileName = "C-small-attempt0";
		String inFile = fileName + ".in";
		String outFile = fileName + ".out";
		Scanner scanner = new Scanner(new File(inFile));
		PrintStream ps = new PrintStream(outFile);
		
		int N = scanner.nextInt(); // cases (patterns)
		scanner.nextLine();
		
		for (int caseNumber = 1; caseNumber <= N ; caseNumber++) {
			C testCase = new C(scanner.nextLine());
			int maches = testCase.getMaches();
			ps.println("Case #" + caseNumber + ": " + String.format("%04d", maches));
		}
	}
}
