import java.io.BufferedReader;
import java.io.FileReader;
import java.util.HashMap;


public class WaterSheads {

    public static void main(String[] args) {
        String str;
        int rows,cols;
        BufferedReader in;
        int nTestCases;
        try {
            in = new BufferedReader(new FileReader("/home/sandeep/codejam/input.txt"));            
            str = in.readLine();
            nTestCases = Integer.parseInt(str);
            
            for(int i=0; i < nTestCases; ++i)
            {
                str = in.readLine();
                String[] arr = str.split(" ");
                rows = Integer.parseInt(arr[0]);
                cols = Integer.parseInt(arr[1]);
                int[][] matrix = new int[rows][cols];
                
                for(int j=0; j < rows; ++j)
                {
                    str = in.readLine();
                    arr = str.split(" ");
                    for(int k = 0; k <cols; ++k)
                    {
                        matrix[j][k] = Integer.parseInt(arr[k]);
                    }
                }
                char[][] Labels = getLabels(matrix,rows,cols);   
                System.out.println("Case #"+(i +1)+":");
                for(int p = 0; p< rows; p++)
                {
                    for(int q=0; q < cols;q++)
                        System.out.print(Labels[p][q]+ ( (q==(cols-1)) ? "":" "));
                    System.out.println("");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static char[][] getLabels(int[][] matrix, int rows, int cols) {
        char[][] labels = new char[rows] [cols];
        
        HashMap<Integer,Integer> eqclasses = new HashMap<Integer, Integer>();
        for(int i=0; i< rows; ++i)
        {
            for(int j=0;j<cols;++j)
            {
                int curPosition = (i*cols)+j;
                int basinPosition = getBasin(matrix,i,j,rows,cols);
                
                if(basinPosition != -1) //if not a sink
                {
                    Integer eqclass = null;
                    if(eqclasses.containsKey(basinPosition))
                    {
                        eqclass = eqclasses.get(basinPosition);                        
                    }
                    if(eqclasses.containsKey(curPosition))
                    {
                        eqclass = eqclasses.get(curPosition);
                    }
                    if(eqclass == null)
                    {
                        eqclass = new Integer(getNextEqNumber());
                    }
                    eqclasses.put(basinPosition, eqclass);
                    eqclasses.put(curPosition, eqclass);
                    
                }
                else {
                    if(!eqclasses.containsKey(curPosition))
                    {
                        eqclasses.put(curPosition, new Integer(getNextEqNumber()) );
                    }
                }
            }
        }  
        
        HashMap<Integer,Character> labelMap = new HashMap<Integer, Character>();
        char label = 'a';
        for(int i=0; i< rows; ++i)
        {
            for(int j=0;j<cols;++j)
            {                
                Integer key;
                key = eqclasses.get(i*cols+j);
                if(!labelMap.containsKey(key))
                {
                    labelMap.put(key, label);
                    label++;                    
                }
                labels[i][j] = labelMap.get(key);                
            }
        }
        return labels;
    }

    private static int getBasin(int[][] matrix, int i, int j, int rows, int cols) {
        int pos = -1;
        int minvalue = matrix[i][j];
        //north
        if(i != 0)
        {
            if(matrix[i-1][j] < minvalue)
            {
                pos = (i-1)*cols+j;
                minvalue = matrix[i-1][j];
            }
        }
        //west
        if(j!=0)
        {
            if(matrix[i][j-1] < minvalue)
            {
                pos = i*cols+(j-1);
                minvalue = matrix[i][j-1]; 
            }
        }
        //east
        if(j < (cols - 1))
        {
            if(matrix[i][j+1] < minvalue)
            {
                pos = i*cols+(j+1);
                minvalue = matrix[i][j+1]; 
            }
        }
        
        //south
        if(i < (rows - 1))
        {
            if(matrix[i+1][j] < minvalue)
            {
                pos = (i+1)*cols+j;
                minvalue = matrix[i+1][j];
            }
        }
        
        return pos;
    }

    private static int getNextEqNumber() {
        return ++counter;
    }
    static int counter = 0;

}
