import java.util.HashMap;


public class Node {
    HashMap<Character,Node> children = new HashMap<Character, Node>();
    
    public Node addChild(char ch)
    {
        Node tree = new Node();
        this.children.put(new Character(ch), tree);  
        return tree;
    }
    
    public int getCount(String[] token)
    {
        if(token.length == 0)
            return 1;
        
        String[] subArray = new String[token.length - 1];
        for(int i=1; i < token.length; ++i)
        {
            subArray[i-1] = token[i];
        }
        
        int totalWordsFound = 0;
        for(int i =0; i < token[0].length(); ++i)
        {
            char ch = token[0].charAt(i);            
            
            if(children.containsKey(ch))
            {
                totalWordsFound += children.get(ch).getCount(subArray);
            }
        }
        
        return totalWordsFound;
        
    }

    public void constructTree(String word) {
        char ch = word.charAt(0);
        Node child;
        if(!children.containsKey(ch))
        {
            child = this.addChild(ch);
        }
        child = children.get(ch);
        if(word.length() > 1)
        {
            child.constructTree(word.substring(1));
        }
    }    

}
