import java.util.*;

/**
 * Created by andrew on 4/7/17.
 */
public class Pancake {
	static int c;
	static class Cake implements Comparable<Cake> {
		int tries;
		BitSet pancakes;

		public Cake(int tries, BitSet pancakes) {
			this.tries = tries;
			this.pancakes = pancakes;
		}

		@Override
		public int compareTo(Cake o) {
			if (tries < o.tries) {
				return -1;
			} else if (tries > o.tries) {
				return 1;
			} else {
				return 0;
			}
		}

		@Override
		public String toString() {
			StringBuilder a =  new StringBuilder();
			a.append("tries: ").append(tries).append(" pancakes: ");
			for (int i = 0; i < c; i++) {
				a.append(pancakes.get(i) ? "1" : "0");
			}

			return a.toString();
		}
	}

	static BitSet happy;

	static boolean isHappy(BitSet p) {
		return p.equals(happy);
	}

	public static void main(String args[]) {
		Scanner s = new Scanner(System.in);

		int n = s.nextInt();
		for (int $ = 1; $ <= n; $++) {
			String cakes = s.next();
			int k = s.nextInt();
			c = cakes.length();

			BitSet p = new BitSet(c);
			for (int i = 0; i < c; i++) {
				p.set(i, cakes.charAt(i) == '+');
			}

			happy = new BitSet(c);
			happy.flip(0, c);

			if (isHappy(p)) {
				System.out.println("Case #" + $ + ": 0");
				continue;
			}

			// bfs
			String ans = null;
			PriorityQueue<Cake> queue = new PriorityQueue<>();
			HashSet<BitSet> seen = new HashSet<>();
			queue.add(new Cake(0, p));
			seen.add(p);
			meow:
			while (!queue.isEmpty()) {
				Cake curr = queue.poll();

				// brute force
				for (int i = 0; i < c - k + 1; i++) {
					BitSet np = (BitSet) curr.pancakes.clone();
					np.flip(i, i + k);

					if (isHappy(np)) {
						ans = "" + (curr.tries + 1);
						break meow;
					} else {
						if (!seen.contains(np)) {
							seen.add(np);
							queue.add(new Cake(curr.tries + 1, np));
						}
					}
				}
			}

			if (ans == null) {
				ans = "IMPOSSIBLE";
			}

			System.out.println("Case #" + $ + ": " + ans);
		}
	}
}
