import java.io.*;
import java.util.Scanner;

public class ThemePark {
	public static void main(String[] args) {
		String inName = "C-small-attempt0.in";
		File file = new File(inName);
		int T; // Cases
		int R; // Times run
		int k; // Max Capacity per run
		int N; // Number of groups
		int[] G; // Array of group sizes. Size 2*N
		int[] myStuff; // Number of people/euros and next group index for each element of G. Size 2*N
		long moneyMade; // Total money made for each run.

		try {
			Scanner scanner = new Scanner(file);
			FileOutputStream fout = new FileOutputStream ("out.txt");
			PrintStream outToFile = new PrintStream(fout);
			
			// INIT
			T = scanner.nextInt();
			for(int t = 0; t < T; t++) {
				outToFile.print("Case #"+(t+1)+": ");
				
				R = scanner.nextInt();
				k = scanner.nextInt();
				N = scanner.nextInt();
				G = new int[2*N];
				myStuff = new int[2*N];
				moneyMade = 0;
				for (int g = 0; g < N; g++) { // Populate groups array
					G[g] = scanner.nextInt();
					G[g+N] = G[g];
				}
				for (int g = 0; g < N; g++) { // Populate myStuff array
					int gPlusN = g + N;
					int seatsLeft = k;
					int nextIndex = g;
					for (int i = g; i < gPlusN; i++) {
						int trySubtract = seatsLeft - G[i];
						if (trySubtract < 0) {
							nextIndex = i%N;
							i = gPlusN;
						} else {
							seatsLeft = trySubtract;
						}
					}
					myStuff[2*g] = k - seatsLeft; // Number of people/euros for a ride starting from group g
					myStuff[2*g+1] = nextIndex; // The group that starts first next round
				}
				int headOfQueue = 0;
				for (int r = 0; r < R; r++) { // Run the roller coaster R times
					moneyMade += myStuff[2*headOfQueue];
					headOfQueue = myStuff[2*headOfQueue+1];
				}
				outToFile.println(moneyMade);
			}
			
			fout.close();
			// END
		} catch (FileNotFoundException e) {
			System.out.println("problem1.");
		} catch (IOException e) {
			System.out.println("problem2.");
		}
	}
}
