import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.Scanner;


public class Main {

	private static String PROJECT = "B-small-attempt4";
	private static String PATH = "C:/Project/Asela/Personal/CodeJam";
	private static String IN_PATH = String.format("%s/%s.in", PATH, PROJECT);
	private static String OUT_PATH = String.format("%s/%s.out", PATH, PROJECT);;
	
	public static void main(String[] args) {
		writeFile(solve(readFile()));
	}
	
	public static Map<Integer, Integer> solve(List<String> list) {
		Map<Integer,Integer> solutions = new HashMap<>();

		Optional<String> numberOfTestCases = list.stream().findFirst();
		int testcases = Integer.parseInt(numberOfTestCases.get());

		String[] rowInputs = list.stream().skip(1).toArray(String[]::new);
		
		int testCaseNumber = 1;
		for (int i = 1; i < rowInputs.length; i+=2) {
			String input = rowInputs[i];
			System.out.println(input);
			int numberOfMinutes1 = 0;
			int numberOfMinutes2 = 0;
			
			String[] split = input.split(" ");
			
			List<Integer> paneCasesinPlates1 = new ArrayList<Integer>();
			List<Integer> paneCasesinPlates2 = new ArrayList<Integer>();
			for (String s : split) {
				paneCasesinPlates1.add(Integer.valueOf(s));
				paneCasesinPlates2.add(Integer.valueOf(s));
			}
			
			while(!paneCasesinPlates1.stream().allMatch(a -> a == 0)) {
				Integer max = paneCasesinPlates1.stream().max(Comparator.naturalOrder()).get();
				boolean once = true;
				System.out.println("Max: " + max);
				List<Integer> sm = new ArrayList<Integer>();
				for (Integer ij : paneCasesinPlates1) {
					if (max % 2 == 0 && max != 2) {
						if (ij == max && once) {
							sm.add(ij / 2);
							sm.add(ij / 2);
							once = false;
						} else {
							sm.add(ij);
						}
					} else {
						if (ij > 0) {
							sm.add(ij - 1);
						}
					}
				}
				paneCasesinPlates1 = sm;
				paneCasesinPlates1.stream().forEach(a -> System.out.printf("%s ",a));
				System.out.println();
				numberOfMinutes1++;
			}
			
			while(!paneCasesinPlates2.stream().allMatch(a -> a == 0)) {
				List<Integer> sm = new ArrayList<Integer>();
				for (Integer ij : paneCasesinPlates2) {
						if (ij > 0) {
							sm.add(ij - 1);
					}
				}
				paneCasesinPlates2 = sm;
				paneCasesinPlates2.stream().forEach(a -> System.out.printf("%s ",a));
				System.out.println();
				numberOfMinutes2++;
			}
			System.out.printf("%s:%s \n", testCaseNumber, numberOfMinutes1 < numberOfMinutes2 ? numberOfMinutes1: numberOfMinutes2);
			System.out.println("---");
			solutions.put(testCaseNumber++, numberOfMinutes1 < numberOfMinutes2 ? numberOfMinutes1: numberOfMinutes2 );
		}
		
		return solutions;
	}
	
	public static List<String> readFile() {
		List<String> list = new LinkedList<>();
		
		try(Scanner scanner = new Scanner(new File(IN_PATH))){
			while (scanner.hasNextLine()) {
				list.add(scanner.nextLine());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		//list.stream().forEach(System.out::println);
		
		return list;
	}
	
	public static void writeFile(Map<Integer, Integer> list) {
		try(PrintWriter write = new PrintWriter(new File(OUT_PATH))){
			list.forEach((a,b) -> write.printf("Case #%s: %s\n", a, b));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
}
