import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.Scanner;


public class Main {

	private static String PROJECT = "A-large";
	private static String PATH = "C:/Project/Asela/Personal/CodeJam";
	private static String IN_PATH = String.format("%s/%s.in", PATH, PROJECT);
	private static String OUT_PATH = String.format("%s/%s.out", PATH, PROJECT);;
	
	public static void main(String[] args) {
		writeFile(solve(readFile()));
	}
	
	public static Map<Integer, Integer> solve(List<String> list) {
		Map<Integer,Integer> solutions = new HashMap<>();

		Optional<String> numberOfTestCases = list.stream().findFirst();
		int testcases = Integer.parseInt(numberOfTestCases.get());

		String[] rowInputs = list.stream().skip(1).toArray(String[]::new);
		
		int testCaseNumber = 1;
		for (String input : rowInputs) {
			int numberOfPeopleInviting = 0;
			
			String[] split = input.split(" ");
			
			List<Integer> shynessString = new ArrayList<Integer>();
			for (char c : split[1].toCharArray()) {
				shynessString.add(Integer.valueOf(""+c));
			}
			int numberOfPeopleStanding = 0;
			int numberOfPeopleNeedToStand = 0;
			for (int c : shynessString) {
				int requiredStanders = numberOfPeopleNeedToStand - numberOfPeopleStanding;
				if(requiredStanders > 0){
					numberOfPeopleInviting += requiredStanders;
					numberOfPeopleStanding += requiredStanders;
				}				
				numberOfPeopleNeedToStand++;
				numberOfPeopleStanding += c;
			}
			
			solutions.put(testCaseNumber++, numberOfPeopleInviting);
		}
		
		return solutions;
	}
	
	public static List<String> readFile() {
		List<String> list = new LinkedList<>();
		
		try(Scanner scanner = new Scanner(new File(IN_PATH))){
			while (scanner.hasNextLine()) {
				list.add(scanner.nextLine());
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		//list.stream().forEach(System.out::println);
		
		return list;
	}
	
	public static void writeFile(Map<Integer, Integer> list) {
		try(PrintWriter write = new PrintWriter(new File(OUT_PATH))){
			list.forEach((a,b) -> write.printf("Case #%s: %s\n", a, b));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
}
