package c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.NumberFormat;

public class C
{
	public static final String PROBLEM_NO = "C";
	public static final String BASE_FOLDER = "C:\\Users\\Ash\\Ash\\Code Jam\\2016\\Input";
	public static final String FS = File.separator;
	
//	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.in";
//	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.out";
	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.in";
	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.out";
	public static final String LARGE_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.in";
	public static final String LARGE_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.out";
	
	public static void main(String[] args)
	{
		processFile(SMALL_IN_FILE, SMALL_OUT_FILE);
//		processFile(LARGE_IN_FILE, LARGE_OUT_FILE);
	}

	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) {
			String line = reader.readLine();
			String[] split = line.split(" ");
			int n = Integer.parseInt(split[0]);
			int j = Integer.parseInt(split[1]);
			writer.write("Case #" + caseNum + ":\n");
			
			NumberFormat nf = NumberFormat.getInstance();
			nf.setMinimumIntegerDigits(n-2);
			nf.setGroupingUsed(false);
			
			int validJamCoins = 0;
			// Find max values to try in base 10, will be n-2 because first and last are 1
			int max = (int)Math.pow(2, n-2); 			// int ok n = 16 or 32
			for (int c=0; c<max; c++) {
				String tmp = Integer.toString(c, 2);
				String jamCoin = "1" + nf.format(Integer.parseInt(tmp)) + "1";
				
				// Is the jam coin valid?
				// If you interpret the string in any base between 2 and 10,
				// inclusive, the resulting number is not prime.
				long[] coinInDiffBases = new long[9];
				for (int i=1; i<=9; i++) {
					coinInDiffBases[i-1] = Long.parseLong(jamCoin, i+1); 	
				}
				
				// Are all not prime?
				boolean primeFound = false;
				long[] nonTrivialDivisors = new long[9];
				for (int i=0; i<9; i++) {
					Long nonTrivialDivisor = getNonTrivialDivisor(coinInDiffBases[i]);
					if (nonTrivialDivisor == null) {
						primeFound = true;
						break;
					} else {
						nonTrivialDivisors[i] = nonTrivialDivisor;
					}
				}
				
				// If all not prime
				if (primeFound) {
					continue;
				} else {
					validJamCoins++;
					String coinAndDivisors = jamCoin;
					for (long nonTrivialDivisor : nonTrivialDivisors) {
						coinAndDivisors += " " + nonTrivialDivisor;	
					}
					writer.write(coinAndDivisors + "\n");
					if (validJamCoins >= j) {
						break;
					}
				}
			}
		}
	}
	
	private static Long getNonTrivialDivisor(long coin)
	{	
		// Only go up square root
		int limit = (int)Math.sqrt(coin);
		for (int i=2; i<=limit; i++) {
			if (coin % i == 0) {
				return coin/i;
			}
		}
		return null;
	}
}
