package b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class B
{
	public static final String PROBLEM_NO = "B";
	public static final String BASE_FOLDER = "C:\\Users\\Ash\\Ash\\Code Jam\\2015\\Input";
	public static final String FS = File.separator;
	
//	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.in";
//	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.out";
	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.in";
	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.out";
//	public static final String LARGE_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.in";
//	public static final String LARGE_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		processFile(SMALL_IN_FILE, SMALL_OUT_FILE);
//		processFile(LARGE_IN_FILE, LARGE_OUT_FILE);
	}
	
	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) {
			
			int nonEmptyDiners = Integer.parseInt(reader.readLine());
			List<Integer> numPancakesPerDiner = new ArrayList<Integer>(nonEmptyDiners);
			for (String split : reader.readLine().split(" ")) {
				numPancakesPerDiner.add(Integer.parseInt(split));
			}
			
			// Sort the list so the people with the most are at the end
			Collections.sort(numPancakesPerDiner);
			 
			int minsToFinish = 0;
			// Only split in half if there is someone with > 3 pancakes and then only if the bigger half is >= the next biggest stack
			while (numPancakesPerDiner.get(numPancakesPerDiner.size()-1) > 3) {
				if (numPancakesPerDiner.size() == 1) {
					minsToFinish++;
					int pancakes = numPancakesPerDiner.remove(numPancakesPerDiner.size()-1);
					// If a 9 split into 6 and 3
					if (pancakes == 9) {
						numPancakesPerDiner.add(3);
						numPancakesPerDiner.add(6);
					} else {
						// Split them in half
						int smallHalf = pancakes/2;
						int bigHalf = pancakes-smallHalf;
						numPancakesPerDiner.add(smallHalf);
						numPancakesPerDiner.add(bigHalf);
					}
					
				// Check if the bigger half is >= the next biggest stack
				} else {
					int pancakes = numPancakesPerDiner.remove(numPancakesPerDiner.size()-1);
					int secondBiggest = numPancakesPerDiner.get(numPancakesPerDiner.size()-1);
					// If a 9 split them in 6 and 3 if the next biggest is <= 3
					if (pancakes == 9 && secondBiggest <= 3)
					{
						numPancakesPerDiner.add(3);
						numPancakesPerDiner.add(6);
						minsToFinish++;
					// Otherwise go with the half approach
					} else {
						int smallHalf = pancakes/2;
						int bigHalf = pancakes-smallHalf;
						// Check against current largest
						if (bigHalf >= numPancakesPerDiner.get(numPancakesPerDiner.size()-1)) {
							numPancakesPerDiner.add(smallHalf);
							numPancakesPerDiner.add(bigHalf);
							minsToFinish++;
						} else {
							// Don't split and just let everyone eat
							numPancakesPerDiner.add(pancakes);
							break;
						}
					}
				}
			}
			
			// Add on the minutes for biggest stack to eat them all
			minsToFinish += numPancakesPerDiner.get(numPancakesPerDiner.size()-1);
			
			writer.write("Case #" + caseNum + ": " + minsToFinish + "\n");
		}
	}
}
