package c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class C
{
	public static final String PROBLEM_NO = "C";
	public static final String BASE_FOLDER = "C:\\Users\\Ash\\Ash\\Code Jam\\2015\\Input";
	public static final String FS = File.separator;
	
//	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.in";
//	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.out";
	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.in";
	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.out";
	public static final String LARGE_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.in";
	public static final String LARGE_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		processFile(SMALL_IN_FILE, SMALL_OUT_FILE);
//		processFile(LARGE_IN_FILE, LARGE_OUT_FILE);
	}
	
	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) {
			
			String line = reader.readLine();
			String[] split = line.split(" ");
			int L = Integer.parseInt(split[0]);
			int X = Integer.parseInt(split[1]);
			String testString = reader.readLine();
			StringBuilder sb = new StringBuilder();
			for (int i=0; i<X; i++)
			{
				sb.append(testString);
			}
			String test = sb.toString();
			
//			test = "jijijijijijijjijijijijijiji";
			
			test = processStartUntilChar(test, "i");
			if (!test.equals("FAIL")) {
				test = processStartUntilChar(test.substring(1), "j");
				if (!test.equals("FAIL")) {
					test = processStartUntilChar(test.substring(1), "k");
					if (!test.equals("FAIL")) {
						// Can we reduce the remainder to 1
						if (test.equals("k")) {
							writer.write("Case #" + caseNum + ": " + "YES" + "\n");
						} else {
							if (remainderReducesTo1(test.substring(1))) {
								writer.write("Case #" + caseNum + ": " + "YES" + "\n");
							} else {
								writer.write("Case #" + caseNum + ": " + "NO" + "\n");
							}
						}
					} else {
						writer.write("Case #" + caseNum + ": " + "NO" + "\n");
					}
				} else {
					writer.write("Case #" + caseNum + ": " + "NO" + "\n");
				}
			} else {
				writer.write("Case #" + caseNum + ": " + "NO" + "\n");
			}
		}
	}
	
	private static String processStartUntilChar(String test, String charToStopAt)
	{
		while (!test.startsWith(charToStopAt)) {
			int i=0;
			// No first char
			if (i >= test.length()) {
				return "FAIL";
			}
			
			char t1 = test.charAt(i++);
			boolean t1Neg = false;
			if (t1 == '-') {
				t1Neg = true;
				t1 = test.charAt(i++);
			}
			
			// No second char
			if (i >= test.length()) {
				return "FAIL";
			}
				
			char t2 = test.charAt(i++);
			boolean t2Neg = false;
			if (t2 == '-') {
				t2Neg = true;
				t2 = test.charAt(i++);
			}
			
			String newT = op(t1, t2);
			boolean newTStartsDash = newT.startsWith("-");
			if ((t1Neg && !t2Neg) || (!t1Neg && t2Neg)) {
				if (newTStartsDash) {
					newT = newT.substring(1);
				} else {
					newT = "-" + newT;
				}
			}
			if (newT.endsWith("1")) {
				newT = newT.substring(0, newT.length()-1);
			}
			test = newT + test.substring(i);
			
			 if (test.equals("-")) {
				 return "FAIL";
			}
		}
		return test;
	}
	
	private static boolean remainderReducesTo1(String test)
	{
		boolean isEmpty = test.isEmpty();
		while (!isEmpty) {
			int i=0;
			// No first char
			if (i >= test.length()) {
				return false;
			}
			
			char t1 = test.charAt(i++);
			boolean t1Neg = false;
			if (t1 == '-') {
				t1Neg = true;
				t1 = test.charAt(i++);
			}
			
			// No second char
			if (i >= test.length()) {
				return false;
			}
				
			char t2 = test.charAt(i++);
			boolean t2Neg = false;
			if (t2 == '-') {
				t2Neg = true;
				t2 = test.charAt(i++);
			}
			
			String newT = op(t1, t2);
			boolean newTStartsDash = newT.startsWith("-");
			if ((t1Neg && !t2Neg) || (!t1Neg && t2Neg)) {
				if (newTStartsDash) {
					newT = newT.substring(1);
				} else {
					newT = "-" + newT;
				}
			}
			if (newT.endsWith("1")) {
				newT = newT.substring(0, newT.length()-1);
			}
			test = newT + test.substring(i);
			
			isEmpty = test.isEmpty();
			if (isEmpty ) {
				return true;
			} else if (test.equals("-")) {
				return false;
			}
				
		}
		return true;
	}

	private static String op(char t1, char t2)
	{
		if (t1 == 'i') {
			if (t2 == 'i') {
				return "-1";
			} else if (t2 == 'j') {
				return "k";
			} else if (t2 == 'k') {
				return "-j";
			}
		} else if (t1 == 'j') {
			if (t2 == 'i') {
				return "-k";
			} else if (t2 == 'j') {
				return "-1";
			} else if (t2 == 'k') {
				return "i";
			}
		} else if (t1 == 'k') {
			if (t2 == 'i') {
				return "j";
			} else if (t2 == 'j') {
				return "-i";
			} else if (t2 == 'k') {
				return "-1";
			}
		}
		return "";
	}
}
