package a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Set;
import java.util.TreeSet;

public class A
{
	public static final String PROBLEM_NO = "A";
	public static final String BASE_FOLDER = "C:\\Users\\Ash\\Ash\\Code Jam\\2016\\Input";
	public static final String FS = File.separator;
	
//	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.in";
//	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.out";
	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.in";
	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.out";
	public static final String LARGE_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.in";
	public static final String LARGE_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.out";
	
	public static void main(String[] args)
	{
//		processFile(SMALL_IN_FILE, SMALL_OUT_FILE);
		processFile(LARGE_IN_FILE, LARGE_OUT_FILE);
	}
	
	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) {
			Set<Integer> numbers = new TreeSet<Integer>(Arrays.asList(new Integer[] {0, 1, 2, 3, 4, 5, 6, 7, 8, 9}));
			int  n = Integer.parseInt(reader.readLine());
			
			if (n == 0) {
				writer.write("Case #" + caseNum + ": " + "INSOMNIA" + "\n");
			} else {
				int multiplier = 0;
				int value = n;
				while (!numbers.isEmpty() && multiplier < 100000) {
					multiplier++;
					value = n * multiplier;
					while (value > 0) {
						int tmp = value % 10;
						value = value/10;
						numbers.remove(tmp);
					}
				}
				
				writer.write("Case #" + caseNum + ": " + (n * multiplier) + "\n");
			}
		}
	}
}
