package a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class A {

	public static final String PROBLEM_NO = "A";
	public static final String BASE_FOLDER = "C:\\Users\\Ash\\Ash\\Code Jam\\2015\\Input";
	public static final String FS = File.separator;
	
	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.in";
	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt0.out";
	public static final String LARGE_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.in";
	public static final String LARGE_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
//		processFile(SMALL_IN_FILE, SMALL_OUT_FILE);
		processFile(LARGE_IN_FILE, LARGE_OUT_FILE);
	}
	
	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) {
			
			String line = reader.readLine();
			String[] split = line.split(" ");
			int maxShyness = Integer.parseInt(split[0]);
			int[] numPplWithShyness = new int[maxShyness+1];
			for (int i=0; i<split[1].length(); i++)
			{
				numPplWithShyness[i] = Character.getNumericValue(split[1].charAt(i));
			}
			
			// Find how many needed
			int numFriendsInvited = 0;
			int peopleStanding = 0;
			for (int i=0; i<=maxShyness; i++)
			{
				// while people standing < i+1, add a friend
				peopleStanding += numPplWithShyness[i];
				while (peopleStanding < i+1) {
					numFriendsInvited++;
					peopleStanding++;
				}
			}
			
			writer.write("Case #" + caseNum + ": " + numFriendsInvited + "\n");
		}
	}

}
