package b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class B
{
	public static final String PROBLEM_NO = "B";
	public static final String BASE_FOLDER = "C:\\Users\\Ash\\Ash\\Code Jam\\2016\\Input";
	public static final String FS = File.separator;
	
//	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.in";
//	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-ash.out";
	public static final String SMALL_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt2.in";
	public static final String SMALL_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-small-attempt2.out";
	public static final String LARGE_IN_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.in";
	public static final String LARGE_OUT_FILE = BASE_FOLDER + FS + PROBLEM_NO + FS + PROBLEM_NO + "-large.out";
	
	public static void main(String[] args)
	{
		processFile(SMALL_IN_FILE, SMALL_OUT_FILE);
//		processFile(LARGE_IN_FILE, LARGE_OUT_FILE);
	}
	
	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) {
			String stack = reader.readLine();
			int numFlips = findNumFlips(stack);
			writer.write("Case #" + caseNum + ": " + numFlips + "\n");
		}
	}
	
	private static int findNumFlips(String stack)
	{
		int numFlips = 0;
		// Work towards getting all as + or -
		for (int i=stack.length()-1; i>=0; i--) {
			if (stack.charAt(i) != '+') {
				// Check the top one is the opposite before flipping
				if (stack.charAt(0) == '+') {
					// If top not the opposite, flip as many at the start that are not the same
					int numToFlip = stack.indexOf('-')-1;
					stack = flip(stack, numToFlip);
					numFlips++;
				}
				stack = flip(stack, i);
				numFlips++;
			}
		}
		return numFlips;
	}

	private static String flip(String stack, int i)
	{
		String stackToFlip = stack.substring(0, i+1);
		String bottomOfStack = stack.substring(i+1);
		// Reverse and negate
		stackToFlip = new StringBuilder(stackToFlip).reverse().toString();
		stackToFlip = stackToFlip.replaceAll("\\-", "a");
		stackToFlip = stackToFlip.replaceAll("\\+", "-");
		return stackToFlip.replaceAll("a", "+") + bottomOfStack;
	}
}
