package q1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

public class Question1 {

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		processFile("C:\\Users\\Ash\\Ash\\Code Jam\\Input\\Q1\\A-small-attempt0.in", "C:\\Users\\Ash\\Ash\\Code Jam\\Input\\Q1\\A-small-attempt0.out");
	}
	
	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) {
			
			Integer[][] arrangement1 = new Integer[4][4];
			int answer1 = Integer.parseInt(reader.readLine());
			arrangement1 = readArrangement(reader);
			
			Integer[][] arrangement2 = new Integer[4][4];
			int answer2 = Integer.parseInt(reader.readLine());
			arrangement2 = readArrangement(reader);
			
			Set<Integer> selectedRow1 = new TreeSet<Integer>();
			for (int i=0; i<4; i++) {
				selectedRow1.add(arrangement1[answer1-1][i]);
			}
			
			Set<Integer> selectedRow2 = new TreeSet<Integer>();
			for (int i=0; i<4; i++) {
				selectedRow2.add(arrangement2[answer2-1][i]);
			}
			
			selectedRow1.retainAll(selectedRow2);
			if (selectedRow1.size() == 0) {
				writer.write("Case #" + caseNum + ": Volunteer cheated!\n");
			} else if (selectedRow1.size() == 1) {
				Iterator<Integer> it = selectedRow1.iterator();
				if (it.hasNext()) {
					writer.write("Case #" + caseNum + ": " + it.next()  + "\n");
				}
			} else if (selectedRow1.size() > 1) {
				writer.write("Case #" + caseNum + ": Bad magician!\n");
			}
		}
	}
	
	private static Integer[][] readArrangement(BufferedReader reader) throws IOException
	{
		Integer[][] arrangement = new Integer[4][4];
		for (int i=0; i<4; i++) {
			String[] tmp = reader.readLine().split(" ");
			for (int j=0; j<4; j++) {	
				arrangement[i][j] = Integer.parseInt(tmp[j]);
			}
		}
		return arrangement;
	}
}
