package q2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.text.NumberFormat;

public class Question2 {

	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		processFile("C:\\Users\\Ash\\Ash\\Code Jam\\Input\\Q2\\B-small-attempt0.in", "C:\\Users\\Ash\\Ash\\Code Jam\\Input\\Q2\\B-small-attempt0.out");
//		processFile("C:\\Users\\Ash\\Ash\\Code Jam\\Input\\Q2\\B-large-attempt0.in", "C:\\Users\\Ash\\Ash\\Code Jam\\Input\\Q2\\B-large-attempt0.out");
	}
	
	private static void processFile(String in, String out)
	{
		try {
			BufferedReader reader = new BufferedReader(new FileReader(in));
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			
			solveProblem(reader, writer);
			
			writer.flush();
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static void solveProblem(BufferedReader reader, BufferedWriter writer) throws IOException
	{
		NumberFormat nf = new DecimalFormat();
		nf.setMinimumFractionDigits(7);
		
		int cases = Integer.parseInt(reader.readLine());
		
		for (int caseNum=1; caseNum<= cases; caseNum++) { 
			String[] tmp = reader.readLine().split(" ");
			double farmCost = Double.parseDouble(tmp[0]);
			double extraCookiesPerSecond = Double.parseDouble(tmp[1]);
			double targetCookies = Double.parseDouble(tmp[2]);
			double bestTime = findBestTime(farmCost, extraCookiesPerSecond, targetCookies);
			writer.write("Case #" + caseNum + ": " + nf.format(bestTime) + "\n");
		}
	}

	private static double findBestTime(double farmCost, double extraCookiesPerSecond, double targetCookies)
	{
		int upgrades = 0;
		double timeToTarget = getTimeToTargetWithUpgrades(upgrades, farmCost, extraCookiesPerSecond, targetCookies);
		upgrades++;
		double timeToTargetWithNextUpgrade = getTimeToTargetWithUpgrades(upgrades, farmCost, extraCookiesPerSecond, targetCookies);

		while (timeToTargetWithNextUpgrade < timeToTarget) {
			timeToTarget = timeToTargetWithNextUpgrade;
			upgrades++;
			timeToTargetWithNextUpgrade = getTimeToTargetWithUpgrades(upgrades, farmCost, extraCookiesPerSecond, targetCookies);
		}
		
		return timeToTarget;
	}
	
	private static double getTimeToTargetWithUpgrades(int numUpgrades, double farmCost, double extraCookiesPerSecond, double targetCookies)
	{
		double cookiesPerSecond = 2;

		// No upgrades
		if (numUpgrades == 0) {
			return getTimeToTarget(cookiesPerSecond, targetCookies);
		}
		
		double timeSpent = 0;
		for (int i=1; i<=numUpgrades; i++) {
			// Add the time to the next upgrade
			timeSpent += getTimeToTarget(cookiesPerSecond, farmCost);
			cookiesPerSecond += extraCookiesPerSecond;
		}
		
		// Add the time from 0 to target cookies at the given number of farm upgrades
		timeSpent += getTimeToTarget(cookiesPerSecond, targetCookies);
		
		return timeSpent;
	}
	
	private static double getTimeToTarget(double cookiesPerSecond, double targetCookies)
	{
		return targetCookies/cookiesPerSecond;
	}
}
