import com.google.common.collect.Lists; // Guava Library

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.*;

/**
 * Created by Albert on 4/8/2016.
 */
public class CoinJam {
    public static final int[] possible = {2,3,5,7,11,13,17,19,23,31,33,37,41,43,47,51,53,61,67};
    public static int[] findWitnesses(Boolean[] array) {
        int [] witnesses = new int[9];
        //Arrays.fill(witnesses, 2);
        for (int base = 2; base<=10; base++) {
            BigInteger sum = BigInteger.ZERO;
            BigInteger digit = BigInteger.ONE;
            for (int i=0; i<array.length; i++) {
                if (array[i]) {
                    sum = sum.add(digit);
                }
                digit = digit.multiply(BigInteger.valueOf(base));
            }
            final BigInteger finalSum = sum;
            System.out.println(sum);
            OptionalInt witness = Arrays.stream(possible).filter(value -> finalSum.remainder(BigInteger.valueOf(value)).equals(BigInteger.ZERO)).findFirst();
            if (witness.isPresent()) {
                System.out.println(witness.getAsInt());
                witnesses[base-2] = witness.getAsInt();
            } else {
                return null;
            }
        }
        return witnesses;
    }
    public static void main(String[] args) throws FileNotFoundException {
        try (Scanner scanner = new Scanner(new File("input.txt"))) {
            int T = scanner.nextInt();
            int N = scanner.nextInt();
            int J = scanner.nextInt();

            //System.out.println(T + " " + N + " " + J);
            //PrintStream output = System.out;
            try(PrintStream output = new PrintStream(new File("output.txt"))) {
                output.println("Case #1:");
                HashMap<List<Boolean>, int[]> map = new HashMap<>();
                while (map.size() < J) {
                    Boolean[] num = new Boolean[N];
                    Random random = new Random();
                    num[0] = true;
                    num[num.length - 1] = true;
                    for (int i = 1; i < num.length - 1; i++) {
                        num[i] = random.nextBoolean();
                    }
                    int[] witnesses = findWitnesses(num);
                    if (witnesses != null) {
                        //System.out.print(Arrays.toString(num));
                        System.out.print(Arrays.toString(witnesses));
                        map.put(Lists.reverse(Arrays.asList(num)), witnesses);
                    }

                    System.out.print("meh");
                }

                for (Map.Entry<List<Boolean>, int[]> entry : map.entrySet()) {
                    List<Boolean> number = entry.getKey();
                    int[] witnesses = entry.getValue();

                    number.stream().map(e -> e ? "1" : "0").forEachOrdered(output::print);

                    output.print(" ");
                    for (int i = 0; i < witnesses.length; i++) {
                        output.print(witnesses[i]);
                        if (i != witnesses.length - 1) {
                            output.print(" ");
                        }
                    }
                    output.println();
                }
            }


        }
    }
}
