import java.io.File;
import java.io.FileNotFoundException;
import java.util.Formatter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class SpeakingInTongues {

	private static final Map<Character, Character> charMap = makeMap();

	private static Map<Character, Character> makeMap() {
		Map<Character, Character> m = new HashMap<Character, Character>();
		m.put(' ', ' ');
		m.put('a', 'y');
		m.put('b', 'h');
		m.put('c', 'e');
		m.put('d', 's');
		m.put('e', 'o');
		m.put('f', 'c');
		m.put('g', 'v');
		m.put('h', 'x');
		m.put('i', 'd');
		m.put('j', 'u');
		m.put('k', 'i');
		m.put('l', 'g');
		m.put('m', 'l');
		m.put('n', 'b');
		m.put('o', 'k');
		m.put('p', 'r');
		m.put('q', 'z');
		m.put('r', 't');
		m.put('s', 'n');
		m.put('t', 'w');
		m.put('u', 'j');
		m.put('v', 'p');
		m.put('w', 'f');
		m.put('x', 'm');
		m.put('y', 'a');
		m.put('z', 'q');
		return m;
	}

	private static final String solve(String line) {
		char res[] = new char[line.length()];
		int i = 0;
		for (char c : line.toCharArray())
			res[i++] = charMap.get(c);
		return new String(res);
	}

	public static void main(String[] args) throws FileNotFoundException {
		//String filename = "A-test.in";
		String filename = "A-small-attempt0.in";
		assert filename.endsWith(".in");
		Scanner in = new Scanner(new File(filename));
		Formatter out = new Formatter(new File(filename.replace(".in", ".out")));

		assert in.hasNext();
		int T = in.nextInt();
		in.nextLine();
		for (int t = 0; t < T; t++) {
			String ans = solve(in.nextLine());

			String result;
			if (t < T - 1)
				result = String.format("Case #%d: %s%n", t + 1, ans);
			else
				result = String.format("Case #%d: %s", t + 1, ans);
			out.format(result);
			System.out.format(result);
		}

		out.flush();
		out.close();
	}
}
