import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayDeque;
import java.util.Formatter;
import java.util.Queue;
import java.util.Scanner;


public class A {

	static final class VinePos {
		int vine;
		int len;
		public VinePos(int v, int l) {
			vine = v;
			len = l;
		}
	}
	static String solve(int[] d, int[] l, int D) {
		final Queue<VinePos> vines = new ArrayDeque<VinePos>();
		vines.add(new VinePos(0,d[0]));
		final int N = d.length;
		boolean saved = false;
		while (!vines.isEmpty()) {
			VinePos v = vines.poll();
			
			if (d[v.vine]+v.len >= D) {
				saved = true;
				break;
			}
			
			int vNext = v.vine+1;			
			while (vNext < N) {
				if (d[vNext] <= d[v.vine]+v.len) {
					int len = Math.min(l[vNext], d[vNext]-d[v.vine]);
					vines.add(new VinePos(vNext, len));
				}
				vNext++;
			}
		}
		return saved ? "YES" : "NO";
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		//String filename = "A-test.in";
		String filename = "A-small-attempt0.in";
		//String filename = "A-large.in";
		assert filename.endsWith(".in");
		Scanner in = new Scanner(new File(filename));
		Formatter out = new Formatter(new File(filename.replace(".in", ".out")));

		assert in.hasNext();
		int T = in.nextInt();
		in.nextLine();
		for (int t = 0; t < T; t++) {
			int N = in.nextInt();
			int d[] = new int[N];
			int l[] = new int[N];
			for (int i = 0; i < N; i++) {
				d[i] = in.nextInt();
				l[i] = in.nextInt();
			}
			int D = in.nextInt();

			String ans = solve(d, l, D);

			String result;
			if (t < T - 1)
				result = String.format("Case #%d: %s%n", t + 1, ans);
			else
				result = String.format("Case #%d: %s", t + 1, ans);
			out.format(result);
			System.out.format(result);
		}

		out.flush();
		out.close();
	}


}
