import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Formatter;
import java.util.Scanner;


public class A {

	static void solve2(double[] S, double[] Y, int N) {
		boolean exclude[] = new boolean[N];
		tries: for(;;) {
			double sum = 0;
			double n = 0;
			for (int i=0;i<N;i++)
				if (!exclude[i]) {
					sum += S[i];
					n += 1.0;
				}
			for (int i=0;i<N;i++) {
				if (exclude[i]) {
					Y[i] = 0;				
				} else {
					if ((2.0*sum - n*S[i])<0) {
						exclude[i] = true;
						continue tries;
					}
					if (sum==0)
						Y[i] = 1/n;
					else 
						Y[i] = ((2.0*sum - n*S[i]) / n) / sum;
				}
			}
			break tries;
		}
	}
	
	static String solve(final int N, final int s[]) {
		int X = 0;
		for (int x:s)
			X += x;
		double[] S = new double[N];
		for (int i=0; i<N; i++)
			S[i] = ((double)s[i]) / ((double)X);
		double[] Y = new double[N];
		
		solve2(S, Y, N);
		
		StringBuilder sb = new StringBuilder();
		for (double y:Y) {
			sb.append(y*100.0);
			sb.append(" ");
		}
		sb.deleteCharAt(sb.length()-1); // delete final space.
		return sb.toString();
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		//String filename = "A-test.in";
		String filename = "A-small-attempt2.in";
		//String filename = "A-large.in";
		assert filename.endsWith(".in");
		Scanner in = new Scanner(new File(filename));
		Formatter out = new Formatter(new File(filename.replace(".in", ".out")));

		assert in.hasNext();
		int T = in.nextInt();
		in.nextLine();
		for (int t = 0; t < T; t++) {
			int N = in.nextInt();
			int s[] = new int[N];
			for (int i = 0; i < N; i++)
				s[i] = in.nextInt();

			String ans = solve(N, s);

			String result;
			if (t < T - 1)
				result = String.format("Case #%d: %s%n", t + 1, ans);
			else
				result = String.format("Case #%d: %s", t + 1, ans);
			out.format(result);
			System.out.format(result);
		}

		out.flush();
		out.close();
	}


}
