package com.google.codejam.themepark;

import java.util.ArrayList;
import java.util.Collections;

/**
 * Created by IntelliJ IDEA.
 * User: ashish
 * Date: 8 May, 2010
 * Time: 12:10:13 PM
 */
public class RollerCoaster {
  private int numberOfRuns;
  private int rollerCoasterCapacity;
  private ArrayList<Integer> groupQueue;

  public RollerCoaster(int numberOfRuns, int rollerCoasterCapacity, Integer... groupQueue) {
    this.numberOfRuns = numberOfRuns;
    this.rollerCoasterCapacity = rollerCoasterCapacity;
    this.groupQueue = new ArrayList<Integer>();
    Collections.addAll(this.groupQueue, groupQueue);
  }


  public int totalMoney() {
    int totalMoney = 0;
    RollerCoasterRide ride = new RollerCoasterRide(rollerCoasterCapacity);
    for (int i = 0; i < numberOfRuns; i++) {
      ArrayList<Integer> riderGroups = ride.riderGroups(groupQueue);
      totalMoney += rideMoney(riderGroups);
      goToEndOfQueue(riderGroups, groupQueue);
    }
    return totalMoney;
  }

  private void goToEndOfQueue(ArrayList<Integer> riderGroups, ArrayList<Integer> groupQueue) {
    groupQueue.addAll(riderGroups);
  }

  private int rideMoney(ArrayList<Integer> riderGroups) {
    int total = 0;
    for (Integer riderGroup : riderGroups) {
      total += riderGroup;
    }
    return total;
  }
}
