package com.google.magicka;

import java.io.IOException;
import java.util.StringTokenizer;

/**
 * User: akumar
 * Date: 7/5/11
 * Time: 8:03 PM
 */
public class TestCaseProcessor {
    private Magicka magicka;

    public TestCaseProcessor(Magicka magicka) {

        this.magicka = magicka;
    }

    void processTestCase(int testCaseIndex, String input) throws IOException {
        StringTokenizer stringTokenizer = new StringTokenizer(input, " ", false);
        int numberOfCombinationPairs = Integer.parseInt(stringTokenizer.nextToken());

        for (int i= 0; i<numberOfCombinationPairs; i++){
            String combinationPair = stringTokenizer.nextToken();
            String pair = combinationPair.substring(0, 2);
            char transformTo = combinationPair.charAt(2);
            magicka.addCombinationPair(pair, transformTo);
        }

        int numberOfOppositePairs = Integer.parseInt(stringTokenizer.nextToken());
        for (int i= 0; i<numberOfOppositePairs; i++){
            String oppositePair = stringTokenizer.nextToken();
            magicka.addOppositePair(oppositePair.charAt(0), oppositePair.charAt(1));
        }

        int numberOfElements = Integer.parseInt(stringTokenizer.nextToken());
        String elements = stringTokenizer.nextToken();
        for (int i = 0; i < numberOfElements; i++) {
            magicka.invokeElement(elements.charAt(i));
        }

        System.out.println("Case #"+testCaseIndex + ": [" + display(magicka.getElementList().toCharArray()) + "]");
    }

    private String display(char[] chars) {
        if(chars == null || chars.length == 0) return "";
        StringBuilder stringBuilder = new StringBuilder();

        for (int i = 0, charsLength = chars.length; i < charsLength; i++) {
            char o = chars[i];
            stringBuilder.append(o);
            stringBuilder.append(", ");
        }

        return stringBuilder.substring(0, stringBuilder.length() - 2);
    }
}
