package com.google.codejam.snapper;

import com.google.codejam.CodeJamTestCase;

/**
 * Created by IntelliJ IDEA.
 * User: akumar
 * Date: May 8, 2010
 * Time: 7:27:53 PM
 */
public class SnapperCodeJamTestCaseImpl implements CodeJamTestCase {
    private int testCaseSequenceNumber;
    private int numberOfFingerSnaps;
    private boolean[] snapperStates;

    public SnapperCodeJamTestCaseImpl(int testCaseSequenceNumber, int numberOfSnappers, int numberOfFingerSnaps) {
        this.testCaseSequenceNumber = testCaseSequenceNumber;
        this.numberOfFingerSnaps = numberOfFingerSnaps;
        snapperStates = new boolean[numberOfSnappers];
        assertAllFalse(snapperStates);
    }

    private void assertAllFalse(boolean[] snapperStates) {
        for (boolean snapperState : snapperStates) {
            assert !snapperState;
        }
    }

    public String result() {
        boolean hasPower = false;
        for (int i=0; i < numberOfFingerSnaps; i++) {
            hasPower = snap();
        }
        return "Case #" + testCaseSequenceNumber + ": " + (hasPower ? "ON" : "OFF");
    }

    private boolean snap() {
        boolean hasPowerToNextSnapper = true;
        for (int i = 0; i < snapperStates.length; i++) {
            boolean snapperState = snapperStates[i];
            snapperStates[i] = hasPowerToNextSnapper ? !snapperState: snapperState;
            hasPowerToNextSnapper = hasPowerToNextSnapper && snapperState;
        }
        return hasPower();
    }

    private boolean hasPower() {
        boolean hasPower = true;
        for (boolean snapperState : snapperStates) {
           hasPower &= snapperState;
        }
        return hasPower;
    }

}
