package com.example.reverse;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class TicTacToe {
	private Scanner reader;
	private PrintStream writer;

	public TicTacToe(String fName) {
		File f = new File(fName);
		try {
			this.reader = new Scanner(f);
			System.out.println(f.getParent());
			this.writer = new PrintStream(f.getParent()+"\\"+f.getName() + "_Solved.OUT");

		} catch (FileNotFoundException e) {
			System.out.println(e.getMessage());

		}
		run();
	}

		public void run() {
		int noOfCase = Integer.parseInt(reader.nextLine());
		char[][] game = new char[4][4];
		for (int j = 1; j <= noOfCase; j++) {
			for (int i = 0; i < game.length; i++) {
				game[i] = reader.nextLine().toCharArray();
			}
			String solu="Case #"+j+": "+solve(game);
			System.out.println(solu);
			writer.println(solu);
			reader.nextLine();
		}

	}

	private String solve(char[][] game) {
		String status;
		if (isWin(game, 'X')) {
			status = "X won";
		} else if (isWin(game, 'O')) {
			status = "O won";
		} else if (isDraw(game)) {
			status = "Draw";
		} else {
			status = "Game has not completed";
		}
		return status;
	}

	private boolean isDraw(char[][] game) {
		for (int i = 0; i < game.length; i++) {
			for (int j = 0; j < game[i].length; j++) {
				if (game[i][j] == '.') {
					return false;
				}
			}
		}
		return true;
	}

	private boolean isWin(char[][] game, char c) {
		int count = 0;
		for (int i = 0; i < game.length; i++) {
			count = 0;
			for (int j = 0; j < game[i].length; j++) {
				if (game[i][j] == c || game[i][j] == 'T') {
					count++;
				}
			}
			if (count == 4) {
				return true;
			}
			count = 0;
			for (int j = 0; j < game.length; j++) {
				if (game[j][i] == c || game[j][i] == 'T') {
					count++;
				}
			}
			if (count == 4) {
				return true;
			}
		}
		count=0;
		for (int i = 0; i < game.length; i++) {
			if (game[i][i] == c || game[i][i] == 'T') {
				count++;
			}
		}
		if (count == 4) {
			return true;
		}
		count=0;
		for (int i = 0; i < game.length; i++) {
			if (game[i][game.length-(i+1)] == c || game[i][game.length-(i+1)] == 'T') {
				count++;
			}
		}
		if (count == 4) {
			return true;
		}
		return false;
	}

}
