import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class MinesweeperMaster {

    private static int rows = 0;

    private static int cols = 0;

    private static int mines = 0;

    /**
     * @param args
     */
    public static void main(String[] args) {
        // assuming first arg is input and second is output location
        String inputLoc = args[0];
        String outputLoc = args[1];

        try {
            BufferedReader br = new BufferedReader(new FileReader(inputLoc));
            BufferedWriter bw = new BufferedWriter(new FileWriter(outputLoc));

            StringBuilder sb = new StringBuilder();

            // number of test cases
            int tcCount = Integer.parseInt(br.readLine());

            for (int index = 1; index < tcCount + 1; index++) {
                String[] inputs = br.readLine().split(" ");

                rows = Integer.parseInt(inputs[0]);
                cols = Integer.parseInt(inputs[1]);
                mines = Integer.parseInt(inputs[2]);

                String[][] solution = findConfiguration(false);

                rows = Integer.parseInt(inputs[0]);
                cols = Integer.parseInt(inputs[1]);
                mines = Integer.parseInt(inputs[2]);

                if (solution == null) {
                    solution = findConfiguration(true);
                }

                // print result
                sb.append("Case #" + index + ":\n");
                if (solution == null) {
                    sb.append("Impossible\n");
                } else {
                    // print configuration
                    for (int i = 0; i < rows; i++) {
                        for (int j = 0; j < cols; j++) {
                            sb.append(solution[i][j]);
                        }
                        sb.append("\n");
                    }
                }
            }
            sb.deleteCharAt(sb.length() - 1);
            bw.write(sb.toString());
            bw.close();
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }

    private static String[][] findConfiguration(boolean includeRemainderSoln) {
        String[][] result = new String[rows][cols];

        int freeCells = (rows * cols) - mines;
        System.out.println("input = " + rows + "," + cols + "," + mines);

        if (freeCells == 1) {
            fillWithAsterix(result);

            // set top left most corner as click
            result[0][0] = "c";

            return result;
        }

        // find numbers a, b and c such that freeCells = a * b + c and c != 1
        if (freeCells < 2 && (rows == 1 || cols == 1)) {
            return null;
        }

        if (freeCells < 4 && (rows > 1 && cols > 1)) {
            return null;
        }

        boolean solutionFound = false;
        int divisor = 0, quotient = 0, remainder = 0;

        for (int i = 2; i <= rows; i++) {
            divisor = i;
            quotient = freeCells / divisor;
            remainder = freeCells % divisor;

            if (quotient == 0 || quotient > cols || (quotient == 1 && cols > 1)) {
            } else {
                System.out.println("workable solution output = " + divisor + "," + quotient + "," + remainder);
                // special case
                if (remainder == 1) {
                    if (includeRemainderSoln) {
                        solutionFound = fillWhenRemainderIsOne(result, divisor, quotient);
                        if (solutionFound) {
                            return result;
                        }
                    }
                } else {
                    solutionFound = true;
                    break;
                }
            }
        }

        if (!solutionFound) {
            for (int i = 2; i <= cols; i++) {
                divisor = i;
                quotient = freeCells / divisor;
                remainder = freeCells % divisor;

                if (quotient == 0 || quotient > rows || (quotient == 1 && rows > 1)) {
                } else {
                    System.out.println("workable solution output = " + divisor + "," + quotient + "," + remainder);
                    // special case
                    if (remainder == 1) {
                        if (includeRemainderSoln) {
                            solutionFound = fillWhenRemainderIsOne(result, quotient, divisor);

                            if (solutionFound) {
                                return result;
                            }
                        }

                    } else {
                        solutionFound = true;
                        break;
                    }
                }
            }
        }

        if (solutionFound) {
            // fill result array first with mines
            fillWithMines(result, divisor, quotient, remainder);

            fillWithAsterix(result);

            // set top left most corner as click
            result[0][0] = "c";
        }

        return solutionFound ? result : null;
    }

    /**
     * @param result
     * @param rCount
     * @param cCount
     */
    private static boolean fillWhenRemainderIsOne(String[][] result, int rCount, int cCount) {
        if (rCount >= 3 && cCount >= 3) {
            fillWithDot(result, rCount, cCount);

            boolean done = setDotsForSpecialCase(result, rCount, cCount);

            if (!done) {
                return done;
            }

            // file all remaining with mines
            fillWithAsterix(result);

            // set top left most corner as click
            result[0][0] = "c";

            return true;
        }

        return false;
    }

    /**
     * @param result
     * @param rCount
     * @param cCount
     */
    private static boolean setDotsForSpecialCase(String[][] result, int rCount, int cCount) {
        boolean done = true;
        if (rCount + 1 < rows) {
            result[2][0] = "*";
            result[rCount + 1][0] = ".";
            result[rCount + 1][1] = ".";
        } else if (cCount + 1 < cols) {
            result[0][2] = "*";
            result[0][cCount + 1] = ".";
            result[1][cCount + 1] = ".";
        } else {
            done = false;
        }
        return done;
    }

    /**
     * @param result
     * @param divisor
     * @param quotient
     */
    private static void fillWithDot(String[][] result, int rowCount, int colCount) {
        for (int m = 0; m < rowCount; m++) {
            for (int n = 0; n < colCount; n++) {
                if (result[m][n] == null) {
                    result[m][n] = ".";
                }
            }
        }
    }

    /**
     * @param result
     */
    private static void fillWithAsterix(String[][] result) {
        for (int i = 0; i < rows; i++) {
            for (int j = 0; j < cols; j++) {
                if (result[i][j] == null) {
                    result[i][j] = "*";
                }
            }
        }
    }

    private static void fillWithMines(String[][] result, int divisor, int quotient, int remainder) {
        int rowLength = divisor;
        int colLength = quotient;
        boolean fillRow = true;
        if (divisor > rows) {
            colLength = divisor;
            rowLength = quotient;
            fillRow = false;
        }

        for (int i = 0; i < rowLength; i++) {
            for (int j = 0; j < colLength; j++) {
                result[i][j] = ".";
            }
        }

        // where to put the remainder - in row or column
        if (fillRow) {
            if (colLength < cols) {
                for (int i = 0; i < remainder; i++) {
                    result[i][colLength] = ".";
                }
            } else {
                for (int i = rowLength; i < rows; i++) {
                    for (int j = 0; j < cols; j++) {
                        if (remainder > 0) {
                            result[i][j] = ".";
                            remainder--;
                        } else {
                            break;
                        }
                    }
                }
            }
        } else {
            if (rowLength < rows) {
                for (int i = 0; i < remainder; i++) {
                    result[rowLength][i] = ".";
                }
            } else {
                for (int j = colLength; j < cols; j++) {
                    for (int i = 0; i < rows; i++) {
                        if (remainder > 0) {
                            result[i][j] = ".";
                            remainder--;
                        } else {
                            break;
                        }
                    }
                }
            }
        }

    }

}
