/**
 * 
 */
package p1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * @author ashutosh
 *
 */
public class MagicTrick {

    /**
     * @param args
     */
    public static void main(String[] args) {
        // assuming first arg is input and second is output location
        String inputLoc = args[0];
        String outputLoc = args[1];
        
        try {
            BufferedReader br = new BufferedReader(new FileReader(inputLoc));
            BufferedWriter bw = new BufferedWriter(new FileWriter(outputLoc));
            
            // number of test cases
            int tcCount = Integer.parseInt(br.readLine());
            
            for (int i = 1; i < tcCount + 1; i++) {
                // read first answer of volunteer
                int firstAnswer = Integer.parseInt(br.readLine());
                
                // read first grid
                List<Integer> firstRow = readAppropriateRow(br, firstAnswer);
                
                // read second answer
                int secAnswer = Integer.parseInt(br.readLine());
                
                // read second grid
                List<Integer> secRow = readAppropriateRow(br, secAnswer);
                
                // check intersection
                List<Integer> commonCards = new ArrayList<>();
                for (Integer card: firstRow) {
                    if (secRow.contains(card)) {
                        commonCards.add(card);
                    }
                }
                
                // print now
                if (commonCards.isEmpty()) {
                    bw.write("Case #" + i + ": Volunteer cheated!\n");
                } else if (commonCards.size() == 1) {
                    bw.write("Case #" + i + ": " + commonCards.get(0) + "\n");
                } else if (commonCards.size() > 1) {
                    bw.write("Case #" + i + ": Bad magician!\n");
                }
            }           
            bw.close();         
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
        
        
    }

    private static List<Integer> readAppropriateRow(BufferedReader br, int answer) throws IOException {
        List<Integer> cards = new ArrayList<>();
        for (int i = 1; i < 5; i++) {
            String row = br.readLine();
            if (i == answer) {
                String[] numbers = row.split(" ");
                for (String number: numbers) {
                    cards.add(Integer.parseInt(number));
                }
            }
        }
        return cards;
    }

}
