import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;


public class LotteryGame {

    /**
     * @param args
     */
    public static void main(String[] args) {
        // assuming first arg is input and second is output location
        String inputLoc = args[0];
        String outputLoc = args[1];

        try {
            BufferedReader br = new BufferedReader(new FileReader(inputLoc));
            BufferedWriter bw = new BufferedWriter(new FileWriter(outputLoc));

            // number of test cases
            int tcCount = Integer.parseInt(br.readLine());
            StringBuilder sb = new StringBuilder();

            for (int i = 1; i < tcCount + 1; i++) {
                System.out.println("case " + i);
                String[] inputs = br.readLine().split(" ");

                long A = Long.parseLong(inputs[0]);
                long B = Long.parseLong(inputs[1]);
                long K = Long.parseLong(inputs[2]);
                
                long r = calculateComb2(A, B, K);
               
                // print result
                String result = "Case #" + i + ": " + r;
                sb.append(result + "\n");
                bw.write(result + "\n");

            }
            
            //bw.write(sb.toString());
            
            bw.close();
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }

    }
    
    private static long calculateComb(long a, long b, long k) {
        long result = 0;
        long max = a > b? a: b;
        
        max = max > k? max: k;
        
        int size = Long.toBinaryString(max - 1).length(); 

        
        for (int i = 0; i < k; i++) {
            String strK = Long.toBinaryString(i);
            
            for (int j = 0; j < strK.length(); j++) {
                if (strK.charAt(j) == '1') {
                    result *= 1;
                } else {
                    result *= 3;
                }
            }

            result -= (size - strK.length())*3;
        }

        
        return result;
    }

    private static long calculateComb2(long a, long b, long k) {
        long result = 0;

        
        for (int i = 0; i < a; i++) {
            for (int j = 0; j < b; j++) {
                int x = (i & j);
                if (x < k) {
                    //System.out.println(Long.toBinaryString(i) + " " + Long.toBinaryString(j) + " = " + Long.toBinaryString(x));
                    result++;
                    
                }
            }

        }

        
        return result;
    }
}
