

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class CookieClicker {

    /**
     * @param args
     */
    public static void main(String[] args) {
        // assuming first arg is input and second is output location
        String inputLoc = args[0];
        String outputLoc = args[1];
        
        try {
            BufferedReader br = new BufferedReader(new FileReader(inputLoc));
            BufferedWriter bw = new BufferedWriter(new FileWriter(outputLoc));
            
            // number of test cases
            int tcCount = Integer.parseInt(br.readLine());
           
            for (int i = 1; i < tcCount + 1; i++) {
                String[] inputs = br.readLine().split(" ");
                
                double currentRate = 2;
                double totalTime = 0;
                double farmCost = Double.parseDouble(inputs[0]);
                double farmRate = Double.parseDouble(inputs[1]);
                double target = Double.parseDouble(inputs[2]);
                
                while (true) {
                    if (isNewFarmRequired(target, farmCost, farmRate, currentRate)) {
                        totalTime += farmCost/ currentRate;
                        currentRate += farmRate;
                    } else {
                        totalTime += target/ currentRate;
                        break;
                    }
                }
                
                // print result
                bw.write("Case #" + i + ": " + formatWithPrecision(totalTime, 7) +"\n");

            }           
            bw.close();         
            br.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
   
    }

    private static boolean isNewFarmRequired(double target, double farmCost, double farmRate, double currentRate) {
        // find time without new farm
        double withoutFarm = target/ currentRate;
        
        // find time with new farm
        double withFarm = (farmCost/ currentRate) + (target / (currentRate + farmRate));
        
        return withFarm < withoutFarm;
    }
    
    private static String formatWithPrecision(double value, Integer precision)
    {
        String val = null;

        if (precision != null)
        {
            DecimalFormat decimalFormat = new DecimalFormat();
            decimalFormat.setGroupingUsed(false);
            decimalFormat.setMaximumFractionDigits(precision);
            decimalFormat.setMinimumFractionDigits(7);
            try
            {
                val = decimalFormat.format(value);
            } catch (Exception e)
            {
                e.printStackTrace();
            }
        }

        return val;
    }


}
