package com.google.code;

import java.io.*;
import java.util.*;

public class SavingTheUniverse 
{
	//for Input
	File ipFile = new File("C:\\Google\\A-small.in");
	FileInputStream fis = null;
	BufferedInputStream bis = null;
	DataInputStream dis = null;
	int noOfCases = 0;
	//for Output
	File opFile = new File("C:\\Google\\A-small.out");
	FileOutputStream fos; 
	PrintWriter out;

	public static void main(String[] args) 
	{
		SavingTheUniverse n = new SavingTheUniverse();
		n.initFiles();
		n.processSavingTheUniverse();
		n.closeFiles();
	}

	void initFiles()
	{
		try 
		{
			//for Read
			fis = new FileInputStream(ipFile);
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			noOfCases = Integer.parseInt(dis.readLine());

			//for Write
			fos = new FileOutputStream(opFile);
			out = new PrintWriter(fos);
		} 
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	void closeFiles()
	{
		try
		{
			fis.close();
			bis.close();
			dis.close();
			fos.close();
			out.close();
		}
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}

	void processSavingTheUniverse()
	{
		for(int i = 0; i< noOfCases; i++)
		{
			String output = processCase();
			out.println("Case #" + (i+1) + ": " + output);
			out.flush();
		}
	}

	String processCase()
	{
		ArrayList searchEngines = new ArrayList();
		ArrayList queries = new ArrayList();
		
		try
		{
			String number = dis.readLine();
			int noSearchEngine = Integer.parseInt(number);

			searchEngines.ensureCapacity(noSearchEngine);
			for(int i=0; i<noSearchEngine;i++)
			{
				searchEngines.add(dis.readLine());
			}
			int noQueries = Integer.parseInt(dis.readLine());
			if(noQueries==0)
			{
				return String.valueOf(0);
			}
			queries.ensureCapacity(noQueries);
			for(int i=0; i<noQueries;i++)
			{
				queries.add(dis.readLine());
			}
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}

		int noofSwitches = -1;
		while(queries.size()>0)
		{
			noofSwitches++;
			int maxIndex = 0;
			int currIndex;
			for(int i=0;i<searchEngines.size();i++)
			{
				currIndex = queries.indexOf(searchEngines.get(i));
				if(currIndex == -1)
				{
					return String.valueOf(noofSwitches);
				}
				else if(currIndex > maxIndex)
				{
					maxIndex = currIndex;
				}
			}
			for(int i=0;i<maxIndex;i++)
			{
				queries.remove(0);
			}
		}
		return String.valueOf(noofSwitches);
	}

}
