package com.google.code;

import java.io.*;
import java.util.*;

public class TextMessagingOutrage 
{

	//for Input
	File ipFile = new File("C:\\Google\\A-small.in");
	FileInputStream fis = null;
	BufferedInputStream bis = null;
	DataInputStream dis = null;
	int noOfCases = 0;
	//for Output
	File opFile = new File("C:\\Google\\A-small.out");
	FileOutputStream fos; 
	PrintWriter out;

	public static void main(String[] args) 
	{
		TextMessagingOutrage n = new TextMessagingOutrage();
		n.initFiles();
		n.processTextMessagingOutrage();
		n.closeFiles();
	}

	void initFiles()
	{
		try 
		{
			//for Read
			fis = new FileInputStream(ipFile);
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			noOfCases = Integer.parseInt(dis.readLine());

			//for Write
			fos = new FileOutputStream(opFile);
			out = new PrintWriter(fos);
		} 
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	void closeFiles()
	{
		try
		{
			fis.close();
			bis.close();
			dis.close();
			fos.close();
			out.close();
		}
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}

	void processTextMessagingOutrage()
	{
		for(int i = 0; i< noOfCases; i++)
		{
			String output = processCase();
			out.println("Case #" + (i+1) + ": " + output);
			out.flush();
		}
	}

	String processCase()
	{
		int keyPress = 0;
		try 
		{
			String inputLine = dis.readLine();
			String[] input = inputLine.split(" ");
			int P = Integer.parseInt(input[0]);
			int K = Integer.parseInt(input[1]);
			int L = Integer.parseInt(input[2]);
			inputLine = dis.readLine();
			input = inputLine.split(" ");
			int keys[] = new int[K];
			for(int i=0;i<K;i++)
				keys[i] = 0;
			int letters[] = new int[L];
			for(int i=0;i<L;i++)
			{
				letters[i] = Integer.parseInt(input[i]);
			}
			for(int i = 0; i< L ;i++)
			{
				for(int j= i+1 ;j<L;j++)
				{
					if(letters[i]<letters[j])
					{
						int t = letters[i];
						letters[i] = letters[j];
						letters[j] = t;
					}
				}
			}
			for(int i=0;i<L;i++)
			{
				int freq = letters[i];
				int min = 0;
				for(int j=0; j<K;j++)
				{
					if(keys[min]>keys[j])
						min = j;
				}
				if(keys[min]<P)
				{
				keys[min] ++;
				keyPress += keys[min]*freq;
				}
				else
				{
					return "Impossible";
				}
			}	

		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		
		return keyPress+"";

	}
}
