package com.google.code;

import java.io.*;
import java.math.*;

public class ThemePark 
{
	//for Input
	File ipFile = new File("C:\\Google\\C-small.in");
	FileInputStream fis = null;
	BufferedInputStream bis = null;
	DataInputStream dis = null;
	int noOfCases = 0;
	//for Output
	File opFile = new File("C:\\Google\\C-small.out");
	FileOutputStream fos; 
	PrintWriter out;

	public static void main(String[] args) 
	{
		ThemePark n = new ThemePark();
		n.initFiles();
		n.processThemePark();
		n.closeFiles();
	}

	void initFiles()
	{
		try 
		{
			//for Read
			fis = new FileInputStream(ipFile);
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			noOfCases = Integer.parseInt(dis.readLine());

			//for Write
			fos = new FileOutputStream(opFile);
			out = new PrintWriter(fos);
		} 
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	void closeFiles()
	{
		try
		{
			fis.close();
			bis.close();
			dis.close();
			fos.close();
			out.close();
		}
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}

	void processThemePark()
	{
		for(int i = 0; i< noOfCases; i++)
		{
			String output = processCase();
			out.println("Case #" + (i+1) + ": " + output);
			out.flush();
		}
	}
	
	int getNextTurn(int t, int n)
	{
		if(t == n-1)
			return 0;
		else
			return ++t;
	}
	
	int getPrevTurn(int t, int n)
	{
		if(t == 0)
			return n-1;
		else
			return --t;
	}

	String processCase()
	{
		String line1 = null;
		String line2 = null;
		long euros = 0;
		try
		{
			line1 = dis.readLine();
			line2 = dis.readLine();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		String[] data = line1.split(" ");
		String[] group = line2.split(" ");
		long r = Long.parseLong(data[0]);
		long k = Long.parseLong(data[1]);
		int n = Integer.parseInt(data[2]);
		int t = 0, start;
		long numPeople;
		for(long i = 0; i<r ;i++)
		{
			start = t;
			numPeople = 0;
			while(numPeople < k)
			{
				numPeople += Long.parseLong(group[t]);
				t = getNextTurn(t, n);
				if(t == start)
				{
					break;
				}
			}
			if(numPeople > k)
			{
				t = getPrevTurn(t, n);
				numPeople -= Long.parseLong(group[t]);
			}
			euros += numPeople;
		}
		return String.valueOf(euros);
	}
}
