package com.google.code;

import java.io.*;
import java.util.*;
import java.text.*;

public class TrainTimetable 
{
	//for Input
	File ipFile = new File("C:\\Google\\B-large.in");
	FileInputStream fis = null;
	BufferedInputStream bis = null;
	DataInputStream dis = null;
	int noOfCases = 0;
	//for Output
	File opFile = new File("C:\\Google\\B-large.out");
	FileOutputStream fos; 
	PrintWriter out;

	public static void main(String[] args) 
	{
		TrainTimetable n = new TrainTimetable();
		n.initFiles();
		n.processTrainTimetable();
		n.closeFiles();
	}

	void initFiles()
	{
		try 
		{
			//for Read
			fis = new FileInputStream(ipFile);
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			noOfCases = Integer.parseInt(dis.readLine());

			//for Write
			fos = new FileOutputStream(opFile);
			out = new PrintWriter(fos);
		} 
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	void closeFiles()
	{
		try
		{
			fis.close();
			bis.close();
			dis.close();
			fos.close();
			out.close();
		}
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}

	void processTrainTimetable()
	{
		for(int i = 0; i< noOfCases; i++)
		{
			String output = processCase();
			out.println("Case #" + (i+1) + ": " + output);
			out.flush();
		}
	}

	String processCase()
	{
		int reqTrainsA = 0;
		int reqTrainsB = 0;
		try
		{
			String time = dis.readLine();
			int turnAroundTime = Integer.parseInt(time);
			String noTrips = dis.readLine();
			String[] numberofTrips = noTrips.split(" ");
			int noofTrips4mA = Integer.parseInt(numberofTrips[0]);
			int noofTrips4mB = Integer.parseInt(numberofTrips[1]);
			ArrayList availableA = new ArrayList();
			availableA.ensureCapacity(noofTrips4mB);
			ArrayList availableB = new ArrayList();
			availableB.ensureCapacity(noofTrips4mA);
			ArrayList trains4mA = new ArrayList();
			trains4mA.ensureCapacity(noofTrips4mA);
			ArrayList trains4mB = new ArrayList();
			trains4mB.ensureCapacity(noofTrips4mB);
			Date d = new Date();
			SimpleDateFormat df = new SimpleDateFormat("HH:mm");
			for(int i=0; i<noofTrips4mA ;i++)
			{
				String[] timestamp = dis.readLine().split(" ");
				d = df.parse(timestamp[0]);
				d = new Date(d.getTime());
				trains4mA.add(d);
				if(noofTrips4mB>0)
				{
					d = df.parse(timestamp[1]);
					d = new Date(d.getTime()+turnAroundTime*60*1000);
					availableB.add(d);
				}
			}
			for(int i=0; i<noofTrips4mB;i++)
			{
				String[] timestamp = dis.readLine().split(" ");
				d = df.parse(timestamp[0]);
				d = new Date(d.getTime());
				trains4mB.add(d);
				if(noofTrips4mA>0)
				{
					d = df.parse(timestamp[1]);
					d = new Date(d.getTime()+turnAroundTime*60*1000);
					availableA.add(d);
				}
			}

			if(noofTrips4mA>0)
			{
				Collections.sort(trains4mA, new DateComparer());
				Collections.sort(availableB, new DateComparer());
			}
			if(noofTrips4mB>0)
			{
				Collections.sort(trains4mB, new DateComparer());
				Collections.sort(availableA, new DateComparer());
			}

			Date d1 = null;

			for(int i=0;i<trains4mA.size();i++)
			{
				d1 = null;
				if(availableA.size()>0)
				{
					d1 = (Date)availableA.get(0);
				}
				if(d1!=null)
				{
					if(((Date)trains4mA.get(i)).compareTo(d1)>=0)
					{
						availableA.remove(0);
					}
					else
					{
						reqTrainsA++;
					}
				}
				else
				{
					reqTrainsA++;
				}

			}

			for(int i=0;i<trains4mB.size();i++)
			{	
				d1 = null;
				if(availableB.size()>0)
				{
					d1 = (Date)availableB.get(0);
				}
				if(d1!=null)
				{
					if(((Date)trains4mB.get(i)).compareTo(d1)>=0)
					{
						availableB.remove(0);
					}
					else
					{
						reqTrainsB++;
					}
				}
				else
				{
					reqTrainsB++;
				}
			}

		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		return String.valueOf(reqTrainsA) + " " + String.valueOf(reqTrainsB);
	}

	class DateComparer implements Comparator 
	{
		public int compare(Object t1, Object t2)
		{
			Date d1 = (Date)t1;
			Date d2 = (Date)t2;
			return d1.compareTo(d2);
		}
	}

}
