package com.google.code;

import java.io.*;
import java.math.*;

public class SnapperChain 
{
	//for Input
	File ipFile = new File("C:\\Google\\A-large.in");
	FileInputStream fis = null;
	BufferedInputStream bis = null;
	DataInputStream dis = null;
	int noOfCases = 0;
	//for Output
	File opFile = new File("C:\\Google\\A-large.out");
	FileOutputStream fos; 
	PrintWriter out;

	public static void main(String[] args) 
	{
		SnapperChain n = new SnapperChain();
		n.initFiles();
		n.processSnapperChain();
		n.closeFiles();
	}

	void initFiles()
	{
		try 
		{
			//for Read
			fis = new FileInputStream(ipFile);
			bis = new BufferedInputStream(fis);
			dis = new DataInputStream(bis);
			noOfCases = Integer.parseInt(dis.readLine());

			//for Write
			fos = new FileOutputStream(opFile);
			out = new PrintWriter(fos);
		} 
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}

	void closeFiles()
	{
		try
		{
			fis.close();
			bis.close();
			dis.close();
			fos.close();
			out.close();
		}
		catch (IOException e) 
		{
			e.printStackTrace();
		}
	}

	void processSnapperChain()
	{
		for(int i = 0; i< noOfCases; i++)
		{
			String output = processCase();
			out.println("Case #" + (i+1) + ": " + output);
			out.flush();
		}
	}

	String processCase()
	{
		String input = null;
		try
		{
			input = dis.readLine();
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
		String[] inputs = input.split(" ");
		int n = Integer.parseInt(inputs[0]);
		BigInteger k = new BigInteger(inputs[1]);
		BigInteger numStates = new BigInteger("2").pow(n);
		if(k.add(BigInteger.ONE).mod(numStates).intValue()==0)
		{
			return "ON";
		}
		else
		{
			return "OFF";
		}
	}
}
