import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


/**
 * Created by ashwinch on 4/9/16.
 */
public class CoinJam {

    static File coinJam16 = new File("coinJam-16.out");
    static PrintWriter pr1;

    public static void main(String[] args) throws FileNotFoundException, IOException {

        String fileName = "C-small-attempt0";
        File outFile = new File(fileName + ".out");
        PrintWriter pr = new PrintWriter(new FileWriter(outFile));
        File inFile = new File(fileName+".in");
        Scanner input = new Scanner(inFile);

        if (!coinJam16.exists()) {
            char[] inp = {'0', '1'};
            pr1 = new PrintWriter(new FileWriter(coinJam16));
            generatePerm(inp, 14, pr1);
        }



        int count = 0;
        int T = input.nextInt();
        int N = input.nextInt();
        int J = input.nextInt();
        input.close();


        Scanner in = new Scanner(coinJam16);
        pr.println("Case #1:");

        while (count < J) {
            long ss = in.nextLong();

            int i = 0;
            long vs[] = new long[9];

            for (i = 0; i < 9; i++) {
                long v = in.nextLong();
                vs[i] = v;
            }

            for (i = 0; i < 9; i++) {
                if (primalityTest(vs[i]))
                    break;
            }

            if (i < 9) {
                continue;
            } else {
                count++;
                pr.print(ss + " ");
                for (int k = 0; k < 9; k++)
                    pr.print(getFactor(vs[k]) + " ");
            }
            pr.println();
        }
        pr.close();
    }

    static void generatePerm(char set[], int k, PrintWriter pr) {
        generateAllPerms(set, "", set.length, k, pr);
        pr.close();
    }

    static void generateAllPerms(char[] set, String p, int n, int k, PrintWriter pr) {

        if (k == 0) {
            String s = new String("1" + p + "1");
            generateBaseValues(s, pr);
            return;
        }

        for (int i = 0; i < n; ++i) {
            String newPrefix = p + set[i];
            generateAllPerms(set, newPrefix, n, k - 1, pr);
        }
    }

    static void generateBaseValues(String s, PrintWriter pr) {

        pr.print(s + " ");
        for (int i = 2; i <= 10; i++)
            pr.print(Long.parseLong(s, i) + " ");
        pr.println();
    }

    static long getFactor(long n) {

        long ret = 0;

        for (long i = 2; i * i < n; i++)
            if (n % i == 0) {
                ret = i;
                break;
            }
        return ret;
    }

    static boolean primalityTest(long l) {
        if (l <= 1) return false;
        if (l <= 3) return true;
        if (l % 2 == 0 || l % 3 == 0) return false;

        long i = 5;

        while (i * i <= l) {
            if (l % i == 0 || l % (i + 2) == 0)
                return false;
            i += 6;
        }
        return true;
    }


}
