package com.google.codejam.qualification;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Dijkstra {
	
	String input = "/Users/ashwins/Documents/Google Code Jam/2015/QualificationRound/Dijkstra/C-small-attempt3.in";
	String out = "/Users/ashwins/Documents/Google Code Jam/2015/QualificationRound/Dijkstra/C-small-attempt3-out.txt";
	Scanner sc;
	PrintWriter pw;
	int[][] quarter = {{1,2,3,4}, {2, -1, 4, -3}, {3, -4, -1, 2}, {4, 3, -2, -1}};

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		new Dijkstra().solve();
	}
	
	private void solve(){
		try {
			StringBuilder output = new StringBuilder();
			sc = new Scanner(new FileReader(input));
			pw = new PrintWriter(out);
			int n = sc.nextInt();
			for (int counter=0; counter<n; counter++) {
				output.append("Case #").append(counter+1).append(": ");
				System.out.print(output.toString());
				if(counter > 0)
					pw.print("\n");
				pw.print(output.toString());
				String result = solveCase();

				System.out.println(result);
				pw.print(result);
				pw.flush();
				output.setLength(0);
			}
			sc.close();
			pw.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("Finished...!!!");
	}

	private String solveCase() {
		boolean isI = false;
		boolean isJ = false;
		boolean isK = false;
		long l = sc.nextInt();
		long x = sc.nextInt();
		if(l * x < 3){
			sc.nextLine();
			sc.nextLine();
			return "NO";
		}
		if(l * x == 3){
			sc.nextLine();
			if(sc.nextLine().equals("ijk")){
				return "YES";
			} else {
				return "NO";
			}
		}
		if(l < 2){
			//No chance of ijk
			sc.nextLine();
			sc.nextLine();
			return "NO";
		}
		sc.nextLine();
		String ip = sc.nextLine();
		ip = ip.replace("i", "2");
		ip = ip.replace("j", "3");
		ip = ip.replace("k", "4");
		int res = 0;
		Counter a = new Counter(ip.length() - 1, 0);
		Counter b = new Counter(ip.length() - 1, 1);
		int A, B;
		A = digitAt(ip.charAt(a.i));
		B = digitAt(ip.charAt(b.i));
		for(long i = 0; i < x * l - 1; i++){
			res = quaternions(A, B);
			if(!isI){
				if(res == 2){
					isI = true;
					a.increment();
					b.increment();
					a.increment();
					b.increment();
					i += 1;
					A = digitAt(ip.charAt(a.i));
					B = digitAt(ip.charAt(b.i));
				} else {
					a.increment();
					b.increment();
					A = res;
					B = digitAt(ip.charAt(b.i));
				}
			} else {
				if(!isJ){
					if(res == 3){
						isJ = true;
						a.increment();
						b.increment();
						i += 1;
						a.increment();
						b.increment();
						A = digitAt(ip.charAt(a.i));
						B = digitAt(ip.charAt(b.i));
					} else {
						a.increment();
						b.increment();
						A = res;
						B = digitAt(ip.charAt(b.i));
					}
				} else {
					if(!isK){
						if(res == 4){
							isK = true;
							a.increment();
							b.increment();
							i += 1;
							a.increment();
							b.increment();
							A = digitAt(ip.charAt(a.i));
							B = digitAt(ip.charAt(b.i));
						} else {
							a.increment();
							b.increment();
							A = res;
							B = digitAt(ip.charAt(b.i));
						}
					}
				}
			}
		}
		if(isI && isJ && isK){
			return "YES";
		} else {
			return "NO";
		}
	}

	private int quaternions(int digitAt, int digitAt2) {
		boolean isNeg = false;
		int  res = 0;
		if(digitAt < 0 && digitAt2 < 0){
			digitAt *= -1;
			digitAt2 *= -1;
		} else if(digitAt < 0){
			isNeg = true;
			digitAt *= -1;
		} else if(digitAt2 < 0){
			isNeg = true;
			digitAt2 *= -1;
		}
		
		res = quarter[digitAt - 1][digitAt2 - 1];
		if(isNeg){
			res *= -1;
		}
		return res;
	}

	private int digitAt(char charAt) {
		return Character.getNumericValue(charAt); 
	}
	
	private class Counter{
		int i;
		int max;
		public Counter(int m, int ii){
			max = m;
			i = ii;
		}
		
		public void increment(){
			i++;
			if(i > max){
				i = 0;
			}
		}
	}
	

}
