import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

import java.util.List;
import java.io.IOException;

import java.util.Collections;
import java.util.ArrayList;
import java.util.Collection;
import java.util.TreeSet;
import java.util.Map;
import java.util.HashMap;

import java.text.DecimalFormat;

import java.math.BigInteger;

public class Cookie {		

	final static Charset ENCODING = StandardCharsets.UTF_8;
	
	public static void main(String[] args) throws IOException {

		String problem =  args.length > 0 ? args[0] : "A";
		String scale =  args.length > 1 ? args[1] : "small";

		String fileName = problem + "-" + scale + "-0.in";
		String outFileName = problem + "-" + scale + "-0.out";
		//InputReader r = new InputReader("A-small-practice.in");
		//int numOfCases = r.open().print().numOfCases();
		Reader in = reader(fileName).open();
		Writer out = writer(outFileName).open();
		int n = in.size();

		for (int i=0; i<n; i++) {
			out.write(i, process(in));
		}
		out.dump();
	}

	public static String process(Reader r){

		String[] vals = r.next().split(" ");

		//log("----------");

		double rate = 2.0d;

		double c = Double.parseDouble(vals[0]);
		double f = Double.parseDouble(vals[1]);
		double x = Double.parseDouble(vals[2]);

		double time = 0.0d;
		double clickTime = 0.0d;

		//log ("c: " + c + ", f: " + f + ", x: " + x);

		while ( (x/rate) > ((c/rate) + x/(rate+f)) ) {

			//log("rate: " + rate);
			//log ("x/rate: " + x/rate);
			//log ("((c/rate) + x/(rate+f)): " + ((c/rate) + x/(rate+f)));

			time += c/rate;
			rate = rate + f;

			//log("time: " + time);
		};

		time += x/rate;

		//log("----------");

		DecimalFormat df = new DecimalFormat("###.0000000");
		return df.format(time);
	}

	static Integer add(Integer a, Integer b){
		return a + b;
	}

	static Integer sub(Integer a, Integer b){
		return a - b;
	}

	static Integer mul(Integer a, Integer b){
		return a * b;
	}

	static Integer div(Integer a, Integer b){
		return a / b;
	}

	static BigInteger add(BigInteger a, BigInteger b){
		return a.add(b);
	}

	static BigInteger sub(BigInteger a, BigInteger b){
		return a.subtract(b);
	}

	static BigInteger mul(BigInteger a, BigInteger b){
		return a.multiply(b);
	}

	static BigInteger div(BigInteger a, BigInteger b){
		return a.divide(b);
	}

	static <T, K> Map<T, K> hashmap(){
		return new HashMap<T, K>();
	}

	static <T> List<T> list(){
		return new ArrayList<T>();
	}

	static void log(Object l){
		System.out.println(String.valueOf(l));
	}
	static Reader reader(String fileName) {

		return new Reader(fileName);
	}
	static Writer writer(String fileName) {

		return new Writer(fileName);
	}
	public static class Reader {

		String fileName = null;
		List<String> lines = null;
		int readIndex = 1;
		public Reader(String fileName){

			this.fileName = fileName;
		}
		public Reader open() throws IOException {

			lines = readInputFile();
			return this;
		}
		public Reader print() {
			for(int i=0;i<this.lines.size();i++){
				System.out.println(this.lines.get(i));
			} 
			return this;
		}
		public int size() {
			return Integer.parseInt(this.lines.get(0));
		}
		public String read(int index) {
			return this.lines.get(index);
		}
		public String next() {
			return this.read(this.readIndex++);
		}

		public List<String> readInputFile() throws IOException {
			Path path = Paths.get(this.fileName);
	    	return Files.readAllLines(path, ENCODING);
		}
	}
	public static class Writer {

		String fileName = null;
		List<String> lines = null;
		public Writer(String fileName){

			this.fileName = fileName;
			this.lines = new ArrayList<String>();
		}
		public Writer open() throws IOException {

			return this;
		}
		public Writer write(int index, String content) {

			this.lines.add("Case #" + (index + 1) + ": " + content);
			return this;
		}
		public Writer dump() throws IOException {
			Path path = Paths.get(this.fileName);
		    try (BufferedWriter writer = Files.newBufferedWriter(path, ENCODING)){
		      for(String line : this.lines){
		        writer.write(line);
		        writer.newLine();
		      }
		    }
		    return this;
		}
	}
}