import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;

import java.util.List;
import java.io.IOException;

import java.util.Collections;
import java.util.ArrayList;
import java.util.Collection;
import java.util.TreeSet;
import java.util.Map;
import java.util.HashMap;

import java.math.BigInteger;

public class Magician {		

	final static Charset ENCODING = StandardCharsets.UTF_8;
	
	public static void main(String[] args) throws IOException {

		String problem =  args.length > 0 ? args[0] : "A";
		String scale =  args.length > 1 ? args[1] : "small";

		String fileName = problem + "-" + scale + "-0.in";
		String outFileName = problem + "-" + scale + "-0.out";
		//InputReader r = new InputReader("A-small-practice.in");
		//int numOfCases = r.open().print().numOfCases();
		Reader in = reader(fileName).open();
		Writer out = writer(outFileName).open();
		int n = in.size();

		for (int i=0; i<n; i++) {
			out.write(i, process(in));
		}
		out.dump();
	}

	public static String process(Reader r){

		Map<Integer, Integer> map = Magician.<Integer, Integer>hashmap();

		int r1 = Integer.parseInt(r.next());
		String[] r1s = new String[4];
		for (int i=0; i<4; i++){
			if (i + 1 == r1)
				r1s = r.next().split(" ");
			else
				r.next();
		}

		int r2 = Integer.parseInt(r.next());
		String[] r2s = new String[4];
		for (int i=0; i<4; i++){
			if (i + 1 == r2)
				r2s = r.next().split(" ");
			else
				r.next();
		}

		String val = "";
		boolean failed = false;

		for (int i=0; i<4 && !failed; i++){
			String r1val = r1s[i];
			for (int j=0; j<4; j++){
				if (r1val.equals(r2s[j])) {
					if (val.equals("")) 
						val = r1val;
					else 
						failed = true;
					break;
				}
			}			
		}

		if (failed)
			return "Bad magician!";
		if (val.equals(""))
			return "Volunteer cheated!";
		return val;
	}

	static Integer add(Integer a, Integer b){
		return a + b;
	}

	static Integer sub(Integer a, Integer b){
		return a - b;
	}

	static Integer mul(Integer a, Integer b){
		return a * b;
	}

	static Integer div(Integer a, Integer b){
		return a / b;
	}

	static BigInteger add(BigInteger a, BigInteger b){
		return a.add(b);
	}

	static BigInteger sub(BigInteger a, BigInteger b){
		return a.subtract(b);
	}

	static BigInteger mul(BigInteger a, BigInteger b){
		return a.multiply(b);
	}

	static BigInteger div(BigInteger a, BigInteger b){
		return a.divide(b);
	}

	static <T, K> Map<T, K> hashmap(){
		return new HashMap<T, K>();
	}

	static <T> List<T> list(){
		return new ArrayList<T>();
	}

	static void log(Object l){
		System.out.println(String.valueOf(l));
	}
	static Reader reader(String fileName) {

		return new Reader(fileName);
	}
	static Writer writer(String fileName) {

		return new Writer(fileName);
	}
	public static class Reader {

		String fileName = null;
		List<String> lines = null;
		int readIndex = 1;
		public Reader(String fileName){

			this.fileName = fileName;
		}
		public Reader open() throws IOException {

			lines = readInputFile();
			return this;
		}
		public Reader print() {
			for(int i=0;i<this.lines.size();i++){
				System.out.println(this.lines.get(i));
			} 
			return this;
		}
		public int size() {
			return Integer.parseInt(this.lines.get(0));
		}
		public String read(int index) {
			return this.lines.get(index);
		}
		public String next() {
			return this.read(this.readIndex++);
		}

		public List<String> readInputFile() throws IOException {
			Path path = Paths.get(this.fileName);
	    	return Files.readAllLines(path, ENCODING);
		}
	}
	public static class Writer {

		String fileName = null;
		List<String> lines = null;
		public Writer(String fileName){

			this.fileName = fileName;
			this.lines = new ArrayList<String>();
		}
		public Writer open() throws IOException {

			return this;
		}
		public Writer write(int index, String content) {

			this.lines.add("Case #" + (index + 1) + ": " + content);
			return this;
		}
		public Writer dump() throws IOException {
			Path path = Paths.get(this.fileName);
		    try (BufferedWriter writer = Files.newBufferedWriter(path, ENCODING)){
		      for(String line : this.lines){
		        writer.write(line);
		        writer.newLine();
		      }
		    }
		    return this;
		}
	}
}