import java.util.*;

public class DeceitfulWar 
{
    public static void main(String[] args) throws Exception
    {
        Scanner in = new Scanner(System.in);
        
        int taskNumber = in.nextInt();
        for (int task = 1; task < taskNumber + 1; task++)
        {
            int blockNo = in.nextInt();
            
            double [][] w = new double[2][blockNo];
            for (int i = 0; i < blockNo*2; i++) {
                w[i/blockNo][i%blockNo] = in.nextDouble();
            }
            
            Arrays.sort(w[0]);
            Arrays.sort(w[1]);
            
            System.out.printf("Case #%d: %d %d", task, 
                playDeceitfulWar(w[0], w[1]), playWar(w[0], w[1]));
            System.out.println();
        }
    }
    
    public static double [] burnWood(double [] woods, int i)
    {
        int l = woods.length - 1;
        double [] newarray = new double[l];
        
        System.arraycopy(woods, 0, newarray, 0, i);
        System.arraycopy(woods, i+1, newarray, i, l-i);
        
        return newarray; // ^_^
    }
    
    public static int playWar(double [] n, double [] k)
    {
        int score = 0;
        
        double [] _n, _k;
        
        if (n.length == 1) {
            return n[0] > k[0] ? 1 : 0;
        }

        double turn = n[n.length-1];
        _n = burnWood(n, n.length-1); // burn Naoko's wood
        
        int kenTurnIndex = 0;
        for (int i = 0; i < k.length; i++)
        {
            if (k[i] > turn) 
            {
                kenTurnIndex = i;
                break;
            }
        }
        
        if (turn > k[kenTurnIndex]) {
            score++;
        }
        
        _k = burnWood(k, kenTurnIndex); // burn Ken's wood
        
        return score + playWar(_n, _k);
    }
    
    public static int playDeceitfulWar(double [] n, double [] k)
    {
        int score = 0;
        double [] _n, _k;
        
        if (n.length == 1) {
            return n[0] > k[0] ? 1 : 0;
        }

        double turn;
        if (n[n.length-1] > k[k.length-1]) 
        {
            turn = n[n.length-1];
            _n = burnWood(n, n.length-1); 
        }
        else
        {
            _n = burnWood(n, 0); 
            turn = k[k.length-1] - 1e-11d; // Типа одурачили Кена
        }
        
        int kenTurnIndex = k.length-1;
        for (int i = 0; i < k.length; i++)
        {
            if (k[i] > turn) 
            {
                kenTurnIndex = i;
                break;
            }
        }
                
        if (turn > k[kenTurnIndex]) {
            score++;
        }
        
        _k = burnWood(k, kenTurnIndex);
        
        return score + playDeceitfulWar(_n, _k);
    }
}
