package GoogleJam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.HashSet;

public class Solution2014 {
	private Solution2014(){}
	
	public static void main(String[] args) throws IOException{
		String file = "C:/zfeng/B-small-attempt0.in";
		String output = "C:/zfeng/A-small-attempt0.out";
//		String file = "C:/zfeng/B-small-practice.in";
//		String output = "C:/zfeng/output.txt";
		BufferedReader content =  new BufferedReader(new FileReader(file));	
		PrintWriter outputFile = new PrintWriter(new FileWriter(output));
		
		int num_cases = Integer.parseInt( content.readLine() );
		
		for( int i = 1; i<=num_cases; i++ ){
//			int D = Integer.parseInt( content.readLine() );
			String dataRow = content.readLine();
			String[] data = dataRow.split(" ");
			int L = Integer.parseInt( data[0] );
			long X = Long.parseLong( data[1] );
			dataRow = content.readLine();
			int XX = ((int)X%4) + 400;
			
			String num = Dijkstra( L, XX, dataRow );
			
			System.out.println("Case #"+i+": "+num);
			outputFile.println("Case #"+i+": "+num);			
		}
		
		content.close();
		outputFile.close();		
	}
	
	public static String Dijkstra(int L, int X, String str){
		if( L*X<3 || str.length()==1) return "NO";
		
		boolean allEqual = true;
		for(int i= 1; i<L; i++){
			if( str.charAt(i) != str.charAt(0) ){
				allEqual = false;
				break;
			}
		}		
		if(allEqual) return "NO";
		
		boolean sign = true;
		int left = 1;
		char leftCh = str.charAt(0);
		char[] res = new char[2];
		while('i'!=leftCh && left<L*X){	
			mapDijkstra(leftCh, str.charAt(left), res);
			if( res[0] == '-')
				sign = !sign;
			if( res[1] == '1' ){
				left++;
				if( left==L ){
					left = 0;
					X--;
				}
				leftCh = str.charAt(left);
			}else
				leftCh = res[1];
			left++;
			if( left==L ){
				left = 0;
				X--;
			}
		}
		
		if( left==L*X )
			return "NO";
		leftCh = str.charAt(left);
		left++;
		if( left==L ){
			left = 0;
			X--;
		}
		while('j'!=leftCh && left<L*X){	
			mapDijkstra(leftCh, str.charAt(left), res);
			if( res[0] == '-')
				sign = !sign;
			if( res[1] == '1' ){
				left++;
				if( left==L ){
					left = 0;
					X--;
				}
				leftCh = str.charAt(left);
			}else
				leftCh = res[1];
			left++;
			if( left==L ){
				left = 0;
				X--;
			}
		}
		if( left==L*X )
			return "NO";
		
		leftCh = str.charAt(left);
		left++;
		if( left==L ){
			left = 0;
			X--;
		}
		while('k'!=leftCh && left<L*X){	
			mapDijkstra(leftCh, str.charAt(left), res);
			if( res[0] == '-')
				sign = !sign;
			if( res[1] == '1' ){
				left++;
				if( left==L ){
					left = 0;
					X--;
				}
				leftCh = str.charAt(left);
			}else
				leftCh = res[1];
			left++;
			if( left==L ){
				left = 0;
				X--;
			}
		}
		
		if( left==L*X )
			return 'k'==leftCh?"YES":"NO";
		
		leftCh = str.charAt(left);
		X = (X-1)%4+1;
		left++;
		if( left==L ){
			left = 0;
			X--;
		}		
		while(left<L*X){	
			mapDijkstra(leftCh, str.charAt(left), res);
			if( res[0] == '-')
				sign = !sign;
			if( res[1] == '1' ){
				left++;
				if( left==L ){
					left = 0;
					X--;
				}
				if( left<L*X )
					leftCh = str.charAt(left);
				else{
					leftCh = res[1];
					break;
				}
			}else
				leftCh = res[1];
			left++;
			if( left==L ){
				left = 0;
				X--;
			}
		}
		
		if( leftCh=='1' && sign )
			return "YES";
		else
			return "NO";
				
	}
	
	public static void mapDijkstra( char x, char y, char[] res){
		if( x==y ){
			res[0] = '-';res[1] = '1';
			return;
		}
		if( x=='i'){
			if( y=='j'){
				res[0] = ' ';res[1] = 'k';
			}else{
				res[0] = '-';res[1] = 'j';
			}			
		}else if( x=='j'){
			if( y=='i'){
				res[0] = '-';res[1] = 'k';
			}else{
				res[0] = ' ';res[1] = 'i';
			}			
		}else{
			if( y=='i'){
				res[0] = ' ';res[1] = 'j';
			}else{
				res[0] = '-';res[1] = 'i';
			}			
		}
	}
	
	public static int InfiniteHouseofPancakes(int D, String str){
		String[] ch = str.split(" ");
		int[] A = new int[D];
		int sum = 0, max = 0;
		for(int i=0;i<D;i++){
			A[i] = Integer.parseInt( ch[i] );
			sum += A[i];
			max = Math.max(A[i], max);
		}
		int x = (int) Math.sqrt( sum );
		
		int num = minSqrtArr(A, x);
		for(int i=1;i<=100;i++){
			if( x+i>max )
				break;
			int num_test = minSqrtArr(A, x+i);
			num = Math.min(num, num_test);
		}		
		for(int i=1;i<=100;i++){
			if( x-i<1 )
				break;
			int num_test = minSqrtArr(A, x-i);
			num = Math.min(num, num_test);
		}	
		return num;
	}
	
	public static int minSqrtArr(int[] A, int x){
		int num = x;
		for(int a:A){
			num += (int)Math.ceil(1.0*a/x)-1;
		}
		return num;
	}
	
	
	public static int StandingOvation( String str){
		String[] data = str.split(" ");
		int smax = Integer.parseInt( data[0] );
		
		int friend = 0, stands = 0;;
		for( int i=0; i<=smax; i++){
			int audi = data[1].charAt(i)-'0';
			if( stands<i ){
				int newInvite = i-stands;
				friend += newInvite;
				stands += newInvite;
			}
			stands += audi;
		}
		
		return friend;
	}

}
