package ch.me;

import org.apache.commons.io.IOUtils;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 * @author Andrei Socaciu
 */
public class P1 {

    public static void main(String[] args) throws Exception {
        InputStream inputStream = P1.class.getResourceAsStream("/A-large.in");
        List<String> lines = IOUtils.readLines(inputStream);
        lines.remove(0);
        List<String> results = IntStream.range(0, lines.size()).mapToObj(i -> solve(i, lines.get(i))).collect(Collectors.toList());
        try (FileOutputStream out = new FileOutputStream("A.large.out.txt")) {
            IOUtils.writeLines(results, "\n", out);
        }


    }

    private static String solve(int caseNo, String input) {
        String levels = input.split(" ")[1];
        int personsSoFar = 0;
        int personsAdded = 0;
        for (int i = 0; i < levels.length(); i++) {
            int personsWithLeveli = Integer.parseInt(levels.substring(i, i+1));
            if (i == 0) {
                personsSoFar += personsWithLeveli;
            } else {
                if (personsSoFar < i) {
                    int toAdd = i - personsSoFar;
                    personsSoFar += personsWithLeveli + toAdd;
                    personsAdded += toAdd;
                } else {
                    personsSoFar += personsWithLeveli;
                }
            }
        }
        return "Case #" + (caseNo + 1) + ": " + personsAdded;
    }

}
