// Author: Alejandro Sotelo Arevalo
package round1a;

import java.io.*;
import java.util.*;

public class A_AlphabetCake { // small: OK, large: OK
  private static final String FILENAME="A-small-attempt0";
  private static final boolean STANDARD_OUTPUT=false;
  public static void main(String[] args) throws Throwable {
    try (BufferedReader in=new BufferedReader(new FileReader(FILENAME+".in"))) {
      try (PrintStream out=!STANDARD_OUTPUT?new PrintStream(FILENAME+".out"):System.out) {
        for (int t=1,T=Integer.parseInt(in.readLine()); t<=T; t++) {
          StringTokenizer tokenizer=new StringTokenizer(in.readLine());
          int R=Integer.parseInt(tokenizer.nextToken());
          int C=Integer.parseInt(tokenizer.nextToken());
          char[][] cake=new char[R][C];
          for (int r=0; r<R; r++) {
            cake[r]=in.readLine().toCharArray();
          }
          new SlowSolution(R,C,cake).solveSlow();
          out.println("Case #"+t+":");
          for (char[] row:cake) {
            out.println(new String(row));
          }
        }
      }
    }
  }
  static class SlowSolution {
    int R,C;
    char[][] cake;
    char[] letters;
    int[] rowsPerLetter;
    int[] colsPerLetter;
    SlowSolution(int R, int C, char[][] cake) {
      this.R=R;
      this.C=C;
      this.cake=cake;
    }
    void solveSlow() {
      String strLetters="";
      Map<Character,int[]> mapPositions=new TreeMap<>();
      for (int r=0; r<R; r++) {
        for (int c=0; c<C; c++) {
          if (cake[r][c]!='?') {
            mapPositions.put(cake[r][c],new int[]{r,c});
            strLetters+=cake[r][c];
          }
        }
      }
      letters=strLetters.toCharArray();
      rowsPerLetter=new int[letters.length];
      colsPerLetter=new int[letters.length];
      for (int z=0; z<letters.length; z++) {
        int position[]=mapPositions.get(letters[z]);
        rowsPerLetter[z]=position[0];
        colsPerLetter[z]=position[1];
      }
      test(0);
    }
    boolean test(int k) {
      if (k==letters.length) {
        for (int r=0; r<R; r++) {
          for (int c=0; c<C; c++) {
            if (cake[r][c]=='?') return false;
          }
        }
        return true;
      }
      int rc=rowsPerLetter[k],cc=colsPerLetter[k];
      if (cake[rc][cc]!=letters[k]) throw new IllegalStateException();
      for (int r1=0; r1<=rc; r1++) {
        for (int c1=0; c1<=cc; c1++) {
          for (int r2=rc; r2<R; r2++) {
            loop:for (int c2=cc; c2<C; c2++) {
              for (int r=r1; r<=r2; r++) {
                for (int c=c1; c<=c2; c++) {
                  if (cake[r][c]!='?'&&cake[r][c]!=cake[rc][cc]) continue loop;
                }
              }
              for (int r=r1; r<=r2; r++) {
                for (int c=c1; c<=c2; c++) {
                  cake[r][c]=letters[k];
                }
              }
              if (test(k+1)) return true;
              for (int r=r1; r<=r2; r++) {
                for (int c=c1; c<=c2; c++) {
                  cake[r][c]='?';
                }
              }
              cake[rc][cc]=letters[k];
            }
          }
        }
      }
      return false;
    }
  }
}
