// Author: Alejandro Sotelo Arevalo
package round1a;

import java.io.*;
import java.util.*;

public class B_Ratatouille { // small: ?, large: ?
  private static final String FILENAME="B-small-attempt0";
  private static final boolean STANDARD_OUTPUT=false;
  public static void main(String[] args) throws Throwable {
    try (BufferedReader in=new BufferedReader(new FileReader(FILENAME+".in"))) {
      try (PrintStream out=!STANDARD_OUTPUT?new PrintStream(FILENAME+".out"):System.out) {
        for (int t=1,T=Integer.parseInt(in.readLine()); t<=T; t++) {
          StringTokenizer tokenizer=new StringTokenizer(in.readLine());
          int N=Integer.parseInt(tokenizer.nextToken());
          int P=Integer.parseInt(tokenizer.nextToken());
          int grams[]=new int[N],quantities[][]=new int[N][P];
          tokenizer=new StringTokenizer(in.readLine());
          for (int n=0; n<N; n++) {
            grams[n]=Integer.parseInt(tokenizer.nextToken());
          }
          for (int n=0; n<N; n++) {
            tokenizer=new StringTokenizer(in.readLine());
            for (int p=0; p<P; p++) {
              quantities[n][p]=Integer.parseInt(tokenizer.nextToken());
            }
          }
System.out.println(N+";"+P);          
          long maxQnt=0;
          for (int n=0; n<N; n++) {
            for (int p=0; p<P; p++) {
              maxQnt=Math.max(maxQnt,(int)Math.ceil(1.1*quantities[n][p]/grams[n]));
            }
          }
          int SOURCE=N*P*2,SINK=SOURCE+1;
          int solution=0;
          Set<String> edges=new HashSet<>();
          MaxFlow_MinCost mfmc=new MaxFlow_MinCost(2+N*P*2);
          for (int n=0; n<N; n++) {
            for (int p=0; p<P; p++) {
              mfmc.addEdge(((n*P+p)<<1)|0,((n*P+p)<<1)|1,1,1);
            }
          }
          loop: for (int qnt=1; qnt<=maxQnt; qnt++) {
            Integer[][] mat=new Integer[N][];
            for (int n=0; n<N; n++) {
              List<Integer> ps=new ArrayList<>();
              for (int p=0; p<P; p++) {
                if (quantities[n][p]>=grams[n]*qnt*9/10&&quantities[n][p]<=grams[n]*qnt*11/10) {
                  ps.add(p);
                }
              }
              mat[n]=ps.toArray(new Integer[0]);
            }
            for (int n=0; n<N; n++) {
              if (mat[n].length==0) continue loop;
            }
            for (int n=0; n<N; n++) {
              if (n>0) {
                for (int p1:mat[n-1]) {
                  for (int p2:mat[n]) {
                    if (edges.add(((n-1)*P+p1)+"->"+(n*P+p2))) mfmc.addEdge((((n-1)*P+p1)<<1)|1,((n*P+p2)<<1)|0,1,1);
                  }
                }
              }
              if (n==0) {
                for (int p:mat[n]) {
                  if (edges.add("S->"+(n*P+p))) mfmc.addEdge(SOURCE,((n*P+p)<<1)|0,1,1);
                }
              }
              if (n==N-1) {
                for (int p:mat[n]) {
                  if (edges.add((n*P+p)+"->"+T)) mfmc.addEdge(((n*P+p)<<1)|1,SINK,1,1);
                }
              }
            }
          }
          solution+=mfmc.getMinCostFlow(SOURCE,SINK)[0];
          out.println("Case #"+t+": "+solution);
        }
      }
    }
  }

  // Taken from http://serjudging.vanb.org/wp-content/uploads/jobpostings_artur.java
  // Max-flow Min-cost algorithm, with multiple edges between nodes
  static class MaxFlow_MinCost {

    static final long INF=1000000000;

    private int n;
    private List<Edge>[] edges;

    @SuppressWarnings("unchecked")
    public MaxFlow_MinCost(int n) {
      this.n=n;
      edges=new List[n];
      for (int i=0; i<n; i++)
        edges[i]=new ArrayList<>();
    }

    public void addEdge(int s, int t, int cap, int cost) {
      edges[s].add(new Edge(s,t,edges[t].size(),cap,cost));
      edges[t].add(new Edge(t,s,edges[s].size()-1,0,-cost));
    }

    public long[] getMinCostFlow(int source, int sink) {
      long flow=0,cost=0;
      long[] potential=new long[n]; // allows Dijkstra to work with negative edge weights

      while (true) {
        Edge[] parent=new Edge[n]; // used to store an augmenting path
        long[] dist=new long[n]; // minimal cost to vertex
        Arrays.fill(dist,INF);
        dist[source]=0;

        // Dijkstra on cost
        PriorityQueue<Item> que=new PriorityQueue<>();
        que.add(new Item(0,source));
        while (!que.isEmpty()) {
          Item item=que.poll();
          if (item.dist!=dist[item.v]) continue;

          for (Edge e:edges[item.v]) {
            long temp=dist[item.v]+e.cost+potential[item.v]-potential[e.t];
            // if can push some flow, and new cost is cheaper than push
            if (e.cap>e.flow&&dist[e.t]>temp) {
              dist[e.t]=temp;
              parent[e.t]=e;
              que.add(new Item(temp,e.t));
            }
          }
        }

        // couldn't reach sink
        if (parent[sink]==null) break;
        // update potentials for Dijkstra
        for (int i=0; i<n; i++)
          if (parent[i]!=null) potential[i]+=dist[i];

        // maximum flow that can be pushed
        long augFlow=INF;
        for (int i=sink; i!=source; i=parent[i].s)
          augFlow=Math.min(augFlow,parent[i].cap-parent[i].flow);
        // push the flow
        for (int i=sink; i!=source; i=parent[i].s) {
          Edge e=parent[i];
          e.flow+=augFlow;
          edges[e.t].get(e.rev).flow-=augFlow;
          cost+=augFlow*e.cost;
        }
        flow+=augFlow;
      }

      return new long[]{flow,cost};
    }

    public class Item implements Comparable<Item> {
      long dist;
      int v;

      public Item(long dist, int v) {
        this.dist=dist;
        this.v=v;
      }

      @Override
      public int compareTo(Item that) {
        if (this.dist<that.dist) return -1;
        if (this.dist>that.dist) return 1;
        return 0;
      }
    }

    public class Edge {
      public int s,t,rev,cap,flow,cost;

      public Edge(int s, int t, int reverse, int cap, int cost) {
        this.s=s;
        this.t=t;
        this.rev=reverse;
        this.cap=cap;
        this.cost=cost;
      }
    }
  }

}
