//-Xmx512M -Xss64M
package qualification;
import java.io.*;
import java.math.*;
import java.util.*;
public class DGoroSort {
  private final static String FILE="D-small-attempt0";
  private static int N=1002,P=32;
  private static BigInteger POW10=BigInteger.TEN.pow(P);
  private static BigInteger[][] posibility=new BigInteger[N][];
  private static double[][] probability=new double[N][];
  private static double[][] memory=new double[N][N];
  private static BigInteger[] factorial=new BigInteger[N];
  private static MathContext MATH_CONTEXT=new MathContext(16);
  public static void main(String[] args) throws Throwable {
    for (int i=0; i<N; i++) {
      posibility[i]=new BigInteger[i+1];
      probability[i]=new double[i+1];
      BigInteger comb=BigInteger.ONE;
      BigInteger fact=BigInteger.ONE;
      BigInteger sumt=BigInteger.ZERO;
      for (int j=0; j<=i; j++) {
        if (j>0) sumt=sumt.add(posibility[i][j]=comb.multiply(posibility[i-j][0]));
        if (j<i) comb=comb.multiply(BigInteger.valueOf(i-j)).divide(BigInteger.valueOf(j+1));
        if (j>0) fact=fact.multiply(BigInteger.valueOf(j));
      }
      posibility[i][0]=fact.subtract(sumt);
      factorial[i]=fact;
      for (int j=0; j<=i; j++) {
        // probability[i][j]=new BigDecimal(posibility[i][j]).divide(new BigDecimal(fact),MATH_CONTEXT).doubleValue();
        // Calculate posibility[i][j]/fact
        BigInteger rem=posibility[i][j].remainder(fact);
        BigInteger coo=rem.multiply(POW10).divide(fact);
        if (coo.compareTo(BigInteger.ZERO)>0) {
          probability[i][j]=new BigDecimal(coo,P).doubleValue();
        }
        else {
          probability[i][j]=0.0;
        }
      }
    }
    // for (int i=0; i<=11; i++) new Test(i).perm();
    for (int step=N-1; step>=0; step--) {
      for (int rest=0; rest<N; rest++) {
        if (rest<=1||step>=N-1)  {
          memory[step][rest]=step;
        }
        else {
          double sum=0.0;
          for (int ordered=0; ordered<=rest; ordered++) {
            sum+=probability[rest][ordered]*memory[step+1][rest-ordered];
          }
          memory[step][rest]=sum;
        }
      }
    }
    java.text.DecimalFormat decimalFormat=new java.text.DecimalFormat("0.00000000");
    System.setIn(new FileInputStream(new File("data/"+FILE+".in")));
    System.setOut(new PrintStream(new File("data/"+FILE+".out")));
    Scanner sc=new Scanner(System.in);
    for (int nc=0,T=sc.nextInt(); nc<T; nc++) {
      int N=sc.nextInt(),rest=0;
      for (int i=1; i<=N; i++) if (sc.nextInt()!=i) rest++;
      System.out.println("Case #"+(nc+1)+": "+decimalFormat.format(memory[0][rest]).replace(',','.'));
    }
  }
  @SuppressWarnings("unused")
  private static class Test {
    private int n,counters[],array[],total=0;
    private boolean visited[];
    private Test(int n) {
      this.n=n;
      this.counters=new int[n+1];
      this.array=new int[n];
      this.visited=new boolean[n];
    }
    private void perm() {
      perm(0);
      System.out.println(Arrays.toString(counters).equals(Arrays.toString(posibility[n])));
    }
    private void perm(int i) {
      if (i==n) {
        int ok=0;
        for (int j=0; j<n; j++) {
          if (array[j]==j) ok++;
        }
        counters[ok]++;
        total++;
      }
      else {
        for (int j=0; j<n; j++) {
          if (!visited[j]) {
            visited[j]=true;
            array[i]=j;
            perm(i+1);
            visited[j]=false;
          }
        }
      }
    }
  }
}
