// Author: Alejandro Sotelo Arevalo
package round2;

import java.io.*;
import java.util.*;

public class B_RollerCoasterScheduling { // small: OK, large: ?
  private static final String FILENAME="B-large";
  private static final boolean STANDARD_OUTPUT=false;
  public static void main(String[] args) throws Throwable {
    try (Scanner in=new Scanner(new File(FILENAME+".in"))) {
      try (PrintStream out=!STANDARD_OUTPUT?new PrintStream(FILENAME+".out"):System.out) {
        for (int t=1,T=in.nextInt(); t<=T; t++) {
          N=in.nextInt();
          C=in.nextInt();
          M=in.nextInt();
          TICKETS=new Ticket[M];
          for (int m=0; m<M; m++) {
            Ticket ticket=TICKETS[m]=new Ticket();
            ticket.P=in.nextInt();
            ticket.B=in.nextInt();
          }
          promotions=0;
          Arrays.sort(TICKETS,(ticket1, ticket2) -> ticket1.P!=ticket2.P?ticket1.P-ticket2.P:ticket1.B-ticket2.B);
          List<Ride> rides=new ArrayList<>();
          loop: for (Ticket ticket:TICKETS) {
            for (Ride ride:rides) {
              if (ride.sit(ticket)) {
                continue loop;
              }
            }
            Ride ride=new Ride();
            if (!ride.sit(ticket)) throw new IllegalStateException();
            rides.add(ride);
          }
          while (true) {
            int changes=0;
            for (Ticket ticket:TICKETS) {
              if (ticket.Q!=ticket.P) {
                for (Ride ride:rides) {
                  if (ride.Qs.contains(ticket.P)) {
                    ticket.ride.unprocess(ticket);
                    ride.process(ticket,ticket.P);
                    changes++;
                  }
                }
              }
            }
            if (changes==0) break;
          }
          out.println("Case #"+t+": "+rides.size()+" "+promotions);
        }
      }
    }
  }
  static int N,C,M;
  static int promotions=0;
  static Ticket[] TICKETS;
  static class Ticket {
    int P,B,Q;
    Ride ride;
  }
  static class Ride {
    TreeSet<Integer> Qs=new TreeSet<>();
    TreeSet<Integer> Bs=new TreeSet<>();
    Ride() {
      for (int P=1; P<=N; P++) {
        Qs.add(P);
      }
    }
    void unprocess(Ticket ticket) {
      if (ticket.P!=ticket.Q) promotions--;
      Bs.remove(ticket.B);
      Qs.add(ticket.Q);
      ticket.Q=0;
      ticket.ride=null;
    }
    void process(Ticket ticket, int Q) {
      ticket.ride=this;
      ticket.Q=Q;
      Qs.remove(Q);
      Bs.add(ticket.B);
      if (ticket.P!=ticket.Q) promotions++;
    }
    boolean sit(Ticket ticket) {
      if (Bs.contains(ticket.B)) {
        return false;
      }
      else if (Qs.contains(ticket.P)) {
        process(ticket,ticket.P);
        return true;
      }
      else {
        SortedSet<Integer> set=Qs.headSet(ticket.P,true);
        if (set.isEmpty()) return false;
        if (set.last()==ticket.P) throw new IllegalStateException();
        process(ticket,set.last());
        return true;
      }
    }
  }
}
