// Author: Alejandro Sotelo Arevalo
package round1a;

import java.io.*;
import java.util.*;

public class B_RankAndFile {
  // --------------------------------------------------------------------------------
  private static final String FILENAME="data/round1a/B-small-attempt1";
  private static final boolean STANDARD_OUTPUT=false;
  private static BufferedReader in=null;
  private static PrintStream out=null;
  public static void main(String[] args) throws Throwable {
    try (BufferedReader reader=in=new BufferedReader(new FileReader(FILENAME+".in"))) {
      try (PrintStream writer=out=!STANDARD_OUTPUT?new PrintStream(FILENAME+".out"):System.out) {
        process();
      }
    }
  }
  // --------------------------------------------------------------------------------
  private static void process() throws Throwable {
    for (int caseNumber=1,T=Integer.parseInt(in.readLine()); caseNumber<=T; caseNumber++) {
      N=Integer.parseInt(in.readLine());
      arrays=new int[2*N-1][N];
      matrix=new int[N][N];
      answer=null;
      for (int i=0; i<arrays.length; i++) {
        StringTokenizer tokenizer=new StringTokenizer(in.readLine());
        for (int j=0; j<N; j++) {
          arrays[i][j]=Integer.parseInt(tokenizer.nextToken());
        }
      }
      Arrays.sort(arrays,new Comparator<int[]>() {
        @Override
        public int compare(int[] array1, int[] array2) {
          for (int j=0; j<N; j++) {
            int c=array1[j]-array2[j];
            if (c!=0) return c;
          }
          return 0;
        }
      });
      build(0,-1,new boolean[arrays.length]);
      out.print("Case #"+caseNumber+":");
      for (int j=0; j<N; j++) {
        out.print(" "+answer[j]);
      }
      out.println();
    }
  }
  static int N,arrays[][],matrix[][],answer[];
  static void build(int index, int missing, boolean[] visited) {
    if (answer!=null) return;
    if (index==2*N) {
      if (missing!=-1) {
        answer=new int[N];
        int z=missing%2;
        int D=missing/2;
        if (z==0) { // row
          for (int c=0; c<N; c++) {
            answer[c]=matrix[D][c];
          }
        }
        else if (z==1) { // column
          for (int r=0; r<N; r++) {
            answer[r]=matrix[r][D];
          }
        }
      }
    }
    else {
      if (missing==-1) build(index+1,index,visited);
      int z=index%2;
      int D=index/2;
      loop: for (int k=0; k<arrays.length; k++) {
        if (!visited[k]) {
          long zeros=0L;
          if (z==0) { // row
            for (int r=0; r<D; r++) {
              for (int c=0; c<N; c++) {
                if (matrix[r][c]>=arrays[k][c]) continue loop;
              }
            }
            for (int s=0; s<D; s++) {
              if (matrix[D][s]!=0&&matrix[D][s]!=arrays[k][s]) continue loop;
            }
            for (int s=0; s<N; s++) {
              if (matrix[D][s]==0) zeros|=1L<<s;
              matrix[D][s]=arrays[k][s];
            }
          }
          else if (z==1) { // column
            for (int c=0; c<D; c++) {
              for (int r=0; r<N; r++) {
                if (matrix[r][c]>=arrays[k][r]) continue loop;
              }
            }
            for (int s=0; s<=D; s++) {
              if (matrix[s][D]!=0&&matrix[s][D]!=arrays[k][s]) continue loop;
            }
            for (int s=0; s<N; s++) {
              if (matrix[s][D]==0) zeros|=1L<<s;
              matrix[s][D]=arrays[k][s];
            }
          }
          visited[k]=true;
          build(index+1,missing,visited);
          visited[k]=false;
          if (z==0) { // row
            for (int s=0; s<N; s++) {
              if (((zeros>>>s)&1L)==1L) matrix[D][s]=0;
            }
          }
          else if (z==1) { // column
            for (int s=0; s<N; s++) {
              if (((zeros>>>s)&1L)==1L) matrix[s][D]=0;
            }
          }
        }
      }
    }
  }
}
