// Author: Alejandro Sotelo Arevalo
package round2;

import java.io.*;
import java.util.*;

public class C_BeamingWithJoy { // small: ?, large: ?
  private static final String FILENAME="C-small-attempt1";
  private static final boolean STANDARD_OUTPUT=false;
  public static void main(String[] args) throws Throwable {
    try (Scanner in=new Scanner(new File(FILENAME+".in"))) {
      try (PrintStream out=!STANDARD_OUTPUT?new PrintStream(FILENAME+".out"):System.out) {
        for (int t=1,T=in.nextInt(); t<=T; t++) {
          R=in.nextInt();
          C=in.nextInt();
          map=new char[R][];
          fixed=new char[R][C];
          processed=new boolean[R][C];
          numPoints=0;
          for (int r=0; r<R; r++) {
            map[r]=in.next().toCharArray();
            for (int c=0; c<C; c++) {
              fixed[r][c]='?';
              if (map[r][c]=='.') numPoints++;
            }
          }
          allCovered=new TreeSet<>();
          inverseMap=new HashMap<>();
          boolean answer=solveEasy();
          out.println("Case #"+t+": "+(answer?"POSSIBLE":"IMPOSSIBLE"));
          if (answer) {
            for (char[] row:map) {
              out.println(new String(row));
            }
          }
        }
      }
    }
  }
  static int R,C,numPoints;
  static char[][] map;
  static char[][] fixed;
  static boolean processed[][];
  static Map<Integer,Set<Inverse>> inverseMap;
  static Set<Integer> allCovered;
  static boolean solveEasy() {
    for (int r=0; r<R; r++) {
      for (int c=0; c<C; c++) {
        if (map[r][c]=='.') inverseMap.put((r<<16)|c,new TreeSet<>());
      }
    }
    for (int r=0; r<R; r++) {
      for (int c=0; c<C; c++) {
        if (map[r][c]=='-'||map[r][c]=='|') {
          if (!test(r,c)) return false;
        }
      }
    }
    for (int r=0; r<R; r++) {
      for (int c=0; c<C; c++) {
        if (map[r][c]=='.') {
          Set<Inverse> set=inverseMap.get((r<<16)|c);
          if (set.isEmpty()) return false;
          if (set.size()==1) {
            Inverse inv=set.iterator().next();
            char type=inv.type;
            int rb=inv.r;
            int cb=inv.c;
            if (fixed[rb][cb]!='?'&&fixed[rb][cb]!=type) return false;
            fixed[rb][cb]=type;
          }
        }
      }
    }
    return simulate(0,0);
  }
  static boolean test(int r, int c) {
    Result resultH=new Result();
    resultH.go(r,c,0,+1);
    resultH.go(r,c,0,-1);
    Result resultV=new Result();
    resultV.go(r,c,+1,0);
    resultV.go(r,c,-1,0);
    if (resultH.isDestroyed&&resultV.isDestroyed) return false;
    if (resultH.isDestroyed) fixed[r][c]='|';
    if (resultV.isDestroyed) fixed[r][c]='-';
    if (!resultH.isDestroyed) {
      for (int emptyPosition:resultH.covered) {
        inverseMap.get(emptyPosition).add(new Inverse(r,c,'-'));
      }
    }
    if (!resultV.isDestroyed) {
      for (int emptyPosition:resultV.covered) {
        inverseMap.get(emptyPosition).add(new Inverse(r,c,'|'));
      }
    }
    return true;
  }
  static boolean simulate(int r, int c) {
    if (c==C) {
      return allCovered.size()==numPoints;
    }
    else if (r==R) {
      return simulate(0,c+1);
    }
    else if (map[r][c]=='-'||map[r][c]=='|') {
      for (char ch:fixed[r][c]!='?'?new char[]{fixed[r][c]}:new char[]{'-','|'}) {
        map[r][c]=ch;
        Result result=new Result();
        if (map[r][c]=='-') {
          result.go(r,c,0,+1);
          result.go(r,c,0,-1);
        }
        else {
          result.go(r,c,+1,0);
          result.go(r,c,-1,0);
        }
        processed[r][c]=true;
        allCovered.addAll(result.coveredNew);
        if (simulate(r+1,c)) return true;
        processed[r][c]=false;
        allCovered.removeAll(result.coveredNew);
      }
      return false;
    }
    else {
      if (map[r][c]=='.'&&!allCovered.contains((r<<16)|c)) {
        int some=0;
        for (Inverse inverse:inverseMap.get((r<<16)|c)) {
          if (!processed[inverse.r][inverse.c]) some++;
        }
        if (some==0) return false;
      }
      return simulate(r+1,c);
    }
  }
  static class Result {
    boolean isDestroyed=false;
    Set<Integer> covered=new TreeSet<>();
    Set<Integer> coveredNew=new TreeSet<>();
    void go(int r, int c, int dr, int dc) {
      int nr=r+dr,nc=c+dc;
      if (nr<0||nr>=R||nc<0||nc>=C||map[nr][nc]=='#') {
      }
      else if (map[nr][nc]=='-'||map[nr][nc]=='|') {
        isDestroyed=true;
      }
      else if (map[nr][nc]=='.') {
        covered.add((nr<<16)|nc);
        if (!allCovered.contains((nr<<16)|nc)) coveredNew.add((nr<<16)|nc);
        go(nr,nc,dr,dc);
      }
      else if (map[nr][nc]=='\\') {
        if (dr==0&&dc==+1) go(nr,nc,+1,0);
        if (dr==0&&dc==-1) go(nr,nc,-1,0);
        if (dr==+1&&dc==0) go(nr,nc,0,+1);
        if (dr==-1&&dc==0) go(nr,nc,0,-1);
      }
      else if (map[nr][nc]=='/') {
        if (dr==0&&dc==+1) go(nr,nc,-1,0);
        if (dr==0&&dc==-1) go(nr,nc,+1,0);
        if (dr==+1&&dc==0) go(nr,nc,0,-1);
        if (dr==-1&&dc==0) go(nr,nc,0,+1);
      }
      else {
        throw new IllegalStateException();
      }
    }
  }
  static class Inverse implements Comparable<Inverse> {
    int r,c;
    char type;
    Inverse(int r, int c, char type) {
      this.r=r;
      this.c=c;
      this.type=type;
    }
    @Override
    public int compareTo(Inverse inv) {
      if (type!=inv.type) return Character.compare(type,inv.type);
      if (r!=inv.r) return r-inv.r;
      if (c!=inv.c) return c-inv.c;
      return 0;
    }
  }
}
