import java.io.*;
import java.util.*;
import java.math.*;

public class AAirportWalkways {
  //private final static String FILE="A-sample";
  //private final static String FILE="A-small-attempt0";
  //private final static String FILE="A-test";
  private final static String FILE="A-large";
  public static void main(String[] args) throws Throwable {
    MathContext MC=new MathContext(500);
    java.text.DecimalFormat df=new java.text.DecimalFormat("0.000000000000");
    System.setIn(new FileInputStream(new File("src/"+FILE+".in")));
    System.setOut(new PrintStream(new File("src/"+FILE+".out")));
    Scanner sc=new Scanner(System.in);
    for (int nc=0,T=sc.nextInt(); nc<T; nc++) {
      long X=sc.nextLong(),S=sc.nextLong(),R=sc.nextLong(),t=sc.nextLong();
      int N=sc.nextInt();
      Intervalo W[]=new Intervalo[N];
      for (int i=0; i<N; i++) {
        W[i]=new Intervalo(sc.nextLong(),sc.nextLong(),sc.nextLong());
      }
      Arrays.sort(W,new Comparator<Intervalo>() {
        public int compare(Intervalo z1, Intervalo z2) {
          return ((Long)(z1.ini)).compareTo((Long)(z2.ini));
        }
      });
      long ini=0;
      ArrayList<Intervalo> list=new ArrayList<Intervalo>(N*2);
      for (Intervalo z:W) {
        if (z.ini!=ini) {
          list.add(new Intervalo(ini,z.ini,0));
        }
        list.add(z);
        ini=z.fin;
      }
      if (list.isEmpty()||list.get(list.size()-1).fin!=X) {
        list.add(new Intervalo(list.get(list.size()-1).fin,X,0));
      }
      Collections.sort(list,new Comparator<Intervalo>() {
        public int compare(Intervalo z1, Intervalo z2) {
          return ((Long)(z1.vel)).compareTo((Long)(z2.vel));
        }
      });
      BigDecimal timeRest=new BigDecimal(t);
      BigDecimal result=new BigDecimal(0.0,MC);
      BigDecimal epsilon=new BigDecimal(1E-25);
      for (Intervalo z:list) {
        BigDecimal distance=new BigDecimal(z.fin-z.ini);
        BigDecimal velocity=new BigDecimal(z.vel).add(new BigDecimal(S),MC);
        BigDecimal superVelocity=new BigDecimal(z.vel).add(new BigDecimal(R,MC));
        BigDecimal time=distance.divide(velocity,MC);
        if (velocity.compareTo(superVelocity)>=0||timeRest.compareTo(epsilon)<0) {
          result=result.add(time,MC);
        }
        else {
          BigDecimal timeA=timeRest.min(distance.divide(superVelocity,MC));
          BigDecimal distanceA=superVelocity.multiply(timeA);
          BigDecimal distanceB=distance.subtract(distanceA);
          BigDecimal timeB=distanceB.divide(velocity,MC);
          result=result.add(timeA,MC).add(timeB,MC);
          timeRest=timeRest.subtract(timeA);
        }
      }
      System.out.println("Case #"+(nc+1)+": "+df.format(result).replace(',','.'));
    }
  }
  private static class Intervalo {
    private long ini;
    private long fin;
    private long vel;
    private Intervalo(long ini, long fin, long vel) {
      this.ini=ini;
      this.fin=fin;
      this.vel=vel;
    }
  }
}
