// Author: Alejandro Sotelo Arevalo
package round2;

import java.io.*;
import java.util.*;

public class B_UpAndDown {
  // --------------------------------------------------------------------------------
  private static String ID="B";
  private static String NAME="small-attempt0";
  private static String STAGE="round2";
  private static boolean STANDARD_OUTPUT=false;
  // --------------------------------------------------------------------------------
  private static BufferedReader reader=null;
  private static PrintStream output=null;
  // --------------------------------------------------------------------------------
  public static void main(String[] args) throws Throwable {
    try (BufferedReader bufferedReader=reader=new BufferedReader(new FileReader(new File("data/"+STAGE+"/"+ID+"-"+NAME+".in")))) {
      try (PrintStream printStream=output=STANDARD_OUTPUT?System.out:new PrintStream(new File("data/"+STAGE+"/"+ID+"-"+NAME+".out"))) {
        process();
      }
    }
  }
  // --------------------------------------------------------------------------------
  private static void process() throws Throwable {
    for (int c=1,T=Integer.parseInt(reader.readLine()); c<=T; c++) {
      int N=Integer.parseInt(reader.readLine());
      StringTokenizer tokenizer=new StringTokenizer(reader.readLine());
      long data[]=new long[N];
      for (int i=0; i<N; i++) {
        data[i]=Long.parseLong(tokenizer.nextToken());
      }
      int r=solveSmall(N,data);
      output.println("Case #"+c+": "+r);
    }
  }
  private static int solveSmall(int N, long[] data) {
    long max=0L;
    for (int i=0; i<N; i++) {
      max=Math.max(max,data[i]);
    }
    int r=Integer.MAX_VALUE;
    long data2[]=new long[N],data3[]=new long[N];
    for (int v=0; v<(1<<N); v++) {
      for (int i=0; i<N; i++) {
        if (((v>>>i)&1)==1) {
          data2[i]=max*4-data[i];
        }
        else {
          data2[i]=data[i];
        }
      }
      numSwaps=0;
      mergeSort(data2,data3,0,N-1);
      r=Math.min(r,numSwaps);
    }
    return r;
  }
  private static int numSwaps=0;
  private static void mergeSort(long[] arr, long[] arrTmp, int pi, int pf) {
    if (pf<=pi) return;
    int m=(pi+pf)/2+1,i,j,k;
    mergeSort(arr,arrTmp,pi,m-1);
    mergeSort(arr,arrTmp,m,pf);
    for (i=pi,j=m,k=pi; i<=m-1&&j<=pf; k++) {
      if (arr[i]<=arr[j]) {
        arrTmp[k]=arr[i++];
      }
      else {
        numSwaps+=j-k;
        arrTmp[k]=arr[j++];
      }
    }
    for (; i<=m-1; k++,i++) {
      arrTmp[k]=arr[i];
    }
    for (k=pi; k<j; k++) {
      arr[k]=arrTmp[k];
    }
  }

}
