// Author: Alejandro Sotelo Arevalo
package round1a;

import java.io.*;
import java.util.*;

public class C_PlayTheDragon { // small: ?, large: ?
  private static final String FILENAME="C-small-attempt0";
  private static final boolean STANDARD_OUTPUT=false;
  public static void main(String[] args) throws Throwable {
    try (BufferedReader in=new BufferedReader(new FileReader(FILENAME+".in"))) {
      try (PrintStream out=!STANDARD_OUTPUT?new PrintStream(FILENAME+".out"):System.out) {
        for (int t=1,T=Integer.parseInt(in.readLine()); t<=T; t++) {
          StringTokenizer tokenizer=new StringTokenizer(in.readLine());
          Hd=Integer.parseInt(tokenizer.nextToken());
          Ad=Integer.parseInt(tokenizer.nextToken());
          Hk=Integer.parseInt(tokenizer.nextToken());
          Ak=Integer.parseInt(tokenizer.nextToken());
          B=Integer.parseInt(tokenizer.nextToken());
          D=Integer.parseInt(tokenizer.nextToken());
          Integer solution=solveSlow();
          out.println("Case #"+t+": "+(solution!=null?solution.toString():"IMPOSSIBLE"));
        }
      }
    }
  }
  static long Hd,Ad,Hk,Ak,B,D;
  static Integer solveSlow() {
    Set<State> visited=new HashSet<>();
    Set<State> level=new HashSet<>();
    State firstState=new State(Hd,Ad,Hk,Ak);
    level.add(firstState);
    visited.add(firstState);
    int step=1;
    while (!level.isEmpty()) {
      Set<State> newLevel=new HashSet<>(level.size());
      for (State state:level) {
        if (state.Hk-state.Ad<=0) return step;
        {
          State newState=state.copy();
          newState.Hk-=newState.Ad;
          newState.Hd-=newState.Ak;
          if (newState.Hd>0&&visited.add(newState)) newLevel.add(newState);
        }
        if (B>0) {
          State newState=state.copy();
          newState.Ad+=B;
          newState.Hd-=newState.Ak;
          if (newState.Hd>0&&visited.add(newState)) newLevel.add(newState);
        }
        if (state.Hd<Hd) {
          State newState=state.copy();
          newState.Hd=Hd;
          newState.Hd-=newState.Ak;
          if (newState.Hd>0&&visited.add(newState)) newLevel.add(newState);
        }
        if (D>0) {
          State newState=state.copy();
          newState.Ak=Math.max(0,state.Ak-D);
          newState.Hd-=newState.Ak;
          if (newState.Hd>0&&visited.add(newState)) newLevel.add(newState);
        }
      }
      step++;
      level=newLevel;
    }
    return null;
  }
  static class State {
    long Hd,Ad,Hk,Ak;
    State(long hd, long ad, long hk, long ak) {
      Hd=hd;
      Ad=ad;
      Hk=hk;
      Ak=ak;
    }
    State copy() {
      return new State(Hd,Ad,Hk,Ak);
    }
    @Override
    public int hashCode() {
      long p=(Hd<<24)^(Ad<<16)^(Hk<<8)^Ak;
      return (int)((p>>>32)^p);
    }
    @Override
    public boolean equals(Object obj) {
      State state=(State)obj;
      return Hd==state.Hd&&Ad==state.Ad&&Hk==state.Hk&&Ak==state.Ak;
    }
  }
}
