import java.io.*;
import java.util.*;
import java.math.*;

public class BSpinningBlade {
  //private final static String FILE="B-sample";
  //private final static String FILE="B-small-attempt0";
  //private final static String FILE="B-small-attempt1";
  //private final static String FILE="B-test";
  private final static String FILE="B-large";
  public static void main(String[] args) throws Throwable {
    System.setIn(new FileInputStream(new File("src/"+FILE+".in")));
    System.setOut(new PrintStream(new File("src/"+FILE+".out")));
    Scanner sc=new Scanner(System.in);
    for (int nc=0,T=sc.nextInt(); nc<T; nc++) {
      int R=sc.nextInt();
      int C=sc.nextInt();
      long D=sc.nextLong();
      long data[][][]=new long[3][R][C];
      long accu[][][]=new long[3][R][C];
      for (int r=0; r<R; r++) {
        char array[]=sc.next().toCharArray();
        for (int c=0; c<C; c++) {
          long mass=D+(array[c]-'0');
          data[0][r][c]=mass;
          data[1][r][c]=mass*((c+1)*2-1);
          data[2][r][c]=mass*((R-r)*2-1);
        }
      }
      for (int z=0; z<3; z++) {
        long M[][]=data[z];
        long A[][]=accu[z];
        for (int r=0; r<R; r++) {
          for (int c=0; c<C; c++) {
            if (r==0&&c==0) {
              A[r][c]=M[r][c];
            }
            else if (r==0&&c>0) {
              A[r][c]=M[r][c]+A[r][c-1];
            }
            else if (r>0&&c==0) {
              A[r][c]=M[r][c]+A[r-1][c];
            }
            else {
              A[r][c]=M[r][c]+A[r-1][c]+A[r][c-1]-A[r-1][c-1];
            }
          }
        }
      }
      int result=-1;
      for (int r=0; r<R; r++) {
        for (int c=0; c<C; c++) {
          int K=Math.min(R-r,C-c);
          for (int k=result==-1?3:result+1; k<=K; k++) {
            int rA=r,cA=c;
            int rB=r,cB=c+k-1;
            int rC=r+k-1,cC=c+k-1;
            int rD=r+k-1,cD=c;
            long mass=extractInfo(accu[0],data[0],rA,cA,rB,cB,rC,cC,rD,cD);
            long sumC=extractInfo(accu[1],data[1],rA,cA,rB,cB,rC,cC,rD,cD);
            long sumR=extractInfo(accu[2],data[2],rA,cA,rB,cB,rC,cC,rD,cD);
            boolean checkC=BigInteger.valueOf(sumC).equals(BigInteger.valueOf(2*cA+k).multiply(BigInteger.valueOf(mass)));
            boolean checkR=BigInteger.valueOf(sumR).equals(BigInteger.valueOf(2*(R-rC-1)+k).multiply(BigInteger.valueOf(mass)));
            //if (r==1&&c==1&&k==5) {
            //  System.out.println("r="+r+",c="+c+",k="+k+",cc="+(0.5*sumC/mass)+",rr="+(0.5*sumR/mass)+"pc="+(cA+1.0*k/2)+",pr="+((R-rC-1)+1.0*k/2));
            //  System.out.println("r="+r+",c="+c+",k="+k+",mass="+mass+",sumC="+sumC+",sumR="+sumR);
            //}
            if (checkC&&checkR) {              
              result=Math.max(result,k);
            }
          }
        }
      }
      System.out.println("Case #"+(nc+1)+": "+(result==-1?"IMPOSSIBLE":result));
    }
  }
  static void print(long[][] matrix) {
    for (long[] row:matrix) {
      System.out.println(Arrays.toString(row));
    }
    System.out.println("-----");
  }
  static long extractInfo(long[][] accumulated, long data[][], int rA, int cA, int rB, int cB, int rC, int cC, int rD, int cD) {
    long result=accumulated[rC][cC];
    if (rA>0) result-=accumulated[rA-1][cC];
    if (cA>0) result-=accumulated[rC][cA-1];
    if (rA>0&&cA>0) result+=accumulated[rA-1][cA-1];
    result-=data[rA][cA];
    result-=data[rB][cB];
    result-=data[rC][cC];
    result-=data[rD][cD];
    return result;
  }
}
