import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;

public class FairAndSquare {

	public static BigInteger bigIntSqRootFloor(BigInteger x)
			throws IllegalArgumentException {
		if (x.compareTo(BigInteger.ZERO) < 0) {
			throw new IllegalArgumentException("Negative argument.");
		}
		// square roots of 0 and 1 are trivial and
		// y == 0 will cause a divide-by-zero exception
		if (x.compareTo(BigInteger.ZERO)==0 || x.compareTo(BigInteger.ONE)==0) {
			return x;
		} // end if
		BigInteger two = BigInteger.valueOf(2L);
		BigInteger y;
		// starting with y = x / 2 avoids magnitude issues with x squared
		for (y = x.divide(two); y.compareTo(x.divide(y)) > 0; y = ((x.divide(y))
				.add(y)).divide(two))
			;
		return y;
	} // end bigIntSqRootFloor

	public static BigInteger bigIntSqRootCeil(BigInteger x)
			throws IllegalArgumentException {
		if (x.compareTo(BigInteger.ZERO) < 0) {
			throw new IllegalArgumentException("Negative argument.");
		}
		// square roots of 0 and 1 are trivial and
		// y == 0 will cause a divide-by-zero exception
		if (x.compareTo(BigInteger.ZERO)==0 || x.compareTo(BigInteger.ONE)==0) {
			return x;
		} // end if
		BigInteger two = BigInteger.valueOf(2L);
		BigInteger y;
		// starting with y = x / 2 avoids magnitude issues with x squared
		for (y = x.divide(two); y.compareTo(x.divide(y)) > 0; y = ((x.divide(y))
				.add(y)).divide(two))
			;
		if (x.compareTo(y.multiply(y)) == 0) {
			return y;
		} else {
			return y.add(BigInteger.ONE);
		}
	} // end bigIntSqRootCeil

	public static boolean isPalindrome(String str) {
		// test for end of recursion
		if (str.length() < 2) {
			return true;
		}

		// check first and last character for equality
		if (str.charAt(0) != str.charAt(str.length() - 1)) {
			return false;
		}

		// recursion call
		return isPalindrome(str.substring(1, str.length() - 1));
	}

	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(
				new FileReader("files/C-small-attempt1.in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter(
				"files/Csmall.out"));
		String strLine1 = br.readLine();
		for (int i = 0; i < Integer.valueOf(strLine1); i++) {
			String strLine = br.readLine();
			BigInteger minVal = new BigInteger(strLine.split(" ")[0]);
			BigInteger maxVal = new BigInteger(strLine.split(" ")[1]);
			BigInteger minV = bigIntSqRootCeil(minVal);
			BigInteger maxV = bigIntSqRootFloor(maxVal);
			BigInteger v = generateNextPalindrome(minV.subtract(BigInteger.valueOf(1)));
			int count = 0;
			while (v.compareTo(maxV) <= 0) {
				if (isPalindrome(v.multiply(v).toString()))
					count++;
				v = generateNextPalindrome(v);
			}
			bw.write("Case #" + (i + 1) + ": " + count);
			bw.newLine();
		}
		br.close();
		bw.close();
	}

	private static BigInteger generateNextPalindrome(BigInteger minV) {
		String s = minV.toString();
		int size = s.length();
		String halfS = s.substring(0, (int) Math.ceil(size / 2.0));
		BigInteger halfV = new BigInteger(halfS);
		BigInteger nextHalfV = halfV;
		String nextHalfS = nextHalfV.toString();
		BigInteger ret = BigInteger.ZERO;
		while(ret.compareTo(minV)<=0){
		if (size % 2 == 0) {
			if (nextHalfS.length() > halfS.length()) {
				ret = new BigInteger(nextHalfS.substring(0, nextHalfS.length()-1) + new StringBuffer(nextHalfS).reverse().toString());
			} else {
				ret = new BigInteger(nextHalfS + new StringBuffer(nextHalfS).reverse().toString());
			}
		} else {
			if (nextHalfS.length() > halfS.length()) {
				ret = new BigInteger(nextHalfS.substring(0, nextHalfS.length()-1) + new StringBuffer(nextHalfS.substring(0, nextHalfS.length()-1)).reverse().toString());
			} else {
				ret = new BigInteger(nextHalfS.substring(0, nextHalfS.length()-1) + new StringBuffer(nextHalfS).reverse().toString());
			}
		}
		nextHalfV = nextHalfV.add(BigInteger.valueOf(1));
		nextHalfS = nextHalfV.toString();
		}
		return ret;
	}
}
