import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;


public class SpeakingInTongues {

	public static HashMap<Character, Character> LearnMappings(){
		HashMap<Character, Character> hm = new HashMap<Character, Character>();
		String input = "y qee ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv";
		String maps = "a zoo our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up";
		for(int i = 0; i<input.length();i++){
			if (input.charAt(i)==' ')
				continue;
			hm.put(input.charAt(i), maps.charAt(i));
		}
		hm.put('z','q');
		return hm;
	}
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(
					"C:\\aInput.txt"));
			BufferedWriter bw = new BufferedWriter(new FileWriter(
					"C:\\aOutput.txt"));
			String strLine;
			strLine = br.readLine();
			int size = Integer.parseInt(strLine);
			HashMap<Character, Character> hm = LearnMappings();
			for (int i = 1; i <= size; i++) {
				String res = Translate(br.readLine(), hm);
				bw.write("Case #" + i + ": " + res);
				bw.newLine();
			}
			bw.close();
			br.close();
		} catch (Exception e) {
			System.out.println(e.getMessage());
		}
	}
	private static String Translate(String input, HashMap<Character, Character> hm) {
		String out = "";
		for(int i = 0;i<input.length();i++){
			if(input.charAt(i)==' '){
				out += " ";
				continue;
			}
			out += hm.get(input.charAt(i));
		}
		return out;
	}

}
