import java.io.*;
import static java.lang.Math.*;
import java.util.*;
import java.util.function.*;
import java.lang.*;

public class Main {
    final static String fileName = "";
    final static boolean useFiles = false;

    public static void main(String[] args) throws FileNotFoundException {
        InputStream inputStream;
        OutputStream outputStream;
        if (useFiles) {
            inputStream = new FileInputStream(fileName + ".in");
            outputStream = new FileOutputStream(fileName + ".out");
        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Task solver = new Task(in, out);
        solver.solve();
        out.close();
    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream), 32768);
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public double nextDouble(){
        return Double.parseDouble(next());
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public long nextLong(){
        return Long.parseLong(next());
    }

    public byte nextByte(){
        return Byte.parseByte(next());
    }
}

class Task {
    boolean[] calc(TreeSet<Integer> set, int v){
        boolean[] dp = new boolean[v + 1];
        dp[0] = true;
        for (int obj : set) {
            for (int i = v; i >= 0; i--) {
                if (i + obj <= v && dp[i])
                    dp[i + obj] = true;
            }
        }
        return dp;
    }
    public void solve() {
//        int[][] table = new int[][]{
//                {},//0
//                {1},//1
//                {1, 2},//2
//                {1, 2}, //3
//                {1, 2, 3},//4
//                {1, 2, 3}, //5
//                {1, 2, 3},//6
//                {1, 2, 3,4} || {1, 2, 3, 5}||{1, 2, 3, 6},{1, 2, 3, 7}//7
//                {1, 2, 3,5} || {1, 2, 3, 6}||{1, 2, 3, 4}//8
//                {1, 2, 3,5} || {1, 2, 3, 6}||{1, 2, 3, 4}//9
//                {1, 2, 3,5} || {1, 2, 3, 6}||{1, 2, 3, 4}//10
//                {1, 2, 3,5} || {1, 2, 3, 6}//11
//
//        };
        int testsCount = in.nextInt();
        for (int test = 1; test <= testsCount; test++) {
            int c = in.nextInt();
            int d = in.nextInt();
            int v = in.nextInt();
            TreeSet<Integer> denominations = new TreeSet<>();
            for (int i = 0; i < d; i++){
                denominations.add(in.nextInt());
            }
            if (c != 1){
                google(test, "oops");
                continue;
            }
            boolean[] dp = calc(denominations, v);
            for (int i = 0; i <= v; i++){
                if (!dp[i]) {
                    denominations.add(i);
                    dp = calc(denominations, v);
                }
            }
            google(test, denominations.size() - d);
        }
    }

    private InputReader in;
    private PrintWriter out;

    <T> void google(int test, T x){
        out.println("Case #" + test + ": " + x);
    }

    Task(InputReader in, PrintWriter out) {
        this.in = in;
        this.out = out;
    }
}
//            int c = in.nextInt();
//            int w = in.nextInt();
//            if (r == 1) {
//                int res = 0;
//                if (2 * w > c) {
//                    if (w == c)
//                        res = w;
//                    else
//                        res = w + 1;
//                } else {
//                    if (c % w == 0)
//                        res = c / w + w;
//                    else
//                        res = c / w + w + 1;
//                }
//                google(test, res);
//            }