import java.io.*;
import static java.lang.Math.*;
import java.util.*;
import java.util.function.*;
import java.lang.*;

public class Main {
    final static String fileName = "";
    final static boolean useFiles = false;

    public static void main(String[] args) throws FileNotFoundException {
        InputStream inputStream;
        OutputStream outputStream;
        if (useFiles) {
            inputStream = new FileInputStream(fileName + ".in");
            outputStream = new FileOutputStream(fileName + ".out");
        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Task solver = new Task(in, out);
        solver.solve();
        out.close();
    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream), 32768);
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public double nextDouble(){
        return Double.parseDouble(next());
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public long nextLong(){
        return Long.parseLong(next());
    }

    public byte nextByte(){
        return Byte.parseByte(next());
    }
}

class Task {
    public void solve() {
        int testsCount = in.nextInt();
        for (int test = 1; test <= testsCount; test++) {
            int r = in.nextInt();
            int c = in.nextInt();
            int w = in.nextInt();
            if (r == 1) {
                int res = 0;
                if (2 * w > c) {
                    if (w == c)
                        res = w;
                    else
                        res = w + 1;
                } else {
                    if (c % w == 0)
                        res = c / w + w;
                    else
                        res = c / w + w + 1;
                }
                google(test, res);
            }
        }
    }

    private InputReader in;
    private PrintWriter out;

    <T> void google(int test, T x){
        out.println("Case #" + test + ": " + x);
    }

    Task(InputReader in, PrintWriter out) {
        this.in = in;
        this.out = out;
    }
}
