import java.io.*;
import static java.lang.Math.*;
import java.util.*;
import java.util.function.*;
import java.lang.*;

public class Main {
    final static boolean debug = false;
    final static String fileName = "";
    final static boolean useFiles = false;

    public static void main(String[] args) throws FileNotFoundException {
        long start;
        if (debug)
            start = System.nanoTime();
        InputStream inputStream;
        OutputStream outputStream;
        if (useFiles) {
            inputStream = new FileInputStream(fileName + ".in");
            outputStream = new FileOutputStream(fileName + ".out");
        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        Task solver = new Task(in, out);
        solver.solve();
        if(debug)
            out.println((System.nanoTime() - start) / 1e+9);
        out.close();
    }
}

class Task {
    public void solve() {
        int tests = in.nextInt();
        for (int i = 0; i < tests; i++){
            solveTest(i);
        }
    }

    void answer(int testNumber, int value){
        out.println("Case #" + (testNumber + 1) + ": " + value);
    }

    int ceilDiv(int a, int b){
        return (a + b - 1) / b;
    }

    void solveTest(int testNumber) {
        int n = in.nextInt();
        int[] a = new int[n];
        for (int i = 0; i < n; i++)
            a[i] = in.nextInt();
        final int MAXTIME = 1000;
        int minimalTime = MAXTIME;
        for (int time = 1; time <= MAXTIME; time++) {
            int addedTime = 0;
            for (int i = 0; i < n; i++) {
                addedTime += ceilDiv(a[i], time) - 1;
            }
            minimalTime = min(minimalTime, addedTime + time);
        }
        answer(testNumber, minimalTime);
    }

    private InputReader in;
    private PrintWriter out;

    Task(InputReader in, PrintWriter out) {
        this.in = in;
        this.out = out;
    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream), 32768);
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public double nextDouble(){
        return Double.parseDouble(next());
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public char[] nextCharArray(){
        return next().toCharArray();
    }

    public int[] nextIntArray(int n){
        int[] result = new int[n];
        for (int i = 0; i < n; i++)
            result[i] = nextInt();
        return result;
    }

    public long[] nextLongArray(int n){
        long[] result = new long[n];
        for (int i = 0; i < n; i++)
            result[i] = nextLong();
        return result;
    }

    public long nextLong(){
        return Long.parseLong(next());
    }

    public byte nextByte(){
        return Byte.parseByte(next());
    }
}
