import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.FileReader;

import org.junit.Test;

import static junit.framework.Assert.*;

public class AlienLanguageFixture {
	
	@Test
	public void test1() throws Exception {
		String input = 
				"3 5 4\r\n" + 
				"abc\r\n" + 
				"bca\r\n" + 
				"dac\r\n" + 
				"dbc\r\n" + 
				"cba\r\n" + 
				"(ab)(bc)(ca)\r\n" + 
				"abc\r\n" + 
				"(abc)(abc)(abc)\r\n" + 
				"(zyx)bc\r\n";
		
		String output = 
				"Case #1: 2\r\n" + 
				"Case #2: 1\r\n" + 
				"Case #3: 3\r\n" + 
				"Case #4: 0\r\n";
		
		AlienLanguage language = new AlienLanguage();
		String realOutput = language.doIt(input);
		
		System.out.println(realOutput);
		
		assertEquals(output, realOutput);
	}
	
	@Test
	public void test2() throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader("E:\\eclipse-workspaces\\code-jam\\AlienLanguage\\A-large.in"));
		
		AlienLanguage language = new AlienLanguage();
		String realOutput = language.doIt(reader);
		
		System.out.println(realOutput);
	}
	
}
