import java.io.BufferedReader;
import java.io.IOException;
import java.io.StringReader;

public class AlienLanguage {
	
	public String doIt(String input) throws IOException {
		return doIt(new BufferedReader(new StringReader(input)));
	}

	public String doIt(BufferedReader reader) throws IOException {
		String firstLine = reader.readLine().trim();
		String[] split = firstLine.split(" ");
		int L = Integer.parseInt(split[0]);
		int D = Integer.parseInt(split[1]);
		int N = Integer.parseInt(split[2]);
		
		char[][] dictionary = new char[D][];
		for (int i = 0; i < D; i++) {
			dictionary[i] = reader.readLine().trim().toCharArray();
		}
		
		Pattern[] patterns = new Pattern[N];
		for (int i = 0; i < N; i++) {
			patterns[i] = new Pattern(reader.readLine().trim(), L);
		}
		
		StringBuilder result = new StringBuilder();
		for (int i = 0; i < patterns.length; i++) {
			Pattern pattern = patterns[i];
			
			int count = 0;
			for (int j = 0; j < dictionary.length; j++) {
				if (pattern.matches(dictionary[j]))
					count++;
			}
			
			result.append("Case #");
			result.append(i + 1);
			result.append(": ");
			result.append(count);
			result.append("\r\n");
		}
		
		return result.toString();
	}

}
