
public class Pattern {
	
	boolean[][] many;
	int[] single;
	boolean invalid = false;
	
	public Pattern(String text, int length) {
		this.many = new boolean[length][];
		this.single = new int[length];
		
		int n = 0;
		boolean inParenthesis = false;
		
		for (int i = 0; i < text.length(); i++) {
			char c = text.charAt(i);
			switch(c) {
			case '(':
				inParenthesis = true;
				break;
			case ')':
				inParenthesis = false;
				n++;
				break;
			default:
				if (n >= length) {
					invalid = true;
					return;
				}
				
				if (inParenthesis) {
					if (this.many[n] == null) {
						this.many[n] = new boolean[30];
					}
					this.many[n][c - 'a'] = true;
				} else {
					this.single[n] = c - 'a';
				}
				
				if (!inParenthesis) {
					n++;
				}
			}
		}
	}
	
	public boolean matches(char[] text) {
		if (invalid)
			return false;
		
		for (int i = 0; i < text.length; i++) {
			if (many[i] != null) {
				if (!many[i][text[i] - 'a'])
					return false;
			} else {
				if (single[i] != text[i] - 'a')
					return false;
			}
		}
		return true;
	}

}
