import org.junit.Test;

import static junit.framework.Assert.*;

public class AlienLanguageFixture {
	
	@Test
	public void test1() throws Exception {
		String input = 
				"3 5 4\r\n" + 
				"abc\r\n" + 
				"bca\r\n" + 
				"dac\r\n" + 
				"dbc\r\n" + 
				"cba\r\n" + 
				"(ab)(bc)(ca)\r\n" + 
				"abc\r\n" + 
				"(abc)(abc)(abc)\r\n" + 
				"(zyx)bc\r\n";
		
		String output = 
				"Case #1: 2\r\n" + 
				"Case #2: 1\r\n" + 
				"Case #3: 3\r\n" + 
				"Case #4: 0\r\n";
		
		AlienLanguage language = new AlienLanguage();
		String realOutput = language.doIt(input);
		
		System.out.println(realOutput);
		
		assertEquals(output, realOutput);
	}
	
	@Test
	public void test2() throws Exception {
		String input = "10 25 10\r\n" + 
				"kivbzabyhy\r\n" + 
				"asxerlbqto\r\n" + 
				"kjjwxodfyb\r\n" + 
				"aimvllymlf\r\n" + 
				"mnzkssxviq\r\n" + 
				"kubvtzjygj\r\n" + 
				"zgrncfactl\r\n" + 
				"hgzistapoj\r\n" + 
				"gafjvykhwq\r\n" + 
				"qyxklzpmdi\r\n" + 
				"zkqysiruyg\r\n" + 
				"fgilpejani\r\n" + 
				"qdgnptoefr\r\n" + 
				"phdffxqzsq\r\n" + 
				"hzwpklvwni\r\n" + 
				"eemmtbfkin\r\n" + 
				"dzuhgbgwaa\r\n" + 
				"mjaizkwugj\r\n" + 
				"fmprajugve\r\n" + 
				"vydrhksoiv\r\n" + 
				"ovgqfhbdej\r\n" + 
				"njyecypwgk\r\n" + 
				"bdlgusqpiz\r\n" + 
				"mzwspdashg\r\n" + 
				"cwpcaraspj\r\n" + 
				"cqmpxhipys\r\n" + 
				"mzwspdashg\r\n" + 
				"(jyb)(wfk)(olm)(nra)(zdk)(ahj)(xck)(jmr)(qya)(jos)\r\n" + 
				"(xcfh)(nw)(hknp)(djzc)(adlv)(drv)(zajm)(syfh)(psvb)(hjac)\r\n" + 
				"(rstuvwxyabcdeghikmnopq)(zbcdefghjklmoqrstuvwxy)(mnpqrsuvwxyzabcefghijk)(rstuvwxyzbcdefhijklmnop)(stvwxyabcdefghijklmnopq)(defgiklmnopqrstuvxyzabc)(jklnoprtuvxyzabcefghi)(ghimnopqrstuvwxzabcdef)(fghijklmnpqstuwxyabcd)(zbcdefghijlmnopqrstuvxy)\r\n" + 
				"(tuvwxyzabcdefghjklmnoprs)(yzabcdefhjlmnopqrstuvwx)(jlmnoprsuvwxyzabcdfgi)(hiklmnoprsuvwyzacdeg)(tuvwxyzbcfghjklmnopqrs)(uvwxyzabcdefghijknopqrst)(defghijklmnprstuvwxyzb)(uvwxyzabcdeghijkmnopqst)(vwxyzabcdeghijklmnopqrstu)(uvxyabcdefgijkmnopqrs)\r\n" + 
				"(knz)(gpde)(uyjr)(nqyi)(uac)(zbfr)(lrsa)(sbc)(ntvy)(jlst)\r\n" + 
				"(ijklmnoprstuvwxzacdefgh)(efgijklmnoqrstuvwxyzabcd)(wxyabcdefghjklmnpqrstuv)(wxzbcdefghijklmnorsuv)(tuvwxyzabcdefghijklmnopqrs)(tuvwxzbcdeghijklmnopqrs)(jklmnopqrstuvwxyzabcdefghi)(fghiklmnopqrstxyzabcde)(stuvwxzabcdeghjlmopq)(bdefghijklmopqrstuvya)\r\n" + 
				"(zgkn)(zdhi)(rvde)(rvwb)(wzhq)(agn)(bmpx)(nrvy)(zhmp)(syaj)\r\n" + 
				"(abcdefghijklmpqrstuvwxyz)(opqstuwzabcdeghijln)(xyzabcdefghijklnopqrstuv)(pqrstuwxyzacdefghijklmn)(ghijklmnopstuvwxzacdef)(jklmnopqrstuvwzabcdefghi)(tuwxyzacefghjklmnopr)(noprstuvwxyzacefhikl)(defhijklmnopqrstuvxyabc)(prstuvwxyzabcdhijklmno)";
		
		AlienLanguage language = new AlienLanguage();
		String realOutput = language.doIt(input);
		
		System.out.println(realOutput);
	}
	
}
