import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.lang.reflect.Array;
import java.util.Arrays;


public class TicTacToeTomek {


	/* Definition of constants that are used to represent the board state */

	public static final String X_WON = "X won";
	public static final String O_WON = "O won";
	public static final String DRAW = "Draw";
	public static final String NOT_OVER = "Game has not completed";

	public static final String CASE_START = "Case #";
	public static final String CASE_END = ": ";


	/*
	 * Main method of the program.
	 * @param args
	 */
	public static void main(String[] args) throws Exception {

		BufferedReader bf = new BufferedReader( new InputStreamReader( System.in));

		String line = bf.readLine();

		int numCases = Integer.parseInt(line);


		for (int i = 0; i < numCases; i++) {

			char[][] board = new char[4][4];

			for (int j = 0; j < board.length; j++) {
				board[j] = bf.readLine().toCharArray();
			}


			bf.readLine();
			String state = determineState( board );
			String output = CASE_START + (i + 1) + CASE_END + state;
			System.out.println(output);
		}

	}


	/**
	 * Method that determines the state of the board
	 * @param board
	 * @return String 
	 */
	public static String determineState( char[][] board ){

		String result = "";

		char[] columnKeeper = board[0];

		char[] rowKeeper = new char[4];
		
		char diagKeeper = board[0][0];
		
		char rightDiag = board[0][3];

		for (int i = 0; i < columnKeeper.length; i++) {
			rowKeeper[i] = board[i][0];
		}
		
		boolean hasEmpty = false;

		for (int i = 0; i < board.length; i++) {

			for (int j = 0; j < board[i].length; j++) {

				char fil = board[i][j];

				if( rowKeeper[i] != fil && fil != 'T'  || fil == '.'){
					rowKeeper[i] = 'N';
				}
				
				if( columnKeeper[j] != fil && fil != 'T'  || fil == '.' ){
					columnKeeper[j] = 'N';
				}
				
				if( i == j ){
					
					if( fil != diagKeeper && fil != 'T' || fil == '.' ){
						diagKeeper = 'N';
					}
				}
				
				if( i + j == 3){
					
					if( fil != rightDiag && fil != 'T' || fil == '.'){
						rightDiag = 'N';
					}
				}
				
				if( fil == '.' ){
					hasEmpty = true;
				}
			}
		}
		
		boolean xWon = false;
		boolean oWon = false;
		
		for (int i = 0; i < rowKeeper.length; i++) {
			
			if( rowKeeper[i] == 'X' || columnKeeper[i] == 'X' ){
				xWon = true;
			}
			
			if( rowKeeper[i] == 'O' || columnKeeper[i] == 'O'){
				oWon = true;
			}
		}
		
		if(diagKeeper == 'X'){
			xWon = true;
		}else if(diagKeeper == 'O'){
			oWon = true;
		}
		
		if(rightDiag == 'X'){
			xWon = true;
		}else if(rightDiag == 'O'){
			oWon = true;
		}
		
		if(xWon && oWon){
			result = DRAW;
		}else{
			
			if(xWon){
				result = X_WON;
			}else if(oWon){
				result = O_WON;
			}else{
				
				if(!hasEmpty){
					result = DRAW;
				}else{
					result = NOT_OVER;
				}
			}
		}
		
		return result;

}

}
