package problems;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;

/**
 *  Google Code Jam  - 2013 - Fair and Square
 * @author jalopez
 */
public class C {
	
	
	public static final String CASE_START = "Case #";
	public static final String CASE_END = ": ";
	
	
	/**
	 * Main method 
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
	
		
		BufferedReader bf = new BufferedReader( new InputStreamReader( System.in ) );
		
		String line = bf.readLine();
		int numCases = Integer.parseInt( line );
		
		for (int i = 1; i < numCases + 1 ; i++) {
			String[] pieces = bf.readLine().split(" ");
			int a = Integer.parseInt( pieces[0] );
			int b = Integer.parseInt( pieces[1] );
			int num = calculateFairAndSquare(a, b);
			System.out.println(CASE_START + (i) + CASE_END + num );
			
		}
		
	}
	
	/**
	 * Method that finds the number of fair and square numbers.
	 * @param int a - Bottom Interval
	 * @param int b - Superior Interval
	 * @return int num - The number of fair and square numbers
	 */
	
	
	public static int calculateFairAndSquare( Integer a, Integer b){
		
		
		HashMap<Integer, Boolean> map = new HashMap<Integer, Boolean>();
		int num = 0;
		
		for (int i = a; i <= b; i++) {
			
			boolean palindrome = false;
			
			if( map.get(i) != null ) {
				palindrome = map.get(i);
			}else{
				palindrome = isPalindrome("" + i);
				map.put(i, palindrome);
			}
			
			if( palindrome ){
				int sqrtNum  = squareRoot(i);
				
				if( sqrtNum != - 1){
					boolean sqrPalindrome = false;
					
					if( map.get(sqrtNum) != null ){
						sqrPalindrome = map.get(sqrtNum);
					}else{
						sqrPalindrome = isPalindrome("" + sqrtNum);
						map.put(sqrtNum, sqrPalindrome);
					}
				
					if( sqrPalindrome ){
						num++;
					}
				}
				
			}
		}
		return num;
	}
	/**
	 * Method that finds the root square of a number.
	 * @param int number - Int to calculate the sqrt.
	 * @return int sqr - The Square root of the the number or -1 if it's not an integer
	 */
	
	public static int squareRoot( int number ){
		
		double root = Math.sqrt(number);
		return  root == Math.round(root)  ? (int) root : -1;
	}
	
	
	/**
	 * Method that checks if a given string is a palindrome.
	 * @param - String phrase - Possible phrase that could be a palindrome.
	 * @return - Boolean output - True or False depending if the string is a palindrome.
	 */
	
	public static boolean isPalindrome( String phrase ){
		
		boolean response = true;
		int n = phrase.length();
		int limit = n / 2;
		
		for (int i = 0; i < limit && response ; i++) {

			if( phrase.charAt(i)  !=  phrase.charAt(n - 1 - i ) ){
				response = false;
			}
		}
		
		return response;
	}

}
