package problems;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;

/**
 * Google Code Jam - 2013 - Problem B
 * @author jalopez
 */
public class B {
	
	
	public static final String CASE_START = "Case #";
	public static final String CASE_END = ": ";
	
	public static final String YES = "YES";
	public static final String NO = "NO";
	
	
	/**
	 *  Main Method - Reads the input and calls the main method.
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		
		BufferedReader bf = new BufferedReader( new InputStreamReader( System.in) );
		
		String line = bf.readLine();
		int numCases = Integer.parseInt( line );
		
		for (int i = 0; i < numCases; i++) {
			
			String[] pieces = bf.readLine().split(" ");
			int n = Integer.parseInt( pieces[0] );
			int m = Integer.parseInt( pieces[1] );
			
			int[][] board = new int[n][m];
			for (int j = 0; j < n ; j++) {
				pieces = bf.readLine().split(" ");
				for (int k = 0; k < m; k++) {
					board[j][k] = Integer.parseInt(pieces[k]);
				}
			}
			
			String result = CASE_START + ( i + 1 ) + CASE_END + possibleArrangement(board, n, m);
			System.out.println(result);
			
		}
	}
	
	
	public static String possibleArrangement( int[][] board,int n, int m){
		
		String output = "";
		
		int[] rowMaximum = new int[n];
		int[] columnMaximum = new int[m];
		
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < m; j++) {
				
				int value = board[i][j];
				
				if( value > rowMaximum[i] ){
					rowMaximum[i] = value;
				}
				
				if( value > columnMaximum[j] ){
					columnMaximum[j] = value;
				}
			}
		}
		
		
		boolean possible = true;
		
		for (int i = 0; i < n ; i++) {
			for (int j = 0; j < m ; j++) {
				
				int value = board[i][j];
				
				if( value < columnMaximum[j] && value < rowMaximum[i] ){
					possible = false;
				}
			}
		}
		
		output = ( possible ) ? YES : NO;
		
		
		return output;
	}

}
