import java.util.ArrayList;
import java.util.Scanner;

public class BathroomStalls {

	public BathroomStalls() {

		Scanner input = new Scanner(System.in);
		int t = Integer.parseInt(input.nextLine());
		
		for (int i = 0; i < t; i++) {
			//get parameters
			String line = input.nextLine();
			int n = Integer.parseInt(line.split(" ")[0]);
			int k = Integer.parseInt(line.split(" ")[1]);
			
			//create stall objects
			Stall[] stalls = new Stall[n + 2];
			for (int j = 0; j < stalls.length; j++) {
				if (j == 0 || j == stalls.length - 1) { 
					stalls[j] = new Stall(true, j);
				} else {
					stalls[j] = new Stall(false, j);
				}
			}
			
			for (int j = 0; j < k; j++) {
				//get ls and rs
				for (int s = 0; s < n + 2; s++)  {
					if (stalls[s].occupied)
						continue;
					
					for (stalls[s].ls = 0; stalls[s].ls < s; stalls[s].ls++) {
						if (stalls[s - stalls[s].ls - 1].occupied)
							break;
					}
					
					for (stalls[s].rs = 0; stalls[s].rs < stalls.length - s; stalls[s].rs++) {
						if (stalls[s + stalls[s].rs + 1].occupied)
							break;
					}
				}
				
				//get mins
				ArrayList<Stall> mins = new ArrayList<Stall>();
				mins.add(stalls[0]);
				for (Stall s : stalls) {
					if (s.occupied)
						continue;
					if (s.min() > mins.get(0).min()) {
						mins.clear();
						mins.add(s);
					} else if (s.min() == mins.get(0).min()) {
						mins.add(s);
					}
				}
				
				//get maxs
				ArrayList<Stall> maxs = new ArrayList<Stall>();
				maxs.add(mins.get(0));
				for (Stall s : mins) {
					if (s.occupied)
						continue;
					if (s.max() > maxs.get(0).max()) {
						maxs.clear();
						maxs.add(s);
					} else if (s.max() == maxs.get(0).max()) {
						maxs.add(s);
					}
				}
				
				//select leftmost stall
				stalls[maxs.get(0).index].occupied = true;
				
				//check if the last person has entered and print
				if (j == k - 1) {
					System.out.println("Case #" + (i + 1) + ": " + maxs.get(0).max() + " " + maxs.get(0).min());
				}
			}
		}
		
		input.close();
	}
	
	public static void main(String[] args) {
		new BathroomStalls();
	}
	
	private class Stall {
		
		public boolean occupied;
		public int ls, rs, index;
		
		public Stall(boolean occupied, int index) {
			this.occupied = occupied;
			this.index = index;
		}
		
		public int min() {
			return Math.min(ls, rs);
		}
		
		public int max() {
			return Math.max(ls, rs);
		}
		
	}
	
}
