import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

public class TheLastWord {

	private Scanner input;
	private PrintWriter output;
	private int t;
	private String s;
	private char[] chars;
	private int[] numbers;
	private ArrayList<Integer> sortedNumbers;
	private HashMap<Character, Integer> charToInt;
	private HashMap<Integer, Character> intToChar;
	
	public TheLastWord() throws FileNotFoundException {
		input = new Scanner(new File("input.txt"));
		output = new PrintWriter(new File("output.txt"));
		initHashMaps();
		t = Integer.parseInt(input.nextLine());
		
		for (int i = 0; i < t; i++) {
			s = input.nextLine();
			chars = s.toCharArray();
			numbers = convertArray(chars);
			sortedNumbers = new ArrayList<Integer>();
			sortedNumbers.add(numbers[0]);
			for (int j = 1; j < numbers.length; j++){
				if (numbers[j] >= sortedNumbers.get(0)){
					sortedNumbers.add(0, numbers[j]);
				} else {
					sortedNumbers.add(numbers[j]);
				}
			}
			
			System.out.println("Case #" + (i + 1) + ": " + getCharString(sortedNumbers));
			output.println("Case #" + (i + 1) + ": " + getCharString(sortedNumbers));
		}
		
		output.close();
	}
	
	public void initHashMaps() {
		charToInt = new HashMap<Character, Integer>();
		charToInt.put('A', 1);
		charToInt.put('B', 2);
		charToInt.put('C', 3);
		charToInt.put('D', 4);
		charToInt.put('E', 5);
		charToInt.put('F', 6);
		charToInt.put('G', 7);
		charToInt.put('H', 8);
		charToInt.put('I', 9);
		charToInt.put('J', 10);
		charToInt.put('K', 11);
		charToInt.put('L', 12);
		charToInt.put('M', 13);
		charToInt.put('N', 14);
		charToInt.put('O', 15);
		charToInt.put('P', 16);
		charToInt.put('Q', 17);
		charToInt.put('R', 18);
		charToInt.put('S', 19);
		charToInt.put('T', 20);
		charToInt.put('U', 21);
		charToInt.put('V', 22);
		charToInt.put('W', 23);
		charToInt.put('X', 24);
		charToInt.put('Y', 25);
		charToInt.put('Z', 26);
		
		intToChar = new HashMap<Integer, Character>();
		intToChar.put(1, 'A');
		intToChar.put(2, 'B');
		intToChar.put(3, 'C');
		intToChar.put(4, 'D');
		intToChar.put(5, 'E');
		intToChar.put(6, 'F');
		intToChar.put(7, 'G');
		intToChar.put(8, 'H');
		intToChar.put(9, 'I');
		intToChar.put(10, 'J');
		intToChar.put(11, 'K');
		intToChar.put(12, 'L');
		intToChar.put(13, 'M');
		intToChar.put(14, 'N');
		intToChar.put(15, 'O');
		intToChar.put(16, 'P');
		intToChar.put(17, 'Q');
		intToChar.put(18, 'R');
		intToChar.put(19, 'S');
		intToChar.put(20, 'T');
		intToChar.put(21, 'U');
		intToChar.put(22, 'V');
		intToChar.put(23, 'W');
		intToChar.put(24, 'X');
		intToChar.put(25, 'Y');
		intToChar.put(26, 'Z');
	}
	
	public int[] convertArray(char[] chars){
		int[] numbers = new int[chars.length];
		for (int i = 0; i < chars.length; i++){
			numbers[i] = charToInt.get(chars[i]);
		}
		return numbers;
	}
	
	public String getCharString(ArrayList<Integer> numbers) {
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < numbers.size(); i++){
			sb.append(intToChar.get(numbers.get(i)));
		}
		return sb.toString();
	}
	
	public static void main(String[] args) {
		try {
			new TheLastWord();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
}
