import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Dijkstra {

	private Scanner input;
	private int T, L, X;
	private String inputString;
	private String[] lx;
	private StringBuilder sb;
	private char temp;
	private char[] chars;
	private boolean[] ijk;
	private PrintWriter output;

	public Dijkstra() throws FileNotFoundException {

		input = new Scanner(new File("input.txt"));
		T = new Integer(input.nextLine());
		output = new PrintWriter(new File("output.txt"));

		for (int i = 0; i < T; i++) {
			ijk = new boolean[3];
			ijk[0] = false;
			ijk[1] = false;
			ijk[2] = false;
			lx = input.nextLine().split(" ");
			L = Integer.parseInt(lx[0]);
			X = Integer.parseInt(lx[1]);

			inputString = input.nextLine();
			sb = new StringBuilder();
			for (int j = 0; j < X; j++) sb.append(inputString);
			chars = sb.toString().toCharArray();
			temp = chars[0];
			
			for (int j = 1; j < L * X + 1; j++) {
				if (!ijk[0] && temp == 'i'){
					ijk[0] = true;
					temp = chars[j];
					continue;
				} else if (ijk[0] && !ijk[1] && temp == 'j'){
					ijk[1] = true;
					temp = chars[j];
					continue;
				} else if (ijk[0] && ijk[1] && !ijk[2] && temp == 'k' && j == L * X){
					ijk[2] = true;
					break;
				}
				if (j != L * X) temp = multiply(temp, chars[j]);
			}
			
			if (ijk[0] && ijk[1] && ijk[2]){
				System.out.println("Case #" + (i + 1) + ": YES");
				output.println("Case #" + (i + 1) + ": YES");
			}
			if (!ijk[0] || !ijk[1] || !ijk[2]){
				System.out.println("Case #" + (i + 1) + ": NO");
				output.println("Case #" + (i + 1) + ": NO");
			}
		}
		
		output.close();

	}
	
	public static char multiply(char a, char b){
		if (a == '1') return b;
		if (b == '1') return a;
		
		switch (a) {
		case 'i':
			switch (b) {
			case 'i':
				return '2';
			case 'j':
				return 'k';
			case 'k':
				return 'J';
			case '2':
				return 'I';
			case 'I':
				return '1';
			case 'J':
				return 'K';
			case 'K':
				return 'j';
			}
		case 'j':
			switch (b) {
			case 'i':
				return 'K';
			case 'j':
				return '2';
			case 'k':
				return 'i';
			case '2':
				return 'J';
			case 'I':
				return 'k';
			case 'J':
				return '1';
			case 'K':
				return 'I';
			}
		case 'k':
			switch (b) {
			case 'i':
				return 'j';
			case 'j':
				return 'I';
			case 'k':
				return '2';
			case '2':
				return 'K';
			case 'I':
				return 'J';
			case 'J':
				return 'i';
			case 'K':
				return '1';
			}
		case '2':
			switch (b) {
			case 'i':
				return 'I';
			case 'j':
				return 'J';
			case 'k':
				return 'K';
			case '2':
				return '1';
			case 'I':
				return 'i';
			case 'J':
				return 'j';
			case 'K':
				return 'k';
			}
		case 'I':
			switch (b) {
			case 'i':
				return '1';
			case 'j':
				return 'K';
			case 'k':
				return 'j';
			case '2':
				return 'i';
			case 'I':
				return '2';
			case 'J':
				return 'k';
			case 'K':
				return 'J';
			}
		case 'J':
			switch (b) {
			case 'i':
				return 'k';
			case 'j':
				return '1';
			case 'k':
				return 'I';
			case '2':
				return 'j';
			case 'I':
				return 'K';
			case 'J':
				return '2';
			case 'K':
				return 'i';
			}
		case 'K':
			switch (b) {
			case 'i':
				return 'J';
			case 'j':
				return 'i';
			case 'k':
				return '1';
			case '2':
				return 'k';
			case 'I':
				return 'j';
			case 'J':
				return 'I';
			case 'K':
				return '2';
			}
		}
		
		return ' ';
	}

	public static void main(String[] args) {
		try {
			new Dijkstra();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

}
