import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class CountingSheep {

	private Scanner input;

	private PrintWriter output;
	private int t, n, coefficient, product;
	private String sn;
	private boolean finished;
	private boolean[] digits;
	
	public CountingSheep() throws FileNotFoundException {
		input = new Scanner(new File("input.txt"));
		t = new Integer(input.nextLine());
		output = new PrintWriter(new File("output.txt"));
		
		for (int i = 0; i < t; i++) {
			digits = new boolean[10];
			finished = false;
			coefficient = 1;
			n = new Integer(input.nextLine());
			
			if (n == 0){
				System.out.println("Case #" + (i + 1) + ": INSOMNIA");
				output.println("Case #" + (i + 1) + ": INSOMNIA");
				continue;
			}
			
			while (!finished){
				product = coefficient * n;
				sn = String.valueOf(product);
				
				for (int j = 0; j < sn.length(); j++){
					check(sn.charAt(j));
					if (finished)
						break;
				}
				
				coefficient++;
			}
			
			System.out.println("Case #" + (i + 1) + ": " + product);
			output.println("Case #" + (i + 1) + ": " + product);
		}
		
		output.close();
		
	}
	
	public void check(char digit) {
		digits[Integer.parseInt(String.valueOf(digit))] = true;
		
		for (int i = 0; i < 10; i++) {
			if (!digits[i])
				break;
			if (i == 9)
				finished = true;
		}
	}
	
	public static void main(String[] args) {
		try {
			new CountingSheep();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
}
