import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class RevengeOfThePancakes {
	
	private Scanner input;
	private PrintWriter output;
	private int t, flips;
	private String s;
	private boolean[] stack;

	public RevengeOfThePancakes() throws FileNotFoundException {
		input = new Scanner(new File("input.txt"));
		output = new PrintWriter(new File("output.txt"));
		t = new Integer(input.nextLine());
		
		for (int i = 0; i < t; i++) {
			flips = 0;
			s = input.nextLine();
			stack = new boolean[s.length()];
			for (int j = 0; j < s.length(); j++) {
				if (s.charAt(j) == '+'){
					stack[j] = true;
				} else {
					stack[j] = false;
				}
			}
			
			outerloop:
			while (true) {
				for (int j = 0; j < stack.length; j++){
					if (!stack[j])
						break;
					if (j == stack.length - 1)
						break outerloop;
				}
				
				for (int j = 0; j < stack.length; j++) {
					if (!stack[j] && j == 0) {
						break;
					} else if (!stack[j]) {
						flip(j - 1);
						break;
					}
				}
				
				for (int j = stack.length - 1; j >= 0; j--){
					if (!stack[j]){
						flip(j);
						break;
					}
				}
			}
			
			System.out.println("Case #" + (i + 1) + ": " + flips);
			output.println("Case #" + (i + 1) + ": " + flips);
		}
		
		output.close();
	}
	
	public void flip(int index) {
		boolean[] flipped = new boolean[stack.length];
		System.arraycopy(stack, 0, flipped, 0, stack.length);
		for (int i = 0; i <= index; i++) {
			if (stack[i]){
				flipped[index - i] = false;
			} else {
				flipped[index - i] = true;
			}	
		}
		stack = flipped;
		flips++;
	}
	
	public static void main(String[] args) {
		try {
			new RevengeOfThePancakes();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
}
