package com.mani.google.codejam.tictactoe;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 * @TicTacToe.java
 * @author E.Manikandan
 */
public class TicTacToe
{
   private BufferedReader getGameReader() throws FileNotFoundException
   {
      return new BufferedReader(new FileReader(
         "D:\\Mani\\Documents\\Personal\\GodeJam2013\\TTTSmallInput.txt"));
   }
   
   private char[][] getNextGameState(BufferedReader reader) throws IOException
   {
      if (reader != null)
      {
         char[][] gameBoard = new char[4][];
         String first = reader.readLine();
         String second = reader.readLine();
         String third = reader.readLine();
         String fourth = reader.readLine();
         if (first == null || second == null || third == null || fourth == null)
         {
            throw new RuntimeException("Invalid file status");
         }
         gameBoard[0] = first.toCharArray();
         gameBoard[1] = second.toCharArray();
         gameBoard[2] = third.toCharArray();
         gameBoard[3] = fourth.toCharArray();
         // skip empty
         reader.readLine();
         return gameBoard;
      }
      return null;
   }
   
   private char calculateGameResult(char[][] gameBoard)
   {
      int i = 0, j = 0;
      while (i < 4 && j < 4)
      {
         boolean match = true;
         for (int k = 0; k < 4; k++)
         {
            match = match
               && (gameBoard[i][k] != '.')
               && (gameBoard[i][j] == gameBoard[i][k] || gameBoard[i][j] == 'T' || gameBoard[i][k] == 'T');
            if (!match)
            {
               break;
            }
         }
         if (match)
         {
            return gameBoard[i][j];
         }
         match = true;
         for (int k = 0; k < 4; k++)
         {
            match = match
               && (gameBoard[k][j] != '.')
               && (gameBoard[i][j] == gameBoard[k][j] || gameBoard[k][j] == 'T' || gameBoard[i][j] == 'T');
            if (!match)
            {
               break;
            }
         }
         if (match)
         {
            return gameBoard[i][j];
         }
         i++;
         j++;
      }
      i = 1;
      j = 1;
      boolean match = true;
      while (i < 4 && j < 4)
      {
         match = match
            && (gameBoard[i][j] != '.')
            && (gameBoard[i][j] == 'T' || gameBoard[i - 1][j - 1] == 'T' || gameBoard[i][j] == gameBoard[i - 1][j - 1]);
         i++;
         j++;
      }
      if (match)
      {
         return gameBoard[1][1];
      }
      i = 0;
      j = 3;
      match = true;
      while (i < 4 && j > 0)
      {
         match = match
            && (gameBoard[i][j] != '.')
            && (gameBoard[i][j] == 'T' || gameBoard[i + 1][j - 1] == 'T' || gameBoard[i][j] == gameBoard[i + 1][j - 1]);
         i++;
         j--;
      }
      if (match)
      {
         return gameBoard[0][3];
      }
      for (i = 0; i < 4; i++)
      {
         for (j = 0; j < 4; j++)
         {
            if (gameBoard[i][j] == '.')
            {
               return gameBoard[i][j];
            }
         }
      }
      return '-';
   }
   
   public void solveTicTacToePuzzle() throws IOException
   {
      int caseNo = 1;
      BufferedReader reader = getGameReader();
      int gameCount = Integer.parseInt(reader.readLine().trim());
      for (int i = 0; i < gameCount; i++)
      {
         char[][] gameBoard = getNextGameState(reader);
         char winChar = calculateGameResult(gameBoard);
         switch (winChar)
         {
            case 'X':
               System.out.println("Case #" + caseNo + ": X won");
               break;
            case 'O':
               System.out.println("Case #" + caseNo + ": O won");
               break;
            case '.':
               System.out.println("Case #" + caseNo
                  + ": Game has not completed");
               break;
            case '-':
               System.out.println("Case #" + caseNo + ": Draw");
               break;
         }
         caseNo++;
      }
   }
   
   public static void main(String[] args) throws IOException
   {
      new TicTacToe().solveTicTacToePuzzle();
   }
}
