package round2;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

public class Acolypse
{
   class AcolypseInput
   {
      private List numberList = new ArrayList();

      public void addNumber(String number)
      {
         numberList.add(number);
      }
   }

   private static final String INPUT_FILE = "E:\\Work\\Mani\\Oracle\\Eclipse Projects\\GoogleCodeJam\\src\\round1\\input.txt";
   private AcolypseInput[] acolypseInputs;

   public Acolypse() throws IOException
   {
      loadAcolypseInputs();
   }

   private void loadAcolypseInputs() throws IOException
   {
      BufferedReader reader = new BufferedReader(new FileReader(INPUT_FILE));
      String line = null;
      int lineCount = 0;
      int index = 0;
      while ((line = reader.readLine()) != null)
      {
         if (lineCount == 0)
         {
            int caseCount = Integer.valueOf(line).intValue();
            acolypseInputs = new AcolypseInput[caseCount];
         }
         else
         {
            acolypseInputs[index] = new AcolypseInput();
            String[] NKs = line.split(" ");
            for (int i = 1; i < NKs.length; i++)
            {
               acolypseInputs[index].addNumber(NKs[i].trim());
            }
            index++;
         }
         lineCount++;
      }
   }

   public void executeAcolypse()
   {
      for (int i = 0; i < acolypseInputs.length; i++)
      {
         determineCaseOutput(i + 1, acolypseInputs[i]);
      }
   }

   private void determineCaseOutput(int i, AcolypseInput acolypseInput)
   {
      // System.out.println("-----------------------------------------");
      // System.out.println("PROCESSING NUMBERS: " + acolypseInput.numberList);
      List reminderList = new ArrayList();
      for (int j = 0; j < acolypseInput.numberList.size(); j++)
      {
         for (int k = j + 1; k < acolypseInput.numberList.size(); k++)
         {
            BigDecimal reminder1 = new BigDecimal(
               ((String) acolypseInput.numberList.get(j)))
               .remainder(new BigDecimal((String) acolypseInput.numberList
                  .get(k)));
            BigDecimal reminder2 = new BigDecimal(
               ((String) acolypseInput.numberList.get(k)))
               .remainder(new BigDecimal((String) acolypseInput.numberList
                  .get(j)));
            BigDecimal reminder = reminder1.compareTo(reminder2) == -1 ? reminder1
               : reminder2;
            reminderList.add(reminder.toString());
         }
      }
      BigDecimal greatestGCD = new BigDecimal(0);
      BigDecimal minimalReminder = new BigDecimal(0);
      BigDecimal[] numbers = new BigDecimal[acolypseInput.numberList.size()];
      for (int j = 0; j < reminderList.size(); j++)
      {
         BigDecimal currentReminder = new BigDecimal((String) reminderList
            .get(j));
         // System.out.println("CURRENT REMINDER: " + currentReminder);
         for (int k = 0; k < acolypseInput.numberList.size(); k++)
         {
            BigDecimal currentNumber = new BigDecimal(
               (String) acolypseInput.numberList.get(k));
            numbers[k] = currentReminder.add(currentNumber);
         }
         BigDecimal hcf = getHCF(numbers);
         // System.out.println("HCF AFTER ADDING REMINDER " + currentReminder
         // + " IS " + hcf);
         if (hcf.compareTo(greatestGCD) > 0)
         {
            greatestGCD = hcf;
            minimalReminder = currentReminder;
         }
         else if (hcf.compareTo(greatestGCD) == 0
            && currentReminder.compareTo(minimalReminder) < 0)
         {
            minimalReminder = currentReminder;
         }
         if (hcf.compareTo(new BigDecimal(1)) == 0
            && currentReminder.compareTo(new BigDecimal(0)) != 0)
         {
            reminderList.add(currentReminder.subtract(new BigDecimal(1))
               .toString());
         }
      }
      System.out.println("Case #" + i + ": " + minimalReminder);
   }

   private BigDecimal getHCF(BigDecimal[] numbers)
   {
      if (numbers == null || numbers.length == 0)
      {
         return new BigDecimal(-1);
      }
      if (numbers.length == 1)
      {
         return numbers[0];
      }
      BigDecimal gcd = gcd(numbers[0], numbers[1]);
      for (int i = 2; i < numbers.length; i++)
      {
         gcd = gcd(gcd, numbers[i]);
      }
      return gcd;
   }

   private BigDecimal gcd(BigDecimal a, BigDecimal b)
   {
      while (b.compareTo(new BigDecimal(0)) != 0)
      {
         BigDecimal temp = b;
         b = a.remainder(b);
         a = temp;
      }
      return a;
   }

   public static void main(String[] args) throws IOException
   {
      Acolypse acolypse = new Acolypse();
      acolypse.executeAcolypse();
   }
}
