package com.mani.google.codejam.closematch;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * @CloseMatch.java
 * @author E.Manikandan
 */
public class CloseMatch {
   public void runTest(String fileName) throws IOException {
      BufferedReader br = null;
      try {
         br = new BufferedReader(new FileReader(fileName));
         int testCount = Integer.parseInt(br.readLine().trim());
         for (int i = 1; i <= testCount; i++) {
            String line = br.readLine().trim();
            // System.out.println("Problem: " + line);
            char[] cArray = line.split(" ")[0].toCharArray();
            char[] jArray = line.split(" ")[1].toCharArray();
            //System.out.println("cArray = " + new String(cArray) + ", jArray = " + new String(jArray));
            for (int j = 0; j < cArray.length; j++) {
               //System.out.println(cArray[j] + " <=> " + jArray[j]);
               boolean isCGreater = isFirstArrayGreater(cArray, jArray, j);
               boolean isJGreater = isFirstArrayGreater(jArray, cArray, j);
               if (isAllZeros(cArray, j) && isAllZeros(jArray, j) && cArray[j] == '?' && jArray[j] == '?') {
                  cArray[j] = '0';
                  jArray[j] = '0';
               }
               else if (cArray[j] == '?' && jArray[j] == '?') {
                  if (isEqual(cArray, jArray, j)) {
                     cArray[j] = '0';
                     jArray[j] = '0';
                  }
                  else if (isCGreater) {
                     cArray[j] = '0';
                     jArray[j] = '9';
                  }
                  else if (isJGreater) {
                     cArray[j] = '9';
                     jArray[j] = '0';
                  }
               }
               else if (cArray[j] == '?') {
                  if (isEqual(cArray, jArray, j)) {
                     cArray[j] = jArray[j];
                  }
                  else if (isCGreater) {
                     cArray[j] = '0';
                  }
                  else if (isJGreater) {
                     jArray[j] = '9';
                  }
               }
               else if (jArray[j] == '?') {
                  if (isEqual(cArray, jArray, j)) {
                     jArray[j] = cArray[j];
                  }
                  else if (isCGreater) {
                     jArray[j] = '9';
                  }
                  else if (isJGreater) {
                     jArray[j] = '0';
                  }
               }
               //System.out.println(cArray[j] + " <=> " + jArray[j]);
            }
            
            System.out.printf("Case #%d: %s%n", i, new String(cArray) + " " + new String(jArray));
         }
      }
      finally {
         if (br != null) {
            br.close();
         }
      }
   }
   
   private boolean isFirstArrayGreater(char[] array1, char[] array2, int k) {
      if (k == 0) {
         return false;
      }
      for (int i = 0; i < k; i++) {
         if (Character.getNumericValue(array1[i]) > Character.getNumericValue(array2[i])) {
            return true;
         }
         else if (Character.getNumericValue(array1[i]) < Character.getNumericValue(array2[i])) {
            return false;
         }
      }
      return false;
   }
   
   private boolean isEqual(char[] array1, char[] array2, int k) {
      if (k == 0) {
         return true;
      }
      for (int i = 0; i < k; i++) {
         if (array1[i] != array2[i]) {
            return false;
         }
      }
      return true;
   }
   
   private boolean isAllZeros(char[] array, int k) {
      if (k == 0) {
         return true;
      }
      for (int i = 0; i < k; i++) {
         if (array[i] != '0') {
            return false;
         }
      }
      return true;
   }
   
   public static void main(String[] args) throws IOException {
      new CloseMatch().runTest("D:\\Input.txt");
   }
   
}
