package com.mani.google.codejam.pancakeflip;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * @author Manikandan Eswaran
 */
public class PancakeFlip2 {
   
   public void runTest(String fileName) throws IOException {
      BufferedReader br = null;
      try {
         br = new BufferedReader(new FileReader(fileName));
         int testCount = Integer.parseInt(br.readLine().trim());
         for (int i = 1; i <= testCount; i++) {
            String s = br.readLine().trim();
            char[] cArray = s.toCharArray();
            long count = count(cArray);
            System.out.println("Case #" + i + ": " + count);
         }
      }
      finally {
         if (br != null) {
            br.close();
         }
      }
   }
   
   private long count(char[] cArray) {
      // System.out.println("Original: " + new String(cArray));
      long flipCount = 0;
      while (!allHappy(cArray)) {
         int flipPosition = findFlipPosition(cArray);
         // System.out.println("flipPosition = " + flipPosition);
         if (flipPosition != -1) {
            flip(cArray, flipPosition);
            flipCount++;
            // System.out
            // .println("After flip " + flipCount + " : " + new String(cArray));
         }
      }
      return flipCount;
   }
   
   private boolean allHappy(char[] cArray) {
      boolean allHappy = true;
      for (int i = 0; i < cArray.length; i++) {
         allHappy = allHappy && (cArray[i] == '+');
         if (!allHappy) {
            break;
         }
      }
      return allHappy;
   }
   
   private int findFlipPosition(char[] cArray) {
      int flipIndex = -1;
      if (cArray.length == 1 && cArray[0] == '-') {
         flipIndex = 0;
      }
      else {
         for (int i = 0; i < cArray.length; i++) {
            if (i > 0 && (cArray[i] != cArray[i - 1])) {
               flipIndex = i - 1;
               break;
            }
         }
         if (flipIndex == -1 && cArray[0] == '-') {
            flipIndex = cArray.length - 1;
         }
      }
      return flipIndex;
   }
   
   private void flip(char[] cArray, int flipIndex) {
      for (int i = 0; i <= flipIndex; i++) {
         if (cArray[i] == '+') {
            cArray[i] = '-';
         }
         else if (cArray[i] == '-') {
            cArray[i] = '+';
         }
      }
      // System.out.println("Before swap: " + new String(cArray));
      // swap(cArray, flipIndex);
      // System.out.println("After swap: " + new String(cArray));
   }
   
   private void swap(char[] cArray, int swapBoundary) {
      int index = 0;
      char tempChar;
      while (index < swapBoundary) {
         System.out.println("swapping " + index + " & " + swapBoundary);
         tempChar = cArray[index];
         cArray[index] = cArray[swapBoundary];
         cArray[swapBoundary] = tempChar;
         index++;
         swapBoundary--;
      }
   }
   
   public static void main(String[] args) throws IOException {
      // PrintWriter pw = null;
      // try {
      // pw = new PrintWriter(new FileWriter("D:\\Input.txt"));
      // pw.println("100");
      // for (int i = 0; i < 100; i++) {
      // StringBuffer sb = new StringBuffer();
      // int size = new Random().nextInt(101);
      // for (int j = 0; j < size; j++) {
      // if (new Random().nextInt(2) == 0) {
      // sb.append('-');
      // }
      // else {
      // sb.append('+');
      // }
      // }
      // pw.println(sb.toString());
      // }
      // }
      // finally {
      // if (pw != null) {
      // pw.close();
      // }
      // }
      new PancakeFlip2().runTest("D:\\Input.txt");
   }
}
