package com.mani.google.codejam.jamcoin;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedHashMap;
import java.util.Map;

/**
 * @JamCoin.java
 * @author Manikandan Eswaran
 */
public class JamCoin {
   
   class Container {
      int base;
      long base10Value;
      long divisor;
   }
   
   // private Map<String, Map<String, Container>> jamCoinMap = new
   // LinkedHashMap<>();
   
   public void runTest(String fileName) throws IOException {
      BufferedReader br = null;
      try {
         br = new BufferedReader(new FileReader(fileName));
         int testCount = Integer.parseInt(br.readLine().trim());
         for (int i = 1; i <= testCount; i++) {
            String s = br.readLine().trim();
            
            int digits = Integer.parseInt(s.split(" ")[0].trim());
            int count = Integer.parseInt(s.split(" ")[1].trim());
            
            int[] jamCoins = new int[digits];
            
            jamCoins[0] = 1;
            jamCoins[jamCoins.length - 1] = 1;
            
            System.out.println("Case #" + i + ":");
            
            int generatedCount = 0;
            while (true) {
               if (generatedCount == count) {
                  break;
               }
               
               StringBuffer sb = new StringBuffer();
               for (int j = jamCoins.length - 1; j >= 0; j--) {
                  sb.append(jamCoins[j]);
               }
               String jamCoinString = sb.toString();
               
               Map<Integer, Container> containerMap = new LinkedHashMap<Integer, Container>();
               // System.out.println("jamCoins = " + jamCoinString);
               
               boolean isNonPrime = true;
               for (int k = 2; k <= 10; k++) {
                  containerMap.put(k, new Container());
                  long base10Value = convertToBase10Value(jamCoins, k);
                  // System.out
                  // .println("Base " + k + " -> base10 value: " + base10Value);
                  containerMap.get(k).base = k;
                  containerMap.get(k).base10Value = base10Value;
                  isNonPrime = isNonPrime
                     && isNonPrime(base10Value, containerMap.get(k));
                  if (!isNonPrime) {
                     break;
                  }
               }
               if (isNonPrime) {
                  generatedCount++;
                  printJamCoinsAndDivisors(jamCoinString, containerMap);
               }
               flipDigits(jamCoins);
            }
         }
      }
      finally {
         if (br != null) {
            br.close();
         }
      }
   }
   
   private void flipDigits(int[] jamCoins) {
      int index = 1;
      while (index < jamCoins.length - 2) {
         if (jamCoins[index] == 0) {
            jamCoins[index] = 1;
            break;
         }
         else {
            jamCoins[index] = 0;
            index++;
         }
      }
   }
   
   private long convertToBase10Value(int[] jamCoins, int base) {
      long base10Value = 0;
      for (int i = 0; i < jamCoins.length; i++) {
         if (jamCoins[i] == 1) {
            base10Value = (long) (base10Value + Math.pow(base, i));
            // System.out.print(base + " pow " + i + " + ");
         }
      }
      // System.out.println(" = " + base10Value);
      return base10Value;
   }
   
   private boolean isNonPrime(long base10Value, Container container) {
      if (base10Value % 2 == 0) {
         container.divisor = 2;
         return true;
      }
      for (long i = 3; i * i <= base10Value; i += 2) {
         if (base10Value % i == 0) {
            container.divisor = i;
            // System.out.println(i + " is a factor of " + base10Value);
            return true;
         }
      }
      return false;
   }
   
   private void printJamCoinsAndDivisors(String jamCoinString,
      Map<Integer, Container> containerMap) {
      StringBuffer sb = new StringBuffer();
      sb.append(jamCoinString + " ");
      for (int base : containerMap.keySet()) {
         sb.append(containerMap.get(base).divisor + " ");
      }
      System.out.println(sb.toString());
      
      // sb = new StringBuffer();
      // sb.append(jamCoinString + " ");
      // for (int base : containerMap.keySet()) {
      // sb.append(
      // containerMap.get(base).divisor + "[" + containerMap.get(base).base
      // + "," + containerMap.get(base).base10Value + "] ");
      // }
      // System.out.println(sb.toString());
   }
   
   public static void main(String[] args) throws IOException {
      new JamCoin().runTest("D:\\Input.txt");
   }
}
