/**
 * CodeJam2012_2.java
 * Created By: E.Manikandan on Apr 14, 2012
 */
package learn.google;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * @author E.Manikandan
 * @revision $Revision:$
 */
public class CodeJam2012_2
{
   private class NumberWithReminder implements Comparable<NumberWithReminder>
   {
      int num;
      int reminder;
      
      NumberWithReminder(int num, int reminder)
      {
         this.num = num;
         this.reminder = reminder;
      }
      
      @Override
      public int compareTo(NumberWithReminder o)
      {
         return num > o.num ? 1 : num == o.num ? 0 : -1;
      }
      
      @Override
      public String toString()
      {
         return String.valueOf(num);
      }
   }
   
   public CodeJam2012_2()
   {
      
   }
   
   public void processGoogleDancers(String fileName) throws IOException
   {
      BufferedReader reader = null;
      try
      {
         List<NumberWithReminder> scoreList = new ArrayList<NumberWithReminder>();
         reader = new BufferedReader(new FileReader(fileName));
         int count = Integer.parseInt(reader.readLine());
         for (int i = 1; i <= count; i++)
         {
            scoreList.clear();
            String line = reader.readLine();
            System.out.print("Case #" + i + ": ");
            String[] tokens = line.split(" ");
            int result = 0;
            int playerCount = Integer.parseInt(tokens[0]);
            int surpriseCount = Integer.parseInt(tokens[1]);
            int checkScore = Integer.parseInt(tokens[2]);
            for (int j = 0; j < playerCount; j++)
            {
               int totalScore = Integer.parseInt(tokens[3 + j]);
               int avg = totalScore / 3;
               int reminder = avg > 0 ? totalScore % avg : 0;
               if (reminder == 0)
               {
                  scoreList.add(new NumberWithReminder(avg, reminder));
               }
               else
               {
                  scoreList.add(new NumberWithReminder(avg + 1, reminder));
               }
            }
            Collections.sort(scoreList);
            while (scoreList.size() > 0)
            {
               NumberWithReminder last = scoreList.remove(scoreList.size() - 1);
               if (last.num >= checkScore)
               {
                  result++;
               }
               else if (surpriseCount > 0 && last.num > 0 && last.reminder != 1
                     && last.num + 1 == checkScore)
               {
                  result++;
                  surpriseCount--;
               }
               else
               {
                  break;
               }
            }
            System.out.println(result);
         }
      }
      finally
      {
         if (reader != null)
         {
            reader.close();
         }
      }
   }
   
   public static void main(String[] args) throws IOException
   {
      new CodeJam2012_2().processGoogleDancers("C:\\Mani\\Input_2.txt");
   }
}
