package round1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class Snapper
{
   class SnapperInput
   {
      private int snapperCount = 0;
      private int snapCount = 0;

      public SnapperInput(int snapperCount, int snapCount)
      {
         this.snapperCount = snapperCount;
         this.snapCount = snapCount;
      }
   }

   private static final String INPUT_FILE = "E:\\Work\\Mani\\Oracle\\Eclipse Projects\\GoogleCodeJam\\src\\round1\\input.txt";
   private SnapperInput[] snapperInputs;

   public Snapper() throws IOException
   {
      loadSnapperInputs();
   }

   private void loadSnapperInputs() throws IOException
   {
      BufferedReader reader = new BufferedReader(new FileReader(INPUT_FILE));
      String line = null;
      int lineCount = 0;
      while ((line = reader.readLine()) != null)
      {
         if (lineCount == 0)
         {
            int caseCount = Integer.valueOf(line).intValue();
            snapperInputs = new SnapperInput[caseCount];
         }
         else
         {
            String[] NKs = line.split(" ");
            snapperInputs[lineCount - 1] = new SnapperInput(Integer
               .parseInt(NKs[0]), Integer.parseInt(NKs[1]));
         }
         lineCount++;
      }
   }

   public void executeSnapper()
   {
      for (int i = 0; i < snapperInputs.length; i++)
      {
         determineCaseOutput(i + 1, snapperInputs[i]);
      }
   }

   private void determineCaseOutput(int i, SnapperInput snapperInput)
   {
      // System.out.println("-------------------------------------");
      // System.out.println("N=" + snapperInput.snapperCount + ",K="
      // + snapperInput.snapCount);
      int[] powerInputs = new int[snapperInput.snapperCount];
      for (int j = 0; j < snapperInput.snapperCount; j++)
      {
         powerInputs[j] = 0;
      }
      powerInputs[0] = 1;
      int[] snapperStates = new int[snapperInput.snapperCount];
      for (int j = 0; j < snapperInput.snapperCount; j++)
      {
         snapperStates[j] = 0;
      }
      for (int j = 0; j < snapperInput.snapCount; j++)
      {
         // System.out.println("After snap " + (j + 1));
         for (int k = 0; k < snapperInput.snapperCount; k++)
         {
            if (powerInputs[k] == 1)
            {
               snapperStates[k] = snapperStates[k] ^ 1;
            }
         }
         for (int k = 0; k < snapperInput.snapperCount; k++)
         {
            if (k > 0)
            {
               powerInputs[k] = powerInputs[k - 1] & snapperStates[k - 1];
            }
         }
         // System.out.print("POWER: ");
         // for (int k = 0; k < powerInputs.length; k++)
         // {
         // System.out.print(powerInputs[k] + " ");
         // }
         // System.out.println();
         // System.out.print("STATE: ");
         // for (int k = 0; k < snapperStates.length; k++)
         // {
         // System.out.print((snapperStates[k] == 1 ? "ON " : "OFF "));
         // }
         // System.out.println();
      }
      System.out.println("Case #"
         + i
         + ": "
         + (snapperStates[snapperStates.length - 1] == 1
            && powerInputs[powerInputs.length - 1] == 1 ? "ON" : "OFF"));
   }

   public static void main(String[] args) throws IOException
   {
      new Snapper().executeSnapper();
   }
}
