/**
 * CodeJam2012_2.java
 * Created By: E.Manikandan on Apr 14, 2012
 */
package learn.google;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

/**
 * @author E.Manikandan
 * @revision $Revision:$
 */
public class CodeJam2012_3
{
   private class Pair
   {
      int a;
      int b;
      
      Pair(int a, int b)
      {
         this.a = a;
         this.b = b;
      }
      
      @Override
      public boolean equals(Object o)
      {
         if (o instanceof Pair)
         {
            Pair p = (Pair) o;
            boolean equals = (a + "," + b).equals(p.a + "," + p.b)
                  || (a + "," + b).equals(p.b + "," + p.a);
            //System.out.println(this + " & " + p + " are equal? " + equals);
            return equals;
         }
         return false;
      }
      
      @Override
      public int hashCode()
      {
         Integer hashCode = a <= b ? Integer.valueOf(a + "" + b) : Integer
               .valueOf(b + "" + a);
         //System.out.println("Hash for " + this + " is " + hashCode);
         return hashCode;
      }
      
      @Override
      public String toString()
      {
         return "(" + a + "," + b + ")";
      }
   }
   
   public CodeJam2012_3()
   {
      
   }
   
   public void processRecycledPairs(String fileName) throws IOException
   {
      BufferedReader reader = null;
      try
      {
         Set<Pair> pairSet = new HashSet<Pair>();
         reader = new BufferedReader(new FileReader(fileName));
         int count = Integer.parseInt(reader.readLine());
         for (int i = 1; i <= count; i++)
         {
            pairSet.clear();
            String line = reader.readLine();
            System.out.print("Case #" + i + ": ");
            String[] tokens = line.split(" ");
            int result = 0;
            int min = Integer.parseInt(tokens[0]);
            int max = Integer.parseInt(tokens[1]);
            int digits = String.valueOf(max).length();
            
            for (int j = min; j <= max; j++)
            {
               if (j % 10 > 0)
               {
                  for (int k = 1; k < digits; k++)
                  {
                     int pow = (int) Math.pow(10, k);
                     int reminder = j % pow;
                     if (String.valueOf(reminder).length() != k)
                     {
                        continue;
                     }
                     int balance = (j - reminder) / pow;
                     Integer newNum = Integer.valueOf(reminder + "" + balance);
                     Pair p = new Pair(j, newNum);
                     if (newNum != j && newNum <= max && pairSet.add(p))
                     {
                        result++;
                     }
                  }
               }
            }
            for (Pair p : pairSet)
            {
               //System.out.println(p);
            }
            
            System.out.println(result);
         }
      }
      finally
      {
         if (reader != null)
         {
            reader.close();
         }
      }
   }
   
   public static void main(String[] args) throws IOException
   {
      new CodeJam2012_3().processRecycledPairs("C:\\Mani\\Input_3.txt");
   }
}
