package com.mani.google.codejam.lastword;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * @LastWord.java
 * @author E.Manikandan
 */
public class LastWord {
   
   public void runTest(String fileName) throws IOException {
      BufferedReader br = null;
      try {
         br = new BufferedReader(new FileReader(fileName));
         int testCount = Integer.parseInt(br.readLine().trim());
         for (int i = 1; i <= testCount; i++) {
            String word = br.readLine().trim();
            String lastWord = getLastWord(word);
            System.out.println("Case #" + i + ": " + lastWord);
         }
      }
      finally {
         if (br != null) {
            br.close();
         }
      }
   }
   
   private String getLastWord(String word) {
      StringBuilder sb = new StringBuilder();
      char[] cArray = word.toCharArray();
      for (int i = 0; i < cArray.length; i++) {
         if (sb.length() == 0) {
            sb.append(cArray[i]);
         }
         else if (cArray[i] < sb.charAt(0)) {
            sb.append(cArray[i]);
         }
         else {
            sb.insert(0, cArray[i]);
         }
      }
      return sb.toString();
   }
   
   public static void main(String[] args) throws IOException {
      new LastWord().runTest("D:\\Input.txt");
   }
}
