package com.mani.google.codejam.y2017;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * CruiseControl.java
 * 
 * @author Manikandan Eswaran
 */
public class CruiseControl {
   void solve() throws IOException {
      BufferedReader reader = new BufferedReader(
         new FileReader("D:\\small.txt"));
      int testCount = Integer.parseInt(reader.readLine());
      for (int i = 0; i < testCount; i++) {
         String[] tokens = reader.readLine().split(" ");
         double d = Double.parseDouble(tokens[0]);
         int n = Integer.parseInt(tokens[1]);
         double[][] otherHorses = new double[n][2];
         for (int r = 0; r < n; r++) {
            tokens = reader.readLine().split(" ");
            otherHorses[r][0] = Double.parseDouble(tokens[0]);
            otherHorses[r][1] = Double.parseDouble(tokens[1]);
         }
         double soln = solve(d, n, otherHorses);
         System.out.printf("Case #%d: %f\n", (i + 1), soln);
      }
      reader.close();
   }
   
   /**
    * solve
    * 
    * @param d
    * @param n
    * @param otherHorses
    * @return
    */
   private double solve(double d, int n, double[][] otherHorses) {
      double minSpeed = Double.MAX_VALUE;
      for (int i = 0; i < n; i++) {
         double dist = d - otherHorses[i][0];
         double speed = otherHorses[i][1];
         double timeToDest = dist / speed;
         double speedOfAnne;
         if (timeToDest != 0.0d) {
            speedOfAnne = d / timeToDest;
         }
         else {
            speedOfAnne = d;
         }
         if (speedOfAnne < minSpeed) {
            minSpeed = speedOfAnne;
         }
      }
      return minSpeed;
   }
   
   public static void main(String[] args) throws IOException {
      new CruiseControl().solve();
       //System.out.printf("%f\n",Math.pow(2, 63));
       //System.out.printf("%f\n",Math.pow(10, 9));
   }
}
