package com.mani.google.codejam.y2017;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * PancakeFlipper.java
 * 
 * @author Manikandan Eswaran
 */
public class PancakeFlipper {
   
   void solve() throws IOException {
      BufferedReader reader = new BufferedReader(
         new FileReader("D:\\large.txt"));
      int testCount = Integer.parseInt(reader.readLine());
      for (int i = 0; i < testCount; i++) {
         String s = reader.readLine();
         String[] tokens = s.split(" ");
         int[] panCakes = new int[tokens[0].length()];
         for (int j = 0; j < panCakes.length; j++) {
            panCakes[j] = (tokens[0].charAt(j) == '+' ? 1 : 0);
         }
         int flipperSize = Integer.parseInt(tokens[1]);
         int flipCount = solve(panCakes, flipperSize);
         if (isAllSimiling(panCakes)) {
            System.out.println("Case #" + (i + 1) + ": " + flipCount);
         }
         else {
            System.out.println("Case #" + (i + 1) + ": " + "IMPOSSIBLE");
         }
      }
      reader.close();
   }
   
   private boolean isAllSimiling(int[] panCakes) {
      int result = 1;
      for (int i = 0; i < panCakes.length; i++) {
         result = result & panCakes[i];
      }
      return result == 1;
   }
   
   void print(int[] panCakes) {
      StringBuffer sb = new StringBuffer();
      for (int i = 0; i < panCakes.length; i++) {
         sb.append(panCakes[i] == 0 ? '-' : '+');
      }
      System.out.println(sb.toString());
   }
   
   int solve(int[] panCakes, int flipperSize) {
      int flipCount = 0;
      if (panCakes != null && panCakes.length > 0) {
         // print(panCakes);
         int index = 0;
         while (index < panCakes.length) {
            if (panCakes[index] == 1) {
               index++;
            }
            else {
               if (flip(panCakes, index, flipperSize)) {
                  flipCount++;
                  // print(panCakes);
               }
               else {
                  return flipCount;
               }
            }
         }
      }
      return flipCount;
   }
   
   boolean flip(int[] panCakes, int index, int flipCount) {
      if (index + flipCount <= panCakes.length) {
         for (int i = index; i < index + flipCount; i++) {
            panCakes[i] = (panCakes[i] == 0 ? 1 : 0);
         }
         return true;
      }
      return false;
   }
   
   public static void main(String[] args) throws IOException {
      new PancakeFlipper().solve();
   }
}
