/**
 * CodeJam2012.java
 * Created By: E.Manikandan on Apr 13, 2012
 */
package learn.google;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * @author E.Manikandan
 * @revision $Revision:$
 */
public class CodeJam2012
{
   private Map<String, String> letterMap = new HashMap<String, String>();
   
   public CodeJam2012()
   {
      letterMap.put("n", "b");
      letterMap.put("f", "c");
      letterMap.put("i", "d");
      letterMap.put("c", "e");
      letterMap.put("w", "f");
      letterMap.put("l", "g");
      letterMap.put("b", "h");
      letterMap.put("k", "i");
      letterMap.put("u", "j");
      letterMap.put("o", "k");
      letterMap.put("m", "l");
      letterMap.put("x", "m");
      letterMap.put("s", "n");
      letterMap.put("e", "o");
      letterMap.put("v", "p");
      letterMap.put("z", "q");
      letterMap.put("p", "r");
      letterMap.put("d", "s");
      letterMap.put("r", "t");
      letterMap.put("j", "u");
      letterMap.put("g", "v");
      letterMap.put("t", "w");
      letterMap.put("h", "x");
      letterMap.put("a", "y");
      letterMap.put("q", "z");
      letterMap.put("y", "a");
   }
   
   public void processGooglerese(String fileName) throws IOException
   {
      BufferedReader reader = null;
      try
      {
         reader = new BufferedReader(new FileReader(fileName));
         int count = Integer.parseInt(reader.readLine());
         for (int i = 1; i <= count; i++)
         {
            String line = reader.readLine();
            System.out.print("Case #" + i + ": ");
            for (int j = 0; j < line.length(); j++)
            {
               String s = line.substring(j, j + 1);
               if (letterMap.containsKey(s))
               {
                  System.out.print(letterMap.get(s));
               }
               else
               {
                  System.out.print(s);
               }
            }
            System.out.println();
         }
      }
      finally
      {
         if (reader != null)
         {
            reader.close();
         }
      }
   }
   
   public static void main(String[] args) throws IOException
   {
      new CodeJam2012().processGooglerese("C:\\Mani\\Input.txt");
   }
}
