package com.mani.google.codejam.phonedigits;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * @PhoneDigits.java
 * @author E.Manikandan
 */
public class PhoneDigits {
   private static final String[] numberStrings = { "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE", "TEN" };
   private static final Map<Character, List<String>> letterToNumberStringMap = new HashMap<Character, List<String>>() {
      {
         put('E', Arrays.asList(new String[] { "ONE", "THREE", "FIVE", "SEVEN", "EIGHT", "NINE", "TEN" }));
         put('F', Arrays.asList(new String[] { "FOUR", "FIVE" }));
         put('G', Arrays.asList(new String[] { "EIGHT" }));
         put('H', Arrays.asList(new String[] { "THREE", "EIGHT" }));
         put('I', Arrays.asList(new String[] { "FIVE", "SIX", "EIGHT", "NINE" }));
         put('N', Arrays.asList(new String[] { "ONE", "SEVEN", "NINE", "TEN" }));
         put('O', Arrays.asList(new String[] { "ONE", "TWO", "FOUR" }));
         put('R', Arrays.asList(new String[] { "THREE", "FOUR" }));
         put('S', Arrays.asList(new String[] { "SIX", "SEVEN" }));
         put('T', Arrays.asList(new String[] { "TWO", "THREE", "EIGHT", "TEN" }));
         put('U', Arrays.asList(new String[] { "FOUR" }));
         put('V', Arrays.asList(new String[] { "FIVE", "SEVEN" }));
         put('W', Arrays.asList(new String[] { "TWO" }));
         put('X', Arrays.asList(new String[] { "SIX" }));
         put('Z', Arrays.asList(new String[] { "ZERO" }));
         
      }
   };
   
   private static final char[] charOrder = new char[] { 'Z', 'G', 'U', 'W', 'X', 'H', 'O', 'F', 'S', 'T', 'E' };
   private static final String[] numStringOrder = new String[] { "ZERO", "EIGHT", "FOUR", "TWO", "SIX", "THREE", "ONE", "FIVE", "SEVEN", "TEN",
      "NINE" };
   private static final int[] numOrder = new int[] { 0, 8, 4, 2, 6, 3, 1, 5, 7, 10, 9 };
   
   public void runTest(String fileName) throws IOException {
      BufferedReader br = null;
      try {
         br = new BufferedReader(new FileReader(fileName));
         int testCount = Integer.parseInt(br.readLine().trim());
         for (int i = 1; i <= testCount; i++) {
            String line = br.readLine().trim();
            // System.out.println("Problem: " + line);
            StringBuilder sb = new StringBuilder(line);
            List<Integer> result = new ArrayList<Integer>();
            while (sb.length() != 0) {
               for (int j = 0; j < charOrder.length; j++) {
                  // System.out.println("charOrder[j] = " + charOrder[j]);
                  // System.out.println("sb = " + sb.toString());
                  while (sb.indexOf(new String(new char[] { charOrder[j] })) != -1) {
                     for (char c : numStringOrder[j].toCharArray()) {
                        // System.out.println("numStringOrder[j] = " +
                        // numStringOrder[j]);
                        // System.out.println("c = " + c);
                        sb.deleteCharAt(sb.indexOf(new String(new char[] { c })));
                        // System.out.println("sb.new = " + sb.toString());
                     }
                     result.add(numOrder[j]);
                  }
               }
            }
            
            Collections.sort(result);
            StringBuffer resultBuf = new StringBuffer();
            for (int r = 0; r < result.size(); r++) {
               resultBuf.append(result.get(r));
            }
            
            System.out.printf("Case #%d: %s%n", i, resultBuf.toString());
         }
      }
      finally {
         if (br != null) {
            br.close();
         }
      }
   }
   
   public static void main(String[] args) throws IOException {
      new PhoneDigits().runTest("D:\\Input.txt");
   }
}
