import java.util.*;
import java.io.*;
public class Main {
	
	public static class Pair {
		long min;
		long max;
		
		Pair(long min, long max) {
			this.min = min;
			this.max = max;
		}
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
		for (int i = 1; i <= t; ++i) {
			long n = in.nextLong();
			long k = in.nextLong();
			
			Pair pair = getPair(n,k);
			
			System.out.println("Case #" + i + ": " + pair.max + " " + pair.min);
		}
	}
	
	
	public static Pair getPair(long n) {
		long max = n/2;
		long min = Math.max(n-1-max, 0);
		
		return new Pair(min, max);
	}
	
	
	public static Pair getPair(long n, long k) {
		
		long remainingK = k;
		long mulitplier = 2;
		
		Pair pair = getPair(n);
		long oldMax = n;
		
		while (remainingK > mulitplier + 1) {
			remainingK -= mulitplier;
			mulitplier *= 2;
			oldMax = pair.max;
			pair = getPair(pair.max);
		}
		
		if (remainingK == 1) {
			return pair;
		} else if (remainingK == 2) {
			return getPair(pair.max);
		} else {
			if(pair.max != pair.min) {
				return getPair(pair.min);
			} else {
				remainingK--;
				
				long actualMin = pair.min-1;
				if(remainingK < 4 || remainingK % 2 != 0) {

					return getPair(pair.max);
				} else {

					return getPair(actualMin);
				}
			}
		}
	}
	
}


/*
Test cases:
***********
25
4 2
5 2
6 2
1000 1000
1000 1
1000 2
1000 3
1000 4
1000 5
1000 6
1000 7
1000 8
1000 9
1000 10
1000 11
1000 12
1000 13
1000 14
1000 15
1000 16
1000 17
1000 18
1000 19
1000 20
1000 21
*/