/**
 * Created by Amy Tai
 */

import java.io.*;
import java.util.ArrayList;

public class FairSquare {
  public static boolean isPal(double x) {
    double unit = x % 10;
    double greatestDig = unit;
    while (x >= 10) {
      x = (x-greatestDig)/10;
      greatestDig = x % 10;
    }
    return unit == greatestDig;
  }

  public static void main(String[] args) throws IOException {
    BufferedReader br = new BufferedReader(new FileReader(new File("input.txt")));
    PrintWriter prn = new PrintWriter(new File("output.txt"));
    int numTrials = Integer.parseInt(br.readLine().trim());
    ArrayList<Double> list = new ArrayList<Double>();
    for (double a = 0; a < 10000000; a++) {
      if (isPal(a)) {
        if (isPal(a*a))
          list.add(a*a);
      }
    }
    System.out.println(list.size());
    System.out.println(list.get(list.size()-1));

    for (int i = 0 ; i < numTrials; i++) {
      String[] line = br.readLine().trim().split(" ");
      double A = Double.parseDouble(line[0]);
      double B = Double.parseDouble(line[1]);
      // Binsearch for smallest index greater than or equal to A
      int small = -1;
      int large = -1;
      int top = list.size()-1;
      int bottom = 0;
      int m = (top+bottom)/2;
      while (bottom < top) {
        if (A == list.get(m))
          break;
        if (A < list.get(m)) {
          top = m-1;
          m = (top+bottom)/2;
        }
        else {
          bottom = m+1;
          m = (top + bottom)/2;
        }
      }
      if (list.get(m) < A)
        small = m+1;
      else small = m;

      m = list.size()/2;
      top = list.size();
      bottom = 0;
      while ((bottom < top) || top > list.size()) {
        if (B == list.get(m))
          break;
        if (B < list.get(m)) {
          top = m-1;
          m = (top+bottom)/2;
        }
        else {
          bottom = m+1;
          m = (top + bottom)/2;
        }
      }
      if (m >= list.size())
        m = list.size()-1;
      if (list.get(m) > B)
        large = m-1;
      else large = m;

      prn.printf("Case #%d: %d\n", i+1, large-small+1);


    }
    prn.close();
  }
}
