package aero.id3.othello.view.test;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import org.apache.commons.io.FileUtils;


public class Test
{
	
	
	public static void main( String[] args )
	{
		try
		{
			String input = FileUtils.readFileToString( new File( "/Users/onuratamer/Desktop/google/A-large.in" ) );
			
			
			String[] lines = input.split( "\n" );
			String sampleCount = lines[0];
			Integer sampleCountInt = new Integer( sampleCount );
			
			List<String[][]> inputArray = new ArrayList<String[][]>();
			
			
			int lineCount = 1;
			for ( int i = 0; i < sampleCountInt; i++ )
			{
				String[][] maze = new String[4][4];
				
				for ( int j = 0; j < 4; j++ )
				{
					String lineStr = lines[lineCount++];
					maze[j][0] = lineStr.substring( 0, 1 );
					maze[j][1] = lineStr.substring( 1, 2 );
					maze[j][2] = lineStr.substring( 2, 3 );
					maze[j][3] = lineStr.substring( 3, 4 );
				}
				inputArray.add( maze );
				lineCount++;
			}
			
			int i = 1;
			List<String> outputList = new ArrayList<String>();
			for ( String[][] maze : inputArray )
			{
				outputList.add( "Case #" + i + ": " + calculateWinner( maze ) );
				i++;
			}
			
			
			for ( String output : outputList )
			{
				System.out.println( output );
			}
			
			// for ( String[][] maze : inputArray )
			// {
			// for ( String[] row : maze )
			// {
			// for ( String cell : row )
			// {
			// System.out.print( cell );
			// }
			// System.out.println();
			// }
			// System.out.println();
			// System.out.println();
			// }
			
			
		}
		catch ( IOException e )
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	private static String calculateWinner( String[][] maze )
	{
		
		// first search for X
		if ( searchFor( "X", maze ) )
		{
			return "X won";
		}
		else if ( searchFor( "O", maze ) )
		{
			return "O won";
		}
		else if ( contains( maze, "." ) )
		{
			return "Game has not completed";
		}
		else
		{
			return "Draw";
		}
		
	}
	
	private static boolean contains( String[][] maze, String str )
	{
		for ( String[] strings : maze )
		{
			for ( String string : strings )
			{
				if ( string.equals( str ) )
				{
					return true;
				}
			}
		}
		return false;
	}
	
	private static boolean searchFor( String val, String[][] maze )
	{
		// search horizontal
		for ( String[] row : maze )
		{
			int XOcount = findCount( val, row );
			int Tcount = findCount( "T", row );
			if ( (XOcount + Tcount) == 4 )
			{
				return true;
			}
			else if ( XOcount == 4 )
			{
				return true;
			}
		}
		
		// search vertical
		for ( int i = 0; i < 4; i++ )
		{
			String[] column = getVertical( maze, i );
			int XOcount = findCount( val, column );
			int Tcount = findCount( "T", column );
			if ( (XOcount + Tcount) == 4 )
			{
				return true;
			}
			else if ( XOcount == 4 )
			{
				return true;
			}
		}
		
		// find first diognasal
		int d = 0;
		String diag[] = new String[4];
		for ( String[] row : maze )
		{
			diag[d] = row[d];
			d++;
		}
		int XOcount = findCount( val, diag );
		int Tcount = findCount( "T", diag );
		if ( (XOcount + Tcount) == 4 )
		{
			return true;
		}
		else if ( XOcount == 4 )
		{
			return true;
		}
		
		// find second diognasal
		d = 3;
		diag = new String[4];
		for ( String[] row : maze )
		{
			diag[d] = row[d];
			d--;
		}
		XOcount = findCount( val, diag );
		Tcount = findCount( "T", diag );
		if ( (XOcount + Tcount) == 4 )
		{
			return true;
		}
		else if ( XOcount == 4 )
		{
			return true;
		}
		return false;
	}
	
	private static String[] getVertical( String[][] maze, int i )
	{
		int j = 0;
		String[] column = new String[4];
		for ( String[] row : maze )
		{
			column[j++] = row[i];
		}
		
		return column;
	}
	
	private static int findCount( String val, String[] row )
	{
		int count = 0;
		for ( String string : row )
		{
			if ( string.equals( val ) )
			{
				count++;
			}
		}
		return count;
		
	}
	
	// public static void main( String[] args )
	// {
	//
	//
	// String content =
	// "Voucher No: ${voucherotelmeal.voucherNo}  Voucher Tarihi: ${jexlfunc:formatdate(voucherotelmeal.voucherDate,'dd/MM/yyyy HH:mm')}"
	// + "<br><table>    <tr>    <tr>   <tr>"
	// + "#forstart"
	// + " <td>${trainee.trainingName}</td>"
	// + " <td>${trainee.traineeName}</td>"
	// + "<td>${jexlfunc:formatdate(trainee.otelCheckInTime, 'dd/MM/yyyy HH:mm')}</td>"
	// + " <td>${jexlfunc:formatdate(trainee.otelCheckOutTime, 'dd/MM/yyyy HH:mm')}</td>"
	// + "#forend"
	// + "</tr>"
	// + "</table>"
	// + "<br>" + "<br>";
	//
	//
	// String body1 = StringUtils.substringBefore( content, "#forstart" );
	//
	// String body2 = StringUtils.substringBetween( content, "#forstart", "#forend" );
	//
	// String body3 = StringUtils.substringAfter( content, "#forend" );
	//
	//
	// System.out.println( body1 );
	// System.out.println( "****" + body2 + "****" );
	// System.out.println( body3 );
	//
	//
	// List<Date> dateList = new ArrayList<Date>();
	//
	// Calendar cal = Calendar.getInstance();
	// cal.add( Calendar.DAY_OF_MONTH, 1 );
	// dateList.add( cal.getTime() );
	//
	// Calendar cal1 = Calendar.getInstance();
	// cal1.add( Calendar.DAY_OF_MONTH, 3 );
	// dateList.add( cal1.getTime() );
	//
	// Calendar cal2 = Calendar.getInstance();
	// cal2.add( Calendar.DAY_OF_MONTH, 5 );
	// dateList.add( cal2.getTime() );
	//
	//
	// Collections.sort( dateList, new Comparator<Date>()
	// {
	//
	// @Override
	// public int compare( Date o1, Date o2 )
	// {
	// return o1.compareTo( o2 );
	// }
	// } );
	//
	// for ( Date date : dateList )
	// {
	// System.out.println( date );
	// }
	//
	//
	// //
	// // Map<String, Object> funcs = new HashMap<String, Object>();
	// // funcs.put( "format", new CustomJexlFunc() );
	// //
	// // JexlEngine jexl = new JexlEngine();
	// // jexl.setFunctions( funcs );
	// //
	// // Passenger pass = new Passenger();
	// // pass.setArrDate( Calendar.getInstance() );
	// // pass.setName( "Onur" );
	// //
	// // JexlContext jc = new MapContext();
	// // jc.set( "pass", pass );
	// //
	// // String jexlExp = "format:formatCal(pass.arrDate,'dd/MM/yyyy HH:mm')";
	// // Expression e = jexl.createExpression( jexlExp );
	// //
	// // Object o = e.evaluate( jc );
	// //
	// // System.out.println( o );
	//
	//
	// // SimpleDateFormat sdf = new SimpleDateFormat( "dd/MM" );
	// //
	// // Calendar checkInDate = Calendar.getInstance();
	// // checkInDate.set( Calendar.DAY_OF_MONTH, 19 );
	// // checkInDate.set( Calendar.MONTH, 1 );
	// // checkInDate.set( Calendar.HOUR_OF_DAY, 19 );
	// //
	// // Calendar checkOutDate = Calendar.getInstance();
	// // checkOutDate.set( Calendar.DAY_OF_MONTH, 20 );
	// // checkOutDate.set( Calendar.MONTH, 1 );
	// // checkOutDate.set( Calendar.HOUR_OF_DAY, 4 );
	// //
	// // Calendar dayTurn = Calendar.getInstance();
	// // dayTurn.set( Calendar.HOUR_OF_DAY, 3 );
	// // dayTurn.set( Calendar.MINUTE, 0 );
	// // dayTurn.set( Calendar.SECOND, 0 );
	// // dayTurn.set( Calendar.MILLISECOND, 0 );
	// //
	// // Calendar otelCheckOutTime = Calendar.getInstance();
	// // otelCheckOutTime.set( Calendar.HOUR_OF_DAY, 18 );
	// // otelCheckOutTime.set( Calendar.MINUTE, 0 );
	// // otelCheckOutTime.set( Calendar.SECOND, 0 );
	// // otelCheckOutTime.set( Calendar.MILLISECOND, 0 );
	// //
	// //
	// // List<OtelUsageTypeObject> list = OthelloUtils.calculateUseType( checkInDate.getTime(), checkOutDate.getTime(),
	// // dayTurn.getTime(),
	// // otelCheckOutTime.getTime() );
	// //
	// // for ( OtelUsageTypeObject otelUsageTypeObject : list )
	// // {
	// // System.out.println( sdf.format( otelUsageTypeObject.getActiveCal().getTime() ) + " TYPE: "
	// // + (otelUsageTypeObject.isDay() ? "Day" : "Night") + " Previous:" + otelUsageTypeObject.isPrevious() );
	// // }
	// }
	
	
}
