package jam.r2y2009;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.*;

/**
 * User: looser
 * Date: Sep 26, 2009
 */
public class CrazyRows {
    private List<Integer> input;

    public CrazyRows(List<Integer> input) {
        this.input = input;
    }

    public static void main(String[] args) throws Exception {
        BufferedReader f = new BufferedReader(new FileReader("input.txt"));
        PrintStream out = new PrintStream("output.txt");
        //PrintStream out = System.out;

        int t = Integer.parseInt(f.readLine());
        for (int i = 1; i <= t; i++) {
            int n = Integer.parseInt(f.readLine());
            List<Integer> input = new ArrayList<Integer>(n);

            for (int j = 0; j < n; j++) {
                char[] str = f.readLine().toCharArray();

                boolean added = false;
                for (int k = n-1; k >=0; k--) {
                    if (str[k] == '1') {
                        input.add(k+1);
                        added = true;
                        break;
                    }
                }

                if (!added) {
                    input.add(0);
                }
            }

            CrazyRows cr = new CrazyRows(input);
            out.println("Case #" + i + ": " + cr.solve());
        }
    }

    private long solve() {
        int[] arr = new int[input.size()];
        for (int i =0; i < input.size(); i++) {
            arr[i] = input.get(i);
        }
        return brute(arr);
    }


    private Map<String, Long> cache = new HashMap<String, Long>();
    private Set<String> seen = new HashSet<String>();
    private long brute(int[] arr) {
        if (isGood(arr)) {
            return 0;
        }



        String repr = Arrays.toString(arr);
        if (seen.contains(repr)) {
            return Integer.MAX_VALUE;
        }

        if (cache.containsKey(repr)) {
            return cache.get(repr) + 1;
        }

        seen.add(repr);

        long min = Integer.MAX_VALUE;
        for (int i = 1; i < arr.length; i++) {
            if (!swapIsGood(i-1, i, arr)) {
                continue;
            }

            long curr = brute(swap(i-1, i, arr));
            swap(i, i-1, arr); // unswap

            if (curr < min) {
                min = curr;
            }
        }

        seen.remove(repr);

        cache.put(repr, min);

        return 1 + min;
    }

    private boolean swapIsGood(int left, int right, int[] arr) {
        return arr[left] + 1  > arr[right];
    }

    private int[] swap(int left, int right, int[] arr) {
        int tmp = arr[left];
        arr[left] = arr[right];
        arr[right] = tmp;
        return arr;
    }

    private boolean isGood(int[] arr) {
        for (int i = 0; i < arr.length; i++) {
            if (arr[i] > i+1) {
                return false;
            }
        }
        return true;
    }
}
