import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;

/**
 * Created by IntelliJ IDEA.
 * User: looser
 */
public class RPI {

    public static void main(String[] args) throws Exception {
        String name = "A-large";
//        String name = "test";
        BufferedReader f = new BufferedReader(new FileReader(name + ".in"));
//        PrintStream out = System.out;
        PrintStream out = new PrintStream(name + ".out");

        Integer T = Integer.parseInt(f.readLine());

        for (int i = 1; i <= T; i++) {
            int N = Integer.parseInt(f.readLine());
            State[][] states = new State[N][N];
            for (int j = 0; j < N; j++) {
                String line = f.readLine();
                for (int k = 0; k < N; k++) {
                    states[j][k] = State.translate(line.charAt(k));
                }
            }


            double[][] partialOWP = new double[N][N];
            double[] WP = new double[N];
            double[] OWP = new double[N];
            double[] OOWP = new double[N];
            int[] played = new int[N];

            for (int j = 0; j < N; j++) {
                played[j] = 0;
                int won = 0;
                for (int k = 0; k < N; k++) {
                    if (states[j][k] != State.NA) {
                        played[j]++;
                    }

                    if (states[j][k] == State.WON) {
                        won++;
                    }
                }

                WP[j] = ((double) won) / played[j];

                for (int k = 0; k < N; k++) {
                    if (states[j][k] != State.NA) {
                        int wonThisOne = states[j][k] == State.WON ? 1 : 0;
                        partialOWP[k][j] = ((double) won - wonThisOne) / (played[j] - 1);
                    }
                }
            }

            for (int j = 0; j < N; j++) {
                double totOwp = 0;
                for (int k = 0; k < N; k++) {
                    totOwp += partialOWP[j][k];
                }
                OWP[j] = totOwp / played[j];
            }


            for (int j = 0; j < N; j++) {
                double totOowp = 0;
                for (int k = 0; k < N; k++) {
                    if (states[j][k] != State.NA) {
                        totOowp += OWP[k];
                    }
                }
                OOWP[j] = totOowp / played[j];
            }

            out.println("Case #" + i + ": ");


            for (int j = 0; j < N; j++) {
                out.println(0.25 * WP[j] + 0.50 * OWP[j] + 0.25 * OOWP[j]);
            }
        }
        out.flush();
    }

    private enum State {
        WON, LOST, NA;

        public static State translate(char c) {
            switch (c) {
                case '1': return WON;
                case '0': return LOST;
                case '.': return NA;
                default: throw new IllegalArgumentException("unexpected " + c);
            }
        }
    }
}
