package ru.atamur.jam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.*;

/**
 * @ looser
 */
public class Magicka {
    public static void main(String[] args) throws Exception {
        String name = "B-large";
//        String name = "test";
        BufferedReader f = new BufferedReader(new FileReader(name + ".in"));
//        PrintStream out = System.out;
        PrintStream out = new PrintStream(name + ".out");

        Integer T = Integer.parseInt(f.readLine());

        for (int i = 1; i <= T; i++) {
            Map<ElemPair, Character> combining = new HashMap<ElemPair, Character>();
            Map<Character, Set<Character>> opposed = new HashMap<Character, Set<Character>>();
            String[] line = f.readLine().split(" ");
            int C = Integer.parseInt(line[0]);
            for (int j = 1; j <= C; j++) {
                String trigram = line[j];
                combining.put(new ElemPair(trigram.charAt(0), trigram.charAt(1)), trigram.charAt(2));
            }

            int D = Integer.parseInt(line[C + 1]);
            for (int j = 1; j <= D; j++) {
                String twogram = line[C + 1 + j];
                lazyPut(opposed, twogram.charAt(0), twogram.charAt(1));
                lazyPut(opposed, twogram.charAt(1), twogram.charAt(0));
            }

            String target = (line[C + 1 + D + 1 + 1]);
            Deque<Character> result = new ArrayDeque<Character>();
            for (char c : target.toCharArray()) {
                Character combined = null;
                if (!result.isEmpty()) {
                    Character last = result.peekLast();
                    combined = combining.get(new ElemPair(last, c));
                }
                if (combined != null) {
                    result.removeLast();
                    result.addLast(combined);
                } else {
                    Set<Character> opposedElems = opposed.get(c);
                    if (opposedElems != null) {
                        boolean found = false;
                        for (Character existing : result) {
                            if (opposedElems.contains(existing)) {
                                found = true;
                                break;
                            }
                        }
                        if (found) {
                            result.clear();
                        } else {
                            result.addLast(c);
                        }
                    } else {
                        result.addLast(c);
                    }
                }
            }


            out.println("Case #" + i + ": " + result);
        }
        out.flush();
    }

    private static void lazyPut(Map<Character, Set<Character>> opposed, char c1, char c2) {
        Set<Character> set = opposed.get(c1);
        if (set == null) {
            set = new HashSet<Character>();
            opposed.put(c1, set);
        }
        set.add(c2);
    }

    private static class ElemPair {
        public final char elemA;
        public final char elemB;

        private ElemPair(char elemA, char elemB) {
            this.elemA = elemA > elemB ? elemA : elemB;
            this.elemB = elemA <= elemB ? elemA : elemB;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            ElemPair elemPair = (ElemPair) o;

            return elemA == elemPair.elemA && elemB == elemPair.elemB;
        }

        @Override
        public int hashCode() {
            int result = (int) elemA;
            result = 31 * result + (int) elemB;
            return result;
        }

        @Override
        public String toString() {
            return "{" +
                    "" + elemA +
                    " " + elemB +
                    '}';
        }
    }
}
