package jam.roundb;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Map;
import java.util.TreeMap;

/**
 * User: looser
 * Date: May 22, 2010
 */
public class FileFixIt {
    private int counter;
    private String[] existing;
    private String[] toBeCreated;

    public FileFixIt(String[] existing, String[] toBeCreated) {
        this.existing = existing;
        this.toBeCreated = toBeCreated;
    }


    public static void main(String[] args) throws Exception{
        String file_name = "A-small-attempt0(2)";
        BufferedReader f = new BufferedReader(new FileReader(file_name + ".in"));
        //BufferedReader f = new BufferedReader(new FileReader("inp.txt"));
        //PrintStream out = System.out;
        PrintStream out = new PrintStream(file_name + ".out");
        Integer T = Integer.parseInt(f.readLine());

        for (int i = 1; i <= T; i++) {
            String[] s = f.readLine().split(" ");
            int N = Integer.parseInt(s[0]);
            int M = Integer.parseInt(s[1]);

            String[] existing = new String[N];
            String[] toBeCreated = new String[M];

            readLinesToArray(f, N, existing);
            readLinesToArray(f, M, toBeCreated);

            FileFixIt o = new FileFixIt(existing, toBeCreated);

            out.println("Case #" + i + ": " + o.solve());
        }
    }

    class FileNode {
        final String name;
        final Map<String, FileNode> children = new TreeMap<String, FileNode>();

        FileNode(String name) {
            this.name = name;
        }

        public void mkdir(String s) {
            int secondSlash = s.indexOf('/', 1);
            if (secondSlash == -1) {
                childNode(s.substring(1));
            } else {
                String childName = s.substring(1, secondSlash);
                childNode(childName).mkdir(s.substring(secondSlash));
            }

            debug(s);
        }

        private void debug(String s) {
            if (name.equals("")) {
                System.out.println("mkdir: " + s);
                printTree("");
            }
        }

        private void printTree(String parentName) {
            if (!parentName.equals("")) {
                System.out.println(parentName + name);
            }
            for (FileNode node : children.values()) {
                node.printTree(parentName + name + "/");
            }
        }

        private FileNode childNode(String childName) {
            FileNode node = children.get(childName);
            if (node == null) {
                counter++;
                children.put(childName, node = new FileNode(childName));
            }
            return node;
        }

        @Override
        public String toString() {
            return "FileNode{" +
                    "name='" + name + '\'' +
                    '}';
        }
    }

    private int solve() {
        FileNode root = new FileNode("");
        for (String s : existing) {
            root.mkdir(s);
        }

        counter = 0;

        for (String s : toBeCreated) {
            root.mkdir(s);
        }

        return counter;
    }

    private static void readLinesToArray(BufferedReader f, int n, String[] existing) throws IOException {
        for (int j = 0; j < n; j++) {
            existing[j] = f.readLine();
        }
    }

}
