package jam.roundb;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

/**
 * User: looser
 * Date: May 22, 2010
 */
public class Chicks {
    private int n;
    private int k;
    private int b;
    private int t;
    private Integer[] x;
    private Integer[] v;

    public Chicks(int n, int k, int b, int t, Integer[] x, Integer[] v) {
        this.n = n;
        this.k = k;
        this.b = b;
        this.t = t;
        this.x = x;
        this.v = v;
    }

    public static void main(String[] args) throws Exception {
        BufferedReader f = new BufferedReader(new FileReader("B-small-attempt1" + ".in"));
        //BufferedReader f = new BufferedReader(new FileReader("inp.txt"));
        //PrintStream out = System.out;
        PrintStream out = new PrintStream("B-small-attempt1" + ".out");

        Integer C = Integer.parseInt(f.readLine());

        for (int i = 1; i <= C; i++) {
            String[] s = f.readLine().split(" ");
            long N = Long.parseLong(s[0]);
            long K = Long.parseLong(s[1]);
            long B = Long.parseLong(s[2]);
            long T = Long.parseLong(s[3]);
            Integer[] X = strToIntArr(f.readLine());
            Integer[] V = strToIntArr(f.readLine());

            Chicks o = new Chicks((int) N, (int) K, (int) B, (int) T, X, V);

            long start = System.currentTimeMillis();

            int solved = o.solve();
            out.println("Case #" + i + ": " + (solved == -1 ? "IMPOSSIBLE" : solved));

            long took = System.currentTimeMillis() - start;
            System.err.println("Case #" + i + " took " + took + "ms");
        }
    }



    private int solve() {
        if (k == 0) {
            return 0;
        }

        List<Double> times = times();
        int[] swapsAllowed = new int[n];

        return doSolution(swapsAllowed, times, 0);

    }

    private int doSolution(int[] swapsAllowed, List<Double> times, int skipped) {
        if (skipped + k > n) {
            return -1;
        }

        int firstNotMakingIt = firstNotMakingIt(times, swapsAllowed);
        if (firstNotMakingIt == -1) {
            return 0;
        }

        int numberIn = n - firstNotMakingIt - 1 - skipped;
        if (numberIn >= k) {
            return 0;
        }

        int swaps = Integer.MAX_VALUE;        
        for (int numberOfSwaps = firstNotMakingIt; numberOfSwaps >= k-numberIn; numberOfSwaps--) {
            swapsAllowed[firstNotMakingIt] = numberOfSwaps;
            int totalSwaps = doSolution(swapsAllowed, times, skipped + 1);

            if (totalSwaps == -1) {
                break;
            }

            totalSwaps += numberOfSwaps;
            if (totalSwaps < swaps) {
                swaps = totalSwaps;
            }
        }
        swapsAllowed[firstNotMakingIt] = 0;

        return swaps == Integer.MAX_VALUE ? -1 : swaps;
    }

    private ArrayList<Double> times() {
        ArrayList<Double> times = new ArrayList<Double>(n);
        for (int i = 0; i < n; i++) {
            times.add((0. + b - x[i]) / v[i]);
        }
        return times;
    }

    private int firstNotMakingIt(List<Double> times, final int[] swapsAllowed) {
        int[] mySwaps = new int[n];
        System.arraycopy(swapsAllowed, 0, mySwaps, 0, n);

        List<Integer> slowChicksAhead = new ArrayList<Integer>();
        for (int i = n-1; i>=0; i--) {
            if (mySwaps[i] > 0) {
                slowChicksAhead.add(0, i);
                continue;
            }

            double timeI = times.get(i);

            if (timeI > t) {
                return i;
            }

            if (slowChicksAhead.isEmpty()) {
                continue;
            }

            for (Integer slowIndex : slowChicksAhead) {
                if (mySwaps[slowIndex] > 0) {
                    mySwaps[slowIndex]--;
                } else {
                    return i;
                }
            }

        }
        return -1;
    }

    private static Integer[] strToIntArr(String s) {
        String[] strings = s.split(" ");
        Integer[] res = new Integer[strings.length];
        for (int i =0; i < strings.length; i++) {
            res[i] = Integer.parseInt(strings[i]);
        }
        return res;
    }

}
