package jam.roundc;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

/**
 * User: looser
 * Date: May 23, 2010
 */
public class RopeIntranet {
    private List<Wire> wires;

    public RopeIntranet(List<Wire> wires) {
        this.wires = wires;
    }

    public static void main(String[] args) throws Exception {
        String name = "A-large(3)";
        BufferedReader f = new BufferedReader(new FileReader(name + ".in"));
        //BufferedReader f = new BufferedReader(new FileReader("inp.txt"));
        //PrintStream out = System.out;
        PrintStream out = new PrintStream(name + ".out");

        Integer T = Integer.parseInt(f.readLine());

        for (int i = 1; i <= T; i++) {
            String[] s = f.readLine().split(" ");
            long N = Long.parseLong(s[0]);


            List<Wire> wires = new ArrayList<Wire>();
            for (int j = 0; j < N; j++) {
                s = f.readLine().split(" ");
                wires.add(new Wire(Integer.parseInt(s[0]), Integer.parseInt(s[1])));
            }

            RopeIntranet o = new RopeIntranet(wires);

            long start = System.currentTimeMillis();

            out.println("Case #" + i + ": " + o.solve());

            long took = System.currentTimeMillis() - start;
            System.err.println("Case #" + i + " took " + took + "ms");
        }
    }

    static class Wire {
        final int a;
        final int b;

        Wire(int a, int b) {
            this.a = a;
            this.b = b;
        }
    }

    private int solve() {
        List<Wire> buildA = new ArrayList<Wire>(wires);
        Collections.sort(buildA, new AComparator());

        List<Wire> buildB = new ArrayList<Wire>(wires);
        Collections.sort(buildB, new BComparator());
        
        int N = buildA.size();

        int counter = 0;
        for (int firstA = 0; firstA < N; firstA++) {
            Wire wireFromA = buildA.get(firstA);
            int firstB = Collections.binarySearch(buildB, wireFromA, new BComparator());
            for (int secondB = 0; secondB < N; secondB++) {
                if (secondB == firstB) {
                    continue;
                }

                Wire wireFromB = buildB.get(secondB);
                int secondA = Collections.binarySearch(buildA, wireFromB, new AComparator());

                if ((firstA < secondA && firstB > secondB)
                        || (firstA > secondA && firstB < secondB)) {
                    counter++;
                }
            }
        }
        return counter / 2;
    }

    private static class BComparator implements Comparator<Wire> {
        public int compare(Wire o1, Wire o2) {
            return o1.b - o2.b;
        }
    }

    private static class AComparator implements Comparator<Wire> {
        public int compare(Wire o1, Wire o2) {
            return o1.a - o2.a;
        }
    }
}
