package jam.qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;

/**
 * User: looser
 * Date: May 8, 2010
 */
public class ThemePark {
    private long r;
    private long k;
    private int[] g;

    public ThemePark(long r, long k, int[] g) {
        this.r = r;
        this.k = k;
        this.g = g;
    }

    public static void main(String[] args) throws Exception {
        BufferedReader f = new BufferedReader(new FileReader("C-large.in"));
        //PrintStream out = System.out;
        PrintStream out = new PrintStream("C-large.out");

        Integer T = Integer.parseInt(f.readLine());

        for (int i = 1; i <= T; i++) {
            String[] s = f.readLine().split(" ");
            long R = Long.parseLong(s[0]);
            long k = Long.parseLong(s[1]);
            long N = Long.parseLong(s[2]);
            int[] g = strToIntArr(f.readLine());

            ThemePark park = new ThemePark(R, k, g);

            out.println("Case #" + i + ": " + park.number());
        }


    }

    List<Integer> indexesOfFirstInTheQueue;

    private long number() {
        indexesOfFirstInTheQueue = new ArrayList<Integer>();

        int nextIndex = 0;
        do {
            indexesOfFirstInTheQueue.add(nextIndex);
            nextIndex = nextIndex();
        } while(!indexesOfFirstInTheQueue.contains(nextIndex));

        int numberBeforeLoop = indexesOfFirstInTheQueue.indexOf(nextIndex);
        int loopLength = indexesOfFirstInTheQueue.size() - numberBeforeLoop;

        long numberOfLoops = r <= numberBeforeLoop ? 0 : (r - numberBeforeLoop) / loopLength;
        int lastLoopRemainder = (int) (r <= numberBeforeLoop ? 0 : (r - numberBeforeLoop) % loopLength);

        if (r <= numberBeforeLoop) {
            numberBeforeLoop = (int) r;
        }

        return amount(0, numberBeforeLoop)
                + numberOfLoops * amount(numberBeforeLoop, indexesOfFirstInTheQueue.size())
                + amount(numberBeforeLoop, numberBeforeLoop + lastLoopRemainder);
    }

    private long amount(int fromIndex, int toIndex) {
        long amount = 0;
        for (Integer gIndex : indexesOfFirstInTheQueue.subList(fromIndex, toIndex)) {
            int nextIndex = gIndex;

            int count = 0;
            int total = 0;
            do {
                total += g[nextIndex];
                nextIndex = (nextIndex + 1) % g.length;
                count++;
            } while(count < g.length && (total + g[nextIndex]) <= k);

            amount += total;
        }

        return amount;
    }

    private int nextIndex() {
        int nextIndex = indexesOfFirstInTheQueue.get(indexesOfFirstInTheQueue.size() - 1);

        int count = 0;
        int total = 0;
        do {
            total += g[nextIndex];
            nextIndex = (nextIndex + 1) % g.length;
            count++;
        } while(count < g.length && (total + g[nextIndex]) <= k);

        return nextIndex;
    }

    private static int[] strToIntArr(String s) {
        String[] strings = s.split(" ");
        int[] res = new int[strings.length];
        for (int i =0; i < strings.length; i++) {
            res[i] = Integer.parseInt(strings[i]);
        }
        return res;
    }
}
