package jam.r1b2009;

import java.util.Arrays;
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;

/**
 * User: looser
 * Date: 12.09.2009
 */
public class TheNextNumber {

    int[] heap = new int[10];

    String asc() {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < heap.length; i++) {
            for (int r = 0; r < heap[i]; r++) {
                sb.append(i);
            }
        }
        return sb.toString();
    }

    String ascLead() {
        StringBuilder sb = new StringBuilder();
        int[] heapCopy = Arrays.copyOf(heap, heap.length);
        for (int i = 1; i < heapCopy.length; i++) {
            if (heapCopy[i] > 0) {
                sb.append(i);
                heapCopy[i]--;
                break;
            }
        }
        for (int i = 0; i < heapCopy.length; i++) {
            for (int r = 0; r < heapCopy[i]; r++) {
                sb.append(i);
            }
        }
        return sb.toString();
    }

    Integer findNextTo(char c) {
        int i = c - (int) '0' + 1;
        if (i > 9) {
            return null;
        }
        for (; i < heap.length; i++) {
            if (heap[i] > 0) {
                return i;
            }
        }
        return null;
    }

    String next(String num) {
        for (int i = 0; i < heap.length; i++) {
            heap[i] = 0;
        }
        for (int i = num.length() - 1; i >= 0; i--) {
            Integer repl = findNextTo(num.charAt(i));
            if (repl != null) {
                heap[repl]--;
                heap[num.charAt(i) - (int)'0']++;
                return num.substring(0, i)
                        + repl
                        + asc();
            }
            heap[num.charAt(i) - (int)'0']++;
        }
        heap[0]++;
        return ascLead();
    }

    public static void main(String[] args) throws Exception {
        BufferedReader in = new BufferedReader(new FileReader("input.txt"));
//        PrintStream out = System.out;
        PrintStream out = new PrintStream("output.txt");
        final Integer T = Integer.valueOf(in.readLine());
        TheNextNumber nextNumber = new TheNextNumber();
        for(int i=1; i<=T; i++) {
            String tmp = String.format("Case #%d: %s", i, nextNumber.next(in.readLine()));
            out.println(tmp);
        }
        in.close();
        out.close();
    }

}
