package ru.atamur.jam;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.Arrays;

/**
 * @ looser
 */
public class Candy {

    public static void main(String[] args) throws Exception {
//        String name = "A-large";
        String name = "C-large";
        BufferedReader f = new BufferedReader(new FileReader(name + ".in"));
//        PrintStream out = System.out;
        PrintStream out = new PrintStream(name + ".out");

        Integer T = Integer.parseInt(f.readLine());

        for (int i = 1; i <= T; i++) {
            int N = Integer.parseInt(f.readLine());
            String[] line = f.readLine().split(" ");
            int[] candies = new int[N];
            for (int j = 0; j < N; j++) {
                candies[j] = Integer.parseInt(line[j]);
            }

            new Solver(out, i, candies).invoke();

        }
        out.flush();
    }

    private static int xor(int[] candies) {
        int xor = 0;
        for (int candy : candies) {
            xor ^= candy;
        }
        return xor;
    }

    private static long sum(int[] candies) {
        long sum = 0;
        for (int candy : candies) {
            sum += candy;
        }
        return sum;
    }

    private static class Solver {
        private PrintStream out;
        private int i;
        private int[] candies;
        private int patricksFirst;

        public Solver(PrintStream out, int i, int[] candies) {
            this.out = out;
            this.i = i;
            Arrays.sort(candies);
            this.candies = new int[candies.length-1];
            System.arraycopy(candies, 1, this.candies, 0, candies.length - 1);
            this.patricksFirst = candies[0];
        }

        public void invoke() {
            long sSum = sum(candies), sXor = xor(candies), pXor = patricksFirst;

            for (int j = 0; j < candies.length; j++) {
                int candy = candies[j];
                if (sXor == pXor) {
                    out.println("Case #" + i + ": " + sSum);
                    return;
                }

                sSum -= candy;
                pXor ^= candy;
                sXor ^= candy;
            }

            out.println("Case #" + i + ": NO");
        }
    }
}
