import java.io.*;
import java.util.*;

public class Main implements Runnable {

    private void solve() throws IOException {

        int T = nextInt();
        for(int t = 1; t <= T; ++t) {
            long D = nextLong();
            int K = nextInt();
            long[] d = new long[K];
            long[] s = new long[K];

            for(int i = 0; i < K; ++i) {
                d[i] = nextLong();
                s[i] = nextLong();
            }
            
            double low = 0.0;
            double high = 1000000000000000000.0;
            double best = -1000.0;
            for(int iter = 0; iter < 100; ++iter) {
                double mid = low + ( high - low ) / 2.0;
//                writer.println("cand = " + mid);
                if(can(mid,d,s,D)) {
                    best = Math.max(best,mid);
                    low = mid;
                } else high = mid;
            }
            writer.printf("Case #%d: %.6f\n",t,best);
        }

    }

    private boolean can(double speed, long[] d, long[] s, long target) {

        for(int a = 0; a < d.length; ++a) {

            long left = target - d[a];

            double after = (left * 1.0) / s[a];
            double me = target / speed;

            if(me < after) return false;
        }
        return true;
    }

    public static void main(String[] args) {
        new Main().run();
    }



    BufferedReader reader;
    //    BufferedReader reader2;
    StringTokenizer tokenizer;
    PrintWriter writer;
    //    BufferedWriter writer;

    public void run() {
        try {
//            reader = new BufferedReader(new InputStreamReader(System.in));
            reader = new BufferedReader(new FileReader("input.txt"));
            //            reader2 = new BufferedReader(new FileReader("1.in"));
            tokenizer = null;
//            writer = new PrintWriter(System.out);
            writer = new     PrintWriter("output.txt");
//                                                    writer = new BufferedWriter(System.out);
            //                        writer = new BufferedWriter(new OutputStreamWriter(System.out));
            solve();
            reader.close();
            //            reader2.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    short nextShort() throws IOException {
        return Short.parseShort(nextToken());
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }

        return tokenizer.nextToken();
    }

}