import java.io.*;

import java.util.*;
import java.util.concurrent.ConcurrentHashMap;

public class Main implements Runnable {

    long multi = 1L;
    long cnt = 0L;

    ConcurrentHashMap<String,Long> hm = new ConcurrentHashMap<>();
    ConcurrentHashMap<String,Long> backup = new ConcurrentHashMap<>();

    long RECURSION_KILLER = 100_000L;

    private void solve() throws IOException {

        int T = nextInt();
        for(int t = 1; t <= T; ++t) {

            long N = nextLong();
            long K = nextLong();
            hm.clear();
            backup.clear();
            go((N - 1) / 2, N / 2, 1L);

            ArrayList<Pair> p = new ArrayList<>();
            for(String s : hm.keySet()) {
                StringTokenizer st = new StringTokenizer(s);
                long left = Long.parseLong(st.nextToken());
                long right = Long.parseLong(st.nextToken());

                long cnt = hm.get(s);
                p.add(new Pair(left, right, cnt));
            }
            Collections.sort(p);
            for(int i = 0; i < p.size(); ++i) {
                if(K - p.get(i).cnt <= 0) {
                    K -= p.get(i).cnt;
                    writer.println("Case #"+t+": "+ p.get(i).right + " " + p.get(i).left);
                    break;
                } else K -= p.get(i).cnt;
            }

            if( K > 0) {

                RECURSION_KILLER = 0L;
                hm.clear();
//                writer.println(backup.size());
                for(String s : backup.keySet()) {
                    StringTokenizer st = new StringTokenizer(s);
                    long left = Long.parseLong(st.nextToken());
                    long right = Long.parseLong(st.nextToken());
                    long cnt = backup.get(s);

                    if(left == right) {
                        go((left - 1) / 2, left / 2,cnt * 2);
                    } else {
                        go((left - 1) / 2, left / 2, cnt);
                        go((right - 1) / 2, right / 2, cnt);
                    }
                }
                ArrayList<Pair> pp = new ArrayList<>();
                for(String s : hm.keySet()) {
                    StringTokenizer st = new StringTokenizer(s);
                    long left = Long.parseLong(st.nextToken());
                    long right = Long.parseLong(st.nextToken());
                    long cnt = hm.get(s);
                    pp.add(new Pair(left,right,cnt));
                }
                Collections.sort(pp);

                for(int i = 0; i < pp.size(); ++i) {
                    if(K - pp.get(i).cnt <= 0) {
                        K -= pp.get(i).cnt;
                        writer.println("Case #"+t+": "+pp.get(i).right+" "+pp.get(i).left);
                        break;
                    } else K -= pp.get(i).cnt;
                }
                if(K > 0) {
                    writer.println("Case #"+t+": 0 0");
                }

            }


        }
    }

    public void go(long left,long right,long multi) {

        String s = left+" "+right;
        if(!hm.containsKey(s)) {
            hm.put(s,multi);
        } else hm.put(s,hm.get(s) + multi);
        if(left <= RECURSION_KILLER) {
            if(!backup.containsKey(s)) {
                backup.put(s, multi);
            } else backup.put(s,backup.get(s) + multi);
            return;
        }
        if(left == right) {
            go((left - 1) / 2, left / 2,multi * 2);
        } else {
                go((left - 1) / 2, left / 2, multi);
                go((right - 1) / 2, right / 2, multi);
        }
    }

    static class Pair implements Comparable<Pair> {
        long left;
        long right;
        long cnt;

        public Pair(long left,long right,long cnt) {
            this.left = left;
            this.right = right;
            this.cnt = cnt;
        }

        @Override
        public int compareTo(Pair o) {
            long minA = Math.min(this.left,this.right);
            long minB = Math.min(o.left,o.right);

            long maxA = Math.max(this.left,this.right);
            long maxB = Math.max(o.left,o.right);

            if(minA != minB) {
                return Long.compare(minB,minA);
            } else {
                return Long.compare(maxB,maxA);
            }

        }
    }

    public static void main(String[] args) {
        new Main().run();
    }

    BufferedReader reader;
    //    BufferedReader reader2;
    StringTokenizer tokenizer;
    PrintWriter writer;
    //    BufferedWriter writer;

    public void run() {
        try {
//            reader = new BufferedReader(new InputStreamReader(System.in));
            reader = new BufferedReader(new FileReader("input.txt"));
            //            reader2 = new BufferedReader(new FileReader("1.in"));
            tokenizer = null;
//            writer = new PrintWriter(System.out);
            writer = new     PrintWriter("output.txt");
//                                                    writer = new BufferedWriter(System.out);
            //                        writer = new BufferedWriter(new OutputStreamWriter(System.out));
            solve();
            reader.close();
            //            reader2.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    short nextShort() throws IOException {
        return Short.parseShort(nextToken());
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }

        return tokenizer.nextToken();
    }

}