import java.io.*;
import java.util.*;

public class Main implements Runnable {

    private void solve() throws IOException {

        int T = nextInt();
        for(int t = 1; t <= T; ++t) {


            int N = nextInt();
            int Q = nextInt();

            long[] dist = new long[N+1];
            long[] speed = new long[N+1];

            for(int i = 1; i <= N; ++i) {
                dist[i] = nextLong();
                speed[i] = nextLong();
            }

            long[][] g = new long[N+1][N+1];
            for(int i = 1; i <= N; ++i) {
                for(int j = 1; j <= N; ++j) {
                    g[i][j] =nextLong();
                    if(g[i][j] == -1) {
                        g[i][j] = 1L << 60;
                    }
                }
            }
            long back = 1L << 60;


            for(int k = 1; k <= N; ++k) {
                for(int i = 1; i <= N; ++i) {
                    for(int j = 1; j <= N; ++j) {
                        g[i][j] = Math.min(g[i][j],g[i][k] + g[k][j]);
                    }
                }
            }


            StringBuilder sb = new StringBuilder("");

            for(int q = 0; q < Q; ++q) {
                int start = nextInt();
                int end = nextInt();
                PriorityQueue<Edge> pq = new PriorityQueue<>();
                double[][] dp = new double[N+1][N+1];
                boolean[][] used = new boolean[N+1][N+1];

                for(double[] ini : dp) Arrays.fill(ini, 1L << 60);


                double best = 1000000000000000000.0;

                pq.offer(new Edge(start,1,0.0));


                while(!pq.isEmpty()) {
                    Edge top = pq.poll();

                    if(top.to == end) {
                        best = top.w;
                        break;
                    }
                    if(used[top.to][top.houseId]) continue;
                    used[top.to][top.houseId] = true;

                    for(int k = 1; k <= N; ++k) {
                        if(k == top.to) continue;
                        if(g[top.to][k] == back) continue;

                        if(g[top.to][k] <= dist[top.houseId]) {
                            double need = (g[top.to][k] * 1.0) / speed[top.houseId];

                            if(dp[k][k] > top.w + need) {
                                dp[k][k] = top.w + need;
                                pq.offer(new Edge(k,k,dp[k][k]));
                            }
                        }
                    }
                }
                if(sb.length() == 0) sb.append(best);
                else sb.append(" "+best);

            }
            writer.println("Case #"+t+": "+sb);
        }
    }

    static class Edge implements Comparable<Edge> {
        int to;
        int houseId;
        double w;

        public Edge(int to,int houseId,double w) {
            this.to = to;
            this.houseId = houseId;
            this.w = w;
        }

        @Override
        public int compareTo(Edge o) {
            return Double.compare(this.w,o.w);
        }
    }
    public static void main(String[] args) {
        new Main().run();
    }



    BufferedReader reader;
    //    BufferedReader reader2;
    StringTokenizer tokenizer;
    PrintWriter writer;
    //    BufferedWriter writer;

    public void run() {
        try {
//            reader = new BufferedReader(new InputStreamReader(System.in));
            reader = new BufferedReader(new FileReader("input.txt"));
            //            reader2 = new BufferedReader(new FileReader("1.in"));
            tokenizer = null;
//            writer = new PrintWriter(System.out);
            writer = new     PrintWriter("output.txt");
//                                                    writer = new BufferedWriter(System.out);
            //                        writer = new BufferedWriter(new OutputStreamWriter(System.out));
            solve();
            reader.close();
            //            reader2.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    short nextShort() throws IOException {
        return Short.parseShort(nextToken());
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }

        return tokenizer.nextToken();
    }

}