import java.io.*;
import java.util.*;

public class Main implements Runnable {

    private void solve() throws IOException {

        int T = nextInt();
        for(int t = 1; t <= T; ++t) {

            int N = nextInt();
            int P = nextInt();
            int[] ing = new int[N];
            for(int i = 0; i < N; ++i) {
                ing[i] = nextInt();
            }
            int[][] p = new int[N][P];
            for(int i = 0; i < N; ++i) {
                for(int j = 0; j < P; ++j) {
                    p[i][j] = nextInt();
                }
            }



            // g[0][0] = source
            // g[N+1][P+1] = sink
            int[][] id = new int[N][P];
            int[][] id2 = new int[N][P];
            int cc = 1;

            for(int i = 0; i < N; ++i) {
                for(int j = 0; j < P; ++j) {
                    id[i][j] = cc++;
                }
            }

            int[][][] magic = new int[N+1][P+1][12];
            int[][] g = new int[cc + 1][cc + 1];
            int[][] count = new int[cc + 1][cc + 1];

            int sink = cc;

            for(int i = 0; i < N; ++i) {

                for(int j = 0; j < P; ++j) {

                    if(i == 0) {

                        int partA = p[i][j] / ing[i];
                        int partB = partA + 1;
                        int[] flow_range = new int[12];
                        int idd = 0;
                        for(int cut = -5; cut <= 5; ++cut) {
                            flow_range[idd++] = partA+ cut;
                        }


                        for(int z = 0; z < 12; ++z) {
                            if(flow_range[z] <= 0) continue;
                            if(isOk(flow_range[z],p[i][j],ing[i])) {
                                g[0][id[i][j]] = 1;
                                magic[i][j][z] = flow_range[z];
                            }
                        }

                    } else {
                        for(int z = 0; z < P; ++z) {
                            for(int take = 0; take < 12; ++take) {
                                if(magic[i-1][z][take] != -1) {
                                    if(isOk(magic[i-1][z][take],p[i][j],ing[i])) {
                                        g[id[i-1][z]][id[i][j]] = 1;
                                        magic[i][j][take] = magic[i-1][j][take];
                                    }
                                }
                            }

                        }
                    }
                }
            }
            for(int j = 0; j < P; ++j) {
                for(int take = 0; take < 12; ++take) {
                    if(magic[N-1][j][take] != 0) {
                        g[id[N-1][j]][sink] = 1;
                    }
                }
            }

            int flow = 0;

            int[] parent = new int[sink + 1];
            int[] cost = new int[sink + 1];
            int source = 0;
            cost[source] = Integer.MAX_VALUE;
            parent[source] = source;

            while(true) {
                Queue<Integer> q = new LinkedList<Integer>();
                q.offer(source);
                boolean[] used = new boolean[sink + 1];
                used[source] = true;
                boolean done = true;
                while (!q.isEmpty()) {
                    int v = q.poll();
                    if (v == sink) {
                        done = false;
                        break;
                    }

                    for (int to = 0; to < g[v].length; ++to) {
                        if (g[v][to] > 0 && !used[to]) {
                            parent[to] = v;
                            cost[to] = Math.min(cost[v], g[v][to]);
                            used[to] = true;
                            q.offer(to);
                        }
                    }

                }
                if (done) break;
                ++flow;
                int end = sink;
                while (parent[end] != end) {
                    g[parent[end]][end] -= cost[sink];
                    g[end][parent[end]] += cost[sink];
                    end = parent[end];
                }
            }
            writer.println("Case #"+t+": "+flow);
        }
    }

    private boolean isOk(int pieces, int total, int need) {
//        double all = need * pieces;
//        writer.println("all = " + all + " total = " + total);
//        double result = ((all * 100.0) / total) + 1e-10;
//        writer.println("result = " + result);

        double totalNeed = need * pieces;
        double have = total;
        double result = (have * 100.0) / totalNeed;
        if(result >= 90.0 && result <= 110.0) return true;
        return false;

    }

    public static void main(String[] args) {
        new Main().run();
    }

    BufferedReader reader;
    //    BufferedReader reader2;
    StringTokenizer tokenizer;
    PrintWriter writer;
    //    BufferedWriter writer;

    public void run() {
        try {
//            reader = new BufferedReader(new InputStreamReader(System.in));
            reader = new BufferedReader(new FileReader("input.txt"));
            //            reader2 = new BufferedReader(new FileReader("1.in"));
            tokenizer = null;
//            writer = new PrintWriter(System.out);
            writer = new     PrintWriter("output.txt");
//                                                    writer = new BufferedWriter(System.out);
            //                        writer = new BufferedWriter(new OutputStreamWriter(System.out));
            solve();
            reader.close();
            //            reader2.close();
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    short nextShort() throws IOException {
        return Short.parseShort(nextToken());
    }

    String nextToken() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }

        return tokenizer.nextToken();
    }

}