import java.io.*;
import java.util.*;
import java.util.HashMap;


public class coin_jam {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    	int t = in.nextInt();
    	for (int i = 1; i <= t; i++) {
    		System.out.println("Case #" + i + ": ");
    		int n = in.nextInt();
    		int j = in.nextInt();
			generateCoins(n-2,j);
    	}
	}

	static void generateCoins(int exponent, int coinsNeeded) {
		long maxNum = (long)Math.pow(2,exponent);
		int coinsFormed = 0;

		for(long i = 0; i < maxNum; i++) {
        	int[] coin = getBinaryForm(i,exponent);

        	long[] decimalForms = new long[9];
        	for (int j = 2; j < 11; j++)
        		decimalForms[j-2] = getDecimalForm(j, coin);

            String divisors = getDivisors(decimalForms);
            if (divisors.equals(""))
            	continue;
         
            for (int j = coin.length-1; j>-1 ; j--)
            	System.out.print(coin[j]);
            System.out.println(divisors);

            coinsFormed++;
            if (coinsFormed == coinsNeeded)
            	return;
        }
	}

	static int[] getBinaryForm(long number,int exponent) {
		int[] coin = new int[exponent+2];		// For 1 in front and end.
		long copyNum = number;
        for (int j = 1; j <= exponent; j++) {
            if (copyNum%2 == 1)
                coin[j] = 1;
            else
                coin[j] = 0;
            copyNum = copyNum/2;
        }
        coin[0] = 1;
        coin[exponent+1] = 1;
        return coin;
	}

	static long getDecimalForm(int base, int[] coin) {
		long val = 0;
		for (int i = 0; i < coin.length; i++) {
			if (coin[i] == 1)
				val = val + (long)Math.pow(base,i);
		}
		return val;
	}

	static String getDivisors(long[] decimalForms) {
		String divisors = "";
		for (int i=0; i<decimalForms.length; i++) {
			boolean isPrime = true;
			for (long j = 2; j < Math.sqrt(decimalForms[i]); j++) {
				if (decimalForms[i] % j == 0) {
					divisors = divisors + " " + j;
					isPrime = false;
					break;
				}
			}
			if (isPrime)
				return "";
		}
		return divisors;
	}

}