import java.io.BufferedWriter;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.io.IOException;
import java.util.Scanner;
import java.io.File;
import java.io.FileWriter;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

import java.util.Iterator;
import java.util.TreeSet;

public class DeceitfulWar {

    public static void main(String[] args) {

        try {

        	Path path = FileSystems.getDefault().getPath(".", args[0]);
            Scanner in = new Scanner(path);
            //File out = new File("./output.txt");
            File out = new File("./" + args[1]);
            if (!out.exists()) out.createNewFile();

            FileWriter fw = new FileWriter(out.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);


            int T = Integer.parseInt(in.nextLine());


            for (int i = 1; i <= T; i++) {
                // # of blocks
                int blocks = Integer.parseInt(in.nextLine());

                TreeSet<Double> naomi_w = new TreeSet<Double>();
                TreeSet<Double> ken_w = new TreeSet<Double>();
                TreeSet<Double> naomi_dw = new TreeSet<Double>();
                TreeSet<Double> ken_dw = new TreeSet<Double>();
                // load and sort naomi's blocks
                Scanner naomi_line = new Scanner(in.nextLine());
                for(int b = 0; b < blocks; b++) {
                    Double block = naomi_line.nextDouble();
                    naomi_dw.add(block);
                    naomi_w.add(block);
                }
                naomi_line.close();


                Scanner ken_line = new Scanner(in.nextLine());
                for(int b = 0; b < blocks; b++) {
                    Double block = ken_line.nextDouble();
                    ken_dw.add(block);
                    ken_w.add(block);
                }
                ken_line.close();

                int[] scores = new int[2];
                scores[0] = d_war(naomi_dw, ken_dw);
                scores[1] = war(naomi_w,ken_w);

                //System.out.print(scores[0] + ", " + scores[1] + "\n");

                bw.write("Case #" + i + ": " + scores[0] + " " + scores[1] + "\n");

            }


            bw.close();

        } catch (IOException x) {
            System.err.format("IOException: %s%n", x);
        }


    }

    private static int war(TreeSet<Double> naomi, TreeSet<Double> ken) {
        int naomi_score = 0;
        
        Double block, ken_block;
        while(!naomi.isEmpty()) {
            block = naomi.pollFirst();
            ken_block = ken_brain(ken, block);

            if(block > ken_block) naomi_score++;
            
        }

        return naomi_score;        
    }

    private static int d_war(TreeSet<Double> naomi, TreeSet<Double> ken) {
        int naomi_score = 0;
        Double block, ken_min, ken_max, tmp;
        ken_min = ken.first();
        ken_max = ken.last();
        while(!naomi.isEmpty()) {
            block = naomi.pollFirst();
            if(block > ken_min) {
                tmp = ken_brain(ken, ken_max + 1.0);
                //ken.remove(ken_min);
                if(!ken.isEmpty()) ken_min = ken.first();
                naomi_score++;
            }
            else {
                
                if(!ken.isEmpty()) ken_max = ken.last();
            }
        }

        return naomi_score;        
    }

    private static Double ken_brain(TreeSet<Double> ken, Double war_block) {
        // if war_block > ken.max , return min (remove from list)
        if(war_block > ken.last() || ken.isEmpty() ) {
            // Retrieves and removes the first (lowest) element, or returns null if this set is empty
            return ken.pollFirst();
        }
        else { 
        // else, return smallest Block which is greater than war_block
            // higher() : returns the least element in the set strictly greater than the given element (or Null)
            Double larger = ken.higher(war_block);
            ken.remove(larger);
            return larger;
        }

    }

    private static void printSet(TreeSet<Double> set) {
        Iterator<Double> iterator = set.iterator();
        while (iterator.hasNext()) {
            System.out.print(" " + iterator.next());
        }
        System.out.print("\n");
    }

}






