import java.io.BufferedWriter;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.io.IOException;
import java.util.Scanner;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;

public class CookieClicker {

    public static void main(String[] args) {

        try {

        	Path path = FileSystems.getDefault().getPath(".", args[0]);
            Scanner in = new Scanner(path);
            //File out = new File("./output.txt");
            File out = new File("./" + args[1]);
            if (!out.exists()) out.createNewFile();

            FileWriter fw = new FileWriter(out.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);


            int T = Integer.parseInt(in.nextLine());
            double C, F, X, result;
            for (int i = 1; i <= T; i++) {

                Scanner line = new Scanner(in.nextLine());
                C = line.nextDouble();
                F = line.nextDouble();
                X = line.nextDouble();
                //System.out.print(C + " " + F + " " + X + "\n");
                result = cookieSolver(C,F,X);
                System.out.print("Case #" + i + ": " + result + "\n");
                bw.write("Case #" + i + ": " + result + "\n");

            }

            bw.close();

        } catch (IOException x) {
            System.err.format("IOException: %s%n", x);
        }


    }

    private static double cookieSolver(double C, double F, double X) {
        int z = 0; // # of factories
        double nextFactory;
        double bestTime = X / 2;
        double tmpTime;
        double time = 0.0;
        double rate = 2;

        while(true) {
            // compute time till next factory
            nextFactory = C / rate;
            // at to time
            time += nextFactory;
            // increment rate
            rate += F;
            // compute total time to X
            tmpTime = (X / rate) + time;

            if(tmpTime > bestTime) {
                return bestTime;
            } else {
                bestTime = tmpTime;
            }

        }

    }

}
