import java.io.BufferedWriter;
import java.nio.file.FileSystems;
import java.nio.file.Path;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;
import java.io.File;
import java.io.FileWriter;

public class magic_trick {

    public static void main(String[] args) {

        try {

        	Path path = FileSystems.getDefault().getPath(".", args[0]);
            Scanner in = new Scanner(path);
            File out = new File("./output.txt");
            if (!out.exists()) out.createNewFile();

            FileWriter fw = new FileWriter(out.getAbsoluteFile());
            BufferedWriter bw = new BufferedWriter(fw);


            int T = Integer.parseInt(in.nextLine());
            int row1, row2;
            int[][] A1, A2;

            for (int i = 1; i <= T; i++) {
                row1 = Integer.parseInt(in.nextLine()) - 1;                
                A1 = scanArrangement(in);                
                row2 = Integer.parseInt(in.nextLine()) - 1;
                A2 = scanArrangement(in);
                bw.write("Case #" + i + ": " + findCard(row1,A1,row2,A2));
            }

            bw.close();

        } catch (IOException x) {
            System.err.format("IOException: %s%n", x);
        }


    }
    private static String findCard(int row1, int[][] arr1, int row2, int[][] arr2) {
        if(arr1[row1].length != arr2[row2].length) return "Error!";
        ArrayList<Integer> matches = new ArrayList<Integer>();
        for(int i = 0; i < arr1[row1].length; i++) {
            int card = arr1[row1][i];
            for (int j = 0; j < arr2[row2].length; j++) {
                if (card == arr2[row2][j]) matches.add(new Integer(card));
            }
        }
        if (matches.isEmpty()) {
            return "Volunteer cheated!\n";
        }
        else if(matches.size() > 1) {
            return "Bad magician!\n";
        }
        else {
            return "" + matches.get(0) + "\n";
        }
    }

    private static int[][] scanArrangement(Scanner s) {
        int[][] A = new int[4][4];

        for(int i = 0; i < 4; i++) {
            if (s.hasNextLine()) {
                Scanner line = new Scanner(s.nextLine());
                for(int j = 0; j < 4; j++) {
                    if(line.hasNextInt()) A[i][j] = line.nextInt();
                }
                line.close();
            }
        }
        return  A;
    }

}
