import java.util.*;
import java.io.*;

public class Main {

	public static void fillArr(char[][] arr, char val) {
		for (char[] row : arr) {
			Arrays.fill(row, val);
		}
	}

	public static void printArr(char[][] arr) {
		for (char[] row : arr) {
			for (char x : row) {
				System.out.print(x + " ");
			}
			System.out.println();
		}
	}

	public static boolean check(char[][] board) {
		int R = board.length;
		int C = board[0].length;
		int count = 0;
		int x1 = 0;
		int y1 = 0;
		for (int i = 0; i < R; i++) {
			for (int j = 0; j < C; j++) {
				boolean valid = true;
				for (int k = -1; k <= 1; k++) {
					for (int l = -1; l <= 1; l++) {
						int x = i + k;
						int y = j + l;
						if (x >= 0 && x < R && y >= 0 && y < C) {
							if (board[x][y] == '*') {
								valid = false;
							}
						}
						if (!valid)
							break;
					}
					if (!valid)
						break;
				}
				if (valid) {
					board[i][j] = 'c';
					return true;
				} else if (board[i][j] == '.') {
					if (count == 0) {
						x1 = i;
						y1 = j;
					}
					count++;
				}
			}
		}
		if (count == 1) {
			board[x1][y1] = 'c';
			return true;
		}
		return false;
	}

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader("C-small-attempt3.in"));
		PrintWriter writer = new PrintWriter("output.txt");
		StringTokenizer st;
		int T = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= T; i++) {

			st = new StringTokenizer(reader.readLine());

			int R = Integer.parseInt(st.nextToken());
			int C = Integer.parseInt(st.nextToken());
			int M = Integer.parseInt(st.nextToken());

			char[][] board = new char[R][C];
			fillArr(board, '.');

			String dir = "right";
			int x = 0;
			int y = 0;

			while (M > 0) {
				board[x][y] = '*';
				M--;
				if (dir.equals("right")) {
					if (y == C - 1 || board[x][y + 1] == '*') {
						x++;
						dir = "down";
					} else {
						y++;
					}
				} else if (dir.equals("down")) {
					if (x == R - 1 || board[x + 1][y] == '*') {
						y--;
						dir = "left";
					} else {
						x++;
					}
				} else if (dir.equals("left")) {
					if (y == 0 || board[x][y - 1] == '*') {
						x--;
						dir = "top";
					} else {
						y--;
					}
				} else {
					// top
					if (x == 0 || board[x - 1][y] == '*') {
						y++;
						dir = "right";
					} else {
						x--;
					}
				}
			}

			boolean valid = check(board);

			writer.println("Case #" + i + ":");
			if (valid) {
				for (char[] row : board) {
					writer.println(row);
				}
			} else {
				writer.println("Impossible");
			}
		}
		writer.close();
		reader.close();
	}
}