package infinitepancake;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class InfinitePancake {

	public static void main(String[] args) throws Exception {
		String directory = "D:\\Work\\eclipse\\workspace\\CodeJam2015\\src\\infinitepancake\\";
		 String fileName = "B-small-attempt13";
		//String fileName = "test";
		File file = new File(directory + fileName + ".in");
		File outFile = new File(directory + fileName + ".out");
		BufferedReader br = new BufferedReader(new FileReader(file));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
		int testCases = Integer.parseInt(br.readLine());
		for (int t = 1; t <= testCases; t++) {
			/*
			 * Your code here
			 */
			String input1 = br.readLine();
			String input2 = br.readLine();
			String answer = solve(input1, input2);

			String response = "Case #" + t + ": " + answer + "\n";
			bw.write(response);

			//System.out.println(input2);
			//System.out.println(response);
		}
		br.close();
		bw.close();
	}

	public static String solve(String input1, String input2) {
		String[] token = input2.split(" ");
		int[] pancakeArr = new int[token.length];
		for (int i = 0; i < token.length; i++) {
			pancakeArr[i] = Integer.parseInt(token[i]);
		}
		Arrays.sort(pancakeArr);

		List<MyTime> timeList = new ArrayList<MyTime>();
		int multiplier = 0;
		int prevValue = pancakeArr[pancakeArr.length - 1];
		for (int i = pancakeArr.length - 1; i >= 0; i--) {
			int pancake = pancakeArr[i];
			if (pancake == prevValue) {
				multiplier++;
			} else {
				MyTime pancakeTime = getSchedule(prevValue);
				pancakeTime.multiplier = multiplier;
				timeList.add(pancakeTime);
				multiplier = 1;
				prevValue = pancake;
			}
		}
		MyTime pancakeTime = getSchedule(prevValue);
		pancakeTime.multiplier = multiplier;
		timeList.add(pancakeTime);

		//printTimeList(timeList);

		MyTime bestTime = calTotalTime(timeList);
		boolean isFinish = false;
		while (!isFinish) {
			isFinish = true;
			for (int i = 0; i < timeList.size(); i++) {
				MyTime currentTime = timeList.get(i);

				currentTime.updateSpecial(currentTime.specialTime + 1);
				MyTime newTime = calTotalTime(timeList);

				if (newTime.diff(bestTime) <= 0) {
					bestTime = newTime;
					isFinish = false;
				} else {
					currentTime.updateSpecial(currentTime.specialTime - 1);
				}

				// printTimeList(timeList);
			}
		}

		return String.valueOf(bestTime.specialTime + bestTime.eatTime);
	}

	private static MyTime calTotalTime(List<MyTime> timeList) {
		MyTime totalTime = new MyTime(0);
		for (MyTime t : timeList) {
			totalTime.specialTime += t.multiplier * t.specialTime;
			if (t.eatTime > totalTime.eatTime) {
				totalTime.eatTime = t.eatTime;
			}
		}
		return totalTime;
	}

	private static MyTime getSchedule(int pancake) {
		MyTime time = new MyTime(pancake);
		time.eatTime = pancake;
		return time;
	}

	private static void printTimeList(List<MyTime> timeList) {
		MyTime total = calTotalTime(timeList);
		System.out.println("Total = " + (total.specialTime + total.eatTime));
		for (MyTime t : timeList) {
			System.out.println(t.toString());
		}
		System.out.println();
	}
}

class MyTime {
	int number;
	int multiplier = 1;
	int specialTime;
	int eatTime;

	MyTime(int a) {
		number = a;
	}

	public void updateSpecial(int sp) {
		specialTime = sp;
		eatTime = (int) Math.ceil(number * 1.0 / (specialTime + 1));
	}

	public String toString() {
		return "num = " + number + ", mul = " + multiplier + ", sp = " + specialTime + ", e = " + eatTime;
	}

	public int diff(MyTime time2) {
		return (specialTime + eatTime) - (time2.specialTime + time2.eatTime);
	}
}
