package dijkstra;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.Map;

public class Dijkstra {

	public static void main(String[] args) throws Exception {
		String directory = "D:\\Work\\eclipse\\workspace\\CodeJam2015\\src\\dijkstra\\";
		String fileName = "C-small-attempt5";
		//String fileName = "test";
		File file = new File(directory + fileName + ".in");
		File outFile = new File(directory + fileName + ".out");
		BufferedReader br = new BufferedReader(new FileReader(file));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
		int testCases = Integer.parseInt(br.readLine());
		for (int t = 1; t <= testCases; t++) {
			/*
			 * Your code here
			 */
			String input1 = br.readLine();
			String input2 = br.readLine();
			String answer = solve(input1, input2);

			String response = "Case #" + t + ": " + answer + "\n";
			bw.write(response);

			//System.out.print(response);
		}
		br.close();
		bw.close();
	}

	private static Map<String, String> MULTIPLY = new HashMap<String, String>();
	private static int MAX_REOCCUR = 0;
	private static String LITERAL = "";
	private static String LITERAL_RESULT = "";
	private static String INITIAL_RESULT = "1";

	public static String solve(String input1, String input2) {
		String[] tokenArr = input1.split(" ");
		MAX_REOCCUR = Integer.parseInt(tokenArr[1]);
		LITERAL = input2;
		LITERAL_RESULT = calculate(LITERAL);

		init();

		boolean isPossible = checkIJK();

		return isPossible ? "YES" : "NO";
	}

	private static boolean checkIJK() {
		int[] currentStartPos = getI(INITIAL_RESULT, 0, 0);
		int[] currentEndPos = getK(INITIAL_RESULT, MAX_REOCCUR - 1, LITERAL.length() - 1);
		if (checkJ(currentStartPos[0], currentStartPos[1], currentEndPos[0], currentEndPos[1])) {
			return true;
		}

		while ((currentStartPos[0] < currentEndPos[0]) || (currentStartPos[0] == currentEndPos[0] && currentStartPos[1] < currentEndPos[1])) {
			int[] newStartPos = getI("i", currentStartPos[0], currentStartPos[1]);
			int[] newEndPos = getK("k", currentEndPos[0], currentEndPos[1]);
			
			if (checkJ(currentStartPos[0], currentStartPos[1], newEndPos[0], newEndPos[1])) {
				return true;
			}
			if (checkJ(newStartPos[0], newStartPos[1], currentEndPos[0], currentEndPos[1])) {
				return true;
			}
			if (checkJ(newStartPos[0], newStartPos[1], newEndPos[0], newEndPos[1])) {
				return true;
			}
			currentStartPos = newStartPos;
			currentEndPos = newEndPos;
		}

		return false;
	}

	private static int[] getI(String currentResult, int startReoccur, int startIndex) {
		if (startIndex >= LITERAL.length()) {
			startReoccur++;
			startIndex -= LITERAL.length();
		}
		for (int h = startReoccur; h < MAX_REOCCUR; h++) {
			for (int i = startIndex; i < LITERAL.length(); i++) {
				currentResult = multiply(currentResult, LITERAL.charAt(i) + "");
				if ("i".equals(currentResult)) {
					return new int[] { h, i + 1 };
				}
			}
			startIndex = 0;
		}
		return new int[] { MAX_REOCCUR + 1, LITERAL.length() + 1 };
	}

	private static int[] getK(String currentResult, int endReoccur, int endIndex) {
		if (endIndex < 0) {
			endReoccur--;
			endIndex += LITERAL.length();
		}
		for (int h = endReoccur; h >= 0; h--) {
			for (int i = endIndex; i >= 0; i--) {
				currentResult = multiply(LITERAL.charAt(i) + "", currentResult);
				if ("k".equals(currentResult)) {
					return new int[] { h, i - 1 };
				}
			}
			endIndex = LITERAL.length() - 1;
		}
		return new int[] { -1, -1 };
	}

	private static boolean checkJ(int startReoccur, int startIndex, int endReoccur, int endIndex) {
		if (startIndex >= LITERAL.length()) {
			startReoccur++;
			startIndex -= LITERAL.length();
		}
		if (endIndex < 0) {
			endReoccur--;
			endIndex += LITERAL.length();
		}

		String currentResult = INITIAL_RESULT;

		if (startReoccur == endReoccur) {
			for (int i = startIndex; i <= endIndex; i++) {
				currentResult = multiply(currentResult, LITERAL.charAt(i) + "");
			}
		} else {
			for (int h = startReoccur; h <= endReoccur; h++) {
				if (h == startReoccur) {
					for (int i = startIndex; i < LITERAL.length(); i++) {
						currentResult = multiply(currentResult, LITERAL.charAt(i) + "");
					}
				} else if (h == endReoccur) {
					for (int i = 0; i < endIndex + 1; i++) {
						currentResult = multiply(currentResult, LITERAL.charAt(i) + "");
					}
				} else {
					currentResult = multiply(currentResult, LITERAL_RESULT);
				}
			}
		}

		return "j".equals(currentResult);
	}

	private static String multiply(String str1, String str2) {
		return MULTIPLY.get(str1 + str2);
	}

	private static String calculate(String literal) {
		String result = "1";
		for (int i = 0; i < literal.length(); i++) {
			result = multiply(result, literal.charAt(i) + "");
		}
		return result;
	}

	private static void init() {
		MULTIPLY.put("11", "1");
		MULTIPLY.put("1i", "i");
		MULTIPLY.put("1j", "j");
		MULTIPLY.put("1k", "k");

		MULTIPLY.put("1m1", "m1");
		MULTIPLY.put("1mi", "mi");
		MULTIPLY.put("1mj", "mj");
		MULTIPLY.put("1mk", "mk");

		MULTIPLY.put("m11", "m1");
		MULTIPLY.put("m1i", "mi");
		MULTIPLY.put("m1j", "mj");
		MULTIPLY.put("m1k", "mk");

		MULTIPLY.put("m1m1", "1");
		MULTIPLY.put("m1mi", "i");
		MULTIPLY.put("m1mj", "j");
		MULTIPLY.put("m1mk", "k");

		MULTIPLY.put("i1", "i");
		MULTIPLY.put("ii", "m1");
		MULTIPLY.put("ij", "k");
		MULTIPLY.put("ik", "mj");

		MULTIPLY.put("im1", "mi");
		MULTIPLY.put("imi", "1");
		MULTIPLY.put("imj", "mk");
		MULTIPLY.put("imk", "j");

		MULTIPLY.put("mi1", "mi");
		MULTIPLY.put("mii", "1");
		MULTIPLY.put("mij", "mk");
		MULTIPLY.put("mik", "j");

		MULTIPLY.put("mim1", "i");
		MULTIPLY.put("mimi", "m1");
		MULTIPLY.put("mimj", "k");
		MULTIPLY.put("mimk", "mj");

		MULTIPLY.put("j1", "j");
		MULTIPLY.put("ji", "mk");
		MULTIPLY.put("jj", "m1");
		MULTIPLY.put("jk", "i");

		MULTIPLY.put("jm1", "mj");
		MULTIPLY.put("jmi", "k");
		MULTIPLY.put("jmj", "1");
		MULTIPLY.put("jmk", "mi");

		MULTIPLY.put("mj1", "mj");
		MULTIPLY.put("mji", "k");
		MULTIPLY.put("mjj", "1");
		MULTIPLY.put("mjk", "mi");

		MULTIPLY.put("mjm1", "j");
		MULTIPLY.put("mjmi", "mk");
		MULTIPLY.put("mjmj", "m1");
		MULTIPLY.put("mjmk", "i");

		MULTIPLY.put("k1", "k");
		MULTIPLY.put("ki", "j");
		MULTIPLY.put("kj", "mi");
		MULTIPLY.put("kk", "m1");

		MULTIPLY.put("km1", "mk");
		MULTIPLY.put("kmi", "mj");
		MULTIPLY.put("kmj", "i");
		MULTIPLY.put("kmk", "1");

		MULTIPLY.put("mk1", "mk");
		MULTIPLY.put("mki", "mj");
		MULTIPLY.put("mkj", "i");
		MULTIPLY.put("mkk", "1");

		MULTIPLY.put("mkm1", "k");
		MULTIPLY.put("mkmi", "j");
		MULTIPLY.put("mkmj", "mi");
		MULTIPLY.put("mkmk", "m1");
	}
}
