package omino;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class Omino {

	public static void main(String[] args) throws Exception {
		String directory = "D:\\Work\\eclipse\\workspace\\CodeJam2015\\src\\omino\\";
		String fileName = "D-large";
		//String fileName = "test";
		File file = new File(directory + fileName + ".in");
		File outFile = new File(directory + fileName + ".out");
		BufferedReader br = new BufferedReader(new FileReader(file));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
		int testCases = Integer.parseInt(br.readLine());
		for (int t = 1; t <= testCases; t++) {
			/*
			 * Your code here
			 */
			String input = br.readLine();
			String answer = solve(input);

			String response = "Case #" + t + ": " + answer + "\n";
			bw.write(response);

			//System.out.print(response);
		}
		br.close();
		bw.close();
	}

	private static int WIDTH = 0;
	private static int HEIGHT = 0;
	
	public static String solve(String input) {
		String[] tokenArr = input.split(" ");
		int omino = Integer.parseInt(tokenArr[0]);
		WIDTH = Integer.parseInt(tokenArr[1]);
		HEIGHT = Integer.parseInt(tokenArr[2]);

		boolean isPossible = true;
		if (omino == 2) {
			isPossible = check2();
		} else if (omino == 3) {
			isPossible = check3();
		} else if (omino == 4) {
			isPossible = check4();
		} else if (omino == 5) {
			isPossible = check5();
		} else if (omino == 6) {
			isPossible = check6();
		} else {
			isPossible = false;
		}

		//System.out.println("input = " + input);

		return isPossible ? "GABRIEL" : "RICHARD";
	}

	private static boolean check6() {
		if (WIDTH <= 3 || HEIGHT <= 3) {
			return false;
		}
		return WIDTH % 6 == 0 || HEIGHT % 6 == 0;
	}
	
	private static boolean check5() {
		if (WIDTH <= 2 || HEIGHT <= 2) {
			return false;
		}
		if (WIDTH == 3 || HEIGHT == 3) {
			return WIDTH % 10 == 0 || HEIGHT % 10 == 0;
		}
		return WIDTH % 5 == 0 || HEIGHT % 5 == 0;
	}

	private static boolean check4() {
		if (WIDTH <= 2 || HEIGHT <= 2) {
			return false;
		}
		return (WIDTH * HEIGHT) % 4 == 0; 
	}
	
	private static boolean check3() {
		if (WIDTH == 1 || HEIGHT == 1) {
			return false;
		}
		return (WIDTH * HEIGHT) % 3 == 0; 
	}

	private static boolean check2() {
		return (WIDTH * HEIGHT) % 2 == 0;
	}
}
