package com.shag;

import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

/**
 * Created by andrii on 4/11/15.
 */
public class Pancakes
{
    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new FileReader("input.txt"));
        File fout = new File("out.txt");
        FileOutputStream fos = new FileOutputStream(fout);

        BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));

        int testCount = in.nextInt();
        in.nextLine();
        int testNumber = 0;
        for(int i=0;i<testCount;i++) {
            Integer nonEmptyPlates = Integer.valueOf(in.nextLine());
            List<Integer> plates = new ArrayList<Integer>();
            int max=0;
            String[] pls = in.nextLine().split(" ");
            for(int j=0;j<nonEmptyPlates;j++){
                plates.add(Integer.valueOf(pls[j]));
            }

            int steps = recursiveCall(plates,0);


            print(bw, i, steps);



        }
        bw.close();
    }
    private static List<Integer> split(List<Integer> a){
        Integer max = a.get(0);
        List<Integer> arr = new ArrayList<Integer>();
        for(int i=1;i<a.size();i++){
            arr.add(a.get(i));
        }
        arr.add(max/2);
        arr.add(max-max/2);
        return arr;
    }
    private static List<Integer> eat(List<Integer> a){
        List<Integer> arr = new ArrayList<Integer>();
        for(int i=0;i<a.size();i++){
            if(a.get(i)>1){
            arr.add(a.get(i)-1);
            }
        }
        return arr;
    }
    private static int recursiveCall (List<Integer> items, int count){
        Collections.sort(items);
        Collections.reverse(items);
        if(items.isEmpty()){
            return count;
        }
        if(items.get(0)==1){
            return count+1;
        }

        List<Integer> splitted = split(items);

        List<Integer> eated = eat(items);

        int withEatedSteps = recursiveCall(eated,count+1);
        int withSplittedSteps = recursiveCall(splitted, count+1);

        return Math.min(withEatedSteps,withSplittedSteps);
    }
    private static void print(BufferedWriter bw,int testNumber,long result) throws IOException {
        bw.write("Case #"+(testNumber+1)+": "+result);
        bw.newLine();
    }

    public static int log2(int n){
        if(n <= 0) throw new IllegalArgumentException();
        return 31 - Integer.numberOfLeadingZeros(n);
    }

}
