package round1b;

import java.util.*;
public class ProblemA {

	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		
		int T = scan.nextInt();
		scan.nextLine();
		
		int k = 1;
		while (k <= T)
		{
			long A = scan.nextInt();
			int N = scan.nextInt();
			int[] motes = new int[N];
			int minResult = N; //worst case, we just remove them all
			
			for (int i = 0; i < N; i++)
			{
				motes[i] = scan.nextInt();
			}
			Arrays.sort(motes);
			
			if (A > 1) //not the degenerate case
			{
				int nextMote = 0;
				int numberOfAdds = 0;

				//run through trying the cost of different things
				int adds = 0;
				while (nextMote < motes.length && adds < minResult)
				{
					//find cost to get to next mote
					int newAdds = 0; //start at zero to handle first time through, when we might already be big enough
					while(maxInKAdds(A, newAdds) <= motes[nextMote]) newAdds++;
					
					A = maxInKAdds(A, newAdds);
					adds += newAdds;

					//consume
					while(nextMote < motes.length && motes[nextMote] < A)
					{
						A += motes[nextMote];
						nextMote++;
					}
	
					//cost if I stopped now
					int operations = adds + (motes.length - nextMote);
					
					if (operations < minResult)
					{
						minResult = operations;
					}
//					System.err.println("Size: " + A + " Position: " + nextMote);
//					System.err.println(java.util.Arrays.toString(motes));
				}
			}
			
			System.out.printf("Case #%d: %s\n", k, minResult);
			k++;
		}
	}
	
	public static long maxInKAdds(long A, int k)
	{
		int pow2 = 1<<k;
		long result = pow2 * A - (pow2-1);
//		System.err.println("max from " + A + " in " + k + " adds is " + result);
		return result;
	}

}
