package de.jaki.codejam.y2017.r1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class B {

	private static final String PROBLEM = "B";
	private static final String TYPE = "small-attempt0";
	private static final String INPUT = String.format("%s-%s.in", PROBLEM, TYPE);
	private static final String OUTPUT = String.format("%s-%s.out", PROBLEM, TYPE);
	private static final String RES_FORMAT = "Case #%d: %s";

	static class Pack implements Comparable<Pack> {
		final int index;
		final Set<Integer> set;
		final int size;
		boolean used = false;

		public Pack(int index, Set<Integer> set, int size) {
			this.index = index;
			this.set = set;
			this.size = size;
		}

		@Override
		public int compareTo(Pack o) {
			if (size < o.size) return -1;
			if (size > o.size) return 1;
			return 0;
		}
	}

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader(INPUT));
		int ttt = Integer.parseInt(br.readLine());
		StringBuilder sb = new StringBuilder();
		for (int i = 1; i <= ttt; i++) {
			String solution = solve(br);
			String formatted = String.format(RES_FORMAT, i, solution);
			sb.append(formatted);
			sb.append(System.getProperty("line.separator"));
			System.out.println(formatted);
		}
		PrintWriter pw = new PrintWriter(OUTPUT);
		pw.println(sb.toString());
		pw.flush();
		pw.close();
	}

	private static String solve(BufferedReader br) throws IOException {
		String[] in = br.readLine().split(" ");
		int n = Integer.parseInt(in[0]);
		int p = Integer.parseInt(in[1]);

		in = br.readLine().split(" ");
		int[] recept = new int[n];
		for (int i = 0; i < n; i++) {
			recept[i] = Integer.parseInt(in[i]);
		}

		Map<Integer, List<Pack>> map = new TreeMap<>();

		for (int i = 0; i < n; i++) {
			in = br.readLine().split(" ");
			for (int j = 0; j < p; j++) {
				int currG = Integer.parseInt(in[j]);
				int needed = recept[i];

				int k = currG / needed;

				int min = k;
				int max = k;
				Set<Integer> set = new TreeSet<>();
				while (isGood(min - 1, currG, needed)) {
					min--;
					set.add(min);
				}
				while (isGood(max + 1, currG, needed)) {
					max++;
					set.add(max);
				}
				if (isGood(k, currG, needed)) {
					set.add(k);
				}

				Pack pp = new Pack(i, set, currG);

				for (int x : set) {
					put(map, x, pp);
				}

			}
		}

		int result = 0;

		for (List<Pack> list : map.values()) {
			Collections.sort(list);
		}

		outer:
		for (Map.Entry<Integer, List<Pack>> entries : map.entrySet()) {
			while (true) {
				boolean[] have = new boolean[n];
				Pack[] used = new Pack[n];
				for (Pack pp : entries.getValue()) {
					if (pp.used) {
						continue;
					}
					if (have[pp.index]) {
						continue;
					}
					have[pp.index] = true;
					used[pp.index] = pp;
				}
				for (boolean b : have) {
					if (!b) {
						continue outer;
					}
				}
				for (Pack ppp : used) {
					ppp.used = true;
				}
				result++;
			}
		}


		return "" + result;
	}

	private static void put(Map<Integer, List<Pack>> map, int key, Pack pack) {
		List<Pack> packs = map.get(key);
		if (packs == null) {
			packs = new ArrayList<>();
			map.put(key, packs);
		}
		packs.add(pack);
	}

	private static boolean isGood(double k, double currG, double needed) {
		if (k == 0) return false;
		return (0.9 * k * needed <= currG) && (1.1 * k * needed >= currG);
	}
}
