package de.jaki.codejam.y2017.r0;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class D3 {

	private static final String PROBLEM = "D";
	private static final String TYPE = "small-attempt0";
	private static final String INPUT = String.format("%s-%s.in", PROBLEM, TYPE);
	private static final String OUTPUT = String.format("%s-%s.out", PROBLEM, TYPE);
	private static final String RES_FORMAT = "Case #%d: %s";
	private static final String LINE = System.getProperty("line.separator");

	static class Pair {
		int x, y;

		public Pair(int x, int y) {
			this.x = x;
			this.y = y;
		}

		@Override
		public boolean equals(Object o) {
			if (this == o) return true;
			if (o == null || getClass() != o.getClass()) return false;

			Pair pair = (Pair) o;

			if (x != pair.x) return false;
			return y == pair.y;

		}

		@Override
		public int hashCode() {
			int result = x;
			result = 31 * result + y;
			return result;
		}

		@Override
		public String toString() {
			return x + " " + y;
		}
	}


	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader(INPUT));
		int ttt = Integer.parseInt(br.readLine());
		StringBuilder sb = new StringBuilder();
		for (int i = 1; i <= ttt; i++) {
			String solution = solve(br);
			String formatted = String.format(RES_FORMAT, i, solution);
			sb.append(formatted);
			System.out.println(formatted);
		}
		PrintWriter pw = new PrintWriter(OUTPUT);
		pw.print(sb.toString());
		pw.flush();
		pw.close();
	}

	private static String solve(BufferedReader br) throws IOException {
		String[] in = br.readLine().split(" ");
		int n = Integer.parseInt(in[0]);
		int m = Integer.parseInt(in[1]);

		Map<Character, Set<Pair>> map = new HashMap<>();
		map.put('+', new HashSet<>());
		map.put('x', new HashSet<>());
		map.put('o', new HashSet<>());

		for (int i = 0; i < m; i++) {
			in = br.readLine().split(" ");
			char ch = in[0].charAt(0);
			int x = Integer.parseInt(in[1]);
			int y = Integer.parseInt(in[2]);
			map.get(ch).add(new Pair(x, y));
		}
		if (n == 1) {
			if (!map.get('o').isEmpty()) {
				return "2 0" + LINE;
			} else {
				return "2 1" + LINE + "o 1 1" + LINE;
			}
		} else {

			StringBuilder moves = new StringBuilder();
			int sum = n * 3 - 2;
			int movesCount = 0;

			if (!map.get('x').isEmpty()) {
				Pair p = map.get('x').iterator().next();
				map.get('x').clear();
				map.get('o').add(p);
				move(moves, p, 'o');
				movesCount++;
			}
			if (map.get('o').isEmpty()) {
				Pair p = new Pair(1, 1);
				map.get('o').add(p);
				move(moves, p, 'o');
				movesCount++;
			}
			int oCol = map.get('o').iterator().next().y;

			for (int i = 1; i <= n; i++) {
				if (i == oCol) continue;
				Pair p = new Pair(1, i);
				boolean newlyAdded = map.get('+').add(p);
				if (newlyAdded) {
					move(moves, p, '+');
					movesCount++;
				}
			}

			for (int i = 2; i <= n - 1; i++) {
				Pair p = new Pair(n, i);
				boolean newlyAdded = map.get('+').add(p);
				if (newlyAdded) {
					move(moves, p, '+');
					movesCount++;
				}
			}

			int j = (oCol == n) ? 2 : 1;
			for (int i = 2; i <= n; i++) {
				if (j == oCol) j++;
				if (j > n) j = 1;
				Pair p = new Pair(i, j++);
				boolean newlyAdded = map.get('x').add(p);
				if (newlyAdded) {
					move(moves, p, 'x');
					movesCount++;
				}
			}

			return sum + " " + movesCount + LINE + moves;
		}
	}

	private static void move(StringBuilder moves, Pair p, char ch) {
		moves.append(ch);
		moves.append(' ');
		moves.append(p.x);
		moves.append(' ');
		moves.append(p.y);
		moves.append(LINE);
	}


}
