package at.jaki.round2.D;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class D {

    //private static final String INPUT = "D-large.in";
    private static final String INPUT = "D-small-attempt0.in";
    //private static final String INPUT = "D-test.in";
    //private static final String INPUT = "D-large.out";
    private static final String OUTPUT = "D-small-attempt0.out";
    //private static final String OUTPUT = "D-test.out";

    private static class Trie {

        Map<Character, Trie> map = new HashMap<Character, Trie>();

        public void add(String string) {
            char ch = string.charAt(0);
            if (!map.containsKey(ch)) {
                map.put(ch, new Trie());
            }
            if (string.length() > 1) {
                map.get(ch).add(string.substring(1));
            }
        }

        public int size() {
            int total = 0;
            for (Trie t : map.values()) {
                total += t.size();
            }
            return total + map.size();
        }

        @Override
        public String toString() {
            return map.toString();
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(INPUT));
        PrintWriter pw = new PrintWriter(OUTPUT);
        int totalTests = Integer.parseInt(br.readLine());
        for (int testNo = 1; testNo <= totalTests; testNo++) {
            String[] temp = br.readLine().split(" ");
            int n = Integer.parseInt(temp[0]);
            int m = Integer.parseInt(temp[1]);
            String[] strings = new String[n];
            for (int i = 0; i < n; i++) {
                strings[i] = br.readLine();
            }

            int[] alloc = new int[n];
            int max = 0;
            int cMax = 0;
            while (true) {
                int x = test(strings, alloc, m);
                if (x > max) {
                    max = x;
                    cMax = 1;
                } else if (x == max) {
                    cMax++;
                }
                inc(alloc, m);
                if (alloc[0] == m) {
                    break;
                }
            }

            max += m;
            pw.print("Case #" + testNo + ": ");
            pw.println(max + " " + cMax);
            System.out.println(max + " " + cMax);
        }

        pw.flush();
        pw.close();

    }

    private static int test(String[] strings, int[] alloc, int m) {
        if (!isCorrect(alloc, m)) {
            return 0;
        }
        Trie[] tries = new Trie[m];
        for (int i = 0; i < m; i++) {
            tries[i] = new Trie();
        }
        for (int i = 0; i < alloc.length; i++) {
            tries[alloc[i]].add(strings[i]);
        }
        int total = 0;
        for (Trie t : tries) {
            total += t.size();
        }
        //System.out.println(Arrays.toString(strings));
        //System.out.println(Arrays.toString(alloc));
        //System.out.println(Arrays.toString(tries));
        return total;
    }

    private static boolean isCorrect(int[] alloc, int m) {
        Set<Integer> set = new HashSet<Integer>();
        for (int x : alloc) set.add(x);
        return set.size() == m;
    }

    private static void inc(int[] alloc, int m) {
        alloc[alloc.length - 1]++;
        int i = alloc.length - 1;
        while (i > 0) {
            if (alloc[i] == m) {
                alloc[i] = 0;
                if (i >= 1) alloc[i - 1]++;
            }
            i--;
        }

    }
}
