package at.jaki.round2.A;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;

public class A {

    private static final String INPUT = "A-large.in";
    //private static final String INPUT = "A-small-attempt1.in";
    //private static final String INPUT = "A-test.in";
    private static final String OUTPUT = "A-large.out";
    //private static final String OUTPUT = "A-small-attempt1.out";
    //private static final String OUTPUT = "A-test.out";

    private static class Elem implements Comparable<Elem> {
        private int val;
        private int id;

        private Elem(int val, int id) {
            this.val = val;
            this.id = id;
        }

        @Override
        public int compareTo(Elem elem) {
            if (val < elem.val) return -1;
            if (val > elem.val) return 1;
            if (id < elem.id) return -1;
            if (id > elem.id) return 1;
            return 0;
        }

        @Override
        public String toString() {
            return "" + val;
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader(INPUT));
        PrintWriter pw = new PrintWriter(OUTPUT);
        int totalTests = Integer.parseInt(br.readLine());
        for (int testNo = 1; testNo <= totalTests; testNo++) {
            String[] temp = br.readLine().split(" ");
            int n = Integer.parseInt(temp[0]);
            int s = Integer.parseInt(temp[1]);
            temp = br.readLine().split(" ");
            //System.out.println(n + " " + s);
            //Arrays.sort(temp);
            //System.out.println(Arrays.toString(temp));
            NavigableSet<Elem> elems = new TreeSet<Elem>();
            List<Elem> list = new ArrayList<Elem>(n);
            for (int i = 0; i < n; i++) {
                int x = Integer.parseInt(temp[i]);
                Elem el = new Elem(x, i);
                elems.add(el);
                list.add(el);
            }
            int total = 0;
            Set<Integer> used = new HashSet<Integer>();
            for (int i = 0; i < n; i++) {
                if (used.contains(i)) continue;
                Elem curr = list.get(i);
                elems.remove(curr);
                Elem pair = elems.floor(new Elem(s - curr.val, n + 1));
                //System.out.println(curr + " + " + pair);
                if (pair != null) {
                    used.add(pair.id);
                    elems.remove(pair);
                }
                used.add(curr.id);
                total++;
            }

            System.out.println(total);
            pw.print("Case #" + testNo + ": ");
            pw.println(total);
        }

        pw.flush();
        pw.close();

    }
}
