package at.jaki.codejam.qr2012.A;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class A {
	
	private static final String TEMPLATE = "Case #%d: %s";
	
	private static final String IN = "A-small-attempt0.in";
	private static final String OUT = "A-small-attempt0.out";
	
	private static Scanner sc;
	private static PrintWriter pw;
	
	public static void main(String[] args) throws FileNotFoundException {
		sc = new Scanner(new File(IN));
		pw = new PrintWriter(new File(OUT));
		int tests = sc.nextInt();
		sc.nextLine();
		
		init();
		
		for (int i=1; i<=tests; i++){
			resolve(i);
		}
		pw.flush();
		pw.close();
	}

	private static final Map<Character,Character> map = new TreeMap<Character, Character>();
	
	
	private static final void init(){
		learn("ejp mysljylc kd kxveddknmc re jsicpdrysi","our language is impossible to understand");
		learn("rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd","there are twenty six factorial possibilities");
		learn("de kr kd eoya kw aej tysr re ujdr lkgc jv","so it is okay if you want to just give up");
		
		map.put('Z', 'q');
		map.put('Q', 'z');
		
		System.out.println(map);
		System.out.println(map.size());
		
		System.out.println(get("de kr kd eoya kw aej tysr re ujdr lkgc jv"));
		System.out.println("----------------------------");
	}
	
	private static void resolve(int i) {
		String line = sc.nextLine();
		String res = get(line);
		System.out.println(res);
		pw.println(String.format(TEMPLATE, i,res));
	}
	
	private static void learn(String coded, String good){
		coded = coded.toUpperCase();
		for (int i=0; i<coded.length(); i++){
			Character oldCh = map.put(coded.charAt(i), good.charAt(i));
			if (oldCh !=null && oldCh.charValue() != good.charAt(i)){
				throw new IllegalStateException("multiple value for char: "+coded.charAt(i));
			}
		}
	}
	
	private static String get(String coded){
		coded = coded.toUpperCase();
		StringBuilder sb = new StringBuilder();
		for (char ch : coded.toCharArray()){
			if (map.containsKey(ch)){
				sb.append(map.get(ch));
			} else {
				sb.append(ch);
				System.out.println("find "+ch);
			}
		}
		return sb.toString();
	}
}
