package de.jaki.codejam.y2017.r1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class A {

	private static final String PROBLEM = "A";
	private static final String TYPE = "large";
	private static final String INPUT = String.format("%s-%s.in", PROBLEM, TYPE);
	private static final String OUTPUT = String.format("%s-%s.out", PROBLEM, TYPE);
	private static final String RES_FORMAT = "Case #%d: %s";
	private static final String LINE = System.getProperty("line.separator");

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader(INPUT));
		int ttt = Integer.parseInt(br.readLine());
		StringBuilder sb = new StringBuilder();
		for (int i = 1; i <= ttt; i++) {
			String solution = solve(br);
			String formatted = String.format(RES_FORMAT, i, solution);
			sb.append(formatted);
			System.out.print(formatted);
		}
		PrintWriter pw = new PrintWriter(OUTPUT);
		pw.println(sb.toString());
		pw.flush();
		pw.close();
	}

	private static String solve(BufferedReader br) throws IOException {
		String[] in = br.readLine().split(" ");
		int n = Integer.parseInt(in[0]);
		int m = Integer.parseInt(in[1]);
		String[] lines = new String[n];
		String[] solution = new String[n];
		boolean[] hasLetter = new boolean[n];
		for (int i = 0; i < n; i++) {
			lines[i] = br.readLine();
			for (char ch : lines[i].toCharArray()) {
				if (ch != '?') {
					hasLetter[i] = true;
					break;
				}
			}
		}

		for (int i = 0; i < n; i++) {
			if (hasLetter[i]) {
				char first = '?';
				for (int j = 0; j < m; j++) {
					if (lines[i].charAt(j) != '?') {
						first = lines[i].charAt(j);
						break;
					}
				}
				char current = first;
				StringBuilder ss = new StringBuilder();
				for (int j = 0; j < m; j++) {
					if (lines[i].charAt(j) != '?') {
						current = lines[i].charAt(j);
					}
					ss.append(current);
				}
				solution[i] = ss.toString();
			}
		}

		String firstLine = null;
		for (int i = 0; i < n; i++) {
			if (hasLetter[i]) {
				firstLine = solution[i];
				break;
			}
		}

		String currentLine = firstLine;
		for (int i = 0; i < n; i++) {
			if (solution[i] != null) {
				currentLine = solution[i];
			}
			solution[i] = currentLine;
		}

		StringBuilder sb = new StringBuilder();
		sb.append(LINE);
		for (String s : solution) {
			sb.append(s);
			sb.append(LINE);
		}

		return sb.toString();
	}
}
