package a;

import java.io.*;
import java.util.*;

public class Main {

    public static void main(String[] args) throws Exception {
        File inFile = new File("d:\\tmp\\input.txt");
        File outFile = new File("d:\\tmp\\output.txt");

        BufferedReader in = new BufferedReader(new FileReader(inFile));
        PrintWriter out = new PrintWriter(outFile);
        String line = in.readLine();
        int N = Integer.parseInt(line);
        for (int caseNo = 1; caseNo <= N; caseNo++) {
            String caseString = in.readLine();
            long minSeconds = getMinimumSeconds(caseString);
            out.println("Case #" + caseNo + ": " + minSeconds);
        }
        out.flush();
        out.close();
        in.close();
    }

    private static long getMinimumSeconds(String symbolString) {
        Map<Character, Integer> symbolMap = new HashMap<Character, Integer>();
        int base = 1;
        String resultString = "";
        for (char symbol : symbolString.toCharArray()) {
            int value = 0;
            if (symbolMap.get(symbol) != null) {
                value = symbolMap.get(symbol);
            } else if (symbolMap.size() == 1) {
                symbolMap.put(symbol, value);
            } else {
                value = base++;
                symbolMap.put(symbol, value);
            }
            resultString += value;
        }
        long result = 0;
        for (int i = resultString.length() - 1; i >= 0; i--) {
            result += Math.pow(base, i) * Integer.parseInt(resultString.charAt(resultString.length() - i - 1) + "");
        }
        return result;
    }
}
