import static java.lang.Long.parseLong;
import static java.lang.System.exit;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;


public class C {

	static BufferedReader in;
	static PrintWriter out;
	static StringTokenizer tok;
	static int test;

	static ArrayList<Long> fsArray = new ArrayList<Long>();
	static void generateSFSnumbers() throws Exception {
		long start = 1;
		long end = (long) Math.pow(10,14);
		
		for(long i = start; i <= end; i++) {
			if ( isPalindrome( Long.toString(i).toCharArray() ) ) {
				long fsnum = i * i;
				if (fsnum > end)
					break;
				
				if ( isPalindrome( Long.toString(fsnum).toCharArray() ) ) {
					fsArray.add(fsnum);
				}
			}
		}
	}
	public static boolean isPalindrome(char[] word){
	    int i1 = 0;
	    int i2 = word.length - 1;
	    while (i2 > i1) {
	        if (word[i1] != word[i2]) {
	            return false;
	        }
	        ++i1;
	        --i2;
	    }
	    return true;
	}
	static void solve() throws Exception {

		printCase();
		long low = nextLong();
		long high = nextLong();
		
		int cnt = 0;
		int lowerIndex = Collections.binarySearch(fsArray, low);
		int higherIndex = Collections.binarySearch(fsArray, high);
		if (lowerIndex < 0)
			lowerIndex = ((-1) * lowerIndex) - 1;
		if (higherIndex < 0)
			higherIndex = ((-1) * higherIndex) - 1;
		else 
			higherIndex++;
		cnt = higherIndex - lowerIndex;
//		for (long i:fsArray ) 
//		{
//			if ( i >= low && i <= high)
//				cnt++;
//		}
		out.print(cnt);
		out.println();
		
	}
	static long nextLong() throws IOException {
		return parseLong(next());
	}

	static void printCase() {
		out.print("Case #" + test + ": ");
	}

	static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			in = new BufferedReader(new InputStreamReader(new FileInputStream(args.length > 0 ? args[0] : (C.class.getName() + ".in"))));
			out = new PrintWriter(new OutputStreamWriter(System.out));
			
			generateSFSnumbers();
			long tests = nextLong();
			for (test = 1; test <= tests; test++) {
				solve();
			}
			in.close();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			exit(1);
		}
	}

}
