/**
 * 
 */


import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.BitSet;
import java.util.StringTokenizer;
import static java.lang.Integer.parseInt;
import static java.lang.System.exit;

/**
 * @author audumbar_chormale
 *
 */
public class A {

	
	static BufferedReader in;
	static PrintWriter out;
	static StringTokenizer tok;
	static int test;
	static BitSet[] Xrows = new BitSet[4];
	static BitSet[] Xcols = new BitSet[4];
	static BitSet[] Orows = new BitSet[4];
	static BitSet[] Ocols = new BitSet[4];
	

	static int n = 4, m = 4;
	static boolean isEmptyCell;
	
	static void solve() throws Exception {

		isEmptyCell = false;
		for (int i=0; i<n; i++) {
			Xrows[i].clear();
			Xcols[i].clear();
			Orows[i].clear();
			Ocols[i].clear();
		}
		printCase();
		for (int i = 0; i < n; i++) 
		{
			String s = in.readLine();
			for (int j = 0; j < m; j++) 
			{
				switch (s.charAt(j)) 
				{
					case 'X':
						Xrows[i].set(j);
						Xcols[j].set(i);
						break;
					case 'O':
						Orows[i].set(j);
						Ocols[j].set(i);
						break;
					case '.':
						isEmptyCell = true;
						break;
					case 'T':
						Xrows[i].set(j);
						Xcols[j].set(i);
						Orows[i].set(j);
						Ocols[j].set(i);
						break;					
				}
				if ( i == n-1) {

					//columns
					if (Xcols[j].cardinality() == n) {
						out.print("X won");
						out.println();
						return;
					}

					if (Ocols[j].cardinality() == n) {
						out.print("O won");
						out.println();
						return;
					}
					//diagonals
					if ( j == 0 ) {
						if ( Xrows[0].get(3) && Xrows[1].get(2) && Xrows[2].get(1) && Xrows[3].get(0) ) {
							out.print("X won");
							out.println();
							return;							
						}
						if ( Orows[0].get(3) && Orows[1].get(2) && Orows[2].get(1) && Orows[3].get(0) ) {
							out.print("O won");
							out.println();
							return;							
						}
					}

					if ( j == m-1 ) {
						if ( Xrows[0].get(0) && Xrows[1].get(1) && Xrows[2].get(2) && Xrows[3].get(3) ) {
							out.print("X won");
							out.println();
							return;							
						}
						if ( Orows[0].get(0) && Orows[1].get(1) && Orows[2].get(2) && Orows[3].get(3) ) {
							out.print("O won");
							out.println();
							return;							
						}
					}
				}
			}
			//rows
			if (Xrows[i].cardinality() == m) {
				out.print("X won");
				out.println();
				return;
			}

			if (Orows[i].cardinality() == m) {
				out.print("O won");
				out.println();
				return;
			}
		}
		if (isEmptyCell) {
			out.print("Game has not completed");
		} else {
			out.print("Draw");
		}
		out.println();
	}

	static int nextInt() throws IOException {
		return parseInt(next());
	}

	static void printCase() {
		out.print("Case #" + test + ": ");
	}

	static String next() throws IOException {
		while (tok == null || !tok.hasMoreTokens()) {
			tok = new StringTokenizer(in.readLine());
		}
		return tok.nextToken();
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			in = new BufferedReader(new InputStreamReader(new FileInputStream(args.length > 0 ? args[0] : (A.class.getName() + ".in"))));
			out = new PrintWriter(new OutputStreamWriter(new FileOutputStream((A.class.getName() + ".out"))));
			for (int i=0; i<n; i++) {
				Xrows[i] = new BitSet(4);
				Xcols[i] = new BitSet(4);
				Orows[i] = new BitSet(4);
				Ocols[i] = new BitSet(4);
			}
			int tests = nextInt();
			for (test = 1; test <= tests; test++) {
				solve();
				
				while (test < tests && in.readLine().length() > 0);
			}
			in.close();
			out.close();
		} catch (Throwable e) {
			e.printStackTrace();
			exit(1);
		}

	}

}
