package qual2010.prob1;


import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Main {
	private final static String inputFileName = "A-small-attempt0.in";

	private final static String outputFileName = "output.txt";
	static List<Snapper> snapperList = new ArrayList<Snapper>();
	public static void main(String[] args) throws Exception {
		BufferedReader input = new BufferedReader(new FileReader(inputFileName));
		FileWriter output = new FileWriter(outputFileName);
		int numCases = Integer.parseInt(input.readLine().trim());
		Main main = new Main();
		for(int c = 1; c <= numCases; c++)
		{
			//load data
			String nAnBString = input.readLine().trim();
			int spaceIndex = nAnBString.indexOf(" ");
			int numSnappers = Integer.parseInt(nAnBString.substring(0, spaceIndex).trim());
			int numSnaps = Integer.parseInt(nAnBString.substring(spaceIndex).trim());
			main.createSnapperLink(numSnappers);
			for(int curSnap = 0; curSnap < numSnaps; curSnap++)
			{
				main.processSnap();
			}
			String resultText = "OFF";
			if(numSnappers > 0)
			{
				Snapper lastSnapper = snapperList.get(numSnappers - 1);
				if(lastSnapper.hasPower && lastSnapper.toggle )
				{
					resultText = "ON";
				}
			}
			
			output.write("Case #"+ c +": "+ resultText + "\n");
			
		}
		output.flush();
		output.close();
		input.close();
	}
	
	void createSnapperLink(int numSnappers)
	{
		snapperList.clear();
		for(int i = 0; i < numSnappers; i++)
		{
			if(i==0)
			{
				snapperList.add(new Snapper(true));
			}
			else
			{
				snapperList.add(new Snapper());
			}
		}
	}
	
	void processSnap()
	{
		for(int i =0; i < snapperList.size(); i++)
		{
			Snapper prevSnapper = null;
			if(i > 0)
			{
				prevSnapper = snapperList.get(i-1);
			}
			Snapper curSnapper = snapperList.get(i);
			if(curSnapper.hasPower)
			{
				if(curSnapper.toggle)
				{
					curSnapper.toggle = false;
				}
				else
				{
					curSnapper.toggle = true;
				}
			}
			if(prevSnapper ==null || (prevSnapper != null && prevSnapper.hasPower && prevSnapper.toggle))
			{
				curSnapper.hasPower = true;
			}
			else
			{
				curSnapper.hasPower = false;
			}
		}
	}
	
	class Snapper{
		public Snapper(boolean hasPower) {
			this.hasPower = hasPower;
		}
		public Snapper() {
		}
		boolean hasPower;
		boolean toggle;
	}

}
