package qualifierround;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.SortedMap;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

import com.sun.corba.se.spi.orb.StringPair;

public class Problem1 {

	private final static String inputFileName = "B-large.in";

	private final static String outputFileName = "output.txt";
	private final static int DEPARTA = 5;
	private final static int DEPARTB = 4;
	private final static int ARRIVEA = 3;
	private final static int ARRIVEB = 2;
	private final static int ADDTRAINA =1;
	private final static int ADDTRAINB = 0;
	private static class TimeCompare implements Comparator{
		public int compare(Object arg0, Object arg1) {
			String tempOne = (String)arg0;
			StringTokenizer tokenizer = new StringTokenizer(tempOne);
			String timeA = tokenizer.nextToken().replaceAll(":", "");
			Integer eventA = new Integer(tokenizer.nextToken());
			String tempTwo = (String)arg1;
			StringTokenizer tokenizer2 = new StringTokenizer(tempTwo);
			String timeB = tokenizer2.nextToken().replaceAll(":", "");
			Integer eventB = new Integer(tokenizer2.nextToken());
			Integer timeAInt = new Integer(timeA);
			Integer timeBInt = new Integer(timeB);
			
			
			if(timeAInt.compareTo(timeBInt) != 0)
				return timeAInt.compareTo(timeBInt);
			else 
			{
				return eventA.compareTo(eventB);
			}
		}
	}
	public static void main(String[] args) throws Exception {
		BufferedReader input = new BufferedReader(new FileReader(inputFileName));
		FileWriter output = new FileWriter(outputFileName);
		int numCases = Integer.parseInt(input.readLine().trim());
		for(int c = 1; c <= numCases; c++)
		{
			//load data
			int turnAroundTime = Integer.parseInt(input.readLine().trim());
			String nAnBString = input.readLine().trim();
			int spaceIndex = nAnBString.indexOf(" ");
			int nA = Integer.parseInt(nAnBString.substring(0, spaceIndex).trim());
			int nB = Integer.parseInt(nAnBString.substring(spaceIndex).trim());
			List eventList = new ArrayList();
			for(int i = 0; i < nA; i++)
			{
				String currArrDep = input.readLine();
				String depTime = currArrDep.substring(0, 5).trim();
				String arriveTime = currArrDep.substring(5).trim();
				System.out.println("Dep A = "+ depTime + " Arrive B = "+ arriveTime);
				eventList.add(depTime+ " " + DEPARTA);
				eventList.add(arriveTime+ " " + ARRIVEB);
			}

			for(int i = 0; i< nB; i++)
			{
				String currArrDep = input.readLine();
				String depTime = currArrDep.substring(0, 5).trim();
				String arriveTime = currArrDep.substring(5).trim();
				System.out.println("Dep B = "+ depTime + " Arrive A = "+ arriveTime);
				eventList.add(depTime+ " " + DEPARTB);
				eventList.add(arriveTime+ " " + ARRIVEA);
			}
			// 0 trains at both locations
			int trainsA = 0;
			int trainsB = 0;
			
			//needed start trains
			int startTrainsA = 0;
			int startTrainsB = 0;
			
			//sort List
			Collections.sort(eventList, new TimeCompare());
			
			//determine next Event
			
			while(eventList.size() > 0)
			{
				String eventStr = (String)eventList.remove(0);;
				StringTokenizer tok = new StringTokenizer(eventStr);
				String eventTime = tok.nextToken();
				int eventType = Integer.parseInt(tok.nextToken());
				//if add trains add trains to location
				if(eventType == ADDTRAINA)
					trainsA++;
				else if(eventType == ADDTRAINB)
					trainsB++;
//				if departure
				else if(eventType == DEPARTA)
				{
//					if train exists depart train reduce total trains at locaion
					
					//else add a train to the start total at that locaion
					if(trainsA == 0)
						startTrainsA++;
					else
						trainsA--;
				}
				else if(eventType == DEPARTB)
				{
					if(trainsB ==0)
						startTrainsB++;
					else
						trainsB--;
				}	
				// if arrival
				//compute turnaround and add an ADDTRAIN event to queue
				else if(eventType == ARRIVEA)
				{
					String addTime = addToTime(eventTime, turnAroundTime);
					eventList.add(addTime + " " + ADDTRAINA);
					Collections.sort(eventList, new TimeCompare());
				}
				else if(eventType == ARRIVEB)
				{
					String addTime = addToTime(eventTime, turnAroundTime);
					eventList.add(addTime + " " + ADDTRAINB);
					Collections.sort(eventList, new TimeCompare());
				}
				
			
			
			
			//end if
			//end if
			
				
					
					//remove last event
			}
			
			//output
			output.write("Case #" + c + ": " + startTrainsA + " " + startTrainsB + "\n");
		}
		output.flush();
		output.close();
		input.close();

	}
	
	public static String addToTime(String time, int numMins)
	{
		int colonIndex = time.indexOf(":");
		int hours = Integer.parseInt(time.substring(0,colonIndex ));
		int mins = Integer.parseInt(time.substring(colonIndex+1));
		System.out.println("hours = " + hours + " Mins = " + mins);
		mins += numMins;
		
		while(mins >= 60)
		{
			mins = mins - 60;
			hours++;
		}
		
		String hoursStr = Integer.toString(hours);
		if(hours < 10)
			hoursStr = "0"+hoursStr;
		String minsString = Integer.toString(mins);
		if(mins < 10)
			minsString = "0"+minsString;
		
		return hoursStr + ":" + minsString;
	}

}
