package qual2010.prob1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class ThemePark {
	private final static String inputFileName = "C-small-attempt0.in";

	private final static String outputFileName = "output.txt";
	
	Queue<Long> groups;
	public ThemePark() {
		groups = new LinkedList<Long>();
	}
	public static void main(String[] args) throws Exception{
		BufferedReader input = new BufferedReader(new FileReader(inputFileName));
		FileWriter output = new FileWriter(outputFileName);
		int numCases = Integer.parseInt(input.readLine().trim());
		
		
		for(int c = 1; c <= numCases; c++)
		{
			ThemePark park = new ThemePark();
			StringTokenizer firstLine = new StringTokenizer(input.readLine().trim());
			StringTokenizer secondLine = new StringTokenizer(input.readLine().trim());
			long coasterRuns = Long.parseLong(firstLine.nextToken());
			long coasterSize = Long.parseLong(firstLine.nextToken());
			long numGroups = Long.parseLong(firstLine.nextToken());
			long totalParkPop = 0;
			
			for(long i = 0; i < numGroups; i++)
			{
				long groupSize = Long.parseLong(secondLine.nextToken());
				park.groups.add(groupSize);
				totalParkPop += groupSize;
			}
			
			long result = 0;
			
			if(coasterSize >= totalParkPop)
			{
				result = totalParkPop * coasterRuns;
			}
			else
			{
				for(long i = 0; i < coasterRuns; i++)
				{
					result += park.runCoaster(coasterSize);
				}
			}
			output.write("Case #"+ c +": "+result +"\n");
		}
		output.flush();
		output.close();
		input.close();
	}
	
	long runCoaster(long coasterSize)
	{
		long result = 0;
		long seatsRemaining = coasterSize;
		while(seatsRemaining > 0)
		{
			Long groupSize = groups.peek();
			if((seatsRemaining - groupSize) < 0)
			{
				break;
			}
			seatsRemaining = seatsRemaining - groupSize;
			result += groupSize;
			groups.add(groups.remove());
			
		}
		
		return result;
	}
	
	
}
