package qualifierround;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class ProblemSearch {

	private final static String inputFileName = "A-large.in";

	private final static String outputFileName = "output.txt";

	public static void main(String[] args) throws Exception {
		BufferedReader input = new BufferedReader(new FileReader(inputFileName));
		FileWriter output = new FileWriter(outputFileName);
		int numCases = Integer.parseInt(input.readLine().trim());
		
		
		for (int c = 1; c <= numCases; c++) {
			List engineNameList = new ArrayList();
			int numEngines = Integer.parseInt(input.readLine().trim());
			for (int i = 0; i < numEngines; i++) {
				engineNameList.add(input.readLine().trim());
			}
			int numQueries = Integer.parseInt(input.readLine().trim());
			List queryText = new ArrayList();
			for (int i = 0; i < numQueries; i++) {
				queryText.add(input.readLine().trim());
			}
			int totalSwitches = -1;
//			 loop until all queries processed
			while(queryText.size()> 0)
			{
				processQueries(engineNameList,queryText);
				totalSwitches ++;
			}
			
			if(totalSwitches < 0)
				totalSwitches = 0;
			
			// output
			output.write("Case #" + c + ": " + totalSwitches + "\n");
			System.out.println("Case Done");
		}
		// loop until end of file
		input.close();
		output.flush();
		output.close();

	}
	public static void processQueries(List engineNameList, List queryText)
	{
//		 determine number of queries until switch
		String curEngine = "";
		String bestEngine = "";
		int bestNumProcessed = 0;
		Iterator engineIt = engineNameList.iterator();
		while (engineIt.hasNext()) {
			curEngine = (String) engineIt.next();
			Iterator queryIt = queryText.iterator();
			int numProcessedQueries = 0;
			System.out.println("First Query in Que = "+ queryText.get(0));
			while (queryIt.hasNext()) {
				String curQuery = (String) queryIt.next();
				if (!curQuery.equals(curEngine))
					numProcessedQueries++;
				else {
					if (numProcessedQueries > bestNumProcessed) {
						bestNumProcessed = numProcessedQueries;
						bestEngine = curEngine;
						System.out.println(curEngine + " = " + bestNumProcessed);
					}
					break;
				}
			}
			if(numProcessedQueries == queryText.size())
			{
				bestNumProcessed = numProcessedQueries;
				bestEngine = curEngine;
				System.out.println(curEngine + " = " + bestNumProcessed);
				break;
			}
			
		}
		for (int i = 0; i < bestNumProcessed; i++)
			queryText.remove(0);
		System.out.println("Best Engine = " + bestEngine + " " + bestNumProcessed);
	}

}
