import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;


public class TrainTimeTable {

	static class TrenDisponible implements Comparable<TrenDisponible>
	{
		int hora;
		public TrenDisponible(int h)
		{
			hora = h;
		}
		
		@Override
		public int compareTo(TrenDisponible o) {
			return hora-o.hora;
		}
	}
	
	static class Tren implements Comparable<Tren>
	{
		int horaSalida;
		int horaLlegada;
		int estacion;
		public Tren(String hs, String ms, String hl, String ml, int e)
		{
			horaSalida = Integer.parseInt(hs)*60+Integer.parseInt(ms);
			horaLlegada = Integer.parseInt(hl)*60+Integer.parseInt(ml);
			estacion = e;
		}
		@Override
		public int compareTo(Tren o) 
		{
			if(horaSalida<o.horaSalida) return -1;
			else if(horaSalida==o.horaSalida)
			{
				return horaLlegada-o.horaLlegada;
			}
			else return 1;
		}
		
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File("train.in"));
		ArrayList<TrenDisponible> D[] = (ArrayList<TrenDisponible>[])new ArrayList[2];
		ArrayList<Tren> trenes;
		int t,nc=1;
		t = in.nextInt();
		while(t-->0)
		{
			int r[] = new int[2];
			r[0] = r[1] = 0;
			int T = in.nextInt();
			int NA = in.nextInt();
			int NB = in.nextInt();
			trenes = new ArrayList<Tren>();
			D[0] = new ArrayList<TrenDisponible>();
			D[1] = new ArrayList<TrenDisponible>();
			for(int i=0;i<NA;i++)
			{
				String hs[] = in.next().split(":");
				String hl[] = in.next().split(":");
				trenes.add(new Tren(hs[0],hs[1],hl[0],hl[1],0));
			}
			for(int i=0;i<NB;i++)
			{
				String hs[] = in.next().split(":");
				String hl[] = in.next().split(":");
				trenes.add(new Tren(hs[0],hs[1],hl[0],hl[1],1));
			}
			while(trenes.size()>0)
			{
				Collections.sort(trenes);
				Tren tren = trenes.get(0);
				trenes.remove(0);
				Collections.sort(D[tren.estacion]);
				if(D[tren.estacion].size()>0&&D[tren.estacion].get(0).hora<=tren.horaSalida)
					D[tren.estacion].remove(0);
				else
					r[tren.estacion]++;
				D[(tren.estacion+1)%2].add(new TrenDisponible(tren.horaLlegada+T));
			}
			System.out.println("Case #"+(nc++)+": "+r[0]+" "+r[1]);
		}
	}

}
