import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class BotTrust {
	private static final boolean DEBUG = false;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("bottrust_example.in"));
		//System.setIn(new FileInputStream("A-small-attempt0.in"));
		System.setIn(new FileInputStream("A-large.in"));
		if(!DEBUG) System.setOut(new PrintStream("bottrust_large.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int i = 0; i < numTestCases; i++) {
			List<Integer> orangeButtons = new ArrayList<Integer>();
			List<Integer> blueButtons = new ArrayList<Integer>();
			List<String> buttonPressOrder = new ArrayList<String>();

			int numButtons = sc.nextInt();
			for(int j = 0; j < numButtons; j++) {
				String botColor = sc.next();
				int buttonPos = sc.nextInt();
				buttonPressOrder.add(botColor);

				if(botColor.equals("O")) {
					orangeButtons.add(buttonPos);
				} else {
					blueButtons.add(buttonPos);
				}
			}
			
			long numSeconds = 0;
			int buttonIndex = 0;
			int orangeIndex = 0, blueIndex = 0;
			int orangePos = 1, bluePos = 1;

			while(buttonIndex < buttonPressOrder.size()) {
				numSeconds++;
				
				if(buttonPressOrder.get(buttonIndex).equals("O")) {
					if(orangeIndex < orangeButtons.size()) {
						int nextOrangeButton = orangeButtons.get(orangeIndex);
						if(nextOrangeButton == orangePos) {
							//Press the button, skipping one turn
							buttonIndex++;
							orangeIndex++;
						} else if(nextOrangeButton > orangePos) {
							orangePos++;
						} else {
							orangePos--;
						}
					}

					if(blueIndex < blueButtons.size()) {
						int nextBlueButton = blueButtons.get(blueIndex);
						if(nextBlueButton == bluePos) {
							//Wait
						} else if(nextBlueButton > bluePos) {
							bluePos++;
						} else {
							bluePos--;
						}
					}
				} else {
					if(orangeIndex < orangeButtons.size()) {
						int nextOrangeButton = orangeButtons.get(orangeIndex);
						if(nextOrangeButton == orangePos) {
							//Wait
						} else if(nextOrangeButton > orangePos) {
							orangePos++;
						} else {
							orangePos--;
						}
					}

					if(blueIndex < blueButtons.size()) {
						int nextBlueButton = blueButtons.get(blueIndex);
						if(nextBlueButton == bluePos) {
							//Press the button, skipping one turn
							buttonIndex++;
							blueIndex++;
						} else if(nextBlueButton > bluePos) {
							bluePos++;
						} else {
							bluePos--;
						}
					}
				}
			}

			System.out.println("Case #" + (i + 1) + ": " + numSeconds);
		}


		if(DEBUG) System.out.println("Total time: " + (float)((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}
