import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class RPI {
	private static final boolean DEBUG = false;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("rpi_example.in"));
		System.setIn(new FileInputStream("A-small-attempt0.in"));
		//System.setIn(new FileInputStream("A-large.in"));
		if(!DEBUG) System.setOut(new PrintStream("rpi_small.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int caseNum = 0; caseNum < numTestCases; caseNum++) {
			int numTeams = sc.nextInt();

			String[] input = new String[numTeams];

			double[] WP = new double[numTeams];
			for(int i = 0; i < numTeams; i++) {
				int numWins = 0, numLosses = 0;

				String line = sc.next();
				input[i] = line;
				for(int j = 0; j < line.length(); j++) {
					if(line.charAt(j) == '1') {
						numWins++;
					} else if(line.charAt(j) == '0') {
						numLosses++;
					}
				}

				
				WP[i] = numWins / (double)(numWins + numLosses);
			}

			double[] OWP = new double[numTeams];
			for(int thisTeam = 0; thisTeam < numTeams; thisTeam++) {
				double avgWP = 0;
				int numOpponents = 0;
				outer:
				for(int otherTeam = 0; otherTeam < numTeams; otherTeam++) {
					if(thisTeam == otherTeam) {
						continue;
					}

					int numWins = 0, numLosses = 0;
					String line = input[otherTeam];
					for(int k = 0; k < line.length(); k++) {
						if(k == thisTeam) {
							if(line.charAt(k) == '.') {
								continue outer;
							}
							continue;
						}
						
						if(line.charAt(k) == '1') {
							numWins++;
						} else if(line.charAt(k) == '0') {
							numLosses++;
						}
					}

					numOpponents++;
					double otherWP = numWins / (double)(numWins + numLosses);
					avgWP += otherWP;
				}
				avgWP /= numOpponents;
				OWP[thisTeam] = avgWP;
			}
			
			double[] OOWP = new double[numTeams];
			for(int thisTeam = 0; thisTeam < numTeams; thisTeam++) {
				double avgOWP = 0;
				int numOpponents = 0;

				for(int otherTeam = 0; otherTeam < numTeams; otherTeam++) {
					if(input[thisTeam].charAt(otherTeam) != '.') {
						numOpponents++;
						avgOWP += OWP[otherTeam];
					}
				}

				OOWP[thisTeam] = avgOWP / numOpponents;
			}

			System.out.println("Case #" + (caseNum + 1) + ": ");
			for(int i = 0; i < numTeams; i++) {
				double RPI = 0.25 * WP[i] + 0.50 * OWP[i] + 0.25 * OOWP[i];
				System.out.println(RPI);
			}
		}


		if(DEBUG) System.out.println("Total time: " + ((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}
