import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class FairAndSquare {
	private static final boolean DEBUG = false;
	private static final String FILENAME = "fairsquare";

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		if(DEBUG) {
			System.setIn(new BufferedInputStream(new FileInputStream(FILENAME + "_example.in")));
		} else {
			System.setIn(new BufferedInputStream(new FileInputStream(FILENAME + ".in")));
			System.setOut(new PrintStream(FILENAME + ".out"));
		}

		Scanner sc = new Scanner(System.in);
		
		//long rangeMax = 100000000000000L;
		long maxSqrt = 10000000;
		List<Long> fairSquareNumbers = new ArrayList<Long>();
		for(long i = 1; i <= maxSqrt; i++) {
			if(isPalindromic(String.valueOf(i)) && isPalindromic(String.valueOf(i * i))) {
				fairSquareNumbers.add(i * i);
			}
		}
		
		int numTestCases = sc.nextInt();
		for(int caseNum = 1; caseNum <= numTestCases; caseNum++) {
			long rangeStart = sc.nextLong();
			long rangeEnd = sc.nextLong();
			
			int count = 0;
			for(Long fairSquare : fairSquareNumbers) {
				if(fairSquare <= rangeEnd && fairSquare >= rangeStart) {
					count++;
				}
			}

			System.out.println("Case #" + caseNum + ": " + count);
		}

		if(DEBUG) System.out.println("Total time: " + ((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
	
	private static boolean isPalindromic(CharSequence str) {
		for(int i = 0; i < str.length() / 2; i++) {
			if(str.charAt(i) != str.charAt(str.length() - i - 1)) {
				return false;
			}
		}

		return true;
	}
}