package Round1B_2010;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class FileFixIt {
	private static final boolean DEBUG = false;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("filefixit_example.in"));
		//System.setIn(new FileInputStream("x_largetest.in"));
		System.setIn(new FileInputStream("A-large.in"));
		System.setOut(new PrintStream("filefixit_large.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int i = 0; i < numTestCases; i++) {
			int existingDirs = sc.nextInt();
			int dirsToCreate = sc.nextInt();

			Set<String> paths = new HashSet<String>();
			
			for(int j = 0; j < existingDirs; j++) {
				String path = sc.next();
				paths.add(path);

				StringBuilder sb = new StringBuilder(path);
				int pos;
				while((pos = sb.lastIndexOf("/")) != -1) {
					sb.delete(pos, sb.length());
					paths.add(sb.toString());
				}
			}

			if(DEBUG) {
				for(String string : paths) {
					System.out.println(string);
				}
			}

			int dirsThatNeedCreating = 0;
			for(int j = 0; j < dirsToCreate; j++) {
				String path = sc.next();
				StringBuilder sb = new StringBuilder(path);
				while(sb.length() > 1) {
					if(paths.contains(sb.toString())) {
						break;
					} else {
						paths.add(sb.toString());
						dirsThatNeedCreating++;
						int pos = sb.lastIndexOf("/");
						sb.delete(pos, sb.length());
					}
				}
			}

			if(DEBUG) {
				for(String string : paths) {
					System.out.println(string);
				}
			}

			System.out.println("Case #" + (i + 1) + ": " + dirsThatNeedCreating);
		}


		if(DEBUG) System.out.println("Total time: " + (float)((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}
