import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class Lawnmower {
	private static final boolean DEBUG = false;
	private static final String FILENAME = "lawnmower";

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		if(DEBUG) {
			System.setIn(new BufferedInputStream(new FileInputStream(FILENAME + "_example.in")));
		} else {
			System.setIn(new BufferedInputStream(new FileInputStream(FILENAME + ".in")));
			System.setOut(new PrintStream(FILENAME + ".out"));
		}

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int caseNum = 1; caseNum <= numTestCases; caseNum++) {
			int numRows = sc.nextInt();
			int numCols = sc.nextInt();
			
			int[][] goal = new int[numRows][numCols];
			for(int row = 0; row < numRows; row++) {
				for(int col = 0; col < numCols; col++) {
					goal[row][col] = sc.nextInt();
				}
			}
			
			int[][] lawn = new int[numRows][numCols];
			for(int row = 0; row < numRows; row++) {
				for(int col = 0; col < numCols; col++) {
					lawn[row][col] = 100;
				}
			}
			
			//From the side
			for(int row = 0; row < numRows; row++) {
				int max = 0;
				for(int col = 0; col < numCols; col++) {
					if(goal[row][col] > max) {
						max = goal[row][col];
					}
				}
				
				for(int col = 0; col < numCols; col++) {
					lawn[row][col] = Math.min(max, lawn[row][col]);
				}
			}
			
			//From the top
			for(int col = 0; col < numCols; col++) {
				int max = 0;
				for(int row = 0; row < numRows; row++) {
					if(goal[row][col] > max) {
						max = goal[row][col];
					}
				}
				
				for(int row = 0; row < numRows; row++) {
					lawn[row][col] = Math.min(max, lawn[row][col]);
				}
			}
		
			boolean possible = true;
			outer:
			for(int row = 0; row < numRows; row++) {
				for(int col = 0; col < numCols; col++) {
					if(lawn[row][col] != goal[row][col]) {
						possible = false;
						break outer;
					}
				}
			}

			if(possible) {
				System.out.println("Case #" + caseNum + ": YES");
			} else {
				System.out.println("Case #" + caseNum + ": NO");
			}
		}

		if(DEBUG) System.out.println("Total time: " + ((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}