package Round1B_2010;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class Chicks {
	private static final boolean DEBUG = false;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("chicks_example.in"));
		//System.setIn(new FileInputStream("x_largetest.in"));
		System.setIn(new FileInputStream("B-large.in"));
		System.setOut(new PrintStream("chicks_large.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int i = 0; i < numTestCases; i++) {
			int numChicks = sc.nextInt();
			int needToFinish = sc.nextInt();
			int barnLocation = sc.nextInt();
			int endTime = sc.nextInt();

			int[] startPositions = new int[numChicks];
			for(int j = 0; j < startPositions.length; j++) {
				startPositions[j] = sc.nextInt();
			}

			int[] chickSpeeds = new int[numChicks];
			for(int j = 0; j < chickSpeeds.length; j++) {
				chickSpeeds[j] = sc.nextInt();
			}

			//Calc which chicks are fast enough to reach the barn
			boolean[] fastEnough = new boolean[numChicks];
			for(int chick = 0; chick < numChicks; chick++) {
				if(startPositions[chick] + endTime * chickSpeeds[chick] >= barnLocation) {
					fastEnough[chick] = true;
				}
			}

			int fastEnoughCount = 0;
			int numSwapsNeeded = 0;
			for(int chick = fastEnough.length - 1; chick >= 0; chick--) {
				if(fastEnough[chick]) {
					fastEnoughCount++;
				} else {
					int numSteps = 0;
					for(int prevChick = chick; prevChick >= 0; prevChick--) {
						if(fastEnough[prevChick]) {
							fastEnough[prevChick] = false;
							fastEnough[chick] = true;
							fastEnoughCount++;
							numSwapsNeeded += numSteps;
							break;
						}
						numSteps++;
					}
				}

				if(fastEnoughCount == needToFinish) {
					break;
				}
			}

			if(DEBUG) System.out.println(Arrays.toString(fastEnough));
			
			if(fastEnoughCount >= needToFinish) {
				System.out.println("Case #" + (i + 1) + ": " + numSwapsNeeded);
			} else {
				System.out.println("Case #" + (i + 1) + ": " + "IMPOSSIBLE");
			}
		}

		if(DEBUG) System.out.println("Total time: " + (float)((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}
