import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class SquareTiles {
	private static final boolean DEBUG = false;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("square_example.in"));
		System.setIn(new FileInputStream("A-small-attempt0.in"));
		//System.setIn(new FileInputStream("A-large.in"));
		if(!DEBUG) System.setOut(new PrintStream("square_small.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int caseNum = 0; caseNum < numTestCases; caseNum++) {
			int numRows = sc.nextInt();
			int numCols = sc.nextInt();

			char[][] field = new char[numRows][numCols];

			for(int i = 0; i < numRows; i++) {
				String row = sc.next();
				field[i] = row.toCharArray();
			}

			int[] colOffset = new int[]{0, 1, 1, 0};
			int[] rowOffset = new int[]{0, 0, 1, 1};

			for(int row = 0; row < numRows; row++) {
				for(int col = 0; col < numCols; col++) {
					int paintCount = 0;

					for(int k = 0; k < colOffset.length; k++) {
						int newRow = row + rowOffset[k];
						int newCol = col + colOffset[k];
						if(newRow < numRows && newCol < numCols && field[newRow][newCol] == '#') {
							paintCount++;
						}
					}

					if(paintCount == 4) {
						field[row][col] = '/';
						field[row][col+1] = '\\';
						field[row+1][col] = '\\';
						field[row+1][col+1] = '/';
					}
				}
			}

			System.out.println("Case #" + (caseNum + 1) + ": ");

			StringBuilder output = new StringBuilder();
			boolean impossible = false;

			outer:
			for(int row = 0; row < numRows; row++) {
				for(int col = 0; col < numCols; col++) {
					if(field[row][col] == '#') {
						impossible = true;
						break outer;
					}

					output.append(field[row][col]);
				}
				output.append("\n");
			}

			if(impossible) {
				System.out.println("Impossible");
			} else {
				System.out.println(output.substring(0, output.length() - 1));
			}
		}

		if(DEBUG) System.out.println("Total time: " + ((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}
