import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class Magicka {
	private static final boolean DEBUG = false;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("magicka_example.in"));
		//System.setIn(new FileInputStream("B-small-attempt0.in"));
		System.setIn(new FileInputStream("B-large.in"));
		if(!DEBUG) System.setOut(new PrintStream("magicka_large.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int i = 0; i < numTestCases; i++) {
			Map<String, String> combinations = new HashMap<String, String>();
			Set<String> opposedElements = new HashSet<String>();

			int numCombinations = sc.nextInt();
			for(int j = 0; j < numCombinations; j++) {
				String comb = sc.next();
				combinations.put(comb.substring(0, 2), ""+comb.charAt(2));
				combinations.put(comb.charAt(1)+""+comb.charAt(0), ""+comb.charAt(2));
			}

			int numOpposed = sc.nextInt();
			for(int j = 0; j < numOpposed; j++) {
				String opp = sc.next();
				opposedElements.add(opp);
				opposedElements.add(opp.charAt(1)+""+opp.charAt(0));
			}

			int strLen = sc.nextInt();
			String inputStr = sc.next();

			////////////////////////////////////

			StringBuilder result = new StringBuilder();
			for(int j = 0; j < inputStr.length(); j++) {
				result.append(inputStr.charAt(j));

				if(result.length() > 1) {
					String lastTwo = result.substring(result.length() - 2, result.length());
					if(combinations.containsKey(lastTwo)) {
						result.replace(result.length() - 2, result.length(), combinations.get(lastTwo));
					}
				}

				for(int k = 0; k < result.length() - 1; k++) {
					if(opposedElements.contains(result.charAt(result.length() - 1)+""+result.charAt(k))) {
						result = new StringBuilder();
						break;
					}
				}
			}

			////////////////////////////////////

			StringBuilder outputFormat = new StringBuilder();
			outputFormat.append("[");
			for(int j = 0; j < result.length(); j++) {
				outputFormat.append(result.charAt(j)).append(", ");
			}
			if(outputFormat.length() > 1) {
				outputFormat.delete(outputFormat.length() - 2, outputFormat.length());
			}
			outputFormat.append("]");

			System.out.println("Case #" + (i + 1) + ": " + outputFormat);
		}


		if(DEBUG) System.out.println("Total time: " + (float)((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}
