import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;

public class DeceitfulWar {
	private static final boolean DEBUG = false;
	private static final String FILENAME = "deceitful_war";

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		if(DEBUG) {
			System.setIn(new BufferedInputStream(new FileInputStream(FILENAME + "_example.in")));
		} else {
			System.setIn(new BufferedInputStream(new FileInputStream(FILENAME + ".in")));
			System.setOut(new PrintStream(FILENAME + ".out"));
		}

		Scanner sc = new Scanner(System.in).useLocale(Locale.US);

		int numTestCases = sc.nextInt();
		for(int caseNum = 1; caseNum <= numTestCases; caseNum++) {
			int numBlocks = sc.nextInt();
			Double[] naomiBlocksInput = new Double[numBlocks];
			for(int i = 0; i < naomiBlocksInput.length; i++) {
				naomiBlocksInput[i] = sc.nextDouble();
			}
			Double[] kenBlocksInput = new Double[numBlocks];
			for(int i = 0; i < kenBlocksInput.length; i++) {
				kenBlocksInput[i] = sc.nextDouble();
			}
			
			int warScore = 0;
			List<Double> naomiBlocks = new ArrayList<Double>(Arrays.asList(naomiBlocksInput));
			List<Double> kenBlocks = new ArrayList<Double>(Arrays.asList(kenBlocksInput));
			Collections.sort(kenBlocks);
			for(int i = 0; i < naomiBlocks.size(); i++) {
				double naomiBlockWeight = naomiBlocks.get(i);
				int kenBlocksIndex = -1;
				for(int j = 0; j < kenBlocks.size(); j++) {
					if(kenBlocks.get(j) > naomiBlockWeight) {
						kenBlocksIndex = j;
						break;
					}
				}
				
				if(kenBlocksIndex == -1) {
					// If no larger block left, play smallest block
					kenBlocks.remove(0);
					warScore++;
				} else {
					// If larger block left, play block closest above her weight
					kenBlocks.remove(kenBlocksIndex);
				}
			}
			
			int deceitfulWarScore = 0;
			naomiBlocks = new ArrayList<Double>(Arrays.asList(naomiBlocksInput));
			kenBlocks = new ArrayList<Double>(Arrays.asList(kenBlocksInput));
			Collections.sort(naomiBlocks);
			Collections.sort(kenBlocks);
			while(naomiBlocks.size() > 0) {
				double kenBlockWeight = kenBlocks.get(0);
				int naomiBlocksIndex = -1;
				for(int j = 0; j < naomiBlocks.size(); j++) {
					if(naomiBlocks.get(j) > kenBlockWeight) {
						naomiBlocksIndex = j;
						break;
					}
				}
				
				if(naomiBlocksIndex == -1) {
					kenBlocks.remove(0);
					naomiBlocks.remove(0);
				} else {
					naomiBlocks.remove(naomiBlocksIndex);
					kenBlocks.remove(0);
					deceitfulWarScore++;
				}
			}

			System.out.println("Case #" + caseNum + ": " + deceitfulWarScore + " " + warScore);
		}

		if(DEBUG) System.out.println("Total time: " + ((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}