import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class SpaceEmergency {
	private static final boolean DEBUG = false;
	private static int numStars, numDistances;
	private static long buildTime;
	private static int[] starDists;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("space_example.in"));
		System.setIn(new FileInputStream("B-small-attempt1.in"));
		//System.setIn(new FileInputStream("B-large.in"));
		if(!DEBUG) System.setOut(new PrintStream("space_small3.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int caseNum = 0; caseNum < numTestCases; caseNum++) {
			int numBoosters = sc.nextInt();
			buildTime = sc.nextLong();
			numStars = sc.nextInt();
			numDistances = sc.nextInt();

			int[] distances = new int[numDistances];
			for(int i = 0; i < numDistances; i++) {
				distances[i] = sc.nextInt();
			}

			starDists = new int[numStars];
			for(int i = 0; i < starDists.length; i++) {
				starDists[i] = distances[i % distances.length];
			}

			long minTime = Integer.MAX_VALUE;

			if(numBoosters == 0) {
				minTime = travelTime(new int[0]);
			} else if(numBoosters == 1) {
				for(int booster1 = 0; booster1 < numStars; booster1++) {
					long currentTime = travelTime(new int[]{booster1});
					if(currentTime < minTime) {
						minTime = currentTime;
					}
				}
			} else if(numBoosters == 2) {
				for(int booster1 = 0; booster1 < numStars; booster1++) {
					for(int booster2 = 0; booster2 < numStars; booster2++) {
						long currentTime = travelTime(new int[]{booster1, booster2});
						if(currentTime < minTime) {
							minTime = currentTime;
						}
					}
				}
			}

			System.out.println("Case #" + (caseNum + 1) + ": " + minTime);
		}

		if(DEBUG) System.out.println("Total time: " + ((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}

	private static long travelTime(int[] boosterPositions) {
		long currentTime = 0;
		for(int currentPos = 0; currentPos < numStars; currentPos++) {
			boolean isAtBoosterStar = false;
			for(int i = 0; i < boosterPositions.length; i++) {
				if(boosterPositions[i] == currentPos) {
					isAtBoosterStar = true;
				}
			}

			if(isAtBoosterStar) {
				if(currentTime < buildTime) {
					long timeUntilBooster = buildTime - currentTime;
					long timeWithBooster = Math.max(starDists[currentPos] - timeUntilBooster / 2, 0);

					long time = timeUntilBooster + timeWithBooster;

					currentTime += time;
				} else {
					currentTime += starDists[currentPos];
				}
			} else {
				currentTime += starDists[currentPos] * 2;
			}
		}

		return currentTime;
	}
}
