package Kval2010;

import java.io.FileInputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class SnapperChain {
	private static final boolean DEBUG = false;

	public static void main(String[] args) throws IOException {
		long startTime = System.nanoTime();

		//System.setIn(new FileInputStream("snapper_example.in"));
		System.setIn(new FileInputStream("A-small-attempt0.in"));
		System.setOut(new PrintStream("snapper_small.out"));

		Scanner sc = new Scanner(System.in);

		int numTestCases = sc.nextInt();
		for(int i = 0; i < numTestCases; i++) {
			int numSnappers = sc.nextInt();
			int numFingerSnaps = sc.nextInt();

			boolean[] snapperStates = new boolean[numSnappers]; //Default value is false
			final boolean ON = true;
			final boolean OFF = false;

			//Check if we are starting over from the beginning
			int cycleLength = (int)Math.pow(2, snapperStates.length);
			if(DEBUG) System.out.println("Cycle: " + cycleLength);

			//Remove cycles
			numFingerSnaps = numFingerSnaps % cycleLength;
			if(DEBUG) System.out.println("Remaining: " + numFingerSnaps);

			
			//Might be a bit faster, not needed
			int numSnapsPattern = 0;
			int count = 0;
			while(numSnapsPattern < numFingerSnaps) {
				numSnapsPattern = numSnapsPattern * 2 + 1;
				count++;
			}
			numSnapsPattern--;
			numSnapsPattern /= 2;
			
			if(DEBUG) System.out.println("Num: " + numSnapsPattern);
			if(DEBUG) System.out.println("Count: " + count);

			if(count >= snapperStates.length) {
				count = snapperStates.length - 1;
			}

			for(int j = 0; j < count; j++) {
				snapperStates[j] = ON;
			}
			
			numFingerSnaps -= numSnapsPattern;


			if(DEBUG) System.out.println(Arrays.toString(snapperStates));

			for(int j = 0; j < numFingerSnaps; j++) {
				int k = 0;
				while(k < snapperStates.length && snapperStates[k] == ON) {
					k++;
				}

				if(k == snapperStates.length) {
					k--;
				}

				for(; k >= 0; k--) {
					snapperStates[k] = !snapperStates[k];
				}

				if(DEBUG) System.out.println(Arrays.toString(snapperStates));
			}

			if(DEBUG) System.out.println(Arrays.toString(snapperStates));

			String lampHasPower = "ON";
			for(boolean state : snapperStates) {
				if(state == OFF) {
					lampHasPower = "OFF";
					break;
				}
			}

			System.out.println("Case #" + (i + 1) + ": " + lampHasPower);

			if(DEBUG) System.out.println();
		}

		if(DEBUG) System.out.println("Total time: " + (float)((System.nanoTime() - startTime) / 1000.0 / 1000.0 / 1000.0) + "s");
	}
}
