import java.io.*;
import java.util.*;

public class DeceitfulWar
{
	public static void main(String[] args) throws Exception
	{
		Scanner input = new Scanner(new File("input.txt"));
		FileWriter output = new FileWriter("output.txt");

		int testCaseCount = input.nextInt();

		for (int i = 0; i < testCaseCount; i++)
		{
			output.write("Case #" + (i+1) + ": ");
			Solve(input, output);
		}

		output.close();
	}

	public static void Solve(Scanner input, FileWriter output) throws Exception
	{
		// Ken's Strategy: Always select the lightest block he has that beats Naomi.

		// Naomi's Strategy: Until her lightest beats Ken's heaviest
		//					 play the lightest and lie it is between 
		//					 Ken's heaviest and second heaviest.
		//	WRONG
		//		Try: Naomi lies repeatedly, starting with her lightest, until
		//			a case will occur when she is caught for it.

		int N = input.nextInt();

		double[] naomi = new double[N];
		double[] ken = new double[N];

		double[] naomiDeceit = new double[N];
		double[] kenDeceit = new double[N];

		for (int i = 0; i < N; i++)
		{
			naomi[i] = input.nextDouble();
		}

		for (int i = 0; i < N; i++)
		{
			ken[i] = input.nextDouble();
		}

		Arrays.sort(naomi);
		Arrays.sort(ken);

		naomiDeceit = Arrays.copyOf(naomi, N);
		kenDeceit = Arrays.copyOf(ken, N);

		int deceitPoints = 0;

		for (int play = 0; play < N; play++)
		{
			double kensLightestUnused = 0.0;
			for (int i = 0; i < N; i++)
			{
				if (kenDeceit[i] != 0)
				{
					kensLightestUnused = kenDeceit[i];
					kenDeceit[i] = 0;
					break;
				}
			}

			for (int i = 0; i < N; i++)
			{
				if (naomiDeceit[i] > kensLightestUnused)
				{
					naomiDeceit[i] = 0;
					deceitPoints++;
					break;
				}
			}
		}

		output.write(deceitPoints + " ");

		// Determine the default game score.

		int trueWarPoints = 0;

		for (int i = 0; i < N; i++)
		{
			double naomiValue = naomi[i];

			int kenLowestIndex = -1;

			boolean kenWin = false;

			// Represent a used Ken value with a 0 in the array.

			for (int j = 0; j < N; j++)
			{
				if (ken[j] > naomiValue)
				{
					ken[j] = 0;
					kenWin = true;
					break;
				}
				if (ken[j] != 0 && kenLowestIndex == -1)
				{
					kenLowestIndex = j;
				}
			}

			if (!kenWin)
			{
				// Ken uses his lowest if he can't win.
				ken[kenLowestIndex] = 0;
				trueWarPoints++;
			}
		}

		output.write(trueWarPoints + "\n");
	}
}