import java.util.StringTokenizer;
import java.io.*;

public class Magicka {
	private String elementList = "";
	private String toAdd = "";
	char[][] combinations;
	char[][] oppositions;
	
	private int qCount = 0;
	private int wCount = 0;
	private int eCount = 0;
	private int rCount = 0;
	private int aCount = 0;
	private int sCount = 0;
	private int dCount = 0;
	private int fCount = 0;

	public String processElementList(String input) {
		clear();
		readInfo(input);
		solve();
		return elementList;
	}

	private void readInfo(String input) {
		StringTokenizer st = new StringTokenizer(input, " ");
		
		int numberCombinations = Integer.parseInt(st.nextToken());
		combinations = new char[numberCombinations][3];
		
		String tempCombination;
		for (int i = 0; i < numberCombinations; i++) {
			tempCombination = st.nextToken();
			combinations[i][0] = tempCombination.charAt(0);
			combinations[i][1] = tempCombination.charAt(1);
			combinations[i][2] = tempCombination.charAt(2);
		}

		int numberOppositions = Integer.parseInt(st.nextToken());
		oppositions = new char[numberOppositions][2];
		
		String tempOpposition;
		for (int i = 0; i < numberOppositions; i++) {
			tempOpposition = st.nextToken();
			oppositions[i][0] = tempOpposition.charAt(0);
			oppositions[i][1] = tempOpposition.charAt(1);
		}
		
		int numberElements = Integer.parseInt(st.nextToken());
		toAdd = st.nextToken();
	}
	
	private void solve() {
		for (int i = 0; i < toAdd.length(); i++) {
			append(toAdd.charAt(i));
		}
	}

	private void append(char element) {
		for (int i = 0; i < combinations.length; i++) {
			if ((element == combinations[i][0] && returnLastChar() == combinations[i][1]) || (element == combinations[i][1] && returnLastChar() == combinations[i][0])) {
				removeLastChar();
				strictAppend(combinations[i][2]);
				return;
			}
		}
		for (int i = 0; i < oppositions.length; i++) {
			if (element == oppositions[i][0]) {
				if (doesExist(oppositions[i][1])) {
					clear();
					return;
				}
			} else if (element == oppositions[i][1]) {
				if (doesExist(oppositions[i][0])) {
					clear();
					return;
				}
			}
		}
		strictAppend(element);
	}
	
	private void strictAppend(char element) {
		// Change the count
		// Append
		switch (element) {
			case 'Q':
				qCount++;
			break;
			case 'W':
				wCount++;
			break;
			case 'E':
				eCount++;
			break;
			case 'R':
				rCount++;
			break;
			case 'A':
				aCount++;
			break;
			case 'S':
				sCount++;
			break;
			case 'D':
				dCount++;
			break;
			case 'F':
				fCount++;
			break;
		}
		elementList = (elementList + element);
	}
	
	private char returnLastChar() {
		if (elementList.length() >= 1) {
			return elementList.charAt(elementList.length()-1);
		} else {
			return 'z';
		}
	}
	
	private void clear() {
		elementList = "";

		qCount = 0;
		wCount = 0;
		eCount = 0;
		rCount = 0;
		aCount = 0;
		sCount = 0;
		dCount = 0;
		fCount = 0;
	}
	
	private void removeLastChar() {
		// Change the count
		// Remove
		switch (returnLastChar()) {
			case 'Q':
				qCount--;
			break;
			case 'W':
				wCount--;
			break;
			case 'E':
				eCount--;
			break;
			case 'R':
				rCount--;
			break;
			case 'A':
				aCount--;
			break;
			case 'S':
				sCount--;
			break;
			case 'D':
				dCount--;
			break;
			case 'F':
				fCount--;
			break;
		}
		if (elementList.length() == 1) {
			// Special case
			elementList = "";
		} else {
			elementList = elementList.substring(0,elementList.length()-1);
		}
	}
	
	private boolean doesExist(char character) {
		// Returns true if count > 0
		boolean result = false;
		
		switch (character) {
			case 'Q':
				result = (qCount > 0);
			break;
			case 'W':
				result = (wCount > 0);
			break;
			case 'E':
				result = (eCount > 0);
			break;
			case 'R':
				result = (rCount > 0);
			break;
			case 'A':
				result = (aCount > 0);
			break;
			case 'S':
				result = (sCount > 0);
			break;
			case 'D':
				result = (dCount > 0);
			break;
			case 'F':
				result = (fCount > 0);
			break;
		}
		
		return result;
	}

	public static void main(String[] args) throws IOException, FileNotFoundException {
		BufferedReader br = new BufferedReader(new FileReader("input.txt"));
		Magicka m = new Magicka();
		int lineNumber = 1;
		String result;
		
		// The code automatically determines how many lines are in the input file, and the first line of the file is not needed
		br.readLine();
		
		while (br.ready()) {
			result = m.processElementList(br.readLine());
			System.out.print("Case #" + lineNumber + ": [");
			for (int i = 0; i < result.length()-1; i++) {
				System.out.print(result.charAt(i) + ", ");
			}
			if (result.length() != 0) {
				System.out.println(result.charAt(result.length()-1) + "]");
			} else {
				System.out.println("]");
			}
			lineNumber++;
		}			
	}
}