import java.io.*;
import java.util.*;

public class MagicTrick
{
	public static void main(String[] args) throws Exception
	{
		Scanner input = new Scanner(new File("input.txt"));
		FileWriter output = new FileWriter("output.txt");

		int testCaseCount = input.nextInt();

		for (int i = 0; i < testCaseCount; i++)
		{
			output.write("Case #" + (i+1) + ": ");
			Solve(input, output);
		}

		output.close();
	}

	public static void Solve(Scanner input, FileWriter output) throws Exception
	{
		int firstRow;
		int secondRow;

		int[][] firstArrangement = new int[4][4];
		int[][] secondArrangement = new int[4][4];

		firstRow = input.nextInt();

		for (int row = 1; row <= 4; row++)
		{
			for (int column = 1; column <= 4; column++)
			{
				firstArrangement[row-1][column-1] = input.nextInt();
			}
		}

		secondRow = input.nextInt();

		for (int row = 1; row <= 4; row++)
		{
			for (int column = 1; column <= 4; column++)
			{
				secondArrangement[row-1][column-1] = input.nextInt();
			}
		}

		int[] possibleAnswers = new int[16];

		for (int i = 0; i < possibleAnswers.length; i++)
		{
			possibleAnswers[i] = 0;
		}

		for (int column = 1; column <= 4; column++)
		{
			possibleAnswers[firstArrangement[firstRow-1][column-1]-1]++;
			possibleAnswers[secondArrangement[secondRow-1][column-1]-1]++;
		}

		int possibilities = 0;
		int lastPossibility = -1;

		for (int i = 0; i < 16; i++)
		{
			if (possibleAnswers[i] == 2)
			{
				possibilities++;
				lastPossibility = i+1;
			}
		}

		switch (possibilities)
		{
			case 0:
				output.write("Volunteer cheated!\n");
				break;

			case 1:
				output.write(lastPossibility + "\n");
				break;

			default:
				output.write("Bad magician!\n");
				break;
		}
	}
}