import java.util.*;
import java.io.*;
/**
 * Problem C from Codejam 2016
 * 
 * @author Austin Barrett
 * @version Codejam 2016
 */
public class JamCoin
{
    public static void main (String[] args)
    {
        Scanner scIn = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        scIn.nextLine(); //Skips # of cases
        System.out.println("Case #1:");
        int length = scIn.nextInt();
        int j = scIn.nextInt();
        int[] base = new int[length];
        base[0] = 1;
        base[length - 1] = 1;
        for (int i = 1; i < length - 1; i ++)
        {
            base[i] = 0;
        }
        
        for (int i = 0; i < j; i++)
        {
            base = mint(base);
            base = increment(base);
        }
    }
    
    public static int[] mint (int[] coin)
    {
        while (proof(coin).equals("NO"))
        {
            increment(coin);
        }
        System.out.println(proof(coin));
        return coin;
    }
    
    public static int[] increment (int[] arr)
    {
        int length = arr.length;
        for (int i = length - 2; i > 0; i--)
        {
            if (arr[i] == 0)
            {
                arr[i] = 1;
                return arr;
            }
            else
                arr[i] = 0;
        }
        return arr;
    }
    
    public static String proof (int[] digits)
    {
        boolean valid = true;
        String s = "";
        for (int i = 0; i < digits.length; i++)
        {
            s += digits[i];
        }
        s += " ";
        for (int base = 2; base <= 10; base++)
        {
            long num = 0;
            for (int i = 0; i < digits.length; i++)
            {
                if (digits[i] == 1)
                {
                    num += Math.pow(base,(digits.length - 1) - i);
                }
            }
            if (isPrime(num))
            {
                return "NO";
            }
            s += factor(num) + " ";
        }
        return s;
    }
    
    public static boolean isPrime (long n)
    {
        if (n <= 1)
        {
            return false;
        }
        if (n == 2)
        {
                return true;
        }
        if (n % 2 == 0)
        {
                return false;
        }
        
        for (int i = 3; i <= Math.sqrt(n) + 1; i += 2)
        {
            if (n % i == 0) {
                return false;
            }
        }
        
        return true;
    }
    
    public static long factor (long n)
    {
        if (n % 2 == 0)
        {
                return 2;
        }
        
        for (long i = 3; i <= Math.sqrt(n) + 1; i += 2)
        {
            if (n % i == 0) {
                return n / i;
            }
        }
        return -1;
    }
}
