import java.util.*;
import java.io.*;
/**
 * Problem A Codejam 2016
 * 
 * @author Austin Barrett
 * @version Attempt 1
 */
public class CountingSheep
{
    public static void main(String[] args) 
    {
        Scanner scIn = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int cases = scIn.nextInt();
        for (int aCase = 1; aCase <= cases; aCase++)
        {
            int eger = scIn.nextInt();
            int result = countSheep(eger);
            if (result < 0)
            {
                System.out.println("Case #" + aCase + ": " + "INSOMNIA");
            }
            else
            {
                System.out.println("Case #" + aCase + ": " + result);
            }
        }
        
    }
    
    public static int countSheep(int base)
    {
        if (base == 0)
        {
            return -1;
        }
        boolean zero = false, one = false, two = false, three = false, four = false, five = false, six = false, seven = false, eight = false, nine = false;
        int counter = 0;
        int save = base;
        while (!(zero && one && two && three && four && five && six && seven && eight && nine))
        {
            counter++;
            base = save * counter;
            for (int digits = countDigits(base); digits > 0; digits--)
            {
                int digit = base / (int) Math.pow(10, digits - 1);
                switch (digit)
                {
                    case 0:
                        zero = true;
                        break;
                    case 1:
                        one = true;
                        break;
                    case 2:
                        two = true;
                        break;
                    case 3:
                        three = true;
                        break;
                    case 4:
                        four = true;
                        break;
                    case 5:
                        five = true;
                        break;
                    case 6:
                        six = true;
                        break;
                    case 7:
                        seven = true;
                        break;
                    case 8:
                        eight = true;
                        break;
                    case 9:
                        nine = true;
                        break;
                    default:
                        break;
                }
                base %= (int) Math.pow(10, digits - 1);
            }
        }
        return save * counter;
    }
    
    public static int countDigits(int n)
    {
        int counter = 0;
        while (n > 0)
        {
            n /= 10;
            counter++;
        }
        return counter;
    }
}
