package Official;

import java.io.File;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class QR2015C {

	public static boolean negative = false;
	public static int n = 0;

	public static void main(String[] args) throws Exception {
		String name = "C-small-attempt3";
		String path = "C:\\Users\\Austin\\workspace\\CodeJam\\src\\2015\\";
		Locale.setDefault(Locale.US);
		Scanner sc = new Scanner(new File(path + name + ".in"));
		PrintWriter pw = new PrintWriter(path + name + ".out");

		// Scanner sc = new Scanner(System.in);
		// PrintWriter pw = new PrintWriter(System.out);

		int testCases = sc.nextInt();
		for (int testCase = 1; testCase <= testCases; testCase++) {
			negative = false;
			String output;
			int n = sc.nextInt();
			int rep = sc.nextInt();
			String s = sc.next();

			if (isDijkstra(n, rep, s) && negative == false)
				output = "YES";
			else
				output = "NO";

			pw.printf("Case #" + testCase + ": " + output + "\n");
			pw.flush();
		}

		pw.close();
		sc.close();
	}

	// determines if value spells out ijk
	public static boolean isDijkstra(int n, int rep, String s) {

		String string = "";
		for (int i = 0; i < rep; i += 1) {
			string += s;
		}

		String temp = string;

		boolean output = solveForI(temp, 1);
		
		return output;
	}

	// shortens the string by 1
	public static String shortener(String s) {

		if (s.length() == 1)
			return s;

		char char1 = s.charAt(0);
		char char2 = s.charAt(1);
		
		if (char1 == char2 && s.length() == 2) {
			negative ^= true;
			return "1";
		} else if (char1 == char2) {
			negative ^= true;
			return s.substring(2, s.length());
		} else if (char1 == 'i' && char2 == 'j') {
			return 'k' + s.substring(2, s.length());
		} else if (char1 == 'i' && char2 == 'k') {
			negative ^= true;
			return 'j' + s.substring(2, s.length());
		} else if (char1 == 'j' && char2 == 'i') {
			negative ^= true;
			return 'k' + s.substring(2, s.length());
		} else if (char1 == 'j' && char2 == 'k') {
			return 'i' + s.substring(2, s.length());
		} else if (char1 == 'k' && char2 == 'i') {
			return 'j' + s.substring(2, s.length());
		} else if (char1 == 'k' && char2 == 'j') {
			negative ^= true;
			return 'i' + s.substring(2, s.length());
		}
		return s;
	}

	// Skips to #pos specific p (ijk) in the string
	public static String skipTo(String s, char p, int pos) {

		int counter = 0;

		do {
			if (s.charAt(0) == p) {
				counter++;
				if (counter == pos)
					return s;
			}			
			s = shortener(s);	
			if (s.length() < 3) {
				return s;
			}
		} while (counter < pos);

		return s;
	}

	// Solve for the value from i
	public static boolean solveForI(String s, int indexI) {

		// Shorten to i
		String tempI = skipTo(s, 'i', indexI);
		// Filter impossible case
		if (tempI.length() < 3 || tempI.equals("1")) {
			return false;
		}

		boolean output = solveForJ(tempI.substring(1, tempI.length()), 1);
		if (output == false) {
			indexI++;
			solveForI(tempI, indexI+1);
		}

		return output;
	}
	
	// Solve for the value from j
	public static boolean solveForJ(String s, int indexJ) {

		// Shorten to j
		String tempJ = skipTo(s, 'j', indexJ);
		// Filter impossible case
		if (tempJ.length() == 1 || tempJ.equals("1")) {
			return false;
		}

		boolean output = solveForK(tempJ.substring(1, tempJ.length()));
		if (output == false) {
			indexJ++;
			solveForJ(tempJ, indexJ+1);
		}

		return output;
	}

	// Solve til completion to determine if substring is equal to k
	public static boolean solveForK(String s) {
		while (s.length() > 1) {
			s = shortener(s);
		}
		if (s.charAt(0) == 'k')
			return true;

		return false;
	}

}
