import java.util.*;
import java.io.*;

public class Pancakes {

	public static int COUNT;

	public static void main(String[] args) 
	{
		ArrayList<String> input = readInput(args[0]);

		for (int i = 0; i < COUNT; i++) 
		{
			boolean[] stack = toArray(input.get(i));
			int result = flipPancakes(stack);
			System.out.println("Case #" + (i+1) + ": " + result);
		}
	}


	public static int flipPancakes(boolean[] stack)
	{
		int count = 0;
		HashSet<String> set = new HashSet<>();

		set.add(toStr(stack));

		while (!happyCheck(set)) 
		{
			set = generateNextSet(set);
			count++;
			if (set.size() == 0) break;
			//printSet(set, count);
		}

		return count;
	}


	public static HashSet<String> generateNextSet(HashSet<String> set)
	{
		HashSet<String> next = new HashSet<>();

		for (String str : set)
		{
			boolean[] stack = toBool(str);
			ArrayList<Integer> indexes = idIndexes(stack);
			next = addFlips(next, stack, indexes);
		}

		return next;
	}


	public static boolean[] toBool(String str)
	{
		boolean[] stack = new boolean[str.length()];
		for (int i = 0; i < str.length(); i++) 
		{
			if (str.charAt(i) == '+')
				stack[i] = true;
			else
				stack[i] = false;
		}
		return stack;
	}

	public static HashSet<String> addFlips(HashSet<String> set, boolean[] stack, ArrayList<Integer> indexes)
	{
		HashSet<String> next = set;
		for (int i : indexes)
			next.add(toStr(flipStack(stack, i)));
		return next;
	}


	public static ArrayList<Integer> idIndexes(boolean[] stack) 
	{
		ArrayList<Integer> indexes = new ArrayList<>();

		for (int i = 0; i < stack.length-1; i++)
		{
			if (stack[i] != stack[i+1])
			{
				indexes.add(i);
				indexes.add(i+1);
			}
		}

		indexes.add(stack.length-1);

		return indexes;
	}

	public static boolean happyCheck(HashSet<String> set)
	{
		for (String str : set)
			if (happyCheckStr(str))
				return true;
		
		return false;
	}

	public static boolean happyCheckStr(String str)
	{
		for (char c : str.toCharArray()) 
			if (c == '-')
				return false;
		return true;
	}


	public static String toStr(boolean[] stack) 
	{
		String str = "";
		for (boolean b : stack)
		{
			if (b) str += "+";
			else str += "-";
		}
		return str;
	}


	public static boolean[] flipStack(boolean[] stack, int index)
	{
		if (index < 0) return stack;

		boolean[] flipped = new boolean[stack.length];

		if (stack.length == 2 && index == 1) 
		{
			if (stack[0]) flipped[1] = false;
			else flipped[1] = true;
			if (stack[1]) flipped[0] = false;
			else flipped[0] = true;
			return flipped;
		}

		for (int i = 0; i <= index; i++) 
			flipped[i] = (stack[index-i]) ? false : true;
		for (int i = index+1; i < stack.length; i++)
			flipped[i] = stack[i];
		return flipped;
	}



	public static void printSet(HashSet<String> set, int count)
	{
		System.out.println("Depth " + count);
		for (String str : set)
		{
			System.out.println("\t" + str);
		}
	}

	public static void printStack(boolean[] stack)
	{
		System.out.print("\t");
		for (boolean b : stack) 
		{
			char c = (b) ? '+' : '-';
			System.out.print(c);
		}

		System.out.print("\n");
	}


	public static boolean[] toArray(String input) 
	{
		boolean[] stack = new boolean[input.length()];
		for (int i = 0; i < input.length(); i++)
		{
			char c = input.charAt(i);
			if (c == '+') stack[i] = true;
			else stack[i] = false;
		}
		return stack;
	}


	public static ArrayList<String> readInput(String fileName)
	{
		ArrayList<String> input = new ArrayList<String>();
		try 
		{
			Scanner in = new Scanner(new File(fileName));
			COUNT = Integer.parseInt(in.nextLine());
			while (in.hasNextLine())
				input.add(in.nextLine());
			in.close();
		} catch (Exception IOE) {
			System.out.println("INPUT FILE READ ERROR");
		}
		return input;
	}



}

