package com.rupam.realproblem;

import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;
import java.util.TreeSet;

import com.rupam.library.InputParser;
import com.rupam.library.ReadWriteFile;

public class ProblemC {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ReadWriteFile rwfile = new ReadWriteFile();
		InputParser inputParser = new InputParser();
		inputParser.setInput(rwfile.ReadFileToString("C:\\input.in"));
		int totalTestCases = inputParser.getIntEquivalent(inputParser.getNextLine());
		try {
			FileOutputStream fstream = new FileOutputStream("c:\\output.out");
			DataOutputStream out = new DataOutputStream(fstream);
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(out));
			for(int i=0;i<totalTestCases;i++){
				String result = "Case #"+(i+1)+": "+getTheValue(inputParser)+"\n";
				bw.write(result);
				System.out.println(result);
			}
	        //bw.write(fileContent);
			bw.flush();
	        out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static String getTheValue(InputParser inputParser) {
		// TODO Auto-generated method stub
		HashMap<Integer, Integer> hm = new HashMap<Integer, Integer>();
		int boardCount = 0;
		int singleBoardCount = 0;
		String[] MN = inputParser.getNextLine().split(" ");
		int M = Integer.parseInt(MN[0]);
		int N = Integer.parseInt(MN[1]);
		String[] rows = new String[M]; 
		for(int i=0;i<M;i++){
			rows[i] = inputParser.getNextLine();
		}
		int[][] matrix = new int[M][N];
		for(int i=0;i<M;i++){
			for(int j=0;j<N/4;j++){
				char fourCells = rows[i].charAt(j);
				int actualVal = getActualVal(fourCells);
				matrix[i][4*j] = (actualVal&8)!=0?1:0;
				matrix[i][4*j+1] = (actualVal&4)!=0?1:0;
				matrix[i][4*j+2] = (actualVal&2)!=0?1:0;
				matrix[i][4*j+3] = (actualVal&1)!=0?1:0;
			}			
		}
		
		for(int I=0;I<M;I++){
			for(int J=0;J<N;J++){
				int largestX = 0;
				int largestY = 0;
				int largestSize = 1;
				//search for the largest chess board possible
				for(int i=0;i<M-1;i++){
					for(int j=0;j<N-1;j++){
						//check if already the board is cut out there
						if(matrix[i][j]==2)continue;
						int size = getBiggestChessBoard(matrix,M,N,i,j,1);
						if(size>largestSize){
							largestSize = size;
							largestX = i;
							largestY = j;
						}
					}
				}
				//found the largest
				if(largestSize>1){
					boardCount++;
					int value = 1;
					if(hm.containsKey(largestSize)){
						value = hm.get(largestSize);
						value++;
					}
					hm.put(largestSize, value);
					for(int i=0;i<largestSize;i++){
						for(int j=0;j<largestSize;j++){
							matrix[largestX+i][largestY+j]=2;
						}
					}
				}
			}
		}
		for(int i=0;i<M;i++){
			for(int j=0;j<N;j++){
				if(matrix[i][j]!=2) {
					boardCount++;
					singleBoardCount++;
				}
			}
		}
		HashMap<Integer,Integer> sortedMap = getSortedMap(hm);//new TreeMap<Integer,Integer>(hm);
		String returnValue = ""+(sortedMap.size()+1);
		Object[] keys = sortedMap.keySet().toArray();
		Object[] values = sortedMap.values().toArray();
		for(int i=0;i<sortedMap.size();i++) returnValue += "\n"+((Integer)keys[i]).toString()+" "+((Integer)values[i]).toString();
		if(singleBoardCount>0)
			returnValue+="\n1 "+(singleBoardCount);
		return returnValue;
	}

	private static int getActualVal(char fourCells) {
		// TODO Auto-generated method stub
		switch(fourCells){
		case '0': return 0;
		case '1': return 1;
		case '2': return 2;
		case '3': return 3;
		case '4': return 4;
		case '5': return 5;
		case '6': return 6;
		case '7': return 7;
		case '8': return 8;
		case '9': return 9;
		case 'A': return 10;
		case 'B': return 11;
		case 'C': return 12;
		case 'D': return 13;
		case 'E': return 14;
		case 'F': return 15;
		default: return 0;
		}
	}

	private static int getBiggestChessBoard(int[][] matrix, int M, int N, int x, int y, int size) {
		// TODO Auto-generated method stub
		boolean allChessBoards = true;
		if(x+size>=M||y+size>=N) return size;
		for(int i=0;i<size;i++){
			for(int j=0;j<size;j++){
				if(matrix[x+i][y+j]==2)return size;
				if(!checkSmallestChessBoard(matrix, x+i, y+j)) {
					allChessBoards = false;
					break;
				}
			}
			if(!allChessBoards) break;
		}
		if(allChessBoards) return getBiggestChessBoard(matrix, M, N, x, y, ++size);
		else return size;
	}
	private static boolean checkSmallestChessBoard(int[][] matrix, int x, int y){
		if(matrix[x][y]==matrix[x+1][y+1]&&
			matrix[x][y]!=matrix[x][y+1]&&
			matrix[x][y]!=matrix[x+1][y]&&
			matrix[x+1][y]!=2&&matrix[x][y+1]!=2&&matrix[x+1][y+1]!=2) return true;
		else return false;
	}
	
	public static HashMap<Integer,Integer> getSortedMap(HashMap<Integer,Integer> hmap)
	{
		HashMap<Integer,Integer> map = new LinkedHashMap<Integer,Integer>();
		List<Integer> mapKeys = new ArrayList<Integer>(hmap.keySet());
		List<Integer> mapValues = new ArrayList<Integer>(hmap.values());
		hmap.clear();
		TreeSet<Integer> sortedSet = new TreeSet<Integer>(mapValues);
		Object[] sortedArray = sortedSet.toArray();
		int size = sortedArray.length;
//		a) Ascending sort
 
		for (int i=0; i<size; i++)
		{
 
		map.put(mapKeys.get(mapValues.indexOf(sortedArray[i])), (Integer) sortedArray[i]);
 
		}
		return map;
	}
	
}
