package com.rupam.realproblem;

import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import com.rupam.library.InputParser;
import com.rupam.library.ReadWriteFile;

public class RotateSolution {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ReadWriteFile rwfile = new ReadWriteFile();
		InputParser inputParser = new InputParser();
		inputParser.setInput(rwfile.ReadFileToString("C:\\B-small-attempt3.in"));
		int totalTestCases = inputParser.getIntEquivalent(inputParser.getNextLine());
		try {
			FileOutputStream fstream = new FileOutputStream("c:\\output.out");
			DataOutputStream out = new DataOutputStream(fstream);
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(out));
			for(int i=0;i<totalTestCases;i++){
				
				String result = "Case #"+(i+1)+": "+findRotatedValue(inputParser)+"\n";
				bw.write(result);
				System.out.println(result);
			}
	        //bw.write(fileContent);
			bw.flush();
	        out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static String findRotatedValue(InputParser inputParser) {
		// TODO Auto-generated method stub
		String nk[] = inputParser.getNextLine().split(" ");
		int n = Integer.parseInt(nk[0]);
		int k = Integer.parseInt(nk[1]);
		if(n<k) return "Neither";
		int[][] matrix = new int[n][n];
		for(int i=0;i<n;i++){
			String nSeries = inputParser.getNextLine();
			int innerFillCount = 0;
			for(int j=0;j<n;j++){
				char state = nSeries.charAt(n-j-1);
				switch(state){
				case '.':
					//gravitate
					break;
				case 'R': 
					matrix[n-i-1][n-innerFillCount-1] = 1;
					innerFillCount++;
					break;
				case 'B': 
					matrix[n-i-1][n-innerFillCount-1] = 2;
					innerFillCount++;
					break;	
				}
			}
		}
		
		int redResult = 0;
		int blueResult = 0;
		k=k-1;
		for(int i=0;i<n;i++){
			for(int j=0;j<n;j++){
				//System.out.print(matrix[j][i]);
				if(matrix[j][i]!=0){
					if(i>=k&&j<n-k){
						//you can do diag back check	
						boolean equals = true;
						for(int l=1;l<=k;l++){
							if(matrix[j][i]!=matrix[j+l][i-l]){
								equals = false;
								break;
							}
						}
						if(equals){
							if(matrix[j][i]==1) redResult++;
							if(matrix[j][i]==2) blueResult++;
						}
					}
					if(i<n-k&&j<n-k){
						//you can do diag front check
						boolean equals = true;
						for(int l=1;l<=k;l++){
							if(matrix[j][i]!=matrix[j+l][i+l]){
								equals = false;
								break;
							}
						}
						if(	equals){	
							if(matrix[j][i]==1) redResult++;
							if(matrix[j][i]==2) blueResult++;
						}
					}
					if(i<n-k){
						//horiz check
						boolean equals = true;
						for(int l=1;l<=k;l++){
							if(matrix[j][i]!=matrix[j][i+l]){
								equals = false;
								break;
							}
						}
						if(	equals){	
							if(matrix[j][i]==1) redResult++;
							if(matrix[j][i]==2) blueResult++;
						}
					}
					
					if(j<n-k){
						//vert check
						boolean equals = true;
						for(int l=1;l<=k;l++){
							if(matrix[j][i]!=matrix[j+l][i]){
								equals = false;
								break;
							}
						}
						if(	equals){	
							if(matrix[j][i]==1) redResult++;
							if(matrix[j][i]==2) blueResult++;
						}
					}

				}
			}	
			//System.out.print("\n");
		}
		if(redResult>0&&blueResult>0)
			return "Both";
		if(redResult>0)
			return "Red";
		if(blueResult>0)
			return "Blue";
		return "Neither";
	}
}
