package com.rupam.realproblem;

import java.io.BufferedWriter;
import java.io.DataOutputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;

import com.rupam.library.InputParser;
import com.rupam.library.ReadWriteFile;

public class ThemeParkSolution {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		ReadWriteFile rwfile = new ReadWriteFile();
		InputParser inputParser = new InputParser();
		inputParser.setInput(rwfile.ReadFileToString("C:\\C-small-attempt0.in"));
		int testCaseCount = inputParser.getIntEquivalent(inputParser.getNextLine());
		try {
			FileOutputStream fstream = new FileOutputStream("c:\\output.out");
			DataOutputStream out = new DataOutputStream(fstream);
			BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(out));
			for(int i=0;i<testCaseCount;i++){
				String valueLine = inputParser.getNextLine();
				int R = inputParser.getIntEquivalent(inputParser.getWordOfLine(valueLine, 0));
				int k = inputParser.getIntEquivalent(inputParser.getWordOfLine(valueLine, 1));
				int N = inputParser.getIntEquivalent(inputParser.getWordOfLine(valueLine, 2));
				String[] groups = inputParser.getNextLine().split(" ");
				int[] groupCount = new int[N];
				for(int j=0;j<N;j++){
					groupCount[j]=inputParser.getIntEquivalent(groups[j]);
				}
				bw.write("Case #"+(i+1)+": "+calculateEuros(R, k, N, groupCount)+"\n");
				//System.out.println("Case #"+(i+1)+": "+calculateEuros(R, k, N, groupCount));
			}
			bw.flush();
	        out.close();
		}catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static int calculateEuros(int r, int k, int n, int[] groupCount) {
		// TODO Auto-generated method stub
		/*for(int i=0;i<n;i++) System.out.print(" "+groupCount[i]);
		System.out.print("\n");*/
		int total = 0;
		int startGroupOnBoard = 0;
		for(int i=0;i<r;i++){
			int totalOnBoard = 0;
			int groupsOnBoard = 0;
			while(totalOnBoard<=k&&groupsOnBoard<n){
				totalOnBoard += groupCount[(startGroupOnBoard+groupsOnBoard)%n];
				groupsOnBoard++;
			}
			if(totalOnBoard>k) totalOnBoard -= groupCount[(startGroupOnBoard+groupsOnBoard-1)%n];
			startGroupOnBoard = (startGroupOnBoard+groupsOnBoard-1)%n;
			total += totalOnBoard;
		}
		return (total);
	}

}
