import java.util.List;

public class SolverImpl implements Solver {
	/**
	 * The language
	 */
	private Language language;

	/**
	 * The TestCases to solve
	 */
	private List<TestCase> testCases;

	public SolverImpl(final Language language, final List<TestCase> testCases) {
		this.language = language;
		this.testCases = testCases;
	}

	public void solve() {
		for (TestCase test : this.testCases) {
			List<String> matches = this.language.searchForPattern(test
					.getPattern());
			test.setResult(matches.size());
		}
		FileManager.writeOutPut(this.testCases, Constants.OUTPATH);
	}

	public Language getLanguage() {
		return this.language;
	}
}
