import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

/**
 * 
 * @author AVadas
 * 
 */
public class FileManager {
	/**
	 * 
	 * @param filePath
	 *            the path of the input file
	 * @return the Solver of the problem
	 */
	public static Solver getInputData(final String filePath) {
		Language resultLanguage = null;
		final List<TestCase> resultTestCases = new ArrayList<TestCase>();
		final File file = new File(filePath);
		if (file.exists()) {
			try {
				BufferedReader input = new BufferedReader(new FileReader(file));
				try {
					String aLine = input.readLine();
					String[] inputDescriptor = aLine.split(" ");
					int numberOfTokens = Integer.parseInt(inputDescriptor[0]);
					int numberOfWords = Integer.parseInt(inputDescriptor[1]);
					int numberOfTestCases = Integer
							.parseInt(inputDescriptor[2]);
					// the language
					resultLanguage = new Language(numberOfTokens, numberOfWords);

					for (int i = 0; i < numberOfWords; i++) {
						resultLanguage.addWordToDictionary(input.readLine());
					}

					// the test cases
					for (int i = 0; i < numberOfTestCases; i++) {
						resultTestCases.add(new TestCase(i, input.readLine()));
					}
				} finally {
					input.close();
				}
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
		return new SolverImpl(resultLanguage, resultTestCases);
	}

	public static void writeOutPut(final List<TestCase> testCases,
			final String filePath) {
		final File file = new File(filePath);
		BufferedWriter output = null;
		if (!file.exists()) {
			try {
				file.createNewFile();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		try {
			output = new BufferedWriter(new FileWriter(file));
			try {
				StringBuffer buffer = new StringBuffer();
				for (TestCase test : testCases) {

					buffer.append("Case ").append("#").append(
							test.getTestCaseNumber()+1).append(": ").append(
							test.getResult()).append("\n");
				}
				String outPutStr = buffer.toString(); 
				output.write(outPutStr.substring(0, outPutStr.length() - 1));
			} finally {
				output.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
