package org.google.codejam;

import java.util.ArrayList;
import java.util.List;

public class JamCoinGenerator {
	
	private final static Integer max = 65536;
	private final static boolean[] flags = new boolean[max];
	private final static List<Integer> primes = new ArrayList<>();
	
	public void generateJamCoinsWithProof(int n, int j) {
		final List<String> jamCoins = new ArrayList<> ();
		final List<List<Integer>> nonTrivialDivisors = new ArrayList<>();
		Long originalValue = (long) (Math.pow(2, n-1) + 1);
		Long currValue = originalValue;
		
		int count = 0;
		outerloop:
		while(count != j) { //check primality of no. in all bases
			List<Integer> divisors = new ArrayList<>();
			String binaryRep = Long.toBinaryString(currValue);
			currValue = currValue + 2;
			for(int i=2; i <= 10; i++) {
				Long convertedNo = Long.parseLong(binaryRep, i);
				boolean foundDivisor = false;
				for(Integer prime: primes) {
					   if(convertedNo % prime == 0 && convertedNo.longValue() != prime) {
						   foundDivisor = true;
						   divisors.add(prime);
						   break;
					   }
			   }
				if(!foundDivisor)
					continue outerloop;
			}
			jamCoins.add(binaryRep);
			nonTrivialDivisors.add(divisors);
			count++;
		}
		
		for(int i=0; i<jamCoins.size(); i++) {
			System.out.print(jamCoins.get(i) + " ");
			for(int k=0; k<nonTrivialDivisors.get(i).size(); k++)
				System.out.print(nonTrivialDivisors.get(i).get(k) + " ");
			System.out.println();
		}
	}
	
	void sieveOfEratosThenes() {
		int count = 0;
		init(); //Setting all flags to true  other than 0 and 1
		int prime = 2;
		
		while(prime <= Math.sqrt(max)) {
			primes.add(prime);
			crossOff(prime);
			prime = getNextPrime(prime);
		}
	}
	
	void crossOff(int prime) {
		for(int i=prime*prime; i < flags.length; i+= prime) {
			flags[i] = false;
		}
	}
	
	int getNextPrime(int prime) {
		int next = prime + 1;
		while(next < flags.length && !flags[next]) {
			next++;
		}
		return next;
	}
	
	void init() {
		flags[0] = false;
		flags[1] = false;
		for(int l = 2; l < flags.length; l++) {
			flags[l] = true;
		}
	}

}
