
/**
 *
 * @author amit
 */
import java.io.*;
import java.util.*;

public class GCJ {

    BufferedReader rin;
    BufferedWriter wout;
    int numCases;

    class Pair {

        public int index;
        public int value;

        public Pair(int i1, int i2) {
            index = i1;
            value = i2;
        }
    }

    public static long gcd(long a, long b) {
        if (a < b) {
            return gcd(b, a);
        }
        if (a % b == 0) {
            return b;
        } else {
            return gcd(b, a % b);
        }
    }

    public static long lcm(long a, long b) {
        return ((a * b) / gcd(a, b));

    }

    public static long lcmofarray(int[] arr, int start, int end) {
        if ((end - start) == 1) {
            return lcm(arr[start], arr[end - 1]);
        } else {
            return (lcm(arr[start], lcmofarray(arr, start + 1, end)));
        }
    }

    public String getNextInput() {
        try {
            String[] line1 = rin.readLine().split(" ");
            int B = Integer.parseInt(line1[0]);
            int N = Integer.parseInt(line1[1]);

            PriorityQueue<Integer> pq = new PriorityQueue<Integer>();

            String[] line2 = rin.readLine().split(" ");
            int[] bk = new int[B];

            for (int i = 0; i < B; i++) {
                bk[i] = Integer.parseInt(line2[i]);
                pq.add(i);
            }
            
            long lc = lcmofarray(bk, 0, B-1);
            int inone = 0;
            for (int i = 0; i < B; i++) {
                inone += lc/bk[i];
            }
            
            int rounds = (N-1)/inone;
            
            
            List<Pair> hm = new LinkedList<Pair>();
            long count = 0;
            long num = rounds * inone + 1;
            System.out.println("inone:" + inone + " rounds:" + rounds + " num:" + num);
            while (true) {
                if (!pq.isEmpty()) {
                    if (num == N) {
                        return Long.toString(pq.poll() + 1);
                    } else {
                        hm.add(new Pair(pq.peek(), bk[pq.poll()]));
                        num += 1;
                    }
                } else {
                    count += 1;
                    for (Pair h : hm) {
                        if (--h.value == 0) {
                            pq.add(h.index);
                        }
                    }
                }

            }
            //return "none";

        } catch (IOException e) {
            System.out.println("File Error! Could not read line from file");
        }
        return null;
    }

    public void writeNextOutput(String s) {
        try {
            wout.write(s);
            wout.write("\n");
        } catch (IOException e) {
            System.out.println("Error! Could not write to the file!");
        }
    }

    public GCJ(String s1, String s2) {
        try {
            rin = new BufferedReader(
                    new FileReader(s1));
            wout = new BufferedWriter(new FileWriter(s2));
            numCases = Integer.parseInt(rin.readLine());

            for (int i = 1; i <= numCases; i++) {
                System.out.println("case#" + i);
                String sout = getNextInput();
                sout = "Case #" + Integer.toString(i) + ":" + " " + sout;
                writeNextOutput(sout);
                //System.out.println("case#" + i);
            }
            rin.close();
            wout.close();
        } catch (IOException e) {
            System.out.println("File error");
            System.exit(0);
        }
    }

    public static void main(String[] args) {/*
         if (args.length!=2) {
         System.out.println("Enter input file!");
         System.exit(0);
         }*/

        //GCJ a = new GCJ("B-small-attempt0.in", "out1.txt");
        GCJ a = new GCJ("B-small-attempt2.in", "out5.txt");
        //GCJ a = new GCJ("infile.txt", "out2.txt");
    }
}
