
/**
 *
 * @author amit
 */
import java.io.*;
import java.util.ArrayList;
public class GCJ_C {

    BufferedReader rin;
    BufferedWriter wout;
    int numCases;

    public String distribute(int [] candies) {
        int max = 0;
        ArrayList<Integer> distribution = new ArrayList<Integer>();
        for (int i=0; i<candies.length; i++) {
            distribution.add(0);
        }
        /* System.out.print("distribution: ");
            for (int k=0; k<distribution.size(); k++){
                System.out.print(distribution.get(k));
            }
         System.out.println();*/
        int numDist = (int)Math.pow((double)2, (double)candies.length) - 2;
        ArrayList<Integer> one = new ArrayList<Integer>();
        one.add(1);
        //System.out.println("numdist" + numDist);
        for (int i=0; i<numDist; i++){
            //System.out.println("dist no" + i);
            distribution = normalBinAdd(distribution,one);
            ArrayList<Integer> seanN = new ArrayList<Integer>();
            ArrayList<Integer> patrickN = new ArrayList<Integer>();
            ArrayList<Integer> seanW = new ArrayList<Integer>();
            ArrayList<Integer> patrickW = new ArrayList<Integer>();

            /*System.out.print("distribution: ");
            for (int k=0; k<distribution.size(); k++){
                System.out.print(distribution.get(k));
            }
            System.out.println();*/
            for (int j=0; j<candies.length; j++){
                if (distribution.get(j)==0) {
                    //System.out.println("sean has " + candies[j]);
                    seanN = normalBinAdd(seanN,decToBin(candies[j]));
                    seanW = binAddWithoutCarry(seanW,decToBin(candies[j]));
                }
                else if(distribution.get(j) == 1) {
                    //System.out.println("pat has " + candies[j]);
                    patrickN = normalBinAdd(patrickN,decToBin(candies[j]));
                    patrickW = binAddWithoutCarry(patrickW,decToBin(candies[j]));
                }
            }
            int numSeanN = binToDec(seanN);
            int numPatrickN = binToDec(patrickN);
            int numSeanW = binToDec(seanW);
            int numPatrickW = binToDec(patrickW);

            //System.out.println("numSeanN:" + numSeanN + " numPatrickN:" + numPatrickN + " numSeanW:" + numSeanW + " numPatrickW:" + numPatrickW);
            if (numSeanW == numPatrickW){
                if (numSeanN > max)
                    max = numSeanN;
            }
        }
        if (max==0) return "NO";
        else return Integer.toString(max);
    }
    public ArrayList<Integer> normalBinAdd (ArrayList<Integer> a, ArrayList<Integer> b) {
        ArrayList<Integer> sum = new ArrayList<Integer>();
        //System.out.println("a.size(): " + a.size() + " b.size(): " + b.size());
        if (a.size()<b.size()) {
            int diff = b.size()-a.size();
            for(int i=0; i < diff; i++)
                a.add(0);
        }
        else {
            int diff = a.size()-b.size();
            //System.out.println("INSIDE else " + Integer.toString(diff));
            for(int i=0; i < diff; i++)
                b.add(0);
        }


        /*System.out.print("a: ");
            for (int k=0; k<a.size(); k++){
                System.out.print(a.get(k));
            }
        System.out.println();
                System.out.print("b: ");
            for (int k=0; k<b.size(); k++){
                System.out.print(b.get(k));
            }
                System.out.println();*/
        int carry = 0;
        //System.out.println("a.size(): " + a.size() + " b.size(): " + b.size());
        for (int i=0; i<a.size(); i++) {
            //System.out.println("i=" + i);
            int bitSum = a.get(i) + b.get(i) + carry;
            if (bitSum == 2) {
                sum.add(0);
                carry = 1;
            }
            else {
                sum.add(bitSum);
                carry = 0;
            }
        }
        if (carry == 1)
            sum.add(1);
                       /* System.out.print("sum: ");
            for (int k=0; k<sum.size(); k++){
                System.out.print(sum.get(k));
            }
                        System.out.println();*/
        return sum;
    }
    public ArrayList<Integer> binAddWithoutCarry (ArrayList<Integer> a, ArrayList<Integer> b) {
        ArrayList<Integer> sum = new ArrayList<Integer>();
        if (a.size()<b.size()) {
            int diff = b.size()-a.size();
            for(int i=0; i < diff; i++)
                a.add(0);
        }
        else {
            int diff = a.size()-b.size();
            for(int i=0; i < diff; i++)
                b.add(0);
        }
        for (int i=0; i<a.size(); i++) {
            int bitSum = a.get(i) + b.get(i);
            bitSum = bitSum % 2;
            sum.add(bitSum);
        }
        return sum;
    }
    public ArrayList<Integer> decToBin (int num) {
        ArrayList<Integer> nBin = new ArrayList<Integer>();
        while (num != 0) {
            nBin.add(num%2);
            num = num/2;
        }
        return nBin;
    }
    public int binToDec (ArrayList<Integer> a) {
        int num = 0;
        for (int i=0; i<a.size(); i++) {
            //System.out.println("bit " + i + " is " + (double)a.get(i));
            num = num + a.get(i)*(int)Math.pow((double)2,(double)i);
        }
        return num;
    }
    public String getNextInput() {
        try {
            String line = rin.readLine();
            System.out.println(line);
            int numCandies = Integer.parseInt(line);
            System.out.println("Number of candies: " + numCandies);
            int [] candyVals = new int[numCandies];
            line = rin.readLine();
            String[] aVars = line.split(" ");
            for(int i=0; i<numCandies; i++) {
                candyVals[i] = Integer.parseInt(aVars[i]);
                System.out.println(candyVals[i]);
            }
            return distribute(candyVals);
        } catch (IOException e) {
            System.out.println("File Error! Could not read line from file");
        }
        return null;
    }

    public void writeNextOutput(String s) {
        try {
            wout.write(s);
            wout.write("\n");
        } catch (IOException e) {
            System.out.println("Error! Could not write to the file!");
        }
    }

    public GCJ_C(String s1, String s2) {
        try {
            rin = new BufferedReader(
                    new FileReader(s1));
            wout = new BufferedWriter(new FileWriter(s2));
            numCases = Integer.parseInt(rin.readLine());

            for(int i=1; i <= numCases; i++){
                System.out.println("case#" + i);
                String sout = getNextInput();
                sout = "Case #" + Integer.toString(i) + ":" + " " + sout;
                writeNextOutput(sout);
                System.out.println("case#" + i);
            }
            rin.close();
            wout.close();
        } catch (IOException e) {
            System.out.println("File error");
            System.exit(0);
        }
    }

    public static void main(String[] args) {/*
        if (args.length!=2) {
        System.out.println("Enter input file!");
        System.exit(0);
        }*/
        GCJ_C a = new GCJ_C("C-small-attempt1.in", "C-small-attempt1.out");
    }
}
