import java.io.*;
import java.math.BigInteger;
import java.util.*;

import static java.lang.Math.*;

public class Main extends PrintWriter {
    final Random rand = new Random(31);
    final int inf = (int) 1e9;
    final long linf = (long) 1e18;

    final static String IO = "_iotxt";

    void solve() throws IOException {
        int n = nextInt();
        int j = nextInt();
        char[] s = new char[n];
        s[0] = '1';
        s[n - 1] = '1';
        Map<String, int[]> ans = new HashMap<>();
        mw:
        while (ans.size() < j) {
            for (int i = 1; i <= n - 2; i++) {
                s[i] = (char) (rand.nextInt(2) + '0');
            }
            int[] divs = new int[9];
            df:
            for (int base = 2; base <= 10; base++) {
                BigInteger x = new BigInteger(String.valueOf(s), base);
                if (x.mod(BigInteger.valueOf(2)).compareTo(BigInteger.ZERO) == 0) {
                    divs[base - 2] = 2;
                    continue df;
                }
                for (int div = 3; div <= 100000 && BigInteger.valueOf(div).pow(2).compareTo(x) <= 0; div += 2) {
                    if (x.mod(BigInteger.valueOf(div)).compareTo(BigInteger.ZERO) == 0) {
                        divs[base - 2] = div;
                        continue df;
                    }
                }
                continue mw;
            }
            ans.put(String.valueOf(s), divs);
        }
        for (Map.Entry<String, int[]> i : ans.entrySet()) {
            print(i.getKey());
            for (int div : i.getValue()) {
                print(" ");
                print(div);
            }
            println();
        }
    }

    void run() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; i++) {
            printf("Case #%d:\n", t);
            solve();
        }
    }

    BufferedReader in;
    StringTokenizer stok;

    Main() {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    Main(String fileIn, String fileOut) throws IOException {
        super(fileOut);
        in = new BufferedReader(new FileReader(fileIn));
    }

    public static void main(String[] args) throws IOException {
        Main main;
        if ("_std".equals(IO)) {
            main = new Main();
        } else if ("_iotxt".equals(IO)) {
            main = new Main("input.txt", "output.txt");
        } else {
            main = new Main(IO + ".in", IO + ".out");
        }
        main.run();
        main.close();
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    int[] nextIntArray(int len) throws IOException {
        int[] a = new int[len];
        for (int i = 0; i < len; i++) {
            a[i] = nextInt();
        }
        return a;
    }

    int[] nextIntArraySorted(int len) throws IOException {
        int[] a = nextIntArray(len);
        shuffle(a);
        Arrays.sort(a);
        return a;
    }

    void shuffle(int[] a) {
        for (int i = 1; i < a.length; i++) {
            int x = rand.nextInt(i + 1);
            int _ = a[i];
            a[i] = a[x];
            a[x] = _;
        }
    }

    void shuffleAndSort(int[] a) {
        shuffle(a);
        Arrays.sort(a);
    }

    boolean nextPermutation(int[] p) {
        for (int a = p.length - 2; a >= 0; --a) {
            if (p[a] < p[a + 1])
                for (int b = p.length - 1; ; --b)
                    if (p[b] > p[a]) {
                        int t = p[a];
                        p[a] = p[b];
                        p[b] = t;
                        for (++a, b = p.length - 1; a < b; ++a, --b) {
                            t = p[a];
                            p[a] = p[b];
                            p[b] = t;
                        }
                        return true;
                    }
        }
        return false;
    }

    <T> List<T>[] createAdjacencyList(int n) {
        List<T>[] res = new List[n];
        for (int i = 0; i < n; i++) {
            res[i] = new ArrayList<>();
        }
        return res;
    }
}