import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main extends PrintWriter {
    final Random rand = new Random(31);
    final int inf = (int) 1e9;
    final long linf = (long) 1e18;

    final static String IO = "_iotxt";

    int n;

    boolean check(boolean[][] g, boolean[] took, boolean[] was, int x) {
        if (x == n) {
            return true;
        }
        for (int i = 0; i < n; i++) {
            if (!was[i]) {
                was[i] = true;
                boolean t1 = false;
                for (int j = 0; j < n; j++) {
                    if (!took[j] && g[i][j]) {
                        took[j] = true;
                        t1 = true;
                        if (!check(g, took, was, x + 1)) {
                            return false;
                        }
                        took[j] = false;
                    }
                }
                if (!t1) {
                    return false;
                }
                was[i] = false;
            }
        }
        return true;
    }

    int ans = inf;

    void go(boolean[][] g, int cost, int last) {
        if (check(g, new boolean[n], new boolean[n], 0)) {
            ans = min(ans, cost);
        }
        for (int i = last; i < n * n; i++) {
            int x = i / n;
            int y = i % n;
            if (!g[x][y]) {
                g[x][y] = true;
                go(g, cost + 1, i);
                g[x][y] = false;
            }
        }
    }

    void solve() throws IOException {
        n = nextInt();
        boolean[][] g = new boolean[n][n];
        for (int i = 0; i < n; i++) {
            char[] s = next().toCharArray();
            for (int j = 0; j < n; j++) {
                g[i][j] = s[j] == '1';
            }
        }

        ans = inf;
        go(g, 0, 0);
        println(ans);
    }

    void run() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; i++) {
            printf("Case #%d: ", i);
            solve();
        }
    }

    BufferedReader in;
    StringTokenizer stok;

    Main() {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    Main(String fileIn, String fileOut) throws IOException {
        super(fileOut);
        in = new BufferedReader(new FileReader(fileIn));
    }

    public static void main(String[] args) throws IOException {
        Main main;
        if ("_std".equals(IO)) {
            main = new Main();
        } else if ("_iotxt".equals(IO)) {
            main = new Main("input.txt", "output.txt");
        } else {
            main = new Main(IO + ".in", IO + ".out");
        }
        main.run();
        main.close();
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    int[] nextIntArray(int len) throws IOException {
        int[] a = new int[len];
        for (int i = 0; i < len; i++) {
            a[i] = nextInt();
        }
        return a;
    }

    int[] nextIntArraySorted(int len) throws IOException {
        int[] a = nextIntArray(len);
        shuffle(a);
        Arrays.sort(a);
        return a;
    }

    void shuffle(int[] a) {
        for (int i = 1; i < a.length; i++) {
            int x = rand.nextInt(i + 1);
            int _ = a[i];
            a[i] = a[x];
            a[x] = _;
        }
    }

    void shuffleAndSort(int[] a) {
        shuffle(a);
        Arrays.sort(a);
    }

    boolean nextPermutation(int[] p) {
        for (int a = p.length - 2; a >= 0; --a) {
            if (p[a] < p[a + 1])
                for (int b = p.length - 1; ; --b)
                    if (p[b] > p[a]) {
                        int t = p[a];
                        p[a] = p[b];
                        p[b] = t;
                        for (++a, b = p.length - 1; a < b; ++a, --b) {
                            t = p[a];
                            p[a] = p[b];
                            p[b] = t;
                        }
                        return true;
                    }
        }
        return false;
    }

    <T> List<T>[] createAdjacencyList(int n) {
        List<T>[] res = new List[n];
        for (int i = 0; i < n; i++) {
            res[i] = new ArrayList<>();
        }
        return res;
    }

    void println(Object... a) {
        for (int i = 0; i < a.length; i++) {
            if (i != 0) {
                print(" ");
            }
            print(a[i]);
        }
        println();
    }
}