import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main extends PrintWriter {
    final Random rand = new Random(31);
    final int inf = (int) 1e9;
    final long linf = (long) 1e18;

    final static String IO = "_iotxt";

    int[][] b = new int[4][4];

    boolean check(int[] a) {
        int x = a.length;
        while (x > 1) {
            for (int i = 0; i * 2 < x; i++) {
                if (a[i * 2] == a[i * 2 + 1]) {
                    return false;
                }
                a[i] = b[a[i * 2]][a[i * 2 + 1]];
            }
            x /= 2;
        }
        return true;
    }

    void solve() throws IOException {
        int n = nextInt();
        int r = nextInt();
        int p = nextInt();
        int s = nextInt();

        int[] a = new int[1 << n];
        int x = 0;
        for (int i = 0; i < p; i++) {
            a[x++] = 1;
        }

        for (int i = 0; i < r; i++) {
            a[x++] = 2;
        }

        for (int i = 0; i < s; i++) {
            a[x++] = 3;
        }

        b[1][2] = 1;
        b[1][3] = 3;
        b[2][1] = 1;
        b[2][3] = 2;
        b[3][1] = 3;
        b[3][2] = 2;

        char[] ans = " PRS".toCharArray();

        do {
            if (check(Arrays.copyOf(a, a.length))) {
                for (int i : a) {
                    print(ans[i]);
                }
                println();
                return;
            }
        } while (nextPermutation(a));
        println("IMPOSSIBLE");
    }

    void run() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; i++) {
            printf("Case #%d: ", i);
            solve();
        }
    }

    BufferedReader in;
    StringTokenizer stok;

    Main() {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    Main(String fileIn, String fileOut) throws IOException {
        super(fileOut);
        in = new BufferedReader(new FileReader(fileIn));
    }

    public static void main(String[] args) throws IOException {
        Main main;
        if ("_std".equals(IO)) {
            main = new Main();
        } else if ("_iotxt".equals(IO)) {
            main = new Main("input.txt", "output.txt");
        } else {
            main = new Main(IO + ".in", IO + ".out");
        }
        main.run();
        main.close();
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    int[] nextIntArray(int len) throws IOException {
        int[] a = new int[len];
        for (int i = 0; i < len; i++) {
            a[i] = nextInt();
        }
        return a;
    }

    int[] nextIntArraySorted(int len) throws IOException {
        int[] a = nextIntArray(len);
        shuffle(a);
        Arrays.sort(a);
        return a;
    }

    void shuffle(int[] a) {
        for (int i = 1; i < a.length; i++) {
            int x = rand.nextInt(i + 1);
            int _ = a[i];
            a[i] = a[x];
            a[x] = _;
        }
    }

    void shuffleAndSort(int[] a) {
        shuffle(a);
        Arrays.sort(a);
    }

    boolean nextPermutation(int[] p) {
        for (int a = p.length - 2; a >= 0; --a) {
            if (p[a] < p[a + 1])
                for (int b = p.length - 1; ; --b)
                    if (p[b] > p[a]) {
                        int t = p[a];
                        p[a] = p[b];
                        p[b] = t;
                        for (++a, b = p.length - 1; a < b; ++a, --b) {
                            t = p[a];
                            p[a] = p[b];
                            p[b] = t;
                        }
                        return true;
                    }
        }
        return false;
    }

    <T> List<T>[] createAdjacencyList(int n) {
        List<T>[] res = new List[n];
        for (int i = 0; i < n; i++) {
            res[i] = new ArrayList<>();
        }
        return res;
    }

    void println(Object... a) {
        for (int i = 0; i < a.length; i++) {
            if (i != 0) {
                print(" ");
            }
            print(a[i]);
        }
        println();
    }
}