import java.util.*;
import java.io.*;

import static java.lang.Math.*;

public class Main {
    FastIO io;

    // File names!!!

    void solve() throws IOException {
        int n = io.nextInt();
        List<Double> ar = new ArrayList<>(n);
        List<Double> br = new ArrayList<>(n);
        for (int i = 0; i < n; i++) {
            ar.add(io.nextDouble());
        }
        for (int i = 0; i < n; i++) {
            br.add(io.nextDouble());
        }
        ar.sort(Double::compare);
        br.sort(Double::compare);

        Deque<Double> a = new ArrayDeque<>(ar);
        Deque<Double> b = new ArrayDeque<>(br);

        int a1 = 0;
        int j = 0;
        for (int i = 0; i < n; i++) {
            while (j < n && br.get(j) < ar.get(i)) {
                a1++;
                j++;
            }
            j++;
        }

        int a2 = 0;
        for (int i = 0; i < n; i++) {
            double x1 = a.peekFirst();
            double x2 = b.peekFirst();
            if (x1 < x2) {
                b.pollLast();
                a.pollFirst();
            } else {
                b.pollFirst();
                a.pollFirst();
                a2++;
            }
        }
        io.printf("%d %d%n", a2, a1);

    }

    void run() {
        try {
            io = new FastIO("");
            int t = io.nextInt();
            for (int i = 0; i < t; i++) {
                io.printf("Case #%d: ", i + 1);
                solve();
            }
            io.close();
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(abs(-1));
        }
    }

    public static void main(String[] args) {
        try {
            Locale.setDefault(Locale.US);
        } catch (Exception ignore) {
        }
        new Main().run();
    }

    class FastIO extends PrintWriter {
        private BufferedReader in;
        private StringTokenizer stok;

        FastIO() {
            super(System.out);
            in = new BufferedReader(new InputStreamReader(System.in));
        }

        FastIO(String s) throws FileNotFoundException {
            super("".equals(s) ? "output.txt" : s + ".out");
            in = new BufferedReader(new FileReader("".equals(s) ? "input.txt" : s + ".in"));
        }

        public void close() {
            super.close();
            try {
                in.close();
            } catch (IOException ignored) {
            }
        }

        String next() {
            while (stok == null || !stok.hasMoreTokens()) {
                try {
                    stok = new StringTokenizer(in.readLine());
                } catch (Exception e) {
                    return null;
                }
            }
            return stok.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        String nextLine() {
            try {
                return in.readLine();
            } catch (IOException e) {
                return null;
            }
        }

        char[] nextCharArray() {
            return next().toCharArray();
        }

    }
}