import java.io.*;
import java.util.*;

import static java.lang.Math.*;

public class Main extends PrintWriter {
    final Random rand = new Random(31);
    final int inf = (int) 1e9;
    final long linf = (long) 1e18;

    final static String IO = "_iotxt";

    void solve1() throws IOException {
        int n = nextInt();
        int k = nextInt();
        double[] a = new double[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextDouble();
        }

        double[][][] d = new double[n + 1][k + 1][k / 2 + 1];
        d[0][0][0] = 1;

        for (int i = 1; i <= n; i++) {
            for (int j = 0; j <= k; j++) {
                for (int t = 0; t <= k / 2; t++) {
                    d[i][j][t] = d[i - 1][j][t];
                    if (j > 0) {
                        d[i][j][t] = max(d[i][j][t], d[i - 1][j - 1][t] * (1 - a[i - 1]));
                        if (t > 0) {
                            d[i][j][t] = max(d[i][j][t], d[i - 1][j - 1][t - 1] * a[i - 1]);
                        }
                    }
                    System.err.print(d[i][j][t] + " ");
                }
                System.err.println();
            }
            System.err.println();
        }

        printf("%.11f%n", d[n][k][k / 2]);
    }

    void solve() throws IOException {
        int n = nextInt();
        int k = nextInt();
        double[] a = new double[n];
        for (int i = 0; i < n; i++) {
            a[i] = nextDouble();
        }


        int[] p = new int[n];
        for (int i = 0; i < k; i++) {
            p[n - 1 - i] = 1;
        }

        double ans = 0;

        double[] b = new double[k];

        do {
            int x = 0;
            for (int i = 0; i < n; i++) {
                if (p[i] == 1) {
                    b[x++] = a[i];
                }
            }

//            System.err.println(Arrays.toString(b));

            double[][] d = new double[k + 1][k + 1];
            d[0][0] = 1;
            for (int i = 1; i <= k; i++) {
                d[i][0] = d[i - 1][0] * (1 - b[i - 1]);
                d[i][k] = d[i - 1][k - 1] * b[i - 1];
                for (int j = 1; j < k; j++) {
                    d[i][j] = d[i - 1][j] * (1 - b[i - 1]) + d[i - 1][j - 1] * b[i - 1];
                }
            }

//            for (int i = 0; i <= k; i++) {
//                for (int j = 0; j <= k; j++) {
//                    System.err.print(d[i][j] + " ");
//                }
//                System.err.println();
//            }
//
//            System.err.println();

            ans = max(ans, d[k][k / 2]);
        } while (nextPermutation(p));

        printf("%.11f%n", ans);
    }

    void run() throws IOException {
        int t = nextInt();
        for (int i = 1; i <= t; i++) {
            printf("Case #%d: ", i);
            solve();
        }
    }

    BufferedReader in;
    StringTokenizer stok;

    Main() {
        super(System.out);
        in = new BufferedReader(new InputStreamReader(System.in));
    }

    Main(String fileIn, String fileOut) throws IOException {
        super(fileOut);
        in = new BufferedReader(new FileReader(fileIn));
    }

    public static void main(String[] args) throws IOException {
        Main main;
        if ("_std".equals(IO)) {
            main = new Main();
        } else if ("_iotxt".equals(IO)) {
            main = new Main("input.txt", "output.txt");
        } else {
            main = new Main(IO + ".in", IO + ".out");
        }
        main.run();
        main.close();
    }

    String next() throws IOException {
        while (stok == null || !stok.hasMoreTokens()) {
            String s = in.readLine();
            if (s == null) {
                return null;
            }
            stok = new StringTokenizer(s);
        }
        return stok.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    int[] nextIntArray(int len) throws IOException {
        int[] a = new int[len];
        for (int i = 0; i < len; i++) {
            a[i] = nextInt();
        }
        return a;
    }

    int[] nextIntArraySorted(int len) throws IOException {
        int[] a = nextIntArray(len);
        shuffle(a);
        Arrays.sort(a);
        return a;
    }

    void shuffle(int[] a) {
        for (int i = 1; i < a.length; i++) {
            int x = rand.nextInt(i + 1);
            int _ = a[i];
            a[i] = a[x];
            a[x] = _;
        }
    }

    void shuffleAndSort(int[] a) {
        shuffle(a);
        Arrays.sort(a);
    }

    boolean nextPermutation(int[] p) {
        for (int a = p.length - 2; a >= 0; --a) {
            if (p[a] < p[a + 1])
                for (int b = p.length - 1; ; --b)
                    if (p[b] > p[a]) {
                        int t = p[a];
                        p[a] = p[b];
                        p[b] = t;
                        for (++a, b = p.length - 1; a < b; ++a, --b) {
                            t = p[a];
                            p[a] = p[b];
                            p[b] = t;
                        }
                        return true;
                    }
        }
        return false;
    }

    <T> List<T>[] createAdjacencyList(int n) {
        List<T>[] res = new List[n];
        for (int i = 0; i < n; i++) {
            res[i] = new ArrayList<>();
        }
        return res;
    }

    void println(Object... a) {
        for (int i = 0; i < a.length; i++) {
            if (i != 0) {
                print(" ");
            }
            print(a[i]);
        }
        println();
    }
}