package main;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import qualificationRound.CookieClickerAlpha;
import qualificationRound.DeceitfulWar;
import qualificationRound.MagicTric;

public class Main {

	public static void main(String[] args) throws IOException {

		String inputFilename = "D-small-attempt0.in";
		String outputFilename = "D-small-attempt0.out";

		List<String> input = Files.readAllLines(Paths.get(inputFilename),
				Charset.forName("UTF-8"));

		System.out.println(new Date().toString() + ": " + input);

		List<String> output = null;

		// output = QualificationRound_A(input);
		// output = QualificationRound_B(input);
		// output = QualificationRound_C(input);
		output = QualificationRound_D(input);

		System.out.println(new Date().toString() + ": " + output);

		Files.write(Paths.get(outputFilename), output,
				Charset.forName("UTF-8"), StandardOpenOption.CREATE,
				StandardOpenOption.WRITE);
	}

	private static List<String> QualificationRound_A(List<String> pInputVector) {

		List<String> result = new ArrayList<String>();

		int T = Integer.valueOf(pInputVector.get(0));
		int row = 1;

		for (int i = 1; i <= T; i++) {

			int rowIndex = Integer.valueOf(pInputVector.get(row));

			row += rowIndex;

			String[] row1 = pInputVector.get(row).split(" ");

			row += (5 - rowIndex);

			rowIndex = Integer.valueOf(pInputVector.get(row));

			row += rowIndex;

			String[] row2 = pInputVector.get(row).split(" ");

			row += (5 - rowIndex);

			result.add("Case #" + i + ": " + new MagicTric(row1, row2).solve());
		}

		return result;
	}

	private static List<String> QualificationRound_B(List<String> input) {

		List<String> result = new ArrayList<String>();

		int T = Integer.valueOf(input.get(0));

		for (int t = 1; t <= T; t++) {

			String[] splitted = input.get(t).split(" ");

			double c = Double.valueOf(splitted[0]);
			double f = Double.valueOf(splitted[1]);
			double x = Double.valueOf(splitted[2]);

			result.add("Case #" + t + ": "
					+ new CookieClickerAlpha(c, f, x).solve());
		}

		return result;
	}

	// private static List<String> QualificationRound_C(List<String> input) {
	//
	// List<String> result = new ArrayList<String>();
	//
	// int T = Integer.valueOf(input.get(0));
	//
	// for (int i = 1; i <= T; i++) {
	//
	// String[] splitted = input.get(i).split(" ");
	//
	// result.add("Case #"
	// + i
	// + ": "
	// + FairAndSquare.count(Long.parseLong(splitted[0]),
	// Long.parseLong(splitted[1])) + "\n");
	// }
	//
	// return result;
	// }

	private static List<String> QualificationRound_D(List<String> input) {

		List<String> result = new ArrayList<String>();

		int T = Integer.valueOf(input.get(0));

		int row = 1;

		for (int t = 1; t <= T; t++) {

			int n = Integer.valueOf(input.get(row++));

			String[] row1 = input.get(row++).split(" ");
			String[] row2 = input.get(row++).split(" ");

			result.add("Case #" + t + ": "
					+ new DeceitfulWar(n, row1, row2).solve());
		}

		return result;
	}

}