package main;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.apache.commons.io.FileUtils;

import round1b.Osmos;

public class Round1Main {

	public static void main(String[] args) throws IOException {

		String inputFilename = "A-large.in";
		String outputFilename = "A-large.out";

		List<String> input = FileUtils.readLines(new File(inputFilename));
		System.out.println(new Date().toString() + ": " + input);

		List<String> output = May2013parser(input);
		System.out.println(new Date().toString() + ": " + output);

		FileUtils.writeLines(new File(outputFilename), output);
	}

	private static List<String> May2013parser(List<String> input) {

		List<String> result = new ArrayList<String>();

		int T = Integer.valueOf(input.get(0));

		int line = 1;

		for (int i = 1; i <= T; i++) {

			String[] ANstr = input.get(line++).split(" ");
			String[] Vstr = input.get(line++).split(" ");

			int A = Integer.parseInt(ANstr[0]);
			int N = Integer.parseInt(ANstr[1]);

			int[] V = new int[N];

			for (int j = 0; j < N; j++)
				V[j] = Integer.parseInt(Vstr[j]);

			result.add("Case #" + i + ": " + new Osmos(A, N, V).calc());
		}

		return result;
	}
}