package qualificationRound;

import java.util.ArrayList;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

public class DeceitfulWar {

	private List<Double> Naomi;
	private List<Double> Ken;

	public DeceitfulWar(int n, String[] row1, String[] row2) {

		this.Naomi = new ArrayList<Double>(n);
		this.Ken = new ArrayList<Double>(n);

		for (int j = 0; j < n; j++) {
			this.Naomi.add(Double.parseDouble(row1[j]));
			this.Ken.add(Double.parseDouble(row2[j]));
		}
	}

	public String solve() {
		return decitful() + " " + regular();
	}

	private int regular() {

		SortedSet<Double> naomi = new TreeSet<Double>(Naomi);
		SortedSet<Double> ken = new TreeSet<Double>(Ken);

		int score = 0;

		while (!naomi.isEmpty()) {

			if (naomi.last() > ken.last()) {
				score++;
				ken.remove(ken.first());
			} else {
				ken.remove(getTheClosest(ken, naomi.last()));
			}

			naomi.remove(naomi.last());
		}

		return score;
	}

	private Object getTheClosest(SortedSet<Double> pKen, Double pLast) {

		for (Double element : pKen)
			if (element > pLast)
				return element;

		return pKen.last();
	}

	private int decitful() {

		SortedSet<Double> naomi = new TreeSet<Double>(Naomi);
		SortedSet<Double> ken = new TreeSet<Double>(Ken);

		while (!naomi.isEmpty()) {

			if (canNaomiWin(naomi.toArray(new Double[naomi.size()]),
					ken.toArray(new Double[ken.size()])))
				return naomi.size();

			else {
				naomi.remove(naomi.first());
				ken.remove(ken.last());
			}
		}

		return 0;
	}

	private boolean canNaomiWin(Double[] naomi, Double[] ken) {

		for (int i = 0; i < naomi.length; i++)
			if (ken[i] > naomi[i])
				return false;

		return true;
	}
}
