//
//  FileProcessor.java
//  AlienLanguage
//
//  Created by adil mezghouti on 9/2/09.
//  Copyright 2009 Northeastern University. All rights reserved.
//

import java.io.*;
import java.util.*;

public class FileProcessor {
	private int size = 0;
	private String input;
	private String output;
	private List data = new ArrayList();
	private int nbrOfLetters, nbrOfWords, nbrOfTests,nbrOfMatches=0;
	private String[] words;
	
	public FileProcessor(String input,String output){
		this.input = input;
		this.output = output;
	}
	
	public List processFile() throws Exception{
		boolean isNotEnd = true;
		int caseNumber=1;
		int wordCounter = 0;
		
		BufferedReader in = new BufferedReader(new FileReader(input));
		BufferedWriter out = new BufferedWriter(new FileWriter(output));
		//StringBuffer line = new StringBuffer();
		while(isNotEnd){
			String line = in.readLine();
			if(line != null){
				String str[] = line.split(" ");
				//System.out.println(line);
				if(str.length == 3)  {
					nbrOfLetters = Integer.parseInt(str[0]);
					nbrOfWords = Integer.parseInt(str[1]);
					nbrOfTests = Integer.parseInt(str[2]);
					words = new String[nbrOfWords];
				}else{
					if(wordCounter < nbrOfWords){
						words[wordCounter] = line;
						wordCounter++;
					}else {
						
						String result = "Case #" + caseNumber + ": " + matchPattern(words, line);
						out.write(result,0,result.length());						
						caseNumber++;
						if(caseNumber <= nbrOfTests) out.newLine();
					}
					
				}
				
			}else{
				isNotEnd = false;
			}
			
		}
		in.close();
		out.close();
		return data;
	}
	
	private int matchPattern(String[] words, String pattern){
		boolean open = false;
		StringBuffer buffer = new StringBuffer();
		int index = 0;
		String patternArr[] = new String[nbrOfLetters];
		
		for(int i=0;i < pattern.length();i++){
			if(pattern.toCharArray()[i] == '('){
				open = true;
			} else if(pattern.toCharArray()[i] == ')'){
				open = false;
				patternArr[index] = buffer.toString();
				buffer = new StringBuffer();
				index++;
			} else {
				buffer.append(pattern.toCharArray()[i]);
				if(!open){
					patternArr[index] = buffer.toString();
					buffer = new StringBuffer();
					index++;
				}
			}
		}
		
		//System.out.println("Pattern: " + Arrays.toString(patternArr));
		nbrOfMatches = 0;
		for(int i=0;i < words.length;i++){
			matchPatternByIndex(words[i], patternArr,0);
		}
		//System.out.println("Matches#: " + nbrOfMatches);
		
		return nbrOfMatches;
	}
	
	private void matchPatternByIndex(String word, String[] patterns, int index){
		if(index < nbrOfLetters){
			for(int j=0;j < patterns[index].length();j++){
				if(patterns[index].toCharArray()[j] == word.toCharArray()[index]){
					//System.out.println("index: " + index + " j:" + j + "  " + word.toCharArray()[index]);
					if(index == nbrOfLetters - 1){
						nbrOfMatches++;
					}else {
						matchPatternByIndex(word ,patterns, index + 1);
					}
					
				}
			}
		}
				

		
		
		

		
		
		
	}
	
		
}

