//
//  FileProcessor.java
//  Welcome
//
//  Created by adil mezghouti on 9/3/09.
//  Copyright 2009 Northeastern University. All rights reserved.
//

import java.io.*;
import java.util.*;

public class FileProcessor {
	private String input;
	private String output;
	private int  caseNumber, nbrOfTests;
	private long nbrOfMatches;
	private String str1;
	
	public FileProcessor(String input,String output){
		this.input = input;
		this.output = output;
		str1 = "welcome to code jam";
	}
	
	public void processFile() throws Exception{
		boolean isNotEnd = true, isFirstLine = true;
		int caseNumber=1;

		
		BufferedReader in = new BufferedReader(new FileReader(input));
		BufferedWriter out = new BufferedWriter(new FileWriter(output));

		while(isNotEnd){
			String line = in.readLine();
			if(line != null){
				if(isFirstLine){
					isFirstLine = false;
					nbrOfTests = Integer.parseInt(line);
				} else {
					nbrOfMatches = 0;
					process(str1.toCharArray(), 0, line.toCharArray(), 0);
					//System.out.println("NbrOfMatches: " + nbrOfMatches);
					String result = "Case #" + caseNumber + ": " + formatNbrOfMatches(nbrOfMatches);
					out.write(result,0,result.length());						
					caseNumber++;
					if(caseNumber <= nbrOfTests) out.newLine();
				}				
			}else{
				isNotEnd = false;
			}
			
		}
		in.close();
		out.close();
	}
	
	private void process(char[] in1, int index1, char[] in2, int index2){
		if(index1 < in1.length && index2 < in2.length){
			for(int j=index2;j < in2.length;j++){
				if(in1[index1] == in2[j]){
					if(index1 == in1.length - 1){
						nbrOfMatches++;
					} else{
						process(in1, index1 + 1, in2, j + 1);
					}
					
				}
			}
			
		}
	}
	
	private String formatNbrOfMatches(long nbr){
		String nbrString = String.valueOf(nbr);
		if(nbrString.length() > 4){
			return nbrString.substring(nbrString.length() - 4);
		} else {			
			StringBuffer result = new StringBuffer("");
			for(int i=0;i < 4 - nbrString.length();i++){
				result.append("0");
			}
			result.append(nbrString);
			return result.toString();
		}
	}
	

}
