import com.sun.xml.internal.ws.util.StringUtils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.HashMap;
import java.util.Stack;

/**
 * Created by avidProgrammer on 4/11/15.
 */
public class Djikstra {
    private static Path ipPath = Paths.get("qual_2015/C-small-attempt3.in");
    private static Path opPath = Paths.get("C-small.out");

    private static HashMap<String, String> lut;
    static {
        lut = new HashMap<>();
        lut.put("11", "1"); lut.put("1i", "i"); lut.put("1j", "j"); lut.put("1k", "k");
        lut.put("i1", "i"); lut.put("ii", "-1"); lut.put("ij", "k"); lut.put("ik", "-j");
        lut.put("j1", "j"); lut.put("ji", "-k"); lut.put("jj", "-1"); lut.put("jk", "i");
        lut.put("k1", "k"); lut.put("ki", "j"); lut.put("kj", "-i"); lut.put("kk", "-1");
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = Files.newBufferedReader(ipPath, Charset.defaultCharset());
        BufferedWriter writer = Files.newBufferedWriter(opPath, Charset.defaultCharset());

        String line, pattern, result;
        String[] split;
        int N = Integer.parseInt(reader.readLine());
        int L, X;
        for (int i = 1; i <= N; i++) {
            line = reader.readLine();
            split = line.split(" ");
            L = Integer.parseInt(split[0]);
            X = Integer.parseInt(split[1]);
            pattern = reader.readLine();
            pattern = repeatPattern(pattern, X);
            if (L > 1) {
                result = isReductionPossible(pattern);
            } else {
                result = "NO";
            }
            writer.write("Case #"+i+": "+result+"\n");
        }
        writer.close();
    }

    private static String repeatPattern(String pattern, int x) {
        String res = "";
        for (int i = 0; i < x ; i++) {
            res += pattern;
        }
        return res;
    }

    private static String isReductionPossible(String pattern) {
        if (reduce(pattern)) {
            return "YES";
        }
        return "NO";
    }

    private static boolean reduce(String pattern) {
        String[] toLookFor = new String[] {"i", "j", "k"};
        Stack<Integer> bookmarks = new Stack<>();
        int lookIdx= 0, pos = 0 ,startpos = 0;
        String start = "1";

        while(startpos < pattern.length()) {
            String next = toLookFor[lookIdx];
            if ((pos = lookFor(next, pattern.substring(startpos), start)) != -1) {
                lookIdx++;
                bookmarks.push(startpos + 1 + pos);
                startpos = bookmarks.peek();
                start = "1";
            } else {
                lookIdx--;
                if (lookIdx < 0 || bookmarks.size() < 1) {
                    return false;
                } else if (lookIdx == 0) {
                    start = "1";
                } else {
                    start = toLookFor[lookIdx];
                }
                startpos = bookmarks.pop();
            }
        }
        return (lookIdx == 3);
    }

    private static int lookFor(String target, String pattern, String start) {
        String res = "";
        int i;
        for (i = 0; i < pattern.length() ; i++) {
            res = multiply(start, "" + pattern.charAt(i));
            if (res.equals(target) && !target.equals("k")) {
                    return i;
            }
            start = res;
        }
        if (res.equals(target)) {
            return i;
        }
        return -1;
    }

    private static String multiply(String x, String y) {
        int negs = 0;
        if (x.contains("-")) {
            negs++;
            x = x.substring(1);
        }
        String res = lut.get(x+y);
        if (res.contains("-")){
            negs++;
            res = res.substring(1);
        }
        if (negs%2 ==0) {
            return res;
        }
        return "-" + res;
    }
}
