import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class StandingOvation {
    private static Path ipPath = Paths.get("qual_2015/A-large.in");
    private static Path opPath = Paths.get("A-large.out");

    public static void main(String[] args) throws IOException {
        BufferedReader reader = Files.newBufferedReader(ipPath, Charset.defaultCharset());
        BufferedWriter writer = Files.newBufferedWriter(opPath, Charset.defaultCharset());

        int N, Smax = 0;
        String line, shyVector = "";

        N = Integer.parseInt(reader.readLine());
        for (int i = 1; i <= N; i++) {
            line = reader.readLine();
            Smax = line.charAt(0) - 48;
            shyVector = line.substring(2);
            int friendsNeeded = getFriendsNeeded(Smax, shyVector);

            writer.write("Case #"+i+": " + friendsNeeded + "\n");
        }
        writer.close();
    }

    private static int getFriendsNeeded(int smax, String shyVector) {
        int friendsNeeded = 0;
        int sumSofar = 0;

        for (int i = 0; i <= smax; i++) {
            int numPeople = shyVector.charAt(i) -48;
            int numNeeded = i;
            if ((numPeople > 0) && ((sumSofar + friendsNeeded) < numNeeded)) {
                friendsNeeded += (numNeeded - sumSofar - friendsNeeded);
            }
            sumSofar += numPeople;
        }

        return friendsNeeded;
    }
}

