import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

import static java.util.Arrays.sort;

/**
 * Created by avidProgrammer on 4/11/15.
 */
public class InfinitePancakes {
    private static Path ipPath = Paths.get("qual_2015/B-small-attempt1.in");
    private static Path opPath = Paths.get("B-small.out");

    public static void main(String[] args) throws IOException {
        BufferedReader reader = Files.newBufferedReader(ipPath, Charset.defaultCharset());
        BufferedWriter writer = Files.newBufferedWriter(opPath, Charset.defaultCharset());

        int T = Integer.parseInt(reader.readLine());
        for (int i = 1; i <= T; i++) {
            int D = Integer.parseInt(reader.readLine());
            String[] P = reader.readLine().split(" ");
            int res = getMinTime(P, D);
            writer.write("Case #" + i + ": " + res + "\n");
            System.out.println("Case #" + i + ": " + res);
        }
        writer.close();
    }

    public static int getMinTime(String[] P, int D) {
        // heap with dups would have been nice
        int[] pc = new int[20];
        for (int i = 0; i < P.length; i++) {
            pc[i] = Integer.parseInt(P[i]);
        }

        sort(pc);
        int size = pc.length;
        int elapsed = 0;
        int best = pc[size-1];
        while(pc[size-1] > 2) {
            int half = pc[size-1]/2;
            pc[0] = half;
            pc[size-1] -= half;
            elapsed++;
            sort(pc);
            int newBest = elapsed + pc[size-1];
            if (newBest < best)
                best = newBest;
        }
        return best;
    }
}
