import java.io.*;
import java.util.StringTokenizer;

/**
 * Created by Andres Villegas on 2017-04-14.
 */
public class AphabetCake {
    public static void main(String[] args) throws IOException {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        PrintWriter out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)));

        int T = Integer.parseInt(in.readLine());
        StringTokenizer stk;
        int R, C;
        char[][] grid;
        for (int t = 1; t <= T; t++) {
            stk = new StringTokenizer(in.readLine());
            R = Integer.parseInt(stk.nextToken());
            C = Integer.parseInt(stk.nextToken());

            grid = new char[R][];
            for (int i = 0; i < R; i++) {
                grid[i] = in.readLine().toCharArray();
            }

            solve(grid);
            out.printf("Case #%d:\n", t);
            out.write(toString(grid));


        }
        out.close();
        in.close();
    }

    private static String toString(char[][] grid){
        StringBuilder stb = new StringBuilder();
        for (int i = 0; i < grid.length; i++) {
            for (int j = 0; j < grid[i].length; j++) {
                stb.append(grid[i][j]);
            }
            stb.append('\n');
        }
        return stb.toString();
    }

    private static void solve(char[][] grid) {
        boolean noChars = true;
        int numNoChars = 0;
        for (int i = 0; i < grid.length; i++) {
            noChars = true;
            for (int j = 0; j < grid[i].length; j++) {
                if(grid[i][j] != '?'){
                    noChars = false;
                    char c = grid[i][j];
                    int temp = j;
                    j++;
                    while(j < grid[i].length && grid[i][j] == '?'){
                        grid[i][j] = c;
                        j++;
                    }
                    j = temp;
                    j--;
                    while(j >= 0 && grid[i][j] == '?'){
                        grid[i][j] = c;
                        j--;
                    }
                    j = temp;

                    for (int k = 1; k <= numNoChars; k++) {
                        grid[i-k] = grid[i];
                    }
                    numNoChars = 0;
                }

            }
            if(noChars) {
                numNoChars++;
                if(i == grid.length-1){
                    char[] copy = grid[i-numNoChars];
                    for (int j = 0; j < numNoChars ; j++) {
                        grid[i-j] = copy;
                    }

                }

            }
        }
    }
}
