package com.practice.problems.google;

import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class MissingHeightList {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		
		int numCases = in.nextInt();
		
		for(int k = 0; k < numCases; k++){
			int n = in.nextInt();
			int listsSize = 2*n-1;
			int[][] lists = new int[listsSize][n];
			for(int i = 0; i < listsSize; i++){
				for(int j = 0; j < n; j++){
					lists[i][j] = in.nextInt();
				}
			}
			System.out.print("Case #" + (k+1) + ": ");
			System.out.println(printSpace(missingheightpaper(lists)));
		}
		
		//System.out.println(Arrays.deepToString(lists));
	}

	private static String printSpace(int[] list) {
		StringBuilder sb = new StringBuilder();
		for(int i = 0; i < list.length; i++){
			sb.append(list[i]);
			if(i != list.length-1){
				sb.append(' ');
			}
		}
		return sb.toString();
	}

	private static int[] missingheightpaper(int[][] list) {
		int n = (list.length+1)/2;
		
		int[] res = new int[n];
		
		Map<Integer, Integer> occMap = new HashMap<>();
		
		for(int i =0; i < list.length; i++){
			for(int j=0; j < n; j++){
				if(occMap.containsKey(list[i][j])){
					occMap.put(list[i][j], occMap.get(list[i][j])+1);
				}else{
					occMap.put(list[i][j], 1);
				}
			}
		}
		
		int resC = 0;
		for(Integer key : occMap.keySet()){
			if(occMap.get(key)%2 != 0){
				res[resC] = key;
				resC++;
			}
		}
		
		Arrays.sort(res);
		
		return res;
	}

}
