package codejam;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;

public class CodeJamProblem4 {

	public static void main(String[] args) {
		File file = new File("input.txt");
		try {
			Parser in = new Parser(new FileInputStream(file));
			PrintWriter out = new PrintWriter("output.txt");
			int T = in.nextInt();
			for (int i = 0; i < T; i++) {
				int x = in.nextInt(), r = in.nextInt(), c = in.nextInt();
				boolean RICHARD = false;
				if ((r * c) % x != 0) {
					RICHARD = true;
				} else {
					int min = r > c ? c : r;
					int max = r > c ? r : c;
					if (x == 4) {
						if (max == 4 && min > 2) {
							RICHARD = false;
						} else {
							RICHARD = true;
						}
					} else {
						int j = 1, k = x;
						while (j <= k) {
							if (j > min || k > max) {
								RICHARD = true;
								break;
							}
							j++;
							k--;
						}
					}
				}
				out.println("Case #" + (i + 1) + ": "
						+ (RICHARD ? "RICHARD" : "GABRIEL"));
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static int multiply(int a, int b) {
		int multi = 1;
		if ((a < 0 && b > 0) || (a > 0 && b < 0))
			multi = -1;
		a = Math.abs(a);
		b = Math.abs(b);
		if (a == 1)
			return multi * b;
		if (b == 1)
			return multi * a;
		if (a == b)
			return multi * -1;
		if (a == 'i') {
			if (b == 'j')
				return multi * 'k';
			if (b == 'k')
				return multi * 'j' * -1;
		}
		if (a == 'j') {
			if (b == 'i')
				return multi * -1 * 'k';
			if (b == 'k')
				return multi * 'i';
		}
		if (a == 'k') {
			if (b == 'j')
				return multi * -1 * 'i';
			if (b == 'i')
				return multi * 'j';
		}
		return 1;
	}

	static class Parser {
		final private int BUFFER_SIZE = 1 << 16;

		private DataInputStream din;
		private byte[] buffer;
		private int bufferPointer, bytesRead;

		public Parser(InputStream in) {
			din = new DataInputStream(in);
			buffer = new byte[BUFFER_SIZE];
			bufferPointer = bytesRead = 0;
		}

		public long nextLong() throws Exception {
			long ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = c == '-';
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
				c = read();
			} while (c > ' ');
			if (neg)
				return -ret;
			return ret;
		}

		// reads in the next string
		public String next() throws Exception {
			StringBuilder ret = new StringBuilder();
			byte c = read();
			while (c <= ' ')
				c = read();
			do {
				ret = ret.append((char) c);
				c = read();
			} while (c > ' ');
			return ret.toString();
		}

		public int nextInt() throws Exception {
			int ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = c == '-';
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
				c = read();
			} while (c > ' ');
			if (neg)
				return -ret;
			return ret;
		}

		private void fillBuffer() throws Exception {
			bytesRead = din.read(buffer, bufferPointer = 0, BUFFER_SIZE);
			if (bytesRead == -1)
				buffer[0] = -1;
		}

		private byte read() throws Exception {
			if (bufferPointer == bytesRead)
				fillBuffer();
			return buffer[bufferPointer++];
		}
	}
}
