
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.*;
public class CodeJamProblem {

	public static void main(String[] args) {
		File file = new File("input.txt");
		try {
			Parser in = new Parser(new FileInputStream(file));
			PrintWriter out = new PrintWriter("output.txt");
			int T = in.nextInt();

			for (int i = 0; i < T; i++) {
				int n = in.nextInt();
				int next = n;
				if(n == 0)
					out.println("Case #" + (i + 1) + ": INSOMNIA");
				else{
					HashSet<Integer> set = new HashSet<>();
					while(set.size()<10){
						int temp = next;
						while(temp>0){
							int d = temp%10;
							set.add(d);
							temp = temp/10;
						}
						next += n;
					}
					//System.out.println(set);
					out.println("Case #" + (i + 1) + ": " + (next-n));
				}
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	static class Parser {
		final private int BUFFER_SIZE = 1 << 16;

		private DataInputStream din;
		private byte[] buffer;
		private int bufferPointer, bytesRead;

		public Parser(InputStream in) {
			din = new DataInputStream(in);
			buffer = new byte[BUFFER_SIZE];
			bufferPointer = bytesRead = 0;
		}

		public long nextLong() throws Exception {
			long ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = c == '-';
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
				c = read();
			} while (c > ' ');
			if (neg)
				return -ret;
			return ret;
		}

		// reads in the next string
		public String next() throws Exception {
			StringBuilder ret = new StringBuilder();
			byte c = read();
			while (c <= ' ')
				c = read();
			do {
				ret = ret.append((char) c);
				c = read();
			} while (c > ' ');
			return ret.toString();
		}

		public int nextInt() throws Exception {
			int ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = c == '-';
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
				c = read();
			} while (c > ' ');
			if (neg)
				return -ret;
			return ret;
		}

		private void fillBuffer() throws Exception {
			bytesRead = din.read(buffer, bufferPointer = 0, BUFFER_SIZE);
			if (bytesRead == -1)
				buffer[0] = -1;
		}

		private byte read() throws Exception {
			if (bufferPointer == bytesRead)
				fillBuffer();
			return buffer[bufferPointer++];
		}
	}
}
