package codejam;

import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.PriorityQueue;

public class CodeJamProblem2 {

	public static void main(String[] args) {
		File file = new File("input.txt");
		try {
			Parser in = new Parser(new FileInputStream(file));
			PrintWriter out = new PrintWriter("output.txt");
			int T = in.nextInt();
			for (int i = 0; i < T; i++) {
				int l = in.nextInt(), x = in.nextInt();
				String s = in.next();
				boolean right = false;
				int current = 1;
				int[] toCompare = { 'i', 'j', 'k' };
				int index = 0, length = x * l;
				int[] xx = new int[3];

				for (int j = 0; j < length; j++) {
					current = multiply(current, s.charAt(j % l));

					if (current == toCompare[index]) {
						current = 1;
						xx[index] = j;
						index++;
						if (index == 3) {
							if (j == length - 1) {
								right = true;
							} else {
								index--;
							}
						}
					} else {
						if (j == length - 1) {
							if (index != 0) {
								index--;
								j = xx[index] + 1;
								current = toCompare[index];
							}
						}
					}
				}
				out.println("Case #" + (i + 1) + ": " + (right ? "YES" : "NO"));
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public static int multiply(int a, int b) {
		int multi = 1;
		if ((a < 0 && b > 0) || (a > 0 && b < 0))
			multi = -1;
		a = Math.abs(a);
		b = Math.abs(b);
		if (a == 1)
			return multi * b;
		if (b == 1)
			return multi * a;
		if (a == b)
			return multi * -1;
		if (a == 'i') {
			if (b == 'j')
				return multi * 'k';
			if (b == 'k')
				return multi * 'j' * -1;
		}
		if (a == 'j') {
			if (b == 'i')
				return multi * -1 * 'k';
			if (b == 'k')
				return multi * 'i';
		}
		if (a == 'k') {
			if (b == 'j')
				return multi * -1 * 'i';
			if (b == 'i')
				return multi * 'j';
		}
		return 1;
	}

	static class Parser {
		final private int BUFFER_SIZE = 1 << 16;

		private DataInputStream din;
		private byte[] buffer;
		private int bufferPointer, bytesRead;

		public Parser(InputStream in) {
			din = new DataInputStream(in);
			buffer = new byte[BUFFER_SIZE];
			bufferPointer = bytesRead = 0;
		}

		public long nextLong() throws Exception {
			long ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = c == '-';
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
				c = read();
			} while (c > ' ');
			if (neg)
				return -ret;
			return ret;
		}

		// reads in the next string
		public String next() throws Exception {
			StringBuilder ret = new StringBuilder();
			byte c = read();
			while (c <= ' ')
				c = read();
			do {
				ret = ret.append((char) c);
				c = read();
			} while (c > ' ');
			return ret.toString();
		}

		public int nextInt() throws Exception {
			int ret = 0;
			byte c = read();
			while (c <= ' ')
				c = read();
			boolean neg = c == '-';
			if (neg)
				c = read();
			do {
				ret = ret * 10 + c - '0';
				c = read();
			} while (c > ' ');
			if (neg)
				return -ret;
			return ret;
		}

		private void fillBuffer() throws Exception {
			bytesRead = din.read(buffer, bufferPointer = 0, BUFFER_SIZE);
			if (bytesRead == -1)
				buffer[0] = -1;
		}

		private byte read() throws Exception {
			if (bufferPointer == bytesRead)
				fillBuffer();
			return buffer[bufferPointer++];
		}
	}
}
