import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.InputMismatchException;
import java.util.List;


public class CodeJam3 {

	static boolean isP(BigInteger b){
		BigInteger temp=b,r=BigInteger.ZERO;
		
		while(b.compareTo(BigInteger.ZERO)>0){
			r=r.multiply(BigInteger.TEN).add(b.mod(BigInteger.TEN));
			b=b.divide(BigInteger.TEN);
		}
		return temp.equals(r);
	}
	
	public static void main(String[] args) {
		
		List<BigInteger> list=new ArrayList<BigInteger>();
		
		for (BigInteger bi = BigInteger.valueOf(1);
	            bi.compareTo(BigInteger.valueOf(100)) <0;
	            bi = bi.add(BigInteger.ONE)) {
				BigInteger bt=bi.multiply(bi);
				if(isP(bi)&&isP(bt)){
					list.add(bt);
				}
	    }
		
		
		File f = new File("input.txt");
		File o = new File("OUTPUT.txt");

		try {
			InputReaderUtil iru = new InputReaderUtil(new FileInputStream(f));
			PrintWriter out = new PrintWriter(o);
			int n = iru.readInt();
			for(int i=0;i<n;i++){
				int count=0;
				int s=iru.readInt(),e=iru.readInt();
				for(BigInteger b : list){
					
					if(b.compareTo(BigInteger.valueOf(s))>=0){
						if(b.compareTo(BigInteger.valueOf(e))>0){
							break;
						}else
							count++;
					}
				}
				
				out.println("Case #"+(i+1)+": "+count);
			}
			out.close();
		} catch (Exception e) {
			// TODO: handle exception
			e.printStackTrace();
		}
	}
}

class InputReaderUtil {

	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;
	private SpaceCharFilter filter;

	public InputReaderUtil(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public String readString() {
		char c = (char) read();
		while (isSpaceChar(c))
			c = (char) read();

		StringBuffer res = new StringBuffer();
		do {

			res.append(c);
			c = (char) read();
		} while (!isSpaceChar(c));

		return res.toString();
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();

		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public long readLong() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		long res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public boolean isSpaceChar(int c) {
		if (filter != null)
			return filter.isSpaceChar(c);
		return isWhitespace(c);
	}

	public static boolean isWhitespace(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public interface SpaceCharFilter {
		public boolean isSpaceChar(int ch);
	}
}
