package codejam2016RoundFirst1C;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.StringTokenizer;

public class Template {

	private InputStream is = System.in;

	public static void main(String[] args) throws IOException {
		new Template().init();
	}

	class Party implements Comparable<Party> {
		char ch;
		int n;

		public Party(char ch, int n) {
			this.ch = ch;
			this.n = n;
		}

		@Override
		public int compareTo(Party arg0) {
			return -(this.n - arg0.n);
		}
	}

	private ArrayList<Party> partyList;
	private int totalCount;
	ArrayList<String> strList;

	private void init() throws IOException {

		MyScanner sc = new MyScanner(is);

		int charValue = 65;
		int T = sc.nextInt();
		for (int i = 1; i <= T; i++) {

			totalCount = 0;
			partyList = new ArrayList<Party>();
			strList = new ArrayList<String>();
			int N = sc.nextInt();// number of partry
			for (int j = 0; j < N; j++) {
				int numberOfMember = sc.nextInt();
				partyList.add(new Party((char) (charValue + j), numberOfMember));
				totalCount += numberOfMember;
			}

			Collections.sort(partyList);

			while (totalCount > 0) {
				String str = "";
				int count = 0;
				Collections.sort(partyList);
				for (int j = 0; j < partyList.size(); j++) {
					Party temp = partyList.get(j);
					if (temp.n > 0) {
						temp.n = temp.n - 1;
						boolean code=true;
						if (count==1) {
							code = checkForValidity();							
						}
						if (code) {
							str = str + temp.ch;
							totalCount--;
							count++;
							if (count == 2) {
								break;
							}
						} else {
							temp.n = temp.n + 1;
						}
					}

				}
				strList.add(str);
			}

			System.out.print("Case #" + (i) + ":");
			for (int k = 0; k < strList.size(); k++) {
				System.out.print(" " + strList.get(k));
			}
			System.out.println();
		}

	}

	private boolean checkForValidity() {
		int count = totalCount - 1;
		int half = count / 2;
		for (int i = 0; i < partyList.size(); i++) {
			if (partyList.get(i).n > half) {
				return false;
			}
		}
		return true;
	}

	private class MyScanner {
		BufferedReader br;
		StringTokenizer st;

		public MyScanner(InputStream is) {
			br = new BufferedReader(new InputStreamReader(is));
			st = new StringTokenizer("");
		}

		public String next() throws IOException {
			if (st.hasMoreTokens()) {
				return st.nextToken();
			}
			st = new StringTokenizer(br.readLine());
			return next();
		}

		public long nextLong() throws IOException {
			if (st.hasMoreTokens()) {
				return Long.parseLong(st.nextToken());
			}
			st = new StringTokenizer(br.readLine());
			return nextLong();
		}

		public int nextInt() throws IOException {
			if (st.hasMoreTokens()) {
				return Integer.parseInt(st.nextToken());
			}
			st = new StringTokenizer(br.readLine());
			return nextInt();
		}

	}
}
