import java.util.*;
import static java.lang.Math.*;

public class A {
	public static void main(String[] args){
		Scanner input = new Scanner(System.in);

		//````````````````````````````````````````````````````````````````````
		// Read in how many cases there will be, and print a new line
		int T = input.nextInt();
		input.skip("\n");
		System.out.println();

		//```````````````````````````````````````````````````````````````````
		// For each line find the optimal strategy and output the 
    // expected number of keystrokes for that strategy
    for(int caseNumber = 1; caseNumber <= T; caseNumber++){
			float output = 0;

			// Read in next integer and store in A 
      //    the number of keystokes already typed
      // Read in next integer and store in B
      //    the total number of keys in the password
			int A = input.nextInt();
      int B = input.nextInt();
      int lengthA = A;

      // Read in p_i and store in an Array of size A
      float[] p = new float[lengthA];
      for (int i = 0; i < lengthA; i++) {
        p[i] = input.nextFloat();
      }
      int lengthP = p.length;

      // Find the Expected value of keystrokes "if I keep typing"
      float probAllCorrect = 1;
      for (int i = 0; i < lengthP; i++) {
        probAllCorrect *= p[i];
      }
      float keepTyping = (probAllCorrect * (B - A + 1))
        + ((1 - probAllCorrect) * (B - A + 1 + B + 1));

      // Find the Expected value of keystrokes if I press backspace
      // n times
      float[] pressBackspace = new float[A];
      for (int i = 0; i < lengthA; i++) {
        pressBackspace[i] = backspace(A , B, i + 1, p);
      }
      
      // Find the Expected value of keystrokes if I press enter right away
      float restart = 2 + B;

      // Find the minimum of Keystrokes 
      output = keepTyping;
      int length = pressBackspace.length;
      for (int i = 0; i < length; i++) {
        output = Math.min(output, pressBackspace[i]);
      }
      output = Math.min(output, restart);

			// Print translated line
			System.out.format("Case #%d: %6f\n", caseNumber, output);
		}
	}

  public static float backspace(int A, int B, int back, float[] p) {
    int keyStrokeSucceed = 2 * back + (B - A + 1);
    int keyStrokeFail = keyStrokeSucceed + B + 1;
    // probability A - back numbers are all correct
    float prob = 1;
    for (int i = 0; i < A - back; i++) {
      prob *= p[i];
    }

    float result = (prob * keyStrokeSucceed) + ((1 - prob) * keyStrokeFail);

    return result;
  }
}
