import java.io.File;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * Created by a0v0035 on 4/8/17.
 */
public class OPF {
    private static void flip(ArrayList<Integer> data, int startPosition, int flipperSize) {
        for (int i = startPosition; i < startPosition + flipperSize; i++) {
            if (data.get(i) == 0) {
                data.set(i, 1);
            } else {
                data.set(i, 0);
            }
        }
    }

    private static int findPlaceToFlip(ArrayList<Integer> data, int start, int flipperSize) {
        for (int i = start; i < data.size() - flipperSize+1; i++) {
            if (data.get(i) == 0) {
                return i;
            }
        }
        return -1;
    }

    private static boolean checkResult(ArrayList<Integer> data) {
        for (int i = 0; i < data.size(); i++) {
            if (data.get(i) == 0) return false;
        }
        return true;
    }

    private static ArrayList<Integer> parseString(String s) {
        ArrayList<Integer> data = new ArrayList<>();
        for (int i = s.length() - 1; i >= 0; i--) {
            if (s.charAt(i) == 45) {
                data.add(0);
            } else {
                data.add(1);
            }
        }
        return data;
    }

    private static String processString(String s, int fSize) {
        int toStart = 0;
        int count = 0;
        ArrayList<Integer> x = parseString(s);

        while (true) {
            toStart = findPlaceToFlip(x, toStart, fSize);
            if (toStart == -1) {
                break;
            }
            else {
                flip(x, toStart, fSize);
                count++;
            }
        }

        if (checkResult(x)) {
            return Integer.toString(count);
        } else {
            return "IMPOSSIBLE";
        }
    }

    public static void main(String[] args) throws Exception{

        File file = new File("/Volumes/Macintosh HD/Users/a0v0035/Downloads/A-small-attempt0.in");
        Scanner input = new Scanner(file);
        int totalCases = input.nextInt();
        for (int i = 1; i < totalCases + 1; i++) {
            String stringToProcess = input.next();
            int fSizeToProcesss = input.nextInt();
            System.out.println("Case #"+i+": "+processString(stringToProcess, fSizeToProcesss));
        }
    }
}
