import java.io.File;
import java.io.FileNotFoundException;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class Watershed {

  Sink[][] sinks;

  Watershed(int height, int width) {
    sinks = new Sink[height][width];
  }

  public static void main(String[] args) throws FileNotFoundException {
    int count = 0;
    Scanner scanner;

    scanner = new Scanner(new File("B-small-attempt0.in"));


    int numMaps = Integer.parseInt(scanner.next());


    for (int numCase = 0; numCase < numMaps; numCase++) {


      int height = Integer.parseInt(scanner.next());
      int width = Integer.parseInt(scanner.next());

      Watershed watershed = new Watershed(height, width);

      int matrix[][] = new int[height][width];
      getMatrix(scanner, height, width, matrix);
      watershed.updateSinks(height, width, matrix);

      watershed.setLabels(height, width);

      watershed.printLabel(numCase, height, width);


    }

  }

  private void setLabels(int height, int width) {
    char label = 'a';
    for (int a = 0; a < height; a++) {
      for (int b = 0; b < width; b++) {
        if (sinks[a][b].getlabel() == ' ') {
          sinks[a][b].setLabel(label);
          label++;
        }
      }
    }
  }

  private void updateSinks(int height, int width, int[][] matrix) {
    for (int a = 0; a < height; a++) {
      for (int b = 0; b < width; b++) {
        int smallest = matrix[a][b];
        int sink_x = a;
        int sink_y = b;
        int k = a - 1;
        if (k >= 0) {
          if (matrix[k][b] < smallest) {
            smallest = matrix[k][b];
            sink_x = k;
            sink_y = b;
          }
        }

        k = b - 1;

        if (k >= 0) {
          if (matrix[a][k] < smallest) {
            smallest = matrix[a][k];
            sink_x = a;
            sink_y = k;
          }
        }

        k = b + 1;
        if (k < width) {
          if (matrix[a][k] < smallest) {
            smallest = matrix[a][k];
            sink_x = a;
            sink_y = k;
          }
        }

        k = a + 1;

        if (k < height) {
          if (matrix[k][b] < smallest) {
            smallest = matrix[k][b];
            sink_x = k;
            sink_y = b;
          }
        }

        if (sinks[sink_x][sink_y] == null) {
          sinks[sink_x][sink_y] = new Sink();
          sinks[sink_x][sink_y].addSource(sink_x, sink_y);
        }

        if (a != sink_x || b != sink_y) {
          if (sinks[a][b] == null) {
            sinks[sink_x][sink_y].addSource(a, b);
          } else {
            for (Sink.Source source : sinks[a][b].getSources()) {
              sinks[source.getx()][source.gety()] = sinks[sink_x][sink_y];
              sinks[sink_x][sink_y].addSource(source.getx(), source.gety());
            }
          }
          sinks[a][b] = sinks[sink_x][sink_y];
        }

      }

    }
  }

  private static void getMatrix(Scanner scanner, int height, int width,
                                int[][] matrix) {
    for (int i = 0; i < height; i++) {
      for (int j = 0; j < width; j++) {
        matrix[i][j] = Integer.parseInt(scanner.next());
      }
    }
  }

  private void printLabel(int numCase, int height, int width) {
    System.out.println("Case #" + (numCase + 1) + ": ");
    for (int i = 0; i < height; i++) {
      for (int j = 0; j < width; j++) {
        System.out.print(sinks[i][j].getlabel() + " ");
      }
      System.out.println();
    }


  }

  public class Sink {
    char label = ' ';
    List<Source> sources;

    Sink() {
      sources = new ArrayList<Source>();
    }

    public void addSource(int x, int y) {
      sources.add(new Source(x, y));
    }

    public void addAllSources(List<Source> newSources) {
      sources.addAll(newSources);
    }

    public void setLabel(char c) {
      label = c;
    }

    public List<Source> getSources() {
      return sources;
    }

    public char getlabel() {
      return label;
    }

    public class Source {
      int x;
      int y;

      Source(int x, int y) {
        this.x = x;
        this.y = y;
      }

      public int getx() {
        return x;
      }

      public int gety() {
        return y;
      }
    }

  }
}


