package cj_14_context;

import java.io.*;
import java.math.RoundingMode;
import java.text.NumberFormat;
import java.util.*;

public class Problem {

    final static String PROBLEM_NAME = "FairAndSquare";
    final static String WORK_DIR = "E:\\CodeJam\\Problems\\" + PROBLEM_NAME + "\\";
    final static String FILE_NAME = "C-small-attempt0";
    
    private final static double EPSILON = 1e-6;

    boolean IsPalindrom(double dIn){
    	
    	NumberFormat nf = NumberFormat.getInstance();
    	nf.setRoundingMode(RoundingMode.DOWN);
    	nf.setMaximumFractionDigits(0);
    	String sIn = nf.format(dIn);

    	return IsPalindrom(sIn);
    }
    
    boolean IsPalindrom(String sIn){

    	char[] word = sIn.toCharArray();
    	
        int i1 = 0;
        int i2 = word.length - 1;
        while (i2 > i1) {
            if (word[i1] != word[i2]) {
                return false;
            }
            ++i1;
            --i2;
        }
        return true;
    }
    
    boolean IsDoubleEqual(double a, double b){
        return a == b ? true : Math.abs(a - b) < EPSILON;
    }
    
    void solve(Scanner sc, PrintWriter pw) {
        
    	Double dStart = sc.nextDouble();
    	Double dEnd = sc.nextDouble();
    	
    	int iCount = 0;
        
    	for (double d = dStart; d <= dEnd; d=d+1) {
			
    		boolean bIsPalin = IsPalindrom(d);
    		boolean bIsSqrtWholeNum = false;
    		boolean bIsFairAndSquare = false;
    		
    		// System.out.println("	IsPalindrome [" +bIsPalin+ "] Num [" + d + "] Sqrt [" + Math.sqrt(d) + "]"); 

    		// Is Number a palindrome
    		if (bIsPalin) {
    			
    			double dSqRt = Math.sqrt(d);
    			
    			NumberFormat nf = NumberFormat.getInstance();
    	    	nf.setRoundingMode(RoundingMode.DOWN);
    	    	nf.setMaximumFractionDigits(0);
    	    	
    	    	String sSqRt = nf.format(dSqRt);
    	    	    			
    			// Is square root a whole number
    	    	bIsSqrtWholeNum = IsDoubleEqual(dSqRt, Double.parseDouble(sSqRt)); 
    	    	
    	    	if (bIsSqrtWholeNum) {
    	    		bIsFairAndSquare = IsPalindrom(sSqRt); // Is sqrt a palindrome
    	    		
    	    		if (bIsFairAndSquare) {
						iCount++;
					}
				}
			}
		}

    	System.out.println("	Count = " + iCount);
        pw.println(iCount);
    }
    
	public static void main(String[] args) {

		Scanner scFileScanner = null;
		PrintWriter pwFileWriter = null;
		try {
			scFileScanner = new Scanner(new FileReader(WORK_DIR + "" + FILE_NAME + ".in"));
			pwFileWriter = new PrintWriter(new FileWriter(WORK_DIR + "" + FILE_NAME + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
		if ((scFileScanner == null) || (pwFileWriter == null)) {
			System.exit(1);
		}
		
        int iCaseCount = scFileScanner.nextInt();
        scFileScanner.nextLine();
        for (int iCurrentCaseNum = 1; iCurrentCaseNum <= iCaseCount; iCurrentCaseNum++) {
            System.out.println("\nProcessing test case " + (iCurrentCaseNum));
            pwFileWriter.print("Case #" + (iCurrentCaseNum) + ": ");
            new Problem().solve(scFileScanner, pwFileWriter);
        }
        
        pwFileWriter.flush();
        pwFileWriter.close();
        scFileScanner.close();
	}
}
