package cj_12_context;

import java.io.*;
import java.util.*;

public class Problem {

    final static String PROBLEM_NAME = "Tic-Tac-Toe-Tomek";
    final static String WORK_DIR = "E:\\CodeJam\\Problems\\" + PROBLEM_NAME + "\\";
    final static String FILE_NAME = "A-large";
    
    final static String XWON = "X won";
    final static String OWON = "O won";
    final static String DRAW = "Draw";
    final static String NOTCMP = "Game has not completed";

    boolean IsSuccess(String sLine, char cPlayer)
    {
    	String sLineToProcess = sLine.replace('T', cPlayer);
    	if (sLineToProcess.equals("" + cPlayer + "" + cPlayer + "" + cPlayer + "" + cPlayer + "")) {
			return true;
		}
    	return false;
    }
    
    void solve(Scanner sc, PrintWriter pw) {
        String sLineToProcess1 = sc.nextLine().trim();
        String sLineToProcess2 = sc.nextLine().trim();
        String sLineToProcess3 = sc.nextLine().trim();
        String sLineToProcess4 = sc.nextLine().trim();
        
        String[] saInput = new String[]{sLineToProcess1, sLineToProcess2, sLineToProcess3, sLineToProcess4};
        
        System.out.println("Processing Line Content : [" + sLineToProcess1 + "]");
        System.out.println("Processing Line Content : [" + sLineToProcess2 + "]");
        System.out.println("Processing Line Content : [" + sLineToProcess3 + "]");
        System.out.println("Processing Line Content : [" + sLineToProcess4 + "]");
        
        // Horizontal Lines
        for (int i = 0; i < 4; i++) {
        	if (IsSuccess(saInput[i], 'X')) {
        		pw.println(XWON);
        		System.out.println("-- Horizontal Match - X Won");
        		return;
			}
        	if (IsSuccess(saInput[i], 'O')) {
        		pw.println(OWON);
        		System.out.println("-- Horizontal Match - O Won");
        		return;
			}
		}
        
        // Vertical Lines
        for (int i = 0; i < 4; i++) {
			String sInpLine = "" + saInput[0].charAt(i) + "" + saInput[1].charAt(i) + "" + saInput[2].charAt(i) + "" + saInput[3].charAt(i);
			if (IsSuccess(sInpLine, 'X')) {
        		pw.println(XWON);
        		System.out.println("-- Vertical Match - X Won");
        		return;
			}
        	if (IsSuccess(sInpLine, 'O')) {
        		pw.println(OWON);
        		System.out.println("-- Vertical Match - O Won");
        		return;
			}
		}
        
        // Diagonal Lines
        String sVLine1 = "" + saInput[0].charAt(0) + "" + saInput[1].charAt(1) + "" + saInput[2].charAt(2) + "" + saInput[3].charAt(3);
        String sVLine2 = "" + saInput[0].charAt(3) + "" + saInput[1].charAt(2) + "" + saInput[2].charAt(1) + "" + saInput[3].charAt(0);
		if (IsSuccess(sVLine1, 'X')) {
    		pw.println(XWON);
    		System.out.println("-- Diagonal Match 1 - X Won");
    		return;
		}
    	if (IsSuccess(sVLine1, 'O')) {
    		pw.println(OWON);
    		System.out.println("-- Diagonal Match 1 - O Won");
    		return;
		}
    	if (IsSuccess(sVLine2, 'X')) {
    		pw.println(XWON);
    		System.out.println("-- Diagonal Match 2 - X Won");
    		return;
		}
    	if (IsSuccess(sVLine2, 'O')) {
    		pw.println(OWON);
    		System.out.println("-- Diagonal Match 2 - O Won");
    		return;
		}
        
    	// Reaching this means game is either draw or not completed
    	boolean bIsCompleted = true;
    	for (int i = 0; i < saInput.length; i++) {
			if (saInput[i].contains(".")) {
				bIsCompleted = false;
				break;
			}
		}
    	
    	if (bIsCompleted) {
    		pw.println(DRAW);
    		System.out.println("-- Draw");
    		return;
		}
    	
        pw.println(NOTCMP);
        System.out.println("-- Not Completed");
    }
    
	public static void main(String[] args) {

		Scanner scFileScanner = null;
		PrintWriter pwFileWriter = null;
		try {
			scFileScanner = new Scanner(new FileReader(WORK_DIR + "" + FILE_NAME + ".in"));
			pwFileWriter = new PrintWriter(new FileWriter(WORK_DIR + "" + FILE_NAME + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
		if ((scFileScanner == null) || (pwFileWriter == null)) {
			System.exit(1);
		}
		
        int iCaseCount = scFileScanner.nextInt();
        scFileScanner.nextLine();
        for (int iCurrentCaseNum = 1; iCurrentCaseNum <= iCaseCount; iCurrentCaseNum++) {
            System.out.println("\nProcessing test case " + (iCurrentCaseNum));
            pwFileWriter.print("Case #" + (iCurrentCaseNum) + ": ");
            new Problem().solve(scFileScanner, pwFileWriter);
            
            if (iCurrentCaseNum != iCaseCount) {
            	scFileScanner.nextLine();
			}
        }
        
        pwFileWriter.flush();
        pwFileWriter.close();
        scFileScanner.close();
	}
}
