package cj_13_context;

import java.io.*;
import java.util.*;

public class Problem {

    final static String PROBLEM_NAME = "Lawnmower";
    final static String WORK_DIR = "E:\\CodeJam\\Problems\\" + PROBLEM_NAME + "\\";
    final static String FILE_NAME = "B-large";

    boolean IsLinePossible(String sIn, String sLine)
    { 	
    	int iIn = Integer.parseInt(sIn);
    	for (int i = 0; i < sLine.length(); i++) {
    		int iCurr = Integer.parseInt("" + sLine.charAt(i));
			if (iCurr > iIn) {
				return false;
			}
		}
    	
    	return true;
    }
    
    void solve(Scanner sc, PrintWriter pw) {
    	
    	int iN = sc.nextInt();
    	int iM = sc.nextInt();
    	sc.nextLine();
    	
    	String[] saInput = new String[iN];
    	
    	for (int i = 0; i < iN; i++) {
    		String sLineToProcess = sc.nextLine().trim().replaceAll(" ", "");
    		saInput[i] = sLineToProcess;
    		System.out.println(sLineToProcess);
		}
    	
    	System.out.println("-- N " + iN + " M " + iM + " Lines [" + Arrays.toString(saInput) + "]");
        
    	boolean bIsPatternPossible = true;
        // for each int, check no higher is present in at least one.
        for (int i = 0; i < iN && bIsPatternPossible; i++) {
			for (int j = 0; j < iM && bIsPatternPossible; j++) {
				
				char cIn = saInput[i].charAt(j);
				
				// Check Horizontally
				bIsPatternPossible = IsLinePossible("" + cIn, saInput[i]);
				System.out.println("	Horizontal check for IsLinePossible char [" + cIn + " Line [" + saInput[i] + "] Returned [" + bIsPatternPossible + "]");
				
				if (!bIsPatternPossible) { // If horizontally impossible
					
					// Check Vertically
					StringBuffer sb = new StringBuffer();
					for (int k = 0; k < iN; k++) {
						sb.append(saInput[k].charAt(j));
					}
					
					bIsPatternPossible = IsLinePossible("" + cIn, sb.toString());
					System.out.println("	Vertical check for IsLinePossible char [" + cIn + " Line [" + sb.toString() + "] Returned [" + bIsPatternPossible + "]");
				}
			}
		}

        if (bIsPatternPossible) {
			pw.println("YES");
		}
        else {
        	pw.println("NO");
        }
 
    }
    
	public static void main(String[] args) {

		Scanner scFileScanner = null;
		PrintWriter pwFileWriter = null;
		try {
			scFileScanner = new Scanner(new FileReader(WORK_DIR + "" + FILE_NAME + ".in"));
			pwFileWriter = new PrintWriter(new FileWriter(WORK_DIR + "" + FILE_NAME + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
		if ((scFileScanner == null) || (pwFileWriter == null)) {
			System.exit(1);
		}
		
        int iCaseCount = scFileScanner.nextInt();
        scFileScanner.nextLine();
        for (int iCurrentCaseNum = 1; iCurrentCaseNum <= iCaseCount; iCurrentCaseNum++) {
            System.out.println("\nProcessing test case " + (iCurrentCaseNum));
            pwFileWriter.print("Case #" + (iCurrentCaseNum) + ": ");
            new Problem().solve(scFileScanner, pwFileWriter);
        }
        
        pwFileWriter.flush();
        pwFileWriter.close();
        scFileScanner.close();
	}
}
