package cj_16_contest;

import java.io.*;
import java.util.*;

public class Problem {

    // final static String PROBLEM_NAME = "ReverseWords";
    // final static String WORK_DIR = "E:\\CodeJam\\Problems\\" + PROBLEM_NAME + "\\";
	final static String WORK_DIR = "E:\\CodeJam\\ContestDownloads\\";
    final static String FILE_NAME = "A-small-attempt0";
    private final static double EPSILON = 1e-6;
    
    boolean IsDoubleEqual(double a, double b){
        return a == b ? true : Math.abs(a - b) < EPSILON;
    }
    
    void solve(Scanner sc, PrintWriter pw) {
    	
    	double dRadius = sc.nextDouble();
    	double dPaintVol = sc.nextDouble();
        
        System.out.println("Processing Line Content : [" + dRadius + "] [" + dPaintVol + "]");
        
        // a*a - b*b = (a+b)(a-b)
        // a - b = 1 always
        double dPaintRequiredForFirst = (dRadius*2)+1; 
        
        System.out.println("Paint For First " + dPaintRequiredForFirst); 

        double dPaintForPrevCircle = dPaintRequiredForFirst;
        double dPaintRemaining = dPaintVol - dPaintForPrevCircle;
        int iCount = 0;
        
        while ((dPaintRemaining > 0)||(IsDoubleEqual(dPaintRemaining, 0))) {
			
        	iCount++;

        	dPaintForPrevCircle+=4;
        	dPaintRemaining -= dPaintForPrevCircle;
        	
		}

        // System.out.println("Circles " + iCount); 

        pw.println(iCount);
    }
    
	public static void main(String[] args) {

		Scanner scFileScanner = null;
		PrintWriter pwFileWriter = null;
		try {
			scFileScanner = new Scanner(new FileReader(WORK_DIR + "" + FILE_NAME + ".in"));
			pwFileWriter = new PrintWriter(new FileWriter(WORK_DIR + "" + FILE_NAME + ".out"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
        
		if ((scFileScanner == null) || (pwFileWriter == null)) {
			System.exit(1);
		}
		
        int iCaseCount = scFileScanner.nextInt();
        scFileScanner.nextLine();
        for (int iCurrentCaseNum = 1; iCurrentCaseNum <= iCaseCount; iCurrentCaseNum++) {
            System.out.println("\nProcessing test case " + (iCurrentCaseNum));
            pwFileWriter.print("Case #" + (iCurrentCaseNum) + ": ");
            new Problem().solve(scFileScanner, pwFileWriter);
        }
        
        pwFileWriter.flush();
        pwFileWriter.close();
        scFileScanner.close();
	}
}
