import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;

public class C {
	
	public static Primes primes;
	
	public static void main(String[] args) throws IOException {
		String dataFile = "./data/C-small-attempt1.in";
		String outFile = "./out/C.out";
		BufferedReader reader = new BufferedReader(new FileReader(dataFile));
		PrintWriter printer = new PrintWriter(outFile, "UTF-8");
		
		primes = new Primes();
		
		String line = reader.readLine();
		
		int nb_problem = Integer.parseInt(line);
		for (int i = 0; i < nb_problem; ++i) {
			line = reader.readLine();
			String[] elements = line.split(" ");
			int length = Integer.parseInt(elements[0]);
			int quantity = Integer.parseInt(elements[1]);
			long[][] res = problemC(length, quantity);
			printer.println("Case #1:");
			
			for (int j = 0; j < res.length; ++j) {
				String output = "";
				output = output +toBinaryString(res[j][0]);
				for (int k = 1; k < res[j].length; ++k)
					output = output+" "+res[j][k];
				System.out.println(output);
				printer.println(output);
			}
			
			
			//System.out.println("Case #"+(i+1)+": "+res);
			//printer.println("Case #"+(i+1)+": "+res);
		}
		
		reader.close();
		printer.close();
		System.out.println("Done");
	}
	
	public static long[][] problemC(int length, int quantity) {
		long[][] res = new long[quantity][10];
		
		int iter = 0;
		long up = oddPowTwo(length, false);
		long down = oddPowTwo(length-1, true);
		for (long n = up; n >= down && iter < quantity; n = n - 2) {
			ArrayList<Integer> bin = toBinary(n);
			for (int b = 2; b <= 10; ++b) {
				
				long base = toBase(bin, b);
				//System.out.println(base);
				if (primes.isPrime(base)) {
					break;
				}
				else {
					//System.out.println(base);
					res[iter][0] = n;
					long pr = 2L;
					while (base % pr != 0L && pr <= Math.sqrt(base)) {
						//System.out.println(pr);
						pr = primes.nextPrime(pr);
					}
					if (pr > Math.sqrt(base))
						break;
					if (base % pr == 0) {
						//System.out.println(base + " "+ pr);
						res[iter][b-1] = pr;
					}
					else break;
					if (b == 10)
						++iter;
				}
			}
		}
		
		return res;
	}
	
	public static long toBase(ArrayList<Integer> bin, int b) {
		long res = 0L;
		for (int i = bin.size() - 1; i >= 0; --i) {
			if (bin.get(i) == 1)
				res += pow(b,bin.size()-1-i);
		}
		return res;
		
	}
	
	public static ArrayList<Integer> toBinary(long n) {
		ArrayList<Integer> bin = new ArrayList<Integer>();
		while (n > 0) {
			if (n % 2L == 0)
				bin.add(0);
			else
				bin.add(1);
			n = n / 2L;
		}
		Collections.reverse(bin);
		return bin;
	}
	
	public static String toBinaryString(long n) {
		String res = "";
		while (n > 0L) {
			if (n % 2L == 0L)
				res = "0"+res;
			else
				res = "1"+res;
			n = n / 2L;
		}
		return res;
	}
	
	public static long oddPowTwo(int length, boolean minmax) {
		long res = 1L;
		for (int i = 0; i < length; ++i)
			res = 2 * res;
		
		if (res % 2L == 0L) {
			if (minmax)
				res++;
			else
				res--;
		}
		return res;
	}
	
	public static long pow(long n, int a)
	{
		assert (a >= 0);
		
		if (a == 0)
			return 1;
		if (a == 1)
			return n;
			
		long buf = pow(n,a/2);
		if (a % 2 == 0)	
			return buf * buf;
		else
			return buf * buf * n;
	}
}

