package Task1_3;

import java.io.*;

/**
 * created by Alex Ivanov on 4/9/16.
 */
public class JaminCoins {

    private String[] jamCoins;
    private String[][] output;

    private boolean isPrime(long n) {
        if (n < 2) return false;
        if (n == 2 || n == 3) return true;
        if (n % 2 == 0 || n % 3 == 0) return false;
        long sqrtN = (long) Math.sqrt(n) + 1;
        for (long i = 6L; i <= sqrtN; i += 6) {
            if (n % (i - 1) == 0 || n % (i + 1) == 0) return false;
        }
        return true;
    }

    private long getSmallestDivider(long num) {
        for (long i = 3; i < num; i++) {
            if (num % i == 0) {
                return i;
            }
        }
        return -1;
    }

    private void generateNumberWithSize(int size, int count) {
        int generatedNumbers = 0;
        int startNumber = (int) (Math.pow(2, size - 1) + 1);
        for (int i = startNumber; i < (int) (Math.pow(2, size)); i += 2) {
            String number = Integer.toBinaryString(i);
            boolean isJamCoin = checkNumberForAllBases(number);
            if (isJamCoin) {
                boolean hasGenerated = generateDividers(number, generatedNumbers);
                if (hasGenerated) {
                    jamCoins[generatedNumbers] = number;
                    generatedNumbers++;
                    System.out.println("GENERATED# " + generatedNumbers);
                    if (generatedNumbers == count) {
                        return;
                    }
                }
            }
        }
    }

    private boolean generateDividers(String number, int pos) {
        String[] num = new String[9];
        for (int i = 2; i <= 10; i++) {
            long divider = getSmallestDivider(getNumberForBase(number, i));
            if (divider == -1) {
                return false;
            }
            num[i - 2] = String.valueOf(divider);
        }
        output[pos] = num;
        return true;
    }

    private boolean checkNumberForAllBases(String num) {
        for (int i = 2; i <= 10; i++) {
            if (isPrime(getNumberForBase(num, i))) {
                return false;
            }
        }
        return true;
    }

    private long getNumberForBase(String in, int base) {
        String[] inArr = in.split("");
        long res = 0;
        for (int i = 0, j = inArr.length - 1; i < inArr.length; i++, j--) {
            res += Integer.parseInt(inArr[j]) * Math.pow(base, i);
        }
        return res;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        JaminCoins main = new JaminCoins();
        int count = Integer.parseInt(br.readLine());
        for (int i = 0; i < count; i++) {
            String line = br.readLine();
            String[] arr = line.split(" ");
            int N = Integer.parseInt(arr[0]);
            int J = Integer.parseInt(arr[1]);
            main.jamCoins = new String[J];
            main.output = new String[J][9];
            main.generateNumberWithSize(N, J);
        }
        br.close();
        main.output();
    }

    private void output() {
        try {
            File logFile = new File("res1_3.txt");

            BufferedWriter writer = new BufferedWriter(new FileWriter(logFile));
            writer.write("Case #1:\n");
            System.out.print("Case #1:\n");
            for (int i = 0; i < output.length; i++) {
                String res = generateOutPut(i);
                System.out.print(res);
                writer.write(res);
            }

            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private String generateOutPut(int n) {
        String out = jamCoins[n];
        for (int i = 0; i < 9; i++) {
            out += " " + output[n][i];
        }
        out += "\n";
        return out;
    }
}
