package Task2c_3;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * created by Alex Ivanov on 5/8/16.
 */
public class CheckMyStyle {

    static int[] jackets;
    static int[] pants;
    static int[] shirts;
    static int[] jailMoves;
    static List<List<Dress>> output;

    public static void main(String... args) {
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
            int count = Integer.parseInt(br.readLine());
            jackets = new int[count];
            pants = new int[count];
            shirts = new int[count];
            jailMoves = new int[count];
            output = new ArrayList<List<Dress>>();
            for (int i = 0; i < count; i++) {
                String[] data = br.readLine().split(" ");
                jackets[i] = Integer.parseInt(data[0]);
                pants[i] = Integer.parseInt(data[1]);
                shirts[i] = Integer.parseInt(data[2]);
                jailMoves[i] = Integer.parseInt(data[3]);
                output.add(i, generateDresses(jackets[i], pants[i], shirts[i], jailMoves[i]));
            }

            output();

            br.close();

        } catch (Exception e) {
            System.out.print("Program terminated" + e.toString());
        }
    }

    private static List<Dress> generateDresses(int jackets, int pants, int shirts, int jailMoves) {
        List<Dress> dresses = new ArrayList<Dress>();
        for (int j = jackets; j > 0; j--) {
            for (int p = pants; p > 0; p--) {
                for (int s = shirts; s > 0; s--) {
                    Dress generated = new Dress(j, p, s);
                    if (canUse(generated, dresses, jailMoves)) {
                        dresses.add(generated);
                    }
                }
            }
        }
        return dresses;
    }

    public static boolean canUse(Dress dress, List<Dress> dresses, int toJailCount) {
        if (dresses.contains(dress)) {
            return false;
        }
        int jpCount = 0;
        int jsCount = 0;
        int psCount = 0;
        for (Dress dress1 : dresses) {
            if (dress.equalJacketAndPants(dress1)) {
                jpCount++;
            }
            if (dress.equalJacketAndShirt(dress1)) {
                jsCount++;
            }
            if (dress.equalShirtAndPants(dress1)) {
                psCount++;
            }
        }
        return jsCount + jpCount + psCount < toJailCount;
    }

    private static void output() {
        try {
            File logFile = new File("res2c_3.txt");

            BufferedWriter writer = new BufferedWriter(new FileWriter(logFile));
            int counter = 1;
            for (List<Dress> out : output) {
                System.out.print("Case #" + counter + ": " + out.size() + "\n");
                writer.write("Case #" + counter + ": " + out.size() + "\n");
                for (Dress str : out) {
                    System.out.print(str.toString());
                    writer.write(str.toString());
                }
                counter++;
            }

            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private static class Dress {
        int jacket;
        int pants;
        int shirt;

        public Dress(int jacket, int pants, int shirt) {
            this.jacket = jacket;
            this.pants = pants;
            this.shirt = shirt;
        }

        public boolean equalJacketAndPants(Dress dress) {
            return this.jacket == dress.jacket && this.pants == dress.pants;
        }

        public boolean equalJacketAndShirt(Dress dress) {
            return this.jacket == dress.jacket && this.shirt == dress.shirt;
        }

        public boolean equalShirtAndPants(Dress dress) {
            return this.shirt == dress.shirt && this.pants == dress.pants;
        }

        @Override
        public boolean equals(Object obj) {
            if (obj instanceof Dress) {
                Dress dress = (Dress) obj;
                return this.shirt == dress.shirt && this.pants == dress.pants && this.jacket == dress.jacket;
            } else {
                return super.equals(obj);
            }
        }

        @Override
        public String toString() {
            return String.format("%1$d %2$d %3$d\n", jacket, pants, shirt);
        }
    }
}
