package Task2c_1;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * created by Alex Ivanov on 5/8/16.
 */
public class BurnTheSenator {

    private static char[] alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
    private static int[][] input;
    private static String[] output;

    public static void main(String... args) {
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
            int count = Integer.parseInt(br.readLine());
            input = new int[count][];
            output = new String[count];
            for (int i = 0; i < count; i++) {
                int size = Integer.parseInt(br.readLine());
                int[] partiesCount = new int[size];
                String[] counts = br.readLine().split(" ");
                for (int j = 0; j < size; j++) {
                    partiesCount[j] = Integer.parseInt(counts[j]);
                }
                input[i] = partiesCount;
            }

            for (int i = 0; i < count; i++) {
                output[i] = evacuateSenators(input[i]);
            }

            output();

            br.close();

        } catch (Exception e) {
            System.out.print("Program terminated" + e.toString());
        }
    }

    private static String evacuateSenators(int[] senators) {
        String result = "";
        while (getLeftSenatorsCount(senators) != 0) {
            do {
                if (getLeftSenatorsCount(senators) == 2) {
                    int party = getBiggestParty(senators, new ArrayList<Integer>());
                    result += alphabet[party];
                    senators[party] -= 1;
                    party = getBiggestParty(senators, new ArrayList<Integer>());
                    result += alphabet[party];
                    senators[party] -= 1;
                } else {
                    List<Integer> except = new ArrayList<Integer>();
                    int party1 = getBiggestParty(senators, except);
                    senators[party1] -= 1;
                    boolean causedByFirst = !checkMajority(senators);
                    if (getLeftSenatorsCount(senators) == 2) {
                        while (!checkMajority(senators)) {
                            senators[party1] += 1;
                            except.add(party1);
                            party1 = getBiggestParty(senators, except);
                            senators[party1] -= 1;
                        }
                        result += String.valueOf(alphabet[party1]) + " ";
                        continue;
                    }
                    int party2 = getBiggestParty(senators, except);
                    senators[party2] -= 1;
                    if (checkMajority(senators)) {
                        result += String.valueOf(alphabet[party1]) + String.valueOf(alphabet[party2]) + " ";
                    } else {
                        if (causedByFirst) {
                            while (!checkMajority(senators)) {
                                senators[party1] += 1;
                                except.add(party1);
                                party1 = getBiggestParty(senators, except);
                                senators[party1] -= 1;
                            }
                            result += String.valueOf(alphabet[party1]) + String.valueOf(alphabet[party2]) + " ";
                        } else {
                            while (!checkMajority(senators)) {
                                senators[party2] += 1;
                                except.add(party2);
                                party2 = getBiggestParty(senators, except);
                                senators[party2] -= 1;
                            }
                            result += String.valueOf(alphabet[party1]) + String.valueOf(alphabet[party2]) + " ";
                        }
                    }
                }
            } while (checkMajority(senators) && getLeftSenatorsCount(senators) != 0);
        }
        return result;
    }

    private static int getBiggestParty(int[] senators, List<Integer> except) {
        int max = 0;
        int index = -1;
        if (senators.length == except.size()) {
            return -1;
        }
        for (int i = 0; i < senators.length; i++) {
            if (except.contains(i)) {
                continue;
            }
            if (max < senators[i]) {
                max = senators[i];
                index = i;
            }
        }
        return index;
    }

    private static int getLeftSenatorsCount(int[] senators) {
        int count = 0;
        for (int party : senators) {
            count += party;
        }
        return count;
    }

    public static boolean checkMajority(int[] senators) {
        int all = getLeftSenatorsCount(senators);
        for (int party : senators) {
            if ((float) party / all > 0.5) {
                return false;
            }
        }
        return true;
    }

    private static void output() {
        try {
            File logFile = new File("res2c_1.txt");

            BufferedWriter writer = new BufferedWriter(new FileWriter(logFile));
            int counter = 1;
            for (String out : output) {
                System.out.print("Case #" + counter + ": " + out + "\n");
                writer.write("Case #" + counter + ": " + out + "\n");
                counter++;
            }

            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}
