package Task1_2;

import java.io.*;

/**
 * created by Alex Ivanov on 4/9/16.
 */
public class FlipThePancakesUp {

    private String[] input;
    private int[] output;

    public void resolveInput() {
        for (int i = 0; i < input.length; i++) {
            output[i] = countFlips(input[i]);
        }
    }

    private int countFlips(String in) {
        int count = 0;
        String[] arr = in.split("");
        boolean[] boolArr = new boolean[arr.length];
        for (int i = 0; i < boolArr.length; i++) {
            boolArr[i] = arr[i].equals("+");
        }

        int last = findLastMinus(boolArr);
        while (last != -1) {
            int lastPlus = findLastPlusFromStart(boolArr);
            if (lastPlus != -1) {
                count++;
                flipSome(boolArr, lastPlus);
                last = findLastMinus(boolArr);
                if (last == -1) {
                    break;
                }
            }
            count++;
            flipSome(boolArr, last);
            last = findLastMinus(boolArr);
        }
        return count;
    }

    private void flipSome(boolean[] input, int last) {
        boolean[] fliped = new boolean[last + 1];
        for (int i = 0; i <= last; i++) {
            fliped[i] = !input[i];
        }
        for (int i = 0, j = last; i <= last; i++, j--) {
            input[i] = fliped[j];
        }
    }

    private int findLastMinus(boolean[] in) {
        int res = -1;
        for (int i = in.length - 1; i >= 0; i--) {
            if (!in[i]) {
                res = i;
                break;
            }
        }
        return res;
    }

    private int findLastPlusFromStart(boolean[] in) {
        int res = -1;
        for (int i = 0; i < in.length; i++) {
            if (!in[i]) {
                res = i - 1;
                break;
            }
        }
        return res;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
        FlipThePancakesUp main = new FlipThePancakesUp();
        int count = Integer.parseInt(br.readLine());
        main.input = new String[count];
        main.output = new int[count];
        for (int i = 0; i < count; i++) {
            main.input[i] = br.readLine();
        }
        br.close();
        main.resolveInput();
        main.output();
    }

    private void output() {
        try {
            File logFile = new File("res1_2.txt");

            BufferedWriter writer = new BufferedWriter(new FileWriter(logFile));

            for (int i = 0; i < output.length; i++) {
                String res = String.format("Case #%1$d: %2$d\n", i + 1, output[i]);
                System.out.print(res);
                writer.write(res);
            }

            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
