package main.d1.t1;

/**
 * created by Alex Ivanov on 4/8/17.
 */
public class FlipperWrapper {

    boolean[] flippedPancakes;
    int flipperWidth;

    public FlipperWrapper(String wrapperString) {
        String[] split = wrapperString.split(" ");
        flipperWidth = Integer.parseInt(split[1]);
        flippedPancakes = new boolean[split[0].length()];
        for (int i = 0; i < split[0].length(); i++) {
            if (split[0].charAt(i) == '+') {
                flippedPancakes[i] = true;
            }
        }
    }

    public int run() {
        int flipCount = 0;
        for (int i = 0; i < flippedPancakes.length; i++) {
            if (checkNext(i)) continue;
            if (!isPossibleToFlip(i)) break;
            flip(i);
            flipCount++;
        }
        return checkResult() ? flipCount : -1;
    }

    private void flip(int offset) {
        for (int i = offset; i < offset + flipperWidth; i++) {
            flippedPancakes[i] = !flippedPancakes[i];
        }
    }

    private boolean isPossibleToFlip(int offset) {
        return offset + flipperWidth <= flippedPancakes.length;
    }

    private boolean checkNext(int offset) {
        return flippedPancakes[offset];
    }

    private boolean checkResult() {
        for (boolean happySide : flippedPancakes) {
            if (!happySide) return false;
        }
        return true;
    }
}
