package main;

import java.io.*;

/**
 * created by Alex Ivanov on 4/8/17.
 */
public class ReadWriteHelper {

    public static String[] readTestCases(File file) {
        FileReader fileReader = null;
        BufferedReader bufferedReader = null;
        try {
            fileReader = new FileReader(file);
            bufferedReader = new BufferedReader(fileReader);

            int cases = Integer.parseInt(bufferedReader.readLine().trim());
            String[] res = new String[cases];
            for (int i = 0; i < cases; i++) {
                res[i] = bufferedReader.readLine();
            }
            return res;
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (fileReader != null) fileReader.close();
                if (bufferedReader != null) bufferedReader.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
        return null;
    }

    public static void writeRes(String[] res, File file) {
        BufferedWriter bw = null;
        try {
            bw = new BufferedWriter(new FileWriter(file));
            for (String outStr : res) {
                System.out.print(outStr);
                bw.write(outStr);
                bw.flush();
            }
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (bw != null) bw.close();
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

}
