import java.io.*;
import java.math.*;
import java.util.*;

public class DataPacking
{
	static Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	static int INF = 123456789;

	public static void main(String[] args)
	{
		int t = in.nextInt();
		for(int i = 1; i <= t; i++)
			System.out.printf("Case #%d: %d\n", i, new DataPacking().solve());
	}

	int solve()
	{
		int m = in.nextInt(), x = in.nextInt(), eq = 0;
		ArrayList<Integer> l = new ArrayList(), r = new ArrayList();
		for(int i = 0; i < m; i++)
		{
			int w = in.nextInt();
			if(2 * w < x)
				l.add(w);
			else if(2 * w > x)
				r.add(w);
			else
				eq++;
		}

		n = l.size() + r.size() + 2;
		g = new ArrayList[n];
		for(int i = 0; i  < n; i++)
			g[i] = new ArrayList();
		for(int i = 0; i < l.size(); i++)
			addEdge(n - 2, i, 1);
		for(int j = 0; j < r.size(); j++)
			addEdge(j + l.size(), n - 1, 1);
		for(int i = 0; i < l.size(); i++)
		for(int j = 0; j < r.size(); j++)
		if(l.get(i) + r.get(j) <= x)
			addEdge(i, j + l.size(), 1);

		int flow = maxFlow(n - 2, n - 1), nl = l.size() - flow, nr = r.size() - flow;
		return flow + nr + (nl + eq + 1) / 2;
	}

	ArrayList<Edge>[] g;
	int n;

	class Edge
	{
		int j, c, f;
		Edge r;

		Edge(int j, int c)
		{
			this.j = j;
			this.c = c;
		}
	}

	void addEdge(int i, int j, int c)
	{
		Edge e = new Edge(j, c), f = new Edge(i, 0);
		e.r = f;
		f.r = e;
		g[i].add(e);
		g[j].add(f);
	}

	int maxFlow(int s, int t)
	{
		seen = new boolean[n];
		do Arrays.fill(seen, false);
		while(maxFlowDFS(s, t, INF) > 0);
		int ans = 0;
		for(Edge e : g[s]) ans += e.f;
		return ans;
	}

	boolean[] seen;

	int maxFlowDFS(int s, int t, int mf)
	{
		if(s == t) return mf;
		if(seen[s]) return 0;
		seen[s] = true;
		for(Edge e : g[s])
		{
			if(e.c == e.f) continue;
			int mf2 = Math.min(mf, e.c - e.f);
			mf2 = Math.min(mf2, maxFlowDFS(e.j, t, mf2));
			if(mf2 > 0)
			{
				e.f += mf2;
				e.r.f -= mf2;
				return mf2;
			}
		}
		return 0;
	}
}
