import java.io.*;
import java.math.*;
import java.util.*;

public class Pegman
{
static Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
static int[] dx = {0, 1, 0, -1}, dy = {1, 0, -1, 0};
static char[] dirs = {'>', 'v', '<', '^'};

public static void main(String[] args)
{
	int t = in.nextInt();
	for(int i = 1; i <= t; i++)
	{
		System.out.printf("Case #%d: %s\n", i, new Pegman().work());
	}
}

int n, m;
String[] g;

int getDir(char c)
{
	for(int i = 0; i < 4; i++)
	if(dirs[i] == c)
		return i;
	return -1;
}

int getDir(int i, int j)
{
	return getDir(g[i].charAt(j));
}

boolean off(int i, int j)
{
	return i < 0 || i >= n || j < 0 || j >= m;
}

int[] run(int i, int j, int dir)
{
	i += dx[dir];
	j += dy[dir];
	while(!off(i, j))
	{
		if(getDir(i, j) != -1)
			return new int[]{i, j};
		i += dx[dir];
		j += dy[dir];
	}
	return null;
}

String work()
{
	n = in.nextInt();
	m = in.nextInt();
	g = new String[n];
	for(int i = 0; i < n; i++)
		g[i] = in.next();

	int ans = 0;
	for(int i = 0; i < n; i++) for(int j = 0; j < m; j++)
	{
		int dir_ = getDir(i, j);
		if(dir_ == -1) continue;
		boolean can = false;
		for(int dir = 0; dir < 4; dir++)
		{
			boolean ok = run(i, j, dir) != null;
			if(ok) can = true;
			else if(dir == dir_) ans++;
		}
		if(!can) return "IMPOSSIBLE";
	}

	return "" + ans;
}
}
