import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;


public class B {
	int nflies;
	double[] x;
	double[] y;
	double[] z;
	int[] vx;
	int[] vy;
	int[] vz;
	
	double cx, cy, cz;
	
	private double getDistance()
	{
		calcMass();
		double dist = 0;
		dist += Math.sqrt(cx*cx + cy*cy + cz*cz);
		return dist;
	}
	
	private void calcMass()
	{
		cx = 0; cy = 0; cz = 0;
		for (int i = 0; i < nflies; i++) {
			cx += x[i];
			cy += y[i];
			cz += z[i];
		}
		cx = cx / nflies;
		cy = cy / nflies;
		cz = cz / nflies;
	}
	
	public void solve(List<String> lines)
	{
		int line = 0;
		int n = Integer.parseInt(lines.get(line++));
		for (int c = 0; c < n; c++)
		{
			nflies = Integer.parseInt(lines.get(line++));
			x = new double[nflies];
			y = new double[nflies];
			z = new double[nflies];
			vx = new int[nflies];
			vy = new int[nflies];
			vz = new int[nflies];
			for (int i = 0; i < nflies; i++) {
				String[] s = lines.get(line++).split(" ");
				x[i] = Integer.parseInt(s[0]);
				y[i] = Integer.parseInt(s[1]);
				z[i] = Integer.parseInt(s[2]);
				vx[i] = Integer.parseInt(s[3]);
				vy[i] = Integer.parseInt(s[4]);
				vz[i] = Integer.parseInt(s[5]);
			}
			
			// now simulate the flies
			double minDist = getDistance();
			int minT = 0;
			// int lastChange = 0;
			for (int t = 1; t < 100000000; t++) {
				simulate();
				double dist = getDistance();
				if (dist < minDist) {
					minDist = dist;
					minT = t;
				}
				
				if (t-minT > 1000000) break;
			}
			
			double minTd = minT;
			
			System.out.println("Case #" + (c+1) + ": " + minDist + " " + minTd);
		}
	}
	
	private void simulate()
	{
		for (int i = 0; i < nflies; i++) {
			x[i] += vx[i];
			y[i] += vy[i];
			z[i] += vz[i];
		}
	}
	
	public static void main(String[] args) throws Exception
	{
		B b = new B();
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		ArrayList<String> lines = new ArrayList<String>();
		String l;
		while ((l = in.readLine()) != null)	lines.add(l);
		b.solve(lines);
	}
}
