package snapper;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Snapper
{
	public static void solve(List<String> lines)
	{
		int l = 0;
		int cases = Integer.parseInt(lines.get(l++));
		for (int c = 0; c < cases; c++) {
			String[] values = lines.get(l++).split("( |\t)+");
			int n = Integer.parseInt(values[0]);
			int k = Integer.parseInt(values[1]);
			
			boolean[] state = new boolean[n];
			boolean[] power = new boolean[n];
			for (int i = 0; i < n; i++) {
				state[i] = false;
				power[i] = false;
			}
			power[0] = true;
			
			// snap k times
			for (int i = 0; i < k; i++) {
				for (int snapper = 0; snapper < n; snapper++) {
					if (!power[snapper]) break;
					state[snapper] = !state[snapper];
				}
				
				power = new boolean[n];
				power[0] = true;
				for (int snapper = 0; snapper+1 < n; snapper++) {
					if (state[snapper]) power[snapper+1] = true;
					else break;
				}
			}
			
			// last snapper must have power and be switched ON
			boolean lightOn = state[state.length-1] && power[state.length-1];
			
			System.out.println("Case #" + (c+1) + ": " + (lightOn ? "ON" : "OFF"));
		}
	}
	
	public static void main(String[] args) throws Exception
	{
		BufferedReader in = new BufferedReader(new FileReader(new File(args[0])));
		ArrayList<String> lines = new ArrayList<String>();
		String l;
		while ((l = in.readLine()) != null)	lines.add(l);
		solve(lines);
	}
}
