package de.ahans.codejam.alienlanguage;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;


public class AlienLanguage
{
	private static void removeNotMatching(Set<String> dict, String chars, int pos)
	{
		// remove all words that do not match
		Set<String> toRemove = new TreeSet<String>();
		for (String word : dict)
		{
			boolean hasChar = false;
			for (int i = 0; i < chars.length(); i++) {
				if (word.charAt(pos) == chars.charAt(i)) {
					hasChar = true;
					break;
				}
			}
			if (!hasChar) toRemove.add(word);
		}
		
		dict.removeAll(toRemove);		
	}
	
	
	@SuppressWarnings("unchecked")
	private static int getPossibleWords(TreeSet<String> dict, String word)
	{		
		Set<String> myDict = (Set<String>) dict.clone();
		
		String curSub = "";
		boolean inBracket = false;
		int pos = 0;
		for (int i = 0; i < word.length(); i++) {
			char c = word.charAt(i);
			if (c == '(') {
				inBracket = true;
			} else if (c == ')') {
				inBracket = false;
				// update dict
				removeNotMatching(myDict, curSub, pos);
				pos++;
				curSub = "";
			} else if (inBracket) {
				curSub = curSub + c;
			} else {
				// update dict
				removeNotMatching(myDict, "" + c, pos);
				pos++;
			}
		}
		
		return myDict.size();
	}
	
	private static void solve(List<String> lines)
	{
		TreeSet<String> dict = new TreeSet<String>();
		String[] numbers = lines.get(0).split(" ");
		int d = Integer.parseInt(numbers[1]);
		int n = Integer.parseInt(numbers[2]);

		// read words from dictionary
		for (int i = 0; i < d; i++)
		{
			String word = lines.get(i+1);
			dict.add(word);
		}
		
		// test cases
		for (int i = 0; i < n; i++)
		{
			String word = lines.get(i+d+1);
			System.out.println("Case #" + (i+1) + ": " + getPossibleWords(dict, word));
		}
	}
	
	public static void main(String[] args) throws Exception
	{
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		ArrayList<String> lines = new ArrayList<String>();
		String l;
		while ((l = in.readLine()) != null)	lines.add(l);
		solve(lines);
	}
}
