package ch.codejam.bottrust;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Bottrust {
	//int[] commands;
	BufferedReader in;
	PrintWriter out;
	int[] orangecmd;
	int[] bluecmd;
	List<String> buttonOrder;
	List<String> commands;
	
	public static void main(String args[]) {
		String output;
		int result = 0;
		Bottrust bot = new Bottrust();
		
		bot.buttonOrder = new ArrayList<String>();
		bot.commands = new ArrayList<String>();
		
		
		try {
			bot.in = new BufferedReader(new FileReader("input.txt"));
			bot.out = new PrintWriter(new FileWriter("output.txt"));
		} catch (Exception e) {
			System.out.println("There was a Problem reading the files.");
		}

		int numberOfCases = Integer.parseInt(bot.readLine());

		for (int testcase = 0; testcase < numberOfCases; testcase++) {
			bot.readCase();
			result = bot.doCase();

			output = "Case #" + (testcase+1) + ": " + result;
			bot.printLine(output);
		}
		bot.out.close();
	}
	

	private int doCase() {
		Robot blue = new Robot(bluecmd);
		Robot orange = new Robot(orangecmd);
		int time;
		int seconds = 0;

		for (int i = 0; i < buttonOrder.size(); i++) {
			time = 0;
			
			if(buttonOrder.get(i).equals("O")) {
				time = orange.pushButton();
				blue.move(time);
			} else {
				time = blue.pushButton();
				orange.move(time);
			}
			
			seconds += time;
		}
		return seconds;
	}

	private void printLine(String output) {
		out.println(output);
	}

	private void readCase() {
		int o = 0;
		int b = 0;
		int size;
		
		// init lists
		commands = new ArrayList<String>();
		buttonOrder = new ArrayList<String>();
		
		commands = Arrays.asList(readLine().split(" "));
		size = Integer.parseInt(commands.get(0));
		
		// create Arrays
		orangecmd = new int[size];
		bluecmd = new int[size];
		
		for (int i = 1; i < commands.size(); i++) {			
			buttonOrder.add(commands.get(i));
			if (commands.get(i).equals("O")) {
				i++;
				orangecmd[o] = Integer.parseInt(commands.get(i));
				o++;
			} else {
				i++;
				bluecmd[b] = Integer.parseInt(commands.get(i));
				b++;
			}
		}

	}

	public String readLine() {
		String line = "";
		try {
			line = in.readLine(); // file.readLine();
		} catch (IOException e) {
			System.out.println("There was a Problem reading the files.");
		}
		return line;
	}
	

	public class Robot {
		private int position = 1;
		private int currentCommand;
		int[] commands;
		
		public Robot(int[] pcommands) {
			commands = pcommands;
		}

		public void move(int seconds) {
			int ipos = commands[currentCommand];
			while (position < ipos && seconds > 0) {
				position++;
				seconds--;
			}
			while (position > ipos && seconds > 0) {
				position--;
				seconds--;
			}
		}

		public int pushButton() {
			int seconds = 0;
			int ipos = commands[currentCommand];			
			// move to the correct position
			for (; position < ipos; position++) {
				seconds++;
			}
			for (; position > ipos; position--) {
				seconds++;
			}
			// one more second for pushing the button
			seconds++;
			currentCommand++;

			return seconds;
		}
	}
}
