package ch.codejam.candysplitting;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;

public class Magicka {
	// int[] commands;
	HashMap<String, String> baseElems = new HashMap<String, String>();
	HashMap<String, String> opposeElems = new HashMap<String, String>();
	List<String> Line;
	char[] spell;
	BufferedReader in;
	PrintWriter out;
	Iterator<String> iterator;

	public static void main(String args[]) {
		String output;
		String result = "";
		Magicka cand = new Magicka();

		cand.Line = new ArrayList<String>();

		try {
			cand.in = new BufferedReader(new FileReader("input.txt"));
			cand.out = new PrintWriter(new FileWriter("output.txt"));
		} catch (Exception e) {
			System.out.println("There was a Problem reading the files.");
		}

		int numberOfCases = Integer.parseInt(cand.readLine());
		char[] chars;
		
		for (int testcase = 0; testcase < numberOfCases; testcase++) {
			cand.readCase();
			result = cand.doCase();
			chars = result.toCharArray();
			result = "[";
			for (int i=0; i<chars.length; i++) {
				result += chars[i];
				if (i != chars.length -1) {
					result += ", ";
				}
			}
			result += "]";

			output = "Case #" + (testcase + 1) + ": " + result;
			cand.printLine(output);
		}
		cand.out.close();
	}

	private String doCase() {
		String key = "";
		String replace = "";
		String elementList = "";
		String newSpell;
		int listsize;

		for (int i = 0; i < spell.length; i++) {
			newSpell = String.valueOf(spell[i]);
			elementList = elementList.concat(newSpell);
			listsize = elementList.length();

			if (listsize > 1) {
				key = elementList.substring(listsize - 2, listsize);
				replace = baseElems.get(key);
				if (replace != null) {
					elementList = elementList.replace(key, replace);
					newSpell = "";
				}
			}

			replace = opposeElems.get(newSpell);
			if (replace != null && elementList.contains(replace)) {
				elementList = "";
			}
		}

		return elementList;
	}

	private void printLine(String output) {
		out.println(output);
	}

	private void readCase() {
		int C;
		int D;
		int N;

		// init lists
		Line = new ArrayList<String>();
		opposeElems.clear();
		baseElems.clear();

		Line = Arrays.asList(readLine().split(" "));
		iterator = Line.iterator();

		C = readInt();
		getBaseElements(C);

		D = readInt();
		getOpposedElements(D);

		N = readInt();
		spell = readString().toCharArray();

	}

	public int readInt() {
		int returnvalue = Integer.parseInt((String) iterator.next());
		return returnvalue;
	}

	public String readString() {
		String returnvalue = (String) iterator.next();
		return returnvalue;
	}

	private void getOpposedElements(int D) {
		String opposeElement;
		String first;
		String second;
		for (int i = 0; i < D; i++) {
			opposeElement = readString();
			first = opposeElement.substring(0, 1);
			second = opposeElement.substring(1);
			opposeElems.put(first, second);
			opposeElems.put(second, first);
		}
	}

	private void getBaseElements(int C) {
		String baseElement;
		String reverse;
		String combineElements;
		for (int i = 0; i < C; i++) {
			baseElement = readString();
			combineElements = baseElement.substring(0, 2);
			reverse = new StringBuffer(combineElements).reverse().toString();
			baseElems.put(combineElements, baseElement.substring(2));
			baseElems.put(reverse, baseElement.substring(2));
		}
	}

	public String readLine() {
		String line = "";
		try {
			line = in.readLine(); // file.readLine();
		} catch (IOException e) {
			System.out.println("There was a Problem reading the files.");
		}
		return line;
	}
}
