import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Map;

/**
 * Created by anand on 9/4/17.
 */
public class BathroomStall {

    public int[] setSmallMan(int stall, int man){

        if(man > stall/2){
            return new int[]{0,0};
        }

        BitSet bs = new BitSet();
        bs.set(0);
        bs.set(stall+1);

        int finalmin = -1;
        int finalmax = -1;

        for(int m =0 ; m<man ; m++){
            int minlsrs = Integer.MIN_VALUE;
            int maxlsrs = Integer.MIN_VALUE;
            int pos=-1;
            for(int i=1;i<stall;i++){
                if(bs.get(i)){
                    continue;
                }
                int ls = i - bs.previousSetBit(i-1);
                int rs = bs.nextSetBit(i+1) - i;
                int min = Math.min(ls,rs);
                int max = Math.max(ls,rs);

                if(min > minlsrs){
                    pos =i;
                    minlsrs = min;
                    maxlsrs = max;
                }
                else if(min == minlsrs){
                    if(max > maxlsrs){
                        pos = i;
                        maxlsrs = max;
                    }
                }
                finalmin = minlsrs-1;
                finalmax = maxlsrs-1;
                //System.out.println(ls + " " + rs + " "+ pos + " "+ finalmin + " "+ finalmax);

            }
            bs.set(pos);
        }

        return new int[]{finalmax,finalmin};
    }






    public static void main(String[] args) throws  Exception{
        BathroomStall obj = new BathroomStall();
        //obj.setSmallMan(9, 2);

        BufferedReader br = new BufferedReader(new FileReader(args[0]));
        int count = Integer.parseInt(br.readLine());
        for(int i=1;i<=count;i++){
            String[] line = br.readLine().split(" ");
            int stall = Integer.parseInt(line[0]);
            int man = Integer.parseInt(line[1]);
            int[] output = obj.setSmallMan(stall, man);
            System.out.println("Case #"+i+": "+output[0] + " " + output[1]);
        }

    }


}
