package code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

public class FairSquare {

	public static boolean isSquare(int number) {
		
		double a = Math.sqrt(number);

		if(a - (int) a == 0.0)
			return true;
		return false;
	}
	
	public static boolean isPalindromes(int number) {

		String s = String.valueOf(number);
		return s.equals(new StringBuffer(s).
				reverse().toString());
	}
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {

//		int i = 0;
//		while(i<1000){
//			i = nextPalindromes(i);
//			System.out.println(i + "\t" + i*i);
//		}
		String file = "C-small-attempt2.in";
		List<int[]> cases = scan(file);
		int caseId = 1;
		FileWriter3 writer = new FileWriter3(file.replace("in", "out"));
		
		for(int[] caseInput:cases){
			int qualified = 0;
			int min = caseInput[0];
			int max = caseInput[1];
			
			int loopStart = (int)Math.sqrt(min);
			int loopEnd = (int)Math.sqrt(max);
			if(!isSquare(min)){
				loopStart += 1;
			}
			StringBuffer strBuffer = new StringBuffer( min + " " + max + "|| \t");
			while(loopStart <= loopEnd){
				int nextNumber = loopStart*loopStart;
				if(nextNumber <= max && isPalindromes(nextNumber)){
					qualified ++;
					strBuffer.append("\t"+nextNumber);
				}
					
				loopStart = nextPalindromes(loopStart);
			}
			System.out.println("Case # " + ": " + qualified + "\t" + "|" + strBuffer);
			writer.writeLine("Case #" + caseId++ + ": " + qualified);
			
		}
		
		writer.close();
	}

	private static int nextPalindromes(int loopStart) {
		while(!isPalindromes(++loopStart)){
		}
		return loopStart;
	}

	private static List<int[]> scan(String file) throws IOException {
		List<int[]> cases = new ArrayList<int[]>();
		FileReader3 reader = new FileReader3(file);
		String line = reader.readLine();
		int caseNumber = Integer.parseInt(line);
		int caseSeq = 0;
		while(caseSeq++ < caseNumber) {
			line = reader.readLine();
			int[] numbers = new int[2]; 
			String[] arr = line.split(" ");
			numbers[0] = Integer.parseInt(arr[0]);
			numbers[1] = Integer.parseInt(arr[1]);
			cases.add(numbers);
		}
		
		reader.close();
		return cases;
	}

}



/*
 * file  util
 * 
 * 
 */
class FileWriter3
	{
	    private BufferedWriter writer = null;

	    FileWriter3(String filePath) throws IOException {
	        this(new File(filePath), "UTF-8");
	    }

	    FileWriter3(File file, String charsetName) throws IOException {
	        if (file == null) {
	            return;
	        }
	        writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file), charsetName));
	    }

	   void writeLine(String line) throws IOException {
	         writer.write(line+"\n");
	    }

	   void close() throws IOException {
	    	writer.close();
	    }
	}

class FileReader3
{
    private BufferedReader m_reader = null;

    public FileReader3(String filePath) throws IOException {
        this(new File(filePath), "UTF-8");
    }

    public FileReader3(File file, String charsetName) throws IOException {
        if (file == null || !file.exists() || !file.isFile()) {
            return;
        }
        m_reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), charsetName));
    }

    public FileReader3(InputStream in, String charsetName) throws IOException {
        if (in == null) {
            return;
        }
        m_reader = new BufferedReader(new InputStreamReader(in, charsetName));
    }

    public String readLine() throws IOException {
        return m_reader.readLine();
    }

    public void close() throws IOException {
        m_reader.close();
    }
}