package code.jam;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class TicTacToeTomek {

	private static final int CHESS_BORAD_SIZE = 4;

	public TicTacToeTomek() {
		
	}
	
	private static List<char[][]> scan() throws IOException {

		List<char[][]> cases = new ArrayList<char[][]>();
		MyFileReader reader = new MyFileReader("A-small-attempt6.in");
		
		String line = reader.readLine();
		int caseNumber = Integer.parseInt(line);
		
		line = reader.readLine();
		int i = 0;
		char[][] chessBoard = new char[CHESS_BORAD_SIZE][CHESS_BORAD_SIZE];
		while(line != null){
			if(!validLine(line)){
				line = reader.readLine();
				continue;
			}
			int length = line.length();
			if(length == CHESS_BORAD_SIZE){
				chessBoard[i][0] = line.charAt(0);
				chessBoard[i][1] = line.charAt(1);
				chessBoard[i][2] = line.charAt(2);
				chessBoard[i][3] = line.charAt(3);
				i ++;
			} else {
				cases.add(chessBoard);
				i = 0;
				chessBoard = new char[CHESS_BORAD_SIZE][CHESS_BORAD_SIZE];
			}
			line = reader.readLine();
		}
		
		if(caseNumber != cases.size()){
			//error
		}
		
		return cases;
	}
	
	private static boolean validLine(String line) {
		if(line.length() == 0)
			return true;
		char c = line.charAt(0);
		return c == 'O' || c == 'T' || c == 'X'| c== '.';
	}

	public static void main(String[] args) throws IOException {
		List<char[][]> cases = scan();
		int i = 0;
		for(char[][] chessBoard : cases ) {
			System.out.println("Case #" + ++i + ": " + check(chessBoard));
		}
	}

	private static String check(char[][] chessBoard) {
		if(win('X', chessBoard)){
			return "X won";
		}
		if(win('O', chessBoard)){
			return "O won";
		}
		
		if(hasChar('.', chessBoard)){
			return "Game has not completed";
		}
		return "Draw";
	}

	private static boolean hasChar(char c, char[][] chessBoard) {
		for(int i = 0; i < CHESS_BORAD_SIZE; i ++ ){
			for(int j = 0; j < CHESS_BORAD_SIZE; j ++ ){
				if(chessBoard[i][j] == c){
					return true;
				}
			}
		}
		return false;
	}

	private static boolean win(char c, char[][] chessBoard) {
		
		for(int i = 0; i < CHESS_BORAD_SIZE; i ++ ){
			boolean flag = true;
			for(int j = 0; j < CHESS_BORAD_SIZE; j ++ ){
				if(!(chessBoard[i][j] == c || chessBoard[i][j] == 'T')){
					flag = false;
				}
			}
			if(flag)
				return true;
		}
		
		for(int i = 0; i < CHESS_BORAD_SIZE; i ++ ){
			boolean flag = true;
			for(int j = 0; j < CHESS_BORAD_SIZE; j ++ ){
				if(!(chessBoard[j][i] == c || chessBoard[j][i] == 'T')){
					flag = false;
				}
			}
			if(flag)
				return true;
		}
		
		boolean flag = true;
		int i = 0;
		while( i < 4){
			if(!(chessBoard[i][i] == c || chessBoard[i][i] == 'T')){
				flag = false;
			}
			i ++;
		}
		
		if(flag)
			return true;
		
		flag = true;
		i = 0;
		while( i < 4){
			if(!(chessBoard[i][3-i] == c || chessBoard[i][3 - i ] == 'T')){
				flag = false;
			}
			i ++;
		}
		if(flag)
			return true;
		return false;
	}
	
}
