package code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

public class Lawnmower {

	private static List<int[][]> scan(String file) throws IOException {

		List<int[][]> cases = new ArrayList<int[][]>();
		FileReader1 reader = new FileReader1(file);
		String line = reader.readLine();
		int caseNumber = Integer.parseInt(line);
		int caseSeq = 0;
		while(caseSeq++ < caseNumber) {
			int[][] lawn = getOneInput(reader);
			cases.add(lawn);
		}
		
		reader.close();
		
		return cases;
	}


	private static int[][] getOneInput(FileReader1 reader) throws IOException {
		String line;
		int lineSeq = 0;
		line = reader.readLine();
		String arr[] = line.split(" ");
		int lines=Integer.parseInt(arr[0]);
		int cols =Integer.parseInt(arr[1]);
		int[][] lawn = new int[lines][cols];
		line = reader.readLine();
		while(line != null){
			arr = line.split(" ");
			for(int i = 0; i < arr.length; i ++){
				lawn[lineSeq][i] = Integer.parseInt(arr[i]); 
			}
			lineSeq ++;
			if(lineSeq < lines )
				line = reader.readLine();
			else
				break;
		}
		return lawn;
	}
	
	public static String check(int[][] lawn) {
		boolean resultFlag = false;
		int min = findMin();
		int max = findMax();
		while(min < max) {
			for(int i = 0; i < lawn.length; i ++) {
				for( int j=0; j < lawn[i].length; j ++){
					resultFlag = check(i, j, lawn);
					if(resultFlag)
						continue;
					if(!resultFlag)
						break;
				}
				if(!resultFlag)
					break;
			}
			min ++;
		}
		
		if(resultFlag)
			return "YES";
		return "NO";
	}


	private static boolean check(int i, int j, int[][] lawn) {

		int[] row = lawn[i];
		int[] col = new int[lawn.length];
		for(int seq = 0; seq < lawn.length; seq ++) {
			col[seq] = lawn[seq][j];
		}
		
		int currentValue = lawn[i][j];
		return(checkRow(row, currentValue) || 
				checkRow(col, currentValue));
	}

	private static boolean checkRow(int row[], int currentValue) {
		for(int height : row){
			if(height > currentValue)
				return false;
		}
		return true;
	}

	private static int findMin() {
		return 1;
	}
	
	private static int findMax() {
		return 2;
	}
	
	
/**
 * 
 * @param args
 * @throws IOException
 */
	public static void main(String[] args) throws IOException{
		List<int[][]> cases = scan("B-large.in");
		
		FileWriter1 writer = new FileWriter1("B-large.out");
		int n = 0;
		for(int[][] lawn : cases){
//			outLawn(lawn);
			String result = check(lawn);
			writer.writeLine("Case #" + ++n + ": " + result );
		}
		
		writer.close();
	}


private static void outLawn(int[][] lawn) {
	System.out.println("{");
	for(int i = 0; i < lawn.length; i ++){
		System.out.print("{ ");
		for(int j = 0; j < lawn[i].length; j ++){
			System.out.print(lawn[i][j] + ", ");
		}
		
		System.out.print("},\n");
	}
	System.out.println("}");
}
}


/*
 * file  util
 * 
 * 
 */
class FileWriter1
	{
	    private BufferedWriter writer = null;

	    FileWriter1(String filePath) throws IOException {
	        this(new File(filePath), "UTF-8");
	    }

	    FileWriter1(File file, String charsetName) throws IOException {
	        if (file == null) {
	            return;
	        }
	        writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(file), charsetName));
	    }

	   void writeLine(String line) throws IOException {
	         writer.write(line+"\n");
	    }

	   void close() throws IOException {
	    	writer.close();
	    }
	}

class FileReader1
{
    private BufferedReader m_reader = null;

    public FileReader1(String filePath) throws IOException {
        this(new File(filePath), "UTF-8");
    }

    public FileReader1(File file, String charsetName) throws IOException {
        if (file == null || !file.exists() || !file.isFile()) {
            return;
        }
        m_reader = new BufferedReader(new InputStreamReader(new FileInputStream(file), charsetName));
    }

    public FileReader1(InputStream in, String charsetName) throws IOException {
        if (in == null) {
            return;
        }
        m_reader = new BufferedReader(new InputStreamReader(in, charsetName));
    }

    public String readLine() throws IOException {
        return m_reader.readLine();
    }

    public void close() throws IOException {
        m_reader.close();
    }
}

