/*
ID: ayush941
LANG: JAVA
TASK: 
*/

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.TreeSet;

public class bathroom {
	
	static class interval{
	    private final int x;
	    private final int y;

	    public interval(int a, int b) {
	        x = a;
	        y = b;

	    }

	    public boolean equals(Object o) {
	        if (this == o) return true;
	        if (!(o instanceof interval)) return false;
	        interval key = (interval) o;
	        return x == key.x && y == key.y;
	    } 
	    
	    public int hashCode() {
	        int result = x;
	        result = 31 * result + y;
	        return result;
	    }

		public int compareTo(interval a) {
			if(this.y-this.x>a.y-a.x){
				return -1;
			}
			else if(a.y-a.x>this.y-this.x){
				return 1;
			}
			if(a.x==this.x){
				return 0;
			}
			if(a.x<this.x){
				return 1;
			}
			return -1;
		}
	}
	
	
	public class BinaryHeap implements PriorityQueue{
	   
	    public BinaryHeap( ) {
	        currentSize = 0;
	        array = new interval[ DEFAULT_CAPACITY + 1 ];
	    }
	     
	    public BinaryHeap( interval [ ] items ) {
	        currentSize = items.length;
	        array = new interval[ items.length + 1 ];
	         
	        for( int i = 0; i < items.length; i++ )
	            array[ i + 1 ] = items[ i ];
	        buildHeap( );
	    }
	     
	    
	    public PriorityQueue.Position insert( interval x ) {
	        if( currentSize + 1 == array.length )
	            doubleArray( );
	         
	        // Percolate up
	        int hole = ++currentSize;
	        array[ 0 ] = x;
	         
	        for( ; x.compareTo( array[ hole / 2 ] ) < 0; hole /= 2 )
	            array[ hole ] = array[ hole / 2 ];
	        array[ hole ] = x;
	         
	        return null;
	    }
	     
	    public void decreaseKey( PriorityQueue.Position p, interval newVal ) {
	        throw new UnsupportedOperationException( "Cannot use decreaseKey for binary heap" );
	    }
	     
	    
	    public interval findMin( ) {
	        if( isEmpty( ) )
	            throw new UnderflowException( "Empty binary heap" );
	        return array[ 1 ];
	    }
	     
	   
	    public interval deleteMin( ) {
	        interval minItem = findMin( );
	        array[ 1 ] = array[ currentSize-- ];
	        percolateDown( 1 );
	         
	        return minItem;
	    }
	     
	  
	    private void buildHeap( ) {
	        for( int i = currentSize / 2; i > 0; i-- )
	            percolateDown( i );
	    }
	     
	    public boolean isEmpty( ) {
	        return currentSize == 0;
	    }
	     
	    public int size( ) {
	        return currentSize;
	    }
	     
	    public void makeEmpty( ) {
	        currentSize = 0;
	    }
	     
	    private static final int DEFAULT_CAPACITY = 100;
	     
	    private int currentSize;      // Number of elements in heap
	    private interval[] array; // The heap array
	
	    private void percolateDown( int hole ) {
	        int child;
	        interval tmp = array[ hole ];
	         
	        for( ; hole * 2 <= currentSize; hole = child ) {
	            child = hole * 2;
	            if( child != currentSize &&
	                    array[ child + 1 ].compareTo( array[ child ] ) < 0 )
	                child++;
	            if( array[ child ].compareTo( tmp ) < 0 )
	                array[ hole ] = array[ child ];
	            else
	                break;
	        }
	        array[ hole ] = tmp;
	    }
	     
	    /**
	     * Internal method to extend array.
	     */
	    private void doubleArray( ) {
	        interval [ ] newArray;
	         
	        newArray = new interval[ array.length * 2 ];
	        for( int i = 0; i < array.length; i++ )
	            newArray[ i ] = array[ i ];
	        array = newArray;
	    }	
	}
	
	
	 

	public interface PriorityQueue {
	    public interface Position {
	        interval getValue( );
	    }
	     
	    Position insert( interval x );
	    interval findMin( );
	    interval deleteMin( );
	    boolean isEmpty( );
	    void makeEmpty( );
	    int size( );
	    void decreaseKey( Position p, interval newVal );
	}

	public class UnderflowException extends RuntimeException {
	    public UnderflowException( String message ) {
	        super( message );
	    }
	}
	
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		FileInputStream fis=null;	
		InputStreamReader isr=null;
		BufferedReader br= null;
		BufferedWriter br1= null;
		FileOutputStream fos = null;
		bathroom test=new bathroom();
		
		try{
			fis= new FileInputStream("/Users/sunitaagarwal/javaproject/CodJam/src/t1");
			isr= new InputStreamReader(fis);
			br=new BufferedReader(isr);
			fos= new FileOutputStream("/Users/sunitaagarwal/javaproject/CodJam/src/tout");
			br1 = new BufferedWriter(new OutputStreamWriter(fos));
					
			int T=Integer.parseInt(br.readLine());
			for(int i=1;i<=T;i++){
				br1.write("Case #"+Integer.toString(i)+": ");
				String[] temp=br.readLine().split(" ");
				int N=Integer.parseInt(temp[0]);
				int K=Integer.parseInt(temp[1]);
				BinaryHeap bh=test.new BinaryHeap();
				bh.insert(new interval(0,N+1));
				for(int j=0;j<K;j++){
					interval min=bh.findMin();
					bh.deleteMin();
					bh.insert(new interval(min.x, (min.x+min.y)/2));
					bh.insert(new interval((min.x+min.y)/2, min.y));
					if(j==K-1){
					int minlr=Math.min((min.x+min.y)/2-min.x, min.y-(min.x+min.y)/2);
					int maxlr=Math.max((min.x+min.y)/2-min.x, min.y-(min.x+min.y)/2);
						br1.write(Integer.toString(maxlr-1)+" "+Integer.toString(minlr-1));
						br1.newLine();
					}
				}
			}
			
			//br1.flush();
			
		}catch(Exception E){
	    	E.getStackTrace();
	    	}finally{
	    	if(br!= null)
	    		br.close();
	    		
	    	if(isr!=null)
	    		isr.close();
	    	
	    	if(fis != null)
	    		fis.close();
	    	if(br1 != null)
	    		br1.close();
	    	
	    }
	    }
	
}
