import java.io.*;

/**
 * @author Aleksey Lagoshin
 */
public class Magicka {

    private final static int EL1 = 0;
    private final static int EL2 = 1;
    private final static int RES = 2;
    private final static int EL1_C = 3;
    private final static int EL2_C = 4;

    BufferedReader in;
    BufferedWriter out;

    private int testCases;

    private int combinations;
    private char[][] elCombinations = new char[64][5];

    private int startElement;
    private int elementsCount;
    private char[] elements = new char[100];

    public Magicka(Reader reader, Writer writer) throws IOException {
        in = new BufferedReader(reader);
        out = new BufferedWriter(writer);
        testCases = Integer.parseInt(in.readLine());
    }

    private void readInput() throws IOException {
        combinations = 0;

        String line = in.readLine();
        String[] content = line.split(" ");
        int c = Integer.parseInt(content[0]);
        for (int i = 1; i <= c; i++) {
            String comb = content[i];
            elCombinations[combinations][EL1] = comb.charAt(0);
            elCombinations[combinations][EL2] = comb.charAt(1);
            elCombinations[combinations][RES] = comb.charAt(2);
            elCombinations[combinations][EL1_C] = 0;
            elCombinations[combinations++][EL2_C] = 0;
        }

        int d = Integer.parseInt(content[c+1]);
        for (int i = 1; i <= d; i++) {
            String comb = content[c+i+1];
            elCombinations[combinations][EL1] = comb.charAt(0);
            elCombinations[combinations][EL2] = comb.charAt(1);
            elCombinations[combinations][RES] = 0;
            elCombinations[combinations][EL1_C] = 0;
            elCombinations[combinations++][EL2_C] = 0;
        }

        startElement = 0;
        elementsCount = Integer.parseInt(content[c+d+2]);
        String elms = content[c+d+3];

        for (int i = 0; i < elementsCount; i++)
            elements[i] = elms.charAt(i);
    }

    private void solveCase() {
        int pointer = 0;

        while (pointer < elementsCount) {
            char el = elements[pointer];
            int combined = -1;
            boolean opposed = false;
            for (int i = 0; i < combinations; i++) {
                char combineEl = 0;
                if (elCombinations[i][EL1] == el) {
                    // Handle two equal elements in combination
                    if (elCombinations[i][EL1_C] > elCombinations[i][EL2_C] && elCombinations[i][EL2] == el)
                        elCombinations[i][EL2_C]++;
                    else
                        elCombinations[i][EL1_C]++;
                    combineEl = elCombinations[i][EL2];
                }
                else if (elCombinations[i][EL2] == el) {
                    elCombinations[i][EL2_C]++;
                    combineEl = elCombinations[i][EL1];
                }

                if (elCombinations[i][EL1_C] > 0 && elCombinations[i][EL2_C] > 0) {
                    if (elCombinations[i][RES] == 0)
                        opposed = true;
                    else if (elements[pointer-1] == combineEl)
                        combined = i;
                }
            }

            if (combined >= 0) {
                opposed = false;
                char prevEl = elements[pointer-1];
                for (int i = 0; i < combinations; i++) {
                    if (elCombinations[i][EL1] == elCombinations[i][EL2] && prevEl == el && elCombinations[i][EL1] == el) {
                        if (elCombinations[i][EL1_C] > 0)
                            elCombinations[i][EL1_C]--;
                        if (elCombinations[i][EL2_C] > 0)
                            elCombinations[i][EL2_C]--;
                    }
                    else {
                        if (elCombinations[i][EL1] == el && elCombinations[i][EL1_C] > 0)
                            elCombinations[i][EL1_C]--;
                        if (elCombinations[i][EL1] == prevEl && elCombinations[i][EL1_C] > 0)
                            elCombinations[i][EL1_C]--;
                        if (elCombinations[i][EL2] == el && elCombinations[i][EL2_C] > 0)
                            elCombinations[i][EL2_C]--;
                        if (elCombinations[i][EL2] == prevEl && elCombinations[i][EL2_C] > 0)
                            elCombinations[i][EL2_C]--;
                    }
                }
                elements[pointer-1] = 0;
                elements[pointer] = elCombinations[combined][RES];
            }

            pointer++;
            if (opposed) {
                startElement = pointer;
                for (int i = 0; i < combinations; i++) {
                    elCombinations[i][EL1_C] = 0;
                    elCombinations[i][EL2_C] = 0;
                }
            }
        }
    }

    public void solve() throws IOException {
        for (int i = 1; i <= testCases; i++) {
            readInput();
            solveCase();

            out.write("Case #" + i + ": [");
            while (elementsCount > startElement && elements[startElement] == 0)
                startElement++;
            if (elementsCount > startElement) {
                out.write(elements[startElement]);
                for (int j = startElement+1; j < elementsCount; j++)
                    if (elements[j] != 0)
                        out.write(", " + elements[j]);
            }
            out.write("]\n");
        }
        in.close();
        out.close();
    }

    public static void main(String[] args) {
        try {
            new Magicka(new FileReader("/home/ayzen/in"), new FileWriter("/home/ayzen/out")).solve();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

}
