import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * @author ayzen
 */
public class Lawnmower {

    public static void main(String[] args) throws IOException {
        Scanner in = new Scanner(new File("/home/ayzen/in"));
        BufferedWriter out = new BufferedWriter(new FileWriter("/home/ayzen/out"));

        int count = in.nextInt();
        for (int i = 1; i <= count; i++) {
            PriorityQueue<Square> heap = new PriorityQueue<Square>();
            int n = in.nextInt();
            int m = in.nextInt();
            Square[][] lawn = new Square[n][m];

            for (int j = 0; j < n; j++) {
                for (int k = 0; k < m; k++) {
                    int height = in.nextInt();
                    lawn[j][k] = new Square(j, k, height);
                    heap.add(lawn[j][k]);
                }
            }

            boolean correct = true;
            while (!heap.isEmpty()) {
                Square s = heap.poll();

                boolean found = false;
                for (int j = 0; j <= n; j++) {
                    if (j == n)
                        found = true;
                    else if (lawn[j][s.m].height > s.height)
                        break;
                    else
                        lawn[j][s.m].checked = true;
                }
                for (int k = 0; k <= m; k++) {
                    if (k == m)
                        found = true;
                    else if (lawn[s.n][k].height > s.height)
                        break;
                    else
                        lawn[s.n][k].checked = true;
                }

                if (!found) {
                    correct = false;
                    break;
                }
            }
            out.write("Case #" + i + ": " + (correct ? "YES" : "NO") + "\n");
        }

        out.close();
    }

    private static class Square implements Comparable<Square> {
        int n;
        int m;
        int height;
        boolean checked = false;

        public Square(int n, int m, int height) {
            this.n = n;
            this.m = m;
            this.height = height;
        }

        @Override
        public int compareTo(Square that) {
            return this.height - that.height;
        }
    }

}
