import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;
import java.util.Scanner;

/**
 * @author Aleksey Lagoshin
 */
public class First {

    public static void main(String[] args) throws Exception {
        Scanner in = new Scanner(new File("/home/ayzen/in"));
        BufferedWriter out = new BufferedWriter(new FileWriter("/home/ayzen/out"));

        int tests = in.nextInt();
        for (int t = 1; t <= tests; t++) {
            double alltime = 0;
            int len = in.nextInt();
            int s = in.nextInt();
            int run = in.nextInt();
            double runtime = in.nextInt();
            int n = in.nextInt();
            int nc = 0;
            int[][] walks = new int[10000][4];
            for (int i = 0; i < n; i++) {
                int b = in.nextInt();
                int e = in.nextInt();
                int w = in.nextInt();
                if (i == 0 && b != 0) {
                    walks[0][0] = 0;
                    walks[0][1] = b;
                    walks[0][2] = s;
                    walks[0][3] = 0;
                    nc++;
                }
                if (i > 0 && walks[i + nc - 1][1] != b) {
                    walks[i + nc][0] = walks[i + nc - 1][1];
                    walks[i + nc][1] = b;
                    walks[i + nc][2] = s;
                    walks[i + nc][3] = 0;
                    nc++;
                }
                walks[i + nc][0] = b;
                walks[i + nc][1] = e;
                walks[i + nc][2] = w + s;
                walks[i + nc][3] = 1;
                if (i == n - 1 && e != len) {
                    nc++;
                    walks[i + nc][0] = e;
                    walks[i + nc][1] = len;
                    walks[i + nc][2] = s;
                    walks[i + nc][3] = 0;
                }
            }

            Arrays.sort(walks, new Comparator<int[]>() {
                public int compare(int[] ints, int[] ints1) {
                    if (ints1[2] == 0)
                        return -1;
                    if (ints[2] == ints1[2])
                        return 0;
                    return ints[2] < ints1[2] ? -1 : 1;
                }
            });

            for (int i = 0; i < n+nc; i++) {
                if (runtime > 0) {
                    int runspeed = walks[i][3] == 1 ? walks[i][2]-s + run : run;
                    int l = walks[i][1] - walks[i][0];
                    double l1 = runspeed * runtime;
                    if (l1 >= l) {
                        double spent = (double)l/runspeed;
                        alltime += spent;
                        runtime -= spent;
                    }
                    else {
                        alltime += runtime;
                        runtime = 0;
                        alltime += (l-l1)/walks[i][2];
                    }
                }
                else {
                    int l = walks[i][1] - walks[i][0];
                    alltime += (double)l/walks[i][2];
                }
            }

            out.write("Case #" + t + ": " + alltime + "\n");
        }

        out.close();
    }

}

