import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;



/**
 * 
 * This class is a solution to the Google Code Jam 2012 Qualification round problem A
 * 
 * This will take as input lines of texts in the Googlerese language and convert into English.
 *   
 * @author Jacob Emil Baungard Hansen
 * @version 1.0
 * @since 14/04/2012
 * @see <a href="http://www.macs.hw.ac.uk/~jeb14">www.macs.hw.ac.uk/~jeb14</a>
 * 
 */
public class Translator {

	// this array will hold all the translations
	static char [] dictionary = new char[26];
	
	// The main method does all the work, taking in the input as well
	// as doing the translations
	public static void main(String args[]) throws IOException{
		// setting up the translatations:
		dictionary[charValue('a')] = 'y'; 
		dictionary[charValue('b')] = 'h';
		dictionary[charValue('c')] = 'e';
		dictionary[charValue('d')] = 's';
		dictionary[charValue('e')] = 'o';
		dictionary[charValue('f')] = 'c';
		dictionary[charValue('g')] = 'v';
		dictionary[charValue('h')] = 'x';
		dictionary[charValue('i')] = 'd';
		dictionary[charValue('j')] = 'u';
		dictionary[charValue('k')] = 'i';
		dictionary[charValue('l')] = 'g';
		dictionary[charValue('m')] = 'l';
		dictionary[charValue('n')] = 'b';
		dictionary[charValue('o')] = 'k';
		dictionary[charValue('p')] = 'r';
		dictionary[charValue('q')] = 'z';
		dictionary[charValue('r')] = 't';
		dictionary[charValue('s')] = 'n';
		dictionary[charValue('t')] = 'w';
		dictionary[charValue('u')] = 'j';
		dictionary[charValue('v')] = 'p';
		dictionary[charValue('w')] = 'f';
		dictionary[charValue('x')] = 'm';
		dictionary[charValue('y')] = 'a';
		dictionary[charValue('z')] = 'q';
		
		// Setup the input
		File f1 = new File("A-small-attempt0.in");
		Scanner s1 = new Scanner(f1);
		// setup the output:
		PrintWriter out = new PrintWriter(new FileWriter("output.out"));
		
		// Get the first line containing the number of lines to translate. There's no need to save the information
		// we can just throw it away
		s1.nextLine();
		// The line to be translated
		String line = "";
		// case number
		int currentLine=0;
		// loop over all the lines (this is why we didn't need the number in the first place
		while(s1.hasNextLine()){
			currentLine++;
			line = "";
			line = s1.nextLine();
			// convert the string to a char array
			char[] charArray = line.toCharArray();
			// loop over the array
			for (int i = 0; i<charArray.length;i++){
				// if the char is a space we ignore it
				if ( charValue(charArray[i]) != -11 ){
					// otherwise we translate the char
					charArray[i] = dictionary[charValue(charArray[i])];
				}
			}
			// convert back to string
			line = new String(charArray);
			// and output the current line
			out.println("Case #"+currentLine+": "+line);
		}
		// close the scanner
		s1.close();
		out.close();
	}
	// Get a numeric value of a char
	public static int charValue(char ch){
		return Character.getNumericValue(ch)-10;
	}
	
}
