
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Scanner;


public class TikTak 
{
	private static char[][] board = new char[4][4];
	private static String[] win = {"XXXX", "XXXT", "XXTX", "XTXX", "TXXX", "OOOO", "OOOT", "OOTO", "OTOO", "TOOO"};
	static LinkedList<String> positions = new LinkedList<String>();
	static int found = -1;
	
	/**
	 * 
	 * @param col
	 * @return
	 */
	public static String getColumn(int col)
	{
		char[] tempList = new char[4];
		for(int i=0; i<4; i++)
		{
			tempList[i] = board[i][col]; 
		}
		
		return (new String(tempList));
	}
	
	public static String getMainDiagonal()
	{
		char[] tempList = new char[4];
		for(int i=0; i<4; i++)
		{
			tempList[i] = board[i][i];
		}
		
		return (new String(tempList));
	}
	
	/**
	 * 
	 * @return
	 */
	public static String getSecondDiagonal()
	{
		int row = 0;
		char[] tempList = new char[4];
		for(int i=3; i>=0; i--)
		{
			tempList[row] = board[row][i];
			row++;
		}
			
		return (new String(tempList));
	}
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new FileReader("input.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));
        
        String cc = sc.nextLine();                
        int cases = Integer.parseInt(cc);
        
        for(int caseNumber=1; caseNumber<=cases; caseNumber++)
        {
        	if(caseNumber>1)
        	{
        		sc.nextLine();
        		positions.clear();
        	}
        	found = -1;
        	pw.print("Case #"+(caseNumber)+": ");
        	
    		for(int row=0; row<4;row++)
    		{
    			String temp = sc.nextLine();
    			int pos = 0;
    			for(int col=0; col<4;col++)
    			{
    				board[row][col] = temp.charAt(pos);
    				pos++;
    			}
    		}
    	    		
    		positions.add(new String(board[0]));
    		positions.add(new String(board[1]));
    		positions.add(new String(board[2]));
    		positions.add(new String(board[3]));
    		positions.add(getColumn(0));
    		positions.add(getColumn(1));
    		positions.add(getColumn(2));
    		positions.add(getColumn(3));
    		positions.add(getMainDiagonal());
    		positions.add(getSecondDiagonal());
    		
    		
    		for(int p=0; p<10; p++)
    		{
    			if(positions.contains(win[p]))
    			{
    				if(win[p].charAt(0)!= 'T')
    				{
            			pw.print(win[p].charAt(0)+" won");
            			pw.println();	
    				}
    				else
    				{
            			pw.print(win[p].charAt(1)+" won");
            			pw.println();	    					
    				}
    				p=10;
    				found = 1;
    			}
    		}
    		
    		if(found == -1)
    		{
    			for(int r=0; r<4; r++)
    			{
    				for(int c=0; c<4; c++)
    				{
    					if(board[r][c]=='.')
    					{
                			pw.print("Game has not completed");
                			pw.println();
                			c=4;
                			r=4;
                			found = 1;
    					}
    				}
    			}
    		}
    		
    		if(found == -1)
    		{
    			pw.print("Draw");
    			pw.println();
    		}
        }
        
        pw.flush();
        pw.close();
        sc.close();
	}

}
