import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

/* Solution to codejam qualifier 2016 C */

public class CoinJam {
	
	private static int[] decToBin(double nextCoin, int length) {
		
		int[] binRep = new int[length];
		
		int i;
		double current = nextCoin;
		
		for(i = 0; i < length; i++) {
			
			binRep[length-1-i] = (int) (current%2);
			current = current/2;
			
		}
		
		return binRep;
		
	}
	
	private static void printBinary(int[] binary) {
		
		int i;
		
		for(i = 0; i < binary.length; i++) {
			
			System.out.print(binary[i]);
			
		}
		
	}
	
	private static String binToStr(int[] binary) {
		
		int i;
		String binStr = new String();
		
		for(i = 0; i < binary.length; i++) {
			
			binStr = binStr + binary[i];
			
		}
		
		return binStr;
		
	}
	
	/* Finds the first non trivial divisor of number
	 * Returns 0 if the number is prime */
	private static int firstDivisor(double valueInCurrBase) {
		
		int i = 0;
		int sqrt = (int) Math.ceil(Math.sqrt(valueInCurrBase));
		
		for(i = 2; i <= sqrt; i++) {
			if(valueInCurrBase%i == 0) {
				return i;
			}
		}
		
		return 0;
		
	}
	
	public static void main(String[] args) {
		
		if(args.length == 0) {
			
			System.out.println("No arguments provided");
			return;
			
		}
		
		try {
			
			File file = new File(args[0]);
			Scanner input = new Scanner(file);
			FileWriter fileOut = new FileWriter("output.txt");
			BufferedWriter writer = new BufferedWriter(fileOut);
						
			int testCases = input.nextInt(); //Never used as is always 1
			int coinLength = input.nextInt();
			int totalCoins = input.nextInt();
			int numCoinsCreated = 0;
			
			writer.write("Case #1:\n");
			
			double nextCoin = (Math.pow(2, coinLength-1) + 1);
			double maxCoin = (Math.pow(2, coinLength));
			
			while(numCoinsCreated < totalCoins && nextCoin < maxCoin) {
//			while(nextCoin < maxCoin) {
				
				//Turn the next coin into binary
				int[] binaryCoin = decToBin(nextCoin, coinLength);
				
printBinary(binaryCoin);
System.out.println(" is next to be tested");

				//An array to hold the divisors, the divisor for the ith base
				//is held at index i-2
				int[] divisors = new int[9];
				
				//Test the coin's interpretations in each base to ensure these are not prime.
				int base;
				
				for(base = 2; base <= 10; base++) {
					
					double valueInCurrBase = 0;
					int i;
					for(i = 0; i < coinLength; i++) {
						valueInCurrBase += Math.pow(base, i) * binaryCoin[coinLength-1-i];
					}
					
System.out.println(valueInCurrBase);
					
					int divisor = firstDivisor(valueInCurrBase);
					
					if(divisor == 0) {
						break;
					} else {
						divisors[base-2] = divisor;
					}
					
				}
				
				if(base > 10) {
					
					//We found a jamcoin!
					//Print the jamcoin
					writer.write(binToStr(binaryCoin));
					
					//Print each of the divisors
					int i;
					
					for(i = 0; i < divisors.length; i++) {
						
						writer.write(" " + divisors[i]);
						
					}
					
					writer.write("\n");
					
					numCoinsCreated++;
					
				}
				
				//Go to next coin
				nextCoin += 2;
				
			}
			
			writer.close();
			fileOut.close();
			input.close();
			
		} catch(FileNotFoundException e) {
			
			System.out.println("Error reading input file");
			
		} catch(IOException e) {
			
			System.out.println("Error writing output");
			
		}
		
	}

}
