import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Fractiles {
	
	public static void main(String[] args) {
		
		if(args.length == 0) {
			
			System.out.println("No arguments provided");
			return;
			
		}
		
		try {
			
			File file = new File(args[0]);
			Scanner input = new Scanner(file);
			FileWriter fileOut = new FileWriter("output.txt");
			BufferedWriter writer = new BufferedWriter(fileOut);
						
			int numTestCases = input.nextInt();
			
			int i;
			
			for(i = 0; i < numTestCases; i++) {
				
				int tilesInOriginal = input.nextInt();
				int complexity = input.nextInt();
				int numCleans = input.nextInt();
				
				writer.write("Case #" + (i+1) + ":");
				
				int j;
				
				//Clearly if k = s then we just clean the first k tiles
				//Because the first k tiles will either be a copy of the original (if resulting from an L)
				//Or will be all Gs if resulting from a G
				
				for(j = 0; j < numCleans; j++) {
					
					writer.write(" " + (j+1));
					
				}
				
				writer.write("\n");
				
				
			}
			
			writer.close();
			fileOut.close();
			input.close();
			
		} catch(FileNotFoundException e) {
			
			System.out.println("Error reading input file");
			
		} catch(IOException e) {
			
			System.out.println("Error writing output");
			
		}
		
	}

}
