import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

public class TicTacToeTomek {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner console = new Scanner(System.in);
        FileInputStream fis = new FileInputStream(new File(Helpers.INPUT_DIR + console.nextLine()));
        Scanner fin = new Scanner(fis);
        PrintStream fout = new PrintStream(new FileOutputStream(new File(
                Helpers.getFilename("TicTacToeTomek"))));

        int numCases = fin.nextInt();
        // Eat the newline
        fin.nextLine();

        char[][] game = new char[4][4];
        for (int i = 1; i <= numCases; i++) {
            readGame(fin, game);
            String verdict = judgeGame(game);
            fout.println("Case #" + i + ": " + verdict);
        }
    }

    public static void readGame(Scanner in, char[][] game) {
        for (int i = 0; i < 4; i++) {
            String line = in.nextLine();
            for (int j = 0; j < line.length(); j++) {
                game[i][j] = line.charAt(j);
            }
        }
        try {
            in.nextLine(); // Eat newline
        } catch (Exception e) { }
    }

    public static void printGame(PrintStream fout, char[][] game) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                fout.print(game[i][j]);
            }
            fout.println();
        }
    }

    public static String judgeGame(char[][] game) {
        boolean dotFound = false;

        // Loop over rows
        for (int i = 0; i < 4; i++) {
            char firstChar = (game[i][0] == 'T' ? game[i][1] : game[i][0]);
            for (int j = 1; j < 4; j++) {
                if (game[i][j] == '.') {
                    dotFound = true;
                    break;
                }
                if (game[i][j] != firstChar && game[i][j] != 'T')
                    break;
                if (j == 3)
                    return firstChar + " won";
            }
        }

        // Loop over columns
        for (int i = 0; i < 4; i++) {
            char firstChar = (game[0][i] == 'T' ? game[1][i] : game[0][i]);
            for (int j = 1; j < 4; j++) {
                if (game[j][i] == '.') {
                    dotFound = true;
                    break;
                }
                if (game[j][i] != firstChar && game[j][i] != 'T')
                    break;
                if (j == 3)
                    return firstChar + " won";
            }
        }

        // Loop over top left to bottom right diagonal
        {
            char firstChar = (game[0][0] == 'T' ? game[1][1] : game[0][0]);
            for (int i = 0; i < 4; i++) {
                if (game[i][i] == '.') {
                    dotFound = true;
                    break;
                }
                if (game[i][i] != firstChar && game[i][i] != 'T')
                    break;
                if (i == 3)
                    return firstChar + " won";
            }
        }

        // Loop over top right to bottom left diagonal
        {
            char firstChar = (game[0][3] == 'T' ? game[1][2] : game[0][3]);
            for (int i = 0; i < 4; i++) {
                if (game[i][3 - i] == '.') {
                    dotFound = true;
                    break;
                }
                if (game[i][3 - i] != firstChar && game[i][3 - i] != 'T')
                    break;
                if (i == 3)
                    return firstChar + " won";
            }
        }

        if (dotFound) {
            return "Game has not completed";
        } else {
            return "Draw";
        }
    }
}
