import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;


public class FairAndSquare {
    
    public static void main(String[] args) throws Throwable {
        Scanner console = new Scanner(System.in);
        FileInputStream fis = new FileInputStream(new File(Helpers.INPUT_DIR + console.nextLine()));
        Scanner fin = new Scanner(fis);
        PrintStream fout = new PrintStream(new FileOutputStream(new File(
                Helpers.getFilename("FairAndSquare"))));

        int numCases = fin.nextInt();
        // Eat the newline
        fin.nextLine();
        
        for (int i=0; i<numCases; i++) {
            int lower = fin.nextInt();
            int upper = fin.nextInt();
            fin.nextLine(); // Eat newline
            int numFas = findNumFas(lower, upper);
            fout.println("Case #" + (i+1) + ": " + numFas);
        }
    }

    public static int findNumFas(int lower, int upper) {
        int count = 0;
        for (int i=lower; i<=upper; i++) {
            int sqrt = (int) Math.sqrt(i);
            if (sqrt * sqrt == i && isPalindromic(i) && isPalindromic(sqrt)) {
                count++;
            }
        }
        return count;
    }
    
    public static boolean isPalindromic(int n) {
        return isPalindrome("" + n);
    }
    
    public static boolean isPalindrome(String s) {
        if (s.length() < 2) {
            return true;
        } else if (s.charAt(0) == s.charAt(s.length() -1)) {
            if (s.length() == 2) {
                return true;
            } else {
                return isPalindrome(s.substring(1, s.length()-1));
            }
        } else {
            return false;
        }
    }
}
