import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Googlerese {
	private char[] key; // Used to decode the messages. Index is order of number
						// of letter needed to decode, i.e. key[1] is the
						// replacement for a.

	/**
	 * Basic constructor. decoded is partially filled key
	 * @param decoded
	 */
	public Googlerese(char[] given) {
		key = given;
	}

	/**
	 * Solve the problem.
	 * 
	 * @param args
	 */
	public static void main(String[] args) {
		// Initialize the key and fill in given information
		char[] given = new char[26];
		given[(int) 'a' - 97] = 'y';
		given[(int) 'y' - 97] = 'a';
		given[(int) 'o' - 97] = 'e';
		given[(int) 'e' - 97] = 'o';
		given[(int) 'z' - 97] = 'q';
		given[(int) 'q' - 97] = 'z';

		Googlerese solver = new Googlerese(given);

		// Fill in the rest of the key using the 3 given test cases
		solver.fillInKey("ejp mysljylc kd kxveddknmc re jsicpdrysi",
				"our language is impossible to understand");
		solver.fillInKey("rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
				"there are twenty six factorial possibilities");
		solver.fillInKey("de kr kd eoya kw aej tysr re ujdr lkgc jv",
				"so it is okay if you want to just give up");
		
		//Take in the input and solve with the key
		try {
			//Input I/O handler
			File input = new File(args[0]);
			Scanner sc = new Scanner(input);
			int cases= Integer.parseInt(sc.nextLine());
			
			//Output I/O handler
			FileWriter output = new FileWriter(args[1],true);
			PrintWriter pw = new PrintWriter(output);
			
			//Process all the cases
			for (int i= 1; i <= cases; i++) {
				String line= sc.nextLine();
				pw.println("Case #" + i + ": " + solver.decode(line));
				pw.flush();
			};
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
	}

	/**
	 * Searches the given strings for matches to fill in the decoding key field.
	 * 
	 * @param crypted
	 * @param cracked
	 */
	private void fillInKey(String crypted, String cracked) {
		for (int i = 0; i < crypted.length(); i++) {
			char index = crypted.charAt(i);
			if (index != ' ') {
				key[(int) index - 97] = cracked.charAt(i);
			}
		}
	}

	/**
	 * Takes a line of input and decodes it.
	 * @param line
	 * @return
	 */
	private String decode(String line) {
		String result= "";
		for(int k= 0; k < line.length(); k++) {
			if(line.charAt(k) == ' '){
				result= result + ' ';
			} else {
				result= result + key[(int)line.charAt(k)-97];
			}
		}
		return result;
	}
}
