import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

import javax.swing.JFileChooser;


public class A {
	private int typed;
	private int whole;
	private double[] prob; 
	
	private double min;
	
	/**
	 * Constructor
	 */
	public A(int t, int w, double[] p) {
		typed = t;
		whole = w;
		prob = p;
		min = Double.MAX_VALUE;
	}
	
	private double finish() {
		double correctProb = 1;
		for (double d: prob) {
			correctProb *= d; 
		}
		double result = (whole-typed+1)*correctProb + ((whole-typed+1)+whole+1)*(1-correctProb);
		
		return result;
	}
	
	private double back(int n) {
		double split = 1;
		for(int i = 1; i <= typed-n; i++){
			split *= split * prob[i-1];
		}
		double result = (2*n+whole-typed+1)*split + ((2*n+whole-typed+1)+(whole+1))*(1-split);
		
		return result;
	}
	
	private double retry() {
		return 1+whole+1;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		//Get the input file
		File input = null;
		JFileChooser chooser = new JFileChooser();
		int returnValue = chooser.showOpenDialog(null);
		if(returnValue == JFileChooser.APPROVE_OPTION) {
			input = chooser.getSelectedFile();
		} else {
			System.out.println("File was not inputted correctly");
		}
		
		//Parse the input file
		try {
			//Input i/o handler
			Scanner sc = new Scanner(input);
			int cases = Integer.parseInt(sc.nextLine());
			
			//Output i/o handler
			String path = input.getAbsolutePath();
			path = path.substring(0, path.length()-7) + "_out.txt";
			FileWriter output = new FileWriter(path, true);
			PrintWriter pw = new PrintWriter(output);
			
			//Process all the cases
			for (int i = 1; i <= cases; i++) {
				String[] pass = sc.nextLine().split(" ");
				String[] probString = sc.nextLine().split(" ");
				int t = Integer.parseInt(pass[0]);
				int w = Integer.parseInt(pass[1]);
				double[] p = new double[t];
				for (int k = 0; k < probString.length; k++) {
					p[k] = Double.parseDouble(probString[k]);
				}
				
				A solver = new A(t, w, p);
				
				solver.min = solver.finish();
				solver.min = Math.min(solver.min, solver.retry());
				for (int l = 1; l <= t; l++) {
					solver.min = Math.min(solver.min, solver.back(l));
				}
				
				String result = "" + solver.min;
						
				pw.println("Case #" + i + ": " + result);
				pw.flush();
			}
			
		} catch (FileNotFoundException e1) {
			e1.printStackTrace();
		} catch (IOException e2) {
			e2.printStackTrace();
		}
	}
}
