import java.util.*;
import java.io.*;

public class PB{
	
	public static long minCost(int round, int game, int[] m, long[][] prices){
		if (round <= 0) return ( (m[2*game] <= 0 || m[2*game+1] <= 0) ? prices[round][game] : 0);
		long try1 = minCost(round - 1, 2*game, m, prices) + minCost(round - 1, 2*game+1, m, prices) + prices[round][game]; //cost of going to this game
		int numTeams = (1 << (round+1));
		int startTeam = game * numTeams;
		boolean canMiss = true;
		for (int i = startTeam; i < (game+1) * numTeams; i++){
			if (m[i] <= 0){
				canMiss = false;
				break;
			}
		}
		long try2 = Long.MAX_VALUE;
		if (canMiss){
			for (int i = startTeam; i < (game+1) * numTeams; i++) m[i]--; //potentially missing these games
			try2 = minCost(round - 1, 2*game, m, prices) + minCost(round - 1, 2*game+1, m, prices);
			for (int i = startTeam; i < (game+1) * numTeams; i++) m[i]++; //reset what games can be missed
		}
		//System.err.print("Round "+round+", game "+game+" uses:");
		if (try1 < try2){
			//System.err.println(" going to this game");
			return try1;
		} else {
			//System.err.println(" NOT going to this game");
			return try2;
		}
			
	}
	
	public static void main(String[] args) throws Exception{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int numCases = Integer.parseInt(br.readLine().trim());
		for (int caseNum = 1; caseNum <= numCases; caseNum++){
			int p = Integer.parseInt(br.readLine().trim());
			int numTeams = 1 << p;
			//System.err.println("P is "+p+", numTeams is "+numTeams);
			String[] parts = br.readLine().trim().split("[\\s]+");
			int[] m = new int[numTeams];
			for (int i = 0;  i < numTeams; i++) m[i] = Integer.parseInt(parts[i]);
			long[][] prices = new long[p][numTeams/2 +1];
			for (int i = 0; i<p; i++){
				parts = br.readLine().trim().split("[\\s]+");
				//System.err.println(Arrays.toString(parts));
				for (int j = 0; j < parts.length; j++){
					prices[i][j] = Integer.parseInt(parts[j]);
				}
			}
			
			long minCost = minCost(p - 1, 0, m, prices);
			System.out.println("Case #"+caseNum+": "+minCost);
		}
	}
	
}