import java.io.*;
import java.util.*;

public class PC{
	
	public static void main(String[] args) throws Exception{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int numCases = Integer.parseInt(br.readLine().trim());
		for (int caseNum = 1; caseNum <= numCases; caseNum++){
			String[] parts = br.readLine().trim().split("[\\s]+");
			long rides = Long.parseLong(parts[0]);
			long capacity = Long.parseLong(parts[1]);
			int nGroups = Integer.parseInt(parts[2]);
			
			long[] gSize = new long[nGroups]; //the size of each group
			int[] canTake = new int[nGroups]; //if group i is at the front, canTake[i] is the last group that can also go on
			long[] takeSize = new long[nGroups]; //the number of people in the selection canTake
			long totalPeople = 0;
			
			parts = br.readLine().trim().split("[\\s]+");
			for (int i=0; i< nGroups; i++){
				gSize[i] = Long.parseLong(parts[i]);
				totalPeople += gSize[i];
			}
			
			if (totalPeople <= capacity){
				//everyone can fit on the rollercoaster
				System.out.println("Case #"+caseNum+": "+totalPeople * rides);
				continue;
			} else {
				//not everyone can fit
				
				//calcualte which groups can go
				for (int i=0; i<nGroups; i++){
					//for each group, at the start of the queue
					for (int j=i, g = 0; g < nGroups; j = (j + 1)%nGroups, g++){
						//for each group behind group i
						if (takeSize[i] + gSize[j] > capacity){
							//can't take any more people with this trip
							canTake[i] = j;
							break;
						}
						takeSize[i] += gSize[j];
					}
				}
				
				//put people on the rides
				int front = 0; //group at the front of the queue
				long profit = 0; //profit aka number of rides
				for (long ride = 0; ride < rides; ride++){
					profit += takeSize[front];
					front = canTake[front];
				}
				
				System.out.println("Case #"+caseNum+": "+profit);
			}
		}
	}
	
}