import java.util.*;
import java.io.*;

public class A{

	static int moveTo(int cPos, int dPos, int time){
		if (time > Math.abs(dPos - cPos)) return dPos; //enough time to move all the way
		if (cPos > dPos){
			//moving left
			return cPos - time;
		} else {
			//moving right
			return cPos + time;
		}
	}
	
	public static void main(String[] args) throws Exception{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int numCases = Integer.parseInt(br.readLine().trim());
		for (int caseNum = 1; caseNum <= numCases; caseNum++){
			System.out.print("Case #"+caseNum+": ");
			String[] parts = br.readLine().trim().split("\\s+");
			int numInstructions = Integer.parseInt(parts[0]);
			int[] oi = new int[numInstructions];
			int noi = 0;
			int[] bi = new int[numInstructions];
			int nbi = 0;
			for (int instr = 1; instr <= numInstructions; instr++){
				boolean is_oi = parts[2*instr - 1].toLowerCase().equals("o");
				int dest = Integer.parseInt(parts[2*instr]);
				if (is_oi){
					oi[noi++] = dest;
				} else {
					bi[nbi++] = dest;
				}
			}
			int time = 0;
			int opos = 1, bpos = 1;
			int o_i = 0, b_i = 0;
			int bip = 0;
			int time_inc;
			for (int instr = 1; instr <= numInstructions; instr++){
				boolean is_oi = parts[2*instr - 1].toLowerCase().equals("o");
				if (is_oi){
					time_inc = Math.abs(oi[o_i] - opos) + 1;
					opos = oi[o_i++];
					if (b_i < nbi){
						//b has moves left, move it closer to its next position
						int next_b_pos = bi[b_i];
						bpos = moveTo(bpos, next_b_pos, time_inc);
					}
				} else {
					//moving blue this instruction
					time_inc = Math.abs(bi[b_i] - bpos) + 1;
					bpos = bi[b_i++];
					if (o_i < noi){
						//orange has moves left, so move him closer
						opos = moveTo(opos, oi[o_i], time_inc);
					}
				}
				time += time_inc;
			}
			System.out.println(time);
		}
	}
	
}
