import java.io.BufferedReader;
import java.io.FileReader;

public class B {

  private static final int[] NOP = { 0, 0};
  private static final int[] N = { -1, 0};
  private static final int[] S = { 1, 0};
  private static final int[] E = { 0, 1};
  private static final int[] W = { 0, -1};

  public final static void main(String[] args) throws Exception {
    BufferedReader in = new BufferedReader(new FileReader(args[0]));
    int T = Integer.parseInt(in.readLine().trim());
    for (int mapnum = 0; mapnum < T; mapnum++) {
      String s = in.readLine().trim();
      int H = Integer.parseInt(s.split(" ")[0]);
      int W = Integer.parseInt(s.split(" ")[1]);
      int[][] inmap = new int[H][W];
      char[][] outmap = new char[H][W];
      for (int row = 0; row < H; row++) {
        s = in.readLine().trim();
        String[] ar = s.split(" ");
        if (ar.length != W) throw new Error("SDLKFJ");
        for (int col = 0; col < W; col++) {
          if (ar[col].length() != 1) throw new Error("SDLKFJ");
          inmap[row][col] = ar[col].charAt(0);
          outmap[row][col] = '0';
        }
      }
      eval(inmap, outmap);
      System.out.print("Case #" + (mapnum + 1) + ":");
      for (int x = 0; x < H; x++) {
        System.out.println();
        for (int y = 0; y < W; y++) {
          if (y > 0) System.out.print(' ');
          System.out.print(outmap[x][y]);
        }
      }
      System.out.println();
    }
    in.close();
  }

  private static void eval(int[][] inmap, char[][] outmap) {
    LABEL = 'a';
    for (int r = 0; r < inmap.length; r++) {
      for (int c = 0; c < inmap[0].length; c++) {
        char ch = dive(r, c, inmap, outmap);
        redive(r, c, inmap, outmap, ch);
      }
    }
  }

  private static void redive(int r, int c, int[][] inmap, char[][] outmap,
      char ch) {
    if (outmap[r][c] != '0') {
      if (outmap[r][c] != ch) throw new Error();
      return;
    }
    outmap[r][c] = ch;
    int[] flowdir = getflowdir(inmap,r,c);
    if (flowdir == NOP) {
      throw new Error();
    }
    redive(r+flowdir[0],c+flowdir[1],inmap,outmap,ch);
  }

  private static int[] getflowdir(int[][] inmap, int r, int c) {
    int alt = inmap[r][c];
    int[] ret = NOP;
    if (r>0) {
      // N
      if (inmap[r-1][c] < alt) {
        alt = inmap[r-1][c];
        ret = N;
      }
    }
    if (c>0) {
      if (inmap[r][c-1] < alt) {
        alt = inmap[r][c-1];
        ret = W;
      }
    }
    if (c < inmap[0].length - 1) {
      if (inmap[r][c+1] < alt) {
        alt = inmap[r][c+1];
        ret = E;
      }
    }
    if (r < inmap.length - 1) {
      if (inmap[r+1][c] < alt) {
        alt = inmap[r+1][c];
        ret = S;
      }
    }
    return ret;
  }

  static char LABEL = 'a';

  private static char dive(int r, int c, int[][] inmap, char[][] outmap) {
    if (outmap[r][c] != '0')
      return outmap[r][c];
    int[] flowdir = getflowdir(inmap,r,c);
    if (flowdir == NOP) {
      if (outmap[r][c] != '0') throw new Error();
      outmap[r][c] = LABEL;
      if (LABEL > 'z') throw new Error();
      LABEL++;
      return outmap[r][c];
    }
    return dive(r+flowdir[0], c+flowdir[1], inmap, outmap);
  }

}
