import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class D {
	public static void main(String[] args) throws Exception {
		File f = new File(args[0]);
		BufferedWriter out = new BufferedWriter(new FileWriter(new File(args[0]
				+ ".out")));
		Scanner s = new Scanner(f);
		int N = s.nextInt();
		for (int n = 0; n < N; n++) {
			int k = s.nextInt();
			String str = s.next();
			PermutationGenerator pg = new PermutationGenerator(k);
			int count = Integer.MAX_VALUE;
			while (pg.hasMore()) {
				System.out.println(pg.getNumLeft() + " "+pg.hasMore());
				int[] idx = pg.getNext();
				System.out.println(pg.getNumLeft() + " "+pg.hasMore());
				count= Math.min(count,eval(remap(str,idx)));
			}
			out.write("Case #" + (n + 1) + ": " + (count) + "\n");
		}
		out.close();
	}

	private static int eval(String remap) {
		int ret = 1;
		for (int x = 1; x < remap.length(); x++) {
			if (remap.charAt(x) != remap.charAt(x-1))
				ret++;
		}
		return ret;
	}

	private static String remap(String str, int[] idx) {
		String ret = "";
		for (int x=0;x<str.length()/idx.length;x++) {
			for (int y=0;y<idx.length;y++) {
				ret += str.charAt(x*idx.length+idx[y]);
			}
		}
		System.out.println(str+" --> "+ret);
		return ret;
	}

	static public class PermutationGenerator {
		// adapted from http://www.merriampark.com/perm.htm
		private int[] a;
		private int numLeft;
		private int total;

		public PermutationGenerator(int n) {
			if (n < 1) {
				throw new IllegalArgumentException("Min 1");
			}
			a = new int[n];
			total = getFactorial(n);
			System.out.println(n + " --> "+total);
			for (int i = 0; i < a.length; i++)
				a[i] = i;
			numLeft = total;
		}

		public int getNumLeft() {
			return numLeft;
		}
		public int getTotal() {
			return total;
		}
		public boolean hasMore() {
			return numLeft > 0;
		}
		private int getFactorial(int n) {
			int fact = 1;
			for (int i = n; i > 1; i--) {
				fact = fact * i;
			}
			return fact;
		}

		// --------------------------------------------------------
		// Generate next permutation (algorithm from Rosen p. 284)
		// --------------------------------------------------------

		public int[] getNext() {

			if (numLeft == total) {
				numLeft = numLeft - 1;
				return a;
			}

			int temp;

			// Find largest index j with a[j] < a[j+1]

			int j = a.length - 2;
			while (a[j] > a[j + 1]) {
				j--;
			}

			// Find index k such that a[k] is smallest integer
			// greater than a[j] to the right of a[j]

			int k = a.length - 1;
			while (a[j] > a[k]) {
				k--;
			}

			// Interchange a[j] and a[k]

			temp = a[k];
			a[k] = a[j];
			a[j] = temp;

			// Put tail end of permutation after jth position in increasing
			// order

			int r = a.length - 1;
			int s = j + 1;

			while (r > s) {
				temp = a[s];
				a[s] = a[r];
				a[r] = temp;
				r--;
				s++;
			}

			numLeft = numLeft-1;
			return a;

		}

	}
}
