package codejam.r22012;

import java.io.File;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Random;
import java.util.Scanner;

public class Yoga {
  public static void main(String[]args) throws Exception {
    File f = new File(args[0]);
    File f2 = new File(f.getParentFile(),f.getName()+".out");
    Scanner s = new Scanner(f);
    int T = s.nextInt();
    for (int t = 1; t <= T; t++) {
      int N = s.nextInt();
      int W = s.nextInt();
      int L = s.nextInt();
      int[] r = new int[N];
      for (int i=0;i<N;i++) {
        r[i] = s.nextInt();
      }
      println(f2,"Case #"+t+": "+solve(W,L,r));
    }
    s.close();
  }
  private static String solve(int w, int l, int[] r) {
    int x[] = new int[r.length];
    int y[] = new int[r.length];
    int N = r.length;
    Arrays.fill(x, -1);
    Arrays.fill(y, -1);
    BitSet used = new BitSet();
    Random rand = new Random();
    foo:
    while (used.nextClearBit(0) != N) {
      int maxrad = -1;
      int idx = -1;
      for (int j = used.nextClearBit(0); j != N; j = used.nextClearBit(j+1)) {
        if (r[j] > maxrad) {
          maxrad = r[j];
          idx = j;
        }
      }
      if (attempt(idx,maxrad,l,w,r,x,y,0,0, used))
        continue;
      if (attempt(idx,maxrad,l,w,r,x,y,w,0, used))
        continue;
      if (attempt(idx,maxrad,l,w,r,x,y,0,l, used))
        continue;
      if (attempt(idx,maxrad,l,w,r,x,y,w,l, used))
        continue;
      int derp = 0;
      while (derp++ < 10000) {
        if (attempt(idx, maxrad, l, w, r,x, y, rand.nextInt(w+1), rand.nextInt(l+1), used))
          continue foo;
      }
      throw new Error();
    }

    String s = "";
    for (int i=0;i<x.length;i++) {
      if (i>0) s+=" ";
      s += x[i] + " " + y[i];
      if (-1==(x[i]) || -1==(y[i])) throw new Error();
    }
    return s;
  }
  private static boolean attempt(int idx, int rad, int l, int w, int[] r, int[] x, int[] y, int i, int j, BitSet bs) {
    int[] mine = bounds(rad, l, w, i, j);

    for (int a = 0; a<x.length; a++) {
      if (-1==(x[a])) continue;
      if (intersects(mine, bounds(r[a],l,w,x[a],y[a]))) return false;
    }
    x[idx] = i;
    y[idx] = j;
    bs.set(idx);
    return true;
  }
  private static boolean intersects(int[] a, int[] b) {
    return intersects(a[0],a[2], b[0],b[2]) && intersects(a[1],a[3],b[1],b[3]);
  }
  private static boolean intersects(int x1, int x2, int x3, int x4) {
    assert x2>x1;
    assert x4>x3;
    if (x3 < x1) return intersects(x3,x4,x1,x2);
    if (x3 >= x2) return false;
    assert x3 >= x1;
    assert x3 < x2;
    return true;
  }
  private static int[] bounds(int rad, int l, int w, int i, int j) {
    int xmin = Math.max(0, i-rad);
    int ymin = Math.max(0, j - rad);
    int xmax = Math.min(w, i+rad);
    int ymax = Math.min(l, j+rad);
    int[] bounds = new int[]{xmin,ymin,xmax,ymax};
    return bounds;
  }
  static void println(File f, String s) throws Exception {
    FileWriter w = new FileWriter(f,true);
    w.write(s+"\n");
    w.close();
    System.out.println(s);
  }

}
