import java.io.BufferedReader;
import java.io.FileReader;


public class A1 {
	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader(args[0]));
		int T = Integer.parseInt(in.readLine());
		for (int t=1;t<=T;t++) {
			System.out.print("Case #"+t+": ");
			String s = in.readLine();
			String[] arr = s.split(" ");
			int N = Integer.parseInt(arr[0]);
			int K = Integer.parseInt(arr[1]);
			char[][] board = new char[N][];
			for (int n=0;n<N;n++) {
				board[n] = in.readLine().toCharArray();
				shiftright(board[n]);
				assert board[n].length == N;
			}
			boolean a = check('R',board,K);
			boolean b = check('B',board,K);
			if (a && b) {
				System.out.println("Both");
			} else if (a) {
				System.out.println("Red");
			} else if (b) {
				System.out.println("Blue");
			} else {
				System.out.println("Neither");
			}
		}
	}

	private static boolean check(char c, char[][] board, int k) {
		return h(c,board,k) || v(c,board,k) || diag(c,board,k);
	}
	private static boolean diag(char ch, char[][] board, int k) {
		String s = rep(ch, k);

		int n = board.length;
		for (int r=0;r<n; r++) {
			for (int c=0;c<n; c++) {
				if (r == 0) {
					if (dr(s,r,c,board) || dl(s,r,c,board))
						return true;
				}
				if (c==0) {
					if (dr(s,r,c,board))
						return true;
				}
				if (c == n-1) {
					if (dl(s,r,c,board))
						return true;
				}
			}
		}
		return false;
	}

	private static boolean dl(String s, int r, int c, char[][] board) {
		String str = "";
		while (r<board.length+0 && c>=0) {
			str += board[r][c];
			r++;
			c--;
		}
		return str.indexOf(s) != -1;
	}
	private static boolean dr(String s, int r, int c, char[][] board) {
		String str = "";
		while (r<board.length && c<board.length) {
			str += board[r][c];
			r++;
			c++;
		}
		return str.indexOf(s) != -1;
	}

	private static String rep(char ch, int k) {
		String s = "";
		for (int i=0;i<k;i++) {
			s += ch;
		}
		return s;
	}

	private static boolean v(char ch, char[][] board, int k) {
		String s = rep(ch, k);
		for (int c=0;c<board[0].length; c++) {
			String line= "";
			for (int r=0;r<board.length; r++) {
				line += board[r][c];
			}
			if (line.indexOf(s) != -1)
				return true;
		}
		return false;
	}

	private static boolean h(char c, char[][] board, int k) {
		String s = rep(c, k);
		for (int r=0;r<board.length; r++) {
			String line = new String(board[r]);
			if (line.indexOf(s) != -1)
				return true;
		}
		return false;
	}

	private static void shiftright(char[] cs) {
		int idx = cs.length - 1;
		while (idx > 0) {
			int n = 0;
			while (n != cs.length+1 && cs[idx] == '.') {
				n++;
				System.arraycopy(cs,0,cs,1,idx);
				cs[0] = '.';
			}
			idx--;
		}
	}
}
