import java.io.BufferedReader;
import java.io.FileReader;
import java.util.Arrays;

public class D {
	public static final void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new FileReader(args[0]));
		int C = Integer.parseInt(in.readLine());
		for (int c = 1; c <= C; c++) {
			int N = Integer.parseInt(in.readLine());
			int[][] lines = new int[N][3];
			for (int n = 0; n < N; n++) {
				String[] s = in.readLine().split(" ");
				lines[n][0] = Integer.parseInt(s[0]);
				lines[n][1] = Integer.parseInt(s[1]);
				lines[n][2] = Integer.parseInt(s[2]);
			}
			System.out.println("Case #" + c + ": " + doit(lines));
		}
		in.close();
	}

	// X Y R
	private static double doit(int[][] m) {
		double best = Double.MAX_VALUE;
		int N = m.length;
		for (int a=0;a<N;a++) {
			for (int b=a;b<N;b++) {
				for (int c=b;c<N;c++) {
					for (int d=c;d<N;d++) {
						
						double[] r1 = rad(m[a],m[b]);
						double[] r2 = rad(m[c],m[d]);
						if (valid(r1,r2,m))
							best = Math.min(best, Math.max(r1[2],r2[2]));

						double[] r3 = rad(m[a],m[c]);
						double[] r4 = rad(m[b],m[d]);
						if (valid(r3,r4,m))
							best = Math.min(best, Math.max(r3[2],r4[2]));
						
						double[] r5 = rad(m[a],m[d]);
						double[] r6 = rad(m[b],m[c]);
						if (valid(r5,r6,m))
							best = Math.min(best, Math.max(r5[2],r6[2]));
					}
				}
			}
		}
		return best;
	}

	private static boolean valid(double[] a, double[] b, int[][] m) {
		for (int x=0;x<m.length;x++) {
			if (!within(m[x],a) && !within(m[x],b))
				return false;
		}
		return true;
	}

	private static boolean within(int[] b, double[] a) {
		double vert = Math.abs(b[1]-a[1]);
		double horz = Math.abs(b[0]-a[0]);
		double h = Math.sqrt(vert*vert+horz*horz);
		return a[2] - h-b[2] >- 1e-6;
	}

	// X Y R
	private static double[] rad(int[] a, int[] b) {
		double vert = Math.abs(b[1]-a[1]);
		double horz = Math.abs(b[0]-a[0]);
		double h = Math.sqrt(vert*vert+horz*horz);
		double theta1 = Math.atan(vert/horz);
		double theta2 = Math.atan(horz/vert);
		
		double[]ret = {0,0,(h+a[2]+b[2])/2};
		double L = Math.cos(theta1) * a[2];
		double R = Math.sin(theta2) * b[2];
		if (a[0] == b[0]) {
			ret[0] = a[0];
		}
		else if (a[0]<b[0]) {
			ret[0] = ((a[0] - L) + (b[0]+R))/2.;
		} else {
			ret[0] = ((a[0] + L) + (b[0]-R))/2.;
		}
		
		double U = Math.sin(theta1) * a[2];
		double D = Math.cos(theta2) * b[2];
		if (a[1]==b[1]){
			ret[1] = a[1];
		} else if (a[1]<b[1]) {
			ret[1] = ((a[1] - U) + (b[1]+D))/2.;
		} else {
			ret[1] = ((a[1] + U) + (b[1]-D))/2.;
		}
		if (!within(a,ret)) {
			System.out.println(within(a,ret));
			a=null;
		}
		assert(within(a, ret)) : Arrays.toString(a)+" "+Arrays.toString(ret);
		assert within(b,ret);
		return ret;
	}
}
