import java.io.BufferedReader;
import java.io.FileReader;


public class F {
  static String[] engines, queries;
  static int S, Q;
  public static void main(String[] args) throws Exception {
    BufferedReader r = new BufferedReader(new FileReader("input.txt"));
    int N = Integer.parseInt(r.readLine().trim());
    for (int caseno = 0; caseno < N; caseno++) {
      S = Integer.parseInt(r.readLine().trim());
      engines = new String[S];
      for (int x = 0; x < S; x++)
        engines[x] = r.readLine().trim();
      Q = Integer.parseInt(r.readLine().trim());
      queries = new String[Q];
      for (int x = 0; x < Q; x++)
        queries[x] = r.readLine().trim();
      int answer = solve();
      System.out.print("Case #" + (1 + caseno) + ": " + answer + "\n");
    }
  }

  private static int solve() {
    if (queries.length == 0)
      return 0;

    int[][] a = new int[S][Q];
    for (int e = 0; e < S; e++)
      for (int q = 0; q < Q; q++)
        a[e][q] = Integer.MAX_VALUE;
    for (int e = 0; e < S; e++)
      if (!engines[e].equals(queries[0]))
        a[e][0] = 0;
    for (int q = 1; q < Q; q++) {
      for (int e = 0; e < S; e++)
        if (!engines[e].equals(queries[q])) {
          if (a[e][q - 1] != Integer.MAX_VALUE)
            a[e][q] = a[e][q - 1];
          else {
            int min = Integer.MAX_VALUE;
            for (int eother = 0; eother < engines.length; eother++) {
              min = Math.min(a[eother][q - 1], min);
            }
            a[e][q] = min + 1;
          }
        }
    }

    int best = a[0][queries.length - 1];
    for (int e = 1; e < engines.length; e++)
      best = Math.min(best, a[e][queries.length - 1]);
    return best;
  }
}
