import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;


public class SpeakingInTongs {

	public static void main(String[] args) {
		
		try {
			
			Map<Character, Character> charMap = new HashMap<Character, Character>();
			charMap.put('f', 'c');
			charMap.put('g', 'v');
			charMap.put('d', 's');
			charMap.put('e', 'o');
			charMap.put('b', 'h');
			charMap.put('c', 'e');
			charMap.put('a', 'y');
			charMap.put('n', 'b');
			charMap.put('o', 'k');
			charMap.put('l', 'g');
			charMap.put('m', 'l');
			charMap.put('j', 'u');
			charMap.put('k', 'i');
			charMap.put('h', 'x');
			charMap.put('i', 'd');
			charMap.put('w', 'f');
			charMap.put('v', 'p');
			charMap.put('u', 'j');
			charMap.put('t', 'w');
			charMap.put('s', 'n');
			charMap.put('r', 't');
			charMap.put('p', 'r');
			charMap.put('y', 'a');
			charMap.put('x', 'm');
			charMap.put('q', 'z');
			charMap.put('z', 'q');

			SpeakingInTongs problem = new SpeakingInTongs();
			List<String> input = problem.getInput();
			Writer writer = new FileWriter("output.txt");
			
			for (int i = 0; i < input.size(); i++) {
				
				String currentInput = input.get(i);
				StringBuilder output = new StringBuilder("Case #");
				output.append(i + 1);
				output.append(": ");
				
				for (int j = 0; j < currentInput.length(); j++) {
					Character inputChar = currentInput.charAt(j);
					Character outputChar = charMap.get(inputChar);
					
					output.append(outputChar == null ? inputChar : outputChar);
				}
				
				if (i + 1 != input.size()) {
					output.append('\n');
				}
				
				writer.write(output.toString());
			}
			
			writer.flush();
			writer.close();
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	protected List<String> getInput() throws NumberFormatException, IOException {
		
		BufferedReader reader = new BufferedReader(new FileReader("input.txt"));
		List<String> input = new ArrayList<>();
		int lineCount = Integer.parseInt(reader.readLine());
		
		for (int i = 0; i < lineCount; i++) {
			input.add(reader.readLine());
		}
		
		return input;
	}
}
