import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;



public class Main {
  
    static void print(List<List<Integer>> list) {
        for (int j = 0; j < list.size(); ++j) {
            System.out.println(list.get(j));
        }
    }
    static void print(char[][] a, int rows, int cols) {
        for (int r = 0; r < rows; ++r) {
            for (int c = 0; c < cols; ++c) {
                System.out.print(a[r][c] + " ");
            }
            System.out.println();
        }
    }
    
    static void print(int[][] a, int rows, int cols) {
        for (int r = 0; r < rows; ++r) {
            for (int c = 0; c < cols; ++c) {
                System.out.print(a[r][c] + " ");
            }
            System.out.println();
        }
    }
    
    static <T> void print(T[][] a, int rows, int cols) {
        for (int r = 0; r < rows; ++r) {
            for (int c = 0; c < cols; ++c) {
                System.out.print(a[r][c] + " ");
            }
            System.out.println();
        }
    }

    private static void print(int[] a) {
        for (int i: a) {
            System.out.print(i + " ");
        }
        System.out.println();
    }
    
    static class Node {
        int v;
        Node n;
    }

    static Node buildLinkedList(int[] a) {
        Node r = new Node();
        Node c = r;
        Node p = null;
        for (int v: a) {
            c.v = v;
            c.n = new Node();
            p = c;
            c = c.n;
        }
        p.n = null;
        return r;
    }
    
    private static void print(Node n) {
        while (n != null) {
            System.out.print(n.v + " ");
            n = n.n;
        }
        System.out.println();
    }
    
//    static Node reverseK(Node r, int k) {
//        Node n = new Node();
//        n.n = r;
//        return reverseK(n, k, new LinkedList<Node>());
//    }
    
    static Node reverseK(Node r, int k, LinkedList<Node> q) {
        if (r == null) {
            return r;
        }
        q.add(r);
        int c = k;
        while (r != null && c > 0) {
            r = r.n;
            c--;
        }
        Node n = reverseK(r, k, q);
        if (q.size() <= 1) {
            return n;
        }
        Node n2 = q.removeLast();
        if (n2.n == null) {
            return n;
        }
        Node n1 = q.removeFirst();
        System.out.println(n1.v);
        System.out.println(n2.v);
        r = n1.n;
        n1.n = n2.n;
        n2.n = r;
        r = n1.n.n;
        n1.n.n = n2.n.n;
        n2.n.n = r;
        return n1.n;
    }
    
    static Node reverse(Node p, Node n) {
        if (n == null) {
            return null;
        }
        Node t = reverse(n, n.n);
        if (t == null) {
            t = n;
        }
        n.n = p;
        return t;
    }
    
    static Node reverseK(Node r, int k) {
        if (k == 1) {
            return reverse(null, r);
        }
        Node l1 = r.n;
        Node l2 = extract(r, k);
        l2 = reverse(null, l2);
        insert(l1, l2, k);
        return l2;
    }
    
    static Node extract(Node r, int k) {
        Node ret = r;
        Node l = r;
        Node p = null;
        int c = k;
        while (r != null) {
            if (c == 0) {
                l.n = r;
                l = l.n;
                p.n = r.n;
                c = k;
            }
            p = r;
            r = r.n;
            l.n = null;
            c--;
        }
        return ret;
    }
    
    static void insert(Node l1, Node l2, int k) {
        Node p = null;
        while (l2 != null) {
            Node n = l2;
            l2 = l2.n;
            n.n = l1;
            if (p != null) {
                p.n = n;
            }
            for (int i = 1; i < k; ++i) {
                if (l1 == null) {
                    break;
                }
                p = l1;
                l1 = l1.n;
            }
        }
    }
    
    static int guess(int[][] a1, int[][] a2, int rows, int cols, int  r1, int r2) {
        int[] m = new int[cols * rows];
        int[] g = new int [4];
        int n = 0;
        for (int c = 0; c < cols; ++c) {
            m[a1[r1 - 1][c] - 1] = 1;
        }
        //print(m);
        for (int c = 0; c < cols; ++c) {
            if (m[a2[r2 - 1][c] - 1] == 1) {
                g[n++] = a2[r2 - 1][c];
            }
        }
        if (n == 1) {
            return g[0];
        }
        if (n > 1) {
            return 0;
        }
        return -1;
    }

    static BigDecimal calcTime(BigDecimal p, BigDecimal n, BigDecimal N, BigDecimal C, BigDecimal F, BigDecimal X) {
        if (n.equals(N)) {
            return X.divide(p, 10, BigDecimal.ROUND_CEILING);
        }
        BigDecimal t = C.divide(p, 10, BigDecimal.ROUND_CEILING);
        n = n.add(BigDecimal.ONE);
        p = F.multiply(n).add(new BigDecimal(2));
        return t.add(calcTime(p, n, N, C, F, X));
    }
    
    static String calcTime(double C, double F, double X) {
        BigDecimal min = BigDecimal.TEN.pow(10);
        int n = 0;
        BigDecimal t = min;
        while (min.compareTo(t) >= 0) {
            min = t;
            t = calcTime(new BigDecimal(2), BigDecimal.ZERO, 
                    new BigDecimal(n++), new BigDecimal(C), new BigDecimal(F), new BigDecimal(X));
//            System.out.println("Factories" + (n - 1) + " time " + t);
        }
        return min.toPlainString();
    }
    
    public static void main(String[] args) {
//        System.out.println(calcTime(500, 4, 2000));
//        int r = guess(new int[][]{
//                {1, 2, 3, 4},
//                {5, 6, 7, 8},
//                {9, 10, 11, 12},
//                {13, 14, 15, 16},
//        } , new int[][]{
//                {1, 2, 5, 4},
//                {3, 11, 6, 15},
//                {9, 10, 7, 12},
//                {13, 14, 8, 16},
//        }, 4, 4, 2, 3);
//        int r = guess(new int[][]{
//                {1, 2, 3, 4},
//                {5, 6, 7, 8},
//                {9, 10, 11, 12},
//                {13, 14, 15, 16},
//        } , new int[][]{
//                {1, 2, 3, 4},
//                {5, 6, 7, 8},
//                {9, 10, 11, 12},
//                {13, 14, 15, 16},
//        }, 4, 4, 2, 2);
//        int r = guess(new int[][]{
//                {1, 2, 3, 4},
//                {5, 6, 7, 8},
//                {9, 10, 11, 12},
//                {13, 14, 15, 16},
//        } , new int[][]{
//                {1, 2, 3, 4},
//                {5, 6, 7, 8},
//                {9, 10, 11, 12},
//                {13, 14, 15, 16},
//        }, 4, 4, 2, 3);
//        System.out.println(r);
//        count(6);
//        Node r = buildLinkedList(new int[]{1,2,3,4,5,6,7,8});
//        print(reverseK(r, 3));
        //r = reverseK(r, 2);
        //print(r);
//        System.out.println(fact(16)/ (fact(16 - 1) * fact(1)));
//        System.out.println(count(25));
//        System.out.println(unorderedCombinations(5, 2));
        try {
            Scanner scanner = new Scanner(new File("/tmp/in"));
            int T = scanner.nextInt();
            for (int i = 1; i <= T; ++i) {
//                int r1 = scanner.nextInt();
//                int[][] a1 = new int[4][4];
//                for (int r = 0; r < 4; ++r) {
//                    for (int c = 0; c < 4; ++c) {
//                        a1[r][c] = scanner.nextInt();
//                    }
//                }
//                int r2 = scanner.nextInt();
//                int[][] a2 = new int[4][4];
//                for (int r = 0; r < 4; ++r) {
//                    for (int c = 0; c < 4; ++c) {
//                        a2[r][c] = scanner.nextInt();
//                    }
//                }
//                int r = guess(a1, a2, 4, 4, r1, r2);
//                String res = String.valueOf(r);
//                if (r == 0) {
//                    res = "Bad magician!";
//                }
//                if (r == -1) {
//                    res = "Volunteer cheated!";
//                }
                double C = scanner.nextDouble();
                double X = scanner.nextDouble();
                double F = scanner.nextDouble();
                System.out.format("Case #%d: %s\n", i, calcTime(C, X, F));
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }
    
    private static long count(int n) {
//        n = 25;
        long c = 1;
        for (int s = 2; s < n; ++s) {
            int[] a = new int[s];
            a[s - 1] = n;
            c += count(s, s - 1, n, s, a);
        }
        return c % 100003;
    }
    
    private static long count(int n, int i, int pn, int pi, int[] a) {
        if (i == 1) {
            a[i - 1] = n;
            print(a);
            a[i - 1] = 0;
            return 1;
        }
        if (i == 0) {
            print(a);
            return 1;
        }
        long C = 0;
        while (pn - n >= pi - i) {
            a[i - 1] = n;
            long c = count(i, i - 1, n, i, a);
            a[i - 1] = 0;
            long w = pi - i - 1;
            if (w != 0) {
                long r = pn - n - 1;
                long k = unorderedCombinations(r, w);
                if (k == 0 || c == 0) {
                    System.out.format("fact %d = %d\n", r, w);
                    throw new RuntimeException();
                }
                c *= k;
            }
            C += c;
            if (--i < 1) {
                break;
            }
        }
        return C;
    }

    private static long unorderedCombinations(long r, long w) {
        if (r == w) {
            return 1;
        }
        long d = r - w + 1;
        long res = 1;
        while (d <= r) {
            res *= d;
            d++;
        }
        return res / fact(w);
    }
    
    public static long fact(long n){
        if (n <= 1)
            return 1;
        else
            return n * fact(n-1);
      }
    
}
