/* 
 *
 * This source file is a part of lainexperiment project.
 * Description for it can be found in ReadMe.txt.
 *
 */

package lainexperiment.codejam.qualification._2017;

import static java.util.stream.IntStream.range;

import java.io.IOException;
import java.nio.file.Paths;
import java.util.Scanner;
import java.util.function.IntConsumer;
import java.util.function.IntUnaryOperator;

public class ProblemA_Oversized_Pancake_Flipper {
    
    static void solve(char[] a, int k) {
        IntUnaryOperator flip = i -> a[i] = a[i] == '+'? '-': '+';
        IntConsumer flipK = i -> {
            for (int j = 0; j < k; j++) {
                a[i + j] = (char) flip.applyAsInt(i + j);
            }
        };
        int c = 0;
        for (int i = 0; i <= a.length - k; i++) {
            if (a[i] == '+') continue;
            c++;
            flipK.accept(i);
        }
        System.out.println(range(0, a.length)
            .allMatch(i -> a[i] == '+')? c: "IMPOSSIBLE");
    }
    
    public static void main(String[] args) throws IOException {
        Class<?> clazz = ProblemA_Oversized_Pancake_Flipper.class;
        String inputFile = clazz.getSimpleName() + ".in";
        Scanner scanner = System.getProperty("local") == null?
            new Scanner(Paths.get("/tmp/in")): new Scanner(clazz.getResourceAsStream(inputFile));
        int T = scanner.nextInt();
        scanner.nextLine();
        for (int i = 0; i < T; i++) {
            System.out.format("Case #%d: ", i + 1);
            solve(scanner.next().toCharArray(), scanner.nextInt());
        }
        scanner.close();
    }

}
