/* 
 *
 * This source file is a part of lainexperiment project.
 * Description for it can be found in ReadMe.txt.
 *
 */


package lainexperiment.codejam.qualification._2017;

import java.io.IOException;
import java.nio.file.Paths;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;

public class ProblemC_Bathroom_Stalls {
    
    static Map<Integer, Pair> M = new HashMap<>();
    static Queue<Pair> Q = new PriorityQueue<>(Comparator.comparingInt((Pair p) -> p.n).reversed());
    
    static class Pair {
        public int n, c;
        public Pair(int n) {this.n = n; }
        @Override
        public String toString() {
            return "" + n + ":" + c;
        }
    }
    
    static Pair update(int n) {
        Pair p = M.get(n);
        if (p == null) {
            p = new Pair(n);
            Q.add(p);
            M.put(n, p);
        }
        p.c++;
        return p;
    }
    
    static void solve(int n, int k) {
        M.clear();
        Q.clear();
        update(n);
        while (k > 1) {
            Pair p = Q.peek();
            p.c--;
            int v = p.n / 2;
            Pair pp = update(v);
            if ((p.n & 1) == 1)
                pp.c++;
            else
                update(v - 1);
            if (p.c == 0)
                Q.poll();
            k--;
        }
        int v = Q.poll().n;
        if ((v & 1) == 1)
            System.out.format("%d %d\n", v / 2, v / 2);
        else
            System.out.format("%d %d\n", v / 2, v / 2 - 1);
    }
    
    public static void main(String[] args) throws IOException {
        Class<?> clazz = ProblemC_Bathroom_Stalls.class;
        String inputFile = clazz.getSimpleName() + ".in";
        Scanner scanner = System.getProperty("local") == null?
            new Scanner(Paths.get("/tmp/in")): new Scanner(clazz.getResourceAsStream(inputFile));
        int T = scanner.nextInt();
        scanner.nextLine();
        for (int i = 0; i < T; i++) {
            System.out.format("Case #%d: ", i + 1);
            solve(scanner.nextInt(), scanner.nextInt());
        }
        scanner.close();
    }

}
