package codejam2016.round1a;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

/**
 * Created by b4dt0bi on 02.05.15.
 */
public class B {
    public static void main(String[] args) throws IOException {
        BufferedReader bufferedReader = new BufferedReader(new FileReader(args[0]));
        String line = bufferedReader.readLine();
        int tcs = Integer.parseInt(line);
        for (int tc = 0; tc < tcs; tc++) {
            int n = Integer.parseInt(bufferedReader.readLine());
            int matrix[][] = new int[n * 2 - 1][];
            for (int i = 0; i < n * 2 - 1; i++) {
                String nrs[] = bufferedReader.readLine().split(" ");
                matrix[i] = new int[nrs.length];
                for (int i2 = 0; i2 < nrs.length; i2++) {
                    matrix[i][i2] = Integer.parseInt(nrs[i2]);
                }
            }
            System.out.println("Case #" + (tc + 1) + ": " + getRow(matrix));
        }
        bufferedReader.close();
    }

    private static class IntHolder implements Comparable<IntHolder> {
        public int[] arr;

        public IntHolder(int[] arr) {
            this.arr = arr;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (!(o instanceof IntHolder)) return false;

            IntHolder intHolder = (IntHolder) o;

            return Arrays.equals(arr, intHolder.arr);

        }

        @Override
        public int hashCode() {
            return Arrays.hashCode(arr);
        }

        public int compareTo(IntHolder intHolder) {
            for (int i = 0; i < arr.length; i++) {
                int res = Integer.compare(arr[i], intHolder.arr[i]);
                if (res != 0) return res;
            }
            return 0;
        }
    }

    public static String getRow(int[][] matrix) {
        List<IntHolder> fullList = new ArrayList<IntHolder>();
        for (int i = 0; i < matrix.length; i++) {
            fullList.add(new IntHolder(matrix[i]));
        }
        Collections.sort(fullList);
        int max = (matrix.length + 1) / 2;

        int m[][] = new int[max][max];
        String res = "";
        int[] result = findLine(m, new ArrayList<IntHolder>(fullList), fullList, 0, max);
        for (int i : result) {
            res += i + " ";
        }
        return res.trim();
    }

    private static int[] findLine(int m[][], List<IntHolder> savedList, List<IntHolder> ih, int crr, int max) {
        if (crr == max) {
            List<IntHolder> sih = removeFromList(new ArrayList<IntHolder>(savedList), m);
            int[][] t = transpose(m);
            for (int[] l : t) {
                if (!removeFromList(sih, l)) {
                    return l;
                }
            }
            return null;
        }
        List<IntHolder> myList = new ArrayList<IntHolder>(ih);
        while (!myList.isEmpty()) {
            if (crr == 0) {
                m[crr] = myList.remove(0).arr;
                int[] res = findLine(m, savedList, myList, crr + 1, max);
                if (res != null) return res;
            } else {
                int l[] = myList.remove(0).arr;
                if (fitsBelow(m[crr - 1], l)) {
                    m[crr] = l;
                    int[] res = findLine(m, savedList, myList, crr + 1, max);
                    if (res != null) return res;
                }
            }
        }
        return null;
    }

    private static List<IntHolder> removeFromList(List<IntHolder> l, int m[][]) {
        List<IntHolder> result = new ArrayList<IntHolder>(l);
        for (int[] line : m) {
            removeFromList(result, line);
        }
        return result;
    }

    private static boolean removeFromList(List<IntHolder> l, int line[]) {
        Iterator<IntHolder> it = l.iterator();
        while (it.hasNext()) {
            if (Arrays.equals(it.next().arr, line)) {
                it.remove();
                return true;
            }
        }
        return false;
    }

    private static int[][] transpose(int[][] m) {
        int result[][] = new int[m.length][m.length];
        for (int x = 0; x < m.length; x++) {
            for (int y = 0; y < m.length; y++) {
                result[y][x] = m[x][y];
            }
        }
        return result;
    }

    private static boolean fitsBelow(int[] m, int[] l) {
        for (int i = 0; i < m.length; i++) {
            if (m[i] >= l[i]) return false;
        }
        return true;
    }
}
