import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

/**
 * Created by b4dt0bi on 11.04.15.
 */
public class InfiniteHouseOfPancakes {
    public static void main(String[] args) throws IOException {
        BufferedReader bufferedReader = new BufferedReader(new FileReader(args[0]));
        String line = bufferedReader.readLine();
        int tcs = Integer.parseInt(line);
        for (int i = 0; i < tcs; i++) {

            List<Integer> pancakes = new ArrayList<Integer>(Integer.parseInt(bufferedReader.readLine()));
            String pcs[] = bufferedReader.readLine().split(" ");
            for (int j = 0; j < pcs.length; j++) {
                pancakes.add(Integer.parseInt(pcs[j]));
            }
            Collections.sort(pancakes);
            int minutes = countMinutes(pancakes);
            //System.out.println(Arrays.toString(pcs));
            System.out.println("Case #" + (i + 1) + ": " + minutes);
        }
        bufferedReader.close();
    }

    public static int countMinutes(List<Integer> panCakes) {
        int maxMinutes = maxPancakes(panCakes);
        if (maxMinutes <= 3) return maxMinutes;
        if (maxMinutes == 9) {
            List<Integer> newList = new ArrayList<Integer>(panCakes);
            Iterator<Integer> it = newList.iterator();
            boolean specialCaseFound = false;
            while (it.hasNext()) {
                Integer tmp = it.next();
                if (tmp == maxMinutes && !specialCaseFound) {
                    it.remove();
                    specialCaseFound = true;
                }
                if (tmp <= 3) it.remove();
            }
            if (specialCaseFound && newList.isEmpty()) {
                return 5;
            }
        }

        return minutes(panCakes, maxMinutes, maxMinutes, 0);
    }

    private static int minutes(List<Integer> panCakes, int newMax, int maxTotal, int crrMin) {

        List<Integer> newList2 = new ArrayList<Integer>(panCakes);
        if (newMax > 3) {
            int min1 = Integer.MAX_VALUE;
            for (int div = 2; div < newMax; div++) {
                int tmpMin;
                if (crrMin + newMax / div < maxTotal) {
                    List<Integer> newList1 = new ArrayList<Integer>(panCakes);
                    specialMinute(newList1, div);
                    tmpMin = minutes(newList1, maxPancakes(newList1), maxTotal, crrMin + 1);
                } else {
                    return newMax + crrMin;
                }
                if (tmpMin < min1) min1 = tmpMin;
            }
            eatPanCakes(newList2);
            int min2 = minutes(newList2, newMax - 1, maxTotal, crrMin + 1);
            if (min1 < min2) {
                return min1;
            } else {
                return min2;
            }
        }
        return newMax + crrMin;
    }

    private static void eatPanCakes(List<Integer> panCakes) {
        List<Integer> result = new ArrayList<Integer>();

        for (Integer pancake : panCakes) {
            pancake--;
            if (pancake > 0) result.add(pancake);
        }
        panCakes.clear();
        panCakes.addAll(result);
    }

    private static void specialMinute(List<Integer> panCakes, int divisor) {
        Collections.sort(panCakes);
        Integer value = panCakes.remove(panCakes.size() - 1);
        int newVal = value - divisor;
        int remainder = value - newVal;
        panCakes.add(remainder);
        panCakes.add(newVal);
    }

    private static int maxPancakes(List<Integer> panCakes) {
        Collections.sort(panCakes);
        return panCakes.get(panCakes.size() - 1);
    }

    private static boolean allPancakesEaten(List<Integer> panCakes) {
        for (int panCake : panCakes) {
            if (panCake > 0) return false;
        }
        return true;
    }
}
