package codejam2016.round1c;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

/**
 * Created by b4dt0bi on 30.04.16.
 */
public class A {
    public static void main(String[] args) throws IOException {
        BufferedReader bufferedReader = new BufferedReader(new FileReader(args[0]));
        String line = bufferedReader.readLine();
        int tcs = Integer.parseInt(line);
        for (int tc = 0; tc < tcs; tc++) {
            int parties = Integer.parseInt(bufferedReader.readLine());
            int[] sen = new int[parties];
            String[] senstr = bufferedReader.readLine().split(" ");
            for (int i = 0; i < sen.length; i++) {
                sen[i] = Integer.parseInt(senstr[i]);
            }
            System.out.println("Case #" + (tc + 1) + ": " + evac(sen));
        }
        bufferedReader.close();
    }

    public static String evac(int[] sen) {
        String plan = "";
        while (!evacuated(sen)) {
            int[] w2 = who2(sen);
            if (w2 != null) {
                plan += toChar(w2) + " ";
            } else {
                int w1 = who1(sen);
                if (w1 != -1) {
                    plan += (char) ('A' + w1) + " ";
                } else {
                    throw new RuntimeException("should no happen?");
                }
            }
        }
        return plan.trim();
    }

    private static String toChar(int[] ints) {
        String s = "";
        for (int i : ints) {
            s += (char) ('A' + i);
        }
        return s;
    }

    private static int[] who2(int[] sen) {
        for (int i = 0; i < sen.length; i++) {
            if (sen[i] > 0) {
                sen[i]--;
                for (int n = 0; n < sen.length; n++) {
                    if (sen[n] > 0) {
                        sen[n]--;
                        if (noMajority(sen)) {
                            return new int[]{i, n};
                        }
                        sen[n]++; // undo
                    }
                }
                sen[i]++; // undo
            }
        }
        return null;
    }

    private static int who1(int[] sen) {
        for (int i = 0; i < sen.length; i++) {
            if (sen[i] > 0) {
                sen[i]--;
                if (noMajority(sen)) {
                    return i;
                }
                sen[i]++; // undo
            }
        }

        return -1;
    }

    private static boolean noMajority(int[] sen) {
        int total = 0;
        for (int i : sen) {
            total += i;
        }
        if (total == 0) return true;
        for (int i : sen) {
            float majority = (float)i/(float)total;
            if (majority > 0.5f) return false;
        }
        return true;
    }

    private static boolean evacuated(int[] sen) {
        for (int i : sen) {
            if (i > 0) return false;
        }
        return true;
    }
}
