import java.io.BufferedReader;
import java.io.FileReader;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

public class ProblemB {
    public static void main(String[] args) throws Exception {
        BufferedReader br = new BufferedReader(new FileReader(args[0]));
        int anzTC = Integer.parseInt(br.readLine());
        for (int tc = 0; tc < anzTC; tc++) {

            int nrwords = Integer.parseInt(br.readLine());
            String words[] = br.readLine().split(" ");
            solve(tc + 1, words);
        }
        br.close();
    }

    private static void solve(int tc, String[] words) {
        ArrayList<String> cars = new ArrayList<String>();
        int[] beg = new int[255];
        int[] end = new int[255];
        for (int i = 0; i < words.length; i++) {
            cars.add(words[i]);
            beg[words[i].charAt(0)]++;
            end[words[i].charAt(words[i].length() - 1)]++;
        }
        System.out.println("Case #" + tc + ": " + getNr(cars, "", beg, end));
    }

    private static long getNr(ArrayList<String> cars, String crrTrain, int[] beg, int[] end) {
        if (cars.isEmpty()) {
            return isValid(crrTrain) ? 1L : 0L;
        }
        long result = 0;
        for (int i = 0; i < cars.size(); i++) {
            String car = cars.get(i);
            if (crrTrain.isEmpty()) {
                ArrayList<String> tmpCars = new ArrayList<String>(cars);
                String newTrain = crrTrain + tmpCars.remove(i);
                result += getNr(tmpCars, newTrain, beg, end);
            } else if (end[crrTrain.charAt(crrTrain.length()-1)] <= 1 ) {
                ArrayList<String> tmpCars = new ArrayList<String>(cars);
                String newTrain = crrTrain + tmpCars.remove(i);
                result += getNr(tmpCars, newTrain, beg, end);
            } else if (crrTrain.charAt(crrTrain.length()-1) == car.charAt(0)) {
                int newEnd [] = new int [255];
                System.arraycopy(end,0,newEnd,0,255);
                newEnd[car.charAt(0)]--;
                ArrayList<String> tmpCars = new ArrayList<String>(cars);
                String newTrain = crrTrain + tmpCars.remove(i);
                result += getNr(tmpCars, newTrain, beg, newEnd);
            }
        }
        return result % 1000000007;
    }

    private static boolean isValid(String train) {
        String reduced = reduce(train);
        char[] tmp = reduced.toCharArray();
        Arrays.sort(tmp);
        String reduced2 = reduce(new String(tmp));
        return (new String(tmp)).equals(reduced2);
    }

    private static String reduce(String text) {
        StringBuffer sb = new StringBuffer();
        sb.append(text.charAt(0));
        for (int i = 1; i < text.length(); i++) {
            if (text.charAt(i - 1) != text.charAt(i)) sb.append(text.charAt(i));
        }
        return sb.toString();
    }


}
