import java.io.*;
import java.util.*;
class B
{
    public static void main(String[] args)
    {
        Scanner sc = new Scanner(System.in);
        int numMaps = sc.nextInt();
        for(int map = 0; map < numMaps; map++)
        {
            int rows = sc.nextInt();
            int cols = sc.nextInt();
            int[] heights = new int[rows*cols];
            for(int row = 0; row < rows; row++)
                for(int col = 0; col < cols; col++)
                    heights[row*cols + col] = sc.nextInt();
            
            int[] labels = new int[rows*cols];
            
            int basin = 1;
            
            for(int row = 0; row < rows; row++)
            {
                for(int col = 0; col < cols; col++)
                {
                    if(drainDir(heights, row*cols + col, rows, cols) == 0)
                    {
                        labels[row * cols + col] = basin;
                        
                        Queue<Integer> basinMembers = new LinkedList<Integer>();
                        basinMembers.offer(row*cols + col);
                        
                        while(!basinMembers.isEmpty())
                        {							
                            int loc = basinMembers.poll();
                            if(loc >= cols && drainDir(heights, loc - cols, rows, cols) == 4)
                            {
                                labels[loc - cols] = basin;
                                basinMembers.offer(loc-cols);
                            }

                            if(loc%cols > 0 && drainDir(heights, loc-1, rows, cols) == 3)
                            {
                                labels[loc-1] = basin;
                                basinMembers.offer(loc-1);
                            }
                            if(loc % cols < cols-1 && drainDir(heights, loc+1, rows, cols) == 2)
                            {
                                labels[loc+1] = basin;
                                basinMembers.offer(loc+1);
                            }
                            if(loc < rows*cols - cols && drainDir(heights, loc + cols, rows, cols) == 1)
                            {
                                labels[loc + cols] = basin;
                                basinMembers.offer(loc+cols);
                            }
                        }
                        
                        basin++;
                    }
                }
            }
            
			Map<Integer, Character> basinNames = new HashMap<Integer, Character>();
			
			char freeName = 'a';
			
            System.out.println("Case #" + (map+1)+":");
            for(int row = 0; row < rows; row++)
            {
                for(int col = 0; col < cols; col++)
                {
					if(basinNames.containsKey(labels[row*cols + col]))
					{
						System.out.print(basinNames.get(labels[row*cols + col]) + " ");
					}
					else
					{
						System.out.print(freeName + " ");
						basinNames.put(labels[row*cols + col], freeName);
						freeName++;
					}
                }
                System.out.println();
            }
        }
    }
    //0 = none, 1 = north, 2 = west, 3 = east, 4 = south
    static int drainDir(int[] heights, int loc, int rows, int cols)
    {
        int myHeight = heights[loc];
        int pourHeight = myHeight;
        int dir = 0;
        
        if(loc >= cols && heights[loc - cols] < pourHeight)
        {
            pourHeight = heights[loc - cols];
            dir = 1;
        }

        if(loc % cols > 0 && heights[loc-1] < pourHeight)
        {
            pourHeight = heights[loc-1];
            dir = 2;
        }
        if(loc % cols < cols-1 && heights[loc+1] < pourHeight)
        {
            pourHeight = heights[loc + 1];
            dir = 3;
        }
        if(loc < rows*cols - cols && heights[loc + cols] < pourHeight)
        {
            pourHeight = heights[loc + cols];
            dir = 4;
        }
        
        return dir;
    }
}