import java.util.*;

public class B
{
	static int[] vendors;
	static int minDist;
	
	static class simDat
	{
		double val;
		double ltrav;
		double rtrav;
		simDat(double v, double l, double r)
		{
			val = v;
			ltrav = l;
			rtrav = r;
		}
		
		public String toString()
		{
			return "[" + val + "," + ltrav + "," + rtrav + "]";
		}
	}
	
	static simDat solve(int start, int end)
	{
		
		if(start == end)
			return new simDat(0, 0, 0);
		if(start +1 == end)
		{
			double splitTime = Math.max(0, minDist - (vendors[end] - vendors[start]))/2.0;
			return new simDat(splitTime, splitTime, splitTime);
		}
		
		int midPt = (start + end) / 2;
		simDat lside = solve(start, midPt);
		simDat rside = solve(midPt + 1, end);
		
		
		double middleCost = Math.max(0, minDist - (vendors[midPt+1] - vendors[midPt])) +
							lside.rtrav + rside.ltrav;
		
		if (lside.val + middleCost <= rside.val)
		{
			return new simDat(rside.val, lside.ltrav + middleCost, rside.rtrav);
		}
		else if(rside.val + middleCost <= lside.val)
		{
			return new simDat(lside.val, lside.ltrav, rside.rtrav + middleCost);
		}
		else
		{
			double ttl = (lside.val + rside.val + middleCost);
			return new simDat(ttl/2, lside.ltrav + (ttl/2 - lside.val), rside.rtrav + (ttl/2 - rside.val));
		}
	}
	
	public static void main(String[] args)
	{
		Scanner sc = new Scanner(System.in);
		int numCases = sc.nextInt();
		for(int cs = 1; cs <= numCases; cs++)
		{
			int numPoints = sc.nextInt();
			minDist = sc.nextInt();
			int[] p = new int[numPoints];
			int[] v = new int[numPoints];
			int total = 0;
			for(int i = 0; i < numPoints; i++)
			{
				p[i] = sc.nextInt();
				v[i] = sc.nextInt();
				total += v[i];
			}
			vendors = new int[total];
			int idx = 0;
			for(int i = 0; i < numPoints;i++)
			{
				for(int j = 0; j < v[i]; j++)
				{
					vendors[idx] = p[i];
					idx++;
				}
			}
			System.out.printf("Case #%d: %f\n", cs, solve(0, total-1).val);
		}
	}
}