package gcj;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.GregorianCalendar;
import java.util.List;
import java.util.Vector;
import java.util.Hashtable;

public class Prueba
{
	Vector<String> vecEntrada = null;
	Vector<String> vecSalida = null;
	
	public Prueba(Vector<String> vecEntrada)
	{
		this.vecEntrada = vecEntrada;
		vecSalida = new Vector<String>();
	}
	
	public Vector<String> getSalida()
	{
		return vecSalida;
	}
	
	public void hazPrueba()
	{
		class Horario
		{
			public Date salida;
			public Date llegada;				
		}
		
		class SalidaComp implements Comparator<Horario>
		{
			public int compare(Horario h1, Horario h2)
			{
				if(h1.salida.before(h2.salida)) 
				{
					return -1;
				}
				else if(h1.salida.after(h2.salida))
				{
					return 1;
				}
				else
				{
					if(h1.llegada.before(h2.llegada)) 
					{
						return -1;
					}
					else if(h1.llegada.after(h2.llegada))
					{
						return 1;
					}	
				}
				return 0;
			}
			
		}
		
		class LlegadaComp implements Comparator<Horario>
		{
			public int compare(Horario h1, Horario h2)
			{
				if(h1.llegada.before(h2.llegada)) 
				{
					return -1;
				}
				else if(h1.llegada.after(h2.llegada))
				{
					return 1;
				}
				else
				{
					if(h1.salida.before(h2.salida)) 
					{
						return -1;
					}
					else if(h1.salida.after(h2.salida))
					{
						return 1;
					}
				}
				return 0;
			}
			
		}
		
		
		SimpleDateFormat f = new SimpleDateFormat("HH:mm");
		
		// Aqui ira el cdigo de la prueba
		int numEntradas = Integer.parseInt(vecEntrada.elementAt(0));
		int linea = 1;
		
		int turnaround;
		
		Vector<String> vecAux;
		int numTrenesA;
		int numTrenesB;
		
		Vector<Horario> vecHorariosA = new Vector<Horario>();
		Vector<Horario> vecHorariosB = new Vector<Horario>();
		
		Calendar cal = new GregorianCalendar();
		
		
		
		int soluA, soluB;
		
		
		for(int caso = 1; caso <= numEntradas; caso++)
		{
			turnaround = Integer.parseInt(vecEntrada.elementAt(linea));
			linea++;
			vecAux = Utils.getPalabras(vecEntrada.elementAt(linea));
			linea++;
			numTrenesA = Integer.parseInt(vecAux.elementAt(0));
			numTrenesB = Integer.parseInt(vecAux.elementAt(1));
			
			vecHorariosA.clear();
			
			for(int n = 0; n < numTrenesA; n++)
			{
				vecAux = Utils.getPalabras(vecEntrada.elementAt(linea));
				linea++; 
				vecHorariosA.add(new Horario());
				try
				{
					vecHorariosA.elementAt(n).salida = f.parse(vecAux.elementAt(0));
					cal.setTime(f.parse(vecAux.elementAt(1)));
					cal.add(Calendar.MINUTE, turnaround);					
					vecHorariosA.elementAt(n).llegada = cal.getTime(); 
				}
				catch (ParseException e)
				{
					e.printStackTrace();
				}
			}
			
			vecHorariosB.clear();
			for(int n = 0; n < numTrenesB; n++)
			{
				vecAux = Utils.getPalabras(vecEntrada.elementAt(linea));
				linea++; 
				vecHorariosB.add(new Horario());
				try
				{
					vecHorariosB.elementAt(n).salida = f.parse(vecAux.elementAt(0));
					cal.setTime(f.parse(vecAux.elementAt(1)));
					cal.add(Calendar.MINUTE, turnaround);		
					vecHorariosB.elementAt(n).llegada = cal.getTime();
				}
				catch (ParseException e)
				{
					e.printStackTrace();
				}
			}
			
			Collections.sort(vecHorariosA, new SalidaComp());
			Collections.sort(vecHorariosB, new LlegadaComp());
			
			boolean[] usadosA = new boolean[numTrenesA];
			for(int a = 0; a < numTrenesA; a++) usadosA[a] = false;
			boolean[] usadosB = new boolean[numTrenesB];
			for(int b = 0; b < numTrenesB; b++) usadosB[b] = false;
			
			int masProximo = -1;
			
			soluA = numTrenesA;
			soluB = numTrenesB;
			
			for(int a = 0; a < numTrenesA; a++)
			{
				masProximo = -1;
				for(int b = 0; b < numTrenesB; b++)
				{
					if(usadosB[b]) continue;
					
					if(vecHorariosA.elementAt(a).salida.compareTo(vecHorariosB.elementAt(b).llegada) >= 0)
					{
						if(masProximo > -1)
						{
							if(vecHorariosB.elementAt(masProximo).salida.before(vecHorariosB.elementAt(b).llegada))
							{
								masProximo = b;
							}
						}
						else
						{
							masProximo = b;							
						}
					}
				}
				
				if(masProximo != -1)
				{
					soluA--;
					usadosB[masProximo] = true;					
				}
			}
			
			for(int b = 0; b < numTrenesB; b++)
			{
				masProximo = -1;
				for(int a = 0; a < numTrenesA; a++)
				{
					if(usadosA[a]) continue;
					
					if(vecHorariosB.elementAt(b).salida.compareTo(vecHorariosA.elementAt(a).llegada) >= 0)
					{
						if(masProximo > -1)
						{
							if(vecHorariosA.elementAt(masProximo).salida.before(vecHorariosA.elementAt(a).llegada))
							{
								masProximo = a;
							}
						}
						else
						{
							masProximo = a;							
						}
					}
				}
				
				if(masProximo != -1)
				{
					soluB--;
					usadosA[masProximo] = true;					
				}
			}
			
			
			
			vecSalida.add("Case #" + caso + ": "+ soluA + " " + soluB);
		}
	}
}
