package gcj.b4sh.y2009.r1c;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * <p>
 * Google Code Jam 2009 - Round 1C - Problem C<br />
 * Bribe the Prisoners
 * </p>
 * 
 * @see http://code.google.com/codejam/contest/dashboard?c=189252#s=p2
 * @author Carlos Vara
 */
public class ProblemC {
    
    int LAST_PERM;
    int[][] PERMS;
    
    int fact(int n) {
        return (n == 1) ? n : n * fact(n - 1);
    }

    void permute(int[] v, int start, int n) {
        if ( start == n-1 ) {
            PERMS[LAST_PERM] = v.clone();
            LAST_PERM++;
//            System.out.println("perm: " + Arrays.toString(v));
        }
        else {
            for (int i = start; i < n; i++) {
                int tmp = v[i];

                v[i] = v[start];
                v[start] = tmp;
                permute(v, start + 1, n);
                v[start] = v[i];
                v[i] = tmp;
            }
        }
    }


    /**
     * Solves the proposed problem.
     * 
     * @param inName Name of the input file.
     * @param outName Name of the output file (will be overwritten if exists).
     */
    public void solve(String inName, String outName) throws Exception {

        // Open input and output files
        Scanner inSc = new Scanner(new FileInputStream(inName));
        PrintWriter outPw = new PrintWriter(new FileWriter(outName));

        // Solve all the cases
        int N = inSc.nextInt();
        for (int i = 1; i <= N; ++i) {

            // Read P and Q
            int P = inSc.nextInt();
            int Q = inSc.nextInt();

//            System.out.println("P: " + P + " Q: " + Q);

            // Read the order
            int[] prisioners = new int[P];
            int[] releases = new int[Q];
            for (int j = 0; j < Q; ++j) {
                releases[j] = inSc.nextInt() - 1;
            }

            LAST_PERM = 0;
            PERMS = new int[fact(releases.length)][Q];

            permute(releases, 0, releases.length);
            

            // Calculate the bribes
            // brute force :-(
            long minBribes = 9000000000000000000l;
            for ( int perm=0; perm<LAST_PERM; perm++ ) {
                Arrays.fill(prisioners, 0);
                long bribes = 0;
                for (int j = 0; j < Q; ++j) {
                    prisioners[PERMS[perm][j]] = -1;
                    int l = PERMS[perm][j] - 1;
                    while (l >= 0 && prisioners[l] == 0) {
                        bribes++;
                        l--;
                    }
                    int r = PERMS[perm][j] + 1;
                    while (r < P && prisioners[r] == 0) {
                        bribes++;
                        r++;
                    }
                }
                minBribes = (bribes<minBribes)?bribes:minBribes;
            }

            outPw.println("Case #" + i + ": " + minBribes);

        }

        // Close files
        outPw.flush();
        outPw.close();
        inSc.close();
    }


    public static void main(String... args) {
        try {
            new ProblemC().solve("r1c/C-small.in", "r1c/C-small.out");
        } catch (Exception e) {
            System.err.println("Oops, something went wrong");
            e.printStackTrace(System.err);
        }
    }


}
