package gcj.b4sh.q2009;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * <p>
 * Google Code Jam 2009 - Qualification Round - Problem A<br />
 * Alien Language
 * </p>
 *
 * @see http://code.google.com/codejam/contest/dashboard?c=90101#s=p0
 * @author Carlos Vara
 */
public class ProblemA {

    /**
     * Solves the proposed problem.
     * 
     * @param inName Name of the input file.
     * @param outName Name of the output file (will be overwritten if exists).
     */
    public void solve(String inName, String outName) throws Exception {

        // Open input and output files
        Scanner inSc = new Scanner(new FileInputStream(inName));
        PrintWriter outPw = new PrintWriter(new FileWriter(outName));

        // Read L D N
        int L = inSc.nextInt();
        int D = inSc.nextInt();
        int N = inSc.nextInt();
        
        // Read the alien dictionary
        ArrayList<String> dict = new ArrayList<String>();
        for ( int i=0; i<D; ++i ) {
            dict.add(inSc.next().trim());
        }
        
        
        // Solve the test cases
        for ( int i=1; i<=N; ++i ) {
            
            String expr = inSc.next().trim();
            ArrayList[] wordGraph = new ArrayList[L];
            
            // Create the graph
            int nextC = 0;
            for ( int j=0; j<L; ++j ) {
                wordGraph[j] = new ArrayList<Character>();
                char c = expr.charAt(nextC);
                if ( c == '(' ) {
                    // Get the group of letters
                    nextC++;
                    while ( ')' != expr.charAt(nextC) ) {
                        wordGraph[j].add(new Character(expr.charAt(nextC)));
                        nextC++;
                    }
                }
                else {
                    wordGraph[j].add(new Character(c));
                }
                nextC++;
            }
            
            // Test all the words against the graph
            int matches = 0;
            for ( String word : dict ) {
                int j = 0;
                while ( j<L && wordGraph[j].contains(new Character(word.charAt(j))) ) {
                    j++;
                }
                if ( j==L ) {
                    matches++;
                }
            }
            
            outPw.println("Case #"+i+": " + matches);
        }
        

        // Close files
        outPw.flush();
        outPw.close();
        inSc.close();
    }


    public static void main(String... args) {
        try {
            new ProblemA().solve("q2009/A-example-q2009.in", "q2009/A-example-q2009.out");
        } catch (Exception e) {
            System.err.println("Oops, something went wrong");
            e.printStackTrace(System.err);
        }
    }


}
