package gcj.b4sh.q2009;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

/**
 * <p>
 * Google Code Jam 2009 - Qualification Round - Problem C<br />
 * Welcome to Code Jam
 * </p>
 * 
 * @see http://code.google.com/codejam/contest/dashboard?c=90101#s=p2
 * @author Carlos Vara
 */
public class ProblemC {

    public static final String GOLD = "welcome to code jam";
    
    public int[] multipliers;

    public static String removeChar(String s, char c) {
        String r = "";
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) != c)
                r += s.charAt(i);
        }
        return r;
    }
    
    public String cleanInput( String text ) {
        
        // Remove non-interesting chars
        for ( char c = 'a'; c <= 'z'; c++ ) {
            if ( -1 == GOLD.indexOf(c) ) {
                text = removeChar(text, c);
            }
        }
        
        // Start from first 'w'
//        text = text.substring(text.indexOf('w'));
        
        // Pack consecutive chars
        int i=0;
        String out = "";
        ArrayList<Integer> mults = new ArrayList<Integer>();
        while ( i<text.length() ) {
            char c = text.charAt(i);
            int times = 1;
            i++;
            while ( i<text.length() && text.charAt(i) == c ) {
                times++;
                i++;
            }
            out = out + c;
            mults.add(times);
        }
        
        multipliers = new int[mults.size()];
        for ( int j=0; j<mults.size(); j++) {
            multipliers[j] = mults.get(j);
        }
        
        return out;
    }


    /**
     * Solves the proposed problem.
     * 
     * @param inName Name of the input file.
     * @param outName Name of the output file (will be overwritten if exists).
     */
    public void solve(String inName, String outName) throws Exception {

        // Open input and output files
        Scanner inSc = new Scanner(new FileInputStream(inName));
        PrintWriter outPw = new PrintWriter(new FileWriter(outName));

        // Solve all the cases
        int N = Integer.parseInt(inSc.nextLine().trim());
        for (int i = 1; i <= N; ++i) {

            String text = cleanInput(inSc.nextLine().trim());

            int indexes[] = new int[GOLD.length()];
            Arrays.fill(indexes, 0);
            int cL = 0;
            long tot = 0;
            while ((indexes[0] + GOLD.length() - 2) < text.length()) {

                if (GOLD.charAt(cL) == text.charAt(indexes[cL])) {
                    if ((cL + 1) == GOLD.length()) {
                        // Full match
                        int mult = 1;
                        for ( int j=0; j<indexes.length; ++j ) {
                            mult *= multipliers[indexes[j]];
                        }
                        tot += mult;
                        indexes[cL]++;
                    } else {
                        // Next letter
                        cL++;
                        for (int j = cL; j < indexes.length; ++j) {
                            indexes[j] = indexes[cL - 1];
                        }
                    }
                } else {
                    // Try next
                    indexes[cL]++;
                }

                while (cL > 0 && indexes[cL] >= text.length()) {
                    cL--;
                    indexes[cL]++;
                }

            }

            String totStr = "0000"+tot;
            outPw.println("Case #"+i+": " + totStr.substring(totStr.length()-4));

        }

        // Close files
        outPw.flush();
        outPw.close();
        inSc.close();
    }


    public static void main(String... args) {
        try {
            new ProblemC().solve("q2009/C-example-q2009.in", "q2009/C-example-q2009.out");
        } catch (Exception e) {
            System.err.println("Oops, something went wrong");
            e.printStackTrace(System.err);
        }
    }


}
