package gcj.b4sh.q2009;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * <p>
 * Google Code Jam 2009 - Qualification Round - Problem C<br />
 * Welcome to Code Jam
 * </p>
 * 
 * @see http://code.google.com/codejam/contest/dashboard?c=90101#s=p2
 * @author Carlos Vara
 */
public class ProblemC {

    public static final String GOLD = "welcome to code jam";

    /**
     * Solves the proposed problem.
     * 
     * @param inName Name of the input file.
     * @param outName Name of the output file (will be overwritten if exists).
     */
    public void solve(String inName, String outName) throws Exception {

        // Open input and output files
        Scanner inSc = new Scanner(new FileInputStream(inName));
        PrintWriter outPw = new PrintWriter(new FileWriter(outName));
        
        // Solve all the cases
        int N = Integer.parseInt(inSc.nextLine().trim());
        for (int i = 1; i <= N; ++i) {

            String text = inSc.nextLine().trim();
            
            int[] occ = new int[GOLD.length()+1];
            occ[0] = 1;
            
            for ( int j=0; j<text.length(); ++j ) {
                for ( int h=0; h<GOLD.length(); h++ ) {
                    if ( GOLD.charAt(h) == text.charAt(j) ) {
                        occ[h+1] = occ[h+1] + occ[h];
                    }
                }
            }
            String totStr = "0000"+occ[GOLD.length()];
            outPw.println("Case #"+i+": " + totStr.substring(totStr.length()-4));

        }

        // Close files
        outPw.flush();
        outPw.close();
        inSc.close();
    }


    public static void main(String... args) {
        try {
            new ProblemC().solve("q2009/C-large.in", "q2009/C-large.out");
        } catch (Exception e) {
            System.err.println("Oops, something went wrong");
            e.printStackTrace(System.err);
        }
    }


}
