package gcj.b4sh.y2009.r1c;

import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * <p>
 * Google Code Jam 2009 - Round 1C - Problem A<br />
 * xxx
 * </p>
 *
 * @see http://problem-text.html
 * @author Carlos Vara
 */
public class ProblemA {
    
    public long calculateNumberValue(String rep, String lang) {
        int radix = lang.length();
        long result = 0;

        for (int i = 0; i < rep.length(); ++i) {
            result = result * (long)radix + (long)lang.indexOf(rep.charAt(i));
        }

        return result;
    }

    /**
     * Solves the proposed problem.
     * 
     * @param inName Name of the input file.
     * @param outName Name of the output file (will be overwritten if exists).
     */
    public void solve(String inName, String outName) throws Exception {

        // Open input and output files
        Scanner inSc = new Scanner(new FileInputStream(inName));
        PrintWriter outPw = new PrintWriter(new FileWriter(outName));

        // Solve all the cases
        int T = inSc.nextInt();
        for (int i = 1; i <= T; ++i) {

            String numberRep = inSc.next();
            
            if ( numberRep.length() == 1 ) {
                outPw.println("Case #"+i+": " + 1);
            }
            else {
                // Read the lang
                String lang = "";
                for ( int j=0; j<numberRep.length(); ++j ) {
                    if ( -1 == lang.indexOf(numberRep.charAt(j))) {
                        lang = lang + numberRep.charAt(j);
                    }
                }
                // Change 0 and 1
                if ( lang.length() == 1 ) {
                    lang = "#" + lang;
                }
                else if ( lang.length() == 2 ) {
                    lang = "" + lang.charAt(1) + lang.charAt(0);
                }
                else {
                    lang = "" + lang.charAt(1) + lang.charAt(0) + lang.substring(2);
                }
                
                outPw.println("Case #"+i+": " + calculateNumberValue(numberRep, lang));
            }
            
            

        }

        // Close files
        outPw.flush();
        outPw.close();
        inSc.close();
    }


    public static void main(String... args) {
        try {
            new ProblemA().solve("r1c/A-large.in", "r1c/A-large.out");
        } catch (Exception e) {
            System.err.println("Oops, something went wrong");
            e.printStackTrace(System.err);
        }
    }


}
