package game2013.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Tic_Tac_Toe_Tome {
	public static final String[] oWinString = { "OOOO", "TOOO", "OTOO", "OOTO",
			"OOOT" };
	public static final String[] xWinString = { "XXXX", "TXXX", "XTXX", "XXTX",
			"XXXT" };

	private static String getResult(String line) {
		for (int i = 0; i < 5; i++) {
			if (oWinString[i].equals(line)) {
				return "O won";
			}
			if (xWinString[i].equals(line)) {
				return "X won";
			}
		}
		if (line.contains(".")) {
			return "NotFinish";
		}
		return "Draw";
	}

	public static void main(String[] args) throws IOException {
		BufferedReader f = new BufferedReader(new FileReader(
				"A-large.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(
				"A-large.out")));
		StringTokenizer st = new StringTokenizer(f.readLine());
		int tests = Integer.parseInt(st.nextToken());
		for (int t = 1; t <= tests; t++) {
			out.printf("Case #%d: ", t);
			String[] lines = new String[4];
			String[] column = new String[4];
			String[] diag = new String[2];
			for (int i = 0; i < 4; i++) {
				st = new StringTokenizer(f.readLine());
				lines[i] = st.nextToken();
				for (int j = 0; j < 4; j++) {
					if (column[j] == null) {
						column[j] = String.valueOf(lines[i].charAt(j));
					} else
						column[j] += lines[i].charAt(j);
					if (i == j) {
						if (diag[0] == null) {
							diag[0] = String.valueOf(lines[i].charAt(j));
						} else
							diag[0] += lines[i].charAt(j);
					}
					if(i + j == 3){
						if (diag[1] == null) {
							diag[1] = String.valueOf(lines[i].charAt(j));
						} else
							diag[1] += lines[i].charAt(j);						
					}
				}
			}
			String results = new String();
			for (int i = 0; i < 4; i++) {
				results += getResult(lines[i]);
				results += getResult(column[i]);
				if (i < 2) {
					results += getResult(diag[i]);
				}
			}
			if (results.contains("O won")) {
				out.println("O won");
			} else if (results.contains("X won")) {
				out.println("X won");
			} else if (results.contains("Draw")) {
				out.println("Draw");
			} else {
				out.println("Game has not completed");
			}
			f.readLine();
		}
		out.close();
	}
}
