/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package tictactoetomek;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

/**
 *
 * @author b.ttalic
 */
public class TicTacToeTomek {

    /**
     * @param args the command line arguments
     */
    public class CheckScore {

        private int[] rows;
        private int[] columns;
        private int diagonal;
        private int antiDiagonal;
        private int columnT;
        private int rowT;
        private boolean incomplete;
        private String result;

        public CheckScore() {
            rows = new int[4];
            columns = new int[4];
            incomplete = false;
            diagonal = 0;
            antiDiagonal = 0;
            columnT = -1;
            rowT = -2;
            result = "";
        }

        private void reset() {
            rows = new int[4];
            columns = new int[4];
            incomplete = false;
            diagonal = 0;
            antiDiagonal = 0;
            columnT = -1;
            rowT = -1;
            result = "";
        }

        private void checkRow(String currentRow, int rowIndex) {
            if (incomplete == false) {
                if (currentRow.indexOf(".") >= 0) {
                    incomplete = true;
                }
            }

            if (currentRow.indexOf("T") >= 0) {
                rowT = rowIndex;
                columnT = currentRow.indexOf("T");
            }

            char[] rowChar = currentRow.toCharArray();

            for (int i = 0; i < rowChar.length; i++) {

                if (rowChar[i] == 'X') {
                    if (rowIndex == i) {
                        diagonal++;
                    }
                    if (rowIndex + i == 3) {
                        antiDiagonal++;
                    }

                    rows[rowIndex]++;
                    if (rows[rowIndex] == 4 || (rows[rowIndex] == 3 && rowT == rowIndex)) {
                        result = "X won";
                        return;
                    }
                    columns[i]++;
                    if (columns[i] == 4 || (columns[i] == 3 && columnT == i)) {
                        result = "X won";
                        return;
                    }

                }

                if (rowChar[i] == 'O') {

                    if (rowIndex == i) {
                        diagonal--;
                    }
                    if (rowIndex + i == 3) {
                        antiDiagonal--;
                    }

                    rows[rowIndex]--;
                    if (rows[rowIndex] == -4 || (rows[rowIndex] == -3 && rowT == rowIndex)) {
                        result = "O won";
                        return;
                    }

                    columns[i]--;
                    if (columns[i] == -4 || (columns[i] == -3 && columnT == i)) {
                        result = "O won";
                        return;
                    }
                }

            }

            if (diagonal == 4 || (diagonal == 3 && rowT == columnT)) {
                result = "X won";
                return;
            }
            if (antiDiagonal == 4 || (antiDiagonal == 3 && rowT + columnT == 3)) {
                result = "X won";
                return;
            }

            if (diagonal == -4 || (diagonal == -3 && rowT == columnT)) {
                result = "O won";
                return;
            }
            if (antiDiagonal == -4 || (antiDiagonal == -3 && rowT + columnT == 3)) {
                result = "O won";
                return;
            }

        }

        private void setWinner() {
            if (result.length() <= 0) {
                if (isIncomplete()) {
                    result = "Game has not completed";
                } else {
                    result = "Draw";
                }
            }
        }

        public boolean hasWinner() {
            if (result.length() > 0) {
                return true;
            }
            return false;
        }

        public String getWinner() {
            return result;
        }

        public boolean isIncomplete() {
            return incomplete;
        }
    }

    public static void testCase(String[] testCase, CheckScore checker) {
        for (int i = 0; i < 4; i++) {
            if (!checker.hasWinner()) {
                checker.checkRow(testCase[i], i);
            } else {
                break;
            }
        }
        checker.setWinner();
    }

    public static void main(String[] args) throws FileNotFoundException, IOException {

        TicTacToeTomek tomek = new TicTacToeTomek();
        CheckScore checker = tomek.new CheckScore();
        int numberOfCases;
        String[] testCase = new String[4];
        String output = "";

        BufferedReader br = new BufferedReader(new FileReader("A-large.in"));
        FileWriter fw = new FileWriter("output.out");
        BufferedWriter bw = new BufferedWriter(fw);
        try {
            StringBuilder sb = new StringBuilder();
            numberOfCases = Integer.parseInt(br.readLine());

            for (int i = 0; i < numberOfCases; i++) {
                for (int j = 0; j < 4; j++) {
                    String line = br.readLine();
                    if (line.length() > 0) {
                        testCase[j] = line;
                       
                    } else {
                        j--;
                    }
                }
            
                testCase(testCase, checker);
                output += "Case #" + (i + 1) + ": " + checker.getWinner() + "\n";
                checker.reset();
            }
            bw.write(output);

        } finally {
            br.close();
            bw.close();
        }

    }
}
