import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.Queue;


public class BotTrust {
	
	public int noOfTestCases;
	
	public static void main(String[] args) throws Exception
	{
		BotTrust a = new BotTrust();
		FileReader fr = new FileReader("/Users/gautams329046/Desktop/Input.in");
		FileWriter fw = new FileWriter("/Users/gautams329046/Desktop/Output.txt");
		BufferedReader br = new BufferedReader(fr);
		a.noOfTestCases = Integer.parseInt(br.readLine());
		int i =1;
		while(i <= a.noOfTestCases)
		{
			String testCase = br.readLine();			
			fw.write("Case #"+i+": " +a.calculateTime(testCase) + "\r\n");
			i++;
		}
		
			
		fr.close();
		fw.close();
	}
	
	public class Bot {
		private int currentPosition = 1;
		private Queue<ButtonPress> queue = new LinkedList<ButtonPress>();
		public int getCurrentPosition() {
			return currentPosition;
		}
		public void setCurrentPosition(int currentPosition) {
			this.currentPosition = currentPosition;
		}
		public Queue<ButtonPress> getQueue() {
			return queue;
		}
		public void setQueue(Queue<ButtonPress> queue) {
			this.queue = queue;
		}		
	}
	
	public class ButtonPress {
		private int buttonNo;
		private int prioritOrder;
		public int getButtonNo() {
			return buttonNo;
		}
		public void setButtonNo(int buttonNo) {
			this.buttonNo = buttonNo;
		}
		public int getPrioritOrder() {
			return prioritOrder;
		}
		public void setPrioritOrder(int prioritOrder) {
			this.prioritOrder = prioritOrder;
		}
		
	}
	
	private int pressButton(Bot prior,Bot second) {
		int result = 0;
		int timeTakenByPrior = Math.abs(prior.getQueue().peek().getButtonNo() - prior.getCurrentPosition()) +1;
		int noOfMovesForSecond = Math.abs(second.getQueue().peek().getButtonNo() - second.getCurrentPosition());
		if(timeTakenByPrior >= noOfMovesForSecond) {
			second.setCurrentPosition(second.getQueue().peek().getButtonNo());
		} else {
			if(second.getQueue().peek().getButtonNo() > second.getCurrentPosition()) {
				second.setCurrentPosition(second.getCurrentPosition() + timeTakenByPrior);
			} else if(second.getQueue().peek().getButtonNo() < second.getCurrentPosition()) {
				second.setCurrentPosition(second.getCurrentPosition() - timeTakenByPrior);
			}			
		}
		prior.setCurrentPosition(prior.getQueue().peek().getButtonNo());
		result = timeTakenByPrior;
		prior.getQueue().poll();
		return result;
	}
	
	private int pressButton(Bot bot) {
		int result = 0;
		int noOfMovesForB = Math.abs(bot.getQueue().peek().getButtonNo() - bot.getCurrentPosition());
		bot.setCurrentPosition(bot.getQueue().peek().getButtonNo());
		result = noOfMovesForB +1;
		bot.getQueue().poll();
		return result;
	}
	
	private int calculateTime(String testCase) {
		int result=0;
		int splitCounter=0;
		String testCaseArray[] = testCase.split(" ");
		Queue<ButtonPress> bQueue = new LinkedList<ButtonPress>();
		Queue<ButtonPress> oQueue = new LinkedList<ButtonPress>();
		int n = Integer.parseInt(testCaseArray[splitCounter++]);
		
		for(int i=0;i<n;i++) {
			ButtonPress buttonPress = new ButtonPress();
			buttonPress.setPrioritOrder(i);
			String botColour = testCaseArray[splitCounter++];
			buttonPress.setButtonNo(Integer.parseInt(testCaseArray[splitCounter++]));
			if("O".equals(botColour)) {
				oQueue.add(buttonPress);
			} else {
				bQueue.add(buttonPress);
			}
		}		
		
		Bot b = new Bot();
		b.setQueue(bQueue);
		Bot o = new Bot();
		o.setQueue(oQueue);
		
		while(b.getQueue().peek() != null && o.getQueue().peek()!= null) {
			if(b.getQueue().peek().getPrioritOrder() < o.getQueue().peek().getPrioritOrder()) {
				result += pressButton(b,o);
			}	else {
				result += pressButton(o,b);
			}
		}
		
		while(o.getQueue().peek()!= null) {
			result += pressButton(o);
		}
		
		while(b.getQueue().peek()!= null) {
			result += pressButton(b);
		}

		return result;
	}
}
