import java.util.*;
import java.io.*;
import java.text.DecimalFormat;

class CruiseControl {

    public static void main(String[] args) throws IOException {
        CruiseControl cc = new CruiseControl();

        DecimalFormat df = new DecimalFormat();
        df.setMaximumFractionDigits(6);
        df.setMinimumFractionDigits(6);

        Scanner scan = new Scanner(System.in);
        int T = scan.nextInt();

        for (int i=0; i<T; ++i) {
            int D = scan.nextInt();
            int N = scan.nextInt();

            int[] speedArray = new int[N];
            int[] initialDistanceArray = new int[N];
            double[] timeToReachDestArray = new double[N];
            //boolean[] completedTheRaceArray = new boolean[N];

            double maxTimetaken = 0;

            for (int j=0; j<N; ++j) {

                int K = scan.nextInt();
                int S = scan.nextInt();

                initialDistanceArray[j] = K;
                speedArray[j] = S;
                timeToReachDestArray[j] = (double)(D-K)/S;
                //completedTheRaceArray[j] = false;

                if (maxTimetaken < timeToReachDestArray[j]) {
                    maxTimetaken = timeToReachDestArray[j];
                }

            }
/*
            int numberOfHorsesRemaining = N;
            // First pass
            for (int k=0; k<N; ++k) {
                // These guys will finish earlier than the slowest guy
                if ((speedArray[k] > speedArray[minSpeedIndex]) && (initialDistanceArray[k] > initialDistanceArray[minSpeedIndex])) {
                    completedTheRaceArray[k] = true;
                    numberOfHorsesRemaining--;
                } 
                // These guys will catchup with the slower fellow
                else if ((speedArray[k] > speedArray[minSpeedIndex]) && (initialDistanceArray[k] <= initialDistanceArray[minSpeedIndex]) && (timeToReachDestArray[k] < timeToReachDestArray[minSpeedIndex])) {
                    completedTheRaceArray[k] = true;
                    numberOfHorsesRemaining--;
                    speedArray[k] = speedArray[minSpeedIndex];
                    initialDistanceArray[k] = initialDistanceArray[minSpeedIndex];
                    timeToReachDestArray[k] = timeToReachDestArray[minSpeedIndex];
                }
                // These guys will never catchup. Update the initial distance to the value of timeToReachDestArray
                else {
                    initialDistanceArray[k] = initialDistanceArray[k] + (timeToReachDestArray[minSpeedIndex] * speedArray[k]);
                    timeToReachDestArray[k] = (D - initialDistanceArray[k])/speedArray[k];
                }

            }

            while (numberOfHorsesRemaining > 0) {
                for (int k=0; k<N; ++k) {
                    if (completedTheRaceArray[k] == true) {
                        continue;
                    }




            }*/


            System.out.println("Case #" + (i+1) + ": " + df.format((double)D/maxTimetaken));

        }
    }
}
