import java.util.*;
import java.io.*;

class AlphabetCake {

    public static void main(String[] args) throws IOException {
        AlphabetCake ac = new AlphabetCake();
        Scanner scan = new Scanner(System.in);
        int T = scan.nextInt();

        for (int i=0; i<T; ++i) {
            int R = scan.nextInt();
            int C = scan.nextInt();

            char[][] inputArray = new char[R][C];
            String S = "";
            for (int j=0; j<R; ++j) {
                S = scan.next();
                int len = S.length();
                for (int k=0; k<len; ++k) {
                    inputArray[j][k] = S.charAt(k);
                }
            }

            String[] outputArray = new String[R];
            
            int emptyRowStart = 0;
            int len = 0;
            boolean currentRowValid = false;
            Map<Integer, Character> myCurrentRowMap = new HashMap<Integer, Character>();

            for (int j=0; j<R; ++j) {
                currentRowValid = false;
                myCurrentRowMap.clear();
                for (int k=0; k<C; ++k) {
                    if (inputArray[j][k] != '?') {
                        currentRowValid = true;
                        myCurrentRowMap.put(k, inputArray[j][k]);
                    }
                }

                if (currentRowValid) {
                    // Fill up this current row completely
                    int previousIndex = -1;
                    StringBuilder sb = new StringBuilder();
                    String result = "";
                    Integer key = 0;
                    char value = '\0';
                    for (Map.Entry<Integer, Character> entry : myCurrentRowMap.entrySet()) {
                        key = entry.getKey();
                        value = entry.getValue();
                        int lengthNeeded = 0;
                        if (previousIndex == -1) {
                            lengthNeeded = key + 1;
                        } else {
                            lengthNeeded = key - previousIndex;
                        }
                        char[] chars = new char[lengthNeeded];
                        Arrays.fill(chars, value);
                        result = new String(chars);
                        previousIndex = key;
                        sb.append(result);
                    }
                    if (previousIndex != (C-1)) {
                        int lengthNeeded = C - previousIndex - 1;
                        char[] chars = new char[lengthNeeded];
                        Arrays.fill(chars, value);
                        result = new String(chars);
                        sb.append(result);
                    }
                    String finalString = sb.toString();
                    outputArray[j] = finalString;

                    // Fill up all previous empty Rows from emptyRowStart to j-1
                    for (int x = emptyRowStart; x <= (j-1); ++x) {
                        outputArray[x] = finalString;            
                    }                    

                    emptyRowStart = j + 1;
                }
            }

            if (!currentRowValid) {
                // Copy from start - 1 : start to myLine
                String fromString = outputArray[emptyRowStart-1];
                for (int x = emptyRowStart; x < R; ++x) {
                    outputArray[x] = fromString;
                }
            }

            System.out.println("Case #" + (i+1) + ": ");
            for (int x = 0; x < R; ++x) {
                System.out.println(outputArray[x]);
            }
//            System.out.println("Case #" + (i+1) + ": ");
        }
    }
}
