package com.google.jam14.qualification.war;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.TreeSet;

import static com.google.jam14.qualification.war.JamUtils.*;

/**
 * Created with IntelliJ IDEA.
 * User: Alisa
 * Date: 12.04.14
 * Time: 17:59
 * To change this template use File | Settings | File Templates.
 */
public class War extends JamTask {


    public static void main(String ... args) {

        War taskC = new War();
        taskC.start();
    }

    @Override
    public void solve(int testCaseNum, BufferedReader bufferedReader, BufferedWriter bufferedWriter) throws IOException {
        int N = getNextInt(bufferedReader);
        String[] lineNaomi = getNextString(bufferedReader).split(" ");
        String[] lineKen = getNextString(bufferedReader).split(" ");


        TreeSet<Double> naomi = new TreeSet<Double>();
        TreeSet<Double> ken = new TreeSet<Double>();

         for(int i = 0; i < N; i++) {
             naomi.add(parseDouble(lineNaomi[i]));
             ken.add(parseDouble(lineKen[i]));

         }

        int pointsNaomifair = fairGame((TreeSet<Double>)naomi.clone(), (TreeSet<Double>)ken.clone(), 0);
        int pointsNaomiUnfair = unFairGame(naomi, ken, 0);
        formatResult(bufferedWriter, testCaseNum, pointsNaomiUnfair, pointsNaomifair);
    }

    private int unFairGame(TreeSet<Double> naomi, TreeSet<Double> ken, int points) {
        if (naomi.size() == 1) return fairGame(naomi, ken, points);
        //how to cheat ? to change naomi's first on ken's last
        // or to change her greatest on his lowest?


        if (naomi.ceiling(ken.last()) != null) {
//            int sizeOfNaomiGreaterThanKensLast = naomi.tailSet(ken.last()).size(); //how many times in a row she can get points
//            int sizeOfNaomiGreaterThanKensAfterKillingHisGreatest = naomi.tailSet(ken.lower(ken.last())).size();
//            if (false){//sizeOfNaomiGreaterThanKensAfterKillingHisGreatest > sizeOfNaomiGreaterThanKensLast) {
//                //naomi tells ken ToldNaomi = (kenLast-kenLast-1)/2 and ken will take his kenSec to take her ball
//                double told = (ken.last() + ken.lower(ken.last())) / 2 + Math.pow(10, -7);
//
//                ken.remove(ken.last());
//                naomi.remove(naomi.first());
//                return unFairGame(naomi, ken, points);
//            } else {
                naomi.remove(naomi.ceiling(ken.first()));// tells her greatest but removes greaater than his first;naomi.remove(naomi.ceiling(ken.last()));
                ken.remove(ken.first());
                return unFairGame(naomi, ken, points + 1);
            //}


        } else if (naomi.first() < ken.last()) {
           //naomi tells ken ToldNaomi = (kenLast-kenLast-1)/2 and ken will take his kenSec to take her ball
            double told = (ken.last() + ken.lower(ken.last())) / 2 + Math.pow(10, -7);

            ken.remove(ken.last());
            naomi.remove(naomi.first());
            return unFairGame(naomi, ken, points);
        } else if (naomi.first() > ken.last()){
            return fairGame(naomi, ken, points);
        }
        return 0;
    }

    private int fairGame(TreeSet<Double> naomi, TreeSet<Double> ken, int points) {
        if (naomi.size() == 1) {
            if (naomi.first() > ken.first()) {
                return points + 1;
            } else {
                return points;
            }
        }
        //naomi gets her smallest and says it, ken gets his first greater and naomi gets 0 points if ken has greater
        double naomiSmallest = naomi.first();
        naomi.remove(naomiSmallest);
        if (ken.ceiling(naomiSmallest) != null) {
            ken.remove(ken.ceiling(naomiSmallest));
            return fairGame(naomi, ken, points);
        } else {
            ken.remove(ken.first());
            return fairGame(naomi, ken, points + 1);
        }
    }

    private void formatResult(BufferedWriter bufferedWriter, int testCaseNum, int decWar, int war) throws IOException {
        formatOutput(bufferedWriter, testCaseNum, decWar + " " + war);
    }


    @Override
    public String getInputFileName() {
        return "D-large.in";
    }
}
