package com.google.jam14.qualification.cookie;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;

/**
 * Created with IntelliJ IDEA.
 * User: Alisa
 * Date: 22.03.14
 * Time: 13:43
 * To change this template use File | Settings | File Templates.
 */
public class JamUtils {
    public static final String SRC = "src";
    public static final String FILE_SYSTEM_DELIMITER = "/";

    public static String getFileName(String fileName, Class<?> clazz) {
        if (fileName == null || clazz == null) throw  new IllegalArgumentException("Parameter's shouldn't be null");
        String fName = SRC +FILE_SYSTEM_DELIMITER;
        if (clazz.getPackage() != null) {
            fName += clazz.getPackage().getName().replaceAll("\\.", "/");
        }
        fName = fName +FILE_SYSTEM_DELIMITER + fileName;
        return fName;

    }

    public static String getFileNameOut(String fileName, Class<?> clazz) {
        return getFileName(fileName.replace("in", "out"), clazz);

    }

    public static int getNextInt(BufferedReader bufferedReader) throws IOException, NumberFormatException {
        String line = bufferedReader.readLine();
        return parseInt(line.trim());
    }

    public static double getNextDouble(BufferedReader bufferedReader) throws IOException, NumberFormatException {
        String line = bufferedReader.readLine();
        return parseDouble(line.trim());
    }

    public static void formatOutput(BufferedWriter writer, int caseNum, int result) throws IOException {
        if (writer != null) writer.write("Case #" + (caseNum + 1) + ": " + result + "\n");
        formatOutput(caseNum, result);
    }

    public static void formatOutput(BufferedWriter writer, int caseNum, String result) throws IOException {
        if (writer != null) writer.write("Case #" + (caseNum + 1) + ": " + result + "\n");
        formatOutput(caseNum, result);
    }

    public static void formatOutput(int caseNum, int result) throws IOException, NumberFormatException {
        System.out.println("Case #" + (caseNum + 1) + ": " + result);
    }

    public static void formatOutput(int caseNum, String result) throws IOException, NumberFormatException {
        System.out.println("Case #" + (caseNum + 1) + ": " + result);
    }

    public static String getNextString(BufferedReader bufferedReader) throws IOException {
        return bufferedReader.readLine().trim();
    }

    private static int parseInt(String line) throws NumberFormatException {
        return Integer.parseInt(line);
    }

    public static double parseDouble(String line) throws NumberFormatException {
        return Double.parseDouble(line);
    }
}
