package com.google.jam14.qualification.magictrick;

import com.google.jam08.qualification.JamTask;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.Arrays;

import static com.google.utils.JamUtils.formatOutput;
import static com.google.utils.JamUtils.getNextInt;
import static com.google.utils.JamUtils.getNextString;

/**
 * Created with IntelliJ IDEA.
 * User: Alisa
 * Date: 12.04.14
 * Time: 13:45
 * To change this template use File | Settings | File Templates.
 */
public class MagicTrick extends JamTask {

    private int dim;

    public MagicTrick(int dimension) {
        dim = dimension;
    }

    public static void main(String ... args) {

        MagicTrick taskA = new MagicTrick(4);
        taskA.start();
    }

    @Override
    public void solve(int testCaseNum, BufferedReader bufferedReader, BufferedWriter bufferedWriter) throws IOException {
        //first answer
        int answerFirst = getNextInt(bufferedReader);
        String[] shuffleFirst = getShuffle(bufferedReader, dim);

        int answerSecond = getNextInt(bufferedReader);
        String[] shuffleSecond = getShuffle(bufferedReader, dim);

        solveIntersection(testCaseNum, shuffleFirst[answerFirst - 1], shuffleSecond[answerSecond - 1], bufferedWriter);

    }

    private void solveIntersection(int testCaseNum, String shuffleFirstRow, String shuffleSecondRow, BufferedWriter bufferedWriter) throws IOException {
        System.out.println("testCaseNum = " + testCaseNum + "; row_1=[" +shuffleFirstRow + "]; "
            + "; row_2=[" + shuffleSecondRow + "]; ");
        int intersectionCount = 0;
        String[] items = shuffleFirstRow.split(" ");
        int hitItem = -1;
        for(int i = 0;  i < items.length; i++) {
            String[] items2 = shuffleSecondRow.split(" ");
            for(int j = 0; j < 4; j++) {
                if (items[i].trim().equalsIgnoreCase(items2[j].trim())) {
                    hitItem = Integer.parseInt(items[i].trim());
                    intersectionCount++;
                }
            }

        }
        if (intersectionCount > 1) {
            formatOutput(bufferedWriter, testCaseNum, "Bad magician!");
        } else if (intersectionCount == 1) {
            formatOutput(bufferedWriter, testCaseNum, hitItem);
        } else {
            formatOutput(bufferedWriter, testCaseNum, "Volunteer cheated!");
        }
    }

    private String[] getShuffle(BufferedReader bufferedReader, int dim) throws IOException {
        String[] shuffleFirst = new String[dim];
        for(int i = 0; i < dim; i++) {
            shuffleFirst[i] = getNextString(bufferedReader);
        }
        return shuffleFirst;
    }

    @Override
    public String getInputFileName() {
        return "A-small-attempt2.in";
    }

}
