package C;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class A 
{
	public static void main(String[] args) throws IOException 
	{
		BufferedReader in = new BufferedReader(new FileReader("A-small.in"));
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));
		
		int nbCases = Integer.parseInt(in.readLine());
		
		for(int i=0; i<nbCases; i++)
		{
			System.out.println("NEW CASE" + i);
			
			String conf = in.readLine();
			String[] c2 = conf.split(" ");
			
			int N = Integer.parseInt(c2[0]);
			int K = Integer.parseInt(c2[1]);
			
			Integer[][] a = new Integer[N][N];
			for(int y=0; y<N; y++)
			{
				for(int x=0; x<N; x++)
				{
					a[y][x] = 0;
				}
			}
			
			// Fill and rotate
			String tmpC = "";
			for(int j=0; j<N; j++)
			{
				String line = in.readLine();
				for(int k=0; k<line.length(); k++)
				{
					tmpC = line.substring(k, k+1);
					if(tmpC.equals(".")) a[k][N-j-1] = 0;
					if(tmpC.equals("R")) a[k][N-j-1] = 1;
					if(tmpC.equals("B")) a[k][N-j-1] = 2;
				}
			}

			
			// Gravity
			for(int j = 0; j<N; j++)
			{
				boolean done = false;
				
				while(!done)
				{
					boolean found = false;
					done = true;
					for(int k=0; k<N; k++)
					{
						if(!found && a[k][j] != 0) found = true;
						if(found && a[k][j] == 0)
						{
							a[k][j] = a[k-1][j];
							a[k-1][j] = 0;
							done = false;
						}
					}
				}
				/*
				if(a[N-1][j] == 0)
				{
					int dist = 0;
					int tmp = N-1;
					
					while(tmp >= 0 && a[tmp][j] == 0)
					{
						dist++;
						tmp--;
					}
					
					tmp = N-dist-1;
					while(tmp >= 0)
					{
						a[tmp+dist][j] = a[tmp][j];
						a[tmp][j] = 0;
						tmp--;
					}
				}
				*/
			}
			
			// Win
			boolean R_win = false;
			boolean B_win = false;
			int c = 0;
			int len = 0;
			
			// Lines
			for(int y = 0; y<N; y++)
			{
				c = 0;
				len = 1;
				
				for(int x=0; x<N; x++)
				{
					if(a[y][x] == c)
					{
						len++;
						if(len >= K)
						{
							if(c == 1) R_win = true;
							if(c == 2) B_win = true;
						}
					}
					else 
					{
						c = a[y][x];
						len = 1;
					}
				}
			}
			
			// Cols
			for(int y = 0; y<N; y++)
			{
				c = 0;
				len = 1;
				
				for(int x=0; x<N; x++)
				{
					if(a[x][y] == c)
					{
						len++;
						if(len >= K)
						{
							if(c == 1) R_win = true;
							if(c == 2) B_win = true;
						}
					}
					else 
					{
						c = a[x][y];
						len = 1;
					}
				}
			}
			
			// Diagonals /
			for(int y = K; y<N; y++)
			{
				int tmpX = 0;
				int tmpY = y;
				c = 0;
				len = 1;
				
				while(tmpX < N && tmpY >= 0)
				{
					if(a[tmpY][tmpX] == c)
					{
						len++;
						if(len >= K)
						{
							if(c == 1) R_win = true;
							if(c == 2) B_win = true;
						}
					}
					else 
					{
						c = a[tmpY][tmpX];
						len = 1;
					}
					
					tmpX++;
					tmpY--;
				}
			}
			
			int x = 1;
			while(x < N-K)
			{
				int tmpX = x;
				int tmpY = N-1;
				c = 0;
				len = 1;
				
				while(tmpX < N && tmpY >= 0)
				{
					if(a[tmpY][tmpX] == c)
					{
						len++;
						if(len >= K)
						{
							if(c == 1) R_win = true;
							if(c == 2) B_win = true;
						}
					}
					else 
					{
						c = a[tmpY][tmpX];
						len = 1;
					}
					
					tmpX++;
					tmpY--;
				}
				
				x++;
			}
			
			// Diagonals \
			for(int y = K; y<N; y++)
			{
				int tmpX = N-1;
				int tmpY = y;
				c = 0;
				len = 1;
				
				while(tmpX >= 0 && tmpY >= 0)
				{
					if(a[tmpY][tmpX] == c)
					{
						len++;
						if(len >= K)
						{
							if(c == 1) R_win = true;
							if(c == 2) B_win = true;
						}
					}
					else 
					{
						c = a[tmpY][tmpX];
						len = 1;
					}
					
					tmpX--;
					tmpY--;
				}
			}
			
			x = 0;
			while(x < N)
			{
				int tmpX = x;
				int tmpY = N-1;
				c = 0;
				len = 1;
				
				while(tmpX >= 0 && tmpY >= 0)
				{
					if(a[tmpY][tmpX] == c)
					{
						len++;
						if(len >= K)
						{
							if(c == 1) R_win = true;
							if(c == 2) B_win = true;
						}
					}
					else 
					{
						c = a[tmpY][tmpX];
						len = 1;
					}
					
					tmpX--;
					tmpY--;
				}
				
				x++;
			}
			
			out.print("Case #" + (i+1) + ": ");
			
			if(!R_win && !B_win) out.print("Neither");
			if(R_win && B_win) out.print("Both");
			if(R_win && !B_win) out.print("Red");
			if(!R_win && B_win) out.print("Blue");
			out.println();
		}
		
		out.close();
		System.out.println("DONE");
	}
}
