package c;

import java.util.ListIterator;
import java.util.Vector;

public class Folder 
{
	private String _name;
	private Vector<Folder> _subFolders;
	
	public Folder(String name)
	{
		_name = name;
		_subFolders = new Vector<Folder>();
	}
	
	public String getName()
	{
		return _name;
	}
	
	public Folder addSubFolder(String name)
	{
		if(hasSubFolder(name)) return null;
		
		Folder f = new Folder(name);
		
		_subFolders.add(f);
		return f;
	}
	
	public boolean hasSubFolder(String name)
	{
		if(getSubFolder(name) == null) return false;
		return true;
	}
	
	public Folder getSubFolder(String name)
	{
		ListIterator<Folder> li = _subFolders.listIterator();
		Folder c = null;
		
		while(li.hasNext())
		{
			c = li.next();
			if(c.getName().equals(name)) return c;
		}
		
		return null;
	}
}
