package com.baconcutter;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;

/**
 * Created by Auke on 4/9/2016.
 */
public class ProblemSolver {

    private int problems = 0;
    private int lineIndex = 0;
    private List<String> answers = new ArrayList<>();

    public ProblemSolver(String filenameInput, String filenameOutput) throws IOException {
        try (Stream<String> lines = Files.lines(Paths.get(filenameInput), Charset.defaultCharset())) {
            lines.forEachOrdered(line -> process(line));
            Files.write(Paths.get(filenameOutput), answers);
        }
    }

    private void process(String line) {
        if(lineIndex == 0){
            problems = Integer.parseInt(line);
        } else{
            answers.add("Case #" + lineIndex + ": " + solveProblem(line));
        }
        lineIndex++;
    }

    private String solveProblem(String input){
        long n = Long.valueOf(input);

        String numbers = "";

        if(n <= 0){
            return "INSOMNIA";
        }

        int i = 1;
        while(true){
            long x = n * i;
            String s = String.valueOf(x);

            for(int p = 0; p < 10; p++){
                String ps = String.valueOf(p);
                if(numbers.contains(ps)) continue;
                if(s.contains(ps)){
                    numbers = numbers.concat(ps);
                }
            }

            if(numbers.length() == 10){
                return s;
            }
            i++;
        }
    }
}
