package com.badal;

import static com.badal.util.InputUtility.getDoubleArray;
import static com.badal.util.InputUtility.getInt;

import java.io.BufferedReader;

import com.badal.util.AbstractProblem;

public class CookieClickerAlpha extends AbstractProblem {

	public static void main(String[] args) throws Exception {
		CookieClickerAlpha problem = new CookieClickerAlpha();
		problem.generateOutputForInput("C:\\Users\\badal\\Downloads\\B-large.in");
	}

	@Override
	public void solve(BufferedReader br) throws Exception {
		int t = getInt(br);
		for (int i = 0; i < t; i++) {
			double[] inp = getDoubleArray(br);
			double c = inp[0];// Farm price
			double f = inp[1];// speed increase
			double x = inp[2];// target
			double s = 2.0f;

			double time = 0.0f;
			while (true) {
				double farmReachTime = c / s;
				double targetReachTime = x / s;
				double targetReachAfterBuyingFarm = farmReachTime + x / (s + f);

				if (targetReachTime <= targetReachAfterBuyingFarm) {
					time += targetReachTime;
					break;
				} else {
					time += farmReachTime;
					s += f;
					continue;
				}
			}

			String out = "Case #" + (i + 1) + ": " + String.format("%.7f", time);
			System.out.println(out);
			output.add(out);
		}
	}

}
