package com.badal;

import static com.badal.util.InputUtility.*;

import java.io.BufferedReader;
import java.util.Arrays;

import com.badal.util.AbstractProblem;

public class DeceitfulWar extends AbstractProblem{

	public static void main(String[] args) throws Exception {
		DeceitfulWar problem = new DeceitfulWar();
		problem.generateOutputForInput("C:\\Users\\badal\\Downloads\\D-small-attempt2.in");
	}

	@Override
	public void solve(BufferedReader br) throws Exception {
		int t= getInt(br);
		for (int i = 0; i < t; i++) {
			int total = getInt(br);
			double[] naomi = getDoubleArray(br);
			double[] ken = getDoubleArray(br);
			Arrays.sort(naomi);
			Arrays.sort(ken);
			System.out.println(Arrays.toString(naomi));
			System.out.println(Arrays.toString(ken));
			
			String out = "Case #" + (i + 1) + ": " + playDeceitful(total, naomi, ken) + " " + playNormally(total, naomi, ken);
			output.add(out);
			System.out.println(out);
		}
	}

	private int playDeceitful(int t, double[] naomi, double[] ken) {
		
		int n =0;
		int k =0;
		int win = 0;
		while(n<t && k<t){
			if (naomi[n] <= ken[k]){
				n++;
			}else{
				n++;
				k++;
				win++;
			}
		}
		return win;
	}

	private int playNormally(int t, double[] naomi, double[] ken) {
		int n =0;
		int k =0;
		while(n<t && k<t){
			if (naomi[n] <= ken[k]){
				n++;
				k++;
			}else{
				k++;
			}
		}
		return t-n;
	}

}
