/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package round1B;

import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;

/**
 *
 * @author bahadir
 */
public class PartA {

    private static class Tree {

        public double weight;
        public String feature;
        public Tree first;
        public Tree second;
        public int lastIndex;
    }

    public static void main(String[] args) throws Exception {
        Scanner in = new Scanner(new File("input.txt"));
        PrintStream out = new PrintStream(new File("output.txt"));

        int N = in.nextInt();
        for (int i = 0; i < N; i++) {
            int nline = in.nextInt();
            in.nextLine();
            String str = new String();
            for (int j = 0; j < nline; j++) {
                str += in.nextLine() + " ";
            }

            Tree tree = treeMaker(str);

            out.println("Case #" + (i + 1) + ":");
            int nquery = in.nextInt();
            for (int j = 0; j < nquery; j++) {
                in.next();
                int nfeat = in.nextInt();
                String[] features = new String[nfeat];
                for (int k = 0; k < nfeat; k++) {
                    features[k] = in.next();
                }
                out.println(compute(tree, features));
            }
        }
    }

    private static Tree treeMaker(String str) {
        return treeMaker2(str, str.indexOf('('));
    }

    private static Tree treeMaker2(String str, int index) {
        Tree tree = new Tree();
        

        index++;
        while (str.charAt(index) == ' ') {
            index++;
        }

        int index2 = str.indexOf(' ', index);
        int index3 = str.indexOf(')', index);
        index2 = index3 < index2 ? index3 : index2;
        tree.weight = Double.parseDouble(str.substring(index, index2));

        index = index2;
        while (str.charAt(index) == ' ') {
            index++;
        }

        if (Character.isLetter(str.charAt(index))) {
            tree.feature = new String();
            while (str.charAt(index) != ' ') {
                tree.feature += str.charAt(index++);
            }

            tree.first = treeMaker2(str, str.indexOf('(', index));
            tree.second = treeMaker2(str, str.indexOf('(', tree.first.lastIndex + 1));
            tree.lastIndex = tree.second.lastIndex;
        } else {
            tree.feature = null;
            tree.first = null;
            tree.second = null;
            tree.lastIndex = str.indexOf(')', index);
        }

        return tree;
    }

    private static double compute(Tree tree, String[] features) {
        double prob = 1;
        while (true) {
            prob *= tree.weight;
            if (tree.feature == null) {
                break;
            }

            boolean flag = false;
            for (int i = 0; i < features.length; i++) {
                if (features[i].equals(tree.feature)) {
                    flag = true;
                    break;
                }
            }

            if (flag) {
                tree = tree.first;
            } else {
                tree = tree.second;
            }
        }

        return prob;
    }
}
