/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package qual;

import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;

/**
 *
 * @author bahadir
 */
public class PartB {

    public static void main(String[] args) throws Exception {
        int T;

        Scanner in = new Scanner(new File("input.txt"));
        PrintStream out = new PrintStream(new File("output.txt"));
        T = in.nextInt();
        for (int i = 0; i < T; i++) {
            int H, W;
            H = in.nextInt();
            W = in.nextInt();

            int[][] map = new int[H][W];
            for (int j = 0; j < H; j++) {
                for (int k = 0; k < W; k++) {
                    map[j][k] = in.nextInt();
                }
            }

            char[][] flow = new char[H][W];
            for (int j = 0; j < H; j++) {
                for (int k = 0; k < W; k++) {
                    flow[j][k] = direction(j, k, map);
                }
            }

            int[][] label = new int[H][W];
            for (int j = 0; j < H; j++) {
                for (int k = 0; k < W; k++) {
                    label[j][k] = 0;
                }
            }

            int index = 1;
            for (int j = 0; j < H; j++) {
                for (int k = 0; k < W; k++) {
                    if (label[j][k] == 0) {
                        label[j][k] = index++;
                    }
                    pathFinder(j, k, flow, label);
                }
            }


            char[][] letter = new char[H][W];
            for (int j = 0; j < H; j++) {
                for (int k = 0; k < W; k++) {
                    letter[j][k] = ' ';
                }
            }

            char code = 'a';
            for (int j = 0; j < H; j++) {
                for (int k = 0; k < W; k++) {
                    if (letter[j][k] == ' ') {
                        int id = label[j][k];
                        for (int x = 0; x < H; x++) {
                            for (int y = 0; y < W; y++) {
                                if (label[x][y] == id) {
                                    letter[x][y] = code;
                                }
                            }
                        }
                        code++;
                    }
                }
            }

            out.println("Case #" + (i + 1) + ":");
            for (int j = 0; j < H; j++) {
                for (int k = 0; k < W; k++) {
                    out.print(letter[j][k] + " ");
                }
                out.println();
            }

        }
    }

    private static char direction(int row, int col, int[][] map) {
        int H = map.length;
        int W = map[0].length;

        int up, left, right, down, center;
        center = map[row][col];
        up = row > 0 ? map[row - 1][col] : Integer.MAX_VALUE;
        left = col > 0 ? map[row][col - 1] : Integer.MAX_VALUE;
        right = col < W - 1 ? map[row][col + 1] : Integer.MAX_VALUE;
        down = row < H - 1 ? map[row + 1][col] : Integer.MAX_VALUE;

        int[] list = new int[]{center, up, left, right, down};
        int index = min(list);
        switch (index) {
            case 0:
                return 'c';
            case 1:
                return 'u';
            case 2:
                return 'l';
            case 3:
                return 'r';
            case 4:
                return 'd';
        }
        return 'c';
    }

    private static int min(int[] list) {
        int index = 0;
        for (int i = 1; i < list.length; i++) {
            if (list[i] < list[index]) {
                index = i;
            }
        }
        return index;
    }

    private static void pathFinder(int row, int col, char[][] flow, int[][] label) {
        int H = label.length;
        int W = label[0].length;

        int change = 0;
        switch (flow[row][col]) {
            case 'u':
                if (label[row - 1][col] != 0) {
                    change = label[row - 1][col];
                } else {
                    label[row - 1][col] = label[row][col];
                }
                break;
            case 'l':
                if (label[row][col - 1] != 0) {
                    change = label[row][col - 1];
                } else {
                    label[row][col - 1] = label[row][col];
                }
                break;
            case 'r':
                if (label[row][col + 1] != 0) {
                    change = label[row][col + 1];
                } else {
                    label[row][col + 1] = label[row][col];
                }
                break;
            case 'd':
                if (label[row + 1][col] != 0) {
                    change = label[row + 1][col];
                } else {
                    label[row + 1][col] = label[row][col];
                }
                break;
            case 'c':
                break;
        }

        if (change != 0) {
            for (int i = 0; i < H; i++) {
                for (int j = 0; j < W; j++) {
                    if (label[i][j] == change) {
                        label[i][j] = label[row][col];
                    }
                }
            }
        }
    }
}
