package baka.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;

/**
 *
 * @author taitt
 */
public class CoinJam {

    private int N;
    private int J;

    public CoinJam(int N, int J) {
        this.N = N;
        this.J = J;
    }

    private int[] divisors(String jamStr) {
        int[] rs = new int[9];
        for (int b = 2; b <= 10; b++) {
            BigInteger bi = new BigInteger(jamStr, b);
            int testRound = 10000;
            try {
                if (bi.intValueExact() < testRound) {
                    testRound = bi.intValueExact() - 1;
                }
            } catch (Exception ignore) {
            }

            for (int i = 2; i <= testRound; i++) {
                if (bi.remainder(new BigInteger(i + "")) == BigInteger.ZERO) {
                    rs[b - 2] = i;
                    break;
                }
            }
        }

        return rs;
    }

    private boolean isJamCoin(int[] divisors) {
        for (int i = 0; i < 9; i++) {
            if (divisors[i] == 0) {
                return false;
            }
        }
        return true;
    }

    private String getDivisorsStr(int[] divisors) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < 9; i++) {
            sb.append(" ").append(divisors[i]);
        }
        return sb.toString();
    }

    private void generate(PrintWriter writer, int caseNum) {
        writer.printf("Case #%d:\n", caseNum);
        
        StringBuilder initStr = new StringBuilder("1");
        for (int i = 0; i < N - 2; i++) {
            initStr.append("0");
        }

        BigInteger bi = new BigInteger(initStr.toString(), 2);
        int count = 0;
        while (count < J) {
            bi = bi.add(BigInteger.ONE);
            String candidate = bi.toString(2) + "1";
            int[] divisors = divisors(candidate);
            if (isJamCoin(divisors)) {
                count++;
                writer.println(candidate + getDivisorsStr(divisors));
            }
        }

    }

    public static void process(String filePath) throws Exception {

        File file = new File(filePath);

        try (BufferedReader reader = new BufferedReader(new FileReader(file));
                PrintWriter writer = new PrintWriter(filePath + ".out", "UTF-8");) {

            int T = Integer.parseInt(reader.readLine());
            for (int i = 1; i <= T; i++) {
                String testCase = reader.readLine();
                int n = Integer.valueOf(testCase.split(" ")[0]);
                int j = Integer.valueOf(testCase.split(" ")[1]);
                CoinJam cj = new CoinJam(n, j);
                cj.generate(writer, i);
            }
        }
    }

    public static void main(String[] args) throws Exception {
        process("C-large.in");
    }
}
