package codejam2017;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

/**
 *
 * @author bakaking
 */
public class ProblemD {

    private static final String INPUT = "data/D-small-attempt5.in";
    private static final String OUTPUT = "data/D-small-attempt5.out";
    private static Map<Integer, String> rs = new ConcurrentHashMap<>();
    static int count = 0;
    public static void main(String[] args) {
        ExecutorService executor = Executors.newSingleThreadExecutor();
        try (final PrintWriter writer = new PrintWriter(OUTPUT);
                BufferedReader reader = new BufferedReader(new FileReader(INPUT))) {
            int T = Integer.parseInt(reader.readLine());
            for (int t = 0; t < T; t++) {
                String[] line = reader.readLine().split(" ");
                int N = Integer.parseInt(line[0]);
                int M = Integer.parseInt(line[1]);
                char[][] stage = new char[N][N];

                for (int r = 0; r < N; r++) {
                    for (int c = 0; c < N; c++) {
                        stage[r][c] = '.';
                    }
                }
                for (int m = 0; m < M; m++) {
                    String[] mline = reader.readLine().split(" ");
                    stage[Integer.parseInt(mline[1]) - 1][Integer.parseInt(mline[2]) - 1] = mline[0].charAt(0);
                }

                final int index = t;
                executor.submit(() -> {
                    process(writer, index, N, stage);
                });
            }

            executor.shutdown();
            executor.awaitTermination(10, TimeUnit.MINUTES);
            
            for (int t = 0; t < T; t++) {
                writer.print(rs.get(t));
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    static void process(PrintWriter writer, int t, int N, char[][] stage) {
        count = 0;
        String best = best(N, stage, N - 1, N -1);
        write(writer, N, t, best, stage);
    }
    
    static synchronized void write(PrintWriter writer, int N, int t, String best, char[][] stage) {
        System.out.println("Write rs: " + t);
        char[][] bestArr = stageArray(N, best);
        int diff = 0;
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                if (bestArr[i][j] != stage[i][j]) {
                    diff++;
                    sb.append(bestArr[i][j] + " " + (i + 1) + " " + (j + 1) + "\n");
                }
            }
        }
        String s = String.format("Case #%d: %s %d\n%s", t + 1, point(N, best), diff, sb.toString());
        System.out.println(N + " " + point(N, best));
        rs.put(t, s);
    }

    static String best(int N, char[][] stage, int R, int C) {

        int bestPoint = 0;
        String best = stageStr(N, stage);
        for (int r = R; r >= 0; r--) {
            int c = R == r ? C - 1 : N - 1;
            for (; c >= 0; c--) {
                if (canPutO(N, r, c, stage)) {
                    char oldM = stage[r][c];
                    stage[r][c] = 'o';
                    String b = best(N, stage, r, c);
                    int point = point(N, b);
                    if (point > bestPoint) {
                        bestPoint = point;
                        best = b;
                    }
                    stage[r][c] = oldM;
                }
//                if (N * 2.5f + 15f <= bestPoint) {
//                    return best;
//                }

                if (canPutX(N, r, c, stage)) {
                    char oldM = stage[r][c];
                    stage[r][c] = 'x';
                    String b = best(N, stage, r, c);
                    int point = point(N, b);
                    if (point > bestPoint) {
                        bestPoint = point;
                        best = b;
                    }
                    stage[r][c] = oldM;
                }
//                if (N * 2.5f + 15f <= bestPoint) {
//                    return best;
//                }

                if (canPutP(N, r, c, stage)) {
                    char oldM = stage[r][c];
                    stage[r][c] = '+';
                    String b = best(N, stage, r, c);
                    int point = point(N, b);
                    if (point > bestPoint) {
                        bestPoint = point;
                        best = b;
                    }
                    stage[r][c] = oldM;
                }
//                if (N * 2.5f + 15f <= bestPoint) {
//                    return best;
//                }

                if (count++ > 500000) return best;
            }
        }

        return best;
    }

    static boolean canPutX(int N, int r, int c, char[][] stage) {
        if (stage[r][c] != '.') {
            return false;
        }
        for (int i = 0; i < N; i++) {
            if (stage[r][i] == 'x' || stage[r][i] == 'o') {
                return false;
            }
            if (stage[i][c] == 'x' || stage[i][c] == 'o') {
                return false;
            }
        }
        return true;
    }

    static boolean canPutP(int N, int r, int c, char[][] stage) {
        if (stage[r][c] != '.') {
            return false;
        }
        for (int i = 0; i < N; i++) {
            if (r + c - i >= 0 && r + c - i < N && (stage[i][r + c - i] == '+' || stage[i][r + c - i] == 'o')) {
                return false;
            }
            if (i + c - r >= 0 && i + c - r < N && (stage[i][i + c - r] == '+' || stage[i][i + c - r] == 'o')) {
                return false;
            }
        }
        return true;
    }

    static boolean canPutO(int N, int r, int c, char[][] stage) {
        switch (stage[r][c]) {
            case '.':
                for (int i = 0; i < N; i++) {
                    if (stage[r][i] == 'x' || stage[r][i] == 'o') {
                        return false;
                    }
                    if (stage[i][c] == 'x' || stage[i][c] == 'o') {
                        return false;
                    }
                    if (r + c - i >= 0 && r + c - i < N && (stage[i][r + c - i] == '+' || stage[i][r + c - i] == 'o')) {
                        return false;
                    }
                    if (i + c - r >= 0 && i + c - r < N && (stage[i][i + c - r] == '+' || stage[i][i + c - r] == 'o')) {
                        return false;
                    }
                }
                break;
            case 'o':
                return false;
            case 'x':
                for (int i = 0; i < N; i++) {
                    if (r + c - i >= 0 && r + c - i < N && (stage[i][r + c - i] == '+' || stage[i][r + c - i] == 'o')) {
                        return false;
                    }
                    if (i + c - r >= 0 && i + c - r < N && (stage[i][i + c - r] == '+' || stage[i][i + c - r] == 'o')) {
                        return false;
                    }
                }
                break;
            case '+':
                for (int i = 0; i < N; i++) {
                    if (stage[r][i] == 'x' || stage[r][i] == 'o') {
                        return false;
                    }
                    if (stage[i][c] == 'x' || stage[i][c] == 'o') {
                        return false;
                    }
                }
                break;
            default:
                break;
        }
        return true;
    }

    static void printStage(int N, char[][] stage) {
        int point = 0;
        for (int r = 0; r < N; r++) {
            for (int c = 0; c < N; c++) {
                System.out.print(stage[r][c]);
                switch (stage[r][c]) {
                    case 'o':
                        point += 2;
                        break;
                    case 'x':
                    case '+':
                        point++;
                }
            }
            System.out.println();
        }
        System.out.println("Point = " + point);
    }

    static String stageStr(int N, char[][] stage) {
        StringBuilder sb = new StringBuilder();
        for (int r = 0; r < N; r++) {
            for (int c = 0; c < N; c++) {
                sb.append(stage[r][c]);
            }
        }
        return sb.toString();
    }

    static char[][] stageArray(int N, String stage) {
        char[][] arr = new char[N][N];
        for (int i = 0; i < N; i++) {
            for (int j = 0; j < N; j++) {
                arr[i][j] = stage.charAt(i * N + j);
            }
        }
        return arr;
    }

    static int point(int N, String stage) {
        int point = 0;
        for (int r = 0; r < N; r++) {
            for (int c = 0; c < N; c++) {
                switch (stage.charAt(r * N + c)) {
                    case 'o':
                        point += 2;
                        break;
                    case 'x':
                    case '+':
                        point++;
                }
            }
        }
        return point;
    }
}
