package baka.codejam;

import static baka.codejam.CountingSheep.process;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;

/**
 *
 * @author taitt
 */
public class RevengeOfThePancakes {

    private String S;

    public RevengeOfThePancakes(String S) {
        this.S = S;
    }

    private String minimize() {
        StringBuilder sb = new StringBuilder();
        char last = S.charAt(0);
        sb.append(last);
        for (int i = 1; i < S.length(); i++) {
            if (last != S.charAt(i)) {
                last = S.charAt(i);
                sb.append(last);
            }
        }

        return sb.toString();
    }

    public int maneuverTime() {
        String min = minimize();
        char last = min.charAt(min.length() - 1);
        return (last == '+') ? min.length() - 1 : min.length();
    }

    public static void process(String filePath) throws Exception {

        File file = new File(filePath);

        try (BufferedReader reader = new BufferedReader(new FileReader(file));
                PrintWriter writer = new PrintWriter(filePath + ".out", "UTF-8");) {

            int T = Integer.parseInt(reader.readLine());
            for (int i = 1; i <= T; i++) {
                String s = reader.readLine();
                int time = new RevengeOfThePancakes(s).maneuverTime();
                writer.printf("Case #%d: %d\n", i, time);
            }
        }
    }

    public static void main(String[] args) throws Exception {
        process("B-small-attempt0.in");
    }
}
