package baka.codejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.Collections;
import java.util.Comparator;

/**
 *
 * @author taitt
 */
public class CountingSheep {

    private int N;
    private BitSet bs;

    public CountingSheep(int N) {
        this.N = N;
        this.bs = new BitSet();
    }

    private void updateBitSet(int number) {
        while (number > 0) {
            bs.set(number % 10);
            number /= 10;
        }
    }

    private boolean fallingAsleep() {
        for (int i = 0; i <= 9; i++) {
            if (!bs.get(i)) {
                return false;
            }
        }
        return true;
    }

    public int lastNumber() {
        for (int i = 1; i < 100; i++) {
            updateBitSet(i * N);
            if (fallingAsleep()) {
                return i * N;
            }
        }
        return -1;
    }

    public static void process(String filePath) throws Exception {

        File file = new File(filePath);

        try (BufferedReader reader = new BufferedReader(new FileReader(file));
                PrintWriter writer = new PrintWriter(filePath + ".out", "UTF-8");) {

            int T = Integer.parseInt(reader.readLine());
            for (int i = 1; i <= T; i++) {
                int N = Integer.parseInt(reader.readLine());
                writer.printf("Case #%d: ", i);
                CountingSheep c = new CountingSheep(N);
                int lastNumber = c.lastNumber();

                if (lastNumber <= 0) {
                    writer.println("INSOMNIA");
                } else {
                    writer.println(lastNumber);
                }
            }
        }
    }

    public static void main(String[] args) throws Exception {
        process("A-large.in");
    }
}
