package com.company;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Locale;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner sc = new Scanner(System.in);
        Locale.setDefault(Locale.US);
        PrintWriter writer = new PrintWriter("TaskC.txt", "UTF-8");
        TaskC solver = new TaskC();
        solver.solve(sc, writer);
        writer.close();
    }

    private static class TaskA {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                int destanation = sc.nextInt();
                int n = sc.nextInt();
                double maxTime = 0.0;
                for (int i = 0; i < n; ++i) {
                    int pos = sc.nextInt();
                    int speed = sc.nextInt();

                    double time = 1.0 * (destanation - pos) / (1.0 * speed);
                    maxTime = Math.max(time, maxTime);
                }

                double answer = 1.0 * destanation / maxTime;
                writer.print("Case #" + (t + 1) + ": ");
                writer.println(String.format("%.6f", answer));

            }
        }

        public boolean[] convert(String line) {
            boolean[] pancakes = new boolean[line.length()];
            for (int i = 0; i < line.length(); ++i)
                pancakes[i] = (line.charAt(i) == '+');
            return pancakes;
        }
    }


    private static class TaskC {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                int n = sc.nextInt();
                int q = sc.nextInt();
                assert (q == 1);

                int[] horsesSpeed = new int[n];
                int[] horsesDist = new int[n];
                for (int i = 0; i < n; ++i) {
                    horsesDist[i] = sc.nextInt();
                    horsesSpeed[i] = sc.nextInt();
                }
                int[] dist = new int[n];
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < n; ++j) {
                        int edge = sc.nextInt();
                        if (edge != -1)
                            dist[i] = edge;
                    }
                }

                double[] prefixDist = new double[n];
                prefixDist[0] = 0;
                for (int i = 1; i < n; ++i) {
                    prefixDist[i] = prefixDist[i - 1] + dist[i - 1];
                }

                int first = sc.nextInt();
                int last = sc.nextInt();


                double[] d = new double[n];
                d[0] = 0;
                for (int i = 1; i < n; ++i)
                    d[i] = Double.MAX_VALUE;

                for (int i = 1; i < n; i++) {
                    for (int j = i - 1; j >= 0; --j) {
                        double distance = prefixDist[i] - prefixDist[j];
                        double time = distance / horsesSpeed[j];
                        if (horsesDist[j] >= distance) {
                            d[i] = Math.min(d[j] + time, d[i]);
                        }
                    }
                }


                writer.print("Case #" + (t + 1) + ": ");
                writer.println(String.format("%.6f", d[n - 1]));
            }
        }
    }

}