package com.company;

import java.io.*;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner sc = new Scanner(System.in);
        PrintWriter writer = new PrintWriter("TaskB.txt", "UTF-8");
        TaskB solver = new TaskB();
        solver.solve(sc, writer);
        writer.close();
    }

    static class TaskB {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                writer.print("Case #" + String.valueOf(t + 1) + ": ");
                int[] number = convert(sc.next());
                // 12345675 -> 12345669
                // 123443 -> 123399
                // 11110 -> 9999
                while (decrease(number));


                for (int i = 0; i < number.length; ++i) {
                    if (i == 0 && number[i] == 0)
                        continue;
                    writer.print(number[i]);
                }
                writer.println();
            }
        }

        boolean decrease(int[] number) {
            int last = number[0];
            int index = -1;
            for (int i = 1; i < number.length; ++i) {
                if (last > number[i]) {
                    index = i;
                    break;
                }
                last = number[i];
            }
            if (index != -1) {
                for (int i = index; i < number.length; ++i)
                    number[i] = 9;

                number[index - 1]--;
            }
            return  index != -1;
        }

        int[] convert(String number) {
            int[] result = new int[number.length()];
            for (int i = 0; i < number.length(); ++i)
                result[i] = number.charAt(i) - '0';
            return result;
        }
    }

    static class TaskA {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                boolean[] pancakes = convert(sc.next());
                int k = sc.nextInt();
                int reverse = 0;
                for (int i = 0; i < pancakes.length; ++i) {
                    if (!pancakes[i] && i + k <= pancakes.length) {
                        reverse++;
                        for (int j = i; j < i + k; ++j) {
                            pancakes[j] = !pancakes[j];

                        }
                    }
                }
                boolean result = true;
                for (int i = 0; i < pancakes.length; ++i) {
                    result = result && pancakes[i];
                }

                writer.print("Case #" + String.valueOf(t + 1) + ": ");
                if (result)
                    writer.println(reverse);
                else
                    writer.println("IMPOSSIBLE");
            }
        }

        public boolean[] convert(String line) {
            boolean[] pancakes = new boolean[line.length()];
            for (int i = 0; i < line.length(); ++i)
                pancakes[i] = (line.charAt(i) == '+');
            return pancakes;
        }
    }
}