package com.company;

import java.io.*;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner sc = new Scanner(System.in);
        PrintWriter writer = new PrintWriter("TaskC2.txt", "UTF-8");
        TaskC solver = new TaskC();
        solver.solve(sc, writer);
        writer.close();
    }

    private static class TaskC {
        private int[][] d1;
        private int[][] d2;

        void solve(Scanner sc, PrintWriter writer) {
            int numberTests = sc.nextInt();

            init();
            for (int t = 0; t < numberTests; ++t) {
                writer.print("Case #" + String.valueOf(t + 1) + ": ");
                int n = sc.nextInt();
                int k = sc.nextInt();
                stall = new boolean[n];
                for (int i = 0; i < k; i++) {
                    stall[nextPlace(n)] = true;
                }
//                System.out.print("+");
//                for (int i = 0; i < n; ++i) {
//                    System.out.print(stall[i] ? "+" : "-");
//                }
//                System.out.print("+");
//                System.out.println();
////                int result1 = search1(n, k);
//                int result2 = search2(n, k);
                writer.println(String.valueOf(maxNextFarthest) + " " + String.valueOf(maxFarthest   ));
            }
        }

        private boolean[] stall;

        private int maxFarthest;
        private int maxNextFarthest;

        int nextPlace(int n) {
            maxFarthest = -1;
            maxNextFarthest = -1;
            int index = -1;
            for (int i = 0; i < n; ++i) {
                if (!stall[i]) {
                    int next = findNext(i, n);
                    int prev = findPrev(i, n);
                    int l = i - prev - 1;
                    int r = next - i - 1;
                    int farthest = Math.min(l, r);
                    int nextFarthest = Math.max(l, r);
                    if (farthest > maxFarthest) {
                        maxFarthest = farthest;
                        maxNextFarthest = nextFarthest;
                        index = i;
                    }
                    if (maxFarthest == farthest) {
                        if (nextFarthest > maxNextFarthest) {
                            maxNextFarthest = nextFarthest;
                            maxFarthest = farthest;
                            index = i;
                        }
                    }
                }
            }
            return index;
        }

        int findPrev(int index, int n) {
            for (int i = index; i >= 0; --i) {
                if (stall[i])
                    return  i;
            }
            return -1;
        }

        int findNext(int index, int n) {
            for (int i = index; i < n; ++i) {
                if (stall[i])
                    return  i;
            }
            return n;
        }

        void init() {
            d1 = new int[1500][1500];
            d2 = new int[1500][1500];
            for (int i = 0; i < 1500; ++i) {
                for (int j = 0; j < 1500; ++j) {
                    d1[i][j] = -1;
                    d2[i][j] = -1;
                }
            }
        }

        int search1(int n, int k) {
            if (k == 1) {
                return (n - 1) / 2;
            }
            if (d1[n][k] == -1) {
                d1[n][k] = Math.max(Math.max(search1((n - 1) / 2, k / 2), search1((n - 1) / 2, (k + 1) / 2)),
                        Math.max(search1(n / 2, k / 2), search1(n / 2, (k + 1) / 2)));
            }
            return d1[n][k];
        }

        int search2(int n, int k) {
            if (k == 1) {
                return n / 2;
            }
            if (d2[n][k] == -1) {
                d2[n][k] = Math.max(Math.max(search2((n - 1) / 2, k / 2), search2((n - 1) / 2, (k + 1) / 2)),
                        Math.max(search2(n / 2, k / 2), search2(n / 2, (k + 1) / 2)));
            }
            return d2[n][k];
        }
    }


    static class TaskB {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                writer.print("Case #" + String.valueOf(t + 1) + ": ");
                int[] number = convert(sc.next());

                while (decrease(number)) ;


                for (int i = 0; i < number.length; ++i) {
                    if (i == 0 && number[i] == 0)
                        continue;
                    writer.print(number[i]);
                }
                writer.println();
            }
        }

        boolean decrease(int[] number) {
            int last = number[0];
            int index = -1;
            for (int i = 1; i < number.length; ++i) {
                if (last > number[i]) {
                    index = i;
                    break;
                }
                last = number[i];
            }
            if (index != -1) {
                for (int i = index; i < number.length; ++i)
                    number[i] = 9;

                number[index - 1]--;
            }
            return index != -1;
        }

        int[] convert(String number) {
            int[] result = new int[number.length()];
            for (int i = 0; i < number.length(); ++i)
                result[i] = number.charAt(i) - '0';
            return result;
        }
    }

    static class TaskA {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                boolean[] pancakes = convert(sc.next());
                int k = sc.nextInt();
                int reverse = 0;
                for (int i = 0; i < pancakes.length; ++i) {
                    if (!pancakes[i] && i + k <= pancakes.length) {
                        reverse++;
                        for (int j = i; j < i + k; ++j) {
                            pancakes[j] = !pancakes[j];

                        }
                    }
                }
                boolean result = true;
                for (int i = 0; i < pancakes.length; ++i) {
                    result = result && pancakes[i];
                }

                writer.print("Case #" + String.valueOf(t + 1) + ": ");
                if (result)
                    writer.println(reverse);
                else
                    writer.println("IMPOSSIBLE");
            }
        }

        public boolean[] convert(String line) {
            boolean[] pancakes = new boolean[line.length()];
            for (int i = 0; i < line.length(); ++i)
                pancakes[i] = (line.charAt(i) == '+');
            return pancakes;
        }
    }
}