package com.company;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner sc = new Scanner(System.in);
        Locale.setDefault(Locale.US);
        PrintWriter writer = new PrintWriter("TaskBLarge.txt", "UTF-8");
        TaskBLarge solver = new TaskBLarge();
        solver.solve(sc, writer);
        writer.close();
    }

    private static class TaskA {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                int destanation = sc.nextInt();
                int n = sc.nextInt();
                double maxTime = 0.0;
                for (int i = 0; i < n; ++i) {
                    int pos = sc.nextInt();
                    int speed = sc.nextInt();

                    double time = 1.0 * (destanation - pos) / (1.0 * speed);
                    maxTime = Math.max(time, maxTime);
                }

                double answer = 1.0 * destanation / maxTime;
                writer.print("Case #" + (t + 1) + ": ");
                writer.println(String.format("%.6f", answer));

            }
        }
    }

    private static class TaskBLarge {
        private class Pair implements Comparable<Pair> {
            public Pair() {
                color = 'U';
                count = 0;
                blockSize = 0;
                anticolor = 'T';
            }

            public int count;
            public int blockSize;

            public char color;
            public char anticolor;

            public int compareTo(Pair other) {
                return this.count - other.count;
            }
        }

        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                int n = sc.nextInt();
                int R = sc.nextInt();
                int O = sc.nextInt();
                int Y = sc.nextInt();
                int G = sc.nextInt();
                int B = sc.nextInt();
                int V = sc.nextInt();

                boolean imposibry = false;

                if (B <= O && O > 0) {
                    imposibry = true;
                }
                if (Y <= V && V > 0) {
                    imposibry = true;
                }

                if (R <= G && G > 0) {
                    imposibry = true;
                }


                B -= O;
                Y -= V;
                R -= G;


                Pair[] array = new Pair[3];
                array[0] = new Pair();
                array[0].count = R;
                array[0].color = 'R';
                array[0].anticolor = 'G';
                array[0].blockSize = G;

                array[1] = new Pair();
                array[1].count = Y;
                array[1].color = 'Y';
                array[1].anticolor = 'V';
                array[1].blockSize = V;

                array[2] = new Pair();
                array[2].count = B;
                array[2].color = 'B';
                array[2].anticolor = 'O';
                array[2].blockSize = O;

                Arrays.sort(array);

                char[] result = new char[n];
                n -= 2 * (O + V + G);
                if (array[2].count * 2 > n) {
                    imposibry = true;
                }

                if (2 * array[1].count < n - 2 * array[2].count + 1) {
                    imposibry = true;
                }

                if (!imposibry) {
                    for (int i = 0; i < array[2].blockSize * 2; i += 2) {
                        result[i] = array[2].color;
                        result[i + 1] = array[2].anticolor;
                    }
                    result[array[2].blockSize * 2] = array[2].color;

                    for (int i = array[2].blockSize * 2 + 1; i < array[2].blockSize * 2 + array[0].blockSize * 2 + 1; i += 2) {
                        result[i] = array[0].color;
                        result[i + 1] = array[0].anticolor;
                    }
                    result[array[2].blockSize * 2 + array[0].blockSize * 2 + 1] = array[0].color;
                    int firstElement = array[2].blockSize * 2 + array[0].blockSize * 2 + 1;

                    for (int i = 0; i < 2 * array[1].blockSize; i += 2) {
                        result[result.length - 1 - i] = array[1].color;
                        result[result.length - 1 - i - 1] = array[1].anticolor;
                    }
                    result[result.length - 1 - 2 * array[1].blockSize] = array[1].color;
                    int lastElement = result.length - 1 - 2 * array[1].blockSize;


                    char[] colors = new char[3];
                    colors[0] = array[0].color;
                    colors[1] = array[1].color;
                    colors[2] = array[2].color;

                    array[2].count--;
                    for (int i = 0; i < n; ++i) {
                        if (result[i] < 'A') {
                            firstElement = i;
                            break;
                        }
                    }
                    for (int i = firstElement; i < result.length; i += 2) {
                        if (array[2].count > 0) {
                            result[i] = colors[2];
                        }
                        array[2].count--;
                    }

                    for (int i = lastElement; i >= 0; i -= 2) {
                        if (array[1].count > 0) {
                            if (result[i] == colors[2]) {
                                i--;
                            }
                            result[i] = colors[1];
                            array[1].count--;
                        }
                    }
                    for (int i = 0; i < result.length; ++i) {
                        if (result[i] < 'A')
                            result[i] = colors[0];
                    }
                }

                writer.print("Case #" + (t + 1) + ": ");
                if (imposibry) {
                    writer.println("IMPOSSIBLE");
                    System.out.println("IMPOSSIBLE");
                } else {
                    for (int i = 0; i < result.length; i++) {
                        writer.print(result[i]);
                        System.out.print(result[i]);
                    }
                    System.out.println();
                    writer.println();
                }
            }
        }

    }


    private static class TaskC {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                int n = sc.nextInt();
                int q = sc.nextInt();
                assert (q == 1);

                int[] horsesSpeed = new int[n];
                int[] horsesDist = new int[n];
                for (int i = 0; i < n; ++i) {
                    horsesDist[i] = sc.nextInt();
                    horsesSpeed[i] = sc.nextInt();
                }
                int[] dist = new int[n];
                for (int i = 0; i < n; ++i) {
                    for (int j = 0; j < n; ++j) {
                        int edge = sc.nextInt();
                        if (edge != -1)
                            dist[i] = edge;
                    }
                }

                double[] prefixDist = new double[n];
                prefixDist[0] = 0;
                for (int i = 1; i < n; ++i) {
                    prefixDist[i] = prefixDist[i - 1] + dist[i - 1];
                }

                int first = sc.nextInt();
                int last = sc.nextInt();


                double[] d = new double[n];
                d[0] = 0;
                for (int i = 1; i < n; ++i)
                    d[i] = Double.MAX_VALUE;

                for (int i = 1; i < n; i++) {
                    for (int j = i - 1; j >= 0; --j) {
                        double distance = prefixDist[i] - prefixDist[j];
                        double time = distance / horsesSpeed[j];
                        if (horsesDist[j] >= distance) {
                            d[i] = Math.min(d[j] + time, d[i]);
                        }
                    }
                }


                writer.print("Case #" + (t + 1) + ": ");
                writer.println(String.format("%.6f", d[n - 1]));
            }
        }
    }
}
