package com.company;

import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Locale;
import java.util.Scanner;

public class Main {
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        Scanner sc = new Scanner(System.in);
        Locale.setDefault(Locale.US);
        PrintWriter writer = new PrintWriter("TaskA.txt", "UTF-8");
        TaskA solver = new TaskA();
        solver.solve(sc, writer);
        writer.close();
    }

    private static class TaskA {
        public void solve(Scanner sc, PrintWriter writer) {
            int numTests = sc.nextInt();

            for (int t = 0; t < numTests; ++t) {
                int destanation = sc.nextInt();
                int n = sc.nextInt();
                double maxTime = 0.0;
                for (int i = 0; i < n; ++i) {
                    int pos = sc.nextInt();
                    int speed = sc.nextInt();

                    double time = 1.0 * (destanation - pos) / (1.0 * speed);
                    maxTime = Math.max(time, maxTime);
                }

                double answer = 1.0 * destanation / maxTime;
                writer.print("Case #" + (t + 1) + ": ");
                writer.println(String.format("%.6f", answer));

            }
        }

        public boolean[] convert(String line) {
            boolean[] pancakes = new boolean[line.length()];
            for (int i = 0; i < line.length(); ++i)
                pancakes[i] = (line.charAt(i) == '+');
            return pancakes;
        }
    }
}