package com.baskok.codejam.round2_2009;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

public class D {

	public class Plant {

		public int x;
		public int y;
		public int r;

		public Plant(int x, int y, int radius) {
			this.x = x;
			this.y = y;
			this.r = radius;
		}
		
		@Override
		public String toString() {
			return x + "-" + y + "-"+ r;
		}

	}

	public static void main(String[] args) throws FileNotFoundException {
//		File file = new File("src/com/baskok/codejam/round2_2009/D-example.in");
		File file = new File("src/com/baskok/codejam/round2_2009/D-small-attempt0.in");
//		File file = new File("src/com/baskok/codejam/round2_2009/D-small-attempt1.in");
//		File file = new File("src/com/baskok/codejam/round2_2009/D-large.in");
		Scanner in = new Scanner(file);
		int runs = in.nextInt();
		for (int run = 1; run <= runs; run++) {
			D problem = new D();
			// add arguments
			String result = problem.solve(in);
			System.out.println("Case #" + run + ": " + result);
		}
	}

	private int n;
	List<Plant> plants;
	
	private String solve(Scanner in) {
		n = in.nextInt();
		plants = new ArrayList<Plant>();
		for (int i = 0; i < n; i++) {
			plants.add(new Plant(in.nextInt(), in.nextInt(), in.nextInt()));
		}
		List<Plant> groupA = new ArrayList<Plant>();
		List<Plant> groupB = new ArrayList<Plant>();
		double r = solve(plants, groupA, groupB);
		return Double.toString(r);
	}

	private double solve(List<Plant> plants, List<Plant> groupA,
			List<Plant> groupB) {
		if (plants.size() == 0) {
			// solve
			double ra = calcMinimumRadius(groupA);
			double rb = calcMinimumRadius(groupB);
			if (ra > rb) {
				return ra;
			} else {
				return rb;
			}
		} else {
			ArrayList<Plant> nextPlants = new ArrayList<Plant>(plants);
			Plant removed = nextPlants.remove(0);
			ArrayList<Plant> nextA = new ArrayList<Plant>(groupA);
			nextA.add(removed);
			ArrayList<Plant> nextB = new ArrayList<Plant>(groupB);
			nextB.add(removed);
			double resultA = solve(nextPlants, nextA, groupB);
			double resultB = solve(nextPlants, groupA, nextB);
			if (resultA > resultB) {
				return resultB;
			} else {
				return resultA;
			}
		}
	}

	private double calcMinimumRadius(List<Plant> groupA) {
		if (groupA.size() == 0) {
			return Double.MAX_VALUE / 1000;
		}
		double minx = 9999;
		double maxx = -9999;
		double miny = 9999;
		double maxy = -9999;
		for (Plant plant : groupA) {
			if (plant.x < minx) {
				minx = plant.x;
			}
			if (plant.x > maxx) {
				maxx = plant.x;
			}
			if (plant.y < miny) {
				miny = plant.y;
			}
			if (plant.y > maxy) {
				maxy = plant.y;
			}
		}
		return sectorize(groupA, minx, maxx, miny, maxy, -1);
	}

	private double sectorize(List<Plant> groupA, double minx, double maxx,
			double miny, double maxy, double prevResult) {
		double midx = (minx + maxx) / 2;
		double midy = (miny + maxy) / 2;
		double r0 = calcDistance((midx+minx)/2, (midy+miny)/2, groupA);
		double r1 = calcDistance((midx+maxx)/2, (midy+miny)/2, groupA);
		double r2 = calcDistance((midx+minx)/2, (midy+maxy)/2, groupA);
		double r3 = calcDistance((midx+maxx)/2, (midy+maxy)/2, groupA);
		if (r0 <= r1 && r0 <= r2 && r0 <= r3) {
			if (Math.abs(minx - midx + miny - midy) < 0.00000001 ) {
				return r0;
			} else {
				return sectorize(groupA, minx, midx, miny, midy, r0);
			}
		} else 
		if (r1 <= r0 && r1 <= r2 && r1 <= r3) {
			if (Math.abs(midx - maxx + miny - midy) < 0.00000001 ) {
				return r1;
			} else {
				return sectorize(groupA, midx, maxx, miny, midy, r1);
			}
		} else
		if (r2 <= r1 && r2 <= r0 && r2 <= r3) {
			if (Math.abs(minx - midx + midy - maxy) < 0.00000001 ) {
				return r2;
			} else {
				return sectorize(groupA, minx, midx, midy, maxy, r2);
			}
		} else if (r3 <= r1 && r3 <= r2 && r3 <= r0) {
			if (Math.abs(midx - maxx + midy - maxy) < 0.00000001 ) {
				return r3;
			} else {
				return sectorize(groupA, midx, maxx, midy, maxy, r3);
			}
		} else {
			return Double.MAX_VALUE / 10;
		}
		
	}

	private double calcDistance(double x, double y, List<Plant> groupA) {
		double maxr = 0;
		for (Plant plant : groupA) {
			double r = Math.sqrt((plant.x - x)*(plant.x - x) + (plant.y - y)*(plant.y - y)) + plant.r;
			if (r > maxr) {
				maxr = r;
			}
		}
		return maxr;
	}
	
}
