import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Hashtable;
import java.util.List;
import java.util.Map;

public class FairWarning {

    public static void main(String[] args) throws IOException {
        BufferedReader bufferedReader = null;
        FileWriter writer = null;
        try {
            bufferedReader = new BufferedReader(new FileReader("smallfile.in"));
            writer = new FileWriter("smallfile.out");
            String s;
            int count = 0, cases = 0;
            String[] strings;
            List<BigInteger> decimals;
            while ((s = bufferedReader.readLine()) != null) {
                if (count == 0) {
                    cases = Integer.parseInt(s);
                } else {
                    strings = s.split(" ");
                    decimals = new ArrayList<BigInteger>();
                    for (int i = 1; i <= Integer.parseInt(strings[0]); i++)
                        decimals.add(new BigInteger(strings[i]));
                    reset();
                    Collections.sort(decimals);
                    if (count > cases) break;
                    writer.write(String.format("Case #%d: %s\n", count, apocalypse(decimals)));
                    System.gc();
                }
                count += 1;
            }
        } finally {
            if (bufferedReader != null) bufferedReader.close();
            if (writer != null) writer.close();
        }
    }

    private static void reset() {
        gcds.clear();
        MAX = BigInteger.ZERO;
        MIN = BigInteger.valueOf(Long.MAX_VALUE);
    }

    static BigInteger calculateGcd(List<BigInteger> m) {
        BigInteger gcd = calculateGcd(m.get(0), m.get(1));
        for (int i = 2; i < m.size(); i++) {
            gcd = calculateGcd(gcd, m.get(i));
        }
        return gcd;
    }

    static BigInteger calculateGcd(BigInteger m, BigInteger n) {
        return m.gcd(n);
    }

    static Map<BigInteger, BigInteger> gcds = new Hashtable<BigInteger, BigInteger>();
    static BigInteger MAX = BigInteger.ZERO;
    static BigInteger MIN = BigInteger.valueOf(Long.MAX_VALUE);

    static BigInteger apocalypse(List<BigInteger> seconds, BigInteger delta) {
        while (true) {
            if (delta.compareTo(BigInteger.ZERO) <= 0) {

                for (Map.Entry<BigInteger, BigInteger> entry : gcds.entrySet())
                    if (entry.getKey().equals(MAX)) {
                        MIN = entry.getValue();
                    }
                return MIN;
            }
            List<BigInteger> new_seconds = new ArrayList<BigInteger>();
            for (BigInteger second : seconds) {
                new_seconds.add(second.add(delta));
            }
            greater(calculateGcd(new_seconds), delta);
            delta = delta.subtract(MAX);
        }

    }

    static BigInteger apocalypse(List<BigInteger> seconds) {
        BigInteger T = seconds.get(0);
        BigInteger gcd = calculateGcd(seconds);
        if (seconds.contains(gcd)) {
            return BigInteger.ZERO;
        }
        return apocalypse(seconds, T.subtract(BigInteger.ONE));
    }

    private static void greater(BigInteger gcd, BigInteger delta) {
        if (MAX.compareTo(gcd) <= 0) {
            MAX = gcd;
            if (!gcds.containsKey(gcd)) {
                gcds.put(gcd, delta);
            } else if (delta.compareTo(gcds.get(gcd)) == -1) {
                gcds.put(gcd, delta);
            }
        }
    }
}
