package com.balaji.gcj;

import java.io.*;
import java.math.BigInteger;
import java.util.Arrays;

public class JamCoins {

    private static final int LIMIT = 9999999;
    private static boolean[] primes = new boolean[LIMIT];
    //set up the primesieve
    static public void fillSieve() {
        Arrays.fill(primes, true);        // assume all integers are prime.
        primes[0] = primes[1] = false;       // we know 0 and 1 are not prime.
        for (int i = 2; i < primes.length; i++) {
            //if the number is prime,
            //then go through all its multiples and make their values false.
            if (primes[i]) {
                for (int j = 2; i * j < primes.length; j++) {
                    primes[i * j] = false;
                }
            }
        }
    }

    static class PrimeFactor {
        boolean isPrime;
        BigInteger factor;

        public PrimeFactor(boolean isPrime, BigInteger factor) {
            this.isPrime = isPrime;
            this.factor = factor;
        }
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = null;
        BufferedWriter writer = null;
        fillSieve();

        try {
            reader = new BufferedReader(new FileReader("A-small-attempt0.in"));
            writer = new BufferedWriter(new FileWriter("output.in"));
            int testCases = Integer.parseInt(reader.readLine());
            int index = 1;
            while (index <= testCases) {
                int[] ints = Arrays.stream(reader.readLine().split(" ")).mapToInt(Integer::parseInt).toArray();
                writer.write("Case #" + index + ":\n");
                jamcoin(ints[0], ints[1], writer);
                writer.newLine();
                index++;
            }
        } finally {
            if (reader != null) reader.close();
            if (writer != null) writer.close();
        }

//        jamcoin(32, 500, writer);

    }

    private static void jamcoin(int n, int j, BufferedWriter writer) throws IOException {
        if (n == 1) {
            return;
        }

        if (n == 2) {
            return;
        }

        int count = 1;

        for (int i = 0; i < Math.pow(2, n - 2); i++) {
            String possibleJamCoin = String.format("1%0" + (n - 2) + ".0f1", Double.parseDouble(Integer.toBinaryString(i)));
            if (count > j) break;

            boolean isPrime = false;
            BigInteger[] factors = new BigInteger[9];

            for (int r = 2; r <= 10; r++) {
                BigInteger number = new BigInteger(possibleJamCoin, r);
                PrimeFactor primeFactor = isPrime(number);
                if (primeFactor.isPrime) {
                    isPrime = true;
                    break;
                }
                factors[r - 2] = primeFactor.factor;
            }

            if (!isPrime) {
                writer.write(possibleJamCoin + " ");
                for (BigInteger factor : factors) {
                    writer.write(factor + " ");
                }
                writer.newLine();
                count++;
            }
        }
    }

    private static PrimeFactor isPrime(BigInteger number) {
        if(!number.isProbablePrime(3)) {
            for(int i = 0; i < LIMIT; i++) {
                if(primes[i] && number.mod(BigInteger.valueOf(i)).equals(BigInteger.ZERO)) {
                    return new PrimeFactor(false, BigInteger.valueOf(i));
                }
            }
        }

        BigInteger two = new BigInteger("2");
        BigInteger three = new BigInteger("3");

        if (number.mod(two).equals(BigInteger.ZERO)) {
            return new PrimeFactor(false, two);
        }

        for (BigInteger i = three; i.multiply(i).compareTo(number) < 1; i = i.add(two)) {
            if (i.compareTo(number) < 1 && number.mod(i).equals(BigInteger.ZERO)) {
                return new PrimeFactor(false, i);
            }
        }

        return new PrimeFactor(true, number);
    }
}
