package com.balaji.gcj;

import java.io.*;
import java.math.BigInteger;
import java.util.Arrays;

public class Bleatrix {
    public static void main(String[] args) throws IOException {
        BufferedReader reader = null;
        BufferedWriter writer = null;
        try {
            reader = new BufferedReader(new FileReader("A-small-attempt1.in"));
            writer = new BufferedWriter(new FileWriter("output.in"));
            int testCases = Integer.parseInt(reader.readLine());
            int index = 1;
            while (index <= testCases) {
                BigInteger input = new BigInteger(reader.readLine());
                Arrays.fill(numbers, 0);
                writer.write("Case #" + (index) + ": " + bleatrix(input));
                writer.newLine();
                index++;
            }
        } finally {
            if (reader != null) reader.close();
            if (writer != null) writer.close();
        }
    }

    static int numbers[] = new int[10];

    private static String bleatrix(BigInteger input) {
        if (input.equals(BigInteger.ZERO)) return "INSOMNIA";
        fillDigits(input);
        long next = 1;
        while(!isFull()) {
            fillDigits(input.multiply(BigInteger.valueOf(++next)));
        }
        return input.multiply(BigInteger.valueOf(next)).toString();
    }

    private static boolean isFull() {
        for (int number : numbers) {
            if (number == 0) return false;
        }
        return true;
    }

    private static void fillDigits(BigInteger number) {
        while (number.compareTo(BigInteger.ZERO) != 0) {
            numbers[number.mod(BigInteger.TEN).intValue()]++;
            number = number.divide(BigInteger.TEN);
        }
    }

}
