package com.balaji.gcj;

import java.io.*;

public class PancakeRevenge {
    private static int flip(String stack) {
        char[] stackArray = stack.toCharArray();
        int attempts = 0;
        int index = 0;

        while(!isServable(stackArray) && index < stackArray.length - 1) {
            if(stackArray[index] != stackArray[index + 1]) {
                stackArray = flip(stackArray, index);
                index = 0;
                attempts++;
            } else {
                index++;
            }
        }
        return (stackArray[0] == '-') ? attempts + 1 : attempts;
    }

    private static char[] flip(char[] stack, int end) {
        int start = 0;
        while (start <= end) {
            char temp = stack[start];
            stack[start] = stack[end] == '-' ? '+' : '-';
            stack[end] = temp == '-' ? '+' : '-';
            start++;
            end--;
        }
        return stack;
    }

    private static boolean isServable(char[] stack) {
        for (char c : stack) {
            if (c == '-') return false;
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = null;
        BufferedWriter writer = null;
        try {
            reader = new BufferedReader(new FileReader("B-large.in"));
            writer = new BufferedWriter(new FileWriter("output.in"));
            int testCases = Integer.parseInt(reader.readLine());
            int index = 1;
            while (index <= testCases) {
                writer.write("Case #" + (index) + ": " + flip(reader.readLine()));
                writer.newLine();
                index++;
            }
        } finally {
            if (reader != null) reader.close();
            if (writer != null) writer.close();
        }

    }
}
