package com.openbala;

import org.apache.commons.lang.ArrayUtils;
import org.apache.commons.lang.StringUtils;

import java.io.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class Magicka {

    public static void main(String[] args) {
        BufferedReader reader = null;
        BufferedWriter writer = null;

        try {
            reader = new BufferedReader(new FileReader("/home/balaji/Documents/test.in"));
            writer = new BufferedWriter(new FileWriter("/home/balaji/Documents/out.in"));
            String line;
            int lineCount = 0, cases = 0, caseCount = 0;
            while ((line = reader.readLine()) != null) {
                lineCount++;
                if (lineCount == 1) {
                    cases = Integer.valueOf(line.trim());
                } else {
                    caseCount++;
                    String[] strings = line.split(" ");
                    String base = null;
                    String opposed = null;
                    if(!strings[0].equals("0")) {
                        base = strings[1];
                        if(!strings[2].equals("0")) {
                            opposed = strings[3];
                        }
                    } else if(!strings[1].equals("0")) {
                        opposed = strings[2];
                    }
                    String spell = strings[strings.length - 1];
                    String result = magic(base, opposed, spell.substring(0, Integer.valueOf(strings[strings.length - 2])));
                    String join = StringUtils.join(ArrayUtils.toObject(result.toCharArray()), ", ");
                    writer.write(String.format("Case #%d: %s\n", caseCount, "[" + join + "]"));
                    if (caseCount == cases) {
                        break;
                    }
                }
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if (reader != null) {
                try {
                    reader.close();
                } catch (IOException e) {
                }
            }
            if (writer != null) {
                try {
                    writer.close();
                } catch (IOException e) {
                }
            }
        }
    }

    static String magic(String base, String opposed, String spell) {
        StringBuilder buffer = new StringBuilder();
        String opp = (opposed != null) ? opposed.charAt(0) + ".*" + opposed.charAt(1) + "|" + opposed.charAt(1) + ".*" + opposed.charAt(0) : "12345";
        Pattern opposePattern = Pattern.compile(opp);
        String bas = (base != null) ? "^" + base.charAt(0) + base.charAt(1) + "$|^" + base.charAt(1) + base.charAt(0) + "$" : "12345";
        Pattern basePattern = Pattern.compile(bas);

        for (int i = 0; i < spell.length(); i++) {
            buffer.append(spell.charAt(i));
            if (i > 0 && buffer.length() > 1) {
                Matcher matcher = basePattern.matcher(String.valueOf(buffer.charAt(buffer.length() - 2)) + buffer.charAt(buffer.length() - 1));
                while (matcher.find()) {
                    buffer.replace(buffer.length() - 2, buffer.length(), String.valueOf(base.charAt(2)));
                }
            }
            Matcher matcher = opposePattern.matcher(buffer.toString());
            while (matcher.find()) {
                buffer.delete(matcher.start(), matcher.end());
            }
        }
        return buffer.toString();
    }
}
