/**
 * 
 * @author Narayanan (balak)
 * @brief  Solution to problem B in Code Jam 2009
 */
import java.io.* ;
import java.util.* ;

public class WaterShed {
	public enum Direction {
		NORTH,
		WEST,
		EAST,
		SOUTH
	}
	
	public static int GetAlt( int Rows, int Cols, int CurrentRow, int CurrentCol, int[][] Altitudes, Direction D )
	{
		switch (D)
		{
		case NORTH:
			if ( ( CurrentRow - 1 ) < 0 ) return -1 ;
			return Altitudes[ CurrentRow - 1 ][ CurrentCol ] ;
		case SOUTH:
			if ( ( CurrentRow + 1 ) >= Rows ) return -1 ;
			return Altitudes[ CurrentRow + 1 ][ CurrentCol ] ;
		case EAST:
			if ( ( CurrentCol + 1 ) >= Cols ) return -1 ;
			return Altitudes[ CurrentRow ][ CurrentCol + 1 ] ;
		case WEST:
			if ( ( CurrentCol - 1 ) < 0 ) return -1 ;
			return Altitudes[ CurrentRow ][ CurrentCol - 1 ] ;
		}
		return -1 ;
	}

	public static int GetLowest( int Rows, int Cols, int RowPos, int ColPos, int Altitudes[][] )
	{
		int LowestAlt[] = new int[4] ;
		int Precedence = -1 ;
		LowestAlt[0] = GetAlt( Rows, Cols, RowPos, ColPos, Altitudes, Direction.NORTH ) ;
		LowestAlt[1] = GetAlt( Rows, Cols, RowPos, ColPos, Altitudes, Direction.WEST ) ;
		LowestAlt[2] = GetAlt( Rows, Cols, RowPos, ColPos, Altitudes, Direction.EAST ) ;
		LowestAlt[3] = GetAlt( Rows, Cols, RowPos, ColPos, Altitudes, Direction.SOUTH ) ;
		
		for (int PrecLooper = 0 ;  PrecLooper < 4 ;  PrecLooper++)
		{
			if (LowestAlt[PrecLooper] != -1)
			{
				if (Precedence == -1) Precedence = PrecLooper ;
				else
				{
					if (LowestAlt[PrecLooper] < LowestAlt[Precedence])
						Precedence = PrecLooper ;
				}
			}
		}
		return Precedence ;
	}
	
	public static void main(String[] argv) throws Exception
	{
		// Create a reader to read stdin
		BufferedReader Reader = new BufferedReader(new InputStreamReader(System.in)) ;
		
		int NumberOfInputs = Integer.parseInt(Reader.readLine()) ;
		for (int InputLooper = 1 ;  InputLooper <= NumberOfInputs ;  InputLooper++)
		{
			StringTokenizer Tokenizer = new StringTokenizer( Reader.readLine(), " ", false ) ;
			int Rows = Integer.parseInt( Tokenizer.nextToken() ) ;
			int Cols = Integer.parseInt( Tokenizer.nextToken() ) ;
			
			int [][] Altitudes = new int [ Rows ][ Cols ] ;
			char[][] Labels    = new char[ Rows ][ Cols ] ;
			
			for (int RowLooper = 0 ;  RowLooper < Rows ;  RowLooper++)
			{
				StringTokenizer RowTokens = new StringTokenizer( Reader.readLine(), " ", false ) ;
				for (int ColLooper = 0 ;  ColLooper < Cols;  ColLooper++)
				{
					Altitudes[ RowLooper ][ ColLooper ] = Integer.parseInt( RowTokens.nextToken() ) ;
					Labels   [ RowLooper ][ ColLooper ] = 0 ;
				}
			}
			
			Labels[0][0]  = 'a' ;
			char NextChar = 'b' ;
			
			int Precedence = GetLowest( Rows, Cols, 0, 0, Altitudes ) ;

			
			for (int RowLooper = 0 ;  RowLooper < Rows ;  RowLooper++)
			{
				for (int ColLooper = 0 ;  ColLooper < Cols;  ColLooper++)
				{
					// if (Labels[RowLooper][ColLooper] != 0) continue ;
					
					Precedence = GetLowest( Rows, Cols, RowLooper, ColLooper, Altitudes ) ;
					int LowestRowIdx = (Precedence == 0) ? (RowLooper - 1) : ((Precedence == 3) ? (RowLooper + 1) : RowLooper) ;
					int LowestColIdx = (Precedence == 1) ? (ColLooper - 1) : ((Precedence == 2) ? (ColLooper + 1) : ColLooper) ;
					
					if (Labels[RowLooper][ColLooper] != 0)
					{
						if (Altitudes[RowLooper][ColLooper] > Altitudes[LowestRowIdx][LowestColIdx])
						{
							if (Labels[LowestRowIdx][LowestColIdx] == 0)
								Labels[LowestRowIdx][LowestColIdx] = Labels[RowLooper][ColLooper] ;
						}
					}
					else
					{
						if (Altitudes[RowLooper][ColLooper] > Altitudes[LowestRowIdx][LowestColIdx])
						{
							if (Labels[LowestRowIdx][LowestColIdx] != 0)
								Labels[RowLooper][ColLooper] = Labels[LowestRowIdx][LowestColIdx] ;
							else
							{
								Labels[LowestRowIdx][LowestColIdx] = NextChar ;
								Labels[RowLooper][ColLooper] = NextChar ;
								if (NextChar < 'z') NextChar++ ;
							}
						}
						else
						{
							Labels[RowLooper][ColLooper] = NextChar ;
							if (NextChar < 'z') NextChar++ ;
						}
					}
				}
			}

			System.out.print("Case #") ;
			System.out.print(InputLooper) ;
			System.out.println(":") ;
			
			for (int RowLooper = 0 ;  RowLooper < Rows ;  RowLooper++)
			{
				for (int ColLooper = 0 ;  ColLooper < Cols;  ColLooper++)
				{
					System.out.print( Labels[RowLooper][ColLooper] ) ;
					if (ColLooper < (Cols - 1)) System.out.print(" ") ;
				}
				System.out.println("") ;
			}
			
		}
	}
}
