/**
 * 
 * @author Narayanan (balak)
 * @brief  Solution to problem A in Code Jam 2009
 */
import java.io.* ;
import java.util.* ;
public class AlienLanguage
{
	private enum ScannerLocation
	{
		IN_PATTERN,
		NOT_IN_PATTERN
	}
	
	public static void main(String[] argv) throws Exception
	{
		// Create a reader to reading stdin
		BufferedReader Reader = new BufferedReader(new InputStreamReader(System.in)) ;
		
		// Read in the first line
		String FirstLine = Reader.readLine() ;
		
		// Break it into L, D, and N
		StringTokenizer Tokenizer = new StringTokenizer(FirstLine, " ") ;
		int L = Integer.parseInt(Tokenizer.nextToken()) ;
		int D = Integer.parseInt(Tokenizer.nextToken()) ;
		int N = Integer.parseInt(Tokenizer.nextToken()) ;
		
		// Read in the words (D of them in all) and store them in an array
		String[] WordList = new String[ D ] ;
		for (int Looper1 = 0 ;  Looper1 < D ;  Looper1++)
		{
			WordList[ Looper1 ] = Reader.readLine() ;
		}
		
		String[] SubPatterns = new String[ L ] ;
		// Read in the patterns and process them
		for (int PatternLooper = 1 ;  PatternLooper <= N ;  PatternLooper++)
		{
			int ScanPos = 0 ;
			int SPAIndex = 0 ;
			ScannerLocation SLoc = ScannerLocation.NOT_IN_PATTERN ;

			for (int Looper2 = 0 ;  Looper2 < L ;  Looper2++)
				SubPatterns[ Looper2 ] = "" ;
			
			String Pattern = Reader.readLine() ;
			while ( ScanPos < Pattern.length() )
			{
				char AChar = Pattern.charAt( ScanPos ) ;
				switch ( AChar )
				{
				case '(':
					SLoc = ScannerLocation.IN_PATTERN ;
					break ;
				case ')':
					SLoc = ScannerLocation.NOT_IN_PATTERN ;
					SPAIndex++ ;
					break ;
				default:
					SubPatterns[ SPAIndex ] += AChar ;
					SPAIndex = (SLoc == ScannerLocation.IN_PATTERN) ? SPAIndex : SPAIndex + 1 ;
				}
				ScanPos++ ;
			}
			
			// Match and report
			int CountMatches = 0 ;
			for (int WordListLooper = 0 ;  WordListLooper < D ;  WordListLooper++)
			{
				boolean Matched = true ;
				int CharLooper = 0 ;
				while (CharLooper < L)
				{
					if (SubPatterns[CharLooper].indexOf( WordList[WordListLooper].charAt(CharLooper)) == -1)
					{
						Matched = false ;
						break ; // exit while loop
					}
					CharLooper++ ;
				}
				CountMatches = Matched ? (CountMatches + 1) : CountMatches ;
			}

			System.out.print("Case #") ;
			System.out.print(PatternLooper) ;
			System.out.print(": ") ;
			System.out.println(CountMatches) ;
		}
	}
}
