import java.io.FileInputStream;
import java.util.Arrays;
import java.util.Scanner;

public class C {

	private static long getNonTrivialDivisor(String binary, int radix) {
		long value = Long.parseLong(binary, radix);
		long limit = (long) Math.sqrt(value);
		for(long i = 2; i < limit; i++)
			if ( value % i == 0 )
				return i;
		return 0;
	}
	
	private static String process(Scanner in) {
		int N = in.nextInt();
		int J = in.nextInt();
		long base = 1 << (N - 2);
		long limit = 1 << (N - 2);
		long[] divisors = new long[9];
		StringBuffer result = new StringBuffer();
		int count = 0;
		for(long i = 0; i < limit; i++) {
			long x = ((base + i) << 1) + 1;
			String binary = Long.toString(x, 2);
			boolean ok = true;
			for(int radix = 2; radix <= 10 && ok; radix++) {
				long divisor = getNonTrivialDivisor(binary, radix);
				if ( divisor < 2 ) 
					ok = false;
				else
					divisors[radix - 2] = divisor;
			}
			if ( ok ) { 
				result.append("\n" + binary + " " + Arrays.toString(divisors).replaceAll("[,\\[\\]]", ""));
				count++;
				if ( count == J )
					return new String(result);
			}
		}
		throw new RuntimeException("not expected");
	}

	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner(System.in.available() > 0 ? System.in : 
			new FileInputStream(Thread.currentThread().getStackTrace()[1].getClassName() + ".practice.in"));
		int T = in.nextInt();
		for(int i = 1; i <= T; i++) 
			System.out.format("Case #%d: %s\n", i, process(in));
	}
}
