import java.io.FileInputStream;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

public class B {

	static int N;
	static char[] res;
	static int[] cnt = new int[255];
	//static Character[] order = new Character[] {'R', 'B', 'Y', 'V', 'G', 'O'};
	static Character[] order = new Character[] {'R', 'B', 'Y'};
	static String[] allowed = new String[255];

	static Comparator<Character> comparator = new Comparator<Character>() {
		@Override
		public int compare(Character o1, Character o2) {
			//System.out.println(cnt[o1] + " " + cnt[o2]);
			if (cnt[o2] == cnt[o1])
				return o2 - o1;
			return cnt[o2] - cnt[o1];
		}
	};

	private static boolean trySet(int pos, char c) {
		if (cnt[c] > 0 && (pos == 0 || allowed[res[pos-1]].indexOf(c) >= 0)) {
			res[pos] = c;
			cnt[c]--;
			return true;
		}
		return false;
	}

	private static boolean setNext(int pos) {
		Arrays.sort(order, comparator);
		if (pos > 0) {
			for(int p = order.length - 1; p > 0; p--) {
				if (res[0] == order[p] && cnt[res[0]] == cnt[order[p-1]]) {
					order[p] = order[p-1];
					order[p-1] = res[0];
				}
			}
		}
		//System.out.println(Arrays.toString(order));
		boolean set = false;
		if ( pos == 0 ) {
			set = true;
			if (!trySet(pos, order[0]))
				if (!trySet(pos, order[1]))
					if (!trySet(pos, order[2]))
						set = false;
		}
		if ( !set ) {
			if (!trySet(pos, 'V'))
				if (!trySet(pos, 'G'))
					if (!trySet(pos, 'O'))
						if (!trySet(pos, order[0]))
							if (!trySet(pos, order[1]))
								if (!trySet(pos, order[2]))
									return false;
		}
		//System.out.println(Arrays.toString(res));
		return true;
	}

	private static String process(Scanner in) {
		Arrays.fill(cnt, 0);
		N = in.nextInt();
		cnt['R'] = in.nextInt();
		cnt['O'] = in.nextInt();
		cnt['Y'] = in.nextInt();
		cnt['G'] = in.nextInt();
		cnt['B'] = in.nextInt();
		cnt['V'] = in.nextInt();
		res = new char[N];
		boolean ok = true;	
		for(int pos = 0; ok && pos < N; pos++) {
			ok = setNext(pos);
		}
		if (ok && allowed[res[N-1]].indexOf(res[0]) < 0)
			ok = false;
		return ok ? new String(res) : "IMPOSSIBLE";
	}

	public static void main(String[] args) throws Exception {
		allowed['R'] = "BYG"; // RR
		allowed['B'] = "RYO"; // BB
		allowed['Y'] = "RBV"; // YY
		allowed['V'] = "Y"; // RB
		allowed['G'] = "R"; // BY
		allowed['O'] = "B"; // RY
		Scanner in = new Scanner(System.in.available() > 0 ? System.in : 
			new FileInputStream(Thread.currentThread().getStackTrace()[1].getClassName() + ".practice.in"));
		int T = in.nextInt();
		for(int i = 1; i <= T; i++) 
			System.out.format("Case #%d: %s\n", i, process(in));
	}
}
