import java.io.FileInputStream;
import java.util.HashSet;
import java.util.InputMismatchException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    double []occ;
    int k,l,s,max;
    String target,orig;
    HashSet<String> set ;
    public void solve(int testNumber, InputReader in, PrintWriter out) {
        k = in.nextInt();
        l = in.nextInt();
        s = in.nextInt();
        orig = in.next();
        set = new HashSet<String>();
        occ = new double[26];
        for (int i = 0; i < orig.length(); i++) {
            occ[orig.codePointAt(i) - 65]++;
        }
        for (int i = 0; i < 26; i++) {
            occ[i] /= k;
        }
        target = in.next();
        max = 0;
        out.print("Case #" + testNumber + ": ");
        double val = go(0, "");
        double max1 = max;
        max1 -= val;
        out.printf("%.6f\n",max1);
        int dd = 0;
    }

    private double go(int pos, String ans) {
        if (pos == s){
            int cnt = 0;
            if (set.contains(ans))return 0;
            for (int i = 0; i < ans.length();) {
                if (ans.indexOf(target,i) == -1)break;
                cnt++;
                i = ans.indexOf(target,i) + 1;
            }
            set.add(ans);
            max = Math.max(cnt,max);
            return cnt;
        }

        double a = 0.0;
        for (int i = 0; i < k; i++) {
            a += go(pos + 1,ans + orig.charAt(i))*(occ[orig.codePointAt(i) - 65]);
        }
        return a;
    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                    tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }


}

