import java.io.FileInputStream;
import java.util.InputMismatchException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "D-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("d.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskD solver = new TaskD();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskD {
    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int x = in.nextInt();
        int r = in.nextInt();
        int c = in.nextInt();
        out.print("Case #"+testNumber+": ");
        int []tiles = new int[]{0,0,0,2,2,3,3};
        if (x >= 7 || tiles[x] > Math.min(r,c)){
            out.print("RICHARD\n");
            return;
        }
        int g = r*c;
        if (x <= 3){
            if (g % x == 0) {
                out.print("GABRIEL\n");
            }
            else out.print("RICHARD\n");
        }
        if (x == 4){
            if (g % x == 0 && ((r >= 3 && c >= 3))) {
                out.print("GABRIEL\n");
            }
            else out.print("RICHARD\n");
        }
        if (x == 5){
            if (g % x == 0 && ((r >= 4 && c >= 4))) {
                out.print("GABRIEL\n");
            }
            else out.print("RICHARD\n");
        }
        if (x == 6){
            if (g % x == 0 && ((r >= 5 && c >= 5))) {
                out.print("GABRIEL\n");
            }
            else out.print("RICHARD\n");
        }

    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                    tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }


}

