import java.io.*;
import java.util.HashSet;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.print("Case #" + testNumber + ": ");
            char[] c = in.next().toCharArray();
            int[] let = new int[26];
            for (int i = 0; i < c.length; i++) {
                let[c[i] - 'A']++;
            }
            String[] al = new String[]{"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
            HashSet<Integer>[] pos = new HashSet[26];
            for (int i = 0; i < 26; i++) {
                pos[i] = new HashSet<>();
            }
            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < al[i].length(); j++) {
                    pos[al[i].charAt(j) - 'A'].add(i);
                }
            }
            int[][] seq = new int[10][2];
            int ind = 0;
            while (true) {
                boolean flag = true;
                for (int i = 0; i < 26; i++) {
                    if (pos[i].size() == 1) {
                        int m = 0;
                        flag = false;
                        for (int d : pos[i]) {
                            m = d;
                        }
                        for (int j = 0; j < al[m].length(); j++) {
                            pos[al[m].charAt(j) - 'A'].remove(m);
                        }
                        seq[ind][0] = m;
                        seq[ind++][1] = i;
                        break;
                    }
                }
                if (flag) break;
            }
            int[] ans = new int[10];
            for (int i = 0; i < 10; i++) {
                if (let[seq[i][1]] > 0) {
                    ans[seq[i][0]] = let[seq[i][1]];
                    int minus = let[seq[i][1]];
                    for (int j = 0; j < al[seq[i][0]].length(); j++) {
                        let[al[seq[i][0]].charAt(j) - 'A'] -= minus;
                    }
                    let[seq[i][1]] = 0;
                }
            }
            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < ans[i]; j++) {
                    out.print(i);
                }
            }
            out.println();
        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

    }
}

