import java.io.*;
import java.util.ArrayList;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "C-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("c.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskC solver = new TaskC();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskC {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int a = in.nextInt(), b = in.nextInt(), c = in.nextInt();
            int k = in.nextInt();
            int[][][] map = new int[20][20][20];
            int[][][] over = new int[20][20][20];
            ArrayList<pairs> list = new ArrayList<>();
            ArrayList<pairs> ans = new ArrayList<>();
            for (int i = 1; i <= a; i++) {
                for (int j = 1; j <= b; j++) {
                    for (int l = 1; l <= c; l++) {
                        list.add(new pairs(i, j, l));
                    }
                }
            }
            while (true) {
                int cnt = 0;
                for (int i = 0; i < list.size(); i++) {
                    pairs p = list.get(i);
                    if (map[p.a][p.b][0] == k || map[p.a][0][p.c] == k ||
                            map[0][p.b][p.c] == k || over[p.a][p.b][p.c] == 1) continue;
                    ans.add(p);
                    map[p.a][p.b][0]++;
                    map[p.a][0][p.c]++;
                    map[0][p.b][p.c]++;
                    ++cnt;
                    over[p.a][p.b][p.c] = 1;
                }
                if (cnt == 0) break;
            }
            out.print("Case #" + testNumber + ": " + ans.size() + "\n");
            for (pairs p : ans) {
                out.println(p.a + " " + p.b + " " + p.c);
            }
        }

        class pairs {
            int a;
            int b;
            int c;

            public pairs(int a, int b, int c) {
                this.a = a;
                this.b = b;
                this.c = c;
            }

        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}

