import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        char[] a1;
        char[] b1;
        String r1;
        String r2;
        int p;

        public void solve(int testNumber, InputReader in, PrintWriter out) {
            a1 = in.next().toCharArray();
            b1 = in.next().toCharArray();
            p = 1000000;
            int min = find(0, "", "");
            out.print("Case #" + testNumber + ": " + r1 + " " + r2 + "\n");
        }

        private int find(int f, String fs, String ss) {
            if (f == a1.length) {
                int fs1 = Integer.parseInt(fs), ss1 = Integer.parseInt(ss);
                if (Math.abs(fs1 - ss1) == p) {
                    if (r1.compareTo(fs) == 0) {
                        if (r2.compareTo(ss) > 0) r2 = ss;
                    } else if (r1.compareTo(fs) > 0) {
                        r1 = fs;
                        r2 = ss;
                    }
                } else if (Math.abs(fs1 - ss1) < p) {
                    p = Math.abs(fs1 - ss1);
                    r1 = fs;
                    r2 = ss;
                }
                return Math.abs(fs1 - ss1);
            }

            int t = 10000;
            if (a1[f] == '?' && a1[f] == b1[f]) {
                for (int i = 0; i < 10; i++) {
                    for (int j = 0; j < 10; j++) {
                        t = Math.min(t, find(f + 1, fs + i, ss + j));
                    }
                }
            } else if (a1[f] == '?') {
                for (int i = 0; i < 10; i++) {
                    t = Math.min(t, find(f + 1, fs + i, ss + b1[f]));
                }
            } else if (b1[f] == '?') {
                for (int i = 0; i < 10; i++) {
                    t = Math.min(t, find(f + 1, fs + a1[f], ss + i));
                }
            } else t = Math.min(t, find(f + 1, fs + a1[f], ss + b1[f]));
            return t;
        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

    }
}

