import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int b = in.nextInt();
            long max = in.nextLong();
            out.print("Case #" + testNumber + ": ");
            long v = 1, p = 1;
            int cnts = 1;
            while (v < max) {
                v += p;
                p *= 2;
                ++cnts;
            }
            long tot = 1;
            p = 1;
            for (int i = 1; i < b; i++) {
                tot += p;
                p *= 2;
            }
            if (cnts >= b) {
                out.print("IMPOSSIBLE\n");
                return;
            }
            tot -= max;
            max = tot;
            int[] bit = new int[51];
            while (max > 0) {
                int cnt = 0;
                p = 1;

                while (p * 2 <= max) {
                    p *= 2;
                    ++cnt;
                }
                bit[cnt]++;
                max -= p;
            }
            int[][] ans = new int[100][100];
            for (int i = 0; i < cnts; i++) {
                for (int j = i + 1; j < b; j++) {
                    ans[i][j] = 1;
                }
            }
            for (int i = 0; i < bit.length; i++) {
                if (i == 0) {
                    if (bit[i] > 1) {
                        ans[i][b - 1] = 0;
                        ans[i + 1][b - 1] = 0;
                    } else if (bit[i] == 1) ans[i + 1][b - 1] = 0;
                } else {
                    if (bit[i] != 0) ans[i + 1][b - 1] = 0;
                }
            }
            out.print("POSSIBLE\n");
            for (int i = 0; i < b; i++) {
                for (int j = 0; j < b; j++) {
                    out.print(ans[i][j]);
                }
                out.println();
            }

        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

    }
}

