import java.io.FileInputStream;
import java.util.InputMismatchException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {

    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int d = in.nextInt();
        int []p = new int[10];
        for (int i = 0; i < d; i++) {
            p[in.nextInt()]++;
        }
        int ans = go(p,9);
        out.print("Case #"+testNumber+": ");
        out.print(ans+"\n");
    }

    private int go(int[] p, int pos) {
        if (pos <= 1){
            return p[pos];
        }
        int ind = pos;
        for (int i = pos; i > 0 ; i--) {
            if (p[i] > 0){
                ind = pos;
                break;
            }
        }
        int t = 0;
        if (ind == 1){
            int []g = new int[1];
            t = Math.min(p[ind] + go(g,ind - 1), ind);
        }
        else {
            int []g = new int[10];
            int l = ind - ind / 2;
            g[l] += p[ind];
            g[ind - l] += p[ind];
            for (int i = 0; i < p.length; i++) {
                if (ind != i){
                    g[i] += p[i];
                }
            }
            t = Math.min(p[ind] + go(g, ind - 1), ind);
        }
        return t;
    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                    tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }


}

