import java.io.*;
import java.util.*;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.print("Case #" + testNumber + ": ");
            int n = in.nextInt();
            ArrayList<pair> senates = new ArrayList<>();
            for (int i = 0; i < n; i++) {
                senates.add(new pair(in.nextInt(), i));
            }
            while (true) {
                Collections.sort(senates, new Comparator<pair>() {

                    public int compare(pair o1, pair o2) {
                        if (o1.cnt == o2.cnt) return o1.ind - o2.ind;
                        return o1.cnt - o2.cnt;
                    }
                });
                int from = senates.size() - 1, to = senates.size() - 1;
                if (senates.get(to).cnt == 0) break;
                for (int i = to - 1; i > -1; --i) {
                    if (senates.get(i).cnt != senates.get(i + 1).cnt) break;
                    from--;
                }
                int size = to - from + 1;
                if (size % 2 != 0) {
                    pair k = senates.get(to);
                    k.cnt--;
                    senates.set(to, k);
                    out.print((char) (k.ind + 'A') + " ");
                    continue;
                }
                if (size % 2 == 0) {
                    for (int i = from; i <= to; i += 2) {
                        pair k1 = senates.get(i);
                        pair k2 = senates.get(i + 1);
                        k1.cnt--;
                        k2.cnt--;
                        senates.set(i, k1);
                        senates.set(i + 1, k2);
                        String pri = String.valueOf((char) (k1.ind + 'A') + "" + (char) (k2.ind + 'A'));
                        out.print(pri + " ");
                    }
                }
            }
            out.println();
        }

        class pair {
            int cnt;
            int ind;

            public pair(int cnt, int ind) {
                this.cnt = cnt;
                this.ind = ind;
            }

        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}

