import java.io.*;
import java.util.HashSet;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "C-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("c.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskC solver = new TaskC();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskC {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            int n = in.nextInt();
            HashSet<String> first = new HashSet<>();
            HashSet<String> second = new HashSet<>();
            String[][] words = new String[n][2];
            for (int i = 0; i < n; i++) {
                String f = in.next(), s = in.next();
                words[i][0] = f;
                words[i][1] = s;
                first.add(f);
                second.add(s);
            }
            int ans = 0;
            HashSet<String> k1 = new HashSet<>();
            HashSet<String> k2 = new HashSet<>();
            for (int i = 0; i < n; i++) {
                if (k1.contains(words[i][0])) continue;
                if (k2.contains(words[i][1])) continue;
                k1.add(words[i][0]);
                k2.add(words[i][1]);
            }
            for (int i = 0; i < n; i++) {
                if (k1.contains(words[i][0]) && k2.contains(words[i][1])) continue;
                k1.add(words[i][0]);
                k2.add(words[i][1]);
            }
            ans = n - k1.size();
            out.print("Case #" + testNumber + ": " + ans + "\n");
        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}

