import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.security.SecureRandom;
import java.util.StringTokenizer;
import java.util.Random;
import java.math.BigInteger;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "C-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("c.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskC solver = new TaskC();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskC {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            Random random = new Random(55350776431903243L);
            BigInteger big = BigInteger.probablePrime(32, random);
            out.print("Case #" + testNumber + ": \n");
            int cnt = 0, m = 0;
            for (int i = 2; cnt < 500 && i <= 1000; i++) {
                big = big.add(BigInteger.valueOf(2));
                boolean flag = false;
                String g = big.toString(2);
                for (int j = 2; j <= 10; j++) {
                    BigInteger big1 = new BigInteger(g, j);
                    if (big1.isProbablePrime(20)) flag = true;
                }
                if (!flag) {
                    ++cnt;
                    out.print(g + " ");
                    for (int k = 2, j; k <= 10; k++) {
                        BigInteger big1 = new BigInteger(g, k);
                        for (j = 2; j <= 1000000; ++j) {
                            if (big1.mod(BigInteger.valueOf(j)).compareTo(BigInteger.ZERO) == 0) {
                                out.print(j + " ");
                                break;
                            }
                        }
                        if (j > 1000000) {
                            PollardRho.flag = false;
                            PollardRho.factors(big1);
                            out.print(PollardRho.val + " ");
                        }
                    }
                    out.println();
                }
            }
            out.println(m);

        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

    }

    static class PollardRho {
        private final static BigInteger ZERO = new BigInteger("0");
        private final static BigInteger ONE = new BigInteger("1");
        private final static BigInteger TWO = new BigInteger("2");
        private final static SecureRandom random = new SecureRandom();
        public static String val;
        public static boolean flag;

        public static BigInteger rho(BigInteger N) {
            BigInteger divisor;
            BigInteger c = new BigInteger(N.bitLength(), random);
            BigInteger x = new BigInteger(N.bitLength(), random);
            BigInteger xx = x;

            // check divisibility by 2
            if (N.mod(TWO).compareTo(ZERO) == 0) return TWO;

            do {
                x = x.multiply(x).mod(N).add(c).mod(N);
                xx = xx.multiply(xx).mod(N).add(c).mod(N);
                xx = xx.multiply(xx).mod(N).add(c).mod(N);
                divisor = x.subtract(xx).gcd(N);
            } while ((divisor.compareTo(ONE)) == 0);

            return divisor;
        }

        public static void factors(BigInteger N) {
            if (flag) return;
            if (N.compareTo(ONE) == 0) return;
            if (N.isProbablePrime(20)) {
                val = N.toString();
                flag = true;
                return;
            }
            BigInteger divisor = rho(N);
            factors(divisor);
            factors(N.divide(divisor));
        }

    }
}

