import java.util.InputMismatchException;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileInputStream;
import java.util.Arrays;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "A-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("a.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		SolutionA solver = new SolutionA();
		solver.solve(1, in, out);
		out.close();
	}
}

class SolutionA {
    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int []cnt = new int[5000001];
        Arrays.fill(cnt, 1000000000);
        cnt[1] = 1;
        for (int i = 1; i <= 1000000; i++) {
            cnt[i + 1] = Math.min(cnt[i] + 1, cnt[i + 1]);
            StringBuilder sb = new StringBuilder();
            sb.append(i);
            sb.reverse();
            if (sb.length() > 7)continue;
            int k = Integer.parseInt(sb.toString());
            cnt[k] = Math.min(cnt[i] + 1, cnt[k]);
        }
        int test = in.nextInt();
        while (testNumber <= test){
            out.print("Case #"+testNumber+++": "+cnt[in.nextInt()]+"\n");
        }
    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                    tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }


}

