import java.io.FileInputStream;
import java.util.HashSet;
import java.util.InputMismatchException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    int r,c,n, d1;
    int [][]map;
    int []d = new int[]{-1,0,0,-1,1,0,0,1};

    public void solve(int testNumber, InputReader in, PrintWriter out) {
        this.r = in.nextInt();
        this.c = in.nextInt();
        this.n = in.nextInt();
        int min = (int)1e9;
map = new int[r][c];
        int cnt = 0;
        for (int i = 0; i < r; i++) {
            for (int j = 0; j < c; j++) {
                map[i][j] = cnt++;
            }
        }
        d1 = cnt;
int g = (1 << cnt);
        for (int i = 0; i < g; i++) {
            int p = 0;
            int []kp = new int[cnt];
            for (int j = 0; j < cnt; j++) {
                if ((i & (1 << j)) > 0)p++;
            }
            if (p != n)continue;
            for (int j = 0; j < cnt; j++) {
                if ((i & (1 << j)) > 0){
                    kp[j]  = 1;
                }
            }
            int d = check(kp);
            min = Math.min(d, min);
        }
        out.print("Case #"+testNumber+": "+min+"\n");
    }
private int check(int [] put) {
        int cnt1 = 0;
        for (int i = 0; i < r; i++) {
            for (int j = 0; j < c; j++) {
                if (put[map[i][j]] > 0){
                    for (int k = 0; k < d.length; k += 2) {
                        if (i + d[k] < 0 || i + d[k] >= r || j + d[k + 1] < 0 || j + d[k + 1] >= c)continue;
                        if (put[map[i + d[k]][j + d[k + 1]]] > 0)cnt1++;
                    }
                }
            }
        }
        return cnt1 / 2;
    }
}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                    tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }


}

