import java.io.FileInputStream;
import java.util.HashSet;
import java.util.InputMismatchException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.BufferedReader;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "C-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("c.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskC solver = new TaskC();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskC {
    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int [][]table = new int[4][4];
        table[0][0] = 4;
        table[0][1] = 1;table[0][2] = 2;table[0][3] = 3;
        table[1][1] = -4;table[1][2] = 3;table[1][3] = -2;table[1][0] = 1;
        table[2][2] = -4;table[2][1] = -3;table[2][3] = 1;table[2][0] = 2;
        table[3][3] = -4;table[3][1] = 2;table[3][2] = -1;table[3][0] = 3;
        int x = in.nextInt();
        int l = in.nextInt();
        String orig = in.next();
        StringBuilder temp = new StringBuilder();
        for (int i = 0; i < l; i++) {
            temp.append(orig);
        }
        out.print("Case #"+testNumber+": ");
        int len = l*x;
        String comp = temp.toString();
        int first = 0;
        int s1 = 0;
        HashSet<Integer> list = new HashSet<Integer>();
        if (comp.equals("ijk")){
            out.print("YES\n");
            return;
        }
        boolean []pk = new boolean[4];
        for (int i = 0; i < len; i++) {
            /*
            if (first == 1){
                int sec = comp.codePointAt(i) - 104, s2 = 0;
                for (int j = i + 1; j < len; j++) {
                    if (sec == 2){
                        int third = comp.codePointAt(j) - 104, s3 = 0;
                        for (int k = j + 1; k < len; k++) {
                            int lookup = table[third][comp.codePointAt(k) - 104];
                            if (lookup == -4){
                                s3++;
                                third = 0;
                            }
                            else{
                                if (lookup < 0){
                                    s3++;
                                    third = -1*lookup;
                                }
                                else {
                                    third = lookup;
                                }
                            }
                        }
                        if ((s1 + s2 + s3) % 2 == 0 && third == 3){
                            out.print("YES\n");
                            return;
                        }
                    }
                    int lookup = table[sec][comp.codePointAt(j) - 104];
                    if (lookup == -4){
                        s2++;
                        sec = 0;
                    }
                    else {
                        if (lookup < 0){
                            s2++;
                            sec = -1*lookup;
                        }
                        else {
                            sec = lookup;
                        }
                    }
                }
            }
            */
            int lookup = table[first][comp.codePointAt(i) - 104];
            if (lookup == -4){
                s1++;
                first = 0;
            }
            else {
                if (lookup < 0){
                    s1++;
                    first = -1*lookup;
                }
                else {
                    first = lookup;
                }
            }
            if (first == 1){
                pk[1] = true;
            }
            if (first == 2){
                pk[2] = true;
            }
            if (first == 3 && s1 % 2 == 0){
                if (pk[1] && pk[2]){
                    list.add(i);
                }
            }
        }
        first = 0;s1 = 0;
        HashSet<Integer> rev = new HashSet<Integer>();
        for (int i = len - 1; i >-1 ; i--) {
            int lookup = table[comp.codePointAt(i) - 104][first];
            if (lookup == -4){
                s1++;
                first = 0;
            }
            else {
                if (lookup < 0){
                    s1++;
                    first = -1*lookup;
                }
                else {
                    first = lookup;
                }
            }
            if (first == 1){
                pk[1] = true;
            }
            if (first == 2){
                pk[2] = true;
            }
            if (first == 3 && s1 % 2 == 0){
                if (pk[1] && pk[2]){
                    rev.add(i);
                }
            }
        }
        for(int e:list){
            if(rev.contains(e + 1)){
                out.print("YES\n");return;
            }
        }
//        out.println();
//        for(int e:rev){
//            out.print(e+" ");
//        }
//        out.println();
//        out.print(first+" "+s1+" ");
        out.print("NO\n");
    }

}

class InputReader {
    public BufferedReader reader;
    public StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                    tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }


}

