import java.io.*;
import java.util.Locale;
import java.util.StringTokenizer;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        public void solve(int testNumber, InputReader in, PrintWriter out) {
            out.print("Case #" + testNumber + ": ");
            char[] pancake = in.next().toCharArray();
            int[][] ans = new int[pancake.length + 2][2];
            ans[0][0] = (pancake[0] == '+' ? 0 : 1);
            ans[0][1] = (pancake[0] == '-' ? 0 : 1);
            for (int i = 1; i < pancake.length; i++) {
                if (pancake[i] == '+') {
                    ans[i][0] = Math.min(ans[i - 1][0], ans[i - 1][1] + 1);
                    ans[i][1] = Math.min(ans[i - 1][0] + 1, ans[i - 1][1] + 2);
                } else {
                    ans[i][0] = Math.min(ans[i - 1][0] + 2, ans[i - 1][1] + 1);
                    ans[i][1] = Math.min(ans[i - 1][0] + 1, ans[i - 1][1]);
                }
            }
            out.println(Math.min(ans[pancake.length - 1][0], ans[pancake.length - 1][1] + 1));
        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

    }
}

