
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;

public class Tidy {

    public static void main(String[] args) {
        Tidy tidy = new Tidy();
    }

    public Tidy() {
        String file = "B-large.in";
        String outFile = "B-large.out";
        BufferedReader br = null;
        BufferedWriter bfw = null;
        try {
            bfw = new BufferedWriter(new FileWriter(outFile));
            br = new BufferedReader(new FileReader(file));
            int test = Integer.parseInt(br.readLine());
            for (int i = 0; i < test; i++) {
                String s = br.readLine();
                String lastTidy = findLastTidy(s);
                bfw.write("Case #" + (i + 1) + ": " + lastTidy);
                bfw.newLine();
            }
        } catch (IOException | NumberFormatException e) {
            try {
                if (br != null) {
                    br.close();
                }
                if (bfw != null) {
                    bfw.close();
                }
            } catch (IOException ex) {
            }
        } finally {
            try {
                if (br != null) {
                    br.close();
                }
                if (bfw != null) {
                    bfw.close();
                }
            } catch (IOException ex) {

            }
        }

    }

    private String optimizate(String s) {
        int t;
        char[] array = null;
        
        BigInteger bres = null;
        BigInteger bi = new BigInteger(s);
        do {
            s = bi.toString();
            array = s.toCharArray();
            t = s.length();
            for (int i = 0; i < t - 1; i++) {
                if (array[i] > array[i + 1]) {
                    String res = s.substring(i + 1);                    
                    bres = new BigInteger(res);                    
                    if(bres.equals(BigInteger.ZERO)){
                        bres = BigInteger.ONE;
                    }
                    bi = bi.subtract(bres);
                    break;
                }
            }
        } while (!isTidy(bi.toString()));
        return bi.toString();
    }

    private String findLastTidy(String s) {

        if (isTidy(s)) {
            return s;
        }
        s = optimizate(s);
        return s;
    }



    private boolean isTidy(String s) {
        if (s.length() == 1) {
            return true;
        }
        int t = s.length();
        char[] array = s.toCharArray();
        for (int i = t - 1; i > 0; i--) {
            if (array[i] < array[i - 1]) {
                return false;
            }
        }
        return true;
    }

}
