
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Random;
import java.util.Scanner;

/**
 *
 * @author LuisR
 */
public class Jamcoin {

    long[] arrayConv = new long[9];
    ArrayList out = new ArrayList();

    public Jamcoin(int N, int J) {

        for (int i = 1; i <= J; ++i) {
            String jcoin = "";
            do {
                jcoin = generate(N);
            } while (!isJamcoin(jcoin));
            String lOut = jcoin + " " + calcularDivisores();
            System.out.println(lOut);
            out.add(lOut);
        }
    }

    public ArrayList getOut() {
        return out;
    }

    public String generate(int lenght) {
        StringBuilder jamcoin = new StringBuilder("1");
        Random random = new Random();
        for (int i = 1; i < lenght - 1; i++) {
            jamcoin.append(random.nextBoolean() ? "1" : "0");
        }

        jamcoin.append("1");
        return jamcoin.toString();
    }

    public boolean isJamcoin(String num) {
        return testCifras(num) && testConversion(num);
    }

    public boolean testCifras(String num) {
        if (num.charAt(0) == '1' && num.charAt(num.length() - 1) == '1') {
            for (int i = 1; i < num.length() - 1; i++) {
                char cifra = num.charAt(i);
                if (cifra != '1' && cifra != '0') {
                    return false;
                }
            }
            return true;
        }
        return false;
    }

    public boolean testConversion(String num) {
        for (int i = 2; i <= 10; i++) {
            long conv = convertirABase(num, i);
            if (isPrimo(conv)) {
                return false; 
            }
            arrayConv[i - 2] = conv;
        }
        return true;
    }

    private long convertirABase(String num, int base) {
        int[] cifras = getCifras(num);
        long val = 0;
        int lenght = cifras.length;
        for (int i = lenght - 1; i >= 0; i--) {
            int cifra = cifras[i];
            val += Math.pow(base, (lenght - (i + 1))) * cifra;
        }
        return val;
    }

    private boolean isPrimo(long num) {
        final int limit = 100000;
        if (num > 2 && num % 2 == 0) {
            return false;
        }
        for (int i = 3, c = 0; i * i <= num; i += 2, c = c + 1) {
            if (num % i == 0) {
                return false;
            }
            if (c > limit) {
                return true;
            }
        }
        return true;
    }

    private String calcularDivisores() {
        String div = "";
        for (int i = 0; i < arrayConv.length; i++) {
            long l = arrayConv[i];
            div += findDivisor(l) + " ";
        }
        return div;
    }

    private int findDivisor(long num) {
        int d = 2;
        int lim = (int) Math.sqrt(num);
        while (d <= lim) {
            if (num % d == 0) {
                return d;
            }
            d++;
        }
        return 0;
    }

    public static int[] getCifras(String numero) {
        int max = (numero.length());
        BigInteger big = new BigInteger(numero);
        int cifras[] = new int[max];
        for (int i = 0; i < max; i++) {
            double p1 = Math.pow(10D, i + 1);
            double p2 = Math.pow(10D, i);
            cifras[max - (i + 1)] = Math.abs((int) (((double) big.longValue() % p1) / p2));
        }
        return cifras;
    }

}
