
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Comparator;
import java.util.List;

public class Bathroom {

    int[] arraystalls = null;
    List<S> stalls = new ArrayList<>();
    ArrayList<Integer> listaMin = new ArrayList<>();

    public static void main(String[] args) {
        new Bathroom();
    }

    public Bathroom() {

        String file = "C-small.in";
        String outFile = "C-small.out";
        BufferedReader br = null;
        BufferedWriter bfw = null;
       
       
        try {
            bfw = new BufferedWriter(new FileWriter(outFile));
            br = new BufferedReader(new FileReader(file));
            int test = Integer.parseInt(br.readLine());
            for (int i = 0; i < test; i++) {
                String[] s = br.readLine().split(" ");
                int N = Integer.parseInt(s[0]);
                int K = Integer.parseInt(s[1]);
                int[] LSRS = bathCalc(N, K);
                bfw.write("Case #" + (i + 1) + ": " + LSRS[1] + " " + LSRS[0]);
                bfw.newLine();
            }
        } catch (IOException | NumberFormatException e) {
            try {
                if (br != null) {
                    br.close();
                }
                if (bfw != null) {
                    bfw.close();
                }
            } catch (IOException ex) {
            }
        } finally {
            try {
                if (br != null) {
                    br.close();
                }
                if (bfw != null) {
                    bfw.close();
                }
            } catch (IOException ex) {

            }
        }

    }

    private int[] bathCalc(int N, int K) {

        if (N == K) {
            return new int[]{0, 0};
        }

        int k = K;
        arraystalls = new int[N + 2];
        Arrays.fill(arraystalls, 0);
        arraystalls[0] = 1;
        arraystalls[N + 1] = 1;
        int[] lastLSRS = new int[2];

        while (k > 0) {

            stalls.clear();

            for (int i = 1; i < N + 1; i++) {
                if (arraystalls[i] == 0) {
                    int LS = findLS(i) - 1;
                    int RS = findRS(i) - 1;
                    stalls.add(new S(i, LS, RS));
                }
            }

            S[] values = new S[1];
            values = stalls.toArray(values);
            Arrays.sort(values);

            int t = values.length - 1;

            S ult = values[t];

            ArrayList<S> set = new ArrayList<>();
            set.add(ult);
            int c = 1;
            boolean band = true;
            while (band) {

                if (ult.getMin() == values[t - c].getMin()) {
                    set.add(values[t - c]);
                    c++;
                }

                if (t - c < 0 || ult.getMin() != values[t - c].getMin()) {
                    band = false;
                }
            }

            if (set.size() == 1) {
                int ind = set.get(0).s;
                arraystalls[ind] = 1;
                lastLSRS[0] = set.get(0).LS;
                lastLSRS[1] = set.get(0).RS;
            } else {

                S[] arraySet = new S[set.size()];
                arraySet = set.toArray(arraySet);

                Arrays.sort(arraySet, new Comparator<S>() {
                    @Override
                    public int compare(S o1, S o2) {
                        int max1 = Integer.max(o1.LS, o1.RS);
                        int max2 = Integer.max(o2.LS, o2.RS);
                        return Integer.compare(max1, max2);
                    }
                });

                int t2 = arraySet.length - 1;

                S ult2 = arraySet[t2];

                ArrayList<S> set2 = new ArrayList<>();

                set2.add(ult2);
                int c1 = 1;
                boolean band1 = true;
                while (band1) {

                    if (ult2.getMax() == arraySet[t2 - c1].getMax()) {
                        set2.add(arraySet[t2 - c1]);
                        c1++;
                    }
                    if (t2 - c1 < 0 || ult2.getMax() != arraySet[t2 - c1].getMax()) {
                        band1 = false;
                    }

                }

                if (set2.size() == 1) {
                    int ind = set2.get(0).s;
                    arraystalls[ind] = 1;
                    lastLSRS[0] = set2.get(0).LS;
                    lastLSRS[1] = set2.get(0).RS;
                } else {
                    int indL = 0;
                    for (int i = 1; i < set2.size(); i++) {
                        if (set2.get(indL).s > set2.get(i).s) {
                            indL = i;
                        }
                    }
                    arraystalls[set2.get(indL).s] = 1;
                    lastLSRS[0] = set2.get(indL).LS;
                    lastLSRS[1] = set2.get(indL).RS;
                }

            }

            k--;
        }
        return lastLSRS;
    }

    private int findRS(int i) {
        int n = arraystalls.length;
        int steps = 0;
        for (int j = i; j < n; j++) {
            if (arraystalls[j] == 1) {
                break;
            }
            steps++;
        }
        return steps;
    }

    private int findLS(int i) {
        int steps = 0;
        for (int j = i; j >= 0; j--) {
            if (arraystalls[j] == 1) {
                break;
            }
            steps++;
        }
        return steps;
    }

    private class S implements Comparable<S> {

        int s;
        int LS;
        int RS;

        public S(int s, int LS, int RS) {
            this.s = s;
            this.LS = LS;
            this.RS = RS;
        }

        public int getMin() {
            return Integer.min(LS, RS);
        }

        public int getMax() {
            return Integer.max(LS, RS);
        }

        @Override
        public int compareTo(S o) {

            int min1 = Integer.min(LS, RS);
            int min2 = Integer.min(o.LS, o.RS);

            return Integer.compare(min1, min2);
        }

        @Override
        public String toString() {
            return s + ": (" + LS + "," + RS + ")min:" + Integer.min(LS, RS);
        }

    }

}
