
import java.util.*;
import java.io.*;

public class Main {

    public static void main(String[] args) {
        if(args.length<1){
            System.out.println("Error muy pocos argumentos");
            return;
        }
        
        ArrayList in = readInput(args[0]); //read input

        arrayDormir = new boolean[10];
        int t = Integer.valueOf(in.get(0).toString());
        for (int i = 1; i <= t; ++i) {
            int n = Integer.valueOf(in.get(i).toString());
            Arrays.fill(arrayDormir, false);
            int res = contar(n);
            System.out.println("Case #" + i + ": " + (res > 0 ? res : "INSOMNIA"));
        }
    }
    private static boolean[] arrayDormir;

    private static int contar(int n) {
        int i = 1, num = 0, LIM = 100;
        do {
            num = n * i;
            check(getCifras(num));
            i++;
            if (i > LIM) {
                return -1;
            }
        } while (!dormida());
        return num;
    }

    private static void check(int[] cifras) {
        for (int i = 0; i < cifras.length; i++) {
            arrayDormir[cifras[i]] = true;
        }
    }

    private static boolean dormida() {
        for (int i = 0; i < 10; i++) {
            if (!arrayDormir[i]) {
                return false;
            }
        }
        return true;
    }

    public static int[] getCifras(int numero) {
        int max = String.valueOf(Math.abs(numero)).length();
        int cifras[] = new int[max];
        for (int i = 0; i < max; i++) {
            double p1 = Math.pow(10D, i + 1);
            double p2 = Math.pow(10D, i);
            cifras[max - (i + 1)] = Math.abs((int) (((double) numero % p1) / p2));
        }
        return cifras;
    }

    private static ArrayList readInput(String archivo) {
        ArrayList lista = new ArrayList();
        try {
            FileReader fr = new FileReader(archivo);
            BufferedReader bfr = new BufferedReader(fr);
            String s = "";
            do {
                s = bfr.readLine();
                if (s != null) {
                    lista.add(s);
                }
            } while (s != null);
        } catch (FileNotFoundException e) {
            System.out.println(e.getMessage());
        } catch (IOException e) {
            System.out.println(e.getMessage());
        }
        return lista;
    }

}
