
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;

public class Tidy {

    public static void main(String[] args) {
        Tidy tidy = new Tidy();
    }

    public Tidy() {
        String file = "B-small.in";
        String outFile = "B-small.out";
        BufferedReader br = null;
        BufferedWriter bfw = null;
        try {
            bfw = new BufferedWriter(new FileWriter(outFile));
            br = new BufferedReader(new FileReader(file));
            int test = Integer.parseInt(br.readLine());
            for (int i = 0; i < test; i++) {
                String s = br.readLine();
                String lastTidy = findLastTidy(s);
                bfw.write("Case #" + (i + 1) + ": " + lastTidy);
                bfw.newLine();
            }
        } catch (IOException | NumberFormatException e) {
            try {
                if (br != null) {
                    br.close();
                }
                if (bfw != null) {
                    bfw.close();
                }
            } catch (IOException ex) {
            }
        } finally {
            try {
                if (br != null) {
                    br.close();
                }
                if (bfw != null) {
                    bfw.close();
                }
            } catch (IOException ex) {
            }
        }
    }

    private String findLastTidy(String s) {
        if (isTidy(s)) {
            return s;
        }
        int n = Integer.parseInt(s);
        boolean fl = true;
        while (fl) {
            n--;
            String ns = String.valueOf(n);
            if (isTidy(ns)) {
                return ns;
            }
        }
        return s;
    }

    private boolean isTidy(String s) {
        if (s.length() == 1) {
            return true;
        }
        int t = s.length();
        char[] array = s.toCharArray();
        for (int i = t - 1; i > 0; i--) {
            if (array[i] < array[i - 1]) {
                return false;
            }
        }
        return true;
    }

}
