import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.PrintStream;
import java.util.Arrays;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author balowria
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, InputReader in, PrintWriter out) {

            int N = in.nextInt();
            int K = in.nextInt();


            int[][] RH = new int[N][2];

            for (int i = 0; i < N; i++) {
                RH[i][0] = in.nextInt();
                RH[i][1] = in.nextInt();
            }

            double res = 0;
            for (int i = 0; i < N; i++) {
                double base = Math.PI * RH[i][0] * RH[i][0] + 2 * Math.PI * RH[i][0] * RH[i][1];
                double max = 0;
                double[] ARR = new double[N];
                for (int j = 0; j < N; j++) {
                    double cal = 2 * Math.PI * RH[j][0] * RH[j][1];
                    if (j == i) {
                        ARR[j] = 0;
                    } else {
                        ARR[j] = (double) cal;
                    }
                }
                Arrays.sort(ARR);
                //System.out.println("ARR: "+Arrays.toString(ARR));
                for (int j = N - K + 1; j < N; j++) {
                    //System.out.println("C: "+testNumber+" "+ARR[j]);
                    max += ARR[j];
                }
                res = Math.max(res, base + max);
            }

            System.out.print("Case #" + testNumber + ": ");
            System.out.printf("%.7f", res);
            System.out.println();
            out.print("Case #" + testNumber + ": ");
            out.printf("%.7f", res);
            out.println();
        }

    }

    static class InputReader {
        public BufferedReader br;
        StringTokenizer st;

        public InputReader(InputStream stream) {
            br = new BufferedReader(new InputStreamReader(stream));
        }

        public String next() {
            return nextToken();
        }

        public String nextToken() {
            while (st == null || !st.hasMoreTokens()) {
                String line = null;
                try {
                    line = br.readLine();
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
                if (line == null) {
                    return null;
                }
                st = new StringTokenizer(line);
            }
            return st.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(nextToken());
        }

    }
}

