import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.StringTokenizer;


public class Main {

    BufferedReader reader;
    StringTokenizer tokenizer;
    PrintWriter out;

    public static void main(String[] args) {
        new Main().run();
    }

    public void run() {
        try {
            reader = new BufferedReader(new InputStreamReader(System.in));
            // reader = new BufferedReader(new InputStreamReader(new
            // FileInputStream("fibo_in")));
            //out = new PrintWriter(System.out);
            out = new PrintWriter("out.txt", "UTF-8");
            solver();
            out.flush();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public void solver() throws IOException {
        int testcase = nextInt();
        for(int zz = 1 ; zz <= testcase ; zz ++) {
            int n = nextInt();
            int a[] = new int[n+1];
            int count = 0;
            String s = next();
            for(int i=0;i<=n;i++) {
                a[i] = Integer.parseInt(""+s.charAt(i));
                if(i > 0) {
                    // If sum of previous less than index
                    if(a[i-1] < i) {
                        // Need to invite more friend
                        count += i-a[i-1];
                        a[i-1] += i-a[i-1];
                    }
                    a[i] += a[i-1];
                }
            }
            out.println("Case #"+zz+": "+count);
        }
    }

    String nextLine() throws IOException {
        return reader.readLine();
    }

    String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}
