import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;


public class Main {

    BufferedReader reader;
    StringTokenizer tokenizer;
    PrintWriter out;

    public static void main(String[] args) {
        new Main().run();
    }

    public void run() {
        try {
            reader = new BufferedReader(new InputStreamReader(System.in));
            // reader = new BufferedReader(new InputStreamReader(new
            // FileInputStream("fibo_in")));
            //out = new PrintWriter(System.out);
            out = new PrintWriter("out4.txt", "UTF-8");
            solver();
            out.flush();
            out.close();
        } catch (IOException e) {
            e.printStackTrace();
            System.exit(1);
        }
    }

    public void solver() throws IOException {
        int testcase = nextInt();
        for(int zz = 1 ; zz <= testcase ; zz ++) {
            int n = nextInt();
            int countTime=0;
            int countEat=0;
            PriorityQueue<Integer> priorityQueue = new PriorityQueue<Integer>(n, Collections.reverseOrder());
            for(int i=0;i<n;i++) {
                priorityQueue.add(nextInt());
            }
            for(int i=0;;i++) {
                int maxStack = priorityQueue.peek()-countEat;

                if(maxStack < 3) {
                    countTime += Math.min(0,maxStack);
                    break;
                } else if(maxStack%2==0) {
                    priorityQueue.poll();
                    priorityQueue.add(countEat + maxStack/2);
                    priorityQueue.add(countEat + maxStack/2);
                    countTime++;
                } else {
                    countEat++;
                    countTime++;
                }
            }
            out.println("Case #"+zz+": "+countTime);
        }
    }

    String nextLine() throws IOException {
        return reader.readLine();
    }

    String next() throws IOException {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            tokenizer = new StringTokenizer(reader.readLine());
        }
        return tokenizer.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    long nextLong() throws IOException {
        return Long.parseLong(next());
    }
}
