import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.PriorityQueue;
import java.util.StringTokenizer;
import java.util.Vector;
import java.util.regex.Pattern;

import javax.swing.text.html.MinimalHTMLWriter;

public class Main {

	static BufferedReader reader;
	static StringTokenizer tokenizer;
	static PrintWriter out;

	static String next() throws IOException {
		while (!tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(reader.readLine());
		}
		return tokenizer.nextToken();
	}

	static int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	static double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	static long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	public static void main(String[] args) throws IOException {

		reader = new BufferedReader(new InputStreamReader(System.in));
		tokenizer = new StringTokenizer("");
		out = new PrintWriter(new File("out.txt"));

		int testcase = nextInt();
		for (int zz = 1; zz <= testcase; zz++) {

			Solve s = new Solve(nextDouble(), nextDouble(), nextDouble());
			out.println("Case #"+zz+": "+s.minTime);
		}

		out.flush();
		out.close();
	}
}

class Solve {
	double c;
	double f;
	double x;

	double minTime;

	public Solve(double c, double f, double x) {
		this.c = c;
		this.f = f;
		this.x = x;

		minTime = Double.MAX_VALUE;

		for (int i = 0;; i++) {
			double time = 0;
			double rate = 2;
			for (int j = 0; j < i; j++) {
				time += getTime(c, rate);
				rate += f;
			}
			time += getTime(x, rate);

			if (time < minTime) {
				minTime = time;
			} else {
				break;
			}
		}
	}

	double getTime(double target, double rate) {
		return target / rate;
	}
}
