package Pancake;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashMap;

public class Solution {
	private int num = 0;
	
	private HashMap<String, Integer> map = new HashMap<String, Integer>();
	
	public String[] readInput(String path){
		try{
			FileInputStream fis = new FileInputStream(path);
			InputStreamReader isr = new InputStreamReader(fis);
			BufferedReader bf = new BufferedReader(isr);
			String s = bf.readLine();
			num = Integer.parseInt(s);
			String[] res = new String[num];
			for(int i=0;i<num;i++){
				s=bf.readLine();
				res[i]=s;
			}
			bf.close();
			return res;
		}catch(IOException e){
			e.printStackTrace();
		}
		return null;
	}
	
	public void output(int[] ans){
		PrintWriter writer;
		try{
			writer = new PrintWriter("/Users/yiwang/Desktop/output.txt");
			for(int i=0;i<ans.length;i++){
				writer.write("Case #"+(i+1)+": "+ans[i]);
				if(i!=ans.length-1){
					writer.write("\n");
				}
			}
			writer.close();
		}catch(FileNotFoundException e){
			e.printStackTrace();
		}
	}
	
	public String reverse(String s){
		String res = "";
		for(int i=s.length()-1;i>=0;i--){
			char c = s.charAt(i);
			if(c=='+'){
				res+='-';
			}
			else{
				res+='+';
			}
		}
		return res;
	}
	
	public int deal(String s){
		
		if(map.containsKey(s)){
			return map.get(s);
		}
		
		int len = s.length();
		int[] arr = new int[len];
		if(s.charAt(0)=='-'){
			arr[0]=1;
		}
		else{
			arr[0]=0;
		}
		
		for(int i=1;i<len;i++){
			if(s.charAt(i)=='+'){
				arr[i]=arr[i-1];
			}
			else{
				if(s.charAt(i-1)=='-'){
					arr[i]=arr[i-1];
				}
				else{
					String newStr = s.substring(0,len-1);
					newStr = reverse(newStr);
					arr[i]=Math.min(arr[i-1]+2, deal(newStr)+2);
				}
			}
		}
		
		map.put(s,arr[len-1]);
		
		return arr[len-1];
				
	}
	
	public static void main(String[] args){
		Solution s = new Solution();
		String[] input = s.readInput("/Users/yiwang/Desktop/B-small-attempt0.in");
		int[] output = new int[input.length];
		for(int i=0;i<output.length;i++){
			output[i]=s.deal(input[i]);
		}
		s.output(output);
	}
}
