package DIJK;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Solution {
	
	private List<String> res = new ArrayList<String>();
	
    private static final Map<String, String> map;
    static
    {
        map = new HashMap<String, String>();
        map.put("11", "1");
        map.put("1i", "i");
        map.put("1j", "j");
        map.put("1k", "k");
        
        map.put("i1", "1");
        map.put("ii", "-1");
        map.put("ij", "k");
        map.put("ik", "-j");
        
        map.put("j1", "j");
        map.put("ji", "-k");
        map.put("jj", "-1");
        map.put("jk", "i");
        
        map.put("k1", "k");
        map.put("ki", "j");
        map.put("kj", "-i");
        map.put("kk", "-1");
    }
	
	public boolean pointsBack(String s ){
		
		if(s.length()<3) return false;
		
		String[] ans = getAnsArray(s);
		String last = ans[ans.length-1];
		if(!last.equals("-1")) return false;
		
		boolean i =false;
		boolean j = false;
		
		for(int p=0;p<ans.length;p++){
			if(!i&&ans[p].equals("i")){
				i=true;
			}
			if(i&&ans[p].equals("k")){
				j=true;
			}
			if(i&&j)
				return true;
		}
		
		return false;
	}
	
	public String mult(String a, String b){
		String s = a+b;
		if(map.containsKey(s))
			return map.get(s);
		else{
			String tmp = map.get(s.substring(1));
			if(tmp.charAt(0)=='-')
				return tmp.substring(1);
			else
				return "-"+tmp;
		}
	}
	
	public String[] getAnsArray(String s){
		
		char[] array = s.toCharArray();
		String[] ans = new String[array.length+1];
		ans[0]="1";
		for(int i=0;i<array.length;i++){
			ans[i+1]=mult(ans[i],""+array[i]);
		}
		
		return ans;
	}
	
	public void createTestCase(String path){
		try{
			FileInputStream fis = new FileInputStream(path);
			InputStreamReader isr= new InputStreamReader(fis);
			BufferedReader bf = new BufferedReader(isr);
			String s = bf.readLine();
			int caseNumbers = Integer.parseInt(s);

			for(int i=0;i<caseNumbers;i++){
				s = bf.readLine();
				String[] temp = s.split("[ ]+");
				int rep = Integer.parseInt(temp[1]);
				s = bf.readLine();
				StringBuilder sb = new StringBuilder();
				for(int j=0;j<rep;j++)
					sb.append(s);
				res.add(sb.toString());
			}
			bf.close();
		}catch(IOException e){
			e.printStackTrace();
		}
	}
	
	public List<Boolean> doTest(){
		List<Boolean> result = new ArrayList<Boolean>();
		
		for(int i=0;i<res.size();i++)
			result.add(pointsBack(res.get(i)));
		
		return result;
	}
	
	public void printAnswer(){
		
		PrintWriter writer;
		try {
			writer = new PrintWriter("output.txt");
			List<Boolean> result = doTest();
			for(int i=0;i<result.size();i++){
				String s = "NO";
				if(result.get(i))
					s="YES";
				writer.write("Case #"+(i+1)+":	"+s);
				writer.write("\n");
			}
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	
	public static void main(String[] args){
		
		Solution s = new Solution();
		s.createTestCase("input.txt");
		s.printAnswer();
	}

}
