package InfinitieHouseOfPancakses;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Queue;

public class SmallSolution {
	
	private List<int[]> cases = new ArrayList<int[]>();
	
	public int find(int[] cakes){
		
		int min = 9;
		int cut = 0;
		
		Queue<Integer> q = new PriorityQueue<Integer>(10,new Comparator<Integer>(){

			@Override
			public int compare(Integer o1, Integer o2) {
				// TODO Auto-generated method stub
				return o2-o1;
			}
		});
		
		for(int i=0;i<cakes.length;i++){
			q.offer(cakes[i]);
		}
		
		min=q.peek();

		while(!q.isEmpty()&&q.peek()>3){
			int tmp = q.poll();
			
			if(tmp<9){
				cut++;
				int left = tmp/2;
				int right = tmp-left;
				q.offer(left);
				q.offer(right);
			}
			else{
				cut+=2;
				q.offer(3);
				q.offer(3);
				q.offer(3);
			}
			if(cut>=min)
				break;
			min=Math.min(min, cut+q.peek());
		}
		
		return min;
	}
	
	public List<Integer> doTestCase(){
		
		List<Integer> result = new ArrayList<Integer>();
		
		for(int i=0;i<cases.size();i++){
			result.add(find(cases.get(i)));
		}
		
		return result;
	}
	
	public void createTestCase(String path){
		try{
			FileInputStream fis = new FileInputStream(path);
			InputStreamReader isr= new InputStreamReader(fis);
			BufferedReader bf = new BufferedReader(isr);
			String s = bf.readLine();
			int testCase = Integer.parseInt(s);

			for(int i=0;i<testCase;i++){
				s = bf.readLine();
				int number = Integer.parseInt(s);
				int[] cakes = new int[number];
				s = bf.readLine();
				String[] temp = s.split("[ ]+");
				for(int j=0;j<number;j++){
					cakes[j]=Integer.parseInt(temp[j]);
				}
				cases.add(cakes);
			}
			bf.close();
		}catch(IOException e){
			e.printStackTrace();
		}
	}
	
	public void printAnswer(){
		
		PrintWriter writer;
		try {
			writer = new PrintWriter("output.txt");
			List<Integer> result = doTestCase();
			for(int i=0;i<result.size();i++){
				writer.write("Case #"+(i+1)+": "+result.get(i));
				writer.write("\n");
			}
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args){
		SmallSolution st = new SmallSolution();
		st.createTestCase("input.txt");
		st.printAnswer();
	}

}
