package CountingSheep;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.HashSet;

public class Solution {
	
	private int num = 0;
	
	public String[] readInput(String path){
		try{
			FileInputStream fis = new FileInputStream(path);
			InputStreamReader isr = new InputStreamReader(fis);
			BufferedReader bf = new BufferedReader(isr);
			String s = bf.readLine();
			num = Integer.parseInt(s);
			String[] res = new String[num];
			for(int i=0;i<num;i++){
				s=bf.readLine();
				res[i]=s;
			}
			bf.close();
			return res;
		}catch(IOException e){
			e.printStackTrace();
		}
		return null;
	}
	
	public String multiply(String num1, String num2) {
	    StringBuilder sb = new StringBuilder();
	    int m = num1.length(), n = num2.length(), carry = 0;

	    if (num1.charAt(0) == '0' || num2.charAt(0) == '0') return "0";

	    for (int k = 0; k < m+n-1; k++) {
	        for (int i = Math.max(0,k-n+1); i < Math.min(m,k+1); i++) {
	            int j = k-i;
	            carry += (num1.charAt(m-i-1)-'0')*(num2.charAt(n-j-1)-'0');
	        }
	        sb.append(carry%10);
	        carry = carry/10;
	    }
	    if (carry > 0) sb.append(carry);
	    return sb.reverse().toString();
	}
	
	public String count(String s){
		HashSet<String> set = new HashSet<String>();
		boolean[] arr = new boolean[10];
		String mul = "1";
		String cur = multiply(s,mul);
		
		while(!set.contains(cur)){
			for(int i=0;i<cur.length();i++){
				arr[cur.charAt(i)-'0']=true;
			}
			if(check(arr)){
				return cur;
			}
			else{
				set.add(cur);
			}
			mul = String.valueOf(Integer.parseInt(mul)+1);
			cur = multiply(s,mul);
		}
		
		return "INSOMNIA";
	
	}
	
	public boolean check(boolean[] arr){
		for(int i=0;i<arr.length;i++){
			if(!arr[i]){
				return false;
			}
		}
		return true;
	}
	
	public int getNum(){
		return num;
	}
	
	public void output(String[] ans){
		PrintWriter writer;
		try{
			writer = new PrintWriter("/Users/yiwang/Desktop/output.txt");
			for(int i=0;i<ans.length;i++){
				writer.write("Case #"+(i+1)+": "+ans[i]);
				if(i!=ans.length-1){
					writer.write("\n");
				}
			}
			writer.close();
		}catch(FileNotFoundException e){
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args){
		Solution s = new Solution();
		String[] input = s.readInput("/Users/yiwang/Desktop/A-large.in");
		String[] output = new String[s.getNum()];
		for(int i=0;i<input.length;i++){
			output[i]=s.count(input[i]);
		}
		s.output(output);
	}

}
