package hu.ka.codejam.pancake;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;

public class Pancake {

	private static class State {
		public State(int m, int[] l, State parent) {
			this.m = m;
			this.l = l;
			this.parent = parent;
		}

		int m = 0;
		int[] l;
		State parent;
	}

	public static void main(String args[]) throws FileNotFoundException {
		parseInput(args[0]);
	}

	private static void parseInput(String arg) throws FileNotFoundException {
		Scanner scanner = new Scanner(new File(arg));
		int testCases = scanner.nextInt();
		for (int i = 0; i < testCases; i++) {
			int diners = scanner.nextInt();
			int[] l = new int[diners];
			for (int j = 0; j < diners; j++) {
				l[j] = scanner.nextInt();
			}
			int minutes = minutes(l);
			if (minutes == -1) {
				throw new IllegalStateException("No solution? " + Arrays.toString(l));
			}
			printOutput(i + 1, Integer.toString(minutes));
		}
	}

	private static int minutes(int[] l) {
		Queue<State> cand = new LinkedList<State>();
		Set<State> seen = new HashSet<State>();
		cand.add(new State(0, l, null));
		while (!cand.isEmpty()) {
			State curr = cand.poll();
			if (!seen.contains(curr)) {
				seen.add(curr);
				if (allZero(curr.l)) {
					return curr.m;
				}
				if (onlyOnes(curr.l)) {
					return curr.m+1;
				}
				int i = 0;
				int max = curr.l[0];
				for (int j = 1; j < curr.l.length; j++) {
					if (curr.l[j] > max) {
						max = curr.l[j];
						i = j;
					}
				}
				for (int k = 1; k <= max/2; ++k) {
					cand.add(new State(curr.m + 1, splitMax(curr.l, i, k), curr));
				}
				cand.add(new State(curr.m+1, eat(curr.l), curr));
			}
		}
		return -1;
	}

	private static int[] splitMax(int[] l, int ind, int val) {
		int[] res = new int[l.length+1];
		System.arraycopy(l, 0, res, 0, l.length);
		res[ind] = res[ind] - val;
		res[res.length-1] = val;
		return res;
	}

	private static int[] eat(int[] l) {
		int[] res = new int[l.length];
		System.arraycopy(l, 0, res, 0, l.length);
		for (int i = 0; i < res.length; i++) {
			if (res[i] > 0) {
				--res[i];
			}
		}
		return res;
	}

	private static boolean allZero(int[] l) {
		for (int integer : l) {
			if (integer != 0) {
				return false;
			}
		}
		return true;
	}

	private static boolean onlyOnes(int[] l) {
		for (int integer : l) {
			if (integer > 1) {
				return false;
			}
		}
		return true;
	}

	private static void printOutput(int i, String s) {
		System.out.println(String.format("Case #%d: %s", i, s));
	}
}
