package com.google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class Bullseye {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new File(args[0]));
        PrintWriter writer = new PrintWriter(new FileOutputStream("bullseye.out"));
        try {
            int caseCnt = scanner.nextInt();
            for (int i = 0; i < caseCnt; i++) {
                long r = scanner.nextLong();
                long t = scanner.nextLong();
                long circleCnt = solve(r, t);
                writer.println(String.format("Case #%d: %d", i + 1, circleCnt));
            }
        } finally {
            writer.close();
        }
    }

    static long solve(long startRadius, long paint) {
        long radius = startRadius;
        boolean isBlack = false;
        long circleCnt = 0;
        while (true) {
            if (isBlack) {
                long neededPaint = (radius) * (radius) - (radius - 1) * (radius - 1);
                if (neededPaint <= paint) {
                    paint -= neededPaint;
                    ++circleCnt;
                } else {
                    break;
                }
            }
            isBlack = !isBlack;
            ++radius;
        }
        return circleCnt;
    }

}
