package com.google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class Energy {

    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new File(args[0]));
        PrintWriter writer = new PrintWriter(new FileOutputStream("energy.out"));
        try {
            int caseCnt = scanner.nextInt();
            for (int i = 0; i < caseCnt; i++) {
                int maxGain = 0;
                int maxGainIdx = -1;
                int maxE = scanner.nextInt();
                int regain = scanner.nextInt();
                int actCnt = scanner.nextInt();
                int gain[] = new int[actCnt];
                for (int j = 0; j < actCnt; j++) {
                    gain[j] = scanner.nextInt();
                    if (gain[j] > maxGain) {
                        maxGain = gain[j];
                        maxGainIdx = j;
                    }
                }
                int spendE[] = new int[actCnt];
                spendE[maxGainIdx] = maxE;
                solve(maxE, regain, gain, 0, actCnt, spendE);
                int res = 0;
                for (int j = 0; j < actCnt; j++) {
                    res += spendE[j] * gain[j];
                }
                writer.println(String.format("Case #%d: %d", i + 1 , res));
            }
        } finally {
            writer.close();
        }
    }

    private static void solve(int maxE, int regain, int[] gain, int start, int end, int spendE[]) {
        if (start < end) {
            int maxGain = 0;
            int maxIdx = -1;
            for (int i = start; i < end; i++) {
                if (maxGain < gain[i]) {
                    maxGain = gain[i];
                    maxIdx = i;
                }
            }
            for (int i = maxIdx - 1; i >= start; --i) {
                spendE[i] = Math.min((maxIdx - i) * regain, maxE);
            }
            for (int i = maxIdx + 1; i < end; ++i) {
                spendE[i] = Math.min(i * regain, maxE);
            }
            solve(maxE, regain, gain, start, maxIdx, spendE);
            solve(maxE, regain, gain, maxIdx + 1, end, spendE);
        }
    }
}
