package com.google.codejam.ka.lawnmover;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class LawnMover {

    static int board[][];

    static boolean checkBoard() {
        for (int i = 0; i < board.length; i++) {
            for (int j = 0; j < board[i].length; j++) {
                if (!checkCell(i, j)) {
                    return false;
                }
            }
        }
        return true;
    }

    static private boolean checkCell(int row, int col) {
        int max = board[row][col];
        boolean good = true;
        //check line
        for (int k = 0; k < board[row].length && good; k++) {
            if (board[row][k] > max) {
                good = false;
            }
        }
        if (good) {
            return true;
        } else {
            //check row
            for (int k = 0; k < board.length; k++) {
                if (board[k][col] > max) {
                    return false;
                }
            }
        }
        return true;
    }

    public static void main(String[] args) throws IOException {
        Scanner scanner = new Scanner(new File(args[0]));
        StringBuilder result = new StringBuilder();
        int caseCnt = Integer.parseInt(scanner.nextLine().trim());
        for (int i = 0; i < caseCnt; i++) {
            int rowCnt = scanner.nextInt();
            int colCnt = scanner.nextInt();
            board = new int[rowCnt][colCnt];
            for (int j = 0; j < rowCnt; j++) {
                for (int k = 0; k < colCnt; k++) {
                    board[j][k] = scanner.nextInt();
                }
            }
            if (checkBoard()) {
                result.append(String.format("Case #%d: YES\n", i+1));
            } else {
                result.append(String.format("Case #%d: NO\n", i+1));
            }
        }
        FileWriter fileWriter = new FileWriter("lm_out.txt");
        fileWriter.append(result.toString());
        fileWriter.close();
    }
}
