package com.google.codejam.ka;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;


public class MagicTrick {

	private static boolean[] cards = new boolean[16];
	private static int card = 0;

	public static void main(String args[]) throws FileNotFoundException {
		parseInput(args[0]);
	}

	private static void parseInput(String arg) throws FileNotFoundException {
		Scanner scanner = new Scanner(new File(arg));
		int testCases = scanner.nextInt();
		for (int i = 0; i < testCases; i++) {
			Arrays.fill(cards, false);
			card = 0;
			int firstAnswer = scanner.nextInt();
			for (int j = 0; j < 4; j++) {
				if (j == firstAnswer - 1) {
					readRow(scanner);
				} else {
					skipLine(scanner);
				}
			}
			int secondAnswer = scanner.nextInt();
			for (int j = 0; j < 4; j++) {
				if (j == secondAnswer - 1) {
					int cnt = countCard(scanner);
					if (cnt == 0) {
						printOutput(i+1, "Volunteer cheated!");
					} else if (cnt == 1) {
						printOutput(i+1, String.valueOf(card + 1));
					} else {
						printOutput(i+1, "Bad magician!");
					}
				} else {
					skipLine(scanner);
				}
			}
		}
	}

	private static void skipLine(Scanner scanner) {
		for (int i = 0; i < 4; i++) {
			 scanner.nextInt();
		}
	}

	private static void printOutput(int i, String s) {
		System.out.println(String.format("Case #%d: %s", i, s));
	}

	private static int countCard(Scanner scanner) {
		int cnt = 0;
		for (int i = 0; i < 4; i++) {
			int matchingCard = scanner.nextInt() - 1;
			if (cards[matchingCard]) {
				++cnt;
				if (cnt == 1) {
					card = matchingCard;
				}
			}
		}
		return cnt;
	}

	private static void readRow(Scanner scanner) {
		for (int i = 0; i < 4; i++) {
			cards[scanner.nextInt() - 1] = true;
		}
	}
}
