import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Scanner;

public class ProblemARunner {

  public static int flips(String pancakes, int k) {

    boolean[] arr = new boolean[pancakes.length()];

    for (int i = 0; i < arr.length; i++) {
      arr[i] = pancakes.charAt(i) == '+';
    }

    int flips = 0;
    for (int i = 0; i <= arr.length - k; i++) {
      if (arr[i]) continue;
      flips++;
      for (int j = i; j < i + k; j++) {
        arr[j] = !arr[j];
      }
    }

    for (int i = 0; i < arr.length; i++) {
      if (arr[i]) continue;
      return -1;
    }
    return flips;
  }

  public static void main(String[] args) throws Exception {
    String name = "A-large.in";
    String out = name.replace(".in", ".out");
    Scanner in = new Scanner(new BufferedReader(
        new InputStreamReader(ProblemARunner.class.getResourceAsStream(name))));
    int t = in.nextInt();
    in.nextLine();
    try(BufferedWriter writer = Files.newBufferedWriter(Paths.get(out))) {
      for (int i = 1; i <= t; ++i) {
        String line = in.nextLine();
        String[] parts = line.split(" ");
        String pancakes = parts[0];
        int k = Integer.parseInt(parts[1]);
        int flips = flips(pancakes, k);
        writer.write(String.format("Case #%d: %s%n", i, flips == -1 ? "IMPOSSIBLE" : flips));
      }
    }
  }
}
