package b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.InputStreamReader;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.Scanner;

public class ProblemBRunner {

  private static long decrement(long n) {
    char[] chars = Long.toString(n).toCharArray();

    if (chars.length < 2) return n - 1;

    char curr = '0';
    int i = 0;
    for (i = 0; i < chars.length; i++) {
      char c = chars[i];
      if (c == curr || c > curr) {
        curr = c;
      } else {
        break;
      }
    }

    i--;
    while (i > 0 && chars[i] == chars[i - 1]) {
      i--;
    }

    i++;

    long diff = Long.parseLong(Long.toString(n).substring(i));

    return n - Math.max(diff, 1);
  }

  private static long solveFast(long n) {
    while (!isTidy(n)) {
      n = decrement(n);
    }
    return n;
  }

  public static long solve(long n) {
    while (!isTidy(n)) {
      n--;
    }
    return n;
  }

  public static boolean isTidy(long n) {
    char[] chars = Long.toString(n).toCharArray();

    char curr = '0';

    for (char c : chars) {
      if (c == curr || c > curr) {
        curr = c;
      } else {
        return false;
      }
    }
    return true;
  }

  public static void main(String[] args) throws Exception {
    String name = "B-large.in";
    String out = name.replace(".in", ".out");
    Scanner in = new Scanner(new BufferedReader(
        new InputStreamReader(ProblemBRunner.class.getResourceAsStream(name))));
    int t = in.nextInt();
    in.nextLine();
    try (BufferedWriter writer = Files.newBufferedWriter(Paths.get(out))) {
      for (int i = 1; i <= t; ++i) {
        long n = in.nextLong();
        writer.write(String.format("Case #%d: %d%n", i, solveFast(n)));
      }
    }
  }
}
