package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class TrainTimetable {
	
	Trip[] A;
	Trip[] B;

	public static void main(String[] args) {
		TrainTimetable test = new TrainTimetable();

		Scanner sc;
		try {
			sc = new Scanner(new File("/Users/bani/Desktop/B-large.in"));
			FileWriter f = new FileWriter("/Users/bani/Desktop/Dataset.out");
			int n = Integer.parseInt(sc.nextLine());
			for (int i = 0; i < n; i++) {
				test.readData(sc);
				int[] s = test.solve();
				f.write("Case #");
				f.write((new Integer(i + 1)).toString());
				f.write(": ");
				f.write((new Integer(s[0])).toString());
				f.write(" ");
				f.write((new Integer(s[1])).toString());
				f.write("\n");
			}
			f.flush();
			f.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


	private int[] solve() {
		int nA = A.length;
		int nB = B.length;
		
		Arrays.sort(A); // sort A by start
		for(Trip t:B)
			t.sortByStart=false;
		Arrays.sort(B); // sort B by finish
		
		// for each train that leaves A,
		// checks if a train from B arrives there before
		for(int i = 0; i < A.length; i++){
			int departure = A[i].start;
			
			for(int j = 0; j < B.length; j++){
				if (departure>=B[j].finish){
					B[j].finish=Integer.MAX_VALUE;
					nA--;
					break;
				}
			}
			
		}
		
		for(Trip t:B)
			t.sortByStart=true;
		Arrays.sort(B); // sort B by start
		for(Trip t:A)
			t.sortByStart=false;
		Arrays.sort(A); // sort A by finish
		
		// for each train that leaves B,
		// checks if a train from A arrives there before
		for(int i = 0; i < B.length; i++){
			int departure = B[i].start;
			
			for(int j = 0; j < A.length; j++){
				if (departure>=A[j].finish){
					A[j].finish=Integer.MAX_VALUE;
					nB--;
					break;
				}
			}
			
		}

		return new int[] {nA,nB};
	}

	private void readData(Scanner sc) {
		int t = Integer.parseInt(sc.nextLine());
		
		int a = sc.nextInt();
		A = new Trip[a];
		int b = sc.nextInt();
		B = new Trip[b];
		
		sc.nextLine();
		
		for(int i = 0; i < a; i++){
			A[i] = new Trip(sc.nextLine(),t);
		}
		for(int i = 0; i < b; i++){
			B[i] = new Trip(sc.nextLine(),t);
		}
	}
	
	private class Trip implements Comparable<Trip>{
		int start;
		int finish;
		boolean sortByStart = true;
		Trip(String t, int turn){
			start += (t.charAt(0) - '0')*10*60;
			start += (t.charAt(1) - '0')*60;
			start += (t.charAt(3) - '0')*10;
			start += (t.charAt(4) - '0');
			
			finish += (t.charAt(6) - '0')*10*60;
			finish += (t.charAt(7) - '0')*60;
			finish += (t.charAt(9) - '0')*10;
			finish += (t.charAt(10) - '0')+turn;
		}
		
		public int compareTo(Trip o){
			if(sortByStart)
				return start - o.start;
			else
				return finish - o.finish;
		}
	}
	
	private void debug() {
		System.out.println("Trips starting at A");
		for(Trip t:A)
			System.out.println(t.start +" "+ t.finish);
		
		System.out.println("Trips starting at B");
		for(Trip t:B)
			System.out.println(t.start +" "+ t.finish);
		
	}

}
