import java.io.*;
import java.util.*;

public class ProblemA {
	private static class Node {
		public String dissector;
		public double weight;
		public Node Yson, Nson;

		public String toString() {
			StringBuilder ans = new StringBuilder();
			ans.append("( ");
			ans.append(Double.toString(this.weight));
			ans.append(" ");
			if (this.Nson != null && this.Yson != null) {
				ans.append("\"");
				ans.append(this.dissector);
				ans.append("\" ");
				ans.append(this.Yson.toString());
				ans.append(" ");
				ans.append(this.Nson.toString());
			}
			ans.append(")");
			return ans.toString();
		}
	}

	static Node root = new Node();
	static String treeS;

	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		PrintWriter out = new PrintWriter(new FileWriter("output.txt"));
		Scanner in = new Scanner(new FileReader("input.txt"));
		int cases = Integer.parseInt(in.nextLine());
		for (int i = 1; i <= cases; ++i) {
			out.println("Case #" + i + ": ");
			int lines = Integer.parseInt(in.nextLine());

			treeS = "";
			for (int j = 0; j < lines; ++j)
				treeS += in.nextLine();
			buildTree(0, treeS.length(), root);
			System.err.println(root.toString());

			lines = Integer.parseInt(in.nextLine());
			for (int j = 0; j < lines; ++j) {
				StringTokenizer st = new StringTokenizer(in.nextLine());
				st.nextToken();
				int vals = Integer.parseInt(st.nextToken());
				HashSet<String> attr = new HashSet<String>();
				for (int k = 0; k < vals; ++k)
					attr.add(st.nextToken());
				out.printf("%.10f", traverse(attr));
				if (j != lines - 1 || i != cases)
					out.print("\n");
			}
		}
		in.close();
		out.close();
	}

	private static double traverse(HashSet<String> attr) {
		System.err.println(attr);
		double ans = 1.0;
		Node curr = root;

		for (;;) {
			ans *= curr.weight;

			if (curr.Yson == null && curr.Nson == null)
				return ans;

			if (attr.contains(curr.dissector)) {
				curr = curr.Yson;
			} else {
				curr = curr.Nson;
			}
		}
	}

	private static void buildTree(int beg, int end, Node curr) {
		// System.err.println("\"" + treeS.substring(beg, end) + "\"");
		++beg;
		// Parse the weight.
		String w = "";
		while (treeS.charAt(beg) == ' ')
			++beg;
		while (treeS.charAt(beg) != ' ' && treeS.charAt(beg) != ')') {
			w += treeS.charAt(beg);
			++beg;
		}
		curr.weight = Double.parseDouble(w);

		// Check out for being leaf.
		while (treeS.charAt(beg) == ' ')
			++beg;
		if (treeS.charAt(beg) == ')')
			return;
		// Parse out the property.
		String p = "";
		while (treeS.charAt(beg) != ' ') {
			p += treeS.charAt(beg);
			++beg;
		}
		while (treeS.charAt(beg) == ' ')
			++beg;
		curr.dissector = p;

		// For 'yes'.
		curr.Yson = new Node();

		int Ybeg = beg;
		++beg;
		int ballance = 1;
		while (ballance != 0) {
			if (treeS.charAt(beg) == '(')
				++ballance;
			if (treeS.charAt(beg) == ')')
				--ballance;
			++beg;
		}
		int Yend = beg;
		buildTree(Ybeg, Yend, curr.Yson);
		// Pass spaces.
		while (treeS.charAt(beg) == ' ')
			++beg;

		// For 'no'.
		curr.Nson = new Node();

		int Nbeg = beg;
		++beg;
		ballance = 1;
		while (ballance != 0) {
			if (treeS.charAt(beg) == '(')
				++ballance;
			if (treeS.charAt(beg) == ')')
				--ballance;
			++beg;
		}
		int Nend = beg;
		buildTree(Nbeg, Nend, curr.Nson);
	}
}
