import java.util.*;

public class ProblemB_small {
	static int[][] basin;
	static int[][] map;
	static int cnt;

	// North - West - East - South.
	static int[] dx = new int[] { -1, +0, +1, +0 };
	static int[] dy = new int[] { +0, -1, +0, +1 };
	static final int oo = 1000 * 1000;

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int n = in.nextInt();
		for (int i = 0; i < n; ++i) {
			int a = in.nextInt();
			int b = in.nextInt();
			map = new int[a + 2][b + 2];
			for (int[] z : map)
				Arrays.fill(z, oo);
			for (int j = 0; j < a; ++j)
				for (int k = 0; k < b; ++k)
					map[j + 1][k + 1] = in.nextInt();
			// System.err.println(Arrays.deepToString(map));
			String ans = solve(map);
			String ans2 = ans.replaceAll("a", "c").replaceAll("b", "a")
					.replaceAll("c", "b");
			if (ans.compareTo(ans2) > 0)
				ans = ans2;
			System.out.print("Case #" + (i + 1) + ":\n" + ans);
		}
	}

	private static String solve(int[][] x) {
		basin = new int[x.length][x[0].length];
		for (int[] i : basin)
			Arrays.fill(i, -1);
		cnt = 0;
		for (int i = 1; i < x.length - 1; ++i)
			for (int j = 1; j < x[0].length - 1; ++j)
				if (sink(i, j)) {
					basin[i][j] = cnt;
					++cnt;
				}

		for (int i = 0; i < x.length; ++i)
			for (int j = 0; j < x[0].length; ++j)
				if (basin[i][j] == -1) {
					basin[i][j] = dfs(i, j);
				}
		StringBuilder ans = new StringBuilder();
		for (int i = 1; i < x.length - 1; ++i) {
			for (int j = 1; j < x[0].length - 1; ++j) {
				ans.append((char) ('a' + basin[i][j]));
				ans.append(" ");
			}
			ans.append("\n");
		}
		return ans.toString();
	}

	private static int dfs(int x, int y) {
		int move = 0;
		if (!good(x, y))
			return -1;
		if (sink(x, y))
			return basin[x][y];
		int ans = -1;
		for (int i = 0; i < dx.length; ++i) {
			if (map[x + dx[i]][y + dy[i]] < map[x][y]
					&& (ans == -1 || map[x + dx[i]][y + dy[i]] < map[x
							+ dx[ans]][y + dy[ans]]))
				ans = i;
		}
		return dfs(x + dx[ans], y + dy[ans]);
	}

	private static boolean sink(int x, int y) {
		if (!good(x, y))
			return false;
		boolean ans = true;
		for (int i = 0; i < dx.length; ++i)
			if (map[x + dx[i]][y + dy[i]] < map[x][y])
				ans = false;
		return ans;
	}

	private static boolean good(int x, int y) {
		return x > 0 && y > 0 && x < map.length - 1 && y < map[0].length - 1;
	}
}
