import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

public class GetJamCoinsBigInt {
	public static void main(String[] args) throws IOException {
		//read the input from file
				String inputLine;
				BufferedReader reader = new BufferedReader(new FileReader("/Users/abanthiy/Documents/workspace/JamCoin/src/input.txt"));
				inputLine = reader.readLine();
				Integer numTestCases = Integer.parseInt(inputLine);
				String[] line2 = reader.readLine().split(" ");
				Integer N = Integer.parseInt(line2[0]);
				Integer J = Integer.parseInt(line2[1]);
				//find J jamcoins of length N
				System.out.print("Case #1: ");
				//loop over all the permutations of possible jam coins
				//get binary representation of possible ints
				//in the base 10 lowest value can be 10^(N-1) + 1
				//in base 10 highest number is 10^(N-1)+10^(N-2)+...+1 = 1*(10^(N)/9)
				//maximum value in base 2 can be handled by the int type, so this can be used to generate binary string
				String minString = "11";
				String maxString = "11";
				while(minString.length() < N) {
					minString = new StringBuilder(minString).insert(minString.length()-1, "0").toString();
				}
				while(maxString.length() < N) {
					maxString = new StringBuilder(maxString).insert(maxString.length()-1, "1").toString();
				}
				BigInteger minNum = new BigInteger(minString, 2);/*(BigInteger)Math.pow(2, N-1)+1;*/
				BigInteger maxNum = new BigInteger(maxString, 2);/*(BigInteger)Math.pow(2, N);*/
				int count = 0;
				BigInteger i = minNum;
				while(i.compareTo(maxNum) < 0) {
					if(isJamCoin(i)) {
						count++;
					}
					if(count >= J){
						break;
					}
					i = i.add(BigInteger.ONE);
				}
	}
	
	private static boolean isJamCoin(BigInteger i){
		Map<Integer, BigInteger> baseToDivisor = new HashMap<Integer, BigInteger>();
		boolean isJamCoin = false;
	
		//convert the number to binary
		String binaryString = i.toString(2);
		if(binaryString.charAt(0) != '1' || binaryString.charAt(binaryString.length()-1) != '1'){
			return false;
		}
		for(int base=2;base <= 10;base++) {
			if(isPrimeForBase(binaryString, base, baseToDivisor)) {
				return isJamCoin;
			}
		}
		System.out.println();
		System.out.print(binaryString);
		for(int base=2;base <= 10;base++) {
			System.out.print(" "+baseToDivisor.get(base));
		}
		isJamCoin = true;
		return isJamCoin;
	}
	
	private static boolean isPrimeForBase(String binaryString, int base, Map<Integer, BigInteger> baseToDivisor){
		BigInteger number = getNumber(binaryString, base);
		BigInteger divisor = getNonTrivialDivisor(number, baseToDivisor);
		if(null == divisor){
			return true;
		}
		baseToDivisor.put(base, divisor);
		return false;
	}
	
	private static BigInteger getNumber(String binaryString, int base) {
		int length = binaryString.length();
		BigInteger sum = BigInteger.ZERO;
		for(int i=0;i<length;i++){
			if(binaryString.charAt(length-i-1) == '1'){
				BigInteger baseInBI = BigInteger.valueOf(base);
				sum = sum.add(baseInBI.pow(i));
			}
		}
		return sum;
	}

	private static BigInteger getNonTrivialDivisor(BigInteger number, Map<Integer, BigInteger> baseToDivisor) {
		BigInteger CONSTANT_TWO = new BigInteger("2");
		BigInteger CONSTANT_THREE = new BigInteger("3");
		BigInteger CONSTANT_FIVE = new BigInteger("5");
		BigInteger CONSTANT_SIX = new BigInteger("6");
		BigInteger i = new BigInteger("1");
		BigInteger upperLimit = BigInteger.valueOf((long)Math.sqrt(number.doubleValue()));/*number.divide(CONSTANT_TWO);*/
		BigInteger divisor = new BigInteger("2");
		if((number.remainder(CONSTANT_TWO) == BigInteger.ZERO)){
				return CONSTANT_TWO;
		}
		if((number.remainder(CONSTANT_THREE) == BigInteger.ZERO)){
			return CONSTANT_THREE;
		}
		if((number.remainder(CONSTANT_FIVE) == BigInteger.ZERO)){
			return CONSTANT_FIVE;
		}
		while(divisor.compareTo(upperLimit) < 0) {
			divisor = i.multiply(CONSTANT_SIX).add(BigInteger.ONE);
			if((number.remainder(divisor) == BigInteger.ZERO)){
					return divisor;
			}
			divisor = i.multiply(CONSTANT_SIX).subtract(BigInteger.ONE);
			if((number.remainder(divisor) == BigInteger.ZERO)){
					return divisor;
			}

			i = i.add(BigInteger.ONE);
//			
		}

		return null;
	}
	

}
