package problemB;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class problemB {

	public static void main(String[] args) throws IOException {
		//read the input from file
				String inputLine;
				BufferedReader reader = new BufferedReader(new FileReader("/Users/abanthiy/Documents/workspace/ProblemA/src/input"));
				inputLine = reader.readLine();
				Integer numTestCases = Integer.parseInt(inputLine);
				for(int i=0; i < numTestCases;i++){
					List<ArrayList<Integer>> arrayOfHeights = new ArrayList<ArrayList<Integer>>();
					int N = Integer.parseInt(reader.readLine());
					for(int k=0;k < 2*N -1;k++){
						String line = reader.readLine();
						String[] heightStrings = line.split(" ");
						ArrayList<Integer> heights = new ArrayList<Integer>();
						for(String heightString : heightStrings){
							heights.add(Integer.parseInt(heightString));
						}
						arrayOfHeights.add(heights);
					}
					List<Integer> missingRowOrCol = getMissingRowOrCol(arrayOfHeights, N);
					if(i != 0) {
						System.out.println();
					}
					System.out.print("Case #" + (i+1)+":");
					for(Integer num:missingRowOrCol){
						System.out.print(" ");
						System.out.print(num);
					}
				}
				reader.close();

	}

	private static  List<Integer> getMissingRowOrCol(List<ArrayList<Integer>> arrayOfHeights, int N) {
		List<ArrayList<Integer>> NewarrayOfHeights = sortByLastNumber(arrayOfHeights, N);
		
		//choose the set of rows
		List<ArrayList<Integer>> testArrayOfHeights = new ArrayList<ArrayList<Integer>>();
		return choosePerms(NewarrayOfHeights,0, testArrayOfHeights,  N);
		
		
	}
	
	private static List<Integer> choosePerms(List<ArrayList<Integer>> arrayOfHeights, int startIndex, List<ArrayList<Integer>> testArrayOfHeights, int N) {
		int sizeOfRemainingList = arrayOfHeights.size();
		int sizeOfTestList = testArrayOfHeights.size();
		if(sizeOfTestList == N){
			if(isValid(testArrayOfHeights, N)){
				return lastNumList(testArrayOfHeights, N);
			}
			else {
				return null;
			}
		}
		for(int i=startIndex;i<sizeOfRemainingList;i++){
			if(sizeOfRemainingList-i+sizeOfTestList >= N){
				testArrayOfHeights.add(arrayOfHeights.get(i));
//				arrayOfHeights.removeAll(arrayOfHeights.subList(0, i));
				List<Integer> list = choosePerms(arrayOfHeights, i+1, testArrayOfHeights, N);
				if(null != list){
					return list;
				}
				testArrayOfHeights.remove(arrayOfHeights.get(i));
			}
			else {
				return null;
			}
		}
		return null;
		
	}

	private static List<Integer> lastNumList(List<ArrayList<Integer>> testArrayOfHeights, int N) {
		ArrayList<Integer> listOfLastNum = new ArrayList<Integer>();
		for(int i = 0;i < testArrayOfHeights.size();i++){
			Integer lastNum = testArrayOfHeights.get(i).get(N-1);
			if(!listOfLastNum.contains(lastNum)){
				listOfLastNum.add(lastNum);
			}
		}
		return listOfLastNum;
		
	}

	private static List<ArrayList<Integer>> sortByLastNumber(List<ArrayList<Integer>> arrayOfHeights, int N) {
		Map<Integer, List<Integer>> mapLastNumToIndexes = new HashMap<Integer, List<Integer>>();
		ArrayList<Integer> listOfLastNum = new ArrayList<Integer>();
		for(int i = 0;i < arrayOfHeights.size();i++){
			Integer lastNum = arrayOfHeights.get(i).get(N-1);
			if(!listOfLastNum.contains(lastNum)){
				listOfLastNum.add(lastNum);
			}
			if(mapLastNumToIndexes.get(lastNum) == null){
				List<Integer> list = new ArrayList<Integer>();
				list.add(i);
				mapLastNumToIndexes.put(lastNum, list);
			}
			else {
				List<Integer> list = mapLastNumToIndexes.get(lastNum);
				list.add(i);
			}
		}
		
		listOfLastNum.sort(null);
		
		List<ArrayList<Integer>> NewarrayOfHeights = new ArrayList<ArrayList<Integer>>();
		for(Integer num: listOfLastNum){
			List<Integer> indexes = mapLastNumToIndexes.get(num);
			for(Integer index: indexes){
				NewarrayOfHeights.add(arrayOfHeights.get(index));
			}
		}
		return NewarrayOfHeights;
	}

	private static boolean isValid(List<ArrayList<Integer>> arrayOfHeights, int N){
		boolean isValid = true;
		//none of them should have duplicates in the same column
		for(int i=0;i<N;i++){
			List<Integer> reachedHeights = new ArrayList<Integer>();
			for(List<Integer> row : arrayOfHeights){
				if(reachedHeights.contains(row.get(i))){
					return false;
				}
				else {
					reachedHeights.add(row.get(i));
				}
			}
		}
		
		return isValid;
	}

}
