import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

public class RevOfPanCakes {

	public static void main(String[] args) throws IOException {
		//read the input from file
		String inputLine;
		BufferedReader reader = new BufferedReader(new FileReader("/Users/abanthiy/Documents/workspace/RevengeOfPancakes/src/input.txt"));
		inputLine = reader.readLine();
		Integer numTestCases = Integer.parseInt(inputLine);
		for(int i=1; i <= numTestCases;i++){
			String S = reader.readLine();
			printMinFlips(S, 0, i);
		}
	}
	
	private static void printMinFlips(String S, int count, int testNum) {
		if(isFlipComplete(S)){
			System.out.println("Case #" + testNum + ": " + count);
			return;
		}
		//find the index to flip at
		int lowestMinusIndex = findIndexToFlip(S);
		S = flipAtIndex(S, lowestMinusIndex);
		count++;
		printMinFlips(S, count, testNum);
	}
	
	private static String flipAtIndex(String S, int index){
		if(index < 0 || index > S.length()) {
			return S;
		}
		String topHalf = S.substring(0, index+1);
		String bottomHalf = S.substring(index+1, S.length());
		
		//change the top half
		String revTopHalf = new StringBuilder(topHalf).reverse().toString();
		char[] characters = revTopHalf.toCharArray();
		for(int i =0;i < characters.length;i++){
			if(characters[i] == '-') {
				characters[i] = '+';
			}
			else {
				characters[i] = '-';
			}
		}
		String finalString = new String(characters);
		if(!bottomHalf.isEmpty()){
			finalString = finalString.concat(bottomHalf);
		}
		return finalString;
	}
	
	private static int findIndexToFlip(String S) {
		char[] characters = S.toCharArray();
		char first = characters[0];
		int i;
		for(i=1;i < characters.length;i++){
			if(characters[i] != first){
				break;
			}
		}
		return i-1;
	}
	private static boolean isFlipComplete(String S) {
		char[] characters = S.toCharArray();
		for(int i=0;i < characters.length;i++){
			if(characters[i] == '-'){
				return false;
			}
		}
		return true;
	}

}
