package prac;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeSet;

class Point{
	int left;
	int right;
	
	Point(int left,int right){
		this.left = left;
		this.right = right;
	}
	@Override
	public String toString() {
		// TODO Auto-generated method stub
		return left+ " "+right;
	}
}
public class BathroomStallsMed {
	
	public int findMiddleIndex(int left, int right){
		int m = left + (right-left)/2;
		return m;
	}
//	 Then they consider the set of stalls with the farthest closest neighbor, 
//	 CASE 1: that is, those S for which min(LS, RS) is maximal.
//	 			If there is only one such stall, they choose it; 
//	 CASE 2: or, they choose the one among those where max(LS, RS) is maximal. 
//	 If there are still multiple tied stalls, 
//	 they choose the leftmost stall among those.

	//	 y is max(LS, RS), and z is min(LS, RS)
	public int personCount = 0;
	
	public String find(long stalls, long lastPerson){
		HashMap<Long, Long> map = new HashMap<>();
		int count = 0, ont = 1;
		Queue<Long> queue = new LinkedList<>();
		queue.add(stalls);
		while(count < lastPerson) {			
			int tnt = ont;
			count = count+ont;
			while(tnt>0){
				long space = queue.remove();
				long RS = (space)/2;
				long LS = (space)%2 == 0? RS-1:RS;
				long sp = map.get(space) == null?0:map.get(space);
				map.put(space, sp+1);
				queue.add(RS);
				queue.add(LS);		
				tnt--;
			}
			
			ont = ont * 2;
			
		}
		
		TreeSet<Long> set = new TreeSet<>(map.keySet());
		
		Iterator<Long> itr = set.descendingIterator();
		long size = 0;
		while (itr.hasNext()){
			long val = itr.next();
			size = size + map.get(val);
			if(size>=lastPerson){
				
				long RS = (val)/2;
				long LS = (val)%2 == 0? RS-1:RS;
				long y = Math.max(LS, RS);
				long z = Math.min(LS, RS);
				return y+" "+z;
			}
		}
		return "";
					
	}
	
//	public void findBK(int left,int right, int lastPerson){
//		
//		if(left+1>=right)
//			return;
//		
//		int middleIndex = findMiddleIndex(left, right);
//		personCount++;
//		int LS = Math.abs(left - middleIndex) - 1;
//		int RS = Math.abs(right - middleIndex) - 1;
//		int y = Math.max(LS, RS);
//		int z = Math.min(LS, RS);
//		str = y+" "+z;
////		System.out.println("Person : "+personCount+" : "+str);
//		
//		if(personCount>=lastPerson)
//			return;
//		if(LS>0){
//			ArrayList<Point> list = map.get(LS);
//			if(list == null){
//				list = new ArrayList<>();
//			}
//			list.add(new Point(left, middleIndex));
//			
//			map.put(LS, list);
//		}
//		if(RS>0){
//			ArrayList<Point> rightlist = map.get(RS);
//			if(rightlist == null){
//				rightlist = new ArrayList<>();
//			}
//			rightlist.add(new Point(middleIndex, right));
//			map.put(RS, rightlist);
//		}
//		
//		findBK(left,middleIndex,lastPerson);
//		findBK(middleIndex, right, lastPerson);
//		
//	}
//	public String iterateBK (int stalls, int lastPerson){
//		this.personCount = 0;
//		this.str = null;
//		map = new HashMap<>();
//		
//		ArrayList<Point> list = new ArrayList<>();
//		list.add(new Point(0, stalls+1));
//		map.put(stalls+1, list);
//		
//		findBK(0, stalls+1, lastPerson);
//		TreeSet<Integer> set = new TreeSet<>(map.keySet());
//		
//		Iterator<Integer> itr = set.descendingIterator();
//		int size = 0;
//		while (itr.hasNext()){
//			int val = itr.next();
//			size = size + map.get(val).size();
//			if(size>=lastPerson){
//				Point p = map.get(val).get(0);
//				
//				int middleIndex = findMiddleIndex(p.left, p.right);  
//				int LS = Math.abs(p.left - middleIndex) - 1;
//				int RS = Math.abs(p.right - middleIndex) - 1;
//				int y = Math.max(LS, RS);
//				int z = Math.min(LS, RS);
//				return y+" "+z;
//			}
//		}
//		return "";
//	}
////		Person : 1 : 5 4 index: 5
////		Person : 2 : 2 2 index: 8
////		Person : 3 : 2 1 index: 2
////		Person : 4 : 1 0 index: 3
////		Person : 5 : 1 0 index: 6
////		Person : 6 : 1 0 index: 9
////		Person : 7 : 0 0 index: 1
////		Person : 8 : 0 0 index: 4
////		Person : 9 : 0 0 index: 7
////		Person : 10 : 0 0 index: 10


	public static void main(String[] args) throws NumberFormatException, IOException {
		BathroomStallsMed bs = new BathroomStallsMed();
//		System.out.println(bs.partition(0, 11, 10, 1));
//		bs.iterateBK(10,10);
		Scanner scanner = new Scanner(System.in);
		System.out.println("Enter the link ");
		String inputPath = "/Users/Bansari/myworkspace/clojure-gcd/gcd/resources/C-large.txt";
		BufferedReader reader = new BufferedReader(new FileReader(inputPath));
		int numberOfInput = Integer.parseInt(reader.readLine());
		FileWriter fstream = new FileWriter("/Users/Bansari/myworkspace/clojure-gcd/gcd/resources/C-large.txt");
		BufferedWriter out = new BufferedWriter(fstream);
		for (int i = 0; i < numberOfInput; i++) {
			String line = reader.readLine();
			String[] partitionData = line.split(" ");
			long stalls = Long.parseLong(partitionData[0]);
			long lastPerson = Long.parseLong(partitionData[1]);
			String str = bs.find(stalls,lastPerson);
			out.write("Case #" + (i+1) + ": " + str +"\n");
		}
		out.close();
	}

}
