import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class A {

    public static void main(String[] args) throws FileNotFoundException {
        //Scanner scanner = new Scanner(System.in);
        Scanner scanner = new Scanner(new File("largeInputA.txt"));
        int t = scanner.nextInt();
        for (int i=1; i<=t; i++) {
            scanner.nextLine();
            System.out.println("Case #" + i + ": " + solve(scanner));
        }
        scanner.close();
    }

    static int n;
    static int all;
    static int r;
    static int p;
    static int s;
    static char[] t;
    static int[] counts;
    static List<Winner>[] winnerList;
    static List<Winner>[] newWinnerList;
    static Winner finalWinner;

    public static String solve(Scanner scanner) {
        n = scanner.nextInt();
        all = (int)Math.pow(2,n);
        r = scanner.nextInt();
        p = scanner.nextInt();
        s = scanner.nextInt();
        t = new char[2*(all+1)];
        counts = new int[256];
        counts['p'] = p;
        counts['r'] = r;
        counts['s'] = s;
        if (!permutate(all)) return "IMPOSSIBLE";
        return finalWinner.parent.toUpperCase();
    }

    public static boolean permutate(int goal) {
        int[] newCounts = new int[256];
        winnerList = new ArrayList[256];
        winnerList['p'] = new ArrayList<Winner>();
        winnerList['r'] = new ArrayList<Winner>();
        winnerList['s'] = new ArrayList<Winner>();
        for (int i=0; i<goal; i+=2) {
            char a = 'ö';
            char b = 'ä';
            if (counts['p'] >= counts['r'] && counts['p'] >= counts['s']) {
                a = 'p';
                b = (counts['r'] > counts['s'] ? 'r' : 's');
            }
            else if (counts['r'] >= counts['p'] && counts['r'] >= counts['s']) {
                a = 'r';
                b = (counts['p'] > counts['s'] ? 'p' : 's');
            }
            else if (counts['s'] >= counts['r'] && counts['s'] >= counts['p']) {
                a = 's';
                b = (counts['r'] > counts['p'] ? 'r' : 'p');
            }
            Pair pair = new Pair(a, b);
            counts[a]--;
            counts[b]--;
            if (counts[a] < 0 || counts[b] < 0) return false;
            char winner = fight(newCounts, a, b);
            newCounts[winner]++;
            String parent = pair.first + "" + pair.second;
            Winner w = new Winner(winner, parent);
            winnerList[winner].add(w);
        }
        counts = newCounts;
        return doRound(goal/2);
    }

    public static boolean doRound(int goal) {
        if (goal == 1) {
            if (counts['p'] > 0) finalWinner = winnerList['p'].get(0);
            if (counts['r'] > 0) finalWinner = winnerList['r'].get(0);
            if (counts['s'] > 0) finalWinner = winnerList['s'].get(0);
            return true;
        }
        int[] newCounts = new int[256];
        newWinnerList = new ArrayList[256];
        newWinnerList['p'] = new ArrayList<Winner>();
        newWinnerList['r'] = new ArrayList<Winner>();
        newWinnerList['s'] = new ArrayList<Winner>();
        for (int i=0; i<goal; i+=2) {
            char a = 'ö';
            char b = 'ä';
            if (counts['p'] >= counts['r'] && counts['p'] >= counts['s']) {
                a = 'p';
                b = (counts['r'] > counts['s'] ? 'r' : 's');
            }
            else if (counts['r'] >= counts['p'] && counts['r'] >= counts['s']) {
                a = 'r';
                b = (counts['p'] > counts['s'] ? 'p' : 's');
            }
            else if (counts['s'] >= counts['r'] && counts['s'] >= counts['p']) {
                a = 's';
                b = (counts['r'] > counts['p'] ? 'r' : 'p');
            }
            counts[a]--;
            counts[b]--;
            if (counts[a] < 0 || counts[b] < 0) return false;

            Winner left = winnerList[a].remove(0);
            Winner right = winnerList[b].remove(0);
            StringBuilder meh = new StringBuilder();
            if (left.parent.compareTo(right.parent) < 0) {
                meh.append(left.parent);
                meh.append(right.parent);
            } else {
                meh.append(right.parent);
                meh.append(left.parent);
            }

            char newWinner = fight(newCounts, a, b);
            newCounts[newWinner]++;
            newWinnerList[newWinner].add(new Winner(newWinner, meh.toString()));
        }
        counts = newCounts;
        winnerList = newWinnerList;
        return doRound(goal/2);
    }

    public static char fight(int[] results, char a, char b) {
        if (a == 'p' && b == 'r') return 'p';
        if (a == 'r' && b == 'p') return 'p';

        if (a == 'p' && b == 's') return 's';
        if (a == 's' && b == 'p') return 's';

        if (a == 's' && b == 'r') return 'r';
        if (a == 'r' && b == 's') return 'r';

        return 'ö';
    }
}

class Winner implements Comparable<Winner> {
    char c;
    String parent;

    public Winner(char c, String parent) {
        this.c = c;
        this.parent = parent;
    }

    @Override
    public int compareTo(Winner o) {
        return (parent.compareTo(o.parent));
    }
}

class Pair implements Comparable<Pair> {
    char first;
    char second;
    String firstParent;
    String secondParent;

    public Pair(char first, char second) {
        this.first = first;
        this.second = second;
        if (first > second) {
            this.first = second;
            this.second = first;
        }
    }

    @Override
    public int compareTo(Pair other) {
        if (this.first < other.first) return -1;
        if (other.first < this.first) return 1;
        return this.second - other.second;
    }
}