import javafx.util.converter.BigIntegerStringConverter;

import java.io.File;
import java.io.FileNotFoundException;
import java.math.BigInteger;
import java.util.Scanner;

public class C {
    public static void main(String[] args) throws FileNotFoundException {
        Scanner scanner = new Scanner(new File("inputC.txt"));
        //Scanner scanner = new Scanner(System.in);
        int tests = scanner.nextInt();
        scanner.nextLine();
        for (int test=1; test<=tests; test++) {
            int n = scanner.nextInt();
            int count = scanner.nextInt();
            System.out.println("Case #" + test + ":\n" + solve(n, count));
        }
        scanner.close();
    }

    public static String solve(int n, int count) {
        StringBuilder ans = new StringBuilder();

        /* Create initial "1000...001" */
        long val = 1;
        for (int i=1; i<n; i++) val *= 2;
        val++;

        /* Generate answers >= initial */
        while (count > 0) {
            String string = Long.toBinaryString(val);
            if (confirmedNonPrimeInAllBases(string, ans)) count--;
            val += 2;
        }

        return ans.toString();
    }

    public static boolean confirmedNonPrimeInAllBases(String candidate, StringBuilder allAnswers) {
        StringBuilder ansBuilder = new StringBuilder(candidate + " ");
        for (int base=2; base<=10; base++) {
            BigInteger inBase = new BigInteger(candidate, base);
            int attempts = 100;
            int divider = findDivider(inBase, attempts);
            if (divider == 0) return false;
            else ansBuilder.append(divider + " ");
        }
        allAnswers.append(ansBuilder + "\n");
        return true;
    }

    public static int findDivider(BigInteger inBase, int maxAttempts) {
        for (int i=0; i<maxAttempts; i++) {
            int div = i+2;
            BigInteger divider = new BigInteger(div+"");
            if (inBase.remainder(divider).equals(new BigInteger("0"))) return div;
        }
        return 0;
    }

}
