package org.zadanie1;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class BotTrust {	
	private Scanner m_scaner;
	
	private PrintWriter out;
	
	public BotTrust() {
		try {
			System.setIn(new FileInputStream("input"));
			System.setOut(new PrintStream(new FileOutputStream("output")));
		} catch (FileNotFoundException e) {
			System.err.println(e.getMessage());
		}
		
		out = new PrintWriter(System.out);
		
		BufferedInputStream bis = new BufferedInputStream(System.in);
		m_scaner = new Scanner(bis);
		
		byte testCasesCount = m_scaner.nextByte();
		byte botsMove = 0;
		
		int i = 0;
		
		while (testCasesCount-- > 0) {
			int timer = 0;
			botsMove = m_scaner.nextByte();
			
			Mastermind mind = new Mastermind();
			Bot prevBot = new Bot('\0');
			int extraTime = 0;
			
			while (botsMove-- > 0) {
				Bot b = mind.getBotByName(m_scaner.next().charAt(0));
				byte step = m_scaner.nextByte();
				
				// new bot
				if (prevBot.getName() != b.getName()) {
					int taskTime = Math.abs(step - b.getPos()) + 1;
					
					if ((taskTime - extraTime) > 0) {
						timer += (taskTime - extraTime);
						
						extraTime = (taskTime - extraTime);
					} else {
						timer += 1;
						
						extraTime = 1;
					}
					
					b.moveTo(step);
					prevBot = b;
				// same bot
				} else {
					int taskTime = Math.abs(step - prevBot.getPos()) + 1;
					
					timer += taskTime;
					
					extraTime += taskTime;
					
					b.moveTo(step);
				}
			}
			out.println("Case #" + (++i) + ": " + timer);
		}
		out.close();
	}
	
	public static void main(String[] args) {
		new BotTrust();
	}
}

class Mastermind {
	Bot[] m_bots = new Bot[2];
	
	public Mastermind() {
		m_bots[0] = new Bot('O');
		m_bots[1] = new Bot('B');
	}
	
	public Bot getBotByName(char name) {
		switch (name) {
			case 'O' : return m_bots[0];
			default : 
				return m_bots[1];
		}
	}
}

class Bot {
	private char m_name;
	
	private byte m_pos = 1;
	
	public Bot(char name) {
		m_name = name;
	}
	
	public void moveTo(byte pos) {
		m_pos = pos;
	}
	
	public byte getPos() {
		return m_pos;
	}
	
	public char getName() {
		return m_name;
	}
}