package org.zadanie2;

import java.io.BufferedInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class Magicka {	
	private Scanner m_scaner;
	
	private PrintWriter out;
	
	public Magicka() {
		try {
			System.setIn(new FileInputStream("input"));
			System.setOut(new PrintStream(new FileOutputStream("output")));
		} catch (FileNotFoundException e) {
			System.err.println(e.getMessage());
		}
		
		out = new PrintWriter(System.out);
		
		BufferedInputStream bis = new BufferedInputStream(System.in);
		m_scaner = new Scanner(bis);
		
		byte testCasesCount = m_scaner.nextByte();
		int replacesCounter = 0;
		int resetsCounter = 0;
				
		int i = 0;
		
		while (testCasesCount-- > 0) {
			// replaces
			int[][] replaces = null;
			replacesCounter = m_scaner.nextByte();
			
			if (replacesCounter > 0) {
				replaces = new int[100][100];
				
				for (int j = 0; j < replacesCounter; j++) {
					String s = m_scaner.next();
					
					if (s.charAt(0) > s.charAt(1)) {
						replaces[s.charAt(1)][s.charAt(0)] = s.charAt(2);
					} else if (s.charAt(0) < s.charAt(1)) {
						replaces[s.charAt(0)][s.charAt(1)] = s.charAt(2);
					// equal
					} else {
						replaces[s.charAt(0)][s.charAt(1)] = s.charAt(2);
					}
				}
			}
			
			// resets			
			int[][] resets = null;
			resetsCounter = m_scaner.nextByte();
			
			if (resetsCounter > 0) {
				resets = new int[100][];
				
				for (int j = 0; j < resetsCounter; j++) {
					String s = m_scaner.next();
					
					 if (null == resets[s.charAt(0)]) {
						 resets[s.charAt(0)] = new int[100];
						 resets[s.charAt(0)][s.charAt(1)] = 99;
					 } else {
						 resets[s.charAt(0)][s.charAt(1)] = 99;
					 }
					
					 if (null == resets[s.charAt(1)]) {
						 resets[s.charAt(1)] = new int[100];
						 resets[s.charAt(1)][s.charAt(0)] = 99;
					 } else {
						 resets[s.charAt(1)][s.charAt(0)] = 99;
					 }
				}
			}
			
			// chain length
			m_scaner.nextByte();
			
			String chain = m_scaner.next();
			
			i++;
			
			if ((null == replaces) && (null == resets)) {
				printChain(chain, i);
			} else {
				StringBuilder result = new StringBuilder();
				byte doReset = 0;
				byte lastReset = 0;
				
				for (int j = 0; j < chain.length(); j++) {
					result.append(chain.charAt(j));
					
					// beginning
					if (2 == result.length()) {
						char yy = '\0';
						if (result.charAt(0) > result.charAt(1)) {
							yy = replace(result.charAt(1), result.charAt(0), replaces);
						} else if (result.charAt(1) > result.charAt(0)) {
							yy = replace(result.charAt(0), result.charAt(1), replaces);
						} else {
							yy = replace(result.charAt(0), result.charAt(1), replaces);
						}
						
						if (yy != 0) {
							result = new StringBuilder(yy + "");
						}
					}
					
					if ((null != resets) && (null != resets[chain.charAt(j)])) {
						if (doReset++ == 0) {
							lastReset = (byte) chain.charAt(j);
						}
						
						if (doReset == 2) {
							byte currentReset = (byte) chain.charAt(j);
							
							if ((0 != resets[lastReset][currentReset]) && (0 != resets[currentReset][lastReset])) {
								result = new StringBuilder();
								doReset = 0;
							}
						}
					}
					
					// end
					if (result.length() > 2) {
						char yy = '\0';
						if (result.charAt(result.length() - 2) > result.charAt(result.length() - 1)) {
							yy = replace(result.charAt(result.length() - 1), result.charAt(result.length() - 2), replaces);
						} else if (result.charAt(result.length() - 1) > result.charAt(result.length() - 2)) {
							yy = replace(result.charAt(result.length() - 2), result.charAt(result.length() - 1), replaces);
						} else {
							yy = replace(result.charAt(result.length() - 1), result.charAt(result.length() - 2), replaces);
						}
						
						if (yy != 0) {
							String pomS = result.substring(0, result.length() - 2);
							result = new StringBuilder(pomS + yy);
						}
					}
				}
				
				printChain(result.toString(), i);
			}
		}
	}
	
	protected void printChain(String chain, int index) {
		StringBuilder list = new StringBuilder();
		
		System.out.print("Case #" + index + ": [");		
		if (chain.length() > 0) {
			list.append(chain.charAt(0));
			for (int j = 1; j < chain.length(); j++) {
			    list.append(", ").append(chain.charAt(j));
			}
		}
		System.out.println(list.toString() + "]");
	}
	
	protected char replace(int x, int y, int[][] values) {
		if (null == values) {
			return 0;
		}
		return (char) values[x][y];
	}
	
	public static void main(String[] args) {
		new Magicka();
	}
}