import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.Scanner;

import static java.math.BigDecimal.ROUND_HALF_UP;

/**
 * Created by s1awek on 12.04.14.
 */
public class Cookie {
    private static final int PRECISION = 7;

    public static void main(String[] args) throws IOException {
        final Scanner in = new Scanner(Cookie.class.getResourceAsStream("B-small-attempt0.in"));
        final BufferedWriter out = new BufferedWriter(new FileWriter("small.out"));

        final int numberOfCases = in.nextByte() + 1;

        for (int i = 1; i < numberOfCases; i++) {
            final BigDecimal C = new BigDecimal(in.next());
            final BigDecimal F = new BigDecimal(in.next());
            final BigDecimal X = new BigDecimal(in.next());

            out.write(String.format("Case #%d: ", i));
            out.write(cookieIt(C, F, X));
            out.newLine();
        }
        out.close();
    }

    private static String cookieIt(final BigDecimal farmPrice, final BigDecimal farmCookies, final BigDecimal cookiesToGain) {
        BigDecimal timeToGainCookiesWithoutFarm, timeToGetAFarm, timeToGainCookiesWithFarm,
                cookies = new BigDecimal("2"), time = new BigDecimal("0");

        do {
            timeToGainCookiesWithoutFarm = cookiesToGain.divide(cookies, PRECISION, ROUND_HALF_UP).add(time);

            timeToGetAFarm = farmPrice.divide(cookies, PRECISION, ROUND_HALF_UP);

            timeToGainCookiesWithFarm = timeToGetAFarm.add(cookiesToGain.divide(cookies.add(farmCookies), PRECISION, ROUND_HALF_UP)).add(time);

            // more cookies and more time spent trying
            cookies = cookies.add(farmCookies);

            time = time.add(timeToGetAFarm);

        } while (timeToGainCookiesWithoutFarm.compareTo(timeToGainCookiesWithFarm) == 1);

        return timeToGainCookiesWithoutFarm.setScale(7, ROUND_HALF_UP).toString();
    }
}
