
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.List;
import java.util.Set;
import java.util.StringTokenizer;


public class ProblemA {

	static long count;
	static Set<String> processed;
	
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int nCases = Integer.parseInt(br.readLine());
		
		for (int g = 1; g <= nCases; g++) {
			StringTokenizer tks = new StringTokenizer(br.readLine());
			
			long n = Long.parseLong(tks.nextToken());
			long a = Long.parseLong(tks.nextToken());
			long b = Long.parseLong(tks.nextToken());
			long c = Long.parseLong(tks.nextToken());
			long d = Long.parseLong(tks.nextToken());
			long x0 = Long.parseLong(tks.nextToken());
			long y0 = Long.parseLong(tks.nextToken());
			long m = Long.parseLong(tks.nextToken());
			
			long x = x0;
			long y = y0;
			
			List<Point> points = new ArrayList<Point>();
			points.add(new Point(x, y));
			
			for (long i = 1; i < n; i++) {
				x = (a * x + b) % m;
				y = (c * y + d) % m;
				
				points.add(new Point(x, y));
			}
			
			count = 0;
			processed = new HashSet<String>();
			backtracking(points, new LinkedList<Point>(), 3);
			
			
			
			
			
			System.out.println("Case #" + g + ": " + count);
		}
	}

	static void backtracking(List<Point> points, List<Point> solucao, long n) {
		if (solucao.size() == n) {
			Point p1 = solucao.get(0);
			Point p2 = solucao.get(1);
			Point p3 = solucao.get(2);
			
			List<Point> newList = new LinkedList<Point>(solucao);
			Collections.sort(newList);
			
			long x = p1.x + p2.x + p3.x;
			long y = p1.y + p2.y + p3.y;
			
			if (x % 3 == 0 && y % 3 == 0 && !processed.contains(newList.toString())) {
//				System.out.println(newList);if (newList.toString().contains("-")) throw new RuntimeException();
				processed.add(newList.toString());
				count++;
			}
		} else {
			for (long i = 0; i < points.size(); i++) {
				Point p = points.remove((int) i);
				solucao.add(p);
				if (isValid(solucao)) backtracking(points, solucao, 3);
				
				points.add((int) i, p);
				solucao.remove(solucao.size() - 1);
			}
		}
	}

	private static boolean isValid(List<Point> solucao) {
		if (solucao.size() == 1) return true;
		
		if (solucao.size() == 2) {
			Point p1 = solucao.get(0);
			Point p2 = solucao.get(1);
			return !p1.equals(p2);
		}
		
		Point p1 = solucao.get(0);
		Point p2 = solucao.get(1);
		Point p3 = solucao.get(2);
		return !p1.equals(p2) && !p1.equals(p3) && !p2.equals(p3);
	}
	
}
class Point implements Comparable<Point> {
	public long x;
	public long y;
	
	public Point(long x, long y) {
		this.x = x;
		this.y = y;
	}
	
	public String toString() {
		return this.x + ":" + this.y;
	}
	
	public boolean equals(Object o) {
		Point p = (Point) o;
		return p.x == x && p.y == y;
	}

	public int compareTo(Point o) {
		if (x != o.x) return (int) (x - o.x);
		return (int) (y - o.y);
	}
}