package qualify;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

import ds.tree.RadixTree;
import ds.tree.RadixTreeImpl;

public class ProblemA {
	
	private static RadixTree<String> tree = new RadixTreeImpl<String>();
	private static int total;

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		String line = br.readLine();
		StringTokenizer tks = new StringTokenizer(line);
		
		int l = Integer.parseInt(tks.nextToken());
		int d = Integer.parseInt(tks.nextToken());
		int n = Integer.parseInt(tks.nextToken());
		
		for (int i = 0; i < d; i++) {
			line = br.readLine();
			
			tree.insert(line, line);
		}
		
		
		for (int i = 1; i <= n; i++) {
			line = br.readLine();
			
			total = 0;
			DFS(line, line, "");
			System.out.println("Case #" + i + ": " + total);
		}
	}

	private static void DFS(String token, String resto, String result) {
		if ("".equals(resto)) {
			total++;
			return;
		}
		
		String nextToken;
		if (resto.charAt(0) != '(') {
			nextToken = resto.substring(0, 1);
			resto = resto.substring(1);
		} else {
			int endIndex = resto.indexOf(')');
			nextToken = resto.substring(1, endIndex);
			resto = resto.substring(endIndex + 1);
		}
		
		for (int i = 0; i < nextToken.length(); i++) {
			String nextResult = result + nextToken.charAt(i);
			
			if (!tree.searchPrefix(nextResult, 1).isEmpty()) DFS(token, resto, nextResult);
		}
	}

}
