
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.StringTokenizer;


public class ProblemB {

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int nCases = Integer.parseInt(br.readLine());
		
		for (int g = 1; g <= nCases; g++) {
			String number = br.readLine();
			
			System.out.println("Case #" + g + ": " + generate(number, new int[number.length()]));
		}
	}

	static long generate(String number, int[] signs) {
		long count = 0;
		
		while (!end(signs)) {
			if (isUgly(evaluate(number, signs))) count++;
			
			inc(signs, 0);
		}
		
		return count;
	}

	private static long evaluate(String number, int[] signs) {
		StringBuilder sb = new StringBuilder();
		
		for (int i = 0; i < number.length(); i++) {
			sb.append(number.charAt(i));
			
			if (i < number.length() - 1)
			switch (signs[i]) {
				case 1: sb.append("+"); break;
				case 2: sb.append("-"); break;
			}
		}
		
		return calcula(sb.toString());
	}

	private static long calcula(String exp) {
		StringTokenizer tks = new StringTokenizer(exp, "+-", true);
		
		long result = Long.parseLong(tks.nextToken());
		
		while (tks.hasMoreTokens()) {
			String op = tks.nextToken();
			
			if ("+".equals(op)) {
				long nextNum = Long.parseLong(tks.nextToken());
				result += nextNum;
			} else if ("-".equals(op)) {
				long nextNum = Long.parseLong(tks.nextToken());
				result -= nextNum;
			}
		}
		
		return result;
	}
	
	private static boolean isUgly(long c) {
		return c % 2 == 0 || c % 3 == 0 || c % 5 == 0 || c % 7 == 0;
	}

	private static void inc(int[] signs, int pos) {
		if (signs[pos] < 2) signs[pos]++;
		else {
			signs[pos] = 0;
			inc(signs, pos + 1);
		}
	}

	private static boolean end(int[] signs) {
		return signs[signs.length - 1] != 0;
	}

	
}
