package round1;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class ProblemB {
	
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int t = Integer.parseInt(br.readLine());
		
		for (int g = 1; g <= t; g++) {
			
			int n = Integer.parseInt(br.readLine());
			Set<Firefly> set = new HashSet<Firefly>();
			
			double sumX = 0;
			double sumY = 0;
			double sumZ = 0;
			
			for (int k = 1; k <= n; k++) {
				StringTokenizer tks = new StringTokenizer(br.readLine());
				int x = Integer.parseInt(tks.nextToken());
				int y = Integer.parseInt(tks.nextToken());
				int z = Integer.parseInt(tks.nextToken());
				int vx = Integer.parseInt(tks.nextToken());
				int vy = Integer.parseInt(tks.nextToken());
				int vz = Integer.parseInt(tks.nextToken());
				
				sumX += x;
				sumY += y;
				sumZ += z;
				
				set.add(new Firefly(x, y, z, vx, vy, vz));
			}
			
			final double DELTA = 0.000001;
			
			double dmin = dist(sumX / n, sumY / n, sumZ / n);
			double tmin = 0;
//System.out.println("#"+dmin);
			for (double i = DELTA; i <= 5000; i += DELTA) {
				for (Firefly ff : set) {
					ff.x += ff.vx * DELTA;
					ff.y += ff.vy * DELTA;
					ff.z += ff.vz * DELTA;
					sumX += ff.vx * DELTA;
					sumY += ff.vy * DELTA;
					sumZ += ff.vz * DELTA;
				}
				double daux = dist(sumX / n, sumY / n, sumZ / n);
//System.out.println(">>"+daux);
				if (daux < dmin) {
					dmin = daux;
					tmin = i;
				} else {
					break;
				}
			}
			
			System.out.printf("Case #%d: %.8f %.8f\n", g, dmin, tmin);
		}
	}

	private static double dist(double d, double e, double f) {
		return Math.sqrt(d * d + e * e + f * f);
	}

}
class Firefly {
	public double x;
	public double y;
	public double z;
	public int vx;
	public int vy;
	public int vz;
	
	public Firefly(double x, double y, double z, int vx, int vy, int vz) {
		this.x = x;
		this.y = y;
		this.z = z;
		this.vx = vx;
		this.vy = vy;
		this.vz = vz;
	}
}