import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Calendar;
import java.util.Collections;
import java.util.LinkedList;
import java.util.StringTokenizer;


public class ProblemB {

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int nCases = Integer.parseInt(br.readLine());
		
		for (int g = 1; g <= nCases; g++) {
			int t = Integer.parseInt(br.readLine());
			
			StringTokenizer tks = new StringTokenizer(br.readLine());
			int na = Integer.parseInt(tks.nextToken());
			int nb = Integer.parseInt(tks.nextToken());
			
			LinkedList<TrainEvent> events = new LinkedList<TrainEvent>();
			
			for (int i = 0; i < na + nb; i++) {
				tks = new StringTokenizer(br.readLine());
				String start = tks.nextToken();
				String end = tks.nextToken();
				
				tks = new StringTokenizer(start, ":");
				Calendar startCal = Calendar.getInstance();
				startCal.clear();
				startCal.set(Calendar.HOUR, Integer.parseInt(tks.nextToken()));
				startCal.set(Calendar.MINUTE, Integer.parseInt(tks.nextToken()));
				
				tks = new StringTokenizer(end, ":");
				Calendar endCal = Calendar.getInstance();
				endCal.clear();
				endCal.set(Calendar.HOUR, Integer.parseInt(tks.nextToken()));
				endCal.set(Calendar.MINUTE, Integer.parseInt(tks.nextToken()));
				endCal.add(Calendar.MINUTE, t);
				
				events.add(new TrainEvent(startCal, 'i', i < na ? 'd' : 'e'));
				events.add(new TrainEvent(endCal, 'f', i < na ? 'd' : 'e'));
			}
			
			Collections.sort(events);
			
			int totalA = 0;
			int totalB = 0;
			int currentA = 0;
			int currentB = 0;
			
			for (TrainEvent event : events) {
				if (event.type == 'i') {
					if (event.direction == 'd') {
						if (currentA > 0) currentA--;
						else totalA++;
					} else {
						if (currentB > 0) currentB--;
						else totalB++;
					}
				} else {
					if (event.direction == 'd') currentB++;
					else currentA++;
				}
			}
			
			
			
			
			System.out.println("Case #" + g + ": " + totalA + " " + totalB);
		}
	}
	
}

class TrainEvent implements Comparable<TrainEvent> {
	public Calendar time;
	public char type;
	public char direction;
	
	public TrainEvent(Calendar time, char type, char direction) {
		this.time = time;
		this.type = type;
		this.direction = direction;
	}

	public int compareTo(TrainEvent o) {
		if (this.time.compareTo(o.time) == 0) {
			if (this.type == o.type) return 0;
			return this.type == 'f' ? -1 : 1;
		}
		return this.time.compareTo(o.time);
	}
	
	public String toString() {
		return this.time.get(Calendar.HOUR)+":"+this.time.get(Calendar.MINUTE) + " " + this.type + " " + this.direction;
	}
}