import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Program1 {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws FileNotFoundException {
		Program1 prog = new Program1();
		prog.readContents();
	}

	private void readContents() throws FileNotFoundException {
		Scanner scanner = new Scanner(System.in);

		try {
			int testCaseCount = Integer.parseInt(scanner.nextLine());
			for (int i = 1; i <= testCaseCount; i++) {
				String line = scanner.nextLine();
				int N = Integer.parseInt(line);
				double[] wp = new double[N + 1];
				double[][] wp_throw = new double[N + 1][N + 1];
				double[] owp = new double[N + 1];
				double[] oowp = new double[N + 1];

				for (int j = 1; j <= N; j++) {
					// Team j
					char[] score = scanner.nextLine().toCharArray();

					int noOfWins = 0;
					int gamesPlayed = 0;
					for (int k = 0; k < N; k++) {
						if (score[k] == '1') {
							noOfWins++;
							gamesPlayed++;
						} else if (score[k] == '0') {
							gamesPlayed++;
						}
					}
					if (gamesPlayed > 0) {
						wp[j] = noOfWins * 1.0 / gamesPlayed;
						for (int k = 1; k <= N; k++) {
							if (k == j) {
								wp_throw[j][k] = -1;
							} else if (score[k - 1] == '1' || score[k - 1] == '0') {
								if (gamesPlayed > 1) {
									if (score[k - 1] == '1')
										wp_throw[j][k] = (noOfWins - 1) * 1.0 / (gamesPlayed - 1);
									else
										wp_throw[j][k] = noOfWins * 1.0 / (gamesPlayed - 1);
								} else {
									wp_throw[j][k] = -1;
								}
							} else {
								wp_throw[j][k] = -1;
							}
						}

					} else {
						wp[j] = 0;
						for (int k = 1; k <= N; k++) {
							wp_throw[j][k] = -1;
						}
					}
				}

				// Calculate OWP
				for (int j = 1; j <= N; j++) {
					int total = 0;
					double percnt = 0.0;
					for (int k = 1; k <= N; k++) {
						if (wp_throw[k][j] >= 0) {
							total++;
							percnt += wp_throw[k][j];
						}
					}
					if (total > 0) {
						owp[j] = percnt / total;
					} else {
						owp[j] = 0;
					}
				}

				// Calculate OOWP
				for (int j = 1; j <= N; j++) {
					int total = 0;
					double percnt = 0.0;
					for (int k = 1; k <= N; k++) {
						if (wp_throw[j][k] >= 0) {
							total++;
							percnt += owp[k];
						}
					}
					if (total > 0) {
						oowp[j] = percnt / total;
					} else {
						oowp[j] = 0;
					}
				}
				System.out.println("Case #" + i + ":");

				for (int j = 1; j <= N; j++) {
					double RWI = 0.25 * wp[j] + 0.5 * owp[j] + 0.25 * oowp[j];
					System.out.println(RWI);
				}
			}
		} finally {
			// ensure the underlying stream is always closed
			scanner.close();
		}
	}
}