import java.io.*;
import java.util.*;

public class OverSizedPancakeFlipper {
	public static void main(String[] args) throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(br.readLine());

		for(int i = 1; i <= t; i++) {
			String[] data = br.readLine().split(" ");
			int size = Integer.parseInt(data[1]);
			if(data[0].indexOf('-') == -1) {
				System.out.println("Case #" + i +": 0");

			} else {
				HashSet<String> all = new HashSet<String>();
				LinkedList<String> pancakes = new LinkedList<String>();
				LinkedList<Integer> flips = new LinkedList<Integer>();

				all.add(data[0]);
				pancakes.add(data[0]);
				flips.add(0);

				String config;
				int flip = 0;
				boolean possible = false;

				while(possible == false && pancakes.size() != 0) {
					config = pancakes.removeFirst();
					flip = flips.removeFirst() + 1;

					LinkedList<String> nextFlips = nextFlips(config, size);
					for(String s: nextFlips) {
						if(all.contains(s) == false) {
							all.add(s);
							if(s.indexOf('-') == -1) {
								possible = true;
								break;
							} else {
								pancakes.addLast(s);
								flips.add(flip);
							}
						}
					}

				}

				if(possible) {
					System.out.println("Case #" + i +": " + flip);
				} else {
					System.out.println("Case #" + i +": IMPOSSIBLE");
				}
			}
		}
	}

	public static LinkedList<String> nextFlips(String pancakes, int size) {
		LinkedList<String> permutations = new LinkedList<String>();

		for(int i = 0; i <= pancakes.length() - size; i++) {
			char[] temp = pancakes.toCharArray();
			boolean shouldAdd = false;
			for(int j = i; j < i + size; j++) {
				if(temp[j] == '-') {
					shouldAdd = true;
					temp[j] = '+';
				} else {
					temp[j] = '-';
				}
			}
			if(shouldAdd) {
				permutations.addLast(new String(temp));
			}
		}

		return permutations;
	} 
}