import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;


public class CoinJam {

	private static final BigInteger BIG_INT2 = BigInteger.valueOf(2);
	private static final BigInteger BIG_INT3 = BigInteger.valueOf(3);
	private static final BigInteger BIG_INT6 = BigInteger.valueOf(6);
	private static final BigInteger BIG_INTMINUS1 = BigInteger.valueOf(-1);
	private static final BigInteger BIG_INTTHOUSAND = BigInteger.valueOf(1000);

	public static void main(String[] args) throws Exception{
		BufferedReader in = new BufferedReader(new FileReader("C.in"));
		FileWriter fw = new FileWriter("C-large.out");
		Long testCaseCount = Long.parseLong(in.readLine());
		for(int i=0;i<testCaseCount;i++){
			fw.write("Case #"+testCaseCount+":\n");
			String[] params = in.readLine().split("\\s+");
			int digitCount = Integer.parseInt(params[0]);
			int coinCount = Integer.parseInt(params[1]);
			int coinsCreated = 0;

			String initialVal = "1";
			for (int j=0;j<digitCount-2;j++){
				initialVal += "0";
			}
			initialVal += "1";
			BigInteger coin = new BigInteger(initialVal,2);
			while(coinsCreated < coinCount){
				String output = coin.toString(2);
				for (int j=2;j<11;j++){
					BigInteger val = checkIfPrimaNumber(new BigInteger(coin.toString(2),j));
					if(val.compareTo(BIG_INTMINUS1) != 0){
						output += " " + val.toString();
						if(10 == j){
							coinsCreated++;
							fw.write(output+"\n");
							System.out.println(output);
						}
					} else{
						break;
					}
				}
				coin = coin.add(BIG_INT2);
				output = coin.toString(2);
			}
		}
		in.close();
		fw.close();
	}

	public static BigInteger checkIfPrimaNumber(BigInteger n) {
		if(n.compareTo(BIG_INT2) == -1){
			return BIG_INTMINUS1;
		} else if(n.compareTo(BIG_INT2) == 0 || n.compareTo(BIG_INT3) == 0) {
			return BIG_INTMINUS1;
		} else if(n.mod(BIG_INT2).compareTo(BigInteger.ZERO) == 0){
			return BIG_INT2;
		} else if(n.mod(BIG_INT3).compareTo(BigInteger.ZERO) == 0){
			return BIG_INT3;
		}

		BigInteger sqrtN = bigIntSqRootFloor(n).add(BigInteger.ONE);
		BigInteger i = BigInteger.valueOf(6);
		while(i.compareTo(sqrtN) < 1 && BIG_INTTHOUSAND.compareTo(i) == 1){
			if(n.mod(i.subtract(BigInteger.ONE)).compareTo(BigInteger.ZERO) == 0){
				return i.subtract(BigInteger.ONE);
			} else if(n.mod(i.add(BigInteger.ONE)).compareTo(BigInteger.ZERO) == 0){
				return i.add(BigInteger.ONE);
			}
			i = i.add(BIG_INT6);
		}
		return BIG_INTMINUS1;
	}
	public static BigInteger bigIntSqRootFloor(BigInteger x)
			throws IllegalArgumentException {
		if (x.compareTo(BigInteger.ZERO) < 0) {
			throw new IllegalArgumentException("Negative argument.");
		}
		if (x .equals(BigInteger.ZERO) || x.equals(BigInteger.ONE)) {
			return x;
		}
		BigInteger two = BIG_INT2;
		BigInteger y;
		for (y = x.divide(two);
				y.compareTo(x.divide(y)) > 0;
				y = ((x.divide(y)).add(y)).divide(two));
		return y;
	}
}
