import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by apurvak on 4/8/16.
 */
public class CountingSheep {

    private static void setDigits(Map<Integer, Boolean> map, long x) {
        while (x > 0) {
            map.put((int)x % 10, true);
            x = x /10;
        }
    }

    private static boolean isAllDigitsSeen(Map<Integer, Boolean> map, long x) {
        for (int i = 0; i <= 9; i++) {
            if (!map.containsKey(i)) {
                return false;
            }
        }
        return true;
    }

    public static int lastInsomnia(int n) {
        if (n == 0) return -1;
        Map<Integer, Boolean> map = new HashMap<>();
        int i = 1;
        long x = n;
        while(true) {
            setDigits(map, x);
            if (isAllDigitsSeen(map, x)) {
                return (int)x;
            }
            i++;
            if (x > Integer.MAX_VALUE) {
                return -1;
            }
            x = i * n;
        }

    }

    public static void main(String[] arg) {
        Scanner sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; i++) {
            int lastSeen = lastInsomnia(sc.nextInt());
            if (lastSeen > 0) {
                System.out.println("Case #" + i + ": " + lastSeen);
            } else {
                System.out.println("Case #" + i + ": INSOMNIA");
            }
        }
    }
}

