package C;

import java.io.*;
import java.util.*;

public class Bathroom {
	
	public static final String NAME = "C-small-1-attempt1";
	public static final boolean IS_SUBMIT = true;
	
	
	public static Scanner in;
	public static PrintWriter out;
	
	public static void main(String[] args) throws FileNotFoundException{
		
		if(IS_SUBMIT){
			in = new Scanner(new File(NAME + ".in"));
			out = new PrintWriter(new File(NAME + ".out"));
		}else{
			in = new Scanner(new File("D:/input.txt"));
			out = new PrintWriter(new File("D:/output.txt"));
		}
		
		int numCases = in.nextInt();
		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			out.print("Case #" + caseNum + ": ");
			main2();
			out.print("\n");
		}
		
		out.close();
		
	}
	
	public static void main2(){
		
		long N = in.nextLong();
		long K = in.nextLong();
		
		solveHard(N, K);
		
	}
	
	// ############################################################# Solve Hard #############################################################
	private static void solveHard(long N, long K){
		
		long lastR = (N - 1) / 2;
		long lastL = N - lastR - 1;
		
		HashMap<Long, Integer> betweens = new HashMap<Long, Integer>();
		add(betweens, N / 2);
		add(betweens, N - 1 - (N / 2));
		for(int i = 2 ; i <= K ; i++){
			
			long max = getMax(betweens);
			long thisL = (max - 1) / 2;
			long thisR = max - thisL - 1;
			if(thisL < 0)
				thisL = 0;
			if(thisR < 0)
				thisR = 0;
			
			lastR = thisL;
			lastL = thisR;
			add(betweens, lastR);
			add(betweens, lastL);
		}
		
		if(lastR > lastL)
			out.print(lastR + " " + lastL);
		else
			out.print(lastL + " " + lastR);
	}
	
	private static void add(HashMap<Long, Integer> betweens, long val){
		boolean f = false;
		for(Long l : betweens.keySet()){
			if(l == val){
				betweens.put(val, betweens.get((long)val) + 1);
				f = true;
				break;
			}
		}
		
		if(!f)
			betweens.put(val, 1);
	}
	
	private static long getMax(HashMap<Long, Integer> betweens){
		long max = 0;
		
		for(Long l : betweens.keySet()){
			if(l > max)
				max = l;
		}
		
		int a = betweens.get((long)max) - 1;
		if(a == 0)
			betweens.remove((long)max);
		else
			betweens.put((long)max, a);
		return max;
	}
	
}
