package D;

import java.io.*;
import java.util.*;

public class FashionShow {
	
	public static final String NAME = "D-small-attempt0";
	public static final boolean IS_SUBMIT = true;
	
	
	public static Scanner in;
	public static PrintWriter out;
	
	public static void main(String[] args) throws FileNotFoundException{
		
		if(IS_SUBMIT){
			in = new Scanner(new File(NAME + ".in"));
			out = new PrintWriter(new File(NAME + ".out"));
		}else{
			in = new Scanner(new File("D:/input.txt"));
			out = new PrintWriter(new File("D:/output.txt"));
		}
		
		int numCases = in.nextInt();
		for (int caseNum = 1; caseNum <= numCases; caseNum++) {
			out.print("Case #" + caseNum + ": ");
			main2();
		}
		
		out.close();
		
	}
	
	static char[][] matrix;
	
	static final char EMPTY = '.';
	static final char X = 'x';
	static final char P = '+';
	static final char O = 'o';
	
	public static ArrayList<Artist> modifiedOrAddeds;
	public static void main2(){
				
		int N = in.nextInt();
		int init = in.nextInt();
		modifiedOrAddeds = new ArrayList<>();
		
		// Make It Empty
		matrix = new char[N][N]; // Row - Col
		for(int i = 0 ; i < N ; i++)
			Arrays.fill(matrix[i], EMPTY);
		
		// Get Values
		for(int i = 0 ; i < init ; i++){
			char c = in.next().charAt(0);
			matrix[in.nextInt() - 1][in.nextInt() - 1] = c;
		}
		
		//printMatrix(matrix, N);
		//System.out.println("-------------");
		
		// Add X and Upgrade P If It Should Be X or P
		for(int x = 0 ; x < N ; x++){
			for(int y = 0 ; y < N ; y++){
				char aType = matrix[x][y];
				boolean isNotContainXorO = rowContains(x, X) == 0 && rowContains(x, O) == 0 && colContains(y, X) == 0 && colContains(y, O) == 0;
				if(aType == EMPTY && isNotContainXorO){ // Can you put X
					matrix[x][y] = X;
					addArtist(x, y, X);
				}else if(aType == P && isNotContainXorO){
					matrix[x][y] = X;
					addArtist(x, y, X);
				}
			}
		}
		
		// ADD +
		for(int x = 0 ; x <= N / 2 ; x++){
			for(int y = 0 ; y < N ; y++){
				if(matrix[x][y] == EMPTY){
					int cout = diagonalContains(x, y, P);
					if(cout == 0){
						matrix[x][y] = P;
						addArtist(x, y, P);
					}
				}
			}
		}
		for(int x = N - 1 ; x > N / 2 ; x--){
			for(int y = 0 ; y < N ; y++){
				if(matrix[x][y] == EMPTY){
					int cout = diagonalContains(x, y, P);
					if(cout == 0){
						matrix[x][y] = P;
						addArtist(x, y, P);
					}
				}
			}
		}
		
		//printMatrix(matrix, N);
		//System.out.println("----------------");
		for(int x = 0 ; x < N ; x++){
			for(int y = 0 ; y < N ; y++){
				if(matrix[x][y] == X){
					addArtist(x, y, O);
					matrix[x][y] = O;
					x = N;
					break;
				}
			}
		}
		//printMatrix(matrix, N);
		
		int total = 0;
		for(int x = 0 ; x < N ; x++){
			for(int y = 0 ; y < N ; y++){
				if(matrix[x][y] == P || matrix[x][y] == X){
					total++;
				}else if(matrix[x][y] == O){
					total += 2;
				}
			}
		}
		//printMatrix(matrix, N);
		
		out.println(total + " " + modifiedOrAddeds.size());
		for(Artist p : modifiedOrAddeds){
			out.println(p.type + " " + p.row + " " + p.col);
		}
	}
	
	public static void addArtist(int x, int y, char type){
		for(Artist a : modifiedOrAddeds){
			if(a.row == x && a.col == y){
				a.type = type;
				return;
			}
		}
		
		Artist a = new Artist(x, y, type);
		modifiedOrAddeds.add(a);
	}
	
	public static void printMatrix(char[][] matrix, int N){
		for(int x = 0 ; x < N ; x++){
			for(int y = 0 ; y < N ; y++){
				System.out.print(matrix[x][y] + " ");
			}
			System.out.println();
		}
	}
	
	public static int diagonalContains(int row, int col, char type){
		int count = 0;
		int max = matrix[0].length;
		if(matrix[row][col] == type)
			count++;
		
		int r1 = row;
		int c1 = col;
		for(;;){
			r1 += 1;
			c1 += 1;
			if(!(r1 == max || c1 == max)){
				if(matrix[r1][c1] == type)
					count++;
			}else{
				break;
			}
		}
		
		int r2 = row;
		int c2 = col;
		for(;;){
			r2 -= 1;
			c2 -= 1;
			if(!(r2 < 0 || c2 < 0)){
				if(matrix[r2][c2] == type)
					count++;
			}else{
				break;
			}
		}
		
		int r3 = row;
		int c3 = col;
		for(;;){
			r3 += 1;
			c3 -= 1;
			if(!(r3 == max || c3 < 0)){
				if(matrix[r3][c3] == type)
					count++;
			}else{
				break;
			}
		}
		
		int r4 = row;
		int c4 = col;
		for(;;){
			r4 -= 1;
			c4 += 1;
			if(!(r4 < 0 || c4 == max)){
				if(matrix[r4][c4] == type)
					count++;
			}else{
				break;
			}
		}
		
		return count;
	}
	
	public static int rowContains(int row, char type){
		int count = 0;
		for(int y = 0 ; y < matrix[0].length ; y++)
			if(matrix[row][y] == type)
				count++;
		
		return count;
	}
	
	public static int colContains(int col, char type){
		int count = 0;
		for(int x = 0 ; x < matrix[0].length ; x++)
			if(matrix[x][col] == type)
				count++;
		
		return count;
	}
	
	public static class Artist{
		public int row;
		public int col;
		public char type;
		public Artist(int x, int y, char type){
			this.row = x;
			this.col = y;
			this.type = type;
		}
	}
	
}
