package googlecodejam.barna.bathroomstalls;

import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;


public class BathroomStalls2 {
	private static final String INPUT_FILE_NAME = "data/BathroomStalls/C-small-1-attempt2.in";
	private static final String OUTPUT_FILE_NAME = "data/BathroomStalls/C-small-1-attempt2.out";

	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner(new File(INPUT_FILE_NAME));
		PrintWriter out = new PrintWriter(OUTPUT_FILE_NAME);

		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			int n = in.nextInt();
			int k = in.nextInt();
			String result = getCaseResult(n, k);
			out.println("Case #" + i + ": " + result);
			System.out.println("Case #" + i + ": " + result);
		}
		in.close();
		out.close();
	}

	private static String getCaseResult(int n, int k) throws Exception {
		Boolean[] stalls = new Boolean[n];
		Arrays.fill(stalls, Boolean.FALSE);
		
		//for each new person
		for(int i=0; i<k; i++) {
			List<Integer> emptyLefts = new ArrayList<>(n);
			List<Integer> emptyRights = new ArrayList<>(n);

			//for each potential stall
			for(int j=0; j<n; j++) {
				//if stall is empty
				if(!stalls[j]) {
					emptyLefts.add(j, getEmptyLefts(stalls, j));
					emptyRights.add(j, getEmptyRights(stalls, j));
				} else {
					emptyLefts.add(null);
					emptyRights.add(null);
				}
			}

			// farthest closest neighbors
			// use list to preserver order
			List<Integer> stallCandidates = new ArrayList<>();
			int max = 0;
			for(int j=0; j<n; j++) {
				if(stalls[j]) {
					continue;
				}
				int currentMax = Math.min(emptyLefts.get(j), emptyRights.get(j));
				if(currentMax>max) {
					stallCandidates.clear();
					stallCandidates.add(j);
					max = currentMax;
				} else if(currentMax==max) {
					stallCandidates.add(j);
				}
			}
			
			int stallIndexPicked;
			if(stallCandidates.size()==1) {
				stallIndexPicked = stallCandidates.iterator().next().intValue();
			} else {
				List<Integer> stallCandidates2 = new ArrayList<>();
				max = 0;
				for (Integer candidateIndex : stallCandidates) {
					int currentMax = Math.max(emptyLefts.get(candidateIndex), emptyRights.get(candidateIndex));
					if(currentMax>max) {
						stallCandidates2.clear();
						stallCandidates2.add(candidateIndex);
						max = currentMax;
					} else if(currentMax==max) {
						stallCandidates2.add(candidateIndex);
					}
				}
				stallIndexPicked = stallCandidates2.iterator().next().intValue();
			}
			
			stalls[stallIndexPicked] = Boolean.TRUE;
			//when we placed the last candidate
			if(i==k-1) {
				return Integer.toString(Math.max(emptyLefts.get(stallIndexPicked), emptyRights.get(stallIndexPicked))) +
						" " +
						Integer.toString(Math.min(emptyLefts.get(stallIndexPicked), emptyRights.get(stallIndexPicked)));
			}
		}
		throw new Exception("no stall found");
	}

	private static int getEmptyLefts(Boolean[] stalls, int stallIndex) {
		int i;
		for(i=stallIndex-1; i>=0 && !stalls[i]; i--);
		return stallIndex-(i+1);
	}
	
	private static int getEmptyRights(Boolean[] stalls, int stallIndex) {
		int i;
		for(i=stallIndex+1; i<stalls.length && !stalls[i]; i++);
		return (i-1)-stallIndex;
	}

}
