package googlecodejam.barna.qualification;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;


public class CruiseControl {
	private static final String INPUT_FILE_NAME = "data/Qualification/A-large.in";
	private static final String OUTPUT_FILE_NAME = "data/Qualification/A-large.out";

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(INPUT_FILE_NAME));
		PrintWriter out = new PrintWriter(OUTPUT_FILE_NAME);

		int t = in.nextInt();
		for (int j = 1; j <= t; j++) {
			long d = in.nextLong();
			int n = in.nextInt();
			long[] k = new long[n];
			long[] s = new long[n];
			
			for(int i=0; i<n; i++) {
				k[i] = in.nextLong();
				s[i] = in.nextLong();
			}
			
			String result = getCaseResult(n, d, k, s);
			out.println("Case #" + j + ": " + result);
			System.out.println("Case #" + j + ": " + result);
		}
		in.close();
		out.close();
	}

	private static String getCaseResult(int n, long d, long[] k, long[] s) {
		double maxHour = 0;
		for(int i=0; i<n; i++) {
			double time = 1d * (d-k[i]) / s[i];
			if(time>maxHour) {
				maxHour = time;
			}
		}
		return Double.toString(1d * d / maxHour);
	}

}
