package googlecodejam.barna.oversizedpancakeflipper;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;


public class OversizedPancakeFlipper {
	private static final String INPUT_FILE_NAME = "data/OversizedPancakeFlipper/A-large.in";
	private static final String OUTPUT_FILE_NAME = "data/OversizedPancakeFlipper/A-large.out";

	private static final String NO_RESULT = "IMPOSSIBLE";
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(INPUT_FILE_NAME));
		PrintWriter out = new PrintWriter(OUTPUT_FILE_NAME);

		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			String pancake = in.next("[-+]+");
			int k = in.nextInt();
			
			String result = getCaseResult(pancake, k);
			
			out.println("Case #" + i + ": " + result);
			System.out.println("Case #" + i + ": " + result);
		}
		in.close();
		out.close();
	}

	private static String getCaseResult(String pancake, int flipperLength) {
		StringBuilder pan = new StringBuilder(pancake);
		Integer moves = getCaseResultInner(pan, 0, flipperLength);
		return moves==null ? NO_RESULT : moves.toString();
	}
	
	private static Integer getCaseResultInner(StringBuilder pan, int startIndex, int flipperLength) {
		int nextWrongIndex = pan.indexOf("-", startIndex);
		if(nextWrongIndex==-1) {
			return 0;
		}
		
		if(pan.length()-startIndex < flipperLength) {
			return null;
		}

		if(nextWrongIndex==startIndex) {
			flip(pan, startIndex, flipperLength);
			Integer subResult =  getCaseResultInner(pan, nextWrongIndex+1, flipperLength);
			return subResult==null ? null : subResult + 1;
		} else {
			return getCaseResultInner(pan, nextWrongIndex, flipperLength);
		}
	}
	
	private static void flip(StringBuilder pan, int startIndex, int flipperLength) {
		for(int i=startIndex; i<startIndex+flipperLength; i++) {
			if(pan.charAt(i)=='-') {
				pan.setCharAt(i, '+');
			} else {
				pan.setCharAt(i, '-');
			}
		}
	}

}
