package googlecodejam.barna.tidynumbers;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class TidyNumbers {
	private static final String INPUT_FILE_NAME = "data/TidyNumbers/B-large.in";
	private static final String OUTPUT_FILE_NAME = "data/TidyNumbers/B-large.out";

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(INPUT_FILE_NAME));
		PrintWriter out = new PrintWriter(OUTPUT_FILE_NAME);

		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			long n = in.nextLong();
			out.println("Case #" + i + ": " + getCaseResult(n));
			System.out.println("Case #" + i + ": " + getCaseResult(n));
		}
		in.close();
		out.close();
	}

	private static String getCaseResult(long input) {
		for(long i=input; i>0; i=getCandidate(i)) {
			if(isTidy(i)) {
				return Long.toString(i);
			}
		}
		return "0";
	}

	private static boolean isTidy(long number) {
		do {
			byte lastDigit = (byte) (number % 10);
			number = number / 10;
			byte digit = (byte) (number % 10);
			if (digit > lastDigit) {
				return false;
			}
		} while (number > 0);
		return true;
	}

	private static long getCandidate(long number) {
		if(number<10) {
			return number;
		}

		char[] digits = Long.toString(number).toCharArray();
		char lastDigit=digits[0];
		for(int i=1; i<digits.length; i++) {
			if(digits[i]<lastDigit) {
				Arrays.fill(digits, i, digits.length-1, '0');
				return Long.valueOf(new String(digits)) - 1;
			}
			lastDigit=digits[i];
		}
		
		return number;
	}
}
