package googlecodejam.barna.bathroomstalls;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;


public class BathroomStalls {
	private static final String INPUT_FILE_NAME = "data/BathroomStalls/C-small-2-attempt1.in";
	private static final String OUTPUT_FILE_NAME = "data/BathroomStalls/C-small-2-attempt1.out";

	public static void main(String[] args) throws FileNotFoundException {
		Scanner in = new Scanner(new File(INPUT_FILE_NAME));
		PrintWriter out = new PrintWriter(OUTPUT_FILE_NAME);

		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			long n = in.nextLong();
			long k = in.nextLong();
			String result = getCaseResult(n, k);
			out.println("Case #" + i + ": " + result);
			System.out.println("Case #" + i + ": " + result);
		}
		in.close();
		out.close();
	}

	private static String getCaseResult(long n, long k) {
		Long[] results = getCaseResultInner(n, k);
		return results[0] + " " +  results[1];
	}
	
	private static Long[] getCaseResultInner(long n, long k) {
		// the next person will occupy one stall in middle
		// if there are 2 middle one, then the leftmost
		long ls = (n-1) / 2;
		long rs = n-1-ls;

		if(k==1) {
			// if it was the last person
			return new Long[]{new Long(Math.max(ls, rs)), new Long(Math.min(ls, rs))};
		} else if (k==2) {
			// one more left, so fit that to the right stalls
			return getCaseResultInner(rs, 1);
		} else {
			// the rs can be bigger than ls with 1
			// same or or one more person will go to the right
			Long[] lres = getCaseResultInner(ls, (k-1)/2);
			Long[] rres = getCaseResultInner(rs,  k/2);

			if(lres[1] < rres[1]) {
				return lres;
			} else if(lres[1].equals(rres[1])) {
				if(lres[0] <= rres[0]) {
					return lres;
				} else {
					return rres;
				}
			} else {
				return rres;
			}
		}
	}
}
