

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Universe {
	
	static int n, m;
	static String []names;
	static String [] query;
	//DP answer[i][j] shows what is the answer if we're currently using
	// i-th engine and we have to process query j.
	static int answer[][];
	static boolean calc[][];
	
	static int solve(int i, int j){
		if(calc[i][j])
			return answer[i][j];
		calc[i][j] = true;
		int k = j;
		while(k < m && !query[k].equals(names[i])){
			++k;
		}
		if(k == m){
			answer[i][j] = 0;
			return 0;
		}
		int min = Integer.MAX_VALUE;
		for(int ii = 0;ii < n;ii++){
			if(!names[ii].equals(query[k])){
				min = Math.min(min, solve(ii, k));
			}
		}
		answer[i][j] = min + 1;
		return answer[i][j];
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(new File("D:\\A.in")));
		FileWriter out = new FileWriter(new File("d:\\A.out"));
		int tests = Integer.parseInt(in.readLine());
		for(int nTest = 0;nTest < tests;nTest++){
			n = Integer.parseInt(in.readLine());
			names = new String[n];
			for(int i = 0;i < n;i++){
				names[i] = in.readLine();
			}
			m = Integer.parseInt(in.readLine());	
			query = new String[m];
			for(int i = 0;i < m;i++){
				query[i] = in.readLine();
			}
			calc = new boolean [n][m];
			answer = new int[n][m];
			int min = Integer.MAX_VALUE;
			if(m == 0){
				out.write("Case #" + (nTest+1) + ": " + 0 + "\n");
				continue;
			}
			for(int i = 0;i < n;i++){
				if(!query[0].equals(names[i])){
					min = Math.min(min, solve(i, 0));
				}
			}
			out.write("Case #" + (nTest+1) + ": " + min + "\n");
		}
		out.flush();
		out.close();
	}
	
}
