
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.PriorityQueue;
import java.util.Set;
import java.util.TreeSet;

import javax.swing.plaf.multi.MultiSeparatorUI;

public class Train {
	
	static Trip[] trips;

	static class Trip implements Comparable{
		int start, end;
		boolean startsA;
		
		Trip(int s, int e, boolean b){
			start = s;
			end = e;
			startsA = b;
		}
		public int compareTo(Object arg0) {
			Trip other = (Trip) arg0;
			return start - other.start;
		}
		
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(new File("D:\\B.in")));
		FileWriter out = new FileWriter(new File("d:\\B.out"));
		int tests = Integer.parseInt(in.readLine());
		for(int nTest = 0;nTest < tests;nTest++){
			int t = Integer.parseInt(in.readLine());
			String line = in.readLine();
			String numbers [] = line.split(" ");
			int na = Integer.parseInt(numbers[0].trim());
			int nb = Integer.parseInt(numbers[1].trim());
			trips = new Trip[na + nb];
			for(int i = 0;i < na;i++){
				line = in.readLine();
				String time[] = line.split(" ");
				trips[i] = new Trip(getTime(time[0]), getTime(time[1]), true);
			}
			for(int i = 0;i < nb;i++){
				line = in.readLine();
				String time[] = line.split(" ");
				trips[na + i] = new Trip(getTime(time[0]), getTime(time[1]), false);
			}
			int ansA = 0;
			int ansB = 0;
			Arrays.sort(trips);
			//TreeSet<Integer> availableTrainsA = new TreeSet<Integer>();
			//TreeSet<Integer> availableTrainsB = new TreeSet<Integer>();
			PriorityQueue<Integer> availableTrainsA = new PriorityQueue<Integer>();
			PriorityQueue<Integer> availableTrainsB = new PriorityQueue<Integer>();
			for(int i = 0;i < trips.length;i++){
				if(trips[i].startsA){
					int least = (availableTrainsA.isEmpty())? Integer.MAX_VALUE: availableTrainsA.element();
					if(least > trips[i].start){
						++ansA;
					}else{
						availableTrainsA.poll();
					}
					availableTrainsB.add(trips[i].end + t);
				}else{
					int least = (availableTrainsB.isEmpty())? Integer.MAX_VALUE: availableTrainsB.element();
					if(least > trips[i].start){
						++ansB;
					}else{
						availableTrainsB.poll();
					}
					availableTrainsA.add(trips[i].end + t);
				}
			}
			out.write("Case #" + (nTest+1) + ": " + ansA + " " + ansB + "\n");
		}
		out.flush();
		out.close();
	}
	
	//converts from format HH:MM to minutes from 00:00
	private static int getTime(String string) {
		String []str = string.split(":");
		int ret =  0;
		ret += Integer.parseInt(str[0])*60 + Integer.parseInt(str[1]);
		return ret;
	}
	
}
