/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

import java.io.BufferedReader;
import java.io.FileReader;

import javax.swing.JOptionPane;

/**
 *
 * @author steven
 */
public class Controlador {

	private int cantidadDeCasos; //N
	private int longitudPalabras; //L
	private int cantidadPalabrasLenguaje; //D
	private String lineaAProcesar;
	private String palabrasLenguaje[];
	private String vectorPatron[];

    String nombreEntrada; //Input
    String SALIDA = "Output.txt";
    ManejadorArchivos manejadorDeArchivos;
    String resultados[];

    public Controlador(String nombreArchivo) {
    	this.lineaAProcesar = "";
        this.nombreEntrada = nombreArchivo;
        this.manejadorDeArchivos = new ManejadorArchivos();
    }//Fin del método constructor

    public void imprimirResultado() {
        String resultado = "";
        this.manejadorDeArchivos.crearArchivo(SALIDA);
        for (int i = 0; i < resultados.length; i++) {
            resultado += resultados[i] + "\n";
            this.manejadorDeArchivos.agregarPalabraArchivo(resultados[i], SALIDA);
        }//Fin del for
        JOptionPane.showMessageDialog(null, resultado, "Output", JOptionPane.INFORMATION_MESSAGE);
    }//Fin del método imprimirResultado

    public void resolverProblema() {

        int caso = 0;

        if (this.nombreEntrada.isEmpty() == false) {
            String longitudPalabrasLenguaje = this.manejadorDeArchivos.obtenerPrimeraPalabraArchivo(this.nombreEntrada);
            String cantidadPalabrasLenguaje = this.manejadorDeArchivos.obtenerSiguientePalabraArchivo();
            String casos = this.manejadorDeArchivos.obtenerSiguientePalabraArchivo();


            if (casos.matches("[0-9]*") && longitudPalabrasLenguaje.matches("[0-9]*") && cantidadPalabrasLenguaje.matches("[0-9]*")) {
                this.cantidadDeCasos = Integer.parseInt(casos);
                this.cantidadPalabrasLenguaje = Integer.parseInt(cantidadPalabrasLenguaje);
                this.longitudPalabras = Integer.parseInt(longitudPalabrasLenguaje);
                this.resultados = new String[this.cantidadDeCasos];
                this.palabrasLenguaje = new String[this.cantidadPalabrasLenguaje];

                try {
                	BufferedReader reader = new BufferedReader(new FileReader(this.nombreEntrada));

                	if(this.cantidadDeCasos > 0){
                       this.lineaAProcesar = this.manejadorDeArchivos.obtenerLineaArchivo(reader);

                       for(int i = 0; i < this.cantidadPalabrasLenguaje; i++){
                    	   this.palabrasLenguaje[i] = this.manejadorDeArchivos.obtenerLineaArchivo(reader);
                       }//Fin del for

                       while (this.cantidadDeCasos > 0) {
			                    this.lineaAProcesar = this.manejadorDeArchivos.obtenerLineaArchivo(reader);
			                    long cantidadPatrones = this.buscarCantidadPatrones(this.lineaAProcesar);
			                    String resultadoString = Long.toString(cantidadPatrones);
			                    this.resultados[caso] = "";
			                    this.resultados[caso] += "Case #" + (caso + 1) + ": " + resultadoString;
			                    this.cantidadDeCasos--;
			                    caso++;
		                }//Fin del while
	                }//Fin del if
	                reader.close();
                }//Fin del try
                catch (Exception e) {
                    JOptionPane.showMessageDialog(null, "El archivo no existe " + e, "ERROR", JOptionPane.ERROR_MESSAGE);
                }//Fin del catch
                this.imprimirResultado();
            }//Fin del if
            else {
                JOptionPane.showMessageDialog(null, "Error to read the input file", "ERROR", JOptionPane.ERROR_MESSAGE);
            }//Fin del else
        }//Fin del if
    }//Fin del método resolverProblema

    public long buscarCantidadPatrones(String linea) {
        long resultado = 0;
        this.llenarVectorPatron(linea);
        resultado = this.obtenerCombinaciones();
        return resultado;
    }//Fin del mtodo buscarAparaciones

    public long obtenerCombinaciones(){
    	long resultado = 0;
    	for(int i = 0; i < this.cantidadPalabrasLenguaje; i++){
    		long resultadoParcial = 0;
    		boolean resultadoCorrecto = true;

    		for(int k = 0; k < this.longitudPalabras; k++){
    			String letraPalabraAlien = String.valueOf(this.palabrasLenguaje[i].charAt(k));
    			if(this.vectorPatron[k].contains(letraPalabraAlien)){
    				resultadoParcial = 1;
    			}//Fin del if
    			else{
    				k = this.longitudPalabras;
    				resultadoCorrecto = false;
    			}//Fin del else
    		}//Fin del for
    		if(resultadoCorrecto == true){
    			resultado += resultadoParcial;
    		}//Fin el if
    	}//Fin del for
    	return resultado;
    }//Fin del mtodo obtenerCombinaciones

    public void llenarVectorPatron(String hilera) {

    	String lineaOriginal = hilera;
    	this.vectorPatron = new String[this.longitudPalabras];
    	int contador = 0;

    	for(int i = 0; i < this.longitudPalabras; i++){
    		String letra = String.valueOf(lineaOriginal.charAt(contador));
    		this.vectorPatron[i] = "";
    		if(letra.compareTo("(") == 0){
    			contador++;
    			letra = String.valueOf(lineaOriginal.charAt(contador));
    			while(letra.compareTo(")")!= 0){
    				this.vectorPatron[i] += letra;
    				contador++;
    				letra = String.valueOf(lineaOriginal.charAt(contador));
    			}//Fin del while
    			contador++;
	    	}//Fin del if
    		else{
    			this.vectorPatron[i] += letra;
    			contador++;
    		}//Fin del else
    	}//Fin del for
    }//Fin del mtodo llenarVectorPatron

    public static void main(String[] args) {
        String nombreArchivo = JOptionPane.showInputDialog(null, "Input the path of archive to scan", "Name of input", JOptionPane.INFORMATION_MESSAGE);
        if (nombreArchivo != null) {
            Controlador controlador = new Controlador(nombreArchivo);
            controlador.resolverProblema();
        }//Fin del if
        else {
            JOptionPane.showMessageDialog(null, "Error to read the input file", "ERROR", JOptionPane.ERROR_MESSAGE);
        }//Fin del else
        System.exit(0);
    }//Fin del main
}//Fin de la clase Controlador
