package themepark;

import javax.swing.*;

public class ThemePark {

    int cantidadDeCasos; //N
    String nombreEntrada; //Input
    ManejadorArchivos manejadorDeArchivos;
    String resultados[];
    String SALIDA = "Output.txt";
    int cantidadGrupos;
    int cantidadVueltas;
    int capacidad;
    StringBuffer colaPasajeros;

    public ThemePark(String nombreArchivo) {
        this.nombreEntrada = nombreArchivo;
        this.manejadorDeArchivos = new ManejadorArchivos();
        this.colaPasajeros = new StringBuffer();
    }//Fin del método constructor

    public void resolverProblema() {

        int caso = 0;

        if (this.nombreEntrada.isEmpty() == false) {
            String casos = this.manejadorDeArchivos.obtenerPrimeraPalabraArchivo(this.nombreEntrada);
            if (casos.matches("[0-9]*")) {
                this.cantidadDeCasos = Integer.parseInt(casos);
                this.resultados = new String[this.cantidadDeCasos];
                while (this.cantidadDeCasos > 0) {
                    int euros = this.resolverThemePark();
                    this.resultados[caso] = "";
                    this.resultados[caso] += "Case #" + (caso + 1) + ": " + euros;
                    this.cantidadDeCasos--;
                    caso++;
                }//Fin del while
                this.imprimirResultado();
            }//Fin del if
            else {
                JOptionPane.showMessageDialog(null, "Error to read the input file", "ERROR", JOptionPane.ERROR_MESSAGE);
            }//Fin del else
        }//Fin del if
    }//Fin del mtodo resolverProblema

    public void imprimirResultado() {
        this.manejadorDeArchivos.crearArchivo(SALIDA);
        for (int i = 0; i < resultados.length; i++) {
            this.manejadorDeArchivos.agregarPalabraArchivo(resultados[i], SALIDA);
        }//Fin del for
    }//Fin del método imprimirResultado

    public int resolverThemePark() {

        String entrada = this.manejadorDeArchivos.obtenerSiguientePalabraArchivo();
        String datos[] = entrada.split(" ");

        this.cantidadVueltas = Integer.parseInt(datos[0]);
        this.capacidad = Integer.parseInt(datos[1]);
        this.cantidadGrupos = Integer.parseInt(datos[2]);
        this.colaPasajeros = new StringBuffer();
        int euros = 0;

        entrada = this.manejadorDeArchivos.obtenerSiguientePalabraArchivo();
        datos = entrada.split(" ");

        for (int i = 0; i < this.cantidadGrupos; i++) {
            this.colaPasajeros.append(datos[i] + " ");
        }//Fin del for
        this.colaPasajeros = this.colaPasajeros.deleteCharAt(this.colaPasajeros.length() - 1);
        //System.out.println(this.colaPasajeros);
        for (int i = 0; i < this.cantidadVueltas; i++) {

            boolean continuar = true;
            int capacidadActual = this.capacidad;
            int gruposAbordo = 0;

            while (continuar) {
                int grupo = 0;
                boolean es10 = false;

                if (this.colaPasajeros.length() > 1) {
                    if (this.colaPasajeros.charAt(1) != ' ') {
                        es10 = true;
                        grupo = Integer.parseInt(this.colaPasajeros.substring(0, 2));
                    }//Fin del if
                    else {
                        grupo = Integer.parseInt(this.colaPasajeros.substring(0, 1));
                    }//Fin del else
                }//Fin del if
                else {
                    grupo = Integer.parseInt(this.colaPasajeros.substring(0, 1));
                }//Fin del else

                if (capacidadActual >= grupo && gruposAbordo != this.cantidadGrupos) {
                    capacidadActual -= grupo;
                    euros += grupo;
                    if (es10) {
                        this.colaPasajeros = this.colaPasajeros.delete(0, 3);
                    }//Fin del if
                    else {
                        this.colaPasajeros = this.colaPasajeros.delete(0, 2);
                    }//Fin del else
                    //System.out.println(this.colaPasajeros);
                    if (this.colaPasajeros.length() > 1 || this.cantidadGrupos == 2) {
                        this.colaPasajeros.append(" " + grupo);
                    }//Fin del if
                    else{
                        this.colaPasajeros.append(grupo);
                    }//Fin del else
                    //System.out.println(this.colaPasajeros);
                    if (capacidadActual == 0) {
                        continuar = false;
                    }//Fin del if
                    gruposAbordo++;
                }//Fin del if
                else {
                    continuar = false;
                }//Fin del else
            }//Fin del while
        }//Fin del for
        //System.out.println(euros);
        return euros;
    }//Fin del mtodo resolverSnapperChain

    public static void main(String[] args) {
        String nombreArchivo = JOptionPane.showInputDialog(null, "Input the path of archive to scan", "Name of input", JOptionPane.INFORMATION_MESSAGE);
        if (nombreArchivo != null) {
            ThemePark controlador = new ThemePark(nombreArchivo);
            controlador.resolverProblema();
        }//Fin del if
        else {
            JOptionPane.showMessageDialog(null, "Error to read the input file", "ERROR", JOptionPane.ERROR_MESSAGE);
        }//Fin del else
        System.exit(0);
    }//Fin del main
}//Fin de la clase ThemePark