package snapperchain;

import javax.swing.*;

public class SnapperChain {

    int cantidadDeCasos; //N
    String nombreEntrada; //Input
    ManejadorArchivos manejadorDeArchivos;
    String resultados[];
    String SALIDA = "Output.txt";
    int cantidadSnapper;
    int cantidadChasquidos;


    public SnapperChain(String nombreArchivo) {
        this.nombreEntrada = nombreArchivo;
        this.manejadorDeArchivos = new ManejadorArchivos();
    }//Fin del método constructor

    public void resolverProblema() {

        int caso = 0;

        if (this.nombreEntrada.isEmpty() == false) {
            String casos = this.manejadorDeArchivos.obtenerPrimeraPalabraArchivo(this.nombreEntrada);
            if (casos.matches("[0-9]*")) {
                this.cantidadDeCasos = Integer.parseInt(casos);
                this.resultados = new String[this.cantidadDeCasos];
                while (this.cantidadDeCasos > 0) {
                    String estadoLuz = this.resolverSnapperChain();
                    this.resultados[caso] = "";
                    this.resultados[caso] += "Case #" + (caso + 1) + ": " + estadoLuz;
                    this.cantidadDeCasos--;
                    caso++;
                }//Fin del while
                this.imprimirResultado();
            }//Fin del if
            else {
                JOptionPane.showMessageDialog(null, "Error to read the input file", "ERROR", JOptionPane.ERROR_MESSAGE);
            }//Fin del else
        }//Fin del if
    }//Fin del mtodo resolverProblema

    public void imprimirResultado() {
        String resultado = "";
        this.manejadorDeArchivos.crearArchivo(SALIDA);
        for (int i = 0; i < resultados.length; i++) {
            resultado += resultados[i] + "\n";
            this.manejadorDeArchivos.agregarPalabraArchivo(resultados[i], SALIDA);
        }//Fin del for
        //JOptionPane.showMessageDialog(null, resultado, "Output", JOptionPane.INFORMATION_MESSAGE);
    }//Fin del método imprimirResultado

    public String resolverSnapperChain() {

        String entrada = this.manejadorDeArchivos.obtenerSiguientePalabraArchivo();
        String datos[] = entrada.split(" ");

        this.cantidadSnapper = Integer.parseInt(datos[0]);
        this.cantidadChasquidos = Integer.parseInt(datos[1]);

        int cantidadEstados = 2;
        int matrizEstados[][] = new int[cantidadEstados][cantidadSnapper];
        matrizEstados[0][0] = 1; //Electricidad

        for (int i = 0; i < cantidadChasquidos; i++) {
            
            for (int k = 0; k < cantidadSnapper; k++) {
                if (matrizEstados[0][k] == 1) {
                    if (matrizEstados[1][k] == 0) {
                        matrizEstados[1][k] = 1;
                    }//Fin del if
                    else {
                        matrizEstados[1][k] = 0;
                    }//Fin del else
                }//Fin del if
            }//Fin del for

            for (int k = 0; k < cantidadSnapper; k++) {
                 if (matrizEstados[1][k] == 1 && matrizEstados[0][k] == 1){
                    if (k < (matrizEstados[0].length - 1)) {
                        matrizEstados[0][k + 1] = 1;
                    }//Fin del if
                 }//Fin del if
                 else{
                    if (k < (matrizEstados[0].length - 1)) {
                        matrizEstados[0][k + 1] = 0;
                    }//Fin del if
                 }//Fin del else
            }//Fin del for
        }//Fin del for

        String resultado = "OFF";
        int totalElectricidad = 0;
        int totalEncendidos = 0;

        for (int k = 0; k < cantidadSnapper; k++) {
            totalElectricidad += matrizEstados[0][k];
            totalEncendidos += matrizEstados[1][k];
        }//Fin del for

        if (totalElectricidad == matrizEstados[0].length && totalEncendidos == matrizEstados[0].length) {
            resultado = "ON";
        }//Fin del if
        return resultado;
    }//Fin del mtodo resolverSnapperChain

    public static void main(String[] args) {
        String nombreArchivo = JOptionPane.showInputDialog(null, "Input the path of archive to scan", "Name of input", JOptionPane.INFORMATION_MESSAGE);
        if (nombreArchivo != null) {
            SnapperChain controlador = new SnapperChain(nombreArchivo);
            controlador.resolverProblema();
        }//Fin del if
        else {
            JOptionPane.showMessageDialog(null, "Error to read the input file", "ERROR", JOptionPane.ERROR_MESSAGE);
        }//Fin del else
        System.exit(0);
    }//Fin del main
}//Fin de la clase SnapperChain

