
package codejam.util;

public interface Matrix<E> {
    
    static int NORTHWEST = 8;
    static int NORTHEAST = 7;
    static int SOUTHWEST = 6;
    static int SOUTHEAST = 5;
    static int NORTH = 4;
    static int WEST = 3;
    static int EAST = 2;
    static int SOUTH = 1;
    
    
    int cols();
    
    int rows();
    
    E valueAt(int col, int row);
    
    void setValueAt(int col, int row, E value);
    
    E valueAt(int index);
    
    boolean hasNeighbour(int col, int row, int direction);
    
    E neighbour(int col, int row, int direction);
    
    int indexAfterMove(int col, int row, int direction);
    
    Point positionAfterMove(int col, int row, int direction);
    
}
