
package codejam.util;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 *
 * @author fwallenius
 */
public abstract class AbstractSolution implements Solver {
    
    private final BufferedReader reader;

    public AbstractSolution() {
        this.reader = new BufferedReader(new InputStreamReader(System.in));
    }
    
    protected String readLine() {
        try {
            return reader.readLine();
        } catch (IOException ex) {
            throw new RuntimeException(ex);
        }
    }
    
    protected Integer[] readIntegerArrayFromStdin() {
        String[] inputs = this.readLine().split(" ");
        Integer[] result = new Integer[inputs.length];
        
        for (int i = 0; i < inputs.length; i++) {
            result[i] = Integer.parseInt(inputs[i], 10);
        }
        
        return result;
    }
    
    protected String prettyPrintArray(Object[] objs) {
        StringBuilder sb = new StringBuilder("[");
        for (int i = 0; i < objs.length; i++) {
            sb.append(objs[i]);
            if (i < objs.length -1 ) {
                sb.append(", ");
            }
        }
        sb.append("]");
        return sb.toString();
    }
    
}
