package codejam;

import codejam.util.AbstractSolution;
import codejam.util.DefaultMatrix;
import codejam.util.Matrix;
import java.util.ArrayList;
import java.util.List;

/**
 *
 * @author fwallenius
 */
public class MagicTrick extends AbstractSolution {

    @Override
    public void run() {
        Integer amount = Integer.parseInt(this.readLine(), 10);
        for (int i = 0; i < amount; i++) {            
            
            Integer firstChoice = Integer.parseInt(this.readLine(), 10);
            Matrix<Integer> firstMatrix = this.readMatrix(4);
            
            Integer secondChoice = Integer.parseInt(this.readLine(), 10);
            Matrix<Integer> secondMatrix = this.readMatrix(4);
            
            
            String solution = this.solve(firstChoice, firstMatrix, secondChoice, secondMatrix);
            System.out.println("Case #" + (i+1) + ": " + solution);
        }
    }

    private Matrix<Integer> readMatrix(int amount) {
        Integer[] numbers = new Integer[amount * amount];
        Integer current = 0;
        for (int i = 0; i < amount; i++) {
            Integer[] line = this.readIntegerArrayFromStdin();
            for (Integer one : line) {
                numbers[current] = one;
                current += 1;
            }
        }
        
        return new DefaultMatrix<>(amount, amount, numbers);
    }

    private String solve(Integer firstChoice, Matrix<Integer> firstMatrix, Integer secondChoice, Matrix<Integer> secondMatrix) {
        
        List<Integer> commonsCards = this.findCommonFrom(this.pickFromLine(firstChoice, firstMatrix), this.pickFromLine(secondChoice, secondMatrix));
        
        if (commonsCards.isEmpty()) {
            return "Volunteer cheated!";
        }
        if (commonsCards.size() > 1) {
            return "Bad magician!";
        }
        
        return commonsCards.get(0).toString();
    }
    
    private List<Integer> findCommonFrom(List<Integer> lineA, List<Integer> lineB) {
        
        List<Integer> result = new ArrayList<>();
        
        for (Integer card : lineA) {
            if (lineB.indexOf(card) > -1) {
                result.add(card);
            }
        }
        
//        System.out.println("Common: " + result);
        
        return result;
    }
    
    private List<Integer> pickFromLine(int row, Matrix<Integer> matrix) {
        
        List<Integer> result = new ArrayList<>();
        
        int startIndex = (matrix.cols() * (row - 1));
        for (int index = startIndex; index < (startIndex + matrix.cols()); index++) {
            result.add(matrix.valueAt(index));
        }
        
        return result;
        
    }

}
