package round1B;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class StableNeighbors {

	public static final String IMPOSSIBLE = "IMPOSSIBLE";

	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream(new File("input/B-small-attempt1.in")));
			System.setOut(new PrintStream(new File("output/output.txt")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		solveProblem();
	}

	public static void solveProblem() {
		Scanner s = new Scanner(System.in);
		int T = Integer.parseInt(s.nextLine());

		for (int i = 1; i <= T; i++) {
			String problem = s.nextLine();
			String solution = solve(problem);
			if (solution != IMPOSSIBLE) {
				for (int j = 0; j < solution.length(); j++) {
					if (!canBeInThisOrder(solution.charAt(j), solution.charAt((j+1)%solution.length()))) {
						System.out.println("Falsch! j = " + j);
						break;
					}
				}
			}
			System.out.println("Case #" + i + ": " + solution);
		}

		s.close();
	}

	public static String solve(String problem) {
		String[] splitProblem = problem.split(" ");

		int n = Integer.parseInt(splitProblem[0]);
		int N = n;
		int R = Integer.parseInt(splitProblem[1]);
		int O = Integer.parseInt(splitProblem[2]);
		int Y = Integer.parseInt(splitProblem[3]);
		int G = Integer.parseInt(splitProblem[4]);
		int B = Integer.parseInt(splitProblem[5]);
		int V = Integer.parseInt(splitProblem[6]);

		int[] BRY = { B, R, Y };
		String[] BRYmarks = { "B", "R", "Y" };

		int[] OGV = { O, G, V };
		String[] OGVmarks = { "O", "G", "V" };

		String solution = "";
		int x = 0;
		while (!empty(OGV)) {
			if (OGV[x] == 0) {
				x = x + 1;
				continue;
			}
			// 1
			if (!solution.endsWith(BRYmarks[x])) {
				solution += BRYmarks[x];
				BRY[x]--;
				if (BRY[x] < 0) {
					return IMPOSSIBLE;
				}
				n--;
			}
			// 2
			solution += OGVmarks[x];
			OGV[x]--;
			n--;
			// 3
			if (BRY[x] > 0) {
				solution += BRYmarks[x];
				BRY[x]--;
				n--;
			} else {
				if (n != 0) {
					return IMPOSSIBLE;
				}
			}
		}
		while (n > 0) {
			int i = getMax(BRY);
			if (!solution.endsWith(BRYmarks[i])) {
				solution += BRYmarks[i];
				BRY[i] = BRY[i] - 1;
				n = n - 1;
			} else {
				i = getMax(BRY, i);
				solution += BRYmarks[i];
				BRY[i] = BRY[i] - 1;
				n = n - 1;
			}
		}

		if (solution.charAt(0) == solution.charAt(solution.length() - 1)) {
			for (int j = N - 2; j > 1; j--) {
				solution = swap(solution, j, j + 1);
				if (solution.charAt(0) == solution.charAt(solution.length() - 1)) {
					break;
				}
				if (canBeInThisOrder(solution.charAt(j - 1), solution.charAt(j))
						&& canBeInThisOrder(solution.charAt(j), solution.charAt(j + 1))) {
					return solution;
				}
			}
			return IMPOSSIBLE;
		}

		return solution;
	}

	public static boolean empty(int[] a) {
		return a[0] == 0 && a[1] == 0 && a[2] == 0;
	}

	public static int getMax(int[] a) {
		if (a[1] > a[0]) {
			if (a[2] > a[1]) {
				return 2;
			} else {
				return 1;
			}
		} else {
			if (a[2] > a[0]) {
				return 2;
			} else {
				return 0;
			}
		}
	}

	public static int getMax(int[] a, int not) {
		int x = (not + 1) % 3;
		int y = (not + 2) % 3;
		if (a[x] > a[y]) {
			return x;
		} else {
			return y;
		}
	}

	public static String swap(String s, int a, int b) {
		String start = s.substring(0, a);
		String end = s.substring(b + 1);
		return start + s.charAt(b) + s.charAt(a) + end;
	}

	public static boolean canBeInThisOrder(char a, char b) {
		if (a == 'O')
			return b == 'B';
		if (a == 'G')
			return b == 'R';
		if (a == 'V')
			return b == 'Y';
		if (b == 'O')
			return a == 'B';
		if (b == 'G')
			return a == 'R';
		if (b == 'V')
			return a == 'Y';
		return a != b;
	}

}
