package qualificationround;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class BathroomStalls {

	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream(new File("input/C-large.in")));
			System.setOut(new PrintStream(new File("output/output.txt")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		solveProblem();
	}
	
	public static void solveProblem(){
		Scanner s = new Scanner(System.in);
		int T = Integer.parseInt(s.nextLine());
		
		for(int i = 1; i <= T; i++){
			String problem = s.nextLine();
			String solution = solve(problem);
			System.out.println("Case #"+i+": "+solution);
		}
		
		s.close();
	}

	public static String solve(String problem){
		String[] parts = problem.split(" ");
		long stalls = Long.parseLong(parts[0]);
		long users = Long.parseLong(parts[1]);
		long left = stalls;
		while(users >= 1){
			left = (stalls - 1) / 2;
			stalls = stalls / 2;
			if((users & 1) == 1){
				long tmp = left;
				left = stalls;
				stalls = tmp;
			}
			users = users / 2;
		}
		return Math.max(stalls, left) + " " + Math.min(stalls, left);
	}
	
}
