package qualificationround;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class OversizedPancakeFlipper {

	public static void main(String[] args) {
		try {
			System.setIn(new FileInputStream(new File("input/A-large.in")));
			System.setOut(new PrintStream(new File("output/output.txt")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		solveProblem();
	}
	
	public static void solveProblem(){
		Scanner s = new Scanner(System.in);
		int T = Integer.parseInt(s.nextLine());
		
		for(int i = 1; i <= T; i++){
			String problem = s.nextLine();
			String solution = solve(problem);
			System.out.println("Case #"+i+": "+solution);
		}
		
		s.close();
	}

	public static String solve(String problem){
		int solution = 0;
		String []parts = problem.split(" ");
		String pancakesString = parts[0];
		int pfSize = Integer.parseInt(parts[1]);
		int pCount = pancakesString.length();
		int maxFlips = pCount - pfSize + 1;
		boolean[] pancakes = new boolean[pCount];
		
		for(int i = 0; i < pCount; i++){
			if(pancakesString.charAt(i) == '+'){
				pancakes[i] = true;
			}else{
				pancakes[i] = false;
			}
		}
		
		for(int i = 0; i < maxFlips; i++){
			if(!pancakes[i]){
				for(int j = i; j < i + pfSize; j++){
					pancakes[j] = !pancakes[j];
				}
				solution++;
			}
		}
		
		for(int i = maxFlips; i < pancakes.length; i++){
			if(!pancakes[i]){
				return "IMPOSSIBLE";
			}
		}
		
		return solution + "";
	}
	
}
