import java.io.PrintWriter;
import java.util.*;

public class PancakeFlipper {

    private static int flipperSize;
    private static final LinkedHashSet<PancakesWithFlipCount> toCheck = new LinkedHashSet<>();
    private static final Set<String> checked = new HashSet<>();

    public static void main(String[] args) {
        try (
                final Scanner scanner = new Scanner(System.in);
                final PrintWriter writer = new PrintWriter(System.out)
        ) {
            final int t = scanner.nextInt();
            scanner.nextLine();
            for (int tt = 0; tt < t; tt++) {
                final String line = scanner.nextLine();
                final int spaceIndex = line.indexOf(' ');
                final String pancakes = line.substring(0, spaceIndex);
                flipperSize = Integer.parseInt(line.substring(spaceIndex + 1));

                toCheck.clear();
                checked.clear();
                final int minFlipsCount = getMinFlipsCount(pancakes);
                if (minFlipsCount != Integer.MAX_VALUE) {
                    writer.print("Case #" + (tt + 1) + ": " + minFlipsCount + "\n");
                } else {
                    writer.print("Case #" + (tt + 1) + ": IMPOSSIBLE\n");
                }
            }
        }
    }

    private static int getMinFlipsCount(String pancakes) {
        toCheck.add(new PancakesWithFlipCount(pancakes, 0));
        return getMinFlipsCount();
    }

    private static int getMinFlipsCount() {
        if (toCheck.isEmpty()) {
            return Integer.MAX_VALUE;
        }

        PancakesWithFlipCount pancakesWithFlipCount = toCheck.iterator().next();
        toCheck.remove(pancakesWithFlipCount);
        final String pancakes = pancakesWithFlipCount.pancakes;
        final int flipsCount = pancakesWithFlipCount.flipCount;
        if (isFlipped(pancakesWithFlipCount.pancakes)) {
            return pancakesWithFlipCount.flipCount;
        }

        checked.add(pancakes);

        for (String newPancakes : getPossibleFlips(pancakes, flipperSize)) {
            if (!checked.contains(newPancakes)) {
                final PancakesWithFlipCount newPancakesWithFlipCount = new PancakesWithFlipCount(newPancakes, flipsCount + 1);
                if (!toCheck.contains(newPancakesWithFlipCount)) {
                    toCheck.add(newPancakesWithFlipCount);
                }
            }
        }

        return getMinFlipsCount();
    }

    private static boolean isFlipped(String pancakes) {
        for (int i = 0; i < pancakes.length(); i++) {
            if (pancakes.charAt(i) != '+') {
                return false;
            }
        }
        return true;
    }

    private static List<String> getPossibleFlips(String pancakes, int flipperSize) {
        final List<String> possibleFlips = new ArrayList<>(pancakes.length() - flipperSize + 1);
        for (int i = 0; i + flipperSize <= pancakes.length(); i++) {
            possibleFlips.add(flip(pancakes, i, flipperSize));
        }
        return possibleFlips;
    }

    private static String flip(String pancakes, int index, int flipperSize) {
        final StringBuilder flippedPancakes = new StringBuilder(pancakes);
        for (int i = index; i < index + flipperSize; i++) {
            flippedPancakes.replace(i, i + 1, pancakes.charAt(i) == '-' ? "+" : "-");
        }
        return flippedPancakes.toString();
    }

    private static final class PancakesWithFlipCount {
        final String pancakes;
        final int flipCount;

        private PancakesWithFlipCount(String pancakes, int flipCount) {
            this.pancakes = pancakes;
            this.flipCount = flipCount;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;

            PancakesWithFlipCount that = (PancakesWithFlipCount) o;

            return pancakes.equals(that.pancakes);
        }

        @Override
        public int hashCode() {
            return pancakes.hashCode();
        }
    }
}
