package qualifications2014;

import java.io.PrintWriter;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Locale;
import java.util.Scanner;

public class ProblemD {
	
	private static final Scanner in = new Scanner(System.in);
	private static final PrintWriter out = new PrintWriter(System.out);
	
	private static int n;
	private static double[] naomi, ken;

	public static void main(String[] args) {
		in.useLocale(Locale.US);
		final int t = in.nextInt();
		for (int caseNum = 1; caseNum <= t; caseNum++) {
			n = in.nextInt();
			naomi = new double[n];
			ken = new double[n];
			for (int i = 0; i < n; i++)
				naomi[i] = in.nextDouble();
			for (int i = 0; i < n; i++)
				ken[i] = in.nextDouble();
			Arrays.sort(naomi);
			Arrays.sort(ken);
			final int deceitful = deceitful(n);
			final int regular = regular(n);
			out.println("Case #" + caseNum + ": " + deceitful + " " + regular);
		}
		
		in.close();
		out.flush();
		out.close();
	}
	
	private static int deceitful(int pieces) {
		int score = 0;
		for (int i = n - pieces; i < n; i++) {
			if (naomi[i] > ken[i - n + pieces])
				score++;
		}
		if (pieces > 1)
			score = Math.max(score, deceitful(pieces - 1));
		return score;
	}
	
	private static int regular(int pieces) {
		final LinkedList<Double> ken2 = new LinkedList<Double>();
		for (int i = 0; i < ken.length; i++)
			ken2.add(ken[i]);
		int score = 0;
		for (int i = pieces - 1; i >= 0; i--) {
			final double naomiValue = naomi[i];
			boolean kenPoint = false;
			int kenIndex = 0;
			for (Double kenValue : ken2) {
				if (kenValue > naomiValue) {
					kenPoint = true;
					break;
				}
				kenIndex++;
			}
			if (kenIndex < ken2.size())
				ken2.remove(kenIndex);
			else
				ken2.removeFirst();
			if (!kenPoint)
				score++;
		}
		return score;
	}

}
