import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

public class CoinJamSmall {
	
	private static final PrintWriter out = new PrintWriter(System.out);
	
	private static final int J = 50;
	private static final long MAX_NUMBER = Long.parseLong("1111111111111111");
	private static Set<Integer> primes = new TreeSet<Integer>();
	
	static {
		final boolean[] isPrime = new boolean[(int) Math.sqrt(MAX_NUMBER) + 1];
		for (int i = 2; i < isPrime.length; i++) isPrime[i] = true;
		for (int i = 2; i < isPrime.length; i++) {
			if (!isPrime[i]) continue;
			int j = 2;
			int k = i * j;
			while (k < isPrime.length) {
				isPrime[k] = false;
				j++;
				k = i * j;
			}
		}
		for (int i = 2; i < isPrime.length; i++) {
			if (isPrime[i]) primes.add(i);
		}
	}

	public static void main(String[] args) {
		out.println("Case #1:");
		int jj = 0;
		for (int i = 0; i < 1 << 14; i++) {
			final String s = "1" + String.format("%14s", Integer.toBinaryString(i)).replace(' ', '0') + "1";
//			out.println("checking " + s);
			boolean isValid = true;
			for (int base = 2; base <= 10; base++) {
				if (checkPrime(s, base)) {
//					out.println("\tis prime in base " + base + ": " + Long.parseLong(s, base));
					isValid = false;
					break;
				}
			}
			if (!isValid) continue;
			out.print(s + " ");
			for (int base = 2; base <= 10; base++) {
				out.print(findDivider(s, base) + " ");
			}
			out.println();
			if (++jj == J) break;
		}
		out.close();
	}
	
	private static boolean checkPrime(String s, int base) {
		final long l = Long.parseLong(s, base);
		if (l < Integer.MAX_VALUE && primes.contains((int) l)) return true;
		for (int i : primes) {
			if (l % i == 0) return false;
		}
		return true;
	}
	
	private static int findDivider(String s, int base) {
		final long l = Long.parseLong(s, base);
		for (int i : primes) {
			if (l % i == 0) return i;
		}
		return -1;
	}

}
