import java.io.PrintWriter;
import java.util.Scanner;

public class TidyNumbers {

    public static void main(String[] args) {
        try (
                final Scanner scanner = new Scanner(System.in);
                final PrintWriter writer = new PrintWriter(System.out)
        ) {
            final int t = scanner.nextInt();
            scanner.nextLine();
            for (int tt = 0; tt < t; tt++) {
                final String n = scanner.nextLine();
                writer.print("Case #" + (tt + 1) + ": " + tidy(n) + "\n");
                writer.flush();
            }
        }
    }

    private static String tidy(String n) {
        while (!isTidy(n)) {
            final int untidyDigitIndex = getFirstUntidyDigitIndex(n);
            n = transform(n, untidyDigitIndex);
        }

        return n;
    }

    private static boolean isTidy(String n) {
        char lastDigit = 0;
        for (int i = 0; i < n.length(); i++) {
            final char digit = n.charAt(i);
            if (digit < lastDigit) {
                return false;
            }
            lastDigit = digit;
        }
        return true;
    }

    private static String removeLeadingZeros(String n) {
        int i = 0;
        while (n.charAt(i) == '0') {
            i++;
        }
        return n.substring(i);
    }

    private static int getFirstUntidyDigitIndex(String n) {
        char lastDigit = n.charAt(0);
        for (int i = 1; i < n.length(); i++) {
            final char digit = n.charAt(i);
            if (digit < lastDigit) {
                return i;
            }
            lastDigit = digit;
        }
        return -1;
    }

    private static String transform(String n, int untidyDigitIndex) {
        final StringBuilder sb = new StringBuilder(n);
        sb.replace(untidyDigitIndex, sb.length(), nines(sb.length() - untidyDigitIndex));
        for (int i = untidyDigitIndex - 1; i >= 0; i--) {
            char digit = sb.charAt(i);
            if (digit != '0') {
                sb.replace(i, i + 1, Character.toString(--digit));
                break;
            }
        }
        return removeLeadingZeros(sb.toString());
    }

    private static String nines(int n) {
        final StringBuilder sb = new StringBuilder();
        for (int i = 0; i < n; i++) {
            sb.append('9');
        }
        return sb.toString();
    }
}
