import java.util.*;
import java.io.*;
public class Stable {
    public static void setupInput() throws Exception{
        try{
            System.setIn(new FileInputStream("StableLarge.in"));
        }catch(IOException e){
            e.printStackTrace();
            return;
        }
        System.out.print("\f");
        main();
    }
    public static void main(){
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int i=1; i<=t; i++){
            int n = in.nextInt();
            int[] colors = new int[6];
            for(int j=0; j<6; j++){
                colors[j]=in.nextInt();
            }
            String out = ans(n, colors);
            System.out.println("Case #" + i + ": " +out);
        }
    }
    
    public static String ans(int n, int[] colors){
        if(colors[0]<colors[3]){
            return "IMPOSSIBLE";
        }
        String redGreen = "";
        while(colors[3]>0){
            redGreen+="RG";
            colors[0]--; colors[3]--;
        }
        
        if(colors[2]<colors[5]){
            return "IMPOSSIBLE";
        }
        String yellowViolet = "";
        while(colors[5]>0){
            yellowViolet+="YV";
            colors[2]--; colors[5]--;
        }
        
        if(colors[4]<colors[1]){
            return "IMPOSSIBLE";
        }
        String blueOrange = "";
        while(colors[1]>0){
            blueOrange+="BO";
            colors[4]--; colors[1]--;
        }
        String s = ansTriplet(colors[0],colors[2],colors[4]);
        if(s.equals("IMPOSSIBLE")){
            return s;
        }
        if(!redGreen.equals("")){
            int i=s.indexOf("R");
            if(i==-1){
                if(s.equals("")){
                    s=redGreen;
                }else{
                    return "IMPOSSIBLE";
                }
            }else{
                s=s.substring(0,i)+redGreen+s.substring(i);
            }
        }
        if(!yellowViolet.equals("")){
            int i=s.indexOf("Y");
            if(i==-1){
                if(s.equals("")){
                    s=yellowViolet;
                }else{
                    return "IMPOSSIBLE";
                }
            }else{
                s=s.substring(0,i)+yellowViolet+s.substring(i);
            }
        }
        if(!blueOrange.equals("")){
            int i=s.indexOf("B");
            if(i==-1){
                if(s.equals("")){
                    s=blueOrange;
                }else{
                    return "IMPOSSIBLE";
                }
            }else{
                s=s.substring(0,i)+blueOrange+s.substring(i);
            }
        }
        return s;
    }
    public static String ansTriplet(int red, int yellow, int blue){
        //int zeroes = (red==0?1:0 + yellow==0?1:0 + blue==0?1:0);
        
        String out = "";
        String triplet = "";
        if(red>=yellow && red>=blue){
            while(red>yellow){
                red--; blue--; out+="RB";
                if(blue<0){return "IMPOSSIBLE";}
            }
            while(red>blue){
                red--; yellow--; out +="RY";
            }
            while(red>0){
                red--; out+="RYB";
            }
            return out;
        }else if(yellow>=blue && yellow>=red){
            while(yellow>blue){
                yellow--; red--; out+="YR";
                if(red<0){return "IMPOSSIBLE";}
            }
            while(yellow>red){
                yellow--; blue--; out +="YB";
            }
            while(yellow>0){
                yellow--; out+="YBR";
            }
            return out;
        }else{
            while(blue>red){
                blue--; yellow--; out+="BY";
                if(yellow<0){return "IMPOSSIBLE";}
            }
            while(blue>yellow){
                blue--; red--; out +="BR";
            }
            while(blue>0){
                blue--; out+="BRY";
            }
            return out;
        }
    }
}