/* TidyNumbers.java
 * Version 1.0
 * Robert Piechota
 * 4/8/2017
 */
import java.util.*;
import java.io.*;
import java.math.BigInteger;
/**Reads an input file of T test cases.
 * A bathroom has n stalls, plus two occupied ones on the end.
 * People enter in turn, and select a stall based on these preferences:
 * 1) min distance from an occupied stall is maximized. In a tie:
 * 2) max distance from an occupied stall is minimized. In a tie:
 * 3) stall is leftmost.
 * Given n, return the max and min values of the stall chosen by the k-th person.
 */
public class BathroomStalls {
    public static void setupInput() throws Exception{
        try{
            System.setIn(new FileInputStream("C-small-1-attempt0.in"));
        }catch(IOException e){
            e.printStackTrace();
            return;
        }
        System.out.print("\f");
        main();
    }
    
    public static void main(){
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int i=1; i<=t; i++){
            String n = in.next();
            String k = in.next();
            System.out.println("Case #" + i + ": " +answer(n, k));
        }
    }
    
    public static String answer(String n, String k){
        final BigInteger TWO = new BigInteger("2");
        BigInteger emptyStalls = new BigInteger(n);
        BigInteger person = new BigInteger(k);
        BigInteger difference = emptyStalls.subtract(person);
        BigInteger divisor = TWO.pow(person.bitLength()-1);
        BigInteger value = difference.divide(divisor);
        if(value.getLowestSetBit()==0){
            value=value.divide(TWO);
            return value.add(BigInteger.ONE).toString() + " " + value.toString();
        }else{
            value=value.divide(TWO);
            return value.toString() + " " +value.toString();
        }
        /* Calculates the max and min values of the k-th person's stall.
         * Max and min differ at most by 1. Increasing n while holding k constant
         * causes the values to increase linearly. Increasing k while holding n constant
         * changes that rate of increase logarithmically (base 2).
         */
    }
}