import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.HashSet;
import java.util.Iterator;

public class TrainTimeTable
{

	public static void main(String[] args) throws IOException
	{
		//args = new String[] {"c:\\input.in"};
		if (args.length == 0)
		{
			System.out.println("No input file entered");
			System.exit(-1);
		}
		BufferedReader rd = new BufferedReader(new FileReader(args[0]));
		
		String line = null;
		
		boolean firstLine = true;
		int counter = 1;
		while ( (line = rd.readLine()) != null)
		{
			if(firstLine)
			{
				firstLine = false;
				continue;
			}
			
			int turnaround = Integer.parseInt(line.trim());
			
			line = rd.readLine();
			
			int a = Integer.parseInt(line.split(" ")[0].trim());
			int b = Integer.parseInt(line.split(" ")[1].trim());
			
			Scheduale sarr[] = new Scheduale[a+b];
			
			for(int i=0 ; i<a ; i++)
			{
				sarr[i] = new Scheduale('a',rd.readLine());
			}
			
			for(int i=a ; i<a+b ; i++)
			{
				sarr[i] = new Scheduale('b',rd.readLine());
			}
			
			System.out.println("Case #"+counter+": "+ process(sarr,turnaround));
			counter++;
		}
	}

	private static String process(Scheduale[] sarr, int turnaround)
	{
		int atrains = 0;
		int btrains = 0;
		
		// sort schedule by the start time
		Arrays.sort(sarr, new Comparator<Scheduale>() {

			public int compare(Scheduale o1, Scheduale o2)
			{
				return (int) (o1.startTime - o2.startTime);
			}});

		// holds train an each station
		HashSet<Train> aTrains = new HashSet<Train>();
		HashSet<Train> bTrains = new HashSet<Train>();
		
		for(int i=0 ; i<sarr.length ; i++)
		{
			// find station from a a add new
			if (sarr[i].station == 'a')
			{
				Train next = getTrain(aTrains, sarr[i].startTime);
				
				if (next == null)
				{
					next = new Train();
					atrains++;
				}
				else
				{
					aTrains.remove(next);
				}
				next.nextAvilTime = sarr[i].endTime+turnaround;
				bTrains.add(next);
			}
			// find a train from b or add a new.
			else
			{
				Train next = getTrain(bTrains, sarr[i].startTime);
				
				if (next == null)
				{
					next = new Train();
					btrains++;
				}
				else
				{
					bTrains.remove(next);
				}
				next.nextAvilTime = sarr[i].endTime+turnaround;
				aTrains.add(next);
			}
		}
		
		
		
		return ""+atrains+" "+btrains;
	}
	
	public static Train getTrain(HashSet<Train> trains,long time)
	{
		for (Iterator<Train> ir = trains.iterator(); ir.hasNext();)
		{
			Train train = ir.next();
			if (train.nextAvilTime <= time)
			{
				return train;
				
			}
		}
		return null;
	}
}

class Train
{
	long nextAvilTime = 0;
}

class Scheduale
{
	public Scheduale(char thestation,String time)
	{
		station = thestation;
		String fields[] = time.split(" ");
		
		startTime = gettime(fields[0]);
		endTime = gettime(fields[1]);
	}
	
	private long gettime(String time)
	{
		String fields[] = time.trim().split(":");
		
		return Integer.parseInt(fields[0].trim())*60 + Integer.parseInt(fields[1].trim());
	}

	long startTime = 0;
	
	long endTime = 0;
	
	char station;
}
