package gcj2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class JamCoin {

	public long toNumber(int base, StringBuffer jamCoin)
	{
		long start = System.currentTimeMillis();
		long result = 0;
		for (int i = 0; i < jamCoin.length(); i++)
		{
			result *= base;
			if (jamCoin.charAt(i) == '1') result++;
		}
		toNumberTime += System.currentTimeMillis()-start;
		return result;
	}
	
	public boolean isPrime(long number)
	{
		long start = System.currentTimeMillis();
		if (number%2 == 0)
		{
			divisor = 2;
			isPrimeTime += System.currentTimeMillis()-start;
			return false;
		}
		long maxDivisor = (long)Math.floor(Math.sqrt(number))+1;
		for (long i = 3; i < maxDivisor;)
		{
			if (number%i == 0)
			{
				divisor = i;
				isPrimeTime += System.currentTimeMillis()-start;
				return false;
			}
			i += 2;
		}
		isPrimeTime += System.currentTimeMillis()-start;
		return true;
	}
	
	public boolean isJamCoin(StringBuffer jamCoin)
	{
		//non prime in all bases 2 to 10
		//if jamcoin return it with divisors
		boolean isJam = true;
		divs = new StringBuffer("");
		for (int base = 2; isJam && base < 11; base++)
		{
			long number = toNumber(base, jamCoin);
			if (isPrime(number))
			{
				isJam = false;
			}
			else
			{
				divs.append(divisor + " ");
			}
		}
		
		return isJam;
	}
	
	private StringBuffer next(StringBuffer jamCoin)
	{
		//find first 0 from back
		//flip it to 1
		//flip ones behind it to 0
		int start = jamCoin.length()-2;
		while (start >= 0 && jamCoin.charAt(start) == '1') start--;
		if (start == -1) return new StringBuffer("THE END");
		
		//start+1+length-2-start-1+1 = length-1
		StringBuffer sb = new StringBuffer(jamCoin.substring(0, start));
		sb.append("1");
		for (int i = start+1; i < jamCoin.length()-1; i++) sb.append("0");
		sb.append("1");
		return sb;
	}
	
	public String solve(int N, int J)
	{
		StringBuffer sb = new StringBuffer("");
		//jamcoin start with 1 end with 1
		//non prime in all bases 2 to 10
		//if jamcoin return it with divisors
		StringBuffer jamCoin = new StringBuffer("1");
		for (int i = 0; i < N-2; i++) jamCoin.append("0");
		jamCoin.append("1");
		int count = 0;
		while (count < J)
		{
			if (isJamCoin(jamCoin))
			{
				sb.append(jamCoin.toString()+" " + divs + "\n");
				count++;
			}
			
			jamCoin = next(jamCoin);
		}
		return sb.toString();
	}
	
	private StringBuffer divs = new StringBuffer("");
	private long divisor;
	private long toNumberTime;
	private long isPrimeTime;
	
	public static void main(String[] args) {
		
		try
		{
			long startTime = System.currentTimeMillis();
			String inputName = "C-small-attempt0.in";
			BufferedReader input = new BufferedReader(new FileReader(inputName));
			BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));
			//read test case number
			String line = input.readLine();
			int testNr = new Integer(line).intValue();
			JamCoin test = new JamCoin();
			
			for (int i = 0; i < testNr; i++)
			{
				//read test case
				line = input.readLine();
				String[] parts = line.split(" ");
				int N = new Integer(parts[0]).intValue();
				int J = new Integer(parts[1]).intValue();
				String res = test.solve(N, J);
				String toWrite = "Case #" + (i+1) + ": \n" + res;
				System.out.println(toWrite);
				output.write(toWrite + "\n");
			}
			output.flush();
			output.close();
			input.close();
			System.out.println("Time: " + (System.currentTimeMillis()-startTime));
			System.out.println("toNumber Time: " + test.toNumberTime);
			System.out.println("isPrime Time: " + test.isPrimeTime);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

}
