package gcj2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class GettingTheDigits {

	private void printArray(int[] array)
	{
		StringBuffer sb = new StringBuffer("");
		for (int i = 0; i < array.length; i++)
		{
			sb.append(array[i]);
		}
		
		System.out.println(sb.toString());
	}
	
	public String solve(String digits)
	{
		int[] digitCounts = new int[26];
		for (int i = 0; i < digits.length(); i++)
		{
			int c = digits.charAt(i)-'A';
			digitCounts[c] += 1;
		}
		
		//figure out ZERO ONE TWO THREE FOUR FIVE SIX SEVEN EIGHT NINE
		//a bcdef ghijk lmnop qrstu vwxyz
		int nZeros = digitCounts[25]; //#count Zs
		digitCounts[25] -= nZeros;
		digitCounts[4] -= nZeros;
		digitCounts[17] -= nZeros;
		digitCounts[14] -= nZeros;
		
		int nTwos = digitCounts[22];
		digitCounts[22] -= nTwos;
		digitCounts[19] -= nTwos;
		digitCounts[14] -= nTwos;
		
		int nSix = digitCounts[23];
		digitCounts[18] -= nSix;
		digitCounts[8] -= nSix;
		digitCounts[23] -= nSix;
		
		int nEight = digitCounts[6];
		digitCounts[4] -= nEight;
		digitCounts[8] -= nEight;
		digitCounts[6] -= nEight;
		digitCounts[7] -= nEight;
		digitCounts[19] -= nEight;
		
		int nThree = digitCounts[7];
		digitCounts[19] -= nThree;
		digitCounts[7] -= nThree;
		digitCounts[17] -= nThree;
		digitCounts[4] -= (nThree+nThree);
		
		int nSeven = digitCounts[18];
		digitCounts[18] -= nSeven;
		digitCounts[4] -= (nSeven+nSeven);
		digitCounts[21] -= nSeven;
		digitCounts[13] -= nSeven;
		
		int nFive = digitCounts[21];
		digitCounts[5] -= nFive;
		digitCounts[20] -= nFive;
		digitCounts[4] -= nFive;
		digitCounts[8] -= nFive;
		
		int nFour = digitCounts[5];
		digitCounts[4] -= nFour;
		digitCounts[14] -= nFour;
		digitCounts[20] -= nFour;
		digitCounts[17] -= nFour;
		
		int nOne = digitCounts[14];
		int nNine = digitCounts[8];
		
		StringBuffer sb = new StringBuffer("");
		for (int i = 0; i < nZeros; i++) sb.append("0");
		for (int i = 0; i < nOne; i++) sb.append("1");
		for (int i = 0; i < nTwos; i++) sb.append("2");
		for (int i = 0; i < nThree; i++) sb.append("3");
		for (int i = 0; i < nFour; i++) sb.append("4");
		for (int i = 0; i < nFive; i++) sb.append("5");
		for (int i = 0; i < nSix; i++) sb.append("6");
		for (int i = 0; i < nSeven; i++) sb.append("7");
		for (int i = 0; i < nEight; i++) sb.append("8");
		for (int i = 0; i < nNine; i++) sb.append("9");
//		printArray(digitCounts);
		return sb.toString();
	}
	
	public static void main(String[] args) 
	{
		try
		{
			String inputName = "A-large (1).in";
			BufferedReader input = new BufferedReader(new FileReader(inputName));
			BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));
			//read test case number
			String line = input.readLine();
			int testNr = new Integer(line).intValue();
			
			for (int i = 0; i < testNr; i++)
			{
				GettingTheDigits test = new GettingTheDigits();
				line = input.readLine();
				String res = test.solve(line);
				String toWrite = "Case #" + (i+1) + ": " + res;
				System.out.println(toWrite);
				output.write(toWrite + "\n");
			}
			output.flush();
			output.close();
			input.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
}
