package gcj2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class TicTacToeTomek 
{
	public String solve(String[] board, int caseNr)
	{
		StringBuffer sb = new StringBuffer("");
		sb.append("Case #");
		sb.append(caseNr);
		sb.append(": ");
		sb.append(processBoard(board));
		//sb.append();
		return sb.toString();
	}

	private String processBoard(String[] board)
	{
		boolean[] noWinX = new boolean[10];
		boolean[] noWinO = new boolean[10];
		int[] tCount = new int[10];
		int dots = 0;
		for (int i = 0; i < 4; i++)
		{
			String line = board[i];
			for (int j = 0; j < 4; j++)
			{
				char c = line.charAt(j);
				switch (c)
				{
					case 'T':
					{
						tCount[i] += 1;
						tCount[j+4] += 1;
						if (i == j) tCount[DIAG] += 1;
						if (i == 3-j) tCount[XDIAG] += 1; 
					} break;
					case '.':
					{
						noWinX[i] = true;
						noWinO[i] = true;
						noWinX[4+j] = true;
						noWinO[4+j] = true;
						if (i == j) 
						{
							noWinX[DIAG] = true;
							noWinO[DIAG] = true;
						}
						if (i == 3-j)
						{
							noWinX[XDIAG] = true;
							noWinO[XDIAG] = true;
						}
						dots += 1;
					} break;
					case 'X':
					{
						noWinO[i] = true;
						noWinO[4+j] = true;
						if (i == j) noWinO[DIAG] = true;
						if (i == 3-j) noWinO[XDIAG] = true;
					} break;
					case 'O':
					{
						noWinX[i] = true;
						noWinX[4+j] = true;
						if (i == j) noWinX[DIAG] = true;
						if (i == 3-j) noWinX[XDIAG] = true;
					} break;					
					default:
						System.err.println("Unknown character: " + c);
						break;
				}
			}
		}
		for (int i = 0; i < 10; i++)
		{
			if (noWinX[i] == false && tCount[i] < 2) return "X won";
			if (noWinO[i] == false && tCount[i] < 2) return "O won";			
		}
		if (dots == 0) return "Draw";
		return "Game has not completed";
	}
	
	private final int DIAG = 8;
	private final int XDIAG = 9;
	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		TicTacToeTomek test = new TicTacToeTomek();
		String fileName = "A-large.in.txt";
		String outName = "out-large.txt";
		try
		{
			BufferedReader br = new BufferedReader(new FileReader(fileName));
			String line = br.readLine();
			BufferedWriter bw = new BufferedWriter(new FileWriter(outName));
			int tests = new Integer(line).intValue();
			for (int i = 0; i < tests; i++)
			{
				String[] board = new String[4];
				for (int j = 0; j < 4; j++) board[j] = br.readLine();
				String line2 = test.solve(board, i+1);
				System.out.println(line2);
				bw.write(line2+"\n");
				if (i < tests -1) br.readLine(); //skip empty line
			}
			bw.flush();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}		
	}

}
