package gcj2010;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class WorldCup
{
	public int solve(int[] maxMissed, int[] prices, int p)
	{
		int result = 0;
		int[][] gamePrices = new int[maxMissed.length][p];
		int[][] gameNrs = new int[maxMissed.length][p];
		for (int i = 0; i < maxMissed.length; i++)
		{
			for (int j = 0; j < p; j++)
			{
				int start = (int)Math.pow(2, p) - 2;
				for (int k = p-1; k > j; k--)
				{
					start -= (int)Math.pow(2, k-j);
				}
				gamePrices[i][j] = prices[start + (i/((int)Math.pow(2, j+1)))];
				gameNrs[i][j] = start + (i/((int)Math.pow(2, j+1)));
			}
		}
		//find 0: can't miss any
		int[] missed = new int[maxMissed.length];
		for (int i = 0; i < maxMissed.length; i++)
		{
			missed[i] = p;
		}
		
		boolean[] attended = new boolean[prices.length];
		
		while(buy(maxMissed, missed))
		{
			int maxGap = 0;
			int maxIndex = 0;
			for (int i = 0; i < maxMissed.length; i++)
			{
				if (missed[i] - maxMissed[i] > maxGap)
				{
					maxGap = missed[i] - maxMissed[i];
					maxIndex = i;
				}
			}
			
			if (maxGap == p)
			{
				//see all games of i
				//see final
				//see first semi if i in [0..2 pow(p-1)
				
				int teamsInGames = (int)Math.pow(2, p);;
				for (int i = 0; i < p; i++)
				{
					for (int j = 0; j < missed.length; j++)
					{
						if (maxIndex/teamsInGames == j/teamsInGames)
						{
							missed[j] -= 1;
						}
					}
					
					teamsInGames = teamsInGames/2;
				}
				
				for (int i = 0; i < p; i++)
				{
					result += gamePrices[maxIndex][i];
					if (attended[gameNrs[maxIndex][i]] == false)
					{
						attended[gameNrs[maxIndex][i]] = true;
					}
					else
					{
						System.out.println("Already attending game: " + gameNrs[maxIndex][i]);
					}
				}				
			}
			else
			{	//see last i games
				int gamesSeen = 0;
//				int teamInGames = (int)Math.pow(2, p);
				for (int i = 0; i < p && gamesSeen < maxGap; i++)
				{
					if (!attended[gameNrs[maxIndex][p-1-i]])
					{
						gamesSeen += 1;
						attended[gameNrs[maxIndex][p-1-i]] = true;
						result += gamePrices[maxIndex][p-1-i];
						
						int teamsInGames = (int)Math.pow(2, p-i);
						for (int j = 0; j < missed.length; j++)
						{
							if (maxIndex/teamsInGames == j/teamsInGames)
							{
								missed[j] -= 1;
							}
						}

					}
				}
				
			}
			
//			return 0;
		}
		
		return result;
	}
	
	public boolean buy(int[] maxMissed, int[] missed)
	{
		for (int i = 0; i < maxMissed.length; i++)
		{
			if (maxMissed[i] < missed[i])
			{
				return true;
			}
		}		
		return false;
	}
	
	public static void println(String s)
	{
		System.out.println(s);
		out.println(s);
		out.flush();
	}
	
	static PrintWriter out = null;
	static String inputFileName = "B-small-attempt0.in";
	static String outputFileName = "b.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		WorldCup test = new WorldCup();
		try
		{
			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			out = new PrintWriter(new FileWriter(outputFileName));
			int testCaseNr = new Integer(inputFile.readLine().split(" ")[0]).intValue();

			for (int i = 0; i < testCaseNr; i++)
			{
				/** READ INPUT */
				String[] parts = inputFile.readLine().split(" ");
				int p = new Integer(parts[0]).intValue();
				
				/** TRANSFORM INPUT */
				parts = inputFile.readLine().split(" ");
				int[] maxMissed = new int [(int)Math.pow(2, p)];
				for (int j = 0; j < Math.pow(2, p); j++)
				{
					maxMissed[j] = new Integer(parts[j]).intValue();
				}
				
				int[] prices = new int [(int)Math.pow(2, p)-1];
				int next = 0;
				for (int j = 0; j < p; j++)
				{
					parts = inputFile.readLine().split(" ");
					for (int k = 0; k < (int)Math.pow(2, p-1-j); k++)
					{
						prices[next] =  new Integer(parts[k]).intValue();
						next += 1;
					}
				}
				/** OUTPUT RESULTS */
				
				int result = test.solve(maxMissed, prices, p);
				println("Case #" + (i+1) + ": " + result);

			}
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}
