package googleCodeJam;

import java.io.*;

public class AlienLanguage
{
	
	public AlienLanguage(int letters, int dictionary_size, int test_cases)
	{
		L = letters;
		D = dictionary_size;
		N = test_cases;
		dict = new String[D];
		next = 0;
	}
	
	public void add(String word)
	{
		dict[next] = word;
		next += 1;
	}
	
	public int decode(String word)
	{
		int result = 0;
		int wordsize = word.length();
		for (int i = 0; i < D; i++)
		{	//does pattern word fit dict[i]
			boolean possible = true;
			int wordindex = 0;
			
			for (int j = 0; j < L && possible; j++)
			{	
				char d = dict[i].charAt(j);
				if (word.charAt(wordindex) == '(')
				{
					wordindex += 1;
					boolean found = false;
					while (word.charAt(wordindex) != ')')
					{
						if (word.charAt(wordindex) == d)
						{
							found = true;
						}
						
						wordindex += 1;
					}
					
					wordindex += 1;
					possible &= found;
				}
				else
				{
					if (word.charAt(wordindex) != d)
					{
						possible = false;
					}					
					wordindex += 1;
				}
			}
			
			if (possible)
			{
				result += 1;
			}
		}
		return result;
	}
	
	private int L;
	private int D;
	private int N;
	private String dict[];
	private int next;
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		File text = new File ("A-large.in");
		String outputFileName = "A-large-out.txt";
		try
		{
			BufferedReader input = new BufferedReader(new FileReader(text));
			FileWriter output = new FileWriter(outputFileName);
			PrintWriter out = new PrintWriter(output);
			//read first line
			String line = input.readLine();
			String[] parts = line.split(" ");
			int letters = (new Integer(parts[0])).intValue();
			int dictionary_size = (new Integer(parts[1])).intValue();
			int test_cases = (new Integer(parts[2])).intValue();
			
			AlienLanguage test = new AlienLanguage(letters, dictionary_size, test_cases);
			//read dictionary
			for (int i = 0; i < dictionary_size; i++)
			{
				//read line
				String word = input.readLine();
				test.add(word);
			}
			
			//read queries
			for (int i = 0; i < test_cases; i++)
			{
				//read line
				String word = input.readLine();
				int result = test.decode(word);
				out.println("Case #" + (i+1) + ": " + result);
			}	
			
			out.close();
		} 
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		} 
		catch (IOException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
