package gcj2010;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class ThemePark
{
	public long solve(long rides, long cap, int size, long[] groups)
	{
		long result = 0;
		int nextGroup = 0;
		int start = 0;
		long[] ridersSum = new long[size];
		int[] ridersStart = new int[size];
		
		for (long index = 0; index < rides; index++)
		{
			if (ridersSum[start] == 0)
			{
				long inCars = groups[nextGroup];
				nextGroup += 1;
				nextGroup %= size;
				while (inCars + groups[nextGroup]<= cap && start != nextGroup)
				{
					inCars += groups[nextGroup];
					nextGroup += 1;
					nextGroup %= size;
				}
				
				result += inCars;
				ridersSum[start] = inCars;
				ridersStart[start] = nextGroup;
				start = nextGroup;
			}
			else
			{
				result += ridersSum[start];
				start = ridersStart[start];
			}
		}
		
		return result;
	}

	public static void println(String s)
	{
		System.out.println(s);
		out.println(s);
		out.flush();
	}
	
	static PrintWriter out = null;
	static String inputFileName = "C-small-attempt1.in";
	static String outputFileName = "b.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		ThemePark test = new ThemePark();
		try
		{
			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			out = new PrintWriter(new FileWriter(outputFileName));
			int testCaseNr = new Integer(inputFile.readLine()).intValue();

			for (int i = 0; i < testCaseNr; i++)
			{
				/** READ INPUT */
				String[] parts = inputFile.readLine().split(" ");
				long rides = new Long(parts[0]).longValue();
				long cap = new Long(parts[1]).longValue();
				int size = new Integer(parts[2]).intValue();
				
				/** TRANSFORM INPUT */
				parts = inputFile.readLine().split(" ");
				long[] groups =  new long[size];
				for (int j = 0; j < size; j++)
				{
					groups[j] = new Long(parts[j]).longValue();
				}
				/** OUTPUT RESULTS */
				long result = test.solve(rides, cap, size, groups);
				println("Case #" + (i+1) + ": " + result);
			}
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}