package gcj2010;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class NumberGame
{
	public int solve(int A1, int A2, int B1, int B2)
	{
		int result = 0;
		for (int i = A1; i <= A2; i++)
		{
			for (int j = B1; j <= B2; j++)
			{
				if (winningPosition(i,j))
				{
					result +=1;
				}
			}
		}
		return result;
	}
	
	public boolean winningPosition(int i, int j)
	{
		if (i == j)
		{
			return false;
		}
		
		if (i > j)
		{
			if (i%j == 0) 
			{
				return true;
			}
			
			if (i == i%j + j)
			{
				return !winningPosition(i%j, j);
			}
			
			return !winningPosition(i%j+j, j);	
		}
		
		if (j%i == 0)
		{
			return true;
		}
		
		if (j == j%i + i)
		{
			return !winningPosition(i, j%i);
		}
		
		return !winningPosition(i, j%i+i);
	}
	
	public static void println(String s)
	{
		System.out.println(s);
		out.println(s);
		out.flush();
	}
	
	static PrintWriter out = null;
	static String inputFileName = "C-small-attempt0 (1).in";
	static String outputFileName = "b.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		NumberGame test = new NumberGame();
		try
		{
			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			out = new PrintWriter(new FileWriter(outputFileName));
			int testCaseNr = new Integer(inputFile.readLine()).intValue();

			for (int i = 0; i < testCaseNr; i++)
			{
				/** READ INPUT */
				String[] parts = inputFile.readLine().split(" ");
				
				/** TRANSFORM INPUT */
				int A1 = new Integer(parts[0]).intValue();
				int A2 = new Integer(parts[1]).intValue();
				int B1 = new Integer(parts[2]).intValue();
				int B2 = new Integer(parts[3]).intValue();
				/** OUTPUT RESULTS */
				int result = test.solve(A1, A2, B1, B2);
				println("Case #" + (i+1) + ": " + result);
			}
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}
