package gcj2010;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;

public class FairWarning
{
	public String solve(BigInteger[] events)
	{
		BigInteger gcd = BigInteger.ONE;
		if (events[0].compareTo(events[1]) > 0)
		{
			gcd = events[0].add(events[1].negate());
		}
		else
		{
			gcd = events[1].add(events[0].negate());
		}
		
		int size = events.length;
		for (int i = 2; i < size; i++)
		{
			BigInteger next = BigInteger.ONE;
			if (events[0].compareTo(events[i]) > 0)
			{
				next = events[0].add(events[i].negate());
			}
			else
			{
				next = events[i].add(events[0].negate());				
			}
			
			gcd = gcd.gcd(next);
		}
		
		BigInteger result = events[0].negate();
		//gcd.add(events[0].remainder(gcd).negate());
		while (result.compareTo(BigInteger.ZERO) < 0)
		{
			result = result.add(gcd);
		}
//		return gcd.toString();
		return result.toString();
	}
	
	public static void println(String s)
	{
		System.out.println(s);
		out.println(s);
		out.flush();
	}
	
	static PrintWriter out = null;
	static String inputFileName = "B-small-attempt0.in";
	static String outputFileName = "b.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		FairWarning test = new FairWarning();
		try
		{
			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			out = new PrintWriter(new FileWriter(outputFileName));
			int testCaseNr = new Integer(inputFile.readLine()).intValue();

			for (int i = 0; i < testCaseNr; i++)
			{
				/** READ INPUT */
				String[] parts = inputFile.readLine().split(" ");
				
				/** TRANSFORM INPUT */
				int size = new Integer(parts[0]).intValue();
				BigInteger[] events = new BigInteger[size];
				for (int j = 0; j < size; j++)
				{
					events[j] = new BigInteger(parts[j+1]);
				}
				
				/** OUTPUT RESULTS */
				String result = test.solve(events);
				println("Case #" + (i+1) + ": " + result);
			}
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}