package gcj2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class AlphabetCake
{	
	public boolean notUsed(char s, char[] used, int extended)
	{
		if (s== '?') return true;
		for (int i = 0; i < extended; i++)
		{
			if (s == used[i]) return true;
		}
		return false;
	}
	
	public boolean allQuestions(char[] sbs, int kr, int mincol, int maxcol, int length)
	{
		for (int i = mincol; i <= maxcol; i++)
		{
			if (sbs[kr*length+i] != '?') return false;
		}
		return true;
	}

	public boolean allQuestionsCol(char[] sbs, int kr, int minrow, int maxrow, int length)
	{
		for (int i = minrow; i <= maxrow; i++)
		{
			if (sbs[kr+length*i] != '?') return false;
		}
		return true;
	}
	
	public String[] solve(String[] lines, int count, int length)
	{
		char[] sbs = new char[count*length];
		int empty = 0;
		int letters = 0;
		for (int i = 0; i < count; i++)
		{
			for (int j = 0; j < length; j++)
			{
				sbs[i*length+j] = lines[i].charAt(j);
				if (lines[i].charAt(j) == '?') empty += 1;
				else letters += 1;
			}
		}
		System.out.println("Empty: " + empty + " Letters: " + letters);
		char[] used = new char[letters];
		for (int i = 0; i < letters; i++) used[i] = '?';
		int extended = 0;
		
		while (empty > 0)
		{
			//find first empty
			int first = 0;
			boolean breakLoop = false;
			while (notUsed(sbs[first], used, extended))
			{
				first++;
/*				if (first >= count*length)
				{
					breakLoop = true;
					break;
				} */
			}
//			if (breakLoop) break;
			
			int row = first/length;
			int col = first%length;
			//extend horizontal or vertical
			used[extended] = sbs[first];
			extended += 1;
			boolean horizontal = false;
			boolean foundOther = false;
			int j = col+1;
			int maxcol = col;
			int mincol = col;
			while (!foundOther && j < length)
			{
				if (sbs[row*length+j] == '?')
				{
					horizontal = true;
					empty -= 1;
					sbs[row*length+j] = sbs[first];
					maxcol = j;
				}
				else foundOther = true;
				j += 1;
			}
			foundOther = false;
			j = col-1;
			while (!foundOther && j >= 0)
			{
				if (sbs[row*length+j] == '?')
				{
					horizontal = true;
					empty -= 1;
					sbs[row*length+j] = sbs[first];
					mincol = j;
				}
				else foundOther = true;				
				j -= 1;
			}
			//checkrows above and below
			if (horizontal)
			{
				int kr = row-1;
				while (kr >= 0 && allQuestions(sbs, kr, mincol, maxcol, length))
				{
					for (j = mincol; j <= maxcol; j++)
					{
						sbs[kr*length+j] = sbs[first];
						empty -= 1;
					}
					kr -= 1;
				}
				kr = row+1;
				while (kr < count && allQuestions(sbs, kr, mincol, maxcol, length))
				{
					for (j = mincol; j <= maxcol; j++)
					{
						sbs[kr*length+j] = sbs[first];
						empty -= 1;
					}
					kr += 1;
				}
			}
			else //(!horizontal)
			{
				foundOther = false;
				j = row+1;
				int maxrow = row;
				int minrow = row;
				while (!foundOther && j < count)
				{
					if (sbs[j*length+col] == '?')
					{
						empty -= 1;
						sbs[j*length+col] = sbs[first];
						maxrow = j;
					}
					else foundOther = true;
					j += 1;
				}
				foundOther = false;
				j = row-1;
				while (!foundOther && j >= 0)
				{
					if (sbs[j*length+col] == '?')
					{
						empty -= 1;
						sbs[j*length+col] = sbs[first];
						minrow = j;
					}
					else foundOther = true;				
					j -= 1;
				}
				
				//check columns left and right
				int kr = col-1;
				while (kr >= 0 && allQuestionsCol(sbs, kr, minrow, maxrow, length))
				{
					for (j = minrow; j <= maxrow; j++)
					{
						sbs[kr+length*j] = sbs[first];
						empty -= 1;
					}
					kr -= 1;
				}
				kr = col+1;
				while (kr < length && allQuestionsCol(sbs, kr, minrow, maxrow, length))
				{
					for (j = minrow; j <= maxrow; j++)
					{
						sbs[kr+length*j] = sbs[first];
						empty -= 1;
					}
					kr += 1;
				}
			}
		}
		
		String[] results = new String[count];
		for (int i = 0; i < count; i++)
		{
			StringBuffer sb = new StringBuffer("");
			for (int j = 0; j < length; j++)
			{
				sb.append(sbs[i*length+j]);
			}
			results[i] = sb.toString();
		}
		return results;		
	}
	
	public static void main(String[] args)
	{
		try
		{
			String inputFileName = "A-large.in-2.txt";
			BufferedReader input = new BufferedReader(new FileReader(inputFileName));
			BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));
			String line = input.readLine();
			int cases = new Integer(line).intValue();
			AlphabetCake test = new AlphabetCake();
			for (int i = 0; i < cases; i++)
			{
				line = input.readLine();
				String[] parts = line.split(" ");
				int count = new Integer(parts[0]).intValue();
				int length = new Integer(parts[1]).intValue();
				String[] lines = new String[count];
				for (int j = 0; j < count; j++)
				{
					line = input.readLine();
					System.out.println(line);
					lines[j] = line;
				}

				String out = "Case #" + (i+1) + ": ";
				System.out.println(out);
				output.write(out + "\n");
				String[] results = test.solve(lines, count, length);
				for (int j = 0; j < results.length; j++)
				{
					out = results[j];
					System.out.println(out);;
					output.write(out + "\n");
				}
			}
			output.flush();
			output.close();
			input.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}

	}

}
