package gcj2010;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class Rotate
{
	public String solve(int N, int K, String[] board)
	{
		String result = "Neither";
		boolean blueWins = false;
		boolean redWins = false;
		
		// .... .... 0 
		// .... R... 1
		// B... B... 2
		// RB.R RB.. 3
		String[] rotated = new String[N];
		StringBuffer[] next = new StringBuffer[N];
		
		//suck out '.' in rows
		for (int i = 0; i < N; i++)
		{
			next[i] = new StringBuffer("");
			for (int j = 0; j < N; j++)
			{
				char c = board[i].charAt(j);
				if (c != '.')
				{
					next[i].append(c);
				}
			}
		}
		
/*		for (int i = 0; i < N; i++)
		{
			System.out.println(next[i]);
		}
*/
		// ""
		// ""
		// B
		// RBR
		
		//rotate
		StringBuffer[] rotate = new StringBuffer[N];
		for (int i = 0; i < N; i++)
		{
			rotate[i] = new StringBuffer("");
		}
		
		int charIndex = 0;
		for (int i = N-1; i >= 0; i--, charIndex++)
		{
			for (int j = N-1; j >= 0; j--)
			{
				if (next[j].length() >= N - i)
				{
					rotate[i].append(next[j].charAt(next[j].length() - 1 - charIndex));
				}
			}
		}
		
		//fill up rotate
		for (int i = 0; i < N; i++)
		{
			int points = N - rotate[i].length();
			for (int j = 0; j < points; j++)
			{
				rotate[i].append('.');
			}
		}
		
/*		for (int i = 0; i < N; i++)
		{
			System.out.println(rotate[i]);
		}
*/		
		//check winner
		blueWins = checkWinner(rotate, 'B', K);
		redWins = checkWinner(rotate, 'R', K);
		
		if ((blueWins) && (redWins))
		{
			result = "Both";
		}
		else if (blueWins)
		{
			result = "Blue";
		}
		else if (redWins)
		{
			result = "Red";
		}
		
		return result;
	}
	
	public boolean checkWinner(StringBuffer[] rotate, char c, int K)
	{
		int size = rotate.length;
		//check horizontal
		for (int i = 0; i < size; i++)
		{
			int current = 0;
			for (int j = 0; j < size; j++)
			{
				if (rotate[i].charAt(j) == c)
				{
					current += 1;
					if (current >= K)
					{
						return true;
					}
				}
				else
				{
					current = 0;
				}
			}
		}
		
		//check vertical
		for (int i = 0; i < size; i++)
		{
			int current = 0;
			for (int j = 0; j < size; j++)
			{
				if (rotate[j].charAt(i) == c)
				{
					current += 1;
					if (current >= K)
					{
						return true;
					}
				}
				else
				{
					current = 0;
				}
			}
		}
		
		//check diagonal
		for (int k = 1 - size; k <= 0; k++)
		{
			int current  = 0;
			for (int l = 0; l < size - Math.abs(k); l++)
			{
				if (rotate[Math.abs(k)+l].charAt(l) == c)
				{
					current += 1;
					if (current >= K)
					{
						return true;
					}
				}
				else
				{
					current = 0;
				}
			}
		}
		for (int k = 1; k < size; k++)
		{
			int current  = 0;
			for (int l = 0; l < size - Math.abs(k); l++)
			{
				if (rotate[l].charAt(l+k) == c)
				{
					current += 1;
					if (current >= K)
					{
						return true;
					}
				}
				else
				{
					current = 0;
				}
			}
		}

		//check crossdiagonal
		for (int k = 0; k < size; k++)
		{
			int current = 0;
			for (int l = 0; l < size - (Math.abs(k-size+1)); l++)
			{
				if (rotate[k-l].charAt(l) == c)
				{
					current += 1;
					if (current >= K)
					{
						return true;
					}
				}
				else
				{
					current = 0;
				}
			}				
		}
		
		for (int k = size; k < 2 * size - 1; k++)
		{
			int current = 0;
			for (int l = 0; l < size - (Math.abs(k-size+1)); l++)
			{
				if (rotate[size-1-l].charAt(l+(k-size+1)) == c)
				{
					current += 1;
					if (current >= K)
					{
						return true;
					}
				}
				else
				{
					current = 0;
				}
			}				
		}
		
		return false;
	}
	
	public static void println(String s)
	{
		System.out.println(s);
		out.println(s);
		out.flush();
	}
	
	static PrintWriter out = null;
	static String inputFileName = "a-small-attempt0 (1).in";
	static String outputFileName = "b.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		Rotate test = new Rotate();
		try
		{
			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			out = new PrintWriter(new FileWriter(outputFileName));
			int testCaseNr = new Integer(inputFile.readLine()).intValue();

			for (int i = 0; i < testCaseNr; i++)
			{
				/** READ INPUT */
				String[] parts = inputFile.readLine().split(" ");
				int N = new Integer(parts[0]).intValue();
				int K = new Integer(parts[1]).intValue();
				
				/** TRANSFORM INPUT */
				String[] board = new String[N];
				for (int j = 0; j < N; j++)
				{
					board[j] = inputFile.readLine();
				}
				
				/** OUTPUT RESULTS */
				String result = test.solve(N, K, board);
				println("Case #" + (i+1) + ": " + result);
			}
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}
