package gcj2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class FairSquare 
{
	public String solve(String A, String B, int caseNr)
	{
		StringBuffer sb = new StringBuffer("");
		sb.append("Case #");
		sb.append(caseNr);
		sb.append(": ");
		sb.append(count(A, B));
		return sb.toString();
	}

	private long count(String A, String B)
	{
		long b = new Long(B).longValue();
		long a = new Long(A).longValue();
		long end = (long)Math.floor(Math.sqrt(b));
		long start = (long)Math.ceil(Math.sqrt(a));
		long result = 0;
		for (long i = start; i < end + 1; i++)
		{
			if (isPalindrome(i))
			{
				if (isPalindrome(i*i)) result += 1;
			}
		}
		return result;
	}
	
	private boolean isPalindrome(long i)
	{
		String str = new Long(i).toString();
		int digits = str.length();
		int checks = digits/2;
		for (int j = 0; j < checks; j++)
		{
			if (str.charAt(j) != str.charAt(str.length()-1-j)) return false;
		}
		return true;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		FairSquare test = new FairSquare();
		String fileName = "C-small-attempt0.in.txt";
		String outName = "outCsmall.txt";
		try
		{
			BufferedReader br = new BufferedReader(new FileReader(fileName));
			String line = br.readLine();
			BufferedWriter bw = new BufferedWriter(new FileWriter(outName));
			int tests = new Integer(line).intValue();
			for (int i = 0; i < tests; i++)
			{
				line = br.readLine();
				String[] parts = line.split(" ");
				String line2 = test.solve(parts[0], parts[1], i+1);
				System.out.println(line2);
				bw.write(line2+"\n");
			}
			bw.flush();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}		
	}

}

