package gcj2010;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class SnapperChain
{
	public String solve(int devices, int snaps)
	{		
		int step = 2;
		for (int i = 1; i < devices; i++)
		{
			step *= 2;
		}
		
		int init = step - 1;
		if (snaps < init)
		{
			return "OFF";
		}
		else
		{
			snaps -= init;
			
			if ((snaps %= step) == 0)
			{
				return "ON";
			}
			else
			{
				return "OFF";
			}
		}		
	}
	
	public static void println(String s)
	{
		System.out.println(s);
		out.println(s);
		out.flush();
	}
	
	static PrintWriter out = null;
	static String inputFileName = "A-large.in";
	static String outputFileName = "b.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		SnapperChain test = new SnapperChain();
		try
		{
			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			out = new PrintWriter(new FileWriter(outputFileName));
			int testCaseNr = new Integer(inputFile.readLine()).intValue();

			for (int i = 0; i < testCaseNr; i++)
			{
				/** READ INPUT */
				String[] parts = inputFile.readLine().split(" ");
				
				/** TRANSFORM INPUT */
				int devices = new Integer(parts[0]).intValue();
				int snaps = new Integer(parts[1]).intValue();
				/** OUTPUT RESULTS */
				String result = test.solve(devices, snaps);
				println("Case #" + (i+1) + ": " + result);
			}			
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}