package gcj2017;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.BufferedWriter;
import java.io.FileWriter;

public class OversizedPancakeFlipper
{
	public String solve(String s)
	{
		String[] parts = s.split(" ");
		int size = new Integer(parts[1]).intValue();
		boolean[] pancakes = new boolean[parts[0].length()];
		for (int i = 0; i < parts[0].length(); i++)
		{
			if (parts[0].charAt(i) == '-')
			{
				pancakes[i] = false;
			}
			else
			{
				pancakes[i] = true;
			}
		}
		int flips = 0;
		int firstSad = 0;
		boolean possible = true;
		while (possible && firstSad < pancakes.length)
		{	//find first -
			while (firstSad < pancakes.length && pancakes[firstSad]) firstSad++;
			if (firstSad < pancakes.length)
			{	
				if (firstSad + size-1 >= pancakes.length)
				{	//if first-+size-1 > pancake count => impossible
					possible = false;
				}
				else
				{	//else flip [first-..first-+size-1]
					for (int i = 0; i < size; i++)
					{
						pancakes[firstSad+i] = !pancakes[firstSad+i];
					}
					//continue
					flips += 1;
				}
			}
		}
		StringBuffer sb = new StringBuffer("");
		if (!possible)
		{
			sb.append("IMPOSSIBLE");
		}
		else
		{
			sb.append(flips);
		}
		return sb.toString();
	}
	
	public static void main(String[] args)
	{
		// TODO Auto-generated method stub
		try
		{
			String inputFileName = "A-small-attempt0 (2).in";
			BufferedReader input = new BufferedReader(new FileReader(inputFileName));
			BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));
			String line = input.readLine();
			int cases = new Integer(line).intValue();
			OversizedPancakeFlipper test = new OversizedPancakeFlipper();
			for (int i = 0; i < cases; i++)
			{
				line = input.readLine();
				String out = "Case #" + (i+1) + ": " + test.solve(line);
				System.out.println(line);
				System.out.println(out);
				output.write(out + "\n");
			}
			output.flush();
			output.close();
			input.close();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

}
