package gcj2013;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class Lawnmower 
{
	public String solve(int[][] heights, int caseNr)
	{
		StringBuffer sb = new StringBuffer("");
		sb.append("Case #");
		sb.append(caseNr);
		sb.append(": ");
		sb.append(mow(heights));
		return sb.toString();
	}
	
	private String mow(int[][] heights)
	{
		int[] maxRowHeight = new int[heights.length];
		int[] maxColHeight = new int[heights[0].length];
		for (int row = 0; row < heights.length; row++)
		{
			for (int col = 0; col < heights[0].length; col++)
			{
				int temp = heights[row][col];
				if (temp > maxRowHeight[row]) maxRowHeight[row] = temp;
				if (temp > maxColHeight[col]) maxColHeight[col] = temp;
			}
		}
		
		for (int row = 0; row < heights.length; row++)
		{
			for (int col = 0; col < heights[0].length; col++)
			{
				int temp = heights[row][col];
				int cut = maxRowHeight[row];
				if (cut > maxColHeight[col]) cut = maxColHeight[col];
				if (cut != temp) return "NO";
			}
		}
		return "YES";
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		Lawnmower test = new Lawnmower();
		String fileName = "B-large.in.txt";
		String outName = "outBlarge.txt";
		try
		{
			BufferedReader br = new BufferedReader(new FileReader(fileName));
			String line = br.readLine();
			BufferedWriter bw = new BufferedWriter(new FileWriter(outName));
			int tests = new Integer(line).intValue();
			for (int i = 0; i < tests; i++)
			{
				line = br.readLine();
				String[] parts = line.split(" ");
				int rows = new Integer(parts[0]).intValue();
				int cols = new Integer(parts[1]).intValue();
				int[][] heights = new int[rows][cols];
				for (int j = 0; j < rows; j++)
				{
					line = br.readLine();
					parts = line.split(" ");
					for (int k = 0; k < cols; k++)
					{
						heights[j][k] = new Integer(parts[k]).intValue();
					}
				}
				String line2 = test.solve(heights, i+1);
				System.out.println(line2);
				bw.write(line2+"\n");
			}
			bw.flush();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}		
	}

}

