package gcj2010;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class SnapperChain
{
	public String solve(int devices, int snaps)
	{
		boolean[] power = new boolean[devices];
		boolean[] state = new boolean[devices];
		power[0] = true;
		
		for (int i = 0; i < snaps; i++)
		{
			//switch state of snappers with power
			for (int j = 0; j < devices; j++)
			{
				if (power[j])
				{
					state[j] = !state[j];
				}
			}
			
			//update power state
			for (int j = 1; j < devices; j++)
			{
				if (power[j-1] && state[j-1])
				{
					power[j] = true;
				}
				else
				{
					power[j] = false;
				}
			}
			
		}
		
		if (power[devices-1] && state[devices-1]) 
		{
			return "ON";
		}
		
		return "OFF";
	}
	
	public static void println(String s)
	{
		System.out.println(s);
		out.println(s);
		out.flush();
	}
	
	static PrintWriter out = null;
	static String inputFileName = "A-small-attempt1.in";
	static String outputFileName = "b.out";
	
	/**
	 * @param args
	 */
	public static void main(String[] args)
	{
		SnapperChain test = new SnapperChain();
		try
		{
			BufferedReader inputFile = new BufferedReader(new FileReader(inputFileName));
			out = new PrintWriter(new FileWriter(outputFileName));
			int testCaseNr = new Integer(inputFile.readLine()).intValue();

			for (int i = 0; i < testCaseNr; i++)
			{
				/** READ INPUT */
				String[] parts = inputFile.readLine().split(" ");
				
				/** TRANSFORM INPUT */
				int devices = new Integer(parts[0]).intValue();
				int snaps = new Integer(parts[1]).intValue();
				/** OUTPUT RESULTS */
				String result = test.solve(devices, snaps);
				println("Case #" + (i+1) + ": " + result);
			}
		}
		catch (FileNotFoundException e)
		{
			e.printStackTrace();
		}
		catch (IOException e)
		{
			e.printStackTrace();
		}
	}
}