import java.util.*;
import java.io.*;

public class Main {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            int N = in.nextInt();
            int K = in.nextInt();

            //Boolean = isOccupied
            HashMap<Integer, Boolean> stalls = new HashMap<Integer, Boolean>();
            ArrayList<Integer> occupiedStalls = new ArrayList<>();

            //INIT STALLS
            for (int j = 0; j < N + 2; j++) {

                if(j == 0 || j == N + 1) {
                    stalls.put(j, true);
                    occupiedStalls.add(j);
                }
                else
                    stalls.put(j, false);
            }
            //FOR EACH PERSON
            ArrayList<Integer> dists = null;
            for(int j = 0; j < K; j++) {
                //Search the farest occupied stall
                dists = new ArrayList<>();

                for(int k = 0; k < occupiedStalls.size() - 1; k++) {
                    dists.add(occupiedStalls.get(k + 1) - occupiedStalls.get(k) - 1);
                }
                occupiedStalls.add(getPosition(dists));

                //Sort dists array
                Collections.sort(occupiedStalls, new Comparator<Integer>() {
                    @Override
                    public int compare(Integer o1, Integer o2) {
                        if(o1 > o2)
                            return 1;
                        else if (o1 < o2)
                            return -1;
                        else
                            return 0;
                    }
                });
                stalls.put(getPosition(dists), true);

            }

            //Presenting the results
            int Rs = 0;
            int Ls = 0;

            int lastPos = getPosition(dists);
            //search right side
            while (true) {
                //Aren't occupied
                if(!stalls.get(lastPos + 1 + Rs)) {
                    Rs++;
                } else {
                    break;
                }
            }

            //search left side
            while (true) {
                //Aren't occupied
                if(!stalls.get(lastPos - 1 - Ls)) {
                    Ls++;
                } else {
                    break;
                }
            }

            if(Ls > Rs)
                System.out.println("Case #" + i + ": " + Ls + " " + Rs);
            else
                System.out.println("Case #" + i + ": " + Rs + " " + Ls);


        }
    }


    public static int getPosition(ArrayList<Integer> dists) {
        //Get the max and the max index
        int bestDist = 0;
        int index = 0;
        for(int i = 0; i < dists.size(); i++) {
            if(dists.get(i) > bestDist) {
                bestDist = dists.get(i);
                index = i;
            }
        }

        int distBefore = 0;
        for(int i = 0; i < index; i++) {
            distBefore += dists.get(i);
        }

        return (int) (index + distBefore + Math.round(bestDist / 2.0));

    }
}