import java.util.*;
import java.io.*;

public class Main {
    private static ArrayList<String> unicorns;

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
        for (int i = 1; i <= t; ++i) {
            int unicornsNb = in.nextInt();
            //                          R   Y   B
            int nbR = in.nextInt();//   1   0   0
            int nbO = in.nextInt();//   1   1   0
            int nbY = in.nextInt();//   0   1   0
            int nbG = in.nextInt();//   0   1   1
            int nbB = in.nextInt();//   0   0   1
            int nbV = in.nextInt();//   1   0   1

            unicorns = new ArrayList<>();

            for(int j = 0; j < nbR; j++) {
                unicorns.add("R");
            }
            for(int j = 0; j < nbO; j++) {
                unicorns.add("O");
            }
            for(int j = 0; j < nbY; j++) {
                unicorns.add("Y");
            }
            for(int j = 0; j < nbG; j++) {
                unicorns.add("G");
            }
            for(int j = 0; j < nbB; j++) {
                unicorns.add("B");
            }
            for(int j = 0; j < nbV; j++) {
                unicorns.add("V");
            }
            unicorns.set(1, unicorns.get(1));
            HashMap<String, ArrayList<String>> possibilities = new HashMap<>();
            possibilities.put("R", new ArrayList<>(Arrays.asList("Y", "G", "B")));
            possibilities.put("O", new ArrayList<>(Arrays.asList("B")));
            possibilities.put("Y", new ArrayList<>(Arrays.asList("R", "B", "V")));
            possibilities.put("G", new ArrayList<>(Arrays.asList("R")));
            possibilities.put("B", new ArrayList<>(Arrays.asList("R", "O", "Y")));
            possibilities.put("V", new ArrayList<>(Arrays.asList("Y")));
            int iterations;
            int maxIter = 100000;

            for(iterations = 0; iterations < maxIter; iterations++) {
                int corectness = 0;

                for (int j = 0; j < unicornsNb; j++) {
                    int afterIndex = j + 1 >= unicorns.size() ? 0 : j + 1;
                    int beforeIndex = j - 1 < 0 ? unicorns.size() - 1 : j - 1;

                    //SWAP
                    String currentU = unicorns.get(j);
                    String afterU = unicorns.get(afterIndex);
                    String beforeU = unicorns.get(beforeIndex);

                    if (!possibilities.get(currentU).contains(afterU) || !possibilities.get(currentU).contains(beforeU)) {
                        //Swap the two
                        swapUnicorn(j, afterU, afterIndex, currentU);
                    } else {
                        corectness++;
                    }

                }
                if(corectness == unicornsNb)
                    break;
                if(iterations % 100 == 0)
                    Collections.shuffle(unicorns);
            }

            if(iterations == maxIter) {
                System.out.println("Case #" + i + ": IMPOSSIBLE");
            } else {
                String result = "";
                for(String unicorn : unicorns)
                    result+= unicorn;
                System.out.println("Case #" + i + ": " + result);
            }


        }

    }



    public static void swapUnicorn(int indexA, String valueA, int indexB, String valueB) {
        unicorns.set(indexA, valueA);
        unicorns.set(indexB, valueB);
    }
}