import java.io.*;
import java.math.*;
import java.util.*;

public class CookieClicker {
  
  private static final String OUT_MESSAGE = "Case #";
  private static final double DEFAULT_SPEED = 2.0;
  private static final int PLACES = 7;
  
  
  public static void main(String args[]) throws IOException {
    
    BufferedReader rd = new BufferedReader(
                                           new InputStreamReader(System.in));
    
    int T = Integer.parseInt(rd.readLine());
    
    for (int i = 0; i < T; i++) {
      
      String[] c = rd.readLine().split(" ");
      double C = Double.parseDouble(c[0]);
      // System.out.println("\tC= " + C);
      double F = Double.parseDouble(c[1]);
      // System.out.println("\tF= " + F);
      double X = Double.parseDouble(c[2]);
      // System.out.println("\tX= " + X);
      
      double time = getTime(C, F, X);
      System.out.println(OUT_MESSAGE + (i + 1) + ": " + time);
    }
  }
  
  private static double getTime(double C, double F, double X) {
   
    PriorityQueue<Node> pq = new PriorityQueue<Node>(1, Node.getComparator());
    double currentTime = 0;
    Node xNode = new Node(NodeType.X, DEFAULT_SPEED, X / DEFAULT_SPEED, X);
    Node cNode = new Node(NodeType.C, DEFAULT_SPEED, C / DEFAULT_SPEED, C);
    pq.add(xNode);
    pq.add(cNode);
    
    while(pq.size() != 0) {
      
      Node currentNode = pq.poll();
      double currentF = currentNode.f;
      currentTime = currentNode.timeToReach;
      double soFar = currentNode.distance;
      
      if (currentNode.type == NodeType.X) {
        break;
      }
      
      Node xNewNode = new Node(NodeType.X, currentF, currentTime + (X - soFar) / currentF, X);
      Node cNewNode = new Node(NodeType.C, currentF + F, currentTime + C / (currentF + F), C);
      // Node cNewNode2 = new Node(NodeType.C, currentF, c + currentDistance ,timeStamp);
      pq.add(xNewNode);
      pq.add(cNewNode);
      // pq.add(cNewNode2);
      
    }
    
    BigDecimal bd = new BigDecimal(currentTime);
    bd = bd.setScale(PLACES, RoundingMode.HALF_UP);
    return bd.doubleValue();
  
  }
  
//  private static int[] getShift(String C, String F, String X) {
//    
//    while (C.endsWith("0")) C = C.substring(0, C.length() - 1);
//    int cShift = C.length() - (C.indexOf(".") + 1);
//    int maxShift = cShift;
//    while (F.endsWith("0")) F = F.substring(0, F.length() - 1);
//    int fShift = F.length() - (F.indexOf(".") + 1);
//    if (fShift > maxShift) {
//      maxShift = fShift;
//    } 
//    while (X.endsWith("0")) X = X.substring(0, X.length() - 1);
//    int xShift = X.length() - (X.indexOf(".") + 1);
//    if (xShift > maxShift) {
//      maxShift = xShift;
//    }
//    
//    C = C.replaceAll("\\.", "");
//    F = F.replaceAll("\\.", "");
//    X = X.replaceAll("\\.", "");
//    
//    int c = Integer.parseInt(C);
//    int f = Integer.parseInt(F);
//    int x = Integer.parseInt(X);
//    
//    c = c * (int) Math.pow(SHIFT_BASE, maxShift - cShift);
//    f = f * (int) Math.pow(SHIFT_BASE, maxShift - fShift);
//    x = x * (int) Math.pow(SHIFT_BASE, maxShift - xShift);
//    
//    int[] ret = new int[4];
//    ret[0] = c;
//    ret[1] = f;
//    ret[2] = x;
//    ret[3] = maxShift;
//    
//    return ret;
//    
//  }
  
  public enum NodeType{C, X};
  
  private static class Node {
    
    public NodeType type;
    public double f;
    public double timeToReach;
    public double distance;
    
    private static Comparator<Node> COMP = new Comparator<Node>() {
      public int compare(Node n1, Node n2) {
        double d1 = n1.timeToReach;
        double d2 = n2.timeToReach;
        int cmp = Double.compare(d1, d2);
        if (cmp < 0) return -1;
        if (cmp > 0) return 1;
        NodeType t1 = n1.type;
        NodeType t2 = n2.type;
        if (t1 == NodeType.C) return -1;
        if (t2 == NodeType.C) return 1;
        else return 0;
      }
    };
    
    public static Comparator<Node> getComparator() {
      return COMP;
    }
    
    public Node(NodeType t, double speed, double time, double dist) {
      type = t;
      f = speed;
      timeToReach = time;
      distance = dist;
    }
    @Override
    public String toString() {
      return "Type : " + type + "\tDistance : " + distance + "\t Rate : " + f + "\t t : " + timeToReach;
    }
  }
  
  
  
}
