import java.util.*;
import java.io.*;

public class MinesWeeper {
  
  private static final String OUT_MESSAGE = "Case #";
  private static final String OUT_IMPOSSIBLE = "Impossible";
  private static final String LS = System.getProperty("line.separator");
  
  private static final String MINE = "*";
  private static final String CLICK = "c";
  private static final String EMPTY = ".";
  
  public static void main(String[] args) throws IOException {
    
    BufferedReader rd = new BufferedReader(
                                           new InputStreamReader(System.in));
    
    int T = Integer.parseInt(rd.readLine());
    for (int i = 0; i < T; i++) {
      String[] inputs = rd.readLine().split(" ");
      int R = Integer.parseInt(inputs[0]);
      // System.out.println("R = " + R);
      int C = Integer. parseInt(inputs[1]);
      // System.out.println("C = " + C);
      int M = Integer.parseInt(inputs[2]);
      // System.out.println("M = " + M);
      
      String conf = getConfiguration(R, C, M);
      
      System.out.println(OUT_MESSAGE + (i + 1) + ":");
      if (conf == null) {
        System.out.println(OUT_IMPOSSIBLE);
      } else {
        System.out.println(conf);
      }
    }
  }
  
  private static String getConfiguration(int R, int C, int M) {
    
    String[]rows = new String[R];
    if (R == 1) {
      rows[0] = getLastLine(M, C);
      
    } else if (C == 1) {
      for (int i = 0; i < R; i++) {
        if (i < M) {
          rows[i] = getLine(M, C);
        } else if (i == R - 1) {
          rows[i] = getLastLine(0, C);
        } else {
          rows[i] = getLine(0, C);
        }
      }
    } else {
      if (C == 2) {
        if (M % 2 == 0) {
          int k = M / C;
          for (int i = 0; i < R; i++) {
            if (i < k) rows[i] = getLine(C, C);
            else if (i == R - 1) rows[i] = getLastLine(0, C);
            else rows[i] = getLine(0, C);
          }
        } else if (M == R * C - 1) {
          for (int i = 0; i < R; i++) {
            if (i == R - 1) rows[i] = getLastLine(1, C);
            else rows[i] = getLine(C, C);
          }
        } else return null;
      } else if (M  > (R - 2) * C) {
        
        if (M  > (R - 3) * C + (C - 2)) return null;
        
        int rest =  M % ((R - 2) * C);
        if (rest % 2 == 0) {
          if (rest < 2 * (C - 1)) {
            // special case 
            for (int i = 0; i < R; i++) {
              if (i < R - 2) rows[i] = getLine(C, C);
              else if (i == R - 2) rows[i] = getLine(rest/2, C);
              else rows[i] = getLastLine(rest/2, C);
            }
          } else {
            System.out.println("Even number, more than 4!");
            return null;
          }
          
        } else if (rest == 2 * C - 1) {
          // special case N-1 mines!
          for (int i = 0; i < R; i++) {
            if (i == R - 1) {
              rows[i] = getLastLine(C-1, C);
            } else {
              rows[i] = getLastLine(C, C);
            }
          }
        } else {
          System.out.println("Odd number, last 4!");
          return null;
        }
        
      } else {
         if (M  > (R - 3) * C + (C - 2)) return null;
        if (M % C == C - 1 && C > 1) {
          int k = M / C;
          for (int i = 0; i < R; i++) {
            if (i < k) rows[i] = getLine(C, C);
            else if (i == k) rows[i] = getLine(C - 2, C);
            else if (i == k + 1) rows[i] = getLine(1, C);
            else if (i == R - 1) rows[i] = getLastLine(0, C);
            else rows[i] = getLine(0, C);
          }
        } else {
          int k = M / C;
          for (int i = 0; i < R; i++) {
            if (i < k) rows[i] = getLine(C, C);
            else if (i == k) rows[i] = getLine(M % C, C);
            else if (i == R - 1) rows[i] = getLastLine(0, C);
            else rows[i] = getLine(0, C);
          }
        }
        
      }
    }
    StringBuilder sb = new StringBuilder();
    for (String s : rows) {
      sb.append(s);
      sb.append(LS);
    }
    return sb.toString();
  }
  
  private static String getLine(int m, int C) {
    StringBuilder sb = new StringBuilder();
    for (int i = 0; i < C; i++) {
      if (i < m) sb.append(MINE);
      else sb.append(EMPTY);
    }
    return sb.toString();
  }
  
  private static String getLastLine(int m, int C) {
    StringBuilder sb = new StringBuilder();
    for (int i = 0; i < C; i++) {
      if (i < m) sb.append(MINE);
      else if (i == C - 1) sb.append(CLICK);
      else sb.append(EMPTY);
    }
    return sb.toString();
  }
}
  
  