package pan.cake;

import static java.util.stream.Collectors.joining;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class PanCakes {

    static final String input = "inputs/panCakes/" + "A-large.in";
    static final String output = input.replaceAll(".in$", ".out");
    static BufferedWriter writer;

    public static void main(String[] args) throws FileNotFoundException, IOException {

        try (BufferedReader reader = new BufferedReader(new FileReader(input));
                BufferedWriter writer = new BufferedWriter(new FileWriter(output))) {
            PanCakes.writer = writer;
            skipOneLine(reader);
            String line = null;
            int i = 1;
            while ((line = reader.readLine()) != null) {
                compute(i++, line);
            }
        }
    }

    static void compute(int _testCase, String _line) {
        LineOfPanCakes panCakes = LineOfPanCakes.read(_line.split(" ")[0]);
        Flipper flipper = new Flipper(Integer.parseInt(_line.split(" ")[1]));

        int posOfFirstUnhappyPanCake = panCakes.posOfFirstUnhappyPanCake();
        int numberOfFlips = 0;

        while (posOfFirstUnhappyPanCake != -1) {
            debug(_testCase + ": " + numberOfFlips + " -> " + panCakes);

            if (panCakes.panCakes.size() < posOfFirstUnhappyPanCake + flipper.k) {
                log("Case #" + _testCase + ": IMPOSSIBLE");
                return;
            }
            flipper.flipAt(panCakes, posOfFirstUnhappyPanCake);
            numberOfFlips++;
            posOfFirstUnhappyPanCake = panCakes.posOfFirstUnhappyPanCake();

            if (posOfFirstUnhappyPanCake == -1) {
                break;
            }
        }

        log("Case #" + _testCase + ": " + numberOfFlips);
    }

    private static void skipOneLine(BufferedReader _reader) throws IOException {
        _reader.readLine();
    }

    static void log(String _msg) {
        System.out.println(_msg);
        try {
            writer.write(_msg);
            writer.write("\n");
        } catch (IOException _e) {
            _e.printStackTrace();
        }
    }

    static void debug(String _msg) {
        System.err.println(_msg);
    }

    static class PanCake {
        boolean happyUp;

        public PanCake(char _c) {
            happyUp = _c == '+';
        }

        void flip() {
            happyUp = !happyUp;
        }

        @Override
        public String toString() {
            return happyUp ? "+" : "-";
        }
    }

    static class LineOfPanCakes {
        final List<PanCake> panCakes;

        LineOfPanCakes(List<PanCake> _panCakes) {
            panCakes = _panCakes;
        }

        static LineOfPanCakes read(String _asString) {
            final List<PanCake> panCakes = new ArrayList<>();
            for (int i = 0; i < _asString.length(); i++) {
                panCakes.add(new PanCake(_asString.charAt(i)));
            }
            return new LineOfPanCakes(panCakes);
        }

        int posOfFirstUnhappyPanCake() {
            for (int i = 0; i < panCakes.size(); i++) {
                if (!panCakes.get(i).happyUp) {
                    return i;
                }
            }
            return -1;
        }

        @Override
        public String toString() {
            return panCakes.stream().map(Object::toString).collect(joining());
        }
    }

    static class Flipper {
        private final int k;

        Flipper(int _k) {
            k = _k;
        }

        void flipAt(LineOfPanCakes _lineOfPanCakes, int _pos) {
            for (int i = _pos; i < _pos + k; i++) {
                _lineOfPanCakes.panCakes.get(i).flip();
            }
        }
    }

}
