package pan.cakes;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class PanCakes {

    public static void main(String[] args) throws FileNotFoundException, IOException {

        disableDebug();

        try (BufferedReader reader = new BufferedReader(new FileReader("inputs/panCakes/B-large.in"))) {
            skipOneLine(reader);
            String line = null;
            int i = 1;
            while ((line = reader.readLine()) != null) {
                compute(i++, line);
            }
        }

    }

    private static void disableDebug() {
        System.setErr(new PrintStream(new OutputStream() {
            @Override
            public void write(int _b) throws IOException {
            }
        }));
    }

    private static void compute(int _testCase, String _line) {
        Stack stack = new Stack(_line);
        System.err.format("new stack: %s\n", stack);

        int i = 0;
        while (!stack.allHappy()) {
            i++;
            stack.flip(stack.firstUnHappyFromBottom());
            System.err.format("%s. flip to %s\n", i, stack);
        }
        System.out.format("Case #%s: %s\n", _testCase, i);
    }

    private static void skipOneLine(BufferedReader _reader) throws IOException {
        _reader.readLine();
    }

    private static class Stack {
        final List<PanCake> stack;

        Stack(String _panCakes) {
            stack = Stream.of(_panCakes.split("(?!^)")).map(pc -> new PanCake(pc)).collect(Collectors.toList());
        }

        void flip(int _numberOfCakes) {
            for (int i = 0; i <= _numberOfCakes; i++) {
                stack.get(i).flip();
            }
        }

        int firstUnHappyFromBottom() {
            for (int i = stack.size() - 1; i >= 0; i--) {
                if (!stack.get(i).happyUp) {
                    return i;
                }
            }
            return -1;
        }

        boolean allHappy() {
            return stack.stream().allMatch(pc -> pc.happyUp);
        }

        @Override
        public String toString() {
            return stack.stream().map(p -> p.toString()).collect(Collectors.joining(""));
        }

    }

    private static class PanCake {
        boolean happyUp;

        public PanCake(String _panCake) {
            happyUp = _panCake.equals("+");
        }

        void flip() {
            happyUp = !happyUp;
        }

        @Override
        public String toString() {
            return happyUp ? "+" : "-";
        }

    }

}
