package counting.sheep;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Set;
import java.util.TreeSet;

public class CountingSheep {

    public static void main(String[] args) throws FileNotFoundException, IOException {

        disableDebug();

        try (BufferedReader reader = new BufferedReader(new FileReader("inputs/coutingSheep/A-large.in"))) {
            skipOneLine(reader);
            String line = null;
            int i = 1;
            while ((line = reader.readLine()) != null) {
                compute(i++, line);
            }
        }

    }

    private static void disableDebug() {
        System.setErr(new PrintStream(new OutputStream() {
            @Override
            public void write(int _b) throws IOException {
            }
        }));
    }

    private static void compute(int _testCase, String _line) {
        BigInteger start = new BigInteger(_line);
        Digits digits = new Digits();
        BigInteger current = start;

        digits.add(current.toString());
        System.err.println(String.format("#{} adding {}", _testCase, current));
        while (!digits.allDigitsSeen()) {
            BigInteger saveLast = current;
            current = current.add(start);
            if (current.equals(saveLast)) {
                System.out.println("Case #" + _testCase + ": INSOMNIA");
                return;
            }
            digits.add(current.toString());
            System.err.println(String.format("#%s adding %s", _testCase, current));
        }

        System.out.println("Case #" + _testCase + ": " + current);
    }

    private static void skipOneLine(BufferedReader _reader) throws IOException {
        _reader.readLine();
    }

    private static class Digits {
        Set<String> digitsSoFar = new TreeSet<>();
        Set<String> expectedDigits = new TreeSet<>(Arrays.asList("0123456789".split("(?!^)")));

        void add(String _newDigits) {
            digitsSoFar.addAll(Arrays.asList(_newDigits.split("(?!^)")));
        }

        boolean allDigitsSeen() {
            return digitsSoFar.equals(expectedDigits);
        }

        @Override
        public String toString() {
            return digitsSoFar.toString();
        }

    }

}
