package tidy.numbers;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TidyNumbers {

    static final String input = "inputs/tidyNumbers/" + "B-small-attempt0.in";
    static final String output = input.replaceAll(".in$", ".out");
    static BufferedWriter writer;

    public static void main(String[] args) throws FileNotFoundException, IOException {

        try (BufferedReader reader = new BufferedReader(new FileReader(input));
                BufferedWriter writer = new BufferedWriter(new FileWriter(output))) {
            TidyNumbers.writer = writer;
            reader.readLine();
            String line = null;
            int i = 1;
            while ((line = reader.readLine()) != null) {
                compute(i++, line);
            }
        }
    }

    private static void compute(int _i, String _line) {
        TatianasNumber number = new TatianasNumber(_line);
        int pos = 0;
        do {
            pos = number.unTidyAt();
            debug(_i + ": " + number + " tidy: " + pos);
            if (pos >= 0) {
                number.tidyAt(pos);
            }
        } while (pos >= 0);

        log("Case #" + _i + ": " + number);
    }

    static void log(String _msg) {
        System.out.println(_msg);
        try {
            writer.write(_msg);
            writer.write("\n");
        } catch (IOException _e) {
            _e.printStackTrace();
        }
    }

    static void debug(String _msg) {
        System.err.println(_msg);
    }

    static class TatianasNumber {
        String digits = "";

        TatianasNumber(String _digits) {
            digits = _digits;
        }

        void tidyAt(int pos) {
            int n = Character.getNumericValue(digits.charAt(pos)) - 1;
            String newDigits = digits.substring(0, pos);
            newDigits += n;
            for (int i = pos + 1; i < digits.length(); i++) {
                newDigits += 9;
            }

            while (newDigits.startsWith("0")) {
                newDigits = newDigits.substring(1);
            }

            digits = newDigits;
        }

        int unTidyAt() {
            for (int i = 0; i < digits.length() - 1; i++) {
                int a = Character.getNumericValue(digits.charAt(i));
                int b = Character.getNumericValue(digits.charAt(i + 1));
                if (a > b)
                    return i;
            }
            return -1;
        }

        @Override
        public String toString() {
            return digits;
        }

    }

}
