/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package googlecodejam2012;

import java.io.*;
import java.util.HashSet;
import java.util.Random;

/**
 *
 * @author Stephen
 */
class Coord {

    public Coord(double xVal, double yVal) {
        x = xVal;
        y = yVal;
    }
    public double x;
    public double y;

    public String stringify() {
        return "(" + x + ", " + y + ")";
    }

    public double distFromCoord(Coord other) {
        return Math.sqrt((other.x - x) * (other.x - x) + (other.y - y) * (other.y - y));
    }

    public double distFromXY(double otherX, double otherY) {
        return Math.sqrt((otherX - x) * (otherX - x) + (otherY - y) * (otherY - y));
    }
}

public class GoogleCodeJam2012Round2N2 {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            FileInputStream fs = new FileInputStream("input.txt");
            DataInputStream in = new DataInputStream(fs);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            FileWriter fws = new FileWriter("output.txt");
            BufferedWriter out = new BufferedWriter(fws);
            String numLine = br.readLine();
            System.out.println(numLine);
            int numCases = Integer.parseInt(numLine);
            String caseLine;
            for (int i = 1; i <= numCases; i++) {
                caseLine = br.readLine();
                System.out.println("Case #" + i);
                String[] splitted = caseLine.split(" ");
                int N = Integer.parseInt(splitted[0]);
                int W = Integer.parseInt(splitted[1]);
                int L = Integer.parseInt(splitted[2]);
                
                System.out.println(N+", "+W+", "+L);

                int[] reaches = new int[N];
                Coord[] coords = new Coord[N];

                caseLine = br.readLine();
                splitted = caseLine.split(" ");

                for (int j = 0; j < N; j++) {
                    reaches[j] = Integer.parseInt(splitted[j]);
                }

                HashSet<Integer> stillNeedsPlaced = new HashSet<Integer>();
                HashSet<Integer> alreadyPlaced = new HashSet<Integer>();
                for (int j = 0; j < N; j++) {
                    stillNeedsPlaced.add(j);
                    coords[j] = null;
                }

                Random random = new Random();

                boolean solutionFound = false;
                
                while (!solutionFound) {
                    solutionFound = true;
                    while (!stillNeedsPlaced.isEmpty()) {
                        System.out.println("Trying to place a circle...");
                        int size = stillNeedsPlaced.size();
                        int element = random.nextInt(size);
                        int picked = 0;
                        int count = 0;
                        for (Integer val : stillNeedsPlaced) {
                            if (count == element) {
                                picked = val;
                            }
                            count++;
                        }
                        stillNeedsPlaced.remove(picked);
                        if (stillNeedsPlaced.size() == N - 1) { // This is first circle.
                            coords[picked] = new Coord(0, 0);
                            System.out.println("Placing a circle radius "+reaches[picked]+" at (0, 0)");
                        } else if(stillNeedsPlaced.size() == N - 2) {
                            for(double angle = 0.0; angle < Math.PI*2; angle+=0.006) {
                                int choseVal = 0;
                                for (Integer val : alreadyPlaced) {
                                    choseVal = val;
                                }
                                double sepdist = reaches[choseVal] + reaches[picked];
                                double xPlace = sepdist * Math.sin(angle);
                                double yPlace = sepdist * Math.cos(angle);
                                if(xPlace >= 0 && yPlace >= 0 && xPlace <= W && yPlace <= L) {
                                    coords[picked] = new Coord(xPlace, yPlace);
                                    System.out.println("Placing a circle radius "+reaches[picked]+" at ("+xPlace+", "+yPlace+")");
                                    break;
                                }
                            }
                        } else {
                            boolean ploppedDownCircle = false;
                            for (Integer val : alreadyPlaced) {
                                double angle = 0.0;
                                double sepdist = reaches[val] + reaches[picked];
                                boolean couldPutDown = true;
                                double xPlace = coords[val].x + sepdist * Math.sin(angle);
                                double yPlace = coords[val].y + sepdist * Math.cos(angle);
                                boolean placed = false;
                                boolean lastWasGood = false;
                                while (!placed && angle < Math.PI*2) {
                                    xPlace = coords[val].x + sepdist * Math.sin(angle);
                                    yPlace = coords[val].y + sepdist * Math.cos(angle);
                                    boolean allGood = true;
                                    for (Integer val2 : alreadyPlaced) {
                                        if (coords[val2].distFromXY(xPlace, yPlace) < (reaches[picked] + reaches[val2])) {
                                            allGood = false;
                                            if (lastWasGood) {
                                                double tempangle = angle-0.006;
                                                xPlace = coords[val].x + sepdist * Math.sin(tempangle);
                                                yPlace = coords[val].y + sepdist * Math.cos(tempangle);
                                                if(xPlace >= 0 && yPlace >= 0 && xPlace <= W && yPlace <= L)
                                                    placed = true;
                                            }
                                            break;
                                        }
                                    }
                                    lastWasGood = allGood;
                                    angle += 0.006;
                                }
                                if(placed) {
                                    //System.out.println("Placing a circle "+reaches[picked]+" at ("+xPlace+", "+yPlace+")");
                                    coords[picked] = new Coord(xPlace, yPlace);
                                    ploppedDownCircle = true;
                                    break;
                                } else {
                                    //System.out.println("Failed to place circle");
                                }
                            }
                            if(!ploppedDownCircle) {
                                stillNeedsPlaced.clear();
                                solutionFound = false;
                            }
                        }
                        alreadyPlaced.add(picked);
                    }
                }

                String answer = "";
                for(int a = 0; a < N; a++) {
                    answer += coords[a].x;
                    answer += " ";
                    answer += coords[a].y;
                    if(a != N-1)
                        answer += " ";
                }
                System.out.println("Ans: " + answer);
                out.write("Case #" + i + ": " + answer + "\r\n");
            }
            in.close();
            out.close();

            displayOutput();
        } catch (Exception e) {
            System.err.println("Oops! Error occured: " + e.getMessage());
        }
    }

    public static void displayOutput() {
        System.out.println("START OUTPUT\n-------------------");
        try {
            FileInputStream fs = new FileInputStream("output.txt");
            DataInputStream in = new DataInputStream(fs);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String readLine;
            while ((readLine = br.readLine()) != null) {
                System.out.println(readLine);
            }
        } catch (Exception e) {
            System.err.println("Oops! Error occured: " + e.getMessage());
        }
        System.out.println("---------------------\nEND OUTPUT");
    }
}
