/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package googlecodejam2012;

import java.io.*;
import java.util.HashSet;

/**
 *
 * @author Stephen
 */

    class Vine {
        public Vine(int xcord, int len) {
            x = xcord;
            length = len;
            maxdrop = 0;
            changed = false;
            soonChanged = false;
        }
        public int x;
        public int length;
        public int maxdrop;
        public boolean changed;
        public boolean soonChanged;
        
        public double hash() {
            return (double)x/2616.0+(double)length/2386736.0+(double)maxdrop/28271.0;
        }
        
        public String stringify() {
            return "X: "+x+" Length: "+length+" maxdrop: "+maxdrop;
        }
    }

public class GoogleCodeJam2012Round2N1 {
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try 
        {
            FileInputStream fs = new FileInputStream("input.txt");
            DataInputStream in = new DataInputStream(fs);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            FileWriter fws = new FileWriter("output.txt");
            BufferedWriter out = new BufferedWriter(fws);
            String numLine = br.readLine();
            System.out.println(numLine);
            int numCases = Integer.parseInt(numLine);
            String caseLine;
            for(int i = 1; i <= numCases; i++)
            {
                caseLine = br.readLine();
                System.out.println("Case #"+i);
                int N = Integer.parseInt(caseLine);
                Vine[] vines = new Vine[N];
                for(int j = 0; j < N; j++) {
                    caseLine = br.readLine();
                    String[] splitted = caseLine.split(" ");
                    int x = Integer.parseInt(splitted[0]);
                    int height = Integer.parseInt(splitted[1]);
                    Vine vine = new Vine(x, height);
                    vines[j] = vine;
                }
                caseLine = br.readLine();
                int D = Integer.parseInt(caseLine);
                vines[0].changed = true;
                vines[0].maxdrop = vines[0].x;
                
                boolean foundExit = false;
                double prevHash = 0;
                double nowHash = sumHash(vines);
                
                int iter = 0;
                while(prevHash!=nowHash && !foundExit) {
                    iter++;
                    System.out.println("Iteration: "+iter);
                    for(int j = 0; j < N; j++) {
                        if(vines[j].changed) { // Only have to process changed vines.
                            for(int k = 0; k < N; k++) {
                                int dist = Math.abs(vines[k].x-vines[j].x);
                                if(dist <= vines[j].maxdrop && dist > vines[k].maxdrop) {
                                    vines[k].maxdrop = dist;
                                    if(vines[k].maxdrop > vines[k].length)
                                        vines[k].maxdrop = vines[k].length;
                                    vines[k].soonChanged = true;
                                }
                            }
                            if(vines[j].maxdrop+vines[j].x >= D) {
                                foundExit = true;
                            }
                            vines[j].changed = false;
                        }
                    }
                    for(int j = 0; j < N; j++) {
                        if(vines[j].soonChanged) {
                            vines[j].soonChanged = false;
                            vines[j].changed = true;
                        }
                        //System.out.println(vines[j].stringify());
                    }
                    prevHash = nowHash;
                    nowHash = sumHash(vines);
                }
                
                System.out.println("Case #"+i+": "+foundExit);
                String stuff = "NO";
                if(foundExit)
                    stuff = "YES";
                out.write("Case #"+i+": "+stuff+"\r\n");
            }
            in.close();
            out.close();
            
            displayOutput();
        } 
        catch (Exception e) 
        {
            System.err.println("Oops! Error occured: " + e.getMessage());
        }
    }
    
    public static double sumHash(Vine[] vines) {
        double ret = 0;
        for(int i = 0; i < vines.length; i++) {
            ret += vines[i].hash();
        }
        return ret;
    }
    
    public static void displayOutput()
    {
        System.out.println("START OUTPUT\n-------------------");
        try
        {
            FileInputStream fs = new FileInputStream("output.txt");
            DataInputStream in = new DataInputStream(fs);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String readLine;
            while ((readLine = br.readLine()) != null)   {
                System.out.println(readLine);
            }
        }
        catch (Exception e) 
        {
            System.err.println("Oops! Error occured: " + e.getMessage());
        }
        System.out.println("---------------------\nEND OUTPUT");
    }
}
