package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.RoundingMode;

public class CookieClickerAlpha {
	private static BufferedReader bufferedReader;
	private static BufferedWriter bufferedWriter;
	private static final BigDecimal normalRate = new BigDecimal("2");

	public static void main(String[] args) throws IOException {
		bufferedReader = new BufferedReader(new FileReader("B-small-attempt0.in"));
		bufferedWriter = new BufferedWriter(new FileWriter("B-small-attempt0.out"));
		int puzzleCount = Integer.valueOf(bufferedReader.readLine());
		for (int i = 0; i < puzzleCount; i++) {
			String line = bufferedReader.readLine();
			String[] params = line.split(" ");
			BigDecimal farmValue = new BigDecimal(params[0]);
			BigDecimal farmProductive = new BigDecimal(params[1]);
			BigDecimal target = new BigDecimal(params[2]);
			BigDecimal time = target.divide(normalRate, 7, RoundingMode.HALF_UP);
			int buyFarmTimes = 1;
			while (checkTime(farmValue, farmProductive, target, buyFarmTimes).compareTo(time) < 0) {
				time = checkTime(farmValue, farmProductive, target, buyFarmTimes);
				buyFarmTimes++;
			}
			writeFile("Case #" + (i + 1) + ": " + time.toPlainString());
		}
		bufferedReader.close();
		bufferedWriter.close();
	}

	private static BigDecimal checkTime(BigDecimal farmValue, BigDecimal farmProductive, BigDecimal target,
			int buyFarmTime) {
		BigDecimal result = BigDecimal.ZERO;
		BigDecimal productive = normalRate;
		for (int i = 0; i < buyFarmTime; i++) {
			result = result.add(farmValue.divide(productive, 7, RoundingMode.HALF_UP));
			productive = productive.add(farmProductive);
		}
		result = result.add(target.divide(productive, 7, RoundingMode.HALF_UP));
		return result;
	}

	private static void writeFile(String string) throws IOException {
		bufferedWriter.write(string + "\n");
	}
}
