package com.shanyang;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Robot {

	private List<Task> tasks = new ArrayList<Task>();
	private Task currentTask;
	int robotPosition = 1;
	private String robotName;

	public Robot(String robotName) {
		this.robotName = robotName;
	}

	public void addTask(int i, Integer position) {
		Task task = new Task(i, position);
		tasks.add(task);
		if (currentTask == null) {
			currentTask = task;
		}
		System.out.println("task added:" + task);
	}

	public boolean performTask(int buttonPressed) {
		if (currentTask == null)
			return false;
		if (robotPosition != currentTask.taskTarget) {
			if (robotPosition > currentTask.taskTarget) {
				System.out.println(robotName + " back to " + robotPosition);
				robotPosition--;
			} else {
				robotPosition++;
				System.out.println(robotName + " go to " + robotPosition);
			}
			return false;
		} else {
			if (currentTask.taskNumber == buttonPressed) {
				System.out.println(robotName + " press button" + currentTask.taskTarget);
				tasks.remove(currentTask);
				Iterator<Task> iterator = tasks.iterator();
				if (iterator.hasNext()) {
					currentTask = iterator.next();
				}
				return true;
			}
			System.out.println(robotName + " stay at " + robotPosition);
			return false;
		}
	}
}
