package com.magicka;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Stack;

public class Magicka {
	private boolean combineMark = false;

	private String invoke(String line) {
		String[] lines = line.split("(?<=\\d|\\w+)\\s(?=\\d)");
		String[] split = lines[0].split("\\s");
		String combineRuleTotal = split.length > 1 ? split[1] : "";
		String combineRule = "";
		String combineResult = "";
		if (combineRuleTotal != "") {
			combineRule = combineRuleTotal.substring(0, 2);
			combineResult = combineRuleTotal.substring(2, 3);
		}
		String[] split2 = lines[1].split("\\s");
		String opposedRule = split2.length > 1 ? split2[1] : "";
		String invokeString = lines[2].split("\\s")[1];
		Stack<CharSequence> result = new Stack<CharSequence>();
		for (int i = 0; i < invokeString.length(); i++) {
			CharSequence currentChar = invokeString.subSequence(i, i + 1);
			if (!combineRule.contains(currentChar) && !opposedRule.contains(currentChar)) {
				result.push(currentChar);
				continue;
			}
			if (combineRule.contains(currentChar)) {
				String leftPair = combineRule.replaceFirst(String.valueOf(currentChar), "");
				if (needToCombine(result, leftPair)) {
					result.pop();
					result.push(combineResult);
					combineMark = false;
					continue;
				}
			}
			if (opposedRule.contains(currentChar)) {
				String leftPair = opposedRule.replaceFirst(String.valueOf(currentChar), "");
				if (needToClear(result, leftPair)) {
					result.clear();
					combineMark = false;
					continue;
				}
			}
			combineMark  = true;
			result.push(currentChar);
		}
		return result.toString();
	}

	private boolean needToClear(Stack<CharSequence> result, String leftPair) {
		return !result.isEmpty() && result.contains(leftPair);
	}

	private boolean needToCombine(Stack<CharSequence> result, String leftPair) {
		return !result.isEmpty() && result.peek().equals(leftPair) && combineMark;
	}

	public static void main(String[] args) throws IOException {
		Magicka magicka;
		BufferedReader reader = new BufferedReader(new FileReader(
				"C:/Users/Battlefly/workspace/test/src/com/Magicka/B-large.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter(
				"C:/Users/Battlefly/workspace/test/src/com/Magicka/test.out"));
		reader.readLine();
		String line = reader.readLine();
		int i = 0;
		while (line != null) {
			magicka = new Magicka();
			i++;
			writer.append("Case #" + i + ": " + magicka.invoke(line) + "\n");
			System.out.println("Case #" + i + ": " + magicka.invoke(line) + "\n");
			writer.flush();
			line = reader.readLine();
		}
	}

}
