import java.io.*;
import java.util.*;
public class B
{
    public static void main (String args[]) throws FileNotFoundException, IOException
    {
        BufferedReader inputStream = new BufferedReader(new FileReader("input.txt"));
        inputStream.readLine();
        String line;
        int caseNumber = 1;
        int[][] caseValue = null;
        int rows = 0;
        int columns = 0;
        int currentLine = -1;
        while((line = inputStream.readLine()) != null)
        {
            if(currentLine == -1)
            {
                String[] parts = line.split(" ");
                rows = Integer.parseInt(parts[0]);
                columns = Integer.parseInt(parts[1]);
                caseValue = new int[rows][columns];
                currentLine = 0;
            }
            else
            {
                String[] parts = line.split(" ");
                
                for(int i = 0; i < parts.length; i++)
                {
                    caseValue[currentLine][i] = Integer.parseInt(parts[i]);
                }

                currentLine++;
                if(currentLine == rows)
                {
                    processLine(caseNumber, caseValue, rows, columns);
                    currentLine = -1;
                    caseNumber++;
                }
            }
        }
        inputStream.close();
    }

    public static void processLine(int lineNumber, int[][] value, int rows, int columns)
    { 
        if(CheckLawn(value, rows, columns))
        {
            outputLine(lineNumber, "YES");
        }
        else
        {
            outputLine(lineNumber, "NO");
        }
    } 

    private static boolean CheckLawn(int[][] grid, int rows, int columns)
    {
        if(rows == 1 || columns == 1)
        {
            return true;
        }

        for(int row = 0; row < rows; row++)
        {
            for(int column = 0; column < columns; column++)
            {
                int current = grid[row][column];
                int largestInRow = largestInRow(grid, row);
                int largestInColumn = largestInColumn(grid, column);
                if(current < largestInRow && current < largestInColumn)
                    return false;
            }
        }
        return true;
    }

    private static int countInColumn(int[][] grid, int column, int value)
    {
        int count = 0;
        for(int i = 0; i < grid.length; i++)
        {
            if(grid[i][column] == value)
                count++;
        }
        return count;
    }

    private static int largestInColumn(int[][] grid, int column)
    {
        int largest = 0;
        for(int i = 0; i < grid.length; i++)
        {
            if(grid[i][column] > largest)
                largest = grid[i][column];
        }
        return largest;
    }

    private static int largestInRow(int[][] grid, int row)
    {
        int largest = 0;
        for(int i = 0; i < grid[row].length; i++)
        {
            if(grid[row][i] > largest)
                largest = grid[row][i];
        }
        return largest;
    }

    private static int countInRow(int[][] grid, int row, int value)
    {
        int count = 0;
        for(int i = 0; i < grid[row].length; i++)
        {
            if(grid[row][i] == value)
                count++;
        }
        return count;
    }

    public static void outputLine(int lineNumber, String value)
    { 
        System.out.println("Case #" + lineNumber + ": " + value); 
    } 
}
