import java.io.*;
import java.util.*;
public class A
{
    enum LineWinner{X,O,Nobody,Draw,Incomplete}
    public static void main (String args[]) throws FileNotFoundException, IOException
    {
        BufferedReader inputStream = new BufferedReader(new FileReader("input.txt"));
        inputStream.readLine();
        String line;
        String caseValue = "";
        int caseNumber = 1;
        while((line = inputStream.readLine()) != null)
        {
            if(line.equals(""))
            {
                processLine(caseNumber, caseValue);
                caseValue = "";
                caseNumber++;
            }
            else
            {
                caseValue += line;
            }
        }
        inputStream.close();
    }
    
    public static void processLine(int lineNumber, String value)
    { 
        switch(DetermineWinner(value))
        {
            case X:
                outputLine(lineNumber, "X won");
                break;
            case O:
                outputLine(lineNumber, "O won");
                break;
            case Draw:
                outputLine(lineNumber, "Draw");
                break;
            default:
                outputLine(lineNumber, "Game has not completed");
                break;
        }
    } 

    private static LineWinner DetermineWinner(String game)
    {
        for(int i = 0; i < 4;i++)
        {
            if(game.charAt(i*4) == 'X' || game.charAt(i*4) == 'O' || game.charAt(i*4) == 'T')
            {
                // row
                String row = game.substring(i*4, i*4+4);
                LineWinner winner = FindWinner(row);
                if(winner != LineWinner.Nobody)
                    return winner;
            }
            if(game.charAt(i) == 'X' || game.charAt(i) == 'O' || game.charAt(i) == 'T')
            {
                //column
                String column = game.substring(i, i+1) + game.substring(i + 4, i+5) + game.substring(i + 8, i+9) + game.substring(i + 12, i+13);
                LineWinner winner = FindWinner(column);
                if(winner != LineWinner.Nobody)
                    return winner;
            }
        }
        // diag 
        String diag = game.substring(0, 1) + game.substring(5, 6) + game.substring(10, 11) + game.substring(15,16);
        LineWinner winner = FindWinner(diag);
        if(winner != LineWinner.Nobody)
            return winner;
        // diag2
        diag = game.substring(3, 4) + game.substring(6,7) + game.substring(9,10) + game.substring(12, 13);
        winner = FindWinner(diag);
        if(winner != LineWinner.Nobody)
            return winner;

        int dotCount = countMatches(game, ".");
        if(dotCount == 0)
            return LineWinner.Draw;

        return LineWinner.Incomplete;
    }

    public static LineWinner FindWinner(String line)
    {
        int xCount = countMatches(line, "X");
        boolean hasT = line.contains("T");
        if(xCount == 4)
            return LineWinner.X;
        if(xCount == 3 && hasT)
            return LineWinner.X;
        int oCount = countMatches(line, "O");
        if(oCount == 4)
            return LineWinner.O;
        if(oCount == 3 && hasT)
            return LineWinner.O;
        return LineWinner.Nobody;
    }

    public static int countMatches(String value, String character)
    {
        return value.replaceAll("[^" + character + "]", "").length();
    }
    
    public static void outputLine(int lineNumber, String value)
    { 
        System.out.println("Case #" + lineNumber + ": " + value); 
    } 
}
