import java.io.*;
import java.util.*;
public class C
{
    public static void main (String args[]) throws FileNotFoundException, IOException
    {
        BufferedReader inputStream = new BufferedReader(new FileReader("input.txt"));
        inputStream.readLine();
        String line;
        int lineNumber = 1;
        while((line = inputStream.readLine()) != null)
        {
            processLine(lineNumber, line);
            lineNumber++;
        }
        inputStream.close();
    }

    public static void processLine(int lineNumber, String value)
    { 
        String[] parts = value.split(" ");
        long start = Long.parseLong(parts[0]);
        long end = Long.parseLong(parts[1]);
        long sqrt = (long)Math.sqrt((double)end);

        int palindromes = 0;
        for(long i = start; i <= end; i++)
        {
            if(isPerfectSquare(i))
            {
                String number = Long.toString(i);

                if((new StringBuffer(number)).reverse().toString().equals(number))
                {
                    String sqString = Long.toString((long)Math.sqrt(i));
                    String square = Long.toString(i*i);
                    if((new StringBuffer(sqString)).reverse().toString().equals(sqString))
                    {
                        /*        System.out.println("number " + number);
                                  System.out.println("sqString " + sqString);*/
                        palindromes++;
                    }
                }
            }
        }
        outputLine(lineNumber, Integer.toString(palindromes));
    } 

    private final static boolean isPerfectSquare(long n)
    {
        if (n < 0)
            return false;

        switch((int)(n & 0x3F))
        {
            case 0x00: case 0x01: case 0x04: case 0x09: case 0x10: case 0x11:
            case 0x19: case 0x21: case 0x24: case 0x29: case 0x31: case 0x39:
                long sqrt;
                if(n < 410881L)
                {
                    //John Carmack hack, converted to Java.
                    // See: http://www.codemaestro.com/reviews/9
                    int i;
                    float x2, y;

                    x2 = n * 0.5F;
                    y  = n;
                    i  = Float.floatToRawIntBits(y);
                    i  = 0x5f3759df - ( i >> 1 );
                    y  = Float.intBitsToFloat(i);
                    y  = y * ( 1.5F - ( x2 * y * y ) );

                    sqrt = (long)(1.0F/y);
                }
                else
                {
                    //Carmack hack gives incorrect answer for n >= 410881.
                    sqrt = (long)Math.sqrt(n);
                }
                return sqrt*sqrt == n;

            default:
                return false;
        }
    }

    public static void outputLine(int lineNumber, String value)
    { 
        System.out.println("Case #" + lineNumber + ": " + value); 
    } 
}
