/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package googlejam;

import java.io.*;
import java.util.*;

/**
 *
 * @author a.bogdanov
 */
public class GoogleJam_DontBreakNile {
	static class cell{
		
		cell(int i, int j){
			this.x = i;
			this.y = j;
			next = new HashSet<cell>(); 
			this.prev = null;
		}
		HashSet<cell> next;
		boolean isStart;
		boolean isEnd;
		int x;
		int y;
		cell prev;
		cell pathPrev;
		boolean marked;
	}
	
    public static final String problemLetter = "C";
    static ArrayList<cell> field;
    static cell[][] arrField;
    static int W;
    static int H;
    static int B;
    static int[] X0;
    static int[] X1;
    static int[] Y0;
    static int[] Y1;
    static cell start;
    static cell end;

    static boolean findPath(){
    	for(cell z:field){
    		z.marked = false;
    		z.pathPrev = null;
    	}
    	Queue<cell> q = new LinkedList<cell>();
    	q.add(start);
    	start.marked = true;
    	while(!q.isEmpty()){
    		cell v = q.poll();
			if(v.prev != null){
				if(v.pathPrev.prev == v){
		    		for(cell e:v.next){
		    			if(!e.marked){
			    			e.pathPrev = v;
			    			e.marked = true;
			    			q.add(e);
		    			}
		    		}
				}else{
					if(!v.prev.marked){
						v.prev.pathPrev = v;
						v.prev.marked = true;
						q.add(v.prev);
					}
				}
			}else{
	    		for(cell e:v.next){
	    			if(!e.marked){
		    			e.pathPrev = v;
		    			e.marked = true;
		    			q.add(e);
	    			}
	    		}
			}
    	}
    	return end.marked;
    }
    
    static boolean check(int x, int y){
    	if(x>=0&&x<W&&y>=0&&y<H){
	    	for(int q=0;q<B;q++){
	    		if(x>=X0[q]&&x<=X1[q]&&y>=Y0[q]&&y<=Y1[q]){
	    			return false;
	    		}
	    	}
	    	return true;
    	}else{
    		return false;
    	}
    }
    
    public static void solve(BufferedReader reader, PrintWriter writer) throws IOException{
        int caseCount = Integer.parseInt(reader.readLine());
        for(int caseNum=1; caseNum<=caseCount; caseNum++){
            String[] str = reader.readLine().split(" ");
            W = Integer.parseInt(str[0]);
            H = Integer.parseInt(str[1]);
            B = Integer.parseInt(str[2]);
            X0 = new int[B];
            X1 = new int[B];
            Y0 = new int[B];
            Y1 = new int[B];
            for(int i=0;i<B;i++){
                str = reader.readLine().split(" ");
                X0[i] = Integer.parseInt(str[0]);
                Y0[i] = Integer.parseInt(str[1]);
                X1[i] = Integer.parseInt(str[2]);
                Y1[i] = Integer.parseInt(str[3]);
            }
            field = new ArrayList<cell>();
            arrField = new cell[W][H];
            start = new cell(-1,-1);
            start.isStart = true;
            field.add(start);
            end = new cell(-2,-2);
            end.isEnd = true;
            field.add(end);
            for(int x=0;x<W;x++){
            	arrField[x] = new cell[H];
                for(int y=0;y<H;y++){
                	if(check(x,y)){
                		cell zz = new cell(x,y);
                		field.add(zz);
                		arrField[x][y] = zz;
                		if(y==0){
                			zz.next.add(start);
                			start.next.add(zz);
                		}
                		if(y==H-1){
                			zz.next.add(end);
                			end.next.add(zz);
                		}
                		if(check(x-1,y)){
                			zz.next.add(arrField[x-1][y]);
                			arrField[x-1][y].next.add(zz);
                		}
                		if(check(x,y-1)){
                			zz.next.add(arrField[x][y-1]);
                			arrField[x][y-1].next.add(zz);
                		}
                	}
                }
            }
            int capacity = 0;
            while(findPath()){
            	capacity++;
            	cell z = end;
            	while(true){
            		if(z.pathPrev== start){
            			break;
            		}
            		cell p = z.pathPrev;
            		if(p.prev == z){
            			p.prev = null;
            		}else{
            			z.prev = p;
            		}
            		z = p;
            	}
            }
            writer.println("Case #" + caseNum + ": " + capacity);
            writer.flush();
        }
    }

    public static void main(String[] args) throws FileNotFoundException, IOException {
        File folder = new File(".");
        for(final File entry:folder.listFiles()){
            if(entry.getName().endsWith(".in") && entry.getName().startsWith(problemLetter)){
                BufferedReader reader = new BufferedReader(new FileReader(entry));
                String fileOut = entry.getName().substring(0, entry.getName().length()-3) + ".out";
                System.out.println(entry.getName() + " -> " + fileOut);
                PrintWriter writer = new PrintWriter(fileOut);
                solve(reader, writer);
                reader.close();
                writer.close();
            }
        }
    }
    
}
