/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package googlejam;

import java.io.*;
import java.util.TreeMap;
import java.util.TreeSet;

/**
 *
 * @author a.bogdanov
 */
public class GoogleJam_TrieSharding {
    public static final String problemLetter = "D";
    
    static int M;
    static int N;
    static String[] S;
    static int[] server;
    
    static TreeMap<Integer, Integer> sizes;
    
    static int countNodes(int j, String prefix){
    	TreeSet<Character> nexts  = new TreeSet<Character>();
    	boolean exists = false;
    	for(int i=0; i<M; i++){
    		if(server[i] == j && S[i].startsWith(prefix)){
    			exists = true;
    			if(S[i].length() > prefix.length()){
    				nexts.add(S[i].charAt(prefix.length()));
    			}
    		}
    	}
    	int count = 0;
    	for(char c:nexts){
    		count += countNodes(j, prefix + c);
    	}
    	if(exists) count++;
    	return count;
    }

    static void put(int i){
    	if(i>=M){
    		int cnt = 0;
    		for(int j=0;j<N;j++){
    			cnt+=countNodes(j, "");
    		}
    		if(sizes.containsKey(cnt)){
    			sizes.put(cnt, sizes.get(cnt)+1);
    		}else{
    			sizes.put(cnt, 1);
    		}
    	}else{
    		for(int j=0;j<N;j++){
    			server[i] = j;
    			put(i+1);
    		}
    	}
    }
    
    public static void solve(BufferedReader reader, PrintWriter writer) throws IOException{
        int caseCount = Integer.parseInt(reader.readLine());
        for(int caseNum=1; caseNum<=caseCount; caseNum++){
            String[] str = reader.readLine().split(" ");
            M = Integer.parseInt(str[0]);
            N = Integer.parseInt(str[1]);
            S = new String[M];
            server = new int[M];
            for(int i=0;i<M;i++){
                S[i] = reader.readLine();
            }
            sizes = new TreeMap<Integer, Integer>();
            put(0);
            int maxS = 0;
            int maxCnt = 0;
            for(int s:sizes.keySet()){
            	if(s>maxS){
            		maxS = s;
            		maxCnt = sizes.get(s);
            	}
            }
            writer.println("Case #" + caseNum + ": " + maxS + " " + maxCnt);
            writer.flush();
        }
    }

    public static void main(String[] args) throws FileNotFoundException, IOException {
        File folder = new File(".");
        for(final File entry:folder.listFiles()){
            if(entry.getName().endsWith(".in") && entry.getName().startsWith(problemLetter)){
                BufferedReader reader = new BufferedReader(new FileReader(entry));
                String fileOut = entry.getName().substring(0, entry.getName().length()-3) + ".out";
                System.out.println(entry.getName() + " -> " + fileOut);
                PrintWriter writer = new PrintWriter(fileOut);
                solve(reader, writer);
                reader.close();
                writer.close();
            }
        }
    }
    
}
