package test.googlejam;

import java.io.*;

/**
 *
 * @author Андрей
 */
public class TicTacToeTomek {
    static boolean checkSymbol(char s, char v){
        if(s==v || s=='T') return true;
        return false;
    }
    static Character checkRow(char[][] field, int r){
        boolean isX = true;
        boolean isO = true;
        for(int i = 0; i < 4; i++){
            if (!checkSymbol(field[r][i], 'X')) isX = false;
            if (!checkSymbol(field[r][i], 'O')) isO = false;
        }
        if (isX) return 'X';
        if (isO) return 'O';
        return null;
    }
    static Character checkColumn(char[][] field, int r){
        boolean isX = true;
        boolean isO = true;
        for(int i = 0; i < 4; i++){
            if (!checkSymbol(field[i][r], 'X')) isX = false;
            if (!checkSymbol(field[i][r], 'O')) isO = false;
        }
        if (isX) return 'X';
        if (isO) return 'O';
        return null;
    }
    static Character checkDiag1(char[][] field){
        boolean isX = true;
        boolean isO = true;
        for(int i = 0; i < 4; i++){
            if (!checkSymbol(field[i][i], 'X')) isX = false;
            if (!checkSymbol(field[i][i], 'O')) isO = false;
        }
        if (isX) return 'X';
        if (isO) return 'O';
        return null;
    }
    static Character checkDiag2(char[][] field){
        boolean isX = true;
        boolean isO = true;
        for(int i = 0; i < 4; i++){
            if (!checkSymbol(field[i][3-i], 'X')) isX = false;
            if (!checkSymbol(field[i][3-i], 'O')) isO = false;
        }
        if (isX) return 'X';
        if (isO) return 'O';
        return null;
    }

    static Character check(char[][] field){
        Character val;
        for(int r = 0; r < 4; r++){
            val = checkRow(field, r);
            if (val != null) return val;
            val = checkColumn(field, r);
            if (val != null) return val;
        }
        val = checkDiag1(field);
        if (val != null) return val;
        val = checkDiag2(field);
        if (val != null) return val;
        return null;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader("data.in"));
        PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter("data.out")));
        int testCount = Integer.parseInt(reader.readLine());
        String str;
        for(int i = 0; i < testCount; i++){
            char[][] field = new char[4][4];
            int emptyCount = 0;
            for(int x = 0; x < 4; x++){
                str = reader.readLine();
                for(int y = 0; y < 4; y++){
                    field[x][y] = str.charAt(y);
                    if(field[x][y] == '.') emptyCount++;
                }
            }
            str = reader.readLine();
            Character val = check(field);
            String res = "";
            if (val == null) {
                if(emptyCount == 0) res = "Draw";
                else res = "Game has not completed";
            }else if (val.equals('O')) res = "O won";
            else if (val.equals('X')) res = "X won";
            writer.println("Case #" + (i+1) + ": " + res);
        }
        reader.close();
        writer.close();
    }
}
