/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package OverSizePankake;

import ReversePancake.*;
import Template.*;
import java.io.File;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;
import org.apache.commons.lang3.ArrayUtils;

/**
 *
 * @author BAYORIAN
 */
public class OverSizePankake {

    private File inputFile;
    private File outputFile;
    private Scanner inputScanner;
    private Output output;
    private int noOfCases;
    private PrintWriter outputPrint;
    private int count = 1;

    public OverSizePankake() {
        try {
            initialise();
            inputScanner = new Scanner(inputFile);
            outputPrint = new PrintWriter(outputFile);
            output = new Output(outputFile, outputPrint);
            noOfCases = inputScanner.nextInt();
            while (inputScanner.hasNext()) {
                char[] side = inputScanner.next().toCharArray();
                int k = inputScanner.nextInt();
                ArrayList<Character> sideList = new ArrayList<Character>(Arrays.asList(ArrayUtils.toObject(side)));
                reversePancake(sideList, 0, k);
                count++;
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            outputPrint.close();
            inputScanner.close();
        }
    }

    private void reversePancake(ArrayList<Character> sideList, int resultCount, int k) {
        int firstPoint = sideList.indexOf('-');
//        System.out.println(sideList + " " + firstPoint + " " + k);
        if (firstPoint == -1) {
            output.writeString(count, String.valueOf(resultCount));
        } else {
            boolean isReversible = reverseSideList(sideList, firstPoint, k);
            if (isReversible) {
                resultCount++;
                reversePancake(sideList, resultCount, k);
            } else {
                output.writeString(count, "IMPOSSIBLE");
            }
        }
    }

    private boolean reverseSideList(ArrayList<Character> sideList, int firstPoint, int k) {
        if (firstPoint + k > sideList.size()) {
            return false;
        }
        for (int i = firstPoint; i < firstPoint + k; i++) {
            char side = sideList.get(i);
            if (side == '-') {
                sideList.set(i, '+');
            } else {
                sideList.set(i, '-');
            }
        }
        return true;
    }

    private int getFirstPointOfChange(ArrayList<Character> linkedList) {
        char startingChar = linkedList.get(0);
        for (int j = 0; j < linkedList.size(); j++) {
            char next = linkedList.get(j);
            if (next != startingChar) {
                return j;
            }
        }
        if (startingChar == '+') {
            return -1;
        } else {
            return linkedList.size();
        }
    }

    private void initialise() {
        System.out.println("Enter the File name of the Input");
        Scanner inputScan = new Scanner(System.in);
        inputFile = new File("C:\\Users\\BAYORIAN\\Documents\\Codejam\\" + inputScan.next());
        System.out.println("Enter the File name of the output");
        outputFile = new File("C:\\Users\\BAYORIAN\\Documents\\Codejam\\" + inputScan.next());
    }

    public static void main(String[] args) {
        OverSizePankake template = new OverSizePankake();
    }
}
