/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package CruiseControl;

import Template.*;
import java.io.File;
import java.io.FilenameFilter;
import java.io.PrintWriter;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.Scanner;

/**
 *
 * @author BAYORIAN
 */
public class CruiseControl {

    private File inputFile;
    private File outputFile;
    private Scanner inputScanner;
    private Output output;
    private int noOfCases;
    private PrintWriter outputPrint;
    private int count = 1;

    public CruiseControl() {
        try {
            initialise();
            inputScanner = new Scanner(inputFile);
            outputPrint = new PrintWriter(outputFile);
            output = new Output(outputFile, outputPrint);
            noOfCases = inputScanner.nextInt();
            while (inputScanner.hasNext()) {
                double d = inputScanner.nextDouble();
                int n = inputScanner.nextInt();                
                double result = Double.POSITIVE_INFINITY;
                for (int i = 1; i <= n; i++) {
                    double nextDist = inputScanner.nextInt();
                    double nextSpeed = inputScanner.nextInt();
                    double currentResult = d / ((d - nextDist) / nextSpeed);
                    if(currentResult < result) {
                        result = currentResult;
                    }
                }                                
                System.out.println("Count " + count);
                output.writeString(count, new DecimalFormat("0.000000").format(result) + "");
                count++;
                
            }
        } catch (Exception ex) {
            ex.printStackTrace();
        } finally {
            outputPrint.close();
            inputScanner.close();
        }
    }

    private void initialise() {
        inputFile = null;
        final String regex = "A-(small|large).*[.]in";
        File directory = new File("C:\\Users\\BAYORIAN\\Documents\\Codejam\\Codejam_Q");
        File[] candidates = directory.listFiles(new FilenameFilter() {
            public boolean accept(File dir, String name) {
                return name.matches(regex);
            }
        });
        for (File candidate : candidates) {
            if (inputFile == null || candidate.lastModified() > inputFile.lastModified()) {
                inputFile = candidate;
            }
        }
        outputFile = new File("C:\\Users\\BAYORIAN\\Documents\\Codejam\\Codejam_Q\\a.out");
    }

    private void initialise_2() {
        System.out.println("Enter the File name of the Input");
        Scanner inputScan = new Scanner(System.in);
        inputFile = new File("C:\\Users\\BAYORIAN\\Documents\\Codejam\\" + inputScan.next());
        System.out.println("Enter the File name of the output");
        outputFile = new File("C:\\Users\\BAYORIAN\\Documents\\Codejam\\" + inputScan.next());
    }

    public static void main(String[] args) {
        CruiseControl template = new CruiseControl();
    }
}
