import java.io.*;
import java.util.*;
/**
 * Template for programming contest.
 * @author Andrew Smith (bAZZA NZ)
 */


public class Question1
{
    // Instance variables
    private InputStreamReader strIn;
    private BufferedReader in;

	//file names
	private static final String inputFile = "sample.in";
	private static final String outputFile = "output.out";

    private static final String TERMINATOR = "0"; // Replace with whatever the terminator is
    //------------------------------------------------------------------------------
    /**
     * Start point for the program
     */
    public static void main(String[] args)
    {
        new Question1().solveProblem();
    }

    //------------------------------------------------------------------------------
    /**
     * Constructor for main class
     */
    public Question1()
    {
        try
        {
          // Set up objects to get input from STDIN
          //strIn = new InputStreamReader(System.in);

          //For debugging (or file input) comment out below line and replace with this:
          strIn = new InputStreamReader(new FileInputStream(inputFile));

          in = new BufferedReader(strIn);
        }
        catch(Exception e)
        {	System.out.println("Error in constructor");
        }
    }
    //------------------------------------------------------------------------------
    /**
     * The program expects data to be passed from a file by redirection.
     */
    private String readLine()
    {
        String sData;
        try
        {	sData = in.readLine();
        }
        catch(Exception ex)
        {	sData = ""; // Returns empty string if no data to read
        }
        return sData;
    }
    //------------------------------------------------------------------------------
    /*
     * Code written here to solve the specific problem. (One block at a time)
     * @param Line read from input
     */
    private String solveBlock(String sLine)
    {
        int firstNumber = Integer.parseInt(sLine);
        int nextNumber = firstNumber+1;
        
        while(true)
        {
            if(checkNumbers(firstNumber, nextNumber))
            {
                break;
            }
            else
            {
                nextNumber++;
            }
        }

        return "" + nextNumber;
    }

    private boolean checkNumbers(int oriNum, int newNum)
    {
        String firstNum = "" + oriNum;
        String secondNum = "" + newNum;
        char[] original = firstNum.toCharArray();
        char[] checking = secondNum.toCharArray();

        char DONE = 'z';

        for(int i=0; i<original.length; i++)
        {
            char currentChar = original[i];
            for(int z=0; z<checking.length; z++)
            {
                if(original[i] != DONE && currentChar == checking[z])
                {
                    original[i] = DONE;
                    checking[z] = DONE;
                }
            }
        }

        boolean allRight = true;
        for(int i=0; i<original.length; i++)
        {
            if(original[i] != DONE)
            {
                allRight = false;
            }
        }

        for(int i=0; i<checking.length; i++)
        {
            if(checking[i] == '0' || checking[i] == DONE)
            {
                
            }
            else allRight = false;
        }

        return allRight;
    }


    //------------------------------------------------------------------------------
    /**
     * This code solves the problem
     * This reads every line, then parses the string to solveLine(...)
     * But not before checking to see if it is the TERMINATOR
     */
    private void solveProblem()
    {
        String sLine = readLine();
        Scanner scan = new Scanner(sLine);
        int amountOfBlocks = scan.nextInt();
        String finalResult = "";
        for(int i=0; i<amountOfBlocks; i++)
        {
            String total = solveBlock(readLine());
            int caseNo = i+1;
            finalResult += "Case #" + caseNo + ": " + total + "\n";
            //System.out.println("Case #" + caseNo + ": " + total);

        }

        printToFile(finalResult);
        //printToConsole(finalResult);
    }

    //------------------------------------------------------------------------------

    /**
     * This will print out outputString to a fileName
     * @param outputString String to print out to file
     */
    private void printToFile(String outputString)
    {
        try
        {
            BufferedWriter output = new BufferedWriter(new FileWriter(outputFile));
            output.write(outputString);
            output.close();
        }
        catch(IOException ex)
        {
        }
    }

    /**
     * This will print out outputString to the console line (System.out.println();)
     * @param outputString String to print out console
     */
    private void printToConsole(String outputString)
    {
        System.out.println(outputString);
    }
}
