import java.io.*;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
/**
 * Template for programming contest.
 * @author Andrew Smith (bAZZA NZ)
 */


public class QuestionC3
{
    // Instance variables
    private InputStreamReader strIn;
    private BufferedReader in;

    private static final String TERMINATOR = "0"; // Replace with whatever the terminator is
    //------------------------------------------------------------------------------
    /**
     * Start point for the program
     */
    public static void main(String[] args)
    {
        QuestionC3 run = new QuestionC3();
        run.solveProblem();
    }

    //------------------------------------------------------------------------------
    /**
     * Constructor for main class
     */
    public QuestionC3()
    {
        try
        {
          // Set up objects to get input from STDIN
          //strIn = new InputStreamReader(System.in);

          //For debugging, comment out below line and replace with this:
          strIn = new InputStreamReader(new FileInputStream("sample.in"));

          in = new BufferedReader(strIn);
        }
        catch(Exception e)
        {	System.out.println("Error in constructor");
        }
    }
    //------------------------------------------------------------------------------
    /**
     * The program expects data to be passed from a file by redirection.
     */
    private String readLine()
    {
        String sData;
        try
        {	sData = in.readLine();
        }
        catch(Exception ex)
        {	sData = ""; // Returns empty string if no data to read
        }
        return sData;
    }
    //------------------------------------------------------------------------------
    /*
     * Code written here to solve the specific problem.
     * @param Line read from input
     */
    private String solveBlock(String sLine)
    {
        int length = sLine.length();

        String[] letters = {"w", "e", "l", "c", "o", "m", "e", " ", "t", "o", " ", "c", "o", "d", "e", " ", "j", "a", "m"}; //whitespace = 7, 10, 15
        int[] multi = { 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0 };
        int total = 0;

        int currentPosition = 0;

        for(int i=0; i<length; i++)
        {
            String subStr = sLine.substring(i, i+1);

            if(subStr.equalsIgnoreCase(letters[currentPosition]))
            {
                multi[currentPosition]++;
                
            }
            if(currentPosition < letters.length-1)
            {
                if(subStr.equalsIgnoreCase(letters[currentPosition+1]))
                {
                    currentPosition++;
                    multi[currentPosition]++;
                }
            }
            if(currentPosition < letters.length-2)
            {
                if(subStr.equalsIgnoreCase(letters[currentPosition]))
                {
                    multi[currentPosition]++;
                }
            }
            
        }


        for(int i=0; i<letters.length; i++)
        {
            //System.out.println(multi[i]);
            if(total == 0)
            {
                total = multi[i];
            }
            else
            {
                total = total * multi[i];
            }
        }
        if(total < 10)
        {
            return "000" + total;
        }
        else if(total < 100)
        {
            return "00" + total;
        }
        else if(total < 1000)
        {
            return "0" + total;
        }
        else
        {
            String newTotal = "" + total;
            newTotal = newTotal.substring(newTotal.length()-4, newTotal.length());
            return newTotal;
        }
    }


    //------------------------------------------------------------------------------
    /**
     * This code solves the problem
	 * This reads every line, then parses the string to solveLine(...)
	 * But not before checking to see if it is the TERMINATOR
     */
    private void solveProblem()
    {
        String sLine = readLine();
        Scanner numberScan = new Scanner(sLine);
        int numberOfLines = numberScan.nextInt();
        String toBeWritten = "";

        for(int i=0; i<numberOfLines ; i++)
        {
            int iCase = i+1;
            sLine = readLine();
            String result = solveBlock(sLine);

            toBeWritten += "Case #" + iCase + ": " + result + "\n";
            //System.out.println("Case #" + iCase + ": " + result);
        }

        try {
                BufferedWriter output = new BufferedWriter(new FileWriter("output.txt"));
                output.write(toBeWritten);
                output.close();
            } catch (IOException ex) {
                Logger.getLogger(QuestionC3.class.getName()).log(Level.SEVERE, null, ex);
            }
    }
    //------------------------------------------------------------------------------
}
