
import java.io.File;
import java.util.ArrayList;
import java.util.Scanner;



/**
 *
 * @author hyv7959
 */
public class Magicka
{

    public static void main(String[] args) throws Exception {
        scan = new Scanner(new File("input.in"));

        int amtRun = scan.nextInt();

        for(int i=0; i<amtRun; i++)
        {
            new Magicka(i+1).run();
        }
    }


    static Scanner scan;

    int caseNum;
    ArrayList<Combine> combines;// opposes;
    ArrayList<Oppose> opposes;
    ArrayList<Character> combination, finalCombination;

    public Magicka(int caseNum)
    {
        this.caseNum = caseNum;
        combines = new ArrayList<Combine>();
        opposes = new ArrayList<Oppose>();
        combination = new ArrayList<Character>();
        finalCombination = new ArrayList<Character>();
    }

    void load()
    {
        //first get all the combines
        int amtCombines = scan.nextInt();
        for(int i=0; i<amtCombines; i++)
            combines.add(new Combine(scan.next()));
        //System.out.println(combines);

        //now get all the opposes
        int amtOpposes = scan.nextInt();
        for(int i=0; i<amtOpposes; i++)
            opposes.add(new Oppose(scan.next()));
        //System.out.println(opposes);

        //now get the starting combination
        int combLength = scan.nextInt();
        String combi = scan.next();
        for(char c : combi.toCharArray())
            combination.add(c);

    }

    public void run()
    {
        load();

        for(int i=0; i<combination.size(); i++)
        {
            invoke(combination.get(i));
            combine();
            oppose();
        }


        System.out.println("Case #" + caseNum + ": " + finalCombination);
    }


    void invoke(char c)
    {
        finalCombination.add(c);
    }


    void combine()
    {
        try
        {
            char a = finalCombination.get(finalCombination.size()-1);
            char b = finalCombination.get(finalCombination.size()-2);

            if(canBeCombined(a, b))
            {
                //then remove them
                finalCombination.remove(finalCombination.size()-1);
                finalCombination.remove(finalCombination.size()-1);
                //and add the combine value
                finalCombination.add(checkCombine(a, b).get(0));
            }
        }
        catch(IndexOutOfBoundsException ex)
        {
            //do nothing
        }
    }


    void oppose()
    {
        try
        {
            //get the last element in the list
            char a = finalCombination.get(finalCombination.size()-1);

            for(int i=0; i<finalCombination.size(); i++)
            {
                if(checkOppose(a, finalCombination.get(i)))
                {
                    finalCombination.clear();
                    return;
                }
            }

        }
        catch(IndexOutOfBoundsException ex)
        {
            //do nothing
        }
    }


    ArrayList<Character> checkCombine(char a, char b)
    {
        ArrayList<Character> result = new ArrayList<Character>();
        result.add(a);
        result.add(b);
        for(Combine c : combines)
            result = c.combine(a, b);
        return result;
    }

    boolean canBeCombined(char a, char b)
    {
        return (checkCombine(a,b).size() == 1);
    }

    boolean checkOppose(char a, char b)
    {
        boolean result = false;

        for(Oppose o : opposes)
            if(o.isOppose(a, b))
                result = true;

        return result;
    }


    class Combine
    {
        private char charA, charB, resultChar;

        public Combine(String all)
        {
            this(all.charAt(0), all.charAt(1), all.charAt(2));
        }

        public Combine(char a, char b, char result)
        {
            charA = a;
            charB = b;
            resultChar = result;
        }

        public ArrayList<Character> combine(char a, char b)
        {
            ArrayList<Character> result = new ArrayList<Character>();
            if((a == charA && b == charB) || (a == charB && b == charA))
                result.add(resultChar);
            else
            {
                result.add(a); result.add(b);
            }
            return result;
        }

        public String toString()
        {
            return "" + charA + " + " + charB + " = " + resultChar;
        }
    }


    class Oppose
    {
        private char charA, charB;

        public Oppose(String all)
        {
            this(all.charAt(0), all.charAt(1));
        }

        public Oppose(char a, char b)
        {
            charA = a;
            charB = b;
        }

        public boolean isOppose(char a, char b)
        {
            return ((a == charA && b == charB) || (a == charB && b == charA));
        }

        public String toString()
        {
            return ""+ charA + " & " + charB;
        }
    }
}
