import java.io.*;
import java.util.*;
/**
 * Template for programming contest.
 * @author Andrew Smith (bAZZA NZ)
 */


public class QuestionA
{
    // Instance variables
    private InputStreamReader strIn;
    private BufferedReader in;

	//file names
	private static final String inputFile = "sample.in";
	private static final String outputFile = "output.out";

    private static final String TERMINATOR = "0"; // Replace with whatever the terminator is
    //------------------------------------------------------------------------------
    /**
     * Start point for the program
     */
    public static void main(String[] args)
    {
        new QuestionA().solveProblem();
    }

    //------------------------------------------------------------------------------
    /**
     * Constructor for main class
     */
    public QuestionA()
    {
        try
        {
          // Set up objects to get input from STDIN
          //strIn = new InputStreamReader(System.in);

          //For debugging (or file input) comment out below line and replace with this:
          strIn = new InputStreamReader(new FileInputStream(inputFile));

          in = new BufferedReader(strIn);
        }
        catch(Exception e)
        {	System.out.println("Error in constructor");
        }
    }
    //------------------------------------------------------------------------------
    /**
     * The program expects data to be passed from a file by redirection.
     */
    private String readLine()
    {
        String sData;
        try
        {	sData = in.readLine();
        }
        catch(Exception ex)
        {	sData = ""; // Returns empty string if no data to read
        }
        return sData;
    }
    //------------------------------------------------------------------------------
    /*
     * Code written here to solve the specific problem. (One block at a time)
     * @param Line read from input
     */
    private String solveBlock(String sLine)
    {

        String word = sLine;
        //System.out.println(word);
        int[] values = new int[word.length()];
        char[] letters = new char[word.length()];
        int[] finalValues = new int[word.length()];

        int currentValue = 1;


        //gets the first letter/value
        char firstChar = word.charAt(0);
        letters[0] = firstChar;

        for(int i=0; i<word.length(); i++)
        {
            boolean found = false;
            //gets the current char to work with
            char currentChar = word.charAt(i);
            //checks to see if it has a value
            for(int z=0; z<word.length(); z++)
            {
                if(currentChar == letters[z] && !found)
                {
                    finalValues[i] = values[z];
                    found = true;
                }
            }
            if(!found)
            {
                letters[i] = currentChar;
                values[i] = currentValue;
                finalValues[i] = currentValue;
                currentValue++;
            }
        }
        for(int i=0; i<word.length(); i++)
        {
            finalValues[i]++;
            //System.out.print(finalValues[i]);
        }
        
        for(int i=0; i<word.length(); i++)
        {
            int currentInt = finalValues[i];
            
            if(currentInt == 2)
            {
                finalValues[i] = 0;
            }
            else if(currentInt > 2)
            {
                finalValues[i]--;
            }
        }



        //System.out.println();
        //System.out.println(currentValue);

        int base = currentValue;
        int finalScore = 0;
        if(base==1)
        {
            base = 2;
            //finalScore++;
        }
        int currentMulti = 1;

        System.out.println(word);
        for(int i=word.length()-1; i>=0; i--)
        {
            //System.out.print(finalValues[i]);
            //System.out.print(currentMulti);
            finalScore += (finalValues[i] * currentMulti);
            currentMulti = currentMulti * base;
        }
        for(int i=0; i<word.length(); i++)
        {
            System.out.print(finalValues[i]);
        }
        System.out.println();

        //finalScore += (finalValues[0] * currentMulti);




        return "" + finalScore;
    }


    //------------------------------------------------------------------------------
    /**
     * This code solves the problem
     * This reads every line, then parses the string to solveLine(...)
     * But not before checking to see if it is the TERMINATOR
     */
    private void solveProblem()
    {
        String sLine = readLine();
        Scanner scan = new Scanner(sLine);
        int amountOfBlocks = scan.nextInt();
        String finalResult = "";
        for(int i=0; i<amountOfBlocks; i++)
        {
            String total = solveBlock(readLine());
            int caseNo = i+1;
            finalResult += "Case #" + caseNo + ": " + total + "\n";
            //System.out.println("Case #" + caseNo + ": " + total);

        }

        printToFile(finalResult);
        //printToConsole(finalResult);
    }

    //------------------------------------------------------------------------------

    /**
     * This will print out outputString to a fileName
     * @param outputString String to print out to file
     */
    private void printToFile(String outputString)
    {
        try
        {
            BufferedWriter output = new BufferedWriter(new FileWriter(outputFile));
            output.write(outputString);
            output.close();
        }
        catch(IOException ex)
        {
        }
    }

    /**
     * This will print out outputString to the console line (System.out.println();)
     * @param outputString String to print out console
     */
    private void printToConsole(String outputString)
    {
        System.out.println(outputString);
    }
}
