import java.io.*;
import java.util.ArrayList;
import java.util.Scanner;
/**
 * Template for programming contest.
 * @author Andrew Smith (bAZZA NZ)
 */


public class QuestionA
{
    // Instance variables
    private InputStreamReader strIn;
    private BufferedReader in;

    private static final String TERMINATOR = "0"; // Replace with whatever the terminator is
    //------------------------------------------------------------------------------
    /**
     * Start point for the program
     */
    public static void main(String[] args)
    {
        QuestionA run = new QuestionA();
        run.solveProblem();
    }

    //------------------------------------------------------------------------------
    /**
     * Constructor for main class
     */
    public QuestionA()
    {
        try
        {
          // Set up objects to get input from STDIN
          //strIn = new InputStreamReader(System.in);

          //For debugging, comment out below line and replace with this:
          strIn = new InputStreamReader(new FileInputStream("sample.in"));

          in = new BufferedReader(strIn);
        }
        catch(Exception e)
        {	System.out.println("Error in constructor");
        }
    }
    //------------------------------------------------------------------------------
    /**
     * The program expects data to be passed from a file by redirection.
     */
    private String readLine()
    {
        String sData;
        try
        {	sData = in.readLine();
        }
        catch(Exception ex)
        {	sData = ""; // Returns empty string if no data to read
        }
        return sData;
    }
    //------------------------------------------------------------------------------
    /*
     * Code written here to solve the specific problem.
     * @param Line read from input
     */
    private void solveBlock(String sLine)
    {
        Scanner scan = new Scanner(sLine);
        //gets the first line of numbers
        int amountOfLetters = scan.nextInt();
        int amountOfWords = scan.nextInt();
        int amountOfTests = scan.nextInt();

        ArrayList<String> dictonary = new ArrayList<String>(amountOfWords);
        ArrayList<String> listOfRecievedWords = new ArrayList<String>(amountOfTests);
        ArrayList<Integer> wordsItCouldBe = new ArrayList<Integer>(amountOfTests);

        //now reads all the known words and puts them into array
        for(int i=0; i < amountOfWords; i++)
        {
            sLine = readLine();
            dictonary.add(sLine);
        }

        //now reads all words recieved (test cases - or tests) and needed to be decoded
        for(int i=0; i < amountOfTests; i++)
        {
            sLine = readLine();
            listOfRecievedWords.add(sLine);
        }

        //stores the test case letters
        ArrayList<String> testCaseLetters = new ArrayList<String>(amountOfLetters);

        //now calculates amount of words it could be.
        for(int i=0; i < amountOfTests; i++)
        {
            //gets the current test case
            String newTestCase = listOfRecievedWords.get(i);
            //sets up the scanner
            scan = new Scanner(newTestCase);
            scan.useDelimiter("()");


            for(int letters=0; letters < amountOfLetters; )
            {
                testCaseLetters.add(letters, ""); //adds in empty space
                String newLetter = scan.next();
                if(newLetter.equalsIgnoreCase("("))
                {
                    while(!newLetter.equalsIgnoreCase(")"))
                    {
                        newLetter = scan.next();
                        if(!newLetter.equalsIgnoreCase(")"))
                        {
                            testCaseLetters.set(letters, testCaseLetters.get(letters) + newLetter);
                        }
                    }
                }
                else
                {
                    testCaseLetters.set(letters, newLetter);
                }
                letters++;
            }
            //only works with 3 worded lists
            //System.out.println(i + "  " + testCaseLetters.get(0));
            //System.out.println(i + "  " + testCaseLetters.get(1));
            //System.out.println(i + "  " + testCaseLetters.get(2));

            wordsItCouldBe.add(i, 0);

            //gets the first word to check
            for(int word=0; word < amountOfWords; word++)
            {
            //ArrayList<Boolean> isAWord = new ArrayList<Boolean>(amountOfLetters);
            //boolean isWordRight = true;

                int allRight = 0;

                String wordToTest = dictonary.get(word); //gets known word
                //System.out.println("Word to Test:  " + wordToTest);
                //tests the letters in this word
                for(int letter=0; letter < amountOfLetters; letter++)
                {
                    String testCaseTestLetters = testCaseLetters.get(letter);
                    String letterToTest = wordToTest.substring(letter, letter+1);
                    if(testCaseTestLetters.contains(letterToTest))
                    {   //System.out.println(letterToTest + "  is in  " + testCaseTestLetters);
                        allRight++;
                    }
                }

                //now adds +1 into the wordsItCouldBe Array
                //System.out.println(isWordRight);
                if(allRight == amountOfLetters)
                {   //System.out.println(wordToTest + "  is a word");
                    wordsItCouldBe.add(i, wordsItCouldBe.get(i)+1);
                }


            }


            
        }

        





        //Prints out the final results
        for(int i=1; i <= amountOfTests; i++)
        {
            System.out.println("Case #" + i + ": " + wordsItCouldBe.get(i-1));
        }


    }

    //------------------------------------------------------------------------------
    /**
     * This code solves the problem
	 * This reads every line, then parses the string to solveLine(...)
	 * But not before checking to see if it is the TERMINATOR
     */
    private void solveProblem()
    {
        String sLine = readLine();

        try
        {
            while(true)
            {
                solveBlock(sLine);
                sLine = readLine();
            }
        }
        catch(NullPointerException e)
        {
            //do nothing. this is the end
        }
    }
    //------------------------------------------------------------------------------
}
