
import java.io.File;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;



/**
 *
 * @author hyv7959
 */
public class Main
{
    public static void main(String[] args) throws Exception
    {
        new Main().run();
    }

    Bot orangeBot, blueBot;
    Combination combination;

    public void run() throws Exception
    {
        Scanner scan = new Scanner(new File("input.in"));

        final int amtOfTests = scan.nextInt();
        //System.out.println(amtOfTests);

        for(int runNum =0; runNum < amtOfTests; runNum++)
        {
            blueBot = new Bot("blue");
            orangeBot = new Bot("orange");

            combination = new Combination(scan);

            int TOTAL_TIME_TAKEN = 0;

            while(!combination.keys.isEmpty())
            {
                boolean moved = false;
                boolean blueMoved = false;
                boolean orangeMoved = false;

                Key blueBotKey = combination.getBotsNextKey(blueBot);
                Key orangeBotKey = combination.getBotsNextKey(orangeBot);

                //is blue bot at it's position?
                if(blueBotKey != null && blueBot.location == blueBotKey.button)
                {
                    if(combination.isNextKey(blueBotKey))
                    {
                        combination.completeKey(blueBotKey);
                        moved = true;
                        blueMoved = true;
                    }
                }
                //checks if it is orange bots button
                if(!moved && orangeBotKey != null && orangeBot.location == orangeBotKey.button)
                {
                    if(combination.isNextKey(orangeBotKey))
                    {
                        combination.completeKey(orangeBotKey);
                        moved = true;
                        orangeMoved = true;
                    }
                }

                //now move them
                blueBotKey = combination.getBotsNextKey(blueBot);
                orangeBotKey = combination.getBotsNextKey(orangeBot);

                if(!blueMoved && blueBotKey != null)
                {
                    blueBot.goToLocation = blueBotKey.button;
                    blueBot.moveToLocation();
                }

                if(!orangeMoved && orangeBotKey != null)
                {
                    orangeBot.goToLocation = orangeBotKey.button;
                    orangeBot.moveToLocation();
                }


                TOTAL_TIME_TAKEN ++;
            }



            int caseNo = runNum +1;
            System.out.println("Case #" + caseNo + ": " + TOTAL_TIME_TAKEN);


        }
    }


    class Combination
    {
        ArrayList<Key> keys;

        public Combination(Scanner scan)
        {
            keys = new ArrayList<Key>();
            int numC = scan.nextInt();
            for(int i=0; i<numC; i++)
            {
                Key key = new Key();

                //Map<Bot, Integer> key = new HashMap<Bot, Integer>();
                if(scan.next().charAt(0) == 'O')
                    key.bot = orangeBot;
                else key.bot = blueBot;
                key.button = scan.nextInt();
                keys.add(key);
            }
        }

        public Key getBotsNextKey(Bot bot)
        {
            for(Key k : keys)
                if(k.bot == bot)
                    return k;
            return null;
        }

        public void completeKey(Key key)
        {
            if(keys.indexOf(key) == 0)
            {
                keys.remove(key);
                return;
            }
            throw new IllegalArgumentException("Wrong Key");
        }

        public boolean isNextKey(Key key)
        {
            return (keys.indexOf(key) == 0);
        }

        public String toString()
        {
            return keys.toString();
        }
    }


    class Key
    {
        Bot bot;
        int button;

        public String toString()
        {
            return bot.toString() + " (" + button + ")";
        }
    }


    class Bot
    {
        private String colour;
        public Bot(String colour)
        {
            this.colour = colour;
        }
        int location = 1;
        int goToLocation = 0;

        public String toString()
        {
            return colour + " bot (" + location + ")";
        }


        public boolean moveToLocation()
        {
            boolean moved = false;
            if(goToLocation != 0)
            {
                moved = true;
                if(goToLocation > location)
                    location++;
                else if(goToLocation < location)
                    location--;
                else moved = false;
            }

            return moved;
        }

        public boolean pressButton()
        {
            boolean pressed = false;
            if(goToLocation == location)
            {
                goToLocation = 0;
                pressed = true;
            }

            return pressed;
        }
    }

}
