import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class Watersheds {


	static boolean sink(int[][] map, int h, int w) {
		int v = map[h][w];
		if (h-1 >= 0 && map[h - 1][w] < v) {
			return false;
		}
		if (h+1 < map.length && map[h + 1][w] < v) {
			return false;
		}
		if (w - 1 >= 0 && map[h][w - 1 ] < v) {
			return false;
		}
		if (w + 1 < map[0].length && map[h][w + 1] < v) {
			return false;
		}
		return true;
	}
	
	static void bft(B[][] ws, int h, int w, char c, char[][] res) {
		res[h][w] = c;
		for (B b :ws[h][w].nexts) {
			bft(ws, b.s, b.d, c, res);
		}
	}
	
	static void drains(int[][] map, int h, int w, B[][]ws) {
		int v = map[h][w];
		int min = Integer.MAX_VALUE;
		int res = -1;
		if (h-1 >= 0 && map[h - 1][w] < min ) {
			min = map[h -1][w];
			res = 0;
		}
		if (w - 1 >= 0 && map[h][w-1] < min) {
			min = map[h][w -1];
			res = 1;
		}
		if (w + 1 < map[0].length && map[h][w+1] < min) {
			min = map[h][w+1];
			res = 2;
		}
		if (h+1 < map.length && map[h+1][w] < min) {
			min = map[h+1][w];
			res = 3;
		}
		if (res >= 0) {
			switch (res) {
			case 0:
				ws[h-1][w].nexts.add(ws[h][w]);
				break;
			case 1:
				ws[h][w - 1].nexts.add(ws[h][w]);
				break;
			case 2:
				ws[h][w + 1].nexts.add(ws[h][w]);
				break;
			case 3:
				ws[h+1][w].nexts.add(ws[h][w]);
				break;
			}
		}
	}
	static class B {
		public int s,d;
		public int altitudes;
		public List<B> nexts = new ArrayList<B>();
	}

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		FileReader fr = new FileReader(new File("B-large.in"));
//		FileWriter fw = new FileWriter(new File("B-small.out"));
		PrintStream out = new PrintStream("B-large.out");
		int t, h, w;
		Scanner in = new Scanner(fr);
		t= in.nextInt();
		for (int i = 1; i <= t; i++) {
			h = in.nextInt();
			w = in.nextInt();
			int[][] map = new int[h][w];
			B[][] ws = new B[h][w];
			char[][] res = new char[h][w];
			
			for (int s = 0; s < h; s++) {
				for (int d = 0; d < w; d++) {
					map[s][d] = in.nextInt();
					B b = new B();
					b.s = s;
					b.d = d;
					b.altitudes = map[s][d];
					ws[s][d] = b;
				}
			}
			for (int s = 0; s < h; s++) {
				for (int d = 0; d < w; d++) {
					if (!sink(map, s, d)) {
						drains(map, s, d, ws);
					}
				}
			}
			char c = 'a';
			for (int s = 0; s < h; s++) {
				for (int d = 0; d < w; d++) {
					if (sink(map, s, d)) {
						bft(ws, s, d, c, res);
						c = (char) (c + 1);
					}
				}
			}
			Map<Character, Character> cMap = new HashMap<Character, Character>();
			c = 'a';
			for (int s = 0; s < h; s++) {
				for (int d = 0; d < w; d++) {
					char cs = res[s][d]; 
					if (cMap.containsKey(cs)) {
						res[s][d] = cMap.get(cs);
					} else {
						cMap.put(cs, c);
						res[s][d] = c;
						c = (char) (c + 1);
					}
				}
			}
			
			out.println("Case #" + i + ":");
			for (int s = 0; s < h; s++) {
				char[] cs = res[s];
				out.print(cs[0]);
				for (int d = 1; d < cs.length; d++)
					out.print(" " + cs[d]);
				out.println();
			}
			out.flush();
		}
		
		/*
		for (int i = 1; i <= n; i++) {
			fw.write("Case #" + i + ": " + reslove(ds, token(in.nextLine(), l)) + "\n");
		}
		*/
	}
}
