import java.io.File;
import java.io.FileReader;
import java.io.PrintStream;
import java.text.DecimalFormat;
import java.text.Format;
import java.text.NumberFormat;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;


public class Decision_Tree {

	static class Node {
		double weight = 0;
		String item = null;
		Node left = null;
		Node right = null;
		public Node(double w, String i) {
			this.weight = w;
			this.item = i;
		}
	}

	public static int find2(String line, int beg) {
		int r = 1;
		beg ++;
		int d = beg;
		while (r != 0) {
			beg = line.indexOf('(', beg) ;
			if ( beg != -1) {
				r++;
				beg ++;
			} 
			d = line.indexOf(')', d);
			if ( d != -1) {
				r--;d ++;
			}
			if (beg == 0 || d <= beg) {
				return d -1;
			}
		}
		return d - 1;
	}
	
	public static void parse(String line, Node parent) {
		line = line.trim();
		line = line.substring(1, line.length() - 1).trim();
		int d = line.indexOf(' ');
		if (d == -1) {
			parent.weight = Double.parseDouble(line);
		} else {
			parent.weight = Double.parseDouble(line.substring(0, d));
			int s = line.indexOf(' ', d + 1);
			parent.item = line.substring(d + 1, s);
			parent.left = new Node(0, "");
			int p = find2(line, s + 1);
			parse(line.substring(s + 1, p + 1), parent.left);
			parent.right = new Node(0, "");
			parse(line.substring(p + 1, line.lastIndexOf(')') + 1), parent.right);
		}
	}
	
	public static double find(Set<String> set, Node root) {
		double res = root.weight;
		if (root.left == null && root.right == null) {
			return res;
		} else {
			if (set.contains(root.item)) {
				res *= find(set, root.left);
				return res;
			} else {
				res *= find(set, root.right);
				return res;
			}
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		// TODO Auto-generated method stub
		// TODO Auto-generated method stub
		FileReader fr = new FileReader(new File("A-small.in"));
//		FileWriter fw = new FileWriter(new File("B-small.out"));
		PrintStream out = new PrintStream("A-small.out");
		int t = 0;
		Scanner in = new Scanner(fr);
		DecimalFormat df = new DecimalFormat();
		NumberFormat nf = NumberFormat.getNumberInstance();
		nf.setMaximumFractionDigits(7);
		nf.setMinimumFractionDigits(7);
		t = in.nextInt();
		for (int i = 1; i <=t; i++) {
			int l = in.nextInt();
			in.nextLine();
			String line = "";
			for (int s = 0; s < l; s++) {
				 line += in.nextLine().trim() + " ";
			}
			Node p = new Node(0, "");
			parse(line, p);
			int n = in.nextInt();
			double res = 0;
			HashSet<String> set = new HashSet<String>();
			out.println("Case #" + i + ": ");
			for (int d = 0; d < n; d++) {
				in.next();
				set.clear();
				int w = in.nextInt();
				for (int q = 0; q < w; q++) {
					set.add(in.next());
				}
				res = find(set, p);
				out.println(nf.format(res));
			}
		}
	}

}
