package com.bchetty.gcj2014;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.Iterator;
import java.util.TreeSet;

/**
 *
 * @author Babji, Chetty
 */
public class DeceitfulWar {
    public static void main(String[] args) {
        DeceitfulWar deceitfulWar = new DeceitfulWar();
        LineNumberReader lineNumberReader = null;
        BufferedWriter bufferedWriter = null;

        try {
            lineNumberReader = new LineNumberReader(new FileReader("/Users/babjichetty/Downloads/D-small-attempt0.in"));
            bufferedWriter = new BufferedWriter(new FileWriter("/Users/babjichetty/Downloads/D-small.out"));
            String line = null;
            int index = 0;
            int count = 0;

            while ((line = lineNumberReader.readLine()) != null) {
                if(index == 0) {
                    count = Integer.parseInt(line);
                    System.out.println("Count : " + count);
                    index++;
                    continue;
                } 
                if(index > count) {
                    break;
                }
                
                int N = Integer.parseInt(line);
                String[] noamisBlocksArr = lineNumberReader.readLine().split(" ");
                String[] kensBlocksArr = lineNumberReader.readLine().split(" ");
                
                TreeSet<Double> noamisSet1 = new TreeSet<Double>();
                TreeSet<Double> kensSet1 = new TreeSet<Double>();
                TreeSet<Double> noamisSet2 = new TreeSet<Double>();
                TreeSet<Double> kensSet2 = new TreeSet<Double>();
                
                for(int i=0;i<N;i++) {
                    noamisSet1.add(Double.parseDouble(noamisBlocksArr[i]));
                    kensSet1.add(Double.parseDouble(kensBlocksArr[i]));
                    noamisSet2.add(Double.parseDouble(noamisBlocksArr[i]));
                    kensSet2.add(Double.parseDouble(kensBlocksArr[i]));
                }
                
                bufferedWriter.write("Case #" + index + ": " + deceitfulWar.findResult(N, noamisSet1, kensSet1, noamisSet2, kensSet2));
                bufferedWriter.newLine();
                index++;                
            }
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            //Close the BufferedWriter
            try {
                if (lineNumberReader != null) {
                    lineNumberReader.close();
                }
                if (bufferedWriter != null) {
                    bufferedWriter.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }

    public String findResult(int N, TreeSet<Double> noamisSet1, TreeSet<Double> kensSet1, TreeSet<Double> noamisSet2, TreeSet<Double> kensSet2) {
        int normalStrategyResult = 0;
        int cheatingStrategyResult = 0;
        
        Iterator<Double> naomisIter1 = noamisSet1.iterator();        
        while(naomisIter1.hasNext()) {
            Double nBlock = naomisIter1.next();
            Double kBlock = kensSet1.ceiling(nBlock);
            
            if(kBlock != null) {
                naomisIter1.remove();
                kensSet1.remove(kBlock);
            } else {
                kensSet1.remove(kensSet1.first());
                normalStrategyResult++;
            }
        }
        
        int size = N;
        while(size > 0) {
            Double nBlock = noamisSet2.last();
            Double kBlock = kensSet2.last();
            
            if(nBlock > kBlock) {
                cheatingStrategyResult++;
                noamisSet2.remove(nBlock);
                kensSet2.remove(kBlock);
            } else {
                if(noamisSet2.size() > 1) {
                    noamisSet2.remove(noamisSet2.first());
                    kensSet2.remove(kBlock);
                }
            }
            size--;
        }
        
        return ("" + cheatingStrategyResult + " " + normalStrategyResult);
    }
}
