package com.bchetty.gcj2013;

import java.io.*;

/**
 *
 * @author Babji Prashanth, Chetty
 */
public class FairAndSquare {
    private boolean[] squareArray = new boolean[1000];
    
    public static void main(String[] args) {
        FairAndSquare fairAndSquare = new FairAndSquare();
        LineNumberReader lineNumberReader = null;
        BufferedWriter bufferedWriter = null;

        try {
            lineNumberReader = new LineNumberReader(new FileReader("/Users/babjichetty/Downloads/C-small-attempt0.in"));
            bufferedWriter = new BufferedWriter(new FileWriter("/Users/babjichetty/Downloads/C-small.out"));
            String line = null;
            int index = 0;
            int count = 0;

            while ((line = lineNumberReader.readLine()) != null) {
                if(index == 0) {
                    count = Integer.parseInt(line);
                    System.out.println("Count : " + count);
                    index++;
                    continue;
                }
                if(index > count) {
                    break;
                }
                String[] arr = line.split(" ");
                int x = Integer.parseInt(arr[0]);
                int y = Integer.parseInt(arr[1]);
                
                bufferedWriter.write("Case #" + index + ": " + fairAndSquare.findNumOfFairSquares(x,y));
                bufferedWriter.newLine();
                index++;
                
            }
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            //Close the BufferedWriter
            try {
                if (lineNumberReader != null) {
                    lineNumberReader.close();
                }
                if (bufferedWriter != null) {
                    bufferedWriter.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    private int findNumOfFairSquares(int x, int y) {
        int res = 0;
        int min = findMinPerfectSquare(x,y);
        if(min == -1) {
            return 0;
        }
        
        int max = findMaxPerfectSquare(x,y);
        System.out.println("Min : " + min + "  Max  : " + max);
        
        for(int i=min;i<=max;i++) {
            if(isPalindrome("" + i) && isPalindrome("" + (i*i))) {
                res++;
            }
        }
        
        return res;
    }
    
    private int findMinPerfectSquare(int x, int y) {
        int res = -1;
        
        for(int i=x;i<=y;i++) {
            if((res = isPerfectSquare(i)) != -1) {
                return res;
            }
        }
        
        return res;
    }
    
    private int findMaxPerfectSquare(int x, int y) {
        int res = -1;
        
        for(int i=y;i>=x;i--) {
            if((res = isPerfectSquare(i)) != -1) {
                return res;
            }
        }
        
        return res;
    }
    
    public static int isPerfectSquare(int num) {
        int sqrt = (int) Math.sqrt(num);
        return ((sqrt*sqrt) == num) ? sqrt : -1;
        
    }
    
    public static boolean isPalindrome(String input) {
        if(input.length() == 0 || input.length() == 1) {
            return true;
        }
        if(input.charAt(0) == input.charAt(input.length()-1)) {
            return isPalindrome(input.substring(1, input.length()-1));
        }
            
        return false;
    }
}