import java.util.*;
import java.io.*;

public class Magicka {
	public static void main(String[] args) {
		File file = null;
		LineNumberReader lnr = null;
		BufferedWriter buffWriter = null;

		try {
			file = new File("B-small-attempt0.in");
			lnr = new LineNumberReader(new FileReader(file));

			buffWriter = new BufferedWriter(new FileWriter(new File("B-small.out")));

			Magicka magicka = new Magicka();

			String line = "";
			boolean newInput = false;
			boolean firstLine = true;
			int numOfTestCases = 0;
			int caseNum = 1;

			while((line = lnr.readLine()) != null) {
				if(firstLine) {					
					numOfTestCases = Integer.parseInt(line);					
					firstLine = false;
				} else {
					String[] splitString = line.split(" ");
					int index = 0;
					int num1 = Integer.parseInt(splitString[index]);
					HashMap<String, String> mergeMap = new HashMap<String, String>();
					
					for(int i=0;i<num1;i++) {
						index++;
						String str = splitString[index];
						String sub1 = str.substring(0,2);
						String sub2 = str.substring(2);

						mergeMap.put(sub1, sub2);
						mergeMap.put(sub1.charAt(1) + "" + sub1.charAt(0), sub2);
					}
					
					index++;
					int num2 = Integer.parseInt(splitString[index]);
					HashMap<String, ArrayList<String>> opposingMap = new HashMap<String, ArrayList<String>>();
					
					for(int i=0;i<num2;i++) {
						index++;
						String str = splitString[index];
						String sub1 = "" + str.charAt(0);
						String sub2 = "" + str.charAt(1);
						
						if(opposingMap.containsKey(sub1)) {
							opposingMap.get(sub1).add(sub2);
						} else {
							ArrayList<String> keyList = new ArrayList<String>();
							keyList.add(sub2);

							opposingMap.put(sub1, keyList);
						}

						if(opposingMap.containsKey(sub2)) {
							opposingMap.get(sub2).add(sub1);
						} else {
							ArrayList<String> keyList = new ArrayList<String>();
							keyList.add(sub1);

							opposingMap.put(sub2, keyList);
						}
					}

					index++;
					int invokeStringLength = Integer.parseInt(splitString[index]); 
					
					index++;
					String invokeString = splitString[index];

					if(caseNum == numOfTestCases) {
						buffWriter.write("Case #" + caseNum + ": " + magicka.castAspell(mergeMap, opposingMap, invokeString, invokeStringLength));
						break;
					} else {
						buffWriter.write("Case #" + caseNum + ": " + magicka.castAspell(mergeMap, opposingMap, invokeString, invokeStringLength) + 
							System.getProperty("line.separator"));
					}
					
					caseNum++;					
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();								
		} finally {
			try {
				if(lnr != null) lnr.close();
				if(buffWriter != null) buffWriter.close();				
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}

	private String castAspell(HashMap<String, String> mergeMap, HashMap<String, ArrayList<String>> opposingMap, String invokeString, 
								int invokeStringLength) {
		StringBuilder sbOutput = new StringBuilder("" + invokeString.charAt(0));

		for(int i=1;i<invokeStringLength;i++) {
			int len = sbOutput.length();
			if(len > 0) {
				int pos = sbOutput.length() - 1;
				String str1 = "" + sbOutput.charAt(pos);
				String str2 = "" + invokeString.charAt(i);

				if(mergeMap.containsKey(str1+str2) || mergeMap.containsKey(str2+str1)) {					
					sbOutput.deleteCharAt(pos);
					sbOutput.append(mergeMap.get(str1+str2));
					continue;
				} else {
					String tempStr = sbOutput.toString();
					Iterator iter = opposingMap.entrySet().iterator();
					boolean flag = false;

					while (iter.hasNext()) {
						Map.Entry pair = (Map.Entry) iter.next();
						String key = (String) pair.getKey();
						ArrayList<String> keyList = (ArrayList<String>) pair.getValue();
						
						if(tempStr.indexOf(key) >= 0) {
							for(String value: keyList) {
								if(str2.indexOf(value) >= 0) {
									sbOutput.delete(0, len);
									flag = true;
								}
							}
						}

						if(flag) {
							break;
						}
					}
					
					if(!flag) {
						sbOutput.append(", " + invokeString.charAt(i));
					}
				}
			} else {
				sbOutput.append(invokeString.charAt(i));
			}
		}

		return "[" + sbOutput.toString() + "]";
	}
}