package com.bchetty.gcj2016;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.LineNumberReader;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author bchetty
 */
public class SheepCounter {
    public static void main(String[] args) {
        SheepCounter newKlass = new SheepCounter();
        LineNumberReader lineNumberReader = null;
        BufferedWriter bufferedWriter = null;

        try {
            lineNumberReader = new LineNumberReader(new FileReader("/Users/bchetty/Downloads/A-large.in"));
            bufferedWriter = new BufferedWriter(new FileWriter("/Users/bchetty/Downloads/A-large.out"));
            String line = null;
            int index = 0;
            int count = 0;

            while ((line = lineNumberReader.readLine()) != null) {
                if(index == 0) {
                    count = Integer.parseInt(line);
                    System.out.println("Count : " + count);
                    index++;
                    continue;
                } 
                if(index > count) {
                    break;
                }
                
                BigInteger n = new BigInteger(line);
                
                bufferedWriter.write("Case #" + index + ": " + newKlass.countSheep(n));
                bufferedWriter.newLine();
                index++;
                
            }
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            //Close the BufferedWriter
            try {
                if (lineNumberReader != null) {
                    lineNumberReader.close();
                }
                if (bufferedWriter != null) {
                    bufferedWriter.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    /**
     * 
     * @param n
     * @return 
     */
    public String countSheep(BigInteger n) {
        if (n.compareTo(BigInteger.ZERO) == 0) {
            return "INSOMNIA";
        }
        
        Set<Integer> digitSet = new HashSet<Integer>();
        BigInteger index = new BigInteger("1");
        String res = null;
        boolean flag = false;
        
        for(BigInteger bigInt = n; ;bigInt = n.multiply(index)) {
            res = bigInt.toString();
            for (int i = 0; i < res.length(); i++){
                Integer digit = Integer.parseInt(res.charAt(i)+"");
                digitSet.add(digit);
                if(digitSet.size() == 10) {
                    flag = true;
                    break;
                }
            }
            if(flag) {
                break;
            }
            
            index = index.add(BigInteger.ONE);
        }
        
        return res;
    }
}
