import java.util.*;
import java.io.*;

public class BotTrust {
	public static void main(String[] args) {
		File file = null;
		LineNumberReader lnr = null;
		BufferedWriter buffWriter = null;

		try {
			file = new File("A-large.in");
			lnr = new LineNumberReader(new FileReader(file));

			buffWriter = new BufferedWriter(new FileWriter(new File("A-large.out")));
			BotTrust botTrust = new BotTrust();

			String line = "";
			boolean newInput = false;
			boolean firstLine = true;
			int numOfTestCases = 0;
			int caseNum = 1;

			while((line = lnr.readLine()) != null) {
				if(firstLine) {					
					numOfTestCases = Integer.parseInt(line);					
					firstLine = false;
				} else {
					int index = 0;
					String[] splitString = line.split(" ");
					int n = Integer.parseInt(splitString[index++]);
					Queue<String> orderQueue = new LinkedList<String>();
					Deque<Integer> orangeQueue =  new ArrayDeque<Integer>();
					Deque<Integer> blueQueue = new ArrayDeque<Integer>();

					for(int i=0;i<n;i++) {
						String robot = splitString[index++];
						orderQueue.add(robot);

						if(robot.equals("O")) {
							orangeQueue.add(Integer.parseInt(splitString[index++]));
						} else {
							blueQueue.add(Integer.parseInt(splitString[index++]));
						}						
					}

					if(caseNum == numOfTestCases) {
						buffWriter.write("Case #" + caseNum + ": " + botTrust.findMin(orderQueue, orangeQueue, blueQueue));
						break;
					} else {
						buffWriter.write("Case #" + caseNum + ": " + botTrust.findMin(orderQueue, orangeQueue, blueQueue) + System.getProperty("line.separator"));
					}
					
					caseNum++;					
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();								
		} finally {
			try {
				if(lnr != null) lnr.close();
				if(buffWriter != null) buffWriter.close();				
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}

	private int findMin(Queue<String> orderQueue, Deque<Integer> orangeQueue, Deque<Integer> blueQueue) {
		int res = 0;
		int orangePos = 1;
		int bluePos = 1;
		
		while(true) {
			if(orderQueue.isEmpty()) {
				break;
			}
			String robot = (String) orderQueue.remove();			
			
			if(robot.equals("O")) {
				int orangeSwitch = (Integer) orangeQueue.removeFirst();
				int orangeTimeRequired = Math.abs(orangeSwitch - orangePos) + 1;
				res += orangeTimeRequired;
				orangePos = orangeSwitch;				
				
				if(!blueQueue.isEmpty()) {
					int blueSwitch = blueQueue.removeFirst();
					blueQueue.addFirst(blueSwitch);
					int blueTimeRequired = Math.abs(blueSwitch - bluePos);
					if(blueTimeRequired >= orangeTimeRequired) {
						bluePos = (blueSwitch > bluePos) ? (bluePos + orangeTimeRequired) : (bluePos - orangeTimeRequired);
					} else {
						bluePos = blueSwitch;
					}
				}				
			} else {
				int blueSwitch = (Integer) blueQueue.removeFirst();
				int blueTimeRequired = Math.abs(blueSwitch - bluePos) + 1;
				res += blueTimeRequired;
				bluePos = blueSwitch;
				
				if(!orangeQueue.isEmpty()) {
					int orangeSwitch = orangeQueue.removeFirst();
					orangeQueue.addFirst(orangeSwitch);
					int orangeTimeRequired = Math.abs(orangeSwitch - orangePos);
					if(orangeTimeRequired >= blueTimeRequired) {
						orangePos = (orangeSwitch > orangePos) ? (orangePos + blueTimeRequired) : (orangePos - blueTimeRequired);
					} else {
						orangePos = orangeSwitch;
					}
				}				
			}
		}

		return res;
	}
}