package com.bchetty.gcj2013;

import java.io.*;

/**
 *
 * @author Babji Prashanth, Chetty
 */
public class TicTacToe {
    public static final String xWin1 = "XXXX";
    public static final String xWin2 = "XXXT";
    public static final String xWin3 = "XXTX";
    public static final String xWin4 = "XTXX";
    public static final String xWin5 = "TXXX";
    
    public static final String possibleXWin1 = "XXX.";
    public static final String possibleXWin2 = "XX.X";
    public static final String possibleXWin3 = "X.XX";
    public static final String possibleXWin4 = ".XXX";
    public static final String possibleXWin5 = "XX.T";
    public static final String possibleXWin6 = "XXT.";
    public static final String possibleXWin7 = "X.TX";
    public static final String possibleXWin8 = "XT.X";
    public static final String possibleXWin9 = ".TXX";
    public static final String possibleXWin10 = "T.XX";
    public static final String possibleXWin11 = ".XXT";
    public static final String possibleXWin12 = "TXX.";
    public static final String possibleXWin13 = "X.XT";
    public static final String possibleXWin14 = "XTX.";
    
    public static final String oWin1 = "OOOO";
    public static final String oWin2 = "OOOT";
    public static final String oWin3 = "OOTO";
    public static final String oWin4 = "OTOO";
    public static final String oWin5 = "TOOO";
    
    public static final String possibleOWin1 = "OOO.";
    public static final String possibleOWin2 = "OO.O";
    public static final String possibleOWin3 = "O.OO";
    public static final String possibleOWin4 = ".OOO";
    public static final String possibleOWin5 = "OO.T";
    public static final String possibleOWin6 = "OOT.";
    public static final String possibleOWin7 = "O.TO";
    public static final String possibleOWin8 = "OT.O";
    public static final String possibleOWin9 = ".TOO";
    public static final String possibleOWin10 = "T.OO";
    public static final String possibleOWin11 = ".OOT";
    public static final String possibleOWin12 = "TOO.";
    public static final String possibleOWin13 = "O.OT";
    public static final String possibleOWin14 = "OTO.";
    
    public static final String empty = "....";
    
    public static void main(String[] args) {
        TicTacToe ticTacToe = new TicTacToe();
        LineNumberReader lineNumberReader = null;
        BufferedWriter bufferedWriter = null;

        try {
            lineNumberReader = new LineNumberReader(new FileReader("/Users/babjichetty/Downloads/A-small-attempt2.in"));
            bufferedWriter = new BufferedWriter(new FileWriter("/Users/babjichetty/Downloads/A-small2.out"));
            String line = null;
            int index = 0;
            int count = 0;

            while ((line = lineNumberReader.readLine()) != null) {
                if(index == 0) {
                    count = Integer.parseInt(line);
                    System.out.println("Count : " + count);
                    index++;
                    continue;
                } 
                if(index > count) {
                    break;
                }
                
                String[] board = new String[4];
                board[0] = line;
                board[1] = lineNumberReader.readLine();
                board[2] = lineNumberReader.readLine();
                board[3] = lineNumberReader.readLine();
                
                if(index != count) {
                    lineNumberReader.readLine();
                }
                
                bufferedWriter.write("Case #" + index + ": " + ticTacToe.getStatusQuo(board));
                bufferedWriter.newLine();
                index++;
                
            }
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            //Close the BufferedWriter
            try {
                if (lineNumberReader != null) {
                    lineNumberReader.close();
                }
                if (bufferedWriter != null) {
                    bufferedWriter.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    private String getStatusQuo(String[] board) {
        String status = null;
        boolean notComplete = false;
        
        int countX = 0;
        int countO = 0;
        boolean xNextStep = false;
        
        for(int i=0;i<4;i++) {
            for(int j=0;j<4;j++) {
                if(board[i].charAt(j) == 'X') {
                    countX++;
                } else if(board[i].charAt(j) == 'O') {
                    countO++;
                } else if(board[i].charAt(j) == '.') {
                    notComplete = true;
                }
            }
        }
        
        if(countX == countO) {
            xNextStep = true;
        }
        
        for(int i=0;i<4;i++) {
            String res1 = check(board[i],xNextStep, notComplete);
            if(res1 != null) {
                return res1;
            }
            
            if(i==0) {
                for(int j=0;j<4;j++) {
                    String col = board[0].charAt(j) + "" + board[1].charAt(j) + "" + board[2].charAt(j) + "" +
                            board[3].charAt(j);
                    
                    String res2 = check(col,xNextStep, notComplete);
                    if(res2 != null) {
                        return res2;
                    }
                    
                    if(j == 0) {
                        String diag1 = board[0].charAt(0) + "" + board[1].charAt(1) + "" + board[2].charAt(2) + "" +
                            board[3].charAt(3);
                        
                        String res3 = check(diag1,xNextStep, notComplete);
                        if(res3 != null) {
                           return res3;
                        }
                    }
                    
                    if(j == 3) {
                        String diag2 = board[0].charAt(3) + "" + board[1].charAt(2) + "" + board[2].charAt(1) + "" +
                            board[3].charAt(0);
                        
                        String res4 = check(diag2,xNextStep, notComplete);
                        if(res4 != null) {
                            return res4;
                        }
                    }
                }       
            }
        }
        
        return notComplete ? "Game has not completed" : "Draw";
    }
    
    /**
     * 
     * @param str
     * @return 
     */
    private String check(String str, boolean xNextStep, boolean notComplete) {
        if(str.equals(xWin1) || str.equals(xWin2) || str.equals(xWin3) || 
                str.equals(xWin4) || str.equals(xWin5)) {
            return "X won";
        }
        if(str.equals(oWin1) || str.equals(oWin2) || str.equals(oWin3) || 
                str.equals(oWin4) || str.equals(oWin5)) {
            return "O won";
        }
        
        if(notComplete) {
            if(xNextStep) {
                if(str.equals(possibleXWin1) || str.equals(possibleXWin2) ||str.equals(possibleXWin3) || str.equals(possibleXWin4) || 
                        str.equals(possibleXWin5) || str.equals(possibleXWin6) || str.equals(possibleXWin7) || str.equals(possibleXWin8) || 
                        str.equals(possibleXWin9) || str.equals(possibleXWin10) || str.equals(possibleXWin11) || str.equals(possibleXWin12) || 
                        str.equals(possibleXWin13) || str.equals(possibleXWin14)) {
                    return "X won";
                }
            } else {
                if(str.equals(possibleOWin1) || str.equals(possibleOWin2) ||str.equals(possibleOWin3) || str.equals(possibleOWin4) || 
                        str.equals(possibleOWin5) || str.equals(possibleOWin6) || str.equals(possibleOWin7) || str.equals(possibleOWin8) || 
                        str.equals(possibleOWin9) || str.equals(possibleOWin10) || str.equals(possibleOWin11) || str.equals(possibleOWin12) || 
                        str.equals(possibleOWin13) || str.equals(possibleOWin14)) {
                    return "O won";
                }
            }
        }
        
        return null;
    }
}
