import java.util.*;
import java.io.*;

public class Snapper {
	public static void main(String[] args) {
		File file = null;
		LineNumberReader lnr = null;
		BufferedWriter buffWriter = null;

		try {
			file = new File("A-small-attempt1.in.e");
			lnr = new LineNumberReader(new FileReader(file));

			buffWriter = new BufferedWriter(new FileWriter(new File("A-small.out")));

			Snapper snapper = new Snapper();

			String line = "";
			boolean newInput = false;
			boolean firstLine = true;
			int numOfTestCases = 0;
			int caseNum = 1;

			while((line = lnr.readLine()) != null) {
				if(firstLine) {					
					numOfTestCases = Integer.parseInt(line);					
					firstLine = false;
				} else {
					String[] splitString = line.split(" ");
					double n = Double.parseDouble(splitString[0]);
					double k = Double.parseDouble(splitString[1]);

					if(caseNum == numOfTestCases) {
						buffWriter.write("Case #" + caseNum + ": " + snapper.findDeviceStatus(n,k));
						break;
					} else {
						buffWriter.write("Case #" + caseNum + ": " + snapper.findDeviceStatus(n,k) + System.getProperty("line.separator"));
					}
					
					caseNum++;					
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();								
		} finally {
			try {
				if(lnr != null) lnr.close();
				if(buffWriter != null) buffWriter.close();				
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}

	private String findDeviceStatus(double numOfSnappers, double numOfSnaps) {
		if(numOfSnaps == 0) return "OFF";
		double minRequiredSnaps = Math.pow(2, numOfSnappers) - 1;
		if(numOfSnaps < minRequiredSnaps) return "OFF";

		return (minRequiredSnaps == numOfSnaps || ((numOfSnaps % (minRequiredSnaps + 1)) == minRequiredSnaps)) ? "ON" : "OFF";
	}
}