import java.util.*;
import java.io.*;
import java.math.BigInteger;

public class FairWarning {
	public static void main(String[] args) {
		File file = null;
		LineNumberReader lnr = null;
		BufferedWriter buffWriter = null;

		try {
			file = new File("B-small-attempt6.in.e");
			lnr = new LineNumberReader(new FileReader(file));

			buffWriter = new BufferedWriter(new FileWriter(new File("B-small.out")));

			FairWarning fairWarning = new FairWarning();

			String line = "";
			boolean newInput = false;
			boolean firstLine = true;
			int numOfTestCases = 0;
			int caseNum = 1;

			while((line = lnr.readLine()) != null) {
				if(firstLine) {					
					numOfTestCases = Integer.parseInt(line);					
					firstLine = false;
				} else {
					String[] splitString = line.split(" ");
					int n = Integer.parseInt(splitString[0]);

					ArrayList<BigInteger> numberList = new ArrayList<BigInteger>();
					for(int i=0;i<n;i++) {
						numberList.add(new BigInteger(splitString[i+1]));
					}

					if(caseNum == numOfTestCases) {
						buffWriter.write("Case #" + caseNum + ": " + fairWarning.nextApocalypseParty(n, numberList));
						break;
					} else {
						buffWriter.write("Case #" + caseNum + ": " + fairWarning.nextApocalypseParty(n, numberList) + System.getProperty("line.separator"));
					}
					
					caseNum++;					
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();								
		} finally {
			try {
				if(lnr != null) lnr.close();
				if(buffWriter != null) buffWriter.close();				
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}

	private BigInteger nextApocalypseParty(int n, ArrayList<BigInteger> numberList) {
		Collections.sort(numberList);
		BigInteger gcdBigInt = new BigInteger("0");
		BigInteger smallest = numberList.get(0);

		for(int i=1;i<n;i++) {
			BigInteger difference = numberList.get(i).subtract(numberList.get(i-1));
			if(difference.equals(BigInteger.ONE)) return BigInteger.ZERO;			
			gcdBigInt = gcdBigInt.gcd(difference);

			if(gcdBigInt.equals(BigInteger.ZERO)) return BigInteger.ZERO;
		}
		
		if(gcdBigInt.equals(BigInteger.ZERO)) {
			return numberList.get(0);
		}

		return (gcdBigInt.multiply(smallest.divide(gcdBigInt).add(BigInteger.ONE))).subtract(smallest);				
	}
}