package com.bchetty.gcj2013;

import java.io.*;
import java.math.BigInteger;
import org.jscience.mathematics.number.LargeInteger;

/**
 *
 * @author Babji Prashanth, Chetty
 */
public class BullsEye {
    public static void main(String[] args) {
        BullsEye bullsEye = new BullsEye();
        LineNumberReader lineNumberReader = null;
        BufferedWriter bufferedWriter = null;

        try {
            lineNumberReader = new LineNumberReader(new FileReader("/Users/babjichetty/Downloads/A-small-attempt1(1).in"));
            bufferedWriter = new BufferedWriter(new FileWriter("/Users/babjichetty/Downloads/A-small.out"));
            String line = null;
            int index = 0;
            int count = 0;

            while ((line = lineNumberReader.readLine()) != null) {
                if(index == 0) {
                    count = Integer.parseInt(line);
                    System.out.println("Count : " + count);
                    index++;
                    continue;
                } 
                if(index > count) {
                    break;
                }
                
                String[] arr = line.split(" ");
                LargeInteger r = LargeInteger.valueOf(new BigInteger(arr[0]));
                LargeInteger t = LargeInteger.valueOf(new BigInteger(arr[1]));
                
                bufferedWriter.write("Case #" + index + ": " + bullsEye.findNumOfRings(r,t));
                bufferedWriter.newLine();
                index++;               
            }
        } catch (FileNotFoundException ex) {
            ex.printStackTrace();
        } catch (IOException ex) {
            ex.printStackTrace();
        } finally {
            //Close the BufferedWriter
            try {
                if (lineNumberReader != null) {
                    lineNumberReader.close();
                }
                if (bufferedWriter != null) {
                    bufferedWriter.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }
    
    /**
     * 
     * @param r
     * @param t
     * @return 
     */
    private LargeInteger findNumOfRings(LargeInteger r, LargeInteger t) {
        LargeInteger res = LargeInteger.ZERO;
        LargeInteger nextRadius = r;
        LargeInteger remainingPaint = t;
        
        while(remainingPaint.compareTo(LargeInteger.ZERO) > 0) {
            LargeInteger paintRequired = ((nextRadius.plus(LargeInteger.ONE)).times(nextRadius.plus(LargeInteger.ONE)).minus(
                                                            nextRadius.times(nextRadius)));
            
            if(remainingPaint.compareTo(paintRequired) >= 0) {
                res = res.plus(LargeInteger.ONE);
                remainingPaint = remainingPaint.minus(paintRequired);
                nextRadius = nextRadius.plus(LargeInteger.ONE).plus(LargeInteger.ONE);
            } else {
                break;
            }
        }
        
        return res;
    }
}