import java.util.*;
import java.io.*;

public class ThemePark {
	public static void main(String[] args) {
		File file = null;
		LineNumberReader lnr = null;
		BufferedWriter buffWriter = null;

		try {
			file = new File("C-small-attempt0.in.e");
			lnr = new LineNumberReader(new FileReader(file));

			buffWriter = new BufferedWriter(new FileWriter(new File("C-small.out")));

			ThemePark themePark = new ThemePark();

			String line = "";
			boolean newInput = false;
			boolean firstLine = true;
			int numOfTestCases = 0;
			int caseNum = 1;

			while((line = lnr.readLine()) != null) {
				if(firstLine) {					
					numOfTestCases = Integer.parseInt(line);					
					firstLine = false;
				} else {
					String[] splitString1 = line.split(" ");
					long numOfRuns = Long.parseLong(splitString1[0]);
					long rollerCosterSize = Long.parseLong(splitString1[1]);
					long numOfGroups = Long.parseLong(splitString1[2]);

					String[] splitString2 = lnr.readLine().split(" ");
					Queue<Long> groupQueue = new LinkedList<Long>();

					for(String str: splitString2) {
						groupQueue.add(Long.parseLong(str));
					}

					if(caseNum == numOfTestCases) {
						buffWriter.write("Case #" + caseNum + ": " + themePark.calculate(numOfRuns,rollerCosterSize, numOfGroups, groupQueue));
						break;
					} else {
						buffWriter.write("Case #" + caseNum + ": " + themePark.calculate(numOfRuns,rollerCosterSize, numOfGroups, groupQueue) + System.getProperty("line.separator"));
					}
					
					caseNum++;					
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();								
		} finally {
			try {
				if(lnr != null) lnr.close();
				if(buffWriter != null) buffWriter.close();				
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}

	private long calculate(long numOfRuns, long rollerCosterSize, long numOfGroups, Queue<Long> groupQueue) {
		long res = 0;

		for(int i=0;i<numOfRuns;i++) {
			int size = 0;
			int groupSize = 1;

			while(groupSize <= numOfGroups) {
				long firstInQueue = groupQueue.element();
				groupSize++;

				if((size + firstInQueue) <= rollerCosterSize) {
					size += firstInQueue;
					res += firstInQueue;
					groupQueue.add(groupQueue.remove());
				} else {
					break;
				}
			}			
		}

		return res;
	}
}