import java.util.*;
import java.io.*;

public class FileFixer {
	public static void main(String[] args) {
		File file = null;
		LineNumberReader lnr = null;
		BufferedWriter buffWriter = null;

		try {
			file = new File("A-large.in.e");
			lnr = new LineNumberReader(new FileReader(file));

			buffWriter = new BufferedWriter(new FileWriter(new File("A-large.out")));

			FileFixer fileFixer = new FileFixer();

			String line = "";
			boolean newInput = false;
			boolean firstLine = true;
			int numOfTestCases = 0;
			int caseNum = 1;

			while((line = lnr.readLine()) != null) {
				if(firstLine) {					
					numOfTestCases = Integer.parseInt(line);					
					firstLine = false;
				} else {
					String[] splitString = line.split(" ");
					int n = Integer.parseInt(splitString[0]);
					int m = Integer.parseInt(splitString[1]);

					ArrayList<String> alreadyExistsList = new ArrayList<String>();
					ArrayList<String> newList = new ArrayList<String>();
					
					for(int i=0;i<n;i++) {
						alreadyExistsList.add(lnr.readLine());
					}

					for(int i=0;i<m;i++) {
						newList.add(lnr.readLine());
					}

					if(caseNum == numOfTestCases) {
						buffWriter.write("Case #" + caseNum + ": " + fileFixer.numberOfMakes(alreadyExistsList, newList));
						break;
					} else {
						buffWriter.write("Case #" + caseNum + ": " + fileFixer.numberOfMakes(alreadyExistsList, newList) + System.getProperty("line.separator"));
					}
					
					caseNum++;					
				}
			}
		} catch (Exception ex) {
			ex.printStackTrace();								
		} finally {
			try {
				if(lnr != null) lnr.close();
				if(buffWriter != null) buffWriter.close();				
			} catch (Exception e) {
				e.printStackTrace();
			}			
		}
	}

	private int numberOfMakes(ArrayList<String> alreadyExistsList, ArrayList<String> newList) {
		int res = 0;
		int length = newList.size();

		for(int i=0;i<length;i++) {
			String newDir = newList.get(i);

			if(!alreadyExistsList.contains(newDir)) {
				res += digThisShit(newDir, alreadyExistsList);				
			}
		}		

		return res;
	}

	public static int digThisShit(String dirName, ArrayList<String> alreadyExistsList) {
		if(alreadyExistsList.contains(dirName)) {
			return 0;
		} else {
			alreadyExistsList.add(dirName);
			int index = dirName.lastIndexOf("/");
		
			String parent = null;
			if(index == 0) {				
				return 1;
			} else {
				parent = dirName.substring(0, index);
			}

			return 1 + digThisShit(parent, alreadyExistsList);
		}
	}
}