package ROUND1B2017;

import org.junit.Test;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * Project: google-code-jam
 * Author:  Brian Dang
 * Date:    4/22/2017
 */

public class StableNeighbors {
    public Character getOtherColorWithMaxCount(Map<Character, Integer> colorMap, char color, Map<Character, Integer> firstOccurringIndex) {
        System.out.println("getOtherColorWithMaxcount(" + colorMap + ", " + color + ", " + firstOccurringIndex + " )");
        Character colorWithMaxCount = null;
        int maxCount = Integer.MIN_VALUE;
        int firstIdx = Integer.MAX_VALUE;

        for(Map.Entry<Character, Integer> entry : colorMap.entrySet()) {
            // Make sure it is not the same color
            if(entry.getKey() != color) {
                int count = entry.getValue();
                if(count == 0)
                    continue;

                if(count > maxCount) {
                    maxCount = count;
                    colorWithMaxCount = entry.getKey();
                    if(firstOccurringIndex.containsKey(colorWithMaxCount)) {
                        firstIdx = firstOccurringIndex.get(colorWithMaxCount);
                    }
                } else if(count == maxCount) {
                    System.out.println("*** TIE *** " + colorWithMaxCount + " and " + entry.getKey());
                    if(firstOccurringIndex.containsKey(entry.getKey())) {
                        int myFirstIndex = firstOccurringIndex.get(entry.getKey());
                        if(myFirstIndex < firstIdx) {
                            colorWithMaxCount = entry.getKey();
                            firstIdx = myFirstIndex;
                        }
                    }
                }
            }
        }

        System.out.println(colorWithMaxCount + " has max count of " + maxCount + " with a first occurring index of " + firstIdx);

        return colorWithMaxCount;
    }

    public String getValidCircularStable(Map<Character, Integer> colorMap, int numStables) {
        System.out.println("getValidCircularStable(" + colorMap.toString() + ", " + numStables + ")");
        String result = "";

        // Indicates the first occurring index of a specific color
        Map<Character, Integer> firstOccurringIndex = new HashMap<Character, Integer>();

        // Get first character
        char prevColor = getOtherColorWithMaxCount(colorMap, ' ', firstOccurringIndex);
        result = result + prevColor;
        int oldCount = colorMap.get(prevColor);
        colorMap.put(prevColor, oldCount - 1);

        System.out.println("Result: " + result);
        firstOccurringIndex.put(prevColor, 0);

        for(int i=1; i < numStables; i++) {
            Character myColor = getOtherColorWithMaxCount(colorMap, prevColor, firstOccurringIndex);
            if(myColor == null) {
                return "IMPOSSIBLE";
            }
            result = result + myColor;
            System.out.println("Result: " + result);

            oldCount = colorMap.get(myColor);
            colorMap.put(myColor, oldCount - 1);

            if(firstOccurringIndex.containsKey(myColor) == false) {
                int lastIdx = result.length() - 1;
                firstOccurringIndex.put(myColor, lastIdx);
            }

            prevColor = myColor;
        }

        // Check last index with first index
        int lastIndex = result.length() - 1;
        if(result.charAt(0) == result.charAt(lastIndex))
            return "IMPOSSIBLE";

        return result;
    }

    /**
     * Parses the input of test cases and generates an output file with solutions to each test case.
     * @param filePath the file path to the input file
     */
    public void runTestCases(String filePath) {
        try {
            PrintWriter pw = new PrintWriter(new File("solution-" + filePath));
            File input = new File(filePath);
            Scanner scan = new Scanner(input);

            int testCases = Integer.valueOf(scan.nextLine());
            for(int i=1; i <= testCases; i++) {
                int N = scan.nextInt();
                int R = scan.nextInt();
                int O = scan.nextInt();
                int Y = scan.nextInt();
                int G = scan.nextInt();
                int B = scan.nextInt();
                int V = scan.nextInt();

                int sum = R + O + Y + G + B + V;
                if(sum != N) {
                    System.out.println("********** N is not equal to sum of all unicorns!!! *********");
                }

                Map<Character, Integer> colorMap = new HashMap<Character, Integer>();
                colorMap.put('R', R);
                colorMap.put('O', O);
                colorMap.put('Y', Y);
                colorMap.put('G', G);
                colorMap.put('B', B);
                colorMap.put('V', V);

                String validCircularStable = getValidCircularStable(colorMap, N);
                pw.write("Case #" + i + ": " + validCircularStable + "\n");
            }

            scan.close();
            pw.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    @Test
    public void test() {
        StableNeighbors f = new StableNeighbors();
        Map<Character, Integer> colorMap = new HashMap<Character, Integer>();
        colorMap.put('R', 2);
        colorMap.put('O', 0);
        colorMap.put('Y', 2);
        colorMap.put('G', 0);
        colorMap.put('B', 2);
        colorMap.put('V', 0);
        int N = 6;

        String validCircularStable = f.getValidCircularStable(colorMap, N);
        System.out.println(validCircularStable);

    }

    @Test
    public void input() {
        StableNeighbors f = new StableNeighbors();
//        f.runTestCases("2-sample.in");
        f.runTestCases("2-small.in");
//        f.runTestCases("2-large.in");
    }
}
