import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.*;

public class ProblemD {

    public static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

    int[][] row, col, diagDesc, diagAsc;
    char occupied[][];
    int N;

    public void run(int caseNum) throws IOException{
        String output = "Case #" + caseNum + ": ";
        String input[] = br.readLine().split("\\s+");
        N = pint(input[0]);
        int M = pint(input[1]);
        occupied = new char[N][N];
        row = new int[N][3]; //0 is +, 1 is x, 2 is o
        col = new int[N][3];
        diagDesc = new int[N+N-1][3];
        diagAsc = new int[N+N-1][3];

        int score = 0;

        for(int i = 0; i<M; i++){
            input = br.readLine().split("\\s+");
            char car = input[0].charAt(0);
            int r = pint(input[1])-1;
            int c = pint(input[2])-1;
            occupied[r][c] = car;
            switch(car){
                case '+':
                    score += 1;
                    row[r][0]++;
                    col[c][0]++;
                    diagDesc[r-c+N-1][0]++;
                    diagAsc[r+c][0]++;
                    break;
                case 'x':
                    score += 1;
                    row[r][1]++;
                    col[c][1]++;
                    diagDesc[r-c+N-1][1]++;
                    diagAsc[r+c][1]++;
                    break;
                case 'o':
                    score += 2;
                    row[r][2]++;
                    col[c][2]++;
                    diagDesc[r-c+N-1][2]++;
                    diagAsc[r+c][2]++;
                    break;
            }
        }

//        0 is +, 1 is x, 2 is o
//        Whenever any two models share a row or column, at least one of the two must be a +.
//        Whenever any two models share a diagonal of the grid, at least one of the two must be an x.

        ArrayList<String> outputs = new ArrayList<>();
        int count = 0;
        //first check all possible o's
        for(int i = 0; i<N; i++){
            for(int j = 0; j<N; j++){
                if(occupied[i][j] == 'o')continue;
                boolean freeRowCol = row[i][1] == 0 && row[i][2] == 0 && col[j][1] == 0 && col[j][2] == 0;
                boolean freeDescDiag = diagDesc[i-j+N-1][0] == 0 && diagDesc[i-j+N-1][2] == 0;
                boolean freeAscDiag = diagAsc[i+j][0] == 0 && diagAsc[i+j][2] == 0;
                if(occupied[i][j] == '+'){
                    if(diagDesc[i-j+N-1][0] <= 1 && diagDesc[i-j+N-1][2] == 0){
                        freeDescDiag = true;
                    }
                    if(diagAsc[i+j][0] <= 1 && diagAsc[i+j][2] == 0){
                        freeAscDiag = true;
                    }
                }
                if(freeRowCol && freeAscDiag && freeDescDiag){ //can be anything so put o
                    if(occupied[i][j] == 'x' || occupied[i][j] == '+'){
                        score--;
                    }
                    count++;
                    score += 2;
                    addToGrid(2, i, j);
                    outputs.add("o " + (i+1) + " " + (j+1));
                }
            }
        }
        //then check for x and +
        for(int i = 0; i<N; i++){
            for(int j = 0; j<N; j++){
                if(occupied[i][j] == 'o' || occupied[i][j] == 'x' || occupied[i][j] == '+') continue;
                boolean freeRowCol = row[i][1] == 0 && col[j][1] == 0 && row[i][2] == 0 && col[j][2] == 0;
                boolean freeDescDiag = diagDesc[i-j+N-1][0] == 0 && diagDesc[i-j+N-1][2] == 0;
                boolean freeAscDiag = diagAsc[i+j][0] == 0 && diagAsc[i+j][2] == 0;

                if(freeRowCol && (!freeAscDiag || !freeDescDiag)){ //diag can only be x
                    addToGrid(1, i, j);
                    count++;
                    score += 1;
                    outputs.add("x " + (i+1) + " " + (j+1));
                }else if(!freeRowCol && freeAscDiag && freeDescDiag){ //row can only be +
                    addToGrid(0, i, j);
                    count++;
                    score += 1;
                    outputs.add("+ " + (i+1) + " " + (j+1));
                }
            }
        }
        output += score + " " + count;
        System.out.println(output);
        for(String s : outputs){
            System.out.println(s);
        }

    }

    public void addToGrid(int i, int r, int c){
        if(i == 0) occupied[r][c] = '+';
        if(i == 1) occupied[r][c] = 'x';
        if(i == 2) occupied[r][c] = 'o';
        row[r][i]++;
        col[c][i]++;
        diagAsc[r+c][i]++;
        diagDesc[r-c+N-1][i]++;
    }


    public static void main(String[] args) throws IOException{
        int testcases = pint(br.readLine());
        for(int i = 0; i<testcases; i++){
            new ProblemD().run(i+1);
        }
    }

    public static int pint(String input){
        return Integer.parseInt(input);
    }

    public static long plong(String input){
        return Long.parseLong(input);
    }

    public static double pdouble(String input){
        return Double.parseDouble(input);
    }

}
