import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Comparator;
import java.util.PriorityQueue;


public class problemC {

    class Partition implements Comparable<Partition>{
        long Ileft;
        long Iright;
        long stall;
        long min;
        long max;
        Partition(long lastOccupiedLeft, long lastUnoccupiedRight){
            this.Ileft = lastOccupiedLeft;
            this.Iright = lastUnoccupiedRight;
            min = ((Iright - Ileft)-1)/2;
            max = ((Iright - Ileft))/2;
            stall = (Ileft + 1) + min;
        }

        @Override
        public int compareTo(Partition o) {
            if(this.min != o.min) {
                if (this.min > o.min) {
                    return -1;
                } else{
                    return 1;
                }
            }

            if(this.max != o.max) {
                if (this.max > o.max) {
                    return -1;
                } else{
                    return 1;
                }
            }

            if(this.stall < o.stall){
                return -1;
            }else if(o.stall < this.stall){
                return 1;
            }

            System.out.println("wtf");
            return 0; //should not be reachable.
        }
    }

    public static BufferedReader br = new BufferedReader(new InputStreamReader(System.in));


    public void run(int c) throws IOException{
        String output = "Case #" + c + ": ";
        String[] input = br.readLine().split("\\s+");
        long N = plong(input[0]);
        int K = pint(input[1]);
        PriorityQueue<Partition> Q = new PriorityQueue<>();
        Q.add(new Partition(0, N)); //last occupied is the 0th one, last unoccupied is before N+1, aka N

        Partition best = null;
        for(int i = 0; i<K; i++){
            best = Q.poll();
            //System.out.println(best.Ileft + " " + best.Iright + ": " + best.min + " " + best.max + " " + best.stall);
            Q.add(new Partition(best.Ileft, best.stall - 1));
            Q.add(new Partition(best.stall, best.Iright));
        }
//        System.out.println();
//        while(!Q.isEmpty()) {
//            Partition p = Q.poll();
//            System.out.println(p.Ileft + " " + p.Iright + ": " + p.min + " " + p.max + " " + p.stall);
//        }

        output += best.max + " ";
        output += best.min;

        System.out.println(output);

    }


    public static void main(String[] args) throws IOException{
        int testcases = pint(br.readLine());
        for(int i = 0; i<testcases; i++){
            new problemC().run(i+1);
        }
    }

    public static int pint(String input){
        return Integer.parseInt(input);
    }

    public static long plong(String input){
        return Long.parseLong(input);
    }

    public static double pdouble(String input){
        return Double.parseDouble(input);
    }

}
