package codejam;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

/**
 * Created by bdomokos on 08/04/17.
 */
public class TidyNumbers {
    public static void main(String[] args) throws IOException {
        String fname = "B-small-attempt1.in";
        Path ins = Paths.get(fname);
        InputStream is = Files.newInputStream(ins);
        Scanner s = new Scanner(is);
        Path outs = Paths.get(fname + ".out");
        BufferedWriter out = Files.newBufferedWriter(outs);

        int n = s.nextInt();
        for (int i = 0; i < n; i++) {
            long num = s.nextLong();
            long solution = calcPrevTidy(num);
            out.write("Case #" + (i + 1) + ": " + solution);
            out.newLine();
        }
        out.flush();
        out.close();
    }
    private static long calcPrevTidy2(long input) {
        long num = input;
        if(num<10) return num;

        while(input>0) {
            num = input;
            List<Integer> lstDigits = new ArrayList<>();
            while (num > 0) {
                lstDigits.add((int) (num % 10));
                num /= 10;
            }
            int n = lstDigits.size();
            Collections.reverse(lstDigits);
            boolean good = true;
            for (int i = 0; i < n-1; i++) {
                if(lstDigits.get(i)>lstDigits.get(i+1)) {
                    good = false;
                    break;
                }
            }
            if(good) return input;
            input--;
        }
        return 0;
    }

    private static long calcPrevTidy(long input) {
        long num = input;
        if(num<10) return num;
        List<Integer> lstDigits = new ArrayList<>();
        while (num > 0) {
            lstDigits.add((int)(num%10));
            num /= 10;
        }
        Collections.reverse(lstDigits);
        int n =lstDigits.size();
        int digits[] = new int[n];
        for (int i = 0; i < n; i++) {
            digits[i] = lstDigits.get(i);
        }

        while(true) {
            int curr = 0;
            boolean found = false;
            while (curr < n - 1) {
                if (digits[curr] > digits[curr + 1]) {
                    found = true;
                    break;
                }
                curr++;
            }
            if (!found) break;

            digits[curr]--;
            while (curr > 0 && digits[curr] == 0) {
                curr--;
                digits[curr]--;
            }
            curr++;
            while (curr < n) {
                digits[curr++] = 9;
            }
        }


        long result = digits[0];
        for (int i = 1; i < n; i++) {
            result = result*10+digits[i];
        }
        return result;
    }
}
