package org.bds.contest;

import java.io.IOException;
import java.util.List;
import java.util.Set;

/**
 * Created by IntelliJ IDEA.
 * User: bds
 * Date: Sep 3, 2009
 * Time: 5:09:41 PM
 */
public class AlienLanguage extends AbstractProblem {
    private List<String> dict;
    private List<Set<Character>> pattern;

    public AlienLanguage(List<String> dict, List<Set<Character>>pattern) {

        this.dict = dict;
        this.pattern = pattern;
    }
    public void process() throws IOException {
        int count = 0;
        for (String word : dict) {
            if (match(word)) {
                count++;
            }
        }
        resultWriter.writeLine(header + count);
    }

    private boolean match(String word) {
        for(int i = 0; i<word.length(); i++) {
            if (!pattern.get(i).contains(word.charAt(i))) {
                return false;
            }
        }
        return true;
    }
}
