package codejam;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.InputStream;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Scanner;

/**
 * Created by bdomokos on 08/04/17.
 */
public class Pancake {
    public static void main(String[] args) throws IOException {
        String fname = "A-large.in";
        Path ins = Paths.get(fname);
        InputStream is = Files.newInputStream(ins);
        Scanner s = new Scanner(is);
        Path outs = Paths.get(fname + ".out");
        BufferedWriter out = Files.newBufferedWriter(outs);

        int n = s.nextInt();
        s.nextLine();
        for (int i = 0; i < n; i++) {
            String line = s.nextLine();
            String arr[] = line.split(" ");
            String pencakes = arr[0];
            int size = Integer.parseInt(arr[1]);

            int solution = minFlips(pencakes, size);
            out.write("Case #"+(i+1)+": "+(solution==-1?"IMPOSSIBLE":solution));
            out.newLine();
        }
        out.flush();
        out.close();
    }

    private static int minFlips(String pencakes, int size) {
        boolean allPlus = true;
        int n = pencakes.length();
        for (int i = 0; i < pencakes.length(); i++) {
            if(pencakes.charAt(i)!='+') {
                allPlus = false;
                break;
            }
        }
        if(allPlus) return 0;
        char pc[] = pencakes.toCharArray();
        int result = 0;
        for (int i = 0; i < n; i++) {
            if(pc[i]=='+') continue;
            if(i+size>n) {
                result = -1;
                break;
            }
            for (int j = 0; j < size; j++) {
                int curr = pc[i+j];
                pc[i+j] = (curr=='-')?'+':'-';
            }
            result++;
        }
        return result;
    }

}
