package org.codejam.themepark;

import javax.swing.*;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.LinkedList;

/**
 * Created by IntelliJ IDEA.
 * User: bds
 */
public class CoasterCase {

    private int numRides;
    private int capacity;
    private int numGroups;
    private LinkedList<Integer> groups = new LinkedList<Integer>();

    public CoasterCase(int numRides, int capacity, int numGroups) {

        this.numRides = numRides;
        this.capacity = capacity;
        this.numGroups = numGroups;
    }

    public int getNumRides() {
        return numRides;
    }

    public void setNumRides(int numRides) {
        this.numRides = numRides;
    }

    public int getCapacity() {
        return capacity;
    }

    public void setCapacity(int capacity) {
        this.capacity = capacity;
    }

    public int getNumGroups() {
        return numGroups;
    }

    public void setNumGroups(int numGroups) {
        this.numGroups = numGroups;
    }

    public void addGroup(int groupSize) {
        groups.add(groupSize);
    }

    public LinkedList<Integer> getGroups() {
        return groups;
    }

    public int calculate() {
        int currPeople = 0;
        for (int i = 0; i < numRides; i++) {
            int okToGo = 0;
            int groupsToGo = 0;
            for (int j = 0; j < numGroups; j++) {
                if (okToGo + groups.get(j) > capacity) {
                    break;
                } else {
                    okToGo += groups.get(j);
                    groupsToGo++;
                }
            }

            currPeople +=okToGo;

            for (int j = 0; j < groupsToGo; j++) {
                int group = groups.remove();
                groups.add(group);
            }
            
        }
        return currPeople;
    }

    public static void main(String[] args) throws Exception {
        String inputFile = "C-small-attempt2.in.txt";
        String outputFile = "C-small-attempt2.out.txt";

        BufferedWriter writer = new BufferedWriter(new FileWriter(outputFile));
        InputReader inputReader = InputReader.parse(new File(inputFile));
        for (int i = 0; i < inputReader.getNumCases(); i++) {
            CoasterCase ccase = inputReader.nextCase();
            writer.write(String.format("Case #%d: %d\n", (i+1), ccase.calculate()));
        }
        inputReader.close();
        writer.close();
    }
}
