package com.woodystech.QualificationRound;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class FairAndSquare
{
  private static final String PROBLEM = "FairAndSquare";

  // private static String FILENAME = "A-small-practice.in";
  // private static String FILENAME = "A-large-practice.in";
  // private static String FILENAME = "B-small-practice.in";
  // private static String FILENAME = "B-large-practice.in";
  private static String FILENAME = "C-small-attempt0.in";
  // private static String FILENAME = "C-large-practice.in";
  // private static String FILENAME = "D-small-practice.in";
  // private static String FILENAME = "D-large-practice.in";

  public static void main(String[] args)
  {
    BufferedReader br = null;
    String outFileName;
    if (FILENAME.contains("small"))
    {
      outFileName = PROBLEM + "-small.out";
    }
    else
    {
      outFileName = PROBLEM + "-large.out";
    }

    try
    {
      FileWriter fstream = new FileWriter(outFileName);
      BufferedWriter out = new BufferedWriter(fstream);

      br = new BufferedReader(new FileReader(FILENAME));
      int numberTestCases = Integer.parseInt(br.readLine());

      System.out.println(numberTestCases);

      for (int i = 1; i <= numberTestCases; i++)
      {
        int result = 0;

        String[] numberRange = br.readLine().split(" ");
        long lowerLimit = Long.parseLong(numberRange[0]);
        long upperLimit = Long.parseLong(numberRange[1]);

        while (lowerLimit <= upperLimit)
        {
          System.out.println("Checking number: " + lowerLimit);
          if (isPalindrome(lowerLimit) && isSquare(lowerLimit))
          {
            System.out.println(lowerLimit + " is Fair & Square....");
            if (isPalindrome((long)Math.sqrt(lowerLimit)))
            {
              System.out.println(((long)Math.sqrt(lowerLimit)) + " is Fair as well!");
              result++;
            }
          }

          lowerLimit += 1;
        }

        System.out.println("Case #" + i + ": " + result);
        out.write("Case #" + i + ": " + result + "\r\n");
      }

      out.close();
    }
    catch (Exception e)
    {
      System.out.println(e);
    }
    finally
    {
      try
      {
        br.close();
      }
      catch (IOException e)
      {
        System.out.println(e);
      }
    }

  }

  private static boolean isPalindrome(long num)
  {

    String numString = num + "";
    String reverseString = "";

    for (int i = 0; i < numString.length(); i++)
    {
      reverseString += numString.substring(numString.length() - i - 1, numString.length() - i);
    }

    long reverseInt = Long.parseLong(reverseString);

    return num == reverseInt;
  }

  private static boolean isSquare(long num)
  {
    boolean result = false;

    long sqrt = (long)Math.sqrt(num);
    // int sqrt = (int)Math.sqrt(num);
    if((sqrt * sqrt) == num)
    {
      result = true;
    }

    return result;
  }
}
