package com.woodystech.QualificationRound;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class TicTacToeTomek
{
  private static final String PROBLEM = "TicTacToeTomek";

  // private static String FILENAME = "A-small-attempt3.in";
  private static String FILENAME = "A-large.in";
  // private static String FILENAME = "B-small-practice.in";
  // private static String FILENAME = "B-large-practice.in";
  // private static String FILENAME = "C-small-practice.in";
  // private static String FILENAME = "C-large-practice.in";
  // private static String FILENAME = "D-small-practice.in";
  // private static String FILENAME = "D-large-practice.in";

  public static void main(String[] args)
  {
    BufferedReader br = null;
    String outFileName;
    if (FILENAME.contains("small"))
    {
      outFileName = PROBLEM + "-small.out";
    }
    else
    {
      outFileName = PROBLEM + "-large.out";
    }

    try
    {
      FileWriter fstream = new FileWriter(outFileName);
      BufferedWriter out = new BufferedWriter(fstream);

      br = new BufferedReader(new FileReader(FILENAME));
      int numberTestCases = Integer.parseInt(br.readLine());

      System.out.println(numberTestCases);

      for (int i = 1; i <= numberTestCases; i++)
      {
        String result = "";
        List<String> board = new ArrayList<String>();
        boolean xWin = false;
        boolean yWin = false;
        boolean gameOver = false;

        for (int row = 0; row < 5; row++)
        {
          board.add(br.readLine());
        }

        for (int row = 0; row < 5; row++)
        {
          System.out.println(board.get(row));
        }

        for (int y = 0; y < 4; y++)
        {
          //System.out.println("y= " + y);
          // check horizontal
          //System.out.println("horizontal check: " + board.get(y));
          if (board.get(y).contains("XXXX") || board.get(y).contains("TXXX") || board.get(y).contains("XTXX") || board.get(y).contains("XXTX") || board.get(y).contains("XXXT"))
          {
            // System.out.println(board.get(y));
            System.out.println("H * * * * * * * * X SCORES * * * * * * * * * ");
            xWin = true;
          }
          if (board.get(y).contains("OOOO") || board.get(y).contains("TOOO") || board.get(y).contains("OTOOO") || board.get(y).contains("OOTO") || board.get(y).contains("OOOT"))
          {
            // System.out.println(board.get(y));
            System.out.println("H * * * * * * * *  O SCORES * * * * * * * * * ");
            yWin = true;
          }
          if (board.get(y).contains("."))
          {
            // System.out.println(board.get(y));
            System.out.println("H * * * * * * * *  GAME INCOMPLETE * * * * * * * * * ");
            gameOver = true;
          }

          // check vertical
          String verticalRow = "";
          for (int z = 0; z < 4; z++)
          {
            //System.out.println("z= " + z);
            verticalRow = verticalRow + board.get(z).substring(y, y + 1);
            // System.out.println("vertical check: " + verticalRow);
          }
          //System.out.println("Vertical Check: " + verticalRow);
          if (verticalRow.contains("XXXX") || verticalRow.contains("TXXX") || verticalRow.contains("XTXX") || verticalRow.contains("XXTX") || verticalRow.contains("XXXT"))
          {
            //System.out.println(verticalRow);
            System.out.println("V * * * * * * * * X SCORES * * * * * * * * * ");
            xWin = true;
          }
          if (verticalRow.contains("OOOO") || verticalRow.contains("TOOO") || verticalRow.contains("OTOOO") || verticalRow.contains("OOTO") || verticalRow.contains("OOOT"))
          {
            //System.out.println(verticalRow);
            System.out.println("V * * * * * * * *  O SCORES * * * * * * * * * ");
            yWin = true;
          }
//          if (verticalRow.contains("."))
//          {
//            //System.out.println(board.get(y));
//            System.out.println("* * * * * * * * *  GAME INCOMPLETE * * * * * * * * * ");
//            gameOver = true;
//          }
        }

        for (int y = 0; y < 4; y++)
        {
          for (int x = 0; x < 4; x++)
          {
            // diagonals
            String diagonalA = "";
            String diagonalB = "";

            //System.out.println("Diagonal Check:");
            //System.out.println("x= " + x);
            //System.out.println("y= " + y);

            for (int j = 0; j <= 4; j++)
            {
              if ((y + j) < 4 && (x + j + 1) <= 4)
              {
                diagonalA = diagonalA + board.get(y + j).substring(x + j, x + j + 1);
              }
              if ((y + j) < 4 && (x - j) > -1)
              {
                diagonalB = diagonalB + board.get(y + j).substring(x - j, x - j + 1);
              }
              // System.out.println("j= " + j);
            }

            //System.out.println("   diagA Check: " + diagonalA);
            //System.out.println("   diagB Check: " + diagonalB);

            if (diagonalA.contains("XXXX") || diagonalA.contains("TXXX") || diagonalA.contains("XTXX") || diagonalA.contains("XXTX") || diagonalA.contains("XXXT") || diagonalB.contains("XXXX") || diagonalB.contains("TXXX") || diagonalB.contains("XTXX") || diagonalB.contains("XXTX") || diagonalB.contains("XXXT"))
            {
              System.out.println("D * * * * * * * * X SCORES * * * * * * * * * ");
              xWin = true;
            }
            if (diagonalA.contains("OOOO") || diagonalA.contains("TOOO") || diagonalA.contains("OTOOO") || diagonalA.contains("OOTO") || diagonalA.contains("OOOT") || diagonalB.contains("OOOO") || diagonalB.contains("TOOO") || diagonalB.contains("OTOOO") || diagonalB.contains("OOTO") || diagonalB.contains("OOOT"))
            {
              System.out.println("D * * * * * * * *  O SCORES * * * * * * * * * ");
              yWin = true;
            }
//            if (diagonalA.contains(".") || diagonalB.contains("."))
//            {
//              System.out.println(board.get(y));
//              System.out.println("* * * * * * * * *  GAME INCOMPLETE * * * * * * * * * ");
//              gameOver = true;
//            }
          }
        }

        if (!xWin && !yWin && gameOver)
        {
          result = "Game has not completed";
        }
        else if (!xWin && !yWin && !gameOver)
        {
          result = "Draw";
        }
        else if (xWin && !yWin)
        {
          result = "X won";
        }
        else if (!xWin && yWin)
        {
          result = "O won";
        }

        System.out.println("Case #" + i + ": " + result);
        out.write("Case #" + i + ": " + result + "\r\n");
      }

      out.close();
    }
    catch (Exception e)
    {
      System.out.println(e);
    }
    finally
    {
      try
      {
        br.close();
      }
      catch (IOException e)
      {
        System.out.println(e);
      }
    }

  }
}
