package com.woodystech.QualificationRound;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class Lawnmower
{
  private static final String PROBLEM = "Lawnmower";

  // private static String FILENAME = "A-small-practice.in";
  // private static String FILENAME = "A-large-practice.in";
  private static String FILENAME = "B-large.in";
  // private static String FILENAME = "B-large-practice.in";
  // private static String FILENAME = "C-small-practice.in";
  // private static String FILENAME = "C-large-practice.in";
  // private static String FILENAME = "D-small-practice.in";
  // private static String FILENAME = "D-large-practice.in";

  public static void main(String[] args)
  {
    BufferedReader br = null;
    String outFileName;
    if (FILENAME.contains("small"))
    {
      outFileName = PROBLEM + "-small.out";
    }
    else
    {
      outFileName = PROBLEM + "-large.out";
    }

    try
    {
      FileWriter fstream = new FileWriter(outFileName);
      BufferedWriter out = new BufferedWriter(fstream);

      br = new BufferedReader(new FileReader(FILENAME));
      int numberTestCases = Integer.parseInt(br.readLine());

      System.out.println(numberTestCases);

      for (int i = 1; i <= numberTestCases; i++)
      {
        String result = "";

        String[] lawnInfo = br.readLine().split(" ");
        int height = Integer.parseInt(lawnInfo[0]);
        System.out.println("Height: " + height);
        int width = Integer.parseInt(lawnInfo[1]);
        System.out.println("Width: " + width);

        int[][] lawnNums = new int[width][height];
        int[][] newLawn = new int[width][height];

        // set newlawn to heights of 100
        for (int x = 0; x < width; x++)
        {
          for (int y = 0; y < height; y++)
          {
            newLawn[x][y] = 100;
          }
        }

        for (int hRow = 0; hRow < height; hRow++)
        {
          String rowString = br.readLine();
          System.out.println(rowString);
          String[] lawnRows = rowString.split(" ");
          for (int ch = 0; ch < width; ch++)
          {
            lawnNums[ch][hRow] = Integer.parseInt(lawnRows[ch]);
          }
        }

        if (height > 1 && width > 1)
        {

          Map<Integer, Integer> vertMax = new HashMap<Integer, Integer>();
          Map<Integer, Integer> vertMin = new HashMap<Integer, Integer>();
          Map<Integer, Integer> horzMax = new HashMap<Integer, Integer>();
          Map<Integer, Integer> horzMin = new HashMap<Integer, Integer>();

          int tempHigh = 101;
          int tempLow = 0;
          for (int j = 0; j < width; j++)
          {
            tempHigh = 101;
            tempLow = 0;
            for (int jy = 0; jy < height; jy++)
            {
              if (lawnNums[j][jy] < tempHigh)
              {
                tempHigh = lawnNums[j][jy];
                vertMin.put(j, lawnNums[j][jy]);
              }
              if (lawnNums[j][jy] > tempLow)
              {
                tempLow = lawnNums[j][jy];
                vertMax.put(j, lawnNums[j][jy]);
              }
            }
          }
          System.out.println("vertMax: " + vertMax);
          System.out.println("vertMin: " + vertMin);

          for (int k = 0; k < height; k++)
          {
            tempHigh = 101;
            tempLow = 0;
            for (int kx = 0; kx < newLawn.length; kx++)
            {
              if (lawnNums[kx][k] < tempHigh)
              {
                tempHigh = lawnNums[kx][k];
                horzMin.put(k, lawnNums[kx][k]);
              }
              if (lawnNums[kx][k] > tempLow)
              {
                tempLow = lawnNums[kx][k];
                horzMax.put(k, lawnNums[kx][k]);
              }
            }
          }
          System.out.println("horzMax: " + horzMax);
          System.out.println("horzMin: " + horzMin);

          Map<Integer, Integer> vertMowOrder = new HashMap<Integer, Integer>();
          Map<Integer, Integer> horzMowOrder = new HashMap<Integer, Integer>();

          int key = 0;
          for (int max : vertMax.values())
          {
            vertMowOrder.put(key, max);
            key++;
          }

          key = 0;
          for (int max : horzMax.values())
          {
            horzMowOrder.put(key, max);
            key++;
          }

          System.out.println("Vertical Mow Order:");
          System.out.println(vertMowOrder);
          System.out.println("Horizontal Mow Order:");
          System.out.println(horzMowOrder);

          //vertical columns
          for (int x = 0; x < width; x++)
          {
            for (int y = 0; y < height; y++)
            {
              if (newLawn[x][y] > vertMowOrder.get(x))
              {
                newLawn[x][y] = vertMowOrder.get(x);
                System.out.println("[Vertical] Cut spot " + x + "," + y + " to height: "+ vertMowOrder.get(x));
              }
            }
          }

          // horizontal rows
          for (int y = 0; y < height; y++)
          {
            for (int x = 0; x < width; x++)
            {
              if (newLawn[x][y] > horzMowOrder.get(y))
              {
                newLawn[x][y] = horzMowOrder.get(y);
                System.out.println("[Horizontal] Cut spot " + x + "," + y + " to height: "+ horzMowOrder.get(y));
              }
            }
          }

          for (int x = 0; x < width; x++)
          {
            for (int y = 0; y < height; y++)
            {
              if(lawnNums[x][y] == newLawn[x][y])
              {
                result = "YES";
              }
              else
              {
                result = "NO";
                break;
              }
            }
            if (result == "NO")
            {
              break;
            }
          }
        }
        else
        {
          result = "YES";
        }





        System.out.println("Case #" + i + ": " + result);
        out.write("Case #" + i + ": " + result + "\r\n");
      }

      out.close();
    }
    catch (Exception e)
    {
      System.out.println(e);
    }
    finally
    {
      try
      {
        br.close();
      }
      catch (IOException e)
      {
        System.out.println(e);
      }
    }

  }
}
