package com.woodystech;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class TidyNumbers {

	private static String FILENAME = "B-small-attempt0.in";
	// private static String FILENAME = "B-large-practice.in";

	public static void main(String[] args) {
		BufferedReader br = null;
		String outFileName;
		if (FILENAME.contains("small")) {
			outFileName = "small.out";
		} else {
			outFileName = "large.out";
		}

		try {
			FileWriter fstream = new FileWriter(outFileName);
			BufferedWriter out = new BufferedWriter(fstream);

			br = new BufferedReader(new FileReader(FILENAME));
			int numberTestCases = Integer.parseInt(br.readLine());

			System.out.println(numberTestCases);

			for (int i = 1; i <= numberTestCases; i++) {

				long endNumber = Long.parseLong(br.readLine());

				System.out.println("Ending Number: " + endNumber);
				
				long tidyNumber = 0;
				
				for (long j = endNumber; j >= 0; j--) {
					if (tidyCheck(j)) {
						System.out.println("Found last tidy number: " + j);
						tidyNumber = j;
						break;
					}
				}

				System.out.println("Case #" + i + ": " + tidyNumber);
				out.write("Case #" + i + ": " + tidyNumber + "\n");
			}

			out.close();
		} catch (Exception e) {
			System.out.println(e);
		} finally {
			try {
				br.close();
			} catch (IOException e) {
				System.out.println(e);
			}
		}
	}
	
	private static boolean tidyCheck(long number) {
		boolean result = true;
		
		System.out.println("Checking number: " + number);
		
		String numberString = Long.toString(number);
		int numberSize = numberString.length();
		
		for (int i = 0; i < numberSize - 1; i++) {
			int n1 = Integer.parseInt(Character.toString(numberString.charAt(i)));
			int n2 = Integer.parseInt(Character.toString(numberString.charAt(i + 1)));
			if (n2 < n1) {
				result = false;
				System.out.println("Number is NOT tidy!");
				break;
			}
		}
		
		System.out.println("Finished Checking...");
		return result;
	}

}
