package qualificationround.oversizedpancakeflipper;

import java.util.LinkedList;
import java.util.List;

public class SolutionSearcher {

	private Node actual;
	private LinkedList<Node> openNodes = new LinkedList<>();
	private LinkedList<Node> closedNodes = new LinkedList<>();

	public SolutionSearcher(Node start){
			openNodes.add(start);
		}

	private boolean isContains(List<Node> nodes, State state) {
		for (Node node : nodes) {
			if (node.getState().equals(state)) {
				return true;
			}
		}
		return false;
	}

	private void expand(Node node) {
		for (Operator operator : Operator.OPERATORS) {
			if (operator.isApplicable(node.getState())) {
				State newState = operator.apply(node.getState());

				boolean isOpenNodesContains = isContains(openNodes, newState);
				boolean isClosedNodesContains = isContains(closedNodes, newState);

				if (!(isOpenNodesContains || isClosedNodesContains)) {

					Node newNode = new Node(newState, node, operator, node.getDepth() + 1);
					openNodes.addLast(newNode);
				}
			}
		}
		openNodes.remove(node);
		closedNodes.add(node);
	}

	public Node search() {
		while (true) {
			if (openNodes.isEmpty()) {
				break;
			}

			actual = openNodes.getFirst();
			if (actual.getState().isGoal()) {
				break;
			}

			expand(actual);
		}
		if (!openNodes.isEmpty()) {
			return actual;
		} else {
			return null;
		}
	}
}
