package qualificationround.oversizedpancakeflipper;

import java.util.ArrayList;
import java.util.List;

public class Operator {

	private int firstIndex;
	private int pancakeFlipperSize;
	
	public static List<Operator> OPERATORS;
	
	public static void initOperators(int pancakeFlipperSize, int numberOfCakes){
		OPERATORS = new ArrayList<>();
		for(int i = 0; i <= numberOfCakes - pancakeFlipperSize; i++){
			OPERATORS.add(new Operator(i, pancakeFlipperSize));
		}
	}

	public Operator(int firstIndex, int pancakeFlipperSize) {
		this.firstIndex = firstIndex;
		this.pancakeFlipperSize = pancakeFlipperSize;
	}
	
	public boolean isApplicable(State state){
		return true;
	}

	public State apply(State state){
		StringBuilder newStateCakePositions = new StringBuilder(state.getCakePositions());
		for(int i = firstIndex; i < firstIndex + pancakeFlipperSize; i++){
			switch(newStateCakePositions.charAt(i)){
			case '+':
				newStateCakePositions.setCharAt(i, '-');
				break;
			case '-':
				newStateCakePositions.setCharAt(i, '+');
				break;
			}
		}
		return new State(newStateCakePositions.toString());
	}

	@Override
	public String toString() {
		return "Operator [firstIndex=" + firstIndex + ", pancakeFlipperSize=" + pancakeFlipperSize + "]";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + firstIndex;
		result = prime * result + pancakeFlipperSize;
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Operator other = (Operator) obj;
		if (firstIndex != other.firstIndex)
			return false;
		if (pancakeFlipperSize != other.pancakeFlipperSize)
			return false;
		return true;
	}
}
