package qualificationround.oversizedpancakeflipper;

public class Node {
	
	private State state;
	private Node parent;
	private Operator operator;
	private int depth;
	
	public Node(State state, Node node, Operator operator, int depth) {
		this.state = state;
		this.parent = node;
		this.operator = operator;
		this.depth = depth;
	}

	public State getState() {
		return state;
	}

	public void setState(State state) {
		this.state = state;
	}

	public Node getNode() {
		return parent;
	}

	public void setNode(Node node) {
		this.parent = node;
	}

	public Operator getOperator() {
		return operator;
	}

	public void setOperator(Operator operator) {
		this.operator = operator;
	}

	public int getDepth() {
		return depth;
	}

	public void setDepth(int depth) {
		this.depth = depth;
	}

	@Override
	public String toString() {
		if(parent != null){
			return "Node [state=" + state + ", parent=" + parent.getState() +  ", operator=" + operator + ", depth=" + depth + "]";
		} else {
			return "Node [state=" + state + ", parent=null" + ", operator=" + operator + ", depth=" + depth + "]";
		}
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((parent == null) ? 0 : parent.getState().hashCode());
		result = prime * result + ((operator == null) ? 0 : operator.hashCode());
		result = prime * result + ((state == null) ? 0 : state.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		Node other = (Node) obj;
		if (parent == null) {
			if (other.parent != null)
				return false;
		} else if (!parent.getState().equals(other.parent.getState()))
			return false;
		if (operator == null) {
			if (other.operator != null)
				return false;
		} else if (!operator.equals(other.operator))
			return false;
		if (state == null) {
			if (other.state != null)
				return false;
		} else if (!state.equals(other.state))
			return false;
		return true;
	}
}
