package ThemePark;

import java.util.ArrayList;
import java.util.LinkedList;

public class ThemeParkClient 
{
	public static void main(String[] args) throws Exception 
	{
		String inputPath = args[0];
		String outputPath = args[1];
		
		InputParser parser = new InputParser(inputPath);
		LinkedList<String> problems = parser.parse();
		LinkedList<Long> results = new LinkedList<Long>();
		for(int i=0; i<parser.testSize; i++){
			//System.out.println("---------------------SOLVING["+((int)i+1)+"]----------------------");
			ProblemItem problemItem = new ProblemItem(problems.removeFirst(),problems.removeFirst());
			//System.out.println("K["+problemItem.K+"] R["+problemItem.R+"] N["+problemItem.N+"]");
			//System.out.println("Groups "+problemItem.groups);
			ProblemSolver solver = new ProblemSolver(problemItem);
			solver.solve();
			results.add(solver.getResult());
			//System.out.println("Result["+solver.getResult()+"]");
		}
		OutputGenerator out = new OutputGenerator(outputPath);
		out.writeToFile(results);
	}
}
