package house_pancakes;

import java.io.File;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {

	private int t;
	private int d;
	private ArrayList<Integer> p = new ArrayList<Integer>();
	
	public Main(String filename) {
		System.err.println("filename: " + filename);
		try{
			Scanner sc = new Scanner(new File(filename));
			
			t = sc.nextInt();
			System.err.println("cases: " + t);
			
			for(int i=0; i<t; i++) {
				System.err.println();
				System.err.println("case " + (i+1) + ":");
				
				p = new ArrayList<Integer>();
				d = sc.nextInt();
				System.err.println("non-empty plates: " + d);
				for(int j=0; j<d; j++) {
					int n = sc.nextInt();
					p.add(n);
					System.err.print(n + " ");
				}
				System.err.println();
				
				// solve it
				int maximalSolution = getMaxNumber(p);
				int normal = 0;
				int special = 0;
				while(!p.isEmpty()){
					int max = getMaxNumber(p);
					System.err.println("max: " + max);
					int amount = getAmountForNumber(max, p);
					NormalSpecial ns = solveNumber(max, amount);
					
					p = deleteAllUnder(ns.getNormal(), p);
					p = deleteNumber(max, p);
					
					if(ns.getNormal() > normal){
						normal = ns.getNormal();
					} 
					
					if (special + max <= normal+special+ns.getSpecial()){
						normal = max;
						p = deleteAllUnder(normal, p);
					} else {
						special += ns.getSpecial();
					}
				}
				
				
				
				// print solution
				System.out.print("Case #" + (i+1) + ": ");
				if(normal+special > maximalSolution){
					System.out.println(maximalSolution);
				} else {
					System.out.println(normal+special);
				}
			}
			
			sc.close();
			
		} catch(Exception e) {
			System.err.println("---------------------------");
			System.err.println("ERROR: IO file");
			System.err.println("---------------------------");
		}
	}
	
	
	public NormalSpecial solveNumber(int number, int amount) {
		int fractal = (number/2+number%2);
		if( (amount + fractal) >= number) {
			return new NormalSpecial(number, 0);
		} else {
			NormalSpecial ret = solveNumber(fractal, amount*2);
			return new NormalSpecial(ret.getNormal(), ret.getSpecial()+amount);
		}
	}
	
	public ArrayList<Integer> deleteNumber(int nr, ArrayList<Integer> p){
		ArrayList<Integer> preturn = new ArrayList<Integer>();
		for(int i:p){
			if(i!=nr){
				preturn.add(i);
			}
		}
		return preturn;
	}
	
	public ArrayList<Integer> deleteAllUnder(int nr, ArrayList<Integer> p) {
		ArrayList<Integer> preturn = new ArrayList<Integer>();
		for(int i:p){
			if(i>nr){
				preturn.add(i);
			}
		}
		return preturn;
	}
	
	public int getAmountForNumber(int nr, ArrayList<Integer> p) {
		int amount = 0;
		for(int i: p) {
			if(i == nr){
				amount ++;
			}
		}
		return amount;
	}
	
	public int getMaxNumber(ArrayList<Integer> p) {
		int max = 0;
		for(int i : p){
			if(i > max){
				max = i;
			}
		}
		return max;
	}
	
	public class NormalSpecial {
		private int normal;
		private int special;
		
		NormalSpecial(int n, int s) {
			this.normal = n;
			this.special = s;
		}

		public int getNormal() {
			return normal;
		}

		public int getSpecial() {
			return special;
		}
	}
	
	public static void main(String[] args) {
		System.err.println("");
		if(args.length == 1){
			new Main(args[0]);
			
			//
			//NormalSpecial ns = new Main(args[0]).solveNumber(9, 1);
			//System.out.println("Solve in : " + ns.getNormal() + " " + ns.getSpecial());
			
		} else {
			System.err.println("---------------------------");
			System.err.println("ERROR: Filename as argument");
			System.err.println("---------------------------");
			System.err.println("");
		}
		
	}

}