package standing_ovation;


import java.io.File;
import java.util.Scanner;

public class Main {

	private int t;
	private int smax = 0;
	private int[] amount = new int[1001];
	
	public Main(String filename) {
		System.err.println("filename: " + filename);
		try{
			Scanner sc = new Scanner(new File(filename));
			
			t = sc.nextInt();
			System.err.println("cases: " + t);
			
			for(int i=0; i<t; i++) {
				System.err.println("case " + i + ":");
				
				smax = sc.nextInt();
				String s = sc.next();
				for(int j=0; j<(smax+1); j++) {
					amount[j] = Character.getNumericValue(s.charAt(j));
					System.err.print(amount[j] + " ");
				}
				System.err.println();
				
				// solve it
				int amountOfPeople = 0;
				for(int j=0; j<(smax+1) ; j++) {
					amountOfPeople += amount[j];
				}
				System.err.println("people present: " + amountOfPeople);

				int amountOfPeopleUp = 0;
				int amountOfPeopleToInvite = 0;
				for(int j=0; j<(smax+1); j++) {
					if(amountOfPeopleUp >= j || amount[j]==0) {
						amountOfPeopleUp += amount[j];
					} else {
						amountOfPeopleToInvite += j - amountOfPeopleUp;
						amountOfPeopleUp += (j - amountOfPeopleUp) + amount[j];
					}
				}
				
				// print solution
				System.out.print("Case #" + (i+1) + ": ");
				System.out.println(amountOfPeopleToInvite);
			}
			
			sc.close();
			
		} catch(Exception e) {
			System.err.println("---------------------------");
			System.err.println("ERROR: IO file");
			System.err.println("---------------------------");
		}
	}
	
	public static void main(String[] args) {
		System.err.println("");
		if(args.length == 1){
			new Main(args[0]);
			
		} else {
			System.err.println("---------------------------");
			System.err.println("ERROR: Filename as argument");
			System.err.println("---------------------------");
			System.err.println("");
		}
		
	}

}
