import edu.princeton.cs.algs4.In;
import edu.princeton.cs.algs4.Out;
import java.util.Arrays;
import java.util.Scanner;
import java.io.File;

public class TidyNumber {

  public static boolean isTidy(long n) {
    return isTidy(integerToDigits(n));
  }

  public static boolean isTidy(int[] tab) {
    // System.out.println(Arrays.toString(tab));
    int lastDigit = tab[0];
    for (int i = 1; i < tab.length; i++) {
      if (lastDigit > tab[i])
        return false;
      lastDigit = tab[i];
    }
    return true;
  }

  public static boolean isTidy(String n) {
    int m = parseInt(n.charAt(0));
    int size = n.length();
    for (int i = 1; i < size; i++) {
      int c = parseInt(n.charAt(i));
      if (m > c)
        return false;
      m = c;
    }
    return true;
  }

  public static long findLastTidyNumber(long n) {
    long copy = n;
    while (copy >= 0) {
      if (isTidy(copy))
        return copy;
      copy--;
    }
    return copy;
  }

  public static int parseInt(char c) {
    return Integer.parseInt(c + "");
  }

  public static String findLastTidyNumber(String n) {
    if (isTidy(n))
      return n;
    String s = n + "";
    int size = s.length();
    if (size > 0) {
      int i = size - 1;
      while (i >= 1) {
        int k = parseInt(s.charAt(i));
        int l = parseInt(s.charAt(i - 1));
        if (k < l) {
          String s2 = "";
          for (int j = 0; j < (size - i); j++) {
            s2 += "9";
          }
          s = s.substring(0, i - 1) + (l - 1) + s2;
          // System.out.println(k + " " + l + " " + s);
        }
        i--;
      }
    }
    return trimNumber(s);
  }

  public static int findDigitPosition(String s, int start) {
    int size = s.length();
    for (int i = start; i < size; i++) {
      if (i + 1 < size) {
        int k = parseInt(s.charAt(i));
        int l = parseInt(s.charAt(i + 1));
        if (k < l) {
          return i;
        }
      } else {
        return i;
      }
    }
    return size - 1;
  }

  public static int[] integerToDigits(long n) {
    int nb = (int) (Math.log10(n) + 1);
    int[] tab = new int[nb];
    long copy = n;
    for (int i = nb - 1; i >= 0; i--) {
      tab[i] = (int) copy % 10;
      copy = copy / 10;
    }
    return tab;
  }

  private static String trimNumber(String s) {
    int size = s.length();
    int k = 0;
    while (k < size && s.charAt(k) == '0') {
      k++;
    }
    return s.substring(k);
  }

  private static String extractFileName(String file) {
    String[] tab = file.split("\\.");
    return tab[0];
  }

  public static void main(String[] args) throws Exception {
    String filename = args[0];
    Scanner in = new Scanner(new File(filename));

    int n = in.nextInt();
    String[] res = new String[n];
    // System.out.println(n);
    for (int i = 0; i < n; i++) {
      String k = in.next();
      res[i] = String.valueOf(findLastTidyNumber(k));
    }

    Out out = new Out(extractFileName(filename) + "-sol.txt");
    for (int i = 0; i < n; i++) {
      out.println(String.format("Case #%d: %s", i + 1, res[i]));
    }
    // out.close();
  }
}