import java.io.*;
import java.util.*;

public class CodeJam implements Runnable {

	public static void main(String[] args) throws Exception {
		new Thread(new CodeJam()).start();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	public void run() {
		try {
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter(new FileWriter("output.txt"));
			solve();
		} catch (Exception ex) {
			throw new RuntimeException(ex);
		} finally {
			out.close();
		}
	}
	
	private String next() throws Exception {
		if (st == null || !st.hasMoreElements())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}

	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	
	public void solve() throws Exception {
		int t = nextInt();
		for(int i = 1; i <= t; ++i){
			int n = nextInt();
			int[] a = new int[n];  
			for(int j = 0; j < n; ++j){
				a[j] = nextInt();
			}
		
			int ans = 0;

			for(int j = 1; j < (1 << n) -1; ++j){
				int s1 = 0;
				int s2 = 0;
				int t1 = 0;
				int t2 = 0;
				for(int k = 0; k < n; k++){
					if((j & (1<<k)) > 0){
						s2 ^= a[k];
						t2 += a[k];
					}
					else {
						s1 ^= a[k];
						t1 += a[k];
					}
				}
				if(s1 == s2) ans = Math.max(ans, t2);
			}
			if(ans == 0) out.println("Case #"+i+": NO");
			else out.println("Case #"+i+": "+ans);
		}
		
		
	}
	
}