import java.io.*;
import java.util.*;

public class CodeJam implements Runnable {

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;
	
	public static void main(String[] args) throws Exception {
		new Thread(new CodeJam()).start();
	}
	public void run() {
		try {
			in = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter(new FileWriter("output.txt"));
			solve();
		} catch (Exception ex) {
			throw new RuntimeException(ex);
		} finally {
			out.close();
		}
	}
	private String next() throws Exception {
		if (st == null || !st.hasMoreElements())
			st = new StringTokenizer(in.readLine());
		return st.nextToken();
	}
	private int nextInt() throws Exception {
		return Integer.parseInt(next());
	}
	char[][] map;
	int r,c;
	
	boolean replace(int x, int y){
		if(y+1>=c) return false;
		if(x+1>=r) return false;
		if(map[x][y+1] != '#') return false;
		if(map[x+1][y+1] != '#') return false;
		if(map[x+1][y+1] != '#') return false;
		map[x][y] = '/';
		map[x][y+1] = '\\';
		map[x+1][y] = '\\';
		map[x+1][y+1] = '/';
		return true;
	}
	
	public void solve() throws Exception {
		int t = nextInt();
		
		for(int i = 1; i <= t; ++i){
			
			r = nextInt();
			c = nextInt();
			map = new char[r][c];
			
			for(int j = 0; j < r; ++j){
				String line = next();
				for(int k = 0; k < c; ++k){
					map[j][k] = line.charAt(k);
				}
			}
			
			
			boolean ok = true;
			for(int j = 0; j < r; ++j){
				for(int k = 0; k < c; ++k){
					if(map[j][k] == '#'){
						if(!replace(j, k))
						{
							ok = false;
							break;
						}
					}	
				}
				if(!ok) break;
			}
				
			out.println("Case #"+i+":");
				
			if(!ok){
				out.println("Impossible");	
			}
			else
			{
				for(int j = 0; j < r; ++j){
					for(int k = 0; k < c; ++k){
						out.print(map[j][k]);
					}
					out.println();
				}
			}
		}
	}
		
	}
	