import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

public class CJR1C_B {
	static BufferedReader br;
	static PrintWriter pw;
	static int case_num;

	public static void print(String message) {
		System.out.print(message);
	}
	
	public static void write(String message) throws IOException {
		pw.print(message);
		print(message);
	}

	public static int parse(String val) {
		return Integer.parseInt(val);
	}
	
	static String [] padding = { "" , "0", "00", "000", "0000" , "00000", "000000", "0000000" };
	public static void printOut(double min, double t) throws IOException {
//		String min_str = "" + min;
//		StringTokenizer st = new StringTokenizer(min_str, ".");
//		
//		String a = st.nextToken();
//		String b = st.nextToken();
//		
//		if (b.length() > 8) {
//			b = b.substring(0, 8);
//		} else {
//			int pad = 8 - b.length();
//			b = b + padding[pad];
//		}
//		write(a + "." + b + " " + t + "0000000\n");
		write(min + " " +  t  + "\n");
	}
	
	public static void solve() throws IOException {
		String in_data = br.readLine();
		double fly_num = Integer.parseInt(in_data);
		
		int x_sum  = 0;
		int vx_sum = 0;
		int y_sum  = 0;
		int vy_sum = 0;
		int z_sum  = 0;
		int vz_sum = 0;
		
		for (int i = 0; i < fly_num; i++) {
			String fly_data = br.readLine();
			StringTokenizer st = new StringTokenizer(fly_data, " ");
			
			int x = parse(st.nextToken());
			int y = parse(st.nextToken());
			int z = parse(st.nextToken());
			int vx = parse(st.nextToken());
			int vy = parse(st.nextToken());
			int vz = parse(st.nextToken());
			x_sum += x;   y_sum += y;   z_sum += z;
			vx_sum += vx; vy_sum += vy; vz_sum += vz;
		}

		double min_sum_sq = Double.MAX_VALUE;
		int min_time      = 1;
		
		for (int t = 0; t <= 100; t++) {
			double x_pos = (x_sum + vx_sum*t) / fly_num;
			double y_pos = (y_sum + vy_sum*t) / fly_num;
			double z_pos = (z_sum + vz_sum*t) / fly_num;
			double sum_sq = (x_pos*x_pos + y_pos*y_pos + z_pos*z_pos);
	
			if (sum_sq < min_sum_sq) {
				min_sum_sq = sum_sq;
				min_time   = t; 
			} 
		}
		
		printOut(Math.sqrt(min_sum_sq), min_time);
	}

    public static void main(String[] args) throws IOException {
		if (args.length != 1) {
			System.err.println("empty input data");
			System.exit(-1);
		}

		br       = new BufferedReader(new FileReader(args[0]));
		pw       = new PrintWriter(new FileWriter(args[0] + ".out.txt")); 
		case_num = Integer.parseInt(br.readLine());
		
		for (int i = 1; i <= case_num; i++) {
			write("Case #" + i + ": ");
			solve();
		}
		br.close();
		pw.close();
	}
}