import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

public class CJR1C_A {
	static BufferedReader br;
	static PrintWriter pw;
	static int case_num;

	public static void print(String message) {
		System.out.print(message);
	}
	
	public static void write(String message) throws IOException {
		pw.print(message);
		print(message);
	}

	public static void solve() throws IOException {
		String in_data = br.readLine();
		int [] table = new int[256];
		for (int i = 0; i < 255; i++) {
			table[i] = -1;
		}
		
		char c   = in_data.charAt(0);
		table[c] = 1;
		char b   = 0;
		int idx = 0;
		for (int i = 1, n = in_data.length(); i < n; i++) {
			b = in_data.charAt(i);
			if (table[b] == -1){
				if (idx == 0) {
					table[b] = 0;
					idx = 1;
				} else {
					idx++;
					table[b] = idx;
				}
			}
		}
		
		int base = idx + 1;
		base = (base == 1) ? 2: base;
		
		int len = in_data.length();
		long sum = 0;
		for (int i = 0; i < len; i++) {
			int val = table[in_data.charAt(i)];
			sum += (val * Math.pow(base, len - (i + 1)));
		}
		write(sum + "\n");
	}

    public static void main(String[] args) throws IOException {
		if (args.length != 1) {
			System.err.println("empty input data");
			System.exit(-1);
		}

		br       = new BufferedReader(new FileReader(args[0]));
		pw       = new PrintWriter(new FileWriter(args[0] + ".out.txt")); 
		case_num = Integer.parseInt(br.readLine());
		
		for (int i = 1; i <= case_num; i++) {
			write("Case #" + i + ": ");
			solve();
		}
		br.close();
		pw.close();
	}
}