import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class SavingTheUniverse {

	public static void main(String [] args) throws NumberFormatException, IOException {
		
		FileReader fr = new FileReader(ClassLoader.getSystemResource("A-small-attempt3.in").getFile());
		BufferedReader br = new BufferedReader(fr);
		
		int caseNum = getInt(br);
		
		for (int i = 1; i <= caseNum; i++) {
			
			List engList   = new ArrayList();
			List queryList = new ArrayList();
			
			int engNum     = getInt(br);
			for (int j = 0; j < engNum; j++) {
				engList.add(getStr(br));
			}
			
			int queryNum     = getInt(br);
			for (int j = 0; j < queryNum; j++) {
				queryList.add(getStr(br));
			}
			
			int switchNum = compute(engList, queryList);
			System.out.println("Case #" + i + ": " + switchNum);
		}
	}
	
	public static int compute(List engList, List queryList) {
		int queryIdx  = 0;
		int switchNum = 0;
		
		while (queryIdx < queryList.size()) {
			int maxDist = 0;
			
			for (int i = 0, n = engList.size(); i < n; i++) {
				String engName = (String) engList.get(i);
				
				int dist = getDistance(engName, queryList, queryIdx);
				
				if (maxDist <= dist) {
					maxDist = dist;
				}
			}
			
			queryIdx = maxDist;
			if (queryIdx < queryList.size()) {
				switchNum++;
			}
		}
		return switchNum;

	}
	
	public static int getDistance(String engName, List queryList, int idx) {
		for (int i = idx, n = queryList.size(); i < n; i++) {
			if (engName.equals(queryList.get(i))) {
				return i;
			}
		}
		
		return queryList.size();
	}
	
	public static int getInt(BufferedReader br) throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine().trim());
	}
	
	public static String getStr(BufferedReader br) throws NumberFormatException, IOException {
		return br.readLine().trim();
	}

}
