import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.StringTokenizer;

public class MSP {
	
	public static void main(String [] args) throws NumberFormatException, IOException {
		FileReader     fr = new FileReader(ClassLoader.getSystemResource("A-small-attempt3.in").getFile());
		BufferedReader br = new BufferedReader(fr);
		
		int caseNum = getInt(br);
		
		for (int i = 1; i <= caseNum; i++) {
			String vecNum = br.readLine();
			
			List vec1 = getIntArr(true, br);
			List vec2 = getIntArr(false, br);
			
			List allList = new ArrayList();
			allList.addAll(vec1);
			allList.addAll(vec2);
			
			VecComparator com = new VecComparator();
			Collections.sort(allList , com);
			
			int result = compute(allList);
			System.out.println("Case #" + i + ": " + result);
		}
	}
	
	private static int compute(List list) {
		int sum = 0;
		
		int vecSize = list.size();
		for (int i = 0; i < vecSize; i++) {
			Vec vec1 = (Vec) list.get(i);
			if (vec1.checked) continue;
			
			int value = vec1.value;
			vec1.checked = true;
			
			for (int j = vecSize -1 ; j >= 0; j--) {
				Vec vec2 = (Vec) list.get(j);
				if (vec2.checked || vec1.isVec1 == vec2.isVec1) continue;
				int value2 = vec2.value;
				sum += value * value2;
				vec2.checked = true;
				break;
			}
		}
		return sum;
	}

	public static int getInt(BufferedReader br) throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine().trim());
	}

	public static List getIntArr(boolean isVec1, BufferedReader br) throws NumberFormatException, IOException {
		StringTokenizer st = new StringTokenizer(br.readLine().trim(), " ");
		List list = new ArrayList();
		
		while(st.hasMoreTokens()) {
			Vec vec = new Vec(isVec1, Integer.parseInt(st.nextToken()));
			list.add(vec);
		}

		return list;
	}

	public static class VecComparator implements Comparator {
		public int compare(Object arg0, Object arg1) {
			Vec vec1 = (Vec) arg0;
			Vec vec2 = (Vec) arg1;
			return vec1.value - vec2.value;
		}
	}
	
	public static class Vec {
		public boolean isVec1 = false;
		public int value;
		public boolean checked = false;
		
		public Vec(boolean x, int value) {
			this.isVec1 = x;
			this.value = value;
		}
		
		public String toString() {
			return "" + value;
		}
	}
}
