import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;

public class TMO {
	
	public static void main(String [] args) throws NumberFormatException, IOException {
		if (args.length != 1) return;
		
		FileReader     fr = new FileReader(ClassLoader.getSystemResource(args[0]).getFile());
		BufferedReader br = new BufferedReader(fr);
		
		int caseNum = getInt(br);
		
		for (int i = 1; i <= caseNum; i++) {
			Data data = parseKeyInfo(br);

			int sum = 0;
			if (data.isPossible()){
				List list = parseKeyFreq(br);
				int mul   = 0;
				int count = 1;
				
				for (int j = list.size() -1 ; j >=0; j--) {
					Integer val = (Integer) list.get(j);
					if ((count % data.k) == 1) {
						mul++;
					}
					
					sum += (val.intValue() * mul);
					count++;					
				}
				
				System.out.println("Case #" + i + ": " + sum);	
			} else {
				System.out.println("Case #" + i + ": Impossible");
			}
		}
	}
	
	private static int compute(List list) {
		int sum = 0;
		
		return sum;
	}

	public static int getInt(BufferedReader br) throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine().trim());
	}

	public static Data parseKeyInfo(BufferedReader br) throws NumberFormatException, IOException {
		StringTokenizer st = new StringTokenizer(br.readLine().trim(), " ");

		int p = Integer.parseInt(st.nextToken());
		int k = Integer.parseInt(st.nextToken());
		int l = Integer.parseInt(st.nextToken());
		
		Data data = new Data(p, k, l);
		return data;
	}
	

	public static List parseKeyFreq(BufferedReader br) throws NumberFormatException, IOException {
		StringTokenizer st = new StringTokenizer(br.readLine().trim(), " ");

		List list = new ArrayList();
		while(st.hasMoreTokens()) {
			list.add(new Integer(st.nextToken())); 
		}
		Collections.sort(list);
		return list;
	}

	public static class Data {
		public int p;
		public int k;
		public int l;
		
		public Data(int p, int k, int l) {
			this.p = p;
			this.k = k;
			this.l = l;
		}
		
		public boolean isPossible() {
			return (p * k >= l);
		}
		
		public String toString() {
			return "P=" + p + ",K=" + k + ",L=" + l;
		}
		
	}
}
