import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

/**
 * A class to solve the Magicka Problem at Google Code Jam 2011 (Qualifying
 * Round)
 * 
 * @author Ben McCormick
 * 
 */
public class KillerWord {

	/**
	 * A method to solve the Magicka problem Moves the Combinations and
	 * Oppositions into a map for each test case, then sends that along with an
	 * array of the letters to the processing method, which returns the final
	 * order
	 * 
	 * @param args
	 * @throws IOException
	 * @throws NumberFormatException
	 */
	public static void main(String[] args) throws NumberFormatException,
			IOException {
		BufferedReader br = new BufferedReader(new FileReader(new File(
				"test.txt")));
		int numtests = Integer.parseInt(br.readLine());

		int numwords, numlists;

		ArrayList<String> words = new ArrayList<String>();
		ArrayList<String> results = new ArrayList<String>();
		char[] list;
		for (int i = 1; i <= numtests; i++) {
			words.clear();
			String line = br.readLine();
			String[] x = line.split(" ");
			numwords = Integer.parseInt(x[0]);
			numlists = Integer.parseInt(x[1]);
			for (int h = 0; h < numwords; h++) {
				words.add(br.readLine());
			}
			for (int h = 0; h < numlists; h++) {
				String list1 = br.readLine();
				list = new char[list1.length()];
				for (int k = 0; k < list1.length(); k++) {
					list[k] = list1.charAt(k);
				}

				results.add(solve(words, list));

			}

			System.out.print("Case #" + i + ": ");
			for (String result : results) {
				System.out.print(result + " ");
			}
			System.out.println();
			results.clear();
		}

	}

	private static String solve(ArrayList<String> words, char[] list) {
		ArrayList<String> dict = (ArrayList<String>) words.clone();
		int maxval = -1;
		String maxword = "";
		int counter = 0;
		boolean[] blacklist;

		for (String word : words) {
			blacklist=new boolean[word.length()];
			dict = (ArrayList<String>) words.clone();

			
			for (int k = 0; k < dict.size(); k++) {
				if (dict.get(k).length() != word.length()) {
					dict.remove(k);
					k--;
				}
			}
				for (char letter : list) {
					
					if(letterin(letter,dict,blacklist))
					{
						counter++;
					
					for (int i = 0; i < word.length(); i++) {
						if (word.charAt(i) == letter) {
							blacklist[i] = true;
							for (int k = 0; k < dict.size(); k++) {
								if (dict.get(k).charAt(i) != letter) {
									dict.remove(k);
									k--;
								}
							}
						}

					}
					if (!word.contains(letter + "")) {
						for (int k = 0; k < dict.size(); k++) {
							if (dict.get(k).contains(letter + "")) {
								// System.out.println("XXX"+dict.get(k)+" "+letter);
								dict.remove(k);
								k--;
							}
						}
					}
					
					}

				}
					if (counter > maxval) {
						maxval = counter;
						maxword = word;
						
					}
				
					counter=0;
				
			
		}
		return maxword;

	}

	private static boolean letterin(char letter, ArrayList<String> dict,boolean[] blacklist) {
		for(String word:dict)
		{
			for(int i=0; i<word.length(); i++)
			{
				if(!blacklist[i] && word.charAt(i) == letter)
					return true;
			}
		}
		return false;
	}
}