import java.util.*;
import java.util.Map.Entry;
import java.io.*;

public class ProblemA {
	final long MOD = 1000003;
	final int MAX_LEN = 500000;

	long pow(long x, long y) {
		if (y == 0)	return 1;
		long res = pow(x, y/2);
		res = (res * res) % MOD;
		if (y % 2 == 1) res = (res * x) % MOD;
		return res;
	}

	long inv(long x) {
		return pow(x, MOD-2);
	}

	long[] fact, invfact;

	void loadMap(String source, String dest) {
		for(int i=0;i<source.length(); i++) {
			char sc = source.charAt(i);
			char dc = dest.charAt(i);
			map.put(sc, dc);
		}
	}

	HashMap<Character,Character> map = new HashMap<Character, Character>();
	void precalc() {
		String s1="ejp mysljylc kd kxveddknmc re jsicpdrysi";
		String d1 = "our language is impossible to understand";
		String s2 = "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd";
		String d2 = "there are twenty six factorial possibilities";
		String s3 = "de kr kd eoya kw aej tysr re ujdr lkgc jv";
		String d3 = "so it is okay if you want to just give up";

		loadMap("a zo","y qe");
		loadMap(s1,d1);
		loadMap(s2,d2);
		loadMap(s3,d3);
		loadMap("q","z");

//		int i=0;
//		for(Entry<Character, Character> entry : map.entrySet() ) {
//			System.out.println(i++ + " " + entry.getKey() + " " + entry.getValue());
//		}

//		char schara = 'a';
//		for(int i=0;i<26;i++){
//			char schar = (char) (schara+i);
//			if( ! map.keySet().contains(schar) ) {
//				System.out.println(schar);
//			}
//		}
//
//		for(int i=0;i<26;i++){
//			char schar = (char) (schara+i);
//			if( ! map.values().contains(schar) ) {
//				System.out.println(schar);
//			}
//		}



	}


	class Testcase {
		String ans;

		public Testcase() {
		}

		public Testcase(int seed) {
			Random rnd = new Random(seed);
		}

		String s;

		public void loadInput(Scanner sc) {
			s = sc.nextLine();
		}

		public void solveSlow() {
		}

		public void solveFast() {
			StringBuffer dest = new StringBuffer();
			for(int i=0;i<s.length();i++ ) {
				char c = s.charAt(i);
				Character dc = map.get(c);
				dest.append(dc);
			}

			ans = dest.toString();
		}

		public void printSelf(PrintWriter pw) {
			System.out.println(ans);
			pw.println(ans);
		}

		public boolean sameAnswers(Testcase other) {
			return false;
		}
	}

	final String AFTER_CASE = " ";

	public void go() throws Exception {

		precalc();

		Scanner sc = new Scanner(new FileReader("src\\input.txt"));
		PrintWriter pw = new PrintWriter(new FileWriter("src\\output.txt"));

		int caseCnt = sc.nextInt();

		sc.nextLine();

		for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
			System.out.println("solving case " + caseNum);

			Testcase tc = new Testcase();

			tc.loadInput(sc);
			tc.solveFast();

			pw.print("Case #" + (caseNum + 1) + ":");
			pw.print(AFTER_CASE);

			tc.printSelf(pw);
		}

		pw.flush();
		pw.close();
		sc.close();
	}

	public void stresstest() {
		int it = 0;
		Random rnd = new Random();
		while (true) {
			it++;
			if (it % 1000 == 0)
				System.out.println(it + " iterations");

			int seed = rnd.nextInt();

			Testcase tc1 = new Testcase(seed);
			tc1.solveFast();

			Testcase tc2 = new Testcase(seed);
			tc2.solveSlow();

			if (!tc1.sameAnswers(tc2)) {
				System.out.println("ERROR: it failed");
				System.exit(0);
			}
		}
	}

	public static void main(String[] args) throws Exception {
		new ProblemA().go();
		System.out.println("finished!");
	}
}
