import java.io.*;
import java.util.*;
import static java.lang.Math.*;

public class A {
	private static String fileName = A.class.getSimpleName().replaceFirst("_.*", "");
	private static String inputFileName = fileName + "-large.in";
	private static String outputFileName = fileName + ".out";
	private static Scanner in;
	private static PrintWriter out;

	private void solve() {
		int n = in.nextInt();
		int[] a = new int[n];
		int[] b = new int[n];
		int ans = 0;
		for (int i = 0; i < n; i++) {
			a[i] = in.nextInt();
			b[i] = in.nextInt();
			for (int j = 0; j < i; j++) {
				if ((a[i] > a[j]) ^ (b[i] > b[j])) {
					ans++;
				}
			}
		}
		out.println(ans);
	}

	int getIn(int p) {
		int d=0;
		for(int j=0;j<n;j++){
			if(m[p][j]==-1)
				d++;
		}
		return d;
	}
	int getIn(int p,int q) {
		int d=0;
		for(int j=0;j<n;j++){
			if(m[p][j]==-1 && j!=q)
				d++;
		}
		return d;
	}
	int getOut(int p){
		int d=0;
		for(int j=0;j<n;j++){
			if(m[p][j]==1)
				d++;
		}
		return d;		
	}
	int getOut(int p,int q){
		int d=0;
		for(int j=0;j<n;j++){
			if(m[p][j]==1 && j!=q)
				d++;
		}
		return d;		
	}
	double wp(int p){
		double d1  = getOut(p);
		double d2 = getIn(p);
		if(d1+d2==0)
			return 0;
		return d1/(d1+d2);
	}
	double owp(int p,int q){
		double d1  = getOut(p,q);
		double d2 = getIn(p,q);
		if(d1+d2==0)
			return 0;
		return d1/(d1+d2);
	}
	double owp(int p){
		//average
		int s = 0;
		double sowp = 0;
		for(int j=0;j<n;j++){
			if(m[p][j]!=0){
				//opponent
				//get wp
				double owp1= owp(j,p);
				sowp += owp1;
				s++;
			}
		}
		if(s==0)
			return 0;
		return sowp/s;
	}
	double oowp(int p){
		int s=0;
		double soowp = 0;
		for(int j=0;j<n;j++){
			if(m[p][j]!=0){
				double o1 = owp(j);
				soowp += o1;
				s++;
			}
		}
		if(s==0)
			return 0;
		return soowp/s;
	}
	//RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP
	double rpi(int p){
		double r=0;
		r = 0.25*wp(p)+0.50*owp(p)+0.25*oowp(p);
		return r;
	}
	int m[][];
	int n;
	private void solve2() {
		n = in.nextInt();
		String a[]=new String [n];
		for(int i=0;i<n;i++){
			a[i]= in.next();
		}
		m =new int[n][n];
		int ind[] = new int[n];
		int outd[] = new int[n];
		for(int i=0;i<n;i++){
			for(int j=0;j<a[i].length();j++){
				if( a[i].charAt(j) == '0' ) {
					m[i][j] = -1;
					ind[i]++;
					outd[j]++;
				} else if (a[i].charAt(j) == '1' ) {
					m[i][j] = 1;
					ind[i]++;
					outd[j]++;
				}
			}
		}
		for(int i=0;i<n;i++){
			for(int j=0;j<n;j++)
				System.out.print(m[i][j]+" ");
			System.out.println();
		}
		for(int i=0;i<n;i++){
			double d =rpi(i);
			System.out.println(d);
			out.println(d);
		}
		
	}
	
	public static void main(String[] args) throws IOException {
		Locale.setDefault(Locale.US);
		System.out.println(Long.MAX_VALUE);
		System.out.println(inputFileName+"\n"+outputFileName);
//		if(true){
//			return;
//		}
		if (args.length >= 1) {
			inputFileName = args[0];
		}
		if (args.length >= 2) {
			inputFileName = args[0];
			outputFileName = args[1];
		}
		in = new Scanner(new FileReader(inputFileName));
		out = new PrintWriter(outputFileName);
		int tests = in.nextInt();
		in.nextLine();
		for (int t = 1; t <= tests; t++) {
			out.println("Case #" + t + ": ");
			new A().solve2();
		}
		in.close();
		out.close();
		System.out.println("success!");
	}
}
