import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;
import java.util.HashSet;
import java.util.InputMismatchException;
import java.util.NoSuchElementException;
import java.util.Set;

/**
 * 
 * @author benadrasni
 */
public class A {
  
  public static void main(String[] args) {
    InputStream inputStream;
    OutputStream outputStream;
    try {
      inputStream = new FileInputStream("taska.in");
    }
    catch (IOException e) {
      throw new RuntimeException(e);
    }
    try {
      outputStream = new FileOutputStream("taska.out");
    }
    catch (IOException e) {
      throw new RuntimeException(e);
    }

    MyScanner in = new MyScanner(inputStream);
    MyPrintWriter out = new MyPrintWriter(outputStream);
    TaskA solver = new TaskA();
    int testCount = Integer.parseInt(in.next());
    for (int i = 1; i <= testCount; i++)
      solver.solve(i, in, out);
    out.close();
  }
}

class TaskA {
  public void solve(int testNumber, MyScanner in, MyPrintWriter out) {
    int firstAnswer = Integer.parseInt(in.next());
    Set<Integer> first = new HashSet<Integer>();
    for (int i = 0; i < 16; i++)
      if (firstAnswer-1 == i/4)
        first.add(Integer.parseInt(in.next()));
      else
        in.next();

    int secondAnswer = Integer.parseInt(in.next());
    Set<Integer> second = new HashSet<Integer>();
    for (int i = 0; i < 16; i++)
      if (secondAnswer-1 == i/4)
        second.add(Integer.parseInt(in.next()));
      else
        in.next();

    String res = null;
    
    int count = 0;
    Integer card = 0;
    for (Integer i : first) {
      if (second.contains(i)) {
          count++;
          card = i;
      }           
  }
    
    if (count == 0) {
      res = "Volunteer cheated!";
    }
    else if (count == 1) {
      res = card.toString();
    }
    else  {
      res = "Bad magician!";
    }
    out.printFormat("Case #%d: %s\n", testNumber, res);
  }
}

class MyScanner {
  private final InputStream in;

  public MyScanner(InputStream in) {
    this.in = in;
  }

  int bufLen;
  int bufPtr;
  byte[] buf = new byte[1024];

  public int read() {
    if (bufLen == -1)
      throw new InputMismatchException();
    if (bufPtr >= bufLen) {
      bufPtr = 0;
      try {
        bufLen = in.read(buf);
      }
      catch (IOException e) {
        throw new InputMismatchException();
      }
      if (bufLen <= 0)
        return -1;
    }
    return buf[bufPtr++];
  }

  private char[] strBuf = new char[65536];

  public String next() {
    int strLen = 0;
    int c;
    do {
      c = read();
      if (c == -1)
        throw new NoSuchElementException();
    }
    while (Character.isWhitespace(c));
    do {
      if (strLen + 1 >= strBuf.length) {
        char[] tmp = new char[strBuf.length * 2];
        System.arraycopy(strBuf, 0, tmp, 0, strBuf.length);
        strBuf = tmp;
      }
      strBuf[strLen++] = (char) c;
      c = read();
    }
    while (c != -1 && !Character.isWhitespace(c));
    return new String(strBuf, 0, strLen);
  }

}

class MyPrintWriter {
  PrintWriter out;

  public MyPrintWriter(OutputStream outputStream) {
    out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(
        outputStream)));
  }

  public MyPrintWriter(Writer writer) {
    out = new PrintWriter(writer);
  }

  public void close() {
    out.close();
  }

  public void printFormat(String format, Object... args) {
    out.printf(format, args);
  }

}
