package lawnmower;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

public class Lawn {

	private static int[][] lawn; // game board status
	
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {

		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(
					"src/lawnmower/B-small-attempt0.in")));
//			br = new BufferedReader(new InputStreamReader(new FileInputStream(
//					"src/lawnmower/test.in")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}

		String s = null;
		s = br.readLine();

		String[] tokens = s.split("\\s+");
		// number of test cases
		int T = Integer.parseInt(tokens[0]);

		for (int i = 0; i < T; i++) { // for each test case
			s = br.readLine();

			tokens = s.split("\\s+");
			// number of test cases
			int x = Integer.parseInt(tokens[0]);		// number of lines
			int y = Integer.parseInt(tokens[1]);		// number of columns
			//System.out.println("x = " + x + " y = " + y);
			// read
			lawn = new int[x][y];
			
			for (int j = 0; j < x; j++) {
				lawn[j] = new int[y];
				s = br.readLine();
				tokens = s.split("\\s+");
				for (int k = 0; k < y; k++) {	
					lawn[j][k] = Integer.parseInt(tokens[k]);
					// debug only
					//System.out.print(lawn[j][k] + " ");
				}
				//System.out.println();			
			}
			//s = br.readLine();		// read in the empty line
				
			
			System.out.println("Case #" + (i + 1) + ": " + (checkOK(x, y) ? "YES" : "NO"));
		}
	}

	private static boolean checkOK(int x, int y) {
		//edge case
		if (x == 1 || y == 1) return true;
		
		boolean []needCheckCol = new boolean[y];
		
		for (int j = 0; j < y; j++) {
			needCheckCol[j] = true;
		}
		
		for (int i = 0; i < x; i++) {
			boolean allSame = true;
			int min = lawn[i][0];
			int minI = 0;			//y index of min in a row
			for (int j = 1; j < y; j++) {
				if (min > lawn[i][j]) {
					min = lawn[i][j];
					minI = j;
					allSame = false;
				}
				else if (min < lawn[i][j]) {
					allSame = false;
				}
			}
			
			if (allSame) continue;		// this line has identical elements, skip
			
			// now we got the min. When check column, this one can be skipped
			needCheckCol[minI] = false;
			//System.out.println(" column " + minI + " skipped!");
			// check whether that column is all same
			for (int j = 1; j < x; j++) {
				if (lawn[0][minI] != lawn[j][minI]) {
					//System.out.println("minI= " + minI + " j= " + j);
					return false;
				}
			}
		}
		
		// do the same thing for column
		for (int i = 0; i < y; i++) {
			if (needCheckCol[i]) {
				int min = lawn[0][i];
				int minI = 0;			//index of min in a row
				for (int j = 1; j < x; j++) {
					if (min > lawn[j][i]) {
						min = lawn[j][i];
						minI = j;
					}
				}
				// now we got the min
				
				// check whether that row is all same
				for (int j = 1; j < y; j++) {
					if (lawn[minI][0] != lawn[minI][j]) {
						//System.out.println("minI= " + minI + " j= " + j);
						return false;
					}
				}
			}
		}
		// all passed
		return true;
	}

}
