package tictactoe;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

public class TicTac {

	private static final int SIZE = 4;
	private static int[][] board; // game board status

	private static final int X = 0;
	private static final int O = 1;
	private static final int T = 2;
	private static final int E = 3; // empty

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {

		board = new int[SIZE][SIZE];

		for (int i = 0; i < SIZE; i++) {
			board[i] = new int[SIZE];
		}

		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(new FileInputStream(
					"src/tictactoe/A-small-attempt0.in")));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

		String s = null;
		s = br.readLine();

		String[] tokens = s.split("\\s+");
		// number of test cases
		int T = Integer.parseInt(tokens[0]);

		for (int i = 0; i < T; i++) { // for each test case
			
			// read
			for (int j = 0; j < SIZE; j++) {
				s = br.readLine();
				for (int k = 0; k < SIZE; k++) {			
					board[j][k] = readSpot(s.charAt(k));
					// debug only
					//System.out.print(board[j][k]);
				}
				//System.out.println();
				
			}
			s = br.readLine();		// read in the empty line
				
			
			System.out.println("Case #" + (i + 1) + ": " + checkWin());
		}

	}

	private static String checkWin() {
		boolean full = true;
		for (int i = 0; i < SIZE; i++) {
			switch(checkRow(i)) {
			case 1:		return "X won";
			case 2:		return "O won";
			case 4:		full = false;
			}
		}
		
		for (int i = 0; i < SIZE; i++) {
			switch(checkColumn(i)) {
			case 1:		return "X won";
			case 2:		return "O won";
			case 4:		full = false;
			}
		}
		
		switch(checkDiag()) {
		case 1:		return "X won";
		case 2:		return "O won";
		case 4:		full = false;
		}
		
		if (!full)	return "Game has not completed";
		else 			return "Draw";
	}

	private static int checkRow(int row) {
		boolean xWin = true;
		boolean oWin = true;
		boolean full = true;
		for (int i = 0; i < SIZE; i++) {
			switch(board[row][i]) {
			case X: oWin = false; break;
			case O: xWin = false; break;
			case E: full = false; xWin = false; oWin = false;	 break;
			default:		break;
			}
		}
		
		if (xWin) 		return 1;	//x wins
		else if (oWin)	return 2;	//o wins
		else if (full)	return 3;	//draw
		else 			return 4;	//not complete
	}

	private static int checkColumn(int col) {
		boolean xWin = true;
		boolean oWin = true;
		boolean full = true;
		for (int i = 0; i < SIZE; i++) {
			switch(board[i][col]) {
			case X: oWin = false; break;
			case O: xWin = false; break;
			case E: full = false; xWin = false; oWin = false;	 break;
			default:		break;
			}
		}
		
		if (xWin) 		return 1;	//x wins
		else if (oWin)	return 2;	//o wins
		else if (full)	return 3;	//draw
		else 			return 4;	//not complete
	}

	private static int checkDiag() {
		int c1 = checkDiag1();
		int c2 = checkDiag2();
		if (c1 == 1 || c2 == 1) {
			return 1;
		}
		else if (c1 == 2 || c2 == 2) {
			return 2;
		} 
		else if (c1 == 4 || c2 == 4) {
			return 4;
		}
		else {
			return 3;		// draw
		}
	}

	private static int checkDiag1() {
		boolean xWin = true;
		boolean oWin = true;
		boolean full = true;
		for (int i = 0; i < SIZE; i++) {
			switch(board[i][i]) {
			case X: oWin = false; break;
			case O: xWin = false; break;
			case E: full = false; xWin = false; oWin = false;	 break;
			default:		break;
			}
		}
		
		if (xWin) 		return 1;	//x wins
		else if (oWin)	return 2;	//o wins
		else if (full)	return 3;	//draw
		else 			return 4;	//not complete
	}

	private static int checkDiag2() {
		boolean xWin = true;
		boolean oWin = true;
		boolean full = true;
		for (int i = 0; i < SIZE; i++) {
			switch(board[i][SIZE - 1 - i]) {
			case X: oWin = false; break;
			case O: xWin = false; break;
			case E: full = false; xWin = false; oWin = false;	 break;
			default:		break;
			}
		}
		
		if (xWin) 		return 1;	//x wins
		else if (oWin)	return 2;	//o wins
		else if (full)	return 3;	//draw
		else 			return 4;	//not complete
	}

	private static int readSpot(char c) {
		int spot;
		
		switch(c) {
		case 'X': spot = X; break;
		case 'O': spot = O; break;
		case 'T': spot = T; break;
		case '.': spot = E; break;

		default: spot = -1; break;
		}
		return spot;
	}

}
