import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class BotTrust {
	public static String fileName = "Testing.txt";
	public static String output = "a.txt";

	public static void main(String[] args) {
		try {
			FileWriter out = new FileWriter(output);
			Scanner scanner = new Scanner(new File(fileName));
			int linesToRead = Integer.parseInt(scanner.nextLine());
			for (int i = 0; i < linesToRead; i++) {
				String line = scanner.nextLine();
				Scanner inLine = new Scanner(line);
				int n = inLine.nextInt(); // not really used
				PositionTracker tracker = new PositionTracker();
				int totalTime = 0;
				Move firstMove = new Move(inLine, tracker);
				if (inLine.hasNext())
					while (true) {
						firstMove.addTimeOffset(tracker);
						if (inLine.hasNext()) {
							Move nextMove = new Move(inLine, tracker);
							while (nextMove.color == firstMove.color) {
								firstMove.mergeWith(nextMove);
								if (inLine.hasNext())
									nextMove = new Move(inLine, tracker);
								else {
									break;
								}
							}
							if (nextMove.color == firstMove.color) {
								totalTime += firstMove.getTimeTaken(tracker);
								break;
							}

							// now its the other color
							Move firstOtherMove = nextMove;
							if (firstOtherMove.getTimeTaken(tracker) > firstMove
									.getTimeTaken(tracker)) {
								if (inLine.hasNext()) {
									nextMove = new Move(inLine, tracker);
									while (nextMove.color == firstOtherMove.color
											&& firstOtherMove
													.getTimeTaken(tracker)
													+ nextMove.time < firstMove
													.getTimeTaken(tracker)) {
										firstOtherMove.mergeWith(nextMove);
										if (inLine.hasNext())
											nextMove = new Move(inLine, tracker);
										else
											break;
									}
								}
								totalTime += firstMove.getHighestTime(
										firstOtherMove, tracker);
								firstMove.setDifferenceWith(firstOtherMove,
										tracker);
								if (nextMove != firstOtherMove)
									firstMove = nextMove;
								else
									break;
							} else {
								// if there is only the first thing to add
								totalTime += firstMove.getTimeTaken(tracker);
								if (firstMove.getTimeTaken(tracker) >= firstOtherMove
										.getTimeTaken(tracker)) {
									if (firstMove.color == 'O') {
										tracker.blueTimeOffset = -firstMove
												.getTimeTaken(tracker);
										tracker.orangeTimeOffset = 0;
									} else {
										tracker.orangeTimeOffset = -firstMove
												.getTimeTaken(tracker);
										tracker.blueTimeOffset = 0;
									}
								}
								firstMove = firstOtherMove;
							}
						} else {
							totalTime += firstMove.getTimeTaken(tracker);
							break;
						}
					}
				else
					totalTime += firstMove.getTimeTaken(tracker);
				out.write("Case #" + (i + 1) + ": " + totalTime + "\n");
			}
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
		System.out.println("done");
	}
}

class PositionTracker {
	int orangeStep = 1;
	int blueStep = 1;
	int orangeTimeOffset = 0;
	int blueTimeOffset = 0;
}

class Move {
	int time;
	char color;

	public Move(Scanner inLine, PositionTracker tracker) {
		color = inLine.next().trim().charAt(0);
		int newStep = inLine.nextInt();
		if (color == 'O') {
			time = Math.max(((int) Math.abs(tracker.orangeStep - newStep)) + 1
					+ tracker.orangeTimeOffset, 1);
			tracker.orangeTimeOffset = 0;
			tracker.orangeStep = newStep;
		} else {
			time = Math.max(((int) Math.abs(tracker.blueStep - newStep)) + 1
					+ tracker.blueTimeOffset, 1);
			tracker.orangeTimeOffset = 0;
			tracker.blueStep = newStep;
		}
	}

	public void addTimeOffset(PositionTracker tracker) {
		if (color == 'O') {
			time = Math.max(time + tracker.orangeTimeOffset, 1);
			tracker.orangeTimeOffset = 0;
		} else {
			time = Math.max(time + tracker.blueTimeOffset, 1);
			tracker.blueTimeOffset = 0;
		}
	}

	public int getHighestTime(Move other, PositionTracker tracker) {
		if (color == 'O')
			return Math.max(
					Math.max(other.time + tracker.blueTimeOffset, time
							+ tracker.orangeTimeOffset), 1);
		else
			return Math.max(
					Math.max(time + tracker.blueTimeOffset, other.time
							+ tracker.orangeTimeOffset), 1);
	}

	public int getTimeTaken(PositionTracker tracker) {
		if (color == 'O')
			return Math.max(1, time + tracker.orangeTimeOffset);
		else
			return Math.max(1, time + tracker.blueTimeOffset);
	}

	public void setDifferenceWith(Move other, PositionTracker tracker) {
		char lesserColor;
		if (getTimeTaken(tracker) > other.getTimeTaken(tracker))
			lesserColor = other.color;
		else
			lesserColor = color;
		int timeOffset = -(int) Math.abs(getTimeTaken(tracker)
				- other.getTimeTaken(tracker));
		if (lesserColor == 'O') {
			tracker.orangeTimeOffset = timeOffset;
			tracker.blueTimeOffset = 0;
		} else {
			tracker.blueTimeOffset = timeOffset;
			tracker.orangeTimeOffset = 0;
		}
	}

	public void mergeWith(Move other) {
		time += other.time;
	}
}