package org.inexorable.codejam.year2013.qr;

import org.inexorable.codejam.util.FileHelper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>org.inexorable.codejam.year2013.qr.C_FairAndSquare, created on 13/04/13 11:07 AM </p>
 *
 * @author ben
 */
public class C_FairAndSquare {

    public static void main(String[] args) throws Exception {
//        new C_FairAndSquare().run("/home/ben/inexorable/modules/codejam/res/year2013/QRC-example");
        new C_FairAndSquare().run("/home/ben/inexorable/modules/codejam/res/year2013/C-small-attempt0");
//        new C_FairAndSquare().run("/home/ben/inexorable/modules/codejam/res/year2013/C-large");
    }

    private void run(String filename) throws Exception {
        // load the tasks to run into a list of task objects
        BufferedReader reader = new BufferedReader(new FileReader(filename + ".in"));
        int n = Integer.parseInt(reader.readLine().trim());
        List<Task> tasks = new ArrayList<Task>(n);
        for (int i = 1; i <= n; i++) {
            Task task = new Task();
            task.number = i;
            BigInteger[] ia = FileHelper.readBigIntArray(reader, 2);
            task.a = ia[0];
            task.b = ia[1];
            tasks.add(task);
        }
        reader.close();
        // now execute each task, writing the result to a file as we process it
        BufferedWriter writer = new BufferedWriter(new FileWriter(filename + ".out"));
        for (Task task : tasks) {
            writer.write(task.run());
            writer.newLine();
        }
        writer.flush();
        writer.close();
        System.out.println("--");
    }

    private class Task {
        int number;
        BigInteger a;
        BigInteger b;

        public String run() {
            int count = 0;
            // find the first square on or after the starting point
            BigInteger fs = firstSquare(a, b);
            if (fs != null) {
                if (palindrome(fs) && palindrome(fs.multiply(fs))) count++;
                BigInteger n = fs.add(BigInteger.ONE);
                boolean done = false;
                while (!done) {
                    // check if the next square is within the bounds
                    BigInteger sqr = n.multiply(n);
                    done = sqr.compareTo(b) > 0;
                    // increment the count if we are within the bounds and it is a palindrome
                    if (!done && palindrome(n) && palindrome(sqr)) count++;
                    n = n.add(BigInteger.ONE);
                }
            }
            return finish(String.valueOf(count));
        }

        private BigInteger firstSquare(BigInteger min, BigInteger max) {
            BigInteger n = new BigInteger(min.toString());
            while (n.compareTo(max) <= 0) {
                BigDecimal s = sqrt(n);
                BigDecimal f = s.setScale(0, BigDecimal.ROUND_FLOOR);
                if (s.compareTo(f) == 0) {
                    return f.toBigInteger();
                }
                n = n.add(BigInteger.ONE);
            }
            return null;
        }

        private BigDecimal sqrt(BigInteger ni) {
            BigDecimal n = new BigDecimal(ni.toString());
            if (ni.compareTo(BigInteger.ZERO) == 0 || ni.compareTo(BigInteger.ONE) == 0) {
                return n;
            }
            BigDecimal two = BigDecimal.valueOf(2L);
            BigDecimal y;
            for (y = n.divide(two, 10, BigDecimal.ROUND_FLOOR);
                 y.compareTo(n.divide(y, 10, BigDecimal.ROUND_FLOOR)) > 0;
                 y = ((n.divide(y, 10, BigDecimal.ROUND_FLOOR)).add(y)).divide(two, 10, BigDecimal.ROUND_FLOOR));
            return y;
        }

        private boolean palindrome(BigInteger n) {
            String s = n.toString();
            if (s.length() == 1) return true;
            boolean palindrome = true;
            for (int i = 0; i < s.length() / 2 && palindrome; i++) {
                palindrome &= s.charAt(i) == s.charAt(s.length()-1);
            }
            return palindrome;
        }

        private String finish(String s) {
            String result = "Case #" + number + ": " + s;
            System.out.println(result);
            return result;
        }
    }

}
