package org.inexorable.codejam.year2014.qr;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * <p>Note: this code is terrible </p>
 * <p/>
 * <p>org.inexorable.codejam.year2014.qr.C, created on 12/04/14 8:11 AM</p>
 *
 * @author benexorable
 */
public class C {

    private static final String IMPOSSIBLE = "Impossible";

    private static final String EOL = System.getProperty("line.separator");

    public static void main(String[] args) throws Exception {
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-example");
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt0");
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt1");
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt2");
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt3");
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt4");
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt5");
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt6");
        new C().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/C-small-attempt7");
    }

    private void run(String filename) throws Exception {
        Scanner scanner = new Scanner(new FileReader(filename + ".in"));
        int T = scanner.nextInt();
        List<String> results = new ArrayList<String>(T);
        for (int number = 1; number <= T; number++) {
            // read the test data (rows, columns, mines)
            int R = scanner.nextInt();
            int C = scanner.nextInt();
            int M = scanner.nextInt();
            // calculate the clear space
            int clearSpace = R * C - M;
            String msg;
            if (R < 1 || C < 1 || M >= R * C) {
                // outside of the limits, but just in case
                msg = IMPOSSIBLE;
            } else if (M == 0) {
                // no mines, so we can click anywhere
                msg = drawGrid(R, C, M, 2);
            } else if (R == 1 || C == 1) {
                // if there's only one row or column then 1 is the minimum free spaces we need
                msg = drawGrid(R, C, M, 1);
            } else if (R * C - M == 1) {
                // if there's only one place to go then that's ok
                msg = drawGrid(R, C, M, 1);
            } else if (R == 3 && C == 3 && M == 4) {
                // special case, haven't thought of a rule for this yet not that the other rules are any good
                msg = ".**" + EOL + "*.." + EOL + "*.c";
            } else {
                // if there's more than one row or column then 4 is the minimum free spaces we need
                if (clearSpace < 4) {
                    msg = IMPOSSIBLE;
                } else {
                    // draw grid
                    msg = drawGrid(R, C, M, 2);
                    // if it's impossible, try the alternate style
                    if (msg.equals(IMPOSSIBLE)) {
                        msg = drawGridX(R, C, M);
                    }
                    if (msg.equals(IMPOSSIBLE)) {
                        msg = drawGridY(R, C, M);
                    }
                    // try some more alternate styles if we have enough width or breadth
                    if (R > 2 && C > 2) {
                        if (msg.equals(IMPOSSIBLE)) {
                            msg = drawGridX2(R, C, M);
                        }
                        if (msg.equals(IMPOSSIBLE)) {
                            msg = drawGridY2(R, C, M);
                        }
                    }
                    // check for dangling 1s
                    if (R > 3 && C > 2 || R > 2 && C > 3) {
                        if (msg.equals(IMPOSSIBLE)) {
                            msg = drawGrid3(R, C, M);
                        }
                    }
                }
            }
            String result = "Case #" + number + ": " + EOL + msg;
            System.out.println(result);
            results.add(result);
        }
        scanner.close();
        BufferedWriter writer = new BufferedWriter(new FileWriter(filename + ".out"));
        for (String result : results) {
            writer.write(result);
            writer.newLine();
        }
        writer.flush();
        writer.close();
        System.out.println("--");
    }

    private String drawGrid(int rows, int cols, int M, int size) {
        int mines = M;
        // fill the grid with mines leaving gaps at the edge
        char[][] ca = new char[rows][cols];
        for (int y = 0; y < rows; y++) {
            for (int x = 0; x < cols; x++) {
                if (x + size < cols && y + size < rows && M > 0) {
                    ca[y][x] = '*';
                    M--;
                } else {
                    ca[y][x] = '.';
                }
            }
        }
        // if we have mines left, see if we can distribute them so we can still win the game
        if (M > 0) {
            // if the remainder is divisible by 2 then we can slot it into the rest of the grid
            if (M % size == 0) {
                // fill in the rows, two at a time
                for (int y = 0; y < rows - size && M > 0; y++) {
                    for (int i = size; i > 0; i--) {
                        ca[y][cols - i] = '*';
                    }
                    M -= size;
                }
                // fill in the cols, two at a time
                for (int x = 0; x < cols - size && M > 0; x++) {
                    for (int i = size; i > 0; i--) {
                        ca[rows - i][x] = '*';
                    }
                    M -= size;
                }
            } else {
                return IMPOSSIBLE;
            }
        }
        // click in the bottom right corner
        ca[rows - 1][cols - 1] = 'c';
        // convert to a string
        gridCheck(ca, rows, cols, mines);
        return grid2string(ca);
    }

    private String drawGridX(int rows, int cols, int M) {
        int mines = M;
        // fill the grid with mines completely
        char[][] ca = new char[rows][cols];
        for (int y = 0; y < rows; y++) {
            for (int x = 0; x < cols; x++) {
                if (M > 0) {
                    ca[y][x] = '*';
                    M--;
                    if (M == 0) {
                        // check if the grid can be solved based on current position
                        if (!((x + 1 == cols || x < cols - 2) && (y + 1 == rows || y < rows - 2))) {
                            return "Impossible";
                        }
                    }
                } else {
                    ca[y][x] = '.';
                }
            }
        }
        // click in the bottom right corner
        ca[rows - 1][cols - 1] = 'c';
        // convert to a string
        gridCheck(ca, rows, cols, mines);
        return grid2string(ca);
    }

    private String drawGridX2(int rows, int cols, int M) {
        int mines = M;
        // fill the grid with mines completely
        char[][] ca = new char[rows][cols];
        for (int y = 0; y < rows; y++) {
            // only continue if possible
            if (y >= rows - 2 && M > 0) {
                return IMPOSSIBLE;
            }
            if (M >= cols) {
                // fill the entire row
                for (int x = 0; x < cols; x++) {
                    ca[y][x] = '*';
                }
                M -= cols;
            } else {
                // otherwise go from side to side
                int x = cols;
                int m = -1;
                for (int i = cols; i > 0; i--) {
                    x = x + (i * m);
                    m *= -1;
                    if (M > 0) {
                        ca[y][x] = '*';
                        M--;
                    } else {
                        ca[y][x] = '.';
                    }
                }
            }
        }
        // click in the bottom middle
        ca[rows - 1][cols / 2] = 'c';
        // convert to a string
        gridCheck(ca, rows, cols, mines);
        return grid2string(ca);
    }

    private String drawGrid3(int rows, int cols, int M) {
        int mines = M;
        // fill the grid with mines completely
        char[][] ca = new char[rows][cols];
        for (int y = 0; y < rows; y++) {
            for (int x = 0; x < cols; x++) {
                ca[y][x] = '*';
            }
        }

        int spaceNeeded = rows * cols - M;
        if (spaceNeeded % 2 == 1) {
            if (cols >= rows) {
                // X based
                int bottomFillNeeded = (spaceNeeded / 2) + 1;
                int upperFillNeeded = (spaceNeeded / 2);
                if (cols >= bottomFillNeeded) {
                    for (int x = 1; x <= bottomFillNeeded; x++) {
                        ca[rows - 1][cols - x] = '.';
                    }
                    for (int x = 1; x <= upperFillNeeded; x++) {
                        ca[rows - 2][cols - x] = '.';
                    }
                    // click in the bottom right corner
                    ca[rows - 1][cols - 1] = 'c';
                    // convert to a string
                    gridCheck(ca, rows, cols, mines);
                    return grid2string(ca);
                }
            } else {
                // Y based
                int bottomFillNeeded = (spaceNeeded / 2) + 1;
                int upperFillNeeded = (spaceNeeded / 2);
                if (rows >= bottomFillNeeded) {
                    for (int y = 1; y <= bottomFillNeeded; y++) {
                        ca[rows - y][cols - 1] = '.';
                    }
                    for (int y = 1; y <= upperFillNeeded; y++) {
                        ca[rows - y][cols - 2] = '.';
                    }
                    // click in the bottom right corner
                    ca[rows - 1][cols - 1] = 'c';
                    // convert to a string
                    gridCheck(ca, rows, cols, mines);
                    return grid2string(ca);
                }
            }
        }
        return IMPOSSIBLE;
    }

    private String drawGridY(int rows, int cols, int M) {
        int mines = M;
        // fill the grid with mines completely
        char[][] ca = new char[rows][cols];
        for (int x = 0; x < cols; x++) {
            for (int y = 0; y < rows; y++) {
                if (M > 0) {
                    ca[y][x] = '*';
                    M--;
                    if (M == 0) {
                        // check if the grid can be solved based on current position
                        if (!((x + 1 == cols || x < cols - 2) && (y + 1 == rows || y < rows - 2))) {
                            return IMPOSSIBLE;
                        }
                    }
                } else {
                    ca[y][x] = '.';
                }
            }
        }
        // click in the bottom right corner
        ca[rows - 1][cols - 1] = 'c';
        // convert to a string
        gridCheck(ca, rows, cols, mines);
        return grid2string(ca);
    }

    private String drawGridY2(int rows, int cols, int M) {
        int mines = M;
        // fill the grid with mines completely
        char[][] ca = new char[rows][cols];
        for (int x = 0; x < cols; x++) {
            // only continue if possible
            if (x >= cols - 2 && M > 0) {
                return IMPOSSIBLE;
            }
            if (M >= rows) {
                // fill the entire col
                for (int y = 0; y < rows; y++) {
                    ca[y][x] = '*';
                }
                M -= rows;
            } else {
                // otherwise go from top to bottom
                int y = rows;
                int m = -1;
                for (int i = rows; i > 0; i--) {
                    y = y + (i * m);
                    m *= -1;
                    if (M > 0) {
                        ca[y][x] = '*';
                        M--;
                    } else {
                        ca[y][x] = '.';
                    }
                }
            }
        }
        // click in the far right middle
        ca[rows / 2][cols - 1] = 'c';
        // convert to a string
        gridCheck(ca, rows, cols, mines);
        return grid2string(ca);
    }

    private String grid2string(char[][] ca) {
        StringBuffer sb = new StringBuffer();
        for (int y = 0; y < ca.length; y++) {
            for (int x = 0; x < ca[y].length; x++) {
                sb.append(ca[y][x]);
            }
            if (y + 1 < ca.length) sb.append(EOL);
        }
        return sb.toString();
    }

    private void gridCheck(char[][] ca, int R, int C, int M) {
        // range checking
        int clicks = 0, mines = 0, space = 0;
        for (int y = 0; y < ca.length; y++) {
            for (int x = 0; x < ca[y].length; x++) {
                clicks += ca[y][x] == 'c' ? 1 : 0;
                mines += ca[y][x] == '*' ? 1 : 0;
                space += ca[y][x] == '.' ? 1 : 0;
            }
        }
        if (clicks + mines + space != R * C)
            throw new RuntimeException("Clicks = " + clicks + ", Mines = " + mines + ", Space = " + space);
        if (clicks != 1) throw new RuntimeException("Clicks = " + clicks);
        if (mines != M) throw new RuntimeException("Mines = " + mines + ", M = " + M);
        if (space != (R * C - M - 1)) throw new RuntimeException("Space = " + space + ", clearSpace = " + (R * C - M));
    }

}