package org.inexorable.codejam.year2014.qr;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.math.RoundingMode;
import java.text.DecimalFormat;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * <p>org.inexorable.codejam.year2014.qr.B, created on 12/04/14 8:11 AM</p>
 *
 * @author benexorable
 */
public class B {

    public static void main(String[] args) throws Exception {
//        new B().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/B-example");
//        new B().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/B-small-attempt0");
        new B().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/B-large");
    }

    private static final NumberFormat NF = new DecimalFormat("0.0000000");

    private void run(String filename) throws Exception {
        Scanner scanner = new Scanner(new FileReader(filename + ".in"));
        int T = scanner.nextInt();
        List<String> results = new ArrayList<String>(T);
        for (int number = 1; number <= T; number++) {
            BigDecimal cs = new BigDecimal("2.0"); // the starting number of cookies per second
            // read the data
            BigDecimal C = scanner.nextBigDecimal(); // cost to buy a farm
            BigDecimal F = scanner.nextBigDecimal(); // number of cookies farm produces
            BigDecimal X = scanner.nextBigDecimal(); // target number of cookies
            // check to see if it is faster to buy a farm or keep calculating
            BigDecimal value = calcMinimum(cs, C, F, X);
            String result = "Case #" + number + ": " + NF.format(value);
            System.out.println(result);
            results.add(result);
        }
        scanner.close();
        BufferedWriter writer = new BufferedWriter(new FileWriter(filename + ".out"));
        for (String result : results) {
            writer.write(result);
            writer.newLine();
        }
        writer.flush();
        writer.close();
        System.out.println("--");
    }

    private BigDecimal calcMinimum(BigDecimal cs, BigDecimal c, BigDecimal f, BigDecimal x) {
        BigDecimal timeTaken = BigDecimal.ZERO;
        while (true) {
            BigDecimal time1 = timeTaken.add(x.divide(cs, 8, RoundingMode.HALF_UP));
            // calculate time to new farm
            BigDecimal farmWait = c.divide(cs, 8, RoundingMode.HALF_UP);
            // calculate time to finish with new farm
            BigDecimal withFarm = x.divide(cs.add(f), 8, RoundingMode.HALF_UP);
            // calculate new total time
            BigDecimal time2 = timeTaken.add(farmWait.add(withFarm));
            // if the time just waiting (with no farm) is less then stop
            // if the time to wait is smaller then we are finished
            if (time1.compareTo(time2) < 0) return time1.compareTo(time2) < 0 ? time1 : time2;
            // increment the time taken for the next loop
            timeTaken = timeTaken.add(farmWait);
            // increment the cookies per second for the next loop
            cs = cs.add(f);
        }
    }

}
