package org.inexorable.codejam.year2013.r1c;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * <p>org.inexorable.codejam.year2013.r1c.A, created on 12/05/13 6:59 PM</p>
 *
 * @author ben
 */
public class A {

    public static void main(String[] args) throws Exception {
//        new A().run("/home/ben/inexorable/modules/codejam/res/year2013/r1c/A-example");
//        new A().run("/home/ben/inexorable/modules/codejam/res/year2013/r1c/A-small-attempt0");
        new A().run("/home/ben/inexorable/modules/codejam/res/year2013/r1c/A-large");
    }

    private void run(String filename) throws Exception {
        // load the tasks to run into a list of task objects
        Scanner scanner = new Scanner(new FileReader(filename + ".in"));
        int T = scanner.nextInt();
        List<String> results = new ArrayList<String>(T);
        for (int number = 1; number <= T; number++) {
            Task task = new Task();
            task.number = number;
            task.s = scanner.next();
            task.minLength = scanner.nextInt();
            results.add(task.run());
        }
        scanner.close();
        // now execute each task, writing the result to a file as we process it
        BufferedWriter writer = new BufferedWriter(new FileWriter(filename + ".out"));
        for (String result : results) {
            writer.write(result);
            writer.newLine();
        }
        writer.flush();
        writer.close();
        System.out.println("--");
    }

    private class Task {
        int number;
        String s;
        int minLength;

        public String run() {
            char[] ca = s.toCharArray();
            char[] cs = new char[minLength];
            int lastIndex = 0;
            long consecutive = 0;
            loopi:
            for (int i = 0; i < ca.length - minLength + 1; i++) {
                for (int j = i; j < i + minLength; j++) {
                    char c = ca[j];
                    if (c == 'a' || c == 'e' || c == 'i' || c == 'o' || c == 'u') {
                        continue loopi;
                    }
                    cs[j - i] = c;
                }
                // process the string
                String sx = new String(cs);
                int sxStart = i;
                int numBefore = sxStart - lastIndex;
                int numAfter = s.length() - (sxStart + sx.length());
                int number = numBefore + numAfter + (numBefore * numAfter) + 1;
                consecutive += number;
                lastIndex = sxStart + 1;
            }
            return finish(Long.toString(consecutive));
        }

        private String finish(String s) {
            String result = "Case #" + number + ": " + s;
            System.out.println(result);
            return result;
        }
    }

}
