package org.inexorable.codejam.year2013.qr;

import org.inexorable.codejam.util.FileHelper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * <p>org.inexorable.codejam.year2013.qr.B_Lawnmower, created on 13/04/13 9:49 AM </p>
 *
 * @author ben
 */
public class B_Lawnmower {

    public static void main(String[] args) throws Exception {
        new B_Lawnmower().run("/home/ben/inexorable/modules/codejam/res/year2013/QRB-example");
        new B_Lawnmower().run("/home/ben/inexorable/modules/codejam/res/year2013/B-small-attempt0");
//        new B_Lawnmower().run("/home/ben/inexorable/modules/codejam/res/year2013/B-large");
    }

    private void run(String filename) throws Exception {
        // load the tasks to run into a list of task objects
        BufferedReader reader = new BufferedReader(new FileReader(filename + ".in"));
        int n = Integer.parseInt(reader.readLine().trim());
        List<Task> tasks = new ArrayList<Task>(n);
        for (int i = 1; i <= n; i++) {
            Task task = new Task();
            task.number = i;
            int[] ia = FileHelper.readIntArray(reader, 2);
            task.n = ia[0];
            task.m = ia[1];
            task.array = new int[task.n][task.m];
            for (int ni = 0; ni < task.n; ni++) {
                task.array[ni] = FileHelper.readIntArray(reader, task.m);
            }
            tasks.add(task);
        }
        reader.close();
        // now execute each task, writing the result to a file as we process it
        BufferedWriter writer = new BufferedWriter(new FileWriter(filename + ".out"));
        for (Task task : tasks) {
            writer.write(task.run());
            writer.newLine();
        }
        writer.flush();
        writer.close();
        System.out.println("--");
    }

    private class Task {
        int number;
        int n;
        int m;
        int[][] array;

        public String run() {
            boolean ok = true;
            for (int ni = 0; ni < n && ok; ni++) {
                for (int mi = 0; mi < m && ok; mi++) {
                    // if everything in the row OR the col is the same height or lower this is a valid height
                    int h = array[ni][mi];
                    // check the row first
                    boolean rowOk = true;
                    for (int i = 0; i < m && rowOk; i++) {
                        rowOk &= array[ni][i] <= h;
                    }
                    // if the row is not ok check the col
                    boolean colOk = true;
                    for (int i = 0; i < n && !rowOk && colOk; i++) {
                        colOk &= array[i][mi] <= h;
                    }
                    ok &= (rowOk || colOk);
                }
            }
            return finish(ok ? "YES" : "NO");
        }

        private String finish(String s) {
            String result = "Case #" + number + ": " + s;
            System.out.println(result);
            return result;
        }
    }

}
