package org.inexorable.codejam.year2016.qr;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * <p>org.inexorable.codejam.year2016.qr.C, created on 9/04/16 7:31 AM</p>
 *
 * @author benexorable
 */
public class C {

    public static void main(String[] args) throws Exception {
//        new C().run("/home/ben/inexorable/modules/codejam/res/year2016/qr/C-example");
        new C().run("/home/ben/inexorable/modules/codejam/res/year2016/qr/C-small-attempt0");
    }

    // took the easy way, because we know the sample set and only have to provide valid results (ie non-primes) we
    // can just calculate valid non-primes quickly up to a certain divisor before discarding and checking the next

    private void run(String filename) throws Exception {
        Scanner scanner = new Scanner(new FileReader(filename + ".in"));
        int T = scanner.nextInt();
        List<String> results = new ArrayList<String>(T);
        for (int number = 1; number <= T; number++) {
            int N = scanner.nextInt();
            int J = scanner.nextInt();

            StringBuffer result = new StringBuffer("Case #" + number + ": ");
            result.append(System.getProperty("line.separator"));

            // determine starting jamcoin to check based on the length
            BigInteger binary = new BigInteger(String.format("1%0" + (N - 1) + "d", 1));
            BigInteger counter = new BigInteger(binary.toString(), 2);

            int found = 0;
            loop:
            while (found < J) {
                // create the potential jamcoin
                BigInteger jamcoin = new BigInteger(counter.toString(2));
                // increment the counter in case the current coin is invalid
                counter = counter.add(BigInteger.ONE);
                // only want coins start/ending with 1
                if (!jamcoin.testBit(0)) {
                    continue;
                }
                List<Integer> divisors = new ArrayList<>(10);
                for (int i = 2; i <= 10; i++) {
                    BigInteger baseX = new BigInteger(jamcoin.toString(), i);
                    // we only want non-primes for jamcoins (and we're only doing a quick check)
                    int divisor = nonPrime(baseX.longValue());
                    if (divisor == 0) {
                        continue loop;
                    }
                    divisors.add(divisor);
                }
                result.append(jamcoin);
                for (Integer divisor : divisors) {
                    result.append(" ").append(divisor);
                }
                result.append(System.getProperty("line.separator"));
                found++;
            }


            System.out.println(result);
            results.add(result.toString());
        }
        scanner.close();
        BufferedWriter writer = new BufferedWriter(new FileWriter(filename + ".out"));
        for (String result : results) {
            writer.write(result);
            writer.newLine();
        }
        writer.flush();
        writer.close();
        System.out.println("--");
    }

    private int[] divisors = {2, 3, 5, 7, 11, 13, 17, 19, 23, 29};

    private int nonPrime(long n) {
        for (int divisor : divisors) {
            if (n % divisor == 0) {
                return divisor;
            }
        }
        return 0;
    }

}
