package org.inexorable.codejam.year2014.qr;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.*;

/**
 * <p>org.inexorable.codejam.year2014.qr.A, created on 12/04/14 8:11 AM</p>
 *
 * @author benexorable
 */
public class A {

    public static void main(String[] args) throws Exception {
//        new A().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/A-example");
        new A().run("/home/ben/inexorable/modules/codejam/res/year2014/qr/A-small-attempt0");
    }

    private void run(String filename) throws Exception {
        Scanner scanner = new Scanner(new FileReader(filename + ".in"));
        int T = scanner.nextInt();
        List<String> results = new ArrayList<String>(T);
        for (int number = 1; number <= T; number++) {
            // read the first row chosen
            int row1 = scanner.nextInt();
            // read the first set of cards
            Set<Integer> cards1 = new HashSet<Integer>();
            for (int y = 1; y <= 4; y++) {
                for (int x = 0; x < 4; x++) {
                    int card = scanner.nextInt();
                    if (y == row1) {
                        // only keep the card if it's the matching row, otherwise discard
                        cards1.add(card);
                    }
                }
            }
            // read the second row chosen
            int row2 = scanner.nextInt();
            // read the second set of cards
            Set<Integer> cards2 = new HashSet<Integer>();
            for (int y = 1; y <= 4; y++) {
                for (int x = 0; x < 4; x++) {
                    int card = scanner.nextInt();
                    if (y == row2) {
                        // only keep the card if it's the matching row, otherwise discard
                        cards2.add(card);
                    }
                }
            }
            // if there are any duplicates set will be smaller
            String msg;
            if (cards1.size() != 4 || cards2.size() != 4) {
                msg = "Bad magician!";
            } else {
                // check if there is a single card in both rows
                Integer matchingCard = null;
                int cardsFound = 0;
                for (Integer card : cards1) {
                    if (cards2.contains(card)) {
                        matchingCard = card;
                        cardsFound++;
                    }
                }
                // determine the output based on the cards found
                switch (cardsFound) {
                    case 0:
                        msg = "Volunteer cheated!";
                        break;
                    case 1:
                        msg = Integer.toString(matchingCard);
                        break;
                    default:
                        msg = "Bad magician!";
                        break;
                }
                if (cardsFound > 1) {
                    msg = "Bad magician!";
                }
            }
            String result = "Case #" + number + ": " + msg;
            System.out.println(result);
            results.add(result);
        }
        scanner.close();
        BufferedWriter writer = new BufferedWriter(new FileWriter(filename + ".out"));
        for (String result : results) {
            writer.write(result);
            writer.newLine();
        }
        writer.flush();
        writer.close();
        System.out.println("--");
    }

}
