import java.io.BufferedReader;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;


public class StandingOvation
{
	public static void main(String [] args) throws IOException
	{
		List<String> text = readTextFile("A-small-attempt0.in");
		
		int numCases = Integer.parseInt(text.remove(0));
		
		for(int i =  1; i <= numCases; i++)
		{
			String[] input = text.get(i-1).split(" ");
			int s_max = Integer.parseInt(input[0]);
			String[] audience = input[1].split("");
			
			int standing = 0;
			int needed   = 0;
			
			for(int j = 0; j <= s_max; j++)
			{
				if(standing < j)
				{
					int toAdd = j - standing;
					needed += toAdd;
					standing += toAdd;
				}
				standing += Integer.parseInt(audience[j]);
			}
			
			System.out.println("Case #" + i + ": " + needed);
		}
	}

	final static Charset ENCODING = StandardCharsets.UTF_8;
	
	static List<String> readTextFile(String filename) throws IOException
	{
		List<String> list = new ArrayList<>();
		
		Path path = Paths.get(filename);
		try (BufferedReader reader = Files.newBufferedReader(path, ENCODING)) {
			String line;
			while((line = reader.readLine()) != null) {
				list.add(line);
			}
		}
		return list;
	}
}
