package src;
import java.io.BufferedReader;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.PriorityQueue;


public class InfiniteHouseOfPancakes
{
	public static void main(String [] args) throws IOException
	{
		List<String> text = readTextFile("B/B-small-attempt11.in");
		
		int numCases = Integer.parseInt(text.get(0));
		
		for(int i =  1; i <= numCases; i++)
		{
			int numPlates = Integer.parseInt(text.remove(i));
			
			System.out.println("Case #" + i + ": " + IHOP(numPlates, text.get(i)));
		}
	}
	
	public static int IHOP(int numPlates, String inputLine)
	{	
		String[] input = inputLine.split(" ");
		
		PriorityQueue<Integer> pq  = new PriorityQueue<>(numPlates, new Comparator<Integer>() {
			@Override
			public int compare(Integer o1, Integer o2)
			{
				return o2-o1;
			}
		});
		
		for(String s : input)
			pq.add(Integer.parseInt(s));
		
		int minutes = 0;
		int top;
		
		while(pq.peek() > 3)
		{
			top = pq.poll();
			int count = 1;
			while(!pq.isEmpty() && top == pq.peek())
			{
				pq.poll();
				count++;
			}
			if(top/2 > count && top >= count + (pq.isEmpty() ? top/2 + top%2 : pq.peek()))
			{
				for(int j = 0; j < count; j++)
				{
					pq.add(top/2);
					pq.add(top/2 + top%2);
				}
				minutes += count;
			}
			else
			{
				pq.add(top);
				break;
			}
		}
		minutes += pq.poll();
		
		return minutes;
	}

	final static Charset ENCODING = StandardCharsets.UTF_8;
	
	static List<String> readTextFile(String filename) throws IOException
	{
		List<String> list = new ArrayList<>();
		
		Path path = Paths.get(filename);
		try (BufferedReader reader = Files.newBufferedReader(path, ENCODING)) {
			String line;
			while((line = reader.readLine()) != null) {
				list.add(line);
			}
		}
		return list;
	}
}
