package snapper;

import java.util.Vector;

import readers.SnapperReader;
import writers.SnapperWriter;

public class Devices {
	
	private Vector<Device> mesDevices;
	private int snaps;
	private int snappers;
	
	public Devices(int snappers, int snaps) {
		Device d = new Socket(null);
		this.mesDevices = new Vector<Device>();
		this.mesDevices.add(d);
		this.snappers = snappers;
		this.snaps = snaps;
		d = new Snapper(null);
		mesDevices.get(mesDevices.size()-1).setSuiv(d);
		d.switchPower();
		this.mesDevices.add(d);
		for (int i=1; i < this.snappers; i++) {
			d = new Snapper(null);
			mesDevices.get(mesDevices.size()-1).setSuiv(d);
			this.mesDevices.add(d);
		}
		d = new Light();
		mesDevices.get(mesDevices.size()-1).setSuiv(d);
		mesDevices.add(d);
	}
	
	public boolean isLightSwithedOn() {
		int j;
		Device d;
		for (int i = 0; i < this.snaps; i++) {
			for (j = this.mesDevices.size() - 2 ; j > 0; j--) {
				d = mesDevices.get(j);
				if (d instanceof Snapper) {
					if (d.getPower()) {
						((Snapper)d).switchState();
						d.getSuiv().setPower(d.getPower() && ((Snapper)d).getState());
					}
				}
			}
		}
		return this.mesDevices.get(mesDevices.size()-1).getPower();
	}
	
	public String toString() {
		StringBuffer retour = new StringBuffer();
		for (Device d : this.mesDevices) {
			retour.append(d.toString()+"\n");
		}
		return retour.toString();
	}
	
	public Vector<Device> getDevices() {
		return this.mesDevices;
	}

	public static class Test {
		
		public static void main(String[] args) {
			boolean b;
			SnapperReader reader = new SnapperReader("A-small-attempt4.in");
			SnapperWriter writer = new SnapperWriter("A-small.out");
			reader.readFile();
			for (int i = 0; i < reader.getNbCases(); i++) {
				Devices mesDevices = new Devices(reader.getCas(i)[0], reader.getCas(i)[1]);
				//System.out.println(mesDevices.toString());
				b = mesDevices.isLightSwithedOn();
				writer.writeFile(b);
			}
			
			reader.closeFile();
			writer.closeFile();
		}
	}
}
