package GCJ2016.round1B.problemA;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.*;

public class Main {

    String[] numbers = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};

    public static void main(String[] args) throws Exception {
        new Main();
    }

    public Main() throws Exception {
        solve();
    }

    private void solve() throws Exception {
        System.out.println(">>> Input: ");
        Scanner sc = new Scanner(System.in);
        BufferedWriter out = new BufferedWriter(new FileWriter("output.txt"));

        int test_cases = sc.nextInt();

        for (int test_case = 1; test_case <= test_cases; test_case++) {
            String word = sc.next();

            String result = "Case #" + test_case + ": " + getResult(word);
            out.write(result + "\n");
            System.out.println(result);
        }

        out.flush();
        out.close();
        sc.close();
    }

    private String getResult(String word) {
        List<Integer> numbersResult = new ArrayList<Integer>();

        Map<Character, Integer> freq = getFrequencyList(word);
        Map<Character, Set<Integer>> possibleNumbers = getPossibleNumbersMap();

        func(numbersResult, freq, possibleNumbers);

        Collections.sort(numbersResult);
        return listToString(numbersResult);
    }

    private boolean func(List<Integer> numbersResult, Map<Character, Integer> freq, Map<Character, Set<Integer>> possibleNumbers) {
        if (freq.isEmpty()) {
            return true;
        }

        Character next = freq.keySet().iterator().next();

        for (Integer n : possibleNumbers.get(next)) {
            Map<Character, Integer> backupFreq = new HashMap<>(freq);
            boolean ok = true;
            for (char c : numbers[n].toCharArray()) {
                if (!freq.containsKey(c)) {
                    ok = false;
                    break;
                }
                if (freq.get(c) > 1) {
                    freq.put(c, freq.get(c) - 1);
                } else {
                    freq.remove(c);
                }
            }
            if (ok) {
                numbersResult.add(n);
                boolean result = func(numbersResult, freq, possibleNumbers);
                if (result) {
                    return true;
                }
                numbersResult.remove(numbersResult.size()-1);
            }
            freq = backupFreq;
        }

        return false;
    }

    private Map<Character, Integer> getFrequencyList(String word) {
        Map<Character, Integer> freq = new HashMap<>();

        for (char c : word.toCharArray()) {
            if (!freq.containsKey(c)) {
                freq.put(c, 1);
            } else {
                freq.put(c, freq.get(c) + 1);
            }
        }

        return freq;
    }

    private Map<Character, Set<Integer>> getPossibleNumbersMap() {
        Map<Character, Set<Integer>> result = new HashMap<>();

        char[] alphabet = "ABCDEFGHIJKLMNOPQRSTUVWXYZ".toCharArray();
        for (char c : alphabet) {
            result.put(c, new HashSet<>());
        }

        for (int i = 0; i < numbers.length; i++) {
            for (char c : numbers[i].toCharArray()) {
                result.get(c).add(i);
            }
        }

        return result;
    }

    private String listToString(List<Integer> list) {
        StringBuilder builder = new StringBuilder();
        for (Integer i : list) {
            builder.append(i);
        }
        return builder.toString();
    }
}