package GCJ2016.round1B.problemB;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class Main {

    public static void main(String[] args) throws Exception {
        new Main();
    }

    public Main() throws Exception {
        solve();
    }

    private void solve() throws Exception {
        System.out.println(">>> Input: ");
        Scanner sc = new Scanner(System.in);
        BufferedWriter out = new BufferedWriter(new FileWriter("output.txt"));

        int test_cases = sc.nextInt();

        for (int test_case = 1; test_case <= test_cases; test_case++) {
            String c = sc.next();
            String j = sc.next();

            String result = "Case #" + test_case + ": " + getResult(c, j);
            out.write(result + "\n");
            System.out.println(result);
        }

        out.flush();
        out.close();
        sc.close();
    }

    private String getResult(String cScore, String jScore) {
        int[] cList = stringToArray(cScore);
        int[] jList = stringToArray(jScore);

        Pair result = getResult(0, cList, jList);

        StringBuilder builder = new StringBuilder();
        for (int i : result.v1) {
            builder.append(i);
        }
        builder.append(" ");
        for (int i : result.v2) {
            builder.append(i);
        }
        return builder.toString();
    }

    private Pair getResult(int index, int[] cList, int[] jList) {
        if (index == cList.length) {
            return new Pair(cList.clone(), jList.clone());
        }
        if (cList[index] == -1 & jList[index] == -1) {
            int cVal = 0;
            int jVal = 0;
            int mult = 1;
            for (int i = index - 1; i >= 0; i--) {
                cVal += cList[i] * mult;
                jVal += jList[i] * mult;
                mult *= 10;
            }
            if (cVal < jVal) {
                cList[index] = 9;
                jList[index] = 0;
                return getResult(index + 1, cList, jList);
            } else if (cVal > jVal) {
                cList[index] = 0;
                jList[index] = 9;
                return getResult(index + 1, cList, jList);
            } else {
                cList[index] = 0;
                jList[index] = 0;
                Pair res = getResult(index + 1, cList.clone(), jList.clone());
                int minDist = distance(res.v1, res.v2);

                jList[index] = 1;
                Pair resJ = getResult(index + 1, cList.clone(), jList.clone());
                int dist = distance(resJ.v1, resJ.v2);
                if (dist < minDist) {
                    minDist = dist;
                    res = resJ;
                }

                cList[index] = 1;
                jList[index] = 0;
                Pair resC = getResult(index + 1, cList.clone(), jList.clone());
                dist = distance(resC.v1, resC.v2);
                if (dist < minDist) {
                    minDist = dist;
                    res = resC;
                }

                return res;
            }
        }
        if (cList[index] == -1) {
            Set<Integer> poss = new HashSet<>();
            int[] possArray = {0, 9, (jList[index] + 9) % 10, jList[index], (jList[index] + 1) % 10};
            for (int i : possArray) {
                poss.add(i);
            }

            int minDist = Integer.MAX_VALUE;
            int num = Integer.MAX_VALUE;
            Pair res = null;

            for (int i : poss) {
                cList[index] = i;
                Pair res2 = getResult(index + 1, cList.clone(), jList.clone());
                int dist = distance(res2.v1, res2.v2);
                if (dist < minDist || (dist == minDist && i < num)) {
                    minDist = dist;
                    num = i;
                    res = res2;
                }
            }

            return res;
        }
        if (jList[index] == -1) {
            Set<Integer> poss = new HashSet<>();
            int[] possArray = {0, 9, (cList[index] + 9) % 10, cList[index], (cList[index] + 1) % 10};
            for (int i : possArray) {
                poss.add(i);
            }
            int minDist = Integer.MAX_VALUE;
            int num = Integer.MAX_VALUE;
            Pair res = null;

            for (int i : poss) {
                jList[index] = i;
                Pair res2 = getResult(index + 1, cList.clone(), jList.clone());
                int dist = distance(res2.v1, res2.v2);
                if (dist < minDist || (dist == minDist && i < num)) {
                    minDist = dist;
                    num = i;
                    res = res2;
                }
            }

            return res;
        }
        return getResult(index + 1, cList, jList);
    }

    private int distance(int[] cList, int[] jList) {
        int c = 0;
        int j = 0;
        int mult = 1;
        for (int i = cList.length-1; i >= 0; i--) {
            c += cList[i] * mult;
            j += jList[i] * mult;
            mult *= 10;
        }
        return Math.abs(c - j);
    }

    private int[] stringToArray(String s) {
        int[] list = new int[s.length()];
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '?') {
                list[i] = -1;
            } else {
                list[i] = Character.getNumericValue(s.charAt(i));
            }
        }
        return list;
    }

    private class Pair {
        int[] v1;
        int[] v2;

        public Pair(int[] v1, int[] v2) {
            this.v1 = v1;
            this.v2 = v2;
        }
    }
}