package GCJ2016.qualiticationRound.problemA;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.BitSet;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws Exception {
        new Main();
    }

    public Main() throws Exception {
        solve();
    }

    private void solve() throws Exception {
        System.out.println(">>> Input: ");
        Scanner sc = new Scanner(System.in);
        BufferedWriter out = new BufferedWriter(new FileWriter("output.txt"));

        int test_cases = sc.nextInt();

        for (int test_case = 1; test_case <= test_cases; test_case++) {
            int n = sc.nextInt();

            String result = "Case #" + test_case + ": " + getResult(n);
            out.write(result + "\n");
            System.out.println(result);
        }

        out.flush();
        out.close();
        sc.close();
    }

    private String getResult(int n) {
        if (n == 0) {
            return "INSOMNIA";
        }

        long result = n;
        BitSet seen = new BitSet(10);
        setDigits(seen, n);

        while (seen.cardinality() < 10) {
            result += n;
            setDigits(seen, result);
        }

        return Long.toString(result);
    }

    private void setDigits(BitSet seen, long number) {
        long n = number;
        int digit;
        while (n > 0) {
            digit = (int) (n % 10);
            n /= 10;
            seen.set(digit);
        }
    }
}