package GCJ2016.qualiticationRound.problemB;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.BitSet;
import java.util.Scanner;

public class Main {

    public static void main(String[] args) throws Exception {
        new Main();
    }

    public Main() throws Exception {
        solve();
    }

    private void solve() throws Exception {
        System.out.println(">>> Input: ");
        Scanner sc = new Scanner(System.in);
        BufferedWriter out = new BufferedWriter(new FileWriter("output.txt"));

        int test_cases = sc.nextInt();

        for (int test_case = 1; test_case <= test_cases; test_case++) {
            String s = sc.next();
            BitSet set = new BitSet(s.length());
            for (int i = 0; i < s.length(); i++) {
                set.set(i, s.charAt(i) == '+');
            }

            String result = "Case #" + test_case + ": " + getResult(set, s.length());
            out.write(result + "\n");
            System.out.println(result);
        }

        out.flush();
        out.close();
        sc.close();
    }

    private String getResult(BitSet set, int length) {
        int count = 0;
        for (int i = 1; i < length; i++) {
            if (set.get(i-1) != set.get(i)){
                flip(set, i);
                count++;
            }
        }

        if (length > 0 && !set.get(0)) {
            count++;
        }

        return Integer.toString(count);
    }

    private void flip(BitSet set, int nr) {
        for (int i = 0; i < nr; i++) {
            set.flip(i);
        }
    }
}