package ca.heavycooler.problem1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

import lombok.SneakyThrows;

public class CountingSheep {

	@SneakyThrows
	public static void main(String[] args) {
		String inputFile = args[0];
		String outFile = args[1];
		
		CountingSheep countingSheep = new CountingSheep();
		
	    Scanner in = new Scanner(new BufferedReader(new FileReader(inputFile)));
	    PrintWriter out = new PrintWriter(new FileWriter(outFile));
	    
	    int t = in.nextInt();  // Read # test cases
	    for (int i = 1; i <= t; ++i) {
	      int n = in.nextInt();
	      try {
	    	  long value = countingSheep.computeLastNumber(n);
	    	  out.println("Case #" + i + ": " + Long.toString(value));
	      } catch (Exception e) {
	    	  out.println("Case #" + i + ": INSOMNIA");
	      }
	    }
	    in.close();
	    out.flush();
	    out.close();
	  }
	
	public long computeLastNumber(int N) {
		if(N == 0) {
			throw new RuntimeException("Never halts");
		}

		// Direct hashing
		int [] digitSet = new int[10];
		long product = N;
		
		for(long counter = 1; !complete(digitSet); counter++) {
			product = counter * N;
			String productString = Long.toString(product);

			for(int i = 0; i < productString.length(); i++) {
				int digit = Integer.parseInt(productString.substring(i, i+1));
				digitSet[digit] = 1;
			}
		}
		
		return product;
	}

	private boolean complete(int[] digitSet) {
		for(int i = 0; i < digitSet.length; i++) {
			if(digitSet[i] == 0) {
				return false;
			}
		}
		return true;
	}

}
