package codeJam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class ProblemA {

	public static long findMin(String numRep) {
		Map<Character, Integer> repMap = new HashMap<Character, Integer>();

		// First find # of symbols
		int numSymbols = 0;
		for(int i = 0; i < numRep.length(); i++) {
			char symbol = numRep.charAt(i);
			if(repMap.get(symbol) == null) {
				numSymbols++;
				repMap.put(symbol, new Integer(-1));
			}
		}
		
		// Determine minimum base
		int minBase = Math.max(2, numSymbols);
		
		int currentDigit = numRep.length()-1;
		int currentBaseDigits = 1;
		
		boolean usedZero = false;
		long retVal = 0;
		// Assign symbols from left to right
		for(int i = 0; i < numRep.length(); i++) {
			char symbol = numRep.charAt(i);
			int value = repMap.get(symbol);
			if(value == -1) {
				if(!usedZero && i != 0) {
					value = 0;
					usedZero = true;
				} else
					value = currentBaseDigits++;
				repMap.put(symbol, value);
			}
			retVal += value * Math.pow(minBase, currentDigit--);
		}
		// Return value
		return retVal;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader input;
		BufferedWriter output;
		try {
			input = new BufferedReader(new FileReader(args[0]));
			output = new BufferedWriter(new FileWriter(args[1]));

			int T = Integer.parseInt(input.readLine());
			
			for(int i = 0; i < T; i++) {
				String num = input.readLine();
				long minVal = findMin(num);
				output.write("Case #" + (i+1) + ": " + minVal);
				output.newLine();
			}
			output.flush();
			output.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
