package codeJam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class MinimumScalarProduct {
	public static int getMinSP(int []x, int []y) {
		// We have to run through all the permutations of x, do the sp with y
		// and check if this is minimum
		
		int initSP = 0;
		for(int i = 0; i < x.length; i++) {
			initSP += x[i] * y[i];
		}
		return getMinSPRecurse(x, y, 0, 0, 0);		
	}
	
	public static int getMinSPRecurse(int []x, int []y, int sp, int used, int depth) {
		int minSP = 1;
		boolean firstSP = true;
		
		if(depth == x.length)
			return sp;
		
		for(int i = 0; i < x.length; i++) {
			if(0 == (used & (1<<i))) {	// Check if this is used in perm already
				int tmpSP = getMinSPRecurse(x, y, sp + x[i] * y[depth], used | (1 << i), depth+1);
				if(tmpSP < minSP || firstSP) {
					minSP = tmpSP;
					firstSP = false;
				}
			}
		}
				
		return minSP;	
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		 try {
		        BufferedReader in = new BufferedReader(new FileReader(args[0]));
		        BufferedWriter out = new BufferedWriter(new FileWriter(args[1]));
		        int testCases = Integer.parseInt(in.readLine());
		        for(int i = 0; i < testCases; i++) {
		        	int vecSize = Integer.parseInt(in.readLine());
		        	
		        	String xString = in.readLine();
		        	String yString = in.readLine();
		        	int [] xp  = new int[vecSize];
		        	int [] yp = new int[vecSize];
		        	String [] xStrings = xString.split(" ");
		        	String [] yStrings = yString.split(" ");
		        	for(int j = 0; j < vecSize; j++) {
		        		xp[j] = Integer.parseInt(xStrings[j]);
		        		yp[j] = Integer.parseInt(yStrings[j]);
		        	}
		        	
		        	int minSP = getMinSP(xp, yp);
		        			        	
		        	out.write("Case #" + Integer.toString(i+1) + ": " + minSP);
		        	
		        	if((i+1) < testCases)
		        		out.newLine();
		        }
		        out.flush();
		        out.close();
		        in.close();
		    } catch (IOException e) {
		    }
	}
}
