package codeJam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;

public class Welcome {

	private static final String target = "welcome to code jam";
	private static final int targetLength = target.length();
	
	public static int computeCombinations(String testString) {
		
		final int testLength = testString.length();
		int [][] scratch = new int[targetLength][testString.length()];
		// Initialize scratch space
		for(int i = 0; i < targetLength; i++) {
			scratch[i][0] = 0;
		}
		scratch[targetLength-1][0] = (target.charAt(targetLength-1) == testString.charAt(testLength-1)) ? 1 : 0;
		
//		scratch[0][0] = (testString.charAt(testLength-1) == target.charAt(targetLength-1)) ? 1 : 0;
		for(int j = 1; j < testLength; j++) {
			scratch[targetLength-1][j] = scratch[targetLength-1][j-1] + ((testString.charAt(testLength-j-1) == target.charAt(targetLength-1)) ? 1 : 0);
		}
		
		for(int i = 1; i < targetLength; i++) { // last i-characters of target
			String huntString = target.substring(targetLength-i-1, targetLength);
			for(int j = 1; j < testLength; j++) { // in the last j characters of test string
				if(testString.charAt(testLength - 1 - j) == target.charAt(targetLength - i - 1)) {
					scratch[targetLength-i-1][j] = scratch[targetLength-i-1][j-1] + scratch[targetLength-i][j-1];
				} else {
					scratch[targetLength-i-1][j] = scratch[targetLength-i-1][j-1];
				}
				scratch[targetLength-i-1][j] = scratch[targetLength-i-1][j] % 10000;
			}
		}
		return scratch[0][testString.length()-1];
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader input;
		BufferedWriter output;
		try {
			input = new BufferedReader(new FileReader(args[0]));
			output = new BufferedWriter(new FileWriter(args[1]));
			int N = Integer.parseInt(input.readLine());
			
			for(int n = 0; n < N; n++) {
				output.write("Case #" + (n+1) + ": ");
				String testString = input.readLine();
//				testString = testString.toLowerCase();
				int last4 = computeCombinations(testString);
				DecimalFormat df = new DecimalFormat("0000");
				output.write(df.format(last4));
				output.newLine();
			}
			
			output.flush();
			output.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
