package codeJam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class SavingTheUniverse {

	public static int getNumberOfSwitches(List<String> engines, String [] queries) {
		int switchCount = 0;
		
		Set<String> availableEngine = new HashSet<String>(engines.size());
		availableEngine.addAll(engines);
		
		// Searching forward through queries, find the engine which appears last
		// or not at all.
		for(int i = 0; i < queries.length; i++) {
			if(availableEngine.contains(queries[i])) {
				availableEngine.remove(queries[i]);
			}
			
			if(availableEngine.size() == 0) {
				switchCount++;
				availableEngine.addAll(engines);
				availableEngine.remove(queries[i]);
			}
		}
				
		return switchCount;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		 try {
		        BufferedReader in = new BufferedReader(new FileReader(args[0]));
		        BufferedWriter out = new BufferedWriter(new FileWriter(args[1]));
		        int testCases = Integer.parseInt(in.readLine());
		        for(int i = 0; i < testCases; i++) {
		        	int numEngines = Integer.parseInt(in.readLine());
		        	
		        	List<String> engines = new ArrayList<String>(numEngines);
		        	for(int j = 0; j < numEngines; j++) {
		        		engines.add(in.readLine());
		        	}
		        	
		        	int numQueries = Integer.parseInt(in.readLine());
		        	String []queries = new String[numQueries];
		        	for(int j = 0; j < numQueries; j++) {
		        		queries[j] = in.readLine();
		        	}

		        	int switches = getNumberOfSwitches(engines, queries);
		        	
		        	out.write("Case #" + Integer.toString(i+1) + ": " + switches);
		        	
		        	if((i+1) < testCases)
		        		out.newLine();
		        }
		        out.flush();
		        out.close();
		        in.close();
		    } catch (IOException e) {
		    }
	}

}
