import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;
import java.io.*;

public class Universe {

	private List<String> engines;
	private BufferedReader inFile;
	private FileWriter outFile;
	private int minSwitches;
	
	public Universe(String inFileName, String outFileName)
	{
		engines = new ArrayList<String>();
		try {
			parseInput(inFileName, outFileName);
		} catch(IOException e) {}
		
    }
	
	private void parseInput(String inFileName, String outFileName) throws IOException
	{
		inFile =  new BufferedReader(new FileReader(inFileName));
		outFile = new FileWriter(outFileName);
		int numCases = Integer.parseInt(inFile.readLine());
		for(int i = 0; i < numCases; i++)
		{
			System.out.println(i + " of " + numCases);
			minSwitches = -1;
			engines = new ArrayList<String>();
			List<String> queries = new ArrayList<String>();
			int numEngines = Integer.parseInt(inFile.readLine());
			for(int j = 0; j < numEngines; j++)
			{
				engines.add(inFile.readLine());
			}
			int numQueries = Integer.parseInt(inFile.readLine());
			for(int j = 0; j < numQueries; j++)
			{
				queries.add(inFile.readLine());
			}
			outFile.write("Case #" + (i+1) + ": " + numSwitches(queries, 0));
			outFile.write("\r\n");
		}		
		outFile.close();
	}
	
	private int numSwitches(List<String> queries, int numSoFar)
	{
		if(queries.size() == 0)
			return numSoFar;
		int maxIndex = 0;
		for(String engine: engines)
		{
			int index = queries.indexOf(engine);
			if(index == -1)
				return numSoFar;
			if(index > maxIndex)
			{
				maxIndex = index;
			}
		}
		return numSwitches(queries.subList(maxIndex, queries.size()), numSoFar+1);
	}

	public static void main(String[] args)
	{
		Universe universe = new Universe("C:\\Documents and Settings\\Me\\Desktop\\A-small-attempt4.in", "C:\\Documents and Settings\\Me\\Desktop\\A-small-attempt4.out");
	}
}