package codejam.round2016.qualification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

public class PCCoinJamBig {
	private static int N, J, TC;
	
	private static String next(String s) {
		int len = s.length();
		char[] arr = s.toCharArray();
		
		int c = 1;
		for (int i = len-2; i >= 1 && c == 1; i--) {
			if (arr[i] == '0') {
				arr[i] = '1';
				c = 0;
			} else {
				arr[i] = '0';
				c = 1;
			}
		}
		
		return new String(arr);
	}
	
	private static BigInteger primeFactor(BigInteger a) {
		BigInteger p = new BigInteger("2");
		boolean ok = true;
		int cnt = 0;
		while (ok) {
			if (a.gcd(p).equals(p))
				break;
			p = p.nextProbablePrime();
			if (cnt++ > 500) 
				ok = false;
		}
		
		return ok? p : a;
	}
	
	private static ArrayList<BigInteger> getFactors(String s) {
		
		ArrayList<BigInteger> factors = new ArrayList<>();
		
		boolean ok = true;
		for (int i = 2; i <= 10; i++) {
			BigInteger a = new BigInteger(s, i);
			if (a.isProbablePrime(30)) {
				ok = false;
				break;
			}
		}
		
		if (!ok) return factors;
		for (int i = 2; i <= 10; i++) {
			BigInteger a = new BigInteger(s, i);
			BigInteger p = primeFactor(a);
			
			if (p.equals(a)) break; // cannot find prime factor
			else factors.add(p); // add to list factor
		}
		
		return factors;
	}
	
	public static void main(String[] args) {
		Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		
		TC = sc.nextInt();
		for (int t = 1; t <= TC; t++) {
			N = sc.nextInt(); // nb digits
			J = sc.nextInt(); // nb CoinJam to find
			
			char[] a = new char[N];
			for (int i = 0; i< N; i++)
				a[i] = '0';
			a[0] = '1'; a[N-1] = '1';
			String s = new String(a);
			
			System.out.printf("Case #%d:\n",t);
			int cnt = 0; 
			while (cnt < J) {
				ArrayList<BigInteger> factors = getFactors(s);
				if (factors.size() == 9) {
					System.out.print(s);
					for (int i = 0; i < 9; i++)
						System.out.print(" " + factors.get(i).toString());
					System.out.println();
					cnt++;
				}
				s = next(s);
				//System.out.println(s);
			}
			
		}
		
		sc.close();
	}
}
