package codejam.round2016.qualification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.BitSet;
import java.util.HashMap;
import java.util.Queue;
import java.util.Scanner;

/*
 * Small problem
 */
public class PBRevengeOfThePancakes {
	
/*
5
--+----+----+----+
-+---+---+---+---+
+---+---+---+---+-
+++-+++-+++-+++-++
--+---+---+---+---
*/
	
	private static HashMap<BitSet, Integer> dis;
	private static int TC, N;
	private static String S;
	
	private static BitSet flip(BitSet bs, int n) {
		BitSet re = (BitSet) bs.clone();
		re.flip(0, n);
		for (int i = 0; i < n/2; i++) {
			boolean tmp = re.get(i);
			re.set(i, re.get(n-1 - i));
			re.set(n-1 - i, tmp);
		}
		return re;
	}
	
	private static int bfs(BitSet bs) {
		dis = new HashMap<>(2000);
		dis.put(bs, 0);
		
		Queue<BitSet> queue = new ArrayDeque<>();
		queue.add(bs);
		int ans = 0;
		
		while (!queue.isEmpty()) {
			BitSet bset = queue.poll();
			Integer d = dis.get(bset);
			//System.out.println(bset + " " + d);
			
			// attention flip bit from 1 to N
			for (int i = 1; i <= N; i++) {
				BitSet fbset = flip(bset, i);
				
				Integer fd = dis.get(fbset);
				if (fd == null) {
					dis.put(fbset, d + 1);
					queue.add(fbset);
					// out when reach destination
					if (fbset.cardinality() == N) {
						ans = d+1;
						//System.out.println("ans:" + ans);
						break;
					}
				}
				
			}
		}
		
		return ans;
	}
	
	public static void main(String[] args) {
		Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		TC = sc.nextInt();
		for (int t = 1; t <= TC; t++) {
			// read string
			S = sc.next();
			N = S.length();
			
			// init data
			BitSet bs = new BitSet(N);
			for (int i = 0; i < N; i++)
				if (S.charAt(i) == '+')
					bs.set(i);
			
//			// test
//			System.out.println(S);
//			System.out.println(bs);
//			System.out.println(flip(bs, N >2 ? 3: 1));
			
			System.out.printf("Case #%d: %d\n", t, bfs(bs));
			
		}
		
		
		sc.close();
	}
}
