package round1B;

import java.util.PriorityQueue;
import java.util.Scanner;





public class B {

    static class Color implements Comparable<Color> {
        int c;
        int f;

        Color(int c, int f) {
            this.c = c;
            this.f = f;
        }

        @Override
        public int compareTo(Color o) {
            return -(this.f - o.f);
        }

        @Override
        public String toString() {
            return c + " " + f;
        }
    }

    private static boolean close(Color a, Color b) {
        return Math.abs(a.c - b.c) == 1 || (a.c == 0 && b.c == 5) || (b.c == 0 && a.c == 5);
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int T = sc.nextInt();
        for (int t = 1; t <= T; t++) {
            // R, O, Y, G, B, V
            //int R = 0, O = 1, Y = 2, G = 3, B = 4, V = 5;
            String[] map = new String[]{"R", "O", "Y", "G", "B", "V"};


            int n = sc.nextInt();
            int[] freq = new int[6];
            for (int i = 0; i < freq.length; i++) {
                freq[i] = sc.nextInt();
            }

            PriorityQueue<Color> pq = new PriorityQueue<>();
            for (int i = 0; i < freq.length; i++) {
                if (freq[i] > 0) pq.add(new Color(i, freq[i]));
            }

            Color prev = new Color(-2, -2);
            String re = "";
            while (!pq.isEmpty()) {
                Color k = pq.poll();
                if (!close(k, prev)) {
                    re += map[k.c];

                    if (prev.f > 0)
                        pq.add(prev);

                    k.f--;
                    prev = k;
                } else {
                    System.out.println("not implemented");
                }
            }

            if (re.length() >= 3 && re.charAt(0) == re.charAt(re.length()-1)) {
                char c1 = re.charAt(re.length()-1);
                char c2 = re.charAt(re.length()-2);
                char c3 = re.charAt(re.length()-3);
                if (c3 != c1) {
                    re = re.substring(0, re.length() - 2) + c1 + c2;
                }
            }

            System.out.printf("Case #%d: %s\n", t,
                    re.length() != n || re.charAt(0) == re.charAt(re.length()-1)? "IMPOSSIBLE" : re );
        }


        sc.close();
    }

}
