package round1C;

import java.util.Arrays;
import java.util.Scanner;

/**
 * Created by ThanhKM on 30/04/2017.
 */
public class A {

    private static class Cake implements Comparable<Cake>{
        int r, h;
        Cake(int r, int h) {
            this.r = r;
            this.h = h;
        }

        public double border() {
            return Math.PI * 2 * r * h;
        }

        public double surface() {
            return Math.PI * r * r;
        }

        @Override
        public int compareTo(Cake o) {
            return r == o.r? h - o.h: r - o.r;
        }

        @Override
        public String toString() {
            return r + " " + h;
        }
    }

    static int N, K;
    static Cake[] cakes;
    static double [][] memo;

    private static double buildCake(int i, int k) {
        if (k == K) return 0;
        if (i == N) return -10e9;

        if (memo[i][k] != -1)
            return memo[i][k];

        double notChoose = buildCake(i+1, k);
        double choose = cakes[i].border() + buildCake(i+1, k+1);
        choose += k+1== K ? cakes[i].surface(): 0; // choose cake i

        return memo[i][k] = Math.max(choose, notChoose);
    }

    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        int T = sc.nextInt();
        for (int t = 1; t <= T; t++) {
            N = sc.nextInt();
            K = sc.nextInt();

            cakes = new Cake[N];
            for (int i = 0; i< N; i++) {
                cakes[i] = new Cake(sc.nextInt(), sc.nextInt());
            }

            Arrays.sort(cakes);

//            double result = cakes[N-1].surface() + cakes[N-1].border();
//            System.out.println(cakes[N-1]);
//            N--; K--;

            double result = 0;
            memo = new double[N][K];
            for (int i = 0; i < N; i++) {
                Arrays.fill(memo[i], -1);
            }
            result = buildCake(0, 0);

            //Case #1: 138230.076757951
            System.out.printf("Case #%d: %.10f\n", t, result);

        }



        sc.close();
    }


}
