import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.*;

public class Main {
	public static void main(String[] args) throws FileNotFoundException {
		InputReader in = new InputReader(new FileInputStream("input.txt"));
		PrintWriter out = new PrintWriter(new FileOutputStream("output.txt"));
		int T = in.nextInt();
		for (int i = 1; i <= T; i++) {
			solve(i, in, out);
		}
		out.close();
	}

	private static void solve(int t, InputReader in, PrintWriter out) {
		double c = in.nextDouble();
		double f = in.nextDouble();
		double x = in.nextDouble();
		double answer = Double.MAX_VALUE;
		double time = 0; double p = 2;
		while (time < answer) {
			answer = Math.min(answer, time + x / p);
			time += c / p;
			p += f;
		}
		out.println("Case #" + new Integer(t).toString() + ": " + answer);
	}
}


class InputReader {
	public BufferedReader reader;
	public StringTokenizer tokenizer;

	public InputReader(InputStream stream) {
		reader = new BufferedReader(new InputStreamReader(stream));
		tokenizer = null;
	}
	public String nextLine() throws IOException {
		return reader.readLine();
	}
	public String next() {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			try {
				tokenizer = new StringTokenizer(reader.readLine());
			} catch (IOException e) {
				throw new RuntimeException(e);
			}
		}
		return tokenizer.nextToken();
	}
	
	public double nextDouble() {
		return Double.parseDouble(next());
	}
	
	public long nextLong() {
		return Long.parseLong(next());
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}
}