package q2;
import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class Cookie {

	static DecimalFormat DF = new DecimalFormat("0.000",new DecimalFormatSymbols(Locale.ENGLISH));
	
	public static void run() throws Exception {
		
		init("B-small");
		
		int cases = INT();
        int GRIDROWS = 4;
        
		for(int cc = 1;cc<=cases;cc++) {
            String CFX = LINE();
            String[] CFXSplit = CFX.split("\\s+");
            double C = Double.parseDouble(CFXSplit[0]);
            double F = Double.parseDouble(CFXSplit[1]);
            double X = Double.parseDouble(CFXSplit[2]);

            int count = 0;
            double rate = 2.0;
            double previousTotalTimeToComplete = 0.3;
            double timeToCompleteDuringThisRound = 0.0;
            double timeToNextFactory = 0.0;
            double currentTime = 0.0;
            double totalTimeToComplete = 0.0;
            boolean completeIsFaster = false;
            DecimalFormat df = new DecimalFormat("#######.#######");

            while(!completeIsFaster) {
                previousTotalTimeToComplete = totalTimeToComplete;
                timeToCompleteDuringThisRound = (X / rate);
                totalTimeToComplete = currentTime + timeToCompleteDuringThisRound;
                timeToNextFactory = (C / rate);

                /*
                println("\nrate = " + rate);
                println("currentTime = " + currentTime);
                println("timeToNextFactory = " + timeToNextFactory);
                println("timeToCompleteDuringThisRound = " + timeToCompleteDuringThisRound);
                println("previousTotalTimeToComplete = " + previousTotalTimeToComplete);
                println("totalTimeToComplete = " + totalTimeToComplete);
                */
                
                currentTime += timeToNextFactory;
                rate += F;
                            
                completeIsFaster = (previousTotalTimeToComplete > 0.0) && (previousTotalTimeToComplete <= totalTimeToComplete);
            }

            // F cookies per second.
            // Rate += F
            
			print("Case #"+cc+": ");
            println(df.format(previousTotalTimeToComplete));
		}
		
	}
	
	// *************************************************************************************
	// *********************************** FRAMEWORK ***************************************
	// *************************************************************************************
	
	public static BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
	public static boolean isStandardInput = false;
	
	public static File input;
	public static FileReader inputreader;
	public static BufferedReader in;
	
	public static File output;
	public static FileWriter outputwriter;
	public static BufferedWriter out;
	
	public static StringTokenizer st;
	
	public static void main(String[] args) throws Exception {
		doSTDIN(true);
		setOutput("test.out");
		run();
		close();
	}
	
	public static void init(String problemName) throws Exception {
		doSTDIN(false);
		setInput(problemName+".in");
		setOutput(problemName+".out");
	}
	
	// **************** PRINT METHODS **********************
	
	public static void println() throws IOException {
		out.write("\n");
		System.out.println();
	}
	
	public static void println(Object obj) throws IOException {
		out.write(obj.toString());
		out.write("\n");
		System.out.println(obj.toString());
	}
	
	public static void print(Object obj) throws IOException {
		out.write(obj.toString());
		System.out.print(obj.toString());
	}
	
	public static void println(long number) throws IOException {
		out.write(Long.toString(number));
		out.write("\n");
		System.out.println(number);
	}
	
	public static void print(long number) throws IOException {
		out.write(Long.toString(number));
		System.out.print(number);
	}
	
	public static void println(char c) throws IOException {
		out.write(Character.toString(c));
		out.write("\n");
		System.out.println(c);
	}
	
	public static void print(char c) throws IOException {
		out.write(Character.toString(c));
		System.out.print(c);
	}
	
	public static void println(String line) throws IOException {
		out.write(line);
		out.write("\n");
		System.out.println(line);
	}
	
	public static void print(String line) throws IOException {
		out.write(line);
		System.out.print(line);
	}
	
	// ******************** INPUT DECLARATION ******************
	
	public static void doSTDIN(boolean standard) {
		isStandardInput = standard;
	}
	
	public static void setInput(String filename) throws IOException {
		input = new File(filename);
		inputreader = new FileReader(input);
		in = new BufferedReader(inputreader);
	}
	
	public static void setOutput(String filename) throws IOException {
		output = new File(filename);
		outputwriter = new FileWriter(output);
		out = new BufferedWriter(outputwriter);
	}
	
	public static void close() throws IOException {
		if(in!=null)in.close();
		if(inputreader!=null)inputreader.close();
		
		if(out!=null)out.flush();
		if(out!=null)out.close();
		if(outputwriter!=null)outputwriter.close();
	}
	
	// ************************** INPUT READING *****************
	
	static String LINE() throws IOException { return isStandardInput?stdin.readLine():in.readLine(); }
	static String TOKEN() throws IOException {
		while (st == null || !st.hasMoreTokens())st = new StringTokenizer(LINE());
		return st.nextToken();
	}
	static int INT() throws IOException {return Integer.parseInt(TOKEN());}
	static long LONG() throws IOException {return Long.parseLong(TOKEN());}
	static double DOUBLE() throws IOException {return Double.parseDouble(TOKEN());}
	static BigInteger BIGINT() throws IOException {return new BigInteger(TOKEN());}
	
}
