package q3;
import java.io.*;
import java.util.*;
import java.math.*;
import java.text.*;

public class War {

	static DecimalFormat DF = new DecimalFormat("0.000",new DecimalFormatSymbols(Locale.ENGLISH));
	
	public static void run() throws Exception {
		
		init("D-large");
		
		int cases = INT();
        boolean debug = true;
        int stopper = 10;
        
		for(int cc = 1;cc<=cases;cc++) {
            
            int numBlocks = INT();
            String N = LINE();
            String K = LINE();
            
            int NWinsNormal = 0;
            int NWinsDeceit = 0;
            
            String[] NSplit = N.split("\\s+");
            String[] KSplit = K.split("\\s+");
            String[] NSplitNoRemoves = N.split("\\s+");
            String[] KSplitNoRemoves = K.split("\\s+");
            ArrayList<Double> NList = new ArrayList<Double>();
            ArrayList<Double> KList = new ArrayList<Double>();
            ArrayList<Double> NListNoRemoves = new ArrayList<Double>();
            ArrayList<Double> KListNoRemoves = new ArrayList<Double>();

            // Convert each list into doubles
            for(int i = 0; i < numBlocks; i++) {
                NList.add(new Double(NSplit[i]));
                KList.add(new Double(KSplit[i]));
                NListNoRemoves.add(new Double(NSplit[i]));
                KListNoRemoves.add(new Double(KSplit[i]));
            }
            
            // Sort each list
            Collections.sort(NList);
            Collections.sort(KList);
            Collections.reverse(NList);
            Collections.reverse(KList);
            Collections.sort(NListNoRemoves);
            Collections.sort(KListNoRemoves);
            
            
            // DWar: Naomi counts how many of her bricks can't beat any of Ken's

            if(debug && cc == stopper) {
                println("cc = " + cc);
                println("numBlocks = " + numBlocks);
                println(NListNoRemoves);
                println(KListNoRemoves);
            }

            // War: Naomi goes hi->log; Ken wins by small-as-possible-margins, loses by wide-as-possible-margins
            for(int i = 0; i < numBlocks; ++i) {
                
                if(NListNoRemoves.get(0) > KListNoRemoves.get(0)) {
                    NWinsDeceit++;
                    NListNoRemoves.remove(0);
                    KListNoRemoves.remove(0);
                } else {
                    NListNoRemoves.remove(0);
                }

                if(NList.get(0) > KList.get(0)) {
                    KList.remove(KList.size() - 1);
                    NWinsNormal++;
                } else {
                    KList.remove(0);
                }
                NList.remove(0);
            }

            if(!debug || (debug && cc == stopper)) {
                println("Case #"+cc+": " + NWinsDeceit + " " + NWinsNormal);
            }
		}
		
	}
	
	// *************************************************************************************
	// *********************************** FRAMEWORK ***************************************
	// *************************************************************************************
	
	public static BufferedReader stdin = new BufferedReader(new InputStreamReader(System.in));
	public static boolean isStandardInput = false;
	
	public static File input;
	public static FileReader inputreader;
	public static BufferedReader in;
	
	public static File output;
	public static FileWriter outputwriter;
	public static BufferedWriter out;
	
	public static StringTokenizer st;
	
	public static void main(String[] args) throws Exception {
		doSTDIN(true);
		setOutput("test.out");
		run();
		close();
	}
	
	public static void init(String problemName) throws Exception {
		doSTDIN(false);
		setInput(problemName+".in");
		setOutput(problemName+".out");
	}
	
	// **************** PRINT METHODS **********************
	
	public static void println() throws IOException {
		out.write("\n");
		System.out.println();
	}
	
	public static void println(Object obj) throws IOException {
		out.write(obj.toString());
		out.write("\n");
		System.out.println(obj.toString());
	}
	
	public static void print(Object obj) throws IOException {
		out.write(obj.toString());
		System.out.print(obj.toString());
	}
	
	public static void println(long number) throws IOException {
		out.write(Long.toString(number));
		out.write("\n");
		System.out.println(number);
	}
	
	public static void print(long number) throws IOException {
		out.write(Long.toString(number));
		System.out.print(number);
	}
	
	public static void println(char c) throws IOException {
		out.write(Character.toString(c));
		out.write("\n");
		System.out.println(c);
	}
	
	public static void print(char c) throws IOException {
		out.write(Character.toString(c));
		System.out.print(c);
	}
	
	public static void println(String line) throws IOException {
		out.write(line);
		out.write("\n");
		System.out.println(line);
	}
	
	public static void print(String line) throws IOException {
		out.write(line);
		System.out.print(line);
	}
	
	// ******************** INPUT DECLARATION ******************
	
	public static void doSTDIN(boolean standard) {
		isStandardInput = standard;
	}
	
	public static void setInput(String filename) throws IOException {
		input = new File(filename);
		inputreader = new FileReader(input);
		in = new BufferedReader(inputreader);
	}
	
	public static void setOutput(String filename) throws IOException {
		output = new File(filename);
		outputwriter = new FileWriter(output);
		out = new BufferedWriter(outputwriter);
	}
	
	public static void close() throws IOException {
		if(in!=null)in.close();
		if(inputreader!=null)inputreader.close();
		
		if(out!=null)out.flush();
		if(out!=null)out.close();
		if(outputwriter!=null)outputwriter.close();
	}
	
	// ************************** INPUT READING *****************
	
	static String LINE() throws IOException { return isStandardInput?stdin.readLine():in.readLine(); }
	static String TOKEN() throws IOException {
		while (st == null || !st.hasMoreTokens())st = new StringTokenizer(LINE());
		return st.nextToken();
	}
	static int INT() throws IOException {return Integer.parseInt(TOKEN());}
	static long LONG() throws IOException {return Long.parseLong(TOKEN());}
	static double DOUBLE() throws IOException {return Double.parseDouble(TOKEN());}
	static BigInteger BIGINT() throws IOException {return new BigInteger(TOKEN());}
	
}
