
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author T7639192
 */
public class StringPattern {
	private StringPatternCharacter[] letter;

	public StringPattern(String string) {
		ArrayList<StringPatternCharacter> lettersList = new ArrayList<>();
		if(string.length() > 0){
			StringPatternCharacter lastChar = new StringPatternCharacter(string.charAt(0));
			lettersList.add(lastChar);
			for(int i = 1; i < string.length(); i++){
				if(string.charAt(i) != lastChar.getLetter()){
					lastChar = new StringPatternCharacter(string.charAt(i));
					lettersList.add(lastChar);
				}
			}
		}
		this.letter = new StringPatternCharacter[lettersList.size()];
		this.letter = lettersList.toArray(this.letter);
	}
	
	public boolean fits(String str){
		if(letter.length == 0){
			return str.length() == 0;
		}
		if(str.length() == 0){
			return letter.length == 0;
		}
		if(str.charAt(0) != letter[0].getLetter()){
			return false;
		}
		int lastFound = 0;
		int counter = 0;
		for(int i = 0; i < str.length(); i++){
			if(str.charAt(i) != letter[lastFound].getLetter()){
				if(lastFound >= letter.length-1) return false;
				if(str.charAt(i) != letter[lastFound+1].getLetter()) return false;
				letter[lastFound].addLen(counter);
				lastFound++;
				counter = 0;
			}
			counter++;
		}
		if(lastFound != letter.length - 1) return false;
		letter[lastFound].addLen(counter);
		return true;
	}
	
	public int getSteps(){
		int steps = 0;
		int size = this.letter.length;
		for(int i = 0; i < size; i++){
			steps += this.letter[i].getSteps();
		}
		return steps;
	}
	
	public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException{
		final Scanner in = new Scanner(new File("C:\\Users\\T7639192\\Desktop\\תלפיות\\סמסטר ד\\אחר\\Google Code Jam\\GCJ_R1b_1\\src\\A-small-attempt0.in"));
		PrintWriter writer = new PrintWriter("C:\\Users\\T7639192\\Desktop\\תלפיות\\סמסטר ד\\אחר\\Google Code Jam\\GCJ_R1b_1\\src\\output.out", "UTF-8");
		int T = in.nextInt();
		String str;
		StringPattern strp;
		for (int caseNum = 1; caseNum <= T; caseNum++) {
			int N = in.nextInt();
			str = in.next();
			strp = new StringPattern(str);
			strp.fits(str);
			boolean fegla = false;
			for(int i = 1; i < N && !fegla; i++){
				if(!strp.fits(in.next())){
					writer.println("Case #" + caseNum + ": Fegla Won");
					fegla = true;
				}
			}
			if(!fegla)
				writer.println("Case #" + caseNum + ": " + strp.getSteps());
		}
		writer.close();
	}
	
	public class StringPatternCharacter {
	private char letter;
	private List<Integer> strLengths;

	public StringPatternCharacter(char letter) {
		this.letter = letter;
		this.strLengths = new ArrayList<>();
	}
	
	public char getLetter() {
		return this.letter;
	}
	
	public void addLen(int len){
		this.strLengths.add(len);
	}
	
	public int getAvg(){
		float sum = 0;
		int size = this.strLengths.size();
		for(int i = 0; i < size; i++){
			sum += this.strLengths.get(i);
		}
		float avg = sum / size;
		return Math.round(avg);
	}
	
	public int getSteps(){
		int avg = this.getAvg();
		int size = this.strLengths.size();
		int steps = 0;
		for(int i = 0; i < size; i++){
			steps += Math.abs(this.strLengths.get(i)-avg);
		}
		return steps;
	}
	
}
}
