/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GCJ;

import java.io.IOException;

/**
 *
 * @author t7639192
 */
public class ProblemC extends GCJSolver {

	/**
	 * @param args the command line arguments
	 */
	public static void main(String[] args) {
		try {
			FileHandler fh = new FileHandler("C-large.in", "C-large.out", 2);
			fh.solveAll(new ProblemC());
			fh.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	private final Quanterion I = new Quanterion(Root.i);
	private final Quanterion J = new Quanterion(Root.j);
	private final Quanterion K = new Quanterion(Root.k);

	@Override
	public String[] solve(String[] input) throws IOException {
		String[] values = input[0].split(" ");
		boolean flag = true;
		for (int i = 0; i < input[1].length(); i++) {
			if (input[1].charAt(i) != input[1].charAt(0)) {
				flag = false;
			}
		}
		if (flag) {
			return new String[]{"NO"};
		}

		LoopString string = new LoopString(input[1], Long.parseLong(values[1]));
		if (string.length() < 3) {
			return new String[]{"NO"};
		}

		Quanterion leftPart = new Quanterion();
		Quanterion middlePart = new Quanterion(input[1].charAt(0));
		Quanterion rightPart = string.eval();

		if (!rightPart.equals(new Quanterion(Root.o, true))) {
			return new String[]{"NO"};
		}

		rightPart = middlePart.clone().inverse().times(rightPart);
		Quanterion temp = rightPart.clone();

		for (int i = 0; i < Math.min(4 * string.getL(), string.length() - 2); i++) {
			leftPart = leftPart.times(new Quanterion(string.charAt(i)));
			middlePart = (new Quanterion(string.charAt(i))).inverse().times(middlePart);
			for (int j = i + 1; j < Math.min(i + 1 + 4 * string.getL(), string.length() - 1); j++) {
				middlePart = middlePart.times(new Quanterion(string.charAt(j)));
				rightPart = (new Quanterion(string.charAt(j))).inverse().times(rightPart);
				if (leftPart.equals(I) && middlePart.equals(J) && rightPart.equals(K)) {
					return new String[]{"YES"};
				}
			}
			middlePart = new Quanterion(string.charAt(i + 1));
			rightPart = middlePart.clone().inverse().times(temp);
			temp = rightPart.clone();
		}
		return new String[]{"NO"};
	}

	private class Quanterion {

		private boolean neg;
		private Root quant;

		public Quanterion(Root quant, boolean neg) {
			this.neg = neg;
			this.quant = quant;
		}

		public Quanterion(Root quant) {
			this(quant, false);
		}

		public Quanterion(char root) {
			this(Root.valueOf("" + root));
		}

		public Quanterion() {
			this(Root.o);
		}

		public Quanterion inverse() {
			this.neg = !this.neg;
			return this;
		}

		public Quanterion times(Quanterion other) {
			Quanterion res = new Quanterion();
			if (other.quant == Root.o) {
				res = new Quanterion(this.quant);
			} else if (this.quant == Root.o) {
				res = new Quanterion(other.quant);
			} else if (this.quant == other.quant) {
				res = new Quanterion(Root.o, true);
			} else if (this.quant == Root.i) {
				switch (other.quant) {
					case j:
						res = new Quanterion(Root.k);
						break;
					case k:
						res = new Quanterion(Root.j, true);
						break;
				}
			} else if (this.quant == Root.j) {
				switch (other.quant) {
					case i:
						res = new Quanterion(Root.k, true);
						break;
					case k:
						res = new Quanterion(Root.i);
						break;
				}
			} else if (this.quant == Root.k) {
				switch (other.quant) {
					case i:
						res = new Quanterion(Root.j);
						break;
					case j:
						res = new Quanterion(Root.i, true);
						break;
				}
			}
			if (this.neg) {
				res.inverse();
			}
			if (other.neg) {
				res.inverse();
			}
			return res;
		}

		public Quanterion square() {
			if (this.quant == Root.o) {
				return new Quanterion();
			} else {
				return new Quanterion(Root.o, true);
			}
		}

		@Override
		public Quanterion clone() {
			return new Quanterion(quant, neg);
		}

		public boolean equals(Quanterion other) {
			return this.neg == other.neg && this.quant == other.quant;
		}
	}

	private enum Root {

		i, j, k, o;
	}

	private class LoopString {

		private long X;
		private int L;
		private String str;

		public LoopString(String str, long X) {
			this.X = X;
			this.str = str;
			this.L = str.length();
		}

		public long length() {
			return L * X;
		}

		public char charAt(long pos) {
			if (pos < 0 || pos >= this.length()) {
				throw new IndexOutOfBoundsException();
			}
			return this.str.charAt((int) (pos % L));
		}

		public Quanterion eval() {
			Quanterion subeval = new Quanterion(this.str.charAt(0));
			for (int i = 1; i < this.str.length(); i++) {
				subeval = subeval.times(new Quanterion(this.str.charAt(i)));
			}

			Quanterion res = new Quanterion();
			long pow = this.X % 4;
			while (pow >= 1) {
				if (pow % 2 == 1) {
					res = res.times(subeval);
				}
				subeval = subeval.square();
				pow = pow / 2;
			}
			return res;
		}

		private int getL() {
			return this.L;
		}
	}
}
