/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package GCJ;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author t7639192
 */
public class FileHandler {
	
	private BufferedReader br;
	private BufferedWriter bw;
	private int linesPerCase;
	private int solved;
	private int T;
	
	public FileHandler(String readFilename, String writeFilename, int linesPerCase) throws IOException {
		this(new FileReader(readFilename), new FileWriter(writeFilename), linesPerCase);
	}
	
	public FileHandler(FileReader fr, FileWriter fw, int linesPerCase) throws IOException {
		this.br = new BufferedReader(fr);
		this.bw = new BufferedWriter(fw);
		this.linesPerCase = linesPerCase;
		this.solved = 0;
		String line;
		if ((line = this.br.readLine()) != null) {
			this.T = Integer.parseInt(line);
		} else {
			throw new IOException();
		}
	}
	
	public int casesLeft() {
		return this.T - this.solved;
	}
	
	public void solve(GCJSolver solver) throws IOException {
		String[] input = new String[this.linesPerCase];
		String line;
		for (int i = 0; i < this.linesPerCase; i++) {
			if ((line = this.br.readLine()) != null) {
				input[i] = line;
			} else {
				throw new IOException();
			}
		}
		String[] output = solver.solve(input);
		this.bw.write("Case #" + (this.solved + 1) + ": ");
		for (int i = 0; i < output.length; i++) {
			this.bw.write(output[i] + "\n");
		}
		this.solved++;
	}
	
	public void solveAll(GCJSolver solver) throws IOException{
		while(this.casesLeft() > 0){
			this.solve(solver);
		}
	}

	public void close() throws IOException {
		this.br.close();
		this.bw.close();
	}
}
