public class Block {

	private int currentLine = 0;

	private final char[][] field = { { '.', '.', '.', '.' },
			{ '.', '.', '.', '.' }, { '.', '.', '.', '.' },
			{ '.', '.', '.', '.' }, };

	public void addLine(String line) {
		field[currentLine][0] = line.charAt(0);
		field[currentLine][1] = line.charAt(1);
		field[currentLine][2] = line.charAt(2);
		field[currentLine][3] = line.charAt(3);
		currentLine++;
	}

	public String lineAt(int i) {
		return String.valueOf(field[i][0]) + field[i][1] + field[i][2]
				+ field[i][3];
	}

	public String solve() {
		if (won('X')) {
			return "X won";
		} else if (won('O')) {
			return "O won";
		} else if (draw()) {
			return "Draw";
		} else {
			return "Game has not completed";
		}
	}

	private boolean won(char p) {
		if (testHorizontals(p)) {
			return true;
		}
		if (testVerticals(p)) {
			return true;
		}
		if (testDiagonals(p)) {
			return true;
		}
		return false;
	}

	private boolean testDiagonals(char p) {
		// one
		int count = 0;
		for (int i = 0; i < 4; i++) {
			char c = field[i][i];
			if (p == c || 'T' == c) {
				count++;
			}
		}
		if (4 == count) {
			return true;
		}
		// another
		count = 0;
		char c = field[0][3];
		if (p == c || 'T' == c) {
			count++;
		}
		c = field[1][2];
		if (p == c || 'T' == c) {
			count++;
		}
		c = field[2][1];
		if (p == c || 'T' == c) {
			count++;
		}
		c = field[3][0];
		if (p == c || 'T' == c) {
			count++;
		}
		return 4 == count;
	}

	private boolean testVerticals(char p) {
		if (testVertical(p, 0) || testVertical(p, 1) || testVertical(p, 2)
				|| testVertical(p, 3)) {
			return true;
		}
		return false;
	}

	private boolean testVertical(char p, int v) {
		int count = 0;
		for (int i = 0; i < 4; i++) {
			char c = field[i][v];
			if (p == c || 'T' == c) {
				count++;
			}
		}
		return 4 == count;
	}

	private boolean testHorizontals(char p) {
		if (testHorizontal(p, 0) || testHorizontal(p, 1)
				|| testHorizontal(p, 2) || testHorizontal(p, 3)) {
			return true;
		}
		return false;
	}

	private boolean testHorizontal(char p, int h) {
		int count = 0;
		for (char c : field[h]) {
			if (p == c || 'T' == c) {
				count++;
			}
		}
		return 4 == count;
	}

	private boolean draw() {
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				if ('.' == field[i][j]) {
					return false;
				}
			}
		}
		return true;
	}

}
