import java.util.ArrayList;
import java.util.List;

public class TicTacToe {

	private List<Block> blocks;

	public TicTacToe(String file) {
		In in = new In(file);
		String line = null;
		int lineNumber = 0;
		Block block = new Block();
		while (null != (line = in.readLine())) {
			if (isFirstLine(lineNumber)) {
				this.blocks = new ArrayList<Block>(Integer.valueOf(line));
				lineNumber++;
			} else if (line.isEmpty()) {
				lineNumber = 1;
			} else if (isLastBlockLine(lineNumber)) {
				block.addLine(line);
				blocks.add(block);
				block = new Block();
				lineNumber = 1;
			} else {
				block.addLine(line.trim().toUpperCase());
				lineNumber++;
			}
		}
	}

	private boolean isLastBlockLine(int lineNumber) {
		return 4 == lineNumber;
	}

	private boolean isFirstLine(int lineNumber) {
		return 0 == lineNumber;
	}

	public List<Block> getBlocks() {
		return this.blocks;
	}

	public void printOutput() {
		Out out = new Out("data/jam2013/A-small-attempt1.out");
		int id = 1;
		for (Block block : blocks) {
			String line = "Case #" + (id++) + ": " + block.solve();
			out.println(line);
		}
		out.close();
	}

}
