public class Lawn {

	private int rows, columns;
	private int[][] pattern;
	private int currentRow = 0;

	public Lawn(Integer rows, Integer columns) {
		this.rows = rows;
		this.columns = columns;
		this.pattern = new int[this.rows][this.columns];
	}

	public void addRow(String row) {
		String[] split = row.split(" ");
		for (int i = 0; i < split.length; i++) {
			this.pattern[currentRow][i] = Integer.valueOf(split[i]);
		}
		currentRow++;
	}

	public int rows() {
		return this.rows;
	}

	public String solve() {
		if (rows == 1 || columns == 1) {
			return "YES";
		} else {
			for (int row = 0; row < rows; row++) {
				for (int col = 0; col < columns; col++) {
					if (pattern[row][col] == 1) {
						if (noExitFor(row, col)) {
							return "NO";
						}
					}
				}
			}
			return "YES";
		}
	}

	private boolean noExitFor(int row, int col) {
		boolean hor = horExit(row);
		boolean ver = verExit(col);
		return !hor && !ver;
	}

	private boolean verExit(int col) {
		for (int row = 0; row < rows; row++) {
			if (pattern[row][col] == 2)
				return false;
		}
		return true;
	}

	private boolean horExit(int row) {
		for (int col = 0; col < columns; col++) {
			if (pattern[row][col] == 2)
				return false;
		}
		return true;
	}

}
