import java.util.ArrayList;
import java.util.List;

public class Lawnmower {

	private String outFileName;
	private List<Lawn> lawns;

	public Lawnmower(String file) {
		this.outFileName = file + ".out";
		In in = new In(file);
		String line = null;
		int lineNumber = 0;
		Lawn lawn = null;
		while (null != (line = in.readLine())) {
			if (isFirstLine(lineNumber)) {
				this.lawns = new ArrayList<Lawn>(Integer.valueOf(line));
				lineNumber++;
			} else if (isLawnMetadata(lineNumber)) {
				String[] metadata = line.split(" ");
				lawn = new Lawn(Integer.valueOf(metadata[0]),
						Integer.valueOf(metadata[1]));
				lineNumber++;
			} else if (isLastLine(lineNumber, lawn)) {
				lawn.addRow(line);
				this.lawns.add(lawn);
				lineNumber = 1;
			} else {
				lawn.addRow(line);
				lineNumber++;
			}
		}
	}

	private boolean isLastLine(int lineNumber, Lawn lawn) {
		return lineNumber == lawn.rows() + 1;
	}

	private boolean isFirstLine(int lineNumber) {
		return 0 == lineNumber;
	}

	private boolean isLawnMetadata(int lineNumber) {
		return 1 == lineNumber;
	}

	public List<Lawn> getLawns() {
		return this.lawns;
	}

	public void printOutput() {
		Out out = new Out(outFileName);
		int id = 1;
		for (Lawn lawn : getLawns()) {
			String line = "Case #" + (id++) + ": " + lawn.solve();
			out.println(line);
		}
		out.close();
	}

}
