import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Palindrome {

	private String filename;

	private List<List<Integer>> ranges;

	public Palindrome(String file) {
		this.filename = file + ".out";
		In in = new In(file);
		String line = null;
		while (null != (line = in.readLine())) {
			if (ranges == null) {
				ranges = new ArrayList<List<Integer>>();
			} else {
				String[] plitted = line.split(" ");
				ranges.add(Arrays.asList(Integer.valueOf(plitted[0]),
						Integer.valueOf(plitted[1])));
			}
		}
	}

	public int fairAndSquareCount(int a, int b) {
		int counter = 0;
		for (int i = a; i <= b; i++) {
			if (fairAndSquare(i)) {
				counter++;
			}
		}
		return counter;
	}

	public boolean isPolindrome(int value) {
		String str = String.valueOf(value);
		if (str.length() == 1) {
			return true;
		} else {
			int mid = str.length() / 2;
			for (int i = 0, j = str.length() - 1; i < mid; i++, j--) {
				if (str.charAt(i) != str.charAt(j)) {
					return false;
				}
			}
		}
		return true;
	}

	public boolean fairAndSquare(int p) {
		if (!isPolindrome(p)) {
			return false;
		}
		double root = Math.sqrt(p);
		int left = (int) root;
		double right = root - (double) left;
		boolean isSquare = right == 0.0D;
		return isSquare && isPolindrome(left);
	}

	public List<List<Integer>> getRanges() {
		return this.ranges;
	}

	public void printOutput() {
		Out out = new Out(filename);
		int id = 1;
		for (List<Integer> range : getRanges()) {
			int a = range.get(0);
			int b = range.get(1);
			String line = "Case #" + (id++) + ": " + fairAndSquareCount(a, b);
			out.println(line);
		}
		out.close();
	}

}
