import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.StreamTokenizer;
import java.io.StringReader;
import java.util.HashMap;
import java.util.Map;


public class Magicka {

	/**
	 * @param args
	 */
	
	private static StreamTokenizer t;
	
	public static void main(String[] args) {
		//String test = "1 QFT 1 QF 7 FAQFDFQ";
		//Case Test: [F, D, T]
		//String test ="1 EEZ 1 QE 7 QEEEERA";
		//Case Test: [Z, E, R, A]
		//String test ="0 1 QW 2 QW";
		//Case Test: []
		//String test =  "2 QFT AFM 2 QF DF 7 FAQFDFQAF";
		//Case Test: [T, M]
		
		//String rawoutput = solve(test);
		//System.out.println("Case Test: " + formatOutput(rawoutput));
		
		try {
			File finput = new File("contest.in");
			File foutput = new File("contest.out");
			BufferedReader reader = new BufferedReader(new FileReader(finput));
			BufferedWriter writer = new BufferedWriter(new FileWriter(foutput));
			String line = null;
			//ignore the count at the top
			line = reader.readLine();
			int i = 1;
			while((line=reader.readLine()) != null)
			{
				String rawOutput = solve(line);
				String solution = formatOutput(rawOutput);
				System.out.println("Given:"+line + "sol:" + solution);
				//"Case #1: [E, A]"
				writer.write("Case #"+i+": " + solution + "\n");
				writer.flush();
				i++;
			}
		}
		catch (Exception ex)
		{
			ex.printStackTrace();
		}

	}

	private static String formatOutput(String rawstring) {
		
		char [] letters = rawstring.toCharArray();
		String buff = "";
		if ( 0!= letters.length)
			buff = rawstring.substring(0,1);
		for (int i = 1; i < letters.length; i++)
		{
			buff += ", " + String.valueOf(letters[i]);
		}
		return "[" + buff + "]";
	}

	private static String solve(String in) {
		// TODO Auto-generated method stub
		
		t =
		    new StreamTokenizer(
		        new StringReader( in ));
		
		if (!nextToken()) return "";
		int nrCombis = (int) t.nval;
		System.out.println(nrCombis + " combinations");
		//magic constant: 2 combis per input / .75 loadfactor rounded up
		Map<String,String> combinations = new HashMap<String,String>(3*nrCombis);
		for (int i=0; i < nrCombis; i++)
		{
			if (!nextToken()) return "";
			mapCombination(t.sval,combinations);
		}
		if (!nextToken()) return "";
		int nrOppositions = (int) t.nval;
		Map<String,String> oppositions = new HashMap<String,String>(3*nrOppositions);
		System.out.println(nrOppositions + " oppositions");
		for (int i=0; i < nrOppositions; i++)
		{
			nextToken();
			mapOpposition(t.sval,oppositions);
		}
		
		if (!nextToken()) return "";
		if (!nextToken()) return "";
		char [] userInput = t.sval.toCharArray();
		String solution = getOutput(userInput,combinations,oppositions);
	
		return solution;
	}

	private static String getOutput(char[] userInput,
			Map<String, String> combinations, Map<String, String> oppositions) {
		String output = "";
		
		
		String oldkey = "";
		String badstuff = "";
		String oldbadstuff = "";
		for (int i = 0; i < userInput.length; i++)
		{
			/*Don't know what's faster, looping over the entire
			 * stream, or just looping over the collisions and remove
			 * everything up to the collision.
			 * Let's loop the stream (although that does do some
			 * unnecessary work
			 * Note that collisions may exist between base & non base 
			 * elements anyhow  
			 */
			
			String sInput = String.valueOf(userInput[i]);
			
			/*NEW::*/
			//1: Check for combinations
			String combination = oldkey + sInput;
			if (combinations.containsKey(combination))
			{
				oldkey = combinations.get(combination);
				oldbadstuff = ""; //related to the bug even more bug :)
			}else //this means I did not combine
			{
				output += oldkey;
				oldkey = sInput;
				badstuff += oldbadstuff; //so I take into account bad stuff
			}
			
			//2: add to blacklist (before going to next round)
			//bug: only blacklist if I did not combine before!
			if (oppositions.containsKey(oldkey))
				oldbadstuff = oppositions.get(oldkey);
			
			//3: the spell is virtually at the tail (it's not in the
			//   string itself, but consider it to be there) so 
			//   we need to check oldkey before going to the next 
			//   round
			if (-1 != badstuff.indexOf(oldkey))
			{
				output = ""; //reset the index
				badstuff = ""; //there is no more blacklist
				oldbadstuff = "";
				oldkey = "";
			}
		}
		output += oldkey;
		return output;
	}

	private static void mapOpposition(String input,
			Map<String, String> oppositions) {
		String key = input.substring(0,1);
		String revkey = input.substring(1,2);
		
		if (!"QWERASDF".contains(key))
			System.out.println("aha!");
		if (!"QWERASDF".contains(revkey))
			System.out.println("aha!");
		
		if (oppositions.containsKey(key))
		{
			String badchars = oppositions.get(key);
			badchars += revkey;
			oppositions.put(key, badchars);
		}else
		{
			oppositions.put(key,revkey);
		}
		
		if (oppositions.containsKey(revkey))
		{
			String badchars = oppositions.get(revkey);
			badchars += key;
			oppositions.put(revkey, badchars);
		}else
		{
			oppositions.put(revkey, key);
		}
		//System.out.println("I am aware of a new opposition:" + key + revkey);
	}

	private static void mapCombination(String input,
			Map<String, String> combinations) {
		//assume given fixed length of 3
		String key = input.substring(0,2);
		String revkey = String.valueOf(input.charAt(1));
		revkey += input.charAt(0);
		
		String output = input.substring(2,3);
		//System.out.println("Mapped " + key + " to " + output);
		combinations.put(key,output);
		combinations.put(revkey,output);
		
		String key1 = key.substring(0,1);
		if (!"QWERASDF".contains(key1))
			System.out.println("aha!");
		String key2 = key.substring(1,2);
		if (!"QWERASDF".contains(key2))
			System.out.println("aha!");
	}

	public static boolean nextToken()
	{
		if (t.ttype == StreamTokenizer.TT_EOF)
			return false;
		try {
			t.nextToken();
			if (t.ttype != StreamTokenizer.TT_EOF)
				return true;
			else
				return false;
		} catch (IOException e) {
			endOfLine();
		}
		return false;
	}

	private static void endOfLine() {
		System.out.println("Todo:implement");
		
	}
	
}
