package nl.bertje.googlecodejam;

import java.io.BufferedReader;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public abstract class Problem {

  private final String targetFile;

  public Problem(String targetFile) {
    this.targetFile = targetFile;
  }

  public void solve() throws IOException {
    final Path path = Paths.get(targetFile);
    try (BufferedReader br = Files.newBufferedReader(path)) {
      final int nrOfCases = Integer.parseInt(br.readLine());
      solveCases(br);
    }
  }

  public void solveCases(BufferedReader br) throws IOException {
    int currentCase = 1;
    String currentLine;
    while ((currentLine = br.readLine()) != null) {
      System.out.println("Case #" + currentCase++ + ": " + solveCase(currentLine));
    }
  }

  public abstract String solveCase(String line);

}
