package nl.bertje.googlecodejam;

import java.io.BufferedReader;
import java.io.IOException;

public class ProblemD extends Problem {

  public ProblemD(String problemFile) {
    super(problemFile);
  }

  @Override
  public String solveNextCase(BufferedReader br) throws IOException {
    // line holds nr of points in omino, width and height of grid:
    final String[] parts = br.readLine().split(" ");
    final int ominoSize = Integer.parseInt(parts[0]);
    final int x = Integer.parseInt(parts[1]);
    final int y = Integer.parseInt(parts[2]);
    boolean impossible = false;
    // condition where win is impossible:
    // omino size doesn't fit the grid due to size
    if (x * y % ominoSize != 0) {
      impossible = true;
    }
    final int maxRib = ominoSize / 2 + (ominoSize % 2 == 0 ? 0 : 1);
    // can be made impossible if size > 2 and either x or y < size
    // (can make a piece that doesn't fit within the borders)
    if (ominoSize > 2 && (x < maxRib || y < maxRib)) {
      impossible = true;
    }

    // can be made impossible if a piece can be made that is large enough to fit
    // between borders AND have a hole...
    if (ominoSize >= 4 && (x <= maxRib || y <= maxRib)) {
      impossible = true;
    }

    // from ominoSize >= 7, it's possible to create a omino with a hole that
    // does never fit
    if (ominoSize >= 7) {
      impossible = true;
    }

    return impossible ? "RICHARD" : "GABRIEL";
  }

}
