package nl.bertjesapps.googlecodejam;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

public class ProblemOne {
	
	private static String sampleIn = "ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jvqz";
	private static String sampleOut = "our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give upzq";
	private Map<Character, Character> results = new HashMap<Character, Character>();
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length == 1) {
			String fileName = args[0];
			ProblemOne problemOne = new ProblemOne();
			try {
				problemOne.solveFile(fileName);
			} catch (FileNotFoundException fnf) {
				System.out.println("File not found!");
				System.out.println(fnf.getMessage());
			} catch (IOException e) {
				System.out.println("Could not read file!");
			}
		} else {
			System.out.println("Need 1 argument!");
		}
	}

	private void solveFile(String fileName) throws IOException {
		StringBuilder output = new StringBuilder();
		File file = new File(fileName);
		FileReader fileReader = new FileReader(file);
		BufferedReader reader = new BufferedReader(fileReader);
		String numberOfCasesString = reader.readLine();
		int numberOfCases = Integer.parseInt(numberOfCasesString);
		for (int i = 1; i <= numberOfCases; i++) {
			output.append("Case #" + i + ": ");
			output.append(solveLine(reader.readLine()));
			output.append("\r\n");
		}
		//output.append(results.size());
		FileWriter writer = new FileWriter(fileName.replace(".in", ".out"));
		writer.write(output.toString());
		writer.close();
	}
	
	private String solveLine(String lineToBeSolved) {
		StringBuilder output = new StringBuilder();
		for (int i = 0;i<lineToBeSolved.length();i++) {
			output.append(solveCharacter(lineToBeSolved.charAt(i)));
		}
		return output.toString();
	}
	
	private char solveCharacter(char character) {
		char returnChar = 'q';
		try {
		 returnChar = sampleOut.charAt(sampleIn.indexOf(character));
		} catch(IndexOutOfBoundsException ie) {
			try {
				returnChar = sampleOut.charAt(sampleIn.indexOf(character));
			} catch(IndexOutOfBoundsException ie2) {
				returnChar = sampleOut.toUpperCase().charAt(sampleIn.toUpperCase().indexOf(character));
			}
		}
		results.put(character, returnChar);
		return returnChar;
	}

}
