package fr.pabeke.round1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.TimeUnit;

public class B {

	static final String INPUT_PATH = "/home/bertrand/Desktop/B-small-attempt0.in";
	static final String OUTPUT_PATH = "/home/bertrand/Desktop/B-small-attempt0.out";

	static final ExecutorService POOL = Executors.newCachedThreadPool();

	static final int LINE_PER_CASE = 1;

	public static void main(String[] args) throws IOException, InterruptedException, ExecutionException {
		try (final BufferedReader br = new BufferedReader(new FileReader(INPUT_PATH)); final BufferedWriter bw = new BufferedWriter(new FileWriter(OUTPUT_PATH));) {
			long beginningTime = System.currentTimeMillis();
			int nbCase = Integer.parseInt(br.readLine());
			Map<Integer, Future<String>> answers = new HashMap<>();

			for (int i = 1; i <= nbCase; i++) {
				List<String> lines = new ArrayList<>();
				for (int j = 0; j < LINE_PER_CASE; j++) {
					lines.add(br.readLine());
				}
				TestCase task = new TestCase(i, lines);
				Future<String> future = POOL.submit(task);
				answers.put(i, future);
			}

			POOL.shutdown();
			POOL.awaitTermination(1, TimeUnit.DAYS);

			for (int i = 1; i <= nbCase; i++) {
				System.out.print(String.format("Case #%s: ", i));
				bw.write(String.format("Case #%s: ", i));

				Future<String> future = answers.get(i);
				String answer = future.get();
				System.out.println(answer);
				bw.write(answer);
				bw.write("\n");
			}

			long end = System.currentTimeMillis();
			System.out.println("Solved everything in " + (end - beginningTime) / 1000 + " s");
		}
	}

	static class TestCase implements Callable<String> {

		int indice;
		List<String> lines;

		public TestCase(int i, List<String> lines) {
			this.indice = i;
			this.lines = lines;
		}

		@Override
		public String call() throws Exception {
			long beginningTime = System.currentTimeMillis();
			System.out.println("Beginning solving of test case " + indice);
			String answer = solve(lines);
			long end = System.currentTimeMillis();
			System.out.println("Finished solving of test case " + indice + " in " + (end - beginningTime) / 1000 + " s");
			return answer;
		}

		private String solve(List<String> lines) {
			String line = lines.get(0);
			String[] split = line.split(" ");
			int A = Integer.parseInt(split[0]);
			int B = Integer.parseInt(split[1]);
			int K = Integer.parseInt(split[2]);

			int nbCas = 0;
			for (int i = 0; i < A; i++) {
				for (int j = 0; j < B; j++) {
					int res = i & j;
					if (res < K) {
						nbCas++;
					}
				}
			}

			return "" + nbCas;
		}

	}

}
