import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Candy_Splitting {

	public static String pathToInput = "./C-small-attempt0.in";
	public static String pathToOutput = "./C-small-attempt0.out";

	public static void main(String[] args) throws IOException {
		BufferedReader bf = new BufferedReader(new FileReader(pathToInput));
		FileWriter fw = new FileWriter(pathToOutput);
		int nbCase = Integer.parseInt(bf.readLine());

		for (int i = 1; i <= 2 * nbCase; i += 2) {
			// Parse data as usual
			int nbCandies = Integer.parseInt(bf.readLine());
			String[] candiesData = bf.readLine().split(" ");
			int[] candies = new int[nbCandies];
			for (int j = 0; j < nbCandies; j++) {
				candies[j] = Integer.parseInt(candiesData[j]);
			}
			// Compute data of the set
			int result = computeCandies(candies);
			if (result < 0) {
				fw.write("Case #" + ((i/2)+1) + ": NO\n");
			} else {
				fw.write("Case #" + ((i/2)+1) + ": " + result + "\n");
			}
		}
		fw.flush();
		fw.close();
		bf.close();
	}

	public static int computeCandies(int[] candies) {
		int bestResult = -1;
		// We are going to create 2 arrays of index,
		// corresponding to a combination of index,
		// and the contrary of this combination
		// Then we process these 2 arrays with a XOR
		int[] indices = new int[candies.length];
		for (int i = 0; i < indices.length; i++) {
			indices[i] = i;
		}

		for (int i = 1; i <= indices.length; i++) {
			// Class to help creating combination
			Combiner combiner = new Combiner(i, indices);
			int[] result = new int[i];
			int[] oppositeResult = new int[indices.length - i];
			while (combiner.searchNext(result)) {
				oppositeResult = theContrary(result, indices);

				// Would have been prettier with Map, but I'm not used to it
				int[] candiesSean = new int[result.length];
				for (int j = 0; j < result.length; j++) {
					candiesSean[j] = candies[result[j]];
				}
				int[] candiesPatrick = new int[oppositeResult.length];
				for (int k = 0; k < oppositeResult.length; k++) {
					candiesPatrick[k] = candies[oppositeResult[k]];
				}
				if (candiesPatrick.length != 0 & candiesSean.length != 0) {
					if (xor(candiesSean) == xor(candiesPatrick)) {
						int max = Math.max(sum(candiesSean), sum(candiesPatrick));
						if (max > bestResult) {
							bestResult = max;
//							System.out.println(Arrays.toString(candiesSean));
//							System.out.println(Arrays.toString(candiesPatrick));
						}
					}
				}
			}
		}
		return bestResult;
	}

	// XOR input array of data
	public static int xor(int[] data) {
		int sum = 0;
		for (int i = 0; i < data.length; i++) {
			sum = sum ^ data[i];
		}
		return sum;
	}

	// Simple sum
	public static int sum(int[] data) {
		int sum = 0;
		for (int i = 0; i < data.length; i++) {
			sum += data[i];
		}
		return sum;
	}

	public static class Combiner {
		protected int count;
		protected int[] array;
		protected int[] indices;

		public Combiner(int count, int[] array) {
			super();
			this.count = count;
			this.array = array;
			indices = new int[count];
			for (int i = 0; i < count; i++) {
				indices[i] = i;
			}
		}

		public boolean searchNext(int[] result) {
			if (indices == null) {
				return false;
			}

			int resultIndex = 0;
			for (int index : indices) {
				result[resultIndex++] = array[index];
			}

			int indexesRank = count - 1;
			int arrayRank = array.length - 1;
			while (indices[indexesRank] == arrayRank) {
				if (indexesRank == 0) {
					indices = null;
					return true;
				}
				indexesRank--;
				arrayRank--;
			}

			int restartIndex = indices[indexesRank] + 1;
			while (indexesRank < count) {
				indices[indexesRank++] = restartIndex++;
			}

			return true;
		}
	}

	// Method to get the contrary of the array of index with original data
	// ex : [1,3,5] -> [0,2,4,6]
	private static int[] theContrary(int[] aCombinaison, int[] indices) {
		ArrayList<Integer> contraryList = new ArrayList<Integer>();
		for (int i = 0; i < indices.length; i++) {
			if (!isPresent(indices[i], aCombinaison)) {
				contraryList.add(indices[i]);
			}
		}
		int[] contraryArray = new int[contraryList.size()];
		for (int i = 0; i < contraryArray.length; i++) {
			contraryArray[i] = contraryList.get(i);
		}
		return contraryArray;
	}

	private static boolean isPresent(int i, int[] aCombinaison) {
		for (int j = 0; j < aCombinaison.length; j++) {
			if (aCombinaison[j] == i) {
				return true;
			}
		}
		return false;
	}
}
