import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class MagicTrick {

	static final String inputPath = "/home/bertrand/Desktop/A-small-attempt0.in";

	public static void main(String[] args) throws IOException {
		FileReader fr = new FileReader(inputPath);
		BufferedReader br = new BufferedReader(fr);

		String nbCaseString = br.readLine();
		int nbCase = Integer.parseInt(nbCaseString);

		for (int i = 1; i <= nbCase; i++) {
			System.out.print(String.format("Case #%s: ", i));

			int firstAnswer = parseAnswer(br);
			List<String> numbersFirst = getNbSelected(br, firstAnswer);

			int secondAnswer = parseAnswer(br);
			List<String> numbersSecond = getNbSelected(br, secondAnswer);

			List<String> intersection = intersection(numbersFirst, numbersSecond);
			if (intersection.isEmpty()) {
				System.out.println("Volunteer cheated!");
			} else if (intersection.size() == 1) {
				System.out.println(intersection.get(0));
			} else if (intersection.size() > 1) {
				System.out.println("Bad magician!");
			}
		}

		br.close();
	}

	static int parseAnswer(BufferedReader br) throws IOException {
		String answerString = br.readLine();
		int answer = Integer.parseInt(answerString);
		return answer;
	}

	static List<String> getNbSelected(BufferedReader br, int answer) throws IOException {
		List<String> numbers = null;
		for (int j = 1; j <= 4; j++) {
			if (j != answer) {
				br.readLine();
				continue;
			}
			String numbersLineString = br.readLine();
			numbers = Arrays.asList(numbersLineString.split(" "));
		}
		return numbers;
	}

	static <T> List<T> intersection(List<T> list1, List<T> list2) {
		List<T> list = new ArrayList<>();
		for (T t : list1) {
			if (list2.contains(t)) {
				list.add(t);
			}
		}
		return list;
	}

}
