import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;

public class CookieClickerAlpha {

	static final String inputPath = "/home/bertrand/Desktop/B-small-attempt0.in";
	static final String outputPath = "/home/bertrand/Desktop/B-small-attempt0.out";

	public static void main(String[] args) throws IOException {
		FileReader fr = new FileReader(inputPath);
		BufferedReader br = new BufferedReader(fr);

		FileWriter fw = new FileWriter(outputPath);
		BufferedWriter bw = new BufferedWriter(fw);

		String nbCaseString = br.readLine();
		int nbCase = Integer.parseInt(nbCaseString);

		for (int i = 1; i <= nbCase; i++) {
			bw.write(String.format("Case #%s: ", i));

			String answer = solve(br);
			bw.write(answer);

			bw.write("\n");
		}

		bw.close();
		br.close();
	}

	static final double initialCookiesPerSecond = 2;
	static final DecimalFormat df = new DecimalFormat("#.0000000");

	private static String solve(BufferedReader br) throws IOException {
		String readLine = br.readLine();
		String[] args = readLine.split(" ");
		double costForFarmC = Double.parseDouble(args[0]);
		double extraCookiesPerSecondF = Double.parseDouble(args[1]);
		double cookiesGoalX = Double.parseDouble(args[2]);

		double bestcostWithoutFarm = costWithNbFarm(0, costForFarmC, extraCookiesPerSecondF, cookiesGoalX);
		for (int nbFarm = 1; true; nbFarm++) {
			double cost = costWithNbFarm(nbFarm, costForFarmC, extraCookiesPerSecondF, cookiesGoalX);
			if (cost > bestcostWithoutFarm) {
				break;
			} else {
				bestcostWithoutFarm = cost;
			}
		}

		return df.format(bestcostWithoutFarm);
	}

	static double costWithNbFarm(int nbFarm, double costForFarmC, double extraCookiesPerSecondF, double cookiesGoalX) {
		if (nbFarm == 0) {
			return cookiesGoalX / initialCookiesPerSecond;
		}
		double time = 0;

		for (int i = 0; i < nbFarm; i++) {
			time += costForFarmC / (initialCookiesPerSecond + i * extraCookiesPerSecondF);
		}

		time += cookiesGoalX / (initialCookiesPerSecond + nbFarm * extraCookiesPerSecondF);

		return time;
	}

}
