package codejam2012qual;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Hashtable;

import util.InputReader;

public class SpeakingInTongues implements Runnable {
	
	private InputReader in;
	private PrintWriter out;
	
	public static void main(String[] args) {
		new Thread(new SpeakingInTongues()).start();
	}
	
	public SpeakingInTongues(){
		try {			
			BufferedReader buffer = new BufferedReader(new FileReader("d:\\A-small-attempt0.in")); 
			in = new InputReader(buffer);
			
			System.setOut(new PrintStream(new FileOutputStream("d:\\output.txt")));
			out = new PrintWriter(System.out);
			
		} catch (FileNotFoundException e) {
			throw new RuntimeException();
		}		
	}
	
	@Override
	public void run() {
		
		int numTests = in.readInt();
		
		Hashtable<Character, Character> dict = GetTable();
		
        for (int testNumber = 0; testNumber < numTests; testNumber++) {
			out.print("Case #" + (testNumber + 1) + ": ");
        
			String line = in.readString();
			StringBuilder sb = new StringBuilder();			
			char[] ch = line.toCharArray();
			
			for(int i=0; i<ch.length; i++){	
				
				sb.append(dict.get(ch[i]));
			}
			
			out.println(sb.toString().trim());
		}
		out.close();

	}
	
	private Hashtable<Character, Character> GetTable() {
		
		Hashtable<Character, Character> alphaTable = new Hashtable<Character, Character>();
		
        alphaTable.put('y', 'a');
        alphaTable.put('n', 'b');
        alphaTable.put('f', 'c');
        
        alphaTable.put('i', 'd');
        alphaTable.put('c', 'e');
        alphaTable.put('w', 'f');
        
        alphaTable.put('l', 'g');
        alphaTable.put('b', 'h');
        alphaTable.put('k', 'i');
        
        alphaTable.put('u', 'j');
        alphaTable.put('o', 'k');
        alphaTable.put('m', 'l');
        
        alphaTable.put('x', 'm');
        alphaTable.put('s', 'n');
        alphaTable.put('e', 'o');
        
        alphaTable.put('v', 'p');
        alphaTable.put('z', 'q');
        alphaTable.put('p', 'r');
        alphaTable.put('d', 's');
        
        alphaTable.put('r', 't');
        alphaTable.put('j', 'u');
        alphaTable.put('g', 'v');
        
        alphaTable.put('t', 'w');
        alphaTable.put('h', 'x');
        alphaTable.put('a', 'y');
        alphaTable.put('q', 'z');
        
        alphaTable.put(' ', ' ');
        
        return alphaTable;
	}

}
