package codejam2015;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.PrintStream;
import java.io.PrintWriter;

import util.InputReader;

public class StandingOvation implements Runnable{
	private InputReader in;
	private PrintWriter out;
	private static String delimiter = " ";

	public static void main(String[] args) {
		new Thread(new StandingOvation()).start();
	}

	public StandingOvation(){
		try{
			BufferedReader buffer = new BufferedReader(new FileReader("d:\\A-large.in"));
			in = new InputReader(buffer);
			System.setOut(new PrintStream(new FileOutputStream("d:\\output-A2.txt")));
			out = new PrintWriter(System.out);
		} catch (FileNotFoundException e) {
			throw new RuntimeException();
		}
	}

	@Override
	public void run() {
		int numTests = in.readInt();

		for (int testNumber = 0; testNumber < numTests; testNumber++) {
			out.print("Case #" + (testNumber + 1) + ": ");
			String line = in.readString();

			String[] token = line.split(delimiter);

			int maxLevel = Integer.valueOf(token[0]);
			int[] shylevels = parseString2Int(token[1]);
			int result = getMinFriends(maxLevel, shylevels);
			
			StringBuilder sb = new StringBuilder();
			sb.append(result);
			out.println(sb.toString().trim());
		}
		out.close();
	}

    private int[] parseString2Int(String str) {
        if (str == null || str.length() == 0)
            return null;
        
        int[] arr = new int[str.length()];
        char[] chars = str.toCharArray();
        for(int i=0; i<chars.length;i++){
            arr[i] = Integer.valueOf(chars[i]-48);
        }
        return arr;
    }

    private int getMinFriends(int maxLevel, int[] shylevels) {
        if(maxLevel == 0)
            return 0;
        
        int count = 0;
        int alreadyClap = 0;
        
        if(shylevels.length > 0)
            alreadyClap = shylevels[0];
        else 
            return 0;
//        System.out.println(alreadyClap);
        
        for(int i = 1; i<shylevels.length; i++){
            if(alreadyClap >= i)
                alreadyClap += shylevels[i];
            else {
                count += (i - alreadyClap);
                alreadyClap = i + shylevels[i];
            }
        }
        return count;
    }
}
