import java.io.FileNotFoundException;
import java.io.IOException;


public class MainRPI {

	
	
	public static void main(String[] args) {
		
		CFileReader fr = null;
		CFileWriter fw = null;
		int numberOfCases;
		try {
			fr = new CFileReader("input.txt");
			fw = new CFileWriter("output.txt");
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		
		try {
			numberOfCases = Integer.parseInt(fr.ReadLine());
			int numOfTeams = 0;
			for(int i = 0; i < numberOfCases; ++i)
			{
				numOfTeams = Integer.parseInt(fr.ReadLine());
				double[][] matrix = new double[numOfTeams][4];
				String[] teams = new String[numOfTeams];
				for(int j = 0; j < numOfTeams; ++j)
				{
					teams[j] = fr.ReadLine();
					double played,won;
					played=won=0;
					for(int k = 0; k  < numOfTeams; ++k)
					{
						if(teams[j].charAt(k) == '1')
						{
							played++;
							won++;
						}
						else if(teams[j].charAt(k) == '0')
						{
							played++;
						}
					}
					matrix[j][0] = won / played;
					matrix[j][3] = played;
				}
				for(int y = 0; y < numOfTeams; ++y)
				{
					double played, TotalWP;
					
					played = TotalWP = 0;
					for(int k=0 ; k < numOfTeams; k++)
					{
						if(teams[y].charAt(k) != '.')
						{
							double tempWP = matrix[k][0];
							tempWP *= matrix[k][3];
							if(teams[k].charAt(y) == '1')
							{
								tempWP --;
							}
							tempWP /= (matrix[k][3] - 1);
							TotalWP += tempWP;
							played++;
						}
					}
					matrix[y][1] = TotalWP / played;
				}
				for(int y = 0; y < numOfTeams; ++y)
				{
double played, TotalWP;
					
					played = TotalWP = 0;
					for(int k=0 ; k < numOfTeams; k++)
					{
						if(teams[y].charAt(k) != '.')
						{
							double tempWP = matrix[k][1];
							TotalWP += tempWP;
							played++;
						}
					}
					matrix[y][2] = TotalWP / played;
				}
				fw.printCase("");
				for(int z=0;z < numOfTeams; ++z)
				{
					fw.print(String.valueOf(matrix[z][0]*0.25 + matrix[z][1]*0.5 + matrix[z][2]*0.25));
				}	
			}
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
