import static java.lang.Integer.parseInt;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Comparator;
import java.util.StringTokenizer;

import org.apache.commons.math3.util.FastMath;
import org.apache.commons.math3.util.Pair;


public class BNew {

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int T = parseInt(br.readLine());
		for (int ii = 1; ii <= T; ii++) {
			int N = parseInt(br.readLine());
			StringTokenizer tok = new StringTokenizer(br.readLine());
			Integer[] A = new Integer[N];
			for (int i = 0; i < N; i++) {
				A[i] = parseInt(tok.nextToken());
			}
//			System.out.println("A=" + Arrays.toString(A));
			long res = solve(N, A);
			System.out.printf("Case #%d: %d\n", ii, res);
		}
	}

	private static long solve(int n, Integer[] a) {
		Integer[] perm = new Integer[n];
		for (int i = 0; i < n; i++) {
			perm[i] = a[i];
		}
		Arrays.sort(perm);
		long min = dist(a, perm);
		while (( perm = nextPermutation( perm ) ) != null) {
			if (isOk(perm)) {				
				long tmp = dist(a, perm);
				if (tmp < min) {
					min = tmp;
				}
			}
		}
		return min;
	}

	static long dist(Integer[] a, Integer[] B) {
		Integer[] bc = Arrays.copyOf(B, B.length);
		int af = 0;
		int al = a.length - 1;
		
		int cnt = 0;
		while (af < al) {
			int bf = -1;
			int bl = -1;
			for (int i = 0; i < bc.length; i++) {
				if (bc[i] == a[af]) {
					bf = i;
				} else if (bc[i] == a[al]) {
					bl = i;
				}
			}
			assert(bf >= 0 && bl >= 0);
			if (bf - af < al - bl) {
				for (int i = bf; i > af; --i) {
					swap(bc, i, i-1);
					++cnt;
				}
				++af;
			} else {
				for (int i = bl; i < al; i++) {
					swap(bc, i, i+1);
					++cnt;
				}
				--al;
			}
		}
		assert Arrays.equals(a,  bc) : String.format("a=%s, bc=%s",  Arrays.toString(a), Arrays.toString(B));
		return cnt;
	}

	static boolean isOk(Integer[] perm) {
		int N = perm.length;
		if (N == 1) {
			return true;
		}
		int i = 1;
		while (i < N && perm[i - 1] < perm[i]) {
			++i;
		}
		while (i < N && perm[i - 1] > perm[i]) {
			++i;
		}
		return i == N;
	}

	// modifies c to next permutation or returns null if such permutation does not exist
	static Integer[] nextPermutation( final Integer[] c ) {
		// 1. finds the largest k, that c[k] < c[k+1]
		int first = getFirst( c );
		if ( first == -1 ) return null; // no greater permutation
		// 2. find last index toSwap, that c[k] < c[toSwap]
		int toSwap = c.length - 1;
		while ( c[ first ].compareTo( c[ toSwap ] ) >= 0 )
			--toSwap;
		// 3. swap elements with indexes first and last
		swap( c, first++, toSwap );
		// 4. reverse sequence from k+1 to n (inclusive) 
		toSwap = c.length - 1;
		while ( first < toSwap )
			swap( c, first++, toSwap-- );
		return c;
	}

	// finds the largest k, that c[k] < c[k+1]
	// if no such k exists (there is not greater permutation), return -1
	private static int getFirst( final Comparable[] c ) {
		for ( int i = c.length - 2; i >= 0; --i )
			if ( c[ i ].compareTo( c[ i + 1 ] ) < 0 )
				return i;
		return -1;
	}

	// swaps two elements (with indexes i and j) in array 
	private static void swap( final Comparable[] c, final int i, final int j ) {
		final Comparable tmp = c[ i ];
		c[ i ] = c[ j ];
		c[ j ] = tmp;
	}
}
