import static java.lang.Integer.parseInt;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.StringTokenizer;

public class C {

	static ArrayList<Integer>[] g;
	static String[] zips;

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int T = parseInt(br.readLine());
		StringTokenizer tok;
		for (int ii = 1; ii <= T; ii++) {
			int N, M;
			tok = new StringTokenizer(br.readLine());
			N = parseInt(tok.nextToken());
			M = parseInt(tok.nextToken());
			zips = new String[N];
			for (int i = 0; i < N; i++) {
				zips[i] = br.readLine();
			}
			g = new ArrayList[N];
			for (int i = 0; i < g.length; i++) {
				g[i] = new ArrayList<Integer>();
			}
			for (int i = 0; i < M; i++) {
				tok = new StringTokenizer(br.readLine());
				int f = parseInt(tok.nextToken()) - 1;
				int t = parseInt(tok.nextToken()) - 1;
				g[f].add(t);
				g[t].add(f);
			}
			System.out.printf("Case #%d: %s\n", ii, solve(N, M));
		}
	}

	private static String solve(int N, int M) {
		Integer[] perm = new Integer[N];
		for (int i = 0; i < perm.length; i++) {
			perm[i] = i;
		}

		String min = null;
		StringBuilder buff = new StringBuilder();
		if (isOk(perm)) {
			buff.setLength(0);
			for (int i = 0; i < perm.length; i++) {
				buff.append(zips[i]);
			}
			min = buff.toString();
		}
		while ((perm = nextPermutation(perm)) != null) {
			if (isOk(perm)) {
				buff.setLength(0);
				for (int i = 0; i < perm.length; i++) {
					buff.append(zips[perm[i]]);
				}
				String tmp = buff.toString();
				if (min == null || tmp.compareTo(min) < 0) {
					min = tmp;
				}
			}
		}
		return min;
	}

	private static boolean isOk(Integer[] perm) {
		// boolean[] avail = new boolean[perm.length];
		// Arrays.fill(avail, true);
		// avail[perm[0]] = false;

		LinkedList<Integer> stack = new LinkedList<>();
		stack.add(perm[0]);

		outer: for (int i = 1; i < perm.length; i++) {
			while (true) {
				Integer top = stack.peek();
				if (top == null) {
					return false;
				} else {
					if (g[top].contains(perm[i])) {
						stack.addFirst(perm[i]);
						continue outer;
					} else {
						stack.poll();
					}
				}
			}
		}
		return true;
	}

	// modifies c to next permutation or returns null if such permutation does
	// not exist
	private static Integer[] nextPermutation(final Integer[] c) {
		// 1. finds the largest k, that c[k] < c[k+1]
		int first = getFirst(c);
		if (first == -1)
			return null; // no greater permutation
		// 2. find last index toSwap, that c[k] < c[toSwap]
		int toSwap = c.length - 1;
		while (c[first].compareTo(c[toSwap]) >= 0)
			--toSwap;
		// 3. swap elements with indexes first and last
		swap(c, first++, toSwap);
		// 4. reverse sequence from k+1 to n (inclusive)
		toSwap = c.length - 1;
		while (first < toSwap)
			swap(c, first++, toSwap--);
		return c;
	}

	// finds the largest k, that c[k] < c[k+1]
	// if no such k exists (there is not greater permutation), return -1
	private static int getFirst(final Comparable[] c) {
		for (int i = c.length - 2; i >= 0; --i)
			if (c[i].compareTo(c[i + 1]) < 0)
				return i;
		return -1;
	}

	// swaps two elements (with indexes i and j) in array
	private static void swap(final Comparable[] c, final int i, final int j) {
		final Comparable tmp = c[i];
		c[i] = c[j];
		c[j] = tmp;
	}

}
