import static java.lang.Integer.parseInt;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.StringTokenizer;


public class C_Dijkstra {

	static int MB = 1 << 20;
	static BufferedReader br = new BufferedReader(new InputStreamReader(
			System.in, StandardCharsets.US_ASCII), 10 * MB);
	static StringTokenizer st;

	static String NL() throws Exception {
		String s = br.readLine();
		st = new StringTokenizer(s);
		return s;
	}

	static String NT() {
		return st.nextToken();
	}

	public static void main(String[] args) throws Exception {
		NL();
		int T = parseInt(NT());
		for (int ii = 1; ii <= T; ii++) {
			NL();
			int L = parseInt(NT());
			int X = parseInt(NT());
			char[] ca = NL().toCharArray();
			char[] nca = new char[L * X];
			for (int i = 0; i < X; i++) {
				copy(ca, nca, i * L);
			}
			print(ii, solve(nca));
		}
	}

	private static void print(int tc, boolean sol) {
		System.out.printf("Case #%d: %s%n", tc, sol ? "YES" : "NO");		
	}

	private static boolean solve(char[] nca) {
		CACHE = new Integer[10001][10001];
		for (int s2 = 1; s2 < nca.length; s2++) {
//			System.out.println("DEBUG: s2=" + s2);
			if (eval(nca, 0, s2 - 1) == 'i') {
				for (int s3 = s2 + 1; s3 < nca.length; s3++) {
					if (eval(nca, s2, s3 - 1) == 'j' 
					&&	eval(nca, s3, nca.length - 1) == 'k') return true;
				}
			}
		}
		return false;
	}

	private static int eval(int c1, int c2) {
		int ac1 = Math.abs(c1);
		int ac2 = Math.abs(c2);

		int ares = -1000;
		switch (ac1) {
		case '1':
			switch(ac2){
			case '1': ares = '1'; break;
			case 'i': ares =  'i'; break;
			case 'j': ares = 'j'; break;
			case 'k': ares = 'k'; break;
			}
			break;

		case 'i':
			switch(ac2){
			case '1': ares = 'i'; break;
			case 'i': ares = -'1'; break;
			case 'j': ares = 'k'; break;
			case 'k': ares = -'j'; break;
			}
			break;

		case 'j':
			switch(ac2){
			case '1': ares = 'j'; break;
			case 'i': ares = -'k'; break;
			case 'j': ares = -'1'; break;
			case 'k': ares = 'i'; break;
			}
			break;

		case 'k':
			switch(ac2){
			case '1': ares = 'k'; break;
			case 'i': ares = 'j'; break;
			case 'j': ares = -'i'; break;
			case 'k': ares = -'1'; break;
			}
			break;

		}
		return c1 * c2 < 0 ? -ares : ares;
	}
	
	static Integer[][] CACHE;
	
	private static int eval(char[] nca, int f, int t) {
		if (f == t) return nca[f];
		if (CACHE[f][t] != null) return CACHE[f][t];
		CACHE[f][t] = eval(eval(nca, f, t - 1), nca[t]);
		return CACHE[f][t];
	}

	private static void copy(char[] orig, char[] dest, int from) {
		for (int i = 0, j = from; i < orig.length; ++i, ++j) {
			dest[j] = orig[i];
		}
	}
}
