import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.Reader;



public class A {

	public static void main( String[] args ) throws Exception {
		final Reader READER;
		final File FILE; // "betlista=etc/problem.in"
		final boolean DEBUG;
		long start = 0L;
		if ( args.length > 0 && args[ 0 ].startsWith( "betlista=" ) ) {
			FILE = new File( args[ 0 ].substring( "betlista=".length() ) );
		} else {
			FILE = null;
		}
		if ( FILE != null && FILE.exists() ) {
			READER = new FileReader( FILE );
			DEBUG = true;
		} else {
			READER = new InputStreamReader( System.in );
			DEBUG = false;
		}
		BufferedReader br = new BufferedReader( READER );

		if ( DEBUG )
			start = System.currentTimeMillis();

		final int T = Integer.parseInt( br.readLine() );
		String[] rc;
		int r, c;
		String[] pict;
		for ( int i = 0; i < T; ++i ) {
			rc = br.readLine().split( " " );
			r = Integer.parseInt( rc[0] );
			pict = new String[r];
			for ( int j = 0; j < r; ++j ) {
				pict[j] = br.readLine();
			}
			System.out.printf( "Case #%d:\n%s", i+1, solve(pict) );
		}

		if ( DEBUG )
			System.out.println( System.currentTimeMillis() - start );
	}

	private static String solve( String[] pict ) {
		final int R = pict.length;
		final int C = pict[0].length();
		char[][] res = new char[R][C];
		int bc = 0;
		for ( int i = 0; i < R; ++i ) {
			for ( int j = 0; j < C; ++j ) {
				res[i][j] = pict[i].charAt( j );
				if ( res[i][j] == '#' ) {
					++bc;
				}
			}
		}
		if ( bc%4 != 0 ) {
			return "Impossible\n";
		}
		
		int[] pos;
		while ( bc > 0 ) {
			pos = find( res );
			if ( pos == null ) return "Impossible\n";
			res = paint( res, pos[0], pos[1] );
			bc -= 4;
		}
		
		StringBuilder buff = new StringBuilder();
		for ( int i = 0; i < R; ++i ) {
			buff.append( new String( res[i] ) ).append("\n");			
		}
		return buff.toString();
	}

	private static int[] find( char[][] res ) {
		final int R = res.length;
		final int C = res[0].length;
		
		for ( int i = 0; i < R-1; ++i ) {
			for ( int j = 0; j < C-1; ++j ) {
				if ( check( res, i, j ) ) {
					return new int[] { i, j };
				}
			}
		}
		return null;
	}

	private static boolean check( char[][] res, int i, int j ) {
		return res[  i  ][j + 1] == '#' 
			&& res[  i  ][  j  ] == '#' 
			&& res[i + 1][j + 1] == '#' 
			&& res[i + 1][  j  ] == '#';
	}

	private static char[][] paint( char[][] res, int i, int j ) {
		res[  i  ][  j  ] = '/';
		res[  i  ][j + 1] = '\\';
		res[i + 1][  j  ] = '\\';
		res[i + 1][j + 1] = '/';
		return res;
	}

}
