import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.Reader;

import org.junit.Assert;
import org.junit.Test;

public class B {

	public static void main( String[] args ) throws Exception {
		final Reader READER;
		final File FILE; // "betlista=etc/problem.in"
		final boolean DEBUG;
		long start = 0L;
		if ( args.length > 0 && args[ 0 ].startsWith( "betlista=" ) ) {
			FILE = new File( args[ 0 ].substring( "betlista=".length() ) );
		} else {
			FILE = null;
		}
		if ( FILE != null && FILE.exists() ) {
			READER = new FileReader( FILE );
			DEBUG = true;
		} else {
			READER = new InputStreamReader( System.in );
			DEBUG = false;
		}
		BufferedReader br = new BufferedReader( READER );

		if ( DEBUG )
			start = System.currentTimeMillis();

		final int T = Integer.parseInt( br.readLine() );
		String[] ints;
		int L, N, C;
		long t;
		for ( int i = 0; i < T; ++i ) {
			ints = br.readLine().split( " " );
			L = Integer.parseInt( ints[ 0 ] );
			t = Long.parseLong(   ints[ 1 ] );
			N = Integer.parseInt( ints[ 2 ] );
			C = Integer.parseInt( ints[ 3 ] );
			System.out.printf( "Case #%d: %d\n", i + 1, solve( L, t, N, C, conv( ints, C, N ) ) );
		}

		if ( DEBUG )
			System.out.println( System.currentTimeMillis() - start );
	}

	private static long solve( int l, long t, int n, int c, int[] vzd ) {
		int[] sum = new int[ vzd.length + 1];
		sum[0] = 0;
		for ( int i = 1; i <= vzd.length; ++i ) {
			sum[i] = sum[i-1] + 2 * vzd[i - 1];
		}
		return getResult(l, t, sum, n);
	}

	private static long getResult( int l, long t, int[] sum, final int n ) {
		if ( l == 0 ) return sum[ n ];
		
//		assert ( sum.length + 1 == n ) : "chyba";
		
		Long max = null;
		if ( l == 1 ) {
			long delta;
			for ( int i = 0; i <= n - 1; ++i ) {
				delta = putBooster( sum, i, t );
				if ( max == null || delta > max ) {
					max = delta;
				}
			}
		}

		if ( l == 2 ) {
			long delta1, delta2;
			for ( int i = 0; i <= n-2; ++i ) {
				delta1 = putBooster( sum, i, t );
				for ( int j = i + 1; j <= n - 1; ++j ) {
					delta2 = putBooster( sum, j, t );
					if ( max == null || delta1 + delta2 > max ) {
						max = delta1 + delta2;
					}
				}
			}
		}

		return sum[n] - max;
	}

	private static long putBooster( int[] sum, int pos, long t ) {
		long odletZ = sum[pos];
		long priletDo = sum[pos+1];
		long cas = priletDo - odletZ;
		assert ( cas%2 == 0 ) : "chyba" ;
		if ( t <= odletZ ) return cas / 2; // cele zrychlene
		if ( t >= priletDo ) return 0; // nic zrychlene

		assert ( (priletDo - t) % 2 == 0 ) : "chyba" ;
		return (priletDo - t) / 2;
	}

	private static int[] conv( String[] ints, int c, int n ) {
		int[] res = new int[n];
		int idx;
		for ( int i = 0; i < n; ++i ) {
			idx = i%c;
			res[i] = Integer.parseInt( ints[idx + 4] );
		}
		return res;
	}

	@Test
	public void test_1() {
		Assert.assertEquals( 9, solve( 1, 8, 2, 2, conv( new String[] { "1", "8", "3", "2", "2", "3" }, 2, 3 ) ), 1E-6 );
	}

	@Test
	public void test_3() {
		Assert.assertEquals( 20, solve( 1, 4, 2, 2, conv( new String[] { "1", "4", "2", "2", "10", "4" }, 2, 2 ) ), 1E-6 );
	}

	@Test
	public void test_2() {
		Assert.assertEquals( 54, solve( 2, 20, 8, 2, conv( new String[] { "2", "20", "8", "2", "3", "5" }, 2, 8 ) ), 1E-6 );
	}

}
