import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigDecimal;

public class B {

	public static void main( final String[] args ) throws Exception {
		final BufferedReader br = new BufferedReader( new InputStreamReader( System.in ) );
		final int T = toi( br.readLine() );
		for ( int ii = 0; ii < T; ++ii ) {
			final String[] parts = br.readLine().split( " " );
			final double D = tod( parts[ 0 ] );
			final int N = toi( parts[ 1 ] );
			final int A = toi( parts[ 2 ] );

			final double[] t = new double[N];
			final double[] x = new double[N];
			for ( int i = 0; i < N; ++i ) {
				final double[] tmp = tod( br.readLine().split( " " ) );
				t[ i ] = tmp[ 0 ];
				x[ i ] = tmp[ 1 ];
			}
			final double[] a = tod( br.readLine().split( " " ) );
			System.out.printf( "Case #%d:\n%s", ii + 1, toStr( solve( D, N, A, t, x, a ) ) );
		}
	}

	private static String toStr( final double[] res ) {
		final StringBuilder buff = new StringBuilder();
		for ( int i = 0; i < res.length; ++i ) {
			buff.append( res[ i ] ).append( '\n' );
		}
		return buff.toString();
	}

	public static double[] solve( final double D, final int N, final int A, final double[] t, final double[] x,
			final double[] a ) {
		final double[] res = new double[a.length];
		for ( int i = 0; i < a.length; ++i ) {
			//			res[ i ] = solve2( D, t.length, t, x, a[ i ] );
			res[ i ] = solve3( D, t.length, t, x, a[ i ] );
		}
		return res;
	}

	private static double solve3( final double d, final int length, final double[] t, final double[] x, final double a ) {
		double mv = 0; // my velosity
		final BigDecimal mvbd = BigDecimal.ZERO;
		double md = 0;
		final BigDecimal mdbd = BigDecimal.ZERO;
		double tprev = 0;
		for ( int i = 1; i < t.length; ++i ) {
			if ( x[ i ] > d ) {
				final double cd = x[ i ] - x[ i - 1 ];
				final double cv = cd / ( t[ i ] - t[ i - 1 ] ); //car v
				x[ i ] = d;
				t[ i ] = t[ i - 1 ] + ( d - x[ i - 1 ] ) / cv;
				break;
			}
		}
		// for each part
		if ( t.length > 1 ) {
			for ( int i = 1; i < t.length; ++i ) {
				final double dist = x[ i ] - md;
				final double D = 4 * mv * mv + 8 * a * dist;
				assert ( D >= 0 );
				final double sD = Math.sqrt( D );
				final double t1 = ( -2 * mv + sD ) / ( 2 * a );
				final double t2 = ( -2 * mv - sD ) / ( 2 * a );
				double mt = t1 > 0 ? t1 : t2;
				final double dt = t[ i ] - t[ i - 1 ];
				if ( mt < dt ) {
					if ( x[ i ] == d ) {
						return dt + tprev;
					}
					//				final double dx = x[ i ] - x[ i - 1 ];
					mv = mv + mt * a; //car v
					tprev = t[ i ];
					md = x[ i ];
				} else {
					if ( x[ i ] == d ) {
						return mt + tprev;
					}
					mv = mv + a * mt;
					md = x[ i ];
					mt = mt + tprev;
				}
			}
		} else {
			final double cd = x[ 0 ];
			final double cv = cd / ( t[ 0 ] ); //car v
			x[ 0 ] = d;
			t[ 0 ] = ( d ) / cv;

			final double mt = Math.sqrt( 2 * d / a );
			final double dt = t[ 0 ];
			if ( mt < dt ) {
				return dt;
			} else {
				return mt;
			}
		}
		throw new IllegalStateException();
	}

	private static double solve2( final double d, final int length, final double[] t, final double[] x, final double a ) {
		final double myCarTime = Math.sqrt( 2 * d / a );
		for ( int i = 1; i < t.length; ++i ) {
			if ( x[ i ] >= d ) {
				final double dd = d - x[ i - 1 ];
				final double dd2 = x[ i ] - x[ i - 1 ];
				final double td = t[ i ] - t[ i - 1 ];
				final double v = dd2 / td;
				final double oct = dd / v;
				if ( oct > myCarTime ) {
					return oct;
				} else {
					return myCarTime;
				}
			}
		}
		throw new IllegalStateException();
	}

	// *** helper methods ***

	public static int toi( final String s ) {
		return Integer.parseInt( s );
	}

	public static int[] toi( final String[] sa ) {
		final int[] res = new int[sa.length];
		for ( int i = 0; i < res.length; ++i ) {
			res[ i ] = toi( sa[ i ] );
		}
		return res;
	}

	public static long tol( final String s ) {
		return Long.parseLong( s );
	}

	public static long[] tol( final String[] sa ) {
		final long[] res = new long[sa.length];
		for ( int i = 0; i < res.length; ++i ) {
			res[ i ] = tol( sa[ i ] );
		}
		return res;
	}

	public static double tod( final String s ) {
		return Double.parseDouble( s );
	}

	public static double[] tod( final String[] sa ) {
		final double[] res = new double[sa.length];
		for ( int i = 0; i < res.length; ++i ) {
			res[ i ] = tod( sa[ i ] );
		}
		return res;
	}

}
