import static java.lang.Integer.parseInt;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.Arrays;
import java.util.PriorityQueue;
import java.util.StringTokenizer;


public class B_InfiniteHouseOfPancakesNew {

	static int MB = 1 << 20;
	static BufferedReader br = new BufferedReader(new InputStreamReader(
			System.in, StandardCharsets.US_ASCII), 10 * MB);
	static StringTokenizer st;

	static String NL() throws Exception {
		String s = br.readLine();
		st = new StringTokenizer(s);
		return s;
	}

	static String NT() {
		return st.nextToken();
	}

	public static void main(String[] args) throws Exception {
		NL();
		int T = parseInt(NT());
		for (int ii = 1; ii <= T; ii++) {
			NL();
			int N = parseInt(NT());
			NL();
			int[] P = new int[N];
			for (int i = 0; i < N; i++) {
				P[i] = parseInt(NT());
			}
			print(ii, solve(N, P));
		}
	}

	private static int solve(int N, int[] A) {
		State f = new State(0, A);
		
		PriorityQueue<State> pq = new PriorityQueue<>();
		pq.add(f);
		while (pq.isEmpty() == false) {
			State act = pq.poll();
			if ( act.max() <= 2 ) {
				return act.cost + act.max();
			}
			addStates(pq, act);
		}
		throw new IllegalStateException();
	}

	private static void addStates(PriorityQueue<State> pq, State o) {
		// no special
		int[] cp = Arrays.copyOf(o.P, o.P.length);
		for (int i = 0; i < cp.length; i++) {
			if (cp[i] > 0) --cp[i];
		}
		State n1 = new State(o.cost + 1, cp);
		pq.add(n1);

		// special
		int omax = o.max();
		int[] na = new int[o.P.length + 1];
		for (int i = 0; i < o.P.length; i++) {
			na[i] = o.P[i];
		}
		for (int i = 0; i < o.P.length; i++) {
			if (o.P[i] == omax) {
				na[i] = omax / 2;
				na[na.length - 1] = (omax+1) >> 1;
				break;
			}
		}
		State n2 = new State(o.cost + 1, na);
		pq.add(n2);
	}

	static class State implements Comparable<State> {
		
		int cost;
		int[] P;

		public State(int cost, int[] a) {
			this.cost = cost;
			P = a;
		}

		public int max() {
			int max = P[0];
			for (int i = 1; i < P.length; i++) max = Math.max(max, P[i]);
			return max;
		}
		
		@Override
		public int compareTo(State s) {
			return Integer.compare(this.cost, s.cost);
		}
		
		@Override
		public String toString() {
			return String.format("%d: %s", cost, Arrays.toString(P));
		}
	}
	
	private static void print(int tc, int sol) {
		System.out.printf("Case #%d: %d%n", tc, sol);
	}

}
