package r1A;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.util.Arrays;

public class Rotate {

	private static char[][] rotate( char[][] c ) {
		char[][] res = new char[c.length][c.length];
		
		for (int i = 0; i < c.length; ++i) {
			Arrays.fill(res[i], '.');
		}
		// for each c row
		for (int r = 0; r < c.length; ++r) {
			int i = c.length - 1;
			for (int s = c.length - 1; s >= 0; --s) {
				if ( c[r][s] != '.' ) {
					res[i][c.length - 1 - r] = c[r][s];
					--i;
				}
			}
		}
//		for (int i = 0; i < c.length; ++i) {
//			System.out.println( new String(res[i]) );
//		}
		return res;
	}

	private static int checkDown( int r, int s, int K, char[][] b ) {
		int res = 0;
		boolean allB = true;
		boolean allR = true;
		for ( int i = r; i < r+K; ++i ) {
			if ( b[i][s] != 'B' ) {
				allB = false;
			}
			if ( b[i][s] != 'R' ) {
				allR = false;
			}
		}
		if ( allB ) res |= 1;
		if ( allR ) res |= 2;
		return res;
	}

	private static int checkRight( int r, int s, int K, char[][] b ) {
		int res;
		boolean allB = true;
		boolean allR = true;
		for ( int i = s; i < s+K; ++i ) {
			if ( b[r][i] != 'B' ) {
				allB = false;
			}
			if ( b[r][i] != 'R' ) {
				allR = false;
			}
		}
		if ( allB ) res = 1;
		else if (allR) res = 2;
		else res = 0;
		return res;
	}

	private static int checkRightDown( int r, int s, int K, char[][] b ) {
		int res;
		boolean allB = true;
		boolean allR = true;
		for ( int i = 0; i < K; ++i ) {
			if ( b[r+i][s+i] != 'B' ) {
				allB = false;
			}
			if ( b[r+i][s+i] != 'R' ) {
				allR = false;
			}
		}
		if ( allB ) res = 1;
		else if (allR) res = 2;
		else res = 0;
		return res;
	}

	private static int checkLeftDown( int r, int s, int K, char[][] b ) {
		int res;
		boolean allB = true;
		boolean allR = true;
		for ( int i = 0; i < K; ++i ) {
			if ( b[r+i][s-i] != 'B' ) {
				allB = false;
			}
			if ( b[r+i][s-i] != 'R' ) {
				allR = false;
			}
		}
		if ( allB ) res = 1;
		else if (allR) res = 2;
		else res = 0;
		return res;
	}

	/**
	 * 
	 * @param K
	 * @param r
	 * @return 0 neither, 1 B, 2 R, 3 both
	 */
	private static int find( int K, char[][] r ) {
		final int N = r.length;
		int res = 0;
		
		for (int i = 0; i <= N - K; ++i) {
			for (int j = 0; j < N; ++j) {
				res |= checkDown( i, j, K, r );
			}
		}

		for (int i = 0; i < N; ++i) {
			for (int j = 0; j <= N - K; ++j) {
				res |= checkRight( i, j, K, r );
			}
		}

		for (int i = 0; i <= N - K; ++i) {
			for (int j = 0; j <= N - K; ++j) {
				res |= checkRightDown( i, j, K, r );
			}
		}

		for (int i = 0; i <= N - K; ++i) {
			for (int j = K-1; j < N; ++j) {
				res |= checkLeftDown( i, j, K, r );
			}
		}

		return res;
	}

	private static String solve( final int N, final int K, final String[] b ) {
//		System.out.println( "N="+ N + ", K="+ K );
		String res = "";
		
		char[][] c = new char[N][];
		for (int i = 0; i < N; ++i) {
			c[i] = b[i].toCharArray();
		}
		char[][] r = rotate( c );
		int p = find( K, r );
		switch (p) {
			case 0: res = "Neither"; break;
			case 1: res = "Blue"; break;
			case 2: res = "Red"; break;
			case 3: res = "Both"; break;
		}
		return res;
	}

	public static void main(String[] args) throws Exception {
		/*char[][] b = { {'B', '.', '.', '.'}
					 , {'B', 'R', '.', 'R'}
					 , {'B', 'R', 'R', 'R'}
					 , {'.', 'R', '.', 'R'}
					 };
		System.out.println( checkDown ( 0, 0, 3, b) );
		System.out.println( checkRight( 2, 1, 3, b) );
		System.out.println( checkRightDown( 1, 1, 3, b) );
		System.out.println( checkLeftDown( 1, 3, 3, b) );
		*/
		final String fileName;
//		fileName = "etc/gcj/2010/1A/rotate_my.in";
		fileName = "etc/gcj/2010/1A/A-small-attempt0.in";
		final BufferedReader br = new BufferedReader(new FileReader(new File(fileName)));
		
		String line = br.readLine();
		final int T = Integer.parseInt( line );
		String[] nk;
		int N, K;
		String[] b;
		for (int ii  = 0; ii  < T; ++ii ) {
			line = br.readLine();
			nk = line.split( " " );
			N = Integer.parseInt( nk[0] );
			K = Integer.parseInt( nk[1] );
			b = new String[N];
			for (int i = 0; i < N; ++i) {
				b[i] = br.readLine();
			}
			System.out.println( "Case #" + (ii+1) + ": " + solve(N, K, b) );
		}
	}

}
