import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.Arrays;
import java.util.StringTokenizer;


public class NoisyNeighborsSmall {

	static int MB = 1 << 20;
	static BufferedReader br = new BufferedReader(new InputStreamReader(
			System.in, StandardCharsets.US_ASCII), 10 * MB);
	static StringTokenizer st;

	static String NL() throws Exception {
		String s = br.readLine();
		st = new StringTokenizer(s);
		return s;
	}

	static String NT() {
		return st.nextToken();
	}

	public static void main(String[] args) throws Exception {
		int T = Integer.parseInt(NL());
		int R, C, N;
		for (int ii = 1; ii <= T; ii++) {
			NL();
			R = Integer.parseInt(NT());
			C = Integer.parseInt(NT());
			N = Integer.parseInt(NT());
			print(ii, solve(R, C, N));
		}
	}

	private static void print(int ii, int sol) {
		System.out.printf("Case #%d: %d%n", ii, sol);
	}

	static boolean[][] B;
	
	private static int solve(int R, int C, int N) {
		if ( (R*C+1)/2 >= N) return 0;
		B = new boolean[R+2][C+2];
		for (int ri = 0; ri < R + 2; ri++) {
			Arrays.fill(B[ri], true);
		}
		// border
		Arrays.fill(B[0], false);
		for (int ri = 1; ri < R + 2; ri++) {
			B[ri][0] = false;
			B[ri][C+1] = false;
		}
		Arrays.fill(B[R+1], false);
		int act = R * C;
		while (act > N) {
			int max = 0;
			int maxr = 0, maxc = 0;
			for (int ri = 1; ri < R + 2; ri++) {
				for (int ci = 1; ci < C + 2; ci++) {
					int tmp = count(B, ri, ci);
					if (tmp > max) {
						maxr = ri;
						maxc = ci;
						max = tmp;
					}
				}
			}
			B[maxr][maxc] = false;
			--act;
		}
		return countAll(B, R, C);
	}

	static int countAll(boolean[][] B, int R, int C) {
		int cnt = 0;
		for (int ri = 1; ri < R + 2; ri++) {
			for (int ci = 1; ci < C + 2; ci++) {
				cnt += count(B, ri, ci);
			}
		}
		return cnt / 2;
	}

	static int countAll2(boolean[][] B, int R, int C) {
		int cnt = 0;
		for (int ri = 1; ri < R + 2; ri++) {
			for (int ci = 1; ci < C + 2; ci++) {
				if (B[ri][ci]) ++cnt;
			}
		}
		return cnt;
	}

	static int[] rx = { -1, 0, 0, 1 };
	static int[] cx = { 0, -1, 1, 0 };
	
	private static int count(boolean[][] B, int ri, int ci) {
		int cnt = 0;
		for (int i = 0; i < 4; i++) {
			int nri = ri + rx[i];
			int nci = ci + cx[i];
			if (B[ri][ci] && B[nri][nci]) {
				++cnt;
			}
		}
		return cnt;
	}
	
}
