import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.Map;
import java.util.TreeMap;



public class RevengeOfTheHotDogs {

	public static void main( String[] args ) throws Exception {
		final Reader READER;
		final File FILE; // "betlista=etc/problem.in"
		final boolean DEBUG;
		long start = 0L;
		if ( args.length > 0 && args[ 0 ].startsWith( "betlista=" ) ) {
			FILE = new File( args[ 0 ].substring( "betlista=".length() ) );
		} else {
			FILE = null;
		}
		if ( FILE != null && FILE.exists() ) {
			READER = new FileReader( FILE );
			DEBUG = true;
		} else {
			READER = new InputStreamReader( System.in );
			DEBUG = false;
		}
		BufferedReader br = new BufferedReader( READER );

		if ( DEBUG )
			start = System.currentTimeMillis();

		final int T = Integer.parseInt( br.readLine() ); // CONTINUE HERE
		String[] cd, pv;
		int c, d, p, v, n = 0;
		Map<Integer, Integer> pos = new TreeMap<Integer, Integer>();
		for ( int i = 0; i < T; ++i ) {
			cd = br.readLine().split( " " );
			c = Integer.parseInt( cd[0] );
			d = Integer.parseInt( cd[1] );
			pos.clear();
			n = 0;
			for ( int j = 0; j < c; ++j ) {
				pv = br.readLine().split( " " );
				p = Integer.parseInt( pv[0] );
				v = Integer.parseInt( pv[1] );
				n += v;
				pos.put( p, v );
			}
			System.out.printf( "Case #%d: %f\n", i+1, solve( c, d, pos, n ) );
		}

		if ( DEBUG )
			System.out.println( System.currentTimeMillis() - start );
	}

	private static double solve( int c, int d, Map<Integer, Integer> pos, int n ) {
		double res = 0D;
		double[] vp = new double[ n ];
		  // init
		for ( int i = 0; i < n; ++i ) {
			vp[i] = i*d;
		}
		
		double[] dist = dist( vp, pos);
		
		double min = dist[0];
		double absMax = Math.abs( dist[0] );
		boolean moveLeft = dist[0] > 0;
		for ( int i = 1; i < dist.length; ++i ) {
			if ( Math.abs( dist[i] ) < min ) {
				min = Math.abs( dist[i] );
			}
			if ( Math.abs( dist[i] ) > absMax ) {
				absMax = Math.abs( dist[i] );
				moveLeft = dist[i] > 0;
			}
		}
		while ( absMax - Math.abs(min) > 1e-6 ) {
			dist = move( dist, (absMax + min) / 2D, moveLeft );
			min = dist[0];
			absMax = Math.abs( dist[0] );
			moveLeft = dist[0] > 0;
			for ( int i = 1; i < dist.length; ++i ) {
				if ( dist[i] < min ) {
					min = dist[i];
				}
				if ( Math.abs( dist[i] ) > absMax ) {
					absMax = Math.abs( dist[i] );
					moveLeft = dist[i] > 0;
				}
			}
		}
		return absMax;
	}

	private static double[] move( double[] dist, double d, boolean moveLeft ) {
		for ( int i = 0; i < dist.length; ++i ) {
			if ( moveLeft ) {
				dist[i] -= d;
			} else {
				dist[i] += d;
			}
		}
		return dist;
	}

	private static double[] dist( double[] vp, Map<Integer, Integer> pos ) {
		double[] res = new double[ vp.length ];
		
		int i = 0;
		int cnt;
		for ( Integer key : pos.keySet() ) {
			cnt = pos.get( key );
			for ( int j = 0; j < cnt; ++j ) {
				res[i] = vp[i] - key;
				++i;
			}
		}
		
		return res;
	}
	
	
}
