import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.StringTokenizer;


public class Lawnmower {

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String line = br.readLine();
		int T = Integer.parseInt(line);
		StringTokenizer tok;
		for (int ii = 0; ii < T; ii++) {
			line = br.readLine();
			tok = new StringTokenizer(line);
			int R = Integer.parseInt(tok.nextToken());
			int C = Integer.parseInt(tok.nextToken());
			int[][] b = new int[R][C];
			for (int i = 0; i < R; i++) {
				line = br.readLine();
				tok = new StringTokenizer(line);
				for (int j = 0; j < C; j++) {
					b[i][j] = Integer.parseInt(tok.nextToken());
				}
			}
			
			System.out.printf( "Case #%d: %s\n", ii+1, solve(R, C, b) );
		}
	}

	private static final String YES = "YES";
	private static final String NO  = "NO";
	
	public static String solve(int R, int C, int[][] b) {
		int[][] act = new int[R][C];
		for (int i = 0; i < R; i++) {
			Arrays.fill(act[i], 100);
		}
		while ( true ) {
			boolean modified = false;
			for (int ri = 0; ri < R; ri++) {
				int d = canModifyR(ri, R, C, b, act);
				if ( d > 0 ) {
					modifyR(ri, d, R, C, b, act);
					modified = true;
				}
			}
			for (int ci = 0; ci < C; ci++) {
				int d = canModifyC(ci, R, C, b, act);
				if (d > 0 ) {
					modifyC(ci, d, R, C, b, act);
					modified = true;
				}
			}
			if ( ok(R, C, b, act) ) {
				return YES;
			}
			if (modified == false) {
				return NO;
			}
		}
	}

	private static void modifyC(int ci, int nv, int R, int C, int[][] b, int[][] act) {
		for (int ri = 0; ri < R; ri++) {
			act[ri][ci] = nv;
		}
	}

	private static int canModifyC(int ci, int R, int C, int[][] b,
			int[][] act) {
		int bmax = b[0][ci];
		for (int ri = 1; ri < R; ri++) {
			bmax = Math.max(bmax, b[ri][ci]);
		}
		int dmax = act[0][ci] - bmax;
		for (int ri = 0; ri < R; ri++) {
			int d = act[ri][ci] - bmax;
			dmax = Math.max(d, dmax);
		}
		return dmax > 0 ? bmax : 0;
	}

	private static void modifyR(int ri, int nv, int R, int C, int[][] b, int[][] act) {
		for (int ci = 0; ci < C; ci++) {
			act[ri][ci] = nv;
		}
	}

	private static int canModifyR(int ri, int R, int C, int[][] b,
			int[][] act) {
		int bmax = b[ri][0];
		for (int ci = 1; ci < C; ci++) {
			bmax = Math.max(bmax, b[ri][ci]);
		}
		int dmax = act[ri][0] - bmax;
		for (int ci = 0; ci < C; ci++) {
			int d = act[ri][ci] - bmax;
			dmax = Math.max(d, dmax);
		}
		return dmax > 0 ? bmax : 0;
	}

	private static boolean ok(int R, int C, int[][] b, int[][] act) {
		for (int i = 0; i < R; i++) {
			for (int j = 0; j < C; j++) {
				if ( b[i][j] != act[i][j]) return false;
			}
		}
		return true;
	}

}
