package qr;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Queue;

public class ThemePark {

	private static long solve( final int R, final int k, final int N, final int[] g) {
		long res = 0;
		final Queue<Integer> q1 = new LinkedList<Integer>();
		for ( int i = 0; i < N; ++i ) q1.add(g[i]); 
		final Queue<Integer> q2 = new LinkedList<Integer>();
		int act;
		long sum;
		for ( int i = 0; i < R; ++i ) {
			sum = 0;
			  // append l2 to the end of l1 and clear l2
			q1.addAll( q2 );
			q2.clear();
			  // get first group count in queue
			act = q1.element();
			  // if element in queue is bigger than roller coaster size, return earned money
			if ( act > k ) return res;
			while ( !q1.isEmpty() && sum + act <= k ) {
				  // ride group on roller coaster
				q1.remove();
				  // add group size to actual roller coaster load 
				sum += act;
				  // earn money too
				res += act;
				  // move the group to the next queue to prevent group from riding in one ride twice
				q2.add(act);
				if ( q1.isEmpty() ) break;
				  // get first group count in queue
				act = q1.element();
				  // if element in queue is bigger than roller coaster size, return earned money
				if ( act > k ) return res;
			}
//			System.out.println( q2 );
		}
		return res;
	}

	public static void main(String[] args) throws NumberFormatException, IOException {
		final String fileName;
//		fileName = "etc/gcj/2010/theme_park.in";
		fileName = "etc/gcj/2010/C-small-attempt0.in";
		final BufferedReader br = new BufferedReader( new FileReader( new File( fileName ) ) );
		final int T = Integer.parseInt( br.readLine() );
		String[] rkn;
		String[] gs;
		int R, k, N;
		int[] g;
		for ( int i = 0; i < T; ++i  ) {
			rkn = br.readLine().split(" ");
			R = Integer.parseInt( rkn[0] );
			k = Integer.parseInt( rkn[1] );
			N = Integer.parseInt( rkn[2] );
			g = new int[N];
			gs = br.readLine().split(" ");
			for (int j = 0; j < N; ++j) {
				g[j] = Integer.parseInt( gs[j] );
			}
			System.out.println( "Case #" + (i+1) + ": " + solve(R, k, N, g) );
		}
	}

}
