import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.Reader;



public class C {

	public static void main( String[] args ) throws Exception {
		final Reader READER;
		final File FILE; // "betlista=etc/problem.in"
		final boolean DEBUG;
		long start = 0L;
		if ( args.length > 0 && args[ 0 ].startsWith( "betlista=" ) ) {
			FILE = new File( args[ 0 ].substring( "betlista=".length() ) );
		} else {
			FILE = null;
		}
		if ( FILE != null && FILE.exists() ) {
			READER = new FileReader( FILE );
			DEBUG = true;
		} else {
			READER = new InputStreamReader( System.in );
			DEBUG = false;
		}
		BufferedReader br = new BufferedReader( READER );

		if ( DEBUG )
			start = System.currentTimeMillis();

		final int T = Integer.parseInt( br.readLine() ); // CONTINUE HERE
		String[] nlh, nsi;
		int n, l, h;
		for ( int i = 0; i < T; ++i ) {
			nlh = br.readLine().split( " " );
			n = Integer.parseInt( nlh[0] );
			l = Integer.parseInt( nlh[1] );
			h = Integer.parseInt( nlh[2] );
			nsi = br.readLine().split( " " );
			System.out.printf( "Case #%d: %s\n", i+1, solve( n, l, h, conv( nsi ) ) );
		}

		if ( DEBUG )
			System.out.println( System.currentTimeMillis() - start );
	}

	private static String solve( int n, int l, int h, int[] fi ) {
		for ( int i = l; i <= h; ++i ) {
			if ( test( fi, i ) ) {
				return "" + i;
			}
		}
		return "NO";
	}

	private static boolean test( int[] fi, int nf ) {
		for ( int i = 0; i < fi.length; ++i ) {
			if ( !inHarmony( fi[i], nf ) ) {
				return false;
			}
		}
		return true;
	}

	private static boolean inHarmony( int f1, int f2 ) {
		if ( f1 == f2 ) return true;
		if ( f1 > f2 ) return f1%f2 == 0;
		return f2%f1 == 0;
	}

	private static int[] conv( String[] nsi ) {
		int[] res = new int[ nsi.length ];
		for ( int i = 0; i < nsi.length; ++i ) {
			res[i] = Integer.parseInt( nsi[i] );
		}
		return res;
	}
}
