import static java.lang.Integer.parseInt;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.StringTokenizer;


public class A_MushroomMonster {

	static int MB = 1 << 20;
	static BufferedReader br = new BufferedReader(new InputStreamReader(
			System.in, StandardCharsets.US_ASCII), 10 * MB);
	static StringTokenizer st;

	static String NL() throws Exception {
		String s = br.readLine();
		st = new StringTokenizer(s);
		return s;
	}

	static String NT() {
		return st.nextToken();
	}

	public static void main(String[] args) throws Exception {
		NL();
		int T = parseInt(NT());
		for (int ii = 1; ii <= T; ++ii ) {
			NL();
			int N = parseInt(NT());
			NL();
			int[] A = new int[N];
			for (int i = 0; i < A.length; i++) {
				A[i] = parseInt(NT());
			}
			print(ii, solve(N, A));
		}
	}

	private static void print(int ii, Result sol) {
		System.out.printf("Case #%d: %d %d%n", ii, sol.min1, (long)Math.round(sol.min2));
	}

	private static Result solve(int N, int[] A) {
		Result res = new Result();
		int curr = 0;
		for (int i = 0; i < N; i++) {
			if (A[i] < curr) {
				res.min1 += curr - A[i];
			}
			curr = A[i];
		}
		res.min2 = solve2(N, A);
		return res;
	}
	
	private static long solve2(int N, int[] A) {
		int speed = 0;
		for (int i = 1; i < N; i++) {
			int d = A[i-1] - A[i];
			if (d > 0) {
				speed = Math.max(speed, d);
			}
		}
		return simulate(N, A, speed);
	}

	private static long simulate(int N, int[] A, int s) {
		long res = 0;
		long curr = A[0];
		for (int t = 1; t < N; t++) {
			double d = Math.min(s, curr);
			curr -= d;
			res += d;
			curr = A[t];
		}
		return res;
	}

	static class Result {
		long min1 = 0;
		long min2 = 0;
	}
}
