import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.nio.charset.StandardCharsets;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;

public class CountingSheep {

	static InputStreamReader isr = new InputStreamReader(System.in, StandardCharsets.US_ASCII);
	static BufferedReader br = new BufferedReader(isr, 20 << 20);

	public static void main(String[] args) throws Exception {
		final ExecutorService es = Executors.newFixedThreadPool(5);

		Result[] res = parseInputAndCreateSolvers(es);
		
		printResults(es, res);
	}
	
	private static Result[] parseInputAndCreateSolvers(ExecutorService es) throws Exception {
		int T = Integer.parseInt(br.readLine());
		Result[] res = new Result[T];
		for (int i = 0; i < res.length; i++) {
			int N = Integer.parseInt(br.readLine());
			res[i] = new Result();
			es.submit(new Solver(res[i], N));
		}
		
		return res;
	}

	private static void printResults(ExecutorService es, Result[] res) {
		es.shutdown();
		while (!es.isTerminated()) {
			try {
				Thread.sleep(1000);
			} catch (InterruptedException ie) {
				ie.printStackTrace();
			}
		}
		final StringBuilder sb = new StringBuilder();
		for (int ii = 0; ii < res.length; ii++) {
			sb.append("Case #").append(ii+1).append(": ").append(res[ii]).append('\n');
		}
		System.out.print(sb);
	}

	static class Solver extends ResultHolder {
		
		int N;
		
		Solver(Result res, int N) {
			super(res);
			this.N = N;
		}
		
		@Override
		public void run() {
			if (N == 0) {
				res.str = "INSOMNIA";
				return;
			}
			boolean[] used = new boolean[10];
			int differentDigits = 0;
			int k = 1;
			do {
				String ns = Integer.toString(k * N);
				for (char c : ns.toCharArray()) {
					if (!used[c - '0']) {
						++differentDigits;
						used[c - '0'] = true; 
					}
				}
				++k;
			} while (differentDigits < 10);
			res.str = Integer.toString((k-1) * N);
		}
	}
	
	static class ResultHolder extends Thread {
		Result res;

		public ResultHolder(Result res) {
			this.res = res;
		}
		
	}
	static class Result {
		
		String str;

		@Override
		public String toString() {
			return str;
		}
	}
}
