import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;


public class TicTacToe
{

    PrintWriter out;

    public void read() throws IOException
    {
        BufferedReader br = new BufferedReader(new FileReader("A-large.in"));
        out = new PrintWriter(new FileWriter("output.out"));
        int n = Integer.parseInt(br.readLine());
        int i = 0;
        //int j = 0;
        String line;
        while (i < n)
        {
            String[][] matrix = new String[4][4];
           
            for (int p=0;p<4;p++){
                line = br.readLine();
                String[] tokens = line.split("");
                for (int q=0; q<4; q++){
                    matrix[p][q] = tokens[q+1]; 
                }
            }
            line = br.readLine();
               
            solve(i + 1, matrix);
            i++;
        }

        out.close();
        out.flush();
    }
    
    private void solve(int c, String[][] matrix)
    {

        out.print("Case #" + c + ": ");
        //System.out.println(matrix.toString());
        
        int state = gameState(matrix, 4);
        if (state == 1){
            out.print("X won");
        }else if(state == 2){
            out.print("O won");
        }else if(state == 3){
            out.print("Draw");
        }else if(state == 4){
            out.print("Game has not completed");
        }
                
        out.println();
        out.flush();
    }
    /**
     * @param args
     */
    public static void main(String[] args) throws IOException
    {
        new TicTacToe().read();
    }
       
    int gameState(String values[][], int boardSz) {

        int X_WIN = 1;
        int O_WIN = 2;
        int DRAW = 3;
        int INPROGRESS = 4;
        
        boolean colCheckNotRequired[] = new boolean[boardSz];//default is false
        boolean diag1CheckNotRequired = false;
        boolean diag2CheckNotRequired = false;
        boolean allFilled = true;
        boolean tfound = false;


        int x_count = 0;
        int o_count = 0;
        /* Check rows */
        for (int i = 0; i < boardSz; i++) {
            x_count = o_count = 0;
            for (int j = 0; j < boardSz; j++) {
                if(values[i][j].equals("X"))x_count++;
                if(values[i][j].equals("O"))o_count++;
                if(values[i][j].equals("T"))tfound = true;
                if(values[i][j].equals("."))
                {
                    colCheckNotRequired[j] = true;
                    if(i==j)diag1CheckNotRequired = true;
                    if(i + j == boardSz - 1)diag2CheckNotRequired = true;
                    allFilled = false;
                    //No need check further
                    break;
                }
            }
            if(x_count == boardSz)return X_WIN;
            if(o_count == boardSz)return O_WIN;    
            if(tfound){
                if(x_count +1 == boardSz)return X_WIN;
                if(o_count +1 == boardSz)return O_WIN;
                tfound = false;
            }
        }


        /* check cols */
        for (int i = 0; i < boardSz; i++) {
            x_count = o_count = 0;
            if(colCheckNotRequired[i] == false)
            {
                for (int j = 0; j < boardSz; j++) {
                    if(values[j][i].equals("X"))x_count++;
                    if(values[j][i].equals("O"))o_count++;
                    if(values[j][i].equals("T"))tfound = true;
                    //No need check further
                    if(values[i][j].equals("."))break;
                }
                if(x_count == boardSz)return X_WIN;
                if(o_count == boardSz)return O_WIN;
                if(tfound){
                    if(x_count +1 == boardSz)return X_WIN;
                    if(o_count +1 == boardSz)return O_WIN;
                    tfound = false;
                }
            }
        }

        x_count = o_count = 0;
        /* check diagonal 1 */
        if(diag1CheckNotRequired == false)
        {
            for (int i = 0; i < boardSz; i++) {
                if(values[i][i].equals("X"))x_count++;
                if(values[i][i].equals("O"))o_count++;
                if(values[i][i].equals("T"))tfound = true;
                if(values[i][i].equals("."))break;
            }
            if(x_count == boardSz)return X_WIN;
            if(o_count == boardSz)return O_WIN;
            if(tfound){
                if(x_count +1 == boardSz)return X_WIN;
                if(o_count +1 == boardSz)return O_WIN;
                tfound = false;
            }
        }

        x_count = o_count = 0;
        /* check diagonal 2 */
        if( diag2CheckNotRequired == false)
        {
            for (int i = boardSz - 1,j = 0; i >= 0 && j < boardSz; i--,j++) {
                if(values[j][i].equals("X"))x_count++;
                if(values[j][i].equals("O"))o_count++;
                if(values[j][i].equals("T"))tfound = true;
                if(values[j][i].equals("."))break;
            }
            if(x_count == boardSz)return X_WIN;
            if(o_count == boardSz)return O_WIN;
            if(tfound){
                if(x_count +1 == boardSz)return X_WIN;
                if(o_count +1 == boardSz)return O_WIN;
                tfound = false;
            }
            x_count = o_count = 0;
        }

        if( allFilled == true)
        {
            for (int i = 0; i < boardSz; i++) {
                for (int j = 0; j < boardSz; j++) {
                    if (values[i][j].equals(".")) {
                        allFilled = false;
                        break;
                    }
                }

                if (allFilled == false) {
                    break;
                }
            }
        }

        if (allFilled)
            return DRAW;

        return INPROGRESS;
    } 
}
