import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Dijkstra {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws FileNotFoundException {

		Map<Integer, Integer> map = new HashMap<Integer, Integer>();
		map.put(1, 0);
		map.put((int) 'i', 1);
		map.put((int) 'j', 2);
		map.put((int) 'k', 3);
		int[][] grid = { { 1, 'i', 'j', 'k' }, { 'i', -1, 'k', -'j' },
				{ 'j', -'k', -1, 'i' }, { 'k', 'j', -'i', -1 } };

		Scanner scan = new Scanner(System.in);
		PrintWriter pr = new PrintWriter(new FileOutputStream(
				"DijkstraOutput.txt"));
		int t = scan.nextInt();

		for (int i = 1; i <= t; i++) {
			int n = scan.nextInt();
			int m = scan.nextInt();
			String s = scan.next();
			int comm = 1;
			boolean goti = false, gotij = false, gotijk = false;
			for (int j = 0; j < n * m; j++) {
				int jj = j % n;
				int op = s.charAt(jj);
				int absComm = Math.abs(comm);
				// System.out.println(comm + " " + map.get(absComm));
				// System.out.println(op + " " + map.get(op));
				comm = comm / absComm * grid[map.get(absComm)][map.get(op)];
				if (comm == (int) 'i') {
					goti = true;
				}
				if (goti && comm == (int)'k') {
					gotij = true;
				}
				if (gotij && comm == -1) {
					gotijk = true;
				} else {
					gotijk = false;
				}

			}
			// System.out.println(goti + " " + gotij + " " + gotijk);
			String output = "NO";
			if(goti && gotij && gotijk) {
				output = "YES";
			}
				
			pr.print("Case #" + i + ": " + output);

			pr.println();
		}

		pr.close();
		scan.close();

	}

}
