import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class War {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Scanner in = new Scanner(System.in);
		int rounds = in.nextInt();
		for (int i = 0; i < rounds; i++) {
			int numBlocks = in.nextInt();
			Game game1 = new Game();
			Game game2 = new Game();
			for (int j = 0; j < numBlocks; j++) {
				double block = in.nextDouble();
				game1.addHerBlock(block);
				game2.addHerBlock(block);
			}
			for (int j = 0; j < numBlocks; j++) {
				double block = in.nextDouble();
				game1.addHisBlock(block);
				game2.addHisBlock(block);
			}
			System.out.println("Case #"+(i+1)+": "+game1.playUnfairGame()+" "+game2.playFairGame());
		}
	}

	private static class Game {
		private int warWins = 0;
		private List<Double> herBlocks = new ArrayList<Double>();
		private List<Double> hisBlocks = new ArrayList<Double>();

		public Game() {

		}

		public void addHerBlock(double block) {
			herBlocks.add(block);
			Collections.sort(herBlocks);
		}

		public void addHisBlock(double block) {
			hisBlocks.add(block);
			Collections.sort(hisBlocks);
		}

		public int playFairGame() {
			while (herBlocks.size() > 0) {
				playHisTurn(playHerTurn());
			}
			return warWins;
		}

		public int playUnfairGame() {
			while (herBlocks.size() > 0) {
				playHisTurn(cheatHerTurn());
			}
			return warWins;
		}

		private double cheatHerTurn() {
			while(herBlocks.size()>0) {
				if(herBlocks.get(herBlocks.size()-1)>hisBlocks.get(0)) {
					herBlocks.remove(getLowestWinningBlock(herBlocks,hisBlocks.get(0)));
					return 1;
				} else {
					return herBlocks.remove(0);
				}
			}
			return herBlocks.remove(herBlocks.size()-1);
		}

		private double playHerTurn() {
			return herBlocks.remove(herBlocks.size() - 1);
		}

		private void playHisTurn(double herBlock) {
			if (hisBlocks.get(hisBlocks.size() - 1) > herBlock) {

				hisBlocks.remove(getLowestWinningBlock(hisBlocks,herBlock)); // He plays his lowest that wins
				return;

			} else {
				hisBlocks.remove(0); // he playes his lowest block and loses
										// because he cannot win
				warWins++;
			}
		}

		// assumes there's at least 1 winning block
		private int getLowestWinningBlock(List<Double> blocks, double block) {
			for (int i = blocks.size() - 1; i >= 0; i--) {
				if (blocks.get(i) < block) {
					return i + 1;
				}
			}
			return 0;
		}
	}
}
