import java.util.Arrays;

public class TicTacToe {
	
	protected String[][] board;
	
	public TicTacToe()
	{
		board = new String[4][4];
		for(int i=0; i<4; i++)
		{
			Arrays.fill(board[i], ".");
		}
	}
	
	public void addRow(int row, String line)
	{
		for(int i=0; i<line.length(); i++)
		{
			board[row][i] = Character.toString(line.charAt(i));
		}
	}
	
	public String toString()
	{
		StringBuilder sBuilder = new StringBuilder();
		for(int i=0; i<board.length; i++)
		{
			for(int j=0; j<board[i].length; j++)
			{
				sBuilder.append(board[i][j]);
			}
			sBuilder.append("\n");
		}
		return sBuilder.toString();
	}
	
	private int countPoints (String cell)
	{
		int points = 0;
		switch(cell)
		{
			case "X" : points += 1;
				break;
			case "O" : points -= 1;
				break;
			case "." : points += 50;
				break;
			default :
				break;
		}
		return points;
	}
	
	public String Solve()
	{
		boolean isNotComplete = false;
		int pointsDiag1 = 0;
		int pointsDiag2 = 0;
		
		for(int i=0; i<board.length; i++)
		{
			int pointsRow = 0;
			int pointsColumn = 0;
			
			pointsDiag1 += countPoints(board[i][i]);
			pointsDiag2 += countPoints(board[i][(board.length-1-i)]);
			
			for(int j=0; j<board.length; j++)
			{
				pointsRow += countPoints(board[i][j]);
				pointsColumn += countPoints(board[j][i]);
			}
			if(pointsRow <= -3 || pointsColumn <= -3)
			{
				return "O won";
			}
			else if((pointsRow >= 3 && pointsRow < 47) || (pointsColumn >= 3 && pointsColumn < 47))
			{
				return "X won";
			}
			else if(pointsRow >= 47 || pointsColumn >= 47)
			{
				isNotComplete = true;
			}
		}
		
		if(pointsDiag1 <= -3 || pointsDiag2 <= -3)
		{
			return "O won";
		}
		else if((pointsDiag1 >= 3 && pointsDiag1 < 47) || (pointsDiag2 >= 3 && pointsDiag2 < 47))
		{
			return "X won";
		}
    	
		if(isNotComplete)
		{
			return "Game has not completed";
		}
    	
		return "Draw";
	}
}
