import java.util.Arrays;

public class LawnMo {
	
	protected int[][] lawn;
	
	public LawnMo(int n, int m)
	{
		lawn = new int[n][m];
		for(int i=0; i<n; i++)
		{
			Arrays.fill(lawn[i], 0);
		}
	}
	
	public void addRow(int row, String line)
	{
		String [] s = line.split(" ");
		
		for(int i=0; i<s.length; i++)
		{
			lawn[row][i] = Integer.parseInt(s[i]);
		}
	}
	
	public String Solve()
	{
		if(lawn.length == 1)
			return "YES";
		else if (lawn[0].length == 1)
		{
			return "YES";
		}
		
		for(int i=0; i<lawn.length; i++)
		{
			int minRow = minRow(lawn[i]);
			int minCol = -1;
			
			for(int j=0;j<lawn[i].length; j++)
			{
				if(lawn[i][j] == minRow)
				{
					minCol = minColumn(j);
					if(minRow > minCol)
					{
						return "NO";
					}
				}
			}
		}
		return "YES";
	}
	
	private int minRow(int[] t)
	{
		int min = t[0];
		for (int i = 0; i < t.length; i++) {
            if (min > t[i]) {
                min = t[i];
            }
        }
		return min;
	}
	
	private int minColumn(int col)
	{
		int min = lawn[0][col];
		for (int i = 0; i < lawn.length; i++) {
            if (min > lawn[i][col]) {
                min = lawn[i][col];
            }
        }
		return min;
	}
	
	public String toString()
	{
		StringBuilder sBuilder = new StringBuilder();
		for(int i=0; i<lawn.length; i++)
		{
			for(int j=0; j<lawn[i].length; j++)
			{
				sBuilder.append(lawn[i][j]);
			}
			sBuilder.append("\n");
		}
		return sBuilder.toString();
	}
}
