
import java.io.*;
import java.util.*;
import java.math.*;

public class C3 {

    static BufferedReader in;
    static PrintWriter out;

    public static void main(String[] args) throws Exception {

        in = new BufferedReader(new FileReader("C3.in"));
        out = new PrintWriter(new BufferedWriter(new FileWriter("C3.out")));

        int t = Integer.parseInt(in.readLine());

        for (int i = 1; i <= t; i++) {

            StringTokenizer st = new StringTokenizer(in.readLine());

            int N = Integer.parseInt(st.nextToken());
            int L = Integer.parseInt(st.nextToken());
            int H = Integer.parseInt(st.nextToken());

            BigInteger[] f = new BigInteger[N];

            st = new StringTokenizer(in.readLine());
            for (int j = 0; j < N; j++) {
                f[j] = new BigInteger(st.nextToken());
            }

            Arrays.sort(f);

            BigInteger[] A = new BigInteger[N];
            BigInteger[] B = new BigInteger[N];

            A[0] = f[0];
            for (int j = 1; j < N; j++) {
                A[j] = (A[j - 1].multiply(f[j])).divide(gcd(A[j - 1], f[j]));
            }

            B[N - 1] = f[N - 1];
            for (int j = N - 2; j >= 0; j--) {
                B[j] = gcd(B[j + 1], f[j]);
            }

            System.out.println(i + " --->  " + L + " - " + H);
            System.out.println(Arrays.toString(f));
            System.out.println(Arrays.toString(A));
            System.out.println(Arrays.toString(B));

            BigInteger res = BigInteger.ZERO;

            boolean found = false;

            for (BigInteger x = BigInteger.valueOf(L); x.compareTo(B[0]) <= 0; x = x.add(BigInteger.ONE)) {
                if (B[0].mod(x).compareTo(BigInteger.ZERO) == 0 && x.compareTo(BigInteger.valueOf(H)) <= 0) {
                    if (found) {
                        if (x.compareTo(res) < 0) {
                            res = x;
                        }
                    } else {
                        found = true;
                        res = x;
                    }
                    break;
                }
            }

            for (int j = 0; j < N - 1; j++) {
                for (BigInteger x = A[j].add(BigInteger.ZERO); x.compareTo(B[j + 1]) <= 0; x = x.add(A[j])) {
                    if (B[j + 1].mod(x).compareTo(BigInteger.ZERO) == 0 && BigInteger.valueOf(L).compareTo(x) <= 0 && x.compareTo(BigInteger.valueOf(H)) <= 0) {
                        if (found) {
                            if (x.compareTo(res) < 0) {
                                res = x;
                            }
                        } else {
                            found = true;
                            res = x;
                        }
                        break;
                    }
                }
            }

            if (!found ){
                BigInteger y = BigInteger.valueOf(L).mod(A[N-1]);
                if(y.compareTo(BigInteger.ZERO)==0){
                    found = true;
                    res = BigInteger.valueOf(L);
                }else{
                    BigInteger z = BigInteger.valueOf(L).subtract(y).add(A[N-1]);
                    if(z.compareTo(BigInteger.valueOf(H))<=0){
                        found = true;
                        res = z;
                    }
                }
            }

            System.out.println(res);
            out.println("Case #" + i + ": " + ((!found) ? "NO" : res));
        }


        // End of user code

        in.close();
        out.close();
    }

    static BigInteger gcd(BigInteger a, BigInteger b) {
        if (b.compareTo(BigInteger.ZERO) == 0) {
            return a;
        }
        return gcd(b, a.mod(b));
    }
}
