
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Main {

    static BufferedReader in;
    static PrintWriter out;
    static StringTokenizer stk;

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new FileReader("inB.txt"));
        out = new PrintWriter("outB.txt");
        stk = new StringTokenizer(in.readLine());
        // Start of User Code

        int T = ni();
        for (int i = 1; i <= T; i++) {
            int N = ni();
            int P = ni();
            printf("Case #%d: %s\n", i, proc(N, P));
        }

        // End of User Code
        in.close();
        out.close();
    }

    static int getA(int N, long i) {
        i = i + 1;
        int res = 0;
        int j = 0;
        while (i > 1) {
            res *= 2;
            res += 1;
            i /= 2;
            j++;
        }
        while (j < N) {
            j++;
            res *= 2;
        }
        return res;
    }

    static int getB(int N, long ii) {
        long i = (1L << N) - ii;
        int res = 0;
        int j = 0;
        while (i > 1) {
            res *= 2;
            res += 0;
            i /= 2;
            j++;
        }
        while (j < N) {
            j++;
            res *= 2;
            res += 1;
        }
        return res;
    }

    static String proc(int N, int P) {
        long hi = (1 << N) - 1;
        long lo = 0;
        while (lo < hi) {
            long mid = (hi + lo) / 2;
            if (getA(N, mid) < P) {
                lo = mid + 1;
            } else {
                hi = mid - 1;
            }
        }
        long res1 = lo;
        if(getA(N, res1)>=P)
            res1--;
        hi = (1 << N) - 1;
        lo = 0;
        while (lo < hi) {
            long mid = (hi + lo) / 2;
            if (getB(N, mid) < P) {
                lo = mid + 1;
            } else {
                hi = mid - 1;
            }
        }
        long res2 = lo;
        if(getB(N, res2)>=P)
            res2--;
        return res1 +" " + res2;
    }

    static void printf(String format, Object... args) {
        System.out.printf(format, args);
        out.printf(format, args);
    }

    static int ni() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Integer.parseInt(stk.nextToken());
    }

    static long nl() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Long.parseLong(stk.nextToken());
    }

    static double nd() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Double.parseDouble(stk.nextToken());
    }

    static String ns() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return stk.nextToken();
    }

    static int min(int a, int b) {
        return a < b ? a : b;
    }

    static int max(int a, int b) {
        return a > b ? a : b;
    }

    static long min(long a, long b) {
        return a < b ? a : b;
    }

    static long max(long a, long b) {
        return a > b ? a : b;
    }

    static int gcd(int a, int b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }

    static long gcd(long a, long b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }
}