
import java.util.*;
import java.io.*;
import java.math.*;

public class Main {

    static BufferedReader in;
    static PrintWriter out;
    static StringTokenizer stk;
    static boolean[] isPrime = new boolean[5000];

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new InputStreamReader(System.in));
        in = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(new FileWriter("output.txt"));
        stk = new StringTokenizer(in.readLine());
        // Start of User Code

        int T = ni();
        for (int t = 1; t <= T; t++) {
            out.printf("Case #%d: %s\n", t, proc());
        }

        // End of User Code
        out.close();
        in.close();
    }

    static String proc() throws Exception {
        int R = ni();
        int C = ni();
        char[][] grid = new char[R][];
        for (int i = 0; i < R; i++) {
            grid[i] = ns().toCharArray();
        }
        int[][] ft = new int[R][C];
        int[][] fb = new int[R][C];
        int[][] fl = new int[R][C];
        int[][] fr = new int[R][C];

        for (int i = 1; i < R; i++) {
            for (int j = 0; j < C; j++) {
                ft[i][j] = ft[i - 1][j] + (grid[i - 1][j] == '.' ? 1 : 0);
            }
        }

        for (int i = R - 2; i >= 0; i--) {
            for (int j = 0; j < C; j++) {
                fb[i][j] = fb[i + 1][j] + (grid[i + 1][j] == '.' ? 1 : 0);
            }
        }

        for (int j = 1; j < C; j++) {
            for (int i = 0; i < R; i++) {
                fl[i][j] = fl[i][j - 1] + (grid[i][j - 1] == '.' ? 1 : 0);
            }
        }

        for (int j = C - 2; j >= 0; j--) {
            for (int i = 0; i < R; i++) {
                fr[i][j] = fr[i][j + 1] + (grid[i][j + 1] == '.' ? 1 : 0);
            }
        }

        int result = 0;
        for (int i = 0; i < R; i++) {
            for (int j = 0; j < C; j++) {
                if (grid[i][j] != '.') {
                    if (ft[i][j] == i && fb[i][j] == R - 1 - i && fl[i][j] == j && fr[i][j] == C - 1 - j) {
                        return "IMPOSSIBLE";
                    }
                    switch (grid[i][j]) {
                        case '^':
                            if(ft[i][j] == i) result ++;
                            break;
                        case 'v':
                            if(fb[i][j] == R - 1 - i) result ++;
                            break;
                        case '<':
                            if(fl[i][j] == j) result ++;
                            break;
                        case '>':
                            if(fr[i][j] == C - 1 - j) result ++;
                            break;
                        default:
                            break;
                    }
                }
            }
        }

        return result + "";
    }

    static long modPow(long n, long pow, long mod) {
        return BigInteger.valueOf(n).modPow(BigInteger.valueOf(pow), BigInteger.valueOf(mod)).longValue();
    }

    static long modInv(long n, long mod, boolean isPrimeModuli) {
        if (isPrimeModuli) {
            return modPow(n, mod - 2, mod);
        }
        return BigInteger.valueOf(n).modInverse(BigInteger.valueOf(mod)).longValue();
    }

    // calc factorials
    static long[] fact;

    static void calcFactorials(int n) {
        fact = new long[n + 1];
        fact[0] = 1;
        for (int i = 1; i <= n; i++) {
            fact[i] = fact[i - 1] * i;
        }
    }

    static void calcFactorialsModM(int n, long M) {
        fact = new long[n + 1];
        fact[0] = 1;
        for (int i = 1; i <= n; i++) {
            fact[i] = fact[i - 1] * i;
            fact[i] %= M;
        }
    }

    static long ncr(int n, int r) {
        return fact[n] / (fact[n - r] * fact[r]);
    }

    static long ncrModM(int n, int r, long MOD, boolean isPrimeModuli) {
        return fact[n] * modInv(fact[n - r], MOD, isPrimeModuli) * modInv(fact[r], MOD, isPrimeModuli);
    }

    static long toL(String s) {
        return Long.parseLong(s);
    }

    static long toL(BigInteger n) {
        return n.longValue();
    }

    static int toI(String s) {
        return Integer.parseInt(s);
    }

    static double toD(String s) {
        return Double.parseDouble(s);
    }


    static void printf(String format, Object... args) {
        System.out.printf(format, args);
    }

    static int ni() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Integer.parseInt(stk.nextToken());
    }

    static long nl() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Long.parseLong(stk.nextToken());
    }

    static double nd() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Double.parseDouble(stk.nextToken());
    }

    static String ns() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return stk.nextToken();
    }

    static int min(int a, int b) {
        return a < b ? a : b;
    }

    static int max(int a, int b) {
        return a > b ? a : b;
    }

    static long min(long a, long b) {
        return a < b ? a : b;
    }

    static long max(long a, long b) {
        return a > b ? a : b;
    }

    static int gcd(int a, int b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }

    static long gcd(long a, long b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }
}