
import java.util.*;
import java.io.*;
import java.math.*;

public class Main {

    static BufferedReader in;
    static PrintWriter out;
    static StringTokenizer stk;
    static boolean[] isPrime = new boolean[5000];

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new InputStreamReader(System.in));
        in = new BufferedReader(new FileReader("input.txt"));
        out = new PrintWriter(new FileWriter("output.txt"));
        stk = new StringTokenizer(in.readLine());
        // Start of User Code

        int T = ni();
        for (int t = 1; t <= T; t++) {
            out.printf("Case #%d: %s\n", t, proc());
        }

        // End of User Code
        out.close();
        in.close();
    }

    static String proc() throws Exception {
        int N = ni();
        double V = nd();
        double X = nd();
        double[] r = new double[N];
        double[] c = new double[N];

        double rth = 0;
        double rte = 0;
        double rtl = 0;
        double ch = 0;
        double cl = 0;

        for (int i = 0; i < N; i++) {
            r[i] = nd();
            c[i] = nd();
            if (c[i] > X + 0.000001) {
                rth += r[i];
                ch += r[i] * c[i];
            } else if (c[i] < X - 0.000001) {
                rtl += r[i];
                cl += r[i] * c[i];
            } else {
                rte += r[i];
            }
        }

        //ch /= rth;
        //cl /= rtl;

        if (rth < 0.000001 && rtl < 0.000001) {
            return String.format("%.9f", new BigDecimal(V).divide(new BigDecimal(rte), 100, RoundingMode.CEILING).doubleValue());
        } else if (rth < 0.000001 || rtl < 0.000001) {
            if (rte > 0.000001) return String.format("%.9f",new BigDecimal(V).divide(new BigDecimal(rte), 100, RoundingMode.CEILING).doubleValue());
            else return "IMPOSSIBLE";
        } else {
            System.out.println(rte);
            System.out.println(rth);
            System.out.println(rtl);
            double p = Math.abs(X * rth - ch);
            double q = Math.abs(cl - X * rtl);
            BigDecimal P = new BigDecimal(p);
            BigDecimal Q = new BigDecimal(q);
            BigDecimal ALPHA = Q.divide(P,100, BigDecimal.ROUND_CEILING);
            double alpha = q / p;
            BigDecimal den;
            System.out.println(ALPHA.toString());
            if(alpha > 1){
                den = new BigDecimal(rtl).add(ALPHA.multiply(new BigDecimal(rth + rte))).divide(ALPHA, 100, BigDecimal.ROUND_CEILING);
                //return String.format("%.9f", V / (rtl + alpha * rth + alpha * rte)) + "";
            }else{
                den = new BigDecimal(rtl + rte).add(ALPHA.multiply(new BigDecimal(rth)));
                //return String.format("%.9f",V / (rtl + alpha * rth + rte)) + "";
            }
            return String.format("%.9f", new BigDecimal(V).divide(den, 15, BigDecimal.ROUND_CEILING).doubleValue());
        }
    }

    static long modPow(long n, long pow, long mod) {
        return BigInteger.valueOf(n).modPow(BigInteger.valueOf(pow), BigInteger.valueOf(mod)).longValue();
    }

    static long modInv(long n, long mod, boolean isPrimeModuli) {
        if (isPrimeModuli) {
            return modPow(n, mod - 2, mod);
        }
        return BigInteger.valueOf(n).modInverse(BigInteger.valueOf(mod)).longValue();
    }

    // calc factorials
    static long[] fact;

    static void calcFactorials(int n) {
        fact = new long[n + 1];
        fact[0] = 1;
        for (int i = 1; i <= n; i++) {
            fact[i] = fact[i - 1] * i;
        }
    }

    static void calcFactorialsModM(int n, long M) {
        fact = new long[n + 1];
        fact[0] = 1;
        for (int i = 1; i <= n; i++) {
            fact[i] = fact[i - 1] * i;
            fact[i] %= M;
        }
    }

    static long ncr(int n, int r) {
        return fact[n] / (fact[n - r] * fact[r]);
    }

    static long ncrModM(int n, int r, long MOD, boolean isPrimeModuli) {
        return fact[n] * modInv(fact[n - r], MOD, isPrimeModuli) * modInv(fact[r], MOD, isPrimeModuli);
    }

    static long toL(String s) {
        return Long.parseLong(s);
    }

    static long toL(BigInteger n) {
        return n.longValue();
    }

    static int toI(String s) {
        return Integer.parseInt(s);
    }

    static double toD(String s) {
        return Double.parseDouble(s);
    }


    static void printf(String format, Object... args) {
        System.out.printf(format, args);
    }

    static int ni() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Integer.parseInt(stk.nextToken());
    }

    static long nl() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Long.parseLong(stk.nextToken());
    }

    static double nd() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Double.parseDouble(stk.nextToken());
    }

    static String ns() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return stk.nextToken();
    }

    static int min(int a, int b) {
        return a < b ? a : b;
    }

    static int max(int a, int b) {
        return a > b ? a : b;
    }

    static long min(long a, long b) {
        return a < b ? a : b;
    }

    static long max(long a, long b) {
        return a > b ? a : b;
    }

    static int gcd(int a, int b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }

    static long gcd(long a, long b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }
}