
import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.HashMap;
import java.util.StringTokenizer;
import java.util.TreeMap;
import java.util.TreeSet;

public class Main {

    static BufferedReader in;
    static PrintWriter out;
    static StringTokenizer stk;
    static int N, M;
    static long actual, minimal;
    static Node[] nodes;
    static TreeSet<Integer> stops;
    static TreeMap<Integer, Long> keys;
    static HashMap<Integer, Long> getDown;
    static long MOD = 1000002013;

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new FileReader("inA.txt"));
        out = new PrintWriter("outA.txt");
        stk = new StringTokenizer(in.readLine());
        // Start of User Code

        int T = ni();
        for (int i = 1; i <= T; i++) {
            N = ni();
            M = ni();
            stops = new TreeSet<Integer>();
            keys = new TreeMap<Integer, Long>();
            getDown = new HashMap<Integer, Long>();
            actual = 0;
            minimal = 0;
            nodes = new Node[M];
            for (int j = 0; j < M; j++) {
                int a = ni();
                int b = ni();
                int p = ni();
                stops.add(a);
                stops.add(b);
                nodes[j] = new Node(a, b, p);
                long temp = 0;
                if (getDown.containsKey(b)) {
                    temp = getDown.get(b);
                }
                getDown.put(b, (temp + p));
                long A = b - a;
                actual += ((((long)p)*A * (long)(2 * N - A + 1)) / 2) % MOD;
                actual %= MOD;
            }
            printf("Case #%d: %s\n", i, proc());
        }

        // End of User Code
        in.close();
        out.close();
    }

    static String proc() {
        Arrays.sort(nodes);
        int i = 0;
        for(int s: stops){
            while(i < nodes.length && nodes[i].o<s)
                i++;
            while(i < nodes.length && nodes[i].o==s){
                long temp = 0;
                if (keys.containsKey(s)) {
                    temp = keys.get(s);
                }
                keys.put(s, (temp + nodes[i].p));
                i++;
            }
            if(getDown.containsKey(s)){
                long num = getDown.get(s);
                HashMap<Integer, Long> sss = new HashMap<Integer,Long>();
                for(Integer a: keys.descendingKeySet()){
                  long tt = keys.get(a);
                  long pp = 0;
                  if(num >=tt){
                      num -= tt;
                      pp = tt;
                  }else{
                      pp = num;
                      num = 0;
                  }
                  long A = s-a;
                  long B = (pp*A)%MOD;
                  minimal += ((B* (long)(2 * N - A + 1)) / 2) % MOD;
                  minimal %= MOD;
                  sss.put(a, pp);
                }
                for(Integer a:sss.keySet()){
                    keys.put(a, keys.get(a)-sss.get(a));
                }
            }
        }
        return (actual + MOD - minimal)%MOD + "";
    }

    static void printf(String format, Object... args) {
        System.out.printf(format, args);
        out.printf(format, args);
    }

    static int ni() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Integer.parseInt(stk.nextToken());
    }

    static long nl() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Long.parseLong(stk.nextToken());
    }

    static double nd() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return Double.parseDouble(stk.nextToken());
    }

    static String ns() throws Exception {
        while (!stk.hasMoreTokens()) {
            stk = new StringTokenizer(in.readLine());
        }
        return stk.nextToken();
    }

    static int min(int a, int b) {
        return a < b ? a : b;
    }

    static int max(int a, int b) {
        return a > b ? a : b;
    }

    static long min(long a, long b) {
        return a < b ? a : b;
    }

    static long max(long a, long b) {
        return a > b ? a : b;
    }

    static int gcd(int a, int b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }

    static long gcd(long a, long b) {
        if (b == 0) {
            return a;
        }
        return gcd(b, a % b);
    }
}
class Node implements Comparable<Node>{
    BigInteger id;
    
    // payload start
    int o, e;
    long p;
    // payload end

    public Node( int o, int e, long p) {
        this.o = o;
        this.e = e;
        this.p = p;
    }

    @Override
    public int compareTo(Node nn) {
        return Integer.valueOf(o).compareTo(nn.o);
    }
    
    public BigInteger id(){
        if(id == null){
            id = BigInteger.ZERO;
        }
        return id;
    }

    @Override
    public boolean equals(Object obj) {
        return this.getClass() == obj.getClass() && this.id.equals(((Node)obj).id());
    }

    @Override
    public int hashCode() {
        return this.id().hashCode();
    }
}