
import java.io.*;
import java.util.*;
import java.math.*;

public class Main {

    static PrintStream out;
    static BufferedReader in;

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new FileReader("Main.in"));
        out = new PrintStream("Main.out");
        int n = Integer.parseInt(in.readLine());
        for (int i = 1; i <= n; i++) {
            out.println("Case #" + i + ": " + proc(Integer.parseInt(in.readLine())));
        }
        out.close();
    }
    
    static String proc(int n) throws Exception{
        int[] dist = new int[n+1];
        int[] length = new int[n+1];
        for(int i = 1; i<=n; i++){
            String[] s = in.readLine().split(" ");
            dist[i] = Integer.parseInt(s[0]);
            length[i] = Integer.parseInt(s[1]);
        }
        int d = Integer.parseInt(in.readLine());
        
        Stack<State> st = new Stack<State>();
        st.add(new State(0, 1));
        while(!st.isEmpty()){
            State t = st.pop();
            long maxdist = dist[t.b] + Math.min(dist[t.b]- dist[t.a], length[t.b]);
            if(maxdist>= d)
                return "YES";
            for(int j = t.b+1; j<=n; j++){
                if(dist[j]>maxdist)
                    break;
                st.add(new State(t.b, j));
            }
        }
        
        
        return "NO";
    }
}
class State{
    int a,  b;
    public State(int a, int b) {
        this.a = a;
        this.b = b;
    }
}
