
import java.io.*;
import java.util.*;
import java.math.*;

public class Main {

    static PrintStream out;
    static Hashtable<Integer, BigDecimal> factorial = new Hashtable<Integer, BigDecimal>();
    static BigDecimal[] z = new BigDecimal[1001];
    static Hashtable<Integer, BigDecimal> expected = new Hashtable<Integer, BigDecimal>();

    public static void main(String[] args) throws Exception {

        z[0] = BigDecimal.ONE;
        for (int i = 1; i <= 1000; i++) {
            z[i] = z[i - 1].add(BigDecimal.valueOf(Math.pow(-1, i)).divide(fact(i), 20, BigDecimal.ROUND_HALF_UP));
            //System.out.println(z[i]);
        }
        //System.out.println(exp(3));
        BufferedReader bf = new BufferedReader(new FileReader("Q4.in"));
        out = new PrintStream("Q4.out");

        int T = Integer.parseInt(bf.readLine());
        for (int i = 1; i <= T; i++) {
            BigDecimal result = BigDecimal.ZERO;
            int N = Integer.parseInt(bf.readLine());
            StringTokenizer st = new StringTokenizer(bf.readLine());
            int[] k = new int[N + 1];
            boolean[] m = new boolean[N + 1];
            for (int j = 1; j <= N; j++) {
                k[j] = Integer.parseInt(st.nextToken());
            }
            TreeSet<Integer> temp = new TreeSet<Integer>();
            //System.out.println("case " + i + "\n");
            for (int j = 1; j <= N; j++) {
                if (!m[j]) {
                    int num = 0;
                    int x = k[j];
                    m[j] = true;
                    while (!temp.contains(x)) {
                        //System.out.println(x);
                        num++;
                        temp.add(x);
                        int y = x;
                        x = k[y];
                        m[y] = true;
                    }
                    //System.out.println("");
                    temp.clear();
                    result = result.add(exp(num));
                }
            }
            out.println("Case #" + i + ": " + result.setScale(7, BigDecimal.ROUND_UP).toPlainString() );
        }
        out.close();
    }

    static BigDecimal exp(int n) {
        if (n <= 1) {
            return BigDecimal.ZERO;
        }
        if (expected.containsKey(n)) {
            return expected.get(n);
        }
        BigDecimal res = pnr(n, n);
        for (int r= 0; r< n; r++) {
            res = res.add(BigDecimal.ONE.add(exp(r)).multiply(pnr(n,r)));
        }
        res = res.divide(BigDecimal.ONE.subtract(pnr(n,n)),20, BigDecimal.ROUND_HALF_UP);
        expected.put(n, res);
        return res;
    }

    static BigDecimal fact(int n) {
        if (n == 0) {
            return BigDecimal.ONE;
        }
        if (factorial.containsKey(n)) {
            return factorial.get(n);
        }
        BigDecimal temp = BigDecimal.valueOf(n).multiply(fact(n - 1));
        factorial.put(n, temp);
        return temp;
    }

    static BigDecimal pnr(int n, int r) {
        return z[r].divide(fact(n - r), 20, BigDecimal.ROUND_HALF_UP);
    }
}
