
import java.io.*;
import java.util.*;
import java.math.*;

public class Main {

    static PrintStream out;

    public static void main(String[] args) throws Exception {

        BufferedReader bf = new BufferedReader(new FileReader("Q2.in"));
        out = new PrintStream("Q2.out");

        int T = Integer.parseInt(bf.readLine());
        for (int i = 1; i <= T; i++) {
            StringTokenizer st = new StringTokenizer(bf.readLine());

            int c = Integer.parseInt(st.nextToken());

            Hashtable<Integer, Integer> combinations = new Hashtable<Integer, Integer>();
            for (int j = 0; j < c; j++) {
                String x = st.nextToken();
                int k = x.charAt(0) - 'A';
                int l = x.charAt(1) - 'A';
                int m = x.charAt(2) - 'A';
                combinations.put(k * 26 + l, m);
                combinations.put(l * 26 + k, m);
            }

            int d = Integer.parseInt(st.nextToken());

            TreeSet<Integer>[] opp = new TreeSet[26];
            for (int j = 0; j < 26; j++) {
                opp[j] = new TreeSet<Integer>();
            }
            for (int j = 0; j < d; j++) {
                String x = st.nextToken();
                int k = x.charAt(0) - 'A';
                int l = x.charAt(1) - 'A';
                opp[k].add(l);
                opp[l].add(k);
            }

            int n = Integer.parseInt(st.nextToken());

            String x = st.nextToken();

            int[] res = new int[n];

            int len = 0;

            for (int j = 0; j < n; j++) {
                int y = x.charAt(j) - 'A';

                if (len == 0) {
                    res[len++] = y;
                } else {
                    Integer z = combinations.get(y * 26 + res[len - 1]);
                    if (z != null) {
                        res[len - 1] = z;
                    } else {
                        if (is_any_common(res, len, opp[y])) {
                            len = 0;
                        } else {
                            res[len++] = y;
                        }
                    }
                }
            }
            char[] result = new char[len];
            for (int j = 0; j < len; j++) {
                result[j] = (char) (res[j] + 'A');
            }
            println("Case #" + i + ": " + Arrays.toString(result));
        }
        out.close();
    }

    static boolean is_any_common(int[] x, int len, TreeSet<Integer> y) {
        for (int i = 0; i<len; i++) {
            for (Integer b : y) {
                if (x[i] == b) {
                    return true;
                }
            }
        }
        return false;
    }

    static void println(String s) {
        System.out.println(s);
        out.println(s);
    }
}
