package y2017;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by bastingomezh on 2017-04-08.
 */
public class TidyNumbersSmall {

    private Map<Integer, Integer> tidyNumberMap = new HashMap<>();

    public static void main(String[] args) throws IOException {
        FileReader freader = new FileReader("codejam.y2017/tidynumbers/bgh1.in");
        Scanner sc = new Scanner(freader);
        int count = sc.nextInt();
        sc.nextLine();
        ArrayList<Integer> inputLst = new ArrayList<>(count);
        for (int i = 0; i < count; i++) {
            Integer input = sc.nextInt();
            inputLst.add(input);
        }

        TidyNumbersSmall tidyNumbers = new TidyNumbersSmall();
        ArrayList<Integer> output = tidyNumbers.findLastTidyNumberInList(inputLst);
        System.out.println(output);

        FileWriter fw = new FileWriter("codejam.y2017/tidynumbers/bgh1.out");
        BufferedWriter bw = new BufferedWriter(fw);

        int i = 1;
        for (; i <= output.size(); i++) {
            bw.write("Case #" + i + ": " + output.get(i - 1));
            bw.newLine();
        }
        bw.flush();
        bw.close();
        sc.close();

    }

    private ArrayList<Integer> findLastTidyNumberInList(ArrayList<Integer> inputLst) {
        ArrayList<Integer> result = new ArrayList<>(inputLst.size());

        for (Integer currItem : inputLst) {
            int lastNo = findLastTidyNumber(currItem);
            result.add(lastNo);
        }
        return result;
    }

    private int findLastTidyNumber(int currItem) {
        int result = currItem;

        for (int i = currItem; i >= 1 ; i--) {

            if (tidyNumberMap.containsKey(i)) {
                result = tidyNumberMap.get(i);
                break;
            }

            System.out.println(i);
            if (isTidyNumber(i)) {
                tidyNumberMap.put(currItem, i);
                result = i;
                break;
            }
        }
        return result;
    }

    private boolean isTidyNumber(int item) {
        while (item != 0) {

            if (item < 10) {
                return true;
            }

            int lastDigit = item % 10;
            item = item / 10;
            int secondLastDigit = item % 10;

            if (secondLastDigit > lastDigit) {
                return false;
            }
        }

        return true;
    }


}

/*
 Tatiana likes to keep things tidy. Her toys are sorted from smallest to largest, her pencils are sorted from shortest to longest and her computers from oldest to newest. One day, when practicing her counting skills, she noticed that some integers, when written in base 10 with no leading zeroes, have their digits sorted in non-decreasing order. Some examples of this are 8, 123, 555, and 224488. She decided to call these numbers tidy. Numbers that do not have this property, like 20, 321, 495 and 999990, are not tidy.

 She just finished counting all positive integers in ascending order from 1 to N. What was the last tidy number she counted?

 Input

 The first line of the input gives the number of test cases, T. T lines follow. Each line describes a test case with a single integer N, the last number counted by Tatiana.

 Output

 For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the last tidy number counted by Tatiana.

 Limits

 1 ≤ T ≤ 100.
 Small dataset

 1 ≤ N ≤ 1000.
 Large dataset

 1 ≤ N ≤ 1018.
 Sample


 Input

 Output

 4
 132
 1000
 7
 111111111111111110

 Case #1: 129
 Case #2: 999
 Case #3: 7
 Case #4: 99999999999999999

 Note that the last sample case would not appear in the Small dataset.
 */
