package codejam.y2016;

import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

public class CountingSheep {
	public static void main(String[] args) throws FileNotFoundException, IOException {
		FileReader freader = new FileReader("input/codejam.y2016/A-small-attempt0.in");
		Scanner sc = new Scanner(freader);
		int count = sc.nextInt();
		sc.nextLine();
		ArrayList<String> inputLst = new ArrayList<>(count);
		for(int i=0;i<count;i++) {
			String input = sc.nextLine();
			inputLst.add(input);
		}
		
		CountingSheep countingSheep = new CountingSheep();
		ArrayList<String> output = countingSheep.findLastNumberForList(inputLst);
		System.out.println(output);
		
		FileWriter fw = new FileWriter("input/codejam.y2016/A-small-attempt0.out");
		BufferedWriter bw = new BufferedWriter(fw);
		
		int i = 1;
		for(;i<=output.size();i++) {
			bw.write("Case #"+i+": "+ output.get(i-1));
			bw.newLine();
		}
		bw.flush();
		bw.close();
		sc.close();
	}

	private ArrayList<String> findLastNumberForList(ArrayList<String> inputLst) {
		ArrayList<String> result = new ArrayList<>(inputLst.size());
		
		for(String currStr: inputLst) {
			String lastNo = findLastNumber(currStr);
			result.add(lastNo);
		}
		return result;	
	}
	
	private String findLastNumber(String input) {
		boolean [] marker = new boolean[10];	
		
		BigInteger ip = new BigInteger(input);
		
		boolean isInsomnia = check4Insomnia(ip);
		if(isInsomnia) {
			return "INSOMNIA";
		}
		
		int multiplier = 1;
		
		BigInteger ip1 = ip;
		while(!gotAllMarker(marker)) {
			ip1 = ip.multiply(BigInteger.valueOf(multiplier));
			multiplier++;
			ArrayList<Integer> digits = getAllDigits(ip1);
			for(int digit : digits) {
				if(!marker[digit]) {
					marker[digit] = true;
				}
			}
			//System.out.println(Arrays.toString(marker));
		}
		return String.valueOf(ip1);
	}

	private ArrayList<Integer> getAllDigits(BigInteger ip) {
		ArrayList<Integer> digits = new ArrayList<>();
		while(!ip.equals(BigInteger.ZERO)) {
			digits.add(ip.mod(BigInteger.TEN).intValue());
			ip = ip.divide(BigInteger.TEN);
		}
		return digits;
	}

	private boolean gotAllMarker(boolean[] marker) {
		for(boolean b : marker){
			if(!b) {
				return false;
			}
		}
		return true;
	}

	private boolean check4Insomnia(BigInteger ip) {
		if(ip.equals(ip.multiply(BigInteger.valueOf(2))) && 
				ip.multiply(BigInteger.valueOf(2)).equals(ip.multiply(BigInteger.valueOf(4)))){
			return true;
		}
		return false;
	}
}
