package y2017;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * Created by bastingomezh on 2017-04-08.
 */
public class TidyNumbersLarge {

    private Map<Long, Long> tidyNumberMap = new HashMap<>();

    public static void main(String[] args) throws IOException {
        FileReader freader = new FileReader("codejam.y2017/tidynumbers/bgh2.in");
        Scanner sc = new Scanner(freader);
        int count = sc.nextInt();
        sc.nextLine();
        ArrayList<Long> inputLst = new ArrayList<>(count);
        for (int i = 0; i < count; i++) {
            Long input = sc.nextLong();
            inputLst.add(input);
        }

        TidyNumbersLarge tidyNumbers = new TidyNumbersLarge();
        ArrayList<Long> output = tidyNumbers.findLastTidyNumberInList(inputLst);
        System.out.println(output);

        FileWriter fw = new FileWriter("codejam.y2017/tidynumbers/bgh2.out");
        BufferedWriter bw = new BufferedWriter(fw);

        int i = 1;
        for (; i <= output.size(); i++) {
            bw.write("Case #" + i + ": " + output.get(i - 1));
            bw.newLine();
        }
        bw.flush();
        bw.close();
        sc.close();

    }

    private ArrayList<Long> findLastTidyNumberInList(ArrayList<Long> inputLst) {
        ArrayList<Long> result = new ArrayList<>(inputLst.size());

        for (Long currItem : inputLst) {
            long lastNo = findLastTidyNumber(currItem);
            result.add(lastNo);
        }
        return result;
    }

    private long findLastTidyNumber(long currItem) {
        long result = currItem;

        if (tidyNumberMap.containsKey(currItem)) {
            return currItem;
        }

        if (isTidyNumber(currItem)) {
            tidyNumberMap.put(currItem, currItem);
            return currItem;
        }

        long tempTidyNum = currItem;

        while (!isTidyNumber(tempTidyNum)) {

            int nonTidyIdx = getNonTidyIndex(tempTidyNum);

            int currItemLen = (int) (Math.log10(tempTidyNum) + 1);

            int numNines = currItemLen - nonTidyIdx;

            long nonNineNum = tempTidyNum / (long) Math.pow(10, numNines);

            tempTidyNum = addNines(nonNineNum - 1, numNines);

        }

        return tempTidyNum;
    }

    private long addNines(long l, int numNines) {
        long result = l;
        for (int i = 0; i < numNines; i++) {
            result = result * 10 + 9;
        }
        return result;
     }

    private int getNonTidyIndex(long currItem) {
        String itemStr = String.valueOf(currItem);

        char[] itemChars = itemStr.toCharArray();

        for (int i = 0; i< itemChars.length - 1; i++) {
            if (itemChars[i] > itemChars[i+1]) {
                return i + 1;
            }
        }

        return -1;
    }


    private boolean isTidyNumber(long item) {

        while (item != 0) {

            if (item < 10) {
                return true;
            }

            long lastDigit = item % 10;
            item = item / 10;
            long secondLastDigit = item % 10;

            if (secondLastDigit > lastDigit) {
                return false;
            }
        }

        return true;
    }


}

/*
 Tatiana likes to keep things tidy. Her toys are sorted from smallest to largest, her pencils are sorted from shortest to longest and her computers from oldest to newest. One day, when practicing her counting skills, she noticed that some integers, when written in base 10 with no leading zeroes, have their digits sorted in non-decreasing order. Some examples of this are 8, 123, 555, and 224488. She decided to call these numbers tidy. Numbers that do not have this property, like 20, 321, 495 and 999990, are not tidy.

 She just finished counting all positive integers in ascending order from 1 to N. What was the last tidy number she counted?

 Input

 The first line of the input gives the number of test cases, T. T lines follow. Each line describes a test case with a single integer N, the last number counted by Tatiana.

 Output

 For each test case, output one line containing Case #x: y, where x is the test case number (starting from 1) and y is the last tidy number counted by Tatiana.

 Limits

 1 ≤ T ≤ 100.
 Small dataset

 1 ≤ N ≤ 1000.
 Large dataset

 1 ≤ N ≤ 1018.
 Sample


 Input

 Output

 4
 132
 1000
 7
 111111111111111110

 Case #1: 129
 Case #2: 999
 Case #3: 7
 Case #4: 99999999999999999

 Note that the last sample case would not appear in the Small dataset.
 */
