import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.ArrayList;

public class Solution {

	public void prepare(StreamTokenizer tokenizer) {
		
		tokenizer.ordinaryChars('0', '9');
		tokenizer.wordChars('0', '9');
		
		tokenizer.ordinaryChar('(');
		tokenizer.wordChars('(', '(');
		
		tokenizer.ordinaryChar(')');
		tokenizer.wordChars(')', ')');
	}
	
	public void process(StreamTokenizer tokenizer) {
		int i;
		int L, D, N;
		String word, pattern;
		ArrayList<String> alienWordList;
		AlienLanguageSolver problemSolver = new AlienLanguageSolver();
		PrintWriter writer = new PrintWriter(System.out); 
		
		try {
			tokenizer.nextToken();
			if (tokenizer.ttype == StreamTokenizer.TT_WORD) {
				L = Integer.parseInt(tokenizer.sval);
				
				tokenizer.nextToken();
				if (tokenizer.ttype == StreamTokenizer.TT_WORD) {
					D = Integer.parseInt(tokenizer.sval);
					alienWordList = new ArrayList<String>(D);
					
					tokenizer.nextToken();
					if (tokenizer.ttype == StreamTokenizer.TT_WORD) {
						N = Integer.parseInt(tokenizer.sval);
						
						for ( i = 0; i < D; ++i ) {
							tokenizer.nextToken();
							if (tokenizer.ttype == StreamTokenizer.TT_WORD) {
								word = tokenizer.sval;
								alienWordList.add(word);
							}
						}
						
						for ( i = 0; i < N; ++i ) {
							tokenizer.nextToken();
							if (tokenizer.ttype == StreamTokenizer.TT_WORD) {
								pattern = tokenizer.sval;
								writer.format("Case #%d: %d\n", i + 1, problemSolver.getNumberOfMatchedWords(L, D, alienWordList, pattern));
							}
						}
					}
				}
			}
		} catch (NumberFormatException e) {
		} catch (IOException e) {
		}
		finally {
			writer.flush();
			writer.close();
		}
	}

	public static void main(String args[]) {
		try {
			BufferedReader reader = new BufferedReader(new InputStreamReader(
					System.in));
			StreamTokenizer tokenizer = new StreamTokenizer(reader);
			Solution solution = new Solution();
			solution.prepare(tokenizer);
			solution.process(tokenizer);
			reader.close();
		} catch (IOException e) {

		}
	}

}

class AlienLanguageSolver
{
	
	private ArrayList<String> getPatternElementList(int L, String pattern)
	{
		int i, j, size;
		char ch;
		ArrayList<String> patternElementList = new ArrayList<String>(L);
		StringBuilder patternElement = new StringBuilder();
		
		size = pattern.length();
		for ( i = 0; i < size; ) {
			ch = pattern.charAt(i);
			if (ch == '(') {
				for ( j = i + 1; j < size; ++j ) {
					ch = pattern.charAt(j);
					if (ch == ')') break;
					patternElement.append(ch);
				}
				patternElementList.add(patternElement.toString());
				patternElement = new StringBuilder();
				i = j + 1;
			}
			else {
				patternElementList.add( "" + ch );
				++i;
			}
		}
		return patternElementList;
	}
	
	private boolean isWordMatchesPattern(int L, String word, ArrayList<String> patternElementList)
	{
		int i, j;
		int wordLen, patternElemLength;
		char ch;
		String patternElem;
		boolean compareStatus;
		
		wordLen = L;
		compareStatus = true;
		for ( i = 0; i < L; ++i ) {
			ch = word.charAt(i);
			patternElem = patternElementList.get( i );
			patternElemLength = patternElem.length();
			for ( j = 0; j < patternElemLength; ++j ) {
				if (ch == patternElem.charAt(j)) break;
			}
			if (j == patternElemLength) {
				compareStatus = false;
				break;
			}
		}
		
		return compareStatus;
	}
	
	public int getNumberOfMatchedWords(int L, int D, ArrayList<String> alienWords, String pattern) {
		int i, matchedWordsCounter;
		String word;
		ArrayList<String> patternElementList = getPatternElementList(L, pattern);
		
		matchedWordsCounter = 0;
		for ( i = 0; i < D; ++i ) {
			word = alienWords.get( i );
			if (isWordMatchesPattern(L, word, patternElementList)) {
				++matchedWordsCounter;
			}
		}
		return matchedWordsCounter;
	}
}
