import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class Solution implements Runnable {

	private void process(Scanner scan, PrintWriter writer) {
		int testNum, T;
		int j, N;
		int[] x;
		int[] y;
		int[] r;
		Task taskSolver = new Task();
		String stringForOutput;
		T = Integer.parseInt(scan.nextLine());
		for (testNum = 0; testNum < T; ++testNum) {
			N = Integer.parseInt(scan.nextLine());
			x = new int[N];
			y = new int[N];
			r = new int[N];
			for (j = 0; j < N; ++j) {
				String line = scan.nextLine();
				String[] tmpArray = line.split(" ");
				x[j] = Integer.parseInt(tmpArray[0]);
				y[j] = Integer.parseInt(tmpArray[1]);
				r[j] = Integer.parseInt(tmpArray[2]);
			}
			stringForOutput = String.format("Case #%d: %.8f\n", testNum + 1,
					taskSolver.getMinRadius(N, x, y, r));
			System.err.println(stringForOutput);
			writer.write(stringForOutput);
			writer.flush();
		}

	}

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();

	}

	@Override
	public void run() {
		Scanner scan = null;
		PrintWriter writer = null;
		try {
			scan = new Scanner(System.in);
			writer = new PrintWriter(new File("output.txt"));
			process(scan, writer);
			writer.flush();
			writer.close();
		}
		catch (FileNotFoundException e) {
		}
	}
}

class Task {

	private double getRad(int N, int[] x, int[] y, int[] r, int[] use,
			int useValue) {
		return 0;
	}

	public double getMinRadius(int N, int[] x, int[] y, int[] r) {
		if (N == 1)
			return r[0];
		double min = 20000;
		for (int i = 0; i < N; ++i) {
			for (int j = 0; j < N; ++j) {
				for (int k = 0; k < N; ++k) {
					for (int t = 0; t < N; ++t) {
						double dx1 = x[i] - x[k];
						double dy1 = y[i] - y[k];
						double rad1 = (Math.sqrt(dx1 * dx1 + dy1 * dy1) + r[k] + r[i]) / 2.0;
						double cx1 = (x[i] + x[k]) / 2.0;
						double cy1 = (y[i] + y[k]) / 2.0;

						double dx2 = x[j] - x[t];
						double dy2 = y[j] - y[t];
						double cx2 = (x[j] + x[t]) / 2.0;
						double cy2 = (y[j] + y[t]) / 2.0;
						double rad2 = (Math.sqrt(dx2 * dx2 + dy2 * dy2) + r[t] + r[j]) / 2.0;

						int q;
						for (q = 0; q < N; ++q) {
							dx1 = x[q] - cx1;
							dy1 = y[q] - cy1;

							double tmp1 = Math.sqrt(dx1 * dx1 + dy1 * dy1)
									+ r[q];

							dx2 = x[q] - cx2;
							dy2 = y[q] - cy2;

							double tmp2 = Math.sqrt(dx2 * dx2 + dy2 * dy2)
									+ r[q];
							if ((tmp1 < rad1 + EPS) || (tmp2 < rad2 + EPS)) {

							}
							else
								break;
						}
						if (q == N) {
							double tmpRad = (rad1 + EPS < rad2) ? rad2 : rad1;
							if (tmpRad + EPS < min)
								min = tmpRad;
						}

					}
				}

			}
		}
		return min;
	}

	private static final double EPS = 1.0e-8;
}