package gcj2010;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class B implements Runnable {

	public static void main(String[] args) {
		B b = new B();
		b.run();

	}

	private int getMaxWeight(List<Integer> targets) {
		int bitPattern = 1 << (targets.size());
		int max = -1;
		List<Integer> first = new ArrayList<Integer>();
		List<Integer> second = new ArrayList<Integer>();
		for (int i = 0; i < bitPattern; ++i) {
			first.clear();
			second.clear();
			for (int j = 0; j < targets.size(); ++j) {
				if ((i & (1 << j)) != 0) {
					first.add(targets.get(j));
				}
				else {
					second.add(targets.get(j));
				}
			}

			if ((first.size() > 0) && (second.size() > 0)) {
				int strangeSum1 = getStrangeSum(first);
				int strangeSum2 = getStrangeSum(second);
				if (strangeSum1 == strangeSum2) {
					int currentSum = Math.max(getSum(first), getSum(second));
					if (max < currentSum) {
						max = currentSum;
					}
				}
			}

		}
		return max;
	}

	private int getStrangeSum(List<Integer> first) {
		String result = "000000000000000000000";
		for (Integer integer : first) {
			result = strandeAddition(result, Integer.toBinaryString(integer));
		}
		return Integer.parseInt(result, 2);
	}

	private int getSum(List<Integer> first) {
		int sum = 0;
		for (Integer integer : first) {
			sum += integer;
		}
		return sum;
	}

	@Override
	public void run() {
		Scanner s = null;
		PrintWriter writer = null;

		try {
			s = new Scanner(System.in);
			writer = new PrintWriter(System.out);

			int T = s.nextInt();
			for (int testNumber = 1; testNumber <= T; ++testNumber) {
				int N = s.nextInt();
				List<Integer> targets = new ArrayList<Integer>();
				for (int j = 0; j < N; ++j) {
					int weight = s.nextInt();
					targets.add(weight);
				}
				int resultValue = getMaxWeight(targets);
				String testResult = String.format("Case #%d: %s", testNumber,
						((resultValue < 0) ? "NO" : resultValue + ""));

				writer.println(testResult);
			}

		}
		catch (Exception e) {
			e.printStackTrace();

		}
		finally {
			if (s != null) {
				s.close();
			}
			if (writer != null) {
				writer.flush();
				writer.close();
			}
		}

	}

	private String strandeAddition(String result, String binaryString) {
		StringBuilder b = new StringBuilder();
		for (int i = binaryString.length() - 1, j = result.length() - 1; (i >= 0)
				&& (j >= 0); --i, --j) {
			int one = binaryString.charAt(i) - '0';
			int two = result.charAt(j) - '0';
			int sum = one + two;
			if (sum > 1) {
				sum = 0;
			}
			b.append((char) (sum + '0'));
		}
		return b.reverse().toString();
	}

}
