package gcj2010;

import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class A implements Runnable {
	public static void main(String[] args) {
		A a = new A();
		a.run();
	}

	private int getTime(List<Target> targets) {
		int orangePos = 1, bluePos = 1;
		int orangeTargetIndex = 0, blueTargetIndex = 0;
		List<Target> orangeTargets = new ArrayList<Target>();
		List<Target> blueTargets = new ArrayList<Target>();
		for (int i = 0; i < targets.size(); ++i) {
			Target t = targets.get(i);
			if (isOrange(t.getColor())) {
				orangeTargets.add(t);
			}
			else {
				blueTargets.add(t);
			}
		}
		int time = 0;
		for (int i = 0; i < targets.size();) {
			++time;
			Target t = targets.get(i);
			if (isOrange(t.getColor())) {
				if (orangePos == t.getPos()) {
					++i;
					++orangeTargetIndex;
				}
				else {
					if (orangeTargetIndex < orangeTargets.size()) {
						Target next = orangeTargets.get(orangeTargetIndex);
						if (next.getPos() < orangePos) {
							--orangePos;
						}
						else {
							if (next.getPos() > orangePos) {
								++orangePos;
							}
						}
					}
				}
				if (blueTargetIndex < blueTargets.size()) {
					Target next = blueTargets.get(blueTargetIndex);
					if (next.getPos() < bluePos) {
						--bluePos;
					}
					else {
						if (next.getPos() > bluePos) {
							++bluePos;
						}
					}
				}
			}
			else {
				if (bluePos == t.getPos()) {
					++i;
					++blueTargetIndex;
				}
				else {
					if (blueTargetIndex < blueTargets.size()) {
						Target next = blueTargets.get(blueTargetIndex);
						if (next.getPos() < bluePos) {
							--bluePos;
						}
						else {
							if (next.getPos() > bluePos) {
								++bluePos;
							}
						}
					}
				}
				if (orangeTargetIndex < orangeTargets.size()) {
					Target next = orangeTargets.get(orangeTargetIndex);
					if (next.getPos() < orangePos) {
						--orangePos;
					}
					else {
						if (next.getPos() > orangePos) {
							++orangePos;
						}
					}
				}
			}
		}
		return time;
	}

	private boolean isOrange(char color) {
		return color == 'O';
	}

	@Override
	public void run() {
		Scanner s = null;
		PrintWriter writer = null;

		try {
			s = new Scanner(System.in);
			writer = new PrintWriter(System.out);

			int T = s.nextInt();
			for (int testNumber = 1; testNumber <= T; ++testNumber) {
				int N = s.nextInt();
				List<Target> targets = new ArrayList<Target>();
				for (int j = 0; j < N; ++j) {
					char color = s.next().charAt(0);
					int pos = s.nextInt();
					targets.add(new Target(color, pos));
				}
				String testResult = String.format("Case #%d: %d", testNumber,
						getTime(targets));
				writer.println(testResult);
			}

		}
		catch (Exception e) {

		}
		finally {
			if (s != null) {
				s.close();
			}
			if (writer != null) {
				writer.flush();
				writer.close();
			}
		}

	}
}

class Target {
	private final char color;

	private final int pos;

	public Target(char color, int pos) {
		super();
		this.color = color;
		this.pos = pos;
	}

	public char getColor() {
		return color;
	}

	public int getPos() {
		return pos;
	}
}
