import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Solution {

	public void process(Scanner scan) {
		int i;
		int N;
		WelcomeToCodeJamSolver problemSolver = new WelcomeToCodeJamSolver();
		PrintWriter writer = new PrintWriter(System.out);
		String tmpString;

		tmpString = scan.nextLine();
		N = Integer.parseInt(tmpString);
		for (i = 0; i < N; ++i) {
			tmpString = scan.nextLine();
			writer.format("Case #%d: %04d\n", i + 1, problemSolver
					.getNumberOfSubsequences(tmpString));
		}
		writer.flush();
		writer.close();
	}

	public static void main(String args[]) {
		Scanner scan = new Scanner(System.in);
		Solution solution = new Solution();
		solution.process(scan);
		scan.close();
	}
}

class WelcomeToCodeJamSolver {

	private void init(String text, int[][] dpTable) {
		int i, textLength;
		int patternLength = PATTERN.length();
		char lastChar = PATTERN.charAt(patternLength - 1);
		textLength = text.length();
		for (i = 0; i < textLength; ++i) {
			dpTable[i][patternLength - 1] = (text.charAt(i) == lastChar) ? 1
					: 0;
		}
	}

	private void processDP(String text, int[][] dpTable) {
		int i, j, t;
		int textLength = text.length();
		int patternLength = PATTERN.length();
		int tmp;

		for (i = patternLength - 2; i >= 0; --i) {
			for (j = textLength - 1; j >= 0; --j) {
				tmp = 0;
				if (text.charAt(j) == PATTERN.charAt(i)) {
					for (t = j + 1; t < textLength; ++t) {
						tmp = (tmp + dpTable[ t ][ i + 1 ]) % MODULE;
					}
					dpTable[ j ][ i ] = tmp;
				}
				else {
					dpTable[ j ][ i ] = 0;
				}
			}
		}
	}

	private int getDPResult(String text, int[][] dpTable) {
		int i, result;
		int textLength = text.length();
		
		result = 0;
		for ( i = 0; i < textLength; ++i ) {
			result = (result + dpTable[ i ][ 0 ]) % MODULE;
		}
		return result;
	}

	public int getNumberOfSubsequences(String text) {
		int[][] dpTable = new int[text.length()][PATTERN.length()];
		init(text, dpTable);
		processDP(text, dpTable);
		return getDPResult(text, dpTable);
	}


	private static final String PATTERN = "welcome to code jam";
	private static final int MODULE = 10000;
}