import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Locale;
import java.util.Scanner;

public class Solution implements Runnable {

	private void process(Scanner scan, PrintWriter writer) {
		int testNum, T;
		int j, N;
		int[] x;
		int[] y;
		int[] r;
		Task taskSolver = new Task();
		String stringForOutput;
		T = Integer.parseInt(scan.nextLine());
		for (testNum = 0; testNum < T; ++testNum) {
			N = Integer.parseInt(scan.nextLine());
			x = new int[N];
			y = new int[N];
			r = new int[N];
			for (j = 0; j < N; ++j) {
				String line = scan.nextLine();
				String[] tmpArray = line.split(" ");
				x[j] = Integer.parseInt(tmpArray[0]);
				y[j] = Integer.parseInt(tmpArray[1]);
				r[j] = Integer.parseInt(tmpArray[2]);
			}
			stringForOutput = String.format("Case #%d: %.8f\n", testNum + 1,
					taskSolver.getMinRadius(N, x, y, r));
			System.err.println(stringForOutput);
			writer.write(stringForOutput);
			writer.flush();
		}

	}

	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		new Thread(new Solution()).start();

	}

	@Override
	public void run() {
		Scanner scan = null;
		PrintWriter writer = null;
		try {
			scan = new Scanner(System.in);
			writer = new PrintWriter(new File("output.txt"));
			process(scan, writer);
			writer.flush();
			writer.close();
		}
		catch (FileNotFoundException e) {
		}
	}
}

class Task {

	private double getRad(int N, int[] x, int[] y, int[] r, int[] use,
			int useValue) {
		return 0;
	}

	public double getMinRadius(int N, int[] x, int[] y, int[] r) {
		if (N == 1)
			return r[0];
		if (N == 2) {
			return r[0] < r[1] ? r[1] : r[0];
		}
		if (N == 3) {
			double min = 20000;
			for (int i = 0; i < N; ++i) {
				double rad1 = r[i];
				double rad2;
				for (int j = 0; j < N; ++j) {
					for (int k = 0; k < N; ++k) {
						if ((j != i) && (k != i) && (k != j)) {
							double dx = x[j] - x[k];
							double dy = y[j] - y[k];
							rad2 = (Math.sqrt(dx * dx + dy * dy) + r[j] + r[k]) / 2.0;
							double tmpRad = (rad1 + EPS < rad2) ? rad2 : rad1;
							if (min - EPS > tmpRad) {
								min = tmpRad;
							}
						}
					}
				}
			}
			return min;
		}
		return 0;
	}

	private static final double EPS = 1.0e-8;
}