import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

//Input 
// 	
//3
//4 O 2 B 1 B 2 O 4
//3 O 5 O 8 B 100
//2 B 2 B 1
//
//Output 
//
//Case #1: 6
//Case #2: 100
//Case #3: 4

public class BotTrust {

	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException {
		InputRecord in = readInput();
		for (int i = 0; i < in.caseCount; i++) {
			System.out.print("Case #" + (i+1) + ": ");
			System.out.println(findSolution(in.cases.get(i)));
		}
	}

	private static int findSolution(CaseRecord caseRecord) {
		int oLastT = 0;
		int oPosition = 1;
		int bLastT =0;
		int bPosition = 1;
		
		for (Button button : caseRecord.buttons) {
			if (button.color == 'O') {
				int moveTime = Math.abs(button.position - oPosition) + 1;
				oLastT = Math.max(oLastT + moveTime, bLastT + 1);
				oPosition = button.position;
			} else {
				int moveTime = Math.abs(button.position - bPosition) + 1;
				bLastT = Math.max(bLastT + moveTime, oLastT + 1);
				bPosition = button.position;
			}
			
		}
		
		return Math.max(oLastT, bLastT);
	}

	private static InputRecord readInput() throws NumberFormatException, IOException {
		BufferedReader f = new BufferedReader(new InputStreamReader(System.in));
		return new InputRecord(f);
	}

}
