import java.io.*;
import java.util.*;

public class GCJ_17_QR_C {

    public static final boolean READ_FROM_FILE = true;
    public static final String NAME = "C-small-1-attempt0";
    public static PrintWriter out;

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public String nextLine() {
            String str = "";
            try {
                str = reader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

    }

    public static void main(String[] args) throws IOException {
        InputStream inputStream;
        OutputStream outputStream;
        if (READ_FROM_FILE) {
            inputStream = new FileInputStream(new File(NAME + ".in"));
            outputStream = new FileOutputStream(NAME + ".out");
        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        InputReader in = new InputReader(inputStream);
        out = new PrintWriter(outputStream);

        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            int N = in.nextInt();
            int K = in.nextInt();

            int[] ans = solve(N, K);
            out.printf("Case #%d: %d %d\n", t, ans[0], ans[1]);
        }

        out.close();
    }

    public static int[] solve(int N, int K) {
        int[] ans = new int[2];
        PriorityQueue<Integer> pq = new PriorityQueue<>(new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2) {
                return Integer.compare(o2, o1);
            }
        });
        pq.add(N);
        for (int i = 0; i < K; i++) {
            int cur = pq.poll();
            cur--;
            int a = cur / 2;
            int b = cur - a;
            if (i == K-1) {
                ans[0] = b;
                ans[1] = a;
            } else {
                if (a != 0) pq.add(a);
                if (b != 0) pq.add(b);
            }
        }
        return ans;
    }
}
