import java.io.*;
import java.util.*;

public class GCJ_17_QR_B {

    public static final boolean READ_FROM_FILE = true;
    public static final String NAME = "B-large";
    public static PrintWriter out;

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public String nextLine() {
            String str = "";
            try {
                str = reader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

    }

    public static void main(String[] args) throws IOException {
        InputStream inputStream;
        OutputStream outputStream;
        if (READ_FROM_FILE) {
            inputStream = new FileInputStream(new File(NAME + ".in"));
            outputStream = new FileOutputStream(NAME + ".out");
        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        InputReader in = new InputReader(inputStream);
        out = new PrintWriter(outputStream);

        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            char[] v = in.next().toCharArray();
            out.printf("Case #%d: %d\n", t, solve(v));
        }

        out.close();
    }

    public static long solve(char[] V) {
        while (true) {
            int idx = -1;
            for (int i = 1; i < V.length; i++) {
                if (idx != -1) {
                    V[i] = '9';
                } else if (V[i] < V[i - 1]) {
                    V[i] = '9';
                    idx = i;
                }
            }
            if (idx != -1) {
                for (int j = idx - 1; j >= 0; j--) {
                    if (V[j] != '0') {
                        V[j]--;
                        break;
                    } else {
                        V[j] = '9';
                    }
                }
            } else {
                break;
            }
        }
        return Long.parseLong(new String(V));
    }
}
