import java.io.*;
import java.util.*;

public class GCJ_17_QR_C {

    public static final boolean READ_FROM_FILE = true;
    public static final String NAME = "C-large";
    public static PrintWriter out;

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public String nextLine() {
            String str = "";
            try {
                str = reader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

    }

    public static void main(String[] args) throws IOException {
        InputStream inputStream;
        OutputStream outputStream;
        if (READ_FROM_FILE) {
            inputStream = new FileInputStream(new File(NAME + ".in"));
            outputStream = new FileOutputStream(NAME + ".out");
        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        InputReader in = new InputReader(inputStream);
        out = new PrintWriter(outputStream);

        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            long N = in.nextLong();
            long K = in.nextLong();

            long[] ans = solve2(N, K);
            out.printf("Case #%d: %d %d\n", t, ans[0], ans[1]);
        }

        out.close();
    }

    public static long[] solve(long N, long K) {
        long[] ans = new long[2];
        PriorityQueue<Long> pq = new PriorityQueue<>(new Comparator<Long>() {
            @Override
            public int compare(Long o1, Long o2) {
                return Long.compare(o2, o1);
            }
        });
        pq.add(N);
        for (int i = 0; i < K; i++) {
            long cur = pq.poll();
            cur--;
            long a = cur / 2;
            long b = cur - a;
            if (i == K-1) {
                ans[0] = b;
                ans[1] = a;
            } else {
                if (a != 0) pq.add(a);
                if (b != 0) pq.add(b);
            }
        }
        return ans;
    }

    public static long[] solve2(long N, long K) {
        long[] ans = new long[2];
        long z = 0;
        long zz = 1L;
        while ((zz - 1) < K) {
            z++;
            zz <<= 1;
        }
        zz--;
        //out.println("zz: " + zz);
        /*
        if (zz >= N) {
            ans[0] = 0;
            ans[1] = 0;
            return ans;
        }
        */

        long count = 1L << (z-1);
        long val = Math.max(0, N - zz);
        long div = val / count;
        long down = count - (val - count * div);
/*
        out.println("zz: " + zz);
        out.println("z: " + z);
        out.println("count: " + count);
        out.println("val: " + val);
        out.println("div: " + div);
        out.println("down: " + down);
*/
        if (K < zz - down + 1) {
            div++;
        }
        ans[1] = div / 2;
        ans[0] = div - ans[1];
        return ans;
    }
}
