import java.io.*;
import java.util.*;

public class GCJ_17_QR_A {

    public static final boolean READ_FROM_FILE = true;
    public static final String NAME = "A-large";
    public static PrintWriter out;

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }

        public double nextDouble() {
            return Double.parseDouble(next());
        }

        public String nextLine() {
            String str = "";
            try {
                str = reader.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

    }

    public static void main(String[] args) throws IOException {
        InputStream inputStream;
        OutputStream outputStream;
        if (READ_FROM_FILE) {
            inputStream = new FileInputStream(new File(NAME + ".in"));
            outputStream = new FileOutputStream(NAME + ".out");
        } else {
            inputStream = System.in;
            outputStream = System.out;
        }
        InputReader in = new InputReader(inputStream);
        out = new PrintWriter(outputStream);

        int T = in.nextInt();
        for (int t = 1; t <= T; t++) {
            String S = in.next();
            int K = in.nextInt();
            int ans = solve(S, K);
            if (ans == -1) {
                out.printf("Case #%d: IMPOSSIBLE\n", t);
            }
            else out.printf("Case #%d: %d\n", t, ans);
        }

        out.close();
    }

    public static int solve(String s, int k) {
        char[] array = s.toCharArray();
        int count = 0;
        for (int i = 0; i + k - 1 < array.length; i++) {
            if (array[i] == '-') {
                for (int j = 0; j < k; j++) {
                    array[i + j] = (array[i + j] == '-') ? '+' : '-';
                }
                count++;
            }
        }

        for (int i = array.length - k + 1; i < array.length; i++) {
            if (array[i] != '+') return -1;
        }
        return count;
    }
}
