package code.google.codejam2k13.qualfication;

import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class TickTocToe {
	private final Scanner SC = new Scanner(System.in); 
	private static final boolean TESTING = true;

	public static void main(String[] args) throws IOException {
		TickTocToe obj = new TickTocToe();
		obj.runTest();
	}

	private void runTest() throws IOException {
		int CASES = SC.nextInt();

		int i = 1;
		FileWriter fw = new FileWriter("Output.txt");
		do{
			SC.nextLine();
			char[][] matrix = new char[4][4];
			for(int j=0;j<4;j++){
				String str = SC.nextLine();
				matrix[j]=str.toCharArray();
			}
			
			String o = "Case #" + i +": " + findStateOfGame(matrix);
			System.out.println(o);
			fw.write(o + '\n');
		}while(++i <= CASES);
		fw.close();
	}

	private String findStateOfGame(char[][] matrix) {
		int emptySpacesCount = 0;
		//Check rows
		char winner = 'T';
		for(int row=0;row<4;row++){
			int i=1;
			char ch = matrix[row][0];
			if(ch == '.'){
				emptySpacesCount++;
				continue;
			} else if(ch == 'T'){
				ch = matrix[row][1];
				i = 2;
			}
			
			boolean broken = false;
			for(;i<4;i++){
				if(matrix[row][i] == '.'){
					emptySpacesCount++;
					broken = true;
					break;
				} else if(matrix[row][i] != ch && matrix[row][i] != 'T'){
					broken = true;
					break;
				}
			}
			
			if(!broken){
				winner = ch;
				break;
			}
		}
		
		if(winner != 'T'){
			return winner + " won";
		}
		
		//Check columns
		for(int col=0;col<4;col++){
			int i=1;
			char ch = matrix[0][col];
			if(ch == '.'){
				emptySpacesCount++;
				continue;
			} else if(ch == 'T'){
				ch = matrix[1][col];
				i = 2;
			}
			
			boolean broken = false;
			for(;i<4;i++){
				if(matrix[i][col] == '.'){
					emptySpacesCount++;
					broken = true;
					break;
				} else if(matrix[i][col] != ch && matrix[i][col] != 'T'){
					broken = true;
					break;
				}
			}
			
			if(!broken){
				winner = ch;
				break;
			}
		}
		
		if(winner != 'T'){
			return winner + " won";
		}
		
		//Check diagonal
		int i=1, j=1;
		char ch = matrix[0][0];
		boolean proceed = true;
		if(ch == '.'){
			emptySpacesCount++;
			proceed = false;
		} else if(ch == 'T'){
			ch = matrix[1][1];
			i = j = 2;
		}
		
		if(proceed){
			boolean broken = false;
			for(;i<4&&j<4;i++,j++){
				if(matrix[i][j] == '.'){
					emptySpacesCount++;
					broken = true;
					break;
				} else if(matrix[i][j] != ch && matrix[i][j] != 'T'){
					broken = true;
					break;
				}
			}
			
			if(!broken){
				winner = ch;
			}
		}
		
		if(winner != 'T'){
			return winner + " won";
		}
		
		//Check other diagnol
		i=1;j=2;
		ch = matrix[0][3];
		proceed = true;
		if(ch == '.'){
			emptySpacesCount++;
			proceed = false;
		} else if(ch == 'T'){
			ch = matrix[1][2];
			i = 2;j = 1;
		}
		
		if(proceed){
			boolean broken = false;
			for(;i<4&&j>=0;i++,j--){
				if(matrix[i][j] == '.'){
					emptySpacesCount++;
					broken = true;
					break;
				} else if(matrix[i][j] != ch && matrix[i][j] != 'T'){
					broken = true;
					break;
				}
			}
			
			if(!broken){
				winner = ch;
			}
		}
		
		if(winner != 'T'){
			return winner + " won";
		}
		
		if(emptySpacesCount>0){
			return "Game has not completed";
		} else {
			return "Draw";
		}
	}
}
