package com.codejam.y2k14.qual;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Scanner;

public class CookieClicker {	
	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws IOException {
		CookieClicker obj = new CookieClicker();
		obj.runTest(args[0], args[1]);
	}

	private void runTest(String inPath, String outPath) throws IOException {
		
		Scanner scanner = new Scanner(new FileInputStream(inPath));
		FileOutputStream out = new FileOutputStream(outPath);
		int T = scanner.nextInt();
		for(int i=1;i<=T;i++){
			double c = scanner.nextDouble(), f=scanner.nextDouble(), x=scanner.nextDouble();
			
			String result = "Case #" + i + ": " + findOptimalTime(c, f, x) + "\n"; 
			System.out.println(result);
			out.write(result.getBytes());
		}		
		
		scanner.close();
		out.close();
	}

	private static final int TIME_MULTIPLYING_FACTOR = 60 * 1000 * 1000; //seconds to micro-sec
	private static final int STARTING_FREQUENCY = 2;
	private double findOptimalTime(double c, double f, double x) {
		double accumulatedTimeForFarms = 0;
		double frequency = STARTING_FREQUENCY * TIME_MULTIPLYING_FACTOR;
		double timeForAllX = x/frequency;
		do{
			accumulatedTimeForFarms += c/frequency;			
			frequency += (f * TIME_MULTIPLYING_FACTOR);
			double timeForXWithNewFrequency = x/frequency + accumulatedTimeForFarms;
			if(timeForAllX < timeForXWithNewFrequency){
				break;
			} else {
				timeForAllX = timeForXWithNewFrequency;
			}
		}while(true);
		
		long result = Math.round(timeForAllX*TIME_MULTIPLYING_FACTOR * ROUNDING);
		return result/ROUNDING;
	}
	private static final double ROUNDING = 10000000.0;
}
