package com.codejam.y2k14.qual;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Scanner;

public class MagicTrick {
	private static final int MATRIX_SIZE = 4;
	
	/**
	 * @param args
	 * @throws FileNotFoundException 
	 */
	public static void main(String[] args) throws IOException {
		MagicTrick obj = new MagicTrick();
		obj.runTest(args[0], args[1]);
	}

	private void runTest(String inPath, String outPath) throws IOException {
		
		Scanner scanner = new Scanner(new FileInputStream(inPath));
		FileOutputStream out = new FileOutputStream(outPath);
		int T = scanner.nextInt();
		for(int i=1;i<=T;i++){
			int firstRow = scanner.nextInt();
			int[][] firstMatrix = new int[MATRIX_SIZE][MATRIX_SIZE];
			for(int rowIndex=0;rowIndex<MATRIX_SIZE;rowIndex++){
				for(int colIndex=0;colIndex<MATRIX_SIZE;colIndex++){
					firstMatrix[rowIndex][colIndex] = scanner.nextInt();
				}	
			}
			
			int secondRow = scanner.nextInt();
			int[][] secondMatrix = new int[MATRIX_SIZE][MATRIX_SIZE];
			for(int rowIndex=0;rowIndex<MATRIX_SIZE;rowIndex++){
				for(int colIndex=0;colIndex<MATRIX_SIZE;colIndex++){
					secondMatrix[rowIndex][colIndex] = scanner.nextInt();
				}	
			}
			
			String result = "Case #" + i + ": " + findMagicResult(firstMatrix[firstRow-1], secondMatrix[secondRow-1]) + "\n"; 
			System.out.println(result);
			out.write(result.getBytes());
		}		
		
		scanner.close();
		out.close();
	}

	private String findMagicResult(int[] firstRow, int[] secondRow) {
		int common = Integer.MAX_VALUE;
		boolean foundCommon = false, foundSecondCommon = false;
		
		for(int i=0;i<MATRIX_SIZE;i++){
			for(int j=0;j<MATRIX_SIZE;j++){
				if(firstRow[i] == secondRow[j]){
					if(!foundCommon){
						common = firstRow[i];
						foundCommon = true;
					} else {
						foundSecondCommon = true;
						break;
					}
				}
			}
		}
		
		String result;
		if(foundSecondCommon){
			result = "Bad magician!";
		} else if(foundCommon){
			result = common + "";
		} else {
			result = "Volunteer cheated!";
		}
		
		return result;
	}

}
