import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

/**
 * Code Jam 2010 qualifier Snapper Chain
 * @author bhalsey
 *
 */
public class Snapper {

	/**
	 * @param args provide input filename
	 */
	public static void main(String[] args) {
       try {
            String filename = args[0];
            BufferedReader in = new BufferedReader( new FileReader( filename ) );
            String numLinesS = in.readLine();
            int numLines = Integer.parseInt(numLinesS);

            for (int i = 1; i <= numLines; i++) {
            	Scanner s = new Scanner(in.readLine());
            	int n = s.nextInt();
            	int k = s.nextInt();
                String state = computeState(n, k);
        		System.out.printf("Case #%d: %s\n", i, state);
            }

        }
        catch (FileNotFoundException fnfe) {
            fnfe.printStackTrace();
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }
	}

	/**
	 * Determine if the light's on or off.  Check that all snappers up to 
	 * where light is plugged in are on (bit = 1).
	 * @param n number of Snapper devices
	 * @param k number of snaps
	 * @return
	 */
	private static String computeState(int n, int k) {
		int mask = (1 << n) - 1;
		if ((k & mask) == mask) {
			return "ON";
		}
		else {
			return "OFF";
		}
	}

}
