import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

/**
 * Code Jam 2010 qualifier
 * @author bhalsey
 *
 */
public class FairWarning {

	/**
	 * @param args filename
	 */
	public static void main(String[] args) {
       try {
            String filename = args[0];
            BufferedReader in = new BufferedReader( new FileReader( filename ) );
            String numLinesS = in.readLine();
            int numLines = Integer.parseInt(numLinesS);

            for (int i = 1; i <= numLines; i++) {
                String time = computeTime(in.readLine());
        		System.out.printf("Case #%d: %s\n", i, time);
            }

        }
        catch (FileNotFoundException fnfe) {
            fnfe.printStackTrace();
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }
	}

	private static String computeTime(String readLine) {
		Scanner s = new Scanner(readLine);
		int n = s.nextInt();
		BigInteger[] times = new BigInteger[n];
		BigInteger gcd = null;
		
		for (int i = 0; i < n; i++) {
			times[i] = s.nextBigInteger();
			
			// look at difference between this one and all previous times, find gcd
			for (int j = 0; j < i; j++) {
				BigInteger diff = times[i].subtract(times[j]).abs();
				if (j == 0 && i == 1) {
					gcd = diff;
				}
				else {
					gcd = diff.gcd(gcd);
				}
			}
		}
		
//		System.out.println("time aka gcd is " + gcd);
		BigInteger remainder = times[0].remainder(gcd);
		if (remainder.equals(BigInteger.ZERO)) {
			return "0"; // party now
		}
		BigInteger timeTilReck = gcd.subtract(remainder);
		return timeTilReck.toString();
	}

}
