import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;


/**
 * Google Code Jam Round 1C, Problem A
 * @author bhalsey
 *
 */
public class ProblemB {
	ProblemB() {
		
	}
	
    /**
     * @param args
     */
    public static void main(String[] args) {
        try {
            String filename = args[0];
            BufferedReader in = new BufferedReader(new FileReader(filename));
            String numLinesS = in.readLine();
            int numCases = Integer.parseInt(numLinesS);
            Scanner sc = new Scanner(in);

            for (int i = 1; i <= numCases; i++) {
                String result = compute(sc);
                System.out.printf("Case #%d: %s\n", i, result);
            }

        } catch (FileNotFoundException fnfe) {
            fnfe.printStackTrace();
        } catch (IOException ioe) {
            ioe.printStackTrace();
        }
    }

    /**
     * Essentially do a binary search with factors of C.  solve with logs.
     * @param sc
     * @return
     */
	private static String compute(Scanner sc) {
		int L = sc.nextInt();
		int P = sc.nextInt();
		int C = sc.nextInt();
		
		// check if we don't need any tests
		if (P <= L * C) { return "0"; }
		
		double low = Math.log(L) / Math.log(C);
		double high = Math.log(P) / Math.log(C);
		
		double y = Math.ceil( Math.log(high - low) / Math.log(2) );
		return Integer.toString((int) y);
		
	}
	

}
