import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;


public class ThemePark {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
       try {
            String filename = args[0];
            BufferedReader in = new BufferedReader( new FileReader( filename ) );
            String numLinesS = in.readLine();
            int numLines = Integer.parseInt(numLinesS);

            for (int i = 1; i <= numLines; i++) {
            	String rkn = in.readLine();
            	String groups = in.readLine();
                String earnings= computeEarnings(rkn, groups);
        		System.out.printf("Case #%d: %s\n", i, earnings);
            }

        }
        catch (FileNotFoundException fnfe) {
            fnfe.printStackTrace();
        }
        catch (IOException ioe) {
            ioe.printStackTrace();
        }
	}

	private static String computeEarnings(String rkn, String groups) {
		Scanner s = new Scanner(rkn);
		int r = s.nextInt();
		int k = s.nextInt();
		int n = s.nextInt();
		s = new Scanner(groups);
		int[]  groupSizes    = new int[n];
		// keep track of earnings when starting from a given group
		long[] groupEarnings = new long[n];
		// keep track of which group goes next
		int[]  groupNext     = new int[n];
		for (int i = 0; i < n; i++) {
			groupSizes[i] = s.nextInt();
			groupEarnings[i] = -1L;
			groupNext[i] = -1;
		}
		
		long sum = 0L;
		int nextInLine = 0;
		// run the roller coaster r times
		for (int i = 0; i < r; i++) {
			
			int availSpots = k;
			int firstGroupOnRide = nextInLine;
			
			if (groupEarnings[firstGroupOnRide] > 0) {
				sum += groupEarnings[firstGroupOnRide];
				nextInLine = groupNext[firstGroupOnRide];
			}
			else {
				long rideSum = 0L;
				fill:
				while (availSpots > 0) {
					if (groupSizes[nextInLine] <= availSpots) {
						availSpots -= groupSizes[nextInLine];
						rideSum += groupSizes[nextInLine];
						nextInLine = (nextInLine + 1) % n;
						if (nextInLine == firstGroupOnRide) {
							break fill;
						}
					}
					else {
						break fill;
						
					}
				}
				
				groupEarnings[firstGroupOnRide] = rideSum;
				groupNext[firstGroupOnRide] = nextInLine;
				sum += rideSum;
			
			}
		}
		
		return String.valueOf(sum);
	}


}
