import java.util.*;

/**
 * Created by bhanu on 9/4/16.
 */
public class Main {
    private static class JamCoinPrinter {
        int rem = 0;
        Set<String> jamCoins = new HashSet<>();

        private long interpretBinary(String s, int base) {
            long n = 0;
            for (int i = 0; i < s.length(); i++) {
                n = (n * base) + (s.charAt(i) - '0');
            }
            return n;
        }

        private long getNonTrivialDivisor(long n) {
            for (long i = 2; i <= Math.sqrt(n); i++) {
                if (n % i == 0) {
                    return i;
                }
            }
            return -1;
        }

        private void printJamCoins(int n, int j) {
            this.rem = j;
            StringBuilder s = new StringBuilder("1");
            printJamCoins(n, j, 1, s);
        }

        private void printJamCoin(String s) {
            List<Long> divisors = new ArrayList<>();
            for (int base = 2; base <= 10; base++) {
                long n = interpretBinary(s, base);
                long div = getNonTrivialDivisor(n);
                if (div == -1) {
                    return;
                }
                long q = n / div;
                if(div * q != n || div == 1 || div == n) {
                    System.out.println("Wrong divisor");
                }
                //System.out.println("n = " + n + ", div = " + div + " ");
                divisors.add(div);
            }

            jamCoins.add(s);
            rem--;
            System.out.print(s + " ");
            for (int i = 0; i < divisors.size(); i++) {
                long div = divisors.get(i);
                System.out.print(div);
                if (i != divisors.size() - 1) {
                    System.out.print(" ");
                }
            }
            System.out.println();
        }

        private void setCharAt(StringBuilder s, int index, char c) {
            if (index < s.length()) {
                s.setCharAt(index, c);
            } else {
                s.append(c);
            }
        }

        private void printJamCoins(int n, int j, int i, StringBuilder s) {
            if (rem == 0) {
                return;
            }

            if (i >= n - 1) {
                setCharAt(s, n - 1, '1');
                String str = s.toString();
                if (!jamCoins.contains(str)) {
                    printJamCoin(str);
                } else {
                    System.out.println("Found duplicate");
                }
                return;
            }

            setCharAt(s, i, '1');
            printJamCoins(n, j, i + 1, s);
            setCharAt(s, i, '0');
            printJamCoins(n, j, i + 1, s);
        }
    }

    public static void main(String[] args) {
        Scanner s = new Scanner(System.in);
        int t = s.nextInt();
        for (int i = 0; i < t; i++) {
            int n = s.nextInt();
            int j = s.nextInt();

            System.out.println("Case #" + (i + 1) + ":");
            new JamCoinPrinter().printJamCoins(n, j);
        }
    }
}
