import java.io.File;
import java.util.Arrays;
import java.util.Collections;

public class Program 
{
	public static void main(String[] args) 
	{
		try
		{
			File inputFile = new File("input.txt");
			String content = FileUtility.getContents(inputFile);
			String[] contentArray = content.split(System.getProperty("line.separator"));
			
			File outputFile = new File("output.txt");
			outputFile.createNewFile();
			StringBuilder output = new StringBuilder();
			
			final int NO_OF_CASES = Integer.parseInt(contentArray[0]);
			
			int lastLineNo = 1;
			
			for (int i = 0; i < NO_OF_CASES; i++)
			{
				String result = "Impossible";
				
				int minKeyPresses = 0;
				
				String input = contentArray[lastLineNo];
				lastLineNo++;
				
				String inputArr[] = input.split(" ");
				
				int P = Integer.parseInt(inputArr[0]);
				int K = Integer.parseInt(inputArr[1]);
				int L = Integer.parseInt(inputArr[2]);
				
				if(P*K >= L)
				{
					String frq = contentArray[lastLineNo];
					lastLineNo++;
					String[] fqStr = frq.split(" ");
					int[] frequencies = new int[fqStr.length];
					for (int j = 0; j < fqStr.length; j++) 
					{
						frequencies[j] = Integer.parseInt(fqStr[j]);
					}
					
					Arrays.sort(frequencies);
					
					int multiplier = 1;
					int count = 0;
					for(int j = frequencies.length-1; j >=0 ; j--)
					{
						if(count < multiplier * K)
						{
							minKeyPresses += frequencies[j]*multiplier;
						}
						if((count+1)%K==0)
						{
							multiplier++;
						}
						count++;
					}
					result = "" + minKeyPresses;
				}
				else
				{
					lastLineNo++;
				}
								
				output.append("Case #" + (int)(i+1) + ": " + result + "\n");
			}
			FileUtility.setContents(outputFile, output.toString());
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	/*static public Set primeFactors(long N,long P)
	{
		Set<Long> PF = new HashSet<Long>(); 
		for (long i = 2 ; i <= N ; i++)
		{			
			while (N % i == 0)
			{				
				if(i>=P)
				{
					PF.add(i);
				}				
				N = N/i;
			}	
		}
		return PF;
	}
	
	static public boolean matchSets(Set s1, Set s2)
	{
		for (Iterator iter = s1.iterator(); iter.hasNext();) 
		{
			Long e1 = (Long) iter.next();
			for (Iterator iterator = s2.iterator(); iterator.hasNext();) 
			{
				Long e2 = (Long) iterator.next();
				if(e1.equals(e2))
				{
					return true;
				}
			}
			
		}
		return false;
	}*/
}

