import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

class TrainTimetable 
{	
	public static void main(String[] a)
	{
		try
		{
			File ip = new File("ip.txt");
			String content = getContents(ip);
			String[] contentArray = content.split(System.getProperty("line.separator"));
			
			File op = new File("op.txt");
			op.createNewFile();
			StringBuilder output = new StringBuilder();
			
			final int NO_OF_CASES = Integer.parseInt(contentArray[0]);
			
			int lastLineNo = 1;
			
			for (int i = 0; i < NO_OF_CASES; i++) 
			{
				int T = Integer.parseInt(contentArray[lastLineNo++]);
				
				String NAnNB = contentArray[lastLineNo++];
				
				String[] NAnNBStr = NAnNB.split(" ");
				
				int MAX_NA = Integer.parseInt(NAnNBStr[0]);
				int MAX_NB = Integer.parseInt(NAnNBStr[1]);
				
				String[] NA = new String[MAX_NA];
				String[] NB = new String[MAX_NB];
				
				int preecedingLines = lastLineNo+MAX_NA;
				
				for(int j = lastLineNo, k=0; j< preecedingLines; j++,k++)
				{
					NA[k] = contentArray[j];
				}
				
				lastLineNo = preecedingLines;
				preecedingLines += MAX_NB;
				
				for(int j = lastLineNo, k=0; j< preecedingLines; j++,k++)
				{
					NB[k] = contentArray[j];
				}
				
				lastLineNo = preecedingLines;
				
				int real_NA = MAX_NA, real_NB = MAX_NB;
				
				List<Calendar> start = new ArrayList<Calendar>(MAX_NB);
				List<Calendar> end = new ArrayList<Calendar>(MAX_NA);
				
				Utility.prepareStartEndLists(MAX_NB, MAX_NA, start, end, NB, NA, T);	
				real_NB = Utility.getMinTrains(MAX_NB, MAX_NA, start, end, real_NB);
				
				start = new ArrayList<Calendar>(MAX_NA);
				end = new ArrayList<Calendar>(MAX_NB);
				
				Utility.prepareStartEndLists(MAX_NA, MAX_NB, end, start, NA, NB, T);
				real_NA = Utility.getMinTrains(MAX_NA, MAX_NB, end, start, real_NA);
				
				output.append("Case #" + (int)(i+1) + ": " + real_NA + " " + real_NB + System.getProperty("line.separator"));
			}
			
			setContents(op, output.toString());
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	static public String getContents(File aFile)
	{
	    //...checks on aFile are elided
	    StringBuilder contents = new StringBuilder();
	    
	    try {
	      //use buffering, reading one line at a time
	      //FileReader always assumes default encoding is OK!
	      BufferedReader input =  new BufferedReader(new FileReader(aFile));
	      try {
	        String line = null; //not declared within while loop
	        /*
	        * readLine is a bit quirky :
	        * it returns the content of a line MINUS the newline.
	        * it returns null only for the END of the stream.
	        * it returns an empty String if two newlines appear in a row.
	        */
	        while (( line = input.readLine()) != null){
	          contents.append(line);
	          contents.append(System.getProperty("line.separator"));
	        }
	      }
	      finally {
	        input.close();
	      }
	    }
	    catch (IOException ex){
	      ex.printStackTrace();
	    }
	    
	    return contents.toString();
	  }
	
	static public void setContents(File aFile, String aContents) throws FileNotFoundException, IOException 
	{
		if (aFile == null) {
		throw new IllegalArgumentException("File should not be null.");
		}
		if (!aFile.exists()) {
		throw new FileNotFoundException ("File does not exist: " + aFile);
		}
		if (!aFile.isFile()) {
		throw new IllegalArgumentException("Should not be a directory: " + aFile);
		}
		if (!aFile.canWrite()) {
		throw new IllegalArgumentException("File cannot be written: " + aFile);
		}
		
		//use buffering
		Writer output = new BufferedWriter(new FileWriter(aFile));
		try {
		//FileWriter always assumes default encoding is OK!
		output.write( aContents );
		}
		finally {
		output.close();
		}
	}
}
