import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;


public class SavingTheUniverse 
{
	public static void main(String[] args) 
	{
		try
		{
			File inputFile = new File("input.txt");
			String content = getContents(inputFile);
			String[] contentArray = content.split(System.getProperty("line.separator"));
			
			File outputFile = new File("output.txt");
			outputFile.createNewFile();
			StringBuilder output = new StringBuilder();
			
			final int NO_OF_CASES = Integer.parseInt(contentArray[0]);
			
			int lastLineNo = 1;
			
			for (int i = 0; i < NO_OF_CASES; i++)
			{
				int S = Integer.parseInt(contentArray[lastLineNo++]);
				
				String[] SE = new String[S];
				
				int preecedingLines = lastLineNo+S;
				
				for (int j = lastLineNo,k=0; j < preecedingLines; j++,k++) 
				{
					SE[k] = contentArray[j];
				}
				
				lastLineNo = preecedingLines;
				
				int Q = Integer.parseInt(contentArray[lastLineNo++]);
				
				preecedingLines = lastLineNo + Q;
				
				String[] queries = new String[Q];
				
				for (int j = lastLineNo,k=0; j < preecedingLines; j++,k++) 
				{
					queries[k] = contentArray[j];
				}
				
				lastLineNo = preecedingLines;
				
				int switches = 0;
				
				/*Map<String,Integer> SEOccurrences = new HashMap<String, Integer>(S);
				
				for (int j = 0; j < SE.length; j++) 
				{
					SEOccurrences.put(SE[j], 0);
				}
				
				for(int j = 0; j < Q; j++)
				{
					String key = queries[j];
					int v = SEOccurrences.get(key);
					SEOccurrences.put(key, ++v);
				}
				
				List<SearchEngineQuery> listOfSE = new ArrayList<SearchEngineQuery>(S);
				
				for (Map.Entry<String,Integer> entry : SEOccurrences.entrySet())
				{
					SearchEngineQuery query = new SearchEngineQuery();
					query.setSEName(entry.getKey());
					query.setOcurrences(entry.getValue());
					
					listOfSE.add(query);
				}
				
				Comparator<SearchEngineQuery> sEQueryComparator = new SEQueryComparator();
				
				Collections.sort(listOfSE, sEQueryComparator);
				
				if(listOfSE.get(0).getOcurrences() == 0)
				{
					switches = 0;
				}
				else
				{
					
				}*/
				
				List<SearchEngineQuery> listOfSE = new ArrayList<SearchEngineQuery>(S);
				
				for (int j = 0; j < S; j++) 
				{
					SearchEngineQuery query = new SearchEngineQuery();
					
					query.setSEName(SE[j]);
					query.setPosition(0);
					
					listOfSE.add(query);
				}
				
				SearchEngineQuery farthestSE = listOfSE.get(0);
				 
				/*for (Iterator iter = listOfSE.iterator(); iter.hasNext();) 
				{
					SearchEngineQuery element = (SearchEngineQuery) iter.next();
					
					int position = getClosestPosition(element.getSEName(), queries);
					
					if(farthestSE.getPosition() < position)
					{
						farthestSE = element;
						farthestSE.setPosition(position);
					}
				}*/
				
				switches = getSwitches(switches, listOfSE, farthestSE, queries);
				
				/*farthestSE = getFarthestSE(listOfSE, farthestSE, queries);
				
				int removalPosition = farthestSE.getPosition();
				
				for(int j=0; j<=removalPosition; j++)
				{
					listOfSE.remove(j);
				}
				
				farthestSE = listOfSE.get(0);
				farthestSE = getFarthestSE(listOfSE, farthestSE, queries);*/
				
				System.out.println(switches);
				output.append("Case #" + (int)(i+1) + ": " + switches + "\n");
			}
			setContents(outputFile, output.toString());
		}
		catch(Exception e)
		{
			e.printStackTrace();
		}
	}
	
	public static int getSwitches(int switches, List<SearchEngineQuery> listOfSE, SearchEngineQuery farthestSE, String[] queries)
	{
		if(listOfSE.size() == 0)
		{
			return switches;
		}
		else if(isAnySENotOccurring(listOfSE, queries))
		{
			return switches;
		}
		else
		{
			for (int m=0; m<listOfSE.size(); m++)
			{
				listOfSE.get(m).setPosition(0);
			}
			farthestSE = listOfSE.get(0);
			farthestSE = getFarthestSE(listOfSE, farthestSE, queries);
			
			int removalPosition = farthestSE.getPosition();
			
			String[] newQueries = new String[queries.length - removalPosition];
			
			for(int j=removalPosition,k=0; j<queries.length; j++,k++)
			{
				newQueries[k] = queries[j];
			}
			queries = newQueries;
			switches = getSwitches(switches+1, listOfSE, farthestSE, queries);
		}
		return switches;
	}
	
	public static boolean isAnySENotOccurring(List<SearchEngineQuery> listOfSE, String[] queries)
	{
		for (Iterator iter = listOfSE.iterator(); iter.hasNext();) 
		{
			SearchEngineQuery element = (SearchEngineQuery) iter.next();
			
			boolean occurred = false;
			String SEnm = element.getSEName();
			for (int i = 0; i < queries.length; i++) 
			{
				if(SEnm.equals(queries[i]))
				{
					occurred = true;
					break;
				}
			}
			
			if(occurred == false)
			{
				return true;
			}
		}
		return false;
	}
	
	public static SearchEngineQuery getFarthestSE(List<SearchEngineQuery> listOfSE, SearchEngineQuery farthestSE, String[] queries)
	{
		for (Iterator iter = listOfSE.iterator(); iter.hasNext();) 
		{
			SearchEngineQuery element = (SearchEngineQuery) iter.next();
			
			int position = getClosestPosition(element.getSEName(), queries);
			
			if(farthestSE.getPosition() < position)
			{
				farthestSE = element;
				farthestSE.setPosition(position);
			}
		}
		
		return farthestSE;
	}
	
	public static int getClosestPosition(String SEName, String[] queries)
	{
		int position = 0;
		for (int i = 0; i < queries.length; i++)
		{
			if(SEName.equals(queries[i]))
			{
				position = i;
				break;
			}
		}
		return position;
	}
	
	static public String getContents(File aFile)
	{
	    //...checks on aFile are elided
	    StringBuilder contents = new StringBuilder();
	    
	    try {
	      //use buffering, reading one line at a time
	      //FileReader always assumes default encoding is OK!
	      BufferedReader input =  new BufferedReader(new FileReader(aFile));
	      try {
	        String line = null; //not declared within while loop
	        /*
	        * readLine is a bit quirky :
	        * it returns the content of a line MINUS the newline.
	        * it returns null only for the END of the stream.
	        * it returns an empty String if two newlines appear in a row.
	        */
	        while (( line = input.readLine()) != null){
	          contents.append(line);
	          contents.append(System.getProperty("line.separator"));
	        }
	      }
	      finally {
	        input.close();
	      }
	    }
	    catch (IOException ex){
	      ex.printStackTrace();
	    }
	    
	    return contents.toString();
	  }
	
	static public void setContents(File aFile, String aContents) throws FileNotFoundException, IOException 
	{
		if (aFile == null) {
		throw new IllegalArgumentException("File should not be null.");
		}
		if (!aFile.exists()) {
		throw new FileNotFoundException ("File does not exist: " + aFile);
		}
		if (!aFile.isFile()) {
		throw new IllegalArgumentException("Should not be a directory: " + aFile);
		}
		if (!aFile.canWrite()) {
		throw new IllegalArgumentException("File cannot be written: " + aFile);
		}
		
		//use buffering
		Writer output = new BufferedWriter(new FileWriter(aFile));
		try {
		//FileWriter always assumes default encoding is OK!
		output.write( aContents );
		}
		finally {
		output.close();
		}
	}
}

/*class SEQueryComparator implements Comparator<SearchEngineQuery>
{
	public int compare(SearchEngineQuery o1, SearchEngineQuery o2) 
	{
		int value = 0;
		if(o1.getOcurrences() < o2.getOcurrences())
		{
			value = -1;
		}
		else if (o1.getOcurrences() > o2.getOcurrences())
		{
			value = 1;
		}
		return value;
	}
}*/