import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collections;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class Utility 
{
	public static void prepareStartEndLists(int startElements, int endElements, List<Calendar> start, List<Calendar> end, String[] startTimeArray, String[] endTimeArray, int T) throws ParseException
	{
		DateFormat formatter = new SimpleDateFormat("HH:mm");
		
//		 For start time
		for (int i = 0; i < startElements; i++) 
		{
			String individualsTiming[] = startTimeArray[i].split(" ");
			
			Date date = formatter.parse(individualsTiming[0]);
			Calendar cal=Calendar.getInstance();
		    cal.setTime(date);
			start.add(cal);
		}
		
//		 For end time
		for (int i = 0; i < endElements; i++) 
		{
			String individualsTiming[] = endTimeArray[i].split(" ");
			
			Date date = formatter.parse(individualsTiming[1]);
			Calendar cal=Calendar.getInstance();
		    cal.setTime(date);
		    cal.add(Calendar.MINUTE, T);
			end.add(cal);
		}
		
		Collections.sort(start);
		Collections.sort(end);
	}
	
	public static int getMinTrains(int startElements, int endElements, List<Calendar> start, List<Calendar> end, int trains)
	{
		List<Calendar> tempStart = new ArrayList<Calendar>(startElements);
		tempStart.addAll(start);
		List<Calendar> tempEnd = new ArrayList<Calendar>(endElements);
		tempEnd.addAll(end);
		
		for (Iterator iter = tempEnd.iterator(); iter.hasNext();)
		{
			Calendar endTime = (Calendar) iter.next();
			
			Calendar startTime = null;
			for (Iterator iterator = tempStart.iterator(); iterator.hasNext();) 
			{
				startTime = (Calendar) iterator.next();
				if(!(endTime.after(startTime)))
				{
					--trains;
					break;
				}
			}
			tempStart.remove(startTime);
		}
		return trains;
	}
}
