
	import java.io.BufferedReader;
	import java.io.BufferedWriter;
	import java.io.File;
	import java.io.FileReader;
	import java.io.FileWriter;
	import java.io.IOException;
	import java.util.ArrayList;
import java.util.StringTokenizer;


	public class Magician {
		/**
		 * Input Output Stream Initilization
		 */
		
		private static  BufferedReader fileReader = null;
		
		private static BufferedWriter fileWriter = null;
		
		private static void createReader(String fileName) throws IOException{
			fileReader = new BufferedReader(new FileReader(new File(fileName)));
		}
		
		private static void createWriter(String fileName) throws IOException{
			fileWriter = new BufferedWriter(new FileWriter(new File(fileName)));
		}
		
		private static void close() throws IOException{
			if(fileReader != null){
				fileReader.close();
			}
			if(fileWriter != null){
				fileWriter.close();
			}
		}
		
		private static String readLine() throws IOException{
			return fileReader.readLine();
		}
		
		private static void writeln(Object value) throws IOException{
			fileWriter.write(value.toString() + "\n");
		}

		private static final String prefix = "Case #";
		
		public static void main(String [] args){
			try{
				createReader("abc.in");
				createWriter("abc.out");
				executeAlgo();
				close();
			}catch(Exception ex){
				System.out.println(ex.getMessage());
			}
		}
		
		
		private static String getSolutionSet(int row) throws IOException{
			String solSet = "";
			for(int i = 1;i <= 4;i++){
				if(i == row){
					solSet = readLine();
				}else{
					readLine();
				}
			}
			return solSet;
		}
		
		
		private static void executeAlgo() throws IOException {
			int noOfCases = Integer.parseInt(readLine());
			int ans = -1;
			String [] solSet1;
			String [] solSet2;
			int count = 0;
			String result = "";
			for(int i = 0;i<noOfCases;i++){
				count = 0;
				result = "";
				ans = Integer.parseInt(readLine());
				solSet1 = getSolutionSet(ans).split(" ");
				ans = Integer.parseInt(readLine());
				solSet2 = getSolutionSet(ans).split(" ");
				for(String card : solSet1){
					for(String matchCard : solSet2){
						if(card.equalsIgnoreCase(matchCard)){
							count++;
							result = card;
							break;
						}
					}
					if(count > 1){
						break;
					}
				}
				if(count == 1){
					writeln(prefix + (i+1) +": " + result);
				}else if(count == 0){
					writeln(prefix + (i+1) +": Volunteer cheated!");
				}else{
					writeln(prefix + (i+1) +": Bad magician!");
				}
			}
		}
	}


