import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class Lawnmower {
	/**
	 * Input Output Stream Initilization
	 */
	
	private static  BufferedReader fileReader = null;
	
	private static BufferedWriter fileWriter = null;
	
	private static void createReader(String fileName) throws IOException{
		fileReader = new BufferedReader(new FileReader(new File(fileName)));
	}
	
	private static void createWriter(String fileName) throws IOException{
		fileWriter = new BufferedWriter(new FileWriter(new File(fileName)));
	}
	
	private static void close() throws IOException{
		if(fileReader != null){
			fileReader.close();
		}
		if(fileWriter != null){
			fileWriter.close();
		}
	}
	
	private static String readLine() throws IOException{
		return fileReader.readLine();
	}
	
	private static ArrayList<Integer> getIntTokens() throws IOException{
		return getIntTokens(readLine()," ");
	}
	
	private static ArrayList<Integer> getIntTokens(String dlim) throws IOException{
		return getIntTokens(readLine(),dlim);
	}
	
	private static ArrayList<Integer> getIntTokens(String line,String dlim) throws IOException{
		StringTokenizer tokens = new StringTokenizer(line,dlim);
		ArrayList<Integer> list = new ArrayList<Integer>();
		if(tokens != null){
			while(tokens.hasMoreTokens()){
				list.add(Integer.valueOf(tokens.nextToken()));
			}
		}
		return list;
	}
	
	private static ArrayList<String> getTokens() throws IOException{
		return getTokens(readLine()," ");
	}
	
	private static ArrayList<String> getTokens(String dlim) throws IOException{
		return getTokens(readLine(),dlim);
	}
	
	private static ArrayList<String> getTokens(String line,String dlim) throws IOException{
		StringTokenizer tokens = new StringTokenizer(line,dlim);
		ArrayList<String> list = new ArrayList<String>();
		if(tokens != null){
			while(tokens.hasMoreTokens()){
				list.add(tokens.nextToken());
			}
		}
		return list;
	}
	
	/**
	 * readline and space
	 * @return
	 * @throws IOException
	 */
	private static int countTokens() throws IOException{
		return countTokens(readLine()," ");
	}
	
	/**
	 * readline
	 * @param dlim
	 * @return
	 * @throws IOException
	 */
	private static int countTokens(String dlim) throws IOException{
		return countTokens(readLine(),dlim);
	}
	/**
	 * all you have to provide
	 * @param line
	 * @param dlim
	 * @return
	 * @throws IOException
	 */
	private static int countTokens(String line,String dlim) throws IOException{
		StringTokenizer tokens = new StringTokenizer(line,dlim);
		return tokens.countTokens();
	}
	
	private static void write(Object value) throws IOException{
		fileWriter.write(value.toString());
	}
	
	private static void writeln(Object value) throws IOException{
		fileWriter.write(value.toString() + "\n");
	}
	
	private static int getInt() throws IOException{
		return Integer.parseInt(getTokens().get(0));
	}
	
	private static long getLong() throws IOException{
		return Long.parseLong(getTokens().get(0));
	}
	
	private static double getDouble() throws IOException{
		return Double.parseDouble(getTokens().get(0));
	}
	
	private static final String prefix = "Case #";
	
	public static void main(String [] args){
		try{
			createReader("abc.in");
			createWriter("abc.out");
			executeAlgo();
			close();
		}catch(Exception ex){
			System.out.println(ex.getMessage());
		}
	}
	
	
	private static final String YES = "YES";
	private static final String NO = "NO";
	
	private static void executeAlgo() throws IOException {
		int noOfCases = getIntTokens().get(0);
		ArrayList<Integer> dimension ;
		ArrayList<ArrayList<Integer>> height;
		for(int i =0 ;i< noOfCases;i++){
			dimension = getIntTokens();
			height = new ArrayList<ArrayList<Integer>>();
			for(int j=0;j < dimension.get(0);j++){
				height.add(getIntTokens());
			}
			
			if(checkEachCell(height)){
				writeln(prefix + (i+1) +": " + YES);
			}else{
				writeln(prefix + (i+1) +": " + NO);
			}
		}
	}
	
	/**
	 * If either all row elements or all columns elemnts are small then it return true.
	 * @param height
	 * @return
	 */
	private static boolean checkEachCell(ArrayList<ArrayList<Integer>> height){
		ArrayList< Integer> data ;
		for(int row =0; row < height.size() ;row++){
			data = height.get(row);
			for(int col=0; col < data.size();col++ ){
				if(!(checkRow(data.get(col),height,row) || checkColumn(data.get(col),height,col))){
					return false;
				}
			}
		}
		return true;
	}
	
	private static boolean checkRow(Integer cell,ArrayList<ArrayList<Integer>> height,int row){
		for(Integer data : height.get(row)){
			if(data > cell){
				return false;
			}
		}
		return true;
	}
	
	private static boolean checkColumn(Integer cell,ArrayList<ArrayList<Integer>> height,int col){
		for(ArrayList<Integer> row : height){
				if(row.get(col) > cell){
					return false;
				}
			}
		return true;
	}
	
}

