import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class FairPallendromeSquare {
	/**
	 * Input Output Stream Initilization
	 */
	
	private static  BufferedReader fileReader = null;
	
	private static BufferedWriter fileWriter = null;
	
	private static void createReader(String fileName) throws IOException{
		fileReader = new BufferedReader(new FileReader(new File(fileName)));
	}
	
	private static void createWriter(String fileName) throws IOException{
		fileWriter = new BufferedWriter(new FileWriter(new File(fileName)));
	}
	
	private static void close() throws IOException{
		if(fileReader != null){
			fileReader.close();
		}
		if(fileWriter != null){
			fileWriter.close();
		}
	}
	
	private static String readLine() throws IOException{
		return fileReader.readLine();
	}
	
	private static ArrayList<Integer> getIntTokens() throws IOException{
		return getIntTokens(readLine()," ");
	}
	
	private static ArrayList<Integer> getIntTokens(String dlim) throws IOException{
		return getIntTokens(readLine(),dlim);
	}
	
	private static ArrayList<Integer> getIntTokens(String line,String dlim) throws IOException{
		StringTokenizer tokens = new StringTokenizer(line,dlim);
		ArrayList<Integer> list = new ArrayList<Integer>();
		if(tokens != null){
			while(tokens.hasMoreTokens()){
				list.add(Integer.valueOf(tokens.nextToken()));
			}
		}
		return list;
	}
	private static ArrayList<Long> getLongTokens() throws IOException{
		return getLongTokens(readLine()," ");
	}
	
	private static ArrayList<Long> getLongTokens(String dlim) throws IOException{
		return getLongTokens(readLine(),dlim);
	}
	
	private static ArrayList<Long> getLongTokens(String line,String dlim) throws IOException{
		StringTokenizer tokens = new StringTokenizer(line,dlim);
		ArrayList<Long> list = new ArrayList<Long>();
		if(tokens != null){
			while(tokens.hasMoreTokens()){
				list.add(Long.valueOf(tokens.nextToken()));
			}
		}
		return list;
	}
	
	private static ArrayList<String> getTokens() throws IOException{
		return getTokens(readLine()," ");
	}
	
	private static ArrayList<String> getTokens(String dlim) throws IOException{
		return getTokens(readLine(),dlim);
	}
	
	private static ArrayList<String> getTokens(String line,String dlim) throws IOException{
		StringTokenizer tokens = new StringTokenizer(line,dlim);
		ArrayList<String> list = new ArrayList<String>();
		if(tokens != null){
			while(tokens.hasMoreTokens()){
				list.add(tokens.nextToken());
			}
		}
		return list;
	}
	
	/**
	 * readline and space
	 * @return
	 * @throws IOException
	 */
	private static int countTokens() throws IOException{
		return countTokens(readLine()," ");
	}
	
	/**
	 * readline
	 * @param dlim
	 * @return
	 * @throws IOException
	 */
	private static int countTokens(String dlim) throws IOException{
		return countTokens(readLine(),dlim);
	}
	/**
	 * all you have to provide
	 * @param line
	 * @param dlim
	 * @return
	 * @throws IOException
	 */
	private static int countTokens(String line,String dlim) throws IOException{
		StringTokenizer tokens = new StringTokenizer(line,dlim);
		return tokens.countTokens();
	}
	
	private static void write(Object value) throws IOException{
		fileWriter.write(value.toString());
	}
	
	private static void writeln(Object value) throws IOException{
		fileWriter.write(value.toString() + "\n");
	}
	
	private static int getInt() throws IOException{
		return Integer.parseInt(getTokens().get(0));
	}
	
	private static long getLong() throws IOException{
		return Long.parseLong(getTokens().get(0));
	}
	
	private static double getDouble() throws IOException{
		return Double.parseDouble(getTokens().get(0));
	}
	
	private static final String prefix = "Case #";
	
	public static void main(String [] args){
		try{
			createReader("abc.in");
			createWriter("abc.out");
			executeAlgo();
			close();
		}catch(Exception ex){
			System.out.println(ex.getMessage());
		}
	}
	
	/**
	 * no. and its square root should be pallendrome
	 * @throws IOException
	 */
	
	private static void executeAlgo() throws IOException {
		int noOfCases = getIntTokens().get(0);
		ArrayList<String> limit;
		for(int i =0; i<noOfCases ;i++){
			limit = getTokens();
			StringBuffer lowerLimit = new StringBuffer(limit.get(0));
			StringBuffer upperLimit = new StringBuffer(limit.get(1));
			Long count = 0L;
			
			if(lowerLimit.charAt(0) == '0'){
				lowerLimit.deleteCharAt(0);
			}
			if(upperLimit.charAt(0) == '0'){
				upperLimit.deleteCharAt(0);
			}
			while(!lowerLimit.toString().equals(upperLimit.toString())){
				if(pallendrome(lowerLimit) && square(new StringBuffer(lowerLimit))){
					count++;
				}
				addOneInLowerLimt(Integer.valueOf(lowerLimit.charAt(lowerLimit.length() -1)+""),lowerLimit ,lowerLimit.length());
			}
			if(pallendrome(lowerLimit) && square(lowerLimit)){
				count++;
			}
			writeln(prefix + (i+1) +": " + count);
		}
	}
	
	private static void addOneInLowerLimt(int lastchar,StringBuffer lowerLimit,int size){
		lastchar += 1;
		if(lastchar > 9){
			lowerLimit.replace(size -1,size, "0"); 
			if(size == 1){
				lowerLimit.insert(0, "1");
			}else{
				addOneInLowerLimt(Integer.valueOf(lowerLimit.charAt(size -2)+""), lowerLimit,size -1);
			}
		}else{
			lowerLimit.replace(size -1,size,lastchar +"");
		}
	}
	
	private static boolean pallendrome(StringBuffer str){
		int size = str.length();
		for(int i =0 ; i < size/2; i++){
			if(str.charAt(i) != str.charAt(size- 1 - i )){
				return false;
			}
		}
		return true;
	}
	
	private static boolean square(StringBuffer str){
		int num;
		int sqrt;
		int rem = 0;
		StringBuffer resultSqrt = new StringBuffer();
		if(!(str.length() % 2 == 0)){//odd number
			num = Integer.valueOf(str.charAt(0) + "");
			sqrt = (int)Math.sqrt(num);
			rem = num - (sqrt*sqrt);
			resultSqrt.append(sqrt);
			str.deleteCharAt(0);
		}
		while(str.length() > 0){
			num = Integer.valueOf(rem + str.substring(0, 2));
			if(resultSqrt.length() == 0){
				sqrt = (int)Math.sqrt(num);
				rem = num - (sqrt*sqrt);
				resultSqrt.append(sqrt);
			}else{
				int i = 0;
				int mul = Integer.valueOf(resultSqrt.toString());
				mul += mul;
				int temp = 0;
				for(i=9;i>=0;i--){
					temp = mul;
					temp = Integer.valueOf(String.valueOf(temp)+ i);
					if(temp*i <= num){
						break;
					}
				}
				rem = num - temp*i;
				resultSqrt.append(i);
			}
			str.delete(0,2);
		}
		if(rem == 0){//perfect sqrt
			return pallendrome(resultSqrt);
		}
		return false;
	}
}


