import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;


public class Cookie {
	/**
	 * Input Output Stream Initilization
	 */
	
	private static  BufferedReader fileReader = null;
	
	private static BufferedWriter fileWriter = null;
	
	private static void createReader(String fileName) throws IOException{
		fileReader = new BufferedReader(new FileReader(new File(fileName)));
	}
	
	private static void createWriter(String fileName) throws IOException{
		fileWriter = new BufferedWriter(new FileWriter(new File(fileName)));
	}
	
	private static void close() throws IOException{
		if(fileReader != null){
			fileReader.close();
		}
		if(fileWriter != null){
			fileWriter.close();
		}
	}
	
	private static String readLine() throws IOException{
		return fileReader.readLine();
	}
	
	private static void writeln(Object value) throws IOException{
		fileWriter.write(value.toString() + "\n");
	}

	private static final String prefix = "Case #";
	
	public static void main(String [] args){
		try{
			createReader("abc.in");
			createWriter("abc.out");
			executeAlgo();
			close();
		}catch(Exception ex){
			System.out.println(ex.getMessage());
		}
	}
	
	
	private static void executeAlgo() throws IOException {
		int noOfCases = Integer.parseInt(readLine());
		float C;
		float F;
		float X;
		float time = 0;
		float rate = 2;
		String []temp;
		DecimalFormat format = new DecimalFormat("0.0000000");

		for(int i = 0;i<noOfCases;i++){
			time = 0;
			rate = 2;
			temp = readLine().split(" ");
			C = Float.parseFloat(temp[0]);
			F = Float.parseFloat(temp[1]);
			X = Float.parseFloat(temp[2]);
			while(C/rate + X/(rate+F) < X/rate){
				//buy farm
				time = time + C/rate;
				rate = rate + F;
			}
			time = time + X/rate;
			writeln(prefix + (i+1) +": " + format.format(time));
		}
	}
}



