import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class PancakeFliper {

	public static String smallFile = "C:/Users/bharath/Downloads/A-small-attempt0.in";
	public static String largeFile = "C:/Users/bharath/Downloads/A-large.in";
	public static String initialInput = "";
	public static int pos;
    public static List<String> outputList=new ArrayList<String>();

	public static void main(String[] args) throws IOException {
		PancakeFliper p=new PancakeFliper();
        p.readWriteFile(largeFile);
    }

    public void readWriteFile(String filePath) throws IOException {
        File file = new File(filePath);
        File outFile = new File(filePath.substring(0, filePath.length() - 2)
                + "out");
        BufferedReader br = new BufferedReader(new FileReader(file));
        BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
        int testCases = Integer.parseInt(br.readLine());
        for (int t = 1; t <= testCases; t++) {
            String input[] = br.readLine().split(" ");
            String value = flipPanCake(input[0], Integer.parseInt(input[1]));
            bw.write("Case #" + t + ": " + value + "\n");
        }
        br.close();
        bw.close();
    }

    public String flipPanCake(String s,int n) {
        clear();
        int count = 0;
        while (true) {
            outputList.add(s);
            if (isPositive(s)) {
                return Integer.toString(count);
            }
            count++;
            String sub = getSubString(s, n);
            if(sub==null)
                return "IMPOSSIBLE";
            String flipped = flip(sub);
            StringBuilder sb = new StringBuilder();
            sb.append(s.substring(0, pos));
            sb.append(flipped);
            sb.append(s.substring(pos + n, s.length()));
            s = sb.toString();
            if(outputList.contains(s)) {
                return "IMPOSSIBLE";
            }
        }

    }


    int getStartPositin(String s)
    {
        for(int i=s.length()-1;i>=0;i--)
        {
            if(s.charAt(i)=='-')
                return s.length()-i-1;
        }
        return 0;
    }

    private String getSubString(String s, int n) {
        int count = 0;
        String toReplace = null;
        int size = s.length();
        int spos=getStartPositin(s);
        for (int i = size-spos; i - n >= 0; i--) {
            String sub = s.substring(i - n, i);
            if (stringCount(sub) > count) {
                pos = i - n;
                count = stringCount(sub);
                toReplace = sub;
            }
        }
        return toReplace;
    }

    private int stringCount(String s) {
        int counter = 0;
        for (int i = 0; i < s.length(); i++) {
            if (s.charAt(i) == '-') {
                counter++;
            }
        }
        return counter;
    }

    private String flip(String s) {
        char[] chars = s.toCharArray();
        for (int i = 0; i <= chars.length - 1; i++) {
            if (chars[i] == '-')
                chars[i] = '+';
            else if (chars[i] == '+')
                chars[i] = '-';
        }
        return new String(chars);
    }

    private Boolean isPositive(String s) {
        char[] chars = s.toCharArray();
        for (char c : chars) {
            if (c == '-')
                return false;
        }
        return true;
    }
    
    private void clear(){
    	outputList.clear();
        pos=0;
    }
}
