package google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.ObjectInputStream.GetField;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

public class BathRoom {

	public static String smallFile = "C:/Users/bharath/Downloads/C-small-1-attempt1.in";
	public static String largeFile = "C:/Users/bharath/Downloads/C-large.in";

	public static void main(String[] args) throws IOException {
		BathRoom p=new BathRoom();
        p.readWriteFile(smallFile);
    }

	public void readWriteFile(String filePath) throws IOException {
		File file = new File(filePath);
		File outFile = new File(filePath.substring(0, filePath.length() - 2)
				+ "out");
		BufferedReader br = new BufferedReader(new FileReader(file));
		BufferedWriter bw = new BufferedWriter(new FileWriter(outFile));
		int testCases = Integer.parseInt(br.readLine());
		for (int t = 1; t <= testCases; t++) {
			String input[] = br.readLine().split(" ");
			String value = create(Integer.parseInt(input[0]),Integer.parseInt(input[1]));
			bw.write("Case #" + t + ": " + value + "\n");
		}
		br.close();
		bw.close();
	}
	public String create(int n,int k) {

//		n = 3;
//		k = 3;
		char bathroom[] = new char[n + 2];
		bathroom[0] = 'o';
		bathroom[n + 1] = 'o';
		for (int x = 1; x < bathroom.length - 1; x++) {
			bathroom[x] = '-';
		}
		BathRoom b = new BathRoom();
		for (int i = 0; i < k; i++) {
			bathroom = b.calculate(bathroom);
			if(rightPosition ==0 && leftPosition == 0){
				break;
			}
		}
		System.out.println("Max:" + rightPosition + "   MIN:" + leftPosition);
		return rightPosition+" "+leftPosition;
	}

	public char[] calculate(char[] bathroom) {

		int right = 0;
		int left = 0;
		Map<Integer, Integer> position = new HashMap<Integer, Integer>();
		// Map<Integer, Integer> minMax = new HashMap<Integer, Integer>();
		List<MinMax> minMax = new ArrayList<MinMax>();
		for (int i = 0; i < bathroom.length; i++) {
			if (bathroom[i] == '-') {
				for (int j = i + 1; j < bathroom.length; j++) {
					if (bathroom[j] == 'o') {
						right = j - i - 1;
						break;
					}
				}
				int count = 0;
				for (int l = i - 1; l >= 0; l--) {
					count++;
					if (bathroom[l] == 'o') {
						left = count - 1;
						break;
					}
				}

				System.out.println("left:" + left + " Right:" + right);
				MinMax minMaxObj = new MinMax();
				if (left > right) {
					// minMax.put(left, right);
					minMaxObj.setMax(left);
					minMaxObj.setMin(right);
				} else {
					// minMax.put(right, left);
					minMaxObj.setMax(right);
					minMaxObj.setMin(left);
				}
				minMax.add(minMaxObj);
			}
		}

		getBathroomPosition(minMax);
		return allocateBathroomForPosition(bathroom);

	}

	public static int rightPosition = 0;
	public static int leftPosition = 0;

	public Map<Integer, Integer> getBathroomPosition(
			Map<Integer, Integer> minMax) {
		Map<Integer, Integer> position = new HashMap<Integer, Integer>();
		int maxValueInMap = (Collections.max(minMax.values()));
		for (Entry<Integer, Integer> entry : minMax.entrySet()) {
			if (entry.getValue() == maxValueInMap) {
				position.put(entry.getValue(), entry.getKey());
				leftPosition = entry.getValue();
				rightPosition = entry.getKey();
				System.out.println("position:" + entry.getValue() + ", "
						+ entry.getKey());
				break;
			}
		}
		return position;

	}

	public void getBathroomPosition(List<MinMax> minMax) {
		Collections.sort(minMax, new Comparator<MinMax>() {
	        public int compare(MinMax o1, MinMax o2) {
	            //Sorts by 'TimeStarted' property
	            return o2.getMin()- o1.getMin();
	        }});
		int minValue=minMax.get(0).getMin();
		int maxValue=minMax.get(0).getMax();
		for(MinMax x:minMax){
			if(x.getMin()==minValue && x.getMax()>maxValue){
				maxValue = x.getMax();
			}
		}
		leftPosition = minValue;
		rightPosition = maxValue;

	}

	public char[] allocateBathroomForPosition(char[] bathRoom) {
		int leftEmptyCount = 0;
		for (int i = 0; i < bathRoom.length; i++) {
			if (bathRoom[i] == '-') {
				leftEmptyCount++;
			} else {
				leftEmptyCount = 0;
			}
			if (leftEmptyCount == leftPosition) {
				int rightEmptyCount = 0;
				for (int j = i + 2; j < bathRoom.length; j++) {
					if (bathRoom[j] == '-') {
						rightEmptyCount++;
					} else {
						rightEmptyCount = 0;
					}
					if (rightEmptyCount == rightPosition) {
						bathRoom[i + 1] = 'o';
						break;
					}
				}
			}
		}
		System.out.println(new String(bathRoom));
		return bathRoom;

	}

	public class MinMax {
		private int min = 0;
		private int max = 0;

		/**
		 * @return the min
		 */
		public int getMin() {
			return min;
		}

		/**
		 * @param min
		 *            the min to set
		 */
		public void setMin(int min) {
			this.min = min;
		}

		public int getMax() {
			return max;
		}

		public void setMax(int max) {
			this.max = max;
		}

	}
}
