import java.util.*;
import java.io.*;
public class Task2
{


    /************************ SOLUTION STARTS HERE ***********************/


    private static String flip(String str)
    {
	StringBuilder sb = new StringBuilder();
	for(int i=0,len=str.length();i<len;i++)
	{
	    if(str.charAt(i) == '+')
		sb.append('-');
	    else
		sb.append('+');
	}
	return sb.reverse().toString();
    }
    private static boolean isCorrect(String str)
    {
	boolean flag = true;
	for(int i=0,len=str.length();i<len;i++)
	    flag &= str.charAt(i) == '+';

	return flag;
    }

    private static int minWaysBFS(String str)
    {
	ArrayDeque<String> queue = new ArrayDeque<>();	
	HashMap<String,Integer> dist = new HashMap<>();
	dist.put(str, 0);
	queue.add(str);
	while(!queue.isEmpty())
	{
	    String curr = queue.remove();
	    if(isCorrect(curr))
		return dist.get(curr);
	    for(int i=1,len=str.length();i<=len;i++)
	    {	
		String v = flip(curr.substring(0, i)) + curr.substring(i);
		if(!dist.containsKey(v))
		{
		    queue.add(v);
		    dist.put(v, dist.get(curr) + 1);
		}
	    }
	}
	return -1;
    }
    private static void solve(FastScanner s1, PrintWriter out){

	int t = s1.nextInt();
	for(int z=1;z<=t;z++)
	{
	    out.println("Case #"+z+": "+minWaysBFS(s1.nextLine()));
	}

    }



    /************************ SOLUTION ENDS HERE ************************/





    /************************ TEMPLATE STARTS HERE *********************/

    public static void main(String []args) throws IOException {
	String location = "/home/bhishmaraj/Documents/OJ/workspace/CodeJam/Task2/";
	//FastScanner in  = new FastScanner(System.in);
	//PrintWriter out = 
	//	new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)), false); 
	FastScanner in = new FastScanner(location + "in.txt");
	PrintWriter out = new PrintWriter(location + "out.txt");
	long start = System.nanoTime();
	solve(in, out);
	long stop = System.nanoTime();
	System.err.println("Time : "+((stop-start)/1e9) + " s");
	in.close();
	out.close();
    }    

    static class FastScanner{
	BufferedReader reader;
	StringTokenizer st;
	FastScanner(InputStream stream){reader=new BufferedReader(new InputStreamReader(stream));st=null;}	
	public FastScanner(String file){
	    try
	    {
		reader = new BufferedReader(new FileReader(file));
		st = null;
	    }
	    catch(FileNotFoundException e)
	    {
		e.printStackTrace();
	    }
	}
	String next()
	{while(st == null || !st.hasMoreTokens()){try{String line = reader.readLine();if(line == null){return null;}		    
	st = new StringTokenizer(line);}catch (Exception e){throw new RuntimeException();}}return st.nextToken();}
	String nextLine()  {String s=null;try{s=reader.readLine();}catch(IOException e){e.printStackTrace();}return s;}	    	  	
	int    nextInt()   {return Integer.parseInt(next());}
	long   nextLong()  {return Long.parseLong(next());}		
	double nextDouble(){return Double.parseDouble(next());}
	char   nextChar()  {return next().charAt(0);}
	int[]  nextIntArray(int n)         {int[] arr= new int[n];   int i=0;while(i<n){arr[i++]=nextInt();}  return arr;}
	long[] nextLongArray(int n)        {long[]arr= new long[n];  int i=0;while(i<n){arr[i++]=nextLong();} return arr;}	
	int[]  nextIntArrayOneBased(int n) {int[] arr= new int[n+1]; int i=1;while(i<=n){arr[i++]=nextInt();} return arr;}	    	
	long[] nextLongArrayOneBased(int n){long[]arr= new long[n+1];int i=1;while(i<=n){arr[i++]=nextLong();}return arr;}	    	
	void   close(){try{reader.close();}catch(IOException e){e.printStackTrace();}}				
    }

    /************************ TEMPLATE ENDS HERE ************************/
}