import java.util.*;
import java.io.*;
import java.math.BigInteger;
import java.security.SecureRandom;
public class Task3
{


    /************************ SOLUTION STARTS HERE ***********************/
    private final static BigInteger ZERO = new BigInteger("0");
    private final static BigInteger ONE  = new BigInteger("1");
    private final static BigInteger TWO  = new BigInteger("2");
    private final static SecureRandom random = new SecureRandom();

    private static BigInteger rho(BigInteger N) {
	BigInteger divisor;
	BigInteger c  = new BigInteger(N.bitLength(), random);
	BigInteger x  = new BigInteger(N.bitLength(), random);
	BigInteger xx = x;

	if (N.mod(TWO).compareTo(ZERO) == 0) return TWO;

	do {
	    x  =  x.multiply(x).mod(N).add(c).mod(N);
	    xx = xx.multiply(xx).mod(N).add(c).mod(N);
	    xx = xx.multiply(xx).mod(N).add(c).mod(N);
	    divisor = x.subtract(xx).gcd(N);
	} while((divisor.compareTo(ONE)) == 0);

	return divisor;
    }

    private static BigInteger factor(BigInteger N) {
	if (N.compareTo(ONE) == 0) return null;
	if (N.isProbablePrime(10)) return null; 
	else return rho(N);

    }

    private static void solve(FastScanner s1, PrintWriter out){

	int nbits = 16;
	int MAX = 50;
	int cnt = 1;	
	BigInteger bases[] = new BigInteger[11];
	HashSet<String> set = new HashSet<>();
	out.println("Case #1: ");
	while(cnt <= MAX)
	{
	    char rand[] = new char[nbits];
	    rand[0] = '1';
	    rand[nbits-1] = '1';
	    for(int i=1;i<nbits-1;i++)
		rand[i] = random.nextBoolean() ? '1' : '0';

	    String seed = new String(rand);
	    if(set.contains(seed))
		continue;
	    else
		set.add(seed);

	    for(int i=2;i<=10;i++)
		bases[i] = new BigInteger(seed, i);
	    BigInteger factors[] = new BigInteger[11];
	    boolean flag = true;
	    for(int i=2;i<=10;i++)
	    {
		factors[i] = factor(bases[i]);
		if(factors[i] == null || !bases[i].mod(factors[i]).equals(ZERO) || factors[i].equals(bases[i]))
		{
		    flag = false;
		    break;
		}
	    }
	    if(flag)
	    {
		cnt++;
		out.print(seed + " ");
		for(int i=2;i<=10;i++)
		    out.print(factors[i] + " ");
		out.println();
	    }
	}

    }



    /************************ SOLUTION ENDS HERE ************************/





    /************************ TEMPLATE STARTS HERE *********************/

    public static void main(String []args) throws IOException {
	String location = "/home/bhishmaraj/Documents/OJ/workspace/CodeJam/Task3/";
	FastScanner in  = new FastScanner(System.in);
	//PrintWriter out = 
	//	new PrintWriter(new BufferedWriter(new OutputStreamWriter(System.out)), false); 
	//FastScanner in = new FastScanner(location + " ");
	PrintWriter out = new PrintWriter(location + "out.txt");
	long start = System.nanoTime();
	solve(in, out);
	long stop = System.nanoTime();
	System.err.println("Time : "+((stop-start)/1e9) + " s");

	in.close();
	out.close();
    }    

    static class FastScanner{
	BufferedReader reader;
	StringTokenizer st;
	FastScanner(InputStream stream){reader=new BufferedReader(new InputStreamReader(stream));st=null;}	
	public FastScanner(String file){
	    try
	    {
		reader = new BufferedReader(new FileReader(file));
		st = null;
	    }
	    catch(FileNotFoundException e)
	    {
		e.printStackTrace();
	    }
	}
	String next()
	{while(st == null || !st.hasMoreTokens()){try{String line = reader.readLine();if(line == null){return null;}		    
	st = new StringTokenizer(line);}catch (Exception e){throw new RuntimeException();}}return st.nextToken();}
	String nextLine()  {String s=null;try{s=reader.readLine();}catch(IOException e){e.printStackTrace();}return s;}	    	  	
	int    nextInt()   {return Integer.parseInt(next());}
	long   nextLong()  {return Long.parseLong(next());}		
	double nextDouble(){return Double.parseDouble(next());}
	char   nextChar()  {return next().charAt(0);}
	int[]  nextIntArray(int n)         {int[] arr= new int[n];   int i=0;while(i<n){arr[i++]=nextInt();}  return arr;}
	long[] nextLongArray(int n)        {long[]arr= new long[n];  int i=0;while(i<n){arr[i++]=nextLong();} return arr;}	
	int[]  nextIntArrayOneBased(int n) {int[] arr= new int[n+1]; int i=1;while(i<=n){arr[i++]=nextInt();} return arr;}	    	
	long[] nextLongArrayOneBased(int n){long[]arr= new long[n+1];int i=1;while(i<=n){arr[i++]=nextLong();}return arr;}	    	
	void   close(){try{reader.close();}catch(IOException e){e.printStackTrace();}}				
    }

    /************************ TEMPLATE ENDS HERE ************************/
}