import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Stack;

public class CoinJam {

	/* Beau Hottovy - bhottovy@hotmail.com - CodeJam Template */
	
	final static String OUT_DIR = "output/";
	final static String IN_DIR = "input/";
	
	final static String FILE_OUT = OUT_DIR + "Output.txt";;
	
	BufferedReader in;
	BufferedWriter out;
	
	public CoinJam() {
		this.init();
	}
	
	public static void main(String args[]) {
		new CoinJam();
	}
	
	public void init() {
		File inDir = new File(IN_DIR);
		File[] inputFiles = inDir.listFiles();
		
		File fileIn = null;
		
		if(inputFiles.length == 1) {
			fileIn = inputFiles[0];
		} else if(inputFiles.length < 1){
			System.out.println("File missing! Wrong folder?");
		} else {
			System.out.println("Too many files! Check input folder.");
		}
		
		if(fileIn == null) System.exit(0);
		FileReader fr = null;
		
		File fileOut = new File(FILE_OUT);
		FileWriter fw = null;
		
		try {
			fr = new FileReader(fileIn);
			this.in = new BufferedReader(fr);
			
			fw = new FileWriter(fileOut);
			this.out = new BufferedWriter(fw);
			
			this.run();
			
			this.in.close();
			this.out.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}

	
	public int getInt(String num) throws IOException {
		return Integer.parseInt(num);
	}
	
	public void out(String line) throws IOException {
		this.out.write(line);
	}
	
	public void outln(String line) throws IOException {
		this.out.write(line);
		this.out.newLine();
	}
	
	public void run() throws IOException {
		int numOfCases = this.getInt(in.readLine());
		
		int curCase = 0;
		
		while(curCase < numOfCases) {
			curCase++;
			outln("Case #" + curCase + ":");

			String[] values = in.readLine().trim().split(" ");
			int N = this.getInt(values[0]);
			int J = this.getInt(values[1]);
			
			int[] digits = new int[N];
			digits[0] = 1;
			digits[N - 1] = 1;
			
			int bits = N - 2;
			int maxBinary = 0;
			for(int i = 0; i < bits; i++) {
				maxBinary += (int)Math.pow(2, i);
			}
			
			int jamCoins = 0;
			
			for(int i = 0; i <= maxBinary; i++) {
				int curBinary = i;
				for(int j = bits - 1; j >= 0; j--) {
					int bitVal = (int)Math.pow(2, j);
					
					if(curBinary >= bitVal) {
						curBinary -= bitVal;
						digits[N - j - 2] = 1;
					} else {
						digits[N - j - 2] = 0;
					}
				}

				boolean isJamCoin = true;
				
				int[] divisors = new int[11];
				
				for(int j = 2; j < 11; j++) {
					int baseSum = 0;
					for(int k = 0; k < digits.length; k++) {
						baseSum += digits[k] * (int)Math.pow(j, k);
					}
					
					int divisor = this.lowestDivisor(baseSum);
					divisors[j] = divisor;
					
					if(divisor == 1) {
						isJamCoin = false;
						break;
					}
				}
				
				if(isJamCoin) {
					jamCoins++;
					for(int j = 0; j < N; j++) {
						out(digits[j] + "");
					}
					
					for(int j = 2; j < 11; j++) {
						out(" " + divisors[j]);
					}
					outln("");
				}
				if(jamCoins >= J) break;
			}
		}
	}
	
	public int lowestDivisor(int value) {
		if((value % 2) == 0) {
			return 2;
		}
		
		for(int i = 3; (i * i) < value; i += 2) {
			if((value % i) == 0) {
				return i;
			}
		}
		
		return 1;
	}
}
