import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class CountingSheep {

	/* Beau Hottovy - bhottovy@hotmail.com - CodeJam Template */
	
	final static String OUT_DIR = "output/";
	final static String IN_DIR = "input/";
	
	final static String FILE_OUT = OUT_DIR + "Output.txt";;
	
	BufferedReader in;
	BufferedWriter out;
	
	public CountingSheep() {
		this.init();
	}
	
	public static void main(String args[]) {
		new CountingSheep();
	}
	
	public void init() {
		File inDir = new File(IN_DIR);
		File[] inputFiles = inDir.listFiles();
		
		File fileIn = null;
		
		if(inputFiles.length == 1) {
			fileIn = inputFiles[0];
		} else if(inputFiles.length < 1){
			System.out.println("File missing! Wrong folder?");
		} else {
			System.out.println("Too many files! Check input folder.");
		}
		
		if(fileIn == null) System.exit(0);
		FileReader fr = null;
		
		File fileOut = new File(FILE_OUT);
		FileWriter fw = null;
		
		try {
			fr = new FileReader(fileIn);
			this.in = new BufferedReader(fr);
			
			fw = new FileWriter(fileOut);
			this.out = new BufferedWriter(fw);
			
			this.run();
			
			this.in.close();
			this.out.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}

	
	public int getInt(String num) throws IOException {
		return Integer.parseInt(num);
	}
	
	public void out(String line) throws IOException {
		this.out.write(line);
	}
	
	public void outln(String line) throws IOException {
		this.out.write(line);
		this.out.newLine();
	}
	
	public void run() throws IOException {
		int numOfCases = this.getInt(in.readLine());
		
		int curCase = 0;
		
		while(curCase < numOfCases) {
			curCase++;
			out("Case #" + curCase + ": ");

			int N = this.getInt(in.readLine());
			
			int MAX_MULT = 200;
			
			int mult = 0;
			
			if(N != 0) {
				boolean[] seen = new boolean[10];
				boolean keepCounting = true;
				for(int i = 0; i < seen.length; i++) {
					seen[i] = false;
				}
				
				while(mult <= MAX_MULT && keepCounting) {
					mult++;
					
					int number = mult * N; 
					while(number > 0) {
						int digit = number % 10;
						number /= 10;
						
						if(seen[digit] == false) seen[digit] = true;
					}
					
					keepCounting = false;
					for(int i = 0; i < seen.length; i++) {
						if(seen[i] == false) keepCounting = true;
					}
					if(!keepCounting) {
						outln((mult * N) + "");
					}
				}
				
				if(keepCounting) outln("INSOMNIA");
				
			} else {
				outln("INSOMNIA");
			}
		};
	}
}
