import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class RevengeOfThePancakes {

	/* Beau Hottovy - bhottovy@hotmail.com - CodeJam Template */
	
	final static String OUT_DIR = "output/";
	final static String IN_DIR = "input/";
	
	final static String FILE_OUT = OUT_DIR + "Output.txt";;
	
	BufferedReader in;
	BufferedWriter out;
	
	public RevengeOfThePancakes() {
		this.init();
	}
	
	public static void main(String args[]) {
		new RevengeOfThePancakes();
	}
	
	public void init() {
		File inDir = new File(IN_DIR);
		File[] inputFiles = inDir.listFiles();
		
		File fileIn = null;
		
		if(inputFiles.length == 1) {
			fileIn = inputFiles[0];
		} else if(inputFiles.length < 1){
			System.out.println("File missing! Wrong folder?");
		} else {
			System.out.println("Too many files! Check input folder.");
		}
		
		if(fileIn == null) System.exit(0);
		FileReader fr = null;
		
		File fileOut = new File(FILE_OUT);
		FileWriter fw = null;
		
		try {
			fr = new FileReader(fileIn);
			this.in = new BufferedReader(fr);
			
			fw = new FileWriter(fileOut);
			this.out = new BufferedWriter(fw);
			
			this.run();
			
			this.in.close();
			this.out.close();
		} catch(IOException e) {
			e.printStackTrace();
		}
	}

	
	public int getInt(String num) throws IOException {
		return Integer.parseInt(num);
	}
	
	public void out(String line) throws IOException {
		this.out.write(line);
	}
	
	public void outln(String line) throws IOException {
		this.out.write(line);
		this.out.newLine();
	}
	
	public void run() throws IOException {
		int numOfCases = this.getInt(in.readLine());
		
		int curCase = 0;
		
		while(curCase < numOfCases) {
			curCase++;
			out("Case #" + curCase + ": ");

			final char HAPPY = '+';
			final char BLANK = '-';
			
			char[] pancakes = in.readLine().trim().toCharArray();
			
			int lowestBlank = -1;
			
			for(int i = 0; i < pancakes.length; i++) {
				if(pancakes[i] == BLANK) {
					lowestBlank = i;
				}
			}
			
			int flips = 0;
			
			while(lowestBlank >= 0) {
				char[] stack = new char[lowestBlank + 1];
				
				for(int i = 0; i < stack.length; i++) {
					stack[i] = pancakes[i];
				}
				
				for(int i = stack.length - 1; i >= 0; i--) {
					if(stack[i] == HAPPY) {
						pancakes[i] = BLANK;
					} else {
						pancakes[i] = HAPPY;
					}
				}
				
				boolean foundBlank = false;
				
				for(int i = 0; i < pancakes.length; i++) {
					if(pancakes[i] == BLANK) {
						lowestBlank = i;
						foundBlank = true;
					}
				}
				
				if(!foundBlank) lowestBlank = -1;
				
				flips++;
			}
			
			outln(flips + "");
		};
	}
}
