import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * @author Bicheng Cao
 */
public class TheKillerWord {
	
	static final int ALPHA_NUM = 26;
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileInputStream("input.txt"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("output.txt")));
		int tests = Integer.parseInt(in.nextLine());
		for (int t = 0; t < tests; t++) {
			int n = in.nextInt();
			int m = in.nextInt();
			in.nextLine();
			String[] d = new String[n];
			String[] l = new String[m];
			for (int i = 0; i < n; i++) {
				d[i] = in.nextLine();
			}
			for (int i = 0; i < m; i++) {
				l[i] = in.nextLine();
			}
			
			out.print("Case #" + (t + 1) + ":");
			int[][] value = new int[n][ALPHA_NUM + 1];
			for (int j = 0; j < n; j++) {
				value[j][0] = d[j].length();
				for (int k = 1; k <= ALPHA_NUM; k++) {
					value[j][k] = 0;
					char c = (char) ('a' + (k - 1));
					for (int p = 0; p < d[j].length(); p++) {
						int bit = 0;
						if (d[j].charAt(p) == c) {
							bit = 1;
						}
						value[j][k] = (value[j][k] << 1) + bit;
					}
				}
			}
			
			outer:
			for (int i = 0; i < m; i++) {
				String[] id = new String[n];
				int max = 0;
				String res = d[0];
				int[] point = new int[n];
				Map<String, Integer> count = new HashMap<String, Integer>();
				for (int j = 0; j < n; j++) {
					id[j] = String.format("%02d", value[j][0]);
					Integer v = count.get(id[j]);
					if (v == null) {
						count.put(id[j], 1);
					} else {
						count.put(id[j], v + 1);
					}
				}
				boolean found = false;
				for (int j = 0; j < n; j++) {
					if (count.get(id[j]) != 1) {
						found = true;
						point[j]++;
						if (point[j] > max) {
							max = point[j];
							res = d[j];
						}
					}
				}
				if (!found) {
					out.print(" " + res);
					continue outer;
				}
				for (int k = 0; k < ALPHA_NUM; k++) {
					int c = l[i].charAt(k) - 'a' + 1;
					found = false;
					for (int j = 0; j < n; j++) {
						if (count.get(id[j]) > 1 && value[j][c] != 0) {
							found = true;
							break;
						}
					}
					if (!found) {
						continue;
					}
					found = false;
					for (int j = 0; j < n; j++) {
						if (count.get(id[j]) != 1) {
							if (value[j][c] == 0) {
								point[j]++;
								if (point[j] > max) {
									max = point[j];
									res = d[j];
								}
							}
						}
					}
					for (int j = 0; j < n; j++) {
						id[j] += String.format("%04d", value[j][c]);
						Integer v = count.get(id[j]);
						if (v == null) {
							count.put(id[j], 1);
						} else {
							count.put(id[j], v + 1);
						}
					}
					for (int j = 0; j < n; j++) {
						if (count.get(id[j]) != 1) {
							found = true;
						}
					}
					if (!found) {
						out.print(" " + res);
						continue outer;
					}
				}
			}
			
			out.println();
		}
		in.close();
		out.close();
	}
}
