package com.bichengcao.googlecodejam.round1a2010;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class NumberGame {

	static int N;

	public static void main(String[] args) throws IOException {
		Input[] inputs = parseInput("src/com/bichengcao/googlecodejam/round1a2010/C-small-attempt0.in");
		Output[] outputs = process(inputs);
		writeOutput("src/com/bichengcao/googlecodejam/round1a2010/NumberGame.out", outputs);
	}

	static class Input {
		int a1, a2, b1, b2;
	}

	static class Output {
		long count;
	}
	
	private static Input[] parseInput(String filename) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(filename));
		N = Integer.parseInt(in.readLine());
		Input[] array = new Input[N];

		for (int i = 0; i < N; i++) {
			Input input = array[i] = new Input();
			String line = in.readLine();
			StringTokenizer st = new StringTokenizer(line);
			input.a1 = Integer.parseInt(st.nextToken());
			input.a2 = Integer.parseInt(st.nextToken());
			input.b1 = Integer.parseInt(st.nextToken());
			input.b2 = Integer.parseInt(st.nextToken());
		}

		in.close();
		return array;
	}

	private static Output[] process(Input[] inputs) {
		Output[] outputs = new Output[N];
		for (int i = 0; i < N; i++) {
			outputs[i] = process(inputs[i]);
		}
		return outputs;
	}

	private static Output process(Input input) {
		Output output = new Output();

		for (int a = input.a1; a <= input.a2; a++) {
			for (int b = input.b1; b <= input.b2; b++) {
				if (isWin(a, b)) {
					output.count++;
				}
			}
		}
		
		return output;
	}

	private static boolean isWin(int a, int b) {
		if (a == b) {
			return false;
		} else if (Math.min(a, b) == 1) {
			return true;
		}
		if (Math.abs(a - b) <= Math.min(a, b)) {
			return !isWin(Math.abs(a - b), Math.min(a, b));
		}
		return true;
//		int gcd = gcd(a, b);
//		if (Math.abs(a / gcd - b / gcd) <= 1) {
//			return false;
//		} else {
//			return true;
//		}
	}

	private static int gcd(int a, int b) {
		while (b != 0) {
			int t = a % b;
			a = b;
			b = t;
		}
		return a;
	}

	private static void writeOutput(String filename, Output[] outputs) throws IOException {
		PrintWriter out = new PrintWriter(new FileWriter(filename));
		for (int i = 0; i < N; i++) {
			Output output = outputs[i];
			out.println("Case #" + (i + 1) + ": " + output.count);
		}
		out.close();
	}

}
