import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Magicka. Qualification Round 2011, Problem B.
 * 
 * @author Bicheng Cao
 */
public class Magicka {
	
	static final int NUMBER_OF_ALPHABET = 26;
	static class Input {
		String[] combine;
		String[] opposed;
		String seq;
	}
	
	static class Output {
		String result;
	}
	
	public static void main(String[] args) throws IOException {
		Input[] inputs = getInputs();
		Output[] outputs = process(inputs);
		printOutputs(outputs);
	}
	
	private static Input[] getInputs() throws IOException {
		Scanner in = new Scanner(new FileInputStream("input.txt"));
		int t = in.nextInt();
		Input[] inputs = new Input[t];
		for (int i = 0; i < t; i++) {
			Input input = inputs[i] = new Input();
			int combines = in.nextInt();
			input.combine = new String[combines];
			for (int j = 0; j < combines; j++) {
				input.combine[j] = in.next();
			}
			int opposeds = in.nextInt();
			input.opposed = new String[opposeds];
			for (int j = 0; j < opposeds; j++) {
				input.opposed[j] = in.next();
			}
			int n = in.nextInt();
			input.seq = in.next();
			assert(input.seq.length() == n);
		}
		in.close();
		return inputs;
	}
	
	private static Output[] process(Input[] inputs) {
		Output[] outputs = new Output[inputs.length];
		for (int i = 0; i < inputs.length; i++) {
			outputs[i] = process(inputs[i]);
		}
		return outputs;
	}

	private static Output process(Input input) {
		Output output = new Output();
		char[][] combine = new char[NUMBER_OF_ALPHABET][NUMBER_OF_ALPHABET];
		for (int i = 0; i < input.combine.length; i++) {
			String s = input.combine[i];
			combine[s.charAt(0) - 'A'][s.charAt(1) - 'A'] = s.charAt(2);
			combine[s.charAt(1) - 'A'][s.charAt(0) - 'A'] = s.charAt(2);
		}
		boolean[][] opposed = new boolean[NUMBER_OF_ALPHABET][NUMBER_OF_ALPHABET];
		for (int i = 0; i < input.opposed.length; i++) {
			String s = input.opposed[i];
			opposed[s.charAt(0) - 'A'][s.charAt(1) - 'A'] = true;
			opposed[s.charAt(1) - 'A'][s.charAt(0) - 'A'] = true;
		}
		List<Character> sb = new ArrayList<Character>();
		for (int i = 0; i < input.seq.length(); i++) {
			char c = input.seq.charAt(i);
			if (sb.size() > 0) {
				char trans = combine[sb.get(sb.size() - 1) - 'A'][c - 'A'];
				if (trans > 0) {
					sb.set(sb.size() - 1, trans);
				} else {
					boolean clear = false;
					for (int j = 0; j < sb.size(); j++) {
						if (opposed[sb.get(j) - 'A'][c - 'A']) {
							clear = true;
							break;
						}
					}
					if (clear) {
						sb.clear();
					} else {
						sb.add(c);
					}
				}
			} else {
				sb.add(c);
			}
		}
		output.result = sb.toString();
		return output;
	}
	
	private static void printOutputs(Output[] outputs) throws IOException {
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("output.txt")));
		for (int i = 0; i < outputs.length; i++) {
			Output output = outputs[i];
			out.print("Case #" + (i + 1) + ": ");
			out.print(output.result);
			out.println();
		}
		out.close();
	}
}
