package com.bichengcao.googlecodejam.round1a2010;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class MakeItSmooth {

	static int N;

	public static void main(String[] args) throws IOException {
		Input[] inputs = parseInput("src/com/bichengcao/googlecodejam/round1a2010/B-small-attempt1.in");
		Output[] outputs = process(inputs);
		writeOutput("src/com/bichengcao/googlecodejam/round1a2010/MakeItSmooth.out", outputs);
	}

	static class Input {
		int d, i, m, n;
		int[] a;
	}

	static class Output {
		int cost;
	}
	
	private static Input[] parseInput(String filename) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(filename));
		N = Integer.parseInt(in.readLine());
		Input[] array = new Input[N];

		for (int i = 0; i < N; i++) {
			Input input = array[i] = new Input();
			String line = in.readLine();
			StringTokenizer st = new StringTokenizer(line);
			input.d = Integer.parseInt(st.nextToken());
			input.i = Integer.parseInt(st.nextToken());
			input.m = Integer.parseInt(st.nextToken());
			input.n = Integer.parseInt(st.nextToken());
			input.a = new int[input.n];
			st = new StringTokenizer(in.readLine());
			for (int j = 0; j < input.n; j++) {
				input.a[j] = Integer.parseInt(st.nextToken());
			}
		}

		in.close();
		return array;
	}

	private static Output[] process(Input[] inputs) {
		Output[] outputs = new Output[N];
		for (int i = 0; i < N; i++) {
			outputs[i] = process(inputs[i]);
		}
		return outputs;
	}

	private static Output process(Input input) {
		Output output = new Output();
		
		int[] dp = new int[256];
		for (int i = 0; i < 256; i++) {
			if (i <= input.m) {
				dp[i] = 0;
			} else if (input.m == 0) {
				dp[i] = dp[i - 1] + 1;
			} else if (i >= 2 * input.m) {
				dp[i] = Math.min(input.i + dp[i - input.m], i - input.m);
			} else {
				dp[i] = Math.min(input.i, i - input.m);
			}
		}
		
		if (input.n == 1) {
			return output;
		} else if (input.n == 2) {
			output.cost = input.d;
			int abs = Math.abs(input.a[0] - input.a[1]);
			output.cost = Math.min(output.cost, dp[abs]);
		} else {
			output.cost = 2 * input.d;
			int abs1 = Math.abs(input.a[0] - input.a[1]);
			int abs2 = Math.abs(input.a[0] - input.a[2]);
			int abs3 = Math.abs(input.a[1] - input.a[2]);
			int abs = Math.min(abs1, Math.min(abs2, abs3));
			output.cost = Math.min(output.cost, input.d + dp[abs]);
			output.cost = Math.min(output.cost, dp[abs1] + dp[abs3]);
			for (int i = 0; i < 256; i++) {
				abs1 = Math.abs(input.a[0] - i);
				abs3 = Math.abs(i - input.a[2]);
				output.cost = Math.min(output.cost, Math.abs(i - input.a[1]) + dp[abs1] + dp[abs3]);
			}
		}
		
		return output;
	}

	private static void writeOutput(String filename, Output[] outputs) throws IOException {
		PrintWriter out = new PrintWriter(new FileWriter(filename));
		for (int i = 0; i < N; i++) {
			Output output = outputs[i];
			out.println("Case #" + (i + 1) + ": " + output.cost);
		}
		out.close();
	}

}
