package com.bichengcao.googlecodejam.round1a2010;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class Rotate {

	static int N;

	public static void main(String[] args) throws IOException {
		Input[] inputs = parseInput("src/com/bichengcao/googlecodejam/round1a2010/A-large.in");
		Output[] outputs = process(inputs);
		writeOutput("src/com/bichengcao/googlecodejam/round1a2010/Rotate.out", outputs);
	}

	static class Input {
		int n;
		int k;
		char[][] board;
	}

	static class Output {
		boolean red;
		boolean blue;
	}
	
	private static Input[] parseInput(String filename) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader(filename));
		N = Integer.parseInt(in.readLine());
		Input[] array = new Input[N];

		for (int i = 0; i < N; i++) {
			Input input = array[i] = new Input();
			String line = in.readLine();
			StringTokenizer st = new StringTokenizer(line);
			input.n = Integer.parseInt(st.nextToken());
			input.k = Integer.parseInt(st.nextToken());
			input.board = new char[input.n][input.n];
			for (int j = 0; j < input.n; j++) {
				line = in.readLine();
				input.board[j] = line.toCharArray();
			}
		}

		in.close();
		return array;
	}

	private static Output[] process(Input[] inputs) {
		Output[] outputs = new Output[N];
		for (int i = 0; i < N; i++) {
			outputs[i] = process(inputs[i]);
		}
		return outputs;
	}

	private static Output process(Input input) {
		Output output = new Output();

		char[][] result = new char[input.n][input.n];
		for (int i = input.n - 1; i >= 0; i--) {
			int count = input.n - 1;
			for (int j = input.n - 1; j >= 0; j--) {
				if (input.board[i][j] != '.') {
					result[count--][input.n - 1 - i] = input.board[i][j];
				}
			}
		}
		
		output.red = joink(result, input.k, 'R');
		output.blue = joink(result, input.k, 'B');
		
		return output;
	}

	private static boolean joink(char[][] board, int k, char c) {
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board.length; j++) {
				boolean result = true;
				if (j + k <= board.length) {
					for (int a = j; a < j + k; a++) {
						if (board[i][a] != c) {
							result = false;
							break;
						}
					}
					if (result) {
						return true;
					}
				}
				result = true;
				if (i + k <= board.length) {
					for (int a = i; a < i + k; a++) {
						if (board[a][j] != c) {
							result = false;
							break;
						}
					}
					if (result) {
						return true;
					}
				}
				result = true;
				if (i + k <= board.length && j + k <= board.length) {
					for (int a = 0; a < k; a++) {
						if (board[i + a][j + a] != c) {
							result = false;
							break;
						}
					}
					if (result) {
						return true;
					}
				}
				result = true;
				if (i - k >= -1 && j + k <= board.length) {
					for (int a = 0; a < k; a++) {
						if (board[i - a][j + a] != c) {
							result = false;
							break;
						}
					}
					if (result) {
						return true;
					}
				}
			}
		}
		return false;
	}

	private static void writeOutput(String filename, Output[] outputs) throws IOException {
		PrintWriter out = new PrintWriter(new FileWriter(filename));
		for (int i = 0; i < N; i++) {
			Output output = outputs[i];
			out.print("Case #" + (i + 1) + ": ");
			if (output.red && output.blue) {
				out.println("Both");
			} else if (output.red && !output.blue) {
				out.println("Red");
			} else if (!output.red && output.blue) {
				out.println("Blue");
			} else if (!output.red && !output.blue) {
				out.println("Neither");
			}
		}
		out.close();
	}

}
