import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * @author Bicheng Cao
 */
public class C {
	
	static final String mapping = "-/|\\";
	static final int[][] dir = {{0, 1}, {1, -1}, {1, 0}, {1, 1},
		{0, -1}, {-1, 1}, {-1, 0}, {-1, -1}};
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileInputStream("input.txt"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("output.txt")));
		int tests = Integer.parseInt(in.nextLine());
		for (int t = 0; t < tests; t++) {
			int r = in.nextInt();
			int c = in.nextInt();
			in.nextLine();
			int[][] m = new int[r][c];
			for (int i = 0; i < r; i++) {
				String line = in.nextLine();
				for (int j = 0; j < c; j++) {
					m[i][j] = mapping.indexOf(line.charAt(j));
				}
			}
			int sum = 0;
			outer:
			for (int i = 0; i < (1 << (r * c)); i++) {
				boolean[][] visited = new boolean[r][c];
				for (int row = 0; row < r; row++) {
					for (int col = 0; col < c; col++) {
						int d = m[row][col];
						if ((i & (1 << (row * c + col))) > 0) {
							d += 4;
						}
						int nr = (row + dir[d][0] + r) % r;
						int nc = (col + dir[d][1] + c) % c;
						if (visited[nr][nc]) {
							continue outer;
						}
						visited[nr][nc] = true;
					}
				}
				sum++;
				sum %= 1000003;
			}
			out.print("Case #" + (t + 1) + ": ");
			out.println(sum);
		}
		in.close();
		out.close();
	}
}
