import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Bicheng Cao
 */
public class C {
	
	static final int MAX = 1000000;
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new FileInputStream("input.txt"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("output.txt")));
		
		boolean[] prime = new boolean[MAX + 1];
		Arrays.fill(prime, true);
		for (int i = 2; i <= MAX; i++) {
			if (prime[i]) {
				for (int j = i + i; j <= MAX; j += i) {
					prime[j] = false;
				}
			}
		}
		
		int tests = Integer.parseInt(in.nextLine());
		for (int t = 0; t < tests; t++) {
			long n = in.nextLong();
			long sum = 1;
			for (long i = 2; i * i <= n; i++) {
				if (prime[(int) i]) {
					long p = i * i;
					while (p <= n) {
						sum++;
						p *= i;
					}
				}
			}
			
			out.print("Case #" + (t + 1) + ": ");
			if (n == 1) {
				out.println(0);
			} else {
				out.println(sum);
			}
		}
		in.close();
		out.close();
	}
}
