import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Candy Splitting. Qualification Round 2011, Problem C.
 * 
 * @author Bicheng Cao
 */
public class CandySplitting {
	
	static class Input {
		int n;
		int[] candy;
	}
	
	static class Output {
		boolean possible;
		int result;
	}
	
	public static void main(String[] args) throws IOException {
		Input[] inputs = getInputs();
		Output[] outputs = process(inputs);
		printOutputs(outputs);
	}
	
	private static Input[] getInputs() throws IOException {
		Scanner in = new Scanner(new FileInputStream("input.txt"));
		int t = in.nextInt();
		Input[] inputs = new Input[t];
		for (int i = 0; i < t; i++) {
			Input input = inputs[i] = new Input();
			input.n = in.nextInt();
			input.candy = new int[input.n];
			for (int j = 0; j < input.n; j++) {
				input.candy[j] = in.nextInt();
			}
		}
		in.close();
		return inputs;
	}
	
	private static Output[] process(Input[] inputs) {
		Output[] outputs = new Output[inputs.length];
		for (int i = 0; i < inputs.length; i++) {
			outputs[i] = process(inputs[i]);
		}
		return outputs;
	}

	private static Output process(Input input) {
		Output output = new Output();
		int result = 0;
		int sum = 0;
		for (int i = 0; i < input.candy.length; i++) {
			result ^= input.candy[i];
			sum += input.candy[i];
		}
		if (result == 0) {
			output.possible = true;
			Arrays.sort(input.candy);
			output.result = sum - input.candy[0];
		}
		return output;
	}
	
	private static void printOutputs(Output[] outputs) throws IOException {
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("output.txt")));
		for (int i = 0; i < outputs.length; i++) {
			Output output = outputs[i];
			out.print("Case #" + (i + 1) + ": ");
			if (output.possible) {
				out.print(output.result);
			} else {
				out.print("NO");
			}
			out.println();
		}
		out.close();
	}
}
