package contest2014.magictrick;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class MagicTrick {
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));
		int caseCnt = sc.nextInt();
		for (int i = 0; i < caseCnt; i++) {
			int rowNum1 = sc.nextInt();
			int[][] square1 = readSquare(sc);
			int rowNum2 = sc.nextInt();
			int[][] square2 = readSquare(sc);
			pw.printf("Case #%d: ", i + 1);
			pw.println(getResult(rowNum1, square1, rowNum2, square2));
		}
		pw.flush();
		pw.close();
		sc.close();
	}

	private static String getResult(int rowNum1, int[][] square1, int rowNum2, int[][] square2) {
		int[] line1 = square1[rowNum1-1];
		int[] line2 = square2[rowNum2-1];
		Set<Integer> result = new HashSet<Integer>();
		for (int i = 0; i < line1.length; i++) {
			for (int j = 0; j < line2.length; j++) {
				if (line1[i] == line2[j]) {
					result.add(line1[i]);
				}
			}
		}
		if (result.isEmpty()) {
			return "Volunteer cheated!";
		}else if (result.size() == 1) {
			return new ArrayList<Integer>(result).get(0) + "";
		}else {
			return "Bad magician!";
		}
		
	}

	private static int[][] readSquare(Scanner sc) {
		int lineNum = 4;
		int rowNum = 4;
		int[][] result = new int[lineNum][rowNum];
		for (int i = 0; i < lineNum; i++) {
			for (int j = 0; j < rowNum; j++) {
				result[i][j] = sc.nextInt();
			}
		}
		return result;
	}

}
