package fairandsquare;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class FairSquare {
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));	
		int caseCnt = sc.nextInt();
		for (int i = 0; i < caseCnt; i++) {
			long[] caze = readCase(sc);
			pw.printf("Case #%d: ", i +1 );
			pw.println(count(caze));
		}
		pw.flush();
		pw.close();
		sc.close();
	}

	private static int count(long[] caze) {
		int i = 0;
		for (long j = caze[0]; j <= caze[1]; j++) {
			if (isPalindrome(j) && isSquare(j) && isPalindrome(square(j))) {
//				System.out.println(j);
				i++;
			}
		}
		return i;
	}

	private static long[] readCase(Scanner sc) {
		long[] caze = new long[2];
		caze[0] = sc.nextLong();
		caze[1] = sc.nextLong();
		return caze;
	}

	static boolean isPalindrome(long i) {
		long reversedNumber = 0;
		long temp = 0;
		long number = i;
		while (number > 0) {
			temp = number % 10;
			number = number / 10;
			reversedNumber = reversedNumber * 10 + temp;
		}
		return i == reversedNumber;
	}

	static boolean isSquare(long n){
		if (n < 0)
			return false;
		long tst = (long)(Math.sqrt(n) + 0.5);
		return tst*tst == n;
	}
	
	static long square(long n){
		return (long)(Math.sqrt(n) + 0.5);
	}


}
