package lawnmower;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class LawnmowerSmall {
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader("input.txt"));
		PrintWriter pw = new PrintWriter(new FileWriter("output.txt"));	
		int caseCnt = sc.nextInt();
		for (int i = 0; i < caseCnt; i++) {
			int[][] caze = readCase(sc);
			pw.printf("Case #%d: ", i +1 );
			pw.println(getName(tryIt(caze)));
		}
		pw.flush();
		pw.close();
		sc.close();
	}

	private static String getName(boolean tryIt) {
		return tryIt ? "YES" : "NO";
	}

	private static boolean tryIt(int[][] caze) {
		for (int i = 0; i < caze.length; i++) {
			for (int j = 0; j < caze[i].length; j++) {
				int[] line = getLine(caze, i);
				int[] row = getRow(caze, j);
				if (!isTheBigest(caze[i][j], line) && !isTheBigest(caze[i][j], row)) {
					return false;
				}
			}
		}
		return true;
	}

	private static int[][] readCase(Scanner sc) {
		int lineNum = sc.nextInt();
		int rowNum = sc.nextInt();
		int[][] result = new int[lineNum][rowNum];
		for (int i = 0; i < lineNum; i++) {
			for (int j = 0; j < rowNum; j++) {
				result[i][j] = sc.nextInt();
			}
		}
		return result;
	}
	
	private static int[] getLine(int[][] caze, int i){
		return caze[i];
	}
	
	private static int[] getRow(int[][] caze, int i) {
		int [] result = new int[caze.length];
		for (int j = 0; j < result.length; j++) {
			result[j] = caze[j][i];
		}
		return result;
	}
	
	private static boolean isTheBigest(int i, int[] array){
		for (int j = 0; j < array.length; j++) {
			if (array[j] > i) {
				return false;
			}
		}
		return true;
	}
}
