package codejam;

import java.util.HashMap;
import java.util.Map;

public class GooglereeseEnglishTranslator {

	private Map<Character, Character> googleToEnglish = new HashMap<Character, Character>();
	
	private static final String[] googlereese =
			new String[] {
			"ejp mysljylc kd kxveddknmc re jsicpdrysi",
			"rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd",
			"de kr kd eoya kw aej tysr re ujdr lkgc jv"
	};

	private static final String[] english =
			new String[] {
		"our language is impossible to understand",
		"there are twenty six factorial possibilities",
		"so it is okay if you want to just give up" };

	private void init()	{
		for ( int i=0; i<googlereese.length; i++ ) {
			String googLine = googlereese[i];
			String eLine = english[i];
			for ( int j = 0; j<googLine.length(); j++ ){
				googleToEnglish.put(googLine.charAt(j), eLine.charAt(j));
			}
		}
		googleToEnglish.put('z', 'q');
		googleToEnglish.put('q', 'z');
	}
	
	public GooglereeseEnglishTranslator() {
		init();
	}

	public String fromGooglereese( String googlereese ) {
		StringBuilder sb = new StringBuilder();
		for ( int i=0; i<googlereese.length(); i++ ){
			Character nextChar = googlereese.charAt(i);
			Character english = googleToEnglish.get(nextChar);
			if ( english == null ){
				sb.append( nextChar );
				System.out.println("Missing char : " + nextChar);
			}
			else {
				sb.append( english );
			}
		}
		return sb.toString();	
	}
}
