package round1b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

public class Round1b_a {
	private BufferedReader reader;
	private BufferedWriter writer;
	
	public boolean Load(){
		try{
			reader = new BufferedReader(new FileReader("A-large.in"));
			writer = new BufferedWriter(new FileWriter("A-large.out"));
		}
		catch(IOException ex){
			ex.printStackTrace();
			return false;
		}
		return true;
	}
	
	public double[] solvecase(int N){
		int[][] table = new int[N][N];
		double[] rpi = new double[N];
		double[] wp = new double[N];
		double[] owp = new double[N];
		double[] oowp = new double[N];
		try{
			for(int i  = 0; i < N; ++i)
			{
				String str = reader.readLine();
				int win = 0, all = 0;
				for(int j = 0; j < N; ++j)
				{
					if(str.charAt(j) == '.')
					{
						table[i][j] = -1;
					}
					else if(str.charAt(j) == '1'){
						table[i][j] = 1;
						++win;
						++all;
					}
					else{
						table[i][j] = 0;
						++all;
					}
				}
				wp[i] = (double)win / (double)all;
			}
			
			for(int i = 0; i < N; ++i){
				int cnt = 0;
				double sum = 0.0f;
				for(int j = 0; j < N; ++j){
					if(table[i][j] >= 0){
						int tmpwin = 0, tmpall = 0;
						for(int k = 0; k < N; ++k){
							if(k == i)
								continue;
							if(table[j][k] == 0){
								tmpall++;
							}
							else if(table[j][k] == 1){
								tmpwin++;
								tmpall++;
							}
						}
						++cnt;
						sum += (double)tmpwin / (double) tmpall;
					}
				}
				owp[i] = sum / cnt;
			}
			
			for(int i = 0; i < N; ++i){
				int cnt = 0;
				double sum = 0.0f;
				for(int j = 0; j < N; ++j){
					if(table[i][j] >= 0){
						++cnt;
						sum += owp[j];
					}
				}
				oowp[i] = sum / cnt;
				
				rpi[i] = 0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
			}
		}
		catch(IOException ex){
			ex.printStackTrace();
		}
		
		
		
		return rpi;
	}
	
	public void solve(){
		try{
			Load();
			int T = Integer.parseInt(reader.readLine());
			for(int i = 0; i < T; ++i){
				int N = Integer.parseInt(reader.readLine());
				double[] ret = solvecase(N);
				
				String s = String.format("Case #%d:\n", i + 1);
				for(int j = 0; j < N; ++j){
					String tmp = String.format("%f\n", ret[j]);
					s += tmp;
				}
				
				System.out.println(s);
				writer.write(s);
				writer.flush();
			}
		}
		catch(IOException ex)		{
			ex.printStackTrace();
		}	
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Round1b_a p = new Round1b_a();
		p.solve();
		//System.out.println(c.solvecase(4, "2 1 4 3"));
	}

}
