import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;


public class Rotate {
	static class TestCase {
		int n,k;
		char[][] table;
		void init(Scanner s) {
			n = s.nextInt();
			k = s.nextInt();
			s.nextLine();
			table = readchars(s, n, n);
		}
		
		void work(PrintWriter p) {
			char[][] newtable = new char[n][n];
			
			for(int i=0;i<n;i++) Arrays.fill(newtable[i], '.');
			int[] height = new int[n];
			
			for(int i=0;i<n;i++) {
				for(int j=n-1;j>=0;j--) {
					if(table[i][j] != '.') newtable[n-1-height[n-1-i]++][n-1-i] = table[i][j];					
				}
			}
			
			boolean r = false;
			boolean b = false;
			// rows
			for(int i=0;i<n;i++) {
				boolean r1 = checkjoin(newtable[i],'R',k);				
				boolean b1 = checkjoin(newtable[i],'B',k);
				if(r1) r = true;
				if(b1) b= true;
				if(r && b) break;
			}
			
			char[][] columns = new char[n][n];
			if(!(r && b)) {
				// columns
				for(int i=0;i<n;i++) {
					for(int j=0;j<n;j++) {
						columns[i][j] = newtable[j][i];
					}
					boolean r1=checkjoin(columns[i],'R',k);
					boolean b1=checkjoin(columns[i],'B',k);				
					if(r1) r = true;
					if(b1) b = true;
					if(r && b) break;
				}
			}
			
			char[][] diagonals = new char[n][n];
			if(!(r&&b)) {
				// left diagonal
				for(int i=0;i<n;i++) Arrays.fill(diagonals[i], '.');
				for(int i=0;i<n;i++) {
					int rw = i;
					int cl = 0;
					for(int j=0;j<n && rw>=0 && cl <n;j++) {						
						diagonals[i][j] = newtable[rw--][cl++];						
					}
					boolean r1=checkjoin(diagonals[i],'R',k);
					boolean b1=checkjoin(diagonals[i],'B',k);				
					if(r1) r = true;
					if(b1) b = true;
					if(r && b) break;
				}
			}
			if(!(r&&b)) {
				// left diagonal
				for(int i=0;i<n;i++) Arrays.fill(diagonals[i], '.');
				for(int i=1;i<n;i++) {
					int rw = n-1;
					int cl = i;
					for(int j=0;j<n && rw>=0 && cl <n;j++) {						
						diagonals[i][j] = newtable[rw--][cl++];						
					}
					boolean r1=checkjoin(diagonals[i],'R',k);
					boolean b1=checkjoin(diagonals[i],'B',k);				
					if(r1) r = true;
					if(b1) b = true;
					if(r && b) break;
				}
			}
			if(!(r&&b)) {
				for(int i=0;i<n;i++) Arrays.fill(diagonals[i], '.');
				// right diagonal
				for(int i=0;i<n;i++) {
					int rw = i;
					int cl = n-1;
					for(int j=0;j<n && rw>=0 && cl >=0;j++) {						
						diagonals[i][j] = newtable[rw--][cl--];						
					}
					boolean r1=checkjoin(diagonals[i],'R',k);
					boolean b1=checkjoin(diagonals[i],'B',k);				
					if(r1) r = true;
					if(b1) b = true;
					if(r && b) break;
				}
			}
			if(!(r&&b)) {
				for(int i=0;i<n;i++) Arrays.fill(diagonals[i], '.');
				// right diagonal
				for(int i=n-2;i>=0;i--) {
					int rw = n-1;
					int cl = i;
					for(int j=0;j<n && rw>=0 && cl >=0;j++) {						
						diagonals[i][j] = newtable[rw--][cl--];						
					}
					boolean r1=checkjoin(diagonals[i],'R',k);
					boolean b1=checkjoin(diagonals[i],'B',k);				
					if(r1) r = true;
					if(b1) b = true;
					if(r && b) break;
				}
			}
			p.print( r&&b ? "Both" : (r? "Red" : (b?"Blue":"Neither")));
			
		}
		
		boolean checkjoin(char[] row, char piece, int k) {
			for(int i=0;i<row.length;i++) {
				if(row[i]==piece) {
					int join = 1;
					for(i++;i<row.length;i++) {
						if(row[i] == piece) {
							join++;
						} else break;
					}
					if(join >= k) return true;
				}
			}
			return false;
		}
	}	
	
	
	public static char[][] readchars(Scanner s, int m, int n) {
		char[][] mt = new char[m][n];		
		for(int i=0;i<m;i++) {
			String line = s.nextLine();
			line.getChars(0, line.length(), mt[i], 0);
		}
		return mt;
	}
	
	public static void main(String[] argv) throws Exception {
		if(argv.length < 1) { so("argument required: <input file name>"); System.exit(1); }
		String in = argv[0];
		String out = argv[0].substring(0,argv[0].lastIndexOf('.')) + ".out";
		Scanner s = new Scanner(new FileInputStream(in));
		PrintWriter p = new PrintWriter(new FileOutputStream(out));
		int n = s.nextInt(); s.nextLine();
		TestCase test = new TestCase();
		for(int i=1;i<=n;i++) {
			p.print("Case #" + i + ": ");
			test.init(s);
			test.work(p);
			p.println();
		}
		s.close();
		p.close();
	}
	
	static void so(Object... os) {
		for(Object o: os) { 
			System.out.print(o);
			System.out.print(' ');
		}
		System.out.println();
	}
	
}
