import java.io.*;
import java.util.ArrayList;

public class Mindsweeper {
	public static char[][] solveMindsweeper(int R, int C, int M) {
		char[][] grid = null;

		if (R == 1 || C == 1 || R*C-M == 1) {
			grid = new char[R][C];
			int mines = M;
			for (int i=0; i<R; i++) {
				for (int j=0; j<C; j++) {
					if (mines > 0) {
						grid[i][j] = '*';
						mines--;
					}
					else {
						grid[i][j] = '.';
					}
				}
			}
			grid[R-1][C-1] = 'c';
			
		}
		else {
			if ((R*C - M) <= 3) {
				return grid;
			}
			else {
				grid = new char[R][C];
				for (int i=0; i<R; i++) {
					for (int j=0; j<C; j++) {
						grid[i][j] = '.';
					}
				}
			
				int r = 0;
				int c = 0;
				int mines = M;
				while (mines > 0) {
//					System.out.println(R + "," + C + "," + r + "," + c +"\n");
					grid[r][c] = '*';
					mines--;
					c++;
					if (r >= R - 2) {
						if (c >= C-2) {
							r++;
							c = 0;
						}
					}
					else {
						if (c >= C) {
							r++;
							c = 0;
						}
					}
				}
				
				grid[R-1][C-1] = 'c';
			}
		}
		return grid;
	}
	
	
	public static void main(String args[] ) throws Exception {
		String filename = "P3/C-small-attempt3.in";
		String outfilename = "P3/p3out_small.txt";
		
    	BufferedReader br = new BufferedReader(new FileReader(filename));
		String line = br.readLine();
		int numTests = Integer.valueOf(line);
		ArrayList<String> results = new ArrayList<String>();
		
		int R, C, M;
		char[][] grid;

		for (int i=0; i<numTests; i++) {

			line = br.readLine();
			String[] tokens = line.split(" ");
			
			R = Integer.valueOf(tokens[0]);
			C = Integer.valueOf(tokens[1]);
			M = Integer.valueOf(tokens[2]);
			
			grid = solveMindsweeper(R, C, M);
			
			String output = "Case #" + (i+1) + ":\n";
			if (grid == null) {
				output += "Impossible";
			}
			else {
				for (int r=0; r<grid.length; r++) {
					String row = new String(grid[r]);
					output += row;
					if (r != grid.length - 1) {
						output += "\n";
					}
				}
			}
			
			results.add(output);
			
		}
		
		br.close();
		
		Writer writer = null;
		try {
		    writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfilename), "utf-8"));
		    for (String str : results) {
		    	writer.write(str+"\n");
		    }
		} catch (IOException ex) {
		  // report
		} finally {
		   try {writer.close();} catch (Exception ex) {}
		}
	}
}


