import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map.Entry;


public class Magic {

	public static String solveMagic(int testId, ArrayList<Integer> row1, ArrayList<Integer> row2) {
		String output = "Case #" + testId + ": ";
		int count = 0;
		int magicNumber = -1;
		for (int i:row2 ) {
			if (row1.contains(i)) {
				if (count == 0) {
					magicNumber = i;
				}
				count++;
			}
		}
		
		if (count == 0) {
			output += "Volunteer cheated!";
		}
		else if (count == 1) {
			output += magicNumber;
		}
		else {
			output += "Bad magician!";
		}
		
		return output;
	}
	
	
	public static void main(String args[] ) throws Exception {
		String filename = "P1/A-small-attempt0.in";
		String outfilename = "P1/p1out.txt";
		
    	BufferedReader br = new BufferedReader(new FileReader(filename));
		String line = br.readLine();
		int numTests = Integer.valueOf(line);
		ArrayList<String> results = new ArrayList<String>();

		for (int i=0; i<numTests; i++) {
			ArrayList<Integer> row1 = new ArrayList<Integer>();
			ArrayList<Integer> row2 = new ArrayList<Integer>();
			int rowNumber;
			
			//read the first arrangement
			line = br.readLine();
			rowNumber = Integer.valueOf(line);
			for (int r=1; r<rowNumber; r++) {
				br.readLine();
			}
			line = br.readLine();
			String[] tokens = line.split(" ");
			for (int j=0; j<tokens.length; j++) {
				row1.add(Integer.valueOf(tokens[j]));
			}
			for (int r=rowNumber; r<4; r++) {
				br.readLine();
			}
			
			//read the second arrangement
			line = br.readLine();
			rowNumber = Integer.valueOf(line);
			for (int r=1; r<rowNumber; r++) {
				br.readLine();
			}
			line = br.readLine();
			tokens = line.split(" ");
			for (int j=0; j<tokens.length; j++) {
				row2.add(Integer.valueOf(tokens[j]));
			}
			for (int r=rowNumber; r<4; r++) {
				br.readLine();
			}
			
			String output = solveMagic(i+1, row1, row2);
			results.add(output);
			
		}
		
		br.close();
		
		Writer writer = null;
		try {
		    writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfilename), "utf-8"));
		    for (String str : results) {
		    	writer.write(str+"\n");
		    }
		} catch (IOException ex) {
		  // report
		} finally {
		   try {writer.close();} catch (Exception ex) {}
		}
	}
}
