import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class War {
	
	public static int solveWar(ArrayList<Double> NaomiNumbers, ArrayList<Double> KenNumbers) {
		
		ArrayList<Double> sortedNaomi = NaomiNumbers;
		Collections.sort(sortedNaomi);
		
		ArrayList<Double> sortedKen = KenNumbers;
		Collections.sort(sortedKen);
		
		int kenIdx = 0;
		int score = 0;
		
		for (int i=0; i<NaomiNumbers.size(); i++) {
			while (kenIdx < KenNumbers.size() && sortedKen.get(kenIdx) < sortedNaomi.get(i)) {
				kenIdx++;
				if (kenIdx >= KenNumbers.size()) {
					score = NaomiNumbers.size() - i;
					return score;
				}
				
			}
			kenIdx++;
			if (kenIdx >= KenNumbers.size()) {
				score = NaomiNumbers.size() - (i+1);
				return score;
			}
		}
		
		return 0;
	}
	
	
	public static int solveDecWar(ArrayList<Double> NaomiNumbers, ArrayList<Double> KenNumbers) {
		
		ArrayList<Double> sortedNaomi = NaomiNumbers;
		Collections.sort(sortedNaomi);
		
		ArrayList<Double> sortedKen = KenNumbers;
		Collections.sort(sortedKen);
		
		int kenIdx = KenNumbers.size() - 1;
		int score = 0;
		for (int i=NaomiNumbers.size()-1; i>=0; i--) {
			while (sortedKen.get(kenIdx) > sortedNaomi.get(i)) {
				kenIdx--;
				if (kenIdx < 0) {
					return score;
				}
			} 
			kenIdx--;
			score++;
			if (kenIdx < 0) {
				return score;
			}
		}
				
		return score;
	}
	
	
	public static void main(String args[] ) throws Exception {
		String filename = "P4/D-small-attempt1.in";
		String outfilename = "P4/p4out_small.txt";
		
    	BufferedReader br = new BufferedReader(new FileReader(filename));
		String line = br.readLine();
		int numTests = Integer.valueOf(line);
		ArrayList<String> results = new ArrayList<String>();
		

		for (int i=0; i<numTests; i++) {
			//read number of weights
			line = br.readLine();
			
			ArrayList<Double> NaomiNumbers = new ArrayList<Double>();
			ArrayList<Double> KenNumbers = new ArrayList<Double>();

			line = br.readLine();
			String[] tokens = line.split(" ");
			
			for (String s:tokens) {
				NaomiNumbers.add(Double.valueOf(s));
			}
			
			line = br.readLine();
			tokens = line.split(" ");
			
			for (String s:tokens) {
				KenNumbers.add(Double.valueOf(s));
			}
			
			int dWarScore = solveDecWar(NaomiNumbers, KenNumbers);
			int warScore = solveWar(NaomiNumbers, KenNumbers);
			
			String output = "Case #" + (i+1) + ": " + dWarScore + " " +warScore;

			results.add(output);
			
		}
		
		br.close();
		
		Writer writer = null;
		try {
		    writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfilename), "utf-8"));
		    for (String str : results) {
		    	writer.write(str+"\n");
		    }
		} catch (IOException ex) {
		  // report
		} finally {
		   try {writer.close();} catch (Exception ex) {}
		}
	}
}


