import java.io.*;
import java.util.ArrayList;

public class Cookie {
	final static double P = 2.0; //2 cookies per second
	public static double solveCookie(double C, double F, double X) {
		double best = 0.0;
		
		int n = 0;
		while (X/(n*F + P) >= C/(n*F + P) + X/((n+1)*F + P)) {
			n++;
		}
		
		for (int i=0; i<n; i++) {
			best += C/(i*F + P);
		}
		best += X/(n*F + P);
		return best;
	}
	
	
	public static void main(String args[] ) throws Exception {
		String filename = "P2/B-large.in";
		String outfilename = "P2/p2out_large.txt";
		
    	BufferedReader br = new BufferedReader(new FileReader(filename));
		String line = br.readLine();
		int numTests = Integer.valueOf(line);
		ArrayList<String> results = new ArrayList<String>();
		
		double C, F, X, best;

		for (int i=0; i<numTests; i++) {

			line = br.readLine();
			String[] tokens = line.split(" ");
			
			C = Double.valueOf(tokens[0]);
			F = Double.valueOf(tokens[1]);
			X = Double.valueOf(tokens[2]);
			
			best = solveCookie(C, F, X);
			
			String output = "Case #" + (i+1) + ": " + String.format("%.7f", best);

			results.add(output);
			
		}
		
		br.close();
		
		Writer writer = null;
		try {
		    writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outfilename), "utf-8"));
		    for (String str : results) {
		    	writer.write(str+"\n");
		    }
		} catch (IOException ex) {
		  // report
		} finally {
		   try {writer.close();} catch (Exception ex) {}
		}
	}
}

