import java.util.*;
import java.io.*;
import java.math.*;

public class C_1
{
	public static void main(String [] args) throws Exception
	{
		Scanner inScan = new Scanner(System.in);
		System.out.println("Enter the filename");
		String filename = inScan.nextLine();
		BufferedReader b = new BufferedReader(new FileReader(filename));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("out.txt")));

		int numExamples = Integer.parseInt(b.readLine());
		
		for(int i = 0; i < numExamples; i++)
		{
			int numKids = Integer.parseInt(b.readLine());
			int [] verts = new int[numKids];
			String [] line = b.readLine().split(" ");
			for(int j = 0; j < numKids; j++)
			{
				verts[j] = Integer.parseInt(line[j])-1;
			}
			Graph g = new Graph(verts);
			int max = -1;
			while(true)
			{
				int length = g.findCycle();
				if(length > max)
					max = length;
				if(length==-1)
					break;
			}
			out.println("Case #" + (i+1) + ": " + max);
		}
		out.flush();
		
		out.close();
	}
	private static class Graph
	{
		int numVerts;
		Node [] list;
		ArrayList<Integer> used;
		public Graph(int [] verts)
		{
			numVerts = verts.length;
			list = new Node[numVerts];
			for(int i = 0; i <verts.length;i++)
			{
				Node curr = new Node(i);
				list[i] = curr;
			}
			for(int i = 0; i < verts.length;i++)
			{
				
				list[i].next = list[verts[i]];
				list[verts[i]].previous.add(list[i]);
				
			}
			used = new ArrayList<Integer>();
			for(int i = 0; i < numVerts;i++)
				used.add(i);
			
		}
		public int findCycle()
		{
			if(used.size()==0)
				return -1;
			ArrayList<Node> circle = new ArrayList<Node>();
			Node curr = list[used.get(0)];
			circle.add(curr);
			while(true)
			{
				if(!circle.contains(curr.next) && (!circle.contains(curr.next.next) || circle.get(0)==curr.next.next || circle.get(circle.size()-1)==curr.next.next))
				{
					curr = curr.next;
					circle.add(curr);
				}
				else break;
				//forward-backward
			}
			while(true)
			{
				boolean found = false;
				Node curr2 = circle.get(circle.size()-1);
				A:for(Node x: curr2.previous)
				{
					if (!circle.contains(x))
					{
						found = true;
						circle.add(x);
						curr2 = x;
						break A;
					}
				}
				if(!found)
				break;
			}
			while(true)
			{
				boolean found = false;
				Node curr2 = circle.get(0);
				A:for(Node x: curr2.previous)
				{
					if (!circle.contains(x) )
					{
						
						found = true;
						circle.add(x);
						curr2 = x;
						break A;
					}
				}
				if(!found)
					break;
			}
			used.remove(0);
			System.out.println(circle);
			return circle.size();
		}
	}
	private static class Node
	{
		public Node next;
		public ArrayList<Node> previous;
		public int id;
		public Node(int x)
		{
			id = x;
			previous = new ArrayList<Node>();
		}
		public String toString()
		{
			return Integer.toString(id);
		}
	}
}