import java.util.*;
import java.io.*;
import java.math.*;

public class pancake_stack
{
	public static void main(String [] args) throws Exception
	{
		Scanner inScan = new Scanner(System.in);
		System.out.println("Enter the filename");
		String filename = inScan.nextLine();
		BufferedReader b = new BufferedReader(new FileReader(filename));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("out.txt")));

		int numExamples = Integer.parseInt(b.readLine());
		for(int i = 0; i < numExamples; i++)
		{
			String[] line = b.readLine().split(" ");
			int N = Integer.parseInt(line[0]);
			int K = Integer.parseInt(line[1]);
			Comparator<Pair> comp = new PairComparator();
			PriorityQueue<Pair> queue = new PriorityQueue<Pair>(N,comp);
			ArrayList<Pair> radii = new ArrayList<Pair>();
			for(int j = 0; j < N; j++)
			{
				line = b.readLine().split(" ");
				int R_i = Integer.parseInt(line[0]);
				int H_i = Integer.parseInt(line[1]);
				Pair curr = new Pair(R_i,H_i);
				radii.add(curr);
				queue.add(curr);
			}
			
			Collections.sort(radii,new PairComparator());
			System.out.println(radii);
			while(queue.size()!=0)
				System.out.println(queue.remove());
			out.print("Case #" + (i+1) + ": "  + getArea(queue,K,radii));
			if(i != numExamples-1)
				out.println();
			out.flush();
		}
		
		out.close();
	}
	
	public static double getArea(PriorityQueue<Pair> queue, int K, ArrayList<Pair> radii)
	{
		double [][] mat = new double[K+1][radii.size()+1];
		double max = 0;
		for(int i = 1; i < K+1;i++)
		{
			for(int j = 1; j < radii.size()+1;j++)
			{
				double temp = 0;
				if(mat[i-1][j-1] ==0)
					temp = radii.get(j-1).area() + radii.get(j-1).height();
				else
					temp = mat[i-1][j-1] + radii.get(j-1).height();
				if(temp > mat[i][j-1])
					mat[i][j] = temp;
				else
					mat[i][j] = mat[i][j-1];
			}
		}
		int i = K;
		for(int j = 0; j < radii.size()+1;j++)
		{
			if(mat[i][j] > max)
				max = mat[i][j];
		}
		//Matrix[i,j] = area of pancake stack with i pancakes and rad[j] radius on top
		//prune tree if no pancake can fit on top and size < K
		//if two subsets have same K and r on top, pick the one with the largest area
		return max;
	}
	
}


