package me.billhsu;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.PriorityQueue;
import java.util.Scanner;

public class BathroomStalls {

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            long n = in.nextLong();
            long k = in.nextLong();
            PriorityQueue<Range> queue = new PriorityQueue<>((Range a, Range b) -> {
                long l1 = a.end - a.start;
                long l2 = b.end - b.start;
                if (l1 == l2) {
                    return a.start > b.start ? 1 : -1;
                } else {
                    return l1 > l2 ? -1 : 1;
                }
            });
            queue.add(new Range(0, n - 1));
            long ls = 0;
            long rs = 0;
            while (!queue.isEmpty() && k > 0) {
                Range range = queue.poll();

                long mid = range.start + (range.end - range.start) / 2;
                ls = mid - range.start;
                rs = range.end - mid;
                if (mid - 1 >= range.start) {
                    queue.offer(new Range(range.start, mid - 1));
                }
                if (mid + 1 <= range.end) {
                    queue.offer(new Range(mid + 1, range.end));
                }
                k--;
            }

            printResult(i, Math.max(ls, rs), Math.min(ls, rs));
        }
    }

    private static class Range {
        long start;
        long end;

        public Range(long start, long end) {
            this.start = start;
            this.end = end;
        }
    }

    private static void printResult(int i, long y, long z) {
        System.out.println("Case #" + i + ": " + y + " " + z + "");
    }
}
