package me.billhsu;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.*;

/**
 * Created by shipeng on 15/4/17.
 */
public class Ratatouille {
    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            final int N = in.nextInt();
            final int P = in.nextInt();
            final int[] Ri = new int[N];
            for (int a = 0; a < N; ++a) {
                Ri[a] = in.nextInt();
            }
            final int[][] Qij = new int[N][P];
            boolean[][] used = new boolean[N][P];
            for (int a = 0; a < N; ++a) {
                for (int b = 0; b < P; ++b) {
                    Qij[a][b] = in.nextInt();
                }
                Arrays.sort(Qij[a]);
            }
            int result = 0;
            for (int col = 0; col < P; ++col) {
                TreeSet<Integer> validPacks = new TreeSet<>();
                for (int pack = 1; pack <= 10000000; ++pack) {
                    int validMin = (int) ((Ri[0] * pack) * 0.9);
                    int validMax = (int) ((Ri[0] * pack) * 1.1);
                    if (Qij[0][col] >= validMin && Qij[0][col] <= validMax) {
                        validPacks.add(pack);
                    }
                }
                HashMap<Integer, List<Position>> map = new HashMap<>();
                for (int row = 1; row < N; ++row) {
                    if (validPacks.size() == 0) {
                        break;
                    }
                    Set<Integer> notValidPacks = new HashSet<>();

                    for (int valid : validPacks) {
                        int validMin = (int) ((Ri[row] * valid) * 0.9);
                        int validMax = (int) ((Ri[row] * valid) * 1.1);
                        boolean found = false;
                        for (int a = 0; a < P; ++a) {
                            if (used[row][a]) {
                                continue;
                            }
                            if (Qij[row][a] >= validMin && Qij[row][a] <= validMax) {
                                found = true;
                                List<Position> positions = map.getOrDefault(valid, new ArrayList<>());
                                positions.add(new Position(row, a));
                                break;
                            }
                        }
                        if (!found) {
                            notValidPacks.add(valid);
                        }
                    }
                    for (int notValid : notValidPacks) {
                        validPacks.remove(notValid);
                    }
                }
                if (validPacks.size() > 0) {
                    result++;
                    for (Position position : map.getOrDefault(validPacks.first(), new ArrayList<>())) {
                        used[position.col][position.row] = true;
                    }
                }
            }
            System.out.println("Case #" + i + ": " + result);
        }
    }

    private static class Position {
        int row;
        int col;

        public Position(int row, int col) {
            this.row = row;
            this.col = col;
        }
    }
}
