import java.io.FileInputStream;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

public class C {
	static boolean conflict[][];
	static int numColors;
	
	static boolean DEBUG = false;

	public static void main(String args[]) throws Exception {
		Scanner in = new Scanner(args.length == 0 ? System.in
				: new FileInputStream(args[0]));
		int T = in.nextInt();
		input: for (int t = 1; t <= T; t++) {
			int N = in.nextInt();
			int K = in.nextInt();
			if (DEBUG) System.out.printf("%d %d\n", N, K);
			int price[][] = new int[N][K];
			for (int n = 0; n < N; n++)
				for (int k = 0; k < K; k++)
					price[n][k] = in.nextInt();
			conflict = new boolean[N][N];
			for (int n1 = 0; n1 < N; n1++)
				for (int n2 = n1 + 1; n2 < N; n2++) {
					conflict[n1][n2] = conflict[n2][n1] = conflict(price[n1],
							price[n2]);
					if (DEBUG && conflict[n1][n2])
						System.out.printf("%d %d conflict\n", n1, n2);
				}

			chooseNumColors: for (int numColors = 1; numColors < N; numColors++) {
				if (numColors > N)
					throw new IllegalStateException();
				HashSet<Integer> allColors = new HashSet<Integer>();
				for (int c = 1; c <= numColors; c++)
					allColors.add(c);
				int color[] = new int[N];
				color[0] = 1;
				int needColors = N - 1;
				while (needColors > 0) {
					if (DEBUG) System.out.printf("%d: %s\n", numColors, Arrays
							.toString(color));
					boolean changed = false;
					for (int n = 1; n < N; n++)
						if (color[n] == 0) {
							HashSet<Integer> allowed = new HashSet<Integer>(
									allColors);
							int uncoloredN = 0;
							int nei = 0;
							for (int n2 = 0; n2 < N; n2++) if  (conflict[n][n2] && color[n2] >= -1) {
								nei++;
								if (color[n2] > 0)
									allowed.remove(color[n2]);
								else if (color[n2] == 0)
									uncoloredN++;
							}
							if (nei <= numColors-1) {
								if (DEBUG)
									System.out.println(n);
								color[n] = -2; // can fill in later with any color
								changed = true;
								needColors--;
							} else if (uncoloredN < allowed.size()) {
								color[n] = -1; // can fill in later with any color
								changed = true;
								needColors--;
							}
//							System.out.printf("Allowed for %d: %s\n", n,
//									allowed);
							if (allowed.isEmpty())
								continue chooseNumColors;
							if (allowed.size() == 1) {
								color[n] = allowed.iterator().next();
								// System.out.printf("set  %d: %s\n" , n,
								// color[n]);
								changed = true;
								needColors--;
							}
						}
					if (!changed && needColors > 0) {
						// pick one
						if (DEBUG) 
							System.out.println("huh");
						continue chooseNumColors;
					}
						
				}
				System.out.printf("Case #%d: %s\n", t, numColors);
				continue input;

			}
			System.out.printf("Case #%d: %s\n", t, N);

		}
	}

	private static boolean conflict(int[] is, int[] is2) {
		for (int i = 0; i < is.length - 1; i++) {
			if (is[i] == is2[i])
				return true;
			if (is[i] < is2[i] && is[i + 1] >= is2[i + 1])
				return true;
			if (is[i] > is2[i] && is[i + 1] <= is2[i + 1])
				return true;
		}
		return false;

	}

}
