import java.io.FileInputStream;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;


public class Tree {
	
	double weight;
	String feature;
	Tree have, notHave;
	
	double compute(Set<String> attrs) {
		if (feature == null)
			return weight;
		if (attrs.contains(feature))
			return weight * have.compute(attrs);
		else
			return weight * notHave.compute(attrs);
	}
	Tree(Scanner scanner) {
		try {
		scanner.skip("[\\n (]+");
		
		String w = scanner.next("[0-9.)]+");
		boolean done = w.endsWith(")");
		if (done)
			w = w.substring(0, w.length()-1);
			
		weight = Double.parseDouble(w);
		if (done)
			return;
		String token = scanner.next();
		if (token.equals(")")) {
			//leaf
		} else {
			feature = token;
			have = new Tree(scanner);
			notHave = new Tree(scanner);
			
			token = scanner.next();
			assert token.equals(")");
			
			
		}
		} catch (Exception e) {
			System.out.println("Oops: " + scanner.nextLine());
		}
	}
	
	public String toString() {
		if (feature == null)
			return String.format("(%s)", weight);
		else 
	return String.format("(%s %s\n %s\n %s\n)", weight, feature, have, notHave);
	}
		
	public static void main(String args[]) throws Exception {
		Scanner scanner = new Scanner(args.length == 0 ? System.in
				: new FileInputStream(args[0]));
		int num = scanner.nextInt();
		for(int x = 1; x <= num; x++) {
			System.out.printf("Case #%d:\n", x);
			int L = scanner.nextInt();
			Tree tree = new Tree(scanner);
			int A = scanner.nextInt();
			for(int a = 0; a < A; a++) {
				String name = scanner.next();
				int attributes = scanner.nextInt();
				HashSet<String> attrs = new HashSet<String>();
				for(int i = 0; i < attributes; i++)
					attrs.add(scanner.next());
				System.out.printf("%9.7f\n", tree.compute(attrs));
			}
		}
	
	}

}
