import java.lang.Math;

public class Bathroom {

	int people;
	int stalls;
	String sMaxMin;
	Stall[] stallArray;
	int stallToChoose;
	int chosenLeft;
	int chosenRight;
	int counter;
	boolean foundNext;
	boolean foundOpen;
	
	//I know this is not the most efficient way to do this
	//it goes left to right, rather than starting in the middle of big spaces
	//I didn't quite know how to do it from the middle
	//basically, this checks every stall each time
	//instead of figuring out where the best stalls will always be
	//without checking everything
	
	public Bathroom(int n, int k) {
		stalls = n;
		people = k;
		stallArray = new Stall[stalls + 2];
		setUpStallArray();
	}
	
	private void setUpStallArray() {
		for(int i=0; i < stalls+2; i++){
			Stall s = new Stall(i, stalls);
			stallArray[i] = s;
		}
	}
	
	public String evaluate(){
		for(int i = 0; i < people; i++){
			setSpaces();
			pickStall();
		}
		return sMaxMin;
	}

	private void setSpaces(){
		for(int i = 1; i < stalls; i++){
			if(stallArray[i].inUse == false){
				stallArray[i].spaceToLeft = countLeft(i);
				stallArray[i].spaceToRight = countRight(i);
				stallArray[i].smallerSpace = Math.min(stallArray[i].spaceToLeft, stallArray[i].spaceToRight);
				stallArray[i].largerSpace = Math.max(stallArray[i].spaceToLeft, stallArray[i].spaceToRight);
			}
		}
	}
	
	private int countLeft(int i){
		counter = 0;
		foundNext = false;
		for(int j = i-1; foundNext == false; j--){
			if(stallArray[j].inUse == false){
				counter++;
			}
			else{
				foundNext = true;
			}
		}
		return counter;
	}
	
	private int countRight(int i){
		counter = 0;
		foundNext = false;
		for(int j = i+1; foundNext == false; j++){
			if(stallArray[j].inUse == false){
				counter++;
			}
			else{
				foundNext = true;
			}
		}
		return counter;
	}
	
	private void pickStall(){		
		stallToChoose = findFirstOpen();
		for(int i = stallToChoose; i < stalls; i++){
			if(stallArray[i].inUse == false){
				if(stallArray[i].smallerSpace > stallArray[stallToChoose].smallerSpace){
					stallToChoose = i;
				}
				else if (stallArray[i].smallerSpace == stallArray[stallToChoose].smallerSpace 
						&& stallArray[i].largerSpace > stallArray[stallToChoose].largerSpace){
					stallToChoose = i;
				}
			}
		}
		stallArray[stallToChoose].inUse = true; 
		sMaxMin = stallArray[stallToChoose].largerSpace + " " + stallArray[stallToChoose].smallerSpace;
	}

	private int findFirstOpen() {
		foundOpen = false;
		for(int i = 1; foundOpen == false; i++){
			if(stallArray[i].inUse == false){
				foundOpen = true;
				return i;
			}
		}
		return 0;//this should never get reached for the parameters of this
	}
	

	
}
