
public class TestCase {
	int r;
	int c;
	int m;
	char[][] board;
	int blanks;
	int mineCount;
	boolean impossible;
	
	public TestCase(int rows, int cols, int mines){
		r = rows;
		c = cols;
		m = mines;
		mineCount = m;
		blanks = (r*c) - m;
		board = new char[r][c];
	}
	
	public void evaluateCase() {
		
		//output board configuration whereby you can win in one click
		//fill it in around the edge until you get to the center?
		//if there are >= 9 squares left over (r*c-m>=9, build around it
		//if there are between 9 and 6
		
		if (m == 0){
			noMines();
		}
		
		else if (blanks == 1){
			oneSpot();
		}
		
		else if (r == 1 || c == 1){
			widthOne();
		}
		
		else if (r == 2 || c == 2){
			widthTwo();
		}
		
		else if (((blanks/r > 1) && (blanks % r == 0)) || 
				((blanks/c > 1) && (blanks % c == 0))){
			divisibleWidth();
		}
		
		else{
			tryOther();
		}
		
	}

	private void noMines() {
		for (int i = 0; i < r; i++){
			for (int k = 0; k < c; k++){
				board[i][k] = '.';
			}
		}
		
		board[0][0] = 'c';
		printBoard();
		// TODO Auto-generated method stub

	}

	private void oneSpot() {
		for (int i = 0; i < r; i++){
			for (int k = 0; k < c; k++){
				board[i][k] = '*';
			}
		}
		
		board[0][0] = 'c';
		printBoard();
		
	}
	
	private void widthOne() {//builds a one-click board with length 1
		//note, we know there has to be more than one spot
		if (r == 1){
			for (int i = 0; i < c; i++){
				if (i < m){
					board[0][i] = '*';
				}
				
				else if (i < (m + (blanks-1))){
					//the minus 1 is because we need a click
					board[0][i] = '.';
				}
				
				else{
					board[0][i] = 'c';
				}
			}
		}
		
		else{
			for (int i = 0; i < r; i++){
				if (i < m){
					board[i][0] = '*';
				}
				
				else if (i < (m + (blanks-1))){
					//the minus 1 is because we need a click
					board[i][0] = '.';
				}
				
				else{
					board[i][0] = 'c';
				}
			}
		}
		printBoard();
	}
	
	private void widthTwo() {
		if (blanks % 2 == 0 && blanks/2 >1){
			if (c == 2){
				for (int i = 0; i < r; i++){
					for (int k = 0; k < c; k++){
						if (mineCount > 0){
							board[i][k] = '*';
							mineCount--;
						}
						else{
							board[i][k] = '.';
						}
					}
				}
			}
			else{
				for (int i = 0; i < c; i++){//for each row
					for (int k = 0; k < r; k++){//fill the row
						if (mineCount > 0){
							board[k][i] = '*';
							mineCount--;
						}
						else{
							board[k][i] = '.';
						}
					}
				}
			}
			board[r-1][c-1] = 'c';
			printBoard();
		}
		else{
			System.out.println("Impossible");
		}
		
	}

	private void divisibleWidth(){
		if ((blanks % r == 0) && (c > ((blanks/r)+1))){
			for (int i = 0; i < c; i++){
				if (i < (blanks/r)){
					for (int k = 0; k < r; k++){
						board[k][i] = '.';
					}
				}
				else{
					for (int k = 0; k < r; k++){
						board[k][i] = '*';
					}
				}
			}
		}
		
		else{
			for (int i = 0; i < r; i++){
				if (i< (blanks/c)){
					for (int k = 0; k < c; k++){
						board[i][k] = '.';
					}
				}
				else{
					for (int k = 0; k < c; k++){
						board[i][k] = '*';
					}
				}
			}
		}
		board[0][0] = 'c';
		printBoard();
	}
	
	private void tryOther() {
		impossible = false;
		if (c > r){//more columns, so load rows first
			for (int i = 0; i < r ; i++){
				for (int k = 0; k < c; k++){
					//fill in all but last two rows
					if ((mineCount >= 1) && (r-i > 2)){//fill in row-wise
						board[i][k] = '*';
						mineCount--;
					}
					//once all but two rows are filled
					//fill in column-wise as long as we have more than one mine
					else if ((mineCount > 1)){
						//fills in each column, 2 at a time
						for (int n = 0; (c - n > 2); n++){
							if (mineCount >= 2){
								board[r-2][n] = '*';
								mineCount--;
								board[r-1][n] = '*';
								mineCount--;
							}
							
						}
						if (mineCount > 0){
							impossible = true;
						}
					}
					
					//what to do if we're left with only one mine
					//and still several rows
					else if ((mineCount == 1) && (c-k > 2)){
						board[i][0] = '*';
						mineCount--;//success!!
					}
					
					else if (mineCount > 0){
						impossible = true;
					}
					
					else if (mineCount == 0 && board[i][k] != '*'){
						board[i][k] = '.';
					}
				}
			}
		}//end building columns bigger
		
		else{//more rows, so load column-wise first
			for (int i = 0; i < c ; i++){
				for (int k = 0; k < r; k++){
					if ((mineCount > 1) && (c-i > 2)){//fill in column-wise
						board[k][i] = '*';
						mineCount--;
					}
					//once all but two columns are filled
					//fill in row-wise as long as we have more than one mine
					else if ((mineCount > 1)){
						//fills in each row, 2 at a time
						for (int n = 0; (r - n > 2); n++){
							if (mineCount > 1){
								board[n][c-2] = '*';
								mineCount--;
								board[n][c-1] = '*';
								mineCount--;
							}
						//if after filling rows 2 at a time
						//we have one left, we're screwed
						}
						if (mineCount > 0){
							impossible = true;
						}
					}

					//what to do if we're left with only one mine
					//and still several rows
					else if ((mineCount == 1) && (r-i > 2)){
						board[0][i] = '*';
						board[k][i] = '.';
						mineCount--;//success!!
					}
					
					else if (mineCount > 0){
						impossible = true;
					}
					
					else if (mineCount == 0 && board[k][i] != '*'){
						board[k][i] = '.';
					}
				}
			}
		}//end building rows bigger
		
		if (impossible == true){
			System.out.println("Impossible");
		}
		
		else{
			board[r-1][c-1] = 'c';
			printBoard();
		}
		
		// TODO Auto-generated method stub
		// load from board[r-1][c-1]
		// go across the longer dimension
		// if placing the last mine leaves a row/column
		// unfinished by exactly one, it's impossible, otherwise it will work
		
	}
	
	public void printBoard(){
		for (int i = 0; i< board.length; i++){
			for (int k = 0; k < board[i].length; k++){
				if (k == (board[i].length - 1)){
					System.out.println(board[i][k]);
				}
				else{
					System.out.print(board[i][k]);
				}
				
			}
		}
	}

}
