import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;
import java.io.PrintWriter;

public class Counted {

	int totalCases;
	Scanner input;
	String[] caseArray;
	char[] charDigitsArray;
	int[] digitsArray;
	int priorDigit;
	int presentDigit;
	PrintWriter writer = new PrintWriter("TidyNumber.out");

	public Counted(File inputFile) throws FileNotFoundException {
		input = new Scanner(inputFile);
		totalCases = input.nextInt();
		input.nextLine();
		buildCaseArray();
		
	}
	
	private void buildCaseArray() {//loads array with each case
		caseArray = new String[totalCases];
		for(int i = 0; i < totalCases; i++){
			caseArray[i] = input.nextLine();
		}
	}
	
	public void evaluate() {//evaluates the cases in the caseArray
		//writes highest tidy for each case
		for(int i = 0; i < totalCases; i++){
			writer.println("Case #" + (i+1) + ": " + 
					findHighestTidy(caseArray[i]));
		}
		writer.close();
	}
	
	private long findHighestTidy(String t){
		//starts from last number counted, goes backwards
		//stops at first tidy number
		for(long i = Long.parseLong(t); i > 0; i--){
			if(checkIfTidy(i)){
				return i;
			}
		}
		return 1;//this condition should never be reached
	}
	
	private boolean checkIfTidy (long t){
		//takes an integer and checks if it's tidy
		//first we need to make an array of each digit
		makeDigitsArray(Long.toString(t));
		for (int i = 0; i < digitsArray.length-1; i++){
			if(digitsArray[i] > digitsArray [i+1]){
				return false;
			}
		}
		//this checks each digit. If a digit is greater than it next digit
		//then the number is not tidy. If we get to the end and no untidiness
		//then the number is tidy
		return true;
	}
	
	private void makeDigitsArray (String t){
		charDigitsArray = new char[t.length()];
		digitsArray = new int[t.length()];
		charDigitsArray = t.toCharArray();
		for(int i = 0; i < t.length(); i++){
			digitsArray[i] = Character.digit(charDigitsArray[i],10);
		}
	}
}
