
public class TestCase {

	int n;
	int digitCounter;
	int iterations;
	int seenDigitSum;
	Boolean insomnia;
	Boolean allDigits;
	int digitsInNumber;
	int digit;
	int tally;
	int tallyTest;
	
	public TestCase (int start) {//variables may pass through from task
		n = start;
		digitCounter = 0;
		seenDigitSum = 0;
		allDigits = false;
		insomnia = false;
		tally = 0;
	}
	
	public int evaluateCase() {
		//if its 0, insomnia
		//if its anything else, iterate the counting process
		//returns n*the number of iterations (to get last number counted)
		if(n == 0){//to account for insomnia
			return 0;
		}
		else{//this assumes, at this stage, insomnia only occurs if n=0
			for(iterations = 1; digitCounter < 10; iterations++){
				checkDigits(n*iterations);
			}
			//reach this code once digitCounter is 10
			return (iterations-1)*n;//end of the loop will increment iterations
		}
	}

	private void checkDigits(int numToCheck) {
		digitsInNumber = getNumberOfDigits(numToCheck);
		for (int i = 0; i < digitsInNumber; i++){
			digit = getDigit(i, numToCheck);
			if (seenDigit(digit) == false){
				digitCounter++;
				tally += (int) Math.pow(2, digit); 
				//ultimately tally and digitCounter are the same thing
				//we've hit everything when we hit 1023 on tally
				//keeping it for now while i'm tinkering
			}
		}//do this for each digit in numToCheck
	}

	private int getNumberOfDigits(int numToCheck) {
		double d = numToCheck * 1.0;
		return (int) (Math.log10(d) - (Math.log10(d) % 1)) + 1;
	}

	private int getDigit(int j, int numToCheck) {
		return ((numToCheck / (int) Math.pow(10, j)) % 10);
		//divide so digit you're checking is last digit before decimal
		//i started at 0 in checkDigits
		//mod 10 to isolate the digit you care about
	}
	
	private Boolean seenDigit (int dig){
		tallyTest = tally;
		//takes our tally of 2^each digit seen
		//then starts from 9, if we've seen 9, tally will be >+ 2^9.
		//if we haven't, cool
		//if we have, subtract 2^9, and if the result is 2^8
		//then we've seen 8, and so on
		//e.g., 768 is greater than 512, so we know we've seen 9
		//subtract out 512, we get 256 =2^8, so we know we's seen 2^8 too

		for (int k = 9; k >= dig; k--){
			if (tallyTest >= (int) Math.pow(2, k)){
				if (k == dig){
					return true;
				}
				else{
					tallyTest -= (int) Math.pow(2, k);
				}
			}
		}
		//reach this code only once we've subtracted out the digits we've seen
		return false;
			//accounts for seeing it in evaluateCase()
	}
}
