import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;

public class war
{
  public static void main(String args[]) throws Exception
  { 
    BufferedReader input = null;
    PrintWriter output = null;
    String currentLine;
    int noOfTests, noOfItems;
    ArrayList<Double> naomi,ken;
    int[] result;
    try
    {
      if(args.length != 2)
        throw new IllegalArgumentException
          ("2 arguents must be given: input file and output file.");

      input = new BufferedReader(new FileReader(args[0]));
      output = new PrintWriter(new FileWriter(args[1]));

      if((currentLine=input.readLine())!=null)
        noOfTests = Integer.parseInt(currentLine);
      else
        throw new IOException("Cannot get the number of tests.");

      for(int i=1;i<noOfTests+1;i++)
      {
        System.out.println("Dealing Case"+i);
        if((currentLine=input.readLine())!=null)
        {
          noOfItems = Integer.parseInt(currentLine);
        }
        else
          throw new IOException("Cannot get the number of items");
        
        naomi = new ArrayList<Double>();
        ken = new ArrayList<Double>();
        
        if((currentLine=input.readLine())!=null)
        {
          String[] dataString = currentLine.split(" ");
          for(int j=0;j<noOfItems;j++)
          {
            naomi.add(Double.parseDouble(dataString[j]));
          }
        }
        else
          throw new IOException("Cannot get the items of naomi");

        if((currentLine=input.readLine())!=null)
        {
          String[] dataString = currentLine.split(" ");
          for(int j=0;j<noOfItems;j++)
          {
            ken.add(Double.parseDouble(dataString[j]));
          }
        }
        else
          throw new IOException("Cannot get the items of ken");
       
        result = openFire(naomi, ken);
        output.println("Case #"+i+": "+ result[0]+" "+result[1]);  
      }
    }
    catch (Exception e)
    {
      System.err.println(e);
    }
    finally
    {
      try
      {
        input.close();
        output.close();
      }
      catch (Exception e)
      {
        System.err.println(e);
      }
    }
  }

  private static int[] openFire(ArrayList<Double> naomi, ArrayList<Double> ken)
  {
    Collections.sort(ken);
    int real = realWar(naomi, ken);
    Collections.sort(naomi);
    int deceitful = deceitfulWar(naomi, ken);
    return new int[]{deceitful,real};
  }

  private static int realWar(ArrayList<Double> n, ArrayList<Double> k)
  {
    ArrayList<Double> naomi = (ArrayList<Double>)n.clone();
    ArrayList<Double> ken = (ArrayList<Double>)k.clone();
    int score=0;

    double naomiItem, kenItem;
    do
    {
      naomiItem = naomi.remove(0);
      int begin=0;
      int end=ken.size()-1;
      while(end-begin>1)
      {
        if(naomiItem>ken.get((begin+end)/2))
        {
          begin=(begin+end)/2;
        }
        else
        {
          end=(begin+end)/2;
        }
      }
      if(naomiItem>=ken.get(end))
        kenItem=ken.remove(0);
      else if(naomiItem>=ken.get(begin))
        kenItem=ken.remove(end);
      else
        kenItem=ken.remove(begin);

      if(naomiItem>kenItem)
        score++;
    } while(naomi.size()>0);

    return score;
  }

  private static int deceitfulWar(ArrayList<Double> n, ArrayList<Double> k)
  {
    ArrayList<Double> naomi = (ArrayList<Double>)n.clone();
    ArrayList<Double> ken = (ArrayList<Double>)k.clone();
    int score=0;

    do
    {
      if(ken.get(0)>=naomi.get(0))
      {
        naomi.remove(0);
        ken.remove(ken.size()-1);
      }
      else
      {
        naomi.remove(0);
        ken.remove(0);
        score++;
      }
    } while(naomi.size()>0);

    return score;
  }
}
