import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
public class Lottery
{
  public static void main(String args[]) throws Exception
  { 
    BufferedReader input = null;
    PrintWriter output = null;
    String currentLine;
    int noOfTests, A, B, K;
    String result;
    try
    {
      if(args.length != 2)
        throw new IllegalArgumentException
          ("2 arguents must be given: input file and output file.");

      input = new BufferedReader(new FileReader(args[0]));
      output = new PrintWriter(new FileWriter(args[1]));

      if((currentLine=input.readLine())!=null)
        noOfTests = Integer.parseInt(currentLine);
      else
        throw new IOException("Cannot get the number of tests.");

      for(int i=1;i<noOfTests+1;i++)
      {
        System.out.println("Dealing Case"+i);
        String[] row;
        if((currentLine=input.readLine())!=null)
        {
          row=currentLine.split(" ");
          A=Integer.parseInt(row[0]);
          B=Integer.parseInt(row[1]);
          K=Integer.parseInt(row[2]);
        }
        else
          throw new IOException("Cannot get data");

        result = win(A,B,K);
        output.println("Case #" + i + ": " + result);  
      }
    }
    catch (Exception e)
    {
      System.err.println(e);
    }
    finally
    {
      try
      {
        input.close();
        output.close();
      }
      catch (Exception e)
      {
        System.err.println(e);
      }
    }
  }

  private static String win(int A,int B,int K)
  {
    int noOfWins=0;
    for(int i=0;i<A;i++)
      for(int j=0;j<B;j++)
      {
        if((i&j)<K)
          noOfWins++;
      }
    return Integer.toString(noOfWins);
  }
}
