import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
public class cookie
{
  public static void main(String args[]) throws Exception
  { 
    BufferedReader input = null;
    PrintWriter output = null;
    String currentLine;
    int noOfTests;
    double farmCost, farmProduction, win, result;
    try
    {
      if(args.length != 2)
        throw new IllegalArgumentException
          ("2 arguents must be given: input file and output file.");

      input = new BufferedReader(new FileReader(args[0]));
      output = new PrintWriter(new FileWriter(args[1]));

      if((currentLine=input.readLine())!=null)
        noOfTests = Integer.parseInt(currentLine);
      else
        throw new IOException("Cannot get the number of tests.");

      for(int i=1;i<noOfTests+1;i++)
      {
        System.out.println("Dealing Case"+i);
        if((currentLine=input.readLine())!=null)
        {
          String[] dataString = currentLine.split(" ");
          farmCost = Double.parseDouble(dataString[0]);
          farmProduction = Double.parseDouble(dataString[1]);
          win = Double.parseDouble(dataString[2]);
        }
        else
          throw new IOException("Cannot get data");

        result = click(farmCost, farmProduction, win);
        output.printf("Case #%d: %.7f\n", i, result);  
      }
    }
    catch (Exception e)
    {
      System.err.println(e);
    }
    finally
    {
      try
      {
        input.close();
        output.close();
      }
      catch (Exception e)
      {
        System.err.println(e);
      }
    }
  }

  private static double click(double farmCost, double farmProduction, double win)
  {
    double noFarmTime, farmTime;
    double totalTime=0.0;
    double production=2.0;
    do
    {
      noFarmTime = win/production;
      farmTime = farmCost/production + win/(production+farmProduction);
      if(noFarmTime>farmTime)
      {
        totalTime+=farmCost/production;
        production+=farmProduction;
      }
    } while(noFarmTime>farmTime);

    return totalTime+win/production;
  }
}
