
class OversizedPancakeFlipper {
    public String run(String pancakes, int size) {
        if (isPancakesOk(pancakes)) return "0";
        if (size == 0) return "IMPOSSIBLE";
        if (size == 1) return String.valueOf(pancakes.replace("+", "").length());

        char[] chars = pancakes.toCharArray();
        int operations = 0;
        for (int i = 0; i <= chars.length - size; ++i) {
            if (chars[i] == '-') {
                chars = flipPancakes(chars, i, size);
                operations++;
            }
        }

        if (!isPancakesOk(new String(chars)))
            operations = -1;

        return (operations == -1) ? "IMPOSSIBLE" : String.valueOf(operations);
    }

    private boolean isPancakesOk(String pancakes) {
        return pancakes.indexOf('-') == -1;
    }
//
//    private String flipPancakes(String pancakes, int startIndex, int sizeToFlip) {
//        char[] chars = pancakes.toCharArray();
//        while (sizeToFlip > 0) {
//            if (chars[startIndex + sizeToFlip - 1] == '-')
//                chars[startIndex + sizeToFlip - 1] = '+';
//            else
//                chars[startIndex + sizeToFlip - 1] = '-';
//            sizeToFlip--;
//        }
//        return new String(chars);
//    }

    private char[] flipPancakes(char[] pancakes, int startIndex, int sizeToFlip) {
        while (sizeToFlip > 0) {
            if (pancakes[startIndex + sizeToFlip - 1] == '-')
                pancakes[startIndex + sizeToFlip - 1] = '+';
            else
                pancakes[startIndex + sizeToFlip - 1] = '-';
            sizeToFlip--;
        }
        return pancakes;
    }
}