import java.util.ArrayList;
import java.util.List;

class BathroomStalls {
    public String run(int stallsNb, int peopleNb) {
        if (stallsNb == peopleNb) return "0 0";
        if (peopleNb == 1) {
            if (stallsNb % 2 == 0)
                return String.valueOf(stallsNb / 2) + " " + String.valueOf(stallsNb / 2 - 1);
            else
                return String.valueOf(stallsNb / 2) + " " + String.valueOf(stallsNb / 2);
        }

        List<int[]> stalls = new ArrayList<int[]>(stallsNb);
        for (int i = 0; i < stallsNb; ++i) {
            stalls.add(new int[]{i, stallsNb - i - 1});
        }

        for (int i = 0; i < peopleNb; ++i) {
            int tmpIndex = findBestStall(stalls);

            int[] tmpStall = stalls.get(tmpIndex);

            changeLeftStalls(stalls, tmpIndex, tmpStall[0]);
            changeRightStalls(stalls, tmpIndex, tmpStall[1]);

            if (i == peopleNb - 1)
                return String.valueOf(Math.max(tmpStall[0], tmpStall[1])) + " " + String.valueOf(Math.min(tmpStall[0], tmpStall[1]));
            tmpStall[0] = -1;
            tmpStall[1] = -1;
        }

        return "";
    }

    private int findBestStall(List<int[]> stalls) {
        List<int[]> result = new ArrayList<int[]>();
        int min = 0;
        int max = 0;

        for (int i = 0; i < stalls.size(); ++i) {
            min = Math.min(stalls.get(i)[0], stalls.get(i)[1]);
            max = Math.max(stalls.get(i)[0], stalls.get(i)[1]);
            if (result.isEmpty() || min == result.get(0)[1]) {
                result.add(new int[]{i, min, max});
            } else if (min > result.get(0)[1]) {
                result.clear();
                result.add(new int[]{i, min, max});
            }
        }

        int t = 0;
        max = -1;
        for (int i = 0; i < result.size(); ++i) {
            if (max < result.get(i)[2]) {
                max = result.get(i)[2];
                t = i;
            }
        }

        return result.get(t)[0];
    }

    private void changeLeftStalls(List<int[]> stalls, int startIndex, int size) {
        for (int i = startIndex - 1; i >= startIndex - size; --i)
            stalls.get(i)[1] = startIndex - i - 1;
    }

    private void changeRightStalls(List<int[]> stalls, int startIndex, int size) {
        for (int i = startIndex + 1; i <= startIndex + size; ++i)
            stalls.get(i)[0] = i - startIndex - 1;
    }
}