import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;


public class P2
{
	public static void main(String[] args) throws IOException
	{
		String fileIn = "B-large.in";
		pw = new PrintWriter(fileIn.replace(".in", ".out"));
		BufferedReader br = new BufferedReader(new FileReader(new File(fileIn)));
		int numCases = Integer.parseInt(br.readLine().trim());
		for (int cNum=1;cNum<=numCases;cNum++)
		{
			String dimStr = br.readLine();
			int[] dims = parseIntsFromString(dimStr);
			Square[][] grid = new Square[dims[1]][dims[0]];

			for (int y=0;y<dims[0];y++)
			{
				int[] vals = parseIntsFromString(br.readLine());
				for (int x=0;x<dims[1];x++)
				{
					grid[x][y] = new Square(x,y ,vals[x]);
				}
			}

			//caluclate flows
			for (int y=0;y<dims[0];y++)
			{
				for (int x=0;x<dims[1];x++)
				{
					Square s = grid[x][y];
					Square best = s;
					int[] dy = new int[]{-1, 0,  0, 1};
					int[] dx = new int[]{0 , -1, 1, 0};
					for (int a=0;a<4;a++)
					{
						int mx = x+dx[a];
						int my = y+dy[a];
						if (mx >= 0 && mx < dims[1] && my >= 0 && my < dims[0] &&
								grid[mx][my].val < best.val)
						{
							best = grid[mx][my];
						}
					}
					if (best == s)
						best = null;
					s.setFlowsTo(best);
				}
			}
			
			println("Case #" + cNum + ":");
			HashMap<Square, Character> sinkMap = new HashMap<Square, Character>();
			int curLettercode = (int)'a';
			for (int y=0;y<dims[0];y++)
			{
				for (int x=0;x<dims[1];x++)
				{
					Square s = grid[x][y];
					Square ssink = s.getSink();
					if (sinkMap.containsKey(ssink) == false)
					{
						sinkMap.put(ssink, (char)curLettercode++);
					}
					
					print(sinkMap.get(ssink) + ((x < dims[1]-1)?" ":""));
				}
				println("");
			}
			
		}
	}
	
	
	public static PrintWriter pw;
	
	public static void println(String s)
	{
		System.out.println(s);
		pw.println(s);
		pw.flush();
	}
	public static void print(String s)
	{
		System.out.print(s);
		pw.print(s);
		pw.flush();
	}
	
	public static int[] parseIntsFromString(String s)
	{
		ArrayList<Integer> al = new ArrayList<Integer>();
		String[] splitStr = s.split(" ");
		for (int a=0;a<splitStr.length;a++)
		{
			try
			{
				al.add(Integer.parseInt(splitStr[a].trim()));
			}
			catch (Exception nfe)
			{
				
			}
		}
		int[] ret = new int[al.size()];
		int a = 0;
		for (int i : al)
		{
			ret[a++] = i;
		}
		return ret;
	}
}


class Square
{
	int x, y, val;
	Square flowsTo;
	
	public Square(int x, int y, int val)
	{
		this.x = x;
		this.y = y;
		this.val = val;
	}
	
	public void setFlowsTo(Square ft)
	{
		flowsTo = ft;
	}
	
	
	public Square getSink()
	{
		Square start = this;
		while (start.flowsTo != null)
		{
			start = start.flowsTo;
		}
		return start;
	}
	
	public int hashCode()
	{
		return x *1117 + y;
	}
}
