import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;


public class B
{

	/**
	 * @param args
	 * @throws Exception 
	 */
	public  static int TA;
	public static void main(String[] args) throws Exception
	{
		BufferedReader br = new BufferedReader(new FileReader("B-large.in"));
		int cases = Integer.parseInt(br.readLine());
		for (int cc=0;cc<cases;cc++)
		{
			TA = Integer.parseInt(br.readLine());
			String nextLine = br.readLine();
			int aTrips = Integer.parseInt(nextLine.split(" ")[0]);
			int bTrips = Integer.parseInt(nextLine.split(" ")[1]);
			
			int[][] aTripsArr = new int[aTrips][2];
			int[][] bTripsArr = new int[bTrips][2];
			for (int a=0;a<aTrips;a++)
			{
				aTripsArr[a] = parseTimePair(br.readLine());
			}
			for (int a=0;a<bTrips;a++)
			{
				bTripsArr[a] = parseTimePair(br.readLine());
			}
						
			TrainStation ATS = new TrainStation();
			TrainStation BTS = new TrainStation();
			ArrayList<Train> trains = new ArrayList<Train>();
			for (int time=0;time<24*60;time++)
			{
				//simulate trains
				for (int a=0;a<trains.size();a++)
				{
					trains.get(a).sim(time);
				}
				//check schedules
				for (int a=0;a<aTripsArr.length;a++)
				{
					if (aTripsArr[a][0] == time)
					{
						//departure at station A.
						Train t = ATS.makeDeparture(time, aTripsArr[a][1], BTS);
						if (t != null)
						{
							trains.add(t);
						}
					}
				}
				for (int a=0;a<bTripsArr.length;a++)
				{
					if (bTripsArr[a][0] == time)
					{
						//departure at station B.
						Train t = BTS.makeDeparture(time, bTripsArr[a][1], ATS);
						if (t != null)
						{
							trains.add(t);
						}
					}
				}
			}
			
			
			
			
			System.out.println("Case #" + (cc+1) + ": " + ATS.numTrainsNeeded
					+ " "  + BTS.numTrainsNeeded);
		}
	}
	
	static class TrainStation
	{
		public int numTrainsNeeded = 0;
		ArrayList<Train> trainsReady = new ArrayList<Train>();
		public void notifyTrainReady(Train t)
		{
			trainsReady.add(t);
		}
		
		public Train makeDeparture(int start, int end, TrainStation otherStation)
		{
			Train t;
			boolean nt = false;
			if (trainsReady.size() == 0)
			{
				t = new Train();
				nt = true;
				numTrainsNeeded++;
			}
			else
			{
				t = trainsReady.remove(trainsReady.size()-1);
			}
			t.setOff(otherStation, end);
			
			
			
			if (nt)
				return t;
			else
				return null;
		}
		
	}
	
	static class Train
	{
		public static final int TRAVELING = 0;
		public static final int WAITING = 2;
		int state = WAITING;		
		
		TrainStation stationAt;
		int finalDestTime;
		
		public void sim(int timeStamp)
		{
			if (state == TRAVELING)
			{
				if (timeStamp >= finalDestTime)
				{
					state = WAITING;
					stationAt.notifyTrainReady(this);
					
				}
			}
		}
		
		public void setOff(TrainStation otherStation, int destTS)
		{
			stationAt = otherStation;
			finalDestTime = destTS + B.TA;
			state = TRAVELING;
		}
	}
	
	public static int[] parseTimePair(String line)
	{
		String dep = line.split(" ")[0];
		String arr = line.split(" ")[1];
		return new int[]{Integer.parseInt(dep.split(":")[0])*60+Integer.parseInt(dep.split(":")[1]),
						Integer.parseInt(arr.split(":")[0])*60+Integer.parseInt(arr.split(":")[1])};
		
	}
}
