import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;


public class P2
{
	public static void main(String[] args) throws IOException
	{
		//BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		BufferedReader br = new BufferedReader(new FileReader(new File("B-small-attempt0.in")));
		String line;
		ArrayList<String> data = new ArrayList<String>();
		Integer numCases = Integer.parseInt(br.readLine());
		for (int cases=1;cases<=numCases;cases++)
		{
			Integer numFF = Integer.parseInt(br.readLine());
			//x y z vx vy vz
			FF[] fireflies = new FF[numFF];
			for (int a=0;a<numFF;a++)
			{
				String s = br.readLine();
				String[] strings = s.split(" |\\t");
				int[] vel= new int[6];
				int c = 0;
				for (int b=0;b<strings.length;b++)
				{
					if (strings[b].trim().length() > 0)
					{
						vel[c++] = Integer.parseInt(strings[b].trim());
					}
				}
				fireflies[a] = new FF(vel[0], vel[1], vel[2], vel[3], vel[4], vel[5]);
			}
			//calculate CMass right now
			double cmx=0, cmy=0, cmz=0;
			//calculate CMass in 1 second
			double cmx1=0, cmy1=0, cmz1=0;
			for (FF f : fireflies)
			{
				cmx +=  f.x;
				cmy +=  f.y;
				cmz +=  f.z;
				
				cmx1 +=  f.x+f.vx;
				cmy1 +=  f.y+f.vy;
				cmz1 +=  f.z+f.vz;
				
			}
			cmx /= (double)fireflies.length;
			cmy /= (double)fireflies.length;
			cmz /= (double)fireflies.length;
			cmx1 /= (double)fireflies.length;
			cmy1 /= (double)fireflies.length;
			cmz1 /= (double)fireflies.length;
			
			//vel of the CM
			double vx = cmx1-cmx;
			double vy = cmy1-cmy;
			double vz = cmz1-cmz;
			
			//derive line equation
			/*       (x1-x0)*(x2-x1)
			 * t = - -----------------
			 *         |x2-x1|^2
			 * 
			 */
			double numerator = -(cmx*(cmx1-cmx) + cmy*(cmy1-cmy) + cmz*(cmz1-cmz));
			double denominator = ((cmx1-cmx)*(cmx1-cmx) + (cmy1-cmy)*(cmy1-cmy) + (cmz1-cmz)*(cmz1-cmz));
			double t;
			if (denominator == 0)
			{
				t = 0;
			}
			else
			{
				t = numerator/denominator;
			}
			if (t < 0)
				t = 0.0;
			double dist = Math.sqrt((cmx + vx*t)*(cmx + vx*t) + 
								(cmy + vy*t)*(cmy + vy*t)+
								(cmz + vz*t)*(cmz + vz*t));
			System.out.println("Case #" + cases + ": " + dist + " " + t);
		}
	}
}

class FF
{
	double x,y,z, vx, vy, vz;

	public FF(double x, double y, double z, double vx, double vy, double vz)
	{
		super();
		this.x = x;
		this.y = y;
		this.z = z;
		this.vx = vx;
		this.vy = vy;
		this.vz = vz;
	}
	
}
