import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;


public class A
{

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException
	{
		BufferedReader br = new BufferedReader(new FileReader("A-large.in"));
		int cases = Integer.parseInt(br.readLine());
		for (int cc=0;cc<cases;cc++)
		{
			String[] engines = new String[Integer.parseInt(br.readLine())];
			for (int a=0;a<engines.length;a++)
			{
				engines[a] = br.readLine();
			}
			String[] searches = new String[Integer.parseInt(br.readLine())];
			for (int a=0;a<searches.length;a++)
			{
				searches[a] = br.readLine();
			}
			
			int[] i = processSearches(engines, searches);
			int engineToUse = evalutateSearches(i, 0, engines.length);
			int globalMin = 0;
			for (int a=0;a<i.length;a++)
			{
				if (i[a] == engineToUse)
				{
					//reevaluate
					engineToUse = evalutateSearches(i, a, engines.length);
					globalMin++;
					a--;
				}
			}
			System.out.println("Case #" + (cc+1) + ": " + globalMin);
		}
	}
	
	public static int evalutateSearches(int[] s, int on, int numEngines)
	{
		int max=-1;
		int engine=0;
		for (int a=0;a<numEngines;a++)
		{
			int b;
			for (b=on;b<s.length && s[b]!=a;b++);
			if (b > max)
			{
				max = b;
				engine = a;
			}
		}
		return engine;
	}
	
	/**
	 * integers will range from 0 to # of engines-1
	 * @param engines
	 * @param searches
	 * @return
	 */
	private static int[] processSearches(String[] engines, String[] searches)
	{
		Map<String, Integer> m = new HashMap<String, Integer>();
		for (int a=0;a<engines.length;a++)
		{
			m.put(engines[a], a);
		}
		int[] ret = new int[searches.length];
		for (int a=0;a<searches.length;a++)
		{
			ret[a] = m.get(searches[a]);
		}
		return ret;
		
	}

}
