import java.util.*;
import java.io.*;
public class GettingDigits {
  public static void main(String[] args) {
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();  // Scanner has functions to read ints, longs, strings, chars, etc.
    for (int i = 1; i <= t; ++i) {
      String s = in.next(); 
      String phone = getDigits(s);
      phone = reorderPhone(phone);
      System.out.println("Case #" + i + ": " + phone);
    }
  }
  
  static String getDigits(String s)
  {
	  String[] digitWords = {"ZERO", "TWO", "FOUR", "ONE", "THREE", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	  String[] digits = {"0", "2", "4", "1", "3", "5", "6", "7", "8", "9"};
	  String n = "";
	  for (int i=0;i<=9;i++)
	  {
		  String digitWord = digitWords[i];
		  while (checkDigitExist(s, digitWord)) {
			  s = removeDigit(s, digitWord);
			  n += digits[i];
			  if (s.length() == 0) return n;
		  }
	  }
	  return n;
  }
  
  static boolean checkDigitExist(String s, String digitWord)
  {
	  for (int i=0; i< digitWord.length(); i++)
	  {
		  if (s.indexOf(digitWord.charAt(i))<0) return false;
	  }
	  return true;
  }
  
  static String removeDigit(String s, String digitWord)
  {
	  for (int i=0; i< digitWord.length(); i++)
	  {
		  int index = s.indexOf(""+digitWord.charAt(i));
		  s = s.substring(0, index) + s.substring(index+1);;
	  }
	  return s;
  }
  
  static String reorderPhone(String phone)
  {
	  char[] phoneDigits = phone.toCharArray();
	  Arrays.sort(phoneDigits);
	  
	  return new String(phoneDigits);
  }
}