import java.util.*;
import java.io.*;
public class OversizedPancakeFlipper {
  public static void main(String[] args) {
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();  // number of test cases
    for (int i = 1; i <= t; ++i) {
      String s = in.next();
      int k = in.nextInt();
      int n = getFlips(s, k);
      if (n == -1)
          System.out.println("Case #" + i + ": IMPOSSIBLE");
      else
	      System.out.println("Case #" + i + ": " + n );
    }
  }
  
  static int getFlips(String s, int k)
  {
	  int flips = 0;
	  //if no -, no flip required
	  if (!s.contains("-")) return 0;
	  while(s.contains("-")){
		  int iFirst = s.indexOf('-');
		  int iLast = s.lastIndexOf('-');
		  // get the block between
		  s = s.substring(iFirst, iLast+1);
		  if (s.length() < k) 
			  return -1;
		  else
		  {
			  s = flip(s, k);
			  flips++;
		  }
	  }
	  return flips;
  }
  
  static String flip (String s, int k)
  {
	  
	  StringBuilder sb = new StringBuilder();
	  for (int i = 0; i < s.length(); i++)
	  {
		  if (i<k)
			  sb.append(s.charAt(i) == '+' ? '-' : '+');
		  else
			  sb.append(s.charAt(i));
	  }
	  return sb.toString();
  }
  
}