import java.util.*;
import java.io.*;
public class Pancake {
  public static void main(String[] args) {
    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
    int t = in.nextInt();  // number of test cases
    for (int i = 1; i <= t; ++i) {
      String s = in.next();
      int n = getFlips(s);
      System.out.println("Case #" + i + ": " + n );
    }
  }
  
  static int getFlips(String s)
  {
	  int flips = 0;
	  //if no -, no flip required
	  if (!s.contains("-")) return 0;
	  //if no +, 1 flip required
	  if (!s.contains("+")) return 1;
	  //find the last position of -, which needs to be flipped to +
	  int iLast = s.lastIndexOf('-');
	  int iFirst = 0;
	  //find the first block of + which needs to be flipped to - first
	  while (s.charAt(iFirst) == '+')
	  {
		  iFirst ++;
	  }
	  //first + appear after the last -
	  if (iFirst > iLast)
	  {
		  //flip the first - block, then should be done
		  return 1;
	  }
	  //flip the first + block
	  if (iFirst > 0)
	  {
		  String leftString = s.substring(0, iFirst);
		  s = flip(leftString) + s.substring(iFirst);
		  flips++;
	  }
	  //flip the second block containing last -
	  if (iLast >= 0)
	  {
		  String leftString = s.substring(0, iLast+1);
		  s = flip(leftString) + s.substring(iLast+1);
		  flips++;
	  }
	  return flips += getFlips(s);
  }
  
  static String flip (String s)
  {
	  StringBuilder sb = new StringBuilder();
	  for (int i = s.length()-1; i >= 0; i--)
	  {
		  sb.append(s.charAt(i) == '+' ? '-' : '+');
	  }
	  return sb.toString();
  }
  
}