package com.mavtushenko;

import java.io.*;
import java.math.BigInteger;
import java.util.Scanner;

public class Gcj3 {
    private static long prime(long val) {
        for (long del = 3; del <= Math.sqrt(val); del += 2) {
            if (val % del == 0)
                return del;
        }
        return -1;
    }

    static BigInteger two = BigInteger.valueOf(2);

    private static BigInteger primeBI(BigInteger val) {
        BigInteger max = two.pow(val.bitLength() / 2 + 1);
        for (BigInteger del = BigInteger.valueOf(3); del.compareTo(max) < 0; del = del.add(two)) {
            if (val.mod(del).equals(BigInteger.ZERO))
                return del;
        }
        return BigInteger.ZERO;
    }

    private static void processLong(int n, int j, BufferedWriter bw) throws IOException {
        long nn = (long) Math.pow(2, n);
        long powed[] = new long[10];
        for (int i = 0; i < powed.length; ++i) {
            powed[i] = (long) Math.pow(i + 1, n - 1);
        }

        System.out.println("Case #1:");
        i:
        for (long coin = (long) Math.pow(2, n - 1) + 1; coin < nn; coin += 2) {
            char str[] = Long.toBinaryString(coin).toCharArray();
            long res[] = new long[9];
            for (int dig = 2; dig <= 10; ++dig) {
                long cur = 0;
                for (int i = 0; i < str.length; ++i) {
                    if (str[i] == '1')
                        cur = cur + (long)Math.pow(dig, n - 1 - i);
                }
                long del = prime(cur);
                if (del == -1)
                    continue i;
                else
                    res[dig - 2] = del;
            }
            --j;
            bw.write(Long.toBinaryString(coin));
            for (long r : res)
                bw.write(" " + r);
            bw.write("\n");
            if (j <= 0)
                break;
        }

    }

    private static void processBI(int n, int maxJ) {
        BigInteger nn = two.pow(n);
        BigInteger powed[][] = new BigInteger[9][n + 1];
        for (int i = 0; i < powed.length; ++i) {
            for (int j = 0; j < powed[i].length; ++j) {
                powed[i][j] = BigInteger.valueOf(i + 2).pow(j);
            }
        }

        i:
        for (BigInteger coin = two.pow(n - 1).add(BigInteger.ONE); coin.compareTo(nn) < 0; coin = coin.add(two)) {
            char str[] = coin.toString(2).toCharArray();
            BigInteger res[] = new BigInteger[9];
            for (int dig = 2; dig <= 10; ++dig) {
                BigInteger cur = BigInteger.ZERO;
                BigInteger digit = BigInteger.valueOf(dig);
                for (int i = 0; i < str.length; ++i) {
                    if (str[i] == '1')
                        cur = cur.add(digit.pow(n - 1 - i));
                }
                BigInteger del = primeBI(cur);
                if (del.equals(BigInteger.ZERO))
                    continue i;
                else
                    res[dig - 2] = del;
            }
            --maxJ;
            System.out.print(coin.toString(2));
            for (BigInteger r : res)
                System.out.print(" " + r);
            System.out.println();
            if (maxJ <= 0)
                break;
        }

    }

    public static void main(String[] args) {
        String fileName = "C-small-attempt0.in";
        try (BufferedReader br = new BufferedReader(new FileReader(fileName))) {

            try (BufferedWriter bw = new BufferedWriter(new FileWriter(fileName + ".out"))) {
                int tests = Integer.valueOf(br.readLine());
                for (int test = 1; test <= tests; ++test) {
                    bw.write("Case #" + test + ":" + "\n");
                    Scanner scanner = new Scanner(br.readLine());
                    int n = scanner.nextInt();
                    int j = scanner.nextInt();
                    processLong(n, j, bw);

                }
                bw.close();
            }

        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
