import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Stack;
import java.util.Collections;
import java.util.ArrayList;

public class DeceitfulWar {

	public static void main(String[] args) {
		try {
			String file = "D-small-attempt0";
			//String file = "D-large";
			//String file = "problem_d_test";
			FileReader fr = new FileReader(file + ".in");
			BufferedReader br = new BufferedReader(fr);
			FileWriter fw = new FileWriter(file + ".out");
			BufferedWriter bw = new BufferedWriter(fw);
			String line;
			line = br.readLine();
			int cases = Integer.parseInt(line);
			ArrayList<Double> Naomi = new ArrayList<Double>();
			ArrayList<Double> Ken = new ArrayList<Double>();
			for(int i=0; i<cases; i++) {
				line = br.readLine();
				int N = Integer.parseInt(line);
				Naomi.clear();
				Ken.clear();
				line = br.readLine();
				String words[] = line.split(" ");
				for(int j=0; j<N; j++) {
					Naomi.add(Double.parseDouble(words[j]));
				}
				line = br.readLine();
				words = line.split(" ");
				for(int j=0; j<N; j++) {
					Ken.add(Double.parseDouble(words[j]));
				}
				Collections.sort(Naomi);
				Collections.sort(Ken);
				bw.write("Case #" + (i+1)+": " + solveDeceitfulWar(N, Naomi, Ken) + " " + solveWar(N, Naomi, Ken));
				bw.write("\n");
			}
			br.close();
			bw.close();
		} catch(Exception e) {
			e.printStackTrace();
		}
	}
	
	public static int solveDeceitfulWar(int N, ArrayList<Double> WeightsNaomi, ArrayList<Double> WeightsKen) {
		int kenWins = 0;
		int naomiWins = 0;
		Double delta = new Double(0.000001);
		ArrayList<Double> Naomi = new ArrayList<Double>(WeightsNaomi);
		ArrayList<Double> Ken = new ArrayList<Double>(WeightsKen);
		for(int i=0; i<N; i++) {
			Double naomiMin = Naomi.remove(0);
			
			Double kenMax = Ken.get(Ken.size()-1);
			Double kenMin = Ken.get(0);
			
			Double naomiTold;
			
			if(kenMax < naomiMin) {
				naomiWins += N-i;
				break;
			}
			if(naomiMin > kenMin) {
				naomiTold = kenMax + delta;
				while(Collections.binarySearch(Naomi, naomiTold) >= 0) {
					naomiTold = naomiTold + delta;
				}
			} else {
				naomiTold = kenMax - delta;
				while(Collections.binarySearch(Ken, naomiTold) >= 0 && (Collections.binarySearch(Naomi, naomiTold) >= 0 || naomiTold == naomiMin)) {
					naomiTold = naomiTold - delta;
				}
			}
			
			//System.out.println("Nchosen " + naomiMin);
			//System.out.println("Ntold " + naomiTold);
			int index = Collections.binarySearch(Ken, naomiTold);
			index = -(index+1);
			//System.out.println("index " + index);
			if(index == Ken.size()) {
				Ken.remove(0);
				naomiWins++;
			} else {
				Ken.remove(index);
				//System.out.println("K " + Ken.remove(index));
				kenWins++;
			}
		}
		return naomiWins;
	}
	
	public static int solveWar(int N, ArrayList<Double> Naomi, ArrayList<Double> Ken) {
		int kenWins = 0;
		for(int i=0; i<N; i++) {
			Double d = Naomi.remove(0);
			//System.out.println("N " + d);
			int index = Collections.binarySearch(Ken, d);
			index = -(index+1);
			//System.out.println("index " + index);
			if(index == Ken.size()) {
				break;
			} else {
				Ken.remove(index);
				//System.out.println("K " + Ken.remove(index));
				kenWins++;
			}
		}
		return N-kenWins;
	}
}
