import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;


public class MakingChessBoards {


	public static boolean[][] makeChessBoard(int m, int n, BigInteger[] rows) {
		boolean[][] board = new boolean[m][n];
		for(int i=0;i<m;i++) {
			for(int j=0;j<n;j++) {
				board[i][j] = rows[i].testBit(n-j-1);
			}
		}
		return board;
	}
	
	public static void printBoard(boolean[][] board) {
//		for(boolean[] row: board) {
//			for(boolean col: row) {
//				System.out.print(col?"*":".");
//			}
//			System.out.println();
//		}
	}
	
	
	public static boolean isBoard(boolean[][] board, boolean[][] used, int row, int col, int size) {
		boolean f = !board[row][col];
		for(int y = row;y<row+size;y++) {
			if(f==board[y][col]) return false;
			f=!f;
			boolean b = !board[y][col];
			for(int x = col;x<col+size;x++) {
				if(used[y][x]) return false;
				if(b==board[y][x]) return false;
				b=!b;
			}
		}
		return true;
	}
	
	
	public static int[] solveBoard(boolean[][] board) {
		int m = board.length;
		int n = board[0].length;
		boolean[][] used = new boolean[m][n];
		
		int sizes[] = new int[m+1];
		
	
		boolean go = true;
		while(go) {
			int[] res = findNext(board,used,m,n);
			int mx = res[0], my = res[1], size = res[2];
			if(size==0) break;
			sizes[size]++;
			for(int x=mx;x<mx+size;x++)
				for(int y=my;y<my+size;y++)
					used[y][x] = true;
			printBoard(used);
		}
		return sizes;
	}
	
	public static int[] findNext(boolean[][] board, boolean[][] used, int m, int n) {
		int biggestBoard = 0;
		int mx = 0, my = 0;
		for(int cx=0;cx<n;cx++) {
			for(int cy=0;cy<m;cy++) {
				if(used[cy][cx]) continue;
				for(int s=biggestBoard;s<=Math.min(m-cy,n-cx);s++) {
					if(isBoard(board,used,cy,cx,s)) {
						if(s>biggestBoard) {
							biggestBoard = s;
							mx = cx;
							my = cy;
						}
					} else break;
				}
			}
		}
		return new int[]{mx,my,biggestBoard};
	}
	
	
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("a.in"));
		BufferedWriter out = new BufferedWriter(new FileWriter("a.out"));
		Scanner s = new Scanner(br);
		int caseCount = s.nextInt();
		for(int i=0;i<caseCount;i++) {
			int m = s.nextInt();
			int n = s.nextInt();
			BigInteger[] rows = new BigInteger[m];
			for(int j=0;j<m;j++) {
				BigInteger row = s.nextBigInteger(16);
				rows[j] = row;
			}
			boolean[][] board = makeChessBoard(m,n,rows);
			printBoard(board);
			int[] sizes = solveBoard(board);
			int f = 0;
			for(int j = m;j>=0;j--) {
				if(sizes[j]>0) f++;
			}
			out.write("Case #"+(i+1)+": "+f+"\n");
			for(int j = m;j>=0;j--) {
				if(sizes[j]>0) out.write(j+" "+sizes[j]+"\n");
			}
		}
		out.flush();
		out.close();
	}

}
