package y2011.q;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

import com.google.common.collect.Lists;
import com.google.common.collect.Maps;

public class Magicka {
	
	private static final String PROBLEM_INPUT = "B-small-attempt0";

	private static class Case {
		List<Set<Character>> opposers = Lists.newArrayList();
		Map<Set<Character>,Character> combiners = Maps.newHashMap();
		String invoke;				
		
		void addOpposer(String opposer) {
			Set<Character> set = new HashSet<Character>();
			for(char c : opposer.toCharArray()) set.add(c);
			opposers.add(set);
		}
		
		void addCombiner(String combiner) {
			Set<Character> set = new HashSet<Character>();
			set.add(combiner.charAt(0)); set.add(combiner.charAt(1));
			combiners.put(set,combiner.charAt(2));
		}
	}
	
	private static boolean combine(Case kase, List<Character> elementList) {
		if(elementList.size()<2) return false;
		char l1 = elementList.get(elementList.size()-1);
		char l2 = elementList.get(elementList.size()-2);
		Character target = kase.combiners.get(new HashSet<Character>(Arrays.asList(new Character[]{l1,l2})));
		if(target!=null) {
			elementList.remove(elementList.size()-1);
			elementList.remove(elementList.size()-1);
			elementList.add(target);
			return true;
		}
		return false;
	}
	
	
	
	private static boolean oppose(Case kase, List<Character> elementList) {
		for(Set<Character> opposer : kase.opposers) {
			if(elementList.containsAll(opposer)) {
				elementList.clear();
				return true;
			}
		}
		return false;
	}
	
	
	
	private static String solve(Case kase) {
		List<Character> elementList = new ArrayList<Character>();
		
		for(char c : kase.invoke.toCharArray()) {
			elementList.add(c);
			if(elementList.size()<2) continue;
			
			// Check combiners.
			while(combine(kase,elementList));

			// Check opposers.
			while(oppose(kase,elementList));
		}
		
		return elementList.toString();
	}
	

	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new File(PROBLEM_INPUT+".in"),"ASCII");
		
		
		BufferedWriter writer = new BufferedWriter(new FileWriter(PROBLEM_INPUT+".out"));
		
		int t = sc.nextInt();
		for(int i=0;i<t;i++) {
			Case kase = new Case();
			int c = sc.nextInt();
			for(int j=0;j<c;j++) kase.addCombiner(sc.next());
			
			int d = sc.nextInt();
			for(int j=0;j<d;j++) kase.addOpposer(sc.next());
			
			sc.nextInt();
			kase.invoke = sc.next();
			
			String result = solve(kase);
			result = String.format("Case #%d: %s",i+1,result);
			writer.write(result+"\n");
			System.out.println(result);
		}
		writer.flush();
		writer.close();
	}



	
	
}
