package y2011.q;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Lists;

public class BotTrust {

	private static class Button {
		char color;
		int pos;
		
		@Override
		public String toString() {
			return String.format("Button [color=%s, pos=%s]", color, pos);
		}
	}
	
	

	private static int solve(List<Button> buttonSequence) {
		int posBlue = 1;
		int posOrange = 1;
		int stepsBlue = 0;
		int stepsOrange = 0;
		
		for(Button button : buttonSequence) {
			switch(button.color) {
			case 'O':
				stepsOrange += Math.abs(posOrange - button.pos);
				stepsOrange = Math.max(stepsOrange,stepsBlue);
				stepsOrange++;
				posOrange = button.pos;
				break;
			case 'B':
				stepsBlue += Math.abs(posBlue - button.pos);
				stepsBlue = Math.max(stepsBlue,stepsOrange);
				stepsBlue++;
				posBlue = button.pos;
				break;
			}
		}

		
		return Math.max(stepsOrange,stepsBlue);
	}
	
	
	
	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new File("A-small-attempt0.in"),"ASCII");
		
		BufferedWriter writer = new BufferedWriter(new FileWriter("A-small-attempt0.out"));
		
		int t = sc.nextInt();
		List<Button> buttonSequence = Lists.newArrayListWithCapacity(t);
		for(int i=0;i<t;i++) {
			buttonSequence.clear();
			int n = sc.nextInt();
			for(int j=0;j<n;j++) {
				Button button = new Button();
				button.color = sc.next().trim().charAt(0);
				button.pos = sc.nextInt();
				buttonSequence.add(button);
			}
			int s = solve(buttonSequence);
			String result = String.format("Case #%d: %d",i+1,s);
			writer.write(result+"\n");
			System.out.println(result);
		}
		writer.flush();
		writer.close();
		
	}

	
}
