import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.LinkedList;
import java.util.Queue;

class Pair {
	public char type;
	public int value;
	
	public Pair(char type, int value) {
		this.type = type;
		this.value = value;
	}
	
	public String toString() {
		return type + " " + value;
	}
}

public class A {
	
	static void runTest(int c, Queue<Pair> queue, Queue<Integer> oQueue, Queue<Integer> bQueue) {
		
		int o = 1, b = 1, seconds = 0;
		
		while(!queue.isEmpty()) {
			Pair target = queue.peek();
			
			// case 1
			if(target.type == 'O' && target.value == o) {
				queue.remove();
				oQueue.remove();
				
				if(!bQueue.isEmpty()) {
					int nextB = bQueue.element();
					if(b < nextB) b++;
					else if(b > nextB) b--;
				}
				
				seconds++;
			}
			// case 2
			else if(target.type == 'B' && target.value == b) {
				queue.remove();
				bQueue.remove();
				
				if(!oQueue.isEmpty()) {
					int nextO = oQueue.element();
					if(o < nextO) o++;
					else if(o > nextO) o--;
				}
				
				seconds++;
			}
			// case 3
			else if(target.type == 'O' && target.value != o) {
				int diff = target.value - o;
				o += diff;
				
				// see if other needs to be adjusted
				if(!bQueue.isEmpty()) {
					int nextB = bQueue.element();
					diff = Math.abs(diff);
					int targetDiff = nextB - b;
				
					if(targetDiff > 0) {
						if(targetDiff <= diff) b += targetDiff;
						else b += diff;
					}
					else if(targetDiff < 0) {
						if(Math.abs(targetDiff) <= diff) b += targetDiff;
						else b -= diff;
					}
				}
				
				seconds += Math.abs(diff);
			}
			// case 4
			else if(target.type == 'B' && target.value != b) {
				int diff = target.value - b;
				b += diff;
				
				// see if other needs to be adjusted
				if(!oQueue.isEmpty()) {
					int nextO = oQueue.element();
					diff = Math.abs(diff);
					int targetDiff = nextO - o;
					
					if(targetDiff > 0) {
						if(targetDiff <= diff) o += targetDiff;
						else o += diff;
					}
					else if(targetDiff < 0) {
						if(Math.abs(targetDiff) <= diff) o += targetDiff;
						else o -= diff;
					}	
				}
				
				seconds += Math.abs(diff);
			}
		}
		System.out.println("Case #" + c + ": " + seconds);
	}
	
	public static void main(String[] args) {
		int t, n;
		int c = 1;
		
		String line;
		try {
			BufferedReader input = new BufferedReader(new InputStreamReader(System.in));
			line = input.readLine();
			t = Integer.parseInt(line);
			
			while( t > 0 ) {
				line = input.readLine();
				String[] testCase = line.split(" ");
				n = Integer.parseInt(testCase[0]);
				
				Queue<Pair> queue = new LinkedList<Pair>();
				Queue<Integer> oQueue = new LinkedList<Integer>();
				Queue<Integer> bQueue = new LinkedList<Integer>();
				for(int i = 1; i <= 2*n; i+=2) {
					char type = testCase[i].charAt(0);
					int value = Integer.parseInt(testCase[i+1]);
					queue.add(new Pair(type, value));
					if(type == 'O') oQueue.add(value);
					if(type == 'B') bQueue.add(value);
				}
				
				runTest(c, queue, oQueue, bQueue);
				t--; 
				c++;
			}
			
		}
		catch (IOException e) {
			System.err.println("Error: " + e);
		}

	}
}
