import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class JoinK {
	public static void main(String[] args) {
		
		if(args.length < 1) {
			System.err.println("Usage: java JoinK inputFile");
			System.exit(1);
		}
		
		BufferedReader in = null;
		PrintWriter out = null;
		try {
			// read the input file
			String inputFile = args[0];
			in = new BufferedReader(new FileReader(inputFile));
			
			// output the file
			String outputFile = inputFile.substring(0, inputFile.indexOf(".")) + ".out";
			out = new PrintWriter(new BufferedWriter(new FileWriter(outputFile)));
			
		    int t = 0; // no of test cases (1 <= T <= 100)
		    // Integer.MAX_VALUE = 2^31 - 1
		    int n; // (3 <= N <= 50)
		    int k; // (3 <= N <= n)
		    int i = 1; // counter
			
			String s;
			StringBuilder sb;
			
			// first line gives t
			if( (s = in.readLine()) != null)
				t = Integer.parseInt(s);
			else {
				System.err.println("Input file " + inputFile + " is empty");
				System.exit(1);
			}
			
			// for each test case
			while( (t-- > 0) && ( s = in.readLine()) != null ) {
				String[] tokens = s.trim().split("\\s+");
				n = Integer.parseInt(tokens[0]);
				k = Integer.parseInt(tokens[1]);
				
				char matrix2[][] = new char[n][n];
				int temp = n;
				int x = 0;
				// read next n lines and create matrix
				while( (temp-- > 0) && (s = in.readLine()) != null ) {
					char[] cArray = s.toCharArray();
					for(int idx = 0; idx < n; idx++) {
						char ch = cArray[idx];
						if(ch == '.')
							matrix2[x][idx] = 0;
						else
							matrix2[x][idx] = cArray[idx];
					}
					x++;
				}
				char matrix[][] = new char[n][n];
				for(int z1 = 0; z1 < n; z1++)
					for(int z2 = 0; z2 < n; z2++)
						matrix[z1][z2] = matrix2[n-z2-1][z1];
				
				// shift
				for(int col=0; col < n; col++) {
					int l = n - 1, r = n - 1;
					while(l >= 0) {
						if(matrix[l][col] != 0) {
							//System.out.println("row = " + row + ", l = " + l);
							matrix[r][col] = matrix[l][col];
							if(l != r)
								matrix[l][col] = 0;
							l--; r--;
						}
						else
							l--;
					}
				}
				
				boolean red = false, blue = false;
				
				for(int row = n-1; row >= 0; row--) {
					for(int col = n-1; col >= 0; col--) {
						char ch = matrix[row][col];
						// left
						int count = 1;
						for(int l1 = col-1; l1 >= 0; l1--) {
							if(matrix[row][l1] == ch) {
								
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							}
							else if(matrix[row][l1] != 0 && matrix[row][l1] != ch)
								break;
						}

						// left up
						count = 1;
						for(int l2 = row-1, r2 = col-1; l2 >= 0 && r2 >= 0; l2--, r2--) {
							if(matrix[l2][r2] == ch)
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							else if(matrix[l2][r2] != 0 && matrix[l2][r2] != ch)
								break;
						}

						// up
						count = 1;
						for(int l3 = row-1; l3 >= 0; l3--) {
							if(matrix[l3][col] == ch) {
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							}
							else if(matrix[l3][col] != 0 && matrix[l3][col] != ch)
								break;
						}
						
						// up right
						count = 1;
						for(int l4 = row-1, r4 = col+1; l4 >= 0 && r4 < n; l4--, r4++) {
							if(matrix[l4][r4] == ch)
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							else if(matrix[l4][r4] != 0 && matrix[l4][r4] != ch)
								break;
						}

						// right
						count = 1;
						for(int l5 = col+1; l5 < n; l5++) {
							if(matrix[row][l5] == ch) {
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							}
							else if(matrix[row][l5] != 0 && matrix[row][l5] != ch)
								break;
						}
						
						// right down
						count = 1;
						for(int l6 = row+1, r6 = col+1; l6 < n && r6 < n; l6++, r6++) {
							if(matrix[l6][r6] == ch)
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							else if(matrix[l6][r6] != 0 && matrix[l6][r6] != ch)
								break;
						}

						// down
						count = 1;
						for(int l7 = row+1; l7 < n; l7++) {
							if(matrix[l7][col] == ch) {
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							}
							else if(matrix[l7][col] != 0 && matrix[l7][col] != ch)
								break;
						}
						
						// down left
						count = 1;
						for(int l8 = row+1, r8 = col-1; l8 < n && r8 >= 0; l8++, r8--) {
							if(matrix[l8][r8] == ch)
								count++;
								if(count >= k) {
									if(ch == 'R') red = true;
									else if(ch == 'B') blue = true;
									break;
								}
							else if(matrix[l8][r8] != 0 && matrix[l8][r8] != ch)
								break;
						}

						if(red && blue)
							break;
						
					}
				}


				sb = new StringBuilder();
				sb.append("Case #").append(i++).append(": ");
				
				if(red && blue)
					sb.append("Both");
				else if(red && !blue)
					sb.append("Red");
				else if(blue && !red)
					sb.append("Blue");
				else
					sb.append("Neither");
				
				out.println(sb.toString());

			}

		}
		catch(NumberFormatException nfe) {
			System.err.println("Number format exception: " + nfe.getMessage());
		}
		catch(IOException io) {
			System.err.println("IO Exception: " + io.getMessage());
		}
		finally {
			try {
				if(in != null) in.close();
				if(out != null) out.close();
			}
			catch(Exception e) { e.printStackTrace(); }
		}
		

	}

}
