import java.io.*;

public class Snapper {
	public static void main(String[] args) {
		
		if(args.length < 1) {
			System.err.println("Usage: java Snapper inputFile");
			System.exit(1);
		}
		
		BufferedReader in = null;
		PrintWriter out = null;
		try {
			// read the input file
			String inputFile = args[0];
			in = new BufferedReader(new FileReader(inputFile));
			
			// output the file
			String outputFile = inputFile.substring(0, inputFile.indexOf(".")) + ".out";
			out = new PrintWriter(new BufferedWriter(new FileWriter(outputFile)));
			
		    int t = 0; // no of test cases (1 <= T <= 10000)
		    // Integer.MAX_VALUE = 2^31 - 1
		    int n; // no of snappers (1 <= N <= 30)
		    int k; // no of snappings (0 <= K <= 10^8)
		    int i = 1; // counter
			
			String s;
			StringBuilder sb;
			
			// first line gives t
			if( (s = in.readLine()) != null)
				t = Integer.parseInt(s);
			else {
				System.err.println("Input file " + inputFile + " is empty");
				System.exit(1);
			}
			
			// for each test case
			while( (t-- > 0) && ( s = in.readLine()) != null ) {
				String[] tokens = s.trim().split("\\s+");
				n = Integer.parseInt(tokens[0]);
				k = Integer.parseInt(tokens[1]);
				
				// logic
				// if( ((k+1) % 2^n) == 0) then ON, else OFF
				int n2 = (int) Math.pow(2, n); // 2^n is within range of integer
				
				sb = new StringBuilder();
				sb.append("Case #").append(i++).append(": ");
				
				if ( ((k+1) % n2) == 0 )
					sb.append("ON");
				else
					sb.append("OFF");
				
				out.println(sb.toString());
			}
			
		}
		catch(NumberFormatException nfe) {
			System.err.println("Number format exception: " + nfe.getMessage());
		}
		catch(IOException io) {
			System.err.println("IO Exception: " + io.getMessage());
		}
		finally {
			try {
				if(in != null) in.close();
				if(out != null) out.close();
			}
			catch(Exception e) { e.printStackTrace(); }
		}
		

	}

}
