import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;

public class TempA {
	
	static int mkdir = 0;
	
    static void createDirs(Set<String> dirs, String path) {
		if(path.equals("") || dirs.contains(path)) 
			return;
		else {
			int idx = path.lastIndexOf('/');
			createDirs(dirs, path.substring(0, idx));
			if(!path.equals("/")) {
				dirs.add(path);
				mkdir++;
			}
		}
	}
    
	public static void main(String[] args) {
		
		if(args.length < 1) {
			System.err.println("Usage: java TempA inputFile");
			System.exit(1);
		}
		
		BufferedReader in = null;
		PrintWriter out = null;
		try {
			// read the input file
			String inputFile = args[0];
			in = new BufferedReader(new FileReader(inputFile));
			
			// output the file
			String outputFile = inputFile.substring(0, inputFile.indexOf(".")) + ".out";
			out = new PrintWriter(new BufferedWriter(new FileWriter(outputFile)));
			
		    int t = 0; 
		    int n;
		    int m;
		    int i = 1; // counter
			
			String s;
			StringBuilder sb;
			
			// first line gives t
			if( (s = in.readLine()) != null)
				t = Integer.parseInt(s);
			else {
				System.err.println("Input file " + inputFile + " is empty");
				System.exit(1);
			}
			
			// for each test case
			while( (t-- > 0) && ( s = in.readLine()) != null ) {
				String[] tokens = s.trim().split("\\s+");
				n = Integer.parseInt(tokens[0]);
				m = Integer.parseInt(tokens[1]);
				
				Set<String> dirs = new HashSet<String>();
				while(n-- > 0)
					dirs.add(in.readLine());
				
				while(m-- > 0)
					createDirs(dirs, in.readLine());
				
				sb = new StringBuilder();
				sb.append("Case #").append(i++).append(": ").append(mkdir);
				
				out.println(sb.toString());
				
				mkdir = 0;
			}
			
		}
		catch(NumberFormatException nfe) {
			System.err.println("Number format exception: " + nfe.getMessage());
		}
		catch(IOException io) {
			System.err.println("IO Exception: " + io.getMessage());
		}
		finally {
			try {
				if(in != null) in.close();
				if(out != null) out.close();
			}
			catch(Exception e) { e.printStackTrace(); }
		}
		

	}

}
