import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.HashSet;
import java.util.LinkedList;


//R is the number of runs
//k is the number of ppl a rollercoaster can hold
//N is the num if groups
//
//
//5 5 10
//2 4 2 3 4 2 1 2 1 3

public class ThemePark {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException 
	{
		long start = Calendar.getInstance().getTimeInMillis();
		if(args.length != 1)
		{
			System.out.println("Usage: filename");
			return;
		}						
					
		File out = File.createTempFile("themepark", ".txt");
		System.out.println(out.getCanonicalPath());
		BufferedWriter bw = new BufferedWriter(new FileWriter(out));						
		File in = new File(args[0]);
		BufferedReader stream = new BufferedReader(new FileReader(in));
		String readline = stream.readLine();	
		
		Integer numInputs = Integer.parseInt(readline);
		
		for(long inputIndex = 1; inputIndex <=numInputs; inputIndex++)
		{
			long start1 = Calendar.getInstance().getTimeInMillis();
			boolean converged = false;
			
			long lastRunValue = 0;
			String[] values = stream.readLine().split(" ");
			long r = Integer.parseInt(values[0]);
			long k = Integer.parseInt(values[1]);
			long N = Integer.parseInt(values[2]);
			long n_multiplier = N;
			String[] groups = stream.readLine().split(" ");
			
			while(!converged)
			{							
				
				LinkedList<Integer> groups_size = new LinkedList<Integer>();
				
				long n_cycle = 0;
				long loop_times = 0 ;
				long rides = 0;
				boolean rec = false;
				boolean terminate = false;
				ArrayList<LinkedList<Integer>> cycleList = new ArrayList<LinkedList<Integer>>(); 
				
	//			System.out.println("start: " + r + " " + k + " " + " " + N);
				
				for(String s : groups)
				{
					groups_size.offer(Integer.parseInt(s));				
				}
				long monies = 0;
				for(rides = 0; rides < r; rides++)
				{
					Integer onRoller = 0;
					LinkedList<Integer> exitList = new LinkedList<Integer>();
					while(true)
					{
						if(!groups_size.isEmpty() && onRoller + groups_size.peek() <= k)
						{
							Integer nextGrp = groups_size.poll();
						
							n_cycle++;
							onRoller += nextGrp;
							exitList.offer(nextGrp);
						}					
						else
						{
	//						System.out.println("On Roll: " + exitList);
							if(rec)
							{
								cycleList.add(exitList);
							}
							
							monies += onRoller;
							break;
						}
						
						if(n_cycle == n_multiplier)
						{
	//						System.out.println("-----");
							loop_times++;
							n_cycle = 0;
							
							if(rec)
							{							
	//							System.out.println("Pattern Found - terminate");
								terminate = true;
							}
							
							if(loop_times == 3)
							{
	//							System.out.println("Start Rec");
								rec = true;
							}
							
						}
					}
					groups_size.addAll(exitList);
					
					if(terminate)
						break;
													
				}
				if(terminate)
				{
					cycleList.remove(cycleList.size()-1);
	//				System.out.println("pattern size: " + cycleList.size());
					
					long patternCost = 0;
					for(LinkedList<Integer> i : cycleList)
					{
						for(Integer t : i)
						{ 
							patternCost += t;
						}
					}
									
	//				System.out.println("Pattern Cost: " + patternCost);
					long numberOfFullCyclesLeft = ((r - rides - 1) / cycleList.size());
					monies += numberOfFullCyclesLeft * patternCost;
					rides += cycleList.size() * numberOfFullCyclesLeft +1;
					
					for(; rides < r; rides++)
					{
						Integer onRoller = 0;
						LinkedList<Integer> exitList = new LinkedList<Integer>();
						while(true)
						{
							if(!groups_size.isEmpty() && onRoller + groups_size.peek() <= k)
							{
								Integer nextGrp = groups_size.poll(); 
								onRoller += nextGrp;
								exitList.offer(nextGrp);
							}					
							else
							{
//								System.out.println("On Roll: " + exitList); 
								monies += onRoller;
								break;
							}
											
						}
						groups_size.addAll(exitList);											
					}
				}
//				System.out.println("Case #" + inputIndex + ": "+monies );
				if(lastRunValue == monies)
				{
					System.out.println("CONVERGED");
					converged = true;
				}
				else
				{
					n_multiplier+=cycleList.size();
//					System.out.println("bump up: " + n_multiplier);
					if(n_multiplier > 100000)
					{
						converged = true;//give up
					}
				}
				lastRunValue = monies;
			}
			
			bw.write("Case #" + inputIndex + ": "+lastRunValue);
			bw.newLine();
			long total = Calendar.getInstance().getTimeInMillis() - start1;
			System.out.println("Time: " + total + "ms");
									
		}
		bw.flush();
		bw.close();
		long total = Calendar.getInstance().getTimeInMillis() - start;
		System.out.println("Time: " + total + "ms");
		System.out.println(out.getCanonicalPath());
				
	}
	

}
