import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class SnapperChain {

	public static void main(String[] args) throws IOException 
	{
		if(args.length != 1)
		{
			System.out.println("Usage: filename");
			return;
		}						
		
		File out = File.createTempFile("out", ".txt");
		BufferedWriter bw = new BufferedWriter(new FileWriter(out));
						
		File in = new File(args[0]);
		BufferedReader stream = new BufferedReader(new FileReader(in));
		String readline = stream.readLine();
		
		int caseCount = Integer.parseInt(readline);
		
		for(int caseCounter = 1; caseCounter <= caseCount; caseCounter++)
		{
			String[] array = stream.readLine().split(" ");
			
			int n = Integer.parseInt(array[0]);
			int k = Integer.parseInt(array[1]);
			SnapperGroup sg = new SnapperGroup(n);
			
			if(k > 0)
			{
				for(;k>1;k--)
				{
					sg.snap(); 
				}
				bw.write("Case #" + caseCounter + ((sg.snap()) ? ": ON" : ": OFF"));
				bw.newLine();
			}
			else
			{
				bw.write("Case #" + caseCounter + ": OFF");
				bw.newLine();
			}
			
		}

		bw.flush();
		bw.close();
		System.out.println(out.getAbsolutePath());
	}
	
}
