import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.LinkedList;


//R is the number of runs
//k is the number of ppl a rollercoaster can hold
//N is the num if groups
//
//
//5 5 10
//2 4 2 3 4 2 1 2 1 3

public class ThemePark {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException 
	{
		if(args.length != 1)
		{
			System.out.println("Usage: filename");
			return;
		}						
					
		File out = File.createTempFile("themepark", ".txt");
		System.out.println(out.getCanonicalPath());
		BufferedWriter bw = new BufferedWriter(new FileWriter(out));						
		File in = new File(args[0]);
		BufferedReader stream = new BufferedReader(new FileReader(in));
		String readline = stream.readLine();	
		
		Integer numInputs = Integer.parseInt(readline);
		
		for(int inputIndex = 1; inputIndex <=numInputs; inputIndex++)
		{
			String[] values = stream.readLine().split(" ");
			int r = Integer.parseInt(values[0]);
			int k = Integer.parseInt(values[1]);
			int N = Integer.parseInt(values[2]);
			String[] groups = stream.readLine().split(" ");
			LinkedList<Integer> groups_size = new LinkedList<Integer>();
			for(String s : groups)
			{
				groups_size.offer(Integer.parseInt(s));				
			}
			int monies = 0;
			for(int i = 0; i < r; i++)
			{
				Integer onRoller = 0;
				LinkedList<Integer> exitList = new LinkedList<Integer>();
				while(true)
				{
					if(!groups_size.isEmpty() && onRoller + groups_size.peek() <= k)
					{
						Integer nextGrp = groups_size.poll();
						onRoller += nextGrp;
						exitList.offer(nextGrp);
					}					
					else
					{
						monies += onRoller;
						break;
					}
				}
				groups_size.addAll(exitList);
								
			}
			bw.write("Case #" + inputIndex + ": "+monies );
			bw.newLine();
									
		}
		bw.flush();
		bw.close();
		
				
	}
	

}
