package google.codejam2010;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Round1 {
	public void ProblemA(){
		File file = new File("Round1/A-small.in");
		File file2 = new File("Round1/A-small.out");
		if(!file.exists()){
			System.err.println("There is no input file exist!");
		}
		try {
			Scanner sc = new Scanner(file);
			file2.createNewFile();
			BufferedWriter writer = new BufferedWriter(
					new FileWriter(file2));
			int num = Integer.parseInt(sc.nextLine());
			for(int i =1; i <= num; ++i){
				String[] info = sc.nextLine().split(" ");
				int n = Integer.parseInt(info[0]);
				int k = Integer.parseInt(info[1]);
				char[][] board = new char[n][];
				for(int j = 0; j < n; ++j){
					board[j] = sc.nextLine().toCharArray();
				}
				String result = calculateProblemA(n, k , board);
				
				writer.write("Case #"+i+": " + result + "\n");
			}
			sc.close();
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	private String calculateProblemA(int n, int k, char[][] board) {
		int wins = 0;
		char[][] rboard = rotate(n, board, 'r');
		
		wins = checkWhoWins(n, k, rboard);
		
		if(wins == 3)
			return "Both";
		if(wins == 1)
			return "Red";
		if(wins == 2)
			return "Blue";
		return "Neither";
	}
	
	private void show(char[][] lboard, int n) {
		for(int i = 0; i < n;++i){
			for(int j = 0; j < n; ++j){
				System.out.print(lboard[i][j]);
			}
			System.out.println();
				
		}
		
	}


	private char[][] rotate(int n, char[][] board, char orientation){
		char[][] rotatedBoard = new char[n][n];
		for(int i = 0; i < n;++i){
			for(int j = 0; j < n; ++j){
				rotatedBoard[i][j] = '.';
			}
		}
		if(orientation == 'r'){
			for(int i = 0; i < n; ++i){
				int position = n-1;
				for(int j = n-1; j > -1; --j){
					if(board[i][j] != '.'){
						rotatedBoard[i][position--] = board[i][j];
					}
				}
			}
		}
		else if(orientation == 'l'){
			for(int i = 0; i < n; ++i){
				int position = 0;
				for(int j = 0; j < n; ++j){
					if(board[i][j] != '.'){
						rotatedBoard[i][position++] = board[i][j];
					}
				}
			}
		}
		return rotatedBoard;
	}

	private int checkWhoWins(int n, int k,char[][] board){
		int wins = 0;
		for(int i = n-1; i > -1; --i){
			for(int j = 0; j < n; ++j){
				if(board[i][j] == '.')
					continue;
				else if(wins == 1 && board[i][j] == 'R')
					continue;
				else if(wins == 2 && board[i][j] == 'B')
					continue;
				else{
					wins |= checkPosition(n, k, board, i, j, board[i][j]);
					if(wins == 3)
						return wins;
				}
					
			}
		}
		
		return wins;
	}
	
	private int checkPosition(int n, int k, char[][] board, int i, int j, char c) {
		boolean success = false;
		int count = 1;
			//horizontal
		if(!success){
			for(int x = j+1; x < n; ++x){
				if(board[i][x] == c){
					count++;
				}
				else{
					break;
				}
			}
			for(int x = j-1; x > -1; --x){
				if(board[i][x] == c){
					count++;
				}
				else
					break;
			}
			if(count >= k)
				success = true;
		}
		if(!success){
			//vertical
			count = 1;
			for(int y = i+1; y < n; ++y){
				if(board[y][j] == c)
					count++;
				else
					break;
			}
			for(int y = i-1; y > -1; --y){
				if(board[y][j] == c)
					count++;
				else
					break;
			}
			if(count >= k)
				success = true;
		}
		if(!success){
			//left side
			count = 1;
			for(int x=j-1,y=i-1; x>-1&&y>-1; x--,y--){
				if(board[y][x] == c)
					count++;
				else 
					break;
			}
			if(count >= k)
				success = true;
		}
		if(!success){
			//right side
			count = 1;
			for(int x=j+1,y=i-1; x<n&&y>-1; x++,y--){
				if(board[y][x] == c)
					count++;
				else
					break;
			}
			if(count >= k)
				success = true;
		}
		if(!success)
			return 0;
		else if(c == 'R')
			return 1;
		return 2;
	}


	public void ProblemB(){
		File file = new File("Round1/B-small.in");
		File file2 = new File("Round1/B-small.out");
		if(!file.exists()){
			System.err.println("There is no input file exist!");
		}
		try {
			Scanner sc = new Scanner(file);
			file2.createNewFile();
			BufferedWriter writer = new BufferedWriter(
					new FileWriter(file2));
			int num = Integer.parseInt(sc.nextLine());
			for(int i =1; i <= num; ++i){
				
				writer.write("Case #"+i+": " + "\n");
			}
			sc.close();
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void ProblemC(){
		File file = new File("Round1/C-small.in");
		File file2 = new File("Round1/C-small.out");
		if(!file.exists()){
			System.err.println("There is no input file exist!");
		}
		try {
			Scanner sc = new Scanner(file);
			file2.createNewFile();
			BufferedWriter writer = new BufferedWriter(
					new FileWriter(file2));
			int num = Integer.parseInt(sc.nextLine());
			for(int i =1; i <= num; ++i){
				
				writer.write("Case #"+i+": " + "\n");
			}
			sc.close();
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		Round1 r = new Round1();
		r.ProblemA();
	}

}