package codejam2010;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Scanner;

public class Qualification {
	public void ProblemA() {
		File file = new File("A-large.in");
		File out = new File("A-large.out");
		if (!file.exists())
			return;
		try {
			Scanner sc = new Scanner(file);
			out.createNewFile();
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			int num = Integer.parseInt(sc.nextLine());
			for (int i = 1; i <= num; ++i) {
				String[] info = sc.nextLine().split(" ");
				int N = Integer.parseInt(info[0]);
				int K = Integer.parseInt(info[1]);
				boolean state = calculateProblemA(N, K);
				writer.write("Case #" + i + ": " + (state ? "ON\n" : "OFF\n"));
			}
			sc.close();
			writer.close();
		} catch (FileNotFoundException e) {

			e.printStackTrace();
		} catch (IOException e) {

			e.printStackTrace();
		}
	}

	public void ProblemB() {
		File file = new File("B-small.in");
		File out = new File("B-small.out");
		if (!file.exists())
			return;
		try {
			Scanner sc = new Scanner(file);
			out.createNewFile();
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			int num = Integer.parseInt(sc.nextLine());
			for (int i = 1; i <= num; ++i) {
				String line = sc.nextLine();
				String info[] = line.split(" ");
				int n = Integer.parseInt(info[0]);
				BigInteger[] nums = new BigInteger[n];
				for (int j = 0; j < n; ++j) {
					nums[j] = new BigInteger(info[j+1]); 
				}
				BigInteger addNum = calculateProblemB(nums);
				writer.write("Case #" + i + ": " + addNum + '\n');
			}
			sc.close();
			writer.close();
		} catch (FileNotFoundException e) {

			e.printStackTrace();
		} catch (IOException e) {

			e.printStackTrace();
		}
	}

	public void ProblemC() {
		long time = System.currentTimeMillis();
		File file = new File("C-large.in");
		File out = new File("C-large.out");
		if (!file.exists())
			return;
		try {
			Scanner sc = new Scanner(file);
			out.createNewFile();
			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			int num = Integer.parseInt(sc.nextLine());
			for (int i = 1; i <= num; ++i) {
				String[] info = sc.nextLine().split(" ");
				int r = Integer.parseInt(info[0]);
				int k = Integer.parseInt(info[1]);
				int n = Integer.parseInt(info[2]);
				info = sc.nextLine().split(" ");
				int[] groups = new int[n];
				for (int j = 0; j < n; ++j) {
					groups[j] = Integer.parseInt(info[j]);
				}
				String earn = caculateProblemC(r, k, n, groups);
				writer.write("Case #" + i + ": " + earn + "\n");
			}
			sc.close();
			writer.close();
			time = System.currentTimeMillis() - time;
			System.out.println(time / 1000);
		} catch (FileNotFoundException e) {

			e.printStackTrace();
		} catch (IOException e) {

			e.printStackTrace();
		}
	}

	public String caculateProblemC(int r, int k, int n, int[] groups) {
		ArrayList<Long> array = new ArrayList<Long>(100000);
		long result = 0;
		int position = 0;
		int index = 0;
		do {
			int current = 0;
			for (int i = position; i < n; ++i) {

				if (current + groups[i] <= k) {
					current += groups[i];
				} else {
					position = i;
					index++;
					if (Long.MAX_VALUE - result > current)
						result += current;
					else {
						array.add(result);
						result = 0;
					}
					break;
				}
				// to the end but begin position is not 0
				if (i == n - 1 && position != 0) {
					i = -1;
				}
				// to the end and begin position is 0
				else if (i == n - 1 && position == 0) {
					array.add((long) current);
					index++;
					result = current;
					break;
				}
			}
			if (index > r)
				break;
		} while (position != 0);
		int times = r / index;
		BigInteger euro = new BigInteger("0");
		for (int i = 0; i < array.size(); ++i) {
			euro.add(new BigInteger(array.get(i).toString()));
		}
		euro.multiply(new BigInteger(new Integer(times).toString()));
		if (position != 0) {
			r = r % index;
			index = 0;
			while (index < r) {
				int current = 0;
				for (int i = position; i < n; ++i) {

					if (current + groups[i] <= k) {
						current += groups[i];
					} else {
						position = i;
						index++;
						if (Long.MAX_VALUE - result > current)
							result += current;
						else {
							array.add(result);
							result = 0;
						}
						break;
					}
					// to the end but begin position is not 0
					if (i == n - 1 && position != 0) {
						i = -1;
					}
					// to the end and begin position is 0
					else if (i == n - 1 && position == 0) {
						array.add((long) current);
						index++;
						result = current;
						break;
					}
				}
			}
		}
		return euro.toString();
	}

	public BigInteger calculateProblemB(BigInteger[] nums) {
		BigInteger minInterval;
		java.util.Arrays.sort(nums);
		minInterval = nums[1].subtract(nums[0]);
		for(int i = 1; i < nums.length-1; i++){
			BigInteger interval = nums[i+1].subtract(nums[i]);
			if(minInterval.intValue() == 0){
				minInterval = interval;
				continue;
			}
			if(interval.intValue() == 0){
				continue;
			}
			if(minInterval.compareTo(interval) != -1)
				minInterval = interval;
		}
		if(minInterval.intValue() == 0)
			return minInterval;
		BigInteger mod = nums[0].mod(minInterval);
		BigInteger result = minInterval.subtract(mod);
		return result;
	}

	public boolean calculateProblemA(int n, int k) {
		int cycle = 1;
		for (int i = 0; i < n; ++i) {
			cycle *= 2;
		}
		if ((++k) % cycle == 0)
			return true;
		else
			return false;
	}

	public static void main(String[] args) {
		Qualification q = new Qualification();
		q.ProblemB();

	}
}
