package p3;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class CoinJam {

    private final static String TEST_DATASET_INPUT = "src/p3/test.in";
    private final static String TEST_DATASET_OUTPUT = "src/p3/test.out";

    private final static String SMALL_DATASET_INPUT = "src/p3/C-small-attempt0.in";
    private final static String SMALL_DATASET_OUTPUT = "src/p3/C-small-attempt0.out";

    private final static String LARGE_DATASET_INPUT = "src/p3/C-large.in";
    private final static String LARGE_DATASET_OUTPUT = "src/p3/C-large.out";

    private static long getDivisor(long n) {
        if (n <= 1) {
            return 0;
        }
        for (long i = 2; i * i <= n; i++) {
            if (n % i == 0) {
                return i;
            }
        }
        return 0;
    }

    private static long getNumber(int[] coin, int base) {
        long number = 0;
        for (int i = coin.length - 1; i >= 0; i--) {
            number += coin[i] * Math.pow(base, coin.length - 1 - i);
        }
        return number;
    }

    private static int[] getNextCoin(int[] coin) {
        int carry = 1;
        for (int i = coin.length - 2; i >= 0; i--) {
            int sum = coin[i] + carry;
            coin[i] = sum % 2;
            carry = sum / 2;
        }
        return coin;
    }

    private static long[] getDivisor(int[] coin) {
        long[] divisors = new long[9];
        for (int i = 2; i <= 10; i++) {
            long number = getNumber(coin, i);
            divisors[i - 2] = getDivisor(number);
            if (divisors[i - 2] == 0) {
                break;
            }
        }
        return divisors;
    }

    private static boolean verify(int[] coin, long[] divisors) {
        for (int i = 0; i < divisors.length; i++) {
            if (getNumber(coin, i + 2) % divisors[i] != 0) {
                return false;
            }
        }
        return true;
    }

    private static void coinJam() throws NumberFormatException, IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(
                TEST_DATASET_INPUT)));
        PrintWriter writer = new PrintWriter(new File(TEST_DATASET_OUTPUT));
        String line;
        int testNum = Integer.parseInt(reader.readLine());
        int count = 0;
        while ((line = reader.readLine()) != null) {
            String[] split = line.split(" ");
            int n = Integer.parseInt(split[0]);
            int j = Integer.parseInt(split[1]);

            n = 16;
            j = 50;

            int[] coin = new int[n];
            coin[0] = 1;
            coin[coin.length - 1] = 1;

            // System.out.println("Case #1:");
            writer.println("Case #1:");

            while (coin[0] != 0) {
                long[] divisors = getDivisor(coin);
                if (divisors[divisors.length - 1] != 0) {
                    ++count;
                    for (int i : coin) {
                        // System.out.print(i);
                        writer.print(i);
                    }
                    for (long d : divisors) {
                        // System.out.print(" " + d);
                        writer.print(" " + d);
                    }
                    // System.out.println();
                    writer.println();
                    if (count == j) {
                        break;
                    }
                }
                coin = getNextCoin(coin);
            }

            ++count;
        }
        reader.close();
        writer.close();
    }

    public static void main(String[] args) throws NumberFormatException,
            IOException {
        coinJam();
    }
}
