package pd;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.TreeSet;

/**
 * Problem D. Deceitful War, Qualification Round, Code Jam 2014
 * 
 * @author bintian
 * 
 */
public class DeceitfulWar {
    // path of test file
    private static final String TEST_FILE_PATH = "D-small-attempt0.in";
    // path of output file
    private static final String OUTPUT_FILE_PATH = "result_d.txt";

    /**
     * solving the problem
     * 
     * @throws IOException
     */
    private static void solve() throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(
                TEST_FILE_PATH)));
        // get case number from the first line
        int casesNum = Integer.parseInt(reader.readLine());
        PrintWriter writer = new PrintWriter(OUTPUT_FILE_PATH);

        // loop for each case
        for (int i = 0; i < casesNum; i++) {
            // get variables
            int blockNum = Integer.parseInt(reader.readLine());

            TreeSet<Double> naomiBlks = new TreeSet<Double>();
            String[] naomiBlksStr = reader.readLine().split(" ");
            for (String blk : naomiBlksStr) {
                naomiBlks.add(Double.parseDouble(blk));
            }

            String[] kenBlksStr = reader.readLine().split(" ");
            TreeSet<Double> kenBlks = new TreeSet<Double>();
            for (String blk : kenBlksStr) {
                kenBlks.add(Double.parseDouble(blk));
            }

            int scoreDeceitfulWar = playDeceitfulWar(
                    (TreeSet<Double>) naomiBlks.clone(),
                    (TreeSet<Double>) kenBlks.clone());
            int scoreWar = playWar(naomiBlks, kenBlks);

            writer.println("Case #" + (i + 1) + ": " + scoreDeceitfulWar + " "
                    + scoreWar);
        }

        reader.close();
        writer.close();
    }

    private static int playDeceitfulWar(TreeSet<Double> naomi,
            TreeSet<Double> ken) {
        int score = 0;
        while (!naomi.isEmpty()) {
            if (naomi.first() > ken.last()) {
                score += naomi.size();
                break;
            } else if (naomi.last() < ken.first()) {
                break;
            } else if (naomi.last() > ken.last()) {
                naomi.pollLast();
                ken.pollLast();
                score++;
            } else {
                naomi.pollFirst();
                ken.pollLast();
            }
        }
        return score;
    }

    private static int playWar(TreeSet<Double> naomi, TreeSet<Double> ken) {
        int score = 0;
        for (Double naomiBlk : naomi) {
            Double kenBlk = ken.higher(naomiBlk);
            if (kenBlk == null) {
                score++;
                ken.pollFirst();
            } else {
                ken.remove(kenBlk);
            }
        }
        return score;
    }

    public static void main(String[] args) throws IOException {
        solve();
    }
}
