package p1;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class CountingSheep {

    private final static String SMALL_DATASET_INPUT = "src/p1/A-small-attempt0.in";
    private final static String SMALL_DATASET_OUTPUT = "src/p1/A-small-attempt0.out";

    private static String countingSheep(int sheep) {
        if (sheep == 0) {
            return "INSOMNIA";
        }

        boolean[] digits = new boolean[10];
        for (int i = 1; i < Integer.MAX_VALUE; i++) {
            if (sheep > Integer.MAX_VALUE / i) {
                break;
            }
            
            int n = i * sheep;

            while (n != 0) {
                digits[n % 10] = true;
                n = n / 10;
            }

            boolean done = true;
            for (int j = 0; j < 10; j++) {
                done = done & digits[j];
            }
            if (done) {
                return String.valueOf(i * sheep);
            }
        }
        return "INSOMNIA";
    }

    private static void countingSheep() throws NumberFormatException,
            IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(
                SMALL_DATASET_INPUT)));
        PrintWriter writer = new PrintWriter(new File(SMALL_DATASET_OUTPUT));
        String line;
        int testNum = Integer.parseInt(reader.readLine());
        int count = 1;
        while ((line = reader.readLine()) != null) {
            int sheep = Integer.parseInt(line);
            writer.println("Case #" + count + ": " + countingSheep(sheep));
            count++;
        }
        reader.close();
        writer.close();
    }

    public static void main(String[] args) throws NumberFormatException,
            IOException {
        countingSheep();
    }

}
