package pb;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

/**
 * Problem B. Cookie Clicker Alpha, Qualification Round, Code Jam 2014
 * 
 * @author bintian
 * 
 */
public class CookieClickerAlpha {

    // path of test file
    private static final String TEST_FILE_PATH = "B-small-attempt0.in";
    // path of output file
    private static final String OUTPUT_FILE_PATH = "result_b.txt";

    private static final double BASE_RATE = 2.0;

    /**
     * solving the problem
     * 
     * @throws IOException
     */
    private static void solve() throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(
                TEST_FILE_PATH)));
        // get case number from the first line
        int casesNum = Integer.parseInt(reader.readLine());
        PrintWriter writer = new PrintWriter(OUTPUT_FILE_PATH);

        // loop for each case
        for (int i = 0; i < casesNum; i++) {
            // get variables
            String[] vars = reader.readLine().split(" ");
            double c = Double.parseDouble(vars[0]);
            double f = Double.parseDouble(vars[1]);
            double x = Double.parseDouble(vars[2]);

            // initialize
            double currentRate = BASE_RATE;
            double totalTime = 0.0;
            double secToNextFarm = c / currentRate;
            double secToFinIfBuy = secToNextFarm + x / (currentRate + f);
            double secToFinIfNotBuy = x / currentRate;

            while (secToFinIfBuy < secToFinIfNotBuy) {
                totalTime += secToNextFarm;
                currentRate += f;

                secToNextFarm = c / currentRate;
                secToFinIfBuy = secToNextFarm + x / (currentRate + f);
                secToFinIfNotBuy = x / currentRate;
            }
            totalTime += secToFinIfNotBuy;

            writer.println(String.format("Case #%d: %.7f", i + 1, totalTime));
        }

        reader.close();
        writer.close();
    }

    public static void main(String[] args) throws IOException {
        solve();
    }
}
