package p2;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class RevengePancakes {

    private final static String TEST_DATASET_INPUT = "src/p2/test.in";
    private final static String TEST_DATASET_OUTPUT = "src/p2/test.out";

    private final static String SMALL_DATASET_INPUT = "src/p2/B-small-attempt0.in";
    private final static String SMALL_DATASET_OUTPUT = "src/p2/B-small-attempt0.out";

    private final static String LARGE_DATASET_INPUT = "src/p2/B-large.in";
    private final static String LARGE_DATASET_OUTPUT = "src/p2/B-large.out";

    private static int revengePancakes(char[] pancakes) {
        int count = 0;
        while (!isReady(pancakes)) {
            ++count;
            int right = pancakes.length - 1;
            while (right > 0 && pancakes[right] != '-') {
                --right;
            }
            if (pancakes[0] == '+') {
                while (right > 0 && pancakes[right] != '+') {
                    --right;
                }
            }
            flip(pancakes, right);
        }
        return count;
    }

    private static void flip(char[] pancakes, int right) {
        int start = 0;
        while (start < right) {
            char temp = pancakes[start];
            pancakes[start] = pancakes[right] == '+' ? '-' : '+';
            pancakes[right] = temp == '+' ? '-' : '+';
            ++start;
            --right;
        }
        if (start == right) {
            pancakes[start] = pancakes[start] == '+' ? '-' : '+';
        }
    }

    private static boolean isReady(char[] pancakes) {
        for (int i = 0; i < pancakes.length; i++) {
            if (pancakes[i] == '-') {
                return false;
            }
        }
        return true;
    }

    private static void revengePancakes() throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(
                LARGE_DATASET_INPUT)));
        PrintWriter writer = new PrintWriter(new File(LARGE_DATASET_OUTPUT));
        String line;
        int testNum = Integer.parseInt(reader.readLine());
        int count = 1;
        while ((line = reader.readLine()) != null) {
            writer.println("Case #" + count + ": "
                    + revengePancakes(line.toCharArray()));
            // System.out.println("Case #" + count + ": "
            // + revengePancakes(line.toCharArray()));
            ++count;
        }
        reader.close();
        writer.close();
    }

    public static void main(String[] args) throws IOException {
        revengePancakes();
    }

}
