package pa;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

/**
 * Problem A. Magic Trick, Qualification Round, Code Jam 2014
 * 
 * @author bintian
 * 
 */
public class MagicTrick {

    // rows of the given grid
    private static final int TOTAL_ROWS = 4;
    // path of test file
    private static final String TEST_FILE_PATH = "A-small-attempt0.in";
    // path of output file
    private static final String OUTPUT_FILE_PATH = "result.txt";

    /**
     * solving the problem
     * 
     * @throws IOException
     */
    private static void solve() throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(new File(
                TEST_FILE_PATH)));
        // get case number from the first line
        int casesNum = Integer.parseInt(reader.readLine());
        PrintWriter writer = new PrintWriter(OUTPUT_FILE_PATH);

        // loop for each case
        for (int i = 0; i < casesNum; i++) {
            // get the first answer
            int firstAns = Integer.parseInt(reader.readLine());
            // read the grid and return all possible numbers
            List<String> possibleNums = getPossibleNums(reader, firstAns);

            // get the second answer
            int secondAns = Integer.parseInt(reader.readLine());
            // refine the list by the second arrangement
            possibleNums.retainAll(getPossibleNums(reader, secondAns));

            // output result
            int matchingSize = possibleNums.size();

            if (matchingSize == 0) {
                writer.println("Case #" + (i + 1) + ": Volunteer cheated!");
            } else if (matchingSize == 1) {
                writer.println("Case #" + (i + 1) + ": " + possibleNums.get(0));
            } else {
                writer.println("Case #" + (i + 1) + ": Bad magician!");
            }
        }

        reader.close();
        writer.close();
    }

    /**
     * Reading the grid
     * 
     * @param reader
     * @param answer
     * @return
     * @throws IOException
     */
    private static List<String> getPossibleNums(BufferedReader reader,
            int answer) throws IOException {
        for (int i = 1; i < answer; i++) {
            reader.readLine();
        }

        List<String> possibleNums = new ArrayList<String>();
        StringTokenizer st = new StringTokenizer(reader.readLine());
        while (st.hasMoreTokens()) {
            possibleNums.add(st.nextToken());
        }

        for (int i = 1; i <= TOTAL_ROWS - answer; i++) {
            reader.readLine();
        }

        return possibleNums;
    }

    public static void main(String[] args) throws IOException {
        solve();
    }
}
