package com.ebar;

import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.StringTokenizer;
import java.util.stream.Collector;

/**
 * Created by evgenbar on 4/30/2016.
 */
public class ProblemA {
    private static TokenizedInputReader in;
    private static PrintWriter out;
    public static boolean DEBUG = false;
    public static final String NAME = "C:\\Users\\evgenbar\\Desktop\\A-large";
    public static String[] DIGITS = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
    public static String[] UNIQUE_DIGITS_LETTERS = {"Z", null, "W", null, "U", null, "X", null, "G", null};

    public static void execute() throws IOException {
        String number = " ";
        String word = in.next();
        int[] digitsCount = new int[10];
        number = " ";

        for (int i = 0; i < UNIQUE_DIGITS_LETTERS.length; i++) {
            String letter = UNIQUE_DIGITS_LETTERS[i];
            if (letter == null) continue;
            while (word.contains(letter)) {
                digitsCount[i]++;
                word = removeDigit(word, i);
            }
        }

        for (int i = 0; i < DIGITS.length; i++) {
            if (UNIQUE_DIGITS_LETTERS[i] != null) continue;
            String digit = DIGITS[i];
            while (containsAll(word, digit)) {
                word = removeDigit(word, i);
                digitsCount[i]++;
            }
        }
        for (int i = 0; i < digitsCount.length; i++) {
            for (int j = 0; j < digitsCount[i]; j++) {
                number += i;
            }
        }
        out.print(number);
    }

    private static boolean containsAll(String s1, String s2) {
        for (int i = 0; i < s2.length(); i++) {
            if (!s1.contains(Character.toString(s2.charAt(i)))) return false;
        }
        return true;
    }

    private static String removeDigit(String string, int digit) {
        for (char c : DIGITS[digit].toCharArray())
            string = string.replaceFirst(String.valueOf(c), "");
        return string;
    }


    public static void main(String[] args) throws IOException {
        InputStream inputStream;
        OutputStream outputStream;
        if (!DEBUG) {
            inputStream = System.in;
            outputStream = System.out;
        } else {
            inputStream = new FileInputStream(new File(NAME + ".in"));
            outputStream = new BufferedOutputStream(new FileOutputStream(NAME + ".out"));
        }

        in = new TokenizedInputReader(inputStream);
        out = new PrintWriter(outputStream, true);

        int numCases = in.nextInt();
        for (int i = 1; i <= numCases; i++) {
            out.print("Case #" + i + ":");
            execute();
            out.println();
        }

        out.close();
    }

    static class TokenizedInputReader {
        public BufferedReader reader;
        public StringTokenizer lineTokenizer;
        public static int BUFFER_SIZE = 16384;

        public TokenizedInputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), BUFFER_SIZE);
            lineTokenizer = null;
        }

        public String next() throws IOException {
            while (lineTokenizer == null || !lineTokenizer.hasMoreTokens())
                lineTokenizer = new StringTokenizer(reader.readLine());
            return lineTokenizer.nextToken();
        }

        public int nextInt() throws IOException {
            return Integer.parseInt(next());
        }
    }

}
