package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;
import java.util.PriorityQueue;
import java.util.Scanner;

public class FRC_A {

	static String IN_FILE = null;
	static String OUT_FILE = null;

	static Scanner sc;
	static PrintStream out;

	// Stream related methods
	static void init() {
		if (IN_FILE != null) {
			try {
				sc = new Scanner(new File(IN_FILE));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			sc = new Scanner(System.in);
		}

		if (OUT_FILE != null) {
			try {
				out = new PrintStream(OUT_FILE);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			out = System.out;
		}
	}

	static void close() {
		sc.close();
		out.close();
	}

	// Input methods
	static int i() {
		return sc.nextInt();
	}

	static long l() {
		return sc.nextLong();
	}

	static double d() {
		return sc.nextDouble();
	}

	static String s() {
		return sc.next();
	}

	static char[] chars() {
		return sc.next().toCharArray();
	}

	static String line() {
		return sc.nextLine();
	}

	// Output methods

	static void p(Object o) {
		out.print(o);
	}

	static void pl(Object o) {
		out.println(o);
	}

	static void pl() {
		out.println();
	}

	// Specify input files here

	static {
		//IN_FILE = "1C/in.txt";
		// IN_FILE = "1C/A-large.in";
		 IN_FILE = "1C/A-small-attempt0.in";
		 OUT_FILE = "1C/out.txt";

		init();
	}

	// Problem logic starts here

	public static void main(String[] args) {
		int T = i();

		for (int t = 1; t <= T; t++) {
			p("Case #" + t + ": ");
			solve();
			pl();
		}

		close();
	}

	// Method that solve single test case
	static void solve() {
		int N = i(), K = i(), r, h;

		List<PanCake> pl = new ArrayList<PanCake>();
		for (int i = 0; i < N; i++) {
			r = i();
			h = i();
			PanCake p = new PanCake(i, r, h);
			pl.add(p);
		}

		Collections.sort(pl);
		int i = 0;
		double max = 0.0;

		do {
			PanCake p = pl.get(i);
			double a = Math.PI * p.r * p.r + 2 * Math.PI * p.r * p.h ;

			if (K > 1) {
				PriorityQueue<PanCake> Q = new PriorityQueue<PanCake>(new Pcomp());
				Q.addAll(pl.subList(i + 1, pl.size()));

				for (int j = 1; j <= K - 1; j++) {
					p = Q.poll();
					a += 2 * Math.PI * p.r * p.h;
				}
			}

			if (a > max)
				max = a;
			i++;
		} while (i + K - 1 <= N - 1);

		p(max);
	}
}

class PanCake implements Comparable<PanCake> {
	int r, h, n;

	PanCake(int n, int r, int h) {
		this.n = n;
		this.r = r;
		this.h = h;
	}

	@Override
	public int compareTo(PanCake ot) {
		if (r > ot.r)
			return -1;
		else if (r < ot.r)
			return 1;
		else if (n < ot.n)
			return -1;
		else
			return 1;
	}
}

class Pcomp implements Comparator<PanCake> {

	@Override
	public int compare(PanCake o1, PanCake o2) {
		long a1 = (long) o1.r * o1.h;
		long a2 = (long) o2.r * o2.h;

		if (a1 > a2)
			return -1;
		else if (a2 > a1)
			return 1;
		else if (o1.n < o2.n)
			return -1;
		else
			return 1;
	}
}