package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

class Pair<X extends Comparable<X>, Y extends Comparable<Y>> implements Comparable<Pair<X,Y>>{
	X first;
	Y second;
	
	public Pair(X first, Y second) {
		this.first = first;
		this.second = second;
	}

	public int compareTo(Pair<X,Y> a) {
		int ret = this.first.compareTo(a.first);
		return (ret != 0) ? ret : this.second.compareTo(a.second);
	}	
}

public class FRC_B {

	static String IN_FILE = null;
	static String OUT_FILE = null;

	static Scanner sc;
	static PrintStream out;

	// Stream related methods
	static void init() {
		if (IN_FILE != null) {
			try {
				sc = new Scanner(new File(IN_FILE));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			sc = new Scanner(System.in);
		}

		if (OUT_FILE != null) {
			try {
				out = new PrintStream(OUT_FILE);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			out = System.out;
		}
	}
	
	static void close() {
		sc.close();
		out.close();
	}

	// Input methods
	static int i() {
		return sc.nextInt();
	}
	
	static long l() {
		return sc.nextLong();
	}

	static double d() {
		return sc.nextDouble();
	}

	static String s() {
		return sc.next();
	}
	
	static char[] chars() {
		return sc.next().toCharArray();
	}

	static String line() {
		return sc.nextLine();
	}

	// Output methods

	static void p(Object o) {
		out.print(o);
	}

	static void pl(Object o) {
		out.println(o);
	}

	static void pl() {
		out.println();
	}
	
	// Specify input files here
	
	static {
		//IN_FILE = "1C/in.txt";
		//IN_FILE = "1C/B-large.in";
		IN_FILE = "1C/B-small-attempt0.in";
		OUT_FILE = "1C/out.txt";

		init();
	}

	// Problem logic starts here

	public static void main(String[] args) {
		int T = i();
		
		for (int t=1; t<=T; t++) {
			p("Case #" + t + ": ");
			solve();
			pl();
		}
		
		close();		
	}
	
	// Method that solve single test case

	static void solve() {
		int Ac= i(), Aj = i(), s, e;
		
		Act c[] = new Act[Ac];
		Act j[] = new Act[Aj];

		for (int i=0;i<Ac;i++) {
			s = i();
			e = i();
			c[i] = new Act(s,e);
		}
		
		for (int i=0;i<Aj;i++) {
			s = i();
			e = i();
			j[i] = new Act(s,e);
		}
		
		int ans = 2;
		if (Ac == 0 && Aj == 1) ans = 2;
		else if (Ac == 0 && Aj == 2) {
			 Act a, b;
			 if (j[0].s < j[1].s) {
				 a = j[0];
				 b = j[1];
			 } else {
				 a = j[1];
				 b = j[0];
			 }
			 if (b.e - a.s <= 720 || b.s - a.e >= 720) ans = 2;
			 else ans = 4;
		} else if(Ac==1) ans =2;
		else if (Ac == 2) {
			Act a, b;
			 if (c[0].s < c[1].s) {
				 a = c[0];
				 b = c[1];
			 } else {
				 a = c[1];
				 b = c[0];
			 }
			 if (b.e - a.s <= 720 || b.s - a.e >= 720) ans = 2;
			 else ans = 4;
		}
		p(ans);
	}
}

class Act{
	int s, e;

	Act(int s, int e) {
		this.s = s;
		this.e = e;
	}
}
