package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

public class FRB_A {

	static String IN_FILE = null;
	static String OUT_FILE = null;

	static Scanner sc;
	static PrintStream out;

	// Stream related methods
	static void init() {
		if (IN_FILE != null) {
			try {
				sc = new Scanner(new File(IN_FILE));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			sc = new Scanner(System.in);
		}

		if (OUT_FILE != null) {
			try {
				out = new PrintStream(OUT_FILE);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			out = System.out;
		}
	}

	static void close() {
		sc.close();
		out.close();
	}

	// Input methods
	static int i() {
		return sc.nextInt();
	}

	static long l() {
		return sc.nextLong();
	}

	static double d() {
		return sc.nextDouble();
	}

	static String s() {
		return sc.next();
	}

	static char[] chars() {
		return sc.next().toCharArray();
	}

	static String line() {
		return sc.nextLine();
	}

	// Output methods

	static void p(Object o) {
		out.print(o);
	}

	static void pl(Object o) {
		out.println(o);
	}

	static void pl() {
		out.println();
	}

	// Specify input files here

	static {
		//IN_FILE = "1B/in.txt";
		IN_FILE = "1B/A-large.in";
		OUT_FILE = "1B/out.txt";

		init();
	}

	// Problem logic starts here

	public static void main(String[] args) {
		int T = i();

		for (int t = 1; t <= T; t++) {
			p("Case #" + t + ": ");
			solve();
			pl();
		}

		close();
	}

	// Method that solve single test case
	static void solve() {
		int D=i(), N=i(), K, S;
		
		double max = 0.0D;
		for (int i=0;i<N;i++) {
			K = i();
			S = i();
			
			double t = (double)(D-K)/S;
			if (t > max) max = t;
		}
		
		double s = (double)D/max;
		p(s);
	}
}
