package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Scanner;

class Pair<X extends Comparable<X>, Y extends Comparable<Y>> implements Comparable<Pair<X,Y>>{
	X first;
	Y second;
	
	public Pair(X first, Y second) {
		this.first = first;
		this.second = second;
	}

	public int compareTo(Pair<X,Y> a) {
		int ret = this.first.compareTo(a.first);
		return (ret != 0) ? ret : this.second.compareTo(a.second);
	}	
}

public class FRB_B {

	static String IN_FILE = null;
	static String OUT_FILE = null;

	static Scanner sc;
	static PrintStream out;

	// Stream related methods
	static void init() {
		if (IN_FILE != null) {
			try {
				sc = new Scanner(new File(IN_FILE));
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			sc = new Scanner(System.in);
		}

		if (OUT_FILE != null) {
			try {
				out = new PrintStream(OUT_FILE);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
		} else {
			out = System.out;
		}
	}
	
	static void close() {
		sc.close();
		out.close();
	}

	// Input methods
	static int i() {
		return sc.nextInt();
	}
	
	static long l() {
		return sc.nextLong();
	}

	static double d() {
		return sc.nextDouble();
	}

	static String s() {
		return sc.next();
	}
	
	static char[] chars() {
		return sc.next().toCharArray();
	}

	static String line() {
		return sc.nextLine();
	}

	// Output methods

	static void p(Object o) {
		out.print(o);
	}

	static void pl(Object o) {
		out.println(o);
	}

	static void pl() {
		out.println();
	}
	
	// Specify input files here
	
	static {
		//IN_FILE = "1B/in.txt";
		IN_FILE = "1B/B-small-attempt0.in";
		OUT_FILE = "1B/out.txt";

		init();
	}

	// Problem logic starts here

	static int N, R, O, Y, G, B, V;
	public static void main(String[] args) {
		int T = i();
		
		for (int t=1; t<=T; t++) {
			p("Case #" + t + ": ");
			solve();
			pl();
		}
		
		close();		
	}
	
	// Method that solve single test case
	static void pc(char c) {
		out.print(c);
		if (c == 'R' && G > 0){
			for(int i=0;i<G;i++) out.print("GR");
			G = 0;
		}
		
		if (c == 'Y' && V > 0){
			for(int i=0;i<V;i++) out.print("VY");
			Y = 0;
		}
	
		if (c == 'B' && O > 0){
			for(int i=0;i<O;i++) out.print("BO");
			B = 0;
		}
	}
	
	static void pc2(char a, char b, int n) {
		for(int i=0;i<n;i++) {
			p(a);
			p(b);
		}
	}

	static void solve() {
		N=i();
		R=i();
		O=i();
		Y=i();
		G=i();
		B=i();
		V=i();
		
		if (R>G) {
			R -= G;
		} else if (R == G && R + G == N) {
			pc2('R', 'G', N/2);
			return;
		} else if (G != 0) {
			p("IMPOSSIBLE");
			return;
		}
		
		if (Y>V) {
			Y -= V;
		} else if (Y == V && Y + V == N) {
			pc2('Y', 'V', N/2);
			return;
		} else if (V != 0){
			p("IMPOSSIBLE");
			return;
		}
		
		if (B>O) {
			B -= O;
		} else if (B == O && B + O == N) {
			pc2('B', 'O', N/2);
			return;
		} else if (O != 0){
			p("IMPOSSIBLE");
			return;
		}
		
		int fn, sn = 0, tn = 0, etn;
		char fc, sc = 0, tc = 0;
		
		if (R >= B && R >= Y && R <= B+Y) {
			fn = R;
			fc = 'R';
			if (B >= Y) {
				sn = B;
				sc = 'B';
				tn = Y;
				tc = 'Y';
			} else {
				sn = Y;
				sc = 'Y';
				tn = B;
				tc = 'B';
			}
			etn = tn - (fn-sn);
			tn -= etn;
		} else if (B >= R && B >= Y && B <= R + Y) {
			fn = B;
			fc = 'B';
			if (R >= Y) {
				sn = R;
				sc = 'R';
				tn = Y;
				tc = 'Y';
			} else {
				sn = Y;
				sc = 'Y';
				tn = R;
				tc = 'R';
			}
			etn = tn - (fn-sn);
			tn -= etn;
		} else if (Y >= B && Y >= R && Y <= B + R) {
			fn = Y;
			fc = 'Y';
			if (B >= R) {
				sn = B;
				sc = 'B';
				tn = R;
				tc = 'R';
			} else {
				sn = R;
				sc = 'R';
				tn = B;
				tc = 'B';
			}
			etn = tn - (fn-sn);
			tn -= etn;
		} else {
			p("IMPOSSIBLE");
			return;
		}
		
		for (int i=0;i<fn;i++) {
			pc(fc);
			if (etn > 0) {
				pc(tc);
				etn--;
			}
			if (sn > 0) {
				pc(sc);
				sn--;
			} else {
				pc(tc);
				tn--;
			}
		}
		
	}
}
