package gcj2017.qualificationround;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Comparator;
import java.util.PriorityQueue;

public class BathroomStalls {

    public static void main(String[] args)
    {
        try {
            //File inFile = new File("res/testcase/BathroomStalls/small-attempt0.in");
            //File outFile = new File("res/testcase/BathroomStalls/out-small-attempt0.txt");
            //File inFile = new File("res/testcase/BathroomStalls/C-small-1-attempt0.in");
            //File outFile = new File("res/testcase/BathroomStalls/out-C-small-1-attempt0.txt");
            File inFile = new File("res/testcase/BathroomStalls/C-small-2-attempt0.in");
            File outFile = new File("res/testcase/BathroomStalls/out-C-small-2-attempt0.txt");

            BufferedReader reader =
                    new BufferedReader(new InputStreamReader(new FileInputStream(inFile)));
            BufferedWriter writer =
                    new BufferedWriter(new OutputStreamWriter(new FileOutputStream(outFile)));

            BathroomStalls sol = new BathroomStalls();

            int testCases = Integer.parseInt(reader.readLine());
            for (int i = 0; i < testCases; i++) {
                String line = reader.readLine();
                int stalls = Integer.parseInt(line.split(" ")[0]);
                int person = Integer.parseInt(line.split(" ")[1]);
                int[] answer = sol.solution(stalls, person);
                // System.out.printf("%s : %s \n", number, answer);
                writer.write("Case #" + (i + 1) + ": " + answer[0] + " " + answer[1] + "\n");
            }
            writer.flush();
            reader.close();
            writer.close();
        } catch (Exception e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }

    public int[] solution(int stalls, int person)
    {
        int[] result = new int[] {0, 0};
        //max heap
        PriorityQueue<Integer> pq = new PriorityQueue<>(new Comparator<Integer>() {
            @Override
            public int compare(Integer o1, Integer o2)
            {
                return o2 - o1;
            }
        });
        pq.add(stalls);
        int max = -1;
        int min = stalls;
        while (person > 0) {
            int space = pq.poll();
            if (space % 2 == 0) {
                max = space/2;
                min = space/2 - 1;
            }else{
                max = space/2;
                min = space/2;
            }
            pq.add(max);
            pq.add(min);
            result[0] = max;
            result[1] = min;
            person--;
        }
        return result;
    }

}
