package gcj1c_a;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.Scanner;

/**
 *
 * @author Birch
 */
public class A implements Runnable {

    protected FileLoader inFile;
    protected Scanner in;
    protected StringBuilder out;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
	(new A()).run();
    }

    public A() {
	inFile = new FileLoader("src\\input.txt");
	out = new StringBuilder();
    }

    public void run() {
	try {
	    in = inFile.getScanner();
	    solve();
	} catch (FileNotFoundException fnfe) {
	    System.out.println("File not found. Exiting.");
	    System.out.println(fnfe);
	    fnfe.printStackTrace();
	}
    }

    //Commence overall magic
    protected void solve() {
	int totalTests = Integer.parseInt(in.nextLine());
	//For each case line, print the answer
	for (int i = 0; i < totalTests; i++) {
	    String[] entries = in.nextLine().split(" ");
	    int rows = Integer.parseInt(entries[0]);
	    int cols = Integer.parseInt(entries[1]);
	    char[][] board = new char[rows][cols];
	    for (int j = 0; j < rows; j++) {
		board[j] = in.nextLine().toCharArray();
	    }
	    String answer = printBoard(solveCase(board));
	    out.append("Case #").append(i + 1).append(": \n").append(answer == null ? "Impossible" : answer);
	    //If we're not at the end, we'll need a new line.
	    if (i + 1 != totalTests) {
		out.append('\n');
	    }
	}
	System.out.println(out);
    }

    //Commence case magic
    protected char[][] solveCase(char[][] board) {
	int rows = board.length;
	int cols = board[0].length;
	for (int i = 0; i < rows - 1; i++) {
	    for (int j = 0; j < cols - 1; j++) {
		if (board[i][j] == '#' && board[i + 1][j] == '#' && board[i][j + 1] == '#' && board[i + 1][j + 1] == '#') {
		    //We can stick it here
		    board[i][j] = '/';
		    board[i+1][j] = '\\';
		    board[i][j+1] = '\\';
		    board[i+1][j+1] = '/';
		}
	    }
	}
	return board;
    }

    protected String printBoard(char[][] board) {
	StringBuilder sb = new StringBuilder();
	for (int i = 0; i < board.length; i++) {
	    for (int j = 0; j < board[0].length; j++) {
		char c = board[i][j];
		if (c == '#') return null;
		sb.append(board[i][j]);
	    }
	    sb.append("\n");
	}
	return sb.toString();
    }

    //Get our file stuff from here. Each case instance loaded sequentially,
    //so not entirely worried about buffered streams.
    public class FileLoader {

	protected String filename;
	protected InputStream stream;
	protected Scanner scanner;

	public FileLoader(String filename) {
	    this.filename = filename;
	}

	public InputStream getStream() throws FileNotFoundException {
	    if (stream == null) {
		stream = new FileInputStream(filename);
	    }
	    return stream;
	}

	public Scanner getScanner() throws FileNotFoundException {
	    if (scanner == null) {
		scanner = new Scanner(this.getStream());
	    }
	    return scanner;
	}
    }
}
