package gcj1c_c;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.Scanner;

/**
 *
 * @author Birch
 */
public class C implements Runnable {

    protected FileLoader inFile;
    protected Scanner in;
    protected StringBuilder out;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
	(new C()).run();
    }

    public C() {
	inFile = new FileLoader("src\\input.txt");
	out = new StringBuilder();
    }

    public void run() {
	try {
	    in = inFile.getScanner();
	    solve();
	} catch (FileNotFoundException fnfe) {
	    System.out.println("File not found. Exiting.");
	    System.out.println(fnfe);
	    fnfe.printStackTrace();
	}
    }

    //Commence overall magic
    protected void solve() {
	int totalTests = Integer.parseInt(in.nextLine());
	//For each case line, print the answer
	for (int i = 0; i < totalTests; i++) {
	    long freq = solveCase(in.nextLine(), in.nextLine());
	    out.append("Case #").append(i + 1).append(": ").append(freq == -1 ? "NO" : freq);
	    //If we're not at the end, we'll need a new line.
	    if (i + 1 != totalTests) {
		out.append('\n');
	    }
	}
	System.out.println(out);
    }

    //Commence case magic
    protected long solveCase(String line1, String line2) {
	long freq = -1;
	String[] firstL = line1.split(" ");
	String[] secondL = line2.split(" ");
	long fmin = Long.parseLong(firstL[1]);
	long fmax = Long.parseLong(firstL[2]);
	long[] fOthers = new long[Integer.parseInt(firstL[0])];
	for (int i = 0; i < fOthers.length; i++){
	    fOthers[i] = Long.parseLong(secondL[i]);
	}
	boolean righto = true;

	for (long i = fmin; i <= fmax; i++){
	    righto=true;
	    for (int j = 0; j < fOthers.length; j++){
		long derp = fOthers[j];
		if (superMod(i, derp) != 0){
		    righto = false;
		    break;
		}
	    }
	    if (righto) return i;
	}


	return freq;
    }

    protected long superMod(long first, long second){
	long a;
	long b;
	if (first > second) {
	    a = first;
	    b = second;
	} else {
	    b = first;
	    a = second;
	}
	return a % b;
    }

    //Get our file stuff from here. Each case instance loaded sequentially,
    //so not entirely worried about buffered streams.
    public class FileLoader {

	protected String filename;
	protected InputStream stream;
	protected Scanner scanner;

	public FileLoader(String filename) {
	    this.filename = filename;
	}

	public InputStream getStream() throws FileNotFoundException {
	    if (stream == null) {
		stream = new FileInputStream(filename);
	    }
	    return stream;
	}

	public Scanner getScanner() throws FileNotFoundException {
	    if (scanner == null) {
		scanner = new Scanner(this.getStream());
	    }
	    return scanner;
	}
    }
}
