package gcj1aa;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.Scanner;

/**
 *
 * @author Birch
 */
public class A implements Runnable {

    protected FileLoader inFile;
    protected Scanner in;
    protected StringBuilder out;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
	(new A()).run();
    }

    public A() {
	inFile = new FileLoader("src\\input.txt");
	out = new StringBuilder();
    }

    public void run() {
	try {
	    in = inFile.getScanner();
	    solve();
	} catch (FileNotFoundException fnfe) {
	    System.out.println("File not found. Exiting.");
	    System.out.println(fnfe);
	    fnfe.printStackTrace();
	}
    }

    //Commence overall magic
    protected void solve() {
	int totalTests = Integer.parseInt(in.nextLine());
	//For each case line, print the answer
	for (int i = 0; i < totalTests; i++) {
	    out.append("Case #").append(i + 1).append(": ").append(solveCase(in.nextLine()) ? "Possible" : "Broken");
	    //If we're not at the end, we'll need a new line.
	    if (i + 1 != totalTests) {
		out.append('\n');
	    }
	}
	System.out.println(out);
    }

    //Commence case magic
    protected boolean solveCase(String inLine) {
	String[] entries = inLine.split(" ");
	int[] values = new int[3];
	values[0] = Integer.parseInt(entries[0]);
	values[1] = Integer.parseInt(entries[1]);
	values[2] = Integer.parseInt(entries[2]);

	if (values[1] < 100 && values[2] == 100) {
	    return false;
	}

	for (int i = 1; i <= values[0]; i++) {
	    //Find the amount of games we'd have to win to get that percentage today
	    double gamesWonTodayDouble = (values[1] * i) / 100.0;
	    int gamesWonTodayInt = (int) gamesWonTodayDouble;
	    //Make sure that was an int
	    if (gamesWonTodayDouble != gamesWonTodayInt) {
		continue;
	    }
	    //For more than won today, but less than max (small A)
	    for (int j = i; j <= 100; j++) {
		//What's the percentage of that total games
		double gamesWonTotalDouble = (values[2] * j) / 100.0;
		//Is it an integer percentage
		int gamesWonTotalInt = (int) gamesWonTotalDouble;
		//Is it more than what we won today
		if (gamesWonTotalInt < gamesWonTodayInt) {
		    continue;
		}
		//Yes!
		return true;

	    }

	}
	return false;
    }

    //Get our file stuff from here. Each case instance loaded sequentially,
    //so not entirely worried about buffered streams.
    public class FileLoader {

	protected String filename;
	protected InputStream stream;
	protected Scanner scanner;

	public FileLoader(String filename) {
	    this.filename = filename;
	}

	public InputStream getStream() throws FileNotFoundException {
	    if (stream == null) {
		stream = new FileInputStream(filename);
	    }
	    return stream;
	}

	public Scanner getScanner() throws FileNotFoundException {
	    if (scanner == null) {
		scanner = new Scanner(this.getStream());
	    }
	    return scanner;
	}
    }
}
