package net.jbirch.gcj12qual;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.Scanner;

/**
 *
 * @author Birch
 */
public class A implements Runnable {

    protected FileLoader inFile;
    protected Scanner in;
    protected char[] transposedCharacters = "yhesocvxduiglbkrztnwjpfmaq".toCharArray();

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        (new A()).run();
    }

    public A() {
        inFile = new FileLoader("src\\main\\resources\\A.txt");
    }

    public void run() {
        try {
            in = inFile.getScanner();
            solve();
        } catch (FileNotFoundException fnfe) {
            System.out.println("File not found. Exiting.");
            System.out.println(fnfe);
        }
    }

    //Commence overall magic
    protected void solve() {
        int cases = Integer.valueOf(in.nextLine());
        for (int i = 0; i < cases; i++) {
            System.out.print("Case #" + (i + 1) + ": ");
            solve(in.nextLine());
        }
    }

    protected void solve(String line) {
        StringBuilder sb = new StringBuilder();
        char[] breakItUp = line.toCharArray();
        for (char c : breakItUp) {
            sb.append(c >= 97 ? transposedCharacters[c - 97] : ' ');
        }
        System.out.println(sb.toString());
    }


    //Get our file stuff from here. Each case instance loaded sequentially,
    //so not entirely worried about buffered streams.
    public class FileLoader {

        protected String filename;
        protected InputStream stream;
        protected Scanner scanner;

        public FileLoader(String filename) {
            this.filename = filename;
        }

        public InputStream getStream() throws FileNotFoundException {
            if (stream == null) {
                stream = new FileInputStream(filename);
            }
            return stream;
        }

        public Scanner getScanner() throws FileNotFoundException {
            if (scanner == null) {
                scanner = new Scanner(this.getStream());
            }
            return scanner;
        }
    }
}
