import java.util.*;

class Main {
	public static void main (String args[]) {
		Scanner sc = new Scanner(System.in);
		int numCase = sc.nextInt();
		for (int h = 1; h <= numCase; h++) {
			int numHorse = sc.nextInt();
			int [] colors = new int[6];
			colors[0] = sc.nextInt(); // r
			colors[1] = sc.nextInt(); // o
			colors[2] = sc.nextInt(); // y
			colors[3] = sc.nextInt(); // g
			colors[4] = sc.nextInt(); // b
			colors[5] = sc.nextInt(); // v
			
			char [] c = {'R', 'O', 'Y', 'G', 'B', 'V'};
			char [] stalls = new char[numHorse];
			boolean possible = true;
			int i = 0;
			int position = 1;
			while (i < numHorse && position <= 6) {
				int temp = setHorse(i, colors, stalls, position, (position+3)%6, 'O', 'B');
				if (temp == -1) {
					possible = false;
					break;
				}
				if (temp == i) {
					position+=2;
				}
				
				i = temp;
			}
			
			for (int j = 0; j < colors.length; j++) {
				if (colors[j] < 0) {
					possible = false;
					break;
				}
			}
			
			if (i == 0) {
				int t = greater(colors, 0, 2, 4);
				stalls[i++] = c[t];
				colors[t]--;
			}
			
			char atZero = stalls[0];
			int zero = atZero == 'R' ? 0 : atZero == 'Y' ? 2 : 4;
			int x = atZero == 'R' ? 4 : 0;
			int y = atZero == 'Y' ? 4 : 2;
			while (i < numHorse) {
				if (stalls[i-1] == atZero) {
					int t = greater(colors, x, y);
					stalls[i++] = c[t];
					colors[t]--;
					continue;
				}
				
				if (colors[zero] > 0) {
					stalls[i++] = c[zero];
					colors[zero]--;
					continue;
				}
				
				if (stalls[i-1] == c[x]) {
					stalls[i++] = c[y];
					colors[y]--;
					continue;
				}
				
				
				stalls[i++] = c[x];
				colors[x]--;
			}
			
			for (int j = 0; j < colors.length; j++) {
				if (colors[j] < 0) {
					possible = false;
					break;
				}
			}
			
			// System.out.println("Stalls: " + Arrays.toString(stalls));
			if (stalls[0] == stalls[stalls.length-1]) {
				possible = false;
			}
			
			String str = "IMPOSSIBLE";
			if (possible)
				str = new String(stalls);
			
			System.out.printf("Case #%d: %s\n", h, str);
		}
	}
	
	public static int setHorse(int i, int [] colors, char [] stalls, int x, int y, char charX, char charY) {
		if (colors[x] > 0) {
			if (i > 0 && stalls[i-1] == charY) {
				stalls[i++] = charX;
				colors[x]--;
				if (i >= stalls.length) {
					if (stalls[0] == charY) {
						return i;
					}
					
					return -1;
				}
				stalls[i++] = charY;
				colors[y]--;
				return i;
			}
			
			stalls[i++] = charY;
			colors[y]--;
			stalls[i++] = charX;
			colors[x]--;
			if (i >= stalls.length) {
				if (stalls[0] == charY) {
					return i;
				}
				
				return -1;
			}
			stalls[i++] = charY;
			colors[y]--;
			return i;
		}
		return i;
	}
	
	public static int greater(int [] colors, int x, int y) {
		if (colors[x] > colors[y]) 
			return x;
		return y;
	}
	
	public static int greater(int [] colors, int x, int y, int z) {
		int maxT = x;
		int max = colors[x];
		if (max < colors[y]) {
			max = colors[y];
			maxT = y;
		}
		
		if (max < colors[z]) {
			max = colors[z];
			maxT = z;
		}
		
		return maxT;
	}
}