package birgit.vera.schmidt.codejam2011.round1c;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Arrays;

public class PerfectHarmony {
  public static void main(String[] args) throws NumberFormatException,
      IOException {
    File file = new File("C-small-attempt1.in");
    System.out.println(file.getAbsolutePath());
    BufferedReader in = new BufferedReader(new FileReader(file));
    PrintStream out = new PrintStream(new FileOutputStream(new File(file
        .getName().replace(".in", ".out"))));

    int t = Integer.parseInt(in.readLine());
    for (int testcase = 1; testcase <= t; testcase++) {
      BigInteger result = solve(in);
      out.println("Case #" + testcase + ": " + (result != null ? result : "NO"));
    }
  }

  public static BigInteger solve(BufferedReader in) throws IOException {
    String line = in.readLine();
    String[] parts = line.split(" ");
    int n = Integer.parseInt(parts[0]);
    BigInteger l = new BigInteger(parts[1]);
    BigInteger h = new BigInteger(parts[2]);
    
    line = in.readLine();
    parts = line.split(" ");
    BigInteger[] players = new BigInteger[n];
    for (int i = 0; i < n; i++) {
      players[i] = new BigInteger(parts[i]);
    }
    Arrays.sort(players);

    // Optimization of start and end index would be possible,
    // but at least one testcase will have l = 1, h = 10^16 anyways.
    // OTOH...
    
    int minIndex = 0;
    while ((minIndex < n) && (l.compareTo(players[minIndex]) > 0)) {
      minIndex++;
    }
    
    int maxIndex = n;
    while ((maxIndex > 0) && (h.compareTo(players[maxIndex-1]) < 0)) {
      maxIndex--;
    }
    
    if (minIndex > maxIndex) {
      // just in case...
      throw new RuntimeException("Something in my theory must be very very wrong");
    }
    
    for (int index = minIndex; index <= maxIndex; index++) {
      BigInteger lcm = BigInteger.ONE;
      for (int i = 0; i < index; i++) {
        lcm = lcm(lcm, players[i]);
      }
      BigInteger gcd = null;
      for (int i = index; i < n; i++) {
        if (gcd == null) {
          gcd = players[i];
        } else {
          gcd = gcd.gcd(players[i]);
        }
      }
      
      if ((gcd == null) || (gcd.remainder(lcm).equals(BigInteger.ZERO))) {
        BigInteger result = findFrequency(lcm, gcd, l, h);
        if (result != null) {
          return result;
        }
      }
    }

    return null;
  }

  private static BigInteger findFrequency(BigInteger lcm, BigInteger gcd,
      BigInteger l, BigInteger h) {
    if (gcd != null) {
      BigInteger factor = gcd.divide(lcm);
      BigInteger minFactor = (l.compareTo(lcm) < 0 ? BigInteger.ONE : 
        (l.remainder(lcm).compareTo(BigInteger.ZERO) == 0 ? l.divide(lcm) : l.divide(lcm).add(BigInteger.ONE)));
      BigInteger maxFactor = h.divide(lcm).min(factor);
      for (BigInteger f = minFactor; f.compareTo(maxFactor) <= 0; f = f.add(BigInteger.ONE)) {
        if (factor.remainder(f).equals(BigInteger.ZERO)) {
          return lcm.multiply(f);
        }
      }
      return null;
    } else {
      if (h.compareTo(lcm) < 0) {
        return null;
      } else if (l.remainder(lcm).equals(BigInteger.ZERO)) {
        return l;
      } else {
        BigInteger result = lcm.multiply(l.divide(lcm).add(BigInteger.ONE));
        if (result.compareTo(h) <= 0) {
          return result;
        } else {
          return null;
        }
      }
    }
  }

  private static BigInteger lcm(BigInteger a, BigInteger b) {
    return a.multiply(b).divide(a.gcd(b));
  }
}
