package birgit.vera.schmidt.codejam2011.qualification;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;

public class Magicks {
  public static void main(String[] args) throws NumberFormatException,
      IOException {
    File file = new File("B-large.in");
    System.out.println(file.getAbsolutePath());
    BufferedReader in = new BufferedReader(new FileReader(file));
    PrintStream out = new PrintStream(new FileOutputStream(new File(file
        .getName().replace(".in", ".out"))));

    int t = Integer.parseInt(in.readLine());
    for (int testcase = 1; testcase <= t; testcase++) {
      String[] sequence = in.readLine().split(" ");
      out.print("Case #" + testcase + ": [");
      String result = solve(sequence);
      for (int i = 0; i < result.length(); i++) {
        if (i > 0) {
          out.print(", ");
        }
        out.print(result.substring(i, i+1));
      }
      out.println("]");
    }
  }

  public static int map(String element) {
    if ("Q".equals(element)) {
      return 0;
    } else if ("W".equals(element)) {
      return 1;
    } else if ("E".equals(element)) {
      return 2;
    } else if ("R".equals(element)) {
      return 3;
    } else if ("A".equals(element)) {
      return 4;
    } else if ("S".equals(element)) {
      return 5;
    } else if ("D".equals(element)) {
      return 6;
    } else if ("F".equals(element)) {
      return 7;
    } else {
      return -1;
    }
  }
  
  public static String solve(String[] sequence) {
    String[][] combinations = new String[8][8];
    boolean[][] oppositions = new boolean[8][8];
    for (int i = 0; i < 8; i++) {
      for (int j = 0; j < 8; j++) {
        combinations[i][j] = null;
        oppositions[i][j] = false;
      }
    }
    
    int c = Integer.parseInt(sequence[0]);
    for (int i = 1; i <= c; i++) {
      String combination = sequence[i];
      String a = combination.substring(0, 1);
      String b = combination.substring(1, 2);
      String result = combination.substring(2, 3);
      combinations[map(a)][map(b)] = result;
      combinations[map(b)][map(a)] = result;
    }
    
    int d = Integer.parseInt(sequence[c+1]);
    for (int i = c+2; i <= c+d+1; i++) {
      String opposition = sequence[i];
      String a = opposition.substring(0, 1);
      String b = opposition.substring(1, 2);
      oppositions[map(a)][map(b)] = true;
      oppositions[map(b)][map(a)] = true;
    }
    
    String input = sequence[c+d+3];
    
    int[] count = new int[8];
    for (int i = 0; i < 8; i++) {
      count[i] = 0;
    }
    String result = "";
    
    for (int i = 0; i < input.length(); i++) {
      String b = input.substring(i, i+1);
      
      boolean combinationFound = false;
      // check combination
      if (result.length() > 0) {
        String last = result.substring(result.length() - 1, result.length());
        if (map(last) >= 0) {
          if (combinations[map(last)][map(b)] != null) {
            count[map(last)]--;
            result = result.substring(0, result.length() - 1) + combinations[map(last)][map(b)];
            combinationFound = true;
          }
        }
      }
      
      boolean oppositionFound = false;
      // check opposition
      if (!combinationFound) {
        int mapped = map(b);
        count[mapped]++;
        if (count[mapped] == 1) {
          for (int j = 0; j < 8; j++) {
            if (oppositions[j][mapped] && count[j] > 0) {
              oppositionFound = true;
              result = "";
              for (int k = 0; k < 8; k++) {
                count[k] = 0;
              }
              break;
            }
          }
        }
      }
      
      if (!oppositionFound && !combinationFound) {
        result = result + b;
      }
    }
    
    return result;
  }
}
