package qualificationround;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;

public class C {

  public static void main(String[] args) throws IOException {
    File file = new File("C-large.in");
    BufferedReader in = new BufferedReader(new FileReader(file));
    PrintStream out = new PrintStream(new FileOutputStream(new File("C-large.out")));

    int t = Integer.parseInt(in.readLine());
    for (int i = 0; i < t; i++) {
      BigInteger result = solveCase(in.readLine(), in.readLine());
      out.println("Case #" + (i+1) + ": " + result.toString());
      System.out.println("Case #" + (i+1) + ": " + result.toString());
    }
  }
  
  private static BigInteger solveCase(String parameters, String queue) {
    String[] parts = parameters.split(" ");
    BigInteger r = new BigInteger(parts[0]);
    BigInteger k = new BigInteger(parts[1]);
    int n = Integer.parseInt(parts[2]);
    BigInteger g[] = new BigInteger[n];
    parts = queue.split(" ");
    for (int i = 0; i < n; i++) {
      g[i] = new BigInteger(parts[i]);
    }
    
    int[] nextstart = new int[n];
    BigInteger[] passengers = new BigInteger[n];
    // Find next queue beginnings.
    // This could be done faster if we needed to.
    System.out.println(queue);
    for (int start = 0; start < n; start++) {
      BigInteger people = BigInteger.ZERO;
      int end = start;
      if (g[end].compareTo(k) <= 0) {
        do {
          people = people.add(g[end]);
          end = (end + 1) % n;
        } while ((people.add(g[end]).compareTo(k) <= 0) && (end != start));
      }
      nextstart[start] = end;
      passengers[start] = people;
      System.out.println("From " + start + " to " + end + " (with " + people.toString() + " passengers)");
    }
    
    BigInteger income = BigInteger.ZERO;
    
    boolean[] circle = new boolean[n];
    int current = 0;
    // Find beginning of circle
    while ((r.compareTo(BigInteger.ZERO) > 0) && (!circle[current])) {
      income = income.add(passengers[current]);
      circle[current] = true;
      r = r.subtract(BigInteger.ONE);
      current = nextstart[current];
    }
    if (r.compareTo(BigInteger.ZERO) == 0) {
      return income;
    }
    int circlestart = current;
    System.out.println("Circle start: " + circlestart);
    
    // Calculate circle length
    BigInteger circleincome = passengers[current];
    int circlelength = 1;
    current = nextstart[current];
    while (current != circlestart) {
      circleincome = circleincome.add(passengers[current]);
      current = nextstart[current];
      circlelength++;
    }
    System.out.println("Circle length: " + circlelength);
    System.out.println("Circle income: " + circleincome.toString());
    
    // Calculate number of circles
    BigInteger rounds = r.divide(BigInteger.valueOf(circlelength));
    System.out.println("Circle rounds: " + rounds);
    income = income.add(circleincome.multiply(rounds));
    r = r.subtract(rounds.multiply(BigInteger.valueOf(circlelength)));

    // Calculate remaining circle part
    while (r.compareTo(BigInteger.ZERO) > 0) {
      income = income.add(passengers[current]);
      r = r.subtract(BigInteger.ONE);
      current = nextstart[current];
    }    
   
    return income;
  }

}
