package firstround;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

public class A {

  public static enum Outcome {NEITHER, BOTH, RED, BLUE};
  public static enum Stone {R, B, E};
  
  public static void main(String[] args) throws NumberFormatException, IOException {
    File file = new File("A-small-attempt2.in");
//    File file = new File("A.in");
//    File file = new File("A-large.in");
    BufferedReader in = new BufferedReader(new FileReader(file));
    PrintStream out = new PrintStream(new FileOutputStream(new File("A-small-attempt2.out")));
//    PrintStream out = new PrintStream(new FileOutputStream(new File("A.out")));
//  PrintStream out = new PrintStream(new FileOutputStream(new File("A-large.out")));

//    String test = in.readLine();
    
    int t = Integer.parseInt(in.readLine());
    for (int c = 0; c < t; c++) {
      String[] parts = in.readLine().split(" ");
      int n = Integer.parseInt(parts[0]);
      int k = Integer.parseInt(parts[1]);
      Stone[][] board = new Stone[n][n];
      for (int i = 0; i < n; i++) {
        String line = in.readLine();
        for (int j = 0; j < n; j++) {
          String letter = line.substring(j, j+1);
          board[i][j] = ("R".equals(letter) ? Stone.R : ("B".equals(letter) ? Stone.B : Stone.E));
        }
      }
      Outcome outcome = calculateOutcomeRotated(board, k);
      out.println("Case #" + (c+1) + ": " + outcome.toString());
      System.out.println("k = "+ k + ", result: " + outcome.toString());
    }
  }
  
  private static Outcome calculateOutcomeRotated(Stone[][] board, int k) {
    System.out.println("Board before:");
    printBoard(board);
    Stone[][] newBoard = new Stone[board.length][board.length];
    for (int i = 0; i < board.length; i++) {
      for (int j = 0; j < board.length; j++) {
        newBoard[i][j] = Stone.E;
      }
    }
    for (int r = 0; r < board.length; r++) {
      int count = 0;
      for (int c = board.length -1; c >= 0; c--) {
        if (board[r][c] != Stone.E) {
//          System.out.println("Found an " + board[r][c].toString() + " at ["+r+"]["+c+"], write it to ["+(board.length-1-count)+"]["+(board.length-r-1)+"]");
          newBoard[board.length-1-(count++)][board.length-r-1] = board[r][c];
        }
      }
    }
    System.out.println("Board rotated:");
    printBoard(newBoard);
    return calculateOutcome(newBoard, k);
  }
  
  private static void printBoard(Stone[][] board) {
    for (int i = 0; i < board.length; i++) {
      for (int j = 0; j < board.length; j++) {
        if (board[i][j] == Stone.E) {
          System.out.print(".");
        } else {
          System.out.print((board[i][j] == Stone.R ? "R" : "x"));
        }
      }
      System.out.println();
    }
  }
  
  private static Outcome calculateOutcome(Stone[][] board, int k) {
    boolean red = false;
    boolean blue = false;

    for (int row = 0; row < board.length; row++) {
      LineCounter cr = new LineCounter(Stone.R);
      LineCounter cb = new LineCounter(Stone.B);
      for (int i = 0; i < board[row].length; i++) {
        cr.feed(board[row][i]);
        cb.feed(board[row][i]);
      }
      red |= (cr.getMax() >= k);
      blue |= (cb.getMax() >= k);
    }
    
    for (int i = 0; i < board[0].length; i++) {
      LineCounter cr = new LineCounter(Stone.R);
      LineCounter cb = new LineCounter(Stone.B);
      for (int row = 0; row < board.length; row++) {
          cr.feed(board[row][i]);
          cb.feed(board[row][i]);
      }
      red |= (cr.getMax() >= k);
      blue |= (cb.getMax() >= k);
    }
    
    for (int offset = -board.length; offset <= board.length; offset++) {
      LineCounter cr = new LineCounter(Stone.R);
      LineCounter cb = new LineCounter(Stone.B);
      for (int col = 0; col < board.length; col++) {
        if ((col + offset < board.length) && (col + offset >= 0)) {
          cr.feed(board[col][col+offset]);
          cb.feed(board[col][col+offset]);
        }
        red |= (cr.getMax() >= k);
        blue |= (cb.getMax() >= k);
      }
    }
    
    for (int offset = 0; offset <= 2*board.length; offset++) {
      LineCounter cr = new LineCounter(Stone.R);
      LineCounter cb = new LineCounter(Stone.B);
      for (int col = 0; col < board.length; col++) {
        if ((offset - col < board.length) && (offset - col>= 0)) {
          cr.feed(board[col][offset-col]);
          cb.feed(board[col][offset-col]);
        }
        red |= (cr.getMax() >= k);
        blue |= (cb.getMax() >= k);
      }
    }
    
    if (red) {
      if (blue) {
        return Outcome.BOTH;
      } else {
        return Outcome.RED;
      }
    } else {
      if (blue) {
        return Outcome.BLUE;
      } else {
        return Outcome.NEITHER;
      }
    }
      
  }
  
  private static class LineCounter {
    int max = 0;
    int currentmax = 0;
    boolean lastFilled = false;
    Stone type;
    
    public LineCounter(Stone type) {
      this.type = type;
    }
    
    public void feed(Stone stone) {
      if (stone == type) {
        if (lastFilled) {
          currentmax++;
          if (currentmax > max) {
            max = currentmax;
          }
        } else {
          currentmax = 1;
          if (currentmax > max) {
            max = currentmax;
          }
        }
        lastFilled = true;
      } else {
        lastFilled = false;
      }
    }
    
    public int getMax() {
      return max;
    }
  }
}
