package birgit.vera.schmidt.codejam2011.round1c;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;

public class SquareTiles {
  public static void main(String[] args) throws NumberFormatException,
      IOException {
    File file = new File("A-large.in");
    System.out.println(file.getAbsolutePath());
    BufferedReader in = new BufferedReader(new FileReader(file));
    PrintStream out = new PrintStream(new FileOutputStream(new File(file
        .getName().replace(".in", ".out"))));

    int t = Integer.parseInt(in.readLine());
    for (int testcase = 1; testcase <= t; testcase++) {
      out.print("Case #" + testcase + ":\n" + solve(in));
    }
  }

  public static String solve(BufferedReader in) throws IOException {
    String line = in.readLine();
    String[] parts = line.split(" ");
    int r = Integer.parseInt(parts[0]);
    int c = Integer.parseInt(parts[1]);
    String[][] field = new String[r][c];
    for (int i = 0; i < r; i++) {
      line = in.readLine();
      for (int j = 0; j < c; j++) {
        field[i][j] = line.substring(j, j+1);
      }
    }

    for (int i = 0; i < r; i++) {
      for (int j = 0; j < c; j++) {
        if ("#".equals(field[i][j])) {
          boolean possible = coverBlue(field, i, j);
          if (!possible) {
            return "Impossible\n";
          }
        }
      }
    }
    
    StringBuilder str = new StringBuilder();
    for (int i = 0; i < r; i++) {
      for (int j = 0; j < c; j++) {
        str.append(field[i][j]);
      }
      str.append("\n");
    }
    

    return str.toString();
  }

  private static boolean coverBlue(String[][] field, int i, int j) {
    boolean possible = true;
    possible &= fillBlueIfPossible(field, i, j, "/");
    possible &= fillBlueIfPossible(field, i, j+1, "\\");
    possible &= fillBlueIfPossible(field, i+1, j, "\\");
    possible &= fillBlueIfPossible(field, i+1, j+1, "/");
    return possible;
  }

  private static boolean fillBlueIfPossible(String[][] field, int i, int j,
      String string) {
    if (i >= field.length) {
      return false;
    }
    if (j >= field[i].length) {
      return false;
    }
    
    if (!"#".equals(field[i][j])) {
      return false;
    }
    field[i][j] = string;
    return true;
  }
}





















