package secondround;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;

public class C {

  public static void main(String[] args) throws NumberFormatException, IOException {
    File file = new File("C-small-attempt0.in");
    BufferedReader in = new BufferedReader(new FileReader(file));
    PrintStream out = new PrintStream(new FileOutputStream(new File("C.out")));

    int t = Integer.parseInt(in.readLine());
    for (int c = 0; c < t; c++) {
      int result = solveCase(in);
      out.println("Case #" + (c+1) + ": " + result);
      System.out.println("Case #" + (c+1) + ": " + result);
    }
  }
  
  private static int solveCase(BufferedReader in) throws IOException {
    int r = Integer.parseInt(in.readLine());
    Rectangle[] rects = new Rectangle[r];
    boolean[] used = new boolean[r];
    for (int i = 0; i < r; i++) {
      rects[i] = new Rectangle(in.readLine());
      used[i] = false;
    }
    
    int maxTime = 0;
    for (int i = 0; i < r; i++) {
      if (!used[i]) {
        Rectangle rect = rects[i];
        int minx = rect.x1;
        int maxx = rect.x2;
        int miny = rect.y1;
        int maxy = rect.y2;
        used[i] = true;
        for (int j = i+1; j < r; j++) {
          if (rect.overlap(rects[j])) {
            used[j] = true;
            minx = Math.min(minx, rects[j].x1);
            maxx = Math.max(maxx, rects[j].x2);
            miny = Math.min(miny, rects[j].y1);
            maxy = Math.max(maxy, rects[j].y2);
          }
        }
        int time = maxx - minx + maxy - miny + 1;
        if (time > maxTime) {
          maxTime = time;
        }
      }
    }
    return maxTime;
  }
  
  static class Rectangle {
    int x1;
    int x2;
    int y1;
    int y2;
    public Rectangle(int x1, int y1, int x2, int y2) {
      this.x1 = x1;
      this.x2 = x2;
      this.y1 = y1;
      this.y2 = y2;
    }
    
    public Rectangle(String rect) {
      String[] parts = rect.split(" ");
      this.x1 = Integer.parseInt(parts[0]);
      this.x2 = Integer.parseInt(parts[2]);
      this.y1 = Integer.parseInt(parts[1]);
      this.y2 = Integer.parseInt(parts[3]);
    }
    
    public boolean overlap(Rectangle r) {
      if (overlapX(r) && overlapY(r)) {
        return true;
      }
      if (touchX(r) && overlapY(r)) {
        return true;
      }
      if (overlapX(r) && touchY(r)) {
        return true;
      }
      return false;
    }
    
    public boolean overlapX(Rectangle r) {
      if (x1 < r.x1) {
        return (x2 >= r.x1);
      } else if (x1 == r.x1) {
        return true;
      } else {
        return (r.x2 >= x1);
      }
    }
    public boolean overlapY(Rectangle r) {
      if (y1 < r.y1) {
        return (y2 >= r.y1);
      } else if (y1 == r.y1) {
        return true;
      } else {
        return (r.y2 >= y1);
      }
    }
    public boolean touchX(Rectangle r) {
      if (x1 == r.x2+1) {
        return true;
      }
      if (x2+1 == r.x1) {
        return true;
      }
      return false;
    }
    public boolean touchY(Rectangle r) {
      if (y1 == r.y2+1) {
        return true;
      }
      if (y2+1 == r.y1) {
        return true;
      }
      return false;
    }
  }
}
