package birgit.vera.schmidt.codejam2011.qualification;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;

public class BotTrust {
  public static void main(String[] args) throws NumberFormatException,
      IOException {
    File file = new File("A-large.in");
    System.out.println(file.getAbsolutePath());
    BufferedReader in = new BufferedReader(new FileReader(file));
    PrintStream out = new PrintStream(new FileOutputStream(new File(file
        .getName().replace(".in", ".out"))));

    int t = Integer.parseInt(in.readLine());
    for (int testcase = 1; testcase <= t; testcase++) {
      String[] sequence = in.readLine().split(" ");
      out.println("Case #" + testcase + ": " + solve(sequence));
    }
  }

  public static int solve(String[] sequence) {
    int n = Integer.parseInt(sequence[0]);
    boolean[] orange = new boolean[n];
    int[] button = new int[n];
    for (int i = 0; i < n; i++) {
      orange[i] = "O".equals(sequence[2 * i + 1]);
      button[i] = Integer.parseInt(sequence[2 * i + 2]);
    }

    int opos = 1;
    int otime = 0;
    int bpos = 1;
    int btime = 0;

    for (int i = 0; i < n; i++) {
      if (orange[i]) {
        int arrivalTime = otime + Math.abs(button[i] - opos) + 1;
        int readyTime = btime + 1;
        otime = Math.max(arrivalTime, readyTime);
        opos = button[i];
      } else {
        int arrivalTime = btime + Math.abs(button[i] - bpos) + 1;
        int readyTime = otime + 1;
        btime = Math.max(arrivalTime, readyTime);
        bpos = button[i];
      }
    }

    return Math.max(otime, btime);
  }
}
