package birgit.vera.schmidt.googlecodejam2012.qual;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

// Just forgive the coding style. It's a contest.
public class A {
  // ugh, global variables
  private static Map<Character, Character> mapping = new HashMap<Character, Character>();

  public static void main(String[] args) {
    learnMapping(
        "our language is impossible to understand",
        "ejp mysljylc kd kxveddknmc re jsicpdrysi");
    learnMapping(
        "there are twenty six factorial possibilities",
        "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd");
    learnMapping(
        "so it is okay if you want to just give up",
        "de kr kd eoya kw aej tysr re ujdr lkgc jv");
    learnMapping(
        "a zoo",
        "y qee");
    // Guess how I found that one out...
    learnMapping(
        "q",
        "z");

    // Let's see what we got...
    List<Character> mappedLetters = new ArrayList<Character>(mapping.keySet());
    System.out.println("Number of mapped letters: " + mappedLetters.size());
    Collections.sort(mappedLetters);
    for (Character c : mappedLetters) {
      System.out.println(c + " --> " + mapping.get(c));
    }

    // For convenience...
    mapping.put(' ', ' ');

    // Time to apply it to the test cases
    try {
      String filename = "A-small-attempt0";
      BufferedReader in = new BufferedReader(new FileReader(new File(filename + ".in")));
      PrintStream out = new PrintStream(new FileOutputStream(new File(filename + ".out")));

      int t = Integer.parseInt(in.readLine());

      for (int i = 0; i < t; i++) {
        out.println("Case #" + (i+1) + ": " + applyMapping(in.readLine()));
      }

    } catch (IOException e) {
      // Just crash.
      e.printStackTrace();
    }
  }

  private static void learnMapping(String english, String googlerese) {
    for (int i = 0; i < english.length(); i++) {
      char e = english.charAt(i);
      char g = googlerese.charAt(i);

      if (e != ' ') {
        // Just making sure that the input is correct...
        // Never trust those contest creators or your ability to copy and paste...
        if (mapping.containsKey(g)) {
          if (mapping.get(g) != e) {
            throw new RuntimeException(g + " should be mapped to " + e + " and " + mapping.get(g));
          }
        }

        mapping.put(g, e);
      }
    }
  }

  private static String applyMapping(String english) {
    StringBuilder res = new StringBuilder();
    for (int i = 0; i < english.length(); i++) {
      res.append(mapping.get(english.charAt(i)));
    }
    return res.toString();
  }
}
