package secondround;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Arrays;

public class Bhard {

  public static void main(String[] args) throws NumberFormatException, IOException {
//    File file = new File("B-test.in");
    File file = new File("B-large.in");
    BufferedReader in = new BufferedReader(new FileReader(file));
//    PrintStream out = new PrintStream(new FileOutputStream(new File("B-small-attempt0.out")));
//    PrintStream out = new PrintStream(new FileOutputStream(new File("B.out")));
    PrintStream out = new PrintStream(new FileOutputStream(new File("B-large.out")));

//    String test = in.readLine();
    
    int t = Integer.parseInt(in.readLine());
    for (int c = 0; c < t; c++) {
      BigInteger result = solveCase(in);
      out.println("Case #" + (c+1) + ": " + result);
      System.out.println("Case #" + (c+1) + ": " + result);
    }
  }
  
  private static BigInteger solveCase(BufferedReader in) throws IOException {
    int p = Integer.parseInt(in.readLine());
    int pp = (int) Math.pow(2, p);
    int m[] = new int[pp];
    String[] parts = in.readLine().split(" ");
    for (int i = 0; i < pp; i++) {
      m[i] = Integer.parseInt(parts[i]);
    }
    BigInteger cost[][] = new BigInteger[p][pp]; 
    for (int i = 0; i < p; i++) {
      parts = in.readLine().split(" ");
      for (int j = 0; j < parts.length; j++) {
        cost[i][j] = new BigInteger(parts[j]); 
      }
    }
    
    return countPartial(p, 0, m, cost, p);
  }
  
  private static BigInteger countPartial(int pow, int interval, int[] m, BigInteger[][] cost, int p) {
    BigInteger result1 = BigInteger.TEN;
    boolean skipPossible = skipPossible(pow, interval, m, p);
    if (skipPossible) {
      result1 = countPartial(pow-1, interval*2, Arrays.copyOf(m, m.length), cost, p);
      result1 = result1.add(countPartial(pow-1, interval*2+1, Arrays.copyOf(m, m.length), cost, p));
    }
    if (pow < 0) {
      return BigInteger.ZERO;
    }
    boolean need = false;
    int power = (int) Math.pow(2, pow);
    for (int i = interval*power; i < (interval+1)*power; i++) {
      if (m[i] < p) {
        need = true;
        m[i]++;
      }
    }
    BigInteger result = (need ? cost[pow-1][interval] : BigInteger.ZERO);
    result = result.add(countPartial(pow-1, interval*2, m, cost, p));
    result = result.add(countPartial(pow-1, interval*2 + 1, m, cost, p));
    if (skipPossible) {
      return result.min(result1);
    }
    return result;
  }
  
  private static boolean skipPossible(int pow, int interval, int[] m, int p) {
    if (pow < 0) {
      return false;
    }
    boolean possible = true;
    int power = (int) Math.pow(2, pow);
    for (int i = interval*power; i < (interval+1)*power; i++) {
      if (m[i] + pow <= p) {
        possible = false;
      }
    }
    return possible;
  }
}
