import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Scanner;

public class Main3 {

    private static final int OCCUPIED = -1;
    private static final int EMPTY = -2;

    public static void main(String[] args) {
        Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i) {
            int n_stalls = in.nextInt();
            int k_queue = in.nextInt();

            int[] stalls = new int[n_stalls + 2];
            Arrays.fill(stalls, EMPTY);
            stalls[0] = OCCUPIED;
            stalls[stalls.length - 1] = OCCUPIED;

            int y = 0;
            int z = 0;
            while (k_queue-- > 0) {
                int curMaxMax = -1;
                int curMaxMin = -1;
                int curIdx = -1;
                for (int j = 1; j <= stalls.length-2; j++) {
                    if (stalls[j] == OCCUPIED) continue;
                    int rs = Rs(stalls, j);
                    int ls = Ls(stalls, j);
                    int min = Math.min(rs, ls);
                    int max = Math.max(rs, ls);
                    if (min == curMaxMin) {
                        if (max > curMaxMax) {
                            curIdx = j;
                            curMaxMax = max;
                        }
                    } else if (min > curMaxMin) {
                        curMaxMin = min;
                        curMaxMax = max;
                        curIdx = j;
                    }
                }
                stalls[curIdx] = OCCUPIED;
                y = curMaxMax;
                z = curMaxMin;
            }

            System.out.println("Case #" + i + ": " + y + " " + z);
        }
    }


    private static int Rs(int[] stalls, int startIdx) {
        for (int i = startIdx+1; i <= stalls.length - 1; i++) {
            if (stalls[i] == OCCUPIED) return i-startIdx-1;
        }
        return 0;
    }

    private static int Ls(int[] stalls, int startIdx) {
        for (int i = startIdx-1; i >= 0; i--) {
            if (stalls[i] == OCCUPIED) return startIdx-i-1;
        }
        return 0;
    }

}
