import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Scanner;

public class MainDemo2 {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  
	    for (int i = 1; i <= t; ++i) {
	    	int n = in.nextInt();
	    	
	    	int[] arr = new int[n];
	    	
	    	for(int j = 0; j < n; j++) {
	    		arr[j] = in.nextInt();
	    	}
	    	
	    	printAll(arr, n, i);
	   	
	    }
	}
	
	static class Party {
		public int index;
		public int val;
		
		public Party(int i, int v) {
			index = i;
			val = v;
		}
	}
	
	private static void printAll(int[] arr, int n, int t) {
		Party[] party = new Party[n];
		for(int i = 0; i < n; i++) {
			party[i] = new Party(i, arr[i]);
		}
		System.out.print("Case #" + t + ":");
		MaxHeap heap = new MaxHeap(party, n);
		heap.buildheap();
		while(heap.size > 0) {
			Party max, max2;
			int ind, ind2;
			
			max = heap.extractMax();
			ind = max.index;
			max.val--;
			if(max.val > 0) {
				heap.insert(max);
			}
			char c = (char) ('A' + max.index);
			System.out.print(" " + c);
			
			max2 = heap.extractMax();
			ind2 = max2.index;
			max2.val--;
			if(max2.val > 0) {
				heap.insert(max2);
			}
			
			if(heap.majority()) {
				if(max2.val == 0) {
					heap.insert(new Party(max2.index, 1));
				}
				else {
					for(int h = 0; h < heap.size; h++) {
						if(heap.harr[h].index == ind2) {
							heap.harr[h].val++;
							heap.buildheap();
							break;
						}
					}
				}
			}
			else {
				c = (char) ('A' + max2.index);
				System.out.print(c);
			}
			
		}
		System.out.print("\n");
	}
	
	static class MaxHeap {
		public Party[] harr;
		public int size;
		
		public MaxHeap(Party[] arr, int n) {
			harr = arr;
			size = n;
		}
		
		public void buildheap() {
			int i = (size - 1) / 2;
			while(i >= 0) {
				heapify(i);
				i--;
			}
		}
		
		private void heapify(int i) {
			int l = 2*i+1;
			int r = 2*i+2;
			int large = i;
			if(l < size && harr[l].val > harr[large].val) {
				large = l;
			}
			if(r < size && harr[r].val > harr[large].val) {
				large = r;
			}
			if(large != i) {
				Party tmp = harr[i];
				harr[i] = harr[large];
				harr[large] = tmp;
				heapify(large);
			}
		}
		
		public int getMax() {
			return harr[0].val;
		}
		
		public Party extractMax() {
			if(size == 0) {
				return null;
			}
			Party root = harr[0];
			
			if(size > 1) {
				harr[0] = harr[size - 1];
				heapify(0);
			}
			size--;
			
			return root;
		}
		
		private int parent(int pos)
	    {
	        return (pos-1) / 2;
	    }
		
		public void insert(Party element)
	    {
			
	        harr[size] = element;
	        int current = size;
	        size++;
	 
	        while(current >= 0 && harr[current].val > harr[parent(current)].val)
	        {
	            Party tmp = harr[current];
	            harr[current] = harr[parent(current)];
	            harr[parent(current)] = tmp;
	            current = parent(current);
	        }	
	    }
		
		public boolean majority() {
			int sum = 0;
			for(int i = 0; i < size; i++) {
				sum+=harr[i].val;
			}
			for(int i = 0; i < size; i++) {
				if(harr[i].val > sum - harr[i].val) {
					return true;
				}
			}
			return false;
		}
		
	}
	

}
