import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Scanner;

public class MainDemo {

	public static void main(String[] args) {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = in.nextInt();  
	    for (int i = 1; i <= t; ++i) {
	    	int j = in.nextInt();
	    	int p = in.nextInt();
	    	int s = in.nextInt();
	    	int k = in.nextInt();
	    	printAllValid(j, p,s,k,i);
	    }

	}
	
	private static void printAllValid(int j, int p, int s, int k, int t) {
		int[] outfit = new int[3];
		outfit[0] = j;
		outfit[1] = p;
		outfit[2] = s;
		ArrayList<ArrayList<Integer>> result = new ArrayList<>();
		AVLTree jp = new AVLTree();
		AVLTree ps = new AVLTree();
		AVLTree js = new AVLTree();
		
		int[] output = new int[3];
		
		getAllValid(outfit, 0, 3, output, result, jp, ps, js, k);
		
		System.out.println("Case #" + t + ": " + result.size());
		for(ArrayList<Integer> list : result) {
			System.out.print(list.get(0) + " ");
			System.out.print(list.get(1) + " ");
			System.out.println(list.get(2));
		}
	}
	
	
	private static void getAllValid(int[] arr, int pos, int n, int[] output, 
			ArrayList<ArrayList<Integer>> outList, AVLTree jp, 	AVLTree ps, AVLTree js, int k) {
		if(pos == n) {
			int c = jp.getCount(output[0], output[1]);
			if(c < k) {
				c = ps.getCount(output[1], output[2]);
				if(c < k) {
					c = js.getCount(output[0], output[2]);
					if(c < k) {
						jp.insert(output[0], output[1]);
						ps.insert(output[1], output[2]);
						js.insert(output[0], output[2]);
						
						ArrayList newOut = new ArrayList<>();
						newOut.add(output[0]);
						newOut.add(output[1]);
						newOut.add(output[2]);
						
						outList.add(newOut);
					}
				}
			}
			return;
		}
		
		for(int i = 1; i <= arr[pos]; i++) {
			output[pos] = i;
			getAllValid(arr, pos+1, n, output, outList, jp, ps, js, k);
		}
	}
	
	
	
	
	static class Node {
		int l, r;
	    int height, count;
	    Node left, right;
	 
	    Node(int val1, int val2) {
	        l = val1;
	        r = val2;
	        height = 1;
	        count = 1;
	    }
	}
	 
	static class AVLTree {
	 
	    Node root;
	    int num;
	    
	    public AVLTree() {
	    	root = null;
	    	num = 0;
	    }
	    
	    public int getCount(int val1, int val2) {
	    	Node node = search(root, val1, val2);
	    	if(node == null) {
	    		return 0;
	    	}
	    	else {
	    		return node.count;
	    	}
	    }
	    
	    private Node search(Node node, int val1, int val2) {
	    	if(node == null) {
	    		return null;
	    	}
	    	if(node.l == val1 && node.r == val2) {
	    		return node;
	    	}
	    	if(compareVal(val1, val2, node.l, node.r)) {
	    		return search(node.left, val1, val2);
	    	}
	    	else {
	    		return search(node.right, val1, val2);
	    	}
	    }
	    
	    public void insert(int val1, int val2) {
	    	root = insert(root, val1, val2);
	    }
	    
	    // A utility function to get height of the tree
	    int height(Node N) {
	        if (N == null) {
	            return 0;
	        }
	        return N.height;
	    }
	 
	    // A utility function to get maximum of two integers
	    int max(int a, int b) {
	        return (a > b) ? a : b;
	    }
	 
	    // A utility function to right rotate subtree rooted with y
	    // See the diagram given above.
	    Node rightRotate(Node y) {
	        Node x = y.left;
	        Node T2 = x.right;
	 
	        // Perform rotation
	        x.right = y;
	        y.left = T2;
	 
	        // Update heights
	        y.height = max(height(y.left), height(y.right)) + 1;
	        x.height = max(height(x.left), height(x.right)) + 1;
	 
	        // Return new root
	        return x;
	    }
	 
	    // A utility function to left rotate subtree rooted with x
	    // See the diagram given above.
	    Node leftRotate(Node x) {
	        Node y = x.right;
	        Node T2 = y.left;
	 
	        // Perform rotation
	        y.left = x;
	        x.right = T2;
	 
	        //  Update heights
	        x.height = max(height(x.left), height(x.right)) + 1;
	        y.height = max(height(y.left), height(y.right)) + 1;
	 
	        // Return new root
	        return y;
	    }
	 
	    // Get Balance factor of node N
	    int getBalance(Node N) {
	        if (N == null) {
	            return 0;
	        }
	        return height(N.left) - height(N.right);
	    }
	    
	    boolean compareVal(int val1, int val2, int val3, int val4) {
	    	if(val1 < val3) {
	    		return true;
	    	}
	    	if(val1 > val3) {
	    		return false;
	    	}
	    	if(val1 == val3) {
	    		if(val2 < val4) {
		    		return true;
		    	}
		    	if(val2 > val4) {
		    		return false;
		    	}
	    	}
	    	return true;
	    }
	 
	    Node insert(Node node, int val1, int val2) {
	 
	        /* 1.  Perform the normal BST rotation */
	        if (node == null) {
	        	num++;
	            return (new Node(val1, val2));
	        }
	        
	        if(node.l == val1 && node.r == val2) {
	        	node.count++;
	        	return node;
	        }
	 
	        if (compareVal(val1, val2, node.l, node.r)) {
	            node.left = insert(node.left, val1, val2);
	        } else {
	            node.right = insert(node.right, val1, val2);
	        }
	 
	        /* 2. Update height of this ancestor node */
	        node.height = max(height(node.left), height(node.right)) + 1;
	 
	        /* 3. Get the balance factor of this ancestor node to check whether
	         this node became unbalanced */
	        int balance = getBalance(node);
	 
	        // If this node becomes unbalanced, then there are 4 cases
	        // Left Left Case
	        if (balance > 1 && compareVal(val1, val2, node.l, node.r)) {
	            return rightRotate(node);
	        }
	 
	        // Right Right Case
	        if (balance < -1 && !compareVal(val1, val2, node.l, node.r)) {
	            return leftRotate(node);
	        }
	 
	        // Left Right Case
	        if (balance > 1 && !compareVal(val1, val2, node.left.l, node.left.r)) {
	            node.left = leftRotate(node.left);
	            return rightRotate(node);
	        }
	 
	        // Right Left Case
	        if (balance < -1 && compareVal(val1, val2, node.right.l, node.right.r)) {
	            node.right = rightRotate(node.right);
	            return leftRotate(node);
	        }
	 
	        /* return the (unchanged) node pointer */
	        return node;
	    }
	 
	    /* Given a non-empty binary search tree, return the node with minimum
	     key value found in that tree. Note that the entire tree does not
	     need to be searched. */
	    Node minValueNode(Node node) {
	        Node current = node;
	 
	        /* loop down to find the leftmost leaf */
	        while (current.left != null) {
	            current = current.left;
	        }
	 
	        return current;
	    }
	    
	    public void inorder() {
	    	System.out.println("num " + num);
	    	inorder(root);
	    }
	    
	    private void inorder(Node node) {
	    	if(node != null) {
	    		inorder(node.left);
	    		//System.out.println("node " + node.key + " count " + node.count);
	    		inorder(node.right);
	    	}
	    }
	}

}
