import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class RollerCoasterSolver {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("coaster.in"));
		PrintWriter printer = new PrintWriter(new BufferedWriter(new FileWriter("coaster.out")));

		int numT = Integer.parseInt(reader.readLine());

		for (int cT = 1; cT <= numT; cT++) {
			StringTokenizer inputData = new StringTokenizer(reader.readLine());
			int numS = Integer.parseInt(inputData.nextToken());
			int numC = Integer.parseInt(inputData.nextToken());
			int numTk = Integer.parseInt(inputData.nextToken());

			int[] cnt1 = new int[numS + 1];
			int[] cnt2 = new int[numS + 1];

			for (int i = 1; i <= numTk; i++) {
				inputData = new StringTokenizer(reader.readLine());
				int a = Integer.parseInt(inputData.nextToken());
				int b = Integer.parseInt(inputData.nextToken());
				if (b == 1) {
					cnt1[a]++;
				} else {
					cnt2[a]++;
				}
			}

			int rCnt = 0;

			for (int i = 1; i <= numS; i++) {
				if (cnt1[i] == 0) {
					continue;
				}
				for (int j = 1; j <= numS; j++) {
					if (i == j) {
						continue;
					}

					int delta = Math.min(cnt1[i], cnt2[j]);
					cnt1[i] -= delta;
					cnt2[j] -= delta;
					rCnt += delta;
					if (cnt1[i] == 0) {
						break;
					}
				}
			}

			int pCnt = 0;

			for (int i = 2; i <= numS; i++) {
				if (cnt1[i] != 0 && cnt2[i] != 0) {
					int delta = Math.min(cnt1[i], cnt2[i]);
					cnt1[i] -= delta;
					cnt2[i] -= delta;
					rCnt += delta;
					pCnt += delta;
				}
			}

			for (int i = 1; i <= numS; i++) {
				if (cnt1[i] != 0) {
					rCnt += cnt1[i];
					cnt1[i] = 0;
				}
				if (cnt2[i] != 0) {
					rCnt += cnt2[i];
					cnt2[i] = 0;
				}
			}

			printer.println("Case #" + cT + ": " + rCnt + " " + pCnt);
		}
		printer.close();
	}
}
