import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;


public class rotate {
	
	public static boolean[] solve(int[][] matrix , int N , int T){
		int[][] result = roa(matrix , N);
		update(result , N);
		return check(result , N , T);
	}
	
	static int[][] roa(int[][] matrix, int N){
		int[][] result = new int[N][N];
		for(int i = 0 ; i < N ; i ++){
			for(int j = 0 ; j < N ; j ++){
				result[j][N - 1 - i] = matrix[i][j];
			}
		}
		return result;
	}
	
	static void update(int[][] matrix, int N){
		for(int i = 0 ; i < N ; i ++){
			int loc = N - 1;
			for(int j = N - 1; j >= 0 ;  j --){
				if(matrix[j][i] == 0)
					continue;
				matrix[loc --][i] = matrix[j][i];
				if(j != loc + 1)
					matrix[j][i] = 0;
			}
		}
	}
	
	static boolean[] check(int[][] matrix , int N, int K){
		boolean r = false , b = false;
		
		for(int i = 0 ; i < N ; i ++){
			if( r && b )
				break;
			int h1 = 0 , h2 = 0 , v1 = 0 , v2 = 0, d1 = 0 , d2 = 0, d3 = 0 , d4 = 0;
			
			for(int j = 0 ; j < N ; j ++){
				if(matrix[i][j] == 1){
					h1 ++;
					h2 = 0;
				}else if(matrix[i][j] == 2){
					h2 ++;
					h1 = 0;
				}else{
					h1 = 0;
					h2 = 0;
				}
				
				if(matrix[j][i] == 1){
					v1 ++;
					v2 = 0;
				}
				else if(matrix[j][i] == 2){
					v1 = 0;
					v2 ++;
				}else{
					v1 = 0;
					v2 = 0;
				}
				
				if(N - 1 - i + j < N){
					if(matrix[j][N - 1 - i + j] == 1){
						d1 ++;
						d2 = 0;
					}
					else if(matrix[j][N - 1 - i + j] == 2){
						d2 ++;
						d1 = 0;
					}else{
						d1 = 0;
						d2 = 0;
					}
				}
				
				if(j <= i){
					if(matrix[j][i - j] == 1){
						d3 ++;
						d4 = 0;
					}
					else if(matrix[j][i - j] == 2){
						d4 ++;
						d3 = 0;
					}else{
						d3 = 0;
						d4 = 0;
					}
				}
				
				if(h1 == K || v1 == K || d1 == K || d3 == K){
					r = true;
				}
				if(h2 == K || v2 == K || d2 == K || d4 == K)
					b = true;
			}
		}
		
		for(int i = 1 ; i < N ; i ++){
			if( r && b )
				break;
			int h1 = 0 , h2 = 0 , v1 = 0 , v2 = 0, d1 = 0 , d2 = 0, d3 = 0 , d4 = 0;

			for(int j = 0 ; j < N ; j ++){
				if(i + j < N){
					if(matrix[i + j][j] == 1){
						d1 ++;
						d2 = 0;
					}else if(matrix[i + j][j] == 2){
						d2 ++;
						d1 = 0;
					}else{
						d1 = 0;
						d2 = 0;
					}
				}
				
				if(i + j < N){
					if(matrix[i + j][N - 1 - j] == 1){
						d3 ++;
						d4 = 0;
					}
					else if(matrix[i + j][N - 1 - j] == 2){
						d4 ++;
						d3 = 0;
					}else{
						d3 = 0;
						d4 = 0;
					}
				}
				
				if(h1 == K || v1 == K || d1 == K || d3 == K){
					r = true;
				}
				if(h2 == K || v2 == K || d2 == K || d4 == K)
					b = true;
			}
			
			if(h1 == K || v1 == K || d1 == K || d3 == K){
				r = true;
			}
			if(h2 == K || v2 == K || d2 == K || d4 == K)
				b = true;
		}
		
		boolean result[] = {r , b};
		return result;
	}
	
	
	public static void main(String args[]) throws Exception{
		BufferedReader reader = new BufferedReader(new FileReader(new File("A-small-attempt1.in")));
		//BufferedReader reader = new BufferedReader(new FileReader(new File("test.txt")));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File("s.out")));
		String line = reader.readLine();
		long k = Integer.parseInt(line);
		for(long i = 0 ; i < k ; i ++){
			line = reader.readLine();
			String tokens[] = line.trim().split("\\s+");
			int N = Integer.parseInt(tokens[0]);
			int T = Integer.parseInt(tokens[1]);
			int[][] matrix = new int[N][N];
			for(int j = 0 ; j < N ; j ++){
				line = reader.readLine();
				for(int l = 0 ; l < line.length() ; l ++){
					char ch = line.charAt(l);
					if(ch == '.')
						matrix[j][l] = 0;
					else if(ch == 'R')
						matrix[j][l] = 1;
					else
						matrix[j][l] = 2;
				}
			}
			boolean result[] = solve(matrix , N , T);
			if(!result[0] && !result[1])
				writer.write("Case #" + (i+1) + ": " + "Neither" + "\r\n");
			else if(result[0] && !result[1])
				writer.write("Case #" + (i+1) + ": " + "Red" + "\r\n");
			else if(!result[0] && result[1])
				writer.write("Case #" + (i+1) + ": " + "Blue" + "\r\n");
			else
				writer.write("Case #" + (i+1) + ": " + "Both" + "\r\n");
		}
		reader.close();
		writer.close();
	}
	
	
	

}
