import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Watersheds {
	
	public static void getMark(int[][] flow , int mark[][], int x , int y){
		if(mark[x][y] != 0)
			return;
		int dir = flow[x][y];
		if(dir == 1){
			getMark(flow , mark , x - 1 , y);
			mark[x][y] = mark[x - 1][y];
		}
		if(dir == 2){
			getMark(flow , mark , x , y - 1);
			mark[x][y] = mark[x][y - 1];
		}
		
		if(dir == 3){
			getMark(flow , mark , x , y + 1);
			mark[x][y] = mark[x][y + 1];
		}
		
		if(dir == 4){
			getMark(flow , mark , x + 1 , y);
			mark[x][y] = mark[x + 1][y];
		}
		
		
	}
	
	public static char[][] test(int map[][], int rownum , int linenum){
		char[][] result = new char[rownum][linenum];
		int[][] flow = new int[rownum][linenum];
		int[][] mark = new int[rownum][linenum];
		for(int i = 0 ; i < rownum ; i ++){
			for(int j = 0 ; j < linenum ; j ++){
				mark[i][j] = 0;
			}
		}
		int m = 1;
		for(int i = 0 ; i < rownum ; i ++){
			for(int j = 0 ; j < linenum ; j ++){
				int mininum = map[i][j];
				int dir = -1;
				if(i  != 0){
					if(map[i - 1][j] < mininum){
						mininum = map[i - 1][j];
						dir = 1;
					}
				}
				if(j != 0){
					if(map[i][j - 1] < mininum){
						mininum = map[i][j - 1];
						dir = 2;
					}
				}
				
				if(j != linenum - 1){
					if(map[i][j + 1] < mininum){
						mininum = map[i][j + 1];
						dir = 3;
					}
				}
				if(i != rownum - 1){
					if(map[i + 1][j] < mininum){
						mininum = map[i + 1][j];
						dir = 4;
					}
				}
				flow[i][j] = dir;
				if(dir == -1){
					mark[i][j] = m ++;
				}
			}
		}
		
		int marknum = m;
		
		for(int i = 0 ; i < rownum ; i ++){
			for(int j = 0 ; j < linenum ; j ++){
				getMark(flow , mark , i , j);
			}
		}
		
		char[] marks = new char[marknum];
		for(int i = 0 ; i < marknum ; i ++){
			marks[i] = ' ';
		}
		
		char start = 'a';
		for(int i = 0 ; i < rownum ; i ++){
			for(int j = 0 ; j < linenum ; j ++){
				m = mark[i][j];
				if(marks[m] == ' '){
					result[i][j] = start;
					marks[m] = start;
					start ++;
				}else
					result[i][j] = marks[m];
			}
		}
		
		return result;
		
	}
	
	
	public static void main(String args[]){
		try{
			BufferedReader reader = new BufferedReader(new FileReader(new File(args[0])));
			BufferedWriter writer = new BufferedWriter(new FileWriter(new File(args[1])));
			String line = reader.readLine();
			System.out.println(line);
			int casenum = Integer.parseInt(line);
			
			for(int i = 0 ; i < casenum ; i ++){	
				if(i == 5){
					System.out.println(casenum);
				}
				line = reader.readLine();
				String tokens[] = line.split("[ \t]+");
				int rownum = Integer.parseInt(tokens[0]);
				int linenum = Integer.parseInt(tokens[1]);
				int[][] map = new int[rownum][linenum];
				for(int j = 0 ; j < rownum ; j ++){
					line = reader.readLine();
					tokens = line.split("[ \t]+");
					for(int k = 0 ; k < linenum ; k ++){
						System.out.println(tokens[k]);
						map[j][k] = Integer.parseInt(tokens[k]);
					}
				}
				char[][] result = test(map, rownum , linenum);
				
				writer.write("Case #" + (i + 1) + ":\r\n");
				for(int j = 0 ; j < rownum ; j ++){
					for(int k = 0 ; k < linenum ; k ++){
						if(k == 0){
							writer.write(result[j][k]);
						}else
							writer.write(" " + result[j][k]);
					}
					writer.write("\r\n");
				}				
			}
			reader.close();
			writer.close();
		}catch(IOException e){
			e.printStackTrace();
		}
		
	}

}
