import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;

public class FairWarning {
	
	static BigInteger gcd(BigInteger a, BigInteger b){
		if(a.compareTo(b) < 0){
			BigInteger tmp = b;
			b = a;
			a = tmp;
		}
		
		
		while(true){
			BigInteger remainer[] = a.divideAndRemainder(b);
			if(remainer[1].equals(BigInteger.ZERO)){
				return b;
			}
			a = b;
			b = remainer[1];
			
		}
		
	}
	
	public static void quickSort(BigInteger[] array, int s, int e) {
		BigInteger st = array[s];
		int sloc = s;
		for (int i = s + 1; i < e; i++) {
			BigInteger number = array[i];
			if (number.compareTo(st) < 0 && ++sloc != i) {
				BigInteger tmp = array[i];
				array[i] = array[sloc];
				array[sloc] = tmp;
			}
		}
		BigInteger tmp = array[sloc];
		array[sloc] = array[s];
		array[s] = tmp;
		if (sloc - s > 1) {
			quickSort(array, s, sloc);
		}
		if (e - sloc > 2)
			quickSort(array, sloc + 1, e);
	}
	
	static boolean checkGCD(BigInteger a , BigInteger b){
		BigInteger remainer[] = a.divideAndRemainder(b);
		if(remainer[1].equals(BigInteger.ZERO)){
			return true;
		}
		return false;
	}
	
	static BigInteger test(BigInteger[] array, int len){
		quickSort(array , 0 , array.length);
		BigInteger result = array[1].add(array[0].negate());
		int i = 1;
		if(result.equals(BigInteger.ZERO)){
			for(i = 1; i < len ; i ++){
				result = array[i].add(array[i - 1].negate());
				if(!result.equals(BigInteger.ZERO)){
					break;
				}
			}
		}
		for(int j = i ; j < len ; j ++){
			BigInteger tmp = array[j].add(array[j - 1].negate());
			if(!tmp.equals(BigInteger.ZERO))
				result = gcd(result , tmp);
		}
		BigInteger max = array[len - 1];
		if(checkGCD(max , result))
			return BigInteger.ZERO;
		BigInteger r = max.divide(result);
		BigInteger f = r.add(new BigInteger("1")).multiply(result);
		f = f.add(max.negate());
		return f;
	}
	public static void main(String args[]) throws Exception{
		BufferedReader reader = new BufferedReader(new FileReader(new File("B-small-attempt1.in")));
		BufferedWriter writer = new BufferedWriter(new FileWriter(new File("s.out")));
		String line = reader.readLine();
		long k = Integer.parseInt(line);
		for(long i = 0 ; i < k ; i ++){
			line = reader.readLine();
			String tokens[] = line.trim().split("\\s+");
			int size = Integer.parseInt(tokens[0]);
			BigInteger[] array = new BigInteger[size];
			for(int j = 0 ; j < size ; j ++){
				array[j] = new BigInteger(tokens[j + 1]);
			}
			BigInteger result = test(array , size);
			writer.write("Case #" + (i+1) + ": " + result + "\r\n");
		}
		reader.close();
		writer.close();
	}
	
}

