/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2016
   Qualifier
   Problem 1
   
   1.0
   by Jos Alberto Bonilla Vera (2016)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.io.*;
import java.text.*;

//import com.rits.cloning.*;
//import org.objenesis.*;

//import helper.Helper;
//import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QualifierProblem1 {
	
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	private static Scanner scanner;
	private static boolean globalDebugVariable;
	
	public static void solveProblem(String[] args) {
	
		if (args.length == 3) {
			globalDebugVariable = Boolean.parseBoolean(args[2]);
		}
		else {
			globalDebugVariable = false;
		}
	
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		String pancakeRow;
		int flipperSize, pancakeRowSize, pos, numMoves /*, pancakeHappyStreak, pancakeSadStreak;*/;
				
		
		/*======== Logic ========*/
		try {
		
			scanner = new Scanner(br);
			/*======== Read Number of Cases ========*/
			numCases = scanner.nextInt();
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {								
				
				pancakeRow = scanner.next();
				pancakeRowSize = pancakeRow.length();
				flipperSize = scanner.nextInt();
				
				debugPrint(":::::::");
				debugPrint(pancakeRow+", flipper = "+flipperSize);
				numMoves = 0;
				pos = firstSad(pancakeRow);
				while (!checkHappyRow(pancakeRow) && pos + flipperSize <= pancakeRowSize) {					
					pancakeRow = flip(pancakeRow, pos, flipperSize);
					debugPrint("  Flipping from pos "+pos+": "+pancakeRow);
					pos = firstSad(pancakeRow);
					numMoves++;
				}
				if (checkHappyRow(pancakeRow)) {
					result = ""+numMoves;
				}
				else {
					result = "IMPOSSIBLE";
				}
				debugPrint(result+":::::::");
				
				//debugPrint(pancakeRow+" / "+flipperSize+": "+pancakeHappyStreak+","+pancakeSadStreak);
				debugPrint("Resultado: "+result);
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}
	
	/*================ Problem-specific methods =====================*/
	public static String flip(String parPancakeRow, int parStartPos, int parFlipperSize) {
		String newString = "";
		int parPancakeRowSize = parPancakeRow.length();
		for (int i=0; i<parPancakeRowSize; i++) {
			if (i<parStartPos || i>=parStartPos+parFlipperSize) {
				newString = newString + parPancakeRow.substring(i,i+1);
			}
			else {
				newString = newString + (parPancakeRow.substring(i,i+1).equals("+") ? "-" : "+");
			}
		}
		return newString;
	}
	public static int firstSad(String parPancakeRow) {
		int parPancakeRowSize = parPancakeRow.length();
		int i = 0;
		while (i<parPancakeRowSize && parPancakeRow.substring(i,i+1).equals("+")) {
			i++;
		}
		return i;
	}
	public static boolean checkHappyRow(String parPancakeRow) {
		int parPancakeRowSize = parPancakeRow.length();
		return firstSad(parPancakeRow) == parPancakeRowSize;
	}
	
	/*====================== Main method ===========================*/

	public static void main(String[] args) {
		try {
			/*======== Open Input File ========*/
			br = new BufferedReader(new FileReader(args[0]));
			/*======== Open Output File ========*/
			bw = new BufferedWriter(new FileWriter(args[1]));
			/*======== Solve Problem ========*/
			solveProblem(args);
			
			/*======== Close Output File ========*/
			bw.close();
			/*======== Open Input File ========*/
			br.close();
		}
		catch (IOException ioe) {
			System.out.println(ioe);
		}
	}	
	
	/*================ Auxilliary methods =====================*/
	
	public static void debugPrint(String str, boolean print) {
		if (print) {
			System.out.println(str);
		}
	}
	
	public static void debugPrint(String str) {
		debugPrint(str, globalDebugVariable);
	}
}