/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
   GoogleCodeJam 2009 Java Template   
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   1.0
   by Jos Alberto Bonilla Vera   
   Mexico                             
   
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   Round: Qualifying Round
   Problem Name: Welcome to Code Jam
   Class Name: WelcomeCodeJam
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Package name ~~~~~~~~~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

package qualifying;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Java library imports ~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.math.*;
import java.io.*;
import java.util.*;
import java.text.*;

import helper.Helper;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Main Class ~~~~~~~~~~~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class WelcomeCodeJam {

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Class Constant Declarations ~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Class Variable Declarations ~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/	
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Helper Methods ~~~~~~~~~~~~~~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	private static void createReadFile(String fileName) {
		try { 
			br = new BufferedReader(new FileReader(fileName));
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void createWriteFile(String fileName) {
		try {
			bw = new BufferedWriter(new FileWriter(fileName));
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void closeReadFile() {
		try { 
			br.close();
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void closeWriteFile() {
		try {
			bw.close();
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	
	static long numberPhrases(String testedString, String text, int indice) {
		
		if (indice==19) {
			return 1;
		}
		else {
			String letter = text.substring(indice,indice+1);
			if (testedString.indexOf(letter) != -1) {
				String searchText = testedString.substring(testedString.indexOf(letter)+1,testedString.length());
				if (searchText.indexOf(letter) != -1) {
					return numberPhrases(searchText, text, indice+1) + numberPhrases(searchText, text, indice);
				}
				else {
					return numberPhrases(searchText, text, indice+1);
				}
			}
			else {
				return 0;
			}
		}
	}
	
	/*======== Main method for solving ========*/
	
	private static void solveProblem(String[] args) {
	
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		
		String text = "welcome to code jam"; 
		
		String temp;
		
		long numCombinations;
		
		/*======== Logic ========*/
		try {
		
			/*======== Read Number of Cases ========*/
			numCases = Integer.parseInt(br.readLine());
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {
			
				/*======== Read Each Case ========*/
				
				thisLine = br.readLine();
				
				/*======== Solve Each Case ========*/
					
				numCombinations = numberPhrases(thisLine,text,0);
				
				System.out.println("Case #" + i + ": " + numCombinations);
				result = "" + numCombinations;
				result = result.substring(Math.max(0,result.length()-4),result.length());
				
				temp = "";
				for (int k=1; k<=4-result.length(); k++) {
					temp = temp + "0";
				}
				result = temp + result;
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Main Program ~~~~~~~~~~~~~~~~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	/*
		Persistent Parameter List
		-----------------------------------
		args[0] = Input file
		args[1] = Output file
		
	*/
	
	public static void main(String[] args) {
	
			
		/*======== Open Input File ========*/
		createReadFile(args[0]);
		/*======== Open Output File ========*/
		createWriteFile(args[1]);			
		/*======== Solve Problem ========*/
		solveProblem(args);
		
		/*======== Close Output File ========*/
		closeWriteFile();
		/*======== Open Input File ========*/
		closeReadFile();

	}
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Helper Classes for Problem ~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

