/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2014
   Qualifier
   Problem 4
   
   1.0
   by Jos Alberto Bonilla Vera (2014)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.io.*;
import java.text.*;

//import com.rits.cloning.*;
//import org.objenesis.*;

//import helper.Helper;
//import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QualifierProblem4 {
	
	private static BufferedReader br;
	private static BufferedWriter bw;

	public static void solveProblem(String[] args) {
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		
		int numBlocks;
		ArrayList<Double> naomiBlocks;
		ArrayList<Double> kenBlocks;
		ArrayList<Double> naomiBlocksRef;
		ArrayList<Double> kenBlocksRef;
		int naomiScoreWar;
		int naomiScoreDeceitfulWar;
		
		/*======== Logic ========*/
		try {
		
			/*======== Read Number of Cases ========*/
			numCases = Integer.parseInt(br.readLine());
	
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {
				thisLine = br.readLine();
				numBlocks = Integer.parseInt(thisLine);
				
				naomiBlocksRef = new ArrayList<Double>();
				kenBlocksRef = new ArrayList<Double>();
				
				thisLine = br.readLine();
				splitLine = thisLine.split(" ");
				
				for (int j=0; j<splitLine.length; j++) {
					naomiBlocksRef.add(new Double(Double.parseDouble(splitLine[j])));
				}
				
				thisLine = br.readLine();
				splitLine = thisLine.split(" ");
				
				for (int j=0; j<splitLine.length; j++) {
					kenBlocksRef.add(new Double(Double.parseDouble(splitLine[j])));
				}
				
				Collections.sort(naomiBlocksRef);
				Collections.sort(kenBlocksRef);
				
				naomiScoreWar = 0;
				naomiScoreDeceitfulWar = 0;
				
				naomiBlocks = new ArrayList<Double>(naomiBlocksRef);
				kenBlocks = new ArrayList<Double>(kenBlocksRef);
				
				//System.out.println(naomiBlocks);
				//System.out.println(kenBlocks);
				
				// War
				
				
				boolean noMoreKen = false;
				while (naomiBlocks.size()>0 && !noMoreKen) {					
					int minKenGTNaomi = -(Collections.binarySearch(kenBlocks, naomiBlocks.get(0))+1);
					//System.out.println("min: "+minKenGTNaomi);
					if (minKenGTNaomi >= naomiBlocks.size()) {
						noMoreKen = true;
					}
					else {
						//System.out.println("El primer bloque que vence a "+naomiBlocks.get(0)+" es: "+kenBlocks.get(minKenGTNaomi));
						naomiBlocks.remove(0);
						kenBlocks.remove(minKenGTNaomi);
					}				
				}
				naomiScoreWar = naomiBlocks.size();
				
				naomiBlocks = new ArrayList<Double>(naomiBlocksRef);
				kenBlocks = new ArrayList<Double>(kenBlocksRef);
				
				//System.out.println(naomiBlocks);
				//System.out.println(kenBlocks);
				
				// Deceitful War
								
				while (naomiBlocks.size() > 0 && naomiBlocks.get(naomiBlocks.size()-1).compareTo(kenBlocks.get(kenBlocks.size()-1)) > 0) {
					//System.out.println("  "+naomiBlocks.get(naomiBlocks.size()-1)+" es mayor que "+kenBlocks.get(kenBlocks.size()-1));
					naomiScoreDeceitfulWar++;
					naomiBlocks.remove(naomiBlocks.size()-1);
					kenBlocks.remove(kenBlocks.size()-1);					
				}
				
				//System.out.println("Todava quedan "+naomiBlocks.size()+" y el score de War es "+naomiScoreWar+" y el de Deceitful War es "+naomiScoreDeceitfulWar);
				
				int j=0;
				while (j<naomiBlocks.size()) {
					if (naomiBlocks.get(0).compareTo(kenBlocks.get(kenBlocks.size()-1))>0) {
						naomiScoreDeceitfulWar++;
					}
					naomiBlocks.remove(0);
					kenBlocks.remove(kenBlocks.size()-1);
				}
				
				result = ""+naomiScoreDeceitfulWar+" "+naomiScoreWar;
				
				System.out.println("Resultado: "+result);
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}

	public static void main(String[] args) {
		try {
			/*======== Open Input File ========*/
			br = new BufferedReader(new FileReader(args[0]));
			/*======== Open Output File ========*/
			bw = new BufferedWriter(new FileWriter(args[1]));
			/*======== Solve Problem ========*/
			solveProblem(args);
			
			/*======== Close Output File ========*/
			bw.close();
			/*======== Open Input File ========*/
			br.close();
		}
		catch (IOException ioe) {
			System.out.println(ioe);
		}
	}	
	
}