/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2011
   Qualifying Round
   Problem B
   
   1.0
   by Jos Alberto Bonilla Vera (2011)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.io.*;
import java.text.*;

import com.rits.cloning.*;
import org.objenesis.*;

import helper.Helper;
import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QR_ProblemB {
	
	private static BufferedReader br;
	private static BufferedWriter bw;

	public static void solveProblem(String[] args) {
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		HashMap combinations = new HashMap();
		ArrayList clearances = new ArrayList();
		ArrayList elementList = new ArrayList();
		int numCombinations = 0;
		int numClearances = 0;
		int numElementsInvoked = 0;
						
		/*======== Logic ========*/
		try {
		
			/*======== Read Number of Cases ========*/
			numCases = Integer.parseInt(br.readLine());
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {
			
				/*======== Read Each Case ========*/
				
				thisLine = br.readLine();
				splitLine = thisLine.split(" ");
				
				int pos = 0;
				combinations.clear();
				clearances.clear();
				elementList.clear();
				
				numCombinations = Integer.parseInt(splitLine[pos]);				
				for (int j=1; j<=numCombinations; j++) {
					combinations.put(splitLine[j].substring(0,2), splitLine[j].substring(2,3));
				}
				
				pos = pos + numCombinations + 1;
				
				numClearances = Integer.parseInt(splitLine[pos]);
				for (int j=pos+1; j<=pos+numClearances; j++) {
					clearances.add(splitLine[j]);
				}
				
				pos = pos + numClearances + 1;
				
				/*======== Solve Each Case ========*/
				
				numElementsInvoked = Integer.parseInt(splitLine[pos]);
				System.out.println("Elements: "+numElementsInvoked);
				
				pos = pos + 1;
				String curr = "";
				for (int j=0; j<numElementsInvoked; j++) {					
					curr = splitLine[pos].substring(j,j+1);						
					System.out.println(" invoking: "+curr);
					
					if (elementList.size() == 0) {						
						elementList.add(curr);
					}
					else {
						String combo1 = curr + elementList.get(elementList.size()-1);
						String combo2 = elementList.get(elementList.size()-1) + curr;
						
						String r1 = (String) combinations.get(combo1);
						String r2 = (String) combinations.get(combo2);
												
						if (r1 != null) { // Combination 1
							System.out.println( combo1 + " -> " + r1 );
							elementList.remove(elementList.size()-1);
							elementList.add(r1);
						}
						else if	(r2 != null) { // Combination 2
							System.out.println( combo2 + " -> " + r2 );
							elementList.remove(elementList.size()-1);
							elementList.add(r2);
						}
						else { // Clearance
							int k=0;
							boolean exit = false;
							while (k<clearances.size() && !exit) {
								String combo = (String) clearances.get(k);
								if (combo.indexOf(curr) != -1) { // Exists
									String l1 = combo.substring(0,1);
									String l2 = combo.substring(1,2);
									String eList = elementList.toString()+curr;
									System.out.println("Buscar: "+l1+" y "+l2+" en "+eList);
									if (eList.indexOf(l1) != -1 && eList.indexOf(l2) != -1) { // Boom!
										System.out.println(l1+l2+" -> Clear!");
										elementList.clear();
										exit = true;
									}
									else {
										k++;
									}
								}
								else {
									k++;
								}
							}
							if (!exit) { // Add to elementList
								elementList.add(curr);
							}
						}
						
					}
				}
				
				result = elementList.toString();
				
				System.out.println(result);
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}

	public static void main(String[] args) {
		/*======== Open Input File ========*/
		br = Helper.createReadFile(args[0]);
		/*======== Open Output File ========*/
		bw = Helper.createWriteFile(args[1]);			
		/*======== Solve Problem ========*/
		solveProblem(args);
		
		/*======== Close Output File ========*/
		Helper.closeWriteFile(bw);
		/*======== Open Input File ========*/
		Helper.closeReadFile(br);
	}	
}