/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2016
   Qualifier
   Problem 2
   
   1.0
   by Jos Alberto Bonilla Vera (2016)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.io.*;
import java.text.*;

//import com.rits.cloning.*;
//import org.objenesis.*;

//import helper.Helper;
//import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QualifierProblem2 {
	
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	private static Scanner scanner;
	private static boolean globalDebugVariable;
	
	public static void solveProblem(String[] args) {
	
		if (args.length == 3) {
			globalDebugVariable = Boolean.parseBoolean(args[2]);
		}
		else {
			globalDebugVariable = false;
		}
	
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		int numMoves, stackLength, j, iterations;
		String pancakeStack;
		String symbol,otherSymbol;
		
		/*======== Logic ========*/
		try {
		
			scanner = new Scanner(br);
			/*======== Read Number of Cases ========*/
			numCases = scanner.nextInt();
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {								
				
				pancakeStack = scanner.next();
				debugPrint("Comenzando: "+pancakeStack);
				stackLength = pancakeStack.length();
				numMoves = 0;
				iterations = 0;
				symbol = "";
				otherSymbol = "";
				while (!happyPancakesDone(pancakeStack)) {
					
					if (iterations % 2 == 0) {
						symbol = "+";
						otherSymbol = "-";
					}
					else {
						symbol = "-";
						otherSymbol = "+";
					}
					// replace "-" for "+" for each of the "-" streak
					j = 0;
					while (j < stackLength && pancakeStack.substring(j,j+1).equals(otherSymbol)) {
						j++;
					}
					pancakeStack = repeat(symbol, j)+restOfString(pancakeStack, j);
					debugPrint(" Sustitucin: "+repeat(symbol, j));
					debugPrint(" Resto: "+restOfString(pancakeStack, j));
					
					iterations++;
					
					if (repeat(symbol, j)!="") {
						numMoves++;
					}
					debugPrint(" Total: "+pancakeStack+", "+numMoves);
				}
				result = ""+numMoves;
				debugPrint("Resultado: "+result);
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}
	
	/*================ Problem-specific methods =====================*/
	
	public static boolean happyPancakesDone(String pancakeStack) {
		return pancakeStack.indexOf("-") == -1;
	}
	
	public static String repeat(String str, int times) {
		String ret = "";
		for (int i=0; i<times; i++) {
			ret = ret+str;
		}
		return ret;
	}
	
	public static String restOfString(String str, int index) {
		if (index >= str.length()) {
			return "";
		}
		else {
			return str.substring(index);
		}
	}
	
	
	/*====================== Main method ===========================*/

	public static void main(String[] args) {
		try {
			/*======== Open Input File ========*/
			br = new BufferedReader(new FileReader(args[0]));
			/*======== Open Output File ========*/
			bw = new BufferedWriter(new FileWriter(args[1]));
			/*======== Solve Problem ========*/
			solveProblem(args);
			
			/*======== Close Output File ========*/
			bw.close();
			/*======== Open Input File ========*/
			br.close();
		}
		catch (IOException ioe) {
			System.out.println(ioe);
		}
	}	
	
	/*================ Auxilliary methods =====================*/
	
	public static void debugPrint(String str, boolean print) {
		if (print) {
			System.out.println(str);
		}
	}
	
	public static void debugPrint(String str) {
		debugPrint(str, globalDebugVariable);
	}
}