/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2017
   Qualifier
   Problem 2
   
   1.0
   by Jos Alberto Bonilla Vera (2017)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.io.*;
import java.text.*;

//import com.rits.cloning.*;
//import org.objenesis.*;

//import helper.Helper;
//import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QualifierProblem2 {
	
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	private static Scanner scanner;
	private static boolean globalDebugVariable;
	
	public static void solveProblem(String[] args) {
	
		if (args.length == 3) {
			globalDebugVariable = Boolean.parseBoolean(args[2]);
		}
		else {
			globalDebugVariable = false;
		}
	
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		String numberString;
		int j, pos, numberStringSize;
		boolean nonDecreasing, finishedEditing;
		
		/*======== Logic ========*/
		try {
		
			scanner = new Scanner(br);
			/*======== Read Number of Cases ========*/
			numCases = scanner.nextInt();
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {								
				numberString = scanner.next();
				numberStringSize = numberString.length();
				result = "";
				if (numberStringSize == 1) {
					result = numberString;
				}
				else {
					// Check position of first decreasing sequence
					pos = 1;
					nonDecreasing = true;
					while (pos < numberStringSize && nonDecreasing) {						
						if (Integer.parseInt(numberString.substring(pos,pos+1)) >= 
							Integer.parseInt(numberString.substring(pos-1,pos))
							) {
							pos++;
						}
						else {
							nonDecreasing = false;
						}
					}
					
					result = numberString;
					
					if (!nonDecreasing) {
										
						// Change to 9's from that position onwards					
						for (j=pos; j<numberStringSize; j++) {
							result = edit(result, j, "9");
						}
						
						// Substract 1 to the first number to the left of that position that can be substracted without breaking the rule - otherwise substitute with 9
						j = pos - 1;
						finishedEditing = false;
						while (j>=0 && !finishedEditing) {
							if (j==0 || Integer.parseInt(result.substring(j,j+1))-1 >= Integer.parseInt(result.substring(j-1,j))) {
								result = edit(result, j, ""+(Integer.parseInt(result.substring(j,j+1))-1));
								finishedEditing = true;
							}
							else {
								result = edit(result, j, "9");
								j--;
							}
						}
					}
					debugPrint(numberString+">> Posicin nonDecreasing: "+pos+", estado nonDecreasing: "+nonDecreasing);
				}
				
				result = ""+Long.parseLong(result);
				debugPrint("Resultado: "+result);
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}
	
	/*================ Problem-specific methods =====================*/
	public static String edit(String parNumberString, int parEditPos, String parEditedCharacter) {
		String newString = "";
		int parNumberStringSize = parNumberString.length();
		for (int i=0; i<parNumberStringSize; i++) {
			if (i<parEditPos || i>parEditPos) {
				newString = newString + parNumberString.substring(i,i+1);
			}
			else {
				newString = newString + parEditedCharacter;
			}
		}
		return newString;
	}
	
	/*====================== Main method ===========================*/

	public static void main(String[] args) {
		try {
			/*======== Open Input File ========*/
			br = new BufferedReader(new FileReader(args[0]));
			/*======== Open Output File ========*/
			bw = new BufferedWriter(new FileWriter(args[1]));
			/*======== Solve Problem ========*/
			solveProblem(args);
			
			/*======== Close Output File ========*/
			bw.close();
			/*======== Open Input File ========*/
			br.close();
		}
		catch (IOException ioe) {
			System.out.println(ioe);
		}
	}	
	
	/*================ Auxilliary methods =====================*/
	
	public static void debugPrint(String str, boolean print) {
		if (print) {
			System.out.println(str);
		}
	}
	
	public static void debugPrint(String str) {
		debugPrint(str, globalDebugVariable);
	}
}