/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
   GoogleCodeJam 2009 Java Template   
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   1.0
   by Jos Alberto Bonilla Vera   
   Mexico                             
   
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   Round: Qualifying Round
   Problem Name: Alien Language
   Class Name: AlienLanguage
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Package name ~~~~~~~~~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

package qualifying;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Java library imports ~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.math.*;
import java.io.*;
import java.util.*;
import java.text.*;

import helper.Helper;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Main Class ~~~~~~~~~~~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class AlienLanguage {

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Class Constant Declarations ~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Class Variable Declarations ~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/	
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Helper Methods ~~~~~~~~~~~~~~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	private static void createReadFile(String fileName) {
		try { 
			br = new BufferedReader(new FileReader(fileName));
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void createWriteFile(String fileName) {
		try {
			bw = new BufferedWriter(new FileWriter(fileName));
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void closeReadFile() {
		try { 
			br.close();
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void closeWriteFile() {
		try {
			bw.close();
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	
	/*======== Main method for solving ========*/
	
	private static void solveProblem(String[] args) {
	
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		
		ArrayList dictionary = new ArrayList();
		int wordLength;
		int numWords;
		
		int numMatches;
		
		/*======== Logic ========*/
		try {
		
			/*======== Read Number of Cases ========*/
			thisLine = br.readLine();
			splitLine = thisLine.split(" ");
			wordLength = Integer.parseInt(splitLine[0]);
			numWords = Integer.parseInt(splitLine[1]);
			numCases = Integer.parseInt(splitLine[2]);
			
			for (int i=1; i<=numWords; i++) {
				dictionary.add(br.readLine());
			}
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {
			
				/*======== Read Each Case ========*/
				
				thisLine = br.readLine();
				thisLine = thisLine.replaceAll("\\(", "\\[");
				thisLine = thisLine.replaceAll("\\)", "\\]");				
				
				/*======== Solve Each Case ========*/
				
				numMatches = 0;
				for (int j=0; j<dictionary.size(); j++) {
					if ( ((String) dictionary.get(j)).matches(thisLine)) {
						numMatches++;
					}					
				}
				result = "" + numMatches;
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Main Program ~~~~~~~~~~~~~~~~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	/*
		Persistent Parameter List
		-----------------------------------
		args[0] = Input file
		args[1] = Output file
		
	*/
	
	public static void main(String[] args) {
	
			
		/*======== Open Input File ========*/
		createReadFile(args[0]);
		/*======== Open Output File ========*/
		createWriteFile(args[1]);			
		/*======== Solve Problem ========*/
		solveProblem(args);
		
		/*======== Close Output File ========*/
		closeWriteFile();
		/*======== Open Input File ========*/
		closeReadFile();

	}
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Helper Classes for Problem ~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

