/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2016
   Qualifier
   Problem 1
   
   1.0
   by Jos Alberto Bonilla Vera (2016)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.util.regex.Matcher;
import java.util.regex.Pattern;
import java.io.*;
import java.text.*;

//import com.rits.cloning.*;
//import org.objenesis.*;

//import helper.Helper;
//import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QualifierProblem1 {
	
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	private static Scanner scanner;
	private static boolean globalDebugVariable;
	
	public static void solveProblem(String[] args) {
	
		if (args.length == 3) {
			globalDebugVariable = Boolean.parseBoolean(args[2]);
		}
		else {
			globalDebugVariable = false;
		}
	
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		int n, j, multiplier;
		String newInt;
		boolean[] seenDigits;
				
		
		/*======== Logic ========*/
		try {
		
			scanner = new Scanner(br);
			/*======== Read Number of Cases ========*/
			numCases = scanner.nextInt();
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {								
				newInt = "";
				seenDigits = new boolean[10];
				
				for (j=0; j<10; j++) {
					seenDigits[j] = false;
				}
				
				n = scanner.nextInt();
				if (n==0) {
					result = "INSOMNIA";
				}
				else { 
					multiplier = 1;
					debugPrint(""+howManyRemainingDigits(seenDigits));
					while (howManyRemainingDigits(seenDigits) > 0) {
						newInt = ""+(n * multiplier);
						j = 0;
						debugPrint(newInt);
						while (j<newInt.length() && howManyRemainingDigits(seenDigits) > 0) {
							seenDigits[Integer.parseInt(newInt.substring(j,j+1))] = true;							
							j++;
						}
						multiplier++;
					}
					result = newInt;
				}
				
				debugPrint("Resultado: "+result);
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}
	
	/*================ Problem-specific methods =====================*/
	
	public static int howManyRemainingDigits(boolean[] array) {
		int howMany = 0;
		for (int i=0; i<array.length; i++) {
			if (!array[i]) {
				howMany++;
			}
		}
		return howMany;
	}
	
	public static int remainingDigit(boolean[] array) {
		boolean firstOne = false;
		int i = 0;
		while (!firstOne && i<array.length) {
			if (!array[i]) {
				firstOne = true;				
			}
			else {
				i++;
			}
		}
		return i;
	}
	
	
	/*====================== Main method ===========================*/

	public static void main(String[] args) {
		try {
			/*======== Open Input File ========*/
			br = new BufferedReader(new FileReader(args[0]));
			/*======== Open Output File ========*/
			bw = new BufferedWriter(new FileWriter(args[1]));
			/*======== Solve Problem ========*/
			solveProblem(args);
			
			/*======== Close Output File ========*/
			bw.close();
			/*======== Open Input File ========*/
			br.close();
		}
		catch (IOException ioe) {
			System.out.println(ioe);
		}
	}	
	
	/*================ Auxilliary methods =====================*/
	
	public static void debugPrint(String str, boolean print) {
		if (print) {
			System.out.println(str);
		}
	}
	
	public static void debugPrint(String str) {
		debugPrint(str, globalDebugVariable);
	}
}