/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2013
   Qualifier
   Problem 1
   
   1.0
   by Jos Alberto Bonilla Vera (2013)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.io.*;
import java.text.*;

//import com.rits.cloning.*;
//import org.objenesis.*;

//import helper.Helper;
//import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QualifierProblem1 {
	
	private static BufferedReader br;
	private static BufferedWriter bw;

	public static void solveProblem(String[] args) {
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		
		String[][] board;
		int numFilled;
		boolean xWon;
		boolean oWon;
						
		/*======== Logic ========*/
		try {
		
			/*======== Read Number of Cases ========*/
			numCases = Integer.parseInt(br.readLine());

			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {
			
				board = new String[4][4];
				numFilled = 0;
				
				xWon = false;
				oWon = false;
				
				/*======== Read Each Case ========*/
				
				for (int j=0; j<4; j++) {
					thisLine = br.readLine();
					for (int k=0; k<4; k++) {
						board[j][k] = thisLine.substring(k,k+1);
						if (board[j][k].equals("O") || board[j][k].equals("X") || board[j][k].equals("T")) {
							numFilled++;
						}
					}
					
					
					System.out.print("[");
					for (int k=0; k<4; k++) {
						System.out.print(board[j][k]);
					}
					System.out.println("]");
					
				}
				
				// Read extra line
				thisLine = br.readLine();
				
				
				for (int rows=0; rows<4; rows++) {
					if (	(board[rows][0].equals("O") || board[rows][0].equals("T")) && 
							(board[rows][1].equals("O") || board[rows][1].equals("T")) && 
							(board[rows][2].equals("O") || board[rows][2].equals("T")) &&
							(board[rows][3].equals("O") || board[rows][3].equals("T"))
						) {
						oWon = true;
					}
					else if ( 	(board[rows][0].equals("X") || board[rows][0].equals("T")) && 
								(board[rows][1].equals("X") || board[rows][1].equals("T")) && 
								(board[rows][2].equals("X") || board[rows][2].equals("T")) &&
								(board[rows][3].equals("X") || board[rows][3].equals("T"))
							) {
						xWon = true;
					}					
				}
				for (int cols=0; cols<4; cols++) {
					if (	(board[0][cols].equals("O") || board[0][cols].equals("T")) && 
							(board[1][cols].equals("O") || board[1][cols].equals("T")) && 
							(board[2][cols].equals("O") || board[2][cols].equals("T")) &&
							(board[3][cols].equals("O") || board[3][cols].equals("T"))
						) {
						oWon = true;
					}
					else if ( 	(board[0][cols].equals("X") || board[0][cols].equals("T")) && 
								(board[1][cols].equals("X") || board[1][cols].equals("T")) && 
								(board[2][cols].equals("X") || board[2][cols].equals("T")) &&
								(board[3][cols].equals("X") || board[3][cols].equals("T"))
							) {
						xWon = true;
					}					
				}
				if (	(board[0][0].equals("O") || board[0][0].equals("T")) && 
						(board[1][1].equals("O") || board[1][1].equals("T")) && 
						(board[2][2].equals("O") || board[2][2].equals("T")) &&
						(board[3][3].equals("O") || board[3][3].equals("T"))
					) {
					oWon = true;
				}
				if (	(board[0][0].equals("X") || board[0][0].equals("T")) && 
						(board[1][1].equals("X") || board[1][1].equals("T")) && 
						(board[2][2].equals("X") || board[2][2].equals("T")) &&
						(board[3][3].equals("X") || board[3][3].equals("T"))
					) {
					xWon = true;
				}
				if (	(board[0][3].equals("O") || board[0][3].equals("T")) && 
						(board[1][2].equals("O") || board[1][2].equals("T")) && 
						(board[2][1].equals("O") || board[2][1].equals("T")) &&
						(board[3][0].equals("O") || board[3][0].equals("T"))
					) {
					oWon = true;
				}
				if (	(board[0][3].equals("X") || board[0][3].equals("T")) && 
						(board[1][2].equals("X") || board[1][2].equals("T")) && 
						(board[2][1].equals("X") || board[2][1].equals("T")) &&
						(board[3][0].equals("X") || board[3][0].equals("T"))
					) {
					xWon = true;
				}
				
				if (xWon) {
					result = "X won";
				}
				else if (oWon) {
					result = "O won";
				}
				else if (numFilled==16) {
					result = "Draw";
				}
				else {
					result = "Game has not completed";
				}
				
				System.out.println("Resultado: "+result);
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}

	public static void main(String[] args) {
		try {
			/*======== Open Input File ========*/
			br = new BufferedReader(new FileReader(args[0]));
			/*======== Open Output File ========*/
			bw = new BufferedWriter(new FileWriter(args[1]));
			/*======== Solve Problem ========*/
			solveProblem(args);
			
			/*======== Close Output File ========*/
			bw.close();
			/*======== Open Input File ========*/
			br.close();
		}
		catch (IOException ioe) {
			System.out.println(ioe);
		}
	}	
}