/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   GoogleCodeJam 2011
   Qualifying Round
   Problem A
   
   1.0
   by Jos Alberto Bonilla Vera (2011)
   Mexico
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Package name
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Java library imports
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.lang.reflect.*;
import java.math.*;
import java.util.*;
import java.io.*;
import java.text.*;

import com.rits.cloning.*;
import org.objenesis.*;

import helper.Helper;
import helper.AuxMath;


/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	Main Class
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class QR_ProblemA {
	
	private static BufferedReader br;
	private static BufferedWriter bw;

	public static void solveProblem(String[] args) {
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		int numButtons = 0;
		ArrayList orangePresses = new ArrayList();;
		ArrayList bluePresses = new ArrayList();;
		ArrayList presses = new ArrayList();
		int orangePos = 0;
		int bluePos = 0;
		int orangeTarget = 0;
		int blueTarget = 0;
		int numMoves = 0;
		
		
		/*======== Logic ========*/
		try {
		
			/*======== Read Number of Cases ========*/
			numCases = Integer.parseInt(br.readLine());
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {
			
				/*======== Read Each Case ========*/
				
				thisLine = br.readLine();
				splitLine = thisLine.split(" ");
				numButtons = Integer.parseInt(splitLine[0]);
				
				/*======== Solve Each Case ========*/
				
				orangePresses = new ArrayList();
				bluePresses = new ArrayList();
				presses = new ArrayList();
				orangePos = 1;
				bluePos = 1;
				numMoves = 0;
				
				for (int j=1; j<=2*numButtons; j=j+2) {
					presses.add(splitLine[j]);
					if (splitLine[j].equals("O")) {						
						orangePresses.add(splitLine[j+1]);
					}
					else { // "B"
						bluePresses.add(splitLine[j+1]);
					}
				}
				
				if (orangePresses.size() == 0) {
					orangePresses.add("1");
				}
				if (bluePresses.size() == 0) {
					bluePresses.add("1");
				}
				
				orangeTarget = Integer.parseInt(getPos(orangePresses,0));
				blueTarget = Integer.parseInt(getPos(bluePresses,0));
				
				for (int j=0; j<numButtons; j++) {
					// System.out.println("===---Press "+j+": (O,B) = ("+orangePos+","+bluePos+") ===");
					if ( ((String) presses.get(j)).equals("O") ) {
						while (orangePos != orangeTarget) {
							if (orangePos < orangeTarget) {
								orangePos++;
								numMoves++;
								// System.out.println(numMoves+": O ->");
							}
							else {
								orangePos--;
								numMoves++;
								// System.out.println(numMoves+": O <-");
							}
							
							if (blueTarget > 0 && bluePos < blueTarget) {
								bluePos++;
								// System.out.println(numMoves+": B ->");
							}
							else if (blueTarget > 0 && bluePos > blueTarget) {
								bluePos--;
								// System.out.println(numMoves+": B <-");
							}
							else {							
								// System.out.println(numMoves+": B x");
							}
						}
						
						numMoves++;
						if (blueTarget > 0 && bluePos < blueTarget) {
							bluePos++;
							// System.out.println(numMoves+": B ->");
						}
						else if (blueTarget > 0 && bluePos > blueTarget) {
							bluePos--;
							// System.out.println(numMoves+": B <-");
						}
						else {							
							// System.out.println(numMoves+": B x");
						}
						
						orangePresses.remove(0);
						orangeTarget = Integer.parseInt(getPos(orangePresses,0));
						// System.out.println(numMoves+": O (press)  --  Next target: "+orangeTarget);
						
					}
					else { // "B"
						while (bluePos != blueTarget) {
							if (bluePos < blueTarget) {
								bluePos++;
								numMoves++;
								// System.out.println(numMoves+": B ->");
							}
							else {
								bluePos--;
								numMoves++;
								// System.out.println(numMoves+": B <-");
							}
							
							if (orangeTarget > 0 && orangePos < orangeTarget) {
								orangePos++;
								// System.out.println(numMoves+": O ->");
							}
							else if (orangeTarget > 0 && orangePos > orangeTarget) {
								orangePos--;
								// System.out.println(numMoves+": O <-");
							}
							else {							
								// System.out.println(numMoves+": O x");
							}
						}
						
						numMoves++;												
						if (orangeTarget > 0 && orangePos < orangeTarget) {
							orangePos++;
							// System.out.println(numMoves+": O ->");
						}
						else if (orangeTarget > 0 && orangePos > orangeTarget) {
							orangePos--;
							// System.out.println(numMoves+": O <-");
						}
						else {							
							// System.out.println(numMoves+": O x");
						}
						
						bluePresses.remove(0);
						blueTarget = Integer.parseInt(getPos(bluePresses,0));
						// System.out.println(numMoves+": B (press)  --  Next target: "+blueTarget);
					}
				}
				System.out.println(numMoves);
				result = ""+numMoves;
				//System.out.println(result);
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ": " + result + "\r\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();			
		}
	}
	
	public static String getPos(ArrayList lst, int p) {
		if (p >= lst.size()) {
			return "0";
		}
		else {
			return (String) lst.get(p);
		}
	}

	public static void main(String[] args) {
		/*======== Open Input File ========*/
		br = Helper.createReadFile(args[0]);
		/*======== Open Output File ========*/
		bw = Helper.createWriteFile(args[1]);			
		/*======== Solve Problem ========*/
		solveProblem(args);
		
		/*======== Close Output File ========*/
		Helper.closeWriteFile(bw);
		/*======== Open Input File ========*/
		Helper.closeReadFile(br);
	}	
}