/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
   GoogleCodeJam 2009 Java Template   
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   1.0
   by Jos Alberto Bonilla Vera   
   Mexico                             
   
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   Round: Qualifying Round
   Problem Name: Watersheds
   Class Name: Watersheds
   ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
   
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Package name ~~~~~~~~~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

package qualifying;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Java library imports ~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

import java.lang.*;
import java.math.*;
import java.io.*;
import java.util.*;
import java.text.*;

import helper.Helper;

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Main Class ~~~~~~~~~~~~~~~~~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

public class Watersheds {

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Class Constant Declarations ~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Class Variable Declarations ~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/	
	
	private static BufferedReader br;
	private static BufferedWriter bw;
	
	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Helper Methods ~~~~~~~~~~~~~~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	private static void createReadFile(String fileName) {
		try { 
			br = new BufferedReader(new FileReader(fileName));
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void createWriteFile(String fileName) {
		try {
			bw = new BufferedWriter(new FileWriter(fileName));
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void closeReadFile() {
		try { 
			br.close();
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	private static void closeWriteFile() {
		try {
			bw.close();
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}
	
	
	static int minimum(int[][] matrix, int i, int j) {
		int north_i = i-1;
		int north_j = j;
		int west_i = i;
		int west_j = j-1;
		int east_i = i;
		int east_j = j+1;
		int south_i = i+1;
		int south_j = j;
		
		int min_value = matrix[i][j];
		String argmin = "C";
		
		if (valid(matrix, north_i, north_j)) {
			if (min_value > matrix[north_i][north_j]) {			
				min_value = matrix[north_i][north_j];
				argmin = "N";
			}
		}
		if (valid(matrix, west_i, west_j)) {
			if (min_value > matrix[west_i][west_j]) {			
				min_value = matrix[west_i][west_j];
				argmin = "W";
			}
		}
		if (valid(matrix, east_i, east_j)) {
			if (min_value > matrix[east_i][east_j]) {			
				min_value = matrix[east_i][east_j];
				argmin = "E";
			}
		}
		if (valid(matrix, south_i, south_j)) {
			if (min_value > matrix[south_i][south_j]) {			
				min_value = matrix[south_i][south_j];
				argmin = "S";
			}
		}
		
		return min_value;
		
	}
	static String argminimum(int[][] matrix, int i, int j) {
		int north_i = i-1;
		int north_j = j;
		int west_i = i;
		int west_j = j-1;
		int east_i = i;
		int east_j = j+1;
		int south_i = i+1;
		int south_j = j;
		
		int min_value = matrix[i][j];
		String argmin = "C";
		
		if (valid(matrix, north_i, north_j)) {
			if (min_value > matrix[north_i][north_j]) {			
				min_value = matrix[north_i][north_j];
				argmin = "N";
			}
		}
		if (valid(matrix, west_i, west_j)) {
			if (min_value > matrix[west_i][west_j]) {			
				min_value = matrix[west_i][west_j];
				argmin = "W";
			}
		}
		if (valid(matrix, east_i, east_j)) {
			if (min_value > matrix[east_i][east_j]) {			
				min_value = matrix[east_i][east_j];
				argmin = "E";
			}
		}
		if (valid(matrix, south_i, south_j)) {
			if (min_value > matrix[south_i][south_j]) {			
				min_value = matrix[south_i][south_j];
				argmin = "S";
			}
		}
		
		return argmin;
		
	}
	static boolean valid(int[][] matrix, int i, int j) {
		return (i>=0 && i<matrix.length && j>=0 && j<matrix[0].length);
	}
	static String checkBasin(String[][] directionMatrix, int i, int j, int basin_i, int basin_j) {
		/*System.out.println("Checando "+basin_i+","+basin_j+" cuyo valor es "+directionMatrix[basin_i][basin_j]);*/
		if (directionMatrix[basin_i][basin_j].equals("C")) {
			return "("+basin_i+","+basin_j+")";
		}
		else {
			if (directionMatrix[basin_i][basin_j].equals("N")) {
				return checkBasin(directionMatrix,i,j,basin_i-1,basin_j);
			}
			else if (directionMatrix[basin_i][basin_j].equals("W")) {
				return checkBasin(directionMatrix,i,j,basin_i,basin_j-1);
			}
			else if (directionMatrix[basin_i][basin_j].equals("E")) {
				return checkBasin(directionMatrix,i,j,basin_i,basin_j+1);
			}
			else {
				return checkBasin(directionMatrix,i,j,basin_i+1,basin_j);
			}
		}
	}
	
	/*======== Main method for solving ========*/
	
	private static void solveProblem(String[] args) {
	
		/*======== Persistent Variable declarations ========*/
		String thisLine = "";
		int numCases = 0;
		String result = "";
		String[] splitLine;
		
		/*======== Problem-specific Variable declarations ========*/
		
		int rows;
		int columns;
		int[][] map;
		int[][] minMap;
		String[][] argminMap;
		String[][] solutionMap;
		ArrayList sinks;
		String tempSink = "";		
		
		/*======== Logic ========*/
		try {
		
			/*======== Read Number of Cases ========*/
			numCases = Integer.parseInt(br.readLine());
			
			/*======== Process each case ========*/
			for (int i=1; i<=numCases; i++) {
			
				/*======== Read Each Case ========*/
				
				thisLine = br.readLine();
				splitLine = thisLine.split(" ");
				rows = Integer.parseInt(splitLine[0]);
				columns = Integer.parseInt(splitLine[1]);
				map = new int[rows][columns];
				minMap = new int[rows][columns];
				argminMap = new String[rows][columns];
				solutionMap = new String[rows][columns];
				sinks = new ArrayList();
				
				for (int j=0; j<rows; j++) {
					thisLine = br.readLine();
					splitLine = thisLine.split(" ");
					for (int k=0; k<columns; k++) {
						map[j][k] = Integer.parseInt(splitLine[k]);
					}
				}
				
				/*======== Solve Each Case ========*/
				
				for (int j=0; j<rows; j++) {
					for (int k=0; k<columns; k++) {
						minMap[j][k] = minimum(map,j,k);
						argminMap[j][k] = argminimum(map,j,k);
					}
				}
				
				/*Helper.printIntMatrix(map);
				Helper.printIntMatrix(minMap);
				Helper.printStringMatrix(argminMap);*/
				
				for (int j=0; j<rows; j++) {
					for (int k=0; k<columns; k++) {
						tempSink = checkBasin(argminMap,j,k,j,k);
						/*System.out.println("("+j+","+k+")-"+tempSink);*/
						if (sinks.indexOf(tempSink) == -1) {
							sinks.add(tempSink);
						}
						solutionMap[j][k] = "" + ( (char) (97+sinks.indexOf(tempSink)) );
					}
				}
				
				/*======== Write the result of the case to file ========*/
				bw.write("Case #" + i + ":" + "\r\n");
				for (int j=0; j<rows; j++) {
					for (int k=0; k<columns; k++) {
						bw.write(solutionMap[j][k]);
						if (k < columns - 1) {							
							bw.write(" ");
						}
					}
					if (j < rows-1) {
						bw.write("\r\n");
					}
				}
				if(i < numCases) {
					bw.write("\r\n");
				}
				
			}
		}
		catch (Exception e) {
			System.out.println("Access file error");
		}
	}

	/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
	~~ Main Program ~~~~~~~~~~~~~~~~~~~~~~~~
	~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
	
	/*
		Persistent Parameter List
		-----------------------------------
		args[0] = Input file
		args[1] = Output file
		
	*/
	
	public static void main(String[] args) {
	
			
		/*======== Open Input File ========*/
		createReadFile(args[0]);
		/*======== Open Output File ========*/
		createWriteFile(args[1]);			
		/*======== Solve Problem ========*/
		solveProblem(args);
		
		/*======== Close Output File ========*/
		closeWriteFile();
		/*======== Open Input File ========*/
		closeReadFile();

	}
}

/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
~~ Helper Classes for Problem ~~~~~~~~~~
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

