import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.TreeSet;

public class GCJ_2013_R2_1 {
	
	public static long minRevenue(long N, TreeMap<Integer,Long> geton, TreeMap<Integer,Long> getoff) {
		
		TreeSet<Integer> sl = new TreeSet<Integer>();
		
		sl.addAll(geton.keySet());
		sl.addAll(getoff.keySet());

		TreeMap<Integer,Long> pfrom = new TreeMap<Integer,Long>();
		long allp = 0;
		
		long rev = 0;
		
		for (Integer s = sl.first(); s != null;  s = sl.higher(s))
		{
			long on = 0;
			if (geton.get(s) != null) on = geton.get(s);
			long off = 0;
			if (getoff.get(s) != null) off = getoff.get(s);

//			System.out.printf("s: %d  on: %d off: %d  all: %d \n",s,on,off,allp);

			
			allp += on;
			
			if (on > 0)
				pfrom.put(s, on);
			
			while (off > 0)
			{
				int lasts = pfrom.lastKey();
				long fromlast = pfrom.get(lasts);
				long ol = Math.min (fromlast , off);
				off -= ol;
				allp -= ol;
				long d = s - lasts;
				rev += ol * (d * N - (d*(d-1)/2));
				if (fromlast - ol > 0)
					pfrom.put(lasts, fromlast - ol);
				else
					pfrom.remove(lasts);
			}
			
		}
		System.out.printf("***   %d\n",rev);
		return rev;
	}

	public static void main(String[] args) throws Exception {
//		String fname = "A_example";
		String fname = "A_small";
//		String fname = "A_large";
		
		File file = new File(fname+"_in.txt");
		Scanner scanner = new Scanner(file);

		FileWriter outFile = new FileWriter(fname+"_out.txt");
		PrintWriter outp = new PrintWriter(outFile);
		
		int T = scanner.nextInt();
		scanner.nextLine();
		for (int i=1;i<=T;i++)
		{
			long N = scanner.nextInt();
			long M = scanner.nextInt();
			
			long honestRev = 0;
			
			TreeMap<Integer,Long> geton = new TreeMap<Integer,Long>();
			TreeMap<Integer,Long> getoff = new TreeMap<Integer,Long>();
			
			for (int j=0;j<M;j++)
			{
				int o = scanner.nextInt();
				int e = scanner.nextInt();
				long p = scanner.nextLong();
				long d = e-o;
				honestRev += p * (long)( N * d - (d-1) * d /2);
				
				if (geton.get(o) == null)
					geton.put(o, 0l);
				geton.put(o, geton.get(o) + p);
				
				if (getoff.get(e) == null)
					getoff.put(e, 0l);
				getoff.put(e, getoff.get(e) + p);
			}
			
			long minRev = minRevenue(N,geton,getoff);

			outp.printf("Case #%d: %d\n",i,honestRev - minRev);
		}
		
		outp.close();

	}

}
