import java.io.*;

/**
 * Created by kaehler on 15.04.2017.
 */
public class Round1AProblem1 {

    public static FileReader reader = null;
    public static BufferedReader br = null;
    public static FileWriter writer = null;
    public static BufferedWriter bw = null;

    private static final String FOLDER = "C:\\Users\\admin\\Jam\\1A\\1\\Large\\";

    public static int caseNumber = 0;
    public static void main (String[] args){
        try {
            reader = new FileReader(new File(FOLDER + "A-large.in"));
            br = new BufferedReader(reader);

            writer = new FileWriter(new File(FOLDER + "Output.out"));
            bw = new BufferedWriter(writer);


            String line1 = br.readLine();
            Integer testCaseCount = Integer.parseInt(line1);

            for (int i = 0; i < testCaseCount; i++){
                caseNumber = i+1;
                String titleLine = br.readLine();
                String[] titleArray = titleLine.split(" ");
                int rows = Integer.parseInt(titleArray[0]);
                int columns = Integer.parseInt(titleArray[1]);

                String[][] cake = new String[rows][columns];

                for(int j = 0; j < rows; j++){
                    String row = br.readLine();
                    cake[j] = row.split("");
                }

                solveLine(rows, columns, cake);
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if(br != null){
                try {
                    br.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            if(reader!=null)
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }


            if(bw != null){
                try {
                    bw.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

    }

    private static void solveLine(int rows, int columns, String[][] cake) throws IOException {
        boolean[] columnEmpty = new boolean[columns];

        for (int i = 0; i < columns; i++){
            boolean empty = true;
            for(int j = 0; j < rows; j++){
                if(!cake[j][i].equalsIgnoreCase("?")){
                    empty = false;
                }
            }
            columnEmpty[i] = empty;
        }

        //Greedy fill all not empty columns
        for(int i = 0; i < columns; i++){
            if(!columnEmpty[i]){
                for(int j = 0; j < rows; j++){
                    if(!cake[j][i].equalsIgnoreCase("?")){
                        String initial = cake[j][i];

                        //Go up
                        for(int k = j-1; k >=0; k--){
                            if(cake[k][i].equalsIgnoreCase("?")){
                                cake[k][i] = initial;
                            } else {
                                // Stop if other childs cake is seen
                                break;
                            }
                        }
                        //Go down
                        for(int k = j+1; k < rows; k++){
                            if(cake[k][i].equalsIgnoreCase("?")){
                                cake[k][i] = initial;
                            } else {
                                // Stop if other childs cake is seen
                                break;
                            }
                        }
                    }
                }
            }
        }
        //Greedy fill all empty Columns
        for(int i = 0; i < columns; i++){
            if(columnEmpty[i]){
                boolean hasBeenFilled = false;
                //Fill with last, if not there, with next
                for(int x = i-1; x >= 0; x--){
                    if(!columnEmpty[x]){
                        for(int y = 0; y < rows; y++){
                            cake[y][i]=cake[y][x];
                        }
                        hasBeenFilled = true;
                        break;
                    }
                }

                if(!hasBeenFilled){
                    //Fill with next
                    for(int x = i+1; x < columns; x++){
                        if(!columnEmpty[x]){
                            for(int y = 0; y < rows; y++){
                                cake[y][i]=cake[y][x];
                            }
                            break;
                        }
                    }
                }
                columnEmpty[i] = false;
            }
        }


        bw.append("Case #"+caseNumber+":");
        bw.newLine();
        for(int i = 0; i < rows; i++){
            for(int j = 0; j < columns; j++){
                bw.append(cake[i][j]);
            }
            bw.newLine();
        }
    }

}
