import java.io.*;
import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collections;

/**
 * Created by kaehler on 15.04.2017.
 */
public class
        Round1AProblem2 {

    public static FileReader reader = null;
    public static BufferedReader br = null;
    public static FileWriter writer = null;
    public static BufferedWriter bw = null;

    private static final String FOLDER = "C:\\Users\\admin\\Jam\\1A\\2\\Large\\";

    public static int caseNumber = 0;
    public static void main (String[] args){
        try {
            reader = new FileReader(new File(FOLDER + "B-large.in"));
            br = new BufferedReader(reader);

            writer = new FileWriter(new File(FOLDER + "Output.out"));
            bw = new BufferedWriter(writer);


            String line1 = br.readLine();
            Integer testCaseCount = Integer.parseInt(line1);

            for (int i = 0; i < testCaseCount; i++){
                caseNumber = i+1;
                String titleLine = br.readLine();
                String[] titleArray = titleLine.split(" ");
                int ingredients = Integer.parseInt(titleArray[0]);
                int packages = Integer.parseInt(titleArray[1]);

                String servingInput = br.readLine();

                String[] serving = servingInput.split(" ");
                int[] servingI = new int[serving.length];
                for(int j = 0; j < ingredients; j++){
                    servingI[j] = Integer.parseInt(serving[j]);
                }

                ArrayList<ArrayList<Integer>> palette = new ArrayList<>();

                for(int j = 0; j < ingredients; j++){
                    palette.add(new ArrayList<>());
                    String packageString = br.readLine();
                    String[] packageArray = packageString.split(" ");

                    for(int k = 0; k < packages; k++){
                        palette.get(j).add(k, Integer.valueOf(packageArray[k]));
                    }
                }

                solveLine(ingredients, packages, palette, servingI);
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            if(br != null){
                try {
                    br.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }

            if(reader!=null)
                try {
                    reader.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }


            if(bw != null){
                try {
                    bw.close();
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
        }

    }

    private static void solveLine(int ingredients, int packages, ArrayList<ArrayList<Integer>> palette, int[] serving) throws IOException {
        int kits = 0;
        //Delete Packages that won't fit at all
        for(int i = 0; i < ingredients; i++){
            ArrayList<Integer> newPackages = new ArrayList<>();
            for(int j = 0; j < packages; j++){
                Integer size = palette.get(i).get(j);
                int bestFitServings = Math.round(((float) size) / serving[i]);
                float originalSize = bestFitServings*serving[i];
                float factor = size / originalSize;

                if(factor <= 1.1f && factor >= 0.9f){
                    newPackages.add(size);
                }
            }
            palette.get(i).clear();
            palette.get(i).addAll(newPackages);
        }

        //Sort Packages
        for(int i = 0; i < ingredients; i++){
            Collections.sort(palette.get(i));
        }

        int[] currentPackage = new int[ingredients];
        int[] maxPackage = new int[ingredients];

        for(int i = 0; i < ingredients; i++){
            maxPackage[i] = palette.get(i).size();
        }

        for(int i = 0; i < maxPackage[0]; i++){
            //check if all ingredients are available
            boolean allAvailable = true;
            for(int x = 0; x < ingredients; x++){
                if(currentPackage[x] >= maxPackage[x])
                    allAvailable = false;
            }

            if(!allAvailable)
                break;

            int currentWeight = palette.get(0).get(i);
            int optimalServings = Math.round(((float)palette.get(0).get(i))/serving[0]);
            int minimalServings = optimalServings;
            int maximalServings = optimalServings;

            while(((float)currentWeight)/((minimalServings-1)*serving[0]) <= 1.1f && minimalServings > 1){
                minimalServings--;
            }

            while(((float)currentWeight)/((maximalServings + 1)*serving[0]) >= 0.9f){
                maximalServings++;
            }

            int[] currentServing = new int[ingredients];
            currentServing[0] = i;

            boolean canServe = true;
            for(int j = 1; j < ingredients; j++){
                boolean canServeIngredient = false;
                int servedPackage = currentPackage[j];
                for(; servedPackage < palette.get(j).size(); servedPackage++){

                    int possibleWeight = palette.get(j).get(servedPackage);
                    int possibleOptimalServings = Math.round(((float)palette.get(j).get(servedPackage))/serving[j]);
                    int possibleMinimalServings = possibleOptimalServings;
                    int possibleMaximalServings = possibleOptimalServings;


                    while(((float)currentWeight)/((minimalServings-1)*serving[0]) <= 1.1f && minimalServings > 1){
                        minimalServings--;
                    }

                    while(((float)currentWeight)/((maximalServings + 1)*serving[0]) >= 0.9f){
                        maximalServings++;
                    }




                    while(((float)possibleWeight)/((possibleMinimalServings-1)*serving[j]) <= 1.1f && possibleMinimalServings > 1){
                        possibleMinimalServings--;
                    }

                    while(((float)possibleWeight)/((possibleMaximalServings+1)*serving[j]) >= 0.9f){
                        possibleMaximalServings++;
                    }

                    if(possibleMinimalServings <= maximalServings && possibleMaximalServings >= minimalServings){
                        canServeIngredient = true;
                        currentServing[j] = servedPackage;
                        if(possibleMinimalServings > minimalServings){
                            minimalServings = possibleMinimalServings;
                        }
                        if(possibleMaximalServings < maximalServings){
                            maximalServings = possibleMaximalServings;
                        }
                        break;
                    }
                }
                if(!canServeIngredient){
                    canServe = false;
                    break;
                }
            }
            if(canServe){
                kits++;
                for ( int x = 0; x < ingredients; x++){
                    currentPackage[x] = currentServing[x]+1;
                }
            }
        }



        bw.append("Case #"+caseNumber+": "+kits);
        bw.newLine();
    }

}
