package codejam;

import java.util.*;
import java.io.*;
import java.math.BigInteger;


public class QR2016C {
	
	public static BigInteger smallestFactor(BigInteger C)
	{
		if (C.isProbablePrime(1)) { return C; }
		
		BigInteger maxCount = new BigInteger("10000");
		for (BigInteger count=new BigInteger("2"); count.compareTo(C) < 0; count = count.add(BigInteger.ONE))
		{
			if (count.compareTo(maxCount) >0) {return C; }
			
			BigInteger bi3 = C.remainder(count);
			if (bi3.compareTo(BigInteger.ZERO)==0){
				return count;
			}
		}

	    return C;
	}
	
	public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
		File file = new File("C:\\codejam\\C-small-attempt0.in");
	    
		PrintWriter writer = new PrintWriter("C:\\codejam\\C-small-attempt0.out", "UTF-8");
        Scanner input = new Scanner(file);
     
        int totalTest = input.nextInt();
        
        for (int test=0; test < totalTest; test++){
        	int digits = input.nextInt();
        	int matches = 0;
        	int matchesReq = input.nextInt();
        	writer.printf("Case #1:\n");
        	System.out.printf("Case #1:\n");
        	BigInteger i = new BigInteger("2");
        	BigInteger bi1 = i.pow(digits-1);
        	BigInteger bi2 = i.pow(digits);
        	
        	for (BigInteger count=bi1; bi1.compareTo(bi2) < 0; count = count.add(BigInteger.ONE)){
        	    String number = count.toString(2);
//        	    System.out.println(number);
//        	    System.out.println(count);
        	    boolean allMatch = true;
        	    String output = "";
        	    output+=number + " ";
        	    String divOutput = "";
        	    divOutput+=number + " ";
        	    if (Character.getNumericValue(number.charAt(0)) == 1 && Character.getNumericValue(number.charAt(digits-1)) == 1){
        	    	for (int j=2; j<=10;j++){
        	    		BigInteger baseNumber = new BigInteger(number,j);
        	    		BigInteger divisor = smallestFactor(baseNumber);
        	    		if (baseNumber.compareTo(divisor)!= 0){
        	    			output+=divisor + " ";
        	    			divOutput+=baseNumber + " ";
        	    		} else {
        	    			allMatch = false;
        	    			break;
        	    		}
        	    	}
        	    } else{
        	    	allMatch = false;
        	    }
        	    if (allMatch){
        	    	output+="\n";
        	    	divOutput+="\n";
        	    	matches++;
        	    	writer.printf(output);
        	    	System.out.printf(output);
//        	    	System.out.printf(divOutput);
        	    }
        	    if (matches>=matchesReq){
        	    	break;
        	    }
        	}
        }
        writer.close();
	}

}
