
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Bharu
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        Main main = new Main();
        main.start();
    }

    public void start() throws Exception {
        //System.out.println("The GCF of 653864 and 52984 is " + fastGCF(653864, 52984));
        
        BufferedReader inStr = new BufferedReader(new InputStreamReader(System.in));
        String fileName = inStr.readLine();

        BufferedReader in = new BufferedReader(new FileReader(fileName + ".in"));

        BufferedWriter out = new BufferedWriter(new FileWriter(fileName + ".out"));

        int noOfTestCases = Integer.parseInt(in.readLine());

        for (int i = 0; i < noOfTestCases; i++) {
            //System.out.println("Case # " + (i + 1));
            String testCase = in.readLine();
            StringTokenizer st = new StringTokenizer(testCase);

            int noOfEvents = Integer.parseInt(st.nextToken());

            long[] initialArray = new long[noOfEvents];
            int eventArrayCounter = 0;
            for (int j = 0; j < noOfEvents; j++) {
                long nextEvent = Long.parseLong(st.nextToken());
                boolean eventExists = false;
                // Add the event only if it doesn't exist yet
                for (int k = 0; k < j; k++) {
                    if (initialArray[k] == nextEvent) {
                        eventExists = true;
                        break;
                    }
                }
                if (!eventExists) {
                    initialArray[eventArrayCounter] = nextEvent;
                    eventArrayCounter++;
                }
            }
            //System.out.println("The intiail array lenegth is " + initialArray.length);

            long[] eventArray = new long[eventArrayCounter];
            // Now copy over to eventArray
            for (int j = 0; j < eventArrayCounter; j++) {
                eventArray[j] = initialArray[j];
            }
            //System.out.println("The event array lenegth is " + eventArray.length);

            long optAniv = calculateOptAniv(eventArray);

            //System.out.println("Opt aniv for case " + (i + 1) + " is " + optAniv);

            out.write("Case #" + (i + 1) + ": " + optAniv);
            out.write("\n");
        }

        if (in != null) {
            in.close();
        }

        if (out != null) {
            out.close();
        }

    }

    private long calculateOptAniv(long[] eventArray) {
        //System.out.println("The size of the event array is " + eventArray.length);
        long optAniv = 0;

        // Store the differences into a separate array
        long[] eventDiffs = new long[eventArray.length - 1];
        for (int i = 0; i < eventDiffs.length; i++) {
            eventDiffs[i] = Math.abs(eventArray[i] - eventArray[i + 1]);
        }
        //System.out.println("The size of the event diff array is " + eventDiffs.length);

        long firstElem = eventDiffs[0];
        long GCF = 0;

        // Calculate the GCF of the differences
        if (eventDiffs.length >= 2) {
            for (int i = 0; i < eventDiffs.length - 1; i++) {
                GCF = fastGCF(firstElem, eventDiffs[i + 1]);
                firstElem = GCF;
            }
        } else {
            GCF = firstElem;
        }

        //System.out.println("The GCF is " + GCF);

        // Once we have the GCF of all the differences of events, we have to find the apocalypse time
        // If the GCF is 1, that means there will be no apocalypse
        if (GCF == 1) {
            optAniv = 0;
        } else {
            // It can be calculated by getting the time for any event to be a factor of the GCF
            // That is finding the multiple of the GCF that is greater than the last event
            long nextMult = nextMultiple(GCF, eventArray[eventArray.length - 1]);
            optAniv = nextMult - eventArray[eventArray.length - 1];
        }

        //System.out.println("The opt aniv is " + optAniv);

        return optAniv;
    }

    private long fastGCF(long a, long b) {

        long max = Math.max(a, b);
        long min = Math.min(a, b);
        long rem = max % min;

        while (rem != 0) {
            max = min;
            min = rem;
            rem = max % min;
        }

        return min;
    }

    private long nextMultiple(long GCF, long number) {
        long nextMult = GCF;

        int counter = 2;

        while (nextMult < number) {
        //while (nextMult <= number) {
            nextMult = GCF * counter;
            counter++;
        }

        //System.out.println("The next multiple is " + nextMult);

        return nextMult;
    }
}
