
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Bharu
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        // TODO code application logic here
        Main main = new Main();
        main.start();
    }

    public void start() throws Exception {

        BufferedReader inStr = new BufferedReader(new InputStreamReader(System.in));
        String fileName = inStr.readLine();

        //BufferedReader in = new BufferedReader(new FileReader("Sample.in"));

        //BufferedWriter out = new BufferedWriter(new FileWriter("Sample.out"));

        BufferedReader in = new BufferedReader(new FileReader(fileName + ".in"));

        BufferedWriter out = new BufferedWriter(new FileWriter(fileName + ".out"));

        int noOfTestCases = Integer.parseInt(in.readLine());

        for (int i = 0; i < noOfTestCases; i++) {

            String firstLine = in.readLine();
            StringTokenizer firstLineTokens = new StringTokenizer(firstLine);
            long noOfRides = Long.parseLong(firstLineTokens.nextToken());
            //System.out.println("The no of rides is "+noOfRides);
            long capacity = Long.parseLong(firstLineTokens.nextToken());
            //System.out.println("The capacity is "+capacity);
            int noOfGroups = Integer.parseInt(firstLineTokens.nextToken());
            //System.out.println("The noOfGroups is "+noOfGroups);

            String secondLine = in.readLine();
            int[] groupArray = new int[noOfGroups];
            StringTokenizer secondLineTokens = new StringTokenizer(secondLine);
            int groupIndex = 0;
            //System.out.println("The group sizes are : ");
            while(secondLineTokens.hasMoreTokens()) {
                groupArray[groupIndex++] = Integer.parseInt(secondLineTokens.nextToken());
                //System.out.println(groupArray[groupIndex-1]+"");
            }

            long totalFare = calculateTotalFare(noOfRides, capacity, groupArray);

            //System.out.println("Case #" + (i + 1) + ": "+totalFare);
            out.write("Case #" + (i + 1) + ": "+totalFare);
            out.write("\n");
        }

        if (in != null) {
            in.close();
        }

        if (out != null) {
            out.close();
        }
    }

    private long calculateTotalFare(long noOfRides, long capacity, int[] groupArray) {
        long totalFare = 0;

        int curArrayPos = 0;
        int groupSize = groupArray.length;

        // Iterate through all the rides
        for(long i=0;i<noOfRides;i++) {
            
            // 1. Maintain the starting position of the array so that the list can be perceived with out rearranging
            long currCapacity = 0;
            
            int groupsAlreadyAdded = 0;

            // Continue adding to the ride until until there are no more groups left or there is no room for the next group
            while(groupsAlreadyAdded < groupSize && currCapacity+groupArray[curArrayPos] <= capacity) {
                currCapacity += groupArray[curArrayPos];
                totalFare += groupArray[curArrayPos];
                // Cannot simply increment currArrayPos; it has to be circular
                curArrayPos = (curArrayPos+1)%groupSize;
                groupsAlreadyAdded++;
            }


            // 2. Probably identify at what point the original list will repeat (in other words, the pointer comes back to 0) and calculate the total fare until then
            // 3. From then, its a matter of calculating how many times the pattern will repeat
        }

        return totalFare;
    }
}
