
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Bharu
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        // TODO code application logic here
        Main main = new Main();
        main.start();
    }

    public void start() throws Exception {

        BufferedReader inStr = new BufferedReader(new InputStreamReader(System.in));
        String fileName = inStr.readLine();

        //BufferedReader in = new BufferedReader(new FileReader("Sample.in"));

        //BufferedWriter out = new BufferedWriter(new FileWriter("Sample.out"));

        BufferedReader in = new BufferedReader(new FileReader(fileName + ".in"));

        BufferedWriter out = new BufferedWriter(new FileWriter(fileName + ".out"));

        int noOfTestCases = Integer.parseInt(in.readLine());

        for (int i = 0; i < noOfTestCases; i++) {
            String currTestCase = in.readLine();

            StringTokenizer st = new StringTokenizer(currTestCase);

            int noOfSnappers = Integer.parseInt(st.nextToken());
            int noOfSnaps = Integer.parseInt(st.nextToken());

            boolean lightOn = isLightOn(noOfSnappers, noOfSnaps);

            String result = "OFF";
            if(lightOn) {
                result = "ON";
            }

            out.write("Case #" + (i + 1) + ": "+result);
            out.write("\n");
        }

        if (in != null) {
            in.close();
        }

        if (out != null) {
            out.close();
        }

    }

    private boolean isLightOn(int noOfSnappers, int noOfSnaps) {
        boolean result = false;

        boolean[] snapperStatusArray = new boolean[noOfSnappers];
        boolean[] snapperPowerArray = new boolean[noOfSnappers];

        for (int i = 0; i < noOfSnappers; i++) {
            snapperStatusArray[i] = false;
            snapperPowerArray[i] = false;
        }

        int currSnap = 0;

        // Only the first snapper has power initially
        snapperPowerArray[0] = true;

        // Iterate through each snap and toggle status accordingly
        for (int i = 0; i < noOfSnaps; i++) {
            for (int j = 0; j < noOfSnappers; j++) {
                // Toggle status only when the snapper's power is on
                if (snapperPowerArray[j]) {
                    snapperStatusArray[j] = !snapperStatusArray[j];
                }

                // Power depends on the previous snapper's power and status
                if (j != 0) {
                    if (snapperStatusArray[j - 1] == true && snapperPowerArray[j - 1] == true) {
                        snapperPowerArray[j] = true;
                    } else {
                        snapperPowerArray[j] = false;
                    }
                }
            }

            // At the end of each snap, check whether the light connected to the last snapper is on
            // It is on only when the last snapper's status is ON and it is receiving power from its previous snapper
            if (snapperStatusArray[noOfSnappers - 1] == true && snapperPowerArray[noOfSnappers-1] == true) {
                currSnap = i + 1;
                //System.out.println("The light goes on in the " + currSnap + "th snap");
                break;
            }
        }

        // If the light ever went on, the pattern  repeats at the same interval
        if (currSnap != 0) {
            int remSnaps = noOfSnaps - currSnap;

            // The reminder of the remaining snaps divided by (currSnap+1)
            // Note that it'll be currsnap+1 as there will be the initial sequence after every light on
            if (remSnaps % (currSnap+1) == 0) {
                result = true;
            }

        }

        return result;
    }
}
