
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.StringTokenizer;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Bharu
 */
public class Main {

    private int MAX_NO_OF_SNAPPERS = 30;
    private int MAX_NO_OF_SNAPS = 100000000;
    HashMap<Integer, Integer> snapMap = new HashMap<Integer, Integer>();

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        // TODO code application logic here
        Main main = new Main();
        main.start();
    }

    public void start() throws Exception {

        calculateSnaps();
        /*for (Integer i : snapMap.keySet()) {
            System.out.println("The value for key " + i + " is " + snapMap.get(i));
        }*/

        BufferedReader inStr = new BufferedReader(new InputStreamReader(System.in));
        String fileName = inStr.readLine();

        //BufferedReader in = new BufferedReader(new FileReader("Sample.in"));

        //BufferedWriter out = new BufferedWriter(new FileWriter("Sample.out"));

        BufferedReader in = new BufferedReader(new FileReader(fileName + ".in"));

        BufferedWriter out = new BufferedWriter(new FileWriter(fileName + ".out"));

        int noOfTestCases = Integer.parseInt(in.readLine());

        for (int i = 0; i < noOfTestCases; i++) {
            //System.out.println("Test Case No : "+(i+1));
            String currTestCase = in.readLine();

            StringTokenizer st = new StringTokenizer(currTestCase);

            int noOfSnappers = Integer.parseInt(st.nextToken());
            int noOfSnaps = Integer.parseInt(st.nextToken());

            boolean lightOn = isLightOn(noOfSnappers, noOfSnaps);

            String result = "OFF";
            if (lightOn) {
                result = "ON";
            }

            out.write("Case #" + (i + 1) + ": " + result);
            out.write("\n");
        }

        if (in != null) {
            in.close();
        }

        if (out != null) {
            out.close();
        }

    }

    private boolean isLightOn(int noOfSnappers, int noOfSnaps) {
        //System.out.println("Test Case with no of snappers " + noOfSnappers + " and no of snaps " + noOfSnaps);
        boolean result = false;

        int requiredSnaps = 0;

        // Frist get the required snaps for the no of snappers given in the test case
        if (snapMap.get(noOfSnappers) != null) {
            requiredSnaps = snapMap.get(noOfSnappers);
        }

        if (requiredSnaps != 0 && noOfSnaps >= requiredSnaps && (noOfSnaps - requiredSnaps) % (requiredSnaps + 1) == 0) {
            result = true;
        }

        /*boolean[] snapperStatusArray = new boolean[noOfSnappers];
        boolean[] snapperPowerArray = new boolean[noOfSnappers];

        for (int i = 0; i < noOfSnappers; i++) {
        snapperStatusArray[i] = false;
        snapperPowerArray[i] = false;
        }

        int currSnap = 0;

        // Only the first snapper has power initially
        snapperPowerArray[0] = true;

        // Start with first 2 snappers and increment this only when the first two are ON
        int validSnappers = 2;

        // Except when no of snappers is 1
        if (noOfSnappers == 1) {
        validSnappers = 1;
        }

        // Iterate through each snap and toggle status accordingly
        for (int i = 0; i < noOfSnaps; i++) {
        //System.out.println("After the " + (i + 1) + "th snap");
        boolean snapperInc = true;

        for (int j = 0; j < validSnappers; j++) {
        // Toggle status only when the snapper's power is on
        if (snapperPowerArray[j]) {
        snapperStatusArray[j] = !snapperStatusArray[j];
        }

        // Power depends on the previous snapper's power and status
        if (j != 0) {
        if (snapperStatusArray[j - 1] == true && snapperPowerArray[j - 1] == true) {
        snapperPowerArray[j] = true;
        } else {
        snapperPowerArray[j] = false;
        }
        }

        //System.out.println("snapperStatusArray[j] is " + snapperStatusArray[j]);
        //System.out.println("snapperPowerArray[j] is " + snapperPowerArray[j]);

        if (snapperStatusArray[j] == true && snapperPowerArray[j] == true) {
        // do nothing
        } else {
        snapperInc = false;
        }
        }

        if (snapperInc == true && validSnappers < noOfSnappers) {
        validSnappers++;
        // Also initialize the latet vaid snapper's power to true
        snapperPowerArray[validSnappers-1] = true;
        //System.out.println("Incrementing valid snappers to " + (validSnappers) + " after " + (i + 1) + " snaps");
        }

        // At the end of each snap, check whether the light connected to the last snapper is on
        // It is on only when the last snapper's status is ON and it is receiving power from its previous snapper
        if (validSnappers == noOfSnappers && snapperStatusArray[noOfSnappers - 1] == true && snapperPowerArray[noOfSnappers - 1] == true) {
        currSnap = i + 1;
        //System.out.println("The light goes on in the " + currSnap + "th snap");
        break;
        }
        }

        // If the light ever went on, the pattern  repeats at the same interval
        if (currSnap != 0) {
        int remSnaps = noOfSnaps - currSnap;

        // The reminder of the remaining snaps divided by (currSnap+1)
        // Note that it'll be currsnap+1 as there will be the initial sequence after every light on
        if (remSnaps % (currSnap + 1) == 0) {
        result = true;
        }

        }*/

        return result;
    }

    // The no of snaps required to turn on a sequence is same regardless of the test case
    // So they can be stored in a hashmap and just retrieved based on the no of snappers in the test case
    private void calculateSnaps() {
        boolean[] snapperStatusArray = new boolean[MAX_NO_OF_SNAPPERS];
        boolean[] snapperPowerArray = new boolean[MAX_NO_OF_SNAPPERS];

        for (int i = 0; i < MAX_NO_OF_SNAPPERS; i++) {
            snapperStatusArray[i] = false;
            snapperPowerArray[i] = false;
        }

        int currSnap = 0;

        // Only the first snapper has power initially
        snapperPowerArray[0] = true;

        // Start with first 2 snappers and increment this only when the first two are ON
        int validSnappers = 2;

        // It requires only 1 snap for the light to be turned on with 1 snapper
        snapMap.put(1, 1);

        // Iterate through each snap and toggle status accordingly
        for (int i = 0; i < MAX_NO_OF_SNAPS; i++) {
            //System.out.println("After the " + (i + 1) + "th snap");
            boolean snapperInc = true;

            for (int j = 0; j < validSnappers; j++) {
                // Toggle status only when the snapper's power is on
                if (snapperPowerArray[j]) {
                    snapperStatusArray[j] = !snapperStatusArray[j];
                }

                // Power depends on the previous snapper's power and status
                if (j != 0) {
                    if (snapperStatusArray[j - 1] == true && snapperPowerArray[j - 1] == true) {
                        snapperPowerArray[j] = true;
                    } else {
                        snapperPowerArray[j] = false;
                    }
                }

                //System.out.println("snapperStatusArray[j] is " + snapperStatusArray[j]);
                //System.out.println("snapperPowerArray[j] is " + snapperPowerArray[j]);

                if (snapperStatusArray[j] == true && snapperPowerArray[j] == true) {
                    // do nothing
                } else {
                    snapperInc = false;
                }
            }

            if (snapperInc == true && validSnappers < MAX_NO_OF_SNAPPERS) {
                // Put the no. of snaps into the hashmap
                snapMap.put(validSnappers, i + 1);
                validSnappers++;
                // Also initialize the latest vaid snapper's power to true
                snapperPowerArray[validSnappers - 1] = true;
                //System.out.println("Incrementing valid snappers to " + (validSnappers) + " after " + (i + 1) + " snaps");
            }

            // At the end of each snap, check whether the light connected to the last snapper is on
            // It is on only when the last snapper's status is ON and it is receiving power from its previous snapper
            if (validSnappers == MAX_NO_OF_SNAPPERS && snapperStatusArray[MAX_NO_OF_SNAPPERS - 1] == true && snapperPowerArray[MAX_NO_OF_SNAPPERS - 1] == true) {
                currSnap = i + 1;
                //System.out.println("The light goes on in the " + currSnap + "th snap");
                break;
            }
        }
    }
}
