
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.StringTokenizer;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author Bharu
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws Exception {
        // TODO code application logic here
        Main main = new Main();
        main.start();
    }

    public void start() throws Exception {

        BufferedReader inStr = new BufferedReader(new InputStreamReader(System.in));
        String fileName = inStr.readLine();

        //BufferedReader in = new BufferedReader(new FileReader("Sample.in"));

        //BufferedWriter out = new BufferedWriter(new FileWriter("Sample.out"));

        BufferedReader in = new BufferedReader(new FileReader(fileName + ".in"));

        BufferedWriter out = new BufferedWriter(new FileWriter(fileName + ".out"));

        int noOfTestCases = Integer.parseInt(in.readLine());

        for (int i = 0; i < noOfTestCases; i++) {

            String firstLine = in.readLine();
            StringTokenizer firstLineTokens = new StringTokenizer(firstLine);
            long noOfRides = Long.parseLong(firstLineTokens.nextToken());
            //System.out.println("The no of rides is "+noOfRides);
            long capacity = Long.parseLong(firstLineTokens.nextToken());
            //System.out.println("The capacity is "+capacity);
            int noOfGroups = Integer.parseInt(firstLineTokens.nextToken());
            //System.out.println("The noOfGroups is "+noOfGroups);

            String secondLine = in.readLine();
            int[] groupArray = new int[noOfGroups];
            StringTokenizer secondLineTokens = new StringTokenizer(secondLine);
            int groupIndex = 0;
            //System.out.println("The group sizes are : ");
            while (secondLineTokens.hasMoreTokens()) {
                groupArray[groupIndex++] = Integer.parseInt(secondLineTokens.nextToken());
                //System.out.println(groupArray[groupIndex-1]+"");
            }

            long totalFare = calculateTotalFare(noOfRides, capacity, groupArray);

            //System.out.println("Case #" + (i + 1) + ": "+totalFare);
            out.write("Case #" + (i + 1) + ": " + totalFare);
            out.write("\n");
        }

        if (in != null) {
            in.close();
        }

        if (out != null) {
            out.close();
        }
    }

    private long calculateTotalFare(long noOfRides, long capacity, int[] groupArray) {
        long totalFare = 0;

        int curArrayPos = 0;
        int groupSize = groupArray.length;

        boolean[] visitedArray = new boolean[groupSize];
        for (int i = 0; i < groupSize; i++) {
            visitedArray[i] = false;
        }

        int[] patternTracker = new int[groupSize];
        for (int i = 0; i < groupSize; i++) {
            patternTracker[i] = 0;
        }

        int counter = 0;

        HashMap<Integer, Long> posVal = new HashMap<Integer, Long>();

        long remRides = 0;
        int repeatNumber = 0;
        int repeatPos = 0;

        //noOfRides = 1000000;

        // Iterate through all the rides
        for (long i = 0; i < noOfRides; i++) {

            // 1. Maintain the starting position of the array so that the list can be perceived with out rearranging
            long currCapacity = 0;

            int groupsAlreadyAdded = 0;

            int savedCurArrayPos = curArrayPos;

            long rideTotal = 0;

            // Check if the fare starting from this position is already calculated
            //if(posVal.get(savedCurArrayPos) != null) {
            if (visitedArray[curArrayPos] == true) {
                // It is already visited; hence it should trigger a pattern from here
                //System.out.println("It's a hit!");
                //System.out.println("The current pos is " + curArrayPos);
                repeatNumber = counter - patternTracker[curArrayPos];
                repeatPos = curArrayPos;
                
                // At this point, calculate the remaining rides
                remRides = noOfRides - i;
                break;
            } else {

                // Continue adding to the ride until until there are no more groups left or there is no room for the next group

                //System.out.println("The current pos is " + curArrayPos);

                while (groupsAlreadyAdded < groupSize && currCapacity + groupArray[curArrayPos] <= capacity) {
                    currCapacity += groupArray[curArrayPos];

                    rideTotal += groupArray[curArrayPos];

                    // Cannot simply increment currArrayPos; it has to be circular
                    curArrayPos = (curArrayPos + 1) % groupSize;

                    groupsAlreadyAdded++;
                }
            }

            visitedArray[savedCurArrayPos] = true;
            patternTracker[savedCurArrayPos] = counter;
            counter++;
            posVal.put(savedCurArrayPos, rideTotal);

            totalFare += rideTotal;

            //System.out.println("The total fare so far is "+totalFare);
            // 2. Probably identify at what point the original list will repeat (in other words, the pointer comes back to 0) and calculate the total fare until then
            // or probably store place values for each position in a separate array and use that place values instead of computing every time
            // or maintain a hash map with the positon and its "total fare value"
            // 3. From then, its a matter of calculating how many times the pattern will repeat
        }

        if (remRides != 0) {
            // Then see how many times it is going to be repeated in the remaing rides, using the repeat number
            long patternCount = remRides / repeatNumber;
            long partialCount = remRides % repeatNumber;
            /*System.out.println("The repeat number is " + repeatNumber);
            System.out.println("The remaining rides is " + remRides);
            System.out.println("The pattern count is " + patternCount);
            System.out.println("The partial count is " + partialCount);*/

            // Calculate the pattern total and partial total
            long patternTotal = 0;
            long partialTotal = 0;
            for (int i = 0; i < repeatNumber; i++) {

                long currCapacity = 0;

                int groupsAlreadyAdded = 0;

                //System.out.println("The current pos is " + curArrayPos);

                while (groupsAlreadyAdded < groupSize && currCapacity + groupArray[curArrayPos] <= capacity) {
                    currCapacity += groupArray[curArrayPos];

                    patternTotal += groupArray[curArrayPos];

                    // Cannot simply increment currArrayPos; it has to be circular
                    curArrayPos = (curArrayPos + 1) % groupSize;

                    groupsAlreadyAdded++;
                }

                //patternTotal += posVal.get(curArrayPos);
                //System.out.println("The pattern total is " + patternTotal);
                //curArrayPos = (curArrayPos + 1) % groupSize;

                if (i + 1 == partialCount) {
                    partialTotal = patternTotal;
                }
            }

            /*System.out.println("The pattern total is " + patternTotal);
            System.out.println("The partial total is " + partialTotal);*/

            totalFare += (patternTotal * patternCount) + partialTotal;
        }



        return totalFare;
    }
}
