import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;


public class Qual1 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File("/home/blarson/output")));
		final int numCases = readInt();
		
		for(int i = 0; i < numCases; i++) {
			out.print("Case #" + (i+1) + ": ");

			solve();
			
			out.println();
		}
		
		out.close();
	}

	static int[][] orange = new int[2][];
	static int[][] blue = new int[2][];
	
	private static void solve() throws IOException {
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		int numCommands = Integer.valueOf(data[0]);
		orange[0] = new int[numCommands+1];
		orange[1] = new int[numCommands+1];
		blue[0] = new int[numCommands+1];
		blue[1] = new int[numCommands+1];
		int orangeStep = 0, blueStep = 0;
		for(int i = 0; i < numCommands; i++) {
			if(data[i*2+1].equals("O")) {
				orange[0][orangeStep] = Integer.valueOf(data[i*2+2]) - 1;
				orange[1][orangeStep] = i;
				orangeStep++;
			} else {
				blue[0][blueStep] = Integer.valueOf(data[i*2+2]) - 1;
				blue[1][blueStep] = i;
				blueStep++;
			}
		}
		orange[1][orangeStep] = -1;
		blue[1][blueStep] = -1;
		orangeStep = blueStep = 0;
		int orangePos = 0, bluePos = 0;
		int numSteps = 0;
		for(int i = 0; i < numCommands;) {
			boolean orangeFound = false;
			if(orange[1][orangeStep] == i && orange[0][orangeStep] == orangePos) {
				i++;
				orangeFound = true;
				orangeStep++;
			}else if(orange[0][orangeStep] < orangePos) {
				orangePos--;
			}else if(orange[0][orangeStep] > orangePos){
				orangePos++;
			}
			if(!orangeFound && blue[1][blueStep] == i && blue[0][blueStep] == bluePos) {
				i++;
				blueStep++;
			}else if(blue[0][blueStep] < bluePos) {
				bluePos--;
			}else if(blue[0][blueStep] > bluePos){
				bluePos++;
			}
			numSteps++;
		}
		
		out.print(numSteps);
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for(int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}
