import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.TreeSet;


public class Round1B {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File("output")));
		final int numCases = readInt();
		
		for(int i = 0; i < numCases; i++) {
			out.print("Case #" + (i+1) + ": ");

			solve();
			
			out.println();
		}
		
		out.close();
	}
	
	private static void solve() throws IOException {
		long[] data = readLongArray(1000006);
		long l = data[0];
		long timeToBuildL = data[1];
		long numStars = data[2];
		long numPoints = data[3];
		long[] distancesRep = Arrays.copyOfRange(data, 4, (int) numPoints+4);
		long[] distances = new long[(int) numStars];
		
		int repPos = 0;
		for(int i = 0; i < numStars; i++) {
			distances[i] = distancesRep[repPos++]*2;
			if(repPos == numPoints) {
				repPos = 0;
			}
		}
		
		Arrays.sort(distancesRep);
		
		long sumDist = 0;
		long remainingTimeToBuild = timeToBuildL;
		int i = 0;
		while(true) {
			long dis = Math.min(distances[i], remainingTimeToBuild);
			remainingTimeToBuild -= dis;
			sumDist += dis;
			distances[i] -= dis;
			i++;
			if(remainingTimeToBuild == 0 || i == numStars) {
				break;
			}
		}
		
		// now we've build all l.  Find where to put them.
		
		while(l > 0) {
			for(int j = 0; j < numStars; j++) {
				if(distances[j] >= distancesRep[distancesRep.length-1]*2) {
					distances[j] /= 2;
					l--;
					if(l == 0) {
						break;
					}
				}
			}
			distancesRep[distancesRep.length-1] = 0;
			Arrays.sort(distancesRep);
		}
		
		for(i = 0; i < numStars; i++) {
			sumDist += distances[i];
		}
		
		out.print(sumDist);
	}

	private static long[] readLongArray(int maxItems) throws IOException {
		long[] array = new long[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for(int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Long(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}
