import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;

public class Qual3 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}

	static ArrayList<BigInteger> list = new ArrayList<BigInteger>(1000);

	static {
		char[] s = { '1' };
		while (true) {
			BigInteger b = new BigInteger(new String(s));
			BigInteger b2 = b.multiply(b);
			String b2Str = b2.toString();
			if (b2Str.length() > 16) {
				break;
			}
			if (isPalendrome(b2Str)) {
				list.add(b2);
			}
			s = nextPalendrome(s);
		}
	}

	private static void solve() throws IOException {
		int[] dims = readIntArray(2);
		int a = Collections.binarySearch(list, new BigInteger("" + dims[0]));
		int b = Collections.binarySearch(list, new BigInteger("" + dims[1]));
		if(a < 0) {
			a = -a - 1;
		}
		if( b < 0) {
			b = -b - 1;
		} else {
			b++;
		}
		out.print(b - a);
	}

	private static boolean isPalendrome(String string) {
		for (int i = 0; i < string.length() / 2; i++) {
			if (string.charAt(i) != string.charAt(string.length() - (i + 1))) {
				return false;
			}
		}
		return true;
	}

	private static char[] nextPalendrome(char[] palendrome) {
		int one = (palendrome.length - 1) / 2;
		int two = palendrome.length / 2;
		if (one < 0) {
			one = 0;
		}
		while (one >= 0) {
			char c = palendrome[one];
			if (c < '9') {
				palendrome[one] = (char) (c + 1);
				palendrome[two] = (char) (c + 1);
				return palendrome;
			}
			palendrome[one] = '0';
			palendrome[two] = '0';
			one--;
			two++;
		}
		// Jump to next size up.
		char[] next = new char[palendrome.length + 1];
		next[0] = '1';
		next[palendrome.length] = '1';
		for (int i = 1; i < palendrome.length; i++) {
			next[i] = '0';
		}
		return next;
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}