package org.blarson.codeJam._2014Qual;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Iterator;
import java.util.LinkedList;

public class Qual4 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}

	private static void solve() throws IOException {
		int n = readInt();
		Double[] myBlocks = readDoubleArray(n);
		Double[] kenBlocks = readDoubleArray(n);
		Arrays.sort(myBlocks);
		Arrays.sort(kenBlocks);
		out.print("" + findOptimal(myBlocks, kenBlocks) + " " + findWar(myBlocks, kenBlocks));
	}

	private static int findOptimal(Double[] myBlocks, Double[] kenBlocks) {
		int points = myBlocks.length;
		LinkedList<Double> myList = new LinkedList<Double>(Arrays.asList(myBlocks));
		LinkedList<Double> kenList = new LinkedList<Double>(Arrays.asList(kenBlocks));
		
		while(!myList.isEmpty()) {
			Iterator<Double> it1 = myList.iterator();
			Iterator<Double> it2 = kenList.iterator();
			boolean solved = true;
			while(it1.hasNext()) {
				if(it2.next() > it1.next()) {
					points--;
					myList.remove();
					kenList.removeLast();
					solved = false;
					break;
				}
			}
			if(solved) {
				break;
			}
		}
		return points;
	}
	
	private static int findWar(Double[] myBlocks, Double[] kenBlocks) {
		int points = 0;
		LinkedList<Double> kenList = new LinkedList<Double>(Arrays.asList(kenBlocks));

		for(int i = 0; i < myBlocks.length; i++) {
			Iterator<Double> it = kenList.iterator();
			boolean found = false;
			while(it.hasNext()) {
				Double d = it.next();
				if(d > myBlocks[i]) {
					it.remove();
					found = true;
					break;
				}
			}
			if(!found) {
				kenList.remove();
				points++;
			}
		}
		return points;
	}
	
	private static Double[] readDoubleArray(int maxItems) throws IOException {
		Double[] array = new Double[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Double(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}