import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;


public class Qual2 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File("/home/blarson/output")));
		final int numCases = readInt();
		
		for(int i = 0; i < numCases; i++) {
			out.print("Case #" + (i+1) + ": ");

			solve();
			
			out.println();
		}
		
		out.close();
	}

	private static void solve() throws IOException {
		String line = r.readLine();
		String[] data = line.split(" ");
		int numCombine = Integer.valueOf(data[0]);
		int readPos = 1;
		HashMap<String, String> combines = new HashMap<String, String>();
		for(int i = 0; i < numCombine; i++, readPos++) {
			char a = data[readPos].charAt(0);
			char b = data[readPos].charAt(1);
			char c = data[readPos].charAt(2);
			combines.put(a + "" + b, "" + c);
			combines.put(b + "" + a, "" + c);
		}
		int numOppose = Integer.valueOf(data[readPos++]);
		HashMap<String, Boolean> opposes = new HashMap<String, Boolean>();
		for(int i = 0; i < numOppose; i++, readPos++) {
			String a = data[readPos].substring(0, 1);
			String b = data[readPos].substring(1);
			opposes.put(a + "" + b, true);
			opposes.put(b + "" + a, true);
		}
		int numchars = Integer.valueOf(data[readPos++]);
		String invoke = data[readPos];
		ArrayList<String> output = new ArrayList<String>();
		
		for(int i = 0; i < invoke.length(); i++) {
			char next = invoke.charAt(i);
			String last = "";
			if(!output.isEmpty()) {
				last = output.get(output.size()-1);
			}
			String combined = combines.get(last + next);
			if(combined != null) {
				output.remove(output.size() - 1);
				output.add(combined);
				continue;
			}
			output.add("" + next);
			for(int j = 0; j < output.size() - 1; j++) {
				for(int k = j + 1; k < output.size(); k++) {
					if(opposes.get(output.get(j) + output.get(k)) != null) {
						output.clear();
						break;
					}
				}
			}
		}
		
		out.print("[");
		for(int i = 0; i < output.size(); i++) {
			out.print(output.get(i));
			if(i < output.size() - 1) {
				out.print(", ");
			}
		}
		out.print("]");
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for(int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}
