import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;


public class Round1B {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File("output")));
		final int numCases = readInt();
		
		for(int i = 0; i < numCases; i++) {
			out.print("Case #" + (i+1) + ": ");

			solve();
			
			out.println();
		}
		
		out.close();
	}
	
	private static void solve() throws IOException {
		int[] data = readIntArray(2);
		int numWords = data[0];
		int numLists = data[1];
		String[] words = new String[numWords];
		for(int i = 0; i < numWords; i++) {
			words[i] = r.readLine();
		}
		String[] lists = new String[numLists];
		for(int i = 0; i < numLists; i++) {
			lists[i] = r.readLine();
		}
		
		HashMap<Integer, LinkedList<String>> wordLengths = new HashMap<Integer, LinkedList<String>>(10);
		for(String word : words) {
			LinkedList<String> list = wordLengths.get(word.length());
			if(list == null) {
				list = new LinkedList<String>();
			} else {
				boolean anogram = false;
				for(String l : list) {
					if(isAnogram(l, word)) {
						anogram = true;
						break;
					}
				}
				if(anogram) {
					continue;
				}
			}
			list.add(word);
			wordLengths.put(word.length(), list);
		}
		
		for(String list : lists) {
			int maxCost = -1;
			String bestWord = "";
			for(String word : words) {
				if(!wordLengths.get(word.length()).contains(word)) {
					continue;
				}
				String dots = "............";
				int cost = calcCost(word, dots.substring(0, word.length()), list, wordLengths.get(word.length()), 0);
				if(cost > maxCost) {
					maxCost = cost;
					bestWord = word;
				}
			}
			out.print(bestWord + " ");
		}
		
	}

	private static boolean isAnogram(String l, String word) {
		StringBuffer s = new StringBuffer(word);
		for(int i = 0; i < l.length(); i++) {
			int a = s.toString().indexOf(l.charAt(i));
			if(a < 0) {
				return false;
			}
			s.deleteCharAt(a);
		}
		return true;
	}

	private static int calcCost(String word, String currentGuess, String list,
			LinkedList<String> words, int curCost) {
		LinkedList<String> newWords = new LinkedList<String>(words);
		for(int i = 0; i < newWords.size(); i++) {
			String testWord = newWords.get(i);
			if(!testWord.matches(currentGuess)) {
				newWords.remove(i);
				i--;
			}
		}
		
		if(newWords.size() < 2) {
			return curCost;
		}
		
		char guess = '?';
		for(int i = 0; i < list.length(); i++) {
			for(String testWord : newWords) {
				if(testWord.contains(""+list.charAt(i))) {
					guess = list.charAt(i);
					list = list.substring(i+1);
					break;
				}
			}
			if(guess != '?') {
				break;
			}
		}
		
		if(!word.contains(""+guess)) {
			for(int i = 0; i < newWords.size(); i++) {
				String testWord = newWords.get(i);
				if(testWord.contains("" + guess)) {
					newWords.remove(i);
					i--;
				}
			}
			curCost++;
		}
		
		StringBuffer newGuess = new StringBuffer(currentGuess);
		
		for(int i = 0; i < word.length(); i++) {
			if(word.charAt(i) == guess) {
				newGuess.setCharAt(i, guess);
			}
		}
		
		return calcCost(word, newGuess.toString(), list, newWords, curCost);
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for(int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}
