import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;


public class Round1A {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File("output")));
		final int numCases = readInt();
		
		for(int i = 0; i < numCases; i++) {
			out.print("Case #" + (i+1) + ": ");

			solve();
			
			//out.println();
		}
		
		out.close();
	}
	
	private static char[][] tiles;
	private static int rows;
	private static int cols;
	
	private static void solve() throws IOException {
		int[] data = readIntArray(2);
		rows = data[0];
		cols = data[1];
		tiles = new char[rows][cols];
		for(int i = 0; i < rows; i++) {
			String s = r.readLine();
			for(int j = 0; j < cols; j++) {
				tiles[i][j] = s.charAt(j);
			}
		}
		
		if(!convert()) {
			out.println();
			out.println("Impossible");
		} else {
			out.println();
			for(int i = 0; i < rows; i++) {
				for(int j = 0; j < cols; j++) {
					out.print(tiles[i][j]);
				}
				out.println();
			}
		}
		
	}

	private static boolean convert() {
		for(int i = 0; i < rows; i++) {
			for(int j = 0; j < cols; j++) {
				if(tiles[i][j] == '#') {
					if(i >= rows-1 || j >= cols-1) {
						return false;
					}
					if(tiles[i][j+1] != '#'|| tiles[i+1][j] != '#' || tiles[i+1][j+1] != '#') {
						return false;
					}
					tiles[i][j] = '/';
					tiles[i+1][j] = '\\';
					tiles[i][j+1] = '\\';
					tiles[i+1][j+1] = '/';
				}
			}
		}
		return true;
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for(int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}
