import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

public class Round2a {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}

	static long[] vinePos;
	static long[] vineLen;
	static long totalDist;
	private static void solve() throws IOException {
		int numVines = readInt();
		vinePos = new long[numVines];
		vineLen = new long[numVines];
		for(int i = 0; i < numVines; i++) {
			vinePos[i] = readSingleLong();
			vineLen[i] = readLong();
		}
		totalDist = readLong();
		int curVine = 0;
		long posOnVine = vinePos[curVine];
		boolean works = tryOn(curVine, posOnVine);
		if(works) {
			out.print("YES");
		} else {
			out.print("NO");
		}
		return;
	}

	private static boolean tryOn(int curVine, long posOnVine) {
		long maxPos = vinePos[curVine] + posOnVine;
		if(maxPos >= totalDist) {
			return true;
		}
		for(int i = curVine+1; i < vinePos.length; i++) {
			if(vinePos[i] > maxPos) {
				return false;
			}
			long myPosOnVine = vinePos[i] - vinePos[curVine];
			if(myPosOnVine >= vineLen[i]) {
				myPosOnVine = vineLen[i];
			}
			if(tryOn(i, myPosOnVine)) {
				return true;
			}
		}
		return false;
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}
	
	private static long readLong() throws IOException {
		String line = r.readLine().trim();
		return new Long(line);
	}

	private static long readSingleLong() throws IOException {
		String line = "";
		char c;
		do {
			c = (char)r.read();
			line += c;
		}while (c != ' ');
		return new Long(line.trim());
	}
}