import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

public class Qual2 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}

	private static void solve() throws IOException {
		int[] dims = readIntArray(2);
		int[][] heights = new int[dims[0]][dims[1]];
		for(int i = 0; i < dims[0]; i++) {
			heights[i] = readIntArray(dims[1]);
		}
		boolean[][] cut = new boolean[dims[0]][dims[1]];
		for(int x = 0; x < dims[1]; x++) {
			for(int y = 0; y < dims[0]; y++) {
				cut[y][x] = false;
			}
		}
		
		for(int x = 0; x < dims[1]; x++) {
			int max = 0;
			for(int y = 0; y < dims[0]; y++) {
				if(heights[y][x] > max) {
					max = heights[y][x];
				}
			}
			for(int y = 0; y < dims[0]; y++) {
				if(heights[y][x] == max) {
					cut[y][x] = true;
				}
			}
		}
		for(int y = 0; y < dims[0]; y++) {
			int max = 0;
			for(int x = 0; x < dims[1]; x++) {
				if(heights[y][x] > max) {
					max = heights[y][x];
				}
			}
			for(int x = 0; x < dims[1]; x++) {
				if(heights[y][x] == max) {
					cut[y][x] = true;
				}
			}
		}
		
		for(int x = 0; x < dims[1]; x++) {
			for(int y = 0; y < dims[0]; y++) {
				if(!cut[y][x]) {
					out.print("NO");
					return;
				}
			}
		}
		
		out.print("YES");
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}