import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

public class Qual1 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}

	private static void solve() throws IOException {
		String[] board = new String[4];
		boolean boardFull = true;
		for (int i = 0; i < 4; i++) {
			board[i] = r.readLine().trim();
			if(board[i].contains(".")) {
				boardFull = false;
			}
		}
		r.readLine();

		for (int i = 0; i < 4; i++) {
			if (win_horz(board, 'X', i) || win_vert(board, 'X', i)) {
				out.print("X won");
				return;
			} else if (win_horz(board, 'O', i) || win_vert(board, 'O', i)) {
				out.print("O won");
				return;
			}
		}
		
		if (win_diag_left(board, 'X') || win_diag_right(board, 'X')) {
			out.print("X won");
			return;
		}
		if (win_diag_left(board, 'O') || win_diag_right(board, 'O')) {
			out.print("O won");
			return;
		}
		if(!boardFull) {
			out.print("Game has not completed");
		} else {
			out.print("Draw");
		}
	}

	private static boolean win_diag_right(String[] board, char c) {
		for(int i = 0; i < 4; i++) {
			if(board[i].charAt(3-i) != c && board[i].charAt(3-i) != 'T') {
				return false;
			}
		}
		return true;
	}

	private static boolean win_diag_left(String[] board, char c) {
		for(int i = 0; i < 4; i++) {
			if(board[i].charAt(i) != c && board[i].charAt(i) != 'T') {
				return false;
			}
		}
		return true;
	}

	private static boolean win_vert(String[] board, char c, int i) {
		for (int j = 0; j < 4; j++) {
			if (board[j].charAt(i) != c && board[j].charAt(i) != 'T') {
				return false;
			}
		}
		return true;
	}

	private static boolean win_horz(String[] board, char c, int i) {
		String s = board[i];
		for (int j = 0; j < 4; j++) {
			if (s.charAt(j) != c && s.charAt(j) != 'T') {
				return false;
			}
		}
		return true;
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}