import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Map.Entry;

public class Round2b {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}
	
	static class Pair{
		int key;
		int value;
	}

	private static void solve() throws IOException {
		int[] nums = readIntArray(3);
		int numStudents = nums[0];
		int width = nums[1];
		int length = nums[2];
		LinkedList<Pair> curHeight = new LinkedList<Pair>();
		LinkedList<Pair> lastHeight = new LinkedList<Pair>();
		int[] radii = readIntArray(numStudents);
		int[] origRadii = Arrays.copyOf(radii, numStudents);
		int[] xpos = new int[numStudents];
		int[] ypos = new int[numStudents];
		int xoff = 0;
		int largest;
		boolean rtol = true;
		while((largest = getLargest(radii)) != -1) {
			radii[largest] = 0;
			int myxpos = xoff == 0 ? 0 : xoff + origRadii[largest];
			if(myxpos > width) {
				rtol = !rtol;
				myxpos = 0;
				lastHeight = curHeight;
				curHeight = new LinkedList<Round2b.Pair>();
				xoff = 0;
			}
			if(!rtol) {
				myxpos = width - myxpos;
			}
			xoff += (xoff == 0 ? origRadii[largest] : origRadii[largest] * 2);
			xpos[largest] = myxpos;
			
			int yoff = 0;
			int xstart = myxpos - origRadii[largest];
			int xstop = xstart + (origRadii[largest] * 2);
			if(xstart < 0) {
				xstart = 0;
			}
			Pair lastHeightMap = null;
			for(Pair heightMap : lastHeight) {
				if(lastHeightMap != null) {
					if(lastHeightMap.key <= xstart && heightMap.key > xstart) {
						yoff = Math.max(lastHeightMap.value, heightMap.value);
						break;
					} else {
						yoff = heightMap.value;
					}
				} else {
					yoff = heightMap.value;
				}
				lastHeightMap = heightMap;
			}
			ypos[largest] = (yoff == 0 ? 0 : yoff + origRadii[largest]);
			Pair p = new Pair();
			p.key = xstart;
			p.value = ypos[largest] + origRadii[largest];
			if(rtol) {
				curHeight.addLast(p);
			} else {
				curHeight.addFirst(p);
			}
		}
		
		for(int i = 0; i < numStudents; i++) {
			out.print("" + xpos[i] + " " + ypos[i] + " ");
			if(xpos[i] < 0 || xpos[i] > width || ypos[i] < 0 || ypos[i] > length) {
				System.out.println("FAILURE1");
			}
		}
		
		for(int i = 0; i < numStudents; i++) {
			for(int j = i + 1; j < numStudents; j++) {
				double x1 = xpos[i];
				double x2 = xpos[j];
				double y1 = ypos[i];
				double y2 = ypos[j];
				double d2 = Math.sqrt(Math.pow((x1 - x2), 2) + Math.pow(y1 - y2,2));
				double dist =(origRadii[i] + origRadii[j]); 
				if(d2 < dist) {
					System.out.println("FAILURE2");
				}
			}
		}
	}

	private static int getLargest(int[] radii) {
		int largest = 0;
		int largestPos = -1;
		for(int i = 0; i < radii.length; i++) {
			if(radii[i] > largest) {
				largest = radii[i];
				largestPos = i;
			}
		}
		return largestPos;
	}

	private static int[] readIntArray(int maxItems) throws IOException {
		int[] array = new int[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Integer(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

	private static int readSingleInt() throws IOException {
		String line = "";
		char c;
		do {
			c = (char)r.read();
			line += c;
		}while (c != ' ');
		return new Integer(line.trim());
	}
}