import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;


public class Round1A {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File("output")));
		final int numCases = readInt();
		
		for(int i = 0; i < numCases; i++) {
			out.print("Case #" + (i+1) + ": ");

			solve();
			
			out.println();
		}
		
		out.close();
	}
	
	private static void solve() throws IOException {
		int numTeams = readInt();
		int[][] wins = new int[numTeams][numTeams];
		for(int i = 0; i < numTeams; i++) {
			String s = r.readLine();
			for(int j = 0; j < numTeams; j++) {
				if(s.charAt(j) == '.') {
					wins[i][j] = -1;
				} else {
					wins[i][j] = Integer.parseInt("" + s.charAt(j));
				}
			}
		}
		
		double[] wp = new double[numTeams];
		for(int i = 0; i < numTeams; i++) {
			double numGames = 0;
			double numWins = 0;
			for(int j = 0; j < numTeams; j++) {
				if(wins[i][j] == 0) {
					numGames++;
				} else if(wins[i][j] == 1) {
					numGames++;
					numWins++;
				}
			}
			wp[i] = numWins / numGames;
		}

		double[] owp = new double[numTeams];
		for(int i = 0; i < numTeams; i++) {
			int numOpponents = 0;
			
			// wp without playing team i.
			double[] wp2 = new double[numTeams];
			
			// for each opponent
			for(int j = 0; j < numTeams; j++) {
				if(i == j) {
					continue;
				}
				if(wins[i][j] == -1) {
					// not an opponent
					continue;
				}
				
				double numGames = 0;
				double numWins = 0;
				for(int k = 0; k < numTeams; k++) {
					if(k == i) {
						continue;
					}
					if(wins[j][k] == 0) {
						numGames++;
					} else if(wins[j][k] == 1) {
						numGames++;
						numWins++;
					}
				}
				wp2[numOpponents] = numWins / numGames;
				numOpponents++;
			}
			
			// average of opponents
			double totalWp2 = 0;
			for(int j = 0; j < numOpponents; j++) {
				totalWp2 += wp2[j];
			}
			owp[i] = totalWp2 / numOpponents;
		}
		
		double[] oowp = new double[numTeams];
		for(int i = 0; i < numTeams; i++) {
			int numOpponents = 0;
			double totalOwp = 0;
			for(int j = 0; j <numTeams; j++) {
				if(wins[i][j] != -1) {
					numOpponents++;
					totalOwp += owp[j];
				}
			}
			oowp[i] = totalOwp / numOpponents;
		}
		
		for(int i = 0; i < numTeams; i++) {
			out.println();
			double rpi = 0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
			out.print(rpi);
		}
	}

	private static long[] readLongArray(int maxItems) throws IOException {
		long[] array = new long[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for(int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Long(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}
