package org.blarson.codeJam._2013Round2;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.List;
import java.util.PriorityQueue;

public class Prob1 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}
	
	private static class Pair {
		Long origin;
		Long end;
		long numPassengers;
		@Override
		public String toString() {
			return "" + origin + " " + end + " " + numPassengers;
		}
	}

	private static void solve() throws IOException {
		long expectedProfit = 0;
		long realCost = 0;
		PriorityQueue<Long> tickets = new PriorityQueue<Long>(10, new Comparator<Long>() {
			@Override
			public int compare(Long o1, Long o2) {
				return o2.compareTo(o1);
			}
		});
		PriorityQueue<Pair> startPairs = new PriorityQueue<Pair>(10, new Comparator<Pair>() {
			@Override
			public int compare(Pair o1, Pair o2) {
				return o1.origin.compareTo(o2.origin);
			}
		});
		PriorityQueue<Pair> endPairs = new PriorityQueue<Pair>(10, new Comparator<Pair>() {
			@Override
			public int compare(Pair o1, Pair o2) {
				return o1.end.compareTo(o2.end);
			}
		});
		long[] data = readLongArray(2);
		long numStops = data[0];
		long numPairs = data[1];
		for(long i = 0; i < numPairs; i++) {
			data = readLongArray(3);
			Pair p = new Pair();
			p.origin = data[0];
			p.end = data[1];
			p.numPassengers = data[2];
			expectedProfit += cost(numStops, p.end - p.origin) * p.numPassengers;
			startPairs.add(p);
			endPairs.add(p);
		}
		Pair p = startPairs.poll();
		while(p != null) {
			while(true) {
				Pair end = endPairs.peek();
				if(end.end >= p.origin) {
					break;
				}
				endPairs.poll();
				// exit with the newest ticket
				for (long i = 0; i < end.numPassengers; i++) {
					long ticketStart = tickets.poll();
					realCost += cost(numStops, end.end - ticketStart);
				}
			}
			for(long j = 0; j < p.numPassengers; j++) {
				tickets.add(p.origin);
			}
			p = startPairs.poll();
		}
		Pair end = endPairs.poll();
		while (end != null) {
			for (long i = 0; i < end.numPassengers; i++) {
				long ticketStart = tickets.poll();
				realCost += cost(numStops, end.end - ticketStart);
			}
			end = endPairs.poll();
		}
		out.print((expectedProfit - realCost) % 1000002013);
	}

	private static long cost(long numStops, long length) {
		long discount = ((length - 1) * (length)) / 2;
		return numStops * length - discount;
	}

	private static long[] readLongArray(int maxItems) throws IOException {
		long[] array = new long[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Long(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}