package org.blarson.codeJam._2014Qual;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;

public class Qual2 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}

	private static void solve() throws IOException {
		double[] data = readDoubleArray(3);
		double farmCost = data[0];
		double farmBonus = data[1];
		double neededCookies = data[2];
		double bestTime = neededCookies / 2;
		int numFarms = 0;
		while(true) {
			double time = 0;
			numFarms++;
			for(int i = 0; i < numFarms; i++) {
				time += farmCost / (2 + (farmBonus * i));
			}
			time += neededCookies / (2 + (farmBonus * numFarms));
			if(time >= bestTime) {
				break;
			}
			bestTime = time;
		}
		out.print("" + bestTime);
	}

	private static double[] readDoubleArray(int maxItems) throws IOException {
		double[] array = new double[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Double(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}