package org.blarson.codeJam._2013Round2;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;
import java.util.PriorityQueue;

public class Prob2 {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File("/home/blarson/input");
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File(
				"/home/blarson/output")));
		final int numCases = readInt();

		for (int i = 0; i < numCases; i++) {
			out.print("Case #" + (i + 1) + ": ");

			solve();

			out.println();
		}

		out.close();
	}

	private static void solve() throws IOException {
		long[] data = readLongArray(2);
		long rounds = data[0];
		long prizes = data[1];
		long numTeams = 1L << (int)rounds;
		long bestPossible = 0;
		PriorityQueue<Long> bestFound = new PriorityQueue<Long>();
		for(long i = 0; i < prizes; i++) {
			long j = reverseBinary(i, rounds);
			bestPossible = Math.max(j, bestPossible);
			bestFound.add(j);
		}
		long bestKnown = 0;
		Long l = bestFound.poll();
		l = bestFound.poll();
		while(l != null) {
			if(l - bestKnown > 1) {
				break;
			}
			bestKnown++;
			l = bestFound.poll();
		}
		out.print(bestKnown + " " + bestPossible);
	}

	private static long reverseBinary(long l, long bitsToReverse) {
		long t = 0;
		for(int i = 0; i < bitsToReverse; i++) {
			if((l & (1L << i)) != 0) {
				t = t | (1L << (bitsToReverse - i - 1));
			}
		}
		return t;
	}

	private static long[] readLongArray(int maxItems) throws IOException {
		long[] array = new long[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for (int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Long(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}