import java.io.BufferedReader;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.io.PrintStream;


public class Round1A {
	private static BufferedReader r;
	private static PrintStream outFile;
	private static PrintStream out = new PrintStream(new OutputStream() {
		@Override
		public void write(int b) throws IOException {
			System.out.write(b);
			outFile.write(b);
		}
	});

	public static void main(String[] args) throws IOException {
		File f = new File(args[0]);
		r = new BufferedReader(new FileReader(f));
		outFile = new PrintStream(new FileOutputStream(new File("output")));
		final int numCases = readInt();
		
		for(int i = 0; i < numCases; i++) {
			out.print("Case #" + (i+1) + ": ");

			solve();
			
			out.println();
		}
		
		out.close();
	}
	
	private static void solve() throws IOException {
		long[] data = readLongArray(3);
		long n = data[0];
		int pd = (int) data[1];
		int pg = (int) data[2];
		
		if(pg == 0 && pd != 0) {
			out.print("Broken");
			return;
		}
		if(pg == 100 && pd != 100) {
			out.print("Broken");
			return;
		}
		
		if(pd == 0 || pd == 100) {
			out.print("Possible");
			return;
		}
		
		int num = pd;
		int den = 100;
		for(int i = 2; i < den / 2 + 1; i++) {
			if(num % i == 0 && den % i == 0) {
				num = num / i;
				den = den / i;
				i--;
			}
		}
		
		if(n >= den) {
			out.print("Possible");
		} else {
			out.print("Broken");
		}
		
	}

	private static long[] readLongArray(int maxItems) throws IOException {
		long[] array = new long[maxItems];
		String line = r.readLine().trim();
		String[] data = line.split(" ");
		for(int i = 0; i < data.length && i < maxItems; i++) {
			array[i] = new Long(data[i]);
		}
		return array;
	}

	private static int readInt() throws IOException {
		String line = r.readLine().trim();
		return new Integer(line);
	}

}
