package com.bkraszewski;

import java.io.IOException;
import java.math.BigDecimal;

public class TidyNumbers {
    public static BigDecimal findLastTidyNumberInRange(BigDecimal n) {
        long max = n.longValue();
        long lastTidyNumber = 1;

        for (int a = 1; a <= max; a++) {
            String strNum = String.valueOf(a);
            if (isTidyNumber(strNum)) {
                lastTidyNumber = a;
            }

        }

        return BigDecimal.valueOf(lastTidyNumber);
    }

    private static boolean isTidyNumber(String strNum) {
        char last = '1';
        for (int a = 0; a < strNum.length(); a++) {
            if (last > strNum.charAt(a)) {
                return false;
            }

            last = strNum.charAt(a);
        }

        return true;
    }

    public static void main(String args[]) throws IOException {
//        String fileName = "B-small-practice";
        String fileName = "B-small-attempt0";

        String inputFile = String.format("./input/numbers/%s.in", fileName);
        String outputFile = String.format("./output/numbers/%s.out", fileName);

        GenericLineReader reader = new GenericLineReader();
        reader.mapInputToOutput(inputFile, outputFile, (line) ->
                {

                    BigDecimal number = new BigDecimal(line);
                    BigDecimal result = findLastTidyNumberInRange(number);

                    return result.toString();
                }
        );
    }
}
