package com.bkraszewski;

import java.io.IOException;
import java.math.BigInteger;

public class TidyNumbers {
    public static BigInteger findLastTidyNumberInRange(BigInteger n) {

        String current = n.toString();
        int firstFailedIndex;
        while ((firstFailedIndex = findMaxUnSortedIndex(current)) != -1) {

            BigInteger num = new BigInteger(current);
            long substractor = (long) Math.pow(10, firstFailedIndex);

            num = num.subtract(BigInteger.valueOf(substractor));
            int startIndexToFilNines = current.length() - 1 - firstFailedIndex;

            if (num.toString().length() != current.length()) {
                current = num.toString();
                char[] arr = current.toCharArray();
                for (int a = startIndexToFilNines; a < arr.length; a++) {
                    arr[a] = '9';
                }
                current = new String(arr);
            } else {
                current = num.toString();

            }
        }

        return new BigInteger(current);
    }

    public static int findMaxUnSortedIndex(String current) {
        int index = 1;
        int maxIndex = -1;
        for (int a = current.length() - 1; a > 0; a--) {
            index = current.length() - 1 - a;

            if (current.charAt(a) >= current.charAt(a - 1)) {
                continue;
            } else {
                if (index > maxIndex) {
                    maxIndex = index;
                }
            }
        }

        return maxIndex;
    }


    public static void main(String args[]) throws IOException {
//        String fileName = "B-small-practice";
        String fileName = "B-large";

        String inputFile = String.format("./input/numbers/%s.in", fileName);
        String outputFile = String.format("./output/numbers/%s.out", fileName);

        GenericLineReader reader = new GenericLineReader();
        reader.mapInputToOutput(inputFile, outputFile, (line) ->
                {

                    BigInteger number = new BigInteger(line);
                    BigInteger result = findLastTidyNumberInRange(number);

                    return result.toString();
                }
        );
    }
}
