package codejam;

import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

abstract public class CodeJam {
	ArrayList<TestCase> testCase=new ArrayList<TestCase>();
	int totalCases=0;
	public String readFile(String arg) throws IOException{
		String retval=new String(Files.readAllBytes(Paths.get(arg)));
		return retval;
	}
	public int getCases(String filePath) throws IOException{
		String fileContents=readFile(filePath);
		List <String> lines=(List<String>) Arrays.asList(fileContents.split("\n"));
		totalCases=Integer.parseInt(lines.get(0));
		int currentCase=0;
		int line=1;
		while(line<lines.size()){
			int numLines=Integer.parseInt(lines.get(line));
			ArrayList<String>caseLines=new ArrayList<String>();
			line++;
			for(int i=0;i<numLines;i++){
				caseLines.add(lines.get(line+i));
			}
			testCase.add(new TestCase(currentCase, caseLines));
			line=line+numLines;
		}
		return totalCases;
	}
	public int getCases1AB(String filePath) throws IOException{
		String fileContents=readFile(filePath);
		List <String> lines=(List<String>) Arrays.asList(fileContents.split("\n"));
		totalCases=Integer.parseInt(lines.get(0));
		int currentCase=0;
		int line=1;
		while(line<lines.size()){
			int numLines=Integer.parseInt(lines.get(line));
			numLines=numLines*2-1;
			ArrayList<String>caseLines=new ArrayList<String>();
			line++;
			for(int i=0;i<numLines;i++){
				caseLines.add(lines.get(line+i));
			}
			testCase.add(new TestCase(currentCase, caseLines));
			line=line+numLines;
		}
		return totalCases;
	}	
	public int getCasesWithOffset(String filePath, int delta) throws IOException{
		String fileContents=readFile(filePath);
		List <String> lines=(List<String>) Arrays.asList(fileContents.split("\n"));
		totalCases=Integer.parseInt(lines.get(0));
		int currentCase=0;
		int line=1;
		while(line<lines.size()){
			int numLines=Integer.parseInt(lines.get(line+delta));
			ArrayList<String>caseLines=new ArrayList<String>();
			for(int i=0;i<numLines+delta+1;i++){
				caseLines.add(lines.get(line+i));
			}
			testCase.add(new TestCase(currentCase, caseLines));
			line=line+numLines+delta+1;
		}
		return totalCases;
	}	
	public int getCasesOnePerLine(String filePath) throws IOException{
		String fileContents=readFile(filePath);
		List <String> lines=(List<String>) Arrays.asList(fileContents.split("\n"));
		totalCases=Integer.parseInt(lines.get(0));
		int currentCase=0;
		int line=1;
		while(line<lines.size()){
			ArrayList<String>caseLines=new ArrayList<String>();
			caseLines.add(lines.get(line));
			testCase.add(new TestCase(currentCase, caseLines));
			line++;
		}
		return totalCases;
	}
	public int getCasesFixedPerLineHeader(String filePath, int intLinesPerCase) throws IOException{
		String fileContents=readFile(filePath);
		List <String> lines=(List<String>) Arrays.asList(fileContents.split("\n"));
		totalCases=Integer.parseInt(lines.get(0));
		int currentCase=0;
		int line=1;
		while(line<lines.size()){
			ArrayList<String>caseLines=new ArrayList<String>();
			for(int i=0;i<intLinesPerCase;i++){
				caseLines.add(lines.get(line+i));
			}
			testCase.add(new TestCase(currentCase, caseLines));
			line=line+intLinesPerCase;
		}
		return totalCases;
	}

	public String start() {
		String result="";
//		executeTestCase(1);
		
		for(int i=0;i<totalCases;i++){
			result+=executeTestCase(i);
		}
		return result;
	}
	abstract public String executeTestCase(int i);
	
}
