import java.io.*;

public class Rpi {
	public static void main(String[] args) throws IOException {
		//input
		FileInputStream fileInputStream = new FileInputStream(args[0]);
		InputStreamReader inputStreamReader = new InputStreamReader(fileInputStream, "utf-8");
		BufferedReader reader = new BufferedReader(inputStreamReader);
		//output
		FileOutputStream fileOutputStream = new FileOutputStream(args[1]);
		OutputStreamWriter outputStreamWriter = new OutputStreamWriter(fileOutputStream, "utf-8");
		PrintWriter writer = new PrintWriter(outputStreamWriter);

		String str = reader.readLine();
		int N = Integer.valueOf(str);
		for (int i = 1; i <= N; ++i){
			int commandsNumber = Integer.valueOf(reader.readLine());
			String[] strArr = new String[commandsNumber];
			for (int j = 0; j < commandsNumber; j++){
				strArr[j] = reader.readLine();
			}
			Double[] winsNum = new Double[commandsNumber];
			Double[] gamesNum = new Double[commandsNumber];
			Double[] WP = new Double[commandsNumber];
			Double[] OWP = new Double[commandsNumber];
			Double[] OOWP = new Double[commandsNumber];
			for (int j = 0; j < commandsNumber; j++){
				double games = 0;
				double wins = 0;
				for (int k = 0; k < commandsNumber; k++){
					char ch = strArr[j].charAt(k);
					if (ch != '.'){
						games++;
						if (ch == '1')
							wins++;
					}
				}
				winsNum[j] = wins;
				gamesNum[j] = games;
				WP[j] = wins / games;
			}
			for (int j = 0; j < commandsNumber; j++){
				double wpSum = 0;
				int oponentsNum = 0;
				for (int k = 0; k < commandsNumber; k++){
					char ch = strArr[j].charAt(k);
					if (ch != '.'){
						oponentsNum++;
						if (ch == '1'){
							wpSum += (double)winsNum[k] / ((double)gamesNum[k] - 1);
						}
						else{
							wpSum += ((double)winsNum[k] - 1) / ((double)gamesNum[k] - 1);
						}
					}
				}
				OWP[j] = wpSum / oponentsNum;
			}
			for (int j = 0; j < commandsNumber; j++){
				double owpSum = 0;
				int oponentsNum = 0;
				for (int k = 0; k < commandsNumber; k++){
					char ch = strArr[j].charAt(k);
					if (ch != '.'){
						oponentsNum++;
						owpSum += OWP[k];
					}
				}
				OOWP[j] = owpSum / oponentsNum;
			}
			writer.println("Case #" + i + ":");
			for (int j = 0; j < commandsNumber; j++){
				double val = 0.25 * WP[j] + 0.50 * OWP[j] + 0.25 * OOWP[j];
				writer.println(val);
			}
		}
		reader.close();
		writer.close();
	}
}