package Round2.B;

import java.io.*;
import java.util.*;

public class UpAndDownSearch {
    int N;
    int[] A;
    int[] B;
    int[] mark;
    int max;
    boolean up;
    HashMap<Integer, Integer> map;

    public int minMoves(int p) {
        if (p < N) {
            int cost = Integer.MAX_VALUE;
            for (int i = 0; i < N; i++) {
                if (mark[i] == 0 && (p == 0 || (up && A[i] > B[p - 1]) || (!up && A[i] < B[p - 1]))) {
                    B[p] = A[i];
                    mark[i] = 1;
                    if (A[i] == max) {
                        up = false;
                    }
                    cost = Math.min(cost, minMoves(p + 1));
                    mark[i] = 0;
                    if (A[i] == max) {
                        up = true;
                    }
                }
            }
            return cost;
        } else {
            int cost = 0;
            for (int i = 0; i < N; i++) {
                cost += Math.abs(i - map.get(B[i]));
            }
            assert cost % 2 == 0;
            return cost / 2;
        }
    }

    public void solve(Scanner sc, PrintWriter pw) throws Exception {
        N = sc.nextInt();
        A = new int[N];
        map = new HashMap<Integer, Integer>();
        max = Integer.MIN_VALUE;
        for (int i = 0; i < N; i++) {
            int p = sc.nextInt();
            A[i] = p;
            map.put(p, i);
            max = Math.max(max, p);
        }

        B = new int[N];
        mark = new int[N];
        up = true;

        int cost = minMoves(0);

        pw.println(cost);
    }

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new FileInputStream("B-small-attempt0.in"));
        PrintWriter pw = new PrintWriter(new FileWriter("B-small-attempt0.out"));
        UpAndDownSearch solver = new UpAndDownSearch();
        int T = sc.nextInt();
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            System.out.println("Processing test case " + caseNum);
            pw.print("Case #" + caseNum + ": ");
            solver.solve(sc, pw);
        }
        pw.flush();
        pw.close();
    }
}
