
package common;

import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.List;

/**
 * 출력 파일을 쓴다.
 * 
 * @author 손혁진
 */
public class OutputWriter {
	
	/**
	 * 테스트 케이스들의 결과를 출력 파일로 쓴다.
	 * 
	 * @param fileName 파일명
	 * @param 테스트 케이스의 List
	 */
	public static void write( String fileName, List<? extends TestCase> testCases ) throws Exception {
		
		PrintWriter pw = new PrintWriter( new OutputStreamWriter( new FileOutputStream( fileName ), "UTF-8" ) );
		
		int index = 0;
		
		for ( TestCase testCase : testCases ) {
			index++;
			pw.println( "Case #" + index + ": " + testCase.getResult() );
		}
		
		pw.close();
	}
}
