
package common;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

/**
 * 입력 파일을 읽는다.
 * 
 * @author 손혁진
 */
public class InputReader {
	
	/**
	 * 입력 파일을 읽어서 테스트 케이스들을 리턴한다.
	 * 
	 * @param fileName 파일명
	 * @param type 테스트케이스의 타입
	 * @return 테스트 케이스의 List
	 */
	public static <T> List<T> read( String fileName, Class<T> type ) throws Exception {
		
		BufferedReader br = new BufferedReader( new InputStreamReader( new FileInputStream( fileName ), "UTF-8" ) );
		
		int count = Integer.parseInt( br.readLine() );
		List<T> testCases = new ArrayList<T>( count );
		
		for ( int i = 0; i < count; i++ ) {
			T testCase = type.getConstructor( String.class, String.class ).newInstance( br.readLine(), br.readLine() );
			testCases.add( testCase );
		}
		
		br.close();
		
		return testCases;
	}
}
