
package problema;

import common.TestCase;

public class SnapperChainTestCase extends TestCase {
	
	private int n;
	private int k;
	private boolean[] snappers;
	
	public SnapperChainTestCase( String input ) {
		
		String[] tokens = input.split( " " );
		n = Integer.parseInt( tokens[ 0 ] );
		k = Integer.parseInt( tokens[ 1 ] );
	}

	public int getN() {
		return n;
	}

	public void setN( int n ) {
		this.n = n;
	}

	public int getK() {
		return k;
	}

	public void setK( int k ) {
		this.k = k;
	}
	
	public void solve() {
		
		snappers = new boolean[ n ];
		
		for ( int i = 0; i < k; i++ ) {
			for ( int j = n - 1; j >= 0; j-- ) {
				// 전원이 들어와 있다면 토글
				if ( j == 0 || isPowered( j ) ) snappers[ j ] = !snappers[ j ];
			}
		}
		
		// 하나라도 꺼져있으면 OFF이다.
		for ( int i = 0; i < n; i++ )
			if ( !snappers[ i ] ) {
				setResult( "OFF" );
				return;
			}
		
		setResult( "ON" );
	}
	
	private boolean isPowered( int index ) {
		for ( int i = 0; i < index; i++ )
			if ( !snappers[ i ] ) return false;
		
		return true;
	}
}
