import java.io.IOException;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.util.Scanner;
import java.util.Arrays;

public class B {

    private static int H;
    private static int W;
    private static char[][] carr;
    private static int[][] area;
    private static char l = (char)0;
    private static final int[][] dirs = new int[][]{{-1,0},{0,-1},{0,1},{1,0}};

    public static int[] getMin(int x, int y) {
        int[] res = null;
        int min = Integer.MAX_VALUE;
        for (int[] d : dirs) {
            int xn = x + d[0];
            int yn = y + d[1];
            if (xn >= 0 && yn >= 0 && xn < H && yn < W) {
                if (min > area[xn][yn]) {
                    min = area[xn][yn];
                    res = new int[]{xn, yn};
                }
            }
        }
        return res;
    }

    public static char f(int x, int y) {
        if (carr[x][y] != 0) return carr[x][y];
        
        int[] m = getMin(x,y);
        if (m == null || (area[m[0]][m[1]] >= area[x][y]))
        {
            carr[x][y] = l;
            ++l;
        } else if (carr[m[0]][m[1]] != 0)
        {
            carr[x][y] = carr[m[0]][m[1]];
        } else
        {
            char cn = f(m[0], m[1]);
            carr[x][y] = cn;
        }
        return carr[x][y];
    }

    public static void main(String[] args) throws IOException {
        File fIn = new File(args[0]);
        File fOut = new File(args[1]);
        FileReader fileReader = new FileReader(fIn);
        FileWriter fileWriter = new FileWriter(fOut);
        BufferedReader in = new BufferedReader(fileReader);
        BufferedWriter out = new BufferedWriter(fileWriter);

        try {
            Scanner sc = new Scanner(in);
            int testCases = readIntsLine(sc, 1)[0];

            for (int i = 0; i < testCases; ++i) {
                int[] size = readIntsLine(sc, 2);
                H = size[0];
                W = size[1];
                area = new int[H][W];
                carr = new char[H][W];
                for (int j=0; j<H; ++j) {
                    area[j] = readIntsLine(sc, W);
                    Arrays.fill(carr[j], (char)0);
                }
                l = 'a';
                for (int x = 0; x<H; ++x) {
                    for (int y=0; y<W; ++y) {
                        if (carr[x][y] == 0) {
                            f(x,y);
                        }
                    }
                }


                String resultStr = "Case #" + (i + 1) + ": \n";
                out.append(resultStr);
                for (int j=0; j<H; ++j) {
                    for (int k=0; k<W; ++k) {
                        out.write(carr[j][k]);
                        out.write(' ');
                    }
                    out.newLine();
                }

            }
            out.flush();
        } finally {
            in.close();
            out.close();
        }
    }

    private static int[] readIntsLine(Scanner sc, int len) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        int[] res = new int[len];
        for (int i = 0; i < len; ++i) {
            res[i] = lineScanner.nextInt();
        }
        return res;
    }

    private static String[] readTokensLine(Scanner sc, int len) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        String[] res = new String[len];
        for (int i = 0; i < len; ++i) {
            res[i] = lineScanner.next();
        }
        return res;
    }

}