import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class SavingUniverse
{


    private static int findFirst(String[] queries, int startIndex,
                                 String server)
    {
        int min = startIndex;
        for (min = startIndex; min < queries.length; ++min) {
            if (server.equals(queries[min])) {
                break;
            }
        }

        return min;
    }


    public static int solve(String[] servers,
                            String[] queries,
                            int start,
                            String currentServer)
    {
        int lookIndex = start;
        int res = 0;
        Set<String> maxSet = null;

        int max = lookIndex-1;
        for (String server : servers) {
            if (!server.equals(currentServer)) {
                int first = findFirst(queries, lookIndex, server);
                if (first > max) {
                    maxSet = new HashSet<String>();
                    maxSet.add(server);
                    max = first;
                } else if (first == max) {
                    maxSet.add(server);
                }
            }
        }
        lookIndex = max;
        if (lookIndex < queries.length) {
            res = Integer.MAX_VALUE;
            for (String server: maxSet) {
                int innerRes = solve(servers, queries, lookIndex, server);
                if (innerRes + 1 < res) {
                    res = innerRes + 1;
                }
            }
        }

        return res;
    }

    private static String[] readStrArr(Scanner sc)
    {
        int s = readIntLine(sc);
        String[] lines = new String[s];
        for (int i = 0; i < s; ++i) {
            lines[i] = sc.nextLine();
        }
        return lines;
    }

    public static void main(String[] args) throws IOException
    {
        File dir = new File("/home/yurij/personal/topcoder/competition/src");
        File fIn = new File(dir, "A-small-attempt3.in");
        File fOut = new File(dir, "a.out");

        FileReader fileReader = new FileReader(fIn);
        FileWriter fileWriter = new FileWriter(fOut);

        BufferedReader in = new BufferedReader(fileReader);
        BufferedWriter out = new BufferedWriter(fileWriter);


        Scanner sc = new Scanner(in);
        int n = readIntLine(sc);

        for (int i = 0; i < n; ++i) {
            String[] servers = readStrArr(sc);
            String[] queries = readStrArr(sc);

            int res = solve(servers, queries, 0, "!");
            String resultStr = "Case #" + (i + 1) + ": " + res;
            if (i != 0) {
                out.newLine();
            }
            out.append(resultStr);
        }
        out.flush();

        in.close();
        out.close();
    }


    private static int readIntLine(Scanner sc)
    {
        Scanner firstLineScanner = new Scanner(sc.nextLine());
        return firstLineScanner.nextInt();
    }
}
