import java.io.IOException;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.util.Scanner;
import java.util.Arrays;

public class B {

    private static int N;
    private static int M;
    private static int[][] area = null;
    private static int[][] S = null;
    private static int[][] W = null;
    private static int[][] C = null;
    private static int[][] T = null;

    public static void solve() {

        area[0][0] = 0;

        for(int i=0; i<2*N; ++i) {
            if (i>0) {
                int wait = findWait(area[i-1][0], true, (i-1)/2, 0);
                area[i][0] = area[i-1][0] + wait;
            }
            for (int j=1; j<2*M; ++j) {
                if (j%2 == 0) {
                    area[i][j] = area[i][j-1] + 2;
                } else {
                    int wait = findWait(area[i][j-1], false, i/2, (j-1)/2);
                    area[i][j] = area[i][j-1] + wait;
                }
                if (i>0) {
                    int wait;
                    if (i%2 == 0) {
                        wait = 2;
                    } else {
                        wait = findWait(area[i-1][j], true, (i-1)/2, j/2);
                    }
                    area[i][j] = Math.min(area[i][j], area[i-1][j] + wait);
                }
            }
        }
    }

    private static int findWait(int m, boolean isS, int x, int y) {
        int p = (S[x][y] + W[x][y]);
        int t = (T[x][y] > 0) ? T[x][y] - C[x][y] : 0;
        int d = m%p;
        int wait = 0;
        if (isS) {
            if ((t<= d && d < t+S[x][y]) ||
                (t+p<= d && d < t+S[x][y]+p))  {
                wait = 1;
            } else if (d >= t+S[x][y] && t+p > d) {
                wait = t+p - d + 1;
            } else {
                wait = t+2*p - d+1;
            }
        } else {
            if ((t+S[x][y]<= d && d < t+p) ||
                (t+p+S[x][y]<= d && d < t+2*p))  {
                wait = 1;
            } else if (d < t+S[x][y]) {
                wait = t+S[x][y] - d+1;
            } else {
                wait = t+ p - d+1;
            }
        }
        return wait;
    }

    public static void main(String[] args) throws IOException {
        File fIn = new File(args[0]);
        File fOut = new File(args[1]);
        FileReader fileReader = new FileReader(fIn);
        FileWriter fileWriter = new FileWriter(fOut);
        BufferedReader in = new BufferedReader(fileReader);
        BufferedWriter out = new BufferedWriter(fileWriter);

        try {
            Scanner sc = new Scanner(in);
            int testCases = readIntsLine(sc, 1)[0];

            for (int i = 0; i < testCases; ++i) {
                int[] size = readIntsLine(sc, 2);
                N = size[0];
                M = size[1];
                area = new int[2*N][2*M];
                S = new int[N][M];
                W = new int[N][M];
                C = new int[N][M];
                T = new int[N][M];
                for (int j=0; j<N; ++j) {
                    int[] p = readIntsLine(sc, 3*M);
                    for (int k=0; k<M; ++k) {
                        S[j][k] = p[3*k];
                        W[j][k] = p[3*k+1];
                        final int c = p[3 * k] + p[3 * k + 1];
                        C[j][k] = c;
                        T[j][k] = ((p[3*k+2]) % c);
                    }
                }
                solve();
                String resultStr = "Case #" + (i + 1) + ": " +
                        area[2*N-1][2*M-1];
                if (i != 0) {
                    out.newLine();
                }
                out.append(resultStr);
            }
            out.flush();
        } finally {
            in.close();
            out.close();
        }
    }

    private static int[] readIntsLine(Scanner sc, int len) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        int[] res = new int[len];
        for (int i = 0; i < len; ++i) {
            res[i] = lineScanner.nextInt();
        }
        return res;
    }

}