import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class A {

    private static final int MAX = 100000;
    private static boolean[][] RESULTS = new boolean[9][MAX];
    private static boolean init = false;

    private static void init() {
        init = true;
        for (int i = 2; i < 11; ++i) {
            for (int j = 2; j < MAX + 2; ++j) {
                RESULTS[i - 2][j - 2] = checkHappy(j, i);
            }
        }
        init = false;
    }

    private static long getSq(long a, int base) {
        long res = 0;
        while (a > 0) {
            long v = a % base;
            res += v * v;
            a /= base;
        }
        return res;
    }

    public static boolean checkHappy(long a, int base) {
        if (!init && a < MAX + 2) {
            return RESULTS[base - 2][(int) a - 2];
        }
        Set<Long> set = new HashSet<Long>();
        boolean f = true;

        while (f) {
            set.add(a);
            a = getSq(a, base);
            if (a == 1) {
                return true;
            }
            if (set.contains(a)) {
                f = false;
            }
        }
        return false;
    }

    public static long solve(Integer[] bases) {

        long a = 1;

        boolean ok = false;

        while (!ok) {
            ok = true;
            ++a;
            for (int i = 0; i < bases.length; ++i) {
                ok &= checkHappy(a, bases[i]);
                if (!ok) break;
            }
        }
        return a;
    }

    public static void main(String[] args) throws IOException {
        File fIn = new File(args[0]);
        File fOut = new File(fIn.getParentFile(), "a.out");

        FileReader fileReader = new FileReader(fIn);
        FileWriter fileWriter = new FileWriter(fOut);

        BufferedReader in = new BufferedReader(fileReader);
        BufferedWriter out = new BufferedWriter(fileWriter);

        init();
        try {
            Scanner sc = new Scanner(in);
            int testCases = readIntsLine(sc)[0];

            for (int i = 0; i < testCases; ++i) {
                Integer[] bases = readIntsLine(sc);
                long res = solve(bases);
                String resultStr = "Case #" + (i + 1) + ": " + res;
                if (i != 0) {
                    out.newLine();
                }
                out.append(resultStr);
            }
            out.flush();
        } finally {
            in.close();
            out.close();
        }
    }


    private static Integer[] readIntsLine(Scanner sc) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        ArrayList<Integer> arr = new ArrayList<Integer>();
        while (lineScanner.hasNextInt()) {
            arr.add(lineScanner.nextInt());
        }

        return arr.toArray(new Integer[arr.size()]);
    }

}