import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import static java.util.Arrays.deepToString;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;
import java.util.Map;
import java.util.HashMap;
import java.math.BigInteger;


public class A {

    public static void main(String[] args) throws IOException {
        File fIn = new File("C:\\Work\\GCJ\\download\\A-small-attempt0.in");
        File fOut = new File("C:\\Work\\GCJ\\src\\a.out");

        FileReader fileReader = new FileReader(fIn);
        FileWriter fileWriter = new FileWriter(fOut);

        BufferedReader in = new BufferedReader(fileReader);
        BufferedWriter out = new BufferedWriter(fileWriter);


        try {
            Scanner sc = new Scanner(in);
            int testCases = readIntsLine(sc, 1)[0];

            for (int i = 0; i < testCases; ++i) {
                String q = sc.nextLine().trim();
                String res = solve(q);

                System.out.println("i = " + i);
                String resultStr = "Case #" + (i + 1) + ": " + res;

                if (i != 0) {
                    out.newLine();
                    out.flush();
                }
                out.append(resultStr);
                out.flush();
            }
        } finally {
            in.close();
            out.close();
        }
    }




    private static String solve(String q) {
        Map<Character, Integer> m = new HashMap <Character, Integer>();
        m.put(q.charAt(0), 1);
        int j = 1;
        while(q.length() > j) {
            if (q.charAt(0) != q.charAt(j)) {
                m.put(q.charAt(j), 0);
                break;
            }
            ++j;
        }
        int c = 2;
        for (int i=j+1; i<q.length(); ++i) {
            final char ch = q.charAt(i);
            if (m.get(ch) == null) {
                m.put(ch, c);
                ++c;
            }
        }

        StringBuilder sb = new StringBuilder();

        for (int i=0; i<q.length(); ++i) {
            final char ch = q.charAt(i);
            int v = m.get(ch);
            sb.append(convert(v));
        }
        int base = m.entrySet().size();
//        System.out.println("base = " + base);
        if (base == 1) {
            base = 2;
        }
        BigInteger b = new BigInteger(sb.toString(), base);
        return b.toString(10);
    }

    private static char convert (int a) {
        if (a < 10) {
            return (char)('0'+a);
        } else {
            return (char)('a'+a-10);
        }
    }


    private static void debug(Object... os) {
        System.err.println(deepToString(os));
    }

    private static int[] readIntsLine(Scanner sc, int len) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        int[] res = new int[len];
        for (int i = 0; i < len; ++i) {
            res[i] = lineScanner.nextInt();
        }
        return res;
    }

    private static String[] readLines(Scanner sc, int len) {
        String[] res = new String[len];
        for (int i = 0; i < len; ++i) {
            res[i] = sc.nextLine();
        }
        return res;
    }

}
