import java.io.IOException;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.util.Scanner;
import java.util.Arrays;
import java.text.DecimalFormat;

public class C {

    private final static String str = "welcome to code jam";

    public static int solve(String s) {
        int dp[] = new int[s.length()];
        Arrays.fill(dp, 1);
        for (char c:str.toCharArray()) {
            int prev = 0;
            for (int i=0; i<s.length(); ++i) {
                char a = s.charAt(i);
                if (a == c) {
                    dp[i] = dp[i] + prev;
                } else {
                    dp[i] = prev;
                }
                prev = dp[i];
            }
        }
        return dp[s.length()-1];
    }

    public static void main(String[] args) throws IOException {
        File fIn = new File(args[0]);
        File fOut = new File(args[1]);

        FileReader fileReader = new FileReader(fIn);
        FileWriter fileWriter = new FileWriter(fOut);

        BufferedReader in = new BufferedReader(fileReader);
        BufferedWriter out = new BufferedWriter(fileWriter);

        try {
            Scanner sc = new Scanner(in);
            int testCases = readIntsLine(sc, 1)[0];

            for (int i = 0; i < testCases; ++i) {
                String s = sc.nextLine();
                long res = solve(s);
                DecimalFormat df = new DecimalFormat("0000");
                String resultStr = "Case #" + (i + 1) + ": " + df.format(res);
                if (i != 0) {
                    out.newLine();
                }
                out.append(resultStr);
            }
            out.flush();
        } finally {
            in.close();
            out.close();
        }
    }


    private static int[] readIntsLine(Scanner sc, int len) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        int[] res = new int[len];
        for (int i = 0; i < len; ++i) {
            res[i] = lineScanner.nextInt();
        }
        return res;
    }

    private static String[] readTokensLine(Scanner sc, int len) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        String[] res = new String[len];
        for (int i = 0; i < len; ++i) {
            res[i] = lineScanner.next();
        }
        return res;
    }

}