import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import java.util.List;
import java.util.LinkedList;
import java.util.Set;
import java.util.HashSet;
import java.util.ArrayList;
import java.util.Collections;
import java.util.regex.Pattern;

public class A {

    public static List<Set<Character>> getPat(String pattern, int L) {
        List<Set<Character>> setList = new ArrayList<Set<Character>>(L);
        Set<Character> currSet = new HashSet<Character>();
        boolean orCond = false;
        for (char c: pattern.toCharArray()) {
            if (c == '(') {
                currSet = new HashSet<Character>();
                orCond = true;
            } else if (c == ')') {
                orCond = false;
                setList.add(currSet);
            } else {
                if (orCond) {
                    currSet.add(c);
                } else {
                    setList.add(Collections.singleton(c));
                }
            }
        }

        return setList;
    }

    public static void main(String[] args) throws IOException {
        File fIn = new File(args[0]);
        File fOut = new File(args[1]);
        FileReader fileReader = new FileReader(fIn);
        FileWriter fileWriter = new FileWriter(fOut);
        BufferedReader in = new BufferedReader(fileReader);
        BufferedWriter out = new BufferedWriter(fileWriter);

        try {
            Scanner sc = new Scanner(in);
            final int[] ints = readIntsLine(sc, 3);
            
            int L = ints[0];
            int D = ints[1];
            int N = ints[2];

            List<String> dict = new LinkedList<String>();
            for (int i=0; i<D; ++i) {
                String word = sc.nextLine();
                dict.add(word);
            }
            for (int i = 0; i < N; ++i) {
                String patternStr = sc.nextLine();
                List<Set<Character>> p = getPat(patternStr, L);
                long res = 0;
                for (String word: dict) {
                    boolean isOk = true;
                    for (int j=0; j<L; ++j) {
                        if (!p.get(j).contains(word.charAt(j))) {
                            isOk = false;
                            break;
                        }
                    }
                    if (isOk) {
                        ++res;
                    }
                }
                String resultStr = "Case #" + (i + 1) + ": " + res;
                if (i != 0) {
                    out.newLine();
                }
                out.append(resultStr);
            }
            out.flush();
        } finally {
            in.close();
            out.close();
        }
    }

    private static int[] readIntsLine(Scanner sc, int len) {
        Scanner lineScanner = new Scanner(sc.nextLine());
        int[] res = new int[len];
        for (int i = 0; i < len; ++i) {
            res[i] = lineScanner.nextInt();
        }
        return res;
    }
}