package codejam.qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class TicTacToe {
    char[][] board = new char[4][4];

    TicTacToe(char[][] board) {
        this.board = board;
    }
    boolean checkWinFor(char person) {
        boolean win;
        //horizontal
        for(int i = 0; i < 4; i++){
            win = true;
            for(int j = 0; j < 4; j++) {
                if (board[i][j] != person && board[i][j] != 'T') {
                    win = false; break;
                }
            }
            if (win == true) return true;
        }

        //vertical
        for(int i = 0; i < 4; i++){
            win = true;
            for(int j = 0; j < 4; j++) {
                if (board[j][i] != person && board[i][j] != 'T') {
                    win = false; break;
                }
            }
            if (win == true) return true;
        }

        //diagnol
        win = true;
        for(int j = 0; j < 4; j++) {
            if (board[j][j] != person && board[j][j] != 'T') {
                win = false; break;
            }
        }
        if (win == true) return true;

        win = true;
         for(int j = 0; j < 4; j++) {
             if (board[j][3-j] != person && board[j][3-j] != 'T') {
                 win = false; break;
             }
         }
         if (win == true) return true;

        return false;
    }

    String getState() {

        //check if X has won
        if( checkWinFor('X') == true) return "X won";
        if( checkWinFor('O') == true) return "O won";

        for(int i = 0; i< 4; i++){
            for(int j=0; j<4; j++) {
                if(board[i][j] == '.')
                    return "Game has not completed";
            }
        }
        return "Draw";
    }

    public static void main(String[] args) {
        BufferedReader br = null;
        String fileLocation = args.length == 1 ? args[0] : "/Users/prateeka/Downloads/testing1.txt";
        try {

            br = new BufferedReader(new FileReader(fileLocation));

            int T = Integer.parseInt(br.readLine());
            for(int i = 1; i <= T; i++) {
                char[][] board = new char[4][4];

                for(int j = 0; j <= 3; j++) {
                    String sCurrentLine = br.readLine();
//                    while ((sCurrentLine = br.readLine()) != null)
                    board[j] = sCurrentLine.toCharArray();
                }

                TicTacToe ticTacToe = new TicTacToe(board);
                System.out.println("Case #"+ i +": " + ticTacToe.getState());

                br.readLine();
            }

        } catch (IOException e) {
            e.printStackTrace();
        } finally {
            try {
                if (br != null) br.close();
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
    }
}
