package codejam.qualification;

import java.math.BigInteger;

public class GenerateSquares {

    static boolean isPallindrome(String value) {
        int size = value.length();
        for(int i = 0; i < size; i++)
            if(value.charAt(i) != value.charAt(size - i - 1))
                return false;
        return true;
    }

    static void squares(int p) {
        long square = (long)p * (long)p;
        String squareString = String.valueOf(square);
        if(isPallindrome(squareString))
            System.out.println(square);
    }

   static void squares(BigInteger p) {
        BigInteger square = p.multiply(p);
        String squareString = String.valueOf(square);
        if(isPallindrome(squareString))
            System.out.println(square);
    }

    static void pallindromes(int length, String prefix, String suffix) {
        int start = prefix == "" ? 1 : 0;
        if(length == 1){
            for(int i = start; i< 10; i++){
                squares(new BigInteger(prefix + i + suffix));
            }
        }
        else if(length == 2){
            for(int i = start; i< 10; i++){
                squares(new BigInteger(prefix + i + i + suffix));
            }
        }
        else {
            for(int i = start; i < 10; i++){
                pallindromes(length - 2, prefix + i, i+ suffix);
            }
        }
    }

    public static void main(String[] args) {
        for(int i = 1; i <= 50; i++)
            pallindromes(i,"","");
    }
}
