package codeJam2016;

import java.io.File;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class JamCoins {
	private static final String DIR_PATH = "C:\\Users\\Abhineet\\OneDrive\\ProjectWork\\GoogleCodeJam\\src\\codeJam2016";

	private static final String INPUT_FILE_NAME = "C-small-attempt0.in";
	private static final String OUTPUT_FILE_NAME = INPUT_FILE_NAME + "__out.txt";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try{
			Scanner scn = new Scanner(new File(DIR_PATH +File.separator + INPUT_FILE_NAME));
			PrintWriter pw = new PrintWriter(new File(DIR_PATH +File.separator +OUTPUT_FILE_NAME ));
			int numTestCases = Integer.parseInt(scn.nextLine());
			System.out.println("# of Test Cases : " +numTestCases);
			int testCaseNum = 1;
			while(scn.hasNextLine()){
				String[] arrTokens = scn.nextLine().split("[\\s]+");
				System.out.println(arrTokens.length);
				int N = Integer.parseInt(arrTokens[0]);
				int J = Integer.parseInt(arrTokens[1]);
				System.out.println("N = " +N +"\t J = " +J);
				Map<String , long[]> map = new HashMap<String , long[]>();
				int[] arr1 = getStartingArr(N);
				int[] arr2 = getStartingArr(N);
				flip(arr1, 1);
				for(int index = 1 ; index < N - 1; index++){
					flip(arr1, index);
					flip(arr2, index);
					long[] arrDiv1 = new long[9];
					long[] arrDiv2 = new long[9];
					boolean isJamCoin1 = true;
					boolean isJamCoin2 = true;
					for(int base = 2; base <= 10; base++){
						if(isJamCoin1){
							long num1 = getNumInBase(arr1, base);
							//System.out.println("\tNUM 1 : " +num1 +" BAse : " +base);
							long div1 = isPrime(num1);
							if(div1 == -1){
								isJamCoin1 = false;
							}else{
								arrDiv1[base-2] = div1; 
							}
						}
						
						if(isJamCoin2){
							long num2 = getNumInBase(arr2, base);
							//System.out.println("\tNUM 2 : " +num2 +" BAse : " +base);
							long div2 = isPrime(num2);
							if(div2 == -1){
								isJamCoin2 = false;
							}else{
								arrDiv2[base-2] = div2; 
							}
						}
						
						if(!isJamCoin1 && !isJamCoin2 ){
							break;
						}
					}
					//System.out.println(toString(arr1) +" --> " +isJamCoin1);
					//System.out.println(toString(arr2) +" --> " +isJamCoin2);
					if(isJamCoin1){
						map.put(toString(arr1), arrDiv1);
					}
					if(isJamCoin2){
						//System.out.println("\t" +toString(arr2));
						map.put(toString(arr2), arrDiv2);
					}
					if(map.keySet().size() == J){
						break;
					}
				}
				StringBuffer out = new StringBuffer("Case #" +(testCaseNum++) +":\n");
				for(String jamCoin : map.keySet()){
					out.append(jamCoin);
					for(long div : map.get(jamCoin)){
						out.append(' ');
						out.append(div);
					}
					out.append("\n");
				}
				System.out.println(out);
				pw.println(out.toString());
			}
			scn.close();
			pw.close();
		}catch(Exception exc){
			exc.printStackTrace();
		}
	}
	
	private static int[] getStartingArr(int len){
		int[] arr = new int[len];
		arr[0] = arr[len-1] = 1;
		return arr;
	}
	
	private static void flip(int[] arr, int index){
		arr[index] = arr[index] == 0 ? 1 : 0;
	}
	
	
	private static long getNumInBase(int[] arr, int base){
		int len = arr.length;
		long retNum = arr[len - 1];
		for(int index = len - 2; index >= 0; index--){
			retNum += arr[index] * (long)Math.pow(base, len - index - 1);
		}
		return retNum;
	}
	
	private static long isPrime(long num){
		for(long div = (int)Math.sqrt(num); div > 1; div--){
			if(num % div == 0){
				return div;
			}
		}
		return -1;
	}
	
	private static String toString(int[] arr){
		StringBuffer strBuf = new StringBuffer();
		for(int val : arr){
			strBuf.append(val);
		}
		return strBuf.toString();
	}
}
