/**
 * 
 */
package codeJam2016;

import java.io.File;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;

/**
 * @author Abhineet
 *
 */
public class RevengeOfPancakes {

private static final String DIR_PATH = "C:\\Users\\Abhineet\\OneDrive\\ProjectWork\\GoogleCodeJam\\src\\codeJam2016";
	
	private static final String INPUT_FILE_NAME = "B-small-attempt0.in";
	private static final String OUTPUT_FILE_NAME = INPUT_FILE_NAME + "__out.txt";
	
	private static class Node{
		char[] inputArr;
		int level;
		Node[] arrChildren;
		String val;
		
		Node(char[] arr, int level){
			this.inputArr = arr;
			this.level = level;
			this.arrChildren = new Node[arr.length];
			this.val = new String(arr);
		}
		
		@Override
		public boolean equals(Object obj){
			if(obj instanceof Node){
				Node otherObj = (Node)obj;
				return val.equals(otherObj.val);
			}else{
				return false;
			}
		}
		
		@Override
		public int hashCode(){
			return val.hashCode();
		}
		
		@Override
		public String toString(){
			return val +" ( Level : " +level +" )";
		}
		
		public char[] copyOfArr(){
			return val.toCharArray();
		}
		
		public boolean isHeadsUp(){
			for(char ch : inputArr){
				if(ch != '+'){
					return false;
				}else{
					//do nothing carry on
				}
			}
			return true;
		}
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try{
			Scanner scn = new Scanner(new File(DIR_PATH +File.separator + INPUT_FILE_NAME));
			PrintWriter pw = new PrintWriter(new File(DIR_PATH +File.separator +OUTPUT_FILE_NAME ));
			int numTestCases = Integer.parseInt(scn.nextLine());
			System.out.println("# of Test Cases : " +numTestCases);
			int testCaseNum = 1;
			while(scn.hasNextLine()){
				String line = scn.nextLine();
				char[] arr = line.toCharArray();
				String out = "Case #" +(testCaseNum++) +": " +bfs(arr);
				System.out.println(out);
				pw.println(out);
				//boolean success = flip(arr, arr.length - 1);
				//System.out.println(new String (arr) +" ( Success : " +success +" )") ;
			}
			scn.close();
			pw.close();
		}catch(Exception exc){
			exc.printStackTrace();
		}
	}
	
	private static int bfs(char[] inputArr){
		Queue<Node> queue = new LinkedList<Node>();
		queue.add(new Node(inputArr, 0));
		Set<Node> visited = new HashSet<Node>();
		while(!queue.isEmpty()){
			Node currNode = queue.poll();
			if(currNode.isHeadsUp()){
				return currNode.level;
			}
			//System.out.println("Visiting " +currNode);
			visited.add(currNode);
			for(int index = 0 ; index < currNode.inputArr.length; index++){
				char[] arr = currNode.copyOfArr();
				flip(arr, index);
				currNode.arrChildren[index] = new Node(arr, currNode.level + 1);
			}
			for(Node child : currNode.arrChildren){
				if(!visited.contains(child)){
					queue.add(child);
				}
			}
		}
		return -1;
	}
	
	private static void flip(char[] inputArr, int n){
		int start = 0;
		int end = n;
		while(start <= end){
			char temp = inputArr[start] == '+' ? '-' : '+';
			inputArr[start] = inputArr[end] == '+' ? '-' : '+';
			inputArr[end] = temp;
			start++;
			end--;
		}
	}
}
