import java.io.BufferedReader;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.List;


public class Problem2 {
	private static int[][] multMat = new int[4][4];
	
	private static int getCharCode(char a){
		switch(a){
		case '1':
			return 1;
		case 'i':
			return 2;
		case 'j':
			return 3;
		case 'k':
			return 4;
		default:
			return -1;
		}
	}
	
	private static char getChar(int code){
		switch(code){
		case 1:
			return '1';
		case 2:
			return 'i';
		case 3:
			return 'j';
		case 4:
			return 'k';
		default:
			return 0;
		}
	}
	
	static{
		multMat[0][0] = 1;
		multMat[0][1] = 2;
		multMat[0][2] = 3;
		multMat[0][3] = 4;
		
		multMat[1][0] = 2;
		multMat[1][1] = -1;
		multMat[1][2] = 4;
		multMat[1][3] = -3;
		
		multMat[2][0] = 3;
		multMat[2][1] = -4;
		multMat[2][2] = -1;
		multMat[2][3] = 2;
		
		multMat[3][0] = 4;
		multMat[3][1] = 3;
		multMat[3][2] = -2;
		multMat[3][3] = -1;
		
	}
	
	private static int multiply(char a, char b){
		return multMat[getCharCode(a) -1][getCharCode(b) -1];
	}
	
	
	
	public static void main(String[] args){
		List<String> lst = readFileLineByLine("D:/Downloads/C-small-attempt2.in");
		int totalCases = 0;
		if(lst.size() > 0){
			totalCases = Integer.parseInt(lst.get(0));
		}
		int currLineIter =  1;
		for(int caseIter = 0; caseIter < totalCases; caseIter++){
			String firstLine  = lst.get(currLineIter++);
			String secondLine  = lst.get(currLineIter++);
			String[] arr = firstLine.split(" ");
			int l =Integer.parseInt(arr[0]);
			int x = Integer.parseInt(arr[1]);
			StringBuffer objStrBuf = new StringBuffer(l * x);
			for(int repeater = 0; repeater < x ; repeater++){
				objStrBuf.append(secondLine);
			}
			if(isItPossible(objStrBuf.toString())){
				System.out.println("Case #"+(caseIter+1)+": YES");
			}else{
				System.out.println("Case #"+(caseIter+1)+": NO");
			}
		}
	}
	
	
	private static boolean isItPossible(String str){
		char[] cArr = str.toCharArray();
		int currIndex = 0;
		boolean positive = true;
		char result = '1';
		boolean foundI = false;
		boolean foundJ = false;
		boolean foundK = false;
//		boolean gotI = false;
//		boolean gotJ = false;
//		boolean gotK = false;
		while(currIndex < cArr.length){
			if(!foundI && (cArr[currIndex] == 'i' || result == 'i')){
				foundI = true;
			}
			if(!foundJ && (cArr[currIndex] == 'j' || result == 'j')){
				foundJ = true;
			}
			if(!foundK && (cArr[currIndex] == 'k' || result == 'k')){
				foundK = true;
			}
			int multRes = multiply(result, cArr[currIndex++]);
			if((positive && multRes > 0) || (!positive && multRes < 0)){
				positive = true;
			}else{
				positive = false;
			}
			result = getChar(Math.abs(multRes));
			//System.out.println("\t=" + multRes);
			
//			if(!gotI && result == 'i' && positive){
//				result = '1';
//				gotI = true;
//				continue;
//			}
//			
//			if(!gotJ && result == 'j' && positive){
//				result = '1';
//				gotJ = true;
//				continue;
//			}
//			
//			if(!gotK && result == 'k' && positive){
//				result = '1';
//				gotK = true;
//				continue;
//			}
		}
		return (result == '1' && !positive && foundI && foundJ && foundK);
	}
	
	private static List<String> readFileLineByLine(String path){
		List<String> retList = new ArrayList<String>();
		try{
			BufferedReader buf = new BufferedReader(new FileReader(path));
			String line;
			while((line=buf.readLine()) != null){
				retList.add(line);
			}
		}catch(Exception exc){
			System.err.println("Exception : " +exc.getMessage());
		}
		return retList;
	}
}
