
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.Reader;

public class TicTacToeTomek {
    public TicTacToeTomek() {
        super();
    }

    private static final String PARENT_DIR =
        "C:\\Users\\blackShadow\\Desktop\\Code Jam\\PreElims\\TicTacToe\\";

    private static final String INPUT_FILE = "in.txt";
    private static final String OUTPUTPUT_FILE = "out.txt";

    public static void main(String[] args) {
        //readAndProcessInput(PARENT_DIR + INPUT_FILE,
          //                  PARENT_DIR + OUTPUTPUT_FILE);
                readAndProcessInput(args[0], args[1]);
    }

    private static void readAndProcessInput(String filePath,
                                            String outFilePath) {
        File objFile = new File(filePath);
        try {
            FileInputStream fis = new FileInputStream(objFile);
            FileReader objFileReader = new FileReader(objFile);
            BufferedReader objBufReader = new BufferedReader(objFileReader);
            FileWriter objFileWriter = new FileWriter(new File(outFilePath));
            String str = objBufReader.readLine();
            int noOfTestCases = Integer.parseInt(str);
            System.out.println("Total No of Test Cases : " + noOfTestCases);
            for (int i = 1; i <= noOfTestCases; i++) {
                String[] arrLines = new String[4];
                char[][] arrTicTacToe = new char[4][4];
                for (int j = 0; j < 4; j++) {
                    arrLines[j] = objBufReader.readLine();
                    arrTicTacToe[j] = arrLines[j].toCharArray();
                }

                String outputStr =
                    "Case #" + i + ": " + processGameState(arrTicTacToe) +
                    "\n";
                System.out.print(outputStr);
                objFileWriter.write(outputStr);
                if (i != noOfTestCases) {
                    objBufReader.readLine();
                }
            }
            objBufReader.close();
            objFileWriter.close();

        } catch (Exception e) {
            e.printStackTrace();
        }
    }


    private static final String X_WON =
        "X won"; // (the game is over, and X won)
    private static final String O_WON =
        "O won"; // (the game is over, and O won)
    private static final String DRAW =
        "Draw"; // (the game is over, and it ended in a draw)
    private static final String INCOMPLETE =
        "Game has not completed"; // (the game is not over yet)

    private static String processGameState(char[][] arrTicTacToe) {
        boolean dotEncountered = false;
        for (int x = 0; x < 4; x++) {
            for (int y = 0; y < 4; y++) {
                char currChar = arrTicTacToe[x][y];
                if (currChar == '.') {
                    dotEncountered = true;
                }
                if (currChar == 'X' || currChar == 'O') {
                    boolean won =
                        checkHorizontally(arrTicTacToe, x, y, currChar) ||
                        checkVertically(arrTicTacToe, x, y, currChar) ||
                        checkDiagonally(arrTicTacToe, x, y, currChar);
                    if (won) {
                        if (currChar == 'X') {
                            return X_WON;
                        } else {
                            return O_WON;
                        }
                    } else {
                        //do nothing. Proceed Check all.             }
                    }

                } else if (currChar == 'T') {
                    if (y == 0) {
                        char nextHorChar = arrTicTacToe[x][y + 1];
                        if (nextHorChar == 'X' || nextHorChar == 'O') {
                            if (checkHorizontally(arrTicTacToe, x, y,
                                                  arrTicTacToe[x][y + 1])) {
                                if (nextHorChar == 'X') {
                                    return X_WON;
                                } else {
                                    return O_WON;
                                }
                            } else {
                                //dop nothing PROCEEED WITH OTHER CHECKS
                            }
                        } else {
                            //do nothing
                        }
                    }

                    if (x == 0) {

                        char nextVerChar = arrTicTacToe[x + 1][y];

                        if (nextVerChar == 'X' || nextVerChar == 'O') {
                            if (checkVertically(arrTicTacToe, x, y,
                                                nextVerChar)) {
                                if (nextVerChar == 'X') {
                                    return X_WON;
                                } else {
                                    return O_WON;
                                }
                            } else {
                                //do nothing
                            }
                        } else {
                            //do nothing
                        }
                    }

                    if (x == 0 && y == 0 &&
                        checkDiagonally(arrTicTacToe, x, y, arrTicTacToe[1][1])) {
                        if (arrTicTacToe[1][1] == 'X') {
                            return X_WON;
                        } else {
                            return O_WON;
                        }
                    } else if (x == 0 && y == 3 &&
                               checkDiagonally(arrTicTacToe, x, y,
                                               arrTicTacToe[1][2])) {
                        if (arrTicTacToe[1][2] == 'X') {
                            return X_WON;
                        } else {
                            return O_WON;
                        }
                    }
                }
            }
        }
        if (dotEncountered) {
            return INCOMPLETE;
        } else {
            return DRAW;
        }
    }

    private static boolean checkHorizontally(char[][] arrTicTacToe, int xStart,
                                             int yStart, char playerChar) {
        if (yStart > 0) {
            return false;
        } else {
            ///PROCEED
        }
        int count = 1;
        ++yStart;
        for (; yStart <= 3; yStart++) {
            char currChar = arrTicTacToe[xStart][yStart];
            if (currChar == playerChar || currChar == 'T') {
                count++;
            } else {
                break;
            }
        }
        return (count == 4);
    }

    private static boolean checkVertically(char[][] arrTicTacToe, int xStart,
                                           int yStart, char playerChar) {
        if (xStart > 0) {
            return false;
        } else {
            //PROCEED
        }
        int count = 1;
        ++xStart;
        for (; xStart <= 3; xStart++) {
            char currChar = arrTicTacToe[xStart][yStart];
            if (currChar == playerChar || currChar == 'T') {
                count++;
            } else {
                break;
            }
        }
        return (count == 4);
    }

    private static boolean checkDiagonally(char[][] arrTicTacToe, int xStart,
                                           int yStart, char playerChar) {
        if (xStart == 0 && yStart == 0) {
            return ((arrTicTacToe[0][0] == 'T' ||
                     arrTicTacToe[0][0] == playerChar) &&
                    (arrTicTacToe[1][1] == 'T' ||
                     arrTicTacToe[1][1] == playerChar) &&
                    (arrTicTacToe[2][2] == 'T' ||
                     arrTicTacToe[2][2] == playerChar) &&
                    (arrTicTacToe[3][3] == 'T' ||
                     arrTicTacToe[3][3] == playerChar));

        } else if (yStart == 3 && xStart == 0) {
            return ((arrTicTacToe[0][3] == 'T' ||
                     arrTicTacToe[0][3] == playerChar) &&
                    (arrTicTacToe[1][2] == 'T' ||
                     arrTicTacToe[1][2] == playerChar) &&
                    (arrTicTacToe[2][1] == 'T' ||
                     arrTicTacToe[2][1] == playerChar) &&
                    (arrTicTacToe[3][0] == 'T' ||
                     arrTicTacToe[3][0] == playerChar));
        } else {
            return false;
        }
    }
}
