import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

import java.util.Date;

public class FairAndSquare {
    public FairAndSquare() {
        super();
    }
    
    private static final String PARENT_DIR =
        "C:\\Users\\blackShadow\\Desktop\\Code Jam\\PreElims\\FairAndSquare\\";

    private static final String INPUT_FILE = "C-small-attempt0.in";
    private static final String OUTPUTPUT_FILE = "C-small-attempt0.out";
    
    public static void main(String[] args){
        readAndProcessInput(PARENT_DIR +INPUT_FILE, PARENT_DIR + OUTPUTPUT_FILE);
    }
    
    private static boolean isSquare(double number){
        double sqrt = Math.sqrt(number);
        boolean isPerfectSquare = (Math.ceil(sqrt) == Math.floor(sqrt));
        return isPerfectSquare;
    }
    
    private static void readAndProcessInput(String inFile, String outFile){
        try{
            File objFile = new File(inFile);
            FileReader objFileReader = new FileReader(objFile);
            
            BufferedReader objBufReader = new BufferedReader(objFileReader);
            FileWriter objFileWriter = new FileWriter(new File(outFile));
            int noOfTestCases = Integer.parseInt(objBufReader.readLine());
            for(int caseNo = 1 ; caseNo <= noOfTestCases; caseNo++){
                String caseData = objBufReader.readLine();
                String[] args = caseData.split(" ");
                double lowRange = Double.parseDouble(args[0]);
                double highRange = Double.parseDouble(args[1]);
                long fairSquare = countFairAndSquare(lowRange, highRange);
                String outString = "Case #" +caseNo +": " +fairSquare +"\n";
                System.out.print(outString);    
                objFileWriter.write(outString);
            }
            
            objBufReader.close();
            objFileWriter.close();
            
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    
    private static long countFairAndSquare(double a, double b){
        long count = 0L;
        
        for(double index = b; index >= a; index-- ){
            
            if( isSquare(index) && isPalindrome(index)  && isPalindrome(Math.sqrt(index))){
                count++;
            }else{
                //do nothing loop through.
            }
       }
        return count;
    }
    
    
    private static boolean isPalindrome(double num){
        
        char[] arrNum = new Integer(new Double(num).intValue()).toString().toCharArray();
        int len = arrNum.length;
        int startIndex = 0;
        int lastIndex = len - 1;
        
        
        for (; startIndex <= lastIndex ; startIndex++, lastIndex--){
            if(arrNum[startIndex] != arrNum[lastIndex]){
                return false;
            }
        }
        return true;
    }
}
