import java.io.*;
import java.util.*;
import java.lang.*;

public class War {
	public static void main(String[] args) throws IOException {
		Scanner input = new Scanner(new File("War.dat"));
		System.setOut(new PrintStream(new File("War.out")));

		int t = input.nextInt();
		for(int tr = 0; tr < t; tr++) {
			System.out.print("Case #" + (tr + 1) + ": ");
			
			int nums = input.nextInt();
			double[] naomi = new double[nums];
			double[] ken = new double[nums];
			for(int r = 0; r < nums; r++)
				naomi[r] = input.nextDouble();
			
			for(int r = 0; r < nums; r++)
				ken[r] = input.nextDouble();
			
			Queue<Double> naomiQueue = new LinkedList<Double>();
			Queue<Double> kenQueue = new LinkedList<Double>();
			
			Deque<Double> naomiCheat = new LinkedList<Double>();
			Deque<Double> kenCheat = new LinkedList<Double>();
			
			Arrays.sort(naomi);
			Arrays.sort(ken);
			
			for(double d : naomi) {
				naomiQueue.offer(d);
				naomiCheat.offerFirst(d);
			}
			for(double d : ken) { 
				kenQueue.offer(d);
				kenCheat.offerFirst(d);
			}
			
			
			int cheatingWins = 0;
			// Deceitful War
			while(!naomiCheat.isEmpty() && !kenCheat.isEmpty()) {
				if(naomiCheat.peek() < kenCheat.peek())
				{
					naomiCheat.pollLast();
					kenCheat.pollFirst();
				} else {
					naomiCheat.pollFirst();
					kenCheat.pollFirst();
					cheatingWins++;
				}
			}
			
			System.out.print(cheatingWins + " ");
			
			// Normal war
			while(!naomiQueue.isEmpty() && !kenQueue.isEmpty()) {
				if(naomiQueue.peek() > kenQueue.peek())
					kenQueue.poll();
				else {
					kenQueue.poll();
					naomiQueue.poll();
				}
			}
			
			
			System.out.println(naomiQueue.size());
			
			//System.out.println(Arrays.toString(naomi));
			//System.out.println(Arrays.toString(ken));
		}

		input.close();
		System.out.close();
	}
}