import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;


public class TicTacToeTomek {
	public static String score(int[][] board)
	{
		if(win(board, 1))
			return "X won";
		if(win(board, 2))
			return "O won";
		
		boolean filled = true;
		outer: for(int x = 0; x < 4; x++)
		{
			for(int y = 0; y < 4; y++)
				if(board[x][y] == 0) { filled = false; break outer; }
		}
		
		if(!filled)
			return "Game has not completed";
		
		return "Draw";
	}
	
	public static boolean win(int[][] board, int check)
	{
		boolean victory = false;
		boolean ld = true, rd = true;
		// row
		for(int x = 0; x < 4; x++)
		{
			victory = victory | r(board, check, x);
			victory = victory | c(board, check, x);
			
			ld &= (board[x][x] == check || board[x][x] == 3);
			rd &= (board[3-x][x] == check || board[3-x][x] == 3);
		}
		
		victory |= ld | rd;
		
		return victory;
	}
	
	public static boolean r(int[][] board, int check, int r)
	{
		boolean b = true;
		for(int x = 0; x < 4; x++)
			b = b & (board[r][x] == 3 || board[r][x] == check);
		return b;
	}
	
	public static boolean c(int[][] board, int check, int c)
	{
		boolean b = true;
		for(int x = 0; x < 4; x++)
			b = b & (board[x][c] == 3 || board[x][c] == check);
		return b;
	}
	
	public static void main(String[] args) throws IOException
	{
		Scanner input = new Scanner(new File("t4.in"));
		PrintWriter output = new PrintWriter(new File("t4.out"));
		int cases = input.nextInt(); input.nextLine();
		for(int l = 0; l < cases; l++)
		{
			int[][] mat = new int[4][4];
			for(int x = 0; x < 4; x++)
			{
				String line = input.nextLine();
				for(int y = 0; y < 4; y++)
					mat[x][y] = g(line.charAt(y));
			}
			
			output.printf("Case #%d: %s%n", l + 1, score(mat));
			if(input.hasNextLine())
				input.nextLine();
		}
		output.flush();
	}
	
	public static int g(char c)
	{
		switch(c)
		{
		case '.': return 0;
		case 'T': return 3;
		case 'X': return 1;
		case 'O': return 2;
		}
		return -1;
	}
}
