import java.util.*;
import java.io.*;
public class lawnmower {
	public static void main(String[] args) throws IOException{
		BufferedReader in = new BufferedReader (new FileReader ("B-small-attempt0.in"));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("lawnmower.out")));
		int n = Integer.parseInt(in.readLine());
		int[][][] lawns = new int[n][][];
		int[] min = new int[n]; //minimum value for each lawn
		Arrays.fill(min,9999);
		for(int i = 0; i<n;i++) {
			StringTokenizer s = new StringTokenizer(in.readLine());
			int N = Integer.parseInt(s.nextToken());
			int M = Integer.parseInt(s.nextToken());
			lawns[i] = new int[N][M];
			for(int j = 0; j<N;j++) {
				StringTokenizer s1 = new StringTokenizer(in.readLine());
				for(int k = 0;k<M;k++) {
					lawns[i][j][k] = Integer.parseInt(s1.nextToken());
					min[i] = Math.min(min[i], lawns[i][j][k]);
				}
			}
		}
		//to solve this, subtract all terms by the minimum value
		//then check all the 0s - if it's not in a path from side to side, return false
		//keep on subtracting by 1 until all spots are 0
		for(int i = 0;i<n;i++) {
			boolean done = false;
			int[][] lawn = (int[][])lawns[i].clone();
			int[][] zero = new int[lawn.length][lawn[0].length];
			for(int a = 0; a<zero.length;a++) {
				Arrays.fill(zero[a],0);
			}
			//subtract all by min
			for(int j = 0; j<lawn.length;j++) {
				for(int k = 0; k<lawn[j].length;k++) {
					lawn[j][k] -= min[i];
				}
			}
			//check
			for(int j = 0; j<lawn.length;j++) {
				for(int k = 0; k<lawn[j].length;k++) {
					if(lawn[j][k] == 0) {
						if(!check(lawn, new int[] {j,k})) {
							out.println("Case #" + (i+1) + ": NO");
							done = true;
							break;
						}
					}
				}
				if(done) break;
			}
			if(done) {continue;}
			//keep on subtracting 1
			decrement(lawn);
			while(!Arrays.deepEquals(lawn, zero)) {
				for(int j = 0; j<lawn.length;j++) {
					for(int k = 0; k<lawn[j].length;k++) {
						if(lawn[j][k] == 0) {
							if(!check(lawn, new int[] {j,k})) {
								out.println("Case #" + (i+1) + ": NO");
								done = true;
								
								break;
							}
						}
					}
					if(done) break;
				}
				if(done) break;
				decrement(lawn);
			}
			if(done) continue;
			out.println("Case #" + (i+1) + ": YES");
		}
		out.close();
		in.close();
	}
	public static boolean check(int[][] lawn, int[] coord) {
		boolean col = true;
		boolean row = true;
		//check column
		int x = coord[0];
		for(int i = 0; i < lawn[x].length; i++) {
			if(lawn[x][i] != 0) {col = false;}
		}
		if(col) return col;
		//check row
		int y = coord[1];
		for(int i = 0; i < lawn.length; i++) {
			if(lawn[i][y] != 0) {row = false;}
		}
		if(row) return row;
		return false;
	}
	public static void decrement(int[][] lawn) {
		for(int i = 0; i<lawn.length;i++) {
			for( int j = 0; j<lawn[i].length; j++) {
				if(lawn[i][j]==0) {continue;}
				lawn[i][j] -=1;
			}
		}
	}
}
