import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Scanner;


public class MinesweeperMaster {
	public static void main(String[] args) throws IOException {
		BufferedWriter bw;
		FileOutputStream fos = new FileOutputStream("C:\\Users\\Administrator\\Downloads\\codejam.out");
		bw = new BufferedWriter(new OutputStreamWriter(fos));
		Scanner reader = new Scanner (System.in);
		int nCases = reader.nextInt();

		for(int i=1; i<=nCases; i++) {
			reader.nextLine();
			int R = reader.nextInt();
			int C = reader.nextInt();
			int M = reader.nextInt();
			char result[][] = null;
			String line ="Case #" + i + ":";
			System.out.println(line);
			bw.write(line);
			bw.newLine();
			try {
				result = getMineDistribution(R, C, M);
				for(int j=0; j<result.length; j++) {
					line = "";
					for(int k=0; k<result[j].length; k++) {
						line += result[j][k];
					}
					bw.write(line);
					System.out.println(line);
					bw.newLine();
				}

			} catch(ImpossibleException e) {
				bw.write("Impossible");
				System.out.println("Impossible");
				bw.newLine();
			}
		}
		
		bw.close();
	}
	
	public static char[][] getMineDistribution(int R, int C, int M) throws ImpossibleException {
		char result[][] = new char[R][C];
		for(int i=0; i<R; i++) {
			for(int j=0; j<C; j++) {
				result[i][j] = '*';
			}
		}
		if(M >= C && R >= 3) {
			try {
				mergeResult(getMineDistribution(R-1, C, M-C), result);
			} catch(ImpossibleException e) {
				if(M >= R && C >= 3)
					mergeResult(getMineDistribution(R, C-1, M-R), result);
				else
					mergeResult(findOneSolution(R, C, M), result);
			}
		} else if(M >= R && C >= 3) {
			mergeResult(getMineDistribution(R, C-1, M-R), result);
		} else {
			mergeResult(findOneSolution(R, C, M), result);			
		}
		return result;
	}

	private static char[][] findOneSolution(int R, int C, int M) throws ImpossibleException {
		char result[][] = new char[R][C];
		for(int i=0; i<R; i++) {
			for(int j=0; j<C; j++) {
				result[i][j] = '.';
			}
		};
		if(M > 0) {
			if(M == R*C - 1) {
				for(int i=0; i<R; i++) {
					for(int j=0; j<C; j++) {
						result[i][j] = '*';
					}
				};				
			} else {
				if(R > C) {
					if(C == 2) {
						throw new ImpossibleException();
					}
					if(M <= R - 2) {
						for(int i=R-1; i > R-M-1; i--) {
							result[i][C-1] = '*';
						}
					} else {
						if(C <= 4) {
							throw new ImpossibleException();
						} else {
							for(int i=R-1; i > 1; i--) {
								result[i][C-1] = '*';
							}					
							result[R-1][0] = '*';
						}
					}
				} else {
					if(R == 2) {
						throw new ImpossibleException();
					}
					if(M <= C - 2) {
						for(int i= C-1; i > C-M-1; i--) {
							result[R-1][i] = '*';
						}
					} else {
						if(R <= 4) {
							throw new ImpossibleException();
						} else {
							for(int i= C-1; i > 1; i--) {
								result[R-1][i] = '*';
							}				
							result[0][C-1] = '*';
						}
					}			
				}
			}
		}
		result[0][0] = 'c';
		return result;
	}

	private static void mergeResult(char[][] mineDistribution, char[][] result) {
		for(int i=0; i<mineDistribution.length; i++) {
			for(int j=0; j<mineDistribution[i].length; j++) {
				result[i][j] = mineDistribution[i][j];
			}
		}
	}
	
}

class ImpossibleException extends Exception {
	
}
