import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;
import java.util.Stack;


public class Treasure {
	public static HashMap<Integer, ArrayList<Chest>> allDependents;
	public static HashMap<Key, Integer> availKeys; 
	public static ArrayList<Chest> chests;
	public static int chestNo;
	public static LinkedList<Integer> result;
	public static String strResult;
	public static int maxKeyType;
	public static boolean finished;
	public static int allDepentsNum;
	public static int availKeysNum;
	public static int NChests;
	public static int depLoopRootIndex;
	public static void main(String[] args) throws IOException {
		BufferedWriter bw;
		FileOutputStream fos = new FileOutputStream("C:\\Users\\Administrator\\Downloads\\codejam.out");
		bw = new BufferedWriter(new OutputStreamWriter(fos));
		Scanner reader = new Scanner (System.in);
		int nCases = reader.nextInt();
		reader.nextLine();
		for(int i=1; i<=nCases; i++) {
			int K = reader.nextInt();
			NChests = reader.nextInt();
			reader.nextLine();
			//init
			strResult = "";
			finished = false;
			chests = new ArrayList<Chest>(NChests);
			chestNo = 1;
			result = new LinkedList<Integer>();
			allDependents = new HashMap<Integer,  ArrayList<Chest>>();
			allDepentsNum = 0;
			availKeys = new HashMap<Key, Integer>();
			availKeysNum = 0;
			maxKeyType = 1;
			
			
			for(int j=0; j<K; j++) {
				Integer type = reader.nextInt();
				if (type > maxKeyType) {
					maxKeyType = type;
				}
				Key key = new Key(type);
				if(availKeys.containsKey(key)) {
					Integer res = availKeys.get(key) + 1;
					availKeys.put(key, res);
				} else {
					availKeys.put(key, 1);
				}
				availKeysNum++;
			}
			for(int j=0; j<NChests; j++) {
				chests.add(new Chest(reader));
			}
			//Collections.sort(chests);
			OpenChests();
			
			if(allDepentsNum > 0) {
				strResult = " IMPOSSIBLE";
			}
			String line ="Case #" + i + ":" + strResult;
			bw.write(line);
			bw.newLine();
			//System.out.println();
		}
		bw.close();
	}
	
	private static void OpenChests() {
		int chestIndex = 0;
		while(allDepentsNum > 0 && availKeysNum > 0 && chestIndex < NChests) {
			Chest chest = chests.get(chestIndex);
			if(chest.isOpen == true) {
				chestIndex++;
				continue;
			}
			ArrayList<Chest> depList = allDependents.get(chest.keyType);
			if(depList == null ||  depList.size() == 0 ) {
				chestIndex++;
				continue;
			}
			Key curKey = new Key(chest.keyType);
			Integer availKeyNum =  availKeys.get(curKey);
			if(availKeyNum != null && availKeyNum > 0){
				Stack<Chest> deploop = new Stack<Chest>();
				if(availKeyNum > 1 && depList.get(0).index-1 <= chestIndex) {
					deploop.push(depList.get(0));
					allDepentsNum--;
					depList.remove(0);
					updateChestStatus(deploop);
					deploop.clear();
					availKeyNum =  availKeys.get(curKey);
					chestIndex = 0;
					continue;
				}
				LinkedList<Integer> visitedKey = new LinkedList<Integer>();
				visitedKey.add(chest.keyType);
				boolean isDepLoop = findDepLoop(chest.keyType, visitedKey, depList);
				if (isDepLoop) {
					if(depList.get(depLoopRootIndex).index-1 <= chestIndex) {
						deploop.push(depList.get(depLoopRootIndex));
						depList.remove(depLoopRootIndex);
					} else if (findOneNotInDepLoop(chest.keyType) && depList.get(0).index-1 <= chestIndex){
						deploop.push(depList.get(0));
						depList.remove(0);
					} else {
						chestIndex++;
						continue;
					}
				} else if(depList.get(0).index-1 <= chestIndex){
					deploop.push(depList.get(0));
					depList.remove(0);
				}
				allDepentsNum--;
				updateChestStatus(deploop);
				deploop.clear();
				chestIndex = 0;
			} else {
				chestIndex++;
			}
		}
		if(chestIndex >= NChests) {
			System.out.println();
		}
	}

	private static void updateChestStatus(Stack<Chest> deploop) {
		if (!deploop.isEmpty()) {
			Chest chest = deploop.pop();
			Key key = new Key(chest.keyType);
			if(availKeys.containsKey(key)) {
				Integer res = availKeys.get(key) - 1;
				availKeys.put(key, res);
			} else {
				System.out.println("error");
			}
			chest.isOpen = true;
			strResult += " " + chest.index;
			availKeysNum--;
			
			for(Key dep : chest.keyList) {
				if (dep.keyType > maxKeyType) {
					maxKeyType = dep.keyType;
				}
				if(availKeys.containsKey(dep)) {
					Integer res = availKeys.get(dep) + 1;
					availKeys.put(dep, res);
				} else {
					availKeys.put(dep, 1);
				}
				availKeysNum++;
			}
		}
	}

	private static boolean findDepLoop(int initKey, LinkedList<Integer> visitedKey, ArrayList<Chest> depList ) {
		boolean deploop = false;
		if(depList != null) {
			for(int i=0; i<depList.size(); i++) {
				Chest chest = depList.get(i);
				ArrayList<Key> depKeys = chest.keyList;
				for(Key depKey : depKeys) {
					if(depKey.keyType == initKey) {
						if(visitedKey.size() == 1) {
							depLoopRootIndex = i;	
						}
						deploop = true;
						return deploop;
					} else if(hasDuplicate(visitedKey, depKey.keyType)) {
						continue;
					} else {
						visitedKey.add(depKey.keyType);
						deploop = findDepLoop(initKey, visitedKey, allDependents.get(depKey.keyType));
						visitedKey.removeLast();
						if(deploop == true) {
							if(visitedKey.size() == 1) {
								depLoopRootIndex = i;	
							}
							return deploop;
						}
					}
				}
			}
		}
		return deploop;
	}

	private static boolean findOneNotInDepLoop(int initKey) {
		boolean isFound = false;
		for(Key key : availKeys.keySet()) {
			if(key.keyType != initKey) {
				Integer num = availKeys.get(key);
				if(num > 0) {
					LinkedList<Integer> visitedKey = new LinkedList<Integer>();
					visitedKey.add(key.keyType);
					isFound = findDepLoop(initKey, visitedKey, allDependents.get(key.keyType));
					if(isFound) {
						return isFound;
					}
				}
			}
		}
		return isFound;
	}
	private static boolean hasDuplicate(LinkedList<Integer> visitedKey,
			int keyType) {
		for(Integer key : visitedKey) {
			if (keyType == key) {
				return true;
			}
		}
		return false;
	}

	static class Chest implements Comparable<Chest> {
		int keyType;
		int keyNum;
		int index;
		ArrayList<Key> keyList;
		boolean isOpen = false;
		Chest(Scanner reader) {
			keyType = reader.nextInt();
			keyNum = reader.nextInt();
			index = chestNo++;
			keyList = new ArrayList<Key>(keyNum);
			for(int i=0; i<keyNum; i++) {
				Integer type = reader.nextInt();
				Key key = new Key(type);
				keyList.add(key);
			}
			Collections.sort(keyList);
			if(allDependents.containsKey(keyType)) {
				allDependents.get(keyType).add(this);
			} else {
				ArrayList<Chest> list = new ArrayList<Chest>();
				list.add(this);
				allDependents.put(keyType, list);
			}
			allDepentsNum++;
			reader.nextLine();
		}
		@Override
		public int compareTo(Chest o) {
			// TODO Auto-generated method stub
			if(o.keyType > keyType) {
				return -1;
			} else if(o.keyType < keyType) {
				return 1;
			}
			return 0;
		}

	}
}

class Key implements Comparable<Key> {
	int keyType;
	
	Key(int keyType) {
		this.keyType = keyType;
	}
	
	@Override
	public int compareTo(Key o) {
		if(o.keyType > keyType) {
			return -1;
		} else if (o.keyType < keyType) {
			return 1;
		}
		return 0;
	}
	
	public int hashCode() {
		return keyType; 
	}
	public boolean equals(Object o) {
		return ((Key)o).keyType == keyType;
	}
}
