import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.PriorityQueue;
import java.util.Scanner;

/**
 * 
 * @author "Blake Arnold"
 * 
 */
public class PickingUpChicks {

	private final static String filename = "B-small-attempt1.in";
	private final static String outFilename = "file-small-out1.out";

	public static void main(String[] args) throws IOException,
			InterruptedException {
		
		Scanner sc = new Scanner(new File(filename));
		BufferedWriter out = new BufferedWriter(new FileWriter(outFilename));
		long time = System.currentTimeMillis();
		
		/* read in test size */
		int totalTests = sc.nextInt();
		String results[] = new String[totalTests + 1];
		
		/*create threads */
		Thread last[] = new Thread[totalTests + 1];
		
		
		for (int i = 1; i < totalTests + 1; i++) {
			int n = sc.nextInt();
			int k = sc.nextInt();
			int b = sc.nextInt();
			int t = sc.nextInt();
			int[] x = new int[n];
			
			for(int j = 0; j<n; j++)
				x[j] = sc.nextInt();
			
			int[] v = new int[n];
			for(int j = 0; j<n; j++)
				v[j] = sc.nextInt();
			
			last[i] = new Thread(new findIt(results, i, n, k, b, t, x, v));
			last[i].start();

		}
		/*reap threads */
		for (int i = 1; i < totalTests + 1; i++) {

			last[i].join();
			System.out.println("reaped " + i);
			System.out.println(results[i]);

		}
		/*write results */
		for (int i = 1; i < totalTests + 1; i++) {

			out.write("Case #" + i + ": ");
			out.write(results[i]);
			out.write("\n");
		}
		System.out.println("Done. " + (System.currentTimeMillis() - time));
		out.close();

	}

}

class findIt implements Runnable {

	String[] results;
	int i,n, k, b, t; 
	int[] x,  v;
	int[][] inTheWay;
	int[] totalTime;

	public findIt(String[] results, int i, int n, int k, int b, int t, int[] x, int[] v) {
		
		this.results = results;
		this.i = i;
		this.n = n;
		this.k = k;
		this.b = b;
		this.t = t;
		this.x = x;
		this.v = v;	
		inTheWay = new int[n][n];
		totalTime = new int[n];
	}

	@Override
	public void run() {
		PriorityQueue<Hen> canMakeIt = new PriorityQueue<Hen>();
		PriorityQueue<Hen> all = new PriorityQueue<Hen>();
		Hen cur;
		for(int j = 0; j<n; j++) {
			cur = new Hen(x[j], v[j], b-x[j]);
			all.add(cur);
			totalTime[j] = (int) (Math.ceil((double)b-x[j])/v[j]);
			if(totalTime[j] <= t){
				cur.setMake(true);
				canMakeIt.add(cur);
			}
		}

		String result = "IMPOSSIBLE";
		if(canMakeIt.size() >= k){
			int inFront = 0;
			int totalJumps = 0;
			int madeIt = 0;
			for(int j = 0; j<n && madeIt < k; j++) {
				
				cur = all.remove();
				System.out.println(i+" order " + cur.x);
				while(!cur.isMake()){
					inFront++;
					cur = all.remove();
					System.out.println(i+" order " + cur.x);
				}

				totalJumps +=inFront;
				madeIt++;
				System.out.println(i+" made it " + cur.x);
			}
			result = totalJumps+"";
			
			
			
		}
		synchronized (results) {

			results[i] = result;

		}

	}
	class Hen implements Comparable<Hen>{
		int x;
		int v;
		Integer d;
		boolean make;
		public boolean isMake() {
			return make;
		}

		public void setMake(boolean make) {
			this.make = make;
		}

		ArrayList<Hen> inBetween;
		public Hen(int x,int v,int d){
			this.x = x;
			this.v = v;
			this.d = d;
			make = false;
		}
		
		@Override
		public int compareTo(Hen o) {
			
			return d.compareTo(o.getD());
		}

		public int getX() {
			return x;
		}

		public void setX(int x) {
			this.x = x;
		}

		public int getV() {
			return v;
		}

		public void setV(int v) {
			this.v = v;
		}

		public Integer getD() {
			return d;
		}

		public void setD(Integer d) {
			this.d = d;
		}

		public ArrayList<Hen> getInBetween() {
			return inBetween;
		}

		public void setInBetween(ArrayList<Hen> inBetween) {
			this.inBetween = inBetween;
		}
	}

}
