import java.util.Scanner;
import java.io.OutputStream;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.FileInputStream;
import java.io.File;
import java.util.Locale;
import java.io.FilenameFilter;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author pankajmore
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "B-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("b.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Scanner in = new Scanner(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskB solver = new TaskB();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskB {
    public void solve(int testNumber, Scanner in, PrintWriter out) {
        int D = in.nextInt();
        int [] A = new int [D];
        int m = 0;
        for(int i=0;i<D;i++) {
            A[i] = in.nextInt();
            if(m<A[i]) m = A[i];
        }
//        int l = search(A,1,m);
        int l = moona(A,m);
        out.println(String.format("Case #%d: %d",testNumber, l));

    }

    private int moona(int[] A, int m) {
        int ans = m;
        for(int x=1;x<=m;x++){
            int c = 0;
            for(int i=0;i<A.length;i++){
                if(A[i] > x){
                    c += (A[i]-x)/x;
                    if(A[i]%x != 0) c += 1;
                }
            }
            c += x;
            if(ans > c) ans= c;
        }
        return ans;
    }

}

