package codejam;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.Scanner;

import org.junit.Assert;
import org.junit.Test;

public class BTidyNumbers {

	private long solveBrutforce(long n) {
		for (long i = n; i > 0; i--) {
			String s = String.valueOf(i);
			if (s.length() == 1) {
				return i;
			}

			boolean sorted = true;
			for (int j = 0; j < s.length() - 1; j++) {
				if (s.charAt(j) > s.charAt(j + 1)) {
					sorted = false;
					break;
				}
			}
			if (sorted) {
				return i;
			}
		}

		return 0;
	}

	@Test
	public void testBrutforce() {
		long result = solveBrutforce(132);
		Assert.assertEquals(129, result);

		result = solveBrutforce(1000);
		Assert.assertEquals(999, result);

		result = solveBrutforce(7);
		Assert.assertEquals(7, result);
	}

	private String solve(String s) {
		if (s.length() == 1) {
			return s;
		}

		boolean sorted = false;
		while (!sorted) {
			int inorderIndex = -1;
			sorted = true;
			for (int j = 0; j < s.length() - 1; j++) {
				if (s.charAt(j) > s.charAt(j + 1)) {
					sorted = false;
					inorderIndex = j;
					break;
				}
			}
			if (sorted) {
				return s;
			}

			char[] arr = s.toCharArray();
			arr[inorderIndex]--;
			for (int i = inorderIndex + 1; i < arr.length; i++) {
				arr[i] = '9';
			}
			s = new String(arr);
			if (s.charAt(0) == '0') {
				s = s.substring(1);
			}
		}

		return s;
	}

	@Test
	public void testSolution() {
		String result = solve("132");
		Assert.assertEquals("129", result);

		result = solve("1000");
		Assert.assertEquals("999", result);

		result = solve("7");
		Assert.assertEquals("7", result);
	}

	@Test
	public void testLong() {
		String result = solve("111111111111111110");
		Assert.assertEquals("99999999999999999", result);
	}
	
	@Test
	public void testCompare() {
		int max = 10000;
		for (int i = 0; i < max; i++) {
			String resultBrutforce = String.valueOf(solveBrutforce(i));
			String result = solve(String.valueOf(i));
			Assert.assertEquals(resultBrutforce, result);
		}			
	}

	public static void main(String[] args) throws Exception {
		FileInputStream fis = new FileInputStream("d:\\1\\b.in");
		BufferedReader br = new BufferedReader(new InputStreamReader(fis));
		Scanner scan = new Scanner(br);
		int numberOfCases = scan.nextInt();

		for (int i = 0; i < numberOfCases; i++) {
			String n = scan.next();

			String result = new BTidyNumbers().solve(n);
			System.out.println("Case #" + (i + 1) + ": " + result);
		}

		scan.close();
	}

}
