package de.measite.gcj1b;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.WeakHashMap;

public class A {

	private static LineNumberReader in;

	static {
		LineNumberReader lnr = null;
		try {
			lnr = new LineNumberReader(new InputStreamReader(new FileInputStream("A.in")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		in = lnr;
		try {
			System.setOut(new PrintStream(new FileOutputStream("A.out")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private final static class DTree {
		String feature;
		double score;
		DTree left;
		DTree right;
		public double accept(TreeSet<String> features) {
			if (feature == null) {
				return score;
			}
			if (features.contains(feature)) {
				return left.accept(features);
			} else {
				return right.accept(features);
			}
		}
	}

	private static class Dint {
		public int pos;
	}
	private static DTree parse(String tokens[], Dint p, double d) {
		double score = Double.parseDouble(tokens[p.pos + 1]);
		if (tokens[p.pos + 2].equals("|")) {
			DTree term = new DTree();
			term.score = score * d;
			p.pos += 3;
			return term;
		}
		DTree root = new DTree();
		p.pos += 2;
		root.feature = tokens[p.pos];
		p.pos++;
		root.left  = parse(tokens, p, d*score);
		root.right = parse(tokens, p, d*score);
		p.pos++;
		return root;
	}

	public static void main(String[] args) {
		try {
			String line = in.readLine();
			int cases = Integer.parseInt(line.trim());
			for(int i = 1; i <= cases; i++) {
				System.out.println("Case #" + i + ":");
				int lines = Integer.parseInt(in.readLine().trim());
				StringBuilder sb = new StringBuilder();
				for(; lines > 0; lines--) {
					sb.append(" ");
					sb.append(in.readLine().trim());
				}
				line = sb.toString().trim();
				line = line.replaceAll("[()]", " | ").replaceAll("  *", " ").trim();
				System.err.println(line);
				DTree root = parse(line.split(" "), new Dint(), 1d);
				int animals = Integer.parseInt(in.readLine().trim());
				for (int j = 0; j < animals; j++) {
					TreeSet<String> af = new TreeSet<String>();
					line = in.readLine().trim();
					line = line.substring(line.indexOf(' ')).trim();
					String afs[] = line.split(" ");
					for (String f: afs) {
						af.add(f);
					}
					double d = root.accept(af);
					System.out.printf("%1.7f", d);
					System.out.println();
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
