package de.measite.gcj2010.q;

import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.ArrayList;

public class C {

    private final static LineNumberReader LNR;
    private static String line;

    static {
        LNR = new LineNumberReader(new InputStreamReader(System.in));
    }

    public static boolean readLine() {
        try {
            line = LNR.readLine();
            return true;
        } catch (IOException e) {
            e.printStackTrace(System.err);
        }
        return false;
    }

    public static ArrayList<Integer> getIntegerArray() {
        ArrayList<Integer> nums = new ArrayList<Integer>();
        StringBuilder buf = new StringBuilder();
        for (int i = 0; i < line.length(); i++) {
            char c = line.charAt(i);
            if (Character.isDigit(c)) {
                buf.append(c);
            } else {
                if (buf.length() > 0) {
                    nums.add(Integer.parseInt(buf.toString()));
                    buf.setLength(0);
                }
            }
        }
        if (buf.length() > 0) {
            nums.add(Integer.parseInt(buf.toString()));
            buf.setLength(0);
        }
        return nums;
    }

    public static int[] getIntArray() {
        ArrayList<Integer> integerArray = getIntegerArray();
        int intArray[] = new int[integerArray.size()];
        for (int i = 0; i < intArray.length; i++) {
            intArray[i] = integerArray.get(i);
        }
        return intArray;
    }

    public static int getInt() {
        return Integer.parseInt(line.trim());
    }

    public static void main(String[] args) {
        readLine();
        int tests = getInt();
        for (int i = 0; i < tests; i++) {
            test(i + 1);
        }
    }

    private static void test(int testcase) {
        System.out.print("Case #" + testcase + ": ");
        readLine();
        ArrayList<Integer> setup = getIntegerArray();
        final int R = setup.get(0);
        final int k = setup.get(1);
        readLine();
        int groups[] = getIntArray();
        int money = 0;
        int grouppointer = 0;
        int filled = 0;
        for (int i = 0; i < R; i++) {
            if (i > 0 && grouppointer == 0) {
                int cycles = R / i;
                if (cycles > 1) {
                    money *= cycles;
                    i *= cycles;
                    i--;
                    continue;
                }
            }
            int count = 0;
            while (filled < k && count < groups.length) {
                filled += groups[grouppointer++];
                grouppointer %= groups.length;
                count++;
            }
            if (filled > k) {
                if (--grouppointer == -1) {
                    grouppointer = groups.length - 1;
                }
                filled -= groups[grouppointer];
            }
            money += filled;
            filled = 0;
        }
        System.out.println(money);
    }

}
