package de.measite.gcj1c;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.BitSet;
import java.util.TreeSet;

public class C {
	private static LineNumberReader in;

	static {
		LineNumberReader lnr = null;
		try {
			lnr = new LineNumberReader(new InputStreamReader(new FileInputStream("C.in")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		in = lnr;
		try {
			System.setOut(new PrintStream(new FileOutputStream("C.out")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	private static class State implements Comparable<State> {
		BitSet prisoners = new BitSet(10002);
		int free = 0;
		int score = 0;
		int[] release = new int[100];
		public State(int cells) {
			prisoners.set(0, 10002, false);
			prisoners.set(1, cells + 1, true);
		}
		public State(State parent, int pos) {
			score = parent.score;
			free = parent.free + 1;
			System.arraycopy(parent.release, 0, release, 0, 100);
			int p = release[pos];
			release[pos] = 0;
			prisoners.or(parent.prisoners);
			prisoners.set(p, false);
			int k = p + 1;
			while (prisoners.get(k)) {
				score++;
				k++;
			}
			k = p - 1;
			while (prisoners.get(k)) {
				score++;
				k--;
			}
		}
		public ArrayList<State> childs() {
			ArrayList<State> result = new ArrayList<State>();
			for (int i = 0; i < release.length; i++) {
				if (release[i] != 0) {
					result.add(new State(this, i));
				}
			}
			return result;
		}
		@Override
		public int compareTo(State o) {
			if (score < o.score) { return -1; }
			if (score > o.score) { return  1; }
			if (free  > o.free)  { return -1; }
			if (free  < o.free)  { return  1; }
			int l = 0;
			int r = 0;
			BitSet b = new BitSet(10002);
			b.or(prisoners);
			b.xor(o.prisoners);
			b.and(o.prisoners);
			l = b.length();
			b = new BitSet(10002);
			b.or(prisoners);
			b.xor(o.prisoners);
			b.and(prisoners);
			r = b.length();
			if (l  > r)  { return -1; }
			if (l  < r)  { return  1; }
			for (int i = 0; i < 100; i++) {
				if (release[i] != o.release[i]) {
					if (release[i]  > o.release[i])  { return -1; }
					if (release[i]  < o.release[i])  { return  1; }
				}
			}
			return 0;
		}
	}

	public static void main(String[] args) {
		try {
			int cases = Integer.parseInt(in.readLine().trim());
			for (int i = 1; i <= cases; i++) {
				System.out.print("Case #" + i + ": ");
				TreeSet<State> states = new TreeSet<State>();
				String v[] = in.readLine().trim().split(" ");
				State root = new State(Integer.parseInt(v[0]));
				states.add(root);
				v = in.readLine().trim().split(" ");
				for (int p = 0; p < v.length; p++) {
					root.release[p] = Integer.parseInt(v[p]);
				}
				State f = states.pollFirst();
				while (f.free < v.length) {
					states.addAll(f.childs());
					f = states.pollFirst();
				}
				System.out.println(f.score);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
