package de.measite.gcj2010.q;

import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.util.ArrayList;

public class A {

    private final static LineNumberReader LNR;
    private static String line;

    static {
        LNR = new LineNumberReader(new InputStreamReader(System.in));
    }

    public static boolean readLine() {
        try {
            line = LNR.readLine();
            System.err.println("Line " + LNR.getLineNumber());
            return true;
        } catch (IOException e) {
            e.printStackTrace(System.err);
        }
        return false;
    }

    public static ArrayList<Integer> getIntegerArray() {
        ArrayList<Integer> nums = new ArrayList<Integer>();
        StringBuilder buf = new StringBuilder();
        for (int i = 0; i < line.length(); i++) {
            char c = line.charAt(i);
            if (Character.isDigit(c)) {
                buf.append(c);
            } else {
                if (buf.length() > 0) {
                    nums.add(Integer.parseInt(buf.toString()));
                    buf.setLength(0);
                }
            }
        }
        if (buf.length() > 0) {
            nums.add(Integer.parseInt(buf.toString()));
            buf.setLength(0);
        }
        return nums;
    }

    public static int[] getIntArray() {
        ArrayList<Integer> integerArray = getIntegerArray();
        int intArray[] = new int[integerArray.size()];
        for (int i = 0; i < intArray.length; i++) {
            intArray[i] = integerArray.get(i);
        }
        return intArray;
    }

    public static int getInt() {
        return Integer.parseInt(line.trim());
    }

    public static void main(String[] args) {
        readLine();
        int tests = getInt();
        for (int i = 0; i < tests; i++) {
            test(i + 1);
        }
    }

    private static void test(int testcase) {
        System.out.print("Case #" + testcase + ": ");
        readLine();
        ArrayList<Integer> setup = getIntegerArray();
        final int N = setup.get(0);
        final int K = setup.get(1);
        if ((K % (1<<N)) + 1 == (1<<N)) {
            System.out.println("ON");
        } else {
            System.out.println("OFF");
        }
    }

}
