package dmg;

import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.TreeSet;

public class A {
    public static class In {
        private final InputStreamReader in;
        private final StringBuilder stringBuilder = new StringBuilder();
        public In(final InputStream in) {
            this.in = new InputStreamReader(in);
        }
        public char readChar() throws IOException {
            return (char) in.read();
        }
        public char readNonWS() throws IOException {
            int c;
            while (Character.isWhitespace(c = in.read())) {}
            return (char) c;
        }
        public short readShort() throws NumberFormatException, IOException {
            return Short.parseShort(readString());
        }
        public int readInt() throws NumberFormatException, IOException {
            return Integer.parseInt(readString());
        }
        public long readLong() throws NumberFormatException, IOException {
            return Long.parseLong(readString());
        }
        public BigInteger readBigInt() throws IOException {
            return new BigInteger(readString());
        }
        public BigInteger readBigInt(int radix) throws IOException {
            return new BigInteger(readString(), radix);
        }
        public float readFloat() throws NumberFormatException, IOException {
            return Float.parseFloat(readString());
        }
        public double readDouble() throws NumberFormatException, IOException {
            return Double.parseDouble(readString());
        }
        public String readString() throws IOException {
            int c;
            stringBuilder.setLength(0);
            while ((c = in.read()) != -1) {
                if (Character.isWhitespace(c)) {
                    if (stringBuilder.length() > 0) {
                        return stringBuilder.toString();
                    }
                } else {
                    stringBuilder.append((char)c);
                }
            }
            return stringBuilder.toString();
        }
    }

    private final static In I = new In(System.in);
    private final static PrintStream O = System.out;
    private final static PrintStream D = System.err;

    public static void main(String[] args) {
        try {
            for (int cs = 1, limit = I.readInt(); cs <= limit; cs++) {
                O.print("Case #");
                O.print(cs);
                O.print(": ");
                int nums = I.readInt();
                int cords[][] = new int[nums][];
                for (int n = 0; n < nums; n++) {
                    cords[n] = new int[]{I.readInt(), I.readInt()};
                }
                int cross = 0;
                for (int c[]: cords) {
                    for (int d[]: cords) {
                        if (c[0] < d[0] && c[1] > d[1]) {
                            cross++;
                        }
                        if (c[0] > d[0] && c[1] < d[1]) {
                            cross++;
                        }
                    }
                }
                O.println(cross / 2);
            }
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
