import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Queue;
import java.util.Map.Entry;

class Solver {

	int result = 0;
	InputData data;
		
	public Solver (InputData data) {
		this.data = data;
	}
	
	public void solve () {
		
		for (Entry<Integer, String> dir: data.createDirs.entrySet()) {
			if (data.existDirs.containsKey(dir.getKey())) {				
			} else {
				addDir(dir.getValue());
			}			
		}
	}
	
	public void addDir(String path) {
		if (data.existDirs.containsKey(path.hashCode())) {
			return;
		} else {
			
			Integer index = path.lastIndexOf('/');
			
			if (index == 0) {
				data.existDirs.put(path.hashCode(), path);
				result++;
			} else {
				String rootPath = path.substring(0, index);

				if (data.existDirs.containsKey(rootPath.hashCode())) {
					data.existDirs.put(path.hashCode(), path);
					result++;
				} else {
					addDir(rootPath);
					data.existDirs.put(path.hashCode(), path);
					result++;
				}
				

			}			
		}
	}

	public int getResult () {
		return result;
	}
}

class InputData {
	//Repeat count
	Map<Integer, String> existDirs = new HashMap<Integer, String>();
	Map<Integer, String> createDirs = new HashMap<Integer, String>();
	
	public InputData (Map<Integer, String> dirs, Map<Integer, String> dirs2create) {
		existDirs = dirs;
		createDirs = dirs2create;
	}
}


public class ProblemA {
	//Test-case count
	//1 ≤ testCaseCount ≤ 50.
	int testCaseCount = 0;
	
	int N = 0;
	int M = 0;
	
	//
	Queue<InputData> inputData = new LinkedList<InputData>();
	//Solve result
	List<Integer> results = new ArrayList<Integer>();
	
	public void read (InputStream input) {

		try {
			InputStreamReader inputStreamReader = new InputStreamReader(input);
			BufferedReader bufferedReader = new BufferedReader (inputStreamReader);
			
			testCaseCount = Integer.valueOf(bufferedReader.readLine()); 
			
			for (int i = 1; i <= testCaseCount; i++) {
				Map<Integer, String> exist = new HashMap<Integer, String>();
				Map<Integer, String> create = new HashMap<Integer, String>();
				exist.put("/".hashCode(), "/");
				
				String paramsLine =  bufferedReader.readLine();
				String[] params = paramsLine.split(" ");
				N = Integer.valueOf(params[0]);
				M = Integer.valueOf(params[1]);
				
				while (N > 0) {
					String dir = bufferedReader.readLine();
					exist.put(dir.hashCode(), dir);
					N--;
				}
				
				while (M > 0) {
					String dir = bufferedReader.readLine();
					create.put(dir.hashCode(), dir);
					M--;
				}
				
				inputData.add(new InputData(exist, create));
			}		
		} catch (FileNotFoundException e) {
			System.err.println (e.getMessage());
		} catch (IOException e) {
			System.err.println (e.getMessage());
		}
	}

	public void solve () {
		int i = 1;
		for (InputData testCase: inputData) {
			Long start = new Date().getTime();
			
			int result = 0;
			Solver solver = new Solver(testCase);
			solver.solve();
			result = solver.getResult();
			results.add(result);
			
			System.out.println("Case #" + i + ": " + result + " in " + (new Date().getTime() - start) / 1000);
			i++;
		}
	}
		
	public void write(PrintStream out) {
		int i = 1;
		for (int result: results) { 
			out.println("Case #" + i + ": " + result);
			i++;
		}
	}
	
	public static void main(String[] args) {
		ProblemA solver = new ProblemA();
		
		Long start = new Date().getTime();
		
		try {
			solver.read(new FileInputStream(new File("input.data")));
			solver.solve();
			solver.write(new PrintStream(new PrintStream(new File("output.data"))));
			//solver.write(System.out);
			
		} catch (FileNotFoundException e) {
			System.err.println (e.getMessage());
		}
		
		System.out.println("Total time is " + (new Date().getTime() - start) / 1000 / 60);
	}
}