import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.LinkedList;

public class B {
	static BufferedReader in;
	static PrintWriter out;
	static boolean DEBUG = false;

	public static void main(String[] args) throws Exception {

		// DEBUG = !DEBUG;

		if (DEBUG) {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(new OutputStreamWriter(System.out));
		} else {
			in = new BufferedReader(new FileReader("B-small-attempt2.in"));
			out = new PrintWriter("B-small.out");
		}

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++) {
			LinkedList<String> D = new LinkedList<String>();
			String[] ints = in.readLine().split(" ");
			int N = Integer.parseInt(ints[0]);
			int M = Integer.parseInt(ints[1]);

			for (int i = 0; i < N; i++) {
				D.add(in.readLine());
			}

			out.printf("Case #%d:", t);

			for (int m = 0; m < M; m++) {
				char[] seq = in.readLine().toCharArray();

				int maxScore = -1;
				String maxWord = "";

				for (String ans : D) {
					char[] guessed = new char[ans.length()];
					int score = 0;
					HashSet<Character> wChars = new HashSet<Character>();

					for (char c : seq) {
						outer: for (String w : D) {
							for (char wc : wChars) {
								if (w.indexOf(wc) > -1) {
									continue outer;
								}
							}
							if (match(w, guessed) && w.indexOf(c) > -1) {
								// Can be this word
								// so he guesses c
								if (!guess(c, ans, guessed)) {
									score += 1;
									wChars.add(c);
								}
							}
						}
					}

					if (score > maxScore) {
						maxScore = score;
						maxWord = ans;
					}
				}
				out.print(" " + maxWord);
			}
			out.println();
		}

		in.close();
		out.flush();
		out.close();
	}

	public static boolean match(String word, char[] guessed) {
		if (word.length() != guessed.length)
			return false;

		for (int i = 0; i < guessed.length; i++) {
			if (guessed[i] == 0)
				continue;

			if (word.charAt(i) != guessed[i])
				return false;
		}

		return true;
	}

	public static boolean guess(char c, String answer, char[] guessed) {
		int placed = 0;
		for (int i = 0; i < guessed.length; i++) {
			if (answer.charAt(i) == c) {
				guessed[i] = c;
				placed++;
			}
		}
		return placed > 0;
	}
}
