import java.io.BufferedReader;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class A {
	static BufferedReader in;
	static PrintWriter out;
	static boolean DEBUG = false;

	public static void main(String[] args) throws Exception {

		// DEBUG = !DEBUG;

		if (DEBUG) {
			in = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(new OutputStreamWriter(System.out));
		} else {
			in = new BufferedReader(new FileReader("A-large.in"));
			out = new PrintWriter("A-large.out");
		}

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++) {
			StringTokenizer st = new StringTokenizer(in.readLine());
			long N = Long.parseLong(st.nextToken());
			int Pd = Integer.parseInt(st.nextToken());
			int Pg = Integer.parseInt(st.nextToken());

			boolean possible = false;

			if (Pg == 100) {
				if (Pd == 100) {
					possible = true;
				}
			} else if (Pg == 0) {
				if (Pd == 0) {
					possible = true;
				}
			} else {
				// out.println("GCD: " + GCD(Pd, 100));
				if (N >= 100 / GCD(Pd, 100)) {
					possible = true;
				}
			}

			out.printf("Case #%d: %s\n", t, possible ? "Possible" : "Broken");

		}

		in.close();
		out.flush();
		out.close();
	}

	public static int GCD(int a, int b) {
		if (a < b) {
			return GCD(b, a);
		}

		while (b != 0) {
			int t = a % b;
			a = b;
			b = t;
		}
		return a;
	}
}
