import java.io.*;
import java.util.*;

public class A {

	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

		int T = Integer.parseInt(in.readLine());
		for (int c = 1; c <= T; c++) {
			StringTokenizer st = new StringTokenizer(in.readLine());

			int X = Integer.parseInt(st.nextToken());
			int S = Integer.parseInt(st.nextToken());
			int R = Integer.parseInt(st.nextToken());
			double t = Integer.parseInt(st.nextToken());
			int N = Integer.parseInt(st.nextToken());

			PriorityQueue<Walkway> pq = new PriorityQueue<A.Walkway>();
			int totWWDist = 0;

			for (int i = 0; i < N; i++) {
				st = new StringTokenizer(in.readLine());
				int B = Integer.parseInt(st.nextToken());
				int E = Integer.parseInt(st.nextToken());
				double w = Integer.parseInt(st.nextToken());
				totWWDist += E - B;

				pq.add(new Walkway(B, E, w));
			}

			pq.add(new Walkway(0, X - totWWDist, 0));

			double time = 0;

			while (pq.size() > 0) {
				Walkway ww = pq.poll();

				// System.out.println("WW speed: " + ww.w);

				double timeToRunComplete = (ww.E - ww.B) / (ww.w + R);
				// System.out.println("Time to run whole: " +
				// timeToRunComplete);
				if (timeToRunComplete < t) {
					t -= timeToRunComplete;
					time += timeToRunComplete;
				} else {
					// Run for remaining of time
					double dCoveredRunning = t * (ww.w + R);
					double timeToWalk = (ww.E - ww.B - dCoveredRunning) / (ww.w + S);

					time += timeToWalk + t;
					t = 0;
				}
			}

			System.out.printf("Case #%d: %.9f\n", c, time);
		}
	}

	static class Walkway implements Comparable<Walkway> {
		int B;
		int E;
		double w;

		public Walkway(int B, int E, double w) {
			this.B = B;
			this.E = E;
			this.w = w;
		}

		@Override
		public int compareTo(Walkway ww) {
			return Double.compare(w, ww.w);
		}
	}
}
