import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class A {
	static BufferedReader in;
	static PrintWriter out;

	public static void main(String[] args) throws Exception {
		in = new BufferedReader(new InputStreamReader(System.in));
		out = new PrintWriter(new OutputStreamWriter(System.out));

		int T = new Integer(in.readLine());

		for (int t = 1; t <= T; t++) {
			StringTokenizer st = new StringTokenizer(in.readLine());

			// Kill leading
			st.nextToken();

			Queue<Character> robots = new LinkedList<Character>();
			Queue<Integer> oran = new LinkedList<Integer>();
			Queue<Integer> blue = new LinkedList<Integer>();

			while (st.hasMoreTokens()) {
				char bot = st.nextToken().charAt(0);
				robots.add(bot);
				if (bot == 'B') {
					blue.add(new Integer(st.nextToken()));
				} else {
					oran.add(new Integer(st.nextToken()));
				}
			}

			int time = 0;

			int bPos = 1;
			int oPos = 1;

			int bTarget = blue.size() > 0 ? blue.poll() : -1;
			int oTarget = oran.size() > 0 ? oran.poll() : -1;

			while (robots.size() > 0) {
				// out.println("B: " + bPos);
				// out.println("O: " + oPos);
				char botToPress = robots.poll();
				if (botToPress == 'B') {
					time += Math.abs(bTarget - bPos) + 1;

					int oDir = (oTarget - oPos == 0) ? 0 : (oTarget - oPos) / Math.abs(oTarget - oPos);
					oPos += Math.min(Math.abs(oTarget - oPos), Math.abs(bTarget - bPos) + 1) * oDir;

					bPos = bTarget;
					bTarget = blue.size() > 0 ? blue.poll() : -1;
				} else {
					time += Math.abs(oTarget - oPos) + 1;

					int bDir = (bTarget - bPos == 0) ? 0 : (bTarget - bPos) / Math.abs(bTarget - bPos);
					bPos += Math.min(Math.abs(bTarget - bPos), Math.abs(oTarget - oPos) + 1) * bDir;

					oPos = oTarget;
					oTarget = oran.size() > 0 ? oran.poll() : -1;
				}
			}

			out.println("Case #" + t + ": " + time);
			out.flush();
		}
	}
}