import java.io.*;
import java.util.*;

public class D {

	static int maxThreat = 0;

	static void findShortest(int[][] adj, HashSet<Integer>[] th, int curr, HashSet<Integer> threats, HashSet<Integer> inPath) {
		if (curr == 0) {
			// System.out.println("Threats: " + threats);
			// System.out.println("Path: " + inPath);
			threats.removeAll(inPath);
			maxThreat = Math.max(threats.size(), maxThreat);
			return;
		}
		for (int p : th[curr]) {
			if (adj[0][curr] == adj[0][p] + 1) { // In shortest path
				HashSet<Integer> cThreats = new HashSet<Integer>(threats);
				HashSet<Integer> cPath = new HashSet<Integer>(inPath);

				cPath.add(p);
				cThreats.addAll(th[p]);

				findShortest(adj, th, p, cThreats, cPath);
			}
		}
	}

	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));

		int T = Integer.parseInt(in.readLine());
		for (int t = 1; t <= T; t++) {
			maxThreat = 0;
			String[] PW = in.readLine().split(" ");
			int P = Integer.parseInt(PW[0]);
			int W = Integer.parseInt(PW[1]);

			int[][] adj = new int[P][P];
			HashSet<Integer>[] th = new HashSet[P];

			for (int i = 0; i < P; i++) {
				Arrays.fill(adj[i], Integer.MAX_VALUE);
				th[i] = new HashSet<Integer>();
				adj[i][i] = 0;
			}

			StringTokenizer st = new StringTokenizer(in.readLine(), " ,");
			for (int i = 0; i < W; i++) {
				int x = Integer.parseInt(st.nextToken());
				int y = Integer.parseInt(st.nextToken());
				adj[x][y] = 1;
				adj[y][x] = 1;

				th[x].add(y);
				th[y].add(x);

				// System.out.println("Adding wormhole: " + x + " " + y);
			}

			for (int k = 0; k < P; k++) {
				for (int i = 0; i < P; i++) {
					for (int j = 0; j < P; j++) {
						if (adj[i][k] - adj[i][j] < -adj[k][j]) {
							adj[i][j] = adj[i][k] + adj[k][j];
						}
					}
				}
			}

			// // Now reconstruct the paths
			//
			// HashSet<Integer>[] dp = new HashSet[P];
			// dp[1] = new HashSet<Integer>();
			//
			// Queue<Integer> q = new LinkedList<Integer>();
			// q.add(1);
			//
			// while (q.size() > 0) {
			// int curr = q.poll();
			// // System.out.println("AT: " + curr);
			//
			//
			// }

			// System.out.println(dp[0] + " SD: " + adj[0][1]);
			// int maxThreat;
			// if (dp[0].contains(0)) {
			// maxThreat = dp[0].size() - adj[0][1];
			// } else {
			// maxThreat = dp[0].size() - adj[0][1] + 1;
			// }

			findShortest(adj, th, 1, new HashSet<Integer>(), new HashSet<Integer>());

			System.out.printf("Case #%d: %d %d\n", t, adj[0][1] - 1, maxThreat);
		}
	}
}
