package codeJam2015;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 *
 @Author : CHIMA VICTOR
 *
 */

public class Dijkstra 
{

	public final static String PROBLEM_NAME = "Dijkstra";
	public final static String WORK_DIR = "D:\\COMPETITIONS\\CodeJam\\" + PROBLEM_NAME + "\\";
	
	public static int l;
	public static long x, len, j;
	public static String string, prev, cur, res;
	public static boolean iFound, jFound, kFound;
	public static Map<String, String> quaternions = new HashMap<String, String>();
	
	static
	{
		quaternions.put("11", "1");
		quaternions.put("1i", "i");
		quaternions.put("1j", "j");
		quaternions.put("1k", "k");
		quaternions.put("i1", "i");
		quaternions.put("ii", "-1");
		quaternions.put("ij", "k");
		quaternions.put("ik", "-j");
		quaternions.put("j1", "j");
		quaternions.put("ji", "-k");
		quaternions.put("jj", "-1");
		quaternions.put("jk", "i");
		quaternions.put("k1", "k");
		quaternions.put("ki", "j");
		quaternions.put("kj", "-i");
		quaternions.put("kk", "-1");
	}
	
	public static void main(String[] args) throws IOException 
	{
		Scanner sc = new Scanner(new FileReader(WORK_DIR + "C-small-attempt1.in"));
		PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + "output.out"));
		
		int nbTestCases = sc.nextInt();
		for (int i = 1; i <= nbTestCases; i++) 
		{
			l = sc.nextInt();
			x = sc.nextLong();
			string = sc.next();
			len = l * x;
			j = 0;
			iFound = jFound = kFound = false;
			System.out.println("String : " + string);
			prev = cur = res = "";
			System.out.println(prev + " " + cur + " " + res);
			if (l > 1)
			{
				compute("i");
				System.out.println("i : " + iFound);
				compute("j");
				System.out.println("j : " + jFound);
				compute("k");
				System.out.println("k : " + kFound);
			}
			System.out.println("j = " + j + " len = " + len + " " + iFound + " " + jFound + " " + kFound);
			String ans;
			if (j == len && iFound && jFound && kFound)
			{
				ans = "YES";
			}
			else
			{
				ans = "NO";
			}
			pw.println("Case #" + i + ": " + ans);
		}
		pw.flush();
		pw.close();
		sc.close();
	}
	
	public static void compute(String pattern)
	{
		while (j < len)
		{
			System.out.println("Previous : " + prev);
			if (prev.equals(pattern))
			{
				eval(pattern);
				prev = "";
				break;
			}
			cur = string.charAt((int) (j++ % l)) + "";
			System.out.println("Current : " + cur);
			if (prev.isEmpty())
			{
				prev = cur;
			}
			else
			{
				if ((prev.charAt(0) == '-' && cur.charAt(0) != '-') || (cur.charAt(0) == '-' && prev.charAt(0) != '-'))
				{
					res = "-";
				}
				System.out.print(prev + " * " + cur + " = ");
				prev = prev.charAt(0) == '-' ? prev.substring(1) : prev;
				cur = cur.charAt(0) == '-' ? cur.substring(1) : cur;
				String quaternion = quaternions.get(prev + cur);
				if (res.equals("-") && quaternion.charAt(0) == '-')
				{
					res = "";
					quaternion = quaternion.substring(1);
				}
				res += quaternion;
				System.out.println(res);
				prev = res;
				res = "";
			}
		}
		if (j == len)
		{
			eval(prev);
		}
	}
	
	public static void eval(String pattern)
	{
		switch (pattern)
		{
		case "i" : iFound = true; break;
		case "j" : jFound = true; break;
		case "k" : kFound = true; break;
		default : ;
		}
	}
}
