package codeJam2014;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 *
 @Author : CHIMA VICTOR
 @Date   : 12 avr. 2014
 *
 */

public class DeceitfulWar {

	public final static String PROBLEM_NAME = "DeceitfulWar";
	public final static String WORK_DIR = "D:\\COMPETITIONS\\CodeJam\\" + PROBLEM_NAME + "\\";
	public static SortedSet<Double> warNaomi, decNaomi, warKen, decKen;
	public static int nWarPoints, nDecWarPoints;
	
	public static void main(String[] args) throws IOException {

		Scanner sc = new Scanner(new FileReader(WORK_DIR + "input.in"));
		PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + "output.out"));
		
		int nbTestCases = sc.nextInt();
		for (int i = 1; i <= nbTestCases; i++) {
			sc.nextLine();
			int n = sc.nextInt();
			warNaomi = new TreeSet<Double>();
			warKen = new TreeSet<Double>();
			for(int j = 0; j < n; j++){
				warNaomi.add(sc.nextDouble());
			}
			for(int j = 0; j < n; j++){
				warKen.add(sc.nextDouble());
			}
			decNaomi = new TreeSet<Double>(warNaomi);
			decKen = new TreeSet<Double>(warKen);
			nWarPoints = 0;
			nDecWarPoints = 0;
			for(int j = 0; j < n; j++){
				// play deceitful war
				double naomi = proposeBest();
				double ken = decKen.first();
				decNaomi.remove(naomi);
				decKen.remove(ken);
				if(naomi > ken){
					nDecWarPoints++;
				}
				// play classic war
				naomi = warNaomi.last();
				ken = getBestWar(naomi);
				warNaomi.remove(naomi);
				warKen.remove(ken);
				if(naomi > ken){
					nWarPoints++;
				}
			}
			pw.println("Case #" + i + ": " + nDecWarPoints + " " + nWarPoints);
		}
		pw.flush();
		pw.close();
		sc.close();
	}

	public static double proposeBest() {
	for(double d : decNaomi){
		if(d > decKen.first()){
			return d;
		}
	}
	return decNaomi.first();
	}

	public static double getBestWar(double naomi) {
		for(double d : warKen){
			if(d > naomi){
				return d;
			}
		}
		return warKen.first();
	}
}
