import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class NiceNumbersFunctions {

	private int testCases;
	private ArrayList<String[]> allCases;
	
	public NiceNumbersFunctions(){
		allCases = new ArrayList<String[]>();
	}
	
	public void readTestCasesFromFile() throws IOException{
		
		BufferedReader br = null;
		
		try {
			br = new BufferedReader(new FileReader("/Users/jurgen/Downloads/input.txt"));

			int lineCounter = 0;
			
	        StringBuilder sb = new StringBuilder();
	        String line = br.readLine();

	        while (line != null) {
	        	
	        	if(lineCounter==0){
	        		testCases = Integer.parseInt(line);
	        	}
	        	
	        	else{
	        	
	        		String[] numberCollection = line.split(" ");
	        		allCases.add(numberCollection);
	        		
	        	}
	        	lineCounter++;
	        	
	            line = br.readLine();
	        }
	     
	    } catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} finally {
	        br.close();
	    }
		
	}
	
	public void checkIntervals(){
		
		if(allCases.size() != testCases){
			System.out.println("Parameters not valid");
			return;
		}
		
		for(int i = 0; i<allCases.size(); i++){
			
			String[] values = allCases.get(i);
			
			long inferiorLimit = Long.parseLong(values[0]);
			long superiorLimit = Long.parseLong(values[1]);
			
			int counter = 0;
			
			for(long j = inferiorLimit; j<= superiorLimit; j++){
				
				long initialValue = j;
				long sqrtValue = getIfSqrt(initialValue);
				
				if(sqrtValue != -1){
					if(checkIfPalyndrome(initialValue) && checkIfPalyndrome(sqrtValue)){
						//System.out.println(initialValue + " " + sqrtValue);
						counter ++;
					}
					
				}
				
			}
			
			System.out.println("Case #" + (i + 1) + ": " + counter);
			
		}
		
	}
	
    public long getIfSqrt(long number){
		
		double result = Math.sqrt(number);
		long sqrResult;
		
		String txtResult = Double.toString(result);
		
		int posicion = txtResult.indexOf(".");
		String decimals = txtResult.substring(posicion + 1);
		sqrResult = Long.parseLong(txtResult.substring(0, posicion));
		
		if(decimals.length() > 1){
			return -1;
		}
		else if(!decimals.startsWith("0")){
			return -1;
		}
		
		return sqrResult;
		
	}
	
    public static boolean checkIfPalyndrome(long number){
		String originalString = Long.toString(number);
		String newString = "";
		char[] chars = originalString.toCharArray();
		
		for(int i = chars.length - 1; i>=0; i-- ){
			newString = newString + chars[i];
		}
		
		if(originalString.equals(newString)){
			return true;
		}
		else{
			return false;
		}
		
	}
	
}
