package cj;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Tick {

	private int testCases;
	private List<String[][]> grids;
	private List<Boolean> withBlanks;
	
	public int getTestCases(){
		return testCases;
	}
	
	public Tick(){
		testCases = 0;
		grids = new ArrayList<String[][]>();
		withBlanks = new ArrayList<Boolean>();
	}
	
	public void readTestCases() {
		
		System.out.println("Number of test cases: ");
	 
		try{
		    BufferedReader bufferRead = new BufferedReader(new InputStreamReader(System.in));
		    String s = bufferRead.readLine();
	 
		    testCases = Integer.parseInt(s);
		}
		catch(IOException e)
		{
			e.printStackTrace();
		}
		
	}
	
	public void readGrids(){
		
		for(int i = 0; i < testCases; i++){

			String[][] grid = new String[4][4];
			boolean hasEmptyCell = false;
			
			for(int j = 0; j < 4; j++){
				
				try{
				    BufferedReader bufferRead = new BufferedReader(new InputStreamReader(System.in));
				    String s = bufferRead.readLine();
			 
				    char[] chars = s.toCharArray();
				    
				    for(int k = 0; k< chars.length; k++){
				    	if(!hasEmptyCell){
				    		if(chars[k] == '.') hasEmptyCell = true;
				    	}
				    	grid[j][k] = Character.toString(chars[k]);
				    }
				    
				}
				catch(IOException e)
				{
					e.printStackTrace();
				}
				
			}
			
			grids.add(grid);
			withBlanks.add(hasEmptyCell);
			System.out.println("");
		}
		
	}
	
	//This is tricky because of the T in the games
	public void calculateGames(){
		
		int countTest = 0;
		
		mainGridList:
		for(String[][] l: grids){
			
			countTest++;
			
			for(int i = 0; i< 4; i++){
				if(calculateRows(l, i, "O")){
					System.out.println("Case #" + countTest + ": O won");
					continue mainGridList;
				}
				if(calculateRows(l, i, "X")){
					System.out.println("Case #" + countTest + ": X won");
					continue mainGridList;
				}
				if(calculateColums(l, i, "O")){
					System.out.println("Case #" + countTest + ": O won");
					continue mainGridList;
				}
				if(calculateColums(l, i, "X")){
					System.out.println("Case #" + countTest + ": X won");
					continue mainGridList;
				}
				if(calculateFirstDiagonal(l, i, "O")){
					System.out.println("Case #" + countTest + ": O won");
					continue mainGridList;
				}
				if(calculateFirstDiagonal(l, i, "X")){
					System.out.println("Case #" + countTest + ": X won");
					continue mainGridList;
				}
				if(calculateSecondDiagonal(l, i, "O")){
					System.out.println("Case #" + countTest + ": O won");
					continue mainGridList;
				}
				if(calculateSecondDiagonal(l, i, "X")){
					System.out.println("Case #" + countTest + ": X won");
					continue mainGridList;
				}
			}
			
			if(withBlanks.get(countTest-1)){
				System.out.println("Case #" + countTest + ": Game has not completed");
			}
			else{
				System.out.println("Case #" + countTest + ": Draw");
			}
			
			
		}
		
		
	}
	
	private boolean calculateRows(String[][] l, int row, String type){
		
		int count = 0;
		boolean tCount = false;
		
		for(int i = 0; i < 4; i++){
			if(l[row][i].equals(type)){
				count++;
			}
			if(l[row][i].equals("T")){
				tCount = true;
			}
			
		}
		
		if(count == 4){
			return true;
		}
		else if(count == 3 && tCount == true){
			return true;
		}
		
		return false;
		
	}
	
	private boolean calculateColums(String[][] l, int column, String type){
		
		int count = 0;
		boolean tCount = false;
		
		for(int i = 0; i < 4; i++){
			if(l[i][column].equals(type)){
				count++;
			}
			if(l[i][column].equals("T")){
				tCount = true;
			}
			
		}
		
		if(count == 4){
			return true;
		}
		else if(count == 3 && tCount == true){
			return true;
		}
		
		return false;
		
	}
	
	private boolean calculateFirstDiagonal(String[][] l, int orientation, String type){
		
		int countFirst = 0;
		int countSecond = 0;
		boolean tCountFirst = false;
		boolean tCountSecond = false;
		
		//Refactor later
		for (int i = 0, j=0; i< 4; i++, j++){
			if(l[i][j].equals(type)){
				countFirst++;
			}
			
			if(l[i][j].equals("T")){
				tCountFirst = true;
			}
			
		}
		
		if(countFirst == 4){
			return true;
		}
		else if(countFirst == 3 && tCountFirst == true){
			return true;
		}
		
		countFirst = 0;
		tCountFirst = false;
		
		//Columns
		for (int i = 0; i< 3; i++){
			if(l[i][i+1].equals(type)){
				countFirst++;
			} 
			if(l[i+1][i].equals(type)){
				countSecond++;
			}
			
			if(l[i][i+1].equals("T")){
				tCountFirst = true;
			} 
			if(l[i+1][i].equals("T")){
				tCountSecond = true;
			}
			
		}
		
		if(countFirst == 4 || countSecond == 4){
			return true;
		}
		else if((countFirst == 3 && tCountFirst == true) || (countSecond == 3 && tCountSecond == true)){
			return true;
		}
		
		
		
		return false;
	}
	
	private boolean calculateSecondDiagonal(String[][] l, int orientation, String type){
		
		int countFirst = 0;
		int countSecond = 0;
		boolean tCountFirst = false;
		boolean tCountSecond = false;
		
		//Columns
				for (int i = 3, j = 0; i>=0; i--, j++){
					if(l[i][j].equals(type)){
						countFirst++;
					} 
					
					
					if(l[i][j].equals("T")){
						tCountFirst = true;
					} 
					
					
				}
				
				if(countFirst == 4){
					return true;
				}
				else if((countFirst == 3 && tCountFirst == true)){
					return true;
				}
		
				countFirst = 0;
				tCountFirst = false;
				
		//Refactor later
		for (int i = 2, j=0; i>= 0; i--, j++){
			if(l[i][j].equals(type)){
				countFirst++;
			} 
			if(l[i+1][j+1].equals(type)){
				countSecond++;
			}
			
			if(l[i][j].equals("T")){
				tCountFirst = true;
			} 
			if(l[i+1][j+1].equals("T")){
				tCountSecond = true;
			}
			
		}
		
		if(countFirst == 4 ){
			return true;
		}
		else if(countFirst == 3 && tCountFirst == true){
			return true;
		}
		
		
		
		
		
		
		return false;
	}
}
