package jam.code.google;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Problem3 {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("C-small-attempt1.in"));
		int T = sc.nextInt(); // 1 ~ 100
		for (int t = 0; t < T; t++) {
			long L = sc.nextLong();
			long X = sc.nextLong();
			String str = sc.next();
			
			String result = solve(L, X, str);
			System.out.println("Case #" + (t+1) + ": " + result);
		}
	}
	

	public static String solve(long L, long X, String str) {
		final String YES = "YES";
		final String NO = "NO";
		
		StringBuilder builder = new StringBuilder();
		for (long n = 0L; n < X; n++) {
			builder.append(str);
		}
		
		String in = builder.toString();
		if (in.length() < 3) return NO;
		
		Data[] lList = new Data[10000]; // small
		Data[] rList = new Data[10000]; // small
		
		List<Integer> iList = new ArrayList<Integer>();
		List<Integer> kList = new ArrayList<Integer>();
		
		// make iList
		lList[0] = new Data(in.charAt(0), 1);
		if (lList[0].val == 'i' && lList[0].plus == 1) iList.add(0);
		for (int n = 1; n < in.length(); n++) {
			lList[n] = multiLeft(lList[n-1], new Data(in.charAt(n), 1));
			if (lList[n].val == 'i' && lList[n].plus == 1) iList.add(n);
		}
		
		// make kList
		rList[in.length()-1] = new Data(in.charAt(in.length()-1), 1);
		if (rList[in.length()-1].val == 'k' && rList[in.length()-1].plus == 1) kList.add(in.length()-1);
		for (int n = in.length()-2; n >= 0; n--) {
			rList[n] = multiRight(new Data(in.charAt(n), 1), rList[n+1]);
			if (rList[n].val == 'k' && rList[n].plus == 1) kList.add(n);
		}
		
		for (int i : iList) {
			for (int k : kList) {
				if (k - i > 1) {
					Data jj = multi_minus_i(lList[k-1]);
					if (jj.plus == 1 && jj.val == 'j') return YES;
				}
			}
		}
		
		return NO;
	}
	
	public static Data multi_minus_i(Data db) {
		char a = 'i';
		int a_plus = -1;

		char b = db.val;
		int b_plus = db.plus;
		
		char ab = 'x';
		int cal_plus = 1; // not determined yet
		
		switch(b) {
		case '1':
			ab = a;
			break;
		case 'i':
			if (a == 'i') {
				ab = '1';
				cal_plus = -1;
			}
			break;
		case 'j':
			if (a == 'i') {
				ab = 'k';
			}
			break;
		case 'k':
			if (a == 'i') {
				ab = 'j';
				cal_plus = -1;
			}
			break;
		}
		if (ab == 'x') System.out.println("middle invalid !!!!!!! a :" + a + ", b : " + b);
		
		int result_plus = a_plus * b_plus * cal_plus;
		return new Data(ab, result_plus);
	}
	
	public static Data multiLeft(Data da, Data db) {
		char a = da.val;
		char b = db.val;
		char ab = 'x';
		int a_plus = da.plus;
		int cal_plus = 1; // not determined yet
		
		switch(a) {
		case '1':
			ab = b;
			break;
		case 'i':
			if (b == 'i') {
				ab = '1';
				cal_plus = -1;
			} else if (b == 'j') {
				ab = 'k';
			} else if (b == 'k') {
				ab = 'j';
				cal_plus = -1;
			}
			break;
		case 'j':
			if (b == 'i') {
				ab = 'k';
				cal_plus = -1;
			} else if (b == 'j') {
				ab = '1';
				cal_plus = -1;
			} else if (b == 'k') {
				ab = 'i';
			}
			break;
		case 'k':
			if (b == 'i') {
				ab = 'j';
			} else if (b == 'j') {
				ab = 'i';
				cal_plus = -1;
			} else if (b == 'k') {
				ab = '1';
				cal_plus = -1;
			}
			break;
		}
		if (ab == 'x') System.out.println("left invalid !!!!!!! a :" + a + ", b : " + b);
		
		int result_plus = a_plus * cal_plus;
		return new Data(ab, result_plus);
	}
	
	public static Data multiRight(Data da, Data db) {
		char a = da.val;
		char b = db.val;
		char ab = 'x';
		int b_plus = db.plus;
		int cal_plus = 1; // not determined yet
		
		switch(b) {
		case '1':
			ab = a;
			break;
		case 'i':
			if (a == 'i') {
				ab = '1';
				cal_plus = -1;
			} else if (a == 'j') {
				ab = 'k';
				cal_plus = -1;
			} else if (a == 'k') {
				ab = 'j';
			}
			break;
		case 'j':
			if (a == 'i') {
				ab = 'k';
			} else if (a == 'j') {
				ab = '1';
				cal_plus = -1;
			} else if (a == 'k') {
				ab = 'i';
				cal_plus = -1;
			}
			break;
		case 'k':
			if (a == 'i') {
				ab = 'j';
				cal_plus = -1;
			} else if (a == 'j') {
				ab = 'i';
			} else if (a == 'k') {
				ab = '1';
				cal_plus = -1;
			}
			break;
		}
		if (ab == 'x') System.out.println("right invalid !!!!!!! a :" + a + ", b : " + b);
		
		int result_plus = b_plus * cal_plus;
		return new Data(ab, result_plus);
	}
	
	static class Data {
		public char val;
		public int plus;
		public Data(char val, int plus) {
			this.val = val;
			this.plus = plus;
		}
	}
	
	
}
