import java.util.*;
import java.io.*;

public class C {
	static final String filename = "C-small-attempt0.in";
	static PrintWriter out;
	
	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new File(filename));
		int T = in.nextInt();
		
		out = new PrintWriter(new FileWriter("C-small-out.txt"));
		
		for (int t = 1; t <= T; t++) {
			out.println("Case #" + t + ":");
			int R = in.nextInt(), C = in.nextInt(), M = in.nextInt();
			solve(R, C, M);
		}
		out.close();
	}
	
	static void solve(int r, int c, int m) {
		if (m == r * c - 1) {
			for (int i = 0; i < r; i++) {
				for (int j = 0; j < c; j++) {
					if (i > 0 || j > 0) out.print('*');
					else out.print('c');
				}
				out.println();
			}
			return;
		}
		
		if (r == 1) {
			for (int i = 0; i < c; i++) {
				if (i < m) out.print('*');
				else if (i == c - 1) out.print('c');
				else out.print('.');
			}
			out.println();
			return;
		}
		
		if (c == 1) {
			for (int i = 0; i < r; i++) {
				if (i < m) out.println("*");
				else if (i == r - 1) out.println("c");
				else out.println(".");
			}
			return;
		}
		
		if (m == r*c - 2) {
			out.println("Impossible");
			return;
		}
		
		/* ELSE */
		boolean found = false;
		
		int maxMask = 1 << (r * c);
		for (int k = 0; k < maxMask && !found; k++) {
			char grid[][] = new char[r][c];
			for (int i = 0; i < r; i++) Arrays.fill(grid[i], '.');
			int mine = 0;
			for (int i = 0; i < r; i++) {
				for (int j = 0; j < c; j++) {
					if ((k & (1 << (i * c + j))) > 0) {
						grid[i][j] = '*';
						mine++;
					}
				}
			}
			if (mine != m) continue;
			
			for (int i = 0; i < r && !found; i++) {
				for (int j = 0; j < c && !found; j++) {
					if (grid[i][j] != '.') continue;
					
					boolean visited[][] = new boolean[r][c];
					LinkedList<int[]> q = new LinkedList<int[]>();
					q.add(new int[]{i, j});
					
					while (q.size() != 0) {
						int[] e = q.remove();
						int cx = e[0], cy = e[1];
						if (visited[cx][cy]) continue;
						visited[cx][cy] = true;
						
						int x = 0;
						if (cx > 0 && grid[cx - 1][cy] == '*') x++;
						if (cy > 0 && grid[cx][cy - 1] == '*') x++;
						if (cx + 1 < r && grid[cx + 1][cy] == '*') x++;
						if (cy + 1 < c && grid[cx][cy + 1] == '*') x++;
						
						if (cx > 0 && cy > 0 && grid[cx - 1][cy - 1] == '*') x++;
						if (cx > 0 && cy + 1 < c && grid[cx - 1][cy + 1] == '*') x++;
						if (cx + 1 < r && cy > 0 && grid[cx + 1][cy - 1] == '*') x++;
						if (cx + 1 < r && cy + 1 < c && grid[cx + 1][cy + 1] == '*') x++;
						
						if (x > 0) continue;
						if (cx > 0) q.add(new int[]{cx - 1, cy});
						if (cy > 0) q.add(new int[]{cx, cy - 1});
						if (cx + 1 < r) q.add(new int[]{cx + 1, cy});
						if (cy + 1 < c) q.add(new int[]{cx, cy + 1});
						
						if (cx > 0 && cy > 0) q.add(new int[]{cx - 1, cy - 1});
						if (cx > 0 && cy + 1 < c) q.add(new int[]{cx - 1, cy + 1});
						if (cx + 1 < r && cy > 0) q.add(new int[]{cx + 1, cy - 1});
						if (cx + 1 < r && cy +1 < c ) q.add(new int[]{cx +1, cy + 1});
					}
					
					boolean bad = false;
					for (int a = 0; a < r && !bad; a++) {
						for (int b = 0; b < c && !bad; b++) {
							if (grid[a][b] == '.' && !visited[a][b])
								bad = true;
						}
					}
					
					if (!bad) {
						for (int a = 0; a < r; a++) {
							for (int b = 0; b < c; b++) {
								if (i == a && j == b) out.print('c');
								else out.print(grid[a][b]);
							}
							out.println();
						}
						found = true;
					}
				}
			}
		}
		
		if (!found) {
			out.println("Impossible");
			return;
		}
	}
}
