import java.io.*;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Scanner;
import java.util.regex.Pattern;

/** Parse the movie database.
 *
 * The format of this database is one movie per line, with movie fields
 * separated by a ",".  The format is:
 *
 *      title,category
 *
 * Note that there is no space before or after the ",".
 */
public class GoogleParser
{
	private String[] Google;
	private FileReader x;

    public static void main(String[] argv)
                  throws FileNotFoundException
    {
        FileReader fr = new FileReader("test.txt");

        GoogleParser x = new GoogleParser(fr);

        String[] g = x.getStrings();
        for (int i = 0; i < g.length; i ++){
        	System.out.println("Case #"+(i+1)+": "+g[i]);
        }
    }

    /** Parse all lines from the database.
     *
     * @param fr    The FileReader object from which to read the database.
     */
    public GoogleParser(FileReader fr)
    {	try {
		if (fr.ready()){
					Scanner g_reader = new Scanner(fr);
					int y = 0;
					if (g_reader.hasNextLine()){
						y = new Integer(g_reader.nextLine());  
					}
					Google = new String[y];
					parseAll(g_reader);
			}
	} catch (IOException e) {
		// TODO Auto-generated catch block
		e.printStackTrace();
	}
    }

    /** Return a copy of the array of movies
     */
    public String[] getStrings()
    {	return Arrays.copyOf(Google, Google.length);
    }

    /** Parse all lines from the database.
     *
     * @param scn   The Scanner object from which to read the database.
     */
    private void parseAll(Scanner scn)
    { int i = 0;
    	while (scn.hasNextLine()){
    		Google[i] = parseOne(scn.nextLine());
    		i++;
    	}
    }

    /** Parse one line from the database.
     *
     * @param line  One line from the movie database, without the newline
     *              character.
     * @throws ParseError 
     */
    private String parseOne(String line)
    {		char[] x = line.toCharArray();
    		for (int i = 0; i < x.length; i++){
    		//	System.out.println("Old: "+x[i]);
    			x[i] = Translate(x[i]);
    	//		System.out.println("New: "+x[i]);
    		}
			return new String(x);
    }
    


    
    private char Translate(char x){
    	HashMap<Character, Character> t = new HashMap<Character, Character>();
    	t.put('a', 'y');
    	t.put('b', 'h');
    	t.put('c', 'e');
    	t.put('d', 's');
    	t.put('e', 'o');
    	t.put('f', 'c');
    	t.put('h', 'x');
    	t.put('i', 'd');
    	t.put('j', 'u');
    	t.put('k', 'i');
    	t.put('l', 'g');
    	t.put('m', 'l');
    	t.put('n', 'b');
    	t.put('o', 'k');
    	t.put('p', 'r');
    	t.put('q', 'z');
    	t.put('r', 't');
    	t.put('s', 'n');
    	t.put('t', 'w');
    	t.put('u', 'j');
    	t.put('v', 'p');
    	t.put('w', 'f');
    	t.put('x', 'm');
    	t.put('y', 'a');
    	t.put(' ', ' ');
    	t.put('z', 'q');
    	t.put('g', 'v');
    	
    	
    	/*
        ejp mysljylc kd kxveddknmc re jsicpdrysi
        rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd
        de kr kd eoya kw aej tysr re ujdr lkgc jv


        Output
        Case #1: our language is impossible to understand
        Case #2: there are twenty six factorial possibilities
        Case #3: so it is okay if you want to just give up
        */
    	
    	
    	
    	
    	
    	
    	return t.get(x);
    
    
    }
}