import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class Problem1 {
	static Scanner inFile;
	static boolean xWin = false;
	static boolean oWin = false;

	public static void main(String[] args) {
		try {
			inFile = new Scanner(new File("in.txt"));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		int numCases = Integer.parseInt(inFile.nextLine());
		int currentCase = 0;
		while (currentCase < numCases) {
			char board[][] = new char[4][4];

			for (int i = 0; i < 4; i++) {
				String line = new String(inFile.nextLine());
				for (int j = 0; j < 4; j++) {
					board[i][j] = line.charAt(j);
				}
			}

			checkRow(board);

			if (!xWin || !oWin) {
				checkCol(board);
			}

			if (!xWin || !oWin) {
				checkDiag(board);
			}
			
			if(xWin){
				System.out.println("Case #" + (currentCase + 1)  + ": X won");
			}
			else if(oWin){
				System.out.println("Case #" + (currentCase + 1) + ": O won");
			}
			else{
				boolean done = true;
				for(int i = 0; i < 4; i++){
					for(int j = 0; j < 4; j++){
						if(board[i][j] == '.'){
							done = false;
						}
					}
				}
				
				if(done){
					System.out.println("Case #" + (currentCase + 1)  + ": Draw");
				}
				else{
					System.out.println("Case #" + (currentCase + 1)  + ": Game has not completed");
				}
			}
			

			xWin = false;
			oWin = false;
			currentCase++;
			if(inFile.hasNext())
				inFile.nextLine();
		}
	}

	private static void checkDiag(char[][] board) {
		int xCount = 0;
		int oCount = 0;
		for (int i = 0; i < 4; i++) {
			char piece = board[i][i];
			if(piece == 'X')
				xCount++;
			else if(piece == 'O')
				oCount++;
			else if(piece == 'T'){
				xCount++;
				oCount++;
			}
		}
		if (xCount == 4) {
			xWin = true;
		}
		if (oCount == 4) {
			oWin = true;
		}
		xCount = 0;
		oCount = 0;
		for (int i = 3; i >= 0; i--) {
			char piece = board[3 - i][i];
			if(piece == 'X')
				xCount++;
			else if(piece == 'O')
				oCount++;
			else if(piece == 'T'){
				xCount++;
				oCount++;
			}
		}
		if (xCount == 4) {
			xWin = true;
		}
		if (oCount == 4) {
			oWin = true;
		}

	}

	private static void checkCol(char[][] board) {
		int xCount = 0;
		int oCount = 0;
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {

				char piece = board[j][i];
				if(piece == 'X')
					xCount++;
				else if(piece == 'O')
					oCount++;
				else if(piece == 'T'){
					xCount++;
					oCount++;
				}
			
			}
			if (xCount == 4) {
				xWin = true;
			}
			if (oCount == 4) {
				oWin = true;
			}
			xCount = 0;
			oCount = 0;
		}
	}

	private static void checkRow(char[][] board) {
		int xCount = 0;
		int oCount = 0;
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {

				char piece = board[i][j];
				if(piece == 'X')
					xCount++;
				else if(piece == 'O')
					oCount++;
				else if(piece == 'T'){
					xCount++;
					oCount++;
				}
			}
			if (xCount == 4) {
				xWin = true;
			}
			if (oCount == 4) {
				oWin = true;
			}
			xCount = 0;
			oCount = 0;
		}

	}

}
