import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

public class TidyNumbers {

	public static void main(String[] args) throws IOException {
		File in = new File( "in.txt" );
		File out = new File( "out.txt" );
		Scanner reader = new Scanner( in );
		FileWriter writer = new FileWriter( out );
		
		int currCase = 1;
		int numCases = Integer.parseInt(reader.nextLine());
		while( currCase <= numCases )
		{
			BigInteger last = reader.nextBigInteger();
			while( ! IsTidy( last ) )
			{
				last = decr( last );
			}
			
			writer.write("Case #" + currCase + ": " + last + "\n");
			currCase++;
		}
		
		reader.close();
		writer.close();
	}
	
	public static boolean IsTidy( BigInteger number )
	{
		String num = number.toString();
		int index = 0;
		if( num.length() == 1 )
		{
			return true;
		}
		else
		{
			while( index < num.length() - 1 && Integer.parseInt(num.substring(index, index + 1 ) ) <=
					Integer.parseInt(num.substring(index+1, index + 2 ) ) )
			{	
				index++;
			}
		}
		return index == num.length() - 1 ;
	}
	
	public static BigInteger decr( BigInteger number )
	{
		String num = number.toString();
		int index = 0;
		while( index < num.length() - 1 && Integer.parseInt(num.substring(index, index + 1 ) ) <=
				Integer.parseInt(num.substring(index+1, index + 2 ) ) )
		{	
			index++;
		}
		int first = Integer.parseInt(num.substring( index, index + 1));
		int second = Integer.parseInt(num.substring(index + 1, index + 2 ));
		int diff =  first;
		int digitplace = num.length() - num.lastIndexOf(Integer.toString(second)) - 1;
		BigInteger sub = BigInteger.ONE.multiply(BigInteger.valueOf(diff)).multiply(BigInteger.TEN.pow(digitplace));
		return number.subtract(BigInteger.ONE);
	}

}
