import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Bathroom {

	public static void main(String[] args) throws IOException {
		File in = new File( "in.txt" );
		File out = new File( "out.txt" );
		Scanner reader = new Scanner( in );
		FileWriter writer = new FileWriter( out );
		
		int currCase = 1;
		int numCases = Integer.parseInt(reader.nextLine());
		while( currCase <= numCases )
		{
			String line = reader.nextLine();
			String[] params = line.split(" ");
			int numStalls = Integer.parseInt(params[0]) + 2;
			Stall[] stalls = new Stall[numStalls];
			int min = 0;
			int max = 0;
			for( int i= 0; i < numStalls ; i++ )
			{
				stalls[i] = new Stall();
				stalls[i].stallNumber = i;
				stalls[i].LS = 0;
				stalls[i].RS = 0;
				if( i == 0 || i == numStalls -1)
				{
					stalls[i].occupied = true;
				}
				else
				{
					stalls[i].occupied = false;
				}
			}
			Stall.UpdateStalls( stalls );
			int persons = Integer.parseInt(params[1]);
			while( persons > 0 )
			{
				//choose stall
				Stall choice = stalls[0];
				for (int j = 0; j < numStalls - 1 ; j++ )
				{
					Stall stall = stalls[j];
					if( !stall.occupied )
					{
						if( stall.MIN > choice.MIN 
							)
						{
							choice = stall;
						}
						else if( stall.MIN == choice.MIN )
						{
							if( stall.MAX > choice.MAX )
							{
								choice = stall;
							}
							else if( stall.MAX == choice.MAX 
									&& stall.stallNumber < choice.stallNumber )
							{
								choice = stall;
							}
						}
					}
				}
				choice.occupied = true;
				min = choice.MIN;
				max = choice.MAX;
				//update choice
				Stall.UpdateStalls( stalls );
				persons--;
			}
			
			writer.write("Case #" + currCase + ": " + max + " " + min +  "\n" );
			currCase++;
		}
		
		reader.close();
		writer.close();
	}

}

