import java.util.ArrayList;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;

public class TikTakToeTomek {

	public TikTakToeTomek(){}
	public static void main( String[] asArguments ){
		doTTTT();
	}
	
	public static enum eStatus {
		Xwon,
		Owon,
		draw,
		incomplete
	}
	
	static void doTTTT(){
		StringBuffer sbError = new StringBuffer();
		StringBuffer sbAnswer = new StringBuffer();
		String sAbsolutePath = "C:\\dev\\workspace\\Sandbox\\A-large.in";
		String sAbsolutePath_output = "C:\\dev\\workspace\\Sandbox\\A-large.out";
		ArrayList<String> listLines = zLoadLines( sAbsolutePath, 10000, sbError );
		int ctTestCases = 0;
		try {
			ctTestCases = Integer.parseInt( listLines.get( 0 ) );
			System.out.println( "test case count: " + ctTestCases ); 
		} catch( Throwable t ) {
			System.err.println( "count test cases: " + t );
			System.exit( -1 );
		}
		int xLine = 1;
		for( int xTestCase = 1; xTestCase <= ctTestCases; xTestCase++ ){
			String sLine = listLines.get( xLine );
			while( sLine.trim().length() == 0 ){
				xLine++;
				sLine = listLines.get( xLine );
			}
			
			// load board
			boolean[][] board_X = new boolean[5][5];
			boolean[][] board_O = new boolean[5][5];
			boolean filled = true;
			for( int xRow = 1; xRow <= 4; xRow++ ){
				for( int xColumn = 1; xColumn <= 4; xColumn++ ){
					char c = sLine.charAt( xColumn - 1 );
					if( c == 'X' || c == 'T' ) board_X[xRow][xColumn] = true; 
					if( c == 'O' || c == 'T' ) board_O[xRow][xColumn] = true;
					if( c == '.' ) filled = false;
				}
				xLine++;
				sLine = listLines.get( xLine );
			}
			
			// determine status
			eStatus status = determineStatus( board_X, board_O, filled );
			
			// write output
			switch( status ){
				case Xwon:
					System.out.println( "Case #" + xTestCase + ": " + "X won" + "\n" );
					sbAnswer.append( "Case #" + xTestCase + ": " + "X won" + "\n" );
					break;
				case Owon:
					System.out.println( "Case #" + xTestCase + ": " + "O won" + "\n" );
					sbAnswer.append( "Case #" + xTestCase + ": " + "O won" + "\n" );
					break;
				case draw:
					System.out.println( "Case #" + xTestCase + ": " + "Draw" + "\n" );
					sbAnswer.append( "Case #" + xTestCase + ": " + "Draw" + "\n" );
					break;
				case incomplete:
					System.out.println( "Case #" + xTestCase + ": " + "Game has not completed" + "\n" );
					sbAnswer.append( "Case #" + xTestCase + ": " + "Game has not completed" + "\n" );
					break;
			}
		}
		fileSave( sAbsolutePath_output, sbAnswer.toString(), sbError );
		System.out.println( "wrote " + ctTestCases + " cases" );
	}
	
	static eStatus determineStatus( boolean[][] board_X, boolean[][] board_O, boolean zFilled ){
		for( int xRow = 1; xRow <= 4; xRow++ ){
			if( board_X[xRow][1] && board_X[xRow][2] && board_X[xRow][3] && board_X[xRow][4] ) return eStatus.Xwon; 
			if( board_O[xRow][1] && board_O[xRow][2] && board_O[xRow][3] && board_O[xRow][4] ) return eStatus.Owon; 
		}
		for( int xColumn = 1; xColumn <= 4; xColumn++ ){
			if( board_X[1][xColumn] && board_X[2][xColumn] && board_X[3][xColumn] && board_X[4][xColumn] ) return eStatus.Xwon; 
			if( board_O[1][xColumn] && board_O[2][xColumn] && board_O[3][xColumn] && board_O[4][xColumn] ) return eStatus.Owon; 
		}
		if( board_X[1][1] && board_X[2][2] && board_X[3][3] && board_X[4][4] ) return eStatus.Xwon; 
		if( board_O[1][1] && board_O[2][2] && board_O[3][3] && board_O[4][4] ) return eStatus.Owon; 
		if( zFilled ) return eStatus.draw; else return eStatus.incomplete;
	}
	
	// loads lines in a file into an array list of lines
	// content can include newlines if in quotation marks
	// End of Line:
	//   PC - carriage return plus line feed
	//   Macintosh - carriage return
	//   UNIX - line feed (usually called "new line" in UNIX parlance)
	// ASCII code in decimal: LF = 10; CR = 13
	public static ArrayList<String> zLoadLines( String sAbsolutePath, int iEstimatedSize, StringBuffer sbError){
		if( sAbsolutePath == null ){ sbError.append("path missing"); return null; }
		StringBuffer sbContent = new StringBuffer(iEstimatedSize);
		if( !fileLoadIntoBuffer( sAbsolutePath, sbContent, sbError ) ){
			sbError.insert(0, "error loading file (" + sAbsolutePath + "): ");
			return null;
		}
		return zLoadLines( sbContent, sbError );
	}
	
	public static ArrayList<String> zLoadLines( StringBuffer sbContent, StringBuffer sbError ){
		return zLoadLines( sbContent.toString(), sbError );
	}
		
	public static ArrayList<String> zLoadLines( String sContent, StringBuffer sbError ){ 
		int lenContent = sContent.length();
		ArrayList<String> listLines = new ArrayList<String>();
		StringBuffer sbLine = new StringBuffer(120);
		int pos = 0;
		int eState = 1;
		while( pos < lenContent ){
			char c = sContent.charAt(pos);
			switch( eState ){
				case( 1 ): // in line
					if( c == 13 ){
						eState = 2; // after CR
					} else if( c == 10 ){ // end of UNIX line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
					} else {
						sbLine.append(c);
					}
					pos++;
					break;
				case( 2 ): // after CR
					if( c == 10 ){ // reached end of PC line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
						eState = 1;
					} else if( c == 13 ){ // two mac lines in a row (stay in CR state)
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
					} else { // single mac line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						eState = 1;
					}
			}
		}
		if( sbLine.length() > 0 ) listLines.add(sbLine.toString()); // add any unterminated lines at end
		return listLines;
	}
	
	public static boolean fileLoadIntoBuffer( String sAbsolutePath, StringBuffer sbResource, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		if( !file.exists() ){
			sbError.append("file not found");
			return false;
		}
		java.io.InputStream inputstreamResource = null;
		try {
			inputstreamResource = new FileInputStream(file);
		} catch(Exception ex) {
			sbError.append("unable to open file: " + ex);
			return false;
		}
		return zLoadString( inputstreamResource, sbResource, sbError );
	}
	
	public static boolean zLoadString( java.io.InputStream inputstreamResource, StringBuffer sbResource, StringBuffer sbError){
		if( inputstreamResource == null ){
			sbError.append("resource input stream does not exist");
			return false;
		}
		BufferedReader brFileToBeLoaded = null;
		try {
			int iFileCharacter;
			brFileToBeLoaded = new BufferedReader(new InputStreamReader(inputstreamResource));
			while(true) {
				iFileCharacter = brFileToBeLoaded.read();
				if(iFileCharacter==-1) break;
				sbResource.append((char)iFileCharacter);
			}
		} catch(Exception ex) {
			sbError.append("Failed to read resource: " + ex);
			return false;
		} finally {
			try {
				if(brFileToBeLoaded!=null) brFileToBeLoaded.close();
			} catch(Exception ex) {
				sbError.append("Failed to close resource: " + ex);
				return false;
			}
		}
		return true;
	}
		public static boolean fileSave( String sAbsolutePath, String sContent, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		return fileSave( file, sContent, sbError );
	}

	public static boolean fileSave(  File file, String sContent, StringBuffer sbError ){

		// if file does not exist, create it
		try {
			if( ! file.exists() ){
				file.createNewFile();
			}
		} catch( Exception ex ) {
			sbError.append("failed to create file " + file + ": " + ex );
			return false;
		}


		// open file
		java.io.FileOutputStream fos = null;
		try {
		    fos = new java.io.FileOutputStream(file);
		} catch(Exception ex) {
			sbError.append("failed to open file for writing: " + ex);
			return false;
		}

		// save to file
		try {
			fos.write( sContent.getBytes() );
		} catch(Exception ex) {
			System.err.println("write failure (" + sContent.length() + " bytes): " + ex);
			return false;
		} finally {
			try {
				if( fos!=null ) fos.close();
			} catch(Exception ex) {}
		}
		return true;
	}

}