import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;

public class CJ2017_Q_A {

	public CJ2017_Q_A(){}
	public static void main( String[] asArguments ) {
		doProblem();
	}
	
	static void doProblem(){
		String sDirectory = "c:/dev/codejam/CJ2017_Q_A/";
//		String sFileName  = "A-small-attempt0";
		String sFileName  = "A-large";
//		String sFileName  = "example";
		StringBuffer sbError = new StringBuffer();
		StringBuffer sbAnswer = new StringBuffer();
		String sAbsolutePath_input  = sDirectory + sFileName + ".in";
		String sAbsolutePath_output = sDirectory + sFileName + ".out";
		ArrayList<String> listLines = zLoadLines( sAbsolutePath_input, 50000, sbError );
		if( listLines == null ) {
			System.out.println( "error reading input file [" + sAbsolutePath_input + "]: " + sbError.toString() );
			System.exit( -1 );
		}
		int ctTestCases = 0;
		int xLine = 0;
		try {
			ctTestCases = Integer.parseInt( listLines.get( xLine ) );
			System.out.println( "test case count: " + ctTestCases ); 
		} catch( Throwable t ) {
			System.err.println( "count test cases: " + t );
			System.exit( -1 );
		}
		for( int xTestCase = 1; xTestCase <= ctTestCases; xTestCase++ ){
			xLine++;
			String sLine = listLines.get( xLine );
			String[] as = split( sLine, ' ' );
			String sPattern = as[0];
			int flipper_size = Integer.parseInt( as[1] );
			memo = new Node(); // clear memo
			sbFlippedArray = new StringBuffer( flipper_size );
			int flips = solve( sPattern, flipper_size );

			// write output
			if( flips == -1 ){
				sbAnswer.append( "Case #" + xTestCase + ": " + "IMPOSSIBLE" ).append( '\n' );
			} else {
				sbAnswer.append( "Case #" + xTestCase + ": " + flips ).append( '\n' );
			}

		}
//		System.out.println( sbAnswer.toString() );
		fileSave( sAbsolutePath_output, sbAnswer.toString(), sbError );
		System.out.println( "wrote " + ctTestCases + " cases" );
	}

	static Node memo = null;
	static StringBuffer sbFlippedArray = null;

	static boolean checkHappy( String s ){
		for( int i=0; i < s.length(); i++ )
			if( s.charAt( i ) != '+' ) return false;
		return true;
	}

	static boolean checkNotHappy( String s ){
		for( int i=0; i < s.length(); i++ )
			if( s.charAt( i ) != '-' ) return false;
		return true;
	}

	static String flip( String s, int pos, int flipper_size ){
		StringBuffer sbNew = new StringBuffer();
		for( int x = 0; x < pos; x++ ) sbNew.append( s.charAt( x ) );
		for( int x = 0; x < flipper_size; x++ ){
			if( s.charAt( pos + x ) == '+' ){
				sbNew.append( '-' );
			} else {
				sbNew.append( '+' );
			}
		}
		for( int x = pos + flipper_size; x < s.length(); x++ ) sbNew.append( s.charAt( x ) );
		return sbNew.toString();
	}

	static int solve( String s, int flipper_size ){
		Node pattern = memo.find( s );
		if( pattern != null ){
//			System.out.println( "found " + s + " " + pattern.flips );
			return pattern.flips;
		} else {
//			System.out.println( "did not find " + s);
		}
		pattern = memo.add( s, Integer.MAX_VALUE );
		if( checkHappy( s ) ){
			pattern.flips = 0;
			return 0;
		}
		int n = s.length();
		if( n < flipper_size ){
			pattern.flips = -1; // not possible
			return -1;
		}
		if( n == flipper_size ){
			if( checkNotHappy( s ) ){
				pattern.flips = 1;
				return 1; // takes one flip to make everything happy
			}
			pattern.flips = -1; // not possible
			return -1;
		}
//		for( int x = 0; x < flipper_size; x++ ){ // flip the beginning of array


		if( s.charAt( 0 ) == '+' ){
			int flips = solve( s.substring( 1 ), flipper_size );
			pattern.flips = flips;
			return flips;
		}
		sbFlippedArray.setLength( 0 );
		for( int x = 0; x < flipper_size; x++ ){ // flip the beginning of array
			if( s.charAt( x ) == '+' ){
				sbFlippedArray.append( '-' );
			} else {
				sbFlippedArray.append( '+' );
			}
		}
		String sNewString = sbFlippedArray.toString() + s.substring( flipper_size );
		int flips = solve( sNewString, flipper_size );
		if( flips > -1 ) flips++;
		Node nodeNewString = memo.add( sNewString, flips );
		return flips;
	}

	// loads lines in a file into an array list of lines
	// content can include newlines if in quotation marks
	// End of Line:
	//   PC - carriage return plus line feed
	//   Macintosh - carriage return
	//   UNIX - line feed (usually called "new line" in UNIX parlance)
	// ASCII code in decimal: LF = 10; CR = 13
	public static ArrayList<String> zLoadLines( String sAbsolutePath, int iEstimatedSize, StringBuffer sbError){
		if( sAbsolutePath == null ){ sbError.append("path missing"); return null; }
		StringBuffer sbContent = new StringBuffer(iEstimatedSize);
		if( !fileLoadIntoBuffer( sAbsolutePath, sbContent, sbError ) ){
			sbError.insert(0, "error loading file (" + sAbsolutePath + "): ");
			return null;
		}
		return zLoadLines( sbContent, sbError );
	}
	
	public static ArrayList<String> zLoadLines( StringBuffer sbContent, StringBuffer sbError ){
		return zLoadLines( sbContent.toString(), sbError );
	}
		
	public static ArrayList<String> zLoadLines( String sContent, StringBuffer sbError ){ 
		int lenContent = sContent.length();
		ArrayList<String> listLines = new ArrayList<String>();
		StringBuffer sbLine = new StringBuffer(120);
		int pos = 0;
		int eState = 1;
		while( pos < lenContent ){
			char c = sContent.charAt(pos);
			switch( eState ){
				case( 1 ): // in line
					if( c == 13 ){
						eState = 2; // after CR
					} else if( c == 10 ){ // end of UNIX line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
					} else {
						sbLine.append(c);
					}
					pos++;
					break;
				case( 2 ): // after CR
					if( c == 10 ){ // reached end of PC line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
						eState = 1;
					} else if( c == 13 ){ // two mac lines in a row (stay in CR state)
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
					} else { // single mac line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						eState = 1;
					}
			}
		}
		if( sbLine.length() > 0 ) listLines.add(sbLine.toString()); // add any unterminated lines at end
		return listLines;
	}
	
	public static boolean fileLoadIntoBuffer( String sAbsolutePath, StringBuffer sbResource, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		if( !file.exists() ){
			sbError.append("file not found");
			return false;
		}
		java.io.InputStream inputstreamResource = null;
		try {
			inputstreamResource = new FileInputStream(file);
		} catch(Exception ex) {
			sbError.append("unable to open file: " + ex);
			return false;
		}
		return zLoadString( inputstreamResource, sbResource, sbError );
	}
	
	public static boolean zLoadString( java.io.InputStream inputstreamResource, StringBuffer sbResource, StringBuffer sbError){
		if( inputstreamResource == null ){
			sbError.append("resource input stream does not exist");
			return false;
		}
		BufferedReader brFileToBeLoaded = null;
		try {
			int iFileCharacter;
			brFileToBeLoaded = new BufferedReader(new InputStreamReader(inputstreamResource));
			while(true) {
				iFileCharacter = brFileToBeLoaded.read();
				if(iFileCharacter==-1) break;
				sbResource.append((char)iFileCharacter);
			}
		} catch(Exception ex) {
			sbError.append("Failed to read resource: " + ex);
			return false;
		} finally {
			try {
				if(brFileToBeLoaded!=null) brFileToBeLoaded.close();
			} catch(Exception ex) {
				sbError.append("Failed to close resource: " + ex);
				return false;
			}
		}
		return true;
	}
		public static boolean fileSave( String sAbsolutePath, String sContent, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		return fileSave( file, sContent, sbError );
	}

	public static boolean fileSave(  File file, String sContent, StringBuffer sbError ){

		// if file does not exist, create it
		try {
			if( ! file.exists() ){
				file.createNewFile();
			}
		} catch( Exception ex ) {
			sbError.append("failed to create file " + file + ": " + ex );
			return false;
		}


		// open file
		java.io.FileOutputStream fos = null;
		try {
		    fos = new java.io.FileOutputStream(file);
		} catch(Exception ex) {
			sbError.append("failed to open file for writing: " + ex);
			return false;
		}

		// save to file
		try {
			fos.write( sContent.getBytes() );
		} catch(Exception ex) {
			System.err.println("write failure (" + sContent.length() + " bytes): " + ex);
			return false;
		} finally {
			try {
				if( fos!=null ) fos.close();
			} catch(Exception ex) {}
		}
		return true;
	}

	public static String[] split( String s, char c ){
		if( s == null ) return null;
		int ctChar = getOccurrenceCount(s, c);
		int ctSegments = ctChar + 1;
		String[] asSegments = new String[ctSegments];
		if( ctChar == 0 ){ // minimal case
			asSegments[0] = s;
			return asSegments;
		}
		int len = s.length();
		int xSegment = 0;
		int posStartOfSegment = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ){
				asSegments[xSegment] = s.substring(posStartOfSegment, pos);
				posStartOfSegment = pos + 1; // skip delimiter
				xSegment++;
			}
		}
		asSegments[xSegment] = s.substring(posStartOfSegment, len);
		return asSegments;
	}

	public static int getOccurrenceCount(String s, char c){
		if( s == null ) return 0;
		int len = s.length();
		if( len == 0 ) return 0;
		int iCount = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ) iCount++;
		}
		return iCount;
	}
	
}

class Node {
	Node snHappy = null;
	Node snBlank = null;
	Node parent = null;
	int flips = Integer.MAX_VALUE; // unknown number of flips
	public final Node find( String s ){ // finds the leaf, if it exists
		return find( s, 0 );
	}
	public final Node find( String s, int pos ){
		if( pos == s.length() ){
			if( flips == Integer.MAX_VALUE ) return null;
			return this;
		}
		if( s.charAt( pos ) == '+' ){
			if( snHappy == null ) return null; // not found
			return snHappy.find( s, pos + 1 );
		} else {
			if( snBlank == null ) return null; // not found
			return snBlank.find( s, pos + 1 );
		}
	}
	public final Node add( String s, int flips ){ // return the leaf node
		return add( s, 0, flips );
	}
	public final Node add( String s, int pos, int flips ){
		if( pos == s.length() ){
			this.flips = flips;
			return this;
		}
		if( s.charAt( pos ) == '+' ){
			if( snHappy == null ){
				Node nodeNew = new Node();
				nodeNew.parent = this;
				snHappy = nodeNew;
			}
			return snHappy.add( s, pos + 1, flips );
		} else {
			if( snBlank == null ){
				Node nodeNew = new Node();
				nodeNew.parent = this;
				snBlank = nodeNew;
			}
			return snBlank.add( s, pos + 1, flips );
		}
	}
}


