import java.util.ArrayList;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;

public class FairAndSquare {

	public FairAndSquare(){}
	public static void main( String[] asArguments ){
		doFairAndSquare();
//		testPalindrome( 1 );
//		testPalindrome( 4 );
//		testPalindrome( 11 );
//		testPalindrome( 12 );
//		testPalindrome( 123 );
//		testPalindrome( 12321 );
//		testPalindrome( 122321 );
//		testPalindrome( 467764 );
	}
	
	static void testPalindrome( long iRoot ){
		boolean zRootIsPalindrome = true;
		String sRoot = Long.toString( iRoot );
		int iRootLength = sRoot.length();
		if( iRootLength > 1 ){
			int floorHalfLength = (int)( iRootLength / 2);
			int xChar = 0;
			while( true ){
				if( sRoot.charAt( xChar ) != sRoot.charAt( iRootLength - xChar - 1 ) ){
					zRootIsPalindrome = false;
					break;
				}
				xChar++;
				if( xChar == floorHalfLength ) break;
			}
		}
		System.out.println( "value " + iRoot + " palindrome: " + zRootIsPalindrome );
	}
	
	static void doFairAndSquare(){
		StringBuffer sbError = new StringBuffer();
		StringBuffer sbAnswer = new StringBuffer();
		String sAbsolutePath = "C:\\dev\\workspace\\Sandbox\\C-small-attempt0.in";
		String sAbsolutePath_output = "C:\\dev\\workspace\\Sandbox\\C-small-attempt0.out";
		ArrayList<String> listLines = zLoadLines( sAbsolutePath, 50000, sbError );
		int ctTestCases = 0;
		try {
			ctTestCases = Integer.parseInt( listLines.get( 0 ) );
			System.out.println( "test case count: " + ctTestCases ); 
		} catch( Throwable t ) {
			System.err.println( "count test cases: " + t );
			System.exit( -1 );
		}
		int xLine = 1;
		for( int xTestCase = 1; xTestCase <= ctTestCases; xTestCase++ ){
			
			// read numerical range
			String sLine = listLines.get( xLine );
			String[] asDimensions = split( sLine, ' ' );
			long iLow = Integer.parseInt( asDimensions[0] );
			long iHigh = Integer.parseInt( asDimensions[1] );
			xLine++;
			
			// determine the square root of the high and low numbers
			long iRoot_low = (long)Math.sqrt( (double)iLow );
			long iRoot_high = (long)Math.sqrt( (double)iHigh );
			if( iRoot_low * iRoot_low < iLow ) iRoot_low++;  
			
			// iterate through this range looking for FAS numbers
			int ctFairAndSquareNumbers = 0;
			for( long iRoot = iRoot_low; iRoot <= iRoot_high; iRoot++ ){
				
				// determine if root is a palindrome
				boolean zRootIsPalindrome = true;
				String sRoot = Long.toString( iRoot );
				int iRootLength = sRoot.length();
				if( iRootLength > 1 ){
					int floorHalfLength = (int)( iRootLength / 2);
					int xChar = 0;
					while( true ){
						if( sRoot.charAt( xChar ) != sRoot.charAt( iRootLength - xChar - 1 ) ){
							zRootIsPalindrome = false;
							break;
						}
						xChar++;
						if( xChar == floorHalfLength ) break;
					}
				}
				
				if( zRootIsPalindrome ){ // then test if square is a palindrome as well
					long nSquare = iRoot * iRoot;
					boolean zSquareIsPalindrome = true;
					String sSquare = Long.toString( nSquare );
					int iSquareLength = sSquare.length();
					if( iSquareLength > 1 ){
						int floorHalfLength = (int)( iSquareLength / 2);
						int xChar = 0;
						while( true ){
							if( sSquare.charAt( xChar ) != sSquare.charAt( iSquareLength - xChar - 1 ) ){
								zSquareIsPalindrome = false;
								break;
							}
							xChar++;
							if( xChar == floorHalfLength ) break;
						}
					}
					if( zSquareIsPalindrome ){
						// System.out.println( "fas: " + nSquare + " " + iRoot );
						ctFairAndSquareNumbers++;
					}
				}
			}
						
			// write output
			System.out.println( "Case #" + xTestCase + ": " + ctFairAndSquareNumbers );
			sbAnswer.append( "Case #" + xTestCase + ": " + ctFairAndSquareNumbers + "\n" );
			
		}
		fileSave( sAbsolutePath_output, sbAnswer.toString(), sbError );
		System.out.println( "wrote " + ctTestCases + " cases" );
	}
	
	// loads lines in a file into an array list of lines
	// content can include newlines if in quotation marks
	// End of Line:
	//   PC - carriage return plus line feed
	//   Macintosh - carriage return
	//   UNIX - line feed (usually called "new line" in UNIX parlance)
	// ASCII code in decimal: LF = 10; CR = 13
	public static ArrayList<String> zLoadLines( String sAbsolutePath, int iEstimatedSize, StringBuffer sbError){
		if( sAbsolutePath == null ){ sbError.append("path missing"); return null; }
		StringBuffer sbContent = new StringBuffer(iEstimatedSize);
		if( !fileLoadIntoBuffer( sAbsolutePath, sbContent, sbError ) ){
			sbError.insert(0, "error loading file (" + sAbsolutePath + "): ");
			return null;
		}
		return zLoadLines( sbContent, sbError );
	}
	
	public static ArrayList<String> zLoadLines( StringBuffer sbContent, StringBuffer sbError ){
		return zLoadLines( sbContent.toString(), sbError );
	}
		
	public static ArrayList<String> zLoadLines( String sContent, StringBuffer sbError ){ 
		int lenContent = sContent.length();
		ArrayList<String> listLines = new ArrayList<String>();
		StringBuffer sbLine = new StringBuffer(120);
		int pos = 0;
		int eState = 1;
		while( pos < lenContent ){
			char c = sContent.charAt(pos);
			switch( eState ){
				case( 1 ): // in line
					if( c == 13 ){
						eState = 2; // after CR
					} else if( c == 10 ){ // end of UNIX line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
					} else {
						sbLine.append(c);
					}
					pos++;
					break;
				case( 2 ): // after CR
					if( c == 10 ){ // reached end of PC line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
						eState = 1;
					} else if( c == 13 ){ // two mac lines in a row (stay in CR state)
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
					} else { // single mac line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						eState = 1;
					}
			}
		}
		if( sbLine.length() > 0 ) listLines.add(sbLine.toString()); // add any unterminated lines at end
		return listLines;
	}
	
	public static boolean fileLoadIntoBuffer( String sAbsolutePath, StringBuffer sbResource, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		if( !file.exists() ){
			sbError.append("file not found");
			return false;
		}
		java.io.InputStream inputstreamResource = null;
		try {
			inputstreamResource = new FileInputStream(file);
		} catch(Exception ex) {
			sbError.append("unable to open file: " + ex);
			return false;
		}
		return zLoadString( inputstreamResource, sbResource, sbError );
	}
	
	public static boolean zLoadString( java.io.InputStream inputstreamResource, StringBuffer sbResource, StringBuffer sbError){
		if( inputstreamResource == null ){
			sbError.append("resource input stream does not exist");
			return false;
		}
		BufferedReader brFileToBeLoaded = null;
		try {
			int iFileCharacter;
			brFileToBeLoaded = new BufferedReader(new InputStreamReader(inputstreamResource));
			while(true) {
				iFileCharacter = brFileToBeLoaded.read();
				if(iFileCharacter==-1) break;
				sbResource.append((char)iFileCharacter);
			}
		} catch(Exception ex) {
			sbError.append("Failed to read resource: " + ex);
			return false;
		} finally {
			try {
				if(brFileToBeLoaded!=null) brFileToBeLoaded.close();
			} catch(Exception ex) {
				sbError.append("Failed to close resource: " + ex);
				return false;
			}
		}
		return true;
	}
		public static boolean fileSave( String sAbsolutePath, String sContent, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		return fileSave( file, sContent, sbError );
	}

	public static boolean fileSave(  File file, String sContent, StringBuffer sbError ){

		// if file does not exist, create it
		try {
			if( ! file.exists() ){
				file.createNewFile();
			}
		} catch( Exception ex ) {
			sbError.append("failed to create file " + file + ": " + ex );
			return false;
		}


		// open file
		java.io.FileOutputStream fos = null;
		try {
		    fos = new java.io.FileOutputStream(file);
		} catch(Exception ex) {
			sbError.append("failed to open file for writing: " + ex);
			return false;
		}

		// save to file
		try {
			fos.write( sContent.getBytes() );
		} catch(Exception ex) {
			System.err.println("write failure (" + sContent.length() + " bytes): " + ex);
			return false;
		} finally {
			try {
				if( fos!=null ) fos.close();
			} catch(Exception ex) {}
		}
		return true;
	}

	public static String[] split( String s, char c ){
		if( s == null ) return null;
		int ctChar = getOccurrenceCount(s, c);
		int ctSegments = ctChar + 1;
		String[] asSegments = new String[ctSegments];
		if( ctChar == 0 ){ // minimal case
			asSegments[0] = s;
			return asSegments;
		}
		int len = s.length();
		int xSegment = 0;
		int posStartOfSegment = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ){
				asSegments[xSegment] = s.substring(posStartOfSegment, pos);
				posStartOfSegment = pos + 1; // skip delimiter
				xSegment++;
			}
		}
		asSegments[xSegment] = s.substring(posStartOfSegment, len);
		return asSegments;
	}

	public static int getOccurrenceCount(String s, char c){
		if( s == null ) return 0;
		int len = s.length();
		if( len == 0 ) return 0;
		int iCount = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ) iCount++;
		}
		return iCount;
	}
	
}