import cra.common.Array_jsc;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Arrays;

public class CJ_InfiniteHouseofPancakes {

	public CJ_InfiniteHouseofPancakes(){}
	public static void main( String[] asArguments ){
		doProblem();
	}

	static void doProblem(){
		String sDirectory = "R:\\dev\\codejam\\2015QA\\Infinite House of Pancakes\\";
//		String sFileName  = "B-small-attempt0";
		String sFileName  = "B-small-attempt2";
//		String sFileName  = "B-small";
//		String sFileName  = "practice";
		StringBuffer sbError = new StringBuffer();
		StringBuffer sbAnswer = new StringBuffer();
		String sAbsolutePath_input  = sDirectory + sFileName + ".in";
		String sAbsolutePath_output = sDirectory + sFileName + ".out";
		ArrayList<String> listLines = zLoadLines( sAbsolutePath_input, 50000, sbError );
		int ctTestCases = 0;
		try {
			ctTestCases = Integer.parseInt( listLines.get( 0 ) );
			System.out.println( "test case count: " + ctTestCases ); 
		} catch( Throwable t ) {
			System.err.println( "count test cases: " + t );
			System.exit( -1 );
		}
		int[] work = new int[1000000]; // working buffer with test numbers of pancakes
		int xLine = 0;
		for( int xTestCase = 1; xTestCase <= ctTestCases; xTestCase++ ){
			xLine++;
			int ctServed = Integer.parseInt( listLines.get( xLine ) );
			xLine++;
			int[] servings = splitInteger( listLines.get( xLine ) );
			if( servings[0] != ctServed ){
				System.out.println( "served mismatch " + xTestCase );
				System.exit( -1 );
			}
			for( int xServing = 1; xServing <= ctServed; xServing++ ) work[ xServing - 1 ] = servings[ xServing ]; // copy servings into work array
//			for( int xWork = ctServed; xWork < work.length; xWork++ ) work[ xWork ] = 0; // zero rest of buffer
			java.util.Arrays.sort( work, 0, ctServed ); // index is exclusive

			int[] work2 = new int[ ctServed ];
			for( int xServing = 1; xServing <= ctServed; xServing++ ) work2[ xServing - 1 ] = servings[ xServing ]; // copy servings into work array
			java.util.Arrays.sort( work2 );
//			int iMinimumMinutes = getMinimum( work2, 0, 0 );
			int iMinimumMinutes = getMinimum2( work2, 0, 0 );

//			int iMinimumMinutes = work[ ctServed - 1 ];
//			int iNumberOfSpecials = 0;
//			int xWork = ctServed - 1;
//			while( true ){
//				if( work[ xWork ] < 4 ) break;
//				iNumberOfSpecials++;
//				int iMaxValue = work[xWork];
//				int iSplitValue = iMaxValue % 2 == 0 ? iMaxValue/2 : iMaxValue/2 + 1;
//				work[ ctServed - 1 + iNumberOfSpecials ] = iSplitValue;
//				work[xWork] = iMaxValue / 2;
//				while( xWork > 0 ){
//					xWork--;
//					if( work[xWork] == iMaxValue ){
//						iNumberOfSpecials++;
//						int iSplitSubValue = work[xWork] % 2 == 0 ? work[xWork]/2 : work[xWork]/2 + 1;
//						work[ ctServed - 1 + iNumberOfSpecials ] = iSplitSubValue;
//						work[xWork] = work[xWork] / 2;
//					} else break;
//				}
//				java.util.Arrays.sort( work, 0, ctServed + iNumberOfSpecials );
//				if( work[ ctServed - 1 + iNumberOfSpecials ] + iNumberOfSpecials < iMinimumMinutes )
//					iMinimumMinutes = work[ ctServed - 1 + iNumberOfSpecials ] + iNumberOfSpecials; // found an improvement
//				xWork = ctServed - 1 + iNumberOfSpecials;
//			}

			// write output
			sbAnswer.append( "Case #" + xTestCase + ": " + iMinimumMinutes + "\n" );
		}
		fileSave( sAbsolutePath_output, sbAnswer.toString(), sbError );
		System.out.println( "wrote " + ctTestCases + " cases" );
	}

	static int getMinimum( int[] work, int splits, int eats ){
		System.out.println( "" );
		int current_value = work[work.length - 1] + splits + eats;
		if( work[work.length - 1] < 4 ){ System.out.print( Array_jsc.dumpArray( work ) ); return current_value; }
		int[] work_after_eating = new int[work.length];
		System.arraycopy( work, 0, work_after_eating, 0, work.length );
		for( int xWork = 0; xWork < work.length; xWork++ ) work_after_eating[ xWork ]--;
		int minAfterEating = getMinimum( work_after_eating, splits, eats + 1 );
		int[] work_after_splitting = new int[work.length + 1];
		System.arraycopy( work, 0, work_after_splitting, 0, work.length );
		if( work[work.length - 1] % 2 == 0 ) work_after_splitting[ work.length ] = work[work.length - 1]/2; else work_after_splitting[ work.length ] = work[work.length - 1]/2 + 1;
		work_after_splitting[work.length - 1] /= 2;
		Arrays.sort( work_after_splitting );
		int minAfterSplitting = getMinimum( work_after_splitting, splits + 1, eats );
		if( current_value < minAfterEating && current_value < minAfterSplitting ){ System.out.print( "C" ); return current_value; }
		if( minAfterEating < minAfterSplitting ){ System.out.print( "E" ); return minAfterEating; }
		System.out.print( "S" );
		return minAfterSplitting;
	}

	static int getMinimum2( int[] work, int splits, int eats ){
		System.out.println( "" );
		int current_value = work[work.length - 1] + splits + eats;
		if( work[work.length - 1] < 4 ){ System.out.print( Array_jsc.dumpArray( work ) ); return current_value; }
		int[] work_after_eating = new int[work.length];
		System.arraycopy( work, 0, work_after_eating, 0, work.length );
		for( int xWork = 0; xWork < work.length; xWork++ ) work_after_eating[ xWork ]--;
		int minAfterEating = getMinimum( work_after_eating, splits, eats + 1 );
		int[] work_after_splitting = new int[work.length + 1];
		System.arraycopy( work, 0, work_after_splitting, 0, work.length );
		if( work[ work.length - 1 ] == 9 ){
			work_after_splitting[ work.length ] = 6;
			work_after_splitting[ work.length - 1 ] = 3;
		} else {
			if( work[ work.length - 1 ] % 2 == 0 ) work_after_splitting[ work.length ] = work[ work.length - 1 ] / 2;
			else work_after_splitting[ work.length ] = work[ work.length - 1 ] / 2 + 1;
		}
		work_after_splitting[work.length - 1] /= 2;
		Arrays.sort( work_after_splitting );
		int minAfterSplitting = getMinimum( work_after_splitting, splits + 1, eats );
		if( current_value < minAfterEating && current_value < minAfterSplitting ){ System.out.print( "C" ); return current_value; }
		if( minAfterEating < minAfterSplitting ){ System.out.print( "E" ); return minAfterEating; }
		System.out.print( "S" );
		return minAfterSplitting;
	}

	/** values[0] = the number of items, any amount of whitespace can be between values */
	public static int[] splitInteger( String s ){
		if( s == null ) return null;
		boolean zWriting = false;
		boolean zInValue = false;
		int ctItems = 0;
		int pos = 0;
		int len = s.length();
		StringBuffer sb = new StringBuffer( );
		int[] values = null;
		while( true ){
			if( pos >= len ){
				if( zInValue ){
					ctItems++;
					if( zWriting ){
						try {
							values[ ctItems ] = Integer.parseInt( sb.toString() );
							sb.setLength( 0 );
						} catch( Throwable t ) {
							return null; // not an integer
						}
					}
				}
				if( zWriting ) break;
				values = new int[ ctItems + 1 ];
				values[ 0 ] = ctItems;
				pos = 0;
				zWriting = true;
				ctItems = 0;
				continue;
			}
			char c = s.charAt( pos );
			if( zInValue ){
				if( Character.isWhitespace( c ) ){
					ctItems++;
					if( zWriting ){
						try {
							values[ ctItems ] = Integer.parseInt( sb.toString() );
							sb.setLength( 0 );
						} catch( Throwable t ) {
							return null; // not an integer
						}
					}
				} else {
					if( zWriting ) sb.append( c );
				}
			} else {
				if( ! Character.isWhitespace( c ) ){
					zInValue = true;
				}
			}
			pos++;
		}
		return values;
	}

	// loads lines in a file into an array list of lines
	// content can include newlines if in quotation marks
	// End of Line:
	//   PC - carriage return plus line feed
	//   Macintosh - carriage return
	//   UNIX - line feed (usually called "new line" in UNIX parlance)
	// ASCII code in decimal: LF = 10; CR = 13
	public static ArrayList<String> zLoadLines( String sAbsolutePath, int iEstimatedSize, StringBuffer sbError){
		if( sAbsolutePath == null ){ sbError.append("path missing"); return null; }
		StringBuffer sbContent = new StringBuffer(iEstimatedSize);
		if( !fileLoadIntoBuffer( sAbsolutePath, sbContent, sbError ) ){
			sbError.insert(0, "error loading file (" + sAbsolutePath + "): ");
			return null;
		}
		return zLoadLines( sbContent, sbError );
	}
	
	public static ArrayList<String> zLoadLines( StringBuffer sbContent, StringBuffer sbError ){
		return zLoadLines( sbContent.toString(), sbError );
	}
		
	public static ArrayList<String> zLoadLines( String sContent, StringBuffer sbError ){ 
		int lenContent = sContent.length();
		ArrayList<String> listLines = new ArrayList<String>();
		StringBuffer sbLine = new StringBuffer(120);
		int pos = 0;
		int eState = 1;
		while( pos < lenContent ){
			char c = sContent.charAt(pos);
			switch( eState ){
				case( 1 ): // in line
					if( c == 13 ){
						eState = 2; // after CR
					} else if( c == 10 ){ // end of UNIX line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
					} else {
						sbLine.append(c);
					}
					pos++;
					break;
				case( 2 ): // after CR
					if( c == 10 ){ // reached end of PC line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
						eState = 1;
					} else if( c == 13 ){ // two mac lines in a row (stay in CR state)
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
					} else { // single mac line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						eState = 1;
					}
			}
		}
		if( sbLine.length() > 0 ) listLines.add(sbLine.toString()); // add any unterminated lines at end
		return listLines;
	}
	
	public static boolean fileLoadIntoBuffer( String sAbsolutePath, StringBuffer sbResource, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		if( !file.exists() ){
			sbError.append("file not found");
			return false;
		}
		java.io.InputStream inputstreamResource = null;
		try {
			inputstreamResource = new FileInputStream(file);
		} catch(Exception ex) {
			sbError.append("unable to open file: " + ex);
			return false;
		}
		return zLoadString( inputstreamResource, sbResource, sbError );
	}
	
	public static boolean zLoadString( java.io.InputStream inputstreamResource, StringBuffer sbResource, StringBuffer sbError){
		if( inputstreamResource == null ){
			sbError.append("resource input stream does not exist");
			return false;
		}
		BufferedReader brFileToBeLoaded = null;
		try {
			int iFileCharacter;
			brFileToBeLoaded = new BufferedReader(new InputStreamReader(inputstreamResource));
			while(true) {
				iFileCharacter = brFileToBeLoaded.read();
				if(iFileCharacter==-1) break;
				sbResource.append((char)iFileCharacter);
			}
		} catch(Exception ex) {
			sbError.append("Failed to read resource: " + ex);
			return false;
		} finally {
			try {
				if(brFileToBeLoaded!=null) brFileToBeLoaded.close();
			} catch(Exception ex) {
				sbError.append("Failed to close resource: " + ex);
				return false;
			}
		}
		return true;
	}
		public static boolean fileSave( String sAbsolutePath, String sContent, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		return fileSave( file, sContent, sbError );
	}

	public static boolean fileSave(  File file, String sContent, StringBuffer sbError ){

		// if file does not exist, create it
		try {
			if( ! file.exists() ){
				file.createNewFile();
			}
		} catch( Exception ex ) {
			sbError.append("failed to create file " + file + ": " + ex );
			return false;
		}


		// open file
		java.io.FileOutputStream fos = null;
		try {
		    fos = new java.io.FileOutputStream(file);
		} catch(Exception ex) {
			sbError.append("failed to open file for writing: " + ex);
			return false;
		}

		// save to file
		try {
			fos.write( sContent.getBytes() );
		} catch(Exception ex) {
			System.err.println("write failure (" + sContent.length() + " bytes): " + ex);
			return false;
		} finally {
			try {
				if( fos!=null ) fos.close();
			} catch(Exception ex) {}
		}
		return true;
	}

	public static String[] split( String s, char c ){
		if( s == null ) return null;
		int ctChar = getOccurrenceCount(s, c);
		int ctSegments = ctChar + 1;
		String[] asSegments = new String[ctSegments];
		if( ctChar == 0 ){ // minimal case
			asSegments[0] = s;
			return asSegments;
		}
		int len = s.length();
		int xSegment = 0;
		int posStartOfSegment = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ){
				asSegments[xSegment] = s.substring(posStartOfSegment, pos);
				posStartOfSegment = pos + 1; // skip delimiter
				xSegment++;
			}
		}
		asSegments[xSegment] = s.substring(posStartOfSegment, len);
		return asSegments;
	}

	public static int getOccurrenceCount(String s, char c){
		if( s == null ) return 0;
		int len = s.length();
		if( len == 0 ) return 0;
		int iCount = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ) iCount++;
		}
		return iCount;
	}
	
}