import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.*;

// Bathroom Stalls

public class CJ2017_Q_C {

	public CJ2017_Q_C(){}
	public static void main( String[] asArguments ) {
//		test_treemap( 4 );
		doProblem();
	}
	
	static void doProblem(){
		String sDirectory = "c:/dev/codejam/CJ2017_Q_C/";
//		String sFileName  = "C-small-1-attempt0";
		String sFileName  = "C-small-2-attempt0";
//		String sFileName  = "C-large";
//		String sFileName  = "example";
		StringBuffer sbError = new StringBuffer();
		StringBuffer sbAnswer = new StringBuffer();
		String sAbsolutePath_input  = sDirectory + sFileName + ".in";
		String sAbsolutePath_output = sDirectory + sFileName + ".out";
		ArrayList<String> listLines = zLoadLines( sAbsolutePath_input, 50000, sbError );
		if( listLines == null ) {
			System.out.println( "error reading input file [" + sAbsolutePath_input + "]: " + sbError.toString() );
			System.exit( -1 );
		}
		int ctTestCases = 0;
		int xLine = 0;
		try {
			ctTestCases = Integer.parseInt( listLines.get( xLine ) );
			System.out.println( "test case count: " + ctTestCases ); 
		} catch( Throwable t ) {
			System.err.println( "count test cases: " + t );
			System.exit( -1 );
		}
		for( int xTestCase = 1; xTestCase <= ctTestCases; xTestCase++ ){
			xLine++;
			String sLine = listLines.get( xLine );
			String[] as = split( sLine, ' ' );
			int stalls = Integer.parseInt( as[ 0 ] );
			int people = Integer.parseInt( as[1] );
			TreeMap<Long, Long> tmap = new TreeMap<Long, Long>( Collections.reverseOrder() );
			tmap.put( (long)stalls, (long)1 );
			build_map( stalls, 1, tmap );
			Set set = tmap.entrySet();
			Iterator iterator = set.iterator();
			long nPeopleSoFar = 0;
			long max = 0, min = 0;
			while( iterator.hasNext() ){
				Map.Entry mentry = (Map.Entry)iterator.next();
				long nAdditionalPeople = (long)mentry.getValue();
				if( nPeopleSoFar + nAdditionalPeople >= people ){
					long nMaxOpenStalls = (long)mentry.getKey();
					if( nMaxOpenStalls % 2 == 0 ){
						max = nMaxOpenStalls / 2;
						min = nMaxOpenStalls / 2 - 1;
					} else {
						max = (nMaxOpenStalls - 1) / 2;
						min = max;
					}
					break;
				}
				nPeopleSoFar += nAdditionalPeople;
			}

			// write output
			sbAnswer.append( "Case #" + xTestCase + ": " + max + " " + min ).append( '\n' );

		}
//		System.out.println( sbAnswer.toString() );
		fileSave( sAbsolutePath_output, sbAnswer.toString(), sbError );
		System.out.println( "wrote " + ctTestCases + " cases" );
	}

	static void build_map( long value, long count, TreeMap<Long, Long> tmap ){
		if( value % 2 == 0 ){
			tree_map_add( value / 2, count, tmap );
			tree_map_add( value / 2 - 1, count, tmap );
			if( value / 2 > 0 ) build_map( value / 2, count, tmap );
			if( value / 2 - 1 > 0 ) build_map( value / 2 - 1, count, tmap );
		} else {
			tree_map_add( value / 2, count * 2, tmap );
			if( value / 2 > 0 ) build_map( value / 2, count * 2, tmap );
		}
	}

	static void tree_map_add( long key, long value, TreeMap<Long, Long> tmap ){
		Long existing_value = tmap.get( key );
		if( existing_value == null ){
			tmap.put( key, value );
		} else {
			tmap.put( key, value + existing_value );
		}
	}

	static void test_treemap( int stalls ){
		TreeMap<Long, Long> tmap = new TreeMap<Long, Long>( Collections.reverseOrder() );
		tmap.put( (long)stalls, (long)1 );
		build_map( stalls, 1, tmap );
		Set set = tmap.entrySet();
		Iterator iterator = set.iterator();
		while( iterator.hasNext() ){
			Map.Entry mentry = (Map.Entry)iterator.next();
			System.out.println( mentry.getKey() + " " + mentry.getValue());
		}
	}

	// study sequence
	static void generate_sequence( int stalls ){
		int[] left = new int[stalls+1];
		int[] right = new int[stalls+1];
		ArrayList<Integer> list = new ArrayList<Integer>();
		list.add( stalls );
		int x = 0;
		while( list.size() > 0 ){
			Integer biggest = null;
			for( Integer i : list ){
				if( biggest == null ){
					biggest = i;
				} else {
					if( i > biggest ) biggest = i;
				}
			}
			list.remove( biggest );
			int l = (biggest - 1) / 2;
			int r = l;
			if( biggest % 2 == 0 ) l++;
//			System.out.print( l + ", " );
			left[++x]=l;
//			System.out.println( l + " " + r );
			if( l > 0 ) list.add( new Integer( l ) );
			if( r > 0 ) list.add( new Integer( r ) );
		}
		System.out.println();
		int count = 0;
		for( x = 1; x <= stalls; x++ ){
			if( left[x] != left[x-1] ){
				if( x > 1 ) System.out.println( left[x - 1] + " " + count );
				count = 1;
			} else count++;
		}
		System.out.println( left[x - 1] + " " + count );
	}

	// loads lines in a file into an array list of lines
	// content can include newlines if in quotation marks
	// End of Line:
	//   PC - carriage return plus line feed
	//   Macintosh - carriage return
	//   UNIX - line feed (usually called "new line" in UNIX parlance)
	// ASCII code in decimal: LF = 10; CR = 13
	public static ArrayList<String> zLoadLines( String sAbsolutePath, int iEstimatedSize, StringBuffer sbError){
		if( sAbsolutePath == null ){ sbError.append("path missing"); return null; }
		StringBuffer sbContent = new StringBuffer(iEstimatedSize);
		if( !fileLoadIntoBuffer( sAbsolutePath, sbContent, sbError ) ){
			sbError.insert(0, "error loading file (" + sAbsolutePath + "): ");
			return null;
		}
		return zLoadLines( sbContent, sbError );
	}
	
	public static ArrayList<String> zLoadLines( StringBuffer sbContent, StringBuffer sbError ){
		return zLoadLines( sbContent.toString(), sbError );
	}
		
	public static ArrayList<String> zLoadLines( String sContent, StringBuffer sbError ){ 
		int lenContent = sContent.length();
		ArrayList<String> listLines = new ArrayList<String>();
		StringBuffer sbLine = new StringBuffer(120);
		int pos = 0;
		int eState = 1;
		while( pos < lenContent ){
			char c = sContent.charAt(pos);
			switch( eState ){
				case( 1 ): // in line
					if( c == 13 ){
						eState = 2; // after CR
					} else if( c == 10 ){ // end of UNIX line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
					} else {
						sbLine.append(c);
					}
					pos++;
					break;
				case( 2 ): // after CR
					if( c == 10 ){ // reached end of PC line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
						eState = 1;
					} else if( c == 13 ){ // two mac lines in a row (stay in CR state)
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						pos++;
					} else { // single mac line
						listLines.add(sbLine.toString());
						sbLine.setLength(0);
						eState = 1;
					}
			}
		}
		if( sbLine.length() > 0 ) listLines.add(sbLine.toString()); // add any unterminated lines at end
		return listLines;
	}
	
	public static boolean fileLoadIntoBuffer( String sAbsolutePath, StringBuffer sbResource, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		if( !file.exists() ){
			sbError.append("file not found");
			return false;
		}
		java.io.InputStream inputstreamResource = null;
		try {
			inputstreamResource = new FileInputStream(file);
		} catch(Exception ex) {
			sbError.append("unable to open file: " + ex);
			return false;
		}
		return zLoadString( inputstreamResource, sbResource, sbError );
	}
	
	public static boolean zLoadString( java.io.InputStream inputstreamResource, StringBuffer sbResource, StringBuffer sbError){
		if( inputstreamResource == null ){
			sbError.append("resource input stream does not exist");
			return false;
		}
		BufferedReader brFileToBeLoaded = null;
		try {
			int iFileCharacter;
			brFileToBeLoaded = new BufferedReader(new InputStreamReader(inputstreamResource));
			while(true) {
				iFileCharacter = brFileToBeLoaded.read();
				if(iFileCharacter==-1) break;
				sbResource.append((char)iFileCharacter);
			}
		} catch(Exception ex) {
			sbError.append("Failed to read resource: " + ex);
			return false;
		} finally {
			try {
				if(brFileToBeLoaded!=null) brFileToBeLoaded.close();
			} catch(Exception ex) {
				sbError.append("Failed to close resource: " + ex);
				return false;
			}
		}
		return true;
	}
		public static boolean fileSave( String sAbsolutePath, String sContent, StringBuffer sbError){
		File file = new File(sAbsolutePath);
		return fileSave( file, sContent, sbError );
	}

	public static boolean fileSave(  File file, String sContent, StringBuffer sbError ){

		// if file does not exist, create it
		try {
			if( ! file.exists() ){
				file.createNewFile();
			}
		} catch( Exception ex ) {
			sbError.append("failed to create file " + file + ": " + ex );
			return false;
		}


		// open file
		java.io.FileOutputStream fos = null;
		try {
		    fos = new java.io.FileOutputStream(file);
		} catch(Exception ex) {
			sbError.append("failed to open file for writing: " + ex);
			return false;
		}

		// save to file
		try {
			fos.write( sContent.getBytes() );
		} catch(Exception ex) {
			System.err.println("write failure (" + sContent.length() + " bytes): " + ex);
			return false;
		} finally {
			try {
				if( fos!=null ) fos.close();
			} catch(Exception ex) {}
		}
		return true;
	}

	public static String[] split( String s, char c ){
		if( s == null ) return null;
		int ctChar = getOccurrenceCount(s, c);
		int ctSegments = ctChar + 1;
		String[] asSegments = new String[ctSegments];
		if( ctChar == 0 ){ // minimal case
			asSegments[0] = s;
			return asSegments;
		}
		int len = s.length();
		int xSegment = 0;
		int posStartOfSegment = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ){
				asSegments[xSegment] = s.substring(posStartOfSegment, pos);
				posStartOfSegment = pos + 1; // skip delimiter
				xSegment++;
			}
		}
		asSegments[xSegment] = s.substring(posStartOfSegment, len);
		return asSegments;
	}

	public static int getOccurrenceCount(String s, char c){
		if( s == null ) return 0;
		int len = s.length();
		if( len == 0 ) return 0;
		int iCount = 0;
		for(int pos = 0; pos < len; pos++){
			if( s.charAt(pos) == c ) iCount++;
		}
		return iCount;
	}
	
}

/*

Problem

A certain bathroom has N + 2 stalls in a single row; the stalls on the left and right ends are permanently occupied by the bathroom guards. The other N stalls are for users.

Whenever someone enters the bathroom, they try to choose a stall that is as far from other people as possible. To avoid confusion, they follow deterministic rules: For each empty stall S, they compute two values LS and RS, each of which is the number of empty stalls between S and the closest occupied stall to the left or right, respectively. Then they consider the set of stalls with the farthest closest neighbor, that is, those S for which min(LS, RS) is maximal. If there is only one such stall, they choose it; otherwise, they choose the one among those where max(LS, RS) is maximal. If there are still multiple tied stalls, they choose the leftmost stall among those.

K people are about to enter the bathroom; each one will choose their stall before the next arrives. Nobody will ever leave.

When the last person chooses their stall S, what will be the values of max(LS, RS) and min(LS, RS) be?
Solving this problem

This problem has 2 Small datasets and 1 Large dataset. You must solve the first Small dataset before you can attempt the second Small dataset. You will be able to retry either of the Small datasets (with a time penalty). You will be able to make a single attempt at the Large, as usual, only after solving both Small datasets.
Input

The first line of the input gives the number of test cases, T. T lines follow. Each line describes a test case with two integers N and K, as described above.
Output

For each test case, output one line containing Case #x: y z, where x is the test case number (starting from 1), y is max(LS, RS), and z is min(LS, RS) as calculated by the last person to enter the bathroom for their chosen stall S.
Limits

1 ≤ T ≤ 100.
1 ≤ K ≤ N.
Small dataset 1

1 ≤ N ≤ 1000.
Small dataset 2

1 ≤ N ≤ 106.
Large dataset

1 ≤ N ≤ 1018.
Sample

Input

Output


5
4 2
5 2
6 2
1000 1000
1000 1



Case #1: 1 0
Case #2: 1 0
Case #3: 1 1
Case #4: 0 0
Case #5: 500 499

In Case #1, the first person occupies the leftmost of the middle two stalls, leaving the following configuration (O stands for an occupied stall and . for an empty one): O.O..O. Then, the second and last person occupies the stall immediately to the right, leaving 1 empty stall on one side and none on the other.

In Case #2, the first person occupies the middle stall, getting to O..O..O. Then, the second and last person occupies the leftmost stall.

In Case #3, the first person occupies the leftmost of the two middle stalls, leaving O..O...O. The second person then occupies the middle of the three consecutive empty stalls.

In Case #4, every stall is occupied at the end, no matter what the stall choices are.

In Case #5, the first and only person chooses the leftmost middle stall.
*/
