import java.math.BigInteger;

public class BaseValue {
	public static final BigInteger ZERO = new BigInteger("0");
	public static final BigInteger ONE = new BigInteger("1");
	public static final BigInteger TWO = new BigInteger("2");
	public static final BigInteger THREE = new BigInteger("3");
	
	public static long time = 10;
	public static long starttime;
	
	public static BigInteger sqrt(BigInteger n) {
		Double d=Math.sqrt(n.doubleValue());
		n = BigInteger.valueOf(d.longValue());
		return n;
	}
	
	public static long divisor(long n) {
		if (n % 2 == 0) return 2;
		long m = (long)Math.sqrt(n);

		for (int i = 3; i <= m; i+=2)
			if (n % i == 0)
				return i;

		return 1;
	}
	
	public static long divisor(BigInteger n) {
		if (n.mod(TWO).equals(ZERO))
			return 2;
		
		BigInteger m = sqrt(n);
		
		BigInteger i = THREE;
		
		while(i.compareTo(m) == -1) {
			if (n.mod(i).equals(ZERO))
				return i.longValue();
			i=i.add(TWO);
			
			if(System.currentTimeMillis() - starttime > time)
				return 1;
		}

		return 1;
	}
	
	public static void main(String[] args) {
		System.out.println("Case #1:");
		int N = 32;
		int J = 500;
		
		int coin = 1;
		coin <<= N-1;
		coin++;
		
		int good = 0;
		
		while(good < J) {
			starttime = System.currentTimeMillis();
			String ss = "";
			String s = Integer.toBinaryString(coin);
			ss += s + " ";
			
			boolean works = true;
			
			for(int r = 2; r <= 10; r++) {
				BigInteger val = new BigInteger(s, r);
				long div = divisor(val);
				if(div == 1) {
					works = false;
					break;
				}
				ss += div + " ";
			}
			
			if(works) {
				System.out.println(ss);
				good++;
			}
			
			coin += 2;
		}
	}
}
