import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.PriorityQueue;
import java.util.Scanner;

public class BathroomStalls {

	/*
	 * 0 : STDIN ==============================================================
	 * 1 : BathroomStalls.sample ==============================================
	 * 2 : BathroomStalls.small ===============================================
	 * 3 : BathroomStalls.large ===============================================
	 */
	static int mode = 2;
	static Scanner s = null;
	static PrintWriter pw = null;

	static boolean[] stalls;

	public static void printStalls() {
		if (!print)
			return;
		for (int i = 1; i < stalls.length - 1; i++)
			System.out.print(stalls[i] ? '#' : '.');
		System.out.println();
	}

	public static class Stall implements Comparable<Stall> {
		int ind, L, R;

		public Stall(int ind, int L, int R) {
			this.ind = ind;
			this.L = L;
			this.R = R;
		}

		@Override
		public String toString() {
			return String.format("(%d [%d,%d])", ind, L, R);
		}

		public int compareTo(Stall S) {
			if (Math.min(L, R) < Math.min(S.L, S.R))
				return 1;
			if (Math.min(L, R) > Math.min(S.L, S.R))
				return -1;
			if (Math.max(L, R) < Math.max(S.L, S.R))
				return 1;
			if (Math.max(L, R) > Math.max(S.L, S.R))
				return -1;
			return ind > S.ind ? 1 : -1;
		}
	}

	public static Stall stall(int i) {
		int L = 0, R = 0;
		for (int j = i - 1; !stalls[j]; j--)
			L++;
		for (int j = i + 1; !stalls[j]; j++)
			R++;
		return new Stall(i, L, R);
	}

	static boolean print = false;

	public static void foo() {
		int N = s.nextInt();
		int K = s.nextInt();
		stalls = new boolean[N + 2];
		stalls[0] = stalls[N + 1] = true;
		printStalls();
		Stall cur = null;
		for (int i = 0; i < K; i++) {
			PriorityQueue<Stall> qq = new PriorityQueue<Stall>();
			for (int j = 1; j <= N; j++)
				if (!stalls[j])
					qq.add(stall(j));
			cur = qq.poll();
			stalls[cur.ind] = true;
			printStalls();
		}
		pw.println("Case #" + t + ": " + Math.max(cur.L, cur.R) + " " + Math.min(cur.L, cur.R));

	}

	static int t;

	public static void go() {
		int T = s.nextInt();
		for (t = 1; t <= T; t++)
			foo();
	}

	public static void main(String[] args) throws IOException {

		switch (mode) {
		case 0:
			s = new Scanner(System.in);
			pw = new PrintWriter(System.out);
			break;
		case 1:
			s = new Scanner(new File("BathroomStalls.sample"));
			pw = new PrintWriter(System.out);
			break;
		case 2:
			s = new Scanner(new File("BathroomStalls.small"));
			pw = new PrintWriter(new File("BathroomStalls.small.out"));
			break;
		case 3:
			s = new Scanner(new File("BathroomStalls.large"));
			pw = new PrintWriter(new File("BathroomStalls.large.out"));
			break;
		}

		go();

		s.close();
		pw.close();

	}

}
