import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.PriorityQueue;
import java.util.Scanner;

public class BathroomStalls {

	/*
	 * 0 : STDIN ==============================================================
	 * 1 : BathroomStalls.sample ==============================================
	 * 2 : BathroomStalls.small ===============================================
	 * 3 : BathroomStalls.large ===============================================
	 */
	static int mode = 2;
	static Scanner s = null;
	static PrintWriter pw = null;

	public static void go() {
		int T = s.nextInt();
		for (int t = 1; t <= T; t++) {
			int N = s.nextInt();
			int K = s.nextInt();
			PriorityQueue<Integer> qq = new PriorityQueue<Integer>();
			qq.add(-N);
			int[] ans = new int[2];
			for (int i = 0; i < K; i++) {
				int cur = -qq.poll() - 1;
				ans[0] = cur / 2;
				ans[1] = cur / 2 + cur % 2;
				qq.add(-ans[0]);
				qq.add(-ans[1]);
			}
			pw.printf("Case #%d: %d %d\n", t, Math.max(ans[0], ans[1]), Math.min(ans[0], ans[1]));
		}
	}

	public static void main(String[] args) throws IOException {

		switch (mode) {
		case 0:
			s = new Scanner(System.in);
			pw = new PrintWriter(System.out);
			break;
		case 1:
			s = new Scanner(new File("BathroomStalls.sample"));
			pw = new PrintWriter(System.out);
			break;
		case 2:
			s = new Scanner(new File("BathroomStalls.small1"));
			pw = new PrintWriter(new File("BathroomStalls.small1.out"));
			break;
		case 3:
			s = new Scanner(new File("BathroomStalls.large"));
			pw = new PrintWriter(new File("BathroomStalls.large.out"));
			break;
		}

		go();

		s.close();
		pw.close();

	}

}
