package be.blop.round1b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class B {
	private BufferedReader reader;
	private BufferedWriter writer;
	private Scanner scanner;

	public static void main(String[] args) throws Exception {
		if (args.length != 2) System.exit(1);
		new B(new BufferedReader(new FileReader(args[0])), new BufferedWriter(new FileWriter(args[1]))).run();
	}

	private B(BufferedReader reader, BufferedWriter writer) {
		this.reader = reader;
		this.writer = writer;
		this.scanner = new Scanner(reader);
	}

	private void run() {
		try {
			codejam();
			writer.flush();
			writer.close();
			reader.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void codejam() throws IOException {
		int cases = scanner.nextInt();
		for (int c = 1; c <= cases; c++) {
			writer.write("Case #" + c + ": ");
			solve();
		}
	}

	private int toInt(char c) {
		return Integer.valueOf("" + c);
	}

	private void solve() throws IOException {
		String score1 = scanner.next();
		String score2 = scanner.next();

		// Search scores
		char[] chars1 = score1.toCharArray();
		char[] chars2 = score2.toCharArray();

		int base1 = 0;
		int base2 = 0;
		for (int d = 0; d < score1.length(); d++) {
			boolean knownDigit1 = chars1[d] != '?';
			boolean knownDigit2 = chars2[d] != '?';
			if (knownDigit1 && knownDigit2) {
				// Do nothing
			} else if (!knownDigit1 && knownDigit2) {
				// If can peak
				int peak = 1;
				boolean done = false;
				while (!done && d + peak < score1.length()) {
					char peakChar1 = chars1[d + peak];
					char peakChar2 = chars2[d + peak];
					boolean knownPeak1 = peakChar1 != '?';
					boolean knownPeak2 = peakChar2 != '?';
					if (knownPeak1 && knownPeak2) {
						int i2 = toInt(chars2[d]);
						if (i2 < 9 && peakChar2 > peakChar1) {
							chars1[d] = new String("" + (i2 + 1)).charAt(0);
							done = true;
						} else if (i2 > 0 && peakChar2 < peakChar1) {
							chars1[d] = new String("" + (i2 - 1)).charAt(0);
							done = true;
						}
					}
					peak++;
				}
				if (!done) {
					if (base1 > base2) {
						chars1[d] = '0';
					} else if (base1 < base2) {
						chars1[d] = '9';
					} else {
						chars1[d] = chars2[d];
					}
				}
			} else if (knownDigit1 && !knownDigit2) {
				// If can peak
				int peak = 1;
				boolean done = false;
				while (!done && d + peak < score1.length()) {
					char peakChar1 = chars1[d + peak];
					char peakChar2 = chars2[d + peak];
					boolean knownPeak1 = peakChar1 != '?';
					boolean knownPeak2 = peakChar2 != '?';
					if (knownPeak1 && knownPeak2) {
						int i1 = toInt(chars1[d]);
						if (i1 < 9 && peakChar1 > peakChar2) {
							chars2[d] = new String("" + (i1 + 1)).charAt(0);
							done = true;
						} else if (i1 > 0 && peakChar1 < peakChar2) {
							chars2[d] = new String("" + (i1 - 1)).charAt(0);
							done = true;
						}
					}
					peak++;
				}
				if (!done) {
					if (base1 > base2) {
						chars2[d] = '9';
					} else if (base1 < base2) {
						chars2[d] = '0';
					} else {
						chars2[d] = chars1[d];
					}
				}
			} else {
				if (base1 > base2) {
					chars1[d] = '0';
					chars2[d] = '9';
				} else if (base1 < base2) {
					chars1[d] = '9';
					chars2[d] = '0';
				} else {
					chars1[d] = '0';
					chars2[d] = '0';
				}
			}

			base1 *= 10;
			base1 += toInt(chars1[d]);
			base2 *= 10;
			base2 += toInt(chars2[d]);
		}

		// Output result
		for (int c = 0; c < chars1.length; c++) {
			writer.write(chars1[c]);
		}
		writer.write(" ");
		for (int c = 0; c < chars2.length; c++) {
			writer.write(chars2[c]);
		}
		writer.write("\n");
	}
}