package be.blop;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStreamWriter;

public class RevengeOfThePancakes {
	private File inputFile;
	private OutputStreamWriter outputWriter;

	public RevengeOfThePancakes(File inputFile, File outputFile) throws FileNotFoundException {
		this.inputFile = inputFile;
		this.outputWriter = new OutputStreamWriter(new FileOutputStream(outputFile));
	}

	public void run() throws IOException {
		int lineNumber = 0;
		try (BufferedReader br = new BufferedReader(new FileReader(inputFile))) {
			String line;
			while ((line = br.readLine()) != null) {
				if (lineNumber > 0) {
					serve(lineNumber, line);
				}
				lineNumber++;
			}
		}

		outputWriter.flush();
		outputWriter.close();
	}

	private void serve(Integer caseNumber, String pancakes) throws IOException {
		byte[] bytes = pancakes.getBytes();
		boolean lastPancakeWasHappy = bytes[0] == '+';
		int numberOfFlips = 0;
		for (int b = 1; b < bytes.length; b++) {
			int c = bytes[b];
			boolean isHappy = (c == '+');
			if (lastPancakeWasHappy != isHappy) {
				numberOfFlips++;
			}
			lastPancakeWasHappy = isHappy;
		}
		if (!lastPancakeWasHappy) {
			numberOfFlips++;
		}

		outputWriter.write("Case #" + caseNumber + ": " + numberOfFlips + "\n");
	}

	public static void main(String[] args) throws Exception {
		if (args.length != 2) System.exit(1);
		File inputFile = new File(args[0]);
		File outputFile = new File(args[1]);
		RevengeOfThePancakes countingSheep = new RevengeOfThePancakes(inputFile, outputFile);
		countingSheep.run();
	}
}
