package be.blop.round1b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

public class A {
	private static final String[] NUMBERS = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	private static final int[] NUMBERS_ORDER = {0, 2, 4, 6, 1, 3, 5, 7, 8, 9};
	private BufferedReader reader;
	private BufferedWriter writer;
	private Scanner scanner;

	public static void main(String[] args) throws Exception {
		if (args.length != 2) System.exit(1);
		new A(new BufferedReader(new FileReader(args[0])), new BufferedWriter(new FileWriter(args[1]))).run();
	}

	private A(BufferedReader reader, BufferedWriter writer) {
		this.reader = reader;
		this.writer = writer;
		this.scanner = new Scanner(reader);
	}

	private void run() {
		try {
			codejam();
			writer.flush();
			writer.close();
			reader.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.exit(1);
		}
	}

	private void codejam() throws IOException {
		int cases = scanner.nextInt();
		for (int c = 1; c <= cases; c++) {
			writer.write("Case #" + c + ": ");
			solve();
		}
	}

	private List<String> explodeStr(String string) {
		List<String> chars = new ArrayList<>();
		for (int c = 0; c < string.length(); c++) {
			chars.add("" + string.charAt(c));
		}
		return chars;
	}

	private void removeChars(List<String> source, List<String> chars) {
		for (String chara : chars) {
			Iterator<String> iterator = source.iterator();
			while (iterator.hasNext()) {
				String next = iterator.next();
				if (chara.equals(next)) {
					iterator.remove();
					break;
				}
			}
		}
	}

	private void solve() throws IOException {
		String input = scanner.next();
		List<String> chars = explodeStr(input);

		List<String> phoneNumber = new ArrayList<>();
		while (!chars.isEmpty()) {
			for (int n = 0; n < NUMBERS_ORDER.length; n++) {
				int nn = NUMBERS_ORDER[n];
				List<String> number = explodeStr(NUMBERS[nn]);
				while (chars.containsAll(number)) {
					phoneNumber.add(""+nn);
					removeChars(chars, number);
				}
			}
		}
		Collections.sort(phoneNumber);
		for (String n : phoneNumber) {
			writer.write(n);
		}
		writer.write("\n");
		writer.flush();
	}
}