import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class TrieSharding {

    static class Trie {
    	Trie ch[] = new Trie[26];
        boolean is;
    }
	
    static int n;
    static int m;
    static String s[];
    static List<String> a[];
    
    static Trie root;
    static int da;
    static int cnt;
	
    
    static void insert(Trie t, String s) {
        for (int i=0; i<s.length(); i++) {
        	int ch = s.charAt(i) - 'A';
        	if (t.ch[ch] == null) t.ch[ch] = new Trie();
        	t = t.ch[ch];
        }
        t.is = true;
    }
    
    static int count(Trie t) {
    	int cnt = 1;
    	for (int i=0; i<26; i++)
    		if (t.ch[i] != null) cnt += count(t.ch[i]);
    	return cnt;
    }
    
    static void dfs(int t) {
    	if (t == m) {
            boolean isok = true;
            for (List<String> i : a)
                if (i.size() == 0) {
                	isok = false;
                    break;
                }
            if (isok) {
                int cb = 0;
                for (int i=0; i<n; i++) {
                    root = new Trie();
                    for (String s : a[i])
                    	insert(root, s);
                    cb += count(root);
                }
                
                if (cb > da) {
                	da = cb;
                	cnt = 1;
                } else if (cb == da) cnt++;
            }
    	} else {
    		for (int i=0; i<n; i++) {
    			a[i].add(s[t]);
    			dfs(t + 1);
    			a[i].remove(a[i].size() - 1);
    		}
    	}
    }
	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws FileNotFoundException {
		Scanner cin = new Scanner(new File("D-small-attempt0.in"));
		PrintStream cout = new PrintStream("D-small-attempt0.out");
//		Scanner cin = new Scanner(new File("A-large.in"));
//		PrintStream cout = new PrintStream("A-large.out");
//		Scanner cin = new Scanner(System.in);
//		PrintStream cout = System.out;
		
		int _case = 0;
		
		for (int T=cin.nextInt(); T>0; T--) {
			_case++;
            
            m = cin.nextInt();
            n = cin.nextInt();
            s = new String[m];
            
            for (int i=0; i<m; i++) s[i] = cin.next();
            
            a = new ArrayList[n];
            for (int i=0; i<n; i++) 
            	a[i] = new ArrayList<String>();
            
            da = cnt = 0;
            dfs(0);
            
            cout.println(String.format("Case #%d: %d %d", _case, da, cnt));
		}
		
		cin.close();
		cout.close();
	}
	
}
