import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;


public class MinesweeperMaster {

	static int[] dx = {-1, -1, -1, 0, 0, 1, 1, 1};
	static int[] dy = {-1, 0, 1, -1, 1, -1, 0, 1};
	
	static int getCnt(char[][] board, int i, int j) {
		int cnt = 0;
		for (int k=0; k<8; k++) {
			int x = i + dx[k];
			int y = j + dy[k];
			if (x >= 0 && x < board.length && y >= 0 && y < board[0].length && board[x][y] == '*') cnt++;
		}
		return cnt;
	}
	public static void main(String[] args) throws FileNotFoundException {
		Scanner cin = new Scanner(new File("C-small-attempt2.in"));
		PrintStream cout = new PrintStream("C-small-attempt2.out");
//		Scanner cin = new Scanner(new File("B-large.in"));
//		PrintStream cout = new PrintStream("B-large.out");
//		Scanner cin = new Scanner(System.in);
//		PrintStream cout = System.out;

		int _case = 0;
		for (int T=cin.nextInt(); T>0; T--) {
			_case++;
			
			int r = cin.nextInt();
			int c = cin.nextInt();
			int m = cin.nextInt();
			
			
			cout.printf("Case #%d:%n", _case);
			if (r * c - 1 == m) {
				for (int i=0; i<r; i++) {
					for (int j=0; j<c; j++)
						if (i == 0 && j == 0) cout.print("c");
						else cout.print("*");
					cout.println();
				}
			} else {
				char[][] board = new char[r][c];
				for (char[] i : board) Arrays.fill(i, '.');
				int cnt = 0;
				if (m > 0) { // Wo ri
					for (int i=0; i<r-2; i++) {
						for (int j=0; j<c; j++) {
							board[i][j] = '*';
							cnt++;
							if (cnt >= m) break;
						}
						if (cnt >= m) break;
					}
					
					if (cnt < m) {
						for (int j=0; j<c; j++) {
							for (int i=Math.max(0, r-2); i<r; i++) {
								board[i][j] = '*';
								cnt++;
								if (cnt >= m) break;
							}
							if (cnt >= m) break;
						}
					}
				}
				
				boolean possible = false;
				for (int i=0; i<r; i++) {
					for (int j=0; j<c; j++)
						if (board[i][j] != '*' && getCnt(board, i, j) == 0) {
							possible = true;
							board[i][j] = 'c';
							break;
						}
					if (possible) break;
				}
				
				if (possible) {
					for (char[] i : board) {
						for (char ch : i) cout.print(ch);
						cout.println();
					}
				} else cout.println("Impossible");
			}
		}
		cin.close();
		cout.close();
	}
	
}
