
import java.io.*;

/**
 *
 * @author Hengky Budiman
 */
public class Watersheds {
    int T,H,W;
    int[][] map;
    char[][] basinMap;
    int[][] tempPath;
    int nPath;
    char basin;

    
    public void solve(){
    try{
        
        FileInputStream fstream = new FileInputStream("B-small.in");
        DataInputStream in = new DataInputStream(fstream);
        BufferedReader br = new BufferedReader(new InputStreamReader(in));
        
        String strLine = br.readLine();
        T = Integer.parseInt(strLine);
        int i,j,k,l;
        String[] bufferString;
        char tempChar;
        for(i=0;i<T;i++){
            //ambil input
            strLine = br.readLine();
            bufferString = strLine.split(" ");
            H = Integer.parseInt(bufferString[0]);
            W = Integer.parseInt(bufferString[1]);
            map = new int[H][W];
            basinMap = new char[H][W];
            for(j=0;j<H;j++){
                strLine = br.readLine();                
                bufferString = strLine.split(" ");
                for(k=0;k<W;k++){
                    map[j][k]=Integer.parseInt(bufferString[k]);
                }
            }
            tempPath = new int[H*W][2];
            basin = 'a';
            //proses
            //inisialisasi map basin
            for(j=0;j<H;j++){
                for(k=0;k<W;k++){
                    basinMap[j][k]='.';
                }
            }
            
            for(j=0;j<H;j++){
                for(k=0;k<W;k++){
                    //cek sudah ditandai belum
                    //kalau belum
                    if(basinMap[j][k]=='.')
                    {
                        if(isSink(k, j)){
                            basinMap[j][k]=basin;
                            basin++;
                        }
                        else{
                            tempChar = trace(k,j);                            
                            for(l=0;l<nPath;l++){
                                basinMap[tempPath[l][1]][tempPath[l][0]]=tempChar;
                            }
                        }
                    }
                        //cek apakah dia sink
                        //kalau iya
                            //tandai nomor baru
                            //naikin basin
                        //kalau bukan
                            //panggil fungsi trace
                            //for dari 0 ke jumlahPath, tandai dengan char dari fungsi trace
                    
                            //coba liat petak yang bakal dialiri udah ditandai blom
                                //trace semua
                            //kalau sudah
                                //tandai semua jalur yang bleum tu dengan nomor tu
                            //kalau belum
                                //tandai semua jalur tu dengan nomor 
                                //naikin counter basin
                }
            }
            
            //print hasil
            System.out.println("Case #"+(i+1)+":");
            for(j=0;j<H;j++)
            {
                for(k=0;k<W;k++)
                {
                    System.out.print(basinMap[j][k]);
                    if(k!=W-1)
                    {
                        System.out.print(" ");                        
                    }
                }
                System.out.println("");
            }
        }
        
        
        in.close();
        }catch (IOException e){
          System.err.println("Error: " + e.getMessage());
        }    
    }
    
    public char trace(int x, int y){
        //hapus dulu jalur yang lama
        nPath = 0;
        
        //panggil rekursif
        return traceRec(x,y);
    }
    
    public char traceRec(int x, int y){
        tempPath[nPath][0]=x;
        tempPath[nPath][1]=y;
        nPath++;
        if(basinMap[y][x]!='.'){
            return basinMap[y][x];
        }
        else if(isSink(x,y)){//cek sudah ditandai belom
            return basin++;           
        }
        else{
            //tandai petak tu
            //naikin jumlah petak yang suda ditandai
            //panggil lagi untuk yang bakal dipanggil
            int nextFlow = flowTo(x,y);
            if(nextFlow==0){
                return traceRec(x,y-1);
            }
            else if(nextFlow==1){
                return traceRec(x-1,y);            
            }
            else if(nextFlow==2){
                return traceRec(x+1,y);            
            }
            else if(nextFlow==3){
                return traceRec(x,y+1);            
            }
            else{
                return '?';
            }
        }
    }
    
    public boolean isSink(int x, int y){
        boolean stillTrue = true;
        
        
        if(x>0){
            stillTrue = stillTrue && (map[y][x-1] >= map[y][x]);            
        }
        
        if(x<W-1 && stillTrue){
            stillTrue = stillTrue && (map[y][x+1] >= map[y][x]);
        }        
        if(y>0 && stillTrue){
            stillTrue = stillTrue && (map[y-1][x] >= map[y][x]);
        }        
        if(y<H-1 && stillTrue){
            stillTrue = stillTrue && (map[y+1][x] >= map[y][x]);
        }        
        return stillTrue;
    }
    
    public int flowTo(int x, int y){
        int[] altitude=new int[4];
        if(y>0){
            altitude[0]=map[y-1][x];
        }else{
            altitude[0]=10000;
        }
         
        if(x>0){
            altitude[1]=map[y][x-1];
        }else{
            altitude[1]=10000;
        }
        
        if(x<W-1){
            altitude[2]=map[y][x+1];
        }else{
            altitude[2]=10000;
        }

        if(y<H-1){
            altitude[3]=map[y+1][x];
        }else{
            altitude[3]=10000;
        }
        
        int min =0;
        for (int i =1;i<4;i++){
            if(altitude[min]>altitude[i]){
                min =i;
            }
        }
        return min;
    }
    
    public static void main(String[] args) {
        Watersheds w = new Watersheds();
        w.solve();
    }

}
