import java.util.*;
import java.io.*;
import java.math.BigInteger;


public class CoinJam2 {

	public static BigInteger sqrt(BigInteger n) {
		BigInteger a = BigInteger.ONE;
		BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
		while(b.compareTo(a) >= 0) {
			BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
			if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
			else a = mid.add(BigInteger.ONE);
		}
		return a.subtract(BigInteger.ONE);
	}


	public static BigInteger isComposite(BigInteger x) {

		//		for(int i = 2; i < sqrt(x).intValue(); i++) {
		//			System.out.println("\t\t" + i);
		for(int i = 2; i < 100; i++) {
			BigInteger bigI = new BigInteger("" + i);
			BigInteger[] qr = x.divideAndRemainder(bigI);
			if(qr[1].equals(BigInteger.ZERO)) {
				return bigI;
			}
		}
		return BigInteger.ZERO;
	}

	public static boolean validate(String s, PrintWriter pw) {
		BigInteger[] proofs = new BigInteger[9];
		for(int i = 2; i <= 10; i++) {
//			System.out.println("\t" + i);
			BigInteger bi = new BigInteger(s, i);
			BigInteger factor = isComposite(bi);
			if(!factor.equals(BigInteger.ZERO)) {
				proofs[i-2] = factor;
			}
			else {
				return false;
			}
		}

		String out = s;

		for(int i = 0; i < proofs.length; i++) {
			out += " " + proofs[i];
		}

		System.out.println(out);
		pw.println(out);

		return true;
	}

	public static void main(String[] args) throws FileNotFoundException {
		//		Scanner sc = new Scanner(new File("sheepIn.txt"));
		//		Scanner sc = new Scanner(new File("A-large.in"));
		PrintWriter pw = new PrintWriter(new FileOutputStream("coinOut.txt"));

		int N = 32;
		int J = 500;

		int remaining = J;
		System.out.println("Case #1:");
		pw.println("Case #1:");
		for(int i = 0; i < (int) Math.pow(2,  N-2); i++) {
//			System.out.println(i);
			if(remaining == 0) break;
			String binStr = Integer.toBinaryString(i);			
			binStr = "1" + new String(new char[(N-2) - binStr.length()]).replace("\0", "0") + binStr + "1";
			//			System.out.println(binStr);
			if(validate(binStr, pw)) remaining--;

		}

		pw.close();

		//		validate("1001");
		//		System.out.println(isComposite(5));
	}

}