import java.util.*;
import java.io.*;


public class Pancakes {
	
	private static class Data {
		public String str;
		public int count;
	}

	public static String doFlip(String orig, int flipAt) throws Exception {
		if(flipAt > orig.length()) {
			throw new Exception();
		}
		
		String prefix = orig.substring(0, flipAt);
		String postfix = orig.substring(flipAt, orig.length());
		
		String revedPre = new StringBuilder(prefix).reverse().toString();
		String finalPre = "";
		
		for(int i = 0; i < revedPre.length(); i++) {
			if(revedPre.charAt(i) == '-') finalPre += "+";
			else finalPre += "-";
		}
		
		return finalPre + postfix;
	}
	
	public static boolean checkAnswer(String s) {
		for(int i = 0; i < s.length(); i++) {
			if(s.charAt(i) != '+') return false;
		}
		return true;
	}
	
	public static int solve(Data input) throws Exception {
		LinkedList<Data> q = new LinkedList<>();
		HashSet<String> processed = new HashSet<>();
		
		String answer = new String(new char[input.str.length()]).replace("\0", "+");
		q.add(input);
		
		
		while(!q.isEmpty()) {
			Data curData = q.removeFirst();
			String cur = curData.str;
			processed.add(cur);
			if(cur.equals(answer)) {
//				System.out.println(curData.count);
				return curData.count;
			}
			else {
				for(int i = 1; i <= cur.length(); i++) {
					String toAdd = doFlip(cur, i);
					if(toAdd.equals(answer)) {
//						System.out.println(toAdd + "\tDone!\t" + (curData.count+1));
//						System.out.println(curData.count+1);
						return curData.count + 1;
					}
					if(!processed.contains(toAdd)) {
						Data toAddData = new Data();
						toAddData.str = toAdd;
						toAddData.count = curData.count + 1;
						q.add(toAddData);
					}
				}
			}
		}
		return -1;
	}
	
	public static void main(String[] args) throws Exception {
		
		Scanner sc = new Scanner(new File("B-small-attempt0.in"));
		PrintWriter out = new PrintWriter(new FileOutputStream("pancakesOut.txt"));

		int numTests = sc.nextInt();
		
		for(int i = 1; i <= numTests; i++) {	
			Data d = new Data();
			d.str = sc.next();
			d.count = 0;
			int ans = solve(d);
			System.out.println("Case #" + i + ": " + ans);
			out.println("Case #" + i + ": " + ans);
		}
		
		out.close();
	}

}