package cj;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Password {
	
	public static float calc(int typed, int total, float[] cprobs) {
		boolean[][] passmap = new boolean[2<<(typed-1)][typed];
		float[] probs = new float[2<<(typed-1)];
		for (int i=0; i<passmap.length; i++) {
			float prob = 1;
			for (int j=0; j<passmap[i].length; j++) {
				//System.out.println(j+" j> "+(1<<j));
				//System.out.println(i+" i> "+(i&(1<<j)));
				passmap[i][j] = ((i & (1<<j))>>j) == 1;
				if (passmap[i][j]) {
					prob *= cprobs[j];
				} else {
					prob *= (1-cprobs[j]);
				}
			}
			//System.out.println();
			probs[i] = prob;
		}
		/*for (int i=0; i<probs.length; i++) {
			System.out.println();
			for (int j=0; j<passmap[i].length; j++) {
				System.out.print(passmap[i][j]?"C":"X");
			}
			System.out.print(" - "+probs[i]);
		}
		System.out.println();
		*/
		float minKeys = keepTyping(typed, total, passmap, probs);
		//System.out.println(minKeys);
		
		for (int i=0; i<typed; i++) {
			float back = backspace(typed, total, passmap, probs, i+1);
		//	System.out.println(back);
			if (back < minKeys) minKeys = back;
		}
		float giveUp = giveUp(total);
		if (giveUp < minKeys) minKeys = giveUp;
		
		
		return minKeys;
	}
	
	public static float keepTyping(int typed, int total, boolean[][] passmap, float[] probs) {
		int[] strokes = new int[probs.length];
		for (int i=0; i<probs.length; i++) {
			strokes[i] = total-typed+1;
			for (int j=0; j<passmap[i].length; j++) {
				//System.out.print(passmap[i][j]?"T":"F");
				if (!passmap[i][j]) {
					strokes[i] += total+1;
					break;
				}
			}
		}
		return compile(probs, strokes);
	}
	
	public static float backspace(int typed, int total, boolean[][] passmap, float[] probs, int back) {
		int[] strokes = new int[probs.length];
		boolean[][] copymap = copy(passmap);
		for (int j=0; j<copymap.length; j++) {
			for (int i=typed-back; i<typed; i++) {
				copymap[j][i] = true;
			}
		}
		return keepTyping(typed, total, copymap, probs) + back*2;
	}
	
	public static boolean[][] copy(boolean[][] a) {
		boolean[][] ret = new boolean[a.length][a[0].length];
		for (int i=0; i<ret.length; i++) {
			for (int j=0; j<ret[0].length; j++) {
				ret[i][j] = a[i][j];
			}
		}
		return ret;
	}
	
	public static float giveUp(int total) {
		return total+2;
	}
	
	public static float compile(float[] probs, int[] strokes) {
		float ret = 0;
		for (int i=0; i<probs.length; i++) {
		//	System.out.println(strokes[i]+", "+probs[i]);
			ret += probs[i]*strokes[i];
		}
		return ret;
	}
	
	
	
	public static void main(String[] args) throws IOException {
		//boolean write = false;
		//System.out.println(new File(".").getCanonicalPath());
		Scanner scan = new Scanner(new File("pwin.in"));
		FileWriter fstream = new FileWriter("pwout.out");
		BufferedWriter bw = new BufferedWriter(fstream);
		int num = new Integer(scan.nextInt());
		for (int i=0; i<num; i++) {
			int typed = scan.nextInt();
			int total = scan.nextInt();
			float[] probs = new float[typed];
			for (int j=0; j<typed; j++) {
				probs[j] = scan.nextFloat();
			}
			float answ = calc(typed, total, probs);
			System.out.println(answ+"\n");
			bw.write("Case #"+(i+1)+": "+answ+"\n");
		}
		scan.close();
		bw.close();
	}
}
