package codejam;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.util.Scanner;

public class Magicka {
	public static char[] base = {'Q', 'W', 'E', 'R', 'A', 'S', 'D', 'F'};
	
	public static class Problem {
		public String[] combos;
		public String[] oppose;
		public char[] typed;
		
		public Problem(String[] c, String[] o, char[] t) {
			combos = c;
			oppose = o;
			typed = t;
		}
	}
	
	public static void main(String[] args) {
		Scanner scan = null;
		try {
			scan = new Scanner(new File("data.in"));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		String s = scan.nextLine();
		int n = new Integer(s);
		String ret = "";
		for (int i=0; i<n; i++) {
			Problem prob = parse(scan.nextLine());
			ret += "Case #"+(i+1)+": "+solve(prob)+"\n";
		}
		try{
		    FileWriter fstream = new FileWriter("data.out");
		        BufferedWriter out = new BufferedWriter(fstream);
		    out.write(ret);
		    out.close();
		    }catch (Exception e){//Catch exception if any
		      System.err.println("Error: " + e.getMessage());
		    }
	}
	
	public static Problem parse(String line) {
		Scanner scan = new Scanner(line);
		int n = new Integer(scan.next());
		String[] comb = new String[n];
		for (int i=0; i<n; i++) {
			comb[i] = scan.next();
		}
		n = new Integer(scan.next());
		String[] opp = new String[n];
		for (int i=0; i<n; i++) {
			opp[i] = scan.next();
		}
		scan.next();
		String type = scan.next();
	//	System.out.println(type);
		return new Problem(comb, opp, type.toCharArray());
	}
	
	public static String solve(Problem p) {
		String ret = "";
		for (int i=0; i<p.typed.length; i++) {
			ret += p.typed[i];
			ret = simplify(ret, p);
		}
		char[] temp = ret.toCharArray();
		ret = "[";
		for (int i=0; i<temp.length; i++) {
			ret += temp[i];
			if (i != temp.length-1) ret += ", ";
		}
		ret += "]";
		return ret;
	}
	
	public static String simplify(String typed, Problem p) {
		if (typed.length() <= 1) return typed;
		char a = typed.charAt(typed.length()-1);
		char b = typed.charAt(typed.length()-2);
		for (int i=0; i<p.combos.length; i++) {
			char c = p.combos[i].charAt(0);
			char d = p.combos[i].charAt(1);
			if ((a == c && b == d) || (a == d && b == c)) {
				typed = typed.substring(0, typed.length()-2) + p.combos[i].charAt(2);
				break;
			}
		}
		for (int i=0; i<p.oppose.length; i++) {
			for (int j=0; j<typed.length(); j++) {
				if (typed.charAt(j) == p.oppose[i].charAt(0)) {
					for (int k=0; k<typed.length(); k++) {
						if (typed.charAt(k) == p.oppose[i].charAt(1)) {
							return "";
						}
					}
				}
			}
		}
		return typed;
	}

}
