package codejam;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.util.Scanner;

public class BotTrust {
	
	public static void main(String[] args) {
		Scanner scan = null;
		try {
			scan = new Scanner(new File("data.in"));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		String s = scan.nextLine();
		int n = new Integer(s);
		String ret = "";
		for (int i=0; i<n; i++) {
			int[] orders = parse(scan.nextLine());
			ret += "Case #"+(i+1)+": "+solve(orders)+"\n";
		}
		try{
		    FileWriter fstream = new FileWriter("data.out");
		        BufferedWriter out = new BufferedWriter(fstream);
		    out.write(ret);
		    out.close();
		    }catch (Exception e){//Catch exception if any
		      System.err.println("Error: " + e.getMessage());
		    }
	}
	
	public static int[] parse(String line) {
		Scanner scan = new Scanner(line);
		String s = scan.next();
		int n = new Integer(s);
		int[] ret = new int[n];
		for (int i=0; i<n; i++) {
			String temp = scan.next();
			int tempI= scan.nextInt();
			if (temp.equals("O")) ret[i] = tempI;
			if (temp.equals("B")) ret[i] = -tempI;
		}
		return ret;
	}
	
	public static int solve(int[] orders) {
		int[] data = {1, 1, 0};
		int i;
		for (i=0; !step(orders, data); i++);
		return i;
	}
	public static boolean step(int[] orders, int[] data) {
	//	System.out.println(data[0]+", "+data[1]+", "+data[2]);
		if (data[2] == orders.length) return true;
		int orangeGoal = -1, blueGoal = -1;
		for (int i=data[2]; i<orders.length; i++) {
			if (orders[i] < 0) {
				if (blueGoal == -1) blueGoal = -orders[i];
			} else {
				if (orangeGoal == -1) orangeGoal = orders[i];
			}
		}
	//	System.out.println(orangeGoal+" | "+blueGoal);
		boolean nextIsOrange = orders[data[2]] > 0;
		boolean pressedButton = false;
		if (nextIsOrange) {
			if (data[0] == orangeGoal) pressedButton = true; 
		} else {
			if (data[1] == blueGoal) pressedButton = true;
		}
		if (pressedButton) data[2]++;
		if (!pressedButton || !nextIsOrange) {
			if (data[0] > orangeGoal) data[0]--;
			else if (data[0] < orangeGoal) data[0]++;
		}
		if (!pressedButton || nextIsOrange) {
			if (data[1] > blueGoal) data[1]--;
			else if (data[1] < blueGoal) data[1]++;
		}
		return false;
	}
}
