import java.io.BufferedReader;


public class CodeJam2013 
{
	public CodeJam2013()
	{
		
	}
	
	public void TicTacToeTomek(BufferedReader input)
	{
		int i;
		//get the arguments in here
		int numLines = 0;
		int j;
		
		try
		{
			numLines = new Integer(input.readLine()).intValue();
		}
		catch(Exception e)
		{
			//do something
		}
		
		int curCredit = 0;
		int numElements = 0;
		int elementWeights[] = null;
		String elementLine[] = null;
		StringBuffer outputBuffer = new StringBuffer();
		
		int curLine = 0;
		
		while(curLine < numLines)
		{
			String boardLines[] = new String[4];
			String board[][] = new String[4][4];
			try
			{
				//init the values
				for(i = 0; i < boardLines.length; ++i)
				{
					boardLines[i] = input.readLine();
					board[i] = boardLines[i].split("(?!^)");
				}
			}
			catch(Exception e)
			{
				//do something
				return;
			}
			
			//check if either player has won
			if(CheckAllVertical("X", board) || CheckAllHorizontal("X", board) || CheckAllDiagonal("X", board))
			{
				OutputCase(curLine+1, "X won");
			}
			else if(CheckAllVertical("O", board) || CheckAllHorizontal("O", board) || CheckAllDiagonal("O", board))
			{
				OutputCase(curLine+1, "O won");
			}
			else
			{
				
				//check if its a draw (a draw means there's no . present)
				boolean inProgress = false;
				for(i = 0; i < board.length; ++i)
				{
					for(j = 0; j < board[i].length; ++j)
					{
						if(board[i][j].equals("."))
						{
							inProgress = true;
							break;
						}
					}
					
					if(inProgress)
					{
						break;
					}
				}
				
				if(inProgress)
				{
					OutputCase(curLine+1, "Game has not completed");
				}
				else
				{
					OutputCase(curLine+1, "Draw");
				}
			}
			
			//skip the whitespace
			try
			{
				input.readLine();
			}
			catch(Exception e)
			{
				
			}
			
			curLine++;
		}
	}
	
	public boolean CheckAllDiagonal(String player, String board[][])
	{
		String newBoard[] = new String[4];
		
		newBoard[0] = board[0][0];
		newBoard[1] = board[1][1];
		newBoard[2] = board[2][2];
		newBoard[3] = board[3][3];
		
		if(CheckList(player, newBoard))
		{
			return true;
		}
		
		newBoard[0] = board[0][3];
		newBoard[1] = board[1][2];
		newBoard[2] = board[2][1];
		newBoard[3] = board[3][0];
		
		if(CheckList(player, newBoard))
		{
			return true;
		}
		
		return false;
	}
	
	public boolean CheckAllVertical(String player, String board[][])
	{
		int i;
		String newBoard[] = new String[4];
		
		for(i = 0; i < board.length; ++i)
		{
			newBoard[0] = board[0][i];
			newBoard[1] = board[1][i];
			newBoard[2] = board[2][i];
			newBoard[3] = board[3][i];
			
			if(CheckList(player, newBoard))
			{
				return true;
			}
		}
		
		return false;
	}
	
	public boolean CheckAllHorizontal(String player, String board[][])
	{
		int i;
		
		for(i = 0; i < board.length; ++i)
		{
			if(CheckList(player, board[i]))
			{
				return true;
			}
		}
		
		return false;
	}
	
	private boolean CheckList(String player,String board[])
	{
		return 	(board[0].equals(player) || board[0].equals("T")) &&
						(board[1].equals(player) || board[1].equals("T")) &&
						(board[2].equals(player) || board[2].equals("T")) &&
						(board[3].equals(player) || board[3].equals("T"));
	}
	
	public void OutputCase(int curCase, String output)
	{
		System.out.println("Case #" + curCase + ": " + output);
	}
}
