import java.io.BufferedReader;


public class LawnMower
{
	public LawnMower()
	{	
		
	}
	
	public void CheckCut(BufferedReader input)
	{
		int i;
		//get the arguments in here
		int numLines = 0;
		int j;
		
		try
		{
			numLines = new Integer(input.readLine()).intValue();
		}
		catch(Exception e)
		{
			//do something
		}
		
		StringBuffer outputBuffer = new StringBuffer();
		
		int curLine = 0;
		
		while(curLine < numLines)
		{
			String lawnLines[];
			int lawn[][];
			int n;
			int m;
			try
			{
				String dimLine = input.readLine();
				String dims[] = dimLine.split(" ");
				n = new Integer(dims[0]).intValue();
				m = new Integer(dims[1]).intValue();
				
				lawnLines = new String[n];
				 lawn = new int[n][m];
				
				//init the values
				for(i = 0; i < lawnLines.length; ++i)
				{
					lawnLines[i] = input.readLine();
					String curLawnLine[] = lawnLines[i].split(" ");
					for(j = 0; j < curLawnLine.length; ++j)
					{
						lawn[i][j] = new Integer(curLawnLine[j].charAt(0) - '0').intValue();
					}
				}
			}
			catch(Exception e)
			{
				//do something
				return;
			}
			
			//System.out.print("Dims : " + n + " , " + m + "\t");
			
			//check if the value is sandwiched between 2 higher values
			if(n == 1 || m == 1)
			{
				OutputCase(curLine+1, "YES");
			}
			else
			{
				//check the inner values
				boolean verticalValid = true;
				boolean horizontalValid = true;
				boolean valid = true;
				
				for(i = 0; i < n; ++i)
				{
					for(j = 0; j < m; ++j)
					{
						verticalValid = VerticalValid(i,j,lawn);
						horizontalValid = HorizontalValid(i,j,lawn);
						
						if(verticalValid || horizontalValid)
						{
							//do nothing
						}
						else
						{
							valid = false;
							break;
						}
					}
					
					if(!valid)
					{
						break;
					}
				}
				
				if(!valid)
				{
					OutputCase(curLine+1, "NO");
				}
				else
				{
					OutputCase(curLine+1, "YES");
				}
			}
			curLine++;
		}
	}
	
	private boolean VerticalValid(int row, int col, int lawn[][])
	{
		int i;
		int startVal = lawn[row][col];
		boolean topGreater = false;
		boolean bottomGreater = false;
		
		for(i = row; i >= 0; --i)
		{
			if(lawn[i][col] > startVal)
			{
				topGreater = true;
				break;
			}
		}
		
		for(i = row; i < lawn.length; ++i)
		{
			if(lawn[i][col] > startVal)
			{
				bottomGreater = true;
				break;
			}
		}
		
		return (!topGreater && !bottomGreater);
	}
	
	private boolean HorizontalValid(int row, int col, int lawn[][])
	{
		int i;
		int startVal = lawn[row][col];
		boolean leftGreater = false;
		boolean rightGreater = false;
		
		for(i = col; i >= 0; --i)
		{
			if(lawn[row][i] > startVal)
			{
				leftGreater = true;
				break;
			}
		}
		
		for(i = col; i < lawn[0].length; ++i)
		{
			if(lawn[row][i] > startVal)
			{
				rightGreater = true;
				break;
			}
		}
		
		return (!leftGreater && !rightGreater);
	}
	
	public void OutputCase(int curCase, String output)
	{
		System.out.println("Case #" + curCase + ": " + output);
	}
}
