package CodeJam;

import java.awt.Point;
import java.util.Locale;
import java.util.Scanner;

public class C
{
	private static int MINE = 99;
	
	public static void main(String[] args)
	{
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		in.useLocale(Locale.US);
		
		for (int zz = 1; zz <= T; zz++)
		{
			int row = in.nextInt();
			int col = in.nextInt();
			int mines = in.nextInt();
			
			String answer = Solve(row, col, mines);
			System.out.format("Case #%d: %s\n", zz, answer);
		}
		
		in.close();
	}
	
	static String Solve(int row, int col, int mines)
	{
		//make sure no mines are adjacent to a chosen click position
		int i;
		Point idx;
		
		int[][] curGrid = new int[row][col];
		int[][] adjacentGrid = new int[row][col];
		
		UpdateAdjacentGrid(adjacentGrid);
		
		for(i = 0; i < mines; ++i)
		{
			idx = FindMin(adjacentGrid, curGrid);
			//idx = FindMaxMine(curGrid);
			
			adjacentGrid[idx.x][idx.y] = MINE; 
			curGrid[idx.x][idx.y] = MINE;
			
			UpdateAdjacentGrid(adjacentGrid);
			UpdateMineNeighbours(curGrid);
		}
		
		//mines are placed, now figure out if we can click anywhere where we can remove the 
		
		return PrintGrid(curGrid);
	}
	
	//increase the number of mines adjacent to each of the cells
	static void UpdateMineNeighbours(int[][] grid)
	{
		int i, j;
		
		int row = grid.length;
		int col = grid[0].length;
		
		//reset it
		for(i = 0; i < row; ++i)
		{
			for(j = 0; j < col; ++j)
			{			
				if(grid[i][j] != MINE)
				{
					grid[i][j] = 0;
				}
			}
		}
			
		
		int tRow, tCol;
		for(i = 0; i < row; ++i)
		{
			for(j = 0; j < col; ++j)
			{
				tRow = i-1;
				tCol = j - 1;
				if(tRow >= 0 && tCol >= 0 && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
				
				tRow = i-1;
				tCol = j;
				if(tRow >= 0 && tCol >= 0 && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
				
				tRow = i-1;
				tCol = j + 1;
				if(tRow >= 0 && tCol < col && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
				
				//middle
				tRow = i;
				tCol = j - 1;
				if(tRow >= 0 && tCol >= 0 && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
				
				tRow = i;
				tCol = j + 1;
				if(tRow >= 0 && tCol < col && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
				
				//bottom
				tRow = i+1;
				tCol = j - 1;
				if(tRow < row && tCol >= 0 && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
				
				tRow = i+1;
				tCol = j;
				if(tRow < row && tCol >= 0 && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
				
				tRow = i+1;
				tCol = j+1;
				if(tRow < row && tCol < col && grid[tRow][tCol] == MINE && grid[i][j] != MINE)
				{
					grid[i][j] = grid[i][j] + 1;
				}
			}
		}
	}
	
	static Point FindMaxMine(int[][] grid)
	{
		int i, j;
		
		int row = grid.length;
		int col = grid[0].length;
		
		int max = -1;
		Point maxPoint = new Point();
		
		for(i = 0; i < row; ++i)
		{
			for(j = 0; j < col; ++j)
			{
				if(grid[i][j] > max && grid[i][j] != MINE)
				{
					max= grid[i][j];
					maxPoint.x = i;
					maxPoint.y = j;
				}
			}
		}
		
		return maxPoint;
	}
	
	static Point FindMin(int[][] adjGrid, int[][] mineGrid)
	{
		int i, j;
		
		int row = adjGrid.length;
		int col = adjGrid[0].length;
		
		int min = 1000;
		Point minPoint = new Point();
		
		int mineMax = -1;
		
		
		for(i = 0; i < row; ++i)
		{
			for(j = 0; j < col; ++j)
			{
				if(adjGrid[i][j] < min && adjGrid[i][j] != MINE)
				{
					if(mineGrid[i][j] > mineMax && mineGrid[i][j] != MINE)
					{
						mineMax = mineGrid[i][j];
						
						min = adjGrid[i][j];
						minPoint.x = i;
						minPoint.y = j;
					}
				}
			}
		}
		
		return minPoint;
	}
	
	static void UpdateAdjacentGrid(int[][] grid)
	{
		int i, j;
		int neighbours;
		int row = grid.length;
		int col = grid[0].length;
		
		//reset except for mines
		for(i = 0; i < row; ++i)
		{
			for(j = 0; j < col; ++j)
			{
				if(grid[i][j] != MINE)
				{
					grid[i][j] = 0;
				}
			}
		}
		
		
		for(i = 0; i < row; ++i)
		{
			for(j = 0; j < col; ++j)
			{
				if(grid[i][j] == MINE)
				{
					continue;
				}
				
				neighbours = 0;
				
				neighbours += (i - 1 >= 0 && j - 1 >= 0 && grid[i-1][j-1] != MINE) ? 1 : 0;
				neighbours += (i - 1 >= 0 && j >= 0 && grid[i-1][j] != MINE) ? 1 : 0;
				neighbours += (i - 1 >= 0 && j + 1 < col && grid[i-1][j+1] != MINE) ? 1 : 0;
				neighbours += (i >= 0 && j - 1 >= 0 && grid[i][j-1] != MINE) ? 1 : 0;
				neighbours += (i >= 0 && j + 1 < col && grid[i][j+1] != MINE) ? 1 : 0;
				neighbours += (i + 1 < row && j - 1 >= 0 && grid[i+1][j-1] != MINE) ? 1 : 0;
				neighbours += (i + 1 < row && j >= 0 && grid[i+1][j] != MINE) ? 1 : 0;
				neighbours += (i + 1 < row && j + 1 < col && grid[i+1][j+1] != MINE) ? 1 : 0;
				
				grid[i][j] = neighbours;
			}
		}
	}
	
	static void ResetGrid(int[][] grid)
	{
		int i,j;
		
		for(i = 0; i < grid.length; ++i)
		{
			for(j = 0; j < grid[i].length; ++j)
			{
				grid[i][j] = 0;
			}
		}
	}
	
	static String PrintGrid(int[][] grid)
	{
		int i,j;
		
		String strGrid = "\n";
		
		boolean zero = false;
		for(i = 0; i < grid.length; ++i)
		{
			for(j = 0; j < grid[i].length; ++j)
			{
				if(grid[i][j] == 0)
				{
					zero = true;
				}
			}
		}
		
		//if there's no zeros, we cant complete this grid
		if(!zero)
		{
			return "\nImpossible";
		}
		
		zero = false;
		
		for(i = 0; i < grid.length; ++i)
		{
			for(j = 0; j < grid[i].length; ++j)
			{
				if(grid[i][j] == MINE)
				{
					strGrid += "*";
				}
				else
				{
					if(!zero && grid[i][j] == 0)
					{
						strGrid += "c";
						zero = true;
					}
					else
					{
						strGrid += ".";
					}
				}
			}
			
			if(i + 1 < grid.length)
			{
				strGrid += "\n";
			}
		}
				
		return strGrid;
	}
}
