package gcj.y2014.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.Writer;

public class MagicTrick {
	
	private static class Square {
		
		private final int[][] cards; // cards[row][col]
		private int selection;
		
		public Square() {
			cards = new int[4][4];
		}
		
		private void setCard(int card, int row, int col) {
			cards[row][col] = card;
		}
		
		private void setSelection(int selection) {
			this.selection = selection;
		}
		
		public int[] getSelectedRow() {
			return cards[selection];
		}
		
		public static Square parseSquare(BufferedReader reader) throws Exception {
			Square square = new Square();
			int selection = Integer.parseInt(reader.readLine()) - 1;
			square.setSelection(selection);
			for (int row = 0; row < 4; row++) {
				String[] tokens = reader.readLine().split(" ");
				for (int col = 0; col < 4; col++) {
					square.setCard(Integer.parseInt(tokens[col]), row, col);
				}
			}
			return square;
		}
	}

	public static void main(String[] args) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader("A-small-attempt0.in"));
		Writer writer = new BufferedWriter(new FileWriter("A-small-attempt0.out"));
		int testCount = Integer.parseInt(reader.readLine());
		for (int t = 0; t < testCount; t++) {
			Square square1 = Square.parseSquare(reader);
			Square square2 = Square.parseSquare(reader);
			int card = findCard(square1, square2);
			String result = formatResult(t, card);
			writer.write(result + "\n");
			System.out.println(result);
		}
		reader.close();
		writer.close();
	}

	/**
	 * 
	 * @return -2 if volunteer cheated, -1 if bad magician, card # otherwise
	 */
	private static int findCard(Square square1, Square square2) {
		int result = -2;
		int[] row1 = square1.getSelectedRow();
		int[] row2 = square2.getSelectedRow();
		for (int i = 0; i < row2.length; i++) {
			int j = 0;
			// find j
			while (j < row1.length) {
				if (row2[i] == row1[j]) {
					break;
				}
				j++;
			}
			// process result
			if (j < row1.length) {
				if (result > 0) {
					result = -1;
					break;
				} else if (result == -2) {
					result = row1[j];
				}
			}
		}
		return result;
	}
	
	private static String formatResult(int t, int card) {
		String cardString = "Volunteer cheated!";
		if (card == -1) {
			cardString = "Bad magician!";
		} else if (card > 0) {
			cardString = "" + card;
		}
		return String.format("Case #%d: %s", t + 1, cardString);
	}
}
