package gcj.y2014.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

public class CookieClickerAlpha {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("B-large.in"));
		Writer writer = new BufferedWriter(new FileWriter("B-large.out"));
		int testCount = Integer.parseInt(reader.readLine());
		for (int t = 0; t < testCount; t++) {
			String[] tokens = reader.readLine().split(" ");
			double c = Double.parseDouble(tokens[0]);
			double f = Double.parseDouble(tokens[1]);
			double x = Double.parseDouble(tokens[2]);
			double time = calculateMinTime(c, f, x);
			String result = formatResult(t, time);
			writer.write(result + "\n");
			System.out.println(result);
		}
		reader.close();
		writer.close();
	}
	
	private static double calculateMinTime(double c, double f, double x) {
		double elapsedTime = 0;
		double prevRate = 2; // cookie production rate
		double prevTimeToX = x / prevRate;
		double prevTime = elapsedTime + prevTimeToX;
		while (true) {
			double timeToFactory = c / prevRate;
			double rate = prevRate + f;
			double timeToX = x / rate;
			double time = elapsedTime + timeToFactory + timeToX;
			if (time < prevTime) {
				prevRate = rate;
				prevTimeToX = timeToX;
				prevTime = time;
				elapsedTime += timeToFactory;
			} else {
				elapsedTime += prevTimeToX;
				break;
			}
		}
		return elapsedTime;
	}
	
	private static String formatResult(int t, double time) {
		return String.format("Case #%d: %.7f", t + 1, time);
	}
}
