import java.io.*;
import java.util.*;

public class A {
	public static boolean DEBUG = true;
	
	public static void main(String[] args) throws Exception{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter pw = new PrintWriter(System.out);
		
		int cases = Integer.parseInt(br.readLine());
		
		for(int t = 1; t <= cases; t++){
			pw.print("Case #" + t + ": ");
			
			StringTokenizer st = getst(br);
			int r = nextInt(st);
			int c = nextInt(st);
			
			char[][] grid = new char[r][c];
			
			for(int i = 0; i < r; i++){
				String line = br.readLine();
				grid[i] = line.toCharArray();
			}
			
			int ans = 0;
			
			for(int i = 0; i < r; i++){
				for(int j = 0; j < c; j++){
					if(grid[i][j] != '.'){
						ans += getAns(grid, i, j);
						if(ans < 0){
							break;
						}
					}
				}
				if(ans < 0){
					break;
				}
			}
			
			if(ans < 0){
				pw.println("IMPOSSIBLE");
			} else {
				pw.println(ans);
			}
		}
		
		br.close();
		pw.close();
	}
	
	public static int getAns(char[][] grid, int r, int c){
		boolean up = false;
		boolean down = false;
		boolean left = false;
		boolean right = false;
		
		for(int i = 0; i < r; i++){
			if(grid[i][c] != '.'){
				up = true;
				break;
			}
		}
		
		for(int i = r+1; i < grid.length; i++){
			if(grid[i][c] != '.'){
				down = true;
				break;
			}
		}
		
		for(int i = 0; i < c; i++){
			if(grid[r][i] != '.'){
				left = true;
				break;
			}
		}
		
		for(int i = c+1; i < grid[0].length; i++){
			if(grid[r][i] != '.'){
				right = true;
				break;
			}
		}
		
		if((grid[r][c] == '>' && right) || (grid[r][c] == '^' && up) || (grid[r][c] == 'v' && down) || (grid[r][c] == '<' && left)){
			return 0;
		}
		
		if(up || down || left || right){
			return 1;
		}
		
		return -999999;
	}
	
	public static void debug(Object o){
		if(DEBUG){
			System.out.println("~" + o);
		}
	}
	
	public static StringTokenizer getst(BufferedReader br) throws Exception{
		return new StringTokenizer(br.readLine(), " ");
	}
	
	public static int nextInt(BufferedReader br) throws Exception{
		return Integer.parseInt(br.readLine());
	}
	
	public static int nextInt(StringTokenizer st) throws Exception{
		return Integer.parseInt(st.nextToken());
	}
}