import java.io.*;
import java.util.*;

public class B {
	public static boolean DEBUG = false;

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter pw = new PrintWriter(System.out);
		StringTokenizer st;

		int cases = nextInt(br);

		for (int t = 1; t <= cases; t++) {
			st = getst(br);
			int c = nextInt(st);
			int j = nextInt(st);
			int n = c+j;

			Act[] acts = new Act[n];

			for (int i = 0; i < n; i++) {
				st = getst(br);
				acts[i] = new Act(nextInt(st), nextInt(st), i < c);
			}

			Arrays.sort(acts);
			int ans = 0;

			if (c == 0 && j == 0 || c == 1 && j == 0 || c == 0 && j == 1) {
				ans = 2;
			} else if (c == 2 && j == 0 || c == 0 && j == 2) {
				int split1 = (1440 + acts[1].s - acts[0].s - acts[0].d) % 1440;
				int split2 = (1440 + acts[0].s - acts[1].s - acts[1].d) % 1440;

				debug(split1, split2);

				if (split1 >= 720 || split2 >= 720) {
					ans = 2;
				} else {
					ans = 4;
				}
			} else if (c == 1 && j == 1) {
				ans = 2;
			}

			// for (int i = 0; i < n; i++) {
			// 	if (acts[i].p != acts[(i+1)%n].p) {
			// 		ans++;
			// 	}
			// }

			// int a = get(acts);

			// for (int i = 0; i < c + j; i++) {
			// 	acts[i].p = !acts[i].p;
			// }

			// int b = get(acts);

			// if (a < 720 || b < 720) {
			// 	ans += 2;
			// }

			// debug(a, b);

			pw.println("Case #" + t + ": " + ans);
		}

		br.close();
		pw.close();
	}

	public static int get(Act[] acts) {
		int out = 0;
		int n = acts.length;

		for (int i = 0; i < n; i++) {
			if (acts[i].p) {
				out += acts[i].d;
			}
			if (acts[i].p || acts[(i+1)%n].p) {
				out += (acts[(i+1)%n].s - acts[i].s - acts[i].d + 1440) % 1440;
			}
		}

		return out;
	}

	static class Act implements Comparable<Act> {
		int s;
		int d;
		boolean p;

		public Act(int ms, int me, boolean mp) {
			s = ms;
			d = (1440 + me - ms) % 1440;
			p = mp;
		}

		public int compareTo(Act o) {
			return s - o.s;
		}
	}

	// -----------------------------------------------------------------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------------

	public static void debug(Object obj, String end) {
		if (DEBUG) {
			if (obj instanceof boolean[]) {
				System.out.print(Arrays.toString((boolean[])obj));
			} else if (obj instanceof byte[]) {
				System.out.print(Arrays.toString((byte[])obj));
			} else if (obj instanceof short[]) {
				System.out.print(Arrays.toString((short[])obj));
			} else if (obj instanceof char[]) {
				System.out.print(Arrays.toString((char[])obj));
			} else if (obj instanceof int[]) {
				System.out.print(Arrays.toString((int[])obj));
			} else if (obj instanceof long[]) {
				System.out.print(Arrays.toString((long[])obj));
			} else if (obj instanceof float[]) {
				System.out.print(Arrays.toString((float[])obj));
			} else if (obj instanceof double[]) {
				System.out.print(Arrays.toString((double[])obj));
			} else if(obj instanceof Object[]) {
				debug((Object[])obj);
			} else {
				System.out.print(obj);
			}
			System.out.print(end);
		}
	}

	public static void debug(Object... args) {
		if (DEBUG) {
			System.out.print("\t");
			for (int i = 0; i < args.length; i++) {
				debug(args[i], " ");
			}
			System.out.println();
		}
	}

	public static void debug(Suspended sus) {
		if (DEBUG) {
			debug(sus.eval());
		}
	}

	public static void debugGrid(int[][] grid) {
		if (DEBUG) {
			for (int i = 0; i < grid.length; i++) {
				System.out.print("\t");
				for (int j = 0; j < grid[0].length; j++) {
					System.out.print(String.format("%3d ", grid[i][j]));
				}
				System.out.println();
			}
		}
	}

	public static StringTokenizer getst(BufferedReader br) throws Exception {
		return new StringTokenizer(br.readLine(), " ");
	}

	public static int nextInt(BufferedReader br) throws Exception {
		return Integer.parseInt(br.readLine());
	}

	public static int nextInt(StringTokenizer st) throws Exception {
		return Integer.parseInt(st.nextToken());
	}

	public static long nextLong(BufferedReader br) throws Exception {
		return Long.parseLong(br.readLine());
	}

	public static long nextLong(StringTokenizer st) throws Exception {
		return Long.parseLong(st.nextToken());
	}

	public static double nextDouble(BufferedReader br) throws Exception {
		return Double.parseDouble(br.readLine());
	}

	public static double nextDouble(StringTokenizer st) throws Exception {
		return Double.parseDouble(st.nextToken());
	}
}

interface Suspended {
	public Object eval();
}