import java.io.*;
import java.util.*;

public class C {
	public static boolean DEBUG = true;

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		PrintWriter pw = new PrintWriter(System.out);
		StringTokenizer st;

		int cases = nextInt(br);

		for (int t = 1; t <= cases; t++) {
			st = getst(br);
			long n = nextLong(st);
			long k = nextLong(st);

			PriorityQueue<Long> pq = new PriorityQueue<Long>((Long a, Long b) -> {
				if (a > b) {
					return -1;
				} else if (b > a) {
					return 1;
				} else {
					return 0;
				}
			});

			pq.add(n);

			for (int i = 0; i < k-1; i++) {
				long next = pq.poll();
				// debug(next);
				next--;
				pq.add(next/2);
				pq.add(next - next/2);
			}

			// debug(pq);

			long last = pq.poll();
			last--;

			pw.print("Case #");
			pw.print(t);
			pw.print(": ");
			pw.print(last - last/2);
			pw.print(" ");
			pw.println(last/2);
		}

		br.close();
		pw.close();
	}

	// -----------------------------------------------------------------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------------
	// -----------------------------------------------------------------------------------------------------------------

	public static void debug(Object obj, String end) {
		if (DEBUG) {
			if (obj instanceof boolean[]) {
				System.out.print(Arrays.toString((boolean[])obj));
			} else if (obj instanceof byte[]) {
				System.out.print(Arrays.toString((byte[])obj));
			} else if (obj instanceof short[]) {
				System.out.print(Arrays.toString((short[])obj));
			} else if (obj instanceof char[]) {
				System.out.print(Arrays.toString((char[])obj));
			} else if (obj instanceof int[]) {
				System.out.print(Arrays.toString((int[])obj));
			} else if (obj instanceof long[]) {
				System.out.print(Arrays.toString((long[])obj));
			} else if (obj instanceof float[]) {
				System.out.print(Arrays.toString((float[])obj));
			} else if (obj instanceof double[]) {
				System.out.print(Arrays.toString((double[])obj));
			} else if(obj instanceof Object[]) {
				debug((Object[])obj);
			} else {
				System.out.print(obj);
			}
			System.out.print(end);
		}
	}

	public static void debug(Object... args) {
		if (DEBUG) {
			System.out.print("\t");
			for (int i = 0; i < args.length; i++) {
				debug(args[i], " ");
			}
			System.out.println();
		}
	}

	public static void debug(Suspended sus) {
		if (DEBUG) {
			debug(sus.eval());
		}
	}

	public static void debugGrid(int[][] grid) {
		if (DEBUG) {
			for (int i = 0; i < grid.length; i++) {
				System.out.print("\t");
				for (int j = 0; j < grid[0].length; j++) {
					System.out.print(String.format("%3d ", grid[i][j]));
				}
				System.out.println();
			}
		}
	}

	public static StringTokenizer getst(BufferedReader br) throws Exception {
		return new StringTokenizer(br.readLine(), " ");
	}

	public static int nextInt(BufferedReader br) throws Exception {
		return Integer.parseInt(br.readLine());
	}

	public static int nextInt(StringTokenizer st) throws Exception {
		return Integer.parseInt(st.nextToken());
	}

	public static long nextLong(BufferedReader br) throws Exception {
		return Long.parseLong(br.readLine());
	}

	public static long nextLong(StringTokenizer st) throws Exception {
		return Long.parseLong(st.nextToken());
	}

	public static double nextDouble(BufferedReader br) throws Exception {
		return Double.parseDouble(br.readLine());
	}

	public static double nextDouble(StringTokenizer st) throws Exception {
		return Double.parseDouble(st.nextToken());
	}
}

interface Suspended {
	public Object eval();
}