import java.io.*;
import java.math.*;
import java.util.*;

public class fairsquare{
	public static void main (String [] args) throws IOException{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int t = Integer.parseInt(br.readLine());
		
		String[] input = new String[t];
		
		for(int i = 1; i <= t; i++){
			input[i-1] = br.readLine();
		}
		
		for(int i = 1; i <= t; i++){
			StringTokenizer st = new StringTokenizer(input[i-1]);
			
			BigInteger a = new BigInteger(st.nextToken());
			BigInteger b = new BigInteger(st.nextToken());
			
			BigInteger low = sqrt(a);
			if(low.multiply(low).compareTo(a) < 0){
				low = low.add(BigInteger.ONE);
			}
			BigInteger high = sqrt(b);
			
			long ans = 0;
			
			for(low = low; low.compareTo(high) <= 0; low = low.add(BigInteger.ONE)){
				if(isPalen(low.toString()) && isPalen(low.multiply(low).toString())){
					ans++;
				}
			}
			
			System.out.println("Case #" + i + ": " + ans);
		}
		
		br.close();
	}
	
	public static boolean isPalen(String str){
		if(str.length() <= 1){
			return true;
		}
		if(str.charAt(0) != str.charAt(str.length() - 1)){
			return false;
		}
		if(str.length() == 2){
			return true;
		}
		return isPalen(str.substring(1, str.length() - 2));
	}
	
	//sqrt function for BigIntegers from http://faruk.akgul.org/blog/javas-missing-algorithm-biginteger-sqrt/
	
	public static BigInteger sqrt(BigInteger n) {
  		BigInteger a = BigInteger.ONE;
  		BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
  		while(b.compareTo(a) >= 0) {
    		BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
    		if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
    		else a = mid.add(BigInteger.ONE);
  		}
  		return a.subtract(BigInteger.ONE);
	}
}