package year2014;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class MinesweeperMaster {

	private static final String IMPOSSIBLE = "Impossible";
	private final static String fILE_NAME = "C-small-attempt3";

	private static int[] lineStringToInt(String s) {
		final String[] os = s.split(" ");
		final int[] output = new int[os.length];
		for (int i = 0; i < os.length; i++) {
			output[i] = Integer.parseInt(os[i]);
		}
		return output;
	}

	public static void main(String[] args) throws IOException {
		final PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter(fILE_NAME + ".out")));
		final BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(fILE_NAME + ".in")));

		final int T = Integer.parseInt(reader.readLine());

		for (int i = 1; i <= T; i++) {
			final int[] input = lineStringToInt(reader.readLine());
			writer.println("Case #" + i + ": ");
			solve(input[0], input[1], input[2], writer);
		}

		writer.close();
		reader.close();
	}

	private static void solve(int R, int C, int M, PrintWriter writer) {
		final int total = R*C;
		final int free = total - M;
		if (M == 0) {
			writer.print('c');
			for (int j = 1; j < C; j++) {
				writer.print('.');
			}
			writer.println();
			for (int i = 1; i < R; i++) {
				for (int j = 0; j < C; j++) {
					writer.print('.');
				}
				writer.println();
			}
		} else if (R == 1) {
			if (free < 2) {
				writer.println(IMPOSSIBLE);
			} else {
				writer.print('c');
				for (int i = 1; i < free; i++) {
					writer.print('.');
				}
				for (int i = 0; i < M; i++) {
					writer.print('*');
				}
				writer.println();
			}
		} else if (C == 1) {
			if (free < 2) {
				writer.println(IMPOSSIBLE);
			} else {
				writer.println('c');
				for (int i = 1; i < free; i++) {
					writer.println('.');
				}
				for (int i = 0; i < M; i++) {
					writer.println('*');
				}
			}
		} else {
			if (free < 4) {
				writer.println(IMPOSSIBLE);
			} else {
				final int minSqrt = (int) Math.sqrt(free);
				if (minSqrt >= C) {
					if (free % C == 1) {
						writer.print(IMPOSSIBLE);
					} else {
						writer.print('c');
						for (int i = 1; i < total; i++) {
							if (i % C == 0) {
								writer.println();
							}
							if (i < free) {
								writer.print('.');
							} else {
								writer.print('*');
							}
						}
					}
				} else if (minSqrt >= R) {
					if (free % R == 1) {
						writer.print(IMPOSSIBLE);
					} else {
						writer.print('c');
						for (int i = 1; i < total; i++) {
							if (i % C == 0) {
								writer.println();
							}
							int x = i % C;
							int l = free / R;
							if (x < l) {
								writer.print('.');
							} else if (x == l) {
								if (i / C < free % R) {
									writer.print('.');
								} else {
									writer.print('*');
								}
							} else {
								writer.print('*');
							}
						}
					}
				} else {
					int rem = free - (minSqrt*minSqrt);
					if (rem == 1) {
						writer.print(IMPOSSIBLE);
					} else if (minSqrt == 2 && rem == 3) {
						writer.print(IMPOSSIBLE);
					} else {
						writer.print('c');
						for (int i = 1; i < total; i++) {
							if (i % C == 0) {
								writer.println();
							}
							int x = i % C;
							int y = i / C;
							if (y < minSqrt) {
								if (x < minSqrt) {
									writer.print('.');
								} else if (x == minSqrt) {
									if (rem > 0 && !(rem == 2 && y == minSqrt-1)) {
										writer.print('.');
										--rem;
									} else {
										writer.print('*');
									}
								} else {
									writer.print('*');
								}
							} else if (y == minSqrt) {
								if (rem > 0) {
									writer.print('.');
									--rem;
								} else {
									writer.print('*');
								}
							} else {
								writer.print('*');
							}
						}
					}
				}
				writer.println();
			}
		}
		
		
	}

}
