package year2014;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;

public class MagicTrick {

	private final static String fILE_NAME = "A-small-attempt1";

	private static String[] readnext(int n, BufferedReader reader) throws IOException {
		final String[] output = new String[n];
		for (int i = 0; i < n; i++) {
			output[i] = reader.readLine();
		}
		return output;
	}

	private static int[][] tabStringToInt(String[] strings) {
		int[][] output = new int[strings.length][];
		for (int i = 0; i < strings.length; i++) {
			output[i] = lineStringToInt(strings[i]);
		}
		return output;
	}

	private static int[] lineStringToInt(String s) {
		final String[] os = s.split(" ");
		final int[] output = new int[os.length];
		for (int i = 0; i < os.length; i++) {
			output[i] = Integer.parseInt(os[i]);
		}
		return output;
	}

	public static void main(String[] args) throws IOException {
		final PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter(fILE_NAME + ".out")));
		final BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(fILE_NAME + ".in")));

		final int T = Integer.parseInt(reader.readLine());

		for (int i = 0; i < T; i++) {
			final int answer1 = Integer.parseInt(reader.readLine());
			final int[][] cards1 = tabStringToInt(readnext(4, reader));
			final int answer2 = Integer.parseInt(reader.readLine());
			final int[][] cards2 = tabStringToInt(readnext(4, reader));
			final String answer = compute(answer1, cards1, answer2, cards2);
			writer.println("Case #" + (i+1) + ": " +answer);
		}

		writer.close();
		reader.close();
	}

	private static String compute(int answer1, int[][] cards1, int answer2, int[][] cards2) {
		final int[] possible1 = cards1[answer1-1];
		final int[] possible2 = cards2[answer2-1];
		int count = 0;
		int answer = 0;
		for (int i = 0; i < possible1.length; i++) {
			for (int j = 0; j < possible2.length; j++) {
				if (possible1[i] == possible2[j]) {
					answer = possible1[i];
					++count;
				}
			}
		}
		if (count == 0) {
			return "Volunteer cheated!";
		} else if (count == 1) {
			return "" + answer;
		} else {
			return "Bad magician!";
		}
	}

	private static void printIntLine(int[] input) {
		for (int i = 0; i < input.length; i++) {
			System.out.print(input[i] + " ");
		}
		System.out.println();
	}

}
