import java.io.*;
import java.util.*;
public class MinesweeperMaster {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner input = new Scanner(new File("C-small-attempt4.in"));
		PrintStream output = new PrintStream(new File("output.txt"));
		int numberOfCases = input.nextInt();
		for (int i = 1; i <= numberOfCases; i++) {
			output.println("Case #" + i + ": ");
			int rows = input.nextInt();
			int columns = input.nextInt();
			int mines = input.nextInt();
			
			boolean possible = isItPossible(rows, columns, mines);
			
			if (possible) {
				String[][] board = new String[rows][columns];
				fillboard(board, rows, columns, mines);
				print(board, output);
			} else {
				output.println("Impossible");
			}
		}
		input.close();
		output.close();
	}
	public static boolean isItPossible(int rows, int columns, int mines) {
		if (rows * columns - 1 == mines) {
			return true;
		}
		if (rows >= 3 && columns >= 3) {
			if (mines <= (rows - 2) * (columns - 2)) {
				return true;
			}
			if (mines <= (rows + columns - 4) * 2 + (rows - 2) * (columns - 2) && (mines - (rows - 2) * (columns - 2)) % 2 == 0) {
				return true;
			}
		}
		if (rows == 1 || columns == 1) {
			return mines <= columns - 1 || mines <= rows - 1;
		}
		if (rows == 2 || columns == 2) { 
			return mines % 2 == 0 && mines <= (rows * columns - 4);
		}
		return false;
	}
	public static void print(String[][] array, PrintStream output) {
		for (int rows = 0; rows < array.length; rows++) {
			for (int columns = 0; columns < array[0].length; columns++) {
				output.print(array[rows][columns] + " ");
			}
			output.println();
		}
	}
	public static void fillboard(String[][] array, int rows, int columns, int mines) {
		int mineCounter = mines;
		boolean done = false;
		if (rows * columns - 1 == mines && !done) {
			for (int row = 0; row < rows; row++) {
				for (int column = 0; column < columns; column++) {
					if (row == 0 && column == 0) {
						array[row][column] = "c";
					} else {
						array[row][column] = "*";
					}
				}
			}
			done = true;
		}
		if (rows >= 3 && columns >= 3  && !done) {
			if (mines <= (rows - 2) * (columns - 2) && !done) {
				for (int row = 0; row < rows; row++) {
					for (int column = 0; column < columns; column++) {
						if (row < rows - 2 && column < columns - 2 && mineCounter > 0) {
							array[row][column] = "*";
							mineCounter--;
						} else {
							array[row][column] = ".";
						}
					}
				}
				array[rows - 1][columns - 1] = "c";
				done = true;
			}
			if (mines <= (rows + columns - 4) * 2 + (rows - 2) * (columns - 2) && (mines - (rows - 2) * (columns - 2)) % 2 == 0 && !done) {
				for (int row = 0; row < rows; row++) {
					for (int column = 0; column < columns; column++) {
						if (row < rows - 2 && column < columns - 2 && mineCounter > 0) {
							array[row][column] = "*";
							mineCounter--;
						} else {
							array[row][column] = ".";
						}
					}
				}
				int currentRow = 0;
				while (mineCounter > 0 && currentRow < rows - 2) {
					array[currentRow][array[0].length - 2] = "*";
					array[currentRow][array[0].length - 1] = "*";
					mineCounter = mineCounter - 2;
					currentRow++;
				}
				int currentColumn = 0;
				while (mineCounter > 0 && currentColumn < columns - 2) {
					array[array.length - 2][currentColumn] = "*";
					array[array.length - 1][currentColumn] = "*";
					mineCounter = mineCounter - 2;
					currentColumn++;
				}
				array[rows - 1][columns - 1] = "c";
				done = true;
			}
		}
		if (((rows == 1 && mines <= columns - 1) || (columns == 1 && mines <= rows - 1)) && !done) {
			for (int row = 0; row < rows; row++) {
				for (int column = 0; column < columns; column++) {
					if ((Math.max(rows, columns) - 2 > row || Math.max(rows, columns) - 2 > column) && mineCounter > 0) {
						array[row][column] = "*";
						mineCounter--;
					} else {
						array[row][column] = ".";
					}
				}
			}
			array[rows - 1][columns - 1] = "c";
			done = true;
		}
		if ((rows == 2 || columns == 2) && mines % 2 == 0 && mines <= (rows * columns - 4) && !done) { 
			boolean isColumnBiggest;
			if (rows > columns) {
				isColumnBiggest = false;
			} else {
				isColumnBiggest = true;
			}
			for (int side = 0; side < Math.max(rows, columns); side++) {
				if (isColumnBiggest && mineCounter > 0) {
					array[0][side] = "*";
					array[1][side] = "*";
					mineCounter = mineCounter - 2;
				} else  if (isColumnBiggest) {
					array[0][side] = ".";
					array[1][side] = ".";
				}
				if (!isColumnBiggest && mineCounter > 0) {
					array[side][0] = "*";
					array[side][1] = "*";
					mineCounter = mineCounter - 2;
				} else if (!isColumnBiggest) {
					array[side][0] = ".";
					array[side][1] = ".";
				}
			}
			array[rows - 1][columns - 1] = "c";
			done = true;
		}
	}
}
