import java.lang.Math;
import java.math.BigInteger;
import java.util.BitSet;
import java.util.Scanner;
import java.util.Vector;

class Main {
  public BigInteger negative_one    = new BigInteger("-1");
  public BigInteger zero            = new BigInteger("0");
  public BigInteger two             = new BigInteger("2");
  
  public BigInteger toBaseTen(BigInteger number, String base) {
    BigInteger ans = new BigInteger("0");
    if (base.length() > 1) {
      ans = ans.add(number);
      return ans;
    }
    
    String snumber = number.toString();
    BigInteger bibase = new BigInteger(base.toString());
    BigInteger j = new BigInteger("1");
    BigInteger digit;
    for (int i = snumber.length() - 1; i > -1; --i) {
      digit = new BigInteger(snumber.substring(i, i + 1));
      ans = ans.add(j.multiply(digit));
      j = j.multiply(bibase);
    }
    return ans;
  }
  
  public BigInteger tenToTwo(BigInteger number) {
    BigInteger snumber = new BigInteger(number.toString());
    BigInteger base    = new BigInteger("10");
    BigInteger j       = new BigInteger("1");
    BigInteger ans     = new BigInteger("0");
    while (snumber.compareTo(zero) > 0) {
      if (snumber.mod(two).intValue() == 1) {
        ans = ans.add(j);
      }
      snumber = snumber.divide(two);
      j = j.multiply(base);
    }
    return ans;
  }
  
  public Vector<Long> divisor = new Vector<Long>();
  public Vector<BigInteger> primes = new Vector<BigInteger>();
  
  public void sieve() {
    for (int i = 0; i < 10000001; ++i) divisor.add(0L);
    divisor.set(0, new Long(-1));
    divisor.set(1, new Long(-1));
    for (long i = 2; i < 10000001L; ++i) {
      int idx = (int) i;
      if (divisor.get(idx).longValue() != 0L) continue;
      
      primes.add(new BigInteger(Long.toString(i)));
      for (long j = i * i; j < 10000001L; j += i) {
        int idxj = (int) j;
        
        divisor.set(idxj, i);
      }
    }
  }
  
  public BigInteger isPrime(BigInteger num) {
    for (int i = 0; i < primes.size(); ++i) {
      if (primes.get(i).multiply(primes.get(i)).compareTo(num) > 0) return negative_one;
      if (num.mod(primes.get(i)).longValue() == 0L) return primes.get(i);
      
    }
    return negative_one;
  }
  
  public static void main(String[] args) {

    Scanner in = new Scanner(System.in);
    
    Main m = new Main();
    System.out.println("Case #1:");
    //System.out.println(m.tenToTwo(new BigInteger("0")));
    
    //int t, n, j;
    //t = in.nextInt();
    //n = in.nextInt();
    //j = in.nextInt();
    m.sieve();
    //BigInteger ini = new BigInteger("100001");
    BigInteger ini = new BigInteger("1000000000000001");
    BigInteger cand;
    BigInteger candDiv;
    int qtd = 0;
    int iter = 1000000001;
    int count = 0;
    Vector<BigInteger> vec = new Vector<BigInteger>();
    while (--iter > 0) {
      ++count;
      if (qtd == 50) break;
      vec.clear();
      for (int i = 2; i < 11; ++i) {
        cand = m.toBaseTen(ini, Integer.toString(i));
        candDiv = m.isPrime(cand);
        if (candDiv.compareTo(m.negative_one) > 0) {
          vec.add(candDiv);
        }
        else {
          vec.clear();
          break;
        }
      }
      if (!vec.isEmpty()) {
        ++qtd;
        System.out.print(ini.toString());
        for (int i = 0; i < vec.size(); ++i) {
          System.out.print(" " + vec.get(i).toString());
        }
        System.out.println();
      }
      cand = m.toBaseTen(ini, m.two.toString());
      cand = cand.add(m.two);
      ini = m.tenToTwo(cand);
    }
    //System.out.println(count + "!!!!!!");
    //Integer.toString(Integer.parseInt(number, base1), base2);
  }
}
