import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class C2 {

	/*
3
3 1
2 3
2 4
4 4
-1 1 -1
-1 -1 1
-1 -1 -1
1 3
4 1
13 10
1 1000
10 8
5 5
-1 1 -1 -1
-1 -1 1 -1
-1 -1 -1 10
-1 -1 -1 -1
1 4
4 3
30 60
10 1000
12 5
20 1
-1 10 -1 31
10 -1 10 -1
-1 -1 -1 10
15 6 -1 -1
2 4
3 1
3 2
	 */

	public static List<Horse> horses;
	public static int[] distanceToNextCity;
	private static Map<Integer, Double> mem;

	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int T = in.nextInt();
		for (int i = 0; i < T; i++) {
			mem = new HashMap<Integer, Double>();
			int N = in.nextInt();
			in.nextInt(); //discard Q
			horses = new ArrayList<Horse>();
			for (int j = 0; j < N; j++) {
				Horse horse = new C2().new Horse();
				horse.distance = in.nextInt();
				horse.speed = in.nextInt();
				horses.add(horse);
			}
			in.nextLine();
			distanceToNextCity = new int[N];
			for (int j = 0; j < N; j++) {
				for (int k = 0; k < N; k++) {
					int val = in.nextInt();
					if (val != -1) {
						distanceToNextCity[j] = val;
					}
				}
			}
			in.nextInt(); // discard U
			in.nextInt(); // discard V
			System.out.print("Case #" + (i+1) + ": ");
			System.out.printf("%f\n", solve(0));
		}
		in.close();
	}

	public static double solve(int horse) {
		if (mem.containsKey(horse)) {
			return mem.get(horse);
		}
		if (horse == horses.size() - 1) {
			mem.put(horse, (double)0);
			return 0;
		}
		Horse currentHorse = horses.get(horse);
		double bestTime = Double.MAX_VALUE;
		int totalDistance = 0;
		for (int i = horse + 1; i < distanceToNextCity.length; i++) {
			totalDistance = totalDistance + distanceToNextCity[i-1];
			if (totalDistance > currentHorse.distance) {
				break;
			}
			double timeToI = ((double)totalDistance) / ((double)currentHorse.speed);
			double timeChangingHere = timeToI + solve(i);
			bestTime = Math.min(bestTime, timeChangingHere);
		}
		mem.put(horse, bestTime);
		return bestTime;
	}

	class Horse {
		public int distance;
		public int speed;
		public String toString() {
			return distance + " " + speed;
		}
	}

}
