import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class B {

	public static final int M = 1000000007;
	
	public static void main(String[] args) {
			Scanner in = new Scanner(System.in);
			int T = in.nextInt();
			for (int i = 1; i <= T; i++) {
				int N = in.nextInt(); in.nextLine();
				List<String> cars = new LinkedList<String>();
				String[] carsInput = in.nextLine().split(" ");
				for (int j = 0; j < N; j++) {
					String car = carsInput[j];
					car = trim(car);
					cars.add(car);
				}
				long result = solve(cars);
				
				System.out.println("Case #" + i + ": " + result);
			}
			in.close();
	}

	private static String trim(String car) {
		String result = "";
		char lastChar = 'A';
		for (int i = 0; i < car.length(); i++) {
			if (car.charAt(i) != lastChar) {
				result += car.charAt(i);
				lastChar = car.charAt(i);
			}
		}
		return result;
	}

	private static long solve(List<String> cars) {
		Collections.sort(cars);
		long result = 1;
		
		//cars without repetitions
		List<String> newCars = new LinkedList<String>();
		String lastCar = "";
		int repCount = 1;
		for (String car : cars) {
			if (!car.equals(lastCar)) {
				newCars.add(car);
				lastCar = car;
				repCount = 1;
			} else {
				repCount++;
				result *= repCount;
				result %= M;
			}
		}
		cars = newCars;
		
		//car contains "inaccessible" letter that appears in other car, it's impossible
		for (String car : cars) {
			for (int i = 1; i < car.length() - 1; i++) {
				char inaccessible = car.charAt(i);
				for (int j = 0; j < cars.size(); j++) {
					String car2 = cars.get(j);
					if (!car.equals(car2)) {
						if (car2.indexOf(inaccessible) != -1) {
							return 0;
						}
					}
				}
			}
		}
		
		newCars = new LinkedList<String>();
		//reduce each car to its first and last letter
		for (String car : cars) {
			newCars.add(trim(car.charAt(0) + "" + car.charAt(car.length() - 1)));
		}
		cars = newCars;
		
		Collections.sort(cars);
		
		//cars without repetitions
		newCars = new LinkedList<String>();
		lastCar = "";
		repCount = 1;
		for (String car : cars) {
			if (!car.equals(lastCar)) {
				newCars.add(car);
				lastCar = car;
				repCount = 1;
			} else {
				repCount++;
				result *= repCount;
				result %= M;
			}
		}
		cars = newCars;
		
		//System.out.println(newCars);
		
		Map<String, String> xPrecedesY = new HashMap<String, String>();
		
		for (int i = 0; i < cars.size(); i++) {
			String car = cars.get(i);
			for (int j = 0; j < cars.size(); j++) {
				if (i != j) {
					String car2 = cars.get(j);
					if (car.charAt(car.length() - 1) == car2.charAt(0)) {
						//there was already a restriction on this car
						if (xPrecedesY.containsKey(car)) {
							String origin = car;
							String oldDest = xPrecedesY.get(car);
							String newDest = car2;
							if (canPrecede(oldDest, newDest)) {
								continue;
							} else if (canPrecede(newDest, oldDest)) {
								xPrecedesY.put(car, newDest);
							} else {
								return 0;
							}
						} else {
							xPrecedesY.put(car, car2);
						}
					}
				}
			}
		}
		
		//System.out.println(cars);
		//System.out.println(xPrecedesY);
		
		//calculate number of groups (and its factorial)
		int groups = 0;
		while (!cars.isEmpty()) {
			groups++;
			String car = cars.get(0);
			cars.remove(car);
			while (xPrecedesY.containsKey(car)) {
				car = xPrecedesY.get(car);
				if (!cars.contains(car)) {
					//we found a loop
					return 0;
				}
				cars.remove(car);
			}
		}
		
		//System.out.println(groups);
		
		for (int i = 2; i <= groups; i++) {
			result *= i;
			result %= M;
		}

		return result;
	}

	private static boolean canPrecede(String car, String car2) {
		return car.charAt(car.length() - 1) == car2.charAt(0);
	}

}
