/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam2016r1b;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 *
 * @author Ben
 */
public class ProblemA {
    
    static String [] intToStringIndex = {
        "ZERO",
        "ONE",
        "TWO",
        "THREE",
        "FOUR",
        "FIVE",
        "SIX",
        "SEVEN",
        "EIGHT",
        "NINE"};
    
    private static final Map<String, Integer> stringToIntMap;
    static
    {
        stringToIntMap = new HashMap<String, Integer>();
        stringToIntMap.put("ZERO", 0);
        stringToIntMap.put("ONE", 1);
        stringToIntMap.put("TWO", 2);
        stringToIntMap.put("THREE", 3);
        stringToIntMap.put("FOUR", 4);
        stringToIntMap.put("FIVE", 5);
        stringToIntMap.put("SIX", 6);
        stringToIntMap.put("SEVEN", 7);
        stringToIntMap.put("EIGHT", 8);
        stringToIntMap.put("NINE", 9);
    }
    
    public static boolean done(Map<String, Integer> s) {
        for (Integer i : s.values()) {
            if (i != 0) {
                return false;
            }
        }
        return true;
    }
    
    public static Map<String, Integer> stringToMap(String s) {
        HashMap<String, Integer> searchMap = new HashMap<>();
        for (int i = 0; i < s.length(); i++) {
            String temp = s.substring(i, i+1);
            if (searchMap.containsKey(temp)) {
                searchMap.put(temp, searchMap.get(temp) + 1);
            } else {
                searchMap.put(temp, 1);
            }
        }
        return searchMap;
    }
    
    public static boolean contains(Map<String, Integer> s, Map<String, Integer> search) {
        for (Map.Entry<String, Integer> entry : search.entrySet()) {
            String key = entry.getKey();
            if (!s.containsKey(key) || s.get(key) < entry.getValue()) {
                return false;
            } 
        }
        return true;
    }
    
    public static void remove(Map<String, Integer> from, Map<String, Integer> remove) {
        for (Map.Entry<String,Integer> entry : remove.entrySet()) {
            String key = entry.getKey();
            Integer value = entry.getValue();
            from.put(key, from.get(key) - value);
        }
    }
    
    public static void add(Map<String, Integer> to, Map<String, Integer> add) {
        for (Map.Entry<String,Integer> entry : add.entrySet()) {
            String key = entry.getKey();
            Integer value = entry.getValue();
            if (to.containsKey(key)) {
                to.put(key, to.get(key) + value);
            } else {
                to.put(key, value);
            }
        }
    }
    
    public static boolean find(int next, Map<String, Integer> s, ArrayList<Integer> found) {
        if (done(s)) {
            return true;
        }
        
        for (int i = next; i <= 9; i++) {
            Map<String, Integer> map = stringToMap(intToStringIndex[i]);
            if (contains(s, map)) {
                found.add(i);
                remove(s, map);
                if (find(i, s, found)) {
                    return true;
                }
                found.remove(found.size()-1);
                add(s, map);
            }
        }
        return false;
    }
    
    public static void run() throws IOException, Exception {
        try(
            Scanner sc = new Scanner(new File("A-small-attempt0.in"));
            PrintWriter pw = new PrintWriter(new File("A-small-attempt0.out")))
        {
            int nTestCases = sc.nextInt();
            for (int testCase = 1; testCase <= nTestCases; testCase++) {
                Map<String, Integer> m = stringToMap(sc.next());
                ArrayList<Integer> found = new ArrayList<>();
                boolean success = find(0, m, found);
                if (!success) {
                    throw new Exception("No solution found");
                }
                Collections.sort(found);
                pw.format("Case #%d: ", testCase);
                for (int i = 0; i < found.size(); i++) {
                    pw.format("%s", Integer.toString(found.get(i)));
                }
                pw.format("\n");
            }
        }
    }
}
