/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam2016r1b;

import static codejam2016r1b.ProblemA.find;
import static codejam2016r1b.ProblemA.stringToMap;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Map;
import java.util.Scanner;

/**
 *
 * @author Ben
 */
public class ProblemB {
    static int candidate_c = 0;
    static int candidate_j = 0;
    
    public static int[] intToArray(int n, int length){
        int[] digits = new int [length];
        int i = length - 1;
        while (n > 0) {
            int r = n % 10;
            digits[i--] = r;
            n /= 10;
        }
        return digits;
    }
    
    public static boolean isValid(char[] known, int[] digits) {
        for (int i = 0; i < known.length; i++) {
            if (known[i] != '?') {
                char d = (char)((int)'0' + digits[i]);
                if (known[i] != d) {
                    return false;
                }
            }
        }
        return true;
    }
    
    public static void solve(char[] known_c, char[] known_j) {
        int minDiff = Integer.MAX_VALUE;
        int nDigits = known_c.length;
        for (int c = 0; c < 1000; c++) {
            if (c >= Math.pow(10, nDigits)) {
                continue;
            }
            int[] digits_c = intToArray(c, nDigits);
            if (!isValid(known_c, digits_c)) {
                continue;
            }
            
            for (int j = 0; j < 1000; j++) {
                if (j >= Math.pow(10, nDigits)) {
                    continue;
                }
                int[] digits_j = intToArray(j, nDigits);
                if (!isValid(known_j, digits_j)) {
                    continue;
                }
                
                if (Math.abs(c - j) <=  minDiff) {
                    if (Math.abs(c - j) < minDiff) {
                        candidate_c = c;
                        candidate_j = j;
                        minDiff = Math.abs(c - j);
                    }
                    else if (c < candidate_c) {
                        candidate_c = c;
                        candidate_j = j;
                        minDiff = Math.abs(c - j);
                    }
                    else if (c == candidate_c) {
                        if (j < candidate_j) {
                            candidate_c = c;
                            candidate_j = j;
                            minDiff = Math.abs(c - j);
                        }
                    }
                }
            }
        }
    }
    
    public static String intToString(int i, int nDigits) {
        String s = Integer.toString(i);
        while (s.length() < nDigits) {
            s = "0" + s;
        }
        return s;
    }
    
    public static void run() throws IOException, Exception {
        try(
            Scanner sc = new Scanner(new File("B-small-attempt0.in"));
            PrintWriter pw = new PrintWriter(new File("B-small-attempt0.out")))
        {
            int nTestCases = sc.nextInt();
            for (int testCase = 1; testCase <= nTestCases; testCase++) {
                candidate_c = Integer.MAX_VALUE;
                candidate_j = Integer.MAX_VALUE;
                
                String c = sc.next();
                String j = sc.next();
                char[] known_c = c.toCharArray();
                char[] known_j = j.toCharArray();
                solve(known_c, known_j);
                pw.format("Case #%d: %s %s\n", testCase, intToString(candidate_c, c.length()), intToString(candidate_j, j.length()));
            }
        }
    }
}
