/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam2014;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

/**
 *
 * @author Ben
 */
public class DeceitfulWar {
    
    static int maxScore = 0;
    static int lIdx, hIdx;
    
    public static int search(ArrayList<Double> M, double search)
    {
        for(int i = 0; i < M.size(); i++){
            if(search < M.get(i))
                return i;
        }
        return M.size();
    }
    
    public static void solve(ArrayList<Double> M_n, ArrayList<Double> M_k, int N,
            PrintWriter pw) throws Exception
    {
        Collections.sort(M_n);
        Collections.sort(M_k);
        ArrayList<Double> M_k_copy = (ArrayList<Double>)M_k.clone();
        
        int nPointsDect = 0, nPointsFair = 0;
        
        /**
         * Playing deceitfully.
         */
        for(double m_n : M_n)
        {
            if(M_k_copy.size() == 1)
                break;
            
            int i = search(M_k_copy, m_n);
            if(i == M_k_copy.size()){
                //ken can't win - will play lightest block
                M_k_copy.remove(0);
                nPointsDect++;
            }
            else{
                //can't win - make ken waste high card
                M_k_copy.remove(M_k_copy.size()-1);
            }
        }
        if(M_n.get(M_n.size()-1) > M_k_copy.get(0))
            nPointsDect++;
        
        /**
         * Playing fair.
         */
        for(double m_n : M_n)
        {
            if(M_k.size() == 1)
                break;
            
            int i = search(M_k, m_n);
            if(i == M_k.size()){
                //ken can't win - will play lightest block
                M_k.remove(0);
                nPointsFair++;
                
            }
            else{
                //can't win - ken will play lightest block heavier than naomi's
                M_k.remove(i);
            }
        }
        
        if(M_n.get(M_n.size()-1) > M_k.get(0))
            nPointsFair++;
        
        System.out.println(nPointsDect + " " + nPointsFair);
        pw.println(nPointsDect + " " + nPointsFair);
    }
    
    /**
     * Linear search for the smallest element less than search.
     */
    public static int searchBruteForce(ArrayList<Double> M, int N, double search)
    {
        double absMin = Double.MAX_VALUE;
        double absMax = Double.MIN_VALUE;
        
        double min = Double.MAX_VALUE;
        int    idx = N;
        
        for(int i = 0; i < N; i++){
            double m = M.get(i);
            if(m > search && m < min){
                idx = i;
            }
            if(m < absMin){
                absMin = m;
                lIdx = i;
            }
            if(m > absMax){
                absMax = m;
                hIdx = i;
            }
        }
        return idx;
    }
    public static void solveBruteForce(ArrayList<Double> M_n, ArrayList<Double> M_k, int N, int score)
    {
        if(N == 0){
            if(score > maxScore)
                maxScore = score;
        }
        else{
            for(int i = 0; i < N; i++)
            {
                double m_n = M_n.get(i);
                int j = searchBruteForce(M_k, N, m_n);
                if (j == N){
                    //ken can't win - will play lightest block
                    j = lIdx; 
                }
                double m_k = M_k.get(j);
                ArrayList<Double> M_n_temp = (ArrayList<Double>)M_n.clone();M_n_temp.remove(i);
                Collections.swap(M_k, j, N-1);
                if(m_k > m_n){
                    solveBruteForce(M_n_temp, M_k, N-1, score);
                }
                else{
                    solveBruteForce(M_n_temp, M_k, N-1, score+1);
                }
                Collections.swap(M_k, j, N-1);
            }
        }
    }
    
    public static void solveBruteForceDeceit(ArrayList<Double> M_n, ArrayList<Double> M_k, int N, int score)
    {
        if(N == 0){
            if(score > maxScore)
                maxScore = score;
        }
        else{
            for(int i = 0; i < N; i++)
            {
                double m_n = M_n.get(i);
                int j = searchBruteForce(M_k, N, m_n);
                if (j == N){
                    //ken can't win - will play lightest block
                    j = lIdx; 
                }
                else{
                    j = hIdx;
                }
                double m_k = M_k.get(j);
                ArrayList<Double> M_n_temp = (ArrayList<Double>)M_n.clone();M_n_temp.remove(i);
                Collections.swap(M_k, j, N-1);
                if(m_k > m_n){
                    solveBruteForceDeceit(M_n_temp, M_k, N-1, score);
                }
                else{
                    solveBruteForceDeceit(M_n_temp, M_k, N-1, score+1);
                }
                Collections.swap(M_k, j, N-1);
            }
        }
    }
    
    public static void go() throws Exception
    {
        
        try(Scanner sc = new Scanner(new FileReader("D-small-attempt0.in"));
            PrintWriter pw = new PrintWriter(new FileWriter("D-small-attempt0.out")))
        {
            int T = sc.nextInt();
            for(int t = 1; t <= T; t++)
            {
                System.out.print("Case #" + t + ": ");
                pw.write("Case #" + t + ": ");
                
                int N = sc.nextInt();
                
                ArrayList<Double> M_n = new ArrayList<>();
                ArrayList<Double> M_k = new ArrayList<>();
                
                for(int i = 0; i < N; i++)
                    M_n.add(sc.nextDouble());
                for(int i = 0; i < N; i++)
                    M_k.add(sc.nextDouble());
                    
                solve(M_n, M_k, N, pw);
                
                
                /*
                Collections.sort(M_n);
                
                maxScore = 0;
                solveBruteForce(M_n, M_k, N, 0);
                int fairScore = maxScore; maxScore = 0;
                solveBruteForceDeceit(M_n, M_k, N, 0);
                int dectScore = maxScore;
                
                System.out.println(dectScore + " " + fairScore);
                pw.println(dectScore + " " + fairScore);
                */
            }
        }
    }
}
