import java.util.*;

public class SpaceEmergency {
  private long runL0(long t, long N, int C, long[] distances, long start, long end) {
    long time = 0;
    int i;
    for(i = (int)start; i < end; ++i) {
      if(i % C == 0) {
        break;
      }
      time += distances[i%C]*2;
    }
    if(i < end) {
      long sum = 0;
      for(int j = 0; j < C; ++j) {
        sum += distances[j];
      }
      sum *= 2;
      for(; i + C < end; i += C) {
        time += sum;
      }
    }
    if(i < end) {
      for(; i < end; ++i) {
        time += distances[i%C]*2;
      }
    }
    return time;
  }

  private long runL1(long t, long N, int C, long[] distances, long start, long time_so_far) {
    int i;
    long time = -1;
    for(i = (int)start; i <= N; ++i) {
      long this_time = time_so_far;
      this_time += runL0(t, N, C, distances, start, i);
      long build_time = t;
      if(this_time >= build_time) {
        build_time = 0;
      } else {
        build_time = build_time - this_time;
      }
      long d = distances[i%C];
      if(build_time > d) {
        build_time = d;
      }
      this_time += d+build_time/2;
      this_time += runL0(t, N, C, distances, i+1, N);
      if(time < 0 || this_time < time) {
        time = this_time;
      }
    }
    if(time == -1) {
      return time_so_far;
    }
    return time;
  }

  private long runL2(long t, long N, int C, long[] distances) {
    long time = -1;
    for(int i = 0; i <= N; ++i) {
      long this_time = 0;
      this_time += runL0(t, N, C, distances, 0, i);
      long build_time = t;
      if(this_time >= build_time) {
        build_time = 0;
      } else {
        build_time = build_time - this_time;
      }
      long d = distances[i%C];
      if(build_time > d) {
        build_time = d;
      }
      this_time += d+build_time/2;
      this_time = runL1(t, N, C, distances, i+1, this_time);
      if(time < 0 || this_time < time) {
        time = this_time;
      }
    }
    return time;
  }

  private long run(Scanner in) {
    long L = in.nextLong();
    long t = in.nextLong();
    long N = in.nextLong();
    int C = in.nextInt();
    long[] distances = new long[C];
    for(int i = 0; i < C; ++i) {
      distances[i] = in.nextLong();
    }
    long time = runL0(t, N, C, distances, 0, N);
    if(L > 0) {
      long time1 = runL1(t, N, C, distances, 0, 0);
      if(time1 < time) {
        time = time1;
      }
    }
    if(L > 1) {
      long time2 = runL2(t, N, C, distances);
      if(time2 < time) {
        time = time2;
      }
    }
    return time;
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    long numTestCases = in.nextLong();
    for(int i = 1; i <= numTestCases; ++i) {
      System.out.println("Case #" + i + ": " + (new SpaceEmergency()).run(in));
    }
  }
}
