import java.util.*;

public class TheKillerWord {
  private class GameSoFar implements Comparable<GameSoFar> {
    public String string;
    private char[] sofar;
    public boolean deleted = false;
    public boolean done = false;
    public int points = 0;
    public GameSoFar(String string) {
      this.string = string;
      clear();
    }

    public int compareTo(GameSoFar other) {
      return new String(this.sofar).compareTo(new String(other.sofar));
    }

    public void reveal(char c) {
      boolean set = false;
      for(int i = 0; i < string.length(); ++i) {
        if(string.charAt(i) == c) {
          set = true;
          sofar[i] = c;
        }
      }
      if(!set) {
        points++;
      }
    }

    public String getValue() {
      return string;
    }

    public String getKey() {
      return new String(sofar);
    }

    public void clear() {
      this.sofar = new char[string.length()];
      for(int i = 0; i < string.length(); ++i) {
        sofar[i] = '_';
      }
      deleted = false;
      points = 0;
    }
  }
  private String run(Scanner in) {
    int num_words = in.nextInt();
    int num_orders = in.nextInt();
    String result = "";
    HashMap<Integer, ArrayList<GameSoFar>> words_length = new HashMap<Integer, ArrayList<GameSoFar>>();
    for(int i = 0; i < num_words; ++i) {
      String word = in.next();
      if(null == words_length.get(word.length())) {
        words_length.put(word.length(), new ArrayList<GameSoFar>());
      }
      words_length.get(word.length()).add(new GameSoFar(word));
    }
    for(int i = 0; i < num_orders; ++i) {
      String order = in.next();
      GameSoFar result_order = new GameSoFar("");
      int high_score = -1;
      for(ArrayList<GameSoFar> words : words_length.values()) {
        for(GameSoFar g : words) {
          g.clear();
        }
        for(int j = 0; j < 26; ++j) {
          TreeMap<String, GameSoFar> map = new TreeMap<String, GameSoFar>();
          char c = order.charAt(j);
          boolean should_use = false;
          for(GameSoFar g : words) {
            should_use = should_use || (g.string.indexOf(c) != -1 && !g.deleted);
          }
          if(!should_use) {
            continue;
          }
          for(GameSoFar g : words) {
            g.done = true;
            if(!g.deleted) {
              g.reveal(c);
              GameSoFar already = map.get(g.getKey());
              if(null == already) {
                map.put(g.getKey(), g);
              } else {
                already.done = false;
                g.done = false;
              }
            }
          }
          boolean any_left = false;
          for(GameSoFar g : words) {
            g.deleted = g.deleted || g.done;
            any_left = any_left || !g.deleted;
          }
          if(!any_left) {
            for(GameSoFar g : words) {
              if(g.points > high_score) {
                result_order = g;
                high_score = g.points;
              }
            }
          }
        }
      }
      result += result_order.getValue() + " ";
    }
    return result.substring(0, result.length()-1);
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    int numTestCases = in.nextInt();
    in.nextLine();
    for(int i = 1; i <= numTestCases; ++i) {
      String result = (new TheKillerWord()).run(in);
      System.out.println("Case #" + i + ": " + result);
    }
  }
}
