import java.util.*;

public class ReventOfTheHotDogs {
  private class Struct {
    public double position;
    public double left;
    public double right;
    public long num_stands;
    public double time_needed;
  }
  private int min_distance;
  private Struct consolidate(ArrayList<Struct> groups, int start, int end) {
//System.out.println("Consolidate " + start + " " + end);
    Struct s = new Struct();
    double sum = 0;
    for(int i = start; i <= end; ++i) {
      sum += groups.get(i).position;
      Struct ss = groups.get(i);
//System.out.println("" + ss.num_stands + " " + ss.position + " " + ss.left + " " + ss.right + " " + ss.time_needed);
    }
    s.position = sum / (end-start+1);

    sum = 0;
    for(int i = start; i <= end; ++i) {
      Struct c = groups.get(i);
      sum += (c.right - c.left);
    }
    double total_length = sum + (end-start)*min_distance;
    s.left = s.position - total_length / 2.0;
    s.right = s.position + total_length / 2.0;

    long isum = 0;
    for(int i = start; i <= end; ++i) {
      isum += groups.get(i).num_stands;
    }
    s.num_stands = isum;

    double cur_left = s.left;
    double new_time = 0.0;
    for(int i = start; i <= end; ++i) {
      Struct c = groups.get(i);
      double t = Math.abs(c.left-cur_left) + c.time_needed;
//System.out.println(t);
      if(t > new_time) {
        new_time = t;
      }
      cur_left = cur_left + (c.right - c.left) + min_distance;
    }
    s.time_needed = new_time;
//System.out.println("" + s.num_stands + " " + s.position + " " + s.left + " " + s.right + " " + s.time_needed);
    return s;
  }
  private double run(Scanner in) {
    int num_groups = in.nextInt();
    min_distance = in.nextInt();
    ArrayList<Struct> groups = new ArrayList<Struct>(num_groups);
    for(int i = 0; i < num_groups; ++i) {
      Struct s = new Struct();
      s.position = (double)in.nextLong();
      s.num_stands = in.nextLong();
      s.left = s.position - ((s.num_stands-1) * min_distance) / 2.0;
      s.right = s.position + ((s.num_stands-1) * min_distance) / 2.0;
      s.time_needed = ((s.num_stands-1) * min_distance) / 2.0;
//System.out.println("" + s.num_stands + " " + s.position + " " + s.left + " " + s.right + " " + s.time_needed);
      groups.add(s);
    }
    int previous_num_group = -1;
    while(previous_num_group != num_groups) {
      if(num_groups == 1) {
        return groups.get(0).time_needed;
      }
      ArrayList<Struct> new_groups = new ArrayList<Struct>(num_groups);
      int left = 0;
      for(int i = 1; i < groups.size(); ++i) {
        if((groups.get(i-1).right + min_distance < groups.get(i).left)) {
          new_groups.add(consolidate(groups, left, i-1));
          left = i;
        }
        if(i == groups.size()-1) {
          new_groups.add(consolidate(groups, left, i));
        }
      }
      groups = new_groups;
      previous_num_group = num_groups;
      num_groups = groups.size();
    }
    double time = groups.get(0).time_needed;
    for(int i = 1; i < groups.size(); ++i) {
      if(groups.get(i).time_needed < time) {
        time = groups.get(i).time_needed;
      }
    }
    return time;
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    int numTestCases = in.nextInt();
    in.nextLine();
    for(int i = 1; i <= numTestCases; ++i) {
      System.out.println("Case #" + i + ": " + (new ReventOfTheHotDogs()).run(in));
    }
  }
}
