import java.util.*;

public class RPI {
  private static Integer WIN = new Integer(1);
  private static Integer LOSS = new Integer(-1);
  private static Integer NO_GAME = new Integer(0);

  private class Struct {
    public int index;
    public double wp, owp, oowp;
    public int num_win, num_loss, num_games;
    public Struct(int index) {
      this.index = index;
      num_win = num_loss = num_games = 0;
    }
  }

  private void run(Scanner in) {
    int N = in.nextInt();
    in.nextLine();
    ArrayList<ArrayList<Integer>> result = new ArrayList<ArrayList<Integer>>(N);
    ArrayList<Struct> teams = new ArrayList<Struct>(N);
    for (int i = 0; i < N; ++i) {
      result.add(new ArrayList<Integer>(N));
      String line = in.nextLine();
      teams.add(new Struct(i));
      for(int j = 0; j < N; ++j) {
        char c = line.charAt(j);
        Integer s = new Integer(0);
        if('1' == c) {
          s = WIN;
        } else if ('0' == c) {
          s = LOSS;
        } else {
          s = NO_GAME;
        }
        result.get(i).add(s);
      }
    }
    for(int i = 0; i < N; ++i) {
      Struct team = teams.get(i);
      int index = team.index;
      for(int j = 0; j < N; ++j) {
        Integer r = result.get(i).get(j);
        if(r == WIN) {
          team.num_win++;
          team.num_games++;
        } else if (r == LOSS) {
          team.num_loss++;
          team.num_games++;
        }
      }
      if(team.num_games == 0) {
        team.wp = 0;
      } else {
        team.wp = ((double)team.num_win) / team.num_games;
      }
    }
    for(int i = 0; i < N; ++i) {
      Struct team = teams.get(i);
      int index = team.index;
      int num_games = 0;
      double sum = 0;
      for(int j = 0; j < N; ++j) {
        Integer r = result.get(i).get(j);
        Struct other_team = teams.get(j);
        if(r == WIN) {
          num_games += 1;
          if(other_team.num_games > 1) {
            sum += ((double)(other_team.num_win)) / (other_team.num_games-1);
          }
        } else if (r == LOSS) {
          num_games += 1;
          if(other_team.num_games > 1) {
            sum += ((double)(other_team.num_win - 1)) / (other_team.num_games-1);
          }
        }
      }
      if(num_games == 0) {
        team.owp = 0;
      } else {
        team.owp = (sum) / num_games;
      }
    }
    for(int i = 0; i < N; ++i) {
      Struct team = teams.get(i);
      double sum = 0.0;
      int num_oppo = 0;
      for(int j = 0; j < N; ++j) {
        Integer r = result.get(i).get(j);
        if(r == WIN || r == LOSS) {
          num_oppo += 1;
          sum += teams.get(j).owp;
        }
      }
      if(num_oppo == 0) {
        team.oowp = 0;
      } else {
        team.oowp = sum / num_oppo;
      }
    }
    for(int i = 0; i < N; ++i) {
      Struct team = teams.get(i);
      System.out.println("" + (0.25 * team.wp + 0.5 * team.owp + 0.25 * team.oowp));
    }
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    int numTestCases = in.nextInt();
    in.nextLine();
    for(int i = 1; i <= numTestCases; ++i) {
      System.out.println("Case #" + i + ": ");
      (new RPI()).run(in);
    }
  }
}
