import java.util.*;

public class CandySplitting {
  private Scanner in;
  private CandySplitting(Scanner in) {
    this.in = in;
  }

  private int calculate(ArrayList<Integer> candies, int subset) {
    int a = 0;
    int b = 0;
    int sum = 0;
    int count = 0;
    for(int i = 0; i < candies.size(); ++i) {
      if(subset % 2 == 0) {
        count += 1;
        sum += candies.get(i);
        a ^= candies.get(i);
      } else {
        b ^= candies.get(i);
      }
      subset /= 2;
    }
    if(a == b) {
      return sum;
    } else {
      return -1;
    }
  }

  private int run() {
    int numCandies = in.nextInt();
    ArrayList<Integer> candies = new ArrayList<Integer>(numCandies);
    for(int i = 0; i < numCandies; ++i) {
      candies.add(in.nextInt());
    }
    int bound = (int)(Math.rint(Math.pow(2, numCandies))+0.1);
    int largest = -1;
    // from 1 to bound-2 since cannot have empty pile..
    for(int subset = 1; subset < bound-1; ++subset) {
      largest = Math.max(largest, calculate(candies, subset));
    }

    return largest;
  }

  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    int numTestCases = in.nextInt();
    for(int i = 1; i <= numTestCases; ++i) {
      String line = in.nextLine();
      int result = (new CandySplitting(in)).run();
      if(result == -1) {
        System.out.println("Case #" + i + ": NO");
      } else {
        System.out.println("Case #" + i + ": " + result);
      }
    }
  }
}
