import java.util.*;

public class BotTrust {
  private String line;
  private BotTrust(String line) {
    this.line = line;
  }

  private int run() {
    Scanner in = new Scanner(line);
    int numButtons = in.nextInt();
    int totalTime = 0;
    int waitingTime = 0;
    int currentOrangePos = 1;
    int currentBluePos = 1;
    char previousBot = '-';
    for(int i = 0; i < numButtons; ++i) {
      char bot = in.next().charAt(0);
      int nextPos = in.nextInt();
      if ('O' == bot) {
        if(previousBot != bot) {
          int time = Math.abs(nextPos-currentOrangePos);
          time = Math.max(time-waitingTime, 0);
          time += 1;  // to press button
          totalTime += time;
          waitingTime = time;
        } else {
          int time = Math.abs(nextPos-currentOrangePos) + 1;
          totalTime += time;
          waitingTime += time;
        }
        currentOrangePos = nextPos;
      } else {
        if(previousBot != bot) {
          int time = Math.abs(nextPos-currentBluePos);
          time = Math.max(time-waitingTime, 0);
          time += 1;  // to press button
          totalTime += time;
          waitingTime = time;
        } else {
          int time = Math.abs(nextPos-currentBluePos) + 1;
          totalTime += time;
          waitingTime += time;
        }
        currentBluePos = nextPos;
      }
      previousBot = bot;
    }
    return totalTime;
  }
  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    int numTestCases = in.nextInt();
    in.nextLine();
    for(int i = 1; i <= numTestCases; ++i) {
      String line = in.nextLine();
      int result = (new BotTrust(line)).run();
      System.out.println("Case #" + i + ": " + result);
    }
  }
}
