package gcj.traintimetable;

import java.util.*;


public class TestCase {
	
	private int turnAroundTime;
	private ArrayList<Route> routes;
	private ArrayList<Time> trainStationA = new ArrayList<Time>();
	private ArrayList<Time> trainStationB = new ArrayList<Time>();
	private int numTrainsA = 0;
	private int numTrainsB = 0;
	
	
	public TestCase(int turnAroundTime, ArrayList<Route> routes) {
		this.turnAroundTime = turnAroundTime;
		this.routes = routes;
	}
	
	public void process() throws Exception {
		for(int i=0; i<routes.size(); i++) {
			Time start = routes.get(i).getStart();
			Time end = routes.get(i).getEnd();
			String startLocation = routes.get(i).getStartLocation();
			boolean trainNotFound = true;
			if(startLocation.equals("A")) {
				for(int j=0; j<trainStationA.size(); j++) {
					if(trainStationA.get(j).compareTo(start)<=0) {
						trainStationA.remove(j);
						Time newTime = new Time(""+end.getHour(),""+end.getMinute());
						newTime.add(turnAroundTime);
						trainStationB.add(newTime);
						trainNotFound = false;
						break;
					}
				}
				if(trainNotFound) {
					numTrainsA++;
					Time newTime = new Time(""+end.getHour(),""+end.getMinute());
					newTime.add(turnAroundTime);
					trainStationB.add(newTime);
				}
			} else if(startLocation.equals("B")) {
				for(int j=0; j<trainStationB.size(); j++) {
					if(trainStationB.get(j).compareTo(start)<=0) {
						trainStationB.remove(j);
						Time newTime = new Time(""+end.getHour(),""+end.getMinute());
						newTime.add(turnAroundTime);
						trainStationA.add(newTime);
						trainNotFound = false;
						break;
					}
				}
				if(trainNotFound) {
					numTrainsB++;
					Time newTime = new Time(""+end.getHour(),""+end.getMinute());
					newTime.add(turnAroundTime);
					trainStationA.add(newTime);
				}
			}
			
		}
	}
	
	public String toString() {
		return "" + numTrainsA + " " + numTrainsB;
	}
}
