package gcj.std;

import java.io.*;
import java.util.*;
import gcj.traintimetable.*;

public class ReadInput {

	private static String filename;
	private static int numCases;
	private static ArrayList<ArrayList<String>> lines = new ArrayList<ArrayList<String>>();
	private static ArrayList<TestCase> testCases = new ArrayList<TestCase>();
	
	public static int getNumCases() {
		return numCases;
	}
	
	public static ArrayList<ArrayList<String>> getLines() {
		return lines;
	}
	
	public static ArrayList<TestCase> getTestCases() {
		return testCases;
	}

	public static void process(String fileName) {
		
		filename = fileName;
		
		String line;
		
		File file = new File(filename);
		FileReader fr;
		BufferedReader br;
		try {
			fr = new FileReader(file);
			br = new BufferedReader(fr);
			
			line = br.readLine();
			numCases = Integer.parseInt(line);
			for(int i=0; i<numCases; i++) {
				line = br.readLine();
				int turnAroundTime = Integer.parseInt(line);
				int numAB, numBA;
				line = br.readLine();
				String[] strArray = line.split(" ");
				numAB = Integer.parseInt(strArray[0]);
				numBA = Integer.parseInt(strArray[1]);
				Time start,end;
				ArrayList<Route> routes = new ArrayList<Route>();
				for(int j=0; j<numAB; j++) {
					line = br.readLine();
					strArray = line.split(" ");
					String[] timeArray = strArray[0].split(":");
					start = new Time(timeArray[0],timeArray[1]);
					timeArray = strArray[1].split(":");
					end = new Time(timeArray[0],timeArray[1]);
					Route route = new Route(start,end,"A");
					routes.add(route);
				}
				for(int j=0; j<numBA; j++) {
					line = br.readLine();
					strArray = line.split(" ");
					String[] timeArray = strArray[0].split(":");
					start = new Time(timeArray[0],timeArray[1]);
					timeArray = strArray[1].split(":");
					end = new Time(timeArray[0],timeArray[1]);
					Route route = new Route(start,end,"B");
					routes.add(route);
				}
				Collections.sort(routes);
				TestCase testCase = new TestCase(turnAroundTime,routes);
				testCases.add(testCase);
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			return;
		} catch (IOException e) {
			e.printStackTrace();
			return;
		}
	}
}