import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;


public class Main {
	
	public static void main(String [] args) throws NumberFormatException, IOException{
		
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		
		int testcaseNum = Integer.parseInt(br.readLine());
		
		ArrayList<String> result = new ArrayList<String>();
		
		for(int i=0; i<testcaseNum; i++)
		{
			char[][] currentMatrix = getMatrix(br);
			result.add(whoWins(currentMatrix));
			br.readLine();
		}
		
		for(int i=0; i<result.size(); i++){
			System.out.println("Case #"+(i+1)+": "+result.get(i));
		}
		
	}

	private static String whoWins(char[][] currentMatrix) {
		boolean isComplete = true;/*changed to false when met with \\.*/
		
		//Horizontal Scan
		for(int i=0; i<4; i++){
		    char currentLabel = currentMatrix[i][0];
		    boolean win = true;
		    if(currentLabel=='T')
		    	currentLabel = currentMatrix[i][1];
		    if(currentLabel=='.')
		    {
		    	isComplete = false;
		    	continue;
		    }
			for(int j=1; j<4; j++)
			{
				if(currentMatrix[i][j]!=currentLabel&&currentMatrix[i][j]!='T')
				{
					win = false;
					break;
				}
			}
			if(win)
				return currentLabel + " won";
		}
		
		//vertical scan
		for(int i=0; i<4; i++){
		    char currentLabel = currentMatrix[0][i];
		    boolean win = true;
		    if(currentLabel=='T')
		    	currentLabel = currentMatrix[1][i];
		    if(currentLabel=='.')
		    {
		    	isComplete = false;
		    	continue;
		    }
			for(int j=1; j<4; j++)
			{
				if(currentMatrix[j][i]!=currentLabel&&currentMatrix[j][i]!='T')
				{
					win = false;
					break;
				}
			}
			if(win)
				return currentLabel + " won";
		}

		//diagnal, left up to right down
	    char currentLabel = currentMatrix[0][0];
	    boolean win = true;
		if (currentLabel == 'T')
			currentLabel = currentMatrix[1][1];
		if(currentLabel!='.'){
			for (int j = 1; j < 4; j++) {
				if (currentMatrix[j][j] != currentLabel
						&& currentMatrix[j][j] != 'T') {
					win = false;
					break;
				}
			}
			if (win)
				return currentLabel + " won";
		}
		else
		 	isComplete = false;

	    
		//diagnal, rd to lu
	    currentLabel = currentMatrix[0][3];
	    win = true;
		if (currentLabel == 'T')
			currentLabel = currentMatrix[1][2];
		if(currentLabel!='.'){
			for (int j = 1; j < 4; j++) {
				if (currentMatrix[j][3-j] != currentLabel
						&& currentMatrix[j][3-j] != 'T') {
					win = false;
					break;
				}
			}
			if (win)
				return currentLabel + " won";
		}
		else
			isComplete = false;

			
	    if(isComplete)
	    	return "Draw";
	    else
	    	return "Game has not completed";
		
	}

	private static char[][] getMatrix(BufferedReader br) throws IOException {
	
		char [][]matrix = new char[4][4];
		for(int i=0; i<4; i++){
			String currentLine = br.readLine();
			for(int j=0; j<4; j++)
				matrix[i][j] = currentLine.charAt(j);
		}
		return matrix;
	}

}
