import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Set;

public class CountingSheep {
	
	public String[] parsedInputs() {
		String[] parsed = new String[inputs.size()-1];
		for (int i = 1; i<inputs.size(); i++) {
			String realInput = inputs.get(i);
			parsed[i-1] = realInput;
		}
		return parsed;
	}
	
	public int[] toArray(String s) {
		int[] arr = new int[s.length()];
		for (int i = 0; i<s.length(); i++){
			arr[i] = s.charAt(i)-48;
		}
		return arr;
	}
	
	
	public int calculate(int a) {
		int num = a;
		Set<Integer> seen = new HashSet<Integer>();
		while (seen.size() < 10) {
			int[] myChars = toArray(num + "");
			for (int i : myChars) {
				seen.add(i);
			}
			num += a;
		}
		return num-a;
	}
	
	ArrayList<String> inputs = new ArrayList<String>();
	
	public boolean readFile(String filename) {
		try {
			FileReader dataFile = new FileReader(filename);
			BufferedReader bufferedReader = new BufferedReader(dataFile);
			String currentLine = bufferedReader.readLine();

			while(currentLine != null) {
				String trimmedWord = currentLine.trim();
				inputs.add(trimmedWord);
				currentLine = bufferedReader.readLine();
			}
			bufferedReader.close();
		} 
		catch (IOException e) {
			System.err.println("A error occured reading file: " + e);
			e.printStackTrace();
			return false;
		}
		System.out.println(inputs);
		return true;
	}
	
	
	
	
	
	public static void main(String[] args) {
		
		PrintStream ps = null;
		
		try {
			ps = new PrintStream(new File("outASmall.txt"));
		}
		catch (FileNotFoundException fx) {
			fx.printStackTrace();
		}
		
		
		CountingSheep s = new CountingSheep();
		
		s.readFile("A-small-attempt0.in");
		
		String[] parsed = s.parsedInputs();
		
		for (int i = 0; i<parsed.length; i++) {
			int num = Integer.parseInt(parsed[i]);
			if (num == 0) {
				ps.println("Case #" + (i+1) + ": " + "INSOMNIA");
			} else {
				ps.println("Case #" + (i+1) + ": " + s.calculate(num));
			}
			
		}
		
	}
}
