package google.y17;

import java.io.*;
import java.util.*;

public class Flipper {
	Queue<String> inputs = new LinkedList<String>();
	
	
	public void reset(String original, char[] temp) {
		for (int i = 0; i<temp.length; i++) {
			temp[i] = original.charAt(i);
		}
	}
	
	public List<Integer> bitPositions(int number) {
	    List<Integer> positions = new ArrayList<>();
	    int position = 0;
	    while (number != 0) {
	        if ((number & 1) != 0) {
	            positions.add(position);
	        }
	        position++;
	        number = number >>> 1;
	    }
	    return positions;
	}
	
	public boolean flip(List<Integer> positions, char[] temp, int size) {
		for (int i: positions) {
			for (int k = 0; k<size; k++) {
				if (temp[i+k] == '-') {
					temp[i+k] = '+';
				} else {
					temp[i+k] = '-';
				}
			}
		}
		for (int i = 0; i<temp.length; i++) {
			if (temp[i] == '-') {
				return false;
			}
		}
		return true;
	}
	
	
	
	
	public String calculate(String s) {
		String original = s.split(" ")[0];
		int size = Integer.parseInt(s.split(" ")[1]);
		char[] temp = new char[original.length()];
		
		
		int min = Integer.MAX_VALUE;
		
		int limit = 1 << (original.length()-size+1);
		
		
		for (int i = 0; i<limit; i++) {
			reset(original, temp);
			List<Integer> positions = bitPositions(i);
			if (flip(positions, temp, size)) {
				min = Math.min(min, Integer.bitCount(i));
			}
		}
		
		if (min == Integer.MAX_VALUE) {
			return "IMPOSSIBLE";
		} else {
			return min + "";
		}
		
		
		
	}
	
	
	
	
	
	
	

	

	public boolean readFile(String filename) {
		try {
			FileReader dataFile = new FileReader(filename);
			BufferedReader bufferedReader = new BufferedReader(dataFile);
			String currentLine = bufferedReader.readLine();

			while(currentLine != null) {
				String trimmedWord = currentLine.trim();
				inputs.add(trimmedWord);
				currentLine = bufferedReader.readLine();
			}
			bufferedReader.close();
		} 
		catch (IOException e) {
			System.err.println("A error occured reading file: " + e);
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public static void main(String[] args) {
		Flipper s = new Flipper();
		

		
		
		PrintStream ps = null;
		
		try {
			ps = new PrintStream(new File("out.txt"));
		}
		catch (FileNotFoundException fx) {
			fx.printStackTrace();
		}
		
		
		
		
		s.readFile("A-small-attempt1.in");
		
		int cases = Integer.parseInt(s.inputs.remove());
		
		for (int i = 1; i<=cases; i++) {
			String input = s.inputs.remove();
			ps.println("Case #" + (i) + ": " + s.calculate(input));
		}
			
		}
	
}
