package google.y17;

import java.io.*;
import java.util.*;

public class Cakes {
	Queue<String> inputs = new LinkedList<String>();
	
	public boolean test(char[][] arr) {
		for (int i = 0; i<arr.length; i++) {
			for (int j = 0; j<arr[0].length; j++) {
				if (arr[i][j] == '?') {
					return false;
				}
			}
		}
		return true;
	}
	
	public boolean checkQ(char[][] arr, char c, int xs, int xe, int ys, int ye) {
		if (xs<0 || xe>=arr.length || ys<0 || ye>=arr[0].length) {
			return false;
		}
		for (int i = xs; i<=xe; i++) {
			for (int j = ys; j<= ye; j++) {
				if (arr[i][j] != '?' && arr[i][j] != c) {
//					System.out.println(i + " " + j + " " + arr[i][j]);
					return false;
				}
			}
		}
		return true;
	}
	
	public void setRange(char[][] arr, char c, int xs, int xe, int ys, int ye) {
		for (int i = xs; i<=xe; i++) {
			for (int j = ys; j<= ye; j++) {
				arr[i][j] = c;
			}
		}
	}
	
	public void fill(boolean horizontal, char[][] arr, Map<Character, int[]> allChars) {

		for (char c : allChars.keySet()) {
			int[] data = allChars.get(c);
			int xs = data[0];
			int xe = data[1];
			int ys = data[2];
			int ye = data[3];
			
			System.out.println(c);
			System.out.println(Arrays.toString(data));
			
			if (horizontal) {
			
			if (checkQ(arr, c, xs-1, xe, ys, ye) || checkQ(arr, c, xs, xe+1, ys, ye)) {
				while (checkQ(arr, c, xs-1, xe, ys, ye)) {
					xs--;
				}
				while (checkQ(arr, c, xs, xe+1, ys, ye)) {
					xe++;
				}
			}
			
			}
			
			
			else {
			
			if (checkQ(arr, c, xs, xe, ys-1, ye) || checkQ(arr, c, xs, xe, ys, ye+1)) {
				while (checkQ(arr, c, xs, xe, ys-1, ye)) {
					ys--;
				}
				while (checkQ(arr, c, xs, xe, ys, ye+1)) {
					ye++;
				}
			}
			
			
			}
			
			data[0] = xs;
			data[1] = xe;
			data[2] = ys;
			data[3] = ye;
			
			setRange(arr, c, xs, xe, ys, ye);
		}
	}
	
	
	public String calculate(List<String> s) {
		StringBuilder sb = new StringBuilder();
		
		char[][] arr = new char[s.size()][s.get(0).length()];
		Map<Character, int[]> allChars = new HashMap<>();
		for (int i = 0; i<arr.length; i++) {
			for (int j = 0; j<arr[0].length; j++) {
				char c = s.get(i).charAt(j);
				arr[i][j] = c;
				if (c != '?') {
					allChars.put(c, new int[]{i,i,j,j});
				}
			}
		}
//		System.out.println(Arrays.deepToString(arr));
		fill(true, arr, allChars);
		fill(false, arr, allChars);
		
		
		
		for (int i = 0; i<arr.length; i++) {
			sb.append('\n');
			for (int j = 0; j<arr[0].length; j++) {
				sb.append(arr[i][j]);
			}
		}
		
		return sb.toString();
	}



	

	public boolean readFile(String filename) {
		try {
			FileReader dataFile = new FileReader(filename);
			BufferedReader bufferedReader = new BufferedReader(dataFile);
			String currentLine = bufferedReader.readLine();

			while(currentLine != null) {
				String trimmedWord = currentLine.trim();
				inputs.add(trimmedWord);
				currentLine = bufferedReader.readLine();
			}
			bufferedReader.close();
		} 
		catch (IOException e) {
			System.err.println("A error occured reading file: " + e);
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public static void main(String[] args) {
		Cakes s = new Cakes();
		
		PrintStream ps = null;
		
		try {
			ps = new PrintStream(new File("outLarge.txt"));
		}
		catch (FileNotFoundException fx) {
			fx.printStackTrace();
		}
		
		
		
		
		s.readFile("A-large.in.txt");
		
		int cases = Integer.parseInt(s.inputs.remove());
		
		for (int i = 1; i<=cases; i++) {
			String input = s.inputs.remove();
			int rows = Integer.parseInt(input.split(" ")[0]);
			List<String> inputs = new ArrayList<>();
			for (int j = 0; j<rows; j++) {
				inputs.add(s.inputs.remove());
			}
			ps.println("Case #" + (i) + ": " + s.calculate(inputs));
		}
			
		}
	
}
