package google.y17;

import java.io.*;
import java.util.*;

public class Problem1BB {
	Queue<String> inputs = new LinkedList<String>();
	
	public int[] findMaxIndex(int[] in) {
		int idx = 0;
		int max = 0;
		for (int i = 0; i<in.length; i++) {
			if (in[i] > max) {
				idx = i;
				max = in[i];
			}
		}
		return new int[]{idx, max};
	}
	
	public boolean triangle(int a, int b, int c) {
		if (a + b < c) {
			return false;
		}
		if (b + c < a) {
			return false;
		}
		if (a + c < b) {
			return false;
		}
		return true;
	}
	
	
	public String calculate(String s) {
		String[] tmp = s.split(" ");
		int[] counts = new int[tmp.length-1];
		for (int i = 1; i<tmp.length; i++) {
			counts[i-1] = Integer.parseInt(tmp[i]);
		}
		char[] colors = new char[] {'R','O','Y','G','B','V'};
		StringBuilder sb = new StringBuilder();
		int firstMax = findMaxIndex(counts)[0];
		char firstColor = colors[firstMax];
		int firstCount = findMaxIndex(counts)[1];
		for (int i = 0; i<firstCount; i++) {
			sb.append(firstColor);
		}
		counts[firstMax] = 0;
		
		int secondMax = findMaxIndex(counts)[0];
		char secondColor = colors[secondMax];
		int secondCount = findMaxIndex(counts)[1];
		int lastIdx = sb.length();
		for (int i = 0; i<secondCount; i++) {
			if (lastIdx < 0) {
				return "IMPOSSIBLE";
			}
			sb.insert(lastIdx, secondColor);
			lastIdx--;
		}
		counts[secondMax] = 0;
		
		int thirdMax = findMaxIndex(counts)[0];
		char thirdColor = colors[thirdMax];
		int thirdCount = findMaxIndex(counts)[1];
		for (int i = 0; i<thirdCount; i++) {
			if (lastIdx < 0) {
				lastIdx = sb.length()-1;
			}
			sb.insert(lastIdx, thirdColor);
			lastIdx--;
		}
		
		if (!triangle(firstCount, secondCount, thirdCount)) {
			return "IMPOSSIBLE";
		}
		
		return sb.toString();
	}



	

	public boolean readFile(String filename) {
		try {
			FileReader dataFile = new FileReader(filename);
			BufferedReader bufferedReader = new BufferedReader(dataFile);
			String currentLine = bufferedReader.readLine();

			while(currentLine != null) {
				String trimmedWord = currentLine.trim();
				inputs.add(trimmedWord);
				currentLine = bufferedReader.readLine();
			}
			bufferedReader.close();
		} 
		catch (IOException e) {
			System.err.println("A error occured reading file: " + e);
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	public static void main(String[] args) {
		Problem1BB s = new Problem1BB();
		
		PrintStream ps = null;
		
		try {
			ps = new PrintStream(new File("out.txt"));
		}
		catch (FileNotFoundException fx) {
			fx.printStackTrace();
		}
		
		s.readFile("B-small-attempt2.in.txt");
		
		int cases = Integer.parseInt(s.inputs.remove());
		
		for (int i = 1; i<=cases; i++) {
			String input = s.inputs.remove();
			ps.println("Case #" + (i) + ": " + s.calculate(input));
		}
			
		}
	
}
