import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

public class LastWord {

	
	public String[] parsedInputs() {
		String[] parsed = new String[inputs.size()-1];
		for (int i = 1; i<inputs.size(); i++) {
			String realInput = inputs.get(i);
			parsed[i-1] = realInput;
		}
		return parsed;
	}
	
	public int[] toArray(String s) {
		int[] arr = new int[s.length()];
		for (int i = 0; i<s.length(); i++){
			arr[i] = s.charAt(i)-48;
		}
		return arr;
	}
	
	
	public String calculate(String s) {
		StringBuilder sb = new StringBuilder();
		sb.append(s.charAt(0));
		for (int i = 1; i<s.length(); i++) {
			char c = s.charAt(i);
			if (c >= sb.charAt(0)) {
				sb.insert(0, c);
			} else {
				sb.append(c);
			}
		}
		return sb.toString();
	}
	
	ArrayList<String> inputs = new ArrayList<String>();
	
	public boolean readFile(String filename) {
		try {
			FileReader dataFile = new FileReader(filename);
			BufferedReader bufferedReader = new BufferedReader(dataFile);
			String currentLine = bufferedReader.readLine();

			while(currentLine != null) {
				String trimmedWord = currentLine.trim();
				inputs.add(trimmedWord);
				currentLine = bufferedReader.readLine();
			}
			bufferedReader.close();
		} 
		catch (IOException e) {
			System.err.println("A error occured reading file: " + e);
			e.printStackTrace();
			return false;
		}
		return true;
	}
	
	
	
	
	
	public static void main(String[] args) {
		
		PrintStream ps = null;
		
		try {
			ps = new PrintStream(new File("outALarge.txt"));
		}
		catch (FileNotFoundException fx) {
			fx.printStackTrace();
		}
		
		
		LastWord s = new LastWord();
		
		s.readFile("A-large.in");
		
		String[] parsed = s.parsedInputs();
		
		for (int i = 0; i<parsed.length; i++) {
			String cakes = parsed[i];
			ps.println("Case #" + (i+1) + ": " + s.calculate(cakes));
		}
			
		}
	
}
