package codejam;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;
import java.util.StringTokenizer;

public class TrainTimetable {

  static final int MAX_N = 3600;

  int[] a = new int[MAX_N];
  int[] b = new int[MAX_N];

  int testCases = 0;
  int t = 0;
  int turnaround = 0;
  int na, nb;
  int[] startA, endA, startB, endB;

  public int hmToInt(String s) {
    // s is of format: HH:MM
    int x = Integer.parseInt(s.substring(0, 2));
    x *= 60;
    x += Integer.parseInt(s.substring(3));
    return x;
  }

  public void solve() {

    File file = new File("src/codejam/B-small-attempt0.in");
    BufferedWriter out;

    try {
      out = new BufferedWriter(new FileWriter("src/codejam/train.out"));
      Scanner scanner = new Scanner(file);

      testCases = Integer.parseInt(scanner.nextLine());

      for (t = 1; t <= testCases; ++t) {

        turnaround = Integer.parseInt(scanner.nextLine());

        String line = scanner.nextLine();
        StringTokenizer st = new StringTokenizer(line);
        na = Integer.parseInt(st.nextToken());
        nb = Integer.parseInt(st.nextToken());

        startA = new int[na];
        endA = new int[na];
        startB = new int[nb];
        endB = new int[nb];

        for (int k = 0; k < na; ++k) {
          line = scanner.nextLine();
          String[] startEnd = line.split(" ");
          startA[k] = hmToInt(startEnd[0]);
          endA[k] = hmToInt(startEnd[1]);
        }

        for (int k = 0; k < nb; ++k) {
          line = scanner.nextLine();
          String[] startEnd = line.split(" ");
          startB[k] = hmToInt(startEnd[0]);
          endB[k] = hmToInt(startEnd[1]);
        }
        // END OF INPUT

        Arrays.fill(a, 0);
        Arrays.fill(b, 0);

        for (int i = 0; i < na; ++i) {
          for (int j = endA[i] + turnaround; j < MAX_N; ++j) {
            ++b[j];
          }
        }

        for (int i = 0; i < nb; ++i) {
          for (int j = endB[i] + turnaround; j < MAX_N; ++j) {
            ++a[j];
          }
        }

        Arrays.sort(startA);
        Arrays.sort(startB);

        int ra = 0;
        for (int i = 0; i < na; ++i) {
          if (a[startA[i]] == 0) {
            ++ra;
          } else {
            for (int j = a[startA[i]]; j < MAX_N; ++j) {
              --a[j];
            }
          }
        }

        int rb = 0;
        for (int i = 0; i < nb; ++i) {
          if (b[startB[i]] == 0) {
            ++rb;
          } else {
            for (int j = b[startB[i]]; j < MAX_N; ++j) {
              --b[j];
            }
          }
        }

        //System.out.println("Case #" + t + ": " + ra + " " + rb);
        out.write("Case #" + t + ": " + ra + " " + rb + "\n");
      }

      out.close();

      scanner.close();

    } catch (FileNotFoundException e) {
      e.printStackTrace();
    } catch (IOException ioe) {
      ioe.printStackTrace();
    }

  }

  public static void main(String[] args) {

    TrainTimetable tt = new TrainTimetable();
    tt.solve();

  }

}
