package codejam;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;
import java.util.StringTokenizer;

public class MinimumScalarProduct {
	
	int testCases, t;
	int n;
	int[] a, b;
	int[] perm;
	long minSum;
	
	static boolean finished = false;

	public static int[] nextPerm(int[] a) {
		int i = a.length - 1;
		while (i > 0 && a[i - 1] > a[i]) {
			--i;
		}

		if (i == 0) {
			Arrays.fill(a, 0);
			finished = true;
		} else {
			--i;
			int j = i + 1;
			int minValue = a[j];
			int minIndex = j;
			++j;
			while (j < a.length) {
				if (a[j] < minValue && a[j] > a[i]) {
					minValue = a[j];
					minIndex = j;
				}
				++j;
			}
			// swap i and minIndex
			int temp = a[i];
			a[i] = a[minIndex];
			a[minIndex] = temp;

			Arrays.sort(a, i + 1, a.length);
		}

		return a;
	}
	
	
	public int[] parseLine(String line, int n) {
		
		int[] c = new int[n];
		StringTokenizer st = new StringTokenizer(line);
		int i = 0;
		while (st.hasMoreTokens()) {
			c[i] = Integer.parseInt(st.nextToken());
			++i;
		}
		
		return c;
	 
	}
	
	public void go() {
		
		try {
		Scanner s  = new Scanner(System.in);
		
		testCases = Integer.parseInt(s.nextLine());
		
		FileWriter fstream = new FileWriter("src/codejam/a.out");
        BufferedWriter out = new BufferedWriter(fstream);
        
		for (t = 1; t <= testCases; ++t) {
			n = Integer.parseInt(s.nextLine());
			
			a = parseLine(s.nextLine(),n);
			b = parseLine(s.nextLine(),n);
			
			perm = new int[n];
			for (int i = 0; i < n; ++i) {
				perm[i] = i;
			}
			finished = false;
			minSum = Long.MAX_VALUE;
			while (!finished) {
				
				long sum = 0L;
				for (int i = 0; i < n; ++i) {
					sum += a[i] * b[perm[i]];
				}
				minSum = Math.min(sum, minSum);
				
				perm = nextPerm(perm);
			
			}
			
			//System.out.println("Case #" + t + ": " + minSum);
			out.write("Case #" + t + ": " + minSum + "\n");
			
		
		}
		
		out.close();
		}
		catch (Exception e) {
		 e.printStackTrace();
		}
		
	}

	
	public void test() {
		perm = new int[4];

		for (int i = 0; i < 4; ++i) {
			perm[i] = i;
		}
		
		for (int i = 0; i < 30; ++i) {
			
			System.out.println(Arrays.toString(perm));
			perm = nextPerm(perm);
		}

	}

	public static void main(String[] args) {
		MinimumScalarProduct k = new MinimumScalarProduct();
		k.go();
		

	}

}
