import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class CookieClickerAlpha {
	static final String input = "B-large.in";
	static final String output = "output.txt";

	public static void main(String[] args) throws IOException {
		BufferedReader f = new BufferedReader(new FileReader(input));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(
				output)));

		int testCount = readInts(f)[0];
		for (int i = 1; i <= testCount; i++) {
			double[] in = readDoubles(f);
			double cookiesInc = in[1];
			double factoryCost = in[0];
			double goal = in[2];

			double res = goal / 2;
			int factoryCount = 1;
			while (true) {
				double sum = 0;
				double sub = 0;
				for (int j = 0; j < factoryCount; j++) {
					sub += factoryCost / (2 + j * cookiesInc);
					sum += sub;
				}
				double time = (goal + factoryCost * factoryCount + sum * cookiesInc)
						/ (2 + factoryCount * cookiesInc);
				if (time < res) {
					res = time;
					factoryCount++;
				} else if (time >= res) {
					out.println("Case #" + i + ": " + res);
					System.out.println("Case #" + i + ": " + res);
					break;
				}
			}
		}
		out.close();
		System.exit(0);
	}

	private static int[] readInts(BufferedReader f) throws IOException {
		StringTokenizer st = new StringTokenizer(f.readLine());
		int[] res = new int[st.countTokens()];
		for (int i = 0; i < res.length; i++)
			res[i] = Integer.parseInt(st.nextToken());
		return res;
	}

	private static double[] readDoubles(BufferedReader f) throws IOException {
		StringTokenizer st = new StringTokenizer(f.readLine());
		double[] res = new double[st.countTokens()];
		for (int i = 0; i < res.length; i++)
			res[i] = Double.parseDouble(st.nextToken());
		return res;
	}
}
