import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class MagicTrick {

	static final String input = "A-small-attempt0.in";
	static final String output = "output.txt";

	public static void main(String[] args) throws IOException {
		// Use BufferedReader rather than RandomAccessFile; it's much faster
		BufferedReader f = new BufferedReader(new FileReader(input));
		// input file name goes above
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(
				output)));

		// Use StringTokenizer vs. readLine/split -- lots faster
		int testCount = readInts(f)[0];

		for (int i = 1; i <= testCount; i++) {
			int firstChoice = readInts(f)[0] - 1;
			int[][] firstBoard = new int[4][];
			for (int j = 0; j < firstBoard.length; j++)
				firstBoard[j] = readInts(f);
			int secondChoice = readInts(f)[0] - 1;
			int[][] secondBoard = new int[4][];
			for (int j = 0; j < secondBoard.length; j++)
				secondBoard[j] = readInts(f);

			Set<Integer> firstPos = new HashSet<Integer>();
			for (int j = 0; j < firstBoard[firstChoice].length; j++)
				firstPos.add(firstBoard[firstChoice][j]);

			Set<Integer> secondPos = new HashSet<Integer>();
			for (int j = 0; j < secondBoard[secondChoice].length; j++)
				secondPos.add(secondBoard[secondChoice][j]);

			firstPos.retainAll(secondPos);

			String res = null;
			if (firstPos.size() == 1)
				res = firstPos.toArray()[0].toString();
			else if (firstPos.size() == 0)
				res = "Volunteer cheated!";
			else
				res = "Bad magician!";
			out.println("Case #" + i + ": " + res);
		}

		out.close(); // close the output file
		System.exit(0); // don't omit this!

	}

	private static int[] readInts(BufferedReader f) throws IOException {
		StringTokenizer st = new StringTokenizer(f.readLine());
		int[] res = new int[st.countTokens()];
		for (int i = 0; i < res.length; i++)
			res[i] = Integer.parseInt(st.nextToken());
		return res;
	}
}
