import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class MinesweeperMaster {
	static final String input = "C-small-attempt1.in";
	static final String output = "output.txt";

	public static void main(String[] args) throws IOException {
		BufferedReader f = new BufferedReader(new FileReader(input));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(
				output)));

		int testCount = readInts(f)[0];
		for (int i = 1; i <= testCount; i++) {
			int[] in = readInts(f);
			int r = in[0];
			int c = in[1];
			int m = in[2];
			int[][] a = new int[r][c];
			int minesInstalled = 0;
			String res = null;
			for (int rr = r - 1; rr >= 0 && minesInstalled < m; rr--)
				for (int cc = c - 1; cc >= 0 && minesInstalled < m; cc--) {
					a[rr][cc] = Integer.MAX_VALUE;
					minesInstalled++;
				}
			if (a[0][0] == Integer.MAX_VALUE) {
				res = "Impossible";
				out.println("Case #" + i + ":\n" + res);
				System.out.println("Case #" + i + ":\n" + res);
			} else {
				if (r * c == m + 1) {
					out.println("Case #" + i + ":");
					System.out.println("Case #" + i + ":");
					printBoard(out, a);
				} else if ((c > 1 && a[0][1] == Integer.MAX_VALUE)
						|| (r > 1 && a[1][0] == Integer.MAX_VALUE)
						|| (r > 1 && c > 1 && a[1][1] == Integer.MAX_VALUE)) {
					res = "Impossible";
					out.println("Case #" + i + ":\n" + res);
					System.out.println("Case #" + i + ":\n" + res);
				} else {
					out.println("Case #" + i + ":");
					System.out.println("Case #" + i + ":");
					printBoard(out, a);
				}
			}
		}
		out.close();
		System.exit(0);
	}

	private static void printBoard(PrintWriter out, int[][] a) {
		for (int rr = 0; rr < a.length; rr++) {
			for (int cc = 0; cc < a[rr].length; cc++) {
				if (rr == 0 && cc == 0) {
					out.print("c");
					System.out.print("c");
				} else if (a[rr][cc] == Integer.MAX_VALUE) {
					out.print("*");
					System.out.print("*");
				} else {
					out.print(".");
					System.out.print(".");
				}
			}
			out.println();
			System.out.println();
		}
	}

	private static int[] readInts(BufferedReader f) throws IOException {
		StringTokenizer st = new StringTokenizer(f.readLine());
		int[] res = new int[st.countTokens()];
		for (int i = 0; i < res.length; i++)
			res[i] = Integer.parseInt(st.nextToken());
		return res;
	}

	private static double[] readDoubles(BufferedReader f) throws IOException {
		StringTokenizer st = new StringTokenizer(f.readLine());
		double[] res = new double[st.countTokens()];
		for (int i = 0; i < res.length; i++)
			res[i] = Double.parseDouble(st.nextToken());
		return res;
	}

}
