package algorithms.contests.gcj2016.round1c;

import java.util.Scanner;

/**
 * May 8, 2016 | 11:36:04 AM
 * <pre>
 * <u>Description</u>
 *
 * </pre>
 *
 * @author Essiennta Emmanuel (colourfulemmanuel@gmail.com)
 */
public class ProblemB{

    int[][] solve(int b, int m){
        long max = max4(b - 2);
        if (m > max)
            return null;
        int[][] matrix = new int[b][b];
        matrix[0][b - 1] = 1;
        for (int i = 1, used = 1; i < b - 1 && used < m; i++, used++)
            matrix[0][i] = matrix[i][b - 1] = 1;
        for (int i = 1, used = 1 + (b - 2); i < b - 1 && used < m; i++)
            for (int j = i + 1; j < b - 1 && used < m; j++) {
                if (i == j)
                    continue;
                matrix[i][j] = 1;
                used++;
                if (used < m){
                    matrix[j][i] = 1;
                    used++;
                }
            }
        return matrix;
    }

    public static void main(String[] args){

        try (Scanner sc = new Scanner(System.in)) {
            int tests = sc.nextInt();
            for (int testNo = 1; testNo <= tests; testNo++) {
                int b = sc.nextInt();
                int m = sc.nextInt();
                int[][] matrix = new ProblemB().solve(b, m);
                if (matrix == null)
                    System.out.println("Case #" + testNo + ": IMPOSSIBLE");
                else {
                    System.out.println("Case #" + testNo + ": POSSIBLE");
                    for (int i = 0; i < matrix.length; i++) {
                        StringBuilder sb = new StringBuilder();
                        for (int j = 0; j < matrix.length; j++) {
                            if (j != 0)
                                sb.append(' ');
                            sb.append(matrix[i][j]);
                        }
                        sb.append('\n');
                        System.out.print(sb);
                    }
                }
            }
        }
    }

    long max4(int b){
        int p = 1;
        long sum = p;
        for (int i = 1; i <= b; i++) {
            p = (b - i + 1) * p;
            sum += p;
        }
        return sum;
    }
}
