package codejampractice;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayDeque;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashSet;
import java.util.List;
import java.util.Queue;
import java.util.Scanner;
import java.util.Set;

/**
 *
 * @author boeingtuan
 */
public class FashionShow {

    public static void main(String[] args) {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
        long t = sc.nextLong();
        long cnt = 0;
        while (t-- > 0) {
            cnt++;
            int n = sc.nextInt();
            int m = sc.nextInt();
            sc.nextLine();
            char[][] map = new char[n][n];
            for (char[] mapChar : map) {
                Arrays.fill(mapChar, '.');
            }
            for (int i = 0; i < m; i++) {
                String[] input = sc.nextLine().split(" ");
                int x = Integer.valueOf(input[1]) - 1;
                int y = Integer.valueOf(input[2]) - 1;
                map[x][y] = input[0].charAt(0);
            }

            char[][] newMap = genMapSmallSubTest(copyArray(map));
            int value = value(newMap);
            List<ChangeObject> listChange = getListChange(map, newMap);
//            for (char[] mapChar : newMap) {
//                System.out.println(Arrays.toString(mapChar));
//            }
//            System.out.println(isValid(newMap));
//            bfs(map);
            System.out.println("Case #" + cnt + ": " + value + " " + listChange.size());
            for (ChangeObject change : listChange) {
                System.out.println(change.type + " " + change.x + " " + change.y);
            }
        }
    }

    public static List<ChangeObject> getListChange(char[][] oriMap, char[][] newMap) {
        List<ChangeObject> res = new ArrayList();
        for (int i = 0; i < oriMap.length; i++) {
            for (int j = 0; j < oriMap.length; j++) {
                if (oriMap[i][j] != newMap[i][j]) {
                    res.add(new ChangeObject(i + 1, j + 1, newMap[i][j]));
                }
            }
        }

        return res;
    }

    public static char[][] genMapSmallSubTest(char[][] map) {
        // preprocess
        boolean checkO = false;
        for (int i = 0; i < map.length; i++) {
            if (map[0][i] == '.') {
                map[0][i] = '+';
            } else if (map[0][i] == 'x') {
                map[0][i] = 'o';
                checkO = true;
            } else if (map[0][i] == 'o') {
                checkO = true;
            }
        }
        if (!checkO) {
            map[0][0] = 'o';
        }

        if (map.length > 3) {
            char[][] newMap = copyArray(map);
            int row = 1;

            for (int col = 1; col < newMap.length - 2; col++) {
                newMap[newMap.length - 1][col] = '+';
            }
            if (newMap[0][newMap.length - 2] == 'o') {
                newMap[newMap.length - 1][newMap.length - 3] = 'o';
                newMap[newMap.length - 1][newMap.length - 2] = '+';
            } else {
                newMap[newMap.length - 1][newMap.length - 2] = 'o';
            }

            for (int col = 0; col < newMap.length; col++) {
                if (newMap[0][col] != 'o' && newMap[newMap.length - 1][col] != 'o') {
                    newMap[row][col] = 'x';
                    row++;
                }
            }
            return newMap;
        } else if (map.length == 1) {
            char[][] newMap = {{'o'}};
            return newMap;
        } else if (map.length == 2) {
            if (map[0][0] == 'o') {
                char[][] newMap = {
                    {'o', '+'},
                    {'.', 'x'}
                };
                return newMap;
            } else {
                char[][] newMap = {
                    {'+', 'o'},
                    {'x', '.'}
                };
                return newMap;
            }
        } else {
            if (map[0][0] == 'o') {
                char[][] newMap = {
                    {'o', '+', '+'},
                    {'.', '.', 'x'},
                    {'.', 'o', '.'}
                };
                return newMap;
            } else if (map[0][1] == 'o') {
                char[][] newMap = {
                    {'+', 'o', '+'},
                    {'x', '.', '.'},
                    {'.', '+', 'x'}
                };
                return newMap;
            } else {
                char[][] newMap = {
                    {'+', '+', 'o'},
                    {'x', '.', '.'},
                    {'.', 'o', '.'}
                };
                return newMap;
            }
        }
    }

    public static char[][] copyArray(char[][] current) {
        char[][] old = new char[current.length][current.length];
        for (int i = 0; i < old.length; i++) {
            for (int j = 0; j < old[i].length; j++) {
                old[i][j] = current[i][j];
            }
        }
        return old;
    }

    public static String arrayToString(char[][] map) {
        String res = "";
        for (char[] mapChar : map) {
            res += Arrays.toString(mapChar);
        }
        return res;
    }

    public static int bfs(char[][] map) {
        Set<String> state = new HashSet();
        int max = value(map);
        int currentValue;
        char[][] maxMap = map;
        ObjectShow startShow = new ObjectShow(map);
        Queue<ObjectShow> queue = new ArrayDeque();
        queue.add(startShow);
        state.add(arrayToString(map));
        while (!queue.isEmpty()) {
            ObjectShow obj = queue.poll();
            for (int i = 0; i < obj.map.length; i++) {
                for (int j = 0; j < obj.map.length; j++) {
                    for (int k = 0; k < 4; k++) {
                        char[][] tmp = copyArray(obj.map);
                        // 0 = x; 1 = +; 2 = o; 3 = .
                        if (map[i][j] != '.' && k != 2) {
                            continue;
                        }
                        switch (k) {
                            case 0:
                                tmp[i][j] = 'x';
                                break;
                            case 1:
                                tmp[i][j] = '+';
                                break;
                            case 2:
                                tmp[i][j] = 'o';
                                break;
                            case 3:
                                tmp[i][j] = '.';
                                break;
                        }
                        if (isValid(tmp)) {
                            ObjectShow newObj = new ObjectShow(tmp);
                            String hash = arrayToString(tmp);
                            if (!state.contains(hash)) {
                                queue.add(newObj);
                                state.add(hash);
                                currentValue = value(tmp);
                                if (currentValue > max) {
                                    max = currentValue;
                                    maxMap = tmp;
                                    System.out.println(max);
                                    for (char[] mapChar : tmp) {
                                        System.out.println(Arrays.toString(mapChar));
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        System.out.println(max);
        for (char[] mapChar : maxMap) {
            System.out.println(Arrays.toString(mapChar));
        }
        return -1;
    }

    public static int value(char[][] map) {
        int cnt = 0;
        for (char[] mapChar : map) {
            for (int i = 0; i < mapChar.length; i++) {
                if (mapChar[i] == '+' || mapChar[i] == 'x') {
                    cnt++;
                } else if (mapChar[i] == 'o') {
                    cnt += 2;
                }
            }
        }
        return cnt;
    }

    public static boolean isValid(char[][] map) {
        // check row        
        for (int i = 0; i < map.length; i++) {
            int cnt = 0;
            for (int j = 0; j < map.length; j++) {
                if (map[i][j] == 'x' || map[i][j] == 'o') {
                    cnt++;
                }
            }
            if (cnt > 1) {
                return false;
            }
        }
        // check col
        for (int i = 0; i < map.length; i++) {
            int cnt = 0;
            for (int j = 0; j < map.length; j++) {
                if (map[j][i] == 'x' || map[j][i] == 'o') {
                    cnt++;
                }
            }
            if (cnt > 1) {
                return false;
            }
        }
        // check diagonal
        int[] cntMainDiagonal = new int[map.length * 2 - 1];
        Arrays.fill(cntMainDiagonal, 0);
        for (int i = 0; i < map.length; i++) {
            for (int j = 0; j < map.length; j++) {
                if (map[i][j] == '+' || map[i][j] == 'o') {
                    cntMainDiagonal[i + j]++;
                }
            }
        }
        for (int i = 0; i < cntMainDiagonal.length; i++) {
            if (cntMainDiagonal[i] > 1) {
                return false;
            }
        }
        // check diagonal
        int[] cntLeftDiagonal = new int[map.length * 2 - 1];
        int offset = map.length - 1;
        Arrays.fill(cntLeftDiagonal, 0);
        for (int i = 0; i < map.length; i++) {
            for (int j = 0; j < map.length; j++) {
                if (map[i][j] == '+' || map[i][j] == 'o') {
                    cntLeftDiagonal[i - j + offset]++;
                }
            }
        }
        for (int i = 0; i < cntMainDiagonal.length; i++) {
            if (cntLeftDiagonal[i] > 1) {
                return false;
            }
        }
        return true;
    }

    public static class ObjectShow {

        char[][] map;

        public ObjectShow(char[][] map) {
            this.map = map;
        }
    }

    public static class ChangeObject {

        int x;
        int y;
        char type;

        public ChangeObject(int x, int y, char type) {
            this.x = x;
            this.y = y;
            this.type = type;
        }
    }
}
