import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class AlphabetCake {
	private Set<Character> alphabets = new HashSet<Character>();
	private char[][] array;
	private int nbBlank = 0;
	
	public AlphabetCake(char[][] array){
		this.array = array;
		for(char[] a : array){
			for(char c : a){
				if(c != '?')
					alphabets.add(c);
				else
					nbBlank++;
			}
		}
	}
	
	public char[][] fillBlankAlphabet(){
		if(nbBlank > 0){
			int row = array.length;
			int column = array[0].length;
			List<Integer> blankColumn = new ArrayList<Integer>();
			for(int i=0; i<column; i++){
				List<Character> columnChars = new ArrayList<Character>();
				for(int j=0; j<row; j++){
					char current = array[j][i]; 
					if(current != '?'){
						if(!columnChars.contains(current)){
							columnChars.add(current);
						}
					}
				}
				
				if(columnChars.size()>0){
					if(columnChars.size() == 1){
						for(int j=0; j<row; j++){
							array[j][i] = columnChars.get(0);
						}
					}else{
						int index = 0;
						for(int j=0; j<row; j++){
							char current = array[j][i]; 
							if(current == columnChars.get(index) || current == '?'){
								array[j][i] = columnChars.get(index);
							}else{
								index++;
								array[j][i] = columnChars.get(index);
							}
						}
					}
				}else{
					blankColumn.add(i);
				}
			}
			
			if(blankColumn.size()>0){
				for(int i=0; i<blankColumn.size(); i++){
					int replacementIndex = -1;
					int index = blankColumn.get(i);
					if(index != array[0].length-1){
						for(int j=index+1; j<column; j++){
							if(array[0][j]!='?'){
								replacementIndex = j;
								break;
							}
						}
						if(replacementIndex==-1){
							for(int j=index-1; j>=0; j--){
								if(array[0][j]!='?'){
									replacementIndex = j;
									break;
								}
							}
						}
						if(replacementIndex>-1){
							for(int k=0; k<row; k++){
								array[k][index] = array[k][replacementIndex];
							}
						}
					}else{
						for(int j=index-1; j>=0; j--){
							if(array[0][j]!='?'){
								replacementIndex = j;
								break;
							}
						}
						if(replacementIndex>-1){
							for(int k=0; k<row; k++){
								array[k][index] = array[k][replacementIndex];
							}
						}
					}
					
				}
			}
		}
		return this.array;
	}

	public static void main(String[] args) throws IOException{
		FileReader fr = new FileReader("A-large.in");
		BufferedReader br = new BufferedReader(fr);
		
		FileWriter fw = new FileWriter("output.txt");
		BufferedWriter bw = new BufferedWriter(fw);
		
		String line = br.readLine();
		int nb = Integer.parseInt(line);
		for(int i=0; i<nb; i++){
			// read R & C
			line = br.readLine();
			String[] split = line.split(" ");
			int r = Integer.parseInt(split[0]);
			int c = Integer.parseInt(split[1]);
			char[][] array = new char[r][c];
			for(int j=0; j<r; j++){
				// content
				line = br.readLine();
				for(int k=0; k<c; k++){
					array[j][k] = line.charAt(k);
				}
			}
			
			AlphabetCake ac = new AlphabetCake(array);
			array = ac.fillBlankAlphabet();
			
			//Case #1:
			bw.write(String.format("Case #%d:", i+1));
			bw.newLine();
			for(int l=0; l<r; l++){
				for(int m=0; m<c; m++){
					bw.write(array[l][m]);
				}
				bw.newLine();
			}
		}
		
		bw.close();
		fw.close();
		br.close();
		fr.close();
	}
}
