import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class BathroomStall {
	private long k;
	private long n;
	
	public BathroomStall(long n, long k){
		this.n = n;
		this.k = k;
	}
	
	private static MaxMin generateMaxMin(long value){
		MaxMin retval = new MaxMin();
		long divisor = value/2;
		long remainder = value%2;
		if(remainder==1){
			retval.setMax(divisor);
			retval.setMin(divisor);
		}else{
			retval.setMax(divisor);
			if(divisor>0)
				retval.setMin(divisor-1);
			else
				retval.setMin(divisor);
		}
		return retval;
	}

	public MaxMin getKthMaxMin(){
		if(k==1){
			return generateMaxMin(n);
		}
		
		MaxMin retval = new MaxMin();
		
		int a = 1;
		int level = 1;
		while(a<k){
			level++;
			a = (int) Math.pow(2, level) - 1;
		}
		
		Map<Long,Long> maxMinEachLevel = new HashMap<Long, Long>();
		for(int i=0; i<level-1; i++){
			if(i==0){
				long divisor = n/2;
				long remainder = n%2;
				if(remainder==1){
					maxMinEachLevel.put(divisor, 2L);
				}else{
					maxMinEachLevel.put(divisor, 1L);
					maxMinEachLevel.put(divisor-1, 1L);
				}
			}else{
				Set<Long> keySet = maxMinEachLevel.keySet();
				Map<Long,Long> temp = new HashMap<Long, Long>();
				for(long key : keySet){
					if(key>0){
						long value = maxMinEachLevel.get(key);
						
						long divisor = key/2;
						long remainder = key%2;
						if(remainder==1){
							Long prev = temp.get(divisor);
							if(prev==null){
								temp.put(divisor, 2*value);
							}else{
								temp.put(divisor, 2*value + prev);
							}
						}else{
							Long prev = temp.get(divisor);
							if(prev==null){
								temp.put(divisor, value);
							}else{
								temp.put(divisor, value + prev);
							}
							prev = temp.get(divisor-1);
							if(prev==null){
								temp.put(divisor-1, value);
							}else{
								temp.put(divisor-1, value + prev);
							}
						}
					}
				}
				maxMinEachLevel = temp;
			}
		}
		
		int b = (int) Math.pow(2, level-1) - 1;
		Object[] keys = maxMinEachLevel.keySet().toArray();
		Arrays.sort(keys, Collections.reverseOrder());
		long kValue = 0;
		for(Object key : keys){
			long value = maxMinEachLevel.get(key);
			b += value;
			if(k<=b){
				kValue = (Long)key;
				break;
			}
		}
		
		long divisor = kValue/2;
		long remainder = kValue%2;
		if(remainder==1){
			retval.setMax(divisor);
			retval.setMin(divisor);
		}else{
			retval.setMax(divisor);
			if(divisor>0)
				retval.setMin(divisor-1);
			else
				retval.setMin(divisor);
		}
		return retval;
	}
	
	public static void main(String[] args) throws IOException{
		FileReader fr = new FileReader("C-small-2-attempt0.in");
		BufferedReader br = new BufferedReader(fr);
		
		FileWriter fw = new FileWriter("output.txt");
		BufferedWriter bw = new BufferedWriter(fw);
		
		String line = br.readLine();
		int nb = Integer.parseInt(line);
		for(int i=0; i<nb; i++){
			line = br.readLine();
			String[] inputs = line.split(" ");
			
			BathroomStall stall = new BathroomStall(Long.parseLong(inputs[0]), Long.parseLong(inputs[1]));
			MaxMin kthMaxMin = stall.getKthMaxMin();
			
			//Case #1: 1 0
			bw.write(String.format("Case #%d: %d %d", i+1, kthMaxMin.getMax(), kthMaxMin.getMin()));
			bw.newLine();
		}
		
		bw.close();
		fw.close();
		br.close();
		fr.close();
	}
}

class MaxMin {
	private long max;
	private long min;
	
	public long getMax() {
		return max;
	}
	public void setMax(long max) {
		this.max = max;
	}
	public long getMin() {
		return min;
	}
	public void setMin(long min) {
		this.min = min;
	}
	
	public String toString(){
		return String.format("max=%d, min=%d", max, min);
	}
}
