import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class PancakeFlipper {
	private int k;
	
	// the i-th pancakes is true if represented as +, false if represented as -
	private boolean[] pancakes;
	
	public int getK() {
		return k;
	}
	public void setK(int k) {
		this.k = k;
	}
	public boolean[] getPancakes() {
		return pancakes;
	}
	public void setPancakes(boolean[] pancakes) {
		this.pancakes = pancakes;
	}
	
	public PancakeFlipper(String s, int k){
		this.k = k;
		pancakes = new boolean[s.length()];
		for(int i=0; i<s.length(); i++){
			if(s.charAt(i) == '+'){
				pancakes[i] = true;
			}else if(s.charAt(i) != '-'){
				throw new RuntimeException("Input string S is not valid!");
			}
		}
	}

	// Get the minimum number of flip to make all elements in pancakes array true. Return -1 if impossible.
	public int getMinimumFlip(){
		int minFlip = 0;
		for(int i=0; i<pancakes.length; i++){
			if(pancakes[i]==false){
				if((pancakes.length-i)>=k){
					// flip it
					for(int j=0; j<k; j++){
						pancakes[i+j] = !pancakes[i+j];
					}
					minFlip++;
				}else{
					minFlip = -1;
					break;
				}
			}
		}
		return minFlip;
	}
	
	public static void main(String[] args) throws IOException{
		FileReader fr = new FileReader("A-large.in");
		BufferedReader br = new BufferedReader(fr);
		
		FileWriter fw = new FileWriter("output.txt");
		BufferedWriter bw = new BufferedWriter(fw);
		
		String line = br.readLine();
		int nb = Integer.parseInt(line);
		for(int i=0; i<nb; i++){
			line = br.readLine();
			String[] arr = line.split(" ");
			PancakeFlipper pancake = new PancakeFlipper(arr[0], Integer.parseInt(arr[1]));
			int minFlip = pancake.getMinimumFlip();
			String out;
			if(minFlip>=0){
				//Case #1: 3
				out = String.format("Case #%d: %d", i+1, minFlip);
			}else{
				//Case #3: IMPOSSIBLE
				out = String.format("Case #%d: IMPOSSIBLE", i+1);
			}
			bw.write(out);
			bw.newLine();
		}
		
		bw.close();
		fw.close();
		br.close();
		fr.close();
	}
}
