import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class TidyNumber {
	private long last;
	public TidyNumber(long last){
		this.last = last;
	}
	
	private List<Integer> convertToLsdDigits(){
		List<Integer> lsd = new ArrayList<Integer>();
		long temp = last;
		long remainder = temp % 10;
		while(temp>0){
			lsd.add((int)remainder);
			
			temp /= 10;
			remainder = temp % 10;
		}
		
		return lsd;
	}
	
	public long getLastTidyNumber(){
		List<Integer> digitLsd = convertToLsdDigits();

		for(int i=0; i<digitLsd.size(); i++){
			if(i+1 >= digitLsd.size()){
				// digits-i is the last digit
				if(digitLsd.get(i)==0)
					digitLsd.remove(i);
			}else{
				int prevDigitIndex = i+1;
				int currentDigit = digitLsd.get(i);
				int prevDigit = digitLsd.get(prevDigitIndex);
				if(currentDigit<prevDigit){
					digitLsd.set(i, 9);
					digitLsd.set(prevDigitIndex, prevDigit-1);
				}
			}
		}
		
		// reverse the digits
		for(int i=0; i<digitLsd.size()/2; i++){
			int pair = digitLsd.size()-i-1;
			int temp = digitLsd.set(i, digitLsd.get(pair));
			digitLsd.set(pair, temp);
		}
		
		boolean found9 = false;
		StringBuilder sb = new StringBuilder();
		for(int i=0; i<digitLsd.size(); i++){
			if(found9)
				digitLsd.set(i, 9);
			else if(digitLsd.get(i)==9)
				found9 = true;
			sb.append(digitLsd.get(i));
		}
		
		return Long.parseLong(sb.toString());
	}
	
	public static void main(String[] args) throws IOException{
		FileReader fr = new FileReader("B-large.in");
		BufferedReader br = new BufferedReader(fr);
		
		FileWriter fw = new FileWriter("output.txt");
		BufferedWriter bw = new BufferedWriter(fw);
		
		String line = br.readLine();
		int nb = Integer.parseInt(line);
		for(int i=0; i<nb; i++){
			line = br.readLine();
			
			TidyNumber tidyNumber = new TidyNumber(Long.parseLong(line));
			long lastTidy = tidyNumber.getLastTidyNumber();

			// Case #1: 129
			bw.write(String.format("Case #%d: %d", i+1, lastTidy));
			bw.newLine();
		}
		
		bw.close();
		fw.close();
		br.close();
		fr.close();
	}
}
