import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.Scanner;

public class GCJ2009_R2_P1_MainClass {
	
	private static final String CLASSNAME = "GCJ2009_R2_P1_MainClass";
	private int T;
	
	private int[] results;
	
	public GCJ2009_R2_P1_MainClass(String fileName) {
		FileInputStream finStr = null;
		try {
			finStr = new FileInputStream(fileName);
		} catch (Exception e) {
			System.err.println("["+CLASSNAME+"::Constructor("+fileName+")] Unable to open input file");
			e.printStackTrace();
			return;
		}
		
		readData(finStr);
		
		try {
			finStr.close();
		} catch (Exception e) {
			System.err.println("["+CLASSNAME+"::Constructor("+fileName+")] Unable to close input file");
			e.printStackTrace();
			return;
		}
		
		regularizeData();
	}
	
	private void readData(InputStream inputStream) {
		Scanner consoleInput = new Scanner(inputStream);
		T = consoleInput.nextInt();
		consoleInput.nextLine();
		results = new int[T];
		
		for (int i=0;i<T;++i) {
			int N = consoleInput.nextInt();
			consoleInput.nextLine();
			
			int[][] rows = new int[N][N];
			
			for (int i1=0; i1<N; ++i1) {
				String s = consoleInput.nextLine();
				for (int j1=0; j1<N; ++j1) {
					rows[i1][j1] = s.charAt(j1)-'0';
				}
			}
			
			results[i] = solveOneCase(rows);
		}		
	}
	
	private void regularizeData() {
		
	}
	
	private int cmp(int[] a, int[] b, int k) {	
		int n = a.length;
		for (int i=n-1;i>k;--i) {
			if (a[i] < b[i]) return -1;
			if (a[i] > b[i]) return 1;
		}
		return 0;
	}
	
	private int solveOneCase(int[][] rows) {
		int n = rows.length;
		int[] index = new int[n];
		for (int i=0;i<n;++i) {
			index[i] = i;
		}
		for (int i=0;i<n-1;++i) {
			for (int j=i+1;j<n;++j) {
				if (cmp(rows[index[i]],rows[index[j]],i) > 0) {
					int aux = index[i];
					index[i] = index[j];
					index[j] = aux;
				} else if (cmp(rows[index[i]],rows[index[j]],i) == 0 && index[i] > index[j]) {
					int aux = index[i];
					index[i] = index[j];
					index[j] = aux;
				}
			}
		}
		
		int cost = 0;
		for (int i=0;i<n;++i) {
			int cnt = -1;
			for (int j=i;j<n;++j) {
				if (index[j] == i) {cnt = j; break;}
			}
			cost += (cnt-i);
			for (int j=cnt;j>i;--j) {
				index[j] = index[j-1];
			}
		}
		
		return cost;
	}
	
	
	public void solve() {
		
	}
	
	public void writeResults(String fileName) {
		FileWriter fwriter = null;
		try {
			fwriter = new FileWriter(fileName);
		} catch (IOException e) {
			System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to open output file");
			e.printStackTrace();
			return;
		}
        BufferedWriter fbwriter = new BufferedWriter(fwriter);
        
        try {
        	for (int i=0; i<T; ++i) {
            	fbwriter.write("Case #"+(i+1)+": ");
            	fbwriter.write(""+results[i]);	
            	fbwriter.newLine();
            }
        } catch (IOException e) {
			System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to write to output file");
			e.printStackTrace();
			try {
				fbwriter.close();
				fwriter.close();
			} catch (IOException e2) {
				System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to close output file");
				e2.printStackTrace();
			}
			return;
		}
        
        try {
			fbwriter.close();
			fwriter.close();
		} catch (IOException e) {
			System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to close output file");
			e.printStackTrace();
		}        
	}
	
	public static void main(String[] args) {
		if (args.length == 2) {
			GCJ2009_R2_P1_MainClass mainObject = new GCJ2009_R2_P1_MainClass(args[0]);
			//mainObject.solve();
			mainObject.writeResults(args[1]);
		} else {
			System.err.println("["+CLASSNAME+"::main] Not enough arguments (please run with arguments: _inputfile _outputfile)");
		}
	}
}
