import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.util.Scanner;

public class GCJ2009_R2_P4_MainClass {
	
	private static final String CLASSNAME = "GCJ2009_R2_P4_MainClass";
	private int T;
	
	private double[] results;
	
	public GCJ2009_R2_P4_MainClass(String fileName) {
		FileInputStream finStr = null;
		try {
			finStr = new FileInputStream(fileName);
		} catch (Exception e) {
			System.err.println("["+CLASSNAME+"::Constructor("+fileName+")] Unable to open input file");
			e.printStackTrace();
			return;
		}
		
		readData(finStr);
		
		try {
			finStr.close();
		} catch (Exception e) {
			System.err.println("["+CLASSNAME+"::Constructor("+fileName+")] Unable to close input file");
			e.printStackTrace();
			return;
		}
		
		regularizeData();
	}
	
	private void readData(InputStream inputStream) {
		Scanner consoleInput = new Scanner(inputStream);
		T = consoleInput.nextInt();
		consoleInput.nextLine();
		results = new double[T];
		
		for (int i=0;i<T;++i) {
			int N = consoleInput.nextInt();
			consoleInput.nextLine();
			
			int[][] plants = new int[N][3];
			
			for (int i1=0; i1<N; ++i1) {
				for (int j1=0; j1<3; ++j1) {
					plants[i1][j1] = consoleInput.nextInt();
				}
				if (!(i == T-1 && i1 == N-1)) consoleInput.nextLine();
			}
			
			results[i] = solveOneCase(N,plants);
		}		
	}
	
	private void regularizeData() {
		
	}
	
	private double dist(int[] c1, int[] c2) {
		double d1 = Math.sqrt((c1[0] - c2[0])*(c1[0] - c2[0]) +(c1[1] - c2[1])*(c1[1] - c2[1]));
		d1 += (c1[2] + c2[2]);
		return d1/2;
	}
	
	private double solveOneCase(int N, int[][] plants) {
		double result;
		if (N == 1) result = plants[0][2];
		else if (N == 2) result = Math.max(plants[0][2], plants[1][2]);
		else if (N == 3) {
			double r1 = Math.max(plants[0][2], dist(plants[1],plants[2]));
			double r2 = Math.max(plants[1][2], dist(plants[0],plants[2]));
			double r3 = Math.max(plants[2][2], dist(plants[0],plants[1]));
			
			result = Math.min(Math.min(r1,r2), r3);
		}
		else result = 0;
		return result;
	}
	
	public void solve() {
		
	}
	
	public void writeResults(String fileName) {
		FileWriter fwriter = null;
		try {
			fwriter = new FileWriter(fileName);
		} catch (IOException e) {
			System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to open output file");
			e.printStackTrace();
			return;
		}
        BufferedWriter fbwriter = new BufferedWriter(fwriter);
        
        try {
        	for (int i=0; i<T; ++i) {
            	fbwriter.write("Case #"+(i+1)+": ");
            	fbwriter.write(""+String.format("%.7f",results[i]));	
            	fbwriter.newLine();
            }
        } catch (IOException e) {
			System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to write to output file");
			e.printStackTrace();
			try {
				fbwriter.close();
				fwriter.close();
			} catch (IOException e2) {
				System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to close output file");
				e2.printStackTrace();
			}
			return;
		}
        
        try {
			fbwriter.close();
			fwriter.close();
		} catch (IOException e) {
			System.err.println("["+CLASSNAME+"::writeResults("+fileName+"] Unable to close output file");
			e.printStackTrace();
		}        
	}
	
	public static void main(String[] args) {
		if (args.length == 2) {
			GCJ2009_R2_P4_MainClass mainObject = new GCJ2009_R2_P4_MainClass(args[0]);
			//mainObject.solve();
			mainObject.writeResults(args[1]);
		} else {
			System.err.println("["+CLASSNAME+"::main] Not enough arguments (please run with arguments: _inputfile _outputfile)");
		}
	}
}
