import java.io.*;
import java.util.*;

public class Main {

    private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    private static PrintWriter out = new PrintWriter(System.out, true);
    private static StringTokenizer st;

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new FileReader("C:\\Users\\bogda\\Downloads\\C-small-2-attempt0.in"));
        out = new PrintWriter(new FileWriter("C:\\Users\\bogda\\Downloads\\C-small-2-attempt0.out"));
        int testCount = nextInt();
        for (int test = 1; test <= testCount; test++) {
            long n = nextLong();
            long k = nextLong();
            long[] res = solveFast(n, k);
            out.println("Case #" + test + ": " + res[0] + " " + res[1]);
        }
        /*for (int n = 1; n <= 1000; n++) {
            for (int k = 1; k <= n; k++) {
                int[] resSlow = solveSlow(n, k);
                long[] resFast = solveFast(n, k);
                if (resSlow[0] != resFast[0] || resSlow[1] != resFast[1]) {
                    out.println(n + " " + k + " " + resSlow[0] + " " + resSlow[1] + " " + resFast[0] + " " + resFast[1]);
                }
            }
        }*/
        out.close();
    }

    private static long[] solveFast(long n, long k) {
        n -= k;
        while (k > 0) {
            if (k >= 2) {
                n /= 2;
                k /= 2;
            }
            if (k == 1) {
                break;
            }
        }
        return new long[]{n - n / 2, n / 2};
    }

    private static int[] solveSlow(int n, int k) {
        int[] segments = new int[n + 1];
        int last = 1;
        segments[0] = n;
        for (int i = 0; i < k; i++) {
            int resIndex = 0;
            for (int j = 0; j < last; j++) {
                if (segments[j] > segments[resIndex]) {
                    resIndex = j;
                }
            }
            if (i == k - 1) {
                int value = segments[resIndex] - 1;
                return new int[]{value - value / 2, value / 2};
            } else {
                int value = segments[resIndex] - 1;
                segments[resIndex] = value / 2;
                segments[last] = value - value / 2;
                last++;
            }
        }
        throw new RuntimeException("impossible");
    }

    private static int nextInt() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Integer.parseInt(st.nextToken());
    }

    private static long nextLong() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Long.parseLong(st.nextToken());
    }

    private static double nextDouble() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Double.parseDouble(st.nextToken());
    }

    private static String nextToken() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return st.nextToken();
    }

}
