import java.io.*;
import java.util.*;

public class Main {

    private static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    private static PrintWriter out = new PrintWriter(System.out, true);
    private static StringTokenizer st;

    public static void main(String[] args) throws Exception {
        in = new BufferedReader(new FileReader("C:\\Users\\bogda\\Downloads\\B-small-attempt0.in"));
        out = new PrintWriter(new FileWriter("C:\\Users\\bogda\\Downloads\\B-small-attempt0.out"));
        int testCount = nextInt();
        for (int test = 1; test <= testCount; test++) {
            long n = nextLong();
            out.println("Case #" + test + ": " + solveFast(n));
        }
        out.close();
    }

    private static long solveFast(long n) {
        if (isOk(n)) return n;
        while (!isOk(n)) {
            String s = String.valueOf(n);
            for (int i = 1; i < s.length(); i++) {
                if (s.charAt(i) < s.charAt(i - 1)) {
                    int j = i;
                    while (s.charAt(j) == s.charAt(i) && j > 0) {
                        j--;
                    }
                    StringBuilder stb = new StringBuilder(s);
                    stb.setCharAt(j, (char) (s.charAt(j) - 1));
                    for (int k = j + 1; k < s.length(); k++) {
                        stb.setCharAt(k, '9');
                    }
                    n = Long.parseLong(stb.toString());
                    break;
                }
            }
        }
        return n;
    }

    private static long solveSlow(long n) {
        long res = 1;
        for (long i = 1; i <= n; i++) {
            if (isOk(i)) {
                res = i;
            }
        }
        return res;
    }

    private static boolean isOk(long n) {
        long lastDigit = 9;
        while (n > 0) {
            long digit = n % 10;
            n /= 10;
            if (digit > lastDigit) {
                return false;
            }
            lastDigit = digit;
        }
        return true;
    }

    private static int nextInt() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Integer.parseInt(st.nextToken());
    }

    private static long nextLong() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Long.parseLong(st.nextToken());
    }

    private static double nextDouble() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Double.parseDouble(st.nextToken());
    }

    private static String nextToken() throws Exception {
        if (st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return st.nextToken();
    }

}
