import java.io.*;
import java.util.*;

public class Main {

    static BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    static PrintWriter out = new PrintWriter(System.out,true);
    static StringTokenizer st;

    public static void main(String[] args) throws Exception {
        int T = nextInt();
        for(int t = 1;t <= T;t++) {
            int r = nextInt(), c = nextInt(), m = nextInt();
            char[][] ans = null;
            for(int i = 0;i < r && ans == null;i++) {
                for(int j = 0;j < c && ans == null;j++) {
                    ans = bfs(i, j, r, c, r*c-m);
                }
            }
            out.println("Case #"+t+":");
            if(ans != null) {
                for(int i = 0;i < r;i++){
                    for(int j = 0;j < c;j++) {
                        out.print(ans[i][j]);
                    }
                    out.println();
                }
            }else{
                out.println("Impossible");
            }
        }
    }

    public static char[][] bfs(int x, int y, int r, int c, int res) {
        char[][] arr = new char[r][c];
        for(int i = 0;i < r;i++) {
            for(int j = 0;j < c;j++) {
                arr[i][j] = '*';
            }
        }
        Queue<Integer> queue = new LinkedList<>();
        queue.add(x+100*y);
        arr[x][y] = 'c';
        int currOpen = 1;
        while(!(queue.isEmpty() || currOpen == res)) {
            int tmp = queue.poll();
            int cx = tmp % 100;
            int cy = tmp / 100;
            int addOpen = 0;
            for(int i = -1;i <= 1;i++) {
                for(int j = -1;j <= 1;j++) {
                    if(cx + i < 0 || cx + i >= r || cy + j < 0 || cy + j >= c) continue;
                    if(arr[cx+i][cy+j] == '*') addOpen++;
                }
            }
            if(currOpen + addOpen > res) continue;
            for(int i = -1;i <= 1;i++) {
                for(int j = -1;j <= 1;j++) {
                    if(cx + i < 0 || cx + i >= r || cy + j < 0 || cy + j >= c) continue;
                    if(arr[cx+i][cy+j] == '*') {
                        currOpen++;
                        queue.add(cx+i+(cy+j)*100);
                        arr[cx+i][cy+j] = '.';
                    }
                }
            }
        }
        if(currOpen == res) {
            return arr;
        }
        return null;
    }

    public static int nextInt() throws Exception {
        if(st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Integer.parseInt(st.nextToken());
    }

    public static long nextLong() throws Exception {
        if(st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine());
        return Long.parseLong(st.nextToken());
    }

    public static double nextDouble() throws Exception {
        if(st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine()," ");
        return Double.parseDouble(st.nextToken());
    }

    public static String nextToken() throws Exception {
        if(st == null || !st.hasMoreTokens()) st = new StringTokenizer(in.readLine()," ");
        return st.nextToken();
    }
}