import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

public class ProblemC {
    final static String PROBLEM_NAME = "ProblemC";
    final static String WORK_DIR = "d:\\work\\algorithms\\codejam\\CodeJam2014_R1B\\src\\";

    private static final int UNVISITED = 0;
    private static final int VISITED = 1;

    public void solve(Scanner sc, PrintWriter pw) {
        int N = sc.nextInt();
        int M = sc.nextInt();

        int start = -1;
        int minZip = Integer.MAX_VALUE;

        boolean[] visited = new boolean[N];
        Vertex[] graph = new Vertex[N];
        for (int i = 0; i < N; i++) {
            graph[i] = new Vertex();
            graph[i].zipCode = sc.nextInt();
            graph[i].idx = i;
            visited[i] = false;

            if (graph[i].zipCode < minZip) {
                minZip = graph[i].zipCode;
                start = i;
            }
        }

        for (int i = 0; i < M; i++) {
            int a = sc.nextInt();
            int b = sc.nextInt();

            graph[a-1].adj.add(b-1);
            graph[b-1].adj.add(a-1);
        }

        String result = "";

        dfsVisit(start, graph, visited, pw);

        pw.println();

        /*List<Vertex> pos = new ArrayList<Vertex>();
        pos.add(graph[start]);

        int lastAddedIdx = start;
        while (true) {
            result += String.valueOf(graph[lastAddedIdx].zipCode);
            visited[lastAddedIdx] = true;

            // Remove.
            Iterator<Vertex> it = pos.iterator();
            while (it.hasNext()) {
                Vertex v = it.next();
                if (lastAddedIdx == v.idx) {
                    it.remove();
                    break;
                }
            }

            for (int adj : graph[lastAddedIdx].adj) {
                if (!visited[adj]) {
                    pos.add(graph[adj]);
                }
            }

            minZip = Integer.MAX_VALUE;
            int newMin = -1;
            for (Vertex v : pos) {
                if (!visited[v.idx] && minZip > v.zipCode) {
                    newMin = v.idx;
                    minZip = v.zipCode;
                }
            }

            if (newMin > -1) {
                lastAddedIdx = newMin;
            } else {
                break;
            }
        }*/

        //pw.println(result);
    }


    public void dfsVisit(int vertexIdx, Vertex[] graph, boolean[] visited, PrintWriter pw) {
        pw.print(String.valueOf(graph[vertexIdx].zipCode));
        visited[vertexIdx] = true;

        while (true) {
            int minZip = Integer.MAX_VALUE;
            int nextMin = -1;
            for (int v : graph[vertexIdx].adj) {
                if (!visited[v] && minZip > graph[v].zipCode) {
                    nextMin = v;
                    minZip = graph[v].zipCode;
                }
            }

            if (nextMin >= 0) {
                dfsVisit(nextMin, graph, visited, pw);
            } else {
                return;
            }
        }
    }

    public class Vertex implements Comparable<Vertex> {
        int idx;
        List<Integer> adj = new ArrayList<Integer>();
        int zipCode;

        @Override
        public int compareTo(Vertex o) {
            if (this.zipCode == o.zipCode) {
                return 0;
            } else {
                return this.zipCode - o.zipCode;
            }
        }
    }

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new FileReader(WORK_DIR + PROBLEM_NAME + ".in"));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + PROBLEM_NAME + ".out"));

        int N = sc.nextInt();

        for (int testNum=1; testNum <= N; testNum++) {
            System.out.println("Processing test case: " + testNum);
            pw.print("Case #" + (testNum) + ": ");
            new ProblemC().solve(sc, pw);
        }

        pw.flush();
        pw.close();
        sc.close();
    }
}
