import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.Scanner;

public class ProblemB {
    final static String PROBLEM_NAME = "ProblemB";
    final static String WORK_DIR = "d:\\work\\idea_work\\codejam2014\\src\\";

    public void solve(Scanner sc, PrintWriter pw) {
        double C = Double.parseDouble(sc.next());
        double F = Double.parseDouble(sc.next());
        double X = Double.parseDouble(sc.next());

        double result = X/2.0;

        double tc = 0; // Sum of times required for farm productions.
        double pr = 2.0; // current production per second.
        while(true) {
            tc += C/pr; // Calculate time of next farm production
            pr += F; // Increase production.

            double newResult = tc + X/pr;
            if (newResult > result) {
                break;
            } else {
                result = newResult;
            }
        }

        pw.println(result);
    }

    public static void main(String[] args) throws Exception {
        Scanner sc = new Scanner(new FileReader(WORK_DIR + PROBLEM_NAME + ".in"));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + PROBLEM_NAME + ".out"));

        int N = sc.nextInt();

        for (int testNum=1; testNum <= N; testNum++) {
            System.out.println("Processing test case: " + testNum);
            pw.print("Case #" + (testNum) + ": ");
            new ProblemB().solve(sc, pw);
        }

        pw.flush();
        pw.close();
        sc.close();
    }
}
