/*
 * bohlampijar@gmail.com
 * Question 2: Train Timetable
 *
 */

import java.util.*;

public class TrainTime {
  
  // Class Data Members:
  static int[] aLeave;      // Array of time when train A leave
  static int[] bLeave;      // Array of time when train B leave
  static int[] aReachB;     // Array of time when A reach B and ready
  static int[] bReachA;     // Array of time when B reach A and ready
  static int turnAround;    // the Turn Around time of the train
  static int aTime;         // # of scheduled train from A
  static int bTime;         // # of scheduled train from B
  static String temp1 = ""; // Temporary string for time input
  static int trainA;        // Train needed at A
  static int trainB;        // Train needed at B
  
  /*
   * Main Class of the Programme
   * Pre-condition  : None
   * Post-condition : Result Printed
   * 
   */
  public static void main (String[]args) {
    
    // Create Scanner for data input
    Scanner sc = new Scanner (System.in);
    // Number of test cases
    int n = sc.nextInt();
    
    // Loop for each test cases
    for (int i=0; i<n; i++) {
      
      // Get initial input
      turnAround = sc.nextInt();
      aTime = sc.nextInt();
      bTime = sc.nextInt();
      
      // Initialize arrays for each use
      aLeave = new int[aTime];
      aReachB = new int[aTime];
      bLeave = new int[bTime];
      bReachA = new int[bTime];
      
      // Get aLeave and aReachB
      for (int j=0; j<aTime; j++) {
        temp1 = sc.next();
        aLeave[j] = convert(temp1);
        temp1 = sc.next();
        aReachB[j] = addTurnAround(convert(temp1), turnAround);
      } // End of For Loop
        
      // Get bLeave and bReachA
      for (int k=0; k<bTime; k++) {
        temp1 = sc.next();
        bLeave[k] = convert(temp1);
        temp1 = sc.next();
        bReachA[k] = addTurnAround(convert(temp1), turnAround);
      } // End of For Loop
      
      // Sort all arrays
      Arrays.sort(aLeave);
      Arrays.sort(bLeave);
      Arrays.sort(aReachB);
      Arrays.sort(bReachA);
      
      // Comparison of time ready and time need to leave
      trainA = getResult (aLeave, bReachA);
      trainB = getResult (bLeave, aReachB);
      
      // Print Result
      System.out.println ("Case #" + (i+1) + ": " + trainA + " " + trainB);
      
    } // End of For Loop
    
  } // End of Main Method
  
  /*
   * Method to get the required train for one station
   * Pre-condition  : Time is inputted correctly, no null pointer
   * Post-condition : Required number of train returned
   * 
   */
  public static int getResult (int[] leave, int[] ready) {
    int result = 0;
    for (int i=0; i<ready.length; i++) {
      for (int j=0; j<leave.length; j++) {
        if (ready[i] <= leave[j]) {
          ready[i] = -1;
          leave[j] = -1;
          break;
        }
      } // End of For Loop
    } // End of For Loop
    for (int k=0; k<leave.length; k++) {
      if (leave[k] != -1) {
        result++;
      }
    }  // End of For Loop
    return result;
  } // End of getResult Method
  
  /*
   * Method to add the turn around time for train in the station
   * Pre-condition  : Time inputted correctly in minutes
   * Post-condition : Turn around time added and returned
   * 
   */
  public static int addTurnAround (int time, int turn) {
    if (turn == 60) { // 60 Minutes = 1 Hour
      turn = 100;
    }
    return (time + turn);
  } // End of addTurnAround Method

  /*
   * Method to convert the time (in HH:MM format) into integer (in HHMM format)
   * Pre-condition  : Time inputted correctly in HH:MM format
   * Post-condition : Time converted, preceding 0 removed, and returned
   * 
   */
  public static int convert (String initial) {
    String temporary = initial.replaceAll (":" , "");
    int finalized = Integer.parseInt(temporary);
    return finalized;
  } // End of Convert Method
  
}