import java.io.*;
import java.util.*;

public class Watersheds 
{
	String line;
	StringTokenizer inputParser;
	BufferedReader is;
	FileInputStream fstream;
	DataInputStream in;
	
	void openInput(String file)
	{

		//is = new BufferedReader(new InputStreamReader(System.in));//stdin
		try{
			fstream = new FileInputStream(file);
			in = new DataInputStream(fstream);
			is = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e)
		{
			System.err.println(e);
		}

	}
	
	void readNextLine()
	{
		try {
			line = is.readLine();
			inputParser = new StringTokenizer(line, " ");
			//System.err.println("Input: " + line);
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}	
		
	}
	
	int NextInt()
	{
		String n = inputParser.nextToken();
		int val = Integer.parseInt(n);
		
		//System.out.println("I read this number: " + val);
		return val;
	}
	
	String NextString()
	{
		String n = inputParser.nextToken();
		return n;
	}
	
	void closeInput()
	{
		try {
			is.close();
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}
			
	}
	
	int T;
	
	public static void main(String [] argv)
	{
		Watersheds  watersheds  = new Watersheds (argv[0]);
	}
	
	public Watersheds (String inputFile)
	{
		openInput(inputFile);
		readNextLine();
		T = NextInt();
		for(int i=0; i<T; i++)
		{
			int H, W;
			readNextLine();
			H = NextInt();
			W = NextInt();
			int map [] [] = new int [H] [W];
			int mapA [] [] = new int [H] [W];
			for(int j=0; j<H; j++)
			{
				readNextLine();
				for(int k=0; k<W; k++)
				{
					map[j][k]=NextInt();
					mapA[j][k]=-1;
				}
			}
			
			int cnt=0;
			int cnt2=0;
			//findSinks
			for(int j=0; j<H; j++)
			{
				for(int k=0; k<W; k++)
				{
					int mAlt=map[j][k];
					int min=mAlt;
					int dir=-1;
					if(j-1>=0&&map[j-1][k]<min){min=map[j-1][k]; dir=0;}//N
					if(k-1>=0&&map[j][k-1]<min){min=map[j][k-1]; dir=1;}//W
					if(k+1<W&&map[j][k+1]<min){min=map[j][k+1]; dir=2;}//E
					if(j+1<H&&map[j+1][k]<min){min=map[j+1][k]; dir=3;}//S
					
					if(dir==-1)
					{
						mapA[j][k]=cnt++;
						//map[j][k]=Integer.MAX_VALUE;
						System.err.println("SINK:"+j+","+k+" "+mapA[j][k]);
						cnt2++;
					}
				}
			}
			
			for(int j=0; j<H; j++)
			{
				for(int k=0; k<W; k++)
				{
					System.err.print(mapA[j][k]);
					if(k+1<W)System.err.print(" ");
				}
				System.err.println();
			}
			
			while(cnt2< (W * H))
			{
				int minx=-1, miny=-1, minVal=Integer.MAX_VALUE;
				for(int j=0; j<H; j++)
				{
					for(int k=0; k<W; k++)
					{
						if(map[j][k]<minVal&&mapA[j][k]==-1)
						{
							minVal=map[j][k];
							minx = j;
							miny = k;
						}
					}
				}
				
				int j=minx, k=miny;
				int mAlt=map[j][k];
				int min=mAlt;
				int dir=-1;
				if(j-1>=0&&map[j-1][k]<min){min=map[j-1][k]; dir=0;}//N
				if(k-1>=0&&map[j][k-1]<min){min=map[j][k-1]; dir=1;}//W
				if(k+1<W&&map[j][k+1]<min){min=map[j][k+1]; dir=2;}//E
				if(j+1<H&&map[j+1][k]<min){min=map[j+1][k]; dir=3;}//S
				
				if(dir!=-1)
				{
					if(dir==0)mapA[j][k]=mapA[j-1][k];
					if(dir==1)mapA[j][k]=mapA[j][k-1];
					if(dir==2)mapA[j][k]=mapA[j][k+1];
					if(dir==3)mapA[j][k]=mapA[j+1][k];
					//map[j][k]=Integer.MAX_VALUE;
					
				}
				cnt2++;
				System.err.println(j+","+k+" "+mapA[j][k]+" dir="+dir);
				if(j-1>=0)System.err.println(map[j-1][k]);
				if(k-1>=0)System.err.println(map[j][k-1]);
				if(k+1<W)System.err.println(map[j][k+1]);
				if(j+1<H)System.err.println(map[j+1][k]);
			}
			
			char act='a';
			char [] myChars = new char [50];
			for(int j=0; j<50; j++)myChars[j]='!';
			System.out.println("Case #"+(i+1)+": ");
			for(int j=0; j<H; j++)
			{
				for(int k=0; k<W; k++)
				{
					if(myChars[mapA[j][k]]=='!')myChars[mapA[j][k]]=(char)act++;
					System.out.print(myChars[mapA[j][k]]);
					if(k+1<W)System.out.print(" ");
				}
				System.out.println();
			}
		}
		closeInput();
	}
}

