package actual;
import java.io.*;
import java.util.*;

public class A
{
	String line;
	StringTokenizer inputParser;
	BufferedReader is;
	FileInputStream fstream;
	DataInputStream in;
	
	void openInput(String file)
	{

		//is = new BufferedReader(new InputStreamReader(System.in));//stdin
		try{
			fstream = new FileInputStream(file);
			in = new DataInputStream(fstream);
			is = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e)
		{
			System.err.println(e);
		}

	}
	
	void readNextLine()
	{
		try {
			line = is.readLine();
			inputParser = new StringTokenizer(line, " ");
			//System.err.println("Input: " + line);
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}	
		
	}
	
	int NextInt()
	{
		String n = inputParser.nextToken();
		int val = Integer.parseInt(n);
		
		//System.out.println("I read this number: " + val);
		return val;
	}
	
	String NextString()
	{
		String n = inputParser.nextToken();
		return n;
	}
	
	void closeInput()
	{
		try {
			is.close();
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}
			
	}
	
	public static void main(String [] argv)
	{
		A a = new A(argv[0]);
	}
	
	public A(String inputFile)
	{
		openInput(inputFile);
		readNextLine();

		int TC = NextInt();
		
		for(int t=0; t<TC; t++)
		{	
			int ret=0;
			readNextLine();
			int N = NextInt();
			MyRobot ro=new MyRobot();
			MyRobot rb=new MyRobot();
			
			for(int p=0; p<N; p++)
			{
				String robot=NextString();
				int button=NextInt();				
				
				switch(robot.charAt(0))
				{
					case 'O':
						ro.addCmd(p, button);
						break;
					case 'B':
						rb.addCmd(p, button);
						break;
				}
				
			}
			int step=0;
			while(!ro.isFinished() || !rb.isFinished())
			{
				boolean moved=ro.move(step);
				
				moved|=rb.move(step);
				if(moved)step++;
				ret++;
			}
			
			System.out.println("Case #"+(t+1)+": "+ret);
		}
		closeInput();
	}
	
	private class MyRobot
	{
		
		int [] cmnds = new int[101];
		int cmndsCount;
		int idCmd=-1;
		int pos;
		
		public MyRobot()
		{
			cmndsCount = 0;
			pos=1;
		}
		
		public void addCmd(int id, int button)
		{
			cmnds[id]=button;
			cmndsCount++;
			if(idCmd==-1)idCmd=id;
		}
		
		public boolean move(int step)
		{
			if(isFinished())return false;
			if(cmnds[idCmd]<pos)pos--;
			else if(cmnds[idCmd]>pos)pos++;
			else if(cmnds[idCmd]==pos && step==idCmd)
			{
				cmndsCount--;
				if(cmndsCount > 0)
				{
					idCmd++;
					while(cmnds[idCmd]==0)idCmd++;
				}
				return true;
			}
			
			return false;		
		}
		
		public boolean isFinished()
		{
			return (cmndsCount == 0);
		}
	}
	
}

