import java.io.*;
import java.util.*;

public class AlienLanguage
{
	String line;
	StringTokenizer inputParser;
	BufferedReader is;
	FileInputStream fstream;
	DataInputStream in;
	
	void openInput(String file)
	{

		//is = new BufferedReader(new InputStreamReader(System.in));//stdin
		try{
			fstream = new FileInputStream(file);
			in = new DataInputStream(fstream);
			is = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e)
		{
			System.err.println(e);
		}

	}
	
	void readNextLine()
	{
		try {
			line = is.readLine();
			inputParser = new StringTokenizer(line, " ");
			//System.err.println("Input: " + line);
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}	
		
	}
	
	int NextInt()
	{
		String n = inputParser.nextToken();
		int val = Integer.parseInt(n);
		
		//System.out.println("I read this number: " + val);
		return val;
	}
	
	String NextString()
	{
		String n = inputParser.nextToken();
		return n;
	}
	
	void closeInput()
	{
		try {
			is.close();
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}
			
	}
	
	int L, D, N;
	
	String [] words;
	
	public static void main(String [] argv)
	{
		AlienLanguage alienLanguage = new AlienLanguage(argv[0]);
	}
	
	public AlienLanguage(String inputFile)
	{
		openInput(inputFile);
		readNextLine();
		L = NextInt();
		D = NextInt();
		N = NextInt();
		
		words = new String[D];
		
		for(int i=0; i<D; i++)
		{
			long ret = 0;
			readNextLine();
			words[i] = NextString();
		}
			
		for(int i=0; i<N; i++)
		{	
			int ret=0;
			readNextLine();
			String pattern=NextString();
			
			for(int j=0; j<D; j++)
			{
				if(matches(words[j], pattern))ret++;
			}
			
			System.out.println("Case #"+(i+1)+": "+ret);
		}
		closeInput();
	}
	
	boolean matches(String s, String p)
	{
		int ppos=0;
		String pp="";
		for(int i=0; i<s.length(); i++)
		{
			if(p.charAt(ppos)=='(')
			{
				int endIndex = p.indexOf(')', ppos);
				//System.err.println("SUB:"+p+"["+ppos+","+endIndex+"]");
				pp=p.substring(ppos+1, endIndex);
				ppos=endIndex+1;
			}
			else
			{
				pp=""+p.charAt(ppos);
				ppos++;
			}
			//System.err.println(s+" "+pp);
			if(pp.indexOf(s.charAt(i))==-1)return false;
		}
		return true;
	}
}

