package P2010R1A;

import java.io.*;
import java.util.*;

public class C
{
	String line;
	StringTokenizer inputParser;
	BufferedReader is;
	FileInputStream fstream;
	DataInputStream in;
	
	void openInput(String file)
	{

		//is = new BufferedReader(new InputStreamReader(System.in));//stdin
		try{
			fstream = new FileInputStream(file);
			in = new DataInputStream(fstream);
			is = new BufferedReader(new InputStreamReader(in));
		}catch(Exception e)
		{
			System.err.println(e);
		}

	}
	
	void readNextLine()
	{
		try {
			line = is.readLine();
			inputParser = new StringTokenizer(line, " ");
			//System.err.println("Input: " + line);
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}	
		
	}
	
	int NextInt()
	{
		String n = inputParser.nextToken();
		int val = Integer.parseInt(n);
		
		//System.out.println("I read this number: " + val);
		return val;
	}
	
	String NextString()
	{
		String n = inputParser.nextToken();
		return n;
	}
	
	void closeInput()
	{
		try {
			is.close();
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}
			
	}
	
	public static void main(String [] argv)
	{
		C c = new C(argv[0]);
	}
	
	public C(String inputFile)
	{
		openInput(inputFile);
		readNextLine();

		int T = NextInt();
			
		for(int t=0; t<T; t++)
		{	
			String ret="";
			readNextLine();

			int N = NextInt();
			int K = NextInt();
			int [][] p = new int[N][N];
			for(int i=0; i<N; i++)
			{
				readNextLine();
				String s=line;		
				for(int j=0; j<N; j++)
				{
					if(s.charAt(j)=='B')p[i][j]=1;
					else if(s.charAt(j)=='R')p[i][j]=2;
					else p[i][j]=0;
				}
			}
			
			p=rotate(p);
			boolean w1=false,w2=false;

			p=gravity(p);

			
			for(int i=0; i<N; i++)
			{
				int n1=0,n2=0;
				for(int j=0; j<N; j++)
				{
					if(p[i][j]!=1)n1=0;
					else
					{
						n1++;
						if(n1==K)w1=true;
					}
					if(p[i][j]!=2)n2=0;
					else
					{
						n2++;
						if(n2==K)w2=true;
					}
				}
					
			}
			
			for(int i=0; i<N; i++)
			{
				int n1=0,n2=0;
				for(int j=0; j<N; j++)
				{
					if(p[j][i]!=1)n1=0;
					else
					{
						n1++;
						if(n1==K)w1=true;
					}
					if(p[j][i]!=2)n2=0;
					else
					{
						n2++;
						if(n2==K)w2=true;
					}
				}
			}
			
			for(int k=0; k<=N*2; k++)
			{
				int n1=0, n2=0;
				for(int i=0; i<N; i++)
				{
					if(k-i<0||k-i>=N)continue;
					if(p[k-i][i]!=1)n1=0;
					else
					{
						n1++;
						if(n1==K)w1=true;
					}
					if(p[k-i][i]!=2)n2=0;
					else
					{
						n2++;
						if(n2==K)w2=true;
					}
				}
				
			}
			
			for(int k=0; k<=N*2; k++)
			{
				int n1=0, n2=0;
				for(int i=0; i<N; i++)
				{
					if(k-i<0||k-i>=N)continue;
					if(p[k-i][N-1-i]!=1)n1=0;
					else
					{
						n1++;
						if(n1==K)w1=true;
					}
					if(p[k-i][N-1-i]!=2)n2=0;
					else
					{
						n2++;
						if(n2==K)w2=true;
					}
				}
				
			}
			ret=getRes(w1,w2);
			
				
					
				
			System.out.println("Case #"+(t+1)+": "+ret);
		}
		closeInput();
	}
	
	private String getRes(boolean w1, boolean w2) {
		if(w1&&w2)return "Both";
		if(w1)return"Blue";
		if(w2)return"Red";
		return "Neither";
	}

	private int [] [] rotate(int [] [] p)
	{
		int N=p.length;
		int [] [] ret = new int[N][N];
		for(int i=0; i<N; i++)
			for(int j=0; j<N; j++)
			{
				ret[j][N-i-1]=p[i][j];
			}
		return ret;
	}
	
	private int [] [] gravity(int [] [] p)
	{
		int N=p.length;
		int [] [] ret = new int[N][N];
		for(int j=0; j<N; j++)
		{
			int u=N-1;
			for(int i=N-1; i>=0; i--)
			{
				if(p[i][j]!=0)ret[u--][j]=p[i][j];
			}
		}
		return ret;
	}
	
}

