import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class A
{
	String line;
	StringTokenizer inputParser;
	BufferedReader is;
	FileInputStream fstream;
	DataInputStream in;
	String FInput="";
	
	void openInput(String file)
	{

		if(file==null)is = new BufferedReader(new InputStreamReader(System.in));//stdin
		else
		{
			try{
		
				
			fstream = new FileInputStream(file);
			in = new DataInputStream(fstream);
			is = new BufferedReader(new InputStreamReader(in));
			}catch(Exception e)
			{
				System.err.println(e);
			}
		}

	}
	
	void readNextLine()
	{
		try {
			line = is.readLine();
			inputParser = new StringTokenizer(line, " ");
			//System.err.println("Input: " + line);
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}	
		catch (NullPointerException e)
		{
			line=null;
			
		}
		
	}
	
	int NextInt()
	{
		String n = inputParser.nextToken();
		int val = Integer.parseInt(n);
		
		//System.out.println("I read this number: " + val);
		return val;
	}
	
	long NextLong()
	{
		String n = inputParser.nextToken();
		long val = Long.parseLong(n);
		
		//System.out.println("I read this number: " + val);
		return val;
	}
	
	double NextDouble()
	{
		String n = inputParser.nextToken();
		double val = Double.parseDouble(n);
		
		//System.out.println("I read this number: " + val);
		return val;
	}
	
	String NextString()
	{
		String n = inputParser.nextToken();
		return n;
	}
	
	void closeInput()
	{
		try {
			is.close();
		} catch (IOException e) {
			System.err.println("Unexpected IO ERROR: " + e);
		}
			
	}
	
	
	public static void main(String [] argv)
	{
		//String filePath="input.txt";
        String filePath=null;
		if(argv.length>0)filePath=argv[0];
		new A(filePath);
	}
	
	public void readFInput()
	{
		for(;;)
		{
			try
			{
				readNextLine();
				FInput+=line+" ";
			}
			catch(Exception e)
			{
				break;
			}
		}
		inputParser = new StringTokenizer(FInput, " ");
	}
	
	ArrayList<BigInteger> res;
	
	public A(String inputFile)
	{
		openInput(inputFile);
		readNextLine();
    	init();
    	
    	int T=NextInt();
    	for(int t=1; t<=T; t++)
    	{
    		readNextLine();
    		BigInteger A = new BigInteger(NextString());
    		BigInteger B = new BigInteger(NextString());
    		
    		System.out.println("Case #" + t + ": " + getRes(A, B));
    	}
	    
	    	
		closeInput();			
	}
	
	private void init()
	{
		res = new ArrayList<BigInteger>();
		int c=0;
		res.add(new BigInteger("1"));
		res.add(new BigInteger("4"));
		res.add(new BigInteger("9"));
		Queue <BigInteger> q=new PriorityQueue<BigInteger>();
		q.add(new BigInteger("11"));
		q.add(new BigInteger("22"));
		int max=0;
		while(!q.isEmpty())
        {
			BigInteger x=q.poll();
			String xs=x.toString();
			
            if(xs.length()>max)
            {
            	max=xs.length();
            }
            x=x.multiply(x);
            
            if (isPalindrome(x))
            {
                res.add(x);
                if(xs.length()<55&&xs.length()%2==0)q.addAll(gen(xs));
            }
            else 
            {
            	//System.err.println("B:"+xs+" "+x);
            }
            
        }
		
	}
	
	 private ArrayList <BigInteger> gen(String xs) {
		ArrayList<BigInteger>res = new ArrayList<BigInteger>();
		res.add(new BigInteger(xs.substring(0, xs.length()/2)+"0"+xs.substring(xs.length()/2)));
		res.add(new BigInteger(xs.substring(0, xs.length()/2)+"1"+xs.substring(xs.length()/2)));
		if(xs.charAt(0)=='1')res.add(new BigInteger(xs.substring(0, xs.length()/2)+"2"+xs.substring(xs.length()/2)));
		res.add(new BigInteger(xs.substring(0, xs.length()/2)+"00"+xs.substring(xs.length()/2)));
		if(xs.charAt(0)=='1')res.add(new BigInteger(xs.substring(0, xs.length()/2)+"11"+xs.substring(xs.length()/2)));
		return res;
	}

	static Boolean isPalindrome(BigInteger x)
     {
         String s = x.toString();
         for (int i = 0; i <= s.length() / 2; i++)
             if (s.charAt(i) != s.charAt(s.length() - i - 1)) return false;
         return true;
     }
	
	private int getRes(BigInteger A, BigInteger B) {
		int a = search(A);
        int b = search(B);
        //System.out.println(a+"["+A+"] "+b+"["+B+"]");
        int ret = 0;
        if(res.contains(A))ret=1;
        return  ret + b - a;
	}

	private int search(BigInteger a) {
		int L=0, R=res.size();
		int M=(L+R)/2;
		while(L+1<R)
		{
			M=(L+R)/2;
			if(res.get(M).compareTo(a)<=0)L=M;
			else R=M;
		}
		if(L+1<res.size()&&res.get(L+1).compareTo(a)>0)return L;
		return L+1;
	}

	
	public static void out(Object s)
	{
		try
		{
		    FileWriter fstream = new FileWriter("output.txt");
			BufferedWriter out = new BufferedWriter(fstream);
			out.write(s.toString());
			out.close();
		}catch (Exception e){
			System.err.println("Error: " + e.getMessage());
		}
	}
	

}