package com.bojako.tictactoatomek;

public class TTTTomek {
	public enum WINNER { O, X, DRAW, NOT_COMPLETED };
	
	public static WINNER winner (char[][] board) {
		boolean hasEmptyCells = false;
		boolean hasWinner = false;
		char[] currentSetLines = new char[4];
		char[] currentSetColumns = new char[4];
		Character winner = null;
		WINNER result = WINNER.NOT_COMPLETED;
		
		// Check lines
		for (int i = 0 ; i < 4 && !hasWinner ; i++) {
			for (int j = 0; j < 4 ; j++) {
				currentSetLines[j] = board[i][j];
				currentSetColumns[j] = board[j][i];
				if (board[i][j] == '.' || board[j][i] == '.') hasEmptyCells = true;
			}
			Character winnerLine = winner(currentSetLines);
			Character winnerColumn = winner(currentSetColumns);
			if (winnerLine != null) {
				hasWinner = true;
				winner = winnerLine;
			}
			if (winnerColumn != null) {
				hasWinner = true;
				winner = winnerColumn;
			}
		}
		
		if (winner != null) {
			if (winner == 'O') {
				return WINNER.O;
			} else {
				return WINNER.X;
			}
		}
		
		// Check diagonals
		char[] diagTLBR = new char[4];
		char[] diagTRBL = new char[4];
		diagTLBR[0] = board[0][0];
		diagTLBR[1] = board[1][1];
		diagTLBR[2] = board[2][2];
		diagTLBR[3] = board[3][3];
		
		diagTRBL[0] = board[0][3];
		diagTRBL[1] = board[1][2];
		diagTRBL[2] = board[2][1];
		diagTRBL[3] = board[3][0];
		
		winner = winner(diagTLBR);
		if (winner != null ) {
			if (winner == 'O') return WINNER.O;
			if (winner == 'X') return WINNER.X;
		}
		winner = winner(diagTRBL);
		if (winner != null ) {
			if (winner == 'O') return WINNER.O;
			if (winner == 'X') return WINNER.X;
		} else {
			if (hasEmptyCells) {
				return WINNER.NOT_COMPLETED;
			} else {
				return WINNER.DRAW;
			}
		}
		
		return result;
	}
	
	public static Character winner(char[] set) {
		Character winner = null;
		int countO = 0;
		int countX = 0;
		int countT = 0;
		
		for (int i = 0; i < 4 ; i++) {
			if (set[i] == 'X') countX++;
			if (set[i] == 'T') countT++;
			if (set[i] == 'O') countO++;
		}
		
		if (countO == 3 && countT == 1) {
			winner = 'O';
		} else if (countX == 3 && countT == 1) {
			winner = 'X';
		} else if (countO == 4) {
			winner = 'O';
		} else if (countX == 4) {
			winner = 'X';
		}
		
		return winner;
	}
	
	public static char[][] loadBoardFromFile(String file) {
		char[][] board = new char[4][4];
		
		return board;
	}
}
