import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;


public class Lawn {
	public static boolean PatternPossible(int[][] lawn, int nbLines, int nbColumns) {
		boolean possible = true;
		
		if (nbLines == 1 || nbColumns == 1) return true;
		
		int maxElement = 0;
		for (int i = 0; i < nbLines ; i++) {
			for (int j = 0 ; j < nbColumns ; j++) {
				if (lawn[i][j] > maxElement) maxElement = lawn[i][j];
			}
		}
		
		int[][] newLawn = new int[nbLines][nbColumns];
		
		for (int i = 0 ; i < nbLines ; i++) {
			for (int j = 0 ; j < nbColumns ; j++) {
				newLawn[i][j] = lawn[i][j];
			}
		}
		
		// For each level, find bands in raws and columns
		// increment by one for each band
		for (int i = 1 ; i < maxElement ; i++) {
			for (int j = 0 ; j < nbLines ; j++) {
				boolean isBand = true;
				
				for (int k = 0 ; k < nbColumns && isBand; k++) {
					if (lawn[j][k] != i) isBand = false;
				}
				if (isBand) {
					for (int k = 0 ; k < nbColumns ; k++) {
						newLawn[j][k] = i + 1;
					}
				} else {
					for (int k = 0 ; k < nbColumns ; k++) {
						newLawn[j][k] = Math.max(lawn[j][k], newLawn[j][k]);
					}
				}
			}
			
			for (int j = 0 ; j < nbColumns ; j++) {
				boolean isBand = true;
				
				for (int k = 0 ; k < nbLines && isBand; k++) {
					if (lawn[k][j] != i) isBand = false;
				}
				if (isBand) {
					for (int k = 0 ; k < nbLines ; k++) {
						newLawn[k][j] = i + 1;
					}
				} else {
					for (int k = 0 ; k < nbLines ; k++) {
						newLawn[k][j] = Math.max(lawn[k][j], newLawn[k][j]);
					}
				}
			}
			
			lawn = newLawn;
		}
		
		// Check if the new lawn is composed of only maxElement
		for (int i = 0 ; i < nbLines && possible; i++) {
			for (int j = 0 ; j < nbColumns && possible; j++) {
				if (newLawn[i][j] != maxElement) possible = false;
			}
		}
		
		return possible;
	}
	
	public static void main(String[] args) {
		String filePath = "B-large.in";
		//String filePath = "test";
		int nbCases = 0;
		String currentLine = "";
		
		try {
			BufferedReader fileReader = new BufferedReader(new FileReader(filePath));
			boolean patternPossible = false;
			
			currentLine = fileReader.readLine();
			
			nbCases = Integer.parseInt(currentLine);
			
			int currentCase = 1;
			while (nbCases > 0) {
				String gridDimensions = fileReader.readLine();
				String[] dims = gridDimensions.split(" ");
				
				int nbLines = Integer.parseInt(dims[0]);
				int nbColumns = Integer.parseInt(dims[1]);
				
				int[][] grid = new int[nbLines][nbColumns];
				
				for (int i = 0 ; i < nbLines ; i++) {
					currentLine = fileReader.readLine();
					String[] squares = currentLine.split(" ");
					
					for (int j = 0 ; j < nbColumns ; j++) {
						grid[i][j] = Integer.parseInt(squares[j]);
					}
				}
				
				patternPossible = PatternPossible(grid, nbLines, nbColumns);
				String result = patternPossible ? "YES" : "NO";
				System.out.format("Case #%d: %s\n", currentCase, result);
				
				nbCases--;
				currentCase++;
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

}
