import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;


public class Chest {
	int ID;
	List<Integer> keys;
	int startingKey;
	
	public Chest(int chestID, int openingKey) {
		this(chestID, openingKey, new ArrayList<Integer>());
	}
	
	public Chest(int chestID, int openingKey, List<Integer> someKeys) {
		ID = chestID;
		keys = new ArrayList<Integer>();
		startingKey = openingKey;
		for (Integer i : someKeys) keys.add(i);
	}
	
	public int countKeys() {
		return keys.size();
	}
	
	public boolean openedBy(Integer key) {
		return (key == startingKey);
	}
	
	public int getID() {
		return ID;
	}
	
	public Integer getOpeningKey() {
		return new Integer(startingKey);
	}
	
	public List<Integer> getKeys() {
		return keys;
	}
	
	public static class ChestComparatorByID implements Comparator<Chest> {

		@Override
		public int compare(Chest arg0, Chest arg1) {
			return Integer.compare(arg0.ID, arg1.ID);
		}
		
	}
}
