package com.bojako.tictactoetomek.tests;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

import com.bojako.tictactoatomek.*;

public class Tests {

	public static void main(String[] args) {
		String filePath = "A-large.in";
		
		try {
			BufferedReader fileReader = new BufferedReader(new FileReader(filePath));
			int nbBoards = 0;
			String currentLine = "";
			int currentBoardNumber = 1;
			boolean inBoard = false;
			char[][] currentBoard = new char[4][4];
			
			currentLine = fileReader.readLine();
			nbBoards = Integer.parseInt(currentLine);
			
			while ((currentLine = fileReader.readLine()) != null && currentBoardNumber <= nbBoards) {
				if (!inBoard && currentLine.length() > 1) {
					inBoard = true;
					for (int i = 0 ; i < 4 ; i++) {
						char[] currentBoardLineChars = currentLine.toCharArray();
						for (int j = 0 ; j < 4 ; j++) {
							currentBoard[i][j] = currentBoardLineChars[j];
						}
						currentLine = fileReader.readLine();
					}
					
					TTTTomek.WINNER winner = TTTTomek.winner(currentBoard);
					String result = "";
					
					if (winner == TTTTomek.WINNER.O) {
						result = "O won";
					} else if (winner == TTTTomek.WINNER.X) {
						result = "X won";
					} else if (winner == TTTTomek.WINNER.DRAW) {
						result = "Draw";
					} else {
						result = "Game has not completed";
					}
					
					System.out.format("Case #%d: %s\n", currentBoardNumber, result);
					
					currentBoardNumber++;
					inBoard = false;
				}
			}
			
			fileReader.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
