package com.bojako.fairpalindrome;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class FairPalindrome {

	public static int numberOfFairAndSquarePalindromes(int a, int b) {
		int count = 0;
		
		for (int i = a ; i <= b ; i++) {
			if (isFairAndSquare(i)) count++;
		}
		
		return count;
	}
	
	public static boolean isFairAndSquare(int n) {
		boolean result = false;
		
		if (!isPalindrome(n)) return false;
		
		int squareRoot = (int) Math.sqrt(new Integer(n).doubleValue());
		if (((squareRoot * squareRoot) == n)) result = true;
		
		result = result & isPalindrome(squareRoot);
		
		return result;
	}
	
	public static boolean isPalindrome(int n) {
		String number = new Integer(n).toString();
		char[] digits = number.toCharArray();
		int nbDigits = digits.length;
		boolean isPalindrome = true;
		
		for (int i = 0 ; (i < nbDigits / 2) && isPalindrome; i++) {
			if (digits[i] != digits[nbDigits - 1 - i]) isPalindrome = false;
		}
		
		return isPalindrome;
	}
	
	public static void main(String[] args) {
		//String filePath = "test";
		String filePath = "C-small-attempt0.in";
		int nbCases = 0;
		String currentLine = "";
		
		try {
			BufferedReader fileReader = new BufferedReader(new FileReader(filePath));
			
			currentLine = fileReader.readLine();
			
			nbCases = Integer.parseInt(currentLine);
			
			int currentCase = 1;
			while (currentCase <= nbCases) {
				String currentInterval = fileReader.readLine();
				String[] interval = currentInterval.split(" ");
				
				int a = Integer.parseInt(interval[0]);
				int b = Integer.parseInt(interval[1]);
				
				int result = numberOfFairAndSquarePalindromes(a, b);
				
				System.out.format("Case #%d: %d\n", currentCase, result);
				
				currentCase++;
			}
			
			fileReader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

}
