import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class Treasure {
	String file;
	
	public Treasure(String filePath) {
		file = filePath;
	}
	
	public void Run() {
		int nbCases = 0;
		String currentLine = "";
		
		try {
			BufferedReader fileReader = new BufferedReader(new FileReader(file));
			
			currentLine = fileReader.readLine();
			
			nbCases = Integer.parseInt(currentLine);
			
			int currentCase = 1;
			while (currentCase <= nbCases) {
				String settings = fileReader.readLine();
				String[] keysChests = settings.split(" ");
				Game currentGame = new Game();
				List<Integer> initialKeys = new ArrayList<Integer>();
				List<Chest> allChests = new ArrayList<Chest>();
				
				int nbKeys = Integer.parseInt(keysChests[0]);
				int nbChests = Integer.parseInt(keysChests[1]);
				
				String keys = fileReader.readLine();
				String[] keysArray = keys.split(" ");
				for (int i = 0 ; i < nbKeys ; i++) {
					int currentKey = Integer.parseInt(keysArray[i]);
					initialKeys.add(currentKey);
				}
				
				for (int i = 0 ; i < nbChests ; i++) {
					String currentChest = fileReader.readLine();
					String[] chestSettings = currentChest.split(" ");
					
					int chestID = i + 1;
					int openingKey = Integer.parseInt(chestSettings[0]);
					int nbKeysChest = Integer.parseInt(chestSettings[1]);
					List<Integer> chestKeys = new ArrayList<Integer>();
					for (int j = 0 ; j < nbKeysChest ; j++) {
						chestKeys.add(Integer.parseInt(chestSettings[2 + j]));
					}
					
					Chest newChest = new Chest(chestID, openingKey, chestKeys);
					allChests.add(newChest);
				}
				
				currentGame.setKeys(initialKeys);
				currentGame.setChests(allChests);
				
				List<Chest> solution = new ArrayList<Chest>();
				
				currentGame.solve(solution);
				
				String result = "";
				if (solution.size() != allChests.size()) {
					result = "IMPOSSIBLE";
				} else {
					for (int i = 0 ; i < solution.size() ; i++) {
						Chest currentChest = solution.get(i);
						result += new Integer(currentChest.getID()).toString();
						if (i < solution.size() - 1) result += " ";
					}
				}
				
				System.out.format("Case #%d: %s\n", currentCase, result);
				
				currentCase++;
			}
			
			fileReader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		//String filePath = "test";
		String filePath = "D-small-attempt2.in";
		
		Treasure program = new Treasure(filePath);
		program.Run();
	}
}
