import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class FairAndSquare {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		BufferedReader br = null;
		BufferedWriter bw = null;
		String line;
		
		long[] pal = new long[1000];
		
		int i, T;
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			bw = new BufferedWriter(new FileWriter("output.txt"));
			T = Integer.parseInt(br.readLine());
			i = 0;
			
			setPalindrom(pal, 1, 100000000000000L);
			
			while ((line = br.readLine()) != null && i<T) {
				i++;
				bw.write("Case #" + i + ": " + evaluate(line, pal));
				bw.newLine();
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		} finally {
			try {
				br.close();
				bw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void setPalindrom(long[] pal, long a, long b){
		int k=0;
		for(long i=1; i<=Math.sqrt(b); i++){
			if(isPalindrom(i) && isPalindrom(i*i)){
				pal[k++] = i*i;
			}
		}
	}
	
	public static boolean isPalindrom(long a){
		
		String s = String.valueOf(a);
		
		for(int i=0; i<s.length()/2; i++){
			if(s.charAt(i) != s.charAt(s.length()-i-1)){
				return false;
			}
		}
		
		return true;
	}
	
	public static int evaluate(String line, long[] pal) {
		
		int cnt = 0;
		String[] tmp = line.split(" ");
		long a = Long.parseLong(tmp[0]);
		long b = Long.parseLong(tmp[1]);
		
		for(int i=0; i<1000; i++){
			if(pal[i] == 0){
				break;
			}
			
			if(a <= pal[i] && pal[i] <= b){
				cnt++;
			}
		}
		
		return cnt;
	}

}
