import java.io.File;
import java.io.PrintWriter;
import java.util.Collections;
import java.util.LinkedList;
import java.util.Scanner;
import java.util.Stack;


public class TicketSwapping {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		Scanner s = new Scanner(new File("input.txt"));
		PrintWriter pw = new PrintWriter(new File("output.txt"));
		
		int T = s.nextInt();
		int it=0;
		while(T-- > 0){
			it++;
			
			long cost = 0;
			long costNew = 0;
			
			int N = s.nextInt();
			int M = s.nextInt();
			
			int o;
			int e;
			int p;
			
			LinkedList<Point> points = new LinkedList<>();
			
			for(int i=0; i<M; i++){
				o = s.nextInt();
				e = s.nextInt();
				p = s.nextInt();	
				cost += calcCost(e-o, N) * p;
				points.add(new Point(o, p, 0));
				points.add(new Point(e, p, 1));				
			}
			
			Collections.sort(points);
			
			Stack<Point> inStack = new Stack<>();
			
			for(Point pt : points){
				if(pt.type == 0){
					inStack.push(pt);
				}else{
					while(pt.cnt > 0){
						Point p2 = inStack.pop();
						if(pt.cnt > p2.cnt){
							pt.cnt -= p2.cnt;
							costNew += calcCost(pt.point - p2.point, N) * p2.cnt;
						}else{
							p2.cnt -= pt.cnt;
							costNew += calcCost(pt.point - p2.point, N) * pt.cnt;
							if(p2.cnt > 0){
								inStack.push(p2);
							}
							pt.cnt = 0;
						}
					}
				}
			}
			pw.printf("Case #%d: %d\n", it, cost-costNew);
			
		}
		
		pw.close();

	}
	
	public static long calcCost(int cnt, int N){
		return N*cnt - cnt*(cnt-1)/2;
	}
	
	static class Point implements Comparable<Point>{
		int point;
		int cnt;
		int type;
		public Point(int point, int cnt, int type){
			this.point = point;
			this.cnt = cnt;
			this.type = type;
		}
		@Override
		public int compareTo(Point o) {
			if(this.point == o.point){
				return this.type - o.type;
			}
			return this.point - o.point;
		}
		
	}

}
