import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class A {
	public static final char WIN = '1';
	public static final char LOSS = '0';
	public static final char NONE = '.';

	public static final boolean DEBUG = false;

	int n;
	char[][] schedule;
	double[] rpis;
	double[] wps;
	double[][] owpsx;
	double[] owps;
	double[][] oowps;

	public A(String[] lines) {
		n = lines.length;
		schedule = new char[n][n];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				schedule[i][j] = lines[i].charAt(j);
			}
		}
		rpis = new double[n];
		wps = new double[n];
		owpsx = new double[n][n];
		owps = new double[n];
		oowps = new double[n][n];
	}

	public char getResult(int i, int j) {
		return schedule[i][j];
	}

	public void calculateRpis() {
		// TODO main logic
		for (int i = 0; i < n; i++) {
			calculateRpis(i);
		}
		for (int i = 0; i < n; i++) {
			double owp = getOwp(i);
			owps[i] = owp;
		}
		for (int i = 0; i < n; i++) {
			double owp = owps[i];
			double oowp = getOowp(i);
			if (DEBUG) {
				System.out.println("wps[" + i + "]=" + wps[i]);
				System.out.println("owp[" + i + "]=" + owp);
				System.out.println("oowp[" + i + "]=" + oowp);
			}
			rpis[i] = rpi(wps[i], owp, oowp);
		}
	}

	private void calculateRpis(int i) {
		// TODO Auto-generated method stub
		int nGames = 0;
		int nWins = 0;
		int nLosses = 0;
		boolean[] played = new boolean[n];
		for (int j = 0; j < n; j++) {
			char result = getResult(i, j);
			if (result == WIN || result == LOSS) {
				nGames++;
				if (result == WIN) {
					nWins++;
				} else {
					nLosses++;
				}
				played[j] = true;
			} else {
				played[j] = false;
			}
		}
		wps[i] = nWins * 1.0 / nGames;
		for (int j = 0; j < n; j++) {
			int deltaWin = 0;
			int deltaGames = 0;
			if (played[j]) {
				deltaGames = -1;
				if (getResult(i, j) == WIN) {
					deltaWin = -1;
				}
			}
			owpsx[i][j] = (nWins + deltaWin) * 1.0 / (nGames + deltaGames);
		}
	}

	public double getOwp(int i) {
		int nGames = 0;
		double owp = 0.0d;
		for (int j = 0; j < n; j++) {
			if (i != j && getResult(j, i) != NONE) {
				nGames++;
				owp += owpsx[j][i];
			}
		}
		return owp / nGames;
	}

	public double getOowp(int i) {
		int nGames = 0;
		double oowp = 0.0d;
		for (int j = 0; j < n; j++) {
			if (i != j && getResult(j, i) != NONE) {
				nGames++;
				oowp += owps[j];
			}
		}
		return oowp / nGames;
	}

	public double[] getRpis() {
		return rpis;
	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String line;
		line = in.readLine(); // number of test cases
		int T = Integer.parseInt(line);
		for (int i = 0; i < T; i++) {
			line = in.readLine();
			int n = Integer.parseInt(line);
			System.out.println("Case #" + (i + 1) + ":");
			String[] lines = new String[n];
			for (int j = 0; j < n; j++) {
				line = in.readLine();
				lines[j] = line;
			}
			A solution = new A(lines);
			solution.calculateRpis();
			for (double rpi : solution.getRpis()) {
				System.out.println(rpi);
			}
		}
	}

	private double rpi(double wp, double owp, double oowp) {
		return 0.25 * wp + 0.5 * owp + 0.25 * oowp;
	}
}
