package net.bolot.codejam2011;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class QualB {
	private static final int N_BASE_ELEMS = 8;
	char[][] combine;
	boolean[][] destroy;
	int n;
	String str;

	public QualB(String line) {
		combine = new char[N_BASE_ELEMS][N_BASE_ELEMS];
		destroy = new boolean[N_BASE_ELEMS][N_BASE_ELEMS];
		String[] tokens = line.split(" ");
		int index = 0;
		int c = Integer.parseInt(tokens[index++]);
		for (int i = 0; i < c; i++) {
			String rule = tokens[index++];
			int ind1 = getIndex(rule.charAt(0));
			int ind2 = getIndex(rule.charAt(1));
			char result = rule.charAt(2);
			combine[ind1][ind2] = result;
			combine[ind2][ind1] = result;
		}
		int d = Integer.parseInt(tokens[index++]);
		for (int i = 0; i < d; i++) {
			String rule = tokens[index++];
			int ind1 = getIndex(rule.charAt(0));
			int ind2 = getIndex(rule.charAt(1));
			destroy[ind1][ind2] = true;
			destroy[ind2][ind1] = true;
		}
		n = Integer.parseInt(tokens[index++]);
		str = tokens[index++];
	}

	public String invoke() {
		boolean[] invoked = new boolean[N_BASE_ELEMS];
		StringBuffer buf = new StringBuffer();
		char currChar = str.charAt(0);
		for (int i = 1; i < n; i++) {
			char nextChar = str.charAt(i);
			int ind1 = getIndex(currChar);
			int ind2 = getIndex(nextChar);
			char comb = combine[ind1][ind2];
			if (shouldDestroy(ind1, invoked)) {
				buf = new StringBuffer();
				invoked = new boolean[N_BASE_ELEMS];
			} else if (comb > '\0') {
				buf.append(comb);
				i++;
				if (i < str.length()) {
					nextChar = str.charAt(i);
					ind2 = getIndex(nextChar);
				}
			} else {
				buf.append(currChar);
				if (ind1 >= 0) {
					invoked[ind1] = true;
				}
			}
			currChar = nextChar;
			if (i == n - 1) {
				if (shouldDestroy(ind2, invoked)) {
					buf = new StringBuffer();
					invoked = new boolean[N_BASE_ELEMS];
				} else {
					buf.append(currChar);
				}
			}
		}
		return buf.toString();
	}

	private boolean shouldDestroy(int ind1, boolean[] invoked) {
		// TODO Auto-generated method stub
		for (int i = 0; i < N_BASE_ELEMS; i++) {
			if (invoked[i]) {
				if (destroy[i][ind1]) {
					return true;
				}
			}
		}
		return false;
	}

	private int getIndex(char ch) {
		switch (ch) {
		case 'Q':
			return 0;
		case 'W':
			return 1;
		case 'E':
			return 2;
		case 'R':
			return 3;
		case 'A':
			return 4;
		case 'S':
			return 5;
		case 'D':
			return 6;
		case 'F':
			return 7;
		}
		return -1;
	}

	public static void main(String[] args) throws IOException {
		/*
		 * String[] lines = { "0 0 2 EA", "1 QRI 0 4 RRQR",
		 * "1 QFT 1 QF 7 FAQFDFQ", "1 EEZ 1 QE 7 QEEEERA", "0 1 QW 2 QW" };
		 */
		QualB solution;
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		String line;
		line = in.readLine(); // number of test cases
		int t = Integer.parseInt(line);
		for (int i = 0; i < t; i++) {
			line = in.readLine();
			solution = new QualB(line);
			// System.out.println(line);
			String invoked = solution.invoke();
			System.out.print("Case #" + (i + 1) + ": ");
			printInvoked(invoked);
		}
	}

	private static void printInvoked(String invoked) {
		System.out.print("[");
		if (invoked.length() > 0) {
			System.out.print(invoked.charAt(0));
		}
		for (int i = 1; i < invoked.length(); i++) {
			System.out.print(", " + invoked.charAt(i));
		}
		System.out.println("]");
	}

}
