package bot_trust;

import java.util.ArrayList;
import java.util.Scanner;

public class bot_trust {
	public static void main (String[] args){
		
		class ButtonInstruction{
			public ButtonInstruction(Boolean isOrange, int buttonId)
			{
				IsOrange = isOrange;
				ButtonId = buttonId;
			}
			public Boolean IsOrange = false;
			public int ButtonId = 0;
		}
		
		Scanner scanIn = new Scanner(System.in);
		
		String numTestCasesString = scanIn.nextLine();
		int numCases = Integer.parseInt(numTestCasesString);
		
		for(int i=0; i<numCases; ++i)
		{
			String testCaseString = scanIn.nextLine();
			
			String[] splits = testCaseString.split(" ");
			
			int numButtonPresses = Integer.parseInt(splits[0]);
			ArrayList<ButtonInstruction> instructions = new ArrayList<ButtonInstruction>(numButtonPresses);
			
			for(int j=0; j<numButtonPresses; j++)
			{
				int colorIndex = 1 + (j*2);
				int idIndex = 2 + (j*2);
				
				Boolean isOrange = splits[colorIndex].charAt(0) == 'O';
				int buttonId = Integer.parseInt(splits[idIndex]);
				
				ButtonInstruction b = new ButtonInstruction(isOrange, buttonId); 
				instructions.add(b);
			}
			
			// now instructions is set up with the list of things Orange and Blue have to do
			int bluePosition = 1;
			int orangePosition = 1;
			int currentInstructionIndex = 0;
			int secondsElapsed = 0;

			while(currentInstructionIndex<numButtonPresses)
			{
				Boolean finishingCurrentInstruction = false;
				
				ButtonInstruction currentInstruction = instructions.get(currentInstructionIndex);
				if(currentInstruction.IsOrange && orangePosition == currentInstruction.ButtonId)
				{
					// orange completes this instruction this round
					finishingCurrentInstruction = true;
				}
				else
				{
					// otherwise orange moves 1 towards its next goal this round
					int nextGoal = 0;
					for(int search=currentInstructionIndex; search<numButtonPresses; ++search)
					{
						ButtonInstruction inst=instructions.get(search);
						if(inst.IsOrange)
						{
							nextGoal = inst.ButtonId; 
							break;
						}
					}
					
					if(orangePosition<nextGoal)
					{
						++orangePosition;
					}
					else if(orangePosition>nextGoal)
					{
						--orangePosition;
					}
				}
				
				if(!currentInstruction.IsOrange && bluePosition == currentInstruction.ButtonId)
				{
					// blue completes this instruction this round
					finishingCurrentInstruction = true;
				}
				else
				{
					// otherwise blue moves 1 toward its next goal this round
					int nextGoal = 0;
					for(int search=currentInstructionIndex; search<numButtonPresses; ++search)
					{
						ButtonInstruction inst=instructions.get(search);
						if(!inst.IsOrange)
						{
							nextGoal = inst.ButtonId; 
							break;
						}
					}
					
					if(bluePosition<nextGoal)
					{
						++bluePosition;
					}
					else if(bluePosition>nextGoal)
					{
						--bluePosition;
					}
				}
				
				if(finishingCurrentInstruction)
				{
					++currentInstructionIndex;
				}
				
				// advance time!
				++secondsElapsed;
			}
			System.out.println("Case #"+(i+1)+": "+secondsElapsed);
		}
		scanIn.close();
	}
}
