import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Iterator;


public class TicTacToe {

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		
		BufferedReader in = null;
		BufferedWriter out = null;
		String input = "";
		int numOfCases = 0;
		
		try {
			in = new BufferedReader(new InputStreamReader(new FileInputStream("./A-large.in")));
			out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("./A-large_output.txt")));
//			The first line of input gives the number of cases, N.
			numOfCases = Integer.valueOf(in.readLine());
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.exit(0);
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			System.exit(0);
		}
		
		// for each test case
//		N test cases follow. 
//		For each test case there will a line of letters and space characters indicating a list of space separated words. 
//		Spaces will not appear at the start or end of a line.
		for(int i = 0; i < numOfCases; i++) {
			String currentLine = "";
			String result = "";
			
			char[][] values = new char[4][4];
			ArrayList<char[]> combinations = new ArrayList<char[]>();
			
			//read all four input lines
			for(int j = 0; j < 4; j++) {
				currentLine = in.readLine();
				char[] currentRow = {currentLine.charAt(0),currentLine.charAt(1),currentLine.charAt(2),currentLine.charAt(3)};
				values[j] = currentRow;
				combinations.add(currentRow);
			}
			//skip empty line
			in.readLine();
			for(int k = 0; k < 4; k++) {
				char[] currentCol = {values[0][k], values[1][k], values[2][k], values[3][k]};
				combinations.add(currentCol);
			}
			
			//diagoanls..
			char[] diago1 = {values[0][0], values[1][1], values[2][2], values[3][3]};
			combinations.add(diago1);
			char[] diago2 = {values[0][3], values[1][2], values[2][1], values[3][0]};
			combinations.add(diago2);
			
			result = computeResult(combinations);
			out.write("Case #" + (i + 1) + ": " + result);
			out.newLine();
		}
		out.flush();
		out.close();	
		

	}

	private static String computeResult(ArrayList<char[]> combinations) {
		String result = "";
		int z = 0;
		Iterator<char[]> it = combinations.iterator();
		while(it.hasNext()) {
			int x = 0;
			int o = 0;
//			computeLiterals(it.next(), x, o, z);
			char[] temp = it.next();
			for(int i = 0; i < temp.length; i++) {
				if(temp[i] == 'X') {
					x+=1;
					z+=1;
				} else if(temp[i] == 'O') {
					o+=1;
					z+=1;
				} else if(temp[i] == 'T') {
					x+=1;
					o+=1;
					z+=1;
				}
			}
			
			if(x == 4) {
				return "X won";
			}
			if(o == 4) {
				return "O won";
			}
		}
		if(z == 40) {
			return "Draw";
		} else {
			return "Game has not completed";
		}
	}

	private static void computeLiterals(char[] next, int x, int o, int z) {
		for(int i = 0; i < next.length; i++) {
			if(next[i] == 'X') {
				x+=1;
				z+=1;
			} else if(next[i] == 'O') {
				o+=1;
				z+=1;
			} else if(next[i] == 'T') {
				x+=1;
				o+=1;
				z+=1;
			}
		}
	}

}
