package com.qualification;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.Scanner;

public class BathroomStalls {
	public static void main(String[] args) throws FileNotFoundException {
		Scanner scan = new Scanner(new FileInputStream("C:/Nandan/GoogleCodeJam/Qualification_2017/resources/C.small"));
		
		int T = scan.nextInt();
		
		for (int testCase = 1; testCase <= T; testCase++) {
			long N = scan.nextLong();
			long K = scan.nextLong();
			
			PriorityQueue<Long> queue = new PriorityQueue<Long>(new Comparator<Long>() {
				@Override
				public int compare(Long o1, Long o2) {
					if(o1 > o2){
						return -1;
					}else if(o1 < o2){
						return 1;
					}
					return 0;
				}
			});
			
			queue.add(N);

			Map<Long, Long> map = new HashMap<Long, Long>();
			map.put(N, 1L);
			
			long max = -1;
			long min = -1;
			
			for(long i=0; i<K;){
				long numberToSplit = queue.remove();
				long availableCount = map.remove(numberToSplit);
				
				boolean splitNumber = (numberToSplit%2 == 0) ? true : false;
				
				long remaining = numberToSplit/2;
				
				if(splitNumber){
					long remainingCount = map.get(remaining) == null ? (1*availableCount) : map.get(remaining)+(1*availableCount);
					long remainingMinus1Count = map.get(remaining-1) == null ? (1*availableCount) : map.get(remaining)+(1*availableCount);
					
					if(map.get(remaining-1) == null){
						queue.add(remaining-1);
					}
					if(map.get(remaining) == null){
						queue.add(remaining);
					}
					
					map.put(remaining, remainingCount);
					map.put(remaining-1, remainingMinus1Count);
					
					max = remaining;
					min = remaining - 1;
				}else{
					long remainingCount = map.get(remaining) == null ? (2*availableCount) : map.get(remaining)+(2*availableCount);

					if(map.get(remaining) == null){
						queue.add(remaining);
					}
					map.put(remaining, remainingCount);
					
					max = remaining;
					min = remaining;
				}
				
				if(i+availableCount >= K){
					break;
				}
				i = i + availableCount;
			}
			
			System.out.println("Case #"+testCase+": "+max+" "+min);
		}
	}
}
