package stalls3;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;

public class BS {
	
	long longest;
	long shortest;
	HashMap<Long, Long> dist;
	
	//find longest available slice
	private long find() {
		Set<Long> keys = dist.keySet();
		Iterator<Long> it = keys.iterator();
		Long ll = 0L;
		while (it.hasNext()) {
			Long val = it.next();
			ll = Math.max(ll, val);
		}
		return ll;
	}
	
	//occupy a stall
	private void occupy(long k) {
		//split long distance
		long left = (k-1)/2;
		long right = k-1-left;
		
		//has to contain old dist
		Long v = dist.get(k);
		if (1==v) { //last
			dist.remove(k);
		} else
			dist.put(k, v-1);//dec counter
		
		if (k==longest) // that was longest
			longest = Math.max(left, right);//new longest
		if (k==shortest) // that was shortest
			shortest = Math.min(left, right);//new shortest
		
		//left dist
		if (dist.containsKey(left)) { //length existed
			v = dist.get(left);
			dist.put(left, v+1);
		} else { //new length
			dist.put(left, 1L);
			if (left < shortest) // new shortest
				shortest = left;
		}
		
		//right
		if (dist.containsKey(right)) {
			v = dist.get(right);
			dist.put(right, v+1);
		} else {
			dist.put(right, 1L);
			if (right < shortest) // new shortest
				shortest = right;
		}
	}
	
	// case no, stalls, persons
	private void solve(int c, long s, long p) {
		longest = s;//longest distance between two occupied stalls
		shortest = s;//shortest, same
		dist = new HashMap<Long, Long>();
		dist.put(s, 1L);//only one distance at first
		for (int j = 0; j < p; j++) {
			long k = find();
			if (0 < k)
				occupy(k);
			else {
//				System.err.println("no more free stalls");
				break;
			}
		}
		System.out.println("Case #"+c+": "+longest+" "+shortest);
	}

	private void read() throws IOException {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
//		BufferedReader br = new BufferedReader(new FileReader("sample.txt"));
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(System.out));
//		BufferedWriter bw = new BufferedWriter(new FileWriter("result.txt"));
		String line = br.readLine();
		final int cases = Integer.parseInt(line);
		int test = 0;
		while (test < cases) {
			line = br.readLine();
			if (null == line)
				break; // no more lines
			String[] vals = line.split(" ");
			if (2 == vals.length) //2^18 is about 60 bits
				solve(test+1, Long.parseLong(vals[0]), Long.parseLong(vals[1]));
			else
				System.err.print("case #"+test+": expecting two values on line");
			test++;
		}
		bw.close();
		br.close();
	}

	static public void main(String[] args) throws IOException {
//		System.err.println(Paths.get(".").toAbsolutePath().normalize().toString());
		new BS().read();
	}
}
