import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class InfiniteHouseOfPancakes {

	private static final String IN = "input.txt";
	private static final String OUT = "output.txt";
	
	private int readInt(BufferedReader r) throws IOException {
		String line = r.readLine();
		int i = Integer.parseInt(line);
		return i;
	}
	
	private List<Integer> readCakes(int c, BufferedReader r) throws IOException {
		String line = r.readLine();
		String[] val = line.split(" ");
		if (c != val.length) {
			throw new IOException("expected " + c + " values in row: " + line);
		}
		List<Integer> l = new ArrayList<Integer>();
		for (int i = 0; i < val.length; ++i) {
			int m = Integer.parseInt(val[i]);
			l.add(m);
		}
		return l;
	}
	
	private int[] minAvgMax(List<Integer> l) {
		int n = Integer.MAX_VALUE;
		int s = 0;
		int m = Integer.MIN_VALUE;
		for (int i = 0; i < l.size(); ++i) {
			final int j = l.get(i);
			s += j;
			if (j < n) {
				n = j;
			}
			if (j > m) {
				m = j;
			}
		}
		return new int[] { n, s/l.size(), m };
	}
	
	private Object[] isSpecial(int sp, List<Integer> l) {
		final int m = 3;
		boolean was = false;
		int no = sp;
		int ma = Integer.MIN_VALUE; // max value
		int mi = -1; // max @ idx
		List<Integer> n = new ArrayList<Integer>();
		for (int i = 0; (0 == sp) && (i < l.size()); ++i) {
			final int j = l.get(i);
			if (m < j && l.size() < j && ma < j) { // one eater with lots of vs lots of eaters
				ma = j;
				mi = i;
			}
		}
		int mc = 0; // max counter
		for (int i = 0; (0 == sp) && (i < l.size()); ++i) {
			final int j = l.get(i);
			if (j == ma) {
				mc++;
			}
		}
		for (int i = 0; i < l.size(); ++i) {
			final int j = l.get(i);
			if (i == mi ) { // just create new eater
				int j1 = j/2; // well, there's no rule about
				int j2 = j - j1; // several "special minutes" in a row
				int j3 = Math.max(j1, j2);
				if (j >= j3+mc) {
					was = true; // was special minute
					no = 0; // no special for 2 rounds
					n.add(j1);
					n.add(j2);
				}
			} else {
				n.add(j);
			}
		}
		return new Object[] { was, no, n };
	}
	
	private List<Integer> eat(List<Integer> e) {
		List<Integer> n = new ArrayList<>();
		for (int i = 0; i < e.size(); ++i) {
			int j = e.get(i);
			--j;
			if (0 < j) {
				n.add(j);
			}
		}
		return n;
	}
	
	private int serve(List<Integer> l) {
		int m = 0;
		int sp = 0;
		while (!l.isEmpty()) {
			int[] mam = minAvgMax(l);
			System.out.println("n/a/m=" + mam[0] + "/" + mam[1] + "/" + mam[2]);
			Object[] o = isSpecial(sp, l);
			boolean was = (boolean)o[0];
			List<Integer> n = (List<Integer>)o[2];
			if (!was) {
				n = eat(l);
				if (0 < sp) {
					--sp;
				}
			} else {
				sp = (int)o[1]; // was special, count until next
			}
			l = n;
			m++;
		}
		return m;
	}
	
	private void read() throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(new File(IN)));
		BufferedWriter bw = new BufferedWriter(new FileWriter(new File(OUT)));
		final int tests = readInt(br);
		int count = 0;
		while (tests > count) {
			int eat = readInt(br);
			List<Integer> l = readCakes(eat, br);
			int minutes = serve(l);
			bw.write("Case #" + (count+1) + ": " + minutes + "\n");
			count++;
		}
		br.close();
		bw.close();
	}
	
	public static void main(String[] args) throws FileNotFoundException, IOException {
		InfiniteHouseOfPancakes mt = new InfiniteHouseOfPancakes();
		mt.read();
	}
}
