import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class OminousOmino {

	private static final String IN = "input.txt";
	private static final String OUT = "output.txt";
	
	private int readInt(BufferedReader r) throws IOException {
		String line = r.readLine();
		int i = Integer.parseInt(line);
		return i;
	}
	
	private int[] readDims(BufferedReader r) throws IOException {
		String line = r.readLine();
		String[] val = line.split(" ");
		if (3 != val.length) {
			throw new IOException("expected 3 values in row: " + line);
		}
		int[] a = { 0, 0, 0, };
		for (int i = 0; i < val.length; ++i) {
			int m = Integer.parseInt(val[i]);
			a[i] = m;
		}
		return a;
	}
	
	private boolean fit(int[] d) {
		boolean b = false;
		final int x = d[0];
		final int r = d[1];
		final int c = d[2];
		int sq = r * c;
		boolean ow1 = (x < 4) && (x <= r || x <= c); // can fit O at least one way
		boolean ow2 = (x > 3) && (x <= r && x <= c); // must fit both way
		if (ow1 || ow2) {
			float xx = (float)x;
			double mul = sq / xx;
			b = (mul == Math.floor(mul));
		}
		return b;
	}
	
	private void read() throws IOException {
		BufferedReader br = new BufferedReader(new FileReader(new File(IN)));
		BufferedWriter bw = new BufferedWriter(new FileWriter(new File(OUT)));
		final int tests = readInt(br);
		int count = 0;
		while (tests > count) {
			int[] dims = readDims(br);
			boolean b = fit(dims);
			String s = b ? "GABRIEL" : "RICHARD";
			bw.write("Case #" + (count+1) + ": " + s + "\n");
			count++;
		}
		br.close();
		bw.close();
	}
	
	public static void main(String[] args) throws FileNotFoundException, IOException {
		OminousOmino mt = new OminousOmino();
		mt.read();
	}
}
