import java.io.IOException;
import java.math.BigInteger;
import java.security.SecureRandom;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class Coins {
	static int n,j=0;
	static HashSet<String> solution = new HashSet<>();
	
	private final static BigInteger ZERO = new BigInteger("0");
    private final static BigInteger ONE  = new BigInteger("1");
    private final static BigInteger TWO  = new BigInteger("2");
    private final static SecureRandom random = new SecureRandom();
    private static Map<BigInteger, Integer> factors = new HashMap<BigInteger, Integer>();
    

    public static BigInteger rho(BigInteger N) {
        BigInteger divisor;
        BigInteger c  = new BigInteger(N.bitLength(), random);
        BigInteger x  = new BigInteger(N.bitLength(), random);
        BigInteger xx = x;

        // check divisibility by 2
        if (N.mod(TWO).compareTo(ZERO) == 0) return TWO;

        do {
            x  =  x.multiply(x).mod(N).add(c).mod(N);
            xx = xx.multiply(xx).mod(N).add(c).mod(N);
            xx = xx.multiply(xx).mod(N).add(c).mod(N);
            divisor = x.subtract(xx).gcd(N);
        } while((divisor.compareTo(ONE)) == 0);

        return divisor;
    }

    public static void factor(BigInteger N) {
        if (N.compareTo(ONE) == 0) return;
        if (N.isProbablePrime(20)) {
        	if( !factors.containsKey(N) )
        		factors.put(N, new Integer(1));
        	else
        		factors.put(N, factors.get(N) + 1 );
//        	System.out.println(N); 
        	return; 
        }
        BigInteger divisor = rho(N);
        factor(divisor);
        factor(N.divide(divisor));
    }
    
    public static void doFactor(BigInteger n){
    	factors.clear();
    	factor(n);
    }
	
	static void solve(){
		int maxm = (1 << (n-2));
		
		for(int number=0; number<maxm && solution.size() < j; number++){
			String aux = Integer.toBinaryString(number);
			while(aux.length() < n-2) aux = "0" + aux;
			
			String repr = "1" + aux + "1";
			BigInteger xd = new BigInteger( repr, 2 );
			if( !xd.isProbablePrime(20) ){
				solution.add(repr);
			}
		}
	}
	
	public static void main(String[] args) throws IOException {
		n = 32;
		j = 500;
		solve();
		System.out.println("Case #1:");
		for(String s : solution){
			System.out.print(s + " ");
			for(int b=2; b<=10; b++){
				doFactor(new BigInteger(s,b));
				for(BigInteger xd : factors.keySet()){
					System.out.print(xd + " ");
					break;
				}
			}
			System.out.println();
		}
	}
}
