import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;

public class Tidy {

	/**
	 * @param args
	 * @throws IOException 
	 */
	/*
	 * BEGIN STANDARD CODE (not unique to any problem)
		 */
	public static int[] toDigits(long n){
		int len = Long.toString(n).length();
		int[] digits = new int[len];
		int i = len - 1;
		while (n > 0){
			digits[i--] = (int) (n % 10);
			n/=10;
		}
		return digits;
	}
	
	public static void solve() throws IOException{
		int t = nextInt();
		for(int tc = 0; tc < t; tc++){
			long n = nextLong();
			int[] d = toDigits(n);
			if(d.length == 1) {println("Case #" + (tc+1)+": " +n); continue;}
			for(int k = 0; k < d.length; k++){
				for(int i = 0; i < d.length-1; i++){
					if(d[i] > d[i+1]){
						d[i]--;
						for(int j = i + 1; j < d.length; j++){
							d[j] = 9;			
						}
						break;
					}
				}
			}
			long out = 0;
			for(int i = 0; i<d.length; i++){
				out = 10 * out + d[i];
			}
			println("Case #" + (tc+1) + ": " +out);
		}
	
	}
	public static void main(String[] args) throws Exception {
		in = new BufferedReader (new FileReader ("B-large.in"));
//		in = new BufferedReader( new InputStreamReader( System.in ));
		out = new PrintWriter (new BufferedWriter (new FileWriter ("tidy.out")));
		solve();
		in.close();
		out.close();
	}
	public static StringTokenizer tokenizer;
	public static BufferedReader in;
	public static PrintWriter out;
	public static String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(in.readLine());
		}
		return tokenizer.nextToken();
	}
	public static String nextString() throws IOException {
		return nextToken();
	}
	public static int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	public static long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	public static double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	public static void println(Object x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(int x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(long x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(double x) {
		System.out.println(x);
		out.println(x);
	}
}




