import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.StringTokenizer;

class Pair{
	int x;
	int y;
	Pair(int x, int y){
		this.x = x;
		this.y = y;
	}
}
public class ProblemB {

	/**
	 * @param args
	 * @throws IOException 
	 */
	/*
	 * BEGIN STANDARD CODE (not unique to any problem)
		 */
	
	public static boolean inRange (int have, int req){
		if (.9 * req <= have && have <= 1.1 * req) return true;
		return false;
	}
	
	public static ArrayList<Pair> path(int start, int lo, int hi, ArrayList<Pair> pt){
		
		if (pt.size() == 0){
			pt.add(new Pair(0, start));
			if (lower[0][start] > upper[0][start]){
				return null;
			}
			ArrayList<Pair> out = path(start, lower[0][start], upper[0][start], pt);
			if(out != null){
				used[0][start] = true;
				return out;
			}
			return null;
		}
		if (pt.size() == n){
			return pt;
		}
		int level = pt.size();
		for(int j = 0; j< p; j++){
			int prevLo = lo;
			int prevHi = hi;
			if(!used[level][j]){
				lo = Math.max(lo, lower[level][j]);
				hi = Math.min(hi, upper[level][j]);
				pt.add(new Pair(level, j));
				used[level][j] = true;
				ArrayList<Pair> out = null;
				if(lo <= hi){
					out = path(start, lo, hi, pt);
				}
				if (out == null){
					used[level][j] = false;
					pt.remove(pt.size()-1);
				}else{
					return out;
				}
			}
			lo = prevLo;
			hi = prevHi;
		}
		return null;		
	}
	
	public static int[][] lower;
	public static int[][] upper;
	public static boolean[][] used;
	public static int n;
	public static int p;
	
	public static void solve() throws IOException{
		int t = nextInt();
		tests: for(int tc = 0; tc < t; tc++){
			n = nextInt(); p = nextInt();
			int[] required = new int[n];
			int[][] packages = new int[n][p];
			lower = new int[n][p];
			upper = new int[n][p];
			used = new boolean[n][p];
			for(int i =0; i < n; i++){
				required[i] = nextInt();
			}
			for(int i =0; i<n; i++){
				for(int j = 0; j<p; j++){
					packages[i][j] = nextInt();
				}
				Arrays.sort(packages[i]);
			}
			
			for(int i =0; i<n; i++){
				for(int j = 0; j<p; j++){
					double lowers = (packages[i][j]/ (required[i] * 1.1));
					double uppers = (packages[i][j]/(required[i] * 0.9));
					lower[i][j] = (int) Math.ceil((packages[i][j]/ (required[i] * 1.1)) - 1e-10);
					upper[i][j] = (int) Math.floor((packages[i][j]/(required[i] * 0.9)) + 1e-10);
				}
			}
			int count = 0;
			for(int j = 0; j < p; j++){
				ArrayList<Pair> out = path(j, 0, Integer.MAX_VALUE, new ArrayList<Pair>());
				if ( out != null){
					count++;
				}
			}
			println("Case #" + (tc+1)+": " + count);
			
		}
	
	}
	public static void main(String[] args) throws Exception {
		in = new BufferedReader (new FileReader ("B-small-attempt1.in"));
	//	in = new BufferedReader( new InputStreamReader( System.in ));
		out = new PrintWriter (new BufferedWriter (new FileWriter ("b2.out")));
		solve();
		in.close();
		out.close();
	}
	public static StringTokenizer tokenizer;
	public static BufferedReader in;
	public static PrintWriter out;
	public static String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(in.readLine());
		}
		return tokenizer.nextToken();
	}
	public static String nextString() throws IOException {
		return nextToken();
	}
	public static int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	public static long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	public static double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	public static void println(Object x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(int x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(long x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(double x) {
		System.out.println(x);
		out.println(x);
	}
}




