import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class ProblemA {

	/**
	 * @param args
	 * @throws IOException 
	 */
	/*
	 * BEGIN STANDARD CODE (not unique to any problem)
		 */
	public static boolean isEmpty(char[] row){
		for(int i = 0; i < row.length; i++){
			if(row[i] != '?'){
				return false;
			}
		}
		return true;
	}
	public static ArrayList<Character> chars(char[] row){
		ArrayList<Character> out = new ArrayList<Character>();
		for(int i = 0; i < row.length; i++){
			if(row[i] != '?'){
				out.add(row[i]);
			}
		}
		return out;
	}
	public static void solve() throws IOException{
		int t = nextInt();
		tests: for(int tc = 0; tc < t; tc++){
			int r = nextInt();
			int c = nextInt();
			char[][] grid = new char[r][c];
			int firstNonempty = -1;
			for(int i = 0; i < r; i++){
				String row = nextString();
				for(int j = 0; j < c; j++){
					grid[i][j] = row.charAt(j);
				}
			}
			for(int i =0; i < r; i++){
				if (!isEmpty(grid[i]) && firstNonempty == -1) firstNonempty = i;
				if (!isEmpty(grid[i])){
					ArrayList<Character> cs = chars(grid[i]);
					for(int j = 0; j < c; j++){
						if(grid[i][j] == cs.get(0) && cs.size() > 1){
							cs.remove(0);
						}else{
							grid[i][j] = cs.get(0);
						}
					}
				}else if (firstNonempty != -1){
					for(int j = 0; j < c; j++){
						grid[i][j] = grid[i-1][j]; 
					}
				}
			}
			for(int i = 0; i < firstNonempty; i++){
				for(int j = 0; j < c; j++){
					grid[i][j] = grid[firstNonempty][j];
				}
			}
			
			println("Case #" + (tc+1)+":");
			for(int i =0; i < r; i++){
				println(String.valueOf(grid[i]));
			}
		}
	
	}
	public static void main(String[] args) throws Exception {
		in = new BufferedReader (new FileReader ("A-large.in"));
	//	in = new BufferedReader( new InputStreamReader( System.in ));
		out = new PrintWriter (new BufferedWriter (new FileWriter ("a2.out")));
		solve();
		in.close();
		out.close();
	}
	public static StringTokenizer tokenizer;
	public static BufferedReader in;
	public static PrintWriter out;
	public static String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(in.readLine());
		}
		return tokenizer.nextToken();
	}
	public static String nextString() throws IOException {
		return nextToken();
	}
	public static int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	public static long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	public static double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	public static void println(Object x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(int x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(long x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(double x) {
		System.out.println(x);
		out.println(x);
	}
}




