import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.Map;
import java.util.StringTokenizer;

class Node{
	String v;
	Node(String v){
		this.v = v;
	}
	ArrayList<Node> neighbors = new ArrayList<Node>();
}
public class PancakeFlip {

	/**
	 * @param args
	 * @throws IOException 
	 */
	/*
	 * BEGIN STANDARD CODE (not unique to any problem)
		 */
	public static String flip(String s){
		StringBuffer out = new StringBuffer();
		for(int i = 0; i < s.length(); i++){
			if(s.charAt(i) == '+') out.append("-");
			else out.append("+");
		}
		return out.toString();
	}
	public static ArrayList<String> getNeighbors(Node c, int k){
		ArrayList<String> n = new ArrayList<String>();
		String s = c.v;
		if (k > s.length()) return n;
		for(int i = 0; i <= s.length() - k; i++ ){
			String cur = s.substring(0, i) + flip(s.substring(i, i+k)) + s.substring(i+k);
			n.add(cur);
		}
		return n;
	}
	public static void solve() throws IOException{
		int t = nextInt();
		tests: for(int tc = 0; tc < t; tc++){
			String s = nextString();
			int k = nextInt();
			Map<String, Integer> visited = new HashMap<String, Integer>();
			StringBuffer sb = new StringBuffer();
			for(int i =0; i < s.length(); i++){
				sb.append("+");
			}
			String goal = sb.toString();
			if(s.equals(goal)) {println("Case #" + (tc+1)+": " +0); continue;}
			Node start = new Node(s);
			visited.put(s, 0);
			LinkedList<Node> q = new LinkedList<Node>();
			q.add(start);
			while(!q.isEmpty()){
				Node top = q.pop();
				for(String neighbor: getNeighbors(top, k)){
					if(!visited.containsKey(neighbor)){
						if(neighbor.equals(goal)) { println("Case #" + (tc+1)+": " +(visited.get(top.v) + 1)); continue tests; }
						visited.put(neighbor, visited.get(top.v) + 1);
						q.add(new Node(neighbor));
					}
				}
			}
			println("Case #" + (tc+1)+": " +"IMPOSSIBLE");
		}
	
	}
	public static void main(String[] args) throws Exception {
		in = new BufferedReader (new FileReader ("A-small-attempt0.in"));
	//	in = new BufferedReader( new InputStreamReader( System.in ));
		out = new PrintWriter (new BufferedWriter (new FileWriter ("pancake.out")));
		solve();
		in.close();
		out.close();
	}
	public static StringTokenizer tokenizer;
	public static BufferedReader in;
	public static PrintWriter out;
	public static String nextToken() throws IOException {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			tokenizer = new StringTokenizer(in.readLine());
		}
		return tokenizer.nextToken();
	}
	public static String nextString() throws IOException {
		return nextToken();
	}
	public static int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}
	public static long nextLong() throws IOException {
		return Long.parseLong(nextToken());
	}
	public static double nextDouble() throws IOException {
		return Double.parseDouble(nextToken());
	}
	public static void println(Object x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(int x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(long x) {
		System.out.println(x);
		out.println(x);
	}
	public static void println(double x) {
		System.out.println(x);
		out.println(x);
	}
}




