import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class TicTacToe {

	char[][] board = new char[4][4];
	String result;

	public TicTacToe() {
	}

	public void loadData(String s, int row) {
		for (int i = 0; i < s.length(); i++) {
			board[row][i] = s.charAt(i);
		}
	}

	public static void main(String[] args) throws IOException {
		FileWriter f1 = new FileWriter("output1.out");
		BufferedWriter b1 = new BufferedWriter(f1);
		FileReader f = new FileReader("A-small-attempt8.in");
		BufferedReader b = new BufferedReader(f);

		int cases = Integer.parseInt(b.readLine());

		for (int i = 1; i <= cases; i++) {
			TicTacToe tacToe = new TicTacToe();
			for (int j = 0; j < 4; j++) {
				tacToe.loadData(b.readLine(), j);				
			}
			tacToe.examineData();
			
			System.out.println("Case #" + (i) + ": " + tacToe.getResult());
			b1.write("Case #" + (i) + ": " + tacToe.getResult());
			b1.newLine();
			b.readLine();
		}
		b1.close();
	}

	private String getResult() {
		return result;
	}
	
	private boolean check(int sta, int end, char c) {
		if(c == '.') {
			return false;
		}
		for (int i = sta; i < end; i++) {
			if(c == 'T') {
				c = board[i][i];
				if(c == '.') {
					return false;
				}
				continue;
			}
			else if(board[i][i] == c || board[i][i] == 'T') {
				continue;
			}
			return false;
		}
		
		return true;
	}

	private void examineData() {
		char c = board[0][0];
		boolean found = false;

		if(c != '.') {
			found = check(1, board.length, c);
		}
		if(!found) {
			c = board[0][3];
			if(c != '.') {
				found = true;
				for (int i = 1; i < board.length; i++) {
					if(c == 'T') {
						c = board[i][3-i];
						if(c == '.') {
							found = false;
							break;
						}
						continue;
					}
					else if(board[i][3-i] == c || board[i][3-i] == 'T') {
						continue;
					}
					found = false;
					break;
				}
			}
		}
		if(!found) {
			for (int i = 0; i < board.length; i++) {
				c = board[0][i];
				if(c != '.') {
					found = true;
					found = true;
					for (int j = 0; j < board[i].length; j++) {
						if(c == 'T') {
							c = board[j][i];
							if(c == '.') {
								found = false;
								break;
							}
							continue;
						}
						else if(board[j][i] == c || board[j][i] == 'T') {
							continue;
						}
						found = false;
						break;
					}
					if(found) 
						break;
				}
			}
		}

		if(!found) {
			for (int i = 0; i < board.length; i++) {
				c = board[i][0];
				if(c != '.') {
					found = true;
					for (int j = 0; j < board[i].length; j++) {
						if(c == 'T') {
							c = board[i][j];
							if(c == '.') {
								found = false;
								break;
							}
							continue;
						}
						else if(board[i][j] == c || board[i][j] == 'T') {
							continue;
						}
						found = false;
						break;
					}
					if(found) 
						break;
				}
			}
		}

		if(found) {
			result = c + " won";
		}
		else {
			boolean draw = checkDraw();
			if(draw) {
				result = "Draw";
			} else {
				result = "Game has not completed";
			}
		}

	}

	private boolean checkDraw() {
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board[i].length; j++) {
				if(board[i][j] == '.')
					return false;
			}
		}
		return true;
	}

}
