import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.StringTokenizer;


public class Treasure {

	List<Integer> keys;
	List<Chest> chests;
	List<Integer> openOrder;
	boolean cannot = false;

	public Treasure() {
		openOrder = new LinkedList<Integer>();
		chests = new LinkedList<Chest>();
	}	


	public static void main(String[] args) throws IOException {
		
		FileWriter f1 = new FileWriter("output.tr");
		BufferedWriter b1 = new BufferedWriter(f1);
		
		FileReader f = new FileReader("D-small-attempt0.in");
		BufferedReader b = new BufferedReader(f);
		
		int cas = Integer.parseInt(b.readLine());
		
		for (int i = 1; i <= cas; i++) {
			String s = b.readLine();
			StringTokenizer st = new StringTokenizer(s, " ");
			st.nextToken();
			Integer ch = Integer.parseInt(st.nextToken());
			
			Treasure treasure = new Treasure();
			treasure.loadKeys(b.readLine());
			
			for (int j = 1; j <= ch; j++) {
				treasure.loadTreasure(b.readLine(), j);
			}
			treasure.openTreasure();
			
			b1.write("Case #" + i + ": " + treasure.getOpenOrder());
			b1.newLine();
			System.out.println("Case #" + i + ": " + treasure.getOpenOrder());
		}
		
		b1.close();
		
//		Treasure treasure = new Treasure();
//		treasure.loadKeys("1 1 1");
//		treasure.loadTreasure("1 0", 1);
//		treasure.loadTreasure("1 0", 2);
//		treasure.loadTreasure("1 0", 3);
////		treasure.loadTreasure("3 1 2", 4);
//
//		treasure.openTreasure();
//		System.out.println(treasure.getOpenOrder());
	}

	private String getOpenOrder() {
		if(cannot) {
			return "IMPOSSIBLE";
		}
		StringBuffer sb = new StringBuffer();
		for (int i=0; i<openOrder.size(); i++) {
			if(i != 0) {
				sb.append(" " + openOrder.get(i));
			}
			else 
				sb.append(openOrder.get(i));
		}
		return sb.toString();
	}


	private void openTreasure() {
		int i = 0;
		while(chests.size() > 0 && i < chests.size()) {
			Chest c = chests.get(i);
			if(keys.contains(c.key)) {
				int siz = c.numb;
				for (int j=(i+1); j<chests.size(); j++) {
					if(chests.get(j).key == c.key && siz < chests.get(j).numb) {
						siz = chests.get(j).numb;
						c = chests.get(j);
					}
				}
				openOrder.add(c.chestNumber);
				keys.remove(c.key);
				keys.addAll(c.keysFound);
				chests.remove(c);
				i = 0;
			}
			else {
				i++;
			}
		}
		if(i >= chests.size() && chests.size() > 0) {
			cannot = true;
		} else {
			cannot = false;
		}
	}

	private void loadTreasure(String string, Integer chestNum) {
		chests.add(new Chest(string, chestNum));
	}

	private void loadKeys(String string) {
		StringTokenizer st = new StringTokenizer(string, " ");
		keys = new ArrayList<Integer>();
		while(st.hasMoreTokens()) {
			keys.add(Integer.parseInt(st.nextToken()));
		}
	}

	class Chest {
		Integer chestNumber;
		Integer key;
		Integer numb;
		List<Integer> keysFound;
		boolean opened;

		public Chest(String s, Integer chestNum) {
			chestNumber = chestNum;
			StringTokenizer st = new StringTokenizer(s, " ");
			opened = false;
			this.key = Integer.parseInt(st.nextToken());
			this.numb = Integer.parseInt(st.nextToken());
			
			keysFound = new ArrayList<Integer>();
			for (int i = 0; i < numb; i++) {
				keysFound.add(Integer.parseInt(st.nextToken()));
			}
		}
		
		public String toString() {
			return chestNumber + " : " + key + " : " + numb + " : " + keysFound.toString();
		}
	}

}
