import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.StringTokenizer;


public class Energy {

	private int E;
	private int R;
	private int N;
	
	private int energyAvail;
	private int energyGain;
	
	private int[] values;

	public Energy(String s) {
		StringTokenizer st = new StringTokenizer(s, " ");
		E = Integer.parseInt(st.nextToken());
		R= Integer.parseInt(st.nextToken());
		N= Integer.parseInt(st.nextToken());
		energyAvail = E;
		energyGain = 0;
		
		values = new int[N];
	}
	
	public static void main(String[] args) throws IOException {
		FileWriter f1 = new FileWriter("Output1.out");
		BufferedWriter b1 = new BufferedWriter(f1);
		
		FileReader f = new FileReader("B-small-attempt1.in");
		BufferedReader b = new BufferedReader(f);
		Integer cases = Integer.parseInt(b.readLine());
		for(int i=1; i<=cases; i++) {
			Energy energy = new Energy(b.readLine());
			energy.loadData(b.readLine());
			energy.find();
			System.out.println("Case #" + i + ": " + energy.energyGain);
			b1.write("Case #" + i + ": " + energy.energyGain);
			b1.newLine();
		}
		b1.close();
	}

	private void find() {
		for(int i=0; i<N; i++) {
			int suggestValue = getSuggestedValue(i);
			energyAvail = energyAvail - suggestValue + R;
			energyGain += values[i] * suggestValue;
		}
	}

	private int getSuggestedValue(int i) {
		int maxLocation = i;
		int minLocation = i;
		for(int j = (i + 1); j < N; j++) {
			if(values[maxLocation] < values[j]) {
				maxLocation = j;
			}
			if(values[minLocation] > values[j]) {
				minLocation = j;
			}
		}
		if(i == maxLocation) 
			return energyAvail;
		else if(i == minLocation) {
			return (energyAvail + R) - E;
		}
		else 
			if(energyAvail < R)
				return energyAvail;
			return R;
	}

	private void loadData(String string) {
		StringTokenizer s = new StringTokenizer(string, " ");
		for(int i=0; i<N; i++) {
			values[i] = Integer.parseInt(s.nextToken());
		}
	}

}
