package net.bo.qualif2014;

import java.util.ArrayList;
import java.util.List;

import net.bo.util.Parent;

public class AMagic extends Parent {
	String badMagic = "Bad magician!";
	String cheat = "Volunteer cheated!";
	
	public AMagic() throws Exception {
	}

	@Override
	protected boolean getDebug() {
		return true;
	}

	@Override
	protected String getFilename() {
		return "A-small-attempt0.in";
	}

	@Override
	protected String executeOne() throws Exception {
		int cardRow = readInt("cardRow");
		
		int [][] cards = new int[4][];
		
		cards[0] = readInts("row1");
		cards[1] = readInts("row2");
		cards[2] = readInts("row3");
		cards[3] = readInts("row4");
		
		//----------------------------------------------
		int cardRow2 = readInt("cardRow2");
		
		int [][] cards2 = new int[4][];
		
		cards2[0] = readInts("row1_2");
		cards2[1] = readInts("row2_2");
		cards2[2] = readInts("row3_2");
		cards2[3] = readInts("row4_2");
		//----------------------------------------------
		List<Integer> result = new ArrayList<>();
		
		for(int i=0; i<4; i++) {
			int val1 = cards[cardRow-1][i];
			for(int j=0; j<4; j++) {
				int val2 = cards2 [cardRow2-1][j];
				if(val1 == val2) {
					result.add(val1);
				}
			}
		}
		
		if(result.isEmpty()) {
			return cheat;
		}
		if(result.size()>1) {
			return badMagic;
		}
		return "" + result.get(0);
	}

	@Override
	protected String getTestCase() {
		return "3\r\n" + 
				"2\r\n" + 
				"1 2 3 4\r\n" + 
				"5 6 7 8\r\n" + 
				"9 10 11 12\r\n" + 
				"13 14 15 16\r\n" + 
				"3\r\n" + 
				"1 2 5 4\r\n" + 
				"3 11 6 15\r\n" + 
				"9 10 7 12\r\n" + 
				"13 14 8 16\r\n" + 
				"2\r\n" + 
				"1 2 3 4\r\n" + 
				"5 6 7 8\r\n" + 
				"9 10 11 12\r\n" + 
				"13 14 15 16\r\n" + 
				"2\r\n" + 
				"1 2 3 4\r\n" + 
				"5 6 7 8\r\n" + 
				"9 10 11 12\r\n" + 
				"13 14 15 16\r\n" + 
				"2\r\n" + 
				"1 2 3 4\r\n" + 
				"5 6 7 8\r\n" + 
				"9 10 11 12\r\n" + 
				"13 14 15 16\r\n" + 
				"3\r\n" + 
				"1 2 3 4\r\n" + 
				"5 6 7 8\r\n" + 
				"9 10 11 12\r\n" + 
				"13 14 15 16";
	}

	@Override
	protected String getTestCaseResult() {
		return "Case #1: 7\r\n" + 
				"Case #2: Bad magician!\r\n" + 
				"Case #3: Volunteer cheated!";
	}

	public static void main(String[] args) throws Exception {
		new AMagic().exe();
	}
}
