package net.bo.qualif2014;

import net.bo.util.Parent;

public class CMines extends Parent {

	public CMines() throws Exception {
	}

	@Override
	protected boolean getDebug() {
		return true;
	}

	@Override
	protected String getFilename() {
		return "C-small-attempt10.in";
	}
	
	String impossible = "\r\nImpossible";
	
	@Override
	protected String executeOne() throws Exception {
		int[] data = readInts("data");
		int H = data[0];
		int L = data[1];
		int mineCount = data[2];
		
		char[][] result;

		//------------------------------------------------------------------------
		int free = H*L - mineCount;
		if(free == 0) {
			return impossible;
		}
		//------------------------------------------------------------------------
		if(mineCount == 0) {
			result = getEmptyMap(H, L);
			
			result[0][0] = CLICK;
			
			return printMap(result);
		}
		//------------------------------------------------------------------------
		
		if(H == 1) {
			if(L==1) {
				return impossible;
			}
			
			result = getEmptyMap(H, L);
			for(int i=0; i<mineCount; i++) {
				result[0][i] = MINE;
			}
			result[0][L-1] = CLICK;
			
			return printMap(result);
		}
		//------------------------------------------------------------------------
		if(L == 1) {
			if(H==1) {
				return impossible;
			}
			
			result = getEmptyMap(H, L);
			for(int i=0; i<mineCount; i++) {
				result[i][0] = MINE;
			}
			result[H-1][0] = CLICK;
			
			return printMap(result);
		}
		//------------------------------------------------------------------------
		if(free == 1) {
			result = getFullMap(H, L);
			result[0][0] = CLICK;
			
			return printMap(result);
		}
		//------------------------------------------------------------------------
		if(free <4) {
			return impossible;
		}
		//------------------------------------------------------------------------
		int smallSide = Math.min(H, L);
		int longSide = Math.max(H, L);
		
		if(smallSide == 2 
				&& (free/2)*2 != free) {//impair
			return impossible;
		}
		//------------------------------------------------------------------------
		int freeL = -1;
		int freeH = -1;
		for(int l=2; l<=L; l++) {
			int neededH = (int) Math.floor((double)free/(double)l);
			if(neededH > H) {
				if(free - l*H > 1 && free - l*H < H) {
					neededH = H;
				}
				else {
					//not large enough
					continue;
				}
			}
			
			if(free == neededH * l + 1) {
				//Not ok
				continue;
			}
			freeL = l;
			freeH = neededH;
			break;
		}
		if(freeH == -1 || freeL == -1){
			return impossible;
		}
		
		result = getFullMap(H, L);
		//We fill the rectangle...
		loop: for(int i=0; i<freeH; i++) {
			for(int j=0; j<freeL; j++) {
				result[i][j] = EMPTY;
				free --;
				if(free == 0) {
					break loop;
				}
			}
		}
		
		//We fill the rest
		if(free>0) {
			if(freeH < H) {
				for(int i=0; i<free; i++) {
					result[freeH][i] = EMPTY;
				}
			}
			else {
				for(int i=0; i<free; i++) {
					result[i][freeL] = EMPTY;
				}
			}
		}
		
		result[0][0] = CLICK;
		
		return printMap(result);
	}

	private char[][] getEmptyMap(int H, int L) {
		char[][] result = new char[H][];
		for(int i=0; i<H; i++) {
			result[i] = new char[L];
			for(int j=0; j<L; j++) {
				result[i][j] = EMPTY;
			}
		}
		return result;
	}
	
	private char[][] getFullMap(int H, int L) {
		char[][] result = new char[H][];
		for(int i=0; i<H; i++) {
			result[i] = new char[L];
			for(int j=0; j<L; j++) {
				result[i][j] = MINE;
			}
		}
		return result;
	}
	
	private String printMap(char[][] data) {
		StringBuilder sb = new StringBuilder();
		for(int i=0; i < data.length; i++) {
			sb.append("\r\n").append(data[i]);
		}
		return sb.toString();
	}
	
	char MINE = '*';
	char EMPTY = '.';
	char CLICK = 'c';
	
	@Override
	protected String getTestCase() {
		return "1\r\n" + 
				"5 3 2\r\n"; 
	}

	@Override
	protected String getTestCaseResult() {
		return "Case #1:\r\n" + 
				"Impossible\r\n" + 
				"Case #2:\r\n" + 
				"c\r\n" + 
				".\r\n" + 
				"*\r\n" + 
				"Case #3:\r\n" + 
				"Impossible\r\n" + 
				"Case #4:\r\n" + 
				"......*\r\n" + 
				".c....*\r\n" + 
				".......\r\n" + 
				"..*....\r\n" + 
				"Case #5:\r\n" + 
				"**********\r\n" + 
				"**********\r\n" + 
				"**********\r\n" + 
				"****....**\r\n" + 
				"***.....**\r\n" + 
				"***.c...**\r\n" + 
				"***....***\r\n" + 
				"**********\r\n" + 
				"**********\r\n" + 
				"**********";
	}

	public static void main(String[] args) throws Exception {
		new CMines().exe();
	}
}
