package net.bo.qualif2014;

import java.util.Locale;

import net.bo.util.Parent;

public class BCookies extends Parent {

	public BCookies() throws Exception {
	}

	@Override
	protected boolean getDebug() {
		return true;
	}

	@Override
	protected String getFilename() {
		return "B-small-attempt0.in";
	}

	float baseRate = 2;
	float farmPrice, farmRate, cookiesWanted;
	
	@Override
	protected String executeOne() throws Exception {
		float[] data = readFloats("data");
		farmPrice = data[0];
		farmRate = data[1];
		cookiesWanted = data[2];
		
//		getTime(0, 0, 0);
		
		
		
		return "" + String.format(Locale.UK, "%8f", getTime(0));
	}

	private float getTime(int farmCount) {
		float rate = baseRate + farmCount * farmRate;
		float timeToFinish = (cookiesWanted)/rate;
		
		float timeToGetFarm = farmPrice/rate;
		float timeToFinishWithOneMoreFarm = timeToGetFarm + cookiesWanted/(rate + farmRate);
		
		if(timeToFinishWithOneMoreFarm >= timeToFinish) {
			return timeToFinish;
		}
		float timeWithMoreFarm = timeToGetFarm + getTime(farmCount + 1);
		
		return  Math.min(timeToFinish, timeWithMoreFarm);
	}
	
	@Override
	protected String getTestCase() {
		return "4\r\n" + 
				"30.0 1.0 2.0\r\n" + 
				"30.0 2.0 100.0\r\n" + 
				"30.50000 3.14159 1999.19990\r\n" + 
				"500.0 4.0 2000.0";
	}

	@Override
	protected String getTestCaseResult() {
		return "Case #1: 1.0000000\r\n" + 
				"Case #2: 39.1666667\r\n" + 
				"Case #3: 63.9680013\r\n" + 
				"Case #4: 526.1904762";
	}

	public static void main(String[] args) throws Exception {
		new BCookies().exe();
	}
}
