import java.util.Scanner;

public class OversizedPancakeFlipper {
	
	public static void main(String[] args) {

		Scanner sc = new Scanner(System.in);
		int t = sc.nextInt();
		
		for (int tc = 1; tc <= t; tc++) {
			String pancakes = sc.next();
			int k = sc.nextInt();
			int solution = minChanges(pancakes, k);
			System.out.printf("Case #%d: %s", tc, (solution == -1) ? "IMPOSSIBLE" : String.valueOf(solution));
			System.out.println();
		}
		sc.close();
	}

	private static int minChanges(String pancakes, int k) {
		
		int leftToRight = countChanges(pancakes, k);
		int rightToLeft = countChanges(new StringBuilder(pancakes).reverse().toString(), k);
		
		if (leftToRight == -1 && rightToLeft == -1) 
			return -1;
		else if (leftToRight == -1)
			return rightToLeft;
		else if (rightToLeft == -1)
			return leftToRight;
		else
			return Math.min(leftToRight, rightToLeft);
	}

	private static int countChanges(String pancakes, int k) {
		
		int count = 0;
		
		char[] pancakesArray = pancakes.toCharArray();
		
		for (int i = 0; i < pancakesArray.length; i++) {
			boolean hasDiff = pancakesArray[i] != '+';
			boolean hasSpace = pancakesArray.length - i >= k;
			
			if (hasDiff && hasSpace) {
				count++;
				
				for (int j = i; j < i + k; j++) {
					if (pancakesArray[j] == '-') {
						pancakesArray[j] = '+';
					} else {
						pancakesArray[j] = '-';
					}
				}
			}
		}
		
		for (int i = 1; i < pancakesArray.length; i++) {
			if (pancakesArray[i] != pancakesArray[i-1]) {
				count = -1;
				break;
			}
		}

		return count;
	}
}
