import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

class Stall {
	long l, r;
	
	Stall(long l, long r) {
		this.l = l;
		this.r = r;
	}
}

public class BathroomStalls {
	
	static Queue<Stall> q = new LinkedList<>();
	static Stall stall;

	public static void main(String[] args) {

		Scanner sc = new Scanner(System.in);
		int t = sc.nextInt();
		
		for (int tc = 1; tc <= t; tc++) {
			
			long n = sc.nextInt();
			long k = sc.nextInt();
			
			q.clear();
			solve(n, k);
			
			long y = Math.max(stall.l, stall.r);
			long z = Math.min(stall.l, stall.r);

			System.out.printf("Case #%d: %d %d", tc, y, z);
			System.out.println();
		}
		
		sc.close();
	}
	
	private static void add(long n) {

		if (n % 2 == 0) {
			q.add(new Stall(n/2-1, n/2));
		} else {
			q.add(new Stall(n/2, n/2));
		}
	}

	private static void solve(long n, long k) {

		long p = 1;
		
		add(n);
		
		stall = q.poll();
		
		while (p != k) {

			p++;
			
			if (stall.l > 0 && stall.r > 0) {
				add(Math.max(stall.l, stall.r));
				add(Math.min(stall.l, stall.r));
			} else if (stall.l > 0) {
				add(stall.l);
			} else if (stall.r > 0) {
				add(stall.r);
			}
			
			stall = q.poll();
		}
	}
}
