import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

// A.
public class A {
	private static void solve(String in) throws IOException {
		PrintWriter writer = new PrintWriter(in.split("\\.")[0] + ".out", "UTF-8");
		BufferedReader br = new BufferedReader(new FileReader(in));

		int cases = parseInt(br);
		for (int q = 1; q <= cases; q++) {
			int[] size = parseArray(br);
			char[][] grid = new char[size[0]][size[1]];
			for(int i = 0; i < size[0]; i++) {
				grid[i] = br.readLine().toCharArray();
			}
			solve(grid, writer, q);
		}

		br.close();
		writer.close();
	}
	
	private static void solve(char[][] grid, PrintWriter writer, long q) {
		for(int row = 0; row < grid.length; row++) {
			for(int col = 0; col < grid[0].length; col++) {
				if(grid[row][col] != '?') {
					fillLeft(grid, row, col - 1, grid[row][col]);
					fillRight(grid, row, col + 1, grid[row][col]);
				}
			}
		}
		for(int row = 0; row < grid.length; row++) {
			fillUp(grid, row - 1);
			fillDown(grid, row + 1);
		}
		writer.println("Case #" + q + ":");
		for(char[] row : grid) {
			writer.println(new String(row));
		}
	}
	
	private static void fillUp(char[][] grid, int row) {
		if (row < 0) {
			return;
		}
		while(grid[row][0] == '?') {
			grid[row] = grid[row + 1];
			row--;
			if (row < 0) {
				return;
			}
		}
	}
	
	private static void fillDown(char[][] grid, int row) {
		if (row >= grid.length) {
			return;
		}
		while(grid[row][0] == '?') {
			grid[row] = grid[row - 1];
			row++;
			if (row >= grid.length) {
				return;
			}
		}
	}
	
	
	private static void fillLeft(char[][] grid, int row, int col, char val) {
		if (col < 0 || col >= grid[0].length) {
			return;
		}
		while(grid[row][col] == '?') {
			grid[row][col] = val;
			col--;
			if (col < 0) {
				return;
			}
		}
	}
	
	private static void fillRight(char[][] grid, int row, int col, char val) {
		if (col < 0 || col >= grid[0].length) {
			return;
		}
		while(grid[row][col] == '?') {
			grid[row][col] = val;
			col++;
			if (col >= grid[0].length) {
				return;
			}
		}
	}
	
	private static int parseInt(BufferedReader br)
			throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine());
	}
	
	private static int[] parseArray(BufferedReader br) throws IOException {
		String[] stringArr = br.readLine().split("\\s+");
		int[] ret = new int[stringArr.length];
		for (int i = 0; i < ret.length; i++) {
			ret[i] = Integer.parseInt(stringArr[i]);
		}
		return ret;
	}

	public static void main(String[] args) throws IOException {
		solve("A-small-attempt0.in");
		//solve("A-large.in");
		//solve("tiny.txt");
	}
}
