import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

//Counting Sheep
public class A {
	private static void solve(String in) throws IOException {
		PrintWriter writer = new PrintWriter(in.split("\\.")[0] + ".out", "UTF-8");
		BufferedReader br = new BufferedReader(new FileReader(in));

		int cases = parseInt(br);
		for (int q = 1; q <= cases; q++) {
			int param = parseInt(br);
			solve(param, writer, q);
		}

		br.close();
		writer.close();
	}
	
	private static void solve(Integer param, PrintWriter writer, Integer q) {
		boolean[] seen = new boolean[10];
		if (param == 0) {
			writer.println("Case #" + q + ": INSOMNIA");
			return;
		}
		int i = 1;
		int latest = param;
		while(notAllSeen(seen)) {
			int val = param * i;
			latest = val;
			while (val > 0) {
			    seen[val % 10] = true;
			    val /= 10;
			}
			i++;
		}
		writer.println("Case #" + q + ": " + latest);
	}

	private static boolean notAllSeen(boolean[] seen) {
		for (boolean b : seen) {
			if (!b) { return true; }
		}
		return false;
	}
	
	private static int parseInt(BufferedReader br)
			throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine());
	}

	private static int[] parseArray(BufferedReader br) throws IOException {
		String[] stringArr = br.readLine().split("\\s+");
		int[] ret = new int[stringArr.length];
		for (int i = 0; i < ret.length; i++) {
			ret[i] = Integer.parseInt(stringArr[i]);
		}
		return ret;
	}

	public static void main(String[] args) throws IOException {
		solve("A-small-attempt0.in");
		//solve("tiny.txt");
	}
}
