import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;

// A. Oversized Pancake Flipper
public class A {
	private static void solve(String in) throws IOException {
		PrintWriter writer = new PrintWriter(in.split("\\.")[0] + ".out", "UTF-8");
		BufferedReader br = new BufferedReader(new FileReader(in));

		int cases = parseInt(br);
		for (int q = 1; q <= cases; q++) {
			String[] s = br.readLine().split(" ");
			solve(s[0].toCharArray(), Integer.parseInt(s[1]), writer, q);
		}

		br.close();
		writer.close();
	}
	
	private static void solve(char[] param, int k, PrintWriter writer, long q) {
		int ret = recurse(param, k, writer, q, new HashSet<String>(), 0);
		if(ret >= 0) {
			writer.println("Case #" + q + ": " + ret);
		} else {
			writer.println("Case #" + q + ": " + "IMPOSSIBLE");
		}
	}
	
	private static int recurse(char[] param, int k, PrintWriter writer, long q, Set<String> seen, int flips) {
		if(seen.contains(new String(param))) {
			return -1;
		}
		for(int i = 0; i < param.length; i++) {
			if(param[i] == '-') {
				// flip
				if(i + k > param.length) {
					return -1;
				}
				seen.add(new String(param));
				for(int j = i; j < i + k; j++) {
					param[j] = param[j] == '+' ? '-' : '+';
				}
				return recurse(param, k, writer, q, seen, flips + 1);
			}
		}
		return flips;
	}
	
	private static int parseInt(BufferedReader br)
			throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine());
	}
	
	private static int[] parseArray(BufferedReader br) throws IOException {
		String[] stringArr = br.readLine().split("\\s+");
		int[] ret = new int[stringArr.length];
		for (int i = 0; i < ret.length; i++) {
			ret[i] = Integer.parseInt(stringArr[i]);
		}
		return ret;
	}

	public static void main(String[] args) throws IOException {
		solve("A-small-attempt0.in");
		//solve("tiny.txt");
	}
}
