import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

// B. Tidy Numbers
public class B {
	private static void solve(String in) throws IOException {
		PrintWriter writer = new PrintWriter(in.split("\\.")[0] + ".out", "UTF-8");
		BufferedReader br = new BufferedReader(new FileReader(in));

		int cases = parseInt(br);
		for (int q = 1; q <= cases; q++) {
			solve(br.readLine(), writer, q);
		}

		br.close();
		writer.close();
	}
	
	private static void solve(String param, PrintWriter writer, long q) {
		char[] ret = param.toCharArray();
		char curr = param.charAt(0);
		int firstIndexOfCurr = 0;
		
		for(int i = 1; i < param.length(); i++) {
			if (param.charAt(i) > curr) {
				curr = param.charAt(i);
				firstIndexOfCurr = i;
			} else if (param.charAt(i) < curr) {
				// it's a non-tidy number so
				// 1) decrement first appearance of curr
				ret[firstIndexOfCurr]--;
				int j = firstIndexOfCurr + 1;
				// 2) turn all following chars into 9
				while(j < ret.length) {
					ret[j] = '9';
					j++;
				}
				break;
			}
		}
		// fix 111...0 case
		for(int i = 1; i < ret.length; i++) {
			if(ret[i] == '0') {
				ret[i] = '9';
			} else {
				break;
			}
		}
		String out = ret[0] == '0' ?
				new String(ret).substring(1) : new String(ret);
		writer.println("Case #" + q + ": " + out);
	}
	
	private static int parseInt(BufferedReader br)
			throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine());
	}
	
	private static int[] parseArray(BufferedReader br) throws IOException {
		String[] stringArr = br.readLine().split("\\s+");
		int[] ret = new int[stringArr.length];
		for (int i = 0; i < ret.length; i++) {
			ret[i] = Integer.parseInt(stringArr[i]);
		}
		return ret;
	}

	public static void main(String[] args) throws IOException {
		solve("B-small-attempt2.in");
		//solve("tiny.txt");
	}
}
