import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

// Revenge of the Pancakes
public class B {
	private static void solve(String in) throws IOException {
		PrintWriter writer = new PrintWriter(in.split("\\.")[0] + ".out", "UTF-8");
		BufferedReader br = new BufferedReader(new FileReader(in));

		int cases = parseInt(br);
		for (int q = 1; q <= cases; q++) {
			boolean[] pancakes = parseArray(br);
			solveCase(pancakes, writer, q);
		}

		br.close();
		writer.close();
	}
	
	private static void solveCase(boolean[] stack, PrintWriter writer, Integer q) {
		stack = reduce(stack);
		int flips = 0;
		// at this line, it ends with -, or is empty
		while (!done(stack)) {
			if (stack[0]) { // if begins with +
				// flip as many + to - from start as possible
				for (int i = 0; i<stack.length; i++) {
					if (stack[i]) {
						stack[i] = false;
					} else {
						break;
					}
				}
				flips++;
			}
			// here we end with - and start with -
			stack = flipStack(stack);
			flips++;
			// here we end with + and start with +
			stack = reduce(stack);
		}
		writer.println("Case #" + q + ": " + flips);
	}
	
	private static boolean[] reduce(boolean[] stack) {
		int reduceBy = 0;
		for (int i = stack.length - 1; i >= 0; i--) {
			if (stack[i]) {
				reduceBy++;
			} else {
				return Arrays.copyOfRange(stack, 0, stack.length - reduceBy);
			}
		}
		return new boolean[0];
	}
	
	private static boolean done(boolean[] stack) {
		boolean ret = true;
		for (boolean b : stack) {
			ret &= b;
		}
		return ret;
	}
	
	private static boolean[] flipStack(boolean[] stack) {
		for (int i = 0; i < (stack.length + 1) / 2; i++) {
			boolean temp = stack[i];
			stack[i] = !stack[stack.length - 1 - i];
			stack[stack.length - 1 - i] = !temp;
		}
		return stack;
	}
	
	private static int parseInt(BufferedReader br)
			throws NumberFormatException, IOException {
		return Integer.parseInt(br.readLine());
	}

	private static boolean[] parseArray(BufferedReader br) throws IOException {
		char[] charArr = br.readLine().toCharArray();
		boolean[] ret = new boolean[charArr.length];
		for (int i = 0; i < ret.length; i++) {
			ret[i] = (charArr[i] == '+');
		}
		return ret;
	}

	public static void main(String[] args) throws IOException {
		solve("B-small-attempt1.in");
		//solve("tiny.txt");
	}
}
