import java.io.*;

class Main {

    static int caseNo = 1;

    public static void main(String[] args) throws IOException {
        BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream("in.txt")));
        String in = reader.readLine();

        while ((in = reader.readLine()) != null) {
            if (in.isEmpty()) {
                continue;
            }
            handleInput(in.split(" "));
        }
    }

    private static void printCase(String out) {
        System.out.println("Case #" + caseNo + ": " + out);
        caseNo++;
    }

    private static void handleInput(String[] in) {
        
        long lowerBound = (long) Math.ceil(Math.sqrt(Long.parseLong(in[0])));
        long upperBound = (long) Math.floor(Math.sqrt(Long.parseLong(in[1])));
        long count = 0;

        for (long i = lowerBound; i <= upperBound; i++) {
            if (isPalindrome(i) && isPalindrome(i * i)) {
                count++;
            }
        }

        printCase(count + "");
    }

    private static boolean isPalindrome(long p) {
        String asString = Long.toString(p);
        for (int i = 0; i < asString.length(); i++) {
            if (asString.charAt(i) != asString.charAt(asString.length() - 1 - i)) {
                return false;
            }
        }
        return true;
    }
}