/*
 * This file is public domain
 */
package net.boreeas.gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigDecimal;
import java.util.Arrays;

/**
 *
 * @author malte
 */
public class Main {

    static long casenum = 1;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        BufferedReader reader =
                       new BufferedReader(new InputStreamReader(new FileInputStream("in")));

        String in = reader.readLine();
        while ((in = reader.readLine()) != null) {
            if (in.trim().isEmpty()) {
                continue;
            }

            int ownSize = Integer.parseInt(in.split(" ")[0]);
            int[] moteSizes = toIntArray(reader.readLine().split(" "));

            if (ownSize == 1) {
                printCase(moteSizes.length);
            } else {

                Arrays.sort(moteSizes);
                printCase(doSolve(ownSize, moteSizes, 0, moteSizes.length, 0));

            }
        }
    }

    static int doSolve(int size, int[] motes, int idx, int bound, int ops) {

        if (idx >= bound) {
           return ops;
        } else if (size > motes[idx]) {
            return doSolve(size + motes[idx], motes, idx + 1, bound, ops);
        } else {
            int opsAdd = doSolve(size + (size - 1), motes, idx, bound, ops + 1);
            int opsRemove = doSolve(size, motes, idx, bound - 1, ops + 1);
            return Math.min(opsAdd, opsRemove);
        }
    }

    static int[] toIntArray(String[] arr) {
        int[] res = new int[arr.length];
        for (int i = 0; i < res.length; i++) {
            res[i] = Integer.parseInt(arr[i]);
        }
        return res;
    }

    static void printCase(long solution) {
        System.out.println("Case #" + casenum + ": " + solution);
        casenum++;
    }
}