import java.io.*;
import java.util.*;

class SavingTheUniverse
{
    public static void main(String args[])
    {
        File inFile  = new File("A-large.in");
        File outFile = new File("A-large.out");
        String line = "";


        int Q = 0; //number of queries
        int S = 0; //number of search engines

        String engines[]; // array of search engines
        String queries[]; // array of queries
        int engineCounter[]; // counter for each search engine, to optimize
        int engineMarker[]; // marker to indicate count finished, 0 == unfinished

        try
        {
            BufferedReader reader = new BufferedReader(new FileReader(inFile));
            BufferedReader console = new BufferedReader(new InputStreamReader(System.in));

            BufferedWriter writer = new BufferedWriter(new FileWriter(outFile));



            int N = Integer.parseInt(reader.readLine()); // num test cases

            for(int i = 0 ; i < N; i++)
            {

                //System.out.println("***************Case #" + (i+1));

                //position in the query list
                int position = 0;
                //min number of switches
                int nSwitch = 0;

                //dont yet have any selected
                int curSelected = -1;


                //load up the list of search engines
                line = reader.readLine();
                S = Integer.parseInt(line);

                engines        = new String[S];
                engineMarker   = new int[S];
                engineCounter  = new int[S];

                for (int j = 0 ; j < S ; j++)
                {
                    line = reader.readLine();
                    engines[j] = line;
                    //System.out.println("Engine #" + (j+1) + ": " + engines[j]);
                    engineMarker[j] = -1;
                    engineCounter[j] = 0;
                }

                //load up the list of queries for this test case
                line = reader.readLine();
                Q = Integer.parseInt(line);
                queries = new String[Q];
                for (int j = 0 ; j < Q ; j++)
                {
                    line = reader.readLine();
                    queries[j] = line;
                }

                while(position < Q)
                {

                    //reset the counters
                    for (int j = 0 ; j < S ; j++)
                    {
                        engineMarker[j] = -1;
                        engineCounter[j] = 0;
                    }

                    if (position!=0)
                        nSwitch += 1;

                    int remaining = Q - position;

                    //find the search engine with the least number of switches
                    for (int j = position ; j < Q ; j++)
                    {
                        //System.out.println(queries[j]);
                        boolean myFlag = false;
                        for (int k = 0; k < S ; k++)
                        {
                            if (engineMarker[k] == -1)
                            {
                                myFlag = true;
                                //System.out.println(queries[j] + " =? " + engines[k]);
                                if (!queries[j].equals(engines[k]))
                                {
                                    engineCounter[k] += 1;
                                    //System.out.println("UP");
                                }
                                else
                                {
                                    engineMarker[k] = engineCounter[k];

                                    //System.out.println("STORED: " + engineMarker[k]);
                                    engineCounter[k] = 0;
                                }
                            }
                        }
                        if (!myFlag)
                            break;
                    }

                    //finishes the case where its the last entry
                    for (int j = 0; j < S ; j++)
                    {
                        if (engineCounter[j] != 0 && engineMarker[j]==-1)
                            engineMarker[j] = engineCounter[j];
                        engineCounter[j] = 0;
                    }

                    int total = 0;
                    int totalN = 0;

                    for (int j = 0; j < S ; j++)
                    {
                        //System.out.println("#" + j + ":\t" + engineMarker[j]);
                        if (engineMarker[j]>total)
                        {
                            total = engineMarker[j];
                            totalN = j;
                        }
                    }

                    //System.out.println("Engine #" + (totalN+1) + " was selected.");
                    //System.out.println(engines[totalN] + " was selected.");
                    //System.out.println("Number of switch: " + nSwitch);
                    //console.readLine();


                    //System.out.println(total);
                    //for(int q = position; q < position + total; q++)
                    //{
                    //    System.out.println(q + ": " + queries[q]);
                    //}

                    position += total;


                }

                writer.write("Case #" + (i+1) + ": " + nSwitch);
                writer.newLine();
            }

            reader.close();
            writer.close();

        }
        catch (IOException e)
        {
            System.err.println(e);
        }

    }

}