import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.util.Iterator;
import java.util.Vector;


public class TrainTimeTable {
	public static final int A =0;
	public static final int B =1;
	private class TrainsNumber {
		public int na;   // number of trains from a;
		public int nb;   // number of trains from b;
	}
	private class Trip {
		public int from;
		public int to;
		public int departure;
		public int arrival;
		public Trip(int from, int to,String dep, String arr,int turnaround_time) {
			this.from = from;
			this.to = to;
			departure = timeToMinutes(dep);
			arrival = timeToMinutes(arr)+turnaround_time;
		}
		private int timeToMinutes(String str) {
			String[] fields = str.split(":");
			int h = Integer.parseInt(fields[0]);
			int m = Integer.parseInt(fields[1]);
			return h*60+m;
		}
		public int getConnection(Trip t2) {
			int result = Integer.MAX_VALUE;
			if (this.to == t2.from) {
				if (this.arrival <= t2.departure) {
					result = (t2.departure-this.arrival);
				}
			};
			return result;
		}
		public void combine(Trip to_reduce) {
			this.to = to_reduce.to;
			this.arrival = to_reduce.arrival;
		}
	}
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		String filename;
		//filename = args[0];
		//filename = "B-small.in.txt";
		//filename = "A-large.in.txt";
		filename = "B-large.in.txt";
		
		// Opening of the file
		FileInputStream fis = new FileInputStream(filename);
		InputStreamReader isr = new InputStreamReader(fis);
		LineNumberReader lnr = new LineNumberReader(isr);

		TrainTimeTable me = new TrainTimeTable();
		String line_num = lnr.readLine();
		String line = "";
		int num_of_lines = Integer.parseInt(line_num);
		String[] fields;       // fields in the line
		FileOutputStream out_file = new FileOutputStream(filename+".out");
		PrintStream out = new PrintStream(out_file);
		for (int nLine =1; nLine <= num_of_lines; nLine++) {
		    //line = lnr.readLine();
		    // detection of EOF
		    //if (line == null) break;
		    //fields = line.split("\\s+");
		    TrainsNumber result = me.do_alg(lnr);
		    out.println("Case #"+nLine+": "+result.na+" "+result.nb);  // might change depending on the required output format
		}
		out.close();

	}

	private Vector<Trip> getTrips(LineNumberReader lnr,int trips_from_a, int trips_from_b,int turnaround_time) throws NumberFormatException, IOException {
		Vector<Trip> trips = new Vector<Trip>();
		for (int i=0;i<trips_from_a+trips_from_b;i++) {
			int from = i<trips_from_a ? A :B;
			int to = (from +1) % 2;
			String trip_detail_line = lnr.readLine();
			String[] times = trip_detail_line.split("\\s+");
			Trip t = new Trip(from,to,times[0],times[1],turnaround_time);
			trips.add(t);
		}
		return trips;
	}
	private TrainsNumber do_alg(LineNumberReader lnr) throws NumberFormatException, IOException {
		TrainsNumber result = new TrainsNumber();
		int turnaround_time = Integer.parseInt(lnr.readLine());
		String trip_num_line = lnr.readLine();
		String[] fields = trip_num_line.split("\\s+");
		int trips_from_a = Integer.parseInt(fields[0]);
		int trips_from_b = Integer.parseInt(fields[1]);
		Vector<Trip> trips = getTrips(lnr,trips_from_a,trips_from_b,turnaround_time);
		boolean finished = false;
		while (!finished) {
			finished = reduceTrip(trips);
		}
		
		Iterator<Trip> iter = trips.iterator();
		while (iter.hasNext()) {
			Trip t = iter.next();
			if (t.from == A) {
				result.na++;
			} else {
				result.nb++;
			}
		}
		return result;
	}

	private boolean reduceTrip(Vector<Trip> trips) {
		Iterator<Trip> iter1 = trips.iterator();
		while (iter1.hasNext()) {
			Trip t1 = iter1.next();
			Iterator<Trip> iter2 = trips.iterator();
			int min_connection = Integer.MAX_VALUE;
			Trip to_reduce = null;
			while (iter2.hasNext()) {
				Trip t2 = iter2.next();
				int connection = t1.getConnection(t2);
				if (connection < min_connection) {
					min_connection = connection;
					to_reduce = t2;
				}
			}
			if (to_reduce != null) {
				t1.combine(to_reduce);
				trips.remove(to_reduce);
				return false;
			}
		}
		return true;
	}

}
