import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.PrintStream;


public class SavingTheUniverse {

	private class SearchEngine {
		String name;
		int first_occurance;
		SearchEngine(String name) {
			this.name = name;
		}
		public void resetOccurance() {
			first_occurance = Integer.MAX_VALUE;
		}
		public void setOccurance(int pos) {
			first_occurance = pos;
		}
		public int getOccurance() {
			return first_occurance;
		}
		public String getName() {
			return name;
		}
	}
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		String filename;
		//filename = args[0];
		//filename = "B-small.in.txt";
		//filename = "A-large.in.txt";
		filename = "A-small-attempt0.in.txt";
		
		// Opening of the file
		FileInputStream fis = new FileInputStream(filename);
		InputStreamReader isr = new InputStreamReader(fis);
		LineNumberReader lnr = new LineNumberReader(isr);

		SavingTheUniverse me = new SavingTheUniverse();
		String line_num = lnr.readLine();
		String line = "";
		int num_of_lines = Integer.parseInt(line_num);
		String[] fields;       // fields in the line
		FileOutputStream out_file = new FileOutputStream(filename+".out");
		PrintStream out = new PrintStream(out_file);
		for (int nLine =1; nLine <= num_of_lines; nLine++) {
		    //line = lnr.readLine();
		    // detection of EOF
		    //if (line == null) break;
		    //fields = line.split("\\s+");
		    int result = me.do_alg(line, lnr);
		    out.println("Case #"+nLine+": "+result);  // might change depending on the required output format
		}
		out.close();

	}

	private SearchEngine[] getEngines(LineNumberReader lnr,int num_of_engines) throws IOException {
		SearchEngine[] engines = new SearchEngine[num_of_engines];
		for (int i=0;i<num_of_engines;i++) {
			String engine_name = lnr.readLine();
			SearchEngine engine = new SearchEngine(engine_name);
			engines[i] = engine;
		}
		return engines;
	}
	private String[] getQueries(LineNumberReader lnr,int num_of_queries) throws IOException {
		
		String[] queries = new String[num_of_queries];
		for (int i=0;i<num_of_queries;i++) {
			queries[i] = lnr.readLine();
		}
		return queries;
	}
	private int do_alg(String line, LineNumberReader lnr) throws NumberFormatException, IOException {
		int num_of_engines = Integer.parseInt(lnr.readLine());
		if (num_of_engines ==0) {
			return 0;
		}
		SearchEngine[] engines = getEngines(lnr,num_of_engines);
		int num_of_queries = Integer.parseInt(lnr.readLine());
		if (num_of_queries ==0) {
			return 0;
		}
		if (num_of_engines == 1) {
			return 0; // The universe should implode here
		}
		String[] queries = getQueries(lnr,num_of_queries);
		int num_of_switches =0;
		int curr_index = 0;
		while (curr_index < num_of_queries) {
			int first_occurance = curr_index;
			for (int i=0; i < num_of_engines;i++) {
				SearchEngine engine = engines[i];
				engine.resetOccurance();
				for (int j=curr_index;j<num_of_queries;j++) {
					if (engine.getName().equals(queries[j])) {
						engine.setOccurance(j);
						break;
					}
				}
				if (engine.getOccurance() > first_occurance) {
					first_occurance = engine.getOccurance();
					if (first_occurance > num_of_queries) {
						return num_of_switches;
					}
				}
			}
			curr_index = first_occurance;
			num_of_switches++;
		}
		return num_of_switches;
	}

}
