import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Vector;


public class Round1Q2 {

	private class Set {
		long[] arr;
		int size;
		public boolean marked;
		Set(long num) {
			arr = new long[2];
			size =1;
			arr[0] = num;
		}
		void add(long num) {
			if (size == arr.length) {
				long[] new_arr = new long[size*2];
				for (int i=0;i<size;i++) {
					new_arr[i]= arr[i];
				}
				arr = new_arr;
			}
			arr[size] = num;
			size++;
		}
		int getSize() {
			return size;
		}
	}
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		String filename;
		//filename = args[0];
		//filename = "B-small.in.txt";
		filename = "B-small-attempt0.in.txt";
		//filename = "test_q2.txt";
		
		// Opening of the file
		FileInputStream fis = new FileInputStream(filename);
		InputStreamReader isr = new InputStreamReader(fis);
		LineNumberReader lnr = new LineNumberReader(isr);

		Round1Q2 me = new Round1Q2();
		String line_num = lnr.readLine();
		String line = "";
		int num_of_lines = Integer.parseInt(line_num);
		String[] fields;       // fields in the line
		FileOutputStream out_file = new FileOutputStream(filename+".out");
		PrintStream out = new PrintStream(out_file);
		for (int nLine =1; nLine <= num_of_lines; nLine++) {
		    line = lnr.readLine();
		    //detection of EOF
		    if (line == null) break;
		    fields = line.split("\\s+");
		    int result = me.do_alg(fields);
		    out.println("Case #"+nLine+": "+result);  // might change depending on the required output format
		}
		out.close();
	}

	private int do_alg(String[] fields) {
		int result =0;
		long A = Long.parseLong(fields[0]);
		long B = Long.parseLong(fields[1]);
		int P = Integer.parseInt(fields[2]);
		Vector<Set> sets = new Vector<Set>();
		int size = (int)(B-A)+1;
		Set[] all_nums = new Set[size];
		for (long i=A;i<=B;i++) {
			int ind = (int)(i-A);
			Set s = all_nums[ind];
			boolean is_new = false;
			if (s==null) {     
				s = new Set(i);
				all_nums[ind] = s;
				is_new = true;
			};
			int[] prims = decompose(i,P);
			for (int fi =0;fi<prims.length;fi++) {
				int prim = prims[fi];
				if (i+prim >B) {
					continue;
				}		
				for (long same_set =i+prim;same_set <=B;same_set = same_set+prim) {
					int ind2 = (int) (same_set-A);
					Set s2 = all_nums[ind2];
					if (s2==null) {
						all_nums[ind2] = s;
					} else {
						for (int i3=0;i3<size;i3++) {
							if (all_nums[i3] ==s2) {
								all_nums[i3] =s;
							}
						}
					}
				}
			}
		}
		for (int i4=0;i4<size;i4++) {
			Set s2 = all_nums[i4];
			if (!s2.marked) {
				result++;
				s2.marked=true;
			}
		}		
		// TODO Auto-generated method stub
		return result;
	}

	private int[] decompose(long i, int p) {
		int[] tmp_result = new int[100];
		int act_size =0;
		double num = (double)i;
		int sqrt = (int)Math.sqrt(num);
		for (int prim=p;prim<=i;prim++) {
			if (i%prim==0) {
				if (isPrim(prim)) {
					tmp_result[act_size] = prim;
					i = i/prim;
					act_size++;
				}
			}
		}
		int[] result = new int[act_size];
		for (int j=0;j<act_size;j++) {
			result[j] = tmp_result[j];
		}
		return result;
	}

	private boolean isPrim(int prim) {
		double num = (double)prim;
		int sqrt = (int)Math.sqrt(num);
		if (prim==2) { return true;};
		for (int i=2;i<=sqrt;i++) {
			if (prim%i ==0) {
				return false;
			}
		}
		return true;
	}

}
