package comp.google.gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayDeque;
import java.util.Deque;
import java.util.StringTokenizer;

public class First {

	static class InputReader {
		public BufferedReader br;
		public StringTokenizer st;

		public InputReader(InputStream is) {
			br = new BufferedReader(new InputStreamReader(is));
			st = null;
		}

		public String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.valueOf(next());
		}

		public long nextLong() {
			return Long.valueOf(next());
		}
	}

	public static void main(String[] args) throws FileNotFoundException, IOException {
		try (FileInputStream inputStream = new FileInputStream("google.in");
				FileOutputStream outputStream = new FileOutputStream("google.out")) {
			InputReader input = new InputReader(inputStream);
			OutputStreamWriter output = new OutputStreamWriter(outputStream);
			int numTests = input.nextInt();
			for (int o = 1; o <= numTests; o++) {
				output.append(String.format("Case #%d: ", o));
				String pancakes = input.next();
				int k = input.nextInt();

				boolean flipped = false;
				int flipNumber = 0;
				boolean hasSolution = true;
				Deque<Integer> flips = new ArrayDeque<>();
				for (int i = 0; i < pancakes.length(); i++) {
					flipped = flips.size() % 2 == 1;
					if (flipped != (pancakes.charAt(i) == '-')) {
						if (i + k <= pancakes.length()) {
							flipped = !flipped;
							flipNumber++;
							flips.add(i);
						} else {
							output.append("IMPOSSIBLE");
							hasSolution = false;
							break;
						}
					}
					if (!flips.isEmpty() && i - flips.peekFirst() + 1 >= k) {
						flips.pop();
					}
				}
				if (hasSolution) {
					output.append(String.valueOf(flipNumber));
				}
				output.append("\n");
			}
			output.flush();
		}

	}

}
