package comp.google.gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.Map;
import java.util.Map.Entry;
import java.util.StringTokenizer;
import java.util.TreeMap;

public class Third {

	static class InputReader {
		public BufferedReader br;
		public StringTokenizer st;
		public InputReader(InputStream is) {
			br = new BufferedReader(new InputStreamReader(is));
			st = null;
		}
		
		public String next() {
			while (st == null || !st.hasMoreTokens()) {
				try {
					st = new StringTokenizer(br.readLine());
				} catch (IOException e) {
					// TODO Auto-generated catch block
					e.printStackTrace();
				}
			}
			return st.nextToken();
		}
		public int nextInt() {
			return Integer.valueOf(next());
		}
		public long nextLong() {
			return Long.valueOf(next());
		}
	}
	
	private static void addEntry(Map<Long, Long> map, long val, long number) {
		if (map.containsKey(val)) {
			map.put(val, map.get(val) + number);
		} else {
			map.put(val,  number);
		}
	}
	
	public static void main(String[] args) throws FileNotFoundException, IOException {
		try (FileInputStream inputStream = new FileInputStream("google.in");
				FileOutputStream outputStream = new FileOutputStream("google.out")) {
			InputReader input = new InputReader(inputStream);
			OutputStreamWriter output = new OutputStreamWriter(outputStream);
			int numTests= input.nextInt();
			
			for (int o = 1; o <= numTests; o++) {
				output.append(String.format("Case #%d: ", o));
				long n, k;
				n = input.nextLong();
				k = input.nextLong();
				TreeMap<Long, Long> numbers = new TreeMap<>();
				numbers.put(n, 1L);
				long solvingNumber = -1;
				while (k > 0) {
					Entry<Long, Long> lastEntry = numbers.lastEntry();
					if (k <= lastEntry.getValue()) {
						solvingNumber = lastEntry.getKey();
						break;
					}
					long number = lastEntry.getValue();
					k -= number;
					long val = lastEntry.getKey();
					numbers.remove(val);
					addEntry(numbers, (val - 1) / 2, number);
					addEntry(numbers, val / 2, number);
				}
				output.append("" + solvingNumber / 2);
				output.append(" ");
				output.append("" + (solvingNumber - 1) / 2);
				output.append("\n");
			}
			output.flush();
		}

	}

}
