package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;

public class Mag {
    public static void main(String[] args) throws Exception {
	BufferedReader br = new BufferedReader(new InputStreamReader(
		new FileInputStream(args[0])));

	String response = new Mag().solve(br);

	FileWriter fileWriter = new FileWriter(args[0]
		+ (System.currentTimeMillis() % 100000) + ".out");
	fileWriter.write(response);
	fileWriter.close();
    }

    public String solve(String string) throws Exception {
	return solve(new BufferedReader(new StringReader(string)));
    }

    private String solve(BufferedReader br) throws Exception {
	int t = Integer.parseInt(br.readLine());

	StringBuilder sb = new StringBuilder();
	for (int i = 0; i < t; i++) {
	    sb.append("Case #" + (i + 1) + ": " + solveOne(br)).append("\n");
	}

	return sb.toString();
    }

    private String solveOne(BufferedReader br) throws Exception {
	String line = br.readLine();
	StringTokenizer tokens = new StringTokenizer(line, " ");

	Map<String, Character> comp = createComposeMap(tokens);
	Set<String> del = createOposeSet(tokens);

	int n = Integer.parseInt(tokens.nextToken());
	String chars = tokens.nextToken().trim();

	List<Character> result = new ArrayList<Character>();

	for (int i = 0; i < n; i++) {
	    char now = chars.charAt(i);

	    if (result.size() > 0) {
		char lastChar = result.get(result.size() - 1);
		Character update = comp.get("" + lastChar + now);
		if (update != null) {
		    result.remove(result.size() - 1);
		    result.add(update);
		    continue;
		}
	    }

	    if (listContainsOpose(del, result, now)) {
		result.clear();
		continue;
	    }

	    result.add(now);
	}

	return result.toString();
    }

    private boolean listContainsOpose(Set<String> del, List<Character> result,
	    char now) {
	for (int i = 0; i < result.size(); i++) {
	    if (del.contains("" + result.get(i) + now)) {
		return true;
	    }
	}

	return false;
    }

    private Map<String, Character> createComposeMap(StringTokenizer tokens) {
	int c = Integer.parseInt(tokens.nextToken());

	Map<String, Character> map = new HashMap<String, Character>();

	for (int i = 0; i < c; i++) {
	    String string = tokens.nextToken().trim();

	    map.put(string.substring(0, 2), string.charAt(2));
	    map.put("" + string.charAt(1) + string.charAt(0), string.charAt(2));
	}

	return map;
    }

    private Set<String> createOposeSet(StringTokenizer tokens) {
	int d = Integer.parseInt(tokens.nextToken());

	Set<String> set = new HashSet<String>();

	for (int i = 0; i < d; i++) {
	    String string = tokens.nextToken().trim();

	    set.add(string.substring(0, 2));
	    set.add("" + string.charAt(1) + string.charAt(0));
	}

	return set;
    }
}