package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.StringTokenizer;

public class HotDog {
    public static void main(String[] args) throws Exception {
	BufferedReader br = new BufferedReader(new InputStreamReader(
		new FileInputStream(args[0])));

	String response = new HotDog().solve(br);

	FileWriter fileWriter = new FileWriter(args[0]
		+ (System.currentTimeMillis() % 100000) + ".out");
	fileWriter.write(response);
	fileWriter.close();
    }

    public String solve(String string) throws Exception {
	return solve(new BufferedReader(new StringReader(string)));
    }

    private String solve(BufferedReader br) throws Exception {
	int t = Integer.parseInt(br.readLine());

	StringBuilder sb = new StringBuilder();
	for (int i = 0; i < t; i++) {
	    sb.append("Case #" + (i + 1) + ": " + solveOne(br)).append("\n");
	}

	return sb.toString();
    }

    private String solveOne(BufferedReader br) throws Exception {
	String line1 = br.readLine();
	StringTokenizer tokens1 = new StringTokenizer(line1, " ");
	int c = Integer.parseInt(tokens1.nextToken().trim());
	int d = Integer.parseInt(tokens1.nextToken().trim());

	int[] points = new int[c];
	int[] dogs = new int[c];
	for (int i = 0; i < c; i++) {
	    String line = br.readLine();
	    StringTokenizer tokens = new StringTokenizer(line, " ");
	    int p = Integer.parseInt(tokens.nextToken().trim());
	    int v = Integer.parseInt(tokens.nextToken().trim());

	    points[i] = p;
	    dogs[i] = v;
	}

	double[] timeUsed = new double[c];
	double[] scPos = new double[c];
	double maxTimeUsed = 0;

	for (int i = 0; i < c; i++) {
	    double scatter = scatter(dogs[i], d);
	    double positionNeg = -scatter + points[i];

	    timeUsed[i] += scatter;
	    System.out.println(String.format("%d scatter = %s", i, scatter));

	    if (timeUsed[i] > maxTimeUsed) {
		maxTimeUsed = timeUsed[i];
		System.out.println(String.format("max time %d update = %s", i,
			timeUsed[i]));
	    }

	    if (i > 0) {
		double prevPositionPos = scPos[i - 1];
		System.out.println(String.format("%d prevPosition = %s", i - 1,
			scPos[i - 1]));
		System.out.println(String.format("%d currPosition = %s", i,
			positionNeg));

		double sep = separate(prevPositionPos, positionNeg, d);
		System.out.println(String.format(
			"%d-%d base separation = %s/2 = %s", i, i - 1, sep,
			sep / 2));

		if (maxTimeUsed > timeUsed[i - 1]) {
		    // still have some time left to move

		    double saved = maxTimeUsed - timeUsed[i - 1];
		    if (sep > saved) {
			sep -= saved;

			timeUsed[i - 1] += saved;
		    } else {
			sep = 0;

			timeUsed[i - 1] += sep;
		    }

		    System.out.println(String.format("%d saves %s time", i - 1,
			    maxTimeUsed - timeUsed[i - 1]));
		}

		if (maxTimeUsed > timeUsed[i]) {
		    // still have some time left to move

		    double saved = maxTimeUsed - timeUsed[i];
		    if (sep > saved) {
			sep -= saved;

			timeUsed[i] += saved;
		    } else {
			sep = 0;

			timeUsed[i] += sep;
		    }
		    System.out.println(String.format("%d saves %s time", i,
			    saved));
		}

		timeUsed[i] += sep / 2;
		timeUsed[i - 1] += sep / 2;

		if (timeUsed[i - 1] > maxTimeUsed) {
		    maxTimeUsed = timeUsed[i - 1];
		    System.out.println(String.format("max time %d update = %s",
			    i - 1, timeUsed[i - 1]));
		}

		System.out
			.println(String.format("%d-%d separation = %s/2 = %s",
				i, i - 1, sep, sep / 2));

		scPos[i] += sep / 2;
	    }

	    scPos[i] += scatter + points[i];

	    if (timeUsed[i] > maxTimeUsed) {
		maxTimeUsed = timeUsed[i];
		System.out.println(String.format("max time %d update = %s", i,
			timeUsed[i]));
	    }
	}

	return Double.toString(maxTimeUsed);
    }

    private double separate(double position1, double position2, int d) {
	if (position2 - position1 >= d) {
	    return 0.0;
	}

	double distance = -position1 + position2;
	double toMove = -distance + d;

	return toMove;
    }

    private double scatter(int count, int d) {
	if ((count % 1) > 0) {
	    // odd

	    return 0.5 * d * count;
	} else {
	    // even
	    return 0.5 * d * (count - 1);
	}
    }
}
