package gcj;

import java.util.HashMap;
import java.util.Map;

public class Calc {

    public Map<Integer, double[]> computeCounts(int n) {
	Map<Integer, double[]> map = new HashMap<Integer, double[]>();

	map.put(2, new double[] { 1, 0, 1, 1 });

	for (int i = 3; i <= n; i++) {
	    double[] array = new double[i + 1 + 1];
	    array[i] = 1;
	    array[i - 1] = 0;

	    for (int k = i - 2; k > 0; k--) {
		array[k] = getNewton(i, k)
			* (factorial(i - k) - map.get(i - k)[i - k + 1]);
	    }

	    array[i + 1] = sum(array, 1, i);
	    array[0] = factorial(i) - array[i + 1];

	    map.put(i, array);
	}

	return map;
    }

    private double sum(double[] array, int from, int to) {
	double result = 0;

	for (int i = from; i <= to; i++) {
	    result += array[i];
	}

	return result;
    }

    double factorial(int i) {
	if (i <= 1) {
	    return 1;
	}

	double result = 1;
	for (int k = i; k > 1; k--) {
	    result *= k;
	}

	return result;
    }

    double getNewton(int n, int k) {
	long result = 1;
	for (int i = n; i > n - k; i--) {
	    result *= i;
	}

	for (int i = k; i > 1; i--) {
	    result /= i;
	}

	return result;
    }

    public Map<Integer, double[][]> computeTables(int n, int limit,
	    Map<Integer, double[]> counts) {

	Map<Integer, double[][]> map = new HashMap<Integer, double[][]>();

	double[][] arrayFor2 = new double[limit][3];
	map.put(2, arrayFor2);

	arrayFor2[1][0] = 0.5;
	arrayFor2[1][1] = 0;
	arrayFor2[1][2] = 0.5;

	for (int i = 2; i < limit; i++) {
	    arrayFor2[i][0] = arrayFor2[i - 1][0] * arrayFor2[1][0];
	    arrayFor2[i][2] = arrayFor2[i - 1][2] * arrayFor2[1][2];
	}

	for (int k = 3; k <= n; k++) {
	    double[][] array = new double[limit][k + 1];
	    map.put(k, array);

	    double fact = factorial(k);
	    for (int j = 0; j <= k; j++) {
		array[1][j] = counts.get(k)[j] / fact;
	    }

	    for (int i = 2; i < limit; i++) {
		for (int l = 0; l <= k - 2; l++) {
		    double prob = 0.0;
		    for (int m = 0; m <= l; m++) {
			try {
			    prob += array[i - 1][m] * map.get(k - m)[1][l - m];
			} catch (NullPointerException e) {
			    System.out.println(String.format(
				    "Computing k=%d, i=%d, l=%d, m=%d\n", k, i,
				    l, m));
			}
		    }
		    array[i][l] = prob;
		}

		double prob = 0.0;
		for (int m = 0; m <= k - 2; m++) {
		    prob += array[i - 1][m] * map.get(k - m)[1][k - m];
		}
		array[i][k] = prob;
	    }
	}

	return map;
    }

    public double[] countMagicValues(int n, int limit,
	    Map<Integer, double[][]> tables) {
	double[] result = new double[n + 1];

	for (int i = 2; i <= n; i++) {
	    result[i] = sum(tables.get(i), limit, i);
	}

	return result;
    }

    private double sum(double[][] ds, int limit, int c) {
	double result = 0.0;

	for (int i = 1; i < limit; i++) {
	    result += ds[i][c] * i;
	}

	return result;
    }
}
