package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.StringTokenizer;

public class Candy {
    public static void main(String[] args) throws Exception {
	BufferedReader br = new BufferedReader(new InputStreamReader(
		new FileInputStream(args[0])));

	String response = new Candy().solve(br);

	FileWriter fileWriter = new FileWriter(args[0]
		+ (System.currentTimeMillis() % 100000) + ".out");
	fileWriter.write(response);
	fileWriter.close();
    }

    public String solve(String string) throws Exception {
	return solve(new BufferedReader(new StringReader(string)));
    }

    private String solve(BufferedReader br) throws Exception {
	int t = Integer.parseInt(br.readLine());

	StringBuilder sb = new StringBuilder();
	for (int i = 0; i < t; i++) {
	    sb.append("Case #" + (i + 1) + ": " + solveOne(br)).append("\n");
	}

	return sb.toString();
    }

    private String solveOne(BufferedReader br) throws Exception {
	int n = Integer.parseInt(br.readLine());

	String line = br.readLine();
	StringTokenizer tokens = new StringTokenizer(line, " ");

	int xored = 0;
	int sum = 0;
	int smallest = Integer.MAX_VALUE;

	for (int i = 0; i < n; i++) {
	    int next = Integer.parseInt(tokens.nextToken().trim());

	    xored ^= next;
	    sum += next;

	    if (next < smallest) {
		smallest = next;
	    }
	}

	if (xored == 0) {
	    return String.valueOf(sum - smallest);
	} else {
	    return "NO";
	}
    }
}
