package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;

public class Goro {
    public static void main(String[] args) throws Exception {
	BufferedReader br = new BufferedReader(new InputStreamReader(
		new FileInputStream(args[0])));

	String response = new Goro().solve(br);

	FileWriter fileWriter = new FileWriter(args[0]
		+ (System.currentTimeMillis() % 100000) + ".out");
	fileWriter.write(response);
	fileWriter.close();
    }

    public String solve(String string) throws Exception {
	return solve(new BufferedReader(new StringReader(string)));
    }

    private String solve(BufferedReader br) throws Exception {
	int t = Integer.parseInt(br.readLine());

	StringBuilder sb = new StringBuilder();
	for (int i = 0; i < t; i++) {
	    sb.append("Case #" + (i + 1) + ": " + solveOne(br)).append("\n");
	}

	return sb.toString();
    }

    private String solveOne(BufferedReader br) throws Exception {
	int n = Integer.parseInt(br.readLine());

	String line = br.readLine();
	StringTokenizer tokens = new StringTokenizer(line, " ");

	int[] tab = new int[n];
	for (int i = 0; i < n; i++) {
	    tab[i] = Integer.parseInt(tokens.nextToken().trim());
	}

	List<Integer> cyc = getCyclesLengths(tab);

	return new Double(sumCycles(cyc)).toString();

    }

    private double sumCycles(List<Integer> cyc) {
	double result = 0.0;

	for (int i = 0; i < cyc.size(); i++) {
	    result += cyc.get(i) == 1 ? 0 : cyc.get(i);
	}

	return result;
    }

    private List<Integer> getCyclesLengths(int[] tab) {
	int[] helper = new int[tab.length];
	List<Integer> cycles = new ArrayList<Integer>();

	int lastCycleNumber = 0;
	for (int i = 0; i < tab.length; i++) {
	    if (helper[i] == 0) {
		int k = i;
		lastCycleNumber++;
		int cycleLength = 0;
		while (helper[k] == 0) {
		    helper[k] = lastCycleNumber;
		    cycleLength++;

		    k = tab[k] - 1;
		}

		cycles.add(cycleLength);
	    }
	}

	return cycles;
    }
}
