package gcj;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.io.StringReader;
import java.util.StringTokenizer;

public class Bot {
    public static void main(String[] args) throws Exception {
	BufferedReader br = new BufferedReader(new InputStreamReader(
		new FileInputStream(args[0])));

	String response = new Bot().solve(br);

	FileWriter fileWriter = new FileWriter(args[0]
		+ (System.currentTimeMillis() % 100000) + ".txt");
	fileWriter.write(response);
	fileWriter.close();
    }

    public String solve(String string) throws Exception {
	return solve(new BufferedReader(new StringReader(string)));
    }

    private String solve(BufferedReader br) throws Exception {
	int t = Integer.parseInt(br.readLine());

	StringBuilder sb = new StringBuilder();
	for (int i = 0; i < t; i++) {
	    sb.append("Case #" + (i + 1) + ": " + solveOne(br)).append("\n");
	}

	return sb.toString();
    }

    private String solveOne(BufferedReader br) throws Exception {
	String line = br.readLine();
	StringTokenizer tokens = new StringTokenizer(line, " ");

	int n = Integer.parseInt(tokens.nextToken());

	int pos[] = new int[] { 1, 1 };
	int rest[] = new int[2];
	int allTime = 0;

	for (int i = 0; i < n; i++) {
	    char type = readChar(tokens.nextToken());
	    int button = readInt(tokens.nextToken());

	    int indM;
	    int indR;
	    if (type == 'O') {
		indM = 0;
		indR = 1;
	    } else {
		indM = 1;
		indR = 0;
	    }

	    int distance = button - pos[indM];
	    if (distance < 0) {
		distance = -distance;
	    }

	    if (rest[indM] == 0) {
		allTime += distance;
		rest[indR] += distance;
	    } else {
		if (rest[indM] >= distance) {
		    rest[indM] = 0;
		} else {
		    distance -= rest[indM];
		    rest[indM] = 0;

		    allTime += distance;
		    rest[indR] += distance;
		}
	    }

	    allTime++;
	    rest[indR]++;

	    pos[indM] = button;
	}

	return String.valueOf(allTime);
    }

    private int readInt(String string) {
	return Integer.parseInt(string.trim());
    }

    private char readChar(String string) {
	return string.trim().charAt(0);
    }
}
