import java.util.Scanner;


public class R1D {

	public static void main(String[] args) {
		Scanner scan = new Scanner(System.in);
		int T = scan.nextInt();
		for(int t=0; t<T; t++)
		{
			int X = scan.nextInt();
			int R = scan.nextInt();
			int C = scan.nextInt();
			System.out.println("Case #"+(t+1)+": " + getWinner2(X, R, C));
		}
		scan.close();
	}
	
	private static String getWinner2(int X, int R, int C)
	{
		//Check if RxC can be completely filled by multiple of X's without hole.
		if((R*C) % X != 0)
		{
			return "RICHARD";
		}
		
		//check if X can be just straight block and extend outside of the grid.
		if( X > R && X > C)
		{
			return "RICHARD";
		}
		
		int minSideLength;
		if(R > C)
		{
			minSideLength = C;
		}
		else
		{
			minSideLength = R;
		}
		
		if(minSideLength == 1)
		{
			//you need at least 3 in order to make L shape (2X2).
			if(X>=3)
				return "RICHARD";
		}
		
		if(minSideLength == 2)
		{
			//you need at least 4 in order to make T shape (3x2).
			if(X>=4)
				return "RICHARD";
		}
		
		if( minSideLength==3)
		{
			//you need at least 5 in order to make cross (3x3).
			if(X>=5)
				return "RICHARD";
		}
		
		if( minSideLength==4)
		{
			//you need at least 6 in order to make cross(4x3).
			if(X>=6)
				return "RICHARD";
		}
		
		//if X>=7, it can make a hole inside, therefore can never be filled.
		if(X>=7)
		{
			return "RICHARD";
		}
		
		
		return "GABRIEL";
	}
	
	private static String getWinner(int X, int R, int C)
	{
		//num of grid is odd, cannot fill with two X's
		if( (R * C) % 2 != 0 )
		{
			return "RICHARD";
		}
		
		//num of grid does not equal exactly two X's, therefore cannot be filled.
		if(X*2 != (R * C))
		{
			return "RICHARD";
		}
		
		//X can be just straight block and extend outside of the grid.
		if( X > R && X > C)
		{
			return "RICHARD";
		}
		
		//check if X can be extended to split both horizontal and vertical.
		
		if(R>=3 && C>=3)
		{
			//check if you can make a cross that can have both width and height greater than 
			//either R or C.
			int numCross = 0;
			if( R > C)
			{
				numCross = C + C - 1;
			}
			else
			{
				numCross = R + R - 1;
			}
			if(X>= numCross)
				return "RICHARD";
		}
		
		//Richard can make T shape that can block
		if(R == 2 && C >=4 || R >= 4 && C == 2)
		{
			return "RICHARD";
		}
		
		//Richard can make a hole of its own.
		if(X>= 7)
			return "RICHARD";
			
			
		return "GABRIEL";
	}

}
