import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;

public class MagicTrick {

	private enum status {
		NONE, ONE, MORE;
	}

	private status s;
	private int num;
	private int caseNum;

	public MagicTrick(int r1, int[][] g1, int r2, int[][] g2, int caseNum) {
		
		// Useful for outputting later
		this.caseNum = caseNum;
		
		// Keeps track of how many intersections we find
		int count = 0;
		
		HashSet<Integer> set = new HashSet<Integer>();
		// Construct a set for first row
		for (int i = 0; i < 4; i++) {
			set.add(g1[r1][i]);
			System.out.println("adding " + g1[r1][i] + " to set");
		}
		
		// Check for contains in second row
		for (int i = 0; i < 4; i++) {
			System.out.println("checking " + g2[r2][i] + " in set");
			if (set.contains(g2[r2][i])) {
				count++;
				num = g2[r2][i];
			}
		}
		
		// We set our status accordingly
		switch (count) {
		case 0:
			s = status.NONE;
			break;
		case 1:
			s = status.ONE;
			break;
		default:
			s = status.MORE;
			break;
		}
	}

	public String toString() {
		switch (s) {
		case NONE:
			return "Case #" + caseNum + ": " + "Volunteer cheated! \n";
		case ONE:
			return "Case #" + caseNum + ": " + num + "\n";
		case MORE:
			return "Case #" + caseNum + ": " + "Bad magician! \n";
		}
		return "";
	}

	public static void main(String[] args) {
		StringBuilder sb = new StringBuilder();
		try {
			BufferedReader in = new BufferedReader(new FileReader(args[0]));

			// First line is number of cases
			int numCases = 0;
			if (in.ready()) {
				numCases = Integer.parseInt(in.readLine());
			}

			// Next are details of cases
			for (int i = 0; i < numCases; i++) {

				// First arrangement
				int r1 = Integer.parseInt(in.readLine()) - 1;
				int[][] g1 = new int[4][4];

				// We will lay out grid by [row][column]
				for (int r = 0; r < 4; r++) {
					String[] nums = in.readLine().split(" ");
					for (int c = 0; c < 4; c++) {
						g1[r][c] = Integer.parseInt(nums[c]);
					}
				}

				// Second arrangement
				int r2 = Integer.parseInt(in.readLine()) - 1;
				int[][] g2 = new int[4][4];

				// We will lay out grid by [row][column]
				for (int r = 0; r < 4; r++) {
					String[] nums = in.readLine().split(" ");
					for (int c = 0; c < 4; c++) {
						g2[r][c] = Integer.parseInt(nums[c]);
					}
				}

				// Details of arrangement
				MagicTrick mt = new MagicTrick(r1, g1, r2, g2, i + 1);
				sb.append(mt);
			}

			// Write the file once it's done
			FileWriter fw = new FileWriter("MT_Solution.txt");
			fw.write(sb.toString());
			fw.close();

			in.close();
		} catch (FileNotFoundException e) {
			System.out.println("File not found!");
		} catch (IOException e) {
			System.out.println("Error while reading!");
		}
	}

}
