import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

/**
 * Start with 0 cookies, gain 2 per second Can buy a farm at at least C cookies
 * Farm gives F extra cookies per second Once have X cookies not spent on farms,
 * win
 */

public class CookieClicker {

	private int caseNum;
	private double minSecs;

	public CookieClicker(double c, double f, double x, int caseNum) {
		this.caseNum = caseNum;
		double r = 2;

		// Corner case: x < c
		if (x < c) {
			minSecs = x / r;
		} else {
			minSecs = c / r;
			double old_ttx = (x - c) / r; // time to get x before buying farm
			double new_ttx = x / (r + f); // time to get x after buying farm
			
			while (new_ttx < old_ttx) { // Do we buy a new farm or wait out (x-c) cookies?
				r += f;
				minSecs += (c / r);
				old_ttx = (x - c) / r;
				new_ttx = x / (r + f);
			}
			minSecs += old_ttx;
		}
	}

	public String toString() {
		return "Case #" + caseNum + ": " + minSecs + "\n";
	}

	public static void main(String[] args) {
		StringBuilder sb = new StringBuilder();

		try {
			BufferedReader in = new BufferedReader(new FileReader(args[0]));

			// First line is number of cases
			int numCases = 0;
			if (in.ready()) {
				numCases = Integer.parseInt(in.readLine());
			}

			// Next are details of cases
			for (int i = 0; i < numCases; i++) {

				String[] nums = in.readLine().split(" ");

				// Calculate minimum time and output
				CookieClicker cc = new CookieClicker(
						Double.parseDouble(nums[0]),
						Double.parseDouble(nums[1]),
						Double.parseDouble(nums[2]), i + 1);
				sb.append(cc);
			}

			// Write the file once it's done
			FileWriter fw = new FileWriter("CC_Solution.txt");
			fw.write(sb.toString());
			fw.close();

			in.close();
		} catch (FileNotFoundException e) {
			System.out.println("File not found!");
		} catch (IOException e) {
			System.out.println("Error while reading!");
		}
	}

}
