import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.MathContext;
import java.math.RoundingMode;


public class FairAndSquare {
	public static final BigDecimal eps = new BigDecimal(1e-7);
	public static final BigDecimal two = new BigDecimal(2);
	public static final BigDecimal one = new BigDecimal(1);
	public static void main(String[] args) throws IOException {
		String inp = "C:\\Users\\dell\\Downloads\\C-small-attempt0.in";
		String otp = "output.txt";
		BufferedReader read = new BufferedReader(new FileReader(new File(inp)));
		BufferedWriter write = new BufferedWriter(new FileWriter(new File(otp)));
		int t = Integer.parseInt(read.readLine());
		for(int i=0; i<t; i++) {
			String[] ranges = read.readLine().split(" ");
			BigDecimal a = new BigDecimal(ranges[0]);
			BigDecimal b = new BigDecimal(ranges[1]);
			write.write("Case #"+(i+1)+": " + solve(a, b).toPlainString()+"\n");
		}
		write.flush();
		write.close();
	}
	
	public static BigDecimal solve(BigDecimal a, BigDecimal b) {
		BigDecimal sqrt = sqRoot(a);
		BigDecimal count = new BigDecimal(0);
		for(BigDecimal i = sqrt, j= i.multiply(i); j.compareTo(b) <=0; ) {
			if(j.compareTo(a)>=0) {
				if(isPalindrome(i) && isPalindrome(j)) {
					count = count.add(one);
				}
			}
			i=i.add(one);
			j=i.multiply(i);
		}
		return count;
	}
	
	public static boolean isPalindrome(BigDecimal n) {
		String val = n.toPlainString();
		int i=0;
		int j=val.length()-1;
		while(i<j) {
			if(val.charAt(i) != val.charAt(j)) {
				return false;
			}
			i++;
			j--;
		}
		return true;
	}
	
	public static BigDecimal sqRoot(BigDecimal a) {
		BigDecimal i=new BigDecimal(1);
		i.setScale(2);
		BigDecimal j = a;
		j.setScale(2);
		while(i.subtract(j).abs().compareTo(eps) >0) {
			BigDecimal mid = i.add(j).divide(two);
			if(mid.multiply(mid).subtract(a).abs().compareTo(eps)<=0) {
				return mid.setScale(0, RoundingMode.CEILING);
			} else if(mid.multiply(mid).compareTo(a) <0) {
				i = mid;
			} else {
				j = mid;
			}
		}
		return i.setScale(0, RoundingMode.CEILING);
	}
}
