import java.io.*;
import java.util.*;

public class NumberSets {
	public static ArrayList<Integer> primes(int max) {
		boolean composite[] = new boolean[max+10];
		for (int i = 4; i < max; i += 2) {
			composite[i] = true;
		}
		ArrayList<Integer> primes = new ArrayList<Integer>();
		primes.add(2);
		for (int i = 3; i < max; i += 2) {
			if (!composite[i]) {
				primes.add(i);
				for (int j = i + i; j < max; j += i) {
					composite[j] = true;
				}
			}
		}
		return primes;
	}
	
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		int qq = Integer.parseInt(in.readLine().trim());
		for (int tc = 1; tc <= qq; tc++) {
			StringTokenizer st = new StringTokenizer(in.readLine());
			int A = Integer.parseInt(st.nextToken());
			int B = Integer.parseInt(st.nextToken());
			int P = Integer.parseInt(st.nextToken());
			
			ArrayList<Integer> primes = primes(2000);
			int low = 0;
			for (; low < primes.size(); low++) {
				if (primes.get(low) >= P) {
					break;
				}
			}
			
			HashMap<Integer, HashSet<Integer>> edges = new HashMap<Integer, HashSet<Integer>>();
			
//			for (int i = low; i < primes.size(); i++) {
//				for (int j = low; j < primes.size(); j++) {
//					int prod = primes.get(i) * primes.get(j);
//					if (A <= prod && prod <= B) {
//						edges.get(primes.get(i)).add(primes.get(j));
//						edges.get(primes.get(j)).add(primes.get(i));
//					} else if (prod > B) {
//						break;
//					}
//				}
//			}
//
			int res = 0;
			for (int i = A; i <= B; i++) {
				int x = i;
				for (int j = 0; x > 1 && j < low; j++) {
//					System.out.println("dividing by " + primes.get(j));
					while (x % primes.get(j) == 0) {
						x /= primes.get(j);
					}
				}
//				System.out.print(i + ": ");
				if (x == 1) {
//					System.out.println(" HAHA " + i + " ");
					res++;
				} else {
					ArrayList<Integer> thesePrimes = new ArrayList<Integer>();
					for (int j = low; j < primes.size() && primes.get(j) <= B; j++) {
						if (i % primes.get(j) == 0) {
							thesePrimes.add(primes.get(j));
							if (!edges.containsKey(primes.get(j))) {
								edges.put(primes.get(j), new HashSet<Integer>());
							}
//							System.out.print(primes.get(j) + " ");
						}
					}
//					System.out.println(" -- ");
					for (int j = 0; j < thesePrimes.size(); j++) {
						for (int k = j+1; k < thesePrimes.size(); k++) {
							edges.get(thesePrimes.get(j)).add(thesePrimes.get(k));
							edges.get(thesePrimes.get(k)).add(thesePrimes.get(j));
						}
					}
				}
			}
//			System.out.println();
//			System.out.println("PRE: " + res);
			
			HashSet<Integer> v = new HashSet<Integer>();
			for (int i = low; primes.get(i) <= B; i++) {
				int prime = primes.get(i);
				if (!v.contains(prime) && edges.containsKey(prime)) {
					res++;
					Queue<Integer> q = new LinkedList<Integer>();
					q.add(prime);
					v.add(prime);
					while (q.size() > 0) {
						int p = q.poll();
//						System.out.print(p + " ");
						if (edges.containsKey(p)) {
							for (int x : edges.get(p)) {
								if (!v.contains(x)) {
									q.add(x);
								}
							}
						}
						v.add(p);
					}
//					System.out.println(" .");
				}
			}
			System.out.printf("Case #%d: %d\n", tc, res);
		}
	}
}
