import java.util.*;
import java.io.*;
import java.math.*;

public class A {
	class Node {
		Node left, right;
		int index = 0;
		int gate = 0;
		boolean changeable = false;
		int value = -1;
		
		public Node(int gate, int changeable, int index) {
			this.gate = gate;
			this.changeable = changeable == 1;
			this.index = index;
		}

		public Node(int value, int index) {
			//System.out.println("index " + index + ": " + value);
			this.value = value;
			this.index = index;
		}

		public int evaluate(int mask) {
			if (value >= 0) {
				return value;
			}
			int op = gate;
			if (changeable && (mask & (1 << (index-1))) != 0) {
				op = 1 - gate;
			}
			int resLeft = left.evaluate(mask);
			int resRight = right.evaluate(mask);
			//System.out.println(index + ": " + resLeft + " and " + resRight + " and " + op);
			int res = -1;
			if (op == 1) { // AND
				res = resLeft == resRight && resLeft == 1 ? 1 : 0;
			} else if (op == 0) { // OR
				res = resLeft == 1 || resRight == 1 ? 1 : 0;
			}
			//System.out.println("index " + index + ": " + res);
			return res;
		}
	}
	
	public static void main(String args[]) throws IOException {
		new A().execute();
	}

	public void execute() throws IOException {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		int N = Integer.parseInt(in.readLine().trim());
		for (int tc = 1; tc <= N; tc++) {
			StringTokenizer st = new StringTokenizer(in.readLine());
			int M = Integer.parseInt(st.nextToken());
			int V = Integer.parseInt(st.nextToken());
			Node nodes[] = new Node[M+10];
			for (int i = 1; i <= (M-1)/2; i++) {
				st = new StringTokenizer(in.readLine());
				nodes[i] = new Node(Integer.parseInt(st.nextToken()), Integer.parseInt(st.nextToken()), i);
			}
			for (int i = (M-1)/2+1; i <= M; i++) {
				nodes[i] = new Node(Integer.parseInt(in.readLine()), i);
			}
			for (int i = 1; i <= (M-1)/2; i++) {
				nodes[i].left = nodes[2*i];
				nodes[i].right = nodes[2*i+1];
				//System.out.println(i + " => " + (2*i) + " and " + (2*i+1));
			}
			int res = 1 << 20;
			for (int m = 0; m < (1 << ((M-1)/2)); m++) {
				//System.out.println("mask " + m);
				if (nodes[1].evaluate(m) == V) {
					res = Math.min(res, Integer.bitCount(m));
				}
			}
			if (res >= 1 << 20) {
				System.out.printf("Case #%d: IMPOSSIBLE\n", tc);
			} else {
				System.out.printf("Case #%d: %d\n", tc, res);
			}
		}
	}
}
