package boy0;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Iterator;

public class QR_C {
	public static void main(String[] args) throws IOException {
		String strLine;
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		QR_C me = new QR_C();

		long t_beg = System.currentTimeMillis();
		me.init();
		long t_end = System.currentTimeMillis();
		System.out.println("mSec: " + (t_end - t_beg));

		strLine = br.readLine();
		int T = Integer.parseInt(strLine);
		String[] as;
		BigInteger a, b;
		BigInteger y;
		for (int x = 1; x <= T; x++) {
			strLine = br.readLine();
			as = strLine.split(" ");
			a = new BigInteger(as[0]);
			b = new BigInteger(as[1]);
			y = me.exec1(a, b);
			System.out.println("Case #" + x + ": " + y);
		}
	}

	// private BigInteger max_num = BigInteger.TEN.pow(7);
	private int max_len = 25;
	char[] pal_half = new char[max_len]; // pal  ,  
	char[] pal_odd_len = new char[max_len * 2];
	char[] pal_even_len = new char[max_len * 2];
	ArrayList<BigInteger> fns = new ArrayList<BigInteger>();

	public void init() {
		// ̸  صд.
		// 1, 1
		// 2, 4
		// 3, 9
		// 11, 121
		// 22, 484
		// 101, 10201
		// BigInteger pow;
		// // 1  ִ밪
		// for (BigInteger i = BigInteger.ONE; i.compareTo(max_num) <= 0; i = i
		// .add(BigInteger.ONE)) {
		// // palindrome ̰
		// if (is_palindrome(i)) {
		// //  palindrome ̸
		// pow = i.pow(2);
		// if (is_palindrome(pow)) {
		// System.out.println(i + ", " + pow);
		// }
		// }
		// }
		fns.add(BigInteger.valueOf(4)); // 2, 4
		fns.add(BigInteger.valueOf(9)); // 3, 9
		fns.add(BigInteger.valueOf(484)); // 22, 484

		// 0 1 ڸ .
		Arrays.fill(pal_half, (char) 0);
		pal_half[0] = '1';

		BigInteger pal, pow;

		while (pal_half[0] != 'E') {
			// check abcba
			pal = make_pal_odd_len();
			// System.out.println(pal);
			pow = pal.pow(2);
			if (is_palindrome(pow)) {
				// System.out.println(pal + ", " + pow);
				fns.add(pow);
			}

			// check abccba
			if (pal_half[max_len - 1] == 0) {
				pal = make_pal_even_len();
				// System.out.println(pal);
				pow = pal.pow(2);
				if (is_palindrome(pow)) {
					// System.out.println(pal + ", " + pow);
					fns.add(pow);
				}
			}

			// add 1 to pal_half
			add_1_to_pal_half(0);
		}

		Collections.sort(fns);
		// System.out.println(fns);
	}

	private BigInteger make_pal_odd_len() {
		for (int i = 0; pal_half[i] != 0; i++) {
			pal_odd_len[max_len + i] = pal_half[i];
			pal_odd_len[max_len - i] = pal_half[i];
		}
		return new BigInteger(String.valueOf(pal_odd_len).trim());
	}

	private BigInteger make_pal_even_len() {
		for (int i = 0; pal_half[i] != 0; i++) {
			pal_even_len[max_len + i] = pal_half[i];
			pal_even_len[max_len - 1 - i] = pal_half[i];
		}
		return new BigInteger(String.valueOf(pal_even_len).trim());
	}

	private boolean is_palindrome(BigInteger num) {
		String numstr = num.toString();
		int n = numstr.length();
		int half = n / 2 - 1;
		for (int i = 0; i <= half; i++) {
			if (numstr.charAt(i) != numstr.charAt(n - 1 - i)) {
				return false;
			}
		}
		return true;
	}

	private void add_1_to_pal_half(int index) {
		switch (pal_half[index]) {
		case '0':
			pal_half[index] = '1';
			return;
		case '1':
			// pal_half[index] = '2';
			// return;
			// case '2':
			if (index + 1 == max_len - 1) {
				pal_half[0] = 'E'; // end sign
			} else {
				pal_half[index] = '0';
				add_1_to_pal_half(index + 1);
			}
			return;
		default:
			// 2  ߰.
			pal_half[index] = '2';
			fns.add(make_pal_odd_len().pow(2)); // 202, 40804
			fns.add(make_pal_even_len().pow(2)); // 2002, 4008004
			pal_half[0] = '1';
			fns.add(make_pal_odd_len().pow(2)); // 212, 44944
			pal_half[0] = '2';
			pal_half[index] = '1';
			fns.add(make_pal_odd_len().pow(2)); // 121, 14641
			for (int i = 1; i < index; i++) {
				pal_half[i] = '1';
				fns.add(make_pal_odd_len().pow(2)); // 1001002001001
				pal_half[i] = '0';
			}

			// ڸ 
			pal_half[index] = '1';
			for (int i = 0; i < index; i++) {
				pal_half[i] = '0';
			}
			return;
		}
	}

	public BigInteger exec1(BigInteger from, BigInteger to) {
		BigInteger y = BigInteger.ZERO;
		for (Iterator<BigInteger> iterator = fns.iterator(); iterator.hasNext();) {
			BigInteger bb = (BigInteger) iterator.next();
			if (bb.compareTo(from) >= 0) {
				if (bb.compareTo(to) <= 0) {
					y = y.add(BigInteger.ONE);
				} else {
					break;
				}
			}
		}
		return y;
	}

}
