import java.io.*;
import java.util.*;

public class Qual {
    private static FastIO io;
    private static final String FILE_NAME = "C-small-2-attempt0";

    void solveMultiTest() throws IOException {
        int testCases = io.readInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            io.print(String.format(Locale.US, "Case #%d: %s%n", testCase, solveOneTest()));
        }
    }

    String solveOneTest() throws IOException {
        int n = io.readInt();
        int k = io.readInt();

        boolean[] a = new boolean[n];
        Arrays.fill(a, false);

        PriorityQueue<Integer> q = new PriorityQueue<>(Comparator.reverseOrder());
        q.add(n);
        for (int i = 0; i < k - 1; i++) {
            int x = q.poll();
            q.add(x / 2);
            q.add((x - 1) / 2);
//            q.forEach(System.out::print);
//            System.out.println();
        }

        int x = q.poll();
        return (x / 2) + " " + ((x  - 1) / 2);
    }

    public void run() {
        try (FastIO fastIO = new FastIO(FILE_NAME)) {
            io = fastIO;
            solveMultiTest();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new Qual().run();
    }
}

class FastIO implements AutoCloseable {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    public FastIO() {
        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
    }

    public FastIO(String file) throws FileNotFoundException {
        if (file == null) {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
        } else {
            in = new BufferedReader(new FileReader(file + ".in"));
            out = new PrintWriter(file + ".out");
        }
    }

    public String readLine() throws IOException {
        st = null;
        return in.readLine();
    }

    public String readToken() throws IOException {
        return nextToken();
    }

    public int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long readLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    public void print(Object o) {
        out.print(o.toString());
    }

    public void println(Object o) {
        out.println(o.toString());
    }

    @Override
    public void close() throws IOException {
        in.close();
        out.close();
    }
}