import java.io.*;
import java.util.*;

public class Qual {
    private static FastIO io;
    private static final String FILE_NAME = "A-small-attempt1";

    void solveMultiTest() throws IOException {
        int testCases = io.readInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            io.print(String.format(Locale.US, "Case #%d: %s%n", testCase, solveOneTest()));
        }
    }

    class Pank implements Comparable<Pank> {
        int r;
        int h;
        double s;

        public Pank(int r, int h) {
            this.r = r;
            this.h = h;
            s = 2 * Math.PI * r * h;
        }

        @Override
        public int compareTo(Pank o) {
            return ((Double) o.s).compareTo(s);
        }

        @Override
        public String toString() {
            return r + " " + h;
        }
    }

    String solveOneTest() throws IOException {
        int n = io.readInt();
        int k = io.readInt();


        Pank[] a = new Pank[n];
        for (int i = 0; i < n; i++) {
            a[i] = new Pank(io.readInt(), io.readInt());
        }
        Arrays.sort(a);

        double sum = 0;
        int maxr = 0;
        for (int i = 0; i < k - 1; i++) {
            sum += a[i].s;
            maxr = maxr > a[i].r ? maxr : a[i].r;
        }

        double max = 0;
        for (int i = k - 1; i < n; i++) {
            double mr = a[i].r > maxr ? a[i].r : maxr;
            double s = sum + a[i].s + Math.PI * mr * mr;
            max = max > s ? max : s;
        }

        return max + "";
    }

    public void run() {
        try (FastIO fastIO = new FastIO(FILE_NAME)) {
            io = fastIO;
            solveMultiTest();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new Qual().run();
    }
}

class FastIO implements AutoCloseable {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    public FastIO() {
        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
    }

    public FastIO(String file) throws FileNotFoundException {
        if (file == null) {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
        } else {
            in = new BufferedReader(new FileReader(file + ".in"));
            out = new PrintWriter(file + ".out");
        }
    }

    public String readLine() throws IOException {
        st = null;
        return in.readLine();
    }

    public String readToken() throws IOException {
        return nextToken();
    }

    public int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long readLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    public void print(Object o) {
        out.print(o.toString());
    }

    public void println(Object o) {
        out.println(o.toString());
    }

    @Override
    public void close() throws IOException {
        in.close();
        out.close();
    }
}