import java.io.*;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.StringTokenizer;

public class Round1 implements Runnable {
    private static FastIO io;
    private static final String FILE_NAME = "D-small-attempt0";

    void solveMultiTest() throws IOException {
        int testCases = io.readInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            io.println(String.format("Case #%d: %s", testCase, solveOneTest()));
        }
    }

    final String s1 = "GABRIEL";
    final String s2 = "RICHARD";
    String solveOneTest() throws IOException {
        int x = io.readInt();
        int r = io.readInt();
        int c = io.readInt();
        if (x == 1) {
            return s1;
        }
        if (x == 2) {
            if (r * c % 2 != 0) {
                return s2;
            } else {
                return s1;
            }
        }
        if (x == 3) {
            if (r * c % 3 != 0) {
                return s2;
            } else {
                if (r == 1 || c == 1) {
                    return s2;
                } else {
                    return s1;
                }
            }
        }
        if (x == 4) {
            if (r * c % 4 != 0) {
                return s2;
            } else {
                if (r * c == 4) {
                    return s2;
                } else {
                    if (c * r >= 12) {
                        return s1;
                    } else {
                        return s2;
                    }
                }
            }
        }
        return "!!!!!!!!--------!!!!!!!!";
    }

    private int task2() throws IOException {
        int d = io.readInt();
        List<Integer> p = new ArrayList<>();
        for (int i = 0; i < d; i++) {
            p.add(io.readInt());
        }
        Integer max = Collections.max(p);
        int c = 0;
        int min = max;
        while (max != 1) {
            p.remove(max);
            p.add((max + 1) / 2);
            p.add(max / 2);
            Integer max2 = Collections.max(p);
            c++;
            if (min > max2 + c) {
                min = max2 + c;
            }
            max = max2;
        }
        return min;
    }

    private int task1() throws IOException {
        int n = io.readInt();
        String s = io.readToken();
        int sum = toInt(s.charAt(0));
        int ans = 0;
        for (int i = 1; i <= n; i++) {
            if (sum < i) {
                ans += i - sum;
                sum += i - sum;
            }
            sum += toInt(s.charAt(i));
        }
        return ans;
    }

    int toInt(char ch) {
        return ch - '0';
    }

    public void run() {
        try (FastIO fastIO = new FastIO(FILE_NAME)) {
            io = fastIO;
            solveMultiTest();
        } catch (IOException e) {
        }
    }

    public static void main(String[] args) {
        new Thread(new Round1()).start();
    }
}

class FastIO implements AutoCloseable {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    public FastIO() {
        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
    }

    public FastIO(String file) throws FileNotFoundException {
        if (file == null) {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
        } else {
            in = new BufferedReader(new FileReader(file + ".in"));
            out = new PrintWriter(file + ".out");
        }
    }

    public String readLine() throws IOException {
        st = null;
        return in.readLine();
    }

    public String readToken() throws IOException {
        return nextToken();
    }

    public int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    public void print(Object o) {
        out.print(o.toString());
    }

    public void println(Object o) {
        out.println(o.toString());
    }

    @Override
    public void close() throws IOException {
        in.close();
        out.close();
    }
}