import java.io.*;
import java.util.*;

public class Qual {
    private static FastIO io;
    private static final String FILE_NAME = "B-small-attempt3";

    void solveMultiTest() throws IOException {
        int testCases = io.readInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            io.print(String.format(Locale.US, "Case #%d: %s%n", testCase, solveOneTest()));
        }
    }

    String solveOneTest() throws IOException {
        int N = io.readInt();
        int R = io.readInt();
        int O = io.readInt();
        int Y = io.readInt();
        int G = io.readInt();
        int B = io.readInt();
        int V = io.readInt();

        int[] a = new int[]{R, Y, B};

        String ch = "";
        for (int i = 0; i < N; i++) {
            if (a[0] == a[1] && a[1] == a[2]) {
                String p = "";
                String f = "";
                if (ch.isEmpty()) {
                    f = "RR";
                } else {
                    f = ch.charAt(0) + "" + ch.charAt(i - 1 >= 0 ? i - 1 : 0);
                }
                switch (f) {
                    case "RR": p = "BRY"; break;
                    case "RY": p = "RBY"; break;
                    case "RB": p = "RBY"; break;
                    case "YR": p = "BYR"; break;
                    case "YY": p = "BYR"; break;
                    case "YB": p = "RYB"; break;
                    case "BR": p = "BRY"; break;
                    case "BY": p = "BYR"; break;
                    case "BB": p = "YBR"; break;
                }
                for (int j = 0; j < a[0]; j++) {
                    ch += p;
                }
                return ch;
            }
            if (a[0] >= a[1] && a[0] >= a[2]) {
                if (i == 0 || ch.charAt(i - 1) != 'R') {
                    ch += 'R';
                    a[0]--;
                } else {
                    if (a[1] >= a[2]) {
                        ch += 'Y';
                        a[1]--;
                    } else {
                        ch += 'B';
                        a[2]--;
                    }
                }
            } else if (a[1] >= a[0] && a[1] >= a[2]) {
                if (i == 0 || ch.charAt(i - 1) != 'Y') {
                    ch += 'Y';
                    a[1]--;
                } else {
                    if (a[0] >= a[2]) {
                        ch += 'R';
                        a[0]--;
                    } else {
                        ch += 'B';
                        a[2]--;
                    }
                }
            } else if (a[2] >= a[0] && a[2] >= a[1]) {
                if (i == 0 || ch.charAt(i - 1) != 'B') {
                    ch += 'B';
                    a[2]--;
                } else {
                    if (a[0] >= a[1]) {
                        ch += 'R';
                        a[0]--;
                    } else {
                        ch += 'Y';
                        a[1]--;
                    }
                }
            }
        }

        if (a[0] < 0 || a[1] < 0 || a[2] < 0) {
            return "IMPOSSIBLE";
        }
        return (ch.charAt(0) == ch.charAt(ch.length() - 1)) ? "IMPOSSIBLE" : ch;
    }

    public void run() {
        try (FastIO fastIO = new FastIO(FILE_NAME)) {
            io = fastIO;
            solveMultiTest();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new Qual().run();
    }
}

class FastIO implements AutoCloseable {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    public FastIO() {
        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
    }

    public FastIO(String file) throws FileNotFoundException {
        if (file == null) {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
        } else {
            in = new BufferedReader(new FileReader(file + ".in"));
            out = new PrintWriter(file + ".out");
        }
    }

    public String readLine() throws IOException {
        st = null;
        return in.readLine();
    }

    public String readToken() throws IOException {
        return nextToken();
    }

    public int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long readLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    public void print(Object o) {
        out.print(o.toString());
    }

    public void println(Object o) {
        out.println(o.toString());
    }

    @Override
    public void close() throws IOException {
        in.close();
        out.close();
    }
}