import java.io.*;
import java.util.*;

public class Qual {
    private static FastIO io;
    private static final String FILE_NAME = "A-large";

    void solveMultiTest() throws IOException {
        int testCases = io.readInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            io.print(String.format(Locale.US, "Case #%d: %s%n", testCase, solveOneTest()));
        }
    }

    String solveOneTest() throws IOException {
        String s = io.readToken();
        int k = io.readInt();

        int l = s.length();
        boolean[] a = new boolean[l];
        for (int i = 0; i < l; i++) {
            a[i] = s.charAt(i) == '+';
        }

        int c = 0;
        for (int i = 0; i < l - k + 1; i++) {
            if (!a[i]) {
                flip(a, i, k);
                c++;
            }
        }

        return check(a) ? c + "" : "IMPOSSIBLE";
    }

    private boolean check(boolean[] a) {
        for (boolean b : a) {
            if (!b) {
                return false;
            }
        }
        return true;
    }

    private void flip(boolean[] a, int ind, int k) {
        for (int i = 0; i < k; i++) {
            a[ind + i] = !a[ind + i];
        }
    }

    private void print(boolean[] a) {
        for (int i = 0; i < a.length; i++) {
            System.out.print(a[i] ? '+' : '-');
        }
        System.out.println();
    }

    public void run() {
        try (FastIO fastIO = new FastIO(FILE_NAME)) {
            io = fastIO;
            solveMultiTest();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new Qual().run();
    }
}

class FastIO implements AutoCloseable {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    public FastIO() {
        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
    }

    public FastIO(String file) throws FileNotFoundException {
        if (file == null) {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
        } else {
            in = new BufferedReader(new FileReader(file + ".in"));
            out = new PrintWriter(file + ".out");
        }
    }

    public String readLine() throws IOException {
        st = null;
        return in.readLine();
    }

    public String readToken() throws IOException {
        return nextToken();
    }

    public int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long readLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    public void print(Object o) {
        out.print(o.toString());
    }

    public void println(Object o) {
        out.println(o.toString());
    }

    @Override
    public void close() throws IOException {
        in.close();
        out.close();
    }
}