import java.io.*;
import java.util.*;

@SuppressWarnings("ALL")
public class Qual {
    private static FastIO io;
    private static final String FILE_NAME = "B-small-attempt0";

    void solveMultiTest() throws IOException {
        int testCases = io.readInt();
        for (int testCase = 1; testCase <= testCases; testCase++) {
            io.print(String.format(Locale.US, "Case #%d: %s%n", testCase, solveOneTest()));
        }
    }

    class T implements Comparable<T> {
        int c;
        int d;
        int w;
        int t;

        public T(int c, int d, int w) {
            this.c = c;
            this.d = d;
            this.w = w;
            t = d - c;
        }

        @Override
        public int compareTo(T o) {
            return ((Integer) c).compareTo(o.c);
        }

        @Override
        public String toString() {
            return "[" + c + " -- " + w + " -- " + d + "]";
        }
    }

    String solveOneTest() throws IOException {
        int ac = io.readInt();
        int aj = io.readInt();

        T[] a = new T[ac + aj];

        TreeSet<T> set = new TreeSet<>();

        int ct = 720;
        for (int i = 0; i < ac; i++) {
            int c = io.readInt();
            int d = io.readInt();

            a[i] = new T(c, d, 1);
            set.add(a[i]);
            ct -= (d - c);
        }

        int jt = 720;
        for (int i = ac; i < aj + ac; i++) {
            int c = io.readInt();
            int d = io.readInt();

            a[i] = new T(c, d, 2);
            set.add(a[i]);
            jt -= (d - c);
        }

        Arrays.sort(a);

        for (int i = 0; i < a.length - 1; i++) {
            int w = 0;
            if (a[i].w != a[i + 1].w) {
                w = 3;
            }
            T t = new T(a[i].d, a[i + 1].c, w);
            set.add(t);
        }

        if (set.first().c != 0) {
            set.add(new T(0, set.first().c, 3));
        }

        if (set.last().d != 1440) {
            set.add(new T(set.last().d, 1440, 3));
        }

        while (true) {
            T min = new T(0, Integer.MAX_VALUE, 3);
            for (T t : set) {
                if (t.w != 0) {
                    continue;
                }
                if (min.t > t.t) {
                    min = t;
                }
            }
            if (min.w != 0) {
                break;
            }
            T l = set.lower(min);
            T r = set.higher(min);
            if (l.w == 1) {
                if (ct >= r.c - l.d) {
                    set.remove(l);
                    set.remove(min);
                    set.remove(r);
                    set.add(new T(l.c, r.d, l.w));
                    ct -= (r.c - l.d);
                } else {
                    set.remove(l);
                    set.remove(min);
                    set.add(new T(l.c, l.d + ct, l.w));
                    set.add(new T(l.d + ct, min.d, 2));
                    jt -= min.d - (l.d + ct);
                    ct = 0;
                }
            }
            if (l.w == 2) {
                if (jt >= r.c - l.d) {
                    set.remove(l);
                    set.remove(min);
                    set.remove(r);
                    set.add(new T(l.c, r.d, l.w));
                    jt -= (r.c - l.d);
                } else {
                    set.remove(l);
                    set.remove(min);
                    set.add(new T(l.c, l.d + jt, l.w));
                    set.add(new T(l.d + jt, min.d, 1));
                    ct -= min.d - (l.d + jt);
                    jt = 0;
                }
            }
        }

        T sf = set.first();
        if (sf.w == 3) {
            T sh = set.higher(sf);
            if (sh.w == 1) {
                if (ct >= sf.t) {
                    ct -= sf.t;
                    sf.w = 1;
                } else {
                    sf.w = 2;
                    jt -= sf.t;
                }
            } else {
                if (jt >= sf.t) {
                    jt -= sf.t;
                    sf.w = 2;
                } else {
                    sf.w = 1;
                    ct -= sf.t;
                }
            }
        }

        T sl = set.last();
        if (sl.w == 3) {
            T slo = set.lower(sl);
            if (slo.w == 1) {
                if (ct >= sl.t) {
                    ct -= sl.t;
                    sl.w = 1;
                } else {
                    sl.w = 2;
                    jt -= sl.t;
                }
            } else {
                if (jt >= sl.t) {
                    jt -= sl.t;
                    sl.w = 2;
                } else {
                    sl.w = 1;
                    ct -= sl.t;
                }
            }
        }

        for (T t : set) {
            if (t.w == 3) {
                t.w = 2;
            }
        }

        set.forEach(System.out::println);

        System.out.println(ct + " " + jt);

        int ans = 0;
        T prev = set.last();
        for (T t : set) {
            if (prev.w != t.w) {
                ans++;
            }
            prev = t;
        }

        return ans + "";
    }

    public void run() {
        try (FastIO fastIO = new FastIO(FILE_NAME)) {
            io = fastIO;
            solveMultiTest();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    public static void main(String[] args) {
        new Qual().run();
    }
}

class FastIO implements AutoCloseable {
    BufferedReader in;
    PrintWriter out;
    StringTokenizer st;

    public FastIO() {
        in = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
    }

    public FastIO(String file) throws FileNotFoundException {
        if (file == null) {
            in = new BufferedReader(new InputStreamReader(System.in));
            out = new PrintWriter(System.out);
        } else {
            in = new BufferedReader(new FileReader(file + ".in"));
            out = new PrintWriter(file + ".out");
        }
    }

    public String readLine() throws IOException {
        st = null;
        return in.readLine();
    }

    public String readToken() throws IOException {
        return nextToken();
    }

    public int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    public long readLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    private String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    public void print(Object o) {
        out.print(o.toString());
    }

    public void println(Object o) {
        out.println(o.toString());
    }

    @Override
    public void close() throws IOException {
        in.close();
        out.close();
    }
}