import java.util.*;
import java.io.*;

public class ProblemA implements Runnable {

	BufferedReader br;
	StringTokenizer in;
	PrintWriter out;

	public void solve() throws IOException {
		int t = nextInt();

		for (int k = 0; k < t; k++) {
			int[][] a = new int[4][4];
			for (int i = 0; i < 4; i++) {
				String s = nextToken();
				for (int j = 0; j < 4; j++) {
					switch (s.charAt(j)) {
					case 'X':
						a[i][j] = 1;
						break;
					case 'O':
						a[i][j] = 2;
						break;
					case 'T':
						a[i][j] = -1;
						break;
					case '.':
						a[i][j] = 0;
					}
				}
			}

			HashSet<Integer> x = new HashSet<Integer>();
			int sd1 = 1;
			int sd2 = 1;
			for (int i = 0; i < 4; i++) {
				int s1 = 1;
				int s2 = 1;
				for (int j = 0; j < 4; j++) {
					s1 *= a[i][j];
					s2 *= a[j][i];
				}
				x.add(s1);
				x.add(s2);
				sd1 *= a[i][i];
				sd2 *= a[i][3 - i];
			}
			x.add(sd1);
			x.add(sd2);

			String ans = "";
			if (x.contains(1) || x.contains(-1))
				ans = "X won";
			else if (x.contains(16) || x.contains(-8))
				ans = "O won";
			else if (x.contains(0))
				ans = "Game has not completed";
			else
				ans = "Draw";

			out.println("Case #" + (k + 1) + ": " + ans);
		}
	}

	public int nextInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	public String nextToken() throws IOException {
		while ((in == null) || (!in.hasMoreTokens()))
			in = new StringTokenizer(br.readLine());
		return in.nextToken();
	}

	public void run() {
		try {
			br = new BufferedReader(new FileReader("input.txt"));
			out = new PrintWriter("output.txt");
			solve();
			out.close();
		} catch (IOException e) {
		}
	}

	public static void main(String[] args) {
		new Thread(new ProblemA()).start();
	}
}
