package codejam.bpeck.round1b.croptriangles;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Scanner;


public class CropTriangle {
	
	public static void main(String[] args) {
		Scanner keyboard = new Scanner(System.in);
		System.out.print("File name: ");
		
		String fileName = keyboard.nextLine();
		long start = System.nanoTime();
		File theFile = new File(fileName);
		BufferedWriter out;
		try {
			out = new BufferedWriter(new FileWriter(fileName + "out"));
			Scanner read = new Scanner(new FileInputStream(theFile));
			// get total
			int total = read.nextInt();
			read.nextLine();
			// loop through each case
			for(int i = 0; i < total; i++) {
				CropTriangle next = new CropTriangle(read.nextLine());
				int rslt = next.run();
				//System.out.println("Case #" + (i + 1) + ": " + rslt);
				out.write("Case #" + (i + 1) + ": " + rslt + "\n");

			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		long end = System.nanoTime();
		double elapsed = (end - start) / 1000000000.0;
		System.out.println("Completed in: " + elapsed);
		
//		CropTriangle ct1 = new CropTriangle("4 10 7 1 2 0 1 20");
//		System.out.println(ct1.run());
//		CropTriangle ct2 = new CropTriangle("6 2 0 2 1 1 2 11");
//		System.out.println(ct2.run());
		
	}
	
	
	private ArrayList<Tree> theTrees;
	public CropTriangle(String input) {
		Scanner read = new Scanner(input);
		int n = read.nextInt();
		long A = read.nextLong();
		long B = read.nextLong();
		long C = read.nextLong();
		long D = read.nextLong();
		long x0 = read.nextLong();
		long y0 = read.nextLong();
		long M = read.nextLong();
		theTrees = new ArrayList<Tree>( n );
		theTrees.add(new Tree( x0, y0 ));
		for(int i = 1; i < n ; i++) {
			x0 = ( A * x0 + B ) % M;
			y0 = ( C * y0 + D ) % M;
			theTrees.add(new Tree( x0, y0 ));
		}

		
	}
	
	public int run() {
		int count = 0;
		for(int i = 0; i < theTrees.size(); i++) {
			for(int j = i + 1; j < theTrees.size(); j++) {
				for(int k = j + 1; k < theTrees.size(); k++) {
					if(centerAtTree(i, j, k)) {
						count++;
					}
				}
			}
		}
		
		
		return count;
	}
	
	

	
	private boolean centerAtTree(int i, int j, int k) {
		long x1 = theTrees.get(i).xCoord;
		long y1 = theTrees.get(i).yCoord;
		long x2 = theTrees.get(j).xCoord;
		long y2 = theTrees.get(j).yCoord;
		long x3 = theTrees.get(k).xCoord;
		long y3 = theTrees.get(k).yCoord;
		//((x1 + x2 + x3) / 3, (y1 + y2 + y3) / 3). 
		double newX = (x1 + x2 + x3) / 3.0;
		double newY = (y1 + y2 + y3) / 3.0;
		long newXInt = (long) newX;
		long newYInt = (long) newY;
		if((newX != newXInt) || (newY != newYInt)) {
			return false;
		}
		//Tree test = new Tree(newXInt, newYInt);
		//System.out.println(i + ", " + j + ", " + k);
		//return theTrees.contains(test);
		return true;

	}






	protected class Tree {
		private long xCoord;
		private long yCoord;
		
		public Tree(long x, long y) {
			xCoord = x;
			yCoord = y;
		}
		
		public boolean equals(Tree other) {
			return ((this.xCoord == other.xCoord) && (this.yCoord == other.yCoord));
		}
		
		public String toString() {
			return xCoord + ", " +  yCoord;
		}
		
	}

}
