package codejam.bpeck.qualification.savingtheuniverse;

import java.util.ArrayList;

/**
 * Represents a Search Engine
 * 
 * @author Brian
 * 
 */
public class SearchEngine {
	private String engineName;

	public SearchEngine(String newName) {
		engineName = newName;
	}

	public String getName() {
		return engineName;
	}

	/**
	 * Determines the next time an engine will be queried
	 * 
	 * @param queries
	 *            all queries
	 * @param curPos
	 *            current query
	 * @return when this engine will next be searched for
	 */
	public int determineNextUsed(ArrayList<String> queries, int curPos) {
		for (; curPos < queries.size(); curPos++) {
			if (queries.get(curPos).equals(engineName)) {
				return curPos;
			}
		}
		return curPos + 1;

	}

}
