package codejam.bpeck.qualification.savingtheuniverse;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.util.Scanner;

/**
 * Solves the "Saving the Universe" prompt.
 * @author Brian Peck
 *
 */
public class SaveTheUniverse {
	
	public static void main(String[] args) {
		
		Scanner keyboard = new Scanner(System.in);
		System.out.print("File name: ");
		
		String fileName = keyboard.nextLine();
		long start = System.nanoTime();
		File theFile = new File(fileName);
		BufferedWriter out;
		try {
			out = new BufferedWriter(new FileWriter(fileName + "out"));
			Scanner read = new Scanner(new FileInputStream(theFile));
			// get total
			int total = read.nextInt();
			read.nextLine();
			// loop through each case
			for(int i = 0; i < total; i++) {
				SingleUniverse su = new SingleUniverse();
				// get number of search engines
				int numEngines = read.nextInt();
				read.nextLine();
				// add each search engine
				for(int j = 0; j < numEngines; j++) {
					su.addSearchEngine(read.nextLine());
				}
				// get the number of queries
				int numQueries = read.nextInt();
				read.nextLine();
				// add each query
				for(int j = 0; j < numQueries; j++) {
					su.addQuery(read.nextLine());
				}
				// get the number of switches and print it
				int switches = su.run();
				out.write("Case #" + (i + 1) + ": ");
				out.write(switches + "\n");
			}
			out.close();
		} catch (Exception e) {
			e.printStackTrace();
		}
		long end = System.nanoTime();
		double elapsed = (end - start) / 1000000000.0;
		System.out.println("Completed in: " + elapsed);
	}


}
