package codejam.bpeck.qualification.savingtheuniverse;

import java.util.ArrayList;

public class SingleUniverse {
	
	private ArrayList<SearchEngine> searchEngines;
	private ArrayList<String> queries;
	private ArrayList<ArrayList<Integer>> allUses;
	
	public SingleUniverse() {
		searchEngines = new ArrayList<SearchEngine>();
		queries = new ArrayList<String>();
	}
	
	public void addSearchEngine(String newSearchEngine) {
		searchEngines.add(new SearchEngine(newSearchEngine));
	}
	
	public void addQuery(String newQuery) {
		queries.add(newQuery);
	}
	
	public int run() {
		if(isOneNotUsed()) {
			return 0;
		}
		int curPos = 0;
		int totalSwitches = -1;
		while(curPos < queries.size()) {
			int curMax = 0;
			for(int i = 0; i < searchEngines.size(); i++) {
				int next = searchEngines.get(i).determineNextUsed(queries, curPos);
				if (next > curMax) {
					curMax = next;
				}
			}
			curPos = curMax;
			totalSwitches++;
		}
		return totalSwitches;
		
		
		
		
//		allUses = new ArrayList<ArrayList<Integer>>();
//		for(int i = 0; i < searchEngines.size(); i++) {
//			allUses.add(searchEngines.get(i).determineWhenUsed(queries));
//			if(allUses.get(i).size() == 1) {
//				return 1;
//			}
//		}
		
	
	}
	
	/*
	 * Quickly check base case of zero.
	 */
	private boolean isOneNotUsed() {
		for(int i = 0; i < searchEngines.size(); i++) {
			if(!queries.contains(searchEngines.get(i).getName())) {
				return true;
			}
		}
		return false;
	}

}
