package google.code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.util.LinkedList;
import java.util.List;
import java.util.regex.Pattern;

public class AlienLanguage {

	private static String encoding = "UTF-8";

	private Integer L, D, N;
	private List<String> dic = null;
	private List<Output> result = null;

	private class Output {
		public Pattern pattern;
		public int cnt = 0;

		public Output(Pattern pattern) {
			this.pattern = pattern;
		}
	}

	private void process(InputStream inputStream) throws IOException {
		BufferedReader reader = null;
		reader = new BufferedReader(
				new InputStreamReader(inputStream, encoding));
		String line;
		int lineNumber = 0;
		try {
			while ((line = reader.readLine()) != null) {
				if (lineNumber == 0) {
					String[] params = line.split(" ");
					L = new Integer(params[0]);
					D = new Integer(params[1]);
					N = new Integer(params[2]);
					//System.out.println("L, D, N:" + L + "," + D + "," + N);
					dic = new LinkedList<String>();
					result = new LinkedList<Output>();
				} else {
					if (lineNumber <= D) {
						dic.add(line);
						//System.out.println("lineNumber dic" + lineNumber + ":" + line);
					} else {
						String pattern = line.replaceAll("\\(", "[")
								.replaceAll("\\)", "]");
						result.add(new Output(Pattern.compile(pattern)));
						//System.out.println("lineNumber pattern" + lineNumber + ":" + pattern);
					}
				}
				lineNumber++;
			}

		} finally {
			reader.close();
		}
	}

	private void writeResult(OutputStream outputStream) throws IOException {
		BufferedWriter writer = null;
		writer = new BufferedWriter(new OutputStreamWriter(outputStream,
				encoding));

		int lineNumber = 1;
		try {
			for (Output output : result) {
				for (String word : dic) {
					if (output.pattern.matcher(word).find()) {
						output.cnt++;
					}
				}
				String resultLine = "Case #" + lineNumber + ": " + new Integer(output.cnt);
				//System.out.println(resultLine);
				writer.write(resultLine);
				writer.newLine();
				lineNumber++;
			}
		} finally {
			writer.close();
		}
	}

	/**
	 * @param args first param is input file path, second param is output file path
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		
		if (args.length < 2) {
			System.err.println("usage: AlienLanguage <input file path> <output file path>");
			System.exit(-1);
		}

		AlienLanguage alienLanguage = new AlienLanguage();
		alienLanguage.process(new FileInputStream(args[0]));
		alienLanguage.writeResult(new FileOutputStream(args[1]));
	}

}
