import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;


public class Problem1 {
	private static Map<Character, Character> mapping = new HashMap<Character, Character>();

	public static void main(String[] args) throws IOException {
		createMapping();
		//printMapping();
		BufferedReader problemSet = new BufferedReader(new FileReader("A-small.txt"));
		PrintWriter out = new PrintWriter(new File("A-out.txt"));
		int num = Integer.parseInt(problemSet.readLine().trim());
		for (int i = 0; i < num; i++) {
			String in = problemSet.readLine();
			String output = "Case #" + (i+1) + ": ";
			for (int j = 0; j < in.length(); j++) {
				if(in.charAt(j) == ' '){
					output += " ";
				} else{
					output += mapping.get(in.charAt(j));
				}
			}
			out.println(output);
		}
		out.close();
	}

	private static void printMapping() {
		for (int i = 'a'; i <= 'z'; i++) {
			char c = (char)i;
			System.out.println(c + " -> " + mapping.get(c));
		}
	}

	private static void createMapping() throws FileNotFoundException,
			IOException {
		BufferedReader in1 = new BufferedReader(new FileReader("in1.txt"));
		BufferedReader in2 = new BufferedReader(new FileReader("in2.txt"));
		int num = Integer.parseInt(in1.readLine().trim());
		
		mapping.put('z', 'q');
		mapping.put('q', 'z');
		for (int i = 0; i < num; i++) {
			String crypted = in1.readLine();
			String original = in2.readLine();
			original = original.substring(original.indexOf(":") + 1);
			original = original.trim();
			for (int j = 0; j < original.length(); j++) {
				char c1 = crypted.charAt(j);
				char c2 = original.charAt(j);
				if(c1 == ' '){
					continue;
				}
				mapping.put(c1, c2);
			}
		}
	}
}
