/**
 * 
 */
package SquareTiles;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;

/**
 * @author Brighton Vino
 * 
 */
public class SquareTiles {

	public static File input;
	public static File output;
	public static FileReader inputreader;
	public static FileWriter outputwriter;
	public static BufferedReader in;
	public static BufferedWriter out;
	public static final String ProblemName = "Tiles";
	public static StringTokenizer ST;
	
	public static int NoOfTestCases = 0;
	public static int Tested = 0;
	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {	
		INITProblem();
		NoOfTestCases = INT(TOKEN());
		while (Tested < NoOfTestCases) {
			TestCase TC = new TestCase(in);
			println("Case #"+(Tested+1)+": ");
			TC.Solve();
			Tested++;
		}
		CLOSE();
	}
	
	public static void INITProblem() throws IOException {
		setInput(ProblemName + ".in");
		setOutput(ProblemName + ".out");
		ST = new StringTokenizer(in.readLine());
	}

	/** - INPUT/OUPUT - **/

	public static void setInput(String filename) throws IOException {
		input = new File(filename);
		inputreader = new FileReader(input);
		in = new BufferedReader(inputreader);
	}

	public static void setOutput(String filename) throws IOException {
		output = new File(filename);
		outputwriter = new FileWriter(output);
		out = new BufferedWriter(outputwriter);
	}

	public static void CLOSE() throws IOException {
		if (in != null)
			in.close();
		if (inputreader != null)
			inputreader.close();

		if (out != null)
			out.flush();
		if (out != null)
			out.close();
		if (outputwriter != null)
			outputwriter.close();
	}

	/** - CONVERSIONS - **/

	static int INT(String A) throws IOException {
		return Integer.parseInt(A);
	}

	static long LONG(String A) throws IOException {
		return Long.parseLong(A);
	}

	static double DOUBLE(String A) throws IOException {
		return Double.parseDouble(A);
	}

	static BigInteger BIGINT(String A) throws IOException {
		return new BigInteger(A);
	}

	/** - CUSTOM PRINTS - **/

	public static void println() throws IOException {
		out.write("\n");
		System.out.println();
	}

	public static void println(Object obj) throws IOException {
		out.write(obj.toString());
		out.write("\n");
		System.out.println(obj.toString());
	}

	public static void print(Object obj) throws IOException {
		out.write(obj.toString());
		System.out.print(obj.toString());
	}

	public static void println(long number) throws IOException {
		out.write(Long.toString(number));
		out.write("\n");
		System.out.println(number);
	}

	public static void print(long number) throws IOException {
		out.write(Long.toString(number));
		System.out.print(number);
	}

	public static void println(char c) throws IOException {
		out.write(Character.toString(c));
		out.write("\n");
		System.out.println(c);
	}

	public static void print(char c) throws IOException {
		out.write(Character.toString(c));
		System.out.print(c);
	}

	public static void println(String line) throws IOException {
		out.write(line);
		out.write("\n");
		System.out.println(line);
	}

	public static void print(String line) throws IOException {
		out.write(line);
		System.out.print(line);
	}

	/** - READING INPUT - **/

	static String TOKEN() throws IOException {
		while (ST == null || !ST.hasMoreTokens()) {
		}
		return ST.nextToken();
	}
}


