package RPI;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

class TestCase {
	int NoOfTeams = 0;
	char Table[][];
	double WP[];
	double OWP[];
	double OOWP[];
	ArrayList<Double> RPIS = new ArrayList<Double>();
	StringTokenizer ST;
	BufferedReader in;

	TestCase(BufferedReader in) throws IOException {
		this.in = in;
		ST = new StringTokenizer(in.readLine());
		NoOfTeams = RPI.INT(TOKEN(ST));
		Table = new char[NoOfTeams][NoOfTeams];
		WP = new double[NoOfTeams];
		OWP = new double[NoOfTeams];
		OOWP = new double[NoOfTeams];
		ReadTeamsTable(NoOfTeams);
		/*
		 * for (int i = 0; i < NoOfTeams; i++) { for (int j = 0; j < NoOfTeams;
		 * j++) { System.out.print(Table[i][j]); } System.out.println(); }
		 */
	}

	private void ReadTeamsTable(int NoOfTeams) throws IOException {
		String S;
		for (int i = 0; i < NoOfTeams; i++) {
			S = in.readLine();
			for (int j = 0; j < NoOfTeams; j++) {
				Table[i][j] = S.charAt(j);
			}
		}
	}

	public int Solve() throws IOException {
		double rpis;
		for (int j = 0; j < NoOfTeams; j++) {
			CalculateWP(j);
			CalculateOWP(j);	
		}
		for (int j = 0; j < NoOfTeams; j++) {
			CalculateOOWP(j);
			rpis = 0.25 * WP[j] + 0.50 * OWP[j] + 0.25 * OOWP[j];
			RPI.println(rpis);
		}
		return 0;
	}

	private void CalculateOOWP(int i) {
		double TOOWP = 0;
		double Played = 0;
		for (int j = 0; j < NoOfTeams; j++) {
			if (Table[i][j] != '.')
			{
				Played++;
				TOOWP += OWP[j];
			}
		}
		OOWP[i] = TOOWP / Played;
//		System.out.println("OOWP: " + OOWP[i]);
	}

	private void CalculateOWP(int i) {
		double TOWP = 0;
		double TotalM = 0;
		double TotalW = 0;
		double Played = 0;
		for (int j = 0; j < NoOfTeams; j++) {
			if (Table[i][j] != '.')
				Played++;
		}

		for (int j = 0; j < NoOfTeams; j++) {
			if (Table[i][j] != '.') {
				TotalM = 0;
				TotalW = 0;
				for (int k = 0; k < NoOfTeams; k++) {
					if (k == i) {
					} else {
						if (Table[j][k] == '1' || Table[j][k] == '0')
							TotalM++;
						if (Table[j][k] == '1')
							TotalW++;
					}
				}
	//			System.out.println("W: " + TotalW + "/" + TotalM);
				TOWP += TotalW / TotalM;
	//			System.out.println("TOWP: " + i + " " + TOWP);
			}
		}
		OWP[i] = TOWP / Played;
//		System.out.println("OWP: " + OWP[i]);

	}

	private void CalculateWP(int i) {
		double TotalM = 0;
		double TotalW = 0;
		for (int j = 0; j < NoOfTeams; j++) {
			if (Table[i][j] == '1' || Table[i][j] == '0')
				TotalM++;
			if (Table[i][j] == '1')
				TotalW++;
		}
		WP[i] = TotalW / TotalM;
//		System.out.println("WP: " + WP[i]);
	}

	public String TOKEN(StringTokenizer ST) throws IOException {
		if (ST == null || !ST.hasMoreTokens()) {
			return null;
		}
		return ST.nextToken();
	}
}