/**
 * 
 */
package Magicka;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author Brighton Vino
 * 
 */
public class Magicka {

	public static File input;
	public static File output;
	public static FileReader inputreader;
	public static FileWriter outputwriter;
	public static BufferedReader in;
	public static BufferedWriter out;
	public static final String ProblemName = "Magicka";
	public static StringTokenizer ST;

	public static int NoOfTestCases = 0;
	public static int Tested = 0;

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(String[] args) throws IOException {
		String Soln;
		INITProblem();
		NoOfTestCases = INT(TOKEN());
		while (Tested < NoOfTestCases) {
			TestCase TC = new TestCase(new StringTokenizer(in.readLine()));
			print("Case #" + (Tested + 1) + ": [");
			Soln = TC.Solve();
			for (int i = 0; i < (Soln.length() - 1); i++) {
				print(Soln.charAt(i) + ", ");
			}
			if (Soln.length() >= 1) {
				print(Soln.charAt(Soln.length() - 1));
			}
			println("]");
			Tested++;
		}
		CLOSE();
	}

	public static void INITProblem() throws IOException {
		setInput(ProblemName + ".in");
		setOutput(ProblemName + ".out");
		ST = new StringTokenizer(in.readLine());
	}

	/** - INPUT/OUPUT - **/

	public static void setInput(String filename) throws IOException {
		input = new File(filename);
		inputreader = new FileReader(input);
		in = new BufferedReader(inputreader);
	}

	public static void setOutput(String filename) throws IOException {
		output = new File(filename);
		outputwriter = new FileWriter(output);
		out = new BufferedWriter(outputwriter);
	}

	public static void CLOSE() throws IOException {
		if (in != null)
			in.close();
		if (inputreader != null)
			inputreader.close();

		if (out != null)
			out.flush();
		if (out != null)
			out.close();
		if (outputwriter != null)
			outputwriter.close();
	}

	/** - CONVERSIONS - **/

	static int INT(String A) throws IOException {
		return Integer.parseInt(A);
	}

	static long LONG(String A) throws IOException {
		return Long.parseLong(A);
	}

	static double DOUBLE(String A) throws IOException {
		return Double.parseDouble(A);
	}

	static BigInteger BIGINT(String A) throws IOException {
		return new BigInteger(A);
	}

	/** - CUSTOM PRINTS - **/

	public static void println() throws IOException {
		out.write("\n");
		System.out.println();
	}

	public static void println(Object obj) throws IOException {
		out.write(obj.toString());
		out.write("\n");
		System.out.println(obj.toString());
	}

	public static void print(Object obj) throws IOException {
		out.write(obj.toString());
		System.out.print(obj.toString());
	}

	public static void println(long number) throws IOException {
		out.write(Long.toString(number));
		out.write("\n");
		System.out.println(number);
	}

	public static void print(long number) throws IOException {
		out.write(Long.toString(number));
		System.out.print(number);
	}

	public static void println(char c) throws IOException {
		out.write(Character.toString(c));
		out.write("\n");
		System.out.println(c);
	}

	public static void print(char c) throws IOException {
		out.write(Character.toString(c));
		System.out.print(c);
	}

	public static void println(String line) throws IOException {
		out.write(line);
		out.write("\n");
		System.out.println(line);
	}

	public static void print(String line) throws IOException {
		out.write(line);
		System.out.print(line);
	}

	/** - READING INPUT - **/

	static String TOKEN() throws IOException {
		while (ST == null || !ST.hasMoreTokens()) {

		}
		return ST.nextToken();
	}
}

class TestCase {
	StringTokenizer ST;
	int NoOfInvoke, NoOfCombine, NoOfChar;
	ArrayList<String> Invoke;
	ArrayList<String> Combine;
	String Result;
	String CharSeq;

	TestCase(StringTokenizer ST) throws IOException {
		Invoke = new ArrayList<String>();
		Combine = new ArrayList<String>();
		Result = "";
		CharSeq = "";

		this.ST = ST;
		NoOfInvoke = Magicka.INT(TOKEN(this.ST));
		// Magicka.println(NoOfInvoke);
		if (NoOfInvoke > 0) {
			for (int i = 0; i < NoOfInvoke; i++) {
				Invoke.add(TOKEN(this.ST));
			}
			// Magicka.println(Invoke);
		}
		NoOfCombine = Magicka.INT(TOKEN(this.ST));
		// Magicka.println(NoOfCombine);
		if (NoOfCombine > 0) {
			for (int i = 0; i < NoOfCombine; i++) {
				Combine.add(TOKEN(this.ST));
			}
			// Magicka.println(Combine);
		}
		NoOfChar = Magicka.INT(TOKEN(this.ST));
		// Magicka.println(NoOfChar);
		if (NoOfChar > 0) {
			CharSeq = TOKEN(this.ST);
			// Magicka.println(CharSeq);
		}
	}

	public String Solve() throws IOException {
		for (int i = 0; i < NoOfChar; i++) {
			Result += CharSeq.charAt(i);
			if (NoOfInvoke > 0)
				CheckInvoke();
			if (NoOfCombine > 0)
				CheckCombine();
		}
		return Result;
	}

	private void CheckCombine() throws IOException {
		String TResult;
		for (int i = 0; i < Combine.size(); i++) {
			String RegExp = Combine.get(i).charAt(0) + "[a-zA-Z]*" + Combine.get(i).charAt(1);
			Pattern pattern = Pattern.compile(RegExp);
			Matcher matcher = pattern.matcher(Result);
			TResult = matcher.replaceAll("");
			if (!TResult.equalsIgnoreCase(Result)) {
				Result = "";
			}

			String RegExpR = Combine.get(i).charAt(1) + "[a-zA-Z]*" + Combine.get(i).charAt(0);
			Pattern patternR = Pattern.compile(RegExpR);
			Matcher matcherR = patternR.matcher(Result);
			TResult = matcherR.replaceAll("");
			if (!TResult.equalsIgnoreCase(Result)) {
				Result = "";
			}
		}

		// Magicka.println("CR "+ Result);
	}

	void CheckInvoke() throws IOException {
		// Magicka.println("I "+ Result);
		for (int i = 0; i < Invoke.size(); i++) {
			if (Result.contains(Invoke.get(i).subSequence(0, 2)) || Result.contains(reverse(Invoke.get(i).subSequence(0, 2).toString()))) {
				Result = Result.substring(0, Result.length() - 2) + Invoke.get(i).charAt(2);
			}
		}
		// Magicka.println("IR "+ Result);
	}

	public String TOKEN(StringTokenizer ST) throws IOException {
		if (ST == null || !ST.hasMoreTokens()) {
			return null;
		}
		return ST.nextToken();
	}

	public String reverse(String A) {
		return (new StringBuffer(A).reverse().toString());
	}
}