package SquareTiles;

import java.io.BufferedReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.StringTokenizer;

class TestCase {
	int Rows = 0;
	int Columns = 0;
	int Points = 0, Turns = 1;
	char Tile[][];
	StringTokenizer ST;
	BufferedReader in;

	TestCase(BufferedReader in) throws IOException {
		this.in = in;
		ST = new StringTokenizer(in.readLine());
		Rows = SquareTiles.INT(TOKEN(ST));
		Columns = SquareTiles.INT(TOKEN(ST));
		Tile = new char[Rows][Columns];
		ReadTiles(Rows, Columns);

	}

	private void ReadTiles(int R, int C) throws IOException {
		for (int i = 0; i < R; i++) {
			String S = in.readLine();
			for (int j = 0; j < C; j++) {
				Tile[i][j] = S.charAt(j);
			}
		}
	}

	public void Solve() throws IOException {
		if (!TryNReplace()) {
			SquareTiles.println("Impossible");
		} else {
			for (int i = 0; i < Rows; i++) {
				for (int j = 0; j < Columns; j++) {
					SquareTiles.print(Tile[i][j]);
				}
				SquareTiles.println();
			}
		}
	}

	private boolean TryNReplace() {
		try {
			for (int i = 0; i < Rows; i++) {
				for (int j = 0; j < Columns; j++) {
					if (Tile[i][j] == '#') {
						Tile[i][j] = '/';
						if (Tile[i][j + 1] == '#')
							Tile[i][j + 1] = '\\';
						else
							return false;
						if (Tile[i + 1][j] == '#')
							Tile[i + 1][j] = '\\';
						else
							return false;
						if (Tile[i + 1][j + 1] == '#')
							Tile[i + 1][j + 1] = '/';
						else
							return false;
					}
				}
			}
		} catch (Exception E) {
			return false;
		}
		return true;
	}

	public String TOKEN(StringTokenizer ST) throws IOException {
		if (ST == null || !ST.hasMoreTokens()) {
			return null;
		}
		return ST.nextToken();
	}
}