import java.io.FileReader;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class B2 {
	
	enum Color {
		R,
		Y,
		B,
		O,
		G,
		V
	}
	
	Map<Color, Integer> colors = new HashMap<>();
	
	Color start;

	private void solve(Scanner scan, PrintWriter out) {
		int N = scan.nextInt();
		colors.put(Color.R, scan.nextInt());
		colors.put(Color.O, scan.nextInt());
		colors.put(Color.Y, scan.nextInt());
		colors.put(Color.G, scan.nextInt());
		colors.put(Color.B, scan.nextInt());
		colors.put(Color.V, scan.nextInt());
		
		int n = N;
		
		int R = colors.get(Color.R);
		int Y = colors.get(Color.Y);
		int B = colors.get(Color.B);
		int O = colors.get(Color.O);
		int G = colors.get(Color.G);
		int V = colors.get(Color.V);
		
//		System.out.println(R + " " + Y + " " + B);

		if (Y == 0 && B == 0 && O == 0 && V == 0 && R == G) {
			printResult(R, "RG", out);
			return;
		}
		if (R == 0 && B == 0 && O == 0 && G == 0 && Y == V) {
			printResult(Y, "YV", out);
			return;
		}
		if (R == 0 && Y == 0 && G == 0 && V == 0 && B == O) {
			printResult(B, "BO", out);
			return;
		}
		
		if (O > B/2) {
			System.out.println("IMPOSSIBLE");
			out.println("IMPOSSIBLE");
			return;
		}
		
		if (G > R/2) {
			System.out.println("IMPOSSIBLE");
			out.println("IMPOSSIBLE");
			return;
		}
		
		if (V > Y/2) {
			System.out.println("IMPOSSIBLE");
			out.println("IMPOSSIBLE");
			return;
		}

		n -= 2*G;
		n -= 2*V;
		n -= 2*O;
		
//		System.out.println(n);

		decrease(Color.R, G);
		decrease(Color.Y, V);
		decrease(Color.B, O);
		
		if (Math.max(R, Math.max(Y, B)) > N/2) {
			System.out.println("IMPOSSIBLE");
			out.println("IMPOSSIBLE");
			return;
		}
		

		R = colors.get(Color.R);
		Y = colors.get(Color.Y);
		B = colors.get(Color.B);
		O = colors.get(Color.O);
		G = colors.get(Color.G);
		V = colors.get(Color.V);
		
//		System.out.println(R + " " + Y + " " + B);
		
		String result = "";
		
		if (R >= Y && R >= B) {
			start = Color.R;
			colors.put(Color.R, colors.get(Color.R) - 1);
		} else if (Y >= R && Y >= B) {
			start = Color.Y;
			colors.put(Color.Y, colors.get(Color.Y) - 1);	
		} else if (B >= R && B >= Y) {
			start = Color.B;
			colors.put(Color.B, colors.get(Color.B) - 1);	
		} else {
			throw new RuntimeException();
		}
		n--;
		result += start;
		
//		System.out.println(n);
		
//		System.out.println(start);
		
		Color last = start;
		
		while (n > 0) {
			Color c = findMax(last);
//			System.out.println(last + " " + c);
			result += c.toString();
			colors.put(c, colors.get(c) - 1);
			last = c;
			n--;
		}

		for (int i = 0; i < G; i++) {
			result = result.replaceFirst("R", "RGR");
		}
		for (int i = 0; i < V; i++) {
			result = result.replaceFirst("Y", "YVY");
		}
		for (int i = 0; i < O; i++) {
			result = result.replaceFirst("B", "BOB");
		}
		
		System.out.println(result);
		out.println(result);
			
	}
	
	private void printResult(int y, String string, PrintWriter out) {
		String result = "";
		for (int i = 0; i < y; i++) {
			result += string;
		}
		System.out.println(result);
		out.println(result);
	}

	private void decrease(Color c, int i) {
		colors.put(c, colors.get(c) - i);
		
	}

	private Color findMax(Color ignore) {
		int r = colors.get(Color.R);
		int y = colors.get(Color.Y);
		int b = colors.get(Color.B);
		if (r < 0) {
			throw new RuntimeException();
		}
		if (y < 0) {
			throw new RuntimeException();
		}
		if (b < 0) {
			throw new RuntimeException();
		}
		if (r == 0 && y == 0 && b == 0) {
			throw new RuntimeException();
		}
//		System.out.println(r + " " + y + " "  + b);
		if (ignore == Color.R) {
			if (y == b) {
				return start == Color.Y ? Color.Y : Color.B;
			}
			return y > b ? Color.Y : Color.B;
		}
		if (ignore == Color.Y) {
			if (r == b) {
				return start == Color.R ? Color.R : Color.B;
			}
			return r > b ? Color.R : Color.B;
		}
		if (ignore == Color.B) {
			if (r == y) {
				return start == Color.R ? Color.R : Color.Y;
			}
			return r > y ? Color.R : Color.Y;
		}
		throw new RuntimeException();
	}
	
    public static void main(String[] args) throws Exception {
		String filename = "B-large";
        Scanner scan = new Scanner(new FileReader(filename + ".in"));
        PrintWriter out = new PrintWriter(filename + ".out");
        int problems = scan.nextInt();
        for (int count = 0; count < problems; count++) {
            System.out.print("Case #" + (count+1) + ": ");
            out.print("Case #" + (count+1) + ": ");
            new B2().solve(scan, out);
        }
        out.flush();
        out.close();
        scan.close();
    }
}
