import java.io.FileReader;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Scanner;

public class SquareFair {
	
	static LinkedList<Long> squares = new LinkedList<Long>();
	
	public static void preprocess() {
		long i = 1;
		while (true) {
			if (i == 10000) {
				break;
			}
			if (Math.floor(Math.sqrt(i))*Math.floor(Math.sqrt(i)) == i && isPalindrome(i)) {	
				squares.add(i);
			}
			i++;
		}
	}
	
	private static boolean isPalindrome(long i) {
		long j = i;
		int length = 1;
		while (j >= 10) {
			j /= 10;
			length++;
		}
		long[] array = new long[length];
		long mod = 10;
		for (int a = length-1; a >= 0; a--) {
			array[a] = (i%mod)/(mod/10);
			mod *= 10;
		}
		for (int a = 0; a < length/2; a++) {
			if (array[a] != array[length-a-1]) {
				return false;
			}
		}
		return true;
	}

	public void solve(Scanner scan, PrintWriter out) {
		long a = scan.nextLong();
		long b = scan.nextLong();
		int result = 0;
		
		for (long i = a; i <= b; i++) {
			if (squares.getLast() < i) {
				break;
			}
			if (squares.contains(i) && isPalindrome((int) Math.sqrt(i))) {
				result++;
			}
		}

		System.out.println(result);
		out.println(result);
	}

	public static void main(String[] args) throws Exception {
		preprocess();
        Scanner scan = new Scanner(new FileReader("input.in"));
        PrintWriter out = new PrintWriter("output.txt");
        int problems = scan.nextInt();
        for (int count = 0; count < problems; count++) {
            System.out.print("Case #" + (count+1) + ": ");
            out.print("Case #" + (count+1) + ": ");
            new SquareFair().solve(scan, out);
        }
        out.flush();
        out.close();
        scan.close();
    }
	
}