package codejam2010.rollercoaster;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;


public class Ride {

	 private List<Event> events = null;

	 public static final String DIR = "F:/codejam/large/";

	 private String filename = DIR + "C-large.in";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Ride ride = new Ride();
		ride.begin();
	}
	
	private void begin(){
		readInput();
//		printInput();
		long start = System.currentTimeMillis();
		solve();
		long end = System.currentTimeMillis();
		System.out.println((end-start)+"ms");
		writeToFile();
	}
	
	public void solve() {
		Event eventRound = null;
		for (int i = 0; i < events.size(); i++) {
			System.out.println("Solving "+(i+1));
			eventRound = events.get(i);
			eventRound.moneyMade = solve(eventRound.R, eventRound.k, eventRound.groups);
		}

	}
	
	private void writeToFile() {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(DIR
					+ "output.txt"));

			Event eventRound = null;
			for (int i = 0; i < events.size()-1; i++) {
				eventRound = events.get(i);
				out.write("Case #"+(i+1)+": "+(eventRound.moneyMade)+System.getProperty("line.separator"));
			}
			out.write("Case #"+(events.size())+": "+(events.get(events.size()-1).moneyMade));
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	public void readInput() {
		FileRead read = new FileRead(filename);
		events = read.getEvents();
	}
	
	public void printInput() {
		Event eventRound = null;
		for (int i = 0; i < events.size(); i++) {
			eventRound = events.get(i);
			System.out.println(eventRound.R+" "+eventRound.k+" "+eventRound.N);
			for(int j=0;j<eventRound.N;j++){
				System.out.print(eventRound.groups[j]+" ");
			}
			System.out.println();
		}
	}
	
	
	
	private long solve(long R, long k, long[] groups){
		
		int len = groups.length;
		
		long[] sums = new long[len];
		int[] span = new int[len];
		
		//irrespective of R, calculate and keep the extent and sum in separate arrays
		
		for(int x=0;x<len;x++){//Maximum 1000 runs
			int sum = 0; int extent=0;
			for(int y=x;;y++){
				if(sum+groups[y%len]>k || len==extent){
					break;
				}
				extent++;
				sum+=groups[y%len];
			}
			sums[x] = sum;
			span[x] = extent;
		}
		
		long totalSum = 0;
		int i = 0;
		
		for(int r=0;r<R;r++){
			totalSum += sums[i];
			i+=span[i];
			i=i%len;
		}
		
		return totalSum;
	}
	
}