package codejam2010.round1c.intranet;

import java.awt.geom.Line2D;
import java.awt.geom.Point2D;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Intranet {
	public static long StaticCount = 0;
	private List<Case> cases = null;
	public static final String DIR = "E:/";
	private String filename = DIR + "A-small-attempt0.in";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Intranet in = new Intranet();
		in.begin();
	}
	
	private void begin(){
		readInput();
		printInput();
		long start = System.currentTimeMillis();
		solve();
		long end = System.currentTimeMillis();
		System.out.println((end-start)+"ms");
		writeToFile();
	}
	
	public void solve() {
		Case eachCase = null;
		for (int i = 0; i < cases.size(); i++) {
			eachCase = cases.get(i);
			eachCase.mesh = solve(eachCase.a, eachCase.b);
		}
	}
	
	private void writeToFile() {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(DIR + "output.txt"));
			Case eachCase = null;
			for (int i = 0; i < cases.size()-1; i++) {
				eachCase = cases.get(i);
				out.write("Case #"+(i+1)+": "+(eachCase.mesh)+System.getProperty("line.separator"));
			}
			out.write("Case #"+(cases.size())+": "+(cases.get(cases.size()-1).mesh));
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public void readInput() {
		FileRead read = new FileRead(filename);
		cases = read.getEvents();
	}
	
	public void printInput() {
		Case eachCase = null;
		for (int i = 0; i < cases.size(); i++) {
			eachCase = cases.get(i);
			System.out.println(eachCase.length);
		}
	}
	
	class PointMesh{
		
		long intersects;
		
		List<Line2D> lineList = new ArrayList<Line2D>();
		
		Line2D line1 = new Line2D.Double();
		Line2D r = new Line2D.Double();
		
		
		void add(int a,int b){
			Point2D p1 = new Point2D.Double(0, a);
			Point2D p2 = new Point2D.Double(10, b);
			
			Line2D newLine = new Line2D.Double(p1,p2);
			
			for(Line2D eachLine:lineList){
				if(eachLine.intersectsLine(newLine)){
					intersects++;
				}
			}
			lineList.add(newLine);
		}
	}
	
	
	private long solve(int[] a, int[] b) {
		
		PointMesh p = new PointMesh();
		
		for(int i=0;i<a.length;i++){
			p.add(a[i], b[i]);
		}
		
		return p.intersects;
	}
}

class Case {
	int length;
	int[] a;
	int[] b;
	long mesh;
}

class FileRead {
	private String filename = null;
	private List<Case> cases;
	public FileRead(String filename) {
		this.filename = filename;
		load();
	}
	private void load() {
		FileInputStream fstream = null;
		DataInputStream in = null;
		BufferedReader br = null;
		Case eachCase = null;
		try {
			fstream = new FileInputStream(filename);
			in = new DataInputStream(fstream);
			br = new BufferedReader(new InputStreamReader(in));
			int totalCases = Integer.parseInt(br.readLine());
			cases = new ArrayList<Case>(totalCases);
			for (int i=0;i<totalCases;i++) {
				eachCase = new Case();
				eachCase.length = Integer.parseInt(br.readLine());
				eachCase.a = new int[eachCase.length];
				eachCase.b = new int[eachCase.length];
				for(int j=0;j<eachCase.length;j++){
					String[] tmp = br.readLine().split(" ");
					eachCase.a[j] = Integer.parseInt(tmp[0]);
					eachCase.b[j] = Integer.parseInt(tmp[1]);
				}
				cases.add(eachCase);
			}
			in.close();
		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		} 	
	}

	public List<Case> getEvents() {
		return cases;
	}
}