package codejam2010.round1b.mkdir;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;


public class MkDir {
	
	public static long StaticCount = 0;

	 private List<Case> cases = null;

	 public static final String DIR = "F:/codejam/round1b/01/";

	 private String filename = DIR + "A-small-attempt0.in";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		MkDir ride = new MkDir();
		ride.begin();
	}
	
	private void begin(){
		readInput();
		printInput();
		long start = System.currentTimeMillis();
		solve();
		long end = System.currentTimeMillis();
		System.out.println((end-start)+"ms");
		writeToFile();
	}
	
	public void solve() {
		Case eachCase = null;
		for (int i = 0; i < cases.size(); i++) {
			eachCase = cases.get(i);
			eachCase.insertsNeeded = solve(eachCase.already, eachCase.fresh);
		}
	}
	
	private void writeToFile() {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(DIR
					+ "output.txt"));

			Case eachCase = null;
			for (int i = 0; i < cases.size()-1; i++) {
				eachCase = cases.get(i);
				out.write("Case #"+(i+1)+": "+(eachCase.insertsNeeded)+System.getProperty("line.separator"));
			}
			out.write("Case #"+(cases.size())+": "+(cases.get(cases.size()-1).insertsNeeded));
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	public void readInput() {
		FileRead read = new FileRead(filename);
		cases = read.getEvents();
	}
	
	public void printInput() {
		Case eachCase = null;
		for (int i = 0; i < cases.size(); i++) {
			eachCase = cases.get(i);

			System.out.println(eachCase.already.length+" "+eachCase.fresh.length);
		}
	}
	
	private int solve(String[] already, String[] fresh) {
		Trie trieDSA = new Trie();
		
		for(int i=0;i<already.length;i++){
			trieDSA.insert(already[i],false);
		}
		
		for(int i=0;i<fresh.length;i++){
			trieDSA.insert(fresh[i], true);
		}
		
		return trieDSA.counter;
	}
}

class Case {
	String[] already;
	String[] fresh;
	long insertsNeeded;
}

class FileRead {

	private String filename = null;
	private List<Case> cases;

	public FileRead(String filename) {
		this.filename = filename;
		load();
	}

	private void load() {

		FileInputStream fstream = null;
		DataInputStream in = null;
		BufferedReader br = null;
		Case eachCase = null;

		try {
			fstream = new FileInputStream(filename);
			in = new DataInputStream(fstream);
			br = new BufferedReader(new InputStreamReader(in));
			
			int totalCases = Integer.parseInt(br.readLine());
			
			cases = new ArrayList<Case>(totalCases);

			for (int i=0;i<totalCases;i++) {

				eachCase = new Case();
				
				String[] nm = br.readLine().split(" ");
				int n = Integer.parseInt(nm[0]);
				int m = Integer.parseInt(nm[1]);
				
				eachCase.already = new String[n];
				eachCase.fresh = new String[m];
				
				for(int x=0;x<n;x++){
					eachCase.already[x] = br.readLine();
				}
				for(int y=0;y<m;y++){
					eachCase.fresh[y] = br.readLine();
				}
				cases.add(eachCase);
			}

		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		} finally {
			try {
				if(in!=null)
					in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public List<Case> getEvents() {
		return cases;
	}
}

class Node {
	String currentPath;
	boolean marker; 
	Collection<Node> child;
	
	public Node(String path){
		child = new HashSet<Node>();
		marker = false;
		currentPath = path;
	}
	
	public Node subNode(String path){
		if(child!=null){
			for(Node eachChild:child){
				if(eachChild.currentPath.equals(path)){
					return eachChild;
				}
			}
		}
		return null;
	}
}

class Trie{
	private Node root;
	
	public int counter = 0;

	public Trie(){
		root = new Node("");
	}

	public void insert(String pathArray, boolean shouldTrack){
		Node current = root;	
		
		String[] paths = pathArray.substring(1).split("\\/");
		
		if(paths.length==0){
			//DO NOTHING
			current.marker=true;
		}
			
			
		for(int i=0;i<paths.length;i++){
			Node child = current.subNode(paths[i]);
			if(child!=null){ 
				current = child;
			}
			else{
				current.child.add(new Node(paths[i]));
				current = current.subNode(paths[i]);
				if(shouldTrack){
					counter++;
				}
			}
			// Set marker to indicate end of the word
			if(i==paths.length-1)
				current.marker = true;
		}	
	}
}
