package codejam2010.round1b.chicken;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;


public class Chicken {
	
	public static long StaticCount = 0;

	 private List<Case> cases = null;

	 public static final String DIR = "F:/codejam/round1b/02/";

	 private String filename = DIR + "B-small-attempt2.in";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Chicken chickie = new Chicken();
		chickie.begin();
	}
	
	private void begin(){
		readInput();
		printInput();
		long start = System.currentTimeMillis();
		solve();
		long end = System.currentTimeMillis();
		System.out.println((end-start)+"ms");
		writeToFile();
	}
	
	public void solve() {
		Case eachCase = null;
		for (int i = 0; i < cases.size(); i++) {
			eachCase = cases.get(i);
			eachCase.output = solve(eachCase.n,eachCase.k,eachCase.b,eachCase.t,eachCase.bias,eachCase.speed);
		}
	}
	
	private void writeToFile() {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(DIR
					+ "output.txt"));

			Case eachCase = null;
			for (int i = 0; i < cases.size()-1; i++) {
				eachCase = cases.get(i);
				out.write("Case #"+(i+1)+": "+(eachCase.output)+System.getProperty("line.separator"));
			}
			out.write("Case #"+(cases.size())+": "+(cases.get(cases.size()-1).output));
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	public void readInput() {
		FileRead read = new FileRead(filename);
		cases = read.getEvents();
	}
	
	public void printInput() {
		Case eachCase = null;
		for (int i = 0; i < cases.size(); i++) {
			eachCase = cases.get(i);
			System.out.println(eachCase.n+" "+eachCase.k+" "+eachCase.b+" "+eachCase.t);
			for(int j=0;j<eachCase.n;j++){
				System.out.print(eachCase.bias[j]+ " ");
			}
			System.out.println();
			for(int j=0;j<eachCase.n;j++){
				System.out.print(eachCase.speed[j]+ " ");
			}
			System.out.println();
		}
	}
	
	class Chickation{

		int n, k;
		long b, t;
		long[] positions, speeds;
		
		public Chickation(int n, int k, long b, long t, long[] positions,
				long[] speeds) {
			this.n = n;
			this.k = k;
			this.b = b;
			this.t = t;
			this.positions = positions;
			this.speeds = speeds;
		}
		
		public long swaps = 0;

		public boolean projectedSuccess(int conceeded) {
			
			int count = 0;
			
			for(int i=n-1;i>=0;i--){
				if( speeds[i]*(t-conceeded)+positions[i] >= b){
					count++;
					if(count==k){
						return true;
					}
				}else{
					return false;
				}
			}
			
			return false;
		}

		public void increment() {
			positions[n-1] = positions[n-1]+speeds[n-1];
			for(int i=n-2;i>=0;i--){
				if(positions[i]+speeds[i] <= positions[i+1]+speeds[i+1]){
					positions[i]+=speeds[i];
				}else{
					positions[i] = positions[i+1];
				}
			}
		}

		public boolean swapIfNeeded(int conceeded) {
			
			if(n==0 || n==1) return false;
			
			for(int j=0;j<n-1;j++){
				
				
				if(positions[j] == positions[j+1]){
					if(speeds[j]>speeds[j+1]){
						long temp = speeds[j];
						speeds[j] = speeds[j+1];
						speeds[j+1] = temp;
						swaps++;
						
						if(projectedSuccess(conceeded)){
							return true;
						}
					
					}
				}
			}
			
			
			
			if(positions[n-2] == positions[n-1]){
				if(speeds[n-2]>speeds[n-1]){
					long temp = speeds[n-2];
					speeds[n-2] = speeds[n-1];
					speeds[n-1] = temp;
					swaps++;
				}
			}
			
			return false;
			
		}
		
	}
	
	private String solve(int n, int k, long b, long t, long[] positions, long[] speeds) {
		
		Chickation chick = new Chickation(n,k,b,t,positions,speeds);
		
		
		for(int i=0;i<t;i++){//T Times run the loop
			if(chick.projectedSuccess(i)){
				return chick.swaps+"";
			}
			chick.increment();
			if(chick.swapIfNeeded(i)){
				return chick.swaps+"";
			}
		}
		
		return "IMPOSSIBLE";
	}
}

class Case {
	int n;
	int k;
	long b;
	long t;
	long[] speed;
	long[] bias;
	String output;
	
	
	int[] rank;
}

class FileRead {

	private String filename = null;
	private List<Case> cases;

	public FileRead(String filename) {
		this.filename = filename;
		load();
	}

	private void load() {

		FileInputStream fstream = null;
		DataInputStream in = null;
		BufferedReader br = null;
		Case eachCase = null;

		try {
			fstream = new FileInputStream(filename);
			in = new DataInputStream(fstream);
			br = new BufferedReader(new InputStreamReader(in));
			
			int totalCases = Integer.parseInt(br.readLine());
			
			cases = new ArrayList<Case>(totalCases);

			for (int i=0;i<totalCases;i++) {

				eachCase = new Case();
				
				String[] props = br.readLine().split(" ");
				
				eachCase.n = Integer.parseInt(props[0]);
				eachCase.k = Integer.parseInt(props[1]);
				eachCase.b = Integer.parseInt(props[2]);
				eachCase.t = Integer.parseInt(props[3]);
				
				String[] biases = br.readLine().split(" ");
				String[] speeds = br.readLine().split(" ");
				
				long[] bias = new long[eachCase.n];
				long[] speed = new long[eachCase.n];
				
				for(int j=0;j<eachCase.n;j++){
					bias[j] = Integer.parseInt(biases[j]);
					speed[j] = Integer.parseInt(speeds[j]);
				}
				
				eachCase.bias = bias;
				eachCase.speed = speed;
				
				cases.add(eachCase);
			}

		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		} finally {
			try {
				if(in!=null)
					in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public List<Case> getEvents() {
		return cases;
	}
}

class Node {
	String currentPath;
	boolean marker; 
	Collection<Node> child;
	
	public Node(String path){
		child = new HashSet<Node>();
		marker = false;
		currentPath = path;
	}
	
	public Node subNode(String path){
		if(child!=null){
			for(Node eachChild:child){
				if(eachChild.currentPath.equals(path)){
					return eachChild;
				}
			}
		}
		return null;
	}
}

class Trie{
	private Node root;
	
	public int counter = 0;

	public Trie(){
		root = new Node("");
	}

	public void insert(String pathArray, boolean shouldTrack){
		Node current = root;	
		
		String[] paths = pathArray.substring(1).split("\\/");
		
		if(paths.length==0){
			//DO NOTHING
			current.marker=true;
		}
			
			
		for(int i=0;i<paths.length;i++){
			Node child = current.subNode(paths[i]);
			if(child!=null){ 
				current = child;
			}
			else{
				current.child.add(new Node(paths[i]));
				current = current.subNode(paths[i]);
				if(shouldTrack){
					counter++;
				}
			}
			// Set marker to indicate end of the word
			if(i==paths.length-1)
				current.marker = true;
		}	
	}
}
