package codejam2010.rollercoaster;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class FileRead {

	private String filename = null;
	private List<Event> events;

	public FileRead(String filename) {
		this.filename = filename;
		load();
	}

	private void load() {

		FileInputStream fstream = null;
		DataInputStream in = null;
		BufferedReader br = null;
		Event event = null;

		try {
			fstream = new FileInputStream(filename);
			in = new DataInputStream(fstream);
			br = new BufferedReader(new InputStreamReader(in));
			
			int totalEvents = Integer.parseInt(br.readLine());
			
			events = new ArrayList<Event>(totalEvents+1);

			for (int i=0;i<totalEvents;i++) {
				event = new Event();
				String thisLine = br.readLine();
				String[] values = thisLine.split(" ");
				event.R = Integer.parseInt(values[0]);
				event.k = Integer.parseInt(values[1]);
				event.N = Integer.parseInt(values[2]);
				
				String nextLine = br.readLine();
				String[] groups = nextLine.split(" ");
				event.groups = new long[groups.length];
				for(int j=0;j<groups.length;j++){
					event.groups[j] = Integer.parseInt(groups[j]);
				}
				
				events.add(event);
			}

		} catch (Exception e) {
			System.err.println("Error: " + e.getMessage());
		} finally {
			try {
				if(in!=null)
					in.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}

	public List<Event> getEvents() {
		return events;
	}
}