package codejam2010.snapper;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;

public class Experiment {

	 private List<Event> events = null;

	 public static final String DIR = "F:/codejam/question1/";

	 private String filename = DIR + "A-small-attempt0.in";
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		Experiment fullExperiment = new Experiment();
		fullExperiment.begin();
	}
	
	private void begin(){
		readInput();
		solve();
		writeToFile();
	}
	
	public void solve() {
		Event eventRound = null;
		for (int i = 0; i < events.size(); i++) {
			System.out.println("Solving "+(i+1));
			eventRound = events.get(i);
			eventRound.finalState = solve(eventRound.n, eventRound.k);
		}
	}
	
	private void writeToFile() {
		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(DIR
					+ "output.txt"));

			Event eventRound = null;
			for (int i = 0; i < events.size()-1; i++) {
				eventRound = events.get(i);
				out.write("Case #"+(i+1)+": "+(eventRound.finalState?"ON":"OFF")+System.getProperty("line.separator"));
			}
			out.write("Case #"+(events.size())+": "+(events.get(events.size()-1).finalState?"ON":"OFF"));
			out.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	
	public void readInput() {
		FileRead read = new FileRead(filename);
		events = read.getEvents();
	}
	
	public void printInput() {
		Event eventRound = null;
		for (int i = 0; i < events.size(); i++) {
			eventRound = events.get(i);
			System.out.println(eventRound.n+" "+eventRound.k);
		}
	}
	
	private boolean solve(int n, int k){
		return  ((k+1) % (int)Math.pow(2, n) == 0);
	}
	
}
