package date_04_07;

import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class ProblemC_2 {
    public static void main(String[] args)
    {
        final Scanner scan = new Scanner(System.in);
        final int numInputs = scan.nextInt();
        final StringBuilder sb = new StringBuilder();
        
        for (int i = 0; i != numInputs; ++i)
        {
            sb.append("Case #" + (i + 1) + ": ");
            final long numStalls = scan.nextLong();
            long numPeople = scan.nextLong();
            final TreeMap<Long, Long> rangeToFrequency = new TreeMap<>();
            rangeToFrequency.put(numStalls, 1L);
            // While there are ranges to explore
            while (!rangeToFrequency.isEmpty())
            {
                // The maximum range is considered next
                final Map.Entry<Long, Long> rangeEntry = rangeToFrequency.lastEntry();
                // We process this range and remove it
                rangeToFrequency.remove(rangeEntry.getKey());
                // Remove the appropiate number of people that fall in this range
                numPeople -= rangeEntry.getValue();
                // If we ran out of people in this range
                if (numPeople <= 0)
                {
                    // Print the number of stalls to the right, then left
                    if (rangeEntry.getKey() % 2 == 0)
                    {
                        sb.append(rangeEntry.getKey() / 2)
                            .append(' ')
                            .append(rangeEntry.getKey() / 2 - 1)
                            .append('\n');
                    }
                    else
                    {
                        sb.append(rangeEntry.getKey() / 2)
                            .append(' ')
                            .append(rangeEntry.getKey() / 2)
                            .append('\n');
                    }
                    break;
                }
                // If the range is odd, we add two of the same ranges
                if (rangeEntry.getKey() % 2 == 1)
                {
                    final long halfRange = rangeEntry.getKey() / 2;
                    if (!rangeToFrequency.containsKey(halfRange))
                    {
                        rangeToFrequency.put(halfRange, 0L);
                    }
                    rangeToFrequency.put(
                        halfRange,
                        rangeToFrequency.get(halfRange) + rangeEntry.getValue() * 2);
                }
                else
                {
                    final long halfRangeA = rangeEntry.getKey() / 2;
                    final long halfRangeB = rangeEntry.getKey() / 2 - 1;
                    if (!rangeToFrequency.containsKey(halfRangeA))
                    {
                        rangeToFrequency.put(halfRangeA, 0L);
                    }
                    if (!rangeToFrequency.containsKey(halfRangeB))
                    {
                        rangeToFrequency.put(halfRangeB, 0L);
                    }
                    rangeToFrequency.put(
                        halfRangeA,
                        rangeToFrequency.get(halfRangeA) + rangeEntry.getValue());
                    rangeToFrequency.put(
                        halfRangeB,
                        rangeToFrequency.get(halfRangeB) + rangeEntry.getValue());
                }
            }
        }
        scan.close();
        System.out.println(sb.toString());
    }
}
