package gcj15qual_b;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.LinkedList;

public class User {
	
	private static final String FILENAME = "C-small-attempt0.in";
	private static final String OUTFILENAME = FILENAME.substring(0,FILENAME.lastIndexOf("."))+".out";
	public static String newline = System.getProperty("line.separator");
	
	private static PrintWriter out;
	private static BufferedReader input;
	
	private static HashMap<String, Integer> dAxis = new HashMap<String, Integer>();
	static{
		dAxis.put("1", 0);
		dAxis.put("i", 1);
		dAxis.put("j", 2);
		dAxis.put("k", 3);
	}
	
	private static String[][] dTable = 
		{{"1", "i", "j", "k"},
		{"i", "-1", "k", "-j"},
		{"j", "-k", "-1", "i"},
		{"k", "j", "-i", "-1"}};

	public static void main(String[] args) throws IOException {
		setupIO();
		
		int T = Integer.parseInt(input.readLine());
		
		for (int t=1; t<=T; t++){
			Object result = doTest(t);
			out.println("Case #" + t + ": " +result);
			System.out.println("Case #" + t + ": " +result);
		}
		out.close();

	}

	private static String doTest(int t) throws IOException {
		String line = input.readLine();
		String[] vals = line.split(" ");
		int L = Integer.parseInt(vals[0]);
		int X = Integer.parseInt(vals[1]);
		String base = input.readLine();
		if (L==1) return "NO";
		char[] chars = base.toCharArray();
		
		LinkedList<String> phrase = new LinkedList<String>();
		for (int i = 0; i<X; i++){
			for (int j = 0; j<L; j++){
				phrase.add(String.valueOf(chars[j]));
			}
		}
		
		if (recurse(phrase, "i")){
			return "YES";
		}
		else return "NO";
		
	}
	
	private static boolean recurse(LinkedList<String> phrase, String goal) {
		if (phrase.isEmpty()){
			return false;
		}
		boolean solved = false;
		while(!solved){
			if ("k".equals(goal)){
				while(true){
					String a = phrase.pop();
					if (phrase.isEmpty() && goal.equals(a)){
						return true;
					}
					else if (phrase.isEmpty()){
						return false;
					}
					else {
						String b = phrase.pop();
						phrase.push(multiply(a, b));
					}
				}
			}
			else {
				String nextGoal = null;
				if ("i".equals(goal)) nextGoal = "j";
				else if ("j".equals(goal)) nextGoal = "k";
				while(true){
					String a = phrase.pop();
					if (goal.equals(a)){
						return recurse((LinkedList<String>) phrase.clone(), nextGoal);
					}
					else if (phrase.isEmpty()){
						return false;
					}
					else {
						String b = phrase.pop();
						phrase.push(multiply(a, b));
					}
				}
			}
			
		}
		return false;
	}

	private static String multiply(String a, String b){
		boolean addNeg = false;
		if (a.startsWith("-") && b.startsWith("-")){
			a = a.substring(1);
			b = b.substring(1);
		}
		else if (a.startsWith("-")){
			a = a.substring(1);
			addNeg = true;
		}
		else if (b.startsWith("-")){
			b = b.substring(1);
			addNeg = true;
		}
		String result = dTable[dAxis.get(a)][dAxis.get(b)];
		if (result.startsWith("-") && addNeg){
			return result.substring(1);
		}
		return (addNeg ? "-" : "") + result;
	}

	private static void setupIO() throws IOException{
		out = new PrintWriter(new FileWriter(OUTFILENAME));
		//	PrintStream out = System.out;
			
			FileReader fr = null;
			try {
				fr = new FileReader(FILENAME);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
			input = new BufferedReader(fr);
	}

}
