import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;


public class User {
	
	static String OUTFILENAME = "out.txt";
	static String FILENAME = "A-large.in";
	
	public static void main(String[] args) throws Exception {
		
		PrintWriter pw = new PrintWriter(new FileWriter(OUTFILENAME));
		
		//initializing file reader
		FileReader fr = null;
		try {
			fr = new FileReader(FILENAME);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		BufferedReader input = new BufferedReader(fr);
		
		int L; //word length 
		int D; //dictionary 
		int N; //number of test cases
		char [][] dictionary; //will store the requests as an array of integers
		StringTokenizer line;
		String inputLine;
		
		//read each line
		inputLine = input.readLine();
		line = new StringTokenizer(inputLine, " ");
		L = Integer.parseInt(line.nextToken());
		D = Integer.parseInt(line.nextToken());
		N = Integer.parseInt(line.nextToken());
		
		dictionary = new char[D][L];
		
		//Input Test
		
	   for (int i=0; i<D; i++){
			dictionary[i] = input.readLine().toCharArray();			
		}
	/*	
		for (int i=0; i<D; i++){
			for (int j=0; j<L; j++){
				System.out.print(dictionary[i][j]);
			}
			System.out.println();
		}
		
	 */

	   for (int i=0; i<N; i++){
		   pw.println("Case #" + (i+1) +
				   ": " + wordHit(input.readLine().toCharArray(), dictionary));
		   

	   }
	   pw.close();
	   
		
	}

	private static int wordHit(char[] charArray, char[][] dictionary) {
		// TODO Auto-generated method stub
		int count = 0;
		
		for (int i = 0; i<dictionary.length; i++){
		//	printArray(dictionary[i]);
		//	printArray(charArray);
			if (tryThis(dictionary[i], charArray)) count++;
			
		}
		
		return count;
		
	}
	
	private static boolean tryThis (char[] dictWord, char[] newWord){
	//	System.out.println(dictWord.length);
	
		LinkedList [] letterOptions = new LinkedList [dictWord.length];
		
		for ( int i = 0; i < dictWord.length; i++ ) {
			letterOptions[i] = new LinkedList();
			}
		
		int letterCount = 0;
		boolean inPar = false;
		
		for (int i=0; i<newWord.length; i++){
			if (!inPar && newWord[i]!='(')
			{
				letterOptions[letterCount].add(newWord[i]);
				letterCount++;
				continue;
			}
			else if (!inPar && newWord[i]=='('){
				inPar = true;
			}
			else if (inPar && newWord[i]!=')'){
				//System.out.println(newWord[i]);
				//System.out.println(letterCount);
				letterOptions[letterCount].push(newWord[i]);
			}
			else if (inPar && newWord[i]==')'){
				inPar = false;
				letterCount++;
			}
		}
		
		for (int i=0; i<dictWord.length; i++){
			if (!letterOptions[i].contains(dictWord[i])) return false;
		}
		
		return true;	

	}
	
	private static void printArray(char[] m){
		for (int i=0; i<m.length; i++){
				System.out.print(m[i]);
		}
		System.out.println();
	}
	

	



}
