
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

import java.io.PrintStream;


import java.util.HashSet;

import java.util.Scanner;


public class User {

	public enum Direction {
		UP,
		DOWN
	}

	private static final String FILENAME = "B-large.in";
	
	
	public static void main(String[] args) {
		
		String OUTFILENAME = FILENAME + ".out";
		
		File inFile = new File (FILENAME);
		
		
		//PrintStream out;
		PrintWriter out = null;
		try {
			out = new PrintWriter(new FileWriter(OUTFILENAME));
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		//out = System.out;

		
		
		Scanner fileInput = null;
		
		try {
			fileInput = new Scanner(inFile);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		int T = fileInput.nextInt();
		
		for (int i=0; i<T; i++){
			int N = fileInput.nextInt();
			int M = fileInput.nextInt();
			
			int[][] lawn = new int[N][M];
			
			for (int n = 0 ; n<lawn.length; n++){
				for (int m=0; m<lawn[0].length; m++){
					lawn[n][m] = fileInput.nextInt();
				}
			}
					
			boolean isPossible = true;
			
			
			int l=1;
			while (isPossible && l<=100){
				isPossible = testLevel (l++, lawn);
				growLawn(lawn, l);
			}
			
			out.print("Case #" + (i+1) + ": ");
			if (isPossible) out.print("YES\n");
			else out.print("NO\n");

		}
		out.close();


	}

	private static void growLawn(int[][] lawn, int l) {
		for (int n = 0 ; n<lawn.length; n++){
			for (int m=0; m<lawn[0].length; m++){
				if (lawn[n][m]==l) lawn[n][m] = l+1;
			}
		}
		
	}

	private static boolean testLevel(int l, int[][] lawn) {
		HashSet<Integer> rowsTested = new HashSet<Integer>();
		HashSet<Integer> colsTested = new HashSet<Integer>();
		boolean result = true;
		
		for (int n = 0 ; n<lawn.length; n++){
			for (int m=0; m<lawn[0].length; m++){
				if (lawn[n][m]==l){ 
					//System.out.println("Testing "+n+";"+m);
					result = testPoint(lawn, n, m, rowsTested, colsTested);
					if (!result) return false;
				
				}
			}
		}
		return true;
	}

	private static boolean testPoint(int[][] lawn, int n, int m,
			HashSet<Integer> rowsTested, HashSet<Integer> colsTested) {
		if (rowsTested.contains(n) || colsTested.contains(m))
			return true;
		else 
		{
			return (testRow(lawn, n, rowsTested) || testCol(lawn, m, colsTested));
		}
	}

	private static boolean testCol(int[][] lawn, int m,
			HashSet<Integer> colsTested) {
		
		int level = lawn[0][m];
		for (int i=1; i<lawn.length;i++)
			if (lawn[i][m]!=level) return false;
		
		colsTested.add(m);
		return true;
	}

	private static boolean testRow(int[][] lawn, int n,
			HashSet<Integer> rowsTested) {

		int level = lawn[n][0];
		for (int i=1; i<lawn[0].length;i++)
			if (lawn[n][i]!=level) return false;
		
		rowsTested.add(n);
		return true;
	}
}
