import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Queue;
import java.util.StringTokenizer;




public class User {
	
	static String OUTFILENAME = "out.txt";
	static String FILENAME = "B-small-attempt0.in";
	static PrintWriter pw;
	
	public static void main(String[] args) throws Exception {
		
		 pw = new PrintWriter(new FileWriter(OUTFILENAME));
		
		//initializing file reader
		FileReader fr = null;
		try {
			fr = new FileReader(FILENAME);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		BufferedReader input = new BufferedReader(fr);
		
		int T; //number of maps 

		StringTokenizer line;
		String inputLine;
		
		//read each line
		inputLine = input.readLine();
		line = new StringTokenizer(inputLine, " ");
		T = Integer.parseInt(line.nextToken());

		//Input Test
		
	   for (int i=0; i<T; i++){
		   int R; //rows
		   int C; //cols
		   
			inputLine = input.readLine();
			line = new StringTokenizer(inputLine, " ");
			R = Integer.parseInt(line.nextToken());
			C = Integer.parseInt(line.nextToken());
			pw.println("Case #"+ (i+1) +":");
			processMap (R, C, input);
			
		}
	   pw.close();

		
	}

	private static void processMap(int r, int c, BufferedReader input) throws IOException {
		// TODO Auto-generated method stub
		
		int [][] map = new int [r][c];
		int [][][] sinkmap = new int [r][c][2];
		char [][] shedmap = new char[r][c];
		int [] foundSink;
		StringTokenizer line;
		String inputLine;
		
		for (int i=0; i<r; i++){
			inputLine = input.readLine();
			line = new StringTokenizer(inputLine, " ");
			for (int j=0; j<c; j++){
				map [i][j] = Integer.parseInt(line.nextToken());
			}
		}
			
		LinkedList <int[]> sinkList = new LinkedList<int[]>();

		// place sinks on sinkmap
		for (int i=0; i<r; i++){
			for (int j=0; j<c; j++){
				foundSink = findSink(i, j, map);
				if (!doesListHave(sinkList, foundSink)){
					sinkList.add(foundSink);
				//	pw.println("new sink");
					
				}
				sinkmap[i][j] = foundSink;


			}
		}
		
		//generate sink names

		
		int [] currentCord = null;
		int sinkTypes = sinkList.size();
		for (int k=0; k<sinkTypes; k++){
			currentCord = (int[]) sinkList.poll();

			
			for (int i=0; i<r; i++){
				for (int j=0; j<c; j++){
					
					if (sinkmap[i][j][0] == currentCord[0] &&
							sinkmap[i][j][1] == currentCord[1]){
									shedmap[i][j] = (char)((int)k + 97);
					}
				}
			
			}
		}
		printMap(shedmap);
		

		
	}

	
	private static boolean doesListHave(LinkedList sinkList, int[] foundSink) {
		int [] tempCoord = {0,0};
		for (int i=0; i<sinkList.size(); i++){
			tempCoord = (int[]) sinkList.get(i);
			if (tempCoord[0] == foundSink[0] &&
				tempCoord[1] == foundSink[1])
				return true;
			
		}
		
		return false;
	}

	private static int[] findSink(int r, int c, int[][] map) {
		// TODO Auto-generated method stub
		boolean foundSink = false;
	//	pw.println("looking at " + r+  " " + c);
		
		char downward;
		int lowest;
		
		while (!foundSink){
			downward = 'o';
			lowest = 20000;
			
			//look north
			if (r!=0){
					if (map[r-1][c] < map[r][c]){
						downward = 'n';
						lowest = map[r-1][c];
						//r = r-1;
					}
			}
			//look west
			 if (c!=0){
				if (map[r][c-1] < map[r][c]){
					if (map[r][c-1] <lowest){
						downward = 'w';
						lowest = map[r][c-1];
					}
					//c = c-1;
				}
			}
			//look east
			 if (c!=map[r].length-1){
				if (map[r][c+1] < map[r][c]){
					if (map[r][c+1] <lowest){
						downward = 'e';
						lowest = map[r][c+1];
					}
					//c = c+1;

				}
				
			}
			//look south
			 if (r!=map.length-1){
				if (map[r+1][c] < map[r][c]){
					if (map[r+1][c] <lowest){
						downward = 's';
						lowest = map[r+1][c];
					}
				}
			}
			switch(downward){
			case 'n':
				r = r-1; 
		//		pw.println("n");
				break;
			case 'w':
				c = c-1;
			//	pw.println("w");
				break;
			case 'e':
				c = c+1;
			//	pw.println("e");
				break;
			case 's':
				r = r+1;
			//	pw.println("s");
				break;
			default:
				foundSink = true;
				
			}
		}

			 
			
			

			
		int [] sink = {r, c};
	//	pw.println(r + " " + c);
		return sink;
	}

	private static void printMap(char[][] shedmap){
		for (int i=0; i<shedmap.length; i++){
			for (int j=0; j<shedmap[i].length; j++)
				pw.print(shedmap[i][j] + " ");
			pw.println();
		}
	}
	

	



}
