import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.InputStreamReader;
import java.io.PrintStream;


public class ProblemSolver {
	
	public static BufferedReader rdr = new BufferedReader(new InputStreamReader(System.in));
	public static PrintStream out = System.out;
	
	public static void Solve_StandingOvation()
	{
		int cases = readLineInt(rdr);
		for(int i = 0; i < cases; i++)
		{
			try {
				String[] line = rdr.readLine().split(" ");
				int T = Integer.parseInt(line[0]);
				String S = line[1];
				out.print("Case #" + (i + 1) + ": ");
				int needs = -1;
				try {
					needs = Solve_StandingOvation(T,S);
				} catch(Exception e2) { }
				out.println(needs);
			} catch(Exception e) { System.err.println(e.toString()); }
		}
	}
	
	public static int Solve_StandingOvation(int T, String S)
	{
		int needs = 0;
		int has = Integer.parseInt(S.substring(0,1));
		for(int i = 1; i < Math.min(T+1,S.length()); i++)
		{
			String c = S.substring(i, i + 1);
			int p = Integer.parseInt(c);
			if(i > has)
			{
				int more = i - has;
				needs += more;
				has += more;
			}
			has += p;
		}
		return needs;
	}
	
	public static int readLineInt(BufferedReader rdr)
	{
		int ret = 0;
		try {
			ret = Integer.parseInt(rdr.readLine());
		} catch(Exception e) { }
		return ret;
	}

	/**
	 * @param args
	 */
	public static void main(String[] args) {

		int num = 0;
		if(args.length >= 1)
		{
			try {
				num = Integer.parseInt(args[0]);
			} catch(Exception e) { }
			if(args.length >= 3) {
				try {
					rdr = new BufferedReader(new FileReader(new File(args[1])));
					out = new PrintStream(new File(args[2]));
				} catch (FileNotFoundException e) {
					System.err.println(e.toString());
					e.printStackTrace();
				}
			}
			if(num > 5 || num <= 0) throw new IndexOutOfBoundsException();
			SolveProblemX(num);
			return;
		}
		System.out.println("Enter Puzzle (1-5):");
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
			String text = in.readLine();
			num = Integer.parseInt(text);
			if(num > 5 || num < 0) throw new IndexOutOfBoundsException();
			SolveProblemX(num);
		} catch(Exception e) { }
	}
	
	public static void SolveProblemX(int x)
	{
		switch(x)
		{
		case 1:
			System.out.println("Standing Ovation...");
			Solve_StandingOvation();
			break;
		}
	}

}
