package org.brandroid.codejam.problems;

import java.util.Arrays;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import org.brandroid.codejam.CodeJam;
import org.brandroid.codejam.CodeJamProblem;

public class _2012_R1A3 extends CodeJamProblem {

	@Override
	public void run() {

		int T = in.readInt();
		for(int i = 0; i < T; i++)
		{
			printLine("Case #" + (i + 1) + ": " + solve());
		}
		if(mListener != null)
			mListener.OnFinished();
	}
	
	private String solve()
	{
		int N = in.readInt();
		int M = in.readInt();
		LinkedList<Pair> box = new LinkedList<_2012_R1A3.Pair>();
		LinkedList<Pair> toy = new LinkedList<_2012_R1A3.Pair>();
		//Pair[] toy = new Pair[M];
		for(int i = 0; i < N; i++)
			box.add(new Pair(in.readLong(), in.readLong()));
			//box[i] = new Pair(in.readInt(), in.readInt());
		for(int i = 0; i < M; i++)
			toy.add(new Pair(in.readLong(), in.readLong()));
			//toy[i] = new Pair(in.readInt(), in.readInt());
		
		purgeLoners(box, toy);
		
		return "" + solve(box, toy);
	}
	
	private void purgeLoners(LinkedList<Pair> box, LinkedList<Pair> toy)
	{
		for(int i = box.size() - 1; i >= 0; i--)
			if(!toy.contains(box.get(i)))
				box.remove(i);
		for(int j = toy.size() - 1; j >= 0; j--)
			if(!box.contains(toy.get(j)))
				toy.remove(j);
	}
	
	private long solve(LinkedList<Pair> box, LinkedList<Pair> toy)
	{
		long ret = 0;
		if(box.size() == 0 || toy.size() == 0) return 0;
		// D:\Projects\CodeJam\C-small-attempt0.in
		if(box.peek().Count <= 0)
		{
			box.pop();
			return solve(box, toy);
		}
		if(toy.peek().Count <= 0)
		{
			toy.pop();
			return solve(box, toy);
		}
		Pair b = box.pop();
		Pair t = toy.pop();
		if(b.equals(t))
		{
			ret = Math.min(b.Count, t.Count);
			b.Count -= ret;
			t.Count -= ret;
			box.addFirst(b);
			toy.addFirst(t);
			return ret + solve(box, toy);
		}
		LinkedList<Pair> box2 = clone(box);
		LinkedList<Pair> toy2 = clone(toy);
		LinkedList<Pair> box3 = clone(box);
		LinkedList<Pair> toy3 = clone(toy);
		box2.addFirst(b);
		toy2.addFirst(t);
		return Math.max(solve(box2, toy3), solve(box3, toy2));
	}
	
	public LinkedList<Pair> clone(LinkedList<Pair> list)
	{
		LinkedList<Pair> ret = new LinkedList<_2012_R1A3.Pair>();
		for(int i = 0; i < list.size(); i++)
			ret.add(list.get(i).clone());
		return ret;
	}
	
	public static class Pair
	{
		public long Count;
		public long Type;
		public Pair(long cnt, long type)
		{
			Count = cnt;
			Type = type;
		}
		public Pair clone()
		{
			return new Pair(Count, Type);
		}
		@Override
		public String toString() {
			return Count + "x" + Type;
		}
		@Override
		public boolean equals(Object obj) {
			return Type == ((Pair)obj).Type;
		}
	}

	@Override
	public String getTitle() {
		return "2012 1(3)C - Box Factory";
	}

}
