package org.brandroid.codejam.problems;

import java.util.Arrays;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

import org.brandroid.codejam.CodeJam;
import org.brandroid.codejam.CodeJamProblem;
import org.brandroid.codejam.InputReader;

public class _2012_R1A3 extends CodeJamProblem {

	@Override
	public void run() {

		int T = in.readInt();
		for(int i = 0; i < T; i++)
		{
			printLine("Case #" + (i + 1) + ": " + solve());
		}
		if(mListener != null)
			mListener.OnFinished();
	}
	
	private String solve()
	{
		//D:\Projects\CodeJam\A-small-attempt0.in
		
		int N = in.readInt();
		MyClass[] n = new MyClass[N];
		for(int i = 0; i < N; i++)
		{
			n[i] = new MyClass(in);
		}
		
		Arrays.sort(n, new Comparator<MyClass>() {
			@Override
			public int compare(MyClass o1, MyClass o2) {
				if(o1.inheritance.length == o2.inheritance.length)
					return 0;
				return o2.inheritance.length > o1.inheritance.length ? 1 : -1;
			}
		});
		
		for(int i = 0; i < n.length; i++)
		{
			int inh = findInheritables(n[i], Arrays.copyOfRange(n, 1, n.length));
			//printLine("Inheritables(" + i + "): " + inh);
			if(inh > 2)
				return "Yes";
		}
		return "No";
	}
	
	private int findInheritables(MyClass top, MyClass[] others)
	{
		int ret = 0;
		for(int i = 0; i < others.length; i++)
			if(!top.conflicts(others[i]))
			{
				if(i < others.length - 1)
					return 1 + findInheritables(others[i], Arrays.copyOfRange(others, i + 1, others.length));
				else return 1;
					//else return 0; //others[others.length - 1].inheritance.length == 0 ? 1 : 0;
				//} //else return 2;
			}
		return ret;
	}
	
	public static class MyClass
	{
		public final int[] inheritance;
		public MyClass(InputReader rdr)
		{
			inheritance = new int[rdr.readInt()];
			for(int i = 0; i < inheritance.length; i++)
				inheritance[i] = rdr.readInt();
			Arrays.sort(inheritance);
		}
		public boolean conflicts(MyClass other)
		{
			if(inheritance.length == other.inheritance.length) return true;
			for(int i = 0; i < inheritance.length; i++)
				for(int j = 0; j < other.inheritance.length; j++)
					if(inheritance[i] != other.inheritance[j])
						return false;
			return false;
		}
	}
	
	@Override
	public String getTitle() {
		return "2012 1(3)A - Diamond Inheritance";
	}

}
