import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.net.URISyntaxException;


public class Main {
    static BufferedReader in;
    static PrintWriter out;

    public static void main(String[] args) throws IOException, URISyntaxException {
        in = new BufferedReader(new FileReader("D-large.in"));
        out = new PrintWriter("output.txt", "UTF-8");
        int X=0, R=0, C=0;

        int testCases = Integer.parseInt(in.readLine());
        for(int curCase=0; curCase<testCases; curCase++){
            boolean GWins = false;
            String[] parsedString = in.readLine().split(" ");
            X=Integer.parseInt(parsedString[0]);
            R=Integer.parseInt(parsedString[1]);
            C=Integer.parseInt(parsedString[2]);

            //if the grid can't be evenly divided into domino sized pieces,
            //gabriel can't win
            if(R*C%X!=0)
                GWins = false;
            //both dimensions must be greater than X/2
            //otherwise Rich will be able to
            //use a zig zag to block off an unreachable section
            else if(X!=2&&(2*R<=X || 2*C<=X))
                GWins = false;
            //at least one dimension must be as long as X
            //otherwise rich will be able to choose a domino
            //with length X
            else if(R<X & C<X)
                GWins = false;
            else
                GWins = true;


            out.print("Case #");
            out.print(curCase + 1);
            out.print(": ");
            if(GWins)
                out.println("GABRIEL");
            else
                out.println("RICHARD");
        }
        out.close();
    }
}
