package Jamcoins;

import java.util.Arrays;
import java.util.Optional;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.atomic.AtomicInteger;

public class ThreadCoinsExplorer extends Thread {
    public static AtomicInteger index;
    public static int goal;
    public static int digitsNumber;
    public static ConcurrentHashMap<Integer, String> map ;
    private int start;
    private int end;

    public ThreadCoinsExplorer(int s, int e)
    {
        start = s;
        end = e;
        if(map == null)
        {
            map = new ConcurrentHashMap<Integer, String>(){{
                put(0, "");
                put(1, "");
                put(2, "");
                put(3, "");
                put(4, "");
                put(5, "");
                put(6, "");
                put(7, "");
                put(8, "");
                put(9, "");
            }};
        }
    }

    public static void setIndex(final int n)
    {
        index = new AtomicInteger(n);
    }


    public void run()
    {
        for (int i = start; i< end; i++) {
            String genDigits = Integer.toBinaryString(i); //0 -> 0
            Optional.of("1" + repeat('0', digitsNumber-2 - genDigits.length()) + genDigits + "1")
                    .filter(s -> !isPrimeInAny(s))
                    .ifPresent(s -> {
                        if(index.get()<goal) {
                            map.put(index.getAndIncrement() ,s + " " + allNonTrivialDivisors(s).trim());
                        }
                    });
            if(index.get()==goal) {
                break;
            }
        }
    }


    public static boolean isPrimeInAny(final String s) {
        for (int i = 2; i < 11; i++) {
            if (isPrime(Long.parseLong(s, i)))
                return true;
        }
        return false;
    }

    public static String repeat(final char c,final  int count)
    {
        char[] chars = new char[count];
        Arrays.fill(chars, c);
        return new String(chars);
    }

    static boolean isPrime(final long n) {
        if (n%2==0) return false;

        for(long i=3;i*i<=n;i+=2) {
            if(n%i==0)
                return false;
        }
        return true;
    }

    public static long nonTrivialDivisor(final long n)
    {
        if(n%2==0)
            return 2;
        for(long i = 3; i< n; i+=2)
        {
            if((n/i) * i == n) {
                return i;
            }
        }
        return -1;
    }

    public static String allNonTrivialDivisors(final String numb) {

        final StringBuilder sb = new StringBuilder();
        for(int i=2; i<11; i++)
        {
            sb.append(nonTrivialDivisor(Long.parseLong(numb, i))+ " ");
        }
        return sb.toString();
    }


}