import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.BufferedWriter;
import java.io.Writer;
import java.io.OutputStreamWriter;
import java.util.InputMismatchException;
import java.io.IOException;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Rinor
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified()) {
                    toRun = candidate;
                }
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        InputReader in = new InputReader(inputStream);
        OutputWriter out = new OutputWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++) {
            solver.solve(i, in, out);
        }
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, InputReader in, OutputWriter out) {
            int startChar = 65;
//        HashMap<Character, Integer> polMap = new HashMap<>();
            int nParties = in.readInt();
            int[] polit = new int[nParties];

            int total = 0;
            for (int i = 0; i < nParties; i++) {
                polit[i] = in.readInt();
                total += polit[i];
            }

            out.print("Case #" + testNumber + ": " + ejaculate(polit, total).trim() + "\n");


        }

        private String ejaculate(int[] polit, int total) {
            StringBuilder sb = new StringBuilder();
            while (total != 0) {
//            System.out.println("while loop-"+ total);
                int max = 0;
                int indexOfMax = -1;

        /*----*/
                int max2 = 0;
                int indexOfMax2 = -1;
                for (int i = 0; i < polit.length; i++) {
                    if (max < polit[i]) {
                        max = polit[i];
                        indexOfMax = i;
                    }
//                System.out.println("First loop");
                }
                polit[indexOfMax]--;
                total--;
                if (titlsTheBalance(polit, total)) {
                    for (int i = 0; i < polit.length; i++) {
                        if (max2 < polit[i]) {
                            max2 = polit[i];
                            indexOfMax2 = i;
                        }
//                    System.out.println("second loop");
                    }
                    polit[indexOfMax2]--;
                    total--;
                    if (titlsTheBalance(polit, total)) {
                        polit[indexOfMax]++;
                        polit[indexOfMax2]++;
                        total += 2;
                        indexOfMax = -1;
                        indexOfMax2 = -1;
                    }
                }
                if (indexOfMax != -1) {
                    sb.append(" " + (char) (indexOfMax + 65) + (indexOfMax2 != -1 ? (char) (indexOfMax2 + 65) : ""));
                }

            }
            return sb.toString();
        }

        public static boolean titlsTheBalance(int[] polit, int total) {
            for (int i = 0; i < polit.length; i++) {
//            System.out.println("third loop n method");
                if (((double) polit[i] * 100) / total > 50) {
                    return true;
                }
            }
            return false;
        }

    }

    static class InputReader {
        private InputStream stream;
        private byte[] buf = new byte[1024];
        private int curChar;
        private int numChars;
        private InputReader.SpaceCharFilter filter;

        public InputReader(InputStream stream) {
            this.stream = stream;
        }

        public int read() {
            if (numChars == -1) {
                throw new InputMismatchException();
            }
            if (curChar >= numChars) {
                curChar = 0;
                try {
                    numChars = stream.read(buf);
                } catch (IOException e) {
                    throw new InputMismatchException();
                }
                if (numChars <= 0) {
                    return -1;
                }
            }
            return buf[curChar++];
        }

        public int readInt() {
            int c = read();
            while (isSpaceChar(c)) {
                c = read();
            }
            int sgn = 1;
            if (c == '-') {
                sgn = -1;
                c = read();
            }
            int res = 0;
            do {
                if (c < '0' || c > '9') {
                    throw new InputMismatchException();
                }
                res *= 10;
                res += c - '0';
                c = read();
            } while (!isSpaceChar(c));
            return res * sgn;
        }

        public String readString() {
            int c = read();
            while (isSpaceChar(c)) {
                c = read();
            }
            StringBuilder res = new StringBuilder();
            do {
                if (Character.isValidCodePoint(c)) {
                    res.appendCodePoint(c);
                }
                c = read();
            } while (!isSpaceChar(c));
            return res.toString();
        }

        public boolean isSpaceChar(int c) {
            if (filter != null) {
                return filter.isSpaceChar(c);
            }
            return isWhitespace(c);
        }

        public static boolean isWhitespace(int c) {
            return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
        }

        public String next() {
            return readString();
        }

        public interface SpaceCharFilter {
            public boolean isSpaceChar(int ch);

        }

    }

    static class OutputWriter {
        private final PrintWriter writer;

        public OutputWriter(OutputStream outputStream) {
            writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
        }

        public OutputWriter(Writer writer) {
            this.writer = new PrintWriter(writer);
        }

        public void print(Object... objects) {
            for (int i = 0; i < objects.length; i++) {
                if (i != 0) {
                    writer.print(' ');
                }
                writer.print(objects[i]);
            }
        }

        public void close() {
            writer.close();
        }

    }
}

