import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;


public class Solver {
	public static void main(String[] args) throws IOException{
		if(args.length > 0){
			File file = new File(args[0]);
			Scanner scanner = new Scanner(file);
			String topLine = scanner.nextLine();
			FileWriter fstream = new FileWriter(args[0] + ".out");
			BufferedWriter out = new BufferedWriter(fstream);

			int numberOfTestCases = Integer.parseInt(topLine);
			for(int i = 0; i < numberOfTestCases; i++){
				int moveCount = -1;
				int numberOfWords = Integer.parseInt(scanner.nextLine());
				List<String> words = new ArrayList<String>();

				Map<String, Integer> letters = new HashMap<String, Integer>();
				for(int j = 0; j < numberOfWords; j++){
					Set<String> charsInWord = new HashSet<String>();
					//Check if there is a letter in one word thats not in the others
					String word = scanner.nextLine();
					for(char c : word.toCharArray()){
						if(letters.containsKey(c+"") && !charsInWord.contains(c+"")){
							letters.put(c + "", letters.get(c+"") + 1);
							charsInWord.add(c + "");
						}else if(!charsInWord.contains(c+"")){
							letters.put(c + "", 1);
							charsInWord.add(c + "");
						}
					}
					words.add(word);
				}

				for(String key : letters.keySet()){
					if(letters.get(key) != numberOfWords){
						System.out.println("Letter " + key + " in one word but not other");
						moveCount = -1;
						break;
					}else{
						moveCount = 0;
					}
				}

				if(moveCount != -1){
					boolean allEqual = true;
					for(int j = 1; j < words.size(); j++){
						if(!words.get(j).equals(words.get(j-1))){
							allEqual = false;
							break;
						}
					}
					if(allEqual){
						moveCount = 0;
					}else{
						moveCount = 1;
					}
				}

				if(moveCount == 1){
					moveCount = 0;
					List<String> simpleWords = new ArrayList<String>();
					List<ArrayList<Integer>> simpleWordsCharCount = new ArrayList<ArrayList<Integer>>();

					for(int in = 0; in < words.size(); in++){//String word : words){
						String w = "";
						char prev = ' ';
						int prevCount = 0;
						int charCount = -1;
						ArrayList<Integer> charsInWord = new ArrayList<Integer>();
						for(int c  = 0; c < words.get(in).toCharArray().length; c++){//: word.toCharArray()){
							char cc = words.get(in).toCharArray()[c];
							if(cc != prev){
								w += cc;
								prev = cc;
								prevCount = 1;
								charCount++;
							}else{
								prevCount++;
							}
							if(!charsInWord.isEmpty() && charCount < charsInWord.size()){
								charsInWord.remove(charCount);
							}
							charsInWord.add(charCount, prevCount);							
						}
						simpleWordsCharCount.add(charsInWord);
						System.out.println("New word " + w + " letter count " + Arrays.toString(charsInWord.toArray()));
						simpleWords.add(w);
					}

					boolean allEqual = true;
					for(int j = 1; j < simpleWords.size(); j++){
						if(!simpleWords.get(j).equals(simpleWords.get(j-1))){
							allEqual = false;
							break;
						}
					}
					if(allEqual){
						for(int id = 0; id < simpleWordsCharCount.get(0).size(); id++){
							int min = 0;
							int max = 0;
							for(List<Integer> nums : simpleWordsCharCount){
								int num = nums.get(id);
								if(num < min || min == 0){
									min = num;
								}
								if(num > max || max == 0){
									max = num;
								}
							}
							moveCount += max - min;
						}
					}else{
						moveCount =  -1;
					}



					//					int longestWord = 0;
					//					Collections.sort(words, new Comparator<String>() {
					//						@Override
					//						public int compare(String o1, String o2) {
					//							 return o1.length() < o2.length() ? -1
					//							         : o1.length() > o2.length() ? 1
					//							         : 0;
					//						}
					//					});	
					//					char[] longword = words.get(0).toCharArray();
					//					longestWord = longword.length;
					//					List<String> charLst = new ArrayList<String>();
					//					List<Integer> charLstCount = new ArrayList<Integer>();
					//					char current = ' ';
					//					for(int c = 0; c < longestWord; c++){
					//						if(longword.)
					//					}
				}

				System.out.println("Case #" + (i+1) + " of " + numberOfTestCases + " done");
				System.out.println("Case #" + (i+1) + ": " + (moveCount >= 0 ? moveCount : "Fegla Won" ) + "\n");
				out.write("Case #" + (i+1) + ": " + (moveCount >= 0 ? moveCount : "Fegla Won" ) + "\n");
			}
			out.flush();
			out.close();
			fstream.close();
			scanner.close();
			System.out.println("Done");

		}
		else{
			System.out.println("Please use file as arguement");
		}
	}
}
