import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class Solver {
	public static void main(String[] args) throws IOException{
		if(args.length > 0){
			File file = new File(args[0]);
			Scanner scanner = new Scanner(file);
			String topLine = scanner.nextLine();
			FileWriter fstream = new FileWriter(args[0] + ".out");
			BufferedWriter out = new BufferedWriter(fstream);

			int numberOfTestCases = Integer.parseInt(topLine);

			for(int i = 0; i < numberOfTestCases; i++){
				String result = "";

				int[][] grid = new int[4][4];

				for(int row = 0; row < 4; row++){
					topLine = scanner.nextLine();
					for(int col = 0; col < 4; col++){
						int temp = 0;
						switch(topLine.charAt(col)){
						case 'X':
							temp = 1;
							break;
						case 'O':
							temp = -1;
							break;
						case 'T':
							temp = 0;
							break;
						default:
							temp = 9;
							break;
						}
						grid[row][col] =temp; 
					}
				}

				boolean winner = false;
				for(int row = 0; row < 4; row++){
					int total = 0;
					for(int col = 0; col < 4; col++){
						total += grid[row][col];
					}
					if(total == 4 || total == 3){
						winner = true;
						result = "X won";
						break;
					}else if(total == -4 || total == -3){
						winner = true;
						result = "O won";
						break;
					}
				}
				for(int row = 0; row < 4; row++){
					int total = 0;
					for(int col = 0; col < 4; col++){
						total += grid[col][row];
					}
					if(total == 4 || total == 3){
						winner = true;
						result = "X won";
						break;
					}else if(total == -4 || total == -3){
						winner = true;
						result = "O won";
						break;
					}
				}
				if(!winner){
					int diag = grid[0][0] + grid[1][1] + grid[2][2] + grid[3][3];
					if(diag == 4 || diag == 3){
						winner = true;
						result = "X won";
					}else if(diag == -4 || diag == -3){
						winner = true;
						result = "O won";
					}
				}
				if(!winner){
					int diag = grid[0][3] + grid[1][2] + grid[2][1] + grid[3][0];
					if(diag == 4 || diag == 3){
						winner = true;
						result = "X won";
					}else if(diag == -4 || diag == -3){
						winner = true;
						result = "O won";
					}
				}
				
				if(!winner){
					//check for draw 
					for(int row = 0; row < 4; row++){
						for(int col = 0; col < 4; col++){
							if(grid[row][col] == 9){
								winner = true;
								result = "Game has not completed";
							}
						}
					}
				}
				if(!winner){
					result = "Draw";
				}

				out.write("Case #" + (i+1) + ": " + result + "\n");
				if(scanner.hasNext())
					scanner.nextLine();
			}

			out.flush();
			out.close();
			fstream.close();
			scanner.close();

		}
		else{
			System.out.println("Please use file as arguement");
		}
	}


}
