import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class Solver {
	public static void main(String[] args) throws IOException{
		if(args.length > 0){
			File file = new File(args[0]);
			Scanner scanner = new Scanner(file);
			String topLine = scanner.nextLine();
			FileWriter fstream = new FileWriter(args[0] + ".out");
			BufferedWriter out = new BufferedWriter(fstream);

			int numberOfTestCases = Integer.parseInt(topLine);

			for(int i = 0; i < numberOfTestCases; i++){
				String values = scanner.nextLine();
				String[] vals = values.split(" ");
				long count = allPalindromes(Long.parseLong(vals[0]), Long.parseLong(vals[1]));
				System.out.println(count);
				out.write("Case #" + (i+1) + ": " + count + "\n");
			}

			out.flush();
			out.close();
			fstream.close();
			scanner.close();

		}
		else{
			System.out.println("Please use file as arguement");
		}
	}
	
	static long getPalindrome(long number){
		String numberString = number + "";
		String newNum = "";
		for(int i = numberString.length() - 1; i > -1; i--){
			newNum += numberString.charAt(i);
		}
		long num = Long.parseLong(newNum);
		return num;
	}
	
	
	static long allPalindromes(long min, long max){
		//System.out.println(min + ":" + max);
		long count = 0;
		for(long i = min; i <= max; i++){
			if(i - getPalindrome(i) == 0){
				//System.out.println("Pal found " + i);
				double sqrt = Math.sqrt(i);
				if(sqrt % 1 == 0){
					long val = (long)sqrt;
					if(val - getPalindrome(val) == 0){
						count++;
						//System.out.println("Added " + (i*i));
					}
				}
			}
		}
		return count;
	}
}
