import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Iterator;




public class Translator {
	
	private static HashMap<Character, Character> dictionary;

	@SuppressWarnings("deprecation")
	private static void solveProblem() {
		// Stream to read file
		FileInputStream fin;
		// Stream to write file
		FileOutputStream fout;
	
		try
		{
		    // Open an input stream
		    // fin = new FileInputStream ("B-large.in");
			fin = new FileInputStream ("input.txt");
		    // Open an output stream
		    fout = new FileOutputStream ("output.txt");
		    // reader
		    DataInputStream reader = new DataInputStream(fin);
		    // writer
		    PrintStream writer = new PrintStream(fout);
		    
		    int numCases = Integer.parseInt(reader.readLine());
		    
		    String line = "";
		    for (int i = 1; i <= numCases; i++) 
		    {		    	
		    	line = "Case #" + i + ": " + solveCase(reader);
		    	writer.println(line);
		    	System.out.println(line);
			}		    
	
		    // Close our input stream
		    fin.close();
		    // Close our output stream
		    fout.close();
		}
		// Catches any error conditions
		catch (IOException e)
		{
			System.err.println ("Unable to read from file");
			System.exit(-1);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@SuppressWarnings("deprecation")
	public static String solveCase(DataInputStream reader) throws Exception, IOException
	{
		return translate(reader.readLine());
	}
	
	private static String translate(String input) 
	{
		String output = "";
		for (int i = 0; i < input.length(); i++)
			output += dictionary.get(input.charAt(i)) ;
		return output;
	}

	private static void createDictionary(ArrayList<String> inputs, ArrayList<String> outputs)
	{	
		dictionary = new HashMap<Character, Character>();
		for (char i = 'a'; i <= 'z'; i++)
			dictionary.put(i, '?') ;
		dictionary.put('z', 'q') ;dictionary.put('q', 'z') ;dictionary.put(' ', ' ') ;
		Iterator<String> outputIterator = outputs.iterator();
		for (String input : inputs) 
		{
			String output = (String) outputIterator.next();
			for (int i = 0; i < input.length(); i++)
				dictionary.put(input.charAt(i), output.charAt(i)) ;
		}
		
		for (char i = 'a'; i <= 'z'; i++)
		{
			System.out.println(i + " -> " + dictionary.get(i)) ; 
		}
		
	}
	
	public static void setupDictionary()
	{	
		ArrayList<String> inputs = new ArrayList<String>(), outputs = new ArrayList<String>();
		
		inputs.add("ejp mysljylc kd kxveddknmc re jsicpdrysi");
		outputs.add("our language is impossible to understand");
		inputs.add("rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd");
		outputs.add("there are twenty six factorial possibilities");
		inputs.add("de kr kd eoya kw aej tysr re ujdr lkgc jv");
		outputs.add("so it is okay if you want to just give up");
		
		createDictionary(inputs, outputs);
	}

	public static void main(String[] args) 
	{
		setupDictionary();
		solveProblem();		
	}
}
