import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;


public class TicTacToeBoe {

	static String[] results = {"X won", "O won", "Draw","Game has not completed"};
	final static int X_WON = 0, O_WON = 1, DRAW = 2, NOT_COMPLETED = 3;
	static int solution;

	@SuppressWarnings("deprecation")
	private static void solveProblem() {
		// Stream to read file
		FileInputStream fin;
		// Stream to write file
		FileOutputStream fout;
	
		try
		{
		    // Open an input stream
		    fin = new FileInputStream ("input.txt");
		    // Open an output stream
		    fout = new FileOutputStream ("output.txt");
		    // reader
		    DataInputStream reader = new DataInputStream(fin);
		    // writer
		    PrintStream writer = new PrintStream(fout);
		    
		    int numCases = Integer.parseInt(reader.readLine());
		    
		    String line = "";
		    for (int i = 1; i <= numCases; i++) 
		    {		    	
		    	line = "Case #" + i + ": " + solveCase(reader);
		    	writer.println(line);
		    	System.out.println(line);
			}		    
	
		    // Close our input stream
		    fin.close();
		    // Close our output stream
		    fout.close();
		}
		// Catches any error conditions
		catch (IOException e)
		{
			System.err.println ("Unable to read from file");
			System.exit(-1);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	@SuppressWarnings("deprecation")
	public static String solveCase(DataInputStream reader) throws Exception, IOException
	{
		solution = DRAW; 
		String line = reader.readLine();
		int numberOfIterations = 4;
		
		int[][] board = new int[4][4];
		for (int i = 0; i < numberOfIterations; i++) {
			for (int j = 0; j < numberOfIterations; j++) {
				switch (line.charAt(j)) {
				case 'X':
					board[i][j] = 2;
					break;
				case 'O':
					board[i][j] = -2;
					break;
				case 'T':
					board[i][j] = 1;
					break;
				default:
					board[i][j] = 0;
					solution = NOT_COMPLETED;
					break;
				}				 
			}
			line = reader.readLine();
		}
		
		return checkResult(board);
	}
	
	private static String checkResult(int[][] board) {
		int length = 4;
		int sumOfRow = 0, sumOfColumn = 0, sumOfDiagonal_1 = 0, sumOfDiagonal_2 = 0;
		
		for (int i = 0; i < length; i++) {
			sumOfRow = board[i][0] + board[i][1] + board[i][2] + board[i][3] ;
			sumOfColumn = board[0][i] + board[1][i] + board[2][i] + board[3][i] ;
			
			if(sumOfRow >= 7 || sumOfColumn >= 7 ) // 3 Xs and 1 T = (7), or 4 Xs = (8)
				return results[X_WON];
			
			if(sumOfRow == -8 || sumOfRow == -5 || sumOfColumn == -8 || sumOfColumn == -5 ) // 3 Os and 1 T = (-5), or 4 Os = (-8)
				return results[O_WON];
			
			sumOfDiagonal_1 += board[i][i];
			sumOfDiagonal_2 += board[i][length-i-1];
		}
		if(sumOfDiagonal_1 >= 7 || sumOfDiagonal_2 >= 7 ) // 3 Xs and 1 T = (7), or 4 Xs = (8)
			return results[X_WON];
		
		if(sumOfDiagonal_1 == -8 || sumOfDiagonal_1 == -5 || sumOfDiagonal_2 == -8 || sumOfDiagonal_2 == -5 ) // 3 Os and 1 T = (-5), or 4 Os = (-8)
			return results[O_WON];
		
		
		return results[solution] ; // to close the loop
	}

	public static void main(String[] args) {
		
		solveProblem();		
		
	}

}
