package bah;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class A {

	
	private final List<String> linhas;

	public A(List<String> linhas) {
		this.linhas = linhas;
	}
	
	public String solve() {
		String vencedor = vencedor(linhas);
		
		if (vencedor == null)
			vencedor = vencedor(colunas());
		
		if (vencedor == null)
			vencedor = vencedor(diagonais());
		
		if (vencedor != null)
			return vencedor;
		
		if (aindaTemJogada())
			return "Game has not completed";
		else
			return "Draw";
		
	}


	private boolean aindaTemJogada() {
		for (String linha : linhas) {
			if (linha.contains("."))
				return true;
		}
		return false;
	}

	private List<String> diagonais() {
		String diagonalPrincipal = "";
		String diagonalSecundaria = "";
		for (int i = 0; i < linhas.size(); i++) {
			diagonalPrincipal += linhas.get(i).charAt(i);
			diagonalSecundaria += linhas.get(i).charAt(linhas.size() - i - 1);
		}
		
		List<String> diagonais = new ArrayList<>();
		diagonais.add(diagonalPrincipal);
		diagonais.add(diagonalSecundaria);
		return diagonais;
	}

	private List<String> colunas() {
		List<String> colunas = new ArrayList<>();
		for (int i = 0; i < linhas.size(); i++) {
			String coluna = "";
			for (String linha : linhas) {
				coluna += linha.charAt(i);
			}
			colunas.add(coluna);
		}
		return colunas;
	}

	private String vencedor(List<String> list) {
		for (String linha : list) {
			if (linha.contains(".")) continue;
			
			if ((linha.contains("O") || linha.contains("T")) && !linha.contains("X")) return "O won";
			if ((linha.contains("X") || linha.contains("T")) && !linha.contains("O")) return "X won";
		}
		return null;
	}
	
	public static void main(String[] args) throws IOException {
		Scanner scanner = new Scanner(new File("A-large.in"));
		
		int testCases = Integer.valueOf(scanner.nextLine());
		List<String> resultados = new ArrayList<>();
		
		for (int i = 0; i < testCases; i++) {
			List<String> testCase = new ArrayList<>();
			for (int j = 0; j < 4; j++) {
				testCase.add(scanner.nextLine());
			}
			scanner.nextLine();
			resultados.add(new A(testCase).solve());
		}
		
		FileWriter saida = new FileWriter(new File("A.output"));
		for (int i = 0; i < resultados.size(); i++) {
			saida.write(String.format("Case #%s: %s\n", i+1, resultados.get(i)));
		}
		
		scanner.close();
		saida.close();
	}
}
