package bah;

import static java.lang.Math.ceil;
import static java.lang.Math.floor;
import static java.lang.Math.sqrt;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class B {

	private final BigDecimal min;
	private final BigDecimal max;

	public B(BigDecimal min, BigDecimal max) {
		this.min = min;
		this.max = max;
	}

	public long solve() {
		double minSqrt = floor(sqrt(min.doubleValue()));
		double maxSqrt = floor(sqrt(max.doubleValue()));

		HashMap<BigDecimal, BigDecimal> quadradosPerfeitos = new HashMap<>();
		while (minSqrt <= maxSqrt) {
			quadradosPerfeitos.put(new BigDecimal(minSqrt), new BigDecimal(
					minSqrt * minSqrt));
			minSqrt++;
		}

		long bah = 0;
		for (Map.Entry<BigDecimal, BigDecimal> entry : quadradosPerfeitos
				.entrySet()) {
				if ((min.compareTo(entry.getValue()) <= 0 && max
						.compareTo(entry.getValue()) >= 0))
					if (ehPalindromo(entry.getKey().toString())
							&& ehPalindromo(entry.getValue().toString())) {
						bah++;
					}
		}
		return bah;

	}

	private boolean ehPalindromo(String string) {
		return string.equals(new StringBuffer(string).reverse().toString());
	}
	
	public static void main(String[] args) throws IOException {
		Scanner scanner = new Scanner(new File("C-small-attempt0.in"));
		
		int testCases = Integer.valueOf(scanner.nextLine());
		List<Long> resultados = new ArrayList<>();
		
		for (int i = 0; i < testCases; i++) {
			resultados.add(new B(new BigDecimal(scanner.nextDouble()), new BigDecimal(scanner.nextDouble())).solve());
		}
		
		FileWriter saida = new FileWriter(new File("C.output"));
		for (int i = 0; i < resultados.size(); i++) {
			saida.write(String.format("Case #%s: %s\n", i+1, resultados.get(i)));
		}
		
		scanner.close();
		saida.close();
	}
}
