package translator;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

public class GooglereseTranslator {
	private static Map<Character, Character> dicionario = montaDicionarioDeTraducao();;

	private static Map<Character, Character> montaDicionarioDeTraducao() {
		Map<Character, Character> dicionario = new LinkedHashMap<Character, Character>();
		
		dicionario.put('y', 'a');
		dicionario.put('n', 'b');
		dicionario.put('f', 'c');
		dicionario.put('i', 'd');
		dicionario.put('c', 'e');
		dicionario.put('w', 'f');
		dicionario.put('l', 'g');
		dicionario.put('b', 'h');
		dicionario.put('k', 'i');
		dicionario.put('u', 'j');
		dicionario.put('o', 'k');
		dicionario.put('m', 'l');
		dicionario.put('x', 'm');
		dicionario.put('s', 'n');
		dicionario.put('e', 'o');
		dicionario.put('v', 'p');
		dicionario.put('z', 'q');
		dicionario.put('p', 'r');
		dicionario.put('d', 's');
		dicionario.put('r', 't');
		dicionario.put('j', 'u');
		dicionario.put('g', 'v');
		dicionario.put('t', 'w');		
		dicionario.put('h', 'x');
		dicionario.put('a', 'y');
		dicionario.put('q', 'z');
		dicionario.put(' ', ' ');
		
		return dicionario;
	}
	
	public static void main(String... args) throws NumberFormatException, IOException {
		BufferedReader buffer = new BufferedReader(new InputStreamReader(new FileInputStream(args[0])));
		
		int qtd = Integer.parseInt(buffer.readLine());
		
		List<String> saida = new ArrayList<String>();
		for (int i = 1; i <= qtd; i++) {
			saida.add("Case #" + i + ": " + traduza(buffer.readLine()));
		}
		
		buffer.close();
		
		escrevaNoArquivoASaida("output.txt", saida);
	}

	private static void escrevaNoArquivoASaida(String nomeArquivo, List<String> saida) throws IOException {
		BufferedWriter br = new BufferedWriter(new FileWriter(new File(nomeArquivo)));  
		
		for (String string : saida) {
			br.write(string + "\n");
		}
		  
		br.close(); 
		
	}

	private static String traduza(String entrada) {
		String retorno = "";
		for (char letra : entrada.toCharArray()) {
			retorno += dicionario.get(letra);
		}
		
		return retorno;
	}
}
