import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class JamCoin {
    private Map<Long, Long> isPrimes = new HashMap<Long, Long>();

    public static void main(String[] args) throws FileNotFoundException {
        System.setOut(new PrintStream("coin-jam/src/A-small.out"));
        JamCoin jamCoin = new JamCoin();

        System.out.println("Case #1:");

        jamCoin.findJamCoin(16, 50);
    }

    private long findJamCoin(int size, int numberToFind) {
        int fillSize = size - 2, remaining = numberToFind;

        for (int i = 0; i < pow(2, fillSize) && remaining > 0; ++i) {
            String s = Integer.toBinaryString(i);
            while (s.length() < fillSize) {
                s = "0" + s;
            }
            s = "1" + s + "1";

            boolean prime = false;
            List<Long> factors = new ArrayList<Long>();

            for (int j = 2; j <= 10; ++j) {
                long i1 = Long.parseLong(s, j);
                if (isPrime(i1) == -1) {
                    prime = true;
                    break;
                } else {
                    factors.add(isPrime(i1));
                }
            }

            if (!prime) {
                System.out.print(s);

                for (Long factor : factors) {
                    System.out.print(" ");
                    System.out.print(factor);
                }
                System.out.print("\n");
                --remaining;
            }
        }
        return 0;
    }

    private int pow(int num, int exponent) {
        int ret = 1;

        for (int i = 0; i < exponent; ++i) {
            ret *= num;
        }

        return ret;
    }

    private long isPrime(long num) {
//        System.out.println("isPrime: " + num);

        if (isPrimes.containsKey(num)) {
            return isPrimes.get(num);
        }

        if (num < 2) {
            isPrimes.put(num, 1L);
            return 1L;
        }
        if (num == 2) {
            isPrimes.put(num, 2L);
            return 2L;
        }
        if (num % 2 == 0) {
            isPrimes.put(num, 2L);
            return 2L;
        }
        for (long i = 3; i * i <= num; i += 2) {
            if (num % i == 0) {
                isPrimes.put(num, i);
                return i;
            }
        }

        isPrimes.put(num, -1L);
        return -1L;
    }
}
