import java.io.*;
import java.util.*;

public class Solver {
    static Scanner input;
    static BufferedWriter output;
    static List<Integer> primes;
    public static void main(String args[]) {
        if(args.length != 1){
            System.out.println("Please specify the input file");
            return;
        }

		String filename = args[0];
		File f = new File(filename);
		BufferedReader br;

        if (!f.exists()) {
            System.out.println("Couldn't find file "+filename);
            return;
        } else if (f.isDirectory()) {
            System.out.println(filename+" is a directory");
            return;
        }

        try {
			br = new BufferedReader (new FileReader (f));
			input = new Scanner(br);
        } catch (IOException iox){
		    System.out.println("Problem reading " + filename );
        }

        //quickly generate first 1000 primes for use in solution
        primes=new ArrayList<Integer>();
        primes.add(2);
        for(int i=3; i<1000; i++){
            boolean broken = false;
            for(Integer div : primes){
                if(i%div == 0){
                    broken = true;
                    break;
                }
            }
            if(!broken) primes.add(i);
        }
        //for(Integer prime : primes) System.out.println(":"+prime);

        try {
            output = new BufferedWriter(
                        new OutputStreamWriter(
                            new FileOutputStream(filename+".out"), "utf-8"));
            solve();
        } catch (IOException ex) {
            System.out.println("Couldn't open an output file");
            return;
        }

        try{
            output.close();
            input.close();
        } catch (IOException ex) {
        }
    }

    public static void solve() throws IOException {
        int T = input.nextInt();
        for(int caseNum=0; caseNum<T; caseNum++){
            int diners = input.nextInt();
            int magicMinutes = 0;
            int totalCost = 0;
            List<Integer> plates = new ArrayList<Integer>(diners);
            for(int i=0; i<diners; i++) plates.add(input.nextInt());
            System.out.println("\n");

            int maxStack = Collections.max(plates);
            int minCost = maxStack;
            for(int i=2; i<maxStack; i++){
                int costToCut=i;
                for(Integer plate:plates){
                    if(plate > i){
                        costToCut += ((plate+i-1)/i)-1;
                    }
                }
                if(costToCut < minCost) minCost = costToCut;
            }
            totalCost = minCost;

            /*while(true){
                Collections.sort(plates,Collections.reverseOrder());
                System.out.print(magicMinutes+":\t");
                for(int i=0; i<plates.size(); i++){
                    System.out.print(plates.get(i)+" ");
                }
                System.out.println();
                Integer largest = plates.get(0);
                Integer second  = 0;
                int numLargest = 0;

                for(int i=0; i<plates.size(); i++){
                    if(plates.get(i)==largest) {
                        numLargest++;
                    } else {
                        second = plates.get(i);
                        break;
                    }
                }

                int costToStay  = magicMinutes //time spent so far
                                + largest; //time to eat remaining pancakes

                int breakDiv = 1;
                int minCost = costToStay;

                for(Integer prime : primes){
                    //if(prime > largest) break;
                    int costBreakPrime = magicMinutes
                                       + numLargest*(prime-1)
                                       + Math.max(second, (largest+(prime-1))/prime);
                    System.out.println("Cost to break by "+prime+": "+costBreakPrime);
                    if(costBreakPrime <= minCost){
                        minCost = costBreakPrime;
                        breakDiv = prime;
                    } else {
                        break;
                    }
                }

                //System.out.println("stay: "+costToStay+" vs break by "+breakDiv+": "+minCost);


                if(breakDiv == 1){
                    totalCost = costToStay;
                    break;
                } else {
                    magicMinutes += numLargest*(breakDiv-1);
                    int ovf = largest % breakDiv;
                    for(int n=0; n<numLargest; n++){
                        plates.remove(0);
                        for(int i=0; i<breakDiv; i++){
                            if(ovf != 0) {
                                plates.add( (largest+(breakDiv-1))/breakDiv );
                                ovf--;
                            } else {
                                plates.add(largest/breakDiv);
                            }
                        }
                    }
                }
            }*/
            System.out.println("Answer was "+totalCost);
            output.write("Case #"+(caseNum+1)+": ");
            output.write(""+totalCost);
            output.newLine();
        }
    }
}

/*            for(Integer plate : plates){
                System.out.print(plate);
                System.out.print("\t");
            }
            System.out.print("\n");*/
