import java.io.*;
import java.util.*;

public class Solver {
    static Scanner input;
    static Writer  output;
    public static void main(String args[]) {
        if(args.length != 1){
            System.out.println("Please specify the input file");
            return;
        }

		String filename = args[0];
		File f = new File(filename);
		BufferedReader br;

        if (!f.exists()) {
            System.out.println("Couldn't find file "+filename);
            return;
        } else if (f.isDirectory()) {
            System.out.println(filename+" is a directory");
            return;
        }

        try {
			br = new BufferedReader (new FileReader (f));
			input = new Scanner(br);
        } catch (IOException iox){
		    System.out.println("Problem reading " + filename );
        }

        try {
            output = new BufferedWriter(
                        new OutputStreamWriter(
                            new FileOutputStream(filename+".out"), "utf-8"));
            solve();
        } catch (IOException ex) {
            System.out.println("Couldn't open an output file");
            return;
        }

        try{
            output.close();
            input.close();
        } catch (IOException ex) {
        }
    }

    public static void solve() throws IOException {
        int T = input.nextInt();
        for(int caseNum=0; caseNum<T; caseNum++){
            int N = input.nextInt();
            int answer = count(N);
            output.write("Case #"+(caseNum+1)+": ");
            output.write(""+answer);
            output.write("\n");
            System.out.println(" )---------");
        }
    }

    static class Pair{
        public int v,s;
        public Pair(int v, int s){
            this.v = v;
            this.s = s;
        }
        public Pair succ(){
            return new Pair(v+1, s+1);
        }
        public Pair psuc(){
            return new Pair(v-1, s+1);
        }
        public Pair brev(){
            return new Pair(reverse(v)-1, s+2);
        }
        public Pair frev(){
            return new Pair(reverse(v)+1, s+2);
        }
    }

    public static int count(int N){
        if(N <= 12) return N;
        int v = 12; //last stated value
        int t = N;
        int steps = 0; //number of numbers said out loud
/*        Queue<Pair> states = new LinkedList<Pair>();
        states.add(new Pair(N,0));
        while(!states.isEmpty()){
            Pair now = states.poll();
            if(now.v > N*10) continue;
            visited.add(now);
            System.out.println(now.s+": "+now.v);
            if(now.v <= 12){
                return now.s + now.v;
            }
            if(now.v%10 == 0) {
                now.v -= 1;
                now.s += 1;
            }
            states.add(now.brev());
            states.add(now.psuc());

        }*/

        while(true){
            //System.out.print(t);
            if(t <= 12){
                steps += t;
                break;
            }
            int digits = (int)(Math.log10(t)+1);
            int lastDig = t%pow10((digits)/2);
            if(lastDig != 1){
                int diff;
                if(lastDig == 0) diff = rep9((digits)/2);
                else diff = lastDig-1;
                t -= diff;
                steps += diff;
                //System.out.print(" -> "+t);
            }
            int trev = reverse(t);
            if(trev < t){
                System.out.println(t +" / "+ trev);
                t = trev - 1;
                steps +=2;
            }
            else{
                t-=1;
                steps +=1;
            }
            //System.out.println(" -> "+t);
        }
/*        int total = 0;
        int digits = (int)(Math.log10(N)+1);
        for(int i=1; i<digits-1; i++){
            total += rep9(digits/2);
            total += rep9((digits+1)/2);
            System.out.println("total has passed "+i+" new total "+total);
        }
        int topHalf = N;
        topHalf /= pow10(digits/2);
        int bottomHalf = N;
        bottomHalf %= pow10(digits/2);
        System.out.println(N+" "+topHalf+" "+bottomHalf);
        total += reverse(topHalf);
        total += bottomHalf;*/

        return steps;
    }

    public static int rep9(int digs){
        int val = 0;
        for(int i=0; i<digs; i++){
            val *= 10;
            val += 9;
        }
        return val;
    }
    public static int pow10(int digs){
        int val = 1;
        for(int i=0; i<digs; i++){
            val *= 10;
        }
        return val;
    }

    public static int reverse(int n){
        int rev = 0;
        while(n != 0){
            int dig = n%10;
            n = (n-dig)/10;
            rev *= 10;
            rev += dig;
        }
        return rev;
    }
}

