import java.util.*;
import java.io.*;

public class Dijkstra {
	static class Node {
		char v;
		boolean isNegative;
		
		Node(char c, boolean flag) {
			v = c;
			isNegative = flag;
		}
	}
	
	private static HashMap<String, Node> hm;
	private static String[] getParams(String line) {
		String delim = "[ ]";
		String[] ret = line.split(delim);
		return ret;
	}
	
	private static boolean canReduce(StringBuilder str, int start, int end, char target, Node[] helper) {
		
		if(target == 'i') {
			if(helper[end].isNegative) return false;
			return helper[end].v == target;
		}
		
		//if(target == 'j') {
			// this means the first part can be reduce to i
			Node soFar = helper[end];
			StringBuilder temp = new StringBuilder();
			// we need to do -i * soFar
			temp.append('i');
			temp.append(soFar.v);
			String key = temp.toString();
			Node value = hm.get(key);
			if(!value.isNegative) return false;
			return value.v == 'j';
		//}
	}
	
	
	private static boolean solve(int L, int X, String s) {
		if(L == 1) return false;
		boolean ret = false;
		// we need a helper Node[] helper
		Node[] helper = new Node[L*X];
		helper[0] = new Node(s.charAt(0), false);
		StringBuilder temp = new StringBuilder();
		
		// brute force
		StringBuilder str = new StringBuilder();
		// build the composition string
		for(int i = 0; i < X; i++) str.append(s);
					
		for(int i = 1; i < L*X; i++) {
			temp.append(helper[i-1].v);
			temp.append(str.charAt(i));
			String key = temp.toString();
			Node value = hm.get(key);
			if(helper[i-1].isNegative) {
				helper[i] = new Node(value.v, !value.isNegative);
			} else {
				helper[i] = new Node(value.v, value.isNegative);
			}
			temp.setLength(0);
		}
		if(helper[L*X - 1].v == '1' && helper[L*X - 1].isNegative) {
			// use two for loops to check every possible breaking
			// the first part need to reduce to i, the second part to j, the thrid part to k
			for(int i = 0; i < str.length(); i++) {
				// we need to check if this part can reduce to i
				if(!canReduce(str, 0, i, 'i', helper)) continue;
				for(int j = i+1; j < str.length(); j++) {
					if(!canReduce(str, i+1, j, 'j', helper)) continue;
					// when it comes here, it means the second part can reduce to j
					// then we check if the rest part can be reduced to k
					// if(canReduce(str, j+1, str.length()-1, 'k', helper)) return true;
					return true;
				}
			}
			return false;
		} else {
			return false;
		}
	}
	
	private static void createHashMap() {
		hm = new HashMap<>();
		hm.put("11", new Node('1', false));
		hm.put("1i", new Node('i', false));
		hm.put("1j", new Node('j', false));
		hm.put("1k", new Node('k', false));
		
		hm.put("i1", new Node('i', false));
		hm.put("ii", new Node('1', true));
		hm.put("ij", new Node('k', false));
		hm.put("ik", new Node('j', true));
		
		hm.put("j1", new Node('j', false));
		hm.put("ji", new Node('k', true));
		hm.put("jj", new Node('1', true));
		hm.put("jk", new Node('i', false));
		
		hm.put("k1", new Node('k', false));
		hm.put("ki", new Node('j', false));
		hm.put("kj", new Node('i', true));
		hm.put("kk", new Node('1', true));
	}
	
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		createHashMap();
		File file = new File("C-small-0.in");
		Scanner in = new Scanner(new BufferedReader(new FileReader(file)));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("C-small-0.out.txt")));
		// number of test cases
		int t = Integer.valueOf(in.nextLine());
		for(int round = 1; round <= t; round++) {
			String[] params = getParams(in.nextLine());
			// params[0] is L, params[1] is X
			String input = in.nextLine();
			boolean result = solve(Integer.valueOf(params[0]), Integer.valueOf(params[1]), input);
			if(result)
				out.println("Case #" + round + ": YES");
			else
				out.println("Case #" + round + ": NO");
		}
		
		out.flush();
		out.close();
		in.close();
	}

}
