import java.util.*;
import java.io.*;

public class Q2 {

	static class Node {
		int time;
		int index;
		int left;
		Node(int t, int i) {
			time = t;
			index = i;
			left = t;
		}
	}
	
	private static String[] getParams(String s) {
		String delim = "[ ]";
		return s.split(delim);
	}
	
	public static void main(String[] args) throws IOException{
		// TODO Auto-generated method stub
		File file = new File("B-small-attempt1.in");
		Scanner in = new Scanner(new BufferedReader(new FileReader(file)));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B-small.out.txt")));
		// number of test cases
		int t = Integer.valueOf(in.nextLine());
		for(int round = 1; round <= t; round++) {
			String[] tokens = getParams(in.nextLine());
			int B = Integer.valueOf(tokens[0]);
			int N = Integer.valueOf(tokens[1]);
			
			tokens = getParams(in.nextLine());
			int[] input = new int[B];
			for(int i = 0; i < B; i++) {
				input[i] = Integer.valueOf(tokens[i]);
			}
			
			int result = solve(B, N, input);
			
			out.println("Case #" + round + ": " + result);
		}
		
		out.flush();
		out.close();
		in.close();
	}

	static Comparator<Node> c = new Comparator<Node>() {

		@Override
		public int compare(Node o1, Node o2) {
			// TODO Auto-generated method stub
			if(o1.left < o2.left) return -1;
			else if(o1.left > o2.left) return 1;
			else {
				return o1.index - o2.index;
			}
		}
		
	};
	private static long gcd(long a, long b) {
	    while (b > 0)
	    {
	        long temp = b;
	        b = a % b; // % is remainder
	        a = temp;
	    }
	    return a;
	}
	
	private static long lcm(long a, long b) {
	    return a * (b / gcd(a, b));
	}

	private static long lcm(long[] input) {
	    long result = input[0];
	    for(int i = 1; i < input.length; i++) result = lcm(result, input[i]);
	    return result;
	}
	
	private static int solve(int B, int N, int[] input) {
		// TODO Auto-generated method stub
		if(N <= B) return N;
		long[] array = new long[B];
		for(int i = 0; i < B; i++) {
			array[i] = input[i];
		}
		long leastCM = lcm(array);
		int total = 0;
		for(long i : array) {
			total += (leastCM / i);
		}
		
		PriorityQueue<Node> minHeap = new PriorityQueue<>(B, c);
		for(int i = 0; i < B; i++) {
			
			minHeap.offer(new Node(input[i], i+1));
		}
		int ret = 0;
		
		int cur = (N % total);
		
		if(cur == 0) cur = total;
		//System.out.println(cur);
		if(cur <= B) return cur;
		cur -= B;
		Queue<Node> q = new LinkedList<Node>();
		
		while(cur > 0) {
			Node root = minHeap.poll();
			cur--;
			q.offer(root);
			while(cur > 0 && !minHeap.isEmpty() && root.left == minHeap.peek().left) {
				root = minHeap.poll();
				q.offer(root);
				cur--;
			}
			if(cur == 0) ret = root.index;
			else if(minHeap.isEmpty()) {
				while(!q.isEmpty()) {
					Node current = q.poll();
					current.left = current.time;
					minHeap.offer(current);
				}
			} else {
				int reduce = q.peek().left;
				// make every node in minheap.left - time;
				Iterator<Node> iterator = minHeap.iterator();
				while(iterator.hasNext()) {
					Node current = iterator.next();
					current.left -= reduce;
				}
				while(!q.isEmpty()) {
					Node current = q.poll();
					current.left = current.time;
					minHeap.offer(current);
				}
			}
		}
		return ret;
	}

}
