import java.util.*;
import java.io.*;

public class Pancake {

	private static int solve(int[] array) {
		int ret = 0;
		PriorityQueue<Integer> maxHeap = new PriorityQueue<Integer>(Collections.reverseOrder());
		for(int i : array) maxHeap.offer(i);
		ret = maxHeap.peek();
		int round = 0;
		boolean flag = false;
		while(true) {
			int root = maxHeap.poll();
			int firstHalf = root/2;
			int secondHalf = root - firstHalf;
			maxHeap.offer(firstHalf);
			maxHeap.offer(secondHalf);
			int curTime = 1 + round + maxHeap.peek();
			round++;
			if(curTime < ret) {
				ret = curTime;
			} else {
				if(maxHeap.peek() == 1) break;
			}
			
		}
		return ret;
	}
	
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		File file = new File("B-small-2.in");
		Scanner in = new Scanner(new BufferedReader(new FileReader(file)));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter("B-small-2.out.txt")));
		// number of test cases
		int t = Integer.valueOf(in.nextLine());
		for(int round = 1; round <= t; round++) {
			int num = in.nextInt();
			int[] array = new int[num];
			for(int i = 0; i < num; i++) {
				array[i] = in.nextInt();
			}
			int result = solve(array);
			out.println("Case #" + round + ": " + result);
		}
		
		out.flush();
		out.close();
		in.close();
	}

}
