import java.util.*;
import java.io.*;

class Stalls{

	public static void main(String[] args) throws Exception{
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		int t = Integer.parseInt(br.readLine());

		for(int numCases = 1; numCases <= t; numCases++){
			String[] line = br.readLine().split(" ");
			long n = Long.parseLong(line[0]);
			long k = Long.parseLong(line[1]);
			PriorityQueue<Interval> pq = new PriorityQueue<Interval>();
			Interval first = new Interval(0, n - 1);
			pq.offer(first);
			Interval out = first;
			for(int i = 0; i < k; i++){
				Interval cur = pq.poll();
				// System.out.println("cur: " + cur);
				out = cur;
				Interval[] splitted = cur.split();
				pq.offer(splitted[0]);
				pq.offer(splitted[1]);
			}
			long[] answer = out.answer();
			System.out.println("Case #" + numCases + ": " + answer[0] + " " + answer[1]);
		}
	
		
		br.close();
	}

	static class Interval implements Comparable{

		long li, ri, size;

		public Interval(long li, long ri){
			this.li = li;
			this.ri = ri;
			this.size = (li - ri + 1);
		}

		public Interval[] split(){
			long mi = (li + ri) / 2;
			Interval i1 = new Interval(li, mi - 1);
			Interval i2 = new Interval(mi + 1, ri);
			return new Interval[]{i1, i2};
		}

		public long[] answer(){
			long mi = (li + ri) / 2;
			long ls = (mi - li);
			long rs = (ri - mi);
			long min = Math.max(ls, rs);
			long max = Math.min(ls, rs);
			return new long[]{min, max};
		}

		public int compareTo(Object rhsObj){
			Interval rhs = (Interval) rhsObj;
			if(this.size != rhs.size)
				return this.size > rhs.size ? 1 : -1;
			return this.li < rhs.li ? 1 : -1;
		}

		public String toString(){
			String out = "";
			// out += li + "\tri: " + ri;
			return out;
		}


	}

}