
package codejam2016;

import java.io.File;
import java.util.Scanner;


public class Fractiles {



	private String getS(int v, int len) {
		char[] base = new char[len];

		for (int i = len - 1; i >= 0; i--) {
			if (v % 2 == 0)
				base[i] = 'G';
			else
				base[i] = 'L';

			v >>= 1;
		}
		return new String(base);
	}

	private String expand(String org, String perm) {
		int n1 = org.length();

		StringBuilder t = new StringBuilder();
		for (int i = 0; i < n1; i++)
			t.append('G');
		String g = t.toString();

		int n = perm.length();
		StringBuilder sb = new StringBuilder();
		for (int i = 0; i < n; i++) {
			char c = perm.charAt(i);

			if (c == 'L') {
				sb.append(org);
			}
			else
				sb.append(g);
		}

		return sb.toString();
	}

	private void count(String[] perms) {

		int n = perms.length;
		int k = perms[0].length();

		for (int i = 0; i < k; i++) {
			int countl = 0;
			for (int j = 0; j < n; j++) {
				if (perms[j].charAt(i) == 'L')
					countl++;
			}
			System.out.format("%3d", countl);
		}
		System.out.format("\n");

	}

	private void gen(int K, int C) {

		int n = (int) Math.pow(2, K);

		String[] orgs = new String[n];
		String[] perm = new String[n];

		for (int i = 0; i < n; i++) {
			String s = getS(i, K);
			orgs[i] = s;
			perm[i] = s;
			System.out.format("%s\n", s);
		}

		count(perm);

		for (int c = 1; c < C; c++) {
			for (int i = 0; i < n; i++) {
				String s = expand(orgs[i], perm[i]);
				perm[i] = s;
				System.out.format("%s\n", s);
			}
			count(perm);
			System.out.format("\n");
		}
	}



	private int[] getSequence(int K, int C) {

		if (K == 1) {
			return new int[] {0};
		}

		int[] ret = new int[K];
		if (C > 1) {
			for (int i = 0; i < K; i++)
				ret[i] = i + 1;
		}
		else {
			for (int i = 0; i < K; i++)
				ret[i] = i;
		}

		return ret;
	}


	private void solve(int no, int K, int C, int S) {

		int[] seq = getSequence(K, C);

		System.out.format("Case #%d:", no);
		for (int i = 0; i < seq.length; i++) {
			System.out.format(" %d", seq[i] + 1);
		}

		System.out.format("\n");
	}


	private void solve(Scanner sc) {
		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {
			int K = sc.nextInt();
			int C = sc.nextInt();
			int S = sc.nextInt();

			solve(i + 1, K, C, S);
		}
	}


	public static void main(String[] args) throws Exception {

		Scanner sc = null;

		Fractiles fractiles = new Fractiles();

		if (args.length == 1) {
			sc = new Scanner(new File(args[0]));

			fractiles.solve(sc);
		}
		else {
			fractiles.solve(1, 2, 3, 2);
			fractiles.solve(1, 1, 2, 1);
			fractiles.solve(1, 2, 1, 2);
			fractiles.solve(1, 3, 2, 3);
			//fractiles.gen(3, 1);
		}
	}

}
