
package codejam2017;

import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;


public class ProbB {

	private static boolean DEBUG = false;

	private PrintStream out;
	private PrintStream debug;



	private boolean isTidy2(long number) {

		while (number > 0) {
			long last1 = number % 10;
			long tmp = number / 10;
			long last2 = tmp % 10;

			if (last2 > last1)
				return false;

			number = tmp;
		}

		return true;
	}


	private int isTidy(long number) {

		if (number < 10)
			return -1;

		String numbers = "" + number;
		int n = numbers.length();

		for (int i = 0; i < n - 1; i++) {
			char ch1 = numbers.charAt(i);
			char ch2 = numbers.charAt(i+1);

			if (ch1 > ch2)
				return i;
		}

		return -1;
	}


	private long nextSmallNumber(long number, int pos) {

		String numbers = "" + number;
		int n = numbers.length();

		long u = Long.parseLong(numbers.substring(0, pos+1));
		long d = Long.parseLong(numbers.substring(pos+1));

		long downnumber = u - 1;

		for (int i = 0; i < n - pos - 1; i++) {
			downnumber = downnumber * 10 + 9;
		}

		return downnumber;
	}


	private long solveAcase(long N) {

		long number = N;
		while (true) {
			int pos = isTidy(number);

			debug.format("\t%d (%d)\n", number, pos);

			if (pos == -1) break;

			number = nextSmallNumber(number, pos);
		}

		return number;
	}

	private void solve(Scanner sc) {
		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {

			long N = sc.nextLong();

			debug.format("Case #%d: %d\n", i+1, N);

			long lastTidy = solveAcase(N);

			out.format("Case #%d: %d\n", i+1, lastTidy);
		}
	}


	public static void main(String[] args) throws Exception {

		DEBUG = true;

		Scanner sc = null;

		ProbB prob = new ProbB();

		if (args.length == 2) {
			String debugfile = args[1] + ".debug";
			prob.out = new PrintStream(args[1]);
			prob.debug = new PrintStream(debugfile);

			sc = new Scanner(new File(args[0]));

			prob.solve(sc);
		}
		else {
			prob.out = System.out;
			prob.debug = System.out;

			int tidy;
			long number = 12345, nextsmall;

			tidy = prob.isTidy(number);
			prob.out.printf("%d -> %d\n", number, tidy);

			number = 132;
			tidy = prob.isTidy(number);
			nextsmall = prob.nextSmallNumber(number, tidy);
			prob.out.printf("%d -> %d  -> %d\n", number, tidy, nextsmall);

			number = 12345421;
			tidy = prob.isTidy(number);
			nextsmall = prob.nextSmallNumber(number, tidy);
			prob.out.printf("%d -> %d  -> %d\n", number, tidy, nextsmall);

			number = 1000;
			tidy = prob.isTidy(number);
			nextsmall = prob.nextSmallNumber(number, tidy);
			prob.out.printf("%d -> %d  -> %d\n", number, tidy, nextsmall);


			number = 111111111111111110L;
			tidy = prob.isTidy(number);
			nextsmall = prob.nextSmallNumber(number, tidy);
			prob.out.printf("%d -> %d  -> %d\n", number, tidy, nextsmall);

			prob.solveAcase(132);
			prob.solveAcase(1000);
			prob.solveAcase(7);
			prob.solveAcase(10);
			prob.solveAcase(21);
			prob.solveAcase(123454321);
			prob.solveAcase(number);
		}
	}
}
