/**

 */
package codejam2017;

import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;


public class ProbA {

	private static boolean DEBUG = false;

	private PrintStream out;
	private PrintStream debug;


	private boolean isHappySide(char[] s) {

		int n = s.length;
		for (int i = 0; i < n; i++) {
			if (s[i] == '-')
				return false;
		}

		return true;
	}

	private void flip(char[] s, int start, int K) {

		for (int i = 0; i < K; i++) {
			int offset = start + i;

			char c = s[offset];

			if (c == '+')
				s[offset] = '-';
			else
				s[offset] = '+';
		}
	}

	private int solveAcase(String S, int K) {

		int flipCount = 0;
		char[] s = S.toCharArray();

		int n = s.length - K + 1;

		debug.format("%s (%d), %d, %d\n", S, s.length, K, n);

		for (int i = 0; i < n; i++) {

			debug.format("\t%3d: %3d: %s\n", i, flipCount, new String(s));

			if (isHappySide(s))
				return flipCount;

			char c = s[i];
			if (c == '+')
				continue;

			flip(s, i, K);
			flipCount++;

			if (isHappySide(s))
				return flipCount;
		}

		debug.format("\tImpossible\n");
		return -1;
	}



	private void solve(Scanner sc) {
		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {

			String S = sc.next();		// e.g. 8 chars: ---+-++-
			int K = sc.nextInt();

			int count = solveAcase(S, K);

			if (count == -1) {
				out.format("Case #%d: IMPOSSIBLE\n", i+1);
			}
			else {
				out.format("Case #%d: %d\n", i+1, count);
			}
		}
	}

	public static void main(String[] args) throws Exception {

		Scanner sc = null;

		ProbA prob = new ProbA();

		String type = "";

		if (args.length == 2) {
			String debugfile = args[1] + ".debug";
			prob.out = new PrintStream(args[1]);
			prob.debug = new PrintStream(debugfile);

			sc = new Scanner(new File(args[0]));

			prob.solve(sc);
		}
		else {
			prob.out = System.out;
			prob.debug = System.out;

			prob.solveAcase("---+-++-", 3);
			prob.solveAcase("++++++", 2);
			prob.solveAcase("-+-+-", 4);
			prob.solveAcase("-----", 1);
			prob.solveAcase("---+++", 4);
			prob.solveAcase("---+++", 3);
			prob.solveAcase("---+++", 2);
			prob.solveAcase("---+++", 1);
		}

	}
}
