
package codejam2016;

import java.io.*;
import java.util.*;


public class ProbA {

	private static boolean DEBUG = false;


	private int findMax(int[] P) {
		int max = 0;
		int maxi = 0;
		for (int i = 0; i < P.length; i++) {
			if (max < P[i]) {
				max = P[i];
				maxi = i;
			}
		}

		return maxi;
	}

	private boolean isNotMajority(int[] p, int total) {

		int t = 0;

		for (int i = 0; i < p.length; i++)
			t += p[i];

		int th = t / 2;
		for (int i = 0; i < p.length; i++)
			if (p[i] > th)
				return false;

		return true;
	}

	private char toChar(int n) {
		return (char)(n + 'A');
	}


	private void solve(int N, int[] P) {

		// 2개 또는 1개를 고른다.
		while (true) {
			int total = 0;
			for (int i = 0; i < N; i++)
				total += P[i];

			if (DEBUG)
				System.out.format(" total: %d\n", total);

			if (total == 0) return;

			for (int i = 0; i < N; i++) {
				for (int j = 0; j < N; j++) {

					boolean c1 = false;
					boolean c2 = false;

					if (P[i] > 0) {
						P[i]--;
						c1 = true;
					}
					if (P[j] > 0) {
						P[j]--;
						c2 = true;
					}

					if (c1 == false && c2 == false) {
						if (DEBUG)
							System.out.format(" c1 && c2 are false.\n");
						continue;
					}

					boolean major = false;
					if (c1 == true && c2 == true) {
						major = isNotMajority(P, total - 2);
						if (major == true) {
							System.out.format(" %c%c", toChar(i), toChar(j));
						}
						else {
							P[j]++;
							major = isNotMajority(P, total - 1);
							if (major == true) {
								System.out.format(" %c", toChar(i));
							}
							else {
								P[j]--;
								P[i]++;
								major = isNotMajority(P, total - 1);
								if (major == true) {
									System.out.format(" %c", toChar(j));
								}
								else {
									P[j]++;
								}
							}
						}
					}
					else if (c1 == true) {
						major = isNotMajority(P, total - 1);
						if (major == true) {
							System.out.format(" %c", toChar(i));
						}
						else {
							P[i]++;
						}
					}
					else if (c2 == true) {
						major = isNotMajority(P, total - 1);
						if (major == true) {
							System.out.format(" %c", toChar(j));
						}
						else {
							P[j]++;
						}
					}
				}
			}
		}
	}


	private void solve(Scanner sc) {
		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {
			int N = sc.nextInt();

			int[] P = new int[N];

			for (int j = 0; j < N; j++) {
				P[j] = sc.nextInt();
			}

			System.out.format("Case #%d:", i+1);

			solve(N, P);

			System.out.format("\n");
		}
	}


	public static void main(String[] args) throws Exception {

		Scanner sc = null;

		ProbA prob = new ProbA();

		if (args.length == 1) {
			sc = new Scanner(new File(args[0]));

			DEBUG = false;

			prob.solve(sc);
		}
		else {

			DEBUG = true;
		}
	}
}
