/**
 */
package codejam2016;

import java.io.File;
import java.util.*;
import java.math.*;


public class CoinJam2 {

	private static boolean DEBUG = false;


	private int pcount;

	private BigInteger ZERO = BigInteger.ZERO;
	private BigInteger ONE = BigInteger.ONE;
	private BigInteger TWO = new BigInteger("2");
	private BigInteger THREE = new BigInteger("3");
	private BigInteger FIVE = new BigInteger("5");
	private BigInteger SIX = new BigInteger("6");



	private boolean isPrime2(BigInteger n) {
		pcount = 1;
		if (n.compareTo(ONE) == 0) return false;

		if (n.compareTo(TWO) == 0) return true;
		if (n.compareTo(THREE) == 0) return true;

		if (n.mod(TWO).equals(BigInteger.ZERO)) return false;
		if (n.mod(THREE).equals(BigInteger.ZERO)) return false;

		BigInteger i = FIVE;
		// while (i * i <= n) {
		while (true) {
			if (i.pow(2).compareTo(n) > 0) break;

			//if (n % i == 0)
			if (n.mod(i).equals(ZERO))
				return false;

			BigInteger i2 = i.add(TWO);
			//if (n % (i+2) == 0)
			if (n.mod(i2).equals(ZERO))
				return false;

			i = i.add(SIX);
			pcount++;
		}

		return true;
	}

	private BigInteger primeFactor;

	private boolean isPrimeGetFactor(BigInteger n) {
		pcount = 1;
		if (n.compareTo(ONE) == 0) return false;

		if (n.compareTo(TWO) == 0) return true;
		if (n.compareTo(THREE) == 0) return true;

		if (n.mod(TWO).equals(BigInteger.ZERO)) {
			primeFactor = TWO;
			return false;
		}
		if (n.mod(THREE).equals(BigInteger.ZERO)) {
			primeFactor = THREE;
			return false;
		}

		BigInteger i = FIVE;
		// while (i * i <= n) {
		while (true) {
			if (i.pow(2).compareTo(n) > 0) break;

			//if (n % i == 0)
			if (n.mod(i).equals(ZERO)) {
				primeFactor = i;
				return false;
			}

			BigInteger i2 = i.add(TWO);
			//if (n % (i+2) == 0)
			if (n.mod(i2).equals(ZERO)) {
				primeFactor = i2;
				return false;
			}

			i = i.add(SIX);
			pcount++;

			if (pcount > 1000)
				return true;
		}

		return true;
	}

	private Long[] primeFactors(long n) {
		List<Long> factors = new ArrayList<Long>();

		long d = 2;
		while (n > 1) {
			while (n % d == 0) {
				factors.add(d);
				n /= d;
			}
			d++;

			if (d*d > n) {
				if (n > 1)
					factors.add(n);
				break;
			}
		}

		Long[] r = factors.toArray(new Long[0]);

		return r;
	}

	private BigInteger primeFactor1(BigInteger n) {
		//List<BigInteger> factors = new ArrayList<BigInteger>();

		BigInteger d = TWO;
		//while (n > 1) {
		while (n.compareTo(BigInteger.ONE) > 0) {
			//while (n % d == 0) {
			while (n.mod(d).compareTo(ZERO) == 0) {
				return d;
			}
			d = d.add(ONE);

			BigInteger d2 = d.pow(2);
			if (d2.compareTo(n) > 0) {
				if (n.compareTo(ONE) > 0)
					return d;
			}
		}

		return ZERO;
	}



	private BigInteger parse(String numberString, int base) {
		BigInteger number = new BigInteger(numberString, base);
		return number;
	}


	private BigInteger[] jamcoin(String numberString) {
		BigInteger[] numbers = new BigInteger[9];

		for (int base = 2; base <= 10; base++) {
			BigInteger number = parse(numberString, base);

			//boolean prime2 = isPrime2(number);
			boolean prime2 = isPrimeGetFactor(number);

			if (DEBUG) {
				int pcount2 = pcount;

				System.out.format("\t%s\t%8d (%2d)\t%b\t%4d\n", numberString, number, base, prime2, pcount2);
			}

			if (prime2 == true)
				return null;

			numbers[base-2] = number;
			pfactors2[base-2] = primeFactor;
		}

		return numbers;
	}

	private BigInteger[] pfactors2;

	private BigInteger[] solve(String numberString) {
		pfactors2 = new BigInteger[9];

		BigInteger[] numbers = jamcoin(numberString);

		if (numbers == null)
			return null;

		return pfactors2;
/*
		BigInteger[] pfactors = new BigInteger[numbers.length];
		for (int i = 0; i < numbers.length; i++) {
			BigInteger number = numbers[i];

			BigInteger pfactor = primeFactor1(number);
			pfactors[i] = pfactor;

			if (DEBUG) {
				System.out.format("\t%d\t%d\n", number, pfactor);
				System.out.flush();
			}
		}

		return pfactors;
		*/
	}

	private String toBinary(long n, int len) {

		char[] ret = new char[len];
		for (int i = len - 1; i >= 0; i--) {

			if (n % 2 == 0) {
				ret[i] = '0';
			}
			else {
				ret[i] = '1';
			}

			n /= 2;
		}

		return new String(ret);
	}


	private void solve(int N, int J) {
		int n = N - 2;
		long max = (long) Math.pow(2, n);

		int success = 0;
		for (long i = 0; i < max; i++) {
			String numberString = "1" + toBinary(i, n) + "1";

			if (DEBUG)
				System.out.format("%s\n", numberString);

			BigInteger[] pfactors = solve(numberString);
			if (pfactors == null)
				continue;

			success++;

			System.out.format("%s", numberString);
			for (int j = 0; j < pfactors.length; j++)
				System.out.format(" %s", pfactors[j].toString());

			System.out.format("\n");

			if (success >= J)
				return;
		}
	}


	private void solve(Scanner sc) {
		int T = sc.nextInt();
		int N = sc.nextInt();
		int J = sc.nextInt();

		System.out.format("Case #1:\n");
		solve(N, J);
	}


	public static void main(String[] args) throws Exception {
		Scanner sc = null;

		CoinJam2 coinjam = new CoinJam2();

		if (args.length == 1) {
			sc = new Scanner(new File(args[0]));

			coinjam.solve(sc);
		}
		else {
			DEBUG = false;

			//coinjam.solve(6, 3);
			coinjam.solve("1001");
			System.out.format("\n");

			coinjam.solve("100011");
			System.out.format("\n");

			coinjam.solve("110111");

			//coinjam.solve(6, 3);
			coinjam.solve(32, 500);
		}
	}
}
