
package codejam2017;

import java.io.File;
import java.io.PrintStream;
import java.util.*;
import java.util.Scanner;


public class ProbC2 {


	private static boolean DEBUG = false;

	private PrintStream out;
	private PrintStream debug;


	long[] klist;
	long[] vlist;
	int listlen = 0;

	private void addList(long k, long v) {

		if (k == 0)
			return;

		int len = listlen;
		for (int i = 0; i < len; i++) {
			if (klist[i] == k) {
				vlist[i] += v;

				return;
			}
		}

		klist[listlen] = k;
		vlist[listlen] = v;
		listlen++;
	}


	private long[] solveAcase(long N, long K) {
		long[] maxmin = new long[2];

		if (N == K) {
			maxmin[0] = 0;
			maxmin[1] = 0;
			return maxmin;
		}

		klist = new long[2000];
		vlist = new long[2000];
		listlen = 0;

		int indx = 0;

		addList(N, 1L);

		indx = 0;

		while (true) {

			long stalls = klist[indx];
			if (stalls == 1)
				break;

			long v = vlist[indx];
			stalls--;

			long sl = stalls / 2;
			long sr = sl;

			if (stalls % 2 == 1)
				sr++;

			addList(sr, v);
			addList(sl, v);

			indx++;
		}

		debug.format("\nN: %d (%d), K: %d\n", N, listlen, K);
		for (int i = 0; i < listlen; i++) {
			debug.format(" %3d", klist[i]);
		}
		debug.format("\n");

		for (int i = 0; i < listlen; i++) {
			debug.format(" %3d", vlist[i]);
		}
		debug.format("\n");

		long total = 0;
		for (int i = 0; i < listlen; i++) {
			total += vlist[i];

			if (total >= K) {
				long stalls = klist[i];

				stalls--;

				long sl = stalls / 2;
				long sr = sl;

				if (stalls % 2 == 1) {
					maxmin[0] = sl + 1;
					maxmin[1] = sl;
				}
				else {
					maxmin[0] = sl;
					maxmin[1] = sl;
				}

				break;
			}
		}

		debug.format("\t%d %d\n", maxmin[0], maxmin[1]);

		//debug.format("\t\t%d, %d\n", maxmin[0], maxmin[1]);

		return maxmin;
	}


	private void solve(Scanner sc) {
		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {

			long N = sc.nextLong();
			long K = sc.nextLong();

			debug.format("Case #%d: %d %d\n", i+1, N, K);

			long[] maxmin = solveAcase(N, K);

			out.format("Case #%d: %d %d\n", i+1, maxmin[0], maxmin[1]);
		}
	}



	public static void main(String[] args) throws Exception {

		DEBUG = true;

		Scanner sc = null;

		ProbC2 prob = new ProbC2();

		if (args.length == 2) {
			String debugfile = args[1] + ".debug";
			prob.out = new PrintStream(args[1]);
			prob.debug = new PrintStream(debugfile);

			sc = new Scanner(new File(args[0]));

			prob.solve(sc);
		}
		else {
			prob.out = System.out;
			prob.debug = System.out;

			long number, N, K;
			String s;

			prob.solveAcase(4, 2);

			prob.solveAcase(5, 3);

			prob.solveAcase(6, 2);

			prob.solveAcase(10, 7);

			prob.solveAcase(13, 4);
			prob.solveAcase(13, 5);
			prob.solveAcase(13, 6);

			prob.solveAcase(15, 7);

			prob.solveAcase(1000, 511);

			prob.solveAcase(1234567890, 7);

			prob.solveAcase(1234567890123456789L, 123456789012345678L);

			/*
			number = 5;
			N = 15;
			for (int i = 1; i < N; i++) {
				prob.solveAcase(N, i);
			}

			prob.solveAcase(4, 2);
			prob.solveAcase(5, 2);
			prob.solveAcase(6, 1);
			prob.solveAcase(6, 2);
			prob.solveAcase(1000, 1000);
			prob.solveAcase(1000, 900);
			prob.solveAcase(1000, 1);
			prob.solveAcase(2, 1);

			for (int i = 1; i < 16; i++) {
				number = i;
				s = prob.toBinary(number);
				prob.out.format("%d %s\n", number, s);
			}
			*/
		}
	}
}
