
package codejam2017;

import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;

public class ProbC {

	private static boolean DEBUG = false;

	private PrintStream out;
	private PrintStream debug;


	private String toBinary(long number) {

		StringBuilder sb = new StringBuilder();

		while (number > 0) {
			if (number % 2 == 0)
				sb.append('0');
			else
				sb.append('1');

			number >>= 1;
		}

		return sb.reverse().toString();
	}

	private long[] solveAcase(long N, long K) {

		long[] maxmin = new long[2];

		if (N == K) {
			maxmin[0] = 0;
			maxmin[1] = 0;
			return maxmin;
		}

		String seq = toBinary(K);
		int len = seq.length();

		long k = K;
		long stalls = N;
		long lstalls = 0;
		long rstalls = 0;

		debug.format("%d %d -> %s\n", N, K, seq);
		for (int i = 0; i < len; i++) {
			stalls--;
			long tmp = stalls / 2;

			lstalls = tmp;
			rstalls = tmp;

			if (stalls % 2 == 1)
				rstalls++;

			if (i == len - 1)
				break;

			char lr = seq.charAt(i+1);


			if (lr == '0') {		// right
				stalls = rstalls;
			}
			else {					// left
				stalls = lstalls;
			}

			debug.format("\t%2d %c (%d, %d, %d)\n", i, lr, stalls, lstalls, rstalls);
		}

		if (lstalls >= rstalls) {
			maxmin[0] = lstalls;
			maxmin[1] = rstalls;
		}
		else {
			maxmin[1] = lstalls;
			maxmin[0] = rstalls;
		}


		debug.format("\t\t%d, %d\n", maxmin[0], maxmin[1]);

		return maxmin;
	}


	private void solve(Scanner sc) {
		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {

			long N = sc.nextLong();
			long K = sc.nextLong();

			debug.format("Case #%d: %d %d\n", i+1, N, K);

			long[] maxmin = solveAcase(N, K);

			out.format("Case #%d: %d %d\n", i+1, maxmin[0], maxmin[1]);
		}
	}


	/////

	private int[] findMaxSeq(char[] table) {
		int[] index = new int[3];

		int n = table.length;
		int f1 = 0;	// from of max
		int t1 = 0;	// to of max
		int max = 0;

		int f, t, m;

		f = t = 0;
		m = 0;
		for (int i = 1; i < n; i++) {
			char c = table[i];

			if (c == 'o') {
				t = i;
				f = t - m;
				if (m > max) {
					f1 = f;
					t1 = t;
					max = m;
				}
				m = 0;
			}
			else {
				m++;
			}
		}

		//debug.format("\t%d %d\n", f, t);

		index[0] = f1;
		index[1] = t1;

		return index;
	}


	private long[] solveAcaseSmall(long N, long K) {
		long[] maxmin = new long[2];

		debug.format("%d %d\n", N, K);

		if (N == K) {
			maxmin[0] = 0;
			maxmin[1] = 0;
			return maxmin;
		}

		char[] table = new char[(int)N+2];


		for (int i = 0; i < table.length; i++) {
			table[i] = '.';
		}
		table[0] = 'o';
		table[table.length-1] = 'o';

		int n = (int) K;
		int[] indx = new int[2];
		int mid = 0;
		for (int i = 0; i < n; i++) {
			indx = findMaxSeq(table);

			int from = indx[0];
			int to = indx[1];

			mid = (to - 1 + from)/ 2;

			debug.format("\t%d %d -> %d  (%d, %d)\n", from, to, mid, to-1-mid, mid - from);

			table[mid] = 'o';
		}

		int sr = indx[1] - mid - 1;
		int sl = mid - indx[0];

		if (sr > sl) {
			maxmin[0] = sr;
			maxmin[1] = sl;
		}
		else {
			maxmin[0] = sl;
			maxmin[1] = sr;
		}

		debug.format("\tresult: %d %d\n", maxmin[0], maxmin[1]);

		return maxmin;
	}


	private void solveSmall(Scanner sc) {
		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {

			long N = sc.nextLong();
			long K = sc.nextLong();

			debug.format("Case #%d: %d %d\n", i+1, N, K);

			long[] maxmin = solveAcaseSmall(N, K);

			out.format("Case #%d: %d %d\n", i+1, maxmin[0], maxmin[1]);
		}
	}

	public static void main(String[] args) throws Exception {

		DEBUG = true;

		Scanner sc = null;

		ProbC prob = new ProbC();

		if (args.length == 3) {
			String debugfile = args[1] + ".debug";
			prob.out = new PrintStream(args[1]);
			prob.debug = new PrintStream(debugfile);

			sc = new Scanner(new File(args[0]));

			String type = args[2];

			if ("S".equals(type))
				prob.solveSmall(sc);
			else {
				prob.solve(sc);
			}
		}
		else {
			prob.out = System.out;
			prob.debug = System.out;

			long number, N, K;
			String s;

			prob.solveAcaseSmall(4, 1);
			prob.solveAcaseSmall(10, 2);
			prob.solveAcaseSmall(15, 2);
			prob.solveAcaseSmall(999, 127);

			prob.solveAcaseSmall(13, 5);
			prob.solveAcase(13, 5);

			prob.solveAcaseSmall(13, 6);
			prob.solveAcase(13, 6);

			/*
			number = 5;
			N = 15;
			for (int i = 1; i < N; i++) {
				prob.solveAcase(N, i);
			}

			prob.solveAcase(4, 2);
			prob.solveAcase(5, 2);
			prob.solveAcase(6, 1);
			prob.solveAcase(6, 2);
			prob.solveAcase(1000, 1000);
			prob.solveAcase(1000, 900);
			prob.solveAcase(1000, 1);
			prob.solveAcase(2, 1);

			for (int i = 1; i < 16; i++) {
				number = i;
				s = prob.toBinary(number);
				prob.out.format("%d %s\n", number, s);
			}
			*/
		}
	}
}
