

package codejam2016;

import java.io.File;
import java.util.*;



public class Digits {


	static boolean DEBUG = false;

	static String[] D = { "ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE" };

	/*
	 *  0 -> z
	 *  1 ->
	 *  2 -> w
	 *  3 ->
	 *  4 -> u
	 *  5 ->
	 *  6 -> x
	 *  7 ->
	 *  8 -> g
	 *  9 ->
	 *
	 * f -> 4, 5
	 * v -> 5, 7
	 * c, d, k, l, m, p, q, r, s
	 *
	 */


	private int[] makeMap(String s) {
		int[] map = new int[26];

		for (int i = 0; i < s.length(); i++) {
			char c = s.charAt(i);

			int indx = c - 'A';
			map[indx]++;
		}

		return map;
	}


	private boolean existAndRemove(int[] map, String number) {

		boolean e = true;
		for (int i = 0; i < number.length(); i++) {
			int indx = number.charAt(i) - 'A';

			map[indx]--;
			if (map[indx] < 0) {
				e = false;
			}
		}

		if (e == true)
			return true;

		// recover
		for (int i = 0; i < number.length(); i++) {
			int indx = number.charAt(i) - 'A';
			map[indx]++;
		}

		return false;
	}


	private String solve(String s) {

		StringBuilder sb = new StringBuilder();

		int[] map = makeMap(s);
		for (int i = 0; i < D.length; i++) {
			String number = D[i];

			if (existAndRemove(map, number) == true) {
				sb.append(i);

				if (DEBUG)
					System.out.format("%d ", i);

				i--;
			}
		}

		String r = sb.toString();

		return r;
	}


	private void valid(int[] map) {
		if (DEBUG == false)
			return;

		for (int i = 0; i < map.length; i++) {
			if (map[i] > 0)
				System.out.format(" %c - %d ", i + 'A', map[i]);
		}
		System.out.format("\n");
	}

	private String solve2(String s) {

		StringBuilder sb = new StringBuilder();

		int[] map = makeMap(s);

		// zero
		while (map['Z' - 'A'] > 0) {
			int indx = 0;
			if (existAndRemove(map, D[indx]) == true)
				sb.append(indx);
		}

		// two
		while (map['W' - 'A'] > 0) {
			int indx = 2;
			if (existAndRemove(map, D[indx]) == true)
				sb.append(indx);
		}

		// four
		while (map['U' - 'A'] > 0) {
			int indx = 4;
			if (existAndRemove(map, D[indx]) == true)
				sb.append(indx);
		}

		// siz
		while (map['X' - 'A'] > 0) {
			int indx = 6;
			if (existAndRemove(map, D[indx]) == true)
				sb.append(indx);
		}

		// eight
		while (map['G' - 'A'] > 0) {
			int indx = 8;
			if (existAndRemove(map, D[indx]) == true)
				sb.append(indx);
		}


		for (int i = 0; i < D.length; i++) {
			String number = D[i];

			if (existAndRemove(map, number) == true) {
				sb.append(i);

				i--;
			}
		}

		String r = sb.toString();

		char[] re = r.toCharArray();

		Arrays.sort(re);

		valid(map);

		return new String(re);
	}


	private void solve(Scanner sc) {

		int T = sc.nextInt();

		for (int i = 0; i < T; i++) {
			String s = sc.next();
			String r = solve2(s);

			System.out.format("Case #%d: %s\n", i+1, r);
		}

	}

	public static void main(String[] args) throws Exception {

		Scanner sc = null;

		Digits digits = new Digits();

		if (args.length == 1) {
			sc = new Scanner(new File(args[0]));

			DEBUG = false;

			digits.solve(sc);
		}
	}
}
