/**
 */
package codejam2016;

import java.io.File;
import java.util.*;


public class CoinJam {

	private static boolean DEBUG = false;


	private int pcount;

	private boolean isPrime1(long n) {
		pcount = 1;
		if (n == 1) return false;

		if (n == 2) return true;
		if (n == 3) return true;
		if (n == 5) return true;

		if (n % 2 == 0) return false;
		if (n % 3 == 0) return false;
		if (n % 5 == 0) return false;

		long k = (long) Math.sqrt(n);
		for (long i = 7; i <= k; i += 2) {
			pcount++;

			if (n % i == 0) return false;
		}

		return true;
	}


	private boolean isPrime2(long n) {
		pcount = 1;

		if (n == 1) return false;

		if (n == 2) return true;
		if (n == 3) return true;

		if (n % 2 == 0) return false;
		if (n % 3 == 0) return false;

		int i = 5;
		while (i * i <= n) {

			if (n % i == 0)
				return false;
			if (n % (i+2) == 0)
				return false;

			i += 6;
			pcount++;
		}

		return true;
	}


	private Long[] primeFactors(long n) {
		List<Long> factors = new ArrayList<Long>();

		long d = 2;
		while (n > 1) {
			while (n % d == 0) {
				factors.add(d);
				n /= d;
			}
			d++;

			if (d*d > n) {
				if (n > 1)
					factors.add(n);
				break;
			}
		}

		Long[] r = factors.toArray(new Long[0]);

		return r;
	}

	private long primeFactor1(long n) {
		List<Long> factors = new ArrayList<Long>();

		long d = 2;
		while (n > 1) {
			while (n % d == 0) {
				return d;
			}
			d++;

			if (d*d > n) {
				if (n > 1)
					return d;
			}
		}

		return 0;
	}



	private long parse(String numberstring, int base) {
		return Long.parseLong(numberstring, base);
	}


	private long[] jamcoin(String numberString) {
		long[] numbers = new long[9];

		for (int base = 2; base <= 10; base++) {
			long number = parse(numberString, base);

			boolean prime1 = isPrime1(number);

			if (prime1 == true)
				return null;

			numbers[base-2] = number;

			if (DEBUG) {
				int pcount1 = pcount;

				boolean prime2 = isPrime2(number);
				int pcount2 = pcount;

				System.out.format("\t%s\t%8d (%2d)\t%b %b\t%4d %4d\n", numberString, number, base, prime1, prime2, pcount1, pcount2);

			}
		}

		return numbers;
	}


	private long[] solve(String numberString) {

		long[] numbers = jamcoin(numberString);

		if (numbers == null)
			return null;

		long[] pfactors = new long[numbers.length];
		for (int i = 0; i < numbers.length; i++) {
			long number = numbers[i];

			long pfactor = primeFactor1(number);
			pfactors[i] = pfactor;

			if (DEBUG) {
				System.out.format("\t%d\t%d\n", number, pfactor);
			}
		}

		return pfactors;
	}

	private String toBinary(long n, int len) {

		char[] ret = new char[len];
		for (int i = len - 1; i >= 0; i--) {

			if (n % 2 == 0) {
				ret[i] = '0';
			}
			else {
				ret[i] = '1';
			}

			n /= 2;
		}

		return new String(ret);
	}

	private void solve(int N, int J) {
		int n = N - 2;
		long max = (long) Math.pow(2, n);

		int success = 0;
		for (long i = 0; i < max; i++) {
			String numberString = "1" + toBinary(i, n) + "1";

			long[] pfactors = solve(numberString);
			if (pfactors == null)
				continue;

			success++;

			System.out.format("%s", numberString);
			for (int j = 0; j < pfactors.length; j++)
				System.out.format(" %d", pfactors[j]);

			System.out.format("\n");

			if (success >= J)
				return;
		}
	}

	private void solve(Scanner sc) {
		int T = sc.nextInt();
		int N = sc.nextInt();
		int J = sc.nextInt();

		System.out.format("Case #1:\n");
		solve(N, J);
	}


	public static void main(String[] args) throws Exception {
		Scanner sc = null;

		CoinJam coinjam = new CoinJam();

		if (args.length == 1) {
			sc = new Scanner(new File(args[0]));

			coinjam.solve(sc);
		}
		else {
			DEBUG = false;

			//coinjam.solve(6, 3);
			coinjam.solve("1001");
			System.out.format("\n");

			coinjam.solve("100011");
			System.out.format("\n");

			coinjam.solve("110111");

			coinjam.solve(6, 3);
			coinjam.solve(19, 200);
		}
	}
}
