
package codejam2017;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;


public class ProbR1BA extends Prob {


	private double solveAcase(int N, double D, double[] Ks, double[] Ss) {
		double y = 0.;

		double[] hours = new double[N];

		for (int i = 0; i < N; i++) {

			double distance = D - Ks[i];
			hours[i] = distance / Ss[i];
		}

		Arrays.sort(hours);

		y = D / hours[N-1];

		return y;
	}


	private void solve(Scanner sc) {
		int T = sc.nextInt();

		for (int t = 0; t < T; t++) {
			double D = (double) sc.nextInt();
			int N =  sc.nextInt();

			double[] Ks = new double[N];
			double[] Ss = new double[N];

			for (int i = 0; i < N; i++) {
				Ks[i] = (double) sc.nextInt();
				Ss[i] = (double) sc.nextInt();
			}

			double y = solveAcase(N, D, Ks, Ss);

			out.format("Case #%d: %.6f\n", t+1, y);
		}
	}


	public static void main(String[] args) throws Exception {

		DEBUG = true;

		Scanner sc = null;

		ProbR1BA prob = new ProbR1BA();

		if (args.length == 1) {
			String infile = args[0];
			String outfile = args[0] + ".out";
			String debugfile = args[0] + ".debug";

			prob.out = new PrintStream(outfile);
			prob.debug = new PrintStream(debugfile);

			sc = new Scanner(new File(infile));

			prob.solve(sc);
		}
		else {
			prob.out = System.out;
			prob.debug = System.out;

		}
	}
}
