

import java.io.*;
import java.util.*;


public class Prob1 {

  private String inFile = null;         // input file name
  private String outFile = null;        // output file name

  final static boolean debug = true;

  public Prob1(String inFile, String outFile) {
    this.inFile = inFile;
    this.outFile = outFile;
  }


  private long solveACase(int n, long[][] v) {
    if (n == 1) return v[0][0] * v[1][0];

    Arrays.sort(v[0]);
    Arrays.sort(v[1]);

    long res = 0;
    for (int i = 0; i < n; i++) {
      res += v[0][i] * v[1][n-1-i];
    }

    return res;
  }


  public void solveAll() {
    try {
      // open input/output files
      LineNumberReader lnr = new LineNumberReader(new FileReader(inFile));
      Writer out = new BufferedWriter(new FileWriter(outFile));

      String str = lnr.readLine();      // read cases
      int cases = Integer.parseInt(str);

      // solve the cases
      for (int i = 0; i < cases; i++) {
        str = lnr.readLine();           // read the number of vectors
        int v_count = Integer.parseInt(str);

        String tmp;
        long[][] v = new long[2][v_count];

        tmp = lnr.readLine();
        String[] items = tmp.split(" ");
        for (int j = 0; j < items.length; j++) {
          v[0][j] = Long.parseLong(items[j]);
        }

        tmp = lnr.readLine();
        items = tmp.split(" ");
        for (int j = 0; j < items.length; j++) {
          v[1][j] = Long.parseLong(items[j]);
        }

        long ret = solveACase(v_count, v);

        out.write("Case #" + (i + 1) + ": " + ret + "\n");

        if (debug)
          System.out.println("Case #" + (i + 1) + ": " + ret);
      }

      lnr.close();
      out.close();
    }
    catch (Exception ex) {
      System.err.println("Exception - " + ex.getMessage());
      ex.printStackTrace();
    }
  }


  public static void main(String[] args) {
    if (args.length != 2) {
      System.err.println("Usage: java Prob1 <input file> <output file>");
      return;
    }

    Prob1 prob = new Prob1(args[0], args[1]);

    prob.solveAll();
  }
}

// end
