import java.io.BufferedReader;
import java.io.FileReader;
import java.math.*;


public class UglyNumbers {
   private static enum Opers {OPER_PLUS, OPER_MINUS};

   private static int readNumber (BufferedReader reader)
         throws Exception {
      String line = reader.readLine();

      if (line == null) {
         throw new Exception (
            "End of file unexpected");
      }

      return Integer.parseInt(line.trim());
   }

   private static String readString (BufferedReader reader)
         throws Exception {
      String line = reader.readLine();

      if (line == null) {
         throw new Exception (
            "End of file unexpected");
      }

      return line.trim();
   }

   private static BigInteger BigTwo = new BigInteger ("2");
   private static BigInteger BigThree = new BigInteger ("3");
   private static BigInteger BigFive = new BigInteger ("5");
   private static BigInteger BigSeven = new BigInteger ("7");

   private static int uglyNumbers (String digits
         , BigInteger subtotal, Opers oper, BigInteger number) {
      int uglies = 0;

      if (digits.length () == 0) {
         switch (oper) {
            case OPER_PLUS:
               subtotal = subtotal.add (number);
               break;
            case OPER_MINUS:
               subtotal = subtotal.add (number.negate ());
               break;
         }

         if (subtotal.mod (BigTwo).equals (BigInteger.ZERO) ||
             subtotal.mod (BigThree).equals (BigInteger.ZERO) ||
             subtotal.mod (BigFive).equals (BigInteger.ZERO) ||
             subtotal.mod (BigSeven).equals (BigInteger.ZERO)) {
            return 1;
         } else {
            return 0;
         }
      }

      String rest = digits.substring (1);
      BigInteger digit = new BigInteger (digits.substring (0, 1));

      uglies += uglyNumbers (rest, subtotal, oper
         , number.multiply (BigInteger.TEN).add (digit));

      switch (oper) {
         case OPER_PLUS:
            subtotal = subtotal.add (number);
            break;
         case OPER_MINUS:
            subtotal = subtotal.add (number.negate ());
            break;
      }

      uglies += uglyNumbers (rest, subtotal, Opers.OPER_PLUS, digit);
      uglies += uglyNumbers (rest, subtotal, Opers.OPER_MINUS, digit);

      return uglies;
   }

   public static void main (String[] args) {
      if (args.length == 0) {
         System.err.println ("Uso: UglyNumbers <fichero>");
         return;
      }

      try {
         BufferedReader reader
            = new BufferedReader (
               new FileReader (args[0]));

         int nCases = readNumber (reader);

         for (int i = 0; i < nCases; i++) {
            String digits = readString (reader);

            System.out.println ("Case #" + (i+1) + ": " +
               uglyNumbers (digits.substring (1), BigInteger.ZERO, Opers.OPER_PLUS
                   , new BigInteger (digits.substring (0, 1))));
         }
      } catch (Exception e) {
         e.printStackTrace();
      }
   }
}
