import java.io.*;


public class CropTriangles {

   private static class Point {
      private long x, y;

      Point (long x, long y) {
         this.x = x;
         this.y = y;
      }
   }


   private static int readNumber (BufferedReader reader)
         throws Exception {
      String line = reader.readLine();

      if (line == null) {
         throw new Exception (
            "End of file unexpected");
      }

      return Integer.parseInt(line.trim());
   }

   private static String readString (BufferedReader reader)
         throws Exception {
      String line = reader.readLine();

      if (line == null) {
         throw new Exception (
            "End of file unexpected");
      }

      return line.trim();
   }

   private static long cropTriangles (
         int n, long A, long B, long C, long D, long x0, long y0, long M) {
      Point[] trees = new Point[n];

      long x = x0, y = y0;

      trees[0] = new Point (x, y);

      for (int i = 1; i < n; i++) {
         x = (A*x + B)%M;
         y = (C*y + D)%M;
         trees[i] = new Point (x, y);
      }

      long triangles = 0;

      for (int i = 0; i < n; i++) {
         for (int j = i+1; j < n; j++) {
            for (int k = j+1; k < n; k++) {
               if (((trees[i].x + trees[j].x + trees[k].x)%3 == 0) &&
                   ((trees[i].y + trees[j].y + trees[k].y)%3 == 0)) {
                  triangles++;
               }
            }
         }
      }

      return triangles;
   }

   public static void main (String[] args) {
      if (args.length == 0) {
         System.err.println ("Uso: CropTriangles <fichero>");
         return;
      }

      try {
         BufferedReader reader
            = new BufferedReader (
               new FileReader (args[0]));

         int nCases = readNumber (reader);

         for (int i = 0; i < nCases; i++) {
            String[] data = readString (reader).split(" ");

            int n = Integer.parseInt (data[0]);
            long A = Long.parseLong (data[1]);
            long B = Long.parseLong (data[2]);
            long C = Long.parseLong (data[3]);
            long D = Long.parseLong (data[4]);
            long x0 = Long.parseLong (data[5]);
            long y0 = Long.parseLong (data[6]);
            long M = Long.parseLong (data[7]);

            System.out.println ("Case #" + (i+1) + ": " +
               cropTriangles (n, A, B, C, D, x0, y0, M));
         }
      } catch (Exception e) {
         e.printStackTrace();
      }
   }
}
