import java.io.*;
import java.util.*;


public class TextMessaging {

   private static int readNumber (BufferedReader reader)
         throws Exception {
      String line = reader.readLine();

      if (line == null) {
         throw new Exception (
            "End of file unexpected");
      }

      return Integer.parseInt(line.trim());
   }

   private static String readString (BufferedReader reader)
         throws Exception {
      String line = reader.readLine();

      if (line == null) {
         throw new Exception (
            "End of file unexpected");
      }

      return line.trim();
   }

   private static int keysPressed (int numKeys, int numLetters, int[] freqLetters) {
      Arrays.sort (freqLetters);

      int row = 1;
      int letter = numLetters-1;

      int total = 0;

      while (letter >= 0) {
         int subtotal = 0;

         for (int i = 0; i < numKeys; i++) {
            subtotal += freqLetters[letter];

            if (--letter < 0) {
               break;
            }
         }

         total += subtotal*row;
         row++;
      }

      return total;
   }

   public static void main (String[] args) {
      if (args.length == 0) {
         System.err.println ("Uso: UglyNumbers <fichero>");
         return;
      }

      try {
         BufferedReader reader
            = new BufferedReader (
               new FileReader (args[0]));

         int nCases = readNumber (reader);

         for (int i = 0; i < nCases; i++) {
            String[] data = readString (reader).split (" ");

            int numKeys = Integer.parseInt (data[1]);
            int numLetters = Integer.parseInt (data[2]);

            data = readString (reader).split (" ");

            int[] freqLetters = new int[numLetters];

            for (int j = 0; j < numLetters; j++) {
               freqLetters[j] = Integer.parseInt (data[j]);
            }

            System.out.println ("Case #" + (i+1) + ": " +
               keysPressed (numKeys, numLetters, freqLetters));
         }
      } catch (Exception e) {
         e.printStackTrace();
      }
   }
}
