/*
 * @author Mingxuan Zha
 * @date April 2017, created
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

import javax.swing.JFileChooser;

public class ProblemA {
	public static void main (String[] args)throws Exception{
		ProblemA myMain = new ProblemA();
		JFileChooser ourChooser = new JFileChooser(".");
		int retval = ourChooser.showOpenDialog(null);
	    if (retval == JFileChooser.APPROVE_OPTION) {
	        File file = ourChooser.getSelectedFile();
	        Scanner input = new Scanner(file);
	        int testSize = Integer.parseInt(input.nextLine());
	        for(int i=0; i<testSize; i++){
	        	String s = input.nextLine();
	        	System.out.println("Case #"+(i+1)+": "+getResult(s));
	        }
	    }
	}
	
	public static String getResult(String s){
		// making boolean array to represent faces of each pancake
		String[] split = s.split(" ");
		int flipSize = Integer.parseInt(split[1]);
		boolean[] faces = new boolean[split[0].length()];
		int index = faces.length; // finding start index
		boolean first = true;
		for (int i=0; i<faces.length; i++) {
			if(split[0].charAt(i) == '+') {
				faces[i] = true;
			}
			if(split[0].charAt(i) == '-' && first) {
				index = i;
				first = false;
			}
		}
		// process the array
		int actions = 0;
		boolean possible = false;
		while (faces.length >= index){
			if (index == faces.length) {
				possible = true;
				break;
			}
			if (faces.length - index < flipSize) {
				possible = false;
				break;
			}
			// swap
			for (int i=0; i<flipSize; i++) {
				if (faces[index+i]) {
					faces[index+i] = false;
				} else {
					faces[index+i] = true;
				}
			}
			int cur = index;
			index = faces.length;
			for (int j=cur; j<faces.length; j++) {
				if (!faces[j]) {
					index = j;
					break;
				}
			}
			actions++;
		}
		
		if (possible) {
			return ""+actions;
		} else {
			return "IMPOSSIBLE";
		}
	}
}