/*
 * @author Mingxuan Zha
 * @date April 2016, created
 */

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.*;

import javax.swing.JFileChooser;

public class ProblemC {
	public static TreeSet<Long> primes = new TreeSet<>();
	public static void main (String[] args)throws Exception{
		ProblemC myMain = new ProblemC();
		JFileChooser ourChooser = new JFileChooser(".");
		int retval = ourChooser.showOpenDialog(null);
	    if (retval == JFileChooser.APPROVE_OPTION) {
	        File file = ourChooser.getSelectedFile();
	        Scanner input = new Scanner(file);
	        int testSize = Integer.parseInt(input.nextLine());
	        for(int i=0; i<testSize; i++){
	        	System.out.println("Case #"+(i+1)+":");
	        	String s = input.nextLine();
	        	String[] sa = s.split(" ");
	        	int len = Integer.parseInt(sa[0]);
	        	int num = Integer.parseInt(sa[1]);
	        	getAllPrimes(len);
	        	getResult(len, num);
	        }
	    }
	}
	
	public static void getAllPrimes(int len){
		primes.clear();
		primes.add((long)2);
		long ceiling = (long) Math.sqrt(Math.sqrt(Math.pow(10, len)-1));
		//find all primes under ceiling
		for(long i=3; i<ceiling; i++){
			boolean isPrime = true;
			for(long x: primes){
				if(i%x==0){
					isPrime = false;
					break;
				}
			}
			if(isPrime){
				primes.add(i);
//				System.out.println(i);
			}
		}
	}
	
	public static void getResult(int len, int num){
		String number = String.valueOf((long)Math.pow(10, len-1));
		for(int i=0; i<num; i++){
			int div2, div3, div4, div5, div6, div7, div8, div9, div10;
			while((div10 = getDiv(number,10)) == -1 || (div9 = getDiv(number,9)) == -1 ||
					(div8 = getDiv(number,8)) == -1 || (div7 = getDiv(number,7)) == -1 ||
					(div6 = getDiv(number,6)) == -1 || (div5 = getDiv(number,5)) == -1 ||
					(div4 = getDiv(number,4)) == -1 || (div3 = getDiv(number,3)) == -1 ||
					(div2 = getDiv(number,2)) == -1 || number.endsWith("0")){
				long numberAddOne = Long.parseLong(number, 2)+(long)1;
				number = Long.toBinaryString(numberAddOne);
			}
			System.out.println(Long.parseLong(number)+" "+div2+" "+div3+" "+div4+" "+
			div5+" "+div6+" "+div7+" "+div8+" "+div9+" "+div10);
			long numberAddOne = Long.parseLong(number, 2)+1;
			number = Long.toBinaryString(numberAddOne);
		}
	}
	
	public static int getDiv(String n, int radix){
		long number = Long.parseLong(n, radix);
//		System.out.println(number);
		if(primes.contains(number)){
			return -1;
		}
		else{
			for(long x:primes){
				if(number%x == 0){
//					System.out.println(number+": "+x);
					return (int)x;
				}
			}
			return -1;
		}
	}

}
