import java.util.*;

public class C {
    static Scanner sc;
    static Set<String> english;
    static Set<String> french;
    static Set<String> both;
    static List<String> sentences;

    public static int recurse(int n) {
        if (n >= sentences.size()) return both.size();

        Set<String> eng = new HashSet<String>(english);
        Set<String> fra = new HashSet<String>(french);
        Set<String> bo = new HashSet<String>(both);

        String curr = sentences.get(n);
        List<String> words = Arrays.asList(curr.split(" "));

        // assume english
        for (String word : words) {
            if (both.contains(word)) {
                continue;
            } else if (french.contains(word)) {
                french.remove(word);
                both.add(word);
            } else {
                english.add(word);
            }
        }

        int a = recurse(n+1);

        // restore sets
        english = eng;
        french = fra;
        both = bo;

        // assume french now
        for (String word : words) {
            if (both.contains(word)) {
                continue;
            } else if (english.contains(word)) {
                english.remove(word);
                both.add(word);
            } else {
                french.add(word);
            }
        }

        int b = recurse(n+1);

        // restore sets
        english = eng;
        french = fra;
        both = bo;

        return Math.min(a, b);
    }

    public static int solve() {
        int n = sc.nextInt();
        // get blank line
        sc.nextLine();

        sentences = new ArrayList<String>();

        // english
        String e = sc.nextLine();
        sentences.add(e);
        List<String> eng = Arrays.asList(e.split(" "));
        english = new HashSet<String>(eng);

        // french
        String f = sc.nextLine();
        sentences.add(f);
        List<String> fra = Arrays.asList(f.split(" "));
        french = new HashSet<String>();
        both = new HashSet<String>();

        for (String s : fra) {
            if (english.contains(s)) {
                english.remove(s);
                both.add(s);
            } else {
                french.add(s);
            }
        }

        //System.out.println(english);
        //System.out.println(french);
        //System.out.println(both);

        for (int i = 2; i < n; ++i) {
            sentences.add(sc.nextLine());
        }

        return recurse(2);
    }

    public static void main(String[] args) {
        sc = new Scanner(System.in);
        int t = sc.nextInt();
        for (int i = 1; i <= t; ++i) {
            System.out.println("Case #" + i + ": " + solve());
        }
    }
}
