package net.ujjwal.google.codejam.round1c;

import java.util.Scanner;

public class CenterOfMass {

    private int[]  x;
    private int[]  y;
    private int[]  z;
    private int[]  vX;
    private int[]  vY;
    private int[]  vZ;
    private int    n;
    private double xCom;
    private double yCom;
    private double zCom;
    private double xVNet;
    private double yVNet;
    private double zVNet;
    private double dMin;
    private double tMin;

    public CenterOfMass(Scanner scanner) {
        n = scanner.nextInt();
        x = new int[n];
        y = new int[n];
        z = new int[n];
        vX = new int[n];
        vY = new int[n];
        vZ = new int[n];
        double xSum = 0, ySum = 0, zSum = 0, xVsum = 0, yVsum = 0, zVsum = 0;
        for (int i = 0; i < n; ++i) {
            x[i] = scanner.nextInt();
            xSum += x[i];
            y[i] = scanner.nextInt();
            ySum += y[i];
            z[i] = scanner.nextInt();
            zSum += z[i];
            vX[i] = scanner.nextInt();
            xVsum += vX[i];
            vY[i] = scanner.nextInt();
            yVsum += vY[i];
            vZ[i] = scanner.nextInt();
            zVsum += vZ[i];
        }
        xCom = xSum / n;
        yCom = ySum / n;
        zCom = zSum / n;
        xVNet = xVsum / n;
        yVNet = yVsum / n;
        zVNet = zVsum / n;
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt();
        for (int i = 1; i <= t; ++i) {
            CenterOfMass mass = new CenterOfMass(scanner);
            mass.findClosestPointAndTime();
            System.out.printf("Case #%d: %.8f %.8f%n", i, mass.dMin(), mass
                    .tMin());
        }
    }

    private double tMin() {
        return tMin;
    }

    private double dMin() {
        return dMin;
    }

    private void findClosestPointAndTime() {
        double t0distance = getDistance(0, 0, 0, xCom, yCom, zCom);
        if (dotProduct(xVNet, yVNet, zVNet, xVNet, yVNet, zVNet) == 0) {
            dMin = t0distance;
            tMin = 0;
        } else {
            tMin = dotProduct(xCom, yCom, zCom, xVNet, yVNet, zVNet);
            tMin /= dotProduct(xVNet, yVNet, zVNet, xVNet, yVNet, zVNet);
            tMin = -tMin;
            if (tMin < 0) {
                tMin = 0;
                dMin = t0distance;
            } else {
                double xDest = xCom + xVNet * tMin;
                double yDest = yCom + yVNet * tMin;
                double zDest = zCom + zVNet * tMin;
                dMin = getDistance(0, 0, 0, xDest, yDest, zDest);
            }
        }
        tMin = Math.abs(tMin);
        dMin = Math.abs(dMin);
    }

    private double dotProduct(double x1, double y1, double z1, double x2,
            double y2, double z2) {
        int sum = 0;
        sum += x1 * x2;
        sum += y1 * y2;
        sum += z1 * z2;
        return sum;
    }

    public static double getDistance(double x1, double y1, double z1,
            double x2, double y2, double z2) {
        return Math.sqrt(Math.pow(x1 - x2, 2) + Math.pow(y1 - y2, 2)
                + Math.pow(z1 - z2, 2));
    }
}
