package net.ujjwal.google.codejam.round2;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.SortedSet;
import java.util.TreeSet;


public class WorldCup
{

    private int                 p;
    private int[]               m;
    private List<List<Integer>> ticketPrices;

    public WorldCup(Scanner in)
    {
        this.p = in.nextInt();
        this.m = new int[1 << p];
        for (int i = 0; i < (1 << p); ++i)
        {
            m[i] = in.nextInt();
        }
        this.ticketPrices = new ArrayList<List<Integer>>();
        for (int i = 0; i < p; ++i)
        {
            List<Integer> roundTickets = new ArrayList<Integer>();
            for (int j = 0; j < (1 << (p - i - 1)); ++j)
            {
                roundTickets.add(in.nextInt());
            }
            ticketPrices.add(roundTickets);
        }
    }

    /**
     * @param args
     * @throws FileNotFoundException 
     */
    public static void main(String[] args) throws FileNotFoundException
    {
        Scanner in = new Scanner(System.in);
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i)
        {
            WorldCup cup = new WorldCup(in);
            System.out.printf("Case #%d: %d%n", i, cup.getCost());
        }
    }

    private int getCost()
    {
        int cost = 0;
        List<SortedSet<Integer>> gameTeams = new ArrayList<SortedSet<Integer>>();
        for (int i = 0; i < (1 << p); ++i)
        {
            SortedSet<Integer> gameTeam = new TreeSet<Integer>();
            gameTeam.add(i);
            gameTeam.add(++i);
            gameTeams.add(gameTeam);
        }
        int[] mCopy = Arrays.copyOf(m, m.length);
        for (int round = 0; round < p; ++round)
        {
            List<Integer> roundTickets = this.ticketPrices.get(round);
            for (int game = 0; game < roundTickets.size(); ++game)
            {
                Integer gameTicket = roundTickets.get(game);
                SortedSet<Integer> gameTeam = gameTeams.get(game);
                boolean watchGame = false;
                for (Integer team : gameTeam)
                {
                    if (mCopy[team] == 0)
                    {
                        // we need to watch this game
                        watchGame = true;
                        break;
                    }
                }
                if (watchGame)
                {
                    cost += gameTicket;
                }
                else
                {
                    // We've lost one opportunity for each of the teams
                    for (Integer team : gameTeam)
                    {
                        mCopy[team]--;
                    }
                }
            }
            List<SortedSet<Integer>> mergedGameTeams = new ArrayList<SortedSet<Integer>>();
            for (int i = 0; i < gameTeams.size(); ++i)
            {
                if (i % 2 == 0)
                {
                    mergedGameTeams.add(gameTeams.get(i));
                }
                else
                {
                    mergedGameTeams.get(mergedGameTeams.size() - 1).addAll(gameTeams.get(i));
                }
            }
            gameTeams = mergedGameTeams;
        }
        return cost;
    }

}
