package net.ujjwal.google.codejam11.quals;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;
import java.util.TreeMap;
import java.util.TreeSet;


public class Magicka
{

    private int                               c;
    private int                               d;
    private int                               n;
    Map<Character, Map<Character, Character>> combinations      = new TreeMap<Character, Map<Character, Character>>();
    Map<Character, Set<Character>>            oppositions       = new TreeMap<Character, Set<Character>>();
    private String                            invoked;
    private List<Character>                   finalElementsList = new ArrayList<Character>();

    public Magicka(Scanner scanner)
    {
        this.c = scanner.nextInt();
        for (int i = 0; i < c; ++i)
        {
            String combination = scanner.next();
            assert (combination.length() == 3);
            Character base1 = combination.charAt(0);
            Character base2 = combination.charAt(1);
            Character nonBase = combination.charAt(2);
            if (!combinations.containsKey(base1))
            {
                combinations.put(base1, new TreeMap<Character, Character>());
            }
            if (!combinations.containsKey(base2))
            {
                combinations.put(base2, new TreeMap<Character, Character>());
            }
            combinations.get(base1).put(base2, nonBase);
            combinations.get(base2).put(base1, nonBase);
        }
        this.d = scanner.nextInt();
        for (int i = 0; i < d; ++i)
        {
            String opposition = scanner.next();
            assert (opposition.length() == 2);
            Character opp1 = opposition.charAt(0);
            Character opp2 = opposition.charAt(1);
            if (!oppositions.containsKey(opp1))
            {
                oppositions.put(opp1, new TreeSet<Character>());
            }
            if (!oppositions.containsKey(opp2))
            {
                oppositions.put(opp2, new TreeSet<Character>());
            }
            oppositions.get(opp1).add(opp2);
            oppositions.get(opp2).add(opp1);
        }
        this.n = scanner.nextInt();
        this.invoked = scanner.next();
        assert (invoked.length() == n);

    }

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt();
        for (int i = 1; i <= t; ++i)
        {
            Magicka magicka = new Magicka(scanner);
            System.out.printf("Case #%d: %s%n", i, magicka.getFinalElementList());
        }
    }

    private List<Character> getFinalElementList()
    {
        invoke();
        return finalElementsList;
    }

    private void invoke()
    {
        for (int i = 0; i < n; ++i)
        {
            Character nextBase = invoked.charAt(i);
            if (finalElementsList.size() > 0)
            {
                Character prevLast = finalElementsList.get(finalElementsList.size() - 1);
                if (combinations.containsKey(prevLast) && combinations.get(prevLast).containsKey(nextBase))
                {
                    Character nonBaseReplacement = combinations.get(prevLast).get(nextBase);
                    finalElementsList.set(finalElementsList.size() - 1, nonBaseReplacement);
                }
                else if (oppositions.containsKey(nextBase))
                {
                    Set<Character> opps = oppositions.get(nextBase);
                    for (Character character : opps)
                    {
                        if (finalElementsList.contains(character))
                        {
                            finalElementsList.clear();
                            break;
                        }
                    }
                    if (!finalElementsList.isEmpty())
                    {
                        finalElementsList.add(nextBase);
                    }
                }
                else
                {
                    finalElementsList.add(nextBase);
                }
            }
            else
            {
                finalElementsList.add(nextBase);
            }
        }
    }

}
