package net.ujjwal.google.codejam.round1b;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class FileFixit
{

    private class Dir
    {
        String           name;
        Map<String, Dir> subDirs = new HashMap<String, Dir>();

        @Override
        public int hashCode()
        {
            return name == null ? 0 : name.hashCode();
        }

        @Override
        public boolean equals(Object obj)
        {
            Dir other = (Dir) obj;
            return name == null ? other.name == null : name.equals(name);
        }

    }
    private int              n;
    private int              m;
    private List<String>     existing = new ArrayList<String>();
    private List<String>     needed   = new ArrayList<String>();
    private Map<String, Dir> rootDirs = new HashMap<String, Dir>();

    public FileFixit(Scanner in)
    {
        this.n = in.nextInt();
        this.m = in.nextInt();
        in.nextLine();
        for (int i = 0; i < n; ++i)
        {
            existing.add(in.nextLine());
        }
        for (int i = 0; i < m; ++i)
        {
            needed.add(in.nextLine());
        }
    }

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i)
        {
            FileFixit fixit = new FileFixit(in);
            System.out.printf("Case #%d: %d%n", i, fixit.count());
        }
    }

    private int count()
    {
        for (String dir : existing)
        {
            Map<String, Dir> dirs = rootDirs;
            String[] split = dir.split("/");
            for (int i = 1; i < split.length; ++i)
            {
                String newDirName = split[i];
                Dir newDir;
                if (dirs.containsKey(newDirName))
                {
                    newDir = dirs.get(newDirName);
                }
                else
                {
                    newDir = new Dir();
                    newDir.name = newDirName;
                    dirs.put(newDirName, newDir);
                }
                dirs = newDir.subDirs;
            }
        }
        int count = 0;
        for (String dir : needed)
        {
            Map<String, Dir> dirs = rootDirs;
            String[] split = dir.split("/");
            for (int i = 1; i < split.length; ++i)
            {
                String newDirName = split[i];
                Dir newDir;
                if (dirs.containsKey(newDirName))
                {
                    newDir = dirs.get(newDirName);
                }
                else
                {
                    newDir = new Dir();
                    newDir.name = newDirName;
                    dirs.put(newDirName, newDir);
                    ++count;
                }
                dirs = newDir.subDirs;
            }
        }
        return count;
    }

}
