package net.ujjwal.google.codejam.round1b;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;


public class ChickPickup
{
    private class Chick implements Comparable<Chick>
    {
        int x;
        int v;
        int aheadCount;

        @Override
        public int compareTo(Chick o)
        {
            return (v == o.v) ? x - o.x : v - o.v;
        }

        /* (non-Javadoc)
         * @see java.lang.Object#toString()
         */
        @Override
        public String toString()
        {
            return String.format("Chick [aheadCount=%s, v=%s, x=%s]", aheadCount, v, x);
        }

    }
    private int         n;
    private int         k;
    private int         b;
    private int         t;
    private int[]       x;
    private int[]       v;
    private List<Chick> chicks;

    public ChickPickup(Scanner in)
    {
        this.n = in.nextInt();
        this.k = in.nextInt();
        this.b = in.nextInt();
        this.t = in.nextInt();
        this.x = new int[n];
        for (int i = 0; i < n; ++i)
        {
            x[i] = in.nextInt();
        }
        this.v = new int[n];
        for (int i = 0; i < n; ++i)
        {
            v[i] = in.nextInt();
        }
        this.chicks = new ArrayList<Chick>();
        for (int i = 0; i < n; ++i)
        {
            Chick chick = new Chick();
            chick.x = x[i];
            chick.v = v[i];
            chick.aheadCount = n - i - 1;
            chicks.add(chick);
        }
    }

    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int c = in.nextInt();
        for (int i = 1; i <= c; ++i)
        {
            ChickPickup pickup = new ChickPickup(in);
            System.out.printf("Case #%d: %s%n", i, pickup.numSwaps());
        }
    }

    private String numSwaps()
    {
        // Check impossible case first - assuming infinite swaps
        int count = 0;
        for (int i = 0; i < n; ++i)
        {
            Chick chick = chicks.get(i);
            int finalPos = chick.x + chick.v * t;
            if (finalPos >= b)
                ++count;
        }
        if (count < k)
        {
            return "IMPOSSIBLE";
        }
        List<Chick> sorted = new ArrayList<Chick>(chicks);
        Collections.sort(sorted);
        for (int i = 0; i < n; ++i)
        {
            Chick consider = chicks.get(i);
            for (int j = i + 1; j < n; ++j)
            {
                Chick ahead = chicks.get(j);
                if (ahead.v >= consider.v)
                {
                    --consider.aheadCount;
                }
            }
        }
        for (int i = n - 1; i >= 0; --i)
        {
            Chick consider = chicks.get(i);
            if ((consider.x + consider.v * t) >= b)
            {
                for (int j = i - 1; j >= 0; --j)
                {
                    Chick other = chicks.get(j);
                    if (other.v > consider.v)
                    {
                        --other.aheadCount;
                    }
                }

            }
        }
        int swaps = 0;
        for (int i = n - 1; i >= n - k; --i)
        {
            swaps += sorted.get(i).aheadCount;
        }
        return String.valueOf(swaps);
    }
}
