package net.ujjwal.codejam.gcj14.round1b;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class TheRepeater implements Callable<String> {

	public static void main(String[] args) throws IOException,
			InterruptedException, ExecutionException {
		BufferedReader reader = new BufferedReader(new InputStreamReader(
				System.in));
		int t = Integer.valueOf(reader.readLine());
		List<Future<String>> futures = new ArrayList<Future<String>>();
		ExecutorService executorService = Executors.newCachedThreadPool();
		for (int i = 0; i < t; ++i) {
			TheRepeater repeater = new TheRepeater();
			repeater.readInput(reader);
			futures.add(executorService.submit(repeater));
		}
		for (int i = 1; i <= t; ++i) {
			System.out.printf("Case #%d: %s%n", i, futures.get(i - 1).get());
		}
		executorService.shutdown();
		executorService.shutdownNow();
	}

	class Reps {
		List<Character> characters;
		List<Integer> repetitions;

		Reps(String string) {
			characters = new ArrayList<Character>();
			repetitions = new ArrayList<Integer>();
			char[] charArray = string.toCharArray();
			char lastChar = 0;
			for (char c : charArray) {
				if (c != lastChar) {
					characters.add(c);
					repetitions.add(1);
					lastChar = c;
				} else {
					repetitions.set(repetitions.size() - 1,
							repetitions.get(repetitions.size() - 1) + 1);
				}
			}
		}

		boolean matches(Reps other) {
			return characters.equals(other.characters);
		}

		public int distance(Reps other) {
			if (!matches(other))
				return Integer.MAX_VALUE;
			int d = 0;
			for (int i = 0; i < repetitions.size(); ++i) {
				d += Math.abs(repetitions.get(i) - other.repetitions.get(i));
			}
			return d;
		}
	}

	private int n;
	private List<String> strings = new ArrayList<String>();
	private List<Reps> reps = new ArrayList<Reps>();

	private void readInput(BufferedReader reader) throws IOException {
		this.n = Integer.valueOf(reader.readLine());
		for (int i = 0; i < n; ++i) {
			strings.add(reader.readLine());
		}
	}

	@Override
	public String call() throws Exception {
		for (int i = 0; i < n; ++i) {
			Reps rep = new Reps(strings.get(i));
			reps.add(rep);
			for (int j = i - 1; j >= 0; --j) {
				if (!rep.matches(reps.get(j))) {
					return "Felga Won";
				}
			}
		}
		// reaching here means that Omar is winning. Just need to calculate the
		// distance between the Reps.
		// Solving for small input first.
		int distance = 0;
		for (int i = 0; i < n; ++i) {
			for (int j = i + 1; j < n; ++j) {
				distance += reps.get(i).distance(reps.get(j));
			}
		}
		return String.valueOf(distance);
	}
}
