package net.ujjwal.codejam.gcj14;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class MinesweeperMaster implements Callable<String> {

	private int r;
	private int c;
	private int m;
	private int b;

	public MinesweeperMaster(int r, int c, int m) {
		this.r = r;
		this.c = c;
		this.m = m;
		this.b = r * c - m;
	}

	public static void main(String[] args) throws InterruptedException,
			ExecutionException {
		ExecutorService executorService = Executors.newCachedThreadPool();
		List<Future<String>> futures = new ArrayList<Future<String>>();

		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		for (int i = 1; i <= t; ++i) {
			int r = in.nextInt();
			int c = in.nextInt();
			int m = in.nextInt();
			futures.add(executorService.submit(new MinesweeperMaster(r, c, m)));
		}

		for (int i = 1; i <= t; ++i) {
			System.out.printf("Case #%d:%n%s", i, futures.get(i - 1).get());
		}
		executorService.shutdown();
		executorService.shutdownNow();
	}

	@Override
	public String call() throws Exception {
		StringBuilder builder = new StringBuilder();
		char[][] board = new char[r][c];
		boolean valid = true;
		int mines = 0;
		int blanks = 0;
		if (b == 1) {
			valid = true;
			board[r - 1][c - 1] = '.';
			blanks += 1;
		} else if (r == 1 || c == 1) { // linear board
			if (b < 2) {
				valid = false;
			}
		} else { // r > 1 && c > 1
			if (b < 4) {
				valid = false;
			} else { // need to confirm that 4 bottom corner squares are blank
				board[r - 2][c - 1] = '.';
				board[r - 1][c - 2] = '.';
				board[r - 2][c - 2] = '.';
				board[r - 1][c - 1] = '.';
				blanks += 4;
				valid = true;
			}
		}

		if (valid) {
			for (int i = 0; i < r; ++i) {
				for (int j = 0; j < c; ++j) {
					if (board[i][j] == '.') { // already set
						continue;
					}
					if (mines < m) {
						board[i][j] = '*';
						++mines;
					} else {
						board[i][j] = '.';
						++blanks;
					}
				}
			}
			board[r - 1][c - 1] = 'c';
		}

		if (valid) {
			for (int i = 0; i < r; ++i) {
				builder.append(board[i]);
				builder.append('\n');
			}
		} else {
			builder.append("Impossible\n");
		}
		return builder.toString();
	}
}
