package net.ujjwal.google.codejam11.round1b;

import java.util.Scanner;


public class RPI
{

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        Scanner scanner = new Scanner(System.in);
        long t = scanner.nextLong();
        for (long i = 1; i <= t; ++i)
        {
            RPI rpi = new RPI();
            rpi.input(scanner);
            System.out.printf("Case #%d:%n", i);
            rpi.evaluate();
        }
    }

    private int        n;
    private String[]   table;
    private int[]      played;
    private int[]      won;
    private double[]   wp;
    private Double[][] owp;
    private double[]   owp1;
    private double[]   oowp;
    private double[]   rpi;

    private void evaluate()
    {
        owp = new Double[n][n];
        owp1 = new double[n];
        oowp = new double[n];
        rpi = new double[n];
        for (int i = 0; i < n; ++i)
        {
            int k = 0;
            double sum = 0.0;
            for (int j = 0; j < n; ++j)
            {
                if (i == j)
                    continue;
                char result = table[i].charAt(j);
                if (result == '.')
                    continue;
                int played = this.played[j] - 1;
                int wins;
                if (result == '1')
                {
                    wins = this.won[j];
                }
                else
                {
                    wins = this.won[j] - 1;
                }
                owp[i][j] = ((double) wins) / played;
                ++k;
                sum += owp[i][j];
            }
            owp1[i] = sum / k;
        }
        for (int i = 0; i < n; ++i)
        {
            int k = 0;
            double sum = 0.0;
            for (int j = 0; j < n; ++j)
            {
                if (table[i].charAt(j) != '.')
                {
                    sum += owp1[j];
                    ++k;
                }
            }
            oowp[i] = sum / k;
            rpi[i] = (wp[i] + owp1[i] + owp1[i] + oowp[i]) / 4;
            System.out.println(rpi[i]);
        }
    }

    private void input(Scanner scanner)
    {
        this.n = scanner.nextInt();
        scanner.nextLine();
        table = new String[n];
        played = new int[n];
        won = new int[n];
        wp = new double[n];
        for (int i = 0; i < n; ++i)
        {
            String res = scanner.nextLine().trim();
            table[i] = res;
            int totalPlayed = 0, won = 0;
            for (int j = 0; j < n; ++j)
            {
                char result = res.charAt(j);
                switch (result)
                {
                    case '1':
                        ++won;
                    case '0':
                        ++totalPlayed;
                        break;
                    case '.':
                    default:
                }
            }
            played[i] = totalPlayed;
            this.won[i] = won;
            wp[i] = ((double) won) / totalPlayed;
        }
    }

}
