package net.ujjwal.codejam.gcj14.round1b;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class NewLotteryGame implements Callable<Integer> {

	private int a;
	private int b;
	private int k;

	public NewLotteryGame(int a, int b, int k) {
		this.a = a;
		this.b = b;
		this.k = k;
	}

	public static void main(String[] args) throws InterruptedException,
			ExecutionException {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		ExecutorService executorService = Executors.newCachedThreadPool();
		List<Future<Integer>> futures = new ArrayList<Future<Integer>>();
		for (int i = 0; i < t; ++i) {
			int a = in.nextInt();
			int b = in.nextInt();
			int k = in.nextInt();
			NewLotteryGame game = new NewLotteryGame(a, b, k);
			futures.add(executorService.submit(game));
		}
		for (int i = 1; i <= t; ++i) {
			System.out.printf("Case #%d: %d%n", i, futures.get(i - 1).get());
		}

		executorService.shutdown();
		executorService.shutdownNow();
	}

	@Override
	public Integer call() throws Exception {
		int count = 0;
		for (int i = 0; i < a; i++) {
			for (int j = 0; j < b; j++) {
				if ((i & j) < k) {
					++count;
				}
			}
		}
		return count;
	}

}
