package net.ujjwal.google.codejam.round1c;

import java.util.Scanner;


public class RopeIntranet
{

    private class Wire
    {
        int a;
        int b;
    }
    private int    n;
    private Wire[] wires;

    public RopeIntranet(Scanner in)
    {
        this.n = in.nextInt();
        this.wires = new Wire[n];
        for (int i = 0; i < n; ++i)
        {
            wires[i] = new Wire();
            wires[i].a = in.nextInt();
            wires[i].b = in.nextInt();
        }
    }

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int t = in.nextInt();
        for (int i = 1; i <= t; ++i)
        {
            RopeIntranet intranet = new RopeIntranet(in);
            System.out.printf("Case #%d: %d%n", i, intranet.numIntersections());
        }
    }

    private int numIntersections()
    {
        int count = 0;
        for (int i = 0; i < n; ++i)
        {
            Wire current = wires[i];
            for (int j = i + 1; j < n; ++j)
            {
                Wire next = wires[j];
                if (intersect(current, next))
                    ++count;
            }
        }
        return count;
    }

    private boolean intersect(Wire current, Wire next)
    {
        if (current.a < next.a && current.b > next.b)
            return true;
        else if (current.a > next.a && current.b < next.b)
            return true;
        else
            return false;
    }

}
