package net.ujjwal.codejam.gcj14;

import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class CookieClickerAlpha implements Callable<Double> {

	private final double c;
	private final double f;
	private final double x;

	public CookieClickerAlpha(double c, double f, double x) {
		this.c = c;
		this.f = f;
		this.x = x;
	}

	@Override
	public Double call() throws Exception {
		List<Double> vi = new ArrayList<Double>();
		List<Double> tCi = new ArrayList<Double>();
		List<Double> tXi = new ArrayList<Double>();
		List<Double> tCiSum = new ArrayList<Double>();

		vi.add(2.0);
		tCi.add(c / vi.get(0));
		tXi.add(x / vi.get(0));
		tCiSum.add(tCi.get(0));
		int currentIndex = 0;
		if (tCi.get(0) >= tXi.get(0)) {
			return tXi.get(0);
		}
		while (true) {
			vi.add(vi.get(currentIndex) + f);
			++currentIndex;
			tCi.add(c / vi.get(currentIndex));
			tXi.add(x / vi.get(currentIndex));
			tCiSum.add(tCiSum.get(currentIndex - 1) + tCi.get(currentIndex));
			if (tXi.get(currentIndex - 1) <= (tCi.get(currentIndex - 1) + tXi
					.get(currentIndex))) {
				if (currentIndex >= 2) {
					return tCiSum.get(currentIndex - 2)
							+ tXi.get(currentIndex - 1);
				} else {
					return tXi.get(currentIndex - 1);
				}
			}
		}
	}

	public static void main(String[] args) throws InterruptedException,
			ExecutionException {
		Scanner in = new Scanner(System.in);
		int t = in.nextInt();
		ExecutorService executorService = Executors.newCachedThreadPool();
		List<Future<Double>> futures = new ArrayList<Future<Double>>();
		for (int i = 0; i < t; ++i) {
			double c = in.nextDouble();
			double f = in.nextDouble();
			double x = in.nextDouble();
			futures.add(executorService.submit(new CookieClickerAlpha(c, f, x)));
		}

		for (int i = 1; i <= t; ++i) {
			System.out.printf("Case #%d: %.7f%n", i, futures.get(i - 1).get());
		}

		executorService.shutdown();
		executorService.shutdownNow();
	}

}
