package net.ujjwal.google.codejam.round1c;

import java.util.Arrays;
import java.util.Scanner;

public class BribePrisoners {

    private int p;
    private int q;
    int[]       releases;
    int         minCost = Integer.MAX_VALUE;

    public BribePrisoners(Scanner scanner) {
        p = scanner.nextInt();
        q = scanner.nextInt();
        releases = new int[q];
        for (int i = 0; i < q; ++i) {
            releases[i] = scanner.nextInt() - 1;
        }
    }

    /**
     * @param args
     */
    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int t = scanner.nextInt();
        for (int i = 1; i <= t; ++i) {
            BribePrisoners bribePrisoners = new BribePrisoners(scanner);
            System.out.printf("Case #%d: %d%n", i, bribePrisoners.getCost());
        }
    }

    private int getCost() {
        Arrays.sort(releases);
        do {
            evaluateCost();
        } while (!nextPermutation());
        return minCost;
    }

    private void evaluateCost() {
        boolean[] prisonerPresent = new boolean[p];
        Arrays.fill(prisonerPresent, true);
        int cost = 0;
        for (int prisonerReleased : releases) {
            cost = releasePrisoner(prisonerReleased, prisonerPresent, cost);
            if (cost > minCost) {
                break;
            }
        }
        if (cost < minCost) {
            minCost = cost;
        }
    }

    private int releasePrisoner(int prisonerReleased,
            boolean[] prisonerPresent, int cost) {
        for (int i = prisonerReleased - 1; i >= 0 && prisonerPresent[i]; --i) {
            ++cost;
        }
        for(int i = prisonerReleased + 1; i < prisonerPresent.length && prisonerPresent[i]; ++i) {
            ++cost;
        }
        prisonerPresent[prisonerReleased] = false;
        return cost;
    }

    private boolean nextPermutation() {
        int i;
        for (i = releases.length - 2; i >= 0; --i) {
            if (releases[i] < releases[i + 1]) {
                for (int j = releases.length - 1; j > i; --j) {
                    if (releases[j] > releases[i]) {
                        swap(releases, i, j);
                        int[] newCharArray = Arrays.copyOfRange(releases,
                                i + 1, releases.length);
                        for (int k = 0; k < newCharArray.length; ++k) {
                            releases[releases.length - k - 1] = newCharArray[k];
                        }
                        break;
                    }
                }
                break;
            }
        }
        return i < 0;
    }

    private void swap(int[] arr, int i, int j) {
        int t = arr[i];
        arr[i] = arr[j];
        arr[j] = t;
    }

}
