package net.ujjwal.google.codejam.quals;

import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;


public class FairWarning
{

    /**
     * @param args
     */
    public static void main(String[] args)
    {
        Scanner in = new Scanner(System.in);
        int c = in.nextInt();
        in.nextLine(); // skipping to next line;
        for (int i = 1; i <= c; ++i)
        {
            String line = in.nextLine();
            String[] split = line.split(" ");
            int n = Integer.valueOf(split[0]);
            assert (split.length == n + 1);
            List<BigInteger> ti = new ArrayList<BigInteger>(n);
            for (int j = 1; j <= n; ++j)
            {
                ti.add(new BigInteger(split[j]));
            }
            Collections.sort(ti);
            List<BigInteger> diffList = diffList(ti);
            BigInteger diffGcd;
            if (n > 2)
            {
                diffGcd = gcd(diffList.toArray(new BigInteger[n - 1]));
            }
            else
            {
                diffGcd = diffList.get(0);
            }
            if (diffGcd.equals(BigInteger.ONE))
            {
                System.out.printf("Case #%d: %s%n", i, String.valueOf(0));
                continue;
            }
            BigInteger first = ti.get(0);
            BigInteger firstStep = diffGcd.subtract(first.mod(diffGcd));
            BigInteger y = firstStep;
            List<BigInteger> timeStep = new ArrayList<BigInteger>(ti);
            BigInteger[] timeStepArray = timeStep.toArray(new BigInteger[timeStep.size()]);
            addAll(timeStepArray, firstStep);
            while (!gcd(timeStepArray).equals(diffGcd))
            {
                y = y.add(diffGcd);
                addAll(timeStepArray, diffGcd);
            }
            System.out.printf("Case #%d: %s%n", i, y.toString());
        }
    }

    private static void addAll(BigInteger[] timeStep, BigInteger step)
    {
        for (int i = 0; i < timeStep.length; ++i)
        {
            timeStep[i] = timeStep[i].add(step);
        }
    }

    private static List<BigInteger> diffList(List<BigInteger> ti)
    {
        List<BigInteger> ret = new ArrayList<BigInteger>(ti.size() - 1);
        for (int i = 1; i < ti.size(); ++i)
        {
            ret.add(ti.get(i).subtract(ti.get(i - 1)));
        }
        return ret;
    }

    private static BigInteger gcd(BigInteger... array)
    {
        BigInteger gcd = array[0].gcd(array[1]);
        int i = 2;
        while (!gcd.equals(BigInteger.ONE) && i < array.length)
        {
            gcd = gcd.gcd(array[i]);
            ++i;
        }
        return gcd;
    }

}
