import java.io.*;
import java.util.*;

public class B {

    
    public static int plusAtBottomAux(String s, int c){
	int len = s.length();
	if (len == 0) return c;
	char last = s.charAt(len-1);
	if (last == '+') return plusAtBottomAux(s.substring(0,len-1), c+1);
	return c;
    }

    public static int plusAtBottom(String s){
	return plusAtBottomAux(s,0);
    }


    public static int charOnTopAux(String s, char c, int k){
	int len = s.length();
	if (len == 0) return k;
	char head = s.charAt(0);
	if (head == c) return charOnTopAux(s.substring(1), c, k+1);
	return k;
    }

    public static int minusOnTop(String s){	
	return charOnTopAux(s,'-',0);
    }

    public static int plusOnTop(String s){
	return charOnTopAux(s,'+',0);
    }
    
    
    public static String flipFullAux(String s1, String s2){
	if (s1.equals("")) return s2;
	char c = s1.charAt(0);
	String tail = s1.substring(1);
	if (c == '+') return flipFullAux(tail, "-"+s2);
	else return flipFullAux(tail, "+"+s2);
    }

    public static String flipFull(String s){
	return flipFullAux(s,"");	
    }


    // flip("-----++", 3) = "++++-++"
    public static String flip(String s, int pos){
	//System.out.println("flip string "+s+" at position "+pos);
	String tail = s.substring(pos+1);
	String head = s.substring(0, pos+1);
	String headFlip = flipFull(head);
	return headFlip+tail; 
    }

    // c is the counter
    public static int processPancakeAux(String s, int len, int sorted, int c){
	//System.out.println("processPancakeAux "+s+" "+"nb of + is "+sorted);
	if (sorted < len){
	    int minusLeft = minusOnTop(s);
	    if (minusLeft == 0){
		int plusLeft = plusOnTop(s);
		String res = flip(s, plusLeft-1);
		return processPancakeAux(res, len, sorted, c+1);
	    }
	    else {
		String res = flip(s, len - 1 - sorted); // TEST
		return processPancakeAux(res, len, sorted + minusLeft, c+1);
	    }
	}
	else return c;
    }

    public static int processPancake(String s){
	//System.out.println("pancake pile is "+s);
	int len = s.length();
	int sorted = plusAtBottom(s);
	//System.out.println("; number of right +  "+sorted);
	return processPancakeAux(s, len, sorted, 0);
    }




	public static void process(Scanner sc_in, int i, PrintWriter pw){
	    //System.out.println("call process");
	    String s = sc_in.nextLine();
	    int n = processPancake(s);
	    pw.println("Case #"+i+": "+n);
	    //System.out.println();
	}

	
	//public static void print(PrintWriter pw){}
	
	public static void main(String[] args){
	    //String res = "123".substring(3);
	    //System.out.println("test "+res);
	    /*
	    String dummy = "--+--+";
	    System.out.println(dummy);
	    System.out.println(flipFull(dummy)); */
		//System.out.println("debut prog");
		String pbName = args[0];
		//String strIn = pbName+".in";
		File fileIn = new File(pbName+".in");		
		try {Scanner sc_in = new Scanner(fileIn);
		//System.out.println("scan réussi");
		PrintWriter pw_out = new PrintWriter(pbName+".out");
		//System.out.println(pbName);
		int nb_cases = sc_in.nextInt();
		//System.out.println("number of cases is "+nb_cases);
		sc_in.nextLine();
		for (int i = 0; i < nb_cases; i++){
			process(sc_in, i+1, pw_out); // i+1 because first case is 1
		}
		sc_in.close();
		pw_out.close();
		//System.out.println(pw_out.toString());
		} catch(FileNotFoundException e) {return;}; //{new Scanner (System.in);}; //{new Scanner (System.in)};
	}
}
