import java.io.*;
import java.util.*;
import java.math.*;

public class C32 {    


    // nb of jamcoins
    public static int jamcoinCounter = 0;
    public static String res = "";


    // returns a factor dividing l < 100000 or -1 if no factor found
    public static int factor(BigInteger l){
	int limit = 100000; // seems to be enough to find the keys
	for(int d = 2; d < limit; d++){
	    String divStr = Integer.toString(d);
	    BigInteger divisor = new BigInteger(divStr);
	    BigInteger rem = l.remainder(divisor);
	    if (rem.intValue() == 0) return d;
	}	
	return -1;
    }

   
    // returns the BigInteger in base b of a string s of length 16
    public static BigInteger string16ToBigInteger(String s, byte b){
	long l = Long.parseLong(s,b);
	String str = Long.toString(l);
	return new BigInteger(str);
    }
    
    // returns the BigInteger in base b of a string coin of length 32
    public static BigInteger coin32ToBigInteger(String coin, byte b){
	String coinHigh = coin.substring(0,16);
	String coinLow = coin.substring(16,32);
	BigInteger coinLowBI = string16ToBigInteger(coinLow, b);
	BigInteger temp = string16ToBigInteger(coinHigh, b);
	BigInteger factorBI = new BigInteger (Long.toString((long) Math.pow(b,16)));
	BigInteger coinHighBI = temp.multiply(factorBI);
	return coinHighBI.add(coinLowBI); 
    }

    public static void jamcoinString(String coin){
	String s ="";
	for(byte b = 2; b < 11; b++){
	    BigInteger l = coin32ToBigInteger(coin, b);
	    int f = factor(l);
	    if (f == -1) {
		return;
	    } // coin is no jamcoin, res is unchanged
	    s = s+" "+f;
	}
	// nb of jamcoins++;
	jamcoinCounter++;	
	res = res + coin + s +"\n";
    }


    public static void process32(int nbC, int lenC, PrintWriter pw){
	// nb of strings
	int nbString = (int) Math.pow(2,lenC - 2); // 2^30 is in int's range
	// for every possible middle string
	for (int i = 0; i < nbString; i++){
	    if (jamcoinCounter >= nbC) break;
	    String s = Integer.toBinaryString(i);
	    // add 0 in front if necessary
	    for (int k = s.length(); k < lenC - 2; k++){
		s ="0" + s;
	    }
	    String coin = "1"+s+"1";
	    jamcoinString(coin);
	}
	pw.println(res);
    }

   

	public static void process(PrintWriter pw){
	    int lengthCoin = 32;
	    int nbCoin = 500;
	    pw.println("Case #1:");
	    process32(nbCoin, lengthCoin, pw);
	}

	
	
    public static void main(String[] args){
	String pbName = "C32";
	try{
	    PrintWriter pw_out = new PrintWriter(pbName+".out");
		    process(pw_out);
		    pw_out.close();
	} catch(FileNotFoundException e) {return;}
	
    }
}
