import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;
import java.util.Stack;

public class dijkstra {
	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new File("input/dijkstra-sm.in"));
		PrintStream out = new PrintStream(new File("output/dijkstra-sm.out"));
//		Scanner input = new Scanner(System.in);
//		PrintStream out = System.out;
		int T = input.nextInt();
		primary: for (int oncase = 1; oncase <= T; oncase++) {
			out.printf("Case #%d: ", oncase);
			int l = input.nextInt();
			int x = input.nextInt();
			input.nextLine();
			String line = input.nextLine();
			int[] base = new int[l];
			for (int i=0; i<l; i++) {
				base[i] = line.charAt(i) - 'g';
			}
			if (solve(base, x)) {
				out.println("YES");
			} else {
				out.println("NO");
			}
		}
		out.close();
		System.out.println("Done");
	}
	
	public static boolean solve(int[] base, int rep) {
		int max = base.length * rep - 1;
		int i = 0, j;
		int first = base[0], last;
		for (; i < max; i++, first = mult(first, base[i % base.length])) {
			if (first == 2) break;
		}
		last = 1;
		Stack<Integer> lasts = new Stack<Integer>();
		for (j=max; j >= i + 1; j--) {
			last = mult(base[j % base.length], last);
			if (last == 4) {
				lasts.add(j);
			}
		}
		j++;
		
//		System.out.println(lasts);
		
		while (i < max - 1) {
//			System.out.println(i + " " + j);
			while (!lasts.isEmpty() && (j = lasts.pop()) < i);
			if (j <= i) return false;
			Stack<Integer> temp = new Stack<>();
			temp.addAll(lasts);
			
			do {
				if (simplify(base, i + 1, j - 1) == 3) return true;
			} while (!temp.isEmpty() && (j = temp.pop()) == j);
			
			for (++i; i < max; i++, first = mult(first, base[i % base.length])) {
				if (first == 2) break;
			}
		}
		
		return false;
	}
	
	public static int simplify(int[] base, int s, int e) {
		int cur = base[s % base.length];
		for (int i=s+1; i<=e; i++) {
			cur = mult(cur, base[i % base.length]);
		}
		return cur;
	}
	
	public static int mult(int a, int b) {
		return mult[Math.abs(a) - 1][Math.abs(b) - 1] * (int)Math.signum(a) * (int)Math.signum(b);
	}
	
	public static int div(int a, int b) {
		return div[Math.abs(a) - 1][Math.abs(b) - 1] * (int)Math.signum(a) * (int)Math.signum(b);
	}
	
	public static int[][] mult = 
		{
			{1, 2, 3, 4},
			{2,-1, 4,-3},
			{3,-4,-1, 2},
			{4, 3,-2,-1}
		};
	
	public static int[][] div = 
		{
			{1, 2, 3, 4},
			{-2,1,-4,3},
			{-3,4,1,-2},
			{-4,-3,2,1}
		};
}