import java.io.File;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.PriorityQueue;
import java.util.Queue;
import java.util.Scanner;

public class Energy {
	static ArrayList<Node> cal = new ArrayList<Node>();
	public static void main(String[] args) throws Exception {
		Scanner input = new Scanner(new File("input/Energy-small.in"));
		PrintWriter out = new PrintWriter(new File("output/Energy-small.out"));
		long sets = input.nextLong();
		input.nextLine();
		primary: for (long onSet = 1; onSet <= sets; onSet++) {
			cal.clear();
			System.out.printf("%d of %d%n", onSet, sets);
			out.printf("Case #%d: ", onSet);
			long max = input.nextLong();
			long reg = input.nextLong();
			long n = input.nextLong();
			ArrayList<Node> cal = new ArrayList<Node>();
			Queue<Node> q = new PriorityQueue<Node>();
			for (long i=0; i<n; i++) {
				Node cur = new Node(input.nextLong(), i);
				cal.add(cur);
				q.add(cur);
			}
			Node root = q.remove();
			while (!q.isEmpty()) {
				Node cur = q.remove();
				//System.out.println(cur.v + " ");
				root.place(cur);
			}
			long totRoot = max+root.i*reg;
			long maxRoot = Math.min(totRoot, max);
			root.assign(maxRoot, totRoot-maxRoot, max, reg, true);
			BigInteger tot = BigInteger.ZERO;
			for (Node cur : cal) {
				//System.out.print(cur.a + " ");
				tot = tot.add(new BigInteger(Long.toString(cur.a*cur.v)));
			}
			//System.out.println();
			out.println(tot.toString());
		}
		out.close();
	}
	
	public static class Node implements Comparable<Node> {
		long v;
		long i;
		long o;
		long a;
		Node left, right, parent;
		public Node(long v, long i) {
			this.v = v;
			this.i = i;
		}
		
		public int compareTo(Node other) {
			if (v > other.v) return -1;
			if (v < other.v) return 1;
			else return 0;
		}
		
		public void place(Node n) {
			if (n.i < i) {
				if (left == null) {
					left = n;
					left.parent = this;
				}
				else left.place(n);
			} else {
				if (right == null) {
					right = n;
					right.parent = this;
				}
				else right.place(n);
			}
		}
		
		public String toString() {
			String cur = " " + v;
			if (left != null) {
				cur += " " + left.toString();
			}
			if (right != null) {
				cur += " " + right.toString();
			}
			return cur;
		}
		
		/*public void assign(long x, long max, long limit, long reg) {
			a = Math.min(x, Math.min(limit,max));
			//if (limit != Long.MAX_VALUE) System.out.println("Limit for " + i + " is " + limit + " but " + a + "-----" + x + " " + max + " " + limit);
			//System.out.print("Had " + x);
			x -= a;
			//System.out.print(" Spent " + a);
			o = x;
			//System.out.println(" Have " + o + " left");
			if (right != null) right.assign((right.i-i)*reg, max, limit, reg);
			if (left != null) left.assign(o, max, (i-left.i)*reg, reg);
		}*/
		public void assign(long x, long over, long max, long reg, boolean pure) {
			//System.out.printf("%d : %d %d%n", i, x, over);
			a = Math.min(x, max);
			x -= a;
			o = x + over;
			if (left != null) {
				long maxLeft = Math.min(o, (i-left.i)*reg);
				left.assign(maxLeft, o-maxLeft, max, reg, false);
			}
			if (right != null) {
				long totRight;
				if (pure) {
					totRight = (right.i-i)*reg;
				} else {
					totRight = Math.max(parent.o - a, 0);
				}
				long maxRight = Math.min(totRight, max);
				right.assign(maxRight, totRight-maxRight, max, reg, pure);
			}
		}
	}
}