import java.util.*;


public class Vine {
	int distance;
	int length;
	static int target;
	static int height;
	public static List<Vine> allVines = new ArrayList<Vine>();
	
	public static void setTarget(int t) {
		target = t;
	}
	
	public static void clear() {
		allVines.clear();
	}
	
	public Vine(int distance, int length) {
		this.distance = distance;
		this.length = length;
		allVines.add(this);
	}
	
	public static List<Vine> getVines(int start, int swing) {
		List<Vine> res = new ArrayList<Vine>();
		for (Vine cur : allVines) {
			if (cur.distance > start && cur.distance <= start + swing) {
				res.add(cur);
			}
		}
		return res;
	}
	
	public boolean reachTarget(int swing) {
		if (distance + swing >= target) return true;
		for (Vine cur : getVines(distance, swing)) {
			if (cur.reachTarget(Math.min(cur.distance - distance, cur.length))) {
				return true;
			}
		}
		return false;
	}
	
}
