package Dijkstra;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Scanner;

public class Main {
	
	private int t = 0;
	
	private ArrayList<ArrayList<String>> answerGrid = new ArrayList<ArrayList<String>>();
	
	public Main() {
		File input = new File("input.txt");
		initialiseAnswerGrid();
		outputData(readData(input));
	}
	
	public void initialiseAnswerGrid() {
		for (int i = 0 ; i < 5 ; i++) {
			answerGrid.add(new ArrayList<String>());
		}
		
		answerGrid.get(0).add("");
		answerGrid.get(0).add("1");
		answerGrid.get(0).add("i");
		answerGrid.get(0).add("j");
		answerGrid.get(0).add("k");
		answerGrid.get(1).add("1");
		answerGrid.get(1).add("1");
		answerGrid.get(1).add("i");
		answerGrid.get(1).add("j");
		answerGrid.get(1).add("k");
		answerGrid.get(2).add("i");
		answerGrid.get(2).add("i");
		answerGrid.get(2).add("-1");
		answerGrid.get(2).add("k");
		answerGrid.get(2).add("-j");
		answerGrid.get(3).add("j");
		answerGrid.get(3).add("j");
		answerGrid.get(3).add("-k");
		answerGrid.get(3).add("-1");
		answerGrid.get(3).add("i");
		answerGrid.get(4).add("k");
		answerGrid.get(4).add("k");
		answerGrid.get(4).add("j");
		answerGrid.get(4).add("-i");
		answerGrid.get(4).add("-1");
	}
	
	public boolean[] readData(File f) {
		try {
			Scanner scan = new Scanner(f);
			
			t = scan.nextInt();
			
			boolean[] toReturn = new boolean[t];
			
			outer : for (int i = 0 ; i < t ; i++) {
				int L = scan.nextInt();
				int X = scan.nextInt();
				
				boolean iDone = false;
				boolean jDone = false;
				boolean kDone = false;
				
				String s = scan.next();
				String ijks = s;
				
				for (int j = 1 ; j < X ; j++) {
					ijks += s;
				}
				
				String letterOne = ijks.substring(0, 1);				
				boolean negative = false;
				
				inner : for (int j = 1 ; j <= ijks.length() ; j++) {
					
					if (j == ijks.length()) {
						if (iDone && jDone && letterOne.equals("k")) {
							toReturn[i] = true;
						} else {
							toReturn[i] = false;
						}
						
						continue outer;
					}
					
					if (! iDone) {
						if (letterOne.equals("i")) {
							iDone = true;
							letterOne = ijks.substring(j, j + 1);
							continue inner;
						}
					} else if (! jDone) {
						if (letterOne.equals("j")) {
							jDone = true;
							letterOne = ijks.substring(j, j + 1);
							continue inner;
						}
					} else if (! kDone) {
						if (letterOne.equals("k")) {
							kDone = true;
							if (ijks.substring(j).equals("")) {
								toReturn[i] = true;
							} else {
								toReturn[i] = false;
							}
							continue outer;
						}
					}
					
					String letterTwo = ijks.substring(j, j+1);
					
					int row = 0;
					int col = 0;
					
					for (int rows = 0 ; rows < 5 ; rows++) {
						if (letterOne.substring(0, 1).equals("-")) {
							negative = true;
							letterOne = letterOne.substring(1);
						}
						if (answerGrid.get(rows).get(0).equals(letterOne)) {
							row = rows;
							break;
						}
					}
					for (int cols = 0 ; cols < 5 ; cols++) {
						if (answerGrid.get(0).get(cols).equals(letterTwo)) {
							col = cols;
						}
					}
					if (negative) {
						letterOne = "-" + answerGrid.get(row).get(col);
						if (letterOne.length() == 3) {
							letterOne = letterOne.substring(2);
							negative = false;
						}
					} else {
						letterOne = answerGrid.get(row).get(col);
					}
					
				}
				
				toReturn[i] = false;
				
			}
			
			return toReturn;
			
		} catch (IOException e) {
			return null;
		}
	}
	
	public void outputData(boolean[] data) {
		File output = new File("Output.txt");
		try {
			PrintStream out = new PrintStream(output);
			for (int i = 0 ; i < t ; i++) {
				if (data[i] == true) {
					out.print("Case #" + (i + 1) + ": YES");
				} else {
					out.print("Case #" + (i + 1) + ": NO");
				}
				if (i != t - 1) { 
					out.println();
				}
			}
			
			out.close();
		} catch(IOException e) {
			// Do nothing
		}
	}
	
	public static void main(String args[]) {
		new Main();
	}
}
