package InfiniteHouseOfPancakes;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Attempt3 {
	
	private int t = 0;
	
	private int occurances = 0;
	
	public Attempt3() {
		
		File f = new File("input.txt");
		outputData(readData(f));
		
	}
	
	public int[] readData(File f) {
		
		try {
			
			Scanner scan = new Scanner(f);
			t = scan.nextInt();
			
			int[] minutesPerTestCase = new int[t];
			
			for (int testCases = 0 ; testCases < t ; testCases++) {
				
				int diners = scan.nextInt();
				int pancakesLeft = 0;
				List<Integer> pancakes = new ArrayList<Integer>();
				
				for (int i = 0 ; i < diners ; i++) {
					pancakes.add(scan.nextInt());
					pancakesLeft += pancakes.get(i);
				}
				
				int numberOfMinutes = 0;
				
				while (pancakesLeft > 0) {
					
					// Each loop, must eat or halve
					boolean halve = halveTest(pancakes);
					
					if (halve) {
						
						// Halve
						getLargestNumberAfterHalving(pancakes);
						numberOfMinutes += this.occurances;
						
					} else {
						
						// Eat
						for (int i = 0 ; i < pancakes.size() ; i++) {
							
							pancakes.set(i, pancakes.get(i) - 1);
							pancakesLeft--;
							
							if (pancakes.get(i) == 0) {
								pancakes.set(i, null);
							}
							
						}
						
						while (pancakes.contains(null)) {
							pancakes.remove(null);
						}
						
						numberOfMinutes++;
						
					}
					
				}
				
				minutesPerTestCase[testCases] = numberOfMinutes;
				
			}
			
			scan.close();
			
			return minutesPerTestCase;
			
		} catch (IOException e) {
			
			return null;
			
		}
		
	}
	
	public void outputData(int[] data) {
		
		File f = new File("Output.txt");
		
		try {
			PrintStream out = new PrintStream(f);
			
			for (int i = 0 ; i < t ; i++) {
				
				out.print("Case #" + (i + 1) + ": " + data[i]);
				
				if (i != t -1) {
					out.println();
				}
				
			}
			
			out.close();
			
		} catch (IOException e) {
			//
		}
		
	}
	
	public boolean halveTest(List<Integer> pancakes) {
		
		// Copy pancakes to a new list for halving
		List<Integer> toHalve = new ArrayList<Integer>();
		for (int i = 0 ; i < pancakes.size() ; i++) {
			toHalve.add(pancakes.get(i));
		}
		
		// Copy pancakes to a new list for eating
		List<Integer> toEat = new ArrayList<Integer>();
		for (int i = 0 ; i < pancakes.size(); i++) {
			toEat.add(pancakes.get(i));
		}
		
		int largestNumberAfterHalving = getLargestNumberAfterHalving(toHalve);
		int largestNumberAfterEating = getLargestNumberAfterEating(toEat);
		
		while (largestNumberAfterHalving >= largestNumberAfterEating) {
			
			if (largestNumberAfterHalving == 1) {
				return false;
			}
			
			// Copy halving list over to eating list
			toEat = new ArrayList<Integer>();
			for (int i = 0 ; i < toHalve.size() ; i++) {
				toEat.add(toHalve.get(i));
			}
			
			largestNumberAfterHalving = getLargestNumberAfterHalving(toHalve);
			largestNumberAfterEating = getLargestNumberAfterEating(toEat);
			
		}
		
		return true;
		
	}
	
	public int getLargestNumberAfterHalving(List<Integer> pancakes) {
		
		int largestNumber = 0;
		
		for (int i = 0 ; i < pancakes.size() ; i++) {
			
			if (pancakes.get(i) > largestNumber) {
				largestNumber = pancakes.get(i);
			}
			
		}
		
		int occurancesOfLargestNumber = 0;
		
		for (int i = 0 ; i < pancakes.size() ; i++) {
			
			if (pancakes.get(i) == largestNumber) {
				occurancesOfLargestNumber++;
			}
			
		}
		
		for (int i = 0 ; i < occurancesOfLargestNumber ; i++) {
			
			int indexOfLargestNumber = pancakes.indexOf(largestNumber);
			
			int pancakesForNewPerson = largestNumber / 2;
			
			pancakes.set(indexOfLargestNumber, largestNumber - pancakesForNewPerson);
			pancakes.add(pancakesForNewPerson);
			
		}
		
		// Find largest number again after halving
		largestNumber = 0;
		
		for (int i = 0 ; i < pancakes.size() ; i++) {
			
			if (pancakes.get(i) > largestNumber) {
				largestNumber = pancakes.get(i);
			}
			
		}
		
		this.occurances = occurancesOfLargestNumber;
		
		return largestNumber;
		
	}
	
	public int getLargestNumberAfterEating(List<Integer> pancakes) {
		
		int largestNumber = 0;
		
		for (int i = 0 ; i < pancakes.size() ; i++) {
			
			if (pancakes.get(i) > largestNumber) {
				largestNumber = pancakes.get(i);
			}
			
		}
		
		return largestNumber - this.occurances;
		
	}
	
	public static void main(String args[]) {
		new Attempt3();
	}
}
