package StandingOvation;

import java.io.File;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Scanner;

public class Main {
	
	private int t = 0;
	
	public Main() {
		File f = new File("input.txt");
		outputData(readData(f));
	}
	
	public int[] readData(File f) {
		try {
			Scanner scan = new Scanner(f);
			t = scan.nextInt();
			
			int[] friends = new int[t];
			
			// For each test case...
			for (int i = 0 ; i < t ; i++) {
				
				int sMax = scan.nextInt();
				String s = scan.next();
				
				int sumBefore = Integer.parseInt(s.substring(0, 1));
				int numberOfFriends = 0;
				
				for (int j = 1 ; j < sMax + 1; j++) {
					// Sum of preceeding no's must be greater than or equal to this
					int number = Integer.parseInt(s.substring(j, j + 1));
					while (true) {
						if (sumBefore >= j) {
							sumBefore+= number;
							break;
						} else {
							numberOfFriends++;
							sumBefore++;
						}
					}
				}
				
				friends[i] = numberOfFriends;
				
			}
			
			return friends;
			
		} catch (IOException e) {
			// Do nothing
			return null;
		}
	}
	
	public void outputData(int[] data) {
		File output = new File("Output.txt");
		try {
			PrintStream out = new PrintStream(output);
			for (int i = 0 ; i < t ; i++) {
				out.print("Case #" + (i + 1) + ": " + data[i]);
				if (i != t - 1) { 
					out.println();
				}
			}
			
			out.close();
		} catch(IOException e) {
			// Do nothing
		}
	}
	
	public static void main(String args[]) {
		new Main();
	}
}
