import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Collections;
import java.util.Scanner;
import java.util.Vector;

public class PasswordProblem {
    
    public static void main(String args[]) throws Exception{
        Scanner in = new Scanner(new File("input.in"));
        BufferedWriter out=new BufferedWriter(new FileWriter("output.out"));
        
        int T=in.nextInt();
        //T=1;
        for(int t=1;t<=T;t++){
            int A=in.nextInt();//Chars Already Typed
            int B=in.nextInt();//Total Number of Characters
            float p[]=new float[A];
            for(int i=0;i<A;i++){
                p[i]=in.nextFloat();
            }
            
            String output=String.format("Case #%d: %.6f\n",t,solve(A,B,p));
            out.write(output);
            System.out.printf(output);
            
        }
        out.close();
    }
    
    private static double solve(int A, int B, float[] p) {
        Vector<Float> v=new Vector<Float>();
        float probArr[]=getProbArr(A,B,p);
        for(int i=0;i<=A;i++){
            v.addElement(withIBackKeepTyping(A,B,probArr,i));
        }
        v.addElement(rightAwayEnter(A,B,probArr));
        
        return Collections.min(v);
    }
    
    
    private static int fact(int n){
        int fact=1;
        for(int i=1;i<=n;i++){
            fact=fact*i;
        }
        return fact;
    }
    
    private static int nCr(int n,int r){
        return (fact(n)/(fact(n-r)*fact(r)));
    }
    
    private static double keepTyping(int A, int B, float[] probArr) {
        double ret=0.0;
        
        for(int i=0;i<probArr.length;i++){
            if(i==0){
                ret+=(probArr[i])*(B -A +1);
            }else{
                ret+=(probArr[i])*(2*B -A +2);
            }
        }
        return ret;
    }
    
    private static float[] getProbArr(int A, int B, float[] p) {
        int max=(int)(Math.pow(2,A));
        float probArr[]=new float[max];
        for(int i=0;i<max;i++){
            probArr[i]=1.0F;
        }
        
        for(int i=0;i<max;i++){
            int val=i;
            
            for(int k=A-1;k>=0;k--){
                if((val&(1<<k)) == 0){
                    probArr[i]=probArr[i]*p[A-1-k];
                }else{
                    probArr[i]=probArr[i]*(1.0F -p[A-1-k]);
                }
            }
        }
        return probArr;
    }
    
    private static float withIBackKeepTyping(int A, int B, float[] probArr, int k) {
        /*
         *For each k I'm expecting 0 to A-1-k to be perfect.
         *if not k have to write entire thing down.
         */
        float ret=0.0F;
        int limit=(int)(Math.pow(2,k));
        
        
        for(int i=0;i<probArr.length;i++){
            if(i<limit){
                ret+=(probArr[i])*(k+(B-(A-k))+1);
            }else{
                ret+=(probArr[i])*(k+(B-(A-k))+1+(B+1));
            }
        }
        return ret;
        
    }
    
    private static float rightAwayEnter(int A, int B, float[] probArr) {
        float ret=0.0F;
        
        if(A<B){
            ret+=B+2;
        }else{
            ret+=1;
        }
        
        return ret;
        
    }
    
}
