
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;

public class RPI {

    public static void main(String[] args) throws Exception {
        File fin = new File("./src/A-small-attempt0.in");
        FileReader fr = new FileReader(fin);
        FileWriter fw = new FileWriter("./src/A_output.txt");
        BufferedReader br = new BufferedReader(fr);

        int T = Integer.parseInt(br.readLine());



        for (int t = 0; t < T; t++) {
            int N = Integer.parseInt(br.readLine());

            int[][] tArray = new int[N][N];
            for (int i = 0; i < N; i++) {
                char arr[] = br.readLine().toCharArray();
                for (int j = 0; j < N; j++) {
                    if (arr[j] == '.') {
                        tArray[i][j] = -1;
                    } else if (arr[j] == '0') {
                        tArray[i][j] = 0;
                    } else {
                        tArray[i][j] = 1;
                    }
                }
            }

            //Formulae -   RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP

            double[][] rArray = new double[N][N];
            double[][] oArray = new double[N][4];

            for (int i = 0; i < N; i++) {
                double total = 0, win = 0;
                for (int j = 0; j < N; j++) {
                    if (tArray[i][j] == 1) {
                        win++;
                        total++;
                    } else if (tArray[i][j] == 0) {
                        total++;
                    }
                }
                //System.out.println(win+"\t"+total);

                for (int j = 0; j < N; j++) {
                    if (tArray[i][j] != -1) {
                        rArray[i][j] = (win - tArray[i][j]) / (total - 1);
                    } else {
                        rArray[i][j] = win / total;
                        oArray[i][0] = win / total;
                    }
                }


            }

//            for (int i = 0; i < N; i++) {
//                for (int j = 0; j < N; j++) {
//                    System.out.print(rArray[i][j]+"\t");
//                }
//                System.out.println();
//            }


            for (int i = 0; i < N; i++) {
                double total = 0, owp = 0;
                for (int j = 0; j < N; j++) {
                    if (tArray[i][j] != -1) {
                        owp += rArray[j][i];
                        total++;
                    }
                }
                oArray[i][1] = owp / total;
            }


            for (int i = 0; i < N; i++) {
                double total = 0, oowp = 0;
                for (int j = 0; j < N; j++) {
                    if (tArray[i][j] != -1) {
                        oowp += oArray[j][1];
                        total++;
                    }
                }
                oArray[i][2] = oowp / total;
            }

            //System.out.println("Case #" + (t + 1) + ":");
            fw.write("Case #" + (t + 1) + ":\n");

            for (int i = 0; i < N; i++) {
                oArray[i][3] = 0.25 * oArray[i][0] + 0.50 * oArray[i][1] + 0.25 * oArray[i][2];
                //System.out.println(oArray[i][3]);
                fw.write(Double.toString(oArray[i][3])+"\n");
            }


        }
        fr.close();
        fw.close();
    }
}
