import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.math.BigInteger;
import java.util.Scanner;

public class SolverC {

    private static final String fileName = "C-small-0";
    private static final BigInteger two = BigInteger.valueOf(2);

    private Writer out;

    private Scanner in;
    private String chars;
    private int charsPos;

    private int T;
    private int case_;

    public static void main(String[] args) throws IOException {
        new SolverC().solve();
    }

    public void solve() throws IOException {
        in = new Scanner(new File(fileName + ".in"));
        out = new FileWriter(fileName + ".out");
        T = in.nextInt();

        int lastProgress = 0;
        for (case_ = 0; case_ < T; case_++) {
            int progress = case_ * 10 / T;
            if (progress > lastProgress) {
                System.out.println(progress + "0%, " + case_ + "/" + T);
                lastProgress = progress;
            }

            BigInteger A = in.nextBigInteger();
            BigInteger B = in.nextBigInteger();
            BigInteger res = BigInteger.ZERO;
            while(A.compareTo(B) <= 0) {
                if (isPalindrome(A)) {
                    BigInteger s = sqrRoot(A);
                    if (s != null) {
                        if (isPalindrome(s)) {
                            res = res.add(BigInteger.ONE);
                        }
                    }
                }
                A = A.add(BigInteger.ONE);
            }
            result(res.toString());
        }
        out.close();
    }

    private BigInteger sqrRoot(BigInteger i) {
        if (i.compareTo(BigInteger.ONE) <= 0) {
            return i;
        }
        BigInteger j;
        for (j = i.divide(two);
             j.compareTo(i.divide(j)) > 0;
             j = ((i.divide(j)).add(j)).divide(two));
        return i.compareTo(j.multiply(j)) == 0 ? j : null;
    }

    private boolean isPalindrome(BigInteger bi) {
        String s = bi.toString();
        int j = s.length();
        int end = j / 2;
        for (int i = 0; i < end; i++) {
            if (s.charAt(i) != s.charAt(--j)) {
                return false;
            }
        }
        return true;
    }

    private void result(String res) throws IOException {
        out.write("Case #" + (case_ + 1) + ": " + res + "\n");
    }

    private char nextChar() {
        if (chars == null) {
            chars = in.next();
            charsPos = 0;
        } else {
            charsPos++;
        }
        return chars.charAt(charsPos);

    }

    private void endChars() {
        if (chars.length() > charsPos + 1) {
            throw new RuntimeException("String wasn't read fully: " + chars + ", pos: " + charsPos);
        }
        chars = null;
    }
}
