import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.math.BigInteger;
import java.util.Scanner;

public class SolverB {

    private static final String fileName = "B-small-0";

    private Writer out;

    private Scanner in;
    private String chars;
    private int charsPos;

    private int T;
    private int case_;

    public static void main(String[] args) throws IOException {
        new SolverB().solve();
    }

    public void solve() throws IOException {
        in = new Scanner(new File(fileName + ".in"));
        out = new FileWriter(fileName + ".out");
        T = in.nextInt();

        int lastProgress = 0;
        for (case_ = 0; case_ < T; case_++) {
            int progress = case_ * 10 / T;
            if (progress > lastProgress) {
                System.out.println(progress + "0%, " + case_ + "/" + T);
                lastProgress = progress;
            }

            int N = in.nextInt();
            int M = in.nextInt();
            int[][] a = new int[N][M];
            int[] maxN = new int[N];
            int[] maxM = new int[M];
            for (int n = 0; n < N; n++) {
                for (int m = 0; m < M; m++) {
                    int v = in.nextInt();
                    a[n][m] = v;
                    if (v > maxN[n]) {
                        maxN[n] = v;
                    }
                    if (v > maxM[m]) {
                        maxM[m] = v;
                    }
                }
            }
            int n;
            for (n = 0; n < N; n++) {
                for (int m = 0; m < M; m++) {
                    int v = a[n][m];
                    if (v < maxN[n] && v < maxM[m]) {
                        result("NO");
                        n = N;
                        break;
                    }
                }
            }
            if (n == N) {
                result("YES");
            }
        }
        out.close();
    }

    private void result(String res) throws IOException {
        out.write("Case #" + (case_ + 1) + ": " + res + "\n");
    }

    private char nextChar() {
        if (chars == null) {
            chars = in.next();
            charsPos = 0;
        } else {
            charsPos++;
        }
        return chars.charAt(charsPos);

    }

    private void endChars() {
        if (chars.length() > charsPos + 1) {
            throw new RuntimeException("String wasn't read fully: " + chars + ", pos: " + charsPos);
        }
        chars = null;
    }
}
