package codejam2015.qualifications;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

public class Dijkstra {
	private static HashMap<Character, Integer> hmap;
	
	public static void main(String[] args) throws IOException {
		Dijkstra obj = new Dijkstra();
		File inFile = new File("input/Dijkstra.in.small");
		File outFile = new File("output/Dijkstra.out.small");
		FileWriter fw = new FileWriter(outFile);
		FileReader fr = new FileReader(inFile);
		BufferedReader br = new BufferedReader(fr);
		BufferedWriter bw = new BufferedWriter(fw);
		DijkstraCharacter[][] refArray = getReferenceArray(obj);
		hmap = new HashMap<Character, Integer>();
		hmap.put('1', 0);
		hmap.put('i', 1);
		hmap.put('j', 2);
		hmap.put('k', 3);
		int numTestCases = Integer.valueOf(br.readLine());
		for(int k=1; k<=numTestCases; k++) {
			bw.write("Case #"+k+": ");
			String input = br.readLine();
			String[] tokens = input.split(" ");			
			int repeatTimes = Integer.valueOf(tokens[1]);
			input = br.readLine();
			StringBuffer sb = new StringBuffer();
			while(repeatTimes>0){
				repeatTimes--;
				sb.append(input);
			}
			String finalString = sb.toString();
						
			//is
			Set<Integer> is = new TreeSet<Integer>();
			char prev = '1';
			int isNegative = 0;
			for(int i=0; i<finalString.length(); i++) {
				DijkstraCharacter nowChar = getArrayElement(refArray, prev, finalString.charAt(i));
				isNegative = nowChar.isNegative ? isNegative^1 : isNegative^0;
				if(nowChar.c=='i' && isNegative==0){
					is.add(i);
				}
				prev = nowChar.c;
			}
			if(is.size()==0){
				bw.write("NO\n");
				continue;
			}
			
			//js
			Set<Integer> js = new TreeSet<Integer>();
			Iterator<Integer> itr = is.iterator();
			while(itr.hasNext()){
				prev='1';
				isNegative = 0;
				for(int i=itr.next()+1; i<finalString.length(); i++) {
					DijkstraCharacter nowChar = getArrayElement(refArray, prev, finalString.charAt(i));
					isNegative = nowChar.isNegative ? isNegative^1 : isNegative^0;
					if(nowChar.c=='j' && isNegative==0){
						js.add(i);
					}
					prev = nowChar.c;	
				}
			}
			if(js.size()==0){
				bw.write("NO\n");
				continue;
			}
			
			//ks
			itr = js.iterator();
			boolean flag = true;
			while(itr.hasNext()){
				prev='1';
				isNegative = 0;
				for(int i=itr.next()+1; i<finalString.length(); i++) {
					DijkstraCharacter nowChar = getArrayElement(refArray, prev, finalString.charAt(i));
					isNegative = nowChar.isNegative ? isNegative^1 : isNegative^0;					
					prev = nowChar.c;	
				}
				if(prev=='k' && isNegative==0){
					bw.write("YES\n");
					flag = false;
					break;
				}
			}
			if(flag){
				bw.write("NO\n");
			}
		}
		bw.close();
		br.close();
		fw.close();
		fr.close();
	}
	
	private static DijkstraCharacter[][] getReferenceArray(Dijkstra d) {
		DijkstraCharacter[][] arr =		{{d.new DijkstraCharacter('1', false), d.new DijkstraCharacter('i', false),
				d.new DijkstraCharacter('j', false), d.new DijkstraCharacter('k', false)},
				{d.new DijkstraCharacter('i', false), d.new DijkstraCharacter('1', true),
					d.new DijkstraCharacter('k', false), d.new DijkstraCharacter('j', true)},
					{d.new DijkstraCharacter('j', false), d.new DijkstraCharacter('k', true),
						d.new DijkstraCharacter('1', true), d.new DijkstraCharacter('i', false)},
						{d.new DijkstraCharacter('k', false), d.new DijkstraCharacter('j', false),
							d.new DijkstraCharacter('i', true), d.new DijkstraCharacter('1', true)}};
		return arr;
	}
	
	private static DijkstraCharacter getArrayElement(DijkstraCharacter[][] arr, char r, char c){
		return arr[hmap.get(r)][hmap.get(c)];
	}
	
	private class DijkstraCharacter {
		char c;
		boolean isNegative;
		
		public DijkstraCharacter(char c,boolean b) {
			this.c = c;
			this.isNegative = b;
		}
	}

}
