package year2016.qualification;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashSet;
import java.util.Set;

public class Main {
	
	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String inputLine = br.readLine();
		int numTestCases = Integer.valueOf(inputLine);
		int currentCase = 0;
		while(currentCase < numTestCases) {
			currentCase++;
			System.out.print("Case #"+currentCase+": ");
			long originalNum = Long.valueOf(br.readLine());
			long num=originalNum;
			if(num == 0) {
				System.out.println("INSOMNIA");
				continue;
			}
			Set<Integer> allDigits = new HashSet<>();
			for(int i=0; i<10; i++) {
				allDigits.add(i);
			}
			int count = 1;
			while(true) {
				Set<Integer> thisNumDigits = getDigitsOfNumber(num);
				allDigits.removeAll(thisNumDigits);
				if(allDigits.size()==0) {
					System.out.println(num);
					break;
				} else {
					count++;
					if(count==Integer.MAX_VALUE) {
						System.out.println("INSOMNIA");
						break;
					} else {
						num=originalNum*count;
					}
				}
			}
		}
	}
	
	private static Set<Integer> getDigitsOfNumber(long num) {
		Set<Integer> result = new HashSet<>();
		while(num>0) {
			int digit = (int)num%10;
			result.add(digit);
			num/=10;
		}
		return result;
	}

}
