package codejam2015.qualifications;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

public class IHOP {

	public static void main(String[] args) throws IOException {
		File inFile = new File("input/IHOP.in");
		File outFile = new File("output/IHOP.out");
		FileWriter fw = new FileWriter(outFile);
		FileReader fr = new FileReader(inFile);
		BufferedReader br = new BufferedReader(fr);
		BufferedWriter bw = new BufferedWriter(fw);
		int numTestCases = Integer.valueOf(br.readLine());
		for(int k=1; k<=numTestCases; k++) {
			int numPlates = Integer.valueOf(br.readLine());
			String input = br.readLine();
			String[] tokens = input.split(" ");
			ArrayList<Integer> list = new ArrayList<Integer>();
			int totalPancakes = 0;
			for(int i=0; i<numPlates; i++) {
				int num = Integer.valueOf(tokens[i]);
				totalPancakes+=num;
				list.add(num);
			}
			int minutes = getMinMinutes(list, totalPancakes);
			bw.write("Case #"+k+": "+minutes+"\n");
		}
		bw.close();
		br.close();
		fw.close();
		fr.close();
	}
	
	private static int getMinMinutes(ArrayList<Integer> plates, int totalPancakes) {
		// normal minute
		if(plates.size()==totalPancakes) {
			return 1;
		}
		ArrayList<Integer> normalMinute = new ArrayList<Integer>(plates.size());		
		for(int i=0; i<plates.size(); i++){
			if(plates.get(i)>1){
				normalMinute.add(plates.get(i)-1);
			}			
		}
		int newTotalPancakes = totalPancakes-plates.size();
		
		// special minute
		Collections.sort(plates);
		int high = plates.remove(plates.size()-1);
		int p1 = high/2;
		int p2 = high-p1;
		plates.add(p1);
		plates.add(p2);
		
		return (1+Math.min(getMinMinutes(normalMinute, newTotalPancakes), getMinMinutes(plates, totalPancakes)));
	}

}
