package challenge2017;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Bruno
 */
public class BathroomStalls {
    
    private static String directory = "data/challenge2017";
    private static String fileName = "C-large";
    private static String inputFile = fileName + ".in";
    private static String outputFile = fileName + ".out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        Path path = Paths.get(directory, inputFile);
        List<String> lines = Files.readAllLines(path);
        PrintWriter out = new PrintWriter(new FileWriter(Paths.get(directory, outputFile).toString()));
        Iterator<String> it = lines.iterator();
        long numTests = Integer.parseInt(it.next());
        for (long i = 1; i <= numTests; ++i) {
            out.printf("Case #%d: %s%n", i, solve(it.next()));
        }
        out.close();
    }

    public static String solve(String line) {
        String[] tokens = line.split(" ");
        long n = Long.parseLong(tokens[0]);
        long k = Long.parseLong(tokens[1]);
        long start = 0;
        long end = n + 1;
        long middle = 0;
        while (true) {
            middle = (start + end) >>> 1;
            if (k == 1) {
                break;
            }
            start = middle;
            k >>>= 1;
        }
        long left = middle - start - 1;
        long right = end - middle - 1;
        return Math.max(left, right) + " " + Math.min(left, right);
    }

}