package challenge2017;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Iterator;
import java.util.List;
import java.util.stream.Collectors;
import java.util.stream.IntStream;

/**
 *
 * @author Bruno
 */
public class NewClass {
    
    private static String directory = "F:/users/bruno/downloads";
    private static String fileName = "A-large";
    private static String inputFile = fileName + ".in";
    private static String outputFile = fileName + ".out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        Path path = Paths.get(directory, inputFile);
        List<String> lines = Files.readAllLines(path);
        PrintWriter out = new PrintWriter(new FileWriter(Paths.get(directory, outputFile).toString()));
        Iterator<String> it = lines.iterator();
        int numTests = Integer.parseInt(it.next());
        for (int i = 1; i <= numTests; ++i) {
            String[] tokens = it.next().split(" ");
            int d = Integer.parseInt(tokens[0]);
            int numHorses = Integer.parseInt(tokens[1]);
            List<String> horses = IntStream.range(0, numHorses).mapToObj(j -> it.next()).collect(Collectors.toList());
            out.printf("Case #%d: %s%n", i, solve(d, horses));
        }
        out.close();
    }

    public static String solve(int dist, List<String> horses) {
        double tempsMax = 0;
        for (String horse : horses) {
            String[] tokens = horse.split(" ");
            int start = Integer.parseInt(tokens[0]);
            int speed = Integer.parseInt(tokens[1]);
            double arrivee = (dist - start) / (double) speed;
            tempsMax = Math.max(tempsMax, arrivee);
        }
        return String.valueOf(dist / tempsMax);
    }
}
