package challenge2017;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Bruno
 */
public class OversizedPancakeFlipper {

    private static String directory = "data/challenge2017";
    private static String fileName = "A-large";
    private static String inputFile = fileName + ".in";
    private static String outputFile = fileName + ".out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        Path path = Paths.get(directory, inputFile);
        List<String> lines = Files.readAllLines(path);
        PrintWriter out = new PrintWriter(new FileWriter(Paths.get(directory, outputFile).toString()));
        Iterator<String> it = lines.iterator();
        int numTests = Integer.parseInt(it.next());
        for (int i = 1; i <= numTests; ++i) {
            out.printf("Case #%d: %s%n", i, solve(it.next()));
        }
        out.close();
    }

    public static String solve(String line) {
        String[] tokens = line.split(" ");
        int[] pancakes = tokens[0].chars().map(c -> c == '+' ? 0 : 1).toArray();
        int flipperSize = Integer.parseInt(tokens[1]);
        int flipCount = 0;
        int maxStart = pancakes.length - flipperSize;
        for (int start = 0; start <= maxStart; ++start) {
            if (pancakes[start] == 1) {
                flip(pancakes, flipperSize, start);
                ++flipCount;
            }
        }
        for (int i = maxStart; i < pancakes.length; ++i) {
            if (pancakes[i] == 1) {
                return "IMPOSSIBLE";
            }
        }
        return String.valueOf(flipCount);
    }

    private static void flip(int[] pancakes, int flipperSize, int start) {
        int stop = start + flipperSize;
        for (int i = start; i < stop; ++i) {
            pancakes[i] ^= 1;
        }
    }
    
}
