package challenge2015;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author Bruno Lehouque
 */
public class Round1 {
    
    public static final String DATA_DIR = "data\\challenge2015\\";

    public static void main(String[] args) {
        System.out.print("Enter the data file name: ");
        String fileName = DATA_DIR + new Scanner(System.in).nextLine();
        String input = fileName + ".in";
        StringBuilder solutions = new StringBuilder();
        try (BufferedReader reader = new BufferedReader(new FileReader(input))) {
            int testCount = Integer.parseInt(reader.readLine());
            
            for (int i = 0; i != testCount; ++i) {
                String[] split = reader.readLine().split(" ");
                int requiredApplauds = Integer.parseInt(split[0]);
                String solution = solve(i + 1, requiredApplauds, split[1]);
                System.out.println(solution);
                solutions.append(solution).append('\n');
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(Round1.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(Round1.class.getName()).log(Level.SEVERE, null, ex);
        }
        
        String output = fileName + ".out";
        try (BufferedWriter writer = new BufferedWriter(new FileWriter(output))) {
            writer.append(solutions);
        } catch (IOException ex) {
            Logger.getLogger(Round1.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    private static String solve(int numCase, int requiredApplauds, String shyness) {
        int applauds = 0;
        int needed = 0;
        int index = 0;
        while (applauds < requiredApplauds) {
            applauds += shyness.charAt(index++) - '0';
            if (applauds < index) {
                ++needed;
                ++applauds;
            }
        }
        return "Case #" + numCase + ": " + needed;
    }
    
}
