package challenge2017;

import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Iterator;
import java.util.List;

/**
 *
 * @author Bruno
 */
public class TidyNumbers {
    
    private static String directory = "data/challenge2017";
    private static String fileName = "B-large";
    private static String inputFile = fileName + ".in";
    private static String outputFile = fileName + ".out";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws IOException {
        Path path = Paths.get(directory, inputFile);
        List<String> lines = Files.readAllLines(path);
        PrintWriter out = new PrintWriter(new FileWriter(Paths.get(directory, outputFile).toString()));
        Iterator<String> it = lines.iterator();
        int numTests = Integer.parseInt(it.next());
        for (int i = 1; i <= numTests; ++i) {
            out.printf("Case #%d: %s%n", i, solve(it.next()));
        }
        out.close();
    }

    public static String solve(String line) {
        int length = line.length();
        if (length == 1) {
            return line;
        }
        char[] tidy = line.toCharArray();
        int i = 1;
        while ((i < length) && (tidy[i] >= tidy[i - 1])) {
            ++i;
        }
        if (i == length) {
            return line;
        }
        while ((i > 1) && (tidy[i - 1] == tidy[i - 2])) {
            --i;
        }
        --tidy[i - 1];
        while (i < length) {
            tidy[i++] = '9';
        }
        String number = String.valueOf(tidy);
        return number.startsWith("0") ? number.substring(1) : number;
    }
}
