//Problem: Google Code Jam 2013 Qualification Round C
//Name: Fair and Square
//Author: Bruce K. B. Tong
//Tag: BigInteger, Lookup Table, Binary Search

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;
import java.math.BigInteger;
import java.util.*;

public class C {
	final int MAX_DIGIT_SQRT = 50;
	final BigInteger ten = BigInteger.valueOf(10);
	ArrayList<BigInteger> num = new ArrayList<BigInteger>();
	PrintWriter tout;
	
	private Boolean palindrome(BigInteger a) {
		String d = a.toString();
		int k = d.length();
		for (int i = 0; i < k/2; i++)
			if (d.charAt(i) != d.charAt(k-i-1)) return false;
		return true;
	}
	
	private void test(char[] val) {
		BigInteger v = new BigInteger(new String(val));
		BigInteger a = v.multiply(v);
		if (palindrome(a)) //num.add(a);
			tout.println(a);
	}
	
	private void fill(char[] val, int lo, int hi) {
		if (lo > hi) {
			test(val);
			return;
		} else if (lo == hi) {
			val[lo] = '0';
			test(val);
			val[lo] = '1';
			test(val);
			val[lo] = '2';
			test(val);
			return;
		}
		val[lo] = val[hi] = '0';
		fill(val, lo+1, hi-1);
		val[lo] = val[hi] = '1';
		fill(val, lo+1, hi-1);
	}

	private void preprocess() {
		for (int i = 1; i <= 9; i++) {
			char[] c = new char[1];
			c[0] = (char)('0'+i);
			test(c);
		}
		for (int i = 1; i <= 9; i++) {
			char[] c = new char[2];
			c[0] = c[1] = (char)('0'+i);
			test(c);
		}
		
		for (int k = 3; k <= MAX_DIGIT_SQRT; k++) {
			char[] val = new char[k];
			val[0] = val[k-1] = '1';
			fill(val, 1, k-2);
			val[0] = val[k-1] = '2';
			fill(val, 1, k-2);
		}
	}

	private int solve(BigInteger A, BigInteger B) {
		int u = Collections.binarySearch(num, A);
		int v = Collections.binarySearch(num, B);
		//System.out.print(u + " * " + v);
		if (u < 0) u = -u-1;
		if (v < 0) v = -v-1 - 1;
		return v - u + 1;
	}
	
	public C() throws FileNotFoundException {
		//String OUT = "C-table.txt";
		//tout = new PrintWriter(new File(OUT));
	}
	
	private void read() throws FileNotFoundException {
		String IN = "C-table.txt";
		Scanner in = new Scanner(new File(IN));
		int n;
		BigInteger a;
		n = in.nextInt();
		for (int i = 1; i <= n; i++) {
			a = in.nextBigInteger();
			num.add(a);
		}
		in.close();
	}
	
	public static void main(String[] args) throws FileNotFoundException {
		//String IN = "C-sample.in";
		//String OUT = "C-sample.out";
		//String IN = "C-small-attempt1.in";
		//String OUT = "C-small-attempt1.out";
		//String IN = "C-large-1.in";
		//String OUT = "C-large-1.out";
		String IN = "C-large-2.in";
		String OUT = "C-large-2.out";
		Scanner in = new Scanner(new File(IN));
		PrintWriter out = new PrintWriter(new File(OUT));
		
		int T;					//1 <= T <= 100 (or 10,000, or 1,000)
		BigInteger A, B;		//1 <= A <= B <= 1,000 (or 10^14, or 10^100)
		C c = new C();
		//c.preprocess();
		c.read();

		T = in.nextInt();
        for (int i = 1; i <= T; i++) {
    		A = in.nextBigInteger();
    		B = in.nextBigInteger();
        	String s = "Case #" + i + ": " + c.solve(A, B);
            out.println(s);
            //System.out.println(s);
        }
        in.close();
        out.close();
	}
}
