package CodeJam2017;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;
import java.util.Stack;

public class Round1C {
	
	public static final boolean SaveToFile = true;
	public static final boolean ReadFromFile = true;
	
	public static final String InputLocation = "C:\\Users\\Macke\\Downloads\\";
	public static final String ResultLocation = "";
	
	public static final String inputFile = "C-small-1-attempt0.in";
	public static final String resultFile = "C-res.txt";
	
	
	static Scanner newInput() throws IOException {
	    if (ReadFromFile) {
	        return new Scanner(new File(InputLocation+inputFile));
	    } else {
	        return new Scanner(System.in);
	    }
	}
	static PrintWriter newOutput() throws IOException {
	    if (SaveToFile) {
	        return new PrintWriter(ResultLocation+resultFile);
	    } else {
	        return new PrintWriter(System.out);
	    }
	}

	public static void main(String[] args) {
		// TODO Auto-generated method stub
		Scanner input = null;
		PrintWriter output = null;
		
		boolean failed = false;		
		try {
			input = newInput();
			output = newOutput();
		} catch(Exception e) {
			failed = true;
			System.out.println("Fail input/output;");
		}
		
		int T,N,K;
		if (!failed) {
			T = input.nextInt();
			for (int i = 0; i < T; i++) {
				N = input.nextInt();
				K = input.nextInt();
				
				output.println(String.format("Case #%d: %s",(i+1),solution(N,K)));
				output.flush();
			}
		} else {
			System.out.println("Something failed with the intput/output fetching");
		}
	}
	
	private static String solution(int N, int K) {
		boolean[] vec = new boolean[N];
		long[] DL = new long[N];
		long[] DR = new long[N];
		for (int i = 0; i < N; i++) {
			DL[i] = i;
			DR[i] = N-i-1;
		}
		
		//System.out.format("DL: %s\n", Arrays.toString(DL));
		//System.out.format("DR: %s\n", Arrays.toString(DR));
		
		int maxNdx = 0;
		for (int i = 0; i < K; i++) {
			maxNdx = getMax(vec,DL,DR);
			
			vec[maxNdx] = true;
			updateDistVecs(maxNdx,vec,DL,DR);
			//System.out.format("maxNdx: %d\nDL: %s\nDR: %s\nvec: %s\n",maxNdx,Arrays.toString(DL),Arrays.toString(DR), Arrays.toString(vec));
		}
		
		return String.format("%d %d",DR[maxNdx],DL[maxNdx]); 
	}
	
	private static void updateDistVecs(int pos, boolean[] vec, long[] DL, long[] DR) {
		for (int i = pos-1; i >-1 && !vec[i];i--) {
			DR[i] = pos - i - 1;
		}
		
		for (int i = pos+1; i < vec.length && !vec[i]; i++) {
			DL[i] = i-pos - 1;
		}
	}
	
	private static int getMax(boolean[] stalls, long[] DL, long[] DR) {
		long maxSum = Integer.MIN_VALUE;
		long minDL;
		long minDR;
		long tmp;
		int res = 0;
		Stack<Integer> candidates = new Stack<Integer>();
		for (int i = 0; i < DL.length; i++) {
			tmp = DL[i] + DR[i];
			if (tmp > maxSum && !stalls[i]) {
				res = i;
				maxSum = tmp;
				candidates.clear();
				candidates.push(i);
			} else if(tmp == maxSum) {
				candidates.push(i);
			}
		}
		
		int t = candidates.pop();
		maxSum = Math.min(DL[t], DR[t]);		
		Stack<Integer> tmpS = new Stack<Integer>();
		//System.out.format("candidate: %d, DL: %d, DR: %d, max: %d\n", t,DL[t],DR[t],maxSum);
		tmpS.push(t);
		while(!candidates.isEmpty()) {
			t = candidates.pop();
			tmp = Math.min(DL[t], DR[t]);
			//System.out.format("candidate: %d, DL: %d, DR: %d, max: %d, tmp: %d\n", t,DL[t],DR[t],maxSum,tmp);
			if (tmp > maxSum) {
				tmpS.clear();
				tmpS.push(t);
				maxSum = tmp;
			} else if(tmp == maxSum) {
				tmpS.push(t);
			}
		}
		
		candidates = tmpS;
		
		t = candidates.pop();
		maxSum = Math.max(DL[t], DR[t]);		
		tmpS = new Stack<Integer>();
		tmpS.push(t);
		while(!candidates.isEmpty()) {
			t = candidates.pop();
			tmp = Math.min(DL[t], DR[t]);
			if (tmp > maxSum) {
				tmpS.clear();
				tmpS.push(t);
				maxSum = tmp;
			} else if(tmp == maxSum) {
				tmpS.push(t);
			}
		}
		
		candidates = tmpS;
		
		t = candidates.pop();
		while (!candidates.isEmpty()) {
			if (candidates.peek() < t) {
				t = candidates.pop();
			} else {
				candidates.pop();
			}
		}
		
		return t;
	}
	
	

}
