/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package trains;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 *
 * @author rstoski
 */
public class Trains {
    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        try {
            BufferedReader in = new BufferedReader(new FileReader("input.txt"));
            int cases = Integer.parseInt(in.readLine());
            List<Integer> arriveA = null;
            List<Integer> arriveB = null;
            List<Integer> departA = null;
            List<Integer> departB = null;
            for (int caseNum = 0; caseNum < cases; ++caseNum) {
                int turnaround = Integer.parseInt(in.readLine());
                
                // Prepare variables
                arriveA = new ArrayList<Integer>();
                arriveB = new ArrayList<Integer>();
                departA = new ArrayList<Integer>();
                departB = new ArrayList<Integer>();
                
                // Parse trip times
                String tripsStr = in.readLine();
                String[] tripStrs = tripsStr.split(" ");
                int aTrips = Integer.parseInt(tripStrs[0]);
                int bTrips = Integer.parseInt(tripStrs[1]);
                parseTrips(aTrips, turnaround, in, departA, arriveB);
                parseTrips(bTrips, turnaround, in, departB, arriveA);
                
                // Sort lists
                Collections.sort(departA);
                Collections.sort(departB);
                Collections.sort(arriveA);
                Collections.sort(arriveB);
                
                // Process A trains
                int requiredA = processRequired(arriveA, departA);
                int requiredB = processRequired(arriveB, departB);
                System.out.println("Case #" + (caseNum + 1) + ": " + requiredA
                        + " " + requiredB);
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    private static String outTime(Integer time) {
        return (time.intValue() / 60) + ":" + (time.intValue() % 60);
    }
    
    private static int processRequired(List<Integer> arrive, List<Integer> depart) {
        int maxRequired = 0;
        int requiredTrains = 0;
        Integer nextArrival = arrive.isEmpty() ? null : arrive.remove(0);
        Integer nextDeparture = depart.isEmpty() ? null : depart.remove(0);
        while (nextArrival != null && nextDeparture != null) {
            if (nextDeparture < nextArrival) {
                // Lose one train
                ++requiredTrains;
                if (depart.isEmpty()) {
                    nextDeparture = null;
                } else {
                    nextDeparture = depart.remove(0);
                }
            } else {
                // Gain one train
                --requiredTrains;
                if (arrive.isEmpty()) {
                    nextArrival = null;
                } else {
                    nextArrival = arrive.remove(0);
                }
            }

            // Update the running total
            if (requiredTrains > maxRequired) {
                maxRequired = requiredTrains;
            }
        }

        if (nextArrival == null) {
            // Ran out of arrivals, update for remaining departures
            if (nextDeparture != 0) {
                ++requiredTrains;
            }
            requiredTrains += depart.size();
        }

        // Update the running total
        if (requiredTrains > maxRequired) {
            maxRequired = requiredTrains;
        }
        return maxRequired;
    }
    
    private static void parseTrips(int numTrips, int turnaround, BufferedReader in, 
            List<Integer> departures, List<Integer> arrivals) {
        try {
            for (int trip = 0; trip < numTrips; ++trip) {
                String[] times = in.readLine().split(" ");
                String[] departStr = times[0].split(":");
                String[] arriveStr = times[1].split(":");
                int departTime = Integer.parseInt(departStr[0]) * 60 + 
                        Integer.parseInt(departStr[1]);
                int arriveTime = Integer.parseInt(arriveStr[0]) * 60 + 
                        Integer.parseInt(arriveStr[1]) + turnaround;
                departures.add(new Integer(departTime));
                arrivals.add(new Integer(arriveTime));
            }
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

}
