//
//  Universe.java
//  Universe
//
//  Created by Robert Stoski on 16/07/08.
//  Copyright (c) 2008 __MyCompanyName__. All rights reserved.
//
import java.util.*;
import java.io.*;


public class Universe {

    public static void main (String args[]) {
		try {
			BufferedReader in = new BufferedReader(new InputStreamReader(new FileInputStream("../input.txt")));
			// Read number of test cases
			int testCases = Integer.parseInt(in.readLine());
			for (int testCase = 0; testCase < testCases; ++testCase) {
				// Perform test case
				
				// Read search engines
				int numEngines = Integer.parseInt(in.readLine());
				HashMap<String, String> engineMap = new HashMap<String, String>(numEngines);
				for (int engine = 0; engine < numEngines; ++engine) {
					String engineStr = in.readLine();
					engineMap.put(engineStr, engineStr);
				}
				
				// Record the number of switches required
				int enginesSwitched = 0;
				
				// Start selecting engines
				Map<String, String> searchMap = (Map<String, String>) engineMap.clone();
				int numSearches = Integer.parseInt(in.readLine());
				String lastEngine = null;
				for (int search = 0; search < numSearches; ++search) {
					if(searchMap.isEmpty()) {
						++enginesSwitched;
						searchMap = (Map<String, String>) engineMap.clone();
						searchMap.remove(lastEngine);
					}
					searchMap.remove((lastEngine = in.readLine()));
				}
				if (searchMap.isEmpty()) ++enginesSwitched;
				
				System.out.println("Case #" + (testCase + 1) + ": " + enginesSwitched);
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
    }
}
