import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 *
 * @author rstoski
 */
public class AlienLanguage {
    public static void main(String[] args) {
        try {
            BufferedWriter writer = new BufferedWriter(new FileWriter("C:/output.txt"));
            BufferedReader reader = new BufferedReader(new FileReader("C:/A-small-attempt0.in"));
            String paramStr = reader.readLine();
            String[] params = paramStr.split(" ");
            int L = Integer.parseInt(params[0]);
            int D = Integer.parseInt(params[1]);
            int N = Integer.parseInt(params[2]);
            Map<Character, Map> charTree = new HashMap<Character, Map>();
            List<String> dictionary = new ArrayList<String>();

            // Build Tree
            for (int i = 0; i < D; ++i) {
                String nextWord = reader.readLine();
                dictionary.add(nextWord);
                Map<Character, Map> charTreeNode = charTree;
                for (char nextChr : nextWord.toCharArray()) {
                    Character nextChar = Character.valueOf(nextChr);
                    if (!charTreeNode.containsKey(nextChar)) {
                        charTreeNode.put(nextChar, new HashMap<Character, Map>());
                    }
                    charTreeNode = charTreeNode.get(nextChar);
                }
            }

            // Search tree
            for (int i = 0; i < N; ++i) {
                int numMatches = 0;
                String nextPattern = reader.readLine();
                String regexPattern = nextPattern.replace('(', '[');
                regexPattern = regexPattern.replace(')', ']');
                Pattern pattern = Pattern.compile(regexPattern);
                for (String word : dictionary) {
                    Matcher m = pattern.matcher(word);
                    if (m.matches()) numMatches++;
                }
                writer.write("Case #" + (i + 1) + ": " + numMatches + "\n");
            }
            writer.close();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}