package gcj2016.onec;

public class A {
	private String path = "/home/brunoff/data/dev/gcj/data/2016/1c/";
	private int casescount;
	private Case[] Cases;
	private class Case {
		public Case(String senatorCount,String senatorArray) {
			senatorcount = Integer.parseInt(senatorCount);
			senators = new int[senatorcount]; { int i = 0;
			for(String s : senatorArray.split(" ")) { senators[i] = Integer.parseInt(s); i++; } }
			senatorsoriginal = "( "; for(int i : senators) senatorsoriginal += i + " "; senatorsoriginal += ")";
		}
		private int senatorcount;
		private String senatorsoriginal;
		private int[] senators;
		private String plan;
		private int senatorsremaining() { int result = 0; for(int i : senators) result += i; return result; }
		
		private void solve() {
			plan = "";
			while(senatorsremaining() > 0) {
				if(senatorsremaining() == 3)
					plan += String.valueOf(takeoneout());
				else
					plan += String.valueOf(takeoneout()) + String.valueOf(takeoneout());
				if(senatorsremaining() > 0)
					plan += " ";
			}
		}
		
		private int biggestpos() {
			int biggestpos = 0;
			for(int pos = 0, biggestfound = 0; pos<senatorcount ;pos++)
				if(senators[pos] >= biggestfound) { biggestfound=senators[pos]; biggestpos=pos; }
			return biggestpos;
		}
		
		private char takeoneout() {
			char senator = senatorchar(biggestpos());
			senators[biggestpos()]--;
			return senator;
		}
		
		public String result() {
			return plan;
		}
		
		public String resultverbose() {
			return senatorcount + " (" + plan + ") " + senatorsoriginal;
		}
		
		private char senatorchar(int partynum) {
			return (char)(partynum+65);
		}
	}
	
	//void main points here (new gcj2016.onea.A().solve("A-large");)
	public void solve(String filename) throws Exception {
		readfile(filename);
		for(int casenumber=0;casenumber<casescount;casenumber++) {
			Cases[casenumber].solve();
			System.out.println("Case #"+(casenumber+1)+": "+caseresult(Cases[casenumber]));
		}
		writeresult(filename);
	}
	
	private String caseresult(Case Case) {
		return Case.result();
	}
	
	private void writeresult(String filename) {
		try(java.io.Writer writer = new java.io.BufferedWriter(new java.io.OutputStreamWriter(new java.io.FileOutputStream(path+filename+".out")))) {
			for(int casenumber=0;casenumber<casescount;casenumber++)
				writer.write("Case #"+(casenumber+1)+": "+caseresult(Cases[casenumber])+System.lineSeparator());
		} catch (Exception ex) { ex.printStackTrace(); };
	}
	
	private void readfile(String filename) {
		try (java.io.BufferedReader reader = java.nio.file.Files.newBufferedReader(java.nio.file.Paths.get(path+filename+".in"))) {
			casescount = Integer.parseInt(reader.readLine());
			Cases = new Case[casescount];
			for(int casenumber=0;casenumber<casescount;casenumber++) {
				Cases[casenumber] = new Case(reader.readLine(),reader.readLine());
			}
		} catch (java.io.IOException ioex) {
			ioex.printStackTrace();
		}
	}
}