package codejam;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class Magicka {
    private static class Pair {
        public char a;
        public char b;

        public Pair(char a, char b) {
            this.a = a;
            this.b = b;
        }

        @Override
        public boolean equals(Object obj) {
            if (obj == null) {
                return false;
            }
            if (getClass() != obj.getClass()) {
                return false;
            }
            final Pair other = (Pair) obj;
            return (a == other.a && b == other.b) || (a == other.b && b == other.a);
        }

        @Override
        public int hashCode() {
            String str = null;
            if (a < b)
                str = a + "" + b;
            else
                str = b + "" + a;
            return str.hashCode();
        }

    }

    static String formatResult(String str) {
        StringBuilder builder = new StringBuilder();
        builder.append("[");
        for (int i = 0; i < str.length(); i++) {
            builder.append(str.charAt(i));
            if (i < str.length() - 1)
                builder.append(", ");
        }
        builder.append("]");
        return builder.toString();
    }

    public static void main(String[] args) throws Exception {
        BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
        int nCases = Integer.parseInt(in.readLine());
        for (int i = 0; i < nCases; i++) {
            String[] tokens = in.readLine().split("\\s");
            int idx = 0;
            int c = Integer.parseInt(tokens[idx++]);
            Map<Pair, Character> combine = new HashMap<Pair, Character>();
            for (int j = 0; j < c; j += 2) {
                String token = tokens[idx++];
                combine.put(new Pair(token.charAt(0), token.charAt(1)), token.charAt(2));
            }
            int o = Integer.parseInt(tokens[idx++]);
            Set<Pair> oppose = new HashSet<Pair>();
            for (int j = 0; j < o; j += 2) {
                String token = tokens[idx++];
                oppose.add(new Pair(token.charAt(0), token.charAt(1)));
            }
            idx++;
            String testCase = tokens[idx++];
            String elementList = "";

            for (int j = 0; j < testCase.length(); j++) {
                //Let's invoke each element from left to right
                elementList += testCase.charAt(j);

                //Check if there's something to erase from the end of the element list
                while (true) {
                    boolean didSomething = false;

                    if (elementList.length() > 1) {
                        Pair finalPair = new Pair(elementList.charAt(elementList.length() - 2), elementList.charAt(elementList.length() - 1));

                        if (combine.containsKey(finalPair)) {
                            elementList = elementList.substring(0, elementList.length() - 2) + combine.get(finalPair);
                            didSomething = true;
                        } else {
                            //Now check if there's some opposite pairs
                            for (Pair opp : oppose) {
                                for (int x = 0; x < elementList.length() - 1; x++) {
                                    for (int y = x + 1; y < elementList.length(); y++) {
                                        if ((opp.a == elementList.charAt(x) && opp.b == elementList.charAt(y)) ||
                                            (opp.a == elementList.charAt(y) && opp.b == elementList.charAt(x))) {
                                            didSomething = true;
                                            elementList = "";
                                        }
                                    }
                                }
                            }
                        }
                    }

                    if (!didSomething)
                        break;
                }
            }

            System.out.println("Case #" + (i + 1) + ": " + formatResult(elementList));
        }
        in.close();
    }
}
