package codejam;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

public class Brible {
	static int minCoins = Integer.MAX_VALUE;
	
	static void solve(boolean[] cells, int[] ops, int index, List<Integer> visited) {
		if (cells[index - 1]) {
			cells[index - 1] = false;
			visited.add(index);
			
			if (visited.size() == ops.length) {
				minCoins = Math.min(minCoins, calc(cells.length, visited));
			} else {
				for (int i = 0; i < ops.length; i++) {
					if (cells[ops[i] - 1]) {
						solve(cells, ops, ops[i], visited);
					}
				}
			}
			
			cells[index - 1] = true;
			visited.remove((Integer)index);
		}
	}
	
	static int calc(int p, List<Integer> visited) {
		int neighbors = 0;
		boolean[] cells = new boolean[p];
		Arrays.fill(cells, true);

		for (int cell : visited) {
			cell--;
			if (cells[cell]) {
				cells[cell] = false;
				
				//Count the neighbors
				for (int i = cell - 1; i >= 0; i--) {
					if (cells[i]) {
						neighbors++;
					} else {
						break;
					}
				}
				
				for (int i = cell + 1; i < p; i++) {
					if (cells[i]) {
						neighbors++;
					} else {
						break;
					}
				}
			}
		}
		
		return neighbors;
	}
	
	public static void main(String[] args) {
		Scanner in = new Scanner(System.in);
		int n = in.nextInt();
		for (int ncase = 0; ncase < n; ncase++) {
			minCoins = Integer.MAX_VALUE;
			
			int p = in.nextInt();
			int q = in.nextInt();
			boolean[] cells = new boolean[p];
			Arrays.fill(cells, true);
			int[] ops = new int[q];
			for (int op = 0; op < q; op++) {
				ops[op] = in.nextInt();
			}
			for (int op : ops) {
				solve(cells, ops, op, new ArrayList<Integer>());
			}
			
			System.out.println("Case #" + (ncase + 1) + ": " + minCoins);
		}
	}
}
