/*
 * A.java
 *
 * Created on 16 de Julho de 2008, 19:05
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package codejam.y2008.qualify;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;

/**
 *
 * @author Anderson L. Brunozi
 */
public class B {    
    private int turnTime;
    private int[][] aTable;
    private int[][] bTable;
    
    private int aTrains;
    private int bTrains;
    
    /** Creates a new instance of A */
    public B(BufferedReader in) throws Exception {
        this.turnTime = Integer.parseInt(in.readLine());
        
        String[] ns = in.readLine().split(" ");
        
        this.aTable = new int[Integer.parseInt(ns[0])][2];
        this.bTable = new int[Integer.parseInt(ns[1])][2];
        
        for(int i = 0; i < this.aTable.length; i++) {
            String[] t = in.readLine().split(" ");
            this.aTable[i][0] = this.parseTime(t[0]);
            this.aTable[i][1] = this.parseTime(t[1]);
        }
        
        for(int i = 0; i < this.bTable.length; i++) {
            String[] t = in.readLine().split(" ");
            this.bTable[i][0] = this.parseTime(t[0]);
            this.bTable[i][1] = this.parseTime(t[1]);
        }
        
        this.sortTables();
        
        this.aTrains = 0;
        this.bTrains = 0;
    }//constructor
    
    private void sortTables() {
        for(int i = 1; i < this.aTable.length; i++) {
            int k = i;
            while((k > 0) && (this.aTable[k][0] < this.aTable[k - 1][0])) {
                int a = this.aTable[k][0];
                this.aTable[k][0] = this.aTable[k - 1][0];
                this.aTable[k - 1][0] = a;

                a = this.aTable[k][1];
                this.aTable[k][1] = this.aTable[k - 1][1];
                this.aTable[k - 1][1] = a;
                k--;
            }
        }
        
        for(int i = 1; i < this.bTable.length; i++) {
            int k = i;
            while((k > 0) && (this.bTable[k][0] < this.bTable[k - 1][0])) {
                int a = this.bTable[k][0];
                this.bTable[k][0] = this.bTable[k - 1][0];
                this.bTable[k - 1][0] = a;

                a = this.bTable[k][1];
                this.bTable[k][1] = this.bTable[k - 1][1];
                this.bTable[k - 1][1] = a;
                k--;
            }
        }
    }//sortTables
    
    private int parseTime(String s) {
        return Integer.parseInt(s.split(":")[1]) + (60 * Integer.parseInt(s.split(":")[0]));
    }//parseTime
    
    private int[] selectLine() {
        int firstA = 0;
        if(this.aTable.length > 0) {
            for(int i = 1; i < this.aTable.length; i++) {
                if((this.aTable[firstA][0] < 0) || ((this.aTable[i][0] < this.aTable[firstA][0]) && (this.aTable[i][0] >= 0))) {
                    firstA = i;
                }
            }

            if(this.aTable[firstA][0] < 0) {
                firstA = -1;
            }
        } else {
            firstA = -1;
        }
        
        int firstB = 0;
        if(this.bTable.length > 0) {
            for(int i = 1; i < this.bTable.length; i++) {
                if((this.bTable[firstB][0] < 0) || ((this.bTable[i][0] < this.bTable[firstB][0]) && (this.bTable[i][0] >= 0))) {
                    firstB = i;
                }
            }

            if(this.bTable[firstB][0] < 0) {
                firstB = -1;
            }
        } else {
            firstB = -1;
        }
        
        if(firstA >= 0) {
            if(firstB >= 0) {
                if(this.bTable[firstB][0] < this.aTable[firstA][0]) {
                    return new int[] { 1, firstB };
                } else {
                    return new int[] { 0, firstA };
                }
            } else {
                return new int[] { 0, firstA };
            }
        } else if(firstB >= 0) {
            return new int[] { 1, firstB };
        }
        
        return null;
    }//selectLine
    
    public void solve() {
        int[] line = this.selectLine();
        while(line != null) {
            if(line[0] == 0) {
                this.aTrains++;
                
                this.aTable[line[1]][0] = -1;
                this.markNextTrip(1, this.aTable[line[1]][1] + this.turnTime);
            } else if(line[0] == 1) {
                this.bTrains++;
                
                this.bTable[line[1]][0] = -1;
                this.markNextTrip(0, this.bTable[line[1]][1] + this.turnTime);
            }
            
            line = this.selectLine();
        }
    }//solve
    
    private void markNextTrip(int line, int time) {
        if(line == 0) { //AB
            for(int k = 0; k < this.aTable.length; k++) {
                if(this.aTable[k][0] >= time) {
                    this.aTable[k][0] = -1;
                    this.markNextTrip(1, this.aTable[k][1] + this.turnTime);
                    break;
                }
            }
        } else if(line == 1) { //BA
            for(int k = 0; k < this.bTable.length; k++) {
                if(this.bTable[k][0] >= time) {
                    this.bTable[k][0] = -1;
                    this.markNextTrip(0, this.bTable[k][1] + this.turnTime);
                    break;
                }
            }
        }
    }//markNextTrip
    
    public void printOutput(PrintStream out) {
        out.println(this.aTrains + " " + this.bTrains);
    }//printOutput
    
    
    public static void main(String[] args) throws Exception {
        BufferedReader in = new BufferedReader(new FileReader("B-large.in"));
        PrintStream out = new PrintStream("B-large.out");
        
        int nCases = Integer.parseInt(in.readLine());
        
        for(int i = 0; i < nCases; i++) {
            out.print("Case #" + (i + 1) + ": ");
            
            B b = new B(in);
            b.solve();
            b.printOutput(out);
        }
    }//main
}
