package google.codejam14;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.file.FileSystems;

public class MagicTrick {
	
	public static void main(String[] args) {
		File inputFile = FileSystems.getDefault().getPath(System.getProperty("user.home"), 
				"code/private/programing-puzzles/tests/magicTrick/input.txt").toFile();
		File outputFile = FileSystems.getDefault().getPath(System.getProperty("user.home"), 
				"code/private/programing-puzzles/tests/magicTrick/output.txt").toFile();
		run(inputFile, outputFile);
	}
	
	private static void run(File inputFileName, File outputFileName) {
		BufferedReader reader = null;
		BufferedWriter writer = null;
		
		try {
			reader = new BufferedReader(new FileReader(inputFileName));
			writer = new BufferedWriter(new FileWriter(outputFileName));
			
			String line = reader.readLine();
			int numTestCases = Integer.parseInt(line);
			
			for (int i = 1; i <= numTestCases; i++) {
				int ans1 = Integer.parseInt(reader.readLine());
				int[][] arrangement1 = new int[4][4];
				for (int j = 0; j < 4; j++) {
					String[] rowArr = reader.readLine().split(" ");
					arrangement1[j][0] = Integer.parseInt(rowArr[0]);
					arrangement1[j][1] = Integer.parseInt(rowArr[1]);
					arrangement1[j][2] = Integer.parseInt(rowArr[2]);
					arrangement1[j][3] = Integer.parseInt(rowArr[3]);
				}
				
				int[] answerRow1 = arrangement1[ans1 - 1];
				
				int ans2 = Integer.parseInt(reader.readLine());
				int[][] arrangement2 = new int[4][4];
				for (int j = 0; j < 4; j++) {
					String[] rowArr = reader.readLine().split(" ");
					arrangement2[j][0] = Integer.parseInt(rowArr[0]);
					arrangement2[j][1] = Integer.parseInt(rowArr[1]);
					arrangement2[j][2] = Integer.parseInt(rowArr[2]);
					arrangement2[j][3] = Integer.parseInt(rowArr[3]);
				}
				
				int[] answerRow2 = arrangement2[ans2 - 1];
				
				// find intersection
				int matchCount = 0;
				int matchVal = -1;
				
				for (int k = 0; k < 4; k++) {
					int ar1 = answerRow1[k];
					for (int l = 0; l < 4; l++) {
						if (ar1 == answerRow2[l]) {
							matchCount++;
							matchVal = ar1;
						}
					}
				}
				
				String prediction = null;
				
				if (matchCount > 1) {
					prediction = "Bad magician!";
				}
				else if (matchCount == 0) {
					prediction = "Volunteer cheated!";
				}
				else {
					prediction = Integer.toString(matchVal);
				}
				
				String output = new StringBuilder("Case #").append(i).append(": ")
						.append(prediction).append("\n").toString();
				
				System.out.println(output);
				writer.write(output);
				
			}
		}
		catch (FileNotFoundException ex) {
			ex.printStackTrace();
		} 
		catch (IOException e) {
			e.printStackTrace();
		}
		finally {
			try {
				if (reader != null) {
					reader.close();
				}
				if (writer != null) {
					writer.close();
				}
			}
			catch (IOException e) {
				e.printStackTrace();
			}
		}
		
	}

}
