package round1_2013.problemC;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.StringTokenizer;

public class FairAndSquare {

	private static final String INPUT_FILE = "/Users/sbhadour/dev/googlecodejam/test/fairandsquare-input.txt";
	
	private static final String OUTPUT_FILE = "/Users/sbhadour/dev/googlecodejam/test/fairandsquare-output.txt";
	
	
	/**
	 * Reads the input file and returns result. 
	 * 
	 * @return
	 */
	public String getResultsForInputFile() {
		StringBuilder result = new StringBuilder();
		
		try {
			BufferedReader input = new BufferedReader(new FileReader(INPUT_FILE));
			try {
				// first line is the number of test cases
				int numTestCases = Integer.parseInt(input.readLine());
				
				for (int i = 1; i <= numTestCases; i++) {
					result.append("Case #" + i + ": ");
					
					StringTokenizer lineToken = new StringTokenizer(input.readLine(), " ");
					long A = Integer.parseInt(lineToken.nextToken());
					long B = Integer.parseInt(lineToken.nextToken());
					
					result.append(getFairAndSquareCount(A, B));
					result.append(System.getProperty("line.separator"));
				}
				
			}
			catch (NumberFormatException nex) {
				nex.printStackTrace();
			} 
			catch (IOException e) {
				e.printStackTrace();
			}
			finally {
				
			}
		} 
		catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return result.toString();
	}
	
	private int getFairAndSquareCount(long A, long B) {
		int count = 0;
		
		// first check the 1 - 9 digits
		if (A < 10 && B > 10) {
			
			if (A > 4) {
				count += 1;
			}
			else if (A > 1){
				count += 2;
			}
			else {
				count += 3;
			}
			
			// set A to start from 11
			A = 11;
		}
		
		for (long i = A; i <= B; i++) {
			// determine if palindrome
			if (isPalindrome(i)) {
				double sqrt = Math.sqrt(i);
				// if non decimal sqrt test for palindrome of sqrt
				if ((sqrt % 1) == 0 && isPalindrome((int) sqrt)) {
					count++;
				}

			}
		}
		
		return count;
	}
	
	private boolean isPalindrome(long number) {
		boolean palindrome = false;
		long reverse = 0;
		long origNumber = number;
		while (origNumber != 0) {
			reverse = reverse * 10 + origNumber % 10;
			origNumber /= 10; 
		}
		
		if (number == reverse) {
			palindrome = true;
		}
			
		return palindrome;
	}
	
	/**
	 * Writes the results to the output file
	 * 
	 * @param results
	 */
	public void writeResults(String results) {
		try {
			Writer writer = new BufferedWriter(new FileWriter(OUTPUT_FILE));
			try {
				writer.write(results);
			}
			catch (IOException ex) {
				ex.printStackTrace();
			}
			finally {
				writer.close();
			}
		} 
		catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		FairAndSquare probC = new FairAndSquare();
		long startTime = System.currentTimeMillis();
		String results = probC.getResultsForInputFile();
		probC.writeResults(results);
		long endTime = System.currentTimeMillis();
		
		System.out.println("Compute Time: " + (endTime - startTime) + " milliseconds");
	}

}
