package round1_2013.problemA;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;

public class TicTacToeTomek {

	private static final String INPUT_FILE = "/Users/sbhadour/dev/googlecodejam/test/tictactoetomek-input.txt";
	
	private static final String OUTPUT_FILE = "/Users/sbhadour/dev/googlecodejam/test/tictactoetomek-output.txt";
	
	private static final String X_WON = "X won";
	
	private static final String O_WON = "O won";
	
	private static final String DRAW = "Draw";
	
	private static final String INCOMPLETE = "Game has not completed";
	
	
	/**
	 * Reads the input file and returns result. 
	 * 
	 * @return
	 */
	public String getResultsForInputFile() {
		StringBuilder result = new StringBuilder();
		
		try {
			BufferedReader input = new BufferedReader(new FileReader(INPUT_FILE));
			try {
				// first line is the number of test cases
				int numTestCases = Integer.parseInt(input.readLine());
				
				for (int i = 1; i <= numTestCases; i++) {
					result.append("Case #" + i + ": ");
					char[][] board = new char[4][4];
					for (int k = 0; k < 4; k++) {
						input.read(board[k]); 
						// read the last character as new line
						input.read(); 
					}
					input.readLine(); // blank line after first set
					result.append(evaluateBoard(board));
					result.append(System.getProperty("line.separator"));
				}
				
			}
			catch (NumberFormatException nex) {
				nex.printStackTrace();
			} 
			catch (IOException e) {
				e.printStackTrace();
			}
			finally {
				
			}
		} 
		catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		return result.toString();
	}
	
	private String evaluateBoard(char[][] board) {
		String result = INCOMPLETE;
		
		// read diagonals first
		int xCount = 0, oCount = 0, dotCount = 0, tCount = 0;
		for (int i = 0; i < 4; i++) {
			if ('.' == board[i][i]) {
				dotCount++;
				break;
			}
			else if ('X' == board[i][i]) {
				xCount++;
			}
			else if ('O'  == board[i][i]) {
				oCount++;
			}
			else {
				tCount++;
			}
		}
		
		if (dotCount == 0) {
			if (xCount + tCount == 4) {
				return X_WON;
				
			}
			else if (oCount + tCount == 4) {
				return O_WON;
			}
		}
		// dot present incomplete row check other diag
		xCount = 0; oCount = 0; dotCount = 0; tCount = 0; // reset
		for (int i = 0; i < 4; i++) {
			if ('.' == board[i][3-i]) {
				dotCount++;
				break;
			}
			else if ('X' == board[i][3-i]) {
				xCount++;
			}
			else if ('O'  == board[i][3-i]) {
				oCount++;
			}
			else {
				tCount++;
			}
		}
		if (dotCount == 0) {
			if (xCount + tCount == 4) {
				return X_WON;
				
			}
			else if (oCount + tCount == 4) {
				return O_WON;
			}
		}
		
		// row wise
		for (int i = 0; i < 4; i++) {
			xCount = 0; oCount = 0; dotCount = 0; tCount = 0; // reset
			for (int j = 0; j < 4; j++) {
				if ('.' == board[i][j]) {
					dotCount++;
					break;
				}
				else if ('X' == board[i][j]) {
					xCount++;
				}
				else if ('O'  == board[i][j]) {
					oCount++;
				}
				else {
					tCount++;
				}
			}
			if (dotCount == 0) {
				if (xCount + tCount == 4) {
					return X_WON;
					
				}
				else if (oCount + tCount == 4) {
					return O_WON;
				}
			}
		}
		
		// col wise
		boolean dotPresent = false;
		for (int j = 0; j < 4; j++) {
			xCount = 0; oCount = 0; dotCount = 0; tCount = 0; // reset
			for (int i =0; i < 4; i++) {
				if ('.' == board[i][j]) {
					dotCount++;
					dotPresent = true;
					break;
				}
				else if ('X' == board[i][j]) {
					xCount++;
				}
				else if ('O'  == board[i][j]) {
					oCount++;
				}
				else {
					tCount++;
				}
			}
			if (dotCount == 0) {
				if (xCount + tCount == 4) {
					return X_WON;
					
				}
				else if (oCount + tCount == 4) {
					return O_WON;
				}
				else if (j == 3 && !dotPresent){
					return DRAW;
				}
			}
		}
		
		return result;
	}
	/**
	 * Writes the results to the output file
	 * 
	 * @param results
	 */
	public void writeResults(String results) {
		try {
			Writer writer = new BufferedWriter(new FileWriter(OUTPUT_FILE));
			try {
				writer.write(results);
			}
			catch (IOException ex) {
				ex.printStackTrace();
			}
			finally {
				writer.close();
			}
		} 
		catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	public static void main(String[] args) {
		TicTacToeTomek probA = new TicTacToeTomek();
		long startTime = System.currentTimeMillis();
		String results = probA.getResultsForInputFile();
		probA.writeResults(results);
		long endTime = System.currentTimeMillis();
		
		System.out.println("Compute Time: " + (endTime - startTime) + " milliseconds");
	}
}
