/**
 * Rotate.java
 *
 * Either use command line or first argument must be path of input file.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * @author bsanghvi
 */
public class Rotate {

   private static final String NEITHER = "Neither";
   private static final String BOTH = "Both";
   private static final String RED = "Red";
   private static final String BLUE = "Blue";
   private static final char R = 'R';
   private static final char B = 'B';

   /**
    * The main method.
    * 
    * @param args the arguments
    */
   public static void main(final String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         final int T = in.nextInt();

         for (int test = 1; test <= T; test++) {
            final String result = processCase(in);
            System.out.println("Case #" + test + ": " + result);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    * 
    * @param in the in
    * 
    * @return the number of switches made
    */
   private static String processCase(final Scanner in) {
      final int N = in.nextInt();
      final int K = in.nextInt();
      final char data[][] = new char[N][N];
      final char def = data[0][0];
      for (int i = N - 1; i >= 0; i--) {
         final char str[] = in.next().toCharArray();
         final ArrayList<Character> list = new ArrayList<Character>();
         for (final char ch : str) {
            if (ch == R || ch == B) {
               list.add(ch);
            }
         }

         for (int j = N - list.size(), k = 0; j < N; j++, k++) {
            data[j][i] = list.get(k);
         }
      }

//      for (int i = 0; i < N; i++) {
//         for (int j = 0; j < N; j++) {
//            System.out.print(data[i][j]);
//         }
//         System.out.println();
//      }

      int x = -1;
      for (int i = 0; i < N; i++) {
         for (int j = 0; j < N; j++) {
            if (data[i][j] != def) {
               x = i;
               break;
            }
         }

         if (x != -1) {
            break;
         }
      }

      int y = -1;
      if (x != -1) {
         for (int j = N - 1; j >= 0; j--) {
            for (int i = x; i < N; i++) {
               if (data[i][j] != def) {
                  y = j + 1;
                  break;
               }
            }

            if (y != -1) {
               break;
            }
         }
      } else {
         return NEITHER;
      }

      final boolean bWinner = isWinner(data, x, y, N, K, B);
      final boolean rWinner = isWinner(data, x, y, N, K, R);

      if (rWinner && bWinner) {
         return BOTH;
      } else if (rWinner) {
         return RED;
      } else if (bWinner) {
         return BLUE;
      } else {
         return NEITHER;
      }
   }

   /**
    * @param data
    * @param X
    * @param Y
    * @param N
    * @param K
    * @param ch
    * @param n
    * @param k
    * @param r2
    * @return
    */
   private static boolean isWinner(final char[][] data, final int X, final int Y, final int N, final int K,
         final char ch) {
      int cnt = 0;
      for (int i = X; i < N; i++) {
         for (int j = 0; j < Y; j++) {
            if (data[i][j] == ch) {
               cnt = 1;
               for (int m = 1; j + m < Y && m < K; m++) {
                  if (data[i][j + m] != ch) {
                     break;
                  } else {
                     cnt++;
                  }
               }
               if (cnt == K) {
                  return true;
               }

               cnt = 1;
               for (int m = 1; i + m < N && m < K; m++) {
                  if (data[i + m][j] != ch) {
                     break;
                  } else {
                     cnt++;
                  }
               }
               if (cnt == K) {
                  return true;
               }

               cnt = 1;
               for (int m = 1, n = 1; i + m < N && j + n < Y && m < K && n < K; m++, n++) {
                  if (data[i + m][j + n] != ch) {
                     break;
                  } else {
                     cnt++;
                  }
               }
               if (cnt == K) {
                  return true;
               }

               cnt = 1;
               for (int m = 1, n = 1; i + m < N && j - n >= 0 && m < K && n < K; m++, n++) {
                  if (data[i + m][j - n] != ch) {
                     break;
                  } else {
                     cnt++;
                  }
               }
               if (cnt == K) {
                  return true;
               }
            }
         }
      }
      return false;
   }

}
