/**
 * Magicka.java
 *
 * Either use command line or first argument must be path of input file.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;
import java.util.Set;

/**
 * @author bsanghvi
 */
public class Magicka {

   final static Set<Character> BASE;
   static {
      BASE = new HashSet<Character>();
      Collections.addAll(BASE, 'Q', 'W', 'E', 'R', 'A', 'S', 'D', 'F');
   }

   /**
    * The main method.
    * 
    * @param args the arguments
    */
   public static void main(final String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         // read cases
         final int T = in.nextInt();

         for (int x = 1; x <= T; ++x) {
            final List<Character> y = processCase(in);
            System.out.println("Case #" + x + ": " + formatString(y));
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    * 
    * @param in the in
    * 
    * @return the number of switches made
    */
   private static List<Character> processCase(final Scanner in) {
      final int C = in.nextInt();
      final char[][] comb = new char[C][3];
      for (int i = 0; i < C; ++i) {
         comb[i] = in.next().toCharArray();
      }

      final int D = in.nextInt();
      final char[][] opp = new char[D][2];
      for (int i = 0; i < D; ++i) {
         opp[i] = in.next().toCharArray();
      }

      final int N = in.nextInt();
      final StringBuilder data = new StringBuilder(in.next());

      final List<Character> out = new ArrayList<Character>();

      boolean add = true;
      for (int i = 0; i < N; ++i) {
         add = true;
         final char ch = data.charAt(i);
         if (BASE.contains(ch) && out.size() > 0) {
            for (int j = 0; j < C; ++j) {
               final int lIndex = out.size() - 1;
               final char lCh = out.get(lIndex);
               if ((comb[j][0] == ch && lCh == comb[j][1]) || (comb[j][1] == ch && lCh == comb[j][0])) {
                  out.remove(lIndex);
                  out.add(comb[j][2]);
                  add = false;
                  break;
               }
            }

            if (add) {
               for (int j = 0; j < D; ++j) {
                  if ((opp[j][0] == ch && out.contains(opp[j][1])) || (opp[j][1] == ch && out.contains(opp[j][0]))) {
                     out.clear();
                     add = false;
                     break;
                  }
               }
            }
         }

         if (add) {
            out.add(ch);
         }
      }

      return out;
   }

   private static String formatString(final List<Character> list) {
      final StringBuilder builder = new StringBuilder("[");
      final int size = list.size();
      if (size > 0) {
         builder.append(list.get(0));
         for (int i = 1; i < size; ++i) {
            builder.append(", ");
            builder.append(list.get(i));
         }
      }
      builder.append("]");
      return builder.toString();
   }
}
