/**
 * SnapperChain.java
 *
 * Either use command line or first argument must be path of input file.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

/**
 * @author bsanghvi
 */
public class SnapperChain {

   /**
    * The main method.
    * 
    * @param args the arguments
    */
   public static void main(final String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         // read cases
         final int T = in.nextInt();

         for (int x = 1; x <= T; x++) {
            final boolean y = processCase(in);
            System.out.println("Case #" + x + ": " + (y ? "ON" : "OFF"));
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    * 
    * @param in the in
    * 
    * @return the number of switches made
    */
   private static boolean processCase(final Scanner in) {
      final int N = in.nextInt();
      final int K = in.nextInt();

      return ((K + 1) % (long) Math.pow(2, N) == 0);
   }

}
