/**
 * ThemePark.java
 *
 * Either use command line or first argument must be path of input file.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

/**
 * @author bsanghvi
 */
public class ThemePark {

   /**
    * The main method.
    * 
    * @param args the arguments
    */
   public static void main(final String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         final int T = in.nextInt();

         for (int x = 1; x <= T; x++) {
            final long y = processCase(in);
            System.out.println("Case #" + x + ": " + y);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    * 
    * @param in the in
    * 
    * @return the number of switches made
    */
   private static long processCase(final Scanner in) {
      long y = 0;

      final long R = in.nextLong();
      final long k = in.nextLong();
      final long N = in.nextLong();

      final Queue<Long> g = new LinkedList<Long>();
      for (long i = 1; i <= N; i++) {
         g.add(in.nextLong());
      }

      for (int round = 1; round <= R; round++) {
         int people = 0;
         for (int i = 1; i <= N && (people + g.peek()) <= k; i++) {
            final long gi = g.remove();
            people += gi;
            g.add(gi);
         }
         y += people;
      }

      return y;
   }

}
