/**
 * Problem A
 *
 * Either use command line or first argument must be the absolute path of input file.
 */

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author bsanghvi
 */
public class A {

   /**
    * The main method.
    *
    * @param args the arguments
    */
   public static void main(String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         // read cases
         final int T = in.nextInt();
         for (int x = 1; x <= T; x++) {
            int y = processCase(in);
            System.out.println("Case #" + x + ": " + y);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case at a time.
    *
    * @param in the Scanner to read the input
    * @param T the t
    *
    * @return the output
    */
   private static int processCase(final Scanner in) {
      int n = in.nextInt();
      int v1[] = new int[n];
      int v2[] = new int[n];

      for (int i = 0; i < n; i++) {
         v1[i] = in.nextInt();
      }
      Arrays.sort(v1);

      for (int i = 0; i < n; i++) {
         v2[i] = in.nextInt();
      }
      Arrays.sort(v2);

      int y = 0;
      for (int i = 0; i < n; i++) {
         y += (v1[i] * v2[n - i - 1]);
      }

      return y;
   }

}
