/**
 * Problem A
 *
 * Either use command line or first argument must be the absolute path of input file.
 */

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author bsanghvi
 */
public class A {

   /**
    * The main method.
    *
    * @param args the arguments
    */
   public static void main(String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         // read cases
         final int N = in.nextInt();
         for (int x = 1; x <= N; x++) {
            int y = processCase(in);
            System.out.println("Case #" + x + ": " + y);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case at a time.
    *
    * @param in the Scanner to read the input
    * @param T the t
    *
    * @return the output
    */
   private static int processCase(final Scanner in) {
      int n = in.nextInt();
      long A = in.nextLong();
      long B = in.nextLong();
      long C = in.nextLong();
      long D = in.nextLong();
      long x0 = in.nextLong();
      long y0 = in.nextLong();
      long M = in.nextLong();

      long[] X = new long[n];
      long[] Y = new long[n];
      X[0] = x0;
      Y[0] = y0;

      for (int i = 1; i < n; i++) {
         X[i] = (A * X[i - 1] + B) % M;
         Y[i] = (C * Y[i - 1] + D) % M;
      }

      int output = 0;
      for (int i = 0; i < n; i++) {
         for (int j = i + 1; j < n; j++) {
            for (int k = j + 1; k < n; k++) {
               if ((0 == (X[i] + X[j] + X[k]) % 3) && (0 == (Y[i] + Y[j] + Y[k]) % 3)) {
                  output++;
               }
            }
         }
      }

      return output;
   }

}
