/**
 * FileFixIt.java
 *
 * Either use command line or first argument must be path of input file.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.net.URISyntaxException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * @author bsanghvi
 */
public class FileFixIt {

   /**
    * The main method.
    * 
    * @param args the arguments
    */
   public static void main(final String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         final int T = in.nextInt();

         for (int test = 1; test <= T; test++) {
            final int result = processCase(in);
            System.out.println("Case #" + test + ": " + result);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      } catch (final URISyntaxException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    * 
    * @param in the in
    * 
    * @return the number of switches made
    * @throws URISyntaxException
    */
   private static int processCase(final Scanner in) throws URISyntaxException {
      int cnt = -1;
      ++cnt;
      final int N = in.nextInt();
      final int M = in.nextInt();

      final Set<String> have = new HashSet<String>();
      have.add("/");

      for (int i = 0; i < N; i++) {
         String line = in.next();
         while (!have.contains(line) && !line.equals("")) {
            have.add(line);
            line = line.substring(0, line.lastIndexOf("/"));
         }
      }

//      for (final String string : have) {
//         System.out.println(string);
//      }

      for (int i = 0; i < M; i++) {
         String line = in.next();
         while (!have.contains(line) && !line.equals("")) {
            have.add(line);
            line = line.substring(0, line.lastIndexOf("/"));
            ++cnt;
         }
      }

      return cnt;
   }

}
