/**
 * SpeakingInTongues.java
 *
 * Either use command line or first argument must be path of input file.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

/**
 * @author bsanghvi
 */
public class SpeakingInTongues {

   private static Map<Character, Character> CODE_TO_ACTUAL;

   static {
      final Map<Character, Character> temp = new HashMap<Character, Character>(26);
      temp.put(' ', ' ');
      temp.put('a', 'y');
      temp.put('b', 'h');
      temp.put('c', 'e');
      temp.put('d', 's');
      temp.put('e', 'o');
      temp.put('f', 'c');
      temp.put('g', 'v');
      temp.put('h', 'x');
      temp.put('i', 'd');
      temp.put('j', 'u');
      temp.put('k', 'i');
      temp.put('l', 'g');
      temp.put('m', 'l');
      temp.put('n', 'b');
      temp.put('o', 'k');
      temp.put('p', 'r');
      temp.put('q', 'z');
      temp.put('r', 't');
      temp.put('s', 'n');
      temp.put('t', 'w');
      temp.put('u', 'j');
      temp.put('v', 'p');
      temp.put('w', 'f');
      temp.put('x', 'm');
      temp.put('y', 'a');
      temp.put('z', 'q');
      CODE_TO_ACTUAL = Collections.unmodifiableMap(temp);
   }

   /**
    * The main method.
    * 
    * @param args the arguments
    */
   public static void main(final String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         final int T = in.nextInt();
         in.nextLine();

         for (int test = 1; test <= T; test++) {
            final String result = processCase(in);
            System.out.println("Case #" + test + ": " + result);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    * 
    * @param in the in
    * 
    * @return the decoded string
    */
   private static String processCase(final Scanner in) {
      final char[] arrayG = in.nextLine().toCharArray();
      final StringBuilder result = new StringBuilder(arrayG.length);
      for (final char c : arrayG) {
         result.append(CODE_TO_ACTUAL.get(c));
      }
      return result.toString();
   }
}
