/**
 * AlienLanguage.java
 *
 * Either use command line or first argument must be path of input file.
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.Scanner;

/**
 * @author bsanghvi
 */
public class AlienLanguage {

   private static int L;
   private static int D;
   private static char[][] words;

   /**
    * The main method.
    * 
    * @param args the arguments
    */
   public static void main(final String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         L = in.nextInt();
         D = in.nextInt();
         final int N = in.nextInt();

         words = new char[D][L];
         for (int i = 0; i < D; i++) {
            words[i] = in.next().toCharArray();
         }

         for (int test = 1; test <= N; test++) {
            final int result = processCase(in);
            System.out.println("Case #" + test + ": " + result);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    * 
    * @param in the in
    * 
    * @return the number of switches made
    */
   private static int processCase(final Scanner in) {
      int result = 0;

      final List<HashSet<Character>> listOfCharSet = new ArrayList<HashSet<Character>>();
      final char[] testCase = in.next().toCharArray();
      for (int i = 0; i < testCase.length; ++i) {
         final HashSet<Character> setOfChar = new HashSet<Character>();
         if (testCase[i] == '(') {
            ++i;
            while (testCase[i] != ')') {
               setOfChar.add(testCase[i]);
               ++i;
            }
         } else {
            setOfChar.add(testCase[i]);
         }
         listOfCharSet.add(setOfChar);
      }

      int j;
      for (int i = 0; i < D; ++i) {
         for (j = 0; j < L; ++j) {
            if (!listOfCharSet.get(j).contains(words[i][j])) {
               break;
            }
         }
         if (j == L) {
            result++;
         }
      }

      return result;
   }
}
