/**
 * SavingTheUniverse.java
 *
 * The file SavingTheUniverse.java.
 *
 * $Id$
 */
import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;


/**
 * @author bsanghvi
 */
public class SavingTheUniverse {

   /**
    * The main method.
    *
    * @param args the arguments
    */
   public static void main(String[] args) {
      try {
         final Scanner in;
         if (args.length >= 1) {
            in = new Scanner(new File(args[0]));
         } else {
            in = new Scanner(System.in);
         }

         // read cases
         final int N = in.nextInt();
         for (int x = 1; x <= N; x++) {
            int y = processCase(in);
            System.out.println("Case #" + x + ": " + y);
         }
      } catch (final FileNotFoundException e) {
         e.printStackTrace();
      }
   }

   /**
    * Processes a case.
    *
    * @param in the in
    *
    * @return the number of switches made
    */
   private static int processCase(final Scanner in) {
      // read search engines
      final int S = in.nextInt();
      final String[] searchEngineArray = new String[S];
      in.nextLine();
      for (int i = 0; i < S; i++) {
         searchEngineArray[i] = in.nextLine();
      }

      // read queries
      final int Q = in.nextInt();
      final ArrayList<String> queries = new ArrayList<String>(Q);
      in.nextLine();
      for (int i = 0; i < Q; i++) {
         queries.add(in.nextLine());
      }

      int totalSwitch = 0;

      while (!queries.isEmpty()) {
         int switchPos = -1;
         for (int i = 0; i < S; i++) {
            int indexOf = queries.indexOf(searchEngineArray[i]);
            if (indexOf == -1) {
               return totalSwitch;
            }
            if (indexOf > switchPos) {
               switchPos = indexOf;
            }
         }

         // need to make a switch
         totalSwitch++;

         // remove the processed queries
         for (int i = 0; i < switchPos; i++) {
            queries.remove(0);
         }
      }

      return totalSwitch;
   }

}
