import java.util.List;
import java.util.Map;
import java.util.TreeMap;


public class Main {
	
	private static final String INPUT_FILE_NAME = "B-small-attempt3.in";
	private static final String OUTPUT_FILE_NAME = "B-small-attempt3.out";
	
	private static final String[] LETTERS = new String[]{"a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z"};
	private static int lastLetter = -1;
	
	public static void main(String[] args) {
		Map<Integer, String> casesResult = new TreeMap<Integer, String>();
		
		List<String> lines = FileParser.readFile(INPUT_FILE_NAME);
		
		int numMaps = Integer.valueOf(lines.get(0));
		
		int posBeginCase = 1;
		for(int caseNum = 1; caseNum <= numMaps; caseNum++) {
			lastLetter = -1;
			String[] size =  lines.get(posBeginCase).split(" ");
			int height = Integer.valueOf(size[0]);
			int width = Integer.valueOf(size[1]);
			
			//Load the map
			int map[][] = new int[height][width];
			String resultMap[][] = new String[height][width];
			for(int posHeight = 1; posHeight <= height; posHeight++) {
				String[] altitudes = lines.get(posBeginCase + posHeight).split(" ");
				int posWidth = 0;
				for(String altitude : altitudes) {
					map[posHeight - 1][posWidth] = Integer.valueOf(altitude);
					resultMap[posHeight - 1][posWidth] = null;
					posWidth++;
				}
				
			}
			
			for(int posHeight = 0; posHeight < height; posHeight++) {
				for(int posWidth = 0; posWidth < width; posWidth++) {
					int altitude = map[posHeight][posWidth];
					int northAltitude = getNorthAltitude(map, posHeight, posWidth, height, width);
					int westAltitude = getWestAltitude(map, posHeight, posWidth, height, width);
					int eastAltitude = getEastAltitude(map, posHeight, posWidth, height, width);
					int southAltitude = getSouthAltitude(map, posHeight, posWidth, height, width);		
					
					//If is not a sink
					if(altitude > northAltitude || altitude > westAltitude || altitude > eastAltitude || altitude > southAltitude) {
						int lowerAltitude = northAltitude;
						if(westAltitude < lowerAltitude) {
							lowerAltitude = westAltitude; 
						}
						if(eastAltitude < lowerAltitude) {
							lowerAltitude = eastAltitude; 
						}
						if(southAltitude < lowerAltitude) {
							lowerAltitude = southAltitude; 
						}
						
						if(northAltitude == lowerAltitude) {
							if(resultMap[posHeight - 1][posWidth] != null) {
								if(resultMap[posHeight][posWidth] == null) {
									resultMap[posHeight][posWidth] = resultMap[posHeight - 1][posWidth];
								}
							} else {
								String letter = resultMap[posHeight][posWidth];
								if(letter == null) {
									letter = getNextLetter();
									resultMap[posHeight][posWidth] = letter;
								}
								resultMap[posHeight - 1][posWidth] = letter;
							}
						} else if(westAltitude == lowerAltitude) {
							if(resultMap[posHeight][posWidth - 1] != null) {
								if(resultMap[posHeight][posWidth] == null) {
									resultMap[posHeight][posWidth] = resultMap[posHeight][posWidth - 1];
								}
							} else {
								String letter = resultMap[posHeight][posWidth];
								if(letter == null) {
									letter = getNextLetter();
									resultMap[posHeight][posWidth] = letter;
								}
								resultMap[posHeight][posWidth - 1] = letter;
							}
						} else if(eastAltitude == lowerAltitude) {
							if(resultMap[posHeight][posWidth + 1] != null) {
								if(resultMap[posHeight][posWidth] == null) {
									resultMap[posHeight][posWidth] = resultMap[posHeight][posWidth + 1];
								}
							} else {
								String letter = resultMap[posHeight][posWidth];
								if(letter == null) {
									letter = getNextLetter();
									resultMap[posHeight][posWidth] = letter;
								}
								resultMap[posHeight][posWidth + 1] = letter;
							}
						} else if(southAltitude == lowerAltitude) {
							if(resultMap[posHeight + 1][posWidth] != null) {
								if(resultMap[posHeight][posWidth] == null) {
									resultMap[posHeight][posWidth] = resultMap[posHeight + 1][posWidth];
								}
							} else {
								String letter = resultMap[posHeight][posWidth];
								if(letter == null) {
									letter = getNextLetter();
									resultMap[posHeight][posWidth] = letter;
								}
								resultMap[posHeight + 1][posWidth] = letter;
							}
						}
					} else { //Is a sink
						String letter = resultMap[posHeight][posWidth];
						if(letter == null) {
							letter = getNextLetter();
							resultMap[posHeight][posWidth] = letter;
						}
					}

				}
			}
			
			
			posBeginCase += height + 1;
			casesResult.put(caseNum, mapToString(resultMap, height, width));
		}
		
		FileParser.writeFile(OUTPUT_FILE_NAME, casesResult);
	}
	
	private static int getNorthAltitude(int[][] map, int posHeight, int posWidth, int maxHeight, int maxWidth) {
		
		if(posHeight == 0) {
			return 100001;
		} else {
			return map[posHeight - 1][posWidth];
		}
	}
	
	private static int getWestAltitude(int[][] map, int posHeight, int posWidth, int maxHeight, int maxWidth) {
		
		if(posWidth == 0) {
			return 100001;
		} else {
			return map[posHeight][posWidth - 1];
		}
	}
	
	private static int getEastAltitude(int[][] map, int posHeight, int posWidth, int maxHeight, int maxWidth) {
		
		if(posWidth == (maxWidth - 1)) {
			return 100001;
		} else {
			return map[posHeight][posWidth + 1];
		}
	}
	
	private static int getSouthAltitude(int[][] map, int posHeight, int posWidth, int maxHeight, int maxWidth) {
		
		if(posHeight == (maxHeight - 1)) {
			return 100001;
		} else {
			return map[posHeight + 1][posWidth];
		}
	}

	private static String getNextLetter() {
		lastLetter++;
		return LETTERS[lastLetter];
	}
	
	private static String mapToString(String[][] map, int maxHeight, int maxWidth) {
		String result = "";
		for(int posHeight = 0; posHeight < maxHeight; posHeight++) {
			for(int posWidth = 0; posWidth < maxWidth; posWidth++) {
				result += map[posHeight][posWidth] + " ";
			}
			result = result.substring(0, result.length() - 1) + "\n";
		}
		return result;
	}

}
