package bsevero.codejam.qualification;

import java.util.HashMap;
import java.util.Map;

public class SpeakingTongues {

	private static Map<String, String> MAPPING;
	
	private static String ORIGINAL_TEXT = "ejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jv y qee z";
	private static String MAPPING_TEXT = "our language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give up a zoo q";
	
	public SpeakingTongues() {
		loadMapping();
	}
	
	private void loadMapping() {
		MAPPING = new HashMap<String, String>();
		
		MAPPING.put("a", "y");
		MAPPING.put("b", "h");
		MAPPING.put("c", "e");
		MAPPING.put("d", "s");
		MAPPING.put("e", "o");
		MAPPING.put("f", "c");
		MAPPING.put("g", "v");
		MAPPING.put("h", "x");
		MAPPING.put("i", "d");
		MAPPING.put("j", "u");
		MAPPING.put("k", "i");
		MAPPING.put("l", "g");
		MAPPING.put("m", "l");
		MAPPING.put("n", "b");
		MAPPING.put("o", "k");
		MAPPING.put("p", "r");
		MAPPING.put("q", "z");
		MAPPING.put("r", "t");
		MAPPING.put("s", "n");
		MAPPING.put("t", "w");
		MAPPING.put("u", "j");
		MAPPING.put("v", "p");
		MAPPING.put("w", "f");
		MAPPING.put("x", "m");
		MAPPING.put("y", "a");
		MAPPING.put("z", "q");
		MAPPING.put(" ", " ");
	}
	
	public String translate(String text) {
		String result = "";
		
		for(char c: text.toCharArray()) {
			int pos = ORIGINAL_TEXT.indexOf(c);
			result += String.valueOf(MAPPING_TEXT.charAt(pos));
		}
		
		return result;
	}
}
