import java.text.DecimalFormat;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;


public class Main {
	
	private static final String INPUT_FILE_NAME = "C-small-attempt0.in";
	private static final String OUTPUT_FILE_NAME = "C-small-attempt0.out";
	
	private static final DecimalFormat FORMATTER = new DecimalFormat("0000");
	private static final char[] words = new char[]{'w', 'e', 'l', 'c', 'o', 'm', 'e', ' ', 't', 'o', ' ', 'c', 'o', 'd', 'e', ' ', 'j', 'a', 'm'};
	
	public static void main(String[] args) {
		Map<Integer, String> casesResult = new TreeMap<Integer, String>();
		
		List<String> lines = FileParser.readFile(INPUT_FILE_NAME);
		int numTestCases = Integer.valueOf(lines.get(0));
		
		int posBeginCase = 1;
		for(int caseNum = 1; caseNum <= numTestCases; caseNum++) {
			String testCase =  lines.get(posBeginCase);
			
			int count = 0;
			
			int posW = testCase.indexOf("w");
			if(posW != -1) {
				char[] testCaseSubString = testCase.substring(posW, testCase.length()).toCharArray();
				
				count = getMatchs(testCaseSubString, 0, 0);
			}
			
			posBeginCase++;
			casesResult.put(caseNum, formatResult(count));
		}
		
		
		FileParser.writeFile(OUTPUT_FILE_NAME, casesResult);
	}
	
	private static int getMatchs(char[] testCase, int beginIndex, int wordsPos) {
		char wantedChar = words[wordsPos];
		int count = 0;
		for(int i = beginIndex; i < testCase.length; i++) {
			char letter = testCase[i];
			
			if(wantedChar == letter) {
				if(wordsPos == (words.length - 1)) {
					count++;
				} else {
					count += getMatchs(testCase, i, wordsPos + 1);
				}
			}
		}
		
		return count;
	}
	
	private static String formatResult(int count) {
		if(count > 9999) {
			String countStr = String.valueOf(count);
			return countStr.substring(countStr.length() - 4, countStr.length());
		} else {
			return FORMATTER.format(count);
		}
	}
	
}
