import java.util.List;
import java.util.Map;
import java.util.TreeMap;


public class Mousetrap {
	
	private static final String INPUT_FILE_NAME = "C-small-attempt0.in";
	private static final String OUTPUT_FILE_NAME = "C-small-attempt0.out";
	
	public static void main(String[] args) {
		
		Map<Integer, String> casesResult = new TreeMap<Integer, String>();
		
		List<String> lines = FileParser.readFile(INPUT_FILE_NAME);
		
		int numTestCases = Integer.parseInt(lines.get(0));
		
		int posBeginCase = 1;
		for(int caseNum = 1; caseNum <= numTestCases; caseNum++) {
			int numberCards = Integer.parseInt(lines.get(posBeginCase));

			int[] perfectDeck = makePerfectDeck(numberCards);
			
			String[] nAndindices = lines.get(posBeginCase + 1).split(" ");
			
			String result = "";
			for(int j = 1; j < nAndindices.length; j++) {
				int index = Integer.parseInt(nAndindices[j]);
				result += perfectDeck[index - 1] + " ";
			}
			result = result.substring(0, result.length() - 1);
			casesResult.put(caseNum, result);
			
			posBeginCase += 2;
		}
		
		
		FileParser.writeFile(OUTPUT_FILE_NAME, casesResult);
	}

	private static int[] makePerfectDeck(int numberCards) {
		int[] perfectDeck = new int[numberCards];
		
		int position = 0;
		for(int card = 1; card < numberCards + 1; card++) {
			position = findNextEmpty(perfectDeck, position, card);
			perfectDeck[position] = card;
		}

		return perfectDeck;
	}
	
	
	private static int findNextEmpty(int[] perfectDeck, int position, int card) {
		
		int emptys = 0;
		int i = position;
		if(card == 1) {
			i = perfectDeck.length - 1;
		}
		while(emptys != card) {
			if(i == (perfectDeck.length - 1)) {
				i = 0;
			} else {
				i++;
			}
			
			if(perfectDeck[i] == 0) {
				emptys++;
			}
		}
		
		return i;
	}
	
}
