import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;


public class Main {
	
	private static final String INPUT_FILE_NAME = "A-small-attempt0.in";
	private static final String OUTPUT_FILE_NAME = "A-small-attempt0.out";
	
	private static int wordsLength;
	private static List<String> words;
	
	public static void main(String[] args) {
		Map<Integer, String> casesResult = new TreeMap<Integer, String>();
		
		List<String> lines = FileParser.readFile(INPUT_FILE_NAME);
		
		String[] properties = lines.get(0).split(" ");
		int numWords = Integer.valueOf(properties[1]);
		wordsLength = Integer.valueOf(properties[0]);
		int numTestCases = Integer.valueOf(properties[2]);
		
		words = new ArrayList<String>(lines.subList(1, numWords + 1));
		
		int posBeginCase = 1 + numWords;
		for(int caseNum = 1; caseNum <= numTestCases; caseNum++) {
			String testCase =  lines.get(posBeginCase);
			
			int matchNum = getMatchs(testCase, "", 0);
			
			posBeginCase++;
			casesResult.put(caseNum, String.valueOf(matchNum));
		}
		
		
		FileParser.writeFile(OUTPUT_FILE_NAME, casesResult);
	}
	
		
		
	private static int getMatchs(String testCase, String testWord, int beginIndex) {
		String testCaseSubString = testCase.substring(beginIndex);
		int count = 0;
		for(char letter : getPossibleLetters(testCaseSubString)) {
			String newWord = testWord.concat(String.valueOf(letter));
			
			if(newWord.length() == wordsLength) {
				if(words.contains(newWord)) {
					count++;
				}
			} else {
				if(containCasesStartWith(newWord)) {
					count += getMatchs(testCaseSubString, newWord, getEndPosition(testCaseSubString));
				} 
			}
			
			
		}
		
		return count;
	}
	
	private static boolean containCasesStartWith(String testWord) {
		for(String word : words) {
			if(word.startsWith(testWord)) {
				return true;
			}
		}
		return false;
	}
	
	private static int getEndPosition(String testCase) {
		if(testCase.startsWith("(")) {
			return testCase.indexOf(")") + 1;
		} else {
			return 1;
		}
	}
	
	private static char[] getPossibleLetters(String testCase) {
		if(testCase.startsWith("(")) {
			return testCase.substring(1, testCase.indexOf(")")).toCharArray();
		} else {
			char[] firstOnly = new char[1];
			firstOnly[0] = testCase.charAt(0);
			return firstOnly;
		}
	}
	
}
