package codejam2015;

import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.Writer;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;
import java.util.stream.Stream;

public class PancakesMain {
	
	private static HashMap<String, Integer> minSteps = new HashMap<>();

	public static void main(String[] args) throws IOException {
		try (Stream<String> inputFile = Files.lines(Paths.get("/Users/bbaker/Downloads/B-small-attempt0.in"));
				Writer writer = new BufferedWriter(new OutputStreamWriter(
						new FileOutputStream("/Users/bbaker/Desktop/pancake-out"), "utf-8"))) {

			List<String> lines = inputFile.collect(Collectors.toList());
			
			// Start at 1 to skip number of test cases line
			long time = System.nanoTime();
			int caseNumber = 1;
			for (int i = 1; i < lines.size(); i += 2) {				
				String[] pancakes = lines.get(i + 1).split(" ");
				ArrayList<Integer> pans = new ArrayList<>(pancakes.length);
				for (int j = 0; j < pancakes.length; ++j) {
					pans.add(Integer.parseInt("" + pancakes[j]));
				}

				writer.write("Case #" + caseNumber++ + ": " + countStepsAll(pans) + "\n");
			}
			System.out.println("done in " + TimeUnit.NANOSECONDS.toMillis(System.nanoTime() - time));
		}
	}
	
	private static int countStepsAll(ArrayList<Integer> pancakes) {
		if (pancakes.isEmpty()) {
			return 0;
		}
		
		Collections.sort(pancakes, Comparator.reverseOrder());

		String panAsString = "";
		for (Integer pancake : pancakes) {
			panAsString += pancake.toString();
		}
		
		if (minSteps.containsKey(panAsString)) {
			return minSteps.get(panAsString);
		}
		
		int max = pancakes.get(0);
		if (max <= 2) {
			return max;
		}		
		
		ArrayList<Integer> pathNormal = new ArrayList<>(pancakes);
		for (int i = pathNormal.size() - 1; i >= 0; --i) {
			int current = pathNormal.get(i);
			if (current <= 1) {
				pathNormal.remove(i);
			} else {
				pathNormal.set(i, current - 1);
			}
		}

		ArrayList<Integer> pathSpecial = new ArrayList<>(pancakes);
		int half = (int) Math.ceil(max / 2.0);
		pathSpecial.set(0, half);
		pathSpecial.add(max - half);
		
		int answer = 1 + Math.min(countStepsAll(pathNormal), countStepsAll(pathSpecial));
		
		minSteps.put(panAsString, answer);
		
		return answer;
	}
}
