import java.io.*;
import java.util.*;

public class BotTrust {
	static final int _O = 0;
	static final int _B = 1;

	int[] getFin(int[][] inp, int curPos, int preIdx, int rem, int rob) {
		int[] ret = new int[]{-1,0};
		int time = 0;
		int i = preIdx+1;
		for(;i<inp.length && inp[i][0] != rob;i++)
			;
		for(;i<inp.length && inp[i][0] == rob;i++) {
			int diff = Math.abs(curPos-inp[i][1]);
			if(rem>0) {
				if(rem>diff)
					diff = 0;
				else
					diff = diff - rem;
				rem = 0;
			}
			time+=diff+1;
			curPos = inp[i][1];
			preIdx = i;
		}
		ret[0] = preIdx;
		ret[1] = time;
		return ret;
	}
	int getWt(int[][] inp, int preIdx, int rob) {
		int time = 0;
		for(int i=preIdx+1;i<inp.length;i++) {
			if(inp[i][0]==rob) {
				return i;
			}
		}
		return -1;
	}
	private void computeCase(int N, int[][] inp) {
		System.out.print("Case #"+N+":");
		int res=0;
		int oPos = 1, bPos = 1;
		int oIdx = -1, bIdx = -1;
		int oNxt = getWt(inp, oIdx, _O);
		int bNxt = getWt(inp, bIdx, _B);
		int oRem = 0, bRem = 0;
		int i=0;
		boolean flag = true;
		while(flag) {
			//System.out.println(oNxt+":"+bNxt+" - "+oIdx+":"+bIdx);
			if(oNxt <0) {
				int[] ret = getFin(inp, bPos, bIdx, bRem, _B);
				res += ret[1];
				flag = false;
			} else if (bNxt<0){
				int[] ret = getFin(inp, oPos, oIdx, oRem, _O);
				res += ret[1];
				flag = false;
			} else if(oNxt<bNxt) {
				int[] ret = getFin(inp, oPos, oIdx, oRem, _O);
				res += ret[1];
				bRem = ret[1];
				oIdx = ret[0];
				oPos = inp[oIdx][1];
				oNxt = getWt(inp, oIdx, _O);
			} else {
				int[] ret = getFin(inp, bPos, bIdx, bRem, _B);
				res += ret[1];
				oRem = ret[1];
				bIdx = ret[0];
				bPos = inp[bIdx][1];
				bNxt = getWt(inp, bIdx, _B);
			}
		}
		System.out.println(" " + res);
	}

	public void compute(String inputFile) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(inputFile));
			int T = Integer.parseInt(in.readLine());
			for(int i=0;i<T;i++) {
				String str = in.readLine();
				String[] r = str.split("\\s");
				int N = Integer.parseInt(r[0]);
				int[][] inp = new int[N][2];
				for(int j=1,k=0;j<r.length;k++,j+=2) {
					if(r[j].charAt(0)=='O')
						inp[k][0] = _O;
					else
						inp[k][0] = _B;
					inp[k][1] = Integer.parseInt(r[j+1]);
				}
				computeCase(i+1, inp);
			}
		}catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		String inputFile = "input.txt";
		if(args.length>0)
			inputFile = args[0];
		new BotTrust().compute(inputFile);
	}
}