import java.io.*;
import java.util.*;

public class GoroSort {
	private void computeCase(int N, int[] inp) {
		System.out.print("Case #"+N+":");
		int len = inp.length;
		boolean[] set = new boolean[len];
		Arrays.fill(set,false);
		int res = 0;
		for(int i=0;i<len;i++) {
			if(!set[i]) {
				int cnt = 0;
				if(inp[i] != (i+1)) {
					int k = i;
					while(!set[k]) {
						cnt++;
						set[k] = true;
						k = inp[k]-1;
					}
					res += cnt;
				} else {
					set[i] = true;
				}
			}
		}
		System.out.println(" " + String.format("%.6f", (double)res));
	}

	public void compute(String inputFile) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(inputFile));
			int T = Integer.parseInt(in.readLine());
			for(int i=0;i<T;i++) {
				int N = Integer.parseInt(in.readLine());
				String str = in.readLine();
				String[] r = str.split("\\s");
				int[] inp = new int[N];
				for(int j=0;j<N;j++) {
					inp[j] = Integer.parseInt(r[j]);
				}
				computeCase(i+1, inp);
			}
		}catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		String inputFile = "input.txt";
		if(args.length>0)
			inputFile = args[0];
		new GoroSort().compute(inputFile);
	}
}