import java.io.*;
import java.util.*;

public class CandySplitting {
	private void computeCase(int N, int[] inp) {
		System.out.print("Case #"+N+":");
		int sum = inp[0];
		int sumX = inp[0];
		int max = -1;
		int len = inp.length;
		for(int i=1;i<len;i++) {
			sum += inp[i];
			sumX ^= inp[i];
		}
		//System.out.print(sumX);
		int mLen = (1<<len)-1;
		for(int i=1;i<mLen;i++) {
			int tSum = 0;
			int tSumX = -1;
			for(int j=0;j<len;j++) {
				if( (i&(1<<j))>0) {
					tSum += inp[j];
					if(tSumX<0) {
						tSumX = inp[j];
					} else {
						tSumX ^= inp[j];
					}
				}
			}
			if(tSumX == (sumX^tSumX)) {
				if((sum-tSum)>tSum) {
					tSum = sum - tSum;
				}
				if(tSum > max) {
					max = tSum;
				}
			}
		}
		if(max>0)
			System.out.println(" " + max);
		else
			System.out.println(" NO");
	}

	public void compute(String inputFile) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(inputFile));
			int T = Integer.parseInt(in.readLine());
			for(int i=0;i<T;i++) {
				int N = Integer.parseInt(in.readLine());
				String str = in.readLine();
				String[] r = str.split("\\s");
				int[] inp = new int[N];
				for(int j=0;j<N;j++) {
					inp[j] = Integer.parseInt(r[j]);
				}
				computeCase(i+1, inp);
			}
		}catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		String inputFile = "input.txt";
		if(args.length>0)
			inputFile = args[0];
		new CandySplitting().compute(inputFile);
	}
}