import java.io.*;
import java.util.*;

public class A {
	private static final String POSS = "Possible";
	private static final String BROK = "Broken";
	private void computeCase(int T, int N, String[] inp) {
		System.out.println("Case #"+T+":");
		double[] WP = new double[N];
		double[][] OWP = new double[N][N];
		double[] AOWP = new double[N];
		double[] OOWP = new double[N];
		for(int i=0;i<N;i++) {
			int t=0,w=0;
			for(int j=0;j<N;j++) {
				if(i!=j) {
					char ch = inp[i].charAt(j);
					if(ch!='.') {
						t++;
						if(ch=='1') w++;
					}
				}
			}
			WP[i] = 1.0*w/t;
			for(int j=0;j<N;j++) {
				if(i!=j) {
					char ch = inp[i].charAt(j);
					if(ch!='.') {
						int nw = w;
						if(ch=='1') nw--;
						OWP[j][i] = 1.0*nw/(t-1);
					}
				}
			}
		}
		for(int i=0;i<N;i++) {
			int cnt = 0;
			double tot = 0;
			for(int j=0;j<N;j++) {
				if(i!=j) {
					char ch = inp[i].charAt(j);
					if(ch!='.') {
						tot += OWP[i][j];
						cnt++;
					}
				}
			}
			AOWP[i] = tot/cnt;
		}
		for(int i=0;i<N;i++) {
			int cnt = 0;
			double tot = 0;
			for(int j=0;j<N;j++) {
				if(i!=j) {
					char ch = inp[i].charAt(j);
					if(ch!='.') {
						tot += AOWP[j];
						cnt++;
					}
				}
			}
			OOWP[i] = tot/cnt;
		}
		for(int i=0;i<N;i++) {
			double res = 0.25*WP[i]+0.5*AOWP[i]+0.25*OOWP[i];
			System.out.println(res);
		}
	}

	public void compute(String inputFile) {
		try {
			BufferedReader in = new BufferedReader(new FileReader(inputFile));
			int T = Integer.parseInt(in.readLine());
			for(int i=0;i<T;i++) {
				int N = Integer.parseInt(in.readLine());
				String[] inp = new String[N];
				for(int j=0;j<N;j++) {
					inp[j] = in.readLine();
				}
				computeCase(i+1, N, inp);
			}
		}catch(Exception e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) {
		String inputFile = "input.txt";
		if(args.length>0)
			inputFile = args[0];
		new A().compute(inputFile);
	}
}