import java.util.HashMap;
import java.util.Map;

/**
 * Created by stan on 11/04/15.
 */
public class ShynessManager {
    private final Map<Integer, Integer> personCountByShyness;

    public ShynessManager(final String shynessString) {
        this.personCountByShyness = new HashMap<Integer, Integer>();
        int shynessLevel = 0;
        for (final char c : shynessString.toCharArray()) {
            personCountByShyness.put(shynessLevel, Character.getNumericValue(c));
            shynessLevel ++;
        }
    }

    public int getPersonCountByShyness(final int shynessLevel) {
        if (shynessLevel > personCountByShyness.size() - 1) {
            throw new IndexOutOfBoundsException("You asked for a too high shyness level");
        }
        return personCountByShyness.get(shynessLevel);
    }
}
