import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by stan on 11/04/15.
 */
public class Solver {
    private static final String inputFilename = "/Users/stan/Documents/Info/Projets/Google Code Jam/Standing Ovation/A-large.in";
    private static final String outputFilename = "/Users/stan/Documents/Info/Projets/Google Code Jam/Standing Ovation/A-large.out";

    public static void main(final String[] args) {
        final List<Case> cases = createCases();
        try (final BufferedWriter bufferedWriter = new BufferedWriter(new FileWriter(outputFilename))) {
            for (final Case aCase : cases) {
                bufferedWriter.write(aCase.getResult());
                if (aCase.getCaseNumber() < cases.size()) {
                    bufferedWriter.newLine();
                }
            }
        } catch (final Exception e) {
            throw new RuntimeException(e);
        }
    }

    private static List<Case> createCases() {
        final List<Case> cases = new ArrayList<>();
        try (final BufferedReader bufferedReader = new BufferedReader(new FileReader(inputFilename))) {
            final int casesCount = Integer.parseInt(bufferedReader.readLine());
            int caseIndex = 1;
            String line;
            while ((line = bufferedReader.readLine()) != null) {
                final Case newCase = new Case(line, caseIndex);
                caseIndex++;
                cases.add(newCase);
            }
        } catch (final Exception e) {
            throw new RuntimeException(e);
        }
        return cases;
    }
}
