/**
 * Created by stan on 11/04/15.
 */
public class Case {
    private final Audience audience;
    private final ShynessManager shynessManager;
    private final int maxShyness;
    private final int caseNumber;

    public Case(final String caseLine, final int caseNumber) {
        this.audience = new Audience();
        final String[] tokens = caseLine.split(" ");
        final String maxShyness = tokens[0];
        this.maxShyness = Integer.parseInt(maxShyness);
        final String shynessToken = tokens[1];
        this.shynessManager = new ShynessManager(shynessToken);
        this.caseNumber = caseNumber;
    }

    public String getResult() {
        final int necessaryFriendsCount = getNecessaryFriendsCount();
        return "Case #" + caseNumber + ": " + necessaryFriendsCount;
    }

    public int getCaseNumber() {
        return caseNumber;
    }

    private int getNecessaryFriendsCount() {
        int totalAddedFriends = 0;
        for (int shynessLevel = 0; shynessLevel <= maxShyness; shynessLevel++) {
            int addedFriends = 0;
            final int shyPersons = shynessManager.getPersonCountByShyness(shynessLevel);
            if (audience.getStoodPersons() < shynessLevel) {
                addedFriends = shynessLevel - audience.getStoodPersons();
                totalAddedFriends += addedFriends;
            }
            audience.addStoodPersons(addedFriends + shyPersons);
        }
        return totalAddedFriends;
    }
}
