import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

/**
 * Created by stan on 11/04/15.
 */
public class Case {
    private final int caseNumber;
    private final String inputString;

    public Case(final int caseNumber, final String inputString) {
        this.caseNumber = caseNumber;
        this.inputString = inputString;
    }

    public String getResult() {
        final boolean result = isIJKPossible('i', inputString);
        return "Case #" + caseNumber + ": " + (result ? "YES" : "NO");
    }

    public int getCaseNumber() {
        return caseNumber;
    }

    private boolean isIJKPossible(final char targetChar, final String currentString) {
        if (targetChar == 'k') {
            return isKPossible(currentString);
        } else {
            final List<String> candidates = getCandidateStrings(targetChar, currentString);
            final char nextTarget = (targetChar == 'i' ? 'j' : 'k');
            for (final String candidate : candidates) {
                if (isIJKPossible(nextTarget, candidate)) {
                    return true;
                }
            }
            return false;
        }
    }

    private List<String> getCandidateStrings(final char target, final String base) {
        final List<String> result = new ArrayList<>();
        char temp = '1';
        int index = 1;
        for (final char c : base.toCharArray()) {
            temp = QuaternionUtil.multiply(temp, c);
            if (temp == target) {
                if (index < base.length()) {
                    result.add(base.substring(index));
                }
            }
            index ++;
        }
        return Collections.unmodifiableList(result);
    }

    private boolean isKPossible(final String base) {
        char temp = '1';
        for (final char c : base.toCharArray()) {
            temp = QuaternionUtil.multiply(temp, c);
            if (temp == 'k') {
                return true;
            }
        }
        return false;
    }
}
