import javafx.util.Pair;

import java.util.Collections;
import java.util.HashMap;
import java.util.Map;

/**
 * Created by stan on 11/04/15.
 */
public class QuaternionUtil {
    private final static Map<Pair<Character, Character>, Character> charactersMap;
    static {
        final Map<Pair<Character, Character>, Character> map = new HashMap<>();
        map.put(new Pair<Character, Character>('1', '1'), '1');
        map.put(new Pair<Character, Character>('1', '&'), '&');
        map.put(new Pair<Character, Character>('1', 'i'), 'i');
        map.put(new Pair<Character, Character>('1', 'j'), 'j');
        map.put(new Pair<Character, Character>('1', 'k'), 'k');
        map.put(new Pair<Character, Character>('1', 'l'), 'l');
        map.put(new Pair<Character, Character>('1', 'm'), 'm');
        map.put(new Pair<Character, Character>('1', 'n'), 'n');
        map.put(new Pair<Character, Character>('&', '1'), '&');
        map.put(new Pair<Character, Character>('&', '&'), '1');
        map.put(new Pair<Character, Character>('&', 'i'), 'l');
        map.put(new Pair<Character, Character>('&', 'j'), 'm');
        map.put(new Pair<Character, Character>('&', 'k'), 'n');
        map.put(new Pair<Character, Character>('&', 'l'), 'i');
        map.put(new Pair<Character, Character>('&', 'm'), 'j');
        map.put(new Pair<Character, Character>('&', 'n'), 'k');
        map.put(new Pair<Character, Character>('i', '1'), 'i');
        map.put(new Pair<Character, Character>('i', '&'), 'l');
        map.put(new Pair<Character, Character>('i', 'i'), '&');
        map.put(new Pair<Character, Character>('i', 'j'), 'k');
        map.put(new Pair<Character, Character>('i', 'k'), 'm');
        map.put(new Pair<Character, Character>('i', 'l'), '1');
        map.put(new Pair<Character, Character>('i', 'm'), 'n');
        map.put(new Pair<Character, Character>('i', 'n'), 'j');
        map.put(new Pair<Character, Character>('j', '1'), 'j');
        map.put(new Pair<Character, Character>('j', '&'), 'm');
        map.put(new Pair<Character, Character>('j', 'i'), 'n');
        map.put(new Pair<Character, Character>('j', 'j'), '&');
        map.put(new Pair<Character, Character>('j', 'k'), 'i');
        map.put(new Pair<Character, Character>('j', 'l'), 'k');
        map.put(new Pair<Character, Character>('j', 'm'), '1');
        map.put(new Pair<Character, Character>('j', 'n'), 'l');
        map.put(new Pair<Character, Character>('k', '1'), 'k');
        map.put(new Pair<Character, Character>('k', '&'), 'n');
        map.put(new Pair<Character, Character>('k', 'i'), 'j');
        map.put(new Pair<Character, Character>('k', 'j'), 'l');
        map.put(new Pair<Character, Character>('k', 'k'), '&');
        map.put(new Pair<Character, Character>('k', 'l'), 'm');
        map.put(new Pair<Character, Character>('k', 'm'), 'i');
        map.put(new Pair<Character, Character>('k', 'n'), '1');
        map.put(new Pair<Character, Character>('l', '1'), 'l');
        map.put(new Pair<Character, Character>('l', '&'), 'i');
        map.put(new Pair<Character, Character>('l', 'i'), '1');
        map.put(new Pair<Character, Character>('l', 'j'), 'n');
        map.put(new Pair<Character, Character>('l', 'k'), 'j');
        map.put(new Pair<Character, Character>('l', 'l'), '&');
        map.put(new Pair<Character, Character>('l', 'm'), 'k');
        map.put(new Pair<Character, Character>('l', 'n'), 'm');
        map.put(new Pair<Character, Character>('m', '1'), 'm');
        map.put(new Pair<Character, Character>('m', '&'), 'j');
        map.put(new Pair<Character, Character>('m', 'i'), 'k');
        map.put(new Pair<Character, Character>('m', 'j'), '1');
        map.put(new Pair<Character, Character>('m', 'k'), 'l');
        map.put(new Pair<Character, Character>('m', 'l'), 'n');
        map.put(new Pair<Character, Character>('m', 'm'), '&');
        map.put(new Pair<Character, Character>('m', 'n'), 'i');
        map.put(new Pair<Character, Character>('n', '1'), 'n');
        map.put(new Pair<Character, Character>('n', '&'), 'k');
        map.put(new Pair<Character, Character>('n', 'i'), 'm');
        map.put(new Pair<Character, Character>('n', 'j'), 'i');
        map.put(new Pair<Character, Character>('n', 'k'), '1');
        map.put(new Pair<Character, Character>('n', 'l'), 'j');
        map.put(new Pair<Character, Character>('n', 'm'), 'l');
        map.put(new Pair<Character, Character>('n', 'n'), '&');
        charactersMap = Collections.unmodifiableMap(map);
    }

    public static char multiply(final char char1, final char char2) {
        return charactersMap.get(new Pair<Character, Character>(char1, char2));
    }
}
