import java.io.*;
import java.util.*;


public class CodeJam3 {

	/**
	 * @param args
	 */
	private List<Integer> integerToBinary(int value) {
		final List<Integer> binaryList = new ArrayList<Integer>();

		while (value > 0) {
			final int remainder = value % 2;

			binaryList.add(0, remainder);

			value = value / 2;
		}

		return binaryList;
	}

	private int binaryToInteger(final List<Integer> list) {
		int value = 0;
		int pos = 0;
		for (int i = list.size() - 1; i >= 0; i--) {
			value += list.get(i) * Math.pow(2, pos++);
		}
		return value;
	}

	private List<Integer> patrickAddBinary(final List<Integer> list1,
			final List<Integer> list2) {

		final List<Integer> resultList = new ArrayList<Integer>();
		final int max = Math.max(list1.size(), list2.size());
		int pos = 1;
		for (int i = 0; i < max; i++) {
			final int val1 = list1.size() - pos >= 0 ? list1.get(list1.size()
					- pos) : 0;
			final int val2 = list2.size() - pos >= 0 ? list2.get(list2.size()
					- pos) : 0;

			int sum = val1 + val2;
			if (sum > 1) {
				sum = 0;
			}
			resultList.add(0, sum);

			pos++;
		}
		return resultList;
	}

	private boolean isBinaryEqual(final List<Integer> list1,
			final List<Integer> list2) {
		final int max = Math.max(list1.size(), list2.size());
		int pos = 1;
		for (int i = 0; i < max; i++) {
			final int val1 = list1.size() - pos >= 0 ? list1.get(list1.size()
					- pos) : 0;
			final int val2 = list2.size() - pos >= 0 ? list2.get(list2.size()
					- pos) : 0;

			if (val1 != val2) {
				return false;
			}
			pos++;
		}
		return true;
	}

	private String getBinaryListString(final List<Integer> list) {
		String text = "";
		for (final Integer bin : list) {
			text += " " + bin;
		}
		return text;
	}

	public void solveInput(final InputStream input, final OutputStream output)
			throws IOException {

		final BufferedReader reader = new BufferedReader(new InputStreamReader(
				input));
		final BufferedWriter writer = new BufferedWriter(
				new OutputStreamWriter(output));

		final int numTestCase = Integer.valueOf(reader.readLine().trim());

		String line = null;
		int caseNo = 1;
		while ((line = reader.readLine()) != null) {
			final int num = Integer.valueOf(line.trim());
			final String[] strings = reader.readLine().trim().split(" ");
			final List<Integer> sortedValues = new ArrayList<Integer>();
			for (final String str : strings) {
				sortedValues.add(Integer.valueOf(str));
			}
			Collections.sort(sortedValues);

			int pilot = 1;
			int maxValuePile2 = 0;
			while (pilot < sortedValues.size()) {
				List<Integer> pile1 = null;
				int valuePile1 = 0;
				for (int i = 0; i < pilot; i++) {
					final int value = sortedValues.get(i);

					final List<Integer> newBinary = integerToBinary(value);
					if (pile1 == null) {
						pile1 = newBinary;
					} else {
						pile1 = patrickAddBinary(pile1, newBinary);
					}
					valuePile1 += value;
				}

				List<Integer> pile2 = null;
				int valuePile2 = 0;
				for (int i = pilot; i < sortedValues.size(); i++) {
					final int value = sortedValues.get(i);
					final List<Integer> newBinary = integerToBinary(value);
					if (pile2 == null) {
						pile2 = newBinary;
					} else {
						pile2 = patrickAddBinary(pile2, newBinary);
					}
					valuePile2 += value;
				}

				if (pile1 != null && pile2 != null
						&& isBinaryEqual(pile1, pile2)) {
					maxValuePile2 = Math.max(maxValuePile2, valuePile2);
				}
				pilot++;
			}

			if (caseNo > 1) {
				writer.write("\n");
			}
			String text = "Case #" + (caseNo++) + ": ";
			if (maxValuePile2 > 0) {
				text += maxValuePile2;
			} else {
				text += "NO";
			}
			System.out.println(text);
			writer.write(text);
			writer.flush();
		}
		writer.close();
		reader.close();
	}

	public static void main(final String[] args) throws Exception {
		final CodeJam3 candy = new CodeJam3();

		final File outputFile = new File("out3.txt");
		if (outputFile.exists()) {
			outputFile.delete();
		}
		final File inputFile = new File("in3.txt");
		final FileOutputStream fos = new FileOutputStream(outputFile);
		final FileInputStream fis = new FileInputStream(inputFile);
		candy.solveInput(fis, fos);

	}

}
