/**
 * @(#)Round1CB.java
 *
 * Round1CB application
 *
 * @author Brian Tagiku
 * @version 1.00 2009/9/13
 */

import java.util.*;
import java.io.*;
import java.text.*;
 
public class Round1CB {
    
    //public static String filename = "B-test";
    public static String filename = "B-small-attempt3";
    //public static String filename = "B-large";
    
    public static DecimalFormat df;
    
    public static void main(String[] args) {
    	
    	df = new DecimalFormat("#0.00000000");
    	
    	// Load input
    	try {
	    	Scanner fin = new Scanner(new File(filename+".in"));
	    	PrintWriter fout = new PrintWriter(new FileWriter(filename+".out"));
	    	
	    	// Load the number of cases
	    	int T = fin.nextInt();
	    	
	    	for(int casenum=0; casenum<T; casenum++) {
	    		
	    		// Read in input
	    		int N = fin.nextInt();
	    		Fly[] flies = new Fly[N];
	    		
	    		for(int i=0; i<N; i++)
	    			flies[i] = new Fly(fin.nextInt(),fin.nextInt(),fin.nextInt(),fin.nextInt(),fin.nextInt(),fin.nextInt());
	    		
	    		// Solve
	    		double minT=0, maxT=1;
	    		double minVel=dCM(flies,0);
	    			
    			// find upper bound
    			while(((dCM(flies,maxT) < 0) && (dCM(flies,minT) < 0)) ||
    				((dCM(flies,maxT) > 0) && (dCM(flies,minT) > 0)))
    				maxT*=2;
    			
    			double minD = CM(flies,minT);
    			double maxD = CM(flies,maxT);
    				
    			// Binary search
    			while((maxT-minT > .000000001) || (maxD-minD > .000000001)) {
    				double currT = (minT+maxT)/2;
    				double currVel = dCM(flies,currT);
    				
    				if(currVel > 0){
    					maxT = currT;
    					maxD = CM(flies,currT);
    				}	
    				else {
    					minT = currT;
    					minD = CM(flies,currT);
    				}
    					    				
    			}
    			
    			fout.println("Case #" + (casenum+1) + ": " + df.format(CM(flies,minT)) + " " + df.format(minT));
    		}

	    	
    		// Close up shop
    		fin.close();
    		fout.close();

       	}
       	catch(IOException e) {
       		System.out.println("Error loading input or output file");
       	}
    }
    
    public static double CM(Fly[] flies, double t) {
    	double sum=0;
    	for(int i=0; i<flies.length; i++) {
    		for(int j=0; j<flies.length; j++) {
    			sum+=flies[i].xLoc(t)*flies[j].xLoc(t);
    			sum+=flies[i].yLoc(t)*flies[j].yLoc(t);
    			sum+=flies[i].zLoc(t)*flies[j].zLoc(t);
    		}
    	}
    	
    	if(sum<0)
    		sum=0;
    	
    	return Math.sqrt(sum)/flies.length;
    }
    
    public static double dCM(Fly[] flies, double t) {
    	// Not true derivative..but only thing we're interested in since we only want zeros
    	
    	double sum=0;
    	
    	for(int i=0; i<flies.length; i++) {
    		for(int j=0; j<flies.length; j++ ) {
    			sum += (flies[i].xLoc(t)*flies[j].vx + flies[i].vx*flies[j].xLoc(t));
    			sum += (flies[i].yLoc(t)*flies[j].vy + flies[i].vy*flies[j].yLoc(t));
    			sum += (flies[i].zLoc(t)*flies[j].vz + flies[i].vz*flies[j].zLoc(t));
    		}
    	}
    	
    	return sum;
    }
    
    public static class Fly {
    	int x,y,z,vx,vy,vz;
    	
    	public Fly(int a, int b, int c,int va,int vb,int vc) {
    		x=a; y=b; z=c; vx=va; vy=vb; vz=vc;
    	}
    	
    	public double xLoc(double t) {
    		return x+vx*t;
    	}
    	
    	public double yLoc(double t) {
    		return y+vy*t;
    	}
    	
    	public double zLoc(double t) {
    		return z+vz*t;
    	}
    }
}
