/**
 * @(#)RoundQC.java
 *
 * RoundQC application
 *
 * @author Brian Tagiku
 * @version 1.00 2009/9/2
 */
 
import java.util.*;
import java.io.*;
 
public class RoundQC {
    
    public static String filename = "C-small-attempt0";
    public static String phrase = "welcome to code jam";
    
    public static void main(String[] args) {
    	
    	// Load input
    	try {
	    	Scanner filein = new Scanner(new File(filename+".in"));
	    	PrintWriter fileout = new PrintWriter(new FileWriter(filename+".out"));
	    	
	    	// For each case...
	    	int N = filein.nextInt();
	    	filein.nextLine();
	    	for(int caseNum=1; caseNum<=N; caseNum++) {
	    		
	    		String text = filein.nextLine();
	    		
	    		// Massive dynamic programming
	    		// dpmatrix[i][j] gives the number of occurences of substring
	    		// phrase[j:end] in text[i:end]
	    		int[][] dpmatrix = new int[text.length()][phrase.length()];
	    		
	    		// Fill out last element and row
	    		char last = phrase.charAt(phrase.length()-1);
	    		if(last == text.charAt(text.length()-1))
	    			dpmatrix[text.length()-1][phrase.length()-1]=1;
	    		for(int i=text.length()-2; i>=0; i--) {
	    			dpmatrix[i][phrase.length()-1]=dpmatrix[i+1][phrase.length()-1];
	    			if(last == text.charAt(i))
	    				dpmatrix[i][phrase.length()-1]++;
	    		}

				// Fill out remaining rows	    		
	    		for(int i=text.length()-2; i>=0; i--) {		
	    			for(int j=phrase.length()-2; (phrase.length()-j<=text.length()-i) && (j>=0); j--) {
	    				if (text.charAt(i)==phrase.charAt(j))
	    					dpmatrix[i][j] = (dpmatrix[i+1][j+1] + dpmatrix[i+1][j])%10000;
	    				else
	    					dpmatrix[i][j] = dpmatrix[i+1][j]%10000;
	    			}
	    		}	    		
	    		
				// Print out answer
				fileout.print("Case #" + (caseNum) + ": ");
				fileout.printf("%04d%n",dpmatrix[0][0]);
	    	}
	    	
	    	filein.close();
	    	fileout.close();
       	}
       	catch(IOException e) {
       		System.out.println("Error loading input or output file");
       	}
    }
}
