import java.util.*;

public class Goro {
    public static double choose(int n, int k) {
	return fac(n)/(fac(k)*fac(n-k));
    }

    public static double pow(int b, int e) {
	if(e==0) return 1.0;
	return pow(b,e-1)*b;
    }

    public static double fac(int n) {
	if (n==0) return 1.0;
	return fac(n-1)*n;
    }

    public static void main(String[] args) {
	Scanner in = new Scanner(System.in);
	int numcases = in.nextInt();

	int numexpected = 1000;
	double[] expectedvalues = new double[numexpected];

	expectedvalues[0] = 0;
	expectedvalues[1] = 2;
	for(int i=2; i<numexpected; i++) {
	    expectedvalues[i] = 1;

	    // Calculate cycles of length j
	    for(int j=2; j<=i; j++) {
		double multiplier = 0;
		for(int k=1; k<=(i+1)/j; k++) {
		    multiplier += 1/(fac(k)*pow(j,k));
		}
		expectedvalues[i] += multiplier*expectedvalues[j-1];
	    }	    

	    expectedvalues[i] *= ((double)(i+1)/(i));
	}
	
	//	for(int i=0; i<numexpected; i++) {
	//	    System.out.println("E[" + (i+1) + "]=" + expectedvalues[i]);
	//	}

	for(int i=0; i<numcases; i++) {
	    int numnum = in.nextInt();
	    int[] list = new int[numnum];
	    for(int j=0; j<numnum; j++)
		list[j] = in.nextInt() - 1;

	    double answer = 0;
	    boolean[] touched = new boolean[numnum];
	    for(int j=0; j<numnum; j++)
		touched[j] = false;

	    // Find a cycle, then add length-1
	    for(int j=0; j<numnum; j++) {
		if(!touched[j]) {
		    int curr = j;
		    int length = 0;
		    while(!touched[curr]) {
			touched[curr] = true;
			length++;
			curr = list[curr];
		    }
		    answer += expectedvalues[length-1];
		}
	    }

	    System.out.println("Case #" + (i+1) + ": " + answer);
	}
    }
}