/**
 * @(#)Round1CA.java
 *
 * Round1CA application
 *
 * @author Brian Tagiku
 * @version 1.00 2009/9/13
 */

import java.util.*;
import java.io.*;
 
public class Round1CA {
    
    //public static String filename = "A-test";
    public static String filename = "A-small-attempt0";
    //public static String filename = "A-large";
    
    public static void main(String[] args) {
    	
    	// Load input
    	try {
	    	Scanner fin = new Scanner(new File(filename+".in"));
	    	PrintWriter fout = new PrintWriter(new FileWriter(filename+".out"));
	    	
	    	// Load the number of cases
	    	int T = fin.nextInt();
	    	fin.nextLine();
	    	
	    	for(int casenum=0; casenum<T; casenum++) {
	    		
	    		// Read in input
	    		String num = fin.nextLine();
	    		
	    		// Print out solution
	    		fout.println("Case #" + (casenum+1) + ": " + next(num));

	    	}
	    	
	    	
	    	
    		// Close up shop
    		fin.close();
    		fout.close();

       	}
       	catch(IOException e) {
       		System.out.println("Error loading input or output file");
       	}
    }
    
    public static String next(String x) {
    	
    	int[] map = new int[36];  // 0-9 then a-z
    	
    	int base = 0;
    	for(int i=0; i<x.length(); i++) {
    		if (map[Character.getNumericValue(x.charAt(i))] != 1) {
    			base++;
    			map[Character.getNumericValue(x.charAt(i))] = 1;
    		}
    	}
    	
    	// Base never unary
    	if(base<2)
    		base=2;
    	
    	// Reset char map
    	for(int i=0; i<36; i++)
    		map[i]=-1;
    	
    	// No leading zeros, find the one
    	map[Character.getNumericValue(x.charAt(0))]=1;
    	
    	// Now find the zero
    	for(int i=0; i<x.length(); i++) {
    		if(map[Character.getNumericValue(x.charAt(i))]<0) {
    			map[Character.getNumericValue(x.charAt(i))]=0;
    			break;
    		}
    	}
    	
    	// Now find the rest
    	int curdig = 2;
    	for(int i=0; i<x.length(); i++) {
    		if(map[Character.getNumericValue(x.charAt(i))]<0) {
    			map[Character.getNumericValue(x.charAt(i))]=curdig;
    			curdig++;
    		}
    	}
    	
    	// Now calculate
    	long ans = 0;
    	for(int i=x.length()-1; i>=0; i--) {
    		ans += map[Character.getNumericValue(x.charAt(i))] * Math.pow(base,x.length()-1-i);
    	}
    	
    	return ""+ans;
    }
}