import java.io.FileInputStream;
import java.io.PrintWriter;
import java.util.HashMap;
import java.util.List;
import java.util.Scanner;
import java.util.Stack;


public class P02 {
	
	private static HashMap<Character, Integer> eIndex = new HashMap<Character, Integer>();
	
	static {
		eIndex.put('Q', 0);
		eIndex.put('W', 1);
		eIndex.put('E', 2);
		eIndex.put('R', 3);
		eIndex.put('A', 4);
		eIndex.put('S', 5);
		eIndex.put('D', 6);
		eIndex.put('F', 7);
	}
	
	public static void main(String[] args) {
		try {
			Scanner scanner = new Scanner(new FileInputStream("input"));
			PrintWriter writer = new PrintWriter("output");
			
			int tNo = scanner.nextInt();
			for (int t = 1; t <= tNo; ++t) {
				int c, d, n;
				char[][] combine = new char[8][8];
				int[][] opposite = new int[8][8];
				int[] count = new int[8];
				Stack<Character> sequence = new Stack<Character>();
				
				c = scanner.nextInt();
				for (int i = 0; i < c; ++i) {
					String cs = scanner.next();
					combine[eIndex.get(cs.charAt(0))][eIndex.get(cs.charAt(1))] = cs.charAt(2);
					combine[eIndex.get(cs.charAt(1))][eIndex.get(cs.charAt(0))] = cs.charAt(2);
				}
				d = scanner.nextInt();
				for (int i = 0; i < d; ++i) {
					String os = scanner.next();
					opposite[eIndex.get(os.charAt(0))][eIndex.get(os.charAt(1))] = 1;
					opposite[eIndex.get(os.charAt(1))][eIndex.get(os.charAt(0))] = 1;
				}
				
				n = scanner.nextInt();
				String seq = scanner.next();
				for (int i = 0; i < seq.length(); ++i) {
					char chr = seq.charAt(i);
					if (!sequence.isEmpty() && eIndex.get(sequence.peek()) != null) {
						Character top = sequence.peek();
						char result = combine[eIndex.get(chr)][eIndex.get(top)];
						if (result != 0) {
							sequence.pop();
							count[eIndex.get(top)]--;
							sequence.push(result);
							continue;
						}
					}
					sequence.push(chr);
					count[eIndex.get(chr)]++;
					for (int j = 0; j < 8; ++j) {
						if (count[j] > 0 && opposite[eIndex.get(chr)][j] == 1) {
							sequence.clear();
							for (int k = 0; k < 8; ++k) {
								count[k] = 0;
							}
							continue;
						}
					}
				}
				
				printCase(writer, t, sequence);
			}
						
			writer.close();
		} catch (Exception e) {
			e.printStackTrace();
			System.out.println(e);
		}
	}
	
	private static void printCase(PrintWriter writer, int caseNumber, List<Character> solution) {
		StringBuffer buffer = new StringBuffer();
		if (solution.size() == 0) {
			writer.println("Case #" + caseNumber + ": []");
		} else {
			buffer.append("Case #" + caseNumber + ": [" + solution.get(0));
			for (int i = 1; i < solution.size(); ++i) {
				buffer.append(", " + solution.get(i));
			}
			buffer.append("]");
			writer.println(buffer.toString());
		}
	}
}
