package password;

public class Case {

	private final int a;

	private final int b;

	private final double[] pp;

	private double[] tp;
	
	private int maxnum;

	private double exp;

	public Case(int a, int b, double[] pp) {
		this.a = a;
		this.b = b;
		this.pp = pp;
		init();
	}

	public double getExp() {
		return exp;
	}

	private void init() {
		maxnum = (int) Math.pow(2, a);
		tp = new double[maxnum];
		for (int i = 0; i < maxnum; i++) {
			String binstr = "";
			String sbinstr = Integer.toBinaryString(i);
			for (int j = 0; j < a - sbinstr.length(); j++) {
				binstr += "0";
			}
			binstr += sbinstr;
			tp[i] = 1;
			for (int j = 0; j < a; j++) {
				if (binstr.substring(j, j + 1).equals("0")) {
					tp[i] *= pp[j];
				} else {
					tp[i] *= 1 - pp[j];
				}
			}
		}
		calExp();
	}

	private void calExp() {
		exp = calKeepType();
		double temp = calEnter();
		if (exp > temp) {
			exp = temp;
		}
		for (int i = 1; i <= a; i++) {
			temp = calBack(i);
			if (exp > temp) {
				exp = temp;
			}
		}
	}

	private double calKeepType() {
		double result = tp[0] * (b - a + 1);
		for (int i = 1; i < maxnum; i++) {
			result += tp[i] * (b - a + 1 + b + 1);
		}
		return result;
	}

	private double calBack(int step) {
		double result = tp[0] * (step * 2 + b - a + 1);
		for (int i = 1; i < maxnum; i++) {
			int pos = getPos(i, a);
			if (pos <= (a - step - 1)) {
				result += tp[i] * (step * 2 + b - a + 1 + b + 1);
			} else {
				result += tp[i] * (step * 2 + b - a + 1);
			}
		}
		return result;
	}

	private double calEnter() {
		return b + 2;
	}

	private int getPos(int binary, int length) {
		int result = -1;
		String binstr = Integer.toBinaryString(binary);
		for (int i = 0; i < binstr.length(); i++) {
			if (binstr.substring(i, i + 1).equals("1")) {
				result = i;
				break;
			}
		}
		result += length - binstr.length();
		return result;
	}

	public static void main(String[] args) {
		int a = 3;
		int b = 4;
		double[] pp = { 1, 0.9, 0.1 };
		System.out.println(new Case(a, b, pp).getExp());
	}

}
