package tongues;

import java.util.List;
import java.util.Map;

import util.ListFactory;
import util.MapFactory;
import file.Input;
import file.Output;

public class Tongues {

	private static final Map<String, String> map = MapFactory
			.newHashMapInstance();

	static {
		map.put("a", "y");
		map.put("b", "h");
		map.put("c", "e");
		map.put("d", "s");
		map.put("e", "o");
		map.put("f", "c");
		map.put("g", "v");
		map.put("h", "x");
		map.put("i", "d");
		map.put("j", "u");
		map.put("k", "i");
		map.put("l", "g");
		map.put("m", "l");
		map.put("n", "b");
		map.put("o", "k");
		map.put("p", "r");
		map.put("q", "z");
		map.put("r", "t");
		map.put("s", "n");
		map.put("t", "w");
		map.put("u", "j");
		map.put("v", "p");
		map.put("w", "f");
		map.put("x", "m");
		map.put("y", "a");
		map.put("z", "q");
	}

	public static void translate() {
		List<String> inputLines = Input.getLines();
		if (inputLines.size() > 0) {
			List<String> outputLines = ListFactory.newArrayListInstance();
			int n = Integer.parseInt(inputLines.get(0));
			for (int i = 1; i <= n; i++) {
				String inputLine = inputLines.get(i).toLowerCase();
				String outputLine = "";
				for (int j = 0; j < inputLine.length(); j++) {
					String key = inputLine.substring(j, j + 1);
					if (map.get(key) != null) {
						outputLine += map.get(key);
					} else {
						outputLine += key;
					}
				}
				outputLines.add("Case #" + i + ": " + outputLine);
			}
			Output.writeLines(outputLines);
		}
	}

	public static void main(String[] args) {
		Tongues.translate();
	}

}
