package com.gmail.bubby4j.codejam2016;

import java.util.*;
import java.io.*;

//Template from https://martin-thoma.com/google-code-jam-templates/

public class CoinJam {
	final static String WORK_DIR = "C:\\Users\\James\\Documents\\EclipseMarsWorkspace\\Code Jam 2016\\bin\\";
	final static String INPUT_FILE_NAME = "input.txt";
	final static String OUTPUT_FILE_NAME = "output.txt";

	//Define global variables here

	static void preprocess() {
		//Any preprocessing code
	}
	
	//Finds a divisor of a number, returns -1 if prime
	long getSingleDivisor(final long num)
	{
		//System.out.println("getting single divisor for " + num);
		for (long i = 2l; i <= ((long) Math.sqrt(num)); i++)
		{
			if(num % i == 0)
			{
				return i;
			}
		}
		return -1l;
	}
	
	String getDivisors(String binaryNum)
	{
		String divisors = "";
		for(int radix = 2; radix <= 10; radix++)
		{
			long thisNumber = Long.parseLong(binaryNum, radix);
			//thisNumber is the number as intreperted in bases 2 through 10
			long divisor = getSingleDivisor(thisNumber);
			if(divisor == -1)
			{
				return "";//Has a prime, this isn't a jamcoin
			}
			divisors += " " + divisor;
		}
		
		
		return divisors;
	}

	void solve(Scanner sc, PrintWriter pw) {
		System.out.println("");
		//1. Get inputs
		int N = sc.nextInt();
		int J = sc.nextInt();
		
		String output = "";
		String numZero = "";
		for(int i = 3; i <= N; i++)
		{
			numZero = numZero + "0";
		}
		
		int numFound = 0;
		String thisNum = "1" + numZero + "1";
		long thisTest;
		for(thisTest = Long.parseLong(thisNum, 2); (thisNum.length() <= N) && (numFound < J); thisTest = thisTest + 2)
		{
			//Test thisNum to see if it's not prime
			String divisors = getDivisors(thisNum);
			if(divisors.length() > 0)
			{
				output += thisNum + divisors + "\r\n";
				System.out.println(thisNum + divisors);
				numFound++;
			}

			//Load next number before loop
			thisNum = Long.toBinaryString(thisTest+2);
		}
		
		

		//3. Profit!

		pw.println("");
		pw.println(output);
	}

	public static void main(String[] args) throws Exception {
		preprocess();

		Scanner sc = new Scanner(new FileReader(WORK_DIR + INPUT_FILE_NAME));

		PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR
				+ OUTPUT_FILE_NAME));

		int caseCnt = sc.nextInt();
		for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
			System.out.print("Case #" + (caseNum + 1) + ": ");
			pw.print("Case #" + (caseNum + 1) + ": ");
			new CoinJam().solve(sc, pw);
		}
		pw.flush();
		pw.close();
		sc.close();
	}
}