package com.gmail.bubby4j.codejam2016;

import java.util.*;
import java.io.*;

//Template from https://martin-thoma.com/google-code-jam-templates/

public class RevengeOfThePancakes {
	final static String WORK_DIR = "C:\\Users\\James\\Documents\\EclipseMarsWorkspace\\Code Jam 2016\\bin\\";
	final static String INPUT_FILE_NAME = "input.txt";
	final static String OUTPUT_FILE_NAME = "output.txt";

	//Define global variables here

	static void preprocess() {
		//Any preprocessing code
	}
	
	ArrayList<Boolean> parse(String S)
	{
		ArrayList<Boolean> newStack = new ArrayList<Boolean>();
		S = S.trim();
		
		for(char c : S.toCharArray())
		{
			newStack.add(c == '+' ? true : false);
		}
		
		return removeBottomPancakes(newStack);
	}
	
	ArrayList<Boolean> flip(ArrayList<Boolean> stack, int to)
	{
		if(to == -1)
		{
			System.out.println("Error?!");
			return stack;
		}
		ArrayList<Boolean> newStack = new ArrayList<Boolean>();
		
		for(int i=to; i>=0; i--)
		{
			newStack.add(!stack.get(i));
		}
		//Add the rest
		for(int i=to+1; i < stack.size(); i++)
		{
			newStack.add(stack.get(i));
		}
		
		return removeBottomPancakes(newStack);
	}
	
	//Removes pancakes on the bottom that are +, we can ignore them
	ArrayList<Boolean> removeBottomPancakes(ArrayList<Boolean> stack)
	{
		ArrayList<Boolean> newStack = new ArrayList<Boolean>();
		int goTo = -1;
		
		for(int i=stack.size()-1; i>=0; i--)
		{
			if(stack.get(i) == false)
			{
				goTo = i;
				break;
			}
		}
		
		//Copy top goTo elements
		for(int i=0; i <= goTo; i++)
		{
			newStack.add(stack.get(i));
		}
		return newStack;
	}
	
	/*String unparse(ArrayList<Boolean> stack)
	{
		String s = "";
		for(Object b : stack.toArray())
		{
			boolean B = (boolean) b;
			s = s + (B == true ? "+" : "-");
		}
		return s;
	}*/

	void solve(Scanner sc, PrintWriter pw) {
		//1. Get inputs
		ArrayList<Boolean> S = parse(sc.next());
		
		int numMoves = 0;
		while(S.size() != 0)
		{
			if(!S.contains(true))
			{
				S = flip(S, S.size()-1);
			}
			else if(S.get(0) == false)
			{
				S = flip(S, S.size()-1);
			}
			else
			{
				for(int i=0; i<S.size(); i++)
				{
					if(S.get(i) == false)
					{
						S = flip(S, i-1);
						break;
					}
					else if(i == S.size()-1)
					{
						S = flip(S, S.size()-1);
					}
				}
			}
			numMoves++;
		}

		//3. Profit!
		String output = Integer.toString(numMoves);

		pw.println(output);
		System.out.println(output);
	}

	public static void main(String[] args) throws Exception {
		preprocess();

		Scanner sc = new Scanner(new FileReader(WORK_DIR + INPUT_FILE_NAME));

		PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR
				+ OUTPUT_FILE_NAME));

		int caseCnt = sc.nextInt();
		for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
			System.out.print("Case #" + (caseNum + 1) + ": ");
			pw.print("Case #" + (caseNum + 1) + ": ");
			new RevengeOfThePancakes().solve(sc, pw);
		}
		pw.flush();
		pw.close();
		sc.close();
	}
}