package com.gmail.bubby4j.codejam2016;

import java.util.*;
import java.io.*;
import java.math.BigInteger;

//Template from https://martin-thoma.com/google-code-jam-templates/

public class CoinJam {
	final static String WORK_DIR = "C:\\Users\\James\\Documents\\EclipseMarsWorkspace\\Code Jam 2016\\bin\\";
	final static String INPUT_FILE_NAME = "input.txt";
	final static String OUTPUT_FILE_NAME = "output.txt";

	//Define global variables here

	static void preprocess() {
		//Any preprocessing code
	}
	
	//Credit: http://faruk.akgul.org/blog/javas-missing-algorithm-biginteger-sqrt/
	BigInteger bigSqrt(BigInteger n) {
		  BigInteger a = BigInteger.ONE;
		  BigInteger b = new BigInteger(n.shiftRight(5).add(new BigInteger("8")).toString());
		  while(b.compareTo(a) >= 0) {
		    BigInteger mid = new BigInteger(a.add(b).shiftRight(1).toString());
		    if(mid.multiply(mid).compareTo(n) > 0) b = mid.subtract(BigInteger.ONE);
		    else a = mid.add(BigInteger.ONE);
		  }
		  return a.subtract(BigInteger.ONE);
		}
	
	//Finds a divisor of a number, returns -1 if prime
	long getSingleDivisor(BigInteger num)
	{
		if(num.isProbablePrime(1))
		{
			return -1; //Give up if there's a decent chance of being prime
		}
		//System.out.println("getting single divisor for " + num);
		for (long i = 2; i < 100000; i++)
		{
			if(num.remainder(BigInteger.valueOf(i)).compareTo(BigInteger.ZERO) == 0)
			{
				return i;
			}
		}
		return -1;
	}
	
	String getDivisors(final String binaryNum)
	{
		String divisors = "";
		for(int radix = 2; radix <= 10; radix++)
		{
			BigInteger thisNumber = new BigInteger(binaryNum, radix);
			//thisNumber is the number as interpreted in bases 2 through 10
			long divisor = getSingleDivisor(thisNumber);
			if(divisor == -1)
			{
				return "";//Has a prime, this isn't a jamcoin
			}
			divisors += " " + divisor;
		}
		
		
		return divisors;
	}

	void solve(Scanner sc, PrintWriter pw) {
		System.out.println("");
		//1. Get inputs
		int N = sc.nextInt();
		int J = sc.nextInt();
		
		String output = "";
		String numZero = "";
		for(int i = 3; i <= N; i++)
		{
			numZero = numZero + "0";
		}
		
		int numFound = 0;
		String thisNum = "1" + numZero + "1";
		long thisTest;
		for(thisTest = Long.parseLong(thisNum, 2); (thisNum.length() <= N) && (numFound < J); thisTest = thisTest + 2)
		{
			//Test thisNum to see if it's not prime
			String divisors = getDivisors(thisNum);
			if(divisors.length() > 0)
			{
				output += thisNum + divisors + "\r\n";
				System.out.println(thisNum + divisors);
				numFound++;
			}

			//Load next number before loop
			thisNum = Long.toBinaryString(thisTest+2);
		}
		
		

		//3. Profit!

		pw.println("");
		pw.println(output);
	}

	public static void main(String[] args) throws Exception {
		preprocess();

		Scanner sc = new Scanner(new FileReader(WORK_DIR + INPUT_FILE_NAME));

		PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR
				+ OUTPUT_FILE_NAME));

		int caseCnt = sc.nextInt();
		for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
			System.out.print("Case #" + (caseNum + 1) + ": ");
			pw.print("Case #" + (caseNum + 1) + ": ");
			new CoinJam().solve(sc, pw);
		}
		pw.flush();
		pw.close();
		sc.close();
	}
}