package one.b;

import com.google.common.collect.ImmutableList;
import com.google.common.collect.Ordering;

import java.util.*;

public class StableNeighborsSmall {
    public static void main(String[] args) {
        try (Scanner sc = new Scanner(System.in)) {
            int numTests = sc.nextInt();
            for (int i = 0; i < numTests; i++) {
                int n = sc.nextInt();
                int red = sc.nextInt();
                int orange = sc.nextInt();
                int yellow = sc.nextInt();
                int green = sc.nextInt();
                int blue = sc.nextInt();
                int violet = sc.nextInt();
                System.out.format("Case #%s: %s%n", (i + 1), solve(red, yellow, blue, n));
            }
        }
    }

    private static String solve(int red, int yellow, int blue, int total) {
        HorseSet redHorses = new HorseSet("R", red);
        HorseSet yellowHorses = new HorseSet("Y", yellow);
        HorseSet blueHorses = new HorseSet("B", blue);
        String useThisColorFastest;
        if (red >= yellow && red >= blue) {
            // red!
            if (red > yellow + blue) {
                return "IMPOSSIBLE";
            }
            useThisColorFastest = "R";
        } else if (yellow >= red && yellow >= blue) {
            // yellow!
            if (yellow > red + blue) {
                return "IMPOSSIBLE";
            }
            useThisColorFastest = "Y";
        } else {
            // blue!
            if (blue > yellow + red) {
                return "IMPOSSIBLE";
            }
            useThisColorFastest = "B";
        }

        PriorityQueue<HorseSet> horseSets = new PriorityQueue<>((o1, o2) -> {
            if (o2.num < o1.num) {
                return -1;
            } else if (o1.num < o2.num) {
                return 1;
            } else {
                if (o2.color.equals(useThisColorFastest)) {
                    return 1;
                } else if (o1.color.equals(useThisColorFastest)) {
                    return -1;
                } else {
                    return 0;
                }
            }
        });
        if (redHorses.num > 0) {
            horseSets.add(redHorses);
        }
        if (yellowHorses.num > 0) {
            horseSets.add(yellowHorses);
        }
        if (blueHorses.num > 0) {
            horseSets.add(blueHorses);
        }

        StringBuilder sb = new StringBuilder();
        HorseSet prevHorseSet = horseSets.poll();
        sb.append(prevHorseSet.color);
        prevHorseSet = HorseSet.dec(prevHorseSet);
        while (!horseSets.isEmpty()) {
            HorseSet currHorseSet = horseSets.poll();
            sb.append(currHorseSet.color);
            if (prevHorseSet.num > 0) {
                horseSets.add(prevHorseSet);
            }
            prevHorseSet = HorseSet.dec(currHorseSet);
        }
        return sb.toString();
    }

    private static class HorseSet implements Comparable<HorseSet> {
        private final String color;
        private final int num;

        public HorseSet(String color, int num) {
            this.color = color;
            this.num = num;
        }

        public static HorseSet dec(HorseSet set) {
            return new HorseSet(set.color, set.num - 1);
        }

        @Override
        public int compareTo(HorseSet o) {
            // reverse ordering
            return o.num - num;
        }
    }
}
