package one.b;

import com.google.common.collect.Ordering;

import java.util.*;

public class CruiseControl {
    public static void main(String[] args) {
        try (Scanner sc = new Scanner(System.in)) {
            int numTests = sc.nextInt();
            for (int i = 0; i < numTests; i++) {
                long destination = sc.nextLong();
                int n = sc.nextInt();
                Map<Long, Integer> horsePosToSpeed = new HashMap<>(n);
                for (int j = 0; j < n; j++) {
                    horsePosToSpeed.put(sc.nextLong(), sc.nextInt());
                }
                System.out.format("Case #%s: %f%n", (i + 1), solve(destination, horsePosToSpeed));
            }
        }
    }

    private static double solve(long destination, Map<Long, Integer> horsePosToSpeed) {
        List<Long> sorted = Ordering.natural().immutableSortedCopy(horsePosToSpeed.keySet());
        long lastHorsePos = sorted.get(sorted.size() - 1);
        int speed = horsePosToSpeed.get(lastHorsePos);
        double maxFinishTime = (destination - lastHorsePos) / (double) speed;

        for (int i = sorted.size() - 2; i >= 0; i--) {
            long horsePos = sorted.get(i);
            double finishTime = (destination - horsePos) / (double) horsePosToSpeed.get(horsePos);
            if (finishTime > maxFinishTime) {
                maxFinishTime = finishTime;
            }
        }
        return destination / maxFinishTime;
    }
}
