package google.codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Lists;

public class B {
    public static void main(String[] args) throws FileNotFoundException {
        try (Scanner sc = new Scanner(new File("large.in"))) {
            int numTests = sc.nextInt();

            for (int i = 0; i < numTests; i++) {
                int numDiners = sc.nextInt();
                List<Integer> dinerStacks = Lists.newArrayList();
                int maxDinerStack = 0;
                for (int j = 0; j < numDiners; j++) {
                    int dinerStack = sc.nextInt();
                    dinerStacks.add(dinerStack);
                    if (dinerStack > maxDinerStack) {
                        maxDinerStack = dinerStack;
                    }
                }
                System.out.print(String.format("Case #%s: ", i + 1));
                solve(dinerStacks, maxDinerStack);
            }
        }
    }

    private static void solve(List<Integer> dinerStacks, int maxDinerStack) {
        int fastest = maxDinerStack;
        for (int maxStackSize = 2; maxStackSize < maxDinerStack; maxStackSize++) {
            int timeToFlattenStacks = 0;
            for (int numDinerStack = 0; numDinerStack < dinerStacks.size(); numDinerStack++) {
                int timeToSplitCurrentStack = (dinerStacks.get(numDinerStack) - 1) / maxStackSize;
                timeToFlattenStacks += timeToSplitCurrentStack;
            }
            int totalTime = timeToFlattenStacks + maxStackSize;
            if (totalTime < fastest) {
                fastest = totalTime;
            }
        }
        System.out.println(fastest);
    }
}
