package google.code.jam.qualification;

import java.io.IOException;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class CountingSheep {
    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(System.in);
        int numTests = sc.nextInt();
        for (int numTest = 0; numTest < numTests; numTest++) {
            int startNum = sc.nextInt();
            final String answer = solve(startNum);
            System.out.format("Case #%d: %s%n", numTest + 1, answer);
        }
    }

    private static String solve(int startNum) {
        final String answer;
        if (startNum == 0) {
            answer = "INSOMNIA";
        } else {
            answer = computeLastNumber(startNum);
        }
        return answer;
    }

    private static String computeLastNumber(int startNum) {
        Set<Integer> seenDigits = new HashSet<>();
        long currNum = startNum;
        updateSeenDigits(seenDigits, currNum);
        while (seenDigits.size() < 10) {
            currNum = currNum + startNum;
            updateSeenDigits(seenDigits, currNum);
        }
        return String.valueOf(currNum);
    }

    private static void updateSeenDigits(Set<Integer> seenDigits, long currNum) {
        seenDigits.addAll(toDigits(currNum));
        //System.out.println("\t" + currNum);
    }

    private static Set<Integer> toDigits(long currNum) {
        Set<Integer> digits = new HashSet<>();
        while (currNum > 0) {
            digits.add((int) (currNum % 10));
            currNum /= 10;
        }
        return digits;
    }
}
