package codejam.two.zero.one.seven.qualification;

import java.util.List;
import java.util.Scanner;
import java.util.stream.Collectors;

import com.google.common.primitives.Chars;

public class TidyNumbers {
    public static void main(String[] args) {
        try (Scanner sc = new Scanner(System.in)) {
            int numTests = sc.nextInt();
            for (int numTest = 0; numTest < numTests; numTest++) {
                String number = sc.next();
                sc.nextLine();
                List<Integer> numberAsIntList = Chars.asList(number.toCharArray()).stream()
                        .map(c -> Character.digit(c, 10))
                        .collect(Collectors.toList());
                System.out.println("Case #" + (numTest + 1) + ": " + solve(numberAsIntList));
            }
        }
    }

    private static String solve(List<Integer> number) {
        int firstNonTidy = -1;
        // check if tidy already
        for (int i = 1; i < number.size(); i++) {
            if (number.get(i) < number.get(i-1)) {
                firstNonTidy = i;
                break;
            }
        }
        if (firstNonTidy < 0) {
            return join(number);
        }

        int indexToDecrement = 0;
        for (int i = firstNonTidy - 1; i > 0; i--) {
            if (number.get(i) > number.get(i-1)) {
                indexToDecrement = i;
                break;
            }
        }

        number.set(indexToDecrement, number.get(indexToDecrement) - 1);
        for (int i = indexToDecrement + 1; i < number.size(); i++) {
            number.set(i, 9);
        }
        return join(number);
    }

    private static String join(List<Integer> number) {
        int firstNonZeroIndex = 0;
        if (number.size() > 1 && number.get(0) == 0) {
            firstNonZeroIndex = 1;
        }
        char[] joined = new char[number.size() - firstNonZeroIndex];
        int joinedIndex = 0;
        for (int i = firstNonZeroIndex; i < number.size(); i++) {
            joined[joinedIndex++] = Character.forDigit(number.get(i), 10);
        }
        return new String(joined);
    }
}
