package RoundOneA;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.List;
import java.util.Scanner;

import com.google.common.collect.Iterables;
import com.google.common.collect.Lists;

public class One {
    public static void main(String[] args) throws FileNotFoundException {
        try (Scanner sc = new Scanner(new File("small.in"))) {
            int numTests = sc.nextInt();
            for (int i = 0; i < numTests; i++) {
                int numIntervals = sc.nextInt();
                List<Integer> numShrooms = Lists.newArrayList();
                for (int j = 0; j < numIntervals; j++) {
                    numShrooms.add(sc.nextInt());
                }
                System.out.print(String.format("Case #%s: ", i + 1));
                solve(numShrooms);
            }
        }
    }

    private static void solve(List<Integer> numShrooms) {
        int anyNumber = solveAnyNumber(numShrooms);
        int constantNumber = solveConstant(numShrooms);
        System.out.println(String.format("%s %s", anyNumber, constantNumber));
    }

    private static int solveAnyNumber(List<Integer> numShrooms) {
        int totalShroomsEaten = 0;
        int prevShrooms = numShrooms.iterator().next();
        for (int currShrooms : Iterables.skip(numShrooms, 1)) {
            if (currShrooms < prevShrooms) {
                totalShroomsEaten += prevShrooms - currShrooms;
            }
            prevShrooms = currShrooms;
        }
        return totalShroomsEaten;
    }

    private static int solveConstant(List<Integer> numShrooms) {
        int maxShroomsPerInterval = 0;
        int prevShrooms = numShrooms.iterator().next();
        for (int currShrooms : Iterables.skip(numShrooms, 1)) {
            if (currShrooms < prevShrooms) {
                int currShroomsPerInterval = prevShrooms - currShrooms;
                if (currShroomsPerInterval > maxShroomsPerInterval) {
                    maxShroomsPerInterval = currShroomsPerInterval;
                }
            }
            prevShrooms = currShrooms;
        }
        int totalEaten = 0;
        for (int i = 0; i < numShrooms.size() - 1; i++) {
            int currNumShrooms = numShrooms.get(i);
            totalEaten += Math.min(maxShroomsPerInterval, currNumShrooms);
        }
        return totalEaten;
    }
}
