package google.code.jam.oneB;

import java.io.IOException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.SortedMap;
import java.util.TreeMap;

public class GettingTheDigits {
    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(System.in);
        int numTests = sc.nextInt();
        // Eat newline
        sc.nextLine();
        for (int numTest = 0; numTest < numTests; numTest++) {
            String s = sc.nextLine();
            String answer = solve(s);
            System.out.format("Case #%d: %s%n", numTest + 1, answer);
        }
    }

    private static String solve(String s) {
        SortedMap<Integer, Integer> numbers = new TreeMap<>();

        Map<Character, Integer> characterCounts = new HashMap<>();
        // Don't need contains check with this
        for (char c : "ZEROONETWOTHREEFOURFIVESIXSEVENEIGHTNINE".toCharArray()) {
            characterCounts.put(c, 0);
        }
        for (char c : s.toCharArray()) {
            characterCounts.put(c, characterCounts.get(c) + 1);
        }

        int numZeros = characterCounts.get('Z');
        numbers.put(0, numZeros);
        updateCounts(characterCounts, "ZERO", numZeros);
        int numTwos = characterCounts.get('W');
        numbers.put(2, numTwos);
        updateCounts(characterCounts, "TWO", numTwos);
        int numFours = characterCounts.get('U');
        numbers.put(4, numFours);
        updateCounts(characterCounts, "FOUR", numFours);
        int numSixes = characterCounts.get('X');
        numbers.put(6, numSixes);
        updateCounts(characterCounts, "SIX", numSixes);
        int numEights = characterCounts.get('G');
        numbers.put(8, numEights);
        updateCounts(characterCounts, "EIGHT", numEights);

        int numOnes = characterCounts.get('O');
        numbers.put(1, numOnes);
        updateCounts(characterCounts, "ONE", numOnes);
        int numThrees = characterCounts.get('T');
        numbers.put(3, numThrees);
        updateCounts(characterCounts, "THREE", numThrees);
        int numFives = characterCounts.get('F');
        numbers.put(5, numFives);
        updateCounts(characterCounts, "FIVE", numFives);
        int numSevens = characterCounts.get('S');
        numbers.put(7, numSevens);
        updateCounts(characterCounts, "SEVEN", numSevens);

        int numNines = characterCounts.get('I');
        numbers.put(9, numNines);

        StringBuilder answer = new StringBuilder();
        for (Map.Entry<Integer, Integer> entry : numbers.entrySet()) {
            if (entry.getValue() > 0) {
                answer.append(new String(new char[entry.getValue()]).replace("\0", entry.getKey().toString()));
            }
        }
        return answer.toString();
    }

    private static void updateCounts(Map<Character, Integer> characterCounts,
                                     String numberAsString,
                                     int numOccurrences) {
        if (numOccurrences == 0) {
            return;
        }
        for (char c : numberAsString.toCharArray()) {
            characterCounts.put(c, characterCounts.get(c) - numOccurrences);
        }
    }
}
