import java.util.Scanner;
import java.math.BigInteger;

public class CandySplitting {

  static int findMax(int col[], int numArr[], int N) {
    BigInteger curr = BigInteger.ONE.shiftLeft(N);
    curr = curr.subtract(new BigInteger("2"));
    int currSubset[] = new int[N];

    for (; curr.compareTo(BigInteger.ZERO) > 0; curr = curr.subtract(BigInteger.ONE)) {
      int subCol[] = new int[20];
      int size = 0;
      int flag = 0;

      for (int i = 0; i < N; i++) {
        if (curr.testBit(i)) {
          for (int j = 0; j < 20; j++) {
            if ((numArr[i] & (1 << j)) != 0) {
              subCol[j]++;
            }
          }
          currSubset[size++] = numArr[i];
        }
      }

      for (int i = 0; i < 20; i++) {
        if (((subCol[i] % 2) == 1) && (subCol[i]*2 != col[i])) {
          flag = 1;
          break;
        }
      }

      if (flag == 0) {
        int sum = 0;
        for (int i = 0; i < size; i++) {
          sum += currSubset[i];
        }

        return sum;
      }
    }

    return 0;
  }

  public static void main(String[] args) {
    String out = "";
    Scanner sc = new Scanner(System.in);

    int T = sc.nextInt();
    
    for (int numTest = 1; numTest <= T; numTest++) {
      int N = sc.nextInt();
      int col[] = new int[20];
      int numArr[] = new int[N];
      int flag = 0;

      for (int i = 0; i < N; i++) {
        int curr = sc.nextInt(); 
        numArr[i] = curr;

        for (int j = 0; j < 20; j++) {
          if ((curr & (1 << j)) != 0)
            col[j]++;
        }
      }
      
      for (int i = 0; i < 20; i++) {
        if ((col[i] % 2) != 0)
          flag = 1;
      }

      if (flag == 1)
        out += "Case #" + numTest + ": NO\n";
      else {
        out += "Case #" + numTest +": " + findMax(col, numArr, N) + "\n";
      }
    }

    System.out.print(out);
  }
}
