import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class B_gdc {

    public static void main(String args[]) {
        B_gdc bgdc = new B_gdc();
        bgdc.solve(System.in, System.out);
    }

    public void solve(InputStream in, OutputStream out) {
        InputReader inputReader = new InputReader(in);
        PrintWriter writer = new PrintWriter(new BufferedOutputStream(out));

        int t = inputReader.nextInt();
        for (int i = 0; i < t; i++) {
            String input = inputReader.next();
            writer.println("Case #" + (i + 1) + ": " + solve(input));
        }

        writer.close();
    }

    public int solve(String input) {
        int n = input.length();
        boolean pancakes[] = new boolean[n];
        for (int i = 0; i < n; i++) {
            pancakes[i] = input.charAt(i) == '+';
        }

        boolean invert = true;
        int ans = 0;
        int j = n - 1;
        while (j >= 0) {
            if (pancakes[j] ^ invert) {
                ans++;
                invert = !invert;
            }
            j--;
        }

        return ans;
    }

    private static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }
    }
}
