import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class A {

    public static void main(String args[]) {
        A a = new A();
        a.solve(System.in, System.out);
    }

    public void solve(InputStream in, OutputStream out) {
        InputReader inputReader = new InputReader(in);
        PrintWriter writer = new PrintWriter(new BufferedOutputStream(out));

        int t = inputReader.nextInt();
        for (int i = 0; i < t; i++) {
            long testCase = inputReader.nextLong();
            long result = solve(testCase);
            String output;
            if (result == -1) {
                output = "INSOMNIA";
            } else {
                output = Long.toString(result);
            }
            writer.println("Case #" + (i + 1) + ": " + output);
        }

        writer.close();
    }

    public long solve(long n) {
        boolean digits[] = new boolean[10];
        for (long i = 1; i < 100; i++) {
            long m =  n * i;
            String digit = Long.toString(m);
            fillDigits(digits, digit);

            boolean allDigits = true;
            for (int j = 0; j < 10; j++) {
                if (!digits[j]) {
                    allDigits = false;
                }
            }
            if (allDigits) {
                return m;
            }
        }
        return -1;
    }

    private void fillDigits(boolean[] digits, String digit) {
        for (int i = 0; i < digit.length(); i++) {
            int d = digit.charAt(i) - '0';
            digits[d] = true;
        }
    }

    private static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream), 32768);
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

        public long nextLong() {
            return Long.parseLong(next());
        }
    }
}
