import java.util.*;

public class B {
  private static void print  (String p) { System.out.print(p);   }
  private static void println(String p) { System.out.println(p); }
  
  static int[] points, counts;
  static Vector<Double> bunchPoints, bunchTimes;
  
  private static void addBunch(int a, int b, int d) {
    
    int tot = 0;
    int vtot = 0;
    for (int i = a; i <= b; i++) {
      tot += counts[i] * points[i];
      vtot += counts[i];
    }
    
    double av = (double)tot/(double)vtot;
    
    double low  = av - (d*(vtot-1))/2;
    //println(av+"   "+low);
    
    double maxL = 0;
    double maxR = 0;
    int used = 0;
    for (int i = a; i <= b; i++) {
      if (Math.abs(points[i] - (low + used*d))  >  maxL) maxL = Math.abs(points[i] - (low + used*d));
      //print(Math.abs(points[i] - (low + used*d)) + "   " );
      used += counts[i] - 1;
      if (Math.abs(points[i] - (low + used*d))  >  maxR) maxR = Math.abs(points[i] - (low + used*d));
      //println(""+Math.abs(points[i] - (low + used*d)) );
      used++;
    }
    
    double maxAv = (maxL + maxR) / 2.0;
    av += (maxL - maxAv);
    
    bunchPoints.add(av);
    bunchTimes.add(maxAv);
    
  }
  
  
  public static void main(String[] args) {
    Scanner in = new Scanner(System.in);
    
    int P = in.nextInt();
    in.nextLine();
    
    for (int p = 1; p <= P; p++) {
      
      int c = in.nextInt();
      int d = in.nextInt();
      
      points = new int[c];
      counts = new int[c];
      
      bunchPoints = new Vector<Double>();
      bunchTimes  = new Vector<Double>();

      for (int i = 0; i < c; i++) {
        points[i] = in.nextInt();
        counts[i] = in.nextInt();
      }
      
      int lasti = 0;
      for (int i = 1; i < c; i++) {
        if (points[i] - points[i-1]  >  d) {
          addBunch(lasti, i-1, d);
          lasti = i;
        }
      }
      addBunch(lasti, c-1, d);
      
      double tot = bunchTimes.get(0);
      for (int i = 1; i < bunchPoints.size(); i++) {
        tot += Math.max(0, (bunchPoints.get(i) - bunchPoints.get(i-1)) - (bunchPoints.get(i-1) + d + bunchPoints.get(i)) );
        tot += bunchTimes.get(i);
      }
      
      System.out.printf("Case #%d: %.10f\n", p, tot);
    }
    
  }
}