package _2016;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class JamCoins {
	private static boolean[] isnotprime = new boolean[(int) Math.sqrt(Math.pow(2, 32))];
	
	public static void main(String[] args) throws FileNotFoundException {
		Scanner sc = new Scanner(new File("C-large.in"));
		
		generatePrime();
		
		int T = sc.nextInt();
		for (int i=0; i<T; i++) {
			int N = sc.nextInt();
			int J = sc.nextInt();
			
			long[][] results = new long[J][12];
			int count = J;
			
			for (long j=(long) (Math.pow(2, N-1)+1); j<Math.pow(2, N) && count>0; j+=2) {
				boolean foundprime = false;
				long[] interpretations = new long[12];
				long[] divisors = new long[12];

				interpretations[2] = j;
				divisors[2] = isPrime(j);
				
				if (j % 2 > 0 && divisors[2] > 0) {
					for (int base=3; base<=10; base++) {
						long ib = interpret(j, base);
						long divisor = isPrime(ib);
						if (divisor < 0) {
							foundprime = true;
							break;
						}
						
						interpretations[base] = ib;
						divisors[base] = divisor;
					}
					
					if (foundprime) {
						continue;
					}
					
					count--;
					divisors[11] = j;
					results[count] = divisors;
				}
			}
			
			System.out.println("Case #" + (i+1) + ":");
			for (int j=0; j<J; j++) {
				StringBuilder sb = new StringBuilder();
				sb.append(Long.toBinaryString(results[j][11]));
				for (int k=2; k<=10; k++) {
					sb.append(" " + results[j][k]);
				}
				
				System.out.println(sb.toString());
			}
		}
	}
	
	private static void generatePrime() {
		isnotprime[0] = true;
		isnotprime[1] = true;
		
		for (int i=2; i<isnotprime.length; i++) {
			if (i==2 || (i % 2 > 0 && !isnotprime[i])) {
				for (int j=i*2; j<isnotprime.length; j+=i) {
					isnotprime[j] = true;
				}
			}
		}
	}
	
	private static long isPrime(long number) {
		long result = -1;
		
		//if (number >= isnotprime.length) {
			for (int i=0; i<isnotprime.length; i++) {
				if (!isnotprime[i] && number > i && (number % i) == 0) {
					return i;
				}
			}
		//} else {
		//	result = !isnotprime[(int) number];
		//}
		
		return result;
	}
	
	private static long interpret(long base2, int base) {
		long ret = 0;
		char[] chs = Long.toBinaryString(base2).toCharArray();
		for (int i=chs.length-1, j=0; i>=0; i--, j++) {
			ret += Character.getNumericValue(chs[i]) * Math.pow(base, j);
		}
	    return ret;
	}
}
