package google.codeJam.year2011;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;

public class BotTrust {

	public static void main(String[] args) {
		File inFile = null;
		File outFile = null;
		BufferedReader input = null;
		BufferedWriter output = null;

		String filePath = "files/2011/BotTrust/";
		try {
			inFile = new File(filePath+"A-small-attempt0.in");
			outFile = new File(filePath+"A-small-attempt0.out");
			input = new BufferedReader(new FileReader(inFile));
			output = new BufferedWriter(new FileWriter(outFile));

			int cases = Integer.parseInt(input.readLine());
			System.out.println("Total Cases = " + cases);

			for (int caseIdx = 1; caseIdx <= cases; caseIdx++) {
				String[] temp = input.readLine().split(" ");
				int numOfButtons = Integer.parseInt(temp[0]);
				String[] robot_color = new String[numOfButtons];
				int idx = 0;
				ArrayList<Integer> blueArray = new ArrayList<Integer>();
				ArrayList<Integer> orangeArray = new ArrayList<Integer>();
				while (idx < numOfButtons) {
					robot_color[idx] = temp[1+idx*2];
					if (robot_color[idx].equals("B")) blueArray.add(Integer.parseInt(temp[1+idx*2+1]));
					else orangeArray.add(Integer.parseInt(temp[1+idx*2+1]));
					idx++;
				}

				int[] blue_moves = new int[blueArray.size()];
				int[] orange_moves = new int[orangeArray.size()];
				for (int i = 0; i < blueArray.size(); i++) {
					if (i == 0) blue_moves[i] = blueArray.get(0);
					else blue_moves[i] = blue_moves[i-1] + Math.abs(blueArray.get(i) - blueArray.get(i-1)) + 1;
				}
				for (int i = 0; i < orangeArray.size(); i++) {
					if (i == 0) orange_moves[i] = orangeArray.get(0);
					else orange_moves[i] = orange_moves[i-1] + Math.abs(orangeArray.get(i) - orangeArray.get(i-1)) + 1;
				}

				int total_moves = 0;
				int blueIdx = 0;
				int orangeIdx = 0;
				String last_robot = robot_color[0];
				if (last_robot.equals("O")) total_moves = orange_moves[orangeIdx++];
				else total_moves = blue_moves[blueIdx++];

				for (int i = 1; i < numOfButtons; i++) {
					if (!last_robot.equals(robot_color[i])) {
						last_robot = robot_color[i];

						if (robot_color[i].equals("O")) {
							if (total_moves >= orange_moves[orangeIdx]) {
								int diff = total_moves - orange_moves[orangeIdx];
								for (int j = orangeIdx; j < orange_moves.length; j++) {
									orange_moves[j] += diff + 1;
								}
							}
							total_moves = orange_moves[orangeIdx];
						}
						else {
							if (total_moves >= blue_moves[blueIdx]) {
								int diff = total_moves - blue_moves[blueIdx];
								for (int j = blueIdx; j < blue_moves.length; j++) {
									blue_moves[j] += diff + 1;
								}
							}
							total_moves = blue_moves[blueIdx];
						}
					}
					else {
						if (robot_color[i].equals("O")) {
							total_moves = orange_moves[orangeIdx];
						}
						else {
							total_moves = blue_moves[blueIdx];
						}
					}

					if (robot_color[i].equals("O")) orangeIdx++;
					else blueIdx++;
				}

				System.out.println("Case #"+caseIdx+": "+total_moves);
	    		output.write("Case #"+caseIdx+": "+total_moves+"\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();
	    }
	    finally {
			if (input != null) try { input.close(); } catch (Exception e) { e.printStackTrace(); }
			if (output != null) try { output.close(); } catch (Exception e) { e.printStackTrace(); }
	    }
	}

}
