import java.io.*;
import java.util.*;
import static java.lang.Math.*;

/**
 * @author raymond
 *
 */
public class A {

	public static void main(String[] args) {
		File inFile = null;
		File outFile = null;
		BufferedReader input = null;
		BufferedWriter output = null;

		String filePath = "src/";
		try {
			inFile = new File(filePath+"A-large.in");
			outFile = new File(filePath+"A-large.out");
			input = new BufferedReader(new FileReader(inFile));
			output = new BufferedWriter(new FileWriter(outFile));

			int cases = Integer.parseInt(input.readLine());
			System.out.println("Total Cases = " + cases);

			for (int no = 1; no <= cases; no++) {
				int N = Integer.parseInt(input.readLine());
				//String[] info = input.readLine().split(" ");
				int[][] arr = new int[N][N];
				for (int i=0; i<N; i++) {
					String line = input.readLine();
					for (int j=0; j<N; j++) {
						char ch = line.charAt(j);
						if (ch=='.') arr[i][j]=-1;
						else arr[i][j]=Integer.valueOf(String.valueOf(ch));
					}
				}
/*for (int i=0; i<N; i++) {
	for (int j=0; j<N; j++) { 
		System.out.print(arr[i][j]);
	}
	System.out.print("\n");
}*/
				//RPI = 0.25 * WP + 0.50 * OWP + 0.25 * OOWP
				float[] WP = new float[N];
				for (int i=0; i<N; i++) {
					int cnt = 0;
					int pt = 0;
					for (int j=0; j<N; j++) {
						if (i!=j && arr[i][j]!=-1) {
							cnt++;
							pt+=arr[i][j];
						}
					}
					WP[i] = (float)pt/cnt;
					//System.out.println("WP["+i+"]="+WP[i]);
				}
				float[] OWP = new float[N];
				for (int i=0; i<N; i++) {
					int cnt = 0;
					float wp = 0;
					for (int j=0; j<N; j++) {
						if (i!=j && arr[i][j]!=-1) {
							cnt++;
							int t_cnt = 0;
							int t_pt = 0;
							for (int k=0; k<N; k++) {
								if (k!=i && arr[j][k]!=-1) {
									t_cnt++;
									t_pt+=arr[j][k];
								}
							}
							wp += (float)t_pt/t_cnt;
						}
					}
					OWP[i] = wp/cnt;
					//System.out.println("OWP["+i+"]="+OWP[i]);
				}
				float[] OOWP = new float[N];
				for (int i=0; i<N; i++) {
					int cnt = 0;
					float owp = 0;
					for (int j=0; j<N; j++) {
						if (i!=j && arr[i][j]!=-1) {
							owp += OWP[j];
							cnt++;
						}
					}
					OOWP[i] = owp/cnt;
					//System.out.println("OOWP["+i+"]="+OOWP[i]);
				}
				double[] RPI = new double[N];
				for (int i=0; i<N; i++) {
					RPI[i] = 0.25*WP[i] + 0.5*OWP[i] + 0.25*OOWP[i];
				}

				System.out.println("Case #"+no+":");
				output.write("Case #"+no+":"+"\n");
				for (int i=0; i<N; i++) {
					System.out.println(String.valueOf(RPI[i]));
					output.write(String.valueOf(RPI[i])+"\n");
				}
				
			}
		}
		catch (Exception e) {
			e.printStackTrace();
	    }
	    finally {
			if (input != null) try { input.close(); } catch (Exception e) { e.printStackTrace(); }
			if (output != null) try { output.close(); } catch (Exception e) { e.printStackTrace(); }
	    }
	}

}
