package google.codeJam.year2013;

import java.io.*;
import java.util.HashMap;

/**
 * Created with IntelliJ IDEA.
 * User: Raymond
 * Date: 4/12/13
 * Time: 6:33 PM
 * To change this template use File | Settings | File Templates.
 */
public class TicTacToeTomek {

	public static void main(String[] args) {
		BufferedReader input = null;
		BufferedWriter output = null;

		String filePath = "files/2013/TicTacToeTomek/";
		String fileName = "A-large";
		try {
			File inFile = new File(filePath + fileName + ".in");
			File outFile = new File(filePath + fileName + ".txt");
			input = new BufferedReader(new FileReader(inFile));
			output = new BufferedWriter(new FileWriter(outFile));

			int cases = Integer.parseInt(input.readLine());
			System.out.println("Total Cases = " + cases);

			for (int caseIdx = 1; caseIdx <= cases; caseIdx++) {
				char[][] matrix = new char[4][4];
				String line;
				for (int i=0 ; i<4; i++)
				{
					line = input.readLine();
					for (int j=0; j<4; j++)
					{
						matrix[i][j] = line.charAt(j);
					}
				}
				input.readLine();

				int status = checkDiagonal(matrix);
				if (status <= 0) status = checkOthers(matrix);

				String show;
				switch (status) {
					case 1:
						show = "X won";
						break;
					case 2:
						show = "O won";
						break;
					case -1:
						show = "Game has not completed";
						break;
					default:
						show = "Draw";
						break;
				}
				System.out.println("Case #"+caseIdx+": "+show);
				output.write("Case #"+caseIdx+": "+show+"\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();
		}
		finally {
			if (input != null) try { input.close(); } catch (Exception e) { e.printStackTrace(); }
			if (output != null) try { output.close(); } catch (Exception e) { e.printStackTrace(); }
		}
	}

	private static int checkDiagonal(char[][] matrix)
	{
		int status = 0;
		//  check \
		char c = matrix[0][0];
		if (c == 'X')
		{
			if ((matrix[1][1] == 'X' || matrix[1][1] == 'T') && (matrix[2][2] == 'X' || matrix[2][2] == 'T') && (matrix[3][3] == 'X' || matrix[3][3] == 'T')) status = 1;
		}
		else if (c == 'O')
		{
			if ((matrix[1][1] == 'O' || matrix[1][1] == 'T') && (matrix[2][2] == 'O' || matrix[2][2] == 'T') && (matrix[3][3] == 'O' || matrix[3][3] == 'T')) status = 2;
		}
		else if (c == 'T')
		{
			if (matrix[1][1] == 'X' && matrix[2][2] == 'X' && matrix[3][3] == 'X') status = 1;
			else if (matrix[1][1] == 'O' && matrix[2][2] == 'O' && matrix[3][3] == 'O') status = 2;
		}
		if (status != 0) return status;
		c = matrix[3][0];
		if (c == 'X')
		{
			if ((matrix[2][1] == 'X' || matrix[2][1] == 'T') && (matrix[1][2] == 'X' || matrix[1][2] == 'T') && (matrix[0][3] == 'X' || matrix[0][3] == 'T')) status = 1;
		}
		else if (c == 'O')
		{
			if ((matrix[2][1] == 'O' || matrix[2][1] == 'T') && (matrix[1][2] == 'O' || matrix[1][2] == 'T') && (matrix[0][3] == 'O' || matrix[0][3] == 'T')) status = 2;
		}
		else if (c == 'T')
		{
			if (matrix[2][1] == 'X' && matrix[1][2] == 'X' && matrix[0][3] == 'X') status = 1;
			else if (matrix[2][1] == 'O' && matrix[1][2] == 'O' && matrix[0][3] == 'O') status = 2;
		}
		return status;
	}

	private static int checkOthers(char[][] matrix)
	{
		int status = 0;
		boolean bDone = true;
		//boolean bDraw = false;
		//row
		for (int i=0; i<4; i++)
		{
			char c = matrix[i][0];
			if (c == 'X')
			{
				if ((matrix[i][1] == 'X' || matrix[i][1] == 'T') && (matrix[i][2] == 'X' || matrix[i][2] == 'T') && (matrix[i][3] == 'X' || matrix[i][3] == 'T')) status = 1;
				else if (matrix[i][1] == '.' || matrix[i][2] == '.' || matrix[i][3] == '.') bDone = false;
			}
			else if (c == 'O')
			{
				if ((matrix[i][1] == 'O' || matrix[i][1] == 'T') && (matrix[i][2] == 'O' || matrix[i][2] == 'T') && (matrix[i][3] == 'O' || matrix[i][3] == 'T')) status = 2;
				else if (matrix[i][1] == '.' || matrix[i][2] == '.' || matrix[i][3] == '.') bDone = false;
			}
			else if (c == 'T')
			{
				if (matrix[i][1] == 'X' && matrix[i][2] == 'X' && matrix[i][3] == 'X') status = 1;
				else if (matrix[i][1] == 'O' && matrix[i][2] == 'O' && matrix[i][3] == 'O') status = 2;
				else if (matrix[i][1] == '.' || matrix[i][2] == '.' || matrix[i][3] == '.') bDone = false;
			}
			else
			{
				//if (matrix[i][1] == '.' && matrix[i][2] == '.' && matrix[i][3] == '.') bDone = true;
				bDone = false;
			}
			if (status > 0) return status;
		}
		for (int j=0; j<4; j++)
		{
			char c = matrix[0][j];
			if (c == 'X')
			{
				if ((matrix[1][j] == 'X' || matrix[1][j] == 'T') && (matrix[2][j] == 'X' || matrix[2][j] == 'T') && (matrix[3][j] == 'X' || matrix[3][j] == 'T')) status = 1;
				else if (matrix[1][j] == '.' || matrix[2][j] == '.' || matrix[3][j] == '.') bDone = false;
			}
			else if (c == 'O')
			{
				if ((matrix[1][j] == 'O' || matrix[1][j] == 'T') && (matrix[2][j] == 'O' || matrix[2][j] == 'T') && (matrix[3][j] == 'O' || matrix[3][j] == 'T')) status = 2;
				else if (matrix[1][j] == '.' || matrix[2][j] == '.' || matrix[3][j] == '.') bDone = false;
			}
			else if (c == 'T')
			{
				if (matrix[1][j] == 'X' && matrix[2][j] == 'X' && matrix[3][j] == 'X') status = 1;
				else if (matrix[1][j] == 'O' && matrix[2][j] == 'O' && matrix[3][j] == 'O') status = 2;
				else if (matrix[1][j] == '.' || matrix[2][j] == '.' || matrix[3][j] == '.') bDone = false;
			}
			else
			{
				//if (matrix[1][j] == '.' && matrix[2][j] == '.' && matrix[3][j] == '.') bDraw = true;
				bDone = false;
			}
			if (status > 0) return status;
		}
		if (!bDone) status = -1;
		return status;
	}
}
