package google.codeJam.year2011;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;

/**
 * @author Raymond
 *
 */
public class CandySplitting {

	public static void main(String[] args) {
		File inFile = null;
		File outFile = null;
		BufferedReader input = null;
		BufferedWriter output = null;

		String filePath = "files/2011/CandySplitting/";
		try {
			inFile = new File(filePath+"C-small-attempt0.in");
			outFile = new File(filePath+"C-small-attempt0.out");
			input = new BufferedReader(new FileReader(inFile));
			output = new BufferedWriter(new FileWriter(outFile));

			int cases = Integer.parseInt(input.readLine());
			System.out.println("Total Cases = " + cases);

			for (int numOfCase = 1; numOfCase <= cases; numOfCase++) {
				int numOfCandies = Integer.parseInt(input.readLine());
				String[] info = input.readLine().split(" ");
				int total_val = 0;
				int total_xor = 0;
				ArrayList<Integer> al = new ArrayList<Integer>();
				for (int i = 0; i < numOfCandies; i ++) {
					int candy = Integer.parseInt(info[i]);
					al.add(candy);
					total_val += candy;
					total_xor ^= candy;
				}
				Collections.sort(al);
				int pat_xor = 0;
				int i = 0;
				int sean_val = total_val;
				boolean found = false;
				do {
					int candy = al.get(i);
					sean_val -= candy;
					pat_xor ^= candy;
					total_xor ^= candy;
					if (pat_xor == total_xor) {
						found = true;
						break;
					}
					i++;
				} while (i < numOfCandies-1);

				System.out.println("Case #"+numOfCase+": "+(found?sean_val:"NO"));
	    		output.write("Case #"+numOfCase+": "+(found?sean_val:"NO")+"\n");
			}
		}
		catch (Exception e) {
			e.printStackTrace();
	    }
	    finally {
			if (input != null) try { input.close(); } catch (Exception e) { e.printStackTrace(); }
			if (output != null) try { output.close(); } catch (Exception e) { e.printStackTrace(); }
	    }
	}

}
