import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class Puncakes {

	public static int numCase = 0;
	public static Scanner in;

	private static void solve() {
		int numOfDiners = in.nextInt();
		in.nextLine();

		List<Integer> pancakes = new ArrayList<Integer>();
		List<Integer> trash = new ArrayList<Integer>();
		for (int i = 0; i < numOfDiners; i++) {
			Integer num = in.nextInt();
			if (num < 4) {
				trash.add(num);
			} else {
				pancakes.add(num);
			}
		}
		in.nextLine();

		Collections.sort(pancakes);
		int numOfMoves = getMoves(pancakes, trash);

		String result = numOfMoves + "";

		printTestCase(result);
	}

	private static int getMoves(List<Integer> pancakes, List<Integer> trash) {
		if (pancakes.size() == 0) {
			return trash.isEmpty() ? 0 : trash.contains(3) ? 3 : trash.contains(2) ? 2 : 1;
		}
		List<Integer> copy = new ArrayList<Integer>(pancakes);
		List<Integer> cTrash = new ArrayList<Integer>(trash);
		int great = pancakes.remove(pancakes.size() - 1);
		int num = (int) Math.round(Math.sqrt(great));
		for (int i = 1; i <= num; i++) {
			int part = great / num;
			if (i == num) {
				part += great % num;
			}
			if (part < 4) {
				trash.add(part);
			} else {
				pancakes.add(part);
			}
		}
		Collections.sort(pancakes);
		int result = Math.min(great, getMoves(pancakes, trash) + num - 1);

		List<Integer> list = new ArrayList<Integer>();
		while (!copy.isEmpty()) {
			num = copy.remove(0);
			num--;
			if (num < 4) {
				cTrash.add(num);
			} else {
				list.add(num);
			}
		}

		result = Math.min(result, getMoves(list, cTrash) + 1);
		return result;
	}

	private static int getMovesB(List<Integer> pancakes) {
		List<Integer> copy = new ArrayList<Integer>(pancakes);
		int first = copy.remove(pancakes.size() - 1);
		if (first == 1) {
			return 1;
		}
		int result = Integer.MAX_VALUE;
		for (int i = 1; i <= first / 2; i++) {
			copy = new ArrayList<Integer>(pancakes);
			copy.remove(pancakes.size() - 1);
			copy.add(i);
			copy.add(first - i);
			Collections.sort(copy);
			result = Math.min(result, Math.min(first, getMovesB(copy) + 1));
		}
		return result;
	}

	private static void printTestCase(final String result) {
		System.out.println("Case #" + numCase + ": " + result);
	}

	public static void main(final String[] args) {
		try (FileInputStream input = new FileInputStream("in.txt")) {
			System.setIn(input);
			System.setOut(new PrintStream(new FileOutputStream("out.txt")));
			in = new Scanner(System.in);
			int numCases = in.nextInt();
			in.nextLine();
			for (numCase = 1; numCase <= numCases; numCase++) {
				solve();
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}