import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class C {

    public static int numCase = 0;
    public static Scanner in;

    private static boolean[] numFactors = new boolean[1000];
    private static List<BigInteger> primes = new ArrayList<>();

    static {
        for (int i = 2; i < numFactors.length; i++) {
            if (!numFactors[i]) {
                primes.add(new BigInteger(i + ""));
                for (int j = 2 * i; j < numFactors.length; j += i) {
                    numFactors[j] = true;
                }
            }
        }
        //        System.err.println(primes);
    }

    private static void solve() {
        int N = in.nextInt();
        int J = in.nextInt();

        boolean[] base = new boolean[N - 2];

        List<Coin> coins = new LinkedList<>();
        while (coins.size() < J) {
            int[] factors = new int[9];
            BigInteger num = BigInteger.ZERO;
            for (int i = 2; i < 11; i += 1) {
                StringBuilder sb = new StringBuilder("1");
                for (int j = N - 3; j >= 0; j--) {
                    boolean b = base[j];
                    if (b) {
                        sb.append("1");
                    } else {
                        sb.append("0");
                    }
                }
                sb.append("1");
                num = new BigInteger(sb.toString(), i);
                for (BigInteger prime : primes) {
                    if (prime.compareTo(num) >= 0) {
                        break;
                    }
                    if (num.mod(prime).compareTo(BigInteger.ZERO) == 0) {
                        factors[i - 2] = prime.intValue();
                        break;
                    }
                }
                if (factors[i - 2] == 0) {
                    break;
                }
            }
            if (factors[8] > 0) {
                coins.add(new Coin(num, factors));
            }

            boolean hasNext = addOne(base);
            if (!hasNext) {
                System.err.println("ERROR");
                System.exit(1);
            }
        }

        StringBuilder b = new StringBuilder();
        for (Coin c : coins) {
            b.append(c);
        }

        printTestCase(b.toString());
    }

    private static boolean addOne(boolean[] base) {
        boolean hasNext = false;
        for (int i = 0; i < base.length; i++) {
            if (!base[i]) {
                base[i] = true;
                for (int j = i - 1; j >= 0; j--) {
                    base[j] = false;
                }
                hasNext = true;
                break;
            }
        }
        return hasNext;
    }

    private static void printTestCase(final String result) {
        System.err.println("Case #" + numCase + ": " + result);
        System.out.println("Case #" + numCase + ": " + result);
    }

    public static void main(final String[] args) {
        try (FileInputStream input = new FileInputStream("in.txt")) {
            System.setIn(input);
            System.setOut(new PrintStream(new FileOutputStream("out.txt")));
            in = new Scanner(System.in);
            int numCases = in.nextInt();
            in.nextLine();
            for (numCase = 1; numCase <= numCases; numCase++) {
                solve();
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static class Coin {
        BigInteger value;
        int[] factors;

        public Coin(BigInteger value, int[] factors) {
            this.value = value;
            this.factors = factors;
        }

        @Override
        public String toString() {
            StringBuilder b = new StringBuilder("\n" + value + " ");
            boolean first = true;
            for (int f : factors) {
                if (first) {
                    first = false;
                } else {
                    b.append(" ");
                }
                b.append(f);
            }
            return b.toString();
        }
    }
}