package codejam.three;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Scanner;

public class TicTacToe {
	public enum State {
		X_WON,
		O_WON,
		DRAW,
		NOT_COMPLITED;
	}
	
	public static void main(String[] args) throws Exception {
		Scanner scanner = new Scanner(new File("C:\\temp\\codejam\\A-small-attempt0.in"));
		FileOutputStream stream = new FileOutputStream(new File("C:\\temp\\codejam\\A-small-attempt0.out"));
		int cases = scanner.nextInt();
		scanner.nextLine();
		for (int i = 0; i < cases; i++) {
			String result = solveCase(scanner);
			stream.write(new String("Case #" + (i+1) + ": " + result + "\r\n").getBytes());
			System.out.println("now in: " + i);
		}
	}
	
	
	private static String solveCase(Scanner scanner) {
		char[][] board = new char[4][4];
		for (int i = 0; i < 4; i++) {
			 char[] line = scanner.nextLine().toCharArray();
			for (int j = 0; j < 4; j++) {
				board[i][j] = line[j];
			}	
		}
		scanner.nextLine();
		switch (checkBoard(board)) {
		case X_WON:
			return "X won";
		case O_WON:
			return "O won";
		case DRAW:
			return "Draw";
		case NOT_COMPLITED:
			return "Game has not completed";
		default:
			break;
		};
		return "";
	}

	private static State checkBoard(char[][] board) {
		State state = checkCase(board[0][0], board[0][1], board[0][2], board[0][3]);
		if (state == State.X_WON || state == State.O_WON) {
			return state;
		}
		State state2 = checkCase(board[1][0], board[1][1], board[1][2], board[1][3]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[2][0], board[2][1], board[2][2], board[2][3]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[3][0], board[3][1], board[3][2], board[3][3]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[0][0], board[1][0], board[2][0], board[3][0]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[0][1], board[1][1], board[2][1], board[3][1]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[0][2], board[1][2], board[2][2], board[3][2]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[0][3], board[1][3], board[2][3], board[3][3]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[0][0], board[1][1], board[2][2], board[3][3]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		state2 = checkCase(board[0][3], board[1][2], board[2][1], board[3][0]);
		if (state2 == State.X_WON || state2 == State.O_WON) {
			return state2;
		}
		if (state2 == State.NOT_COMPLITED) {
			state = state2;
		}
		return state;
	}

	private static State checkCase(char c1, char c2, char c3, char c4) {
		if ((c1 == 'X' || c1 == 'T') && 
				(c2 == 'X' || c2 == 'T') && 
				(c3 == 'X' || c3 == 'T') && 
				(c4 == 'X' || c4 == 'T')) {
			return State.X_WON;
		}
		if ((c1 == 'O' || c1 == 'T') && 
				(c2 == 'O' || c2 == 'T') && 
				(c3 == 'O' || c3 == 'T') && 
				(c4 == 'O' || c4 == 'T')) {
			return State.O_WON;
		}
		if (c1 == '.' || c2 == '.' || c3 == '.' || c4 == '.') {
			return State.NOT_COMPLITED;
		}
		return State.DRAW;
	}


	public static void testTimes(String[] args) {
		char[][] board = { { 'X', 'X', 'X', 'O' }, { 'X', 'X', 'X', 'O' },
				{ 'X', 'X', 'X', 'O' }, { 'X', 'X', 'X', 'O' } };
		for (int i = 0; i < 1000; i++) {
			System.out.println("now in: " + i);
			checkBoard(board);
		}
	}
	
	


}
