/**
 * 
 */
package rotate;

import java.io.File;
import java.io.FileOutputStream;
import java.math.BigInteger;
import java.util.Scanner;

import com.sun.org.apache.xpath.internal.operations.Bool;

/**
 * @author buga
 *
 */
public class Rotate {
	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		File inputFile = new File("A-small-attempt1.in");
		File outputFile = new File("A-small-attempt1.out");
		FileOutputStream outputStream = new FileOutputStream(outputFile);
		Scanner scanner = new Scanner(inputFile);
		int cases = scanner.nextInt();
		for (int i = 1; i <= cases; i++) {
			String result = handleCase(scanner);
			String strOut = "Case #" + i + ": " + result + "\n";
//			System.out.println(strOut);
			outputStream.write(strOut.getBytes());
		}

	}

	/**
	 * check who win after roratitng the board
	 * @param scanner the scanner to read the input from
	 * @return who win- the red, the blue, both of them or neither
	 */
	private static String handleCase(Scanner scanner) {
		int N = scanner.nextInt();
		int K = scanner.nextInt();
		scanner.nextLine();
		char[][] board = getBoard(scanner, N);
		board = rotate(board);
		Boolean redWin = checkAll(board, 'R', K);
		Boolean blueWin = checkAll(board, 'B', K);
		if (redWin && blueWin) {
			return "Both";
		}
		if (redWin && !blueWin) {
			return "Red";
		}
		if (!redWin && blueWin) {
			return "Blue";
		}
		return "Neither";
	}

	/**
	 * helper method to pring the board
	 */
	private static void printBoard(char[][] board) {
		for (int i = 0; i < board.length; i++) {
			for (int j = 0; j < board.length; j++) {
				System.out.print(board[i][j]);
			}
			System.out.println();
		}
		
	}

	/**
	 * check all the possibles option for winning chac c in the len k
	 */
	private static Boolean checkAll(char[][] board, char c, int k) {
		Boolean win = check(board, c, k, 1, 0);
		if (win) {
			return true;
		}
		win = check(board, c, k, 1, 1);
		if (win) {
			return true;
		}
		win = check(board, c, k, 0, 1);
		if (win) {
			return true;
		}
		return checkDiagonal(board, c, k);
	}

	/**
	 * check if char c have a won in Join-K game in one way (where i and j goes forword.
	 * we check it using dynamic programing
	 */
	private static boolean check(char[][] board, char c, int len, int diffI, int diffJ) {
		int size = board.length;
		int[][] serias = new int[size][size];
		if (diffI != 0) {
			for (int j = size-1; j >= 0; j--) {
				if (board[size-1][j] == c) {
					serias[size-1][j] = 1;
				}
			}
		}
		
		if (diffJ != 0) {
			for (int i = size-1; i >= 0; i--) {
				if (board[i][size-1] == c) {
					serias[i][size-1] = 1;
				}
			}
		}
		
		for (int j = size-1-diffJ; j >= 0; j--) {
			for (int i = size-1-diffI; i >= 0; i--) {
				if (board[i][j] == '.') {
					break;
				}
				if (board[i][j] == c) {
					if (serias[i+diffI][j+diffJ] == len - 1) {
						return true;
					}
					serias[i][j] = 1 + serias[i+diffI][j+diffJ];
				}
			}
		}
		return false;
	}
	

	/**
	 * special checking for the diagonal because it doesnt goes forword.
	 * we check it the same way we check the others
	 */
	private static boolean checkDiagonal(char[][] board, char c, int len) {
		int size = board.length;
		int[][] serias = new int[size][size];
		for (int j = size-1; j >= 0; j--) {
			if (board[size-1][j] == c) {
				serias[size-1][j] = 1;
			}
		}

		for (int i = size-1; i >= 0; i--) {
			if (board[i][0] == c) {
				serias[i][0] = 1;
			}
		}
		
		for (int j = 1; j < size; j++) {
			for (int i = size-2; i >= 0; i--) {
				if (board[i][j] == '.') {
					break;
				}
				if (board[i][j] == c) {
					if (serias[i+1][j-1] == len - 1) {
						return true;
					}
					serias[i][j] = 1 + serias[i+1][j-1];
				}
			}
		}
		return false;
	}

	/**
	 * rotate the board 90 degrees clockwise onto its side
	 */
	private static char[][] rotate(char[][] board) {
		int size = board.length;
		char[][] newBoard = new char[size][size];
		for (int i = 0; i < size; i++) {
			for (int j = 0; j < size; j++) {
				newBoard[i][j] = board[size-j-1][i];
			}
		}
		for (int j = 0; j < size; j++) {
			int diff = 0;
			for (int i = size-1; i >=0 ; i--) {
				char curr = newBoard[i][j];
				if (curr == '.') {
					diff++;
				} else {
					if (diff != 0){
						newBoard[i+diff][j] = newBoard[i][j];
						newBoard[i][j] = '.';
					}
				}
			}
		}
		return newBoard;
		
	}

	/**
	 * scan the board and insert it the 2dim array
	 */
	private static char[][] getBoard(Scanner scanner, int N) {
		char[][] board = new char[N][N];
		for (int i = 0; i < N; i++) {
			String line = scanner.nextLine();
			for (int j = 0; j < N; j++) {
				board[i][j] = line.charAt(j);
			}
		}

		return board;
	}
	
	
}
