/**
 * 
 */
package fair;

import java.io.File;
import java.io.FileOutputStream;
import java.math.BigInteger;
import java.util.Scanner;

import sun.security.util.BigInt;

/**
 * @author buga
 *
 */
public class FairWarning {

	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		File inputFile = new File("B-small-attempt3.in");
		File outputFile = new File("B-small-attempt3.out");
		FileOutputStream outputStream = new FileOutputStream(outputFile);
		Scanner scanner = new Scanner(inputFile);
		int cases = scanner.nextInt();
		for (int i = 1; i <= cases; i++) {
			String result = handleCase(scanner);
			String strOut = "Case #" + i + ": " + result + "\n";
//			System.out.println(strOut);
			outputStream.write(strOut.getBytes());
		}

	}

	/**
	 * Calc the gcd for all the diff between each 2 events and then the result
	 * is the closest number to event that is also a multiply of the gcd (so we
	 * return the (gcd * X - event), and there is no matter with event we choose
	 * couse it's suppose to be the same for all eventsm so for effectiveness we
	 * choose the minimum.
	 * @param scanner the scanner to read the input from
	 * @return the minimum number of slarboseconds until ti + y is a multiple
	 *         of the largest possible integer factor T for all i.
	 */
	private static String handleCase(Scanner scanner) {
		int eventsNumbers = scanner.nextInt();
		BigInteger curr = BigInteger.valueOf(0);
		BigInteger prev = scanner.nextBigInteger();
		BigInteger gcd = BigInteger.valueOf(0);
		BigInteger min = prev;
		
		for (int i = 1; i < eventsNumbers; i++) {
			 curr = scanner.nextBigInteger();
			 BigInteger diff = curr.subtract(prev).abs();
			 gcd = gcd.gcd(diff);
			 // if we have 2 sequential number the won't have common multiply
			 if (gcd.equals(BigInteger.valueOf(1))) {
				 // read the last of the line of there is any
				 if (i + 1< eventsNumbers) {
					 scanner.nextLine();
				 }
				 return "0";
			 }
			 prev = curr;
			 min = min.min(curr);
		}
		//calc the closest number to gcd miltiply
		BigInteger result = gcd.subtract(min.mod(gcd));
		return result.toString();
		
	}
}
