/**
 * 
 */
package theme;

import java.io.File;
import java.io.FileOutputStream;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

/**
 * @author buga
 *
 */
public class ThemePark {
	/**
	 * @param args
	 * @throws Exception 
	 */
	public static void main(String[] args) throws Exception {
		File inputFile = new File("C-small-attempt0.in");
		File outputFile = new File("C-small-attempt0.out");
		FileOutputStream outputStream = new FileOutputStream(outputFile);
		Scanner scanner = new Scanner(inputFile);
		int cases = scanner.nextInt();
		for (int i = 1; i <= cases; i++) {
			Integer result = handleCase(scanner);
			String strOut = "Case #" + i + ": " + result + "\n";
//			System.out.println(strOut);
			outputStream.write(strOut.getBytes());
		}

	}

	/**
	 * @param scanner the scanner to read the input from
	 * @return the number of Euros made by the roller coaster.
	 */
	private static Integer handleCase(Scanner scanner) {
		int round = scanner.nextInt();
		int rollerCap = scanner.nextInt();
		int groups = scanner.nextInt();
		int result = 0;
		Queue<Integer> queue = new LinkedList<Integer>();
		Queue<Integer> ridingQueue = new LinkedList<Integer>();
		for (int i = 0; i < groups; i++) {
			queue.offer(scanner.nextInt());
		}
		
		int currCap;
		for (int i = 0; i < round; i++) {
			currCap = rollerCap;
			Integer next = queue.peek();
			//try to add as much as possible to the ride
			while(next != null && next <= currCap) {
				next = queue.poll();
				result += next;
				currCap -= next;
				ridingQueue.offer(next);
				next = queue.peek();
			}
			
			//end of the ride- return the groups to queue
			while((next = ridingQueue.poll()) != null) {
				queue.offer(next);
			}
		}
		return result;
		
	}
}
