package de.google;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.Iterator;
import java.util.Vector;

public class Universe {

	boolean virgin=true;
	private int runs = 0;
	static int switches = 0;
	int engCount = 0;

	public static void main(String[] args) {
		try {
			new Universe();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	private Vector<Engine> engines;
	private Vector<String> queries;

	private Universe() throws Exception {
		BufferedReader ready = openFile("A-small-attempt5.in");
		StringBuffer result = new StringBuffer();
		for (int i = 1; i <= runs; i++) {
			engines = new Vector<Engine>();
			queries = new Vector<String>();
			switches = 0;
			String line = ready.readLine();

			// engine information
			engCount = Integer.parseInt(line);//
			for (int a = 0; a < engCount; a++) {
				Engine e = new Engine();
				line = ready.readLine();
				e.setName(line);

				// e.setLastOc(e.getLastOc() < i ? i : e.getLastOc());
				engines.add(e);

			}

			// statistics find out if there is one not occuring
			line = ready.readLine();
			int qCount = Integer.parseInt(line);//
			for (int b = 0; b < qCount; b++) {
				line = ready.readLine();
				addQueryCount(line, b);
				queries.add(line);
			}

			result.append("Case #" + i + ": " + (engEmpty()?"0":goahead()) + "\n");
			// System.out.println(i+" "+runs);
		}
		ready.close();
		System.out.println(result.toString());
		writeResult(result);

	}

	private void addQueryCount(String line, int b) {

		for (Iterator<Engine> ir = engines.iterator(); ir.hasNext();) {
			Engine e = ir.next();
			if (e.getName().equals(line)) {
				e.increase();
				if (e.getFirstOc() == -1)
					e.setFirstOc(b);
			}
		}

	}

	@SuppressWarnings("unchecked")
	private String goahead() {

		Collections.sort(engines);
		Engine actual = engines.get(0);

		while (!engEmpty() && !qEmpty()) {
			Engine e = new Engine();
			e.setName(queries.get(0));
			if (!e.equals(actual)) {
				queries.remove(0);
				
				engines.get(engines.indexOf(e)).decrease();
			} else {
				switches++;
				resetFirstOc();
				Collections.sort(engines);
				actual=engines.get(0);
			}

		}
		if(engEmpty())
			switches++;
		return "" + switches;

	}

	private void resetFirstOc() {
		for (Iterator<Engine> ir = engines.iterator(); ir.hasNext();) {
			Engine e = ir.next();
			e.setFirstOc(queries.indexOf(e.getName())+1);
		}
		
	}

	private boolean qEmpty() {
		return queries.size() == 0 ? true : false;

	}

	private boolean engEmpty() {
		for (Iterator<Engine> ir = engines.iterator(); ir.hasNext();) {
			Engine e = ir.next();
			if (e.getCount() == 0) {

				return true;
			}
		}
		return false;
	}

	// @SuppressWarnings("unchecked")
	// private String goahead() {
	//
	// for (Iterator<Engine> ir = engines.iterator(); ir.hasNext();) {
	// Engine e = ir.next();
	// if (e.getCount() == 0) {
	//
	// return "" + 0;
	// }
	// // System.out.println(e.getCount()+" "+e.getName());
	// }
	// Collections.sort(engines);
	//
	// Engine actual = engines.get(0);
	// //System.out.println("a:   "+actual.getName()+"  "+actual.getFirstOc());
	// while (!queries.isEmpty()) {
	// String now=queries.get(0);
	// boolean allthesame = true;
	// for (Iterator i = queries.iterator(); i.hasNext();) {
	// if (!i.next().equals(queries.get(0)))
	// allthesame = false;
	//
	// }
	// if (allthesame)
	// break;
	//
	// if (!queries.get(0).equals(actual.getName())) {
	// System.out.println("delete: " + queries.get(0));
	//
	// Engine ex = new Engine();
	// ex.setName(queries.get(0));
	// Engine exy = engines.get(engines.indexOf(ex));
	// exy.decrease();
	//
	// if (exy.getCount() == 0) {
	// switches++;
	// break;
	// }
	//
	// queries.remove(0);
	// System.out.println("remaining " + queries.size());
	//
	// } else {
	// this.switches++;
	// //while(queries.get(0).equals(now))
	// //queries.remove(0);
	// engines = new Vector<Engine>();
	// for (int a = 0; a < queries.size(); a++) {
	// Engine e = new Engine();
	//
	// e.setName(queries.get(a));
	// if (!engines.contains(e)) {
	// if (e.getFirstOc() == -1)
	// e.setFirstOc(a);
	// // e.setLastOc(e.getLastOc() < a ? a : e.getLastOc());
	// engines.add(e);
	// }
	// }
	// Collections.sort(engines);
	//				
	// if(queries.get(1).equals(now))
	// actual =
	// engines.get(0).getName().equals(actual)?engines.get(1):engines.get(0);
	// else
	// actual=engines.get(0);
	// // System.out.println("a:   "+actual.getName()+"  "+actual.
	// // getFirstOc()+" q.size"+queries.size()+""+switches);
	// }
	//
	// }
	//
	// return switches + "";
	// }

	private BufferedReader openFile(String string) {
		BufferedReader re = null;
		try {
			re = new BufferedReader(new FileReader(string));

			runs = Integer.parseInt(re.readLine());

		} catch (Exception e) {
			e.printStackTrace();
		}
		return re;
	}

	private void writeResult(StringBuffer result) {
		try {
			BufferedWriter buffy = new BufferedWriter(new FileWriter("output"));
			buffy.write(result.toString());
			buffy.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}

}
