import java.util.Scanner;
import java.util.Arrays;

public class Watersheds {

	public static int H, W;

	public static int [][] map;

	public static char [][] val;

	public static char nextChar;

	public static int [] smallest (int i , int j) {
		
		Cell [] options;
		
		options = new Cell [4];
		options[0] = new Cell (i-1, j, 0);
		options[1] = new Cell (i+1, j, 3);
		options[2] = new Cell (i, j-1, 1);
		options[3] = new Cell (i, j+1, 2);
		Arrays.sort(options);
		if (options[0].isValid && options[0].val < map[i][j])
			return new int [] {options[0].x, options[0].y};
		return null;
		
	}

	public static char investigate (int i , int j) {
		
		int [] newPos;
		int ni, nj;
		
		if (val[i][j]!='+')
			return val[i][j];
		newPos = smallest (i, j);
		if (newPos == null)
			return nextChar++;
		ni = newPos[0];
		nj = newPos[1];
		return val[ni][nj] = investigate(ni, nj);
		
	}

	public static void main (String [] args) {
		
		Scanner S;
		String sep;
		int T, i, j, caso;
		
		S = new Scanner (System.in);
		T = S.nextInt();
		caso = 1;
		while (T-- > 0) {
			H = S.nextInt();
			W = S.nextInt();
			Cell.H = H;
			Cell.W = W;
			map = new int [H][W];
			val = new char [H][W];
			for (i=0 ; i<H ; i++) {
				Arrays.fill(val[i], '+');
				for (j=0 ; j<W ; j++)
					map[i][j] = S.nextInt();
			}
			Cell.map = map;
			nextChar = 'a';
			for (i=0 ; i<H ; i++)
				for (j=0 ; j<W ; j++) {
					if (val[i][j]=='+')
						val[i][j] = investigate(i, j);
				}
			System.out.println("Case #" + (caso++) + ":");
			for (i=0 ; i<H ; i++) {
				sep = "";
				for (j=0 ; j<W ; j++) {
					System.out.print(sep + val[i][j]);
					sep = " ";
				}
				System.out.println();
			}
		}
		
	}

}

class Cell implements Comparable<Cell> {

	public static int H, W;

	public static int [][] map;

	int x, y, dir, val;

	boolean isValid;

	public Cell (int x, int y, int dir) {
		
		this.x = x;
		this.y = y;
		this.dir = dir;
		isValid = (x>=0 && x<H && y>=0 && y<W);
		if (isValid)
			val = map[x][y];
		
	}

	public int compareTo (Cell other) {
		
		if (this.isValid) {
			if (other.isValid) {
				if (this.val < other.val)
					return -1;
				if (this.val > other.val)
					return 1;
				if (this.dir < other.dir)
					return -1;
				if (this.dir > other.dir)
					return 1;
				return 0;
			}
			return -1;
		}
		if (other.isValid)
			return 1;
		return 0;
		
	}

}