import java.util.*;

public class a {

  public static int n, m;

  public static char[][] mat = new char[30][30];

  public static HashSet<Character> available = new HashSet<Character>();

  public static char allSame(int i, int j, int ii, int jj) {
    
    char comp = mat[i][j];
    boolean sawWildcard = false;
    for (int x = i ; x < ii ; x++)
      for (int y = j ; y < jj ; y++) {
        if (mat[x][y] == '?')
          sawWildcard = true;
        if (mat[x][y] != comp && mat[x][y] != '?') {
          if (comp == '?')
            comp = mat[x][y];
          else
            return '@';
        }
      }
    if (sawWildcard)
      return comp;
    else
      return '@';
    
  }

  public static void fillAll(int i, int j, int ii, int jj, char c) {
    
    for (int x = i ; x < ii ; x++)
      for (int y = j ; y < jj ; y++)
        mat[x][y] = c;
    
  }

  public static char nonConflicting(int i, int j, int ii, int jj) {
    
    HashSet<Character> possible = new HashSet<Character>();
    possible.addAll(available);
    int[] movex = new int[] {0, 1,  0, -1},
          movey = new int[] {1, 0, -1,  0};
    for (int x = i ; x < ii ; x++)
      for (int y = j ; y < jj ; y++)
        for (int k = 0 ; k < 4 ; k++) {
          int xx = x + movex[k],
              yy = y + movey[k];
          if (xx >= 0 && xx < n && yy >= 0 && yy < m)
            possible.remove(mat[xx][yy]);
        }
    for (char c : possible)
      return c;
    return '@';
    
  }

  public static void printMatrix() {
    
    for (int i = 0 ; i < n ; i++) {
      for (int j = 0 ; j < m ; j++)
        System.out.print(mat[i][j]);
      System.out.println();
    }
    
  }

  public static void main (String[] args) {
    
    Scanner s = new Scanner(System.in);
    int t = s.nextInt();
    for (int caso = 1 ; caso <= t ; caso++) {
      System.out.println("Case #" + caso + ": ");
      n = s.nextInt();
      m = s.nextInt();
      available.clear();
      for (int i = 0 ; i < n ; i++) {
        mat[i] = s.next().toCharArray();
        for (int j = 0 ; j < m ; j++)
          if (mat[i][j] != '?')
            available.add(mat[i][j]);
      }
      for (int i = 0 ; i < n ; i++)
        for (int j = 0 ; j < m ; j++)
          for (int ii = n ; ii > i ; ii--)
            for (int jj = m ; jj > j ; jj--) {
              char c = allSame(i, j, ii, jj);
              if (c != '@' && c != '?' && available.contains(c)) {
                available.remove(c);
                fillAll(i, j, ii, jj, c);
              }
            }
      /*
      for (int i = 0 ; i < n ; i++)
        for (int j = 0 ; j < m ; j++)
          for (int ii = n ; ii > i ; ii--)
            for (int jj = j + 1 ; jj > j ; jj--) {
              char c = allSame(i, j, ii, jj);
              if (c != '@')
                fillAll(i, j, ii, jj, nonConflicting(i, j, ii, jj));
            }
      */
      printMatrix();
    }
    
  }

}