import java.util.*;

public class D {

      public static int N, all_chests;

      public static Chest[] chests = new Chest[20];

      public static boolean[] visited = new boolean[1 << 20];
      
      public static Bag initial;

      public static void main (String[] args) {
            
            Scanner S = new Scanner(System.in);
            int T = S.nextInt(), c, K, ki, a;
            
            for (c = 1; T-->0 ; c++) {
                  K = S.nextInt();
                  N = S.nextInt();
                  all_chests = (1 << N) - 1;
                  initial = new Bag();
                  while (K-- > 0)
                        initial.add(S.nextInt());
                  for (K = 0 ; K < N ; K++) {
                        chests[K] = new Chest(S.nextInt());
                        ki = S.nextInt();
                        while (ki-- > 0)
                              chests[K].addContent(S.nextInt());
                  }
                  Arrays.fill(visited, false);
                  LinkedList<Node> queue = new LinkedList<Node>();
                  Node begin = new Node(), ret = null;
                  queue.add(begin);
                  while (!queue.isEmpty()) {
                        // Node actual = queue.removeFirst();
                        Node actual = queue.removeLast();
                        if (actual.hash == all_chests) {
                              ret = actual;
                              break;
                        }
                        if (visited[actual.hash])
                              continue;
                        visited[actual.hash] = true;
                        for (int next : actual.unOpened()) {
                              if (actual.canOpen(chests[next-1])) {
                                    Node newNode = actual.open(next);
                                    // if (!visited[newNode.hash]) {
                                    //       visited[newNode.hash] = true;
                                          queue.addLast(newNode);
                                    // }
                              }
                        }
                  }
                  if (ret == null)
                        System.out.println("Case #" + c + ": IMPOSSIBLE");
                  else
                        System.out.println("Case #" + c + ":" + ret);
            }
            
      }

}

class Node {

      int hash;

      int last_chest;
      
      Node before;

      public Node () {
            
            hash = 0;
            last_chest = -1;
            before = null;
            
      }
      
      public void addChest(int chest) {
            
            hash = hash | (1 << (chest - 1));
            last_chest = chest;
            
      }

      public LinkedList<Integer> opened() {
            
            LinkedList<Integer> ret = new LinkedList<Integer>();
            
            for (int i = 0 ; i < D.N ; i++)
                  if ((hash & (1 << i)) != 0)
                        ret.add(i+1);
            
            return ret;
            
      }

      public LinkedList<Integer> unOpened() {
            
            LinkedList<Integer> ret = new LinkedList<Integer>();
            
            // for (int i = 0 ; i < D.N ; i++)
            for (int i = D.N - 1 ; i >= 0 ; i--)
                  if ((hash & (1 << i)) == 0)
                        ret.add(i+1);
            
            return ret;
            
      }

      public Node open(int chest) {
            
            Node ret = new Node();
            
            ret.hash = hash;
            ret.addChest(chest);
            ret.before = this;
            
            return ret;
            
      }

      public boolean canOpen(Chest chest) {
            
            Bag actual = new Bag(D.initial);
            
            for (int op : opened()) {
                  actual.remove(D.chests[op-1].keyType);
                  actual.addAll(D.chests[op-1].contents);
            }
            
            return actual.contains(chest.keyType);
            
      }

      public String toString() {
            
            String ret = "";
            
            if (before == null)
                  return "";
            else
                  ret = before.toString() + " " + last_chest;
            
            return ret;
            
      }

}

class Chest {

      int keyType;

      Bag contents;

      public Chest(int keyType) {
            
            this.keyType = keyType;
            contents = new Bag();
            
      }

      public void addContent(int key) {
            
            contents.add(key);
            
      }

}

class Bag {

      int[] contents;

      public Bag () {
            
            contents = new int[200];
            
      }

      public Bag (Bag ks) {
            
            this();
            addAll(ks);
            
      }

      public void add(int k) {
            
            contents[k-1]++;
            
      }

      public void addAll(Bag ks) {
            
            for (int i = 0 ; i < 200 ; i++)
                  contents[i] += ks.contents[i];
            
      }

      public void remove(int k) {
            
            contents[k-1]--;
            
      }

      public boolean contains(int k) {
            
            return contents[k-1] > 0;
            
      }

}