import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Created by yiluo on 4/9/16.
 */
public class CoinJam {

    public long minInt(int n) {
        StringBuffer bf = new StringBuffer("1");
        for (int i = 0; i < n - 1; i ++) {
            bf.append("0");
        }
        return Long.parseLong(bf.toString(), 2);
    }

    public long maxInt(int n) {
        StringBuffer bf = new StringBuffer("1");
        for (int i = 1; i < n; i ++) {
            bf.append("1");
        }
        return Long.parseLong(bf.toString(), 2);
    }

    public long isPrime(long num) {
        if (0 == num % 2) {
            return 2;
        } else {
            for (long i = 3; i * i <= num; i += 2) {
                if (0 == num % i )
                    return i;
            }
            return -1;
        }
    }

    public void start(int n, int j) {
        long[] divisors = new long[9];
        long min = minInt(n);
        long max = maxInt(n);
        int count = 1;

        for (long num = min; num <= max; num ++) {
            if (count <= j) {
                divisors[8] = isPrime(num);
                if (divisors[8] > 0) {
                    String base2Str = Long.toString(num, 2);
                    boolean isJamCoin = false;

                    if (base2Str.endsWith("1"))
                        isJamCoin = true; // ends with '1'

                    if (isJamCoin) {
                        for (int base = 2; base < 10; base++) {
                            long newNum = Long.parseLong(base2Str, base);
                            divisors[base - 2] = isPrime(newNum);
                            if (divisors[base - 2] == -1) {
                                isJamCoin = false;
                                break;
                            }
                        }
                    }

                    if (isJamCoin) {
                        System.out.print(Long.toString(num, 2));
                        for (int base = 0; base < 9; base++) {
                            System.out.print(" " + divisors[base]);
                        }
                        System.out.println();
                        count++;
                    }
                }
            } else {
                break;
            }
        }
    }

    public void processFile(String fileName) {
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(fileName)));
            String lineNumStr = br.readLine();

            int totalLine = Integer.parseInt(lineNumStr);

            for (int i = 0; i < totalLine; i ++) {
                String[] parts = br.readLine().split(" ");
                int n = Integer.parseInt(parts[0]); // length of chars
                int j = Integer.parseInt(parts[1]); // length of groups

                System.out.println("Case #1:");
                start(n, j);
            }

            br.close();
        } catch (FileNotFoundException e) {
            System.out.println("File not found: " + fileName);
        } catch (IOException e) {
            // do nothing
        }
    }

    public static void main(String[] args) {
        CoinJam starter = new CoinJam();
        starter.processFile("data/CoinJam2.txt");
    }
}
