import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Created by yiluo on 4/9/16.
 */
public class PancakeRevenge {

    public char flip(char cake) {
        switch (cake) {
            case '-':
                return '+';
            case '+':
                return '-';
            default:
                return '*';
        }
    }

    public int flipCakes(String cakesStr) {
        char[] cakes = cakesStr.toCharArray();
        char target = '+';

        int k = cakes.length - 1;
        int steps = 0;
        while (k >= 0) {
            if (cakes[k] == target) {
                k --;
            } else {
                steps ++;
                target = flip(target);
            }
        }
        return steps;
    }

    public void processFile(String fileName) {
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(fileName)));
            String lineNumStr = br.readLine();

            int totalLine = Integer.parseInt(lineNumStr);

            for (int i = 0; i < totalLine; i ++) {
                String cakes = br.readLine();
                int steps = flipCakes(cakes);
                System.out.println(String.format("Case #%d: %d", i + 1, steps));
            }

            br.close();
        } catch (FileNotFoundException e) {
            System.out.println("File not found: " + fileName);
        } catch (IOException e) {
            // do nothing
        }
    }

    public static void main(String args[]) {
        PancakeRevenge starter = new PancakeRevenge();
        starter.processFile("data/PancakeRevenge3.txt");
    }
}
