import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;

/**
 * Created by yiluo on 4/9/16.
 */
public class CountingSheep {

    public boolean[] digits;

    public void init() {
        digits = new boolean[10];
        for (int i = 0; i < 10; i ++) {
            digits[i] = false;
        }
    }

    public boolean isFinished() {
        boolean isFinished = true;
        for (int i = 0; i < 10; i ++) {
            isFinished = isFinished && digits[i];
            if (!isFinished) {
                break;
            }
        }
        return isFinished;
    }

    public void updateDigits(int startNum) {
        while (startNum != 0) {
            int mod = startNum % 10;
            digits[mod] = true;
            startNum = startNum / 10;
        }
    }


    public void processNewNum(int index, int startNum) {
        init();
        int k = 0;
        while (!isFinished()) {
            k ++;
            updateDigits(k * startNum);
        }
        System.out.println(String.format("Case #%d: %d", index, k * startNum));
    }

    public void processFile(String fileName) {
        try {
            BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(fileName)));
            String lineNumStr = br.readLine();

            int totalLine = Integer.parseInt(lineNumStr);

            for (int i = 0; i < totalLine; i ++) {
                String startNumStr = br.readLine();
                int startNum = Integer.parseInt(startNumStr);

                if (startNum != 0) {
                    processNewNum(i + 1, startNum);
                } else {
                    System.out.println(String.format("Case #%d: INSOMNIA", i + 1));
                }
            }

        } catch (FileNotFoundException e) {
            System.out.println("File not found: " + fileName);
        } catch (IOException e) {
            // do nother
        }

    }

    public static void main(String args[]) {
        CountingSheep countingSheep = new CountingSheep();
        countingSheep.processFile("data/CountingSheep2.txt");
    }

}
