
import static org.junit.Assert.*;

import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;

import org.junit.Test;



public class CandySplitting extends CodeJam {
	@Test
	public void main(){
		int T = readInteger();
		int c = 1;
		while(c<=T){
			int N = readInteger();
			List<BigInteger> AD = new ArrayList<BigInteger>();
			
			for(int i=0; i<N; i++){
				AD.add(readBigInteger());
			}
			String result = "Case #"+c+": "+calculate(AD);
			writeLine(result);
			System.out.println(result);
			c++;
		}
		assertEquals(T+1,c);
	}
	
	
	@Test
	public void test1(){
		List<BigInteger> a = new ArrayList<BigInteger>();
		a.add(new BigInteger("1"));
		a.add(new BigInteger("2"));
		a.add(new BigInteger("3"));
		a.add(new BigInteger("4"));
		a.add(new BigInteger("5"));
		assertEquals("NO", calculate(a));
	}
	
	@Test
	public void test2(){
		List<BigInteger> a = new ArrayList<BigInteger>();
		a.add(new BigInteger("3"));
		a.add(new BigInteger("5"));
		a.add(new BigInteger("6"));
		assertEquals("11", calculate(a));
	}

	private String calculate(List<BigInteger> aD) {
		BigInteger total = null;
		BigInteger oTotal = new BigInteger("0");
		Iterator<BigInteger> it = aD.iterator();
		while (it.hasNext()) {
			BigInteger val = (BigInteger) it.next();
			oTotal = oTotal.add(val);
			if(total != null){
				total = total.xor(val);
			}
			else {
				total = val;
			}
		}
		if(!total.equals(new BigInteger("0"))){
			return "NO";
		}
		else {
			Collections.sort(aD);
			oTotal = oTotal.subtract(aD.get(0));
			return oTotal.toString();
		}
	}
}




class CodeJam {
	private DataOutputStream dos;
	private BufferedReader br;
	private int counter = 0;
	private String words[];

	public double readDouble() {
		return Double.valueOf(readWord());
	}

	public BigInteger readBigInteger() {
		return new BigInteger(readWord());
	}

	public int readInteger() {
		return Integer.parseInt(readWord());
	}

	public String readWord() {
		return this.readWord(" ");
	}

	public String readWord(String regex) {
		String str;
		if (counter == 0) {
			str = readLine();
			words = str.split(regex);
		}
		str = words[counter];
		counter = (counter + 1) % words.length;
		return str;
	}

	public String readLine() {
		try {
			String str = br.readLine();
			return str;
		} catch (Exception ex) {
			ex.printStackTrace();
			return null;
		}
	}

	public boolean writeLine(String dataLine) {
		dataLine += "\n";
		try {
			dos.writeBytes(dataLine);
		} catch (FileNotFoundException ex) {
			return (false);
		} catch (IOException ex) {
			return (false);
		}
		return (true);
	}

	public CodeJam(String inputFile, String outputFile) {
		try {
			File inFile = new File(inputFile);
			br = new BufferedReader(new InputStreamReader(new FileInputStream(
					inFile)));

			File outFile = new File(outputFile);
			outFile.deleteOnExit();
			dos = new DataOutputStream(new FileOutputStream(outFile, true));
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public CodeJam() {
		this("resources\\Input.in", "resources\\Output.out");
	}

	@Override
	public void finalize() {
		try {
			br.close();
			dos.close();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}