
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/**
 *
 * @author pghosh
 */
public class Watersheds {

    private int T = 0;

    public void readWrite(String inputFolder, String outputFile) {
        try {
            File folder = new File(inputFolder);
            File files[] = folder.listFiles();
            FileInputStream fstream = new FileInputStream(files[0]);
            DataInputStream in = new DataInputStream(fstream);
            BufferedReader br = new BufferedReader(new InputStreamReader(in));
            String strLine;
            strLine = br.readLine().trim();
            T = Integer.parseInt(strLine);
            String strOutput = this.process(br);
            in.close();

            File file = new File(outputFile);
            BufferedWriter bw = new BufferedWriter(new FileWriter(file));
            bw.write(strOutput);
            bw.close();

            System.out.println(strOutput);
        } catch (Exception e) {
        }
    }

    public String process(BufferedReader br) {
        try {
            String strOutput = "";
            for (int i = 0; i < T; i++) {
                String strRowColumn[] = br.readLine().split(" ");
                row = Integer.parseInt(strRowColumn[0]);
                column = Integer.parseInt(strRowColumn[1]);
                altitudes = new int[row][column];
                for (int r = 0; r < row; r++) {
                    String lineRow[] = br.readLine().split(" ");
                    for (int c = 0; c < column; c++) {
                        altitudes[r][c] = Integer.parseInt(lineRow[c]);
                    }
                }
                strOutput += "Case #" + (i + 1) + ":\n" + this.getMatrics() + "\n";
            }
            return strOutput;
        } catch (Exception ex) {
            ex.printStackTrace();
            return "Invalid Input";
        }
    }
    String output[][];
    int row;
    int column;
    int altitudes[][];
    int usedNotationCount = 0;

    public String getMatrics() {
        output = new String[row][column];
        usedNotationCount = 0;
        for (int r = 0; r < row; r++) {
            for (int c = 0; c < column; c++) {
                if(output[r][c]==null)
                output[r][c] = recursive(r, c);
            }
        }
        
        String strOutput = "";
        for (int r = 0; r < row; r++) {
            if (r != 0) {
                strOutput += "\n";
            }
            for (int c = 0; c < column; c++) {
                if (c != 0) {
                    strOutput += " ";
                }
                strOutput += output[r][c];
            }
        }
        return strOutput;
    }

    public String recursive(int r, int c) {
        String notation = "abcdefghijklmnopqrstuvwxyz";
        int minX = r;
        int minY = c;
        if (r > 0 && altitudes[minX][minY] > altitudes[r - 1][c]) {
            minX = r - 1;
            minY = c;
        }
        if (c > 0 && altitudes[minX][minY] > altitudes[r][c - 1]) {
            minX = r;
            minY = c - 1;
        }
        if (c < column - 1 && altitudes[minX][minY] > altitudes[r][c + 1]) {
            minX = r;
            minY = c + 1;
        }
        if (r < row - 1 && altitudes[minX][minY] > altitudes[r + 1][c]) {
            minX = r + 1;
            minY = c;
        }
        if (minX == r && minY == c) {
            if(output[r][c]==null)
                output[r][c] = notation.charAt(usedNotationCount++) + "";
        } else {
            output[r][c] = recursive(minX,minY);
        }
        return output[r][c];
    }

    public static void main(String args[]) {
        try {
            Watersheds a = new Watersheds();
            a.readWrite("C:\\CodeJam", "C:\\CodeJam\\data.txt");
        } catch (Exception ex) {
            ex.printStackTrace();
        }
    }
}
