import java.io.*;
import java.util.Arrays;
import java.util.InputMismatchException;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author Partha Sarathi Ghosh
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream;
		try {
			inputStream = new FileInputStream("input.in");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("output.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		InputReader in = new InputReader(inputStream);
		OutputWriter out = new OutputWriter(outputStream);
		TaskA solver = new TaskA();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++) {
			solver.solve(i, in, out);
			if(i!= testCount) {
				in.read();
			}
		}
		out.close();
	}
}

class TaskA {
	public void solve(int testNumber, InputReader in, OutputWriter out) {
		String answer = "YES";
		System.out.println("Game "+testNumber);
		int row = 4;
		int column = 4;
		int data[][] = new int[row][column];
		boolean gameEnd = true;
		for(int i=0; i<row; i++) {
			for(int j=0; j<column; j++) {
				data[i][j] = in.read();
				System.out.print(data[i][j] + " ");
				if(data[i][j] == 46) {
					gameEnd = false;
				}
			}
			System.out.println();
			in.read();
		}
		
		int match = 0;
		
		for(int y=0; y<column; y++) {
			int XCount = 0;
			int OCount = 0;
			for(int x=0; x<row; x++) {
				if(data[x][y] == 88 || data[x][y]==84) {
					XCount++;
				}
				if(data[x][y] == 79 || data[x][y]==84) {
					OCount++;
				}
			}
			if(XCount==4) {
				match = 88;
				break;
			}
			if(OCount==4) {
				match = 79;
				break;
			}
		}
		
		for(int x=0; x<row; x++) {
			int XCount = 0;
			int OCount = 0;
			for(int y=0; y<column; y++) {
				if(data[x][y] == 88 || data[x][y]==84) {
					XCount++;
				}
				if(data[x][y] == 79 || data[x][y]==84) {
					OCount++;
				}
			}
			if(XCount==4) {
				match = 88;
				break;
			}
			if(OCount==4) {
				match = 79;
				break;
			}
		}
		
		if(
				(data[0][0] == 88 || data[0][0]==84) &&
				(data[1][1] == 88 || data[1][1]==84) &&
				(data[2][2] == 88 || data[2][2]==84) &&
				(data[3][3] == 88 || data[3][3]==84)
				)
			match = 88;
		
		if(
				(data[0][0] == 79 || data[0][0]==84) &&
				(data[1][1] == 79 || data[1][1]==84) &&
				(data[2][2] == 79 || data[2][2]==84) &&
				(data[3][3] == 79 || data[3][3]==84)
				)
			match = 79;
		
		if(
				(data[0][3] == 88 || data[0][3]==84) &&
				(data[1][2] == 88 || data[1][2]==84) &&
				(data[2][1] == 88 || data[2][1]==84) &&
				(data[3][0] == 88 || data[3][0]==84)
				)
			match = 88;
		
		if(
				(data[0][3] == 79 || data[0][3]==84) &&
				(data[1][2] == 79 || data[1][2]==84) &&
				(data[2][1] == 79 || data[2][1]==84) &&
				(data[3][0] == 79 || data[3][0]==84)
				)
			match = 79;
		


		if(match == 88){
			answer = "X won";
		}
		else if(match == 79){
			answer = "O won";
		}
		else if(gameEnd) {
			answer = "Draw";
		}
		else {
			answer = "Game has not completed";
		}
		
		out.printLine("Case #" + testNumber + ":", answer);
	}
}

class InputReader {

	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	public static boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public String next() {
		return readString();
	}
}

class OutputWriter {
	private final PrintWriter writer;

	public OutputWriter(OutputStream outputStream) {
		writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
	}

	public OutputWriter(Writer writer) {
		this.writer = new PrintWriter(writer);
	}

	public void print(Object...objects) {
		for (int i = 0; i < objects.length; i++) {
			if (i != 0)
				writer.print(' ');
			writer.print(objects[i]);
		}
	}

	public void printLine(Object...objects) {
		print(objects);
		writer.println();
	}

	public void close() {
		writer.close();
	}

	}

class IOUtils {

	public static void readIntArrays(InputReader in, int[]... arrays) {
		for (int i = 0; i < arrays[0].length; i++) {
			for (int j = 0; j < arrays.length; j++)
				arrays[j][i] = in.readInt();
		}
	}

	}

class ArrayUtils {

	public static void fill(int[][] array, int value) {
		for (int[] row : array)
			Arrays.fill(row, value);
	}

	}

