import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.Writer;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.InputMismatchException;
import java.util.Scanner;


/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 * @author Partha Sarathi Ghosh
 */
public class Main {
	public static void main(String[] args) {
		InputStream inputStream;
		File f;
		Scanner in;
		try {
			f = new File("input.in");
			in = new Scanner(f);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("output.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputWriter out = new OutputWriter(outputStream);
		
		TaskA solver = new TaskA();
		int testCount = in.nextInt();
		for (int i = 1; i <= testCount; i++) {
			solver.solve1(i, in, out);
		}
		out.close();
	}
}

class TaskA {
	
	public static String genNextPalin(String base){
	    //check if it is 1 digit
	    if(base.length()==1){
	        if(Integer.parseInt(base)==9)
	            return "11";
	        else
	            return (Integer.parseInt(base)+1)+"";
	    }
	    boolean check = true;
	    //check if it is all 9s
	    for(char a: base.toCharArray()){
	        if(a!='9')
	            check = false;
	    }
	    if(check){
	        String num = "1";
	        for(int i=0; i<base.length()-1; i++)
	            num+="0";
	        num+="1";
	        return num;
	    }

	    boolean isBasePalin = isPalindrome(base);
	    int mid = base.length()/2;
	    if(isBasePalin){
	        //if base is palin and it is odd increase mid and return
	        if(base.length()%2==1){
	            BigInteger leftHalf = new BigInteger(base.substring(0,mid+1));
	            String newLeftHalf = leftHalf.add(BigInteger.ONE).toString();
	            String newPalin = genPalin2(newLeftHalf.substring(0,mid),newLeftHalf.charAt(mid));
	            return newPalin;
	        }
	        else{
	            BigInteger leftHalf = new BigInteger(base.substring(0,mid));
	            String newLeftHalf = leftHalf.add(BigInteger.ONE).toString();
	            String newPalin = genPalin(newLeftHalf.substring(0,mid));
	            return newPalin;
	        }
	    }
	    else{
	        if(base.length()%2==1){
	            BigInteger leftHalf = new BigInteger(base.substring(0,mid));
	            BigInteger rightHalf = new BigInteger(reverse(base.substring(mid+1,base.length())));

	            //check if leftHalf is greater than right half
	            if(leftHalf.compareTo(rightHalf)==1){
	                String newPalin = genPalin2(base.substring(0,mid),base.charAt(mid));
	                return newPalin;
	            }
	            else{
	                BigInteger leftHalfMid = new BigInteger(base.substring(0,mid+1));
	                String newLeftHalfMid = leftHalfMid.add(BigInteger.ONE).toString();
	                String newPalin = genPalin2(newLeftHalfMid.substring(0,mid),newLeftHalfMid.charAt(mid));
	                return newPalin;
	            }
	        }
	        else{
	            BigInteger leftHalf = new BigInteger(base.substring(0,mid));
	            BigInteger rightHalf = new BigInteger(reverse(base.substring(mid,base.length())));

	            //check if leftHalf is greater than right half
	            if(leftHalf.compareTo(rightHalf)==1){
	                return genPalin(base.substring(0,mid));
	            }
	            else{
	                BigInteger leftHalfMid = new BigInteger(base.substring(0,mid));
	                String newLeftHalfMid = leftHalfMid.add(BigInteger.ONE).toString(); 
	                return genPalin(newLeftHalfMid);
	            }
	        }
	    }
	}

	public static String genPalin(String base){
	    return base + new StringBuffer(base).reverse().toString();
	}
	public static String genPalin2(String base, char middle){
	    return base + middle +new StringBuffer(base).reverse().toString();
	}

	public static String reverse(String in){
	    return new StringBuffer(in).reverse().toString();
	}

	static boolean isPalindrome(String str) {    
	    int n = str.length();
	    for( int i = 0; i < n/2; i++ )
	        if (str.charAt(i) != str.charAt(n-i-1)) 
	            return false;
	    return true;    
	}

	public void solve(int testNumber, Scanner in, OutputWriter out) {
		int answer = 0;
		int start = in.nextInt();
		int end = in.nextInt();
		int x = (int) Math.sqrt(start);
		x--;
		int y = 0;
		do {
			x = Integer.parseInt(TaskA.genNextPalin(Integer.toString(x)));
			y = x * x;
			if(y >= start && y<= end && TaskA.isPalindrome(Integer.toString(y))){
				System.out.print(y+" ");
				answer++;
			}
		}
		while(y <= end);
		System.out.println();
		out.printLine("Case #" + testNumber + ":", answer);
	}
	
	public void solve1(int testNumber, Scanner in, OutputWriter out) {
		int answer = 0;
		BigInteger start = in.nextBigInteger();
		BigInteger end = in.nextBigInteger();
		BigInteger x = BigIntSqRoot.bigIntSqRootFloor(start);
		x = x.subtract(BigInteger.ONE);
		BigInteger y = BigInteger.ZERO;
		do {
			x = new BigInteger(TaskA.genNextPalin(x.toString()));
			y = x.multiply(x);
			if(y.compareTo(start) >= 0 && y.compareTo(end)<= 0 && TaskA.isPalindrome(y.toString())){
				System.out.print(y+" ");
				answer++;
			}
		}
		while(y.compareTo(end) <= 0);
		System.out.println();
		out.printLine("Case #" + testNumber + ":", answer);
	}
}

class BigIntSqRoot {

	public static BigInteger bigIntSqRootFloor(BigInteger x)
	        throws IllegalArgumentException {
		
		String sqrt = "";
	    BigInteger divisor = BigInteger.ZERO;
	    BigInteger toDivide = BigInteger.ZERO;
	    String Nstr = x.toString(10);
	    if (Nstr.length() % 2 == 1)
	        Nstr = "0" + Nstr;
	    for (int digitCount = 0; digitCount < Nstr.length(); digitCount += 2) {
	        toDivide = toDivide.multiply(BigInteger.TEN).multiply(
	                BigInteger.TEN);
	        toDivide = toDivide.add(new BigInteger(Nstr.substring(digitCount,
	                digitCount + 2)));
	        String div = divisor.toString(10);
	        divisor = divisor.add(new BigInteger(
	                div.substring(div.length() - 1)));
	        int into = tryMax(divisor, toDivide);
	        divisor = divisor.multiply(BigInteger.TEN).add(
	                BigInteger.valueOf(into));
	        toDivide = toDivide.subtract(divisor.multiply(BigInteger
	                .valueOf(into)));
	        sqrt = sqrt + into;
	    }
	    
		return new BigInteger(sqrt);
	} // end bigIntSqRootFloor

	private static int tryMax(final BigInteger divisor,
	        final BigInteger toDivide) {
	    for (int i = 9; i > 0; i--) {
	        BigInteger div = divisor.multiply(BigInteger.TEN).add(
	                BigInteger.valueOf(i));
	        if (div.multiply(BigInteger.valueOf(i)).compareTo(toDivide) <= 0)
	            return i;
	    }
	    return 0;
	}
	
	public static BigInteger bigIntSqRootCeil(BigInteger x)
	        throws IllegalArgumentException {
	    if (x.compareTo(BigInteger.ZERO) < 0) {
	        throw new IllegalArgumentException("Negative argument.");
	    }
	    // square roots of 0 and 1 are trivial and
	    // y == 0 will cause a divide-by-zero exception
	    if (x == BigInteger.ZERO || x == BigInteger.ONE) {
	        return x;
	    } // end if
	    BigInteger two = BigInteger.valueOf(2L);
	    BigInteger y;
	    // starting with y = x / 2 avoids magnitude issues with x squared
	    for (y = x.divide(two);
	            y.compareTo(x.divide(y)) > 0;
	            y = ((x.divide(y)).add(y)).divide(two));
	    if (x.compareTo(y.multiply(y)) == 0) {
	        return y;
	    } else {
	        return y.add(BigInteger.ONE);
	    }
	} // end bigIntSqRootCeil
	} // end class bigIntSqRoot

class InputReader {

	private InputStream stream;
	private byte[] buf = new byte[1024];
	private int curChar;
	private int numChars;

	public InputReader(InputStream stream) {
		this.stream = stream;
	}

	public int read() {
		if (numChars == -1)
			throw new InputMismatchException();
		if (curChar >= numChars) {
			curChar = 0;
			try {
				numChars = stream.read(buf);
			} catch (IOException e) {
				throw new InputMismatchException();
			}
			if (numChars <= 0)
				return -1;
		}
		return buf[curChar++];
	}

	public int readInt() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		int sgn = 1;
		if (c == '-') {
			sgn = -1;
			c = read();
		}
		int res = 0;
		do {
			if (c < '0' || c > '9')
				throw new InputMismatchException();
			res *= 10;
			res += c - '0';
			c = read();
		} while (!isSpaceChar(c));
		return res * sgn;
	}

	public String readString() {
		int c = read();
		while (isSpaceChar(c))
			c = read();
		StringBuffer res = new StringBuffer();
		do {
			res.appendCodePoint(c);
			c = read();
		} while (!isSpaceChar(c));
		return res.toString();
	}

	public static boolean isSpaceChar(int c) {
		return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
	}

	public String next() {
		return readString();
	}
}

class OutputWriter {
	private final PrintWriter writer;

	public OutputWriter(OutputStream outputStream) {
		writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(outputStream)));
	}

	public OutputWriter(Writer writer) {
		this.writer = new PrintWriter(writer);
	}

	public void print(Object...objects) {
		for (int i = 0; i < objects.length; i++) {
			if (i != 0)
				writer.print(' ');
			writer.print(objects[i]);
		}
	}

	public void printLine(Object...objects) {
		print(objects);
		writer.println();
	}

	public void close() {
		writer.close();
	}

	}

class IOUtils {

	public static void readIntArrays(InputReader in, int[]... arrays) {
		for (int i = 0; i < arrays[0].length; i++) {
			for (int j = 0; j < arrays.length; j++)
				arrays[j][i] = in.readInt();
		}
	}

	}

class ArrayUtils {

	public static void fill(int[][] array, int value) {
		for (int[] row : array)
			Arrays.fill(row, value);
	}

	}

