import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class main {
  public static void main(String args[]) throws Exception {
    // main.solveTestCases();
    main.solveFromFile();
  }

  public static void solveTestCases() {
    Solution.logs = false;
    int[] sol1 = Solution.solve(4, 2);
    Test.that(sol1[0] == 1 && sol1[1] == 0, sol1);
    int[] sol2 = Solution.solve(5, 2);
    Test.that(sol2[0] == 1 && sol2[1] == 0, sol2);
    int[] sol3 = Solution.solve(6, 2);
    Test.that(sol3[0] == 1 && sol3[1] == 1, sol3);
    int[] sol4 = Solution.solve(1000, 1000);
    Test.that(sol4[0] == 0 && sol4[1] == 0, sol4);
    int[] sol5 = Solution.solve(1000, 1);
    Test.that(sol5[0] == 500 && sol5[1] == 499, sol5);
    int[] sol6 = Solution.solve(10, 1);
    Test.that(sol6[0] == 5 && sol6[1] == 4, sol6);
    int[] sol7 = Solution.solve(10, 2);
    Test.that(sol7[0] == 2 && sol7[1] == 2, sol7);
    int[] sol8 = Solution.solve(10, 10);
    Test.that(sol8[0] == 0 && sol8[1] == 0, sol8);
  }

  public static void solveFromFile() throws Exception {
    Solution.logs = false;
    File file = new File("C-small-1-attempt1.in");
    Scanner in = new Scanner(file);
    ArrayList<String> lines = new ArrayList<>();
    int size = in.nextInt();

    for (int i = 1; i <= size; ++i) {
      int N = in.nextInt();
      int K = in.nextInt();
      int[] solution = Solution.solve(N, K);

      lines.add("Case #" + i + ": " + solution[0] + " " + solution[1]);
      System.out.println("Case #" + i + ": " + solution[0] + " " + solution[1]);
    }

    Path filePath = Paths.get("result.txt");
    Files.write(filePath, lines, Charset.forName("UTF-8"));
  }
}

class Solution {
  public static boolean logs = true;

  public static int[] solve(int total, int needle) {
    int[] result = new int[2];
    result[0] = 0;
    result[1] = 0;

    if (Solution.logs) System.out.println("In: " + total + ", " + needle);
    int pow = (int)Math.floor(Math.log(needle) / Math.log(2) + 0.0001);
    if (Solution.logs) System.out.println("Pow: " + pow);
    int sectionsCount = (int)Math.pow(2, pow);
    if (Solution.logs) System.out.println("Sections count: " + sectionsCount);

    int sectionSize = (total - (sectionsCount - 1)) / sectionsCount;
    if (Solution.logs) System.out.println("Section size: " + sectionSize);

    int largeSectionsCount = (total - sectionsCount + 1) - (sectionSize * sectionsCount);
    if (Solution.logs) System.out.println("Large sections: " + largeSectionsCount);

    int needleRemainder = needle - sectionsCount + 1;
    if (Solution.logs) System.out.println("Needle remainder: " + needleRemainder);

    if (needleRemainder <= largeSectionsCount) {
      result[1] = sectionSize / 2;
      result[0] = sectionSize - result[1];
    } else {
      result[1] = (sectionSize - 1) / 2;
      result[0] = (sectionSize - 1) - result[1];
    }

    int needleBinaryPow = (int)Math.round(Math.log(needle) / Math.log(2));
    if (Solution.logs) System.out.println(needleBinaryPow);
    int remainingSlots = total - (int)Math.pow(2, needleBinaryPow) + 1;

    return result;
  }
}

class Test {
  public static void that(Boolean result) {
    System.out.println(result ? "OK" : "FAIL");
  }

  public static void that(Boolean result, int[] testValue) {
    System.out.format("%s - %s\n", result ? "OK" : "FAIL", Arrays.toString(testValue));
  }
}
