import java.io.*;
import java.util.*;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Scanner;

// @SuppressWarnings("all")
@SuppressWarnings("unchecked")
public class Solution {
	private static final String FILE_NAME = "B-small-attempt1";	

	/**************************** 
	 * 		   Solution
	 * R + Y = O
	 * Y + B = G
	 * R + B = V
	 ****************************/

	private void solve() {
		int count = nextInt();
		int R = nextInt();
		int O = nextInt();
		int Y = nextInt();
		int G = nextInt();
		int B = nextInt();
		int V = nextInt();

		ArrayList<Character> order = getOrder(count, R, Y, B);

		if (order == null) {
			print("IMPOSSIBLE");
		} else {
			for (char c : order) {
				print(c);
			}
		}
	}

	private ArrayList<Character> getOrder(int count, int R, int Y, int B) {
			// System.out.println("Start " + R + " " + Y + " " + B);
		ArrayList<Character> order = new ArrayList<>();
		char last = 0;
		if (R > Y && R > B) {
			last = 'R';
			R--;
		} else if (Y > B) {
			last = 'Y';
			Y--;
		} else {
			last = 'B';
			B--;
		}
		char first = last;
		order.add(last);


		while (R > 0 || Y > 0 || B > 0) {
			// System.out.println(last + " " + R + " " + Y + " " + B);
			if (last == 'R') {
				if (Y == 0 && B == 0) break;
				if (Y > B) {
					last = 'Y';
					Y--;
				} else {
					last = 'B';
					B--;
				}
			} else if (last == 'Y') {
				if (R == 0 && B == 0) break;
				if (R > B) {
					last = 'R';
					R--;
				} else {
					last = 'B';
					B--;
				}
			} else if (last == 'B') {
				if (R == 0 && Y == 0) break;
				if (R > Y) {
					last = 'R';
					R--;
				} else {
					last = 'Y';
					Y--;
				}
			}
			// System.out.println(last + " " + R + " " + Y + " " + B);
			order.add(last);
		}

		if (order.get(0) == order.get(order.size() - 1) && order.size() > 2) {
			// Try to swap last 2
			char tail = order.get(order.size() - 1);
			char tail2 = order.get(order.size() - 2);
			char tail3 = order.get(order.size() - 3);
			if (tail != tail3) {
				order.set(order.size() - 1, tail2);
				order.set(order.size() - 2, tail);
			} else {
				return null;
			}
		}

		if (R == 0 && B == 0 && Y == 0 && order.get(0) != order.get(order.size() - 1)) {
		// if (R == 0 && B == 0 && Y == 0) {
			return order; 
		} else {
			return null;
		}
	}
	
	/**************************** 
	 * 		Set-up
	 ****************************/
	
	private Scanner in;
	private PrintStream out;

	public Solution () throws FileNotFoundException {
		in = new Scanner(new File(FILE_NAME + ".in"));	
		out = new PrintStream(FILE_NAME + ".out"); 

		int cases = nextInt();	
		for (int i = 1; i <= cases; i++) {
			print("Case #" + i + ": ");
			solve();
			println();
		}	

		out.close();
	}
	
	/**************************** 
	 * 		Manage input
	 ****************************/
	private int[] nextArray(int length) {
		int[] arr = new int[length];
		for (int i = 0; i < length; i++) {
			arr[i] = nextInt();
		}
		return arr;
	}
	
	private int[][] nextMatrix(int rows, int columns) {
		int[][] mat = new int[rows][columns];
		for (int r = 0; r < rows; r++) {
			for (int c = 0; c < columns; c++) {
				mat[r][c] = nextInt();
			}
		}
		return mat;
	}
	
	private String nextLine() {
		return in.nextLine();
	}
	private String next() {
		return in.next();
	}
	private int nextInt() {
		return in.nextInt();
	}
	private long nextLong() {
		return in.nextLong();
	}

	/**************************** 
	 * 		Manage output
	 ****************************/
	private void print(String s) { 
		System.out.print(s);
		out.print(s); 
	}	
	private void print(char s) { 
		System.out.print(s);
		out.print(s); 
	}
	private void print(int i) { 
		System.out.print(i);
		out.print(i); 
	}
	private void print(long l) {
		System.out.print(l);
		out.print(l);
	}
	private void print(Object o) {
		System.out.print(o);
		print(o);
	}
	private void println() { 
		System.out.println();
		out.println(); 
	}
	
	public static void main(String[] args) {
		try {
			new Solution();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**************************** 
	 * 		Utils
	 ****************************/
	private static char[] cloneArray(char[] src) {
		return Arrays.copyOf(src, src.length);
	}

	private static int[] cloneArray(int[] src) {
		return Arrays.copyOf(src, src.length);
	}

	public static char[][] cloneArray(char[][] src) {
		int length = src.length;
		char[][] target = new char[length][src[0].length];
		for (int i = 0; i < length; i++) {
			System.arraycopy(src[i], 0, target[i], 0, src[i].length);
		}
		return target;
	}

	public static int[][] cloneArray(int[][] src) {
		int length = src.length;
		int[][] target = new int[length][src[0].length];
		for (int i = 0; i < length; i++) {
			System.arraycopy(src[i], 0, target[i], 0, src[i].length);
		}
		return target;
	}
}