import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class main {
  public static void main(String args[]) throws Exception {
    // main.solveTestCases();
    main.solveFromFile();
  }

  public static void solveTestCases() {
    char[] set1 = "---+-++-".toCharArray();
    char[] set2 = "+++++".toCharArray();
    char[] set3 = "-+-+-".toCharArray();

    Test.that(Solution.solve(set1, 3) == 3);
    Test.that(Solution.solve(set2, 4) == 0);
    Test.that(Solution.solve(set3, 4) == -1);
  }

  public static void solveFromFile() throws Exception {
    File file = new File("A-large.in");
    Scanner in = new Scanner(file);
    ArrayList<String> lines = new ArrayList<>();
    int size = in.nextInt();

    for (int i = 1; i <= size; ++i) {
      String s = in.next();
      int width = in.nextInt();

      int solution = Solution.solve(s.toCharArray(), width);

      if (solution == -1) {
        lines.add("Case #" + i + ": IMPOSSIBLE");
        System.out.println("Case #" + i + ": IMPOSSIBLE");
      } else {
        lines.add("Case #" + i + ": " + solution);
        System.out.println("Case #" + i + ": " + solution);
      }
    }

    Path filePath = Paths.get("result.txt");
    Files.write(filePath, lines, Charset.forName("UTF-8"));
  }
}

class Solution {
  public static int solve(char[] set, int width) {
    int swaps = 0;
    if (width > set.length) return -1;

    for (int i = 0; i <= set.length - width; i++) {
      if (set[i] == '-') {
        swaps += 1;
        for (int j = 0; j < width; j++) {
          Solution.swap(set, i+j);
        }
      }
    }

    for (int i = 0; i < set.length; i++) {
      if (set[i] == '-') {
        return -1;
      }
    }

    return swaps;
  }

  public static void swap(char[] set, int index) {
    set[index] = set[index] == '-' ? '+' : '-';
  }
}

class Test {
  public static void that(Boolean result) {
    System.out.println(result ? "OK" : "FAIL");
  }

  public static void that(Boolean result, int testValue) {
    System.out.format("%s - %s\n", result ? "OK" : "FAIL", testValue);
  }
}
