import java.util.*;
import java.io.*;
import java.nio.*;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;

public class main {
  public static void main(String args[]) throws Exception {
    // main.solveTestCases();
    main.solveFromFile();
  }

  public static void solveTestCases() {
    char[] set1 = "132".toCharArray();
    char[] set2 = "1000".toCharArray();
    char[] set3 = "7".toCharArray();
    char[] set4 = "111111111111111110".toCharArray();

    Test.that(Solution.solve("132").equals("129"), Solution.solve("132"));
    Test.that(Solution.solve("1000").equals("999"), Solution.solve("1000"));
    Test.that(Solution.solve("7").equals("7"), Solution.solve("7"));
    Test.that(Solution.solve("0").equals("0"), Solution.solve("0"));
    Test.that(Solution.solve("111111111111111110").equals("99999999999999999"), Solution.solve("111111111111111110"));
  }

  public static void solveFromFile() throws Exception {
    File file = new File("B-large.in");
    Scanner in = new Scanner(file);
    ArrayList<String> lines = new ArrayList<>();
    int size = in.nextInt();

    for (int i = 1; i <= size; ++i) {
      String s = in.next();
      String solution = Solution.solve(s);

      lines.add("Case #" + i + ": " + solution);
      System.out.println("Case #" + i + ": " + solution);
    }

    Path filePath = Paths.get("result.txt");
    Files.write(filePath, lines, Charset.forName("UTF-8"));
  }
}

class Solution {
  public static String solve(String str) {
    ArrayList<Integer> set = new ArrayList<>();
    for (char c : str.toCharArray()) {
      set.add(c - '0');
    }

    int anchor = 0;
    // int curr = 0;
    for (int i = 1; i < str.length(); i++) {
      if (set.get(i) > set.get(i - 1)) {
        // all good
        anchor = i;
      } else if (set.get(i) == set.get(i - 1)) {
        // all good, anchor stays in place
      } else {
        // not good, decrease the anchor, set everything after the anchor to 9
        set.set(anchor, set.get(anchor) - 1);
        for (int j = anchor + 1; j < str.length(); j++) {
          set.set(j, 9);
        }
        break;
      }
    }

    if (set.get(0) == 0 && set.size() > 1) {
      set.remove(0);
    }

    char[] result = new char[set.size()];
    for (int i = 0; i < set.size(); i++) {
      result[i] = (char)('0' + set.get(i));
    }

    return new String(result);
  }
}

class Test {
  public static void that(Boolean result) {
    System.out.println(result ? "OK" : "FAIL");
  }

  public static void that(Boolean result, String testValue) {
    System.out.format("%s - %s\n", result ? "OK" : "FAIL", testValue);
  }
}
