import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

public class Q1 {
	public static List<String> readFile(String name) throws IOException {

		List<String> result = new ArrayList<String>();

		FileInputStream fis = null;
		InputStreamReader isr = null;
		BufferedReader br = null;

		try {
			fis = new FileInputStream(name);
			isr = new InputStreamReader(fis);
			br = new BufferedReader(isr);

			String line = null;

			while ((line = br.readLine()) != null) {
				result.add(line);
			}

			return result;
		} finally {
			if (br != null)
				try {
					br.close();
				} catch (Exception e) {

				}
			if (isr != null)
				try {
					isr.close();
				} catch (Exception e) {

				}
			if (fis != null)
				try {
					fis.close();
				} catch (Exception e) {

				}
		}
	}

	public static void writeFile(String name, String content)
			throws IOException {
		FileWriter fw = null;
		try {
			fw = new FileWriter(name);

			fw.write(content);
			fw.flush();
		} finally {
			if (fw != null)
				try {
					fw.close();
				} catch (Exception e) {

				}
		}
	}

	public static void main(String args[]) throws Exception {

		String inputName = "A-large.in";

		List<String> input = Utility.readFile(inputName);

		String[] columns = input.get(0).split(" ");

		int wordsLength = Integer.parseInt(columns[0]);
		int noOfWord = Integer.parseInt(columns[1]);
		int noOfTestCase = Integer.parseInt(columns[2]);

		String[] words = new String[noOfWord];

		for (int i = 1; i <= noOfWord; i++) {
			words[i - 1] = input.get(i).trim();
		}

		StringBuffer buffer = new StringBuffer();

		for (int i = 0; i < noOfTestCase; i++) {
			String testCase = input.get(i + noOfWord + 1);

			testCase = testCase.replace('(', '[');
			testCase = testCase.replace(')', ']');

			int match = 0;

			for (String word : words) {
				if (word.matches(testCase))
					match++;
			}

			buffer.append("Case #" + (i + 1) + ": " + match + "\n");
		}

		writeFile(inputName + "_result", buffer.toString());
	}
}
