import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

public class Q2 {
	public static Iterator<String> readFile(String name) throws IOException {

		List<String> result = new ArrayList<String>();

		FileInputStream fis = null;
		InputStreamReader isr = null;
		BufferedReader br = null;

		try {
			fis = new FileInputStream(name);
			isr = new InputStreamReader(fis);
			br = new BufferedReader(isr);

			String line = null;

			while ((line = br.readLine()) != null) {
				result.add(line);
			}

			return result.iterator();
		} finally {
			if (br != null)
				try {
					br.close();
				} catch (Exception e) {

				}
			if (isr != null)
				try {
					isr.close();
				} catch (Exception e) {

				}
			if (fis != null)
				try {
					fis.close();
				} catch (Exception e) {

				}
		}
	}

	public static void writeFile(String name, String content) throws IOException {
		FileWriter fw = null;
		try {
			fw = new FileWriter(name);

			fw.write(content);
			fw.flush();
		} finally {
			if (fw != null)
				try {
					fw.close();
				} catch (Exception e) {

				}
		}
	}

	public static void main(String[] args) throws Exception {
		String inputName = "B-small-attempt3.in";

		Iterator<String> input = readFile(inputName);

		int noOfCases = Integer.parseInt(input.next());

		StringBuffer buffer = new StringBuffer();

		for (int i = 0; i < noOfCases; i++) {
			String line1_cols[] = input.next().split(" ");

			int noOfRows = Integer.parseInt(line1_cols[0]);

			int noOfCols = Integer.parseInt(line1_cols[1]);

			int[][] altitudes = new int[noOfRows][noOfCols];

			char[][] results = new char[noOfRows][noOfCols];

			for (int j = 0; j < noOfRows; j++) {
				String line = input.next();

				String[] columns = line.split(" ");

				for (int k = 0; k < noOfCols; k++) {
					altitudes[j][k] = Integer.parseInt(columns[k]);
				}
			}

			System.out.println(noOfRows + " : " + noOfCols);

			char currentLabel = 'a';

			for (int j = 0; j < altitudes.length; j++) {
				for (int k = 0; k < altitudes[j].length; k++) {

					if (results[j][k] == '\u0000') {
						results[j][k] = currentLabel;
						currentLabel++;
					}

					// check flow, North, West, East, South
					int[] diff = new int[] { Integer.MIN_VALUE, Integer.MIN_VALUE, Integer.MIN_VALUE, Integer.MIN_VALUE };

					if (j != 0) {
						diff[0] = altitudes[j][k] - altitudes[j - 1][k];
					}

					if (k != 0) {
						diff[1] = altitudes[j][k] - altitudes[j][k - 1];
					}

					if (k < altitudes[j].length - 1) {
						diff[2] = altitudes[j][k] - altitudes[j][k + 1];
					}

					if (j < altitudes.length - 1) {
						diff[3] = altitudes[j][k] - altitudes[j + 1][k];
					}

					int maxIndex = findMaxIndex(diff);

					if (diff[maxIndex] > 0) {
						switch (maxIndex) {
						case 0:
							if (results[j - 1][k] == '\u0000') {
								results[j - 1][k] = results[j][k];
							} else {
								if (results[j - 1][k] > results[j][k]) {
									replaceChar(results, results[j - 1][k], results[j][k]);
								} else {
									replaceChar(results, results[j][k], results[j - 1][k]);
								}
							}
							break;
						case 1:
							if (results[j][k - 1] == '\u0000') {
								results[j][k - 1] = results[j][k];
							} else {
								if (results[j][k - 1] > results[j][k]) {
									System.out.println(results[j][k - 1] + " to " + results[j][k]);
									replaceChar(results, results[j][k - 1], results[j][k]);
								} else {
									System.out.println(results[j][k] + " to " + results[j][k - 1]);
									replaceChar(results, results[j][k], results[j][k - 1]);
								}
							}
							break;
						case 2:
							if (results[j][k + 1] == '\u0000') {
								results[j][k + 1] = results[j][k];
							} else {
								if (results[j][k + 1] > results[j][k]) {
									replaceChar(results, results[j][k + 1], results[j][k]);
								} else {
									replaceChar(results, results[j][k], results[j][k + 1]);
								}
							}
							break;
						case 3:
							if (results[j + 1][k] == '\u0000') {
								results[j + 1][k] = results[j][k];
							} else {
								if (results[j + 1][k] > results[j][k]) {
									replaceChar(results, results[j + 1][k], results[j][k]);
								} else {
									replaceChar(results, results[j][k], results[j + 1][k]);
								}
							}
							break;
						}
					}
				}
			}

			for (int j = 0; j < results.length; j++) {
				for (int k = 0; k < results[j].length; k++) {
					if (results[j][k] == '\u0000') {
						results[j][k] = currentLabel;
						currentLabel++;
					}
				}
			}

			// lexicographically smallest replacement
			List<Character> cList = new ArrayList<Character>();
			for (int j = 0; j < results.length; j++) {
				for (int k = 0; k < results[j].length; k++) {
					if (!cList.contains(results[j][k])) {
						cList.add(results[j][k]);
					}
				}
			}

			char c = 'a';
			for (int j = 0; j < cList.size(); j++) {
				replaceChar(results, cList.get(j), c);
				c++;
			}

			buffer.append("Case #" + (i + 1) + ":\n");

			for (int j = 0; j < results.length; j++) {
				for (int k = 0; k < results[j].length; k++) {
					if (k > 0)
						buffer.append(" ");
					buffer.append(results[j][k]);
				}
				buffer.append("\n");
			}
		}

		writeFile(inputName + "_result", buffer.toString());
	}

	private static int findMaxIndex(int[] input) {
		int index = 0;
		int max = input[0];

		for (int i = 1; i < input.length; i++) {
			if (input[i] > max) {
				index = i;
				max = input[i];
			}
		}

		return index;
	}

	private static void replaceChar(char[][] array, char from, char to) {
		for (int i = 0; i < array.length; i++) {
			for (int j = 0; j < array[i].length; j++) {
				if (array[i][j] == from)
					array[i][j] = to;
			}
		}
	}
}
