import java.util.Scanner;

public class Main {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		String filename = "A-small.in";
		Scanner scanner = new Scanner(Main.class.getResourceAsStream(filename));

		int noOfCase = scanner.nextInt();
		scanner.nextLine();

		for (int caseNo = 1; caseNo <= noOfCase; caseNo++) {
			boolean[][] xStatus = new boolean[4][4];
			boolean[][] oStatus = new boolean[4][4];
			int dotCount = 0;

			for (int i = 0; i < 4; i++) {
				String line = scanner.nextLine();
				char[] chars = line.toCharArray();

				for (int j = 0; j < 4; j++) {
					if (chars[j] == 'X') {
						xStatus[i][j] = true;
					} else if (chars[j] == 'O') {
						oStatus[i][j] = true;
					} else if (chars[j] == 'T') {
						xStatus[i][j] = true;
						oStatus[i][j] = true;
					} else {
						dotCount++;
					}
				}
			}

			boolean xWin = win(xStatus);
			boolean oWin = win(oStatus);

			if (xWin) {
				System.out.println("Case #" + caseNo + ": X won");
			} else if (oWin) {
				System.out.println("Case #" + caseNo + ": O won");
			} else if (!xWin && !oWin && dotCount == 0) {
				System.out.println("Case #" + caseNo + ": Draw");
			} else if (!xWin && !oWin && dotCount > 0) {
				System.out.println("Case #" + caseNo + ": Game has not completed");
			}

			if (scanner.hasNextLine())
				scanner.nextLine();
		}

		scanner.close();
	}

	public static boolean win(boolean[][] status) {

		for (int i = 0; i < 4; i++) {
			if (status[i][0] && status[i][1] && status[i][2] && status[i][3]) {
				return true;
			}
		}

		for (int i = 0; i < 4; i++) {
			if (status[0][i] && status[1][i] && status[2][i] && status[3][i]) {
				return true;
			}
		}

		if (status[0][0] && status[1][1] && status[2][2] && status[3][3]) {
			return true;
		}

		if (status[0][3] && status[1][2] && status[2][1] && status[3][0]) {
			return true;
		}

		return false;
	}
}
