import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.StreamTokenizer;
import java.util.Arrays;
import java.util.Locale;
import java.util.Random;

public final class B {

	static {
		final Locale us = Locale.US;
		if (!Locale.getDefault().equals(us)) {
			Locale.setDefault(us);
		}
	}

	static boolean file = true;
	static boolean isLocal = true;

	private static int nextInt() throws IOException {
		in.nextToken();
		return (int) in.nval;
	}

	private static String nextWord() throws IOException {
		in.nextToken();
		return in.sval;
	}

	static StreamTokenizer in;
	static {
		try {
			// in = new Scanner(file ? new
			// FileInputStream("c:\\var\\tmp\\in.txt")
			// : System.in);

			// in = new BufferedReader(new InputStreamReader(
			// file ? new FileInputStream("c:\\var\\tmp\\in.txt")
			// : System.in));

			in = new StreamTokenizer(new BufferedReader(new InputStreamReader(
					file ? new FileInputStream("c:\\var\\tmp\\in.txt")
							: System.in)));
		} catch (final FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	static PrintWriter out;
	static {
		try {
			out = file ? new PrintWriter(
					new FileWriter("c:\\var\\tmp\\out.txt")) : new PrintWriter(
					System.out);
		} catch (final IOException e) {
			e.printStackTrace();
		}
	}

	static PrintStream err;
	static {
		err = System.err;
	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(final String[] args) throws IOException {

		final long startTime = System.nanoTime();
		final int t = nextInt();

		for (int i = 0; i < t; ++i) {
			solve(i + 1);
			if (isLocal && file) {
				err.println(i + 1 + "/" + t);
			}
			if (isLocal && !file) {
				out.flush();
			}
		}

		if (isLocal) {
			err.println(String.format("Completed after %d ms.",
					(System.nanoTime() - startTime) / 1000000));
		}

		out.flush();
		if (file) {
			out.close();
		}

	}

	private static void Assert(final boolean x) {
		if (!x) {
			System.err.println("Assertion failed");
		}
	}

	private static void solve(final int testId) throws IOException {
		final Random gen = new Random();

		final double M = 1;

		final int n = nextInt();
		final double X = nextInt() * M;
		final double Y = nextInt() * M;

		final double[] xs = new double[n];
		final double[] ys = new double[n];
		final double[] rs = new double[n];

		for (int i = 0; i < n; ++i) {
			rs[i] = nextInt() * M;
		}

		final boolean[] happy = new boolean[n];
		Arrays.fill(happy, false);
		int nHappy = 0;

		int iter = 0;
		while (nHappy < n) {
			++iter;
			System.err.flush();
			for (int i = 0; i < n; ++i) {
				if (!happy[i]) {
					xs[i] = Math.round(gen.nextDouble() * X);
					ys[i] = Math.round(gen.nextDouble() * Y);
					happy[i] = true;
					++nHappy;
				}
			}

			for (int i = 0; i < n; ++i) {
				for (int j = 0; j < i; ++j) {
					if (sqr(xs[i] - xs[j]) + sqr(ys[i] - ys[j]) < sqr(rs[i]
							+ rs[j])) {
						if (happy[i]) {
							happy[i] = false;
							--nHappy;
						}
						if (happy[j]) {
							happy[j] = false;
							--nHappy;
						}
					}
				}
			}
			System.err.printf("Case %d, iteration %d, nHappy = %d/%d\n",
					testId, iter, nHappy, n);
		}

		out.printf("Case #%d:", testId);
		for (int i = 0; i < n; ++i) {
			out.printf(" %.3f %.3f", xs[i], ys[i]);
		}
		out.println();

	}

	private static double sqr(final double d) {
		return d * d;
	}
}
