import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class A {
	// static final PrintWriter out = new PrintWriter(System.out);

	static class Diamond {
		private int k;
		private final int[][] data = new int[200][200];

		public Diamond() {

		}

		private void assertPosition(final int i, final int j) {
			assert insideDiamond(i, j);
		}

		/**
		 * @param i
		 * @param j
		 * @return
		 */
		private int cost(final int centerRow, final int centerCol) {
			final int enhanced = enhancedSize(centerRow, centerCol);
			// out.println("Enhanced size: " + enhanced + ", curent size: " +
			// k);
			return enhanced * enhanced - k * k;
		}

		/**
		 * @return
		 */
		public int enhance() {
			int ans = Integer.MAX_VALUE;
			for (int i = 0; i < getHeight(); ++i) {
				for (int j = 0; j < getMaxWidth(); ++j) {
					if (symmetrical(i, j)) {
						ans = Math.min(ans, cost(i, j));
					}
				}
			}
			assert ans != Integer.MAX_VALUE;

			return ans;
		}

		private int enhancedSize(final int centerRow, final int centerCol) {
			return maxDistance(centerRow, centerCol) + 1;
		}

		int get(final int i, final int j) {
			assertPosition(i, j);
			return data[i][j];
		}

		/**
		 * @param centerRow
		 * @param centerCol
		 * @param i
		 * @param j
		 * @return
		 */
		private int getDistance(final int centerRow, final int centerCol,
				final int i, final int j) {
			return Math.abs(centerRow - i) + Math.abs(centerCol - j);
		}

		private int getHeight() {
			return getSize();
		}

		public int getK() {
			return k;
		}

		private int getMaxWidth() {
			return getSize();
		}

		/**
		 * @param i
		 * @return
		 */
		private int getOffset(final int i) {
			return (getMaxWidth() - getWidth(i)) / 2;
		}

		private int getSize() {
			return 2 * k - 1;
		}

		private int getWidth(final int i) {
			return i + 1 <= k ? 2 * (i + 1) - 1 : 2 * (k - (i + 1 - k)) - 1;
		}

		private boolean insideDiamond(final int i, final int j) {
			return i >= 0 && j >= getOffset(i) && i < getHeight()
					&& j < getOffset(i) + getWidth(i);
		}

		/**
		 * @param centerRow
		 * @param centerCol
		 * @return
		 */
		private int maxDistance(final int centerRow, final int centerCol) {
			int ans = Integer.MIN_VALUE;

			ans = Math.max(ans, getDistance(centerRow, centerCol,
					getHeight() / 2, 0));
			ans = Math.max(ans, getDistance(centerRow, centerCol,
					getHeight() / 2, getMaxWidth() - 1));
			ans = Math.max(ans, getDistance(centerRow, centerCol, 0,
					getOffset(0)));
			ans = Math.max(ans, getDistance(centerRow, centerCol,
					getHeight() - 1, getOffset(getHeight() - 1)));

			return ans;
		}

		/**
		 * @param in
		 */
		public void read(final Scanner in) {
			k = in.nextInt();
			for (int i = 0; i < getHeight(); ++i) {
				final int l = getWidth(i);
				final int offset = getOffset(i);

				for (int j = offset; j < offset + l; j += 2) {
					set(i, j, in.nextInt());
				}
			}
		}

		/**
		 * @param i
		 * @param j
		 * @param nextInt
		 */
		void set(final int i, final int j, final int v) {
			assertPosition(i, j);
			data[i][j] = v;
		}

		private boolean symmetrical(final int row, final int col) {
			for (int i = 0; i < getHeight(); ++i) {
				final int offset = getOffset(i);
				final int width = getWidth(i);

				for (int j = offset; j < offset + width; j += 2) {
					final int i1 = i;
					final int j1 = j;
					final int i2 = 2 * row - i1;
					final int j2 = 2 * col - j1;

					if (insideDiamond(i1, j2) && get(i1, j1) != get(i1, j2)) {
						return false;
					}

					if (insideDiamond(i2, j1) && get(i1, j1) != get(i2, j1)) {
						return false;
					}
				}
			}

			return true;
		}
	};

	private static boolean file = true;
	static Scanner in;
	static {
		try {
			in = file ? new Scanner(new FileReader("f:\\var\\tmp\\in.txt"))
					: new Scanner(System.in);
		} catch (final FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	static PrintWriter out;

	static {
		try {
			out = file ? out = new PrintWriter(new FileWriter(
					"f:\\var\\tmp\\out.txt", false)) : new PrintWriter(
					System.out);
		} catch (final IOException e) {
			e.printStackTrace();
		}
	}

	/**
	 * @param args
	 */
	public static void main(final String[] args) {
		try {
			final int t = in.nextInt();
			for (int i = 0; i < t; ++i) {
				solve(i + 1);
			}

		} finally {
			in.close();
			out.close();
		}
	}

	private static void solve(final int cas) {
		final Diamond diamond = new Diamond();

		diamond.read(in);

		out.println("Case #" + cas + ": " + diamond.enhance());
		if (!file) {
			out.flush();
		}
	}
}
