import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class GcjC {

	private static BigInteger gcd(final BigInteger p, final BigInteger q) {
		if (q.equals(new BigInteger("0"))) {
			return p;
		} else {
			return gcd(q, p.mod(q));
		}
	}

	private static BigInteger gcd(final List<BigInteger> v) {
		BigInteger ans = v.get(0);

		for (int i = 1; i < v.size(); ++i) {
			ans = gcd(ans, v.get(i));
		}

		return ans;
	}

	/**
	 * @param args
	 * @throws IOException
	 */
	public static void main(final String[] args) throws IOException {
		final Scanner in = new Scanner(new File("f:\\var\\tmp\\input.txt"));

		final PrintWriter out = new PrintWriter(new File(
				"f:\\var\\tmp\\output.txt"));

		final int tc = in.nextInt();

		for (int ti = 1; ti <= tc; ++ti) {
			final int n = in.nextInt();

			final List<BigInteger> v = new ArrayList<BigInteger>();

			for (int i = 0; i < n; ++i) {
				v.add(in.nextBigInteger());

			}

			BigInteger m = v.get(0);
			for (int i = 1; i < n; ++i) {
				if (v.get(i).compareTo(m) == -1) {
					m = v.get(i);
				}
			}

			for (int i = 0; i < n; ++i) {
				v.set(i, v.get(i).subtract(m));
			}

			final BigInteger g = gcd(v);

			final BigInteger mod = m.mod(g);

			final BigInteger ans = mod.equals(new BigInteger("0")) ? new BigInteger(
					"0")
					: g.subtract(mod);

			out.println("Case #" + ti + ": " + ans.toString());
		}
		out.close();
	}
}
