package codejam.round.one.c;

import java.io.File;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;
import java.util.SortedMap;
import java.util.TreeMap;
import java.util.concurrent.Future;
import java.util.concurrent.LinkedBlockingQueue;
import java.util.concurrent.ThreadFactory;
import java.util.concurrent.ThreadPoolExecutor;
import java.util.concurrent.TimeUnit;


public class A {
	
	
	private static final String FILE_IN = "resources/A-small-attempt3.in";
	private static final String FILE_OUT = "resources/A-small-attempt3.out";
	
//	private static final String FILE_IN = "resources/a.in";
//	private static final String FILE_OUT = "resources/a.out";

	
	private long allStart;
	
	private static final String IMP = "impossible";
	
	private static final String OUT_FORMAT = "Case #%d: %s";
	
	
	private SortedMap<Integer, String> outputLines = Collections.synchronizedSortedMap(new TreeMap<Integer, String>());

    private ThreadPoolExecutor executor = new ThreadPoolExecutor(8, 8, 5, TimeUnit.DAYS, new LinkedBlockingQueue<Runnable>(), new ThreadFactory() {
        @Override
        public Thread newThread(Runnable r) {
            Thread thread = new Thread(r);
            thread.setDaemon(true);
            return thread;
        }
    });
	
	
	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner ( new File ( FILE_IN ) );
		
		int testCount = in.nextInt();
		List<InputData> inputDataList = new ArrayList<>();
		for ( int test = 0; test < testCount; ++test ) {
			InputData inputData = new InputData(in);
			inputDataList.add(inputData);
		}
		in.close();
		A template = new A();
		template.run(inputDataList);
	}
	
	
	private void run(List<InputData> inputDataList) throws Exception {
		allStart = System.currentTimeMillis();
		
		Path outPath = Paths.get(FILE_OUT);
		Charset charset = Charset.forName("US-ASCII");

		List<Future<?>> tasks = new ArrayList<>(inputDataList.size());
		int i = 0;
		for (final InputData inputData : inputDataList){
			final int fi = i++;
			tasks.add(executor.submit(new Runnable() {
                @Override
                public void run() {
                    try {
                        runCase((fi+1), inputData);
                    } catch (Throwable t) {
                        t.printStackTrace();
                    }
                }
            }));
		}
		for (Future<?> task : tasks) {
            task.get();
        }
		long allEnd = System.currentTimeMillis();
		
		System.out.printf ( "%dms\n", allEnd-allStart );
		Files.write(outPath, outputLines.values(), charset, StandardOpenOption.WRITE, StandardOpenOption.CREATE, StandardOpenOption.TRUNCATE_EXISTING);
	}

	 public void runCase(int caseNumber, InputData inputData) {
//		 if (!inputData.possible()){
//			 outputLines.put(caseNumber, String.format(Locale.ENGLISH, OUT_FORMAT, caseNumber, IMP));
//			 return;
//		 }
		 double value = inputData.getValue();
		 int generation = 0;
		 
		 int testGeneration = 0;
		 while (generation <= 40){
			 generation++;
			 value *= 2;
			 if (value >= 1 && testGeneration == 0){
				 testGeneration = generation;
			 }
			 if (value == (long)value){
				 break;
			 }
			 
		 }
		 if (testGeneration >= 0 && generation <= 40){
			 outputLines.put(caseNumber, String.format(Locale.ENGLISH, OUT_FORMAT, caseNumber, testGeneration));
		 }else{
			 outputLines.put(caseNumber, String.format(Locale.ENGLISH, OUT_FORMAT, caseNumber, IMP));
		 }
		 
	 }

	private static class InputData {
		
		private long p;
		private long q;
		
		public InputData(Scanner in){
			String number = in.next();
			int slash = number.indexOf('/');
			p = Long.valueOf(number.substring(0, slash));
			q = Long.valueOf(number.substring(slash+1));
		}
		
		private double getValue(){
			double result = (double)p/(double)q;
			return result;
		}
		
		private boolean possible(){
			return (q % 2 == 0);
		}

		@Override
		public String toString() {
			return "InputData [p=" + p + ", q=" + q + "]";
		}
		
		
		
	}
}








