import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, Scanner in, PrintWriter out) {
            final int R = in.nextInt();
            final int C = in.nextInt();

            char[][] cells = new char[R][C];
            for (int i = 0; i < R; i++) {
                String row = in.next();
                System.arraycopy(row.toCharArray(), 0, cells[i], 0, C);
            }

            boolean isEnd = false;
            while (!isEnd) {
                for (int r = 0; r < R; r++) {
                    boolean isAllWildcard = true;
                    for (int c = 0; c < C; c++) {
                        if (cells[r][c] != '?') {
                            isAllWildcard = false;
                            // Copy to the left
                            for (int c2 = c - 1; c2 >= 0; c2--) {
                                if (cells[r][c2] == '?') {
                                    cells[r][c2] = cells[r][c];
                                } else {
                                    break;
                                }
                            }

                            // Copy to the right
                            for (int c2 = c + 1; c2 < C; c2++) {
                                if (cells[r][c2] == '?') {
                                    cells[r][c2] = cells[r][c];
                                } else {
                                    break;
                                }
                            }
                        }
                    }

                    if (isAllWildcard) {
                        if (r != 0 && cells[r - 1][0] != '?') {
                            // Copy above
                            System.arraycopy(cells[r - 1], 0, cells[r], 0, C);
                        } else {
                            // Copy below
                            System.arraycopy(cells[r + 1], 0, cells[r], 0, C);
                        }
                    }

                    if (r == R - 1) {
                        boolean hasWildcard = false;
                        for (int r2 = 0; r2 < R && !hasWildcard; r2++) {
                            for (int c2 = 0; c2 < C && !hasWildcard; c2++) {
                                if (cells[r2][c2] == '?') {
                                    hasWildcard = true;
                                }
                            }
                        }
                        if (!hasWildcard) {
                            isEnd = true;
                        }
                    }
                }
            }
            out.write(String.format("Case #%d:\n", testNumber));
            for (int r = 0; r < R; r++) {
                for (int c = 0; c < C; c++) {
                    out.write(cells[r][c]);
                }
                out.write('\n');
            }
        }

    }
}

