import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.List;
import java.util.Scanner;
import java.util.Collections;
import java.util.ArrayList;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        private static final int C = 0;
        private static final int J = 1;

        public void solve(int testNumber, Scanner in, PrintWriter out) {
            final int AC = in.nextInt();
            final int AJ = in.nextInt();

            List<TaskB.Care> cares = new ArrayList<>();
            int totalC = 0;
            for (int i = 0; i < AC; i++) {
                TaskB.Care care = new TaskB.Care(C, in.nextInt(), in.nextInt());
                totalC += care.end - care.start;
                cares.add(care);
            }

            int totalJ = 0;
            for (int i = 0; i < AJ; i++) {
                TaskB.Care care = new TaskB.Care(J, in.nextInt(), in.nextInt());
                totalJ += care.end - care.start;
                cares.add(care);
            }
            Collections.sort(cares);

            if (AC + AJ <= 1) {
                out.write(String.format("Case #%d: %d\n", testNumber, 2));
            } else {
                TaskB.Care c1 = cares.get(0);
                TaskB.Care c2 = cares.get(1);

                if (c1.person == c2.person) {
                    int remain = 720 - (c1.end - c1.start + c2.end - c2.start);
                    // Checks if cares can be concatenated
                    if (c2.start - c1.end <= remain || c1.start + 1440 - c2.end <= remain) {
                        out.write(String.format("Case #%d: %d\n", testNumber, 2));
                    } else {
                        out.write(String.format("Case #%d: %d\n", testNumber, 4));
                    }
                } else {
                    out.write(String.format("Case #%d: %d\n", testNumber, 2));
                }
            }
        }

        private static class Care implements Comparable<TaskB.Care> {
            int person;
            int start;
            int end;

            Care(int person, int start, int end) {
                this.person = person;
                this.start = start;
                this.end = end;
            }


            public int compareTo(TaskB.Care o) {
                return start - o.start;
            }

        }

    }
}

