import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;
import java.util.Collections;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, Scanner in, PrintWriter out) {
            final int N = in.nextInt();
            final int K = in.nextInt();

            TaskA.Cake[] cakes = new TaskA.Cake[N];
            for (int i = 0; i < N; i++) {
                cakes[i] = new TaskA.Cake(in.nextInt(), in.nextInt());
            }
            Arrays.sort(cakes, Collections.reverseOrder());

            double[][] dp = new double[N + 1][K + 1];
            for (int i = 0; i < N; i++) {
                TaskA.Cake cake = cakes[i];
                double areaR = Math.PI * cake.r * cake.r;
                double areaH = Math.PI * cake.r * 2.0 * cake.h;

                int max = Math.min(i, K - 1);
                for (int j = 0; j <= max; j++) {
                    // Chooses a cake
                    if (j == 0) {
                        dp[i + 1][j + 1] = Math.max(dp[i + 1][j + 1], dp[i][j] + areaR + areaH);
                    } else {
                        dp[i + 1][j + 1] = Math.max(dp[i + 1][j + 1], dp[i][j] + areaH);
                    }

                    // Do nothing
                    dp[i + 1][j] = Math.max(dp[i + 1][j], dp[i][j]);
                }
                dp[i + 1][K] = Math.max(dp[i + 1][K], dp[i][K]);
            }
            out.write(String.format("Case #%d: %.7f\n", testNumber, dp[N][K]));
        }

        private static class Cake implements Comparable<TaskA.Cake> {
            private int r;
            private int h;

            Cake(int r, int h) {
                this.r = r;
                this.h = h;
            }


            public int compareTo(TaskA.Cake o) {
                return (r == o.r) ? h - o.h : r - o.r;
            }

        }

    }
}

