import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.List;
import java.util.Scanner;
import java.util.ArrayList;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        private int P;

        public void solve(int testNumber, Scanner in, PrintWriter out) {
            final int N = in.nextInt();
            P = in.nextInt();

            int[] grams = new int[N];
            for (int i = 0; i < N; i++) grams[i] = in.nextInt();

            int[][] packages = new int[N][P];
            for (int i = 0; i < N; i++)
                for (int p = 0; p < P; p++)
                    packages[i][p] = in.nextInt();

            int result = 0;
            if (N == 1) {
                for (int amount : packages[0]) {
                    if (getNum(grams[0], amount).size() != 0) {
                        result++;
                    }
                }
            } else {
                boolean[][] graph = new boolean[P][P];
                for (int i = 0; i < P; i++) {
                    List<Integer> n1 = getNum(grams[0], packages[0][i]);
                    for (int j = 0; j < P; j++) {
                        List<Integer> n2 = getNum(grams[1], packages[1][j]);
                        for (int num : n1) {
                            if (n2.contains(num)) {
                                graph[i][j] = true;
                                break;
                            }
                        }
                    }
                }

                result = maxBpm(graph);
            }
            out.write(String.format("Case #%d: %d\n", testNumber, result));
        }

        private List<Integer> getNum(int required, int amount) {
            amount *= 10;
            int max = amount / (required * 9);
            int min = amount / (required * 11);

            List<Integer> num = new ArrayList<>();
            for (int i = min; i <= max; i++) {
                long minAmount = required * i * 9;
                long maxAmount = required * i * 11;
                if (amount >= minAmount && amount <= maxAmount) {
                    num.add(i);
                }
            }
            return num;
        }

        private boolean bpm(boolean[][] graph, int u, boolean[] seen, int[] matchR) {
            for (int v = 0; v < P; v++) {
                if (graph[u][v] && !seen[v]) {
                    seen[v] = true;
                    if (matchR[v] < 0 || bpm(graph, matchR[v], seen, matchR)) {
                        matchR[v] = u;
                        return true;
                    }
                }
            }
            return false;
        }

        private int maxBpm(boolean[][] graph) {
            int[] matchR = new int[P];

            for (int i = 0; i < P; ++i)
                matchR[i] = -1;

            int result = 0;
            for (int u = 0; u < P; u++) {
                boolean[] seen = new boolean[P];
                for (int i = 0; i < P; ++i)
                    seen[i] = false;
                if (bpm(graph, u, seen, matchR))
                    result++;
            }
            return result;
        }

    }
}

