import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        public void solve(int testNumber, Scanner in, PrintWriter out) {
            final int N = in.nextInt();
            int[] numUnicorns = new int['Y' + 1];
            numUnicorns['R'] = in.nextInt();
            numUnicorns['O'] = in.nextInt();
            numUnicorns['Y'] = in.nextInt();
            numUnicorns['G'] = in.nextInt();
            numUnicorns['B'] = in.nextInt();
            numUnicorns['V'] = in.nextInt();

            char[] primary = {'R', 'Y', 'B'};
            char[] secondary = {'G', 'V', 'O'};
            for (int i = 0; i < primary.length; i++) {
                if (numUnicorns[secondary[i]] != 0 && numUnicorns[primary[i]] == numUnicorns[secondary[i]]) {
                    if (N != numUnicorns[primary[i]] + numUnicorns[secondary[i]]) {
                        out.write(String.format("Case #%d: IMPOSSIBLE\n", testNumber));
                        return;
                    }

                    StringBuilder sb = new StringBuilder();
                    for (int j = 0; j < numUnicorns[primary[i]]; j++) {
                        sb.append(primary[i]).append(secondary[i]);
                    }

                    out.write(String.format("Case #%d: %s\n", testNumber, sb.toString()));
                    return;
                }
            }

            if (numUnicorns['O'] > numUnicorns['B']
                    || numUnicorns['G'] > numUnicorns['R']
                    || numUnicorns['V'] > numUnicorns['Y']) {
                out.write(String.format("Case #%d: IMPOSSIBLE\n", testNumber));
                return;
            }

            numUnicorns['R'] -= numUnicorns['G'];
            numUnicorns['Y'] -= numUnicorns['V'];
            numUnicorns['B'] -= numUnicorns['O'];

            System.out.println("Test = " + testNumber);
            System.out.println("R = " + numUnicorns['R']);
            System.out.println("Y = " + numUnicorns['Y']);
            System.out.println("B = " + numUnicorns['B']);

            if (numUnicorns['R'] > numUnicorns['Y'] + numUnicorns['B']
                    || numUnicorns['Y'] > numUnicorns['B'] + numUnicorns['R']
                    || numUnicorns['B'] > numUnicorns['R'] + numUnicorns['Y']) {
                out.write(String.format("Case #%d: IMPOSSIBLE\n", testNumber));
                return;
            }

            char[] indexes = {'R', 'Y', 'B'};
            StringBuilder sb = new StringBuilder();
            while (true) {
                char prev = (sb.length() != 0) ? sb.charAt(sb.length() - 1) : 0;

                char c = 0;
                for (int i = 0, num = 0; i < indexes.length; i++) {
                    if (indexes[i] != prev && (numUnicorns[indexes[i]] > num || (numUnicorns[indexes[i]] != 0
                            && numUnicorns[indexes[i]] == num && prev != 0 && indexes[i] == sb.charAt(0)))) {
                        num = numUnicorns[indexes[i]];
                        c = indexes[i];
                    }
                }
                if (c == 0) break;
                sb.append(c);
                numUnicorns[c]--;
            }

            if (numUnicorns['G'] != 0) {
                replaceString(sb, 'R', 'G', numUnicorns['G']);
            }
            if (numUnicorns['V'] != 0) {
                replaceString(sb, 'Y', 'V', numUnicorns['V']);
            }
            if (numUnicorns['O'] != 0) {
                replaceString(sb, 'B', 'O', numUnicorns['O']);
            }
            out.write(String.format("Case #%d: %s\n", testNumber, sb.toString()));
        }

        private void replaceString(StringBuilder sb, char primary, char secondary, int num) {
            StringBuilder r = new StringBuilder();
            r.append(primary);
            for (int i = 0; i < num; i++) {
                r.append(secondary).append(primary);
            }
            for (int i = 0; i < sb.length(); i++) {
                if (sb.charAt(i) == primary) {
                    sb.replace(i, i + 1, r.toString());
                    return;
                }
            }
        }

    }
}

