import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "C-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("c.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskC solver = new TaskC();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskC {
        public void solve(int testNumber, Scanner in, PrintWriter out) {
            final int N = in.nextInt();
            final int K = in.nextInt();

            double U = in.nextDouble();
            double[] p = new double[N];
            for (int i = 0; i < N; i++) {
                p[i] = in.nextDouble();
            }

            if (N == 1) {
                p[0] += U;
                out.write(String.format("Case #%d: %.7f\n", testNumber, p[0]));
                return;
            }

            Arrays.sort(p);
            for (int i = 1; Double.compare(U, 0) > 0 && i < N; i++) {
                double diff = p[i] - p[0];
                if (Double.compare(U, diff * i) >= 0) {
                    for (int j = 0; j < i; j++) p[j] += diff;
                    U -= diff * i;
                } else {
                    for (int j = 0; j < i; j++) p[j] += U / i;
                    U = 0;
                }
            }

            if (Double.compare(U, 0) > 0) {
                double diff = 1.0 - p[0];
                if (Double.compare(U, diff * N) >= 0) {
                    out.write(String.format("Case #%d: %.7f\n", testNumber, 1.0));
                    return;
                }
                for (int i = 0; i < N; i++) p[i] += U / N;
            }

            double result = 1.0;
            for (int i = 0; i < N; i++) {
                result *= p[i];
            }
            out.write(String.format("Case #%d: %.7f\n", testNumber, result));
        }

    }
}

