import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileInputStream;
import java.util.Scanner;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.io.IOException;
import java.io.FileOutputStream;
import java.io.File;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
	public static void main(String[] args) {
		Locale.setDefault(Locale.US);
		InputStream inputStream;
		try {
			final String regex = "C-(small|large).*[.]in";
			File directory = new File(".");
			File[] candidates = directory.listFiles(new FilenameFilter() {
				public boolean accept(File dir, String name) {
					return name.matches(regex);
				}
			});
			File toRun = null;
			for (File candidate : candidates) {
				if (toRun == null || candidate.lastModified() > toRun.lastModified())
					toRun = candidate;
			}
			inputStream = new FileInputStream(toRun);
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		OutputStream outputStream;
		try {
			outputStream = new FileOutputStream("c.out");
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
		Scanner in = new Scanner(inputStream);
		PrintWriter out = new PrintWriter(outputStream);
		TaskC solver = new TaskC();
		int testCount = Integer.parseInt(in.next());
		for (int i = 1; i <= testCount; i++)
			solver.solve(i, in, out);
		out.close();
	}
}

class TaskC {
    final int[][] MATRIX = {
            {0, 1, 2, 3, 4, 5, 6, 7},
            {1, 4, 3, 6, 5, 0, 7, 2},
            {2, 7, 4, 1, 6, 3, 0, 5},
            {3, 2, 5, 4, 7, 6, 1, 0},
            {4, 5, 6, 7, 0, 1, 2, 3},
            {5, 0, 7, 2, 1, 4, 3, 6},
            {6, 3, 0, 5, 2, 7, 4, 1},
            {7, 6, 1, 0, 3, 2, 5, 4},
    };

    public void solve(int testNumber, Scanner in, PrintWriter out) {
        final int L = in.nextInt(), LX = L * in.nextInt();
        String str = in.next();

        int[] values = new int[LX];
        for (int i = 0; i < L; i++)
            values[i] = (str.charAt(i) == 'i') ? 1 : (str.charAt(i) == 'j') ? 2 : 3;
        for (int i = L; i < LX; i++)
            values[i] = values[i % L];

        int[][] cache = new int[LX][LX];
        for (int i = 0; i < LX; i++) {
            cache[i][i] = values[i];
            for (int j = i + 1; j < LX; j++) {
                cache[i][j] = MATRIX[cache[i][j - 1]][values[j]];
            }
        }

        for (int i = 0; i < LX; i++) {
            if (cache[0][i] == 1) {
                for (int j = i + 1; j + 1 < LX; j++) {
                    if (cache[i + 1][j] == 2 && cache[j + 1][LX - 1] == 3) {
                        out.println("Case #" + testNumber + ": YES");
                        return;
                    }
                }
            }
        }
        out.println("Case #" + testNumber + ": NO");
    }
}

