import java.util.*;
import java.io.*;

public class Main {

	class FastIO {
		BufferedReader br;
		StringTokenizer st;
		PrintWriter out;

		public FastIO(File in, File o) {
			try {
				br = new BufferedReader(new FileReader(in));
				out = new PrintWriter(new FileWriter(o));
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			eat("");
		}

		public FastIO() {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(new OutputStreamWriter(System.out));
			eat("");
		}

		public void eat(String s) {
			st = new StringTokenizer(s);
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				throw new IOError(e);
			}
		}

		public boolean hasNext() {
			while (!st.hasMoreTokens()) {
				String s = nextLine();
				if (s == null)
					return false;
				eat(s);
			}
			return true;
		}

		public String next() {
			hasNext();
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}

		public double nextDouble() {
			return Double.parseDouble(next());
		}

		public void print(String ans) {
			out.print(ans);
			out.flush();
		}

		public void println(String ans) {
			out.println(ans);
			out.flush();
		}

		public void println() {
			println("");
		}

		public void println(Object ans[]) {
			for (Object cur : ans)
				print(cur.toString() + " ");
			println();
		}

		public void println(Object ans[][]) {
			for (int i = 0; i < ans.length; i++) {
				for (int j = 0; j < ans[i].length; i++) {
					print(ans[i] + " ");
				}
				println();
			}
		}

		public void close() {
			out.close();
		}

	}

	FastIO scan = new FastIO(new File("a.in"), new File("a.out"));

	// FastIO scan = new FastIO();

	public void solve() {
		int a = scan.nextInt();
		int ans = -1;
		int cnt = 0;
		int a1[][] = new int[4][4];
		TreeSet<Integer> set = new TreeSet<Integer>();
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				a1[i][j] = scan.nextInt();
				if (i == (a - 1))
					set.add(a1[i][j]);
			}
		}
		int b = scan.nextInt();
		int b1[][] = new int[4][4];
		for (int i = 0; i < 4; i++) {
			for (int j = 0; j < 4; j++) {
				b1[i][j] = scan.nextInt();
				if (i == (b - 1)) {
					if (set.contains(b1[i][j])) {
						ans = b1[i][j];
						cnt++;
					}
				}
			}
		}
		if (cnt == 0) {
			scan.println("Volunteer cheated!");
		} else if (cnt == 1) {
			scan.println("" + ans);
		} else
			scan.println("Bad magician!");
	}

	public void run() {
		int t = scan.nextInt();
		for (int i = 1; i <= t; i++) {
			scan.print("Case #" + i + ": ");
			solve();
		}
	}

	public static void main(String args[]) throws Exception {
		new Main().run();
	}
}
