import java.util.*;
import java.io.*;

public class MainB {

	class FastIO {
		BufferedReader br;
		StringTokenizer st;
		PrintWriter out;

		public FastIO(File in, File o) {
			try {
				br = new BufferedReader(new FileReader(in));
				out = new PrintWriter(new FileWriter(o));
			} catch (Exception e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			eat("");
		}

		public FastIO() {
			br = new BufferedReader(new InputStreamReader(System.in));
			out = new PrintWriter(new OutputStreamWriter(System.out));
			eat("");
		}

		public void eat(String s) {
			st = new StringTokenizer(s);
		}

		public String nextLine() {
			try {
				return br.readLine();
			} catch (IOException e) {
				throw new IOError(e);
			}
		}

		public boolean hasNext() {
			while (!st.hasMoreTokens()) {
				String s = nextLine();
				if (s == null)
					return false;
				eat(s);
			}
			return true;
		}

		public String next() {
			hasNext();
			return st.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(next());
		}

		public long nextLong() {
			return Long.parseLong(next());
		}

		public double nextDouble() {
			return Double.parseDouble(next());
		}

		public void print(String ans) {
			out.print(ans);
			out.flush();
		}

		public void println(String ans) {
			out.println(ans);
			out.flush();
		}

		public void println() {
			println("");
		}

		public void println(Object ans[]) {
			for (Object cur : ans)
				print(cur.toString() + " ");
			println();
		}

		public void println(Object ans[][]) {
			for (int i = 0; i < ans.length; i++) {
				for (int j = 0; j < ans[i].length; i++) {
					print(ans[i] + " ");
				}
				println();
			}
		}

		public void printf(String arg0, Object... arg1) {
			out.printf(arg0, arg1);
			out.flush();
		}

		public void close() {
			out.close();
		}
	}

	FastIO scan = new FastIO(new File("in"), new File("out"));

	// FastIO scan = new FastIO();

	public void solve() {
		double C = scan.nextDouble();
		double F = scan.nextDouble();
		double X = scan.nextDouble();
		if (X <= C) {
			scan.printf("%.7f\n", X / 2.0D);
			return;
		}
		double curSpeed = 2.0;
		double Time = 0.0;
		while (true) {
			double temp1 = (X - C) / curSpeed;
			double temp2 = X / (curSpeed + F);
			if (temp1 <= temp2) {
				break;
			} else {
				Time += C / curSpeed;
				curSpeed += F;
			}
		}
		Time += X / curSpeed;
		scan.printf("%.7f\n", Time);
	}

	public void run() {
		int T = scan.nextInt();
		for (int i = 1; i <= T; i++) {
			scan.print("Case #" + i + ": ");
			solve();
		}
	}

	public static void main(String args[]) throws Exception {
		new MainB().run();
	}
}
