package forJSMeetup;

import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Scanner;

public class BathroomStallsNew {
	public static void main(String[] args) {
	    Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
	    int t = Integer.parseInt(in.nextLine());  
	    for (int i = 1; i <= t; ++i) {
	      String n = in.nextLine();
	      String numbers[] = n.split(" ");
	      Long[] maxMinLsRs = calculateBathStall(Long.parseLong(numbers[0]), Long.parseLong(numbers[1]));
	      System.out.println("Case #" + i + ": " + maxMinLsRs[0] + " " + maxMinLsRs[1]);
	    }
	    in.close();
	  }

	private static Long[] calculateBathStall(long n, long k) {
		long level = findLogK(k);
		if (level == 0) {
			return calculateMaxMin(n);
		}
		long filledStalls = calculateFilledStalls(level-1);
		long remaining = n - filledStalls;
		long currentlevelSpots = powerOfTwo(level);
		long whole = remaining/currentlevelSpots, reminder = remaining % currentlevelSpots, position = k-currentlevelSpots;
		long emptySlotcount = whole;
		if (reminder > position) {
			emptySlotcount++;
		} 
		return calculateMaxMin(emptySlotcount);
	}

	private static Long[] calculateMaxMin(long n) {
		if (n % 2 == 0) {
			return new Long[]{n/2, n/2-1};
		} else
			return new Long[]{n/2, n/2};
	}

	private static long calculateFilledStalls(long l) {
		long sum = 1;
		while (l > 0 ) {
			sum = sum + powerOfTwo(l--);
		}
		return sum;
	}

	private static long powerOfTwo(long l) {
		if (l==0) return 1;
		long power = 1;
		while (l-->0) {
			power = power * 2;
		}
		return power;
	}

	private static long findLogK(long k) {
		if (k==1) return 0;
		long pow = 1;
		while ((k = k / 2) > 1) {
			pow++;
		}
		return pow;
	}
}
