package ru.buzden.gcj.gcj2011;

import java.io.*;
import java.math.*;
import java.util.*;

public class B implements Runnable {
    BufferedReader in;
    StringTokenizer st;
    PrintWriter out;

    public static final int SIZE = 255;

    public void solve() throws IOException {
        final int testsAmount = nextInt();

        for (int testNo = 1; testNo <= testsAmount; ++testNo) {
            final char[][] changeTable = new char[SIZE][SIZE];

            final int c = nextInt();
            for (int i = 0; i < c; ++i) {
                final String change = next();

                changeTable[change.charAt(0)][change.charAt(1)] =
                changeTable[change.charAt(1)][change.charAt(0)] = change.charAt(2);
            }

            final boolean[][] oppositeTable = new boolean[SIZE][SIZE];

            final int d = nextInt();
            for (int i = 0; i < d; ++i) {
                final String opposite = next();

                oppositeTable[opposite.charAt(0)][opposite.charAt(1)] =
                oppositeTable[opposite.charAt(1)][opposite.charAt(0)] = true;
            }

            nextInt();
            char[] seq = next().toCharArray();

            ArrayList<Character> currHand = new ArrayList<Character>();

            SEQ_CYCLE:
            for (char k : seq) {
                if (currHand.size() >= 1) {
                    char top = currHand.get(currHand.size() - 1);

                    if (changeTable[top][k] != 0) {
                        currHand.remove(currHand.size() - 1);
                        currHand.add(changeTable[top][k]);

                        continue;
                    }
                }

                for (char existing : currHand) {
                    if (oppositeTable[existing][k]) {
                        currHand.clear();
                        continue SEQ_CYCLE;
                    }
                }

                currHand.add(k);
            }

            out.printf("Case #%d: %s\n", testNo, currHand.toString());
        }
    }

    public void run() {
        try {
            String filename = "B";

            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
            st = new StringTokenizer("");
            solve();
            out.close();
            in.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private String next() throws IOException {
        while (!st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) {
                return null;
            }
            st = new StringTokenizer(line);
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    private BigInteger nextBigInteger() throws IOException {
        return new BigInteger(next());
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new Thread(new B()).start();
    }
}