package ru.buzden.gcj.gcj2011;

import java.awt.*;
import java.io.*;
import java.math.*;
import java.util.*;

import static java.lang.Math.abs;

public class A implements Runnable {
    BufferedReader in;
    StringTokenizer st;
    PrintWriter out;

    public void solve() throws IOException {
        int testsAmount = nextInt();

        for (int testNo = 1; testNo <= testsAmount; ++testNo) {
            int n = nextInt();

            IntegerArrayList[] colouredPrograms = new IntegerArrayList[2];
            for (int i = 0; i < colouredPrograms.length; ++i) {
                colouredPrograms[i] = new IntegerArrayList();
            }

            Point[] program = new Point[n];
            for (int i = 0; i < n; ++i) {
                String colourString = next();
                int position = nextInt();

                int colour = colourString.equals("B") ? 0 : 1;

                program[i] = new Point(colour, position);
                colouredPrograms[colour].add(position);
            }

            int[] position = new int[] {1, 1};

            int[] programPosition = new int[] {0, 0};

            int totalTime = 0;
            for (int programIndex = 0; programIndex < n; ++programIndex) {
                int turnColour = program[programIndex].x;
                int anotherColour = 1 - turnColour;

                int turnTargetPosition = program[programIndex].y;
                int timeOfStep = abs(position[turnColour] - turnTargetPosition) + 1;

                totalTime += timeOfStep;
                position[turnColour] = turnTargetPosition;
                ++programPosition[turnColour];

                if (programPosition[anotherColour] < colouredPrograms[anotherColour].size()) {
                    int anotherTargetPosition = colouredPrograms[anotherColour].get(programPosition[anotherColour]);

                    if (position[anotherColour] != anotherTargetPosition) {
                        if (abs(position[anotherColour] - anotherTargetPosition) > timeOfStep) {
                            int direction = (position[anotherColour] < anotherTargetPosition) ? 1 : -1;

                            position[anotherColour] += direction * timeOfStep;
                        } else {
                            position[anotherColour] = anotherTargetPosition;
                        }
                    }
                }
            }

            out.printf("Case #%d: %d\n", testNo, totalTime);
        }
    }

    protected static class IntegerArrayList extends ArrayList<Integer> {}

    public void run() {
        try {
            String filename = "A-small";

            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
            st = new StringTokenizer("");
            solve();
            out.close();
            in.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private String next() throws IOException {
        while (!st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) {
                return null;
            }
            st = new StringTokenizer(line);
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    private BigInteger nextBigInteger() throws IOException {
        return new BigInteger(next());
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new Thread(new A()).start();
    }
}