import java.io.*;
import java.util.*;
import java.awt.*;

/**
 * Created by IntelliJ IDEA.
 * Date: 03.09.2009
 * Time: 22:27:48
 *
 * @author Denis V. Buzdalov
 */
public class Qual09b {
    protected BufferedReader input = new BufferedReader(new FileReader("B-small-attempt0.in"));
    protected StringTokenizer tokenizer = new StringTokenizer("");
    protected PrintWriter output = new PrintWriter("B-small-attempt0.out");

    public Qual09b() throws FileNotFoundException {
    }

    public static void main(String[] args) throws FileNotFoundException {
        new Qual09b().run();
    }

    protected int[][] map;
    protected Point[][] sinks;
    protected int height, width;

    public void run() {
        int testsAm = nextInt();

        for (int test = 1; test <= testsAm; ++test) {
            height = nextInt();
            width = nextInt();

            map = new int[height][width];

            for (int r = 0; r < height; ++r) {
                for (int c = 0; c < width; ++c) {
                    map[r][c] = nextInt();
                }
            }

            sinks = new Point[height][width];
            for (int r = 0; r < height; ++r) {
                for (int c = 0; c < width; ++c) {
                    if (sinks[r][c] == null) {
                        sinks[r][c] = deep(r, c);
                    }
                }
            }

            output.printf("Case #%d:\n", test);
            char curr = 'a';
            Map<Point, Character> map = new HashMap<Point, Character>();
            for (int r = 0; r < height; ++r) {
                for (int c = 0; c < width; ++c) {
                    if (!map.containsKey(sinks[r][c])) {
                        map.put(sinks[r][c], curr);
                        curr++;
                    }
                    output.print(map.get(sinks[r][c]));
                    output.print(' ');
                }
                output.println();
            }
        }

        output.close();
    }

    protected final int[] dr = new int[] {-1, 0, 0, 1};
    protected final int[] dc = new int[] {0, -1, 1, 0};

    protected Point deep(int r, int c) {
        ArrayList<Point> alts = new ArrayList<Point>(4);
        for (int i = 0; i < 4; ++i) {
            if ((r + dr[i] >= 0) && (r + dr[i] <= height - 1) &&
                    (c + dc[i] >= 0) && (c + dc[i] <= width - 1) &&
                    (map[r + dr[i]][c + dc[i]] < map[r][c])) {
                alts.add(new Point(map[r + dr[i]][c + dc[i]], i));
            }
        }
        if (alts.isEmpty()) {
            return new Point(r, c);
        }

        int indOfMaxInAlts = 0;
        for (int i = 1; i < alts.size(); ++i) {
            if (alts.get(i).x < alts.get(indOfMaxInAlts).x) {
                indOfMaxInAlts = i;
            }
        }

        int indOfMaxInDiffs = alts.get(indOfMaxInAlts).y;
        if (sinks[r + dr[indOfMaxInDiffs]][c + dc[indOfMaxInDiffs]] == null) {
            sinks[r + dr[indOfMaxInDiffs]][c + dc[indOfMaxInDiffs]] = deep(r + dr[indOfMaxInDiffs], c + dc[indOfMaxInDiffs]);
        }
        return sinks[r + dr[indOfMaxInDiffs]][c + dc[indOfMaxInDiffs]];
    }

    protected int nextInt() {
        return Integer.parseInt(nextString());
    }

    protected String nextString() {
        while (!tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(input.readLine());
            } catch (IOException e) {
                return null;
            }
        }
        return tokenizer.nextToken();
    }
}
