import java.io.*;
import java.util.*;

public class Round1_09_a extends Thread {
    protected BufferedReader input = new BufferedReader(new FileReader("A-small-attempt1.in"));
    protected StringTokenizer tokenizer = new StringTokenizer("");
    protected PrintWriter output = new PrintWriter("A-small-attempt1.out");

    public Round1_09_a() throws FileNotFoundException {
    }

    public static void main(String[] args) throws FileNotFoundException {
        new Round1_09_a().start();
    }

    protected String currString = null;

    public void run() {
        Locale.setDefault(Locale.US);

        int testsAm = nextInt();
        for (int test = 1; test <= testsAm; ++test) {
            output.println("Case #" + test + ":");

            int treeLen = nextInt();
            currString = "";
            for (int i = 0; i < treeLen; ++i) {
                try {
                    currString += input.readLine();
                } catch (IOException ignored) {
                }
            }
            tokenizer = new StringTokenizer(currString);
            currString = null;

            Tree tree = loadTree();

            try {
                tokenizer = new StringTokenizer(input.readLine());
            } catch (IOException ignored) {
            }

            int animalsAm = nextInt();
            for (int i = 0; i < animalsAm; ++i) {
                Animal animal = loadAnimal();
                output.printf("%.7f\n", getProb(tree, animal));
            }
        }

        output.close();
    }

    protected double getProb(Tree tree, Animal animal) {
        double res = tree.weight;
        if (tree.first != null) {
            if (animal.features.contains(tree.feature)) {
                res *= getProb(tree.first, animal);
            } else {
                res *= getProb(tree.second, animal);
            }
        }
        return res;
    }

    protected Animal loadAnimal() {
        Animal res = new Animal();
        nextString();
        int am = nextInt();
        res.features = new HashSet<String>(am);
        for (int i = 0; i < am; ++i) {
            res.features.add(nextString());
        }
        return res;
    }

    protected Tree loadTree() {
        Tree tree = new Tree();
        boolean isLeaf = false;

        String s = nextString();
        if (s.length() > 1) {
            if (s.indexOf(')') != -1) {
                tree.weight = Double.parseDouble(s.substring(1, s.indexOf(')')));
                if (s.indexOf(')') < s.length() - 1) {
                    currString = s.substring(s.indexOf(')') + 1, s.length());
                }
                isLeaf = true;
            } else {
                tree.weight = Double.parseDouble(s.substring(1, s.length()));
            }
        } else {
            s = nextString();
            if (s.charAt(s.length() - 1) == ')') {
                tree.weight = Double.parseDouble(s.substring(0, s.length() - 1));
                isLeaf = true;
            } else {
                tree.weight = Double.parseDouble(s);
            }
        }

        if (!isLeaf) {
            s = nextString();
            if (s.startsWith(")")) {
                isLeaf = true;
                if (s.length() > 1) {
                    currString = s.substring(1, s.length());
                } else {
                    currString = null;
                }
            }
        }

        if (isLeaf) {
            tree.first = null;
        } else {
            tree.feature = s;
            tree.first = loadTree();
            tree.second = loadTree();

            s = nextString();
            if (s.startsWith(")")) {
                if (s.length() > 1) {
                    currString = s.substring(1, s.length());
                } else {
                    currString = null;
                }
            } else {
                System.err.println("err!");
            }
            if (s.length() > 1) {
                currString = s.substring(1, s.length());
            }
        }
        return tree;
    }

    protected static class Animal {
        Set<String> features;
    }

    protected static class Tree {
        public double weight;
        public String feature;
        public Tree first;
        public Tree second;
    }

    protected double nextDouble() {
        return Double.parseDouble(nextString());
    }

    protected int nextInt() {
        return Integer.parseInt(nextString());
    }

    protected String nextString() {
        if (currString != null) {
            String t = currString;
            currString = null;
            return t;
        }
        while (!tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(input.readLine());
            } catch (IOException e) {
                return null;
            }
        }
        return tokenizer.nextToken();
    }
}
