import java.io.*;
import java.math.*;
import java.util.*;

public class Qual_10_c implements Runnable {
    BufferedReader in;
    StringTokenizer st;
    PrintWriter out;

    public void solve() throws IOException {
        int testAmount = nextInt();

        for (int test = 1; test <= testAmount; ++test) {
            int rounds = nextInt();
            int capacity = nextInt();
            int groupsAmount = nextInt();

            int[] groups = new int[groupsAmount];
            for (int i = 0; i < groupsAmount; ++i) {
                groups[i] = nextInt();
            }

            int[] caps = new int[groupsAmount];
            for (int i = 0; i < groupsAmount; ++i) {
                int currCap = 0;
                int k = i;
                int counter = 0;
                while ((currCap <= capacity)  && (counter <= groupsAmount)) {
                    ++caps[i];
                    currCap += groups[k];

                    k = (k + 1) % groupsAmount;
                    ++counter;
                }
                --caps[i];
            }

            int res = 0;

            int current = 0;
            for (int r = 0; r < rounds; ++r) {
                for (int i = 0; i < caps[current]; ++i) {
                    res += groups[(current + i) % groupsAmount];
                }

                current = (current + caps[current]) % groupsAmount;
            }

            out.printf("Case #%d: %d\n", test, res);
        }
    }

    public void run() {
        try {
            String filename = "C-small-attempt0";

            in = new BufferedReader(new FileReader(filename + ".in"));
            out = new PrintWriter(filename + ".out");
            st = new StringTokenizer("");
            solve();
            out.close();
            in.close();
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private String next() throws IOException {
        while (!st.hasMoreTokens()) {
            String line = in.readLine();
            if (line == null) {
                return null;
            }
            st = new StringTokenizer(line);
        }
        return st.nextToken();
    }

    private int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    private long nextLong() throws IOException {
        return Long.parseLong(next());
    }

    private double nextDouble() throws IOException {
        return Double.parseDouble(next());
    }

    private BigInteger nextBigInteger() throws IOException {
        return new BigInteger(next());
    }

    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        new Thread(new Qual_10_c()).start();
    }
}