package cjb20111a.b;

import java.util.BitSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;
import java.util.TreeSet;

public class Main {
    Scanner in = new Scanner(System.in);
    
    private void run() {
	int tCount = in.nextInt();
	int tNum = 0;
	while (tNum++ < tCount) {
	    int n = in.nextInt(), m = in.nextInt();
	    in.nextLine();
	    StringBuffer[] words = new StringBuffer[n];
	    
	    String line;
	    for (int i = 0; i < n; i++) {
		words[i] = new StringBuffer();
		words[i].append(in.nextLine());
	    }
	    
	    System.out.print(String.format("Case #%d: ", tNum));
	    
	    for (int i = 0; i < m; i++) {
		line = in.nextLine();
		char[] c = line.toCharArray();
		int[] cnt = new int[n];
		for (int j = 0; j < n; j++) {
		    cnt[j] = getWorst(words, c, j);
		}
		
		int max = 0;
		for (int j = 0; j < n; j++) {
		    if (cnt[j] > cnt[max]) {
			max = j;
		    }
		}
		
		if (i > 0) {
		    System.out.print(" "); 
		}
		System.out.print(words[max].toString());
	    }
	    
	    System.out.println();
	}
    }
    
    private int getWorst(StringBuffer[] words, char[] c, int x) {
	int n = words.length;
	BitSet mask = new BitSet(n);
	for (int i = 0; i < n; i++) {
	    if (words[i].length() == words[x].length()) {
		mask.set(i);
	    }
	}
	
	TreeSet<Character> ct = getSet(words, mask);
	
	int count = 0;
	
	for (int i = 0; i < c.length && mask.cardinality() > 1; i++) {
	    if (ct.contains(c[i])) {
		int pos = -1;
		while ((pos = mask.nextSetBit(pos + 1)) != -1) {
		    if (!compare(words[x], words[pos], c[i])) {
			mask.set(pos, false);
		    }
		}
		
		ct = getSet(words, mask);
		if (!ct.contains(c[i])) {
		    count++;
		}
	    }
	}
	
	return count;
    }
    
    private boolean compare(StringBuffer a, StringBuffer b, char c) {
	for (int i = 0; i < a.length(); i++) {
	    if (a.charAt(i) == c && b.charAt(i) != c || b.charAt(i) == c && a.charAt(i) != c) {
		return false;
	    }
	}
	
	return true;
    }
    
    private TreeSet<Character> getSet(StringBuffer[] words, BitSet mask) {
	TreeSet<Character> result = new TreeSet<Character>();
	for (int pos = mask.nextSetBit(0); pos >= 0; pos = mask.nextSetBit(pos + 1) ) {
	    for (int i = 0; i < words[pos].length(); i++) {
		result.add(words[pos].charAt(i));
	    }
	}
	
	return result;
    }
    
    public static void main(String[] args) {
	Main p = new Main();
	p.run();
    }
}
