/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam;

import java.io.BufferedWriter;
import java.io.IOException;
import java.util.Scanner;

/**
 *
 * @author Ramon
 */
class TicTacToeTomek implements CodeJamSolver
{
    private enum Field
    {
        X('X'), O('O'), T('T'), empty('.'); 
        
        private char c;
        private Field(char c)
        {
            this.c = c;
        }
        
        /**
         * whether this field would add one extra length to a row of the given
         * type
         * @param type
         * @return 
         */
        public boolean addsToRow(Field type)
        {
            if (this == empty)
                return false;
            if (this == T)
                return true;
            return this == type;
        }
        
        public static Field charToField(char c)
        {
            for (Field field : Field.values())
            {
                if (field.c == c)
                    return field;
            }
            return null;
        }
        
        public char toChar()
        {
            return c;
        }
    }
    
    @Override
    public void solve(Scanner in, BufferedWriter out) throws IOException
    {
        int numberOfCases = in.nextInt();
        for (int caseNr = 1; caseNr <= numberOfCases; caseNr++)
        {
            out.write("Case #" + caseNr + ": ");
            Field[][] board = new Field[4][4];
            for (int i = 0; i < 4; i++)
            {
                char[] nextRow = in.next().toCharArray();
                for (int j = 0; j < 4; j++)
                    board[i][j] = Field.charToField(nextRow[j]);
            }
//                for (int j = 0; j < 4; j++)
//                    board[i][j] = Field.charToField((char)in.next());
        
            Field winnerType = findWinner(board);
            if (winnerType != null)
            {
                out.write(winnerType.toChar());
                out.write(" won\n");
            }
            else
            {
                boolean completed = true;
                for (int i = 0; i < 4; i++)
                for (int j = 0; j < 4; j++)
                {
                    if (board[i][j] == Field.empty)
                        completed = false;
                }
                if (completed)
                {
                    out.write("Draw\n");
                }
                else
                {
                    out.write("Game has not completed\n");
                }
            }
        }
    }
    
    public Field findWinner(Field[][] board) throws IOException
    {
        for (Field typeToCheck : new Field[]{Field.O, Field.X})
        {
            Field[][] cleanedBoard = new Field[4][4];
            for (int i = 0; i < 4; i++)
                for (int j = 0; j < 4; j++)
                {
                    if (board[i][j].addsToRow(typeToCheck))
                        cleanedBoard[i][j] = typeToCheck;
                    else
                        cleanedBoard[i][j] = Field.empty;
                }

            // horizontal
            for (int i = 0; i < 4; i++)
            for (int j = 0; j < 4; j++)
            {
                if (cleanedBoard[i][j] != typeToCheck)
                    break;
                if (j == 3)
                    return typeToCheck;
            }

            // vertical
            for (int i = 0; i < 4; i++)
            for (int j = 0; j < 4; j++)
            {
                if (cleanedBoard[j][i] != typeToCheck)
                    break;
                if (j == 3)
                    return typeToCheck;
            }

            // diagonal
            for (int i = 0; i < 4; i++)
            {
                if (cleanedBoard[i][i] != typeToCheck)
                    break;
                if (i == 3)
                    return typeToCheck;
            }

            // diagonal
            for (int i = 0; i < 4; i++)
            {
                if (cleanedBoard[i][3 - i] != typeToCheck)
                    break;
                if (i == 3)
                    return typeToCheck;
            }
        }
        return null;
    }
}
