/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package codejam;

import java.io.BufferedWriter;
import java.io.IOException;
import java.util.Scanner;

/**
 *
 * @author Ramon
 */
public abstract class CaseSolver implements CodeJamSolver
{
    /**
     * solves a problem which contains of multiple cases.
     * @param in should give input starting with the number of cases, then
     * solves every case
     * @param out of the form "Case #n: ...answer..." for each case n from 1 to
     * the number of cases.
     * @throws IOException 
     */
    @Override
    public void solve(Scanner in, BufferedWriter out) throws IOException
    {
        int numberOfCases = in.nextInt();
        for (int caseNr = 1; caseNr <= numberOfCases; caseNr++)
        {
            out.write("Case #" + caseNr + ": " + solveCase(in, caseNr) + "\n");
        }
    }
 
    /**
     * should solve exactly one case of the problem.
     * @param in the input scanner
     * @param caseNr the number of the case
     * @return a string with the answer, starting behind the space behind the
     * colon.
     */
    protected abstract String solveCase(Scanner in, int caseNr);
}
