package codejam;

import java.io.BufferedWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.ListIterator;
import java.util.Scanner;

public class OsmosSolver extends CaseSolver {	
	@Override
	protected String solveCase(Scanner in, int caseNr) {
		final int initialSize = in.nextInt();
		final int nrOfMotes = in.nextInt();
		final LinkedList<Integer> motes = new LinkedList<>();
		
		for (int i = 0; i < nrOfMotes; i++) {
			motes.add(in.nextInt());
		}
		
		// initial size 1, so cannot eat any other mote, so all motes need to be removed
		if (initialSize == 1) {
			return Integer.toString(nrOfMotes);
		}
		
		// sort the motes, starting with the smaller motes always makes sense
		Collections.sort(motes);
		
		// the current best solution
		int currentMinimum = Integer.MAX_VALUE;
		// the current size of the own mote
		int size = initialSize;
		// number of motes yet to eat
		int motesToEat = motes.size();
		// current number of motes added to the list
		int motesAdded = 0;
		
		System.out.println("\ncase " + caseNr + "**************\nsize: " + size);
		for (int i : motes) {
			System.out.print(i + " ");
		}
		System.out.println();
		
		ListIterator<Integer> listIt = motes.listIterator();
		// start eating other motes until none are left
		while (listIt.hasNext()) {
			int nextMote = listIt.next();
			// next mote can simply be eaten
			System.out.print("next mote is " + nextMote + ": ");
			if (nextMote < size) {
				System.out.println("eat, own size is " + (size + nextMote));
				motesToEat--;
				size += nextMote;
			}
			// next mote too large
			else {
				// answer if all following motes are eaten
				int possibleMinimum = motesAdded + motesToEat;
				System.out.println("possible answer: " + possibleMinimum);
				if (possibleMinimum < currentMinimum) {
					currentMinimum = possibleMinimum;
				}
				// add a mote of maximum size and eat it
				if (size > 1) {
					System.out.println("add mote of size " + (size - 1) + " and eat it, own size " + (size*2 - 1));
					size += (size - 1);
					motesAdded++;
					// look at the current mote again
					listIt.previous();
				}
			}
			
			// if no better solution will be found anyway, stop
			if (motesAdded > currentMinimum) {
				break;
			}
		}
		if (motesAdded < currentMinimum) {
			currentMinimum = motesAdded;
		}
		
		System.out.println(currentMinimum);
		return Integer.toString(currentMinimum);
	}

}
