import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class CookieClickerAlpha {
    public static final double INITIAL_COOKIES_PER_SECOND = 2.0f;

    Scanner in;
    int numberOfCases;

    public CookieClickerAlpha() {
        in = new Scanner(System.in);
    }

    private void solveAndPrintResult() {
        double c, f, x;

        numberOfCases = in.nextInt();

        for (int i = 0; i < numberOfCases; i++) {
            c = in.nextDouble();
            f = in.nextDouble();
            x = in.nextDouble();

            System.out.println("Case #" + (i+1) + ": " + calculateTime(c, f, x, INITIAL_COOKIES_PER_SECOND));
        }
    }

    private double calculateTime(double c, double f, double x, double cookiesPerSecond) {
        double timeWithoutFactory = x / cookiesPerSecond;
        double timeWithFactory = (c / cookiesPerSecond) + (x / (cookiesPerSecond + f));

        if (timeWithoutFactory < timeWithFactory) {
            return timeWithoutFactory;
        }
        return c / cookiesPerSecond + calculateTime(c, f, x, cookiesPerSecond + f);
    }

    public static void main(String[] args) {
        CookieClickerAlpha solver = new CookieClickerAlpha();

        solver.solveAndPrintResult();
    }
}
