import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class MagicTrick {
    private static int ROWS = 4;
    private static String ANSWER_BAD = "Bad magician!";
    private static String ANSWER_CHEAT = "Volunteer cheated!";

    Scanner in;
    int numberOfCases;

    public MagicTrick() {
        in = new Scanner(System.in);
    }

    private void solveAndPrintResult() {
        String firstAnswerRow, secondAnswerRow;

        numberOfCases = in.nextInt();

        for (int i = 0; i < numberOfCases; i++) {
            firstAnswerRow = getNextRow();
            secondAnswerRow = getNextRow();
            System.out.println("Case #" + (i+1) + ": " + getResultFor(firstAnswerRow, secondAnswerRow));
        }
    }

    private String getNextRow() {
        int rowNumber = in.nextInt() - 1;
        in.nextLine();

        // skip lines that we don't care about
        for (int j = 0; j < rowNumber; j++) {
            in.nextLine();
        }

        String numbers = in.nextLine();

        // skip lines that we don't care about
        for (int j = rowNumber + 1; j < ROWS; j++) {
            in.nextLine();
        }

        return numbers;
    }


    private String getResultFor(String firstAnswerRow, String secondAnswerRow) {
        String[] firstRowNumbers = firstAnswerRow.split(" ");
        String[] secondRowNumbers = secondAnswerRow.split(" ");
        boolean hasAnswer = false;
        String answer = "";

        for (String firstToken : firstRowNumbers) {
            for (String secondToken : secondRowNumbers) {
                if (firstToken.equals(secondToken)) {
                    answer = hasAnswer ? ANSWER_BAD : firstToken;
                    hasAnswer = true;
                }
            }
        }

        return hasAnswer ? answer : ANSWER_CHEAT;
    }

    public static void main(String[] args) {
        MagicTrick solver = new MagicTrick();

        solver.solveAndPrintResult();
    }
}
