package tidynumbers;

import common.Solver;

import java.io.PrintWriter;
import java.util.Scanner;

public class TidyNumberCalculator implements Solver {
    @Override
    public void solveAllTests(Scanner in, PrintWriter out) {
        int noOfTests = Integer.valueOf(in.nextLine());
        for (int i = 1; i <= noOfTests; i++) {
            long largestNumber = Long.valueOf(in.nextLine());
            long largestTidyNumber = solve(largestNumber);
            out.println("Case #" + i + ": " + largestTidyNumber);
        }
    }

    private long solve(long largestNumber) {
        long largestTidyNumber = largestNumber;
        String largestTidyNumberStr = String.valueOf(largestTidyNumber);

        for (int i = largestTidyNumberStr.length() - 1; i >= 0; i--) {
            String numbersBefore = largestTidyNumberStr.substring(0, i);
            int largestDigit = 0;
            for (int j = 0; j < numbersBefore.length(); j++) {
                int digit = Integer.valueOf(numbersBefore.substring(j, j + 1));
                if (digit == 9) {
                    largestDigit = 9;
                    break;
                } else if (digit > largestDigit) {
                    largestDigit = digit;
                }
            }
            long currentDigit = Long.valueOf(largestTidyNumberStr.substring(i, i + 1));
            if (largestDigit > currentDigit) {
                largestTidyNumber = largestTidyNumber -
                        Long.valueOf(largestTidyNumberStr.substring(i, largestTidyNumberStr.length()))
                        - 1;
                largestTidyNumberStr = String.valueOf(largestTidyNumber);
            }
        }

        return largestTidyNumber;
    }
}
