package de.google.code.jam;

import java.util.ArrayList;
import java.util.List;

public class CoinJam {

	private final static String NO_MORE_FILLERS = "noFillersLeft";

	public static void main(String[] args) {
		CoinJam excercise = new CoinJam();
		excercise.execute();
	}

	public void execute() {
		List<String> input = FileOperation.openFile("C:\\Users\\noa\\Desktop\\C-small-attempt1.in");
		List<String> output = new ArrayList<>();

		if (input != null && !input.isEmpty()) {
			int testCases = Integer.valueOf(input.get(0));

			for (int i = 1; i <= testCases; i++) {
				String[] params = input.get(i).split(" ");

				output.add("Case #" + i + ":");

				int numOfFillers = Integer.valueOf(params[0]) - 2;
				int numOfJamCoins = Integer.valueOf(params[1]);
				String jamCoin = "1" + initializeFillingNumber(numOfFillers) + "1";

				int j = 0;
				while (j < numOfJamCoins) {
					List<Long> results = new ArrayList<>();

					for (int k = 2; k <= 10; k++) {
						Long convertedJamCoin = Long.valueOf(jamCoin, k);
						long divisor = divisorCheck(convertedJamCoin);

						if (divisor > -1) {
							results.add(divisor);
						} else {
							break;
						}
					}

					if (results.size() == 9) {
						output.add(createOutputString(jamCoin, results));
						j++;
					}

					jamCoin = createNewJamCoin(jamCoin);
				}

			}
		}

		FileOperation.saveToFile("C:\\Users\\noa\\Desktop\\output.txt", output);
	}

	private String createOutputString(String jamCoin, List<Long> results) {
		StringBuilder sb = new StringBuilder();
		sb.append(jamCoin);

		for (long result : results) {
			sb.append(" " + result);
		}

		return sb.toString();
	}

	private int divisorCheck(long value) {
		if (value > 1) {
			for (int i = 2; i < value; i++) {
				if (value % i == 0) {
					return i;
				}
			}
		}

		return -1;
	}

	private String initializeFillingNumber(int length) {
		if (length > 0) {
			StringBuilder sb = new StringBuilder();

			for (int i = 0; i < length; i++) {
				sb.append("0");
			}

			return sb.toString();
		}

		return "";
	}

	private String createNewJamCoin(String oldValue) {
		if (oldValue.length() > 0) {
			char[] value = oldValue.toCharArray();

			for (int i = 0; i < value.length; i++) {
				if (value[i] == '0') {
					value[i] = '1';
					return new String(value);
				}
			}

			for (int i = 0; i < value.length; i++) {
				if (value[i] == '1') {
					value[i] = '0';
					return new String(value);
				}
			}

			return NO_MORE_FILLERS;
		}

		return "";
	}
}
