import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class TrainTimeTable {
	static int noOfNewTrainsFromA = 0;
	static int noOfNewtrainsFromB = 0;
	static ArrayList aTripsSortedByDepTime = null;
	static ArrayList aTripsSortedByArrTime = null;
	static ArrayList bTripsSortedByDepTime = null;
	static ArrayList bTripsSortedByArrTime = null;
	static String currentListName = "";

	public static void main(String[] args) {
		File testFile = new File(".\\B-small-attempt3.in");
		try {
			BufferedReader inputFile = new BufferedReader(new FileReader(testFile));
			try {
				String line = null;
				String input = "";
				line = inputFile.readLine();
				int cases = Integer.parseInt(line);
				int turnAroundTime = 0;
				int noOfTripsA = 0;
				int noOfTripsB = 0;

				Train tempTrain = null;
				int j = 0;
				for (int intI = 1; intI <= cases; intI++) {
					System.out.print("Case #" + intI + ": ");
					aTripsSortedByDepTime = new ArrayList(3);
					aTripsSortedByArrTime = new ArrayList(3);
					bTripsSortedByDepTime = new ArrayList(3);
					bTripsSortedByArrTime = new ArrayList(3);
					noOfNewTrainsFromA = 0;
					noOfNewtrainsFromB = 0;
					line = inputFile.readLine();
					turnAroundTime = Integer.parseInt(line);
					line = inputFile.readLine();
					noOfTripsA = Integer.parseInt(line.split(" ")[0]);
					noOfTripsB = Integer.parseInt(line.split(" ")[1]);

					int trainNumber = 0;

					for (j = 1; j <= noOfTripsA; j++) {
						line = inputFile.readLine();
						tempTrain = new Train(line, turnAroundTime, trainNumber++);
						aTripsSortedByDepTime.add(tempTrain);
						aTripsSortedByArrTime.add(tempTrain);
					}
					for (j = 1; j <= noOfTripsB; j++) {
						line = inputFile.readLine();
						tempTrain = new Train(line, turnAroundTime, trainNumber++);
						bTripsSortedByDepTime.add(tempTrain);
						bTripsSortedByArrTime.add(tempTrain);
					}

					noOfNewTrainsFromA = noOfTripsA;
					noOfNewtrainsFromB = noOfTripsB;
					if ((noOfTripsA != 0) && (noOfTripsB != 0)) {
						Collections.sort(aTripsSortedByDepTime, new DepTimeComparator());
						Collections.sort(aTripsSortedByArrTime, new ArrTimeComparator());
						Collections.sort(bTripsSortedByDepTime, new DepTimeComparator());
						Collections.sort(bTripsSortedByArrTime, new ArrTimeComparator());
						//System.out.println("aTripsSortedByDepTime" + aTripsSortedByDepTime);
						//System.out.println("aTripsSortedByArrTime" + aTripsSortedByArrTime);
						//System.out.println("bTripsSortedByDepTime" + bTripsSortedByDepTime);
						//System.out.println("bTripsSortedByArrTime" + bTripsSortedByArrTime);
						for (j = 0; j < aTripsSortedByDepTime.size(); j++) {
							tempTrain = (Train) aTripsSortedByDepTime.get(j);
							if (isTrainReady(tempTrain, bTripsSortedByArrTime)) {
								noOfNewTrainsFromA--;
							}
						}
						for (j = 0; j < bTripsSortedByDepTime.size(); j++) {
							tempTrain = (Train) bTripsSortedByDepTime.get(j);
							if (isTrainReady(tempTrain, aTripsSortedByArrTime)) {
								noOfNewtrainsFromB--;
							}
						}
					}
					System.out.print(noOfNewTrainsFromA + " " + noOfNewtrainsFromB + "\n");
					aTripsSortedByDepTime = null;
					aTripsSortedByArrTime = null;
					bTripsSortedByDepTime = null;
					bTripsSortedByArrTime = null;
				}
			} finally {
				inputFile.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}

	private static boolean isTrainReady(Train tempTrain, ArrayList tripsSortedByArrTime) {
		boolean returnValue = false;
		if (tripsSortedByArrTime.size() > 0) {
			Train train = (Train) tripsSortedByArrTime.get(0);
			if (tempTrain.compareDepArrTrain(train) != -1) {
				returnValue = true;
				tripsSortedByArrTime.remove(0);
			}
		}

		return returnValue;
	}
}

class Train {
	int depHour = 0;
	int depMinute = 0;
	int arrHour = 0;
	int arrMinute = 0;
	int trainNumber = 0;

	public Train(int depHour, int depMinute, int arrHour, int arrMinute, int turnAroundTime, int trainNumber) {
		this.depHour = depHour;
		this.depMinute = depMinute;
		this.arrHour = arrHour;
		this.arrMinute = arrMinute;
		this.trainNumber = trainNumber;
		addMinutes(turnAroundTime);
	}

	public String toString() {
		// TODO Auto-generated method stub
		return "\n" + depHour + ":" + depMinute + "  " + arrHour + ":" + arrMinute + "   " + trainNumber;
	}

	public Train(String time, int turnAroundTime, int trainNumber) {
		String[] temp = time.split(" ");
		this.depHour = Integer.parseInt(temp[0].split(":")[0]);
		this.depMinute = Integer.parseInt(temp[0].split(":")[1]);
		this.arrHour = Integer.parseInt(temp[1].split(":")[0]);
		this.arrMinute = Integer.parseInt(temp[1].split(":")[1]);
		this.trainNumber = trainNumber;
		addMinutes(turnAroundTime);
	}

	void addMinutes(int minutes) {
		if (minutes > 0) {
			arrHour = arrHour + (minutes / 60);
			arrMinute = arrMinute + (minutes % 60);
		}
	}

	public int compareDepDepTrain(Train arrivingTrain) {
		int returnValue = -1;
		if (getDepHour() > arrivingTrain.getDepHour()
				|| (getDepHour() == arrivingTrain.getDepHour() && getDepMinute() > arrivingTrain.getDepMinute())) {
			returnValue = 1;
		} else if (getDepHour() == arrivingTrain.getDepHour() && getDepMinute() == arrivingTrain.getDepMinute()) {
			returnValue = 0;
		}
		return returnValue;
	}

	public int compareDepArrTrain(Train arrivingTrain) {
		int returnValue = -1;
		if (getDepHour() > arrivingTrain.getArrHour()
				|| (getDepHour() == arrivingTrain.getArrHour() && getDepMinute() > arrivingTrain.getArrMinute())) {
			returnValue = 1;
		} else if (getDepHour() == arrivingTrain.getArrHour() && getDepMinute() == arrivingTrain.getArrMinute()) {
			returnValue = 0;
		}
		return returnValue;
	}

	public boolean equals(Object arg0) {
		if (arg0 instanceof Train) {
			return ((Train) arg0).trainNumber == trainNumber;
		}
		return super.equals(arg0);
	}

	public int getArrHour() {
		return arrHour;
	}

	public int getArrMinute() {
		return arrMinute;
	}

	public int getDepHour() {
		return depHour;
	}

	public int getDepMinute() {
		return depMinute;
	}
}

class DepTimeComparator implements Comparator {
	public int compare(Object firstTrain, Object secondTrain) {
		if (!(firstTrain instanceof Train && secondTrain instanceof Train)) {
			throw new ClassCastException("A Train objects expected.");
		}
		int returnValue = -1;
		Train temp = (Train) firstTrain;
		Train temp1 = (Train) secondTrain;
		if ((temp.getDepHour() > temp1.getDepHour())
				|| (temp.getDepHour() == temp1.getDepHour() && temp.getDepMinute() > temp1.getDepMinute())) {
			returnValue = 1;
		} else if ((temp.getDepHour() == temp1.getDepHour()) && (temp.getDepMinute() == temp1.getDepMinute())) {
			if ((temp.getArrHour() > temp1.getArrHour())
					|| (temp.getArrHour() == temp1.getArrHour() && temp.getArrMinute() > temp1.getArrMinute())) {
				returnValue = 1;
			} else if ((temp.getArrMinute() == temp1.getArrMinute()) && (temp.getArrHour() == temp1.getArrHour())) {
				returnValue = 0;
			}
		}
		return returnValue;
	}
}

class ArrTimeComparator implements Comparator {
	public int compare(Object firstTrain, Object secondTrain) {
		if (!(firstTrain instanceof Train && secondTrain instanceof Train)) {
			throw new ClassCastException("A Train objects expected.");
		}
		int returnValue = -1;
		Train temp = (Train) firstTrain;
		Train temp1 = (Train) secondTrain;
		if ((temp.getArrHour() > temp1.getArrHour())
				|| (temp.getArrHour() == temp1.getArrHour() && temp.getArrMinute() > temp1.getArrMinute())) {
			returnValue = 1;
		} else if ((temp.getArrHour() == temp1.getArrHour()) && temp.getArrMinute() == temp1.getArrMinute()) {
			returnValue = 0;
		}
		return returnValue;
	}
}
