package de.google.code.jam;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.StandardOpenOption;
import java.util.List;

public class FileOperation {
	private FileOperation() {}
	
	public static List<String> openFile(String location) {
		try {
			File file = new File(location);

			if (file.exists()) {
				return Files.readAllLines(file.toPath());
			}
		} catch (IOException e) {
			e.printStackTrace();
		}

		return null;
	}

	public static void saveToFile(String location, List<String> content) {
		try {
			File file = new File(location);

			Files.write(file.toPath(), content, StandardOpenOption.CREATE);
		} catch (IOException e) {
			e.printStackTrace();
		}

	}
}
