package de.google.code.jam;

import java.util.ArrayList;
import java.util.List;

public class RevengeOfThePancakes {

	public static void main(String[] args) {
		RevengeOfThePancakes excercise = new RevengeOfThePancakes();
		excercise.execute();
	}

	public void execute() {
		List<String> input = FileOperation.openFile("C:\\Users\\noa\\Desktop\\B-small-attempt0.in");
		List<String> output = new ArrayList<>();

		if (input != null && !input.isEmpty()) {
			int testCases = Integer.valueOf(input.get(0));

			for (int i = 1; i <= testCases; i++) {
				boolean[] caseValue = initializeStructure(input.get(i));

				int changes = 0;

				while (true) {
					int position = checkPancakes(caseValue);

					if (position > -1) {
						changes += 1;
						caseValue = flipPancakes(position, caseValue);
					} else {
						break;
					}
				}

				output.add("Case #" + i + ": " + changes);
			}
		}

		FileOperation.saveToFile("C:\\Users\\noa\\Desktop\\output.txt", output);
	}

	private boolean[] flipPancakes(int position, boolean[] caseValue) {
		for (int j = position; j >= 0; j--) {
			caseValue[j] = !caseValue[j];
		}

		return caseValue;
	}

	private int checkPancakes(boolean[] caseValue) {
		for (int j = caseValue.length - 1; j >= 0; j--) {
			if (!caseValue[j]) {
				return j;
			}
		}

		return -1;
	}

	private boolean[] initializeStructure(String caseValue) {
		boolean[] structure = new boolean[caseValue.length()];

		for (int i = 0; i < caseValue.length(); i++) {
			structure[i] = caseValue.charAt(i) == '+';
		}

		return structure;
	}
}
