package de.c0lt.googlecodejam.qualificationround.d;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class QualiDSmall {

	BufferedReader reader = null;
	BufferedWriter writer = null;
	private File input;
	private File output;
	private int testCases, masses, points, minKen, maxKen;
	private String string;
	private double chosenNaomi, chosenKen;

	private String[] inputs;
	private List<Double> massesNaomi, massesKen, differences;
	private List<String> solutionsDeceitful, solutionsWar;

	public QualiDSmall(String input, String output) {
		this.input = new File(input);
		this.output = new File(output);
	}

	public static void main(String[] args) throws IOException {
		QualiDSmall qualiDSmall = new QualiDSmall("D-small.in", "D-small.out");

		qualiDSmall.solve();
		qualiDSmall.output();

		qualiDSmall.writer.flush();
		qualiDSmall.writer.close();
	}

	private void solve() throws FileNotFoundException {

		try {
			reader = new BufferedReader(new FileReader(input));
			writer = new BufferedWriter(new FileWriter(output));
			massesNaomi = new LinkedList<Double>();
			massesKen = new LinkedList<Double>();
			differences = new LinkedList<Double>();
			solutionsDeceitful = new ArrayList<String>();
			solutionsWar = new ArrayList<String>();

			testCases = Integer.parseInt(reader.readLine());

			for (int i = 0; i < testCases; i++) {

				massesNaomi.clear();
				massesKen.clear();
				points = 0;

				string = reader.readLine();
				masses = Integer.parseInt(string);

				string = reader.readLine();
				inputs = string.split(" ");
				for (int j = 0; j < masses; j++) {
					massesNaomi.add(Double.parseDouble(inputs[j]));
				}
				Collections.sort(massesNaomi);

				string = reader.readLine();
				inputs = string.split(" ");
				for (int j = 0; j < masses; j++) {
					massesKen.add(Double.parseDouble(inputs[j]));
				}
				Collections.sort(massesKen);

				List<Double> copyMassesNaomi = new LinkedList<>(massesNaomi);
				List<Double> copyMassesKen = new LinkedList<>(massesKen);
				minKen = 0;
				maxKen = masses;

				for (int j = 0; j < masses; j++) {
					chosenNaomi = copyMassesNaomi.get(j);
					chosenKen = copyMassesKen.get(minKen);
					if ((chosenKen - chosenNaomi) > 0) {
						maxKen--;
					} else {
						minKen++;
					}
				}
				solutionsDeceitful.add(String.valueOf((maxKen)));

				for (int j = 0; j < masses; j++) {
					differences.clear();
					chosenNaomi = massesNaomi.get(j);
					for (int j2 = 0; j2 < massesKen.size(); j2++) {
						chosenKen = massesKen.get(j2);
						differences.add(chosenKen - chosenNaomi);
					}
					for (int j2 = 0; j2 < differences.size(); j2++) {
						if (differences.get(j2) > 0) {
							massesKen.remove(j2);
							break;
						}
						if (j2 == differences.size() - 1) {
							massesKen.remove(0);
							points++;
						}
					}
				}
				solutionsWar.add(String.valueOf(points));

			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void output() {

		for (int i = 0; i < testCases; i++) {
			StringBuilder stringBuilder = new StringBuilder();

			stringBuilder.append("Case #" + (i + 1) + ": ");
			stringBuilder.append(solutionsDeceitful.get(i));
			stringBuilder.append(" ");
			stringBuilder.append(solutionsWar.get(i));
			System.out.println(stringBuilder.toString());

			try {
				writer.write(stringBuilder.toString());
				writer.newLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block e.printStackTrace();
			}
		}
	}

}
