package de.c0lt.googlecodejam.qualificationround.b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class QualiBLarge {

	BufferedReader reader = null;
	BufferedWriter writer = null;
	private File input;
	private File output;
	private int testCases;
	private String string;
	private double rate, costs, farming, goal, doublePrev, time, casetime;

	private String[] inputs;
	private List<String> solutions;

	public QualiBLarge(String input, String output) {
		this.input = new File(input);
		this.output = new File(output);
	}

	public static void main(String[] args) throws IOException {
		QualiBLarge qualiBLarge = new QualiBLarge("B-large.in", "B-large.out");

		qualiBLarge.solve();
		qualiBLarge.output();

		qualiBLarge.writer.flush();
		qualiBLarge.writer.close();
	}

	private void solve() throws FileNotFoundException {

		try {
			reader = new BufferedReader(new FileReader(input));
			writer = new BufferedWriter(new FileWriter(output));
			solutions = new ArrayList<String>();

			testCases = Integer.parseInt(reader.readLine());

			for (int i = 0; i < testCases; i++) {

				doublePrev = 0.0;
				rate = 2.0;

				string = reader.readLine();
				inputs = string.split(" ");
				costs = Double.parseDouble(inputs[0]);
				farming = Double.parseDouble(inputs[1]);
				goal = Double.parseDouble(inputs[2]);

				time = (goal / rate);

				for (int j = 1; j < 1000000; j++) {
					doublePrev = doublePrev
							+ (costs / (rate + ((j - 1) * farming)));
					casetime = doublePrev + (goal / (rate + j * farming));
					if (casetime < time) {
						time = casetime;
					}
				}
				solutions.add(String.valueOf(time));

			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private void output() {

		for (int i = 0; i < testCases; i++) {
			StringBuilder stringBuilder = new StringBuilder();

			stringBuilder.append("Case #" + (i + 1) + ": ");
			stringBuilder.append(solutions.get(i));
			System.out.println(stringBuilder.toString());

			try {
				writer.write(stringBuilder.toString());
				writer.newLine();
			} catch (IOException e) {
				// TODO Auto-generated catch block e.printStackTrace();
			}
		}
	}
}
