package com.artem.barger.bot.trust;

import java.text.MessageFormat;

import com.artem.barger.TestCaseReader;

public class BotTrustSolver extends TestCaseReader {

	private static final String OUT_STR = "Case #{0}: {1}";
	
	public BotTrustSolver( final String fileName) {
		super(fileName);
	}

	@Override
	public void processLine( final String line, int lineNum) {
		String $ = line.split( " ")[0];
		String sequence = line.substring( $.length( ) + 1);
		Robot orange = new Robot( 'O', sequence);
		Robot blue = new Robot( 'B', sequence);
		long timer = 1;
		for( ; !blue.hasFinished( ) || !orange.hasFinished( ); ++timer) {
			boolean bluePressed = blue.makeMove( timer);
			boolean orangePressed = orange.makeMove( timer);
			blue.updateState( orangePressed);
			orange.updateState( bluePressed);
		}
		print( MessageFormat.format( OUT_STR, lineNum, timer - 1));
	}
	
	public static void main(String[] args) {
		BotTrustSolver solver = new BotTrustSolver(args[0]);
		solver.startProcessing( );
	}
}