package com.artem.barger.magicka;

import java.util.List;

public class Sequence {

	
	private String sequence = "";
	
	private List<Opposite> opposites;
	
	private List<Combination> combinations;
	
	public Sequence( final List<Combination> combinations, final List<Opposite> opposites) {
		this.combinations = combinations;
		this.opposites = opposites; 
	}
	
	public void invoke( char ch) {
		sequence += ch;
		for( Combination $ : combinations ) {
			sequence = $.combibe( sequence);
		}
		for ( Opposite $ : opposites) {
			sequence = $.opposite(sequence);
		}
	}

	public String getSequence( ) {
		StringBuilder builder = new StringBuilder( );
		builder.append( "[");
		for ( int i = 0; i < sequence.length( ); ++i) {
			builder.append( ", " + sequence.charAt(i) );
		}
		builder.append( "]");
		return builder.toString( ).replaceFirst( ", ", "");
	}
}