package com.artem.barger.candy.split;

import java.text.MessageFormat;

import com.artem.barger.TestCaseReader;

public class CandySplitSolver extends TestCaseReader {

	private static final String OUT_STR = "Case #{0}: {1}";

	private int testCase = 1;
	
	private Long count = 0l;

	public CandySplitSolver(final String fileName) {
		super(fileName);
	}

	@Override
	public void processLine(final String line, int lineNum) {
		if ( lineNum % 2 == 1) {
			count = Long.valueOf( line);
			return;
		}
		String[] candies = line.split( " ");
		Bag firstBag = new Bag( );
		Bag secondBag = new Bag( );
		for ( String $ : candies) {
			firstBag.addNext( Long.valueOf( $));
		}
		if ( firstBag.calculateValue( ) != 0) {
			print( MessageFormat.format( OUT_STR, testCase++, "NO"));
			return;
		}
		for ( int i = 0; i < count; ++i) {
			secondBag.addNext( firstBag.removeNext( ));
			if ( secondBag.calculateValue( ).equals( firstBag.calculateValue( ))) {
				print( MessageFormat.format( OUT_STR, testCase++, firstBag.sumValues( )));
				return;
			}
		}
	}
	
	public static void main(String[] args) {
		CandySplitSolver solver = new CandySplitSolver( args[0]);
		solver.startProcessing( );
	}
}