package com.artem.barger.magicka;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

import com.artem.barger.TestCaseReader;

public class MagickaSolver extends TestCaseReader {

	private static final String OUT_STR = "Case #{0}: {1}";
	
	public MagickaSolver( final String fileName) {
		super(fileName);
	}

	@Override
	public void processLine( final String line, int lineNum) {
		int index = 0;
		String[] tokens = line.split( " ");
		Integer combineNum = Integer.valueOf( tokens[index++]);
		List<Combination> combinations = new ArrayList<Combination>( );
		for( int i = 0; i < combineNum ; ++i) {
			combinations.add( new Combination( tokens[index++]));
		}
		Integer oppositeNum = Integer.valueOf( tokens[index++]);
		List< Opposite> opposites = new ArrayList< Opposite>( );
		for( int i = 0; i < oppositeNum; ++i) {
			opposites.add( new Opposite( tokens[index++]));
		}
		String invokationSeq = tokens[++index];
		Sequence sequence = new Sequence(combinations, opposites);
		for ( int i = 0; i < invokationSeq.length(); ++i) {
			sequence.invoke( invokationSeq.charAt(i));
		}
		print(  MessageFormat.format( OUT_STR, lineNum, sequence.getSequence( )));
	}
	
	public static void main(String[] args) {
		MagickaSolver solver = new MagickaSolver( args[0]);
		solver.startProcessing( );
	}
}