package com.artem.barger.bot.trust;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

public class Robot {

	private String sequence;
	
	private Character name;

	private List<Integer> moves = new ArrayList< Integer>( );
	
	private List<Boolean> pushesMap = new ArrayList< Boolean>( );
	
	private int minePosition = 1;
	
	private Boolean canPress;

	public Robot( final Character name, final String sequence) {
		this.name = name;
		this.sequence = sequence;
		String[] tmp = sequence.split( " ");
		for ( int i = 0; i < tmp.length; ++i) {
			if (tmp[i].charAt(0) != name) {
				pushesMap.add( pushesMap.size( ), false);
				++i;
				continue;
			}
			moves.add( moves.size( ), Integer.valueOf( tmp[++i].replace( "\\w*", "")));
			pushesMap.add( pushesMap.size( ), true);
		}
		canPress = pushesMap.remove(0);
	}

	public Robot pressedButton( long timer) {
		if ( !pushesMap.isEmpty( ))
			canPress = pushesMap.remove(0);
		if ( !moves.isEmpty( ))
			 moves.remove(0);//System.err.println( MessageFormat.format( "{0}: {1} pressed button {2}", timer, name, moves.remove(0)));
		return this;
	}
	
	public boolean hasFinished( ) {
		return moves.size( ) == 0;
	}
	
	public boolean makeMove( long timer) {
		if ( hasFinished( ))
			return false;
		if ( canPress && minePosition == moves.get(0)) {
				pressedButton( timer);
				return true;
		} 
		if ( Integer.valueOf( minePosition).compareTo( moves.get(0)) != 0) {
			minePosition += -1 * Integer.valueOf( minePosition).compareTo( moves.get(0)) / Math.abs(Integer.valueOf( minePosition).compareTo( moves.get(0)));
			//System.err.println( MessageFormat.format( "{0}: {1} Move to button {2}", timer, name, minePosition));
		} else {
			//System.err.println( MessageFormat.format( "{0}: {1} Stay at button {2}", timer, name, minePosition));
		}
		return false;
	}
	
	public void updateState( boolean wasPressed) {
		if ( wasPressed && !pushesMap.isEmpty( )) {
			canPress = pushesMap.remove(0);
		}
	}
}