package com.artem.barger;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;

public abstract class TestCaseReader {

	
	private Integer testCasesNum;
	
	private BufferedReader reader;

	private File testCaseFile;

	private PrintStream out;

	abstract public void processLine( final String line, int lineNum);

	public TestCaseReader( final String fileName) {
		testCaseFile = new File( fileName);
		if ( !testCaseFile.exists( )) {
			return;
		}
		try {
			reader = new BufferedReader( new InputStreamReader( new FileInputStream( testCaseFile)));
			out = new PrintStream( new FileOutputStream( fileName + ".out"));
			String line = reader.readLine( );
			testCasesNum = Integer.valueOf( line);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public void print( String string) {
		out.println( string);
	}
	
	public void startProcessing( ) {
		String line = null;
		int lineNum = 1;
		try {
			while ( ( line = reader.readLine( )) != null) {
				processLine( line, lineNum++);
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				reader.close( );
				out.close( );
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public Integer getTestCasesNum() {
		return testCasesNum;
	}

	public void setTestCasesNum(Integer testCasesNum) {
		this.testCasesNum = testCasesNum;
	}
}