package y2015;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.Scanner;

public class Omino {


	private static Reader in;
	private static PrintWriter out;	
	public static final String NAME = "D-small-attempt.in";		
	
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader(NAME));
		BufferedWriter bw = new BufferedWriter(new FileWriter("output.out"));
		
		String output = "";
		int cases = Integer.valueOf(sc.nextLine());
		for (int c = 1; c <= cases; c++) {
			output += "Case #" + c + ": ";
			
			int X = sc.nextInt();
			int R = sc.nextInt();
			int C = sc.nextInt();
			int area = R * C;
			
			System.out.println("Case: " + c);
			System.out.println(X + ", " + R + ", " + C);
			
			int maxDim = Math.max(R, C);
			int minDim = Math.min(R, C);
			boolean isRich = false;
			// if X can be longer than largest dim, Richard wins
			if (X == 1) {
				// Rich loses
			} else if (X > maxDim) {
				isRich = true;
			} else if (X >= 7) {
				// we can form a closed square that can never be filled
				isRich = true;
			} else if (area % X != 0) {
				isRich = true;
			} else {
				// if Richard can make it so that any rotation wins
				int first;;
				int second;
				if (X > 2 * minDim) {
					first = minDim+1;
					second = X - first + 1; // share the same corner
					if (second > minDim) {
						isRich = true;
					}
				}
				if (!isRich) {
					// check another configuration
					// Check to see if we can get a closed space no matter the rotation
					// At least one of the sides need to be exactly or bigger than both dimensions
					int minRequired = 3;
					while(minRequired < minDim) {
						minRequired++;
					}
					int remaining = X - minRequired + 1;
					if (remaining >= minDim) {
						// can form a closed space
						isRich = true;
					}
				}
			}
			
			String res = ((isRich) ? "RICHARD": "GABRIEL") + "\n";
			System.out.println(res);
			
			output +=  res;
			
			if (sc.hasNext()) sc.nextLine();
		}		
		bw.write(output);
		bw.close();
	}

	public static class ArrayUtil {
		
		public static void printArray(int[] arr, int size) {
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < arr.length; i++) {
				if (i > 0) {
					sb.append(",");
				}
				
				int padding = size - String.valueOf(arr[i]).length();
				while (padding > 0) {
					sb.append(" ");
				}				
				sb.append(arr[i]);
			}
			System.out.println(sb);
		}
		
		public static void printArray(float[] arr, int size) {
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < arr.length; i++) {
				if (i > 0) {
					sb.append(",");
				}
				
				int padding = size - String.valueOf(arr[i]).length();
				while (padding > 0) {
					sb.append(" ");
					padding--;
				}				
				sb.append(arr[i]);
			}
			System.out.println(sb);
		}		
		
		public static int bitToInt(String num) {
			int result = 0;
			int length = num.length();
			for (int i = 0; i < length; i++) {
				int pow = length - 1 -i;
				if (i == length - 1) {
					result += Integer.valueOf(String.valueOf(num.charAt(length - 1)));
				} else {
					result += (int) Math.pow(2, length - 1 - i);	
				}
			}
			return result;
		}		
		
	}	

}
