package y2015;

import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.Reader;
import java.util.HashMap;
import java.util.Scanner;

public class Dijkstra {


	private static Reader in;
	private static PrintWriter out;	
	public static final String NAME = "C-small-attempt3.in";	
	//public static final String NAME = "A-small-practice.in";
	public static String[][] map = new String[200][200];
	
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader(NAME));
		BufferedWriter bw = new BufferedWriter(new FileWriter("output.out"));
		
		map['1']['1'] = "1";
		map['1']['i'] = "i";
		map['1']['j'] = "j";
		map['1']['k'] = "k";
		
		map['i']['1'] = "i";
		map['i']['i'] = "-1";
		map['i']['j'] = "k";
		map['i']['k'] = "-j";
		
		map['j']['1'] = "j";
		map['j']['i'] = "-k";
		map['j']['j'] = "-1";
		map['j']['k'] = "i";
		
		map['k']['1'] = "k";
		map['k']['i'] = "j";
		map['k']['j'] = "-i";
		map['k']['k'] = "-1";		
		
		
		String output = "";
		int cases = Integer.valueOf(sc.nextLine());
		for (int c = 1; c <= cases; c++) {
			output += "Case #" + c + ": ";
			
			int L = sc.nextInt();
			int X = sc.nextInt();
			sc.nextLine();
			String pattern = sc.next();
			
			System.out.println("Case: " + c + ", length: " + L + ", repeat " + X);
			System.out.println(pattern);
			
			boolean yes = false;
			if ((pattern.length() * X) < 3) {
				//output += "NO\n";
			} else {
				
				boolean[] isThere = new boolean[Character.MAX_VALUE];
				int numUniques = 0;
				for (int i = 0; i < pattern.length(); i++) {
					if (! isThere[pattern.charAt(i)]) {
						isThere[pattern.charAt(i)] = true;
						numUniques++;
					}
				}
				if (numUniques <= 1) {
					//output += "NO\n";
				} else {
					if (couldBeSol(pattern, X)) {
						if (find(pattern, X)) {
							yes = true;
						} else {
							//output += "NO\n";
						}	
					}
				}				
			}
			
			System.out.println(yes);
			System.out.println();
			output += ((yes) ? "YES" : "NO") + "\n";
			
			if (sc.hasNext()) sc.nextLine();
		}		
		bw.write(output);
		bw.close();
	}

	public static boolean couldBeSol(String pattern, int X) {
		int maxLength = pattern.length() * X;
		String res = "1";	
		// eventually become -1, then we are good
		for (int i = 0; i < maxLength; i++) {
			String cur = "" + pattern.charAt(i % pattern.length());
			res = getRes(res, cur);
		}
		return res.equals("-1");
	}
	
	public static boolean find(String pattern, int X) {

		int maxLength = pattern.length() * X;
		String first = "1";
		
		int repeatMax = pattern.length() * 2;
		int firstCounter = 0;
		
		// build a lookup table
		String[] lookup = new String[maxLength];
		lookup[maxLength-1] = pattern.charAt(pattern.length()-1)+"";
		for (int i = maxLength -2; i >= 1; i--) {
			String cur = "" + pattern.charAt(i % pattern.length());
			lookup[i] = getRes(cur, lookup[i+1]);
		}
		
		for (int i = 0; i < maxLength - 2; i++) {
			String cur = "" + pattern.charAt(i % pattern.length());
			first = getRes(first, cur);
			firstCounter++;
			if(first.equals("i") || first.equals("-i")) {
			} else {
				if (firstCounter > repeatMax) break;
				continue;
			}

			String second = "1";
			int secondCounter = 0;
			
			// Check if the rest can be j * k
			String check = lookup[i+1];
			if (!check.equals("i") && !check.equals("-i")) {
				continue;
			}
			for (int j = i+1; j < maxLength - 1; j++) {
				String secondCur = "" + pattern.charAt(j % pattern.length());
				second = getRes(second, secondCur);
				secondCounter++;
				if (second.equals("j") || second.equals("-j")){
				} else {
					continue;
				}
			
				String third = "1";
				int thirdCounter = 0;
				for (int k = j+1; k < maxLength; k++) {
					third = lookup[k];
					thirdCounter++;
					
					if ((third.equals("k") || third.equals("-k"))){
						System.out.println(first + second + third);
						// check the signs and see if they cancel
						int signI = (first.charAt(0) == '-') ? -1 : 1;
						int signJ = (second.charAt(0) == '-') ? -1 : 1;
						int signK = (third.charAt(0) == '-') ? -1 : 1;
						
						return (signI * signJ * signK) > 0;
					} else {
						break;
					}
				}
			}
		}
		return false;
	}
	
		
	public static String getRes(String a, String b) {
		
		int signA = 1;
		int signB = 1;

		char A;
		if (a.charAt(0) == '-') {
			signA = -1;
			A = a.charAt(1);
		} else {
			A = a.charAt(0);
		}
		
		char B;
		if (b.charAt(0) == '-') {
			signB = -1;
			B = b.charAt(1);
		} else {
			B = b.charAt(0);
		}
		
		int sign = signA * signB;
		String mapped = map[A][B];
		if (mapped.charAt(0) == '-') {
			sign = (sign * -1);
			mapped = mapped.charAt(1)+"";
		}
		
		return ((sign > 0) ? "" : "-")  + mapped;
	}
	
	
	public static class ArrayUtil {
		
		public static void printArray(int[] arr, int size) {
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < arr.length; i++) {
				if (i > 0) {
					sb.append(",");
				}
				
				int padding = size - String.valueOf(arr[i]).length();
				while (padding > 0) {
					sb.append(" ");
				}				
				sb.append(arr[i]);
			}
			System.out.println(sb);
		}
		
		public static void printArray(float[] arr, int size) {
			StringBuilder sb = new StringBuilder();
			for (int i = 0; i < arr.length; i++) {
				if (i > 0) {
					sb.append(",");
				}
				
				int padding = size - String.valueOf(arr[i]).length();
				while (padding > 0) {
					sb.append(" ");
					padding--;
				}				
				sb.append(arr[i]);
			}
			System.out.println(sb);
		}		
		
		public static int bitToInt(String num) {
			int result = 0;
			int length = num.length();
			for (int i = 0; i < length; i++) {
				int pow = length - 1 -i;
				if (i == length - 1) {
					result += Integer.valueOf(String.valueOf(num.charAt(length - 1)));
				} else {
					result += (int) Math.pow(2, length - 1 - i);	
				}
			}
			return result;
		}		
		
	}	

}
