/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package snapperchain;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.OutputStream;
import java.math.BigInteger;
import java.util.Stack;
import java.util.Vector;

/**
 *
 * @author Luciano
 */
public class SnapperChain {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException {
        String[] lines = new Lector("C:\\A-small-attempt2.in").getArray();



        int ntestcases = Integer.valueOf(lines[0]);

        for(int i = 1; i <= ntestcases; i++){
            int lamps, snaps;
            int spacepos = lines[i].indexOf(" ");
            lamps = Integer.parseInt(lines[i].substring(0, spacepos));
            snaps = Integer.parseInt(lines[i].substring(spacepos+1, lines[i].length()));

            String snap;
            snap = lines[i].substring(spacepos+1, lines[i].length());

            System.out.printf("Case #%d: %s\n", i, (checkBulbNu(lamps, new BigInteger(snap)) == false) ? "OFF" : "ON", lamps, snaps);
        }
    }

    public static boolean checkBulbNu(int nlamps, BigInteger nsnaps){
        if(nsnaps.equals(BigInteger.ZERO))
            return false;
        if(nsnaps.remainder(new BigInteger("2")).equals(BigInteger.ZERO))
            return false;

        BigInteger DOS = new BigInteger("2");
        BigInteger jump = DOS.pow(nlamps);
        BigInteger current = jump.subtract(BigInteger.ONE);

        int res;
        while( (res = current.compareTo(nsnaps)) == -1 || res == 0 ){
            if(res == 0)
                return true;
            
            current = current.add(jump);
        }

        return false;
    }



}


class Lector {
    private File file;
    private Stack strVector = new Stack();
    private boolean read; //file has been read.

    public Lector(File file) throws FileNotFoundException{
        if(!file.exists())
            throw new FileNotFoundException("Archivo inexistente: " + file.getAbsolutePath());

        this.file = file;
        readFile();
    }

    public Lector(String fileName) throws FileNotFoundException{
        this(new File(fileName));
    }

    public void readFile(){
        FileReader fileReader = null;
        BufferedReader in = null;
        try {
            fileReader = new FileReader(file);
            in = new BufferedReader(fileReader);
            String str;

            while ((str = in.readLine()) != null) {
                strVector.add(str);
            }
        } catch (FileNotFoundException e) { //This is likely not to happen, because it has alreay been checked.
            System.out.printf("El archivo no fue encontrado: %s\n", e);
        } catch (IOException e) {
            System.out.printf("Problema de I/O: %s\n", e);
        } finally {
            try{
                in.close();
                fileReader.close();
            }catch(Exception e){
                //Do nothing, if file already closed, don't matter.
            }
        }
        read = true;

    }

    public File getFile(){
        return file;
    }

    public Vector<String> getVector(){
        return (Vector<String>)strVector;
    }

    public Stack getStack(){
        return strVector;
    }

    public String[] getArray(){
        if(read == true){
            //return strVector.toArray(new String[0]);
            return (String[]) strVector.toArray(new String[0]);
        }else{
            return null;
        }
    }
}
