/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package themepark;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.LinkedList;
import java.util.Stack;
import java.util.Vector;
import java.util.concurrent.ConcurrentHashMap;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.Queue;


/**
 *
 * @author Luciano
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException {
        ConcurrentHashMap<Integer, Long> resultmap = new ConcurrentHashMap<Integer, Long>();
        ConcurrentLinkedQueue<ParkTestCase> queue = new ConcurrentLinkedQueue<ParkTestCase>();

        Lector lector = new Lector("C:\\C-small-attempt0.in");
        String[] lines = lector.getArray();
        int ntestcases = Integer.valueOf(lines[0]);

        for(int i = 1; i <= ntestcases*2; i+=2){
            ParkTestCase c;
            String str[] = lines[i].split(" ");



            c = new ParkTestCase((i/2)+1, Long.valueOf(str[0]), Long.valueOf(str[1]), Long.valueOf(str[2]), lines[i+1]);
            queue.add(c);
        }

        new ThreadRusa(queue, resultmap).start();
        /*new ThreadRusa(queue, resultmap).start();
        new ThreadRusa(queue, resultmap).start();
        new ThreadRusa(queue, resultmap).start();
        new ThreadRusa(queue, resultmap).start();
        new ThreadRusa(queue, resultmap).start();
        new ThreadRusa(queue, resultmap).start();
        new ThreadRusa(queue, resultmap).start();
        

        while(resultmap.size() != ntestcases){
            try{
                Thread.sleep(500);
            }catch(Exception e){
                
            }
        }

        for(int i = 0; i < ntestcases; i++)
            System.out.printf("Case #%d: %d", resultmap.);*/
    }

}

class ParkTestCase{
    int Xtestcase;
    long RcoasterRuns, Kseats, Ngroups;
    Queue<Long> groupQueue;

    public ParkTestCase(int X, long R, long K, long N, String g){
        groupQueue = new LinkedList<Long>();
        Xtestcase = X;
        RcoasterRuns = R;
        Kseats = K;
        Ngroups = N;
        String[] array = g.split(" ");
        for(String s:array)
            groupQueue.add(Long.parseLong(s));

        //System.out.println(this);
        
    }

    public String toString(){
        return String.format("Case #%d - R (runs): %d - K (seats): %d - N (groups): %d\n %s\n", Xtestcase, RcoasterRuns, Kseats, Ngroups, groupQueue);
    }
}

class ThreadRusa extends Thread{
    private ConcurrentLinkedQueue<ParkTestCase> queue;
    private ConcurrentHashMap<Integer, Long> resultmap;
    
    public ThreadRusa(ConcurrentLinkedQueue<ParkTestCase> queue, ConcurrentHashMap<Integer, Long> resultmap){
        this.queue = queue;
        this.resultmap = resultmap;
    }

    @Override
    public void run(){
        while(!queue.isEmpty()){ //Para cada testcase
            ParkTestCase testcase = queue.poll();

            int ncase = testcase.Xtestcase;
            long euros = 0;

            //System.out.println("Estoy procesando el caso #" + ncase);

            Rusa mrusa = new Rusa(testcase.Kseats);

            for(int i = 0; i < testcase.RcoasterRuns; i++){ //Mientras halla más vueltas...
                //System.out.printf("La vuelta: %d/%d [€%d]\n", i+1, testcase.RcoasterRuns, euros);
                

                while(testcase.groupQueue.peek() != null){
                    //System.out.println("Hay grupo: " + testcase.groupQueue);
                    if(mrusa.groupFits(testcase.groupQueue.peek()))
                        mrusa.addSeats(testcase.groupQueue.poll());
                    else
                        break;
                }

                euros += mrusa.cashWon();

                testcase.groupQueue.addAll(mrusa.getGroup());
                mrusa.clear();
            }

            resultmap.put(ncase, euros);

            System.out.printf("Case #%d: %d\n", ncase, euros);
        }
    }
}

class Rusa{
    long usedSeats;
    final long Kseats;
    Queue<Long> groups;

    public Rusa(long Kseats){
        this.Kseats = Kseats;
        groups = new LinkedList<Long>();
    }

    public boolean isFull(){
        return usedSeats == Kseats;
    }

    public boolean groupFits(long nseats){
        if(usedSeats + nseats <= Kseats)
            return true;
        
        return false;
    }

    public void addSeats(long nseats){
        usedSeats += nseats;
        groups.add(nseats);
        //System.out.printf("Me agregaron personas: %d - Capacidad: %d/%d\n", nseats, usedSeats, Kseats);
    }

    public Queue<Long> getGroup(){
        return groups;
    }

    public long cashWon(){
        return usedSeats;
    }

    public void clear() {
        usedSeats = 0;
        groups.clear();
    }

}


class Lector {
    private File file;
    private Stack strVector = new Stack();
    private boolean read; //file has been read.

    public Lector(File file) throws FileNotFoundException{
        if(!file.exists())
            throw new FileNotFoundException("Archivo inexistente: " + file.getAbsolutePath());

        this.file = file;
        readFile();
    }

    public Lector(String fileName) throws FileNotFoundException{
        this(new File(fileName));
    }

    public void readFile(){
        FileReader fileReader = null;
        BufferedReader in = null;
        try {
            fileReader = new FileReader(file);
            in = new BufferedReader(fileReader);
            String str;

            while ((str = in.readLine()) != null) {
                strVector.add(str);
            }
        } catch (FileNotFoundException e) { //This is likely not to happen, because it has alreay been checked.
            System.out.printf("El archivo no fue encontrado: %s\n", e);
        } catch (IOException e) {
            System.out.printf("Problema de I/O: %s\n", e);
        } finally {
            try{
                in.close();
                fileReader.close();
            }catch(Exception e){
                //Do nothing, if file already closed, don't matter.
            }
        }
        read = true;

    }

    public File getFile(){
        return file;
    }

    public Vector<String> getVector(){
        return (Vector<String>)strVector;
    }

    public Stack getStack(){
        return strVector;
    }

    public String[] getArray(){
        if(read == true){
            //return strVector.toArray(new String[0]);
            return (String[]) strVector.toArray(new String[0]);
        }else{
            return null;
        }
    }
}