import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class TidyNumbers {
	private static PrintWriter printer; 
	private static void PrintResult(String line, int caseNum)
	{
		String caseNumLine = "Case #" + caseNum + ": ";
		String resultLine = caseNumLine + line;
		System.out.println(resultLine);
		printer.println(resultLine);
		System.out.println();
	}
	
	private static String GetResult(String line)
	{
		System.out.println("line   : " + line);
		StringBuilder sb = new StringBuilder();
		char[] chars = line.trim().toCharArray();
		int[] nums = new int[chars.length];
		for (int i = 0; i < chars.length; i++)
		{
			nums[i] = chars[i] - '0';
		}
		
		int prev = nums[nums.length-1];
		int fillStart = nums.length;
		for (int i = nums.length - 1; i >= 0; i--)
		{
			if (nums[i] > prev)
			{
				nums[i]--;
				fillStart = i + 1;
			}
			
			prev = nums[i];
		}
		
		for (int i = fillStart; i < nums.length; i++)
		{
			nums[i] = 9;
		}
		
		boolean pushStarted = false;
		
		for (int num : nums)
		{
			pushStarted |= num > 0;
			if (pushStarted)
			{
				sb.append(num);
			}
		}
		
		return sb.toString();
	}
	
	private static void Solve(String line, int caseNum)
	{
		String result = GetResult(line);
		PrintResult(result, caseNum);
	}
	
	public static void main(String[] args) throws FileNotFoundException 
	{
		// TODO Auto-generated method stub
		boolean solveSmall = true;
		
		String testInput = "tidyNumTestInput.in";
		String smallInput = "B-small-attempt0.in";
		
		//String inputFile = testInput;
		String inputFile = smallInput;
		String outputFile = "tidyNum.out";
		Scanner scanner = new Scanner(new FileInputStream(inputFile));
		printer = new PrintWriter(new FileOutputStream(outputFile));
		
		int n = Integer.valueOf(scanner.nextLine().trim());
		
		for (int i = 0; i < n; i++)
		{
			String line = scanner.nextLine();
			Solve(line, i+1);
		}
		
		printer.close();
	}

}
