import java.io.File;
import java.io.PrintStream;
import java.util.*;

/**
 * Created by yatsynych on 11/04/2015.
 */
public class Q_2015_C {
    private static String _inputPath = "c:\\temp\\competition\\Q2015_C.in";
    private static String _outputPath = "c:\\temp\\competition\\Q2015_C.out";

    private static HashMap<String, HashMap<String, String>> table = new HashMap<String, HashMap<String, String>>();

    private static void process(String inputPath, String outputPath) {
        table.put("1", new HashMap<String, String>());
        table.get("1").put("1", "1");
        table.get("1").put("i", "i");
        table.get("1").put("j", "j");
        table.get("1").put("k", "k");

        table.put("i", new HashMap<String, String>());
        table.get("i").put("1", "1");
        table.get("i").put("i", "-1");
        table.get("i").put("j", "k");
        table.get("i").put("k", "-j");

        table.put("j", new HashMap<String, String>());
        table.get("j").put("1", "j");
        table.get("j").put("i", "-k");
        table.get("j").put("j", "-1");
        table.get("j").put("k", "i");

        table.put("k", new HashMap<String, String>());
        table.get("k").put("1", "k");
        table.get("k").put("i", "j");
        table.get("k").put("j", "-i");
        table.get("k").put("k", "-1");

        Scanner input = null;
        PrintStream output = null;
        try {
            input = new Scanner(new File(inputPath));
            output = new PrintStream(outputPath);

            int numberOfTestCases = input.nextInt();
            for (int i = 0; i < numberOfTestCases; ++i) {
                long numberOfChars = input.nextLong();
                long numberOfRepetitions = input.nextLong();
                String chars = input.next();

                StringBuilder builder = new StringBuilder();
                for (long j = 0; j < numberOfRepetitions; j++) {
                    builder.append(chars);
                }

                String resultString = "NO";

                if (numberOfChars * numberOfRepetitions >= 3) {
                    String inputString = builder.toString();

                    int endPos = 0;
                    int startPos = 0;

                    while (true) {
                        endPos = findFromTheEnd(inputString, endPos > 0 ? inputString.length() - endPos : 0, "k");
                        startPos = findFromTheBeginning(inputString, startPos, "i");

                        if ((endPos < 0) || (startPos < 0) || (endPos < startPos)) {
                            break;
                        }

                        if (canCompressToCharacter(inputString.substring(startPos, endPos), "j")) {
                            resultString = "YES";
                            break;
                        }
                    }
                }

                output.println(String.format("Case #%d: %s", i + 1, resultString));
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (input != null) {
                input.close();
            }

            if (output != null) {
                output.close();
            }
        }

    }

    private static int findFromTheEnd(String inputString, int positionFromTheEnd, String k) {
        int range = (inputString.length() + 1) > 128 ? inputString.length() - 128 : 0;
        for (int i = inputString.length() - 1; i > range; i--) {
            if (canCompressToCharacter(inputString.substring(i), k)) {
                if (positionFromTheEnd > 0) {
                    if (i < positionFromTheEnd) {
                        return (i);
                    }
                }
                else {
                    return (i);
                }
            }
        }
        return -1;
    }

    private static int findFromTheBeginning(String inputString, int positionFromStart, String k) {
        for (int i = 1; i < Math.min(inputString.length(), 128); i++) {
            if (canCompressToCharacter(inputString.substring(positionFromStart, positionFromStart + i), k)) {
                if (i > positionFromStart) {
                    return (i);
                }
            }
        }
        return -1;
    }

    private static boolean hasSign(String string) {
        return String.valueOf(string.charAt(0)).equals("-");
    }

    private static boolean canCompressToCharacter(String source, String character) {
        if (source.isEmpty()) {
            return false;
        }

        String token = String.valueOf(source.charAt(0));
        String tmpResult = String.valueOf(source.charAt(0));

        if (tmpResult.equals(character) && source.length() == token.length()) {
            return true;
        }

        for (int j = 1; j < source.length(); j++) {
            String nextCharacter = String.valueOf(source.charAt(j));
            token += nextCharacter;
            boolean sign = hasSign(tmpResult);
            if (sign) {
                tmpResult = tmpResult.substring(1);
            }
            tmpResult = table.get(tmpResult).get(nextCharacter);
            if (sign) {
                if (hasSign(tmpResult)) {
                    tmpResult = tmpResult.substring(1);
                } else {
                    tmpResult = "-" + tmpResult;
                }
            }
        }
        return tmpResult.equals(character);
    }

    public static void main(String[] args) {
        process(_inputPath, _outputPath);
    }
}
