package codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

/**
 * Created by yatsynych on 09/04/2016.
 */
public class Q_2016_C {
    private static String _inputPath = "c:\\temp\\competition\\newtask.in";
    private static String _outputPath = "c:\\temp\\competition\\newtask.out";

    private static void process(String inputPath, String outputPath) {
        Scanner input = null;
        PrintStream output = null;
        try {
            input = new Scanner(new File(inputPath));
            output = new PrintStream(outputPath);

            int T = input.nextInt();
            for (int t = 0; t < T; ++t){
                int N = input.nextInt(); // jamcoin length
                int J = input.nextInt(); // number of jamcoins

                if (N <=2)
                    throw new IllegalArgumentException("N should not be less or equal than 2");

                output.println(String.format("Case #%d: ", t + 1));

                int jamcoinsCount = 0;
                String token = generateInitialToken(N);
                do {
                    Jamcoin jamcoin = getJamcoin(token);
                    if (jamcoin != null) {
                        output.println(jamcoin.toString());
                        jamcoinsCount++;
                        if (jamcoinsCount == J) {
                            break;
                        }
                    }
                }
                while ((token = generateNextToken(token)) != null);
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (input != null) {
                input.close();
            }

            if (output != null) {
                output.close();
            }
        }
    }

    private static class Jamcoin {
        public String token;
        public long dividers[] = new long[11];

        @Override
        public String toString() {
            return String.format("%s %d %d %d %d %d %d %d %d %d", token, dividers[2], dividers[3], dividers[4],
                    dividers[5], dividers[6], dividers[7], dividers[8], dividers[9], dividers[10]);
        }
    }

    private static Jamcoin getJamcoin(String token) {
        Jamcoin result = new Jamcoin();
        result.token = token;
        for (int radix = 2; radix <= 10; ++radix) {
            long divider = findDivider(Long.parseLong(token, radix));
            if (divider == 0) {
                return null;
            }
            else {
                result.dividers[radix] = divider;
            }
        }
        return result;
    }

    public static long findDivider(long N) {
        for (long i = 2; i < Math.sqrt(N); ++i) {
            if (N % i == 0) {
                return i;
            }
        }
        return 0;
    }

    public static String generateInitialToken(int n) {
        return String.format("1%0" + (n - 2) + "d1", 0);
    }

    public static String generateNextToken(String token) {
        String middle = token.substring(1, token.length() - 1);
        long middleAsLong = Long.parseLong(middle, 2);
        middleAsLong++;
        String newMiddle = Long.toBinaryString(middleAsLong);
        if (newMiddle.length() > middle.length()) {
            return null;
        } else if (newMiddle.length() < middle.length()) {
            newMiddle = String.format("%0" + (middle.length() - newMiddle.length()) + "d", 0) + newMiddle;
        }

        return String.format("1%s1", newMiddle);
    }

    public static void main(String[] args) {
        process(_inputPath, _outputPath);
    }
}
