import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Q_2015_A {
    private static String _inputPath = "c:\\temp\\competition\\Q2015_A_large.in";
    private static String _outputPath = "c:\\temp\\competition\\Q2015_A_large.out";

    private static void process(String inputPath, String outputPath) {
        Scanner input = null;
        PrintStream output = null;
        try {
            input = new Scanner(new File(inputPath));
            output = new PrintStream(outputPath);

            int numberOfTestCases = input.nextInt();
            for (int i = 0; i < numberOfTestCases; ++i) {
                int maxShinestLevel = input.nextInt();
                String audienceString = input.next();
                List<Integer> audience = new ArrayList<Integer>();
                for (int j = 0; j < maxShinestLevel + 1; j++) {
                    audience.add(Character.getNumericValue(audienceString.charAt(j)));
                }

                int peopleRequired = 0;
                int peopleStoodUp = 0;
                for (int j = 0; j < maxShinestLevel + 1; j++) {
                    int numberOfPeopleInCategory = audience.get(j);
                    if (numberOfPeopleInCategory > 0) {
                        if (peopleStoodUp + peopleRequired >= j) {
                            peopleStoodUp += numberOfPeopleInCategory;
                        } else {
                            peopleRequired += j - (peopleStoodUp + peopleRequired);
                            peopleStoodUp += numberOfPeopleInCategory;
                        }
                    }
                }

                String resultString = String.format("Case #%d: %d", i + 1, peopleRequired);
                output.println(resultString);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (input != null) {
                input.close();
            }

            if (output != null) {
                output.close();
            }
        }
    }

    public static void main(String[] args) {
        process(_inputPath, _outputPath);
    }

}
