package codejam;

import java.io.File;
import java.io.PrintStream;
import java.util.*;

public class A2_2016 {
    private static String _inputPath = "c:\\temp\\competition\\newtask.in";
    private static String _outputPath = "c:\\temp\\competition\\newtask.out";

    private static void process(String inputPath, String outputPath) {
        Scanner input = null;
        PrintStream output = null;
        try {
            input = new Scanner(new File(inputPath));
            output = new PrintStream(outputPath);

            int numberOfTestCases = input.nextInt();
            for (int k = 0; k < numberOfTestCases; ++k) {
                char[] C = input.next().toCharArray();
                char[] J = input.next().toCharArray();

                String resultC = "";
                String resultJ = "";

                boolean canBeTheSame = true;
                int lastMatch = 0;

                for (int i = 0; i < C.length; ++i) {
                    if ((C[i] == J[i]) && (C[i] == '?')) {
                        resultC += '0';
                        resultJ += '0';
                        if (!canBeTheSame) {
                            lastMatch = i;
                        }
                        continue;
                    } else if (C[i] != '?' && J[i] != '?') {
                        canBeTheSame = false;
                        resultC += C[i];
                        resultJ += J[i];
                    } else {
                        if (C[i] != '?') {
                            resultC += C[i];
                            resultJ += canBeTheSame ? C[i] : (char)(((int)C[i]) + 1);
                        }
                        else if (J[i] != '?') {
                            resultJ += J[i];
                            resultC += canBeTheSame ? J[i] : (char)(((int)C[i]) - 1);
                        }
                    }
                }

                if (!canBeTheSame && lastMatch > 0) {
                    if (resultC.compareTo(resultJ) > 0) {
                        StringBuilder tmp = new StringBuilder(resultJ);
                        tmp.setCharAt(lastMatch, '9');
                        resultJ = tmp.toString();
                    }
                    else {
                        StringBuilder tmp = new StringBuilder(resultC);
                        tmp.setCharAt(lastMatch, '9');
                        resultC = tmp.toString();
                    }

                }

                String resultString = String.format("Case #%d: %s %s", k + 1, resultC, resultJ);
                output.println(resultString);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (input != null) {
                input.close();
            }

            if (output != null) {
                output.close();
            }
        }
    }

    public static void main(String[] args) {
        process(_inputPath, _outputPath);
    }
}
