import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;

public class Q_2016_A {
    private static String _inputPath = "c:\\temp\\competition\\newtask.in";
    private static String _outputPath = "c:\\temp\\competition\\newtask.out";

    private static void process(String inputPath, String outputPath) {
        Scanner input = null;
        PrintStream output = null;
        try {
            input = new Scanner(new File(inputPath));
            output = new PrintStream(outputPath);

            int T = input.nextInt();
            for (int i = 0; i < T; ++i) {
                long N = input.nextLong();
                long count = 0;
                long result = 0;

                int retriesBeforeInsomnia = 0;
                for (int k = 1; retriesBeforeInsomnia < 500; k++) {
                    result = N * k;
                    char[] nAsArray = String.valueOf(result).toCharArray();
                    for (int j = 0; j < nAsArray.length; ++j) {
                        long newCount = markNumber(count, nAsArray[j]);
                        if (count == newCount) {
                            retriesBeforeInsomnia++;
                        }
                        else {
                            count = newCount;
                            retriesBeforeInsomnia = 0;
                        }
                    }
                    if (isSleeping(count)) {
                        break;
                    }
                }

                String resultString = String.format("Case #%d: %s", i + 1, "INSOMNIA");

                if (isSleeping(count)) {
                    resultString = String.format("Case #%d: %d", i + 1, result);
                }
                output.println(resultString);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (input != null) {
                input.close();
            }

            if (output != null) {
                output.close();
            }
        }
    }

    private static boolean isSleeping(long count) {
        return count == 0x3ff;
    }

    private static boolean isBitSet(long value, byte bitPosition) {
        assert Long.SIZE < bitPosition;

        return (value & (1 << bitPosition)) != 0;
    }

    private static long setBit(long value, byte bitPosition) {
        assert Long.SIZE < bitPosition;

        return value | (1 << bitPosition);
    }

    private static long markNumber(long count, char c) {
        byte numericValue = (byte) Character.getNumericValue(c);
        for (byte i = 0; i < 10; ++i) {
            if (!isBitSet(count, numericValue)) {
                count = setBit(count, numericValue);
            }
        }
        return count;
    }

    public static void main(String[] args) {
        process(_inputPath, _outputPath);
    }
}
