/*
 * Patrick Bonnell
 * Google Code Jam 2012
 * Round 1A
 * Kingdom Rush
 */


import java.io.*;
import java.util.*;


public class KingdomRushSolution
{
	String filename;
	Case[] cases;
	
	private class Case
	{
		int[][] starsToPlay;
		int[][] starsEarned;
		
		public Case(int n)
		{
			starsToPlay = new int[n][2];
			starsEarned = new int[n][2];
			for(int i=0; i<starsEarned.length; i++)
				starsEarned[i][0] = starsEarned[i][1] = 0;
		}
		
		public String solveCase()
		{
			int plays = 0;
			int stars = 0;
			int twoStarsComplete = starsToPlay.length;
			
			boolean played = false;
			while(twoStarsComplete > 0)
			{
				for(int i=0; i<starsToPlay.length && !played; i++)
				{
					if(starsToPlay[i][1] <= stars && starsEarned[i][1] == 0)
					{
						if(starsEarned[i][0] == 0)
						{
							starsEarned[i][0]++;
							stars++;
						}
						starsEarned[i][1]++;
						stars++;
						plays++;
						twoStarsComplete--;
						played = true;
					}
				}
				
				for(int i=0; i<starsToPlay.length && !played; i++)
				{
					if(starsToPlay[i][0] <= stars && starsEarned[i][0] == 0)
					{
						starsEarned[i][0]++;
						stars++;
						plays++;
						played = true;
					}
				}
				
				if(twoStarsComplete > 0 && !played) return "Too Bad";
				played = false;
			}
			
			return Integer.toString(plays);
		}
	}
	
	public KingdomRushSolution(String filename) throws FileNotFoundException
	{
		this.filename = filename;
		Scanner sc = new Scanner(new File(filename));
		
		cases = new Case[sc.nextInt()];
		sc.nextLine();
		
		for(int i=0; i<cases.length; i++)
		{
			cases[i] = new Case(sc.nextInt());
			
			for(int j=0; j<cases[i].starsToPlay.length; j++)
			{
				cases[i].starsToPlay[j][0] = sc.nextInt();
				cases[i].starsToPlay[j][1] = sc.nextInt();
			}
		}
	}
	
	public void solve() throws IOException
	{
		BufferedWriter out = new BufferedWriter(new FileWriter(new File(filename.replace("in", "out"))));
		for(int i=0; i<cases.length; i++)
			out.write("Case #"+(i+1)+": "+cases[i].solveCase()+"\n");
		out.close();
	}
	
	public static void main(String[] args)
	{
		System.out.print("Input file: ");
		try
		{
			KingdomRushSolution sol = new KingdomRushSolution(new Scanner(System.in).nextLine());
			System.out.println("Running...");
			sol.solve();
			System.out.println("Done.");
		}
		catch(IOException e)
		{
			System.err.println(e);
		}
	}
}
