/*
 * Patrick Bonnell
 * Google Code Jam 2012
 * Round 1A
 * Password Problem
 */


import java.io.*;
import java.util.*;


public class PasswordSolution
{
	String filename;
	Case[] cases;
	
	private class Case
	{
		int a, b;
		double[] p;
		
		public Case(int a, int b)
		{
			this.a = a;
			this.b = b;
			this.p = new double[a];
		}
		
		public double solveCase()
		{
			double opt;
			double prob = 1;
			double best = Double.MAX_VALUE;
			
			for(int i=0; i<a; i++)
			{
				for(int j=0; j<(a-i); j++)
					prob *= p[j];
				
				opt = (b-a+i*2+1)*prob + (2*b-a+i*2+2)*(1-prob);
				
				if(opt < best) best = opt;
				prob = 1;
			}
			
			opt = b+2;
			if(opt < best) best = opt;
			
			return best;
		}
	}
	
	public PasswordSolution(String filename) throws FileNotFoundException
	{
		this.filename = filename;
		Scanner sc = new Scanner(new File(filename));
		
		cases = new Case[sc.nextInt()];
		sc.nextLine();
		
		for(int i=0; i<cases.length; i++)
		{
			cases[i] = new Case(sc.nextInt(), sc.nextInt());
			
			for(int j=0; j<cases[i].a; j++)
				cases[i].p[j] = sc.nextDouble();
		}
	}
	
	public void solve() throws IOException
	{
		BufferedWriter out = new BufferedWriter(new FileWriter(new File(filename.replace("in", "out"))));
		for(int i=0; i<cases.length; i++)
			out.write("Case #"+(i+1)+": "+cases[i].solveCase()+"\n");
		out.close();
	}
	
	public static void main(String[] args)
	{
		System.out.print("Input file: ");
		try
		{
			PasswordSolution sol = new PasswordSolution(new Scanner(System.in).nextLine());
			System.out.println("Running...");
			sol.solve();
			System.out.println("Done.");
		}
		catch(IOException e)
		{
			System.err.println(e);
		}
	}
}
