/*
 * Patrick Bonnell
 * Google Code Jam 2012
 * Qualification Round
 * Dancing With the Googlers
 */


import java.io.*;
import java.util.*;


public class TonguesSolution
{
	String filename;
	String[] cases;
	HashMap<Character, Character> transMap;
	
	public TonguesSolution(String filename) throws FileNotFoundException
	{
		this.filename = filename;
		Scanner sc = new Scanner(new File(filename));
		
		cases = new String[sc.nextInt()];
		sc.nextLine();
		
		for(int i=0; i<cases.length; i++)
		{
			cases[i] = sc.nextLine();
		}
		
		transMap = new HashMap<Character, Character>();
		transMap.put('a', 'y');
		transMap.put('b', 'h');
		transMap.put('c', 'e');
		transMap.put('d', 's');
		transMap.put('e', 'o');
		transMap.put('f', 'c');
		transMap.put('g', 'v');
		transMap.put('h', 'x');
		transMap.put('i', 'd');
		transMap.put('j', 'u');
		transMap.put('k', 'i');
		transMap.put('l', 'g');
		transMap.put('m', 'l');
		transMap.put('n', 'b');
		transMap.put('o', 'k');
		transMap.put('p', 'r');
		transMap.put('q', 'z');
		transMap.put('r', 't');
		transMap.put('s', 'n');
		transMap.put('t', 'w');
		transMap.put('u', 'j');
		transMap.put('v', 'p');
		transMap.put('w', 'f');
		transMap.put('x', 'm');
		transMap.put('y', 'a');
		transMap.put('z', 'q');
		transMap.put(' ', ' ');
	}
	
	private String solveCase(int n)
	{
		String solved = "";
		
		for(int i=0; i<cases[n].length(); i++)
			solved += transMap.get(cases[n].charAt(i));
		
		return solved;
	}
	
	public void solve() throws IOException
	{
		BufferedWriter out = new BufferedWriter(new FileWriter(new File(filename.replace("in", "out"))));
		for(int i=0; i<cases.length; i++)
			out.write("Case #"+(i+1)+": "+solveCase(i)+"\n");
		out.close();
	}
	
	public static void main(String[] args)
	{
		System.out.print("Input file: ");
		try
		{
			TonguesSolution sol = new TonguesSolution(new Scanner(System.in).nextLine());
			System.out.println("Running...");
			sol.solve();
			System.out.println("Done.");
		}
		catch(IOException e)
		{
			System.err.println(e);
		}
	}
}
