package fairandsquare;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;
import java.util.ArrayList;

public class FairAndSquare {

	public static void main(String[] args) {
		
		try {
			Scanner sc = new Scanner(new FileReader("input.in"));
			BufferedWriter bw = new BufferedWriter(new FileWriter(new File("output.out")));
			
			int cases = sc.nextInt();
			sc.nextLine();
			
			ArrayList<BigInteger> fs = new ArrayList<BigInteger>();
			
			BigInteger A = BigInteger.ONE;
			BigInteger B = BigInteger.TEN.pow(26);
			BigInteger x = A;
			
			while (x.compareTo(B) < 0) {
				x = A.pow(2);
				if (isPalindrome(x.toString())) {
					fs.add(new BigInteger(x.toString()));
				}
				A = new BigInteger(nextPalindrome(A.toString()));
			}
			
			for (int i = 0; i < cases; i++) {
				int count = 0;
				A = new BigInteger(sc.next());
				B = new BigInteger(sc.next());
				for (BigInteger b : fs) {
					if (b.compareTo(A) >= 0 && b.compareTo(B) <= 0) {
						count++;
					}
				}
				bw.write("Case # "+ (i+1) + ": " + count + "\n");
			}
			
			bw.flush();
			bw.close();
			sc.close();
			
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private static boolean isPalindrome(String s) {
		for (int i = 0; i < (s.length())/2; i++) {
			if (s.charAt(i) != s.charAt(s.length()-1-i)) {
				return false;
			}
		}
		return true;
	}
	
	private static String nextPalindrome(String s) {
		StringBuilder sb = new StringBuilder();
		if (!(s.charAt(0) == '1' || s.charAt(0) == '2' || s.charAt(0) == '3')) {
			sb.append('1');
			for (int i = 0; i < s.length()-1; i++) {
				sb.append('0');
			}
			sb.append('1');
			return sb.toString();			
		} else if (s.length() % 2 == 0) {
			BigInteger b = new BigInteger(s.substring(0, s.length()/2));
			b = b.add(BigInteger.ONE);
			sb.append(b.toString());
			sb.reverse();
			sb.insert(0, b.toString());
			return sb.toString();
		} else {
			BigInteger b = new BigInteger(s.substring(0, (s.length()+1)/2));
			b = b.add(BigInteger.ONE);
			sb.append(b.toString());
			sb.reverse();
			sb.insert(0, b.toString().substring(0, s.length()/2));
			return sb.toString();
		}
	}
}
