package duke.google.jam_2015.q.a;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;

/**
 * Created by andrew on 11.04.2015.
 */
public class Solve {
    private static final double INIT_SPEED = 2.0;

    public static void main(String[] args) throws IOException {
        new Solve().solve("C:\\Andrew\\develop\\google-jam\\2015\\q\\a\\A-large.in", "C:\\Andrew\\develop\\google-jam\\2015\\q\\a\\res.out");
    }


    public void solve(String in, String out) throws IOException {
        List<String> lines = Files.readAllLines(Paths.get(in), Charset.defaultCharset());
        List<String> result = new LinkedList<String>();
        int size = Integer.parseInt(lines.get(0));
        int i = 1;
        for (String s : lines.subList(1, lines.size())) {
            result.add(solveItem(createHolder(s), i++));
        }
        Files.write(Paths.get(out), result, Charset.defaultCharset(), StandardOpenOption.TRUNCATE_EXISTING);
    }

    private Holder createHolder(String s) {
        String[] split = s.split(" ");
        return new Holder(split[1]);

    }

    private String solveItem(Holder h, int i) {
        int result = 0;
        char[] chars = h.s.toCharArray();

        int currentCrowdCount = 0;
        for (int j = 0; j < chars.length; j++) {
            if (j > currentCrowdCount) {
                int add = (j - currentCrowdCount);
                result += add;
                currentCrowdCount += add;
            }
            currentCrowdCount += (int) chars[j] -0x30;
        }

        return "Case #" + i + ": " + result;
    }

    private static class Holder {
        String s;

        private Holder(String s) {
            this.s = s;
        }
    }
}
