package duke.google.jam_2015.q.d;

import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.nio.file.StandardOpenOption;
import java.util.LinkedList;
import java.util.List;

/**
 * Created by andrew on 11.04.2015.
 */
public class Solve {
    private static final double INIT_SPEED = 2.0;

    public static void main(String[] args) throws IOException {
        new Solve().solve("C:\\Andrew\\develop\\google-jam\\2015\\q\\d\\D-small-attempt0.in", "C:\\Andrew\\develop\\google-jam\\2015\\q\\d\\res.out");
    }


    public void solve(String in, String out) throws IOException {
        List<String> lines = Files.readAllLines(Paths.get(in), Charset.defaultCharset());
        List<String> result = new LinkedList<String>();
        int size = Integer.parseInt(lines.get(0));
        int i = 1;
        for (String s : lines.subList(1, lines.size())) {
            result.add(solveItem(createHolder(s), i++));
        }
        Files.write(Paths.get(out), result, Charset.defaultCharset(), StandardOpenOption.TRUNCATE_EXISTING);
    }

    private Holder createHolder(String s) {
        String[] split = s.split(" ");
        Holder holder = new Holder();
        holder.x = Integer.valueOf(split[0]);
        holder.r = Integer.valueOf(split[1]);
        holder.c = Integer.valueOf(split[2]);
        return holder;
    }

    private enum Result {GABRIEL, RICHARD}

    private String solveItem(Holder h, int i) {
        Result result = null;
        if (h.x == 1 && h.r >= 1 && h.c >= 1) {
            result = Result.GABRIEL;
        } else if (h.x == 2 && h.r >= 2 && h.c >= 2 && h.r % 2 == 0 && h.c % 2 == 0) {
            result = Result.GABRIEL;
        } else if (h.x == 3 && h.r > 0 && h.c > 0) {
            if ((h.r % 2 == 0 && h.c % 3 == 0) || (h.r % 3 == 0 && h.c % 2 == 0)) {
                result = Result.GABRIEL;
            } else {
                result = Result.RICHARD;
            }
        } else {
            result = Result.RICHARD;
        }

        return "Case #" + i + ": " + result;
    }

    private static class Holder {
        int x;
        int r;
        int c;
    }
}
