package gcj;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author cadooo
 */
public class MineSweeperMaster {

	public static void main(String[] args) {
		String in = "C-small-attempt1.in";
		String out = "out.txt";

		try {
			Scanner sc = new Scanner(new FileReader(in));
			PrintWriter pw = new PrintWriter(out);

			int T = sc.nextInt();
			sc.nextLine();
			for (int caseNumber = 0; caseNumber < T; caseNumber++) {
				pw.print("Case #" + (caseNumber + 1) + ": ");
				pw.println();
				pw.print(test(sc, pw));
			}
			pw.flush();
			pw.close();
			sc.close();
		} catch (FileNotFoundException ex) {
			Logger.getLogger(MineSweeperMaster.class.getName()).log(Level.SEVERE, null, ex);
		}
	}

	public static String test(Scanner sc, PrintWriter pw) {

		int R = sc.nextInt();
		int C = sc.nextInt();
		int M = sc.nextInt();
		sc.nextLine();
		return printBoard(R, C, M);
	}

	public static String printBoard(final int R, final int C, final int M) {
		if (R * C - 1 == M) {
			return printBoardOne(R, C);
		}
		if (R == 1) {
			return printSingleRow(C, M);
		}

		if (C == 1) {
			return printSingleColumn(R, M);
		}

		if (R * C - 4 < M) {
			return "Impossible\n";
		}
		StringBuilder board = new StringBuilder();
		int mIndex = 0;
		for (int rIndex = 0; rIndex < R; rIndex++) {
			for (int cIndex = 0; cIndex < C; cIndex++) {
				if (mIndex < M) {
					if (rIndex >= R - 2 && cIndex >= C - 2) {
						board.append('.');
					} else {
						board.append('*');
						mIndex++;
					}
				} else if (rIndex == R - 1 && cIndex == C - 1) {
					board.append('c');
				} else {
					board.append('.');
				}
			}
			board.append("\n");
		}
		return board.toString();
	}

	public static String printBoardOne(final int R, final int C) {

		if (R == 1) {
			return printSingleRowOne(C);
		}

		if (C == 1) {
			return printSingleColumnOne(R);
		}
		StringBuilder board = new StringBuilder();
		for (int rIndex = 0; rIndex < R; rIndex++) {
			for (int cIndex = 0; cIndex < C; cIndex++) {
				if (rIndex == R - 1 && cIndex == C - 1) {
					board.append('c');
				} else {
					board.append('*');
				}
			}
			board.append("\n");
		}
		return board.toString();
	}

	public static String printSingleRowOne(final int C) {
		StringBuilder board = new StringBuilder();
		for (int cIndex = 0; cIndex < C - 1; cIndex++) {
			board.append('*');
		}
		board.append("c\n");
		return board.toString();
	}

	public static String printSingleColumnOne(final int R) {
		StringBuilder board = new StringBuilder();
		for (int rIndex = 0; rIndex < R - 1; rIndex++) {
			board.append("*\n");
		}
		board.append("c\n");
		return board.toString();
	}

	public static String printSingleRow(int C, final int M) {
		if (C - M < 1) {
			return "Impossible\n";
		}
		StringBuilder board = new StringBuilder();
		int mIndex = 0;
		for (int cIndex = 0; cIndex < C - 1; cIndex++) {
			if (mIndex < M) {
				board.append('*');
				mIndex++;
			} else {
				board.append('.');
			}
		}
		board.append('c');
		board.append("\n");
		return board.toString();

	}

	public static String printSingleColumn(int R, final int M) {
		if (R - M < 1) {
			return "Impossible\n";
		}
		StringBuilder board = new StringBuilder();
		int mIndex = 0;
		for (int rIndex = 0; rIndex < R - 1; rIndex++) {
			if (mIndex < M) {
				board.append('*');
				mIndex++;
			} else {
				board.append('.');
			}
			board.append("\n");
		}
		board.append("c\n");
		return board.toString();

	}

}
