package gcj.a;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

public class A {

    public static void main(String[] args) {
        new SolveProblem().solve();
    }

    public static class SolveProblem {

        private Scanner sc = null;
        private StringBuilder sb = new StringBuilder();

        public SolveProblem() {
            loadInput();
        }

        private void loadInput() {
            try {
                sc = new Scanner(new FileReader("in.txt"));
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
                System.exit(-1);
            }
        }

        private void saveSolution(){
            PrintWriter pw = null;
            try {
                pw = new PrintWriter("out.txt");
                pw.append(sb.toString());
            } catch (FileNotFoundException ex) {
                ex.printStackTrace();
                System.exit(-1);
            } finally{
                pw.flush();
                pw.close();
            }
        }

        public void solve() {
            int T = sc.nextInt();
            sc.nextLine();
            for (int caseNumber = 1; caseNumber <= T; caseNumber++) {
                sb.append("Case #").append(caseNumber).append(": ");
                sb.append(SolveTestCase(sc)).append("\n");
            }
           
            System.out.print(sb.toString());
            saveSolution();
        }

        private static String SolveTestCase(Scanner sc) {
            int sMax = sc.nextInt();
            String[] S = sc.nextLine().trim().split("");
            
            Integer standing = 0;
            Integer added = 0;
            for(int i = 0; i < S.length; i++){
                Integer sI = Integer.parseInt(S[i]); 
                    System.out.println("Standing " + standing + " Si:" + sI + " i:" + i );
                if(standing < i && sI > 0){
                    added += i - standing;
                    System.out.println("Adding " + (i - standing));
                    standing = i;
                } 
                    
                standing += sI;
                
            }
            return added.toString();
        }

        protected void finalize() {
            sc.close();
        }
    }

}
