package codejam2014;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;

public class Game1 {

	public static void main(String[] args) {
		BufferedReader br=null;
		try {
			FileReader fr = new FileReader("file.txt");
			br = new BufferedReader(fr);
		} catch (FileNotFoundException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		FileWriter outFile = null;
		try {
			outFile = new FileWriter(new File("output.txt"));
		} catch (IOException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}
		PrintWriter out = new PrintWriter(outFile);
	    try {
	        StringBuilder sb = new StringBuilder();
	        String line = br.readLine();
        	Integer problems=Integer.parseInt(line);
        	int resolved=1;
	        while (resolved<problems+1) {
	        	System.out.println("Resolving "+resolved);
	        	int result=resolve(br);
	        	if(result==-1){
	        		out.println("Case #"+resolved+": Fegla Won");
	        	}else{
	        		out.println("Case #"+resolved+": "+result);
	        	}
	        	resolved++;
	        }
	        String everything = sb.toString();
	    }catch(Exception e){
	    	e.printStackTrace();
	    	System.out.println("error");
	    } finally {
	        try {
	        	out.close();
				br.close();
			} catch (IOException e) {
				System.out.println("error closing");
				e.printStackTrace();
			}
	    }
    	System.out.println("END");
	}

	private static int resolve(BufferedReader br) throws IOException {
		String line = br.readLine();
    	Integer wordCount=Integer.parseInt(line);
    	List<Word> words=getWords(br, wordCount);
    	
    	for(int i=0;i<words.get(0).character.size();i++){
    		for(int j=1;j<words.size();j++){
    			if(words.get(0).character.size()!=words.get(j).character.size() || !words.get(0).character.get(i).equals(words.get(j).character.get(i)))
    				return -1;
    		}
    	}
    	List<Integer> closestValues=new ArrayList<Integer>();
    	for(int i=0;i<words.get(0).character.size();i++){
    		double mean=getMeanForCharacter(words,i);
    		int closestCount=getClosestCount(words,i,mean);
    		closestValues.add(closestCount);
    	}
    	int changes=0;
    	for(int i=0;i<words.size();i++){
			for(int j=0;j<words.get(i).character.size();j++){
				changes+=Math.abs(words.get(i).count.get(j)-closestValues.get(j));
			}
    	}
    	
		return changes;
	}

	private static int getClosestCount(List<Word> words, int index, double mean) {
		double closestValue=Double.MAX_VALUE;
		double closestDistance=Double.MAX_VALUE;
		for(int i=0;i<words.size();i++){
			if(Math.abs(words.get(i).count.get(index)-mean)<closestDistance){
				closestValue=words.get(i).count.get(index);
				closestDistance=words.get(i).count.get(index)-mean;
			}
		}
		return (int) closestValue;
	}

	private static double getMeanForCharacter(List<Word> words, int index) {
		double add=0;
		for(int i=0;i<words.size();i++){
			add+=words.get(i).count.get(index);
		}
		return (double)add/words.size();
	}

	private static List<Word> getWords(BufferedReader br, Integer wordCount)
			throws IOException {
		List<Word> words=new ArrayList<Word>();
		for(int i=0;i<wordCount;i++){
			String wordString=br.readLine();
			Word word=new Word();
			word.set(wordString);
			words.add(word);
		}
		return words;
	}
	

}
