import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Scanner;


public class Energy {
		final static String WORK_DIR = "/home/cae/googleCodeJam/";

		/**
		 * @param args
		 * @throws IOException 
		 */
		public static void main(String[] args) throws IOException {
			
			Scanner sc = new Scanner(new FileReader(WORK_DIR + "B-small-attempt0.in"));
//			Scanner sc = new Scanner(new FileReader(WORK_DIR + "input.txt"));
	        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + "output.txt"));
	        int caseCnt = sc.nextInt();
	        sc.nextLine();
	        long ini=Calendar.getInstance().getTimeInMillis();
	        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
	            System.out.println("Processing test case " + (caseNum + 1));
	            pw.print("Case #" + (caseNum + 1) + ": ");
	            new Energy().solve(sc,pw);
	            pw.println();
	        }
	        System.out.println(Calendar.getInstance().getTimeInMillis()-ini);
	        pw.flush();
	        pw.close();
	        sc.close();
		}

		
		private void solve(Scanner sc, PrintWriter pw) {
			String line = sc.nextLine();
			String[] arrayLine = line.split(" ");
			long maxEnergy=Long.parseLong(arrayLine[0]);
			long regain=Long.parseLong(arrayLine[1]);
			long activities=Long.parseLong(arrayLine[2]);
			line = sc.nextLine();
			String[] arrayLine2 = line.split(" ");
			List<Integer> values=new ArrayList<Integer>();
			List<Integer> valuesIndexesOrdered=new ArrayList<Integer>();
			for(int i=0;i<activities;i++)
			{
				values.add(Integer.parseInt(arrayLine2[i]));
			}
			orderValuesIndexes(valuesIndexesOrdered,values);
			long[] energyUsed=new long[values.size()];
			long[] energyLeft=new long[values.size()];
			for(int i=0;i<activities;i++)
			{
				energyUsed[i]=Math.min(regain, maxEnergy);
				energyLeft[i]=maxEnergy-energyUsed[i];
			}
			for(int max:valuesIndexesOrdered)
			{
				boolean flag=false;
				while(energyLeft[max]>0 && !flag)
				{
					energyUsed[max]+=1;
					for(int pos=max;pos<energyLeft.length;pos++)
					{
						energyLeft[pos]-=1;
						if(energyLeft[pos]<0)
						{
							for(int j=pos;j>max;j--)
							{
								energyLeft[j]+=1;
							}
							energyUsed[max]-=1;
							pos=energyLeft.length;
							flag=true;
						}
					}
				}
			}
			
			long gain=0;
			for(int i=0;i<energyUsed.length;i++)
			{
				gain+=energyUsed[i]*values.get(i);
			}
			
			pw.print(gain);
		}


		private void orderValuesIndexes(List<Integer> valuesIndexesOrdered,List<Integer> values) 
		{
			List<Integer> valuesCopy=copyArray(values);
			int count=0;
			while(count<values.size())
			{
				int maxValue=-1;
				int maxPos=-1;
				for(int i=0;i<valuesCopy.size();i++)
				{
					if(maxValue<valuesCopy.get(i))
					{
						maxValue=valuesCopy.get(i);
						maxPos=i;
					}
				}
				valuesCopy.set(maxPos, -1);
				valuesIndexesOrdered.add(maxPos);
				count++;
			}
		}


		private List<Integer> copyArray(List<Integer> values) {
			List<Integer> valuesCopy=new ArrayList<Integer>();
			for(int i=0;i<values.size();i++)
			{
				valuesCopy.add(values.get(i));
			}
			return valuesCopy;
		}
			
}
