import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;
import java.util.Scanner;


public class Lawnmower {
	final static String WORK_DIR = "C:/Users/leyre/Desktop/cae/workspace/";

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		// TODO Auto-generated method stub
		Scanner sc = new Scanner(new FileReader(WORK_DIR + "B-small-attempt0.in"));
//		Scanner sc = new Scanner(new FileReader(WORK_DIR + "test.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + "output.txt"));
        int caseCnt = sc.nextInt();
        sc.nextLine();
        long ini=Calendar.getInstance().getTimeInMillis();
        for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
            System.out.println("Processing test case " + (caseNum + 1));
            pw.print("Case #" + (caseNum + 1) + ": ");
            new Lawnmower().solve(sc,pw);
            pw.println();
        }
        System.out.println(Calendar.getInstance().getTimeInMillis()-ini);
        pw.flush();
        pw.close();
        sc.close();
	}

	private void solve(Scanner sc, PrintWriter pw) {

		int[][] tablero = getTablero(sc);
		List<Integer> heights=getHeights(tablero);
		List<Integer> filsToUnMow=new ArrayList<Integer>();
		List<Integer> colsToUnMow=new ArrayList<Integer>();
		for (int i = 0; i < heights.size()-1; i++) {
			for (int fil = 0; fil < tablero.length; fil++) {
				if(allLineIsHeight(tablero,fil,heights.get(i)))
					filsToUnMow.add(fil);
			}
			for (int col = 0; col < tablero[0].length; col++) {
				if(allColIsHeight(tablero,col,heights.get(i)))
					colsToUnMow.add(col);
			}
			for (Integer fil : filsToUnMow) {
				unMowFil(tablero, fil, heights.get(i)+1);
			}

			for (Integer col : colsToUnMow) {
				unMowCol(tablero, col, heights.get(i)+1);
				
			}
		}
		for (int fil = 0; fil < tablero.length; fil++) {
			for (int col = 0; col < tablero[fil].length; col++) {
				if(tablero[fil][col]!=heights.get(heights.size()-1))
				{
					pw.print("NO");
					return;
				}
					
			}
		}
		pw.print("YES");
}


	private void unMowFil(int[][] tablero, int fil, Integer height) {
		for (int i = 0; i < tablero[fil].length; i++) {
			tablero[fil][i]=height;
		}
		
	}

	private boolean allLineIsHeight(int[][] tablero, int fil, Integer height) {
		for (int i = 0; i < tablero[fil].length; i++) {
			if(tablero[fil][i]!=height)
				return false;
		}
		return true;
	}
	private void unMowCol(int[][] tablero, int col, Integer height) {
		for (int i = 0; i < tablero.length; i++) {
			tablero[i][col]=height;
		}
		
	}

	private boolean allColIsHeight(int[][] tablero, int col, Integer height) {
		for (int i = 0; i < tablero.length; i++) {
			if(tablero[i][col]!=height)
				return false;
		}
		return true;
	}

	private List<Integer> getHeights(int[][] tablero) {
		List<Integer> heights=new ArrayList<Integer>();
		for (int i = 0; i < tablero.length; i++) {
			for (int j = 0; j < tablero[i].length; j++) {
				insertOrdered(heights,tablero[i][j]);
			}
		}
		return heights;
	}

	private void insertOrdered(List<Integer> heights, int height) {
		for (int j = 0; j < heights.size(); j++) {
			if(heights.get(j)==height)
				return;
			if(heights.get(j)>height)
			{
				heights.add(j,height);
				return;
			}
		}
		heights.add(height);
		
	}

	private int[][] getTablero(Scanner sc) {
		String line = sc.nextLine();
		int fil=Integer.parseInt(line.split(" ")[0]);
		int col=Integer.parseInt(line.split(" ")[1]);
		int[][] tablero=new int[fil][col];
		for(int i=0;i<fil;i++)
		{
			String[] numbers = sc.nextLine().split(" ");
			for(int j=0;j<numbers.length;j++)
			{
				tablero[i][j]=Integer.parseInt(numbers[j]);
			}
		}
		return tablero;
	}
}
