import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Calendar;

/**
 * 
 */

/**
 * @author caecus
 * 
 */
public class Solution {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		// Input data
		int testCases = 0;
		int[] dirExist = null;
		int[] dirCreate = null;
		ArrayList<String>[] dirsToCreate = null;
		ArrayList<String>[] dirs = null;

		try {
			BufferedReader input = new BufferedReader(new FileReader("A-small-attempt0.in"));
			try {
				testCases = Integer.valueOf(input.readLine());
				dirs = new ArrayList[testCases];
				dirsToCreate = new ArrayList[testCases];
				dirExist = new int[testCases];
				dirCreate = new int[testCases];

				for (int i = 0; i < testCases; i++) { // FOR EACH TEST CASE
					dirs[i] = new ArrayList<String>();
					dirs[i].add("/");
					
					dirsToCreate[i] = new ArrayList<String>();

					String[] results = input.readLine().split(" ");
					dirExist[i] = Integer.valueOf(results[0]);
					dirCreate[i] = Integer.valueOf(results[1]);

					for (int e = 0; e < dirExist[i]; e++) { // FOR EACH EXISTING
						// DIR
						dirs[i] = addDir(dirs[i], input.readLine());
					}
					for (int c = 0; c < dirCreate[i]; c++) { // FOR EACH CREATED
						// DIR
						dirsToCreate[i].add(input.readLine());
					}
				}
			} finally {
				input.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}

		// Run tests
		long start = Calendar.getInstance().getTimeInMillis();
		StringBuilder output = new StringBuilder();
		for (int i = 0; i < testCases; i++) {

			int commands = 0;
			for (int c = 0; c < dirCreate[i]; c++) { // FOR EACH CREATED
				// DIR
				commands += createDir(dirs[i], dirsToCreate[i].get(c));
			}

			output.append("Case #");
			output.append(String.valueOf(i + 1));
			output.append(": ");
			output.append(String.valueOf(commands));
			output.append(System.getProperty("line.separator"));
			System.out.println(i + 1);
		}
		long end = Calendar.getInstance().getTimeInMillis();
		System.out.print("Time:");
		System.out.println(end - start);

		// Write output
		try {
			Writer outFile = new BufferedWriter(new FileWriter("output.txt"));
			outFile.write(output.toString());
			outFile.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}

	}

	private static int createDir(ArrayList<String> dirs, String dir) {
		int index = dir.lastIndexOf("/");
		if (dirs.contains(dir) || index == -1) {
			return 0;
		}
		else {
			int commands = 0;
			commands += createDir(dirs, dir.substring(0, index));
			dirs.add(dir);
			return commands + 1;
		}
	}

	private static ArrayList<String> addDir(ArrayList<String> dirs, String dir) {
		int index = dir.lastIndexOf("/");
		if (dirs.contains(dir) || index == -1) {
			return dirs;
		} else {
			dirs.add(dir);
			return addDir(dirs, dir.substring(0, index));
		}

	}

}
