import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Calendar;

public class Solution {

	public static void main(String[] args) {
		// Input data
		int testCases = 0;
		ArrayList<int[]>[] yAB = null;

		try {
			BufferedReader input = new BufferedReader(new FileReader(
					"A-small-attempt0.in"));
			try {
				testCases = Integer.valueOf(input.readLine());
				
				yAB = new ArrayList[testCases];

				for (int t = 0; t < testCases; t++) {
				
					int lines = Integer.valueOf(input.readLine());
					
					yAB[t] = new ArrayList<int[]>();
					
					for (int l = 0; l < lines; l++) {
						String[] results = input.readLine().split(" ");
						int[] temp = {Integer.valueOf(results[0]), Integer.valueOf(results[1])};
						yAB[t].add(temp);
					}
				}
			} finally {
				input.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}

		// Run tests
		long start = Calendar.getInstance().getTimeInMillis();
		StringBuilder output = new StringBuilder();
		for (int i = 0; i < testCases; i++) {

			ArrayList<double[]> intersections = new ArrayList<double[]>();
			for(int a = 0; a<yAB[i].size(); a++) {
				for(int b = 0; b<yAB[i].size(); b++) {
					double[] intersection = new double[2];
					if(1 == Geometry.findLineSegmentIntersection(0, yAB[i].get(a)[0],//Line 1 end 1
							1, yAB[i].get(a)[1],//Line 1 end 2
							0, yAB[i].get(b)[0],//Line 2 end 1
							1, yAB[i].get(b)[1],//Line 2 end 2
							intersection)) {
						if(!intersections.contains(intersection)) {
								intersections.add(intersection);
						}
					}
				}
			}

			output.append("Case #");
			output.append(String.valueOf(i + 1));
			output.append(": ");
			output.append(String.valueOf(intersections.size()/2));
			output.append(System.getProperty("line.separator"));
			System.out.println(i + 1);
		}
		long end = Calendar.getInstance().getTimeInMillis();
		System.out.print("Time:");
		System.out.println(end - start);

		// Write output
		try {
			Writer outFile = new BufferedWriter(new FileWriter("output.txt"));
			outFile.write(output.toString());
			outFile.close();
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
