import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

public class ProblemA {
	
	static final int MODULO = 1000000007;
	//x^y % z
	public static int superMod(int x, int y, int z){
		//System.out.println("y is " +y);
		if (y == 0) return 1 %z;
		if (y == 1) return x % z;
		if (y == 2) return x %z *x %z;
		if (y %2 ==0){
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z;
		}else{
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z * x %z;
		}
	}
	
	public static int solve(int a , int b){  
	    BigInteger ba = new BigInteger(a+"");
	    BigInteger bb = new BigInteger(b+"");
	    BigInteger tw = new BigInteger("12");
	    BigInteger mod = new BigInteger("1000000007");
		if (a == b){
			BigInteger b1 = ba.multiply(ba);
			BigInteger b2 = b1.multiply(b1);
			BigInteger b3 = b2.subtract(b1);
			BigInteger b4 = b3.divide(tw);
			BigInteger b5 = b4.mod(mod);
			
			BigInteger q1 = ba.add(new BigInteger("1"));
			BigInteger q2 = q1.add(ba);
			BigInteger q3 = ba.multiply(q1.multiply(q2));
			BigInteger q4 = q3.divide(new BigInteger("6"));
			BigInteger q5 = q4.mod(mod);
			
			BigInteger ans = b5.add(q5);
			ans = ans.mod(mod);
			
			return ans.intValue();
	    }else{
	    	int n=a<b?a:b;  
	    	int m = a >b ? a : b;
	    	int t = m - n;
	    	BigInteger bm = new BigInteger(m+"");
	    	BigInteger bn = new BigInteger(n+"");
	    	BigInteger bt = new BigInteger(t+"");
	    	BigInteger two = new BigInteger("2");
	    	BigInteger t1 = two.multiply(bm.multiply(bn.multiply(bn.multiply(bn))));
	    	BigInteger t2 = two.multiply(bm.multiply(bn));
	    	BigInteger t3 = bn.multiply(bn.multiply(bn.multiply(bn)));
	    	BigInteger t4 = bn.multiply(bn);
	    	BigInteger tt1 = t2.add(t3);
	    	BigInteger tt2 = t1.add(t4);
	    	BigInteger t5 = tt2.subtract(tt1);
	    	BigInteger t6 = t5.divide(tw);
	    	
	    	BigInteger t7 = t6.mod(mod);
	    	// n(n + 1)/6*[2n + 3t + 1]
	    	
	    	BigInteger q1 = bn.multiply(new BigInteger("2"));
	    	BigInteger q2 = bt.multiply(new BigInteger("3"));
	    	BigInteger q3 = q1.add(q2.add(new BigInteger("1")));
	    	BigInteger q4 = bn.add(new BigInteger("1"));
	    	BigInteger q5 = q4.multiply(bn.multiply(q3));
	    	BigInteger q6 = q5.divide(new BigInteger("6"));
	    	BigInteger ans = q6.add(t6);
	    	ans = ans.mod(mod);
	    	
	    	
	    	
	    	
	    	return ans.intValue();
	    	
	    }
	}  
	
	public static void main(String args[]) throws IOException{
		FileInputStream  inputStream = new FileInputStream("input.txt");
		Scanner sc = new Scanner(inputStream, "UTF-8");
	    File file = new File("out.txt");
	    FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    BufferedWriter bw = new BufferedWriter(fw);
	    
	    
		int numOfTestCase;
		numOfTestCase = sc.nextInt();
		for (int i = 0; i < numOfTestCase; i++){
			int n,k;
			double pi = Math.PI;
			int r[] = new int[2000];
			int h[] = new int[2000];
			double sideArea[] = new double[2000];
			n = sc.nextInt();
			k = sc.nextInt();
			for (int j = 0; j < n; j++){
				r[j] = sc.nextInt();
				h[j] = sc.nextInt();
				sideArea[j] = 2 * pi * r[j] * h[j];
			}
			for (int j = 0; j < n; j++){
				for (int kk = j+1; kk < n; kk++){
					if (sideArea[j] < sideArea[kk]){
						double t = sideArea[j];
						sideArea[j] = sideArea[kk];
						sideArea[kk] = t;
						int tt = r[j];
						r[j] =  r[kk];
						r[kk] = tt;
					}
				}
			}
			double max = 0;
			for (int j = 0; j < n; j++){
				double area = pi * r[j] * r[j];
				area += sideArea[j];
				int remain = k-1;
				for (int kk = 0; kk < n; kk++){
					if (kk == j) continue;
					if (remain == 0) break;
					if (r[kk] <= r[j]){
						area += sideArea[kk];
						remain --;
					}
				}
				if (remain == 0 && area > max)
					max = area;
			}
			
			bw.write("Case #" + (i+1) + ": "+ max);
			if (i != numOfTestCase -1){
				bw.newLine();
			}
		}
		bw.flush();
		bw.close();
		sc.close();

	}
}
