import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class ProblemB {
	
	static final int MODULO = 1000000007;
	static ArrayList<String> allA = new ArrayList<String>();
	static ArrayList<String> allB = new ArrayList<String>();
	static String[] chars = {"","|","||","|||","||||"};
	//x^y % z
	public static int superMod(int x, int y, int z){
		//System.out.println("y is " +y);
		if (y == 0) return 1 %z;
		if (y == 1) return x % z;
		if (y == 2) return x %z *x %z;
		if (y %2 ==0){
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z;
		}else{
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z * x %z;
		}
	}
	
	public static void change(String a, int i){
		if (i == a.length()){
			allA.add(a);
			return;
		}
		if (a.charAt(i) == '*'){
			for (int j = 0; j < 5; j++){
				String newString = a.replaceFirst("\\*", chars[j]);
				change(newString, i+j);
			}
		}else{
			change(a, i+1);
		}
	}

	public static void change2(String a, int i){
		if (i == a.length()){
			allB.add(a);
			return;
		}
		if (a.charAt(i) == '*'){
			for (int j = 0; j < 5; j++){
				String newString = a.replaceFirst("\\*", chars[j]);
				change2(newString, i+j);
			}
		}else{
			change2(a, i+1);
		}
	}
	
	public static boolean isEqual(String a, String b){
		if (a.length() != b.length()) return false;
		for (int i = 0; i < a.length(); i++){
			if ((a.charAt(i) != b.charAt(i)) && ( a.charAt(i) != '|') && (b.charAt(i) != '|')){
				return false;
			}
		}
		return true;
	}
	
	public static String solve(String a , String b){  
		
		allA.clear();
		allB.clear();
		change(a, 0);
		change2(b, 0);
		for (int i =0; i < allA.size(); i++){
			for (int j = 0; j < allB.size(); j++){
				if (isEqual(allA.get(i), allB.get(j))){
					return "TRUE";
				}
			}
		}
		return "FALSE";
	}  
	
	public static String solve2(String a, String b){
		int n = a.length();
		int m = b.length();
		int[][] f = new int[n+10][m+10];
		for (int i =0; i < n; i++){
			for (int j = 0; j < m; j++){
				f[i][j] = 0;
			}
		}
		if (a.charAt(0) == b.charAt(0)){
			f[0][0] = 1;
		}else if ((a.charAt(0) == '*') || (b.charAt(0) == '*')){
			f[0][0] = 1;
		}
		if ((a.charAt(0) == '*')){
			f[0][0] = 1;
			for (int j = 1; j < m && j < 5; j++){
				f[0][j] = 1;
			}
		}
		if ((b.charAt(0) == '*')){
			f[0][0] = 1;
			for (int j = 1; j < n && j < 5; j++){
				f[j][0] = 1;
			}
		}
		for (int i = 1; i < n; i++){
			for (int j = 1; j < m; j++){
				//f[i][j] = 0;
				if (a.charAt(i) == b.charAt(j)){
						f[i][j] = f[i-1][j-1];  
				}
				if (a.charAt(i) == '*'){
					for (int k = 0; k < 5; k++){
						if (k <= j){
								f[i][j] = f[i][j] + f[i-1][j-k];
						}
					}					
				}
				if (b.charAt(j) == '*'){
					for (int k = 0; k < 5; k++){
						if (k <= i){
								f[i][j] = f[i][j] + f[i-k][j-1];
						}
					}					
				}
			}
		}
		if (f[n-1][m-1] > 0) return "TRUE";else
		return "FALSE";
	}
	
	public static void main(String args[]) throws IOException{
		FileInputStream  inputStream = new FileInputStream("input.txt");
		Scanner sc = new Scanner(inputStream, "UTF-8");
	    File file = new File("out.txt");
	    FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    BufferedWriter bw = new BufferedWriter(fw);
	    
	    
		int numOfTestCase;
		numOfTestCase = sc.nextInt();
		sc.nextLine();
		for (int q = 0; q < numOfTestCase; q++){
			int n = sc.nextInt();
			int m = sc.nextInt();
			int a1[] = new int[1000];
			int a2[] = new int[1000];
			int b1[] = new int[1000];
			int b2[] = new int[1000];
			for (int i = 0; i < n; i ++){
				a1[i] = sc.nextInt();
				a2[i] = sc.nextInt();
			}
			for (int i = 0; i < m; i++){
				b1[i] = sc.nextInt();
				b2[i] = sc.nextInt();
			}
			for (int i = 0; i < n; i++){
				for (int j = i+1; j < n; j++){
					if (a1[i] > a1[j]){
						int t = a1[i];
						a1[i] = a1[j];
						a1[j] = t;
						t = a2[i];
						a2[i] = a2[j];
						a2[j] = t;
					}
			
				}
			}
			for (int i = 0 ; i < m; i++){
				for (int j = i+1; j < m; j++){
					if (b1[i] > b1[j]){
						int t = b1[i];
						b1[i] = b1[j];
						b1[j] = t;
						t = b2[i];
						b2[i] = b2[j];
						b2[j] = t;
					}
				}
			}
			if (n + m <2)
				bw.write("Case #" + (q+1) + ": "+ 2);
			else if ((n == 1) && ( m == 1))
				bw.write("Case #" + (q+1) + ": "+ 2);
			else{
				if(n + m != 2){
					System.out.println("Fuck");
				}
				if (n == 2){
					if (a2[1] - a1[0] <= 720 || a2[0] - a1[1] + 1440 <= 720){
						bw.write("Case #" + (q+1) + ": "+ 2);
					}else{
						bw.write("Case #" + (q+1) + ": "+ 4);
					}
				}else{
					if (b2[1] - b1[0] <= 720 || b2[0] - b1[1] + 1440 <= 720){
						bw.write("Case #" + (q+1) + ": "+ 2);
					}else{
						bw.write("Case #" + (q+1) + ": "+ 4);
				
					}
				}
			}
			
			if (q != numOfTestCase -1){
				bw.newLine();
			}
		}
		bw.flush();
		bw.close();
		sc.close();

	}
}
