import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

public class ProblemC {
	
	static final int MODULO = 1000000007;
	static ArrayList<String> allA = new ArrayList<String>();
	static ArrayList<String> allB = new ArrayList<String>();
	static String[] chars = {"","|","||","|||","||||"};
	//x^y % z
	public static int superMod(int x, int y, int z){
		//System.out.println("y is " +y);
		if (y == 0) return 1 %z;
		if (y == 1) return x % z;
		if (y == 2) return x %z *x %z;
		if (y %2 ==0){
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z;
		}else{
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z * x %z;
		}
	}
	
	public static void change(String a, int i){
		if (i == a.length()){
			allA.add(a);
			return;
		}
		if (a.charAt(i) == '*'){
			for (int j = 0; j < 5; j++){
				String newString = a.replaceFirst("\\*", chars[j]);
				change(newString, i+j);
			}
		}else{
			change(a, i+1);
		}
	}

	public static void change2(String a, int i){
		if (i == a.length()){
			allB.add(a);
			return;
		}
		if (a.charAt(i) == '*'){
			for (int j = 0; j < 5; j++){
				String newString = a.replaceFirst("\\*", chars[j]);
				change2(newString, i+j);
			}
		}else{
			change2(a, i+1);
		}
	}
	
	public static boolean isEqual(String a, String b){
		if (a.length() != b.length()) return false;
		for (int i = 0; i < a.length(); i++){
			if ((a.charAt(i) != b.charAt(i)) && ( a.charAt(i) != '|') && (b.charAt(i) != '|')){
				return false;
			}
		}
		return true;
	}
	
	public static String solve(String a , String b){  
		
		allA.clear();
		allB.clear();
		change(a, 0);
		change2(b, 0);
		for (int i =0; i < allA.size(); i++){
			for (int j = 0; j < allB.size(); j++){
				if (isEqual(allA.get(i), allB.get(j))){
					return "TRUE";
				}
			}
		}
		return "FALSE";
	}  
	
	public static String solve2(String a, String b){
		int n = a.length();
		int m = b.length();
		int[][] f = new int[n+10][m+10];
		for (int i =0; i < n; i++){
			for (int j = 0; j < m; j++){
				f[i][j] = 0;
			}
		}
		if (a.charAt(0) == b.charAt(0)){
			f[0][0] = 1;
		}else if ((a.charAt(0) == '*') || (b.charAt(0) == '*')){
			f[0][0] = 1;
		}
		if ((a.charAt(0) == '*')){
			f[0][0] = 1;
			for (int j = 1; j < m && j < 5; j++){
				f[0][j] = 1;
			}
		}
		if ((b.charAt(0) == '*')){
			f[0][0] = 1;
			for (int j = 1; j < n && j < 5; j++){
				f[j][0] = 1;
			}
		}
		for (int i = 1; i < n; i++){
			for (int j = 1; j < m; j++){
				//f[i][j] = 0;
				if (a.charAt(i) == b.charAt(j)){
						f[i][j] = f[i-1][j-1];  
				}
				if (a.charAt(i) == '*'){
					for (int k = 0; k < 5; k++){
						if (k <= j){
								f[i][j] = f[i][j] + f[i-1][j-k];
						}
					}					
				}
				if (b.charAt(j) == '*'){
					for (int k = 0; k < 5; k++){
						if (k <= i){
								f[i][j] = f[i][j] + f[i-k][j-1];
						}
					}					
				}
			}
		}
		if (f[n-1][m-1] > 0) return "TRUE";else
		return "FALSE";
	}
	
	public static void main(String args[]) throws IOException{
		FileInputStream  inputStream = new FileInputStream("input.txt");
		Scanner sc = new Scanner(inputStream, "UTF-8");
	    File file = new File("out.txt");
	    FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    BufferedWriter bw = new BufferedWriter(fw);
	    
	    
		int numOfTestCase;
		numOfTestCase = sc.nextInt();
		sc.nextLine();
		for (int q = 0; q < numOfTestCase; q++){
			int n = sc.nextInt();
			int m = sc.nextInt();
			double u = sc.nextDouble();
			double a[] = new double[500];
			for (int i = 0; i < n; i++){
				a[i] = sc.nextDouble();
			}
			
			for (int i = 0; i < n; i++){
				for ( int j = i+1; j < n; j++){
					if (a[i] > a[j]){
						double t= a[i];
						a[i] = a[j];
						a[j] = t;
					}
				}
			}
			double total[] = new double[500];
			total[0] = a[0];
			for (int i = 1; i <n; i++){
				total[i] = a[i] + total[i-1];
			}
			if (u + total[n-1] >= n){
				bw.write("Case #" + (q+1) + ": "+ 1.000000);
			}else{
				for (int i = n-1; i >= 0; i--){
					if (u + total[i] >= a[i] * (i+1)){
						double f = 1;
						for (int j = 0; j <= i; j++){
							f *=  (u + total[i])/(i+1);
						}
						for (int j = i +1; j <n; j++){
							f *= a[j];
						}
						bw.write("Case #" + (q+1) + ": "+ f);
						break;
					}
				}
			}
//			double f = 1;
//			for (int i =0 ; i< n; i++){
//				f*=a[i];
//			}
//			bw.write("Case #" + (q+1) + ": "+ f);

			if (q != numOfTestCase -1){
				bw.newLine();
			}
		}
		bw.flush();
		bw.close();
		sc.close();

	}
}
