import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

public class ProblemC {
	
	static final int MODULO = 1000000007;
	//x^y % z
	public static int superMod(int x, int y, int z){
		//System.out.println("y is " +y);
		if (y == 0) return 1 %z;
		if (y == 1) return x % z;
		if (y == 2) return x %z *x %z;
		if (y %2 ==0){
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z;
		}else{
			int subAns = superMod(x,y/2,z);
			return (subAns * subAns) %z * x %z;
		}
	}
	
	public static long solve(long a, long k){
		long b = 0L;
		long c = 1L;
		while (b+c < k){
			b += c;
			c *= 2;
		}
		a -= b;
		k -= b;
		if (k <= a % c){
			return a/c +1;
		}else{
			return a/c;
		}
	}  
	
	public static void main(String args[]) throws IOException{
		FileInputStream  inputStream = new FileInputStream("input.txt");
		Scanner sc = new Scanner(inputStream, "UTF-8");
	    File file = new File("out.txt");
	    FileWriter fw = new FileWriter(file.getAbsoluteFile());
	    BufferedWriter bw = new BufferedWriter(fw);
	    
	    
		int numOfTestCase;
		numOfTestCase = sc.nextInt();
		for (int i = 0; i < numOfTestCase; i++){
			long a;
			long b;
			a = sc.nextLong();
			b = sc.nextLong();
			long ans = solve(a,b) -1;
			long max = ans /2 + ans %2;
			long min = ans /2;
			bw.write("Case #" + (i+1) + ": "+ max +" " + min);
			if (i != numOfTestCase -1){
				bw.newLine();
			}
		}
		bw.flush();
		bw.close();
		sc.close();

	}
}
