package com.googlecode.contest.recycled;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.StringTokenizer;

public class Recycler {

    public static void main(String[] args) throws Exception {
        File outputFile = new File("recyclers_output.txt");
        FileOutputStream fos = new FileOutputStream(outputFile);
        BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(fos));
        FileInputStream fis = new FileInputStream(args[0]);
        final String preface = "Case #";
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(fis));
        String numberOfTestCasesString = bufferedReader.readLine();
        int numberOfTestCases = Integer.parseInt(numberOfTestCasesString);
        for (int i = 1; i <= numberOfTestCases; i++) {
            RecyclerTestCase testCase = parseString(i, bufferedReader.readLine());
            solveTestCase(testCase);
            System.out.println(preface + i + ": " + testCase.getAnswer());
            bufferedWriter.write(preface + i + ": " + testCase.getAnswer() );
            bufferedWriter.newLine();
            bufferedWriter.flush();
        }
    }

    private static void solveTestCase(RecyclerTestCase testCase) {
        if (testCase.int1 < 9) {
            System.out.println("single digits never work");
            testCase.setAnswer(0);
            return;
        }

        if (testCase.int1 < 99) {
            System.out.println("testing " + testCase.int1 + " " + testCase.int2);
            int combos = 0;
            for (int i = testCase.int1; i < testCase.int2; i++) {
                if (i % 10 == 0) {
                    continue;
                }
                for (int j = testCase.int2; j > testCase.int1 && j > i; j--) {
                    String integer1 = "" + i;
                    char char1 = integer1.charAt(0);
                    char char2 = integer1.charAt(1);
                    StringBuffer buffer = new StringBuffer().append(char2).append(char1);
                    int flippedNumber = Integer.parseInt(buffer.toString());
                    if (flippedNumber == j) {
                        System.out.println("found combo " + i + " " + j);
                        combos++;
                    }

               }
            }
            testCase.setAnswer(combos);
            return;
        }

       if (testCase.int1 <= 999) {
            System.out.println("testing " + testCase.int1 + " " + testCase.int2);
            int combos = 0;
            for (int i = testCase.int1; i < testCase.int2; i++) {

                for (int j = testCase.int2; j > testCase.int1 && j > i; j--) {
                    //System.out.println("in second loop j: " + j);
                    String integer1 = "" + i;
                    char char1 = integer1.charAt(0);
                    char char2 = integer1.charAt(1);
                    char char3 = integer1.charAt(2);

                    StringBuffer buffer = new StringBuffer().append(char2).append(char3).append(char1);
                    int flippedNumber = Integer.parseInt(buffer.toString());
                    if (flippedNumber == j) {
                        System.out.println("found combo " + i + " " + j);
                        combos++;
                    }

                    buffer = new StringBuffer().append(char3).append(char2).append(char1);
                    flippedNumber = Integer.parseInt(buffer.toString());
                    if (flippedNumber == j) {
                        System.out.println("found combo " + i + " " + j);
                        combos++;
                    }

                    buffer = new StringBuffer().append(char3).append(char1).append(char2);
                    flippedNumber = Integer.parseInt(buffer.toString());
                    if (flippedNumber == j) {
                        System.out.println("found combo " + i + " " + j);
                        combos++;
                    }
               }
            }
            testCase.setAnswer(combos);
        }
    }

    public static RecyclerTestCase parseString(final int testCaseNumber, final String s) {
        StringTokenizer tokenizer = new StringTokenizer(s);
        String int1String = tokenizer.nextToken();
        int int1 = Integer.parseInt(int1String);
        String int2String = tokenizer.nextToken();
        int int2 = Integer.parseInt(int2String);
        RecyclerTestCase testCase = new RecyclerTestCase(testCaseNumber, int1, int2);
        return testCase;
    }

    static class RecyclerTestCase {
        private int answer;
        final int testCaseNumber;
        final int int1;
        final int int2;

        public RecyclerTestCase(int testCaseNumber, int int1, int int2) {
            this.testCaseNumber = testCaseNumber;
            this.int1 = int1;
            this.int2 = int2;
        }

        public int getAnswer() {
            return answer;
        }

        public void setAnswer(int answer) {
            this.answer = answer;
        }
    }
}
