import com.sun.org.apache.xpath.internal.FoundIndex;

import java.io.*;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

/**
 * Created by IntelliJ IDEA.
 * User: jdunn010
 * Date: 4/12/13
 * Time: 4:25 PM
 * To change this template use File | Settings | File Templates.
 */
public class TomekApp {

    private static int numberOfTestCases = 0;
    private static ArrayList<String> fileStrings = new ArrayList<String>();
    private static ArrayList<String> testCases = new ArrayList<String>();

    public static void main(String[] args) throws Exception {
        PrintStream out = new PrintStream(new FileOutputStream("tomek_large_test_output.txt"));
        System.setOut(out);
        System.err.println("starting the game from " + System.getProperty("user.dir"));
        //System.out.println("parsing the file..." + args[0]);
        parseFile(args[0]);
        verifyNumberOfTestCases();
        generateTestCases();
        //System.out.println("number of test cases found: " + testCases.size());
        analyzeTestCases();
    }

    private static void analyzeTestCases() {
        int testIndex = 0;
        for (String testCase : testCases) {
            testIndex++;
            String result = checkRows(testCase);
            if (result.isEmpty() == false) {
                //System.out.println("FOUND A ROW WINNER");
                handleWinner(result, testIndex);
            } else if ((result = checkColumns(testCase)).isEmpty() == false) {
                //System.out.println("FOUND A COLUMN WINNER");
                handleWinner(result, testIndex);
            } else if ((result = checkDiagonals(testCase)).isEmpty() == false) {
                //System.out.println("FOUND A DIAGONAL WINNER");
                handleWinner(result, testIndex);
            } else if (testCase.contains(".")) {
                System.out.println("Case #" + testIndex + ": Game has not completed");
            } else {
                System.out.println("Case #" + testIndex + ": Draw");
            }

        }

    }

    private static void handleWinner(String result, int index) {
        if (result.contains("X")) {
            System.out.println("Case #" + index + ": X won");
        } else {
            System.out.println("Case #" + index + ": O won");
        }

    }


    private static String checkDiagonals(String testCase) {
        String diagonal1 = "";
        String diagonal2 = "";
        for (int i = 0; i < testCase.length(); i += 5) {
            diagonal1 += testCase.charAt(i);
        }
        //System.out.println("diagonal 1: " + diagonal1);
        if (verifyString(diagonal1)) {
            return diagonal1;
        }
        for (int i = 3; i < testCase.length() - 3; i += 3) {
            diagonal2 += testCase.charAt(i);
        }
        //System.out.println("diagonal 2: " + diagonal2);
        if (verifyString(diagonal2)) {
            return diagonal2;
        }
        return "";
    }

    private static String checkColumns(String testCase) {
        String column1 = "";
        String column2 = "";
        String column3 = "";
        String column4 = "";


        //System.out.println("Test Case contains list of " + testCase.size() + " rows.");
        String wholeTestString = testCase;

        if (wholeTestString.length() != 16) {
            throw new IllegalStateException();
        }

        for (int i = 0; i < wholeTestString.length(); i++) {
            if (i % 4 == (0)) {
                column1 += wholeTestString.charAt(i);
            } else if (i % 4 == 1) {
                column2 += wholeTestString.charAt(i);
            } else if (i % 4 == 2) {
                column3 += wholeTestString.charAt(i);
            } else if (i % 4 == 3) {
                column4 += wholeTestString.charAt(i);
            }
        }

        String[] columns = {column1, column2, column3, column4};
        for (String column : columns) {
            //System.out.println("column: " + column);
            if (verifyString(column)) {
                //System.out.println("found a winning column: " + column);
                return column;
            }
        }

        return "";
    }

    private static String checkRows(String testCase) {
        //System.out.println("checking rows for test case: " + testCase);
        String[] result = new String[4];

        int j = 0;
        int lastIndex = result.length - 1;
        for (int i = 0; i < lastIndex; i++) {
            result[i] = testCase.substring(j, j + 4);
            j += 4;
        }
        result[lastIndex] = testCase.substring(j);

        String row = "";
        for (int i = 0; i < result.length; i++) {
            row = result[i];

            if (verifyString(row)) {
                //System.out.println("found a winning row: " + row);
                return row;
            }

        }

        return "";
    }

    private static boolean verifyString(String entry) {
        if (entry.contains(".")) {
            return false;
        } else if (entry.contains("O") && entry.contains("X")) {
            return false;
        } else {
            return true;
        }
    }

    private static void generateTestCases() {
        String wholeTestCaseString = "";
        int index = 0;
        for (String fileString : fileStrings) {
            wholeTestCaseString += fileString;
            index++;
            if (index % 4 == 0) {
                testCases.add(wholeTestCaseString);
                wholeTestCaseString = "";
            }
        }
    }

    private static void parseFile(String fileName) throws Exception {
        FileReader input = new FileReader(fileName);
        BufferedReader bufRead = new BufferedReader(input);
        String myLine = bufRead.readLine();
        calculateNumberOfTestCases(myLine);

        while ((myLine = bufRead.readLine()) != null) {
            if (myLine.isEmpty() == false) {
                fileStrings.add(myLine);
            }
        }
    }

    private static void calculateNumberOfTestCases(String myLine) {
        TomekApp.numberOfTestCases = Integer.parseInt(myLine);
    }

    private static void verifyNumberOfTestCases() {
        if (fileStrings.size() % 4 != 0) {
            throw new IllegalStateException();
        } else if (fileStrings.size() / 4 != numberOfTestCases) {
            throw new IllegalStateException();
        }
    }
}
