package com.googlecode.contest.googlerese;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.HashMap;

public class GooglereseTranslator {
    final static HashMap<Character,Character> googlereseKeys= new HashMap<Character, Character>();

    final static char[] englishChars = {'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z'};
    final static char[] googlereseChars = {'y','n','f','i','c','w','l','b','k','u','o','m','x','s','e','v','z','p','d','r','j','g','t','h','a','q'};

    static {
        for (int i = 0; i < googlereseChars.length; i++) {
            googlereseKeys.put(googlereseChars[i], englishChars[i]);
        }
    }

    public static void main(String[] args) throws Exception {
        File outputFile = new File("googlerese_output.txt");
        FileOutputStream fos = new FileOutputStream(outputFile);
        BufferedWriter bufferedWriter = new BufferedWriter(new OutputStreamWriter(fos));
        FileInputStream fis = new FileInputStream(args[0]);
        final String preface = "Case #";
        BufferedReader bufferedReader = new BufferedReader(new InputStreamReader(fis));
        String numberOfTestCasesString = bufferedReader.readLine();
        int numberOfTestCases = Integer.parseInt(numberOfTestCasesString);
        for (int i = 1; i <= numberOfTestCases; i++) {
            String resultString = translateGooglereseToEnglish(bufferedReader.readLine());
            System.out.println(preface + i + " " + resultString);
            bufferedWriter.write(preface + i + ": " + resultString );
            bufferedWriter.newLine();
            bufferedWriter.flush();
        }

    }

    public static String translateGooglereseToEnglish(String googlereseString) {
        StringBuffer newString = new StringBuffer();
        int stringLength = googlereseString.length();

        for (int i = 0; i < stringLength; i++) {
            char charAt = googlereseString.charAt(i);
            if (googlereseKeys.containsKey(charAt)) {
                newString.append(googlereseKeys.get(charAt));
            } else {
                newString.append(charAt);
            }
        }
        return newString.toString();
    }
}