package nb;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import utils.FileUtils;

public class B {
	
	private static final char LETTER = 'B';
	private static final int ATTEMPT = 0;
	private static final boolean LARGE = true;
	private static final boolean PRACTICE = false;
	
	public static void main(String[] args) throws IOException {
		
		BufferedReader br = FileUtils.getReader(LETTER, ATTEMPT, LARGE, PRACTICE);
		BufferedWriter bw = FileUtils.getWriter(LETTER, LARGE);

		int t = Integer.parseInt(br.readLine());
		for(int x = 1; x <=t; x++) {
			
			String[] chunks = br.readLine().split(" ");
			
			Map<Character, Character>[] combine = new Map[26];
			for (int i = 0; i < 26; i++) {
				combine[i] = new HashMap<Character, Character>();
			}
			
			int c = Integer.parseInt(chunks[0]);
			for (int i = 0; i < c; i++) {
				char base1 = chunks[i + 1].charAt(0);
				char base2 = chunks[i + 1].charAt(1);
				char nonBase = chunks[i + 1].charAt(2);
				
				combine[base1 - 'A'].put(base2, nonBase);
				combine[base2 - 'A'].put(base1, nonBase);
			}
			
			int[] opposed = new int[26];
			
			int d = Integer.parseInt(chunks[c + 1]);
			for (int i = 0; i < d; i++) {
				char base1 = chunks[i + c + 2].charAt(0);
				char base2 = chunks[i + c + 2].charAt(1);
			
				opposed[base1 - 'A'] = setBit(opposed[base1 - 'A'], base2);
				opposed[base2 - 'A'] = setBit(opposed[base2 - 'A'], base1);
			}
			
			int n = Integer.parseInt(chunks[c + d + 2]);
			char[] input = chunks[c + d + 3].toCharArray();
			
			List<Character> elements = new ArrayList<Character>();
			int elementsVector = 0;
			for (char in : input) {
				if (elements.isEmpty()) {
					elements.add(in);
					elementsVector = setBit(elementsVector, in);
					continue;
				}
				
				char lastElement = elements.get(elements.size() - 1);
				if (combine[in - 'A'].containsKey(lastElement)) {
					elements.remove(elements.size() - 1);
					elements.add(combine[in - 'A'].get(lastElement));
					if (!elements.contains(lastElement)) {
						elementsVector = unsetBit(elementsVector, lastElement);
					}
					
				} else if ((elementsVector & opposed[in - 'A']) > 0) {
					elements.clear();
					elementsVector = 0;
				
				} else {
					elements.add(in);
					elementsVector = setBit(elementsVector, in);
				}
			}
			
			String msgOut = "Case #" + x + ": [";
			for (int i = 0; i < elements.size(); i++) {
				msgOut += elements.get(i);
				if (i < elements.size() - 1) {
					msgOut += ", "; 
				}
			}
			msgOut += "]";
			
			System.out.println(msgOut);
			bw.write(msgOut + "\n");
		}
		
		br.close();
		bw.close();
	}
	
	private static int setBit(int vector, char letter) {
		return vector | (1 << (letter - 'A'));
	}
	
	private static int unsetBit(int vector, char letter) {
		return vector & ~(1 << (letter - 'A'));
	}
}

