package jamUtil;
import java.awt.Container;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.PrintStream;
import java.util.Scanner;

import javax.swing.BoxLayout;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;
import javax.swing.border.TitledBorder;


public class IOConsole {

	private FileReader in;
	private PrintStream out;

	public IOConsole(String fileInName, String fileOutName) {

		try {
			in = new FileReader(new File(fileInName));
		} catch (Exception e) {
			System.err.println("Problem initializing input file.");
			System.err.println(e);
		}

		try {
			out = new PrintStream(new FileOutputStream(new File(fileOutName)));
		} catch (Exception e) {
			System.err.println("Problem initializing output file.");
			System.err.println(e);
		}

		this.fileInName = fileInName;
		this.fileOutName = fileOutName;

	}

	public Scanner getScanner() {
		return new Scanner(in);
	}

	public PrintStream getOut() {
		return out;
	}

	private String fileInName;
	private String fileOutName;

	public void displayFiles() {
		
		Scanner inputScanner = null;
		Scanner outputScanner = null;
		
		try {
			inputScanner = new Scanner(new FileReader(new File(fileInName)));
			outputScanner = new Scanner(new FileReader(new File(fileOutName)));
		} catch (Exception e) {
			System.err.println("Couldn't read from files.");
			System.err.println(e);
			return;
		}
		
		JFrame frame = new JFrame("Code Jam Question Inspector");
		frame.setSize(400,400);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

		Container content = frame.getContentPane();
		BoxLayout layout = new BoxLayout(content, BoxLayout.X_AXIS);
		content.setLayout(layout);

		JTextArea inText = new JTextArea();
		JTextArea outText = new JTextArea();

		while(inputScanner.hasNextLine()) {
			inText.append(inputScanner.nextLine() + "\n");
		}
		
		while(outputScanner.hasNextLine()) {
			outText.append(outputScanner.nextLine() + "\n");
		}
		
		JScrollPane inPane = new JScrollPane(inText);
		inPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		inPane.setBorder(new TitledBorder("Input: " + fileInName));
		content.add(inPane);
		
		JScrollPane outPane = new JScrollPane(outText);
		outPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
		outPane.setBorder(new TitledBorder("Outpout: " + fileOutName));
		content.add(outPane);

		frame.setVisible(true);

	}


}
