package question2;

import jamUtil.IOConsole;

import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class TrainController {

	private ArrayList<Time> times = new ArrayList<Time>();
	private Set<Time> aTimes, bTimes;

	int aNeeded, bNeeded;
	private TrainStation a, b;

	public TrainController(int turnAround, Map<Time, Time> aTimes, Map<Time, Time> bTimes) {
		this.aTimes = aTimes.keySet();
		this.bTimes = bTimes.keySet();
		times.addAll(this.aTimes);
		times.addAll(this.bTimes);
		Collections.sort(this.times);

		a = new TrainStation(aTimes, turnAround);
		b = new TrainStation(bTimes, turnAround);

		calculate();
	}

	public int aTrains() {
		return aNeeded;
	}
	
	public int bTrains() {
		return bNeeded;
	}
	
		
	private void calculate() {

		for(Time t : times) {

			if(aTimes.contains(t)) {
				
				if(a.getReady(t) == null) {
					a.addTrain();
					aNeeded++;
				}

				Train train = a.getReady(t);
				
				a.depart(train, t);
				b.arrive(train);

			}

			if(bTimes.contains(t)) {

				if(b.getReady(t) == null) {
					b.addTrain();
					bNeeded++;
				}
					
				Train train = b.getReady(t);
				
				b.depart(train, t);
				a.arrive(train);

			}
		}
	}


	public static void main(String[] args){

		IOConsole io = new IOConsole("B-large.in", "B-large.out");

		Scanner s = io.getScanner();

		int n = Integer.parseInt(s.nextLine());

		for(int i = 1; i <= n; i++) {

			int turnAround = Integer.parseInt(s.nextLine());
			String[] numTrips = s.nextLine().split(" ");
			int na = Integer.parseInt(numTrips[0]);
			int nb = Integer.parseInt(numTrips[1]);
			Map<Time, Time> aTimes = new HashMap<Time,Time>();
			Map<Time, Time> bTimes = new HashMap<Time,Time>();

			for(int j = 1; j <= na; j++ ) {

				String[] times = s.nextLine().split(" ");
				String[] depart = times[0].split(":");
				String[] arrive = times[1].split(":");

				aTimes.put(new Time(Integer.parseInt(depart[0]), Integer.parseInt(depart[1])), 
						new Time(Integer.parseInt(arrive[0]), Integer.parseInt(arrive[1])));

			}

			for(int j = 1; j <= nb; j++ ) {

				String[] times = s.nextLine().split(" ");
				String[] depart = times[0].split(":");
				String[] arrive = times[1].split(":");

				bTimes.put(new Time(Integer.parseInt(depart[0]), Integer.parseInt(depart[1])), 
						new Time(Integer.parseInt(arrive[0]), Integer.parseInt(arrive[1])));

			}
			
			TrainController tc = new TrainController(turnAround, aTimes, bTimes);

			io.getOut().println("Case #" + i + ": " + tc.aTrains() + " " + tc.bTrains());
		}
		
		io.displayFiles();

	}

}
