package a1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;

import utils.FileUtils;

public class A {

	private static final char LETTER = 'A';
	private static final boolean LARGE = true;
	private static final int attempt = 0;

	public static void main(String[] args) throws IOException {

		BufferedReader br = FileUtils.getReader(LETTER, attempt, LARGE);
		BufferedWriter bw = FileUtils.getWriter(LETTER, LARGE);

		int t = Integer.parseInt(br.readLine());

		for(int x = 1; x <= t; x++) {
			String[] chunks = br.readLine().split(" ");

			int n = Integer.parseInt(chunks[0]);
			int k = Integer.parseInt(chunks[1]);

			char[][] board = new char[n][n];

			for(int i = 0; i < n; i++) {
				String line = br.readLine();
				for(int j = 0; j < n; j++) {
					board[i][j] = line.charAt(j);
				}
			}


			for(int i = 0; i < n; i++) {
				for(int j = board[i].length-1; j>=0; j--) {
					int count = 0;
					while(board[i][j] == '.' && count < j) {
						for(int z = j; z > 0; z--) {
							if(board[i][z] == '.') {
								board[i][z] = board[i][z-1];
								board[i][z-1] = '.';
							}
						}
						count++;
					}
				}
			}

			boolean blueWin = false;
			boolean redWin = false;

			/*horiz*/
			for(int i = 0; i < n; i++) {
				int countR = 0;
				int countB = 0;
				boolean onR = false;
				boolean onB = false;
				for(int j = n-1; j >=0; j--) {
					if(board[i][j] == '.') {
						countB = 0;
						countR = 0;
						onB = false;
						onR = false;
						continue;
					}

					if(board[i][j] == 'R') {
						countB = 0;
						onB = false;
						onR = true;
						countR++;
					} else {
						countR = 0;
						onR = false;
						onB = true;
						countB++;
					}
					if(countR >= k) redWin = true;
					if(countB >= k) blueWin = true;
					if(redWin && blueWin) break;
				}

			}


			/*vert*/
			for(int i = 0; i < n; i++) {
				int countR = 0;
				int countB = 0;
				boolean onR = false;
				boolean onB = false;
				for(int j = n-1; j >=0; j--) {
					if(board[j][i] == '.') {
						countB = 0;
						countR = 0;
						onB = false;
						onR = false;
						continue;
					}

					if(board[j][i] == 'R') {
						countB = 0;
						onB = false;
						onR = true;
						countR++;
					} else {
						countR = 0;
						onR = false;
						onB = true;
						countB++;
					}
					if(countR >= k) redWin = true;
					if(countB >= k) blueWin = true;
					if(redWin && blueWin) break;
				}

			}


			/*L-diag*/
			for(int i = 0; i < n; i++) {
				int countR = 0;
				int countB = 0;
				boolean onR = false;
				boolean onB = false;
				for(int j = 0; j <= i; j++) {

					if(board[j][i-j] == '.') {
						countB = 0;
						countR = 0;
						onB = false;
						onR = false;
						continue;
					}

					if(board[j][i-j] == 'R') {
						countB = 0;
						onB = false;
						onR = true;
						countR++;
					} else {
						countR = 0;
						onR = false;
						onB = true;
						countB++;
					}
					if(countR >= k) redWin = true;
					if(countB >= k) blueWin = true;
					if(redWin && blueWin) break;
				}


				countR = 0;
				countB = 0;
				onR = false;
				onB = false;
				for(int j = 0; j <= n-1-i; j++) {
					if(board[n-1-j][i+j] == '.') {
						countB = 0;
						countR = 0;
						onB = false;
						onR = false;
						continue;
					}



					if(board[n-1-j][i+j] == 'R') {
						countB = 0;
						onB = false;
						onR = true;
						countR++;
					} else {
						countR = 0;
						onR = false;
						onB = true;
						countB++;
					}
					if(countR >= k) redWin = true;
					if(countB >= k) blueWin = true;
					if(redWin && blueWin) break;
				}

			}

			/*R-diag*/
			for(int i = 0; i < n; i++) {
				int countR = 0;
				int countB = 0;
				boolean onR = false;
				boolean onB = false;
				for(int j = 0; j <= i && i+j < n; j++) {
					if(board[j][i+j] == '.') {
						countB = 0;
						countR = 0;
						onB = false;
						onR = false;
						continue;
					}

					if(board[j][i+j] == 'R') {
						countB = 0;
						onB = false;
						onR = true;
						countR++;
					} else {
						countR = 0;
						onR = false;
						onB = true;
						countB++;
					}
					if(countR >= k) redWin = true;
					if(countB >= k) blueWin = true;
					if(redWin && blueWin) break;
				}


				countR = 0;
				countB = 0;
				onR = false;
				onB = false;
				for(int j = 0; j <= i; j++) {
					if(board[n-1-j][i-j] == '.') {
						countB = 0;
						countR = 0;
						onB = false;
						onR = false;
						continue;
					}

					if(board[n-1-j][i-j] == 'R') {
						countB = 0;
						onB = false;
						onR = true;
						countR++;
					} else {
						countR = 0;
						onR = false;
						onB = true;
						countB++;
					}
					if(countR >= k) redWin = true;
					if(countB >= k) blueWin = true;
					if(redWin && blueWin) break;
				}

			}

			String msgOut = "Case #" + x + ": ";

			if(redWin && blueWin) {
				msgOut += "Both";
			} else if(redWin) {
				msgOut += "Red";
			} else if(blueWin) {
				msgOut += "Blue";
			} else {
				msgOut += "Neither";
			}

			System.out.println(msgOut);
			bw.write(msgOut  + "\n");
			
		}

		br.close();
		bw.close();

	}

	public static void printBoard(char[][] board) {
		for(int i = 0; i < board.length; i++) {
			for(int j = 0; j < board.length; j++) {
				System.out.print(board[i][j]);
			}
			System.out.println();
		}
	}

}
