package utils;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;

public class FileUtils {

	private static final String LARGE = "large";
	private static final String SMALL = "small-attempt";
	
	private static final String IN_SUFFIX = ".in";
	private static final String OUT_SUFFIX = ".out";
	
	public static BufferedReader getReader(char letter, int attempt, boolean large) throws IOException {
		String fileName = letter + "-" + (large ? LARGE : SMALL + attempt) + IN_SUFFIX;
		File f = new File(fileName);
		
		return new BufferedReader(new InputStreamReader(new FileInputStream(f)));
	}
	
	public static BufferedWriter getWriter(char letter, boolean large) throws IOException {
		String fileName = letter + "-" + (large ? LARGE : SMALL) + OUT_SUFFIX;
		File f = new File(fileName);
		
		if(f.exists())
			f.delete();
		
		if(!f.createNewFile())
			throw new IOException("Couldn't create output file '" + fileName + "'.");
		
		return new BufferedWriter(new FileWriter(f));
	}
	
}
