package question2;

import java.util.HashSet;
import java.util.Map;
import java.util.Set;

public class TrainStation {

	Map<Time, Time> times;
	int turnAround;
	Set<Train> trains = new HashSet<Train>();
	
	public TrainStation(Map<Time, Time> times, int turnAround) {
		this.times = times;
		this.turnAround = turnAround;
	}
	
	public void addTrain() {
		trains.add(new Train(turnAround));
	}
	
	public void arrive(Train train) {
		trains.add(train);
	}
	
	public void depart(Train train, Time time) {
		train = getReady(time);
		train.depart(times.get(time));
		trains.remove(train);
	}
	
	public Train getReady(Time time) {
		for(Train t : trains) {
			if(t.isReady(time))
				return t;
		}
		
		return null;
	}
	
	public int getNumTrains() {
		return trains.size();
	}
	
}
