package b_1c;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;

import utils.FileUtils;

public class B {
	
	private static final char LETTER = 'B';
	private static final int ATTEMPT = 0;
	private static final boolean LARGE = false;
	private static final boolean PRACTICE = false;
	
	public static void main(String[] args) throws IOException {
		
		BufferedReader br = FileUtils.getReader(LETTER, ATTEMPT, LARGE, PRACTICE);
		BufferedWriter bw = FileUtils.getWriter(LETTER, LARGE);

		int t = Integer.parseInt(br.readLine());
		double ln2 = Math.log(2);
		
		for(int x = 1; x <=t; x++) {
			
			String[] chunks = br.readLine().split(" ");
			
			long l = Integer.parseInt(chunks[0]);
			long p = Integer.parseInt(chunks[1]);
			int c = Integer.parseInt(chunks[2]);
			
			int steps = recurseRange(l,p,c);
			
			int answer = steps == 0 ? 0 : (int)(Math.floor(Math.log(steps)/ln2) + 1);
			
			String msgOut = "Case #" + x + ": " + answer;
			
			System.out.println(msgOut);
			bw.write(msgOut + "\n");
		}
		
		br.close();
		bw.close();
	}
	
	public static int recurseRange(long l, long p, int c) {
		System.out.println(l + "," + p);
		
		if(l * c >= p)
			return 0;
		
		long l1 = l*c;
		long p1 = (long)Math.ceil(((double)p)/c);
		if(l1 - l > p - p1) {
			return 1 + recurseRange(l1, p, c);
		} else {
			return 1 + recurseRange(l, p1, c);
		}
	}

}

