package a_1b;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import utils.FileUtils;

public class A {

	private static final char LETTER = 'A';
	private static final int ATTEMPT = 0;
	private static final boolean LARGE = true;
	private static final boolean PRACTICE = false;

	String name;
	List<A> children;

	public A(String name) {
		this.name = name;
		children = new ArrayList<A>();
	}

	public int add(String path) {
		if(path.equals(""))
			return 0;
		//System.out.println(path);
		
		int firstSlash =path.indexOf("/");
		if(firstSlash < 0) {
			for(A a : children)
				if(a.name.equals(path))
					return 0;
			
			children.add(new A(path));
			return 1;

		} else {
			String nextDir = path.substring(0, firstSlash);
			for(A a : children) 
				if(a.name.equals(nextDir)) 
					return a.add(path.substring(firstSlash + 1));

			A next = new A(nextDir);
			children.add(next);
			return 1 + next.add(path.substring(firstSlash + 1));
			
		}
	}

	public static void main(String[] args) throws IOException {

		BufferedReader br = FileUtils.getReader(LETTER, ATTEMPT, LARGE, PRACTICE);
		BufferedWriter bw = FileUtils.getWriter(LETTER, LARGE);

		int t = Integer.parseInt(br.readLine());

		for(int x = 1; x <=t; x++) {

			String[] chunks = br.readLine().split(" ");
			int n = Integer.parseInt(chunks[0]);
			int m = Integer.parseInt(chunks[1]);

			A root = new A("/");
			
			for(int i = 0; i < n; i++) {
				root.add(br.readLine().substring(1));
			}

			int sum = 0;
			for(int i = 0; i < m; i++)
				sum += root.add(br.readLine().substring(1));
				
			String msgOut = "Case #" + x + ": " + sum;

			System.out.println(msgOut);
			bw.write(msgOut + "\n");
		}

		br.close();
		bw.close();
	}

}

