package c1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import utils.FileUtils;

public class C {

	private static final char LETTER = 'C';
	private static final boolean LARGE = false;
	private static final int attempt = 1;

	public static void main(String[] args) throws IOException {

		BufferedReader br = FileUtils.getReader(LETTER, attempt, LARGE);
		BufferedWriter bw = FileUtils.getWriter(LETTER, LARGE);

		int t = Integer.parseInt(br.readLine());

		for(int x = 1; x <=t; x++) {

			String[] chunks = br.readLine().split(" ");
			int a1 = Integer.parseInt(chunks[0]);
			int a2 = Integer.parseInt(chunks[1]);
			int b1 = Integer.parseInt(chunks[2]);
			int b2 = Integer.parseInt(chunks[3]);

			int count = 0;
			
			for(int a = a1; a <= a2; a++) {
				for(int b = b1; b <= b2; b++) {
					int bigger = a > b ? a : b;
					int smaller = a > b ? b : a;
					if(recurseCorrect(smaller,bigger,true))
						count++;
				}
			}
			
			
			String msgOut = "Case #" + x + ": " + count;
			System.out.println(msgOut);
			bw.write(msgOut + "\n");
		}

		br.close();
		bw.close();

	}
	
	public static boolean recurseCorrect(int a, int b, boolean aTurn) {
		
		for(int i = (int)a/b; i > 0; i--) {
			int value = a - i*b;
			if(value < 1) continue;
			//System.out.println(a + "," + b);
			if(recurseCorrect(value, b, !aTurn)) {
				if(aTurn)
					return true;
				
			} else if(!aTurn){
				return false;
			}
		}
		for(int i = (int)b/a; i >0; i--) {
			int value = b - i*a;
			if(value < 1) continue;
			if(recurseCorrect(a, value, !aTurn)) {
				if(aTurn)
					return true;
				
			} else if(!aTurn){
				return false;
			}
		}

		return !aTurn;
	}

}
