package c_2;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

import utils.FileUtils;

public class C {

	private static final char LETTER = 'C';
	private static final int ATTEMPT = 0;
	private static final boolean LARGE = false;
	private static final boolean PRACTICE = false;

	int x, y;
	
	public C(int x, int y) {
		this.x = x;
		this.y = y;
	}
	
	public boolean equals(Object o) {
		if(o == null) {
			return false;
		} else if(o instanceof C) {
			return ((C) o).x == x && ((C)o).y == y;
		} else {
			return false;
		}
	}
	
	public int hashCode() {
		return (x + "," + y).hashCode();
	}
	
	public String toString() {
		return (x + "," + y);
	}
	
	public static void main(String[] args) throws IOException {

		BufferedReader br = FileUtils.getReader(LETTER, ATTEMPT, LARGE, PRACTICE);
		BufferedWriter bw = FileUtils.getWriter(LETTER, LARGE);

		int c = Integer.parseInt(br.readLine());

		for(int n = 1; n <=c; n++) {

			int r = Integer.parseInt(br.readLine());
			Set<C> table = new HashSet<C>();
			Set<C> nextTable = new HashSet<C>();

			for(int i = 0; i < r; i++) {
				String[] chunks = br.readLine().split(" ");

				int x1 = Integer.parseInt(chunks[0]);
				int y1 = Integer.parseInt(chunks[1]);
				int x2 = Integer.parseInt(chunks[2]);
				int y2 = Integer.parseInt(chunks[3]);

				for(int x = x1; x <= x2; x++) {
					for(int y = y1; y <= y2; y++) {
						table.add(new C(x,y));
					}
				}
			}

			int time = 1;

			for(;; time++) {
				nextTable.clear();
				for(C b : table) {
					if(table.contains(new C(b.x-1, b.y+1)))
						nextTable.add(new C(b.x, b.y+1));
					if(table.contains(new C(b.x-1, b.y)) || table.contains(new C(b.x, b.y-1)))
						nextTable.add(b);
						
				}
				
				if(nextTable.isEmpty()) break;
				
				table.clear();
				table.addAll(nextTable);
			}

			String msgOut = "Case #" + n + ": " + time;

			System.out.println(msgOut);
			bw.write(msgOut + "\n");
		}

		br.close();
		bw.close();
	}

}

