package qb;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

import utils.FileUtils;

public class B {

	private static final char LETTER = 'B';
	private static final int ATTEMPT = 2;
	private static final boolean LARGE = true;

	public static void main(String[] args) throws IOException {

		BufferedReader br = FileUtils.getReader(LETTER, ATTEMPT, LARGE);
		BufferedWriter bw = FileUtils.getWriter(LETTER, LARGE);

		int c = Integer.parseInt(br.readLine());

		for(int x = 0; x < c; x++) {

			String[] chunks = br.readLine().split(" ");
			int n = Integer.parseInt(chunks[0]);

			BigInteger min = null;

			BigInteger[] bigInts = new BigInteger[n];
			for(int i = 0; i < n; i++) {
				bigInts[i] = new BigInteger(chunks[i+1]);
				if(min == null)
					min = bigInts[i];
				else
					min = min.min(bigInts[i]);
			}

			BigInteger gcd = null;

			for(int i = 0; i < n; i++) {
				for(int j = i + 1; j < n; j++) {
					BigInteger difference = bigInts[i].subtract(bigInts[j]).abs();
					if(difference.equals(BigInteger.ZERO))
						continue;

					if(gcd == null) {
						gcd = difference;

					} else {
						gcd = gcd.gcd(difference);
					}
				}
			}

			BigInteger y = null;

			if(gcd.equals(BigInteger.ONE)) {
				y = BigInteger.ZERO;

			} else {
				if(min.mod(gcd).equals(BigInteger.ZERO))
					y = BigInteger.ZERO;
				else
					y = gcd.subtract(min.mod(gcd));


				for(;; y = y.add(gcd)) {
					boolean finished = true;
					for(int i = 0; i < n; i++) {
						bigInts[i] = bigInts[i].add(y);
						if(!bigInts[i].mod(gcd).equals(BigInteger.ZERO))
							finished = false;
					}

					if(finished)
						break;
				}
			}

			String outLine = "Case #" + (x + 1) + ": " + y;
			System.out.println(outLine);
			bw.write(outLine + "\n");
		}
		bw.close();
		br.close();
	}

	public static long nextPrime(long lastPrime, List<Long> primes) {

		return 0;
	}

}
