package com.company;

import java.util.Arrays;
import java.util.Scanner;
import java.util.stream.Collectors;

public class Question2 {
    public static void main(final String[] args) {
        final Scanner s = new Scanner(System.in);
        final int T = Integer.parseInt(s.nextLine());
        for (int i = 1; i <= T; i++) {
            final int N = Integer.parseInt(s.nextLine());
            String[] in = new String[2*N -1];
            for (int j = 0; j < 2*N -1; j++ ){
                in[j] = s.nextLine();
            }
            Arrays.sort(in);

            int[][] input = new int[2*N -1][];
            for (int j = 0; j < 2*N -1; j++ ){
                input[j] = new int[N];
                String[] split = in[j].split(" ");
                for (int k = 0; k < N; k++) {
                    input[j][k] = Integer.parseInt(split[k]);
                }
            }
            System.out.format("Case #%d: %s\n", i, solve(input, N));


        }
    }

    public static String solve(final int[][] in, int size) {

        int index = getIndexOfFailure(in, size);

        final int[][] map = new int[size][];

        for (int i = 0, j = 0; i < size; i++) {
            map[i] = new int[size];
        }

        for (int i = 0, marker = 0; i < size; i++) {
            int[] line0, line1;
            line0 = in[marker++];
            if (marker == 0) {
                map[i] = line0;

                if (i != index) {
                    line1 = in[marker++];
                    for (int j = 0; j < size; j++) {
                        map[j][i] = line1[j];
                    }
                }
                continue;
            }

            if (i == index) {
                boolean match = true;
                for (int j = 0; j < i; j++) {
                    match &= map[i][j] == line0[j];
                }
                if (match) {
                    map[i] = line0;
                }
                else {
                    for (int j = 0; j < size; j++) {
                        map[j][i] = line0[j];
                    }
                }
                continue;
            }

            line1 = in[marker++];

            boolean match = true;
            for (int j = 0; j < i; j++) {
                match &= map[i][j] == line0[j];
            }
            if (match) {
                map[i] = line0;
            }

            if (!match) {
                int[] temp = line0;
                line0 = line1;
                line1 = temp;
            }
            map[i] = line0;
            for (int j = 0; j < size; j++) {
                map[j][i] = line1[j];
            }
        }

        for (int i = 0; i < size; i++) {
            if (map[index][i] != in[index * 2][i]) {
                return Arrays.stream(map[index]).mapToObj(String::valueOf).collect(Collectors.joining(" "));
            }
        }

        int[] ans = new int[size];
        for (int i = 0; i < size; i++) {
            ans[i] = map[i][index];
        }
        return Arrays.stream(ans).mapToObj(String::valueOf).collect(Collectors.joining(" "));
    }

    public static int getIndexOfFailure(final int[][] input, int size) {
        for (int i = 0; i < size - 1; i++) {
            if (input[i * 2][i] != input[i * 2 + 1][i]) {
                return i;
            }
        }
        return size - 1;
    }
}
