package magicka;

import java.util.ArrayList;
import java.util.HashMap;


/**
 *
 * @author Christian
 */
public class TestCase
{
    public static final int[] charValues=new int[]{0,1,2,4,8,16,32,64,128,256,512,
                                                   1024,2048,4096,8192,16384,32768,65536,131072,262144,524288,
                                                   1048576,2097152,4194304,8388608,16777216};
    private char[] opposedElements;
    private char[] invokedElements;
    private int[] elementCameUp;
    private HashMap<Integer,Character> nonBaseElements;
    public TestCase()
    {
        opposedElements=new char[]{'-','-','-','-','-','-','-','-','-','-',
                                   '-','-','-','-','-','-','-','-','-','-',
                                   '-','-','-','-'};
        nonBaseElements=new HashMap<Integer,Character>();
        elementCameUp=new int[26];
    }
    
    public String getElementList()
    {
        ArrayList<Character> elementList=new ArrayList<Character>();
        if(invokedElements.length>0)
        {
            elementList.add(invokedElements[0]);
            elementCameUp[invokedElements[0]-'A']++;
        }
        for(int i=1;i<invokedElements.length;i++)
        {
            char act=invokedElements[i];
            Character nonBaseElement=null;
            if(!elementList.isEmpty())
            {
                nonBaseElement=nonBaseElements.get(getKey(elementList.get(elementList.size()-1), act));
            }
            if(nonBaseElement!=null)
            {
                char a=elementList.get(elementList.size()-1);
                elementList.remove(elementList.size()-1);
                elementList.add(nonBaseElement);
                elementCameUp[nonBaseElement.charValue()-'A']++;
                elementCameUp[a-'A']--;
                checkLastTwoElements(elementList);
            }
            else if((opposedElements[act-'A']!='-')&&(elementCameUp[opposedElements[act-'A']-'A']>0))
            {
                elementList.clear();
                resetElementsCameUp();
            }
            else
            {
                elementList.add(act);
                elementCameUp[act-'A']++;
            }
        }
        return elementListToString(elementList);
    }
    private String elementListToString(ArrayList<Character> elementList)
    {
        StringBuilder builder=new StringBuilder();
        builder.append("[");
        for(int i=0;i<elementList.size()-1;i++)
        {
            builder.append(elementList.get(i));
            builder.append(", ");
        }
        if(!elementList.isEmpty()){
        builder.append(elementList.get(elementList.size()-1));}
        builder.append("]");
        return builder.toString();
    }
    public void addNonBaseElement(String nonBaseElement) 
    {
        char[] chars=nonBaseElement.toCharArray();
        nonBaseElements.put(getKey(chars[0],chars[1]), chars[2]);
    }
    private int getKey(char a,char b)
    {
        return charValues[a-'A']+charValues[b-'A'];
    }
        
    public void addOpposedElement(String elements) 
    {
        char[] chars=elements.toCharArray();
        opposedElements[chars[0]-'A']=chars[1];
        opposedElements[chars[1]-'A']=chars[0];
    }

    public void setInvokedElements(String invokedElements) 
    {
        this.invokedElements=invokedElements.toCharArray();
    }

    private void resetElementsCameUp() {
        elementCameUp=new int[26];
    }

    private void checkLastTwoElements(ArrayList<Character> elementList) 
    {
        Character nonBaseElement=null;
        if(elementList.size()>1)
        {
            nonBaseElement=nonBaseElements.get(getKey(elementList.get(elementList.size()-1),elementList.get(elementList.size()-2) ));
        }
        if(nonBaseElement!=null)
        {
            char a=elementList.get(elementList.size()-1);
            char b=elementList.get(elementList.size()-2);
            elementList.remove(elementList.size()-1);
            elementList.remove(elementList.size()-1);
            elementList.add(nonBaseElement);
            elementCameUp[nonBaseElement.charValue()-'A']++;
            elementCameUp[a-'A']--;
            elementCameUp[b-'A']--;
            checkLastTwoElements(elementList);
        }
    }

    
}
