package candysplitting;

import java.io.BufferedWriter;
import java.io.FileWriter;
import java.io.IOException;

/**
 *
 * @author Christian
 */
public class CaseWriter
{
    private static final String CASE_PREFIX = "Case #";
    private static final String NEWLINE = "\n";
    private static final String SEPARATOR = ": ";
    private String[] cases;

    public CaseWriter(int maxCases)
    {
        cases=new String[maxCases+1];
    }
    public void addCase(int number,String solution)
    {
        if(number<cases.length)
        {
            cases[number]=solution;
        }
    }
    public void writeOutputToFile(String filename) throws IOException
    {
        BufferedWriter output=new BufferedWriter(new FileWriter(filename));
        for(int i=1;i<cases.length;i++)
        {
            output.write(CASE_PREFIX+i+SEPARATOR+cases[i]+NEWLINE);
        }
        output.close();
    }
}
