package ropeintranet;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 *
 * @author Christian
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException, IOException
    {
        TestCase[] cases=TestCaseReader.readTestCases("C:\\A-large.in");
        CaseWriter output=new CaseWriter(cases.length);
        for(int i=0;i<cases.length;i++)
        {
            int numberOfIntersections=calcNumberOfIntersections(cases[i]);
            output.addCase(i+1, ""+numberOfIntersections);
        }
        output.writeOutputToFile("C:\\Output.txt");
    }
    private static int calcNumberOfIntersections(TestCase actCase)
    {
        int count=0;

        for(Rope act:actCase.getRopes())
        {
            for(Rope other:actCase.getRopesAfter(act))
            {
                if(act!=other)
                {
                    if((act.getA()-other.getA())*(act.getB()-other.getB())<0)
                    {
                        count++;
                    }
                }
            }

        }
        return count;
    }
}
