package filefixit;

import java.util.ArrayList;

/**
 *
 * @author Christian
 */
public class DirectoryTree
{
    private DirectoryTreeNode root;

    public DirectoryTree()
    {
        root=new DirectoryTreeNode();
        root.setName("/");
    }

    /*Adds the path in the tree and returns the number of mkdir's used to do so*/
    public int addPath(String path)
    {
        String[] directories=path.split("/");
        int numberOfMkdirs=0;
        DirectoryTreeNode act=root;
        DirectoryTreeNode nextNode=null;
        for(int i=1;i<directories.length;i++)
        {
            nextNode=getNodeByName(directories[i], act.getChildren());
            if(nextNode==null)
            {
                nextNode=new DirectoryTreeNode();
                nextNode.setName(directories[i]);
                act.getChildren().add(nextNode);
                numberOfMkdirs++;
            }
            act=nextNode;
        }
        return numberOfMkdirs;
    }

    private DirectoryTreeNode getNodeByName(String name,ArrayList<DirectoryTreeNode> nodes)
    {
        for(DirectoryTreeNode node:nodes)
        {
            if(node.getName().equals(name))
            {
                return node;
            }
        }
        return null;
    }
}
