package makingchessboards;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;

/**
 *
 * @author Christian
 */
public class TestCaseReader
{
    public static TestCase[] readTestCases(String filename) throws FileNotFoundException, IOException
    {
        TestCase[] returnValue=null;
        BufferedReader input=new BufferedReader(new FileReader(filename));
        int numberOfCases=Integer.parseInt(input.readLine());
        returnValue=new TestCase[numberOfCases];
        for(int i=0;i<returnValue.length;i++)
        {
            String[] line1=input.readLine().split("\\s+");
            int M,N;
            M=Integer.parseInt(line1[0]);
            N=Integer.parseInt(line1[1]);
            TestCase act=new TestCase(M,N);
            for(int j=0;j<M;j++)
            {
                String actRow=input.readLine();

                act.getBoard()[j]=processHexRow(actRow);
            }
           
            returnValue[i]=act;
        }
        input.close();
        return returnValue;
    }

    private static int[] processHexRow(String actRow)
    {
        int[] returnValue=new int[actRow.length()*4];
        for(int i=0;i<actRow.length();i++)
        {
            char actChar=actRow.charAt(i);
            int currentNumber=0;
            if((actChar>='0')&&(actChar<='9'))
            {
                currentNumber=actChar-'0';
            }
            else
            {
                currentNumber=10+actChar-'A';
            }
            for(int j=0;j<4;j++)
            {
                returnValue[(i*4)+(3-j)]=currentNumber%2;
                currentNumber/=2;
            }
        }
        return returnValue;
    }

}
