package themepark;

import java.util.LinkedList;

/**
 *
 * @author Christian
 */
public class RollerCoaster
{
    private long R;
    private long k;
    private LinkedList<Long> queue;
    private long Euro;

    public RollerCoaster(TestCase testCase)
    {
        Euro=0;
        R=testCase.getR();
        k=testCase.getK();
        createQueue(testCase.getG());

    }
    public void runRollerCoaster()
    {
        LinkedList<Long> temp;
        for(long i=0;i<R;i++)//runs
        {
            long places=k;
            long first=queue.getFirst();
            temp=(LinkedList<Long>) queue.clone();
            while((places>=first)&&(!temp.isEmpty()))
            {
                places-=first;
                queue.remove();
                temp.remove();
                queue.add(first);
                Euro+=first;
                first=queue.getFirst();

            }
        }
    }

    private void createQueue(long[] g)
    {
        queue=new LinkedList<Long>();
        for(int i=0;i<g.length;i++)
        {
            queue.add(g[i]);
        }
    }

    /**
     * @return the Euro
     */
    public long getEuro() {
        return Euro;
    }

    /**
     * @param Euro the Euro to set
     */
    public void setEuro(long Euro) {
        this.Euro = Euro;
    }

}
