package bottrust;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 *
 * @author Christian
 */
public class BotTrust {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException, IOException 
    {
        TestCase[] cases=TestCaseReader.readTestCases("C:\\codejam\\A-small-attempt0.in");
        CaseWriter output=new CaseWriter(cases.length);
        for(int i=0;i<cases.length;i++)
        {
            output.addCase(i+1, solveCase(cases[i]));
        }
        output.writeOutputToFile("C:\\codejam\\output.txt");
    }

    private static String solveCase(TestCase testCase) 
    {
        int seconds=0;
        int bluePosition=1;
        int orangePosition=1;
        int blueTurnNumber=0;
        int orangeTurnNumber=0;
        testCase.getBlueButtons().add(0);
        testCase.getOrangeButtons().add(0);
        for(Boolean turn:testCase.getBluesTurn())
        {
            int blueButton=testCase.getBlueButtons().get(blueTurnNumber);
            int orangeButton=testCase.getOrangeButtons().get(orangeTurnNumber);
            if(turn)
            {
                blueTurnNumber++;
                int numberOfMoves=Math.abs(bluePosition-blueButton);
                seconds+=numberOfMoves;//move to the position
                seconds++;//push the button
                bluePosition=blueButton;
                if(orangeButton<orangePosition)
                {
                    orangePosition-=(Math.min(orangePosition-orangeButton,numberOfMoves+1 ));
                }
                else
                {
                    orangePosition+=(Math.min(orangeButton-orangePosition,numberOfMoves+1 ));
                }
            }
            else
            {
                orangeTurnNumber++;
                int numberOfMoves=Math.abs(orangePosition-orangeButton);
                seconds+=numberOfMoves;//move to the position
                seconds++;//push the button
                orangePosition=orangeButton;
                if(blueButton<bluePosition)
                {
                    bluePosition-=(Math.min(bluePosition-blueButton,numberOfMoves+1 ));
                }
                else
                {
                    bluePosition+=(Math.min(blueButton-bluePosition,numberOfMoves+1 ));
                }
            }
        }
        return Integer.toString(seconds);
    }
}
