
package makingchessboards;

import java.io.FileNotFoundException;
import java.io.IOException;

/**
 *
 * @author Christian
 */
public class Main {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException, IOException
    {
        TestCase[] cases=TestCaseReader.readTestCases("C:\\C-small-attempt0.in");
        CaseWriter output=new CaseWriter(cases.length);
        for(int i=0;i<cases.length;i++)
        {
            output.addCase(i+1, solveCase(cases[i]));
        }
        output.writeOutputToFile("C:\\Output.txt");
    }
    public static String solveCase(TestCase actCase)
    {
        String solution="";
        int M=actCase.getBoard().length;
        int N=actCase.getBoard()[0].length;
        int maxSize=Math.min(M, N);
        int numberOfSizes=0;
        for(;maxSize>0;maxSize--)
        {
            int foundBoards=findBoardsOfSize(maxSize,actCase.getBoard());
            if(foundBoards!=0)
            {
                solution+="\n"+maxSize+" "+foundBoards+"";
                numberOfSizes++;
            }
            
        }
        return numberOfSizes+solution;
    }

    private static int findBoardsOfSize(int maxSize, int[][] board)
    {
        int foundBoards=0;
        for(int i=0;i+maxSize<=board.length;i++)
        {
            for(int j=0;j+maxSize<=board[0].length;j++)
            {
                if(checkBoard(i,j,maxSize,board))
                {
                    foundBoards++;
                    removeBoard(i,j,maxSize,board);
                }
            }
        }
        return foundBoards;
    }
    private static boolean checkBoard(int x, int y, int size,int[][] board)
    {
        if(size==1)return board[x][y]!=2;
        for(int i=x;i<x+size;i++)
        {
            for(int j=y;j<y+size;j++)
            {
                if(board[i][j]==2)return false;
                if((i+1)<Math.min(board.length,x+size))
                {
                    if(board[i][j]==board[i+1][j])return false;
                }
                if((j+1)<Math.min(board[i].length,y+size))
                {
                    if(board[i][j]==board[i][j+1])return false;
                }
            }
        }

        return true;
    }

    private static void removeBoard(int x, int y, int maxSize, int[][] board)
    {
        for(int i=x;i<x+maxSize;i++)
        {
            for(int j=y;j<y+maxSize;j++)
            {
                board[i][j]=2;
            }
        }
    }
}
