import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.util.Scanner;

public class counting_sheep {
	public static void main(String[] args) {
		BufferedReader br = null;
		try {
			br = new BufferedReader(new FileReader("./src/A-small-attempt1.in"));
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		counting_sheep(br);
		try {
			br.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static void counting_sheep(BufferedReader br) {
		StringBuilder output = new StringBuilder();
		Scanner sc = new Scanner(br);
		int newinput = 0;
		int input = 0;
		int i = 1;
		boolean done = false;
		boolean[] digits = reset();
		int round = 1;
		sc.nextInt();
		while (sc.hasNextInt()) {
			input = sc.nextInt();
			newinput = input;
			output.append("Case #" + round + ": ");
			while (!done) {
				update_array(newinput, digits);
				done = update_done(digits);
				i += 1;
				newinput = input * i;
				if (newinput == input) {
					done = false;
					break;
				}
			}

			if (!done) {
				output.append("INSOMNIA\n");
			} else {
				output.append((i - 1) * input + "\n");
			}

			round += 1;
			done = false;
			digits = reset();
			i = 1;
		}
		System.out.print(output.toString());
		sc.close();
	}

	private static boolean[] update_array(int input, boolean[] digits) {
		int placeholder = 0;
		int next_round = input;
		while (next_round > 0) {
			placeholder = next_round % 10;
			digits[placeholder] = true;
			next_round = next_round / 10;
		}
		return digits;
	}

	private static boolean update_done(boolean[] digits) {
		for (boolean a : digits) {
			if (!a) {
				return false;
			}
		}
		return true;
	}

	private static boolean[] reset() {
		boolean[] digits = new boolean[10];
		for (boolean a : digits) {
			a = false;
		}
		return digits;
	}
}
