import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Built using CHelper plug-in Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "B-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("b.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskB solver = new TaskB();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskB {
        public void solve(int testNumber, Scanner in, PrintWriter out) {
            String C = in.next();
            String J = in.next();
            String C2 = "";
            String J2 = "";
            for (int i = 0; i < C.length(); i++) {
                char ci = C.charAt(i);
                char ji = J.charAt(i);
                int c2 = Integer.parseInt("0" + C2);
                int j2 = Integer.parseInt("0" + J2);
                char cin = '0';
                char jin = '0';
                char cin2 = '0';
                char jin2 = '0';
                if (i < C.length() - 1) {
                    cin = C.charAt(i + 1);
                    jin = J.charAt(i + 1);
                    if (i < C.length() - 2) {
                        cin2 = C.charAt(i + 2);
                        jin2 = J.charAt(i + 2);
                    }
                }

                if (ci != '?' && ji != '?') {
                    C2 += ci;
                    J2 += ji;
                    continue;
                }
                if (ci != '?') {
                    C2 += ci;
                    if (c2 == j2) {
                        if (jin == '?' || cin == '?') {
                            J2 += ci;
                            continue;
                        } else {
                            int cini = Integer.parseInt("" + cin);
                            int jini = Integer.parseInt("" + jin);
                            int diff = cini - jini;
                            if (diff > 5 && ci != '9') {
                                J2 += (Integer.parseInt(String.valueOf(ci)) + 1);
                                continue;
                            }
                            if (diff <= -5 && ci != '0') {
                                J2 += (Integer.parseInt(String.valueOf(ci)) - 1);
                                continue;
                            }
                            J2 += ci;
                            continue;
                        }
                    }
                    if (j2 > c2) {
                        J2 += '0';
                        continue;
                    }
                    if (j2 < c2) {
                        J2 += '9';
                    }
                } else if (ji != '?') {
                    J2 += ji;
                    if (c2 == j2) {
                        if (jin == '?' || cin == '?') {
                            C2 += ji;
                            continue;
                        } else {
                            int cini = Integer.parseInt("" + cin);
                            int jini = Integer.parseInt("" + jin);
                            int diff = jini - cini;
                            if (diff > 5 && ji != '9') {
                                C2 += (Integer.parseInt(String.valueOf(ji)) + 1);
                                continue;
                            }
                            if (diff <= -5 && ji != '0') {
                                C2 += (Integer.parseInt(String.valueOf(ji)) - 1);
                                continue;
                            }
                            C2 += ji;
                            continue;
                        }
                    }
                    if (j2 > c2) {
                        C2 += '9';
                        continue;
                    }
                    if (j2 < c2) {
                        C2 += '0';
                    }
                } else {
                    if (c2 == j2) {
                        if (jin == '?' || cin == '?') {
                            if ((jin == '?' && cin == '?') || (jin2 == '?' || cin2 == '?') || (jin2 != '9' && cin2 != '9')) {
                                J2 += '0';
                                C2 += '0';
                                continue;
                            } else {
                                int cin2i = Integer.parseInt("" + cin2);
                                int jin2i = Integer.parseInt("" + jin2);
                                int diff = cin2i - jin2i;
                                if (diff > 5) {
                                    C2 += '0';
                                    J2 += '1';
                                    continue;
                                }
                                if (diff <= -5) {
                                    C2 += '1';
                                    J2 += '0';
                                    continue;
                                }
                                J2 += '0';
                                C2 += '0';
                                continue;
                            }

                        } else {
                            int cini = Integer.parseInt("" + cin);
                            int jini = Integer.parseInt("" + jin);
                            int diff = cini - jini;
                            if (diff > 5) {
                                C2 += '0';
                                J2 += '1';
                                continue;
                            }
                            if (diff < -5) {
                                C2 += '1';
                                J2 += '0';
                                continue;
                            }
                            J2 += '0';
                            C2 += '0';
                            continue;
                        }
                    }
                    if (c2 < j2) {
                        C2 += '9';
                        J2 += '0';
                    }
                    if (c2 > j2) {
                        C2 += '0';
                        J2 += '9';
                    }
                }
            }
            out.println("Case #" + testNumber + ": " + C2 + " " + J2);
        }

    }
}

