import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.List;
import java.util.Scanner;
import java.util.ArrayList;

/**
 * Built using CHelper plug-in Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        public void solve(int testNumber, Scanner in, PrintWriter out) {
            int parties = in.nextInt();
            String letters = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
            List<String> outputs = new ArrayList<>();
            int[] party_counts = new int[parties];
            for (int i = 0; i < parties; i++) {
                party_counts[i] = in.nextInt();
            }

            while (true) {
                int max_0 = -1;
                int max_1 = -1;
                int max_2 = -1;
                int sum = 0;
                for (int i = 0; i < parties; i++) {
                    int val = party_counts[i];
                    if (val == 0) {
                        continue;
                    }
                    if (max_0 == -1 || val > party_counts[max_0]) {
                        max_2 = max_1;
                        max_1 = max_0;
                        max_0 = i;
                    } else if (max_1 == -1 || val > party_counts[max_1]) {
                        max_2 = max_1;
                        max_1 = i;
                    } else if (max_2 == -1 || val > party_counts[max_2]) {
                        max_2 = i;
                    }
                    sum += val;
                }
                String o = String.valueOf(letters.charAt(max_0));
                party_counts[max_0] -= 1;
                if ((max_2 != -1 && party_counts[max_2] <= (sum - 2) / 2 && sum != 3) || (max_2 == -1 && sum > 1)) {
                    int val1 = party_counts[max_0];
                    int val2 = party_counts[max_1];
                    if (val1 < val2) {
                        o += String.valueOf(letters.charAt(max_1));
                        party_counts[max_1] -= 1;
                    } else {
                        o += String.valueOf(letters.charAt(max_0));
                        party_counts[max_0] -= 1;
                    }
                }
                outputs.add(o);
                if (sum - o.length() == 0) {
                    break;
                }
            }

            String output = "";
            for (String s : outputs) {
                output = output + " " + s;
            }
            out.println("Case #" + testNumber + ":" + output);
        }

    }
}

