import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.List;
import java.util.Scanner;
import java.util.HashMap;
import java.util.ArrayList;

/**
 * Built using CHelper plug-in Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "C-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("c.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskC solver = new TaskC();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskC {
        public void solve(int testNumber, Scanner in, PrintWriter out) {
            HashMap<PairTaken, Integer> pairsTaken = new HashMap<>();
            int j = in.nextInt();
            int p = in.nextInt();
            int s = in.nextInt();
            int k = in.nextInt();
            List<int[]> clothing = new ArrayList<>();
            List<int[]> lastVal = new ArrayList<>();
            for (int i1 = 1; i1 <= j; i1++) {
                for (int i2 = 1; i2 <= p; i2++) {
                    for (int i3 = 1; i3 <= s; i3++) {
                        PairTaken p1 = new PairTaken(-1, i2, i3);
                        PairTaken p2 = new PairTaken(i1, -1, i3);
                        PairTaken p3 = new PairTaken(i1, i2, -1);

                        if (pairsTaken.containsKey(p1) || pairsTaken.containsKey(p2) || pairsTaken.containsKey(p3)) {
                            int count1 = pairsTaken.getOrDefault(p1, 0);
                            int count2 = pairsTaken.getOrDefault(p2, 0);
                            int count3 = pairsTaken.getOrDefault(p3, 0);
                            if (count1 == k || count2 == k || count3 == k) {
                                continue;
                            }
                            pairsTaken.put(p1, count1 + 1);
                            pairsTaken.put(p2, count2 + 1);
                            pairsTaken.put(p3, count3 + 1);
                            lastVal.add(new int[]{i1, i2, i3});
                            continue;
                        }
                        pairsTaken.put(p1, 1);
                        pairsTaken.put(p2, 1);
                        pairsTaken.put(p3, 1);
                        clothing.add(new int[]{i1, i2, i3});
                    }
                }
            }
            out.println("Case #" + testNumber + ": " + (clothing.size() + lastVal.size()));
            for (int[] cl : clothing) {
                out.println(cl[0] + " " + cl[1] + " " + cl[2]);
            }
            for (int[] cl : lastVal) {
                out.println(cl[0] + " " + cl[1] + " " + cl[2]);
            }
        }

        class PairTaken {
            private int j;
            private int p;
            private int s;

            public PairTaken(int j, int p, int s) {
                this.j = j;
                this.p = p;
                this.s = s;
            }

            public boolean equals(Object other) {
                PairTaken obj = (PairTaken) other;
                if (j == -1 && obj.j == -1) {
                    return obj.p == p && obj.s == s;
                } else if (p == -1 && obj.p == -1) {
                    return obj.j == j && obj.s == s;
                } else if (s == -1 && obj.s == -1) {
                    return obj.j == j && obj.p == p;
                } else {
                    return false;
                }
            }

            public int hashCode() {
                return 4;
            }

        }

    }
}

