import java.io.OutputStream;
import java.io.FilenameFilter;
import java.util.Locale;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Scanner;

/**
 * Built using CHelper plug-in Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        Locale.setDefault(Locale.US);
        InputStream inputStream;
        try {
            final String regex = "A-(small|large).*[.]in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("a.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        Scanner in = new Scanner(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        TaskA solver = new TaskA();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class TaskA {
        String[] numbers = new String[]{"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
        String[] numToCheck = new String[]{"Z", "G", "X", "S", "V", "I", "U", "H", "W", "N"};
        int[] order = new int[]{0, 8, 6, 7, 5, 9, 4, 3, 2, 1};

        public void solve(int testNumber, Scanner in, PrintWriter out) {
            String jumble = in.next();
            String current = "";
            int[] nums = new int[]{0, 0, 0, 0, 0, 0, 0, 0, 0, 0};
            for (int i = 0; i < 10; i++) {
                int toDo = order[i];
                int num = countChar(jumble, numToCheck[i]) - countChar(current, numToCheck[i]);
                nums[toDo] = num;
                for (int j = 0; j < num; j++) {
                    current += numbers[toDo];
                }
            }
            String pno = "";
            for (int i = 0; i < 10; i++) {
                for (int j = 0; j < nums[i]; j++) {
                    pno += Integer.toString(i);
                }
            }
            out.println("Case #" + testNumber + ": " + pno);
        }

        public int countChar(String string, String chara) {
            int counter = 0;
            for (int i = 0; i < string.length(); i++) {
                if (string.charAt(i) == chara.toCharArray()[0]) {
                    counter++;
                }
            }
            return counter;
        }

    }
}

