import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;

public class Milkshakes {
	private static int n;

	private static int m;

	private static short[] sol;

	private static short[] minSol;

	private static long min;

	private static long cur;

	private static List<Customer> c;

	private static void solve(int idx) {
		if (idx >= c.size()) {
			if (cur < min) {
				min = cur;
				minSol = Arrays.copyOf(sol, sol.length);
			}
			return;
		}
		for (MShake ms : c.get(idx).likes) {
			if (sol[ms.f] == ms.m) {
				if (cur < min)
					solve(idx + 1);
			} else if (sol[ms.f] == -1) {
				cur += ms.m;
				sol[ms.f] = ms.m;
				if (cur < min)
					solve(idx + 1);
				sol[ms.f] = -1;
				cur -= ms.m;
			}
		}
	}

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("B-small2.in"));
		PrintWriter out = new PrintWriter("B-small2.out");

		int nC = Integer.parseInt(br.readLine());
		int test = 0;
		while (test < nC) {
			n = Integer.parseInt(br.readLine());
			m = Integer.parseInt(br.readLine());

			min = Integer.MAX_VALUE;
			cur = 0;
			sol = new short[n];
			minSol = null;

			c = new ArrayList<Customer>();

			for (int i = 0; i < m; i++) {
				Customer ci = new Customer();
				String data[] = br.readLine().split(" ");
				for (int j = 1; j < data.length; j += 2) {
					MShake ms = new MShake();
					ms.f = Integer.parseInt(data[j]) - 1;
					ms.m = Short.parseShort(data[j + 1]);
					ci.likes.add(ms);
				}
				c.add(ci);
			}

			for (int i = 0; i < n; i++) {
				sol[i] = -1;
			}

			Collections.sort(c);

			solve(0);

			String res = "IMPOSSIBLE";
			if (minSol != null) {
				if (minSol[0] == -1)
					minSol[0] = 0;
				res = "" + minSol[0];
				for (int i = 1; i < minSol.length; i++) {
					if (minSol[i] == -1)
						minSol[i] = 0;
					res += " " + minSol[i];
				}
			}

			out.println("Case #" + (test + 1) + ": " + res);
			test++;
		}

		out.flush();
		out.close();
		br.close();
	}

	private static class Customer implements Comparable<Customer> {
		List<MShake> likes = new LinkedList<MShake>();

		@Override
		public int compareTo(Customer o) {
			return likes.size() - o.likes.size();
		}

		@Override
		public boolean equals(Object obj) {
			Customer c1 = (Customer) obj;
			return likes.equals(c1.likes);
		}

		@Override
		public String toString() {
			return "Likes: " + likes.toString();
		}
	}

	private static class MShake implements Comparable<MShake> {
		int f;

		short m;

		@Override
		public int compareTo(MShake o) {
			if (f == o.f) {
				return m - o.m;
			}
			return f - o.f;
		}

		@Override
		public int hashCode() {
			return (f * m) % 37;
		}

		@Override
		public String toString() {
			return "F: " + f + ", " + m;
		}
	}
}
