import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class TrainTimetable {
	private static int tt;

	private static int na;

	private static int nb;

	private static List<Trip> trips;

	private static List<List<Trip>> trains;

	private static S1 findTrain(Trip t) {
		S1 s = new S1();
		s.train = -1;
		s.trip = -1;
		s.after = false;
		int min = Integer.MAX_VALUE;
		for (int k = 0; k < trains.size(); k++) {
			List<Trip> train = trains.get(k);
			for (int i = 0; i < train.size(); i++) {
				Trip trip = train.get(i);
				if (trip.a != t.a) {
					if (trip.arr + tt <= t.dep) {
						int dif = t.dep - (trip.arr + tt);
						if (dif < min) {
							if (dif < trip.chainAhead || i == train.size() - 1) {
								min = dif;
								s.train = k;
								s.trip = i;
								s.after = true;
							}
						}
					}
					if (t.arr + tt <= trip.dep) {
						int dif = trip.dep - (t.arr + tt);
						if (dif < min) {
							if (dif < trip.chainBefore || i == 0) {
								min = dif;
								s.train = k;
								s.trip = i;
								s.after = false;
							}
						}
					}
				}
			}
		}
		return s;
	}

	private static int solve() {
		trains = new ArrayList<List<Trip>>();
		for (Trip trip : trips) {
			S1 best = findTrain(trip);
			if (best.train == -1) {
				List<Trip> t1 = new ArrayList<Trip>();
				trains.add(t1);
				t1.add(trip);
			} else {
				List<Trip> tempTrain = new ArrayList<Trip>();

				List<Trip> train = trains.get(best.train);
				Trip t1 = train.get(best.trip);
				for (Trip t : train) {
					if ((t.arr + tt > trip.dep && t.arr + tt < trip.arr)
							|| (t.dep < trip.arr + tt && t.dep > trip.dep)) {
						tempTrain.add(t);
					}
				}

				if (!tempTrain.isEmpty()) {
					trains.add(tempTrain);
					train.removeAll(tempTrain);
				}
				int idx = train.indexOf(t1);
				if (best.after) {
					train.add(idx + 1, trip);
				} else {
					train.add(idx, trip);
				}
			}
		}
		return trains.size();
	}

	private static int solveCase(BufferedReader br) throws Exception {
		tt = Integer.parseInt(br.readLine());
		String d[] = br.readLine().split(" ");
		na = Integer.parseInt(d[0]);
		nb = Integer.parseInt(d[1]);
		trips = new ArrayList<Trip>();
		for (int i = 0; i < na; i++) {
			Trip tr = new Trip();
			String t[] = br.readLine().split(" ");

			d = t[0].split("[:]");
			int time = Integer.parseInt(d[0]) * 60;
			time += Integer.parseInt(d[1]);
			tr.dep = time;

			d = t[1].split("[:]");
			time = Integer.parseInt(d[0]) * 60;
			time += Integer.parseInt(d[1]);
			tr.arr = time;

			tr.a = true;

			trips.add(tr);
		}
		for (int i = 0; i < nb; i++) {
			Trip tr = new Trip();
			String t[] = br.readLine().split(" ");

			d = t[0].split("[:]");
			int time = Integer.parseInt(d[0]) * 60;
			time += Integer.parseInt(d[1]);
			tr.dep = time;

			d = t[1].split("[:]");
			time = Integer.parseInt(d[0]) * 60;
			time += Integer.parseInt(d[1]);
			tr.arr = time;

			tr.a = false;

			trips.add(tr);
		}
		Collections.sort(trips);
		return solve();
	}

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("B-large.in"));
		PrintWriter out = new PrintWriter("B-large.out");

		int nCases = Integer.parseInt(br.readLine());

		for (int i = 0; i < nCases; i++) {
			solveCase(br);

			int aa = 0;
			int bb = 0;
			for (List<Trip> t : trains) {
				if (!t.isEmpty()) {
					if (t.get(0).a) {
						aa++;
					} else {
						bb++;
					}
				}
			}

			out.println("Case #" + (i + 1) + ": " + aa + " " + bb);
			out.flush();
		}
		out.close();
		br.close();
	}

	private static class Trip implements Comparable<Trip> {
		int arr;

		int dep;

		int chainAhead;

		int chainBefore;

		boolean a;

		public Trip() {
			chainAhead = -1;
			chainBefore = -1;
		}

		@Override
		public String toString() {
			return "A: " + a + ", From: " + dep + ", To: " + arr;
		}

		@Override
		public int compareTo(Trip t) {
			if (t.dep == dep) {
				return arr - t.arr;
			}
			return dep - t.dep;
		}
	}

	private static class S1 {
		int train;

		int trip;

		boolean after;
	}
}
