import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.LinkedList;

public class PermRLE {
	private static LinkedList<Integer> p;

	private static String s;

	private static char[] perm;

	private static int k;

	private static int min;

	private static void permutation() {
		for (int i = 0; i < s.length(); i += k) {
			for (int j = 0; j < k; j++) {
				perm[i + j] = s.charAt(i + p.get(j) - 1);
			}
		}
		int gr = 1;
		char last = perm[0];
		for (int i = 1; i < s.length(); i++) {
			if (perm[i] != last) {
				gr++;
				last = perm[i];
			}
		}
		if (gr < min)
			min = gr;
	}

	private static void solve(int idx) {
		if (idx >= k) {
			permutation();
			return;
		}
		for (int i = 1; i <= k; i++) {
			if (!p.contains(i)) {
				p.add(idx, i);
				solve(idx + 1);
				p.remove((int) idx);
			}
		}
	}

	public static void main(String[] args) throws Exception {
		BufferedReader br = new BufferedReader(new FileReader("D-small0.in"));
		PrintWriter out = new PrintWriter("D-small0.out");

		int nC = Integer.parseInt(br.readLine());
		int test = 0;
		while (test < nC) {
			k = Integer.parseInt(br.readLine());
			s = br.readLine();
			perm = new char[s.length()];
			p = new LinkedList<Integer>();

			min = Integer.MAX_VALUE;
			solve(0);
			out.println("Case #" + (test + 1) + ": " + min);

			test++;
		}

		out.flush();
		out.close();
		br.close();
	}
}
