/*
 *   Copyright 2010 Camilo Gonzalez 
 *
 *   This file is part of Up4people.
 *
 *   Up4people is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   any later version.
 *
 *   Up4people is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with Up4people.  If not, see <http://www.gnu.org/licenses/>.
 */
package q1;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.PrintWriter;

/**
 * @author Camilo Gonzalez
 */
public class RollerCoaster {

	public static void main(String[] args) throws Exception {
		int fileNumber = 3;
		FileReader inF = new FileReader("roller" + fileNumber + ".in");

		BufferedReader in = new BufferedReader(inF);
		PrintWriter out = new PrintWriter("roller" + fileNumber + ".out");

		int testCases = Integer.parseInt(in.readLine());

		for (int t = 1; t <= testCases; t++) {
			String data1[] = in.readLine().split("[ ]+");
			int r = Integer.parseInt(data1[0]);
			int k = Integer.parseInt(data1[1]);
			int n = Integer.parseInt(data1[2]);

			String data2[] = in.readLine().split("[ ]+");
			int groups[] = new int[n];
			for (int i = 0; i < n; i++) {
				groups[i] = Integer.parseInt(data2[i]);
			}
			data2 = null;

			// preprocess
			int m[][] = new int[n][2];
			for (int i = 0; i < n; i++) {
				int cnt = 0;
				int actPos = i;
				while (cnt + groups[actPos] <= k) {
					cnt += groups[actPos];
					actPos = actPos + 1;
					actPos = actPos % n;
					if (actPos == i) {
						break;
					}
				}
				m[i][0] = actPos;
				m[i][1] = cnt;
			}

			// process
			int actPos = 0;
			long sum = 0;
			for (int i = 0; i < r; i++) {
				sum = sum + m[actPos][1];
				actPos = m[actPos][0];
			}

			out.println(String.format("Case #%d: %d", t, sum));
			System.out.println(String.format("Case #%d: %d", t, sum));
		}
		out.flush();
		out.close();
	}
}
