import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.math.BigInteger;
import java.util.Arrays;

public class FairWarning {
	private static final String folder = "C:\\Users\\Scott\\Documents\\workspace\\codejam2010-fairwarning\\bin\\";
	private static final String inputFile = folder + "B-small-attempt1.in";
	private static final String outputFile = folder + "output.txt";

	public static void main(final String[] args) {
		try {
			final FileInputStream fis = new FileInputStream(inputFile);
			final BufferedReader br = new BufferedReader(new InputStreamReader(
					fis));

			final FileOutputStream fos = new FileOutputStream(outputFile);
			final BufferedWriter bw = new BufferedWriter(
					new OutputStreamWriter(fos));

			String line = br.readLine();

			int testCases = Integer.parseInt(line);

			for (int i = 1; i <= testCases; i++) {
				line = br.readLine();
				final String[] inputs = line.split(" ");

				int events = Integer.parseInt(inputs[0]);
				BigInteger[] times = new BigInteger[events];

				for (int j = 0; j < events; j++) {
					times[j] = new BigInteger(inputs[j + 1]);
				}

				// find minimum difference, as that's the largest possible integer factor
				Arrays.sort(times);
				
				/*BigInteger difference = new BigInteger("-1");
				
				for (int j = 1; j < events; j++) {
					final BigInteger newDiff = times[j].subtract(times[j - 1]);

					if (newDiff.signum() != 0 && 
							(newDiff.compareTo(difference) < 0 || difference.signum() == -1)) {
						difference = newDiff;
					}
				}*/
				
				BigInteger difference = times[1].subtract(times[0]);
				
				for (int j = 0; j < events - 1; j++) {
					for (int k = j + 1; k < events; k++) {
						difference = difference.gcd(times[k].subtract(times[j]));
					}
				}
				
				// check multiples of the difference
				boolean done = false;
				int multiples = 1;
				BigInteger checkTime = new BigInteger("-1");
				
				while (!done) {
					checkTime = difference.multiply(BigInteger.valueOf(multiples)).subtract(times[0]);
					
					if (checkTime.signum() >= 0) {
						boolean valid = true;
						for (int j = 1; j < events; j++) {
							if (times[j].add(checkTime).mod(difference).signum() != 0) {
								valid = false;
								break;
							}
						}
						
						if (valid) {
							done = true;
						}
					}
					
					multiples++;
				}

				System.out.println("Case #" + i + ": " + checkTime.toString());
				bw.write("Case #" + i + ": " + checkTime.toString());
				bw.newLine();
			}

			br.close();
			bw.close();
		} catch (final IOException e) {
			e.printStackTrace();
		}
	}
}
