package qualificationRound;

import java.util.ArrayList;

public class QuestionA {

	public static void main( String[] args ) {
		// First line is # of test cases
		int num_test_cases = Integer.parseInt( args[0] );
		ArrayList<char[][]> test_cases = new ArrayList<char[][]>();
		
		
		// Once for each test case;
		char[][] test_case;
		for( int a = 0; a < num_test_cases; a++ ) {
			 test_case = new char[4][4];
			 // Once for each line in test case a
			 for( int b = 0; b < 4; b++ ) {
				 for( int c = 0; c < 4; c++ ) {
					 test_case[b][c] = args[a * 4 + b + 1].charAt( c );
				 }
			 }
			 
			 test_cases.add( test_case );
		}
		
		int case_num = 1;
		for( char[][] current_test_case: test_cases ) {
			
			boolean player_x_win = false;
			boolean player_o_win = false;
			
			if( checkRows( current_test_case, 'X' ) || checkColumns( current_test_case, 'X' ) || checkDiagonals( current_test_case, 'X' ) )
				player_x_win = true;
			if( checkRows( current_test_case, 'O' ) || checkColumns( current_test_case, 'O' ) || checkDiagonals( current_test_case, 'O' ) )
				player_o_win = true;
			

			if( player_x_win && !player_o_win )
				System.out.println( "Case #" + case_num + ": X won" );
	   else if( player_o_win && !player_x_win )
				System.out.println( "Case #" + case_num + ": O won" );
	   else if( checkFinished( current_test_case ) )
				System.out.println( "Case #" + case_num + ": Draw" ); 
	   else
		   		System.out.println( "Case #" + case_num + ": Game has not completed" );
				case_num++;
		}
	}
	
	public static boolean checkRows( char[][] test_case, char player ) {
		for( int a = 0; a < 4; a++ ) { // For each row
			boolean row_win = true;
			for( int b = 0; b < 4; b++ ) {
				if( test_case[a][b] != player && test_case[a][b] != 'T' )
					row_win = false;
			}
			
			// If the row_win variable is still true, then the player in question has won
			if( row_win )
				return row_win;
		}
		
		// If we reach this point, then none of the rows yield a win for the given player
		return false;
	}
	
	public static boolean checkColumns( char[][] test_case, char player ) {
		for( int a = 0; a < 4; a++ ) { // For each row
			boolean column_win = true;
			for( int b = 1; b < 4; b++ ) {
				if( test_case[b][a] != player && test_case[a][b] != 'T' )
					column_win = false;
			}
			
			// If the row_win variable is still true, then the player in question has won
			if( column_win )
				return column_win;
		}
		
		// If we reach this point, then none of the columns yield a win for the given player
		return false;
	}
	
	public static boolean checkDiagonals( char[][] test_case, char player ) {
		boolean diagonal_win = true;
		for( int a = 0; a < 4; a++ ) {
			if( test_case[a][a] != player && test_case[a][a] != 'T' )
				diagonal_win = false;
		}
		
		if( diagonal_win )
			return diagonal_win;
		
		diagonal_win = true;
		for( int a = 0; a < 4; a++ ) {
			if( test_case[a][3 - a] != player && test_case[a][3 - a] != 'T' )
				diagonal_win = false;
		}
		
		if( diagonal_win )
			return diagonal_win;

		
		return false;
	}
	
	public static boolean checkFinished( char[][] test_case ) {
		for( int a = 0; a < 4; a++ ) {
			for( int b = 0; b < 4; b++ ) {
				if( test_case[a][b] == '.' )
					return false;
			}
		}
		
		return true;
	}
}
