import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

class Chest {
	int id;
	int keyNeeded;
	int keys[];
	
	@Override
	public String toString() {
		String s = keyNeeded + " | ";
		for(int k:keys) {
			s += k + ", ";
		}
		return "[ " + s + " ]";
	}
}

public class Treasure {
	
	static void processFile(String filename) {
		BufferedReader in = null;
		PrintWriter out = null;
		try {
			in = new BufferedReader(new FileReader(filename));
			out = new PrintWriter(filename + ".output");
			int testCases = Integer.parseInt(in.readLine());
			for(int i=0;i < testCases;i++) {
				String t[] = in.readLine().split(" ");
				int numKeys = Integer.parseInt(t[0]);
				int numChests = Integer.parseInt(t[1]);
				t = in.readLine().split(" ");
				List<Integer> keys = new ArrayList<>();
				for(int k=0;k<numKeys;k++) {
					keys.add(Integer.parseInt(t[k]));
				}
				LinkedHashMap<Integer, Chest> chests = new LinkedHashMap<>();
				for(int k=0;k<numChests;k++) {
					t = in.readLine().split(" ");
					Chest c = new Chest();
					c.id = k+1;
					c.keys = new int[Integer.parseInt(t[1])];
					for(int l=0;l<c.keys.length;l++){
						c.keys[l] = Integer.parseInt(t[2+l]);
					}
					c.keyNeeded = Integer.parseInt(t[0]);
					chests.put(k+1, c);
				}
//				printChests(chests);
				String res = "";
				if(!enoughKeys(keys, chests)) {
					res = "IMPOSSIBLE";
				}
				else {
					res  = openChests(keys, chests, "");
					res = res.equals("")?"IMPOSSIBLE":res;
				}
//				System.out.println(res + "\n");
				out.printf("Case #%d: "+res+"\n", i+1);
			}
			
			in.close();
			out.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static boolean enoughKeys(List<Integer> keys, LinkedHashMap<Integer, Chest> chests) {
		Set<Integer> DistKeys = new TreeSet<>();
		for(Chest c: chests.values()) {
			DistKeys.add(c.keyNeeded);
		}
		int min = DistKeys.iterator().next(), max=DistKeys.iterator().next();
		for(int k: DistKeys) {
			if(k<=min) min = k;
			if(k>=max) max = k;
		}
		int totalNeeded[] = new int[max], totalHave[] = new int[max];
		for(Chest c: chests.values()) {
			totalNeeded[c.keyNeeded-1]++;
			for(int k: c.keys) {
				if(k<=totalHave.length)
					totalHave[k-1]++;
			}
		}
		for(int k: keys) {
			if(k<=totalHave.length)
				totalHave[k-1]++;
		}
		for(int i=0;i<DistKeys.size();i++) {
//			System.out.printf("key %d = %d | %d\n",i+1,totalNeeded[i],totalHave[i]);
			if(totalNeeded[i]>totalHave[i]) return false;
		}
		return true;
	}
	
	public static String openChests(List<Integer> keys,LinkedHashMap<Integer, Chest> chests, String path) {
		if(chests.size()==0) return path;
		List<Integer> newKeys = new ArrayList<>();
		newKeys.addAll(keys);
//		LinkedHashMap<Integer, Chest> chests2 = (LinkedHashMap<Integer, Chest>) chests.clone();
//		if(chests2.size()==1) {
//			Chest c = chests2.values().iterator().next();
//			if(c.keyNeeded==newKeys.get(0)) {
//				return path + c.id;
//			}
//			else return "";
//		}
		Set<String> paths = new TreeSet<>();
		Iterator<Chest> it = chests.values().iterator();
		while(it.hasNext()) {
			Chest c = it.next();
			for(Integer k: newKeys) {
				List<Integer> temp = new ArrayList<>();
				temp.addAll(newKeys);
				temp.remove(k);
				
				if(c.keyNeeded==k && notNeeded(k,chests,c)) {
					for(int kl: c.keys) {
						temp.add(kl);
					}
					LinkedHashMap<Integer, Chest> t2 = (LinkedHashMap<Integer, Chest>) chests.clone();
					t2.remove(c.id);
					String p = openChests(temp, t2, path + c.id + " ");
					if(!p.equals("")) {
						paths.add(p);
						return p;
					}
					break;
				}
			}
		}
		
		if(paths.size()>0) {
			if(paths.size()==1) return paths.iterator().next();
//			long n[] = new long[paths.size()];
//			String set[] = new String[100];
//			set = paths.toArray(set);
			
			List<String> temp = new ArrayList<String>();
			temp.addAll(paths);
			List<String> temp2 = new ArrayList<String>();
			temp2.addAll(paths);
			int size = paths.iterator().next().length();
			for(int i=0;i<size;i+=2) {
				Iterator<String> t = temp.iterator();
				String s = t.next();
				while(t.hasNext()) {
					String f = t.next();
					if(s.toCharArray()[i]<f.toCharArray()[i]) {
						temp2.remove(f);
					}
					else if(s.toCharArray()[0]>f.toCharArray()[0]) {
						temp2.remove(s);
						s = f;
					}
				}
				temp.clear();
				temp.addAll(temp2);
			}
			
			return temp.get(0);
//			for(int i=0;i<n.length;i++) {
////				n[i] = Long.parseLong(set[i].replaceAll(" ", ""));
//			}
//			int min = 0;
//			for(int i=1;i<n.length;i++) {
//				if(n[i]<n[min]) min = i;
//			}
//			return set[min];
		}
		
		return "";
 	}
	
	public static boolean notNeeded(int key,LinkedHashMap<Integer, Chest> chests,Chest current) {
		if(current.keys.length>0) return true;
		for(Chest c: chests.values()) {
			if(!c.equals(current) && c.keyNeeded==key && c.keys.length>0) return false;
		}
		return true;
	}
	
	public static void printChests(LinkedHashMap<Integer, Chest> chests) {
		System.out.println("Chest\t|Key to open\t|Contains");
		System.out.println("........+...............+........");
		Iterator<Integer> iter = chests.keySet().iterator();
		int i = 1;
		while(iter.hasNext()) {
			int key = iter.next();
			System.out.printf("%d   \t| %d        \t| ",i,chests.get(key).keyNeeded);
			if(chests.get(key).keys.length==0) {
				System.out.print("None");
			}
			else {
				for(int c: chests.get(key).keys) {
					System.out.print(c + ", ");
				}
			}
			System.out.println();
			i++;
		}
		System.out.println();
	}
	
	public static void main(String[] args) {
//		processFile("testTreasure.in");
		processFile("D-small-attempt1.in");

	}

}
