import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;


public class Lawnmower {

	static void processFile(String filename) {
		BufferedReader in = null;
		PrintWriter out = null;
		try {
			in = new BufferedReader(new FileReader(filename));
			out = new PrintWriter(filename + ".output");
			int testCases = Integer.parseInt(in.readLine());
			for(int i=0;i < testCases;i++) {
				String dim[] = in.readLine().split(" ");
				int w = Integer.parseInt(dim[0]);
				int h = Integer.parseInt(dim[1]);
				int lawn[][] = new int[w][h];
				for(int k=0;k<w;k++) {
					String t[] = in.readLine().split(" ");
					for(int l=0;l<h;l++) {
						lawn[k][l] = Integer.parseInt(t[l]);
					}
				}
				
				String ans = performChecks(lawn,w,h);
				out.println("Case #"+(i+1)+": " + ans);
			}
			in.close();
			out.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (NumberFormatException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static String performChecks(int lawn[][],int w,int h) {
		for(int i=0;i<w;i++) {
			for(int j=0;j<h-1;j++) {
				if(lawn[i][j]!=lawn[i][j+1]) {
					boolean a = false, b = false;
					for(int k=0;k<w;k++) {
						if(lawn[k][j]!=lawn[i][j]) a = true;
						if(lawn[k][j+1]!=lawn[i][j+1]) b = true;
					}
					if(b && lawn[i][j]>lawn[i][j+1]) return "NO";
					if( a&&b ) return "NO";
				}
			}
		}
		
		for(int j=0;j<h;j++) {
			for(int i=0;i<w-1;i++) {
				if(lawn[i][j]!=lawn[i+1][j]) {
					boolean a = false, b = false;
					for(int k=0;k<h;k++) {
						if(lawn[i][k]!=lawn[i][j]) a = true;
						if(lawn[i+1][k]!=lawn[i+1][j]) b = true;
					}
					if(b && lawn[i][j]>lawn[i+1][j]) return "NO";
					if(a&&b) return "NO";
				}
			}
		}
		return "YES";
	}
	
	public static void main(String[] args) {
		processFile("B-small-attempt1.in");
	}

}
