package codejamquestion;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Scanner;

/**
 * @author Canberk
 */

public class CodeJamQuestion {

    public static void main(String[] args) {
        try {
            Scanner in = new Scanner(new File("C-small-attempt0.in"));
            PrintWriter out = new PrintWriter("out.out");

            int cases = Integer.parseInt(in.nextLine());
            
            for (int x = 1; x <= cases; x++) {
                String answer = "Case #" + x + ": ";
                HashMap<String, Integer> fws = new HashMap<String, Integer>();
                HashMap<String, Integer> sws = new HashMap<String, Integer>();
                int N = Integer.parseInt(in.nextLine());
                String[][] topics = new String[N][2];
                for(int i=0;i<N;i++){
                    topics[i] = in.nextLine().split(" ");
                    String[] input = topics[i];
                    if(fws.containsKey(input[0])){
                        fws.put(input[0],fws.get(input[0])+1);
                    } else {
                        fws.put(input[0],1);
                    }
                    if(sws.containsKey(input[1])){
                        sws.put(input[1],sws.get(input[1])+1);
                    } else {
                        sws.put(input[1],1);
                    }
                }
                
                ArrayList<String[]> pfake = new ArrayList<String[]>();
                ArrayList<String[]> preal = new ArrayList<String[]>();
                for(String[] topic : topics){
                    if(fws.get(topic[0])>1 && sws.get(topic[1])>1){
                        pfake.add(topic);
                    } else {
                        preal.add(topic);
                    }
                }
                
                answer += testAll(preal,pfake);
                
                out.println(answer);
            }
            in.close();
            out.close();
        } catch (FileNotFoundException ex) {
            System.out.println("ERROR");
        }

    }

    private static int testAll(ArrayList<String[]> preal, ArrayList<String[]> pfake) {
        for(int i = (int)Math.pow(2, pfake.size());i>0;i--){
            ArrayList<String[]> fake = new ArrayList<String[]>();
            ArrayList<String[]> real = new ArrayList<String[]>();
            real.addAll(preal);
            String bin = Integer.toBinaryString(i);
            while(bin.length() < pfake.size()) bin = "0" + bin;
            for(int j= 0;j< pfake.size();++j){
		if(bin.charAt(j) == '1')fake.add(pfake.get(j));
                else real.add(pfake.get(j));
            }
            if(test(real,fake)){
                return fake.size();
            }
        }
        return 0;
    }

    private static boolean test(ArrayList<String[]> real, ArrayList<String[]> fake) {
        
        HashMap<String, Integer> fws = new HashMap<String, Integer>();
        HashMap<String, Integer> sws = new HashMap<String, Integer>();
                
        for(String[] input : real) {
            if (fws.containsKey(input[0])) {
                fws.put(input[0], fws.get(input[0]) + 1);
            } else {
                fws.put(input[0], 1);
            }
            if (sws.containsKey(input[1])) {
                sws.put(input[1], sws.get(input[1]) + 1);
            } else {
                sws.put(input[1], 1);
            }
        }
        for(String[] input : fake) {
            if(!fws.containsKey(input[0]) || !sws.containsKey(input[1]))
                return false;
        }
        return true;
    }
    
}
