package com.canburaktumer;

import java.time.LocalDateTime;
import java.util.LinkedList;
import java.util.Scanner;

public class Main {
	static Scanner in;
	static DebugPrinter pt;
	static boolean DEBUG_FLAG = false;

	public static void main(String[] args) {
		pt = new DebugPrinter(DEBUG_FLAG);
		System.err.println(LocalDateTime.now());
		in = new Scanner(System.in);
		int caseCount = in.nextInt();
		// run for each case
		for(int i = 1 ; i <= caseCount; i++){
			doSomething(i);
		}
		System.err.println(LocalDateTime.now());
	}

	private static void doSomething(int caseNumber) {
		String result = "";
// Write problem solution between these comments
// ***************************
		int stallCount = in.nextInt();
		int personCount = in.nextInt();
		int finalStall = 0;
		if(stallCount == personCount){
			result = "0 0";
		} else {
			LinkedList<Integer> stalls = new LinkedList<Integer>();
			stalls.add(stallCount);
			for(int i = 0; i < personCount; i++){
				finalStall = stallSelect(stalls);
			}
			
			pt.print(finalStall+"");
			if(finalStall == 0){
				result = stalls.get(finalStall+1)+ " 0";
			}else if (finalStall == stalls.size()){
				result = stalls.get(finalStall-1)+ " 0";
			}else result = Math.max(stalls.get(finalStall-1), stalls.get(finalStall+1)) + " " + Math.min(stalls.get(finalStall-1), stalls.get(finalStall+1));
		}
		
// Write problem solution between these comments
// ***************************		
		System.out.println("Case #"+caseNumber+": "+result);
				
	}

	private static int stallSelect(LinkedList<Integer> stalls) {
		pt.print(" before selecting : "+stalls.toString());
		int index = findMax(stalls);
		int leftValue, rightValue, midValue = -99;
		if(stalls.get(index)%2==1){
			leftValue = stalls.get(index)/2;
			rightValue = stalls.get(index)/2;
		} else {
			leftValue = stalls.get(index)/2-1;
			rightValue = stalls.get(index)/2;
		}
		stalls.remove(index);
		stalls.add(index, leftValue);
		stalls.add(index+1, midValue);
		stalls.add(index+2, rightValue);
		pt.print("after selecting " +stalls.toString());
		return index+1;
	}

	private static int findMax(LinkedList<Integer> stalls) {
		int maxVal = stalls.get(0);
		int maxInd = 0;
		for(int i = 0; i < stalls.size(); i++ ){
			if(maxVal < stalls.get(i)){
				maxVal = stalls.get(i);
				maxInd = i;
			}
		}
		return maxInd;
	}

	

}

class DebugPrinter {
	public boolean DEBUG_MODE;
	
	public void print(String s){
		if(DEBUG_MODE)
			System.out.println(s);
	}
	
	DebugPrinter(boolean DM){
		this.DEBUG_MODE = DM;
	}

}