package com.canburaktumer;

import java.time.LocalDateTime;
import java.util.Scanner;

public class Main {
	static Scanner in;
	static DebugPrinter pt;
	static boolean DEBUG_FLAG = false;
	static int stallCnt, redCnt, orangeCnt, yellowCnt, greenCnt, blueCnt, violetCnt;

	public static void main(String[] args) {
		pt = new DebugPrinter(DEBUG_FLAG);
		System.err.println(LocalDateTime.now());
		in = new Scanner(System.in);
		int caseCount = in.nextInt();
		// run for each case
		for(int i = 1 ; i <= caseCount; i++){
			doSomething(i);
		}
		System.err.println(LocalDateTime.now());
	}

	private static void doSomething(int caseNumber) {
		String result = "";
// Write problem solution between these comments
// ***************************
		stallCnt = in.nextInt();
		redCnt = in.nextInt();
		orangeCnt = in.nextInt();
		yellowCnt = in.nextInt();
		greenCnt = in.nextInt();
		blueCnt = in.nextInt();
		violetCnt = in.nextInt();
		
		StringBuilder s = new StringBuilder();
		if(redCnt > 0){
			s.append('R');
			redCnt--;
		} else if (orangeCnt > 0){
			s.append('O');
			orangeCnt--;
		} else if (yellowCnt > 0){
			s.append('Y');
			yellowCnt--;
		} else if (greenCnt > 0){
			s.append('G');
			greenCnt--;
		} else if (blueCnt > 0){
			s.append('B');
			blueCnt--;
		} else if (violetCnt > 0){
			s.append('V');
			violetCnt--;
		}
		for(int i = 1; i < stallCnt; i++){
			try{
				s.append(findRelatedMax(s.charAt(i-1)));
				pt.print(s.toString());
			}catch(Exception e){
				result = "IMPOSSIBLE";
				System.out.println("Case #"+caseNumber+": "+result);
				return;
			}
		}		
		result = s.toString();
		result = check(result);
// Write problem solution between these comments
// ***************************		
		System.out.println("Case #"+caseNumber+": "+result);
				
	}

	private static String check(String result) {
		int last = result.length()-1;
		if(result.charAt(0) == 'R' && ( result.charAt(last) == 'O' || result.charAt(last) == 'R' || result.charAt(last) == 'V' )){
			return "IMPOSSIBLE";
		} else if(result.charAt(0) == 'O' && result.charAt(last) != 'B' ){
			return "IMPOSSIBLE";
		}  else if(result.charAt(0) == 'Y' && (result.charAt(last) == 'O' || result.charAt(last) == 'G' || result.charAt(last) == 'Y' )){
			return "IMPOSSIBLE";
		}  else if(result.charAt(0) == 'G' && result.charAt(last) != 'R' ){
			return "IMPOSSIBLE";
		}  else if(result.charAt(0) == 'B' && (result.charAt(last) == 'G' || result.charAt(last) == 'B' || result.charAt(last) == 'V' )){
			return "IMPOSSIBLE";
		}  else if(result.charAt(0) == 'V' && result.charAt(last) != 'Y' ){
			return "IMPOSSIBLE";
		}  
		return result;
	}

	private static Object findRelatedMax(char charAt) throws Exception {
		Exception e = new Exception();
		char result = ' ';
		switch(charAt){
			case 'R':
				if(greenCnt > 0){
					result = 'G';
					greenCnt--;
				} else {
					if (yellowCnt >= blueCnt){
						result = 'Y';
						yellowCnt --;
					} else {
						blueCnt--;
						result = 'B';
					}
				}
				break;
			case 'O':
				if(blueCnt > 0){
					result = 'B';
				} else throw e;
				break;
			case 'Y':
				if(violetCnt > 0){
					result = 'V';
					violetCnt--;
				} else {
					if (redCnt >= blueCnt){
						result = 'R';
						redCnt --;
					} else {
						blueCnt--;
						result = 'B';
					}
				}
				break;
			case 'G':
				if(redCnt > 0){
					result = 'R';
				} else throw e;
				break;
			case 'B':
				if(orangeCnt > 0){
					result = 'O';
					orangeCnt--;
				} else {
					if (redCnt >= yellowCnt){
						result = 'R';
						redCnt --;
					} else {
						yellowCnt--;
						result = 'Y';
					}
				}
				break;
			case 'V':
				if(yellowCnt > 0){
					result = 'Y';
				} else throw e;
				break;
		}
		pt.print("redCnt :" + redCnt);
		pt.print("orangeCnt :" + orangeCnt);
		pt.print("yellowCnt :" + yellowCnt);
		pt.print("greenCnt :" + greenCnt);
		pt.print("blueCnt :" + blueCnt);
		pt.print("violetCnt :" + violetCnt);
		if(redCnt < 0 || orangeCnt < 0 || yellowCnt < 0 || greenCnt < 0 || blueCnt < 0 || violetCnt < 0)
			throw e;
		return result;
	}


}

class DebugPrinter {
	public boolean DEBUG_MODE;
	
	public void print(String s){
		if(DEBUG_MODE)
			System.out.println(s);
	}
	
	DebugPrinter(boolean DM){
		this.DEBUG_MODE = DM;
	}

}