package com.canburaktumer;

import java.time.LocalDateTime;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.Scanner;

public class Main {
	static Scanner in;
	static Hashtable<String, Integer> treeIndex;
	static Node root;
	static int limit, sLen, k,caseCount;
	static String s;
	static boolean DEBUG_FLAG = false;

	public static void main(String[] args) {
		
		System.err.println(LocalDateTime.now());
		in = new Scanner(System.in);
		caseCount = in.nextInt();
		in.nextLine();
		// run for each case
		for(int i = 1 ; i <= caseCount; i++){
			doSomething(i);
		}
		System.err.println(LocalDateTime.now());
	}

	private static void doSomething(int caseNumber) {
		String result;
// Write problem solution between these comments
// ***************************
		// read input data
		treeIndex = new Hashtable<String, Integer>();
		s = in.next();
		k = in.nextInt();
		if(caseNumber < caseCount) in.nextLine();
		
		// calculate local variables
		sLen = s.length();
		limit = sLen - (k-1);
		
		String sFullPositive = createFullPositive(sLen);
		root = new Node(sFullPositive, 0);
		treeIndex.put(sFullPositive, 0);
		createChildren(root, root.data, root.level+1);
		walkOnTree(root);
		//traverse(root);
		
		if(treeIndex.get(s) == null){
				result = "IMPOSSIBLE";
		} else result = treeIndex.get(s).toString();
		//System.out.println("S : "+s+ " K : "+ k);
// Write problem solution between these comments
// ***************************		
		System.out.println("Case #"+caseNumber+": "+result);
				
	}
	
	private static void walkOnTree(Node root){
		// walking on the tree
		int index = 0;
		while(!root.children.isEmpty() && index < root.children.size()){
			Node current = root.children.get(index);
			createChildren(current, current.data, current.level+1);
			walkOnTree(current);
			index++;
		}
	}
	
	private static void createChildren(Node root2, String data, int i) {
		if(limit < i){
			return;
		} else {
			for(int off = 0; off < limit; off++){
				String s = flip(data, off);
				if(treeIndex.containsKey(s)){
					//continue;
					//System.out.println("Found : " + s);
					if(i < treeIndex.get(s)){
						treeIndex.remove(s);
						treeIndex.put(s, i);
						root2.children.add(new Node(s, i));
					}
				} else {
					//System.out.println("Not Found : " + s);
					treeIndex.put(s, i);
					root2.children.add(new Node(s, i));
				}
			}
		}
		
	}
	
	private static void traverse(Node root){
		int index = 0;
		while(!root.children.isEmpty() && index < root.children.size()){
			Node current = root.children.get(index);
			System.out.println(current.data);
			walkOnTree(current);
			index++;
		}
	}

	private static String flip(String data, int off) {
		StringBuilder newData = new StringBuilder(data);
		for(int i = 0; i < k; i++){
			if(data.charAt(off+i) == '+'){
				newData.setCharAt(off+i, '-');
			} else 
				newData.setCharAt(off+i, '+');
		}
		return newData.toString();
	}

	private static String createFullPositive(int sLen) {
		String s = "";
		for(int i = 0; i < sLen; i++)
				s += "+";
		return s;
	}

	static class Node{
		String data;
		int level;
		ArrayList<Node> children;
		
		Node(String d, int l){
			this.data = d;
			level = l;
			children = new ArrayList<Node>();
		}
		
	}

}