package com.canburaktumer;

import java.text.DecimalFormat;
import java.time.LocalDateTime;
import java.util.Scanner;

public class Main {
	static Scanner in;
	static DebugPrinter pt;
	static boolean DEBUG_FLAG = false;

	public static void main(String[] args) {
		pt = new DebugPrinter(DEBUG_FLAG);
		System.err.println(LocalDateTime.now());
		in = new Scanner(System.in);
		int caseCount = in.nextInt();
		// run for each case
		for(int i = 1 ; i <= caseCount; i++){
			doSomething(i);
		}
		System.err.println(LocalDateTime.now());
	}

	private static void doSomething(int caseNumber) {
		double result = 0;
		DecimalFormat df = new DecimalFormat("#.######");
// Write problem solution between these comments
// ***************************
		int destination = in.nextInt();
		int horseCount = in.nextInt();
		double maxTime = -1;
		for(int i = 0; i < horseCount; i++){
			int start = in.nextInt();
			int speed = in.nextInt();
			double time = (double) (destination-start) / (double) speed;
			if(time > maxTime){
				maxTime = time;
			}
			
			result = (double) destination / maxTime;  
		}
		
// Write problem solution between these comments
// ***************************		
		System.out.println("Case #"+caseNumber+": "+df.format(result).replaceAll(",", "."));
				
	}




}

class DebugPrinter {
	public boolean DEBUG_MODE;
	
	public void print(String s){
		if(DEBUG_MODE)
			System.out.println(s);
	}
	
	DebugPrinter(boolean DM){
		this.DEBUG_MODE = DM;
	}

}