import java.util.*;
import java.util.logging.*;
import java.io.*;

public class Solution1 {


    public static void main(String[] args) {
        // LOG.info("Starting main method.");

        String filename = args[0];
        // LOG.info("Filename: " + filename);

        Solution1 sol = new Solution1();
        sol.solve(filename);

        // LOG.info("Exiting main method.");
    }

    public void solve(String filename) {
        try {

            FileReader fr = new FileReader(filename);
            BufferedReader br = new BufferedReader(fr);

            String line = br.readLine();
            int len = Integer.parseInt(line);

            for (int i = 0; i < len; i++) {

                String RC = br.readLine();
                String[] RCS = RC.split(" ");

                int R = Integer.parseInt(RCS[0]);
                int C = Integer.parseInt(RCS[1]);

                char[][] map = new char[R][C];


                for (int j = 0; j < R; j++) {
                    String str = br.readLine();

                    char[] arr = str.toCharArray();
                    for (int k = 0; k < C; k++) {
                        map[j][k] = arr[k];
                    }
                }
                /* split a line to get input(s) */

                /* write the real method */

                System.out.println("Case #" + (i+1) + ":");

                solve(map, R, C);
            }

            fr.close();
            br.close();
        } catch(Throwable e) {

        }
    }

    private void solve(char[][] map, int R, int C) {
        int row = 0;
        while (isEmpty(map[row])) {
            row++;
        }

        char[] nonER = map[row];
        for (int i = 0; i < row; i++) {
            for (int j = 0; j < C; j++) {
                map[i][j] = nonER[j];
            }
        }


        for (int i = 0; i < R; i++) {

            char[] thisRow = map[i];
            if (isEmpty(thisRow)) {
                for (int j = 0; j < C; j++) {
                    map[i][j] = map[i-1][j];
                }
            }



            int col = 0;
            while (map[i][col] == '?') {
                col++;
            }

            for (int j = 0; j < col; j++) {
                map[i][j] = map[i][col];
            }

            col++;
            while (col < C) {
                if (map[i][col] == '?') {
                    map[i][col] = map[i][col-1];
                }
                col++;
            }

        }
        printMap(map, R, C);

    }

    private boolean isEmpty(char[] row) {
        boolean res = true;
        for (int i = 0; i < row.length; i++) {
                if (row[i] != '?') {
                    res = false;
                    break;
                }
        }

        return res;
    }

    private void printMap(char[][] map, int R, int C) {
        for (int i = 0; i < R; i++) {
            String str = new String(map[i]);
            System.out.println(str);
        }
    }
}
