import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;


public class Problem1
{
	public static void main( String[] args )
	{
		BufferedReader br = null;
		BufferedWriter bw = null;
		try
		{
			bw = new BufferedWriter(new FileWriter("C:\\Users\\Sydney.Pang\\Desktop\\problem1.out"));

			br = new BufferedReader(new FileReader("C:\\Users\\Sydney.Pang\\Desktop\\A-large.in"));

			String line = br.readLine();
			int numTestCases = Integer.parseInt(line.trim());

			System.err.println("numTestCases: " + numTestCases);

			for (int lineNum = 0; lineNum < numTestCases; lineNum++)
			{
				line = br.readLine();
				System.err.println(line);
				String[] splitResults = line.split(" ");
				int numTotalButtonPresses = Integer.parseInt(splitResults[0]);
				String botName = "";
				Vector orangeInstructions = new Vector();
				Vector blueInstructions = new Vector();
				Vector mastermindInstructions = new Vector();
				for (int i = 1; i < splitResults.length; i++)
				{
					int buttonNum;
					if (i % 2 == 1)
					{
						botName = splitResults[i];
					}
					else
					{
						buttonNum = Integer.parseInt(splitResults[i]);
						System.err.println(botName + buttonNum);
						if (botName.equals("O"))
						{
							orangeInstructions.add(new Integer(buttonNum));
							mastermindInstructions.add(new String("O"));
						}
						else
						{
							blueInstructions.add(new Integer(buttonNum));
							mastermindInstructions.add(new String("B"));
						}
					}
				}

				// Instructions should be acquired for orange, blue, and
				// mastermind //

				System.err.println(blueInstructions.size());
				System.err.println(orangeInstructions.size());
				System.err.println(mastermindInstructions.size());

				// mastermind instructions //
				String[] masterStringInstructions = new String[mastermindInstructions.size()];
				for (int i = 0; i < masterStringInstructions.length; i++)
				{
					masterStringInstructions[i] = (String)mastermindInstructions.elementAt(i);
				}
				// blue instructions //
				int[] blueIntInstructions = new int[blueInstructions.size()];
				for (int i = 0; i < blueIntInstructions.length; i++)
				{
					blueIntInstructions[i] = ((Integer)blueInstructions.elementAt(i)).intValue();
				}
				// orange instructions //
				int[] orangeIntInstructions = new int[orangeInstructions.size()];
				for (int i = 0; i < orangeIntInstructions.length; i++)
				{
					orangeIntInstructions[i] = ((Integer)orangeInstructions.elementAt(i)).intValue();
				}

				Problem1 p1 = new Problem1();
				Mastermind mastermind = p1.new Mastermind(masterStringInstructions);
				Bot blue = p1.new Bot("B", blueIntInstructions, mastermind);
				Bot orange = p1.new Bot("O", orangeIntInstructions, mastermind);
				mastermind.setBots(blue, orange);

				int seconds = 0;
				while (false == mastermind.isAllDone())
				{
					System.err.println("second: " + seconds);
					mastermind.step();
					seconds++;
				}

				System.err.println("Case#" + Integer.toString(lineNum + 1) + ": " + seconds);
				bw.write("Case #" + Integer.toString(lineNum + 1) + ": " + seconds);
				if (lineNum < numTestCases - 1)
				{
					bw.newLine();
				}
			}

		}
		catch (Exception e)
		{
			System.out.println("Error!");
			e.printStackTrace();
		}
		finally
		{
			if (br != null)
			{
				try
				{
					br.close();
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			}
			if (bw != null)
			{
				try
				{
					bw.close();
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			}
		}
	}
	class Mastermind
	{
		Bot			orange;
		Bot			blue;
		String[]	instructions;
		int			instructionsIndex;
		boolean		allDone;

		public Mastermind( String[] aInstructions )
		{
			orange = null;
			blue = null;
			instructions = aInstructions;
			instructionsIndex = 0;
			allDone = false;
		}

		public void setBots( Bot blueBot, Bot orangeBot )
		{
			blue = blueBot;
			orange = orangeBot;
		}

		public boolean isAllDone()
		{
			return allDone;
		}

		public void step()
		{
			String nextBotToDoSomething = instructions[instructionsIndex];
			if (nextBotToDoSomething.equals(orange.getName()))
			{
				orange.givePermissionToPress();
			}
			else
			{
				blue.givePermissionToPress();
			}

			orange.step();
			blue.step();
		}

		public void notifyThatObjectiveComplete( String botName )
		{
			instructionsIndex++;
			if (instructionsIndex == instructions.length)
			{
				allDone = true;
			}
			else
			{

			}
		}
	}

	class Bot
	{
		private int			location;
		private char		action;				// m, w, p
		private int			target;
		private boolean		hasPermissionToPress;
		private int[]		mission;
		private int			missionIndex;
		private String		name;
		private Mastermind	mastermind;

		public Bot( String aName, int[] aMission, Mastermind aMastermind )
		{
			location = 1;
			action = 'w';
			target = -1;
			hasPermissionToPress = false;
			mission = aMission;
			missionIndex = 0;
			name = aName;
			mastermind = aMastermind;
		}

		public String getName()
		{
			return name;
		}

		public void givePermissionToPress()
		{
			hasPermissionToPress = true;
		}

		public void step()
		{
			if (missionIndex < mission.length)
			{
				target = mission[missionIndex];
			}

			if (target == -1)
			{
				action = 'w';
				System.err.println(name + ": Stay at button " + location);
				return;
			}

			if (location == target)
			{
				if (hasPermissionToPress)
				{
					action = 'p';
					missionIndex++;
					hasPermissionToPress = false;
					mastermind.notifyThatObjectiveComplete(name);
					System.err.println(name + ": Push button " + location);
				}
				else
				{
					action = 'w';
					System.err.println(name + ": Stay at button " + location);
				}
			}
			else
			{
				if (location < target)
				{
					location++;
					action = 'm';
					System.err.println(name + ": Move to Button " + location);
				}
				else
				{
					location--;
					action = 'm';
					System.err.println(name + ": Move to Button " + location);
				}
			}
		}
	}
}
