import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Vector;


public class Problem2
{
	public static void main( String[] args )
	{
		BufferedReader br = null;
		BufferedWriter bw = null;
		try
		{
			bw = new BufferedWriter(new FileWriter("C:\\Users\\Sydney.Pang\\Desktop\\problem2.out"));

			br = new BufferedReader(new FileReader("C:\\Users\\Sydney.Pang\\Desktop\\B-large.in"));

			String line = br.readLine();
			int numTestCases = Integer.parseInt(line.trim());

			System.err.println("numTestCases: " + numTestCases);

			Problem2 p2 = new Problem2();
			for (int lineNum = 0; lineNum < numTestCases; lineNum++)
			{
				line = br.readLine();
				System.err.println("\n" + line);

				String[] splitResults = line.split(" ");

				// Learn all Combinations //
				int numCombinations = Integer.parseInt(splitResults[0]);
				Vector allCombinations = new Vector();
				int i;
				for (i = 1; i <= numCombinations; i++)
				{
					String combination = splitResults[i];
					System.err.println("<C> " + combination);

					Combination combo = p2.new Combination(combination);
					allCombinations.add(combo);
				}

				// Learn all Oppositions //
				int numOppositions = Integer.parseInt(splitResults[i++]);
				Vector allOppositions = new Vector();
				int j;
				for (j = i; j < i + numOppositions; j++)
				{
					String opposition = splitResults[j];
					System.err.println("[O] " + opposition);

					Opposition opp = p2.new Opposition(opposition);
					allOppositions.add(opp);
				}

				int elementListLength = Integer.parseInt(splitResults[j++]);
				String invokeQueue = splitResults[j];
				int invokeQueueIndex = 0;
				String elementList = "";

				for (int k = 0; k < invokeQueue.length(); k++)
				{
					String invokedElement = invokeQueue.substring(invokeQueueIndex, invokeQueueIndex + 1);
					System.err.println(invokedElement);

					if (elementList.length() < 1)
					{
						elementList += invokedElement;
					}
					else
					{
						boolean isCombo = false;

						// Look for combination //
						for (int x = 0; x < allCombinations.size(); x++)
						{
							Combination currentCombo = (Combination)allCombinations.elementAt(x);
							String elementA = elementList.substring(elementList.length() - 1);
							if (currentCombo.isMatch(elementA, invokedElement))
							{
								// Combination found //
								String sum = currentCombo.getSum();
								elementList = elementList.substring(0, elementList.length() - 1) + sum;
								isCombo = true;
								break;
							}
						}

						if (!isCombo)
						{
							boolean isOpposition = false;

							// Look for Opposition //
							for (int y = 0; y < allOppositions.size(); y++)
							{
								Opposition currentOpp = (Opposition)allOppositions.elementAt(y);
								if (currentOpp.isMatch(elementList, invokedElement))
								{
									// Opposition found //
									elementList = "";
									isOpposition = true;
									break;
								}
							}

							// Simply add to the element list //
							if (!isOpposition)
							{
								elementList += invokedElement;
							}
						}
					}
					invokeQueueIndex++;
				}

				String result = "Case #" + Integer.toString(lineNum + 1) + ": [";
				for (int z = 0; z < elementList.length(); z++)
				{
					result += elementList.charAt(z);

					if (z < elementList.length() - 1)
					{
						result += ", ";
					}
				}
				result += "]";
				System.err.println(result);

				bw.write(result);
				if (lineNum < numTestCases - 1)
				{
					bw.newLine();
				}
			}

		}
		catch (Exception e)
		{
			System.out.println("Error!");
			e.printStackTrace();
		}
		finally
		{
			if (br != null)
			{
				try
				{
					br.close();
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			}
			if (bw != null)
			{
				try
				{
					bw.close();
				}
				catch (IOException e)
				{
					e.printStackTrace();
				}
			}
		}
	}
	class Combination
	{
		private String	first;
		private String	second;
		private String	sum;

		public Combination( String fss )
		{
			first = fss.substring(0, 1);
			second = fss.substring(1, 2);
			sum = fss.substring(2, 3);
		}

		public String getSum()
		{
			return sum;
		}

		public boolean isMatch( String elementA, String elementB )
		{
			boolean ret;

			if (elementA.equals(first) && elementB.equals(second))
			{
				ret = true;
			}
			else if (elementA.equals(second) && elementB.equals(first))
			{
				ret = true;
			}
			else
			{
				ret = false;
			}

			return ret;
		}
	}

	class Opposition
	{
		private String	first;
		private String	second;

		public Opposition( String fs )
		{
			first = fs.substring(0, 1);
			second = fs.substring(1, 2);
		}

		public boolean isMatch( String elementList, String invokedElement )
		{
			boolean ret = false;

			if (invokedElement.equals(first))
			{
				if (elementList.indexOf(second) >= 0)
				{
					ret = true;
				}
			}
			else if (invokedElement.equals(second))
			{
				if (elementList.indexOf(first) >= 0)
				{
					ret = true;
				}
			}
			else
			{
				ret = false;
			}

			return ret;
		}
	}
}
