
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.InputStreamReader;

import java.io.FileNotFoundException;
import java.io.IOException;

import java.util.StringTokenizer;

public class AA {

    private Pipe pipe = null;

    public AA(String args[]) throws FileNotFoundException, IOException {
        this.pipe = new Pipe(args);
    }

    public static void main(String args[]) throws FileNotFoundException, IOException {
        new AA(args).start();
    }

    public void start() throws FileNotFoundException, IOException {
        int roundCount = pipe.ni();
        for (int round = 1; round <= roundCount; round++) {
            String result = solve();
            String outStr = "Case #" + round + ": " + result + "\n";
            pipe.print(outStr);
//            pipe.nline();
        }
        pipe.close();
    }

    public String solve() throws IOException {
        int N = pipe.ni();
        String[] strs = new String[N];
        for(int i = 0; i < N; i++) {
            strs[i] = pipe.nline();
        }
        
        int result = possible(strs);
        if(result == -1) {
            return "Fegla Won";
        } else {
            result = compute(strs);
        }
        
        return ""+result;
    }
    private int possible(String[] strs){
        String compress0 = compress(strs[0]);
        String compress1 = compress(strs[1]);
        if(compress0.equals(compress1)) {
            return Math.abs(strs[0].length() - strs[1].length());
        } else {
            return -1;
        }
    }
    
    private String compress(String str) {
        String stt = "";
        char ch = '*';
        for(int i = 0; i < str.length(); i++) {
            if(str.charAt(i) != ch) {
                stt += str.charAt(i);
                ch = str.charAt(i);
            }
        }
        return stt;
    }

    private int compute(String[] strs) {
        String st1 = strs[0];
        String st2 = strs[1];
        int d = 0;
        char ch = '*';
        int i = 0; 
        int j = 0;
        
        while(i<st1.length() && j<st2.length()) {
            if(st1.charAt(i) == st2.charAt(j)) {
                ch = st1.charAt(i);
                i++; j++;
            } else {
                if(st1.charAt(i) == ch) {
                    i++;
                } else {
                    j++;
                }
                d++;
            }
        }
        if(i < st1.length()){
            d += st1.length() - i;
        } else if(j < st2.length()) {
            d += st2.length() - j;
        }
        return d;
    }
    

    private class Pipe {

        private BufferedReader reader;
        private BufferedWriter writer;
        private StringTokenizer tokenizer;

        public Pipe(String args[]) throws FileNotFoundException, IOException {
            if (args != null && args.length >= 1) {
                reader = new BufferedReader(new FileReader(args[0]));
                if (args.length == 2) {
                    writer = new BufferedWriter(new FileWriter(args[1]));
                }
            } else {
                reader = new BufferedReader(new InputStreamReader(System.in));
            }
        }

        public String nline() throws IOException {
            tokenizer = null;
            return reader.readLine();
        }

        public String ns() throws IOException {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                tokenizer = new StringTokenizer(reader.readLine());
            }
            return tokenizer.nextToken();
        }

        public int ni() throws IOException {
            return Integer.parseInt(ns());
        }

        public long nl() throws IOException {
            return Long.parseLong(ns());
        }

        public float nf() throws IOException {
            return Float.parseFloat(ns());
        }

        public double nd() throws IOException {
            return Double.parseDouble(ns());
        }

        public void print(String str) throws IOException {
            System.out.print(str);
            if (writer != null) {
                writer.write(str, 0, str.length());
            }
        }

        public void close() throws IOException {
            if (writer != null) {
                writer.close();
            }
        }
    }
}
