import java.util.Scanner;

public class QualifyB {
	private static char currentSink;
	private static char[][] sinks;
	private static int[][] altitudes;
	private static int width,height;
	
	public static void main(String[] args) {
		Scanner input = new Scanner(System.in);
		
		int testCaseCount = Integer.parseInt(input.nextLine());
		for(int testCase=1; testCase <= testCaseCount; testCase++) {
			String result = "";
			
			currentSink = 96;
			
			String[] dimensions = input.nextLine().split(" ");
			height = Integer.parseInt(dimensions[0]);
			width = Integer.parseInt(dimensions[1]);
			
			sinks = new char[height][width];
			for(int row=0; row < height; row++) {
				for(int col=0; col < width; col++) {
					sinks[row][col] = currentSink;
				}
			}
			
			altitudes = new int[height][width];
			for(int row=0; row < height; row++) {
				String[] columns = input.nextLine().split(" ");
				for(int col=0; col < width; col++) {
					altitudes[row][col] = Integer.parseInt(columns[col]);
				}
			}
			
			for(int row=0; row < height; row++) {
				for(int col=0; col < width; col++) {
					getSink(row,col);
				}
			}
			
			for(int row=0; row < height; row++) {
				if(row > 0) {
					result += "\n";
				}
				
				for(int col=0; col < width; col++) {
					if(col > 0) {
						result += " ";
					}
				
					result += sinks[row][col];
				}
			}
			
			System.out.println("Case #"+testCase+":\n"+result);
		}
	}
	
	private static char getSink(int row, int col) {
		if(sinks[row][col] > 96) {
			return sinks[row][col];
		}
		
		int altitude = altitudes[row][col];
		
		int north = altitude+1;
		int west = altitude+1;
		int east = altitude+1;
		int south = altitude+1;
		
		if(row > 0) {
			north = altitudes[row-1][col];
		}
		
		if(col > 0) {
			west = altitudes[row][col-1];
		}
		
		if(col < width-1) {
			east = altitudes[row][col+1];
		}
		
		if(row < height-1) {
			south = altitudes[row+1][col];
		}
		
		int drainValue = north;
		int yDir = row-1;
		int xDir = col;
		
		if(west < drainValue) {
			drainValue = west;
			yDir = row;
			xDir = col-1;
		}
		
		if(east < drainValue) {
			drainValue = east;
			yDir = row;
			xDir = col+1;
		}
		
		if(south < drainValue) {
			drainValue = south;
			yDir = row+1;
			xDir = col;
		}
		
		if(drainValue < altitude) {
			sinks[row][col] = getSink(yDir,xDir);
		}
		else {
			++currentSink;
			sinks[row][col] = currentSink;
		}
		
		return sinks[row][col];
	}
}