import java.util.List;
import java.util.LinkedList;
import java.util.Scanner;

public class A {
	public static void main(String[] args) {
		A obj = new A();
		
		Scanner input = new Scanner(System.in);
		int testCaseCount = Integer.parseInt(input.nextLine());
		for(int testCase=1; testCase <= testCaseCount; testCase++) {
			int lines = Integer.parseInt(input.nextLine());
			
			Node rootNode = obj.new Node(null);
			rootNode.setValue(1.0);
			
			Node parentNode = rootNode;
			for(int i=0; i < lines; i++) {
				String line = input.nextLine();
				
				String value = line.replaceAll(".*(\\d+\\.\\d+).*","$1");
				String[] attrs = line.replaceAll("([^a-z ]*)","").split(" ");
				int closingParens = line.replaceAll("[^)]*","").length();
				
				if(line.matches("\\s*\\)\\s*")) {
					parentNode = parentNode.getParent();
					continue;
				}
				
				Node node = obj.new Node(parentNode);
				node.setValue(Double.parseDouble(value));
				for(int j=0; j < attrs.length; j++) {
					node.addAttribute(attrs[j]);
				}
				parentNode.addChild(node);
				
				if(closingParens > 1) {
					for(int j=1; j < closingParens; j++) {
						parentNode = parentNode.getParent();
					}
				}
				else if(closingParens == 0) {
					parentNode = node;
				}
			}
						
			String result = "";
			int animals = Integer.parseInt(input.nextLine());
			for(int i=0; i < animals; i++) {
				String[] animalAttrs = input.nextLine().split(" ");
				//String animalName = animalAttrs[0];
				//String animalValue = animalAttrs[1];
				
				List<String> attrs = new LinkedList<String>();
				for(int j=2; j < animalAttrs.length; j++) {
					attrs.add(animalAttrs[j]);
				}
				
				double cuteProb = findCute(1,attrs,rootNode);
				result += "\n"+cuteProb;
			}
			
			System.out.println("Case #"+testCase+":"+result);
		}
	}
	
	private static double findCute(double value, List<String> attrs, Node treeNode) {
		double nodeValue = treeNode.getValue();
		
		value = value * nodeValue;
		
		List<Node> children = treeNode.getChildren();
		List<String> nodeAttrs = treeNode.getAttributes();
		
		int childIdx = 1;
		if(!children.isEmpty() && nodeAttrs.isEmpty()) {
			childIdx = 0;
		}
		else {
			for(int i=0; i < nodeAttrs.size(); i++) {
				String childAttr = nodeAttrs.get(i);
				if(attrs.contains(childAttr)) {
					childIdx = 0;
					break;
				}	
			}
		}
		
		
		if(children.size() > childIdx) {
			Node child = children.get(childIdx);
			value = findCute(value,attrs,child);
		}
		
		return value;
	}
	
	private class Node {
		List<Node> nodes;
		Node parent;
		double value;
		List<String> attrs;
		
		public Node(Node parentNode) {
			parent = parentNode;
			nodes = new LinkedList<Node>();
			value = 0.0;
			attrs = new LinkedList<String>();
		}
		
		public void setValue(double val) {
			value = val;
		}
		
		public double getValue() {
			return value;
		}
		
		public Node getParent() {
			return parent;
		}
		
		public void addChild(Node node) {
			nodes.add(node);
		}
		
		public List<Node> getChildren() {
			return nodes;
		}
		
		public void addAttribute(String attr) {
			attrs.add(attr);
		}
		
		public List<String> getAttributes() {
			return attrs;
		}
		
		public String toString() {
			String str = "";
			
			str += "("+value+" ";
			for(int i=0; i < nodes.size(); i++) {
				str += nodes.get(i).toString();
			}
			str += ")\n";
			
			return str;
		}
	}
}
