package com.cmd.gcj2017.qualification;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

/**
 * Created by caomanhdat on 4/8/17.
 */
public class BathroomStalls {

    private static class Result{
        long max;
        long min;
        long n;

        Result(long max, long min, long n) {
            this.max = max;
            this.min = min;
            this.n = n;
        }

        @Override
        public String toString() {
            return max + " " + min;
        }
    }

    // start from 1
    private static int depth(long k) {
        int depth = 1;
        while (k > 1) {
            k = k / 2;
            depth++;
        }
        return depth;
    }

    // depth start from 1, n start from 1
    private static Result getBoundary(long n, int depth, boolean isLeft) {
        long l = n;
        long r = n;
        for (int i = 0; i < depth; i++) {
            if (isLeft) {
                n = l;
            } else {
                n = r;
            }
            if (n % 2 == 1) {
                l = n / 2;
                r = n / 2;
            } else {
                l = n / 2;
                r = Math.max(n / 2 - 1, 0);
            }
        }
        return new Result(l, r, n);
    }

    private static long getIndex(long depth) {
        long numNode = 1;
        long total = 0;
        for (long i = 0; i < depth; i++) {
            total += numNode;
            numNode *= 2;
        }
        return total;
    }

    private static Result getResult(long n, long k) {
        int depth = depth(k);
        long upperNodes = getIndex(depth-1);
        long leftNodes = n - upperNodes;
        long numNodesAtThisDepth = getIndex(depth) - upperNodes;
        Result leftBoundary = getBoundary(n, depth, true);
        Result rightBoundary = getBoundary(n , depth, false);
        long numOfLeftValues = leftNodes - rightBoundary.n * numNodesAtThisDepth;
        if (k < upperNodes + 1 + numOfLeftValues ) {
            return leftBoundary;
        } else {
            return rightBoundary;
        }
    }

    public static void main(String[] args) throws IOException {
        String fileName = "C-small-2-attempt0.in";
        Scanner scanner = new Scanner(new File("data/gjc2017/qualification/" + fileName));
        int numTestCase = Integer.parseInt(scanner.nextLine().trim());
        BufferedWriter writer = new BufferedWriter(new FileWriter("rs/gjc/2017/qualification/" + fileName));
        for (int i = 1; i <= numTestCase; i++) {
            String ins[] = scanner.nextLine().trim().split(" ");
            long n = Long.parseLong(ins[0]);
            long k = Long.parseLong(ins[1]);
            writer.write("Case #" + i + ": " + getResult(n, k) + "\n");
        }
        writer.close();
    }
}
