package vucm.google.codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.Set;


public class ProblemA {
	private int mT = -1;
	private String[] mN;
	
	private void output(String filename, String data) throws IOException {
		PrintWriter	writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}
	
	private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		mT = Integer.parseInt(br.readLine());
		mN = new String[mT];
		for(int i=0; i<mT; i++) {
			mN[i] = br.readLine();
		}
		br.close();
		
		
//		mT = 1000001;
//		mN = new int[mT];
//		for(int i=0; i<mT; i++) {
//			mN[i] = i;
//		}
		
		System.out.println("Total testcases: " + mT);
		for(int i=0; i<mT; i++) {
			System.out.println("Testcase #" + i + ": " + mN[i]);
		}
		
	}
	
	private int timeExisted(String number, String digit, char validate) {
//		System.out.println(number + ":" + digit);
		int min = Integer.MAX_VALUE;
		int max = Integer.MIN_VALUE;
		char minChar='0';
		for(int i=0; i<digit.length(); i++) {
			int count = 0;
			for(int j=0; j<number.length(); j++) {
				if(number.charAt(j) == digit.charAt(i)) count++;
			}
//			System.out.println("Checking" + (""+ digit.charAt(i)) + ":" + count);
			if(min > count) {
				min = count;
				minChar = digit.charAt(i);
			}
			if(max <count) {
				max = count;
			}
		}
		
		if(max >= min) {
			
			if(validate != '0') {
				int count = 0;
				for(int j=0; j<number.length(); j++) {
					if(number.charAt(j) == validate) count++;
				}
				return count >= 2  ? min : 0;
			} else return min;
		} else return 0; 
	}
	
	public void solve() {
		Map<String, Integer> NumberList = new LinkedHashMap<>();
		NumberList.put("ZERO", 0);
		NumberList.put("ONE", 1);
		NumberList.put("TWO", 2);
		NumberList.put("THREE", 3);
		NumberList.put("FOUR", 4);
		NumberList.put("FIVE", 5);
		NumberList.put("SIX", 6);
		NumberList.put("SEVEN", 7);
		NumberList.put("EIGHT", 8);
		NumberList.put("NINE", 9);
		String[] NumberNormal = { "ZERO", "TWO", "SIX","EIGHT", "SEVEN", "THREE", "FOUR","FIVE", "NINE", "ONE", "SIX"};
		for (int i=0; i<mT; i++) {
			String original = mN[i];
			ArrayList<Integer> number = new ArrayList<>();
			for(int j=0; j<NumberNormal.length; j++) {
				char validate = '0';
				if(j == 4 || j == 5) {
					validate = 'E';
				} else if(j == 8) {
					validate = 'N';
				}
				int count = timeExisted(original, NumberNormal[j], validate);
//				System.out.println("Contain: " + NumberList.get(NumberNormal[j]) + ":" + count);
				
				if(count > 0) {
					for(int k=0; k<count; k++) {
						number.add(NumberList.get(NumberNormal[j]));
					}
					for(int l=0; l<count; l++) {
						for(int k=0; k<NumberNormal[j].length(); k++)
							original = original.replaceFirst("" + NumberNormal[j].charAt(k), "");
					}
				}
			}
			
			if(original.length() > 0) {
				System.out.println("Wrong......" + mN[i]);
			}
			Collections.sort(number);
			String output = "";
			for(int l=0; l<number.size();l++) {
				output += number.get(l);
			}
			
//			System.out.println(output);
					
			String data = "Case #" + (i+1) + ": " + output ;
			try {
				output("./src/digits_out.txt", data);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		ProblemA countingSheep = new ProblemA();
		try {
			countingSheep.input("./src/digits.txt");
			countingSheep.solve();
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
}
