package vucm.google.codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

import com.sun.xml.internal.ws.policy.privateutil.PolicyUtils.Collections;

public class RankAndFile {
	private int mT = -1;
	private int[] mN;
	private String[][] mNData;
	
	private void output(String filename, String data) throws IOException {
		PrintWriter	writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}
	
	private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		mT = Integer.parseInt(br.readLine());
		
		mN = new int[mT];
		mNData = new String[mT][];
		for(int i=0; i<mT; i++) {
			mN[i] = Integer.parseInt(br.readLine());
			mNData[i] = new String[2*mN[i]-1];
			for(int j=0; j < 2*mN[i]-1; j++) {
				mNData[i][j] = br.readLine();
			}
		}
		br.close();
		
		
		System.out.println("Total testcases: " + mT);
		for(int i=0; i<mT; i++) {
			System.out.println("Testcase #" + i + ": " + mN[i]);
			for(int j=0; j<2*mN[i]-1; j++) {
				System.out.println(mNData[i][j]);
			}
		}
		
	}
	
	
	public void solve() {
		for (int i=0; i<mT; i++) {
			int N = mN[i];
			HashMap<String, Integer> mCountTable = new HashMap<>();
			for(int j=0; j<2*N-1; j++) {
				String[] numbers = mNData[i][j].split(" ");
				for(int k =0; k<numbers.length; k++) {
					if(mCountTable.containsKey(numbers[k])) {
						mCountTable.put(numbers[k], mCountTable.get(numbers[k])+1);
					} else {
						mCountTable.put(numbers[k], 1);
					}
				}
			}
			
			
			
			Set<String> keys = mCountTable.keySet();
			ArrayList<Integer> mMiss = new ArrayList<>();
			for(String key : keys) {
//				System.out.println(key + ":" + mCountTable.get(key));
				if(mCountTable.get(key) % 2 != 0) {
					mMiss.add(Integer.parseInt(key));
				}
			}
			
			java.util.Collections.sort(mMiss);
//			for(int l=0; l<mMiss.size()  ; l++) {
//				System.out.println(mMiss.get(l));
//			}
			
			String str = "";
			for(int l=0; l<mMiss.size() -1 ; l++) {
				str += mMiss.get(l) + " ";
			}
			str += mMiss.get(mMiss.size() -1);
			
			String data = "Case #" + (i+1) + ": " + str;
			try {
				output("./src/rankandfile_out.txt", data);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		RankAndFile countingSheep = new RankAndFile();
		try {
			countingSheep.input("./src/rankandfile.txt");
			countingSheep.solve();
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
}
