package vucm.google.codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

import com.sun.xml.internal.bind.v2.model.util.ArrayInfoUtil;
import com.sun.xml.internal.ws.policy.privateutil.PolicyUtils.Collections;

import sun.reflect.generics.tree.ArrayTypeSignature;

public class RevengeOfThePancakes {
	private int mT = -1;
	private String[] mS;
	
	private void output(String filename, String data) throws IOException {
		PrintWriter	writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}
	
	private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		mT = Integer.parseInt(br.readLine());
		mS = new String[mT];
		
		for(int i=0; i<mT; i++) {
			mS[i] = br.readLine();
		}
		br.close();
		
		System.out.println("Total testcases: " + mT);
		for(int i=0; i<mT; i++) {
			System.out.println("Testcase #" + i + ": " + mS[i]);
		}
		
	}
	
	private int recursive(List<Boolean> pancakes) {
		System.out.println("Size: " + pancakes.size());
		for(int i=0; i<pancakes.size(); i++) {
			System.out.print(pancakes.get(i) ? "+":"-" );
		}
		System.out.println("");
		
		if(pancakes.size() == 0) return 0;
		else if(pancakes.size() == 1) {
			return pancakes.get(0) ? 0 : 1;// + or -
		}
		if(pancakes.get(0)) {//+++-----
			return recursive(pancakes.subList(1, pancakes.size()));
		} else {//--+++--++...- or --+++--++...+
			if(pancakes.get(pancakes.size()-1)) {
				int index = 0;
				while(!pancakes.get(index)) index++;
				List<Boolean> subPancakes = new ArrayList<>(pancakes.subList(index, pancakes.size()));
				for(int i = 0; i<subPancakes.size(); i++) {
					subPancakes.set(i, !subPancakes.get(i));
				}
				return 1 + recursive(subPancakes);
			} else {
				for(int i=0; i<pancakes.size(); i++) {
					pancakes.set(i, !pancakes.get(i));
				}
				java.util.Collections.reverse(pancakes);
				return 1 + recursive(pancakes);
			}
		}
		
		
	}
	
	public void solve() {
		for (int i=0; i<mT; i++) {
			String strPancakes = mS[i];
			List<Boolean> pancakes = new ArrayList<>();
			for(int j=0; j<strPancakes.length(); j++) {
				pancakes.add(strPancakes.charAt(j) == '+' ? true : false);
			}
			
			java.util.Collections.reverse(pancakes);
			
			String data = "Case #" + (i+1) + ": " + recursive(pancakes);
			try {
				output("./src/revenge_of_pancakes_out.txt", data);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		RevengeOfThePancakes revengeOfThePancakes = new RevengeOfThePancakes();
		try {
			revengeOfThePancakes.input("./src/revenge_of_pancakes.txt");
			revengeOfThePancakes.solve();
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
}
