package vucm.google.codejam2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class BathRoomStalls {
	static int T;
	static String[] N;
	static String[] K;

	static private void output(String filename, String data) throws IOException {
		PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}

	static private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		T = Integer.parseInt(br.readLine());
		N = new String[T];
		K = new String[T];
		for (int i = 0; i < T; i++) {
			String line =  br.readLine();
			N[i] = line.split(" ")[0];
			K[i] = line.split(" ")[1];
		}
		br.close();

		System.out.println("Total testcases: " + T);
		for (int i = 0; i < T; i++) {
			System.out.println("Testcase #" + (i + 1) + ": " + N[i] + " " + K[i]);
		}

	}
	

	static private String[] solve(String N, String K) throws IOException {
		
			String temp = K;
			int count = 0;
			boolean isFinalInGroup = true;
			while(temp.length() > 0) {
				temp = divide(temp);
				temp = temp.replaceFirst("^0+", "");
				count++;
				if(temp.length() > 0 && Character.digit(temp.charAt(temp.length()-1), 10) % 2 != 0) {
					isFinalInGroup = false;
				}
			}
			
			System.out.println("count:" + count);
		
			
			String distance = N;
			String previousDistance=distance;
			boolean isZero = false;
			for(int i=0; i<count-1; i++) {
				if(distance.length() == 1 && Character.digit(distance.charAt(0),10) == 0) {
					break;
				}
				distance = divide(distance);   
				distance = distance.replaceFirst("^0+", "");
				if(distance.length()==0) {
					distance = "0";
					isZero = true;
				}
				previousDistance = distance;
				System.out.println("distance: " + distance );
			}
			
			if(distance.length() > 1 || Character.digit(distance.charAt(0),10) > 0){
				distance = divide(distance);   
				distance = distance.replaceFirst("^0+", "");
				if(distance.length()==0) {
					distance = "0";
					isZero = true;
				}
			}
			System.out.println("previous distance: " + previousDistance );
			System.out.println("distance: " + distance );
			
			
			boolean isEven = Character.digit(previousDistance.charAt(previousDistance.length()-1),10) % 2 == 0? true: false;
//			boolean isFinal = distance.length() == 1 && Character.digit(distance.charAt(distance.length()-1),10)==1;
			
			if(isEven) {
				return new String[] {distance, isZero? distance: minusOne(distance)};
			} else {
				return new String[] {distance, distance};
			}
	}

	static private String minusOne(String number) {
		StringBuilder builder = new StringBuilder(number);
		for(int i=number.length()-1; i>=0; i--) { 
			int digit = Character.digit(number.charAt(i), 10);
			if(digit > 0) {
				builder.setCharAt(i, Character.forDigit(digit-1, 10));
				break;
			} else {
				builder.setCharAt(i, '9');
			}
		}
		return builder.toString();
	}
	static private String divide(String number) {
		StringBuilder builder = new StringBuilder(number);
		int r=0;
		for(int i=0; i<number.length(); i++) {
			int digit = Character.digit(number.charAt(i), 10);
			int d = (digit+(r*10)) / 2;
			builder.setCharAt(i, Character.forDigit(d, 10));
			r = digit % 2;
		}
		return builder.toString();
	}
	
	
	public static void main(String[] args) {
		try {
			input("./src/bathroom.txt");
			for (int i = 0; i < T; i++) {
				String[] ret = solve(N[i], K[i]);
				output("./src/out.txt", "Case #" + (i + 1) + ": " + ret[0] + " " + ret[1]);
			}
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
