import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;


public class Pancakes {
	private int T; //1<=T<=100
	int[] D;
	int[][] Pi;
	int[] mResults;
	private void readInput(String file) {
		try {
			// Open the file
			FileInputStream fstream = new FileInputStream(file);
			BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

			T = Integer.valueOf(br.readLine());
			D = new int[T];
			Pi = new int[T][];
			for(int i=0; i<T; i++) {
				D[i] = Integer.valueOf(br.readLine());
				Pi[i] = new int[D[i]];
				String[] data = br.readLine().split(" ");
				for(int j=0; j<D[i]; j++) {
					Pi[i][j] = Integer.valueOf(data[j]);
				}
			}
			
			System.out.println(T);
			for(int i=0; i<T; i++) {
				System.out.print(D[i] + ": ");
				for(int j=0; j<D[i]; j++) {
					System.out.print(Pi[i][j] + " ");
				}
				System.out.println("");
			}

			//Close the input stream
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
	}
	
	private void printOutput(String file) {
		System.out.println("Printing result...");
		try {
			PrintWriter writer = new PrintWriter(file, "UTF-8");
			for(int i=0; i<T; i++) {
				String text = "Case #" + (i+1) + ": " + mResults[i];
				writer.println(text);
				System.out.println(text);
			}
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		
	}
	
	private void solve() {
		mResults = new int[T];
		for(int i=0; i<T; i++) {
			mResults[i] = 0;
			boolean oneShare = false;
			for(int j=0; j<D[i]; j++) {
				//Time: Even: n/2 + 1; odd: n/2 + 2
				int time;
				if(Pi[i][j] == 1) {
					time = -1;
				} else {
					time = (Pi[i][j] / 2 + 1) + (Pi[i][j] % 2) - 2; //-2: will overlap
				}
				
				if(time <0) {
					time = 0;
				} else {
					oneShare = true;
				}
				
				mResults[i] += time;
			}
			if(oneShare) {
				mResults[i] += 2;
			}
		}
	}
	
	public static void main(String[] args) {
		System.out.println("Solving Pancakes...");
		Pancakes solver = new Pancakes();
		solver.readInput("src/input");
		solver.solve();
		solver.printOutput("src/output");
		System.out.println("Done!");

	}

}
