package vucm.google.codejam2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;


public class OversizedPancakeFlipper {
	static int T;
	static String[] N;
	static int[] K;
	private void output(String filename, String data) throws IOException {
		PrintWriter	writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}
	
	private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		T = Integer.parseInt(br.readLine());
		N = new String[T];
		K = new int[T];
		for(int i=0; i<T; i++) {
			String line = br.readLine();
			N[i] = line.substring(0, line.indexOf(" "));
			K[i] = Integer.valueOf(line.substring(line.indexOf(" ")+1, line.length()));
		}
		br.close();
		
		System.out.println("Total testcases: " + T);
		for(int i=0; i<T; i++) {
			System.out.println("Testcase #" + (i+1) + ": " + N[i] + " " + K[i] );
		}
		
	}
	
	private int solve(String state,int K, int number) throws IOException {
		if(!state.contains("-")) {
			return number;
		}
		if(((state.length()-1) - state.indexOf("-") +1) < K) {
			return -1;
		} else {
			StringBuilder str = new StringBuilder(state);
			for(int i=state.indexOf("-"); i<state.indexOf("-") + K; i++) {
				str.setCharAt(i, state.charAt(i)=='+'? '-':'+');
			}
			return solve(str.toString(), K, number+1);
		}
		
	}
	public static void main(String[] args) {
		OversizedPancakeFlipper pancake = new OversizedPancakeFlipper();
		try {
			pancake.input("./src/oversize_pancake.txt");
			for(int i=0; i<T; i++) {
				int min = pancake.solve(N[i], K[i], 0);
				pancake.output("./src/out.txt","Case #" +(i+1) +": " + (min >= 0 ? min:"IMPOSSIBLE"));
			}
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
