package vucm.google.codejam2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;

public class TidyNumbers {
	static int T;
	static String[] N;

	private void output(String filename, String data) throws IOException {
		PrintWriter writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}

	private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		T = Integer.parseInt(br.readLine());
		N = new String[T];
		for (int i = 0; i < T; i++) {
			N[i] = br.readLine();
		}
		br.close();

		System.out.println("Total testcases: " + T);
		for (int i = 0; i < T; i++) {
			System.out.println("Testcase #" + (i + 1) + ": " + N[i]);
		}

	}

	private String solve(String state, int previous) throws IOException {
			
			if (state.length() == 1)
				return state;
			int i = 0;
			for (i = 0; i < state.length() - 1; i++) {
				if (Character.getNumericValue(state.charAt(i)) > Character.getNumericValue(state.charAt(i + 1))) {
					break;
				}
			}
			if (i >= state.length() - 1)
				return state;
			else {
				StringBuilder builder = new StringBuilder(state);
				int digit = Character.digit(state.charAt(i), 10);
				if(previous ==-1 || previous > i) {
					builder.setCharAt(i, Character.forDigit(digit-1, 10));
				}
				builder.setCharAt(i+1, '9');
				return solve(builder.toString(), i);
			}
	}

	public static void main(String[] args) {
		TidyNumbers tidynumbers = new TidyNumbers();
		try {
			tidynumbers.input("./src/tidynumbers.txt");
			for (int i = 0; i < T; i++) {
				String nearest = tidynumbers.solve(N[i], -1);
				tidynumbers.output("./src/out.txt", "Case #" + (i + 1) + ": " + nearest.replaceFirst("^0+(?!$)", ""));
			}
		} catch (NumberFormatException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
