import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;


public class StandingOvationProb {
	private int T; //1<=T<=100
	int[] Smax;
	String[] S;
	int[] mMore;
	private void readInput(String file) {
		try {
			// Open the file
			FileInputStream fstream = new FileInputStream(file);
			BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

			T = Integer.valueOf(br.readLine());
			Smax = new int[T];
			S = new String[T];
			for(int i=0; i<T; i++) {
				String[] data = br.readLine().split(" ");
				Smax[i] = Integer.valueOf(data[0]);
				S[i] = data[1];
			}
			
			System.out.println(T);
			for(int i=0; i<T; i++) {
				System.out.println(Smax[i] + " " + S[i]);
			}

			//Close the input stream
			br.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		
	}
	
	private void printOutput(String file) {
		System.out.println("Printing result...");
		try {
			PrintWriter writer = new PrintWriter(file, "UTF-8");
			for(int i=0; i<T; i++) {
				String text = "Case #" + (i+1) + ": " + mMore[i];
				writer.println(text);
			}
			writer.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
		
	}
	
	private void solve() {
		mMore = new int[T];
		for(int i=0; i< T; i++) {
			mMore[i] = 0;
			int standing = 0;
			for(int j=0; j <= Smax[i]; j++) {
				int audienWatching = Character.getNumericValue(S[i].charAt(j));
				if(audienWatching > 0 && standing  < j) {
					mMore[i] += j - standing;
					standing += mMore[i];
				}
				standing += audienWatching;
			}
		}
	}
	
	public static void main(String[] args) {
		System.out.println("Solving StandingOvation...");
		StandingOvationProb solver = new StandingOvationProb();
		solver.readInput("src/A-small");
		solver.solve();
		solver.printOutput("src/A-small-sol");

	}

}
