package vucm.google.codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;

public class CountingSheep {
	private int mT = -1;
	private int[] mN;
	
	private void output(String filename, String data) throws IOException {
		PrintWriter	writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}
	
	private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		mT = Integer.parseInt(br.readLine());
		mN = new int[mT];
		for(int i=0; i<mT; i++) {
			mN[i] = Integer.parseInt(br.readLine());
		}
		br.close();
		
		
//		mT = 1000001;
//		mN = new int[mT];
//		for(int i=0; i<mT; i++) {
//			mN[i] = i;
//		}
		
		System.out.println("Total testcases: " + mT);
		for(int i=0; i<mT; i++) {
			System.out.println("Testcase #" + i + ": " + mN[i]);
		}
		
	}
	public void solve() {
		Set<Integer> detector = new HashSet<>();
		for (int i=0; i<mT; i++) {
			detector.clear();
			int multiply = 0;
			System.out.println("Solving: " + mN[i] );
			if(mN[i] > 0) {
				do {
					multiply++;
					int lastNumber =mN[i] * multiply;
					while(lastNumber > 0) {
						int d = lastNumber / 10;
						int digit = lastNumber - d*10;
						lastNumber = d;
						detector.add(digit);
					}
				} while(detector.size() < 10);
			}
			
			String data = "Case #" + (i+1) + ": " + (multiply != 0 ? mN[i] * multiply : "INSOMNIA");
			try {
				output("./src/countingsheep_out.txt", data);
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		CountingSheep countingSheep = new CountingSheep();
		try {
			countingSheep.input("./src/countingsheep.txt");
			countingSheep.solve();
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
}
