package vucm.google.codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;

public class JamCoin {
	private int mT = -1;
	private int mN, mJ;
	
	private void output(String filename, String data) throws IOException {
		PrintWriter	writer = new PrintWriter(new BufferedWriter(new FileWriter(filename, true)));
		writer.println(data);
		writer.close();
	}
	
	private void input(String filename) throws NumberFormatException, IOException {
		BufferedReader br = new BufferedReader(new FileReader(filename));
		mT = Integer.parseInt(br.readLine());
		String strInput = br.readLine();
		mN = Integer.parseInt(strInput.split(" ")[0].trim());
		mJ = Integer.parseInt(strInput.split(" ")[1].trim());
		br.close();
		
		System.out.println("Total testcases: " + mT);
		System.out.println("Require: generate " + mJ + " jamcoin " + "having length: " + mN );
		
	}
	
	private int isNotPrime(long n) {
	    //check if n is a multiple of 2
	    if (n%2==0) return 2;
	    //if not, then just check the odds
	    for(int i=3;i*i<=n;i+=2) {
	        if(n%i==0)
	            return i;
	    }
	    return -1;
	}
	
	public void solve() {
		try {
			output("./src/jamcoin_out.txt", "Case #" + 1 + ":");
		} catch (IOException e1) {
			e1.printStackTrace();
		}
		int min = (int) (Math.pow(2, mN-1) + 1);
		int max = (int) (Math.pow(2, mN) -1);
		System.out.println("Length: " + mN + "Candidate range: " + min + ":" + max);
		for (int jamcoin=min; jamcoin<=max; jamcoin+=2) {
			System.out.println("Finding solution number #:" + mJ);
			if(mJ < 1) break;
			String binaryJamcoin = Integer.toBinaryString(jamcoin);
			String output = binaryJamcoin;
			
			int base = 2;
			for(base = 2; base<=10; base++) {
//				System.out.println("Checking base:" + base);
				int nontrivialInBase = isNotPrime(Long.parseLong(binaryJamcoin, base));
				if(nontrivialInBase != -1) {
					output += " " + nontrivialInBase;
				} else break;;
			}
			
			if(base <=10) continue;
			
			try {
				output("./src/jamcoin_out.txt", output);
			} catch (IOException e) {
				e.printStackTrace();
			}
			mJ--;
		}
	}
	
	public static void main(String[] args) {
		JamCoin countingSheep = new JamCoin();
		try {
			countingSheep.input("./src/jamcoin.txt");
			countingSheep.solve();
		} catch (NumberFormatException | IOException e) {
			e.printStackTrace();
		}
	}
}
