import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;


public class SnapperChainRunner {

	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		SnapperChainRunner run = new SnapperChainRunner();
	}
	
	public SnapperChainRunner()
	{
		SnapperChain park = new SnapperChain("A-small-attempt5.in", "A-test-5.out");
		park.Solve();
	}

	private class SnapperChain 
	{
		private ReadFileHelper readFileHelper;
		private WriteFileHelper writeFileHelper;
		private int caseCount;
		
		public SnapperChain(String filePath, String outputFilePath)
		{
			this.readFileHelper = new ReadFileHelper(filePath);
			this.writeFileHelper = new WriteFileHelper(outputFilePath);
		}
		
		public void Solve()
		{
			int snapsForTwo = 3;
			int lineCount = 0;
			String line = null;
			
			this.readFileHelper.readLine();
			
			while((line = this.readFileHelper.readLine()) != null)
			{
				++this.caseCount;
				
				String[] lineContent = line.split(" ");
				int snappers = Integer.parseInt(lineContent[0]); //3
				int snapCount = Integer.parseInt(lineContent[1]); //79
				//int movesToOn = (snappers - 1) + snappers; //5
				int movesToOn = 0;
				
				if(snappers <= 2)
				{
					movesToOn = (snappers - 1) + snappers;
				}
				else
				{
					movesToOn = snapsForTwo;
					//writeFileHelper.WriteLine(caseCount + " " + movesToOn + " - snapsForTwo");
					for (int i = 3; i <= snappers; i++) 
					{
						movesToOn = (movesToOn * 2) + 1;
					}
				}
				//writeFileHelper.WriteLine(caseCount + " " + movesToOn + " ");
				
				
				if(snapCount < movesToOn)
				{
					System.out.println("Case #" + this.caseCount + ": OFF");
					writeFileHelper.WriteLine("Case #" + this.caseCount + ": OFF");
				}
				else if(snapCount == movesToOn)
				{
					System.out.println("Case #" + this.caseCount + ": ON");
					writeFileHelper.WriteLine("Case #" + this.caseCount + ": ON");
				}
				else
				{
					int movesAfterOn = snapCount - movesToOn; //72
					
					if(snappers == 1)
					{
						if(snapCount % 2 == 0)
						{
							System.out.println("Case #" + this.caseCount + ": OFF" );
							writeFileHelper.WriteLine("Case #" + this.caseCount + ": OFF");
						}
						else
						{
							System.out.println("Case #" + this.caseCount + ": ON");
							writeFileHelper.WriteLine("Case #" + this.caseCount + ": ON");
						}
					}
					else if(movesAfterOn % (movesToOn + 1) == 0)
					{
						System.out.println("Case #" + this.caseCount + ": ON" );
						writeFileHelper.WriteLine("Case #" + this.caseCount + ": ON");
					}
					else
					{
						System.out.println("Case #" + this.caseCount + ": OFF");
						writeFileHelper.WriteLine("Case #" + this.caseCount + ": OFF");
					}
				}
			}
			writeFileHelper.CloseFile();
			
		}
	}

	private class ReadFileHelper 
	{
		private BufferedReader reader;
		
	    public ReadFileHelper(String filePath)
	    {
			try 
			{
				this.reader = new BufferedReader(new FileReader(filePath));
			} 
			catch (FileNotFoundException e) 
			{
				e.printStackTrace();
			}
	    }
	    
	    public String readLine()
	    {
	    	try 
	        {
	        	return reader.readLine();
			} catch (IOException e) 
			{
				e.printStackTrace();
			}
			return null;
	    }
	}

	private class WriteFileHelper
	{
		    private BufferedWriter writer;
	    
		public WriteFileHelper(String filePath)
		{
			try 
			{
				this.writer = new BufferedWriter(new FileWriter(filePath));
		    } 
			catch (IOException e) 
			{
				e.printStackTrace();
		    }
		}
		
		public void WriteLine(String line)
		{
		    try 
		    {
				writer.write(line);
				writer.newLine();
			} 
		    catch (IOException e) 
		    {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		
		public void CloseFile()
		{
			try 
			{
				writer.close();
			} 
			catch (IOException e) 
			{
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
}
