import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Set;

public class codeJam2017P4 {

	public static void main(String[] args) {
		try {
			File inputFile = new File("D-small-attempt0.in");
			FileReader fIn = new FileReader(inputFile);
			try {
				String fNameIn = inputFile.getName();
				String fNameOut = fNameIn.replaceFirst("in","out");
				FileWriter fOut = new FileWriter(fNameOut);
				BufferedReader b1 = new BufferedReader(fIn);
				String currLine = null;
				int nCases;
				currLine = b1.readLine();
				nCases = Integer.valueOf(currLine);
				for (int iCase=1; iCase <= nCases; iCase ++) {
					String[] words = b1.readLine().split(" ");
					n = Integer.valueOf(words[0]);
					int m = Integer.valueOf(words[1]);
					grid = new char[n+1][n+1];
					isOpen = new boolean[n+1][n+1];
					char ch1 = 'x';
					char ch2 = '+';
					char ch3 = 'o';
					for (int i=1; i<=n; i++) {
						for (int j=1; j<=n; j++) {
							grid[i][j] = '.';
							isOpen[i][j] = true;
						}
					}
					Set<Integer> fRows = new HashSet<Integer>();
					Set<Integer> fCols = new HashSet<Integer>();
					List<cell> added = new ArrayList<cell>();
					int score = 0;
					for (int i=0; i<m; i++) {
						String[] chars = b1.readLine().split(" ");
						char ch = chars[0].charAt(0);
						int ri = Integer.valueOf(chars[1]);
						int ci = Integer.valueOf(chars[2]);
						grid[ri][ci] = ch;
						isOpen[ri][ci] = false;
						if (ch == 'o') {
							score += 2;
							fRows.add(ri);
							fCols.add(ci);
						}
						else if (ch == 'x') {
							score += 1;
							fRows.add(ri);
							fCols.add(ci);
						}
						else {
							score += 1;
						}
					}
					closeCells();

					int count = 0;
					// subtitutions
					boolean additionsDone = false;
					if (noMoreAdditions()) additionsDone = true;
					//o-additions
					if (!additionsDone) {
						for (int i=1; i<=n; i++) {
							if (fRows.contains(i)) continue;
							for (int j=1; j<=n; j++) {
								if (fCols.contains(j)) continue;
								if (isOpen[i][j] && grid[i][j] == '.' && isLegal(i, j, ch3)) {
									cell c = new cell();
									c.x = i;
									c.y = j;
									c.c = ch3;
									added.add(c);
									count++;
									score += 2;
									grid[i][j] = ch3;
									isOpen[i][j] = false;
									fRows.add(i);
									fCols.add(j);
								}
							}
						}
						closeCells();
						if (noMoreAdditions()) additionsDone = true;
					}

					for (int i=1; i<=n; i++) {
						for (int j=1; j<n; j++) {
							if (grid[i][j] == ch1 && isLegal(i, j, ch3)) {
								cell c = new cell();
								c.x = i;
								c.y = j;
								c.c = ch3;
								added.add(c);
								count ++;
								score += 1;
								grid[i][j] = ch3;
								fRows.add(i);
								fCols.add(j);
							}
							if (grid[i][j] == ch2 && isLegal(i, j, ch3)) {
								cell c = new cell();
								c.x = i;
								c.y = j;
								c.c = ch3;
								added.add(c);
								count ++;
								score += 1;
								grid[i][j] = ch3;
								fRows.add(i);
								fCols.add(j);
							}
						}
					}

					// additions
					// x-additions
					if (!additionsDone) {
						for (int i=1; i<=n; i++) {
							if (fRows.contains(i)) continue;
							for (int j=1; j<=n; j++) {
								if (fCols.contains(j)) continue;
								if (isOpen[i][j] && grid[i][j] == '.' && isLegal(i, j, ch1)) {
									cell c = new cell();
									c.x = i;
									c.y = j;
									c.c = ch1;
									added.add(c);
									count ++;
									score += 1;
									grid[i][j] = ch1;
									isOpen[i][j] = false;
									fRows.add(i);
									fCols.add(j);
								}
							}
						}
						closeCells();
						if (noMoreAdditions()) additionsDone = true;
					}

					//+additions
					if (!additionsDone) {
						for (int i=1; i<=n; i++) {
							for (int j=1; j<=n; j++) {
								if (isOpen[i][j] && grid[i][j] == '.' && isLegal(i, j, ch2)) {
									cell c = new cell();
									c.x = i;
									c.y = j;
									c.c = ch2;
									added.add(c);
									count ++;
									score += 1;
									grid[i][j] = ch2;
									isOpen[i][j] = false;
									fRows.add(i);
									fCols.add(j);
								}
							}
						}
						closeCells();
						if (noMoreAdditions()) additionsDone = true;
					}

					if (additionsDone) {
						//						System.out.println("Case #"+iCase+": "+score+" "+count);
						fOut.write("Case #"+iCase+": "+score+" "+count+"\n");
						Iterator<cell> it = added.iterator();
						while (it.hasNext()) {
							cell c = it.next();
							//							System.out.println(c.c+" "+c.x+" "+c.y);
							fOut.write(c.c+" "+c.x+" "+c.y+"\n");
						}
					}


				}
				fOut.close();
			}
			catch (IOException e) {
				e.printStackTrace();
			}
			fIn.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static int n;
	private static char[][] grid;
	private static boolean[][] isOpen;

	private static void closeCells() {
		char c1 = 'x';
		char c2 = '+';
		char c3 = 'o';
		for (int i=1; i<=n; i++) {
			for (int j=1; j<=n; j++) {
				if (isOpen[i][j] && grid[i][j] == '.') {
					if (!isLegal(i, j, c1) && !isLegal(i, j, c2) && !isLegal(i, j, c3)) isOpen[i][j] = false;
				}
			}
		}
	}

	private static boolean noMoreAdditions() {
		for (int i=1; i<=n; i++) {
			for (int j=1; j<=n; j++) {
				if (isOpen[i][j]) return false;
			}
		}
		return true;
	}

	private static boolean isLegal(int i, int j, char ch) {
		boolean legal = false;
		char ch1 = 'x';
		char ch2 = '+';
		char ch3 = '.';
		boolean f1 = false;
		boolean f2 = false;
		boolean d1 = true;
		boolean d2 = true;
		for (int i0=1; i0<=n; i0++) {
			if (i0 == i) continue;
			int j0 = i+j-i0;
			if (j0 >= 1 && j0<= n) {
				char c = grid[i0][j0];
				if (ch == ch1) {
					if (c != ch1 && c != ch3) {
						if (f1) {
							d1 = false;
							break;
						}
						else f1 = true;
					}
				}
				else {
					if (c != ch1 && c != ch3) {
						d1 = false;
						break;
					}
				}
			}
			int j1 = i0+j-i;
			if (j1 >= 1 && j1 <= n) {
				char c = grid[i0][j1];
				if (ch == ch1) {
					if (c != ch1 && c != ch3) {
						if (f2) {
							d2 = false;
							break;
						}
						else f2 = true;
					}
				}
				else {
					if (c != ch1 && c != ch3) {
						d2 = false;
						break;
					}
				}
			}
		}
		legal = d1 && d2;

		if (legal) {
			boolean c3 = true;
			boolean f3 = false;
			for (int i0=1; i0<=n; i0++) {
				if (i0 == i) continue;
				char c = grid[i0][j];
				if (ch == ch2) {
					if (c != ch2 && c != ch3) {
						if (f3) {
							c3 = false;
							break;
						}
						else f3 = true;
					}
				}
				else {
					if (c != ch2 && c != ch3) {
						c3 = false;
						break;
					}
				}
			}
			legal = legal && c3;
		}

		if (legal) {
			boolean r4 = true;
			boolean f4 = false;
			for (int j0=1; j0<=n; j0++) {
				if (j0 == j) continue;
				char c = grid[i][j0];
				if (ch == ch2) {
					if (c != ch2 && c != ch3) {
						if (f4) {
							r4 = false;
							break;
						}
						else f4 = true;
					}
				}
				else {
					if (c != ch2 && c != ch3) {
						r4 = false;
						break;
					}
				}
			}
			legal = legal && r4;
		}
		return legal;
	}

	static class cell {
		int x, y;
		char c;
	}

}
