import java.util.Arrays;
import java.util.Scanner;

public class ProbC {
    static int R;
    static long K;
    static int N;
    public static void main(String[] args) {
        Scanner scn = new Scanner(System.in);
        int TCNum = Integer.parseInt(scn.nextLine());
        for(int test=1;test<=TCNum;test++) {
            System.out.println("Case #"+test+": "+solve(scn.nextLine(), scn.nextLine()));
            //System.out.println("Case #"+test+": "+simpleSolve(scn.nextLine(), scn.nextLine()));
        }
    }

    private static String solve(String s1, String s2) {
        int[] g = initData(s1, s2);

        long personsNumber = 0;
        for(int i=0;i<N;i++) {
            personsNumber = personsNumber + g[i];
        }
        if(personsNumber<=K) return ""+(personsNumber*R);


        int[] visits = new int[N];
        Arrays.fill(visits, -1);

        int pos = 0;
        int cik = 0;
        long money = 0;
        
        while(!(visits[pos]>=0) && cik<R) {
            visits[pos] = cik;
            long cnt = 0;
            while(cnt + g[pos]<=K) {
                cnt = cnt + g[pos];
                pos = (pos+1)%N;
            }
            money+=cnt;
            cik++;
        }

        if(cik<R) {
            int cikLen = cik - visits[pos];
            int fulCicles = (R-cik)/cikLen;
            int leftToMove = (R-cik)%cikLen;
            money += fulCicles * processCicles(cikLen, g, pos);
            money += processCicles(leftToMove, g, pos);
        }

        return ""+money;
    }

    public static long processCicles(int r, int[] g, int start) {
        long m = 0;
        long currK;
        int pos = start;
        for(int i=0;i<r;i++) {
            currK = 0;
            while(currK+g[pos]<=K) {
                currK+=g[pos];
                pos = (pos+1)%N;
            }
            m+=currK;
        }
        return m;
    }

    private static int[] initData(String s1, String s2) {
        String[] s1a = s1.split(" ");
        String[] s2a = s2.split(" ");
        R = Integer.parseInt(s1a[0]);
        K = Integer.parseInt(s1a[1]);
        N = Integer.parseInt(s1a[2]);

        int[] g = new int[N];

        for(int i=0;i<N;i++) {
            g[i] = Integer.parseInt(s2a[i]);

        }
        return g;
    }

    public static String simpleSolve(String s1, String s2) {
        int[] g = initData(s1, s2);

        long personsNumber = 0;
        for(int i=0;i<N;i++) {
            personsNumber = personsNumber + g[i];
        }
        if(personsNumber<=K) return ""+(personsNumber*R);

        int currK;
        int pos = 0;
        long money = 0;
        for(int i=0;i<R;i++) {
            currK = 0;
            while(currK+g[pos]<=K) {
                currK+=g[pos];
                pos = (pos+1)%N;
            }
            //System.err.println("adding " + currK);
            money+=currK;
        }

        return ""+money;
    }
}
