import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.LinkedList;
import java.util.Random;
import java.util.Scanner;

public class MineSweeper2 {

	static Scanner in;
	static PrintWriter out;
	static Random rand;

	static char[][] map;
	static boolean[][] bmap; // marks location has been searched
	static boolean[][] cmap; // marks location have been covered either mine or number)

	static boolean[][] dmap;

	static int row;
	static int col;

	static boolean status;

	static long time1;
	static long time2;

	public static void main(String[] args) throws IOException {

		in = new Scanner(new FileInputStream("C-small-attempt7.in"));
		out = new PrintWriter(new FileOutputStream("C-small-attempt7.out"));
		rand = new Random();

		int iteration = in.nextInt();

		for (int z = 0; z < iteration; z++) {

			int casenum = z + 1;

			out.println("Case #" + casenum + ":");

			row = in.nextInt();
			col = in.nextInt();
			int mine = in.nextInt();

			map = new char[row][col];
			bmap = new boolean[row][col];
			cmap = new boolean[row][col];
			dmap = new boolean[row][col];
			status = false;

			for (int i = 0; i < row; i++) {
				for (int j = 0; j < col; j++) {
					map[i][j] = '.';
					dmap[i][j] = false;
				}
			}

			// System.out.printf("case: %d~~~%d~~%d~~%d~~~\n", casenum, row, col, mine);

			if ((row * col - mine) == 1) {
				status = true;
			} else {

				time1 = System.currentTimeMillis();
				finalFill(mine, -1, -1);
			}

			if (status) {
				printResult();
			} else {
				out.println("Impossible");
			}

		}

		out.flush();
		out.close();

	}

	public static void finalFill(int left, int pr, int pc) {

		// out.println(left);

		if (left == 0) {

			int[] start = findStart();

			if (start[0] == -99) {
				status = false;
				return;
			}

			// initialize maps
			for (int i = 0; i < row; i++) {
				for (int j = 0; j < col; j++) {
					bmap[i][j] = false;
					if (map[i][j] == '.') {
						cmap[i][j] = false;
					} else {
						cmap[i][j] = true;
					}
				}
			}

			gothrough(start[0], start[1]);

			if (checkMap()) {
				status = true;
			}

		} else {

			/*
			 * out.println("----"); out.println(pr + ", " + pc); out.println((row * col - (pr + 1) * (pc + 1))); out.println(left);
			 */

			time2 = System.currentTimeMillis();

			if (time2 - time1 > 1000) {
				return;
			}

			if ((row * col - (pr + 1) * (pc + 1)) < left) {
				return;
			}

			l9: for (int i = 0; i < row; i++) {
				l10: for (int j = 0; j < col; j++) {

					if (status) {
						return;
					}

					if (i <= pr && j <= pc) {
						// nothing
					} else if (map[i][j] == '.') {
						map[i][j] = '*';
						finalFill(left - 1, i, j);
						if (status) {
							return;
						} else {
							map[i][j] = '.';
						}

					}

				}
			}

		}
	}

	public static int[] findStart() {
		int r = -99;
		int c = -99;

		l5: for (int i = 0; i < row; i++) {
			l6: for (int j = 0; j < col; j++) {

				if (map[i][j] == '.' && checkSurrond(i, j)) {

					r = i;
					c = j;

					break l5;
				}

			}
		}

		int[] result = new int[2];
		result[0] = r;
		result[1] = c;

		return result;
	}

	public static void gothrough(int i, int j) {

		if (bmap[i][j]) {
			return;
		} else {
			bmap[i][j] = true;
			cmap[i][j] = true;
			if ((i - 1) > -1) {
				cmap[i - 1][j] = true;
				if (checkSurrond(i - 1, j)) {
					gothrough(i - 1, j);
				}
			}

			if ((i + 1) < row) {
				cmap[i + 1][j] = true;
				if (checkSurrond(i + 1, j)) {
					gothrough(i + 1, j);
				}
			}

			if ((j - 1) > -1) {
				cmap[i][j - 1] = true;
				if (checkSurrond(i, j - 1)) {
					gothrough(i, j - 1);
				}
			}

			if ((j + 1) < col) {
				cmap[i][j + 1] = true;
				if (checkSurrond(i, j + 1)) {
					gothrough(i, j + 1);
				}
			}
			if ((i - 1) > -1 && (j - 1) > -1) {
				cmap[i - 1][j - 1] = true;
				if (map[i - 1][j - 1] != '.') {
					if (checkSurrond(i - 1, j - 1)) {
						gothrough(i - 1, j - 1);
					}
				}
			}
			if ((i - 1) > -1 && (j + 1) < col) {
				cmap[i - 1][j + 1] = true;
				if (map[i - 1][j + 1] != '.') {
					if (checkSurrond(i - 1, j + 1)) {
						gothrough(i - 1, j + 1);
					}
				}
			}
			if ((i + 1) < row && (j - 1) > -1) {
				cmap[i + 1][j - 1] = true;
				if (map[i + 1][j - 1] != '.') {
					if (checkSurrond(i + 1, j - 1)) {
						gothrough(i + 1, j - 1);
					}
				}
			}
			if ((i + 1) < row && (j + 1) < col) {
				cmap[i + 1][j + 1] = true;
				if (map[i + 1][j + 1] != '.') {
					if (checkSurrond(i + 1, j + 1)) {
						gothrough(i + 1, j + 1);
					}
				}
			}
		}

	}

	public static boolean checkSurrond(int i, int j) {
		if ((i - 1) > -1) {
			if (map[i - 1][j] != '.') {
				return false;
			}
		}

		if ((i + 1) < row) {
			if (map[i + 1][j] != '.') {
				return false;
			}
		}

		if ((j - 1) > -1) {
			if (map[i][j - 1] != '.') {
				return false;
			}
		}

		if ((j + 1) < col) {
			if (map[i][j + 1] != '.') {
				return false;
			}
		}

		if ((i - 1) > -1 && (j - 1) > -1) {
			if (map[i - 1][j - 1] != '.') {
				return false;
			}
		}

		if ((i - 1) > -1 && (j + 1) < col) {
			if (map[i - 1][j + 1] != '.') {
				return false;
			}
		}

		if ((i + 1) < row && (j - 1) > -1) {
			if (map[i + 1][j - 1] != '.') {
				return false;
			}
		}

		if ((i + 1) < row && (j + 1) < col) {
			if (map[i + 1][j + 1] != '.') {
				return false;
			}
		}

		return true;
	}

	public static boolean checkMap() {

		for (int i = 0; i < row; i++) {
			for (int j = 0; j < col; j++) {
				if (cmap[i][j] == false) {
					return false;
				}
			}
		}

		return true;

	}

	public static void printMap() {

		for (int i = 0; i < row; i++) {
			for (int j = 0; j < col; j++) {
				System.out.print(map[i][j]);
			}
			System.out.println();
		}
	}

	public static void printcMap() {
		for (int i = 0; i < row; i++) {
			for (int j = 0; j < col; j++) {

				if (cmap[i][j]) {
					System.out.print("o");
				} else {
					System.out.print("x");
				}

			}
			System.out.println();
		}
	}

	public static void printbMap() {
		for (int i = 0; i < row; i++) {
			for (int j = 0; j < col; j++) {

				if (bmap[i][j]) {
					System.out.print("o");
				} else {
					System.out.print("x");
				}

			}
			System.out.println();
		}
	}

	public static void printCombined() {

		for (int i = 0; i < row; i++) {
			for (int j = 0; j < col; j++) {

				if (bmap[i][j]) {
					System.out.print("o");
				} else {
					System.out.print(map[i][j]);
				}

			}
			System.out.println();
		}

	}

	public static void printResult() {

		boolean gotcha = false;

		for (int i = 0; i < row; i++) {
			for (int j = 0; j < col; j++) {

				if (gotcha == false && bmap[i][j]) {
					out.print("c");
					gotcha = true;
				} else {
					out.print(map[i][j]);
				}

			}
			out.println();
		}
	}
}
