import java.util.*;
import java.io.*;

public class Main
{
      static Scanner input;
      static StringBuilder results = new StringBuilder();

      public static void main(String[] args)
      {
            String filename = "C-small-1-attempt0.in";
            File file = new File(filename);

            try {
                  input = new Scanner(file);
            } catch (Exception e) {
                  System.out.println("File not found: " + file.toString());
                  return;
            }

            int cases = input.nextInt();

            for (int i = 1; i <= cases; i++) {
                  results.append("Case #");
                  results.append(i);
                  results.append(": ");
                  main2();
                  results.append("\n");
            }

            try {
                  PrintWriter writer = new PrintWriter("output.txt", "UTF-8");
                  writer.print(results.toString());
                  writer.close();
            } catch (IOException e) {
                  // do something
            }
      }

      static void main2()
      {
            boolean[] stalls = new boolean[input.nextInt() + 2];
            int people = input.nextInt();
            stalls[0] = true;
            stalls[stalls.length - 1] = true;

            int emptyLeft = 0, emptyRight = 0, emptyPosition = 0;

            for (int j = 0; j < people; j++) {
                  emptyLeft = 0; emptyRight = 0; emptyPosition = 0;

                  for (int i = 1; i < stalls.length - 1; i++) {
                        if (stalls[i])
                              continue;

                        else {
                              int left = countLeft(stalls, i);
                              int right = countRight(stalls, i);

                              if (Math.min(left, right) > Math.min(emptyLeft, emptyRight)) {
                                    emptyLeft = left;
                                    emptyRight = right;
                                    emptyPosition = i;

                              } else if (Math.min(left, right) == Math.min(emptyLeft, emptyRight)) {
                                    if (Math.max(left, right) > Math.max(emptyLeft, emptyRight)) {
                                          emptyLeft = left;
                                          emptyRight = right;
                                          emptyPosition = i;
                                    }
                              }
                        }
                  }
                  stalls[emptyPosition] = true;
            }

            int z = Math.min(emptyLeft, emptyRight);
            int y = Math.max(emptyLeft, emptyRight);
            results.append(y + " " + z);
      }

      static int countLeft(boolean[] stalls, int pos)
      {
            int count = 0;
            while (pos > 0) {
                  pos--;
                  if (stalls[pos])
                        return count;
                  else
                        count++;
            }
            return count;
      }

      static int countRight(boolean[] stalls, int pos)
      {
            int count = 0;
            while (pos < stalls.length) {
                  pos++;
                  if (stalls[pos])
                        return count;
                  else
                        count++;
            }
            return count;
      }
}