/**
 * 
 * Copyright 2016 RSVP Technologies Inc. All rights reserved. RevengeOfThePancakes.java
 * 
 */
package qual;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.util.Arrays;
import java.util.Scanner;

/**
 * @author Anqi Cui (caq@rsvptech.ca)
 * @date Apr 9, 2016
 */
public class RevengeOfThePancakes {
  static final String PROB = "B", SIZE = "small", NUMTRY = "0";
  static final String FILENAME = PROB + "-" + SIZE + "-attempt" + NUMTRY;

  /**
   * 
   * @param line Left is top, right is bottom
   * @param start incl.
   * @param end excl.
   */
  static int flip(char[] stack) {
    // System.out.println("Flipping " + Arrays.toString(stack));
    int bottomMostMinus = stack.length - 1;
    while (bottomMostMinus >= 0 && stack[bottomMostMinus] == '+') {
      bottomMostMinus--;
    }
    if (bottomMostMinus < 0) {
      /*
       * All are plus. No flip.
       */
      return 0;
    }
    int topMostMinus = 0;
    while (topMostMinus < stack.length && stack[topMostMinus] == '+') {
      topMostMinus++;
    }
    if (topMostMinus >= stack.length) {
      /*
       * All are minus. One full flip.
       */
      return 1;
    }

    /*
     * The bottom minus in the top minus section.
     */
    int topMinusBottom = topMostMinus;
    while (topMinusBottom < stack.length && stack[topMinusBottom] == '-') {
      topMinusBottom++;
    }
    topMinusBottom--;

    int result = 0;
    /*
     * If there are plus before the topMostMinus, do one more flip to these plus's.
     */
    if (topMostMinus > 0) {
      result++;
      for (int i = 0; i < topMostMinus; i++) {
        stack[i] = '-';
      }
    }

    /*
     * Then flip 0 -- topMinusBottom.
     */
    result++;
    for (int i = 0; i <= bottomMostMinus / 2; i++) {
      if (i != bottomMostMinus - i) {
        char tmp = stack[bottomMostMinus - i];
        stack[bottomMostMinus - i] = stack[i];
        stack[i] = tmp;
        stack[bottomMostMinus - i] = (stack[bottomMostMinus - i] == '+' ? '-' : '+');
      }
      stack[i] = (stack[i] == '+' ? '-' : '+');
    }

    /*
     * Then flip the middle part recursively.
     */
    // System.out.println(Arrays.toString(stack));
    result += flip(Arrays.copyOfRange(stack, 0, stack.length - topMinusBottom));
    return result;
  }

  public static void main(String[] args) throws Exception {
    try (BufferedWriter bw = new BufferedWriter(new FileWriter("output/" + FILENAME + ".out"))) {
      try (Scanner scanner = new Scanner(new File("input/" + FILENAME + ".in"))) {
        int T = scanner.nextInt();
        scanner.nextLine();
        for (int t = 0; t < T; t++) {
          System.out.print("Case # " + t + ": ");
          String line = scanner.nextLine();
          int answer = flip(line.toCharArray());
          System.out.println(answer);
          bw.write("Case #" + (t + 1) + ": " + answer);
          bw.newLine();
        }
      }
    }
  }
}
