import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

public class ThemePark {

	static long earnMoney(long R, long k, int N, long[] gi) {
		long[] moneyFromThisHeadTillNow = new long[gi.length];
		long[] roundFromThisHeadTillNow = new long[gi.length];
		for (int i = 0; i < gi.length; i++) {
			moneyFromThisHeadTillNow[i] = -1;
			roundFromThisHeadTillNow[i] = -1;
		}
		long money = 0L;
		int nextWaiting = 0;
		long round = 0;

		int currHead = 0;
		int nextGroup = 0;

		while (round < R) {
			long currPeople = 0;
			while (currPeople + gi[nextGroup] <= k) {
				currPeople += gi[nextGroup];
				nextGroup = (nextGroup + 1) % gi.length;
				if (nextGroup == currHead)
					break;
			}
			nextWaiting = nextGroup;

			round++;

			money += currPeople;
			moneyFromThisHeadTillNow[currHead] = currPeople;
			roundFromThisHeadTillNow[currHead] = 1;
			for (int i = 0; i < gi.length; i++) {
				if (i != currHead && moneyFromThisHeadTillNow[i] > -1) {
					moneyFromThisHeadTillNow[i] += currPeople;
					roundFromThisHeadTillNow[i]++;
				}
			}

			if (moneyFromThisHeadTillNow[nextWaiting] > -1)
				break;
			currHead = nextWaiting;
			nextGroup = nextWaiting;
		}
		if (round == R)
			return money;

		money += ((R - round) / roundFromThisHeadTillNow[nextWaiting])
				* moneyFromThisHeadTillNow[nextWaiting];
		round = R - ((R - round) % roundFromThisHeadTillNow[nextWaiting]);

		while (round < R) {
			currHead = nextWaiting;
			nextGroup = nextWaiting;
			long currPeople = 0;
			while (currPeople + gi[nextGroup] <= k) {
				currPeople += gi[nextGroup];
				nextGroup = (nextGroup + 1) % gi.length;
				if (nextGroup == currHead)
					break;
			}
			nextWaiting = nextGroup;
			if (nextWaiting == gi.length)
				nextWaiting = 0;

			round++;
			money += currPeople;
		}

		return money;
	}

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(
					"C:\\Documents and Settings\\Anqi Cui\\Desktop\\C-large.in"));
			BufferedWriter bw = new BufferedWriter(
					new FileWriter(
							"C:\\Documents and Settings\\Anqi Cui\\Desktop\\output.txt"));

			String line = br.readLine();

			int T = Integer.parseInt(line);
			for (int i = 0; i < T; i++) {
				line = br.readLine();
				String[] pars = line.split(" ");
				long R = Long.parseLong(pars[0]);
				long k = Long.parseLong(pars[1]);
				int N = Integer.parseInt(pars[2]);
				long[] gi = new long[N];
				line = br.readLine();
				pars = line.split(" ");
				for (int j = 0; j < N; j++) {
					gi[j] = Long.parseLong(pars[j]);
				}
				bw.write("Case #" + (i + 1) + ": " + earnMoney(R, k, N, gi));
				bw.newLine();
			}

			br.close();
			bw.close();
		} catch (FileNotFoundException fnfe) {
			fnfe.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		System.out.println("done.");
	}

}
