package gcj2014;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class DeceitfulWar {
	static String PATH = "data/gcj2014/qual/", PROBLEM = "D", SIZE = "small",
			ATTEMPT = "0";

	public static void main(String[] args) throws IOException {
		String filename = PATH + PROBLEM + "-" + SIZE;
		if (SIZE.equals("small"))
			filename += "-attempt" + ATTEMPT;
		Scanner sc = new Scanner(new File(filename + ".in"));
		BufferedWriter bw = new BufferedWriter(
				new FileWriter(filename + ".out"));
		int T = sc.nextInt();
		for (int t = 0; t < T; t++) {
			System.out.println(t);
			int N = sc.nextInt();
			double[] naomis = new double[N], kens = new double[N];
			for (int i = 0; i < N; i++) {
				naomis[i] = sc.nextDouble();
			}
			Arrays.sort(naomis);
			for (int i = 0; i < N; i++) {
				kens[i] = sc.nextDouble();
			}
			Arrays.sort(kens);

			// Honest War
			int naomiWinsWar = N;
			int k = 0;
			for (double naomi : naomis) {
				// Ken finds his block that is just bigger than Naomi's.
				while (k < N && kens[k] < naomi) {
					k++;
				}
				if (k < N) {
					// Ken finds one and wins.
					naomiWinsWar--;
					// Move on, this blocks should not be used again.
					k++;
				} else {
					// Ken has no bigger blocks anymore.
					break;
				}
			}

			// Deceitful War
			// Strategy 1: Naomi uses smallest to ruin Ken's biggest, then wins
			// the rest.
			int naomiWinsDeceitfulWar1 = N;
			int n = 0;
			k = N - 1;
			while (naomis[n] <= kens[k]) {
				// Naomi loses this time.
				naomiWinsDeceitfulWar1--;
				n++;
				k--;
				if (n >= N || k < 0)
					break;
			}
			// After that, Naomi wins the rest.
			System.out.println("Strategy 1, Naomi wins "
					+ naomiWinsDeceitfulWar1);

			// Strategy 2: Naomi uses the one just bigger than Ken's smallest to
			// win cheatfully, announcing hers is even bigger than Ken's
			// biggest.
			int naomiWinsDeceitfulWar2 = 0;
			n = 0;
			for (double ken : kens) {
				while (n < N && naomis[n] < ken) {
					n++;
				}
				if (n < N) {
					// Naomi finds one that can win
					naomiWinsDeceitfulWar2++;
					n++;
				} else {
					// Naomi can't win any more.
					break;
				}
			}
			System.out.println("Strategy 2, Naomi wins "
					+ naomiWinsDeceitfulWar2);

			int naomiWinsDeceitfulWar = Math.max(naomiWinsDeceitfulWar1,
					naomiWinsDeceitfulWar2);

			bw.write("Case #" + (t + 1) + ": " + naomiWinsDeceitfulWar + " "
					+ naomiWinsWar);
			bw.newLine();
		}
		sc.close();
		bw.close();
	}

}
