import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

public class Rotate {
	static int T, N, K;
	static String[] map;
	static int[] dx = { 1, 0, 2, -1 }, dy = { 0, 1, 1, 1 };

	static int max(int a, int b) {
		return a > b ? a : b;
	}

	static int winner() {
		System.out.println();
		int winn = 0;
		for (int i = 0; i < N; i++) {
			int rightMostDot = map[i].lastIndexOf('.');
			if (rightMostDot < 0)
				continue;
			do {
				String lStr = map[i].substring(0, rightMostDot);
				if (lStr.lastIndexOf('B') >= 0 || lStr.lastIndexOf('R') >= 0) {
					int rightMostPiece = max(lStr.lastIndexOf('B'), lStr
							.lastIndexOf('R'));
					map[i] = map[i].substring(rightMostPiece + 1,
							rightMostDot + 1)
							+ map[i].substring(0, rightMostPiece + 1)
							+ map[i].substring(rightMostDot + 1);
				} else {
					break;
				}
				rightMostDot = map[i].lastIndexOf('.');
			} while ((rightMostDot > 0));
		}
		boolean rwin = false, bwin = false;

		// Heng
		for (int i = 0; i < N; i++) {
			for (int sp = 0; sp < N; sp++) {
				if (map[i].charAt(sp) == '.')
					continue;
				int maxl = 1;
				for (int ep = sp + 1; ep < N; ep++) {
					if (map[i].charAt(ep) == map[i].charAt(sp)) {
						maxl++;
					} else {
						break;
					}
				}
				if (maxl >= K) {
					if (map[i].charAt(sp) == 'R')
						rwin = true;
					else
						bwin = true;
				}
			}
		}
		//		System.out.println("After heng, R:" + rwin + ", B:" + bwin);
		if (rwin && bwin)
			return 3;

		// Shu
		for (int j = 0; j < N; j++) {
			for (int sp = 0; sp < N; sp++) {
				if (map[sp].charAt(j) == '.')
					continue;
				int maxl = 1;
				for (int ep = sp + 1; ep < N; ep++) {
					if (map[ep].charAt(j) == map[sp].charAt(j)) {
						maxl++;
					} else {
						break;
					}
				}
				if (maxl >= K) {
					if (map[sp].charAt(j) == 'R')
						rwin = true;
					else
						bwin = true;
				}
			}
		}
		//		System.out.println("After shu, R:" + rwin + ", B:" + bwin);
		if (rwin && bwin)
			return 3;

		// Pie
		for (int j = -N + 1; j <= N - 1; j++) {
			int firstRow = (j > 0 ? j : 0), firstCol = (j > 0 ? N - 1 : j + N
					- 1);
			for (int sp = 0; sp < N - Math.abs(j); sp++) {
				int spR = firstRow + sp, spC = firstCol - sp;
				if (map[spR].charAt(spC) == '.')
					continue;
				int maxl = 1;
				for (int ep = sp + 1; ep < N - Math.abs(j); ep++) {
					int epR = firstRow + ep, epC = firstCol - ep;
					if (map[epR].charAt(epC) == map[spR].charAt(spC)) {
						maxl++;
					} else {
						break;
					}
				}
				if (maxl >= K) {
					if (map[spR].charAt(spC) == 'R')
						rwin = true;
					else
						bwin = true;
				}
			}
		}
		//		System.out.println("After pie, R:" + rwin + ", B:" + bwin);
		if (rwin && bwin)
			return 3;

		// Na
		for (int j = -N + 1; j <= N - 1; j++) {
			int firstRow = (j < 0 ? -j : 0), firstCol = (j < 0 ? 0 : j);
			for (int sp = 0; sp < N - Math.abs(j); sp++) {
				int spR = firstRow + sp, spC = firstCol + sp;
				if (map[spR].charAt(spC) == '.')
					continue;
				int maxl = 1;
				for (int ep = sp + 1; ep < N - Math.abs(j); ep++) {
					int epR = firstRow + ep, epC = firstCol + ep;
					if (map[epR].charAt(epC) == map[spR].charAt(spC)) {
						maxl++;
					} else {
						break;
					}
				}
				if (maxl >= K) {
					if (map[spR].charAt(spC) == 'R')
						rwin = true;
					else
						bwin = true;
				}
			}
		}
		//		System.out.println("After na, R:" + rwin + ", B:" + bwin);
		if (rwin)
			winn += 1;
		if (bwin)
			winn += 2;

		return winn;
	}

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(
					new FileReader(
							"C:\\Documents and Settings\\Anqi Cui\\Desktop\\A-small-attempt0.in"));
			BufferedWriter bw = new BufferedWriter(
					new FileWriter(
							"C:\\Documents and Settings\\Anqi Cui\\Desktop\\output.txt"));

			String line = br.readLine();
			T = Integer.parseInt(line);

			for (int i = 0; i < T; i++) {
				line = br.readLine();
				String[] pars = line.split(" ");
				N = Integer.parseInt(pars[0]);
				K = Integer.parseInt(pars[1]);
				map = new String[N];
				for (int j = 0; j < N; j++) {
					line = br.readLine();
					map[j] = line;
				}
				int w = winner();
				bw.write("Case #" + (i + 1) + ": ");
				switch (w) {
				case 0:
					bw.write("Neither");
					break;
				case 1:
					bw.write("Red");
					break;
				case 2:
					bw.write("Blue");
					break;
				case 3:
					bw.write("Both");
					break;
				}
				bw.newLine();
			}

			br.close();
			bw.close();
		} catch (FileNotFoundException fnfe) {
			fnfe.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}

	}

}
