package gcj2015;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class InfiniteHouseOfPancakes {
	static String PATH = "data/gcj2015/qual/", PROBLEM = "B", SIZE = "small",
			ATTEMPT = "1";

	static int go(List<Integer> pancakes) {
		int sz = pancakes.size();
		// The biggest
		int maxNum = pancakes.get(sz - 1);
		int noSplitResult = maxNum;
		if (maxNum == 1)
			return noSplitResult;
		int s0 = maxNum / 2, s1 = maxNum - s0;
		// First find all the max
		int i = sz - 2;
		while (i >= 0 && pancakes.get(i) == maxNum) {
			i--;
		}
		// Now [i+1, sz-1] are the biggest.
		int splitCount = (sz - 1 - i - 1 + 1);
		// Try split the biggest
		List<Integer> splitPancakes = new ArrayList<Integer>();
		for (int j = 0; j <= i; j++) {
			// Put the smaller back in
			splitPancakes.add(pancakes.get(j));
		}
		for (int j = i + 1; j < sz; j++) {
			// Split the biggest and put in
			splitPancakes.add(s0);
			splitPancakes.add(s1);
		}
		Collections.sort(splitPancakes);
		int splitResult = splitCount + go(splitPancakes);
		if (splitResult < noSplitResult)
			return splitResult;
		else
			return noSplitResult;
	}

	public static void main(String[] args) throws NumberFormatException,
			IOException {
		String filename = PATH + PROBLEM + "-" + SIZE;
		if (SIZE.equals("small"))
			filename += "-attempt" + ATTEMPT;
		Scanner sc = new Scanner(new File(filename + ".in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter(PATH + PROBLEM
				+ "-" + SIZE + "-attempt" + ATTEMPT + ".out"));
		int T = sc.nextInt();
		sc.nextLine();
		for (int t = 0; t < T; t++) {
			int D = sc.nextInt();
			List<Integer> pancakes = new ArrayList<Integer>();
			for (int d = 0; d < D; d++) {
				pancakes.add(sc.nextInt());
			}
			Collections.sort(pancakes);
			int result = go(pancakes);
			bw.write("Case #" + (t + 1) + ": " + result);
			bw.newLine();
		}
		sc.close();
		bw.close();
	}
}
