/**
 * 
 * Copyright 2016 RSVP Technologies Inc. All rights reserved. RevengeOfThePancakes.java
 * 
 */
package qual;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

/**
 * @author Anqi Cui (caq@rsvptech.ca)
 * @date Apr 9, 2016
 */
public class CountingSheep {
  static final String PROB = "A", SIZE = "large", NUMTRY = "";
  static final String FILENAME = PROB + "-" + SIZE
      + (SIZE.equals("large") ? "" : "-attempt" + NUMTRY);

  static BufferedWriter bw;
  static {
    try {
      bw = new BufferedWriter(new FileWriter("output/" + FILENAME + ".out"));
    } catch (IOException e) {
      e.printStackTrace();
    }
  }

  static void print(String s) throws IOException {
    System.out.print(s);
    bw.write(s);
  }

  static void println() throws IOException {
    System.out.println();
    bw.newLine();
  }

  public static void main(String[] args) throws Exception {
    try (Scanner scanner = new Scanner(new File("input/" + FILENAME + ".in"))) {
      int T = scanner.nextInt();
      for (int t = 0; t < T; t++) {
        print("Case #" + (t + 1) + ": ");
        int N = scanner.nextInt();

        String answer = "INSOMNIA";
        if (N == 0) {
          print(answer);
          println();
          continue;
        }

        Set<Character> appeared = new HashSet<>();
        BigInteger num = new BigInteger(N + "");
        BigInteger k = BigInteger.ZERO;
        while (appeared.size() < 10) {
          k = k.add(BigInteger.ONE);
          BigInteger result = num.multiply(k);
          String s = result.toString();
          for (int i = 0; i < s.length(); i++) {
            char c = s.charAt(i);
            appeared.add(c);
          }
        }

        print(num.multiply(k).toString());
        println();
      }
    }
    bw.close();
  }
}
