package gcj2014;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;

public class MagicTrick {
	static String PATH = "data/gcj2014/qual/", PROBLEM = "A", SIZE = "small",
			ATTEMPT = "0";

	public static void main(String[] args) throws NumberFormatException,
			IOException {
		String filename = PATH + PROBLEM + "-" + SIZE;
		if (SIZE.equals("small"))
			filename += "-attempt" + ATTEMPT;
		Scanner sc = new Scanner(new File(filename + ".in"));
		BufferedWriter bw = new BufferedWriter(new FileWriter(PATH + PROBLEM
				+ "-" + SIZE + "-attempt" + ATTEMPT + ".out"));
		int T = sc.nextInt();
		for (int t = 0; t < T; t++) {
			int row0 = sc.nextInt() - 1;
			int[] candidates0 = new int[4];
			for (int r = 0; r < 4; r++) {
				for (int c = 0; c < 4; c++) {
					int temp = sc.nextInt();
					if (r == row0) {
						candidates0[c] = temp;
					}
				}
			}
			int row1 = sc.nextInt() - 1;
			int[] candidates1 = new int[4];
			for (int r = 0; r < 4; r++) {
				for (int c = 0; c < 4; c++) {
					int temp = sc.nextInt();
					if (r == row1) {
						candidates1[c] = temp;
					}
				}
			}
			System.out.println(Arrays.toString(candidates0));
			System.out.println(Arrays.toString(candidates1));
			int possible = -1;
			for (int c0 : candidates0) {
				int count = 0;
				for (int c1 : candidates1) {
					if (c0 == c1)
						count++;
				}
				if (count == 1) {
					// possible answer
					if (possible == -1) {
						possible = c0;
					} else {
						// already have a possible answer, bad magician
						possible = -2;
						break;
					}
				}
			}
			String answer = "";
			if (possible == -1) {
				// no possible answer
				answer = "Volunteer cheated!";
			} else if (possible == -2) {
				// multiple possible answers
				answer = "Bad magician!";
			} else {
				answer = "" + possible;
			}
			bw.write("Case #" + (t + 1) + ": " + answer);
			bw.newLine();
		}
		sc.close();
		bw.close();
	}

}
