import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;

public class Watersheds {
	static int[][] altmap, paintmap;
	static char[][] finalmap;
	static int T, H, W;
	static int[] dH = { -1, 0, 0, 1 }, dW = { 0, -1, 1, 0 };

	static int paintMap(int h, int w, int color) {
		if (paintmap[h][w] >= 0)
			return color;
		int min = 32767, mini = -1;
		for (int i = 0; i < 4; i++) {
			int nh = h + dH[i], nw = w + dW[i];
			if (nh >= 0 && nh < H && nw >= 0 && nw < W) {
				if (altmap[nh][nw] < min && altmap[nh][nw] < altmap[h][w]) {
					min = altmap[nh][nw];
					mini = i;
				}
			}
		}
		if (mini == -1) {
			paintmap[h][w] = color;
			return color;
		}
		if (paintmap[h + dH[mini]][w + dW[mini]] >= 0) {
			paintmap[h][w] = paintmap[h + dH[mini]][w + dW[mini]];
			return paintmap[h][w];
		}
		paintmap[h][w] = color;
		int retcolor = paintMap(h + dH[mini], w + dW[mini], color);
		if (retcolor != color)
			paintmap[h][w] = retcolor;
		return retcolor;
	}

	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(
					"C:\\Documents and Settings\\admin\\\\B-large.in"));
			BufferedWriter bw = new BufferedWriter(new FileWriter(
					"C:\\Documents and Settings\\admin\\\\output.txt"));

			T = Integer.parseInt(br.readLine());
			for (int t = 0; t < T; t++) {
				String[] pars = br.readLine().split(" ");
				H = Integer.parseInt(pars[0]);
				W = Integer.parseInt(pars[1]);
				altmap = new int[H][W];
				paintmap = new int[H][W];
				finalmap = new char[H][W];
				for (int h = 0; h < H; h++) {
					pars = br.readLine().split(" ");
					for (int w = 0; w < W; w++) {
						altmap[h][w] = Integer.parseInt(pars[w]);
						paintmap[h][w] = -1;
					}
				}
				int color = 0;
				for (int h = 0; h < H; h++) {
					for (int w = 0; w < W; w++) {
						if (paintmap[h][w] < 0) {
							color = paintMap(h, w, color);
							color++;
						}
					}
				}

				bw.write("Case #" + (t + 1) + ":");
				bw.newLine();
				for (int h = 0; h < H; h++) {
					for (int w = 0; w < W; w++) {
						bw.write((char) (paintmap[h][w] + 'a'));
						if (w < W - 1)
							bw.write(' ');
					}
					bw.newLine();
				}
			}

			br.close();
			bw.close();
		} catch (FileNotFoundException fnfe) {
			fnfe.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}

	}
}
