import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;

public class FairWarning {
	static BigInteger ZERO = new BigInteger("0");

	static BigInteger gcd(BigInteger b1, BigInteger b2) {
		if (b2.compareTo(ZERO) == 0) {
			return b1;
		}
		return gcd(b2, b1.remainder(b2));
	}

	static BigInteger min(BigInteger b1, BigInteger b2) {
		if (b1.compareTo(b2) < 0) {
			return b1;
		}
		return b2;
	}

	static String apocalypse(int n, BigInteger[] ti) {
		BigInteger tigcd = ZERO;
		BigInteger minti = min(ti[0], ti[1]);
		if (ti.length >= 3) {
			for (int i = 2; i < ti.length; i++) {
				minti = min(minti, ti[i]);
			}
			BigInteger[] newti = new BigInteger[ti.length];
			int j = 0;
			for (int i = 0; i < ti.length; i++, j++) {
				newti[j] = ti[i].subtract(minti);
				if (newti[j].compareTo(ZERO) == 0) {
					j--;
				}
			}
			tigcd = gcd(newti[0], newti[1]);
			for (int i = 2; i < j; i++) {
				tigcd = gcd(tigcd, newti[i]);
			}
		} else { // ti.length == 2
			if (ti[0].compareTo(ti[1]) < 0) {
				tigcd = ti[1].subtract(ti[0]);
			} else {
				tigcd = ti[0].subtract(ti[1]);
			}
		}

		if (minti.remainder(tigcd).compareTo(ZERO) == 0) {
			return "0";
		}
		return tigcd.subtract(ti[0].remainder(tigcd)).toString();
	}

	public static void main(String[] args) {
		int C, N;
		BigInteger[] ti;
		try {
			BufferedReader br = new BufferedReader(
					new FileReader(
							"C:\\Documents and Settings\\Anqi Cui\\Desktop\\B-large.in"));
			BufferedWriter bw = new BufferedWriter(
					new FileWriter(
							"C:\\Documents and Settings\\Anqi Cui\\Desktop\\output.txt"));

			String line = br.readLine();
			C = Integer.parseInt(line);
			for (int i = 0; i < C; i++) {
				line = br.readLine();
				String[] pars = line.split(" ");
				N = Integer.parseInt(pars[0]);
				ti = new BigInteger[N];
				for (int j = 0; j < N; j++) {
					ti[j] = new BigInteger(pars[j + 1]);
				}
				bw.write("Case #" + (i + 1) + ": " + apocalypse(N, ti));
				bw.newLine();
			}

			br.close();
			bw.close();
		} catch (FileNotFoundException fnfe) {
			fnfe.printStackTrace();
		} catch (IOException ioe) {
			ioe.printStackTrace();
		}
		System.out.println("done.");
	}

}
