package org.carisuuuu.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.LinkedList;
import java.util.List;

public class Pancakes {
	public int testsT;
	public List<Integer> allDinersD = new ArrayList<>();
	public List<List<Integer>> allPancakesP = new ArrayList<>();
	public List<Integer> allMinutes = new ArrayList<>();
	
	public static void main(String[] args) {
		final Pancakes pancakes = new Pancakes();
		pancakes.load(args[0]);
		pancakes.process();
		pancakes.write(args[1]);
	}

	private void process() {
		for (int test = 0; test < testsT; ++test) {
			List<Integer> orderedPancakes = new LinkedList<>(allPancakesP.get(test));
			sortPancakes(orderedPancakes);
			allMinutes.add(findMinutes(orderedPancakes));
		}
	}

	private void sortPancakes(List<Integer> orderedPancakes) {
		Collections.sort(orderedPancakes, new Comparator<Integer>() {
			@Override
			public int compare(Integer o1, Integer o2) {
				return o2-o1;
			}
		});
	}
	
	private int findMinutes(List<Integer> orderedPancakes)
	{
		int specialMinutes = 0;
		int specialRequired = 0;
		int pancakesMax = orderedPancakes.get(0);
		int currentMinutes = pancakesMax;
		int nextMinutes = pancakesMax;
		while (pancakesMax > 3) {
			currentMinutes = Math.min(currentMinutes, nextMinutes);
			specialMinutes += specialRequired;
			
			int pancakesSplit = (int) Math.round(Math.sqrt(pancakesMax));
			specialRequired = pancakesSplit-1;
			final int extraPancakes = pancakesMax % pancakesSplit;
			final int minPancakes = pancakesMax / pancakesSplit;
			orderedPancakes.remove(0);
			for (int distribution = 0; distribution < pancakesSplit; ++ distribution) {
				orderedPancakes.add(minPancakes + (distribution < extraPancakes ? 1 : 0));
			}
			sortPancakes(orderedPancakes);
			
			pancakesMax = orderedPancakes.get(0);
			nextMinutes = pancakesMax + specialMinutes + specialRequired;
		};
		
		return Math.min(currentMinutes, nextMinutes);
	}

	private void load(String file) {
		try (final BufferedReader reader = new BufferedReader(new FileReader(file))) {
			testsT = Integer.valueOf(reader.readLine());
			for (int test = 0; test < testsT; ++test) {
				allDinersD.add(Integer.valueOf(reader.readLine()));
				final String line = reader.readLine();
				final String[] pancakeList = line.split(" ");
				final List<Integer> pancakes = new ArrayList<>();
				for (int diner = 0; diner < allDinersD.get(test); ++diner) {
					pancakes.add(Integer.valueOf(pancakeList[diner]));
				}
				allPancakesP.add(pancakes);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	private void write(String file) {
		try (final BufferedWriter writer = new BufferedWriter(new FileWriter(file))) {
			for (int test = 0; test < testsT; ++test) {
				writer.write("Case #" + (test+1) + ": " + allMinutes.get(test));
				writer.newLine();
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
