package org.codejam.carisuuuuu;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * Created by Carisuuuuu on 09/04/2016.
 */
public class Pancakes {
    private String faces;

    public Pancakes() {
    }

    public int flip(String faces) {
        this.faces = faces;
        int pos = 0, flips = 0;

        while (pos < faces.length()) {
            pos = searchFaces(pos, faces.charAt(pos));
            flips++;
        }

        if (faces.charAt(faces.length()-1) == '+') {
            flips--;
        }
        return flips;
    }

    public boolean validPos(int pos) {
        return pos >= 0 && pos < faces.length();
    }

    public int searchFaces(int start, char face) {
        int pos = start;
        while (validPos(pos) && faces.charAt(pos) == face) {
            pos++;
        }
        return pos;
    }

    public static void main(String[] args) throws FileNotFoundException {
        final Scanner scanner = new Scanner(new File(args[0]));
        PrintStream output = System.out;
        if (args.length > 1) {
            output = new PrintStream(new FileOutputStream(new File(args[1])));
        }

        final int total = scanner.nextInt();
        final Pancakes pancakes = new Pancakes();
        for (int i = 1; i <= total; ++i) {
            final int flips = pancakes.flip(scanner.next());
            output.println("Case #" + i + ": " + flips);
        }
    }
}
