package org.codejam.carisuuuuu;

import java.io.*;
import java.util.Arrays;
import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * Created by Carisuuuuu on 09/04/2016.
 */
public class ProblemA {
    public ProblemA() {
    }

    public static void main(String[] args) throws FileNotFoundException {
        final Scanner scanner = new Scanner(new File(args[0]));
        PrintStream output = System.out;
        if (args.length > 1) {
            output = new PrintStream(new FileOutputStream(new File(args[1])));
        }

        final int total = scanner.nextInt();
            final ProblemA problemA = new ProblemA();
        for (int i = 1; i <= total; ++i) {
            String number = problemA.solve(scanner.next());
            output.println("Case #" + i + ": " + number);
        }
    }

    private static final Pattern[] MATCHES = {
            Pattern.compile("^(.*)E(.*)O(.*)R(.*)Z(.*)$"),
            Pattern.compile("^(.*)E(.*)N(.*)O(.*)$"),
            Pattern.compile("^(.*)O(.*)T(.*)W(.*)$"),
            Pattern.compile("^(.*)E(.*)E(.*)H(.*)R(.*)T(.*)$"),
            Pattern.compile("^(.*)F(.*)O(.*)R(.*)U(.*)$"),
            Pattern.compile("^(.*)E(.*)F(.*)I(.*)V(.*)$"),
            Pattern.compile("^(.*)I(.*)S(.*)X(.*)$"),
            Pattern.compile("^(.*)E(.*)E(.*)N(.*)S(.*)V(.*)$"),
            Pattern.compile("^(.*)E(.*)G(.*)H(.*)I(.*)T(.*)$"),
            Pattern.compile("^(.*)E(.*)I(.*)N(.*)N(.*)$")
    };
    private static final int[] SURROUND = {5, 4, 4, 6, 5, 5, 4, 6, 6, 5};

    String solve(String jumbled) {
        char[] letters = jumbled.toCharArray();
        Arrays.sort(letters);
        String ordered = new String(letters);
        int digit = 0;
        return solveFrom(ordered, 0, "");
    }

    String solveFrom(String remaining, int digit, String phone) {
        if (remaining.isEmpty()) {
            return phone;
        }
        if (digit > 9) {
            return null;
        }
        Matcher matcher = MATCHES[digit].matcher(remaining);
        if (matcher.matches()) {
            StringBuilder next = new StringBuilder();
            for (int pos = 0; pos < SURROUND[digit]; ++pos) {
                next.append(matcher.group(pos + 1));
            }
            String nextTry = solveFrom(next.toString(), digit, phone + String.valueOf(digit));
            if (nextTry != null) {
                return nextTry;
            }
        }
        return solveFrom(remaining, digit+1, phone);
    }
}
