package org.codejam.carisu.round1b.b;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

/**
 * Created by Carisu on 07/03/2017.
 */
public class ProblemB {
    private static PrintStream output = System.out;
    private static Scanner input;

    private final static String[] CODES = {"R", "Y", "B"};

    private static void files(String[] args) throws FileNotFoundException {
        input = new Scanner(ProblemB.class.getResourceAsStream(args[0]));
        if (args.length > 1) {
            output = new PrintStream(new FileOutputStream(args[1]));
        }
    }
    public static void main(String[] args) throws FileNotFoundException {
        files(args);
        int t = input.nextInt();
        for (int h = 1; h <= t; ++h) {
            int n = input.nextInt(), r = input.nextInt(), o = input.nextInt(), y = input.nextInt(),
                    g = input.nextInt(), b = input.nextInt(), v = input.nextInt();
            final int[] cols = {r, y, b};
            Integer[] colInd = {0, 1, 2};
            Arrays.sort(colInd, new Comparator<Integer>() {
                @Override
                public int compare(Integer o1, Integer o2) {
                    return Integer.compare(cols[o1], cols[o2]);
                }
            });
            StringBuilder sb = new StringBuilder(n);
            if (cols[colInd[0]] > 0) {
                int reduce = Math.min(cols[colInd[0]], cols[colInd[2]]/2);
                if (reduce%2 == 1) {
                    --reduce;
                }
                String seq = CODES[colInd[2]] + CODES[colInd[1]] + CODES[colInd[2]] + CODES[colInd[0]];
                sb.append(fillSeq(reduce, seq));
                cols[colInd[0]] -= reduce;
                cols[colInd[1]] -= reduce;
                cols[colInd[2]] -= reduce*2;
            }
            if (cols[colInd[0]] > 0) {
                String seq = CODES[colInd[2]] + CODES[colInd[1]] + CODES[colInd[0]];
                sb.append(fillSeq(cols[colInd[0]], seq));
                cols[colInd[1]] -= cols[colInd[0]];
                cols[colInd[2]] -= cols[colInd[0]];
            }
            String seq = CODES[colInd[2]] + CODES[colInd[1]];
            sb.append(fillSeq(cols[colInd[1]], seq));
            if (cols[colInd[1]] != cols[colInd[2]]) {
                output.println(String.format("Case #%d: IMPOSSIBLE", h));
            } else {
                output.println(String.format("Case #%d: %s", h, sb));
            }
        }
    }

    private static String fillSeq(int reduce, String seq) {
        if (reduce < 1) {
            return "";
        }
        return String.format("%"+reduce+"s", " ").replace(" ", seq);
    }
}
