package org.carisuuuu.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Ovation {
	private int testsT;
	private List<Integer> allShynessSmax = new ArrayList<>();
	private List<List<Integer>> allAudience = new ArrayList<>();
	private List<Integer> allExtra = new ArrayList<>();

	public static void main(String[] args) {
		final Ovation ovation = new Ovation();
		ovation.load(args[0]);
		ovation.process();
		ovation.write(args[1]);
	}

	private void process() {
		for (int test = 0 ; test < testsT; ++test) {
			int extra = 0;
			int standing = 0;
			final List<Integer> audience = allAudience.get(test);
			for (int shyness = 0; shyness <= allShynessSmax.get(test); ++shyness) {
				if (standing < shyness)
				{
					final int required = shyness - standing;
					extra += required;
					standing += required;
				}
				standing += audience.get(shyness);
			}
			allExtra.add(extra);
		}
	}

	private void load(String file) {
		try (final BufferedReader reader = new BufferedReader(new FileReader(file))) {
			testsT = Integer.valueOf(reader.readLine());
			for (int test = 0; test < testsT; ++test) {
				final String line = reader.readLine();
				final int space = line.indexOf(' ');
				final int shynessMax = Integer.valueOf(line.substring(0, space));
				final String audience = line.substring(space+1);
				final List<Integer> members = new ArrayList<>();
				for (char member : audience.toCharArray()) {
					members.add(Integer.valueOf(new String(new char[] {member})));
				}
				allAudience.add(members);
				allShynessSmax.add(shynessMax);
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	private void write(String file) {
		try (final BufferedWriter writer = new BufferedWriter(new FileWriter(file))) {
			for (int test = 0; test < testsT; ++test) {
				writer.write("Case #" + (test+1) + ": " + allExtra.get(test));
				writer.newLine();
			}
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}


}
