package org.codejam.carisu.round1c.a;

import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.math.BigDecimal;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

/**
 * Created by Carisu on 07/03/2017.
 */
public class ProblemA {
    private static PrintStream output = System.out;
    private static Scanner input;

    private static void files(String[] args) throws FileNotFoundException {
        input = new Scanner(ProblemA.class.getResourceAsStream(args[0]));
        if (args.length > 1) {
            output = new PrintStream(new FileOutputStream(args[1]));
        }
    }
    private static final BigDecimal TWO = new BigDecimal("2");
    private static final BigDecimal PI = new BigDecimal(Math.PI);

    static class Pancake {
        int id;
        BigDecimal radius;
        BigDecimal height;
        BigDecimal edge;
        BigDecimal area;
        BigDecimal total;
        Pancake(int id, BigDecimal radius, BigDecimal height) {
            this.id = id;
            this.radius = radius;
            this.height = height;
            edge = radius.multiply(height.multiply(TWO));
            area = radius.multiply(radius);
            total = area.add(edge);
        }
    }
    public static void main(String[] args) throws FileNotFoundException {
        files(args);
        int t = input.nextInt();
        for (int g = 1; g <= t; ++g) {
            int n = input.nextInt(), k = input.nextInt();
            Pancake[] pancake = new Pancake[n];
            for (int p = 0; p < n; ++p) {
                pancake[p] = new Pancake(p, new BigDecimal(input.next()), new BigDecimal(input.next()));
            }
            Arrays.sort(pancake, new Comparator<Pancake>() {
                @Override
                public int compare(Pancake o1, Pancake o2) {
                    return -o1.area.compareTo(o2.area);
                }
            });
            int bottom = -1;
            for (int p = 0; p < k; ++p) {
                if (bottom == -1 || pancake[bottom].total.compareTo(pancake[p].total) < 0) {
                    bottom = p;
                }
            }
            BigDecimal total = pancake[bottom].total;
            BigDecimal area = pancake[bottom].area;
            int id = pancake[bottom].id;
            Arrays.sort(pancake, new Comparator<Pancake>() {
                @Override
                public int compare(Pancake o1, Pancake o2) {
                    return -o1.edge.compareTo(o2.edge);
                }
            });
            --k;
            for (Pancake p : pancake) {
                if (id == p.id)  {
                    continue;
                }
                if (k == 0) {
                    break;
                }
                if (area.compareTo(p.area) >= 0) {
                    total = total.add(p.edge);
                    --k;
                }
            }
            output.println(String.format("Case #%d: %.9f", g, total.multiply(PI)));
        }
    }
}
