/*********************************************
Google Code Jam 2014 - Qualification Round

@ID: CarrDelling
@Author: Joaquin Derrac Rus
@E-mail: carrdelling@gmail.com
**********************************************/

import java.util.*;
import java.io.*;
import java.text.*;

public class Cookies{

	private static String INPUT_FILE="input.txt";
	private static String OUTPUT_FILE="solution.txt";

	private static int nCases;
	private static double cost;
	private static double farm;		
	private static double obj;	
	
	private static void run()throws IOException{

		double output;
		
		nCases = getInt();
		
		for(int i=1;i<=nCases;i++){
			output=solveCase();
			print("Case #"+i+": ");
			println(output);
		}
	}

	private static double solveCase()throws IOException{
		
		//read cost
		cost = getDouble();
		
		//read farm production increase
		farm = getDouble();
		
		//read objective
		obj = getDouble();
		
		double solution = solve(0,2);
		
		return solution;
	}
	
	private static double solve(double currentTime,double production)throws IOException{
		
		double solution;
		
		//estimate cost without buying anything
		double estimate = obj/production;
		
		//estimate cost of getting another farm
		double farmEstimate = cost/production;
		
		//estimate cost with production enhanced
		double estimateEnhanced = obj/(production+farm);
		
		//should we buy a new farm ?
		if(estimate>(farmEstimate+estimateEnhanced)){
			solution=solve(currentTime+farmEstimate,production+farm);
		}
		else{
			solution = currentTime+estimate;
		}
		
		return solution;
		
	}
	
	// *************************************************************************************
	// FRAMEWORK 
	// *************************************************************************************

	private static Scanner scannerIN;
	private static PrintWriter prOUT;
	
	public static final void main(String[] args) throws Exception{
	
		Locale.setDefault(new Locale("en", "US"));
	
		setArgs(args);
		setInput();
		setOutput();
		
		run();

		exit();
	}


	// *************************************************************************************
	// SETUP 
	// *************************************************************************************

	private static void setArgs(String[] args){

		if(args.length>0){

			INPUT_FILE=args[0];

			if(args.length>1){	

				OUTPUT_FILE=args[1];

			}		
		}
	}
 
	private static void setInput() throws Exception{

		scannerIN = new Scanner(new FileReader(INPUT_FILE)).useLocale(Locale.US);

	}

	private static void setOutput() throws Exception{

		prOUT = new PrintWriter(new FileWriter(OUTPUT_FILE));
	}

	private static void exit() throws Exception{

		scannerIN.close();
		prOUT.close();
	}

	// *************************************************************************************
	// INPUT METHODS 
	// *************************************************************************************

	private static int getInt(){

		return scannerIN.nextInt();

	}

	private static long getLong(){

		return scannerIN.nextLong();

	}

	private static double getDouble(){

		return scannerIN.nextDouble();

	}

	private static String getLine(){

		return scannerIN.nextLine();

	}

	// *************************************************************************************
	// OUTPUT METHODS 
	// *************************************************************************************

	public static void newln() throws IOException {
		System.out.println();
		prOUT.write("\n");
	}
	
	public static void println(String line) throws IOException {

		System.out.println(line);
		prOUT.write(line);
		prOUT.write("\n");
	}

	public static void print(String line) throws IOException {

		System.out.print(line);
		prOUT.write(line);
	}


	public static void println(char c) throws IOException {

		System.out.println(c);
		prOUT.write(Character.toString(c));
		prOUT.write("\n");
		
	}
	
	public static void print(char c) throws IOException {

		System.out.print(c);
		prOUT.write(Character.toString(c));
		
	}

	public static void println(long number) throws IOException {

		System.out.println(number);
		prOUT.write(Long.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(long number) throws IOException {

		System.out.print(number);
		prOUT.write(Long.toString(number));

	}


	public static void println(int number) throws IOException {

		System.out.println(number);
		prOUT.write(Integer.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(int number) throws IOException {

		System.out.print(number);
		prOUT.write(Integer.toString(number));

	}

	public static void println(double number) throws IOException {

		System.out.printf("%.7f",number);
		System.out.println();
		prOUT.printf("%.7f",number);
		prOUT.write("\n");

	}
	
	public static void print(double number) throws IOException {

		System.out.printf("%.7f",number);
		prOUT.printf("%.7f",number);

	}


	public static void println(Object obj) throws IOException {
		
		System.out.println(obj.toString());
		prOUT.write(obj.toString());
		prOUT.write("\n");
		
	}
	
	public static void print(Object obj) throws IOException {
		
		System.out.print(obj.toString());
		prOUT.write(obj.toString());
		
	}

	// *************************************************************************************
	// USEFUL CONSTANTS
	// *************************************************************************************


}
