/*********************************************
Google Code Jam 2014 - Qualification Round

@ID: CarrDelling
@Author: Joaquin Derrac Rus
@E-mail: carrdelling@gmail.com
**********************************************/

import java.util.*;
import java.io.*;
import java.text.*;

public class Magician{

	private static String INPUT_FILE="text.txt";
	private static String OUTPUT_FILE="solution.txt";

	private static int nCases;
	private static int firstRow;
	private static int secondRow;
	
	private static final int BAD_MAGICIAN = 999;
	private static final int CHEATER = 0;
	
	private static HashSet<Integer> possible;
	
	private static void run()throws IOException{

		String output;
	
		possible = new HashSet<Integer> ();
	
		nCases = getInt();
		
		for(int i=1;i<=nCases;i++){
			output=solveCase();
			println("Case #"+i+": "+output);
		}
		
	}

	private static String solveCase()throws IOException{
	
		int number=CHEATER;
		int aux;
		
		possible.clear();
		
		//read first guess
		firstRow = getInt();
		
		for(int row=1; row <=4; row++){
		
			//save numbers of the true row
			if(row==firstRow){
				for(int num=1; num <=4; num++){
					aux = getInt();
					possible.add(aux);
				}
			}
			//discard the rest
			else{
				for(int num=1; num <=4; num++){
					getInt();
				}
			}
		}
		
		//read second guess
		secondRow = getInt();
		
		for(int row=1; row <=4; row++){
		
			//true row
			if(row==secondRow){
				for(int num=1; num <=4; num++){
		
					aux = getInt();

					if(possible.contains(aux)){
						
						if(number==CHEATER){
							number = aux;
						}
						else{
							number = BAD_MAGICIAN;
						}
						
					}
				}
			}
			//discard
			else{
				for(int num=1; num <=4; num++){
					getInt();
				}
			}
		}
				
		//output
		if(number==BAD_MAGICIAN){
			return "Bad magician!";
		}
			
		if(number==CHEATER){
			return "Volunteer cheated!";
		}
			
		return ""+number;
	}
	
	// *************************************************************************************
	// FRAMEWORK 
	// *************************************************************************************

	private static Scanner scannerIN;
	private static PrintWriter prOUT;

	static DecimalFormat DF = new DecimalFormat("0.000",new DecimalFormatSymbols(Locale.ENGLISH));

	public static final void main(String[] args) throws Exception{

		setArgs(args);
		setInput();
		setOutput();
		
		run();

		exit();
	}


	// *************************************************************************************
	// SETUP 
	// *************************************************************************************

	private static void setArgs(String[] args){

		if(args.length>0){

			INPUT_FILE=args[0];

			if(args.length>1){	

				OUTPUT_FILE=args[1];

			}		
		}
	}
 
	private static void setInput() throws Exception{

		scannerIN = new Scanner(new FileReader(INPUT_FILE));
	}

	private static void setOutput() throws Exception{

		prOUT = new PrintWriter(new FileWriter(OUTPUT_FILE));
	}

	private static void exit() throws Exception{

		scannerIN.close();
		prOUT.close();
	}

	// *************************************************************************************
	// INPUT METHODS 
	// *************************************************************************************

	private static int getInt(){

		return scannerIN.nextInt();

	}

	private static long getLong(){

		return scannerIN.nextLong();

	}

	private static double getDouble(){

		return scannerIN.nextDouble();

	}

	private static String getLine(){

		return scannerIN.nextLine();

	}

	// *************************************************************************************
	// OUTPUT METHODS 
	// *************************************************************************************

	public static void newln() throws IOException {
		System.out.println();
		prOUT.write("\n");
	}
	
	public static void println(String line) throws IOException {

		System.out.println(line);
		prOUT.write(line);
		prOUT.write("\n");
	}

	public static void print(String line) throws IOException {

		System.out.print(line);
		prOUT.write(line);
	}


	public static void println(char c) throws IOException {

		System.out.println(c);
		prOUT.write(Character.toString(c));
		prOUT.write("\n");
		
	}
	
	public static void print(char c) throws IOException {

		System.out.print(c);
		prOUT.write(Character.toString(c));
		
	}

	public static void println(long number) throws IOException {

		System.out.println(number);
		prOUT.write(Long.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(long number) throws IOException {

		System.out.print(number);
		prOUT.write(Long.toString(number));

	}


	public static void println(int number) throws IOException {

		System.out.println(number);
		prOUT.write(Integer.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(int number) throws IOException {

		System.out.print(number);
		prOUT.write(Integer.toString(number));

	}

	public static void println(double number) throws IOException {

		System.out.println(number);
		prOUT.write(Double.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(double number) throws IOException {

		System.out.print(number);
		prOUT.write(Double.toString(number));

	}


	public static void println(Object obj) throws IOException {
		
		System.out.println(obj.toString());
		prOUT.write(obj.toString());
		prOUT.write("\n");
		
	}
	
	public static void print(Object obj) throws IOException {
		
		System.out.print(obj.toString());
		prOUT.write(obj.toString());
		
	}

	// *************************************************************************************
	// USEFUL CONSTANTS
	// *************************************************************************************


}
