/*********************************************
Google Code Jam 2014 - Qualification Round

@ID: CarrDelling
@Author: Joaquin Derrac Rus
@E-mail: carrdelling@gmail.com
**********************************************/

import java.util.*;
import java.io.*;
import java.text.*;

public class War{

	private static String INPUT_FILE="text.txt";
	private static String OUTPUT_FILE="solution.txt";

	private static void run()throws IOException{

		String output;
		
		int nCases = getInt();
		
		for(int i=1;i<=nCases;i++){
			output=solveCase();
			println("Case #"+i+": "+output);

		}
	}

	private static String solveCase()throws IOException{
	
		ArrayList<Double> Naomi = new ArrayList<Double>();
		ArrayList<Double> Ken = new ArrayList<Double>();
				
		int originalPoints;
		int deceitfulPoints;
		
		int nBlocks = getInt();
		
		//Naomi blocks
		for(int i=0;i<nBlocks;i++){
			Naomi.add(getDouble());
		}
		
		//Ken blocks
		for(int i=0;i<nBlocks;i++){
			Ken.add(getDouble());
		}
		
		Collections.sort(Naomi ,Collections.reverseOrder());
		Collections.sort(Ken ,Collections.reverseOrder());
		
		//Solve original
		
		originalPoints=0;
		
		ArrayList<Double> NaomiOrg = copyArray(Naomi);
		ArrayList<Double> KenOrg = copyArray(Ken);		
		
		while(NaomiOrg.size()>0){
			
			double chN = NaomiOrg.get(0);
			NaomiOrg.remove(chN);
			
			if(chN>KenOrg.get(0)){
			
				KenOrg.remove(KenOrg.size()-1);
				originalPoints++;
			}
			else{
				int selKen=KenOrg.size()-1;
				
				while(KenOrg.get(selKen)<chN){
					selKen--;
				}
				
				KenOrg.remove(selKen);
			}
		}
		
		//Solve deceitful
		NaomiOrg = copyArray(Naomi);
		KenOrg = copyArray(Ken);
		
		deceitfulPoints=0;
		while(NaomiOrg.size()>0){
			
			//Ken has the strongest block: kill it cheating!
			if(KenOrg.get(0)>NaomiOrg.get(0)){
				KenOrg.remove(0);
				NaomiOrg.remove(NaomiOrg.size()-1);
			}
			//Naomi has the strongest block: win with it cheating!
			else{
				KenOrg.remove(0);
				NaomiOrg.remove(0);	
				deceitfulPoints++;				
			}
		}
		
		return  deceitfulPoints + " " + originalPoints;
	}
	
	private static ArrayList<Double> copyArray(ArrayList<Double> org){
		
		ArrayList<Double> copy = new ArrayList<Double>();
		
		for(Double i:org){
			copy.add(i);
		}
		
		return copy;
	}
	
	
	
	// *************************************************************************************
	// FRAMEWORK 
	// *************************************************************************************

	private static Scanner scannerIN;
	private static PrintWriter prOUT;

	static DecimalFormat DF = new DecimalFormat("0.000",new DecimalFormatSymbols(Locale.ENGLISH));

	public static final void main(String[] args) throws Exception{

		setArgs(args);
		setInput();
		setOutput();
		
		run();

		exit();
	}


	// *************************************************************************************
	// SETUP 
	// *************************************************************************************

	private static void setArgs(String[] args){

		if(args.length>0){

			INPUT_FILE=args[0];

			if(args.length>1){	

				OUTPUT_FILE=args[1];

			}		
		}
	}
 
	private static void setInput() throws Exception{

		scannerIN = new Scanner(new FileReader(INPUT_FILE)).useLocale(Locale.US);
	}

	private static void setOutput() throws Exception{

		prOUT = new PrintWriter(new FileWriter(OUTPUT_FILE));
	}

	private static void exit() throws Exception{

		scannerIN.close();
		prOUT.close();
	}

	// *************************************************************************************
	// INPUT METHODS 
	// *************************************************************************************

	private static int getInt(){

		return scannerIN.nextInt();

	}

	private static long getLong(){

		return scannerIN.nextLong();

	}

	private static double getDouble(){

		return scannerIN.nextDouble();

	}

	private static String getLine(){

		return scannerIN.nextLine();

	}

	// *************************************************************************************
	// OUTPUT METHODS 
	// *************************************************************************************

	public static void newln() throws IOException {
		System.out.println();
		prOUT.write("\n");
	}
	
	public static void println(String line) throws IOException {

		System.out.println(line);
		prOUT.write(line);
		prOUT.write("\n");
	}

	public static void print(String line) throws IOException {

		System.out.print(line);
		prOUT.write(line);
	}


	public static void println(char c) throws IOException {

		System.out.println(c);
		prOUT.write(Character.toString(c));
		prOUT.write("\n");
		
	}
	
	public static void print(char c) throws IOException {

		System.out.print(c);
		prOUT.write(Character.toString(c));
		
	}

	public static void println(long number) throws IOException {

		System.out.println(number);
		prOUT.write(Long.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(long number) throws IOException {

		System.out.print(number);
		prOUT.write(Long.toString(number));

	}


	public static void println(int number) throws IOException {

		System.out.println(number);
		prOUT.write(Integer.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(int number) throws IOException {

		System.out.print(number);
		prOUT.write(Integer.toString(number));

	}

	public static void println(double number) throws IOException {

		System.out.println(number);
		prOUT.write(Double.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(double number) throws IOException {

		System.out.print(number);
		prOUT.write(Double.toString(number));

	}


	public static void println(Object obj) throws IOException {
		
		System.out.println(obj.toString());
		prOUT.write(obj.toString());
		prOUT.write("\n");
		
	}
	
	public static void print(Object obj) throws IOException {
		
		System.out.print(obj.toString());
		prOUT.write(obj.toString());
		
	}

	// *************************************************************************************
	// USEFUL CONSTANTS
	// *************************************************************************************


}
