/*********************************************
Google Code Jam 2014 - Round 1C

@ID: CarrDelling
@Author: Joaquin Derrac Rus
@E-mail: carrdelling@gmail.com
**********************************************/

import java.util.*;
import java.io.*;
import java.text.*;

public class Enclosure{

	private static String INPUT_FILE="input.txt";
	private static String OUTPUT_FILE="solution.txt";

	private static int nCases;
	private static int N;
	private static int M;
	private static int K;
	
	private static void run()throws IOException{

		String output;
		
		nCases = getInt();
		
		for(int i=1;i<=nCases;i++){
			output=solveCase();
			print("Case #"+i+": ");
			println(output);
		}
	}

	private static String solveCase()throws IOException{
		
		N = getInt();
		M = getInt();
		K = getInt();
		
		if(N<3){
			return K+"";
		}
		
		if(M<3){
			return K+"";
		}

		//starting cross
		//   *
		//  * *
		//   *
		
		int cF = 3;
		int cC = 3;
		int cost = 4;
		int empty =1;
		
		while((cost+empty)<K){
		
			if((cost+empty)==(K-1)){
				cost++;
			}else{
			
				if((cost+empty)==(K-2)){
					cost++;
					cost++;
				}else{
			
				
					if((cF<N)&&(cC<M)){
							if(cF<=cC){
								cF++;
								cost+=2;
								empty+=(cC-2);
							}else{
								cC++;
								cost+=2;
								empty+=(cF-2);		

							}
							
							
					}
					else if((cF==N) &&(cC<M)){
						cC++;
						cost+=2;
						empty+=(cF-2);			
					}
					else if((cC==M) &&(cF<N)){
							cF++;
							cost+=2;
							empty+=(cC-2);					
					}
					else{
						cost++;
					}
				}
			}

		}
		
		if(K<cost){
			cost=K;
		}
		
		return cost+"";
	}
	
	// *************************************************************************************
	// FRAMEWORK 
	// *************************************************************************************

	private static Scanner scannerIN;
	private static PrintWriter prOUT;
	
	public static final void main(String[] args) throws Exception{
	
		Locale.setDefault(new Locale("en", "US"));
	
		setArgs(args);
		setInput();
		setOutput();
		
		run();

		exit();
	}


	// *************************************************************************************
	// SETUP 
	// *************************************************************************************

	private static void setArgs(String[] args){

		if(args.length>0){

			INPUT_FILE=args[0];

			if(args.length>1){	

				OUTPUT_FILE=args[1];

			}		
		}
	}
 
	private static void setInput() throws Exception{

		scannerIN = new Scanner(new FileReader(INPUT_FILE)).useLocale(Locale.US);

	}

	private static void setOutput() throws Exception{

		prOUT = new PrintWriter(new FileWriter(OUTPUT_FILE));
	}

	private static void exit() throws Exception{

		scannerIN.close();
		prOUT.close();
	}

	// *************************************************************************************
	// INPUT METHODS 
	// *************************************************************************************

	private static int getInt(){

		return scannerIN.nextInt();

	}

	private static long getLong(){

		return scannerIN.nextLong();

	}

	private static double getDouble(){

		return scannerIN.nextDouble();

	}

	private static String getLine(){

		return scannerIN.nextLine();

	}

	// *************************************************************************************
	// OUTPUT METHODS 
	// *************************************************************************************

	public static void newln() throws IOException {
		System.out.println();
		prOUT.write("\n");
	}
	
	public static void println(String line) throws IOException {

		System.out.println(line);
		prOUT.write(line);
		prOUT.write("\n");
	}

	public static void print(String line) throws IOException {

		System.out.print(line);
		prOUT.write(line);
	}


	public static void println(char c) throws IOException {

		System.out.println(c);
		prOUT.write(Character.toString(c));
		prOUT.write("\n");
		
	}
	
	public static void print(char c) throws IOException {

		System.out.print(c);
		prOUT.write(Character.toString(c));
		
	}

	public static void println(long number) throws IOException {

		System.out.println(number);
		prOUT.write(Long.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(long number) throws IOException {

		System.out.print(number);
		prOUT.write(Long.toString(number));

	}


	public static void println(int number) throws IOException {

		System.out.println(number);
		prOUT.write(Integer.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(int number) throws IOException {

		System.out.print(number);
		prOUT.write(Integer.toString(number));

	}

	public static void println(double number) throws IOException {

		System.out.printf("%.7f",number);
		System.out.println();
		prOUT.printf("%.7f",number);
		prOUT.write("\n");

	}
	
	public static void print(double number) throws IOException {

		System.out.printf("%.7f",number);
		prOUT.printf("%.7f",number);

	}


	public static void println(Object obj) throws IOException {
		
		System.out.println(obj.toString());
		prOUT.write(obj.toString());
		prOUT.write("\n");
		
	}
	
	public static void print(Object obj) throws IOException {
		
		System.out.print(obj.toString());
		prOUT.write(obj.toString());
		
	}

	// *************************************************************************************
	// USEFUL CONSTANTS
	// *************************************************************************************


}
