/*********************************************
Google Code Jam 2014 - Round 1B

@ID: CarrDelling
@Author: Joaquin Derrac Rus
@E-mail: carrdelling@gmail.com
**********************************************/

import java.util.*;
import java.io.*;
import java.text.*;

public class Sales{

	private static String INPUT_FILE="input.txt";
	private static String OUTPUT_FILE="solution.txt";

	private static int nCases;
	private static int CITY;
	private static int FL;
	private static int zip [];
	private static int mat [][];
	
	private static void run()throws IOException{

		String output;
		
		nCases = getInt();
		
		for(int i=1;i<=nCases;i++){
			output=solveCase();
			print("Case #"+i+": ");
			println(output);
		}
	}

	private static String solveCase()throws IOException{
		
		CITY=getInt();
		FL=getInt();
		
		zip=new int [CITY];
		
		for(int i=0;i<CITY;i++){
			zip[i]=getInt();
		}
		
		mat = new int [CITY][CITY];

		for(int i=0;i<CITY;i++){
			Arrays.fill(mat[i],0);
		}
		
		for(int i=0;i<FL;i++){
			int a=getInt()-1;
			int b=getInt()-1;

			mat[a][b]=1;
			mat[b][a]=1;
			
		}
		
		boolean visited [] = new boolean[CITY];
		boolean available [] = new boolean[CITY];
		Arrays.fill(visited,false);
		Arrays.fill(available,false);
		
		String trueOutput="";
		int minZIP = Integer.MAX_VALUE;
		
		for(int i=0;i<CITY;i++){
		
			boolean Navailable [] = new boolean[CITY];
			System.arraycopy(available,0,Navailable,0,CITY);
			
			for(int j=0;j<CITY;j++){
				if((mat[i][j]==1)&&(!visited[j])){
					Navailable[j]=true;
				}
			}
			
			boolean Nvisited [] = new boolean[CITY];
			System.arraycopy(visited,0,Nvisited,0,CITY);
			Nvisited[i]=true;
			
			String output=""+zip[i];
			
			output=solv(output,Navailable,Nvisited);

			if(output!="Error"){
				if(zip[i]<minZIP){
					minZIP=zip[i];
					trueOutput=output;
				}
			}
		}

		return trueOutput;
		
		
	}
	
	private static String solv(String output,boolean available[] , boolean visited [])throws IOException{
	
		boolean done=true;
	
		for(int i=0; i<CITY && done;i++){
			done=visited[i];
		}
		
		if(done){
			return output;
		}
		
		boolean error=true;
				String trueOutput="";
		int minZIP = Integer.MAX_VALUE;
		
		for(int i=0;i<CITY;i++){
		
			if ((available[i])&&(!visited[i])){
				boolean Navailable [] = new boolean[CITY];
				System.arraycopy(available,0,Navailable,0,CITY);
				
				for(int j=0;j<CITY;j++){
					if((mat[i][j]==1)&&(!visited[j])){
						Navailable[j]=true;
					}
				}
				
				boolean Nvisited [] = new boolean[CITY];
				System.arraycopy(visited,0,Nvisited,0,CITY);
				Nvisited[i]=true;
				
				String Noutput=output+""+zip[i];
				
				Noutput=solv(Noutput,Navailable,Nvisited);
				
				if(Noutput!="Error"){
					if(zip[i]<minZIP){
					minZIP=zip[i];
						trueOutput=Noutput;
					}
				}
				error=false;
			}

		}
		
		if(error){
			return "Error";
		}
	
		return trueOutput;
	}
	// *************************************************************************************
	// FRAMEWORK 
	// *************************************************************************************

	private static Scanner scannerIN;
	private static PrintWriter prOUT;
	
	public static final void main(String[] args) throws Exception{
	
		Locale.setDefault(new Locale("en", "US"));
	
		setArgs(args);
		setInput();
		setOutput();
		
		run();

		exit();
	}


	// *************************************************************************************
	// SETUP 
	// *************************************************************************************

	private static void setArgs(String[] args){

		if(args.length>0){

			INPUT_FILE=args[0];

			if(args.length>1){	

				OUTPUT_FILE=args[1];

			}		
		}
	}
 
	private static void setInput() throws Exception{

		scannerIN = new Scanner(new FileReader(INPUT_FILE)).useLocale(Locale.US);

	}

	private static void setOutput() throws Exception{

		prOUT = new PrintWriter(new FileWriter(OUTPUT_FILE));
	}

	private static void exit() throws Exception{

		scannerIN.close();
		prOUT.close();
	}

	// *************************************************************************************
	// INPUT METHODS 
	// *************************************************************************************

	private static int getInt(){

		return scannerIN.nextInt();

	}

	private static long getLong(){

		return scannerIN.nextLong();

	}

	private static double getDouble(){

		return scannerIN.nextDouble();

	}

	private static String getLine(){

		return scannerIN.nextLine();

	}

	// *************************************************************************************
	// OUTPUT METHODS 
	// *************************************************************************************

	public static void newln() throws IOException {
		System.out.println();
		prOUT.write("\n");
	}
	
	public static void println(String line) throws IOException {

		System.out.println(line);
		prOUT.write(line);
		prOUT.write("\n");
	}

	public static void print(String line) throws IOException {

		System.out.print(line);
		prOUT.write(line);
	}


	public static void println(char c) throws IOException {

		System.out.println(c);
		prOUT.write(Character.toString(c));
		prOUT.write("\n");
		
	}
	
	public static void print(char c) throws IOException {

		System.out.print(c);
		prOUT.write(Character.toString(c));
		
	}

	public static void println(long number) throws IOException {

		System.out.println(number);
		prOUT.write(Long.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(long number) throws IOException {

		System.out.print(number);
		prOUT.write(Long.toString(number));

	}


	public static void println(int number) throws IOException {

		System.out.println(number);
		prOUT.write(Integer.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(int number) throws IOException {

		System.out.print(number);
		prOUT.write(Integer.toString(number));

	}

	public static void println(double number) throws IOException {

		System.out.printf("%.7f",number);
		System.out.println();
		prOUT.printf("%.7f",number);
		prOUT.write("\n");

	}
	
	public static void print(double number) throws IOException {

		System.out.printf("%.7f",number);
		prOUT.printf("%.7f",number);

	}


	public static void println(Object obj) throws IOException {
		
		System.out.println(obj.toString());
		prOUT.write(obj.toString());
		prOUT.write("\n");
		
	}
	
	public static void print(Object obj) throws IOException {
		
		System.out.print(obj.toString());
		prOUT.write(obj.toString());
		
	}

	// *************************************************************************************
	// USEFUL CONSTANTS
	// *************************************************************************************


}
