/*********************************************
Google Code Jam 2014 - Round 1B

@ID: CarrDelling
@Author: Joaquin Derrac Rus
@E-mail: carrdelling@gmail.com
**********************************************/

import java.util.*;
import java.io.*;
import java.text.*;

public class Repeater{

	private static String INPUT_FILE="input.txt";
	private static String OUTPUT_FILE="solution.txt";

	private static int nCases;
	private static String chains[];
	private static int nChains;

	
	private static ArrayList<Character> dist;
	
	private static void run()throws IOException{

		String output;
		
		nCases = getInt();
		
		for(int i=1;i<=nCases;i++){
			output=solveCase();
			print("Case #"+i+": ");
			println(output);
		}
	}

	private static String solveCase()throws IOException{
		
		nChains=getInt();

		//read chains
		chains=new String [nChains];
		getLine();
		for(int i=0;i<nChains;i++){
		
			chains[i]=getLine();

		}
		
		dist = new ArrayList<Character>();
		
		//check first chain
		dist.add(chains[0].charAt(0));
		int index=0;
		
		for(int i=1;i<chains[0].length();i++){
		
			if(chains[0].charAt(i)==dist.get(index)){
			
			}
			else{
				dist.add(chains[0].charAt(i));
				index++;
			}
		}
		
		//count all
		int count [][] = new int [nChains][index+1];
		for(int c=0; c< nChains;c++){
		
			Arrays.fill(count[c],0);
			index=0;

			for(int i=0;i<chains[c].length();i++){
			
				if(chains[c].charAt(i)==dist.get(index)){
					count[c][index]++;

				}
				else{
					if(index==(dist.size()-1)){

						return "Fegla Won";
					}

					if(i==0){

						return "Fegla Won";
					}
					
					if(chains[c].charAt(i)!=dist.get(index+1)){

						return "Fegla Won";
					}
					else{
						index++;
						count[c][index]++;
					}
				}	
				
			}
			
			if(index<(dist.size()-1)){
				return "Fegla Won";
			}
			
			
		}
		
		//solution can be achieved. Count minimum
		double sum;
		int cost=0;
		for(int col=0;col<count[0].length;col++){
		
			sum=0.0;
			
			for(int c=0; c< nChains;c++){
			
				sum+=count[c][col];
			}
		
			double avg = sum/(double)nChains;
			
			int pat = (int)Math.round(avg);
			
			for(int c=0; c< nChains;c++){
			
				if(pat>count[c][col]){
					cost+=pat-count[c][col];
				}
				else{
					cost+=count[c][col]-pat;
				}
			}
		}
		
		return ""+cost;
	}
	
	// *************************************************************************************
	// FRAMEWORK 
	// *************************************************************************************

	private static Scanner scannerIN;
	private static PrintWriter prOUT;
	
	public static final void main(String[] args) throws Exception{
	
		Locale.setDefault(new Locale("en", "US"));
	
		setArgs(args);
		setInput();
		setOutput();
		
		run();

		exit();
	}


	// *************************************************************************************
	// SETUP 
	// *************************************************************************************

	private static void setArgs(String[] args){

		if(args.length>0){

			INPUT_FILE=args[0];

			if(args.length>1){	

				OUTPUT_FILE=args[1];

			}		
		}
	}
 
	private static void setInput() throws Exception{

		scannerIN = new Scanner(new FileReader(INPUT_FILE)).useLocale(Locale.US);

	}

	private static void setOutput() throws Exception{

		prOUT = new PrintWriter(new FileWriter(OUTPUT_FILE));
	}

	private static void exit() throws Exception{

		scannerIN.close();
		prOUT.close();
	}

	// *************************************************************************************
	// INPUT METHODS 
	// *************************************************************************************

	private static int getInt(){

		return scannerIN.nextInt();

	}

	private static long getLong(){

		return scannerIN.nextLong();

	}

	private static double getDouble(){

		return scannerIN.nextDouble();

	}

	private static String getLine(){

		return scannerIN.nextLine();

	}

	// *************************************************************************************
	// OUTPUT METHODS 
	// *************************************************************************************

	public static void newln() throws IOException {
		System.out.println();
		prOUT.write("\n");
	}
	
	public static void println(String line) throws IOException {

		System.out.println(line);
		prOUT.write(line);
		prOUT.write("\n");
	}

	public static void print(String line) throws IOException {

		System.out.print(line);
		prOUT.write(line);
	}


	public static void println(char c) throws IOException {

		System.out.println(c);
		prOUT.write(Character.toString(c));
		prOUT.write("\n");
		
	}
	
	public static void print(char c) throws IOException {

		System.out.print(c);
		prOUT.write(Character.toString(c));
		
	}

	public static void println(long number) throws IOException {

		System.out.println(number);
		prOUT.write(Long.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(long number) throws IOException {

		System.out.print(number);
		prOUT.write(Long.toString(number));

	}


	public static void println(int number) throws IOException {

		System.out.println(number);
		prOUT.write(Integer.toString(number));
		prOUT.write("\n");

	}
	
	public static void print(int number) throws IOException {

		System.out.print(number);
		prOUT.write(Integer.toString(number));

	}

	public static void println(double number) throws IOException {

		System.out.printf("%.7f",number);
		System.out.println();
		prOUT.printf("%.7f",number);
		prOUT.write("\n");

	}
	
	public static void print(double number) throws IOException {

		System.out.printf("%.7f",number);
		prOUT.printf("%.7f",number);

	}


	public static void println(Object obj) throws IOException {
		
		System.out.println(obj.toString());
		prOUT.write(obj.toString());
		prOUT.write("\n");
		
	}
	
	public static void print(Object obj) throws IOException {
		
		System.out.print(obj.toString());
		prOUT.write(obj.toString());
		
	}

	// *************************************************************************************
	// USEFUL CONSTANTS
	// *************************************************************************************


}
