import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class TaskC1 {
	private static final String TEST_NAME = "C-small-attempt0";
	private static final String INPUT_FILE = TEST_NAME + ".in";
	private static final String OUTPUT_FILE = TEST_NAME + ".out";

	private static final int MOD = 1000000007;
	
	private static Scanner in;
	private static PrintWriter out;
		
	public static void main(String[] args) throws Exception {
		in = new Scanner(new File(INPUT_FILE));
		out = new PrintWriter(OUTPUT_FILE);
		
		int testCasesNum = in.nextInt();
		for (int i=0; i<testCasesNum; ++i) {
			solveTestCase(i+1);
		}
		in.close();
		out.close();
	}
	
	private static void solveTestCase(int testCaseID ) {
		int n = in.nextInt(), m = in.nextInt();
		long X = in.nextLong(), Y = in.nextLong(), Z = in.nextLong();
		long[] am = new long[m], an = new long[n];
		
		for (int i=0; i<m; ++i) {
			am[i] = in.nextLong();
		}
		
		for (int i=0; i<n; ++i) {
			an[i] = am[i%m];
			am[i % m] = (X*am[i%m] + Y*(i+1)) % Z;
		}
		
		long[] f = new long[n];
		
		for (int i=0; i<n; ++i) {
			for (int j=0; j<i; ++j) {
				if (an[j] < an[i]) {
					f[i] = (f[i] + f[j]) % MOD;
				}
			}
			f[i] = (f[i] + 1) % MOD;
		}
		
		long result = 0;
		
		for (int i=0; i<n; ++i) {
			result = (result + f[i]) % MOD;
		}
		
		out.println(String.format("Case #%d: %d", testCaseID, result));
	}
}