/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package watersheds_qr2009_codejam;

import java.util.ArrayList;

/**
 *
 * @author Casanova
 */
public class Basins {

    private ArrayList<ArrayList<Cell>> matrix;
    private int currentOrder;

    public Basins() {
        matrix = new ArrayList<ArrayList<Cell>>();
        currentOrder = 1;
    }

    public void insertRow(String strRow) {
        if(strRow.isEmpty())
            return;
        ArrayList<Cell> row = new ArrayList<Cell>();
        String[] strCols = strRow.split(" ");
        for(int i = 0; i < strCols.length; i++) {
            row.add(new Cell(Integer.parseInt(strCols[i])));
        }
        matrix.add(row);
    }

    public void process() {
        for(int i = 0; i < matrix.size(); i++) {
            ArrayList<Cell> row = this.matrix.get(i);
            for(int j = 0; j < row.size(); j++) {
                if(row.get(j).Order == Integer.MAX_VALUE) {
                    row.get(j).Order = currentOrder;
                    currentOrder++;
                }
                findNextCell(i, j);
            }
        }
    }

    private void findNextCell(int curRow, int curCol) {
        int lowest = findLowestValue(curRow, curCol);
        if(lowest >= this.matrix.get(curRow).get(curCol).Value)
            return;
        Cell cell = null;
        if(curRow + 1 < this.matrix.size() && this.matrix.get(curRow + 1).get(curCol).Value == lowest) {
            cell = this.matrix.get(curRow + 1).get(curCol);
        } if(curCol + 1 < this.matrix.get(curRow).size() && this.matrix.get(curRow).get(curCol + 1).Value == lowest) {
            cell = this.matrix.get(curRow).get(curCol + 1);
        } if(curCol - 1 >= 0 && this.matrix.get(curRow).get(curCol - 1).Value == lowest) {
            cell = this.matrix.get(curRow).get(curCol - 1);
        } if(curRow - 1 >= 0 && this.matrix.get(curRow - 1).get(curCol).Value == lowest) {
            cell = this.matrix.get(curRow - 1).get(curCol);
        }
        if(cell != null) {
            int order =  Math.min(cell.Order, this.matrix.get(curRow).get(curCol).Order);
            if(cell.Order != Integer.MAX_VALUE) {
                for(int i = 0; i < matrix.size(); i++) {
                    ArrayList<Cell> row = this.matrix.get(i);
                    for(int j = 0; j < row.size(); j++) {
                        if(row.get(j).Order == cell.Order || row.get(j).Order == this.matrix.get(curRow).get(curCol).Order)
                            row.get(j).Order = order;
                    }
                }
            }
            cell.Order = this.matrix.get(curRow).get(curCol).Order = order;
        }
    }

    private int findLowestValue(int curRow, int curCol) {
        int lowest = 10000;
        if(curRow + 1 < this.matrix.size() && this.matrix.get(curRow + 1).get(curCol).Value < lowest) {
            lowest = this.matrix.get(curRow + 1).get(curCol).Value;
        } if(curRow - 1 >= 0 && this.matrix.get(curRow - 1).get(curCol).Value < lowest) {
            lowest = this.matrix.get(curRow - 1).get(curCol).Value;
        } if(curCol + 1 < this.matrix.get(curRow).size() && this.matrix.get(curRow).get(curCol + 1).Value < lowest) {
            lowest = this.matrix.get(curRow).get(curCol + 1).Value;
        } if(curCol - 1 >= 0 && this.matrix.get(curRow).get(curCol - 1).Value < lowest) {
            lowest = this.matrix.get(curRow).get(curCol - 1).Value;
        }
        return lowest;
    }

    public void convertTolexicographicallyChar() {
        int currentCode = 97;
        for(int num = 1; num <= this.currentOrder; num++) {
            boolean flag = false;
            for(int i = 0; i < matrix.size(); i++) {
                ArrayList<Cell> row = this.matrix.get(i);
                for(int j = 0; j < row.size(); j++) {
                    if(row.get(j).Order == num) {
                        row.get(j).Letter = (char)currentCode;
                        flag = true;
                    }
                }
            }
            if(flag)
                currentCode++;
        }
    }

    public String toString() {
        String result = "";
        for(int i = 0; i < matrix.size(); i++) {
            ArrayList<Cell> row = this.matrix.get(i);
            for(int j = 0; j < row.size(); j++) {
                result += row.get(j).Letter + " ";
            }
            result = result.trim() + "\n";
        }
        return result;
    }
}
