import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.*;

public class problem {
	
	static Scanner console;
	static PrintStream printstream;

	public static void main(String[] args) throws FileNotFoundException {

		console = new Scanner(new File("input.txt"));
		printstream = new PrintStream(new File("output.txt"));
		int tn = console.nextInt();
		for (int ti = 0; ti < tn; ti++) {
			solve(ti+1);
		}
		console.close();
	}
	
	public static String rec(int n, int r, int p, int s, Queue<String> rq, Queue<String> pq, Queue<String> sq) {
		
		assert(r == rq.size());
		assert(p == pq.size());
		assert(s == sq.size());
		
		if (n <= 1) {
			if (r == 1) return rq.remove();
			if (p == 1) return pq.remove();
			if (s == 1) return sq.remove();
		}
		
		int rt, pt, st;
		
		rt = (r + s - p) / 2;
		pt = (r + p - s) / 2;
		st = (p + s - r) / 2;
		
		if (rt < 0 || pt < 0 || st < 0) {
			return "IMPOSSIBLE";
		}
	
		Queue<String> rqt = new LinkedList<String>();
		Queue<String> pqt = new LinkedList<String>();
		Queue<String> sqt = new LinkedList<String>();
		for (int i = 0; i < rt; i++) {
			String s1 = rq.remove();
			String s2 = sq.remove();
			
			rqt.add((s1+s2).compareTo(s2+s1) < 0 ? s1+s2: s2+s1);
		}
		for (int i = 0; i < pt; i++) {
			String s1 = pq.remove();
			String s2 = rq.remove();

			pqt.add((s1+s2).compareTo(s2+s1) < 0 ? s1+s2: s2+s1);
		}
		for (int i = 0; i < st; i++) {
			String s1 = pq.remove();
			String s2 = sq.remove();

			sqt.add((s1+s2).compareTo(s2+s1) < 0 ? s1+s2: s2+s1);
		}
		return rec(n / 2, rt, pt, st, rqt, pqt, sqt);
	}
	
	public static void solve(int tt) {
		int n = (int) Math.pow(2, console.nextInt());
		int r = console.nextInt();
		int p = console.nextInt();
		int s = console.nextInt();
		
		Queue<String> rq = new LinkedList<String>();
		for (int i = 0; i < r; i++) rq.add("R");
		Queue<String> pq = new LinkedList<String>();
		for (int i = 0; i < p; i++) pq.add("P");
		Queue<String> sq = new LinkedList<String>();
		for (int i = 0; i < s; i++) sq.add("S");
		
		printstream.println("Case #" + tt + ": " + rec(n, r, p, s, rq, pq, sq));
	}

}
