import java.util.Scanner;
import java.io.*;

public class B {

	public static boolean isValid(int x, int y, int W, int H) {
		if (x < 0 || y < 0)
			return false;
		else if (x >= W || y >= H)
			return false;
		else
			return true;
	}

	public static boolean isSolved(char[][] solution, int W, int H) {
		for (int y = 0; y < H; ++y) {
			for (int x = 0; x < W; ++x) {
				if (solution[y][x] == '0')
					return false;
			}
		}
		return true;
	}

	public static char getDirection(int current, int[] nwes) {
		int minimum = 10000;
		char ret = '0';
		// This eliminates ties too...
		if (nwes[3] <= minimum && nwes[3] != -1) {
			minimum = nwes[3];
			ret = 's';
		}
		if (nwes[2] <= minimum && nwes[2] != -1) {
			minimum = nwes[2];
			ret = 'e';
		}
		if (nwes[1] <= minimum && nwes[1] != -1) {
			minimum = nwes[1];
			ret = 'w';
		}
		if (nwes[0] <= minimum && nwes[0] != -1) {
			minimum = nwes[0];
			ret = 'n';
		}
		return ret;
	}

	public static void main(String[] args) throws FileNotFoundException {
		final String kFileName = "B-Small.in";
		int N;
		char[] alphabet = { 'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j',
				'k', 'l', 'm', 'n', 'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
				'w', 'x', 'y', 'z' };
		Scanner sc = new Scanner(new File(kFileName));
		// Scanner sc = new Scanner(System.in);

		// Populate N
		N = sc.nextInt();

		for (int i = 0; i < N; ++i) {
			int H = sc.nextInt();
			int W = sc.nextInt();
			int[][] data = new int[H][W];
			char[][] solution = new char[H][W];

			// Enter data into matrix and clear solution matrix
			for (int y = 0; y < H; ++y) {
				for (int x = 0; x < W; ++x) {
					data[y][x] = sc.nextInt();
					solution[y][x] = '0';
				}
			}

			// Identify and Mark Basins
			int currentLetter = 0;
			for (int y = 0; y < H; ++y) {
				for (int x = 0; x < W; ++x) {
					int validCount = 0;
					// Check North
					if (isValid(x, y - 1, W, H)) {
						if (data[y][x] <= data[y - 1][x]) {
							validCount = validCount + 1;
						}
					} else {
						validCount = validCount + 1;
					}
					// Check West
					if (isValid(x - 1, y, W, H)) {
						if (data[y][x] <= data[y][x - 1]) {
							validCount = validCount + 1;
						}
					} else {
						validCount = validCount + 1;
					}
					// Check East
					if (isValid(x + 1, y, W, H)) {
						if (data[y][x] <= data[y][x + 1]) {
							validCount = validCount + 1;
						}
					} else {
						validCount = validCount + 1;
					}
					// Check South
					if (isValid(x, y + 1, W, H)) {
						if (data[y][x] <= data[y + 1][x]) {
							validCount = validCount + 1;
						}
					} else {
						validCount = validCount + 1;
					}

					if (validCount == 4) {
						solution[y][x] = alphabet[currentLetter];
						currentLetter = currentLetter + 1;
					}
				}
			}

			// Extrap
			while (!(isSolved(solution, W, H))) {
				for (int y = 0; y < H; ++y) {
					for (int x = 0; x < W; ++x) {
						if (solution[y][x] == '0') {
							// Determine Direction of Travel
							int current = data[y][x];
							int[] nwes = new int[4];
							// Check North
							if (isValid(x, y - 1, W, H)) {
								nwes[0] = data[y - 1][x];
							} else {
								nwes[0] = -1;
							}
							// Check West
							if (isValid(x - 1, y, W, H)) {
								nwes[1] = data[y][x - 1];
							} else {
								nwes[1] = -1;
							}
							// Check East
							if (isValid(x + 1, y, W, H)) {
								nwes[2] = data[y][x + 1];
							} else {
								nwes[2] = -1;
							}
							// Check South
							if (isValid(x, y + 1, W, H)) {
								nwes[3] = data[y + 1][x];
							} else {
								nwes[3] = -1;
							}

							char dir = getDirection(current, nwes);
							
							if (dir == 'n' && solution[y-1][x] != '0') {
								solution[y][x] = solution[y-1][x];
							}
							if (dir == 'w' && solution[y][x-1] != '0') {
								solution[y][x] = solution[y][x-1];
							}
							if (dir == 'e' && solution[y][x+1] != '0') {
								solution[y][x] = solution[y][x+1];
							}
							if (dir == 's' && solution[y+1][x] != '0') {
								solution[y][x] = solution[y+1][x];
							}
						}
					}
				}
			}
			
			// Lexigraphic Order Check and Swap if Necessary
			String tracker = "";
			int[][] newOrder = new int[H][W];
			for (int y = 0; y < H; ++y) {
				for (int x = 0; x < W; ++x) {
					if(tracker.contains(solution[y][x] + "")) {
						newOrder[y][x] = tracker.indexOf(solution[y][x]);
					} else {
						tracker = tracker + solution[y][x];
						newOrder[y][x] = tracker.indexOf(solution[y][x]);
					}
				}
			}
			for (int y = 0; y < H; ++y) {
				for (int x = 0; x < W; ++x) {
					solution[y][x] = alphabet[newOrder[y][x]];
				}
			}			
			
			System.out.println("Case #" + (i+1) + ":");
			for (int y = 0; y < H; ++y) {
				for (int x = 0; x < W; ++x) {
					if (x != W-1)
						System.out.print(solution[y][x] + " ");
					else
						System.out.print(solution[y][x]);
				}
				System.out.println();
			}
		}
	}
}