import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class Translator {
	private int tests;
	private String[] inputs;
	public static String rootDir = System.getProperty("user.dir") + File.separator;
	public static String filesDir = rootDir + "files" + File.separator;


	public static void main(String[] args) {
		Translator t = new Translator("trans1.txt");
		// t.go();
		t.translate();
	}

	public Translator(String fileName) {
		Scanner input = null;
		try {
			input = new Scanner(new File(filesDir + "trans1.txt"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		tests = Integer.parseInt(input.nextLine());
		inputs = new String[tests];

		for (int i = 0; i < tests; i++)
			inputs[i] = input.nextLine();
		for (int i = 0; i < tests; i++)
			System.out.println((i+1) + ": " + inputs[i]);
//		for (String s : inputs)
//			System.out.println(s);
	}

	private void translate() {
		String s;
		String temp;

		try {
			FileWriter fw = new FileWriter(new File(filesDir
					+ "transAns.txt"));
			for (int i = 0; i < inputs.length; i++) {
				s = inputs[i];
				temp = "Case #" + (i + 1) + ": ";
				System.out.print(temp);
				fw.write(temp);
				for (int j = 0; j < s.length(); j++) {
					temp = getMappingOf(s.charAt(j)) + "";
					System.out.print(temp);
					fw.write(temp);
				}
				if (i != (inputs.length - 1)) {
					temp = "\n";
					System.out.print(temp);
					fw.write(temp);
				}
			}

			fw.close();
		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	private void go() {
		char start = 'a';
		FileWriter fw = null;
		try {
			fw = new FileWriter(new File(filesDir + "data.txt"));

			for (char i = 'a'; i <= 'z'; i++) {
				System.out.print(i + " " + getMappingOf(i) + " | "
						+ (i - getMappingOf(i)) + " | " + ((int) i) + " "
						+ ((int) getMappingOf(i)) + "\n");
				fw.write(((int) i) + " " + ((int) getMappingOf(i)) + "\n");
			}
			fw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}

	}

	// from googlerese to english
	private char getMappingOf(char c) {
		switch (c) {
		case 'a':
			return 'y';
		case 'b':
			return 'h';
		case 'c':
			return 'e';
		case 'd':
			return 's';
		case 'e':
			return 'o';
		case 'f':
			return 'c';
		case 'g':
			return 'v';
		case 'h':
			return 'x';
		case 'i':
			return 'd';
		case 'j':
			return 'u';
		case 'k':
			return 'i';
		case 'l':
			return 'g';
		case 'm':
			return 'l';
		case 'n':
			return 'b';
		case 'o':
			return 'k';
		case 'p':
			return 'r';
		case 'q':
			return 'z';
		case 'r':
			return 't';
		case 's':
			return 'n';
		case 't':
			return 'w';
		case 'u':
			return 'j';
		case 'v':
			return 'p';
		case 'w':
			return 'f';
		case 'x':
			return 'm';
		case 'y':
			return 'a';
		case 'z':
			return 'q';
		default:
			return ' ';
		}
	}
}
