package com.ehxm.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

public class Problem1 {

	public static class Intermed{ 
		public char[] pies;
		public String hash;
		public Intermed(char[] pies){
			this.pies = pies;
			hash = new String(pies);
		}
		
		public void flip(int size, int startIndex){
			for(int i=0; i<size; i++){
				pies[i+startIndex] = pies[i+startIndex]=='+'?'-':'+'; 
			}
			hash = new String(pies);
		}
		
		public boolean checkDone(){
			for(int i=0; i<pies.length; i++){
				if(pies[i]=='-'){
					return false;
				}
			}
			return true;
		}
		
		@Override
		public int hashCode() {
			//System.out.println(new String(pies) + "==>" + hash.hashCode());
			return hash.hashCode();
		}
		@Override
		public boolean equals(Object obj) {
			return hashCode() == obj.hashCode();
		}
		
		
		
		
		
	}
	
	public static void main(String[] args) {
		try {
			BufferedReader br = new BufferedReader(new FileReader(new File("A-small-attempt0.in")));
			BufferedWriter bw = new BufferedWriter(new FileWriter(new File("problem1_out.txt")));
			
			String input = br.readLine();
			int T = Integer.parseInt(input);
			for(int i=1; i<=T; i++){
				bw.write("Case #" + i + ": ");
				
				input = br.readLine();
				String[] token = input.split(" ");
				//System.out.println(token[0]);
				//System.out.println(token[1]);
				int size = Integer.parseInt(token[1]);
				int solved = solve(token[0], size);
				if(solved==-1){
					bw.write("IMPOSSIBLE\n");
				}
				else{
					bw.write(solved + "\n");
				}
				
			}
			
			
			bw.close();
			br.close();
			
			
			
			
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}

	}
	
	
	public static int solve(String problem, int size){
		int length = problem.length();
		
		Intermed interMed = new Intermed(problem.toCharArray());
		if(interMed.checkDone()){
			return 0;
		}
		
		Set<Intermed> checked = new HashSet<>();
		Set<Intermed> hasToCheck = new HashSet<>();
		checked.add(interMed);
		hasToCheck.add(interMed);
		boolean added = false;
		int flips = 0;
		do{
			added=false;
			flips++;
			System.out.println(flips+"=================================================================");
			Set<Intermed> next = new HashSet<>();
			for (Intermed _intermed : hasToCheck) {
				for(int i=0; i<=length-size; i++){
					Intermed _inter = new Intermed(_intermed.pies.clone());
					_inter.flip(size, i);
					
					System.out.println(new String(_inter.pies));
					
					if(_inter.checkDone()){
						return flips;
					}
					if(!checked.contains(_inter)){
						added=true;
						checked.add(_inter);
						next.add(_inter);
					}
				}
			}
			hasToCheck = next;			
			
		}while(added);	
		
		return -1;
	}

}
