package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class BathroomStalls {
    public String resolve(Scanner scanner) {
        int n = scanner.nextInt();
        int k = scanner.nextInt();
        if (n == k) {
            return "0 0";
        }
        
        TreeMap<Integer, Integer> map = new TreeMap<>();
        map.put(n, 1);
        int i = 0;
        while(true) {
        	int key = map.lastEntry().getKey();
        	int cnt = map.get(key);
        	int[] lens = split(key);
        	if(cnt >= k) return lens[0] + " " + lens[1];
        	k -= cnt;
        	map.remove(key);
        	map.put(lens[0], map.getOrDefault(lens[0], 0) + cnt);
        	map.put(lens[1], map.getOrDefault(lens[1], 0) + cnt);
        }
    }
    
    public int[] split(int len) {
    	if(len % 2 == 1) {
    		return new int[]{len/2, len/2};
    	}else {
    		return new int[]{len/2, len/2-1};
    	}
    }
    
    public static void main(String[] args) {
    	Scanner scanner = null;
        PrintWriter writer = null;
		try {
			scanner = new Scanner(new File("C-small-1-attempt0.in"));
			writer = new PrintWriter(new File("C-small-1-attempt0.out"));
			BathroomStalls exercise = new BathroomStalls();
	        
	        int cases = Integer.parseInt(scanner.nextLine());
	        for (int i = 0; i < cases; i++) {
	            System.out.println("Case #" + (i + 1) + ": ");
	            writer.println("Case #" + (i + 1) + ": " + exercise.resolve(scanner));
	        }
	        scanner.close();
	        writer.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
}
