package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

public class BathroomStalls {
    public String resolve(Scanner scanner) {
        long n = scanner.nextLong();
        long k = scanner.nextLong();
        if (n == k) {
            return "0 0";
        }
        
        TreeMap<Long, Long> map = new TreeMap<>();
        map.put(n, 1l);
        long i = 0;
        while(true) {
        	long key = map.lastEntry().getKey();
        	long cnt = map.get(key);
        	long[] lens = split(key);
        	if(cnt >= k) return lens[0] + " " + lens[1];
        	k -= cnt;
        	map.remove(key);
        	map.put(lens[0], map.getOrDefault(lens[0], 0l) + cnt);
        	map.put(lens[1], map.getOrDefault(lens[1], 0l) + cnt);
        }
    }
    
    public long[] split(long len) {
    	if(len % 2 == 1) {
    		return new long[]{len/2, len/2};
    	}else {
    		return new long[]{len/2, len/2-1};
    	}
    }
    
    public static void main(String[] args) {
    	Scanner scanner = null;
        PrintWriter writer = null;
		try {
			scanner = new Scanner(new File("C-large.in"));
			writer = new PrintWriter(new File("C-large.out"));
			BathroomStalls exercise = new BathroomStalls();
	        
	        int cases = Integer.parseInt(scanner.nextLine());
	        for (int i = 0; i < cases; i++) {
	            System.out.println("Case #" + (i + 1) + ": ");
	            writer.println("Case #" + (i + 1) + ": " + exercise.resolve(scanner));
	        }
	        scanner.close();
	        writer.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
}
