package codejam;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public final class OversizedPancakeFlipper {

    private String flip(String tmpStr, int k) {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < k; i++) {
            sb.append(tmpStr.charAt(i) == '+' ? '-' : '+');
        }
        sb.append(tmpStr.substring(k));
        return sb.toString();
    }

    private String removeFirstCakes(String str) {
        int pointer = 0;
        while (pointer < str.length() && str.charAt(pointer) == '+') {
            pointer++;
        }
        return str.substring(pointer);
    }

    public String resolve(Scanner scanner) {
        String cakeStr = scanner.next();
        int k = scanner.nextInt();
        int count = 0;
        String tmpStr = cakeStr;
        while (!tmpStr.isEmpty() && tmpStr.length() >= k) {
            tmpStr = removeFirstCakes(tmpStr);
            if (tmpStr.length() >= k) {
                count++;
                tmpStr = flip(tmpStr, k);
            }
        }
        return tmpStr.isEmpty() ? String.valueOf(count) : "IMPOSSIBLE";
    }
    
    public static void main(String[] args) {
    	Scanner scanner = null;
        PrintWriter writer = null;
		try {
			scanner = new Scanner(new File("A-small-attempt2.in"));
			writer = new PrintWriter(new File("A-small-attempt2.out"));
			OversizedPancakeFlipper exercise = new OversizedPancakeFlipper();
	        
	        int cases = Integer.parseInt(scanner.nextLine());
	        for (int i = 0; i < cases; i++) {
	            System.out.println("Case #" + (i + 1) + ": ");
	            writer.println("Case #" + (i + 1) + ": " + exercise.resolve(scanner));
	        }
	        scanner.close();
	        writer.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
    }
}
