import java.io.File;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class QualificationRoundC {
    public static void main(String[] args) throws Exception {
        int t;
        Scanner in = new Scanner(new File("/home/cata/workspace/gcj/C-large.in"));
        PrintStream out = new PrintStream(new File("C.out"));
        t = in.nextInt();
        final Quaternion finalResult = mul(Quaternion.I, Quaternion.J, Quaternion.K);
        for (int caseNumber = 1; caseNumber <= t; caseNumber++) {
            int L;
            L = in.nextInt();
            long X = in.nextLong();
            String s = in.next();

            Quaternion[] quaternions = toArray(s);
            Quaternion pow = pow(mul(quaternions), X);
            boolean solvable = pow == finalResult;
            if (solvable) {
                boolean iFound = false, jFound = false;
                Quaternion r = Quaternion.ONE;
                for (int i = 0; i < 8 && i < X && !jFound; i++) {
                    for (int j = 0; j < L && !jFound; j++) {
                        r = mul(r, quaternions[j]);
                        iFound |= r == Quaternion.I;
                        jFound = iFound && r == Quaternion.K;
                    }
                }
                solvable = jFound;
            }
            out.println("Case #" + caseNumber + ": " + (solvable ? "YES" : "NO"));
            System.out.println("Case #" + caseNumber + ": " + (solvable ? "YES" : "NO"));
        }

    }

    private static Quaternion mul(Quaternion... q) {
        Quaternion result = Quaternion.ONE;
        for (Quaternion next : q) {
            result = result.multiply(next);
        }
        return result;
    }

    private static Quaternion pow(Quaternion q, long p) {
        Quaternion r = Quaternion.ONE;
        for (int i = 0; i < p % 4; i++) {
            r = mul(r, q);
        }
        return r;
    }

    private static Quaternion[] toArray(String s) {
        Quaternion[] quaternions = new Quaternion[s.length()];
        for (int i = 0; i < s.length(); i++) {
            switch (s.charAt(i)) {
                case 'i':
                    quaternions[i] = Quaternion.I;
                    break;
                case 'j':
                    quaternions[i] = Quaternion.J;
                    break;
                case 'k':
                    quaternions[i] = Quaternion.K;
                    break;
            }
        }
        return quaternions;
    }

    private static final Map<Integer, Quaternion> QUATERNION_MAP;

    static {
        QUATERNION_MAP = new HashMap<>();
        QUATERNION_MAP.put(1, Quaternion.ONE);
        QUATERNION_MAP.put(2, Quaternion.I);
        QUATERNION_MAP.put(3, Quaternion.J);
        QUATERNION_MAP.put(4, Quaternion.K);
        QUATERNION_MAP.put(-1, Quaternion.MINUS_ONE);
        QUATERNION_MAP.put(-2, Quaternion.MINUS_I);
        QUATERNION_MAP.put(-3, Quaternion.MINUS_J);
        QUATERNION_MAP.put(-4, Quaternion.MINUS_K);
    }

    private enum Quaternion {
        ONE(1, "1"),
        I(2, "i"),
        J(3, "j"),
        K(4, "k"),
        MINUS_ONE(-1, "-1"),
        MINUS_I(-2, "-i"),
        MINUS_J(-3, "-j"),
        MINUS_K(-4, "-k");

        private final int value;
        private final String name;

        Quaternion(int value, String name) {
            this.value = value;
            this.name = name;
        }

        public Quaternion multiply(Quaternion q) {
            if (this.value < 0) {
                return QUATERNION_MAP.get(
                        -1 * QUATERNION_MAP.get(-value).multiply(q).value
                );
            }
            if (q.value < 0) {
                return QUATERNION_MAP.get(
                        -1 * multiply(QUATERNION_MAP.get(-q.value)).value
                );
            }

            if (this == ONE) {
                return q;
            }
            if (q == ONE) {
                return this;
            }

            if (this == q) {
                return MINUS_ONE;
            }

            if (this == I && q == J) {
                return K;
            }
            if (this == J && q == K) {
                return I;
            }
            if (this == K && q == I) {
                return J;
            }
            return QUATERNION_MAP.get(-q.multiply(this).value);
        }


        @Override
        public String toString() {
            return name;
        }
    }
}
