import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * Created by Catalin on 4/8/2017.
 */
public class ProblemA {
    private final Scanner in;
    private final PrintStream out;
    private final int instanceCount;

    public ProblemA(Scanner in, PrintStream out) {
        this.in = in;
        this.out = out;
        instanceCount = in.nextInt();
    }

    public static void main(String[] args) throws Exception {
        ProblemA problem = new ProblemA(new Scanner(new File("A-large.in")), new PrintStream("pancake.out"));
        problem.solve();
    }

    public void solve() {
        for (int testCase = 1; testCase <= instanceCount; testCase++) {
            out.print("Case #" + testCase + ": ");
            StringBuilder row = new StringBuilder(in.next());
            int k = in.nextInt();
            int flips = 0;
            for (int i = 0; i < row.length() - k; i++) {
                if (row.charAt(i) == '-') {
                    flips++;
                    for (int j = 0; j < k; j++) {
                        if (row.charAt(i + j) == '-') {
                            row.setCharAt(i + j, '+');
                        } else {
                            row.setCharAt(i + j, '-');
                        }
                    }
                }
            }
            boolean lastAreSame = true;
            for (int i = row.length() - k; i < row.length() - 1; i++) {
                lastAreSame &= (row.charAt(i) == row.charAt(row.length() - 1));
            }
            if (row.charAt(row.length() - 1) == '-') {
                flips++;
            }
            if (lastAreSame) {
                out.println(flips);
            } else {
                out.println("IMPOSSIBLE");
            }
        }
    }
}
