import java.io.File;
import java.io.PrintStream;
import java.util.Scanner;

/**
 * Created by Catalin on 4/8/2017.
 */
public class ProblemB {
    private final Scanner in;
    private final PrintStream out;
    private final int instanceCount;

    public ProblemB(Scanner in, PrintStream out) {
        this.in = in;
        this.out = out;
        instanceCount = in.nextInt();
    }

    public static void main(String[] args) throws Exception {
        ProblemB problem = new ProblemB(new Scanner(new File("B-large.in")), new PrintStream("src/numbers.out"));
        problem.solve();
    }

    public void solve() {
        for (int testCase = 1; testCase <= instanceCount; testCase++) {
            out.print("Case #" + testCase + ": ");
            StringBuilder s = new StringBuilder(in.next());
            int i = 1;
            while (i < s.length() && s.charAt(i) >= s.charAt(i - 1)) {
                i++;
            }
            if (i == s.length()) {
                out.println(s);
                continue;
            }
            for (int j = i; j < s.length(); j++) {
                s.setCharAt(j, '9');
            }
            char c = s.charAt(i - 1);
            int j = i - 1;
            while (j > 0 && s.charAt(j) == c && s.charAt(j - 1) == c) {
                s.setCharAt(j, '9');
                j--;
            }
            s.setCharAt(j, (char) (s.charAt(j) - 1));
            if (s.charAt(0) == '0') {
                s.deleteCharAt(0);
            }
            out.println(s);
        }
    }
}
