import java.io.File;
import java.io.PrintStream;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;

/**
 * Created by Catalin on 4/8/2017.
 */
public class ProblemC {
    private final Scanner in;
    private final PrintStream out;
    private final int instanceCount;

    public ProblemC(Scanner in, PrintStream out) {
        this.in = in;
        this.out = out;
        instanceCount = in.nextInt();
    }

    public static void main(String[] args) throws Exception {
        ProblemC problem = new ProblemC(new Scanner(new File("C-small-2-attempt0.in")), new PrintStream("src/stalls.out"));
        problem.solve();
    }

    public void solve() {
        for (int testCase = 1; testCase <= instanceCount; testCase++) {
            out.print("Case #" + testCase + ": ");
            int n, k;
            n = in.nextInt();
            k = in.nextInt();
            TreeMap<Integer, Integer> s = new TreeMap<>();
            s.put(n, 1);
            int a, b, x;
            for (int i = 1; i < k; i++) {
                Map.Entry<Integer, Integer> lastEntry = s.lastEntry();
                x = lastEntry.getKey();
                int count = lastEntry.getValue();
                if (count == 1) {
                    s.remove(lastEntry.getKey());
                } else {
                    s.put(x, count - 1);
                }
                a = (x - 1) / 2;
                b = x - 1 - a;
                if (s.containsKey(a)) {
                    s.put(a, s.get(a) + 1);
                } else {
                    s.put(a, 1);
                }
                if (s.containsKey(b)) {
                    s.put(b, s.get(b) + 1);
                } else {
                    s.put(b, 1);
                }
            }
            x = s.lastKey();
            a = (x - 1) / 2;
            b = x - 1 - a;
            out.println(b + " " + a);
        }
    }
}
