import java.io.File;
import java.io.PrintStream;
import java.util.*;

/**
 * Created by Catalin on 4/8/2017.
 */
public class ProblemB {
    private final Scanner in;
    private final PrintStream out;
    private final int instanceCount;

    public ProblemB(Scanner in, PrintStream out) {
        this.in = in;
        this.out = out;
        instanceCount = in.nextInt();
    }

    public static void main(String[] args) throws Exception {
        ProblemB problem = new ProblemB(new Scanner(new File("B-small-attempt0.in")), new PrintStream("src/unicorns.out"));
        problem.solve();
    }

    public void solve() {
        for (int testCase = 1; testCase <= instanceCount; testCase++) {
            out.print("Case #" + testCase + ": ");
            int n = in.nextInt();
            int r, o, y, g, b, v;
            r = in.nextInt();
            o = in.nextInt();
            y = in.nextInt();
            g = in.nextInt();
            b = in.nextInt();
            v = in.nextInt();
            StringBuilder s = new StringBuilder(n);
            while (r > 0 || y > 0 || b > 0) {
                if (r > 0) {
                    s.append('R');
                    r--;
                }
                if (y > 0) {
                    s.append('Y');
                    y--;
                }
                if (b > 0) {
                    s.append('B');
                    b--;
                }
            }
            boolean possible = true;
            for (int i = 1; i < s.length(); i++) {
                if (s.charAt(i) == s.charAt(i - 1)) {
                    possible = false;
                }
            }
            if (s.charAt(0) == s.charAt(s.length() - 1)) {
                possible = false;
            }
            out.println(possible ? s : "IMPOSSIBLE");
        }
    }
}
