import java.io.File;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class ProblemB {
    private final Title[] titles;

    public ProblemB(Title[] titles) {
        this.titles = titles;
    }

    public int solution() {
        int result = 0;
        Map<String, Integer> count1 = new HashMap<>();
        Map<String, Integer> count2 = new HashMap<>();
        for (Title title : titles) {
            incCount(count1, title.s1);
            incCount(count2, title.s2);
        }
        for (Title title : titles) {
            if (count1.get(title.s1) > 1 && count2.get(title.s2) > 1) {
                result++;
            }
        }
        return result;
    }

    private void incCount(Map<String, Integer> map, String s) {
        Integer integer = map.get(s);
        if (integer == null) {
            map.put(s, 1);
        } else {
            map.put(s, 1 + integer);
        }
    }

    public static void main(String[] args) throws Exception {
//        Scanner in = new Scanner(System.in);
//        PrintStream out = System.out;
        Scanner in = new Scanner(new File("B.in"));
        PrintStream out = new PrintStream("B.out");
        int TOTAL_TESTS = in.nextInt();
        for (int t = 1; t <= TOTAL_TESTS; t++) {
            int n = in.nextInt();
            Title[] titles = new Title[n];
            for (int i = 0; i < n; i++) {
                titles[i] = new Title(in.next(), in.next());
            }
            out.println("Case #" + t + ": " + new ProblemB(titles).solution());
        }
    }

    private static class Title {
        final String s1, s2;

        private Title(String s1, String s2) {
            this.s1 = s1;
            this.s2 = s2;
        }
    }

}
