import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class ProblemA {
    private final int p[];
    private final int total;

    public ProblemA(int[] p) {
        this.p = p;
        int t = 0;
        for (int x : p) {
            t += x;
        }
        total = t;
    }


    public String solution() {
        String result = "";
        int evacuated = 0;
        while (evacuated < total) {
            int max = 0;
            List<Integer> maxCount = new ArrayList<>();
            for (int i = 0; i < p.length; i++) {
                int party = p[i];
                if (max == party) {
                    maxCount.add(i);
                } else if (party > max) {
                    max = party;
                    maxCount.clear();
                    maxCount.add(i);
                }
            }
            if (maxCount.size() == 1 || (max == 1 && maxCount.size() == 3)) {
                if (!result.isEmpty()) {
                    result += " ";
                }
                p[maxCount.get(0)]--;
                result += toChar(maxCount.get(0));
                evacuated++;
            } else if (maxCount.size() >= 2) {
                if (!result.isEmpty()) {
                    result += " ";
                }
                p[maxCount.get(0)]--;
                p[maxCount.get(1)]--;
                result += toChar(maxCount.get(0));
                result += toChar(maxCount.get(1));
                evacuated += 2;
            }
        }
        return result;
    }

    private char toChar(int party) {
        return (char) ('A' + party);
    }

    public static void main(String[] args) throws Exception {
        Scanner in = new Scanner(new File("A.in"));
//        PrintStream out = System.out;
        PrintStream out = new PrintStream("A.out");
        int TOTAL_TESTS = in.nextInt();
        for (int t = 1; t <= TOTAL_TESTS; t++) {
            int n = in.nextInt();
            int p[] = new int[n];
            for (int i = 0; i < p.length; i++) {
                p[i] = in.nextInt();
            }
            out.println("Case #" + t + ": " + new ProblemA(p).solution());
        }
    }

}
