package google.codejam;

import java.io.*;
import java.util.ArrayList;
import java.util.List;

/**
 * Created by on 4/9/16.
 */
public class JamCoin {

    private static int findNontrivialDivisor(int n){
        for ( int d = 2 ; d * d <= n; ++d ){
            if ( n%d == 0){
                return d;
            }
        }
        return -1;
    }

    private static int interpreteValue(String numStr, int base){
        int val = (int) (Math.pow(base,numStr.length()-1) + 1);
        for ( int i = 1; i < numStr.length()-1; ++i ){
            if ( numStr.charAt(i)=='1' ){
                val += (int) Math.pow(base,numStr.length()-i);
            }
        }
        return val;
    }

    private static List<String> produceCandidateCoins(int len){
        //Generate candidate
        //start with 1 ending with 1
        //1...000...1
        String startNum = "1000000000000001";

        List<String> coins = new ArrayList<>();
        coins.add("");
        int i = 0;
        while ( i!=len-2){
            List<String> newCoins = new ArrayList<>();
            for ( String coin : coins){
                newCoins.add(coin+"1");
                newCoins.add(coin+"0");
            }
            coins = newCoins;
            ++i;
        }
        List<String> output = new ArrayList<>();
        for ( String coin : coins ){
            output.add("1"+coin+"1");
        }
        //Collections.reverse(output);
        return output;
    }

    public static List<List<String>> computeOutput(int count, int len ){

        List<String> candidates = produceCandidateCoins(len);
        List<List<String>> output = new ArrayList<>();
        for( String cand : candidates){
            List<String> row = new ArrayList<>();
            row.add(cand);
            List<Integer> divs = new ArrayList<>();
            for ( int base = 2; base <= 10; ++base){
                int resVal = interpreteValue(cand,base);
                int div = findNontrivialDivisor(resVal);
                if ( div == -1){
                    break;
                }else{
                    divs.add(div);
                }
            }
            if (divs.size() == 9){
                String divStr = "";
                for ( Integer d : divs ){
                    divStr+=String.valueOf(d);
                    divStr+=" ";
                }
                row.add(divStr.trim());
                output.add(row);
            }
            if ( output.size() == count){
                break;
            }
        }
        return output;

    }


    public static void main(String[] args) {
        //System.out.println(findNontrivialDivisor(217));

        //System.out.println(produceCandidateCoins(16));

        System.out.println(interpreteValue("1001",4));

        //System.out.println(computeOutput(3,6));


        try (BufferedReader br = new BufferedReader(new FileReader(new File("./resources/B-large-practice.in")));
             BufferedWriter bw = new BufferedWriter(new FileWriter(new File("./output/C-small-practice.out")))
        ) {
            String caseNumberLine = br.readLine();
            int caseNum = Integer.valueOf(caseNumberLine.trim());
            long start = System.currentTimeMillis();
            for (int i = 1; i <= 1; ++i) {
                String ouputLine = String.format("Case #%d:\n",i);
                bw.write(ouputLine);
                List<List<String>> result = computeOutput(50,16);
                for ( List<String> res : result){
                    String line = "";
                    line +=res.get(0);
                    line +=" ";
                    line +=res.get(1);
                    line +="\n";
                    bw.write(line);
                }
            }
            long end = System.currentTimeMillis();
            System.out.println(end - start);
        } catch (IOException e) {
            e.printStackTrace();
        }


    }

}
