package google.code.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.Map;

/**
 * Created on 4/8/16.
 */
public class RevengePancakes {

    static Map<String,Integer> countMemory = new HashMap<>();
    static Map<String,Integer> reversedCountMemory = new HashMap<>();

    public static int countMinFlips(String cakes, boolean isReversed){
        if (countMemory.containsKey(cakes) && !isReversed){
            return countMemory.get(cakes);
        } else if ( reversedCountMemory.containsKey(cakes) && isReversed){
            return reversedCountMemory.get(cakes);
        } else if ( cakes.isEmpty()){
            return 0;
        }

        int count = 0;
        int idx = cakes.length()-1;
        while (idx >= 0 && ((cakes.charAt(idx) == '+' && !isReversed) || (cakes.charAt(idx)=='-' && isReversed))){
            --idx;
        }

        if ( idx >= 0 ) {
            count += (1 + countMinFlips(cakes.substring(0, idx + 1), !isReversed));
        }
        if ( isReversed ){
            reversedCountMemory.put(cakes,count);
        }else{
            countMemory.put(cakes,count);
        }
        return count;
    }

    public static void main(String[] args ) throws Exception {

        System.out.println(countMinFlips("+",false));

        try (BufferedReader br = new BufferedReader(new FileReader(new File("./input/B-small-attempt0.in.txt")));
             BufferedWriter bw = new BufferedWriter(new FileWriter(new File("./output/B-small-attempt0.out.txt")))) {
            String firstLine = br.readLine();
            int numTCs = Integer.valueOf(firstLine);
            for ( int i = 1; i <= numTCs; ++i ){
                String input = br.readLine();
                String outputLine  = String.format("Case #%d: %d\n",i,countMinFlips(input,false));
                bw.write(outputLine);
            }
        }


    }


}
