import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class TicTacToe {
	
	
	public void read(String fromFile, String toFile) {
		try {

            FileReader fileReader = new FileReader(fromFile);
            FileWriter fileWriter = new FileWriter(toFile);
            String line = null;
            // Always wrap FileReader in BufferedReader.
            BufferedReader bufferedReader = 
                new BufferedReader(fileReader);
            BufferedWriter bufferedWriter = 
                    new BufferedWriter(fileWriter);
            int count = Integer.parseInt(bufferedReader.readLine());
            for(int i=1; i<=count; i++) {
            	char[][] board = new char[4][4];
            	for(int j=0; j<4; j++) {
	                if((line = bufferedReader.readLine()) != null) {
	                    board[j] = line.toCharArray();
	                }
            	}
            	bufferedWriter.write("Case #" + i + ": " + checkResult(board));
            	bufferedWriter.newLine();
            	bufferedReader.readLine();
            }

            bufferedReader.close();
            bufferedWriter.close();
            fileReader.close();
            fileWriter.close();
            
		 } catch (FileNotFoundException e) {
		        System.err.println("FileStreamsReadnWrite: " + e);
		 } catch (IOException e) {
		        System.err.println("FileStreamsReadnWrite: " + e);
		 }
	}
	
	public String checkResult(char[][] board) {
		if(checkIfWon(board, 'X'))return "X won";
		if(checkIfWon(board, 'O'))return "O won";
		for(int i=0; i<4; i++) {
			for(int j=0; j<4; j++) {
				if(board[i][j] == '.') {
					return "Game has not completed";
				}
			}
		}
		return "Draw";
	}
	
	public boolean checkIfWon(char[][] board, char toWin) {
		for(int i=0; i<4; i++) {
			if(board[i][0] == toWin && board[i][1] == toWin
					&& board[i][2] == toWin && board[i][3] == toWin) return true;
			if(board[i][0] == 'T' && board[i][1] == toWin
					&& board[i][2] == toWin && board[i][3] == toWin) return true;
			if(board[i][0] == toWin && board[i][1] == 'T'
					&& board[i][2] == toWin && board[i][3] == toWin) return true;
			if(board[i][0] == toWin && board[i][1] == toWin
					&& board[i][2] == 'T' && board[i][3] == toWin) return true;
			if(board[i][0] == toWin && board[i][1] == toWin
					&& board[i][2] == toWin && board[i][3] == 'T') return true;
		}
		for(int i=0; i<4; i++) {
			if(board[0][i] == toWin && board[1][i] == toWin
					&& board[2][i] == toWin && board[3][i] == toWin) return true;
			if(board[0][i] == 'T' && board[1][i] == toWin
					&& board[2][i] == toWin && board[3][i] == toWin) return true;
			if(board[0][i] == toWin && board[1][i] == 'T'
					&& board[2][i] == toWin && board[3][i] == toWin) return true;
			if(board[0][i] == toWin && board[1][i] == toWin
					&& board[2][i] == 'T' && board[3][i] == toWin) return true;
			if(board[0][i] == toWin && board[1][i] == toWin
					&& board[2][i] == toWin && board[3][i] == 'T') return true;
		}
		if(board[0][0] == toWin && board[1][1] == toWin
				&& board[2][2] == toWin && board[3][3] == toWin) return true;
		if(board[0][0] == 'T' && board[1][1] == toWin
				&& board[2][2] == toWin && board[3][3] == toWin) return true;
		if(board[0][0] == toWin && board[1][1] == 'T'
				&& board[2][2] == toWin && board[3][3] == toWin) return true;
		if(board[0][0] == toWin && board[1][1] == toWin
				&& board[2][2] == 'T' && board[3][3] == toWin) return true;
		if(board[0][0] == toWin && board[1][1] == toWin
				&& board[2][2] == toWin && board[3][3] == 'T') return true;
		
		if(board[0][3] == toWin && board[1][2] == toWin
				&& board[2][1] == toWin && board[3][0] == toWin) return true;
		if(board[0][3] == 'T' && board[1][2] == toWin
				&& board[2][1] == toWin && board[3][0] == toWin) return true;
		if(board[0][3] == toWin && board[1][2] == 'T'
				&& board[2][1] == toWin && board[3][0] == toWin) return true;
		if(board[0][3] == toWin && board[1][2] == toWin
				&& board[2][1] == 'T' && board[3][0] == toWin) return true;
		if(board[0][3] == toWin && board[1][2] == toWin
				&& board[2][1] == toWin && board[3][0] == 'T') return true;
		return false;
	}
	
	public static void main(String args[]) {
		TicTacToe ttt = new TicTacToe();
		ttt.read("C://temp/A-small-attempt0.in", "C://temp/A-small-attempt0.out");
	}

}
