import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class FairNSquare {

	public void read(String fromFile, String toFile) {
		try {

            FileReader fileReader = new FileReader(fromFile);
            FileWriter fileWriter = new FileWriter(toFile);
            String line = null;
            // Always wrap FileReader in BufferedReader.
            BufferedReader bufferedReader = 
                new BufferedReader(fileReader);
            BufferedWriter bufferedWriter = 
                    new BufferedWriter(fileWriter);
            int count = Integer.parseInt(bufferedReader.readLine());
            for(int i=1; i<=count; i++) {
                if((line = bufferedReader.readLine()) != null) {
                    String[] strs = line.split(" ");
                    int start = Integer.parseInt(strs[0]);
                    int end = Integer.parseInt(strs[1]);
                	bufferedWriter.write("Case #" + i + ": " + count(start, end));
                	bufferedWriter.newLine();
                }
            }

            bufferedReader.close();
            bufferedWriter.close();
            fileReader.close();
            fileWriter.close();
            
		 } catch (FileNotFoundException e) {
		        System.err.println("FileStreamsReadnWrite: " + e);
		 } catch (IOException e) {
		        System.err.println("FileStreamsReadnWrite: " + e);
		 }
	}
	
	public int count(int start, int end) {
		int a = (int) Math.ceil(Math.sqrt(start));
		int b = (int) Math.sqrt(end);
		int result = 0;
		for(int i=a; i<=b; i++) {
			if(isPalindrome(i) && isPalindrome(i*i)) {
				result++;
			}
		}
		return result;
	}
	
    public boolean isPalindrome(int x) {
        if(x < 0) return false;
        int base = 1;
        while(x/base >= 10) {
            base *= 10;
        }
        while(x > 0) {
            int first = x/base;
            int last = x%10;
            if(first != last) {
                return false;
            }
            x -= base*first;
            x /= 10;
            base /= 100;
        }
        return true;
     }
	
	public static void main(String args[]) {
		FairNSquare fns = new FairNSquare();
		fns.read("C://temp/C-small-attempt0.in", "C://temp/C-small-attempt0.out");
	}
}
