import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;

/**
 * 
 */

/**
 * @author pR
 * 
 */
public class BotTrust {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 2) {
			System.out.println("Command: java BotTrust <InputFile> <OutputFile>");
			return;
		}

		BotTrust test = new BotTrust();
		ArrayList<String> result = null;
		try {
			result = test.execute(args[0]);
			test.save(result, args[1]);
		} catch (Exception e) {
			System.out.println("Exception message: " + e.getMessage());
			e.printStackTrace();
		}
	}

	public synchronized ArrayList<String> execute(String data) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(data)));
		try {
			String line = br.readLine();

			if (null == line || line.equals("")) {
				throw new Exception("Invalid Input Data");
			}

			int numTC = Integer.parseInt(line);
			ArrayList<String> result = new ArrayList<String>(numTC);

			for (int i = 0; i < numTC; ++i) {
				line = br.readLine();
				String[] elements = line.split(" ");

				if (1 != elements.length % 2)
					throw new Exception("Invalid Test Case Line");

				final int nb = Integer.parseInt(elements[0]);

				if (nb << 1 != elements.length - 1)
					throw new Exception("Invalid Button Number");

				int[] btseq = new int[nb];
				int[] rbseq = new int[nb];
				int[] rbpos = new int[] { 1, 1 };
				ArrayList<Integer>[] rb = new ArrayList[2];
				rb[0] = new ArrayList<Integer>();
				rb[1] = new ArrayList<Integer>();
				for (int eIdx = 1; eIdx < elements.length; eIdx += 2) {
					rbseq[eIdx >> 1] = "O".equals(elements[eIdx]) ? 0 : 1;
					btseq[eIdx >> 1] = Integer.parseInt(elements[eIdx + 1]);
					rb[rbseq[eIdx >> 1]].add(btseq[eIdx >> 1]);
				}

				int btIdx = 0;
				int cost = 0;
				int move = 0;
				int p = 0;
				while (btIdx < nb) {
					if (rb[0].isEmpty() || rb[1].isEmpty()) {
						p = (rb[0].isEmpty() ? 1 : 0);
						for (int remain = 0; remain < rb[p].size(); ++remain) {
							cost += rb[p].get(remain) > rbpos[p] ? rb[p].get(remain)
									- rbpos[p]
									: rbpos[p] - rb[p].get(remain);
							rbpos[p] = rb[p].get(remain);
							cost++;
						}
						break;
					}
					cost++;
					move = 0;
					for (p = 0; p < 2; ++p) {
						if (rbpos[p] != rb[p].get(0)) {
							// move on
							rbpos[p] = rb[p].get(0) > rbpos[p] ? rbpos[p] + 1
									: rbpos[p] - 1;
						} else if (rbseq[btIdx] == p) {
							// remove pushed button
							rb[p].remove(0);
							move = 1;
						}
					}
					btIdx += move;
				}
				result.add("Case #" + (i + 1) + ": " + cost + "\n");
			}
			return result;
		} finally {
			br.close();
		}
	}

	public void save(ArrayList<String> result, String filename)
			throws Exception {
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename)));
		for (int i = 0; i < result.size(); ++i)
			bw.write(result.get(i));
		bw.close();
	}
}
