import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * 
 */

/**
 * @author pR
 * 
 */
public class Candy {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 2) {
			System.out.println("Command: java BotTrust <InputFile> <OutputFile>");
			return;
		}

		Candy test = new Candy();
		ArrayList<String> result = null;
		try {
			result = test.execute(args[0]);
			int i = test.add(5, 6);
			i = test.add(i, 3);
			test.save(result, args[1]);
		} catch (Exception e) {
			System.out.println("Exception message: " + e.getMessage());
			e.printStackTrace();
		}
		System.out.println("Done");
	}
	
	private int add(int a, int b) {
		int bitCount = Integer.toBinaryString(a > b ? b : a).length();
		int mask = ~((0xFFFFFFFF >> bitCount) << bitCount);
		int left = ((a > b ? a : b) >> bitCount) << bitCount;
		int ma = (a & mask);
		int mb = (b & mask);
		return left + ~(~ma ^ mb);
	}
	
	public ArrayList<String> execute(String data) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(data)));
		try {
			String line = br.readLine();

			if (null == line || line.equals("")) {
				throw new Exception("Invalid Input Data");
			}

			int numTC = Integer.parseInt(line);
			ArrayList<String> result = new ArrayList<String>(numTC);
			
			for (int TCIndex = 0; TCIndex < numTC; ++TCIndex) {
				final int numCandy = Integer.parseInt(br.readLine());
				String[] strval = br.readLine().split(" ");
				int[] val = new int[strval.length];
				if (numCandy != val.length)
					throw new Exception("Invalid Candy Number");
				
				
				int flag = 0;
				for (int vIndex = 0; vIndex < val.length; ++vIndex) {
					val[vIndex] = Integer.parseInt(strval[vIndex]);
					if (vIndex == 0)
						flag = val[vIndex];
					else
						flag ^= val[vIndex];
				}
				
				String output = "Case #" + (TCIndex + 1) + ": ";
				if (0 != flag) {
					output += "NO\n";
				} else {
					Arrays.sort(val);
					int total = 0;
					for (int i = 1; i < val.length; ++i)
						total += val[i];
					output += total + "\n";
				}
				
				result.add(output);
			}
			return result;
		} finally {
			br.close();
		}
	}

	public void save(ArrayList<String> result, String filename)
			throws IOException {
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename)));
		for (int i = 0; i < result.size(); ++i)
			bw.write(result.get(i));
		bw.close();
	}
}
