import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.HashMap;

/**
 * 
 */

/**
 * @author pR
 * 
 */
public class Magicka {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 2) {
			System.out.println("Command: java BotTrust <InputFile> <OutputFile>");
			return;
		}

		Magicka test = new Magicka();
		ArrayList<String> result = null;
		try {
			result = test.execute(args[0]);
			test.save(result, args[1]);
		} catch (Exception e) {
			System.out.println("Exception message: " + e.getMessage());
			e.printStackTrace();
		}
		System.out.println("Done");
	}

	public ArrayList<String> execute(String data) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(data)));
		try {
			String line = br.readLine();

			if (null == line || line.equals("")) {
				throw new Exception("Invalid Input Data");
			}

			int numTC = Integer.parseInt(line);
			ArrayList<String> result = new ArrayList<String>(numTC);

			for (int TCIndex = 0; TCIndex < numTC; ++TCIndex) {
				line = br.readLine();
				if (null == line || line.equals("")) {
					throw new Exception("Invalid Input Data");
				}

				String[] element = line.split(" ");
				if (0 == element.length)
					return null;

				int marker = 0;
				int numBase = Integer.parseInt(element[marker++]);
				HashMap<String, Character> base = new HashMap<String, Character>(numBase << 1);
				for (int index = 0; index < numBase; ++index) {
					base.put(element[marker + index].substring(0, 2), element[marker
							+ index].charAt(2));
					base.put(element[marker + index].charAt(1) + ""
							+ element[marker + index].charAt(0), element[marker
							+ index].charAt(2));
				}
				marker += numBase;

				int numOpps = Integer.parseInt(element[marker++]);
				HashMap<Character, Character> opps = new HashMap<Character, Character>(numOpps << 1);
				for (int index = 0; index < numOpps; ++index) {
					opps.put(element[marker + index].charAt(0), element[marker
							+ index].charAt(1));
					opps.put(element[marker + index].charAt(1), element[marker
							+ index].charAt(0));
				}
				marker += numOpps;
				final int datalen = Integer.parseInt(element[marker++]);
				String input = element[marker];
				if (datalen != element[marker].length())
					throw new Exception("Oops, why isn't datalen equal to input length?");

				// start process
				StringBuffer temp = new StringBuffer();
				for (int index = 0; index < input.length(); ++index) {
					// check combine
					if (0 != temp.length()) {
						String key = temp.charAt(temp.length() - 1) + "" + input.charAt(index);
						if (base.containsKey(key)) {
							temp.setLength(temp.length() - 1);
							temp.append(base.get(key));
							continue;
						}
					}
					
					// check opposite
					if (opps.containsKey(input.charAt(index))) {
						if (-1 != temp.indexOf("" + opps.get(input.charAt(index)))) {
							temp.setLength(0);
							continue;
						}
					}
					
					temp.append(input.charAt(index));
				}

				String output = "Case #" + (TCIndex + 1) + ": [";
				for (int index = 0; index < temp.length(); ++index) {
					output += temp.charAt(index)
							+ (index == temp.length() - 1 ? "" : ", ");
				}
				output += "]\n";
				result.add(output);
			}
			return result;
		} finally {
			br.close();
		}
	}

	public void save(ArrayList<String> result, String filename)
			throws IOException {
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename)));
		for (int i = 0; i < result.size(); ++i)
			bw.write(result.get(i));
		bw.close();
	}
}
