import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;

/**
 * 
 */

/**
 * @author pR
 * 
 */
public class Harmony {
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 2) {
			System.out.println("Command: java BotTrust <InputFile> <OutputFile>");
			return;
		}

		Harmony test = new Harmony();
		ArrayList<String> result = null;
		try {
			result = test.execute(args[0]);
			test.save(result, args[1]);
		} catch (Exception e) {
			System.out.println("Exception message: " + e.getMessage());
			e.printStackTrace();
		}
		System.out.println("Done");
	}

	public ArrayList<String> execute(String data) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(data)));
		try {
			String line = br.readLine();

			if (null == line || line.equals("")) {
				throw new Exception("Invalid Input Data");
			}

			int numTC = Integer.parseInt(line);
			ArrayList<String> result = new ArrayList<String>(numTC);
			for (int TCIndex = 0; TCIndex < numTC; ++TCIndex) {
				String[] line1 = br.readLine().split(" ");
				String[] line2 = br.readLine().split(" ");
				long others = Long.parseLong(line1[0]);
				long Low = Long.parseLong(line1[1]);
				long High = Long.parseLong(line1[2]);
				if (others != line2.length)
					throw new Exception("Incorrect number");
				
				long[] notes = new long[line2.length];
				for (int i = 0; i < others; ++i)
					notes[i] = Long.parseLong(line2[i]);
				
				long num = check(Low, High, notes);
				
				String output = "Case #" + (TCIndex + 1) + ": ";
				
				if (-1 != num)
					output += num + "\n";
				else
					output += "NO\n";
				
				System.out.print(output);
				result.add(output);
			}
			return result;
		} finally {
			br.close();
		}
	}

	private long check(long low, long high, long[] notes) {
		for (long n = low; n <= high; ++n) {
			boolean find = true;
			for (int i = 0; i < notes.length; ++i) {
				if (n > notes[i] && n % notes[i] != 0) {
					find = false;
					break;
				} else if (n < notes[i] && notes[i] % n != 0) {
					find = false;
					break;
				}
			}
			if (find)
				return n;
		}
		return -1;
	}

	public void save(ArrayList<String> result, String filename)
			throws IOException {
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename)));
		for (int i = 0; i < result.size(); ++i)
			bw.write(result.get(i));
		bw.close();
	}
}
