import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Arrays;

/**
 * 
 */

/**
 * @author pR
 * 
 */
public class GoroSort {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		if (args.length != 2) {
			System.out.println("Command: java BotTrust <InputFile> <OutputFile>");
			return;
		}

		GoroSort test = new GoroSort();
		ArrayList<String> result = null;
		try {
			result = test.execute(args[0]);
			test.save(result, args[1]);
		} catch (Exception e) {
			System.out.println("Exception message: " + e.getMessage());
			e.printStackTrace();
		}
		System.out.println("Done");
	}

	public ArrayList<String> execute(String data) throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(new FileInputStream(data)));
		try {
			String line = br.readLine();

			if (null == line || line.equals("")) {
				throw new Exception("Invalid Input Data");
			}

			int numTC = Integer.parseInt(line);
			ArrayList<String> result = new ArrayList<String>(numTC);
			for (int TCIndex = 0; TCIndex < numTC; ++TCIndex) {
				final int num = Integer.parseInt(br.readLine());
				String[] strelem = br.readLine().split(" ");
				if (num != strelem.length)
					throw new Exception("Invalid Element Number");
				
				int[] elem = new int[num];
				int[] sortedElem = new int[num];
				for (int index = 0; index < num; ++index) {
					elem[index] = Integer.parseInt(strelem[index]);
					sortedElem[index] = elem[index];
				}
				Arrays.sort(sortedElem);
				
				int cost = 0;
				int pos = 0;
				for (int index = 0; index < num; ) {
					if (elem[index] != sortedElem[index]) {
						pos = Arrays.binarySearch(sortedElem, elem[index]);
						elem[index] = elem[pos];
						elem[pos] = sortedElem[pos];
						cost++;
					} else
						index++;
				}
				String output = "Case #" + (TCIndex + 1) + ": " + (cost << 1) + "\n";
				result.add(output);
			}
			return result;
		} finally {
			br.close();
		}
	}

	public void save(ArrayList<String> result, String filename)
			throws IOException {
		BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(filename)));
		for (int i = 0; i < result.size(); ++i)
			bw.write(result.get(i));
		bw.close();
	}
}
