import java.util.*;

// Problem A. Tic-Tac-Toe-Tomek
class ProblemA {
	public static void main (String [] args) {
		Scanner in = new Scanner( System.in );
		int nCases = in.nextInt();
		for( int i = 0; i < nCases; i ++ ) {
			char [][] mat = new char[4][4];
			for( int row=0; row<4; row++ ) {
				String rowString = in.next();
				for( int col=0; col<4; col++ ) {
					mat[row][col] = rowString.charAt(col);
				}
			}

			boolean playerX = ( searchRows( mat, 'X' ) || 
				searchCols( mat, 'X' ) || 
				searchInDiagonalA( mat, 'X' ) || 
				searchInDiagonalB( mat, 'X' ) );
			
			boolean playerO = ( searchRows( mat, 'O' ) || 
				searchCols( mat, 'O' ) || 
				searchInDiagonalA( mat, 'O' ) || 
				searchInDiagonalB( mat, 'O' ) );
			
			if( playerX == playerO ) {
				if( notCompleted(mat) ) {
					System.out.println( "Case #" + (i+1) + ": Game has not completed" );
				} else {
					System.out.println( "Case #" + (i+1) + ": Draw" );
				}
			} else if( playerX ) {
				System.out.println( "Case #" + (i+1) + ": X won" );
			} else {
				System.out.println( "Case #" + (i+1) + ": O won" );
			}
			
		}
	}
	
	public static boolean notCompleted( char [][] mat ) {
		for( int row=0; row<4; row++ ) {
			for( int col=0; col<4; col++ ) {
				if( mat[row][col] == '.' ) {
					return true;
				}
			}
		}
		return false;
	}
	
	public static boolean searchRows(  char [][] mat, char player ) {
		for( int row=0; row<4; row++ ) {
			if( searchInRow( mat, row, player ) ) {
				return true;
			}
		}
		return false;
	}
	
	public static boolean searchInRow( char [][] mat, int row, char player ) {
		for( int col=0; col<4; col++ ) {
			if( ( mat[row][col] != player && mat[row][col] != 'T' ) ) {
				return false;
			}
		}
		return true;
	}
	
	public static boolean searchCols( char [][] mat, char player ) {
		for( int col=0; col<4; col++ ) {
			if( searchInCol( mat, col, player ) ) {
				return true;
			}
		}
		return false;
	}
	
	public static boolean searchInCol( char [][] mat, int col, char player ) {
		for( int row=0; row<4; row++ ) {
			if( ( mat[row][col] != player && mat[row][col] != 'T' ) ) {
				return false;
			}
		}
		return true;
	}
	
	public static boolean searchInDiagonalA( char [][] mat, char player ) {
		for( int row=0; row<4; row++ ) {
			if( ( mat[row][row] != player && mat[row][row] != 'T' ) ) {
				return false;
			}
		}
		return true;
	}
	
	public static boolean searchInDiagonalB( char [][] mat, char player ) {
		for( int row=0; row<4; row++ ) {
			if( ( mat[row][3 - row] != player && mat[row][3 - row] != 'T' ) ) {
				return false;
			}
		}
		return true;
	}
}