import java.util.*;

// Problem C. Fair and Square
class ProblemC {
	public static void main (String [] args) {
		List<Long> palindromes = generate();

		Scanner in = new Scanner( System.in );
		int nCases = in.nextInt();
		for( int i = 0; i < nCases; i ++ ) {
			long A = in.nextLong();
			long B = in.nextLong();
			
			long a = (long) Math.sqrt( A );
			long b = (long) Math.sqrt( B );
			
			int count = 0;
			for( long palindrome : palindromes ) {
				if( palindrome < a ) {
					continue;
				}
				if( palindrome > b ) {
					break;
				}
				
				long square = palindrome * palindrome;
				if( square >= A && square <= B && isPalindrome( square ) ) {
					count ++;
				}
			}
			System.out.println( "Case #" + (i+1) + ": " + count );
		}
	}
	
	public static boolean isPalindrome( long num ) {
		String number = num + "";
		int ini = 0;
		int fin = number.length() - 1;
		while( ini < fin ) {
			if( number.charAt(ini) == number.charAt(fin) ) {
				ini ++;
				fin --;
			} else {
				return false;
			}
		}
		return true;
	}
	
	public static List<Long> generate(){
		List<Long> palindromes = new ArrayList<Long>();
		long A = 1;
		long B = (long) Math.pow(10, 14);
			
		long a = (long) Math.sqrt( A );
		long b = (long) Math.sqrt( B );

		for( long num = a; num <= b; num ++ ) {			
			if( isPalindrome( num ) ) {
				long square = num * num;
				if( square >= A && square <= B && isPalindrome( square ) ) {
					palindromes.add( num );
				}
			}
		}

		return palindromes;
	}
}