import java.util.*;

// Problem B. Lawnmower
class ProblemB {
	public static void main (String [] args) {
		Scanner in = new Scanner( System.in );
		int nCases = in.nextInt();
		for( int i = 0; i < nCases; i ++ ) {
			int N = in.nextInt();
			int M = in.nextInt();

			int [][] mat = new int[N][M];
			for( int n=0; n<N; n++ ) {
				for( int m=0; m<M; m++ ) {
					mat[n][m] = in.nextInt();
				}
			}
			
			boolean isPossible = true;
			for( int maxH=99; maxH>=1; maxH--) {
				isPossible = isPossible && verify( mat, N, M, maxH );
				if( !isPossible ) {
					break;
				}
			}
			
			if( isPossible ) {
				System.out.println( "Case #" + (i+1) + ": YES" );
			} else {
				System.out.println( "Case #" + (i+1) + ": NO" );
			}
		}
	}
	
	public static boolean verify( int [][] mat, int N, int M, int h ) {
		for( int n=0; n<N; n++ ) {
			for( int m=0; m<M; m++ ) {
				if( mat[n][m] == h ) {
					if( !( vertical( mat, N, m, h ) || horizontal( mat, n, M, h ) ) ) {
						return false;
					}			
				}
			}
		}
		return true;
	}
	
	public static boolean vertical( int [][] mat, int N, int col, int h ) {
		for( int row=0; row<N; row++ ) {
			if( mat[row][col] > h ) {
				return false;
			}
		}
		return true;
	}
	
	public static boolean horizontal( int [][] mat, int row, int M, int h ) {
		for( int col=0; col<M; col++ ) {
			if( mat[row][col] > h ) {
				return false;
			}
		}
		return true;
	}
}