package com.test.codejam;

import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;

/**
 * @author Igor Konoplyanko <ikonopyanko@xsolut.de>
 *         Date: 13.04.13
 *         Time: 12:57
 */
public class P1 {


  public static void main(String... args) throws Exception {
    final InputStream resourceAsStream = P1.class.getClassLoader().getResourceAsStream("A-small-attempt0.in");

    DataInputStream in = new DataInputStream(resourceAsStream);
    BufferedReader br = new BufferedReader(new InputStreamReader(in));

    String strLine;
    int casenum = 1;

    strLine = br.readLine();
    int numOfCases = Integer.parseInt(strLine);
    System.out.println("num of: " + numOfCases);

    char[][] game = new char[4][4];

    while ((strLine = br.readLine()) != null) {

      game[0] = strLine.toCharArray();
      game[1] = br.readLine().toCharArray();
      game[2] = br.readLine().toCharArray();
      game[3] = br.readLine().toCharArray();

      System.out.print("Case #" + casenum + ": ");
      System.out.println(solve(game));

      casenum++;
      br.readLine();
    }
    in.close();
  }

  private static String solve(char[][] game) {

    int t, x, o;
    boolean notCompleted = false;
    for (int i = 0; i < 4; i++) {

      char[] row = game[i];

      t = x = o = 0;
      for (int j = 0; j < 4; j++) {
        char c = row[j];
        if (c == '.') {
          notCompleted = true;
          break;
        }

        if (c == 'X') {
          x++;
        } else if (c == 'O') {
          o++;
        } else if (c == 'T') {
          t++;
        }
      }
      if (x == 4 || (x == 3 && t == 1)) {
        return "X won";
      }
      if (o == 4 || (o == 3 && t == 1)) {
        return "O won";
      }
    }
    // ----------------------
    for (int j = 0; j < 4; j++) {
      t = x = o = 0;
      for (int i = 0; i < 4; i++) {
        char c = game[i][j];
        if (c == 'X') {
          x++;
        } else if (c == 'O') {
          o++;
        } else if (c == 'T') {
          t++;
        }
      }
      if (x == 4 || (x == 3 && t == 1)) {
        return "X won";
      }
      if (o == 4 || (o == 3 && t == 1)) {
        return "O won";
      }
    }
    // ----------------------

    t = x = o = 0;
    for (int i = 0; i < 4; i++) {
      char c = game[i][i];
      if (c == 'X') {
        x++;
      } else if (c == 'O') {
        o++;
      } else if (c == 'T') {
        t++;
      }
    }
    if (x == 4 || (x == 3 && t == 1)) {
      return "X won";
    }
    if (o == 4 || (o == 3 && t == 1)) {
      return "O won";
    }
    // ----------------------
    t = x = o = 0;
    for (int i = 0; i < 4; i++) {
      char c = game[3 - i][i];
      if (c == 'X') {
        x++;
      } else if (c == 'O') {
        o++;
      } else if (c == 'T') {
        t++;
      }
    }
    if (x == 4 || (x == 3 && t == 1)) {
      return "X won";
    }
    if (o == 4 || (o == 3 && t == 1)) {
      return "O won";
    }

    return notCompleted ? "Game has not completed" : "Draw";
  }


}
