
import java.io.*;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.StringTokenizer;

public class ProbC {

    public static final int CERTAINTY = 128;
    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws FileNotFoundException {
        new ProbC().run();
    }

    private void run() throws FileNotFoundException {
        File file = new File(getClass().getClassLoader().getResource("probC.in").getFile());
        br = new BufferedReader(new FileReader(file));
        out = new PrintWriter(this.getClass().getSimpleName() + ".out");
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
        out.close();
    }

    private void solve() throws IOException {
        int n = nextInt();
        for (int i = 0; i < n; i++) {
            int a = nextInt();
            int b = nextInt();

            System.out.println("Case #1:");
            out.println("Case #1:");
            solveTest(a, b);

        }
    }

    private void solveTest(int length, int amount) {

        ArrayList<String> allValues = generateVals(length);

        int n = 0;
        for (String val : allValues) {
            if (tryToGetJamcoin(val)) {
                n++;
            }
            if (n >= amount) {
                return;
            }
        }

    }

    private boolean tryToGetJamcoin(String val) {

        ArrayList<Long> divisors = new ArrayList<>();
        for (int i = 2; i <= 10; i++) {
            Long radix = Long.valueOf(val, i);
            if (BigInteger.valueOf(radix).isProbablePrime(CERTAINTY)) {
                return false;
            }
            Long divisor = getDivisor(radix);
            if (divisor == null) return false;
            divisors.add(divisor);
        }

        StringBuilder buffer = new StringBuilder();
        buffer.append(val);
        buffer.append(" ");
        for (Long divisor : divisors) {
            buffer.append(divisor).append(" ");
        }
        System.out.println(buffer.toString());
        out.println(buffer.toString());
        return true;
    }

    private Long getDivisor(Long num) {
        for (long i = 2; i <= Math.sqrt(num); i++) {
            if (num % i == 0) {
                return (i);
            }
        }
        return null;
    }

    private ArrayList<String> generateVals(int length) {
        ArrayList<String> res = new ArrayList<>();

        ArrayList<String> clearVals = gen(length - 2);
        for (String re : clearVals) {
            res.add("1" + re + "1");
        }
        return res;
    }

    private ArrayList<String> gen(int len) {
        ArrayList<String> strings = new ArrayList<>();
        int pow = (int) Math.pow(2, len);
        for (int i = 0; i < pow; i++) {
            String s = Integer.toBinaryString(i);
            strings.add(String.format("%" + len + "s", s).replace(' ', '0'));
        }

        return strings;

    }

}
