package com.test.codejam2;

import java.io.*;
import java.util.HashSet;
import java.util.Set;

/**
 * @author Igor Konoplyanko <ikonopyanko@xsolut.de>
 *         Date: 12.04.14
 *         Time: 14:22
 */
public class ProblemAMagicTrick {

  public static void main(String[] args) throws IOException {
    final InputStream resourceAsStream = ProblemAMagicTrick.class.getClassLoader().getResourceAsStream("A-small-attempt0.in");

    DataInputStream in = new DataInputStream(resourceAsStream);
    BufferedReader br = new BufferedReader(new InputStreamReader(in));

    String strLine;
    int casenum = 1;

    strLine = br.readLine();
    int numOfCases = Integer.parseInt(strLine);
//    System.out.println("num of: " + numOfCases);

    int[][] game1 = new int[4][4];
    int[][] game2 = new int[4][4];

    while ((strLine = br.readLine()) != null) {

      int firstAnswer = Integer.parseInt(strLine);

      game1[0] = parse(br.readLine());
      game1[1] = parse(br.readLine());
      game1[2] = parse(br.readLine());
      game1[3] = parse(br.readLine());

      int secondAnswer = Integer.parseInt(br.readLine());

      game2[0] = parse(br.readLine());
      game2[1] = parse(br.readLine());
      game2[2] = parse(br.readLine());
      game2[3] = parse(br.readLine());

      System.out.print("Case #" + casenum + ": ");
      System.out.println(solve(game1, game2, firstAnswer, secondAnswer));

      casenum++;
    }
    in.close();
  }

  private static String solve(int[][] game1, int[][] game2, int firstAnswer, int secondAnswer) {
    Set<Integer> row1 = new HashSet<Integer>(4);
    Set<Integer> row2 = new HashSet<Integer>(4);

    for (int i : game1[firstAnswer - 1]) {
      row1.add(i);
    }

    for (int i : game2[secondAnswer - 1]) {
      row2.add(i);
    }

    Set<Integer> intersection = intersection(row1, row2);

    if (intersection.size() == 1) {
      return String.valueOf(intersection.iterator().next());
    } else if (intersection.isEmpty()) {
      return "Volunteer cheated!";
    } else if (intersection.size() > 1) {
      return "Bad magician!";
    }
    throw new IllegalStateException();
  }

  private static int[] parse(String line) {
    int[] ints = new int[4];
    String[] split = line.split("\\s");
    for (int i = 0, splitLength = split.length; i < splitLength; i++) {
      ints[i] = Integer.parseInt(split[i]);
    }
    return ints;
  }

  private static Set<Integer> intersection(Set<Integer> s1, Set<Integer> s2) {
    Set<Integer> result = new HashSet<Integer>();
    for (Integer integer : s1) {
      if (s2.contains(integer)) {
        result.add(integer);
      }
    }
    return result;
  }

  private static String solve(char[][] game) {
    return "";
  }


}
