import java.io.*;
import java.util.BitSet;
import java.util.StringTokenizer;

public class ProbA {

    BufferedReader br;
    StringTokenizer st;
    PrintWriter out;

    String next() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            st = new StringTokenizer(br.readLine());
        }
        return st.nextToken();
    }

    int nextInt() throws IOException {
        return Integer.parseInt(next());
    }

    public static void main(String[] args) throws FileNotFoundException {
        new ProbA().run();
    }

    private void run() throws FileNotFoundException {
        File file = new File(getClass().getClassLoader().getResource("A-large.in").getFile());
        br = new BufferedReader(new FileReader(file));
        out = new PrintWriter(this.getClass().getSimpleName() + ".out");
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
        out.close();
    }

    private void solve() throws IOException {
        int n = nextInt();
        for (int i = 0; i < n; i++) {
            int core = nextInt();
            int res = solveTest(core);
            if (res > 0) {
                System.out.println("Case #" + (i + 1) + ": " + res);
                out.println("Case #" + (i + 1) + ": " + res);
            } else {
                String x = "Case #" + (i + 1) + ": INSOMNIA";
                System.out.println(x);
                out.println(x);
            }

        }
    }

    private int solveTest(int core) {
        BitSet set = new BitSet();
        if (core == 0) {
            return 0;
        }

        for (int i = 1; i < 1000 ; i++) {
            int val = i*core;
            char[] chars = String.valueOf(val).toCharArray();
            for (char aChar : chars) {
                int integer = Integer.valueOf(Character.toString(aChar));
                set.set(integer);
            }
            if (set.cardinality() == 10) {
                return val;
            }
        }

        return 0;
    }

}
