package com.test.codejam2;

import java.io.*;
import java.text.DecimalFormat;
import java.text.DecimalFormatSymbols;
import java.util.ArrayList;
import java.util.List;
import java.util.Locale;

/**
 * @author Igor Konoplyanko <konoplianko@me.com>
 *         Date: 12.04.14
 *         Time: 14:22
 */
public class ProblemBCookies {

  public static final DecimalFormatSymbols OTHER_SYMBOLS;
  public static final DecimalFormat df;

  static {
    OTHER_SYMBOLS = new DecimalFormatSymbols(new Locale("EN"));
    OTHER_SYMBOLS.setDecimalSeparator('.');
    df = new DecimalFormat("0.0000000", OTHER_SYMBOLS);
  }

  public static void main(String[] args) throws IOException {

    PrintStream out = new PrintStream(new FileOutputStream("solution.txt"));
    System.setOut(out);

    final InputStream resourceAsStream = ProblemBCookies.class.getClassLoader().getResourceAsStream("B-large.in");

    DataInputStream in = new DataInputStream(resourceAsStream);
    BufferedReader br = new BufferedReader(new InputStreamReader(in));

    String strLine;
    int casenum = 1;

    strLine = br.readLine();
    int numOfCases = Integer.parseInt(strLine);
//    System.out.println("num of: " + numOfCases);

    while ((strLine = br.readLine()) != null) {

      List<Double> game = parse(strLine);

      System.out.print("Case #" + casenum + ": ");
      System.out.println(solve(game));

      casenum++;
    }
    in.close();
  }

  private static String solve(List<Double> game) {

    Double bestTime = Double.MAX_VALUE;
    Double farmCost = game.get(0);
    Double farmProductionRate = game.get(1);
    Double goal = game.get(2);

    Double rate = 2d;

    Double time;
    Double farmsCount = 0d;
    Double timeOnFarms = 0d;

    while (true) {

      time = timeOnFarms + goal/rate;

      if (bestTime.compareTo(time) > 0) {
        bestTime = time;
      } else {
        break;
      }

      timeOnFarms = timeOnFarms + farmCost / rate;
      rate += farmProductionRate;
      farmsCount = farmsCount + 1d;
    }

    return df.format(bestTime);
  }

  private static List<Double> parse(String line) {
    ArrayList<Double> result = new ArrayList<Double>();

    String[] split = line.split("\\s");
    for (String aSplit : split) {
      result.add(Double.parseDouble(aSplit));
    }
    return result;
  }

}
