import java.util.*;
import java.io.*;
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.math.*;

public class Main {

    int add (int a, int b) {
        char[] s = Integer.toBinaryString(a).toCharArray();
        char[] t = Integer.toBinaryString(b).toCharArray();
        char[] r = new char[max(s.length, t.length)];
        for (int i = s.length - 1, j = t.length - 1; i >= 0 && j >= 0; i--, j--) {
            r[i] = (char)('0' + (s[i] - '0' + t[j] - '0') % 2);
        }        
        for (int i = 0; i < s.length - t.length; i++) {
            r[i] = s[i];
        }
        return Integer.parseInt(new String(r), 2);
    }
    
    void run() throws IOException {
        int tests = nint();
        for (int number = 1; number <= tests; number++) {
            int n = nint();
            int[] v = new int[n];
            for (int i = 0; i < n; i++) {
                v[i] = nint();
            }
            int ans = 0;
            for (int i = 1; i < (1 << n) - 1; i++) {
                int a = 0, b = 0, sa = 0, sb = 0;
                for (int j = 0; j < n; j++) {
                    if ((i & (1 << j)) != 0) {
                        a = add(max(a, v[j]), min(a, v[j]));
                        sa += v[j];
                    } else {
                        b = add(max(b, v[j]), min(b, v[j]));
                        sb += v[j];
                    }
                }
                if (a == b) {
                    ans = max(ans, max(sa, sb));
                }
            }
            if (ans == 0) {
                out.printf("Case #%d: NO\n", number);
            } else {
                out.printf("Case #%d: %d\n", number, ans);
            }
        }
    }    
    
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        final String FILENAME = "test";
        in = new BufferedReader(new FileReader(new File(FILENAME + ".in")));
        out = new PrintWriter(new File(FILENAME + ".out"));
        //in = new Scanner(System.in);
        //in = new BufferedReader(new InputStreamReader(System.in));
        //out = new PrintWriter(System.out);
        st = new StringTokenizer(" ");
        new Main().run();
        out.close();
    }

    static BufferedReader in;
    //static Scanner in;
    static PrintWriter out;
    static StringTokenizer st;

    String token() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    int nint() throws IOException {
        return Integer.parseInt(token());
    }

    long nlong() throws IOException {
        return Long.parseLong(token());
    }

    double ndouble() throws IOException {
        return Double.parseDouble(token());
    }
}