import java.util.*;
import java.io.*;
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.math.*;

public class Main {
    
    void run() throws IOException {
        int tests = nint();
        loop: for (int test = 1; test <= tests; test++) {
            int n = nint(), m = nint(), d = nint();
            long[][] v = new long[n][m];
            for (int i = 0; i < n; i++) {
                char[] s = token().toCharArray();
                for (int j = 0; j < m; j++) {
                    v[i][j] = d + (s[j] - '0');
                }
            }
            for (int k = min(n, m); k >= 3; k--) {
                for (int i = 0; i < n; i++) {
                    for (int j = 0; j < m; j++) {
                        if (i + k - 1 >= n || j + k - 1 >= m) {
                            continue;
                        }
                        long Ax = 0, Ay = 0, mass = 0;
                        for (int x = 0; x < k; x++) {
                            for (int y = 0; y < k; y++) {
                                if (x + y == 0 || x + y == 2 * (k - 1) || x == 0 && y == k - 1 || x == k - 1 && y == 0) {
                                    continue;
                                }
                                Ax += x * v[i + x][j + y];
                                Ay += y * v[i + x][j + y];
                                mass += v[i + x][j + y];
                            }
                        }
                        if (Ax == Ay && 2 * Ax == mass * (k - 1)) {
                            out.printf("Case #%d: %d\n", test, k);
                            continue loop;
                        }
                    }
                }
            }
            out.printf("Case #%d: IMPOSSIBLE\n", test);
        }
    }

    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        final String FILENAME = "test";
        in = new BufferedReader(new FileReader(new File(FILENAME + ".in")));
        out = new PrintWriter(new File(FILENAME + ".out"));
        //in = new Scanner(System.in);
        //in = new BufferedReader(new InputStreamReader(System.in));
        //out = new PrintWriter(System.out);
        st = new StringTokenizer(" ");
        new Main().run();
        out.close();
    }

    static BufferedReader in;
    //static Scanner in;
    static PrintWriter out;
    static StringTokenizer st;

    String token() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    int nint() throws IOException {
        return Integer.parseInt(token());
    }

    long nlong() throws IOException {
        return Long.parseLong(token());
    }

    double ndouble() throws IOException {
        return Double.parseDouble(token());
    }
}