import java.util.*;
import java.io.*;
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.math.*;

public class Main {

    void run() throws IOException {
        int tests = nint();
        for (int test = 1; test <= tests; test++) {
            int n = nint();
            double d = nint();
            double[] p = new double[n];
            int[] v = new int[n];
            int cnt = 0;
            for (int i = 0; i < n; i++) {
                p[i] = nint();
                v[i] = nint();
                cnt += v[i];
            }
            double first = p[0], last = p[n - 1];
            double l = 0, r = 1e15;
            int iter = 100;
            final double eps = 1e-8;
            for (int j = 0; j < iter; j++) {
                double m = (l + r) / 2;
                double left = first - m;
                double right = last + m;
                double x = right - left, y = d * (cnt - 1);
                boolean ok = true;
                if (x > y || abs(x - y) < eps) {
                    double prev = left;
                    double canL, canR, need;                    
                    loop: for (int i = 0; i < n; i++) {
                        int st = 0;
                        if (i == 0) st = 1;
                        for (int q = st; q < v[i]; q++) {
                            canL = p[i] - m;
                            canR = p[i] + m;
                            need = prev + d;
                            if (canR < need) {
                                ok = false;
                                break loop;
                            } else {
                                prev = max(need, canL);
                            }                            
                        }
                    }
                } else {
                    ok = false;
                }
                if (ok) {
                    r = m;
                } else {
                    l = m;
                }
            }
            out.printf("Case #%d: %.10f\n", test, l);
        }
    }
    
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        final String FILENAME = "test";
        in = new BufferedReader(new FileReader(new File(FILENAME + ".in")));
        out = new PrintWriter(new File(FILENAME + ".out"));
        //in = new Scanner(System.in);
        //in = new BufferedReader(new InputStreamReader(System.in));
        //out = new PrintWriter(System.out);
        st = new StringTokenizer(" ");
        new Main().run();
        out.close();
    }

    static BufferedReader in;
    //static Scanner in;
    static PrintWriter out;
    static StringTokenizer st;

    String token() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    int nint() throws IOException {
        return Integer.parseInt(token());
    }

    long nlong() throws IOException {
        return Long.parseLong(token());
    }

    double ndouble() throws IOException {        
        return Double.parseDouble(token());
    }
}