import java.util.*;
import java.io.*;
import static java.util.Arrays.*;
import static java.lang.Math.*;
import java.math.*;

public class Main {

    void run() throws IOException {
        int tests = nint();
        for (int test = 1; test <= tests; test++) {
            int n = nint();
            char[][] s = new char[n][];
            for (int i = 0; i < n; i++) {
                s[i] = token().toCharArray();
            }
            int[] win = new int[n];
            int[] tot = new int[n];
            double[] wp = new double[n];
            double[] owp = new double[n];
            double[] oowp = new double[n];
            for (int i = 0; i < n; i++) {                
                for (int j = 0; j < n; j++) {
                    if (s[i][j] == '1') {
                        win[i]++;
                    }
                    if (s[i][j] != '.') {
                        tot[i]++;
                    }
                }
                wp[i] = (win[i] + 0.) / tot[i];
            }
            for (int i = 0; i < n; i++) {
                double r = 0;                
                for (int j = 0; j < n; j++) {
                    if (s[i][j] == '1') {
                        r += (win[j]) / (tot[j] - 1.);                        
                    } else if (s[i][j] == '0') {
                        r += (win[j] - 1.) / (tot[j] - 1.);                        
                    }
                }
                owp[i] = r / tot[i];
            }
            for (int i = 0; i < n; i++) {
                double r = 0;
                for (int j = 0; j < n; j++) {
                    if (s[i][j] != '.') {
                        r += owp[j];
                    }
                }
                oowp[i] = r / tot[i];
            }
            out.printf("Case #%d:\n", test);
            for (int i = 0; i < n; i++) {
                double rpi = 0.25 * wp[i] + 0.5 * owp[i] + 0.25 * oowp[i];
                out.printf("%.10f\n", rpi);
            }
        }
    }
    
    public static void main(String[] args) throws IOException {
        Locale.setDefault(Locale.US);
        final String FILENAME = "test";
        in = new BufferedReader(new FileReader(new File(FILENAME + ".in")));
        out = new PrintWriter(new File(FILENAME + ".out"));
        //in = new Scanner(System.in);
        //in = new BufferedReader(new InputStreamReader(System.in));
        //out = new PrintWriter(System.out);
        st = new StringTokenizer(" ");
        new Main().run();
        out.close();
    }

    static BufferedReader in;
    //static Scanner in;
    static PrintWriter out;
    static StringTokenizer st;

    String token() throws IOException {
        while (!st.hasMoreTokens()) {
            st = new StringTokenizer(in.readLine());
        }
        return st.nextToken();
    }

    int nint() throws IOException {
        return Integer.parseInt(token());
    }

    long nlong() throws IOException {
        return Long.parseLong(token());
    }

    double ndouble() throws IOException {        
        return Double.parseDouble(token());
    }
}