import java.io.*;

class Tree {
	public int children = 0;
	public Tree []next;
	
	public int Search(String str) {
		if(str.length() == 0) {
			return 1;
		}
		int from = 0, to = 1, next_start = 1;
		if(str.charAt(0) == '(') {
			from = 1;
			to = str.indexOf(')');
			next_start = to + 1;
		}
		int R = 0;
		char c;
		String nextString = str.substring(next_start);
		for(int i = from; i < to ; i++) {
			c = str.charAt(i);
			if(next[c - 'a'] != null) {
				R += next[c - 'a'].Search(nextString);
			}
		}
		return R;
	}
	
	public Tree() {
		Init();
	}
	
	public Tree(String str) {
		if(str.length() == 0) {
			return;
		}
		Init();
		ReallyAdd(str);
	}
	
	public void Add(String str) {
		if(str.length() == 0) {
			return;
		}
		ReallyAdd(str);
	}
	
	private void Init() {
		next = new Tree['z'-'a'+1];
		for(int i=0; i<'z'-'a'+1; i++) {
			next[i] = null;
		}
	}
	
	private void ReallyAdd(String str) {
		char c = str.charAt(0);
		if(next[c-'a'] == null) {
			next[c-'a'] = new Tree(str.substring(1));
		} else {
			next[c-'a'].Add(str.substring(1));
		}
	}
}

public class AlienSolver {
	int L, D, N;
	Tree words = new Tree();
	
	public void Solve() throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String firstLine = br.readLine().trim();
		String[] LDN = firstLine.split(" ");
		L = Integer.parseInt(LDN[0]);
		D = Integer.parseInt(LDN[1]);
		N = Integer.parseInt(LDN[2]);
		
		int i;
		
		for(i = 0; i < D; i++) {
			String knownWord = br.readLine().trim();
			words.Add(knownWord);
		}
		
		for(i = 1; i <= N; i++) {
			String pattern = br.readLine().trim();
			System.out.println("Case #" + i + ": " + words.Search(pattern));
		}
		
	}
	
	public static void main(String[] args) throws Exception {
//		PrintStream console = System.out;
//		BufferedInputStream in = new BufferedInputStream(new FileInputStream("A.in"));
//		PrintStream out = new PrintStream(new BufferedOutputStream(new FileOutputStream("A.out")));
//		System.setIn(in);
//		System.setOut(out);
//		System.setErr(out);

		new AlienSolver().Solve();
		
//		out.close();
//		System.setOut(console);
	}

}
