import java.io.File;
import java.util.ArrayList;
import java.util.Stack;


public class Main {
	
	public class LinesWrapper {
		private String[] lines;
		private LineWrapper currentLineWrapper = null;
		private int currentLine;
		
		LinesWrapper(String lines) {
			this.lines = lines.split("\n");
			currentLine = 0;
			currentLineWrapper = new LineWrapper(this.lines[0]);
		}
		
		public int readInt() {
			int r = currentLineWrapper.readInt();
			if (currentLineWrapper.atEnd()) {
				currentLine ++;
				if (currentLine < lines.length) {
					currentLineWrapper = new LineWrapper(this.lines[currentLine]);
				} else {
					currentLineWrapper = null;
				}
			}
			return r;
		}
		
//		public char readChar() {
//			
//		}
	}
	
	public class LineWrapper {
		private String[]pieces;
		private int currentPiece;
		private int insidePiece;
		
		LineWrapper(String line) {
			pieces = line.trim().split(" ");
			currentPiece = 0;
			insidePiece = 0;
		}
		
		public boolean atEnd() {
			return currentPiece == pieces.length;
		}
		
		public int readInt() {
			insidePiece = 0;
			return Integer.parseInt(pieces[currentPiece++]);
		}
		
		public char readChar() {
			char r = pieces[currentPiece].charAt(insidePiece++);
			if (pieces[currentPiece].length() == insidePiece) {
				currentPiece ++;
				insidePiece = 0;
			}
			return r;
		}
	}
	
	public static void main(String[] args) {
		new Main().start();
	}

	private void start() {
		LinesWrapper input = new LinesWrapper(FileUtil.getContents(new File("in.txt")));
		String result = "";
		int T = input.readInt();
		for(int i=1; i<=T; i++) {
			int N = input.readInt();
			int[] arr = new int[N];
			for (int j=0; j<N; j++) {
				arr[j] = input.readInt();
			}
			
			long r = solve(arr);
			result += "Case #" + i + ": " + (r == -1 ? "NO" : r) + "\n";
		}
		FileUtil.setContents(new File("out.txt"), result);
		System.out.println(result);
	}
	
	long solve(int[] A) {
		long quickie = 0;
		for (int i=0; i<A.length; i++) {
			quickie ^= A[i];
		}
		if (quickie != 0) {
			return -1;
		}
		int minAt = 0;;
		for (int i=1; i<A.length; i++) {
			if (A[i] < A[minAt]) {
				minAt = i;
			}
		}
		long r = 0;
		for (int i=0; i<A.length; i++) {
			if (i != minAt) {
				r += A[i];
			}
		}
		return r;
	}
}
