import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.Iterator;

public class ProblemC {

	public static void main(String[] args) {
		new ProblemC().start();
	}
	
	void start() {
		LinesWrapper input = new LinesWrapper(FileUtil.getContents(new File("Cin.txt")));
		int T = input.readInt();
		String result = "";
		for(int t=1; t<=T; t++) {
			N = input.readInt();
			int M = input.readInt();
			int []U = new int[M];
			int []V = new int[M];
			for(int i=0; i<M; i++) {
				U[i] = input.readInt() - 1;
			}
			for(int i=0; i<M; i++) {
				V[i] = input.readInt() - 1;
			}
			GOTO = new ArrayList[N];
			for(int i=0; i<N; i++) {
				GOTO[i] = new ArrayList<Integer>();
			}
			for(int i=0; i<M; i++) {
				GOTO[U[i]].add(V[i]);
				GOTO[V[i]].add(U[i]);
			}
			for(int i=0; i<N; i++) {
				Collections.sort(GOTO[i]);
			}
			
			result += "Case #" + t + ": " + work(M) + "\n";
		}
		FileUtil.setContents(new File("Cout.txt"), result);
		System.out.println(result);
	}

	ArrayList<Integer>[] GOTO;
	int N;
	private String work(int M) {
//		for (int i=0; i<N; i++) {
//			System.out.println(i + ": " + GOTO[i]);
//		}
		int min = 0, max = 0;
		for (int i=0; i<N; i++) {
			if (GOTO[i].size() > 0) {
				min = i;
				for (Integer to : GOTO[i]) {
					max = Math.max(max, to);
				}
				break;
			}
		}
		
		ArrayList<Integer>[] chains = new ArrayList[M+1];
		chains[0] = visit (max, min);
		int pos = 1;
		for (int i=0; i<N; i++) {
			for (Integer to : GOTO[i]) {
				if (to > i) {
					chains[pos++] = visit(i, to);
				}
				min = Math.min(i, to);
				max = Math.max(i, to);
			}
		}
		
		Arrays.sort(chains, new Comparator<ArrayList<Integer>>() {
			@Override
			public int compare(ArrayList<Integer> o1, ArrayList<Integer> o2) {
				return o1.size() - o2.size();
			}
		});
		int colors = chains[0].size();
//		for (int i=0; i<chains.length; i++) {
//			colors = Math.min(colors, chains[i].size());
//			System.out.println(chains[i]);
//		}
		
		ArrayList<Integer>[] inChain = new ArrayList[N];
		for (int i=0; i<N; i++) {
			inChain[i] = new ArrayList<Integer>();
		}
		for (int i=0; i<chains.length; i++) {
			for (Integer in : chains[i]) {
				inChain[in].add(i);
			}
		}
		
		int[] colorOf = new int[N];
		boolean [][]hasColor = new boolean[M+1][colors+1];
		
		for (int i=0; i<chains.length; i++) {
			Iterator<Integer> it = chains[i].iterator();
			for (int j=1; j<=colors; j++) {
				if(!hasColor[i][j]) {
//					System.out.println("Chain " + chains[i] + " doesn't have color " + j);
					int vertice = -1;
					while(it.hasNext()) {
						vertice = it.next();
						if (colorOf[vertice] == 0) {
							break;
						}
					}
//					System.out.println ("Selected vertice " + vertice);
					colorOf[vertice] = j;
					for (Integer inCh : inChain[vertice]) {
						hasColor[inCh][j] = true;
					}
				}
			}
		}
		
		String r = "" + (colorOf[0] == 0 ? 1 : colorOf[0]);
		for(int i=1; i<N; i++) {
			r += " " + (colorOf[i] == 0 ? 1 : colorOf[i]);
		}
		
		return colors + "\n" + r;
	}

	private ArrayList<Integer> visit(int a, int b) {
//		System.out.println(a + ", " + b);
		ArrayList<Integer> chain = new ArrayList<Integer>();
		boolean[]in = new boolean[N];
		chain.add(a); chain.add(b);
		in[a] = true; in[b] = true;
		
		int curr = b;//, i=0;;
		
		do {
			int next = curr - 1;
			if (next < 0) {
				next += N;
			}
			for (Integer Goto : GOTO[curr]) {
//				System.out.println (" I can go to " + Goto);
				if (a < b) {
					if ((curr != b || Goto > a) && Goto < next) {
//						System.out.println (" I actually go to " + Goto);
						next = Goto;
					}
				}
				
			}
			curr = next;
			if (in[curr]) {
				break;
			}
			in[curr] = true;
			chain.add(curr);
//			System.out.println ("curr: " + curr);
//			i++;
//			if (i== 20) {
//				break;
//			}
		} while(true);
//		System.out.println(chain);
//		int max = Math.max(a,b);
//		int c = next(max, a, b);
		return chain;
	}

	private int next(int max, int a, int b) {
		int normal = b-1;
		if (normal < 0) {
			normal += N;
		}
		System.out.println("Next of " + a + ", " + b + ", max: " + max + ": --- normal:" + normal);
		return normal;
	}
	
}
