import java.io.*;
import java.text.DecimalFormat;
import java.util.*;

class Tree {
	public double P;
	public String Feature;
	public Tree Left, Right;

	public Tree() {
		P = 0;
		Feature = "";
		Left = Right = null;
	}
	
	public double Find(String []features, double input_P) {
		double output_P = input_P * P;
		if(Left == null || Right == null) {
			return output_P;
		}
		
		if(Feature != "") {
			boolean found = false;
			for(int i=0; i<features.length; i++) {
				if(features[i].equals(Feature)) {
					found = true;
					break;
				}
			}
			if(found) {
				return Left.Find(features, output_P);
			}
		}
		return Right.Find(features, output_P);
	}
	
	public int Init(String[] pieces, int index) {
		boolean do_break = true;
		do {
			do_break = true;
			if(pieces[index].length() == 0) {
				index ++;
				do_break = false;
			}
			if(pieces[index].charAt(0) == ')') {
				pieces[index] = pieces[index].substring(1);
				do_break = false;
			}
		} while(!do_break);

//		System.out.print("Tree ctor with: ");
//		for(int K=index; K<pieces.length; K++) {
//			System.out.print(pieces[K]+",");
//		}
//		System.out.println("\n");
		
		if(pieces[index].charAt(0) == '(') {
			int begin_index = 0;
			int stop_index = 0;
			if(pieces[index].length() == 1) {
				// simple '('
				index ++;
			} else {
				begin_index = 1;
			}
			int p_close_test = pieces[index].indexOf(')');
			if(p_close_test == -1) {
				stop_index = pieces[index].length();
			} else {
				stop_index = p_close_test;
			}
			P = Double.parseDouble(pieces[index].substring(begin_index, stop_index));
//			System.out.println("AM GASIT P: " + P);
			
			if(p_close_test == -1 && pieces[index+1].charAt(0) != ')') {
				// I have a feature
				Feature = pieces[index+1];
//				System.out.println("AM GASIT FEATURE: "+ Feature);
				Left = new Tree();
				Right = new Tree();
				index = Left.Init(pieces, index+2);
				index = Right.Init(pieces, index);
				return index;
			} else {
				return index+1;
			}
		} else {
			System.out.println("WHY AM I HERE? ");
			return 0;
		}
	}
}

public class A {
	int T, L, A, C;
	String INPUT;
	String []features;
	
	public void Solve() throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String line = br.readLine().trim();
		T = Integer.parseInt(line);
		
		int i;
		DecimalFormat myFormatter = new DecimalFormat("0.0000000");
		for(int case_no = 1; case_no <= T; case_no ++) {
			line = br.readLine().trim();
			L = Integer.parseInt(line);
			
			INPUT = "";
			for(i=1; i<=L; i++) {
				line = br.readLine().trim();
				INPUT += " " + line;
			}
			
			Tree t = new Tree();
			t.Init(INPUT.split(" "), 0);
			
			System.out.println("Case #"+case_no+":"); System.out.flush();
			
			line = br.readLine().trim();
			A = Integer.parseInt(line);
			
			for(i=0; i < A; i++) {
				line = br.readLine().trim();
				String[] pieces = line.split(" ");
				int C = Integer.parseInt(pieces[1]);
				features = new String[C];
				for(int j=2; j<pieces.length; j++) {
					features[j-2] = pieces[j];
				}
				double result = t.Find(features, 1);
				System.out.println(myFormatter.format(result));
				System.out.flush();
			}
		}
	}
	
	public static void main(String[] args) throws Exception {
		PrintStream console = System.out;
		BufferedInputStream in = new BufferedInputStream(new FileInputStream("A.in"));
		PrintStream out = new PrintStream(new BufferedOutputStream(new FileOutputStream("A.out")));
		System.setIn(in);
		System.setOut(out);

		new A().Solve();
		
		out.close();
		System.setOut(console);

	}

}
