import java.io.*;


public class B {
	int T, H, W;
	int A[][] = new int[100][100];
	char R[][] = new char[100][100];
	char go_to[][] = new char[100][100];
	int dir[][] = new int[100][100];
	int dir_line [] = new int[] { -1, 0, 0, 1 };
	int dir_column [] = new int[] { 0, -1, 1, 0 };
	char codes[] = new char[] { 'U', 'L', 'R', 'D' };
	
	//int line[] = new int[100 * 100 + 1];
	//int column[] = new int[100 * 100 + 1];
	char color;
	//int line, column;
	int new_line, new_column;
	
	public void Fill(int line, int column) {
		R[line][column] = color;
		
		// GO DOWN WITH THE WATER
		if(dir[line][column] != -1) {
			new_line = line + dir_line[dir[line][column]];
			new_column = column + dir_column[dir[line][column]];
			if(	new_line >=0 && new_line < H && new_column >= 0 && new_column < W && R[new_line][new_column] == '-') {
				Fill(new_line, new_column);
			}
		}
		
		// TRY UP
		if (line > 0 && go_to[line-1][column] == 'D' && R[line-1][column] == '-') {
			Fill(line-1, column);
		}
		
		// TRY DOWN
		if (line+1 < H && go_to[line+1][column] == 'U' && R[line+1][column] == '-') {
			Fill(line+1, column);
		}
		
		// TRY LEFT
		if (column > 0 && go_to[line][column-1] == 'R' && R[line][column-1] == '-') {
			Fill(line, column-1);
		}
		
		// TRY RIGHT
		if (column+1 < W && go_to[line][column+1] == 'L' && R[line][column+1] == '-') {
			Fill(line, column+1);
		}
	}
	
	public void Solve() throws Exception {
		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		String line = br.readLine().trim();
		
		T = Integer.parseInt(line);
		
		int i, j, k, l;
		
		for(i=1; i<=T; i++) {
			line = br.readLine().trim();
			String []HW = line.split(" ");
			H = Integer.parseInt(HW[0]);
			W = Integer.parseInt(HW[1]);
			
			for(j=0; j<H; j++) {
				for(k=0; k<W; k++) {
					R[j][k] = '-';
				}
			}
			
			for(j=0; j<H; j++) {
				line = br.readLine().trim();
				String []pieces = line.split(" ");
				k = 0;
				for(String s : pieces) {
					A[j][k] = Integer.parseInt(s);
					k ++;
				}
			}
			
			int new_j, new_k, best_l, best;
			for(j=0; j<H; j++) {
				for(k=0; k<W; k++) {
					
					best_l = -1;
					best = 10001;
					
					for(l=0; l < 4; l++) {
						new_j = j + dir_line[l];
						new_k = k + dir_column[l];
						if(new_j >= 0 && new_j < H &&
								new_k >=0 && new_k < W) {
							if(A[new_j][new_k] < A[j][k]) {
								if(A[new_j][new_k] < best) {
									best = A[new_j][new_k];
									best_l = l;
								}
							}
						}
					}
					
					dir[j][k] = best_l;
					if(best_l == -1) {
						go_to[j][k] = '-';
					} else {
						go_to[j][k] = codes[best_l];
					}
				}
			}
			
			color = 'a';
			for(j=0; j<H; j++) {
				for(k=0; k<W; k++) {
					if(R[j][k] == '-') {
						Fill(j, k);
						color ++;
					}
				}
			}
			
			System.out.println("Case #" + i + ":");
			for(j=0; j<H; j++) {
				System.out.print(R[j][0]);
				for(k=1; k<W; k++) {
					System.out.print(" " + R[j][k]);
				}
				System.out.println();
			}
			
		}
		
	}
	
	public static void main(String[] args) throws Exception {
		PrintStream console = System.out;
		BufferedInputStream in = new BufferedInputStream(new FileInputStream("B.in"));
		PrintStream out = new PrintStream(new BufferedOutputStream(new FileOutputStream("B.out")));
		System.setIn(in);
		System.setOut(out);
		//System.setErr(out);

		new B().Solve();
		
		out.close();
		System.setOut(console);
	}

}
