import java.io.File;

public class ProblemB {
	
	public static void main(String[] args) {
		new ProblemB().start();
	}
	
	void start() {
		LinesWrapper input = new LinesWrapper(FileUtil.getContents(new File("Bin.txt")));
		int T = input.readInt();
		String result = "";
		for(int t=1; t<=T; t++) {
			int R = input.readInt();
			int C = input.readInt();
			int D = input.readInt();
			int [][]M = new int[R][C];
			for(int i=0; i<R; i++) {
				String l = input.readLine();
				for(int j=0; j<C; j++) {
					M[i][j] = 1 + l.charAt(j) - '0';
				}
			}
			
			result += "Case #" + t + ": " + work(R,C,D,M) + "\n";
		}
		FileUtil.setContents(new File("Bout.txt"), result);
		System.out.println(result);
	}
	
	private static final double eps = 0.000000001;
	
	private String work(int r, int c, int d, int[][] m) {
		double[][] rSum = new double[r][c];
		double[][] cSum = new double[r][c];
		double[][] cnt = new double[r][c];
		cnt[0][0] = m[0][0];
		rSum[0][0] = 0;
		cSum[0][0] = 0;
		for (int i=1; i<r; i++) {
			cnt[i][0] = cnt[i-1][0] + m[i][0];
			rSum[i][0] = (cnt[i-1][0] * rSum[i-1][0] + i * m[i][0]) / cnt[i][0];
			cSum[i][0] = 0;
		}
		for (int j=1; j<c; j++) {
			cnt[0][j] = cnt[0][j-1] + m[0][j];
			cSum[0][j] = (cnt[0][j-1] * cSum[0][j-1] + j * m[0][j]) / cnt[0][j];
			rSum[0][j] = 0;
		}
		for (int i=1; i<r; i++) {
			for (int j=1; j<c; j++) {
				cnt[i][j] = m[i][j] + cnt[i-1][j] + cnt[i][j-1] - cnt[i-1][j-1];
				rSum[i][j] = (i * m[i][j] + cnt[i-1][j] * rSum[i-1][j] + cnt[i][j-1] * rSum[i][j-1] - cnt[i-1][j-1] * rSum[i-1][j-1]) / cnt[i][j];
				cSum[i][j] = (j * m[i][j] + cnt[i-1][j] * cSum[i-1][j] + cnt[i][j-1] * cSum[i][j-1] - cnt[i-1][j-1] * cSum[i-1][j-1]) / cnt[i][j];
			}
		}
		
//		for (int i=0; i<r; i++) {
//			for (int j=0; j<c; j++) {
//				System.out.print(cnt[i][j] + " ");
//			}
//			System.out.println();
//		}
		
//		double[][] rSum2 = new double[r][c];
//		double[][] cSum2 = new double[r][c];
//		double[][] cnt2 = new double[r][c];
//		cnt2[r-1][c-1] = m[r-1][c-1];
//		rSum2[r-1][c-1] = r-1;
//		cSum2[r-1][c-1] = c-1;
//		for (int i=r-2; i>=0; i--) {
//			cnt2[i][c-1] = cnt2[i+1][c-1] + m[i][c-1];
//			rSum2[i][c-1] = (i * m[i][c-1] + rSum2[i+1][c-1] * cnt2[i+1][c-1]) / cnt2[i][c-1];
//		}
//		for (int j=c-2; j>=0; j--) {
//			cnt2[r-1][j] = m[r-1][j] + cnt2[r-1][j+1];
//			cSum2[r-1][j] = (j * m[r-1][j] + cSum2[r-1][j+1] * cnt2[r-1][j+1]) / cnt2[r-1][j];
//		}
//		for (int i=r-2; i>=0; i--) {
//			for (int j=c-2; j>=0; j--) {
//				cnt2[i][j] = m[i][j] + cnt2[i+1][j] + cnt2[i][j+1] - cnt2[i+1][j+1];
//				rSum2[i][j] = (i * m[i][j] + cnt2[i+1][j] * rSum2[i+1][j] + cnt2[i][j+1] * rSum2[i][j+1] - cnt2[i+1][j+1] * rSum2[i+1][j+1]) / cnt2[i][j];
//				cSum2[i][j] = (j * m[i][j] + cnt2[i+1][j] * cSum2[i+1][j] + cnt2[i][j+1] * cSum2[i][j+1] - cnt2[i+1][j+1] * cSum2[i+1][j+1]) / cnt2[i][j];
//			}
//		}
		int bestK = 0;
		for (int i=0; i<r; i++) {
			for (int j=0; j<r; j++) {
				int maxk = Math.min(r-i, c-j);
				int mink = Math.max(bestK, 3);
				for (int k=maxk; k>=mink; k--) {
//					System.out.println("Coltul sus " + i + ", " + j + ", lungime " + k);
					int i2 = i + k - 1;
					int j2 = j + k - 1;
					double mycnt, myrSum, mycSum;
					if (i>0 && j>0) {
						mycnt = cnt[i2][j2] - cnt[i-1][j2] - cnt[i2][j-1] + cnt[i-1][j-1];
						myrSum = (rSum[i2][j2] * cnt[i2][j2] - rSum[i-1][j2] * cnt[i-1][j2] - rSum[i2][j-1] * cnt[i2][j-1] + rSum[i-1][j-1] * cnt[i-1][j-1]) / mycnt;
						mycSum = (cSum[i2][j2] * cnt[i2][j2] - cSum[i-1][j2] * cnt[i-1][j2] - cSum[i2][j-1] * cnt[i2][j-1] + cSum[i-1][j-1] * cnt[i-1][j-1]) / mycnt;
					} else if(i > 0) {
						mycnt = cnt[i2][j2] - cnt[i-1][j2];
						myrSum = (rSum[i2][j2] * cnt[i2][j2] - rSum[i-1][j2] * cnt[i-1][j2]) / mycnt;
						mycSum = (cSum[i2][j2] * cnt[i2][j2] - cSum[i-1][j2] * cnt[i-1][j2]) / mycnt;
					} else if(j > 0) {
						mycnt = cnt[i2][j2] - cnt[i2][j-1];
						myrSum = (rSum[i2][j2] * cnt[i2][j2] - rSum[i2][j-1] * cnt[i2][j-1]) / mycnt;
						mycSum = (cSum[i2][j2] * cnt[i2][j2] - cSum[i2][j-1] * cnt[i2][j-1]) / mycnt;
					} else {
						mycnt = cnt[i2][j2];
						myrSum = rSum[i2][j2];
						mycSum = cSum[i2][j2];
					}
//					System.out.println("cnt: " + mycnt + ", rSum: " + myrSum + ", cSum: " + mycSum);
					// Cut off corners
					double mycnt2 = mycnt - m[i][j] - m[i][j2] - m[i2][j] - m[i2][j2];
					myrSum = (myrSum * mycnt - i * m[i][j] - i * m[i][j2] - i2 * m[i2][j] - i2 * m[i2][j2]) / mycnt2;
					mycSum = (mycSum * mycnt - j * m[i][j] - j2 * m[i][j2] - j * m[i2][j] - j2 * m[i2][j2]) / mycnt2;
					
					double iMiddle = ((double)(i + i2)) / 2;
					double jMiddle = ((double)(j + j2)) / 2;
					
					if (Math.abs(iMiddle-myrSum)<eps && Math.abs(jMiddle-mycSum)<eps) {
//						System.out.println("MEGA WOW");
						bestK = k;
						break;
					}
					
//					System.out.println("cnt: " + mycnt + ", rSum: " + myrSum + ", cSum: " + mycSum);
//					System.out.println("FATA DE ---- " + iMiddle + ", " + jMiddle);
					//if (i > 0)
//					double mycnt = cnt[i2][j2] + cnt
				}
			}
		}
		if (bestK > 0) {
			return bestK + "";
		}
		return "IMPOSSIBLE";
	}


}
