import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;


public class Main {

	public static void main(String[] args) {
		new Main().start();
	}
	
	class Pair {
		public int who;
		public int where;
		public Pair(int who, int where) {
			this.who = who;
			this.where = where;
		}
	}
	
	private void start() {
		String contents = FileUtil.getContents(new File("in.txt"));
		String[] lines = contents.split("\n");
		String result = "";
		int N = Integer.parseInt(lines[0].trim());
		for(int i=1; i<=N; i++) {
			String[] pieces = lines[i].trim().split(" ");
			int P = Integer.parseInt(pieces[0]);
			Pair[] pairs = new Pair[P];
			for (int j=1; j<=P; j++) {
				int who = pieces[2*j-1].charAt(0) == 'O' ? 0 : 1;
				int where = Integer.parseInt(pieces[2*j]);
				pairs[j-1] = new Pair(who, where);
			}
			result += "Case #" + i + ": " + solve(pairs) + "\n";
		}
		FileUtil.setContents(new File("out.txt"), result);
	}
	
	private int solve(Pair[] pairs) {
		int[] pos = new int[] {1, 1};
		int[] next = new int[] {findNext(pairs,-1,0), findNext(pairs,-1,1)};
		int[] lastTime = new int[] {0, 0};
		int currentTime = 0;
		
//		System.out.println("HI");
		
		for(int i=1; i<=pairs.length; i++) {
			int who = 0;
			if (next[0] == -1 || (next[1] != -1 && next[1] < next[0])) {
				who = 1;
			}
//			System.out.println(currentTime + "::: " + who + " has to go to " + pairs[next[who]].where + " -- last moved at " + lastTime[who]);
			
			int time = Math.abs(pairs[next[who]].where - pos[who]) - (currentTime - lastTime[who]);
			time = 1 + Math.max(time, 0);
//			System.out.println("It takes " + time + "\n\n");
			
			currentTime += time;
			lastTime[who] = currentTime;
			pos[who] = pairs[next[who]].where;
			next[who] = findNext(pairs,next[who],who);
		}
		
		return currentTime;
//		System.out.println("Total currentTime: " + currentTime);
	}
	
	private int findNext(Pair[] pairs, int startAt, int who) {
		for(int i=startAt+1; i<pairs.length; i++) {
			if (pairs[i].who == who) {
				return i;
			}
		}
		return -1;
	}
}
