import java.io.File;
import java.util.Arrays;
import java.util.Comparator;


public class ProblemB {
	
	public static void main(String[] args) {
		new ProblemB().start();
	}
	
	class Point {
		public int P;
		public int V;
		
		Point(int P, int V) {
			this.P = P;
			this.V = V;
		}
		
		@Override
		public String toString() {
			return "(" + P + " " + V + ")";
		}
	}
	
	void start() {
		LinesWrapper input = new LinesWrapper(FileUtil.getContents(new File("Bin.txt")));
		int T = input.readInt();
		String result = "";
		for(int t=1; t<=T; t++) {
			int C = input.readInt();
			int D = input.readInt();
			Point []points = new Point[C];
			for (int i=0; i<C; i++) {
				int P = input.readInt();
				int V = input.readInt();
				points[i] = new Point(P,V);
			}
			Arrays.sort(points, new Comparator<Point>() {
				@Override
				public int compare(Point o1, Point o2) {
					return o1.P - o2.P;
				}
			});
			result += "Case #" + t + ": " + work(points,C,D) + "\n";
		}
		FileUtil.setContents(new File("Bout.txt"), result);
		System.out.println(result);
	}

	private String work(Point[] points, int C, int D) {
		long[][] V = new long[C][C];
		long[][] Dist = new long[C][C];
		for (int i=0; i<C; i++) {
			V[i][i] = points[i].V;
			Dist[i][i] = 0;
		}
		for (int i=1; i<C; i++) {
//			System.out.println("Distance: " + i);
			for (int j1=0; j1<C-i; j1++) {
				int j2 = j1 + i;
				V[j1][j2] = V[j1][j2-1] + V[j2][j2];
				Dist[j1][j2] = Dist[j1][j2-1] + points[j2].P - points[j2-1].P;
//				System.out.println("TODO: ,,, V: " + j1 + ", " + j2 + ", V::: " + V[j1][j2] + ", Dist :::" + Dist[j1][j2]);
				
			}
		}
		long maxD = 0;
		for (int i=0; i<C; i++) {
			for (int j=i; j<C; j++) {
				long v = V[i][j] - 1;
				if (v != 0) {
					long desiredD = v * D;
//					System.out.println (i + " cu " + j + ", sunt " + V[i][j] + " pe o raza de " + Dist[i][j]);
//					System.out.println ("Si ar tb sa fie pe o raza de " + desiredD);
//					System.out.println ("Tb sa se miste " + (desiredD - Dist[i][j]) + " unitati ");
					maxD = Math.max(maxD, (desiredD - Dist[i][j]));
				}
			}
		}
		
//		for (int i=0; i<points.length; i++) {
//			System.out.print(" " + points[i]);
//		}
//		System.out.println();
		return "" + maxD / (double)2;
	}
}
