package codejam.y2013;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.TreeSet;

import codejam.base.ProblemSolver;


public class D extends ProblemSolver {

	public static void main(String[] args) throws java.io.IOException
	{
		D processor;
		processor = new D();
		processor.setFilePrefix("D-small");
		processor.start();
	}
	
	int[] needed;
	int[][] chests;
	int c;
	
	@Override
	public String processCase(int caseNumber) throws IOException {
		int k = nextInteger();
		c = nextInteger();
		int[] keys = new int[201];
		needed = new int[201];
		chests = new int[201][];
		for ( int i = 0; i < k; i++ )
			keys[nextInteger()]++;
		for ( int i = 1; i <= c; i++ )
		{
			needed[i] = nextInteger();
			int n = nextInteger();
			chests[i] = nextIntegers(n);
		}
		
		LinkedList<Node> queue = new LinkedList<Node>();
		Node start = new Node();
		start.keys = keys.clone();
		start.path = new ArrayList<Integer>();
		start.visited = new HashSet<Integer>();
		
		TreeSet<String> sols = new TreeSet<String>();
		queue.add(start);
		
		while ( !queue.isEmpty() )
		{
			Node next = queue.remove();
			if ( next.isDestination() )
				sols.add(next.toString());
			next.pushNeighbors(queue);
			
		}
		if ( sols.isEmpty() )
			return "IMPOSSIBLE";
		return sols.first();
	}
	
	class Node
	{
		int[] keys;
		ArrayList<Integer> path;
		HashSet<Integer> visited;
		
		void pushNeighbors(LinkedList<Node> queue)
		{
			for ( int i = 1; i < 201; i++ )
				if ( keys[i] > 0 )
					for ( int j = 1; j < 201; j++ )
						if ( !visited.contains(j) && needed[j] == i )
						{
							Node next = new Node();
							next.keys = keys.clone();
							next.keys[i]--;
							next.path = path;
							next.path.add(j);
							next.visited = visited;
							next.visited.add(j);
							if ( chests[j] != null )
								for ( int k = 0; k < chests[j].length; k++ )
									next.keys[chests[j][k]]++;
							
							queue.add(next);
						}
		}
		
		boolean isDestination()
		{
			return path.size() == c;
		}
		
		public String toString()
		{
			String s = "";
			for ( int n : path )
			{
				s += Integer.toString(n);
				s += " ";
			}
				
			return s.substring(0, s.length() - 1);
		}
	}
}
