package com.capell.Qualification.ProblemD;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.Deque;
import java.util.LinkedList;
import java.util.Locale;
import java.util.Scanner;

public class Main {

	public static int warDeceitful(Deque<Double> naomi, Deque<Double> ken) {
		int naomiPunts = 0;
		while (!naomi.isEmpty()) {
			if (naomi.pollFirst() > ken.getFirst()) {
				naomiPunts++;
				ken.pollFirst();
			} else {
				ken.pollLast();
			}
		}
		return naomiPunts;
	}

	public static int warOptimo(Deque<Double> naomi, Deque<Double> ken) {
		int puntoNaomi = 0;
		while (!naomi.isEmpty()) {
			double nextNaomi = naomi.pollLast();
			if (!containsMayor(nextNaomi, ken))
				puntoNaomi++;
		}
		return puntoNaomi;
	}

	private static boolean containsMayor(double nextNaomi, Deque<Double> ken) {
		for (Double d : ken) {
			if (d > nextNaomi) {
				ken.remove(d);
				return true;
			}
		}
		return false;
	}

	public static void main(String[] args) {

		Scanner sc = null;
		BufferedWriter bw = null;
		try {
			sc = new Scanner(new File("problemC.in")).useLocale(Locale.ENGLISH);
			bw = new BufferedWriter(new FileWriter(new File("problemC.out")));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}

		int numTestCases = sc.nextInt();
		sc.nextLine();
		for (int i = 1; i <= numTestCases; i++) {

			LinkedList<Double> naomi = new LinkedList<Double>();
			LinkedList<Double> ken = new LinkedList<Double>();
			sc.nextLine();
			// naomi.add(0.186);
			// naomi.add(0.389);
			// naomi.add(0.907);
			// naomi.add(0.832);
			// naomi.add(0.959);
			// naomi.add(0.557);
			// naomi.add(0.300);
			// naomi.add(0.992);
			// naomi.add(0.899);
			//
			// ken.add(0.916);
			// ken.add(0.728);
			// ken.add(0.271);
			// ken.add(0.520);
			// ken.add(0.700);
			// ken.add(0.521);
			// ken.add(0.215);
			// ken.add(0.341);
			// ken.add(0.458);

			// String n= "0.2 0.3 0.4 0.5 0.6";
			// String k= "0.15 0.25 0.35 0.45 0.55";

			// String n = "0.1 0.3 0.4 0.5 0.6";
			// String k = "0.15 0.25 0.35 0.45 0.55";

			// String n= "0.1 0.2 0.99";
			// String k = "0.25 0.45 0.5";

//			String n = "0.186 0.389 0.907 0.832 0.959 0.557 0.300 0.992 0.899";
//			String k = "0.916 0.728 0.271 0.520 0.700 0.521 0.215 0.341 0.458";
			
			String n= sc.nextLine();
			String k= sc.nextLine();

			for (String d : n.split(" ")) {
				naomi.add(Double.parseDouble(d));
			}
			for (String d : k.split(" ")) {
				ken.add(Double.parseDouble(d));
			}
			
			String out="";
			
			if(naomi.size()==1){
				out = "Case #"
						+ i
						+ ": "
						+ ((naomi.get(0)>ken.get(0))?"1":"0") + " "
						+ ((naomi.get(0)>ken.get(0))?"1":"0");
			}else{
			
			Collections.sort(naomi);
			Collections.sort(ken);

			Double[] nOrig = naomi.toArray(new Double[naomi.size()]);
			Double[] kOrig = ken.toArray(new Double[naomi.size()]);

			out = "Case #"
					+ i
					+ ": "+ warDeceitful(naomi, ken) +" "
					+ warOptimo(new LinkedList<Double>(Arrays.asList(nOrig)),
							new LinkedList<Double>(Arrays.asList(kOrig)))
					;
			}
			
			try {
				bw.write(out + "\n");
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
		
		try {
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private static double media(LinkedList<Double> blocks) {
		double media = 0.0;
		for (Double d : blocks) {
			media += d;
		}
		media = media / blocks.size();
		return media;
	}

}
