import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;


public class FileFixIt {

	
	public static class TreeNode
	{
		public int id;
		public Map<Integer, TreeNode> children = new HashMap<Integer, TreeNode>();
	}
	
	public static int totalMakeCount;
	public static TreeNode root;
	
	public static void createTree(List<Integer> path)
	{
		TreeNode curr = root;
		for(int item : path)
		{
			if(curr.children.containsKey(item))
			{
				curr = curr.children.get(item);

			}
			else
			{
				TreeNode newNode = new TreeNode();
				newNode.id = item;
				curr.children.put(item, newNode);
				curr = newNode;
			}
			
			
		}
	}
	
	public static void makeTree(List<Integer> path)
	{
		TreeNode cur = root;
		for(int item : path)
		{
			if(cur.children.containsKey(item))
			{
				cur = cur.children.get(item);
			}
			else
			{
				totalMakeCount++;
				TreeNode newNode = new TreeNode();
				newNode.id = item;
				cur.children.put(item, newNode);
				cur = newNode;
			}
			
			
		}
	}
	
	
	
	/**
	 * @param args
	 * @throws IOException 
	 * @throws NumberFormatException 
	 */
	public static void main(String[] args) throws NumberFormatException, IOException 
	{
		RandomAccessFile in = new RandomAccessFile(args[0], "r");
		RandomAccessFile out = new RandomAccessFile(args[1], "rw");
	
		int caseCount = Integer.parseInt(in.readLine());
		int N, M;
		String result;
		for(int i = 0; i < caseCount; i++)
		{
			String[] temp = in.readLine().trim().split(" ");
			N = Integer.parseInt(temp[0]);
			M = Integer.parseInt(temp[1]);
			root = new TreeNode();
			totalMakeCount = 0;
			dictNo = 0;
			dict = new HashMap<String,Integer>();
			
			for(int j = 0; j < N; j++)
			{
				createTree(toList(in.readLine().trim()));
			}
			for(int j = 0; j < M; j++)
			{
				makeTree(toList(in.readLine().trim()));
			}
			//output result
			result = "Case #";
			result = result + (i + 1) + ": " + totalMakeCount + "\n";
			out.writeBytes(result);
			
			
		}
		
	
		

	}
	
	public static Map<String, Integer> dict;
	public static int dictNo;
	
	public static List<Integer> toList(String line)
	{
		line = line.substring(1);
		String temp[] = line.split("/");
		List<Integer> ret = new LinkedList<Integer>();
		for(String str : temp)
		{
			if(dict.containsKey(str))
			{
				ret.add(dict.get(str));
			}
			else
			{
				dictNo++;
				ret.add(dictNo);
				dict.put(str, dictNo);
				
			}
		}
		
		return ret;
	}

}
