import java.util.Arrays;
import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class B_small_0 {
    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
        int tests = Integer.parseInt(input.nextLine());
        assert (tests >= 1 && tests <= 100) : "invalid number of tests: " + tests;
        for (int t = 0; t < tests; t++) {
            Magicka game = new Magicka();
            String line = input.nextLine();
            String[] data = line.split(" ");
            int dataIndex = 0;

            int combinedCount = Integer.parseInt(data[dataIndex++]);
            assert (combinedCount >= 0 && combinedCount <= 1) : "invalid number of combined elements: " + combinedCount;
            for (int c = 0; c < combinedCount; c++) {
                String combination = data[dataIndex++];
                game.addCombination(new Pair(combination.charAt(0), combination.charAt(1)), combination.charAt(2));
            }

            int removalCount = Integer.parseInt(data[dataIndex++]);
            assert (removalCount >= 0 && removalCount <= 1) : "invalid number of removal elements: " + removalCount;
            for (int d = 0; d < removalCount; d++) {
                String pair = data[dataIndex++];
                game.addRemoval(new Pair(pair.charAt(0), pair.charAt(1)));
            }

            int elementsCount = Integer.parseInt(data[dataIndex++]);
            assert (elementsCount >= 1 && elementsCount <= 10) : "invalid number of elements to invoke: " + elementsCount;
            char[] elements = data[dataIndex].toCharArray();

            List<Character> invoked = game.invokeElements(elements);
            System.out.printf("Case #%d: %s%n", t + 1, invoked);
        }
        input.close();
    }
}

class Pair {
    char element1;
    char element2;

    Pair(char e1, char e2) {
        element1 = e1;
        element2 = e2;
    }
}

class Magicka {
    private Map<Pair, Character> combinations;
    private List<Pair> removals;

    public static List<Character> BASE_ELEMENTS = Arrays.asList('Q', 'W', 'E', 'R', 'A', 'S', 'D', 'F');

    public Magicka() {
        combinations = new HashMap<Pair, Character>();
        removals = new ArrayList<Pair>();
    }

    public void addCombination(Pair toBeCombined, Character combined) {
        assert (BASE_ELEMENTS.contains(toBeCombined.element1) && BASE_ELEMENTS.contains(toBeCombined.element2) && !BASE_ELEMENTS.contains(combined)) : "invalid element combination: [" + toBeCombined.element1 + ", " + toBeCombined.element2 + "] -> " + combined;
        combinations.put(toBeCombined, combined);
    }

    public void addRemoval(Pair toBeRemoved) {
        assert (BASE_ELEMENTS.contains(toBeRemoved.element1) && BASE_ELEMENTS.contains(toBeRemoved.element2)) : "invalid element removal: [" + toBeRemoved.element1 + ", " + toBeRemoved.element2 + "]";
        removals.add(toBeRemoved);
    }

    public List<Character> invokeElements(char[] elements) {
        List<Character> invoked = new ArrayList<Character>();

        for (char c : elements) {
            if (invoked.isEmpty()) {
                invoked.add(c);
            }
            else {
                boolean reacted = false;
                for (Map.Entry<Pair, Character> entry : combinations.entrySet()) {
                    char lastElement = invoked.get(invoked.size() - 1);
                    if ((entry.getKey().element1 == lastElement && entry.getKey().element2 == c) ||
                        (entry.getKey().element2 == lastElement && entry.getKey().element1 == c)) {
                        invoked.set(invoked.size() - 1, entry.getValue());
                        reacted = true;
                        break;
                    }
                }
                if (!reacted) {
                    for (Pair removal : removals) {
                        if ((removal.element1 == c && invoked.contains(removal.element2)) ||
                            (removal.element2 == c && invoked.contains(removal.element1))) {
                            invoked.clear();
                            reacted = true;
                            break;
                        }
                    }
                }
                if (!reacted) {
                    invoked.add(c);
                }
            }
        }

        return invoked;
    }
}
