import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class C_small_0 {
    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
        int tests = input.nextInt();
        assert (tests >= 1 && tests <= 100) : "invalid number of test cases";
        for (int t = 0; t < tests; t++) {
            int candies = input.nextInt();
            assert (candies >= 2 && candies <= 15) : "invalid number of candies";
            List<Integer> allCandies = new ArrayList<Integer>(candies);
            for (int n = 0; n < candies; n++) {
                int candy = input.nextInt();
                assert (candy >= 1 && candy <= 1000000) : "invalid candy value";
                allCandies.add(candy);
            }
            Integer candiesValue = calculateValue(allCandies);
            System.out.printf("Case #%d: %s%n", t + 1, (candiesValue == null ? "NO" : candiesValue.toString()));
        }
        input.close();
    }

    private static Integer calculateValue(List<Integer> candies) {
        for (int i = 0; i < candies.size() - 1; i++) {
            List<Integer> firstPile = candies.subList(0, i + 1);
            List<Integer> secondPile = candies.subList(i + 1, candies.size());
            long firstValue = 0;
            long firstRealValue = 0;
            long secondValue = 0;
            long secondRealValue = 0;
            for (Integer v : firstPile) {
                firstValue ^= v;
                firstRealValue += v;
            }
            for (Integer v : secondPile) {
                secondValue ^= v;
                secondRealValue += v;
            }
            if (firstValue == secondValue) {
                return (int) Math.max(firstRealValue, secondRealValue);
            }
        }
        return null;
    }
}
