import java.util.Scanner;

public class A_large_0 {
	public static void main(String[] args) {
		char[][] schedule;
		Scanner input = new Scanner(System.in);
		int tests = input.nextInt();
		for (int t = 0; t < tests; t++) {
			int teams = input.nextInt();
			schedule = new char[teams][teams];
			input.nextLine(); // consumes \n
			for (int n = 0; n < teams; n++) {
				schedule[n] = input.nextLine().toCharArray();
			}
			System.out.printf("Case #%d:%n", t + 1);
			for (int n = 0; n < teams; n++) {
				double rpi = calculateRpi(schedule, n);
				System.out.printf("%f%n", rpi);
			}
		}
		input.close();
	}

	private static double wp(char[][] schedule, int team, int opponent) {
		int wins = count(schedule[team], '1', opponent);
		int losses = count(schedule[team], '0', opponent);
		return (double) wins / (wins + losses);
	}

	private static double owp(char[][] schedule, int team) {
		double wpSum = 0;
		int opponents = 0;
		for (int i = 0; i < schedule[team].length; i++) {
			if (i != team) {
				switch (schedule[team][i]) {
					case '0':
					case '1':
						wpSum += wp(schedule, i, team);
						opponents++;
						break;
				}
			}
		}
		return wpSum / opponents;
	}

	private static double oowp(char[][] schedule, int team) {
		double owpSum = 0;
		int opponents = 0;
		for (int i = 0; i < schedule[team].length; i++) {
			switch (schedule[team][i]) {
				case '0':
				case '1':
					owpSum += owp(schedule, i);
					opponents++;
					break;
			}
		}
		return owpSum / opponents;
	}

	private static double calculateRpi(char[][] schedule, int team) {
		double wp = wp(schedule, team, -1);
		double owp = owp(schedule, team);
		double oowp = oowp(schedule, team);
		return 0.25 * wp + 0.5 * owp + 0.25 * oowp;
	}

	private static int count(char[] array, char element, int opponent) {
		int c = 0;
		for (int i = 0; i < array.length; i++) {
			if (i != opponent) {
				if (array[i] == element) {
					c++;
				}
			}
		}
		return c;
	}
}
