import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;
import java.util.logging.Logger;

public class AlienLanguage {
	private static final Logger log = Logger.getLogger(AlienLanguage.class.getName());

	private List<String> dictionary;

	public AlienLanguage() {
		dictionary = new ArrayList<String>();
	}

	public void addWord(String word) {
		dictionary.add(word);
	}

	public int wordsPerPattern(String pattern) {
		AlienPattern apattern = new AlienPattern(pattern);
		List<String> possibleWords = new ArrayList<String>(dictionary);
		for (int i = 0; apattern.hasNext(); i++) {
			apattern.filterWords(possibleWords, i);
		}
		return possibleWords.size();
	}

	public static void main(String[] args) {
		AlienLanguage alang = new AlienLanguage();
		Scanner input = new Scanner(System.in);
		String[] params = input.nextLine().split(" ");
		int l = Integer.parseInt(params[0]);
		int d = Integer.parseInt(params[1]);
		int n = Integer.parseInt(params[2]);
		for (int i = 0; i < d; i++) {
			String word = input.nextLine();
			alang.addWord(word);
		}
		for (int i = 0; i < n; i++) {
			String testCase = input.nextLine();
			int possibleWords = alang.wordsPerPattern(testCase);
			System.out.printf("Case #%d: %d%n", i + 1, possibleWords);
		}
		input.close();
	}

	class AlienPattern {
		private char[] patternArray;
		private int nextIndex;

		public AlienPattern(String pattern) {
			patternArray = pattern.toCharArray();
			nextIndex = 0;
		}

		public boolean hasNext() {
			return (nextIndex < patternArray.length);
		}

		public void filterWords(List<String> words, int start) {
			log.entering(AlienLanguage.class.getName(), "filterWords", new Object[] { words.size(), start });
			char c = patternArray[nextIndex];
			List<Character> group = new ArrayList<Character>();
			if (Character.isLowerCase(c)) {
				log.fine(String.format("%c is lower case", c));
				group.add(c);
			}
			else {
				assert c == '(';
				nextIndex++;
				while (patternArray[nextIndex] != ')') {
					group.add(patternArray[nextIndex++]);
				}
				log.fine(String.format("group detected: %s", group.toString()));
			}
			for (int i = 0; i < words.size(); i++) {
				String w = words.get(i);
				if (!group.contains(w.charAt(start))) {
					words.remove(i);
					i--;
				}
			}
			nextIndex++;
			log.exiting(AlienLanguage.class.getName(), "filterWords");
		}
	}
}
