import java.util.*;
import java.util.logging.*;

public class BribeThePrisoners {
	private int nPrisoners;

	private static Logger log = Logger.getLogger(BribeThePrisoners.class.getName());

	public static void main(String[] args) {
		Scanner input = new Scanner(System.in);
		int n = input.nextInt();
		for (int i = 0; i < n; i++) {
			BribeThePrisoners kingdom = new BribeThePrisoners();
			int p = input.nextInt();
			log.config(String.format("p = %d", p));
			kingdom.setPrisonersCount(p);
			int q = input.nextInt();
			log.config(String.format("q = %d", q));
			List<Integer> releasedPrisoners = new ArrayList<Integer>(q);
			for (int j = 0; j < q; j++) {
				int released = input.nextInt();
				releasedPrisoners.add(released);
			}
			log.config(String.format("released prisoners = %s", releasedPrisoners));
			System.out.printf("Case #%d: %d%n", i + 1, kingdom.bribePrisoners(releasedPrisoners));
		}
		input.close();
	}

	public void setPrisonersCount(int n) {
		nPrisoners = n;
	}

	public int bribePrisoners(List<Integer> releasedPrisoners) {
		log.entering(BribeThePrisoners.class.getName(), "bribePrisoners", releasedPrisoners.size());
		List<List<Integer>> releaseOrders = permutation(releasedPrisoners);
		int leastBribe = Integer.MAX_VALUE;
		for (List<Integer> order : releaseOrders) {
			List<Integer> allPrisoners = new ArrayList<Integer>(nPrisoners);
			for (int i = 1; i <= nPrisoners; i++) {
				allPrisoners.add(i);
			}
			int bribe = 0;
			for (int o : order) {
				allPrisoners.set(o - 1, null);
				// search to the left
				if (o - 1 > 0) {
					for (int i = o - 2; i >= 0 && allPrisoners.get(i) != null; i--) {
						bribe++;
					}
				}
				// search to the right
				if (o - 1 < nPrisoners) {
					for (int i = o; i < allPrisoners.size() && allPrisoners.get(i) != null; i++) {
						bribe++;
					}
				}
			}
			log.fine(String.format("bribe for %s= %d", order, bribe));
			leastBribe = Math.min(bribe, leastBribe);
		}
		log.exiting(BribeThePrisoners.class.getName(), "bribePrisoners", leastBribe);
		return leastBribe;
	}

	private List<List<Integer>> permutation(List<Integer> base) {
		log.entering(BribeThePrisoners.class.getName(), "permutation", base);
		List<List<Integer>> permutations = new ArrayList<List<Integer>>();
		if (base.size() == 1) {
			permutations.add(Arrays.asList(base.get(0)));
		}
		else {
			for (int i = 0; i < base.size(); i++) {
				int firstElement = base.get(i);
				List<Integer> remainder = new ArrayList<Integer>(base);
				remainder.remove(i);
				List<List<Integer>> permutationsAfter = permutation(remainder);
				for (List<Integer> pAfter : permutationsAfter) {
					List<Integer> onePermutation = new ArrayList<Integer>();
					onePermutation.add(firstElement);
					onePermutation.addAll(pAfter);
					permutations.add(onePermutation);
				}
			}
		}
		log.exiting(BribeThePrisoners.class.getName(), "permutation", permutations.size());
		return permutations;
	}
}
