import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Googlerese {
	private static Map<Character, Character> replacementLetters;

	static {
		replacementLetters = new HashMap<Character, Character>();
		replacementLetters.put('a', 'y');
		replacementLetters.put('b', 'h');
		replacementLetters.put('c', 'e');
		replacementLetters.put('d', 's');
		replacementLetters.put('e', 'o');
		replacementLetters.put('f', 'c');
		replacementLetters.put('g', 'v');
		replacementLetters.put('h', 'x');
		replacementLetters.put('i', 'd');
		replacementLetters.put('j', 'u');
		replacementLetters.put('k', 'i');
		replacementLetters.put('l', 'g');
		replacementLetters.put('m', 'l');
		replacementLetters.put('n', 'b');
		replacementLetters.put('o', 'k');
		replacementLetters.put('p', 'r');
		replacementLetters.put('q', 'z');
		replacementLetters.put('r', 't');
		replacementLetters.put('s', 'n');
		replacementLetters.put('t', 'w');
		replacementLetters.put('u', 'j');
		replacementLetters.put('v', 'p');
		replacementLetters.put('w', 'f');
		replacementLetters.put('x', 'm');
		replacementLetters.put('y', 'a');
		replacementLetters.put('z', 'q');
	}

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int t = Integer.parseInt(scanner.nextLine());
		for (int x = 0; x < t; x++) {
			String g = scanner.nextLine();
			String s = Googlerese.decode(g);
			System.out.printf("Case #%d: %s%n", (x + 1), s);
		}
		scanner.close();
	}

	public static String decode(String input) {
		StringBuilder output = new StringBuilder(input.length());
		for (char c : input.toCharArray()) {
			if (replacementLetters.containsKey(c)) {
				output.append(replacementLetters.get(c));
			}
			else {
				output.append(c);
			}
		}

		return output.toString();
	}

	// This method is used to generate the character table, based on the output file
	private static void learnALLTheLetters(File inputFile, File outputFile) {
		try {
			Scanner input = new Scanner(inputFile);
			Scanner output = new Scanner(outputFile);
			input.nextLine(); // discard number of test cases
			while (input.hasNextLine()) {
				String inputText = input.nextLine();
				String outputText = output.nextLine().split(": ")[1];
				for (int i = 0; i < inputText.length(); i++) {
					char in = inputText.charAt(i);
					char out = outputText.charAt(i);
					if (Character.isLetter(in) && !replacementLetters.containsKey(in)) {
						replacementLetters.put(in, out);
						System.out.printf("replacementLetters.put('%c', '%c');%n", in, out);
					}
				}
			}
			output.close();
			input.close();
		}
		catch (FileNotFoundException e) {
			System.err.println(e.getMessage());
		}
	}
}
