import java.util.ArrayList;
import java.util.List;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class A_small_0 {
    public static void main(String[] args) {
        Scanner input = new Scanner(System.in);
        int tests = Integer.parseInt(input.nextLine());
        assert (tests >= 1 && tests <= 20) : "invalid number of test cases";
        for (int t = 0; t < tests; t++) {
            String line = input.nextLine();
            List<ButtonPress> buttonSequences = parseInputLine(line);
            int seconds = A_small_0.pushAllButtons(buttonSequences);
            System.out.printf("Case #%d: %d%n", t + 1, seconds);
        }
        input.close();
    }

    private static List<ButtonPress> parseInputLine(String inputLine) {
        String[] data = inputLine.split(" ");
        int buttonsCount = Integer.parseInt(data[0]);
        assert (buttonsCount >=1 && buttonsCount <= 10) : "invalid number of buttons";
        assert (data.length == buttonsCount * 2 + 1) : "invalid number of parameters in current test case";

        List<ButtonPress> sequences = new ArrayList<ButtonPress>(buttonsCount);
        for (int i = 0; i < buttonsCount; i++) {
            int dataIndex = 2 * i + 1;
            ButtonPress button = new ButtonPress();
            button.robot = data[dataIndex].charAt(0);
            assert (button.robot == 'B' || button.robot == 'O') : "invalid robot letter";
            button.button = Integer.parseInt(data[dataIndex + 1]);
            assert (button.button >= 1 && button.button <= 100) : "invalid button number";
            sequences.add(button);
        }
        return sequences;
    }

    private static int pushAllButtons(List<ButtonPress> sequences) {
        int time = 1;
        Map<Character, Integer> positions = new HashMap<Character, Integer>(2);
        positions.put('B', 1);
        positions.put('O', 1);

        for (int i = 0; i < sequences.size(); time++) {
            // System.out.printf("> TIME %d:%n", time);
            ButtonPress button = sequences.get(i);
            char otherRobot = (button.robot == 'B' ? 'O' : 'B');
            ButtonPress nextButton = findNextIn(otherRobot, sequences.subList(i + 1, sequences.size()));

            if (nextButton != null && positions.get(otherRobot) < nextButton.button) {
                positions.put(otherRobot, positions.get(otherRobot) + 1);
                // System.out.printf("%c moves to button %d%n", otherRobot, positions.get(otherRobot));
            }
            else if (nextButton != null && positions.get(otherRobot) > nextButton.button) {
                positions.put(otherRobot, positions.get(otherRobot) - 1);
                // System.out.printf("%c moves to button %d%n", otherRobot, positions.get(otherRobot));
            }
            else {
                // System.out.printf("%c stays at button %d%n", otherRobot, positions.get(otherRobot));
            }

            if (positions.get(button.robot) < button.button) {
                positions.put(button.robot, positions.get(button.robot) + 1);
                // System.out.printf("%c moves to button %d%n", button.robot, positions.get(button.robot));
            }
            else if (positions.get(button.robot) > button.button) {
                positions.put(button.robot, positions.get(button.robot) - 1);
                // System.out.printf("%c moves to button %d%n", button.robot, positions.get(button.robot));
            }
            else {
                // System.out.printf("%c pushes button %d%n", button.robot, button.button);
                i++;
            }
        }

        return time - 1;
    }

    private static ButtonPress findNextIn(char robot, List<ButtonPress> sequences) {
        for (ButtonPress b : sequences) {
            if (b.robot == robot) {
                return b;
            }
        }
        return null;
    }
}

class ButtonPress {
    char robot;
    int button;
}
