package main;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.math.BigInteger;

public class MainEntry {
	private static String outFilePath = "./folder/out.txt";

	private static BigInteger zero = new BigInteger("0");
	private static BigInteger two = new BigInteger("2");
	private static BigInteger three = new BigInteger("3");

	public static void main(String[] args) {
		File out = new File(outFilePath);

		try {
			out.delete();
			out.createNewFile();

			BufferedWriter writer = new BufferedWriter(new FileWriter(out));
			writer.write("Case #1:\r\n");

			int count = 0;
			String startStr = "1000000000000011";
			log("len=" + startStr.length());
			BigInteger start = new BigInteger(startStr);
			BigInteger start2Digit = getBigByDigits(start, 2);
			BigInteger decimal, factor = null;
			BigInteger[] factors = new BigInteger[9];
			while (count < 50) {
				boolean flag = false;
				for (int n = 2; n <= 10; n++) {
					decimal = getBigByDigits(start, n);
					factor = getFactor(decimal);
					if (factor.equals(zero)) {
						factors[n - 2] = zero;
						flag = true;
						break;
					}

					factors[n - 2] = factor;
				}

				if (!flag) {
					writer.write(String.format("%s %s\r\n", start, arrayToString(factors)));
					log("count=" + count + ",num=" + start + ",factor=" + arrayToString(factors));
					count++;
				}

				start2Digit = start2Digit.add(two);
				start = new BigInteger(numTo2DigitString(start2Digit));
				log("start add=" + start);
			}

			writer.flush();
			writer.close();
			log("success");
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();

			log("failed");
		}
	}

	private static String arrayToString(BigInteger[] factors) {
		String result = "";

		for (int n = 0; n < factors.length; n++) {
			result = result + factors[n] + " ";
		}

		return result;
	}

	private static void log(String log) {
		System.out.println(log);
	}

	private static BigInteger getBigByDigits(BigInteger num, int digit) {
		BigInteger result = zero;

		char[] chrs = num.toString().toCharArray();
		for (int n = 0; n < chrs.length; n++) {
			BigInteger chr = new BigInteger(String.valueOf(chrs[n] - '0'));
			BigInteger pow = new BigInteger(String.valueOf(digit)).pow(chrs.length - n - 1);
			result = result.add(chr.multiply(pow));
		}

		return result;
	}

	public static BigInteger getFactor(BigInteger n) {
		if (n.compareTo(BigInteger.ONE) == 0 || n.compareTo(two) == 0) {
			return zero;
		}

		if (n.mod(two).equals(BigInteger.ZERO)) {
			return two;
		}

		BigInteger half = n.divide(two);
		BigInteger level = new BigInteger("100");

		for (BigInteger i = three; i.compareTo(half) <= 0 && i.compareTo(level) < 0; i = i.add(two)) {

			if (n.mod(i).equals(BigInteger.ZERO)) {
				return i;
			}

		}
		return zero;

	}

	private static String numTo2DigitString(BigInteger num) {
		String result = "";

		while (num.compareTo(two) >= 0) {
			if (num.mod(two).compareTo(zero) == 0) {
				result = "0" + result;
			} else {
				result = "1" + result;
			}

			num = num.divide(two);
		}

		if (!num.equals(zero)) {
			result = "1" + result;
		}

		return result;
	}
}
