
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Scanner;

public class CountingSheep {    
    static Scanner scanner = new Scanner(System.in);
    static PrintWriter writer;
    
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        int T = scanner.nextInt();
        writer = new PrintWriter("counting_sheep.out");
        for (int i = 0; i < T; i++) {
            Solution solution = new Solution();
            solution.solve(i);
        }
        writer.close();
    }
    
    static class Solution {
        public void solve(int i) {
            int N = scanner.nextInt();
            
            if (N == 0) {
                output(i, "INSOMNIA");
            } else {
                int n = 0;
                boolean[] digits = new boolean[10];

                do {
                    n += N;
                    process(n, digits);
                } while(!all(digits));
                
                output(i, Integer.toString(n));
            }
        }
        
        private boolean all(boolean[] C) {
            boolean result = true;
            for (boolean state : C) result &= state;             
            return result;
        }
        
        private void process(long n, boolean[] C) {
            while (n > 0) {
                C[(int)(n % 10L)] = true;
                n /= 10L;
            }
        }
        
        private void output(int i, String output) {
            writer.println("Case #" + (i+1) + ": " + output);
        }
    }
}
