
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.util.Scanner;

public class RevengeOfThePancakes {    
    static Scanner scanner = new Scanner(System.in);
    static PrintWriter writer;
    
    public static void main(String[] args) throws FileNotFoundException, UnsupportedEncodingException {
        int T = scanner.nextInt();
        writer = new PrintWriter("revenge_of_the_pancakes.out");
        for (int i = 0; i < T; i++) {
            Solution solution = new Solution();
            int output = solution.solve();
            System.out.println("Case #" + (i+1) + ": " + output);
            writer.println("Case #" + (i+1) + ": " + output);
        }
        writer.close();
    }
    
    static class Solution {
        public int solve() {
            String raw = scanner.next();
            int S = raw.length();
            
            boolean[] pancakes = process(raw);
            
            int flips = 0;
            boolean current = pancakes[0];
            for (int j = 1; j < S; j++) {
                if (current != pancakes[j]) {
                    flip(pancakes, j);
                    current = !current;
                    flips++;
                    j = 0;
                }
            }

            if (!current) {
                flip(pancakes, S);
                flips++;
            }
            
            return flips;
        }
        
        private boolean[] process(String raw) {
            int S = raw.length();
            boolean[] result = new boolean[S];
            for (int j = 0; j < S; j++) 
                result[j] = raw.charAt(j) == '+';
            return result;
        }
        
        private void flip(boolean[] pancakes, int i) {
            boolean[] buffer = new boolean[i];
            for (int j = 0; j < i; j++) 
                buffer[j] = pancakes[i-j-1];
            for (int j = 0; j < i; j++) 
                pancakes[j] = !buffer[j];
        }
    }
}