package cw;

import static cw.A.Color.B;
import static cw.A.Color.O;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.Queue;

public class A {
	int totalMoves;

	enum Color {
		O, B;
	}

	Bot o = new Bot(O);
	Bot b = new Bot(B);
	LinkedList<Color> buttonOrders = new LinkedList<Color>();

	public static void main(String args[]) throws Exception {
		String path = System.getProperty("user.home");
		final BufferedReader br = new BufferedReader(new FileReader(path
				+ "/input.txt"));
		final BufferedWriter bw = new BufferedWriter(new FileWriter(path
				+ "/output.txt"));

		int n = Integer.parseInt(br.readLine());
		for (int numCase = 1; numCase <= n; numCase++) {
			String line = br.readLine();
			String[] data = line.split(" ");

			int out = new A(data).runGame();
			bw.write(String.format("Case #%s: %s\n", numCase, out));
		}

		br.close();
		bw.close();
	}

	public A(String[] data) {
		for (int i = 1; i < data.length; i += 2) {
			String color = data[i];
			int num = Integer.parseInt(data[i + 1]);
			if ("O".equals(color)) {
				o.tasks.add(num);
				buttonOrders.add(O);
			} else {
				b.tasks.add(num);
				buttonOrders.add(B);
			}
		}
	}

	int runGame() {
		while (shouldContinue()) {
			makeMove();
			totalMoves++;
		}
		return totalMoves;
	}

	boolean shouldContinue() {
		return o.tasks.size() > 0 || b.tasks.size() > 0;
	}

	void makeMove() {
		//only one button press per round
		boolean buttonAvail = true;
		for (Bot bot : new Bot[] { o, b }) {
			
			if (!bot.tasks.isEmpty()) {
				// if more moves to make
				if (bot.pos == bot.tasks.peek()) {
					// already at target, either wait or push the btn
					if (buttonAvail && buttonOrders.peek() == bot.color) {
						// our move for the btn
						buttonAvail = false;
						buttonOrders.remove();
						bot.tasks.remove();
					} else {
						// just waiting
					}
				} else {
					// move towards our goal
					int target = bot.tasks.peek();
					if (target > bot.pos) {
						bot.pos++;
					} else {
						bot.pos--;
					}
				}
			}
		}
	}

	private class Bot {
		private final Color color;
		Queue<Integer> tasks = new LinkedList<Integer>();
		int pos = 1;

		public Bot(Color o) {
			color = o;
		}

		@Override
		public String toString() {
			return pos + ", " + tasks;
		}

	}
}
