package y2013;

import java.io.*;

/**
 * @author Mohsen Shabani
 */
public class TicTacToeTomek {
    private enum WinterType
    {
        XWIN,
        OWIN,
        NOWIN,
        DRAW
    }
    public static  BufferedReader br;
    public static  BufferedWriter bw;
    public static void main(String[] args) throws IOException {
        String inputPath = "d:\\A-small-attempt0.in";
        String outputPath = "d:\\A-small-attempt0.out";
        br = new BufferedReader(new FileReader(inputPath));
        bw = new BufferedWriter(new FileWriter(outputPath));

        int tc = Integer.parseInt(br.readLine());
        for (int tCount = 0; tCount < tc; tCount++) {
            String[][] arr = fillArray(br);
            br.readLine();
            boolean done = false;
            //check rows
            for (int m = 0;m<4;m++) {
                WinterType result = checkWinner(arr[m][0], arr[m][1], arr[m][2], arr[m][3]);
                if(result !=  WinterType.NOWIN) {
                    done = true;
                    writeOut(tCount,result);
                    break;
                }
            }
            if(done) continue;

            //check columns

            for (int m = 0;m<4;m++) {
                WinterType result = checkWinner(arr[0][m], arr[1][m], arr[2][m], arr[3][m]);
                if(result !=  WinterType.NOWIN) {
                    done = true;
                    writeOut(tCount,result);
                    break;
                }
            }
            if(done) continue;

            WinterType resultD1 = checkWinner(arr[0][0], arr[1][1], arr[2][2], arr[3][3]);
            if(resultD1 !=  WinterType.NOWIN) {
                done = true;
                writeOut(tCount,resultD1);
            }if(done) continue;

            WinterType resultD2 = checkWinner(arr[3][0], arr[2][1], arr[1][2], arr[0][3]);
            if(resultD2 !=  WinterType.NOWIN) {
                done = true;
                writeOut(tCount,resultD2);
            }if(done) continue;

            for (int l = 0;l<4;l++){
                for (int k = 0;k<4;k++){
                    if(arr[l][k].equals(".")){
                        done = true;
                        writeOut(tCount,resultD2);
                        break;
                    }
                }
                if(done) break;
            }
            if(done) continue;
            writeOut(tCount,WinterType.DRAW);
        }
        br.close();
        bw.close();
    }
    private static WinterType checkWinner(String a, String b, String c, String d) {
        String w = a+b+c+d;
        if(countOfChar(".",w) >= 2) return WinterType.NOWIN;
        if(countOfChar("X",w) == 4) return WinterType.XWIN;
        if(countOfChar("O",w) == 4) return WinterType.OWIN;
        if(countOfChar("X",w) == 3 && countOfChar("T",w) == 1) return WinterType.XWIN;
        if(countOfChar("O",w) == 3 && countOfChar("T",w) == 1) return WinterType.OWIN;
        return WinterType.NOWIN;
    }


    private static int countOfChar(String ch ,String s){
        int count = 0;
        for (int i = 0; i < s.length(); i++) {
             if(ch.equals(String.valueOf(s.charAt(i))))
                 count++;
        }
        return count;
    }
    private static void writeOut(int tc,WinterType winner) throws IOException {
        StringBuilder sb = new StringBuilder();
        sb.append("Case #").append(String.valueOf(tc + 1)).append(": ");

        if(winner == WinterType.XWIN)
            sb.append("X won");
        else if (winner == WinterType.OWIN)
            sb.append("O won");
        else if (winner == WinterType.DRAW)
            sb.append("Draw");
         else   sb.append("Game has not completed");

        sb.append("\n");
        bw.write(sb.toString());
    }

    private static String[][] fillArray(BufferedReader br) throws IOException {
        String[] lns = new String[4];
        for (int k = 0;k<4;k++) {
            lns[k] = br.readLine();
        }
        String[][] arr = new String[4][4];
        for (int i = 0;i<4;i++){
            for (int j = 0;j<4;j++){
                 arr[i][j] = String.valueOf(lns[i].charAt(j));
            }
        }
        return arr;
    }
}
