import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.StringTokenizer;


public class P4 {
	static PrintWriter out;
	static {
		try {
			out = new PrintWriter(new File("out.txt"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("D-small-attempt1.in"));
		
		String line = in.readLine();
		int T = Integer.parseInt(line.trim());
		for (int c = 1; c <= T; c++) {
			StringTokenizer st = new StringTokenizer(in.readLine());
			int P = Integer.parseInt(st.nextToken());
			List<Vertex> vList = new ArrayList<P4.Vertex>(P);
			for (int i = 0; i < P; i++) {
				vList.add(new Vertex(i));
			}
			int W = Integer.parseInt(st.nextToken());
			
			st = new StringTokenizer(in.readLine());
			for (int w = 0; w < W; w++) {
				String wormHole = st.nextToken();
				int idx = wormHole.indexOf(",");
				int source = Integer.parseInt(wormHole.substring(0,idx));
				int dest = Integer.parseInt(wormHole.substring(idx+1,wormHole.length()));
				vList.get(source).addLink(dest);
				vList.get(dest).addLink(source);
			}
			
			// travel
			Vertex start = vList.get(0);
			start.dist = 0;
			start.taken.add(0);
			
			boolean isFinished = false;
			List<Integer> currentVertiecs = new ArrayList<Integer>();
			List<Vertex> finishVertices = new ArrayList<Vertex>();
			currentVertiecs.add(0);
			while(!isFinished) {
				List<Integer> nextVertiecs = new ArrayList<Integer>();
				for (Integer cur : currentVertiecs) {
					Vertex v = vList.get(cur);
					for (Integer next : v.c) {
						Vertex n = vList.get(next);
						if(next==1) {
							isFinished = true;
							finishVertices.add(v); 
							break;
						}
						
						if(n.dist > v.dist+1) {
							// condition 2
							n.dist = v.dist+1;
							n.threats = new HashSet<Integer>(v.threats);
							n.threats.remove(next);	// remove self
							for (int i = 0; i < n.c.size(); i++) {
								if(!v.taken.contains(n.c.get(i))) {
									n.threats.add(n.c.get(i));
								}
							}
							n.taken = new HashSet<Integer>(v.taken);
							n.taken.add(next); // add self
							nextVertiecs.add(next);
						} else if(n.dist == v.dist+1) {
							// condition 3
							HashSet<Integer> newThreats = new HashSet<Integer>(v.threats);
							newThreats.remove(next); // remove self
							for (int i = 0; i < n.c.size(); i++) {
								if(!v.taken.contains(n.c.get(i))) {
									newThreats.add(n.c.get(i));
								}
							}
							if(newThreats.size() > n.threats.size()) {
								n.threats = newThreats;
								n.taken = new HashSet<Integer>(v.taken);
								n.taken.add(next); // add self
								nextVertiecs.add(next);
							}
						}
					}
				}
				currentVertiecs = nextVertiecs;
			}
			
			int conq = Integer.MAX_VALUE;
			int threat = 0;
			for (Vertex v : finishVertices) {
				if(v.dist < conq) {
					conq = v.dist;
					threat = v.threats.size();
				} else if(v.dist == conq) {
					if(v.threats.size() > threat) {
						threat = v.threats.size();
					}
				}
			}
			printf("Case #%d: %d %d\n", c, conq, threat);
		}
		in.close();
		out.close();
	}

	static class Vertex {
		int n;
		List<Integer> c = new ArrayList<Integer>();
		HashSet<Integer> taken = new HashSet<Integer>();
		HashSet<Integer> threats = new HashSet<Integer>();
		public Vertex(int n) {
			this.n = n;
		}
		public void addLink(int dest) {
			c.add(dest);
			threats.add(dest);
		}
		int dist = Integer.MAX_VALUE;
		@Override
		public String toString() {
			return n + " " + dist + " " + threats.size();
		}
	}
	
	static void println(String s) {
		System.out.println(s);
		out.println(s);
	}
	
	static void printf(String format, Object... args) {
		System.out.printf(format, args);
		out.printf(format, args);
	}
	
	static void close() {
		out.close();
	}
}
