package goo1A;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;

import org.apache.commons.lang.StringUtils;

public class ProblemA {
	static BufferedReader in;
	static PrintWriter out;
	public static void main(String[] args) throws Exception {
		in = new BufferedReader(new FileReader("A-small-attempt0.in"));
		out = new PrintWriter(new File("out.txt"));
		
		int cc = Integer.parseInt(in.readLine());
		for (int c = 1; c <= cc; c++) {
			// each test case
			String[] sp = StringUtils.split(in.readLine());
			int n = Integer.parseInt(sp[0]);
			int k = Integer.parseInt(sp[1]);
			
			
			char[][] b = new char[n][n];
			
			// read and turn clockwise
			for (int i = 0; i < n; i++) {
				String line = in.readLine();
				b[i] = line.toCharArray();
				turn(b[i]);
			}
			
//			for (int i = 0; i < b.length; i++) {
//				println(new String(b[i]));
//			}
//			println();
			
			// check winning situation
			boolean blueWin = false;
			boolean redWin = false;
			for (int i = 0; i < n; i++) {
				if(blueWin && redWin) break;
				for (int j = 0; j < n; j++) {
					if(b[i][j]=='.') continue;
					if(b[i][j] == 'B' && blueWin) continue;	// blue already win
					if(b[i][j] == 'R' && redWin) continue;	// red already win
					// check horizontal
					boolean status = checkWin(b[i][j], k, b, i, j);
					if(status) {
						if(b[i][j] == 'B') blueWin = true;
						if(b[i][j] == 'R') redWin = true;
					}
				}
			}
			
			String str = null;
			if(blueWin && redWin) str = "Both";
			else if(blueWin) str = "Blue";
			else if(redWin) str = "Red";
			else if(!blueWin && !redWin) str = "Neither";
			printf("Case #%d: %s\n", c, str);
		}
		
		
		out.close();
	}
	
	private static boolean checkWin(char c, int k, char[][] b, int i, int j) {
		if(checkHorizontal(b[i][j], k, b, i, j))
			return true;
		if(checkVertical(b[i][j], k, b, i, j))
			return true;
		if(checkDiag(b[i][j], k, b, i, j))
			return true;
		if(checkBackDiag(b[i][j], k, b, i, j))
			return true;
		return false;
	}

	private static boolean checkHorizontal(char verify, int k, char[][] b, int si, int sj) {
		if(sj>=b.length-k+1) return false;
		for (int x = 1; x < k; x++) {
			if(b[si][sj+x] != verify) return false;
		}
		return true;
	}
	
	private static boolean checkVertical(char verify, int k, char[][] b, int si, int sj) {
		if(si+k-1>=b.length) return false;
		for (int x = 1; x < k; x++) {
			if(b[si+x][sj] != verify) return false;
		}
		return true;
	}
	
	private static boolean checkDiag(char verify, int k, char[][] b, int si, int sj) {
		if(si+k-1>=b.length) return false;
		if(sj>=b.length-k+1) return false;
		for (int x = 1; x < k; x++) {
			if(b[si+x][sj+x] != verify) return false;
		}
		return true;
	}
	
	private static boolean checkBackDiag(char verify, int k, char[][] b, int si, int sj) {
		if(si+k-1>=b.length) return false;
		if(sj<k-1) return false;
		for (int x = 1; x < k; x++) {
			if(b[si+x][sj-x] != verify) return false;
		}
		return true;
	}

	private static void turn(char[] cs) {
		int wh = cs.length-1;
		int cb;
		while(true) {
			while(wh>=0 && cs[wh]!='.') wh--;
			cb = wh-1;
			while(cb>=0 && cs[cb]=='.') cb--;
			if(wh<0 || cb<0) break;
			cs[wh] = cs[cb];
			cs[cb] = '.';
			wh--;
		}
	}
	
	private static void println(String line) {
		out.println(line);
		System.out.println(line);
	}
	
	private static void println() {
		out.println();
		System.out.println();
	}
	
	private static void printf(String format, Object... o) {
		out.printf(format, o);
		System.out.printf(format, o);
	}
}
