import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Set;
import java.util.StringTokenizer;


public class P2 {
	static PrintWriter out;
	static {
		try {
			out = new PrintWriter(new File("out.txt"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("B-small-attempt1.in"));
		
		String line = in.readLine();
		int N = Integer.parseInt(line.trim());
		for (int c = 1; c <= N; c++) {
			StringTokenizer st = new StringTokenizer(in.readLine());
			int nWords = Integer.parseInt(st.nextToken());
			int nList = Integer.parseInt(st.nextToken());
			
			
			Map<Integer, WordGroup> wordLengthMap = new HashMap<Integer, WordGroup>();// length, num
			Word[] words = new Word[nWords];
			for (int i = 0; i < nWords; i++) {
				words[i] = new Word(in.readLine());
				WordGroup group = wordLengthMap.get(words[i].length());
				if(group==null) {
					group = new WordGroup();
					wordLengthMap.put(words[i].length(), group);
				}
				group.add(words[i]);
			}
			GList[] lists = new GList[nList];
			for (int i = 0; i < nList; i++) {
				lists[i] = new GList(in.readLine());
			}
			
			StringBuilder solution = new StringBuilder();
			for (int i = 0; i < nList; i++) {
				for (Word word : words) word.reset();
				List<WordGroup> wordGroups = new ArrayList<WordGroup>(wordLengthMap.values());
				if(!hasMore(wordGroups)) {
					solution.append(' ').append(findSolution(wordGroups, words));
					continue;
				} else {
					wordGroups = trim(wordGroups);
				}
				GList list = lists[i];

				for (int j = 0; j < list.length(); j++) {
					List<WordGroup> newGroups = new ArrayList<WordGroup>();
					char ch = list.get(j);
					for (WordGroup group : wordGroups) {
						List<WordGroup> splitedGroups = group.process(ch);
						newGroups.addAll(splitedGroups);
					}
					wordGroups = newGroups;
					if(!hasMore(wordGroups)) {
						solution.append(' ').append(findSolution(wordGroups, words));
						break;
					} else {
						wordGroups = trim(wordGroups);
					}
				}
			}
			printf("Case #%d:%s\n", c, solution.toString());
		}
		in.close();
		out.close();
	}
	
	private static List<WordGroup> trim(List<WordGroup> wordGroups) {
		return wordGroups;
//		List<WordGroup> n = new ArrayList<P2.WordGroup>();
//		for (WordGroup group : wordGroups) {
//			if(group.size()>1) n.add(group);
//		}
//		return n;
	}

	private static String findSolution(List<WordGroup> wordGroups, Word[] words) {
		int score = 0;
		Set<Word> potentialSolutions = new HashSet<Word>();
		for (WordGroup group : wordGroups) {
			Word word = group.getOnlyWord();
			if(word.score>score) {
				score = word.score;
				potentialSolutions = new HashSet<Word>();
				potentialSolutions.add(word);
			} else if(word.score==score) {
				potentialSolutions.add(word);
			} else {
				// ignore
			}
		}
		for (Word word : words) {
			if(potentialSolutions.contains(word)) {
				return word.word;
			}
		}
		throw new RuntimeException("NO Solution");
	}

	private static boolean hasMore(List<WordGroup> wordGroups) {
		for (WordGroup wordGroup : wordGroups) {
			if(wordGroup.size()>1) return true;
		}
		return false;
	}

	static void println(String s) {
		System.out.println(s);
		out.println(s);
	}
	
	static void printf(String format, Object... args) {
		System.out.printf(format, args);
		out.printf(format, args);
	}
	
	static void close() {
		out.close();
	}
	
	static class WordGroup {
		List<Word> words = new ArrayList<Word>();

		public void add(Word word) {
			words.add(word);
		}

		public List<WordGroup> process(char ch) {
			assert words.size()>1;
			boolean contain = false;
			for (Word word : words) {
				if(word.contains(ch)) {
					contain = true;
					break;
				}
			}
			if(!contain) return Collections.singletonList(this);
			
			Map<Mask, WordGroup> newMap = new HashMap<Mask, WordGroup>();
			for (Word word : words) {
				word.set(ch);
				WordGroup newGroup = newMap.get(word.mask);
				if(newGroup==null) {
					newGroup = new WordGroup();
					newMap.put(word.mask, newGroup);
				}
				newGroup.add(word);
			}
			
			return new ArrayList<WordGroup>(newMap.values());
		}

		public Word getOnlyWord() {
			assert words.size()==1;
			return words.get(0);
		}

		public int size() {
			return words.size();
		}
		
		@Override
		public String toString() {
			return words.toString();
		}
	}
	
	static class Mask {
		boolean[] bs;
		public Mask(int len) {
			bs = new boolean[len];
		}
		public void set(int i) {
			bs[i] = true;
		}
		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + Arrays.hashCode(bs);
			return result;
		}
		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Mask other = (Mask) obj;
			if (!Arrays.equals(bs, other.bs))
				return false;
			return true;
		}
	}
	
	static class Word {
		String word;
		Mask mask;
		int score = 0;
		public Word(String word) {
			this.word = word;
			this.mask = new Mask(word.length());
		}
		public boolean contains(char ch) {
			return word.indexOf(ch)>=0;
		}
		public void set(char ch) {
			boolean hit = false;
			for (int i = 0; i < word.length(); i++) {
				if(word.charAt(i)==ch) {
					mask.set(i);
					hit = true;
				}
			}
			if(!hit) score++;
		}
		public int length() {
			return word.length();
		}
		public void reset() {
			this.mask = new Mask(word.length());
			this.score = 0;
		}
		@Override
		public int hashCode() {
			final int prime = 31;
			int result = 1;
			result = prime * result + ((word == null) ? 0 : word.hashCode());
			return result;
		}
		@Override
		public boolean equals(Object obj) {
			if (this == obj)
				return true;
			if (obj == null)
				return false;
			if (getClass() != obj.getClass())
				return false;
			Word other = (Word) obj;
			if (word == null) {
				if (other.word != null)
					return false;
			} else if (!word.equals(other.word))
				return false;
			return true;
		}
		@Override
		public String toString() {
			return word + "-" + score;
		}
	}
	static class GList {
		String list;
		public GList(String list) {
			this.list = list;
		}
		public char get(int i) {
			return list.charAt(i);
		}
		public int length() {
			return list.length();
		}
	}
}
