package gooB;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.PrintWriter;
import java.util.Arrays;

import org.apache.commons.math.util.MathUtils;

public class ProblemC {
	static BufferedReader in;
	static PrintWriter out;
	static int[][] dp;
	public static void main(String[] args) throws Exception {
		in = new BufferedReader(new FileReader("C-small-attempt0.in"));
		out = new PrintWriter(new File("out.txt"));
		
		int cc = Integer.parseInt(in.readLine());
		for (int c = 1; c <= cc; c++) {
			// for each case
			int N = Integer.parseInt(in.readLine());
			dp = new int[N+1][N+1];		// sum for num i at pos j
			for (int i = 0; i < dp.length; i++) {
				dp[i] = new int[N];
				Arrays.fill(dp[i], 0);
			}
			for (int i = 0; i < dp.length; i++) {
				dp[i][1] = 1;
			}
			for (int n = 3; n <= N; n++) {	// for each n
				for (int pos = 2; pos < n ; pos++) {
					dp[n][pos] = 0;
					int dist = n-pos;
					for (int p2 = Math.max(1, pos-dist); p2 <= pos-1; p2++) {
						dp[n][pos] += dp[pos][p2]*chose(n-pos-1, pos-p2-1);
					}
				}
			}
			int sum = 0;
			for (int pos = 1; pos < N; pos++) {
				sum += dp[N][pos];
			}
			printf("Case #%d: %d\n", c, sum%100003);
		}
		
		out.close();
	}
	
	private static long chose(int n, int k) {
		if(n<k) return 1;
		return MathUtils.binomialCoefficient(n, k);
	}

	static void println(String s) { out.println(s); System.out.println(s); }
	static void println() { out.println(); System.out.println(); }
	static void printf(String s, Object... o) { out.printf(s, o); System.out.printf(s, o); }
}
