import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.StringTokenizer;


public class P1 {
	static PrintWriter out;
	static {
		try {
			out = new PrintWriter(new File("out.txt"));
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}

	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("A-large.in"));
		
		String line = in.readLine();
		int N = Integer.parseInt(line.trim());
		for (int c = 1; c <= N; c++) {
			line = in.readLine();
			StringTokenizer st = new StringTokenizer(line);
			int num = Integer.parseInt(st.nextToken());
			
			List<Seq> seqs = new ArrayList<Seq>(num);
			for (int i = 0; i < num; i++) {
				boolean type = "O".equals(st.nextToken());
				int button = Integer.parseInt(st.nextToken());
				seqs.add(new Seq(type, button));
			}
			
			int totalTime = 0;
			int oCur = 1;
			int oIdle = 0;
			int bCur = 1;
			int bIdle = 0;
			for (Seq seq : seqs) {
				if(seq.type) { //O
					int dist = Math.abs(seq.button-oCur);
					int time = Math.max(dist-oIdle,0)+1;
					oIdle = 0;
					oCur = seq.button;
					bIdle += time;
					totalTime += time;
				} else {
					int dist = Math.abs(seq.button-bCur);
					int time = Math.max(dist-bIdle,0)+1;
					bIdle = 0;
					bCur = seq.button;
					oIdle += time;
					totalTime += time;
				}
			}
			printf("Case #%d: %d\n", c, totalTime);
		}
		in.close();
		out.close();
	}
	
	static void println(String s) {
		System.out.println(s);
		out.println(s);
	}
	
	static void printf(String format, Object... args) {
		System.out.printf(format, args);
		out.printf(format, args);
	}
	
	static void close() {
		out.close();
	}
}

class Seq {
	boolean type;
	int button;
	public Seq(boolean type, int button) {
		this.type = type;
		this.button = button;
	}
}

