package goo;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Comparator;
import java.util.StringTokenizer;

public class GcdSmall {
	public static void main(String[] args) throws IOException {
		BufferedReader in = new BufferedReader(new FileReader("B-small-attempt2.in"));
		PrintWriter out = new PrintWriter(new FileWriter("out.txt"));
		
		int T = Integer.parseInt(in.readLine());
		for (int cas = 1; cas <= T; cas++) {
			StringTokenizer st = new StringTokenizer(in.readLine(), " ");
			int N = Integer.parseInt(st.nextToken());
			long[] nums = new long[N];
			for (int i = 0; i < nums.length; i++) {
				nums[i] = Long.parseLong(st.nextToken());
			}
			Arrays.sort(nums);
			
			long[][] factors = new long[nums.length-1][];
			for (int i = 0; i < nums.length-1; i++) {
				factors[i] = findXAndFactor(nums[i], nums[i+1]);
			}
			Arrays.sort(factors, new Comparator<long[]>(){
				@Override
				public int compare(long[] o1, long[] o2) {
					return new Long(o1[1]).compareTo(o2[1]);
				}
			});
			
			boolean equals = true;
			long[] minFactor = factors[0];
			for (int i = 1; i < factors.length; i++) {
				long factor = gcd(minFactor[1], factors[i][1]);
				if(factor != minFactor[1]) {
					equals = false;
					break;
				}
			}
			if(equals) {
				System.out.printf("Case #%d: %d\n", cas, minFactor[0]);
				out.printf("Case #%d: %d\n", cas, minFactor[0]);
			} else {
				System.out.printf("Case #%d: 0\n", cas);
				out.printf("Case #%d: 0\n", cas);
			}
		}
		
		out.close();
		in.close();
	}
	
	private static long[] findXAndFactor(long a, long b) {
		if(a==b) return new long[]{0, b};
		if(b>a) return findXAndFactor(b, a);
		
		long r = a-b;
		while(b>r) b = b-r;
		long x = r-b;
		return new long[]{x, r};
	}

	int gcd(int a, int b) {
		if(a==0) {
			return b;
		}
		while(b!=0) {
			if(a>b)
				a = a - b;
			else
				b = b - a;
		}
		return a;
	}
	
	static long gcd(long a, long b) {
		if(a==0) {
			return b;
		}
		while(b!=0) {
			if(a>b)
				a = a-b;
			else
				b = b-a;
		}
		return a;
	}
}
