package tictactoe;


import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTacToe {

    private boolean areMovesLeft = false;
    private int ROWS = 4;
    private int COLS = 4;
    private char playerX = 'X';
    private char playerO = 'O';
    private char tomek = 'T';
    private char empty = '.';
    private char[][] state = new char[ROWS][COLS];
    public  int cases;
    
    private void loadState(Scanner sc) {
        for (int r = 0; r < ROWS; ++r) {
            String line = sc.nextLine();
            System.out.println(line + " " + line.length());
            for (int c = 0; c < COLS; ++c) {
                state[r][c] = line.charAt(c);
            }
        }
    }

    private String getGameStatus() {
        char lastMark;
        char linePlayer;
        boolean isSameMark;
        areMovesLeft = false;
        
        // Check rows
        for (int i = 0; i < ROWS; ++i) {
            isSameMark = true;
            linePlayer = '-';
            for (int j = 0; j < COLS; ++j) {
                if (state[i][j] == empty) {
                    areMovesLeft = true;
                    isSameMark = false;
                    break;
                }
                lastMark = state[i][j];
                if (state[i][j] != tomek) {
                    if (linePlayer != '-' && state[i][j] != linePlayer) {
                    isSameMark = false;
                }
                    linePlayer = state[i][j];
                }
                if (state[i][j] != lastMark && state[i][j] != tomek && lastMark != tomek) {
                    isSameMark = false;
                }
            }
            if (isSameMark) {
                return linePlayer + " won";
            }
        }
        //check columns
        
        for (int i = 0; i < COLS; ++i) {
            isSameMark = true;
            linePlayer = '-';
            for (int j = 0; j < ROWS; ++j) {
                if (state[j][i] == empty) {
                    areMovesLeft = true;
                    isSameMark = false;
                    break;
                }
                lastMark = state[j][i];
                if (state[j][i] != tomek) {
                    if (linePlayer != '-' && state[j][i] != linePlayer) {
                    isSameMark = false;
                }
                    linePlayer = state[j][i];
                }
                if (state[j][i] != lastMark && state[j][i] != tomek && lastMark != tomek) {
                    isSameMark = false;
                }
            }
            if (isSameMark) {
                return linePlayer + " won";
            }
        }
        // check diagonals
        isSameMark = true;
        linePlayer = '-';
        for (int i = 0; i < COLS; ++i) {
            if (state[i][i] == empty) {
                areMovesLeft = true;
                isSameMark = false;
                break;
            }
            lastMark = state[i][i];
            if (state[i][i] != tomek) {
                if (linePlayer != '-' && state[i][i] != linePlayer) {
                    isSameMark = false;
                }
                linePlayer = state[i][i];
            }
            if (state[i][i] != lastMark && state[i][i] != tomek && lastMark != tomek) {
                isSameMark = false;
            }
        }
        if (isSameMark) {
            return linePlayer + " won";
        }
        
        isSameMark = true;
        linePlayer = '-';
        for (int i = 0; i < COLS; ++i) {
            if (state[i][COLS - 1 - i] == empty) {
                areMovesLeft = true;
                isSameMark = false;
                break;
            }
            lastMark = state[i][COLS - 1 - i];
            if (state[i][COLS - 1 - i] != tomek) {
                if (linePlayer != '-' && state[i][COLS - 1 - i] != linePlayer) {
                    isSameMark = false;
                }
                linePlayer = state[i][COLS - 1 - i];
            }
            if (state[i][COLS - 1 - i] != lastMark && state[i][COLS - 1 - i] != tomek && lastMark != tomek) {
                isSameMark = false;
            }
        }
        if (isSameMark) {
            return linePlayer + " won";
        }
        
        // no winner
        if (areMovesLeft) {
            return "Game has not completed";
        } else {
            return "Draw";
        }
    }
    
//    private void execute() {
//        String dir = "~/codejam";
//        Scanner sc = new Scanner(new FileReader(dir + "p1test.in"));
//        PrintWriter pw = new PrintWriter(new FileWriter(dir + "p1test_output.txt"));
//        cases = sc.nextInt();
//        sc.nextLine();
//        for (int i = 1; i <= cases; ++i) {
//            loadState(sc);
//            pw.print("Case #" + i + ": " + getGameStatus());
//        }
//        pw.flush();
//        pw.close();
//        sc.close();
//    }
    
    public static void main(String[] args) {
        TicTacToe t = new TicTacToe();
        String dir = "/home/eduardo_gomez/codejam/";
        try {
            try {
                Scanner sc = new Scanner(new FileReader(dir + "A-large.in"));
                try {
                    PrintWriter pw = new PrintWriter(new FileWriter(dir + "A-large.out"));
                    t.cases = sc.nextInt();
                    System.out.println(t.cases);
                    
                    for (int i = 1; i <= t.cases; ++i) {
                        sc.nextLine();
                        t.loadState(sc);
                        pw.print("Case #" + i + ": " + t.getGameStatus() + "\n");
                    }
                    pw.flush();
                    pw.close();
                    sc.close();
                } catch (IOException e) {
                    
                    e.printStackTrace();
                }

            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            
        }
    }
    
    
}
