package deceitfulwar;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;


public class DeceitfulWar {
    private int testCases;
    private int blockNum;
    private List<Double> naomi;
    private List<Double> ken;
    private double inc = 0.00000001;
    
    private void loadState(Scanner sc) {
        naomi = new ArrayList<>();
        ken   = new ArrayList<>();
        blockNum = sc.nextInt();
        for (int j = 1; j <= blockNum; ++j) {
            naomi.add(new Double(sc.nextDouble()));
        }
        for (int j = 1; j <= blockNum; ++j) {
            ken.add(new Double(sc.nextDouble()));
        }
        Collections.sort(ken);
        Collections.sort(naomi);
    }
    
    private Double findMinViable(List<Double> l, Double d) {
        Double res = null;
        for (Double e : l) {
            if (e.compareTo(d) > 0) {
                res = e;
                break;
            }
        }
        return res;
    }
    
    private Double kenWarChoice(List<Double> k, Double nc) {
        Double choice;
        Double minViable = findMinViable(k, nc);
        if (minViable != null) {
            choice = minViable;
        } else {
            choice = Collections.min(k);
        }
        return choice;
    }
    
    private Double naomiWarChoice(List<Double> n) {
        Double choice = Collections.min(n);
        return choice;
    }
    
    private Double naomiDWChoice(List<Double> n, List<Double> k) {
        Double choice = Collections.min(n);
        if (Collections.max(n).compareTo(Collections.max(k)) > 0 &&
                Collections.min(n).compareTo(Collections.min(k)) < 0 ) {
            choice = findMinViable(n, Collections.min(k));
        }
        if (Collections.min(n).compareTo(Collections.min(k)) > 0) {
            choice = Collections.min(n);
        }
        if (Collections.min(n).compareTo(Collections.min(k)) < 0 &&
                (n.size() > 2 && n.get(1).compareTo(k.get(0)) > 0 &&  n.get(1).compareTo(k.get(1)) < 0)
                ) {
            choice = n.get(1);
        }
        return choice;
    }
    
    private Double naomiDWTellChoice(List<Double> n, List<Double> k) {
        if (n.size() == 1) return n.get(0);
        if (Collections.min(n).compareTo(Collections.max(k)) > 0) {
            return Collections.min(n);
        }
        if (Collections.min(n).compareTo(Collections.min(k)) > 0) {
            inc += 0.00000001;
            return new Double(Collections.max(k).doubleValue() + inc);
        }
        if (Collections.min(n).compareTo(Collections.min(k)) < 0 &&
                (n.size() > 2 && n.get(1).compareTo(k.get(0)) > 0 &&  n.get(1).compareTo(k.get(1)) < 0) 
                ) {
            inc += 0.00000001;
            return new Double(Collections.max(k).doubleValue() + inc);
        }
        if (Collections.max(n).compareTo(Collections.max(k)) > 0 ) {
            inc += 0.00000001;
            return new Double(Collections.max(k).doubleValue() + inc);
        }
        return new Double(Collections.max(k).doubleValue() - 0.00000001);
    }
    
    private int warPoints() {
        List<Double> n = new ArrayList<>(naomi);
        List<Double> k = new ArrayList<>(ken);
        int points = 0;
        Double nc, kc;
        for (int i = 0; i < blockNum; ++i) {
            nc = naomiWarChoice(n);
            kc = kenWarChoice(k, nc);
            points += nc.compareTo(kc) > 0 ? 1 : 0;
            n.remove(nc);
            k.remove(kc);
        }
        return points;
    }
    
    private int dwPoints() {
        List<Double> n = new ArrayList<>(naomi);
        List<Double> k = new ArrayList<>(ken);
        int points = 0;
        Double nc, kc;
        System.err.println("TC");
        for (int i = 0; i < blockNum; ++i) {
            nc = naomiDWChoice(n,k);
            kc = kenWarChoice(k, naomiDWTellChoice(n,k));
            System.out.println("DW: " +nc + " " + kc);
            points += nc.compareTo(kc) > 0 ? 1 : 0;
            n.remove(nc);
            k.remove(kc);
        }
        return points;
    }
    
    private String getAnswer() {
        return "" + dwPoints() + " " + warPoints();
    }


    public static void main(String[] args) {
        String dir = "/home/eduardo_gomez/codejam/2014/Qualification/D/";
        DeceitfulWar dw = new DeceitfulWar();
        try {
            try {
                Scanner sc = new Scanner(new FileReader(dir + "D-small-attempt2.in"));
                try {
                    PrintWriter pw = new PrintWriter(new FileWriter(dir + "D-small-attempt2.out"));
                    dw.testCases = sc.nextInt();
                    System.out.println(dw.testCases);
                    
                    for (int i = 1; i <= dw.testCases; ++i) {
                        sc.nextLine();
                        dw.loadState(sc);
                        pw.print("Case #" + i + ": " + dw.getAnswer() + "\n");
                    }
                    pw.flush();
                    pw.close();
                    sc.close();
                } catch (IOException e) {
                    
                    e.printStackTrace();
                }

            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            
        }
    }
}
