import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class TicTacToe {
	public static void main(String args[]) {
		BufferedReader inputReader;
		try {
			inputReader = new BufferedReader(new FileReader("A-large.in"));
			System.out.println("start");
			String line = inputReader.readLine();
			BufferedWriter outWriter = new BufferedWriter(new FileWriter(
					"output.txt"));
			int gSize = Integer.parseInt(line);
			for (int g = 1; g <= gSize; g++) {
				char[][] gameBoard = new char[4][4];
				for (int i = 0; i < 4; i++) {
					line = inputReader.readLine();
					gameBoard[i] = line.toCharArray();
				}
				String result = runCompute(gameBoard);
				outWriter.write("Case #" + g + ": " + result + "\n");
				System.out.println("Case #" + g + ": " + result + "\n");
				inputReader.readLine();
			}
			outWriter.flush();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static String runCompute(char[][] gameBoard) {
		boolean empty = false;
		for (int i = 0; i < 4; i++) {
			char last = gameBoard[i][0];
			if (last == '.') {
				empty = true;
				continue;
			}
			for (int j = 1; j < 4; j++) {
				char now = gameBoard[i][j];
				if (now == '.') {
					empty = true;
					break;
				}
				String success = computeNowLast(last, now, j == 3);
				if (null == success) {
					break;
				} else if (!"next".equals(success)) {
					System.out.println("in r " + i + " " + j);
					return success;
				}
				last = now;
			}
		}
		for (int i = 0; i < 4; i++) {
			char last = gameBoard[0][i];
			System.out.println(0 + " " + i + " = " + last);
			if (last == '.') {
				empty = true;
				continue;
			}
			for (int j = 1; j < 4; j++) {
				char now = gameBoard[j][i];
				System.out.println(j + " " + i + " = " + now);
				if (now == '.') {
					empty = true;
					break;
				}
				String success = computeNowLast(last, now, j == 3);
				if (null == success) {
					break;
				} else if (!"next".equals(success)) {
					System.out.println("in c " + i + " " + j);
					return success;
				}
				last = now;
			}

		}
		char last = gameBoard[0][0];
		if (last != '.') {
			for (int j = 1; j < 4; j++) {
				char now = gameBoard[j][j];
				if (now == '.') {
					break;
				}
				String success = computeNowLast(last, now, j == 3);
				if (null == success) {
					break;
				} else if (!"next".equals(success)) {
					System.out.println("in d " + j + " " + j);
					return success;
				}

				last = now;
			}
		}
		last = gameBoard[0][3];
		if (last != '.') {
			for (int j = 1; j < 4; j++) {
				char now = gameBoard[j][3 - j];
				if (now == '.') {
					break;
				}
				String success = computeNowLast(last, now, j == 3);
				if (null == success) {
					break;
				} else if (!"next".equals(success)) {
					System.out.println("in d " + j + " " + (3 - j));
					return success;
				}

				last = now;
			}
		}
		if (empty) {
			return "Game has not completed";
		} else {
			return "Draw";
		}
	}

	public static String computeNowLast(char last, char now, boolean finalItem) {

		if ('T' != now && 'T' != last) {
			if (now != last) {
				return null;
			}
		}
		if (finalItem) {
			char win = now == 'T' ? last : now;
			return win + " won";
		}
		return "next";

	}
}
