import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Scanner;

public class DecifulWar {

    public List<Double> rowOne;
    public List<Double> rowTwo;

    public DecifulWar(Scanner scanner) {

        int num = scanner.nextInt();

        scanner.nextLine();
        System.out.println(num);
        rowOne = readRow(scanner, num);
        rowTwo = readRow(scanner, num);

    }

    public int getResult() {
        int len = rowOne.size();
        int winCount = 0;
        int i, j;
        i = j = 0;
        while ( i < len && j < len ) {
            double a = rowOne.get(i);
            double b = rowTwo.get(j);
            if ( a < b ) {
                winCount++;
                i++;j++;
            }else{
                j++;
            }
        }
        return len - winCount;
    }

    public int getDeceifulResult() {
        int len = rowOne.size();
        int i, j;
        i = j = len - 1;
        int winCount = 0;

        while ( i >= 0 && j >= 0 ) {
            double a = rowOne.get(i);
            double b = rowTwo.get(j);
            if ( a > b ) {
                winCount++;
                i--;
                j--;
            } else {
                j--;
            }
        }
        return winCount;
    }

    public List<Double> readRow(Scanner scanner, int num) {
        List<Double> rowNumber = new ArrayList<Double>();
        String line = scanner.nextLine();
        if ( line != null ) {
            String numberArray[] = line.split(" ");
            for ( int i = 0; i < num; i++ ) {
                rowNumber.add(Double.parseDouble(numberArray[i]));
            }
        }
        Collections.sort(rowNumber);
        for ( int i = 0; i < num; i++ ) {
            System.out.print(rowNumber.get(i) + " ");
        }
        System.out.println();
        return rowNumber;
    }

    public static void main(String[] args) {
        Scanner scanner;
        try {
            scanner = new Scanner(new FileInputStream("input.txt"));
            FileWriter out = new FileWriter("output.txt");
            BufferedWriter outoutStream = new BufferedWriter(out);
            int t = scanner.nextInt();
            for ( int i = 0; i < t; i++ ) {
                DecifulWar war = new DecifulWar(scanner);
                outoutStream.write("Case #" + ( i + 1 ) + ": "
                    + war.getDeceifulResult() + " " + war.getResult() + "\n");

            }
            outoutStream.flush();
        } catch ( FileNotFoundException e ) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch ( IOException e ) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }

    }
}
