import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class FairSquare {
	public static void main(String args[]) {
		BufferedReader inputReader;
		try {
			inputReader = new BufferedReader(new FileReader("input.txt"));
			String line = inputReader.readLine();
			BufferedWriter outWriter = new BufferedWriter(new FileWriter(
					"output.txt"));
			int gSize = Integer.parseInt(line);
			for (int g = 1; g <= gSize; g++) {
				line = inputReader.readLine();
				String[] AB = line.split(" ");
				int A = Integer.parseInt(AB[0]);
				int B = Integer.parseInt(AB[1]);

				String result = runCompute(A, B);
				outWriter.write("Case #" + g + ": " + result + "\n");
				System.out.println("Case #" + g + ": " + result + "\n");
			}
			outWriter.flush();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static String runCompute(int A, int B) {
		int sqrtF = (int) Math.floor(Math.sqrt(A));
		int sqrtT = (int) Math.floor(Math.sqrt(B));
		int count = 0;
		for (int i = sqrtF; i <= sqrtT; i++) {
			int square = i * i;
			if (square >= A && square <= B) {
				if (computePalindrom(i)) {
					boolean isPalindrom = computePalindrom(square);
					if (isPalindrom) {
						count += 1;
					}
				}
			}
		}
		return count + "";
	}

	private static boolean computePalindrom(int square) {
		int ori = square;
		List<Integer> squareList = new ArrayList<Integer>();
		while (square >= 1) {
			int num = square % 10;
			squareList.add(num);
			square /= 10;
		}

		for (int i = 0; i < squareList.size(); i++) {
			int j = squareList.size() - i - 1;
			if (squareList.get(i) != squareList.get(j)) {
				return false;
			}

		}
		System.out.println("find " + ori);
		return true;
	}
}
