import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

/**
 * Created by wenchihhsieh on 2017/4/8.
 */
public class BathroomStall {
    public static void main(String args[]) {
        File file = new File("C-small-1-attempt0.in");
        File output = new File("out.txt");
        try {
            FileWriter fileWriter = new FileWriter(output);
            Scanner scanner = new Scanner(file);
            int num = scanner.nextInt();
            for (int k = 1; k <= num; k++) {
                int stalls = scanner.nextInt();
                int people = scanner.nextInt();
                String result = findResult(stalls, people);
                fileWriter.write(String.format("Case #%d: %s\n", k, result));
            }
            fileWriter.flush();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static String findResult(long stalls, long num) {
        LinkedList<Long> longList = new LinkedList<>();
        Map<Long, Long> numMap = new HashMap<>();
        longList.add(stalls);
        //System.out.println("add " + stalls);
        addSlot(numMap, stalls);
        long divides[] = new long[2];
        for (int i = 0; i < num; i++) {
            long slot = longList.getFirst();
            long remain = slot - 1;
            if (remain % 2 == 1) {
                divides[0] = remain / 2;
                divides[1] = remain / 2 + 1;
            } else {
                divides[0] = remain / 2;
                divides[1] = remain / 2;
            }
            addSlot(numMap, divides[0]);
            addSlot(numMap, divides[1]);
            long last = longList.getLast();
           // System.out.println(last + " divide " +divides[0] + " " + divides[1]);
            if (last > divides[1]) {
                longList.add(divides[1]);
               // System.out.println("add " + divides[1]);

            }
            last = Math.min(last,divides[1]);
            if (last > divides[0]) {
                longList.add(divides[0]);
               // System.out.println("add " + divides[0]);

            }
           // System.out.println(slot);
            long slotNum = numMap.get(slot);
            if (slotNum == 1) {
                numMap.remove(slot);
                longList.removeFirst();
            } else {
                numMap.put(slot, slotNum - 1);
            }
        }
        return divides[1] + " " + divides[0];
    }

    private static void addSlot(Map<Long, Long> map, long slot) {
        if (map.containsKey(slot)) {
            map.put(slot, map.get(slot) + 1);
        } else {
            map.put(slot, 1L);
        }
    }
}
