import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;

/**
 * Created by wenchihhsieh on 2017/4/15.
 */
public class PanCake {
    public static class Cake {
        int radius;
        int height;
        double pile;
        double plate;

        public Cake(int r, int h) {
            radius = r;
            height = h;
            pile = 2 * Math.PI * r * h;
            plate = Math.PI * r * r;
        }

    }

    public static void main(String args[]) {
        File file = new File("A-small.in");
        File output = new File("out.txt");
        try {
            FileWriter fileWriter = new FileWriter(output);
            Scanner scanner = new Scanner(file);
            int num = scanner.nextInt();
            for (int t = 1; t <= num; t++) {
                scanner.nextLine();
                //Hd, Ad, Hk, Ak, B, 
                int n = scanner.nextInt();
                int k = scanner.nextInt();
                Cake cakes[] = new Cake[n];
                for (int i = 0; i < n; i++) {
                    cakes[i] = new Cake(scanner.nextInt(), scanner.nextInt());
                }
                double result = findResult(n, k, cakes);
                System.out.println("case " + t + " " + result);
                fileWriter.write(String.format("Case #%d: %s\n", t, result));
            }
            fileWriter.flush();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }

    private static double findResult(int n, int k, Cake[] cakes) {
        Arrays.sort(cakes, new Comparator<Cake>() {
            @Override
            public int compare(Cake o1, Cake o2) {
                return o1.radius - o2.radius;
            }
        });
        double max = 0;

        for (int i = k-1; i < n; i++) {
            double bottom = cakes[i].pile + cakes[i].plate;
            max = Math.max(max, helper(i, k - 1, cakes) + bottom);
        }

        return max;

    }

    private static double helper(int n, int k, Cake[] cakes) {
        Arrays.sort(cakes, 0, n, new Comparator<Cake>() {
            @Override
            public int compare(Cake o1, Cake o2) {
                if (o1.pile > o2.pile) {
                    return -1;
                } else {
                    return 1;
                }
            }
        });
        double result = 0;
        for (int i = 0; i < k; i++) {
            result += cakes[i].pile;
        }
        return result;
    }


}
