import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Formatter;

public class PasswordProblem {
	public static void main(String args[]) {
		try {
			BufferedReader inputReader = new BufferedReader(new FileReader(
					"input.txt"));
			String line = inputReader.readLine();
			BufferedWriter outWriter = new BufferedWriter(new FileWriter(
					"output.txt"));
			int number = Integer.parseInt(line);
			for (int i = 1; i <= number; i++) {
				String result = "Case #" + i + ": ";
				line = inputReader.readLine();
				String inputs[] = line.split(" ");
				int typed = Integer.parseInt(inputs[0]);
				int num = Integer.parseInt(inputs[1]);
				line = inputReader.readLine();
				inputs = line.split(" ");
				float p[] = new float[typed];
				for (int k = 0; k < typed; k++) {
					p[k] = Float.valueOf(inputs[k]);
				}
				String expected = compute(typed, num, p);
				result = result + expected + "\n";
				outWriter.write(result);
			}
			outWriter.flush();
			outWriter.close();
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

	private static String compute(int typed, int num, float[] p) {
		int row = 1 << typed;
		int col = typed + 1;// continue + enter + delete(typed-1)
		int keystroke[] = new int[col];

		keystroke[0] = num - typed + 1;
		for (int i = 1; i < col - 1; i++) {
			keystroke[i] = keystroke[i - 1] + 2;
		}
		keystroke[col - 1] = num + 2;
		float ri[] = new float[typed];
		ri[typed - 1] = p[0];
		int k = 0;
		for (int i = typed - 2; i >= 0; i--) {
			k++;
			ri[i] = ri[i + 1] * p[k];
		}

		float expected = keystroke[col - 1];
		for (int i = 0; i < col - 1; i++) {
			float newE = keystroke[i] * ri[i] + (1 - ri[i])
					* (keystroke[i] + num + 1);
			expected = Math.min(expected, newE);
		}
		Formatter formatter = new Formatter();
		String result = formatter.format("%6f", expected).toString();
		System.out.println(result);
		return result;
	}

	public static int getResult(int number, int surprise, int point,
			int scores[]) {
		int surpriseLimit = 3 * point - 4;
		if (surpriseLimit <= 0) {
			surpriseLimit = point;
		}
		int acceptableLimit = 3 * point - 2;
		if (acceptableLimit <= 0) {
			acceptableLimit = point;
		}
		int surpriseNum = 0;
		int acceptableNum = 0;
		for (int i = 0; i < scores.length; i++) {
			int score = scores[i];
			if (score < acceptableLimit && score >= surpriseLimit) {
				surpriseNum++;
			} else if (score >= acceptableLimit) {
				acceptableNum++;
			}
		}
		return acceptableNum + Math.min(surpriseNum, surprise);
	}
}
