import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.Set;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.HashSet;
import java.util.List;
import java.util.StringTokenizer;
import java.math.BigInteger;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        CODEJAM_2016_CoinJam solver = new CODEJAM_2016_CoinJam();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class CODEJAM_2016_CoinJam {
        Set<String> pool;
        List<Entry> results;
        StringBuilder sb;
        int n;
        int J;
        int lim = 5000;
        BigInteger zero = BigInteger.valueOf(0);
        BigInteger one = BigInteger.valueOf(1);
        BigInteger two = BigInteger.valueOf(2);
        BigInteger three = BigInteger.valueOf(3);

        public void solve(int testNumber, InputReader input, PrintWriter out) {
            FastScanner in = new FastScanner(input);
            n = in.i();
            J = in.i();

            //sieve();

            sb = new StringBuilder(n);
            sb.append('1');
            for (int i = 1; i <= n - 2; ++i)
                sb.append('0');
            sb.append('1');

            results = new ArrayList<>();
            pool = new HashSet<>();

            build(1);

//        for(String s : pool)
//            out.println(s);

            calc();
            for (Entry e : results) {
                out.print(e.num);
                for (int i = 2; i <= 10; ++i) {
                    out.print(" " + e.divisors[i]);
                    BigInteger bi = new BigInteger(e.num, i);
                    if (!bi.mod(e.divisors[i]).equals(zero))
                        out.println("Shit!");
                }
                out.println();
            }
        }

        void calc() {
            boolean ok;
            BigInteger[] bases = new BigInteger[11];
            for (String s : pool) {
                ok = true;
                for (int i = 2; i <= 10; ++i) {
                    bases[i] = new BigInteger(s, i);
                    if (bases[i].isProbablePrime(1)) {
                        ok = false;
                        break; // can be a prime
                    }
                }
                if (ok) {
                    Entry e = new Entry();
                    e.num = s;
                    for (int i = 2; i <= 10; ++i) {
                        BigInteger bi = bases[i];
                        BigInteger d = smallestPrimeFactor(bi);
                        e.divisors[i] = d;
                    }
                    results.add(e);
                    if (results.size() == J)
                        return;
                }
            }
        }

        private BigInteger smallestPrimeFactor(BigInteger n) {
            if (n.mod(two).compareTo(BigInteger.ZERO) == 0)
                return two;

            BigInteger sqrt = sqrt(n).add(one);
            for (BigInteger i = three; i.compareTo(sqrt) <= 0; i = i.add(two)) {
                if (n.mod(i).compareTo(zero) == 0) {
                    return i;
                }
            }
            return n;
        }

        public BigInteger sqrt(BigInteger n) {
            BigInteger a = one;
            BigInteger b = n.shiftRight(1).add(two);
            while (b.compareTo(a) >= 0) {
                BigInteger mid = a.add(b).shiftRight(1); // (a+b) >> 1
                if (mid.multiply(mid).compareTo(n) > 0)
                    b = mid.subtract(one);
                else
                    a = mid.add(one);
            }
            return a.subtract(one);
        }

        void build(int len) {
            if (pool.size() >= lim || len >= n - 1)
                return;
            for (int i = 0; i <= 1; ++i) {
                sb.setCharAt(len, (char) ('0' + i));
                pool.add(sb.toString());
                build(len + 1);
            }
            sb.setCharAt(len, '0'); // reset
        }

        class Entry {
            String num;
            BigInteger[] divisors = new BigInteger[11];

        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }

    static class FastScanner {
        InputReader in;

        public FastScanner(InputReader in) {
            this.in = in;
        }

        public int i() {
            return in.nextInt();
        }

    }
}

