import java.io.OutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.PrintWriter;
import java.util.StringTokenizer;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 */
public class Main {
    public static void main(String[] args) {
        InputStream inputStream = System.in;
        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        CODEJAM_CountingSheep solver = new CODEJAM_CountingSheep();
        int testCount = Integer.parseInt(in.next());
        for (int i = 1; i <= testCount; i++)
            solver.solve(i, in, out);
        out.close();
    }

    static class CODEJAM_CountingSheep {
        public void solve(int testNumber, InputReader input, PrintWriter out) {
            FastScanner in = new FastScanner(input);

            int n = in.i();

            boolean[] digit = new boolean[10];
            int cnt = 0;
            long mul = n;
            for (int i = 0; i < 1000 * 1000; ++i) {
                long tmp = mul;
                // count digits
                while (tmp > 0) {
                    int d = (int) tmp % 10;
                    if (!digit[d]) {
                        cnt++;
                        digit[d] = true;
                    }
                    tmp /= 10;
                }
                if (cnt == 10)
                    break;
                mul += n;
            }

            if (cnt < 10)
                out.printf("Case #%d: INSOMNIA\n", testNumber);
            else
                out.printf("Case #%d: %d\n", testNumber, mul);
        }

    }

    static class FastScanner {
        InputReader in;

        public FastScanner(InputReader in) {
            this.in = in;
        }

        public int i() {
            return in.nextInt();
        }

    }

    static class InputReader {
        public BufferedReader reader;
        public StringTokenizer tokenizer;

        public InputReader(InputStream stream) {
            reader = new BufferedReader(new InputStreamReader(stream));
            tokenizer = null;
        }

        public String next() {
            while (tokenizer == null || !tokenizer.hasMoreTokens()) {
                try {
                    tokenizer = new StringTokenizer(reader.readLine());
                } catch (IOException e) {
                    throw new RuntimeException(e);
                }
            }
            return tokenizer.nextToken();
        }

        public int nextInt() {
            return Integer.parseInt(next());
        }

    }
}

