package qualification;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.util.Arrays;

public class ProblemD {
	BufferedReader br = null;
	BufferedOutputStream bw = null;

	int testCaseCount;
	
	private class TestCase {
		public int testCaseId;
		private int totalLines = 3; //total lines of input per test case
		private int readLines = 0; //total lines read so far from test case


		//Test case specific
		int N; //blocks
		double[] weights1;
		double[] weights2;
		
		int scoreY;
		int scoreZ;
		
		public TestCase(int id) {
			testCaseId = id;
		}
		
		public boolean readLine(String line) {
			String[] weights;
			
			readLines++;
			
			switch (readLines) {
				case (1):
					N = Integer.parseInt(line);
					weights1 = new double[N];
					weights2 = new double[N];
				break;
				case (2):
					weights = line.split(" ");
					for (int i=0; i < N; i++) weights1[i] = Double.parseDouble(weights[i]);
					Arrays.sort(weights1);
				break;
				case (3):
					weights = line.split(" ");
					for (int i=0; i < N; i++) weights2[i] = Double.parseDouble(weights[i]);
					Arrays.sort(weights2);
				break;
			}
			return readLines != totalLines;
		}
		
		public void solve() {
			scoreY = N;
			scoreZ = N;

			for (int i=0; i < N ; i++) if (weights1[i] < weights2[0]) scoreY--;

			for (int i=0, j = 0; i < N && j < N; i++)
			{
				while (j < N && weights1[i] > weights2[j]) j++;
				if (j < N  && weights1[i] < weights2[j++]) scoreZ--;
			}
		}

		public String formatOut() {
			return (String.format("Case #%d: %d %d", testCaseId, scoreY, scoreZ));
		}
		
	}

	public void solve(String fileName) {
		try {
			 
			br = new BufferedReader(new FileReader(fileName +".in"));
			bw = new BufferedOutputStream(new FileOutputStream(fileName+".out"));

			testCaseCount = Integer.parseInt(br.readLine());
			
			for (int i = 1; i <= testCaseCount; i++) {
				TestCase t = new TestCase(i);
				while (t.readLine(br.readLine()));
				
				t.solve();
				bw.write(t.formatOut().getBytes());
				bw.write("\n".getBytes());
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
				if (bw != null)bw.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		ProblemD p = new ProblemD();
		String path = "C:\\Users\\abdullah\\Downloads\\";
		p.solve(path + "D-small-attempt1");
	}
}
