package codejam2010.qualification;

import java.util.LinkedList;

public class SnapperChain {
    LinkedList<Snapper> snapperChain;
    
    public SnapperChain(int chainLength) {
        snapperChain = new LinkedList<Snapper> ();
        for (int i = 0; i < chainLength; i++) snapperChain.add(new Snapper(i==0));
    }
    
    public void snapListener() {
        boolean currentPower = true;
        for (Snapper s : snapperChain) s.respondToSnapp();
        for (Snapper s : snapperChain)
        {
            s.updatePowerState(currentPower); //first snapper will be receiving power
            currentPower = currentPower && s.isOnState;
        }
    }
    
    public String toString() {
        return (snapperChain.getLast().isSendingPower())?"ON":"OFF";
    }

}
