package codejam2010.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;

import java.io.IOException;

import java.math.BigInteger;

import java.util.Date;

public class FairWarning {
    BigInteger[] events;
    
    public FairWarning(int numEvents) {
        events = new BigInteger [numEvents];
    }

    public BigInteger getOptimumAnniversary() {
        BigInteger maxT; // maximum T
        
        maxT = BigInteger.ZERO;
                
        for (int i = 0; i < events.length; i++) {

            for (int j = i + 1; j < events.length; j++) {
                maxT = maxT.gcd(events[i].subtract(events[j]).abs());
            }
        }
        
        BigInteger result []= events[0].divideAndRemainder(maxT);
        BigInteger a = maxT.multiply(result[0].add(
                                        (result[1].compareTo(BigInteger.ZERO) == 0)?BigInteger.ZERO:BigInteger.ONE));
        return a.subtract(events[0]); // minimum Y
    }

    public String toString() {
        return getOptimumAnniversary().toString();
    }
    
    public static void main(String[] args) throws FileNotFoundException, 
                                                  IOException {

        int numberOfCases;
        int numberOfEvents;

        System.out.println(new Date());
        BufferedReader br = new BufferedReader(new FileReader(args[0]));
        BufferedWriter bw = new BufferedWriter(new FileWriter(args[1]));
        
        //read number of cases
        String firstLine = br.readLine();
        numberOfCases = Integer.parseInt(firstLine);
        FairWarning fw;
        for (int c = 1; c <= numberOfCases; c++) {
            String[] parameters = br.readLine().split(" ");
            numberOfEvents = Integer.parseInt(parameters[0]);
            fw = new FairWarning(numberOfEvents);
            for (int i = 1; i <= numberOfEvents; i++)
                fw.events[i - 1] = new BigInteger(parameters[i]);
            
            bw.write("Case #" + c + ": " + fw.toString() + "\n");
        }

        br.close();
        bw.close();
        System.out.println(new Date());
    }
}
