package codejam2010.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;

import java.io.IOException;

import java.util.Date;
import java.util.LinkedList;

public class ThemePark {
    
    int revenue;
    int rollerCoasterSize;
    int rollerCoasterRounds;
    LinkedList<Integer> queue;
    
    public ThemePark(int r, int k) {
        queue = new LinkedList <Integer> ();
        revenue = 0;
        rollerCoasterSize = k;
        rollerCoasterRounds = r;
    }
    
    private void play() {
        int currentRollerSize;
        int currentGroupCount;
        int groupSize;
        
        for (int i = 0; i < rollerCoasterRounds; i++) {
            currentRollerSize = 0;
            currentGroupCount = 0;
            while (currentRollerSize + queue.getFirst().intValue() <= rollerCoasterSize
                    && currentGroupCount < queue.size()) {
                groupSize = queue.removeFirst().intValue();
                currentRollerSize += groupSize;
                queue.addLast(groupSize);
                currentGroupCount += 1;
            }
            revenue += currentRollerSize;
        }
    }
    
    public String toString() {
        return String.format("%d", revenue);
    }

    public static void main(String[] args) throws FileNotFoundException, 
                                                  IOException {
        
        int numberOfCases;
        int  numberOfGroups;
        ThemePark tp;
        String[] parameters;

        System.out.println(new Date());

        BufferedReader br = new BufferedReader(new FileReader(args[0]));
        BufferedWriter bw = new BufferedWriter(new FileWriter(args[1]));
        
        //read number of cases
        String firstLine = br.readLine();
        numberOfCases = Integer.parseInt(firstLine);

        for (int c = 1; c <= numberOfCases; c++) {
            parameters = br.readLine().split(" ");
            tp = new ThemePark(Integer.parseInt(parameters[0]), Integer.parseInt(parameters[1]));
            
            numberOfGroups = Integer.parseInt(parameters[2]);
            parameters = br.readLine().split(" ");
            for (int i = 0; i < numberOfGroups; i++) {
                tp.queue.addLast(Integer.parseInt(parameters[i]));
            }
            tp.play();
            
            bw.write("Case #" + c + ": " + tp.toString() + "\n");
            bw.flush();
        }

        br.close();
        bw.close();
        System.out.println(new Date());

    }
}
