package codejam2010.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;

import java.io.IOException;

import java.math.BigInteger;

import java.util.ArrayList;
import java.util.Date;

public class FairWarning {
    ArrayList<BigInteger> events;
    
    public FairWarning() {
        events = new ArrayList<BigInteger> ();
    }

    public BigInteger getOptimumAnniversary() {
        BigInteger gcd;
        BigInteger oldestEvent;
        
        oldestEvent = events.get(0);
        
        gcd = events.get(0).subtract(events.get(1)).abs();
                
        for (int i = 0; i < events.size(); i++) {

            oldestEvent = oldestEvent.max(events.get(i));
            
            for (int j = i + 1; j < events.size(); j++) {
                gcd = gcd.gcd(events.get(i).subtract(events.get(j)).abs());
            }
        }
        
        BigInteger result []= oldestEvent.divideAndRemainder(gcd);
        BigInteger a = gcd.multiply(result[0].add(
                                        (result[1].compareTo(BigInteger.ZERO) == 0)?BigInteger.ZERO:BigInteger.ONE));
        return a.subtract(oldestEvent);
    }
    public String toString() {
        return getOptimumAnniversary().toString();
    }
    
    public static void main(String[] args) throws FileNotFoundException, 
                                                  IOException {

        int numberOfCases;
        int numberOfEvents;

        System.out.println(new Date());
        BufferedReader br = new BufferedReader(new FileReader(args[0]));
        BufferedWriter bw = new BufferedWriter(new FileWriter(args[1]));
        
        //read number of cases
        String firstLine = br.readLine();
        numberOfCases = Integer.parseInt(firstLine);
        FairWarning fw;
        for (int c = 1; c <= numberOfCases; c++) {
            String[] parameters = br.readLine().split(" ");
            numberOfEvents = Integer.parseInt(parameters[0]);
            fw = new FairWarning();
            for (int i = 1; i <= numberOfEvents; i++) {
                fw.events.add(new BigInteger(parameters[i]));
                
            }
            
            bw.write("Case #" + c + ": " + fw.toString() + "\n");
            bw.flush();
        }

        br.close();
        bw.close();
        System.out.println(new Date());

    }
}
