package qualification;

import java.io.BufferedOutputStream;
import java.io.BufferedReader;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;

public class ProblemB {
	BufferedReader br = null;
	BufferedOutputStream bw = null;

	int testCaseCount;
	
	private class TestCase {
		public int testCaseId;
		private int totalLines = 1; //total lines of input per test case
		private int readLines = 0; //total lines read so far from test case


		//Test case specific
		private String solution = null;
		double C; //cookies farm cost
		double F; //extra cookie production rate
		double X; //target
		double time = 0;
		double minTime = Double.MAX_VALUE;
		double cookieRate = 2;
		
		public TestCase(int id) {
			testCaseId = id;
		}
		
		public boolean readLine(String line) {
			readLines++;

			String[] values = line.split(" ");
			C = Double.parseDouble(values[0]);
			F = Double.parseDouble(values[1]);
			X = Double.parseDouble(values[2]);
			
			return readLines != totalLines;
		}
		
		public void solve() {
			double tTarget1; //time for 1st target: C
			double tTarget2; //time for 2nd target: X
			while (time < minTime)
			{
				tTarget1 = C / cookieRate;
				tTarget2 = X / cookieRate;
				
				if (minTime > (time + tTarget2)) minTime = time + tTarget2;
				
				time += tTarget1;
				cookieRate += F;
			}
			
		}

		public String formatOut() {
			return (String.format("Case #%d: %.7f", testCaseId, minTime));
		}
		
	}

	public void solve(String fileName) {
		try {
			 
			br = new BufferedReader(new FileReader(fileName +".in"));
			bw = new BufferedOutputStream(new FileOutputStream(fileName+".out"));

			testCaseCount = Integer.parseInt(br.readLine());
			
			for (int i = 1; i <= testCaseCount; i++) {
				TestCase t = new TestCase(i);
				while (t.readLine(br.readLine()));
				
				t.solve();
				bw.write(t.formatOut().getBytes());
				bw.write("\n".getBytes());
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
				if (bw != null)bw.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}
	
	public static void main(String[] args) {
		ProblemB p = new ProblemB();
		String path = "C:\\Users\\abdullah\\Downloads\\";
		p.solve(path + "B-small-attempt0");
	}
}
