import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class B {

	private static int C;
	private static int[] distances;
	private static int N;
	private static long t;

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int tests = scanner.nextInt();
		for(int test=1;test<=tests; ++test) {
			long L = scanner.nextLong();
			t = scanner.nextLong();
			N = scanner.nextInt();
			C = scanner.nextInt();
			distances = new int[C];
			List<Integer> orderedIndex = new ArrayList<Integer>(C);
			outer:
			for(int i=0; i<C; ++i) {
				distances[i] = scanner.nextInt();
				for(int j=0; j<i; ++j) {
					if(distances[i] > distances[orderedIndex.get(j)]) {
						orderedIndex.add(j, i);
						continue outer;
					}
				}
				orderedIndex.add(i);
			}
			
			boolean[] boosters = new boolean[N];
			Arrays.fill(boosters, false);
			long put = L;
			for(int i=0; i<C && put>0; ++i) {
				int index = orderedIndex.get(i);
				for(int j=N-1; j>=0 && put>0; --j) {
					if(j%C == index) {
						boosters[j] = true;
						--put;
					}
				}
			}
			
			long calculatedTime = calculateTime(boosters);
			for(int i=0; i<N-1; ++i) {
				if(boosters[i]) {
					int alternative = findNextEmptyBooster(boosters, i);
					if(alternative == -1)
						break;
					boosters[i] = false;
					boosters[alternative] = true;
					long alternativeTime = calculateTime(boosters);
					if(alternativeTime < calculatedTime) {
						calculatedTime = alternativeTime;
						continue;
					} else {
						boosters[i] = true;
						boosters[alternative] = false;
					}
				}
			}
			System.out.println("Case #"+test+": "+calculatedTime);
		}
	}
	
	static long calculateTime(boolean[] boosters) {
		long elapsed = 0;
		for(int i=0; i<N; ++i) {
			if(boosters[i]) {
				if(elapsed < t) {
					// booster henuz bitmedi
					long remaintime = t - elapsed; // Kalan zaman
					if(remaintime >= distances[i%C]*2) {
						// booster etkisiz
						elapsed += distances[i%C]*2;
						continue;
					}
					long remaindistance = distances[i%C] - remaintime/2;
					elapsed += remaintime + remaindistance;
				} else {
					elapsed += distances[i%C];
				}
			} else {
				elapsed += distances[i%C]*2;
			}
		}
		return (long)elapsed;
	}
	
	static int findNextEmptyBooster(boolean[] boosters, int start) {
		int index = -1;
		int distance=0;
		for(int i=boosters.length-1; i>start;--i) {
			if(!boosters[i]) {
				int d = distances[i%C];
				if(d>distance) {
					distance = d;
					index = i;
				}
			}
		}
		return index;
	}

}
