package robot;

import java.util.List;

public class Robot {
	
	public static final String ROBOT_O = "O";
	public static final String ROBOT_B = "B";
	
	private int position = 1; // initial position
	private String color = null;

	public Robot(String color) {
		this.color = color;
	}

	public int getPosition() {
		return position;
	}

	public void setPosition(int position) {
		this.position = position;
	}

	/**
	 * make action in step
	 * @param test
	 * @return true if button pressed. otherwise false
	 */
	public boolean action(List<Command> test) {
		Command command = test.get(0);
		if(command.getRobot().equals(color)) {
			// My step
			if(position == command.getButton()) {
				// Press button.
				return true;
			} else  {
				gotoButton(command);
			}
		} else{
			// Not my step
			Command nextCommand = findMyCommand(test);
			if(nextCommand != null) {
				if(nextCommand.getButton() != position) {
					gotoButton(nextCommand);
				}
			}
		}
		return false;
	}

	private void gotoButton(Command nextCommand) {
		position = (position > nextCommand.getButton() ? -- position : ++position);
	}

	private Command findMyCommand(List<Command> test) {
		for(Command c : test) {
			if(c.getRobot().equals(color))
				return c;
		}
		return null;
	}
	

}
