package main;

import java.util.Scanner;

public class A {

	private static int teams;
	private static char[][] matches;
	private static int[] wins;
	private static int[] totals;

	public static void main(String[] args) {
		Scanner scanner = new Scanner(System.in);
		int tests = scanner.nextInt();
		for(int test = 1; test <= tests; ++test) {
			teams = scanner.nextInt();
			matches = new char[teams][teams];
			wins = new int[teams];
			totals = new int[teams];
			for(int i=0; i < teams; ++i) {
				String scores = scanner.next();
				for (int j = 0; j < teams; j++) {
					char c = scores.charAt(j);
					matches[i][j] = c;
					if(c != '.')
						++totals[i];
					if(c == '1')
						++wins[i];
				}
			}
			System.out.println("Case #"+test+":");
			for(int i=0; i<teams; ++i) {
				// Print RDI
				double RDI = 0.25d * (double)wins[i] / (double)totals[i];
				RDI += 0.5d * calculateOWP(i);
				RDI += 0.25d * calculateOOWP(i);
				System.out.println(RDI);
			}
		}
	}
	
	static double calculateOWP(int t) {
		double sum = 0;
		double avg = 0;
		for(int i=0; i<teams; ++i) {
			if(i == t)
				continue;
			if(matches[t][i] == '.')
				continue;
			++avg;
			sum += calculatePercentageWithoutOpponent(i, t);
		}
		if(avg == 0)
			return 0;
		return sum / (double)(avg);
	}
	
	static double calculateOOWP(int t) {
		double sum = 0;
		double avg = 0; 
		for(int i=0; i<teams; ++i) {
			if(i == t)
				continue;
			if(matches[t][i] == '.')
				continue;
			++avg;
			sum += calculateOWP(i);
		}
		if(avg == 0)
			return 0;
		return sum / (double)(avg);
	}
	
	static double calculatePercentageWithoutOpponent(int t, int o) {
		char c = matches[t][o];
		int win = wins[t];
		int total = totals[t];
		if(c == '1') {
			--win;
		}
		if(c != '.') {
			--total;
		}
		return (double)win/(double)total;
	}
}

