import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TidyNumbers {
	private static final String OutputFile = "B-small-practice.out";
	private static final String InputFile = "B-small-attempt0.in";

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(new BufferedReader(new FileReader(InputFile)));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(OutputFile)));

		int t = in.nextInt();

		long lastTidy = 1;
		for (int i = 1; i <= t; i++) {
			long n = in.nextLong();
			lastTidy = findLastTidy(n);
			out.println("Case #" + i + ": " + lastTidy);
		}

		in.close();
		out.flush();
		out.close();
	}

	private static long findLastTidy(long n) {
		long tidyNumb = 1;

		for (long i = n; i > 1; i--) {
			if (isTidyNumb(i)) {
				tidyNumb = i;
				return tidyNumb;
			}
		}
		return tidyNumb;
	}

	private static boolean isTidyNumb(long n) {
		if(new Long(n).toString().contains("0")) return false;
		long numb = 10;
		long last = 0;
		while (n > 0) {
			last = n%10;
			if(last <= numb) {
				numb = last;
			}
			else {
				return false;
			}
			n /= 10;
		}
		return true;
	}
}
