package main;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;
import java.util.Stack;

public class Main {
	
	public Main() {
		try {
			Scanner scan = new Scanner(new File(FILE));
			Writer write = new FileWriter("output.txt");
			Writer writer = new BufferedWriter(write);
			
			int t = scan.nextInt(); //test cases
			
			for(int i = 0; i<t; i++) {
				int c = scan.nextInt(); //number of base pairs
				char[][] pairs = new char[c][3];
				for(int j = 0; j<c; j++) {
					pairs[j] = scan.next().toCharArray();
				}
				
				int d = scan.nextInt(); //number of opposing pairs
				Map<Character, Character> map = new HashMap<Character, Character>();
				for(int j = 0; j<d; j++) {
					char[] chars = scan.next().toCharArray();
					map.put(chars[0], chars[1]);
					map.put(chars[1], chars[0]);
				}
				
				int n = scan.nextInt(); //number of elements in string
				char[] string = scan.next().toCharArray();
				
				Stack<Character> stack = new Stack<Character>();
				
				for(int j = 0; j<n; j++) {
					char elem = string[j];
					if(stack.isEmpty()) {
						stack.push(elem);
					} else {
						char top = stack.peek();
						//now check if they can form a non-base
						boolean nonBase = false;
						for(int k = 0; k<pairs.length; k++) {
							char[] pair = pairs[k];
							if((pair[0]==elem && pair[1]==top) || (pair[0]==top && pair[1]==elem)) {
								nonBase = true;
								stack.pop(); //remove top from stack
								stack.push(pair[2]); //to replace with new non base
								break;
							}
						}
						//now if didn't form a non base 
						if(!nonBase) {
							Character first = map.get(elem);
							//then check it doesn't clash
							if(first!=null && stack.contains(first)) {
								//opposing elements so clear
								stack.clear();
							} else {
								//add it to the stack
								stack.push(elem);
							}
						}
					}
				}
				writer.write(String.format("Case #%d: %s\n", i+1, stack));
			}
			
			writer.close();
			write.close();
			
			
			
		} catch (FileNotFoundException e) {
			System.out.println("FNF: "+FILE);
			return;
		} catch (IOException e) {
			System.out.println("IO Exception");
			return;
		}
		
		
	}
	
	
	public static void main(String[] args) {
		new Main();
	}
	
	public static final String FILE = "B-large.in";

}
