package main;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Main {
	
	public Main() {
		try {
			Scanner scan = new Scanner(new File(FILE));
			
			Writer write = new FileWriter("output.txt");
			Writer writer = new BufferedWriter(write);
			
			int t = scan.nextInt(); //number of test cases
			
			for(int i = 0; i<t; i++) {
				Robot o = new Robot("orange");
				Robot b = new Robot("blue");
				
				int n = scan.nextInt();
				List<Instruction> instructions = new ArrayList<Instruction>();
				for(int j = 0; j<n; j++) {
					instructions.add(new Instruction(scan.next().equals("O") ? o:b, scan.nextInt()));
				}
				
				int time = 0;
				
				int instruction = 0;
				
				while(instruction<n) {
					
					Instruction inst = instructions.get(instruction);
					Robot current = inst.r;
					
					int blueNext = getNextButton(instruction, instructions, b);
					int orangeNext = getNextButton(instruction, instructions, o);
					
					//handle blue
					if(blueNext == -1) { //no further instructions
						//do nothing
					} else if (blueNext<b.current) { //move down
						b.current--;
					} else if (blueNext>b.current) { //move up
						b.current++;
					} else { //we are where we need to be
						if(current.equals(b)) { //we should move to next inst
							instruction++;
						}
					}
					
					//handle orange
					if(orangeNext == -1) { //no further instructions
						//do nothing
					} else if (orangeNext<o.current) { //move down
						o.current--;
					} else if (orangeNext>o.current) { //move up
						o.current++;
					} else { //we are where we need to be
						if(current.equals(o)) { //we should move to next inst
							instruction++;
						}
					}
					
					
					time++;
				}
				
				writer.write(String.format("Case #%d: %d\n", i+1, time));
				
			}
			
			writer.close();
			write.close();
		} catch (FileNotFoundException e) {
			System.out.println("Could not find input file: "+FILE);
			return;
		} catch (IOException e) {
			System.out.println("Error in output file");
			return;
		}
	}

	private int getNextButton(int instruction, List<Instruction> list, Robot o) {
		
		for(int i = instruction; i<list.size();i++) {
			Instruction inst = list.get(i);
			if(inst.r.equals(o)) {
				return inst.button;
			}
		}
		return -1;
	}

	private class Robot {
		int current;
		String colour;
		
		public Robot(String colour) {
			current = 1;
			this.colour = colour;
		}
		
		public boolean equals(Robot r) {
			return this.colour.equals(r.colour);
		}
	}
	
	private class Instruction {
		Robot r;
		int button;
		
		public Instruction(Robot r, int button) {
			this.r = r;
			this.button = button;	
		}
	}
	
	
	public static void main(String[] args) {
		new Main();
	}
	
	public static final String FILE = "A-small-attempt0.in";

}
