package com.cbp;

import java.io.*;
import java.util.*;

public class Main {


    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(
                new File("C:/Users/cbp/dev/java/GCJ/2017/solutions/B-large.in")))));
        PrintWriter out = new PrintWriter("C:/Users/cbp/dev/java/GCJ/2017/solutions/B-large.out");
        int N = sc.nextInt();
        for ( int i = 1; i <= N; i++ ) {
            int ac = sc.nextInt();
            int aj = sc.nextInt();
            List<Activity> activities = new ArrayList<>();
            for ( int j = 0; j < ac; j++ ) {
                activities.add(new Activity(0, sc.nextInt(), sc.nextInt()));
            }
            for ( int j = 0; j < aj; j++ ) {
                activities.add(new Activity(1, sc.nextInt(), sc.nextInt()));
            }

            System.err.println("Case #" + i + ": " + solve(activities));
            out.println("Case #" + i + ": " + solve(activities));
        }

        sc.close();
        out.close();
    }

    private static String solve(List<Activity> activities) {
        activities.sort(new CompareActivities());
        int t0Rem = 720;
        int t1Rem = 720;

        for ( int i = 0; i < activities.size(); i++ ) {
            Activity act = activities.get(i);
            if ( act.type == 0 ) {
                t1Rem -= act.length;
            } else {
                t0Rem -= act.length;
            }

            if ( i == 0 && act.type == activities.get(activities.size() - 1).type ) {
                act.gapLeft = act.start + 1440 - activities.get(activities.size() - 1).end;
            } else if ( i > 0 ) {
                act.gapLeft = act.start - activities.get(i - 1).end;
            }
        }

        activities.sort(new CompareGaps());
        int gaps = 0;
        for ( int i = 0; i < activities.size(); i++ ) {
            if ( activities.get(i).gapLeft == null || activities.get(i).gapLeft != 0 )
                gaps++;
        }
        for ( int i = 0; i < activities.size(); i++ ) {
            if ( t0Rem == 0 && t1Rem == 0 ) break;
            Activity act = activities.get(i);
            if ( act.gapLeft != null ) {
                if ( act.type == 0 && t1Rem >= act.gapLeft ) {
                    t1Rem -= act.gapLeft;
                    gaps--;
                } else if ( act.type == 1 && t0Rem >= act.gapLeft ) {
                    t0Rem -= act.gapLeft;
                    gaps--;
                }
            }

        }
        if ( gaps == 0 )
            gaps = 1;

        return "" + gaps * 2;
    }

    private static class Activity {
        int type;
        Integer start;
        int end;
        int length;
        Integer gapLeft = null;
        Activity(int type, int start, int end) {
            this.type = type;
            this.start = start;
            this.end = end;
            this.length = end - start;
        }
    }

    private static class CompareActivities implements Comparator<Activity> {
        @Override
        public int compare(Activity p1, Activity p2) {
            // sort reverse order
            return p1.start.compareTo(p2.start);
        }
    }

    private static class CompareGaps implements Comparator<Activity> {
        @Override
        public int compare(Activity p1, Activity p2) {
            // sort reverse order
            Integer p1g = 5000, p2g = 5000;
            if ( p1.gapLeft != null ) p1g = p1.gapLeft;
            if ( p2.gapLeft != null ) p2g = p2.gapLeft;
            return p1g.compareTo(p2g);
        }
    }



}
