package com.cbp;

import java.io.*;
import java.util.*;

public class Main {


    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(
                new File("C:/Users/cbp/dev/java/GCJ/2017/solutions/A-large.in")))));
        PrintWriter out = new PrintWriter("C:/Users/cbp/dev/java/GCJ/2017/solutions/A-large.out");
        int N = sc.nextInt();
        for ( int i = 1; i <= N; i++ ) {
            int R = sc.nextInt();
            int C = sc.nextInt();
            char[][] problem = new char[R][C];
            for ( int j = 0; j < R; j++ ) {
                problem[j] = sc.next().toCharArray();
            }
            out.print("Case #" + i + ":\n");
            out.print(solve(problem, R, C) + "\n");
            System.err.println("Case #" + i + ":");
            System.err.println(solve(problem, R, C));
        }

        sc.close();
        out.close();
    }

    private static char[][] clone(char[][] p) {
        char[][] res = new char[p.length][p[0].length];
        for ( int i = 0; i < p.length; i++ ) {
            for ( int j = 0; j < p[0].length; j++ ) {
                res[i][j] = p[i][j];
            }
        }
        return res;

    }

    private static String solve(char[][] pr, int R, int C) {
        List<Character> letters = new LinkedList<>();
        for ( char c : new char[]{'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'} ) {
            letters.add(c);
        }

        char[][] problem = clone(pr);

        Character current;
        for ( int i = 0; i < R; i++ ) {
            for ( int j = 0; j < C; j++ ) {
                step(i, j, letters, problem, R, C);
            }
        }
        boolean valid = true;
        for ( int i = 0; i < R; i++ ) {
            for ( int j = 0; j < C; j++ ) {
                if ( problem[i][j] == '?' ) {
                    valid = false;
                    break;
                }
            }
        }

        if ( !valid ) {
            letters = new LinkedList<>();
            for ( char c : new char[]{'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'} ) {
                letters.add(c);
            }

            problem = clone(pr);
            for ( int j = 0; j < C; j++ ) {
                for ( int i = 0; i < R; i++ ) {
                    step(i, j, letters, problem, R, C);
                }
            }
        }

        StringBuilder sb = new StringBuilder();
        for ( char[] row : problem ) {
            System.err.println(Arrays.toString(row));
            sb.append(String.valueOf(row));
            sb.append('\n');
        }
        return sb.substring(0, sb.length() - 1);
    }

    private static void step(int i, int j, List<Character> letters, char[][] problem, int R, int C) {
        if ( problem[i][j] != '?' && letters.contains(problem[i][j]) ) {
            Character current = problem[i][j];
            letters.remove(current);
            int length = 0;
            int height = 0;
            int minl = 0, minu = 0, maxr = C - 1, maxd = R - 1;
            for ( int l = j - 1; l >= 0; l-- ) {
                if ( problem[i][l] != '?' ) {
                    minl = l + 1; break;
                }
                length++;
            }
            for ( int r = j + 1; r < C; r++ ) {
                if ( problem[i][r] != '?' ) {
                    maxr = r - 1;
                    break;
                }
                length++;
            }

            for ( int d = i + 1; d < R; d++ ) {
                if ( problem[d][j] != '?' ) {
                    maxd = d - 1;
                    break;
                }
                height++;
            }

            for ( int u = i - 1; u >= 0; u-- ) {
                if ( problem[u][j] != '?' ) {
                    minu = u + 1;
                    break;
                }
                height++;
            }
            System.err.println(String.format("current %s, maxr %d, maxd %d, minl %d, minu %d, length %d, height %d", current, maxr, maxd, minl, minu, length, height));


            if ( length > height ) {
                for ( int c = minl; c <= maxr; c++ ) {
                    problem[i][c] = current;
                }

                for ( int r = i - 1; r >= minu; r-- ) {
                    boolean can = true;
                    for ( int c = minl; c <= maxr; c++ ) {
                        if ( problem[r][c] != '?' && problem[r][c] != current ) {
                            can = false; break;
                        }
                    }
                    if ( can ) {
                        for ( int c = minl; c <= maxr; c++ ) {
                            problem[r][c] = current;
                        }
                    } else break;
                }
                for ( int r = i + 1; r <= maxd; r++ ) {
                    boolean can = true;
                    for ( int c = minl; c <= maxr; c++ ) {
                        if ( problem[r][c] != '?' && problem[r][c] != current ) {
                            can = false; break;
                        }
                    }
                    if ( can ) {
                        for ( int c = minl; c <= maxr; c++ ) {
                            problem[r][c] = current;
                        }
                    } else break;
                }
            } else {
                for ( int r = minu; r <= maxd; r++ ) {
                    problem[r][j] = current;
                }

                for ( int c = j - 1; c >= minl; c-- ) {
                    boolean can = true;
                    for ( int r = minu; r <= maxd; r++ ) {
                        if ( problem[r][c] != '?' && problem[r][c] != current ) {
                            can = false; break;
                        }
                    }
                    if ( can ) {
                        for ( int r = minu; r <= maxd; r++ ) {
                            problem[r][c] = current;
                        }
                    } else break;
                }

                for ( int c = j + 1; c <= maxr; c++ ) {
                    boolean can = true;
                    for ( int r = minu; r <= maxd; r++ ) {
                        if ( problem[r][c] != '?' && problem[r][c] != current ) {
                            can = false; break;
                        }
                    }
                    if ( can ) {
                        for ( int r = minu; r <= maxd; r++ ) {
                            problem[r][c] = current;
                        }
                    } else break;
                }
            }
        }
    }



}
