package com.cbp;

import java.io.*;
import java.util.*;

public class Main {


    public static void main(String[] args) throws IOException {
        Scanner sc = new Scanner(new BufferedReader(new InputStreamReader(new FileInputStream(
                new File("C:/Users/cbp/dev/java/GCJ/2017/solutions/A-large.in")))));
        PrintWriter out = new PrintWriter("C:/Users/cbp/dev/java/GCJ/2017/solutions/A-large.out");
        int N = sc.nextInt();
        for ( int i = 1; i <= N; i++ ) {
            int n = sc.nextInt();
            int k = sc.nextInt();
            List<Pancake> pancakes = new ArrayList<>();
            for ( int j = 1; j <= n; j++ ) {
                pancakes.add(new Pancake(sc.nextInt(), sc.nextInt()));
            }

            System.err.println("Case #" + i + ": " + solve(pancakes, k));
            out.println("Case #" + i + ": " + solve(pancakes, k));
        }

        sc.close();
        out.close();
    }

    private static String solve(List<Pancake> pancakes, int k) {
        pancakes.sort(new ComparePancakes());
        Double firstSideSum = 0.0;
        Double firstSurface = 0.0;
        Double totalMax;
        for ( int i = 0; i < k - 1; i++ ) {
            firstSideSum += pancakes.get(i).side;
            if ( pancakes.get(i).top > firstSurface )
                firstSurface = pancakes.get(i).top;
        }
        totalMax = firstSideSum + firstSurface;
        for ( int i = k - 1; i < pancakes.size(); i++ ) {
            Double nextMax = firstSideSum + pancakes.get(i).side;
            nextMax += pancakes.get(i).top > firstSurface ? pancakes.get(i).top : firstSurface;
            if ( nextMax > totalMax )
                totalMax = nextMax;
        }

        return totalMax.toString();

    }

    private static class Pancake {
        int r;
        int h;
        Double side;
        Double top;
        Pancake(int r, int h) {
            this.r = r;
            this.h = h;
            side = 2 * Math.PI * r * h;
            top = Math.PI * r * r;
        }

        @Override
        public String toString() {
            return "<" + r + ", " + h + ", " + side + ", " + top + ">";
        }
    }

    private static class ComparePancakes implements Comparator<Pancake> {
        @Override
        public int compare(Pancake p1, Pancake p2) {
            // sort reverse order
            return p2.side.compareTo(p1.side);
        }
    }



}
