

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Hashtable;
import java.util.Scanner;
import java.util.StringTokenizer;


public class Treasure2 {

	
	ArrayList<Integer> path;
	Hashtable<Integer, ArrayList<Node>> allkeys;
	ArrayList<Integer> myKeys;
	
	public Treasure2() throws FileNotFoundException {

		Scanner sc = new Scanner(new FileReader("input.txt"));
		int numberOfCases=Integer.parseInt(sc.nextLine());

		for(int z=0; z<numberOfCases; z++){

			readFile(sc);

			if (compareSolvability()) {
				findPath(myKeys);
			}
			
			Collections.reverse(path);
			
			
			
			System.out.print("Case #"+ (z+1) +": ");

			for (int i = 0; i < path.size(); i++) {
				if (i==path.size()-1) {
					System.out.print(path.get(i));
				}else{
					System.out.print(path.get(i)+" ");	
				}
			}

			if (path.size()==0) {
				System.out.print("IMPOSSIBLE");
			}

			System.out.println();
			
			//break;
		}

		sc.close();
	}




	private boolean findPath(ArrayList<Integer> myKeys) {
		
		boolean flag=false;
		
		for (int i = 0; i < myKeys.size(); i++) {
			if (allkeys.containsKey(myKeys.get(i))) {
				
				ArrayList<Node> sorted=allkeys.get(myKeys.get(i));
				
				for (int j = 0; j < myKeys.size(); j++) {
					if ((j!=i)&&(myKeys.get(i)==myKeys.get(j))) {
						flag=true;
						break;
					}
				}
				
				if (!flag) {
					sortArray(sorted, myKeys.get(i));	
				}
				
				
				for (int j = 0; j < sorted.size(); j++) {

					Node n=	sorted.get(j);
					allkeys.get(myKeys.get(i)).remove(n);
					
					
					ArrayList<Integer> myNewKeys=new ArrayList<Integer>(myKeys);
					myNewKeys.addAll(n.keys);
					myNewKeys.remove(i);
					

					if (findPath(myNewKeys)) {
						path.add(n.chestNumber);
					}else{
						
						allkeys.get(myKeys.get(i)).add(j, n);
					}
					
					
				}
			}
		}
		
		
		for (Integer integer : allkeys.keySet()) {
			if (allkeys.get(integer).size()>0) {
				return false;
			}
		}
		

		return true;
	}

	
	private void sortArray(ArrayList<Node> array, int key) {
		int counter=array.size()-1;
		for (int i = array.size()-1; i >=0 ; i--) {
			
			Node node =array.get(counter);
			if (node.keys.contains(key)) {
				array.remove(node);
				array.add(0, node);
			}else{
				counter--;
			}
		}
	}
	
	
	private boolean compareSolvability() {
		
		Hashtable<Integer, Integer> possibilities=new Hashtable<Integer, Integer>();
		
		for (Integer i : allkeys.keySet()) {
			possibilities.put(i, 0);
		}
		
		for (Integer i : allkeys.keySet()) {
			for (Node j : allkeys.get(i)) {
				for (Integer in : j.keys) {
					
					if (possibilities.get(in)==null) {
						possibilities.put(in, 0);
					}
					
					possibilities.put(in, possibilities.get(in)+1);	
				}
			}
		}
		
		
		for (Integer i : myKeys) {
			
			if (possibilities.get(i)==null) {
				possibilities.put(i, 0);
			}
			possibilities.put(i, possibilities.get(i)+1);
		}
		
		
		for (Integer i : possibilities.keySet()) {

			if (allkeys.get(i)!=null&&allkeys.get(i).size()>possibilities.get(i)) {
				return false;
			}
		}
		
		return true;
	}

	
	public static void main(String[] args) {
		try {
			new Treasure2();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
	
	
	private void readFile(Scanner sc){
		
		path=new ArrayList<Integer>();
		allkeys=new Hashtable<Integer, ArrayList<Node>>();
		
		String row=sc.nextLine();
		StringTokenizer token=new StringTokenizer(row);
		int numberOfKeys=Integer.parseInt(token.nextToken());
		int numberOfChests=Integer.parseInt(token.nextToken());
		
		myKeys=new ArrayList<Integer>();

		String keys=sc.nextLine();
		token=new StringTokenizer(keys);
		
		for (int i = 0; i < numberOfKeys; i++) {
			myKeys.add(Integer.parseInt(token.nextToken()));
		}

		
		for (int i = 0; i < numberOfChests; i++) {
			String chestInfo=sc.nextLine();
			token=new StringTokenizer(chestInfo);
			Node chest =new Node();
			chest.chestNumber=i+1;
			chest.neededKey=Integer.parseInt(token.nextToken());
			
			if (!allkeys.containsKey(chest.neededKey)) {
				allkeys.put(chest.neededKey, new ArrayList<Node>());
				allkeys.get(chest.neededKey).add(chest);
			}else{
				allkeys.get(chest.neededKey).add(chest);	
			}
			
			
			
			token.nextToken();
			
			int k=token.countTokens();
			for (int j = 0; j < k; j++) {
				chest.keys.add(Integer.parseInt(token.nextToken()));
			}
		}	
		
		/*for (Integer integer : allkeys.keySet()) {
			System.out.print(integer+": ");
			for (Node n : allkeys.get(integer)) {
				System.out.print(n.chestNumber+" ");
			}
			System.out.println();
		}*/
	}


	private class Node{
		int chestNumber;
		ArrayList<Integer> keys;
		int neededKey;
		
		public Node() {
			keys=new ArrayList<>();
		}
	}
}