import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Hashtable;
import java.util.Scanner;
import java.util.StringTokenizer;


public class FairSquare {
	
	private int upperBound;
	private int lowerBound;
	private Hashtable<Long, Boolean> dictionary;
	

	public FairSquare() throws FileNotFoundException {
		Scanner sc = new Scanner(new FileReader("FairNumbers"));
		int numberOfCases=Integer.parseInt(sc.nextLine());
		dictionary=new Hashtable<Long, Boolean>();
		
		
		for(int i=0; i<numberOfCases; i++){
			
			readData(sc);
			System.out.println("Case #"+ (i+1) +": "+solve());
		}

		sc.close();
	}
	
	
	private int solve() {
		double aux=Math.sqrt(lowerBound);
		int numberOfPalindroms=0;

		if (aux-((int)aux)!=0) {
			aux=Math.ceil(aux);
		}
		
		while (aux<=Math.sqrt(upperBound)) {
			
			if (isPalindrom(aux)&isPalindrom(Math.pow(aux,2))) {
				numberOfPalindroms++;
			}
			aux++;			
		}
		
		return numberOfPalindroms;
	}
	
	private boolean isPalindrom(double a) {
		
		long i=(long)a;
		
		if (dictionary.containsKey(i)) {
			return dictionary.get(i);
		}
		
		
		long reverseNumber=0;
		long n=10;
		
		int size=(int)Math.floor(Math.log10(i)) + 1;		
				
		while (size>0) {
			reverseNumber+=(((i%n)/(n/10))*Math.pow(10, size-1));
			size--;
			i-=i%n;
			n*=10;
		}
		

		if (reverseNumber==(long)a) {
			dictionary.put((long)a, true);
			return true;
		}
		
		dictionary.put((long)a, false);
		return false;

	}
	
	private void readData(Scanner sc){

		String data=sc.nextLine();
		StringTokenizer token=new StringTokenizer(data);
		
		lowerBound=Integer.parseInt(token.nextToken());
		upperBound=Integer.parseInt(token.nextToken());

	}
	
	public static void main(String[] args) {
		try {
			new FairSquare();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
	}
}
