import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;


public class TicTacToeTomek {
	private static boolean isCompleted;
	private static final int EMPTY = 0;
	private static final int T = 1;
	private static final int O = 2;
	private static final int X = 3;
	private static final String X_WON = "X won";
	private static final String O_WON = "O won";
	private static final String DRAW = "Draw";
	private static final String NOT_COMPLETED = "Game has not completed";
	
	public static void main(String[] args) throws IOException {
		final String INPUT_FILE = "A-small-attempt0.in";
		final String OUTPUT_FILE = "output.out";
		Scanner scanner = new Scanner(new File(INPUT_FILE));
        FileWriter fw = new FileWriter(new File(OUTPUT_FILE));
		try{
			StringBuffer stringBuffer = new StringBuffer();
			scanner = new Scanner(new File(INPUT_FILE));
            fw = new FileWriter(new File(OUTPUT_FILE));
			int t = scanner.nextInt();
			for(int i = 1; i <= t; i++){
				scanner.nextLine();
				final int[][] board = new int[4][4];
				for(int j=0; j<4; j++){
					String line = scanner.nextLine();
					for(int k=0; k<4; k++){
						board[j][k]=toInt(line.charAt(k));
					}
				}
				stringBuffer.append("Case #" + i + ": " + getStatus(board) +
						"\n");
			}
			fw.write(stringBuffer.toString());
		 } finally{
	            fw.close();	
	            scanner.close();
	     }
	}
	
	private static String getStatus(final int[][] board){
		String result = DRAW;
		isCompleted = true;
		int check = checkRowsAndColumns(board);
		if(check != 0){
			result = getStringWon(check); 
		} else{
			check = checkDiagonals(board);
			if(check != 0){
				result = getStringWon(check); 
			} else{
				if(isCompleted){
					result = DRAW;
				} else{
					result = NOT_COMPLETED;
				}
			}
		}
		return result;
	}
	
	private static int toInt(char symbol){
		int result = EMPTY;
		switch(symbol){
			case('T'):result = T; break;
			case('O'):result = O; break;
			case('X'):result = X; break;
		}
		return result;
	}
	
	private static String getStringWon(int symbol){
		return symbol == O ? O_WON : X_WON;
	}
	
	private static int checkRowsAndColumns(final int[][] board){
		int result = 0;
		MAIN_LOOP:
		for(int j=0; j<4; j++){
			/*
			 * Checking rows
			 */
			int product = 1;
			for(int k=0; k<4; k++){
				product *= board[j][k];
			}
			if(product == 0){
				isCompleted = false;
			}else{
				result = getResult(product);
				if(result == O || result == X){
					break MAIN_LOOP;
				}
			} 
			
			/*
			 * Checking columns
			 */
			product = 1;
			for(int k=0; k<4; k++){
				product *= board[k][j];
			}
			result = getResult(product);
			if(result == O || result == X){
				break MAIN_LOOP;
			}
		}
		return result;
	}
	
	private static int getResult(final int product){
		int result = 0;
		if(product == 8 || product == 16){
			result = O;
		} else if(product == 27 || product == 81){
			result = X;
		}
		return result;
	}
	
	private static int checkDiagonals(final int[][] board){
		int result = 0;
		
		int product = 1;
		for(int i = 0; i < 4; i++){
			product *= board[i][i];
		}
		result = getResult(product);
		if(result == O || result == X){
			return result;
		}
		
		product = 1;
		for(int i = 0; i < 4; i++){
			product *= board[i][3-i];
		}

		result = getResult(product);
		return result;
	}
}
