import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class RevengePancakes {
    public static void main(String[] args) throws IOException {
        String INPUT_FILE = "B-large.in";
        String OUTPUT_FILE = "B-large.out";
        try (Scanner scanner = new Scanner(new File(INPUT_FILE)); FileWriter fw = new FileWriter(new File(OUTPUT_FILE))) {
            StringBuilder stringBuilder = new StringBuilder();
            int t = scanner.nextInt();
            for (int i = 1; i <= t; i++) {
                String pancakeStack = scanner.next();
                stringBuilder.append(String.format("Case #%d: %s\n", i, calculateMinimumManeuver(pancakeStack)));
            }
            fw.write(stringBuilder.toString());
        }
    }

    public static int calculateMinimumManeuver(String s) {
        int maneuverCounts = 0;
        char previousPancakeSide = ' ';
        for (char currentPancakeSide : s.toCharArray()) {
            if (currentPancakeSide != previousPancakeSide) {
                maneuverCounts++;
                previousPancakeSide = currentPancakeSide;
            }
        }
        if (s.endsWith("+")) {
            maneuverCounts--;
        }
        return maneuverCounts;
    }
}
