import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Scanner;

public class TinyNumbers {
    public static void main(String[] args) throws IOException {
        String INPUT_FILE = "B-small-attempt0.in";
        String OUTPUT_FILE = "B-small-attempt0.out";
        try (Scanner scanner = new Scanner(new File(INPUT_FILE)); FileWriter fw = new FileWriter(new File(OUTPUT_FILE))) {
            StringBuilder stringBuilder = new StringBuilder();
            int t = scanner.nextInt();
            for (long i = 1; i <= t; i++) {
                Long n = scanner.nextLong();
                stringBuilder.append(String.format("Case #%d: %s\n", i, previousTinyNumber(n)));
            }
            fw.write(stringBuilder.toString());
        }
    }

    static long previousTinyNumber(long n) {
        if (n < 10) {
            return n;
        }
        long firstNonDecreasingDigits = firstNonDecreasingDigits(n);
        if (firstNonDecreasingDigits == n) {
            return n;
        }
        int tailSize = length(n) - length(firstNonDecreasingDigits);
        long l = previousTinyNumber(firstNonDecreasingDigits - 1);
        if(l == 0 )  {
            return Long.parseLong(stringOfNineOfSize(tailSize));
        }
        String s = String.valueOf(l) + stringOfNineOfSize(tailSize);
        return Long.valueOf(s);
    }

    private static int length(long n) {
        return String.valueOf(n).length();
    }

    private static long firstNonDecreasingDigits(long n) {
        char[] digits = String.valueOf(n).toCharArray();
        for (int i = 0; i < digits.length - 1; i++) {
            if (digits[i] > digits[i + 1]) {
                String substring = String.valueOf(n).substring(0, i + 1);
                return Long.parseLong(substring);
            }
        }
        return n;
    }

    private static String stringOfNineOfSize(int tailSize) {
        StringBuilder builder = new StringBuilder();
        for (int i = 0; i < tailSize; i++) {
            builder.append('9');
        }
        return builder.toString();
    }
}
