import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;
import java.util.stream.Collectors;
import java.util.stream.LongStream;

public class Fractiles {
    public static void main(String[] args) throws IOException {
        String INPUT_FILE = "D-small-attempt3.in";
        String OUTPUT_FILE = "D-small-attempt3.out";
        try (Scanner scanner = new Scanner(new File(INPUT_FILE)); FileWriter fw = new FileWriter(new File(OUTPUT_FILE))) {
            StringBuilder stringBuilder = new StringBuilder();
            int t = scanner.nextInt();
            for (int i = 1; i <= t; i++) {
                int k = scanner.nextInt();
                int c = scanner.nextInt();
                int s = scanner.nextInt();
                stringBuilder.append(String.format("Case #%d: %s\n", i, fractiles(k, c, s)));
            }
            fw.write(stringBuilder.toString());
        }
    }

    public static String fractiles(int k, int c, int s) {
        List<Long> tilesToCleanList = tilesToClean(k, c);
        if(tilesToCleanList.size() >  s) {
            return "IMPOSSIBLE";
        }
        return tilesToCleanList.stream().map(i -> i.toString()).collect(Collectors.joining(" "));
    }

    private static List<Long> tilesToClean(int k, int c) {
        long fractileSize = (long) Math.pow(k, c);
        if(fractileSize == 1){
            return Collections.singletonList(1l);
        }
        if (c == 1) {
            return LongStream.rangeClosed(1, fractileSize).boxed().collect(Collectors.toList());
        }
        List<Long> tilesToCleanList = new ArrayList<>();
        tilesToCleanList.add(1l);
        for (int i = 1; i < k; i++) {
            fractileSize /= 2;
            long toAdd = fractileSize + tilesToCleanList.get(i - 1);
            tilesToCleanList.add(toAdd);
            if(fractileSize == 1) {
                break;
            }
        }
        return tilesToCleanList;
    }
}
