package v2015.qualificationround;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.*;

public class InfiniteHouseOfPancakes {
    public static void main(String[] args) throws IOException {
        final String INPUT_FILE = "input.in";
        final String OUTPUT_FILE = "output.out";
        final Scanner scanner = new Scanner(new File(INPUT_FILE));
        final FileWriter fw = new FileWriter(new File(OUTPUT_FILE));
        try{
            StringBuilder stringBuilder = new StringBuilder();
            int t = scanner.nextInt();
            for(int i = 1; i <= t; i++) {
                int d = scanner.nextInt();
                List<Integer> p = new LinkedList<Integer>();
                for (int j = 0; j < d; j++) {
                    p.add(scanner.nextInt());
                }
                stringBuilder.append(String.format("Case #%d: %s\n", i, getOutput(p)));
            }
            fw.write(stringBuilder.toString());
        }finally{
            fw.close();
            scanner.close();
        }
    }

    private static int getOutput(List<Integer> p) {
        final int max = Collections.max(p);
        if(max < 4){
            return max;
        }
        sharePancakes(p, max);
        return Math.min(getOutput(p) + 1, max);
    }

    private static void sharePancakes(List<Integer> p, int max) {
        for (int i = 0; i < p.size(); i++) {
            int pancakesInPlate = p.get(i);
            if(pancakesInPlate == max){
                int pancakesToShare = pancakesInPlate / 2;
                p.add(pancakesToShare);
                p.set(i, pancakesInPlate - pancakesToShare);
                return;
            }
        }
    }

    private static double f(int n){
        return Math.ceil(Math.log(n)/Math.log(2)) + 1;
    }
}
