import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;
import java.util.ArrayList;

public class Main {

	/**
	 * @param args
	 */
	Scanner in;
	int [][] map;
	int [][] label;
	int cases,H,W;
	
	public static void main(String[] args) {
		new Main().process();
	}

	void process() {
		try {
			FileInputStream fileStream = new FileInputStream("in.txt");
			System.setIn(fileStream);
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		try {
			FileOutputStream fileStream = new FileOutputStream("out.txt");
			System.setOut(new PrintStream(fileStream));
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		
		in = new Scanner(System.in);
		cases = in.nextInt();
		
		for (int i = 0; i < cases; i++) 
		{
			H = in.nextInt(); W = in.nextInt();
			map = new int[H][W];
			label = new int[H][W];
			for (int j = 0; j < H; j++) {
				for (int j2 = 0; j2 < W; j2++) {
					map[j][j2]=in.nextInt();
				}
			}
			
			int color=1;
			for (int j = 0; j < H; j++) {
				for (int j2 = 0; j2 < W; j2++) {
					if(label[j][j2]==0){
						if(fill(j,j2,color)==color)
							color++;
					}
				}
			}
			
			System.out.printf("Case #%d:",i+1);
			System.out.println();
			for (int j = 0; j < H; j++) {
				for (int j2 = 0; j2 < W; j2++) {
					System.out.print((char)(label[j][j2]+'a'-1));
					if(j2+1!=W)
						System.out.print(' ');
				}
				System.out.println();
			}		
		}
	}
	
	int fill(int h,int w,int color)
	{
		if(label[h][w]!=0)
			return label[h][w];
		label[h][w]=color;
		int min=map[h][w],dir=-1;
		if(h-1>=0) // N
			if(map[h-1][w]<min)
			{
				min=map[h-1][w];
				dir=1;
			}
		if(w-1>=0) //W
			if(map[h][w-1]<min)
			{
				min=map[h][w-1];
				dir=2;
			}
		if(w+1<W)  //E
			if(map[h][w+1]<min)
			{
				min=map[h][w+1];
				dir=3;
			}
		if(h+1<H) //S
			if(map[h+1][w]<min)
			{
				min=map[h+1][w];
				dir=4;
			}
		
		if(dir==-1)
			return color;
		
		int re=0;
		switch(dir)
		{
			case 1:
				re = fill(h-1,w,color);
				break;
			case 2:
				re = fill(h,w-1,color);
				break;
			case 3:
				re = fill(h,w+1,color);
				break;
			case 4:
				re = fill(h+1,w,color);
				break;
		}
		if(re!=color)
		{
			label[h][w]=re;
			return re;
		}
		return color;
	}
}