import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;
import java.util.ArrayList;

public class Main {

	/**
	 * @param args
	 */
	Scanner in;
	String [] dict;
	StringBuffer [] pattern;
	int L,D,cases;
	int count;
	
	public static void main(String[] args) {
		new Main().process();
	}

	void process() {
		try {
			FileInputStream fileStream = new FileInputStream("in.txt");
			System.setIn(fileStream);
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		try {
			FileOutputStream fileStream = new FileOutputStream("out.txt");
			System.setOut(new PrintStream(fileStream));
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		
		in = new Scanner(System.in);
		L = in.nextInt(); D = in.nextInt();
		cases = in.nextInt();
		
		//Process dictionary
		dict = new String[D];
		for (int i = 0; i < D; i++) {
			dict[i]=in.next();
		}
			
		
		for (int i = 0; i < cases; i++) 
		{
			//Process Pattern
			pattern = new StringBuffer[L];
			String tmp = in.next();
			int index=0;
			for (int j = 0; j < L; j++) {
				pattern[j] = new StringBuffer();
				if(tmp.charAt(index)=='('){
					while(tmp.charAt(++index)!=')')
					{
						pattern[j].append(tmp.charAt(index));
					}
					index++;
				}
				else
				{
					pattern[j].append(tmp.charAt(index++));
				}
			}		
			//Calculate Pattern Count
			count = 0;
			StringBuffer buffer = new StringBuffer();
			ArrayList<String> list = new ArrayList<String>();
			for (int j = 0; j < D; j++) {
				list.add(dict[j]);
			}
			patternCount(buffer, 0, list);
			System.out.printf("Case #%d: %d",i+1,count);
			System.out.println();
			
		}
	}

	
	void patternCount(StringBuffer buffer, int index, ArrayList<String> list)
	{
		if(index==L)
		{
			for (int i = 0; i < D; i++) {
				if(buffer.toString().compareTo(dict[i])==0)
				{
					count++;
					return;
				}
			}
			return;
		}
		for (int i = 0; i < pattern[index].length(); i++) {
			buffer.append(pattern[index].charAt(i));
			ArrayList<String> newList = new ArrayList<String>();
			for (int j = 0; j < list.size(); j++) {
				if(list.get(j).startsWith(buffer.toString()))
				{
					newList.add(list.get(j));
				}	
			}
			if(newList.size()>0)
				patternCount(buffer,index+1,newList);
			buffer.deleteCharAt(buffer.length()-1);
		}
	}
}