import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;
import java.util.ArrayList;

public class Main {

	/**
	 * @param args
	 */
	Scanner in;
	int n,t;
	boolean [] used;
	stock [][] time;
	int c;
	
	public static void main(String[] args) {
		new Main().process();
	}

	void process() {
		try {
			FileInputStream fileStream = new FileInputStream("inS1.txt");
			System.setIn(fileStream);
		} catch (Exception ex) {
			ex.printStackTrace();
		}

		try {
			FileOutputStream fileStream = new FileOutputStream("out.txt");
			System.setOut(new PrintStream(fileStream));
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		
		in = new Scanner(System.in);
		int cases = in.nextInt();
		
		in.nextLine();
		for (int i = 0; i < cases; i++) 
		{
			n = in.nextInt(); t = in.nextInt(); c=0;
			used = new boolean[n];
			time = new stock[t][n];
			
			for (int j = 0; j < n; j++) {
				for (int j2 = 0; j2 < t; j2++) {
					time[j2][j]= new stock(j,in.nextLong());
				}			
			}
			for (int j = 0; j < t; j++) {
				Arrays.sort(time[j]);
			}
			
			while(!completed())
			{
				String lcs = takeString(0);
				for (int j = 1; j < t; j++) {
					lcs = LCS.LCSAlgorithm(lcs, takeString(j));
				}
				for (int j = 0; j < lcs.length(); j++) {
					used[lcs.charAt(j)-'a']=true;
				}
				c++;
			}
			
			System.out.printf("Case #%d: %d",i+1,c);
			System.out.println();

		}
	}
	
	boolean completed()
	{
		for (int i = 0; i < n; i++) {
			if(used[i]==false)
				return false;
		}
		return true;
	}
	
	String takeString(int tt)
	{
		StringBuffer tmp = new StringBuffer();
		for (int i = 0; i < n; i++) {
			if(used[time[tt][i].index])
				continue;
			//if(i>0&&used[time[tt][i-1].index]==false&&time[tt][i].price==time[tt][i-1].price)
			//	continue;
			char a = (char)((int)'a' + time[tt][i].index);
			tmp.append(a);
		}
		return tmp.toString();
	}
	
	
}

class stock implements java.lang.Comparable<stock>
{
	int index;
	long price;
	
	public int compareTo(stock o) {
        if(this.price==o.price)
        	return this.index-o.index;
        if(this.price>o.price)
        	return 1;
        else
        	return -1;
    }
	
	stock(int index, long price)
	{
		this.index = index;
		this.price = price;
	}
}

class LCS {
	// These are "constants" which indicate a direction in the backtracking array.
	private static final int NEITHER     = 0;
	private static final int UP          = 1;
	private static final int LEFT        = 2;
	private static final int UP_AND_LEFT = 3;

	public static String LCSAlgorithm(String a, String b) {
		int n = a.length();
		int m = b.length();
		int S[][] = new int[n+1][m+1];
		int R[][] = new int[n+1][m+1];
		int ii, jj;

		// It is important to use <=, not <.  The next two for-loops are initialization
		for(ii = 0; ii <= n; ++ii) {
			S[ii][0] = 0;
			R[ii][0] = UP;
		}
		for(jj = 0; jj <= m; ++jj) {
			S[0][jj] = 0;
			R[0][jj] = LEFT;
		}

		// This is the main dynamic programming loop that computes the score and
		// backtracking arrays.
		for(ii = 1; ii <= n; ++ii) {
			for(jj = 1; jj <= m; ++jj) { 
	
				if( a.charAt(ii-1) == b.charAt(jj-1) ) {
					S[ii][jj] = S[ii-1][jj-1] + 1;
					R[ii][jj] = UP_AND_LEFT;
				}

				else {
					S[ii][jj] = S[ii-1][jj-1] + 0;
					R[ii][jj] = NEITHER;
				}

				if( S[ii-1][jj] >= S[ii][jj] ) {	
					S[ii][jj] = S[ii-1][jj];
					R[ii][jj] = UP;
				}

				if( S[ii][jj-1] >= S[ii][jj] ) {
					S[ii][jj] = S[ii][jj-1];
					R[ii][jj] = LEFT;
				}
			}
		}

		// The length of the longest substring is S[n][m]
		ii = n; 
		jj = m;
		int pos = S[ii][jj] - 1;
		char lcs[] = new char[ pos+1 ];

		// Trace the backtracking matrix.
		while( ii > 0 || jj > 0 ) {
			if( R[ii][jj] == UP_AND_LEFT ) {
				ii--;
				jj--;
				lcs[pos--] = a.charAt(ii);
			}
	
			else if( R[ii][jj] == UP ) {
				ii--;
			}
	
			else if( R[ii][jj] == LEFT ) {
				jj--;
			}
		}

		return new String(lcs);
	}
}

