/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package google1;

import java.io.BufferedInputStream;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author thibault
 */
public class Solution {

	private String exId;
	private Scanner sc;
	private BufferedWriter bw;

	public Solution(String exId) throws FileNotFoundException, IOException {

		this.exId = exId;
		sc = new Scanner(new BufferedInputStream(new FileInputStream("src/res/" + exId + ".in")));
		bw = new BufferedWriter(new FileWriter("src/res/" + exId + ".out"));

		int T = sc.nextInt();
		sc.nextLine();
		for (int i = 0; i < T; i++) {
			bw.write("Case #" + (i + 1) + ": " + run().toString() + "\n");
		}

		bw.flush();
		bw.close();

	}

	public Object run() {
		int nb = Integer.parseInt(sc.nextLine());
		String[] words = new String[nb];
		for(int i=0;i<nb;i++){
			words[i] = sc.nextLine();
		}
		int[] sums = new int[nb];
		for(int i=0; i<nb; i++){
			int sum = 0;
			String from = words[i];
			for(int j=0; j<nb; j++){
				String to = words[j];
				Object res = processTwo(from, to);
				if(res instanceof String) return res;
				sum += (int) res;
			}
			sums[i] = sum;
		}
		Arrays.sort(sums);
		
		return sums[0];
	}
	
	private Object processTwo(String from, String to){
		List<CharNumber> groups = new ArrayList<>();
		String regexValid = "";
		for(char c : from.toCharArray()) {
			if(groups.isEmpty()){
				groups.add(new CharNumber(c));
				regexValid += "("+c+")+";
			}
			else {
				CharNumber cur = groups.get(groups.size()-1);
				if(cur.c!=c){
					groups.add(new CharNumber(c));
					regexValid += "("+c+")+";
				}
				else {
					cur.num++;
				}
			}
		}
		if(!to.matches(regexValid)) return "Fegla Won";
		List<CharNumber> groupsTo = new ArrayList<>();
		for(char c : to.toCharArray()) {
			if(groupsTo.isEmpty()){
				groupsTo.add(new CharNumber(c));
			}
			else {
				CharNumber cur = groupsTo.get(groupsTo.size()-1);
				if(cur.c!=c){
					groupsTo.add(new CharNumber(c));
				}
				else {
					cur.num++;
				}
			}
		}
		int nbOp = 0;
		
		for(int i=0; i<groupsTo.size(); i++){
			nbOp += Math.abs(groups.get(i).num - groupsTo.get(i).num);
		}
		return nbOp;
	}
	
	private class CharNumber {
		public char c;
		public int num;

		public CharNumber(char c) {
			this.c = c;
			this.num = 0;
		}
	}
	
}
