import java.util.*;
import java.io.*;

public class gcj_a {
    public static void main(String[] args){
        if(args.length<1){
            System.out.println("Usage: <fnIn>");
        }
        String fn = args[0];
        String fnOut = toFnOut(fn);
        try{
            BufferedReader br = new BufferedReader(new FileReader(fn));
            BufferedWriter bw = new BufferedWriter(new FileWriter(fnOut));
            String line = null;
            int NCase = Integer.valueOf(br.readLine().trim());
            long stime = System.currentTimeMillis();
            for(int icase=0;icase<NCase;icase++){
                String[] a = toStringArray(br.readLine());
                String buf = process(a);
                String out = "Case #"+(icase+1)+": "+buf;
                bw.write(out,0,out.length());
                bw.newLine();
                long ctime = System.currentTimeMillis();
                System.out.println(String.format("--- Done: #%2d,%3.0fs, ends in:%2.1fm",(icase+1),(ctime-stime)*0.001,(ctime-stime)*0.001/60*NCase/(icase+1)));
            }
            br.close();
            bw.close();
        }catch(IOException ex){
            System.out.println(ex);
        }
    }
    static String process(String[] g){
        int opos=1,bpos=1,otime=0,btime=0;
        String out="";
        int var_time=0;
        int k=new Integer(g[0]);
        for(int j=0;j<k;j++){
            int next=new Integer(g[2*j+2]);
            if(g[2*j+1].equals("o") || g[2*j+1].equals("O")){
                int next_time=Math.max(Math.abs(next-opos)-otime,0)+1;
                var_time=var_time+next_time;
                opos=next;
                otime=0;
                btime=btime+next_time;
            }else{
                int next_time=Math.max(Math.abs(next-bpos)-btime,0)+1;
                var_time=var_time+next_time;
                bpos=next;
                btime=0;
                otime=otime+next_time;
            }
        }
        System.out.println(String.format("--- time: %2d",var_time));
        return ""+var_time;
    }
    static String[] toStringArray(String line){
        String[] p = line.trim().split("\\s+");
        String[] out = new String[p.length];
        for(int i=0;i<out.length;i++) out[i] = p[i];
        return out;
    }

    static String toFnOut(String fn){
        if(fn.lastIndexOf('.')!=-1){
            return fn.substring(0,fn.lastIndexOf('.'))+".out";
        }else return fn + ".out";
    }
}