
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

/**
 *
 * @author Charles
 */
public class CodeJam {

    //input/output file name
    static final String FILE_NAME = "A-small-attempt0";

    static int[] firstRow;
    static int[] secondRow;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException {
        ArrayList<String> values = readFile(FILE_NAME + ".in");
        int count = 1;

//        PrintWriter outFile = new PrintWriter(new File(FILE_NAME + ".out"));
//        for (String line : values) {
//            String output = processAlgorithm(line, count++);
//            System.out.println(output);
////            outFile.println(output);
////        }
//        outFile.close();
    }

    /**
     * Reads the CodeJam files and returns the input as a List of String. Should
     * be adjusted for each individual file inputs.
     *
     * @param fileName The name of the file to be read
     * @return the list containing the contents of the file.
     */
    public static ArrayList<String> readFile(String fileName) {
        ArrayList<String> results = new ArrayList<String>();
        try {
            Scanner inFile = new Scanner(new File(fileName));
            int numberOfLines = Integer.parseInt(inFile.nextLine());
            int count = 1;

            PrintWriter outFile = new PrintWriter(new File(FILE_NAME + ".out"));

            for (int cases = 0; cases < numberOfLines; cases++) {
                int first = Integer.parseInt(inFile.nextLine());
                firstRow = new int[4];
                for (int row = 1; row <= 4; row++) {
                    if (row == first) {
                        firstRow[0] = inFile.nextInt();
                        firstRow[1] = inFile.nextInt();
                        firstRow[2] = inFile.nextInt();
                        firstRow[3] = inFile.nextInt();
                    }
                    inFile.nextLine();
                }
                int second = Integer.parseInt(inFile.nextLine());
                secondRow = new int[4];
                for (int row = 1; row <= 4; row++) {
                    if (row == second) {
                        secondRow[0] = inFile.nextInt();
                        secondRow[1] = inFile.nextInt();
                        secondRow[2] = inFile.nextInt();
                        secondRow[3] = inFile.nextInt();
                    }
                    inFile.nextLine();
                }
                String output = processAlgorithm("", count++);
                System.out.println(output);
                outFile.println(output);
            }
            outFile.close();
            while (inFile.hasNextLine()) {
                results.add(inFile.nextLine());
            }
        } catch (FileNotFoundException ex) {
            System.err.println("File not found...");
            System.exit(0);
        }
        return results;
    }

    /**
     * Work the magic here.
     *
     * @param line
     * @param count
     * @return
     */
    private static String processAlgorithm(String line, int count) {
        StringBuilder result = new StringBuilder("Case #" + count + ": ");
        int sum = 0;
        int cardNumber = -1;
        for (int index = 0; index < firstRow.length; index++) {
            int target = firstRow[index];
            for (int inside = 0; inside < secondRow.length; inside++) {
                if (target == secondRow[inside]) {
                    cardNumber = target;
                    sum++;
                }
            }
        }
        if (sum == 0) {
            result.append("Volunteer cheated!");
        } else if (sum == 1) {
            result.append(cardNumber);
        } else {
            result.append("Bad magician!");
        }

        return result.toString();
    }

    /**
     * Possible helper, in certain cases, (long) Math.pow(base, exponent) does
     * NOT return a correct long value. Use this method instead when dealing
     * with large numbers.
     *
     * @param base
     * @param exponent
     * @return base base raised to the exponent power, base ^ exponent
     */
    private static long pow(int base, int exponent) {
        long result = 1;
        for (int count = 1; count <= exponent; count++) {
            result *= base;
        }
        return result;
    }

    /**
     * This method will, with limited accuracy, check to see if the floating
     * point number passed in as an argument can be considered a whole number
     * with minimal loss of precision.
     *
     * @param number
     * @return
     */
    private static boolean isDoubleWhole(double number) {
        long numberAsInteger = (long) number;

        double diff = number - numberAsInteger;

        if (diff > .00000001) {
            return false;
        } else {
            return true;
        }
    }
}
