
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;

/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
/**
 *
 * @author Charles
 */
public class SpeakingInTongues
{

    static final String FILE_NAME = "A";

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException
    {
        ArrayList<String> values = readFile(FILE_NAME + ".in");
        int count = 1;

        PrintWriter outFile = new PrintWriter(new File(FILE_NAME + ".out"));
        for (String line : values)
        {
            String output = processAlgorithm(line, count++);
            System.out.println(output);
            outFile.println(output);
        }
        outFile.close();
    }

    /**
     * Reads the CodeJam files and returns the input as a List of String.
     *
     * @param fileName The name of the file to be read
     * @return the list containing the contents of the file.
     */
    public static ArrayList<String> readFile(String fileName)
    {
        ArrayList<String> results = new ArrayList<String>();
        try
        {
            Scanner inFile = new Scanner(new File(fileName));
            int numberOfLines = Integer.parseInt(inFile.nextLine());
            while (inFile.hasNextLine())
            {
                results.add(inFile.nextLine());
            }

            if (numberOfLines != results.size())
            {
                System.err.println("File size does not match...");
                System.exit(0);
            }

        } catch (FileNotFoundException ex)
        {
            System.err.println("File not found...");
            System.exit(0);
        }
        return results;
    }

    private static String processAlgorithm(String line, int count)
    {
        StringBuilder result = new StringBuilder("Case #" + count + ": ");

        char currentLet;
        for (int index = 0; index < line.length(); index++)
        {
            result.append(getKeyCode(line.charAt(index)));
        }

    return result.toString ();
}
    
private static String getKeyCode(char let)
    {
        switch (let)
        {
            case 'a':
                return "y";
            case 'b':
                return "h";
            case 'c':
                return "e";
            case 'd':
                return "s";
            case 'e':
                return "o";
            case 'f':
                return "c";
            case 'g':
                return "v";
            case 'h':
                return "x";
            case 'i':
                return "d";
            case 'j':
                return "u";
            case 'k':
                return "i";
            case 'l':
                return "g";
            case 'm':
                return "l";
            case 'n':
                return "b";
            case 'o':
                return "k";
            case 'p':
                return "r";
            case 'q':
                return "z";
            case 'r':
                return "t";
            case 's':
                return "n";
            case 't':
                return "w";
            case 'u':
                return "j";
            case 'v':
                return "p";
            case 'w':
                return "f";
            case 'x':
                return "m";
            case 'y':
                return "a";
            case 'z':
                return "q";
            case ' ':
                return " ";
            default:
                return "ERROR!!!";
        }

    }
}
