
import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Scanner;


/*
 * To change this template, choose Tools | Templates and open the template in
 * the editor.
 */
/**
 *
 * @author Charles
 */
public class CodeJam2015B
{

    static final String FILE_NAME = "B-small-attempt1";

    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) throws FileNotFoundException
    {
        ArrayList<Case> values = readFile(FILE_NAME + ".in");
        int count = 1;

        PrintWriter outFile = new PrintWriter(new File(FILE_NAME + ".out"));
        for (Case c : values)
        {
            String output = processAlgorithm(c, count++);
            System.out.println(output);
            outFile.println(output);
        }
        outFile.close();
    }

    /**
     * Reads the CodeJam files and returns the input as a List of String.
     *
     * @param fileName The name of the file to be read
     * @return the list containing the contents of the file.
     */
    private static ArrayList<Case> readFile(String fileName)
    {
        ArrayList<Case> results = new ArrayList<Case>();
        try
        {
            Scanner inFile = new Scanner(new File(fileName));
            int numberOfLines = inFile.nextInt();
            
            //inFile.nextLine();  //  If reading strings uncomment....
            
            while (inFile.hasNextInt())
            {
                Case c = new Case();

                c.dishes = new int[inFile.nextInt()];
                for(int i = 0; i < c.dishes.length; i++) {
                    c.dishes[i] = inFile.nextInt();
                }
                
                results.add(c);
            }

            if (numberOfLines != results.size())
            {
                System.err.println("File size does not match...");
                System.exit(0);
            }

        } catch (FileNotFoundException ex)
        {
            System.err.println("File not found...");
            System.exit(0);
        }
        return results;
    }

    private static String processAlgorithm(Case c, int caseNumber)
    {
        StringBuilder result = new StringBuilder("Case #" + caseNumber + ": ");

        Arrays.sort(c.dishes);

        int highestIndex = c.dishes.length - 1;
        int highestStack = c.dishes[highestIndex];
     
        if(highestStack <= 3) {
            result.append(highestStack);
        }
        else if(highestStack == 4) {
            highestIndex--;
            if(c.dishes.length == 1 || c.dishes[highestIndex] <= 2) {
                result.append(3);
            }
            else {
                result.append(4);
            }
        }
        else if(c.dishes.length == 1) {
            if(highestStack % 3 == 0) {
                result.append(highestStack / 3 + 2);
            }
            else {
                result.append(highestStack / 3 + 3);
            }
        }
        else {
            int time = highestStack / 3 + ((highestStack % 3 == 0) ? 2 : 3);
            while(highestIndex > 0 && time < highestStack) {
                highestIndex--;
                int current = c.dishes[highestIndex];
                if(current == 4) {
                    time++;
                    break;
                }
                else if (current <= 3) {
                    break;
                }
                else {
                    time += (current % 3 == 0 ? current / 3 - 1 : current / 3);
                }
            }
            result.append((time < highestStack) ? time : highestStack);
        }

        return result.toString();
    }
    
    /**
     * Possible helper, in certain cases, (long) Math.pow(base, exponent) does
     * NOT return a correct long value. Use this method instead when dealing
     * with large numbers.
     *
     * @param base
     * @param exponent
     * @return base base raised to the exponent power, base ^ exponent
     */
    private static long pow(int base, int exponent) {
        long result = 1;
        for (int count = 1; count <= exponent; count++) {
            result *= base;
        }
        return result;
    }

    /**
     * This method will, with limited accuracy, check to see if the floating
     * point number passed in as an argument can be considered a whole number
     * with minimal loss of precision.
     *
     * @param number
     * @return
     */
    private static boolean isDoubleWhole(double number) {
        return (number - (long) number) <= .00000001;
    }
    
}

class Case
{

    int[] dishes;
}

class Node<T>
{
    T data;
    ArrayList<Node> leaves = new ArrayList<Node>();
    
    Node(T name)
    {
        this.data = name;
    }
    
    Node getChildNode(T target)
    {
        for(Node n : leaves)
        {
            if(n.data.equals(target))
            {
                return n;
            }
        }
        return null;
    }
    
    Node makeChildNode(T target)
    {
        Node n = new Node(target);
        leaves.add(n);
        return n;
    }
}

