import java.io.*;
import java.util.*;

public class C {
    public static void main(String[] args) throws Exception {
        // file handlers
        // first param is input file name
        // second param is output file name
        Scanner in = new Scanner(new File(args[0]));
        PrintStream out = new PrintStream(new FileOutputStream(args[1]));

        in.useDelimiter("\n|\r\n| ");

        int numCases = in.nextInt();
        int count = 0;

        while (in.hasNext()) {
            count++;

            int rows = in.nextInt();
            int cols = in.nextInt();
            int mines = in.nextInt();

            int totalSize = rows * cols;
            int reserveReq = 0;
            if (rows == 1 || cols == 1) {
                reserveReq = 2;
            } else {
                reserveReq = 4;
            }

            out.println("Case #" + count + ":");
            if (mines + reserveReq > totalSize && mines + 1 != totalSize) {
                // can't fit the reserve requirement together with the mines
                out.println("Impossible");
            } else {
                // possible!
                // initialise the matrix
                char[][] m = new char[rows][cols];
                for (int r = 0; r < m.length; r++) {
                    for (int c = 0; c < m[0].length; c++) {
                        m[r][c] = '.';
                    }
                }

                // reserve the corner
                if (mines + 1 == totalSize) {
                    // no reservation edge case
                    if (rows == 1) {
                        m[0][cols - 1] = 'c';
                    } else if (cols == 1) {
                        m[rows - 1][0] = 'c';
                    } else {
                        m[rows - 1][cols - 1] = 'c';
                    }
                } else {
                    if (rows == 1) {
                        m[0][cols - 1] = 'c';
                        m[0][cols - 2] = 'r'; // reserved
                    } else if (cols == 1) {
                        m[rows - 1][0] = 'c';
                        m[rows - 2][0] = 'r'; // reserved
                    } else {
                        m[rows - 1][cols - 1] = 'c';
                        m[rows - 2][cols - 1] = 'r';
                        m[rows - 1][cols - 2] = 'r';
                        m[rows - 2][cols - 2] = 'r';
                    }
                }

                // fill in the mines
                int minedCount = 0;
                for (int r = 0; r < m.length; r++) {
                    for (int c = 0; c < m[0].length; c++) {
                        if (minedCount < mines
                                && m[r][c] != 'r'
                                && m[r][c] != 'c') {
                            m[r][c] = '*';
                            minedCount++;
                        }
                    }
                }

                // replace reserved with dots
                for (int r = 0; r < m.length; r++) {
                    for (int c = 0; c < m[0].length; c++) {
                        if (m[r][c] == 'r') {
                            m[r][c] = '.';
                        }
                    }
                }

                // output the matrix
                for (int r = 0; r < m.length; r++) {
                    for (int c = 0; c < m[0].length; c++) {
                        out.print(m[r][c]);
                    }
                    out.println();
                }
            }
        }
    }
}
