import java.io.*;
import java.util.ArrayList;
import java.util.StringTokenizer;


public class AlienLanguage {
	private static ArrayList<String> input = new ArrayList<String>();
	private static String[] words;
	private static int[] numbers;
	private static String[] cases;
	private static int wordLength;

	/**
	 * Prints number of words matching each test case for given input file
	 */
	public static void main(String[] args) {
		
		try {
			// Read lines into an array
			String filename = "alsample.txt";
			File currentDirectory = new File( "." );
			filename = currentDirectory.getCanonicalPath() + "/src/" + filename;
			BufferedReader br = new BufferedReader(new FileReader(filename));
			
			while (true) {
				String line = br.readLine();
				if (line == null) break;
				input.add(line);
			}
			
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		analyzeInput();
		testCases();
	}

	private static void testCases() {
		for (int i = 0; i < cases.length; ++i) {
			int numMatchesFound = 0;
			String pattern = cases[i];
			ArrayList<String> expressions = new ArrayList<String>();
			for (int j = 0; j < wordLength; ++j) {
				if (pattern.charAt(0) != '(') {
					String exp = pattern.substring(0,1);
					expressions.add(exp);
					pattern = pattern.substring(1);
				} else {
					int endParen = pattern.indexOf(')');
					String exp = pattern.substring(1,endParen);
					expressions.add(exp);
					pattern = pattern.substring(endParen+1);
				}
			}
			for (int j = 0; j < words.length; ++j) {
				boolean mismatch = false;
				String word = words[j];
				for (int k = 0; k < word.length(); ++k) {
					char ch = word.charAt(k);
					if (expressions.get(k).indexOf(ch) == -1) {
						mismatch = true;
						break;
					}
				}
				if (!mismatch) numMatchesFound++;
			}
			System.out.println("Case #" + (i+1) + ": " + numMatchesFound);
		}
		
	}

	private static String analyzeInput() {
		// first line (L D N)
		numbers = new int[3];
		String[] numsAsStr = input.get(0).split(" ");
		//System.out.println(numsAsStr);
		for (int i = 0; i < numbers.length; i++) 
			numbers[i] = Integer.parseInt(numsAsStr[i]);
		
		wordLength = numbers[0];
		// read in words
		int numWords = numbers[1];
		words = new String[numWords];
		for (int i = 0; i < numWords; ++i) 
			words[i] = input.get(i+1);
	 
		// read in patterns
		int numPatterns = numbers[2];
		cases = new String[numPatterns];
		for (int i = 0; i < numPatterns; ++i) 
			cases[i] = input.get(numWords+i+1);
		
		
		return "";
		
	}

}
