package round1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Q1Magician {

	public static void main(String[] args) throws NumberFormatException {
		try (BufferedReader reader = new BufferedReader(new FileReader("input.txt"));
				BufferedWriter writer = new BufferedWriter(new FileWriter(
						"out.txt"))) {
			int testCases = Integer.valueOf(reader.readLine());
			for (int i = 0; i < testCases; i++) {
				writer.write(String.format("Case #%d: ", i+1));
				int rowOne = Integer.valueOf(reader.readLine());
				List<Integer> rowOneNums = readMatrix(reader, rowOne);
				int rowTwo = Integer.valueOf(reader.readLine());
				List<Integer> rowTwoNums = readMatrix(reader, rowTwo);
				rowOneNums.retainAll(rowTwoNums);
				switch (rowOneNums.size()) {
				case 0:
					writer.write("Volunteer cheated!\n");
					break;
				case 1:
					writer.write(String.format("%d\n", rowOneNums.get(0)));
					break;
				default:
					writer.write("Bad magician!\n");
					break;
				}
			}
		} catch (IOException e) {
			System.err.println(e.getMessage());
		}
	}

	public static List<Integer> readMatrix(BufferedReader reader, int row)
			throws IOException {
		List<Integer> rowValues = new ArrayList<Integer>();
		for (int i = 0; i < 4; i++) {
			String[] rowNums = reader.readLine().split(" ");
			if (i+1 == row) {
				for (String num : rowNums) {
					rowValues.add(Integer.valueOf(num));
				}
			}
		}
		return rowValues;
	}
}
