package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Comparator;
import java.util.PriorityQueue;

public class Pancakes {

	public static void main(String[] args) throws IOException {
		try (BufferedReader reader = new BufferedReader(new FileReader(
				"input.in"));
				BufferedWriter writer = new BufferedWriter(new FileWriter(
						"output"))) {
			int testCases = Integer.valueOf(reader.readLine());
			int testCase = 1;
			while (reader.ready()) {
				reader.readLine();
				String[] pancakesStr = reader.readLine().split(" ");
				PriorityQueue<Integer> pancakes = new PriorityQueue<Integer>(
						new Comparator<Integer>() {

							@Override
							public int compare(Integer o1, Integer o2) {
								if (o1 < o2) {
									return 1;
								} else if (o1 > o2) {
									return -1;
								} else {
									return 0;
								}
							}
						});
				for (String pancakeStr : pancakesStr) {
					pancakes.add(Integer.valueOf(pancakeStr));
				}

				writer.write(String.format("Case #%d: %d", testCase++,
						getMinTime(pancakes)));
				if (testCase <= testCases) {
					writer.newLine();
				}
			}
		}
	}

	private static int getMinTime(PriorityQueue<Integer> pancakes) {
		if (pancakes.peek() <= 3) {
			return pancakes.peek();
		} else {
			return Math.min(pancakes.peek(),
					1 + getMinTime(splitPancakes(pancakes)));
		}
	}

	private static PriorityQueue<Integer> splitPancakes(
			PriorityQueue<Integer> pancakes) {
		int num = pancakes.poll();
		if (num % 2 == 0) {
			pancakes.add(num / 2);
			pancakes.add(num / 2);
		} else {
			pancakes.add(num / 2);
			pancakes.add(num / 2 + 1);
		}
		return pancakes;
	}
}
