package qualifiers;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class Q2Pancakes {

	public static void main(String[] args) {
		try (BufferedReader reader = new BufferedReader(new FileReader("B-large.in")); BufferedWriter writer = new BufferedWriter(new FileWriter("out.txt"))) {
			int testCases = Integer.valueOf(reader.readLine());
			for (int i = 0; i < testCases; i++) {
				writer.write(String.format("Case #%d: ", i + 1));
				String pancakes = reader.readLine();
				// Trim happy pancakes at bottom off since no need to flip
				while (pancakes.length() > 0 && pancakes.charAt(pancakes.length() - 1) == '+') {
					pancakes = pancakes.substring(0, pancakes.length() - 1);
				}

				int numFlips = 0;
				if (pancakes.length() > 0) {
					List<String> pancakeArray = Arrays.asList(pancakes.split(""));
					while (pancakeArray.size() > 0) {
						// If start is also a - then flip whole stack
						if (pancakeArray.get(0).equals("-")) {
							pancakeArray = flipStack(pancakeArray.size() - 1, pancakeArray);
							numFlips++;
						} else {
							// Flip as many + from the start as possible
							int flipIndex = 0;
							while (pancakeArray.get(flipIndex).equals("+")) {
								flipIndex++;
							}
							pancakeArray = flipStack(flipIndex - 1, pancakeArray);
							numFlips++;
							//	Now flip the whole stack to get +'s on bottom
							pancakeArray = flipStack(pancakeArray.size() - 1, pancakeArray);
							numFlips++;
						}
						for (int j = pancakeArray.size() - 1; j > -1; j--) {
							if (pancakeArray.get(j).equals("+")) {
								pancakeArray.remove(j);
							} else {
								break;
							}
						}
					}
				}
				writer.write(String.format("%d\n", numFlips));
			}
		} catch (IOException e) {
			System.err.println(e.getMessage());
		}
		System.out.println("Finished!");
	}

	/**
	 * Flips from index 0 to given flipIndex, rest of pancakes remain untouched.
	 * 
	 * @param flipIndex
	 * @param pancakes
	 * @return
	 */
	public static List<String> flipStack(int flipIndex, List<String> pancakes) {
		List<String> flippedPancakes = new ArrayList<>(pancakes.size());
		// Deal with flipping selected stack first
		for (int i = flipIndex; i > -1; i--) {
			if (pancakes.get(i).equals("+")) {
				flippedPancakes.add(flipIndex - i, "-");
			} else {
				flippedPancakes.add(flipIndex - i, "+");
			}
		}
		// Add on the remaining pancakes
		for (int i = flipIndex + 1; i < pancakes.size(); i++) {
			flippedPancakes.add(i, pancakes.get(i));
		}
		return flippedPancakes;
	}
}
