package googlerese;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashMap;
import java.util.Map;

/**
 * Google Code Jam, Translator
 * 
 * @author Petar
 * 
 */
public class Googlerese {
	private static BufferedReader in;
	private static BufferedWriter out;
	private static Map<Character, Character> dictionary;

	/**
	 * Main, reads in Googlerese input, outputs original string
	 * 
	 * @param args
	 */
	public static void main(String[] args) {

		setUpTranslator();

		String currLine = "";
		try {
			out = new BufferedWriter(new FileWriter(".out"));
			in = new BufferedReader(new FileReader(".in"));
			int testNum = Integer.parseInt(in.readLine());
			for (int i = 0; i < testNum; i++) {
				currLine = in.readLine();
				out.write(String.format("Case #%d: ", i + 1));
				for (char c : currLine.toCharArray()) {
					out.write(dictionary.get(c));
				}
				out.newLine();
			}

			in.close();
			out.flush();
			out.close();
		} catch (FileNotFoundException e) {
			System.err.println("Input file was not found");
		} catch (IOException e) {
			System.err.println("Problem reading from input file");
			e.printStackTrace();
		}
	}

	/**
	 * Sets up the Googlerese to OrigString Translator
	 */
	private static void setUpTranslator() {
		String sample1 = "our language is impossible to understand";
		String sample2 = "there are twenty six factorial possibilities";
		String sample3 = "so it is okay if you want to just give up";
		String trainSet = sample1 + sample2 + sample3;
		String data1 = "ejp mysljylc kd kxveddknmc re jsicpdrysi";
		String data2 = "rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd";
		String data3 = "de kr kd eoya kw aej tysr re ujdr lkgc jv";
		String dataSet = data1 + data2 + data3;

		// Build dictionary
		trainSet.trim();
		dataSet.trim();
		if (trainSet.length() != dataSet.length()) {
			System.out.println("Error, sample set is not same size as dataset");
		}

		dictionary = new HashMap<Character, Character>();
		for (int i = 0; i < dataSet.length(); i++) {
			dictionary.put(dataSet.charAt(i), trainSet.charAt(i));
		}

		// Derived/Rule specified
		dictionary.put('z', 'q');
		dictionary.put('q', 'z');
		dictionary.put(' ', ' ');

		System.out.println(dictionary.entrySet().toString());
	}
}
