
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

/**
 *
 * @author Chadi
 */

enum Item {
	T(1),
	X(10),
	O(100),
	DOT(0);
	
	
	
	int value;
	
	Item(int value) {
		this.value = value;
	}
}

class TestCase {
	Item[][] board;
	boolean hasDots;
	
	public TestCase() {
	}

	
	public String solve() {
		for (int i = 0; i < board.length; i++) {
			int sum = board[i][0].value + board[i][1].value + board[i][2].value + board[i][3].value;
			String message = getMessage(sum);
			if (!message.isEmpty()) {
				return message;
			}
		}
		for (int i = 0; i < board.length; i++) {
			int sum = board[0][i].value + board[1][i].value + board[2][i].value + board[3][i].value;
			String message = getMessage(sum);
			if (!message.isEmpty()) {
				return message;
			}
		}

		int sumD1 = board[0][0].value + board[1][1].value + board[2][2].value + board[3][3].value;
		String message = getMessage(sumD1);
		if (!message.isEmpty()) {
			return message;
		}
		
		int sumD2 = board[0][3].value + board[1][2].value + board[2][1].value + board[3][0].value;
		message = getMessage(sumD2);
		if (!message.isEmpty()) {
			return message;
		}


		if (hasDots) {
			return "Game has not completed";
		}
		
		return "Draw";
	}
	
	public String getMessage(int sum) {
		if ((sum == (4*Item.X.value)) || (sum == (3*Item.X.value + Item.T.value))) {
			return "X won";
		}
		else if ((sum == (4*Item.O.value)) || (sum == (3*Item.O.value + Item.T.value))) {
			return "O won";
		}
		return "";
	}
}



public class Main {
	private static Item parse(char c) {
		if (c == '.') {
			return Item.DOT;
		}
		else if (c == 'X') {
			return Item.X;
		}
		else if (c == 'O') {
			return Item.O;
		}
		else if (c == 'T') {
			return Item.T;
		}
		return null;
	}
    public static void main(String[] args) throws FileNotFoundException, IOException {
		/* READ INPUT + DATA STRUCTURES */
		//String input = "A-small-attempt0.in";
		String input = "A-large.in";
		String output = input.replace(".in", ".out");
		File f = new File(input);
		Scanner sc = new Scanner(f);

		int T = Integer.parseInt(sc.nextLine());
		TestCase[] cases = new TestCase[T];
		for (int i = 0; i < T; i++) {
			cases[i] = new TestCase();

			/* Add inputs to this case */
			String line1 = sc.nextLine();
			String line2 = sc.nextLine();
			String line3 = sc.nextLine();
			String line4 = sc.nextLine();
			
			String[] lines = new String[] {line1, line2, line3, line4};
			
			if (i < T-1) {
				sc.nextLine();
			}
			
			Item[][] board = new Item[4][4];
			for (int ii = 0; ii < board.length; ii++) {
				board[ii] = new Item[board.length];
				for (int j = 0; j < board.length; j++) {
					board[ii][j] = parse(lines[ii].charAt(j));
					if (board[ii][j] == Item.DOT) {
						cases[i].hasDots = true;
					}
				}
			}
			
			cases[i].board = board;			
		}
		/* END READ INPUT + DATA STRUCTURES */

		File out = new File(output);
		if (out.exists()) {
			out.delete();
		}
		PrintWriter pw = new PrintWriter(new FileOutputStream(out, true));

		for (int i = 0; i < T; i++) {
			System.out.println("Solving case: " + "#" + (i+1));
			String result = "Case #" + (i+1) + ": " + cases[i].solve();
			if (i <= T-2) { pw.println(result); }
			else { pw.print(result); }
		}
		pw.close();
    }
}