import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;

public class Tidy {
    public static void main(String[] args) throws FileNotFoundException {
        TestCase[] testCases;

        String inputFile = "B-small-attempt0.in";
        String outputFile = inputFile.replace(".in", ".out");

        try(Scanner sc = new Scanner(new File(inputFile))) {
            testCases = new TestCase[sc.nextInt()];

            for (int i = 0; i < testCases.length; i++) {
                testCases[i] = new TestCase();
                testCases[i].inputNumber = sc.next().toCharArray();
            }
        }

        TestCaseResult[] results = new TestCaseResult[testCases.length];

        for (int i = 0; i < testCases.length; i++) {
            results[i] = solve(testCases[i]);
        }

        display(results, outputFile);
    }

    private static TestCaseResult solve(TestCase testCase) {
        char[] inputNumber = testCase.inputNumber;

        char[] outputNumber = Arrays.copyOf(inputNumber, inputNumber.length);

        if (outputNumber.length == 1) {
            return new TestCaseResult(outputNumber);
        }

        for (int i = outputNumber.length - 1; i >= 1; i--) {
            int curNumber = Integer.parseInt(Character.toString(outputNumber[i]));
            int prevNumber = Integer.parseInt(Character.toString(outputNumber[i-1]));

            if (curNumber < prevNumber) {
                outputNumber[i-1] = Integer.toString(prevNumber - 1).charAt(0);
                for (int j = i; j < outputNumber.length; j++) {
                    outputNumber[j] = '9';
                }
            }
        }

        return new TestCaseResult(outputNumber);
    }

    private static void display(TestCaseResult[] results, String outputFile) throws FileNotFoundException {
        try(PrintWriter pw = new PrintWriter(new FileOutputStream(outputFile))) {
            for (int i = 0; i < results.length; i++) {
                TestCaseResult result = results[i];
                pw.println("Case #" + (i + 1) + ": " + new BigInteger(new String(result.targetNumber)));
            }
        }
    }

    private static class TestCase {
        char[] inputNumber;
    }

    private static class TestCaseResult {
        char[] targetNumber;

        public TestCaseResult(char[] targetNumber) {
            this.targetNumber = targetNumber;
        }
    }
}

