import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.util.Scanner;

public class PancakeFlipper {
    public static void main(String[] args) throws FileNotFoundException {
        TestCase[] testCases;

        String inputFile = "A-large.in";
        String outputFile = inputFile.replace(".in", ".out");

        try(Scanner sc = new Scanner(new File(inputFile))) {
            testCases = new TestCase[sc.nextInt()];

            for (int i = 0; i < testCases.length; i++) {
                testCases[i] = new TestCase();
                testCases[i].sequence = sc.next().toCharArray();
                testCases[i].flipSize = sc.nextInt();
            }
        }

        TestCaseResult[] results = new TestCaseResult[testCases.length];

        for (int i = 0; i < testCases.length; i++) {
            results[i] = solve(testCases[i]);
        }

        display(results, outputFile);
    }

    private static TestCaseResult solve(TestCase testCase) {
        int flipCount = 0;

        char[] sequence = testCase.sequence;
        int flipSize = testCase.flipSize;

        for (int i = 0; i < sequence.length; i++) {
            if (sequence[i] == '-') {
                if (i + flipSize <= sequence.length) {
                    flip(sequence, i, flipSize);
                    flipCount++;
                } else {
                    return new TestCaseResult(-1);
                }
            }
        }

        return new TestCaseResult(flipCount);
    }

    private static void flip(char[] sequence, int startIndex, int flipSize) {
        for (int i = 0; i < flipSize; i++) {
            sequence[startIndex+i] = flip(sequence[startIndex+i]);
        }
    }

    private static char flip(char c) {
        if (c == '-') {
            return '+';
        } else {
            return '-';
        }
    }

    private static void display(TestCaseResult[] results, String outputFile) throws FileNotFoundException {
        try(PrintWriter pw = new PrintWriter(new FileOutputStream(outputFile))) {
            for (int i = 0; i < results.length; i++) {
                TestCaseResult result = results[i];
                pw.println("Case #" + (i + 1) + ": " + (result.flipCount == -1 ? "IMPOSSIBLE" : result.flipCount));
            }
        }
    }
}

class TestCase {
    char[] sequence;
    int flipSize;
}

class TestCaseResult {
    int flipCount;

    public TestCaseResult(int flipCount) {
        this.flipCount = flipCount;
    }
}