import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.PrintWriter;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.math.MathContext;
import java.util.Scanner;

/**
 *
 * @author Chadi
 */

class TestCase {
	BigInteger min;
	BigInteger max;
	public TestCase() {
		
	}
	public int solve() {
		int count = 0;
		BigInteger maxPlusOne = max.add(BigInteger.ONE);
		for (BigInteger cur = min; cur.compareTo(maxPlusOne) == -1; cur = cur.add(BigInteger.ONE)) {
			//System.out.println(cur + " " + isFairAndSquare(cur));
			if (isFairAndSquare(cur)) {
				count++;
			}
		}
		return count;
	}
	
	private boolean isPalindrome(String number) {
		StringBuilder sb = new StringBuilder(number);
		return sb.reverse().toString().equals(number);
	}
	
	private boolean isFairAndSquare(BigInteger num) {
		return isPalindrome(num.toString()) && isSquare(num);
	}

	private boolean isSquare(BigInteger num) {
		int max = 1000;
		int count = 0;
		BigDecimal comparison = new BigDecimal(0.05);
		BigDecimal multiplication = new BigDecimal(0.5);
		BigDecimal n = new BigDecimal(num);
		BigDecimal x = BigDecimal.ONE;
		BigDecimal xNext = x.add(n.divide(x, MathContext.DECIMAL128)).multiply(multiplication);
		while ((xNext.subtract(x).abs()).compareTo(comparison) == 1 && count < max) {
			x = xNext;
			xNext = x.add(n.divide(x, MathContext.DECIMAL128)).multiply(multiplication);
			count++;
		}
		BigInteger n1 = x.round(MathContext.DECIMAL128).toBigInteger();
		if (n1.pow(2).compareTo(num) == 0) {
			return isPalindrome(n1.toString());
		}
		return false;
	}
}

public class Main {
    public static void main(String[] args) throws FileNotFoundException, IOException {
		/* READ INPUT + DATA STRUCTURES */
		String input = "C-small-attempt0.in";
		//String input = "C-large.in";
		String output = input.replace(".in", ".out");
		File f = new File(input);
		Scanner sc = new Scanner(f);

		int T = Integer.parseInt(sc.nextLine());
		TestCase[] cases = new TestCase[T];
		for (int i = 0; i < T; i++) {
			cases[i] = new TestCase();

			/* Add inputs to this case */
			cases[i].min = new BigInteger(sc.next());
			cases[i].max = new BigInteger(sc.next());
			//sc.nextLine();
			
		}
		/* END READ INPUT + DATA STRUCTURES */

		File out = new File(output);
		if (out.exists()) {
			out.delete();
		}
		PrintWriter pw = new PrintWriter(new FileOutputStream(out, true));

		for (int i = 0; i < T; i++) {
			System.out.println("Solving case: " + "#" + (i+1));
			String result = "Case #" + (i+1) + ": " + cases[i].solve();
			if (i <= T-2) { pw.println(result); }
			else { pw.print(result); }
		}
		pw.close();
    }
}