import java.util.Scanner;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class B {

    private static final Pattern TIDY_PATTERN = Pattern.compile("(0*1*2*3*4*5*6*7*8*9*)(\\d*)");

    private static String getPrevTidyNumber(String tidyNumber) {
        char lastChar = tidyNumber.charAt(tidyNumber.length() - 1);
        char decLastChar = (char)((int) lastChar - 1);
        return tidyNumber
                .replaceFirst(Character.toString(lastChar), Character.toString(decLastChar))
                .replaceAll(Character.toString(lastChar), "9");
    }

    public static String lastTidyNumber(String lastNumber) {
        Matcher tidyMatcher = TIDY_PATTERN.matcher(lastNumber);
        tidyMatcher.matches();
        String tidyGroup = tidyMatcher.group(1);
        String restGroup = tidyMatcher.group(2);
        String resultPrefix = tidyGroup.length() > 0 && restGroup.length() > 0
                ? getPrevTidyNumber(tidyGroup) : tidyGroup;
        String resultSuffix = restGroup.replaceAll("\\d", "9");
        return (resultPrefix + resultSuffix).replaceFirst("(^0+)(.+)", "$2");
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int casesCount = scanner.nextInt();
        for (int i = 1; i <= casesCount; i++) {
            String lastNumber = scanner.next();
            System.out.format("Case #%d: %s\n", i, lastTidyNumber(lastNumber));
        }
    }
}
