import java.math.BigInteger;
import java.util.Scanner;

public class C {

    public static BigInteger getLastInterval(BigInteger stallsCount, BigInteger peopleCount) {
        BigInteger cycleLength = BigInteger.ONE.shiftLeft(peopleCount.bitLength() - 1);
        BigInteger[] divideAndRemainder = stallsCount.subtract(peopleCount).add(BigInteger.ONE)
                .divideAndRemainder(cycleLength);
        BigInteger lastInterval = divideAndRemainder[1].equals(BigInteger.ZERO)
                ? divideAndRemainder[0] : divideAndRemainder[0].add(BigInteger.ONE);
        return lastInterval;
    }

    public static String getLastMaxMinInterval(BigInteger stallsCount, BigInteger peopleCount) {
        BigInteger sumInterval = getLastInterval(stallsCount, peopleCount);
        boolean isEven = sumInterval.testBit(0);
        BigInteger maxInterval = sumInterval.shiftRight(1);
        BigInteger minInterval = isEven ? maxInterval : maxInterval.subtract(BigInteger.ONE);
        return maxInterval.toString() + " " + minInterval.toString();
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int casesCount = scanner.nextInt();
        for (int i = 1; i <= casesCount; i++) {
            BigInteger stallsCount = scanner.nextBigInteger();
            BigInteger peopleCount = scanner.nextBigInteger();
            System.out.format("Case #%d: %s\n", i, getLastMaxMinInterval(stallsCount, peopleCount));
        }
    }
}
