import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class A {

    public static double findSpeed(long distance, Horse[] horses) {
        Arrays.sort(horses);
        double time = 0L;
        for (int i = horses.length - 1; i >= 0; i--) {
            double minTime = ((double) distance - horses[i].coordinate) / horses[i].speed;
            time = Math.max(time, minTime);
        }
        return distance / time;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int casesCount = scanner.nextInt();
        for (int i = 1; i <= casesCount; i++) {
            long distance = scanner.nextInt();
            int horsesCount = scanner.nextInt();
            Horse[] horses = new Horse[horsesCount];
            for (int k = 0; k < horsesCount; k++) {
                Horse horse = new Horse();
                horse.coordinate = scanner.nextLong();
                horse.speed = scanner.nextLong();
                horses[k] = horse;
            }
            double speed = findSpeed(distance, horses);
            System.out.format(Locale.ENGLISH, "Case #%d: %1.6f\n", i, speed);
        }
    }
}

class Horse implements Comparable<Horse> {
    public long coordinate;
    public long speed;

    public int compareTo(Horse o) {
        return coordinate < o.coordinate ? -1 : coordinate == o.coordinate ? 0 : 1;
    }

    public boolean equals(Object o) {
        if (!(o instanceof Horse)) return false;
        Horse horse = (Horse) o;
        return coordinate == horse.coordinate && speed == horse.speed;
    }

    public int hashCode() {
        return (int)(31 * coordinate + speed);
    }

    public String toString() {
        return "Horse{" +
                "coordinate=" + coordinate +
                ", speed=" + speed +
                '}';
    }
}
