import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;

public class B {

    public static int countKit(int ingRequired, int ingAvailable) {
        int lowerBound = (int) Math.ceil(ingAvailable / (ingRequired * 1.1d));
        int upperBound = (int) Math.floor(ingAvailable / (ingRequired * 0.9d));
        return (lowerBound <= upperBound) ? upperBound : 0;
    }

    public static List<Integer> countKits(int ingRequired, int[] ingPackage) {
        List<Integer> kits = new LinkedList<Integer>();
        for (int i = 0; i < ingPackage.length; i++) {
            int kit = countKit(ingRequired, ingPackage[i]);
            if (kit != 0) {
                kits.add(kit);
            }
        }
        return kits;
    }

    public static int findMaxKitsSum(int[] ratatouille, int[][] packages) {
        List<Integer> kits = countKits(ratatouille[0], packages[0]);
        for (int ingIdx = 1; ingIdx < ratatouille.length; ingIdx++) {
            List<Integer> currentIngKits = countKits(ratatouille[ingIdx], packages[ingIdx]);
            List<Integer> maxKits = new LinkedList<Integer>();
            for (Integer kit : kits) {
                if (currentIngKits.contains(kit)) {
                    currentIngKits.remove(kit);
                    maxKits.add(kit);
                }
            }
            kits = maxKits;
        }
        return kits.size();
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int casesCount = scanner.nextInt();
        for (int i = 1; i <= casesCount; i++) {
            int ingNum = scanner.nextInt();
            int packageNum = scanner.nextInt();
            int[] ratatouille = new int[ingNum];
            for (int ingIdx = 0; ingIdx < ingNum; ingIdx++) {
                ratatouille[ingIdx] = scanner.nextInt();
            }
            int[][] packages = new int[ingNum][packageNum];
            for (int ingIdx = 0; ingIdx < ingNum; ingIdx++) {
                for (int packageIdx = 0; packageIdx < packageNum; packageIdx++) {
                    packages[ingIdx][packageIdx] = scanner.nextInt();
                }
            }
            System.out.format("Case #%d: %s\n", i, findMaxKitsSum(ratatouille, packages));
        }
    }
}
