import java.util.Arrays;
import java.util.Locale;
import java.util.Scanner;

public class A {

    private static class Cake implements Comparable<Cake> {
        public final long radius;
        public final long height;

        public Cake(long radius, long height) {
            this.radius = radius;
            this.height = height;
        }

        public long sideArea() {
            return 2 * radius * height;
        }

        public long topArea() {
            return radius * radius;
        }

        public int compareTo(Cake o) {
            double diff = sideArea() - o.sideArea();
            return diff < 0 ? -1 : diff == 0 ? 0 : 1;
        }
    }

    public static double findMaxArea(int k, Cake[] cakes) {
        Arrays.sort(cakes);
        Cake baseCake = cakes[cakes.length - 1];
        Cake minAreaCake = cakes[cakes.length - k];
        long totalArea = 0;
        for (int i = cakes.length - 1; i >= cakes.length - k; i--) {
            Cake cake = cakes[i];
            totalArea += cake.sideArea();
            if (cake.radius > baseCake.radius) {
                baseCake = cake;
            }
        }
        totalArea += baseCake.topArea();
        long maxArea = totalArea;
        for (Cake cake : cakes) {
            if (cake.radius > baseCake.radius) {
                long area = totalArea - minAreaCake.sideArea() - baseCake.topArea()
                            + cake.sideArea() + cake.topArea();
                if (area > maxArea) {
                    maxArea = area;
                }
            }
        }
        return maxArea * Math.PI;
    }

    public static void main(String[] args) {
        Scanner scanner = new Scanner(System.in);
        int casesCount = scanner.nextInt();
        for (int i = 1; i <= casesCount; i++) {
            int n = scanner.nextInt();
            int k = scanner.nextInt();
            Cake[] cakes = new Cake[n];
            for (int cakeIndex = 0; cakeIndex < n; cakeIndex++) {
                cakes[cakeIndex] = new Cake(scanner.nextInt(), scanner.nextInt());
            }
            double maxArea = findMaxArea(k, cakes);
            System.out.format(Locale.ENGLISH, "Case #%d: %1.9f\n", i, maxArea);
        }
    }
}
