package edu.personal.gcj;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class GettingTheDigits {

	String[] digits = new String[] { "ZERO", "ONE", "TWO", "THREE", "FOUR",
			"FIVE", "SIX", "SEVEN", "EIGHT", "NINE" };

	public String phoneNumber(String inputStr) {
		Map<Character, Integer> digitMap = new HashMap<>();
		for (int i = 0; i < inputStr.length(); i++) {
			char ch = inputStr.charAt(i);
			int count = 1;
			if (digitMap.containsKey(ch)) {
				count = digitMap.get(ch) + 1;
			}
			digitMap.put(ch, count);
		}
		String number = parseNumber(digitMap, inputStr.length());
		char[] digits = number.toCharArray();
		Arrays.sort(digits);
		number = new String(digits);
		return number;
	}

	private String parseNumber(Map<Character, Integer> digitMap, int charCount) {
		StringBuilder builder = new StringBuilder();
		while (charCount > 0) {
			int count = -1;
			if (digitMap.containsKey('Z')) {
				count = digitMap.get('Z');
				for (int i = 0; i < count; i++)
					builder.append('0');

				digitMap.remove('Z');
				digitMap.put('E', digitMap.get('E') - count);
				digitMap.put('R', digitMap.get('R') - count);
				digitMap.put('O', digitMap.get('O') - count);
				charCount -= 4 * count;
			}

			if (digitMap.containsKey('W')) {
				count = digitMap.get('W');
				for (int i = 0; i < count; i++)
					builder.append('2');

				digitMap.remove('W');
				digitMap.put('T', digitMap.get('T') - count);
				digitMap.put('O', digitMap.get('O') - count);
				charCount -= 3 * count;
			}

			if (digitMap.containsKey('U')) {
				count = digitMap.get('U');
				for (int i = 0; i < count; i++)
					builder.append('4');

				digitMap.put('F', digitMap.get('F') - count);
				digitMap.put('O', digitMap.get('O') - count);
				digitMap.remove('U');
				digitMap.put('R', digitMap.get('R') - count);

				charCount -= 4 * count;

			}

			if (digitMap.containsKey('T') && digitMap.get('T') > 0
					&& digitMap.containsKey('H') && digitMap.get('H') > 0
					&& digitMap.containsKey('R') && digitMap.get('R') > 0) {
				builder.append('3');
				digitMap.put('T', digitMap.get('T') - 1);
				digitMap.put('H', digitMap.get('H') - 1);
				digitMap.put('R', digitMap.get('R') - 1);
				digitMap.put('E', digitMap.get('E') - 2);
				charCount -= 5;
			}

			if (digitMap.containsKey('F') && digitMap.get('F') > 0
					&& digitMap.containsKey('I') && digitMap.get('I') > 0
					&& digitMap.containsKey('V') && digitMap.get('V') > 0) {
				builder.append('5');
				digitMap.put('F', digitMap.get('F') - 1);
				digitMap.put('I', digitMap.get('I') - 1);
				digitMap.put('V', digitMap.get('V') - 1);
				digitMap.put('E', digitMap.get('E') - 1);
				charCount -= 4;
			}

			if (digitMap.containsKey('X')) {
				count = digitMap.get('X');
				for (int i = 0; i < count; i++)
					builder.append('6');

				digitMap.put('S', digitMap.get('S') - count);
				digitMap.put('I', digitMap.get('I') - count);
				digitMap.remove('X');

				charCount -= 3 * count;
			}

			if (digitMap.containsKey('S') && digitMap.get('S') > 0
					&& digitMap.containsKey('N') && digitMap.get('N') > 0
					&& digitMap.containsKey('V') && digitMap.get('V') > 0) {
				builder.append('7');
				digitMap.put('S', digitMap.get('S') - 1);
				digitMap.put('E', digitMap.get('E') - 2);
				digitMap.put('V', digitMap.get('V') - 1);
				digitMap.put('N', digitMap.get('N') - 1);
				charCount -= 5;
			}

			if (digitMap.containsKey('G')) {
				count = digitMap.get('G');
				for (int i = 0; i < count; i++)
					builder.append('8');

				digitMap.put('E', digitMap.get('E') - count);
				digitMap.put('I', digitMap.get('I') - count);
				digitMap.remove('G');
				digitMap.put('H', digitMap.get('H') - count);
				digitMap.put('T', digitMap.get('T') - count);

				charCount -= 5 * count;
			}

			if (digitMap.containsKey('O') && digitMap.get('O') > 0
					&& digitMap.containsKey('N') && digitMap.get('N') > 0
					&& digitMap.containsKey('E') && digitMap.get('E') > 0) {
				builder.append('1');
				digitMap.put('O', digitMap.get('O') - 1);
				digitMap.put('N', digitMap.get('N') - 1);
				digitMap.put('E', digitMap.get('E') - 1);
				charCount -= 3;
			}

			if (digitMap.containsKey('N') && digitMap.get('N') > 1
					&& digitMap.containsKey('I') && digitMap.get('I') > 0
					&& digitMap.containsKey('E') && digitMap.get('E') > 0) {
				builder.append('9');
				digitMap.put('N', digitMap.get('N') - 2);
				digitMap.put('I', digitMap.get('I') - 1);
				digitMap.put('E', digitMap.get('E') - 1);
				charCount -= 4;
			}
		}

		return builder.toString();
	}

	public static void main(String s[]) {
		GettingTheDigits solution = new GettingTheDigits();
		Scanner scanner = null;
		try {
			scanner = new Scanner(new File("A-small-attempt1.in"));
			int T = scanner.nextInt();
			for (int i = 0; i < T; i++) {

				System.out.println(String.format("Case #%d: %s", i + 1,
						solution.phoneNumber(scanner.next())));

			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (scanner != null) {
				scanner.close();
			}
		}
	}
}
