package codejam.google.problems;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;

public class Chicks {
	public int[] locations, speeds;
	int numOfCases, numOfChicken, required, barnDist, time;
	int[][] piecePositions;

	public Chicks(String aFileName) {
		initData(aFileName);
	}

	private void initData(String aFileName) {

		try {
			BufferedReader in = new BufferedReader(new FileReader(new File(
					aFileName)));
			numOfCases = Integer.parseInt(in.readLine());
			for (int i = 0; i < numOfCases; i++) {
				String[] aString = in.readLine().split(" ");
				numOfChicken = Integer.parseInt(aString[0]);
				required = Integer.parseInt(aString[1]);
				barnDist = Integer.parseInt(aString[2]);
				time = Integer.parseInt(aString[3]);
				getLocations(in);
				getSpeeds(in);
				int count = noOfSwaps();
				if (required == 0)
					System.out.println("Case #" + (i + 1) + ": " + count);
				else
					System.out.println("Case #" + (i + 1) + ": IMPOSSIBLE");
			}
		} catch (IOException e) {

		}
	}

	private void getLocations(BufferedReader in) {
		locations = new int[numOfChicken];
		try {
			String[] aString = in.readLine().split(" ");
			for (int i = 0; i < numOfChicken; i++) {
				locations[i] = Integer.parseInt(aString[i]);

			}
		} catch (IOException e) {

		}

	}

	private void getSpeeds(BufferedReader in) {
		speeds = new int[numOfChicken];
		try {
			String[] aString = in.readLine().split(" ");
			for (int i = 0; i < numOfChicken; i++) {
				speeds[i] = Integer.parseInt(aString[i]);

			}
		} catch (IOException e) {

		}

	}

	private int noOfSwaps() {
		int swapCount = 0, timer = 1;

		while (timer <= time) {
			for (int i = 0; i < locations.length; i++) {
				locations[i] += speeds[i] * 1;
				if (locations[i] >= barnDist) {
					required--;
					locations[i] = -999999;
				}
			}

			if (required == 0)
				break;

			for (int i = 0; i < locations.length - 1; i++) {
				if (locations[i] == locations[i + 1]
						&& speeds[i] > speeds[i + 1]) {
					int temp = speeds[i + 1];
					speeds[i + 1] = speeds[i];
					speeds[i] = temp;
					swapCount++;
				}
			}
			timer++;
		}
		return swapCount;
	}

	private void displayResult() {

		for (int i = 0; i < required; i++) {
			System.out.print("" + speeds[i]);
		}
	}

	public static void main(String s[]) {
		long startTime = System.currentTimeMillis();
		Chicks test = new Chicks("C:\\GCJ\\chicks.in");
		long endTime = System.currentTimeMillis();
		System.out.println(endTime - startTime);
	}
}