import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;


public class WaterSheds {

	private int mapHeight,mapWidth,maxAltitude=11000,k=0;
    private int [][] map;
    private String [][] labellingPattern;
    private int[] neighbours=new int[4];
    private int[] sinks;
    private char ch='a';
    private int[] path;
    
	public WaterSheds(int [][] map,int mapHeight,int mapWidth)
	{
		this.map=map;
		this.mapHeight=mapHeight;
		this.mapWidth=mapWidth;
		labellingPattern=new String[mapHeight][mapWidth];
		path=new int[mapHeight*mapWidth];
		sinks=new int[mapHeight*mapWidth];
		
		for(int i=0;i<sinks.length;i++)
			sinks[i]=-1;
	}
	
	public String[][] labelling()
	{
		boolean flag=false;
		labellingPattern[0][0]=""+ch;
		findSinks();
		for(int i=0;i<k;i++)
		{
			if(sinks[i]==0)
			{
				flag=true;
				break;
			}
		}
		if(flag)
		trackPathsToFirst();
		else
			trackPathsFromFirst();
		return labellingPattern;
	}
	
	private void findSinks()
	{
		for(int i=0;i<mapHeight;i++)
		{
			for(int j=0;j<mapWidth;j++)
			{
				addNeighbours(i,j);

			
			}
		}
	}
	
	private void addNeighbours(int i,int j)
	{
         int north,west,east,south;
         if(j+1<=mapWidth-1)
        	 east=map[i][j+1];
         else
        	 east=maxAltitude;
         
         if(j-1>=0)
        	 west=map[i][j-1];
         else
        	 west=maxAltitude;
         
         if(i+1<=mapHeight-1)
        	 south=map[i+1][j];
         else
        	 south=maxAltitude;
         
         if(i-1>=0)
        	 north=map[i-1][j];
         else
        	 north=maxAltitude;
         
         neighbours[0]=north;
         neighbours[1]=west;
         neighbours[2]=east;
         neighbours[3]=south;
           if(isSink(i,j))
           {
        	   labellingPattern[i][j]=""+ch;
        	   ch++;
        	   path[i*mapWidth+j]=-1;
        	   sinks[k]=i*mapWidth+j;
               k++;
           }
           else
           {
        	   if(findMin()==0)
        		   path[i*mapWidth+j]=(i-1)*mapWidth+j;
        	   else if(findMin()==1)
        		   path[i*mapWidth+j]=i*mapWidth+(j-1);
        	   else if(findMin()==2)
        		   path[i*mapWidth+j]=i*mapWidth+(j+1);
        	   else if(findMin()==3)
        		   path[i*mapWidth+j]=(i+1)*mapWidth+j;
           }
	}
	
	private void trackPathsToFirst()
	{
		for(int j=0;j<k;j++)
		{
			for(int i=0;i<path.length;i++)
			{
				if(path[i]==sinks[j] && sinks[j]!=-1)
				{
					labellingPattern[i/mapWidth][i%mapWidth]=labellingPattern[sinks[j]/mapWidth][sinks[j]%mapWidth];
					sinks[k]=i;
                    k++;
				}
			}
		}
	}
	
	private void trackPathsFromFirst()
	{
		int j=0;
		boolean colorSwitched=false;
		String labelPattern=null;
		while(path[j]!=-1)
			j=path[j];
		
		if(!labellingPattern[j/mapWidth][j%mapWidth].equals(labellingPattern[0][0]))
		{
			labelPattern=labellingPattern[j/mapWidth][j%mapWidth];
			labellingPattern[j/mapWidth][j%mapWidth]=labellingPattern[0][0];
			colorSwitched=true;
		}
		
		if(colorSwitched)
		{
		for(int i=0;i<sinks.length;i++)
		{
			if(sinks[i]!=-1 && sinks[i]!=j)
			{
				if(labellingPattern[sinks[i]/mapWidth][sinks[i]%mapWidth].equals(labellingPattern[0][0]))
					labellingPattern[sinks[i]/mapWidth][sinks[i]%mapWidth]=labelPattern;
			}
		  }
		}
		trackPathsToFirst();
	}
	
	private int findMin()
	{
		int min=neighbours[0],minIndex=0;
		for(int i=0;i<neighbours.length;i++)
		{
			if(min>neighbours[i])
			{
				min=neighbours[i];
				minIndex=i;
			}
		}
		return minIndex;
	}
	
	private boolean isSink(int i,int j)
	{
		return(map[i][j]<=neighbours[findMin()]);
	}
	public static void main(String s[]) throws IOException
	{
		BufferedReader in= new BufferedReader(new FileReader("C:\\Chatya\\B-large.in"));
		int numOfTestCases,mapHeight,mapWidth;
        String input;
        int [][] map;
         numOfTestCases=Integer.parseInt(in.readLine());
        
        for(int i=0;i<numOfTestCases;i++)
        {
        	input=in.readLine();
        	String[] inputArguments=input.split(" ", 2);
        	mapHeight=Integer.parseInt(inputArguments[0]);
        	mapWidth=Integer.parseInt(inputArguments[1]);
        	map=new int[mapHeight][mapWidth];
        	
        	for(int j=0;j<mapHeight;j++)
        	{
        		input=in.readLine();
                inputArguments=input.split(" ", mapWidth);
        	for(int k=0;k<mapWidth;k++)
        	    map[j][k]=Integer.parseInt(inputArguments[k]);
        	
        	}
			System.out.println("Case #"+(i+1)+": ");
            String[][] labelledBasins=new WaterSheds(map,mapHeight,mapWidth).labelling();
             for(int j=0;j<mapHeight;j++)
             {
            	 for(int k=0;k<mapWidth;k++)
            		 System.out.print(labelledBasins[j][k]+" ");
            	 System.out.print("\n");
             }
            
		}

		in.close();
	}
	
}
