package edu.personal.gcj;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.Scanner;

public class PancakesRevenge {

	public int minFlips(String pancakeStack) {
		int flipCount = 0;
		if (pancakeStack.matches("^(\\+)+$")) {
			return 0;
		}
		if (pancakeStack.matches("^(\\-)+$")) {
			return 1;
		}

		while (!pancakeStack.matches("^(\\+)+$")) {
			int start = 0;
			int end = pancakeStack.lastIndexOf("-");
			while (start <= end) {
				if (pancakeStack.charAt(start) == pancakeStack.charAt(end))
					break;
				else
					end--;
			}
			pancakeStack = performFlip(pancakeStack, end);
			flipCount++;
		}

		return flipCount;
	}

	private String performFlip(String sequence, int index) {
		StringBuilder builder = new StringBuilder();
		for (int i = index; i >= 0; i--) {
			char flippedChar = sequence.charAt(i) == '-' ? '+' : '-';
			builder.append(flippedChar);
		}
		for (int i = index + 1; i < sequence.length(); i++) {
			builder.append(sequence.charAt(i));
		}
		return builder.toString();
	}

	public static void main(String[] args) {
		PancakesRevenge solution = new PancakesRevenge();
		Scanner scanner = null;
		try {
			scanner = new Scanner(new File("B-small-attempt1.in"));
			int T = scanner.nextInt();

			for (int i = 0; i < T; i++) {

				System.out.println(String.format("Case #%d: %d", i + 1,
						solution.minFlips(scanner.next())));

			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} finally {
			if (scanner != null) {
				scanner.close();
			}
		}

	}

}
