import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;

public class CookieClickerAlpha {

    private double C, X, F;

    public void setArgs(double C, double F, double X) {
	this.C = C;
	this.X = X;
	this.F = F;
    }

    public String timeForEatingCookies(int caseNum) {
	StringBuilder builder = new StringBuilder();
	builder.append(String.format("Case #%d: ", caseNum));
	double min = Double.MAX_VALUE, currentMin = Double.MAX_VALUE, cookieFarmTime = 0.0;
	int farmNum = 0;
	while (min >= currentMin) {
	    min = currentMin;
	    cookieFarmTime = getCookieFarmTime(farmNum, cookieFarmTime);
	    currentMin = cookieFarmTime + getCookieMakeTime(farmNum);
	    farmNum++;
	}
	builder.append(String.format("%.7f", min));
	return builder.toString();
    }

    private double getCookieFarmTime(int farmNum, double previousTime) {
	double retVal = 0.0;
	if (farmNum > 0) {
	    double farmRate = (farmNum - 1) * F;
	    retVal = C / (2 + farmRate) + previousTime;
	}
	return retVal;
    }

    private double getCookieMakeTime(int farmNum) {
	double retVal = 0.0;
	if (farmNum > 0) {
	    double farmRate = farmNum * F;
	    retVal = X / (2.0 + farmRate);
	} else if (farmNum == 0)
	    retVal = X / 2.0;
	return retVal;
    }

    public static void main(String[] args) {
	File inputFile = new File("C:\\gcj\\B-small-attempt0.in");
	BufferedReader reader = null;
	double c, x, f;
	CookieClickerAlpha test = new CookieClickerAlpha();
	try {
	    reader = new BufferedReader(new InputStreamReader(
		    new FileInputStream(inputFile)));
	    int numOfCases = Integer.parseInt(reader.readLine());
	    for (int i = 1; i <= numOfCases; i++) {
		String[] splits = reader.readLine().split(" ");
		c = Double.parseDouble(splits[0]);
		f = Double.parseDouble(splits[1]);
		x = Double.parseDouble(splits[2]);
		test.setArgs(c, f, x);
		System.out.println(test.timeForEatingCookies(i));
	    }
	} catch (Exception e) {
	    e.printStackTrace();
	} finally {
	    if (reader != null)
		try {
		    reader.close();
		} catch (IOException e) {
		    e.printStackTrace();
		}
	}
    }
}
