package edu.personal.gcj;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class CountingSheep {

	private final Map<Integer, Integer> digitCountMap = new HashMap<Integer, Integer>();

	public int lastAsleepNumber(int N) {
		initMap();
		int lastAsleepNumber = N;
		int i = 1;
		while (!isAsleep()) {
			extractDigits(i * N);
			lastAsleepNumber = i * N;
			i++;
		}
		return lastAsleepNumber;
	}

	private void initMap() {
		for (int i = 0; i < 10; i++) {
			digitCountMap.put(i, 0);
		}
	}

	private void extractDigits(int number) {
		while (number > 0) {
			int remainder = number % 10;
			digitCountMap.put(remainder, digitCountMap.get(remainder) + 1);
			number = number / 10;
		}
	}

	private boolean isAsleep() {
		boolean isAsleep = true;
		for (Integer value : digitCountMap.values()) {
			if (value == 0) {
				isAsleep = false;
				break;
			}

		}
		return isAsleep;
	}

	public static void main(String[] args) {
		CountingSheep solution = new CountingSheep();
		Scanner scanner = null;
		try {
			scanner = new Scanner(new File("A-small-attempt0.in"));
			int T = scanner.nextInt();

			for (int i = 0; i < T; i++) {
				int N = scanner.nextInt();
				if (N == 0) {
					System.out.println(String.format("Case #%d: INSOMNIA",
							i + 1));
				} else {
					System.out.println(String.format("Case #%d: %d", i + 1,
							solution.lastAsleepNumber(N)));
				}
			}

		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} finally {
			if (scanner != null) {
				scanner.close();
			}
		}

	}

}
