import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.HashMap;
import java.util.Map;

public class MagicTrick {
    public String guess(int[] firstIn, int[] secondIn, int caseNum) {
	StringBuilder builder = new StringBuilder();
	int answer = -1;
	builder.append(String.format("Case #%d: ", caseNum));
	Map<Integer, Boolean> map = new HashMap<Integer, Boolean>();
	for (int num : firstIn)
	    map.put(num, true);
	int present = 0;
	for (int num : secondIn) {
	    if (map.containsKey(num)) {
		present++;
		answer = num;
	    }
	}
	if (present == 1)
	    builder.append(answer);
	else if (present == 0)
	    builder.append("Volunteer cheated!");
	else
	    builder.append("Bad magician!");
	return builder.toString();
    }

    public static void main(String[] args) {
	File inputFile = new File("C:\\gcj\\A-small-attempt0.in");
	BufferedReader reader = null;
	int[] firstRow = null;
	int[] secondRow = null;
	MagicTrick test = new MagicTrick();
	try {
	    reader = new BufferedReader(new InputStreamReader(
		    new FileInputStream(inputFile)));
	    int numOfCases = Integer.parseInt(reader.readLine());
	    for (int i = 1; i <= numOfCases; i++) {
		int answer = Integer.parseInt(reader.readLine());
		firstRow = getRow(reader, answer);
		answer = Integer.parseInt(reader.readLine());
		secondRow = getRow(reader, answer);
		System.out.println(test.guess(firstRow, secondRow, i));
	    }
	} catch (Exception e) {
	    e.printStackTrace();
	} finally {
	    if (reader != null)
		try {
		    reader.close();
		} catch (IOException e) {
		    e.printStackTrace();
		}
	}
    }

    private static int[] getRow(BufferedReader reader, int num)
	    throws IOException {
	int[] retVal = new int[4];
	for (int j = 1; j <= 4; j++) {
	    String line = reader.readLine();
	    if (j == num) {
		String[] splits = line.split(" ");
		for (int k = 0; k < 4; k++)
		    retVal[k] = Integer.parseInt(splits[k]);
	    }
	}
	return retVal;
    }

}
