package codejam.google.problems;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

public class ThemePark {

	private int numOfCases;
	private LinkedList<Integer> groupQueue;

	public ThemePark(String aFileName) {

		groupQueue = new LinkedList<Integer>();
		File inputFile = new File(aFileName);
		try {
			BufferedReader in = new BufferedReader(new FileReader(inputFile));
			numOfCases = Integer.parseInt(in.readLine());
			for (int i = 1; i <= numOfCases; i++) {
				String aLine = in.readLine();
				String[] aString = aLine.split(" ");
				int noOfGroups = Integer.parseInt(aString[2]);
				String[] groups = in.readLine().split(" ");
				for (int j = 0; j < groups.length; j++)
					groupQueue.add(Integer.parseInt(groups[j]));
				displayResult(i, numOfPeople(Integer.parseInt(aString[0]),
						Integer.parseInt(aString[1]), noOfGroups));
				for (int j = 0; j < groups.length; j++)
					groupQueue.remove();
			}

		} catch (IOException e) {

		}
	}

	private int numOfPeople(int noOfRides, int capacity, int noOfGroups) {

		int noOfPeople = 0, localCapacity, groupSize;
		for (int i = 0; i < noOfRides; i++) {
			localCapacity = capacity;
			groupSize = noOfGroups;
			while (localCapacity >= 0 && groupSize >= 0) {
				localCapacity -= groupQueue.peek();
				groupSize -= 1;
				if (localCapacity >= 0 && groupSize >= 0) {
					int anItem = groupQueue.removeFirst();
					noOfPeople += anItem;
					groupQueue.add(anItem);
				}

			}

		}

		return noOfPeople;

	}

	private void displayResult(int i, int noOfPeople) {

		try {
			BufferedWriter out = new BufferedWriter(new FileWriter(
					"C:\\GCJ\\out3.txt", true));

			System.out.println("Case #" + i + ": " + noOfPeople);
			out.write("Case #" + i + ": " + noOfPeople);

			out.write("\r\n");
			out.close();
		} catch (IOException e) {

		}
	}

	public static void main(String s[]) {

		ThemePark test = new ThemePark("C:\\GCJ\\C-small-attempt0.in");
	}

}
