import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class DeceitfulWar {

    public String play(double[] n, double[] k, int caseNum) {
	StringBuilder builder = new StringBuilder();
	builder.append(String.format("Case #%d: ", caseNum));
	Arrays.sort(n);
	Arrays.sort(k);
	builder.append(String.format("%d %d", cheatPlay(n, k), warPlay(n, k)));
	return builder.toString();
    }

    private int warPlay(double[] naomi, double[] ken) {
	int retVal = 0;
	int high = ken.length - 1;
	int low = 0;
	for (int i = 0; i < naomi.length; i++) {
	    if (naomi[naomi.length - i - 1] > ken[low]) {
		if (naomi[naomi.length - i - 1] > ken[high]) {
		    retVal++;
		    low--;
		} else
		    high--;
	    }
	    low++;
	}
	return retVal;
    }

    private int cheatPlay(double[] naomi, double[] ken) {
	int retVal = 0;
	for (int i = 0; i < naomi.length; i++) {
	    if (naomi[i] < ken[0])
		retVal++;
	}
	return ken.length - retVal;
    }

    public static void main(String[] args) {
	File inputFile = new File("C:\\gcj\\D-small-attempt0.in");
	BufferedReader reader = null;
	double[] n = null;
	double[] k = null;
	DeceitfulWar test = new DeceitfulWar();
	try {
	    reader = new BufferedReader(new InputStreamReader(
		    new FileInputStream(inputFile)));
	    int numOfCases = Integer.parseInt(reader.readLine());
	    for (int i = 1; i <= numOfCases; i++) {
		int blockNum = Integer.parseInt(reader.readLine());
		n = getBlocks(reader.readLine(), blockNum);
		k = getBlocks(reader.readLine(), blockNum);
		System.out.println(test.play(n, k, i));
	    }
	} catch (Exception e) {
	    e.printStackTrace();
	} finally {
	    if (reader != null)
		try {
		    reader.close();
		} catch (IOException e) {
		    e.printStackTrace();
		}
	}
    }

    private static double[] getBlocks(String line, int size) throws IOException {
	double[] retVal = new double[size];

	String[] splits = line.split(" ");
	for (int k = 0; k < size; k++)
	    retVal[k] = Double.parseDouble(splits[k]);

	return retVal;
    }
}
