import java.io.File;
import java.io.FileNotFoundException;
import java.util.HashMap;
import java.util.Map;
import java.util.Scanner;

public class Dijkstra {

	private Map<String, String> dijkstraMap = new HashMap<String, String>();

	private static final String RESULT = "-1";

	public Dijkstra() {
		dijkstraMap.put("11", "1");
		dijkstraMap.put("1i", "i");
		dijkstraMap.put("1j", "j");
		dijkstraMap.put("1k", "k");

		dijkstraMap.put("i1", "i");
		dijkstraMap.put("ii", "-1");
		dijkstraMap.put("ij", "k");
		dijkstraMap.put("ik", "-j");

		dijkstraMap.put("j1", "j");
		dijkstraMap.put("ji", "-k");
		dijkstraMap.put("jj", "-1");
		dijkstraMap.put("jk", "i");

		dijkstraMap.put("k1", "k");
		dijkstraMap.put("ki", "j");
		dijkstraMap.put("kj", "-i");
		dijkstraMap.put("kk", "-1");

	}

	public boolean isSpellingCorrect(String input) {
		boolean valid = false;

		if (input.length() > 2) {
			String s = dijkstraMap.get(input.substring(0, 2));

			for (int i = 2; i < input.length(); i++) {
				boolean minusPresent = s.contains("-");
				if (minusPresent) {
					String key = String.valueOf(s.charAt(1)) + input.charAt(i);
					s = dijkstraMap.get(key);
				} else {
					s = dijkstraMap.get(s + input.charAt(i));
				}
				if (minusPresent) {
					minusPresent = false;
					if (s.contains("-")) {
						s = String.valueOf(s.charAt(1));
					} else {
						s = "-" + s;
					}
				}
			}
			valid = s.equals(RESULT);
		}
		return valid;
	}

	public static void main(String s[]) {
		Scanner scanner = null;
		Dijkstra test = new Dijkstra();
		StringBuilder builder = new StringBuilder();
		try {
			scanner = new Scanner(new File("C-small-attempt2.in"));
			int num = Integer.parseInt(scanner.nextLine());
			for (int i = 0; i < num; i++) {
				String[] splits = scanner.nextLine().split(" ");
				int X = Integer.parseInt(splits[1]);
				int L = Integer.parseInt(splits[0]);
				if (L == 1) {
					System.out.println(String.format("Case #%d: NO", i + 1));
					scanner.nextLine();
					continue;
				}
				String input = scanner.nextLine();
				for (int j = 0; j < X; j++)
					builder.append(input);
				if (test.isSpellingCorrect(builder.toString()))
					System.out.println(String.format("Case #%d: YES", i + 1));
				else
					System.out.println(String.format("Case #%d: NO", i + 1));
				builder.setLength(0);
			}
		} catch (FileNotFoundException e) {

			e.printStackTrace();
		} finally {
			if (scanner != null)
				scanner.close();
		}

	}
}
