
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class TidyNumbers {
		private BufferedReader br;
		private PrintWriter writer;

		public TidyNumbers(String pathToReadFile, String pathToWriteFile) {
			openReadFile(pathToReadFile);
			openWriteFile(pathToWriteFile);
		}
		
		private void openReadFile(String path) {
			try {
				br = new BufferedReader(new FileReader(path));
			} catch (FileNotFoundException e) {
				System.err.println("Can't read the input.");
			}
		}
		
		private String [] getInput() {
			String[] inputs = null;
			try {
				inputs = br.readLine().split(" ");
			} catch (IOException e) {
				System.err.println("Can't read lines.");
			}
			return inputs;
		}
		
		private void openWriteFile(String path) {
			try{
			    writer = new PrintWriter(path, "UTF-8");
			} catch (IOException e) {
				System.err.println("Can't open write file.");
			}
		}
		
		private void writeFile(String str) {
			writer.println(str);
		}
		
		private void closeAllFiles() {
			writer.close();
			try {
				br.close();
			} catch (IOException e) {
				System.err.println("Can't close files.");
			}
		}
		
		private void swap(int start, int K, int[] data) {
			for(int i = 0; i < K; ++i) {
				data[i+start] = data[i+start]==0 ? 1 : 0;
			}
		}
		
		private void work() {
			int T;
			T = Integer.parseInt(getInput()[0]);
			for(int q = 0; q < T; ++q) {
				String[] inputs = getInput();
				Long n = Long.parseUnsignedLong(inputs[0]);
				
				while(true) {
					String numberAsString = Long.toString(n);
					Long newLong = isTidy(numberAsString);
					if(newLong <= 0) break;
					else n = newLong;
				}
				writeFile("Case #"+(q+1)+": "+n);
			}
			
			closeAllFiles();
		}
		
		private Long isTidy(String numberAsString) {
			for(int i = numberAsString.length() - 1; i > 0; --i){
				if(numberAsString.charAt(i) < numberAsString.charAt(i-1)) {
					Long frontNumber = Long.parseUnsignedLong(numberAsString.substring(0, i)) - 1;
					String end = numberAsString.substring(i).replaceAll(".", "9");
					if(frontNumber > 0){
						return Long.parseUnsignedLong(Long.toString(frontNumber) + end);
					}
					else return Long.parseUnsignedLong(end);
				}
			}
			return (long) 0;
		}

		public static void main(String[] args) {
			String inputPath = "B-small-attempt0.in";
			TidyNumbers p = new TidyNumbers(inputPath, "output.txt");
			p.work();
		}

	}
