import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;


public class OversizedPancakeFlipper {

	private BufferedReader br;
	private PrintWriter writer;

	public OversizedPancakeFlipper(String pathToReadFile, String pathToWriteFile) {
		openReadFile(pathToReadFile);
		openWriteFile(pathToWriteFile);
	}
	
	private void openReadFile(String path) {
		try {
			br = new BufferedReader(new FileReader(path));
		} catch (FileNotFoundException e) {
			System.err.println("Can't read the input.");
		}
	}
	
	private String [] getInput() {
		String[] inputs = null;
		try {
			inputs = br.readLine().split(" ");
		} catch (IOException e) {
			System.err.println("Can't read lines.");
		}
		return inputs;
	}
	
	private void openWriteFile(String path) {
		try{
		    writer = new PrintWriter(path, "UTF-8");
		} catch (IOException e) {
			System.err.println("Can't open write file.");
		}
	}
	
	private void writeFile(String str) {
		writer.println(str);
	}
	
	private void closeAllFiles() {
		writer.close();
		try {
			br.close();
		} catch (IOException e) {
			System.err.println("Can't close files.");
		}
	}
	
	private void swap(int start, int K, int[] data) {
		for(int i = 0; i < K; ++i) {
			data[i+start] = data[i+start]==0 ? 1 : 0;
		}
	}
	
	private void work() {
		int T;
		T = Integer.parseInt(getInput()[0]);
		for(int q = 0; q < T; ++q) {
			int count = 0;
			String[] inputs = getInput();
			int [] data = new int[inputs[0].length()];
			for(int w = 0; w < inputs[0].length(); ++w) {
				if(inputs[0].charAt(w) == '+') data[w] = 0;
				else data[w] = 1;
			}
			int K = Integer.parseInt(inputs[1]);
			
			for(int w = 0; w <= data.length - K; ++w) {
				if(data[w] == 1) {
					count++;
					swap(w, K, data);
				}
			}
			
			for(int w = data.length - K + 1 ; w < data.length; ++w) {
				if(data[w] == 1) {
					writeFile("Case #"+(q+1)+": IMPOSSIBLE");
					break;
				}
				else if(w == data.length -1) {
					writeFile("Case #"+(q+1)+": "+count);
				}
			}
		}
		
		closeAllFiles();
	}
	
	public static void main(String[] args) {
		OversizedPancakeFlipper p = new OversizedPancakeFlipper("A-large.in", "output.txt");
		p.work();
	}

}
