
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.Comparator;

public class ParentingPartnering {
		private BufferedReader br;
		private PrintWriter writer;

		private int answer;
		
		public ParentingPartnering(String pathToReadFile, String pathToWriteFile) {
			openReadFile(pathToReadFile);
			openWriteFile(pathToWriteFile);
		}
		
		private void openReadFile(String path) {
			try {
				br = new BufferedReader(new FileReader(path));
			} catch (FileNotFoundException e) {
				System.err.println("Can't read the input.");
			}
		}
		
		private String [] getInput() {
			String[] inputs = null;
			try {
				inputs = br.readLine().split(" ");
			} catch (IOException e) {
				System.err.println("Can't read lines.");
			}
			return inputs;
		}
		
		private void openWriteFile(String path) {
			try{
			    writer = new PrintWriter(path, "UTF-8");
			} catch (IOException e) {
				System.err.println("Can't open write file.");
			}
		}
		
		private void writeFile(String str) {
			writer.println(str);
		}
		
		private void closeAllFiles() {
			writer.close();
			try {
				br.close();
			} catch (IOException e) {
				System.err.println("Can't close files.");
			}
		}
		
		private void work() {
			int T;
			T = Integer.parseInt(getInput()[0]);
			for(int q = 0; q < T; ++q) {
				String[] inputs = getInput();
				int C = Integer.parseInt(inputs[0]);
				int J = Integer.parseInt(inputs[1]);
				
				answer = C + C;
				int allocationTime = 720;
				
				if(J > C) answer = J + J;
				
				info[] dataC = new info[C];
				for(int a = 0; a < C; ++a) {
					inputs = getInput();
					int R = Integer.parseInt(inputs[0]);
					int H = Integer.parseInt(inputs[1]);
					dataC[a] = new info();
					dataC[a].R = R;
					dataC[a].H = H;
					
					if(C>=J) allocationTime -= H-R;
				}
				
				info[] dataJ = new info[J];
				for(int a = 0; a < J; ++a) {
					inputs = getInput();
					int R = Integer.parseInt(inputs[0]);
					int H = Integer.parseInt(inputs[1]);
					dataJ[a] = new info();
					dataJ[a].R = R;
					dataJ[a].H = H;
					
					if(C<J) allocationTime -= H-R;
				}
				
				Arrays.sort(dataC, aComparator);
				Arrays.sort(dataJ, aComparator);
				
				if(C == 0 && J == 0) {
					writeFile("Case #"+(q+1)+": 2");
				}
				else {
					info[] space;
					if(C >= J) {
						space = helperFunc(C, J, dataC, dataJ);
						for(int a = 0; a < C; ++a) {
							if(space[a].R >= 0 && allocationTime >= space[a].R) {
								allocationTime -= space[a].R;
								answer -= 2;
							}
							System.out.println(space[a].R);
						}
					}
					
					else {
						space = helperFunc(J, C, dataJ, dataC);
						for(int a = 0; a < J; ++a) {
							if(space[a].R >= 0 && allocationTime >= space[a].R) {
								allocationTime -= space[a].R;
								answer -= 2;
							}
							System.out.println(space[a].R);
						}
					}

					System.out.println("Case #"+(q+1)+": "+answer);
					writeFile("Case #"+(q+1)+": "+answer);
				}
			}
			
			closeAllFiles();
		}
		
		private info[] helperFunc(int C, int J, info[] dataC, info[] dataJ) {
			info[] spaceC = new info[C];
			
			int pivatStart = 0;
			for(;pivatStart < J && dataC[0].R > dataJ[pivatStart].R; pivatStart++);
			
			int pivatJ = pivatStart;
			
			for(int a = 0; a < C; ++a) {
				spaceC[a] = new info();					
				spaceC[a].R = dataC[a].H;
				if(a+1<C) spaceC[a].H = dataC[a+1].R;
				else spaceC[a].H = dataC[0].R;
				
				boolean canSwap = true;
				while(pivatJ < J) {
					if(spaceC[a].R <= dataJ[pivatJ].R && spaceC[a].H >= dataJ[pivatJ].R) {
						pivatJ++;
						canSwap = false;
					}
					else if(spaceC[a].R > spaceC[a].H && (spaceC[a].R <= dataJ[pivatJ].R || pivatStart != 0)) {
						pivatJ++;
						canSwap = false;	
					}
					else break;
				}
				if(spaceC[a].R > spaceC[a].H && (pivatStart != 0)) {
					canSwap = false;	
				}
				if(findTime(spaceC[a].R, spaceC[a].H) > 720) this.answer += 2;
				
				if(!canSwap) spaceC[a].R = -1;
				else spaceC[a].R = findTime(spaceC[a].R, spaceC[a].H);
			}
			
			Arrays.sort(spaceC, aComparator);
			
			return spaceC;
		}

		private int findTime(int r, int h) {
			if(r < h) return h - r;
			else if(h == r) return 0;
			else return 1440 - r + h;
		}

		public static void main(String[] args) {
//			String inputPath = "input.in";
			String inputPath = "B-small-attempt2.in";
			ParentingPartnering p = new ParentingPartnering(inputPath, "a_output.txt");
			p.work();
		}
		
		private class info {
			int R;
			int H;
		}

		public static Comparator<info> aComparator
	                          = new Comparator<info>() {

		    public int compare(info j, info i) {
		    	if(j.R == i.R) {
					return j.H - i.H;
				}

				return j.R - i.R;
		    }

		};
	}
