
import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class BathroomStalls {

		private BufferedReader br;
		private PrintWriter writer;

		public BathroomStalls(String pathToReadFile, String pathToWriteFile) {
			openReadFile(pathToReadFile);
			openWriteFile(pathToWriteFile);
		}
		
		private void openReadFile(String path) {
			try {
				br = new BufferedReader(new FileReader(path));
			} catch (FileNotFoundException e) {
				System.err.println("Can't read the input.");
			}
		}
		
		private String [] getInput() {
			String[] inputs = null;
			try {
				inputs = br.readLine().split(" ");
			} catch (IOException e) {
				System.err.println("Can't read lines.");
			}
			return inputs;
		}
		
		private void openWriteFile(String path) {
			try{
			    writer = new PrintWriter(path, "UTF-8");
			} catch (IOException e) {
				System.err.println("Can't open write file.");
			}
		}
		
		private void writeFile(String str) {
			writer.println(str);
		}
		
		private void closeAllFiles() {
			writer.close();
			try {
				br.close();
			} catch (IOException e) {
				System.err.println("Can't close files.");
			}
		}
		
		private void work() {
			int T;
			T = Integer.parseInt(getInput()[0]);
			for(int q = 0; q < T; ++q) {
				String[] inputs = getInput();
				Long n = Long.parseUnsignedLong(inputs[0]);
				Long k = Long.parseUnsignedLong(inputs[1]);
				
				Long max = n;
				Long min = max;
				
				for(; k > 1; k>>=1){
					max = n >> 1;
					min = (n-1) >> 1;
					if(k%2==0) n = max;
					else n = min;
				}

				max = n >> 1;
				min = (n-1) >> 1;
				writeFile("Case #"+(q+1)+": "+max+" "+min);
			}
			
			closeAllFiles();
		}

		public static void main(String[] args) {
			String inputPath = "C-large.in";
//			String inputPath = "input.txt";
			BathroomStalls p = new BathroomStalls(inputPath, "a_output.txt");
			p.work();
		}

	}
