package com.google.codejam.alien;

import java.io.BufferedReader;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.StringTokenizer;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import sun.misc.Regexp;
import sun.misc.RegexpPool;

import com.google.codejam.common.FileReader;
import com.sun.org.apache.xerces.internal.impl.xpath.regex.RegularExpression;

public class AlienLanguage {
	
	private static String example = 
			"3 5 4\n" +
			"abc\n" +
			"bca\n" +
			"dac\n" +
			"dbc\n" +
			"cba\n" +
			"(ab)(bc)(ca)\n" +
			"abc\n" +
			"(abc)(abc)(abc)\n" +
			"(zyx)bc";
	
	private FileReader reader;
	
	public AlienLanguage() {
		reader = new FileReader();
	}
	
	public void parseString(String stream) {
		reader.loadStream(stream);
		parse();
	}
	
	public void parseFile(String fileName) {
		reader.loadFile(fileName);
		parse();
	}
	
	private void parse() {
		String line;
		List<String> words = new ArrayList<String>();
		line = reader.nextLine();
		String[] LDN = line.split(" ");
		int length = Integer.valueOf(LDN[0]);
		int known = Integer.valueOf(LDN[1]);
		int tests = Integer.valueOf(LDN[2]);
		for ( int i=0 ; i<known ; i++ ) {
			words.add(reader.nextLine());
		}
		Map<Integer,Integer> storeResults = new HashMap<Integer, Integer>();
		for ( int i=0 ; i<tests ; i++ ) {
			String test = reader.nextLine();
			String regExp = toRegExp(test);
			int match = 0;
			for ( String word : words ) {
				if ( word.matches(regExp) ) {
					match++;
				}
			}
			System.out.println("Case #"+(i+1)+": "+match);
		}
	}
	
	private String toRegExp(String line) {
		String regExp = "";
		String aux = "";
		boolean inBraces = false;
		for ( char c : line.toCharArray() ) {
			if ( c == '(' ) {
				inBraces = true;
				aux = "(";
			} else if ( c == ')' ) {
				inBraces = false;
				regExp += aux + ")";
				aux = "";
			} else {
				if ( inBraces ) {
					if ( !aux.equals("(") ) {
						aux += "|";
					}
					aux += c;
				} else {
					regExp += c;
				}
			}
		}
		return regExp;
	}
	
	public static void main(String[] args) {
		AlienLanguage alien = new AlienLanguage();
		alien.parseFile("input/A-large.in");
	}
	

}
