package com.google.codejam.welcome;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.google.codejam.common.FileReader;

public class WelcomeToCodeJam {
	
	private static final String text = "welcome to code jam";
	private FileReader reader;
	
	public WelcomeToCodeJam() {
		reader = new FileReader();
	}
	
	public void parseString(String stream) {
		reader.loadStream(stream);
		parse();
	}
	
	public void parseFile(String fileName) {
		reader.loadFile(fileName);
		parse();
	}
	
	private void parse() {
		String regExp = ".*";
		for ( Character c : text.toCharArray() ) {
			regExp += c + ".*";
		}
		int cases = Integer.valueOf(reader.nextLine());
		List<Integer> lastPos = new ArrayList<Integer>();
		Map<Character,List<Integer>> inputPositions = new HashMap<Character, List<Integer>>();
		for ( int i=0 ; i<cases ; i++ ) {
			inputPositions.clear();
			lastPos.clear();
			lastPos.add(-1);
			loadInputPositions(reader.nextLine(), inputPositions); 
			for ( Character c : text.toCharArray() ) {
				List<Integer> newPos = new ArrayList<Integer>();
				for ( Integer pos : lastPos ) {
					newPos.addAll(getCharPossAfter(inputPositions, c, pos));
				}
				lastPos = newPos;
			}
			System.out.println("Case #"+(i+1)+": "+String.format("%04d", lastPos.size()));
		}
	}
	
	private List<Integer> getCharPossAfter(Map<Character,List<Integer>> inputPositions, Character c, Integer pos) {
		List<Integer> charPoss = new ArrayList<Integer>();
		List<Integer> list = inputPositions.get(c);
		if ( list != null ) {
			for ( Integer charPos : list ) {
				if ( charPos > pos ) {
					charPoss.add(charPos);
				}
			}
		}
		return charPoss;
	}
	
	private void loadInputPositions(String input, Map<Character, List<Integer>> inputPositions) {
		int index=0;
		for ( Character c : input.toCharArray() ) {
			List<Integer> pos = inputPositions.get(c);
			if ( pos == null ) {
				pos = new ArrayList<Integer>();
				inputPositions.put(c, pos);
			}
			pos.add(index++);
		}
	}
	
	public static void main(String[] args) {
		WelcomeToCodeJam jam = new WelcomeToCodeJam();
		jam.parseFile("input/C-small-attempt0.in.txt");
	}

}
