package com.google.codejam;

import java.util.ArrayList;
import java.util.StringTokenizer;

public class A {
	
	public static void main(String[] args) {
		FileReader reader = new FileReader();
		reader.loadFile("a.in");
		int tests = Integer.valueOf(reader.nextLine());
		for ( int test=1 ; test<=tests ; test++ ) {
			int treeLines = Integer.valueOf(reader.nextLine());
			StringBuffer buff = new StringBuffer();
			for ( int treeLine=0 ; treeLine < treeLines ; treeLine++ ) {
				buff.append(reader.nextLine());
			}
			String str = buff.toString().replaceAll(" +", " ").replaceAll("\\( +", "(").replaceAll(" +\\)", ")").replaceAll("\\(", " ( ").replaceAll("\\)", " ) ");
			Node tree = createTree(str, null);
			int animals = Integer.valueOf(reader.nextLine());
			System.out.println("Case #" + test + ":");
			for ( int animal=0 ; animal<animals ; animal++ ) {
				String[] caze = reader.nextLine().split(" ");
				ArrayList<String> chars = new ArrayList<String>();
				for ( int i=2 ; i<caze.length ; i++ ){
					chars.add(caze[i]);
				}
				System.out.println(String.format("%1.7f", tree.getOdds(1, chars)));
				
			}
		}
	}

	private static Node createTree(String string, StringTokenizer st) {
		if ( st == null ) {
			st = new StringTokenizer(string, " ");
		}
		Node root = new Node();
		if ( st.countTokens() > 1 ) {
			st.nextToken(); // (
			root.p = Double.valueOf(st.nextToken());
			if ( st.countTokens() > 1 ) {
				root.key = st.nextToken();
				if ( !root.key.equals(")") ) {
					root.hasKey = createTree(string, st);
					root.hasNotKey = createTree(string, st);
				}
			}
			if ( !")".equals(root.key) )
				st.nextToken(); // )
			else
				root.key = null;
		}
		return root;
	}
}

class Node {
	double p;
	String key;
	Node hasKey;
	Node hasNotKey;
	
	@Override
	public String toString() {
		String string = "( ";
		string += p;
		if ( key != null ) {
			string += " " + key + " " + hasKey.toString() + " " + hasNotKey.toString();
		}
		return string + " )";
	}
	
	public double getOdds(double p0, ArrayList<String> keys) {
		double pf = p0 * p;
		if ( key != null ) {
			if ( keys.contains(key) ) {
				pf = hasKey.getOdds(pf, keys);
			} else {
				pf = hasNotKey.getOdds(pf, keys);
			}
		}
		return pf;
	}
	
}