import java.io.OutputStream;
import java.io.FilenameFilter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.OutputStream;
import java.io.IOException;
import java.util.InputMismatchException;
import java.io.InputStreamReader;
import java.io.Writer;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Chamath Kumarasinghe
 */
public class Main {

  public static void main(String[] args) {
    InputStream inputStream;
    try {
      final String regex = "^.*\\.txt$";
      File directory = new File(".");
      File[] candidates = directory.listFiles(new FilenameFilter() {
        public boolean accept(File dir, String name) {
          return name.matches(regex);
        }
      });
      File toRun = null;
      for (File candidate : candidates) {
        if (toRun == null || candidate.lastModified() > toRun.lastModified()) {
          toRun = candidate;
        }
      }
      inputStream = new FileInputStream(toRun);
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
    OutputStream outputStream;
    try {
      outputStream = new FileOutputStream("a.out");
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
    FastScanner in = new FastScanner(inputStream);
    FastPrinter out = new FastPrinter(outputStream);
    GCJ2017 solver = new GCJ2017();
    solver.solve(1, in, out);
    out.close();
  }

  static class GCJ2017 {

    public void solve(int testNumber, FastScanner in, FastPrinter out) {
      int T = in.nextInt();
      for (int t = 0; t < T; t++) {
        int ans = 0;
        String s = in.next();
        int k = in.nextInt(), n = s.length();
        boolean[] bits = new boolean[n];
        for (int i = 0; i < n; i++) {
          if (s.charAt(i) == '+') {
            bits[i] = true;
          }
        }

        for (int i = 0; i <= n - k; i++) {
          if (!bits[i]) {
            ans++;
            for (int j = 0; j < k; j++) {
              bits[i + j] = !bits[i + j];
            }
          }

        }

        boolean aa = true;

        for (int i = 0; i < n; i++) {
          aa &= bits[i];
        }

        if (aa) {
          System.out.println("Case #" + (1 + t) + ": " + ans);
          out.println("Case #" + (1 + t) + ": " + ans);
        } else {
          System.out.println("Case #" + (1 + t) + ": IMPOSSIBLE");
          out.println("Case #" + (1 + t) + ": IMPOSSIBLE");

        }
      }
    }

  }

  static class FastPrinter extends PrintWriter {

    public FastPrinter(OutputStream out) {
      super(out);
    }

    public FastPrinter(Writer out) {
      super(out);
    }

  }

  static class FastScanner extends BufferedReader {

    public FastScanner(InputStream is) {
      super(new InputStreamReader(is));
    }


    public int read() {
      try {
        int ret = super.read();
//            if (isEOF && ret < 0) {
//                throw new InputMismatchException();
//            }
//            isEOF = ret == -1;
        return ret;
      } catch (IOException e) {
        throw new InputMismatchException();
      }
    }

    public String next() {
      StringBuilder sb = new StringBuilder();
      int c = read();
      while (isWhiteSpace(c)) {
        c = read();
      }
      if (c < 0) {
        return null;
      }
      while (c >= 0 && !isWhiteSpace(c)) {
        sb.appendCodePoint(c);
        c = read();
      }
      return sb.toString();
    }

    static boolean isWhiteSpace(int c) {
      return c >= 0 && c <= 32;
    }

    public int nextInt() {
      int c = read();
      while (isWhiteSpace(c)) {
        c = read();
      }
      int sgn = 1;
      if (c == '-') {
        sgn = -1;
        c = read();
      }
      int ret = 0;
      while (c >= 0 && !isWhiteSpace(c)) {
        if (c < '0' || c > '9') {
          throw new NumberFormatException("digit expected " + (char) c
              + " found");
        }
        ret = ret * 10 + c - '0';
        c = read();
      }
      return ret * sgn;
    }

    public String readLine() {
      try {
        return super.readLine();
      } catch (IOException e) {
        return null;
      }
    }

  }
}

