import java.io.OutputStream;
import java.io.FilenameFilter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.OutputStream;
import java.io.IOException;
import java.util.InputMismatchException;
import java.io.InputStreamReader;
import java.util.TreeMap;
import java.io.Writer;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Chamath Kumarasinghe
 */
public class Main {

  public static void main(String[] args) {
    InputStream inputStream;
    try {
      final String regex = "^.*\\.in$";
      File directory = new File(".");
      File[] candidates = directory.listFiles(new FilenameFilter() {
        public boolean accept(File dir, String name) {
          return name.matches(regex);
        }
      });
      File toRun = null;
      for (File candidate : candidates) {
        if (toRun == null || candidate.lastModified() > toRun.lastModified()) {
          toRun = candidate;
        }
      }
      inputStream = new FileInputStream(toRun);
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
    OutputStream outputStream;
    try {
      outputStream = new FileOutputStream("a.out");
    } catch (IOException e) {
      throw new RuntimeException(e);
    }
    FastScanner in = new FastScanner(inputStream);
    FastPrinter out = new FastPrinter(outputStream);
    GCJ2017 solver = new GCJ2017();
    solver.solve(1, in, out);
    out.close();
  }

  static class GCJ2017 {

    public void solve(int testNumber, FastScanner in, FastPrinter out) {
      int T = in.nextInt();
      for (int t = 0; t < T; t++) {
        long n = in.nextLong(), k = in.nextLong(), y = 0, z = 0;
        TreeMap<Long, Long> gapCount = new TreeMap<>();

        gapCount.put(n, 1L);

        while (k > 0) {
          long maxK = gapCount.lastKey();
          long count = gapCount.get(maxK);
          gapCount.remove(maxK);

          long k1 = (maxK - 1) / 2;
          long k2 = maxK - 1 - k1;

          if (count < k) {
            k -= count;

            if (gapCount.containsKey(k1)) {
              gapCount.put(k1, gapCount.get(k1) + count);
            } else {
              gapCount.put(k1, count);
            }

            if (gapCount.containsKey(k2)) {
              gapCount.put(k2, gapCount.get(k2) + count);
            } else {
              gapCount.put(k2, count);
            }

          } else {
            y = Math.max(k1, k2);
            z = Math.min(k1, k2);
            break;
          }
        }

        System.out.println("Case #" + (1 + t) + ": " + y + " " + z);
        out.println("Case #" + (1 + t) + ": " + +y + " " + z);

      }
    }

  }

  static class FastPrinter extends PrintWriter {

    public FastPrinter(OutputStream out) {
      super(out);
    }

    public FastPrinter(Writer out) {
      super(out);
    }

  }

  static class FastScanner extends BufferedReader {

    public FastScanner(InputStream is) {
      super(new InputStreamReader(is));
    }


    public int read() {
      try {
        int ret = super.read();
//            if (isEOF && ret < 0) {
//                throw new InputMismatchException();
//            }
//            isEOF = ret == -1;
        return ret;
      } catch (IOException e) {
        throw new InputMismatchException();
      }
    }

    public String next() {
      StringBuilder sb = new StringBuilder();
      int c = read();
      while (isWhiteSpace(c)) {
        c = read();
      }
      if (c < 0) {
        return null;
      }
      while (c >= 0 && !isWhiteSpace(c)) {
        sb.appendCodePoint(c);
        c = read();
      }
      return sb.toString();
    }

    static boolean isWhiteSpace(int c) {
      return c >= 0 && c <= 32;
    }

    public int nextInt() {
      int c = read();
      while (isWhiteSpace(c)) {
        c = read();
      }
      int sgn = 1;
      if (c == '-') {
        sgn = -1;
        c = read();
      }
      int ret = 0;
      while (c >= 0 && !isWhiteSpace(c)) {
        if (c < '0' || c > '9') {
          throw new NumberFormatException("digit expected " + (char) c
              + " found");
        }
        ret = ret * 10 + c - '0';
        c = read();
      }
      return ret * sgn;
    }

    public long nextLong() {
      return Long.parseLong(next());
    }

    public String readLine() {
      try {
        return super.readLine();
      } catch (IOException e) {
        return null;
      }
    }

  }
}

