import java.io.OutputStream;
import java.io.FilenameFilter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.FileInputStream;
import java.io.File;
import java.io.InputStream;
import java.io.PrintStream;
import java.io.PrintWriter;
import java.io.OutputStream;
import java.io.IOException;
import java.util.InputMismatchException;
import java.io.InputStreamReader;
import java.io.Writer;
import java.io.BufferedReader;
import java.io.InputStream;

/**
 * Built using CHelper plug-in
 * Actual solution is at the top
 *
 * @author Chamath Kumarasinghe
 */
public class Main {
    public static void main(String[] args) {
        InputStream inputStream;
        try {
            final String regex = ".*in";
            File directory = new File(".");
            File[] candidates = directory.listFiles(new FilenameFilter() {
                public boolean accept(File dir, String name) {
                    return name.matches(regex);
                }
            });
            File toRun = null;
            for (File candidate : candidates) {
                if (toRun == null || candidate.lastModified() > toRun.lastModified())
                    toRun = candidate;
            }
            inputStream = new FileInputStream(toRun);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        OutputStream outputStream;
        try {
            outputStream = new FileOutputStream("output.out");
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
        FastScanner in = new FastScanner(inputStream);
        FastPrinter out = new FastPrinter(outputStream);
        TR1B solver = new TR1B();
        solver.solve(1, in, out);
        out.close();
    }

    static class TR1B {
        public void solve(int testNumber, FastScanner in, FastPrinter out) {
            int t = in.nextInt();
            int cc = 0;
            while (t-- > 0) {
                cc++;
                System.out.print("Case #" + cc + ": ");
                out.print("Case #" + cc + ": ");
                int n = in.nextInt();
                int r = in.nextInt();
                int p = in.nextInt();
                int s = in.nextInt();
                char[] set = new char[1];
                char[] ans = null;
                for (char c : new char[]{'R', 'P', 'S'}) {
                    set[0] = c;
                    char[] res = gen(set, n);
                    int rc = 0;
                    int pc = 0;
                    int sc = 0;
                    for (char h : res) {
                        if (h == 'R')
                            rc++;
                        if (h == 'P')
                            pc++;
                        if (h == 'S')
                            sc++;
                    }
                    if (rc == r && pc == p && sc == s) {
                        fix(res, n);
                        if (ans != null) {
                            if (cmp(ans, 0, res, 0, 1 << n) > 0)
                                ans = res;
                        } else
                            ans = res;
                    }
                }

                if (ans == null) {
                    System.out.println("IMPOSSIBLE");
                    out.println("IMPOSSIBLE");
                } else {
                    for (char c : ans) {
                        out.print(c);
                        System.out.print(c);

                    }
                    System.out.println();
                    out.println();
                }


            }


        }

        char[] gen(char[] cc, int n) {
            if (n == 0)
                return cc;
            char[] ret = new char[2 * cc.length];
            for (int i = 0; i < cc.length; i++) {
                if (cc[i] == 'R') {
                    ret[2 * i] = 'R';
                    ret[2 * i + 1] = 'S';
                }
                if (cc[i] == 'P') {
                    ret[2 * i] = 'R';
                    ret[2 * i + 1] = 'P';
                }
                if (cc[i] == 'S') {
                    ret[2 * i] = 'P';
                    ret[2 * i + 1] = 'S';
                }
            }

            return gen(ret, n - 1);
        }

        void fix(char[] cc, int n) {
            int step = 2;
            int hstep = 1;
            while (step <= cc.length) {
                for (int i = 0; i < cc.length; i += step) {
                    if (cmp(cc, i, cc, i + hstep, hstep) > 0)
                        swp(cc, i, i + hstep, hstep);

                }

                step *= 2;
                hstep *= 2;
            }


        }

        private void swp(char[] cc, int i, int i1, int hstep) {
            for (int j = 0; j < hstep; j++) {
                char t = cc[i + j];
                cc[i + j] = cc[i1 + j];
                cc[i1 + j] = t;
            }
        }

        private int cmp(char[] cc, int i, char[] cc1, int i1, int hstep) {
            for (int j = 0; j < hstep; j++) {
                if (cc[i + j] != cc1[i1 + j])
                    return cc[i + j] - cc1[i1 + j];
            }
            return 0;

        }

    }

    static class FastPrinter extends PrintWriter {
        public FastPrinter(OutputStream out) {
            super(out);
        }

        public FastPrinter(Writer out) {
            super(out);
        }

        public void close() {
            super.close();
        }

    }

    static class FastScanner extends BufferedReader {
        public FastScanner(InputStream is) {
            super(new InputStreamReader(is));
        }


        public int read() {
            try {
                int ret = super.read();
//            if (isEOF && ret < 0) {
//                throw new InputMismatchException();
//            }
//            isEOF = ret == -1;
                return ret;
            } catch (IOException e) {
                throw new InputMismatchException();
            }
        }

        static boolean isWhiteSpace(int c) {
            return c >= 0 && c <= 32;
        }

        public int nextInt() {
            int c = read();
            while (isWhiteSpace(c)) {
                c = read();
            }
            int sgn = 1;
            if (c == '-') {
                sgn = -1;
                c = read();
            }
            int ret = 0;
            while (c >= 0 && !isWhiteSpace(c)) {
                if (c < '0' || c > '9') {
                    throw new NumberFormatException("digit expected " + (char) c
                            + " found");
                }
                ret = ret * 10 + c - '0';
                c = read();
            }
            return ret * sgn;
        }

        public String readLine() {
            try {
                return super.readLine();
            } catch (IOException e) {
                return null;
            }
        }

    }
}

