package com.google.codejam.snapper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigInteger;
import java.util.Date;
import java.util.Iterator;
import java.util.Set;
import java.util.TreeSet;

public class FairWarning 
{
	
	public static BigInteger calculateApocalypse(Set<BigInteger> datas)
	{
		BigInteger apocalypticValue = null;
		datas = caliberation(datas);
		Set<BigInteger> listOfDiffs = getDifferenceSet(datas);
		System.out.println("List of Diffs " +listOfDiffs);
		BigInteger hcfOfDiffs = hcf(listOfDiffs);
		BigInteger hcfOdData = hcf(datas);
		if(hcfOdData.equals(hcfOfDiffs))
		{
			apocalypticValue = new BigInteger("0");
		}
		else
		{
			BigInteger singleData = datas.iterator().next();
			BigInteger modWithHcf = singleData.mod(hcfOfDiffs);
			apocalypticValue = hcfOfDiffs.subtract(modWithHcf);
			apocalypticValue = apocalypticValue.abs();
		}
		return apocalypticValue;
	}
	
	public static Set<BigInteger> caliberation(Set<BigInteger> input)
	{
		if(input.size() == 2)
		{
			Iterator<BigInteger> itor = input.iterator();
			BigInteger smallNumber = itor.next();
			BigInteger bigNumber = itor.next();
			BigInteger newElement = bigNumber.add(bigNumber.subtract(smallNumber));
			System.out.println("New Element added : " + newElement);
			input.add(newElement);
		}
		return input;
	}
	
	public static BigInteger hcf(Set<BigInteger> datas)
	{
		BigInteger finalGCD = null;
		/*Set<BigInteger> sortedInput = new TreeSet<BigInteger>();
		sortedInput.addAll(datas);*/
		for(BigInteger singleValue : datas)
		{
			if(finalGCD == null)
			{
				finalGCD = singleValue;
			}
			else
			{
				finalGCD = hcf(finalGCD,singleValue);
				//System.out.println("Prev : " + previousInput+" Next : " + singleValue);
				//System.out.println("Diff: "+ listOfDifferences);
			}
		}
		return finalGCD;
	}
	
	public static Set<BigInteger> getDifferenceSet(Set<BigInteger> sets)
	{
		Set<BigInteger> diffSet = new TreeSet<BigInteger>();
		BigInteger previousOne= null;
		for(BigInteger oneInt : sets)
		{
			if(previousOne == null)
			{
				previousOne = oneInt;
			}
			else
			{
				diffSet.add(oneInt.subtract(previousOne));
				previousOne = oneInt;
			}
		}
		return diffSet;
	}
	
	public static BigInteger hcf(BigInteger bigNumber, BigInteger smallNumber)
	{
		BigInteger tmp;
		BigInteger zeroBigInt = new BigInteger("0");
//		 make sure a is the larger of the two, swap around if needed
		if (bigNumber.compareTo(smallNumber) < 0)
		{
			tmp = smallNumber;
			smallNumber = bigNumber;
			bigNumber = tmp;
		}
		//System.out.println("Big : " + bigNumber +" Small no : " + smallNumber);
		tmp = bigNumber.mod(smallNumber);
		//System.out.println("Mod : " + tmp);
		while (!zeroBigInt.equals(tmp))
		{
			bigNumber = smallNumber;
			smallNumber = tmp;
			tmp = bigNumber.mod(smallNumber);
			//System.out.println("Mod : " + tmp);
		}
		
		return smallNumber;
	}
	
	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		Date startTime = new Date();
		if(args.length!=1)
		{
			System.out.println("Invalid Input.Please enter a file");
			System.exit(-1);
		}
		
		String filePath = args[0];
		filePath = "c:/Apocalypse.in";
		String outputFile = "output.txt";
		File fileInput = new File(filePath);
		File fileOutput = new File(outputFile);
		BufferedWriter bufferedWriter = null;
		BufferedReader bufferedReader = null;
		try 
		{
			bufferedReader = new BufferedReader(new FileReader(fileInput));
			bufferedWriter = new BufferedWriter(new FileWriter(outputFile));
			String inputLine = bufferedReader.readLine();
			Integer totalInputs = new Integer(inputLine);
			for(int currentInputIndex =0;currentInputIndex<totalInputs.intValue();currentInputIndex++)
			{
				String firstLine = inputLine = bufferedReader.readLine();
				System.out.println(firstLine);
				if(firstLine!= null &&!"".equals(firstLine))
				{
					String[] apocalypicInputs = firstLine.split(" ");
					int totalNoOfInputs = new Integer(apocalypicInputs[0]).intValue();
					Set<BigInteger> apoInputsInbigInt = new TreeSet<BigInteger>();
					for(int i=1;i<apocalypicInputs.length;i++)
					{
						apoInputsInbigInt.add(new BigInteger(apocalypicInputs[i]));
					}
					
					String output = "Case #"+(currentInputIndex+1)+": "+calculateApocalypse(apoInputsInbigInt)+"\n";
					System.out.print(output);
					bufferedWriter.write(output);
				}
			}
		}
		catch (Exception e) 
		{
			System.out.println("Error while trying to read file.");
			e.printStackTrace();
			System.exit(-1);
		}
		finally
		{
			try
			{
				if(bufferedReader!= null)
					bufferedReader.close();
				if(bufferedWriter != null)
					bufferedWriter.close();
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		Date toTime = new Date();
		System.out.println("from " + startTime.toLocaleString());
		System.out.println("To " + toTime.toLocaleString());
	}

	
}
