package com.google.codejam.snapper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;


public class SnapperChain 
{
	public static void main(String args[])
	{
		if(args.length!=1)
		{
			System.out.println("Invalid Input.Please enter a file");
			System.exit(-1);
		}
		String filePath = args[0];
		
		String outputFile = "output.txt";
		File fileInput = new File(filePath);
		File fileOutput = new File(outputFile);
		BufferedWriter bufferedWriter = null;
		BufferedReader bufferedReader = null;
		try 
		{
			bufferedReader = new BufferedReader(new FileReader(fileInput));
			bufferedWriter = new BufferedWriter(new FileWriter(outputFile));
			String inputLine = bufferedReader.readLine();
			Integer totalInputs = new Integer(inputLine);
			for(int i =0;i<totalInputs.intValue();i++)
			{
				inputLine = bufferedReader.readLine();
				if(inputLine!= null &&!"".equals(inputLine))
				{
					String[] nAndKInputs = inputLine.split(" ");
					if(nAndKInputs.length == 2)
					{
						int n = new Integer(nAndKInputs[0]).intValue();
						int k = new Integer(nAndKInputs[1]).intValue();
						String output = "Case #"+(i+1)+": "+isLightOn(n,k)+"\n";
						//System.out.print(n+","+k+" ");
						//System.out.println(output);
						bufferedWriter.write(output);
					}
				}
			}
		}
		catch (Exception e) 
		{
			System.out.println("Error while trying to read file.");
			e.printStackTrace();
			System.exit(-1);
		}
		finally
		{
			try
			{
				if(bufferedReader!= null)
					bufferedReader.close();
				if(bufferedWriter != null)
					bufferedWriter.close();
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
	}
	
	public static int power(int n, int k)
	{
		int output=1;
		for(int i=0;i<k;i++)
		{
			output = output * n;
		}
		return output;
	}
	
	public static String isLightOn(int n, int k)
	{
		String finalOutput = "OFF";
		int powervalue =  new Double(Math.pow(2,n)).intValue();
		int newPower = power(2,n);
		if(powervalue!= newPower)
			System.out.println("ERROR");
		//int tempK = k;
		int remainder = (k%powervalue);
		//int lightValue = (k-multiple) % powervalue;
		//boolean lightStatus = false;
		if(remainder == powervalue -1)
		{
			//lightStatus = true;
			finalOutput = "ON";
		}
		/*if(tempK==0)
		{
			lightStatus = false;
			finalOutput = "OFF";
		}*/
		return finalOutput;
	}

}
