package com.google.codejam.snapper;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Date;
import java.util.LinkedList;
import java.util.Queue;

public class Roller 
{

	public static int calculateFair(int totalNoOfRides, int capacityOfRide, Queue<Group> groupSizes)
	{
		int fair = 0;
		for(int rideIndex=0; rideIndex<totalNoOfRides; rideIndex++)
		{
			int capacityLeftForRide = capacityOfRide;
			while(!groupSizes.isEmpty() && capacityLeftForRide >= groupSizes.peek().size)
			{
				Group first = groupSizes.peek();
				if(first.count == rideIndex)
					break;
				groupSizes.remove();
				first.count = rideIndex;
				capacityLeftForRide = capacityLeftForRide - first.size;
				fair= fair + first.size;
				groupSizes.add(first);
			}
		}
		return fair;
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) 
	{
		Date startTime = new Date();
		if(args.length!=1)
		{
			System.out.println("Invalid Input.Please enter a file");
			System.exit(-1);
		}
		String filePath = args[0];
		filePath = "c:/Roller.in";
		String outputFile = "output.txt";
		File fileInput = new File(filePath);
		File fileOutput = new File(outputFile);
		BufferedWriter bufferedWriter = null;
		BufferedReader bufferedReader = null;
		try 
		{
			bufferedReader = new BufferedReader(new FileReader(fileInput));
			bufferedWriter = new BufferedWriter(new FileWriter(outputFile));
			String inputLine = bufferedReader.readLine();
			Integer totalInputs = new Integer(inputLine);
			for(int currentInputIndex =0;currentInputIndex<totalInputs.intValue();currentInputIndex++)
			{
				String firstLine = inputLine = bufferedReader.readLine();
				String secondLine = inputLine = bufferedReader.readLine();
				//System.out.println(firstLine);
				//System.out.println(secondLine);
				Queue<Group> groupSizeQueue = new LinkedList<Group>();
				if(firstLine!= null &&!"".equals(firstLine)&& secondLine!= null &&!"".equals(secondLine))
				{
					
					String[] RkNInputs = firstLine.split(" ");
					if(RkNInputs.length == 3)
					{
						int totalNoOfRides = new Integer(RkNInputs[0]).intValue();
						int capacityOfRide = new Integer(RkNInputs[1]).intValue();
						int noOfGroups = new Integer(RkNInputs[2]).intValue();
						String[] groupSizes = secondLine.split(" ");
						if(groupSizes.length == noOfGroups)
						{
							for(int currentGroupNo =0;currentGroupNo<noOfGroups;currentGroupNo++)
							{
								Group singleGroup = new Group();
								singleGroup.size = (new Integer(groupSizes[currentGroupNo])).intValue();
								singleGroup.count = -1;
								groupSizeQueue.add(singleGroup);
							}
						}
						String output = "Case #"+(currentInputIndex+1)+": "+calculateFair(totalNoOfRides,capacityOfRide,groupSizeQueue)+"\n";
						
						System.out.println(output);
						bufferedWriter.write(output);
					}
					else
					{
						System.out.println("Invalid Input");
						System.exit(-1);
					}
				}
			}
		}
		catch (Exception e) 
		{
			System.out.println("Error while trying to read file.");
			e.printStackTrace();
			System.exit(-1);
		}
		finally
		{
			try
			{
				if(bufferedReader!= null)
					bufferedReader.close();
				if(bufferedWriter != null)
					bufferedWriter.close();
			}
			catch (Exception e) {
				e.printStackTrace();
			}
		}
		Date toTime = new Date();
		System.out.println("from " + startTime.toLocaleString());
		System.out.println("To " + toTime.toLocaleString());
	}

}


class Group
{
	public int size;
	public int count;
}