package codejam2014.qual.magictrick;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Set;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        InputStream inputStream = new FileInputStream(
                "/Users/chandangiri/Documents/workspace/Competetions/src/codejam2014/qual/magictrick/A-small-attempt0.in");
        OutputStream outputStream = new FileOutputStream(
                "/Users/chandangiri/Documents/workspace/Competetions/src/codejam2014/qual/magictrick/out.txt");
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        MagicTrick solver = new MagicTrick();
        int testCount = in.nextInt();
        for (int i = 1; i <= testCount; i++) {
            solver.solve(i, in, out);
        }
        out.close();
    }
}

class MagicTrick {

    public void solve(int testNumber, InputReader in, PrintWriter out) {
        int x = in.nextInt();
        int a[][] = new int[4][4];
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                a[i][j] = in.nextInt();
            }
        }
        Set<Integer> sa = new HashSet<>();
        for (int j = 0; j < 4; j++) {
            sa.add(a[x - 1][j]);
        }

        int y = in.nextInt();
        int b[][] = new int[4][4];
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                b[i][j] = in.nextInt();
            }
        }
        Set<Integer> sb = new HashSet<>();
        for (int j = 0; j < 4; j++) {
            sb.add(b[y - 1][j]);
        }

        sa.retainAll(sb);

        out.printf("Case #%d: ", testNumber);
        if (sa.size() == 1) {
            out.println(sa.iterator().next());
        } else if (sa.size() > 1) {
            out.println("Bad magician!");
        } else {
            out.println("Volunteer cheated!");
        }
    }
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public double nextDouble() {
        return Double.parseDouble(next());
    }

    public long nextLong() {
        return Long.parseLong(next());
    }
}

