package TicTacToeTomek;

import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class TicTacToe {
	final static String PROBLEM_NAME = "tictactoe";
    final static String WORK_DIR = "/Users/chandangiri/Desktop/CJ/" + PROBLEM_NAME + "/";
    String A[] = new String[4];
    
    boolean checkRow(int r, char ch) {
    	int c = 0;
    	for(int i=0; i<4; i++) {
    		if(A[r].charAt(i)==ch || A[r].charAt(i)=='T') {
    			c++;
    		}
    	}
    	if(c == 4) {
    		return true;
    	}
    	return false;
    }
    
    boolean checkColumn(int r, char ch) {
    	int c = 0;
    	for(int i=0; i<4; i++) {
    		if(A[i].charAt(r)==ch || A[r].charAt(i)=='T') {
    			c++;
    		}
    	}
    	if(c == 4) {
    		return true;
    	}
    	return false;
    }
    
    boolean checkDiagonal(char ch) {
    	int c1 = 0,c2 = 0;
    	for(int i=0; i<4; i++) {
    		if(A[i].charAt(i)==ch || A[i].charAt(i)=='T') {
    			c1++;
    		}
    		if(A[i].charAt(3-i)==ch || A[i].charAt(3-i)=='T') {
    			c2++;
    		}
    	}
    	if(c1==4 || c2==4) {
    		return true;
    	}
    	return false;
    }
    
    boolean checkWin(char ch) {
    	if(checkRow(0,ch) || checkRow(1,ch) || checkRow(2, ch) || checkRow(3, ch)) {
    		return true;
    	}
    	if(checkColumn(0,ch) || checkColumn(1,ch) || checkColumn(2, ch) || checkColumn(3, ch)) {
    		return true;
    	}
    	if(checkDiagonal(ch)) {
    		return true;
    	}
    	return false;
    }
    
    boolean containsDot() {
    	if(A[0].contains(".") || A[1].contains(".") || A[2].contains(".") || A[3].contains(".")) {
    		return true;
    	}
    	return false;
    }
    
    void solve(Scanner sc, PrintWriter pw) {
    	sc.nextLine();
    	A[0] = sc.nextLine();
    	A[1] = sc.nextLine();
    	A[2] = sc.nextLine();
    	A[3] = sc.nextLine();
    	if(checkWin('O')) {
    		pw.print("O won");
    	} else if(checkWin('X')) {
    		pw.print("X won");
    	} else if(containsDot()) { 
    		pw.print("Game has not completed");
    	} else {
    		pw.print("Draw");
    	}
    	pw.println();
    }
    
	public static void main(String[] args) throws IOException {
		Scanner sc = new Scanner(new FileReader(WORK_DIR + "input.txt"));
        PrintWriter pw = new PrintWriter(new FileWriter(WORK_DIR + "output.txt"));
		int testCount = sc.nextInt();
		for (int i = 0; i < testCount; i++) {
            pw.print("Case #" + (i + 1) + ": ");
            new TicTacToe().solve(sc, pw);
        }
		pw.flush();
        pw.close();
        sc.close();
	}
}





