package codejam2014.qual.deceitfulwar;

import java.io.BufferedReader;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class Main {

    public static void main(String[] args) throws FileNotFoundException {
        InputStream inputStream = new FileInputStream(
                "/Users/chandangiri/Documents/workspace/Competetions/src/codejam2014/qual/deceitfulwar/D-large.in");
        OutputStream outputStream = new FileOutputStream(
                "/Users/chandangiri/Documents/workspace/Competetions/src/codejam2014/qual/deceitfulwar/out.txt");
        //        InputStream inputStream = System.in;
        //        OutputStream outputStream = System.out;
        InputReader in = new InputReader(inputStream);
        PrintWriter out = new PrintWriter(outputStream);
        DeceitfulWar solver = new DeceitfulWar();
        int testCount = in.nextInt();
        for (int i = 1; i <= testCount; i++) {
            out.printf("Case #%d: ", i);
            solver.solve(in, out);
        }
        out.close();
    }
}

class DeceitfulWar {

    public void solve(InputReader in, PrintWriter out) {
        int n = in.nextInt();
        double nao[] = new double[n];
        double ken[] = new double[n];

        for (int i = 0; i < n; i++) {
            nao[i] = in.nextDouble();
        }
        for (int i = 0; i < n; i++) {
            ken[i] = in.nextDouble();
        }
        Arrays.sort(nao);
        Arrays.sort(ken);
        int deceit = deceit(n, nao, ken);
        int optimal = optimal(n, nao, ken);
        out.println(deceit + " " + optimal);
    }

    private int optimal(int n, double[] nao, double[] ken) {
        int j = 0;
        int ct = 0;
        for (int i = 0; i < n && j < n; i++) {
            for (; j < n; j++) {
                if (ken[j] > nao[i]) {
                    ct++;
                    j++;
                    break;
                }
            }
        }
        return (n - ct);
    }

    private int deceit(int n, double[] nao, double[] ken) {
        int ct = 0;
        //strategy : block just greater than that block or give lesser weight blocks
        int j = 0;
        for (int i = 0; i < n; i++) {
            for (; j < n; j++) {
                if (nao[j] > ken[i]) {
                    ct++;
                    j++;
                    break;
                }
            }
        }
        return ct;
    }
}

class InputReader {
    private BufferedReader reader;
    private StringTokenizer tokenizer;

    public InputReader(InputStream stream) {
        reader = new BufferedReader(new InputStreamReader(stream));
        tokenizer = null;
    }

    public String next() {
        while (tokenizer == null || !tokenizer.hasMoreTokens()) {
            try {
                tokenizer = new StringTokenizer(reader.readLine());
            } catch (IOException e) {
                throw new RuntimeException(e);
            }
        }
        return tokenizer.nextToken();
    }

    public int nextInt() {
        return Integer.parseInt(next());
    }

    public double nextDouble() {
        return Double.parseDouble(next());
    }

    public long nextLong() {
        return Long.parseLong(next());
    }
}

