package qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class A {

	public static void main(String[] args) throws Exception {
		Scanner in = new Scanner("IO_2013/inputs/A-large.in");
		PrintWriter out = new PrintWriter("IO_2013/outputs/A-large.out");

		int n = in.nextInt();

		/*
		 * [0][0] quantidade X 1 linha [0][1] quantidade X 2 linha [0][2]
		 * quantidade X 3 linha [0][3] quantidade X 4 linha [0][4] quantidade
		 * X diagonal 1 [0][5] quantidade X diagonal 2 [0][6] quantidade X 1
		 * coluna [0][7] quantidade X 2 coluna [0][8] quantidade X 3 coluna
		 * [0][9] quantidade X 4 coluna
		 * 
		 * [1][0] quantidade O 1 linha . . . T -> soma para X e O
		 */

		for (int i = 1; i <= n; i++) {
			out.print("Case #" + i + ": ");

			int quantidade[][] = new int[2][10];
			boolean aindaDaParaJogar = false;
			boolean alguemGanhou = false;

			for (int j = 0; j < 4; j++) {
				in.nextLine();

				if (!alguemGanhou) {
					for (int z = 0; z < 4; z++) {

						if (in.line.charAt(z) == 'X') {
							// soma a linha
							quantidade[0][j]++;

							// soma a coluna
							quantidade[0][6 + z]++;

							// se est na primeira diagonal
							if (j == z) {
								quantidade[0][4]++;
							} else if ((j == 0 && z == 3) || (j == 1 && z == 2)
									|| (j == 2 && z == 1) || (j == 3 && z == 0)) {
								quantidade[0][5]++;
							}

						} else if (in.line.charAt(z) == 'O') {
							// soma a linha
							quantidade[1][j]++;

							// soma a coluna
							quantidade[1][6 + z]++;

							// se est na primeira diagonal
							if (j == z) {
								quantidade[1][4]++;
							} else if ((j == 0 && z == 3) || (j == 1 && z == 2)
									|| (j == 2 && z == 1) || (j == 3 && z == 0)) {
								quantidade[1][5]++;
							}

						} else if (in.line.charAt(z) == 'T') {
							// soma para X e O
							quantidade[0][j]++;
							quantidade[1][j]++;

							quantidade[0][z + 6]++;
							quantidade[1][z + 6]++;

							// se est na primeira diagonal
							if (j == z) {
								quantidade[0][4]++;
								quantidade[1][4]++;
							} else if ((j == 0 && z == 3) || (j == 1 && z == 2)
									|| (j == 2 && z == 1) || (j == 3 && z == 0)) {
								quantidade[0][5]++;
								quantidade[1][5]++;
							}
						} else if (in.line.charAt(z) == '.') {
							aindaDaParaJogar = true;
						}
					}

					if (quantidade[0][j] == 4) {
						alguemGanhou = true;
						out.println("X won");
					} else if (quantidade[1][j] == 4) {
						alguemGanhou = true;
						out.println("O won");
					}
				}
			}
			
			if (!alguemGanhou) {

				// verifica se h vencedores por coluna
				for (int c = 6; c < 10; c++) {
					if (quantidade[0][c] == 4) {
						alguemGanhou = true;
						out.println("X won");
						break;
					} else if (quantidade[1][c] == 4) {
						alguemGanhou = true;
						out.println("O won");
						break;
					}
				}

				// verifica a diagonal
				if (!alguemGanhou) {
					if (quantidade[0][4] == 4 || quantidade[0][5] == 4) {
						alguemGanhou = true;
						out.println("X won");
					} else if (quantidade[1][4] == 4
							|| quantidade[1][5] == 4) {
						alguemGanhou = true;
						out.println("O won");
					}
				}

				// empate
				if (!alguemGanhou) {

					if (aindaDaParaJogar)
						out.println("Game has not completed");
					else
						out.println("Draw");
				}
			}
			
			in.nextLine();
		}
		out.close();
	}

	static char posicao(int letra) {

		char[] v = { 'y', 'h', 'e', 's', 'o', 'c', 'v', 'x', 'd', 'u', 'i',
				'g', 'l', 'b', 'k', 'r', 'z', 't', 'n', 'w', 'j', 'p', 'f',
				'm', 'a', 'q' };

		return v[letra - 97];
	}

	public static class Scanner {
		private final BufferedReader in;
		private String line = "";
		private int pos;
		private int lineNo;

		public Scanner(String Arquive) throws Exception {
			in = new BufferedReader(new FileReader(Arquive));
			nextLine();
		}

		public boolean hasNext() throws IOException {
			return in.ready();
		}

		public void close() {
			try {
				in.close();
			} catch (IOException e) {
				throw new AssertionError("Failed to close with " + e);
			}
		}

		public void nextLine() {
			try {
				line = in.readLine();
			} catch (IOException e) {
				throw new AssertionError("Failed to read line with " + e);
			}
			pos = 0;
			lineNo++;
		}

		public String next() {
			if (pos != 0) {
				pos++;
			}
			StringBuilder sb = new StringBuilder();
			while (pos < line.length() && line.charAt(pos) > ' ')
				sb.append(line.charAt(pos++));
			return sb.toString();
		}

		public int nextInt() {
			int num, total = 0;
			boolean negativo = false;

			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}

			while (pos < line.length() && line.charAt(pos) > ' ') {
				num = line.charAt(pos++) - '0';
				total *= 10;
				total += num;
			}
			if (negativo)
				total *= -1;

			return total;
		}

		public long nextLong() {
			long num, total = 0;
			boolean negativo = false;
			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}
			while (pos < line.length() && line.charAt(pos) > ' ') {
				num = line.charAt(pos++) - '0';
				total *= 10;
				total += num;
			}
			if (negativo)
				total *= -1;
			return total;
		}
	}

}
