package Qualification;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

/* *****************************************************************************************************************************
 * Judge: Google Code Jam
 * Round: Qualification
 * Problem: B_Tidy_Numbers
 * URL: 
 * Description: 
 *******************************************************************************************************************************/
public class B_Tidy_Numbers {
	private static Scanner in;
	private static PrintWriter out;
	private static boolean printConsole;

	public static void main(String[] args) throws Exception {
		String inputSize = "B-small-attempt0";

		String pathInput = "IO_2017/inputs/" + inputSize + ".in";
		String pathOutput = "IO_2017/outputs/" + inputSize + ".out";

		printConsole = inputSize.equals("default") || false;

		in = new Scanner(pathInput);
		out = new PrintWriter(pathOutput);

		int t = nextInt();

		int[] number = new int[19];
		int digits = 0;

		for (int i = 1; i <= t; i++) {
			nextLine();
			printf("Case #%d: ", i);

			digits = in.line.length();

			for (int j = 0; j < digits; j++) {
				number[j] = in.line.charAt(j) - '0';
			}

			if (isTidy(number, digits)) {
				println(getLine());
			} else {

				digits = transformNumber(number, digits);

				for (int j = 0; j < digits; j++)
					print(number[j]);

				println();
			}
		}

		out.close();
	}

	private static int transformNumber(int[] number, int digits) {

		int wrong = 0;

		do {

			for (int i = 0; i < digits - 1; i++) {
				if (number[i] > number[i + 1]) {
					wrong = i + 1;
					break;
				}
			}

			if (number[wrong - 1] == 1) {
				digits--;
				wrong = 0;
			} else
				number[wrong - 1]--;

			for (int j = wrong; j < digits; j++)
				number[j] = 9;

		} while (!isTidy(number, digits));

		return digits;
	}

	private static boolean isTidy(int[] number, int digits) {

		for (int i = 1; i < digits; i++) {
			if (number[i] < number[i - 1])
				return false;
		}

		return true;
	}

	private static String getLine() {
		return in.line;
	}

	private static boolean EOL() {
		return in.EOL();
	}

	private static String next() {
		return in.next();
	}

	private static void nextLine() {
		in.nextLine();
	}

	private static int nextInt() {
		return in.nextInt();
	}

	private static long nextLong() {
		return in.nextLong();
	}

	private static double nextDouble() {
		return in.nextDouble();
	}

	private static void print(Object value) {
		if (printConsole)
			System.out.print(value);
		out.print(value);
	}

	private static void printf(String format, Object... params) {
		if (printConsole)
			System.out.printf(format, params);
		out.printf(format, params);
	}

	private static void println(Object value) {
		if (printConsole)
			System.out.println(value);
		out.println(value);
	}

	private static void println() {
		if (printConsole)
			System.out.println();
		out.println();
	}

	private static class Scanner {
		private final BufferedReader in;
		private String line = "";
		private int pos;
		private int lineNo;

		public Scanner(String Arquive) throws Exception {
			in = new BufferedReader(new FileReader(Arquive));
			nextLine();
		}

		public void close() {
			try {
				in.close();
			} catch (IOException e) {
				throw new AssertionError("Failed to close with " + e);
			}
		}

		public boolean hasNext() throws IOException {
			return in.ready();
		}

		public String next() {
			if (pos != 0) {
				pos++;
			}
			StringBuilder sb = new StringBuilder();
			while (pos < line.length() && line.charAt(pos) > ' ')
				sb.append(line.charAt(pos++));
			return sb.toString();
		}

		public int nextInt() {
			int num, total = 0;
			boolean negativo = false;

			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}

			while (pos < line.length() && line.charAt(pos) > ' ') {
				num = line.charAt(pos++) - '0';
				total *= 10;
				total += num;
			}
			if (negativo)
				total *= -1;

			return total;
		}

		public boolean EOL() {
			return pos >= line.length();
		}

		public void nextLine() {
			try {
				line = in.readLine();
			} catch (IOException e) {
				throw new AssertionError("Failed to read line with " + e);
			}
			pos = 0;
			lineNo++;
		}

		public long nextLong() {
			long num, total = 0;
			boolean negativo = false;
			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}
			while (pos < line.length() && line.charAt(pos) > ' ') {
				num = line.charAt(pos++) - '0';
				total *= 10;
				total += num;
			}
			if (negativo)
				total *= -1;
			return total;
		}

		public double nextDouble() {
			double total = 0;
			boolean negativo = false;

			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}

			while (pos < line.length() && line.charAt(pos) > 47 && line.charAt(pos) < 58)
				total = total * 10 + line.charAt(pos++) - '0';

			if (line.charAt(pos) == '.') {
				pos++;

				double decimal = 1;

				while (pos < line.length() && line.charAt(pos) > 47 && line.charAt(pos) < 58) {
					decimal /= 10;
					total += (line.charAt(pos++) - '0') * decimal;
				}
			}

			if (negativo)
				total *= -1;

			return total;
		}
	}
}
