package Round_1A;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

/* *****************************************************************************************************************************
 * Judge: Google Code Jam
 * Round: Round_1A
 * Problem: A_Alphabet_Cake
 * URL: 
 * Description: 
 *******************************************************************************************************************************/
public class A_Alphabet_Cake {
	private static Scanner in;
	private static PrintWriter out;
	private static boolean printConsole;

	public static void main(String[] args) throws Exception {
		String inputSize = "A-small-attempt0";

		String pathInput = "IO_2017/inputs/" + inputSize + ".in";
		String pathOutput = "IO_2017/outputs/" + inputSize + ".out";

		printConsole = inputSize.equals("default") || false;

		in = new Scanner(pathInput);
		out = new PrintWriter(pathOutput);

		int t = nextInt(), r, c, total, empty, xR, xC, maxLeft, maxRight, maxTop, maxBottom;

		char[][] grid = new char[25][25];
		int letters[][] = new int[25][2];
		boolean addLine;

		for (int i = 1; i <= t; i++) {
			nextLine();
			printf("Case #%d:\n", i);

			r = nextInt();
			c = nextInt();

			total = empty = 0;

			for (int j = 0; j < r; j++) {
				nextLine();
				for (int x = 0; x < c; x++) {
					if (in.line.charAt(x) == '?')
						empty++;
					else {
						letters[total][0] = j;
						letters[total++][1] = x;
					}

					grid[j][x] = in.line.charAt(x);
				}
			}

			for (int j = 0; j < total && empty > 0; j++) {
				xR = maxTop = maxBottom = letters[j][0];
				xC = maxLeft = maxRight = letters[j][1];

				while (maxRight + 1 < c && grid[xR][maxRight + 1] == '?') {
					maxRight++;
					empty--;
					grid[xR][maxRight] = grid[xR][xC];
				}

				while (maxLeft - 1 >= 0 && grid[xR][maxLeft - 1] == '?') {
					maxLeft--;
					empty--;
					grid[xR][maxLeft] = grid[xR][xC];
				}

				addLine = true;

				while (maxTop - 1 >= 0) {

					for (int x = maxLeft; x <= maxRight; x++) {

						if (grid[maxTop - 1][x] != '?') {
							addLine = false;
							break;
						}
					}

					if (addLine) {
						maxTop--;

						for (int x = maxLeft; x <= maxRight; x++) {
							grid[maxTop][x] = grid[xR][xC];
							empty--;
						}
					} else
						break;
				}

				addLine = true;

				while (maxBottom + 1 < r) {

					for (int x = maxLeft; x <= maxRight; x++) {

						if (grid[maxBottom + 1][x] != '?') {
							addLine = false;
							break;
						}
					}

					if (addLine) {
						maxBottom++;

						for (int x = maxLeft; x <= maxRight; x++) {
							grid[maxBottom][x] = grid[xR][xC];
							empty--;
						}
					} else
						break;
				}
			}

			for (int j = 0; j < r; j++) {
				for (int x = 0; x < c; x++) {
					print(grid[j][x]);
				}
				println();
			}

		}

		out.close();
	}

	private static String getLine() {
		return in.line;
	}

	private static boolean EOL() {
		return in.EOL();
	}

	private static String next() {
		return in.next();
	}

	private static void nextLine() {
		in.nextLine();
	}

	private static int nextInt() {
		return in.nextInt();
	}

	private static long nextLong() {
		return in.nextLong();
	}

	private static double nextDouble() {
		return in.nextDouble();
	}

	private static void print(Object value) {
		if (printConsole)
			System.out.print(value);
		out.print(value);
	}

	private static void printf(String format, Object... params) {
		if (printConsole)
			System.out.printf(format, params);
		out.printf(format, params);
	}

	private static void println(Object value) {
		if (printConsole)
			System.out.println(value);
		out.println(value);
	}

	private static void println() {
		if (printConsole)
			System.out.println();
		out.println();
	}

	private static class Scanner {
		private final BufferedReader in;
		private String line = "";
		private int pos;
		private int lineNo;

		public Scanner(String Arquive) throws Exception {
			in = new BufferedReader(new FileReader(Arquive));
			nextLine();
		}

		public void close() {
			try {
				in.close();
			} catch (IOException e) {
				throw new AssertionError("Failed to close with " + e);
			}
		}

		public boolean hasNext() throws IOException {
			return in.ready();
		}

		public String next() {
			if (pos != 0) {
				pos++;
			}
			StringBuilder sb = new StringBuilder();
			while (pos < line.length() && line.charAt(pos) > ' ')
				sb.append(line.charAt(pos++));
			return sb.toString();
		}

		public int nextInt() {
			int num, total = 0;
			boolean negativo = false;

			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}

			while (pos < line.length() && line.charAt(pos) > ' ') {
				num = line.charAt(pos++) - '0';
				total *= 10;
				total += num;
			}
			if (negativo)
				total *= -1;

			return total;
		}

		public boolean EOL() {
			return pos >= line.length();
		}

		public void nextLine() {
			try {
				line = in.readLine();
			} catch (IOException e) {
				throw new AssertionError("Failed to read line with " + e);
			}
			pos = 0;
			lineNo++;
		}

		public long nextLong() {
			long num, total = 0;
			boolean negativo = false;
			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}
			while (pos < line.length() && line.charAt(pos) > ' ') {
				num = line.charAt(pos++) - '0';
				total *= 10;
				total += num;
			}
			if (negativo)
				total *= -1;
			return total;
		}

		public double nextDouble() {
			double total = 0;
			boolean negativo = false;

			if (pos != 0) {
				pos++;
			}
			if (pos < line.length() && line.charAt(pos) == '-') {
				negativo = true;
				pos++;
			}

			while (pos < line.length() && line.charAt(pos) > 47 && line.charAt(pos) < 58)
				total = total * 10 + line.charAt(pos++) - '0';

			if (line.charAt(pos) == '.') {
				pos++;

				double decimal = 1;

				while (pos < line.length() && line.charAt(pos) > 47 && line.charAt(pos) < 58) {
					decimal /= 10;
					total += (line.charAt(pos++) - '0') * decimal;
				}
			}

			if (negativo)
				total *= -1;

			return total;
		}
	}
}
