package com.google.codejam2016;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

public class JamCoin {

	public static void main(String[] args) {

		BufferedReader br = null;
		BufferedWriter bw = null;
		try {
			br = new BufferedReader(new FileReader("/Users/chsankar/chandra/codejam/qualification/C-small-attempt0.in"));
			bw = new BufferedWriter(new FileWriter("/Users/chsankar/chandra/codejam/qualification/C-small-attempt0.out"));
			int T = Integer.parseInt(br.readLine().trim());
			for (int i = 0; i < T; i++) {
				String strA[] = br.readLine().trim().split(" ");
				int N = Integer.parseInt(strA[0]);
				int J = Integer.parseInt(strA[1]);
				bw.write("Case #"+(i+1)+":");
				bw.newLine();
				Map<Long, List<Long>> map = getNonPrimes(N, J);
				for(Long key : map.keySet()) {
					List<Long> list = map.get(key);
					String str = key.toString();
					for(Long value : list) {
						str = str.concat(" ").concat(value.toString());
					}
					bw.write(str);
					bw.newLine();
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				br.close();
				bw.close();
			} catch (IOException e) {
				e.printStackTrace();
			}
		}
	}
	
	private static Map<Long, List<Long>> getNonPrimes(int N, int J) {
		long number = (long)Math.pow(10, (N-1)) + 1;
		Map<Long, List<Long>> nonPrimes = new TreeMap<Long, List<Long>>(); 
		while (nonPrimes.size() != J) {
			boolean nonPrime = true;
			List<Long> list = new ArrayList<Long>();
			for(int i=2; i<=10; i++) {
				long baseValue = convert(number, i);
				long div = getDiv(baseValue);
				if(div == -1) {
					nonPrime = false;
					break;
				}
				list.add(div);
			}
			if(nonPrime) {
				nonPrimes.put(number, list);
			}
			number = nextNum(number);
		}
		return nonPrimes;
	}
	
	private static long convert(long N, int base) {
		long quotient = N;
		long baseValue = 0;
		int count = 0;
		while(quotient != 0) {
			long digit = quotient % 10;
			baseValue = baseValue + (digit * (long)Math.pow(base, count));
			quotient = quotient / 10;
			count++;
		}
		return baseValue;
	}
	
	private static long getDiv(long number) {
		long root = (long) Math.sqrt(number);
		for(long i=2; i<=root; i++) {
			if(number % i == 0)	{
				return i;
			}
		}
		return -1;
	}
	
	private static long nextNum(long N) {
		String binary = Long.toString(N);
		String two = "10";
		long sum = Long.parseLong(binary, 2) + Long.parseLong(two, 2);
		String binaryStr = Long.toBinaryString(sum);
		return Long.parseLong(binaryStr);
	}
}
