/**
 * @author chang
 * created on 11/04/15
 */

import java.util.*;
import java.io.*;

public class Main {
    public static void main(String[] args) throws IOException {
        new OvationSolver();
    }
}

class OvationSolver {

    BufferedReader br;
    PrintWriter out;
    StringTokenizer st;
    boolean eof;

    void solve(int ts) throws IOException {
        int n = nextInt();
        String shy = nextToken();

        int ans = 0;
        int clap = shy.charAt(0)-48;

        for(int i = 1; i <= n; ++i){
            int freq = shy.charAt(i)-48;
            if (clap < i){
                ans += i-clap;
                clap = i;
            }
            clap += freq;
        }
        out.println("Case #"+ts+": "+ans);
    }

    OvationSolver() throws IOException {
        br = new BufferedReader(new InputStreamReader(System.in));
        out = new PrintWriter(System.out);
        Thread t = new Thread(null, () -> {
            try {
                int ts = 1;
                ts = nextInt();
                for(int i = 1; i <= ts; ++i){
                    solve(i);
                }
            } catch (Exception e) {
                // TODO Auto-generated catch block
                e.printStackTrace();
            }
        }, "a", 1 << 24);
        t.start();
        try {
            t.join();
        } catch (InterruptedException e) {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        out.close();
    }

    String nextToken() {
        while (st == null || !st.hasMoreTokens()) {
            try {
                st = new StringTokenizer(br.readLine());
            } catch (Exception e) {
                eof = true;
                return null;
            }
        }
        return st.nextToken();
    }

    String nextString() {
        try {
            return br.readLine();
        } catch (IOException e) {
            eof = true;
            return null;
        }
    }

    int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    long nextLong() throws IOException {
        return Long.parseLong(nextToken());
    }

    double nextDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }
}