import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class FairAndSquare {

	public static void main(String...args) throws IOException {
		setup();
		
		Scanner in = new Scanner(new File("C-small-attempt0.in"));
//		PrintStream out = System.out;
		PrintStream out = new PrintStream(new File("C-small-attempt0.out"));
		
		int t = in.nextInt();
		for(int i=0; i<t; i++) {
			out.append("Case #").append(String.valueOf(i+1)).append(": ").append(evaluate(in)).append('\n');
		}
		
		out.close();
	}

	static String squareInPalidrome(String v) {
		int len = v.length();
		char[] cs = v.toCharArray();
		for(int i=0; i<len; i++) cs[i] -= '0';
		StringBuffer buf = new StringBuffer();
		int p[][] = new int[len][len];
		for(int i=0; i<len; i++) {
			for(int j=0; j<len; j++) {
				p[i][j] = cs[i] * cs[j];
			}
		}
		for(int n=0; n<len; n++) {
			int sum = 0;
			for(int m=0; m<=n; m++) {
				sum += p[n-m][m];
			}
			if(sum>9) return null;
			buf.append(sum);
		}
		StringBuffer res = new StringBuffer();
		res.append(buf);
		buf.delete(buf.length()-1, buf.length());
		res.append(buf.reverse());
		return res.toString();
	}
	
	static boolean isPalindrome(String v) {
		char[] cs = v.toCharArray();
		int len = cs.length;
		for(int i=0; i<len/2; i++) {
			if(cs[i]!=cs[len-i-1]) return false;
		}
		return true;
	}
	
	static class FNQ implements Comparable<FNQ> {
		String v;
		int len;
		
		FNQ(String v) {
			this.v = v;
			len = v.length();
		}

		@Override
		public int compareTo(FNQ o) {
			if(len>o.len) return 1;
			if(len<o.len) return -1;
			return v.compareTo(o.v);
		}
		
		boolean gte(FNQ o) {
			return compareTo(o)>=0;
		}
		
		boolean lte(FNQ o) {
			return compareTo(o)<=0;
		}

		@Override
		public boolean equals(Object o) {
			return v.equals(((FNQ) o).v);
		}

		@Override
		public String toString() {
			return v;
		}
		
	}
	
	private static void setup() {
		for(long i=1; i<200010002; i++) {
			if(isPalindrome(String.valueOf(i))) {
				String m = String.valueOf(i * i);
				if(isPalindrome(m)) {
					FNQ f = new FNQ(m);
					fnq.add(f);
					System.out.println(i + ": " + m);
				}
			}
		}
		
//		for(int i=3; i<=10; i++) {
//			char data[] = new char[i];
//			data[0] = '1';
//			for(int j=1; j<i; j++) data[j] = '0';
//			boolean run = true;
//			List<FNQ> eList = new ArrayList<FNQ>();
//			while(run) {
//				String s = String.valueOf(data);
//				StringBuilder ebuf = new StringBuilder(s);
//				StringBuilder obuf = new StringBuilder(s);
//				obuf.delete(obuf.length()-1, obuf.length());
//				obuf.reverse().insert(0, s);
//				ebuf.reverse().insert(0, s);
//				String op = squareInPalidrome(obuf.toString());
//				String ep = squareInPalidrome(ebuf.toString());
//				if(op!=null) {
//					fnq.add(new FNQ(op));
////					System.out.println(i + "} " + obuf.toString() + ": " + op);
//				}
//				if(ep!=null) {
//					eList.add(new FNQ(ep));
//					System.out.println(i + "] " + ebuf.toString() + ": " + ep);
//				}
//
//				boolean c = true;
//				if(data[i-1]=='2') {
//					data[i-1]='0';
//					c = true;
//				} else {
//					data[i-1]++;
//					c = false;
//				}
//				
//				if(c) {
//					int j, jc=0;
//					for(j=0; j<i-1; j++) {
//						if(data[j]=='1') {
//							if(++jc>=4) break;
//						}
//					}
//					for(; j>=0; j--) {
//						if(c) {
//							if(data[j]=='1') {
//								data[j]='0';
//								c = true;
//							} else {
//								data[j] = '1';
//								c = false;
//							}
//						}
//					}
//				}
//				
//				if(c) break;
//				if(data[0]=='2' && data[i-2]!='0') break;
//			}
//			
//			fnq.addAll(eList);
//		}
	}
	
	static List<FNQ> fnq = new ArrayList<FNQ>();

	private static CharSequence evaluate(Scanner in) {
		FNQ min = new FNQ(in.next());
		FNQ max = new FNQ(in.next());
		
		int count = 0;
		for(FNQ f: fnq) {
			if(count==0) {
				if(f.gte(min) && f.lte(max)) {
					count++;
				}
			} else {
				if(f.lte(max)) {
					count++;
				}
				else break;
			}
		}
		
		return String.valueOf(count);
	}
}
