

import java.io.File;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class Treasure {

	public static void main(String...args) throws Exception {
//		Scanner in = new Scanner("3 1 4 1 1 0 1 2 1 3 2 0 3 1 2 3 3 1 1 1 1 0 1 0 1 0 1 1 2 1 1 1");
		Scanner in = new Scanner(new File("D-small-attempt4.in"));
//		Scanner in = new Scanner(new File("sample.in"));
//		PrintStream out = System.out;
		PrintStream out = new PrintStream(new File("D-small-attempt4.out"));
		
		int t = in.nextInt();
		for(int i=0; i<t; i++) {
			out.append("Case #").append(String.valueOf(i+1)).append(": ").append(evaluate(in)).append('\n');
		}
		
		out.close();
	}
	
	static final int KEYCHAIN_SIZE = 512;
	
	static class Chest {
		int id;
		int toOpen;
		int[] keysInside = new int[KEYCHAIN_SIZE];
		int nKeysInside = 0;
		boolean opened = false;
		
		Chest(int id, Scanner in) {
			this.id = id;
			toOpen = in.nextInt();
			nKeysInside= in.nextInt();
			for(int i=0; i<nKeysInside; i++)
				keysInside[in.nextInt()]++;
		}

		@Override
		public String toString() {
			return id + "(" + toOpen + ")";
		}
		
	}
	
	static int keychain[];
	static int keyRequires[];
	static List<Chest> chests;
	static List<Chest> seq;
	
	static boolean find() {
		System.out.print("keys : ");
		for(int i=0; i<KEYCHAIN_SIZE; i++) {
			if(keychain[i]>0) System.out.print(" " + i + "(" + keychain[i] + ")");
		}
		System.out.print(", chests: ");
		for(Chest chest: chests) {
			if(!chest.opened)
				System.out.println(chest.id + "(" + chest.toOpen + ")");
		}
		System.out.println();
		boolean closedChest = false;
		for(Chest chest: chests) {
			if(chest.opened) continue;
			closedChest = true;
			if(keychain[chest.toOpen]==0) continue;
//			if(keychain[chest.toOpen]==1 && chest.nKeysInside==0 && keyRequires[chest.toOpen]>1) continue;
			if(keychain[chest.toOpen]<keyRequires[chest.toOpen] && chest.nKeysInside==0) continue;
			
			// open
			seq.add(chest);
			chest.opened = true;
			keychain[chest.toOpen]--;
			keyRequires[chest.toOpen]--;
			for(int i=0; i<KEYCHAIN_SIZE; i++) keychain[i]+=chest.keysInside[i];
			
			System.out.println("open chest " + chest.id + " with key " + chest.toOpen);
			
			if(find()) return true;
			
			// close
			for(int i=0; i<KEYCHAIN_SIZE; i++) keychain[i]-=chest.keysInside[i];
			keyRequires[chest.toOpen]++;
			keychain[chest.toOpen]++;
			chest.opened = false;
			seq.remove(chest);
		}
		
		return !closedChest;
	}
	
	static String evaluate(Scanner in) {
		int nKeysIGot = in.nextInt();
		int nChests = in.nextInt();
		
		keychain = new int[KEYCHAIN_SIZE];
		for(int i=0; i<KEYCHAIN_SIZE; i++) keychain[i] = 0;
		for(int i=0; i<nKeysIGot; i++) {
			keychain[in.nextInt()]++;
		}
		
		int wholeKeys[] = new int[KEYCHAIN_SIZE];
		for(int i=0; i<KEYCHAIN_SIZE; i++) wholeKeys[i] = keychain[i];
		
		keyRequires = new int[KEYCHAIN_SIZE];
		for(int i=0; i<KEYCHAIN_SIZE; i++) keyRequires[i] = 0;
		chests = new ArrayList<Chest>();
		for(int i=1; i<=nChests; i++) {
			Chest chest = new Chest(i, in);
			chests.add(chest);
			for(int j=0; j<KEYCHAIN_SIZE; j++) {
				wholeKeys[j]+=chest.keysInside[j];
			}
			keyRequires[chest.toOpen]++;
		}
		
		for(int i=0; i<KEYCHAIN_SIZE; i++) {
			if(keyRequires[i]>wholeKeys[i])
				return "IMPOSSIBLE";
		}
		
		seq = new ArrayList<Chest>();
		
		if(find()) {
			StringBuilder buf = null;
			for(Chest chest: seq) {
				if(buf==null) buf = new StringBuilder();
				else buf.append(" ");
				buf.append(chest.id);
			}
			if(buf!=null) return buf.toString();
		}
		
		return "IMPOSSIBLE";
	}
}
