/**
 * Author: Chan Jun Wei
 */

import java.io.FileReader;
import java.io.File;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.io.IOException;
import java.util.*;

public class DeceitfulWar
{
  static String fileName = "DeceitfulWar";
  static final String OUTPUT = "Case #%d: %d %d";
  static final int MAX_SIZE = 200;
  static final double ERROR_DIFFERENCE = 0.00001;
  public static void main( String [ ] args )
  {
    File file=new File(fileName + ".in");
    try
    {
      // Opening of files for input and output
      Scanner sc=new Scanner(file);
      PrintWriter writer = new PrintWriter(fileName + ".out");
      
      int T;
     
     
      T = sc.nextInt();
      
      double[] naomi = new double[MAX_SIZE];
      double[] ken = new double[MAX_SIZE];
      
      for (int cases = 1; cases <= T; cases++){
        int num = sc.nextInt();
        
        int winNormal = 0;
        int winDeceit = 0;
        
        for (int i = 0; i < num; i++){
          naomi[i] = sc.nextDouble();
        }
        
        for (int i = 0; i < num; i++){
          ken[i] = sc.nextDouble();
        }
        
        Arrays.sort(naomi, 0, num);
        Arrays.sort(ken, 0, num);
        
        //normal case
        int kenEnd = num - 1;
        for (int i = num - 1; i >=0; i--){
          //no equal case
          if (naomi[i] - ken[kenEnd] > ERROR_DIFFERENCE){
            winNormal++;
          } else if (naomi[i] - ken[kenEnd] < ERROR_DIFFERENCE){
            kenEnd--;
          } else {
            System.exit(-1);
          }
        }
        
        //deceit case
        int naomiEnd = num - 1;
        int naomiStart = 0;
        for (int i = num - 1; i >=0; i--){
          //no equal case
          if (naomi[naomiEnd] - ken[i] > ERROR_DIFFERENCE){
            winDeceit++;
            naomiEnd--;
          } else if (naomi[naomiEnd] - ken[i] < ERROR_DIFFERENCE){
            naomiStart++;
          } else {
            System.exit(-1);
          }
        }
        
        writer.println(String.format(OUTPUT, cases, winDeceit, winNormal));
      }
      
      sc.close();
      writer.close();
    }
    catch( IOException e )  
    { e.printStackTrace(System.out); }
    finally  
    {// Close the files if they have been opened.
      //file.delete();
    }
  }
}