import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.StringTokenizer;

public class CoreTraining {
	private static InputReader in;
	  private static PrintWriter out;
	  public static boolean SUBMIT = true;
	  public static final String NAME = "A-large";
	  
	  static class InputReader {
		    public BufferedReader reader;
		    public StringTokenizer tokenizer;

		    public InputReader(InputStream stream) {
		      reader = new BufferedReader(new InputStreamReader(stream), 32768);
		      tokenizer = null;
		    }

		    public String next() {
		      while (tokenizer == null || !tokenizer.hasMoreTokens()) {
		        try {
		          tokenizer = new StringTokenizer(reader.readLine());
		        } catch (IOException e) {
		          throw new RuntimeException(e);
		        }
		      }
		      return tokenizer.nextToken();
		    }

		    public int nextInt() {
		      return Integer.parseInt(next());
		    }
		  }
	  
	  private static void main2() throws IOException {
	    String sN = in.next();
	    String sK = in.next();
	    int n = Integer.parseInt(sN);
	    int K = Integer.parseInt(sK) + 1;

		Pancake[] p = new Pancake[n];
		double[][][] dp = new double[K][n][2];
		
		for (int i = 0; i < n; ++i) {
			int tempR = Integer.parseInt(in.next());
			int tempH = Integer.parseInt(in.next());
			p[i] = new Pancake((double) tempR, (double) tempH);
		}
		
		Arrays.sort(p);
		
		for (int k = 0; k < K; ++k) { // k
			for (int i = n - 1; i >= 0; --i) { // i
				for (int s = 1; s >= 0; --s) {
					if (k == 0) {
						dp[k][i][s] = 0;
					} else if (n - i == k) {
						if (i == n - 1) {
							dp[k][i][s] = 2 * Math.PI * p[i].r * p[i].h;
							if (s == 0) dp[k][i][s] += Math.PI * p[i].r * p[i].r;
						} else if (s == 1) {
							dp[k][i][s] = dp[k - 1][i + 1][1] + 2 * Math.PI * p[i].r * p[i].h;
						} else {
							dp[k][i][s] = dp[k - 1][i + 1][1] + 2 * Math.PI * p[i].r * p[i].h + Math.PI * p[i].r * p[i].r;
						}
					} else {
						if (i == n - 1) {
							dp[k][i][s] = -1; // don't care
						} else if (s == 1) {
							dp[k][i][s] = Math.max(
								dp[k - 1][i + 1][1] + 2 * Math.PI * p[i].r * p[i].h,
								dp[k][i + 1][1]
							);
						} else {
							dp[k][i][s] = Math.max(
								dp[k - 1][i + 1][1] + 2 * Math.PI * p[i].r * p[i].h + Math.PI * p[i].r * p[i].r,
								dp[k][i + 1][0]
							);
						}
					}
					// System.out.printf("dp[%d][%d][%d] = %f\n", k, i, s, dp[k][i][s]);
				} // end s
			} // end i
		} // end k
		
		/* for (int k = 0; k < K; ++k) { // k
			for (int i = n - 1; i >= 0; --i) { // i
				System.out.print(dp[k][i][1] + " ");
			}
			System.out.println();
		} */
		
		out.println(dp[K - 1][0][0]);
		System.out.println(dp[K - 1][0][0]);
	  }
	  


	  public static void main(String[] args) throws IOException {
	    if (SUBMIT) {
	      in = new InputReader(new FileInputStream(new File(NAME + ".in")));
	      out = new PrintWriter(new BufferedWriter(new FileWriter(NAME + ".out")));
	    } else {
	      in = new InputReader(System.in);
	      out = new PrintWriter(System.out, true);
	    }

	    int numCases = in.nextInt();
	    for (int test = 1; test <= numCases; test++) {
	      out.print("Case #" + test + ": ");
	      main2();
	    }

	    out.close();
	    System.exit(0);
	  }
		private static class Pancake implements Comparable<Pancake> {
			public double r, h;
			public Pancake (double r, double h) {
				this.r = r;
				this.h = h;
			}
			public int compareTo(Pancake p) {
				// return ((this.r - p.r) > 0) ? 1 : -1;
				return ((this.r - p.r) > 0) ? -1 : 1;
			}
		}
}
