package codejam2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;
import java.util.PriorityQueue;
import java.util.StringTokenizer;


public class BathroomStalls {
	  private static InputReader in;
	  private static PrintWriter out;
	  public static boolean SUBMIT = true;
	  public static final String NAME = "C-small";
	  
	  public static class Node{
		  long val;
		  long c;
		  public Node(long val, long c){
			  this.val = val;
			  this.c = c;
		  }
	  }
	  
	  static class InputReader {
		    public BufferedReader reader;
		    public StringTokenizer tokenizer;

		    public InputReader(InputStream stream) {
		      reader = new BufferedReader(new InputStreamReader(stream), 32768);
		      tokenizer = null;
		    }

		    public String next() {
		      while (tokenizer == null || !tokenizer.hasMoreTokens()) {
		        try {
		          tokenizer = new StringTokenizer(reader.readLine());
		        } catch (IOException e) {
		          throw new RuntimeException(e);
		        }
		      }
		      return tokenizer.nextToken();
		    }

		    public int nextInt() {
		      return Integer.parseInt(next());
		    }
		  }
	  
	  private static void main2() throws IOException {
	    long n = Long.parseLong(in.next());
	    long k = Long.parseLong(in.next());
	    
	    //from descending order, find largest space to fill
	    PriorityQueue<Node> queue= new PriorityQueue<Node>(new Comparator<Node>(){
            @Override
            public int compare(Node o1,Node o2){
                if (o1.val<o2.val)
                    return 1;
                else if (o1.val==o2.val)
                    return 0;
                else 
                    return -1;
            }
        });
	    
	    Map<Long, Node> map = new HashMap<Long,Node>();
	    Node initialNode = new Node(n,1);
	    map.put(n, initialNode);
	    queue.add(initialNode);
	    long[] ret = new long[2];
	    
	    for(int i = 0; i < k; i++){
	    	
	    	Node max = queue.poll();
	    	long val = max.val;
	    	long c = max.c;
	    	if((val-1)%2==0){
	    		long next = (val-1)/2;
	    		putNext(map, next, queue);
	    		putNext(map, next, queue);
	    		ret[0] = next;
	    		ret[1] = next;
	    	}else{
	    		long next0 = (val-1)/2;
	    		long next1 = next0 + 1;
	    		putNext(map, next0, queue);
	    		putNext(map, next1, queue);
	    		ret[0] = next1;
	    		ret[1] = next0;
	    	}
	    	
	    	if(c!=1){
	    		max.c =  c - 1;
	    		queue.add(max);
	    	}else{
	    		map.remove(val);
	    	}
	    }
	    out.println(ret[0] + " " + ret[1]);
	  }
	  
	  public static void putNext(Map<Long, Node> map, long next, PriorityQueue<Node> queue){
  		if(map.containsKey(next)){
			Node existN = map.get(next);
			existN.c = existN.c + 1;
			map.put(next, existN);
		}else{
			Node newN = new Node(next, 1);
			map.put(next, newN);
			queue.add(newN);
		}
	  }

	  public static void main(String[] args) throws IOException {
	    if (SUBMIT) {
	      in = new InputReader(new FileInputStream(new File(NAME + ".in")));
	      out = new PrintWriter(new BufferedWriter(new FileWriter(NAME + ".out")));
	    } else {
	      in = new InputReader(System.in);
	      out = new PrintWriter(System.out, true);
	    }

	    int numCases = in.nextInt();
	    for (int test = 1; test <= numCases; test++) {
	      out.print("Case #" + test + ": ");
	      main2();
	    }

	    out.close();
	    System.exit(0);
	  }
}
