import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Main {

	int fln = -1;
	
	int M, N;
	
	int[][] g;
	
	void read(String filename) throws NumberFormatException, IOException {
		LineNumberReader read = new LineNumberReader(new FileReader(filename));

		int count = -1;
		int count2 = 0;
		String line = null;
		boolean isFirst = true;
		while ((line = read.readLine()) != null) {
			line = line.trim();
			count++;

			if (count == 0) {
				fln = Integer.parseInt(line);
				continue;
			}

			
			if(isFirst) {
				String[] sp = line.split("\\s");
				M = Integer.parseInt(sp[0]);
				N = Integer.parseInt(sp[1]);
				g = new int[M][N];
				
				isFirst = false;
				continue;
			}
			
			for (int i = 0; i < line.length(); i++) {
				int b = Integer.parseInt("" + line.charAt(i), 16);
				for (int j = 0; j < 4; j++) {
					g[count2][4 * i + j] = ((b & (1 << (3 - j))) > 0) ? 1 : 0;
				}
			}
			
			count2++;
			if(count2 == M) {
				isFirst = true;
				count2 = 0;
				calc();
			}

		}

	}

	int caseNum = 1;
	private void calc() {
		Map<Integer, Integer> m = new HashMap<Integer, Integer>();
		while(true){
			int max = getMax();
			if(max <= 1) {
				int count = 0;
				for (int i = 0; i < M; i++) {
					for (int j = 0; j < N; j++) {
						if(g[i][j] != -1) count++;
					}
				}
				if(count != 0) {
					m.put(1, count);
				}
				break;
			}
			if(!m.containsKey(max)) {
				m.put(max, 0);
			}
			Integer i = m.get(max);
			m.put(max, i + 1);
		}
		
		System.out.println("Case #" + (caseNum++) + ": " + m.keySet().size());
		List<Integer> list = new ArrayList<Integer>();
		list.addAll(m.keySet());
		Collections.sort(list);
		Collections.reverse(list);
		for (Integer i : list) {
			System.out.println(i + " " + m.get(i));
		}
	}
	
	private int getMax(){
		int mx = 0, my = 0;
		int max = 0;
		
		for (int i = 0; i < M; i++) {
			for (int j = 0; j < N; j++) {
				int num = check(g, i, j);
				if(num > max) {
					mx = i; my = j;
					max = num;
				}
			}
		}
		
		if(max > 1){
			fill(g, mx, my, max);
		}
		
		return max;	
	}
	
	private void fill(int[][] g, int x, int y, int n) {
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < n; j++) {
				g[x + i][y + j] = -1;
			}
		}
	}
	
	private int check(int[][] g, int x, int y){
		int i = 0;
		int first = g[x][y];
		if(first == -1) {
			return 0;
		}
		
		OUT:
		for (i = 1; i < g.length; i++) {

			for (int j = 0; j < i; j++) {
//				int jf = (first + j) % 2;
				for (int k = 0; k < i; k++) {
					int kv = (first + k + j) % 2;
					int nx = x + j, ny = y + k;
					
					if(nx >= M || ny >= N) break OUT;
					if(kv != g[nx][ny]) break OUT;
				}
				
			}
			
//			for (int j = 0; j < i; j++) {
////				int jf = (first + j) % 2;
//				for (int k =  i - 1; k < i; k++) {
//					int kv = (first + k + j) % 2;
//					int nx = x + j, ny = y + k;
//					
//					if(nx >= M || ny >= N) break OUT;
//					if(kv != g[nx][ny]) break OUT;
//				}
//				
//			}
		}
		
		return i - 1;
	}

	//-----------------------------
	
	public static void main(String[] args) throws IOException {
		Main main = new Main();
		main.read("cs.in");
	}

}
