import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

public class Snapper {

	PrintStream writer;

	int firstLineNumber = -1;

	public Snapper() throws IOException {
		// writer = System.out;
		writer = new PrintStream("out-large.txt");
	}

	@Override
	protected void finalize() throws Throwable {
		if (writer != null) {
			writer.close();
		}
	}

	List<int[]> cases = new LinkedList<int[]>();

	void read(String filename) throws NumberFormatException, IOException {
		LineNumberReader read = new LineNumberReader(new FileReader(filename));

		String line = null;
		int count = -1;
		while ((line = read.readLine()) != null) {
			line = line.trim();
			count++;

			if (count == 0) {
				firstLineNumber = Integer.parseInt(line);
				continue;
			}

			String[] split = line.split("\\s");
			int[] inp = new int[split.length];
			for (int i = 0; i < split.length; i++) {
				inp[i] = Integer.parseInt(split[i]);
				// System.out.println(inp[i]);
			}

			if (!Kmap.containsKey(inp[1])) {
				Kmap.put(inp[1], new HashMap<Integer, Boolean>());
			}

			Map<Integer, Boolean> map = Kmap.get(inp[1]);
			map.put(inp[0], false);

			cases.add(inp);
		}

		int prev = -1;
		for (Integer i : Kmap.keySet()) {
			if (i == prev)
				continue;

			prev = i;
			Ks.add(i);
		}

		Collections.sort(Ks);

		solve();

		writeDown();

	}

	private void writeDown() {
		for (int i = 0; i < cases.size(); i++) {
			int[] inp = cases.get(i);
			Boolean b = Kmap.get(inp[1]).get(inp[0]);
			writer.print("Case #" + (i + 1) + ": ");
			if (b) {
				writer.println("ON");
			} else {
				writer.println("OFF");
			}
		}
	}

	void solve() {
		OUT: for (Integer k : Ks) {
			while (true) {
				if (snapCount > k) {
					continue OUT;
				}

				if (snapCount == k) {
					// measure
					Map<Integer, Boolean> map = Kmap.get(k);
					for (Integer i : map.keySet()) {
						map.put(i, check(i));
					}
				}

				snap();
			}
		}
	}

	void snap() {
		snapCount++;

		for (int i = 0; i < n.length; i++) {
			if (n[i] == 0) {
				n[i] = 1;
				break;
			}

			n[i] = 0;
		}
	}

	boolean check(int ns) {
		for (int i = 0; i < ns; i++) {
			if (n[i] == 0) {
				return false;
			}
		}
		return true;
	}

	// -------------
	int[] n = new int[30];
	int snapCount = 0;
	List<Integer> Ks = new ArrayList<Integer>();
	Map<Integer, Map<Integer, Boolean>> Kmap = new HashMap<Integer, Map<Integer, Boolean>>();

	// Map<Integer, Boolean> ans = new HashMap<Integer, Boolean>();

	public static void main(String[] args) throws IOException {
		Snapper main = new Snapper();
		main.read("A-large.in");
	}

}
