import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.util.LinkedList;
import java.util.Queue;

public class Roller {

	PrintStream writer;

	int firstLineNumber = -1;

	public Roller() throws IOException {
		// writer = System.out;
		writer = new PrintStream("outr0.txt");
	}

	@Override
	protected void finalize() throws Throwable {
		if (writer != null) {
			writer.close();
		}
	}

	int R = 0;
	int k = 0;

	Queue<Integer> q = new LinkedList<Integer>();

	// int N = 0;

	void read(String filename) throws NumberFormatException, IOException {
		LineNumberReader read = new LineNumberReader(new FileReader(filename));

		String line = null;
		int count = -1;
		int testline = 0;
		int testcount = 0;
		while ((line = read.readLine()) != null) {
			line = line.trim();
			count++;

			if (count == 0) {
				firstLineNumber = Integer.parseInt(line);
				continue;
			}

			String[] split = line.split("\\s");
			int[] inp = new int[split.length];
			for (int i = 0; i < split.length; i++) {
				inp[i] = Integer.parseInt(split[i]);
			}

			if (testline == 0) {
				R = inp[0];
				k = inp[1];
				// N = inp[2];

				testline++;
				testcount++;
			} else {
				testline = 0;
				int[] g = inp;
				q.clear();

				for (int i = 0; i < g.length; i++) {
					q.add(g[i]);
				}

				long ans = calcEuro();
				System.out.println("Case #" + (testcount) + ": " + ans);
				writer.println("Case #" + (testcount) + ": " + ans);
			}
		}

	}

	private long calcEuro() {
		long total = 0;

		for (int i = 0; i < R; i++) {
			LinkedList<Integer> queueForNext = new LinkedList<Integer>();
			int sum = 0;

			OUT: while (true) {
				Integer g0 = q.peek();
				if (g0 != null && sum + g0 <= k) {
					sum += g0;
					q.poll();
					queueForNext.add(g0);
				} else {
					break OUT;
				}
			}

			// run
			total += sum;

			q.addAll(queueForNext);
		}

		return total;
	}

	public static void main(String[] args) throws IOException {
		Roller main = new Roller();
		main.read("C-small-attempt0.in");

		// System.out.println(Integer.MAX_VALUE);
	}

}
