import java.io.FileReader;
import java.io.IOException;
import java.io.LineNumberReader;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.List;

public class JamCode {

	PrintStream writer;

	int firstLineNumber = -1;

	public JamCode() throws IOException {
		// writer = System.out;
		writer = new PrintStream("out22.txt");
	}

	@Override
	protected void finalize() throws Throwable {
		if (writer != null) {
			writer.close();
		}
	}

	void read(String filename) throws NumberFormatException, IOException {
		LineNumberReader read = new LineNumberReader(new FileReader(filename));

		String line = null;
		int count = -1;
		while ((line = read.readLine()) != null) {
			line = line.trim();
			count++;

			if (count == 0) {
				firstLineNumber = Integer.parseInt(line);
				continue;
			}

			String[] split = line.split("\\s");
			BigInteger[] inp = new BigInteger[split.length - 1];
			for (int i = 1; i < split.length; i++) {
				inp[i - 1] = new BigInteger(split[i]);
			}

			List<BigInteger> asList = Arrays.asList(inp);
			Collections.sort(asList);
			// Collections.reverse(asList);
			inp = (BigInteger[]) asList.toArray(new BigInteger[asList.size()]);

			BigInteger[] sa = new BigInteger[inp.length - 1];
			for (int i = 0; i < inp.length - 1; i++) {
				sa[i] = inp[i].subtract(inp[i + 1]).abs();
			}

			Arrays.sort(sa);

			List<BigInteger> newsa = new ArrayList<BigInteger>();
			BigInteger prev = BigInteger.valueOf(-1L);
			for (int i = 0; i < sa.length; i++) {
				BigInteger b = sa[i];
				if (b.equals(prev) || b.equals(BigInteger.ZERO)) {
					continue;
				}
				prev = b;
				newsa.add(b);
			}

			sa = newsa.toArray(new BigInteger[newsa.size()]);

			BigInteger fac = sa[0];
			OUT: for (int i = 0; i < sa.length; i++) {
				fac = ecd2(sa[i], fac);
				if (fac.equals(BigInteger.ONE)) {
					break OUT;
				}
			}

			if (fac.equals(BigInteger.ONE)) {
				writer.println("Case #" + (count) + ": " + 0);
				System.out.println("Case #" + (count) + ": " + 0);
				continue;
			}

			Arrays.sort(sa);
			BigInteger min = inp[0];
			while (min.compareTo(BigInteger.ZERO) > 0) {
				min = min.subtract(fac);
			}
			writer.println("Case #" + (count) + ": " + min.abs());
			System.out.println("Case #" + (count) + ": " + min.abs());
		}

	}

	public static BigInteger ecd2(BigInteger m, BigInteger n) {
		// n1 = .abs();
		// n2 = n2.abs();

		m = m.abs();
		n = n.abs();

		BigInteger temp;
		while (!m.mod(n).equals(BigInteger.ZERO)) {
			temp = n;
			n = m.mod(n);
			m = temp;
		}
		// while (n1.compareTo(n2) != 0) {
		// if (n1.equals(BigInteger.ZERO))
		// break;
		// if (n2.equals(BigInteger.ZERO))
		// break;
		//
		// if (n1.compareTo(n2) > 0) {
		// n1 = n1.subtract(n2);
		// } else {
		// n2 = n2.subtract(n1);
		// }
		// }

		return n;
	}

	public static void main(String[] args) throws IOException {
		JamCode main = new JamCode();
		main.read("B-small-attempt2.in");

		// System.out.println(ecd2(BigInteger.valueOf(100L), BigInteger
		// .valueOf(5L)));
	}

}
