import java.util.*;
public class Pancake{
  public static void main(String[] jingle){
    Scanner in = new Scanner(System.in);
    int n = Integer.parseInt(in.nextLine().trim());
    for(int i = 0; i < n; i++){
      String line = in.next();
      boolean[] p = toBoolArr(line);
      int k = Integer.parseInt(in.nextLine().trim());
      int out = removeTrivials(p, k);
      int out2 = minSteps(p, k);
      if(out2 == -1) System.out.println("Case #"+(i+1)+": IMPOSSIBLE");
      else System.out.println("Case #"+(i+1)+": "+(out+out2));
    }
  }
  public static int removeTrivials(boolean[] b, int k){
    int out = 0;
    for(int i = 0; i <= b.length-k; i++){
      boolean flag = true;
      for(int x = i; x < i+k; x++){
        if(b[x]){
          flag = false;
          break;
        }
      }
      if(flag){
        b = flip(b, k, i);
        i += k-1;
        out++;
      }
      else{
        return out;
      }
    }
    return out;
  }
  public static int minSteps(boolean[] b, int k){
    ArrayList<Integer> a = new ArrayList<>();
    for(int i = 0; i <= b.length-k; i++) a.add(i);
    for(int i = 0; i <= a.size(); i++){
      List<Set<Integer>> t = getSubsets(a, i);
      for(Set<Integer> x : t){
        boolean[] clone = clone(b);
        for(int f : x){
          clone = flip(clone, k, f);
        }
        if(isDone(clone)) return i;
      }
    }
    return -1;
  }
  private static void getSubsets(List<Integer> superSet, int k, int idx, Set<Integer> current,List<Set<Integer>> solution) {
    //successful stop clause
    if (current.size() == k) {
        solution.add(new HashSet<>(current));
        return;
    }
    //unseccessful stop clause
    if (idx == superSet.size()) return;
    Integer x = superSet.get(idx);
    current.add(x);
    //"guess" x is in the subset
    getSubsets(superSet, k, idx+1, current, solution);
    current.remove(x);
    //"guess" x is not in the subset
    getSubsets(superSet, k, idx+1, current, solution);
  }
  public static List<Set<Integer>> getSubsets(List<Integer> superSet, int k) {
    List<Set<Integer>> res = new ArrayList<>();
    getSubsets(superSet, k, 0, new HashSet<Integer>(), res);
    return res;
  }
  public static boolean[] toBoolArr(String line){
    boolean[] r = new boolean[line.length()];
    int at = 0;
    for(char c : line.toCharArray()){
      if(c == '+') r[at] = true;
      else r[at] = false;
      at++;
    }
    return r;
  }
  public static boolean isDone(boolean[] x){
    for(int i = 0; i < x.length; i++)
      if(!x[i]) return false;
    return true;
  }
  public static boolean[] clone(boolean[] x){
    boolean[] b = new boolean[x.length];
    for(int i = 0; i < x.length; i++) b[i] = x[i];
    return b;
  }
  public static boolean[] flip(boolean[] x, int k, int start){
    for(int i = start; i < start+k; i++){
      x[i] = !x[i];
    }
    return x;
  }
}
