import java.io.*;
import java.util.*;

public class GettingTheDigits {
    private static String[] words = {
        "ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX",
        "SEVEN", "EIGHT", "NINE"
    };
    private static boolean isEnd(int[] count) {
        for (int i = 0; i < count.length; i++) {
            if (count[i] != 0) return false;
        }
        return true;
    }
    private static boolean isValid(int[] count) {
        for (int i = 0; i < count.length; i++) {
            if (count[i] < 0) return false;
        }
        return true;
    }
    private static boolean findRes(StringBuilder res, int[] count, int c) {
        if (c > 9) return isEnd(count);

        while (c <= 9) {
            String word = words[c];
            for (int i = 0; i < word.length(); i++) {
                count[word.charAt(i) - 'A']--;
            }
            if (isEnd(count) || (isValid(count) && findRes(res, count, c))) {
                res.append(c);
                return true;
            } else {
                for (int i = 0; i < word.length(); i++) {
                    count[word.charAt(i) - 'A']++;
                }
                c++;
            }
        }
        return false;
    }
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int t = 0; t < T; t++) {
            String s = in.next();
            int[] count = new int[26];
            for (int i = 0; i < s.length(); i++) {
                count[s.charAt(i) - 'A']++;
            }
            StringBuilder res = new StringBuilder();
            findRes(res, count, 0);
            System.out.printf("Case #%d: %s\n", t + 1, res.reverse().toString());
        }
    }
}
