import java.io.*;
import java.util.*;

public class Solution {
    static private int N;
    static private int[] bbf;
    static private boolean[] visited;
    private static int countCycle(int cur) {
        int count = 1;
        int p = cur;
        while (bbf[p] != cur) {
            p = bbf[p];
            count++;
        }
        return count;
    }
    private static int countDest(int dest1, int dest2) {
        int res1 = 0;
        int res2 = 0;
        boolean[] vs = new boolean[N];
        for (int i = 0; i < N; i++) {
            int p = i;
            int count = 1;
            while (p != dest1 && p != dest2 && !vs[p]) {
                vs[p] = true;
                p = bbf[p];
                count++;
            }
            if (p == dest1) res1 = Math.max(res1, count);
            if (p == dest2) res2 = Math.max(res2, count);
        }
        return res1 + res2;
    }
    public static void main(String[] args) {
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int t = 0; t < T; t++) {
            N = in.nextInt();
            bbf = new int[N];
            for (int i = 0; i < N; i++) {
                bbf[i] = in.nextInt() - 1;
            }
            visited = new boolean[N];
            int ans = 0;
            for (int i = 0; i < N; i++) {
                Arrays.fill(visited, false);
                int cur = i;
                while (!visited[cur]) {
                    visited[cur] = true;
                    cur = bbf[cur];
                }
                ans = Math.max(ans, countCycle(cur));
            }
            int dans = 0;
            Arrays.fill(visited, false);
            for (int i = 0; i < N; i++) {
                if (visited[i]) continue;
                if (i == bbf[bbf[i]]) {
                    dans += countDest(i, bbf[i]);
                    visited[i] = visited[bbf[i]] = true;
                }
            }
            System.out.printf("Case #%d: %d\n", t + 1, Math.max(ans, dans));
        }
    }
}
