import java.io.File;
import java.util.Scanner;


public class ProbA {
	public static char[][] grid;
	public static int caseNum;
	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new File("A-large.in"));
		int numCases = Integer.parseInt(sc.nextLine());
		for(caseNum=1; caseNum<=numCases; caseNum++){
			grid = new char[4][4];
			for(int row=0; row<4; row++)
				grid[row] = sc.nextLine().trim().toCharArray();
			check(grid);
			if(!sc.hasNext())
				return;
			sc.nextLine();
		}
	}
	public static void check(char[][] grid){
		for(int row=0; row<4; row++)
			if(checkRow(row))
				if(winMsg(detWin(grid[row][0], grid[row][1])))
					return;
		for(int col=0; col<4; col++)
			if(checkCol(col))
				if(winMsg(detWin(grid[0][col], grid[1][col])))
					return;
		if(eq(grid[0][0], grid[1][1], grid[2][2], grid[3][3]))
			if(winMsg(detWin(grid[0][0], grid[1][1])))
				return;
		if(eq(grid[0][3], grid[1][2], grid[2][1], grid[3][0]))
			if(winMsg(detWin(grid[0][3], grid[1][2])))
				return;
		if(isFull())
			winMsg('d');
		else
			winMsg('n');
	}
	public static boolean winMsg(char res){
		res = Character.toLowerCase(res);
		System.out.printf("Case #%d: ", caseNum);
		if(res=='x')
			System.out.println("X won");
		else if(res=='o')
			System.out.println("O won");
		else if(res=='d')
			System.out.println("Draw");
		else if(res=='n')
			System.out.println("Game has not completed");
		else
			throw new Error("Unknown character "+res);
		return true;
	}
	public static boolean isFull(){
		for(int i=0; i<4; i++)
			for(int j=0; j<4; j++)
				if(grid[i][j]=='.')
					return false;
		return true;
	}
	public static boolean checkRow(int rowNum){
		return eq(grid[rowNum][0], grid[rowNum][1], grid[rowNum][2], grid[rowNum][3]);
	}
	public static boolean checkCol(int colNum){
		return eq(grid[0][colNum], grid[1][colNum], grid[2][colNum], grid[3][colNum]);
	}
	public static boolean eq(char a, char b, char c, char d){
		if(a=='.' || b=='.' || c=='.' || d=='.')
			return false;
		char nonT = detWin(a,b);
		a = repT(a, nonT);
		b = repT(b, nonT);
		c = repT(c, nonT);
		d = repT(d, nonT);
		return ((a==b)&&(a==c)&&(a==d));
	}
	public static char repT(char a, char nonT){
		if(a=='T')
			return nonT;
		return a;
	}
	public static char detWin(char a, char b){
		if(a=='T')
			return b;
		return a;
	}
}
