import java.io.*;
import java.util.*;

public class A {

	class Pair {
		int beg;
		int cost;
	}

	long mod = 1000002013;

	class Situation implements Comparable<Situation> {
		int type;
		int cord;
		int add;

		public Situation(int type, int cord, int add) {
			this.type = type;
			this.add = add;
			this.cord = cord;
		}

		@Override
		public int compareTo(Situation o) {
			if (cord == o.cord) {
				return type - o.type;
			}
			return cord - o.cord;
		}

	}

	class Passenger implements Comparable<Passenger> {
		long start;
		long count;

		public Passenger(long start, long count) {
			this.start = start;
			this.count = count;
		}

		public int compareTo(Passenger o) {
			return Long.valueOf(start).compareTo(Long.valueOf(count));
		}
	}

	long calc(long d) {
		return (((d * 1L * n) % mod) - (d * (d - 1) / 2) % mod + mod) % mod;
	}

	int n;

	void solve() throws IOException {
		n = nextInt();
		long res = 0;
		ArrayList<Situation> sob = new ArrayList<>();
		int m = nextInt();
		for (int i = 0; i < m; i++) {
			long st = nextLong() - 1;
			long en = nextLong() - 1;
			long cur = calc(en - st);
			long p = nextLong();
			res = (res + cur * p) % mod;
			sob.add(new Situation(1, (int) st, (int) p));
			sob.add(new Situation(2, (int) en, (int) p));
		}
		System.err.println(res);
		Collections.sort(sob);
		long prev = 0;
		ArrayList<Passenger> arr = new ArrayList<>();
		for (Situation s : sob) {
			long cur = s.cord;
			for (int i = 0; i < arr.size(); i++) {
				Passenger p = arr.get(i);
				long add = calc(cur - p.start) - calc(prev - p.start);
				add = (add + mod) % mod;
				res = (res - (add * p.count) % mod + mod) % mod;
			}
			if (s.type == 1) {
				arr.add(new Passenger(cur, s.add));
			} else {
				int k = s.add;
				for (int i = arr.size() - 1; i >= 0; --i) {
					Passenger p = arr.get(i);
					if (p.count >= k) {
						p.count -= k;
						break;
					} else {
						k -= p.count;
						p.count = 0;
					}
				}
			}
			prev = cur;
		}
		out.println(res);
	}

	public void run() throws IOException {
		br = new BufferedReader(new FileReader("A.in"));
		out = new PrintWriter("A.out");
		int n = nextInt();
		for (int i = 0; i < n; i++) {
			out.print("Case #" + (i+1) + ": ");
			solve();
		}
		br.close();
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A().run();
	}

	BufferedReader br;
	StringTokenizer str;
	PrintWriter out;

	String next() throws IOException {
		while (str == null || !str.hasMoreTokens()) {
			String s = br.readLine();
			if (s != null) {
				str = new StringTokenizer(s);
			} else {
				return null;
			}
		}
		return str.nextToken();
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

}
