import java.io.*;
import java.util.*;

public class C {

	class Edge {
		int st, en;
		Edge rev;
		int flow;

		public Edge(int st, int en, int flow) {
			this.st = st;
			this.en = en;
			this.flow = flow;
		}
	}

	void addEdge(int v, int u, int fl) {
		Edge e1 = new Edge(v, u, fl);
		Edge e2 = new Edge(u, v, 0);
		e1.rev = e2;
		e2.rev = e1;
		edges[v].add(e1);
		edges[u].add(e2);
	}

	int vs;

	int[] was = new int[3000000];
	int cw = 0;

	static ArrayList<Edge>[] edges = new ArrayList[300000];

	public boolean dfs(int v) {
		if (v == vs) {
			return true;
		}
		if (was[v] == cw) {
			return false;
		}
		was[v] = cw;
		for (int i = 0; i < edges[v].size(); i++) {
			Edge t = edges[v].get(i);
			if (t.flow > 0 && dfs(t.en)) {
				t.flow--;
				t.rev.flow++;
				return true;
			}
		}
		return false;
	}

	void solve() throws IOException {
		for (int i = 0; i < 300000; i++) {
			edges[i] = new ArrayList<>();
		}
		Arrays.fill(was, 0);
		cw = 1;
		int w = nextInt();
		int h = nextInt();
		int n = nextInt();
		int[][] cord = new int[n][4];
		for (int i = 0; i < n; i++) {
			for (int j = 0; j < 4; j++) {
				cord[i][j] = nextInt();
			}
		}
		int[] was = new int[w];
		vs = 1;

		for (int i = 0; i < h; i++) {
			int[] cov = new int[w + 1];
			for (int j = 0; j < n; j++) {
				if (cord[j][1] <= i && cord[j][3]>= i) {
					cov[cord[j][0]]++;
					cov[cord[j][2] + 1]--;
				}
			}
			int[] newwas = new int[w];
			int sum = 0;
			for (int j = 0; j < w; j++) {
				sum += cov[j];
				if (sum == 0) {
					newwas[j] = vs++;
				} else {
					newwas[j] = -1;
				}
			}
			for (int j = 0; j < w; j++) {
				if (newwas[j] == -1) {
					continue;
				}
				addEdge(2 * newwas[j], 2 * newwas[j] + 1, 1);
				if (j < w - 1 && newwas[j + 1] != -1) {
					addEdge(2 * newwas[j] + 1, 2 * newwas[j + 1], 1);
				}
				if (j > 0 && newwas[j - 1] != -1) {
					addEdge(2 * newwas[j] + 1, 2 * newwas[j - 1], 1);
				}
				if (was[j] != -1) {
					if (was[j] != 0) {
						addEdge(2 * newwas[j] + 1, 2 * was[j], 1);
					}
					addEdge(2 * was[j] + 1, 2 * newwas[j], 1);
				}
			}
			was = newwas;
		}
		for (int i = 0; i < w; i++) {
			if (was[i] != -1) {
				addEdge(2 * was[i] + 1, 2 * vs, 1);
			}
		}
		int ans = 0;
		System.err.println(vs);
		vs *= 2;
		while (dfs(1)) {
			System.err.println(ans);
			ans++;
			cw++;
		}
		out.println(ans);
	}

	void run() throws IOException {
		in = new BufferedReader(new FileReader("C.in"));
		out = new PrintWriter("C.out");
		int t = nextInt();
		for (int i = 1; i <= t; i++) {
			System.err.println(i);
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new C().run();
	}

	BufferedReader in;
	PrintWriter out;
	StringTokenizer st;

	String next() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			String temp = in.readLine();
			if (temp == null) {
				return null;
			}
			st = new StringTokenizer(temp);
		}
		return st.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

}
