import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class B {
	BufferedReader in;
	StringTokenizer str;
	PrintWriter out;
	String SK;

	String next() throws IOException {
		while ((str == null) || (!str.hasMoreTokens())) {
			SK = in.readLine();
			if (SK == null)
				return null;
			str = new StringTokenizer(SK);
		}
		return str.nextToken();
	}

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	}

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	}

	long nextLong() throws IOException {
		return Long.parseLong(next());
	}

	class Circle implements Comparable<Circle> {
		int x;
		int num;

		public Circle(int a, int b) {
			x = a;
			num = b;
		}

		@Override
		public int compareTo(Circle o) {
			return o.x - x;
		}
	}

	void solve() throws IOException {
		int n = nextInt();
		int w = nextInt();
		int h = nextInt();
		boolean rev = false;
		if (w > h) {
			int t = h;
			h = w;
			w = t;
			rev = true;
		}
		Circle[] a = new Circle[n];
		for (int i = n - 1; i >= 0; --i) {
			a[i] = new Circle(nextInt(), n - i - 1);
		}
		Arrays.sort(a);
		int[] resx = new int[n];
		int[] resy = new int[n];
		int curx = 0;
		int old = Integer.MIN_VALUE;
		for (int i = 0; i < n;) {
			curx = Math.max(curx, old + a[i].x);
			if (curx > h) {
				out.println("Ooops");
				return;
			}
			int old1 = Integer.MIN_VALUE;
			int cury = 0;
			int j = i;
			for (; j < n; j++) {
				cury = Math.max(cury, old1 + a[j].x);
				if (cury > w) {
					break;
				}
				resx[a[j].num] = cury;
				resy[a[j].num] = curx;
				old1 = cury + a[j].x;
			}
			old = curx + a[i].x;
			i = j;
		}
		for (int i = 0; i < n; i++) {
			if (!rev) {
				out.print(" " + resx[i] + " " + resy[i]);
			} else {
				out.print(" " + resy[i] + " " + resx[i]);
			}
		}
		out.println();
	}

	void run() throws IOException {
		in = new BufferedReader(new FileReader("input.txt"));
		out = new PrintWriter("output.txt");
		int t = nextInt();
		for (int i = 0; i < t; i++) {
			out.print("Case #" + (i + 1) + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new B().run();
	}

}