import java.io.*;
import java.util.Arrays;
import java.util.Locale;
import java.util.StringTokenizer;

public class A {
	BufferedReader in;
	StringTokenizer str;
	PrintWriter out;
	String SK;

	String next() throws IOException {
		while ((str == null) || (!str.hasMoreTokens())) {
			SK = in.readLine();
			if (SK == null)
				return null;
			str = new StringTokenizer(SK);
		}
		return str.nextToken();
	};

	int nextInt() throws IOException {
		return Integer.parseInt(next());
	};

	double nextDouble() throws IOException {
		return Double.parseDouble(next());
	};

	long nextLong() throws IOException {
		return Long.parseLong(next());
	};

	void solve() throws IOException {
		int X = nextInt();
		int S = nextInt();
		int R = nextInt() - S;
		int a[] = new int[X + 22];
		double left = nextDouble();
		int n = nextInt();
		for (int i = 0; i < n; i++) {
			int st = nextInt();
			int en = nextInt();
			int cost = nextInt();
			a[st] += cost;
			a[en] -= cost;
		}
		double b[] = new double[X];
		int sum = 0;
		for (int i = 0; i < X; i++) {
			sum += a[i];
			b[i] = sum + S;
		}
		Arrays.sort(b);
		double res = 0;
		for (int i = 0; i < X; i++) {
			double dln = left * (b[i] + R);
			if (dln > 1 - 1e-10) {
				res += 1 / (b[i] + R);
				left -= 1 / (b[i] + R);
			} else {
				res += dln / (b[i] + R) + (1 - dln) / (b[i]);
				left = 0;
			}
		}
		out.printf("%.10f\n",res);
	}

	void run() throws IOException {
		Locale.setDefault(Locale.US);
		in = new BufferedReader(new FileReader("input.txt"));
		out = new PrintWriter("output.txt");
		int n = nextInt();
		for (int i = 1; i <= n; i++) {
			out.print("Case #" + i + ": ");
			solve();
		}
		out.close();
	}

	public static void main(String[] args) throws IOException {
		new A().run();
	}

}
