import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class R1BA {

	private static BufferedReader br;
	private static StringTokenizer st;
	private static PrintWriter pw;

	static char[] C = "ZWUFXSGOHI".toCharArray();
	static int[] D = new int[] { 0, 2, 4, 5, 6, 7, 8, 1, 3, 9 };
	static String[] S = new String[] { "ZERO", "TWO", "FOUR", "FIVE", "SIX",
			"SEVEN", "EIGHT", "ONE", "THREE", "NINE" };

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new InputStreamReader(new DataInputStream(
				new FileInputStream("r:\\input.txt"))));
		pw = new PrintWriter(new BufferedWriter(
				new FileWriter("r:\\output.txt")));
		int MAX_NUM_CASE = readInt();

		for (int qq = 1; qq <= MAX_NUM_CASE; qq++) {
			pw.print("Case #" + qq + ": ");

			solve();
		}

		pw.close();
	}

	private static void solve() throws IOException {

		String s = nextToken();

		int[] p1 = parich(s);
		int[] res = new int[10];

		for (int i = 0; i < 10; i++) {

			int[] p2 = parich(S[i]);

			while (p1[C[i] - 'A'] > 0) {
				sub(p1, p2);
				res[D[i]]++;
			}
		}

		for (int i = 0; i < 10; i++) {
			for (int j = 0; j < res[i]; j++) {
				pw.print(i);
			}
		}

		pw.println();
	}

	private static int[] parich(String s) {
		int[] parich = new int[30];
		for (char c : s.toCharArray()) {
			parich[c - 'A']++;
		}
		return parich;
	}

	private static boolean canSub(int[] p1, int[] p2) {
		for (int i = 0; i < p1.length; i++) {
			if (p1[i] < p2[i])
				return false;
		}
		return true;
	}

	private static void sub(int[] p1, int[] p2) {
		for (int i = 0; i < p1.length; i++) {
			p1[i] -= p2[i];
		}
	}

	private static int readInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	private static String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			if (!br.ready()) {
				pw.close();
				System.exit(0);
			}
			st = new StringTokenizer(br.readLine().trim());
		}
		return st.nextToken();
	}

}
