import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.util.StringTokenizer;

public class R1BB {

	private static BufferedReader br;
	private static StringTokenizer st;
	private static PrintWriter pw;

	public static void main(String[] args) throws IOException {
		br = new BufferedReader(new InputStreamReader(new DataInputStream(
				new FileInputStream("r:\\input.txt"))));
		pw = new PrintWriter(new BufferedWriter(
				new FileWriter("r:\\output.txt")));
		int MAX_NUM_CASE = readInt();

		for (int qq = 1; qq <= MAX_NUM_CASE; qq++) {
			pw.print("Case #" + qq + ": ");

			solve();
		}

		pw.close();
	}

	private static void solve() throws IOException {

		char[] c = nextToken().toCharArray();
		char[] j = nextToken().toCharArray();

		int state = 0;

		int p = 1;

		while (p < c.length && !(c[p] != '?' && j[p] != '?' && c[p] != j[p])) {
			p++;
		}

		if (p < c.length) {

			if (c[p] > j[p] && c[p] - j[p] > j[p] + 10 - c[p]) {

				p--;

				while (p >= 0 && (c[p] == '9' || j[p] == '0')) {
					p--;
				}

				if (p >= 0) {
					if (j[p] == '?' && c[p] == '?') {
						c[p] = '0';
						j[p] = '1';
					} else if (c[p] == '?') {
						c[p] = (char) (j[p] - 1);
					} else {
						j[p] = (char) (c[p] + 1);
					}
				}

			} else if (c[p] < j[p] && j[p] - c[p] > c[p] + 10 - j[p]) {
				p--;

				while (p >= 0 && (j[p] == '9' || c[p] == '0')) {
					p--;
				}

				if (p >= 0) {
					if (j[p] == '?' && c[p] == '?') {
						c[p] = '1';
						j[p] = '0';
					} else if (j[p] == '?') {
						j[p] = (char) (c[p] - 1);
					} else {
						c[p] = (char) (j[p] + 1);
					}
				}
			}

		}

		int t = 0;

		for (int i = 0; i < c.length; i++) {

			if (state == 0) {

				if (c[i] == '?' && j[i] == '?') {
					c[i] = '0';
					j[i] = '0';
				} else if (c[i] == '?') {
					c[i] = j[i];
				} else if (j[i] == '?') {
					j[i] = c[i];
				} else {
					state = c[i] > j[i] ? 1 : -1;
				}

			} else if (state == 1) {

				if (c[i] == '?')
					c[i] = '0';
				if (j[i] == '?')
					j[i] = '9';

			} else if (state == -1) {
				if (c[i] == '?')
					c[i] = '9';
				if (j[i] == '?')
					j[i] = '0';
			}

		}

		for (int i = 0; i < c.length; i++) {
			pw.print(c[i]);
		}
		pw.print(' ');
		for (int i = 0; i < j.length; i++) {
			pw.print(j[i]);
		}
		pw.println();
	}

	private static int readInt() throws IOException {
		return Integer.parseInt(nextToken());
	}

	private static String nextToken() throws IOException {
		while (st == null || !st.hasMoreTokens()) {
			if (!br.ready()) {
				pw.close();
				System.exit(0);
			}
			st = new StringTokenizer(br.readLine().trim());
		}
		return st.nextToken();
	}

}
