import java.io.*;
import java.lang.reflect.Array;
import java.util.Arrays;
import java.util.StringTokenizer;

/**
 * Created by ChCat on 30.04.2017.
 */
public class CodeJam2017R1C1 {

    private static BufferedReader br;
    private static StringTokenizer st;
    private static PrintWriter pw;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(new DataInputStream(
                new FileInputStream("r:\\input.txt"))));
        pw = new PrintWriter(new BufferedWriter(
                new FileWriter("r:\\output.txt")));
        int MAX_NUM_CASE = readInt();

        for (int qq = 1; qq <= MAX_NUM_CASE; qq++) {
            pw.print("Case #" + qq + ": ");

            solve();
        }

        pw.close();
    }

    private static class Cake implements Comparable<Cake>{

        double r;
        double h;

        public Cake(double r,double h){
            this.r = r;
            this.h = h;
        }

        double side(){
            return Math.PI * 2 * r * h;
        }

        @Override
        public int compareTo(Cake o) {
            return Double.compare(this.side(),o.side());
        }
    }

    private static void solve() throws IOException {

        int N = readInt();
        int K = readInt();

        Cake[] cakes = new Cake[N];

        for (int n=0;n<N;n++){

            cakes[n] = new Cake(readDouble(),readDouble());

        }

        Arrays.sort(cakes);

        double ans = 0;

        for (int n=0;n<N;n++){

            double r = cakes[n].r;

            double lans = Math.PI * r *r + cakes[n].side();

            int cnt = 1;

            for (int j = N-1; j>=0; j--){

                if (cnt == K ) break;

                if (j == n) continue;

                if (cakes[j].r>r) continue;

                cnt++;

                lans += cakes[j].side();
            }

            ans = lans > ans ? lans : ans;
        }


        pw.println(ans);

    }

    private static double readDouble() throws IOException {
        return Double.parseDouble(nextToken());
    }

    private static int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            if (!br.ready()) {
                pw.close();
                System.exit(0);
            }
            st = new StringTokenizer(br.readLine().trim());
        }
        return st.nextToken();
    }


}
