import java.io.*;
import java.util.*;

/**
 * Created by ChCat on 21.05.2016.
 */
public class CodeJam2015R21 {

    private static BufferedReader br;
    private static StringTokenizer st;
    private static PrintWriter pw;

    public static void main(String[] args) throws IOException {
        br = new BufferedReader(new InputStreamReader(new DataInputStream(
                new FileInputStream("r:\\input.txt"))));
        pw = new PrintWriter(new BufferedWriter(
                new FileWriter("r:\\output.txt")));
        int MAX_NUM_CASE = readInt();

        for (int qq = 1; qq <= MAX_NUM_CASE; qq++) {
            pw.print("Case #" + qq + ": ");

            solve();
        }

        pw.close();
    }



    private static void solve() throws IOException {

        int N = readInt();
        int R = readInt();
        int P = readInt();
        int S = readInt();

        String[] minP = new String[N+1];
        String[] minR = new String[N+1];
        String[] minS = new String[N+1];

        minP[0]="P";
        minR[0]="R";
        minS[0]="S";

        for (int i=1;i<=N;i++){
            minP[i] = minP[i-1].compareTo(minR[i-1]) <0 ?  minP[i-1]+minR[i-1] : minR[i-1]+minP[i-1];
            minR[i] = minR[i-1].compareTo(minS[i-1]) <0 ?  minR[i-1]+minS[i-1] : minS[i-1]+minR[i-1];
            minS[i] = minS[i-1].compareTo(minP[i-1]) <0 ?  minS[i-1]+minP[i-1] : minP[i-1]+minS[i-1];
        }

        if (meets(getParikh(minP[N]),R,P,S)) {pw.println(minP[N]); return;}
        if (meets(getParikh(minR[N]),R,P,S)) {pw.println(minR[N]); return;}
        if (meets(getParikh(minS[N]),R,P,S)) {pw.println(minS[N]); return;}

        pw.println("IMPOSSIBLE");

    }

    private static boolean meets(int[] p, int R, int P, int S){
        return p[0] == R && p[1] == P && p[2] == S;
    }

    private static int[] getParikh(String s){
        int[] p = new int[3];
        for (char c : s.toCharArray()){
            if (c=='R') p[0]++;
            if (c=='P') p[1]++;
            if (c=='S') p[2]++;
        }
        return p;
    }

    private static int readInt() throws IOException {
        return Integer.parseInt(nextToken());
    }

    private static String nextToken() throws IOException {
        while (st == null || !st.hasMoreTokens()) {
            if (!br.ready()) {
                pw.close();
                System.exit(0);
            }
            st = new StringTokenizer(br.readLine().trim());
        }
        return st.nextToken();
    }
}
