/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package google;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.util.ArrayList;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;

/**
 *
 * @author sergio
 */
public class main {

    private static ArrayList<String> getArtworks(int tiles, int complexity) {
        ArrayList<String> sequences = new ArrayList<>();
        String[] elements = {"G", "L"};
        getOriginalSequences(sequences, elements, "", tiles, 2);
        String complex;
        for (int i = 0; i < sequences.size(); i++) {
            complex = getComplexSequence(sequences.get(i), complexity);
            sequences.set(i, complex);
        }
        return sequences;
    }

    private static void getOriginalSequences(ArrayList<String> sequences, String[] elements, String act, int n, int r) {
        if (n == 0) {
            sequences.add(act);
        } else {
            for (int i = 0; i < r; i++) {
                getOriginalSequences(sequences, elements, act + elements[i], n - 1, r);
            }
        }
    }

    private static String getComplexSequence(String original, int complexity) {
        String complex = original, aux;
        for (int i = 1; i < complexity; i++) {
            aux = "";
            for (int j = 0; j < complex.length(); j++) {
                if (complex.charAt(j) == 'G') {
                    for (int k = 0; k < original.length(); k++) {
                        aux += "G";
                    }
                } else {
                    aux += original;
                }
            }
            complex = aux;
        }
        return complex;
    }

    private static ArrayList<Boolean> hasGold(ArrayList<String> artworks) {
        ArrayList<Boolean> hasGold = new ArrayList<Boolean>();
        for (String artwork : artworks) {
            hasGold.add(artwork.contains("G"));
        }
        return hasGold;
    }

    private static List<int[]> getPosibleSolutions(int students, int artworkLength) {
        int[] input = new int[artworkLength];
        for (int i = 0; i < artworkLength; i++) {
            input[i] = i + 1;
        }
        int k = students;                             // sequence length   

        List<int[]> subsets = new ArrayList<>();

        int[] s = new int[k];                  // here we'll keep indices 
        // pointing to elements in input array

        if (k <= input.length) {
            // first index sequence: 0, 1, 2, ...
            for (int i = 0; (s[i] = i) < k - 1; i++);
            subsets.add(getSubset(input, s));
            for (;;) {
                int i;
                // find position of item that can be incremented
                for (i = k - 1; i >= 0 && s[i] == input.length - k + i; i--);
                if (i < 0) {
                    break;
                } else {
                    s[i]++;                    // increment this item
                    for (++i; i < k; i++) {    // fill up remaining items
                        s[i] = s[i - 1] + 1;
                    }
                    subsets.add(getSubset(input, s));
                }
            }
        }
        return subsets;
    }

    private static int[] getSubset(int[] input, int[] subset) {
        int[] result = new int[subset.length];
        for (int i = 0; i < subset.length; i++) {
            result[i] = input[subset[i]];
        }
        return result;
    }

    private static int factorial(int n) {
        int fact = 1; // this  will be the result
        for (int i = 1; i <= n; i++) {
            fact *= i;
        }
        return fact;
    }

    private static ArrayList<String> read(String filename) {
        ArrayList lines = new ArrayList();
        BufferedReader bufferedReader;
        FileReader fileReader;
        String currentLine;
        try {
            fileReader = new FileReader(filename);
            bufferedReader = new BufferedReader(fileReader);
            while ((currentLine = bufferedReader.readLine()) != null) {
                lines.add(currentLine);
            }
        } catch (FileNotFoundException ex) {
            Logger.getLogger(main.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(main.class.getName()).log(Level.SEVERE, null, ex);
        }

        return lines;
    }

    public static void main(String[] args) {
        PrintWriter printWriter = null;
        try {

            ArrayList<String> lines = read("D-small-attempt1.in");
            printWriter = new PrintWriter("D-small-attempt1.out");

            String[] pData;
            ArrayList<String> artworks;
            ArrayList<Boolean> hasGold;
            boolean possible, valid;
            int tiles, complexity, students, c = 1;
            List<int[]> possibleSolutions;
            int[] currentSolution;
            String aux;
            lines.remove(0);

            for (String line : lines) {
                if (c > 1) {
                    printWriter.println();
                    System.out.println();
                }
                printWriter.print("Case #" + c + ":");
                System.out.print("Case #" + c + ":");
                pData = line.split(" ");
                tiles = Integer.parseInt(pData[0]);
                complexity = Integer.parseInt(pData[1]);
                students = Integer.parseInt(pData[2]);

                if (students == tiles) {
                    for (int i = 0; i < students; i++) {
                        printWriter.print(" " + (i + 1));
                        System.out.print(" " + (i + 1));
                    }
                    c++;
                    continue;
                }

                artworks = getArtworks(tiles, complexity);
                hasGold = hasGold(artworks);
                possible = false;

                for (int t = 1; t <= students; t++) {
                    possibleSolutions = getPosibleSolutions(t, artworks.get(0).length());
                    currentSolution = null;

                    for (int i = 0; i < possibleSolutions.size(); i++) {
                        currentSolution = possibleSolutions.get(i);
                        valid = true;
                        for (int j = 0; j < artworks.size(); j++) {
                            aux = "";
                            for (int k = 0; k < currentSolution.length; k++) {
                                aux += artworks.get(j).charAt(currentSolution[k] - 1);
                            }
                            if (aux.contains("G") != hasGold.get(j)) {
                                valid = false;
                                currentSolution = null;
                                break;
                            }
                        }
                        if (valid) {
                            break;
                        }
                    }

                    if (currentSolution != null) {
                        for (int i = 0; i < currentSolution.length; i++) {
                            printWriter.print(" " + currentSolution[i]);
                            System.out.print(" " + currentSolution[i]);
                        }
                        possible = true;
                        break;
                    }
                }

                if (!possible) {
                    printWriter.print(" IMPOSSIBLE");
                    System.out.print(" IMPOSSIBLE");
                }
                c++;

            }

        } catch (FileNotFoundException ex) {
            Logger.getLogger(main.class.getName()).log(Level.SEVERE, null, ex);
        } finally {
            printWriter.close();
        }
    }

}
