package DeceitfulWar;

import java.util.Arrays;

import TextIO.FileHandler;

public class DeceitfulWar {

    double[][] input;
    String output[];
    
    public DeceitfulWar() {
        input = readInput("src/DeceitfulWar/D-large.in");
        loop();
        write();
    }
    
    public double[][] readInput(String path) {
        String[] temp = null;
        try {
            temp = FileHandler.readFile(path);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
        return a2i(temp);
    }
    
    public double[][] a2i(String[] ss) {
        double[][] out = new double[ss.length][];
        for (int i = 0; i < ss.length; i++) {            
            String line = ss[i];
            String[] tokens = line.split(" ");
            double[] temp = new double[tokens.length];
            for (int j = 0; j < tokens.length; j++) {
                temp[j] = Double.parseDouble(tokens[j]);
            }
            out[i] = temp;
        }
        return out;
    }
    
    public void write() {
        try {
            FileHandler.writeFile("src/DeceitfulWar/D-large.out", output);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    public void loop() {
        int numberOfCases = (int)input[0][0];
        output = new String[numberOfCases];
        int inputLinePointer = 1;
        int caseNumber = 1;
        while (caseNumber < numberOfCases + 1) {
            int numberOfBlocks = (int)input[inputLinePointer++][0];
            double a[] = input[inputLinePointer++];
            double b[] = input[inputLinePointer++];
            
            Arrays.sort(a);
            Arrays.sort(b);
            
            int startPointer = 0;
            int score = 0;
            for (int i = 0; i < a.length; i++) {
                if (a[i] < b[startPointer]) {
                    //do nothing
                } else if (a[i] > b[startPointer]) {
                    startPointer++;
                    score++;
                }
            }
            
            int pointer = 0;
            int score2 = 0;
            for (int i = 0; i < a.length; i++) {
                if (a[i] < b[pointer]) {
                    score2++;
                    pointer++;
                } else if (a[i] > b[pointer]) {
                    for (int j = pointer + 1; j < b.length; j++) {
                        if (b[j] < a[i]) {
                            //do nothing, go to next b
                        } else {
                            //found the minimum value for win
                            score2++;
                            pointer++;
                            //erase it
                            b[j] = -1;
                            //break the inner for loop
                            j = b.length;
                        }
                    }
                }
            }
            output[caseNumber - 1] = String.format("Case #%d: %d %d", caseNumber, (int)score, (int)(b.length - score2));
            System.out.println(String.format("Case #%d: %d %d", caseNumber, (int)score, (int)(b.length - score2)));
            caseNumber++;
        }
    }
}
