package learn;

import TextIO.*;

public class TTT {

    String[] input;
    String[] output;
    
    public TTT() {
        input = readInput("src/learn/A-small-attempt3.in");
        output = loop();
        write();
    }
    
    public String[] readInput(String path) {
        String [] temp = null;
        try {
            temp = FileHandler.readFile(path);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
        return temp;
    }
    
    public String[] loop() {
        int noCases = Integer.parseInt(input[0]);
        String[] o = new String[noCases];
        int linePointer = 1;
        int i = 0;
        char[] grid;
        char c = '0';
        boolean b = false;
        boolean isComplete;
        StringBuilder sb = new StringBuilder();
        while (i != noCases) {
            grid = new char[16];
            b = false;
            isComplete = true;
            for (int j = 0; j < 16; j++) {
                if (j != 0 && j % 4 == 0) {
                    linePointer++;
                }
                grid[j] = input[linePointer].charAt(j % 4);
                if (grid[j] == '.') {
                    isComplete = false;
                }
            }
            for (int j = 0; j < 4; j++) {
                c = '0';
                c = findRow(j, grid);
                if (c != '0' && c != '.') {
                    b = true;
                    o[i] = String.format("Case #%d: %c won", i+1, c);
                    j = 5;
                }
            }
            for (int j = 0; j < 4; j++) {
                if (b) {
                    j = 5;
                    continue;
                }
                c = '0';
                c = findColumn(j, grid);
                if (c != '0' && c != '.') {
                    b = true;
                    o[i] = String.format("Case #%d: %c won", i+1, c);
                }
            }
            c = findDiagonals(grid);
            if (c != '0' && c != '.' && !b) {
                b = true;
                o[i] = String.format("Case #%d: %c won", i+1, c);
            }
            if (!b) {
                if (isComplete) {                    
                    o[i] = String.format("Case #%d: Draw", i+1);
                } else {
                    o[i] = String.format("Case #%d: Game has not completed", i+1);
                }
               
            }
            i++;
            linePointer+= 2;
        }
        return o;
    }
    
    public void write () {
        try {
            FileHandler.writeFile("src/learn/output.txt", output);
            
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    public char findRow(int row, char[] grid) {
        int i = 0;
        char memory = grid[row*4 + i++];
        while (i != 4) {
            if (memory == 'T') {
                memory = grid[row*4 + i++];
                continue;
            }
            if (grid[row*4 + i] == 'T') {
                i++;
                continue;
            }
            if (memory != grid[row*4 + i]) {
                return '0';
            } 
            memory = grid[row*4 + i++];
        }
        return memory;
    }
    
    public char findColumn(int column, char[] grid) {
        int i = 0;
        char memory = grid[column + i*4];
        i++;
        while (i < 4) {
            if (memory == 'T') {
                memory = grid[column + i*4];
                continue;
            }
            if (grid[column + i*4] == 'T') {
                i++;
                continue;
            }
            if (memory != grid[column + i*4]) {
                return '0';
            } 
            memory = grid[column + i*4];
            i++;
        }
        return memory;
    }
    
    public char findDiagonals(char[] grid) {
        int i = 0;
        char memory = grid[i];
        char c = '0';
        for (i = 5; i < 16; i +=5) {
            c = memory;
            if (memory == 'T') {
                memory = grid[i];
            }
            if (grid[i] == 'T') {
                continue;
            }
            if (memory != grid[i]) {
                c = '0';
                break;
            }         
        }
        if (c != '0') {
            return c;
        }
        memory = grid[3];
        for (i = 6; i < 13; i += 3) {
            c = memory;
            if (memory == 'T') {
                memory = grid[i];
            }
            if (grid[i] == 'T') {
                continue;
            }
            if (memory != grid[i]) {
                c = '0';
                break;
            }
        }
        return c;
    }
    
}
