package learn.Lawn;

import TextIO.FileHandler;

public class Lawn {
    
    int[][] input;
    String[] output;
    
    public Lawn() {
        input = readInput("src/learn/Lawn/B-small-attempt1.in");
        output = loop();
        write();
    }
    
    public int[][] readInput(String path) {
        String[] temp = null;
        try {
            temp = FileHandler.readFile(path);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
        return a2i(temp);
    }
    
    public int[][] a2i(String[] ss) {
        int[][] out = new int[ss.length][];
        for (int i = 0; i < ss.length; i++) {            
            String line = ss[i];
            String[] tokens = line.split(" ");
            int[] temp = new int[tokens.length];
            for (int j = 0; j < tokens.length; j++) {
                temp[j] = Integer.parseInt(tokens[j]);
            }
            out[i] = temp;
        }
        return out;
    }
    
    public void write() {
        try {
            FileHandler.writeFile("src/learn/Lawn/outputB.txt", output);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    public String[] loop() {
        int noCases = input[0][0];
        int linePointer = 1;
        int i = 0;
        boolean possible;
        String[] out = new String[noCases];
        while (i < noCases) {
            int noLines = input[linePointer++][0];
            possible = true;
            int[][] grid = new int[noLines][];
            for (int j = 0; j < noLines; j++) {
                grid[j] = input[linePointer++];
            }
            for (int j = 0; j < grid.length; j++) {
                int l = grid[j].length;
                for (int k = 0; k < l; k++) {
                    boolean up = goUp(grid, j, k);
                    boolean down = goDown(grid, j, k);
                    boolean left = goLeft(grid, j, k);
                    boolean right = goRight(grid, j, k);
                    if (!(up && down) && !(left && right)) {
                        possible = false;
                        k = grid[j].length;
                        j = grid.length;
                    }
                }
            }
            if (possible) {
                out[i] = String.format("Case #%d: YES", i+1);
            } else {
                out[i] = String.format("Case #%d: NO", i+1);
            }
            i++;
        }
        return out;
    }
    
    public boolean goUp(int[][] grid, int j, int k) {
        int i = 0;
        int num = grid[j][k];
        while (j - i >= 0) {
            if (num < grid[j - i][k]) {
                return false;
            }
            i++;
        }
        return true;
    }
    
    public boolean goDown(int[][] grid, int j, int k) {
        int i = 0;
        int num = grid[j][k];
        while (j + i < grid.length) {
            if (num < grid[j + i][k]) {
                return false;
            }
            i++;
        }
        return true;
    }
    
    public boolean goLeft(int[][] grid, int j, int k) {
        int i = 0;
        int num = grid[j][k];
        while (k - i >= 0) {
            if (num < grid[j][k - i]) {
                return false;
            }
            i++;
        }
        return true;
    }
    
    public boolean goRight(int[][] grid, int j, int k) {
        int i = 0;
        int num = grid[j][k];
        while (k + i < grid[j].length) {
            if (num < grid[j][k + i]) {
                return false;
            }
            i++;
        }
        return true;
    }

}
