package TextIO;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;

public class FileHandler {
    
    public static String[] readFile(String filePath) throws FileNotFoundException, IOException{
        ArrayList<String> lines = new ArrayList<String>();        
        BufferedReader br = new BufferedReader(new FileReader(filePath));
        
        String nextLine = br.readLine();
        while(nextLine != null){
            lines.add(nextLine);
            nextLine = br.readLine();
        }
        br.close();
        return lines.toArray(new String[0]);
    }
    
    public static void clearFile(String filePath) throws IOException{
        PrintWriter pw = new PrintWriter(new FileWriter(filePath, false));
        pw.print("");
        pw.close();
    }
    
    public static void writeFile(String filePath, String line) throws IOException{
        PrintWriter pw = new PrintWriter(new FileWriter(filePath, true));        
        pw.print(line);
        pw.println();
        pw.close();
    }
    
    public static void writeFile(String filePath, String[] lines) throws IOException{
        if (lines.length == 0){
            return;
        }
        PrintWriter pw = new PrintWriter(new FileWriter(filePath, false));
        for (int i = 0; i < lines.length; i++){
            pw.print(lines[i]);
            pw.println();
        }
        pw.close();
    }
}
