package learn.FairSquare;

import TextIO.FileHandler;

public class FairSquare {
    
    int[][] input;
    String[] output;
    
    public FairSquare () {
        input = readInput("src/learn/FairSquare/C-small-attempt0.in");
        output = loop();
        write();
    }
    
    public int[][] readInput(String path) {
        String[] temp = null;
        try {
            temp = FileHandler.readFile(path);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
        return a2i(temp);
    }
    
    public int[][] a2i(String[] ss) {
        int[][] out = new int[ss.length][];
        for (int i = 0; i < ss.length; i++) {            
            String line = ss[i];
            String[] tokens = line.split(" ");
            int[] temp = new int[tokens.length];
            for (int j = 0; j < tokens.length; j++) {
                temp[j] = Integer.parseInt(tokens[j]);
            }
            out[i] = temp;
        }
        return out;
    }
    
    public void write() {
        try {
            FileHandler.writeFile("src/learn/FairSquare/outputc1.txt", output);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    public String[] loop() {
        int noCases = input[0][0];
        String[] ss = new String[noCases];
        int i = 0;
        int count = 0;
        while (i < noCases) {
            count = 0;
            int num1 = input[i + 1][0];
            int num2 = input[i + 1][1];
            for (int j = num1; j <= num2; j++) {
                if (isPalindrome(Integer.toString(j))) {
                    double ans = Math.sqrt(j);
                    if (ans % 1 < 0.0000001) {
                        int a = (int)(ans + 0.1);
                        if (isPalindrome(Integer.toString(a))){
                            count++;
                        }
                    }
                }
            }          
            ss[i] = String.format("Case #%d: %d", i+1, count);
            i++;
        }
        return ss;
    }
    
    public boolean isPalindrome(String s) {
        for (int i = 0; i < s.length() / 2; i++) {
            char c = s.charAt(i);
            if (c != s.charAt(s.length() -1 - i)) {
                return false;
            }
        }
        return true;
    }

}
