package MagicTrick;

import TextIO.FileHandler;

public class MagicTrick {
    
    int[][] input;
    String[] output;
    
    public MagicTrick() {
        input = readInput("src/MagicTrick/A-small-attempt1 (1).in");
        loop();
        write();
    }
    
    public int[][] readInput(String path) {
        String[] temp = null;
        try {
            temp = FileHandler.readFile(path);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
        return a2i(temp);
    }
    
    public int[][] a2i(String[] ss) {
        int[][] out = new int[ss.length][];
        for (int i = 0; i < ss.length; i++) {            
            String line = ss[i];
            String[] tokens = line.split(" ");
            int[] temp = new int[tokens.length];
            for (int j = 0; j < tokens.length; j++) {
                temp[j] = Integer.parseInt(tokens[j]);
            }
            out[i] = temp;
        }
        return out;
    }
    
    public void write() {
        try {
            FileHandler.writeFile("src/MagicTrick/A-small-attempt0 (1).out", output);
        } catch (Exception e) {
            e.printStackTrace();
            System.exit(-1);
        }
    }
    
    public void loop() {
        
        int numberOfTestCases = input[0][0];
        int i = 0;
        int linePointer = 1;
        output = new String[numberOfTestCases];
        
        while (i < numberOfTestCases) {
            int location = input[linePointer][0];
            int row1[] = input[linePointer + location];
            //go to the next 4x4
            linePointer += 5;
            location = input[linePointer][0];
            int row2[] = input[linePointer + location];
            linePointer+=5;
            int ans = isCommon(row1, row2);
            if (ans == -2) {
                output[i] = String.format("Case #%d: Bad magician!", i + 1);
                System.out.println(String.format("Case #%d: Bad magician!", i + 1));
            } else if (ans == -1) {
                output[i] = String.format("Case #%d: Volunteer cheated!", i + 1);
                System.out.println(String.format("Case: #%d Volunteer cheated!", i + 1));
            } else {
                output[i] = String.format("Case #%d: %d", i + 1, ans);
                System.out.println(String.format("Case #%d: %d", i + 1, ans));
            }
            i++;
        }
    }
    
    public int isCommon(int a[], int b[]) {
        int numberOfMatches = 0;
        int ans = -1;
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (a[i] == b[j]) {
                    numberOfMatches++;
                    ans = a[i];
                }
            }
        }
        if (numberOfMatches == 1) {
            return ans;
        } else if (numberOfMatches > 1) {
            return -2;
        }
        return -1;
    }
            
}
