import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;

public class B {

	static String formata(int x) {
		if (x > 9) {
			return x + "";
		} else {
			return "0" + x;
		}
	}

	static int compara(Evento e1, Evento e2){
		String[] s1 = e1.tempo.split(":");
		String[] s2 = e2.tempo.split(":");
		int n1 = Integer.parseInt(s1[0]);
		int n2 = Integer.parseInt(s2[0]);
		
		if(n1 < n2) {
			return -1;
		}
		
		if(n1 > n2) {
			return 1;
		}
		
		n1 = Integer.parseInt(s1[1]);
		n2 = Integer.parseInt(s2[1]);
		
		if(n1 < n2) {
			return -1;
		}
		
		if(n1 > n2) {
			return 1;
		}
		
		if(e1.tipo == tipo_evento.SAIDA_A_B || e1.tipo == tipo_evento.SAIDA_B_A) {
			return 1;
		}

		if(e2.tipo == tipo_evento.SAIDA_A_B || e2.tipo == tipo_evento.SAIDA_B_A) {
			return -1;
		}

		return 0;
	}
	
	static String soma(String tempo, int x) {
		String[] s = tempo.split(":");
		int dir = Integer.parseInt(s[1]);

		if (dir + x < 60) {
			return s[0] + ":" + formata((dir + x));
		} else {
			int esq = Integer.parseInt(s[0]);
			return formata((esq + 1)) + ":" + formata(((dir + x) % 60));
		}
	}

	enum tipo_evento{
		SAIDA_B_A,
		SAIDA_A_B,
		DISPONIBILIZAR_TREM_A,
		DISPONIBILIZAR_TREM_B;
	}
	
	static class Evento {
		String tempo;
		tipo_evento tipo;
	}

	public static void main(String[] args) throws Exception {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		int instancias = Integer.parseInt(in.readLine().trim());

		for (int i = 1; i <= instancias; i++) {
			int turnaround = Integer.parseInt(in.readLine().trim());
			String[] line = in.readLine().trim().split("\\s+");
			int n_viagens_a_b = Integer.parseInt(line[0]);
			int n_viagens_b_a = Integer.parseInt(line[1]);
			ArrayList<Evento> eventos = new ArrayList<Evento>();

			for (int j = 0; j < n_viagens_a_b; j++) {
				line = in.readLine().trim().split("\\s+");
				Evento e1 = new Evento(), e2 = new Evento();
				e1.tempo = line[0];
				e1.tipo = tipo_evento.SAIDA_A_B;
				e2.tempo = soma(line[1], turnaround);
				e2.tipo = tipo_evento.DISPONIBILIZAR_TREM_B;
				eventos.add(e1);
				eventos.add(e2);
			}

			for (int j = 0; j < n_viagens_b_a; j++) {
				line = in.readLine().trim().split("\\s+");
				Evento e1 = new Evento(), e2 = new Evento();
				e1.tempo = line[0];
				e1.tipo = tipo_evento.SAIDA_B_A;
				e2.tempo = soma(line[1], turnaround);
				e2.tipo = tipo_evento.DISPONIBILIZAR_TREM_A;
				eventos.add(e1);
				eventos.add(e2);
			}

			Collections.sort(eventos, new Comparator<Evento>(){
				@Override
				public int compare(Evento e1, Evento e2) {
					return compara(e1, e2);
				}
			});

			int trensDispoA = 0;
			int trensDispoB = 0;
			int respA = 0;
			int respB = 0;
			
			for(Evento e: eventos) {
				if(e.tipo == tipo_evento.SAIDA_A_B){
					if(trensDispoA == 0) {
						respA++;
					} else {
						trensDispoA--;	
					}
				} else if(e.tipo == tipo_evento.SAIDA_B_A){
					if(trensDispoB == 0) {
						respB++;
					} else {
						trensDispoB--;	
					}
				} else if(e.tipo == tipo_evento.DISPONIBILIZAR_TREM_A){
					trensDispoA++;
				} else if(e.tipo == tipo_evento.DISPONIBILIZAR_TREM_B){
					trensDispoB++;
				}
			}
			
			System.out.println("Case #" + i + ": " + respA + " " + respB);
		}
	}
}
