import java.io.File;
import java.io.FileNotFoundException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class FairAndSquareLarge2 {
	static Scanner scanner;
	static List<BigInteger> fairAndSquares = new ArrayList<BigInteger>();
	
	public static void main(String[] args) throws FileNotFoundException {
		long start = System.currentTimeMillis();

		preCalculateFairAndSquares(50);
		
		scanner = new Scanner(new File("C-large-2.in"));
		int caseCount = scanner.nextInt();
		for (int caseNumber = 1; caseNumber <= caseCount; caseNumber++) {
			long result = solve();
			System.out.format("Case #%d: %d%n", caseNumber, result);
		}
		System.out.format("Total time: %d%n", System.currentTimeMillis() - start);
	}

	static long solve() {
		String minValueString = scanner.next();
		BigInteger minValue = new BigInteger(minValueString);
		String maxValueString = scanner.next();
		BigInteger maxValue = new BigInteger(maxValueString);
		
		int result = 0;
		for (BigInteger fairAndSquareNumber: fairAndSquares) {
			if (fairAndSquareNumber.compareTo(minValue) >= 0 && fairAndSquareNumber.compareTo(maxValue) <=0) {
				result++;
			}
		}
		
		return result;
	}
	
	static void preCalculateFairAndSquares(int maxLength) {
		// 1 digit
		fairAndSquares.add(new BigInteger("1"));
		fairAndSquares.add(new BigInteger("4"));
		fairAndSquares.add(new BigInteger("9"));
		
		StringBuilder s = new StringBuilder();
		generateFairAndSquares(s, 0, maxLength);
		System.out.println("Total square roots: " + fairAndSquares.size());
	}
	
	static void generateFairAndSquares(StringBuilder s, int squareSum, int maxLength) {
		if (s.length() * 2 + 1 >= maxLength) {
			return;
		}
		int minInt = s.length() == 0 ? 1 : 0;
		int maxInt = s.length() == 0 ? 2 : 1;
		for (int i = minInt; i <= maxInt; i++) {
			int newSquareSum = squareSum + i * i;
			if (newSquareSum * 2 < 10) {
				s.append(i);
				addPalindrome(s.toString());
				if (s.length() * 2 + 1 <= maxLength) {
					addPalindrome(s.toString(), "0");
					// adding 1 will not go over 10
					addPalindrome(s.toString(), "1");
					if (newSquareSum * 2 + 2 * 2 < 10) {
						addPalindrome(s.toString(), "2");
					}
				}
				generateFairAndSquares(s, newSquareSum, maxLength);
				s.deleteCharAt(s.length() - 1);
			}
		}
	}

	static void addPalindrome(String half) {
		addPalindrome(half, null);
	}

	static void addPalindrome(String half, String middleChar) {
		String otherHalf = new StringBuilder(half).reverse().toString();
		BigInteger n = new BigInteger(half + (middleChar == null ? "" : middleChar) + otherHalf);
//		System.out.format("%50d%100d%n", n, n.pow(2));
		fairAndSquares.add(n.pow(2));
	}
}
