import java.util.Scanner;

public class Main {

    public static void main(String[] args) {

        Scanner scanner = new Scanner(System.in);
        Main main = new Main();
        int count = scanner.nextInt();
        for (int i=0; i< count; i++) {
            long L = scanner.nextLong();
            long X = scanner.nextLong();
            String str = scanner.next();
            System.out.println(String.format("Case #%d: ", i+1) + (main.canConvert(str, X)? "YES": "NO"));
        }
    }

    private int[][] initTransform() {
        int[][] transform = new int[8][8];
        for(int i=0; i<8; i++) {
            transform[0][i] = i;
            transform[4][i] = (i<4) ? i+4 : i-4;
            transform[i][0] = i;
            transform[i][4] = (i<4) ? i+4 : i-4;
            if(i!=0) {
                transform[i][i] = 4;
            }
        }
        transform[1][2] = 3;
        transform[1][3] = 6;

        transform[2][1] = 7;
        transform[2][3] = 1;

        transform[3][1] = 2;
        transform[3][2] = 5;

        transform[5][1] = 0;
        transform[5][2] = 7;
        transform[5][3] = 2;

        transform[6][1] = 3;
        transform[6][2] = 0;
        transform[6][3] = 5;

        transform[7][1] = 6;
        transform[7][2] = 1;
        transform[7][3] = 0;
        return transform;
    }

    public boolean canConvert(String str , long repeat) {
        //0:1, 1:i, 2:j ,3:k, 4: -1, 5:-i, 6:-j, 7:-k
        int[][] transform = initTransform();


        if(canConvert2(str, 1)) {
            return repeat%2 !=0;
        }


        for(int i=2; i<=6 && i<=repeat; i++) {
            if(canConvert2(str, i)) {
                return (repeat - i) % 4==0 || (repeat-i) % (i*2) == 0;
            }
        }
        return false;
    }

    private boolean canConvert2(String origin, long repeat) {

        StringBuilder sb = new StringBuilder();

        for(int i=0; i<1; i++) {
            sb.append(origin);
        }
        String str = sb.toString();

        int[][] transform = initTransform();
        boolean getI = false, getK= false;
        int cur = charToInt(str.charAt(0));
        if(cur == 1) {
            getI = true;
        }
        for (int i = 1; i < str.length(); i++) {
            cur = transform[cur][charToInt(str.charAt(i))];
            if (cur == 1) {
                getI = true;
            }
            if (cur == 3 && getI) {
                getK = true;
            }
        }
        return getK && cur == 4;
    }


    private int charToInt(char ch) {
        switch (ch) {
            case 'i':
                return 1;
            case 'j':
                return 2;
            case 'k':
                return 3;
            default:
                return 1;
        }
    }


}
