import com.google.common.base.Enums;
import com.google.common.base.Optional;
import com.google.common.base.Predicate;
import com.google.common.collect.Collections2;
import com.google.common.collect.FluentIterable;
import com.google.common.collect.ForwardingObject;
import com.google.common.math.IntMath;
import com.google.common.primitives.Ints;
import com.sun.istack.internal.Nullable;

import java.util.Collection;
import java.util.List;

import java.util.Scanner;


public class Main {

    public static void main(String... args) {
        Main a = new Main();
        Scanner scanner = new Scanner(System.in);
        int caseNum = scanner.nextInt();
        for(int i=0; i< caseNum; i++) {

            long start = scanner.nextLong();
            long result = a.solve(start);
            if(result == -1L) {
                System.out.println(String.format("Case #%d: INSOMNIA", i+1));
            } else {
                System.out.println(String.format("Case #%d: %d", i+1, result));
            }
        }
    }


    private boolean allSeen(boolean[] digits) {
        for(int i=0; i<10; i++) {
            if(!digits[i]) {
                return false;
            }
        }
        return true;
    }

    private void markSeen(boolean[] digits, long i) {
        while (i!=0) {
            digits[(int)(i % 10)] = true;
            i /=10;
        }
        return;
    }

    public long solve(long start) {
        if(start == 0) {
            return -1L;
        }
        boolean[] digits = new boolean[10];
        long i = start;
        while(true) {
            markSeen(digits, i);
            if(allSeen(digits)) {
                return i;
            }

            i += start;
        }
    }



}