package com.google.codejam11.qualification.c;

import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class CandySplitting {

  public String[] solve(InputStream resourceAsStream) {
    Scanner sc = new Scanner(resourceAsStream);
    int testCases = sc.nextInt();
    String[] result = new String[testCases];
    for (int i = 0; i < testCases; i++) {
      int candiesCount = sc.nextInt();
      int[] candies = new int[candiesCount];
      for (int j = 0; j < candiesCount; j++) {
        candies[j] = sc.nextInt();
      }
      
      result[i] = combine(candies);
    }
    
    return result;
  }

  public String combine(int[] candies) {
    List<Comb> combinations = new ArrayList<Comb>();
    
    // Optimization
    int temp = 0;
    for (int i = 0; i < candies.length; i++) {
      temp ^= candies[i];
    }
    if (temp != 0) {
      return "NO";
    }
    
    for (int i = 0; i < 1 << candies.length; i++) {
      int selected = 0;

      int bogusSum = 0;
      int realSum = 0;
//      StringBuilder sb = new StringBuilder();
      for (int j = 0; j < candies.length; j++) {
        if ((i & 1 << j) != 0) {
//          sb.append("1");
          selected += 1;
          
          bogusSum ^= candies[j];
          realSum += candies[j];
//        } else {
//          sb.append("0");
        }
      }
      
      combinations.add(new Comb(i, bogusSum, realSum));

//      System.out.println(i +". Comb: " + sb.toString() + "\tbogus: " + bogusSum + "\treal:" + realSum);
    }
    
    int bestReal = 0;
    L1:
    for (int i = 0; i < combinations.size(); i++) {
      for (int j = 0; j < i; j++) {
        Comb iComb = combinations.get(i);
        Comb jComb = combinations.get(j);
        if (iComb.bogus > 0 && jComb.bogus > 0 && (iComb.real > bestReal || jComb.real > bestReal) && iComb.bogus == jComb.bogus && (iComb.comb & jComb.comb) == 0 && (iComb.comb | jComb.comb) == (1 << candies.length) - 1) {
          if (bestReal < iComb.real) {
            bestReal = iComb.real;
//            System.out.println("found ");
//            System.out.println(i +". Comb: " + iComb.comb + "\tbogus: " + iComb.bogus + "\treal:" + iComb.real);
//            System.out.println(j +". Comb: " + jComb.comb + "\tbogus: " + jComb.bogus + "\treal:" + jComb.real);
          }
          if (bestReal < jComb.real) {
            bestReal = jComb.real;
          }
        }
      }
    }
    
//    System.out.println("bestReal: " + bestReal);
    
    if (bestReal == 0) {
      return "NO";
    } else {
      return "" + bestReal;
    }
  }
  
  class Comb {
    int comb;
    int bogus;
    int real;
    
    public Comb(int comb, int bogus, int real) {
      this.comb = comb;
      this.bogus = bogus;
      this.real = real;
    }
  }
}
