package com.google.codejam11.qualification;
import java.io.InputStream;
import java.util.LinkedList;
import java.util.Scanner;

public class BotTrust {
  public String[] solve(InputStream is) {
    Scanner sc = new Scanner(is);
    int testCases = sc.nextInt();

    LinkedList<Integer> orangeQueue = new LinkedList<Integer>();
    LinkedList<Integer> blueQueue = new LinkedList<Integer>();
    
    LinkedList<Command> orangeBlueQueue = new LinkedList<Command>();

    for (int i = 0; i < testCases; i++) {
      int buttons = sc.nextInt();

      for (int j = 0; j < buttons; j++) {
        String robot = sc.next();
        int buttonIndex = sc.nextInt();

        boolean useOrange = robot.equals("O");
        if (useOrange) {
          orangeQueue.add(buttonIndex);
        } else {
          blueQueue.add(buttonIndex);
        }
        
        orangeBlueQueue.add(new Command(useOrange, buttonIndex));
      }

      LinkedList<State> queue = new LinkedList<State>();
      queue.add(new State(1, 1));
      
      int timeSpent = 0;

      while (!queue.isEmpty()) {
        State current = queue.pop();
        
        // Exit condition
        Command command = orangeBlueQueue.peekFirst();
        if (command == null) {
          // Done (works for case 1, 3)
          break;
        }

        timeSpent++;
        
        boolean poppedOrange = false;
        boolean poppedBlue = false;
        if (command.useOrangeRobot) {
          if (current.orangePos == command.pos) {
            orangeQueue.pop();
            orangeBlueQueue.pop();
            poppedOrange = true;
          }
        } else {
          if (current.bluePos == command.pos) {
            blueQueue.pop();
            orangeBlueQueue.pop();
            poppedBlue = true;
          }
        }

//        if (orangeBlueQueue.isEmpty()) {
//          // Done (fix case 2)
//          break;
//        }

        Integer orangeHead = orangeQueue.peekFirst() == null ? current.orangePos : orangeQueue.peekFirst();
        int nextOrangePos;
        if (Math.abs(orangeHead - (current.orangePos + 1)) < Math.abs(orangeHead - (current.orangePos - 1))) {
          nextOrangePos = current.orangePos + 1;
        } else if (Math.abs(orangeHead - (current.orangePos + 1)) > Math.abs(orangeHead - (current.orangePos - 1))) {
          nextOrangePos = current.orangePos - 1;
        } else {
          // We are already in the spot
          nextOrangePos = orangeHead;
        }

        Integer blueHead = blueQueue.peekFirst() == null ? current.bluePos : blueQueue.peekFirst();
        int nextBluePos;
        if (Math.abs(blueHead - (current.bluePos + 1)) < Math.abs(blueHead - (current.bluePos - 1))) {
          nextBluePos = current.bluePos + 1;
        } else if (Math.abs(blueHead - (current.bluePos + 1)) > Math.abs(blueHead - (current.bluePos - 1))) {
          nextBluePos = current.bluePos - 1;
        } else {
          // We are already in the spot
          nextBluePos = blueHead;
        }
        
        if (poppedOrange) {
          nextOrangePos = current.orangePos;
        }
        if (poppedBlue) {
          nextBluePos = current.bluePos;
        }
        State nextState = new State(nextOrangePos, nextBluePos);
        
        queue.push(nextState);
      }
      
      System.out.println("Case #" + (i + 1) + ": " + timeSpent);
    }
    
    return null;
  }

  class State {
    int orangePos;
    int bluePos;

    // boolean orangePushed;
    // boolean bluePushed;

    public State(int orangePos, int bluePos) {
      this.orangePos = orangePos;
      this.bluePos = bluePos;
    }
  }


  class Command {
    boolean useOrangeRobot;
    int pos;

    public Command(boolean useOrangeRobot, int pos) {
      this.useOrangeRobot = useOrangeRobot;
      this.pos = pos;
    }
  }
}