package test;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.LinkedList;
import java.util.Queue;
import java.util.Scanner;

public class Pancake {
	private boolean allHappy(String S) {
		for (int i = 0; i < S.length(); ++i) {
			if (S.charAt(i) != '+') {
				return false;
			}
		}
		return true;
	}

	private boolean KHappy(String S, int start, int K) {
		for (int i = 0; i < K; ++i) {
			if (S.charAt(start + i) != '+') {
				return false;
			}
		}
		return true;
	}

	private int shortFlips(String S, int K) {
		if (allHappy(S)) {
			return 0;
		}
		Queue<String> q = new LinkedList<>();
		HashSet<String> set = new HashSet<>();
		q.add(S);
		int step = 0;
		set.add(S);
		while (!q.isEmpty()) {
			int size = q.size();
			step++;
			for (int i = 0; i < size; ++i) {
				String front = q.poll();
				for (int j = 0; j <= front.length() - K; ++j) {
					if (KHappy(front, j, K)) {
						continue;
					}
					StringBuilder sb = new StringBuilder(front);
					for (int k = j; k < j + K; ++k) {
						if (sb.charAt(k) == '+') {
							sb.setCharAt(k, '-');
						} else {
							sb.setCharAt(k, '+');
						}
					}
					String sbb = sb.toString();
					if (allHappy(sbb)) {
						return step;
					}
					if (!set.contains(sbb)) {
						set.add(sbb);
						q.add(sbb);
					}
				}
			}
		}

		return -1;
	}

	@SuppressWarnings("resource")
	public static void main(String[] args) throws IOException {
		Pancake pancake = new Pancake();
		Scanner in = new Scanner(new BufferedReader((new FileReader("/Users/haifeng.chen/Downloads/A-small-attempt0.in"))));
		BufferedWriter bw = new BufferedWriter(new FileWriter("/Users/haifeng.chen/Downloads/a-out.txt"));
		int T = in.nextInt();
		for (int t = 1; t <= T; ++t) {
			String S = in.next();
			int K = in.nextInt();
			System.out.println(S);
			System.out.println(K);
			int step = pancake.shortFlips(S, K);
			if (step == -1) {
				bw.write("Case #" + t + ": IMPOSSIBLE\n");
			} else {
				bw.write("Case #" + t + ": " + step + "\n");
			}
		}
		bw.close();
	}
}
