import java.util.*;
import java.io.*;

public class C
{
	static final String PROB_NAME = "C";
	static final boolean SMALL = true;
	static final int ATTEMPT_NUM = 0;
	
	static String NAME;
	static
	{
		if (SMALL)
		{
			if (ATTEMPT_NUM == -1)
				NAME = PROB_NAME + "-small-1";
			else
				NAME = PROB_NAME + "-small-1-attempt" + ATTEMPT_NUM;
		}
		else
			NAME = PROB_NAME + "-large";
	}
	static final boolean STDOUT = true;
	
	public static long[] solve(long n, long k)
	{
		PriorityQueue<Long> queue = new PriorityQueue<> ();
		queue.add(-n);
		long lastLeft = 0;
		long lastRight = 0;
		while (k-- > 0)
		{
			long v = -queue.poll();
			lastLeft = (v - 1) / 2;
			lastRight = v - 1 - lastLeft;
			queue.add(-lastLeft);
			queue.add(-lastRight);
		}
		return new long[] {lastLeft, lastRight};
	}
	
	public static void main(String[] args) throws IOException
	{
		Scanner in = new Scanner(new BufferedReader(new FileReader(NAME + ".in")));
		PrintWriter out = new PrintWriter(new BufferedWriter(new FileWriter(NAME + ".out")));
		
		int t = in.nextInt();
		for (int ii = 1; ii <= t; ii++)
		{
			long n = in.nextInt();
			long k = in.nextInt();
			long[] v = solve(n, k);
			print(out, "Case #" + ii + ": " + v[1] + " " + v[0] + "\n");
		}
		out.flush();
		out.close();
	}
	
	static void print(PrintWriter out, String str) throws IOException
	{
		if (STDOUT)
			System.out.print(str);
		out.print(str);
	}
}