package template;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.Iterator;
import java.util.PriorityQueue;

public class ReadWrite {
	int num;
	ArrayList<Integer> pos = new ArrayList<Integer>();
	ArrayList<Integer> result = new ArrayList<Integer>();
	ArrayList<ArrayList<Integer>> content = new ArrayList<ArrayList<Integer>>();
	public void calculate(){
		for(int i = 0; i < num; i ++){
			int number = minimize(content.get(i));
			number = pos.get(i) % number;
			if(number <= content.get(i).size()){
				if(number == 0) result.add(content.get(i).size());
				else result.add(number);
				continue;
			}
			int[] barber = new int[content.get(i).size()];
			for(int j = 0; j < barber.length; j ++){
				barber[j] = content.get(i).get(j);
			}
			int leave = number - barber.length;
			int last = 0;
			while(leave > 0){
				int min = barber[0];
				for(int j = 0; j < barber.length; j ++){
					min = Math.min(min, barber[j]);
				}
				for(int j  = 0; j < barber.length; j ++){
					barber[j] = barber[j] - min;
					if(barber[j] == 0){
						leave --;
						last = j + 1;
						if(leave == 0){
							break;
						}
						barber[j] = content.get(i).get(j);
					}
				}
			}
			result.add(last);
		}
	}
	public int minimize(ArrayList<Integer> wait){
		if(wait.size() == 1) return 1;
		int cur = wait.get(0);
		for(int i = 1; i < wait.size(); i ++){
			cur = commonMultiple(cur, wait.get(i));
		}
		int sum = 0;
		for(int i = 0; i < wait.size(); i ++){
			sum = cur / wait.get(i) + sum;
		}
		return sum;
	}
	public static int commonDivisor(int n,int m){
		while(n%m!=0){
		int temp=n%m;
		n=m;
		m=temp;
		}
		return m;
		}
	public static int commonMultiple(int n,int m){
		return n*m/commonDivisor(n,m);
		}
	public void readFile(String name) throws IOException{
		File file = new File(name);
		BufferedReader reader = new BufferedReader(new FileReader(file));
		String temp = null;
		num = Integer.valueOf(reader.readLine());
		int line = 0;
		while((temp = reader.readLine()) != null){
			if(line % 2 == 0){
				pos.add(Integer.valueOf(temp.split(" ")[1]));
			}
			else{
				String[] now = temp.split(" ");
				ArrayList<Integer> cur = new ArrayList<Integer>();
				for(int i = 0; i < now.length; i ++){
					cur.add(Integer.valueOf(now[i]));
				}
				content.add(cur);
			}	
			line ++;
		}
		reader.close();
	}
	public void writeFile(String name) throws Exception{
		FileWriter writer = new FileWriter(name);
		for(int i = 0; i < result.size(); i ++){
			int j = i + 1;
			System.out.println(result.get(i));
			writer.write("case #" + j + ": " + result.get(i) + "\n");
			
		}
		writer.close();
	}
	public static void main(String args[]) throws Exception{
		ReadWrite a = new ReadWrite();
		a.readFile("/Users/apple/Desktop/B-small-attempt3.in");
		a.calculate();
		a.writeFile("/Users/apple/Desktop/output.txt");
		
	}
	

}
