import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class PROBLEMC {
	final static String FILE_NAME = "C:\\CJ13\\Input\\C-small-attempt0.in";
	final static String OUTPUT_FILE_NAME = "C:\\CJ13\\Output\\C-small-attempt0.out";
	final static Charset ENCODING = StandardCharsets.UTF_8;
	static int limit = 0;

	public static void main(String args[]) throws IOException {
		PROBLEMC problema = new PROBLEMC();
		problema.readLargerTextFile(FILE_NAME);
	}

	public void readLargerTextFile(String aFileName) throws IOException {
		Path path = Paths.get(aFileName);
		Scanner scanner = new Scanner(path, ENCODING.name());
		int qCount = 0;
		ArrayList<String> result = new ArrayList<String>();
		DecimalFormat df = new DecimalFormat("0");
		while (scanner.hasNextLine()) {
			if (limit == 0) {
				limit = Integer.valueOf(scanner.nextLine());
				System.out.println(limit + "<-- limit ");
			} else {
				String testCase = scanner.nextLine();
				if (testCase.length() > 0) {
					qCount++;
					Double minlt = 0.0;
					Double maxlt = 0.0;
					long fsCount = 0;
					String[] testSplit = testCase.split(" ");
					minlt = new Double(testSplit[0]);
					maxlt = new Double(testSplit[1]);
					for (double value = minlt; value <= maxlt; value++) {
						if (chkPali(value, df)) {
							Double valRoot = Math.sqrt(value);
							if (valRoot - new Double(df.format(valRoot)) == 0
									&& chkPali(valRoot, df)) {
								fsCount++;
							}
						}
					}
					result.add("Case #" + qCount + ": " + fsCount);
					System.out.println(qCount + " " + minlt + " " + maxlt+" sol --> "+fsCount);
				}
			}
		}
		System.out.println(result);
		writeLargerTextFile(OUTPUT_FILE_NAME, result);
	}

	public void writeLargerTextFile(String aFileName, List<String> aLines)
			throws IOException {
		try {
			File file = new File(aFileName);
			// if file doesnt exists, then create it
			if (!file.exists()) {
				file.createNewFile();
			}
			FileWriter fw = new FileWriter(file.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			for (String string : aLines) {
				bw.write(string);
				bw.newLine();
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private boolean chkPali(Double value, DecimalFormat df) {
		String valStr = df.format(value);
		boolean status = true;
		int length = valStr.length();
		if (length % 2 == 0) {
			for (int i = 0; i < length / 2; i++) {
				if (!(valStr.charAt(i) == valStr.charAt(length - i - 1))) {
					status = false;
					break;
				}
			}
		} else {
			for (int i = 0; i < (length / 2) + 1; i++) {
				if (!(valStr.charAt(i) == valStr.charAt(length - i - 1))) {
					status = false;
					break;
				}
			}
		}
		return status;
	}
}
