import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class PROBLEMB {
	final static String FILE_NAME = "C:\\CJ13\\Input\\B-small-attempt1.in";
	final static String OUTPUT_FILE_NAME = "C:\\CJ13\\Output\\B-small-attempt1.out";
	final static Charset ENCODING = StandardCharsets.UTF_8;
	static int limit = 0;

	public static void main(String args[]) throws IOException {
		PROBLEMB problemb = new PROBLEMB();
		problemb.readLargerTextFile(FILE_NAME);
	}

	public void readLargerTextFile(String aFileName) throws IOException {
		Path path = Paths.get(aFileName);
		Scanner scanner = new Scanner(path, ENCODING.name());
		ArrayList<String> result = new ArrayList<String>();
		int[][] matData = null;
		int[][] floorData = null;
		boolean status = true;
		int tLine = 0, rows = 0, cols = 0;
		int qcount = 0;
		while (scanner.hasNextLine()) {
			if (limit == 0) {
				limit = Integer.valueOf(scanner.nextLine());
				System.out.println(limit + "<-- limit ");
			} else {
				String testCase = scanner.nextLine();
				if (testCase.length() > 0) {
					tLine++;
					if (matData == null) {
						rows = Integer.valueOf(testCase.split(" ")[0]);
						cols = Integer.valueOf(testCase.split(" ")[1]);
						matData = new int[rows][cols];
						floorData = new int[rows][cols];
					} else {
						String[] vData = testCase.split(" ");
						for (int j = 0; j < cols; j++) {
							matData[tLine - 2][j] = Integer.valueOf(vData[j]);
						}
					}
					if (tLine == rows + 1) {
						int max = 0;
						for (int i = 0; i < rows; i++) {
							for (int j = 0; j < cols; j++) {
								System.out.print(matData[i][j] + " ");
								max = max > matData[i][j] ? max : matData[i][j];
								floorData[i][j] = 100;
							}
							System.out.println();
						}
						while (max > 0) {
							for (int i = 0; (i < rows && status); i++) {
								for (int j = 0; j < cols; j++) {
									int value = matData[i][j];
									if (max == value) {
										int tempHmax = 0, tempVmax = 0;
										for (int col = 0; col < cols; col++) {
											tempHmax = tempHmax > matData[i][col] ? tempHmax
													: matData[i][col];
										}
										for (int row = 0; row < rows; row++) {
											tempVmax = tempVmax > matData[row][j] ? tempVmax
													: matData[row][j];
										}
										if (matData[i][0] <= max
												&& matData[i][cols - 1] <= max
												&& tempHmax <= max) {
											for (int k = 0; k < cols; k++) {
												floorData[i][k] = max;
											}
										}

										if (matData[0][j] <= max
												&& matData[rows - 1][j] <= max
												&& tempVmax <= max) {
											for (int k = 0; k < rows; k++) {
												floorData[k][j] = max;
											}
										}
									}

								}
							}
							max--;
						}

						for (int i = 0; i < rows; i++) {
							for (int j = 0; j < cols; j++) {
								System.out.print(floorData[i][j] + " ");
							}
							System.out.println();
						}
						for (int i = 0; i < rows; i++) {
							for (int j = 0; j < cols; j++) {
								if (matData[i][j] != floorData[i][j]) {
									status = false;
									break;
								}
							}
						}
						qcount++;
						System.out.println("**********" + status + "*********");
						if (status) {
							result.add("Case #" + qcount + ": YES");
						} else {
							result.add("Case #" + qcount + ": NO");
						}
						status = true;
						matData = null;
						rows = cols = tLine = 0;
					}

				}
			}
		}
		System.out.println(result);
		writeLargerTextFile(OUTPUT_FILE_NAME, result);
	}

	public void writeLargerTextFile(String aFileName, List<String> aLines)
			throws IOException {
		try {
			File file = new File(aFileName);
			// if file doesnt exists, then create it
			if (!file.exists()) {
				file.createNewFile();
			}
			FileWriter fw = new FileWriter(file.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			for (String string : aLines) {
				bw.write(string);
				bw.newLine();
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
