import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.sql.Timestamp;
import java.util.Arrays;
import java.util.Calendar;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.StringTokenizer;
import java.util.concurrent.atomic.AtomicInteger;

import org.apache.commons.lang3.ArrayUtils;

public class PROBLEMB {
	enum TYPE {
		LENGTH, INDEX
	}

	private static char[] poplast(char[] charVal) {

		while (charVal.length > 0 && charVal[charVal.length - 1] == '+') {
			charVal = Arrays.copyOfRange(charVal, 0, charVal.length - 1);
		}
		return charVal;
	}

	private static int frontMinus(char[] charVal) {
		int count = 0;
		for (int i = 0; i < charVal.length; i++) {
			if (charVal[i] == '-') {
				count++;
			} else {
				break;
			}
		}
		return count;
	}
	private static int frontPlus(char[] charVal) {
		int count = 0;
		for (int i = 0; i < charVal.length; i++) {
			if (charVal[i] == '+') {
				count++;
			} else {
				break;
			}
		}
		return count;
	}
	private static int firstfrontMinus(char[] charVal) {
		int count = 0;
		boolean enable =false;
		for (int i = 0; i < charVal.length; i++) {
			if (charVal[i] == '-') {
				enable = true;
				count++;
			} else if(enable) {
				break;
			}
		}
		return count;
	}
	private static int firstfrontPlus(char[] charVal) {
		int count = 0;
		boolean enable =false;
		for (int i = 0; i < charVal.length; i++) {
			if (charVal[i] == '+') {
				enable = true;
				count++;
			} else if(enable) {
				break;
			}
		}
		return count;
	}
	
	private static int frontChar(char[] charVal) {
		int count = 0;
		char c = charVal[0];
		for (int i = 0; i < charVal.length; i++) {
			if (charVal[i] == c) {
				count++;
			} else {
				break;
			}
		}
		return count;
	}

	private static int substringChk(char[] charVal, String c, TYPE t) {
		int substr = -1;
		String val = String.valueOf(charVal);
		StringTokenizer st = new StringTokenizer(val, c);
		String maxVal = null;
		while (st.hasMoreElements()) {
			String string = st.nextToken();
			if (maxVal == null || string.length() > maxVal.length()) {
				maxVal = string;
			}
		}
		if (maxVal != null) {
			if (t == TYPE.INDEX) {
				substr = val.indexOf(maxVal) + maxVal.length();
			} else {
				substr = maxVal.length();
			}

		}
		return substr;
	}

	private static void flipper(int till, char[] charVal) {
		for (int i = 0; i < ((till / 2) + (till % 2)); i++) {
			char a = charVal[i];
			char b = charVal[till - 1 - i];
			if (a == '+') {
				charVal[till - 1 - i] = '-';
			} else {
				charVal[till - 1 - i] = '+';
			}
			if (b == '+') {
				charVal[i] = '-';
			} else {
				charVal[i] = '+';
			}

		}
	}

	/**
	 * @param sc
	 * @param pw
	 */
	/**
	 * @param sc
	 * @param pw
	 */
	void solve(Scanner sc, PrintWriter pw) {
		String val = sc.next();
		//System.out.print(":"+val);
		char[] charVal = val.toCharArray();

		long count = 0;
		// 1. first - and last + pop last
		// 2. first + and last - : flip first and flip entire and pop last
		// 3. first - and last - : chk length of - in last and first : if first
		// >= last flip entire and pop last
		// 4. : if first < last , DO SUBSTRING of - ,
		// chk is +'s is more that first and last, then get the pst of max +'s
		// and flip upto that , and flip again and pop last
		// 5. else flip and pop out
		while (true) {
			if (charVal.length == 0) {
				break;
			}
			//System.out.println();
			//System.out.println("before  :" +count+" => "+ Arrays.asList(ArrayUtils.toObject(charVal)));
			charVal = poplast(charVal);
			//System.out.println("after  :" +count+" => "+ Arrays.asList(ArrayUtils.toObject(charVal)));
			int subStrPlus = substringChk(charVal, "-", TYPE.LENGTH);
			int subStrMinus = substringChk(charVal, "+", TYPE.LENGTH);
			int frontMinus = frontMinus(charVal);
			 //System.out.println("frontMinus:" + frontMinus + " subStrMinus:" +			 subStrMinus + " subStrPlus:" + subStrPlus);
			if (subStrMinus != -1 || subStrPlus != -1) {
				int frontPlus = frontPlus(charVal);
				int firstfrontMinus = firstfrontMinus(charVal);
				int firstfrontPlus = firstfrontPlus(charVal);
				
				//System.out.println("frontPlus:" + frontPlus + " firstfrontMinus:" +						firstfrontMinus+ "   firstfrontPlus:"+firstfrontPlus);
				if(charVal[charVal.length-1] == '-' &&  charVal[0] == '+'){
					flipper(frontPlus, charVal);
					count++;
					continue;
				}
				if(charVal[charVal.length-1] == '-' &&  charVal[0] == '-'){
					flipper(charVal.length, charVal);
					count++;
					continue;
				}
			}
			//System.out.println("end :" + Arrays.asList(ArrayUtils.toObject(charVal)));
			//break;
		}
		//if(val.length() <= count)
			System.out.println("val : "+val+" count: "+count);
		pw.println(count);
	}

	public static void main(String[] args) throws Exception {
		Scanner sc = new Scanner(new FileReader("/home/saranya/workspace/16/B-small-attempt6.in"));
		PrintWriter pw = new PrintWriter(new FileWriter("/home/saranya/workspace/16/B-small-attempt6.out"));
		int caseCnt = sc.nextInt();
		Timestamp t1 = new Timestamp(Calendar.getInstance().getTimeInMillis());
		System.out.println("t1: " + t1);
		for (int caseNum = 0; caseNum < caseCnt; caseNum++) {
			System.out.println("test case number " + (caseNum + 1));
	
			pw.print("Case #" + (caseNum + 1) + ": ");
			new PROBLEMB().solve(sc, pw);
		}
		Timestamp t2 = new Timestamp(Calendar.getInstance().getTimeInMillis());
		System.out.println("time : " + ((t2.getTime() - t1.getTime()) / 1000));
		pw.flush();
		pw.close();
		sc.close();
	}

}
