import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.nio.charset.Charset;
import java.nio.charset.StandardCharsets;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

public class PROBLEMA {
	final static String FILE_NAME = "C:\\CJ13\\Input\\A-large.in";
	final static String OUTPUT_FILE_NAME = "C:\\CJ13\\Output\\A-large.out";
	final static Charset ENCODING = StandardCharsets.UTF_8;
	static int limit = 0;

	public static void main(String args[]) throws IOException {
		PROBLEMA problema = new PROBLEMA();
		problema.readLargerTextFile(FILE_NAME);
	}

	public void readLargerTextFile(String aFileName) throws IOException {
		Path path = Paths.get(aFileName);
		Scanner scanner = new Scanner(path, ENCODING.name());
		int dataLine = 0;
		int qCount = 0;
		boolean flagT = false;
		boolean gameComp = true;
		LocT locT = null;
		char[][] matData = new char[4][4];
		ArrayList<String> result = new ArrayList<String>();
		while (scanner.hasNextLine()) {
			if (limit == 0) {
				limit = Integer.valueOf(scanner.nextLine());
				log(limit + "<-- limit ");
			} else {
				String testCase = scanner.nextLine();
				if (testCase.length() > 0) {
					if (matData == null) {
						matData = new char[4][4];
					}
					for (int i = 0; i < 4; i++) {
						matData[dataLine][i] = testCase.charAt(i);
						if (String.valueOf(testCase.charAt(i))
								.equalsIgnoreCase("T")) {
							flagT = true;
							locT = new LocT(dataLine, i);
						}
					}
					if (dataLine == 3) {
						qCount++;
						System.out.println("--> Ques " + qCount);
						for (int i = 0; i < matData.length; i++) {
							for (int j = 0; j < matData.length; j++) {
								System.out.print(matData[i][j]);
							}
							System.out.println();
						}
						for (int i = 0; i < matData.length; i++) {
							for (int j = 0; j < matData.length; j++) {
								if (matData[i][j] == '.') {
									gameComp = false;
									break;
								}
							}
						}
						boolean statusX = false;
						boolean statusO = false;

						if (flagT) {
							// test X with T
							statusX = testHVD(locT, matData, 'X', 'T');
							// test O with T
							statusO = testHVD(locT, matData, 'O', 'T');
							if (!statusX && !statusO) {
								boolean status = false;
								for (int i = 0; i < matData.length; i++) {
									locT = new LocT(i, i);
									// test X with T
									statusX = testHVD(locT, matData, 'X', 'X');
									// test O with T
									statusO = testHVD(locT, matData, 'O', 'O');
									if (statusX || statusO) {
										status = true;
										break;
									}
								}
							}

						} else {
							boolean status = false;
							for (int i = 0; i < matData.length; i++) {
								locT = new LocT(i, i);
								// test X with T
								statusX = testHVD(locT, matData, 'X', 'X');
								// test O with T
								statusO = testHVD(locT, matData, 'O', 'O');
								if (statusX || statusO) {
									status = true;
									break;
								}
								locT = new LocT(i, 3-i);
								// test X with T
								statusX = testHVD(locT, matData, 'X', 'X');
								// test O with T
								statusO = testHVD(locT, matData, 'O', 'O');
								if (statusX || statusO) {
									status = true;
									break;
								}
								
							}
						}

						if (statusX || statusO) {
							if (statusX) {
								// X won
								result.add("Case #" + qCount + ": X won");
								System.out.println("Case #" + qCount
										+ ": X won");

							} else {
								// O won
								result.add("Case #" + qCount + ": O won");
								System.out.println("Case #" + qCount
										+ ": O won");
							}
						} else if (!gameComp) {
							// Game has not completed
							result.add("Case #" + qCount
									+ ": Game has not completed");
							System.out.println("Case #" + qCount
									+ ": Game has not completed");
						} else {
							// Draw
							result.add("Case #" + qCount + ": Draw");
							System.out.println("Case #" + qCount + ": Draw");
						}
						System.out.println();
					}

					dataLine++;
					if (dataLine > 3) {
						matData = null;
						locT = null;
						flagT = false;
						gameComp = true;
						dataLine = 0;
					}
				}
			}
		}
		System.out.println(result);
		writeLargerTextFile(OUTPUT_FILE_NAME, result);
	}

	public void writeLargerTextFile(String aFileName, List<String> aLines)
			throws IOException {
		try {
			File file = new File(aFileName);
			// if file doesnt exists, then create it
			if (!file.exists()) {
				file.createNewFile();
			}
			FileWriter fw = new FileWriter(file.getAbsoluteFile());
			BufferedWriter bw = new BufferedWriter(fw);
			for (String string : aLines) {
				bw.write(string);
				bw.newLine();
			}
			bw.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	class LocT {
		int i, j;

		public LocT(int i, int j) {
			this.i = i;
			this.j = j;
		}
	}

	private static void log(Object aMsg) {
		System.out.println(String.valueOf(aMsg));
	}

	private boolean testHVD(LocT locT, char[][] matData, char testChar,
			char secChar) {
		boolean status = true;
		for (int i = 0; i < matData.length; i++) {
			if (matData[i][locT.j] != testChar && matData[i][locT.j] != secChar) {
				status = false;
				break;
			}
		}
		if (!status) {
			status = true;
			for (int j = 0; j < matData.length; j++) {
				if (matData[locT.i][j] != testChar
						&& matData[locT.i][j] != secChar) {
					status = false;
					break;
				}
			}
		}
		if (!status) {
			status = true;
			if (locT.i == locT.j) {
				for (int i = 0; i < matData.length; i++) {
					if (matData[i][i] != testChar && matData[i][i] != secChar) {
						status = false;
						break;
					}
				}
			} else if (locT.i + locT.j == 3) {
				for (int i = 0; i < matData.length; i++) {
					for (int j = matData.length - 1; j >= 0; j--) {
						if (matData[i][j] != testChar
								&& matData[i][j] != secChar) {
							status = false;
						}
						i++;
					}
				}
			} else {
				status = false;
			}
		}

		return status;
	}
}
