package google.codejam;

import org.junit.Test;

import java.util.*;

/**
 * Created by chetan on 4/9/2017.
 */
public class BathroomStalls implements CodeJamProblem {

    List<Depth> bucket;

    public String solution(String input) {
        bucket = new ArrayList<Depth>();
        String[] params = input.split("\\s+");
        Integer totalStalls = Integer.parseInt(params[0]);
        Integer totalPeople = Integer.parseInt(params[1]);
        Node tree = constructStalls(totalStalls);
        int digger = 1;
        Collections.sort(bucket, Collections.reverseOrder());
        for(Depth depth:bucket){
            if(digger == totalPeople){
                return depth.getMax()+" "+depth.getMin();
            }
            digger++;
        }
        return "0 0";
    }

    private Depth travel(Node head, Integer person){
        if(person == 1) {
            return head.getDepth();
        }
        return null;
    }

    int globalIndex = 1;
    private Node constructStalls(Integer totalStalls) {
        Node node = new Node();
        Depth currentDepth = getCurrentNodeDepth(totalStalls);
        node.setDepth(currentDepth);
        if (currentDepth.getMin() > 0)
            node.setLeft(constructStalls(currentDepth.getMin()));
        if (currentDepth.getMax() > 0)
            node.setRight(constructStalls(currentDepth.getMax()));

        currentDepth.setIndex(globalIndex++);
        bucket.add(currentDepth);
        return node;
    }

    private Depth getCurrentNodeDepth(Integer totalStalls) {
        Depth depth = new Depth();
        boolean even = isEven(totalStalls);
        Integer mid = getNextIndex(totalStalls, even);
        Integer children = totalStalls - mid;
        depth.setIndex(mid);
        depth.setMin(even ? children - 1 : children);
        depth.setMax(children);
        return depth;
    }

    private Integer getNextIndex(Integer totalStalls, boolean even) {
        Integer result = totalStalls / 2;
        if (even)
            return result;
        else
            return result + 1;
    }

    private boolean isEven(Integer totalStalls) {
        return totalStalls % 2 == 0 ? true : false;
    }

    class Node {

        private Depth depth;
        private Node left;
        private Node right;

        public Node() {
        }

        public Depth getDepth() {
            return depth;
        }

        public void setDepth(Depth depth) {
            this.depth = depth;
        }

        public Node getLeft() {
            return left;
        }

        public void setLeft(Node left) {
            this.left = left;
        }

        public Node getRight() {
            return right;
        }

        public void setRight(Node right) {
            this.right = right;
        }

        @Override
        public String toString() {
            return "Node{" +
                    "depth=" + depth +
                    ", left=" + left +
                    ", right=" + right +
                    '}';
        }
    }

    class Depth implements Comparable<Depth>{
        private Integer index;
        private Integer min;
        private Integer max;

        public Depth() {
        }

        public Integer getIndex() {
            return index;
        }

        public void setIndex(Integer index) {
            this.index = index;
        }

        public Integer getMin() {
            return min;
        }

        public void setMin(Integer min) {
            this.min = min;
        }

        public Integer getMax() {
            return max;
        }

        public void setMax(Integer max) {
            this.max = max;
        }

        @Override
        public boolean equals(Object o) {
            if (this == o) return true;
            if (o == null || getClass() != o.getClass()) return false;
            Depth depth = (Depth) o;
            return Objects.equals(index, depth.index) &&
                    Objects.equals(min, depth.min) &&
                    Objects.equals(max, depth.max);
        }

        @Override
        public int hashCode() {
            return Objects.hash(index, min, max);
        }

        @Override
        public String toString() {
            return "Depth{" +
                    "index=" + index +
                    ", min=" + min +
                    ", max=" + max +
                    '}';
        }

        @Override
        public int compareTo(Depth o) {
            int comparisionMin =  this.min.compareTo(o.min);
            return comparisionMin != 0 ? comparisionMin: this.max.compareTo(o.max);
        }
    }
}
