package codejam2010.round1a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;

public class NumberGame {
	int noOfTests;
	long a1,a2;
	long b1,b2;
	long ans;
	
	BufferedReader in;
	BufferedWriter out;
	
	public static void main(String[] args) throws Exception {
		new NumberGame(args[0]);
    }
	
	public NumberGame(String fn) throws Exception {
		in = new BufferedReader(new FileReader(fn+".in"));
		out = new BufferedWriter(new FileWriter(fn + ".out"));
		readInput();
		out.flush();
        out.close();
	}
	
	public void readInput() throws Exception {
        String line = null;
        line = in.readLine();
        noOfTests = Integer.parseInt(line.trim());
        
        for(int i=0; i<noOfTests; i++) {
            line = in.readLine();
            String[] parts = line.split(" ");
            a1 = Long.parseLong(parts[0].trim());
            a2 = Long.parseLong(parts[1].trim());
            b1 = Long.parseLong(parts[2].trim());
            b2 = Long.parseLong(parts[3].trim());
        	process();
        	writeOutput(i+1);
        }
    }
	
	public void writeOutput(long inputNumber) throws Exception {
        String str = String.format("Case #%s: %s\n", inputNumber, ans);
        out.write(str);
    }
	
	public void process() {
		ans = 0;
		for(long i=a1;i<=a2;i++)
			for(long j=b1;j<=b2;j++)
				if( sureWin(i, j))
					ans++;
	}
	
	public boolean sureWin(long a, long b) {
		if( a == b )
			return false;
		List<Long> list = new LinkedList<Long>();
		
		while( a != b ) {
			if( a < b ) {
				long temp;
				temp = a;
				a = b;
				b = temp;
			}
			
			if( a%b == 0 ) {
				list.add(1L);
				a = b = 1;
			} else {
				list.add(a/b);
				a = a%b;
			}
		}
		
		long ones = 0, nonOnes = 0;
		for (Iterator<Long> iterator = list.iterator(); iterator.hasNext();) {
			Long num = (Long) iterator.next();
			if( num == 1 )
				ones++;
			else
				nonOnes++;
		}
		
		if( ones % 2 == 1)
			return true;
		else {
			if(nonOnes > 0)
				return true;
			else
				return false;
		}
	}
}
