package gcj2014.qualification;


import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class MagicTrick {
	BufferedReader br;
	BufferedWriter bw;
	int noOfTestCases;
	int currentCase;
	
	int firstAns;
	int[][] firstArrangement;
	int secondAns;
	int[][] secondArrangement;
	String ans;
	
	public MagicTrick(String filename) throws Exception {
		br = new BufferedReader(new FileReader(filename));
		bw = new BufferedWriter(new FileWriter(filename + ".out"));
		
		noOfTestCases = Integer.parseInt(br.readLine());
		currentCase = 1;
		for(int i=0;i<noOfTestCases;i++) {
			readInput();
			process();
			writeOutput();
			currentCase++;
		}
		
		br.close();
		bw.flush();
		bw.close();
	}
	
	public void readInput() throws Exception {
		String[] strArr;
		
		String str = br.readLine();
		firstAns = Integer.parseInt(str);
		firstAns--;
		
		firstArrangement = new int[4][4];
		for(int i = 0; i < 4; i++) {
			str = br.readLine();
			strArr = str.split(" ");
			
			firstArrangement[i][0] = Integer.parseInt(strArr[0]);
			firstArrangement[i][1] = Integer.parseInt(strArr[1]);
			firstArrangement[i][2] = Integer.parseInt(strArr[2]);
			firstArrangement[i][3] = Integer.parseInt(strArr[3]);
		}
		
		str = br.readLine();
		secondAns = Integer.parseInt(str);
		secondAns--;
		
		secondArrangement = new int[4][4];
		for(int i = 0; i < 4; i++) {
			str = br.readLine();
			strArr = str.split(" ");
			
			secondArrangement[i][0] = Integer.parseInt(strArr[0]);
			secondArrangement[i][1] = Integer.parseInt(strArr[1]);
			secondArrangement[i][2] = Integer.parseInt(strArr[2]);
			secondArrangement[i][3] = Integer.parseInt(strArr[3]);
		}
	}
	
	public void process() {
		int common = 0;
		int firstArrangementColumn = -1;
		
		for(int i=0; i < 4; i++) {
			for(int j=0; j < 4; j++) {
				if(firstArrangement[firstAns][i] == secondArrangement[secondAns][j]) {
					common++;
					firstArrangementColumn = i;
				}
			}
		}
		
		if(common == 0) {
			ans = "Volunteer cheated!";
		} else if (common == 1) {
			ans = Integer.toString(firstArrangement[firstAns][firstArrangementColumn]);
		} else {
			ans = "Bad magician!";
		}
	}
	
	public void writeOutput() throws Exception {
		StringBuffer buf = new StringBuffer();
		buf.append("Case #").append(currentCase).append(": ");
		buf.append(ans);
		buf.append('\n');
		bw.write(buf.toString());
	}
	
	public static void main(String[] args) throws Exception {
		new MagicTrick("input/gcj2014/qualification/A-small-attempt0.in");
	}
}
