package codejam.year2013.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.math.BigDecimal;
import java.math.BigInteger;

public class FairAndSquare {
	BufferedReader br;
	BufferedWriter bw;
	int noOfTestCases;
	int currentCase;
	
	String llStr;
	String ulStr;
	BigInteger lowerLimit;
	BigInteger upperLimit;
	BigInteger ans;
	
	public FairAndSquare(String filename) throws Exception {
		br = new BufferedReader(new FileReader(filename));
		bw = new BufferedWriter(new FileWriter(filename + ".out"));
		
		noOfTestCases = Integer.parseInt(br.readLine());
		currentCase = 1;
		for(int i=0;i<noOfTestCases;i++) {
			readInput();
			process();
			writeOutput();
			currentCase++;
		}
		
		br.close();
		bw.flush();
		bw.close();
	}
	
	public void readInput() throws Exception {
		String str = br.readLine();
		String[] strArr = str.split(" ");
		llStr = strArr[0];
		lowerLimit = new BigInteger(strArr[0]);
		ulStr = strArr[1];
		upperLimit = new BigInteger(strArr[1]);
	}
	
	public void process() {
		ans = BigInteger.ZERO;
		
		int power = llStr.length() == 1 ? 0 : 
			(llStr.length() % 2 == 0 ? (llStr.length()/2) - 1 : (llStr.length()/2));
		BigInteger num = BigInteger.TEN.pow(power);
		
		while(true) {
			BigInteger square = num.pow(2);
			if(square.compareTo(upperLimit) > 0)
				break;
			else {
				if(square.compareTo(lowerLimit) >= 0 && isPalindrome(square)) {
					ans = ans.add(BigInteger.ONE);
				}
			}
			
			num = nextPalindrome(num);
		}
	}
	
	private BigInteger nextPalindrome(BigInteger par) {
		par = par.add(BigInteger.ONE);
		if(isPalindrome(par))
			return par;
		
		String parString = par.toString();
		int len = parString.length();
		
		if(len % 2 == 0) {
			String lhs = parString.substring(0, len/2);
			if(par.compareTo(new BigInteger(lhs + reverse(lhs))) > 0) {
				lhs = new BigInteger(lhs).add(BigInteger.ONE).toString();
			}
			
			return new BigInteger(lhs + reverse(lhs));
		} else {
			String lhsWithM = parString.substring(0, len/2+1);
			String lhs = lhsWithM.substring(0, lhsWithM.length()-1);
			
			if(par.compareTo(new BigInteger(lhsWithM + reverse(lhs))) > 0) {
				lhsWithM = new BigInteger(lhsWithM).add(BigInteger.ONE).toString();
				lhs = lhsWithM.substring(0, lhsWithM.length()-1);
			}
			
			return new BigInteger(lhsWithM + reverse(lhs));
		}
	}
	
	private String reverse(String str) {
		return new StringBuffer(str).reverse().toString();
	}
	
	private boolean isPalindrome(BigInteger par) {
		String str = par.toString();
		return str.equals(new StringBuffer(str).reverse().toString());
	}
	
	public void writeOutput() throws Exception {
		StringBuffer buf = new StringBuffer();
		buf.append("Case #").append(currentCase).append(": ");
		buf.append(ans.toString());
		buf.append('\n');
		bw.write(buf.toString());
	}
	
	public static void main(String[] args) throws Exception {
		FairAndSquare fas = new FairAndSquare("input/input.txt");
	}
}
