package codejam.year2013.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class TieTacToeTomek {
	BufferedReader br;
	BufferedWriter bw;
	int noOfTestCases;
	int currentCase;
	
	char[][] board;
	String ans;
	
	public TieTacToeTomek(String filename) throws Exception {
		br = new BufferedReader(new FileReader(filename));
		bw = new BufferedWriter(new FileWriter(filename + ".out"));
		
		noOfTestCases = Integer.parseInt(br.readLine());
		currentCase = 1;
		for(int i=0;i<noOfTestCases;i++) {
			readInput();
			process();
			writeOutput();
			currentCase++;
		}
		
		br.close();
		bw.flush();
		bw.close();
	}
	
	public void readInput() throws Exception {
		board = new char[4][4];
		for(int i=0;i<4;i++) {
			String str = br.readLine();
			for(int j=0;j<4;j++) {
				board[i][j] = str.charAt(j);
			}
		}
		br.readLine();
	}
	
	public void process() {
		for(int i=0;i<4;i++) {
			ans = checkRow(i);
			if(ans != null)
				return;
			
			ans = checkColumn(i);
			if(ans != null)
				return;
		}
		
		ans = checkPrincipalDiagonal();
		if(ans != null)
			 return;
		
		ans = checkOtherDiagonal();
		if(ans != null)
			return;
		
		for(int i=0;i<4;i++) {
			for(int j=0;j<4;j++) {
				if(board[i][j] == '.') {
					ans = "Game has not completed";
					return;
				}
			}
		}
		
		ans = "Draw";
	}
	
	private String checkOtherDiagonal() {
		return hasWon(board[3][0], board[2][1], board[1][2], board[0][3]);
	}
	
	private String checkPrincipalDiagonal() {
		return hasWon(board[0][0], board[1][1], board[2][2], board[3][3]);
	}
	
	private String checkRow(int row) {
		return hasWon(board[row][0], board[row][1], board[row][2], board[row][3]);
	}
	
	private String checkColumn(int column) {
		return hasWon(board[0][column], board[1][column], board[2][column], board[3][column]);
	}
	
	private String hasWon(char a, char b, char c, char d) {
		if(a == '.' || b == '.' || c == '.' || d == '.')
			return null;
		
		char ch = (a == 'T') ? b : a;
		if( (ch == a || a == 'T') &&
			(ch == b || b == 'T') &&
			(ch == c || c == 'T') &&
			(ch == d || d == 'T')) {
			return "" + ch + " won";
		}
		
		if(a == '.' || b == '.' || c == '.' || d == '.')
			return "Game has not completed";
		
		return null;
	}
	
	public void writeOutput() throws Exception {
		StringBuffer buf = new StringBuffer();
		buf.append("Case #").append(currentCase).append(": ");
		buf.append(ans);
		buf.append('\n');
		bw.write(buf.toString());
	}
	
	public static void main(String[] args) throws Exception {
		new TieTacToeTomek("input/A-small-attempt1.in");
	}

}
