import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class Rotate {
	int noOfTests;
	char[][] board;
	int n,k;
	String ans;
	boolean[][][] blueCache;
	boolean[][][] redCache;
	
	BufferedReader in;
	BufferedWriter out;
	
	public static void main(String[] args) throws Exception {
		new Rotate(args[0]);
    }
	
	public Rotate(String fn) throws Exception {
		in = new BufferedReader(new FileReader(fn+".in"));
		out = new BufferedWriter(new FileWriter(fn + ".out"));
		readInput();
		out.flush();
        out.close();
	}
	
	public void readInput() throws Exception {
        String line = null;
        line = in.readLine();
        noOfTests = Integer.parseInt(line.trim());
        
        for(int i=0; i<noOfTests; i++) {
            line = in.readLine();
            String[] parts = line.split(" ");
            n = Integer.parseInt(parts[0].trim());
            k = Integer.parseInt(parts[1].trim());
            board = new char[n][n];
            blueCache = new boolean[n][n][4];
            redCache = new boolean[n][n][4];
            
            for(int j=0;j<n;j++) {
            	line = in.readLine();
            	line = line.trim();
            	for(int k=0;k<n;k++) {
            		board[j][k] = line.charAt(k);
            	}
            }
            
        	process();
        	writeOutput(i+1);
        }
        
    }
	
	public void writeOutput(long inputNumber) throws Exception {
        String str = String.format("Case #%s: %s\n", inputNumber, ans);
        out.write(str);
    }
	
	public void process() {
		// Rotate
		char[][] temp = new char[n][n];
		for(int i=0;i<n;i++) {
			for(int j=0;j<n;j++) {
				temp[j][n-i-1] = board[i][j];
			}
		}
		board = temp;
		
		// Gravity
		for(int j=n-1;j>=0;j--) {
			int newIndex = n;
			for(int i=n-1;i>=0;i--) {
				if('.' != board[i][j]) {
					board[--newIndex][j] = board[i][j];
					if(newIndex != i)
						board[i][j] = '.';
				}
			}
		}
		
		// Right - Column increase
		// Left - Column decrease
		// Up - Row decrease
		// Down - Row increase
		// 0 - Horizontal
		// 1 - Vertical
		// 2 - LT to RB
		// 3 - LB to RT
		// Evaluate
		boolean blue = false;
		boolean red = false;
		for(int i=0;i<n && !(blue && red);i++) {
			for(int j=0;j<n && !(blue && red);j++) {
				char ch = board[i][j];
				boolean[][][] cache = null;
				if( 'R' == ch ) {
					if( red )
						continue;
					cache = redCache;
				} else if( 'B' == ch ) {
					if( blue )
						continue;
					cache = blueCache;
				} else {
					continue;
				}
				
				if( !cache[i][j][0] ) {
					int count=0;
					for(int col=j;col<n;col++) {
						cache[i][col][0] = true;
						if(board[i][col]!=ch) {
							break;
						} else {
							count++;
							if(count==k) {
								break;
							}
						}
					}
					if(count==k) {
						if('R' == ch) {
							red = true;
						} else {
							blue = true;
						}
					}
				}
				
				if( !cache[i][j][1] ) {
					int count=0;
					for(int row=i;row<n;row++) {
						cache[row][j][1] = true;
						if(board[row][j]!=ch) {
							break;
						} else {
							count++;
							if(count==k) {
								break;
							}
						}
					}
					if(count==k) {
						if('R' == ch) {
							red = true;
						} else {
							blue = true;
						}
					}
				}
				
				if( !cache[i][j][2] ) {
					int count=0;
					for(int row=i, col=j;row<n&&col<n;row++,col++) {
						cache[row][col][2] = true;
						if(board[row][col]!=ch) {
							break;
						} else {
							count++;
							if(count==k) {
								break;
							}
						}
					}
					if(count==k) {
						if('R' == ch) {
							red = true;
						} else {
							blue = true;
						}
					}
				}
				
				if( !cache[i][j][3] ) {
					int count=0;
					for(int row=i, col=j;row<n&&col>=0;row++,col--) {
						cache[row][col][3] = true;
						if(board[row][col]!=ch) {
							break;
						} else {
							count++;
							if(count==k) {
								break;
							}
						}
					}
					if(count==k) {
						if('R' == ch) {
							red = true;
						} else {
							blue = true;
						}
					}
				}
			}
		}
		
		if( !red && !blue ) {
			ans = "Neither";
		} else if( red && blue )
			ans = "Both";
		else if(red)
			ans = "Red";
		else
			ans = "Blue";
	}
}
