package gcj2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.nio.file.Files;
import java.nio.file.Paths;
import java.util.stream.Stream;

public class OversizedPancakeFlipper {
	int n, k; 
	boolean[] pcs;
	
	void process(String filename) throws Exception {
		
		BufferedReader br = Files.newBufferedReader(Paths.get(filename));
		BufferedWriter bw = Files.newBufferedWriter(Paths.get(filename + ".out"));
		n = Integer.parseInt(br.readLine());
		
		for(int i = 0; i < n; i++) {
			String[] parts = br.readLine().split(" ");
			getPcs(parts[0]);
			k = Integer.parseInt(parts[1]);
			
			int count = 0;
			int ind = 0;
			
			while(true) {
				for(;ind < pcs.length && pcs[ind];ind++);
				
				if(ind + k > pcs.length) {
					break;
				}
				
				int j = ind;
				for(; j < ind + k; j++)
					pcs[j] = !pcs[j];
				count++;
				ind++;
				
				if(j == pcs.length)
					break;
			}
				
			boolean allHappy = true;
			for(boolean pc : pcs)
				allHappy = allHappy && pc;
			
			bw.write("Case #" + (i+1) + ": ");
			if(!allHappy)
				bw.write("IMPOSSIBLE\n");
			else
				bw.write(count + "\n");
		}
		
		br.close();
		bw.close();
	}
	
	void getPcs(String str) {
		pcs = new boolean[str.length()];
		for(int i = 0; i < str.length(); i++)
			pcs[i] = str.charAt(i) == '+';
	}
	
	public static void main(String[] args) throws Exception {
		new OversizedPancakeFlipper().process("IO/A-large.in");
	}
}
