import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashSet;
import java.util.Set;

public class FileFixIt {
	int noOfTests;
	Set<String> directories;
	long ans;
	int existCount, tobeCreatedCount;
	
	BufferedReader in;
	BufferedWriter out;
	
	public static void main(String[] args) throws Exception {
		new FileFixIt(args[0]);
    }
	
	public FileFixIt(String fn) throws Exception {
		in = new BufferedReader(new FileReader(fn+".in"));
		out = new BufferedWriter(new FileWriter(fn + ".out"));
		readInput();
		out.flush();
        out.close();
	}
	
	public void readInput() throws Exception {
        String line = null;
        line = in.readLine();
        noOfTests = Integer.parseInt(line.trim());
        
        for(int i=0; i<noOfTests; i++) {
            line = in.readLine();
            String[] parts = line.split(" ");
            existCount = Integer.parseInt(parts[0].trim());
            tobeCreatedCount = Integer.parseInt(parts[1].trim());
            directories = new HashSet<String>();
            ans = 0;
            
            for(int j=0;j<existCount;j++) {
            	line = in.readLine().trim();
            	int index = 0;
            	while( (index = line.indexOf('/', index +1)) != -1 ) {
            		directories.add(line.substring(0, index));
            	}
            	directories.add(line);
            }
            
            for(int j=0;j<tobeCreatedCount;j++) {
            	line = in.readLine().trim();
            	int index = 0;
            	while( (index = line.indexOf('/', index +1)) != -1 ) {
            		String subDir = line.substring(0, index);
            		if( !directories.contains(subDir) ) {
            			directories.add(subDir);
            			ans++;
            		}
            	}
            	
            	if( !directories.contains(line) ) {
            		directories.add(line);
        			ans++;
            	}
            }
            
        	writeOutput(i+1);
        }
    }
	
	public void writeOutput(long inputNumber) throws Exception {
        String str = String.format("Case #%s: %s\n", inputNumber, ans);
        out.write(str);
    }
}
