import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;


public class CountingSheep {
	static int _0BIT = 1;
	static int _1BIT = 1 << 1;
	static int _2BIT = 1 << 2;
	static int _3BIT = 1 << 3;
	static int _4BIT = 1 << 4;
	static int _5BIT = 1 << 5;
	static int _6BIT = 1 << 6;
	static int _7BIT = 1 << 7;
	static int _8BIT = 1 << 8;
	static int _9BIT = 1 << 9;
	static int _ALLBITS = _0BIT + _1BIT + _2BIT + _3BIT + _4BIT
			+ _5BIT + _6BIT + _7BIT + _8BIT + _9BIT;
	
	long cases;
	long input;
	String ans;
	
	public int getBitMask(char c) {
		switch(c) {
			case '0' :
				return _0BIT;
			case '1' :
				return _1BIT;
			case '2' :
				return _2BIT;
			case '3' :
				return _3BIT;
			case '4' :
				return _4BIT;
			case '5' :
				return _5BIT;
			case '6' :
				return _6BIT;
			case '7' :
				return _7BIT;
			case '8' :
				return _8BIT;
			case '9' :
				return _9BIT;
		}

		throw new IllegalArgumentException("" + c);
	}
	
	public static void main(String[] args) throws Exception {
		new CountingSheep().solveAndWrite("IO/ProbA/A-small-attempt0.in");
	}
	
	public void solveAndWrite(String inputFile) throws Exception {
		BufferedReader reader = new BufferedReader(new FileReader(inputFile));
		BufferedWriter writer = new BufferedWriter(new FileWriter(inputFile + ".out"));
		
		cases = Long.parseLong(reader.readLine());
		for(int i = 0; i < cases; i++) {
			input = Long.parseLong(reader.readLine());
			solve();
			
			writer.write("Case #" + (i+1) + ": " + ans + "\n");
		}
		
		reader.close();
		writer.close();
	}
	
	public void solve() {
		int bits = 0;
		
		for(int i = 1; i <= 1000; i++) {
			String numStr = Long.toString(i * input);
			
			for(int j = 0; j < numStr.length(); j++) {
				bits = bits | getBitMask(numStr.charAt(j));
			}
			
			if(bits == _ALLBITS) {
				ans = numStr;
				return;
			}
		}
		
		ans = "INSOMNIA";
	}
}
