import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Set;

public class RopeIntranet {
	int noOfTests;
	int noOfRopess;
	List<Rope> ropes;
	long ans;
	
	BufferedReader in;
	BufferedWriter out;
	
	public static void main(String[] args) throws Exception {
		new RopeIntranet(args[0]);
    }
	
	public RopeIntranet(String fn) throws Exception {
		in = new BufferedReader(new FileReader(fn+".in"));
		out = new BufferedWriter(new FileWriter(fn + ".out"));
		readInput();
		out.flush();
        out.close();
	}
	
	public void readInput() throws Exception {
        String line = null;
        line = in.readLine();
        noOfTests = Integer.parseInt(line.trim());
        
        for(int i=0; i<noOfTests; i++) {
            line = in.readLine().trim();
            noOfRopess = Integer.parseInt(line);
            ropes = new ArrayList<Rope>(noOfRopess);
            
            for(int j=0;j<noOfRopess;j++) {
            	line = in.readLine();
            	String[] parts = line.split(" ");
            	
            	Rope temp = new Rope();
            	temp.leftHeight = Long.parseLong(parts[0].trim());
            	temp.rightHeight = Long.parseLong(parts[1].trim());
            	ropes.add(temp);
            }
            
            Collections.sort(ropes);
            ans = 0;
            for(int j=0;j<ropes.size();j++) {
            	Rope rope = ropes.get(j);
            	for(int k=j+1;k<ropes.size();k++) {
            		if( rope.rightHeight > ropes.get(k).rightHeight )
            			ans++;
            	}
            }
            
        	writeOutput(i+1);
        }
    }
	
	public void writeOutput(long inputNumber) throws Exception {
        String str = String.format("Case #%s: %s\n", inputNumber, ans);
        out.write(str);
    }
	
	public static class Rope implements Comparable<Rope> {
		long leftHeight;
		long rightHeight;
		Set<Rope> rightBelowRopes = new HashSet<Rope>();
		
		public int compareTo(Rope rope) {
			if( this.leftHeight < rope.leftHeight )
				return -1;
			else if (this.leftHeight == rope.leftHeight )
				return 0;
			else
				return 1;
		}
	}
}
