import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class YourRankIsPure {
	int noOfTests;
	long[][] nCr;
	long[][] cache;
	long[] noOfSets;
	long ans;
	
	BufferedReader in;
	BufferedWriter out;
	
	public static void main(String[] args) throws Exception {
		new YourRankIsPure(args[0]);
    }
	
	public void initialize() {
		nCr = new long[501][501];
		nCr[0][0] = 1;
		nCr[1][0] = 1;
		nCr[1][1] = 1;
		nCr[1][2] = 0;
		for(int i=2;i<501;i++) {
			nCr[i][0] = 1;
			for(int j=1;j<=i;j++) {
				nCr[i][j] = nCr[i-1][j] + nCr[i-1][j-1];
			}
			if( i != 500 ) {
				nCr[i][i+1] = 0;
			}
		}
		
		cache = new long[501][501];
		noOfSets = new long[501];
		
		cache[2][1] = 1;
		noOfSets[2] = 1;
		
		for(int i=3;i<501;i++) {
			cache[i][1] = 1;
			cache[i][i-1] = 1;
			
			for(int j=i-2;j>1;j--) {
				long temp = 0;
				int choice = (i-j-1);
				int toBeSelected = 0;
				
				int newRow = j;
				int newCol = j-1;
				
				for(;toBeSelected<=choice&&newCol>=1;toBeSelected++,newCol--) {
					temp = (temp + (nCr[choice][toBeSelected]*cache[newRow][newCol]) ) % 100003;
				}
				
				cache[i][j] = temp;
			}
			
			noOfSets[i] = 0;
			for(int j=1;j<i;j++) {
				noOfSets[i] = (noOfSets[i] + cache[i][j]) % 100003;
			}
		}
	}
	
	public YourRankIsPure(String fn) throws Exception {
		initialize();
		
		in = new BufferedReader(new FileReader(fn+".in"));
		out = new BufferedWriter(new FileWriter(fn + ".out"));
		readInput();
		out.flush();
        out.close();
	}
	
	public void readInput() throws Exception {
        String line = null;
        line = in.readLine();
        noOfTests = Integer.parseInt(line.trim());
        
        for(int i=0; i<noOfTests; i++) {
            line = in.readLine().trim();
            int num = Integer.parseInt(line);
            
            ans = noOfSets[num];
        	writeOutput((i+1));
        }
    }
	
	public void writeOutput(long inputNumber) throws Exception {
        String str = String.format("Case #%s: %s\n", inputNumber, noOfSets);
        out.write(str);
    }
}
