package gcj2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.nio.file.Files;
import java.nio.file.Paths;

public class BathroomStalls {
	int tcCount;
	
	void process(String filename) throws Exception {
		
		BufferedReader br = Files.newBufferedReader(Paths.get(filename));
		BufferedWriter bw = Files.newBufferedWriter(Paths.get(filename + ".out"));
		tcCount = Integer.parseInt(br.readLine());
		
		for(int i = 0; i < tcCount; i++) {
			String[] parts = br.readLine().split(" ");
			long n = Long.parseLong(parts[0]);
			long k = Long.parseLong(parts[1]);
			
			long max = 0, min = 0;
			MyArray myArray = new MyArray();
			myArray.insert(n, 1);
			long count = 1;
			
			while(count <= k) {
				long highestCount = myArray.peakHighestCount();
				long highest = myArray.getAllHighest();
				if(highest == 0)
					throw new IllegalStateException();
				long left = highest - 1;
				
				if(left % 2 == 0) {
					max = min = left / 2;
				} else {
					min = left / 2;
					max = min + 1;
				}
				myArray.insert(max, highestCount);
				myArray.insert(min, highestCount);
				count = count + highestCount;
				
				if(max == 0) {
					break;
				}
			}

			bw.write("Case #" + (i+1) + ": " + max + " " + min + "\n");
		}
		
		br.close();
		bw.close();
	}
	
	private static final class MyArray {
		int si = -1, ei = -1;
		long[] elements = new long[150];
		long[] counts = new long[150];
		
		public void insert(long n, long count) {
			if(n == 0)
				return;
			
			if(si == -1) {
				si++; ei++;
				elements[ei] = n;
				counts[ei] = count;
				return;
			}
			
			if(elements[ei] == n) {
				counts[ei] = counts[ei] + count;
			} else if(ei > 0 && elements[ei - 1] == n) {
				counts[ei - 1] = counts[ei - 1] + count;
			} else {
				ei++;
				elements[ei] = n;
				counts[ei] = count;
			}
		}
		
		public long peakHighestCount() {
			return counts[si];
		}
		
		public long getAllHighest() {
			long highest = elements[si];
			counts[si] = 0;
			si++;
			return highest;
		}
	}
	
	public static void main(String[] args) throws Exception {
//		new BathroomStalls().process("IO/BathroomStalls/test.in");
		new BathroomStalls().process("IO/BathroomStalls/C-large.in");
	}
}
