package codejam2012.qualifier;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class SpeakingInTongues {
	
	private int noOfCases;
	private int currentCase;
	private BufferedReader reader;
	private BufferedWriter writer;
	
	String str;
	StringBuilder engStr;
	
	public static void main(String[] args) throws Exception {
		new SpeakingInTongues().solveProblem("input/2012Qualifier/A-small-attempt0.in.txt", "input/2012Qualifier/A-small-attempt0.out.txt");
	}
	
	private char getEnglishChar(char engChar) {
		switch(engChar) {
			case 'y' : return 'a';
			case 'n' : return 'b';
			case 'f' : return 'c';
			case 'i' : return 'd';
			case 'c' : return 'e';
			case 'w' : return 'f';
			case 'l' : return 'g';
			case 'b' : return 'h';
			case 'k' : return 'i';
			case 'u' : return 'j';
			case 'o' : return 'k';
			case 'm' : return 'l';
			case 'x' : return 'm';
			case 's' : return 'n';
			case 'e' : return 'o';
			case 'v' : return 'p';
			case 'z' : return 'q';
			case 'p' : return 'r';
			case 'd' : return 's';
			case 'r' : return 't';
			case 'j' : return 'u';
			case 'g' : return 'v';
			case 't' : return 'w';
			case 'h' : return 'x';
			case 'a' : return 'y';
			case 'q' : return 'z';
			case ' ' : return ' ';
			default : return ' ';
		}
	}
	
	private void solveProblem(String inputFileName, String outputFileName) throws Exception {
		reader = new BufferedReader(new FileReader(inputFileName));
		writer = new BufferedWriter(new FileWriter(outputFileName));
		
		try {
			String str = reader.readLine();
			noOfCases = Integer.parseInt(str);
			currentCase = 0;
			
			for(int i=0;i<noOfCases;i++) {
				readInput();
				process();
				writeOutput();
			}
		} finally {
			reader.close();
			writer.flush();
			writer.close();
		}
	}
	
	private void process() throws Exception {
		engStr = new StringBuilder();
		for(int i=0;i < str.length();i ++) {
			engStr.append(getEnglishChar(str.charAt(i)));
		}
	}
	
	private void readInput() throws Exception {
		currentCase++;
		str = reader.readLine();
	}
	
	private void writeOutput() throws Exception {
		writer.write("Case #" + currentCase + ": ");
		writer.write(engStr.toString());
		writer.write("\n");
	}
}
