package codejam.year2013.qualification;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

public class Lawnmover {
	BufferedReader br;
	BufferedWriter bw;
	int noOfTestCases;
	int currentCase;
	int[][] lawn;
	boolean possible;
	
	public Lawnmover(String filename) throws Exception {
		br = new BufferedReader(new FileReader(filename));
		bw = new BufferedWriter(new FileWriter(filename + ".out"));
		
		noOfTestCases = Integer.parseInt(br.readLine());
		currentCase = 1;
		for(int i=0;i<noOfTestCases;i++) {
			readInput();
			process();
			writeOutput();
			currentCase++;
		}
		
		br.close();
		bw.flush();
		bw.close();
	}
	
	public void readInput() throws Exception {
		String str = br.readLine();
		String[] strArr = str.split(" ");
		int m = Integer.parseInt(strArr[0]);
		int n = Integer.parseInt(strArr[1]);
		lawn = new int[m][n];
		
		for(int i=0;i<m;i++) {
			str = br.readLine();
			strArr = str.split(" ");
			for(int j=0;j<n;j++) {
				lawn[i][j] = Integer.parseInt(strArr[j]);
			}
		}
	}
	
	public void process() {
		possible = true;
		for(int i=0;i<lawn.length;i++) {
			for(int j=0;j<lawn[0].length;j++) {
				boolean hPossible = (lawn[i][j] >= lawn[i][0]) && (lawn[i][j] >= lawn[i][lawn[0].length-1]);
				if(hPossible) {
					for(int k=0;k<lawn[0].length;k++) {
						hPossible = lawn[i][j] >= lawn[i][k];
						if(!hPossible)
							break;
					}
				}
				
				boolean vPossible = (lawn[i][j] >= lawn[0][j]) && (lawn[i][j] >= lawn[lawn.length-1][j]);
				if(vPossible) {
					for(int k=0;k<lawn.length;k++) {
						vPossible = lawn[i][j] >= lawn[k][j];
						if(!vPossible)
							break;
					}
				}
				possible = hPossible || vPossible;
				if(!possible)
					return;
			}
		}
	}
	
	public void writeOutput() throws Exception {
		StringBuffer buf = new StringBuffer();
		buf.append("Case #").append(currentCase).append(": ");
		String ans = possible ? "YES" : "NO";
		buf.append(ans);
		
		buf.append('\n');
		bw.write(buf.toString());
	}
	
	public static void main(String[] args) throws Exception {
		new Lawnmover("input/B-large.in");
	}

}
