package ominous;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;

/**
 * Created by cheto on 4/11/2015.
 */
public class Ominous {
    public static final String GABRIEL = "GABRIEL";
    public static final String RICHARD = "RICHARD";
    static BufferedReader reader;
    static BufferedWriter writer;
    public static void main(String[] args) throws Exception{
        reader = new BufferedReader(new FileReader(args[0]));
        writer = new BufferedWriter(new FileWriter(args[0].substring(0, args[0].length() - 2) + "out"));
        int testCases = Integer.parseInt(reader.readLine());
        System.out.println("Test cases: "+testCases);
        for (int test = 0; test < testCases; test++) {
            String[] splitLine = reader.readLine().split(" ");
            int X = Integer.parseInt(splitLine[0]);
            int R = Integer.parseInt(splitLine[1]);
            int C = Integer.parseInt(splitLine[2]);
            if(     (X > 6) ||              // When it is greater than 6 it could simply roll like a cinnamon to let a isolate square in the middle
                    ((R * C) % X != 0) ||   // When R + C is not a multiple of X, Richard will always win.
                    (Math.ceil(X/2.0) > R) || // When it can make that the figure always get off the grid from R
                    (Math.ceil(X/2.0) > C)    // When it can make that the figure always get off the grid from C
                    ){
                printCase(RICHARD,test);
                continue;
            }

            if(X > R) {
                if (checkDivision(X, R, C)) {
                    printCase(RICHARD,test);
                    continue;
                }
            }
            if(X > C){
                if (checkDivision(X, C, R)) {
                    printCase(RICHARD,test);
                    continue;
                }
            }
            printCase(GABRIEL, test);
        }
        reader.close();
        writer.flush();
        writer.close();
    }

    public static boolean checkDivision(int X, int fulled, int trying){
        int left = X - fulled;
        int moveToTrying = (int)Math.ceil(((left+1.0)) / 2);
        int verificationMovement = (int)Math.ceil((trying - (left+1.0)) / 2);
        for (int i = 0; i < fulled - 1; i++) {
            for (int j = 1; j < moveToTrying; j++) {
                for (int k = 0; k < verificationMovement; k++) {
                    int downArea = ((fulled - (i+1))*j) + (k * fulled);
                    int upArea = ((fulled - (i+1))*(left-j)) + (((trying-(left+1))-k)*fulled);
                    if((downArea % X == 0) && (upArea % X == 0)){
                        break;
                    }
                }
                return true;
            }
        }
        return false;
    }

    public static void printCase(String winner, int test) throws Exception{
        writer.write("Case #"+(test+1)+": "+winner+"\n");
    }
}
