package gt.impower.jam.sixteen.qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class Jamcoins {
	static Writer output;
	
	List<BigInteger> primes = new ArrayList<BigInteger>();
	
	public Jamcoins() {
		this.initPrimes();
	}
	
	private void initPrimes() {
		primes.add(new BigInteger("3"));
		primes.add(new BigInteger("5"));
		primes.add(new BigInteger("7"));
		primes.add(new BigInteger("11"));
		primes.add(new BigInteger("13"));
		primes.add(new BigInteger("17"));
		primes.add(new BigInteger("19"));
		primes.add(new BigInteger("23"));
		primes.add(new BigInteger("29"));
		primes.add(new BigInteger("31"));
		primes.add(new BigInteger("37"));
		primes.add(new BigInteger("41"));
		primes.add(new BigInteger("43"));
		primes.add(new BigInteger("47"));
		primes.add(new BigInteger("53"));
		primes.add(new BigInteger("59"));
		primes.add(new BigInteger("61"));
		primes.add(new BigInteger("67"));
		primes.add(new BigInteger("71"));
		primes.add(new BigInteger("73"));
		primes.add(new BigInteger("79"));
		primes.add(new BigInteger("83"));
		primes.add(new BigInteger("89"));
		primes.add(new BigInteger("97"));
		primes.add(new BigInteger("101"));
		primes.add(new BigInteger("103"));
		primes.add(new BigInteger("107"));
		primes.add(new BigInteger("109"));
		primes.add(new BigInteger("113"));
		primes.add(new BigInteger("127"));
		primes.add(new BigInteger("131"));
		primes.add(new BigInteger("137"));
		primes.add(new BigInteger("139"));
		primes.add(new BigInteger("149"));
		primes.add(new BigInteger("151"));
		primes.add(new BigInteger("157"));
		primes.add(new BigInteger("163"));
		primes.add(new BigInteger("167"));
		primes.add(new BigInteger("173"));
		primes.add(new BigInteger("179"));
		primes.add(new BigInteger("181"));
		primes.add(new BigInteger("191"));
		primes.add(new BigInteger("193"));
		primes.add(new BigInteger("197"));
		primes.add(new BigInteger("199"));
		primes.add(new BigInteger("211"));
		primes.add(new BigInteger("223"));
		primes.add(new BigInteger("227"));
		primes.add(new BigInteger("229"));
		primes.add(new BigInteger("233"));
		primes.add(new BigInteger("239"));
		primes.add(new BigInteger("241"));
		primes.add(new BigInteger("251"));
		primes.add(new BigInteger("257"));
		primes.add(new BigInteger("263"));
		primes.add(new BigInteger("269"));
		primes.add(new BigInteger("271"));
		primes.add(new BigInteger("277"));
		primes.add(new BigInteger("281"));
		primes.add(new BigInteger("283"));
		primes.add(new BigInteger("293"));
		primes.add(new BigInteger("307"));
		primes.add(new BigInteger("311"));
		primes.add(new BigInteger("313"));
		primes.add(new BigInteger("317"));
		primes.add(new BigInteger("331"));
		primes.add(new BigInteger("337"));
		primes.add(new BigInteger("347"));
		primes.add(new BigInteger("349"));
		primes.add(new BigInteger("353"));
		primes.add(new BigInteger("359"));
		primes.add(new BigInteger("367"));
		primes.add(new BigInteger("373"));
		primes.add(new BigInteger("379"));
		primes.add(new BigInteger("383"));
		primes.add(new BigInteger("389"));
		primes.add(new BigInteger("397"));
		primes.add(new BigInteger("401"));
		primes.add(new BigInteger("409"));
		primes.add(new BigInteger("419"));
		primes.add(new BigInteger("421"));
		primes.add(new BigInteger("431"));
		primes.add(new BigInteger("433"));
		primes.add(new BigInteger("439"));
		primes.add(new BigInteger("443"));
		primes.add(new BigInteger("449"));
		primes.add(new BigInteger("457"));
		primes.add(new BigInteger("461"));
		primes.add(new BigInteger("463"));
		primes.add(new BigInteger("467"));
		primes.add(new BigInteger("479"));
		primes.add(new BigInteger("487"));
		primes.add(new BigInteger("491"));
		primes.add(new BigInteger("499"));
		primes.add(new BigInteger("503"));
		primes.add(new BigInteger("509"));
		primes.add(new BigInteger("521"));
		primes.add(new BigInteger("523"));
		primes.add(new BigInteger("541"));
		primes.add(new BigInteger("547"));
		primes.add(new BigInteger("557"));
		primes.add(new BigInteger("563"));
		primes.add(new BigInteger("569"));
		primes.add(new BigInteger("571"));
		primes.add(new BigInteger("577"));
		primes.add(new BigInteger("587"));
		primes.add(new BigInteger("593"));
		primes.add(new BigInteger("599"));
		primes.add(new BigInteger("601"));
		primes.add(new BigInteger("607"));
		primes.add(new BigInteger("613"));
		primes.add(new BigInteger("617"));
		primes.add(new BigInteger("619"));
		primes.add(new BigInteger("631"));
		primes.add(new BigInteger("641"));
		primes.add(new BigInteger("643"));
		primes.add(new BigInteger("647"));
		primes.add(new BigInteger("653"));
		primes.add(new BigInteger("659"));
		primes.add(new BigInteger("661"));
		primes.add(new BigInteger("673"));
		primes.add(new BigInteger("677"));
		primes.add(new BigInteger("683"));
		primes.add(new BigInteger("691"));
		primes.add(new BigInteger("701"));
		primes.add(new BigInteger("709"));
		primes.add(new BigInteger("719"));
		primes.add(new BigInteger("727"));
		primes.add(new BigInteger("733"));
		primes.add(new BigInteger("739"));
		primes.add(new BigInteger("743"));
		primes.add(new BigInteger("751"));
		primes.add(new BigInteger("757"));
		primes.add(new BigInteger("761"));
		primes.add(new BigInteger("769"));
		primes.add(new BigInteger("773"));
		primes.add(new BigInteger("787"));
		primes.add(new BigInteger("797"));
		primes.add(new BigInteger("809"));
		primes.add(new BigInteger("811"));
		primes.add(new BigInteger("821"));
		primes.add(new BigInteger("823"));
		primes.add(new BigInteger("827"));
		primes.add(new BigInteger("829"));
		primes.add(new BigInteger("839"));
		primes.add(new BigInteger("853"));
		primes.add(new BigInteger("857"));
		primes.add(new BigInteger("859"));
		primes.add(new BigInteger("863"));
		primes.add(new BigInteger("877"));
		primes.add(new BigInteger("881"));
		primes.add(new BigInteger("883"));
		primes.add(new BigInteger("887"));
		primes.add(new BigInteger("907"));
		primes.add(new BigInteger("911"));
		primes.add(new BigInteger("919"));
		primes.add(new BigInteger("929"));
		primes.add(new BigInteger("937"));
		primes.add(new BigInteger("941"));
		primes.add(new BigInteger("947"));
		primes.add(new BigInteger("953"));
		primes.add(new BigInteger("967"));
		primes.add(new BigInteger("971"));
		primes.add(new BigInteger("977"));
		primes.add(new BigInteger("983"));
		primes.add(new BigInteger("991"));
		primes.add(new BigInteger("997"));
		primes.add(new BigInteger("1009"));
		primes.add(new BigInteger("1013"));
		primes.add(new BigInteger("1019"));
		primes.add(new BigInteger("1021"));
		primes.add(new BigInteger("1031"));
		primes.add(new BigInteger("1033"));
		primes.add(new BigInteger("1039"));
		primes.add(new BigInteger("1049"));
		primes.add(new BigInteger("1051"));
		primes.add(new BigInteger("1061"));
		primes.add(new BigInteger("1063"));
		primes.add(new BigInteger("1069"));
		primes.add(new BigInteger("1087"));
		primes.add(new BigInteger("1091"));
		primes.add(new BigInteger("1093"));
		primes.add(new BigInteger("1097"));
		primes.add(new BigInteger("1103"));
		primes.add(new BigInteger("1109"));
		primes.add(new BigInteger("1117"));
		primes.add(new BigInteger("1123"));
		primes.add(new BigInteger("1129"));
		primes.add(new BigInteger("1151"));
		primes.add(new BigInteger("1153"));
		primes.add(new BigInteger("1163"));
		primes.add(new BigInteger("1171"));
		primes.add(new BigInteger("1181"));
		primes.add(new BigInteger("1187"));
		primes.add(new BigInteger("1193"));
		primes.add(new BigInteger("1201"));
		primes.add(new BigInteger("1213"));
		primes.add(new BigInteger("1217"));
		primes.add(new BigInteger("1223"));
		primes.add(new BigInteger("1229"));
		primes.add(new BigInteger("1231"));
		primes.add(new BigInteger("1237"));
		primes.add(new BigInteger("1249"));
		primes.add(new BigInteger("1259"));
		primes.add(new BigInteger("1277"));
		primes.add(new BigInteger("1279"));
		primes.add(new BigInteger("1283"));
		primes.add(new BigInteger("1289"));
		primes.add(new BigInteger("1291"));
		primes.add(new BigInteger("1297"));
		primes.add(new BigInteger("1301"));
		primes.add(new BigInteger("1303"));
		primes.add(new BigInteger("1307"));
		primes.add(new BigInteger("1319"));
		primes.add(new BigInteger("1321"));
		primes.add(new BigInteger("1327"));
		primes.add(new BigInteger("1361"));
		primes.add(new BigInteger("1367"));
		primes.add(new BigInteger("1373"));
		primes.add(new BigInteger("1381"));
		primes.add(new BigInteger("1399"));
		primes.add(new BigInteger("1409"));
		primes.add(new BigInteger("1423"));
		primes.add(new BigInteger("1427"));
		primes.add(new BigInteger("1429"));
		primes.add(new BigInteger("1433"));
		primes.add(new BigInteger("1439"));
		primes.add(new BigInteger("1447"));
		primes.add(new BigInteger("1451"));
		primes.add(new BigInteger("1453"));
		primes.add(new BigInteger("1459"));
		primes.add(new BigInteger("1471"));
		primes.add(new BigInteger("1481"));
		primes.add(new BigInteger("1483"));
		primes.add(new BigInteger("1487"));
		primes.add(new BigInteger("1489"));
		primes.add(new BigInteger("1493"));
		primes.add(new BigInteger("1499"));
		primes.add(new BigInteger("1511"));
		primes.add(new BigInteger("1523"));
		primes.add(new BigInteger("1531"));
		primes.add(new BigInteger("1543"));
		primes.add(new BigInteger("1549"));
		primes.add(new BigInteger("1553"));
		primes.add(new BigInteger("1559"));
		primes.add(new BigInteger("1567"));
		primes.add(new BigInteger("1571"));
		primes.add(new BigInteger("1579"));
		primes.add(new BigInteger("1583"));
		primes.add(new BigInteger("1597"));
		primes.add(new BigInteger("1601"));
		primes.add(new BigInteger("1607"));
		primes.add(new BigInteger("1609"));
		primes.add(new BigInteger("1613"));
		primes.add(new BigInteger("1619"));
		primes.add(new BigInteger("1621"));
		primes.add(new BigInteger("1627"));
		primes.add(new BigInteger("1637"));
		primes.add(new BigInteger("1657"));
		primes.add(new BigInteger("1663"));
		primes.add(new BigInteger("1667"));
		primes.add(new BigInteger("1669"));
		primes.add(new BigInteger("1693"));
		primes.add(new BigInteger("1697"));
		primes.add(new BigInteger("1699"));
		primes.add(new BigInteger("1709"));
		primes.add(new BigInteger("1721"));
		primes.add(new BigInteger("1723"));
		primes.add(new BigInteger("1733"));
		primes.add(new BigInteger("1741"));
		primes.add(new BigInteger("1747"));
		primes.add(new BigInteger("1753"));
		primes.add(new BigInteger("1759"));
		primes.add(new BigInteger("1777"));
		primes.add(new BigInteger("1783"));
		primes.add(new BigInteger("1787"));
		primes.add(new BigInteger("1789"));
		primes.add(new BigInteger("1801"));
		primes.add(new BigInteger("1811"));
		primes.add(new BigInteger("1823"));
		primes.add(new BigInteger("1831"));
		primes.add(new BigInteger("1847"));
		primes.add(new BigInteger("1861"));
		primes.add(new BigInteger("1867"));
		primes.add(new BigInteger("1871"));
		primes.add(new BigInteger("1873"));
		primes.add(new BigInteger("1877"));
		primes.add(new BigInteger("1879"));
		primes.add(new BigInteger("1889"));
		primes.add(new BigInteger("1901"));
		primes.add(new BigInteger("1907"));
		primes.add(new BigInteger("1913"));
		primes.add(new BigInteger("1931"));
		primes.add(new BigInteger("1933"));
		primes.add(new BigInteger("1949"));
		primes.add(new BigInteger("1951"));
		primes.add(new BigInteger("1973"));
		primes.add(new BigInteger("1979"));
		primes.add(new BigInteger("1987"));
		primes.add(new BigInteger("1993"));
		primes.add(new BigInteger("1997"));
		primes.add(new BigInteger("1999"));
		primes.add(new BigInteger("2003"));
		primes.add(new BigInteger("2011"));
		primes.add(new BigInteger("2017"));
		primes.add(new BigInteger("2027"));
		primes.add(new BigInteger("2029"));
		primes.add(new BigInteger("2039"));
		primes.add(new BigInteger("2053"));
		primes.add(new BigInteger("2063"));
		primes.add(new BigInteger("2069"));
		primes.add(new BigInteger("2081"));
		primes.add(new BigInteger("2083"));
		primes.add(new BigInteger("2087"));
		primes.add(new BigInteger("2089"));
		primes.add(new BigInteger("2099"));
		primes.add(new BigInteger("2111"));
		primes.add(new BigInteger("2113"));
		primes.add(new BigInteger("2129"));
		primes.add(new BigInteger("2131"));
		primes.add(new BigInteger("2137"));
		primes.add(new BigInteger("2141"));
		primes.add(new BigInteger("2143"));
		primes.add(new BigInteger("2153"));
		primes.add(new BigInteger("2161"));
		primes.add(new BigInteger("2179"));
		primes.add(new BigInteger("2203"));
		primes.add(new BigInteger("2207"));
		primes.add(new BigInteger("2213"));
		primes.add(new BigInteger("2221"));
		primes.add(new BigInteger("2237"));
		primes.add(new BigInteger("2239"));
		primes.add(new BigInteger("2243"));
		primes.add(new BigInteger("2251"));
		primes.add(new BigInteger("2267"));
		primes.add(new BigInteger("2269"));
		primes.add(new BigInteger("2273"));
		primes.add(new BigInteger("2281"));
		primes.add(new BigInteger("2287"));
		primes.add(new BigInteger("2293"));
		primes.add(new BigInteger("2297"));
		primes.add(new BigInteger("2309"));
		primes.add(new BigInteger("2311"));
		primes.add(new BigInteger("2333"));
		primes.add(new BigInteger("2339"));
		primes.add(new BigInteger("2341"));
		primes.add(new BigInteger("2347"));
		primes.add(new BigInteger("2351"));
		primes.add(new BigInteger("2357"));
		primes.add(new BigInteger("2371"));
		primes.add(new BigInteger("2377"));
		primes.add(new BigInteger("2381"));
		primes.add(new BigInteger("2383"));
		primes.add(new BigInteger("2389"));
		primes.add(new BigInteger("2393"));
		primes.add(new BigInteger("2399"));
		primes.add(new BigInteger("2411"));
		primes.add(new BigInteger("2417"));
		primes.add(new BigInteger("2423"));
		primes.add(new BigInteger("2437"));
		primes.add(new BigInteger("2441"));
		primes.add(new BigInteger("2447"));
		primes.add(new BigInteger("2459"));
		primes.add(new BigInteger("2467"));
		primes.add(new BigInteger("2473"));
		primes.add(new BigInteger("2477"));
		primes.add(new BigInteger("2503"));
		primes.add(new BigInteger("2521"));
		primes.add(new BigInteger("2531"));
		primes.add(new BigInteger("2539"));
		primes.add(new BigInteger("2543"));
		primes.add(new BigInteger("2549"));
		primes.add(new BigInteger("2551"));
		primes.add(new BigInteger("2557"));
		primes.add(new BigInteger("2579"));
		primes.add(new BigInteger("2591"));
		primes.add(new BigInteger("2593"));
		primes.add(new BigInteger("2609"));
		primes.add(new BigInteger("2617"));
		primes.add(new BigInteger("2621"));
		primes.add(new BigInteger("2633"));
		primes.add(new BigInteger("2647"));
		primes.add(new BigInteger("2657"));
		primes.add(new BigInteger("2659"));
		primes.add(new BigInteger("2663"));
		primes.add(new BigInteger("2671"));
		primes.add(new BigInteger("2677"));
		primes.add(new BigInteger("2683"));
		primes.add(new BigInteger("2687"));
		primes.add(new BigInteger("2689"));
		primes.add(new BigInteger("2693"));
		primes.add(new BigInteger("2699"));
		primes.add(new BigInteger("2707"));
		primes.add(new BigInteger("2711"));
		primes.add(new BigInteger("2713"));
		primes.add(new BigInteger("2719"));
		primes.add(new BigInteger("2729"));
		primes.add(new BigInteger("2731"));
		primes.add(new BigInteger("2741"));
		primes.add(new BigInteger("2749"));
		primes.add(new BigInteger("2753"));
		primes.add(new BigInteger("2767"));
		primes.add(new BigInteger("2777"));
		primes.add(new BigInteger("2789"));
		primes.add(new BigInteger("2791"));
		primes.add(new BigInteger("2797"));
		primes.add(new BigInteger("2801"));
		primes.add(new BigInteger("2803"));
		primes.add(new BigInteger("2819"));
		primes.add(new BigInteger("2833"));
		primes.add(new BigInteger("2837"));
		primes.add(new BigInteger("2843"));
		primes.add(new BigInteger("2851"));
		primes.add(new BigInteger("2857"));
		primes.add(new BigInteger("2861"));
		primes.add(new BigInteger("2879"));
		primes.add(new BigInteger("2887"));
		primes.add(new BigInteger("2897"));
		primes.add(new BigInteger("2903"));
		primes.add(new BigInteger("2909"));
		primes.add(new BigInteger("2917"));
		primes.add(new BigInteger("2927"));
		primes.add(new BigInteger("2939"));
		primes.add(new BigInteger("2953"));
		primes.add(new BigInteger("2957"));
		primes.add(new BigInteger("2963"));
		primes.add(new BigInteger("2969"));
		primes.add(new BigInteger("2971"));
		primes.add(new BigInteger("2999"));
		primes.add(new BigInteger("3001"));
		primes.add(new BigInteger("3011"));
		primes.add(new BigInteger("3019"));
		primes.add(new BigInteger("3023"));
		primes.add(new BigInteger("3037"));
		primes.add(new BigInteger("3041"));
		primes.add(new BigInteger("3049"));
		primes.add(new BigInteger("3061"));
		primes.add(new BigInteger("3067"));
		primes.add(new BigInteger("3079"));
		primes.add(new BigInteger("3083"));
		primes.add(new BigInteger("3089"));
		primes.add(new BigInteger("3109"));
		primes.add(new BigInteger("3119"));
		primes.add(new BigInteger("3121"));
		primes.add(new BigInteger("3137"));
		primes.add(new BigInteger("3163"));
		primes.add(new BigInteger("3167"));
		primes.add(new BigInteger("3169"));
		primes.add(new BigInteger("3181"));
		primes.add(new BigInteger("3187"));
		primes.add(new BigInteger("3191"));
		primes.add(new BigInteger("3203"));
		primes.add(new BigInteger("3209"));
		primes.add(new BigInteger("3217"));
		primes.add(new BigInteger("3221"));
		primes.add(new BigInteger("3229"));
		primes.add(new BigInteger("3251"));
		primes.add(new BigInteger("3253"));
		primes.add(new BigInteger("3257"));
		primes.add(new BigInteger("3259"));
		primes.add(new BigInteger("3271"));
		primes.add(new BigInteger("3299"));
		primes.add(new BigInteger("3301"));
		primes.add(new BigInteger("3307"));
		primes.add(new BigInteger("3313"));
		primes.add(new BigInteger("3319"));
		primes.add(new BigInteger("3323"));
		primes.add(new BigInteger("3329"));
		primes.add(new BigInteger("3331"));
		primes.add(new BigInteger("3343"));
		primes.add(new BigInteger("3347"));
		primes.add(new BigInteger("3359"));
		primes.add(new BigInteger("3361"));
		primes.add(new BigInteger("3371"));
		primes.add(new BigInteger("3373"));
		primes.add(new BigInteger("3389"));
		primes.add(new BigInteger("3391"));
		primes.add(new BigInteger("3407"));
		primes.add(new BigInteger("3413"));
		primes.add(new BigInteger("3433"));
		primes.add(new BigInteger("3449"));
		primes.add(new BigInteger("3457"));
		primes.add(new BigInteger("3461"));
		primes.add(new BigInteger("3463"));
		primes.add(new BigInteger("3467"));
		primes.add(new BigInteger("3469"));
		primes.add(new BigInteger("3491"));
		primes.add(new BigInteger("3499"));
		primes.add(new BigInteger("3511"));
		primes.add(new BigInteger("3517"));
		primes.add(new BigInteger("3527"));
		primes.add(new BigInteger("3529"));
		primes.add(new BigInteger("3533"));
		primes.add(new BigInteger("3539"));
		primes.add(new BigInteger("3541"));
		primes.add(new BigInteger("3547"));
		primes.add(new BigInteger("3557"));
		primes.add(new BigInteger("3559"));
		primes.add(new BigInteger("3571"));
		primes.add(new BigInteger("3581"));
		primes.add(new BigInteger("3583"));
		primes.add(new BigInteger("3593"));
		primes.add(new BigInteger("3607"));
		primes.add(new BigInteger("3613"));
		primes.add(new BigInteger("3617"));
		primes.add(new BigInteger("3623"));
		primes.add(new BigInteger("3631"));
		primes.add(new BigInteger("3637"));
		primes.add(new BigInteger("3643"));
		primes.add(new BigInteger("3659"));
		primes.add(new BigInteger("3671"));
		primes.add(new BigInteger("3673"));
		primes.add(new BigInteger("3677"));
		primes.add(new BigInteger("3691"));
		primes.add(new BigInteger("3697"));
		primes.add(new BigInteger("3701"));
		primes.add(new BigInteger("3709"));
		primes.add(new BigInteger("3719"));
		primes.add(new BigInteger("3727"));
		primes.add(new BigInteger("3733"));
		primes.add(new BigInteger("3739"));
		primes.add(new BigInteger("3761"));
		primes.add(new BigInteger("3767"));
		primes.add(new BigInteger("3769"));
		primes.add(new BigInteger("3779"));
		primes.add(new BigInteger("3793"));
		primes.add(new BigInteger("3797"));
		primes.add(new BigInteger("3803"));
		primes.add(new BigInteger("3821"));
		primes.add(new BigInteger("3823"));
		primes.add(new BigInteger("3833"));
		primes.add(new BigInteger("3847"));
		primes.add(new BigInteger("3851"));
		primes.add(new BigInteger("3853"));
		primes.add(new BigInteger("3863"));
		primes.add(new BigInteger("3877"));
		primes.add(new BigInteger("3881"));
		primes.add(new BigInteger("3889"));
		primes.add(new BigInteger("3907"));
		primes.add(new BigInteger("3911"));
		primes.add(new BigInteger("3917"));
		primes.add(new BigInteger("3919"));
		primes.add(new BigInteger("3923"));
		primes.add(new BigInteger("3929"));
		primes.add(new BigInteger("3931"));
		primes.add(new BigInteger("3943"));
		primes.add(new BigInteger("3947"));
		primes.add(new BigInteger("3967"));
		primes.add(new BigInteger("3989"));
		primes.add(new BigInteger("4001"));
		primes.add(new BigInteger("4003"));
		primes.add(new BigInteger("4007"));
		primes.add(new BigInteger("4013"));
		primes.add(new BigInteger("4019"));
		primes.add(new BigInteger("4021"));
		primes.add(new BigInteger("4027"));
		primes.add(new BigInteger("4049"));
		primes.add(new BigInteger("4051"));
		primes.add(new BigInteger("4057"));
		primes.add(new BigInteger("4073"));
		primes.add(new BigInteger("4079"));
		primes.add(new BigInteger("4091"));
		primes.add(new BigInteger("4093"));
		primes.add(new BigInteger("4099"));
		primes.add(new BigInteger("4111"));
		primes.add(new BigInteger("4127"));
		primes.add(new BigInteger("4129"));
		primes.add(new BigInteger("4133"));
		primes.add(new BigInteger("4139"));
		primes.add(new BigInteger("4153"));
		primes.add(new BigInteger("4157"));
		primes.add(new BigInteger("4159"));
		primes.add(new BigInteger("4177"));
		primes.add(new BigInteger("4201"));
		primes.add(new BigInteger("4211"));
		primes.add(new BigInteger("4217"));
		primes.add(new BigInteger("4219"));
		primes.add(new BigInteger("4229"));
		primes.add(new BigInteger("4231"));
		primes.add(new BigInteger("4241"));
		primes.add(new BigInteger("4243"));
		primes.add(new BigInteger("4253"));
		primes.add(new BigInteger("4259"));
		primes.add(new BigInteger("4261"));
		primes.add(new BigInteger("4271"));
		primes.add(new BigInteger("4273"));
		primes.add(new BigInteger("4283"));
		primes.add(new BigInteger("4289"));
		primes.add(new BigInteger("4297"));
		primes.add(new BigInteger("4327"));
		primes.add(new BigInteger("4337"));
		primes.add(new BigInteger("4339"));
		primes.add(new BigInteger("4349"));
		primes.add(new BigInteger("4357"));
		primes.add(new BigInteger("4363"));
		primes.add(new BigInteger("4373"));
		primes.add(new BigInteger("4391"));
		primes.add(new BigInteger("4397"));
		primes.add(new BigInteger("4409"));
		primes.add(new BigInteger("4421"));
		primes.add(new BigInteger("4423"));
		primes.add(new BigInteger("4441"));
		primes.add(new BigInteger("4447"));
		primes.add(new BigInteger("4451"));
		primes.add(new BigInteger("4457"));
		primes.add(new BigInteger("4463"));
		primes.add(new BigInteger("4481"));
		primes.add(new BigInteger("4483"));
		primes.add(new BigInteger("4493"));
		primes.add(new BigInteger("4507"));
		primes.add(new BigInteger("4513"));
		primes.add(new BigInteger("4517"));
		primes.add(new BigInteger("4519"));
		primes.add(new BigInteger("4523"));
		primes.add(new BigInteger("4547"));
		primes.add(new BigInteger("4549"));
		primes.add(new BigInteger("4561"));
		primes.add(new BigInteger("4567"));
		primes.add(new BigInteger("4583"));
		primes.add(new BigInteger("4591"));
		primes.add(new BigInteger("4597"));
		primes.add(new BigInteger("4603"));
		primes.add(new BigInteger("4621"));
		primes.add(new BigInteger("4637"));
		primes.add(new BigInteger("4639"));
		primes.add(new BigInteger("4643"));
		primes.add(new BigInteger("4649"));
		primes.add(new BigInteger("4651"));
		primes.add(new BigInteger("4657"));
		primes.add(new BigInteger("4663"));
		primes.add(new BigInteger("4673"));
		primes.add(new BigInteger("4679"));
		primes.add(new BigInteger("4691"));
		primes.add(new BigInteger("4703"));
		primes.add(new BigInteger("4721"));
		primes.add(new BigInteger("4723"));
		primes.add(new BigInteger("4729"));
		primes.add(new BigInteger("4733"));
		primes.add(new BigInteger("4751"));
		primes.add(new BigInteger("4759"));
		primes.add(new BigInteger("4783"));
		primes.add(new BigInteger("4787"));
		primes.add(new BigInteger("4789"));
		primes.add(new BigInteger("4793"));
		primes.add(new BigInteger("4799"));
		primes.add(new BigInteger("4801"));
		primes.add(new BigInteger("4813"));
		primes.add(new BigInteger("4817"));
		primes.add(new BigInteger("4831"));
		primes.add(new BigInteger("4861"));
		primes.add(new BigInteger("4871"));
		primes.add(new BigInteger("4877"));
		primes.add(new BigInteger("4889"));
		primes.add(new BigInteger("4903"));
		primes.add(new BigInteger("4909"));
		primes.add(new BigInteger("4919"));
		primes.add(new BigInteger("4931"));
		primes.add(new BigInteger("4933"));
		primes.add(new BigInteger("4937"));
		primes.add(new BigInteger("4943"));
		primes.add(new BigInteger("4951"));
		primes.add(new BigInteger("4957"));
		primes.add(new BigInteger("4967"));
		primes.add(new BigInteger("4969"));
		primes.add(new BigInteger("4973"));
		primes.add(new BigInteger("4987"));
		primes.add(new BigInteger("4993"));
		primes.add(new BigInteger("4999"));
		primes.add(new BigInteger("5003"));
		primes.add(new BigInteger("5009"));
		primes.add(new BigInteger("5011"));
		primes.add(new BigInteger("5021"));
		primes.add(new BigInteger("5023"));
		primes.add(new BigInteger("5039"));
		primes.add(new BigInteger("5051"));
		primes.add(new BigInteger("5059"));
		primes.add(new BigInteger("5077"));
		primes.add(new BigInteger("5081"));
		primes.add(new BigInteger("5087"));
		primes.add(new BigInteger("5099"));
		primes.add(new BigInteger("5101"));
		primes.add(new BigInteger("5107"));
		primes.add(new BigInteger("5113"));
		primes.add(new BigInteger("5119"));
		primes.add(new BigInteger("5147"));
		primes.add(new BigInteger("5153"));
		primes.add(new BigInteger("5167"));
		primes.add(new BigInteger("5171"));
		primes.add(new BigInteger("5179"));
		primes.add(new BigInteger("5189"));
		primes.add(new BigInteger("5197"));
		primes.add(new BigInteger("5209"));
		primes.add(new BigInteger("5227"));
		primes.add(new BigInteger("5231"));
		primes.add(new BigInteger("5233"));
		primes.add(new BigInteger("5237"));
		primes.add(new BigInteger("5261"));
		primes.add(new BigInteger("5273"));
		primes.add(new BigInteger("5279"));
		primes.add(new BigInteger("5281"));
		primes.add(new BigInteger("5297"));
		primes.add(new BigInteger("5303"));
		primes.add(new BigInteger("5309"));
		primes.add(new BigInteger("5323"));
		primes.add(new BigInteger("5333"));
		primes.add(new BigInteger("5347"));
		primes.add(new BigInteger("5351"));
		primes.add(new BigInteger("5381"));
		primes.add(new BigInteger("5387"));
		primes.add(new BigInteger("5393"));
		primes.add(new BigInteger("5399"));
		primes.add(new BigInteger("5407"));
		primes.add(new BigInteger("5413"));
		primes.add(new BigInteger("5417"));
		primes.add(new BigInteger("5419"));
		primes.add(new BigInteger("5431"));
		primes.add(new BigInteger("5437"));
		primes.add(new BigInteger("5441"));
		primes.add(new BigInteger("5443"));
		primes.add(new BigInteger("5449"));
		primes.add(new BigInteger("5471"));
		primes.add(new BigInteger("5477"));
		primes.add(new BigInteger("5479"));
		primes.add(new BigInteger("5483"));
		primes.add(new BigInteger("5501"));
		primes.add(new BigInteger("5503"));
		primes.add(new BigInteger("5507"));
		primes.add(new BigInteger("5519"));
		primes.add(new BigInteger("5521"));
		primes.add(new BigInteger("5527"));
		primes.add(new BigInteger("5531"));
		primes.add(new BigInteger("5557"));
		primes.add(new BigInteger("5563"));
		primes.add(new BigInteger("5569"));
		primes.add(new BigInteger("5573"));
		primes.add(new BigInteger("5581"));
		primes.add(new BigInteger("5591"));
		primes.add(new BigInteger("5623"));
		primes.add(new BigInteger("5639"));
		primes.add(new BigInteger("5641"));
		primes.add(new BigInteger("5647"));
		primes.add(new BigInteger("5651"));
		primes.add(new BigInteger("5653"));
		primes.add(new BigInteger("5657"));
		primes.add(new BigInteger("5659"));
		primes.add(new BigInteger("5669"));
		primes.add(new BigInteger("5683"));
		primes.add(new BigInteger("5689"));
		primes.add(new BigInteger("5693"));
		primes.add(new BigInteger("5701"));
		primes.add(new BigInteger("5711"));
		primes.add(new BigInteger("5717"));
		primes.add(new BigInteger("5737"));
		primes.add(new BigInteger("5741"));
		primes.add(new BigInteger("5743"));
		primes.add(new BigInteger("5749"));
		primes.add(new BigInteger("5779"));
		primes.add(new BigInteger("5783"));
		primes.add(new BigInteger("5791"));
		primes.add(new BigInteger("5801"));
		primes.add(new BigInteger("5807"));
		primes.add(new BigInteger("5813"));
		primes.add(new BigInteger("5821"));
		primes.add(new BigInteger("5827"));
		primes.add(new BigInteger("5839"));
		primes.add(new BigInteger("5843"));
		primes.add(new BigInteger("5849"));
		primes.add(new BigInteger("5851"));
		primes.add(new BigInteger("5857"));
		primes.add(new BigInteger("5861"));
		primes.add(new BigInteger("5867"));
		primes.add(new BigInteger("5869"));
		primes.add(new BigInteger("5879"));
		primes.add(new BigInteger("5881"));
		primes.add(new BigInteger("5897"));
		primes.add(new BigInteger("5903"));
		primes.add(new BigInteger("5923"));
		primes.add(new BigInteger("5927"));
		primes.add(new BigInteger("5939"));
		primes.add(new BigInteger("5953"));
		primes.add(new BigInteger("5981"));
		primes.add(new BigInteger("5987"));
		primes.add(new BigInteger("6007"));
		primes.add(new BigInteger("6011"));
		primes.add(new BigInteger("6029"));
		primes.add(new BigInteger("6037"));
		primes.add(new BigInteger("6043"));
		primes.add(new BigInteger("6047"));
		primes.add(new BigInteger("6053"));
		primes.add(new BigInteger("6067"));
		primes.add(new BigInteger("6073"));
		primes.add(new BigInteger("6079"));
		primes.add(new BigInteger("6089"));
		primes.add(new BigInteger("6091"));
		primes.add(new BigInteger("6101"));
		primes.add(new BigInteger("6113"));
		primes.add(new BigInteger("6121"));
		primes.add(new BigInteger("6131"));
		primes.add(new BigInteger("6133"));
		primes.add(new BigInteger("6143"));
		primes.add(new BigInteger("6151"));
		primes.add(new BigInteger("6163"));
		primes.add(new BigInteger("6173"));
		primes.add(new BigInteger("6197"));
		primes.add(new BigInteger("6199"));
		primes.add(new BigInteger("6203"));
		primes.add(new BigInteger("6211"));
		primes.add(new BigInteger("6217"));
		primes.add(new BigInteger("6221"));
		primes.add(new BigInteger("6229"));
		primes.add(new BigInteger("6247"));
		primes.add(new BigInteger("6257"));
		primes.add(new BigInteger("6263"));
		primes.add(new BigInteger("6269"));
		primes.add(new BigInteger("6271"));
		primes.add(new BigInteger("6277"));
		primes.add(new BigInteger("6287"));
		primes.add(new BigInteger("6299"));
		primes.add(new BigInteger("6301"));
		primes.add(new BigInteger("6311"));
		primes.add(new BigInteger("6317"));
		primes.add(new BigInteger("6323"));
		primes.add(new BigInteger("6329"));
		primes.add(new BigInteger("6337"));
		primes.add(new BigInteger("6343"));
		primes.add(new BigInteger("6353"));
		primes.add(new BigInteger("6359"));
		primes.add(new BigInteger("6361"));
		primes.add(new BigInteger("6367"));
		primes.add(new BigInteger("6373"));
		primes.add(new BigInteger("6379"));
		primes.add(new BigInteger("6389"));
		primes.add(new BigInteger("6397"));
		primes.add(new BigInteger("6421"));
		primes.add(new BigInteger("6427"));
		primes.add(new BigInteger("6449"));
		primes.add(new BigInteger("6451"));
		primes.add(new BigInteger("6469"));
		primes.add(new BigInteger("6473"));
		primes.add(new BigInteger("6481"));
		primes.add(new BigInteger("6491"));
		primes.add(new BigInteger("6521"));
		primes.add(new BigInteger("6529"));
		primes.add(new BigInteger("6547"));
		primes.add(new BigInteger("6551"));
		primes.add(new BigInteger("6553"));
		primes.add(new BigInteger("6563"));
		primes.add(new BigInteger("6569"));
		primes.add(new BigInteger("6571"));
		primes.add(new BigInteger("6577"));
		primes.add(new BigInteger("6581"));
		primes.add(new BigInteger("6599"));
		primes.add(new BigInteger("6607"));
		primes.add(new BigInteger("6619"));
		primes.add(new BigInteger("6637"));
		primes.add(new BigInteger("6653"));
		primes.add(new BigInteger("6659"));
		primes.add(new BigInteger("6661"));
		primes.add(new BigInteger("6673"));
		primes.add(new BigInteger("6679"));
		primes.add(new BigInteger("6689"));
		primes.add(new BigInteger("6691"));
		primes.add(new BigInteger("6701"));
		primes.add(new BigInteger("6703"));
		primes.add(new BigInteger("6709"));
		primes.add(new BigInteger("6719"));
		primes.add(new BigInteger("6733"));
		primes.add(new BigInteger("6737"));
		primes.add(new BigInteger("6761"));
		primes.add(new BigInteger("6763"));
		primes.add(new BigInteger("6779"));
		primes.add(new BigInteger("6781"));
		primes.add(new BigInteger("6791"));
		primes.add(new BigInteger("6793"));
		primes.add(new BigInteger("6803"));
		primes.add(new BigInteger("6823"));
		primes.add(new BigInteger("6827"));
		primes.add(new BigInteger("6829"));
		primes.add(new BigInteger("6833"));
		primes.add(new BigInteger("6841"));
		primes.add(new BigInteger("6857"));
		primes.add(new BigInteger("6863"));
		primes.add(new BigInteger("6869"));
		primes.add(new BigInteger("6871"));
		primes.add(new BigInteger("6883"));
		primes.add(new BigInteger("6899"));
		primes.add(new BigInteger("6907"));
		primes.add(new BigInteger("6911"));
		primes.add(new BigInteger("6917"));
		primes.add(new BigInteger("6947"));
		primes.add(new BigInteger("6949"));
		primes.add(new BigInteger("6959"));
		primes.add(new BigInteger("6961"));
		primes.add(new BigInteger("6967"));
		primes.add(new BigInteger("6971"));
		primes.add(new BigInteger("6977"));
		primes.add(new BigInteger("6983"));
		primes.add(new BigInteger("6991"));
		primes.add(new BigInteger("6997"));
		primes.add(new BigInteger("7001"));
		primes.add(new BigInteger("7013"));
		primes.add(new BigInteger("7019"));
		primes.add(new BigInteger("7027"));
		primes.add(new BigInteger("7039"));
		primes.add(new BigInteger("7043"));
		primes.add(new BigInteger("7057"));
		primes.add(new BigInteger("7069"));
		primes.add(new BigInteger("7079"));
		primes.add(new BigInteger("7103"));
		primes.add(new BigInteger("7109"));
		primes.add(new BigInteger("7121"));
		primes.add(new BigInteger("7127"));
		primes.add(new BigInteger("7129"));
		primes.add(new BigInteger("7151"));
		primes.add(new BigInteger("7159"));
		primes.add(new BigInteger("7177"));
		primes.add(new BigInteger("7187"));
		primes.add(new BigInteger("7193"));
		primes.add(new BigInteger("7207"));
		primes.add(new BigInteger("7211"));
		primes.add(new BigInteger("7213"));
		primes.add(new BigInteger("7219"));
		primes.add(new BigInteger("7229"));
		primes.add(new BigInteger("7237"));
		primes.add(new BigInteger("7243"));
		primes.add(new BigInteger("7247"));
		primes.add(new BigInteger("7253"));
		primes.add(new BigInteger("7283"));
		primes.add(new BigInteger("7297"));
		primes.add(new BigInteger("7307"));
		primes.add(new BigInteger("7309"));
		primes.add(new BigInteger("7321"));
		primes.add(new BigInteger("7331"));
		primes.add(new BigInteger("7333"));
		primes.add(new BigInteger("7349"));
		primes.add(new BigInteger("7351"));
		primes.add(new BigInteger("7369"));
		primes.add(new BigInteger("7393"));
		primes.add(new BigInteger("7411"));
		primes.add(new BigInteger("7417"));
		primes.add(new BigInteger("7433"));
		primes.add(new BigInteger("7451"));
		primes.add(new BigInteger("7457"));
		primes.add(new BigInteger("7459"));
		primes.add(new BigInteger("7477"));
		primes.add(new BigInteger("7481"));
		primes.add(new BigInteger("7487"));
		primes.add(new BigInteger("7489"));
		primes.add(new BigInteger("7499"));
		primes.add(new BigInteger("7507"));
		primes.add(new BigInteger("7517"));
		primes.add(new BigInteger("7523"));
		primes.add(new BigInteger("7529"));
		primes.add(new BigInteger("7537"));
		primes.add(new BigInteger("7541"));
		primes.add(new BigInteger("7547"));
		primes.add(new BigInteger("7549"));
		primes.add(new BigInteger("7559"));
		primes.add(new BigInteger("7561"));
		primes.add(new BigInteger("7573"));
		primes.add(new BigInteger("7577"));
		primes.add(new BigInteger("7583"));
		primes.add(new BigInteger("7589"));
		primes.add(new BigInteger("7591"));
		primes.add(new BigInteger("7603"));
		primes.add(new BigInteger("7607"));
		primes.add(new BigInteger("7621"));
		primes.add(new BigInteger("7639"));
		primes.add(new BigInteger("7643"));
		primes.add(new BigInteger("7649"));
		primes.add(new BigInteger("7669"));
		primes.add(new BigInteger("7673"));
		primes.add(new BigInteger("7681"));
		primes.add(new BigInteger("7687"));
		primes.add(new BigInteger("7691"));
		primes.add(new BigInteger("7699"));
		primes.add(new BigInteger("7703"));
		primes.add(new BigInteger("7717"));
		primes.add(new BigInteger("7723"));
		primes.add(new BigInteger("7727"));
		primes.add(new BigInteger("7741"));
		primes.add(new BigInteger("7753"));
		primes.add(new BigInteger("7757"));
		primes.add(new BigInteger("7759"));
		primes.add(new BigInteger("7789"));
		primes.add(new BigInteger("7793"));
		primes.add(new BigInteger("7817"));
		primes.add(new BigInteger("7823"));
		primes.add(new BigInteger("7829"));
		primes.add(new BigInteger("7841"));
		primes.add(new BigInteger("7853"));
		primes.add(new BigInteger("7867"));
		primes.add(new BigInteger("7873"));
		primes.add(new BigInteger("7877"));
		primes.add(new BigInteger("7879"));
		primes.add(new BigInteger("7883"));
		primes.add(new BigInteger("7901"));
		primes.add(new BigInteger("7907"));
		primes.add(new BigInteger("7919"));
	}
	
	public void tryOne() {
		String binary = "1001";
		String resultado = "";
        boolean exitoso = true;
        List<Long> ntdivisors = new ArrayList<Long>();
		for(int j = 2; j <= 10; j++) {
        	//Long numeroBase = new Long(Long.toString(Long.parseLong(binary, j), 10));
			BigInteger numeroBase = new BigInteger(binary, j);
			System.out.println(numeroBase);
        	// buscar si es primo
        	/*if(!primes.contains(numeroBase)) {
            	System.out.println("\tNO ES PRIMO: " + numeroBase);
        		for(int l = 0; l < 25; l++) {
            		if(numeroBase % primes.get(l) == 0 && !ntdivisors.contains(primes.get(l))) {
            			resultado += " " + primes.get(l);
            			ntdivisors.add(primes.get(l));
            			System.out.println(primes.get(l));
            			break;
            		}
        		}
        	} else {
        		System.out.println("\tNO CUMPLE");
        		break;
        	}*/
        }
		//System.out.println(ntdivisors);
	}

	public void generarJamcoin(int posiciones, int cantidad) {
		long posibilidades = new Double(Math.pow(2, posiciones)).longValue();
		System.out.println(posiciones);
		System.out.println(posibilidades);
		String binary = "";
		int encontrados = 0;
        for(long i = posibilidades/2; i < posibilidades; i++) { 
        	//binary = Integer.toBinaryString(i);
        	binary = new BigInteger(new Long(i).toString()).toString(2);
            while(binary.length() < posiciones){ 
            	binary = 0 + binary; 
            }
            String resultado = "";
            boolean exitoso = true;
            List<BigInteger> ntdivisors = new ArrayList<BigInteger>();
            if(binary.endsWith("1")) {
                resultado = binary;
                //System.out.println(resultado);
                // convertir a las bases
                for(int j = 2; j <= 10; j++) {
                	//Long numeroBase = new Long(Long.toString(Long.parseLong(binary, j), 10));
                	BigInteger numeroBase = new BigInteger(binary, j);
                	// buscar si es primo
                	if(!primes.contains(numeroBase)) {
                    	//System.out.println("\tNO ES PRIMO: " + numeroBase);
                		for(int l = 0; l < 25; l++) {
                    		if(numeroBase.mod(primes.get(l)).intValue() == 0 && !ntdivisors.contains(primes.get(l)) && ntdivisors.size() < 9) {
                    			resultado += " " + primes.get(l);
                    			ntdivisors.add(primes.get(l));
                    			//System.out.println(primes.get(l));
                    			break;
                    		} else if(numeroBase.mod(primes.get(l)).intValue() == 0 && ntdivisors.contains(primes.get(l)) && ntdivisors.size() < 9) {
                    			if(!ntdivisors.contains(numeroBase.divide(primes.get(l)))) {
                        			resultado += " " + numeroBase.divide(primes.get(l));
                        			ntdivisors.add(numeroBase.divide(primes.get(l)));
                        			//System.out.println(primes.get(l));
                        			break;
                    			}
                    		}
                		}
                	} else {
                		//System.out.println("\tSI ES PRIMO: " + numeroBase);
                		exitoso = false;
                		break;
                	}
                }
                if(exitoso && ntdivisors.size() == 9) {
                	System.out.println(resultado);
                	try {
						output.write(resultado + "\n");
					} catch (IOException e) {
						// TODO Auto-generated catch block
						e.printStackTrace();
					}
                	encontrados++;
                }
                if(encontrados == cantidad) {
                	break;
                }
            }
        }
		//System.out.println(Integer.parseInt("1001", 2));
		//System.out.println(Integer.toString(Integer.parseInt("1001", 3), 10));
	}
	
	public static void main(String[] args) {
		Jamcoins app = new Jamcoins();
		String path = "";
		String name = "C-large";
		int cantCasos = 0;

		try {
			File archivoEntrada = new File(path + name + ".in");
			File archivoSalida = new File(path + name + ".out");

			output = new BufferedWriter(new FileWriter(archivoSalida));

			BufferedReader entrada = new BufferedReader(new FileReader(
					archivoEntrada));
			try {
				String linea = null;
				int nLinea = 0;
				int caso = 1;

				while ((linea = entrada.readLine()) != null) {
					// procesar cada linea y agregarla al Collection
					Scanner scanner = new Scanner(linea);
					scanner.useDelimiter(" ");
					if (scanner.hasNext()) {
						if (nLinea == 0) {
							// cantidad de casos
							cantCasos = scanner.nextInt();
						} else {
							output.write("Case #" + caso + ":\n");
							System.out.println("Case #" + caso + ":");
							app.generarJamcoin(scanner.nextInt(), scanner.nextInt());
							//app.tryOne();
							caso++;
						}
						// int cumplidos = app.encontrarPatron(patron);
						// cumplidos + "\n");
						nLinea++;
					} else {
						System.out.println("Error al procesar la linea: " + linea);
					}

					scanner.close();
				}
			} finally {
				System.out.println("Finalizado el proceso!!!");
				output.close();
				entrada.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
