package gt.jl.jam.roundone;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

public class BribePrisoners {
	static Writer output;
	List<String> combinaciones = null;
	String[] strCombinaciones = null;

	public int factorial(int n) {
		int suma = n;
		if(n == 0) {
			return 1;
		}
		return suma * factorial(n-1);
	}

	public int calcularMinimoSoborno(int vp, int vq) {
		int minimoSoborno = -1;
		for (Iterator iterator = combinaciones.iterator(); iterator.hasNext();) {
			String[] strCombinacion = ((String) iterator.next()).split(" ");
			int[] celdas = new int[vp];
			for(int i = 0; i < vp; i++) {
				celdas[i] = 0;
			}
			int sobornar = 0;
			for(int j = 0; j < strCombinacion.length; j++) {
				celdas[Integer.parseInt(strCombinacion[j]) - 1] = -1;
				// para celdas menores
				int cmin = Integer.parseInt(strCombinacion[j]) - 2;
				while(cmin >= 0 && celdas[cmin] > -1) {
					sobornar++;
					cmin--;
				}
				// para celdas mayores
				int cmax = Integer.parseInt(strCombinacion[j]);
				while(cmax < vp && celdas[cmax] > -1) {
					sobornar++;
					cmax++;
				}
			}

			if(minimoSoborno == -1 || sobornar < minimoSoborno) {
				minimoSoborno = sobornar;
			}
		}
		return minimoSoborno;
	}

	public String combinar(String celda, ArrayList<String> arrCeldas, int longitud, int pos, int nCombinaciones) {
		//System.out.print(celda + " ");
		String combinacion = celda;

		arrCeldas = new ArrayList<String>(arrCeldas);
		arrCeldas.remove(celda);

		for (int i = 0; i < arrCeldas.size(); i++) {
			if(i > 0) {
				pos++;
				combinacion = celda;
			}
			combinacion += " " + combinar(arrCeldas.get(i), arrCeldas, longitud, pos, nCombinaciones);
			if(strCombinaciones[pos] != null && combinacion.split(" ").length < longitud) {
				strCombinaciones[pos] = combinacion;
			} else if(combinacion.split(" ").length < longitud) {
				strCombinaciones[pos] = new String(combinacion);
			}
			// agregar combinacion
			if(combinacion.split(" ").length == longitud) {
				//System.out.println(combinacion);
				combinaciones.add(combinacion);
				int posx = 0;
				String strCombinacion = celda + " " + strCombinaciones[posx];
				while(strCombinaciones[posx] != null && !strCombinacion.equals(combinacion)) {
					combinaciones.add(celda + " " + strCombinaciones[posx]);
					posx++;
					if(strCombinaciones[posx] != null) {
						strCombinacion = celda + " " + strCombinaciones[posx];
					}
				}
				combinacion = celda;
				strCombinaciones = new String[nCombinaciones];
				pos = -1;
			}
		}

		if(longitud == 1) {
			combinaciones.add(combinacion);
		}
		return combinacion;
	}

	public ArrayList<String> determinarCombinaciones(ArrayList<String> arrCeldas) {
		int nCombinaciones = factorial(arrCeldas.size());
		strCombinaciones = new String[nCombinaciones];
		for (int i = 0; i < arrCeldas.size(); i++) {
			combinar(arrCeldas.get(i), arrCeldas, arrCeldas.size(), 0, nCombinaciones);
			//System.out.println();
		}
		return null;
	}

	public int calcularSoborno(int vp, int vq, String[] celdas) {
		// System.out.println(vp + "-" + vq + ":" + celdas);
		combinaciones = new ArrayList<String>();
		ArrayList<String> arrCeldas = new ArrayList<String>();
		for (int i = 0; i < celdas.length; i++) {
			arrCeldas.add(celdas[i]);
		}
		determinarCombinaciones(arrCeldas);
		int minimo = calcularMinimoSoborno(vp, vq);
		return minimo;
	}

	public static void main(String[] args) {
		BribePrisoners app = new BribePrisoners();

		String name = "C-small-attempt1";
		String path = "";
		int valueT = 0;
		int valueD = 0;
		int valueN = 0;

		try {
			File archivoEntrada = new File(path + name + ".in");
			File archivoSalida = new File(path + name + ".out");

			output = new BufferedWriter(new FileWriter(archivoSalida));

			BufferedReader entrada = new BufferedReader(new FileReader(
					archivoEntrada));
			try {
				String linea = null;
				int nLinea = 0;

				while ((linea = entrada.readLine()) != null) {
					// procesar cada linea y agregarla al Collection
					// los casos
					Scanner scanner = new Scanner(linea);
					scanner.useDelimiter(" ");
					if (scanner.hasNext()) {
						if (nLinea == 0) {
							// los datos iniciales
							valueT = scanner.nextInt();
						} else {
							// las bases
							int valorP = scanner.nextInt();
							int valorQ = scanner.nextInt();
							linea = entrada.readLine();
							String[] celdas = linea.split(" ");
							int minimum = app.calcularSoborno(valorP, valorQ,
									celdas);
							output.write("Case #" + nLinea + ": " + minimum
									+ "\n");
							System.out.print("Case #" + nLinea + ": " + minimum
									+ "\n");
							// double promedio =
							// app.promedioPaquetes(tiposCartas, cartasPaquete);
							/*
							 * DecimalFormat df = new
							 * DecimalFormat("#0.0000000");
							 */
						}
						nLinea++;

					} else {
						System.out.println("Error al procesar la linea: "
								+ linea);
					}

					scanner.close();
				}
			} finally {
				System.out.println("Finalizado el proceso!!!");
				output.close();
				entrada.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
