package gt.impower.jam.thirteen.qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class TicTacToeTomek {
	static Writer output;
	
	private static int DIMENSION = 4;
	int[][] tableroChar = new int[DIMENSION][DIMENSION];

	public void procesarCasilla(int pX, int pY) {
		int hor = 0;
		int ver = 0;
		int dia = 0;
	}
	
	public String determinarGanador(String[] pTablero) {
		int[] horizontal = new int[8];
		int[] vertical = new int[8];
		int[] diagonal = new int[4];
		boolean completo = true;
		
		for(int i = 0; i < DIMENSION; i++) {
			for(int j = 0; j < DIMENSION; j++) {
				char casilla = pTablero[i].charAt(j);
				if(casilla == 'X') {
					tableroChar[i][j] = 1;
				} else if(casilla == 'O') {
					tableroChar[i][j] = -1;
				} else if(casilla == 'T') {
					tableroChar[i][j] = 2;
				} else if(casilla == '.') {
					completo = false;
					tableroChar[i][j] = 0;
				}
			}
		}
		
		for(int a = 0; a < DIMENSION; a++) {
			for(int b = 0; b < DIMENSION; b++) {
				if(tableroChar[a][b] == 2) {
					horizontal[a * 2]++;
					horizontal[(a * 2) + 1]--;
					
					vertical[b * 2]++;
					vertical[(b * 2) + 1]--;
					
					if(a == b) {
						diagonal[0]++;
						diagonal[1]--;
					} else if(a + b == 3) {
						diagonal[2]++;
						diagonal[3]--;
					}
				} else {
					horizontal[a * 2] += tableroChar[a][b];
					horizontal[(a * 2) + 1] += tableroChar[a][b];
					
					vertical[b * 2] += tableroChar[a][b];
					vertical[(b * 2) + 1] += tableroChar[a][b];
					
					if(a == b) {
						diagonal[0] += tableroChar[a][b];
						diagonal[1] += tableroChar[a][b];
					} else if(a + b == 3) {
						diagonal[2] += tableroChar[a][b];
						diagonal[3] += tableroChar[a][b];
					}
				}
			}
		}
		
		String resultado = "";
		// determinar ganador
		for(int i = 0; i < horizontal.length; i++) {
			if(horizontal[i] == 4) {
				resultado = "X won";
			} else if(horizontal[i] == -4) {
				resultado = "O won";
			}
		}
		
		for(int i = 0; i < vertical.length; i++) {
			if(vertical[i] == 4) {
				resultado = "X won";
			} else if(vertical[i] == -4) {
				resultado = "O won";
			}
		}
		
		for(int i = 0; i < diagonal.length; i++) {
			if(diagonal[i] == 4) {
				resultado = "X won";
			} else if(diagonal[i] == -4) {
				resultado = "O won";
			}
		}

		if(resultado.equals("") && completo) {
			resultado = "Draw";
		} else if(resultado.equals("") && !completo) {
			resultado = "Game has not completed";
		}
		
		return resultado;
	}
	
	public static void main(String[] args) {
		TicTacToeTomek app = new TicTacToeTomek();
		String path = "";
		String name = "A-small-attempt0";
		int cantCasos = 0;
		SimpleDateFormat sdf = new SimpleDateFormat("mm:ss.SSS");
		
		long inicioProceso = System.currentTimeMillis();

		try {
			File archivoEntrada = new File(path + name + ".in");
			File archivoSalida = new File(path + name + ".out");

			output = new BufferedWriter(new FileWriter(archivoSalida));

			BufferedReader entrada = new BufferedReader(new FileReader(
					archivoEntrada));
			try {
				String linea = null;
				int nLinea = 0;
				int caso = 1;

				while ((linea = entrada.readLine()) != null) {
					// procesar cada linea y agregarla al Collection
					Scanner scanner = new Scanner(linea);
					scanner.useDelimiter(" ");
					if (scanner.hasNext()) {
						if (nLinea == 0) {
							// cantidad de casos
							cantCasos = scanner.nextInt();
						} else {
							// formar tablero
							String[] tablero = new String[4];
							tablero[0] = linea;
							tablero[1] = entrada.readLine();
							tablero[2] = entrada.readLine();
							tablero[3] = entrada.readLine();
							// procesar tablero
							long inicio = System.currentTimeMillis();
							String resultado = app.determinarGanador(tablero);
							long fin = System.currentTimeMillis();
							output.write("Case #" + caso + ": " + resultado + "\n");
							System.out.println("Case #" + caso + ": " + resultado + " en " + sdf.format(new java.util.Date(fin - inicio)));
							caso++;
							entrada.readLine();
							nLinea+=4;
						}
						// int cumplidos = app.encontrarPatron(patron);
						// cumplidos + "\n");
						nLinea++;
					} else {
						System.out.println("Error al procesar la linea: " + linea);
					}

					scanner.close();
				}
			} finally {
				long finProceso = System.currentTimeMillis();
				System.out.println("Finalizado el proceso!!! en " + sdf.format(new java.util.Date(finProceso - inicioProceso)));
				output.close();
				entrada.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
