package gt.impower.jam.thirteen.qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class FairSquare {
	static Writer output;

	public boolean esPalindromo(BigInteger pNumero) {
		String original = pNumero.toString();
		StringBuffer modificado = new StringBuffer(original).reverse();
		
		if(original.equals(modificado.toString())) {
			return true;
		} else {
			return false;
		}
	}
	
	public long encontrarFairAndSquare(BigInteger pInferior, BigInteger pSuperior) {
		// determinar raiz cuadrada mas cercana a limite superior
		double raizMasGrande = Math.sqrt(pSuperior.doubleValue());
		double raizMasPequena = Math.sqrt(pInferior.doubleValue());
		BigInteger fairAndSquare = new BigInteger("0");
		BigInteger raizMasGrandeBI = new BigDecimal(raizMasGrande).toBigInteger();
		BigInteger raizMasPequenaBI = new BigDecimal(raizMasPequena).toBigInteger();
		System.out.println(raizMasPequenaBI);
		BigInteger cuadradoMasPequenoBI = new BigDecimal(Math.pow(raizMasPequenaBI.doubleValue(), new Double(2).doubleValue())).toBigInteger();
		System.out.println(raizMasPequenaBI + ", " + cuadradoMasPequenoBI + ", " + pInferior);
		if(cuadradoMasPequenoBI.compareTo(pInferior) < 0) {
			raizMasPequenaBI = raizMasPequenaBI.add(new BigInteger("1"));
		}
		//System.out.println(raizMasGrandeBI);
		for(BigInteger i = raizMasGrandeBI; i.compareTo(raizMasPequenaBI) >= 0; i = i.subtract(new BigInteger("1"))) {
			if(esPalindromo(i)) {
				BigInteger cuadrado = new BigDecimal(Math.pow(i.doubleValue(), new Double(2).doubleValue())).toBigInteger();
				if(esPalindromo(cuadrado)) {
					fairAndSquare = fairAndSquare.add(new BigInteger("1"));
				}
			}
		}
		return fairAndSquare.longValue();
	}
	
	public static void main(String[] args) {
		FairSquare app = new FairSquare();
		String path = "";
		String name = "C-small-attempt1";
		int cantCasos = 0;

		SimpleDateFormat sdf = new SimpleDateFormat("mm.ss.SSS");

		long inicioProceso = System.currentTimeMillis();
		try {
			File archivoEntrada = new File(path + name + ".in");
			File archivoSalida = new File(path + name + ".out");

			output = new BufferedWriter(new FileWriter(archivoSalida));

			BufferedReader entrada = new BufferedReader(new FileReader(
					archivoEntrada));
			try {
				String linea = null;
				int nLinea = 0;
				int caso = 1;

				while ((linea = entrada.readLine()) != null) {
					// procesar cada linea y agregarla al Collection
					Scanner scanner = new Scanner(linea);
					scanner.useDelimiter(" ");
					if (scanner.hasNext()) {
						if (nLinea == 0) {
							// cantidad de casos
							cantCasos = scanner.nextInt();
						} else {
							BigInteger limiteInferior = scanner.nextBigInteger();
							BigInteger limiteSuperior = scanner.nextBigInteger();
							// procesar limites
							
							long inicio = System.currentTimeMillis();
							long fairAndSquareEncontrados = app.encontrarFairAndSquare(limiteInferior, limiteSuperior);
							long fin = System.currentTimeMillis();
							output.write("Case #" + caso + ": " + fairAndSquareEncontrados + "\n");
							System.out.println("Case #" + caso + ": " + fairAndSquareEncontrados + " en " + sdf.format(new java.util.Date(fin - inicio)));
							caso++;
						}
						// int cumplidos = app.encontrarPatron(patron);
						// cumplidos + "\n");
						nLinea++;
					} else {
						System.out.println("Error al procesar la linea: " + linea);
					}

					scanner.close();
				}
			} finally {
				long finProceso = System.currentTimeMillis();
				System.out.println("Finalizado el proceso!!! en " + sdf.format(new java.util.Date(finProceso - inicioProceso)));
				output.close();
				entrada.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
