package gt.jl.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Collections;
import java.util.Iterator;
import java.util.List;
import java.util.Scanner;

class Celda {
	boolean norte;
	boolean oeste;
	boolean este;
	boolean sur;

	boolean verificada = false;

	int altitude;

	String basin;

	public Celda(int pAltitude, boolean pNorte, boolean pOeste, boolean pEste,
			boolean pSur) {
		this.altitude = pAltitude;
		this.norte = pNorte;
		this.oeste = pOeste;
		this.este = pEste;
		this.sur = pSur;
	}

	public Celda() {

	}

	public String toString() {
		return this.altitude + ":" + this.basin + ", " + this.norte + "."
				+ this.oeste + "." + this.este + "." + this.sur;
	}
}

public class Watersheds {

	static Writer output;
	static List<String> mapas = new ArrayList<String>();
	Celda[][] celdas = null;

	char letraBasinActual = 'a';

	public void limpiarVerificadas(int mapHeight, int mapWidth) {
		//char letraMayor = 'a';
		for(int i = 0; i < mapHeight; i++) {
			for(int j = 0; j < mapWidth; j++) {
				celdas[i][j].verificada = false;
				/*if(celdas[i][j].basin != null && letraMayor < celdas[i][j].basin.toCharArray()[0]) {
					System.out.println(letraMayor + "," + celdas[i][j].basin.toCharArray()[0]);
					letraMayor++;
					System.out.println(letraMayor);
				}*/
			}
		}
		//letraBasinActual=letraMayor;
	}

	public int verificarLetra(char pLetra, int mapHeight, int mapWidth) {
		int letraRetornar = -1;
		//char menor = 'a';
		for(int i = 0; i < mapHeight; i++) {
			for(int j = 0; j < mapWidth; j++) {
				if(pLetra == celdas[i][j].basin.charAt(0)) {
					letraRetornar = 1;
					break;
				}
			}
		}
		return letraRetornar;
	}

	public void reemplazarLetra(char pLetra, char pAnterior, int mapHeight, int mapWidth) {
		for(int i = 0; i < mapHeight; i++) {
			for(int j = 0; j < mapWidth; j++) {
				if(celdas[i][j].basin.charAt(0) == pAnterior) {
					celdas[i][j].basin = new Character(pLetra).toString();
				}
			}
		}
	}

	public void imprimirMapa(int mapHeight, int mapWidth) throws IOException {
		List<Character> pendientes = new ArrayList<Character>();
		char pendiente = '}';
		for(char abc = 'a'; abc <= 'z'; abc++) {
			int resultadoVerificar = verificarLetra(abc, mapHeight, mapWidth);
			if(resultadoVerificar == -1) {
				pendientes.add(new Character(abc));
			} else {
				Collections.sort(pendientes);
				pendiente = ((pendientes != null && pendientes.size() > 0) ? pendientes.get(0) : '}');
				if(pendiente < abc) {
					reemplazarLetra(pendiente, abc, mapHeight, mapWidth);
					pendientes.remove(0);
					pendientes.add(new Character(abc));
				}
			}

			pendiente = '}';
		}

		for(int i = 0; i < mapHeight; i++) {
			for(int j = 0; j < mapWidth; j++) {
				output.write(celdas[i][j].basin);
				if(j < mapWidth-1) {
					output.write(" ");
				}
			}
			output.write("\n");
		}
	}

	public void actualizarRelacionados(int k, int l, String pBasin, int viene) {
		// verificar la celda norte
		if(celdas[k][l].norte) {
			if(celdas[k][l].basin == celdas[k-1][l].basin && !celdas[k-1][l].verificada) {
				// tambien sufre cambio
				celdas[k-1][l].verificada = true;
				actualizarRelacionados(k-1, l, pBasin, 4);
				celdas[k-1][l].basin = pBasin;
			}
		}

		// verificar la celda oeste
		if(celdas[k][l].oeste) {
			if(celdas[k][l].basin == celdas[k][l-1].basin && !celdas[k][l-1].verificada) {
				// tambien sufre cambio
				celdas[k][l-1].verificada = true;
				actualizarRelacionados(k, l-1, pBasin, 3);
				celdas[k][l-1].basin = pBasin;
			}
		}

		// verificar la celda este
		if(celdas[k][l].este) {
			if(celdas[k][l].basin == celdas[k][l+1].basin && !celdas[k][l+1].verificada) {
				// tambien sufre cambio
				celdas[k][l+1].verificada = true;
				actualizarRelacionados(k, l+1, pBasin, 2);
				celdas[k][l+1].basin = pBasin;
			}
		}

		// verificar la celda sur
		if(celdas[k][l].sur) {
			if(celdas[k][l].basin == celdas[k+1][l].basin && !celdas[k+1][l].verificada) {
				// tambien sufre cambio
				celdas[k+1][l].verificada = true;
				actualizarRelacionados(k+1, l, pBasin, 1);
				celdas[k+1][l].basin = pBasin;
			}
		}
	}

	public void dibujarMapas(int mapHeight, int mapWidth, List<String> pMapas) throws IOException {
		letraBasinActual = 'a';

		celdas = new Celda[mapHeight][mapWidth];

		int i = 0;
		for (Iterator iterMapas = pMapas.iterator(); iterMapas.hasNext();) {
			String fila = (String) iterMapas.next();
			String[] strCeldas = fila.split(" ");
			for (int j = 0; j < strCeldas.length; j++) {
				celdas[i][j] = new Celda(Integer.parseInt(strCeldas[j]), !(i == 0), !(j == 0), !(j == mapWidth-1), !(i == mapHeight-1));
			}
			i++;
		}

		int filBasin = -1;
		int colBasin = -1;
		Celda celdaBasin = new Celda();
		for(int k = 0; k < mapHeight; k++) {
			for(int l = 0; l < mapWidth; l++) {
				if(celdas[k][l].norte) {
					if(celdas[k][l].altitude > celdas[k-1][l].altitude) {
						filBasin = k-1;
						colBasin = l;
						celdaBasin = celdas[filBasin][colBasin];
					}
				}

				if(celdas[k][l].oeste) {
					if(celdas[k][l].altitude > celdas[k][l-1].altitude) {
						if(filBasin > -1) {
							if(celdas[filBasin][colBasin].altitude > celdas[k][l-1].altitude) {
								filBasin = k;
								colBasin = l-1;
								celdaBasin = celdas[filBasin][colBasin];
							}
						} else {
							filBasin = k;
							colBasin = l-1;
							celdaBasin = celdas[filBasin][colBasin];
						}
					}
				}

				if(celdas[k][l].este) {
					if(celdas[k][l].altitude > celdas[k][l+1].altitude) {
						if(filBasin > -1) {
							if(celdas[filBasin][colBasin].altitude > celdas[k][l+1].altitude) {
								filBasin = k;
								colBasin = l+1;
								celdaBasin = celdas[filBasin][colBasin];
							}
						} else {
							filBasin = k;
							colBasin = l+1;
							celdaBasin = celdas[filBasin][colBasin];
						}
					}
				}

				if(celdas[k][l].sur) {
					if(celdas[k][l].altitude > celdas[k+1][l].altitude) {
						if(filBasin > -1) {
							if(celdas[filBasin][colBasin].altitude > celdas[k+1][l].altitude) {
								filBasin = k+1;
								colBasin = l;
								celdaBasin = celdas[filBasin][colBasin];
							}
						} else {
							filBasin = k+1;
							colBasin = l;
							celdaBasin = celdas[filBasin][colBasin];
						}
					}
				}

				if(filBasin == -1 || celdas[filBasin][colBasin].basin == null) {
					if(celdas[k][l].basin == null) {
						celdas[k][l].basin = new Character(letraBasinActual++).toString();
					}
					if(filBasin > -1) {
						celdas[filBasin][colBasin].basin = celdas[k][l].basin;
					}
				} else if(celdas[filBasin][colBasin].basin != null) {
					if(celdas[k][l].basin != null) {
						// actualizar las celdas relacionadas a k,l
						limpiarVerificadas(mapHeight, mapWidth);
						celdas[k][l].verificada = true;
						actualizarRelacionados(k, l, celdas[filBasin][colBasin].basin, 0);
					}
					celdas[k][l].basin = celdas[filBasin][colBasin].basin;
				}

				filBasin = -1;
				colBasin = -1;

				/*output.write(celdas[k][l].basin);
				System.out.print(celdas[k][l].basin);
				if(l < mapWidth-1) {
					output.write(" ");
					System.out.print(" ");
				}*/
			}
			/*output.write("\n");
			System.out.println();*/
		}
	}

	public static void main(String[] args) {
		Watersheds app = new Watersheds();
		String path = "";
		String name = "WatershedsTest";
		int cantMapas = 0;
		int mapWidth = 0;
		int mapHeight = 0;

		try {
			File archivoEntrada = new File(path + name + ".in");
			File archivoSalida = new File(path + name + ".out");

			output = new BufferedWriter(new FileWriter(archivoSalida));

			BufferedReader entrada = new BufferedReader(new FileReader(
					archivoEntrada));
			try {
				String linea = null;
				int nLinea = 0;
				int caso = 1;
				int lineaDimensiones = 1;
				boolean cambioMapa = false;

				while ((linea = entrada.readLine()) != null) {
					// procesar cada linea y agregarla al Collection
					Scanner scanner = new Scanner(linea);
					scanner.useDelimiter(" ");
					if (scanner.hasNext()) {
						if (nLinea == 0) {
							// cantidad de mapas
							// los datos iniciales
							cantMapas = scanner.nextInt();
						} else if (nLinea == lineaDimensiones) {
							// las dimensiones
							mapHeight = scanner.nextInt();
							mapWidth = scanner.nextInt();
							lineaDimensiones += mapHeight + 1;
							mapas = new ArrayList<String>();
						} else {
							// los mapas
							String mapa = linea;
							// System.out.println(mapa);
							mapas.add(mapa);
							if (lineaDimensiones - nLinea == 1) {
								// procesar el mapa
								//System.out.println(mapHeight + "," + mapWidth);
								//System.out.println(mapas);
								output.write("Case #" + caso + ":\n");
								app.dibujarMapas(mapHeight, mapWidth, mapas);
								app.imprimirMapa(mapHeight, mapWidth);
								caso++;
							}
							// int cumplidos = app.encontrarPatron(patron);
							// cumplidos + "\n");
						}
						nLinea++;

					} else {
						System.out.println("Error al procesar la linea: "
								+ linea);
					}

					scanner.close();
				}
			} finally {
				System.out.println("Finalizado el proceso!!!");
				output.close();
				entrada.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
