package gt.impower.jam.thirteen.qr;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.Writer;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.Scanner;

public class Lawnmower {
	static Writer output;
	
	int[][] cespedInt;
	
	public boolean procesarCespedMayor(int pMayor) {
		int nuevoMayor = 0;
		boolean posible = true;
		for(int i = 0; i < cespedInt.length; i++) {
			for(int j = 0; j < cespedInt[0].length; j++) {
				if(cespedInt[i][j] > 0) {
					cespedInt[i][j] = pMayor - cespedInt[i][j];
				}
				if(cespedInt[i][j] > nuevoMayor) {
					nuevoMayor = cespedInt[i][j];
				}
			}
		}
		
		if(nuevoMayor > 0) {
			int orillaMayor = 0;
			for(int a = 0; a < cespedInt.length; a++) {
				for(int b = 0; b < cespedInt[0].length; b++) {
					if((a > 0 && b > 0) && (a < cespedInt.length - 1 && b < cespedInt[0].length - 1) && cespedInt[a][b] == 0) {
						// revisar casillas adyacentes
						if(cespedInt[a - 1][b] > 0 && cespedInt[a][b - 1] > 0 && cespedInt[a + 1][b] > 0 && cespedInt[a][b + 1] > 0) {
							posible = false;
							break;
						}
					}
					
					if((a == 0 || b == 0) && cespedInt[a][b] > 0) {
						orillaMayor++;						
					}
				}
				if(!posible) {
					break;
				}
			}
			
			if(orillaMayor == 0) {
				posible = false;
			}
			
			if(posible) {
				posible = procesarCespedMayor(nuevoMayor);
			}
		}
		
		return posible;
	}

	public boolean procesarCespedMenor(int pMenor) {
		int nuevoMenor = 100;
		int orillaMayorCero = 0;
		boolean posible = true;
		int[][] cespedTmp = new int[1][1];
		for(int i = 0; i < cespedInt.length; i++) {
			for(int j = 0; j < cespedInt[0].length; j++) {
				if(cespedInt[i][j] > 0) {
					cespedInt[i][j] = cespedInt[i][j] - pMenor;
				}
				if(cespedInt[i][j] < nuevoMenor) {
					nuevoMenor = cespedInt[i][j];
				}
				
				if((i == 0 || j == 0) && cespedInt[i][j] > 0) {
					orillaMayorCero++;
				}
				
				if(cespedInt.length > 2 && cespedInt[0].length > 2) {
					cespedTmp = new int[cespedInt.length - 2][cespedInt[0].length - 2];
					if(i > 0 && j > 0 && i < cespedInt.length - 1 && j < cespedInt[0].length - 1) {
						cespedTmp[i - 1][j - 1] = cespedInt[i][j];
					}
				}
			}
		}
		
		if(orillaMayorCero == 0) {
			cespedInt = cespedTmp;
		}
		
		if(nuevoMenor < 100) {
			for(int a = 0; a < cespedInt.length; a++) {
				for(int b = 0; b < cespedInt[0].length; b++) {
					if((a > 0 && b > 0) && (a < cespedInt.length - 1 && b < cespedInt[0].length - 1) && cespedInt[a][b] > 0) {
						// revisar casillas adyacentes
						if(cespedInt[a - 1][b] == 0 && cespedInt[a][b - 1] == 0 && cespedInt[a + 1][b] == 0 && cespedInt[a][b + 1] == 0) {
							posible = false;
							break;
						}
					}
					
					/*if(cespedInt[a][b] > 0 && cespedInt.length > 2 && cespedInt[0].length > 2) {
						// verificar adyacentes
						int adyacentes = 0;
						if(a == 0) {
							if(cespedInt[a + 1][b] == 0) {
								adyacentes++;
							}
							if(b < cespedInt[0].length - 1 && cespedInt[a][b + 1] == 0) {
								adyacentes++;
							}
							if(b > 0 && cespedInt[a][b - 1] == 0) {
								adyacentes++;
							}
						} else if(b == 0) {
							if(cespedInt[a][b + 1] == 0) {
								adyacentes++;
							}
							if(a < cespedInt.length - 1 && cespedInt[a + 1][b] == 0) {
								adyacentes++;
							}
							if(a > 0 && cespedInt[a - 1][b] == 0) {
								adyacentes++;
							}
						}
						
						if(adyacentes == 1) {
							posible = false;
							break;
						}
					}*/
				}
				if(!posible) {
					break;
				}
			}
			
			if(posible) {
				posible = procesarCespedMenor(nuevoMenor);
			}
		}
		
		return posible;
	}
	
	public boolean procesarCespedTres(int pHeight, int pWidth) {
		boolean posible = true;
		int posibleHor = 0;
		int posibleVer = 0;
		
		for(int i = 0; i < pHeight; i++) {
			int inicio = cespedInt[i][0];
			int fin = cespedInt[i][pWidth - 1];
			int mayori = 0;
			for(int j = 0; j < pWidth; j++) {
				if(cespedInt[i][j] > mayori) {
					mayori = cespedInt[i][j];
				}
				if(mayori < inicio && mayori < fin) {
					posible = false;
					break;
				}
			}
			
			if(!posible) {
				posible = true;
				inicio = cespedInt[i][pWidth - 1];
				fin = cespedInt[i][0];
				mayori = 0;
				for(int a = pWidth - 1; a >= 0; a--) {
					if(cespedInt[i][a] > mayori) {
						mayori = cespedInt[i][a];
					}
					if(mayori < inicio && mayori < fin) {
						posible = false;
						break;
					}
				}
			}
			
			if(posible) {
				posibleHor++;
			}
		}
		
		if(posibleHor < pHeight) {
			posible = true;
			for(int a = 0; a < pWidth; a++) {
				int inicio = cespedInt[0][a];
				int fin = cespedInt[pHeight - 1][a];
				int mayora = 0;
				for(int b = 0; b < pHeight; b++) {
					if(cespedInt[b][a] > mayora) {
						mayora = cespedInt[b][a];
					}
					if(mayora < inicio && mayora < fin) {
						posible = false;
						break;
					}
				}
				
				if(!posible) {
					posible = true;
					inicio = cespedInt[pHeight - 1][a];
					fin = cespedInt[0][a];
					mayora = 0;
					for(int i = pHeight - 1; i >= 0; i--) {
						if(cespedInt[i][a] > mayora) {
							mayora = cespedInt[i][a];
						}
						if(mayora < inicio && mayora < fin) {
							posible = false;
							break;
						}
					}
				}
				
				if(posible) {
					posibleVer++;
				}
			}
		} else {
			return true;
		}
		
		if(posibleVer < pWidth) {
			return false;
		}
		
		return true;
	}
	
	public int procesarCespedCuatro(int pHeight, int pWidth, int pMayor) {
		int nuevoMayor = 0;
		for(int i = 0; i < pHeight; i++) {
			for(int j = 0; j < pWidth; j++) {
				if(cespedInt[i][j] == pMayor) {
					cespedInt[i][j] = 0;
				} else if(cespedInt[i][j] > nuevoMayor) {
					nuevoMayor = cespedInt[i][j];
				}
			}
		}
		return nuevoMayor;
	}
	
	public int verificarUnosPosibles(int pHeight, int pWidth) {
		boolean posible = true;
		int unosPosibles = 0;
		int posibleHor = 0;
		int posibleVer = 0;
		
		for(int i = 0; i < pHeight; i++) {
			int inicio = cespedInt[i][0];
			for(int j = 0; j < pWidth; j++) {
				if(cespedInt[i][j] > inicio) {
					posible = false;
					break;
				}
			}
			
			if(!posible) {
				posible = true;
				inicio = cespedInt[i][pWidth - 1];
				for(int a = pWidth - 1; a >= 0; a--) {
					if(cespedInt[i][a] > inicio) {
						posible = false;
						break;
					}
				}
			}
			
			if(posible) {
				for(int k = 0; k < pWidth; k++) {
					if(cespedInt[i][k] == 1) {
						unosPosibles++;
					}
				}
			}
		}
		
		posible = true;
		for(int a = 0; a < pWidth; a++) {
			int inicio = cespedInt[0][a];
			for(int b = 0; b < pHeight; b++) {
				if(cespedInt[b][a] > inicio) {
					posible = false;
					break;
				}
			}
			
			if(!posible) {
				posible = true;
				inicio = cespedInt[pHeight - 1][a];
				for(int i = pHeight - 1; i >= 0; i--) {
					if(cespedInt[i][a] > inicio) {
						posible = false;
						break;
					}
				}
			}
			
			if(posible) {
				for(int k = 0; k < pHeight; k++) {
					if(cespedInt[k][a] == 1) {
						unosPosibles++;
					}
				}
			}
		}
		
		return unosPosibles;
	}

	public boolean procesarUnos(int pHeight, int pWidth) {
		//contar la cantidad de unos que hay
		int cantidadUnos = 0;
		for(int i = 0; i < pHeight; i++) {
			for(int j = 0; j < pWidth; j++) {
				if(cespedInt[i][j] == 1) {
					cantidadUnos++;
				}
			}
		}
		//verificar cuantos son posibles vertical y horizontal
		//verificar cuantos unos se pueden abarcar con los posibles
		int cantidadUnosPosibles = verificarUnosPosibles(pHeight, pWidth);
		//si la cantidad de unos posibles es mayor que la cantidad de unos que hay, return true
		if(cantidadUnos < cantidadUnosPosibles) {
			return true;
		} else {
			return false;
		}
	}
	
	public boolean procesar(int pHeight, int pWidth, int pMayor) {
		int nuevoMayor = 0;
		boolean posible = procesarCespedTres(pHeight, pWidth);
		if(posible) {
			nuevoMayor = procesarCespedCuatro(pHeight, pWidth, pMayor);
			if(nuevoMayor > 1) {
				posible = procesar(pHeight, pWidth, nuevoMayor);
			} else if(nuevoMayor == 1) {
				// procesarUnos
				posible = procesarUnos(pHeight, pWidth);
			}
		}
		
		return posible;
	}

	public String determinarPosibilidad(String[] pCesped, int pHeight, int pWidth) {
		String resultado = "";
		cespedInt = new int[pHeight][pWidth];
		int mayor = 0;
		
		for(int i = 0; i < pHeight; i++) {
			String row = pCesped[i];
			for(int j = 0; j < pWidth; j++) {
				cespedInt[i][j] = new Integer(row.split(" ")[j]).intValue();
				if(cespedInt[i][j] > mayor) {
					mayor = cespedInt[i][j];
				}
			}
		}
		
		//System.out.println(menor);
		//boolean posible = procesarCespedMayor(mayor);
		//boolean posible = procesarCespedMenor(menor);
		//boolean posible = procesarCespedTres(pHeight, pWidth);
		boolean posible = procesar(pHeight, pWidth, mayor);
		/*System.out.println(posible);
		if(posible) {
			posible = procesarCespedMenor(menor);
		}*/
		//System.out.println(posible);
		
		return (posible ? "YES" : "NO");
		//return "";
	}
	
	public static void main(String[] args) {
		Lawnmower app = new Lawnmower();
		String path = "";
		String name = "B-small-attempt0";
		int cantCasos = 0;
		SimpleDateFormat sdf = new SimpleDateFormat("mm.ss.SSS");

		long inicioProceso = System.currentTimeMillis();
		try {
			File archivoEntrada = new File(path + name + ".in");
			File archivoSalida = new File(path + name + ".out");

			output = new BufferedWriter(new FileWriter(archivoSalida));

			BufferedReader entrada = new BufferedReader(new FileReader(
					archivoEntrada));
			try {
				String linea = null;
				int nLinea = 0;
				int caso = 1;

				while ((linea = entrada.readLine()) != null) {
					// procesar cada linea y agregarla al Collection
					Scanner scanner = new Scanner(linea);
					scanner.useDelimiter(" ");
					if (scanner.hasNext()) {
						if (nLinea == 0) {
							// cantidad de casos
							cantCasos = scanner.nextInt();
						} else {
							int height = scanner.nextInt();
							int width = scanner.nextInt();
							String[] lawn = new String[height];
							for(int i = 0; i < height; i++) {
								lawn[i] = entrada.readLine();
							}
							// procesar cesped
							long inicio = System.currentTimeMillis();
							String resultado = app.determinarPosibilidad(lawn, height, width);
							long fin = System.currentTimeMillis();
							output.write("Case #" + caso + ": " + resultado + "\n");
							System.out.println("Case #" + caso + ": " + resultado + " en " + sdf.format(new java.util.Date(fin - inicio)));
							caso++;
						}
						// int cumplidos = app.encontrarPatron(patron);
						// cumplidos + "\n");
						nLinea++;
					} else {
						System.out.println("Error al procesar la linea: " + linea);
					}

					scanner.close();
				}
			} finally {
				long finProceso = System.currentTimeMillis();
				System.out.println("Finalizado el proceso!!! en " + sdf.format(new java.util.Date(finProceso - inicioProceso)));
				output.close();
				entrada.close();
			}
		} catch (IOException ex) {
			ex.printStackTrace();
		}
	}
}
