/**
 * @(#)BacLarge.java
 *
 *
 * @author 
 * @version 1.00 2010/6/5
 */
import java.io.*;
import java.util.Scanner;
import java.util.ArrayList;
import java.lang.Math;

public class BacLarge {

		public ArrayList<myBox> boxes;

    public BacLarge(ArrayList<myBox> boxes) {
    	this.boxes = boxes;
    }
    
    public boolean canMerge(myBox b1, myBox b2){
    	if(b1.x2 == b2.x1-1 && b1.y1 >= b2.y2+1)
    		return true;
    	else if(b1.y1 == b2.y2+1 && b1.x2 >= b2.x1-1)
    		return true;
    	else if(b2.x2 == b1.x1-1 && b2.y1 >= b1.y2+1)
    		return true;
    	else if(b2.y1 == b1.y2+1 && b2.x2 >= b1.x1-1)
    		return true;
    	else
    		return false;
    }
    
    public myBox merge(myBox b1, myBox b2)
    {
    	int x1 = Math.min(b1.x1, b2.x1);
    	int x2 = Math.max(b1.x2, b2.x2);
    	int y1 = Math.min(b1.y1, b2.y1);
    	int y2 = Math.max(b1.y2, b2.y2);
    	myBox newBox = new myBox(x1,x2,y1,y2);
    	int b1ygain = y2 - b1.y2;
    	int b1xgain = x2 - b1.x2;
    	int b1gain = Math.max(b1ygain, b1xgain);
    	int b2ygain = y2 - b2.y2;
    	int b2xgain = x2 - b2.x2;
    	int b2gain = Math.max(b2ygain, b2xgain);
    	newBox.score = Math.max(b1.score+b1gain, b2.score+b2gain);
    	return newBox;
    }
    
    
    public int solve()
    {
    	int numBoxes = boxes.size()+1;
    	boolean flag = false;
    	while(boxes.size() != numBoxes)
    	{
    		ArrayList<myBox> newBoxes = new ArrayList<myBox>();
    		numBoxes = boxes.size();
    		for(int i = 0; i < boxes.size(); i++)
    		{
    			flag = false;
    			for(int j = i+1; j < boxes.size(); j++)
    			{
    				if(canMerge(boxes.get(i), boxes.get(j)))
    				{
    					myBox merged = this.merge(boxes.get(i), boxes.get(j));
    					boxes.remove(j);
    					newBoxes.add(merged);
    					flag = true;
    					break;
    				}
    			}
    			if(!flag)
    			{
    				newBoxes.add(boxes.get(i));
    			}
    			else{
    				boxes.remove(i);
    				i = i-1;
    			}
    		}
    		boxes = newBoxes;
    	}
    	
    	int maxScore = 0;
    	for(int i = 0; i < boxes.size(); i++)
    	{
    		if(boxes.get(i).score > maxScore)
    			maxScore = boxes.get(i).score;
    	}
    	return maxScore;
    }
    
    
    
    
    public static void main(String[] args){
    	String filename = args[0];
    	
    	try{
    	File file = new File(filename);
    	
    	Scanner sc = new Scanner(file);
    	
    	int numCases = sc.nextInt();
    	
    	for(int i = 0; i < numCases; i++)
    	{
    		
    		int numBoxes = sc.nextInt();
    		ArrayList<myBox> boxes = new ArrayList<myBox>();
    		for(int j = 0; j < numBoxes; j++)
    		{
    			int x1 = sc.nextInt();
    			int y1 = sc.nextInt();
    			int x2 = sc.nextInt();
    			int y2 = sc.nextInt();
    			myBox box = new myBox(x1,x2,y1,y2);
    			boxes.add(box);
    		}
    		BacLarge solver = new BacLarge(boxes);
    		
    		int answer = solver.solve();
    		System.out.println("Case #" + (i+1) + ": " + answer);
    	}
    	
    	
    	}
    	catch(Exception e){
    		System.out.println(e);
    	}
    }
}