import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class Solution3 {

    public static boolean isPrime(long num) {
        if (num > 2 && num % 2 == 0) {
            return false;
        }
        long top = (long) Math.sqrt(num) + 1;
        for (int i = 3; i < top; i += 2) {
            if (num % i == 0) {
                return false;
            }
        }
        return true;
    }

    public static long getFactor(long num) {
        long i = 2;

        while (i < num) {
            if (num % i == 0)
                break;

            i++;
        }
        return i;
    }

    public static long pow(long base, long power) {
        if (power == 0) return 1;
        return base * pow(base, --power);
    }

    public static String addBinary(String a, String b) {
        int m = a.length();
        int n = b.length();
        int carry = 0;
        String res = "";
        int maxLen = Math.max(m, n);
        for (int i = 0; i < maxLen; i++) {
            int p = i < m ? a.charAt(m - 1 - i) - '0' : 0;
            int q = i < n ? b.charAt(n - 1 - i) - '0' : 0;
            int tmp = p + q + carry;
            carry = tmp / 2;
            res = tmp % 2 + res;
        }
        return (carry == 0) ? res : "1" + res;
    }

    public static long baseConvert(int base, String num) {
        long value = 0;
        for (int i = 0; i < num.length(); i++)
            value += Character.getNumericValue(num.charAt(i)) * pow(base, num.length() - i - 1);

        return value;
    }

    public static void main(String[] args) throws FileNotFoundException {
        File infile = new File("in/C-small-attempt0.in");
        Scanner in = new Scanner(infile);
        PrintWriter out = new PrintWriter("out/C-output.txt");
        in.nextLine();

        int N = in.nextInt();
        int J = in.nextInt();
        String coin = Long.toString(pow(10, N - 1) + 1);
        int found = 0;
        String[] baseList = new String[9];
        long[] factors = new long[9];

        out.write("Case #1: \n");

        while (found < J && coin.length() <= N) {
            baseList[0] = Long.toString(baseConvert(2, coin));
            baseList[1] = Long.toString(baseConvert(3, coin));
            baseList[2] = Long.toString(baseConvert(4, coin));
            baseList[3] = Long.toString(baseConvert(5, coin));
            baseList[4] = Long.toString(baseConvert(6, coin));
            baseList[5] = Long.toString(baseConvert(7, coin));
            baseList[6] = Long.toString(baseConvert(8, coin));
            baseList[7] = Long.toString(baseConvert(9, coin));
            baseList[8] = coin;
            boolean isJamCoins = true;

            for (int i = 0; i < baseList.length; i++) {
                //System.out.println(baseList[i]);
                if (isPrime(Long.parseLong(baseList[i]))) {
                    isJamCoins = false;
                    break;
                }
            }

            if (isJamCoins) {
                for (int i = 0; i < baseList.length; i++) {
                    factors[i] = getFactor(Long.parseLong(baseList[i]));
                }

                out.write(coin + " ");

                for (int i = 0; i < factors.length; i++) {
                    out.write(factors[i] + " ");
                }
                out.write("\n");
                found++;
            }

            coin = addBinary(coin, "1");
            while (coin.charAt(coin.length() - 1) != '1' || coin.charAt(0) != '1')
                coin = addBinary(coin, "1");
        }

        in.close();
        out.close();
    }
}
