import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Scanner;

public class Solution3 {
    public static boolean isPrime(BigInteger n) {
        BigInteger lessOne = n.subtract(BigInteger.ONE);
        return lessOne.nextProbablePrime().compareTo(n) == 0;
    }

    public static String addBinary(String a, String b) {
        int m = a.length();
        int n = b.length();
        int carry = 0;
        String res = "";
        int maxLen = Math.max(m, n);
        for (int i = 0; i < maxLen; i++) {
            int p = i < m ? a.charAt(m - 1 - i) - '0' : 0;
            int q = i < n ? b.charAt(n - 1 - i) - '0' : 0;
            int tmp = p + q + carry;
            carry = tmp / 2;
            res = tmp % 2 + res;
        }
        return (carry == 0) ? res : "1" + res;
    }

    public static BigInteger tdFactors(BigInteger n) {
        BigInteger two = BigInteger.valueOf(2);
        BigInteger f = BigInteger.valueOf(3);

        if (n.compareTo(two) < 0) {
            throw new IllegalArgumentException("must be greater than one");
        }

        if (n.mod(two).equals(BigInteger.ZERO)) {
            return two;

        }

        while (f.multiply(f).compareTo(n) <= 0) {
            if (n.mod(f).equals(BigInteger.ZERO)) {
                break;
            } else {
                f = f.add(two);
            }
        }

        return f;
    }

    public static void main(String[] args) throws FileNotFoundException {
        File infile = new File("in/C-test.in");
        Scanner in = new Scanner(infile);
        PrintWriter out = new PrintWriter("out/C-output.txt");
        in.nextLine();

        int N = in.nextInt();
        int J = in.nextInt();
        String coin = "1";
        int found = 0;
        BigInteger[] baseList = new BigInteger[9];

        for (int i = 0; i < N - 2; i++) {
            coin += "0";
        }

        coin += "1";
        out.write("Case #1: \n");

        while (found < J && coin.length() <= N) {
            baseList[0] = new BigInteger(coin, 2);
            baseList[1] = new BigInteger(coin, 3);
            baseList[2] = new BigInteger(coin, 4);
            baseList[3] = new BigInteger(coin, 5);
            baseList[4] = new BigInteger(coin, 6);
            baseList[5] = new BigInteger(coin, 7);
            baseList[6] = new BigInteger(coin, 8);
            baseList[7] = new BigInteger(coin, 9);
            baseList[8] = new BigInteger(coin, 10);
            boolean isJamCoins = true;

            for (int i = 0; i < baseList.length; i++) {
                if (isPrime(baseList[i])) {
                    isJamCoins = false;
                    break;
                }
            }

            if (isJamCoins) {
                out.write(coin + " ");
                for (int i = 0; i < baseList.length; i++) {
                    out.write(tdFactors(baseList[i]) + " ");
                }
                out.write("\n");
                found++;
            }

            String innerCoin = coin.substring(1, coin.length() - 1);
            innerCoin = addBinary(innerCoin, "1");
            coin = "1" + innerCoin + "1";
        }

        in.close();
        out.close();
    }
}
