/**
 * Author: amit.zur
 * Date: 03/09/2009
 */

import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;
import java.io.*;

/**
 * TODO: JavaDoc
 */
public class CodeJam2009 {
	public static void main(String[] args) throws IOException {
		String inputPath = "d:\\codejam\\2009\\B-small-attempt1.in";
		String outputPath = "d:\\codejam\\2009\\B-small-attempt1.out";
//		solveAlienLang(inputPath, outputPath);
		solveWatersheds(inputPath, outputPath);
	}

	/*************** Alien Language *************************/

	private static void solveAlienLang(String inputPath, String outputPath) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(inputPath));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath));
		String firstLine = reader.readLine();
		String[] firstLineArr = firstLine.split(" ");
		int L = Integer.parseInt(firstLineArr[0]);
		int D = Integer.parseInt(firstLineArr[1]);
		int N = Integer.parseInt(firstLineArr[2]);
		String[] words = new String[D];
		List<Character>[] testCase;
		for (int i = 0; i < D; i++) {
			words[i] = reader.readLine();
		}
		for (int i = 0; i < N; i++) {
			testCase = compileTestCase(reader.readLine(), L);
			int solution = solveTestCase(testCase, words);
			writer.write("Case #" + (i+1) + ": " + solution + "\n");
		}
		reader.close();
		writer.flush();
		writer.close();
		System.out.println('a' + "s");
	}

	private static int solveTestCase(List<Character>[] testCase, String[] words) {
		if (words.length == 0) return 0;
		if (testCase.length == 0) return 1;

		int result = 0;
		for (int i = 0; i < testCase[0].size(); i++) {
			char curr = testCase[0].get(i);
			List<String> newWords = new ArrayList<String>();
			for (String word : words) {
				if (word.charAt(0) == curr) {
					newWords.add(word.substring(1));
				}
			}

			int newLength = testCase.length-1;
			List<Character>[] newTestCase = (List<Character>[]) new List[newLength];
			System.arraycopy(testCase, 1, newTestCase, 0, newLength);

			result += solveTestCase(newTestCase, newWords.toArray(new String[newWords.size()]));
		}
		return result;
	}

	private static List<Character>[] compileTestCase(String str, int L) {
		List<Character>[] result = (List<Character>[]) new List[L];
		for (int i = 0; i < L; i++) {
			result[i] = new ArrayList<Character>();
		}
		int pos = 0;
		boolean insidePar = false;
		for (int i = 0; i < str.length(); i++) {
			char curr = str.charAt(i);
			if (curr == '(') {
				insidePar = true;
				continue;
			}
			if (curr == ')') {
				insidePar = false;
				pos++;
				continue;
			}
			if (curr >= 'a' && curr <= 'z') {
				result[pos].add(curr);
				if (!insidePar) pos++;
			}
		}
		return result;
	}

	/*************** END Alien Language *************************/

	/*************** Watersheds *************************/

	private static void solveWatersheds(String inputPath, String outputPath) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(inputPath));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath));

		int cases = Integer.parseInt(reader.readLine());
		for (int t = 0; t < cases; t++) {
			String[] mapSize = reader.readLine().split(" ");
			int height = Integer.parseInt(mapSize[0]);
			int width = Integer.parseInt(mapSize[1]);

			int[][] map = new int[height][width];
			for (int i = 0; i < height; i++) {
				String[] heights = reader.readLine().split(" ");
				for (int j = 0; j < width; j++) {
					map[i][j] = Integer.parseInt(heights[j]);
				}
			}
			char[][] solution = solveMap(map);

			writer.write("Case #" + (t+1) + ":\n");
			for (int i = 0; i < solution.length; i++) {
				for (int j = 0; j < solution[i].length-1; j++) {
					writer.write(solution[i][j] + " ");
				}
				writer.write(solution[i][solution[i].length-1] + "\n");
			}
		}
		reader.close();
		writer.flush();
		writer.close();
	}

	private static char[][] solveMap(int[][] map) {
		char[][] result = new char[map.length][map[0].length];
		initResult(result);
		assignSinks(map, result);

		for (int j = 0; j < map[0].length; j++) {
			for (int i = 0; i < map.length; i++) {
				if (result[i][j] == '$') {
					result[i][j] = assignCell(i,j,map,result);
				}
			}
		}

		return result;
	}

	private static void initResult(char[][] result) {
		for (int i = 0; i < result.length; i++) {
			char[] chars = result[i];
			for (int j = 0; j < chars.length; j++) {
				result[i][j] = '$';
			}
		}
	}

	private static char assignCell(int i, int j, int[][] map, char[][] result) {
		int width = map[0].length;
		int height = map.length;
		
		int north = i>0 ? map[i-1][j] : Integer.MAX_VALUE;
		int west = j>0 ? map[i][j-1] : Integer.MAX_VALUE;
		int south = i<height-1 ? map[i+1][j] : Integer.MAX_VALUE;
		int east = j<width-1 ? map[i][j+1] : Integer.MAX_VALUE;

		int min = findMin(north, west, south, east);
		if (north == min) {
			if (result[i-1][j] == '$') {
				result[i][j] = assignCell(i-1, j, map, result);
			} else {
				return result[i-1][j];
			}
		} else if (west == min) {
			if (result[i][j-1] == '$') {
				result[i][j] = assignCell(i, j-1, map, result);
			} else {
				return result[i][j-1];
			}
		} else if (east == min) {
			if (result[i][j+1] == '$') {
				result[i][j] = assignCell(i, j+1, map, result);
			} else {
				return result[i][j+1];
			}
		} else if (south == min) {
			if (result[i+1][j] == '$') {
				result[i][j] = assignCell(i+1, j, map, result);
			} else {
				return result[i+1][j];
			}
		}


		return result[i][j];
	}

	private static int findMin(int north, int west, int south, int east) {
		int[] arr = new int[4];
		arr[0] = north;
		arr[1] = west;
		arr[2] = south;
		arr[3] = east;
		Arrays.sort(arr);
		return arr[0];
	}

	private static void assignSinks(int[][] map, char[][] result) {
		char curr = 'a';
		for (int j = 0; j < map[0].length; j++) {
			for (int i = 0; i < map.length; i++) {
				if (isSink(i,j,map)) {
					result[i][j] = curr++;
				}
			}
		}
	}

	private static boolean isSink(int i, int j, int[][] map) {
		int width = map[0].length;
		int height = map.length;

		int north = i>0 ? map[i-1][j] : Integer.MAX_VALUE;
		int west = j>0 ? map[i][j-1] : Integer.MAX_VALUE;
		int south = i<height-1 ? map[i+1][j] : Integer.MAX_VALUE;
		int east = j<width-1 ? map[i][j+1] : Integer.MAX_VALUE;

		return map[i][j] <= north && map[i][j] <= south && map[i][j] <= west && map[i][j] <= east;
	}
}
