/**
 * Author: amit.zur
 * Date: 03/09/2009
 */

import java.util.List;
import java.util.ArrayList;
import java.util.Arrays;
import java.io.*;
import java.text.DecimalFormat;

/**
 * TODO: JavaDoc
 */
public class CodeJam2009 {
	final static String inputSmall = "d:\\codejam\\2009\\1c\\B-small-attempt2.in";
	final static String outputSmall = "d:\\codejam\\2009\\1c\\B-small-attempt2.out";
	final static String inputLarge = "d:\\codejam\\2009\\1c\\B-large.in";
	final static String outputLarge = "d:\\codejam\\2009\\1c\\B-large.out";
	final static String inputTest = "d:\\codejam\\2009\\1c\\A-test.in";
	final static String outputTest = "d:\\codejam\\2009\\1c\\A-test.out";
	
	public static void main(String[] args) throws IOException {
		String inputPath = inputLarge;
		String outputPath = outputLarge;
//		solveAlienLang(inputPath, outputPath);
//		solveWatersheds(inputPath, outputPath);
		solveCenterOfMass(inputPath, outputPath);
	}

	private static void solveCenterOfMass(String inputPath, String outputPath) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(inputPath));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath));
		int cases = Integer.parseInt(reader.readLine());
		for (int i = 1; i <= cases; i++) {
			int N = Integer.parseInt(reader.readLine());
			int[] x = new int[N];
			int[] y = new int[N];
			int[] z = new int[N];
			int[] vx = new int[N];
			int[] vy = new int[N];
			int[] vz = new int[N];
			int sx=0, sy=0, sz=0, svx=0, svy=0, svz=0;
			for (int j = 0; j < N; j++) {
				String[] arr = reader.readLine().split(" ");
				x[j] = Integer.parseInt(arr[0]);
				y[j] = Integer.parseInt(arr[1]);
				z[j] = Integer.parseInt(arr[2]);
				vx[j] = Integer.parseInt(arr[3]);
				vy[j] = Integer.parseInt(arr[4]);
				vz[j] = Integer.parseInt(arr[5]);
				sx += x[j];
				sy += y[j];
				sz += z[j];
				svx += vx[j];
				svy += vy[j];
				svz += vz[j];
			}
			double tx = -(double)sx*(double)svx;
			double ty = -(double)sy*(double)svy;
			double tz = -(double)sz*(double)svz;
			double ss = (double)(svx*svx + svy*svy + svz*svz);
			double t;
			if (ss == 0) {
				t=0;
			}  else {
				t = (tx+ty+tz)/(double)(svx*svx + svy*svy + svz*svz);
			}
			if (t<0) t=0;
			double mx = (sx + t*svx) / N;
			double my = (sy + t*svy) / N;
			double mz = (sz + t*svz) / N;
			double m = Math.sqrt(mx*mx + my*my + mz*mz);
			writer.write("Case #" + i + ": " + toMyString(m) + " " + toMyString(t) + "\n");
		}
		writer.flush();
		writer.close();

	}

	private static String toMyString(double m) {
		DecimalFormat df = new DecimalFormat("#.########");
		String s = df.format(m);
		if (s.length() == 10) return s;
		if (s.indexOf(".") < 0) {
			StringBuilder sb = new StringBuilder();
			sb.append(s).append(".").append("0");
			s = sb.toString();
		}
		if (s.length() < 10) {
			StringBuilder sb = new StringBuilder(s);
			for (int i = 0; i < 10-s.length(); i++) {
				sb.append("0");
			}
			return sb.toString();
		}
		return df.format(m);
	}

	/*************** Alien Language *************************/

	private static void solveAlienLang(String inputPath, String outputPath) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(inputPath));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath));
		String firstLine = reader.readLine();
		String[] firstLineArr = firstLine.split(" ");
		int L = Integer.parseInt(firstLineArr[0]);
		int D = Integer.parseInt(firstLineArr[1]);
		int N = Integer.parseInt(firstLineArr[2]);
		String[] words = new String[D];
		List<Character>[] testCase;
		for (int i = 0; i < D; i++) {
			words[i] = reader.readLine();
		}
		for (int i = 0; i < N; i++) {
			testCase = compileTestCase(reader.readLine(), L);
			int solution = solveTestCase(testCase, words);
			writer.write("Case #" + (i+1) + ": " + solution + "\n");
		}
		reader.close();
		writer.flush();
		writer.close();
	}

	private static int solveTestCase(List<Character>[] testCase, String[] words) {
		if (words.length == 0) return 0;
		if (testCase.length == 0) return 1;

		int result = 0;
		for (int i = 0; i < testCase[0].size(); i++) {
			char curr = testCase[0].get(i);
			List<String> newWords = new ArrayList<String>();
			for (String word : words) {
				if (word.charAt(0) == curr) {
					newWords.add(word.substring(1));
				}
			}

			int newLength = testCase.length-1;
			List<Character>[] newTestCase = (List<Character>[]) new List[newLength];
			System.arraycopy(testCase, 1, newTestCase, 0, newLength);

			result += solveTestCase(newTestCase, newWords.toArray(new String[newWords.size()]));
		}
		return result;
	}

	private static List<Character>[] compileTestCase(String str, int L) {
		List<Character>[] result = (List<Character>[]) new List[L];
		for (int i = 0; i < L; i++) {
			result[i] = new ArrayList<Character>();
		}
		int pos = 0;
		boolean insidePar = false;
		for (int i = 0; i < str.length(); i++) {
			char curr = str.charAt(i);
			if (curr == '(') {
				insidePar = true;
				continue;
			}
			if (curr == ')') {
				insidePar = false;
				pos++;
				continue;
			}
			if (curr >= 'a' && curr <= 'z') {
				result[pos].add(curr);
				if (!insidePar) pos++;
			}
		}
		return result;
	}

	/*************** END Alien Language *************************/

	/*************** Watersheds *************************/

	private static void solveWatersheds(String inputPath, String outputPath) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(inputPath));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath));

		int cases = Integer.parseInt(reader.readLine());
		for (int t = 0; t < cases; t++) {
			String[] mapSize = reader.readLine().split(" ");
			int height = Integer.parseInt(mapSize[0]);
			int width = Integer.parseInt(mapSize[1]);

			int[][] map = new int[height][width];
			for (int i = 0; i < height; i++) {
				String[] heights = reader.readLine().split(" ");
				for (int j = 0; j < width; j++) {
					map[i][j] = Integer.parseInt(heights[j]);
				}
			}
			char[][] solution = solveMap(map);

			writer.write("Case #" + (t+1) + ":\n");
			for (int i = 0; i < solution.length; i++) {
				for (int j = 0; j < solution[i].length-1; j++) {
					writer.write(solution[i][j] + " ");
				}
				writer.write(solution[i][solution[i].length-1] + "\n");
			}
		}
		reader.close();
		writer.flush();
		writer.close();
	}

	private static char[][] solveMap(int[][] map) {
		char[][] result = new char[map.length][map[0].length];
		initResult(result);
		assignSinks(map, result);

		for (int j = 0; j < map[0].length; j++) {
			for (int i = 0; i < map.length; i++) {
				if (result[i][j] == '$') {
					assignCell(i,j,map,result);
				}
			}
		}

		return result;
	}

	private static void initResult(char[][] result) {
		for (int i = 0; i < result.length; i++) {
			char[] chars = result[i];
			for (int j = 0; j < chars.length; j++) {
				result[i][j] = '$';
			}
		}
	}

	private static void assignCell(int i, int j, int[][] map, char[][] result) {
		int width = map[0].length;
		int height = map.length;
		
		int north = i>0 ? map[i-1][j] : Integer.MAX_VALUE;
		int west = j>0 ? map[i][j-1] : Integer.MAX_VALUE;
		int south = i<height-1 ? map[i+1][j] : Integer.MAX_VALUE;
		int east = j<width-1 ? map[i][j+1] : Integer.MAX_VALUE;

		int min = findMin(north, west, south, east);
		if (north == min) {
			if (result[i-1][j] == '$') {
				assignCell(i-1, j, map, result);
				result[i][j] = result[i-1][j];
			} else {
				result[i][j] = result[i-1][j];
			}
		} else if (west == min) {
			if (result[i][j-1] == '$') {
				assignCell(i, j-1, map, result);
				result[i][j] = result[i][j-1];
			} else {
				result[i][j] = result[i][j-1];
			}
		} else if (east == min) {
			if (result[i][j+1] == '$') {
				assignCell(i, j+1, map, result);
				result[i][j] = result[i][j+1];
			} else {
				result[i][j] = result[i][j+1];
			}
		} else if (south == min) {
			if (result[i+1][j] == '$') {
				assignCell(i+1, j, map, result);
				result[i][j] = result[i+1][j];
			} else {
				result[i][j] = result[i+1][j];
			}
		}
	}

	private static int findMin(int north, int west, int south, int east) {
		int[] arr = new int[4];
		arr[0] = north;
		arr[1] = west;
		arr[2] = south;
		arr[3] = east;
		Arrays.sort(arr);
		return arr[0];
	}

	private static void assignSinks(int[][] map, char[][] result) {
		char curr = 'a';
		for (int j = 0; j < map[0].length; j++) {
			for (int i = 0; i < map.length; i++) {
				if (isSink(i,j,map)) {
					result[i][j] = curr++;
				}
			}
		}
	}

	private static boolean isSink(int i, int j, int[][] map) {
		int width = map[0].length;
		int height = map.length;

		int north = i>0 ? map[i-1][j] : Integer.MAX_VALUE;
		int west = j>0 ? map[i][j-1] : Integer.MAX_VALUE;
		int south = i<height-1 ? map[i+1][j] : Integer.MAX_VALUE;
		int east = j<width-1 ? map[i][j+1] : Integer.MAX_VALUE;

		return map[i][j] <= north && map[i][j] <= south && map[i][j] <= west && map[i][j] <= east;
	}
}
