/**
 * Author: amit.zur
 * Date: 03/09/2009
 */

import java.util.List;
import java.util.ArrayList;
import java.io.*;

/**
 * TODO: JavaDoc
 */
public class CodeJam2009 {
	public static void main(String[] args) throws IOException {
		String inputPath = "d:\\codejam\\2009\\A-large.in";
		String outputPath = "d:\\codejam\\2009\\A-large.out";
		solveAlienLang(inputPath, outputPath);
	}

	private static void solveAlienLang(String inputPath, String outputPath) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader(inputPath));
		BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath));
		String firstLine = reader.readLine();
		String[] firstLineArr = firstLine.split(" ");
		int L = Integer.parseInt(firstLineArr[0]);
		int D = Integer.parseInt(firstLineArr[1]);
		int N = Integer.parseInt(firstLineArr[2]);
		String[] words = new String[D];
		List<Character>[] testCase;
		for (int i = 0; i < D; i++) {
			words[i] = reader.readLine();
		}
		for (int i = 0; i < N; i++) {
			testCase = compileTestCase(reader.readLine(), L);
			int solution = solveTestCase(testCase, words);
			writer.write("Case #" + (i+1) + ": " + solution + "\n");
		}
		reader.close();
		writer.flush();
		writer.close();
	}

	private static int solveTestCase(List<Character>[] testCase, String[] words) {
		if (words.length == 0) return 0;
		if (testCase.length == 0) return 1;

		int result = 0;
		for (int i = 0; i < testCase[0].size(); i++) {
			char curr = testCase[0].get(i);
			List<String> newWords = new ArrayList<String>();
			for (String word : words) {
				if (word.charAt(0) == curr) {
					newWords.add(word.substring(1));
				}
			}

			int newLength = testCase.length-1;
			List<Character>[] newTestCase = (List<Character>[]) new List[newLength];
			System.arraycopy(testCase, 1, newTestCase, 0, newLength);

			result += solveTestCase(newTestCase, newWords.toArray(new String[newWords.size()]));
		}
		return result;
	}

	private static List<Character>[] compileTestCase(String str, int L) {
		List<Character>[] result = (List<Character>[]) new List[L];
		for (int i = 0; i < L; i++) {
			result[i] = new ArrayList<Character>();
		}
		int pos = 0;
		boolean insidePar = false;
		for (int i = 0; i < str.length(); i++) {
			char curr = str.charAt(i);
			if (curr == '(') {
				insidePar = true;
				continue;
			}
			if (curr == ')') {
				insidePar = false;
				pos++;
				continue;
			}
			if (curr >= 'a' && curr <= 'z') {
				result[pos].add(curr);
				if (!insidePar) pos++;
			}
		}
		return result;
	}
}
