import java.io.File;
import java.io.FileNotFoundException;
import java.math.BigInteger;
import java.util.Scanner;

public class Candy {

	public class CombinationGenerator {

		private int[] a;
		private int n;
		private int r;
		private BigInteger numLeft;
		private BigInteger total;

		// ------------
		// Constructor
		// ------------

		public CombinationGenerator(int n, int r) {
			if (r > n) {
				throw new IllegalArgumentException();
			}
			if (n < 1) {
				throw new IllegalArgumentException();
			}
			this.n = n;
			this.r = r;
			a = new int[r];
			BigInteger nFact = getFactorial(n);
			BigInteger rFact = getFactorial(r);
			BigInteger nminusrFact = getFactorial(n - r);
			total = nFact.divide(rFact.multiply(nminusrFact));
			reset();
		}

		// ------
		// Reset
		// ------

		public void reset() {
			for (int i = 0; i < a.length; i++) {
				a[i] = i;
			}
			numLeft = new BigInteger(total.toString());
		}

		// ------------------------------------------------
		// Return number of combinations not yet generated
		// ------------------------------------------------

		public BigInteger getNumLeft() {
			return numLeft;
		}

		// -----------------------------
		// Are there more combinations?
		// -----------------------------

		public boolean hasMore() {
			return numLeft.compareTo(BigInteger.ZERO) == 1;
		}

		// ------------------------------------
		// Return total number of combinations
		// ------------------------------------

		public BigInteger getTotal() {
			return total;
		}

		// ------------------
		// Compute factorial
		// ------------------

		private BigInteger getFactorial(int n) {
			BigInteger fact = BigInteger.ONE;
			for (int i = n; i > 1; i--) {
				fact = fact.multiply(new BigInteger(Integer.toString(i)));
			}
			return fact;
		}

		// --------------------------------------------------------
		// Generate next combination (algorithm from Rosen p. 286)
		// --------------------------------------------------------

		public int[] getNext() {

			if (numLeft.equals(total)) {
				numLeft = numLeft.subtract(BigInteger.ONE);
				return a;
			}

			int i = r - 1;
			while (a[i] == n - r + i) {
				i--;
			}
			a[i] = a[i] + 1;
			for (int j = i + 1; j < r; j++) {
				a[j] = a[i] + j - i;
			}

			numLeft = numLeft.subtract(BigInteger.ONE);
			return a;

		}
	}

	static Candy dummy = new Candy();

	public static void main(String[] args) throws FileNotFoundException {
//		Scanner sc = new Scanner(new File("Candy.in"));
		 Scanner sc = new Scanner(new File("C-small-attempt2.in"));
		int t = Integer.parseInt(sc.nextLine());
		for (int i = 0; i < t; i++) {
			int n = sc.nextInt();
			Integer[] a = new Integer[n];
			for (int j = 0; j < n; j++) {
				// read the integers into an array
				a[j] = sc.nextInt();
			}
			// System.out.println(total);
			int tot = 0;
			Integer[] elements = a;
			for (int t3 = 1; t3 <= (elements.length + 2) / 2; t3++) {
				int[] indices;
				CombinationGenerator x = dummy.new CombinationGenerator(
						elements.length, t3);
				// System.out.println(t3);
				while (x.hasMore()) {
					Integer t1 = 0;
					int rt = 0;
					int rt2 = 0;
					Integer t2 = 0;
					indices = x.getNext();
					boolean[] b = new boolean[elements.length];
					for (int j = 0; j < indices.length; j++) {
						b[indices[j]] = true;
						// Systemstem.out.println(j);
						t1 = p(t1, a[indices[j]]);
						rt = rt + a[indices[j]];
					}
					for (int j = 0; j < b.length; j++) {
						if (b[j] != true) {
							t2 = p(t2, a[j]);
							rt2 = rt2 + a[j];
						}
					}
					/*
					System.out.println(t1+"vs"+t2);
					System.out.println(rt2+"vs!"+rt);
					System.out.println(t1-t2);
					*/
					if (t1 - t2 == 0) {						
						int max = Math.max(rt2, rt);						
						if (max > tot && rt2 > 0 && rt > 0)
							tot = max;
					}
//					System.out.println(tot);
					// for (int i1 = 0; i1 < n; i1++) {
					// if ()
					// combination.append(elements[indices[i1]]);
					// }
					// System.out.println(combination.toString());
				}
			}
			// Integer[] elements = a;
			int bugme = 0;
			for (int j = 0; j < elements.length; j++) {
				bugme = p(bugme, elements[j]);
			}
			if (bugme != 0 && tot > 0) {
				System.out.println("FUCK");
				System.exit(0);
			}
			if (bugme == 0 && tot == 0) {
				System.out.println("FUCK");
				System.exit(0);
			}
			if (tot > 0)
				System.out.printf("Case #%d: %d", i + 1, tot);
			else
				System.out.printf("Case #%d: NO", i + 1);
			System.out.println();
		}
		// System.out.println(p(3,5));
		// int total = pa(new Integer[] { 5, 6 });

	}

	public static Integer p(Integer i, Integer j) {
		BigInteger total = new BigInteger(i.toString());
		total = total.xor(new BigInteger(j.toString()));
		return Integer.parseInt(total.toString());
	}

	public static Integer pa(Integer[] i) {
		BigInteger total = new BigInteger("0");
		total = total.add(new BigInteger(i[0].toString()));

		for (int j = 1; j < i.length; j++) {
			total = total.xor(new BigInteger(i[j].toString()));
		}

		return Integer.parseInt(total.toString());
	}
	/*
	 * // running total int total = i[0]; for (int j = 1; j < i.length; j++) {
	 * int c = 1; int m = (int) (Math.log(i[j]) / Math.log(2)); int tmp = i[j];
	 * Integer tmp2 = 10; int tot = total; for (int k = 0; k < m; k++) { if (tmp
	 * % Math.pow(2, c) > 1) { if (tot % Math.pow(2, c) > 1) { total -=
	 * Math.pow(2, c-1); } else { total += Math.pow(2, c-1); }
	 * 
	 * } c++; } } System.out.println(total); return total; }
	 */
}
