package question1;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;

public class TicTacToeTomek {

	private static final Set<String> xWinningSet = new HashSet<String>() {{ 
		add("XXXX"); add("TXXX"); add("XTXX"); add("XXTX"); add("XXXT");  
	}};
	private static final Set<String> oWinningSet = new HashSet<String>() {{ 
		add("OOOO"); add("TOOO"); add("OTOO"); add("OOTO"); add("OOOT");  
	}};

	public static void main(String[] args) throws IOException {
		boolean dotFound=false;
		Scanner reader = new Scanner(new FileInputStream(args[0]));
		int numSet = reader.nextInt();
		//System.out.println("numset=" + numSet);
		reader.nextLine();

		
	    FileWriter fWriter = new FileWriter (new File (args[1]));
	    PrintWriter pWriter = new PrintWriter (fWriter);

		
		int caseCount = 1;
		while(reader.hasNextLine()){
			char[][] matrix = new char[4][4];
			for(int row=0; row<4; row++){
				String thisLine = reader.nextLine();
			//	System.out.println(thisLine);
				for(int col=0; col<4; col++){
					if(thisLine.charAt(col)=='.'){
						dotFound=true;
					}
					matrix[row][col]=thisLine.charAt(col);
				}
			}
			
			if(reader.hasNextLine()){
				reader.nextLine();
			}
			
			StringBuffer result = new StringBuffer();
			if(dotFound==false){
				writeResult(matrix, result.append("Draw"));
			}else{
				writeResult(matrix, result.append("Game has not completed"));
			}
			
			//System.out.println("Case #" + String.valueOf(caseCount++) + ": " + result);
		    pWriter.println("Case #" + String.valueOf(caseCount++) + ": " + result);
			
			dotFound=false;
		}
		
		pWriter.close();
		

	}

	private static void writeResult(char[][] matrix, StringBuffer result) {
		String original = result.toString();
		
		//check row winner
		StringBuilder currentLine = new StringBuilder();
		for(int row=0; row<4; row++){
			for(int col=0; col<4; col++){
				currentLine.append(matrix[row][col]);
			}
			//System.out.println("currentLine=" + currentLine);
			if(xWinningSet.contains(currentLine.toString())){
				result.setLength(0);
				result.append("X won");
				return;
			}else if(oWinningSet.contains(currentLine.toString())){
				result.setLength(0);
				result.append("O won");
				return;
			}
			currentLine.setLength(0);
		}
		
		//check column winner
		currentLine.setLength(0);
		for(int col=0; col<4; col++){
			for(int row=0; row<4; row++){
				currentLine.append(matrix[row][col]);
			}
			//System.out.println("currentLine=" + currentLine);
			if(xWinningSet.contains(currentLine.toString())){
				result.setLength(0);
				result.append("X won");
				return;
			}else if(oWinningSet.contains(currentLine.toString())){
				result.setLength(0);
				result.append("O won");
				return;
			}
			currentLine.setLength(0);
		}
		
		//check diagonal winner
		currentLine.setLength(0);
		for(int i=0; i<4; i++){
			currentLine.append(matrix[i][i]);
		}
		if(xWinningSet.contains(currentLine.toString())){
			result.setLength(0);
			result.append("X won");
			return;
		}else if(oWinningSet.contains(currentLine.toString())){
			result.setLength(0);
			result.append("O won");
			return;
		}
		
		//check reverse diagonal winner
		currentLine.setLength(0);
		for(int i=0; i<4; i++){
			currentLine.append(matrix[i][3-i]);
		}
		if(xWinningSet.contains(currentLine.toString())){
			result.setLength(0);
			result.append("X won");
			return;
		}else if(oWinningSet.contains(currentLine.toString())){
			result.setLength(0);
			result.append("O won");
			return;
		}
		
		currentLine.setLength(0);
		currentLine.append(original);

		
	}

	

}
