package deceitfulWar;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class DeceitfulWarMain {

	public static void main(String[] args) throws IOException {
		BufferedReader br = null;
		File file = new File("output.txt");
		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		try {

			br = new BufferedReader(new FileReader("D-small-attempt0.in"));

			int numTestCases = Integer.parseInt(br.readLine());
			System.out.println("num test cases=" + numTestCases);

			List<Double> naomi=null;
			List<Double> ken=null;

			for(int i=1; i<=numTestCases; i++){
				int numSize = Integer.parseInt(br.readLine());
				naomi = getNumList(br, numSize);
				ken = getNumList(br, numSize);
				//				System.out.println(naomi.toString() + ken.toString());

				Collections.sort(naomi);
				Collections.sort(ken);

//				System.out.println("n=" + naomi);
//				System.out.println("k=" + ken);
				
				int warResult= processWar(naomi, ken, numSize);
//				System.out.println("Naomi War Win=" + warResult);
				
				int dWarResult= processDWar(naomi, ken, numSize);
//				System.out.println("Naomi DWar Win=" + dWarResult);

				bw.write("Case #" + i + ": " + dWarResult + " " + warResult + "\n");
				System.out.println("Case #" + i + ": " + dWarResult + " " + warResult);
			}

		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
				if (bw != null)bw.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}
		
	private static int processDWar(List<Double> naomi, List<Double> ken, int numSize) {
		int j=numSize-1;
		int naomiStart=0;
		int naomiWin=0;
		for(int i=numSize-1; i>=naomiStart; i--){
			if(naomi.get(i)>ken.get(j)){
				naomiWin++;
			}else {
				i++;
				naomiStart++;
			}
			j--;
		}
		return naomiWin;
	}

	private static int processWar(List<Double> naomi, List<Double> ken,	int numSize) {
		int j=0, i=0;
		int result =0;
		for(; i<numSize; i++){
			for(; j<numSize; j++){
				if(ken.get(j)>naomi.get(i)){
					j++;
					break;
				}
			}
			if(j==numSize)
				break;
		}
		result = numSize-i-1;
		return result;
	}

	private static List<Double> getNumList(BufferedReader br, int numSize) throws NumberFormatException, IOException {
		String numStr = br.readLine();
		String[] splited = numStr.split("\\s+");

		List<Double> result = new ArrayList<Double>();
		for(int i=0; i<numSize; i++){
			result.add(Double.valueOf(splited[i]));
		}

		return result;
	}

}
