import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;

/**
 * Created by Chihwa on 4/11/2015.
 */
public class Pancakes {
    public static void main(String[] args) throws IOException {

        StringBuilder sb = new StringBuilder();

        Scanner scanner = new Scanner(new File("B-small-attempt1.in"));
        while (scanner.hasNextInt()) {
            int tc = scanner.nextInt();
            for (int i = 0; i < tc; i++) {
                int numDiners = scanner.nextInt();
                scanner.nextLine();
                String sCakes[] = scanner.nextLine().split("\\s+");
                int count = serve(numDiners, getIntArray(sCakes), 0);
                sb.append(String.format("Case #%d: %d\n", i + 1, count));
            }
        }
        scanner.close();

        File file = new File("B-small-attempt1.out");
        BufferedWriter output = new BufferedWriter(new FileWriter(file));
        output.write(sb.toString());
        output.close();

    }

    private static List<Integer> getIntArray(String[] sCakes) {
        List<Integer> result = new ArrayList();

        for (int i = 0; i < sCakes.length; i++) {
            result.add(Integer.parseInt(sCakes[i].trim()));
        }
        return result;
    }

    private static int serve(int numDiners, List<Integer> cakes, int count) {
        if (allZero(cakes)) {
            return count;
        }
        if(allOneOrZero(cakes)){
            return count+1;
        }
        int splitCnt = serve(numDiners, split(cakes), count + 1);
        int consumeCnt = serve(numDiners, consume(cakes), count + 1);

        return Math.min(splitCnt, consumeCnt);
    }

    private static boolean allOneOrZero(List<Integer> cakes) {
        for (int i = 0; i < cakes.size(); i++) {
            if (cakes.get(i) != 1 && cakes.get(i) != 0) {
                return false;
            }
        }
        return true;
    }

    private static List<Integer> consume(List<Integer> cakes) {
        List<Integer> copy = new ArrayList<Integer>(cakes);
        for (int i = 0; i < copy.size(); i++) {
            int num = copy.get(i);
            if (num > 0) {
                copy.set(i, num - 1);
            }
        }
        return copy;
    }

    private static List<Integer> split(List<Integer> cakes) {
        List<Integer> copy = new ArrayList<Integer>(cakes);
        for (int i = 0; i < copy.size(); i++) {
            int num = copy.get(i);
            if (num > 1) {
                copy.set(i, num / 2 + num % 2);
                copy.add(num / 2);
                break;
            }
        }
        return copy;
    }

    private static boolean allZero(List<Integer> cakes) {
        for (int i = 0; i < cakes.size(); i++) {
            if (cakes.get(i) > 0) {
                return false;
            }
        }
        return true;
    }

    private static int getMaxIndex(List<Integer> cakes) {
        int max = cakes.get(0);
        int maxIndex = 0;
        for (int i = 0; i < cakes.size(); i++) {
            if (cakes.get(i) > max) {
                max = cakes.get(i);
                maxIndex = i;
            }
        }
        return maxIndex;
    }
}
