import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class MinesweeperMasterMain {

	public static void main(String[] args) throws IOException {
		BufferedReader br = null;
		File file = new File("C-small-attempt1.out.txt");
		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		try {
 
			br = new BufferedReader(new FileReader("C-small-attempt1.in"));
 
			int numTestCases = Integer.parseInt(br.readLine());
			System.out.println("num test cases=" + numTestCases);
			
			List<Integer> dl=null;
			for(int i=1; i<=numTestCases; i++){
				dl = getNumList(br);
				Integer r = dl.get(0);
				Integer c = dl.get(1);
				Integer m = dl.get(2);
				
//				System.out.println("R= " + r + " C= " +c+ " M=" + m);
				
				boolean answer = determine(r, c, m);
				bw.write("Case #"+i+":\n");
				System.out.print("Case #"+i+":\n");
				if(!answer){
					bw.write("Impossible\n");
					System.out.println("Impossible");
				}else{
					printAnswer(r, c, m, bw);
				}
			}
 
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
				if (bw != null)bw.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}

	}
	
	private static void printAnswer(Integer r, Integer c, Integer m, BufferedWriter bw) throws IOException {
		int originalM=m;
		for(int i=0; i<r-2; i++){
			for(int j=0; j<c; j++){
				if(m==0){
					bw.write(".");
				}else{
					bw.write("*");
					m--;
				}
			}
			bw.write("\n");
		}

//		System.out.println("m="+ m);
		for(int i=0; i<m/2; i++)
			bw.write("*");
		if(m>0 && originalM%2==1){
			bw.write("*");
			for(int i=m/2; i<c-1; i++)
				bw.write(".");
		}else{
			for(int i=m/2; i<c; i++)
				bw.write(".");
		}
		bw.write("\n");
		
		for(int i=0; i<m/2; i++)
			bw.write("*");
		for(int i=m/2; i<c-1; i++)
			bw.write(".");
		
		

		
		bw.write("C\n");
}

	private static boolean determine(Integer r, Integer c, Integer m) {
		if(r==1 && c==1 && m==0){
			return true;
		}else if(r==1){
			return c-m >= 2;
		}else if(c==1){
			return r-m >= 2;
		}
		return (r*c) - m >= 4;
	}

	private static List<Integer> getNumList(BufferedReader br) throws NumberFormatException, IOException {
		String numStr = br.readLine();
		String[] splited = numStr.split("\\s+");
		
		List<Integer> result = new ArrayList<Integer>();
		for(int i=0; i<splited.length; i++){
			result.add(Integer.valueOf(splited[i]));
		}
		
		return result;
	}

}
