import java.io.*;
import java.util.Arrays;

/**
 * Created by Chihwa on 4/8/2016.
 */
public class CoinJam {
    private static int isPrime(long num) {
        if (num < 2) return -1;
        if (num == 2) return -1;
        if (num % 2 == 0) return 2;
        for (int i = 3; i * i <= num; i += 2)
            if (num % i == 0) return i;
        return -1;
    }

    public static void main(String[] args) throws IOException {
        BufferedReader br = new BufferedReader(new FileReader("input.txt"));
        int t = Integer.parseInt(br.readLine());
        String nj[] = br.readLine().split("\\s");
        int n = Integer.parseInt(nj[0]);
        int j = Integer.parseInt(nj[1]);
        String r[][] = new String[j][10];

        int max = (int) Math.pow(2.0, n - 2) - 1;
        int curRow = 0;
        for (int i = 0; i <= max && curRow < j; i++) {
            String cur = String.format("1%s1", fillZeros(Integer.toString(i, 2), n - 2));
            int base = 2;

            for (; base <= 10; base++) {
                long divisible = isPrime(Long.parseLong(cur, base));
                if (divisible == -1) {
                    break;
                } else {
                    r[curRow][base - 1] = String.valueOf(divisible);
                }
            }

            //log answer
            if (base == 11) {
                r[curRow++][0] = cur;
            }
        }

//        System.out.println(Arrays.deepToString(r).replace("], ", "]\n"));

        br.close();

        Writer bw = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("smallOutput.txt"), "utf-8"));
        bw.write("Case #1:\n");
        for (int row = 0; row < j; row++) {
            for (int col = 0; col < r[0].length; col++) {
                bw.write(String.format("%s ", r[row][col]));
            }
            bw.write("\n");
        }
        bw.close();
    }

    private static String fillZeros(String s, int digits) {
        char[] repeat = new char[digits];
        Arrays.fill(repeat, '0');
        StringBuilder r = new StringBuilder(new String(repeat));
        r.replace(Math.max(0, digits - s.length()), repeat.length, s);
        return r.toString();
    }
}
