package magicTrick;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.HashSet;
import java.util.Set;

public class MagicTrickMain {

	public static void main(String[] args) throws IOException {
		BufferedReader br = null;
		File file = new File("magicTrickOutput.txt");
		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		try {
 
			br = new BufferedReader(new FileReader("A-small-attempt0.in"));
 
			int numTestCases = Integer.parseInt(br.readLine());
			System.out.println("num test cases=" + numTestCases);
			
			for(int i=1; i<=numTestCases; i++){
				Set<Integer> set1 = getIntList(br);
				Set<Integer> set2 = getIntList(br);
				int overlap=0;
				int answer=0;
				for(Integer num: set1){
					if(set2.contains(num)){
						overlap++;
						answer=num;
					}
				}
				System.out.println("overlapCnt=" + overlap);
				
				if(overlap==0){
					bw.write("Case #" + i + ": " + "Volunteer cheated!\n");
				}else if(overlap==1){
					bw.write("Case #" + i + ": " + answer + "\n");
				}else {
					bw.write("Case #" + i + ": " + "Bad magician!\n");
				}
			}
 
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
				if (bw != null)bw.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}

	}

	private static Set<Integer> getIntList(BufferedReader br) throws NumberFormatException, IOException {
		int row =  Integer.parseInt(br.readLine());
		int cur=1;
		for(; cur<=row-1; cur++){
			br.readLine();
		}
		String numStr = br.readLine();
		String[] splited = numStr.split("\\s+");
		
		Set<Integer> result = new HashSet<Integer>();
		for(int i=0; i<splited.length; i++){
			result.add(Integer.valueOf(splited[i]));
		}
		
		for(; cur<4; cur++){
			br.readLine();
		}
		
		return result;
	}

}
