package cookieClickerAlphaMain;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.List;

public class CookieClickerAlphaMain {
	
	public static List<Double> timeArray = new ArrayList<Double>();

	public static void main(String[] args) throws IOException {
		BufferedReader br = null;
		File file = new File("output.txt");
		FileWriter fw = new FileWriter(file.getAbsoluteFile());
		BufferedWriter bw = new BufferedWriter(fw);
		try {
 
			br = new BufferedReader(new FileReader("B-small-attempt0.in"));
 
			int numTestCases = Integer.parseInt(br.readLine());
			System.out.println("num test cases=" + numTestCases);
			
			List<Double> dl=null;
			for(int i=1; i<=numTestCases; i++){
				dl = getNumList(br);
				Double c = dl.get(0);
				Double f = dl.get(1);
				Double x = dl.get(2);
				
				Double totalTimeTaken = Double.MAX_VALUE;
				Long count=0L;
				while(true){
					Double newTime = getTimeForBuyXTimes(count++, c, f, x);
					if(newTime>totalTimeTaken){
						break;
					}else{
						totalTimeTaken = newTime;
					}
				}
				DecimalFormat df = new DecimalFormat(".#######");
				bw.write("Case #" + i + ": " + df.format(totalTimeTaken) + "\n");
				System.out.println("Case #" + i + ": " + df.format(totalTimeTaken));
				
			}
 
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			try {
				if (br != null)br.close();
				if (bw != null)bw.close();
			} catch (IOException ex) {
				ex.printStackTrace();
			}
		}
	}

	private static Double getTimeForBuyXTimes(Long count, Double c, Double f, Double x) {
		Double timeWithBuy = 0D;
		Double ff=2D;
		for(int i=1; i<=count; i++){
			timeWithBuy += c/ff;
			ff +=f;
		}
		Double result = 0D;
		if(count==0)
			result = x / 2;
		else 
			result = timeWithBuy + x / ff;
//		System.out.println("result=" + result + " timeWithBuy= " + timeWithBuy + " f=" + ff);
		return result;
	}

	private static List<Double> getNumList(BufferedReader br) throws NumberFormatException, IOException {
		String numStr = br.readLine();
		String[] splited = numStr.split("\\s+");
		
		List<Double> result = new ArrayList<Double>();
		for(int i=0; i<splited.length; i++){
			result.add(Double.valueOf(splited[i]));
		}
		
		return result;
	}
}
