
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

public class FairWarningSmall
{

    private BufferedReader d;
    private DataOutputStream dos = null;
    private Logger logger = Logger.getLogger(ThemePark.class.getName());
    private int n, c;
    private static final String outputPrefix = "Case #";
    private static final Pattern numericPattern = Pattern.compile("(\\d+)");
    private static final Pattern rknPattern = Pattern.compile("(\\d+)\\s*(\\d+)\\s*(\\d+)");

    public FairWarningSmall() throws IOException
    {
        try
        {
            d = new BufferedReader(new InputStreamReader(new FileInputStream(new File("B-small.in"))));
            dos = new DataOutputStream(new FileOutputStream(new File("B-small.out")));
        }
        catch (FileNotFoundException ex)
        {
            logger.log(Level.SEVERE, "Could not find file");
        }
        try
        {
            Matcher m = numericPattern.matcher(d.readLine().trim());
            if (m.matches())
            {
                c = Integer.parseInt(m.group(1));
            }
            else
            {
                logger.log(Level.SEVERE, "Invalid value for T");
                c = 0;
            }
        }
        catch (NullPointerException e)
        {
            //file could not be opened, already logged, so nothing to do
            throw e;
        }
        catch (IOException e)
        {
            logger.log(Level.SEVERE, "Could not read from file");
            throw e;
        }
        for (int i = 0; i < c; i++)
        {
            startTest(i + 1);
        }
    }

    private void startTest(int testCase)
    {
        try
        {
            String line = d.readLine();
            String[] time = line.trim().split("\\s");
            n = Integer.parseInt(time[0]);
            long values[] = new long[n];
            for (int i = 1; i <= n; i++)
            {
                values[i - 1] = Long.parseLong(time[i]);
            }
            long oldValue = Math.abs(values[0] - values[1]);
            for (int i = 0; i < n; i++)
            {
                for (int j = i + 1; j < n; j++)
                {
                    oldValue = leastCommonDivizor(oldValue, Math.abs(values[i] - values[j]));
                }
            }
            if (oldValue==1) writeResponse(testCase, "0" + (testCase < c ? "\n" : ""));
            else writeResponse(testCase, "" + (oldValue-(values[0] % oldValue)) + (testCase < c ? "\n" : ""));
        }
        catch (IOException e)
        {
            logger.log(Level.SEVERE, "Could not read from file test #" + testCase);
            return;
        }
        catch (NullPointerException e)
        {
            return;
            // already logged;
        }
    }

    private long leastCommonDivizor(long a, long b)
    {
        if (a == 0 || b == 0)
        {
            return 1;
        }
        if (a < 0)
        {
            a = -a;
        }
        if (b < 0)
        {
            b = -b;
        }
        while (a != b)
        {
            if (a == 1 || b == 1)
            {
                return 1;
            }
            if (b > a)
            {
                long temp = a;
                a = b;
                b = temp;
            }
            a -= b;
        }
        return a;
    }

    private void writeResponse(int testCase, String value)
    {
        try
        {
            dos.write((outputPrefix + testCase + ": " + value).getBytes());
        }
        catch (IOException ex)
        {
            logger.log(Level.SEVERE, "Could not write output for testcase #" + testCase);
        }
    }

    public static void main(String args[]) throws IOException
    {
        FairWarningSmall t = new FairWarningSmall();
    }
}
