
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author Adrian Buturuga
 */
public class Rank
{

    private BufferedReader d;
    private DataOutputStream dos = null;
    private Logger logger = Logger.getLogger(this.getClass().getName());
    private int t;
    private static final String outputPrefix = "Case #";
    private static final String inputFileName = "C-small.in";
    private static final String outputFileName = "C-small.out";

    public Rank() throws IOException
    {
        try
        {
            d = new BufferedReader(new InputStreamReader(new FileInputStream(new File(inputFileName))));
            dos = new DataOutputStream(new FileOutputStream(new File(outputFileName)));
        }
        catch (FileNotFoundException ex)
        {
            logger.log(Level.SEVERE, "Could not find file");
        }
        try
        {
            t = Integer.parseInt(d.readLine().trim());
        }
        catch (NullPointerException e)
        {
            //file could not be opened, already logged, so nothing to do
            throw e;
        }
        catch (IOException e)
        {
            logger.log(Level.SEVERE, "Could not read from file");
            throw e;
        }
        for (int i = 0; i < t; i++)
        {
            startTest(i + 1);
        }
    }

    public void startTest(int testCase)
    {
        try
        {
            int n = Integer.parseInt(d.readLine().trim());
            writeResponse(testCase, "" + (Fibb(n) % 100003));
        }
        catch (IOException e)
        {
            logger.log(Level.SEVERE, "Could not read from file test #" + testCase);
            return;
        }
        catch (NullPointerException e)
        {
            return;
            // already logged;
        }
    }

    private long Fibb(int k)
    {
        if (k == 1 || k == 2)
        {
            return 1;
        }
        else
        {
            return Fibb(k - 1) + Fibb(k - 2);
        }
    }

    private void writeResponse(int testCase, String value)
    {
        try
        {
            dos.write((outputPrefix + testCase + ": " + value + "\n").getBytes());
        }
        catch (IOException ex)
        {
            logger.log(Level.SEVERE, "Could not write output for testcase #" + testCase);
        }
    }

    public static void main(String args[]) throws IOException
    {
        Rank rank = new Rank();
    }
}
