
import java.io.BufferedReader;
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @author Adrian Buturuga
 */
public class Chicks
{

    private BufferedReader d;
    private DataOutputStream dos = null;
    private Logger logger = Logger.getLogger(this.getClass().getName());
    private int c, n, k, t, v[];
    private long b, x[];
    private double time[];
    private static final String outputPrefix = "Case #";
    private static final Pattern nkbtPattern = Pattern.compile("(\\d+)\\s*(\\d+)\\s*(\\d+)\\s*(\\d+)");
    private static final String inputFileName = "B-large.in";
    private static final String outputFileName = "B-large.out";

    public Chicks() throws IOException
    {
        try
        {
            d = new BufferedReader(new InputStreamReader(new FileInputStream(new File(inputFileName))));
            dos = new DataOutputStream(new FileOutputStream(new File(outputFileName)));
        }
        catch (FileNotFoundException ex)
        {
            logger.log(Level.SEVERE, "Could not find file");
        }
        try
        {
            c = Integer.parseInt(d.readLine().trim());
        }
        catch (NullPointerException e)
        {
            //file could not be opened, already logged, so nothing to do
            throw e;
        }
        catch (IOException e)
        {
            logger.log(Level.SEVERE, "Could not read from file");
            throw e;
        }
        for (int i = 0; i < c; i++)
        {
            startTest(i + 1);
        }
    }

    public void startTest(int testCase)
    {
        try
        {
            Matcher matcher = nkbtPattern.matcher(d.readLine().trim());
            if (matcher.matches())
            {
                n = Integer.parseInt(matcher.group(1));
                x = new long[n];
                v = new int[n];
                time = new double[n];
                k = Integer.parseInt(matcher.group(2));
                b = Long.parseLong(matcher.group(3));
                t = Integer.parseInt(matcher.group(4));
            }
            else
            {
                logger.log(Level.SEVERE, "Invalid values for N and M");
                n = k = t = 0;
                b = 0;
                return;
            }
            String[] xs = d.readLine().trim().split("\\s");
//            System.out.print("Test case "+testCase+" \ndistance: ");
            for (int i = 0; i < n; i++)
            {
                x[i] = b - Long.parseLong(xs[i]);
//                System.out.print(x[i]+" ");
            }
            String[] vs = d.readLine().trim().split("\\s");
            int possible = 0;
//            System.out.print("\nTime: ");
            for (int i = 0; i < n; i++)
            {
                v[i] = Integer.parseInt(vs[i]);
                time[i] = (1.0 * x[i]) / v[i];
                if (time[i] <= t)
                {
                    possible++;
                }
//                System.out.print(time[i]+" ");
            }
//            System.out.println();
            if (possible < k)
            {
                writeResponse(testCase, "IMPOSSIBLE");
                return;
            }
            int swaps = 0;
            for (int j = 0; j < k; j++)
            {
                if (time[n - 1 - j] > t)
                {
                    int pos = n - 1 - k;
                    while (time[pos] > t)
                    {
                        pos--;
                    }
//                    System.out.println("Swapping "+(n-1-j)+" with "+pos+": cost "+(n-j-1-pos));
                    swaps += n - j -1 - pos;
                    double temp = time[n - 1 - j];
                    time[n - 1 - j] = time[pos];
                    time[pos] = temp;
                }
            }
            writeResponse(testCase, ""+swaps);

        }
        catch (IOException e)
        {
            logger.log(Level.SEVERE, "Could not read from file test #" + testCase);
            return;
        }
        catch (NullPointerException e)
        {
            return;
            // already logged;
        }
    }

    private void writeResponse(int testCase, String value)
    {
        try
        {
            dos.write((outputPrefix + testCase + ": " + value + "\n").getBytes());
        }
        catch (IOException ex)
        {
            logger.log(Level.SEVERE, "Could not write output for testcase #" + testCase);
        }
    }

    public static void main(String args[]) throws IOException
    {
        Chicks chicks = new Chicks();
    }
}
