
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Scanner;
import java.util.TreeSet;

/**
 * @author Adrian Buturuga
 */
public class Magicka
{

    private static String combinations[][];
    private static boolean deletions[][];

    private static void resetMatrixes()
    {
        combinations = new String[8][8];
        deletions = new boolean[8][8];
        for (int i = 0; i < 8; i++)
        {
            for (int j = 0; j < 8; j++)
            {
                combinations[i][j] = getChar(i) + getChar(j);
                deletions[i][j] = false;
            }
        }
    }

    private static int getMapping(String character)
    {
        switch (character.toUpperCase().charAt(0))
        {
            case 'Q':
                return 0;
            case 'W':
                return 1;
            case 'E':
                return 2;
            case 'R':
                return 3;
            case 'A':
                return 4;
            case 'S':
                return 5;
            case 'D':
                return 6;
            case 'F':
                return 7;
            default:
                return -1;
        }
    }

    private static String getChar(int mapping)
    {
        switch (mapping)
        {
            case 0:
                return "Q";
            case 1:
                return "W";
            case 2:
                return "E";
            case 3:
                return "R";
            case 4:
                return "A";
            case 5:
                return "S";
            case 6:
                return "D";
            case 7:
                return "F";
            default:
                return "?";
        }
    }

    public static void main(String args[]) throws FileNotFoundException, IOException
    {
        File input = new File("B-small-attempt1.in");
        File output = new File("B-small-attempt1.out");
        Scanner scanner = new Scanner(input);
        DataOutputStream writer = new DataOutputStream(new FileOutputStream(output));
        int T = scanner.nextInt();
        for (int i = 1; i <= T; i++)
        {
            resetMatrixes();
            int C = scanner.nextInt();
            for (int j = 0; j < C; j++)
            {
                String combination = scanner.next();
                int x = getMapping(combination.substring(0, 1));
                int y = getMapping(combination.substring(1, 2));
                combinations[x][y] = combination.substring(2, 3);
                combinations[y][x] = combination.substring(2, 3);
            }
            int D = scanner.nextInt();
            for (int j = 0; j < D; j++)
            {
                String deletion = scanner.next();
                int x = getMapping(deletion.substring(0, 1));
                int y = getMapping(deletion.substring(1, 2));
                deletions[x][y] = true;
                deletions[y][x] = true;
            }
            TreeSet<String> currentlyInvokedElements = new TreeSet<String>();
            ArrayList<String> invokedList = new ArrayList<String>();
            int N = scanner.nextInt();
            String invoke = scanner.next();
            for (int j = 0; j < N; j++)
            {
                String current = invoke.substring(j, j + 1);
                if (invokedList.isEmpty())
                {
                    invokedList.add(current);
                    currentlyInvokedElements.add(current);
                    continue;
                }
                String last = invokedList.get(invokedList.size() - 1);
                String combination = last + current;
                try
                {
                    combination = combinations[getMapping(last)][getMapping(current)];
                }
                catch (ArrayIndexOutOfBoundsException e)
                {
                }
                if (combination.length() == 1)
                {
                    invokedList.remove(invokedList.size() - 1);
                    if (!invokedList.contains(last))
                    {
                        currentlyInvokedElements.remove(last);
                    }
                    invokedList.add(combination);
                }
                else
                {
                    invokedList.add(current);
                    currentlyInvokedElements.add(current);
                    Iterator<String> iterator = currentlyInvokedElements.iterator();
                    boolean found = false;
                    while (iterator.hasNext() && !found)
                    {
                        String check = iterator.next();
                        if (deletions[getMapping(check)][getMapping(current)])
                        {
                            found = true;
                        }
                    }
                    if (found)
                    {
                        currentlyInvokedElements.clear();
                        invokedList.clear();
                    }
                }
            }
            writer.write(("Case #" + i + ": [").getBytes());
            if (!invokedList.isEmpty())
            {
                Iterator<String> iterator = invokedList.iterator();
                writer.write(iterator.next().getBytes());
                while (iterator.hasNext())
                {
                    writer.write((", " + iterator.next()).getBytes());
                }
            }
            writer.write("]\n".getBytes());

        }
        writer.close();
        scanner.close();
    }
}
