
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Scanner;

/**
 * @author Adrian Buturuga
 */
public class Repeater
{

	private static final String IMPOSSIBLE = "Fegla Won";

	static class Element
	{

		public char c;
		public int times;
	}

	private static void solveTestCase(int testCase, Scanner input, FileOutputStream output) throws IOException
	{
		int n = input.nextInt();
		input.nextLine(); // clear \n
		ArrayList<ArrayList<Element>> elements = new ArrayList<ArrayList<Element>>();
		int avg[] = new int[0];
		boolean impossible = false;
		for (int i = 0; i < n; i++)
		{
			ArrayList<Element> current = readElement(input);
			elements.add(current);
			if (elements.size() > 1)
			{
				if (isImpossible(current, elements.get(0)))
				{
					impossible = true;
				}
			}
			else
			{
				avg = new int[current.size()];
			}
			for (int j = 0; !impossible && j < current.size(); j++)
			{
				avg[j] += current.get(j).times;
			}
		}
		if (impossible)
		{
			writeSolution(testCase, IMPOSSIBLE, output);
			return;
		}
		for (int i = 0; i < avg.length; i++)
		{
			avg[i] = (int) Math.round(avg[i] * 1.0 / n);
		}
		int result = 0;
		for (ArrayList<Element> current : elements) {
			for (int i=0; i<current.size(); i++) {
				result += Math.abs(current.get(i).times-avg[i]);
			}
		}
		writeSolution(testCase, ""+result, output);
	}

	private static boolean isImpossible(ArrayList<Element> current, ArrayList<Element> comparison)
	{
		if (current.size() != comparison.size())
		{
			return true;
		}
		for (int j = 0; j < current.size(); j++)
		{
			if (current.get(j).c != comparison.get(j).c)
			{
				return true;
			}
		}
		return false;
	}

	private static ArrayList<Element> readElement(Scanner input)
	{
		ArrayList<Element> str = new ArrayList<Element>();
		String current = input.nextLine();
		int i = 1;
		Element elem = new Element();
		elem.c = current.charAt(0);
		elem.times = 1;
		while (i < current.length())
		{
			char c = current.charAt(i);
			if (c == elem.c)
			{
				elem.times++;
			}
			else
			{
				str.add(elem);
				elem = new Element();
				elem.c = c;
				elem.times = 1;
			}
			i++;
		}
		str.add(elem);
		return str;
	}

	private static void writeSolution(int testCase, String result, FileOutputStream output) throws IOException
	{
		output.write(("Case #" + testCase + ": " + result + "\n").getBytes());
	}

	public static void main(String args[]) throws Exception
	{
		File inputFile = new File("A-small-attempt0.in");
		Scanner input = new Scanner(inputFile);

		File outputFile = new File("A-small-attempt0.out");
		FileOutputStream fos = new FileOutputStream(outputFile);

		int testCases = input.nextInt();

		for (int i = 1; i <= testCases; i++)
		{
			solveTestCase(i, input, fos);
		}

		input.close();
		fos.close();
	}
}
