
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Scanner;

/**
 * @author Adrian
 */
public class Digigs
{

	public static final String FILENAME = "d:/A-large.in";
	public static final String OUTPUT = "d:/output.out";
	public static FileOutputStream fos;
	
	public static void main(String args[]) throws FileNotFoundException, IOException
	{
		Scanner s = new Scanner(new File(FILENAME));
		fos = new FileOutputStream(OUTPUT);
		int tests = s.nextInt();
		s.nextLine();
		for (int i = 1; i <= tests; i++)
		{
			String input = s.nextLine().trim();
			solve(input, i);
		}
	}

	public static void solve(String line, int testNo) throws IOException
	{
		ArrayList<Integer> numbers = new ArrayList<Integer>();
		StringBuffer input = new StringBuffer(line);
		ArrayList<Search> list = new ArrayList<Search>();
		list.add(new Search("Z", "ZERO", 0));
		list.add(new Search("W", "TWO", 2));
		list.add(new Search("X", "SIX", 6));
		list.add(new Search("G", "EIGHT", 8));
		list.add(new Search("H", "THREE", 3));
		list.add(new Search("R", "FOUR", 4));
		list.add(new Search("F", "FIVE", 5));
		list.add(new Search("O", "ONE", 1));
		list.add(new Search("S", "SEVEN", 7));
		list.add(new Search("I", "NINE", 9));
		while (input.length() > 0)
		{
			for (Search s : list)
			{
				Integer v = null;
				do
				{
					v = remove(input, s);
					if (v != null)
					{
						numbers.add(v);
					}
				}
				while (v != null);
			}

		}
		Collections.sort(numbers);
		printAnswer(numbers, testNo);
	}
	
	public static void printAnswer(ArrayList<Integer> numbers, int test) throws IOException {
		fos.write(("Case #"+test+": ").getBytes());
		for (Integer i : numbers) {
			fos.write((""+i).getBytes());
		}
		fos.write("\n".getBytes());
	}

	public static Integer remove(StringBuffer line, Search s)
	{
		if (line.toString().contains(s.search))
		{
			for (int i = 0; i < s.remove.length(); i++)
			{
				line = line.deleteCharAt(line.toString().indexOf(s.remove.charAt(i)));
			}
			return s.val;
		}
		return null;
	}

	public static class Search
	{

		public String search;
		public String remove;
		public int val;

		public Search(String search, String remove, int val)
		{
			this.search = search;
			this.remove = remove;
			this.val = val;
		}
	}
}
