import java.io.*;
import java.util.Scanner;

public class Pancakes {

    private static Scanner s;
    private static FileOutputStream fs;

    public static void main(String args[]) throws Exception {
        s = new Scanner(new FileReader("src/A-large.in"));
        int testCases = Integer.parseInt(s.nextLine().trim());
        fs = new FileOutputStream("output.out");
        for (int i = 0; i < testCases; i++) {
            solveProblem(i+1);
        }
        fs.close();
    }

    private static void solveProblem(int test) throws IOException {
        String line = s.nextLine();
        char[] state = line.split("\\s")[0].toCharArray();
        int k = Integer.parseInt(line.split("\\s")[1]);
        int flips = 0;
        for (int i=0; i<state.length; i++) {
            if (state[i]=='-') {
                if (i+k-1>=state.length) {
                    writeOutcome(test, -1);
                    return;
                } else {
                    flips++;
                    for (int j=i; j<i+k; j++) {
                        state[j] = state[j] == '-' ? '+' : '-';
                    }
                }
            }
        }
        writeOutcome(test, flips);
    }

    private static void writeOutcome(int test, int solution) throws IOException {
        fs.write(("Case #"+test+": " + (solution == -1 ? "IMPOSSIBLE" : solution)+"\n").getBytes());
    }
}
