
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Iterator;
import java.util.Scanner;

/**
 * @author Adrian Buturuga
 */
public class GoroSort
{

    private static ArrayList<Integer> indexes = new ArrayList<Integer>();
    private static ArrayList<Integer> orbits = new ArrayList<Integer>();

    private static void resetArrays()
    {
        indexes.clear();
        orbits.clear();
    }

    public static void main(String args[]) throws FileNotFoundException, IOException
    {
        File input = new File("D-small-attempt0.in");
        File output = new File("D-small-attempt0.out");
        Scanner scanner = new Scanner(input);
        DataOutputStream writer = new DataOutputStream(new FileOutputStream(output));
        int T = scanner.nextInt();
        for (int i = 1; i <= T; i++)
        {
            resetArrays();
            int hits = 0;
            int N = scanner.nextInt();
            for (int j = 0; j < N; j++)
            {
                indexes.add(scanner.nextInt()-1);
            }
            for (int j=0; j<N; j++)
            {
                orbits.clear();
                if (indexes.get(j)!=j)
                {
                    int current = j;
                    while (!orbits.contains(current))
                    {
                        orbits.add(current);
                        current = indexes.get(j);
                    }
                    hits += 2 * (orbits.size()-1);
                }
                Iterator<Integer> iterator = orbits.iterator();
                while (iterator.hasNext())
                {
                    int current = iterator.next();
                    indexes.set(current, current);
                }
            }
            writer.write(("Case #"+i+": "+hits+"\n").getBytes());
        }
        scanner.close();
        writer.close();
    }
}
