
import java.io.File;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Scanner;

/**
 * @author Adrian Buturuga
 */
public class Lottery
{

	private static void solveTestCase(int testCase, Scanner input, FileOutputStream output) throws IOException
	{

		int A = input.nextInt();
		int B = input.nextInt();
		int K = input.nextInt();
		int possibilities = getPossibilities(K, A, B);
		writeSolution(testCase, "" + possibilities, output);
	}

	private static int getPossibilities(int K, int A, int B)
	{
//		System.out.println(A+" "+B+" "+K);
		int possibilities = 0;
		for (int i = 0; i < A; i++)
		{
			for (int j = 0; j < B; j++)
			{
				if ((i & j) < K)
				{
//					System.out.println("## "+i+" "+j+" "+(i&j));
					possibilities++;
				}
			}
		}
		return possibilities;
	}

	private static void writeSolution(int testCase, String result, FileOutputStream output) throws IOException
	{
		output.write(("Case #" + testCase + ": " + result + "\n").getBytes());
	}

	public static void main(String args[]) throws Exception
	{
		File inputFile = new File("B-small-attempt0.in");
		Scanner input = new Scanner(inputFile);

		File outputFile = new File("B-small-attempt0.out");
		FileOutputStream fos = new FileOutputStream(outputFile);

		int testCases = input.nextInt();

		for (int i = 1; i <= testCases; i++)
		{
			solveTestCase(i, input, fos);
		}

		input.close();
		fos.close();
	}
}
