import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;
import java.util.Scanner;

public class Tidy {

    private static Scanner s;
    private static FileOutputStream fs;

    public static void main(String args[]) throws Exception {
        s = new Scanner(new FileReader("src/B-large.in"));
        int testCases = Integer.parseInt(s.nextLine().trim());
        fs = new FileOutputStream("output.out");
        for (int i = 0; i < testCases; i++) {
            solveProblem(i + 1);
        }
        fs.close();
    }

    private static void solveProblem(int test) throws IOException {
        String line = s.nextLine();
        if (line.length() == 1) {
            writeOutcome(test, line);
            return;
        }
        for (int i = 0; i < line.length() - 1; i++) {
            int current = line.charAt(i) - '0';
            int next = line.charAt(i + 1) - '0';
            if (current > next) {
                if (i > 0) {
                        line = line.substring(0, i)+(current-1)+get9s(line.length()-i-1);
                        i-=2;
                        continue;

                } else {
                    writeOutcome(test, (current - 1) + get9s(line.length() - i - 1));
                    return;
                }
            }
        }
        writeOutcome(test, line);
    }

    private static String get9s(int number) {
        String nines = "";
        for (int i = 0; i < number; i++) {
            nines += "9";
        }
        return nines;
    }

    private static void writeOutcome(int test, String solution) throws IOException {
        while (!solution.equals("0") && solution.startsWith("0")) {
            solution = solution.substring(1);
        }
        String output = ("Case #" + test + ": " + solution + "\n");
        fs.write(output.getBytes());
        System.out.print(output);
    }
}
