
import java.io.DataOutputStream;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.util.Scanner;


/**
 * @author Adrian Buturuga
 */
public class BotTrust
{
    private static int T;
    
    private static int dist(int x, int y)
    {
        return Math.abs(x - y);
    }
    
    public static void main(String args[]) throws FileNotFoundException, IOException
    {
        File input = new File("A-large.in");
        File output = new File("A-large.out");
        Scanner scanner = new Scanner(input);        
        DataOutputStream writer = new DataOutputStream(new FileOutputStream(output));
        T = Integer.parseInt(scanner.next());
        for (int i=0; i<T; i++)
        {
            int n = scanner.nextInt();
            int positionO = 1;
            int positionB = 1;
            int cost = 0;
            int balance = 0;
            for (int j=0; j<n; j++)
            {
                boolean isONext = scanner.next().trim().toUpperCase().equals("O");
                int target = scanner.nextInt();
                if (isONext)
                {
                    int pressCost = dist(positionO, target)+1;
                    if (balance < 0)
                    {
                        if (pressCost <= -balance)
                        {
                            cost += 1;
                            balance = 1;
                        }
                        else
                        {
                            pressCost += balance;
                            cost += pressCost;
                            balance = pressCost;
                        }
                    }
                    else
                    {
                        balance += pressCost;
                        cost += pressCost;
                    }
                    positionO = target;
                }
                else
                {
                    int pressCost = dist(positionB, target)+1;
                    if (balance > 0)
                    {
                        if (pressCost <= balance)
                        {
                            cost += 1;
                            balance = -1;
                        }
                        else
                        {
                            pressCost -= balance;
                            cost += pressCost;
                            balance = -pressCost;
                        }
                    }
                    else
                    {
                        balance -= pressCost;
                        cost += pressCost;
                    }
                    positionB = target;
                }
            }
            writer.write(("Case #"+(i+1)+": "+cost+"\n").getBytes());            
        }
        writer.flush();
        writer.close();
        scanner.close();
    }
}
