import java.io.*;
import java.nio.Buffer;
import java.util.*;

public class Test {
	
	public static final String INFILE = "A-small-attempt0.in";
	public static final String OUTFILE = "A-small.out";
	
	public static void main(String[] args) {
		new Test().go();
	}
	
	public void go() {
		try {
			BufferedReader reader = new BufferedReader(new FileReader(INFILE));
			PrintWriter writer = new PrintWriter(OUTFILE);
			
			String t = reader.readLine();
			int T = Integer.parseInt(t);
			
			for (int i=1; i<=T; i++) {
				String line = reader.readLine();
				String[] token = line.split(" ");
				int[] bases = new int[token.length];
				for (int j=0; j<token.length; j++) {
					bases[j] = Integer.parseInt(token[j]);
				}
				
				long result = 2;
				boolean found = false;
				
				while (!found) {
					boolean ok = true;
					for (int base : bases) {
						if (!test(result, base))
							ok = false;
					}
					if (ok) {
						writer.write("Case #" + i + ": " + result + "\n");
						break;
					} else {
						result++;
					}
				}
			}
			writer.close();
			reader.close();
		} catch (IOException e) {
			e.printStackTrace();
		}		
	}
	
	public boolean test(long num, int base) {
		HashSet<Long> set = new HashSet<Long>();
		set.add(num);
		long sum = 0;
		long a=num;
		int b=base;
		boolean result = false;
		while (true) {
			sum = 0;
			while (a != 0) {
				sum += (a % base) * (a % base);
				a /= base;
			}
			if (set.contains(sum)) {
				break;
			}
			if (sum == 1) {
				result = true;
				break;
			}
			set.add(sum);
			a = sum;
		}
		return result;
	}
}