import java.io.*;
public class TicTacToeTomek {
	public static void main(String args[])
	{
		try{
			// Create output file 
			FileWriter fstream = new FileWriter("out.txt");
			BufferedWriter out = new BufferedWriter(fstream);

			// Open source file 
			//FileInputStream ifstream = new FileInputStream("test.txt");
			FileInputStream ifstream = new FileInputStream("A-large.in");

			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(ifstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));

			int numberOfCase = Integer.parseInt(br.readLine());
			for (int i=1; i<=numberOfCase;i++){
				
				char[][] board = new char[4][4];
				board[0] = br.readLine().toCharArray();
				board[1] = br.readLine().toCharArray();
				board[2] = br.readLine().toCharArray();
				board[3] = br.readLine().toCharArray();
				
				char[][]board2 = board.clone();
				for(int w = 0; w < 4; w++)
					board2[w] = board2[w].clone();
				
				char[][] boardX = transformX(board);
				char[][] boardO = transformO(board2);
				
				//status: 1: X won, 2: O won, 3: Draw, 4: not completed
				int status = -1;
				char winner;
				
				//check the rows
				for (int j=0;j<4;j++){
					if (boardX[j][0]==boardX[j][1]&&boardX[j][1]==boardX[j][2]&&boardX[j][2]==boardX[j][3]&&boardX[j][2]!='.'){						
						winner=boardX[j][1];
						status = (winner=='X')? 1: 2; 
					}
					if (boardO[j][0]==boardO[j][1]&&boardO[j][1]==boardO[j][2]&&boardO[j][2]==boardO[j][3]&&boardO[j][2]!='.'){						
						winner=boardO[j][1];
						status = (winner=='X')? 1: 2; 
					}
				}
				
				//check the columns
				for (int j=0;j<4;j++){
					if (boardX[0][j]==boardX[1][j]&&boardX[1][j]==boardX[2][j]&&boardX[2][j]==boardX[3][j]&&boardX[2][j]!='.'){						
						winner=boardX[0][j];
						status = (winner=='X')? 1: 2;
					}
					if (boardO[0][j]==boardO[1][j]&&boardO[1][j]==boardO[2][j]&&boardO[2][j]==boardO[3][j]&&boardO[2][j]!='.'){						
						winner=boardO[0][j];
						status = (winner=='X')? 1: 2; 
					}
				}
				
				//check the diagonals
				if (boardX[0][0]==boardX[1][1]&&boardX[1][1]==boardX[2][2]&&boardX[2][2]==boardX[3][3]&&boardX[2][2]!='.'){						
					winner=boardX[0][0];
					status = (winner=='X')? 1: 2;
				}
				if (boardO[0][0]==boardO[1][1]&&boardO[1][1]==boardO[2][2]&&boardO[2][2]==boardO[3][3]&&boardO[2][2]!='.'){						
					winner=boardO[0][0];
					status = (winner=='X')? 1: 2; 
				}
				if (boardX[3][0]==boardX[2][1]&&boardX[2][1]==boardX[1][2]&&boardX[1][2]==boardX[0][3]&&boardX[1][2]!='.'){						
					winner=boardX[3][0];
					status = (winner=='X')? 1: 2;
				}
				if (boardO[3][0]==boardO[2][1]&&boardO[2][1]==boardO[1][2]&&boardO[1][2]==boardO[0][3]&&boardO[1][2]!='.'){						
					winner=boardO[3][0];
					status = (winner=='X')? 1: 2;
				}
				
				if (status==-1){//no win yet
					for (int a=0;a<4;a++)
						for (int b=0; b<4;b++)
							if (boardX[a][b]=='.') status=4;//ongoing 
					if (status!=4) status=3;
				}
				String textstatus="";
				if (status==1) textstatus="X won";
				if (status==2) textstatus="O won";
				if (status==3) textstatus="Draw";
				if (status==4) textstatus="Game has not completed";
				
				out.write("Case #" + i + ": " + textstatus + "\n");
				br.readLine();
			}

			//Close the input stream
			in.close();

			//Close the output stream
			out.close();
		}catch (IOException e){
			System.err.println("Error: " + e.getMessage());
		}
	}
	public static char[][] transformX(char[][] input){
		for (int i=0;i<4;i++)
			for (int j=0; j<4;j++)
				if (input[i][j]=='T') input[i][j]='X';
		return input;
	}
	public static char[][] transformO(char[][] input){
		for (int i=0;i<4;i++)
			for (int j=0; j<4;j++)
				if (input[i][j]=='T') input[i][j]='O';
		return input;
	}
}
