import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
public class Lawnmower {
	public static void main(String args[])
	{
		try{
			// Create output file 
			FileWriter fstream = new FileWriter("out.txt");
			BufferedWriter out = new BufferedWriter(fstream);

			// Open source file 
			//FileInputStream ifstream = new FileInputStream("test.txt");
			FileInputStream ifstream = new FileInputStream("B-large.in");

			// Get the object of DataInputStream
			DataInputStream in = new DataInputStream(ifstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));

			int numberOfCase = Integer.parseInt(br.readLine());
			
			for (int i=1; i<=numberOfCase;i++){
				String[] dimension = br.readLine().split("\\s+");
				int numrow = Integer.parseInt(dimension[0]);
				int numcol = Integer.parseInt(dimension[1]);//since[1] is the space
				int[][] field = new int[numrow][numcol];
				for (int j=0; j<numrow;j++){
					String[] temp = br.readLine().split("\\s+");
					for (int k=0;k<numcol;k++)
						field[j][k] = Integer.parseInt(temp[k]);
				}
				
				int min = min(field);
				boolean condition1 = checkCondition1(field, min);
				boolean condition2 = checkCondition2(field);
				
				boolean condition = false;
				
				if (numrow==1) condition = condition1;
				else condition = condition1&&condition2;
				
				String resulttext = (condition)? "YES" : "NO";
				
				System.out.println("Case #" + i + ": " + resulttext);
				
				out.write("Case #" + i + ": " + resulttext + "\n");
				
				
//				for(int j=0; j<numrow; j++){
//					for(int k=0; k<numcol; k++){
//						System.out.print(field[j][k]+" ");
//					}
//					System.out.println();
//				}
//				System.out.println();
			}

			//Close the input stream
			in.close();

			//Close the output stream
			out.close();
		}catch (IOException e){
			System.err.println("Error: " + e.getMessage());
		}
	}
	public static int min(int[][] array){
		int result=array[0][0];
		for (int i=0;i<array.length;i++)
			for (int j=0;j<array[0].length;j++)
				if (array[i][j]<result) result=array[i][j];
		return result;
	}
	public static boolean checkCondition1(int[][] array, int min){
		boolean result=true;
		for (int i=0;i<array.length;i++)
			for (int j=0;j<array[0].length;j++)
				if (array[i][j]==min) {
					boolean rowValid = true;
					boolean columnValid = true;
					for (int k=0;k<array.length;k++)
						if (array[k][j]!=min) {
							rowValid=false;
							break;
						}
					for (int l=0;l<array[0].length;l++)
						if (array[i][l]!=min) {
							columnValid=false;
							break;
						}
					result = columnValid||rowValid;
					if (result==false) return false;
				}
		return result;
	}
	
	public static boolean checkCondition2(int[][] array){
		boolean result = true;
		for (int i=0;i<array.length;i++)
			for (int j=0;j<array[0].length;j++){
				boolean a = false, b = false, c = false, d = false;
				if (i-1>=0&&i-1<array.length)
					if (array[i-1][j]<=array[i][j]) a = true;
				if (i+1>=0&&i+1<array.length)
					if (array[i+1][j]<=array[i][j]) b = true;
				if (j-1>=0&&j-1<array[0].length)
					if (array[i][j-1]<=array[i][j]) c = true;
				if (j+1>=0&&j+1<array[0].length)
					if (array[i][j+1]<=array[i][j]) d = true;
				result = a || b ||c || d;
				if (result==false) return false;
			}		
		return result;
	}
}
