import java.io.*;
import java.util.*;

public class C {
    final String file = "C-small-attempt0";

    FastScanner in;
    PrintWriter out;

    void solve() {
        long tc = in.nextLong();
        for (long t = 0; t < tc; t++) {
            out.print("Case #" + (t + 1) + ": \n");
            long n = in.nextLong();
            long j = in.nextLong();
            long counter = 0;
            long[] divisors = new long[9];
            for(long i = (long) Math.pow(2, n-1); i < (long) Math.pow(2, n); i++) {
                if(counter >= j) {
                    break;
                }
                if(isJamcoin(i, divisors)) {
                    out.print(Long.toBinaryString(i) + " ");
                    for(int d = 0; d < divisors.length; d++) {
                        out.print(divisors[d]);
                        out.print(" ");
                    }
                    out.println();
                    counter++;
                }
            }
        }
    }

    boolean isJamcoin(long num, long[] divisors) {
        String s = Long.toBinaryString(num);
        if(s.charAt(0) == '0' || s.charAt(s.length() - 1) == '0')
            return false;
        for(long i = 2; i <= 10; i++) {
            long divisor = isPrime(Long.parseLong(s, (int) i));

            if(divisor < 0)
                return false;
            divisors[(int) i-2] = divisor;
        }
        return true;
    }

    long isPrime(long num) {
        if(num < 2) return -2;
        if(num == 2) return -2;
        if(num % 2 == 0) return 2;
        for(long i = 3; i * i <= num; i += 2)
            if(num % i == 0) return i;
        return -1;
    }

    void run() {
        try {
            in = new FastScanner(new File(file + ".in"));
            out = new PrintWriter(new File(file + ".out"));

            solve();

            out.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        }
    }

    class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(File f) {
            try {
                br = new BufferedReader(new FileReader(f));
            } catch (FileNotFoundException e) {
                e.printStackTrace();
            }
        }

        String next() {
            while (st == null || !(st.hasMoreTokens())) {
                String s = null;
                try {
                    s = br.readLine();
                } catch (IOException e) {
                    e.printStackTrace();
                }
                if (s == null) {
                    return null;
                }
                st = new StringTokenizer(s);
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(this.next());
        }

        long nextLong() {
            return Long.parseLong(this.next());
        }

        double nextDouble() {
            return Double.parseDouble(this.next());
        }


    }

    public static void main(String ... args) {
        // TODO Auto-generated method stub
        new C().run();
    }
}
