package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Stack;

import mk.chip.codejam.FullyBinaryMain.Node;

public class TechnobabbleMain {

	static final String IN_FILE = "D:\\C-small-attempt2.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
//	static final String IN_FILE = "D:\\A-small-attempt1.in";
//	static final String IN_FILE = "D:\\B-large-practice.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	
	static HashMap<String, Integer> firstEnc;
	static HashMap<String, Integer> secEnc;
	static String[] wordL;
	static String[] wordR;
	
	public static void main(String[] args) {
		long startDT = System.currentTimeMillis();
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
		print("tot time: " + (System.currentTimeMillis() - startDT));
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		// Number of cases
		int cases = Integer.parseInt(in.readLine().trim());
		for (int t = 1; t <= cases; t++) {
			int parN = Integer.parseInt(in.readLine().trim());
			firstEnc = new HashMap<String, Integer>();
			secEnc = new HashMap<String, Integer>();
			wordL = new String[parN];
			wordR = new String[parN];
			
			for (int n = 0; n < parN; n++) {
				String[] words = in.readLine().trim().split(" ");
				wordL[n] = words[0];
				wordR[n] = words[1];
				
				Integer i = firstEnc.get(words[0]);
				if (i == null) {firstEnc.put(words[0], 1);}
				else {firstEnc.put(words[0], i + 1);}
				
				i = secEnc.get(words[1]);
				if (i == null) {secEnc.put(words[1], 1);}
				else {secEnc.put(words[1], i + 1);}
			}
				
			int numOrig = 0;
			for (int n = 0; n < parN; n++) {
				if (isOriginal(wordL[n], wordR[n])) numOrig++;
			}
			
			writeAndPrint(String.format("Case #%s: %s", t, parN - numOrig));
		}
	}

	static boolean isOriginal(String a, String b) {
		if (firstEnc.get(a) == 1 || secEnc.get(b) == 1) return true;
		boolean lOrig = false, rOrig = false;
		for (int i = 0; i < wordL.length; i++) {
			if (!wordL[i].equals(a) && !wordR[i].equals(b)) {
				if (wordL[i].equals(a)) {
					if (!isOriginal(wordL[i], wordR[i])) lOrig = true;
				}
				if (wordR[i].equals(b)) {
					if (!isOriginal(wordL[i], wordR[i])) rOrig = true;
				}
			}
		}
		return lOrig || rOrig;
	}
	
	/*
	 * Utility methods	
	 */
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* @param str  Line containing multiple Long values
	* @return     Stack containing parsed Long values in FILO order
	*/
	static Stack<Long> getLongs(String str) {
		Stack<Long> ls = new Stack<Long>();
		for (String s : str.split(" ")) ls.push(Long.parseLong(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		System.out.println(str);
		out.write(str);
		out.newLine();
	}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
     
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
	
	/**
	 * Convenient formated print
	 */
	static void fPrint(String fmt, Object... args) {System.out.println(String.format(fmt, args));}
	
	/**
	 * Simple Print
	 */
	static void print(Object o) {System.out.println(o);}
}