package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Stack;

public class FractilesMain {

//	static final String IN_FILE = "D:\\C-large-practice.in";
//	static final String IN_FILE = "D:\\B-large.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
	static final String IN_FILE = "D:\\D-small-attempt0.in";
//	static final String IN_FILE = "D:\\A-large-practice.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	static boolean firstLine = true;

	public static void main(String[] args) {
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		// Number of cases
		int cases = Integer.parseInt(in.readLine().trim());
		for (int t = 1; t <= cases; t++) {
			Stack<Integer> si = getInts(in.readLine().trim());
			long parS = si.pop();	// S
			long parC = si.pop();	// C
			long parK = si.pop();	// K
			
			// Initial value of multiply coefficient =  K^(C-1)
			long initCoef = 1;
			for (int i = 0; i < parC - 1; i++) initCoef *= parK;
			
			String answer = "IMPOSSIBLE";
			
			// Process if enough cleaning is available
			long minimumS = (parK % parC > 0 ? 1 : 0) + parK / parC;
			if (parS >= minimumS) {
				answer = "";
				long nextTile = 0;
				long coef = initCoef;
				for (int i = 0; i < parK; i++) {
					nextTile +=  i * coef;
					coef /= parK;
					if (coef == 0) {
						answer += " " + (nextTile + 1);
						nextTile = 0;
						coef = initCoef;
					}
				}
				if (nextTile > 0 || parK == 1) {
					answer += " " + (nextTile + 1);
				}
			}
			
			writeAndPrint(String.format("Case #%s: %s", t, answer.trim()));
			firstLine = false;
		}
	}
	
	/*
	 * Utility methods	
	 */
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* @param str  Line containing multiple Long values
	* @return     Stack containing parsed Long values in FILO order
	*/
	static Stack<Long> getLongs(String str) {
		Stack<Long> ls = new Stack<Long>();
		for (String s : str.split(" ")) ls.push(Long.parseLong(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		if (!firstLine) out.newLine();
		System.out.println(str);
		out.write(str);
	}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
     
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
	
	/**
	 * Convenient formated print
	 */
	static void fPrint(String fmt, Object... args) {System.out.println(String.format(fmt, args));}
}