package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Stack;

public class TidyNumbersMain {

//	static final String IN_FILE = "D:\\B-small-attempt0.in";
	static final String IN_FILE = "D:\\B-large.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
//	static final String IN_FILE = "D:\\D-large-practice.in";
//	static final String IN_FILE = "D:\\A-large-practice.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	
	static long startTime = System.currentTimeMillis();
	
	public static void main(String[] args) {
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
		reportTime("Exec time %s sec");
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		// Number of cases
		int cases = Integer.parseInt(in.readLine());
		for (int t = 1; t <= cases; t++) {
			char[] numN = in.readLine().toCharArray();
			char[] lastT = new char[numN.length + 1];
			lastT[0] = '0';
			for (int i = 1; i < lastT.length; i++) {
				if (numN[i - 1] >= lastT[i - 1]) {
					lastT[i] = numN[i - 1];
				} else {
					decAt(lastT, i - 1);
					while (i < lastT.length) lastT[i++] = '9';
				}
			}
			
			String solution = String.valueOf(lastT);
			
			writeAndPrint(String.format("Case #%s: %s", t, Long.parseLong(solution)));
		}
	}
 
	static boolean isTidy(long n) {
		return isTidy(String.valueOf(n).toCharArray());
	}
	
	static boolean isTidy(char[] num) {
		char lastD = 0;
		for (char d : num) {
			if (d < lastD) return false;
			lastD = d;
		}
		return true;
	}
	
	static void decAt(char[] num, int pos) {
		num[pos]--;
		if (num[pos] < num[pos - 1]) {
			num[pos] = '9';
			decAt(num, pos - 1);
		}
	}
	
//---------------------------------------------	
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		System.out.println(str);
		out.write(str);
		out.newLine();
	}
	
	/**
	 * Simple print to console method
	 * @param o item to print
	 */
	static void print(Object o) {System.out.println(o);}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
 
	static void reportTime(String msg) {
		print(String.format(msg, (System.currentTimeMillis() - startTime) / 1000.0));
	}
	
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
 
}