package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Locale;
import java.util.Stack;

public class CruiseControlMain {

//	static final String IN_FILE = "D:\\B-small-practice.in";
//	static final String IN_FILE = "D:\\B-large-practice.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
//	static final String IN_FILE = "D:\\D-large-practice.in";
	static final String IN_FILE = "D:\\A-small-attempt0.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	
	static long startTime = System.currentTimeMillis();
	
	public static void main(String[] args) {
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
		reportTime("Exec time %s sec");
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		// Number of cases
		int cases = Integer.parseInt(in.readLine());
		for (int t = 1; t <= cases; t++) {
			Stack<Integer> si = getInts(in.readLine().trim());
			int parN = si.pop();
			int parD = si.pop();
			
			double maxT = 0;
			
			for (int i = 0; i < parN; i++) {
				si = getInts(in.readLine().trim());
				double parS = si.pop();
				double parK = si.pop();
				double time = (parD - parK) / parS;
				if (time > maxT) maxT = time;
			}
			
			double s = parD / maxT;

			writeAndPrint(String.format(Locale.US, "Case #%s: %.6f", t, s));
		}
	}
 
	
//---------------------------------------------	
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		System.out.println(str);
		out.write(str);
		out.newLine();
	}
	
	/**
	 * Simple print to console method
	 * @param o item to print
	 */
	static void print(Object o) {System.out.println(o);}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
 
	static void reportTime(String msg) {
		print(String.format(msg, (System.currentTimeMillis() - startTime) / 1000.0));
	}
	
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
 
}