package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Stack;

public class AlphabetCakeMain {

//	static final String IN_FILE = "D:\\B-small-practice.in";
//	static final String IN_FILE = "D:\\B-large-practice.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
//	static final String IN_FILE = "D:\\D-large-practice.in";
	static final String IN_FILE = "D:\\A-small-attempt0.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	
	static long startTime = System.currentTimeMillis();
	
	static char[][] cake;
	
	public static void main(String[] args) {
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
		reportTime("Exec time %s sec");
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		// Number of cases
		int cases = Integer.parseInt(in.readLine());
		for (int t = 1; t <= cases; t++) {
			Stack<Integer> si = getInts(in.readLine().trim());
			int parC = si.pop();
			int parR = si.pop();
			cake = new char[parR][parC];
			for (int r = 0; r < parR; r++) {
				cake[r] = in.readLine().toCharArray();
			}

			// Top down
			for (int r = 0; r < parR; r++) {
				int ins = 0;
				char ic = '?';
				for (int c = 0; c < parC; c++) {
					if (cake[r][c] == '?') {
						cake[r][c] = ic;
					} else {
						ic = cake[r][c];
						if (ins == 0) {
							for (int i = c - 1; i >= 0; i--) cake[r][i] = ic;
						}
						ins++;
					}
				}
				// Copy above row
				if (ins == 0 && r > 0) {
					for (int i = 0; i < parC; i++) cake[r][i] = cake[r - 1][i];
				}
			}
			
			// Bottom up
			for (int r = parR - 1; r >=0; r--) {
				boolean empty = true;
				for (char ic : cake[r]) {
					empty = (ic == '?');
					if (!empty) break;	
				}
				if (empty) {
					for (int i = 0; i < parC; i++) cake[r][i] = cake[r + 1][i];
				}
			}
			
			writeAndPrint(String.format("Case #%s:", t));
			for (char[] row : cake) {
				writeAndPrint(String.valueOf(row));
			}
		}
	}
 	
	
//---------------------------------------------	
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		System.out.println(str);
		out.write(str);
		out.newLine();
	}
	
	/**
	 * Simple print to console method
	 * @param o item to print
	 */
	static void print(Object o) {System.out.println(o);}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
 
	static void reportTime(String msg) {
		print(String.format(msg, (System.currentTimeMillis() - startTime) / 1000.0));
	}
	
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
 
}