package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Stack;

public class RevengeOfPancakesMain {

//	static final String IN_FILE = "D:\\C-large-practice.in";
	static final String IN_FILE = "D:\\B-large.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
//	static final String IN_FILE = "D:\\D-large-practice.in";
//	static final String IN_FILE = "D:\\A-large-practice.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	static boolean firstLine = true;

	public static void main(String[] args) {
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		// Number of cases
		int cases = Integer.parseInt(in.readLine().trim());
		for (int t = 1; t <= cases; t++) {
			char[] initialStack = in.readLine().trim().toCharArray();
			// Prepare the stack of pancakes 
			boolean[] stack = new boolean[initialStack.length];
			for (int i = 0; i < stack.length; i++) stack[i] = initialStack[i] == '+';
			
			int flipNo = 0;
			
			while (true) {
				// Find discontinuity
				int at = 1;
				while (at < stack.length && stack[at] == stack[0]) at++;
				if (at < stack.length) {
					// If discontinuity is found make a flip  
					flip(stack, at);
					flipNo++;
				} else {
					// All pancakes are equally oriented
					// Flip the whole stack if blank side is on top
					if (stack[0] == false) {
						flip(stack, stack.length);
						flipNo++;
					}
					break;
				}
			}
							
			writeAndPrint(String.format("Case #%s: %s", t, flipNo));
			firstLine = false;
		}
	}
	
	// Flips first n pancakes
	static void flip(boolean[] stack, int n) {
		int flips = (int) Math.ceil(n / 2.0);
		for (int i = 0; i < flips; i++) {
			boolean b = !stack[i];
			stack[i] = !stack[n - 1 - i];
			stack[n - 1 - i] = b;
		}
	}
	
	/*
	 * Utility methods	
	 */
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* @param str  Line containing multiple Long values
	* @return     Stack containing parsed Long values in FILO order
	*/
	static Stack<Long> getLongs(String str) {
		Stack<Long> ls = new Stack<Long>();
		for (String s : str.split(" ")) ls.push(Long.parseLong(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		if (!firstLine) out.newLine();
		System.out.println(str);
		out.write(str);
	}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
     
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
	
	/**
	 * Convenient formated print
	 */
	static void fPrint(String fmt, Object... args) {System.out.println(String.format(fmt, args));}
}