package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.BitSet;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Stack;

import mk.chip.codejam.FullyBinaryMain.Node;

public class GettingDigitsMain {

//	static final String IN_FILE = "D:\\A-large.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
	static final String IN_FILE = "D:\\A-small-attempt1.in";
//	static final String IN_FILE = "D:\\B-large-practice.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	
	static final String[] digits = {"ZERO", "ONE", "TWO", "THREE", "FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE"};
	static final char[] letterMarks = {'Z', ' ', 'W', ' ', 'U', ' ', 'X', ' ', 'G', ' '};

	public static void main(String[] args) {
		long startDT = System.currentTimeMillis();
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
		print("tot time: " + (System.currentTimeMillis() - startDT));
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		// Number of cases
		int cases = Integer.parseInt(in.readLine().trim());
		for (int t = 1; t <= cases; t++) {
			int[] letterOccurences = new int[26];
			String sequence = in.readLine().trim();
			int letterCnt = sequence.length();
			for (char c : sequence.toCharArray()) {
				letterOccurences[c - 'A']++;
			}
			int[] sureDigits = new int[10];
//			int sureCnt = 0;
			for (int i = 0; i < 10; i++) {
				char lm = letterMarks[i];
				if (lm != ' ' &&  letterOccurences[lm - 'A'] > 0) {
					sureDigits[i] = letterOccurences[lm - 'A'];
					removeDigits(letterOccurences, digits[i], sureDigits[i]);
				}
			}
			
			int digit = 0;
			String answer = "";
			
			while (letterCnt > 0) {
				if (sureDigits[digit] > 0) {
					letterCnt -= sureDigits[digit] * digits[digit].length();
					while (sureDigits[digit]-- > 0) answer += Integer.toString(digit);
					digit++;
				} else {
				
					boolean fits = true;
					for (char letter : digits[digit].toCharArray()) {
						if (letterOccurences[letter - 'A'] < 1) {
							fits = false;
							break;
						}
					}
					
					if (fits) {
						for (char c : digits[digit].toCharArray()) {
							letterOccurences[c - 'A']--;
							letterCnt--;
						}
						answer += Integer.toString(digit);
					} else {
						digit++;
					}
				}
			}
			
			writeAndPrint(String.format("Case #%s: %s", t, answer));
		}
	}

	static void removeDigits(int[] occurences, String digit, int times) {
		for (char c : digit.toCharArray()) {
			occurences[c - 'A'] -= times;
		}
	}
	
	/*
	 * Utility methods	
	 */
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* @param str  Line containing multiple Long values
	* @return     Stack containing parsed Long values in FILO order
	*/
	static Stack<Long> getLongs(String str) {
		Stack<Long> ls = new Stack<Long>();
		for (String s : str.split(" ")) ls.push(Long.parseLong(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		System.out.println(str);
		out.write(str);
		out.newLine();
	}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
     
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
	
	/**
	 * Convenient formated print
	 */
	static void fPrint(String fmt, Object... args) {System.out.println(String.format(fmt, args));}
	
	/**
	 * Simple Print
	 */
	static void print(Object o) {System.out.println(o);}
}