package mk.chip.codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.HashSet;
import java.util.Random;
import java.util.Stack;

public class CoinJamMain {

	static final String IN_FILE = "D:\\C-small-attempt1.in";
//	static final String IN_FILE = "D:\\D-large.in";
//	static final String IN_FILE = "D:\\C-large-practice.in";
//	static final String IN_FILE = "D:\\D-small-attempt0.in";
//	static final String IN_FILE = "D:\\A-large-practice.in";
//	static final String IN_FILE = "D:\\codejam_in.txt";
	static final String OUT_FILE = "D:\\codejam_out.txt";
	static FileReader inFile = null;
	static FileWriter outFile = null;
	static BufferedReader in = null;
	static BufferedWriter out = null;
	static boolean firstLine = true;
	
	static int[] primes = new int[10000];
	static long[][] powers = new long[11][16];

	public static void main(String[] args) {
		// Open input and output file
		try {
			openIn();
			openOut();

			// Run the solution
			solution();
		} catch (IOException e) {
			e.printStackTrace();
		}

		// Close intput and output file
		closeInAndOut();
	}

	/**
	* Solution of a codejam problem
	* @throws IOException
	*/
	static void solution() throws IOException {
		long startDT = System.currentTimeMillis();
		generatePrimes();
//		System.out.println(System.currentTimeMillis() - startDT);
		calculatePowers();
/*		{		JamCoin jc = new JamCoin("1001");
		System.out.println(jc.toString());
		System.out.println(powers[2][5]);
		for (int i = 2; i <= 9; i++) System.out.println(i + " : " + jc.getInBaseN(i));
		}
*/		// Number of cases
		int cases = Integer.parseInt(in.readLine().trim());
		for (int t = 1; t <= cases; t++) {
			Stack<Integer> si = getInts(in.readLine().trim());
			int parJ = si.pop();	// S
			int parN = si.pop();	// C
			
			HashSet<String> jamCoins = new HashSet<String>(2 * parN);
			
			writeAndPrint(String.format("Case #%s:", t));
			firstLine = false;
			
			for (int j = 0; j < parJ; j++) {
				JamCoin jc = new JamCoin(parN);
				String answer, divisors;
				boolean verified;
				do {
					verified = true;
					divisors = "";
					do {
						jc.setRandom();
						answer = jc.toString();
					} while (jamCoins.contains(answer));
					for (int i = 2; i <= 10; i++) {
						long d = jc.findDivisor(i);
						if (d == 1) {
							verified = false;
							break;
						} else {
							divisors += " " + d;
						}
					}
				} while (!verified);
				writeAndPrint(answer + divisors);
				jamCoins.add(answer);
				verify(answer + divisors);
			}
			
		}
	}
	
	static void generatePrimes() {
		primes[0] = 2;
		primes[1] = 3;
		for (int i = 2; i < primes.length; i++) {
			for (int j = primes[i - 1] + 2; j < Integer.MAX_VALUE - 10; j += 2) {
				boolean isPrime = true;
				for (int k = 0; k < i; k++) { 
					if (j % primes[k] == 0) {
						isPrime = false;
						break;
					}
				}
				if (isPrime) {
					primes[i] = j;
					break;
				}
			}
		}
	}
	
	static void calculatePowers() {
		for (int i = 1; i <= 10; i++) {
			long result = 1;
			for (int j = 0; j < powers[i].length; j++) {
				powers[i][j] = result;
				result *= i;
			}
		}
	}
	
	static class JamCoin {
		static Random random = new Random(12345L);
		boolean[] digits;
		JamCoin(int len) {
			digits = new boolean[len];
			Arrays.fill(digits, false);
		}
		JamCoin(String coin) {
			char[]chars = coin.toCharArray();
			digits = new boolean[chars.length];
			for (int i = 0; i < digits.length; i++) {
				digits[i] = (chars[chars.length - 1 - i] == '1');
			}
		}
		void setBare() {
			Arrays.fill(digits, false);
			digits[0] = digits[digits.length - 1] = true;
		}
		void setRandom() {
			for (int i = 0; i < digits.length; i++) digits[i] = random.nextBoolean();
			digits[0] = digits[digits.length - 1] = true;
		}
		long getInBaseN(int base) {
			long result = 0;
			for (int i = 0; i < digits.length; i++) 
				if (digits[i]) result += powers[base][i];
			return result;
		}
		long findDivisor(int base) {
			long val = getInBaseN(base);
			long divisor = 1;
			for (long l : primes) {
				if (val % l == 0) {
					divisor = l;
					if (val == divisor) divisor = 1;
					break;
				}
			}
	if (val == divisor) System.err.println(base + " : " + divisor);
			return divisor;
		}
		public String toString() {
			char[] cd = new char[digits.length];
			for (int i = 0; i < cd.length; i++) { 
				if (digits[digits.length - 1 - i]) {cd[i] = '1';}
				else {cd[i] = '0';}
			}
			return String.copyValueOf(cd);
		}
	}
	
	static void verify(String s) {
		String[] hr = s.split(" ");
		JamCoin jc = new JamCoin(hr[0]);
		for (int i = 1; i < 10; i++) {
			if (jc.getInBaseN(i + 1) % Long.valueOf(hr[i]) > 0 ) System.err.println(i + " : " + s);
		}
	}
	/*
	 * Utility methods	
	 */
	
	/**
	* @param str  Line containing multiple integer values
	* @return     Stack containing parsed Integer values in FILO order
	*/
	static Stack<Integer> getInts(String str) {
		Stack<Integer> ls = new Stack<Integer>();
		for (String s : str.split(" ")) ls.push(Integer.parseInt(s));
		return ls;
	}
     
	/**
	* @param str  Line containing multiple Long values
	* @return     Stack containing parsed Long values in FILO order
	*/
	static Stack<Long> getLongs(String str) {
		Stack<Long> ls = new Stack<Long>();
		for (String s : str.split(" ")) ls.push(Long.parseLong(s));
		return ls;
	}
     
	/**
	* Writes simultaneously to output file and console
	* @param str
	* @throws IOException
	*/
	static void writeAndPrint(String str) throws IOException {
		if (!firstLine) out.newLine();
		System.out.println(str);
		out.write(str);
	}
     
	/**
	* Opens the predefined input file
	* @throws FileNotFoundException
	*/
	static void openIn() throws FileNotFoundException {
		inFile = new FileReader(IN_FILE);
		in = new BufferedReader(inFile);
	}
 
	/**
	* Opens an output file
	* @throws IOException
	*/
	static void openOut() throws IOException {
		outFile = new FileWriter(OUT_FILE);
		out = new BufferedWriter(outFile);
	}
     
	/**
	* Close input and output file and corresponding reader/writer
	*/
	static void closeInAndOut() {
		if (out != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (outFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (in != null) {
			try {out.close();}
			catch (IOException e) {}
		}
		if (inFile != null) {
			try {out.close();}
			catch (IOException e) {}
		}
	}
	
	/**
	 * Convenient formated print
	 */
	static void fPrint(String fmt, Object... args) {System.out.println(String.format(fmt, args));}
}