import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import Library.*;

class Nd {
	List<Nd> next;
	List<Nd> prev;
	char x;
	boolean visited;
	
	public List<Nd> getNext() {
		return next;
	}
	public void addPrev(Nd previous) {
		prev.add(previous);
	}
	public void addNext(Nd nxt) {
		next.add(nxt);
	}
	public void setNext(List<Nd> next) {
		this.next = next;
	}
	public List<Nd> getPrev() {
		return prev;
	}
	public void setPrev(List<Nd> prev) {
		this.prev = prev;
	}
	public char getX() {
		return x;
	}
	public boolean isVisited() {
		return visited;
	}
	public void setVisited(boolean visited) {
		this.visited = visited;
	}
	public void setX(char x) {
		this.x = x;
	}
	public Nd() {
		next = new ArrayList<Nd>();
		prev = new ArrayList<Nd>();
		visited = false;
	}
	
}

public class Waterfall {

	private static Input in = new Input();
	private static Output out = new Output("output/Waterfall.out");
	private static Nd matrix[][];
	private static int altitudes[][];
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		int T = in.readInt();
		for (int t=0; t < T; t++) {
			int H = in.readInt();
			int W = in.readInt();
			altitudes = new int[H][W];
			matrix = new Nd[H][W];
			for (int row = 0; row < H; row++) {
				for (int col = 0; col < W; col++) {
					altitudes[row][col] = in.readInt();
					matrix[row][col] = new Nd();
				}
			}
			for (int row = 0; row < H; row++) {
				for (int col = 0; col < W; col++) {
					findParent(row,col,H,W);
				}
			}
			char currChar = 'a';
			for (int row = 0; row < H; row++) {
				for (int col = 0; col < W; col++) {
					if (!matrix[row][col].isVisited()) {
						bfs(currChar, matrix[row][col]);
						int val = (int)currChar;
						val++;
						currChar = (char)val;
					}
				}
			}
			
			out.printf("Case #%d:\n",t+1);
			for (int row = 0; row < H; row++) {
				for (int col = 0; col < W; col++) {
					out.print(matrix[row][col].getX() + " ");
				}
				out.printf("\n");
			}
		}
	}
	
	public static void bfs(char curr, Nd now) {
		if (!now.isVisited()) {
			now.setX(curr);
			now.setVisited(true);
			for (Nd child: now.getNext()) {
				bfs(curr,child);
			}
			for (Nd child: now.getPrev()) {
				bfs(curr,child);
			}
		}
	}

	//Set the parent/child of current node to the neighbor that has the least val
	public static void findParent(int row, int col, int maxRow, int maxCol) {
		//search north
		int north = 10000, south = 10000, west= 10000, east=10000;
		if (row > 0)
			north = altitudes[row-1][col];
		if (col > 0)
			west = altitudes[row][col-1];
		if (row < maxRow-1) {
			south = altitudes[row+1][col];
		}
		if (col < maxCol -1) {
			east = altitudes[row][col+1];
		}
		int curr = altitudes[row][col];
		if (row > 0 && north < curr && north <= south && north <= west && north <= east) {
			matrix[row][col].addPrev(matrix[row-1][col]);
			matrix[row-1][col].addNext(matrix[row][col]);
		} else
		if (col > 0 && west < curr && west <= south && west <= north && west <= east) {
			matrix[row][col].addPrev(matrix[row][col-1]);
			matrix[row][col-1].addNext(matrix[row][col]);
		} else
		if (col < maxCol-1 && east < curr && east <= south && east <= west && east <= north) {
			matrix[row][col].addPrev(matrix[row][col+1]);
			matrix[row][col+1].addNext(matrix[row][col]);
		} else
		if (row < maxRow-1 && south < curr && south <= north && south <= west && south <= east) {
			matrix[row][col].addPrev(matrix[row+1][col]);
			matrix[row+1][col].addNext(matrix[row][col]);
		}
	}
}
