import java.io.*;
import java.math.BigInteger;
import java.util.*;

public class TaskA implements Runnable {

	private InputReader in;
	private PrintWriter out;
	private static final int INF = 1000000000;

	public static void main(String[] args) {
		PrintStream stdout = new PrintStream(System.out);
		new Thread(new TaskA()).start();
		System.setOut(stdout);
		System.out.println("Done.");
	}

	public TaskA() {
		try {
			//comment these out if you want to use stdin/stdout
			System.setIn(new FileInputStream("input.txt"));
			System.setOut(new PrintStream(new FileOutputStream("output.txt")));
		} catch (FileNotFoundException e) {
			throw new RuntimeException();
		}
		in = new InputReader(System.in);
		out = new PrintWriter(System.out);
	}

	/**
	 * main function goes here.
	 */
	@Override
	public void run() {
		int T= in.readInt();
		for (int t = 0; t < T; t++) {
			out.print("Case #" + (t+1) + ": ");
			int l = in.readInt();
			char P[] = new char[l];
			int I[] = new int[l];
			
			int time = 0;
			int count = 0;
			LinkedList<Integer> nextO = new LinkedList<Integer>();
			LinkedList<Integer> nextB = new LinkedList<Integer>();
			for (int i = 0; i < l; i++) {
				P[i] = in.readCharacter();
				I[i] = in.readInt() - 1;
				if (P[i] == 'O') {
					nextO.add(Integer.valueOf(I[i]));
				} else {
					nextB.add(Integer.valueOf(I[i]));
				}
			}
			int O_pos = 0;
			int B_pos = 0;
			while (count < l) {
				if ((P[count] == 'O' && O_pos == I[count]) || (P[count] == 'B' && B_pos == I[count])) {
					if (P[count] == 'O') {
						nextO.removeFirst();
						if (!nextB.isEmpty() && nextB.getFirst().intValue() < B_pos) {
							B_pos--;
						} else if (!nextB.isEmpty() && nextB.getFirst().intValue() > B_pos){
							B_pos++;
						}
					} else {
						nextB.removeFirst();
						if (!nextO.isEmpty() && nextO.getFirst().intValue() < O_pos) {
							O_pos--;
						} else if (!nextO.isEmpty() && nextO.getFirst().intValue() > O_pos){
							O_pos++;
						} 
					}
					count++;
				} else {
					if (!nextO.isEmpty() && nextO.getFirst().intValue() < O_pos) {
						O_pos--;
					} else if (!nextO.isEmpty() && nextO.getFirst().intValue() > O_pos){
						O_pos++;
					} 
					if (!nextB.isEmpty() && nextB.getFirst().intValue() < B_pos) {
						B_pos--;
					} else if (!nextB.isEmpty() && nextB.getFirst().intValue() > B_pos){
						B_pos++;
					}
				}
				time++;
			}
			out.println(time);
		}
		out.close();
	}

	/**
	 * in.read...
	 * out.println...
	 * out.close
	 */
	private static class InputReader {
		private InputStream stream;
		private byte[] buf = new byte[1000];
		private int curChar, numChars;

		public InputReader(InputStream stream) {
			this.stream = stream;
		}

		private int read() {
			if (numChars == -1)
				throw new InputMismatchException();
			if (curChar >= numChars) {
				curChar = 0;
				try {
					numChars = stream.read(buf);
				} catch (IOException e) {
					throw new InputMismatchException();
				}
				if (numChars <= 0)
					return -1;
			}
			return buf[curChar++];
		}

		public int readInt() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			int res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public long readLong() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			long res = 0;
			do {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			} while (!isSpaceChar(c));
			return res * sgn;
		}

		public String readString() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			StringBuffer res = new StringBuffer();
			do {
				res.appendCodePoint(c);
				c = read();
			} while (!isSpaceChar(c));
			return res.toString();
		}

		private boolean isSpaceChar(int c) {
			return c == ' ' || c == '\n' || c == '\r' || c == '\t' || c == -1;
		}

		private String readLine0() {
			StringBuffer buf = new StringBuffer();
			int c = read();
			while (c != '\n' && c != -1) {
				buf.appendCodePoint(c);
				c = read();
			}
			return buf.toString();
		}

		public String readLine() {
			String s = readLine0();
			while (s.trim().length() == 0)
				s = readLine0();
			return s;
		}

		public String readLine(boolean ignoreEmptyLines) {
			if (ignoreEmptyLines)
				return readLine();
			else
				return readLine0();
		}

		public BigInteger readBigInteger() {
			try {
				return new BigInteger(readString());
			} catch (NumberFormatException e) {
				throw new InputMismatchException();
			}
		}

		public char readCharacter() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			return (char) c;
		}

		public double readDouble() {
			int c = read();
			while (isSpaceChar(c))
				c = read();
			int sgn = 1;
			if (c == '-') {
				sgn = -1;
				c = read();
			}
			double res = 0;
			while (!isSpaceChar(c) && c != '.') {
				if (c < '0' || c > '9')
					throw new InputMismatchException();
				res *= 10;
				res += c - '0';
				c = read();
			}
			if (c == '.') {
				c = read();
				double m = 1;
				while (!isSpaceChar(c)) {
					if (c < '0' || c > '9')
						throw new InputMismatchException();
					m /= 10;
					res += (c - '0') * m;
					c = read();
				}
			}
			return res * sgn;
		}
	}
}
