import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import Library.Input;
import Library.Output;


public class Prisoners {

	private static Input in = new Input();
	private static Output out = new Output("output/Prisoners.out");
	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		int N = in.readInt();
		for (int c = 0; c < N; c++) {
			int P = in.readInt();
			int Q = in.readInt();
			List<Integer> prisoners = new ArrayList<Integer>();
			for (int i=0; i<P; i++) {
				prisoners.add(Integer.valueOf(i+1));
			}
			List<Integer> release = new ArrayList<Integer>();
			for (int q=0; q<Q; q++) {
				release.add(Integer.valueOf(in.readInt()));
			}
			int cost = 0;
			while (release.size() > 0) {
				Integer prisoner = chooseLeastValue(release,prisoners,P);
				cost += calculateCostOfRelease(prisoner, prisoners,P);
				prisoners.remove(prisoner);
				release.remove(prisoner);
			}
			out.printf("Case #%d: %d\n",c+1,cost);
		}
		
	}
	private static int calculateCostOfRelease(Integer prisoner,
			List<Integer> prisoners,int P) {
		int cost = 0;
		for (int i = prisoner.intValue()-1; i > 0; i--) {
			if (prisoners.contains(Integer.valueOf(i))) {
				cost++;
			} else
				break;
		}
		for (int i = prisoner.intValue()+1; i <= P; i++) {
			if (prisoners.contains(Integer.valueOf(i))) {
				cost++;
			} else
				break;
		}
		return cost;
	}
	private static Integer chooseLeastValue(List<Integer> release, List<Integer> prisoners, int p) {
		int minVal = 1000000;
		Integer chosen = null;
		for (Integer r: release) {
			int val = calculateCostOfRelease(r,prisoners,p);
			if (val == minVal) {
				if (Math.abs(((double)(p+1))/2.0 - r.doubleValue()) < Math.abs(((double)(p+1))/2.0 - chosen.doubleValue())) {
					chosen = r;
				}
			} else
			if (val < minVal) {
				minVal = val;
				chosen = r;
			}
		}
		return chosen;
	}

}
