import java.util.*;
import java.io.*;

public class Solution
{
	static String filename = "B-small-attempt3";
	static Scanner input;

    public static void main(String ... orange) throws Exception
    {
		File file = new File(filename + ".in");
        input = new Scanner(file);
	    PrintWriter writer = new PrintWriter(filename + ".out", "UTF-8");

        int numCases = input.nextInt();
        for (int n = 0; n < numCases; n++)
        {
        	// Solve each test case
        	String solution = processTestCase();
            
            writer.printf("Case #%d: %s\n", n + 1, solution);
            System.out.printf("Case #%d: %s\n", n + 1, solution);
        }
        
        writer.close();
        input.close();
    }
    
    public static String processTestCase() {
    	
    	// Use input.nextLong() to get next Long
    	// Use input.next() to get next line
    	
    	int B = input.nextInt();
    	long N = input.nextLong();
    	
    	int time[] = new int[B];
    	int remain[] = new int[B];
    	for (int i = 0; i < time.length; i++) {
			time[i] = input.nextInt();
		}
    	
    	if (N <= B) {
			return "" + N;
		}
    	
    	long customerIn = 0L;
    	long divide = 0;
    	int lastIndex = 0;
    	
    	// Find all clear or finish
    	while (customerIn <= N) {
    		
    		// Optimize
    		if (divide != 0) {
    			customerIn = Math.max(B + divide*((N - B)/divide), customerIn);
    			System.out.println("in = " + customerIn + " " + N);
    			
				if (customerIn == N) {
					return "" + (lastIndex+1);
				}
			}
    		
    		// Find min cut time
			int min = 100000;
			for (int i = 0; i < remain.length; i++) {
				if (remain[i] < min) {
					min = remain[i];
				}
			}
			
			// Cut 
			for (int i = 0; i < remain.length; i++) {
				remain[i] -= min;
			}
			
			// If remain[i] = 0, 1 customer in
			// Add time[i] to remain[i]
			for (int i = 0; i < remain.length; i++) {
				if (remain[i] == 0 ) {
					customerIn++;
					lastIndex = i;
					remain[i]=time[i]; 
					
					if (customerIn == N) {
						return "" + (i+1);
					}
				}
			}

			// If not first time to run
			if (min != 0) {
				// current state equal to customerIn = B
				// Set divide to customerIn - B
				for (int i = 0; i < remain.length; i++) {
					if (remain[i] == time[i]) {
						divide = customerIn - B;
					}
				}
			}
		}
    	
    	return " All clear ";
	}
    

}
