package ynu.edu.codejam.example2;

import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.Date;
import java.util.List;

public class SolveTimetable {

	private static SimpleDateFormat format=new SimpleDateFormat("HH:mm");
	
	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws IOException, ParseException {
		BufferedReader in = new BufferedReader(new FileReader("B-large.in"));
		PrintWriter out = new PrintWriter(new FileWriter("B-large-output.txt"), true);
		int size = Integer.valueOf(in.readLine());
		for(int i=0;i<size;i++){
			long Turnaroundtime=Long.valueOf(in.readLine())*1000*60;
			String[]temp=in.readLine().split(" ");
			int startANum=Integer.valueOf(temp[0]);
			int startBNum=Integer.valueOf(temp[1]);
			
			List<Train> startATrains=new ArrayList();//保存从A出发的车.
			List<Train> startBTrains=new ArrayList();//保存从B出发的车.

			for(int j=0;j<startANum;j++){
				Train train=new Train();
				String[] time=in.readLine().split(" ");
				train.setStartTime(format.parse(time[0]));
				train.setEndTime(format.parse(time[1]));
				train.setDuplicate(false);
				startATrains.add(train);
			} 

			for(int j=0;j<startBNum;j++){
				Train train=new Train();
				String[] time=in.readLine().split(" ");
				train.setStartTime(format.parse(time[0]));
				train.setEndTime(format.parse(time[1]));
				train.setDuplicate(false);
				startBTrains.add(train);
			}
			
			Comparator startcomp = new Startcomparator();
			Comparator endcomp=new Endcomparator();
			//从A出发的按出发时间降序排,B过来的按到达时间的降序排.
			Collections.sort(startATrains,startcomp);
			Collections.sort(startBTrains,endcomp);
			
			//计算从A出发的车.若可以有反方向代替则设置duplicate为true.
			for(int j=0;j<startBNum;j++){
				Date date=new Date(startBTrains.get(j).getEndTime().getTime()+Turnaroundtime);
				for(int k=0;k<startANum;k++){
					Train startAtrain=startATrains.get(k);
					if(!startAtrain.getDuplicate()&&!startAtrain.getStartTime().before(date)){
						startATrains.get(k).setDuplicate(true);
						break;
					}
				}
			}
			//与上面相反,从B出发的按出发时间降序排,A过来的按到达时间的降序排.
			Collections.sort(startATrains,endcomp);
			Collections.sort(startBTrains,startcomp);
			
			//计算从B出发的车.若可以有反方向代替则设置duplicate为true.
			for(int j=0;j<startANum;j++){
				Date date=new Date(startATrains.get(j).getEndTime().getTime()+Turnaroundtime);
				for(int k=0;k<startBNum;k++){
					Train startBtrain=startBTrains.get(k);
					if(!startBtrain.getDuplicate()&&!startBtrain.getStartTime().before(date)){
						startBTrains.get(k).setDuplicate(true);
						break;
					}
				}
			}
			
			out.print("Case #"+(i+1)+": ");
			int countA=0,countB=0;
			for(int m=0;m<startANum;m++){
				if(startATrains.get(m).getDuplicate()==false)
					countA++;
			}
			
			for(int m=0;m<startBNum;m++){
				if(startBTrains.get(m).getDuplicate()==false)
					countB++;
			}
			out.println(countA+" "+countB);
		}

	}
	
	

}
