import java.awt.List;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Scanner;
import java.util.Set;
import static java.lang.Math.*;

import org.jgrapht.graph.DirectedWeightedMultigraph;
import org.jgrapht.graph.DefaultWeightedEdge;
import org.jgrapht.alg.*;


public class Main {

	public static void main(String[] args) throws Exception{
		Scanner reader = new Scanner(new File("1.in"));
		FileWriter writer = new FileWriter(new File("1.out"));
		int t = reader.nextInt();
		for(int j = 0; j < t; j++){
			int n, e;
			n = reader.nextInt();
			e = reader.nextInt();
			DirectedWeightedMultigraph<Integer, DefaultWeightedEdge> g = new DirectedWeightedMultigraph<Integer, DefaultWeightedEdge>(DefaultWeightedEdge.class);
			for(int i = 0; i < n; i++){
				g.addVertex(i);
			}
			for(int i = 0; i < e; i++){
				String s = reader.next();
				String[] nodes = s.split(",");
				g.addEdge(Integer.parseInt(nodes[0]), Integer.parseInt(nodes[1]));
				g.addEdge(Integer.parseInt(nodes[1]), Integer.parseInt(nodes[0]));
			}
			//HashMap<DefaultWeightedEdge, Boolean> map = new HashMap<DefaultWeightedEdge, Boolean>();
			Boolean[] visited = new Boolean[n];
			for(int i = 0 ; i < n; i++)
				visited[i] = false;
			
			for(int i = 0; i < n; i++){
				Set<DefaultWeightedEdge> set =  g.outgoingEdgesOf(i);
				
				
				int ile = 0;
				for(DefaultWeightedEdge edge : set){

					if(!visited[g.getEdgeTarget(edge)]){
						visited[g.getEdgeTarget(edge)] = true;
						ile++;
					}
				}
				
				/*
				for(DefaultWeightedEdge edge : set){
					if(g.getEdgeWeight(edge) == 1.0)
						g.setEdgeWeight(edge, g.outDegreeOf(i));
				}
				*/
				for(DefaultWeightedEdge edge : set){
					if((g.getEdgeWeight(edge) == 1.0) || (g.getEdgeWeight(edge) == 0))
						g.setEdgeWeight(edge, max(ile , 0));
				}
			}

			writer.write("Case #" + (j + 1) + ": ");
			DijkstraShortestPath<Integer, DefaultWeightedEdge> dsp = new DijkstraShortestPath<Integer, DefaultWeightedEdge>(g, 0, 1);
			java.util.List<DefaultWeightedEdge> list = dsp.getPathEdgeList();
			int threat = 0;
			for(DefaultWeightedEdge edge : list){
				threat += g.getEdgeWeight(edge);
			}
			writer.write((max(list.size() - 1, 0)) + " " + threat + "\n");
		}
		reader.close();
		writer.close();
		
	}
}
