package round01;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.SortedSet;
import java.util.TreeSet;

/**
 * Problem A. Speaking in Tongues
 * 
 * Problem

We have come up with the best possible language here at Google, called Googlerese. To translate text into Googlerese, we take any message and replace each English letter with another English letter. This mapping is one-to-one and onto, which means that the same input letter always gets replaced with the same output letter, and different input letters always get replaced with different output letters. A letter may be replaced by itself. Spaces are left as-is.

For example (and here is a hint!), our awesome translation algorithm includes the following three mappings: 'a' -> 'y', 'o' -> 'e', and 'z' -> 'q'. This means that "a zoo" will become "y qee".

Googlerese is based on the best possible replacement mapping, and we will never change it. It will always be the same. In every test case. We will not tell you the rest of our mapping because that would make the problem too easy, but there are a few examples below that may help.

Given some text in Googlerese, can you translate it to back to normal text?
Solving this problem

Usually, Google Code Jam problems have 1 Small input and 1 Large input. This problem has only 1 Small input. Once you have solved the Small input, you have finished solving this problem.
Input

The first line of the input gives the number of test cases, T. T test cases follow, one per line.

Each line consists of a string G in Googlerese, made up of one or more words containing the letters 'a' - 'z'. There will be exactly one space (' ') character between consecutive words and no spaces at the beginning or at the end of any line.
Output

For each test case, output one line containing "Case #X: S" where X is the case number and S is the string that becomes G in Googlerese.
Limits

1  T  30.
G contains at most 100 characters.
None of the text is guaranteed to be valid English.
Sample


Input
3
ejp mysljylc kd kxveddknmc re jsicpdrysi
rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd
de kr kd eoya kw aej tysr re ujdr lkgc jv


Output
Case #1: our language is impossible to understand
Case #2: there are twenty six factorial possibilities
Case #3: so it is okay if you want to just give up

 * 
 * @author chmin
 *
 */
public class SpeakingInTongues {

	static String [] patterns = new String []{
			"a", "y", 
			"b", "h", 
			"c", "e", 
			"d", "s", 
			"e", "o", 
			"f", "c", 
			"g", "v", 
			"h", "x", 
			"i", "d", 
			"j", "u", 
			"k", "i", 
			"l", "g", 
			"m", "l", 
			"n", "b", 
			"o", "k", 
			"p", "r", 
			"q", "z", 
			"r", "t", 
			"s", "n", 
			"t", "w", 
			"u", "j", 
			"v", "p", 
			"w", "f", 
			"x", "m", 
			"y", "a", 
			"z", "q"
	};
	static String transform ( String value ){
		StringBuffer buf = new StringBuffer() ;
		
		for( int i = 0 ; i < value.length() ; i++){
			if ( " ".equals("" + value.charAt(i)) ){
				buf.append(" ");
				continue;
			}
			for ( int k = 0 ; k < patterns.length ; k+=2){
				if ( patterns[k].equals("" + value.charAt(i))){
					buf.append(patterns[k+1]);
					break;
				}
			}
		}
		return buf.toString();
	}
	
	static List<String> readFile ( String fName) throws IOException{
		ArrayList<String> list = new ArrayList<>();
		
		BufferedReader br = new BufferedReader(new FileReader(fName));
		String line = "";
		br.readLine(); // 
		while ( (line = br.readLine()) != null  ){
			list.add(line);
		}
		return list;
		
	}
	
	static void writeToFile(String fName, String content ) throws IOException {
		BufferedWriter bw = new BufferedWriter(new FileWriter(fName));
		bw.write(content);
		bw.close();
	}
	/**
	 * @param args
	 */
	public static void main(String[] args) {
		StringBuffer buf1 = new StringBuffer();
		StringBuffer buf2 = new StringBuffer();
		
		buf1.append("zejp mysljylc kd kxveddknmc re jsicpdrysi rbcpc ypc rtcsra dkh wyfrepkym veddknkmkrkcd de kr kd eoya kw aej tysr re ujdr lkgc jvq");
		buf2.append("qour language is impossible to understand there are twenty six factorial possibilities so it is okay if you want to just give upz");
		
		
		StringBuilder results = new StringBuilder();
		try {
			List<String> lines = readFile("R1.in");
			for( int i = 0 ; i < lines.size(); i++){
				results.append("Case #" + (i+1) + ": ");
				results.append(transform(lines.get(i)) + System.getProperty("line.separator"));
			}
			writeToFile ("R1.out", results.toString());
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		
		String result = transform(buf1.toString());
		
		System.out.println(result);
		
		
		
		
//		char [] ch1 = buf1.toString().toCharArray();
//		char [] ch2 = buf2.toString().toCharArray();
//		
//		HashMap<String, String> maps = new HashMap<>(27);
//		for( int i = 0 ; i < ch1.length ; i++){
//			maps.put(""+ ch1[i], "" + ch2[i]);
//		}
//		
//		SortedSet<String> keySet = new TreeSet<>(maps.keySet());
//		SortedSet<String> valueSet = new TreeSet<>(maps.values());
//		Iterator<String> it = keySet.iterator();
//		int cnt = 1;
//		while ( it.hasNext() ){
//			String key = it.next();
//			System.out.println("\"" + key + "\", \"" + maps.get(key) + "\", ");
//			cnt ++ ;
//		}
		
//		it = valueSet.iterator();
//		while ( it.hasNext() ){
//			System.out.println(it.next());
//		}
		

	}

}
