
import java.util.ArrayList;
import java.util.Scanner;

public class ProblemA
{

    static int[] states = new int[2];
    static int blue = 1, orange = 0;

    public static void main(String[] args)
    {
        Scanner scan = new Scanner(System.in);

        int T = scan.nextInt();

        for (int i = 0; i < T; i++)
        {

            int N = scan.nextInt();

            ArrayList<Pair> list = new ArrayList<Pair>();

            for (int j = 0; j < N; j++)
            {


                Pair p = new Pair();

                p.S = scan.next();
                p.I = scan.nextInt();

                list.add(p);

            }

            states[blue] = 1;
            states[orange] = 1;

            int res = compute(list);

            System.out.println("Case #" + (i+1) + ": " + res);

        }

    }

    private static int compute(ArrayList<Pair> list) {


        ArrayList<Pair> taskB = new ArrayList<Pair>();
        ArrayList<Pair> taskO = new ArrayList<Pair>();
        ArrayList<Pair>[] tasks = new ArrayList[2];

        tasks[blue] = taskB;
        tasks[orange] = taskO;

        for(Pair p : list)
        {
            if (p.S.equals("B")) tasks[blue].add(p);
            else tasks[orange].add(p);

        }



        int res = 0;

        for(Pair p : list)
        {
            int color = (p.S.equals("B") ? 1 : 0);
            res += makeProgress(color,p,tasks);
        }

        return res;
    }

    private static int makeProgress(int color,Pair p, ArrayList[] tasks) {

        tasks[color].remove(p);

        int res = Math.abs(p.I - states[color]) + 1;

        states[color] = p.I;
        int icolor = (color == 1 ? 0 : 1);

        if (tasks[icolor].size() > 0)
            states[icolor] = computeState(res,states[icolor],(Pair)(tasks[icolor].get(0)));

        return res;
    }

    private static int computeState(int time, int state, Pair pair) {

        int desired = pair.I;
        int togo = Math.abs(desired - state);

        if (time >= togo) return desired;
        else return state + time * (desired < state ? -1 : 1);
    }

    static class Pair
    {
        String S;

        int I;
    }


}