package net.choas.jam;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Solve {

	private static final String BOT_BLUE = "B";
	private static final String BOT_ORANGE = "O";
	String input;
	StringBuilder output;

	public Solve(String input, StringBuilder output) {
		this.input = input;
		this.output = output;
	}

	public static void main(String[] args) throws IOException {
		String input = Jam.read(args[0]).toString();
		StringBuilder output = new StringBuilder();
		Solve r = new Solve(input, output);
		r.solve();
		Jam.write(args[1], output.toString());
	}

	private void solve() {
		String[] lines = input.split("\n");
		int cases = s2i(lines[0]);
		int lpos = 0;

		for (int i = 0; i < cases; i++) {
			output.append("Case #" + (i + 1) + ": ");
			String line = lines[++lpos];
			String[] nrp = line.split(" ");
			int n = s2i(nrp[0]);
			// start
			List<Integer> buttonsOrange = new ArrayList<Integer>();
			List<Integer> buttonsBlue = new ArrayList<Integer>();
			List<String> buttonOrder = new ArrayList<String>();
			for (int j = 0; j < n; j++) {
				if (nrp[j * 2 + 1].equals(BOT_ORANGE)) {
					buttonOrder.add(BOT_ORANGE);
					buttonsOrange.add(new Integer(nrp[j * 2 + 2]));
				} else {
					buttonOrder.add(BOT_BLUE);
					buttonsBlue.add(new Integer(nrp[j * 2 + 2]));
				}
			}
			Bot botOrange = new Bot(buttonsOrange);
			Bot botBlue = new Bot(buttonsBlue);

			int count = 0;
			for (String nextBot : buttonOrder) {
				boolean pressedO = false;
				boolean pressedB = false;
				while (!pressedO && !pressedB) {
					count++;
					pressedO = botOrange.nextStep(BOT_ORANGE.equals(nextBot));
					pressedB = botBlue.nextStep(BOT_BLUE.equals(nextBot));
				}
			}
			output.append(count);
			output.append("\n");
		}
	}

	public class Bot {
		int buttonPos = 1;
		int nextPos = 1;
		List<Integer> buttonList;
		int listPos = 0;

		public Bot(List<Integer> buttonList) {
			this.buttonList = buttonList;
			this.nextPos();
		}

		public boolean nextStep(boolean pressAllowed) {
			boolean ret;
			if (buttonPos != nextPos) {
				if (buttonPos < nextPos) {
					buttonPos++;
				} else {
					buttonPos--;
				}
				ret = false;
			} else if (pressAllowed) {
				// press
				listPos++;
				this.nextPos();
				ret = true;
			} else {
				// stay
				ret = false;
			}
			return ret;
		}

		private void nextPos() {
			if (buttonList.size() > listPos) {
				nextPos = buttonList.get(listPos).intValue();
			}
		}

	}

	private static int s2i(String s) {
		return Integer.parseInt(s);
	}
}
