package net.choas.jam;

import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class Solve {

	String input;
	StringBuilder output;

	public Solve(String input, StringBuilder output) {
		this.input = input;
		this.output = output;
	}

	public static void main(String[] args) throws IOException {
		String input = Jam.read(args[0]).toString();
		StringBuilder output = new StringBuilder();
		Solve r = new Solve(input, output);
		r.solve();
		Jam.write(args[1], output.toString());
	}

	private void solve() {
		String[] lines = input.split("\n");
		int cases = s2i(lines[0]);
		int lpos = 0;

		for (int i = 0; i < cases; i++) {
			output.append("Case #" + (i + 1) + ": [");
			String line = lines[++lpos];
			// start
			List<Matcher> matcherList = new ArrayList<Matcher>();

			String[] cdnItems = line.split(" ");
			int cdnpos = 0;
			int c = s2i(cdnItems[cdnpos++]);
			for (int j = 0; j < c; j++) {
				Matcher m = new Matcher(cdnItems[cdnpos++]);
				matcherList.add(m);
			}
			int d = s2i(cdnItems[cdnpos++]);
			for (int j = 0; j < d; j++) {
				Matcher m = new Matcher(cdnItems[cdnpos++]);
				matcherList.add(m);
			}
			int n = s2i(cdnItems[cdnpos++]);
			String nStr = "";
			if (n > 0) {
				nStr = cdnItems[cdnpos++];
			}

			String nOut = "";
			int outPos = 0;
			for (int j = 0; j < nStr.length(); j++) {
				String ch = nStr.substring(j, j + 1);

				boolean cleared = false;
				for (Matcher m : matcherList) {
					int startPos = m.getStartPos();
					String res = m.match(ch, outPos);
					if (res != null) {
						cleared = true;
						if (m.isCombine()) {
							nOut = nOut.substring(0, startPos) + res;
						} else {
							// "then your element list will be cleared." -- http://code.google.com/codejam/contest/dashboard?c=975485#s=p1
							nOut = "";
						}
						outPos = nOut.length();
						for (Matcher mReset : matcherList) {
							if (m.isCombine()) {
								// reset only the matchers where with the same startPos
								mReset.reset(startPos);
							} else {
								mReset.reset();
							}
						}
						break;
					}
				}
				if (!cleared) {
					nOut += ch;
					outPos++;
				}
			}
			int chPos = 0;
			for (char ch : nOut.toCharArray()) {
				if (++chPos > 1) {
					output.append(", ");
				}
				output.append(ch);
			}
			output.append("]\n");
		}
	}

	public class Matcher {
		private String[] c1;
		private String replaceWith = "";
		private int posC1;
		private int posC2;
		private boolean isCombine;

		private int startPos;

		public Matcher(String cStr) {
			if (cStr.length() > 0) {
				c1 = new String[2];
				c1[0] = cStr.substring(0, 1);
				c1[1] = cStr.substring(1, 2);
				if (cStr.length() > 2) {
					replaceWith = cStr.substring(2, 3);
					isCombine = true;
				} else {
					replaceWith = "";
					isCombine = false;
				}
				this.reset();
			}
		}

		public String match(String ch, int sPos) {
			String ret = null;
			if (ch.equals(c1[posC1]) || ch.equals(c1[posC2])) {
				if (ch.equals(c1[posC1])) {
					posC1++;
				}
				if (ch.equals(c1[posC2])) {
					posC2--;
				}
				if (posC1 == 2 || posC2 == -1) {
					this.reset();
					ret = replaceWith;
				} else {
					startPos = sPos;
				}
			} else if (isCombine && ch.equals(c1[0])) {
				posC1 = 1;
				startPos = sPos;
			} else if (isCombine && ch.equals(c1[1])) {
				posC2 = 0;
				startPos = sPos;
			} else {
				// no match
				if (isCombine) {
					// reset positions for a combine
					this.reset();
				}
			}
			return ret;
		}

		public int getStartPos() {
			return this.startPos;
		}
		
		public boolean isCombine() {
			return this.isCombine;
		}

		public void reset() {
			posC1 = 0;
			posC2 = 1;
			startPos = -1;
		}
		
		public void reset(int sPos) {
			if (this.startPos == sPos) {
				this.reset();
			}
		}
	}

	private static int s2i(String s) {
		return Integer.parseInt(s);
	}
}
