package net.choas.jam;

import java.io.IOException;

public class Solve {
	
	String input;
	StringBuilder output;
	
	public Solve(String input, StringBuilder output) {
		this.input = input;
		this.output = output;
	}

	public static void main(String[] args) throws IOException {
		String input = Jam.read(args[0]).toString();
		StringBuilder output = new StringBuilder();
		Solve r = new Solve(input, output);
		r.solve();
		Jam.write(args[1], output.toString());
	}

	private void solve() {
		String[] lines = input.split("\n");
		int cases = s2i(lines[0]);
		int lpos = 0;

		for (int i = 0; i < cases; i++) {
			output.append("Case #" + (i + 1) + ": ");
			++lpos; // n
			// start
			String b = lines[++lpos];
			String[] bs = b.split(" ");
			int total = 0;
			int min = Integer.MAX_VALUE;
			int possible = 0;
			for (String bag : bs) {
				int bi = s2i(bag);
				if (bi < min) {
					min = bi;
				}
				total += bi;
				possible = possible ^ bi;
			}
			
			if (possible == 0) {
				// cheat Patrick and give him just the minimum
				output.append(total - min);
			} else {
				// earplugs, please
				output.append("NO");
			}
			output.append("\n");
		}
		
	}
	
	private static int s2i(String s) {
		return Integer.parseInt(s);
	}
}
