import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;

public class Solve {

	String input;
	StringBuilder output;

	public Solve(String input, StringBuilder output) {
		this.input = input;
		this.output = output;
	}

	public static StringBuilder read(String filename) throws IOException {
		StringBuilder strBuf = new StringBuilder();
		DataInputStream dis;
		BufferedReader br = new BufferedReader(new InputStreamReader(
				dis = new DataInputStream(new FileInputStream(filename))));
		String line;
		while ((line = br.readLine()) != null) {
			strBuf.append(line).append("\n");
		}
		dis.close();

		return strBuf;
	}

	public static void write(String filename, String t) throws IOException {
		FileWriter fstream = new FileWriter(filename);
		BufferedWriter out = new BufferedWriter(fstream);
		out.write(t);
		out.close();
	}

	public static void main(String[] args) throws IOException {
		String input = read(args[0]).toString();
		StringBuilder output = new StringBuilder();
		Solve r = new Solve(input, output);
		r.solve();
		write(args[1], output.toString());
	}

	private void solve() {
		String[] lines = input.split("\n");
		int cases = s2i(lines[0]);
		int lpos = 0;

		for (int i = 0; i < cases; i++) {
			output.append("Case #" + (i + 1) + ": ");
			// start
			int c = s2i(lines[++lpos]);
			String[] nsStr = lines[++lpos].split(" ");
			int hitsOnTheTable = 0;
			Integer[] ns = new Integer[c];
			Integer[] nsSorted = new Integer[c];

			int ni = 0;
			for (String nStr : nsStr) {
				int n = s2i(nStr);
				ns[ni] = n;
				nsSorted[ni] = n;
				ni++;
			}
			Arrays.sort(nsSorted);

			int j = 0;
			while (j < c) {
				if (nsSorted[j] != ns[j]) {
					int n = ns[j];
					for (int j2 = j + 1; j2 < c; j2++) {
						if (nsSorted[j2] == n && ns[j2] != nsSorted[j2]) {
							ns[j] = ns[j2];
							ns[j2] = n;
							break;
						}
					}
					hitsOnTheTable += 2;
				} else {
					j++;
				}
			}
			System.out.println("" + i);
			output.append(hitsOnTheTable);
			output.append(".000000\n");
		}

	}

	private static int s2i(String s) {
		return Integer.parseInt(s);
	}
}
