import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintStream;


public class Minewsweeper {
	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader in = new BufferedReader(new FileReader("I:/C-small-attempt0.in"));
		PrintStream out = 	new PrintStream("I:/MinesweeperOutput.txt");
		
		int cases = Integer.parseInt(in.readLine());
		
		for (int o = 0; o < cases; o++) {
			String[] Case = in.readLine().split(" ");
			int width = Integer.parseInt(Case[0]);
			int height = Integer.parseInt(Case[1]);
			int mines = Integer.parseInt(Case[2]);
			//System.out.println("A grid "+width+" wide by "+height+" high containing "+mines+" mines.");
			
			gridPoint[][] grid = new gridPoint[width][height];
			
			int cX = width-1;
			int cY = height-1;
			// Populate grids
			for (int x = 0; x < width; x++) {
				for (int y = 0; y < height; y++) {
					grid[x][y] = new gridPoint();
				}
			}
			int i = 0;
			int y = 0;
			//for (int y = 0; y < height; y++) {
			while (i < mines) {
				for (int x = 0; x < width; x++) {
					if (y-x > -1 && y-x < height && i < mines) {
						grid[x][y-x].mine = true;
						i++;
					}
				}
				y++;
			}
			
			
			// Find adjacents
			for (int x = 0; x < width; x++) {
				for (y = 0; y < height; y++) {
					int adjs = 0;
					int neigh= 0;
					for (int aX = -1; aX < 2; aX++) {
						for (int aY = -1; aY < 2; aY++) {
							if (x+aX < width && x+aX > -1 && y+aY < height && y+aY > -1 && grid[x+aX][y+aY].mine) {
								adjs++;
							}
							if (x+aX < width && x+aX > -1 && y+aY < height && y+aY > -1){
								neigh++;
							}
							
						}
					}
					grid[x][y].neighbours= neigh;
					grid[x][y].adjacents = adjs;
				}
			}
			
			for (int x = 0; x < width; x++) {
				for (y = 0; y < height; y++) {
					if (grid[x][y].adjacents == 0) {
						cX = x;
						cY = y;
					}
				}
			}
			
			System.out.println("Case #"+(o+1)+":");
			
			// If adjacent = neighbours, the grid si full. If 
			
			if (grid[cX][cY].adjacents == 0 || grid[cX][cY].adjacents == grid[cX][cY].neighbours) {
				// Display grids
				for (int x = 0; x < width; x++) {
					for (y = 0; y < height; y++) {
						if (grid[x][y].mine) {
							System.out.print('*');
						} else {
							if (x == cX && y == cY) {
								System.out.print('c');
							} else {
								System.out.print('.');
							}
						}
					}
					System.out.println();
				}
			} else {
				System.out.println("Impossible");
			}
			
		}
		in.close();
		out.close();
	}
}

class gridPoint {
	int adjacents = 0;
	int neighbours= 0;
	boolean mine  = false;
	boolean revealed = false;
}
