import java.util.*;


public class TrainTable {
	private static final int A = 0, B = 1;
	public class Time {
		private int h, m;
		public Time(int h, int m) {
			this.h = h;
			this.m = m;
		}
		public int compareTo(Time t) { 
			if(h == t.getHour()) {
				if(m == t.getMinute())
					return 0;
				return m < t.getMinute() ? -1 : 1;
			} 
			return h < t.getHour() ? -1 : 1;
		}
		public Time add(int m) {
			int h = this.h;
			m += this.m;
			if(m > 59) {
				h += m/60;
				m %= 60;
			}
			return new Time(h,m);
		}
		public int getHour() {
			return h;
		}
		public int getMinute() {
			return m;
		}
	}
	public class TrainEvent implements Comparable<TrainEvent> {
		private Time t;
		private boolean d, a;
		public TrainEvent(boolean depart,boolean stationA,Time t) {
			this.t = t;
			d = depart;
			a = stationA;
		}
		public boolean isDeparture() {
			return d;
		}
		public boolean stationA() {
			return a;
		}
		public Time getTime() {
			return t;
		}
		public int compareTo(TrainEvent e) {
			int c = getTime().compareTo(e.getTime());
			if(c == 0) {
				if(isDeparture())
					return 1;
				return -1;
			}
			return c;
		}
	}
	
	public Time parseTime(String s) {
		return new Time(Integer.parseInt(s.substring(0,2)), Integer.parseInt(s.substring(3,5)));
	}
	public TrainTable() {
		Scanner in = new Scanner(System.in);

		int n = in.nextInt();
		for(int k=1; k<=n; k++) {
			int trackA = 0, trackB = 0, avA = 0, avB = 0;
			int t = in.nextInt();
			int nA = in.nextInt(), nB = in.nextInt(), nE = 0;
			TrainEvent e[] = new TrainEvent[(nA+nB)*2];
			in.nextLine();
			for(int i=0; i<nA; i++) {
				String tmp = in.nextLine();
				String[] part = tmp.split("\\s");
				e[nE++] = new TrainEvent(true,true,parseTime(part[0]));
				e[nE++] = new TrainEvent(false,true,parseTime(part[1]).add(t));
			}
			for(int i=0; i<nB; i++) {
				String tmp = in.nextLine();
				String[] part = tmp.split("\\s");
				e[nE++] = new TrainEvent(true,false,parseTime(part[0]));
				e[nE++] = new TrainEvent(false,false,parseTime(part[1]).add(t));
			}
			
			Arrays.sort(e);
			
			for(int i=0; i<nE; i++) {
				if(e[i].isDeparture()) {
					if(e[i].stationA()) {
						if(avA == 0)
							trackA++;
						else
							avA--;
					} else {
						if(avB == 0)
							trackB++;
						else
							avB--;
					}
				} else {
					if(e[i].stationA()) // arrive at A
						avB++;
					else
						avA++;
				}
			}
			System.out.println("Case #"+k+": "+trackA+" "+trackB);
		}
	}
	public static void main(String[] args) {
		new TrainTable();
	}

}
