import java.io.BufferedReader;
import java.io.DataInputStream;
import java.io.FileInputStream;
import java.io.InputStreamReader;
import java.util.ArrayList;


public class BotTrust {

	static final String O = "O";
	static final String	B = "B";
	private static int numberOfTestCases = 0;
	String[] info;
	int time = 0;
	int numberOfButtons = 0;
	ArrayList<String> orderToMove = new ArrayList<String>();

	public int process(String input) {
		info = input.split(" ");
		numberOfButtons = Integer.valueOf(info[0]);
		
		Robot o = new Robot("O");
		Robot b = new Robot("B");
		
		for(int i = 1; i <= numberOfButtons * 2;) {
			String robot = info[i];
			int buttonNumber = Integer.valueOf(info[i+1]);
			if(robot.equals("O")) {
				o.buttonsToPress.add(buttonNumber);
			} else if(robot.equals("B")) {
				b.buttonsToPress.add(buttonNumber);
			}
			orderToMove.add(robot);
			i+=2;
		}
		
		while(numberOfButtons > 0) {
			String robotName = orderToMove.remove(0);
			Robot currentRobotToMove;
			Robot theOtherRobot;
			
			if(robotName.equals("O")) {
				currentRobotToMove = o;
				theOtherRobot = b;
			} else {
				currentRobotToMove = b;
				theOtherRobot = o;
			}
			
			int buttonToPress = currentRobotToMove.buttonsToPress.get(0);
			
			boolean currentRobotMoveForward = true;
			int spacesToMove = buttonToPress - currentRobotToMove.currentPosition;
			if(spacesToMove < 0 ) {
				currentRobotMoveForward = false;
			}

			for(int i = 0; i < Math.abs(spacesToMove); i++) {
				if(currentRobotMoveForward) {
					currentRobotToMove.moveForward();
				} else {
					currentRobotToMove.moveBackward();
				}
				
				//while currentRobot is moving, the other robot is also allowed to move if necessary
				if(theOtherRobot.buttonsToPress.size() > 0) {
					int theOtherRobotNextButton = theOtherRobot.buttonsToPress.get(0);
					if(theOtherRobotNextButton > theOtherRobot.currentPosition) {
						theOtherRobot.moveForward();
					} else if(theOtherRobotNextButton < theOtherRobot.currentPosition) {
						theOtherRobot.moveBackward();
					}
				}
				
				time++;
			}
			currentRobotToMove.pressButton();
			if(theOtherRobot.buttonsToPress.size() > 0) {
				int theOtherRobotNextButton = theOtherRobot.buttonsToPress.get(0);
				if(theOtherRobotNextButton > theOtherRobot.currentPosition) {
					theOtherRobot.moveForward();
				} else if(theOtherRobotNextButton < theOtherRobot.currentPosition) {
					theOtherRobot.moveBackward();
				}
			}
		}
		
		return time;
	}
	
	private class Robot {
		public int currentPosition = 1;
		public String name;
		public ArrayList<Integer> buttonsToPress = new ArrayList<Integer>();
		
		public Robot(String name) {
			this.name = name;
		}
		
		public void moveForward() {
			currentPosition++;
		}
		
		public void moveBackward() {
			currentPosition--;
		}
		
		public void pressButton() {
			time++;
			buttonsToPress.remove(0);
			numberOfButtons--;
			
		}
	}
	
	public static void main(String[] args) {
		String fileLocation = args[0];
		try {
			FileInputStream fstream = new FileInputStream(fileLocation);
			DataInputStream in = new DataInputStream(fstream);
			BufferedReader br = new BufferedReader(new InputStreamReader(in));
			numberOfTestCases = Integer.valueOf(br.readLine());
			for(int i = 1; i <= numberOfTestCases; i++) {
				String input = br.readLine();
				BotTrust x = new BotTrust();
				System.out.println("Case #" + i + ": " + x.process(input));
			}
		} catch (Exception e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
	}
}
