import java.io.*;
import java.text.NumberFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collection;
import java.util.Collections;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Random;
import java.util.Set;
import java.util.Vector;

import org.jgrapht.*;
import org.jgrapht.experimental.dag.DirectedAcyclicGraph;
import org.jgrapht.graph.*;
import org.jgrapht.alg.*;

public class CodeJam
{
	static String baseDir = "C:\\Users\\Chris\\Desktop\\";
	static String problem = "B-small-attempt1.in";
	static NumberFormat codeJamAnswer = NumberFormat.getNumberInstance();
	
	public String solveCase( int L, long t, int N, int C, long[] a )
	{
		long[][] T = new long [L+1][N+1];
		for( int i = 0; i <= L; i++ )
			T[i][0] = 0;
		for( int j = 1; j <= N; j++ )
			T[0][j] = T[0][j-1] + ( 2 * a[(j-1)%C] );
		
		for( int j = 0; j <= N; j++ )
			for( int i = 1; i <= L; i++ )
			{
				if( i <= j )
				{
					long min = T[0][N] + t;
					for( int k = 0; k <= j; k++ )
					{
						long time = T[i-1][k] + bestOne( k, j, a, T[i-1][k], C, t );
						if( time < min )
							min = time;
					}
					T[i][j] = min;
				}
				else
					T[i][j] = T[j][j];
			}
		
		String caseAnswer = "" + T[L][N];
		return caseAnswer;
	}
	
	public long bestOne( int start, int end, long[] a, long t2, int C, long t )
	{
		long totalTime = t2, maxSave = 0, dTotal = 0;
		for( int s = start; s < end; s++ )
		{
			long timeLeft = t - totalTime;
			timeLeft = Math.max( timeLeft, 0 );
			long d = a[s%C];
			long save = d - ( timeLeft / 2 );
			if( save > maxSave )
				maxSave = save;
			dTotal += d;
			totalTime += ( d * 2 );
		}
		maxSave = Math.max( 0, maxSave );
		return dTotal * 2 - maxSave;
	}
	
	public void solve()
	{
        BufferedReader 	reader = null;
        PrintWriter 	writer = null;
        try
        {
        	writer = new PrintWriter( new FileWriter( baseDir + "Output.txt" ) );
            reader = new BufferedReader( new FileReader( new File( baseDir + problem ) ) );
            codeJamAnswer.setGroupingUsed( false );
        	codeJamAnswer.setMinimumFractionDigits( 1 );
            long caseNumber = 1;
            String inputLine = reader.readLine();
            while( ( inputLine = reader.readLine()) != null )
            {
            	String[] input = inputLine.split( " " );
            	int L = Integer.parseInt( input[ 0 ] );
            	long t = Long.parseLong( input[ 1 ] );
            	int N = Integer.parseInt( input[ 2 ] );
            	int C = Integer.parseInt( input[ 3 ] );
            	long[] a = new long [ C ];
            	for( int i = 0; i < C; i++ )
            		a[ i ] = Integer.parseInt( input[ i + 4 ] );

            	// Here we go...
            	String caseAnswer = solveCase( L, t, N, C, a );

            	String output = "Case #" + caseNumber++ + ": " + caseAnswer;
                writer.println( output );
                System.out.println( output );
            }
            reader.close();
            writer.close();
        }
        catch( FileNotFoundException e ){ e.printStackTrace(); }
        catch( IOException e ) 			{ e.printStackTrace(); }
	}
	
	public static void main( String[] args )
	{
		CodeJam problem = new CodeJam();
		problem.solve();
	}
}