import java.io.*;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

import org.jgrapht.*;
import org.jgrapht.experimental.dag.DirectedAcyclicGraph;
import org.jgrapht.graph.*;
import org.jgrapht.alg.*;

public class CodeJam
{
	static String baseDir = "C:\\Users\\Chris\\Desktop\\";
	static String problem = "A-small-attempt0.in";
	
	public void solve()
	{
        BufferedReader 	reader = null;
        PrintWriter 	writer = null;

        try
        {
        	writer = new PrintWriter( new FileWriter( baseDir + "Output.txt" ) );
            reader = new BufferedReader( new FileReader( new File( baseDir + problem ) ) );
            int caseNumber = 1;
            String inputLine = reader.readLine();
            while( ( inputLine = reader.readLine()) != null )
            {
            	String caseAnswer = "";
            	int N = Integer.parseInt( inputLine );
            	
            	DefaultDirectedGraph< Integer, DefaultEdge > G 
            				= new DefaultDirectedGraph< Integer, DefaultEdge >( DefaultEdge.class );

            	for( int v = 0; v < N; v++ )
            		G.addVertex( v );
           
            	for( int homeTeam = 0; homeTeam < N; homeTeam++ )
            	{
            		inputLine = reader.readLine();
            		for( int awayTeam = 0; awayTeam < N; awayTeam++ )
            			if( inputLine.charAt( awayTeam ) == '1' )
            				G.addEdge( homeTeam, awayTeam );
            	}
            	
        		double[] P = new double [N];
        		double[] W = new double [N];
        		double[] WP = new double [N];
        		double[] OWP = new double [N];
        		double[] OOWP = new double [N];
        	
            	for( int team = 0; team < N; team++ )
            	{
            		int a = G.inDegreeOf( team );
            		int b = G.outDegreeOf( team );
            		P[ team ] = a + b;
            		W[ team ] = G.outDegreeOf( team );
            		WP[ team ] = W[ team ] / P[team];
            	}
            	
               	for( int team = 0; team < N; team++ )
            	{
               		Set< DefaultEdge > beat = G.outgoingEdgesOf( team );
               		Set< DefaultEdge > lost = G.incomingEdgesOf( team );
               		Iterator< DefaultEdge > b = beat.iterator();
               		Iterator< DefaultEdge > l = lost.iterator();
               		double totalWP = 0.0;
               		while( b.hasNext() )
               		{
               			Integer t = G.getEdgeTarget( b.next() );
               			double nWP = W[ t ] / ( P[ t ] - 1 );
               			totalWP += nWP;
               		}
               		while( l.hasNext() )
               		{
               			Integer t = G.getEdgeSource( l.next() );
               			double nWP = ( W[ t ] - 1 ) / ( P[ t ] - 1 );
               			totalWP += nWP;
               		}
               		OWP[ team ] = totalWP / ( beat.size() + lost.size() );
            	}
               	
               	for( int team = 0; team < N; team++ )
            	{
               		Set< DefaultEdge > beat = G.outgoingEdgesOf( team );
               		Set< DefaultEdge > lost = G.incomingEdgesOf( team );
               		Iterator< DefaultEdge > b = beat.iterator();
               		Iterator< DefaultEdge > l = lost.iterator();
               		double totalOOWP = 0.0;
               		while( b.hasNext() )
               		{
               			Integer t = G.getEdgeTarget( b.next() );
               			totalOOWP += OWP[ t ];
               		}
               		while( l.hasNext() )
               		{
               			Integer t = G.getEdgeSource( l.next() );
               			totalOOWP += OWP[ t ];
               		}
               		OOWP[ team ] = totalOOWP / ( beat.size() + lost.size() );
            	}
            	
            	String output = "Case #" + caseNumber++ + ":\n";
            	for( int t = 0; t < N; t++ )
            	{
            		double RPI = 0.25 * WP[ t ] + 0.5 * OWP[t] + 0.25 *OOWP[t];
            		caseAnswer += ( RPI + "\n" );
            	}
                writer.print( output + caseAnswer );
                System.out.print( output + caseAnswer );
            }
            reader.close();
            writer.close();
        }
        catch( FileNotFoundException e ){ e.printStackTrace(); }
        catch( IOException e ) 			{ e.printStackTrace(); }
	}
	
	public static void main( String[] args )
	{
		CodeJam problem = new CodeJam();
		problem.solve();
	}
}