package com.codejam.qualification.a;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.List;
import java.util.Set;

/**
 * @author Christiaan Verpooten
 * @since 12/04/14
 */
public class Main {

    private void execute(String inputPath, String outputPath) throws IOException {
        BufferedReader reader = new BufferedReader(new FileReader(inputPath));
        BufferedWriter writer = new BufferedWriter(new FileWriter(outputPath));
        TrickComparator comparator = new TrickComparator();
        try {
            int numberOfCases = Integer.valueOf(reader.readLine());
            for (int i = 0; i < numberOfCases; i++) {
                int row1 = Integer.valueOf(reader.readLine()) - 1;
                Trick trick1 = readTrick(reader);
                int row2 = Integer.valueOf(reader.readLine()) - 1;
                Trick trick2 = readTrick(reader);
                Set<Integer> sameCards = comparator.compareTricks(trick1, trick2, row1, row2);
                writer.write(String.format("Case #%d", i + 1) + ": ");
                switch (sameCards.size()) {
                    case 0:
                        writer.write("Volunteer cheated!");
                        break;
                    case 1:
                        writer.write(String.valueOf(sameCards.iterator().next()));
                        break;
                    default:
                        writer.write("Bad magician!");
                        break;
                }
                writer.newLine();
            }
        } finally {
            reader.close();
            writer.close();
        }
    }

    private Trick readTrick(BufferedReader reader) throws IOException {
        Trick trick = new Trick();
        for (int row = 0; row < 4; row++) {
            String[] cardValueStrings = reader.readLine().split(" ");
            for (String cardValueString : cardValueStrings) {
                trick.addCardValue(row, Integer.valueOf(cardValueString));
            }
        }
        return trick;
    }

    public static void main(String[] args) throws IOException {
        Main main = new Main();
        main.execute("C:\\Temp\\qualification\\a-small.in", "C:\\Temp\\qualification\\a-small.out");
    }
}
