package j2011r1a;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Set;

public class C {
	public static String inputDirectory="src/j2011r1a/";
	public static String inputFile="C.in";
	public static String outputFile="C.out";
	public static PrintWriter output;
	public static Map<String, Game> gameMap;
	public static Set<String> usedSet;
	public static char HAND = '1';
	public static char USED = '2';
	public static Card[] cards;
	public static int numCards;
	public static long bestScore = 0;
	public static void main(String[] args) throws FileNotFoundException{
		Scanner s=new Scanner(new File(inputDirectory + inputFile));
		output=new PrintWriter(new File(inputDirectory + outputFile));
		int cases = s.nextInt();
		s.nextLine();
		for(int Case=1;Case<=cases;Case++){
			gameMap = new HashMap<String,Game>();
			usedSet = new HashSet<String>();
			cards = new Card[100];
			int handSize = s.nextInt();
			int totalTurnsPossible = 1;
			s.nextLine();
			String firstState="";
			//System.out.println("HAND:");
			for(int i=0;i<handSize;i++){
				cards[i] = new Card(s.nextLine());
				totalTurnsPossible+=cards[i].turn;
				firstState += HAND;
				//System.out.println(cards[i]);
			}
			int deckSize = s.nextInt();
			s.nextLine();
			//System.out.println("DECK:");
			for(int i=0;i<deckSize;i++){
				cards[handSize + i] = new Card(s.nextLine());
				totalTurnsPossible+=cards[handSize + i].turn;
				//System.out.println(cards[handSize + i]);
			}
			numCards = handSize + deckSize;
			bestScore = 0;
			getBestScore(new Game(firstState));
			//System.out.println("turns "+totalTurnsPossible);
			//System.out.println(bestScore);
			out("Case #"+Case+": "+bestScore);
		}
		output.flush();
	}
	
	public static void getBestScore(Game game){
		if(null==game)return;
		String state = game.state;
		if(usedSet.contains(state))return;
		Game nextGame;
		while(true){
			nextGame = game.playTurnCard();
			if(null != nextGame){
				game = nextGame;
			}else{
				break;
			}
		}
		bestScore = Math.max(game.score, bestScore);
		if(game.turns > 0){
			getBestScore(game.playBestOneDraw());
			getBestScore(game.playBestTwoDraw());
			getBestScore(game.playBestScore());
		}
		usedSet.add(state);
	}
	
	public static void out(String s){
		output.println(s);
		//System.out.println(s);
	}
	public static class Game {
		public long score;
		public long turns;
		public String state;
		
		public Game(String state){
			this.state = state;
			turns = 1;
			score = 0;
			int used = 0;
			for(int i=0;i<state.length();i++){
				if(state.charAt(i) == USED){
					turns--;
					turns += cards[i].turn;
					score += cards[i].score;
					used ++;
				}
			}
			//System.out.println(state+" has score "+score + " left "+turns+ " used " + used);
			gameMap.put(state, this);
		}
		public Game playBestOneDraw(){
			int bestIndex = -1;
			for(int i=0;i<state.length();i++){
				if(state.charAt(i) == HAND && cards[i].draw == 1){
					if(bestIndex < 0 || cards[i].score > cards[bestIndex].score){
						bestIndex = i;
					}
				}
			}
			if(bestIndex<0){
				return null;
			}
			return playCard(bestIndex);
		}
		public Game playBestTwoDraw(){
			int bestIndex = -1;
			for(int i=0;i<state.length();i++){
				if(state.charAt(i) == HAND && cards[i].draw == 2){
					if(bestIndex < 0 || cards[i].score > cards[bestIndex].score){
						bestIndex = i;
					}
				}
			}
			if(bestIndex<0){
				return null;
			}
			return playCard(bestIndex);
		}
		public Game playBestScore(){
			int bestIndex = -1;
			for(int i=0;i<state.length();i++){
				if(state.charAt(i) == HAND){
					if(bestIndex < 0 || cards[i].score > cards[bestIndex].score){
						bestIndex = i;
					}
				}
			}
			if(bestIndex<0){
				return null;
			}
			return playCard(bestIndex);
		}
		
		public Game playTurnCard(){
			for(int i=0;i<state.length();i++){
				if(state.charAt(i) == HAND && cards[i].turn > 0){
					return playCard(i);
				}
			}
			return null;
		}
		
		public Game playCard(int index){
			String newState = index > 0 ? state.substring(0, index) + USED : "" + USED;
			if(index<state.length() - 1){
				newState +=state.substring(index+1, state.length());
			}
			for(int i=0;i<cards[index].draw && newState.length() < numCards;i++){
				newState += HAND;
			}
			if(gameMap.containsKey(newState)){
				//System.out.println(newState+" already been seen woth score: "+getBestScore(gameMap.get(newState)));
				return gameMap.get(newState);
			}
			return new Game(newState);
		}

	}
	public static class Card {
		public int draw;
		public int score;
		public int turn;
		public Card(String source){
			Scanner s = new Scanner(source);
			draw = s.nextInt();
			score = s.nextInt();
			turn = s.nextInt();
		}
		public String toString(){
			return draw + " "+ score+" "+ turn;
		}
	}
}
