package j2010r1a;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintWriter;
import java.util.Scanner;

public class A {
	public static String inputDirectory="src/j2010r1a/";
	public static String inputFile="A.in";
	public static String outputFile="A.out";
	public static PrintWriter output;
	public static void main(String[] args) throws FileNotFoundException{
		Scanner s=new Scanner(new File(inputDirectory + inputFile));
		output=new PrintWriter(new File(inputDirectory + outputFile));
		int cases = s.nextInt();
		s.nextLine();
		for(int Case=1;Case<=cases;Case++){
			int N = s.nextInt();
			int K = s.nextInt();
			char[][] board = new char[N][N];
			s.nextLine();
			for(int i=0;i<N;i++){
				String line = s.nextLine();
				for(int j=0;j<N;j++){
					board[i][j] = line.charAt(j);
				}
			}
			//System.out.println(boardString(board));
			board = rotateBoard(board);
			//System.out.println(boardString(board));
			out("Case #"+Case+": "+whoWins(board,K));
		}
		output.flush();
	}
	
	public static String whoWins(char[][] board, int K){
		int N = board.length;
		boolean blueWon = false;
		boolean redWon = false;
		for(int i=0;i<N && !(blueWon && redWon);i++){
			for(int j=0;j<N && !(blueWon && redWon);j++){
				char color = board[i][j];
				if(color != 'R' && color != 'B')continue;
				//System.out.println("found "+color);
				boolean won=false;
				for(int dx=-1;dx<2 && !won;dx++){
					for(int dy=-1;dy<2 && !won;dy++){
						if(dx==0 & dy==0)continue;
						for(int d=1;d<K;d++){
							if(getChar(board, j+d*dx,i+d*dy) != color){
								//System.out.println("hit "+getChar(board, j+d*dx,i+d*dy));
								break;
							}
							if(d==K-1)won=true;
						}
					}
				}
				if(won){
					if(color == 'B')blueWon=true;
					if(color == 'R')redWon=true;
				}
			}
		}
		if(blueWon && redWon)return "Both";
		if(redWon) return "Red";
		if(blueWon) return "Blue";
		return "Neither";
	}
	
	public static char getChar(char[][] board, int x, int y){
		if(x<0 || y<0 || x>=board.length || y>=board.length)return ' ';
		return board[y][x];
	}
	
	public static char[][] rotateBoard(char[][] board){
		int N = board.length;
		char[][] newBoard = new char[N][N];
		for(int i=0;i<N;i++){
			int target = 0;
			for(int j=N-1;j>=0;j--){
				if(board[i][j] != '.'){
					newBoard[target][i] = board[i][j];
					target++;
				}
			}
		}
		return newBoard;
	}
	
	public static void out(String s){
		output.println(s);
		//System.out.println(s);
	}
	
	public static String boardString(char[][] board){
		int N = board.length;
		String s = "";
		for(int i=0;i<N;i++){
			for(int j=0;j<N;j++){
				s+=board[i][j];
			}
			s+="\n";
		}
		return s;
	}
}
