import java.io.File;
import java.io.FileInputStream;
import java.util.Scanner;

public class Main {

	public static void main(String[] args) throws Exception {
		FileInputStream in = new FileInputStream(new File("src/dataset"));
		Scanner sc = new Scanner(in);

		int cases = sc.nextInt();
		sc.nextLine();
		for (int i = 0; i < cases; i++) {
			System.out.println("Case #" + (i + 1) + ":");
			sc.nextInt();
			int j = sc.nextInt();
			char[] jamcoin = "1000000000000001".toCharArray();
			int found = 0;
			long[] results = new long[9];

			
			while (found < j) {
				for (int b = 2; b <= 10; b++) {
					long isPrime = isPrime(getNumber(jamcoin, b));
					if (isPrime != 0) {
						results[b-2] = isPrime(getNumber(jamcoin, b));
						if (b == 10) {
							found++;
							System.out.print(String.valueOf(jamcoin) + " ");
							for (long x : results)
								System.out.print(" " + x);
							System.out.println();
						}
					} else
						break;
				}	
				jamcoin = addOne(jamcoin);
			}			
		}
		
		if (in != null)
			in.close();
		if (sc != null)
			sc.close();
	}
	
	public static long isPrime(long num){
	    if (num > 2 && num%2 == 0 ) {
	        return 2;
	    }
	    int top = (int)Math.sqrt(num) + 1;
	    for(int i = 3; i < top; i+=2){
	        if(num % i == 0){
	            return i;
	        }
	    }
	    return 0; 
	}
	
	public static long getNumber(char[] number, int base) {
		long n = 0;
		
		for (int i = 0; i < 16; i++)
			n += (number[i]-'0') * Math.pow(base, 15-i);
			
		return n;
	}
	
	public static char[] addOne(char[] number) {
		char[] x = addBinary(String.valueOf(number), "0000000000000001").toCharArray();
		if (x[x.length-1]=='0')
			x = addBinary(String.valueOf(x), "0000000000000001").toCharArray();
		
		return x;
	}
	
    public static String addBinary(String a, String b) {
        // Start typing your Java solution below
        // DO NOT write main() function
        int la = a.length();
        int lb = b.length();
        
        int max = Math.max(la, lb);
        
        StringBuilder sum = new StringBuilder("");
        int carry = 0;
        
        for(int i = 0; i < max; i++){
            int m = getBit(a, la - i - 1);
            int n = getBit(b, lb - i - 1);
            int add = m + n + carry;
            sum.append(add % 2);
            carry = add / 2;
        }
        
        if(carry == 1)
            sum.append("1");
        
        return sum.reverse().toString();
        
    }
    
    public static int getBit(String s, int index){
        if(index < 0 || index >= s.length())
            return 0;
        
        if(s.charAt(index) == '0')
            return 0;
        else
            return 1;
        
    }
    
    public static boolean check(String s) {
    	for (int i = 2; i < 11; i++)
    		if (getNumber(s.toCharArray(), i) % 2 != 0)
    			return false;
    	
    	return true;
    }
}
