
import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.math.BigInteger;
import java.util.Scanner;

class CountingSheep {
	int	t;
	BigInteger n;
	BigInteger xn;
	BigInteger zero;
	BigInteger one;
	BigInteger counter;
	boolean[] digitFlags;
	
	public CountingSheep() {
		digitFlags = new boolean[10];
		zero = new BigInteger("0");
		one = new BigInteger("1");
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		
		
		t = in.nextInt();
		in.nextLine();
		for (int i = 0; i < t; ++i) {
			clearDigitFlags();
			counter = zero;
			n = new BigInteger(in.nextLine());
			
			if (n.compareTo(zero) == 0) {
				System.out.println("Case #"+(i+1)+": INSOMNIA");
			} else {
				while (true) {
					counter = counter.add(one);
					xn = n.multiply(counter);
					setDigitFlags(xn);
					if (areAllDigitFlagsSet()) {
						System.out.println("Case #"+(i+1)+": "+xn);
						break;
					}
				}
			}
		}
	}
	
	public void clearDigitFlags() {
		for (int i = 0; i < 10; ++i) {
			digitFlags[i] = false;
		}
	}
	
	public boolean areAllDigitFlagsSet() {
		for (int i = 0; i < 10; ++ i) {
			if (digitFlags[i] == false) return false;
		}
		return true;
	}
	
	public void setDigitFlags(BigInteger newNumber) {
		String numberStr = newNumber.toString();
		int digit;
		int len = numberStr.length();
		for (int i = 0; i < len; ++i) {
			digit = Character.getNumericValue(numberStr.charAt(i));
			digitFlags[digit] = true;
		}
	}
	
	public static void main (String[] args) {
		new CountingSheep();
	}
}