import java.io.*;
import java.util.*;
import java.math.BigInteger;

public class BathroomStalls {
	int t;
	ArrayList<BigInteger> gapList;
	
	public BathroomStalls() {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		t = in.nextInt();
		in.nextLine(); // for '\n'
		
		for(int i = 0; i < t; ++i) {
			String line = in.nextLine();
			String[] splitted = line.split("\\s+");
			BigInteger n = new BigInteger(splitted[0]);
			BigInteger k = new BigInteger(splitted[1]);
			BigInteger km = k.subtract(new BigInteger("1"));
			
			gapList = new ArrayList();
			gapList.add(n);
			
			BigInteger zero = new BigInteger("0");
			BigInteger one = new BigInteger("1");
			BigInteger two = new BigInteger("2");
			for (BigInteger j = new BigInteger("1"); j.compareTo(km) <= 0; j = j.add(one)) {
				BigInteger gap = extractMaxGap();
				BigInteger gap1 = gap.divide(two);
				BigInteger gap2 = gap.subtract(gap1).subtract(one);
				if (gap1.compareTo(zero) > 0) gapList.add(gap1);
				if (gap2.compareTo(zero) > 0) gapList.add(gap2);
			}
			BigInteger gap = extractMaxGap();
			BigInteger gap1 = gap.divide(two);
			BigInteger gap2 = gap.subtract(gap1).subtract(one);
			System.out.print("Case #"+(i+1)+": ");
			if (gap1.compareTo(gap2) < 0)
				System.out.println(gap2+" "+gap1);
			else 
				System.out.println(gap1+" "+gap2);
			gapList.clear();
		}
		
//		System.out.println("t = "+t);
	}
	
	BigInteger extractMaxGap() {
		BigInteger maxN = gapList.get(0);
		int idx = 0;
		int len = gapList.size();
		if (len == 1) {
			gapList.remove(idx);
			return maxN;
		}
		
		for (int i = 0; i < len-1; ++i) {
			BigInteger i1 = gapList.get(i);
			BigInteger i2 = gapList.get(i+1);
			if (i1.compareTo(i2) < 0) {
				idx = i+1;
				maxN = i2;
			}
		}
		gapList.remove(idx);
		return maxN;
	}
	
	
	public static void main (String[] args) {
		new BathroomStalls();
	}
}
