import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.util.Scanner;

class RevengeOfPancakes {
	String	stack;
	int		t;
	int		result;
	
	public RevengeOfPancakes() {
		Scanner in = new Scanner(new BufferedReader(new InputStreamReader(System.in)));
		t = in.nextInt();
		in.nextLine(); // for '\n'
		for (int i = 0; i < t; ++i) {
			stack = "";
			result = 0;
			
			stack = in.nextLine();
			if (stack.length() <= 0) {
				result = 0;
			} else {
				int lastIdx = getLastFirstMinus(stack.length()-1);		
				maneuver('+', lastIdx);
			}

			System.out.println("Case #"+(i+1)+": "+result);
		}
	}
	
	public void maneuver(char mode, int lastIdx) {
		if (lastIdx < 0) return;
		int localLastIdx = lastIdx;
		while (mode == '+') {
			if (stack.charAt(0) == '-' && stack.charAt(localLastIdx) == '-') {
				flip(localLastIdx);
				localLastIdx = getLastFirstMinus(localLastIdx);
				if (localLastIdx < 0) return;
			}

			if (stack.charAt(0) == '+' && stack.charAt(localLastIdx) == '-') {
				int plusIdx = getLastFirstPlus(localLastIdx);
				maneuver('-', plusIdx);
				flip(localLastIdx);
				localLastIdx = getLastFirstMinus(localLastIdx);
				if (localLastIdx < 0) return;
			}
		}
		while (mode == '-') {
			if (stack.charAt(0) == '+' && stack.charAt(localLastIdx) == '+') {
				flip(localLastIdx);
				localLastIdx = getLastFirstPlus(localLastIdx);
				if (localLastIdx < 0) return;
			}
			
			if (stack.charAt(0) == '-' && stack.charAt(localLastIdx) == '+') {
				int minusIdx = getLastFirstMinus(localLastIdx);
				maneuver('+', minusIdx);
				flip(localLastIdx);
				localLastIdx = getLastFirstPlus(localLastIdx);
				if (localLastIdx < 0) return;
			}
		}
	}
	
	public void flip(int lastIdx) {
		String queue = stack.substring(0, lastIdx+1);
		
		StringBuilder newStack = new StringBuilder(stack);
		for (int j = 0, i = lastIdx; i >= 0; ++j, --i) {
			if (queue.charAt(j) == '+') newStack.setCharAt(i, '-');
			else newStack.setCharAt(i, '+');
		}
		stack = newStack.toString();
		++result;
	}
	
	// Normal Case.........
	public int getLastFirstMinus(int endIdx) {
		int lastUnsolvedIdx = -1;
		for (lastUnsolvedIdx = endIdx; lastUnsolvedIdx >= 0; --lastUnsolvedIdx) {
			if (stack.charAt(lastUnsolvedIdx) == '-') return lastUnsolvedIdx;
		}
		return lastUnsolvedIdx;
	}
	
	public int getLastFirstPlus(int endIdx) {
		int lastFirstPlus = -1;
		for (lastFirstPlus = endIdx; lastFirstPlus >= 0; --lastFirstPlus) {
			if (stack.charAt(lastFirstPlus) == '+') return lastFirstPlus;
		}
		return lastFirstPlus;
	}

	public static void main(String[] args) {
		new RevengeOfPancakes();
	}
}