import java.io.*;
import java.util.*;

class B
{
    static public int[][] timeTableAB, timeTableBA;

    public static void main(String[] args)
    {
        try {
        int numCases, numAB, numBA;
        int numTrainsAB, numTrainsBA;
        int casesCount, tripCount, tripCount2;
        int turnaroundTime;

        StringTokenizer tokenizer, tokenizer2;
        String curLine, curTime, curHr, curMin;

        BufferedReader bufIn = new BufferedReader(new FileReader(args[0]));
        numCases = Integer.valueOf(bufIn.readLine()).intValue();

        for(casesCount = 0; casesCount < numCases; casesCount++)
        {
            turnaroundTime = Integer.valueOf(bufIn.readLine()).intValue();
            tokenizer = new StringTokenizer(bufIn.readLine());
            numAB = Integer.valueOf(tokenizer.nextToken()).intValue();
            numBA = Integer.valueOf(tokenizer.nextToken()).intValue();

            // store timetables from A to B
            timeTableAB = new int[numAB][3];
            
            for(tripCount = 0; tripCount < numAB; tripCount++)
            {
                curLine = bufIn.readLine();
                tokenizer = new StringTokenizer(curLine);
                // parse departure time
                curTime = tokenizer.nextToken();
                tokenizer2 = new StringTokenizer(curTime, ":");
                curHr = tokenizer2.nextToken();
                curMin = tokenizer2.nextToken();
                // store departure time
                timeTableAB[tripCount][0] = Integer.valueOf(curHr).intValue() * 60 + Integer.valueOf(curMin).intValue();
                // parse arrival time
                curTime = tokenizer.nextToken();
                tokenizer2 = new StringTokenizer(curTime, ":");
                curHr = tokenizer2.nextToken();
                curMin = tokenizer2.nextToken();
                // store arrival time
                timeTableAB[tripCount][1] = Integer.valueOf(curHr).intValue() * 60 + Integer.valueOf(curMin).intValue();

                // assume train available for followup trip
                timeTableAB[tripCount][2] = 1;
            }

            // store timetables from B to A
            timeTableBA = new int[numBA][4];

            for(tripCount = 0; tripCount < numBA; tripCount++)
            {
                curLine = bufIn.readLine();
                tokenizer = new StringTokenizer(curLine);
                // parse departure time
                curTime = tokenizer.nextToken();
                tokenizer2 = new StringTokenizer(curTime, ":");
                curHr = tokenizer2.nextToken();
                curMin = tokenizer2.nextToken();
                // store departure time
                timeTableBA[tripCount][0] = Integer.valueOf(curHr).intValue() * 60 + Integer.valueOf(curMin).intValue();
                // parse arrival time
                curTime = tokenizer.nextToken();
                tokenizer2 = new StringTokenizer(curTime, ":");
                curHr = tokenizer2.nextToken();
                curMin = tokenizer2.nextToken();
                // store arrival time
                timeTableBA[tripCount][1] = Integer.valueOf(curHr).intValue() * 60 + Integer.valueOf(curMin).intValue();

                // assume train available for followup trip
                timeTableBA[tripCount][2] = 1;
            }

            // start out assuming 1 train for each trip A to B
            numTrainsAB = numAB;

            // sort both lists appropriately
            B.sortArrayByColumn(timeTableAB, 0);
            B.sortArrayByColumn(timeTableBA, 1);

            // search for starter train from B to A list
            for(tripCount = 0; tripCount < numAB; tripCount++)
            {
                for(tripCount2 = 0; tripCount2 < numBA; tripCount2++)
                {
                    // if train from B to A is available for followup trip
                    // and will be ready for departure before departure time for A to B trip
                    if(timeTableBA[tripCount2][2] == 1 && timeTableBA[tripCount2][1] + turnaroundTime <= timeTableAB[tripCount][0])
                    {
                        // set B to A train as not available for another followup trip
                        timeTableBA[tripCount2][2] = 0;
                        // decrement trains needed count from A to B
                        numTrainsAB--;
                        // stop searching for starter train from B to A list
                        break;
                    }
                }
            }


            // start out assuming 1 train for each trip from B to A
            numTrainsBA = numBA;

            // sort both lists appropriately
            B.sortArrayByColumn(timeTableBA, 0);
            B.sortArrayByColumn(timeTableAB, 1);

            // search for starter train from A to B list
            for(tripCount = 0; tripCount < numBA; tripCount++)
            {
                for(tripCount2 = 0; tripCount2 < numAB; tripCount2++)
                {
                    // if train from A to B is available for followup trip
                    // and will be ready for departure before departure time for B to A trip
                    if(timeTableAB[tripCount2][2] == 1 && timeTableAB[tripCount2][1] + turnaroundTime <= timeTableBA[tripCount][0])
                    {
                        // set A to B train as not available for another followup trip
                        timeTableAB[tripCount2][2] = 0;
                        // decrement trains needed count from B to A
                        numTrainsBA--;
                        // stop searching for starter train from A to B list
                        break;
                    }
                }
            }

            System.out.printf("Case #%d: %d %d\n", casesCount + 1, numTrainsAB, numTrainsBA);
        }
        } catch(Exception e) { System.out.println(e); }
    }

    public static void sortArrayByColumn(int[][] array, int column)
    {
        int i, j;
        int[] temp;

        for(i = 0; i < array.length - 1; i++)
        {
            for(j = 0; j < array.length - i - 1; j++)
            {
                if(array[j][column] > array[j + 1][column])
                {
                    temp = array[j];
                    array[j] = array[j + 1];
                    array[j + 1] = temp;
                }
            }
        }
    }
}
