package gcj.gcj2017.qual;

import gcj.Problems;

import java.util.Arrays;
import java.util.List;

/**
 * Author: Ritwik
 * Date: 4/8/2017
 */
public class ProbD extends Problems {
    public ProbD(String input, String output) {
        super.exec(input, output);
    }

    @Override
    protected int getTCLines(String line) {
        return 1 + Integer.valueOf(line.split(" ")[1]);
    }

    @Override
    protected String processTestCase(List<String> lines) {
        String[] input = lines.get(0).split(" ");
        final Integer n = Integer.parseInt(input[0]);
        final Integer m = Integer.parseInt(input[1]);

        StringBuilder res;

        char[][] origstage = new char[n][n];
        for(int i = 0; i < n; i++)
        {
            for(int j = 0; j < n; j++)
            {
                origstage[i][j] = '.';
            }
        }

        for(int i = 1; i <= m; i++)
        {
            String[] model = lines.get(i).split(" ");
            origstage[Integer.parseInt(model[1]) - 1][Integer.parseInt(model[2]) - 1] = model[0].charAt(0);
        }

        StringBuilder temp = new StringBuilder();
        int max = ConfigOXP(origstage, n, temp);
        res = temp;

        StringBuilder temp2 = new StringBuilder();
        int val = ConfigOPX(origstage, n, temp2);
        if(val > max)
        {
            max = val;
            res = temp2;
        }

        StringBuilder temp3 = new StringBuilder();
        val = ConfigPOX(origstage, n, temp3);
        if(val > max)
        {
            max = val;
            res = temp3;
        }

        StringBuilder temp4 = new StringBuilder();
        val = ConfigPXO(origstage, n, temp4);
        if(val > max)
        {
            max = val;
            res = temp4;
        }

        StringBuilder temp5 = new StringBuilder();
        val = ConfigXOP(origstage, n, temp5);
        if(val > max)
        {
            max = val;
            res = temp5;
        }

        StringBuilder temp6 = new StringBuilder();
        val = ConfigXPO(origstage, n, temp6);
        if(val > max)
        {
            max = val;
            res = temp6;
        }


        return res.toString();
    }

    private int ConfigXPO(char[][] origstage, int n, StringBuilder str)
    {
        char[][] stage = new char[n][n];
        for(int i = 0; i < n; i++)
        {
            stage[i] = Arrays.copyOf(origstage[i], n);
        }

        int changed = 0;

        changed += FillX(stage, n);
        changed += FillP(stage, n);
        changed += FillO(stage, n);
        changed += Upgrade(stage, origstage, n);

        int val = GetValue(stage, n);

        str.append(val).append(" ").append(changed);
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(origstage[i][j] != stage[i][j]) {
                    str.append(System.lineSeparator()).append(stage[i][j]).append(" ").append(i + 1).append(" ").append(j + 1);
                }
            }
        }
        return val;
    }

    private int ConfigXOP(char[][] origstage, int n, StringBuilder str)
    {
        char[][] stage = new char[n][n];
        for(int i = 0; i < n; i++)
        {
            stage[i] = Arrays.copyOf(origstage[i], n);
        }

        int changed = 0;

        changed += FillX(stage, n);
        changed += FillO(stage, n);
        changed += FillP(stage, n);
        changed += Upgrade(stage, origstage, n);

        int val = GetValue(stage, n);

        str.append(val).append(" ").append(changed);
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(origstage[i][j] != stage[i][j]) {
                    str.append(System.lineSeparator()).append(stage[i][j]).append(" ").append(i + 1).append(" ").append(j + 1);
                }
            }
        }
        return val;
    }

    private int ConfigPOX(char[][] origstage, int n, StringBuilder str)
    {
        char[][] stage = new char[n][n];
        for(int i = 0; i < n; i++)
        {
            stage[i] = Arrays.copyOf(origstage[i], n);
        }

        int changed = 0;

        changed += FillP(stage, n);
        changed += FillO(stage, n);
        changed += FillX(stage, n);
        changed += Upgrade(stage, origstage, n);

        int val = GetValue(stage, n);

        str.append(val).append(" ").append(changed);
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(origstage[i][j] != stage[i][j]) {
                    str.append(System.lineSeparator()).append(stage[i][j]).append(" ").append(i + 1).append(" ").append(j + 1);
                }
            }
        }
        return val;
    }

    private int ConfigPXO(char[][] origstage, int n, StringBuilder str)
    {
        char[][] stage = new char[n][n];
        for(int i = 0; i < n; i++)
        {
            stage[i] = Arrays.copyOf(origstage[i], n);
        }

        int changed = 0;

        changed += FillP(stage, n);
        changed += FillX(stage, n);
        changed += FillO(stage, n);
        changed += Upgrade(stage, origstage, n);

        int val = GetValue(stage, n);

        str.append(val).append(" ").append(changed);
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(origstage[i][j] != stage[i][j]) {
                    str.append(System.lineSeparator()).append(stage[i][j]).append(" ").append(i + 1).append(" ").append(j + 1);
                }
            }
        }
        return val;
    }

    private int ConfigOPX(char[][] origstage, int n, StringBuilder str)
    {
        char[][] stage = new char[n][n];
        for(int i = 0; i < n; i++)
        {
            stage[i] = Arrays.copyOf(origstage[i], n);
        }

        int changed = 0;

        changed += FillO(stage, n);
        changed += FillP(stage, n);
        changed += FillX(stage, n);
        changed += Upgrade(stage, origstage, n);

        int val = GetValue(stage, n);

        str.append(val).append(" ").append(changed);
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(origstage[i][j] != stage[i][j]) {
                    str.append(System.lineSeparator()).append(stage[i][j]).append(" ").append(i + 1).append(" ").append(j + 1);
                }
            }
        }
        return val;
    }

    private int ConfigOXP(char[][] origstage, int n, StringBuilder str)
    {
        char[][] stage = new char[n][n];
        for(int i = 0; i < n; i++)
        {
            stage[i] = Arrays.copyOf(origstage[i], n);
        }

        int changed = 0;

        changed += FillO(stage, n);
        changed += FillX(stage, n);
        changed += FillP(stage, n);
        changed += Upgrade(stage, origstage, n);

        int val = GetValue(stage, n);

        str.append(val).append(" ").append(changed);
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(origstage[i][j] != stage[i][j]) {
                    str.append(System.lineSeparator()).append(stage[i][j]).append(" ").append(i + 1).append(" ").append(j + 1);
                }
            }
        }
        return val;
    }

    private int GetValue(char[][] stage, int n)
    {
        int val = 0;
        for(int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if(stage[i][j] == 'o')
                    val += 2;
                else if (stage[i][j] == '+' || stage[i][j] == 'x')
                    val += 1;
            }
        }
        return val;
    }

    private int Upgrade(char[][] stage, char[][] origstage, int n)
    {
        int changed = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if ((origstage[i][j] == '+' || origstage[i][j] == 'x') && AddO(i, j, stage, n)) {
                    stage[i][j] = 'o';
                    changed++;
                }
            }
        }
        return changed;
    }

    private int FillP(char[][] stage, int n)
    {
        int changed = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (stage[i][j] == '.' && AddP(i, j, stage, n)) {
                    stage[i][j] = '+';
                    changed++;
                }
            }
        }
        return changed;
    }

    private int FillX(char[][] stage, int n)
    {
        int changed = 0;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (stage[i][j] == '.' && AddX(i, j, stage, n)) {
                    stage[i][j] = 'x';
                    changed++;
                }
            }
        }
        return changed;
    }

    private int FillO(char[][] stage, int n)
    {
        int changed = 0;
        // Add models: o
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < n; j++) {
                if (stage[i][j] == '.' && AddO(i, j, stage, n)) {
                    stage[i][j] = 'o';
                    changed++;
                }
            }
        }
        return changed;
    }

    private boolean AddP(int i, int j, char[][] stage, int n) {
        int si, sj;
        // no o/+ in right diag
        if(i == j)
            si = sj = 0;
        else if(i < j)
        {
            si = 0;
            sj = j - i;
        }
        else
        {
            si = i - j;
            sj = 0;
        }
        for(; si < n && sj < n; si++, sj++)
            if((si != i || sj != j) && (stage[si][sj] == 'o' || stage[si][sj] == '+'))
                return false;

        // no o/+ in left diag
        if(i == n - j - 1)
        {
            si = 0;
            sj = n - 1;
        }
        else if(i < n - j - 1)
        {
            si = 0;
            sj = j + i;
        }
        else
        {
            si = i - (n - j - 1);
            sj = n - 1;
        }
        for(; si < n && sj >= 0; si++, sj--)
            if((si != i || sj != j) && (stage[si][sj] == 'o' || stage[si][sj] == '+'))
                return false;

        return true;
    }

    private boolean AddX(int i, int j, char[][] stage, int n) {
        // no o/x in row
        for(int col = 0; col < n; col++)
            if(col != j && (stage[i][col] == 'o' || stage[i][col] == 'x'))
                return false;

        // no o/x in col
        for(int row = 0; row < n; row++)
            if(row != i && (stage[row][j] == 'o' || stage[row][j] == 'x'))
                return false;

        return true;
    }

    private boolean AddO(int i, int j, char[][] stage, int n)
    {
        // no o/x in row
        for(int col = 0; col < n; col++)
            if(col != j && (stage[i][col] == 'o' || stage[i][col] == 'x'))
                return false;

        // no o/x in col
        for(int row = 0; row < n; row++)
            if(row != i && (stage[row][j] == 'o' || stage[row][j] == 'x'))
                return false;

        int si, sj;

        // no o/+ in right diag
        if(i == j)
            si = sj = 0;
        else if(i < j)
        {
            si = 0;
            sj = j - i;
        }
        else
        {
            si = i - j;
            sj = 0;
        }
        for(; si < n && sj < n; si++, sj++)
            if((si != i || sj != j) && (stage[si][sj] == 'o' || stage[si][sj] == '+'))
                return false;

        // no o/+ in left diag
        if(i == n - j - 1)
        {
            si = 0;
            sj = n - 1;
        }
        else if(i < n - j - 1)
        {
            si = 0;
            sj = j + i;
        }
        else
        {
            si = i - (n - j - 1);
            sj = n - 1;
        }
        for(; si < n && sj >= 0; si++, sj--)
            if((si != i || sj != j) && (stage[si][sj] == 'o' || stage[si][sj] == '+'))
                return false;

        return true;
    }
}
