package gcj.gcj2016.Qual;

import gcj.Problems;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

/**
 * Author: Ritwik
 * Date: 4/8/2016
 */
public class ProbC extends Problems {
    private Map<Long, Integer> factors;

    public ProbC(String input, String output) {
        super();
        factors = new ConcurrentHashMap<>();
        super.exec(input, output);
    }

    private Integer getFactor(long num) {
        if(factors.containsKey(num))
            return factors.get(num);
        int sqrt = (int)Math.sqrt(num);
        for(int i = 2; i <= sqrt; i++) {
            if(num % i == 0) {
                factors.put(num, i);
                return i;
            }
        }
        factors.put(num, -1);
        return -1;
    }

    @Override
    protected String processTestCase(List<String> lines) {
        StringBuilder result = new StringBuilder();
        String[] nj = lines.get(0).split(" ", 2);
        int n = Integer.valueOf(nj[0]);
        int j = Integer.valueOf(nj[1]);
        String form = "%0" + String.valueOf(n - 2) + "d";
        int begin = 0;
        int end =  (1 << (n - 2)) - 1;
        for(int num = begin; num <= end; num++) {
            StringBuilder inner = new StringBuilder(String.format(form, Integer.valueOf(Integer.toBinaryString(num))));
            inner.insert(0, '1');
            inner.append('1');
            List<Integer> facts = new ArrayList<>();
            for(int base = 2; base <= 10; base++) {
                long bn = Long.parseLong(inner.toString(), base);
                Integer f = getFactor(bn);
                if(f == -1)
                    break;
                facts.add(f);
            }
            if(facts.size() == 9) {
                j--;
                result.append("\n");
                result.append(inner.toString());
                for (Integer f : facts) {
                    result.append(" ").append(f.toString());
                }
            }
            if (j == 0)
                break;
        }

        return result.toString();
    }

    @Override
    protected int getTCLines(String line) {
        return 1;
    }
}
