import java.io.File;
import java.util.Scanner;

public class Main {

	private static Scanner scanner;

	public static void main(String[] args) throws Exception {

		scanner = new Scanner(new File("B-large.in"));
		int cases = scanner.nextInt();
		for (int i = 0; i < cases; i++) {
			if(processCase())
				System.out.println("Case #" + (i+1) + ": YES");
			else
				System.out.println("Case #" + (i+1) + ": NO");
		}

	}

	private static boolean processCase() {
		int y = scanner.nextInt();
		int x = scanner.nextInt();
		int garden[][] = new int[y][x];

		for (int i = 0; i < y; i++) {
			for (int j = 0; j < x; j++) {
				garden[i][j] = scanner.nextInt();
			}
		}

		return checkGarden(garden);
	}

	private static boolean checkGarden(int[][] garden) {
		for (int y = 0; y < garden.length; y++) {
			for (int x = 0; x < garden[0].length; x++) {
				if(!checkForEveryField(garden, x, y))
					return false;
			}
		}
		return true;
	}

	private static boolean checkForEveryField(int[][] garden, int x, int y) {
		int height = garden[y][x];
		boolean possible1 = true;
		boolean possible2 = true;
		for (int i = 0; i < garden.length; i++) {
			if (garden[i][x] > height)
				possible1 = false;
		}
		for (int j = 0; j < garden[0].length; j++) {
			if (garden[y][j] > height)
				possible2 = false;
		}
		return possible1 || possible2;
	}

}
