package qualification;

import java.io.File;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.Scanner;

public class MagicTrick {

	private static Scanner scanner;

	public static void main(String[] args) throws Exception {
		scanner = new Scanner(new File("A-small-attempt0.in"));
		int N = scanner.nextInt();
		for (int n = 0; n < N; n++) {
			int[] firstLine = getPickedLine();
			int[] secondLine = getPickedLine();

			LinkedList<Integer> union = union(firstLine, secondLine);
			if (union.size() == 0)
				System.out.printf("Case #%d: Volunteer cheated!\n", n + 1);
			else if (union.size() == 1)
				System.out.printf("Case #%d: %d\n", n + 1, union.get(0));
			else if (union.size() > 1)
				System.out.printf("Case #%d: Bad magician!\n", n + 1);
			
		}
		scanner.close();
	}

	private static LinkedList<Integer> union(int[] firstLine, int[] secondLine) {
		Arrays.sort(firstLine);
		Arrays.sort(secondLine);
		LinkedList<Integer> union = new LinkedList<>();

		int i = 0;
		int j = 0;
		while (i < 4 && j < 4) {
			if (firstLine[i] == secondLine[j]) {
				union.add(firstLine[i]);
				i++;
				j++;
			} else if (firstLine[i] < secondLine[j]) {
				if (i == 3)
					break;
				i++;
			} else if (firstLine[i] > secondLine[j]) {
				if (j == 3)
					break;
				j++;
			}
		}

		return union;
	}

	private static int[] getPickedLine() {
		int firstPick = scanner.nextInt();
		skipLines(firstPick - 1);
		int[] firstLine = new int[] { scanner.nextInt(), scanner.nextInt(),
				scanner.nextInt(), scanner.nextInt() };
		skipLines(4 - firstPick);
		return firstLine;
	}

	private static void skipLines(int howMany) {
		for (int i = 0; i < howMany * 4; i++)
			scanner.nextInt();
	}
}
