package qualification;

import java.io.File;
import java.util.Scanner;
import java.util.TreeSet;

public class War {

	private static Scanner scanner;

	@SuppressWarnings("unchecked")
	public static void main(String[] args) throws Exception {
		scanner = new Scanner(new File("D-small-attempt0.in"));
		int N = scanner.nextInt();
		for (int n = 0; n < N; n++) {
			int blocks = scanner.nextInt();
			TreeSet<Double> naomi = new TreeSet<Double>();
			for (int i = 0; i < blocks; i++)
				naomi.add(scanner.nextDouble());
			TreeSet<Double> ken = new TreeSet<Double>();
			for (int i = 0; i < blocks; i++)
				ken.add(scanner.nextDouble());

			int scoreTruthful = playTruthful((TreeSet<Double>) naomi.clone(),
					(TreeSet<Double>) ken.clone());

			int scoreDeceitful = playDeceitful((TreeSet<Double>) naomi.clone(),
					(TreeSet<Double>) ken.clone());

			System.out.printf("Case #%d: %d %d\n", n + 1, scoreDeceitful,
					scoreTruthful);

//			if (n == 3) {
//				System.out.println(naomi.toString());
//				System.out.println(ken.toString());
//			}
		}
		scanner.close();
	}

	private static int playDeceitful(TreeSet<Double> naomi, TreeSet<Double> ken) {
		int scoreNaomi = 0;
		while (naomi.size() > 0) {
			Double tellNaomi;
			Double pickNaomi;
			Double bestNaomi = naomi.ceiling(ken.last());
			if (bestNaomi == null) {
				tellNaomi = ken.last() - 0.000001;
				pickNaomi = naomi.first();
			} else {
				tellNaomi = bestNaomi;
				pickNaomi = bestNaomi;
			}

			Double pickKen = getKensBest(ken, tellNaomi);

//			System.out.printf("n%f (n%.3f) k%.3f %s\n", tellNaomi, pickNaomi,
//					pickKen, tellNaomi > pickKen ? "win" : "");

			assert (pickNaomi > pickKen && tellNaomi > pickKen)
					|| (pickNaomi < pickKen && tellNaomi < pickKen);

			if (tellNaomi > pickKen)
				scoreNaomi++;

			naomi.remove(pickNaomi);
			ken.remove(pickKen);
		}
		return scoreNaomi;
	}

	private static int playTruthful(TreeSet<Double> naomi, TreeSet<Double> ken) {
		int scoreNaomi = 0;
		while (naomi.size() > 0) {
			Double pickNaomi = naomi.last();
			Double pickKen = getKensBest(ken, pickNaomi);

			if (pickNaomi > pickKen)
				scoreNaomi++;

			naomi.remove(pickNaomi);
			ken.remove(pickKen);
		}
		return scoreNaomi;
	}

	private static Double getKensBest(TreeSet<Double> ken, Double tellNaomi) {
		Double pickKen = ken.ceiling(tellNaomi);
		if (pickKen == null)
			pickKen = ken.first();
		return pickKen;
	}
}
