import java.math.BigInteger;

public class FairObject {

    private BigInteger[] obj;
    private BigInteger[][] dist;
    private BigInteger smallest;
    private BigInteger answer;
    private int index;

    public FairObject (int n) {
        obj = new BigInteger[n];
        dist = new BigInteger[n][n];
        smallest = BigInteger.ZERO;
        index = 0;
    }
    
    public void add (String s) {
        obj[index++] = new BigInteger(s);
        if (index == obj.length) {
            calculateDist();
        }
    }
    
    private void calculateDist() {
        for (int i = 0; i < obj.length; ++i) {
            for (int j = 0; j < obj.length; ++j) {
                dist[i][j] = obj[i].subtract(obj[j]).abs();
                if (smallest.equals(BigInteger.ZERO) ||
                    !dist[i][j].equals(BigInteger.ZERO) &&
                     dist[i][j].gcd(smallest).compareTo(smallest) < 0) {
                    smallest = dist[i][j].gcd(smallest);
                }
            }
        }
        
        if (smallest.equals(BigInteger.ZERO)) {
            answer = BigInteger.ZERO;
            return;
        }
        
        answer = smallest.subtract(obj[0].mod(smallest));
        if (answer.equals(BigInteger.ONE)) {
            answer = BigInteger.ZERO;
        }
    }

    // Get result
    public BigInteger get() {
        return answer;
    }
    
}