/*
The Snapper is a clever little gadget that, on one side, 
plugs into a power socket and, on the other side, 
exposes a power socket for plugging in a light or other device.
*/
/*
When the Snapper is in the ON state and is receiving power from the 
input socket, then the connected device is receiving power as well. 
When you snap your fingers, the Snapper toggles between the ON and OFF states. 
Of course, snapping your fingers only has an effect if the Snapper is 
plugged in and is receiving power from the socket.
*/
/*
In hopes of destroying the universe by means of a singularity, 
I have purchased N Snapper devices and chained them together by plugging the 
first one into a power socket, the second one into the first one, and so on. 
The light is plugged into the Nth Snapper.
*/
/*
Initially, all the Snappers are in the OFF state, 
so only the first one is receiving power from the socket, and the light is off.
I snap my fingers once, which toggles the first Snapper into the ON state 
and gives power to the second one. 
I snap my fingers again, which toggles both Snappers and then promptly 
cuts power off from the second one, leaving it in the ON state, 
but with no power. I snap my fingers the third time, 
which toggles the first Snapper again and gives power to the second one. 
Now both Snappers are in the ON state, 
and if my light is plugged into the second Snapper it will be on.
*/
/*
I keep doing this for hours. 
Will the light be on or off after I have snapped my fingers K times? 
The light is on if and only if it's receiving power from the Snapper 
it's plugged into. 
*/

import java.util.Scanner;

public class SnapperChain {

    public static void main (String[] args) {

        Scanner sc = new Scanner(System.in);
        int numCases = sc.nextInt();
        for (int i = 0; i < numCases; ++i) {
            int n = sc.nextInt();
            int k = sc.nextInt();
            System.out.print("Case #" + (i+1) + ": ");
            double d = Math.pow(2, n);
            if ((k % d) == (d - 1)) {
                System.out.println("ON");
            }
            else {
                System.out.println("OFF");
            }
        }
        sc.close();

    }

}