/*
Problem

On our planet, Jamcode IX, three Great Events occurred. 
They happened 26000, 11000 and 6000 slarboseconds ago. 
In 4000 slarboseconds, the amount of time since all of those events will be 
multiples of 5000 slarboseconds, the largest possible amount... 
and the apocalypse will come.
*/
/*
Luckily for you, you live on Jamcode X! The apocalypse came on Jamcode IX 
less than a year ago. 
But Jamcode X has a worrying prophecy: 
"After the moment of reckoning, on the first optimum anniversary of 
the N Great Events, the apocalypse will come. 64 bits will not save you.
You have been warned."
*/
/*
The people of Jamcode X are very concerned by this prophecy. 
All of the Great Events have already happened, and their times have 
been measured to the nearest slarbosecond; 
but nobody knows when their optimum anniversary will occur. 
After studying the diary of a scientist from Jamcode IX, 
scientists working on the problem have come up with a theory:
*/
/*
The moment of reckoning is now, the moment you solve this problem. 
At some time y = 0 slarboseconds from now, the number of slarboseconds 
since each of the Great Events will be divisible by some maximum number T. 
If you can find the smallest value of y that gives this largest possible T, 
that will give you the optimum anniversary when the apocalypse will come.
*/
/*
On Jamcode IX, for example, there were 3 Great Events and they happened 
26000, 11000 and 6000 slarboseconds before the moment of reckoning. 
4000 slarboseconds later, the amount of time since each event was a 
multiple of T=5000 slarboseconds, and the apocalypse came.
*/
/*
Your job is to compute the amount of time until the apocalypse comes. 
But remember the prophecy: even though the people of Jamcode X have been 
solving problems for two years, and 64-bit integers have always been 
enough, they might not always be enough now or in the future.
*/

import java.math.BigInteger;

import java.util.Scanner;

public class FairWarning {

    public static void main (String[] args) {

        // INPUT
        Scanner sc = new Scanner (System.in);
        final int numCases = sc.nextInt();
        FairObject[] cases = new FairObject[numCases];
        for (int i = 0; i < numCases; ++i) {
            int n = sc.nextInt();
            FairObject f = new FairObject(n);
            for (int j = 0; j < n; ++j) {
                f.add(sc.next());
            }
            cases[i] = f;
        }
        sc.close();

        // OUTPUT
        for (int i = 0; i < numCases; ++i) {
            System.out.println("Case #" + (i+1) + ": " + cases[i].get());
        }

    }

} // FairWarning