import java.util.LinkedList;

public class CoasterQueue {

    private int r;
    private int k;
    private int n;
    private int[] groups;
    
    private int numOn;
    
    private int euros;
    
    private LinkedList<Integer> queue;
    private LinkedList<Integer> riding;

    public CoasterQueue (int r, int k, int n, int[] groups) {
    
        this.r = r;
        this.k = k;
        this.n = n;
        this.groups = groups;
        
        numOn = 0;
        euros = 0;
        
        queue = new LinkedList<Integer>();
        riding = new LinkedList<Integer>();
        for (int i = 0; i < n; ++i) {
            queue.add(new Integer(groups[i]));
        }
    }
    
    public int getEuros () {
        return euros;
    }

    public int getk () {
        return k;
    }
    
    public int getr () {
        return r;
    }
    
    /*
    public int peek () {
        if (queue.isEmpty()) {
            return 0;
        }
        return queue.getFirst().intValue();
    }
    */

    public boolean ride () {
        if (queue.isEmpty()) {
            return false;
        }
        
        int i = queue.getFirst().intValue();
        if ((i + numOn) <= k) {
            riding.add(queue.removeFirst());
            euros += i;
            numOn += i;
            return true;
        }
        return false;
    }

    public void rideOver () {
        while ( !riding.isEmpty() ) {
            queue.add(riding.remove());
        }
        numOn = 0;
    }

}