/*
Some people go alone; other people go in groups, 
and don't want to board the roller coaster unless they can all go together. 
And everyone who rides the roller coaster wants to ride again. 
A ride costs 1 Euro per person; 
your job is to figure out how much money the roller coaster will make today.
*/
/*
The roller coaster can hold k people at once. 
People queue for it in groups. 
Groups board the roller coaster, one at a time, 
until there are no more groups left or there is no room for the next group; 
then the roller coaster goes, whether it's full or not. 
Once the ride is over, all of its passengers re-queue in the same order. 
The roller coaster will run R times in a day.
*/
/*
For example, suppose R=4, k=6, 
and there are four groups of people with sizes: 1, 4, 2, 1. 
The first time the roller coaster goes, the first two groups [1, 4] will ride, 
leaving an empty seat 
(the group of 2 won't fit, and the group of 1 can't go ahead of them). 
Then they'll go to the back of the queue, which now looks like 2, 1, 1, 4. 
The second time, the coaster will hold 4 people: [2, 1, 1]. 
Now the queue looks like 4, 2, 1, 1. 
The third time, it will hold 6 people: [4, 2]. 
Now the queue looks like [1, 1, 4, 2]. 
Finally, it will hold 6 people: [1, 1, 4]. 
The roller coaster has made a total of 21 Euros! 
*/

import java.util.Scanner;

public class ThemePark {

    public static void main (String[] args) {
    
        /* INPUT */
        Scanner sc = new Scanner (System.in);
        int numCases = sc.nextInt();
        CoasterQueue[] queues = new CoasterQueue[numCases];
        for (int i = 0; i < numCases; ++i) {
            int r = sc.nextInt(); // num times coaster runs a day
            int k = sc.nextInt(); // num people coaster can hold
            int n = sc.nextInt(); // num groups
            int[] groups = new int[n];
            for (int j = 0; j < n; ++j) {
                groups[j] = sc.nextInt();
            }
            queues[i] = new CoasterQueue(r,k,n,groups);
        }
        sc.close();
        
        /* RIDE COASTERS */
        for (int i = 0; i < numCases; ++i) {
            CoasterQueue q = queues[i];
            int r = q.getr();
            int k = q.getk();
        
            for ( ; r > 0; --r) {
                while (q.ride()) { }
                q.rideOver();
            }
        }
        
        /* OUTPUT */
        for (int i = 0; i < numCases; ++i) {
            System.out.println("Case #" + (i+1) + ": " + queues[i].getEuros());
        }
    }

}