import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class SolutionB {

    public int[][] map;
    public String level = "abcdefghijklmnopqrstuvwxyz";
    public int H;
    public int W;

    class point {
        public int x;
        public int y;
        public int alti;
        public char value;
        public point parent;

        public point(int x, int y, int alti) {
            this.x = x;
            this.y = y;
            this.alti = alti;
        }
    }

    public boolean isInRange(int x, int y) {
        if ((x < H) && (x >= 0) && (y >= 0) && (y < W)) {
            return true;
        }
        return false;
    }

    public point basin(point p, point[] map) {
        // p.isVisited = true;
        // N W E S
        point[] quart = new point[4];

        // N
        if (isInRange(p.x - 1, p.y)) {
            quart[0] = map[(p.x - 1) * W + p.y];
        }

        // W
        if (isInRange(p.x, p.y - 1)) {
            quart[1] = map[p.x * W + p.y - 1];
        }

        // E
        if (isInRange(p.x, p.y + 1)) {
            quart[2] = map[p.x * W + p.y + 1];
        }

        // S
        if (isInRange(p.x + 1, p.y)) {
            quart[3] = map[(p.x + 1) * W + p.y];
        }

        int index = -1;
        int min = p.alti;
        for (int i = 0; i < quart.length; i++) {
            if ((quart[i] != null) && (quart[i].alti < min)) {
                index = i;
                min = quart[i].alti;
            }
        }

        if (index < 0) {
            return p;
        }
        return basin(quart[index], map);
    }

    public void getValue(point p) {
        point s = p;
        while (s.parent != s) {
            s = s.parent;
        }
        p.value = s.value;
    }

    public point[] solve(int[][] map) {
        this.H = map.length;
        this.W = map[0].length;

        point[] points = new point[W * H];

        int count = 0;
        for (int i = 0; i < H; i++) {
            for (int j = 0; j < W; j++) {
                points[W * i + j] = new point(i, j, map[i][j]);
            }
        }
        points[0].value = 'a';

        for (int i = 0; i < H; i++) {
            for (int j = 0; j < W; j++) {
                points[W * i + j].parent = basin(points[W * i + j], points);
            }
        }

        point b = points[0].parent;

        while (b.parent != b) {
            b = b.parent;
        }

        b.value = points[0].value;

        for (int i = 0; i < H; i++) {
            for (int j = 0; j < W; j++) {
                if ((points[W * i + j].parent == points[W * i + j]) && (b != points[W * i + j])) {
                    points[W * i + j].value = level.charAt(++count);
                    // System.out.println(points[W * i + j].value + " " + i + " " + j);
                }
            }
        }

        for (int i = 0; i < H; i++) {
            for (int j = 0; j < W; j++) {
                getValue(points[W * i + j]);
                // System.out.print(points[i * W + j].value + " ");
            }
            // System.out.println();
        }
        return points;
    }

    public static void main(String[] args) {
        try {
            String inFile = "./test2009/B-small-attempt2.in";
            String outFile = "./test2009/B.out";
            BufferedReader reader = new BufferedReader(new InputStreamReader(new FileInputStream(new File(inFile))));
            BufferedWriter writer = new BufferedWriter(new OutputStreamWriter(new FileOutputStream(new File(outFile))));
            int numCase = Integer.parseInt(reader.readLine());
            for (int i = 0; i < numCase; i++) {
                String[] arg = reader.readLine().split(" ");
                int H = Integer.parseInt(arg[0]);
                int W = Integer.parseInt(arg[1]);
                int[][] map = new int[H][W];
                for (int j = 0; j < H; j++) {
                    String[] elem = reader.readLine().split(" ");
                    for (int k = 0; k < W; k++) {
                        map[j][k] = Integer.parseInt(elem[k]);
                        // System.out.print(map[j][k] + " ");
                    }
                    // System.out.println();
                }

                SolutionB sb = new SolutionB();
                point[] points = sb.solve(map);
                writer.write("Case #" + (i + 1) + ": \r\n");
                for (int j = 0; j < H; j++) {
                    String str = "";
                    for (int j2 = 0; j2 < W; j2++) {
                        str += points[j * W + j2].value + " ";
                        // System.out.print(points[j * W + j2].value + " ");
                    }
                    // System.out.println();
                    writer.write(str.trim() + "\r\n");
                }
                // System.out.println("------------------------------------");
            }
            writer.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}
