import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Set;

public class CodeJamMagicka {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("/Users/Christopher/Downloads/B-small-attempt0.in.txt"));
		int numOfCases = Integer.parseInt(reader.readLine());

		for (int caseNum = 1; caseNum <= numOfCases; caseNum++) {
			String[] line = reader.readLine().split(" ");
			int lineIndex = 0;

			int combineElemCount = Integer.parseInt(line[lineIndex++]);

			Map<Collection<Character>, Character> combineElems = new HashMap<Collection<Character>, Character>(combineElemCount);
			for (int i = 0; i < combineElemCount; i++) {
				char[] elems = line[lineIndex++].toCharArray();
				Collection<Character> pair = new ElementPair(elems[0], elems[1]);
				combineElems.put(pair, elems[2]);
			}

			int opposedElemCount = Integer.parseInt(line[lineIndex++]);
			Set<Set<Character>> opposedElems = new HashSet<Set<Character>>(opposedElemCount);
			for (int i = 0; i < opposedElemCount; i++) {
				char[] elems = line[lineIndex++].toCharArray();
				Set<Character> pair = new HashSet<Character>(2);
				pair.add(elems[0]);
				pair.add(elems[1]);
				opposedElems.add(pair);
			}

			@SuppressWarnings("unused")
			int invokeElemCount = Integer.parseInt(line[lineIndex++]);
			char[] invokeElems = line[lineIndex++].toCharArray();

			solveCase(caseNum, combineElems, opposedElems, invokeElems);
		}
	}

	private static void solveCase(int caseNum, Map<Collection<Character>, Character> combineElems, Set<Set<Character>> opposedElems, char[] invokeElems) {
		List<Character> curElems = new ArrayList<Character>(invokeElems.length);
		ElementPair elemPair = new ElementPair();
		Set<Character> workingSet = new HashSet<Character>(2);

		mainLoop: for (Character invokingElem : invokeElems) {
			// first try to combine
			if (curElems.size() > 0) {
				elemPair.a = invokingElem;
				elemPair.b = curElems.get(curElems.size() - 1);
				Character nonbaseElement = combineElems.get(elemPair);
				if (nonbaseElement != null) {
					curElems.remove(curElems.size() - 1);
					curElems.add(nonbaseElement);
					continue;
				}
			}

			// If they don't combine, then look for opposed elems.
			for (Character elem : curElems) {
				workingSet.clear();
				workingSet.add(invokingElem);
				workingSet.add(elem);
				if (opposedElems.contains(workingSet)) {
					curElems.clear();
					continue mainLoop;
				}
			}

			curElems.add(invokingElem);
		}

		// Couldn't find a solution. ;'(
		System.out.format("Case #%d: %s\n", caseNum, curElems);
	}

	private static class ElementPair implements Collection<Character> {

		Character a;
		Character b;

		public ElementPair() {
		}

		public ElementPair(Character a, Character b) {
			this.a = a;
			this.b = b;
		}

		@Override
		public boolean add(Character arg0) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public boolean addAll(Collection<? extends Character> arg0) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public void clear() {
			// TODO Auto-generated method stub

		}

		@Override
		public boolean contains(Object arg0) {
			return arg0 == a | arg0 == b;
		}

		@Override
		public boolean containsAll(Collection<?> arg0) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public boolean isEmpty() {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public Iterator<Character> iterator() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public boolean remove(Object arg0) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public boolean removeAll(Collection<?> arg0) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public boolean retainAll(Collection<?> arg0) {
			// TODO Auto-generated method stub
			return false;
		}

		@Override
		public int size() {
			return 2;
		}

		@Override
		public Object[] toArray() {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public <T> T[] toArray(T[] arg0) {
			// TODO Auto-generated method stub
			return null;
		}

		@Override
		public boolean equals(Object obj) {
			if (obj instanceof ElementPair) {
				ElementPair elem = (ElementPair) obj;
				return a == elem.a && b == elem.b || b == elem.a && a == elem.b;
			} else {
				return false;
			}
		}

		@Override
		public int hashCode() {
			return a.hashCode() + b.hashCode();
		}

	}
}
