import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class CodeJamGoroSort {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("/Users/Christopher/Downloads/D-small-attempt0.in.txt"));
		int numOfCases = Integer.parseInt(reader.readLine());

		for (int caseNum = 1; caseNum <= numOfCases; caseNum++) {
			int numOfIntegers = Integer.parseInt(reader.readLine());
			String[] strInts = reader.readLine().split(" ");
			Num[] nums = new Num[numOfIntegers];
			for (int i = 0; i < strInts.length; i++) {
				String string = strInts[i];
				nums[i] = new Num(Integer.valueOf(string), Integer.valueOf(i + 1));
			}

			solveCase(caseNum, nums);
		}
	}

	private static void solveCase(int caseNum, Num[] nums) {
		int expectedHits;

		List<Num> remainingNums = new ArrayList<Num>(nums.length);
		for (Num num : nums) {
			if (!num.inPlace()) {
				remainingNums.add(num);
			}
		}

		expectedHits = remainingNums.size();

		System.out.format("Case #%d: %d.000000\n", caseNum, expectedHits);
	}

	private static class Num {
		Integer num;
		Integer pos;

		public Num(Integer num, Integer position) {
			this.num = num;
			this.pos = position;
		}

		public boolean inPlace() {
			return num.equals(pos);
		}

		@Override
		public boolean equals(Object obj) {
			if (obj instanceof Num) {
				return num.equals(((Num) obj).num) && pos.equals(((Num) obj).pos);
			}
			return false;
		}
	}

}