import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;

public class CodeJamCandySplitting {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("/Users/Christopher/Downloads/C-small-attempt0.in.txt"));
		// BufferedReader reader = new BufferedReader(new FileReader("/Users/Christopher/test.txt"));
		int numOfCases = Integer.parseInt(reader.readLine());

		for (int caseNum = 1; caseNum <= numOfCases; caseNum++) {
			int numOfCandies = Integer.parseInt(reader.readLine());
			String[] strCandyValues = reader.readLine().split(" ");
			int[] candyValues = new int[numOfCandies];
			for (int i = 0; i < numOfCandies; i++) {
				candyValues[i] = Integer.parseInt(strCandyValues[i]);
			}

			solveCase(caseNum, candyValues);
		}
	}

	private static void solveCase(int caseNum, int[] candyValues) {
		// Determine if it can be split equally according to Patrick.
		if (0 != patrickSum(candyValues)) {
			System.out.format("Case #%d: NO\n", caseNum);
		} else {
			// No matter how you split the pile the piles will be the same to Patrick.
			// So just give the smallest piece to Patrick and he'll be happy.
			// :)
			int smallestPiece = candyValues[0];
			for (int i = 0; i < candyValues.length; i++) {
				int j = candyValues[i];
				if (j < smallestPiece) {
					smallestPiece = j;
				}
			}

			System.out.format("Case #%d: %d\n", caseNum, seanSum(candyValues) - smallestPiece);
		}
	}

	private static int seanSum(int[] values) {
		int sum = 0;

		for (int i = 0; i < values.length; i++) {
			sum += values[i];
		}

		return sum;
	}

	private static int patrickSum(int[] values) {
		int sum = 0;

		for (int i = 0; i < values.length; i++) {
			sum ^= values[i];
		}

		return sum;
	}

}
