import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

public class CodeJamBotTrust {

	public static void main(String[] args) throws IOException {
		BufferedReader reader = new BufferedReader(new FileReader("/Users/Christopher/Downloads/A-large.in.txt"));
		int numOfCases = Integer.parseInt(reader.readLine());

		for (int caseNum = 1; caseNum <= numOfCases; caseNum++) {
			String[] strButtons = reader.readLine().split(" ");
			int numOfButtons = Integer.parseInt(strButtons[0]);
			List<Integer> orangeButtons = new ArrayList<Integer>();
			List<Integer> blueButtons = new ArrayList<Integer>();
			String[] buttonColors = new String[numOfButtons];

			for (int i = 0; i < numOfButtons; i++) {
				String color = strButtons[i * 2 + 1];
				int position = Integer.parseInt(strButtons[i * 2 + 2]);
				buttonColors[i] = color;
				if ("O".equals(color)) {
					orangeButtons.add(position);
				} else { // B
					blueButtons.add(position);
				}
			}

			int orangePosition = 1;
			int bluePosition = 1;
			int curOrangeButtonIndex = 0;
			int curBlueButtonIndex = 0;
			int timeElapsed = 0;
			int orangeGoal = goal(orangeButtons, curOrangeButtonIndex);
			int blueGoal = goal(blueButtons, curBlueButtonIndex);

			while (orangeGoal > -1 | blueGoal > -1) {
				boolean nextButtonIsOrange = "O".equals(buttonColors[curOrangeButtonIndex + curBlueButtonIndex]);

				if (orangeGoal == orangePosition) {
					if (nextButtonIsOrange) {
						// press the button
						curOrangeButtonIndex++;
						orangeGoal = goal(orangeButtons, curOrangeButtonIndex);
					} // else wait
				} else {
					orangePosition = moveTowardsButton(orangePosition, orangeGoal);
				}

				if (blueGoal == bluePosition) {
					if (!nextButtonIsOrange) {
						// press the button
						curBlueButtonIndex++;
						blueGoal = goal(blueButtons, curBlueButtonIndex);
					} // else wait
				} else {
					bluePosition = moveTowardsButton(bluePosition, blueGoal);
				}

				timeElapsed++;
			}

			System.out.format("Case #%d: %d\n", caseNum, timeElapsed);
		}
	}

	public static int goal(List<Integer> buttons, int index) {
		if (index < buttons.size()) {
			return buttons.get(index);
		} else {
			return -1;
		}
	}

	// returns new pos
	public static int moveTowardsButton(int curPos, int buttonPos) {
		if (curPos == buttonPos) {
			return curPos;
		} else if (curPos < buttonPos) {
			return curPos + 1;
		} else {
			return curPos - 1;
		}
	}
}
