import java.io.IOException;
import java.util.Arrays;
import java.util.Scanner;
import java.util.List;
import java.util.ArrayList;
import java.util.Map;
import java.util.HashMap;
import java.util.Set;
import java.util.HashSet;

import com.google.common.base.*;
import com.google.common.collect.*;

public class ACodeJam {

	private enum Tile {
		BLUE, REDF, REDB, WHITE;

		@Override
		public String toString() {
			if (this == REDF) {
				return "/";
			} else if (this == REDB) {
				return "\\";
			} else if (this == BLUE) {
				return "#";
			} else {
				return ".";
			}
		}
	}

	public static void main(String[] args) throws IOException {
		Scanner in = new Scanner(System.in);
		int numOfCases = in.nextInt();

		caseLoop: for (int caseNum = 1; caseNum <= numOfCases; caseNum++) {
			int y = in.nextInt();
			int x = in.nextInt();

			Tile[][] tiles = new Tile[x][y];
			for (int i = 0; i < y; i++) {
				String line = in.next();
				for (int j = 0; j < x; j++) {
					char ch = line.charAt(j);
					tiles[j][i] = ch == '#' ? Tile.BLUE : Tile.WHITE;
				}
			}

			for (int i = 0; i < y; i++) {
				for (int j = 0; j < x; j++) {
					if (canPlaceRed(tiles, j, i)) {
						placeRed(tiles, j, i);
					}
				}
			}

			System.out.format("Case #%d:\n", caseNum);

			for (int i = 0; i < y; i++) {
				for (int j = 0; j < x; j++) {
					if (tiles[j][i] == Tile.BLUE) {
						System.out.println("Impossible");
						continue caseLoop;
					}
				}
			}

			for (int i = 0; i < y; i++) {
				for (int j = 0; j < x; j++) {
					System.out.print(tiles[j][i]);
				}
				System.out.println();
			}
		}
	}

	public static boolean canPlaceRed(Tile[][] tiles, int x, int y) {
		if (x + 1 < tiles.length && y + 1 < tiles[x].length) {
			if (tiles[x][y] == Tile.BLUE && tiles[x + 1][y] == Tile.BLUE && tiles[x][y + 1] == Tile.BLUE && tiles[x + 1][y + 1] == Tile.BLUE) {
				return true;
			}
		}

		return false;
	}

	public static void placeRed(Tile[][] tiles, int x, int y) {
		tiles[x][y] = Tile.REDF;
		tiles[x + 1][y + 1] = Tile.REDF;
		tiles[x + 1][y] = Tile.REDB;
		tiles[x][y + 1] = Tile.REDB;
	}
}
