import java.util.Arrays;
import java.util.Scanner;

/**
 * Created by Christy on 4/30/17.
 */
public class AmpleSyrup {
    public static Pancake[] pan;
    public static double[][] dp;
    public static void main(String[] args) {
        Scanner scan = new Scanner(System.in);

        int cases = scan.nextInt();

        for (int i =0; i < cases; i++) {

            int n = scan.nextInt();
            int k = scan.nextInt();

            pan  = new Pancake[n];
            dp = new double[n][n];

            for (int m = 0; m < n; m++) {
                Arrays.fill(dp[m], -1);
            }

            for (int j = 0; j < n; j++) {
                double r = scan.nextDouble();
                double h = scan.nextDouble();

                pan[j] = new Pancake(r, h);
            }

            Arrays.sort(pan);

            double ans = solve(k, -1, 0.0, 0);

            System.out.printf("Case #%d: %f\n", (i + 1), ans);

        }
    }

    private static double solve( int k, int lastindex, double total, int currindex) {
        double max = Double.MIN_VALUE;
        //base
        if (k == 0 ) {
            return total;
        }
        if ( k > 0 && currindex >= pan.length) {
            return Double.MIN_VALUE;
        }

        //take
        double didnttake = solve(k, lastindex, total, currindex + 1);
        //System.err.println("didn't take " + currindex + " and ans is " + didnttake);
        max = Math.max(max, didnttake);


        //don't take
        double tooktotal = get(lastindex, currindex);
        double took = solve(k - 1, currindex, tooktotal + total, currindex + 1);
        //System.err.println("did take " + currindex + " and ans is " + took);
        max = Math.max(max, took);

        return max;
    }

    //what we're doing here is finding what the current pancake adds
    //to the stack.
    //this means:
    //  height of current pancake
    //  top of current pancake
    // top of old - bottom of new
    //
    private static double get(int lastindex, int currindex) {

        Pancake curr = pan[currindex];

        //calculate whole surface area for current
        double top =  Math.PI *curr.r * curr.r;
        double sides = 2.0 * Math.PI * curr.r * curr.h;
        double total = top + sides;

        //subtract the overlap (doesn't count for either one)
        if (lastindex != -1) {

            if (dp[lastindex][currindex] != -1) {
                return dp[lastindex][currindex];
            }





            Pancake last = pan[lastindex];
           double lastTop = Math.PI * last.r * last.r;
            total -= 1.0 * lastTop;

            dp[lastindex][currindex] = total;

        }

        return total;
    }


    public static class Pancake implements Comparable{
        public double r, h;
        public Pancake(double r, double h) {
            this.r = r;
            this.h = h;
        }


        @Override
        public int compareTo(Object o) {
            Pancake other = (Pancake) o;
            int rr = Double.compare(this.r, other.r);

            if (rr != 0) {
                return rr;
            }

            return Double.compare(this.h, other.h);
        }
    }
}
