package _2016_round1a;

import java.io.BufferedReader;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.Map;


@SuppressWarnings("unused")
public class SolutionB {

  // NOTE: Download input files to TOP-LEVEL directory of project.
  // Example: "A-small-attempt0", "A-large"
  private static final String FILENAME = "B-small-attempt4";

  /*
   * API for output:
   * - void sout(Object): output to console
   * - void fout(Object): output to output file
   * - void out(Object): output to console and output file
   * - void outCase(int, Object): outputs "Case #[i]: " + obj.toString()
   *
   * API for file reading:
   * - String[] getStrings(): read and parse one line of Strings from input file
   * - String getString(): read and parse one line of one String from input file
   * - int[] getInts(): read and parse one line of ints from input file
   * - int getInt(): read and parse one line of one int from input file
   * - double[] getDoubles(): read and parse one line of doubles from input file
   * - double getDouble(): read and parse one line of one double from input file
   */
  private void solveCase(int caseNumber) throws Exception {
    int N = getInt();

    ArrayList<int[]> lists = new ArrayList<int[]>();
    ArrayList<int[]> lists2 = new ArrayList<int[]>();
    for (int i = 0; i < (2 * N) - 1; ++i) {
      lists.add(getInts());
      lists2.add(lists.get(i));
    }

    int[] result = new int[N];

    int index;
    int[] isolatedList = null;
    for (index = 0; index < N - 1; index++) {
      final int index_ = index;

      Collections.sort(lists, new Comparator<int[]>() {
        @Override
        public int compare(int[] o1, int[] o2) {
          return Integer.compare(o1[index_], o2[index_]);
        }
      });

      int[] l1 = lists.get(0);
      int[] l2 = lists.get(1);


      if (l1[index] != l2[index]) {
        isolatedList = l1;
        break;
      }
      lists.remove(0);
      lists.remove(0);
    }
    if (isolatedList == null) {
      isolatedList = lists.get(0);
    }
    for (int i = 0; i < N; ++i) {
      final int i_ = i;
      Collections.sort(lists2, new Comparator<int[]>() {
        @Override
        public int compare(int[] o1, int[] o2) {
          return Integer.compare(o1[i_], o2[i_]);
        }
      });
      if (i == index) {
        result[i] = isolatedList[i];
        lists2.remove(0);
      } else {
        int[] l1 = lists2.get(0);
        int[] l2 = lists2.get(1);

        if (isolatedList[i] == l1[index]) {
          result[i] = l2[index];
        } else if (isolatedList[i] == l2[index]) {
          result[i] = l1[index];
        } else {
          sout(isolatedList[i]);
          sout(index);
          sout(i);
          sout(Arrays.toString(l1));
          sout(Arrays.toString(l2));
          sout(Arrays.toString(lists2.get(2)));
          System.exit(1);
        }

        lists2.remove(0);
        lists2.remove(0);
      }
    }



//    int[] result = new int[N];
//    for (int i = 0; i < N - 1; ++i) {
//      final int index = i;
//      Collections.sort(lists, new Comparator<int[]>() {
//        @Override
//        public int compare(int[] o1, int[] o2) {
//          return Integer.compare(o1[index], o2[index]);
//        }
//      });
//
//      int[] l1 = lists.get(0);
//      int[] l2 = lists.get(1);
//
//      if (l1[index] != l2[index]) {
//        result[index] = l1[index];
//        lists.remove(0);
//
//        Collections.sort(lists, new Comparator<int[]>() {
//          @Override
//          public int compare(int[] o1, int[] o2) {
//            return Integer.compare(o1[index], o2[index]);
//          }
//        });
//
//        for (int k = index + 1; k < N; ++k) {
//          final int kk = k;
//
//          int[] ll1 = lists.get(0);
//          int[] ll2 = lists.get(1);
//          if (l1[kk] == ll1[index]) {
//            result[kk] = ll2[index];
//          } else {
//            result[kk] = ll1[index];
//          }
//          lists.remove(0);
//          lists.remove(0);
//        }
//
//        String s = "";
//        for (int ii = 0; ii < N - 1; ++ii) s += result[ii] + " ";
//        s += result[N - 1];
//
//        outCase(caseNumber, s);
//        return;
//      }
//
//      Map<Integer, Integer> seen = new HashMap<Integer, Integer>();
//      for (int j = index + 1; j < l1.length; ++j) {
//        int num = l1[j];
//        int num2 = l2[j];
//        seen.put(num, seen.containsKey(num) ? seen.get(num) + 1 : 1);
//        seen.put(num2, seen.containsKey(num2) ? seen.get(num2) + 1 : 1);
//      }
//
//      for (int j = 2; j < lists.size(); ++j) {
//        int num = lists.get(j)[index];
//        seen.put(num, seen.get(num) - 1);
//      }
//
//      int found = -1;
//      for (int key : seen.keySet()) {
//        if (seen.get(key) == 1) {
//          found = key;
//          break;
//        }
//      }
//      if (found == -1) {
//        throw new RuntimeException("BUG " + Arrays.toString(l1) + " " + Arrays.toString(l2) + " " + index);
//      }
//      result[index] = found;
//
//      lists.remove(0);
//      lists.remove(0);
//    }
//
//    result[N - 1] = lists.get(0)[N - 1];
//
    String s = "";
    for (int i = 0; i < N - 1; ++i) s += result[i] + " ";
    s += result[N - 1];

    outCase(caseNumber, s);
  }


  /* ----- Code run from main() ----- */

  private SolutionB() {
    try {
      rd = new BufferedReader(new FileReader(FILENAME + ".in"));
      wr = new PrintWriter(new FileWriter(FILENAME + ".out"));
      numCases = getInt();
      isInitialized = true;
    } catch (Exception e) {
      sout("Error reading file:");
      e.printStackTrace();
    }
  }

  private void solveCases() {
    if (!isInitialized) {
      return;
    }

    for(int i = 1; i <= numCases; ++i) {
      try {
        solveCase(i);
      } catch (Exception e) {
        sout("Exception in Case " + i + ".");
        e.printStackTrace();
        break;
      }
    }
  }

  private void tearDown() {
    try {
      if (wr != null) {
        wr.close();
      }
    } catch (Exception e) {
      sout("Error closing writer.");
      e.printStackTrace();
    }

    try {
      if (rd != null) {
        rd.close();
      }
    } catch (Exception e) {
      sout("Error closing reader.");
      e.printStackTrace();
    }
  }

  /* ----- Utility fields ----- */

  private BufferedReader rd = null;
  private PrintWriter wr = null;
  private boolean isInitialized = false;
  private int numCases = -1;

  /* ----- Output utilities ----- */

  private void sout(Object s) {
    System.out.println(s);
  }

  private void fout(Object s) {
    if (wr == null) {
      throw new RuntimeException("Writer has not been initialized.");
    }
    wr.println(s);
  }

  private void out(Object s) {
    sout(s);
    fout(s);
  }

  private void outCase(int c, Object s) {
    String out = "Case #" + c + ": " + s.toString();
    sout(out);
    fout(out);
  }

  /* ----- Input utilities ----- */

  private String[] getStrings() throws Exception {
    if (rd == null) {
      throw new RuntimeException("Reader has not been initialized.");
    }
    return rd.readLine().split(" ");
  }

  private int[] getInts() throws Exception {
    String[] strData = getStrings();
    int length = strData.length;
    int[] arr = new int[length];
    for(int i = 0; i < length; ++i) {
      arr[i] = Integer.parseInt(strData[i], 10);
    }
    return arr;
  }

  private double[] getDoubles() throws Exception {
    String[] strData = getStrings();
    int length = strData.length;
    double[] arr = new double[length];
    for (int i = 0; i < length; ++i) {
      arr[i] = Double.parseDouble(strData[i]);
    }
    return arr;
  }

  private String getString() throws Exception {
    String[] strData = getStrings();
    if (strData.length != 1) {
      throw new RuntimeException("Misinterpreted the file in getString().");
    }
    return strData[0];
  }

  private int getInt() throws Exception {
    int[] intData = getInts();
    if (intData.length != 1) {
      throw new RuntimeException("Misinterpreted the file in getInt().");
    }
    return intData[0];
  }

  private double getDouble() throws Exception {
    double[] doubleData = getDoubles();
    if (doubleData.length != 1) {
      throw new RuntimeException("Misinterpreted the file in getDouble().");
    }
    return doubleData[0];
  }


  /* Start program via code in constructor */
  public static void main(String[] args) {
    SolutionB solution = new SolutionB();
    solution.solveCases();
    solution.tearDown();
  }
}
