import java.util.*;
import java.math.*;
import java.io.*;

public class C {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        
        int limit = (1 << 20);
        boolean[] isPrime = sieve(limit);
        
        int T = sc.nextInt();
        StringBuilder sb = new StringBuilder();
        long[] numbers = new long[11];
        for (int c = 1; c <= T; c++) {
            int length = sc.nextInt();
            int numJams = sc.nextInt();
            int begin = (1 << (length-1)) + 1;
            int end = 1 << length;
            int numFound = 0;
            out:
            for (int base2 = begin; base2 < end && numFound < numJams; base2 += 2) {
                String base2Str = Long.toString(base2, 2);
                if (!isPrime[base2]) {
//                    System.out.println(base2);
//                    System.out.println(base2Str);
                    for (int base = 3; base <= 10; base++) {
                        long next = Long.valueOf(base2Str, base);
//                        System.out.printf("\t%d: %d\n", base, next);
                        BigInteger bi = BigInteger.valueOf(next);
                        if (bi.isProbablePrime(150)) {
                            continue out;
                        }
                        numbers[base] = next;
                    }
                    sb.append(base2Str).append(' ');
                    sb.append(findFactor(base2));
                    for (int base = 3; base <= 10; base++) {
                        sb.append(' ');
                        sb.append(findFactor(numbers[base]));
                    }
                    sb.append('\n');
                    numFound++;
                }
            }
            
            System.out.printf("Case #%d:\n", c);
            System.out.print(sb);
        }
    }
    
    static long findFactor(long num) {
        for (long i = 3; ; i++) {
            if (num % i == 0) return i;
        }
    }
    
    static long toRadix(String base2Str, int radix) {
        return Long.valueOf(base2Str, radix);
    }
    
    static boolean [] sieve(int N) {
        boolean [] a = new boolean[N+1];
        Arrays.fill(a, true);
        a[0] = a[1] = false;
        for (int p = 2; p * p <= N; p++) 
            if (a[p]) {
                // Iterate through all multiples m of the prime and mark 
                // them as not prime.
                for (int m = p * p; m <= N; m += p)
                    a[m] = false;
            }
        return a;
    }

    /* generate all prime numbers from 2..N, inclusive */
    static int [] generatePrimes(int N) {
        List<Integer> primes = new ArrayList<Integer>();
        boolean [] isPrime = sieve(N);
        for (int i = 0; i <= N; i++)
            if (isPrime[i])
                primes.add(i);
        int [] pa = new int[primes.size()];
        for (int i = 0; i < pa.length; i++)
            pa[i] = primes.get(i);
        return pa;
    }

    /*
     * P - list of primes
     * n - number to factor
     * @return list of prime factors, e.g. n = 100 returns [2, 2, 5, 5]
     */
    static List<Integer> factor(int []P, int n) {
        List<Integer> result = new ArrayList<Integer>();
        for (int i = 0; i < P.length; i++) {
            int p = P[i];
            if (p * p > n) break;
            while (n % p == 0) {
                result.add(p);
                n /= p;
            }
        }
        if (n != 1) // large prime remainder
            result.add(n);

        return result;
    }
}
