import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.util.Arrays;
import java.util.Random;
import java.util.StringTokenizer;
import java.util.TreeSet;

public class C_Slow {
    public static void main(String[] args) {
        FastScanner sc = new FastScanner();

        int numCases = sc.nextInt();
        for (int q = 1; q <= numCases; q++) {
            System.out.printf("Case #%d: ", q);

            int N = sc.nextInt();
            int K = sc.nextInt();

            TreeSet<Integer> set = new TreeSet<>();
            set.add(0);
            set.add(N + 1);

            for (int i = 0; i < K; i++) {
                int bestMin = 0;
                int bestMax = 0;
                int bestIdx = 0;
                for (int j = 1; j <= N; j++) {
                    int left = set.floor(j);
                    int right = set.ceiling(j);
                    int leftDist = j - left;
                    int rightDist = right - j;
                    int minDist = Math.min(leftDist, rightDist);
                    int maxDist = Math.max(leftDist, rightDist);
                    if (minDist > bestMin) {
                        bestMin = minDist;
                        bestMax = maxDist;
                        bestIdx = j;
                    } else if (minDist == bestMin && maxDist > bestMax) {
                        bestMin = minDist;
                        bestMax = maxDist;
                        bestIdx = j;
                    }
                }
                if (bestIdx == 0) {
                    throw new Error();
                }
                set.add(bestIdx);
                if (i == K - 1) {
                    System.out.printf("%d %d\n", bestMax - 1, bestMin - 1);
                }
            }
        }
    }

    static void sort(int[] arr) {
        Random rng = new Random();
        int length = arr.length;
        for (int idx = 0; idx < arr.length; idx++) {
            int toSwap = idx + rng.nextInt(length-idx);
            int tmp = arr[idx];
            arr[idx] = arr[toSwap];
            arr[toSwap] = tmp;
        }
        Arrays.sort(arr);
    }

    public static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(Reader in) {
            br = new BufferedReader(in);
        }

        public FastScanner() {
            this(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        String readNextLine() {
            String str = "";
            try {
                str = br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

        int[] readIntArray(int n) {
            int[] a = new int[n];
            for (int idx = 0; idx < n; idx++) {
                a[idx] = nextInt();
            }
            return a;
        }
        long[] readLongArray(int n) {
            long[] a = new long[n];
            for (int idx = 0; idx < n; idx++) {
                a[idx] = nextLong();
            }
            return a;
        }
    }
}
