import java.io.*;
import java.util.*;

public class FashionShow {
    public static void main(String[] args) {
//        Scanner sc = new Scanner(System.in);
        FastScanner sc = new FastScanner();

        int numCases = sc.nextInt();
        for (int q = 1; q <= numCases; q++) {

            n = sc.nextInt();
            int m = sc.nextInt();
            original = new char[n][n];
            grid = new char[n][n];
            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    grid[i][j] = '.';
                    original[i][j] = '.';
                }
            }
            rowUsed = new boolean[n];
            colUsed = new boolean[n];
            forwardDiagUsed = new boolean[n + n - 1];
            backwardDiagUsed = new boolean[n + n - 1];

            int[] rowFreq = new int[n];
            int[] colFreq = new int[n];
            int[] forwardDiagFreq  = new int[n + n - 1];
            int[] backwardDiagFreq  = new int[n + n - 1];

            for (int i = 0; i < m; i++) {
                char c = sc.next().charAt(0);
                int row = sc.nextInt() - 1;
                int col = sc.nextInt() - 1;
                original[row][col] = c;
                grid[row][col] = c;

                int forwardDiag = row + col;
                int backwardDiag = n - row + col - 1;

                if (c == 'o') {
                    rowUsed[row] = true;
                    colUsed[col] = true;
                    forwardDiagUsed[forwardDiag] = true;
                    backwardDiagUsed[backwardDiag] = true;

                    rowFreq[row]++;
                    colFreq[col]++;
                    forwardDiagFreq[forwardDiag]++;
                    backwardDiagFreq[backwardDiag]++;
                } else if (c == '+') {
                    forwardDiagUsed[forwardDiag] = true;
                    backwardDiagUsed[backwardDiag] = true;

                    forwardDiagFreq[forwardDiag]++;
                    backwardDiagFreq[backwardDiag]++;
                } else if (c == 'x') {
                    rowUsed[row] = true;
                    colUsed[col] = true;

                    rowFreq[row]++;
                    colFreq[col]++;
                } else {
                    throw new Error(c + " " + (row+1) + " " + (col+1));
                }
            }

            int row1 = 0;
            int col1 = 0;
            int row2 = n - 1;
            int col2 = n - 1;
            for (int i = 0; i < n * n; i++) {
                int row = (i % 2 == 0 ? row1 : row2);
                int col = (i % 2 == 0 ? col1 : col2);
                int forwardDiag = row + col;
                int backwardDiag = n - row + col - 1;
                if (grid[row][col] == '.') {
                    if (!rowUsed[row] && !colUsed[col]) {
                        grid[row][col] = 'x';
                        rowUsed[row] = true;
                        colUsed[col] = true;
                        rowFreq[row]++;
                        colFreq[col]++;
                    } else if (!forwardDiagUsed[forwardDiag] && !backwardDiagUsed[backwardDiag]) {
                        grid[row][col] = '+';
                        forwardDiagUsed[forwardDiag] = true;
                        backwardDiagUsed[backwardDiag] = true;
                        forwardDiagFreq[forwardDiag]++;
                        backwardDiagFreq[backwardDiag]++;
                    }
                }
                if (i % 2 == 0) {
                    col1++;
                    if (col1 == n) {
                        row1++;
                        col1 = 0;
                    }
                } else {
                    col2--;
                    if (col2 == -1) {
                        row2--;
                        col2 = n - 1;
                    }
                }
            }

            for (int row = 0; row < n; row++) {
                for (int col = 0; col < n; col++) {
                    int forwardDiag = row + col;
                    int backwardDiag = n - row + col - 1;
                    char c = grid[row][col];
                    if (c == 'x') {
                        if (!forwardDiagUsed[forwardDiag] && !backwardDiagUsed[backwardDiag]) {
                            grid[row][col] = 'o';
                            forwardDiagUsed[forwardDiag] = true;
                            backwardDiagUsed[backwardDiag] = true;
                        }
                    } else if (c == '+') {
                        if (!rowUsed[row] && !colUsed[col]) {
                            grid[row][col] = 'o';
                            rowUsed[row] = true;
                            colUsed[col] = true;
                        }
                    }
                }
            }

            int score = 0;
            int count = 0;
            StringBuilder sb = new StringBuilder();
            for (int row = 0; row < n; row++) {
                for (int col = 0; col < n; col++) {
                    score += score(grid[row][col]);
                    if (grid[row][col] != '.' && grid[row][col] != original[row][col]) {
                        sb.append(grid[row][col]).append(' ').append(row+1).append(' ').append(col+1)
                                .append('\n');
                        count++;
                    }
                }
            }

            System.out.printf("Case #%d: ", q);
            System.out.println(score + " " + count);
            System.out.print(sb);

//            printGrid();
        }


    }

    static void printGrid() {
        for (char[] row : grid) {
            System.out.println(new String(row));
        }
    }

    static int score(char c) {
        switch (c) {
            case 'o':
                return 2;
            case 'x':
            case '+':
                return 1;
            default:
                return 0;
        }
    }

    static boolean[] rowUsed;
    static boolean[] colUsed;
    static boolean[] forwardDiagUsed;
    static boolean[] backwardDiagUsed;

    static int n;
    static char[][] original;
    static char[][] grid;

    public static class FastScanner {
        BufferedReader br;
        StringTokenizer st;

        public FastScanner(Reader in) {
            br = new BufferedReader(in);
        }

        public FastScanner() {
            this(new InputStreamReader(System.in));
        }

        String next() {
            while (st == null || !st.hasMoreElements()) {
                try {
                    st = new StringTokenizer(br.readLine());
                } catch (IOException e) {
                    e.printStackTrace();
                }
            }
            return st.nextToken();
        }

        int nextInt() {
            return Integer.parseInt(next());
        }

        long nextLong() {
            return Long.parseLong(next());
        }

        double nextDouble() {
            return Double.parseDouble(next());
        }

        String readNextLine() {
            String str = "";
            try {
                str = br.readLine();
            } catch (IOException e) {
                e.printStackTrace();
            }
            return str;
        }

        int[] readIntArray(int n) {
            int[] a = new int[n];
            for (int idx = 0; idx < n; idx++) {
                a[idx] = nextInt();
            }
            return a;
        }

        long[] readLongArray(int n) {
            long[] a = new long[n];
            for (int idx = 0; idx < n; idx++) {
                a[idx] = nextLong();
            }
            return a;
        }
    }
}
