/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.chrywhy.codejam;

/**
 *
 * @author chry
 */
public class CoinJam {
    public static long[] primes = new long[100];
    public static int primeCount = 0;
    public static int MaxPrimeCount = 100;
    
    private static void addNewPrime(long p) {
        if (primeCount < MaxPrimeCount) {
            primes[primeCount++] = p;
        }
    }
    
    private static long findFirstDivisor(long n) {
        long m = n / 2;
        int i;
        for (i=0; i<primeCount && primes[i]<=m; i++) {
            if (n % primes[i] == 0) {
                return  primes[i];
            }
        }
        
        if(i==primeCount) {
            long p = primeCount == 0 ? 1 : primes[primeCount-1];
            while (p <= m && primeCount < MaxPrimeCount) { //if max prime is tried, do not try, deem it as prime
                p = findNextPrime(m, p);
                if (p <= m) {
                    if (n % p == 0) {
                        return  p;
                    }
                }
            }
        }
        return 0;
    }
    
    public static long findNextPrime(long n, long p) {
        int i;
        p++;
        while (p <= n) {
            long m = p/2;
            boolean isPrime = true;
            for (i=0; i<primeCount && primes[i]<=m; i++) {
                if (p % primes[i] == 0) {
                    isPrime = false;
                    break;
                }
            }
            if (isPrime) {
                break;
            }
            p++;
        }
        if (p <= n) {
            addNewPrime(p);
        }
        return p;
    }

    static long power(long a, int n) {
        long r = 1;
        while (n-- >= 1) {
            r =r *  a;
        }
        return r;
    }
                            
    public static String getFirstCoinJam(int n) {
        if(n<2) {
            throw new IllegalArgumentException("CoinJam should at least 2 digits");
        }
        String s = "";
        for (int i=0; i<n-2;i++) {
            s += "0";
        }
        return "1" + s + "1";
    }

    public static String getNextCoinJam(String coinJam) {
        String middleStr = coinJam.substring(1, coinJam.length()-1);
        long nextMiddleValue = Long.valueOf(middleStr, 2) + 1;
        String nextMiddleStr = Long.toBinaryString(nextMiddleValue);
        String leadZeros = "";
        int k = middleStr.length() - nextMiddleStr.length();
        if (k > 0) {
            for (int i=0; i<k ;i++) {
                leadZeros += "0";
            }
        } else if(k < 0) {
            throw new RuntimeException("This maximum codejam!");
        }
        return "1" + leadZeros + nextMiddleStr + "1";
    }

    public String testFindPrime(String input) {
        long n = Long.parseLong(input);
        long d = findFirstDivisor(n);
        String str = "";
        int group = 1;
        for (int i=0; i<primeCount && primes[i] <= n; i++) {
            str += primes[i];
            if (str.length() > 100 * group) {
                str += "\n";
                group++;
            } else {
                str += " ";
            }
        }
        return d + "\n" + str.trim();
    }

    public static void testFindNexCoinJam() {
        String s = getFirstCoinJam(5);
        System.out.println(s);
        for (int i =0; i<20; i++) {
            try {
                s = getNextCoinJam(s);
                System.out.println(s);
            } catch (Exception e) {
                break;
            }
        }
    }

    public String testCase(String input) {
        String[] nj = input.split(" ");
        int k = 0;
        int n = 0;
        int j = 0;
        for (int i=0; i<nj.length; i++) {
            String s = nj[i].trim();
            if (!s.isEmpty()) {
                int v = Integer.parseInt(s);
                if (k ==0) {
                    n = v;
                    k++;
                } else {
                    j = v;
                }
            }
        }
        if (n==0 || j==0) {
            throw new RuntimeException("invalid input!");
        }
        String str = "";
        int m = 0;
        String coinJam = getFirstCoinJam(n);
        while (m < j) {
            String result = coinJam;
            boolean primeFound = false;
            for (int b=2; b<=10; b++) {
                long bv = Long.valueOf(coinJam, b);
//                System.out.println("coinjam=" + coinJam + ",base=" + b + ",bv=" + bv);
                long d = findFirstDivisor(bv);
                if (d > 0) {
                    result += " " + d;
//                    System.out.println(result);
                } else {    //this is a prime
//                    System.out.println("found prime:" + coinJam + " --" + bv);
                    primeFound = true;
                    addNewPrime(bv);
                    break;
                }
            }
            if (!primeFound) {
//                System.out.println("coinjam=" + coinJam + ": " + result);
                str += result + "\n";
                m++;
            }
            try {
                result = coinJam = getNextCoinJam(coinJam);
            } catch(RuntimeException e) {
                return "can not find more coinjam";
            }
        }
        
        return str.trim();
    }
}
