/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.chrywhy.codejam;
/**
 *
 * @author chry
 */
import java.math.BigInteger;
public class CoinJamBig {
    public static BigInteger[] primes = new BigInteger[100];
    public static int primeCount = 0;
    public static int MaxPrimeCount = 100;
    
    private static void addNewPrime(BigInteger p) {
        if (primeCount < MaxPrimeCount) {
            primes[primeCount++] = p;
        }
    }
    
    private static BigInteger findFirstDivisor(BigInteger n) {
        BigInteger m = n.divide(BigInteger.valueOf(2));
        int i;
        for (i=0; i<primeCount && primes[i].compareTo(m) <= 0; i++) {
            if (n.mod(primes[i]).compareTo(BigInteger.valueOf(0)) == 0) {
                return  primes[i];
            }
        }
        
        if(i==primeCount) {
            BigInteger p = primeCount == 0 ? BigInteger.valueOf(1) : primes[primeCount-1];
            while (p.compareTo(m) <= 0 && primeCount < MaxPrimeCount) { //if max prime is tried, do not try, deem it as prime
                p = findNextPrime(m, p);
                if (p.compareTo(m)<=0) {
                    if (n.mod(p).compareTo(BigInteger.valueOf(0)) == 0) {
                        return  p;
                    }
                }
            }
        }
        return BigInteger.valueOf(0);
    }
    
    public static BigInteger findNextPrime(BigInteger n, BigInteger p) {
        int i;
        p = p.add(BigInteger.valueOf(1));
        while (p.compareTo(n) <= 0) {
            BigInteger m = p.divide(BigInteger.valueOf(2));
            boolean isPrime = true;
            for (i=0; i<primeCount && primes[i].compareTo(m)<=0; i++) {
                if (p.mod(primes[i]).compareTo(BigInteger.valueOf(0)) == 0) {
                    isPrime = false;
                    break;
                }
            }
            if (isPrime) {
                break;
            }
            p = p.add(BigInteger.valueOf(1));
        }
        if (p.compareTo(n) <= 0) {
            addNewPrime(p);
        }
        return p;
    }
                            
    public static String getFirstCoinJam(int n) {
        if(n<2) {
            throw new IllegalArgumentException("CoinJam should at least 2 digits");
        }
        String s = "";
        for (int i=0; i<n-2;i++) {
            s += "0";
        }
        return "1" + s + "1";
    }

    public static String getNextCoinJam(String coinJam) {
        String middleStr = coinJam.substring(1, coinJam.length()-1);
        BigInteger nextMiddleValue = new BigInteger(middleStr, 2);
        nextMiddleValue = nextMiddleValue.add(BigInteger.valueOf(1));
        String nextMiddleStr = nextMiddleValue.toString(2);
        String leadZeros = "";
        int k = middleStr.length() - nextMiddleStr.length();
        if (k > 0) {
            for (int i=0; i<k ;i++) {
                leadZeros += "0";
            }
        } else if(k < 0) {
            throw new RuntimeException("This maximum codejam!");
        }
        return "1" + leadZeros + nextMiddleStr + "1";
    }

    public String testCase(String input) {
        String[] nj = input.split(" ");
        int k = 0;
        int n = 0;
        int j = 0;
        for (int i=0; i<nj.length; i++) {
            String s = nj[i].trim();
            if (!s.isEmpty()) {
                int v = Integer.parseInt(s);
                if (k ==0) {
                    n = v;
                    k++;
                } else {
                    j = v;
                }
            }
        }
        if (n==0 || j==0) {
            throw new RuntimeException("invalid input!");
        }
        String str = "";
        int m = 0;
        String coinJam = getFirstCoinJam(n);
        while (m < j) {
            String result = coinJam;
            boolean primeFound = false;
            for (int b=2; b<=10; b++) {
                BigInteger bv = new BigInteger(coinJam, b);
//                System.out.println("coinjam=" + coinJam + ",base=" + b + ",bv=" + bv);
                BigInteger d = findFirstDivisor(bv);
                if (d.compareTo(BigInteger.valueOf(0)) > 0) {
                    result += " " + d;
//                    System.out.println(result);
                } else {    //this is a prime
//                    System.out.println("found prime:" + coinJam + " --" + bv);
                    primeFound = true;
                    addNewPrime(bv);
                    break;
                }
            }
            if (!primeFound) {
//                System.out.println("coinjam=" + coinJam + ": " + result);
                str += result + "\n";
                m++;
            }
            try {
                result = coinJam = getNextCoinJam(coinJam);
            } catch(RuntimeException e) {
                return "can not find more coinjam";
            }
        }
        
        return str.trim();
    }
}
