/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */

package com.chrywhy.codejam;

import java.util.HashSet;
import java.util.Set;

/**
 *
 * @author chry
 */
public class Fractiles {    
    private int K;
    private int C;
    private int S;
    private Set[] leadPos;
    private boolean[] oneGoldSequence;
    
    public void init(int k, int c, int s) {
        K = k;
        C = c;
        S = s;
        leadPos = new Set[K];
        for (int i=0; i<k; i++) {
            leadPos[i] = new HashSet<Long>();
        }
    }
                    
    public static long power(long a, int n) {
        long r = a;
        long x = 1;
        while (n >= 1) {
            if ((n & 1) == 1) {
                x *= r;
            }
            n = n >> 1;
            if (n>=1) {
                r *= r;
            }
        }
        return x;
    }

    private void gotoNextSequence(int origIndexGold) {
        Set<Long> oldSet = leadPos[origIndexGold];
        Set<Long> newSet = new HashSet(oldSet.size() * 2);
        for (Long pos: oldSet) {
            long startPos = (pos -1) * K + 1;
            for (long i=0; i<K; i++) {
                if (i!=origIndexGold) {
                    newSet.add(startPos + i);
                }
            }
        }
        leadPos[origIndexGold] = newSet;
    }
    
    public void gotoFinalSequence() {
        for (int origIndexGold=0; origIndexGold<K; origIndexGold++) {  
            for (int i=1; i<C; i++) {
                gotoNextSequence(origIndexGold);
            }
        }
    }

    public boolean checkMatch(Set<Long> matchSet) {
        for (int i=0; i<K; i++) {
            if (leadPos[i].containsAll(matchSet)) {
                return false;
            }
        }
        return true;
    }
    
    public Set<Long> serachMatchSet(long n, int r) {  
        int i = 0;  
        long[] a = new long[r];  
        a[i] = 0;  
        while (true) {  
            if (a[i] < n) {  
                if (i == (r - 1)) {
                    Set<Long> matchSet = new HashSet(a.length);
                    for (int t=0; t<a.length;t++) {
                        matchSet.add(a[t] + 1);
                    }
                    if (checkMatch(matchSet)) {
                        return matchSet;
                    }
                    a[i]++;  
                } else {  
                    i++;  
                    a[i] = a[i - 1] + 1;  
                }  
            } else {  
                if (i == 0) {  
                    break;  
                }  
                i--;  
                a[i]++;  
            }  
        }
        return null;
    }  
      
    public Set<Long> findMatchSet(long n, int r) {
        Set<Long> matchSet = serachMatchSet(n, r);
        if (matchSet != null) {
            return matchSet;
        }
        return null;
    }
    
    public Set<Long> findTileSet() {
        long[] checkTiles = new long[S];
        gotoFinalSequence();
        boolean found = false;
        long totalPos = power(K, C);
        Set<Long> matchSet = findMatchSet(totalPos, S);
        return matchSet;
    }
            
    private void parseInput(String input) {
        String[] kcs = input.split(" ");
        int k = 0;
        int c = 0;
        int s = 0;
        int n = 0;
        for (int i=0; i<kcs.length; i++) {
            String str = kcs[i].trim();
            if (!str.isEmpty()) {
                int v = Integer.parseInt(str);
                if (n==0) {
                    k = v;
                    n++;
                } else if (n==1){
                    c = v;
                    n++;
                } else {
                    s = v;
                }
            }
        }
        if (k==0 || c==0 || s==0) {
            throw new RuntimeException("invalid input!");
        }
        init(k, c, s);
    }
    
    public String testCase(String input) {
        parseInput(input);
        String str = "";
        Set<Long> tilePos = findTileSet();
        if (tilePos == null) {
            str += " IMPOSSIBLE";
        } else {
            for (Long pos : tilePos) {
                str += " " + pos;
            }
        }
        return str.trim();
    }

    public static void main(String[] args) {
        System.out.println(power(2,59));
    }

}
