package qualification.pancake;

import java.io.*;
import java.util.*;
import java.text.*;
import java.math.*;

public class Pancake {
	private static final String PATH_IN = 
			"/home/chau/Documents/workspace/CodeJam2017/src/qualification/pancake/A-large.in";
	private static final String PATH_OUT = 
			"/home/chau/Documents/workspace/CodeJam2017/src/qualification/pancake/A-large.out";
	
	public static void main(String[] args) throws Exception {
		solve();
	}
	
	static void test() {
		int T = 1000;
		int maxLength = 15;
		Random r = new Random();
		for (int t = 1; t <= T; t++){
//			System.out.println(t);
			int L = r.nextInt(maxLength) + 1;
			int K = r.nextInt(L) + 1;
			
			StringBuilder sb = new StringBuilder();	
			for (int i = 0; i < L; i++) {
				sb.append(r.nextBoolean()? '+' : '-');
			}
			String begin = sb.toString();
			
			int actual = minFlips(begin, K);
			int expected = minFlipsSlow(begin, K);
			if (expected != actual) {
				System.out.println("error");
				System.out.println("Expected: " + expected + ", actual: " + actual);
				System.out.println("s: " + begin + ", K = " + K);
				return;
			}
		}
		System.out.println("success");
	}
	
	static void solve() throws Exception {
		Scanner sc = new Scanner(new FileInputStream(new File(PATH_IN)));
		PrintWriter pw = new PrintWriter(new File(PATH_OUT));
		
		int T = Integer.parseInt(sc.nextLine().trim());
		for (int t = 1; t <= T; t++) {
			String line =  sc.nextLine().trim();
			String[] parts = line.split(" ");
			int K = Integer.parseInt(parts[1]);
			int ans = minFlips(parts[0], K);
			
			String out = "Case #" + t + ": ";
			if (ans >= 0) {
				out += ans;
			} else {
				out += "IMPOSSIBLE";
			}
			
			System.out.println(out);
			pw.println(out);
		}
		
		pw.close();
		sc.close();
	}
	
	static int minFlips(String s, int K) {
		if (!s.contains("-")) {
			return 0;
		}
		
		int count = 0;
		char[] a = s.toCharArray();
		
		int i = 0;
		while (i <= a.length - K) {
			if (a[i] == '-') {
				count++;
				
				for (int j = i; j < i + K; j++) {
					a[j] = (a[j] == '-')? '+' : '-';
				}
			}
			
			i++;
		}

		String str = new String(a);
		if (str.contains("-")) {
			return -1;
		}
		return count;
	}
	
	
	static int minFlipsSlow(String begin, int K) {
		Queue<String> queue = new ArrayDeque<>();
		Map<String, String> mapPrev = new HashMap<>();
		
		mapPrev.put(begin, null);
		queue.add(begin);
		
		while (!queue.isEmpty()) {
			String curr = queue.poll();
			if (!curr.contains("-")) {
				return processOutput(curr, mapPrev);
			}
			
			for (int start = 0; start <= begin.length() - K; start++) {
				String next = flip(curr, K, start);
				if (!mapPrev.containsKey(next)) {
					mapPrev.put(next, curr);
					queue.add(next);
				}
			}
		}
		
		return -1;
	}
	
	static String flip(String s, int K, int start) {
		char[] a = s.toCharArray();
		for (int i = start; i < start + K; i++) {
			a[i] = (a[i] == '+')? '-' : '+';
		}
		return new String(a);
	}
	
	
	static int processOutput(String s, Map<String, String> mapPrev) {
		int count = 0;
		List<String> steps = new ArrayList<>();
		String curr = s;
		
		while (curr != null) {
			steps.add(curr);
			String prev = mapPrev.get(curr);
//			System.out.println(prev);
			curr = prev;
			
			if (curr != null) {
				count++;
			}
		}
		
		return count;
	}

}
