package round1B.steed;

import java.io.*;
import java.util.*;
import java.text.*;
import java.math.*;

public class Steed {
	private static final String PATH_IN = 
			"/home/chau/Documents/workspace/CodeJam2017/src/round1B/steed/A-small-attempt0.in";
	private static final String PATH_OUT = 
			"/home/chau/Documents/workspace/CodeJam2017/src/round1B/steed/A-small-attempt0.out";
	
	public static void main(String[] args) throws Exception {
		solve();
	}
	
	static void solve() throws Exception {
		PrintWriter pw = new PrintWriter(new File(PATH_OUT));
		Input in = new Input(new FileInputStream(new File(PATH_IN)));
		
		int T = in.nextInt();
		for (int t = 1; t <= T; t++) {
			int D = in.nextInt();
			int N = in.nextInt();
			int[] initialPos = new int[N];
			int[] speeds = new int[N];
			
			for (int i = 0; i < N; i++) {
				initialPos[i] = in.nextInt();
				speeds[i] = in.nextInt();
			}
			double v = getSpeed(D, initialPos, speeds);
			DecimalFormat formatter = new DecimalFormat("#0.000000");
			
			String out = "Case #" + t + ": " + formatter.format(v);
			System.out.println(out);
			pw.println(out);
		}
		
		pw.close();
		in.close();
	}
	
	static double getSpeed(int D, int[] initialPos, int[] speeds) {
		double minSpeed = Double.MAX_VALUE;
		
		for (int i = 0; i < speeds.length; i++) {
			int s = D - initialPos[i];
			double t = (double) s / speeds[i];
			double v = (double) D / t;
			minSpeed = Math.min(minSpeed, v);
		}
		
		return minSpeed;
	}
	
	static class Horse {
		int pos;
		int speed;
	}
	
	static class Input {
		private BufferedReader reader;
		private StringTokenizer stt;

		public Input(InputStream stream) {
			reader = new BufferedReader(new InputStreamReader(stream));
		}

		public String nextLine() {
			try {
				return reader.readLine();
			} catch (IOException e) {
				return null;
			}
		}

		public String nextString() {
			while (stt == null || !stt.hasMoreTokens()) {
				String line = nextLine();
				if (line == null)
					return null;

				stt = new StringTokenizer(line);
			}
			return stt.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextString());
		}

		public long nextLong() {
			return Long.parseLong(nextString());
		}

		public String next() {
			return nextString();
		}

		public void close() {
			if (reader != null) {
				try {
					reader.close();
				} catch (Exception e) {}
			}
		}
	}
}
