package round1B.stable;

import java.io.*;
import java.util.*;

import round1B.stable.Stable.Color;

import java.text.*;
import java.math.*;

public class Stable {
	private static final String PATH_IN = 
			"/home/chau/Documents/workspace/CodeJam2017/src/round1B/stable/B-small-attempt0.in";
	private static final String PATH_OUT = 
			"/home/chau/Documents/workspace/CodeJam2017/src/round1B/stable/B-small-attempt0.out";
	
	public static void main(String[] args) throws Exception {
		solve();
//		int N = 6;
//		int[] colors = {2, 0, 2, 0, 2, 0};
//		System.out.println(solve(N, colors));
	}
	
	static void solve() throws Exception {
		PrintWriter pw = new PrintWriter(new File(PATH_OUT));
		Input in = new Input(new FileInputStream(new File(PATH_IN)));
		
		int T = in.nextInt();
		for (int t = 1; t <= T; t++) {
			int[] colors = new int[6];
			int N = in.nextInt();
			
			for (int i = 0; i < 6; i++) {
				colors[i] = in.nextInt();
			}
			
			String ans = solve(N, colors);
			
			String out = "Case #" + t + ": " + ans;
			System.out.println(out);
			pw.println(out);
		}
		
		pw.close();
		in.close();
	}
	
	static Comparator<Color> cmp = new Comparator<Stable.Color>() {
		
		@Override
		public int compare(Color a, Color b) {
			return b.count - a.count;
		}
	};
	
	static String solve(int N, int[] colors) {
//		int R = colors[0];
//		int Y = colors[2];
//		int B = colors[4];
		
		Color[] a = new Color[3];
		a[0] = new Color('R', colors[0]);
		a[1] = new Color('Y', colors[2]);
		a[2] = new Color('B', colors[4]);
		
		Arrays.sort(a, cmp);
		
		char[] ans = new char[N];
		int left = 0;
		int right = N - 1;
		
		ans[left++] = a[0].color;
		a[0].count--;
		Arrays.sort(a, cmp);
		
		if (left > right) {
			return "IMPOSSIBLE";
		}
		
		ans[right--] = a[1].color;
		a[1].count--;
		Arrays.sort(a, cmp);
		
		while (left <= right) {
			int i = 0;
			
			while (i < a.length && (a[i].count <= 0 ||
					(a[i].color == ans[left-1] || a[i].color == ans[left+1]))) {
				i++;
			}
			if (i == a.length) {
				return "IMPOSSIBLE";
			}
			ans[left++] = a[i].color;
			a[i].count--;
			Arrays.sort(a, cmp);
			
			if (left <= right) {
				i = 0;
				while (i < a.length && (a[i].count <= 0 ||
						(a[i].color == ans[right-1] || a[i].color == ans[right+1]))) {
					i++;
				}
				if (i == a.length) {
					return "IMPOSSIBLE";
				}
				ans[right--] = a[i].color;
				a[i].count--;
				Arrays.sort(a, cmp);
			}
		}
		
		return new String(ans);
	}
	
	static class Color {
		char color;
		int count;
		
		public Color(char c, int count) {
			this.color = c;
			this.count = count;
		}

		@Override
		public String toString() {
			return "Color [c=" + color + ", count=" + count + "]";
		}
	}
	
	static class Input {
		private BufferedReader reader;
		private StringTokenizer stt;

		public Input(InputStream stream) {
			reader = new BufferedReader(new InputStreamReader(stream));
		}

		public String nextLine() {
			try {
				return reader.readLine();
			} catch (IOException e) {
				return null;
			}
		}

		public String nextString() {
			while (stt == null || !stt.hasMoreTokens()) {
				String line = nextLine();
				if (line == null)
					return null;

				stt = new StringTokenizer(line);
			}
			return stt.nextToken();
		}

		public int nextInt() {
			return Integer.parseInt(nextString());
		}

		public long nextLong() {
			return Long.parseLong(nextString());
		}

		public String next() {
			return nextString();
		}

		public void close() {
			if (reader != null) {
				try {
					reader.close();
				} catch (Exception e) {}
			}
		}
	}
}
