package qualification.tidy;

import java.io.*;
import java.util.*;
import java.text.*;
import java.math.*;

public class Tidy {
	private static final String PATH_IN = 
			"/home/chau/Documents/workspace/CodeJam2017/src/qualification/tidy/B-small-attempt0.in";
	private static final String PATH_OUT = 
			"/home/chau/Documents/workspace/CodeJam2017/src/qualification/tidy/B-small-attempt0.out";
	
	static final TreeSet<Long> set = generate(999999999999999999L);
	
	public static void main(String[] args) throws Exception {
		solve();
	}
	
	static void solve() throws Exception {
		Scanner sc = new Scanner(new FileInputStream(new File(PATH_IN)));
		PrintWriter pw = new PrintWriter(new File(PATH_OUT));
		
		int T = Integer.parseInt(sc.nextLine().trim());
		for (int t = 1; t <= T; t++) {
			long N = Long.parseLong(sc.nextLine().trim());
			String out = "Case #" + t + ": " + findTidy(N);
			
			System.out.println(out);
			pw.println(out);
		}
		
		pw.close();
		sc.close();
	}
	
	static long findTidy(long N) {
		return set.floor(N);
	}
	
	static TreeSet<Long> generate(long max) {
		TreeSet<Long> set = new TreeSet<>();
		for (long num = 1; num <= 9; num++) {
			dfs(set, num, max);
		}
		return set;
	}
	
	static void dfs(TreeSet<Long> set, long curr, long max) {
		if (curr > max) {
			return;
		}
		
		set.add(curr);
		long digit = curr % 10l;
		
		while (digit <= 9) {
			long next = curr * 10l + digit;
//			System.out.println(next);
			dfs(set, next, max);
			digit++;
		}
	}

}
