package qualification.stall;

import java.io.*;
import java.util.*;

import qualification.stall.Bathroom.Stall;

import java.text.*;
import java.math.*;

public class Bathroom {
	private static final String PATH_IN = 
			"/home/chau/Documents/workspace/CodeJam2017/src/qualification/stall/C-small-1-attempt0.in";
	private static final String PATH_OUT = 
			"/home/chau/Documents/workspace/CodeJam2017/src/qualification/stall/C-small-1-attempt0.out";

	public static void main(String[] args) throws Exception {
		solve();
	}
	
	static void solve() throws Exception {
		Scanner sc = new Scanner(new FileInputStream(new File(PATH_IN)));
		PrintWriter pw = new PrintWriter(new File(PATH_OUT));
		
		int T = sc.nextInt();
		for (int t = 1; t <= T; t++) {
			long N = sc.nextLong();
			long K = sc.nextLong();
			String out = "Case #" + t + ": " + lastPos(N, K);
			
			System.out.println(out);
			pw.println(out);
		}
		
		pw.close();
		sc.close();
	}

	static String lastPos(long N, long K) {
		TreeSet<Long> busySet = new TreeSet<Long>();
		busySet.add(-1l);
		busySet.add(N);
		Stall last = null;
		
		for (long k = 0; k < K; k++) {
			PriorityQueue<Stall> queue = new PriorityQueue<>(cmpQueue);
			
			for (long i = 0; i < N; i++) {
				if (!busySet.contains(i)) {
					Stall stall = new Stall(i);
					stall.ls = i - busySet.lower(i) - 1;
					stall.rs = busySet.higher(i) - i - 1;
					stall.min = Math.min(stall.ls, stall.rs);
					stall.max = Math.max(stall.ls, stall.rs);
					
					queue.add(stall);
				}
			}
			
			Stall stall = queue.poll();
			last = stall;
			busySet.add(stall.index);
		}
		
		return last.max + " " + last.min;
	}
	
	static Comparator<Stall> cmpQueue = new Comparator<Bathroom.Stall>() {
		
		@Override
		public int compare(Stall a, Stall b) {
			if (a.min != b.min) {
				return Long.compare(a.min, b.min) * -1;
			}
			
			if (a.max != b.max) {
				return Long.compare(a.max, b.max) * -1;
			}
			
			return Long.compare(a.index, b.index);
		}
	};
	
	static class Stall {
		long index;
		long ls;
		long rs;
		long min;
		long max;
		
		public Stall(long index) {
			this.index = index;
		}
	}
}
