import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.math.BigInteger;


public class ProblemA {

	public static void main( String[] args ){
		BufferedReader reader = null;
		try{
			reader = new BufferedReader( new FileReader("A-large.in"));
		}catch( FileNotFoundException e ){
			e.printStackTrace();
		}
		
		int testCase = 0;
		try{
			testCase = Integer.parseInt( reader.readLine() );
		}catch(Exception e){
			e.printStackTrace();
		}
		
		for( int i = 0; i < testCase; i++ ){
			String line = null;
			
			try{
				line = reader.readLine();
			}catch (IOException e ){
				e.printStackTrace();
			}
			
			String[] valuesString = line.split(" ");
			
			int sMax = Integer.parseInt(valuesString[0]);	//MAX shyness level
			//int numPeople = Integer.parseInt(valuesString[1]);	//number of people for each shyness level starting from 0,1,2...
			
			BigInteger numPeople = new BigInteger(valuesString[1]);
			
			int[] peopleArray = getDigitsOf(numPeople, sMax+1);
			
			int TotalShynessLevel = 0;
			int friend = 0;
			
			for ( int j = 0; j < peopleArray.length; j++ ){
				
				while(TotalShynessLevel < j){
					friend++;
					TotalShynessLevel++;
				}
				TotalShynessLevel += peopleArray[j];
			}
			
			System.out.println( "Case #" +(i+1)+ ": " +friend);
			
		}
		
	}
	
	public static int[] getDigitsOf(BigInteger num, int digitCount)
	{	
		String divisor = "10";
		String comparator = "0";
		if( num.compareTo(new BigInteger(comparator)) < 0 )
			digitCount--;
		
		int[] result = new int[digitCount];
		
		while(digitCount-- > 0){
			String temp = num.remainder(new BigInteger(divisor)).toString();
			result[digitCount] = Integer.parseInt(temp);
			num = num.divide( new BigInteger(divisor));
		}
		
		return result;
	}
}
