import java.io.File;
import java.io.FileInputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.Reader;
import java.io.StringWriter;
import java.io.Writer;
import java.util.TreeSet;


public class AlienLang {

	private static final int DEFAULT_BUFFER_SIZE = 1024 * 4;
	 
	public static String readFileToString(String filePath) throws IOException{
		InputStreamReader is = new InputStreamReader(new FileInputStream(new File(filePath)));
		StringWriter sw = new StringWriter();
		copy(is,sw);
		return sw.toString();
	}
	
	public static int copy(Reader input, Writer output) throws IOException {
        long count = copyLarge(input, output);
        if (count > Integer.MAX_VALUE) {
            return -1;
        }
        return (int) count;
    }

    public static long copyLarge(Reader input, Writer output) throws IOException {
        char[] buffer = new char[DEFAULT_BUFFER_SIZE];
        long count = 0;
        int n = 0;
        while (-1 != (n = input.read(buffer))) {
            output.write(buffer, 0, n);
            count += n;
        }
        return count;
    }
    
	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception{
		String[] a = readFileToString("sample.in").split("\n");
		String[] allocate = a[0].split(" ");
		TreeSet<String>[] alSet = new TreeSet[Integer.valueOf(allocate[0].trim()).intValue()];
		for (int i=0; i < alSet.length; i++ ){
			alSet[i] = new TreeSet<String>();
		}
		
		int existsLang = Integer.valueOf(allocate[1].trim()).intValue();
		for (int i=0; i <existsLang ; i++){
			String exWord = a[1+i].trim();
			for (int y = 0; y < exWord.length(); y++)
			{
				//System.out.println(exWord.substring(0,y+1));
				alSet[y].add( exWord.substring(0,y+1) );
			}
		}
		
		int testCase = Integer.valueOf(allocate[2].trim()).intValue();
		for (int i=0; i <testCase ; i++){
			String testWord = a[1 + existsLang + i].trim();
			int result = recurse(testWord, "", alSet, 0);
			System.out.println("Case #"+ (i+1) +": " + result);
		}
	}
	public static int recurse(String ask,String salt, TreeSet<String>[] alSet, int alSetIndex){
		int result = 0;
		if(ask.indexOf("(") == 0)
		{
			int parent = ask.indexOf(")");
			String temp = ask.substring(1,parent);
			ask = ask.substring(parent+1);
			for (int i = 0; i < temp.length(); i++)
			{
				String c = String.valueOf(temp.charAt(i));
				if( alSet[alSetIndex].contains(salt + c))
					result += recurse(ask, salt + c, alSet , alSetIndex+1); 
			}
		} else {
			
			if (alSetIndex == alSet.length)
				return 1;

			String c = String.valueOf(ask.charAt(0));
			ask = ask.substring(1);
			if (alSet[alSetIndex].contains(salt + c))
				result += recurse(ask, salt + c, alSet , alSetIndex+1);
		}
		
		return result;
	}

}
