import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class CoinJamSmall {
	private static int[] factors = new int[11];
	private static List<Integer> primes = new ArrayList<>();
	private static int left;
	
	private static int getDivisor(long num)
	{
		long max = (long) Math.sqrt(num);
		for (int j = 0; j < primes.size(); j++) {
			int prime = primes.get(j);
			if ((num % prime) == 0) {
				return prime;
			}
			else if (prime > max) {
				break;
			}
		}
		return -1;
	}
	
	private static int getDivisorOnDemand(long num)
	{
		long max = (long) Math.sqrt(num);
		if ((num & 1) == 0) {
			return 2;
		}
		for (int j = 3; j <= max; j += 2) {
			if ((num % j) == 0) {
				return j;
			}
		}
		return -1;		
	}
	
	private static void go(boolean[] bits, int bit)
	{
		if (left == 0) {
			// Nothing more to do.
			return;
		}
		if (bit + 1 < bits.length) {
			for (int i = 0; i < 2; i++) {
				bits[bit] = (i == 0) ? false : true;
				go(bits, bit + 1);
			}
		}
		else {
			boolean ok = true;
			for (int base = 2; base <= 10; base++) {
				long num = 0;
				for (int j = 0; j < bits.length; j++) {
					num = num * base;
					if (bits[j]) {
						num += 1;
					}
				}
				int divisor = getDivisorOnDemand(num);
				if (divisor == -1) {
					// It's prime.
					ok = false; break;
				}
				else {
					factors[base] = divisor;
				}
			}
			if (ok) {
				left--;
				for (int i = 0; i < bits.length; i++) {
					System.out.print(bits[i] ? 1 : 0);
				}
				for (int base = 2; base <= 10; base++) {
					System.out.print(" ");
					System.out.print(factors[base]);
				}
				System.out.println();
			}
		}
	}

	public static void main(String[] args)
	{
		// Start by computing all the primes up to 10^8
		/*primes.add(2);
		primes.add(3);
		for (int i = 5; i < 100000000; i+= 2) {
			boolean isprime = true;
			for (int k : primes) {
				if ((i % k) == 0) {
					isprime = false;
					break;
				}
			}
			if (isprime) {
				primes.add(i);
				System.err.println(i);
			}
		}
		System.err.println("Computed primes");*/
		Scanner sc = new Scanner(System.in);
		int T = sc.nextInt();
		for (int caseNum = 1; caseNum <= T; caseNum++) {
			int N = sc.nextInt();
			int J = sc.nextInt();
			boolean[] bits = new boolean[N];
			bits[0] = bits[N - 1] = true;
			System.out.println("Case #" + caseNum + ":");
			left = J;
			go(bits, 1);
		}
	}
}
