package dijktstra;

import java.util.Scanner;

public class dijkstra2 {
	public static int apply(int cur, char c)
	throws Exception
	{
		switch (c) {
		case 'i': return apply(cur, 2);
		case 'j': return apply(cur, 3);
		case 'k': return apply(cur, 4);
		default: throw new Exception();
		}
	}
	
	public static int apply(char c, int cur)
	throws Exception
	{
		switch (c) {
		case 'i': return apply(2, cur);
		case 'j': return apply(3, cur);
		case 'k': return apply(4, cur);
		default: throw new Exception();
		}
	}
	
	public static int apply(int cur, int c)
	throws Exception
	{
		if (c == 1) { return cur; }
		if (c == -1) { return -cur; }
		int mul = 1;
		if (cur < 0) {
			mul = -1;
			cur = -cur;
		}
		if (c < 0) {
			mul *= -1;
			c = -c;
		}
		switch (cur) {
		case 1:
			switch (c) {
			case 2: cur = 2; break;
			case 3: cur = 3; break;
			case 4: cur = 4; break;
			default: throw new Exception();
			}
			break;
		case 2:
			switch (c) {
			case 2: cur = -1; break;
			case 3: cur = 4; break;
			case 4: cur = -3; break;
			default: throw new Exception("" + c);
			}
			break;
		case 3:
			switch (c) {
			case 2: cur = -4; break;
			case 3: cur = -1; break;
			case 4: cur = 2; break;
			default: throw new Exception();
			}
			break;
		case 4:
			switch (c) {
			case 2: cur = 3; break;
			case 3: cur = -2; break;
			case 4: cur = -1; break;
			default: throw new Exception();
			}
			break;
		default: throw new Exception();
		}
		return cur * mul;
		
	}
	
	public static void main(String[] args)
	    throws Exception
	{
		Scanner sc = new Scanner(System.in);
		int t = sc.nextInt();
		for (int caseNum = 1; caseNum <= t; caseNum++) {
			long l = sc.nextLong();
			long x = sc.nextLong();
			String s = sc.next();

			System.out.print("Case #" + caseNum + ": ");

			// Figure out if we can create an i
			int cur = 1;
			long i = 0;
			long a;
			for (a = 0; a < 4; a++) {
				for (i = 0; i < s.length(); i++) {
					cur = apply(cur, s.charAt((int) i));
					if (cur == 2) {
						break;
					}
				}
				if (cur == 2) {
					break;
				}
			}
			if (cur != 2) {
				// No i possible.
				System.out.println("NO");
				continue;
			}
			
			// Figure out if we can create a k
			long k = 0;
			long m;
			cur = 1;
			for (m = 0; m < 4; m++) {
				for (k = s.length() - 1; k >= 0; k--) {
					cur = apply(s.charAt((int)k), cur);
					if (cur == 4) {
						break;
					}
				}
				if (cur == 4) {
					break;
				}
			}
			
			// Now figure out whether the middle bit is a j.
			cur = 1;
			long full = x - m - a - 2;
			//System.err.println(i + " " + a + " " + k + " " + m + " " + full);
			if (full < 0) {
				for (i++; i < k; i++) {
					cur = apply(cur, s.charAt((int)i));
				}
			}
			else {
				for (i++; i < s.length(); i++) {
					cur = apply(cur, s.charAt((int)i));
				}
				int c = 1;
				for (i = 0; i < s.length(); i++) {
					c = apply(c, s.charAt((int)i));
				}
				
				full = full % 4;
				for (i = 0; i < full; i++) {
					cur = apply(cur, c);
				}
				for (i = 0; i < k; i++) {
					cur = apply(cur, s.charAt((int)i));
				}
			}
			System.out.println(cur == 3 ? "YES" : "NO");
		}
	}
}
