package round.two;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Scanner;

public class B
{
   static int size;
   static int [] array;
   static int [] sorted;
   static int [] inverse;
   public static void main(String[] args) throws FileNotFoundException
   {
      System.setOut(new PrintStream(new File("small.out")));
      Scanner scan = new Scanner(new File("small.in"));

      int numCases = scan.nextInt();
      for (int z = 1; z <= numCases; z++)
      {
         size = scan.nextInt();
         array = new int[size];
         sorted = new int[size];
         inverse = new int[size];
         for (int i = 0; i < size; i++)
         {
            array[i] = scan.nextInt();
            sorted[i] = array[i];
         }
         
         Arrays.sort(sorted);
         for (int i = 0; i < sorted.length; i++)
            inverse[i] = sorted[size - i - 1];
         
         int best = Integer.MAX_VALUE / 100;
         for (int i = 0; i <= size; i++)
         {
            best = Math.min(best, evaluate(i));
         }
         
         System.out.println("Case #" + z + ": " + best);
      }

      scan.close();
   }
   
   private static int evaluate(int pivot)
   {
      return ascending(0, pivot) + descending(pivot, size);
   }

   private static int ascending(int start, int end)
   {
      if (start == end) return 0;
      
      int [] subArray = new int[end - start];
      int [] sortedSub = new int[end - start];
      for (int i = start; i < end; i++)
      {
         subArray[i] = array[i];
         sortedSub[i] = array[i];
      }
      
      Arrays.sort(sortedSub);
      
      int count = 0;
      for (int i = 0; i < sortedSub.length; i++)
      {
         for (int j = i; j < subArray.length; j++)
         {
            if (subArray[j] == sortedSub[i])
            {
               for (int k = j; k > i; k--)
               {
                  int temp = subArray[k];
                  subArray[k] = subArray[k-1];
                  subArray[k-1] = temp;
                  count++;
               }
            }
         }
      }
//      System.out.println(start + " " + end + " " + count);
      
      return count;
   }

   private static int descending(int start, int end)
   {
      if (start == end) return 0;
//      System.out.println(start + " " + end);
      
      int [] subArray = new int[end - start];
      int [] sortedSub = new int[end - start];
      for (int i = start; i < end; i++)
      {
         subArray[i - start] = array[i];
         sortedSub[i - start] = array[i];
      }
      
//      Arrays.sort(sortedSub);
      for (int i = 0; i < sortedSub.length / 2; i++)
      {
         int temp = sortedSub[i];
         sortedSub[i] = sortedSub[sortedSub.length - i - 1];
         sortedSub[sortedSub.length - i - 1] = temp;
      }
//      System.out.println(Arrays.toString(sortedSub));
      
      int count = 0;
      for (int i = 0; i < sortedSub.length; i++)
      {
         for (int j = i; j < subArray.length; j++)
         {
            if (subArray[j] == sortedSub[i])
            {
               for (int k = j; k > i; k--)
               {
                  int temp = subArray[k];
                  subArray[k] = subArray[k-1];
                  subArray[k-1] = temp;
                  count++;
               }
            }
         }
      }
      
      return count;
   }

}

