import java.io.*;
import java.util.*;

public class CrossingTheRoad
{
	static int N, M;
	static boolean [][][] visited;
	static long [][] S;
	static long [][] W;
	static long [][] T;
	public static void main (String [] args) throws IOException
	{
		Scanner scan = new Scanner(new File("small.in"));
		
		int numCases = scan.nextInt();
		
		for (int z = 1; z <= numCases; z++)
		{
			N = scan.nextInt();
			M = scan.nextInt();
			
			visited = new boolean[N][M][4];
			S = new long[N][M];
			W = new long[N][M];
			T = new long[N][M];
			
			String junk = scan.nextLine();
			
			for (int i = 0; i < N; i++)
			{
				for (int j = 0; j < M; j++)
				{
					S[i][j] = scan.nextInt();
					W[i][j] = scan.nextInt();
					T[i][j] = scan.nextInt()%(S[i][j]+W[i][j]);
				}
			}
			
			PriorityQueue<State> q = new PriorityQueue<State>();
			q.add(new State(N-1, 0, 0, 0));
			
			long ret = 0;
			while (q.size() > 0)
			{
				State c = q.poll();
				if (c.i == 0 && c.j == M-1 && c.pos == 3)
				{
					ret = c.gen;
					break;
				}
				
				visited[c.i][c.j][c.pos] = true;
				
				if (c.pos == 0)
				{
					long cur = (c.gen-T[c.i][c.j]+S[c.i][c.j]+W[c.i][c.j])%(S[c.i][c.j]+W[c.i][c.j]);
					if (cur < S[c.i][c.j])
					{
						if (!visited[c.i][c.j][2])
						{
							q.add(new State(c.i, c.j, 2, c.gen+1));
							visited[c.i][c.j][2] = true;
						}
					}
					else
					{
						if (!visited[c.i][c.j][1])
						{
							q.add(new State(c.i, c.j, 1, c.gen+1));
							visited[c.i][c.j][1] = true;
						}
					}
					if (c.i+1 < N)
						q.add(new State(c.i+1, c.j, 2, c.gen+2));
					if (c.j > 0)
					{
						q.add(new State(c.i, c.j-1, 1, c.gen+2));
					}
				}
				else if (c.pos == 1)
				{
					long cur = (c.gen-T[c.i][c.j]+S[c.i][c.j]+W[c.i][c.j])%(S[c.i][c.j]+W[c.i][c.j]);
					if (cur < S[c.i][c.j])
					{
						if (!visited[c.i][c.j][3])
						{
							q.add(new State(c.i, c.j, 3, c.gen+1));
							visited[c.i][c.j][3] = true;
						}
					}
					else
					{
						if (!visited[c.i][c.j][0])
						{
							q.add(new State(c.i, c.j, 0, c.gen+1));
							visited[c.i][c.j][0] = true;
						}
					}
						
					if (c.i+1 < N)
						q.add(new State(c.i+1, c.j, 3, c.gen+2));
						
					if (c.j+1 < M)
						q.add(new State(c.i, c.j+1, 0, c.gen+2));
				}
				else if (c.pos == 2)
				{
					long cur = (c.gen-T[c.i][c.j]+S[c.i][c.j]+W[c.i][c.j])%(S[c.i][c.j]+W[c.i][c.j]);
					if (cur < S[c.i][c.j])
					{
						if (!visited[c.i][c.j][0])
						{
							q.add(new State(c.i, c.j, 0, c.gen+1));
							visited[c.i][c.j][0] = true;
						}
					}
					else
					{
						if (!visited[c.i][c.j][3])
						{
							q.add(new State(c.i, c.j, 3, c.gen+1));
							visited[c.i][c.j][3] = true;
						}
					}
						
					if (c.i > 0)
					{
						q.add(new State(c.i-1, c.j, 0, c.gen+2));
					}
					if (c.j > 0)
					{
						q.add(new State(c.i, c.j-1, 3, c.gen+2));
					}
				}
				else
				{
					long cur = (c.gen-T[c.i][c.j]+S[c.i][c.j]+W[c.i][c.j])%(S[c.i][c.j]+W[c.i][c.j]);
					if (cur < S[c.i][c.j])
					{
						if (!visited[c.i][c.j][1])
						{
							q.add(new State(c.i, c.j, 1, c.gen+1));
							visited[c.i][c.j][1] = true;
						}
					}
					else
					{
						if (!visited[c.i][c.j][2])
						{
							q.add(new State(c.i, c.j, 2, c.gen+1));
							visited[c.i][c.j][2] = true;
						}
					}
					
					if (c.i-1 >= 0)
					{
							q.add(new State(c.i-1, c.j, 1, c.gen+2));
					}
					if (c.j+1 < M)
					{
							q.add(new State(c.i, c.j+1, 2, c.gen+2));
					}
				}
				q.add(new State(c.i, c.j, c.pos, c.gen+1));
			}
			
			System.out.println("Case #" + z+ ": " + ret);
		}
	}
}

class State implements Comparable<State>
{
	public int i, j, pos;
	public long gen;
	
	public State(int i, int j, int pos, long gen)
	{
		this.i = i;
		this.j = j;
		this.pos = pos;
		this.gen = gen;
	}
	
	public int compareTo(State s)
	{
		if (this.gen > s.gen)
			return 1;
		else if (this.gen < s.gen)
			return -1;
		return 0;
	}
}