import java.io.*;
import java.util.*;
import java.math.*;

class D
{
	static Plant [] plants;
	static int N;
	public static void main (String [] args) throws IOException
	{
		Scanner scan = new Scanner(new File("small.in"));
		
		int numCases = scan.nextInt();
		for(int z = 1; z <= numCases; z++)
		{
			N = scan.nextInt();
			plants = new Plant[N];
			
			for (int i = 0; i < N; i++)
				plants[i] = new Plant(scan.nextInt(), scan.nextInt(), scan.nextInt());
				
			System.out.printf("Case #%d: %f\n", z, solve());
		}	
	}
	
	static double solve()
	{
		if (N == 1)
			return plants[0].r;
		if (N == 2)
			return Math.max(plants[0].r, plants[1].r);
		
		double ret = 1e9;
		for (int i = 0; i < N; i++)
		{
			for (int j = i+1; j < N; j++)
			{
				ret = Math.min(ret, Math.max(getRadius(plants[i], plants[j]), plants[N-i-j].r));
			}
		}
		
		return ret;
	}
	
	static double getRadius(Plant a, Plant b)
	{
		double sx, sy, ex, ey;
		
		double dist = Math.hypot(a.x-b.x, a.y-b.y);
		double vx = (b.x-a.x)/dist;
		double vy = (b.y-a.y)/dist;
		
		ex = b.x + vx*b.r;
		ey = b.y + vy*b.r;
		
		vx = (a.x-b.x)/dist;
		vy = (a.y-b.y)/dist;
		
		sx = a.x + vx*a.r;
		sy = a.y + vy*a.r;
		
		return Math.hypot(sx-ex, sy-ey)/2.0;
	}
}

class Plant 
{
	double x, y, r;
	
	public Plant(double x, double y, double r)
	{
		this.x = x;
		this.y = y;
		this.r = r;
	}
}