import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.List;

public class DeceitfulWar {
	public static void main(String[] args)
	{
		DeceitfulWar g = new DeceitfulWar();
		g.start();
	}

	private int[] compute(List<Double> blockNaomi, List<Double> blockKen){
		Collections.sort(blockNaomi);
		Collections.sort(blockKen);
		int[] result = new int[2];
		result[0] = dWar(blockNaomi, blockKen);
		result[1] = war(blockNaomi, blockKen);
		return result;
	}
	
	private int dWar(final List<Double> blockNaomi, final List<Double> blockKen){
		List<Double> blockNaomi1 = copyList(blockNaomi);
		List<Double> blockKen1 = copyList(blockKen);
		int scoreNaomi = 0;
		int size = blockNaomi1.size();

		Collections.reverse(blockNaomi1);
		Collections.reverse(blockKen1);
		for(int i = 0; i < size; i++){
			double chooseNaomi = blockNaomi1.remove(0);
			
			for(Double d : blockKen1){
				if(chooseNaomi > d){
					blockKen1.remove(d);
					scoreNaomi++;
					break;
				}
			}
		}
		return scoreNaomi;
	}
	
	private int war(final List<Double> blockNaomi, final List<Double> blockKen){
		List<Double> blockNaomi1 = copyList(blockNaomi);
		List<Double> blockKen1 = copyList(blockKen);
		int scoreNaomi = 0;
		int size = blockNaomi1.size();
		
		for(int i = 0; i < size; i++){
			double chooseNaomi = blockNaomi1.remove(0);
			boolean hasGreater = false;
			for(int j = 0; j < blockKen1.size(); j++){
				if(blockKen1.get(j) > chooseNaomi){
					hasGreater = true;
					blockKen1.remove(j);
					break;
				}
			}
			if(!hasGreater){
				scoreNaomi++;
			}
		}
		return scoreNaomi;
	}
	
	private List<Double> copyList(final List<Double> list){
		List<Double> copy= new ArrayList<Double>();
		for(Double d : list){
			copy.add(d);
		}
		return copy;
	}
	
	private void start(){
		FileInputStream fin;
		FileOutputStream fout;
		
		try{
			fin = new FileInputStream("D-large.in");
			InputStreamReader r = new InputStreamReader(fin);		
			BufferedReader br = new BufferedReader(r);
			
			fout = new FileOutputStream("D-large.out");
			OutputStreamWriter w = new OutputStreamWriter(fout);		
			BufferedWriter bw = new BufferedWriter(w);
			
			int round = Integer.parseInt(br.readLine());
			
			for(int i = 0; i < round; i++){
				int n = Integer.parseInt(br.readLine());
				List<Double> blockNaomi = new ArrayList<Double>();
				List<Double> blockKen = new ArrayList<Double>();
				
				String tmp = br.readLine();
				String tmp2[] = new String[n];
				tmp2 = tmp.split(" ");
				for(String s : tmp2){
					blockNaomi.add(Double.parseDouble(s));
				}
				tmp = br.readLine();
				tmp2 = new String[n];
				tmp2 = tmp.split(" ");
				for(String s : tmp2){
					blockKen.add(Double.parseDouble(s));
				}
				
				int[] result = new int[2];
				result = compute(blockNaomi, blockKen);
				bw.append("Case #" + (i+1) + ": " + result[0] + " " + result[1]);
				bw.newLine();
			}
			br.close();
			bw.flush();
			bw.close();			
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}	
	}
}
