import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.List;

public class MagicTrick {
	int COL_NUMBER = 4;
	int ROW_NUMBER = 4;

	public static void main(String[] args)
	{
		MagicTrick g = new MagicTrick();
		
		g.start();
	}

	private String compute(int[][] arrangement1, int[][] arrangement2, int ans1, int ans2){
		List<Integer> possible1 = new ArrayList<Integer>();
		for(int i = 0; i < 4; i++){
			possible1.add(arrangement1[ans1-1][i]);
		}
		
		List<Integer> possible2 = new ArrayList<Integer>();
		for(int i = 0; i < 4; i++){
			possible2.add(arrangement2[ans2-1][i]);
		}
		
		int same = 0;
		int guess = 0;
		for(int i = 0; i < 4; i++){
			for(int j = 0; j < 4; j++){
				if(possible1.get(i) == possible2.get(j)){
					same++;
					guess = possible1.get(i);
				}
			}
		}
		
		if(same == 1){
			return guess + "";
		}
		else if(same == 0){
			return "Volunteer cheated!";
		}
		else if(same > 1){
			return "Bad magician!";
		}
		return "";
	}
	
	private void start(){
		FileInputStream fin;
		FileOutputStream fout;
		
		try{
			fin = new FileInputStream("A-small-attempt0.in");
			InputStreamReader r = new InputStreamReader(fin);		
			BufferedReader br = new BufferedReader(r);
			
			fout = new FileOutputStream("A-small-attempt0.out");
			OutputStreamWriter w = new OutputStreamWriter(fout);		
			BufferedWriter bw = new BufferedWriter(w);
			
			int round = Integer.parseInt(br.readLine());
			
			for(int i = 0; i < round; i++){
				int ans1 = Integer.parseInt(br.readLine());			
				int[][] arrangement1 = new int[ROW_NUMBER][COL_NUMBER];	
				for(int j = 0; j < ROW_NUMBER; j++){
					String tmp = br.readLine();
					String tmp2[] = new String[COL_NUMBER];
					tmp2 = tmp.split(" ");
					for(int k = 0; k < COL_NUMBER; k++){
						arrangement1[j][k] = Integer.parseInt(tmp2[k]);	
					}
				}
				int ans2 = Integer.parseInt(br.readLine());	
				int[][] arrangement2 = new int[ROW_NUMBER][COL_NUMBER];
				for(int j = 0; j < ROW_NUMBER; j++){
					String tmp = br.readLine();
					String tmp2[] = new String[COL_NUMBER];
					tmp2 = tmp.split(" ");
					for(int k = 0; k < COL_NUMBER; k++){
						arrangement2[j][k] = Integer.parseInt(tmp2[k]);	
					}
				}
				String result = compute(arrangement1, arrangement2, ans1, ans2);
				
				bw.write("Case #" + (i+1) + ": " + result);
				bw.newLine();
			}
			
			br.close();
			bw.flush();
			bw.close();			
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}	
	}
}
