import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.InputMismatchException;
import java.util.List;
import java.util.Map;
import java.util.Scanner;
import java.util.Stack;
public class Round2C {
	private Stack<Integer> stack;
	
	public static void main(String[] args)
	{
		Round2C g = new Round2C();
		
		g.start();
	}

	public List<Integer> dfs(int adjacency_matrix[][], int source)
    {
        int number_of_nodes = adjacency_matrix[source].length - 1;
 
        int visited[] = new int[number_of_nodes + 1];		
        int element = source;		
        int i = source;	
        
        List<Integer> result = new ArrayList<Integer>();	
        result.add(element);
        
        visited[source] = 1;		
        stack.push(source);
 
        while (!stack.isEmpty())
        {
            element = stack.peek();
            i = element;	
	    while (i <= number_of_nodes)
	    {
     	        if (adjacency_matrix[element][i] == 1 && visited[i] == 0)
	        {
                    stack.push(i);
                    visited[i] = 1;
                    element = i;
                    i = 1;
                    result.add(element);
	            continue;
                }
                i++;
	    }
            stack.pop();	
        }	
        return result;
    }
	
	private void start(){
		FileInputStream fin;
		FileOutputStream fout;
		
		try{
			fin = new FileInputStream("C-small-attempt0.in");
			InputStreamReader r = new InputStreamReader(fin);		
			BufferedReader br = new BufferedReader(r);
			
			fout = new FileOutputStream("C-small-attempt0.out");
			OutputStreamWriter w = new OutputStreamWriter(fout);		
			BufferedWriter bw = new BufferedWriter(w);
			
			int round = Integer.parseInt(br.readLine());
			
			for(int i = 0; i < round; i++){
				String tmp = br.readLine();
				String tmp2[] = new String[2];
				tmp2 = tmp.split(" ");
				int N = Integer.parseInt(tmp2[0]);
				int M = Integer.parseInt(tmp2[1]);
							
				List<String> zip = new ArrayList<String>();
				for(int j = 0; j < N ; j++){
					zip.add(br.readLine());
				}
							
				stack = new Stack<Integer>();	
				int number_of_nodes, source;
				number_of_nodes = N;
				int adjacency_matrix[][] = new int[number_of_nodes + 1][number_of_nodes + 1];    
	            for (int k = 1; k <= number_of_nodes; k++)
	            	for (int j = 1; j <= number_of_nodes; j++)
	            		adjacency_matrix[k][j] = 0;
	            
	            for(int j = 0; j < M ; j++){
					String tmp3 = br.readLine();
					String tmp4[] = new String[2];
					tmp4 = tmp3.split(" ");
					int start = Integer.parseInt(tmp4[0]);
					int end = Integer.parseInt(tmp4[1]);
					
					adjacency_matrix[start][end] = 1;
					adjacency_matrix[end][start] = 1;
				}
	            

	            List<List<Integer>> all = new ArrayList<List<Integer>>();
	            for(int j = 0; j < N; j++){
	            	source = j+1;
	            	List<Integer> result = dfs(adjacency_matrix, source);
	            	all.add(result);
	            }
	            
	            List<Integer> result = new ArrayList<Integer>();	
	            for(List<Integer> e : all){
	            	if(e.size() == N){
	            		result = e;
	            		break;
	            	}
	            }
	            
	            
	            String zips = "";
	            for(Integer e : result){
	            	zips += zip.get(e-1).toString();
	            }
	            bw.write(String.format("Case #%d: %s", (i+1), zips));
				bw.newLine();
	            //System.out.println(zips);
	            
			}
			
			br.close();
			bw.flush();
			bw.close();			
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}	
	}
}
