import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
class Grid {
	private String content = ".";
	private int count;
	private boolean reveal = false;
	public Grid(){
	}


	public void setContent(String content){
		this.content = content;
	}
	
	public String getContent(){
		return content;
	}
	
	public void setCount(int count){
		this.count = count;
	}
	
	public void setReveal(){
		this.reveal = true;
	}
	
	public boolean getReveal(){
		return reveal;
	}
	
	public int getCount(){
		return count;
	}
	
	public String toString(){
		return content;
	}
}

public class MinesweeperMaster {
	public static void main(String[] args){
		MinesweeperMaster g = new MinesweeperMaster();
		g.start();
	}
	
	private void start(){
		FileInputStream fin;
		FileOutputStream fout;
		
		try{
			//fin = new FileInputStream("C.in.txt");
			fin = new FileInputStream("C-small-attempt2.in");
			InputStreamReader r = new InputStreamReader(fin);		
			BufferedReader br = new BufferedReader(r);
			
			fout = new FileOutputStream("C-small-attempt2.out");
			OutputStreamWriter w = new OutputStreamWriter(fout);		
			BufferedWriter bw = new BufferedWriter(w);
			
			int round = Integer.parseInt(br.readLine());
			
			for(int i = 0; i < round; i++){
				String tmp = br.readLine();
				String[] tmp2 = new String[3];
				tmp2 = tmp.split(" ");
				
				compute(Integer.parseInt(tmp2[0]), Integer.parseInt(tmp2[1]), Integer.parseInt(tmp2[2]), bw, (i+1));
			}
			
			br.close();
			bw.flush();
			bw.close();			
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}	
	}
	
	private void compute(int R, int C, int M, BufferedWriter bw, int round){
		Grid[][] board = new Grid[R][C];
		
		int tryNum = 0;
		boolean pass = false;
		while((!pass)&&(tryNum<(R*C))){
			for(int i = 0; i < R; i++){
				for(int j = 0; j < C; j++){
					board[i][j] = new Grid();
				}
			}

			if(tryNum%3 == 0){
				board = setMine1(board, R, C, M);
			}
			else if(tryNum%3 == 1){
				board = setMine3(board, R, C, M);
			}
			else if(tryNum%3 == 2){
				board = setMine2(board, R, C, M);
			}
			
			for(int i = 0; i < R; i++){
				for(int j = 0; j < C; j++){
					int countMine = 0;
					
					if((i-1)>=0){
						if(board[i-1][j].getContent().equals("*")){
							countMine++;
						}
						if((j-1 >= 0)){
							if(board[i-1][j-1].getContent().equals("*")){
								countMine++;
							}
						}
						if((j+1 < C)){
							if(board[i-1][j+1].getContent().equals("*")){
								countMine++;
							}
						}
					}
					if((j-1 >= 0)){
						if(board[i][j-1].getContent().equals("*")){
							countMine++;
						}
						if((i+1) < R){
							if(board[i+1][j-1].getContent().equals("*")){
								countMine++;
							}
						}
					}
					
					if((j+1 < C)){
						if(board[i][j+1].getContent().equals("*")){
							countMine++;
						}
						if((i+1) < R){
							if(board[i+1][j+1].getContent().equals("*")){
								countMine++;
							}
						}
					}
					if((i+1) < R){
						if(board[i+1][j].getContent().equals("*")){
							countMine++;
						}
					}
					
					board[i][j].setCount(countMine);
				}
			}
			
			int found = tryNum/3;
			for(int i = 0; i < R; i++){
				for(int j = 0; j < C; j++){
					if(board[i][j].getContent().equals(".")){
						if(found > 0){
							found--;
						}
						else
						{
							board[i][j].setContent("c");
							found--;
							break;
						}
					}
				}
				if(found < 0){
					break;
				}
			}
			
			for(int i = 0; i < R; i++){
				for(int j = 0; j < C; j++){
					int currentCount = board[i][j].getCount();
					if((currentCount == 0)){
						if((i-1)>=0){		
							if(board[i-1][j].getContent().equals(".")){
								board[i-1][j].setReveal();
							}
							if((j-1 >= 0)){
								if(board[i-1][j-1].getContent().equals(".")){
									board[i-1][j-1].setReveal();
								}
							}
							if((j+1 < C)){
								if(board[i-1][j+1].getContent().equals(".")){
									board[i-1][j+1].setReveal();
								}
							}
						}
						if((j-1 >= 0)){
							if(board[i][j-1].getContent().equals(".")){
								board[i][j-1].setReveal();
							}
							if((i+1) < R){
								if(board[i+1][j-1].getContent().equals(".")){
									board[i+1][j-1].setReveal();
								}
							}
						}
						
						if((j+1 < C)){
							if(board[i][j+1].getContent().equals(".")){
								board[i][j+1].setReveal();
							}
							if((i+1) < R){
								if(board[i+1][j+1].getContent().equals(".")){
									board[i+1][j+1].setReveal();
								}
							}
						}
						if((i+1) < R){
							if(board[i+1][j].getContent().equals(".")){
								board[i+1][j].setReveal();
							}
						}
					}
				}
			}
			
			pass = testValid(board, R, C);
			
			if(pass){
				try{
					bw.append("Case #" + round + ":");
					bw.newLine();
					
					for(int i = 0; i < R; i++){
						for(int j = 0; j < C; j++){
							bw.append(board[i][j]+"");
							/*
							if(board[i][j].getContent().equals(".")){
								if(board[i][j].getReveal()){
									bw.append(board[i][j].getCount()+"");
								}
								else{
									bw.append(board[i][j]+"");
								}
							}
							else{
								bw.append(board[i][j]+"");
							}
							*/
						}
						bw.newLine();
					}
				}
				catch (Exception e)
				{
					e.printStackTrace();
				}	
			}
			else{
				tryNum++;
			}
		}
		if(!pass){
			try{
				bw.append("Case #" + round + ":");
				bw.newLine();
				bw.append("Impossible");
				bw.newLine();
			}
			catch (Exception e)
			{
				e.printStackTrace();
			}
		}
		
	}
	
	private Grid[][] setMine3(Grid[][] board, int R, int C, int M){
		int r = R-1;
		int c = C-1;
		for(int i = 0; i < M ; i++){
			board[r][c].setContent("*");
			c--;
			if(c < 0){
				r--;
				c = C-1;
			}
		}
		return board;
	}
	
	private Grid[][] setMine2(Grid[][] board, int R, int C, int M){
		int row = R-1;
		int count = 0;
		boolean enough = false;
		for(int i = C-1; i >= 0 ; i--){
			board[row][i].setContent("*");
			count++;
			if(count == M){
				enough = true;
				break;
			}
			int tmpI = i;
			int tmpR = row;
			while((tmpI<C-1)&&(tmpR > 0)&&(!enough)){
				tmpI++;
				tmpR--;
				board[tmpR][tmpI].setContent("*");
				count++;
				if(count == M){
					enough = true;
				}
			}
			if(enough){
				break;
			}
		}
		if(!enough){
			for(int i = R-2; i >= 0 ; i--){
				board[i][0].setContent("*");
				count++;
				if(count == M){
					enough = true;
					break;
				}
				int tmpI = i;
				int tmpC = 0;
				while((tmpI>0)&&(tmpC < (C-1))&&(!enough)){
					tmpI--;
					tmpC++;
					board[tmpI][tmpC].setContent("*");
					count++;
					if(count == M){
						enough = true;
					}
				}
				if(enough){
					break;
				}
			}
		}
		return board;
	}
	
	private Grid[][] setMine1(Grid[][] board, int R, int C, int M){
		int r = R-1;
		int currentRow = R-1;
		int c = C-1;
		int currentCol = C-1;
		boolean isCol = true;

		for(int i = 0; i < M ; i++){
			board[r][c].setContent("*");
			if(isCol){
				if(c!=0){
					c--;
				}
				else{
					isCol = false;
					currentRow--;
					r = currentRow;
					c = currentCol;
				}
			}		
			else{
				if(r!=0){
					r--;
				}
				else{
					isCol = true;
					currentCol--;
					r = currentRow;
					c = currentCol;
				}
			}
		}
		return board;
	}
	
	private boolean testValid(Grid[][] board, int R, int C){
		for(int i = 0; i < R; i++){
			for(int j = 0; j < C; j++){
				if(board[i][j].getContent().equals(".")){
					if(!board[i][j].getReveal()){
						return false;
					}
				}
			}
		}
		return true;
	}
}
