package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class Solver {

	private static ArrayList<Integer[]> possibles;

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		for (int t = 1; t <= totalTests; ++t) {
			System.out.println("Case #" + t + ":");
			writer.write("Case #" + t + ":");
			writer.newLine();

			String[] values = reader.readLine().split(" ");
			int n = Integer.parseInt(values[0]);
			int j = Integer.parseInt(values[1]);
			computeBinary(n);

			int index = 0;
			int found = 0;
			while (found < j && index < possibles.size()) {
				Integer[] chain = possibles.get(index);

				if (prime(chain)) {
					String result = "";

					for (Integer in : chain) {
						result += in;
					}

					for (int p = 2; p <= 10; p++) {
						long number = 0;
						long pTmp = 1;
						for (int counter = chain.length - 1; counter >= 0; counter--) {
							number += chain[counter] * pTmp;
							pTmp *= p;
						}

						boolean valid = false;
						for (int i = 3; i < number && !valid; i++) {
							if (number % i == 0) {
								result += " " + i;
								valid = true;
							}
						}

						if (!valid) {
							System.out.println("error: big time for " + number + "in basis " + p);
						}
					}

					found++;
					System.out.println(result);
					writer.write(result);
					writer.newLine();
				}
				index++;
			}
		}

		writer.flush();
		writer.close();
		reader.close();
	}

	private static void computeBinary(int n) {
		List<List<Integer>> pos = recursive(n - 2);
		possibles = new ArrayList<>();

		for (List<Integer> list : pos) {
			list.add(1);
			list.add(0, 1);

			possibles.add(list.toArray(new Integer[list.size()]));
		}

	}

	private static List<List<Integer>> recursive(int n) {
		if (n == 1) {
			LinkedList<List<Integer>> l = new LinkedList<>();
			List<Integer> a = new LinkedList<>();
			a.add(0);
			List<Integer> b = new LinkedList<>();
			b.add(1);
			l.add(a);
			l.add(b);

			return l;
		}

		LinkedList<List<Integer>> l = new LinkedList<>();

		List<List<Integer>> pos = recursive(n - 1);

		for (List<Integer> list : pos) {
			List<Integer> a = new LinkedList<>(list);
			a.add(0, 0);
			List<Integer> b = new LinkedList<>(list);
			b.add(0, 1);
			l.add(a);
			l.add(b);
		}

		return l;
	}

	private static boolean prime(Integer[] chain) {
		// prime
		for (int p = 2; p <= 10; p++) {
			long number = 0;
			long pTmp = 1;
			for (int counter = chain.length - 1; counter >= 0; counter--) {
				number += chain[counter] * pTmp;
				pTmp *= p;
			}

			if (isPrime(number)) {
				return false;
			}
		}

		return true;
	}

	private static boolean isPrime(long num) {
		if (num < 2)
			return false;
		if (num == 2)
			return true;
		if (num % 2 == 0)
			return false;
		for (long i = 3; i * i <= num; i += 2)
			if (num % i == 0)
				return false;
		return true;
	}
}