package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;

public class Solver {

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		char[] parties = "ABCDEFGHIJKLMNOPJRSTUVWXYZ".toCharArray();

		for (int t = 1; t <= totalTests; ++t) {
			String result = "";
			int n = Integer.parseInt(reader.readLine());
			String[] values = reader.readLine().split(" ");
			Party[] senators = new Party[n];
			int total = 0;
			for (int i = 0; i < values.length; ++i) {
				Party p = new Party();
				p.name = parties[i];
				p.number = Integer.parseInt(values[i]);
				senators[i] = p;
				total += p.number;
			}

			while (total > 0) {
				Arrays.sort(senators);
				if (senators[0].number == 2 && senators[1].number == 1) {
					if (n > 2 && senators[2].number == 1) {
						senators[0].number = senators[0].number - 2;
						result += new StringBuilder().append(senators[0].name).append(senators[0].name).append(" ")
								.toString();
						total -= 2;
						continue;
					} else {
						senators[0].number = senators[0].number - 1;
						result += new StringBuilder().append(senators[0].name).append(" ").toString();
						total -= 1;
						continue;
					}
				}

				if (n > 2 && senators[0].number == 1 && senators[1].number == 1 && senators[2].number == 1) {
					senators[0].number = senators[0].number - 1;
					result += new StringBuilder().append(senators[0].name).append(" ").toString();
					total -= 1;
					continue;
				}

				if (senators[0].number > senators[1].number) {
					senators[0].number = senators[0].number - 2;
					result += new StringBuilder().append(senators[0].name).append(senators[0].name).append(" ")
							.toString();
					total -= 2;
					continue;
				}

				if (senators[0].number == senators[1].number) {
					senators[0].number = senators[0].number - 1;
					senators[1].number = senators[1].number - 1;
					result += new StringBuilder().append(senators[0].name).append(senators[1].name).append(" ")
							.toString();
					total -= 2;
					continue;
				}
				System.out.println("error.");
			}

			System.out.println("Case #" + t + ": " + result);
			writer.write("Case #" + t + ": " + result);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

	static class Party implements Comparable {

		public int number;

		public char name;

		@Override
		public int compareTo(Object o) {
			int result = 0;
			if (o instanceof Party) {
				Party other = (Party) o;
				result = other.number - this.number;
			}

			return result;
		}
	}

}
