package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Solver {
	
	static char[][] board;
	static boolean[][] boardBool;
	static int r;
	static int c;
	static int result;
	static String resString;

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int t = Integer.parseInt(reader.readLine());

		for (int c2 = 1; c2 <= t; ++c2) {
			result = 0;
			resString = null;

			String[] values = reader.readLine().split(" ");
			r = Integer.parseInt(values[0]);
			c = Integer.parseInt(values[1]);

			board = new char[r][c];
			boardBool = new boolean[r][c];
			for (int i = 0; i < r; ++i) {
				board[i] = reader.readLine().toCharArray();
			}

			for (int i = 0; i < r; i++) {
				for (int j = 0; j < c; ++j) {
					if (board[i][j] != '.' && !boardBool[i][j]) {
						isSave(i, j);
					}
				}
			}
			
			if (resString == null) {
				resString = String.valueOf(result);
			}
				
			System.out.println("Case #" + c2 + ": " + resString);
			writer.write("Case #" + c2 + ": " + resString);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}
	
	private static boolean isSave(int x, int y) {
		if (boardBool[x][y]) {
			return true;
		}
		if (board[x][y] == '.') {
			return false;
		}
		
		char last = '?';
		char lastLast = '?';
		int lastRow = 0;
		int lastCol = 0;
		while (x >= 0 && x < r && y >= 0 && y < c && !boardBool[x][y]) {
			char field = board[x][y];
			int oldRow = x;
			int oldCol = y;
			if (field == '.') {
				if (last == '<') {
					y--;
				}
				if (last == '>') {
					y++;
				}
				if (last == '^') {
					x--;
				}
				if (last == 'v') {
					x++;
				}
			} else {
				if (field == '<') {
					y--;
				}
				if (field == '>') {
					y++;
				}
				if (field == '^') {
					x--;
				}
				if (field == 'v') {
					x++;
				}
				lastRow = oldRow;
				lastCol = oldCol;
				lastLast = last;
				last = field;
				
				boardBool[oldRow][oldCol] = true;
			}		

			if (!(x >= 0 && x < r && y >= 0 && y < c)) {
				char gegenteil = '?';

				if (lastLast == '?') {

					if (last == '<') {
						boolean possible = false;
						
						for (int i2 = lastRow - 1; i2 >= 0 && !possible; i2--) {
							if (isSave(i2, lastCol)) {
								possible = true;
								gegenteil = '^';
							}
						}
						for (int i2 = lastRow + 1; i2 < r && !possible; i2++) {
							if (isSave(i2, lastCol)) {
								possible = true;
								gegenteil = 'v';
							}
						}
						for (int i2 = lastCol + 1; i2 < c && !possible; i2++) {
							if (isSave(lastRow, i2)) {
								possible = true;
								gegenteil = '>';
							}
						}
						
						if (!possible) {
							resString = "IMPOSSIBLE";
							break;
						}
					}
					if (last == '>') {
						boolean possible = false;
						
						for (int i2 = lastRow - 1; i2 >= 0 && !possible; i2--) {
							if (isSave(i2, lastCol)) {
								possible = true;
								gegenteil = '^';
							}
						}
						for (int i2 = lastRow + 1; i2 < r && !possible; i2++) {
							if (isSave(i2, lastCol)) {
								possible = true;
								gegenteil = 'v';
							}
						}
						for (int i2 = lastCol - 1; i2 >= 0 && !possible; i2--) {
							if (isSave(lastRow, i2)) {
								possible = true;
								gegenteil = '<';
							}
						}
						
						if (!possible) {
							resString = "IMPOSSIBLE";
							break;
						}
					}
					if (last == '^') {
						boolean possible = false;
						

						for (int i2 = lastRow + 1; i2 < r && !possible; i2++) {
							if (isSave(i2, lastCol)) {
								possible = true;
								gegenteil = 'v';
							}
						}
						for (int i2 = lastCol + 1; i2 < c && !possible; i2++) {
							if (isSave(lastRow, i2)) {
								possible = true;
								gegenteil = '>';
							}
						}
						for (int i2 = lastCol - 1; i2 >= 0 && !possible; i2--) {
							if (isSave(lastRow, i2)) {
								possible = true;
								gegenteil = '<';
							}
						}
						
						if (!possible) {
							resString = "IMPOSSIBLE";
							break;
						}
					}
					if (last == 'v') {
						boolean possible = false;
						
						for (int i2 = lastRow - 1; i2 >= 0 && !possible; i2--) {
							if (isSave(i2, lastCol)) {
								possible = true;
								gegenteil = '^';
							}
						}
						for (int i2 = lastCol + 1; i2 < c && !possible; i2++) {
							if (isSave(lastRow, i2)) {
								possible = true;
								gegenteil = '>';
							}
						}
						for (int i2 = lastCol - 1; i2 >= 0 && !possible; i2--) {
							if (isSave(lastRow, i2)) {
								possible = true;
								gegenteil = '<';
							}
						}
						
						if (!possible) {
							resString = "IMPOSSIBLE";
							break;
						}
					}
				} else {

					if (lastLast == '<') {
						gegenteil = '>';
					}
					if (lastLast == '>') {
						gegenteil = '<';
					}
					if (lastLast == '^') {
						gegenteil = 'v';
					}
					if (lastLast == 'v') {
						gegenteil = '^';
					}
				}

				board[lastRow][lastCol] = gegenteil;

				result++;
				break;
			}
		}
		
		if (resString == "IMPOSSIBLE") {
			return false;
		} else {
			return true;
		}
	}

}
