package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Solver {

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int t = Integer.parseInt(reader.readLine());

		for (int c = 1; c <= t; ++c) {
			String result = null;

			String[] values = reader.readLine().split(" ");
			int l = Integer.parseInt(values[0]);
			long x = Long.parseLong(values[1]);
			String input = reader.readLine();
			StringBuilder builder = new StringBuilder();
			for (int i = 0; i < x; ++i) {
				builder.append(input);
			}

			// pres
			if ((l * x) < 3) {
				result = "NO";
			} else {
				String completeWord = builder.toString();
				char[] allChars = completeWord.toCharArray();

				int indexI = getRemainingAfterI(allChars, true, 0);

				while (indexI != -1 && result == null) {

					int indexJ = getRemainingAfterJ(allChars, true, indexI);
					while (indexJ != -1 && result == null) {

						if (possibleK(allChars, indexJ)) {
							result = "YES";
						}

						indexJ = getRemainingAfterJ(allChars, false, indexJ);
					}

					indexI = getRemainingAfterI(allChars, false, indexI);
				}

				if (result == null) {
					result = "NO";
				}
			}

			System.out.println("Case #" + c + ": " + result);
			writer.write("Case #" + c + ": " + result);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

	private static char multi(char x, char y) {
		switch (x) {
			case 'i':
				return multiI(y);
			case 'j':
				return multiJ(y);
			case 'k':
				return multiK(y);
			case '1':
				return multi1(y);
			case 'a':
				return multiA(y);
			case 'b':
				return multiB(y);
			case 'c':
				return multiC(y);
			case 'd':
				return multiD(y);
		}

		return 'z';
	}

	private static char multiA(char z) {
		switch (z) {
			case 'i':
				return '1';
			case 'j':
				return 'c';
			case 'k':
				return 'j';
			case '1':
				return 'a';
			case 'a':
				return 'd';
			case 'b':
				return 'k';
			case 'c':
				return 'b';
			case 'd':
				return 'i';
		}
		return z;
	}

	private static char multiI(char z) {
		switch (z) {
			case 'i':
				return 'd';
			case 'j':
				return 'k';
			case 'k':
				return 'b';
			case '1':
				return 'i';
			case 'a':
				return '1';
			case 'b':
				return 'c';
			case 'c':
				return 'j';
			case 'd':
				return 'a';
		}
		return z;
	}

	private static char multiJ(char z) {
		switch (z) {
			case 'i':
				return 'c';
			case 'j':
				return 'd';
			case 'k':
				return 'i';
			case '1':
				return 'j';
			case 'a':
				return 'k';
			case 'b':
				return '1';
			case 'c':
				return 'a';
			case 'd':
				return 'b';
		}
		return z;
	}

	private static char multiB(char z) {
		switch (z) {
			case 'i':
				return 'k';
			case 'j':
				return '1';
			case 'k':
				return 'a';
			case '1':
				return 'b';
			case 'a':
				return 'c';
			case 'b':
				return 'd';
			case 'c':
				return 'i';
			case 'd':
				return 'j';
		}
		return z;
	}

	private static char multiK(char z) {
		switch (z) {
			case 'i':
				return 'j';
			case 'j':
				return 'a';
			case 'k':
				return 'd';
			case '1':
				return 'k';
			case 'a':
				return 'b';
			case 'b':
				return 'i';
			case 'c':
				return '1';
			case 'd':
				return 'c';
		}
		return z;
	}

	private static char multiC(char z) {
		switch (z) {
			case 'i':
				return 'b';
			case 'j':
				return 'i';
			case 'k':
				return '1';
			case '1':
				return 'c';
			case 'a':
				return 'j';
			case 'b':
				return 'a';
			case 'c':
				return 'd';
			case 'd':
				return 'k';
		}
		return z;
	}

	private static char multi1(char z) {
		switch (z) {
			case 'i':
				return 'i';
			case 'j':
				return 'j';
			case 'k':
				return 'k';
			case '1':
				return '1';
			case 'a':
				return 'a';
			case 'b':
				return 'b';
			case 'c':
				return 'c';
			case 'd':
				return 'd';
		}
		return z;
	}

	private static char multiD(char z) {
		switch (z) {
			case 'i':
				return 'a';
			case 'j':
				return 'b';
			case 'k':
				return 'c';
			case '1':
				return 'd';
			case 'a':
				return 'i';
			case 'b':
				return 'j';
			case 'c':
				return 'k';
			case 'd':
				return '1';
		}
		return z;
	}

	private static int getRemainingAfterI(char[] word, boolean first, int offset) {
		if (offset >= word.length) {
			return -1;
		}

		char lastChar;
		if (first) {
			lastChar = word[offset];
			offset++;
			if (lastChar == 'i') {
				return offset;
			}
		} else {
			lastChar = 'i';
		}

		for (int i = offset; i < word.length; ++i) {
			lastChar = multi(lastChar, word[i]);
			if (lastChar == 'i') {
				if ((i + 1) < word.length) {
					return (i + 1);
				} else {
					return -1;
				}
			}
		}

		return -1;
	}

	private static int getRemainingAfterJ(char[] word, boolean first, int offset) {
		if (offset >= word.length) {
			return -1;
		}

		char lastChar;
		if (first) {
			lastChar = word[offset];
			offset++;
			if (lastChar == 'j') {
				return offset;
			}
		} else {
			lastChar = 'j';
		}

		for (int i = offset; i < word.length; ++i) {
			lastChar = multi(lastChar, word[i]);
			if (lastChar == 'j') {
				if ((i + 1) < word.length) {
					return (i + 1);
				} else {
					return -1;
				}
			}
		}

		return -1;
	}

	private static boolean possibleK(char[] word, int offset) {
		if (offset >= word.length) {
			return false;
		}

		char lastChar = word[offset];
		for (int i = 1 + offset; i < word.length; ++i) {
			lastChar = multi(lastChar, word[i]);
		}

		if (lastChar == 'k') {
			return true;
		} else {
			return false;
		}
	}
}
