
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Solver {

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		for (int t = 1; t <= totalTests; ++t) {
			int result = -1;

			String[] values = reader.readLine().split(" ");
			char[] setting = values[0].toCharArray();
			int K = Integer.parseInt(values[1]);

			boolean[] pancakes = new boolean[setting.length];
			for (int i = 0; i < pancakes.length; ++i) {
				pancakes[i] = setting[i] == '+';
			}

			int counter = 0;
			for (int i = 0; i < pancakes.length - K + 1; ++i) {
				if (!pancakes[i]) {
					for (int j = 0; j < K; ++j) {
						pancakes[i + j] = !pancakes[i + j];
					}
					counter++;
				}
			}
			boolean valid = true;
			for (int i = 0; i < pancakes.length; ++i) {
				if (!pancakes[i]) {
					valid = false;
				}
			}
			if (valid) {
				result = counter;
			}

			if (result != -1) {
				System.out.println("Case #" + t + ": " + result);
				writer.write("Case #" + t + ": " + result);
				writer.newLine();
			} else {
				System.out.println("Case #" + t + ": IMPOSSIBLE");
				writer.write("Case #" + t + ": IMPOSSIBLE");
				writer.newLine();
			}
		}

		writer.flush();
		writer.close();
		reader.close();
	}

}
