
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Solver {

	private static int[] R;
	private static int[] H;

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		for (int t = 1; t <= totalTests; ++t) {
			double result = -1;

			String[] NK = reader.readLine().split(" ");
			int N = Integer.parseInt(NK[0]);
			int K = Integer.parseInt(NK[1]);

			R = new int[N];
			H = new int[N];
			for (int i = 0; i < N; ++i) {
				String[] RH = reader.readLine().split(" ");
				R[i] = Integer.parseInt(RH[0]);
				H[i] = Integer.parseInt(RH[1]);
			}

			boolean[] used = new boolean[N];
			result = calcOptimal(used, K, Integer.MAX_VALUE, 0.d, true);

			System.out.println("Case #" + t + ": " + result);
			writer.write("Case #" + t + ": " + result);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

	private static double calcOptimal(boolean[] used, int remaining, int lastRadius, double lastSurface,
			boolean first) {
		double result = 0;
		if (remaining < 1) {
			return lastSurface;
		}

		double max = 0;
		for (int i = 0; i < used.length; ++i) {
			if (!used[i] && R[i] <= lastRadius) {
				double currentSurface = 2 * Math.PI * R[i] * H[i];
				if (first) {
					currentSurface += Math.PI * R[i] * R[i];
				}
				double total = lastSurface + currentSurface;
				used[i] = true;

				double withTops = calcOptimal(used, remaining - 1, R[i], total, false);
				used[i] = false;

				max = Double.max(max, withTops);
			}
		}
		result = max;

		return result;
	}

}
