
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.SortedMap;
import java.util.SortedSet;
import java.util.TreeMap;
import java.util.TreeSet;

public class Solver {

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		for (int t = 1; t <= totalTests; ++t) {
			String[] values = reader.readLine().split(" ");
			int N = Integer.parseInt(values[0]);
			int K = Integer.parseInt(values[1]);

			SortedMap<Integer, SortedSet<Integer>> mapping = new TreeMap<>();
			SortedSet<Integer> l = new TreeSet<>();
			l.add(0);
			mapping.put(N, l);

			int Ls = 0;
			int Rs = 0;
			for (int i = 0; i < K; ++i) {
				int distance = mapping.lastKey();
				SortedSet<Integer> list = mapping.get(distance);
				int positionLeft = list.first();
				list.remove(positionLeft);
				if (list.isEmpty()) {
					mapping.remove(distance);
				}

				distance--;
				if (distance % 2 == 0) {
					Ls = distance / 2;
					Rs = Ls;
				} else {
					Ls = distance / 2;
					Rs = Ls + 1;
				}

				int newPosition = positionLeft + Ls + 1;

				if (mapping.containsKey(Ls)) {
					mapping.get(Ls).add(positionLeft);
				} else {
					SortedSet<Integer> toAdd = new TreeSet<>();
					toAdd.add(positionLeft);
					mapping.put(Ls, toAdd);
				}

				if (mapping.containsKey(Rs)) {
					mapping.get(Rs).add(newPosition);
				} else {
					SortedSet<Integer> toAdd = new TreeSet<>();
					toAdd.add(newPosition);
					mapping.put(Rs, toAdd);
				}
			}

			System.out.println("Case #" + t + ": " + Rs + " " + Ls);
			writer.write("Case #" + t + ": " + Rs + " " + Ls);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

}
