package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Collections;
import java.util.LinkedList;

public class Solver {

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int t = Integer.parseInt(reader.readLine());

		for (int c = 1; c <= t; ++c) {
			long result = 0;

			String WTF = reader.readLine();
			String[] values = reader.readLine().split(" ");

			LinkedList<Integer> pancakes = new LinkedList<Integer>();
			for (String v : values) {
				pancakes.add(Integer.parseInt(v));
			}
			Collections.sort(pancakes, Collections.reverseOrder());
			int[] numbers = new int[pancakes.getFirst() + 1];
			for (Integer num : pancakes) {
				numbers[num] += 1;
			}

			int lower = 0;
			int upper = numbers.length - 1;
			int minutes = 0;
			for (int i = numbers.length - 1; i >= 0; --i) {
				if (numbers[i] > 0) {
					if (timeForSpecial(i, numbers[i])) { // special
						int dif = i / 2;
						if ((i % 2) == 0) {
							numbers[dif] += (numbers[i] * 2);
						} else {
							numbers[dif] += numbers[i];
							numbers[(dif + 1)] += numbers[i];
						}

						minutes += numbers[i];
					} else { // eating
						lower = i;

						if ((lower + minutes) >= upper) {
							result = upper;
						} else {
							result = (lower + minutes);
						}

						break;
					}
				}
			}

			System.out.println("Case #" + c + ": " + result);
			writer.write("Case #" + c + ": " + result);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

	private static boolean timeForSpecial(int firstValue, int NbrOfFirsts) {
		if (firstValue <= 3) {
			return false;
		}

		int teilen = firstValue / 2;
		// System.out.println("teilen: " + teilen);
		if (NbrOfFirsts <= teilen) {
			return true;
		} else {
			return false;
		}
	}

}
