package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.LinkedList;

public class Solver {

	private static int[][] jp;
	private static int[][] js;
	private static int[][] ps;

	private static boolean[][][] used;
	private static int k;
	private static int j;

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		for (int t = 1; t <= totalTests; ++t) {
			String[] values = reader.readLine().split(" ");
			j = Integer.parseInt(values[0]);
			int p = Integer.parseInt(values[1]);
			int s = Integer.parseInt(values[2]);
			k = Integer.parseInt(values[3]);
			jp = new int[j][p];
			js = new int[j][s];
			ps = new int[p][s];
			LinkedList<int[]> list = new LinkedList<int[]>();
			used = new boolean[j][p][s];

			boolean stop = false;
			while (!stop) {
				int[] result = getNext();
				if (result[0] == -1) {
					stop = true;
					break;
				}
				jp[result[0]][result[1]]++;
				js[result[0]][result[2]]++;
				ps[result[1]][result[2]]++;
				used[result[0]][result[1]][result[2]] = true;
				list.add(result);
			}

			System.out.println("Case #" + t + ": " + list.size());
			for (int[] line : list) {
				System.out.println((line[0] + 1) + " " + (line[1] + 1) + " " + (line[2] + 1));
			}
			writer.write("Case #" + t + ": " + list.size());
			for (int[] line : list) {
				writer.write((line[0] + 1) + " " + (line[1] + 1) + " " + (line[2] + 1));
			}
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

	private static int[] getNext() {
		int[] result = new int[3];
		result[0] = -1;
		int min = Integer.MAX_VALUE;
		for (int g = 0; g < j; g++) {
			for (int i = 0; i < jp[g].length; i++) {
				for (int j = 0; j < js[g].length; j++) {
					if (jp[g][i] < k && js[g][j] < k && ps[i][j] < k) {
						int current = jp[g][i] + js[g][j] + ps[i][j];
						if (current < min && !used[g][i][j]) {
							min = current;
							result[0] = g;
							result[1] = i;
							result[2] = j;
						}
					}
				}
			}
		}

		return result;
	}
}