
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import javax.lang.model.element.NestingKind;

public class Solver {

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		for (long t = 1; t <= totalTests; ++t) {
			double result = -1;

			String[] NQ = reader.readLine().split(" ");
			int N = Integer.parseInt(NQ[0]);
			int Q = Integer.parseInt(NQ[1]);

			long[] Es = new long[N];
			long[] Ss = new long[N];

			for (int i = 0; i < N; ++i) {
				String[] ES = reader.readLine().split(" ");
				Es[i] = Long.parseLong(ES[0]);
				Ss[i] = Long.parseLong(ES[1]);
			}
			long[][] D = new long[N][N];
			for (int i = 0; i < N; ++i) {
				String[] Ds = reader.readLine().split(" ");
				for (int j = 0; j < N; j++) {
					D[i][j] = Long.parseLong(Ds[j]);
				}
			}
			long[] Us = new long[Q];
			long[] Vs = new long[Q];
			for (int i = 0; i < Q; i++) {
				String[] UV = reader.readLine().split(" ");
				Us[i] = Long.parseLong(UV[0]);
				Vs[i] = Long.parseLong(UV[1]);
			}

			double[] mlongimes = new double[N];
			for (int i = 0; i < N - 1; i++) {
				mlongimes[i] = Double.MAX_VALUE;
			}
			mlongimes[N - 1] = 0.f;

			for (int i = N - 2; i >= 0; i--) {
				long endurance = Es[i];
				long speed = Ss[i];

				double timeMin = Double.MAX_VALUE;

				for (int j = i + 1; j < N; j++) {
					long nextDistance = 0;
					for (int k = i; k < j; k++) {
						nextDistance += D[k][k + 1];
					}

					if (nextDistance <= endurance) {
						double timeToNext = ((double) nextDistance) / speed;
						double overallTime = timeToNext + mlongimes[j];
						if (overallTime < 0) {
							System.out.println("overall negativ");
						}
						timeMin = Double.min(timeMin, overallTime);
					}
				}
				mlongimes[i] = timeMin;
			}

			result = mlongimes[0];

			System.out.println("Case #" + t + ": " + result);
			writer.write("Case #" + t + ": " + result);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

}
