package codejam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.LinkedList;
import java.util.List;

public class Solver {

	private static char[] digits = new char[] { '0', '1', '2', '3', '4', '5', '6', '7', '8', '9' };

	public static void main(String[] args) throws NumberFormatException, IOException {
		BufferedReader reader = new BufferedReader(new FileReader("input.in"));
		BufferedWriter writer = new BufferedWriter(new FileWriter("output.out"));

		int totalTests = Integer.parseInt(reader.readLine());

		for (int t = 1; t <= totalTests; ++t) {
			String[] values = reader.readLine().split(" ");
			char[] c = values[0].toCharArray();
			char[] j = values[1].toCharArray();
			String cResult = "???";
			String jResult = "???";

			List<Integer> cQuestionmarks = new LinkedList<Integer>();
			for (int i = 0; i < c.length; i++) {
				if (c[i] == '?') {
					cQuestionmarks.add(i);
				}
			}
			List<Integer> jQuestionmarks = new LinkedList<Integer>();
			for (int i = 0; i < j.length; i++) {
				if (j[i] == '?') {
					jQuestionmarks.add(i);
				}
			}

			int minimum = Integer.MAX_VALUE;
			List<char[]> cPossible = GetPossibleValues(c);
			List<char[]> jPossible = GetPossibleValues(j);

			for (int i = 0; i < cPossible.size(); i++) {
				for (int n = 0; n < jPossible.size(); n++) {
					int cValue = Integer.valueOf(String.valueOf(cPossible.get(i)));
					int jValue = Integer.valueOf(String.valueOf(jPossible.get(n)));
					int diff = Math.abs(cValue - jValue);
					if (diff < minimum) {
						minimum = diff;
						cResult = String.valueOf(cPossible.get(i));
						jResult = String.valueOf(jPossible.get(n));
					}
				}
			}

			System.out.println("Case #" + t + ": " + cResult + " " + jResult);
			writer.write("Case #" + t + ": " + cResult + " " + jResult);
			writer.newLine();
		}

		writer.flush();
		writer.close();
		reader.close();
	}

	private static List<char[]> GetPossibleValues(char[] base) {
		List<Integer> questionmarks = new ArrayList<Integer>();
		for (int i = 0; i < base.length; i++) {
			if (base[i] == '?') {
				questionmarks.add(i);
			}
		}
		List<char[]> sofar = new ArrayList<char[]>();
		sofar.add(base);
		for (int i = 0; i < questionmarks.size(); i++) {
			sofar = setIndex(questionmarks.get(i), sofar);
		}

		return sofar;
	}

	private static List<char[]> setIndex(int n, List<char[]> sofar) {
		List<char[]> result = new ArrayList<char[]>();

		for (int m = 0; m < sofar.size(); m++) {
			for (int i = 0; i < 10; i++) {
				char[] toAdd = sofar.get(m).clone();
				toAdd[n] = digits[i];
				result.add(toAdd);
			}
		}

		return result;
	}

}