package ominous;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

public class Solver {
	private FileReader m_fileReader;
	private FileWriter m_fileWriter;
	private BufferedReader m_bufferedReader;
	private BufferedWriter m_bufferedWriter;
	
	private int m_numCases;
	
	public Solver() {
		try {
			m_fileReader = new FileReader("input.txt");
			m_fileWriter = new FileWriter("output.txt");
			m_bufferedReader = new BufferedReader(m_fileReader);
			m_bufferedWriter = new BufferedWriter(m_fileWriter);
			
			m_numCases = Integer.parseInt(m_bufferedReader.readLine());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		for(int x = 1; x <= m_numCases; x++) {
			_solveCase(x);
		}
		
		try {
			m_bufferedReader.close();
			m_bufferedWriter.close();
			m_fileReader.close();
			m_fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void _solveCase(int caseNum) {
		int X = 0;
		int R = 0;
		int C = 0;
		
		boolean gWins = true;
		
		try {
			String line = m_bufferedReader.readLine();
			String[] parts = line.split(" ");
			X = Integer.parseInt(parts[0]);
			R = Integer.parseInt(parts[1]);
			C = Integer.parseInt(parts[2]);
		} catch (IOException e) {
			e.printStackTrace();
		} catch (NumberFormatException e) {
			e.printStackTrace();
		}
		
		double rootX = Math.sqrt(X);
		
		//If R * C is not a multiple of X
		if((R * C) % X != 0) gWins = false;
		
		//Straight piece will not fit
		else if(X > R && X > C) gWins = false;
		
		//A piece will be too wide or tall
		else if(X > 2 && (rootX >= R || rootX >= C)) gWins = false;
		
		String winner = gWins ? "GABRIEL" : "RICHARD";
		try {
			m_bufferedWriter.write("Case #" + caseNum + ": " + winner + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
