package standing;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;

public class Solver {
	private FileReader m_fileReader;
	private FileWriter m_fileWriter;
	private BufferedReader m_bufferedReader;
	private BufferedWriter m_bufferedWriter;
	
	private int m_numCases;
	
	public Solver() {
		try {
			m_fileReader = new FileReader("input.txt");
			m_fileWriter = new FileWriter("output.txt");
			m_bufferedReader = new BufferedReader(m_fileReader);
			m_bufferedWriter = new BufferedWriter(m_fileWriter);
			
			m_numCases = Integer.parseInt(m_bufferedReader.readLine());
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		for(int x = 1; x <= m_numCases; x++) {
			_solveCase(x);
		}
		
		try {
			m_bufferedReader.close();
			m_bufferedWriter.flush();
			m_bufferedWriter.close();
			m_fileReader.close();
			m_fileWriter.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
	
	private void _solveCase(int caseNum) {
		int maxShy = 0;
		int maxGap = 0;
		ArrayList<Integer> people = new ArrayList<Integer>();
		
		try {
			String line = m_bufferedReader.readLine();
			String parts[] = line.split(" ");
			
			assert(parts.length == 2);
			
			maxShy = Integer.parseInt(parts[0]);
			
			for(int x = 0; x < parts[1].length(); x++) {
				int shyCount = parts[1].charAt(x) - 48;
				
				for(int y = 0; y < shyCount; y++) {
					people.add(x);
				}
			}
		} catch (IOException e) {
			e.printStackTrace();
		}
		
		for(int x = 0; x < people.size(); x++) {
			int shyness = people.get(x);
			
			if(shyness > x && shyness - x > maxGap) maxGap = shyness - x;
		}
		
		try {
			m_bufferedWriter.write("Case #" + caseNum + ": " + maxGap + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
