package com.google.pancake;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;


public class FileIO
{
    BufferedWriter bw;

    public void readFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("A-small-practice.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;

            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   {
                // Print the content on the console
                System.out.println (strLine);
            }

            //Close the input stream
            br.close();

        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }
    
    public void readOperaAudienceInputFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("B-small-attempt3.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;
            
            int noTestCases = -1;
            int currentTestCase = 0;
            openTicTacToeTomekOutputFile();
            int minutesToFinishBreakfast;
            
            String pancakesStr;
            
            PancakeHouse pancakeHouse = new PancakeHouse();
            
            
            String[] ominousGameInfo;
            
            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   
            {
                // Print the content on the console
            	System.out.println();
                System.out.println (strLine);
                
                if(noTestCases == -1)
                {
                	noTestCases = Integer.parseInt(strLine);
                	continue;
                }
                
                currentTestCase++;
                
                pancakesStr = br.readLine();
                
                minutesToFinishBreakfast = pancakeHouse.getMaxMinutesToFinishBreakfast(pancakesStr);
                
                System.out.println("Case #" + currentTestCase + ": " + minutesToFinishBreakfast);
                
                writeTicTacToeTomekOutputFile("Case #" + currentTestCase + ": " + minutesToFinishBreakfast);
            }

            //Close the input stream
            br.close();

            closeTicTacToeTomekOutputFile();
        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }


    private void openTicTacToeTomekOutputFile()
    {
        try
        {
            File fout = new File("B-small-attempt3.out");
            FileOutputStream fos = new FileOutputStream(fout);

            bw = new BufferedWriter(new OutputStreamWriter(fos));
    
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void writeTicTacToeTomekOutputFile(String inputLine)
    {
        try
        {
            bw.write(inputLine);
            bw.newLine();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void closeTicTacToeTomekOutputFile()
    {
        try
        {
            bw.close();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}

