package com.dijkstra.jam;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class FileIO
{
    BufferedWriter bw;

    public void readFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("A-small-practice.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;

            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   {
                // Print the content on the console
                System.out.println (strLine);
            }

            //Close the input stream
            br.close();

        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }
    
    public void readOperaAudienceInputFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("C-small-attempt3.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;
            
            int noTestCases = -1;
            int currentTestCase = 0;
            openTicTacToeTomekOutputFile();
            String wordStatus = "";
            
            Dijkstra dijkstra = new Dijkstra();

            String strLine2;
            
            String[] wordInfo;
            
            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   
            {
                // Print the content on the console
                System.out.println (strLine);
                
                if(noTestCases == -1)
                {
                	noTestCases = Integer.parseInt(strLine);
                	continue;
                }
                
                currentTestCase++;
                
                strLine2 = br.readLine();
                System.out.println(strLine2);
                wordInfo = strLine.split("\\s+");
                
                System.out.println();
                wordStatus = dijkstra.evaluate(strLine2, Integer.parseInt(wordInfo[0]), Integer.parseInt(wordInfo[1]));
                System.out.println();
                
                System.out.println("Case #" + currentTestCase + ": " + wordStatus + "\n");
                
                writeTicTacToeTomekOutputFile("Case #" + currentTestCase + ": " + wordStatus);
                
                //if(currentTestCase == 20)
                //{
                //	break;
                //}
            }

            //Close the input stream
            br.close();

            closeTicTacToeTomekOutputFile();
        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }


    private void openTicTacToeTomekOutputFile()
    {
        try
        {
            File fout = new File("C-small-attempt3.out");
            FileOutputStream fos = new FileOutputStream(fout);

            bw = new BufferedWriter(new OutputStreamWriter(fos));
    
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void writeTicTacToeTomekOutputFile(String inputLine)
    {
        try
        {
            bw.write(inputLine);
            bw.newLine();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void closeTicTacToeTomekOutputFile()
    {
        try
        {
            bw.close();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}

