package com.ominous.omino;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

public class FileIO
{
    BufferedWriter bw;

    public void readFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("A-small-practice.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;

            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   {
                // Print the content on the console
                System.out.println (strLine);
            }

            //Close the input stream
            br.close();

        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }
    
    public void readOperaAudienceInputFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("D-large.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;
            
            int noTestCases = -1;
            int currentTestCase = 0;
            openTicTacToeTomekOutputFile();
            String winner = "";
            
            Ominous ominous = new Ominous();
            
            
            String[] ominousGameInfo;
            
            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   
            {
                // Print the content on the console
                System.out.println (strLine);
                
                if(noTestCases == -1)
                {
                	noTestCases = Integer.parseInt(strLine);
                	continue;
                }
                
                currentTestCase++;
                
                ominousGameInfo = strLine.split("\\s+");
                
                winner = ominous.getWinner(Integer.parseInt(ominousGameInfo[0]), Integer.parseInt(ominousGameInfo[1]), 
                		Integer.parseInt(ominousGameInfo[2]));
                
                writeTicTacToeTomekOutputFile("Case #" + currentTestCase + ": " + winner);
            }

            //Close the input stream
            br.close();

            closeTicTacToeTomekOutputFile();
        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }


    private void openTicTacToeTomekOutputFile()
    {
        try
        {
            File fout = new File("D-large.out");
            FileOutputStream fos = new FileOutputStream(fout);

            bw = new BufferedWriter(new OutputStreamWriter(fos));
    
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void writeTicTacToeTomekOutputFile(String inputLine)
    {
        try
        {
            bw.write(inputLine);
            bw.newLine();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void closeTicTacToeTomekOutputFile()
    {
        try
        {
            bw.close();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}
