package com.standing.ovation;

import java.io.*;

public class FileIO
{
    BufferedWriter bw;

    public void readFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("A-small-practice.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;

            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   {
                // Print the content on the console
                System.out.println (strLine);
            }

            //Close the input stream
            br.close();

        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }
    
    public void readOperaAudienceInputFile()
    {
        try
        {
            FileInputStream fstream = new FileInputStream("A-large.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;
            
            int noTestCases = -1;
            int currentTestCase = 0;
            openTicTacToeTomekOutputFile();
            int requiredAudienceForCurrentTestCase = 0;
            
            OperaAudience operaAudience = new OperaAudience();

            //Read File Line By Line
            while ((strLine = br.readLine()) != null)   
            {
                // Print the content on the console
                System.out.println (strLine);
                
                if(noTestCases == -1)
                {
                	noTestCases = Integer.parseInt(strLine);
                	continue;
                }
                
                currentTestCase++;
                requiredAudienceForCurrentTestCase = operaAudience.evaluate(strLine);
                
                writeTicTacToeTomekOutputFile("Case #" + currentTestCase + ": " + requiredAudienceForCurrentTestCase);
            }

            //Close the input stream
            br.close();

            closeTicTacToeTomekOutputFile();
        }catch (Exception e)
        {

            e.printStackTrace();
        }
    }
/*
    public void readTicTacToeTomekInputFile()
    {
        int noTotalGames = -1;
        int readGameLine = 0;
        int currentReadingGameInstance = 0;

        String[] gameBoard = new String[4];

        String gameResult;

        openTicTacToeTomekOutputFile();

        TicTacToeTomek ticTacToeTomek = new TicTacToeTomek();

        try
        {
            //FileInputStream fstream = new FileInputStream("A-small-practice.in");//A-large-practice
            FileInputStream fstream = new FileInputStream("A-large-practice.in");
            BufferedReader br = new BufferedReader(new InputStreamReader(fstream));

            String strLine;

            //Read File Line By Line
            while ((strLine = br.readLine()) != null)
            {
                // Print the content on the console
                //System.out.println (strLine);

                if(noTotalGames == -1)
                {
                    noTotalGames = Integer.parseInt(strLine);

                    System.out.println("No. of Games : " + noTotalGames);

                    continue;
                }

                readGameLine++;

                if(readGameLine == 1)
                {
                    currentReadingGameInstance++;

                    System.out.println("\n");
                    System.out.println("Game Begins : #" + currentReadingGameInstance);
                }

                if(readGameLine == 5)
                {
                    System.out.println("Game Ends");
                    readGameLine = 0;

                    //ticTacToeTomek.evaluate(gameBoard);
                    //System.out.println(ticTacToeTomek.evaluate(gameBoard));

                    gameResult = "Case #" + currentReadingGameInstance + ": " + ticTacToeTomek.evaluate(gameBoard);
                    System.out.println(gameResult);

                    writeTicTacToeTomekOutputFile(gameResult);

                }else
                {
                    System.out.println (strLine);

                    gameBoard[readGameLine - 1] = strLine;
                }


            }

            //Close the input stream
            br.close();

        }catch (Exception e)
        {

            e.printStackTrace();
        }

        closeTicTacToeTomekOutputFile();
    }
*/
    private void writeFile()
    {
        try
        {
            File fout = new File("out.in");
            FileOutputStream fos = new FileOutputStream(fout);

            BufferedWriter bw = new BufferedWriter(new OutputStreamWriter(fos));

            for (int i = 0; i < 10; i++) {
                bw.write("something");
                bw.newLine();
            }

            bw.close();

        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void openTicTacToeTomekOutputFile()
    {
        try
        {
            File fout = new File("A-large.out");
            FileOutputStream fos = new FileOutputStream(fout);

            bw = new BufferedWriter(new OutputStreamWriter(fos));
    
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void writeTicTacToeTomekOutputFile(String inputLine)
    {
        try
        {
            bw.write(inputLine);
            bw.newLine();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }

    private void closeTicTacToeTomekOutputFile()
    {
        try
        {
            bw.close();
        }catch (Exception e)
        {
            e.printStackTrace();
        }
    }
}
