package com.dijkstra.jam;

public class Dijkstra 
{
	int i_foundRepetion = 0;
	int i_fountOffSet = 0;
	int i_negativeCount = 0;
	
	int j_foundRepetion = 0;
	int j_fountOffSet = 0;
	int j_negativeCount = 0;
	
	int k_foundRepetion = 0;
	int k_fountOffSet = 0;
	int k_negativeCount = 0;
	
	int I_LETTER = 1;
	int J_LETTER = 2;
	int K_LETTER = 3;
	
	char multiplicativeCharStructure[][] = {{'1', 'i', 'j', 'k'},
											{'i', '1', 'k', 'j'},
											{'j', 'k', '1', 'i'},
											{'k', 'j', 'i', '1'}};
	
	int multiplicativeSignStructure[][] = {	{1, 1, 1, 1},
											{1, -1, 1, -1},
											{1, -1, -1, 1},
											{1 , 1, -1, -1}};
	
	int signOfLastOperation = 0;
	
	public Dijkstra() {
		// TODO Auto-generated constructor stub
	}
	
	public String evaluate(String wrongLine, int wrongLineLength, int wrongLineRepetition)
	{
		i_foundRepetion = 0;
		i_fountOffSet = 0;
		i_negativeCount = 0;
		
		j_foundRepetion = 0;
		j_fountOffSet = 0;
		j_negativeCount = 0;
		
		k_foundRepetion = 0;
		k_fountOffSet = 0;
		k_negativeCount = 0;
		
		System.out.println("Wrong Line Length Received : " + wrongLine.length());
		
		if(wrongLineLength <= 1)
		{
			return "NO";
		}
		
		boolean i_found = false, j_found = false, k_found = false, remaingClear = false;
		
		i_found = discoverI(wrongLine, wrongLineLength, wrongLineRepetition);
		
		if(i_found)
		{
			System.out.println("I found Repetition : " + i_foundRepetion);
			System.out.println("I found offset : " + i_fountOffSet);
		}
		
		j_found = i_found && discoverJ(wrongLine, wrongLineLength, wrongLineRepetition);
		k_found = j_found && discoverK(wrongLine, wrongLineLength, wrongLineRepetition);
		
		
		remaingClear = k_found && isRemainingClear(wrongLine, wrongLineLength, wrongLineRepetition);
		
		
		
		if(j_found)
		{
			System.out.println("J found Repetition : " + j_foundRepetion);
			System.out.println("J found offset : " + j_fountOffSet);
		}
		
		if(k_found)
		{
			System.out.println("K found Repetition : " + k_foundRepetion);
			System.out.println("K found offset : " + k_fountOffSet);
		}
		
		
		if(remaingClear)
		{
			return "YES";
		}
		
		/*
		if(discoverI(wrongLine, wrongLineLength, wrongLineRepetition))
		{
			System.out.println("I found Repetition : " + i_foundRepetion);
			System.out.println("I found offset : " + i_fountOffSet);
		}
		
		if(discoverJ(wrongLine, wrongLineLength, wrongLineRepetition))
		{
			System.out.println("J found Repetition : " + j_foundRepetion);
			System.out.println("J found offset : " + j_fountOffSet);
		}
		
		if(discoverK(wrongLine, wrongLineLength, wrongLineRepetition))
		{
			System.out.println("K found Repetition : " + k_foundRepetion);
			System.out.println("K found offset : " + k_fountOffSet);
		}
		
		if(isRemainingClear(wrongLine, wrongLineLength, wrongLineRepetition))
		{
			System.out.println("Remaining is good");
		}
		*/
		return "NO";
	}
	
	private boolean discoverI(String wrongLine, int wrongLineLength, int wrongLineRepetition)
	{
		boolean begin = true;
		
		char leftChar = '.', rightChar = '.', resultedChar = '.';
		
		for(int i = 0; i < wrongLineRepetition ; i++)
		{
			//System.out.println("Repetion : " + i);
			for(int j = 0 ; j < wrongLineLength ;)
			{
				signOfLastOperation = 0;
				
				if(begin)
				{
					leftChar = wrongLine.charAt(0);
					rightChar = wrongLine.charAt(1);
					
					if(leftChar == 'i' && i_negativeCount%2 == 0)
					{
						i_foundRepetion = 0;
						i_fountOffSet = 0;
						return true;
					}
					
					begin = false;
					j = 1;
				}else
				{
					if(resultedChar == '1')
					{
						if(j == wrongLineLength - 1)
						{
							resultedChar = wrongLine.charAt(j);
							if(resultedChar == 'i' && i_negativeCount%2 == 0)
							{
								i_foundRepetion = i;
								i_fountOffSet = j;
								return true;
							}
							break;
						}else
						{
							leftChar = wrongLine.charAt(j);
							if(leftChar == 'i' && i_negativeCount%2 == 0)
							{
								i_foundRepetion = i;
								i_fountOffSet = j;
								return true;
							}
							rightChar = wrongLine.charAt(j + 1);
							
							j++;
						}
					}else
					{
						leftChar = resultedChar;
						rightChar = wrongLine.charAt(j);
					}
					
				}
				
				//System.out.println(leftChar + "\t" + rightChar);
				
				resultedChar = getResultedChar(leftChar, rightChar);
				
				if(signOfLastOperation == -1)
				{
					i_negativeCount++;
				}
				
				if(resultedChar == 'i' && i_negativeCount%2 == 0)
				{
					i_foundRepetion = i;
					i_fountOffSet = j;
					return true;
				}
				
				
				j++;
			}
		}
		
		return false;
	}
	
	private boolean discoverJ(String wrongLine, int wrongLineLength, int wrongLineRepetition)
	{
		boolean begin = true;
		
		char leftChar = '.', rightChar = '.', resultedChar = '.';
		
		int i = i_foundRepetion;
		
		if(i_fountOffSet == wrongLineLength - 1)
		{
			i++;
			i_fountOffSet = -1;
		}
		
		for(; i < wrongLineRepetition ; i++)
		{
			//System.out.println("Repetion : " + i);
			
			int j = 0;
			if(begin)
			{
				j = i_fountOffSet + 1;
			}
			
			for(; j < wrongLineLength ;)
			{
				signOfLastOperation = 0;
				
				if(begin)
				{
					//System.out.println("Begin");
					if(j == wrongLineLength - 1)
					{
						resultedChar = wrongLine.charAt(j);
						
						if(resultedChar == 'j' && j_negativeCount%2 == 0)
						{
							j_foundRepetion = i;
							j_fountOffSet = j;
							return true;
						}
						
						begin = false;
						break;
					}else
					{
						leftChar = wrongLine.charAt(j);
						if(leftChar == 'j' && j_negativeCount%2 == 0)
						{
							j_foundRepetion = i;
							j_fountOffSet = j;
							return true;
						}
						rightChar = wrongLine.charAt(j + 1);
						
						j++;
					}
					
					
					begin = false;
				}else
				{
					if(resultedChar == '1')
					{
						if(j == wrongLineLength - 1)
						{
							resultedChar = wrongLine.charAt(j);
							if(resultedChar == 'j' && j_negativeCount%2 == 0)
							{
								j_foundRepetion = i;
								j_fountOffSet = j;
								return true;
							}
							break;
						}else
						{
							leftChar = wrongLine.charAt(j);
							if(leftChar == 'j' && j_negativeCount%2 == 0)
							{
								j_foundRepetion = i;
								j_fountOffSet = j;
								return true;
							}
							rightChar = wrongLine.charAt(j + 1);
							
							j++;
						}
					}else
					{
						leftChar = resultedChar;
						rightChar = wrongLine.charAt(j);
					}
					
				}
				
				//System.out.println(leftChar + "\t" + rightChar);
				
				resultedChar = getResultedChar(leftChar, rightChar);
				
				if(signOfLastOperation == -1)
				{
					j_negativeCount++;
				}
				
				if(resultedChar == 'j' && j_negativeCount%2 == 0)
				{
					j_foundRepetion = i;
					j_fountOffSet = j;
					return true;
				}
				
				
				j++;
			}
			
		}
		
		return false;
	}
	
	private boolean discoverK(String wrongLine, int wrongLineLength, int wrongLineRepetition)
	{
		boolean begin = true;
		
		char leftChar = '.', rightChar = '.', resultedChar = '.';
		
		int i = j_foundRepetion;
		
		if(j_fountOffSet == wrongLineLength - 1)
		{
			i++;
			j_fountOffSet = -1;
		}
		
		for(; i < wrongLineRepetition ; i++)
		{
			//System.out.println("Repetion : " + i);
			
			int j = 0;
			if(begin)
			{
				j = j_fountOffSet + 1;
			}
			
			for(; j < wrongLineLength ;)
			{
				signOfLastOperation = 0;
				
				//System.out.println("W");
				
				if(begin)
				{
					//System.out.println("Begin");
					if(j == wrongLineLength - 1)
					{
						resultedChar = wrongLine.charAt(j);
						
						if(resultedChar == 'k' && k_negativeCount%2 == 0)
						{
							k_foundRepetion = i;
							k_fountOffSet = j;
							return true;
						}
						
						begin = false;
						break;
					}else
					{
						leftChar = wrongLine.charAt(j);
						if(leftChar == 'k' && k_negativeCount%2 == 0)
						{
							k_foundRepetion = i;
							k_fountOffSet = j;
							return true;
						}
						rightChar = wrongLine.charAt(j + 1);
						
						j++;
					}
					
					begin = false;
				}else
				{
					if(resultedChar == '1')
					{
						if(j == wrongLineLength - 1)
						{
							resultedChar = wrongLine.charAt(j);
							if(resultedChar == 'k' && k_negativeCount%2 == 0)
							{
								k_foundRepetion = i;
								k_fountOffSet = j;
								return true;
							}
							break;
						}else
						{
							leftChar = wrongLine.charAt(j);
							if(leftChar == 'k' && k_negativeCount%2 == 0)
							{
								k_foundRepetion = i;
								k_fountOffSet = j;
								return true;
							}
							rightChar = wrongLine.charAt(j + 1);
							
							j++;
						}
					}else
					{
						leftChar = resultedChar;
						rightChar = wrongLine.charAt(j);
					}
					
				}
				
				//System.out.println(leftChar + "\t" + rightChar);
				
				resultedChar = getResultedChar(leftChar, rightChar);
				
				if(signOfLastOperation == -1)
				{
					k_negativeCount++;
				}
				
				if(resultedChar == 'k' && k_negativeCount%2 == 0)
				{
					k_foundRepetion = i;
					k_fountOffSet = j;
					return true;
				}
				
				
				j++;
			}
			
		}
		
		return false;
	}
	
	private boolean isRemainingClear(String wrongLine, int wrongLineLength, int wrongLineRepetition)
	{
		boolean begin = true;
		
		char leftChar = '.', rightChar = '.', resultedChar = '.';
		
		int remainingNegativeCount = 0;
		
		int i = k_foundRepetion;
		
		if(k_fountOffSet == wrongLineLength - 1)
		{
			i++;
			k_fountOffSet = -1;
		}
		
	
		
		for(; i < wrongLineRepetition ; i++)
		{
			//System.out.println("Repetion : " + i);
			
			
			int j = 0;
			if(begin)
			{
				j = k_fountOffSet + 1;
			}
			
			
			for( ; j < wrongLineLength ;)
			{
				signOfLastOperation = 0;
				
				if(begin)
				{
					//System.out.println("Begin");
					if(j == wrongLineLength - 1)
					{
						resultedChar = wrongLine.charAt(j);
						
						begin = false;
						break;
					}else
					{
						leftChar = wrongLine.charAt(j);
						rightChar = wrongLine.charAt(j + 1);
						
						j++;
					}
					
					begin = false;
				}else
				{
					if(resultedChar == '1')
					{
						if(j == wrongLineLength - 1)
						{
							resultedChar = wrongLine.charAt(j);
							break;
						}else
						{
							leftChar = wrongLine.charAt(j);
							rightChar = wrongLine.charAt(j + 1);
							
							j++;
						}
					}else
					{
						leftChar = resultedChar;
						rightChar = wrongLine.charAt(j);
					}
					
				}
				
				//System.out.println(leftChar + "\t" + rightChar);
				
				resultedChar = getResultedChar(leftChar, rightChar);
				
				if(signOfLastOperation == -1)
				{
					remainingNegativeCount++;
				}
			
				j++;
			}
		}
		
		
		
		if((resultedChar == '1' && remainingNegativeCount%2 == 0) || resultedChar == '.')
		{
			//System.out.println("REMAIN GOOD");
			return true;
		}else
		{
			//System.out.println("REMAIN BAD");
			return false;
		}
		
	}
	
	private char getResultedChar(char leftChar, char rightChar)
	{
		int leftArrayInd = getArrayIndexOfChar(leftChar);
		int rightArrayInd = getArrayIndexOfChar(rightChar);
		
		char resultedChar = multiplicativeCharStructure[leftArrayInd][rightArrayInd];
		signOfLastOperation = multiplicativeSignStructure[leftArrayInd][rightArrayInd];
		
		return resultedChar;
	}
	
	private int getArrayIndexOfChar(char c)
	{
		if(c == 'i')
		{
			return I_LETTER;
		}else if(c == 'j')
		{
			return J_LETTER;
		}else if(c == 'k')
		{
			return K_LETTER;
		}else
		{
			return -1;
		}
	}

}
