import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class Lawnmower {
	BufferedReader reader = null;
	BufferedWriter writer = null;
	
	public void loadDataFromFile(String fileName){
		File file = new File(fileName);

		try {
			//Define file reader
			reader = new BufferedReader(new FileReader(file));
			
			//Define file writer
			writer = new BufferedWriter(new FileWriter("B-large.out"));
			
			String line = reader.readLine();
			int T = Integer.parseInt(line);
			
			for(int i=0;i<T;i++){		
				String sizeLine = reader.readLine();
				String []sizeString = sizeLine.split(" ");
				int row = Integer.parseInt(sizeString[0]);
				int column = Integer.parseInt(sizeString[1]);
				
				int [][]data = new int[row][column];
				
				for(int j=0;j<row;j++){
					String rowData = reader.readLine();
					String []dataString = rowData.split(" ");
					
					int k;
					for(k=0;k<column;k++){
						data[j][k] = Integer.parseInt(dataString[k]);
					}
				}
				
				boolean result = checkLarge(row, column, data);
				String outputString = result?"YES":"NO";
				writer.write("Case #" + (i+1) + ": " + outputString + "\n");
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
			try {
				reader.close();
				writer.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	/*
	 * There must be a row or column cross the lowest point
	 */
	public boolean checkSmall(int row, int column, int [][]data){
		for(int i=0;i<row;i++){
			for(int j=0;j<column;j++){
				if(data[i][j]==1){
					int m=0;
					//check row and column
					boolean hasRow = true;
					boolean hasColumn = true;
					for(m=0;m<row;m++){
						if(data[m][j] !=1){
							hasRow = false;
							break;
						}
					}
					for(m=0;m<column;m++){
						if(data[i][m] !=1){
							hasColumn = false;
							break;
						}
					}
					if(!(hasRow||hasColumn)){
						return false;
					} 
				}
			}
		}
		return true;
	}
	
	/*
	 * There must be a row or column cross the lowest point
	 */
	public boolean checkLarge(int row, int column, int [][]data){
		boolean isVPossible = true;
		boolean isHPossible = true;
		
		//check the smallest element with row first
		for(int i=0;i<row;i++){
			int min = 101;
			int minIndexJ = -1;
			for(int j=0;j<column;j++){
				if(data[i][j]<min){
					min = data[i][j];
					minIndexJ = j;
				}
			}
			
			//check for the column of the minimal element
			for(int k=0;k<row;k++){
				//find the bigger one, impossible
				if(data[k][minIndexJ]>min){
					isVPossible =  false;
				}
			}
		}
		
		//check the smallest element with column first
		for(int j=0;j<column;j++){
			int min = 101;
			int minIndexI = -1;
			for(int i=0;i<row;i++){
				if(data[i][j]<min){
					min = data[i][j];
					minIndexI = i;
				}
			}
			
			//check for the column of the minimal element
			for(int k=0;k<column;k++){
				//find the bigger one, impossible
				if(data[minIndexI][k]>min){
					isHPossible = false;
				}
			}
		}
		return isVPossible||isHPossible;
	}
	
	
	public static void main(String []args){
		Lawnmower test = new Lawnmower();
		test.loadDataFromFile("B-large.in");
	}
}
