package Support;

import java.util.ArrayList;

public class BigInteger {
	public String number;
	public ArrayList<Integer> digits = null;
	public int length = 0;
	
	public BigInteger(String number){
		this.number = number;
		char[]numberChar = number.toCharArray();
		length = numberChar.length;
		digits = new ArrayList<Integer>();
		for(int i=0;i<length;i++){
			digits.add((int)numberChar[length-1-i]-48);
//			System.out.println(digits.get(i));
		}
	}
	
	/*
	 * Digits marker with binary number, the lowest position means 0, highest is 9.
	 */
	public short getDigitsContent(){
		short digitsContent = 0b00_0000_0000;
		for(int i=0;i<this.length;i++){
			digitsContent|=(short)Math.pow(2, this.digits.get(i));
		}
		return digitsContent;
	}
	
	public Object[] getIntegerArray(){
		return this.digits.toArray();
	}
	
	public void add(BigInteger addNumber){
		int calcuLength = this.length < addNumber.length ? this.length : addNumber.length;
		
		boolean isCarry = false;
		for(int i=0;i<calcuLength;i++){
			int temp = this.digits.get(i)+addNumber.digits.get(i);
			if(isCarry){
				temp++;
				isCarry = false;
			}
			if(temp >= 10){
				this.digits.set(i, temp-10);
				isCarry = true;
			} else {
				this.digits.set(i, temp);
			}
		}
		
		//If this number is bigger
		if(this.length > calcuLength){
			for(int i=calcuLength;i<this.length;i++){
				int temp = this.digits.get(i); 
				if(isCarry){
					temp++;
					isCarry = false;
				}
				if(temp>=10){
					this.digits.set(i, temp-10);
					isCarry = true;
				} else {
					this.digits.set(i, temp);
				}
			}
		} else {
			//If the add Number is bigger
			for(int i=calcuLength;i<addNumber.length;i++){
				int temp = addNumber.digits.get(i); 
				if(isCarry){
					temp++;
					isCarry = false;
				}
				if(temp>=10){
					this.digits.add(temp-10);
					isCarry = true;
				} else {
					this.digits.add(temp);
				}
			}
		}
		
		if(isCarry){
			this.digits.add(1);
		}
		
		this.length = this.digits.size();
	}
	
	public void print(){
		System.out.println(this.toString());
	}
	
	public String toString(){
		StringBuilder builder = new StringBuilder();
		for(int i=0;i<this.length;i++){
			builder.append(this.digits.get(length-1-i));
		}
		return builder.toString();
	}
	
	public static void main(String []args){
		BigInteger t1 = new BigInteger("999999");
		BigInteger t2 = new BigInteger("99");
		t1.print();
		t1.add(t2);
		t1.print();
	}
}
