package Qeustion;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;

import Support.BigInteger;

public class CountingSheep {
	BufferedReader reader = null;
	BufferedWriter writer = null;
	
	String inputFileName = "A-small.in";
	String outputFileName = "A-small-attempt0.out";
	
	public void loadDataFromFile(String fileName){
//		File file = new File(fileName);

		try {
			//Define file reader
			reader = new BufferedReader(new FileReader(fileName));
			
			//Define file writer
			writer = new BufferedWriter(new FileWriter(outputFileName));
			
			String line = reader.readLine();
			int T = Integer.parseInt(line);
			
			for(int i=0;i<T;i++){		
//				System.out.println(reader.readLine());
				String inputString = reader.readLine();
				String result = this.isCompleted(inputString);
				
				writer.write("Case #" + (i+1) + ": " + result + "\n");
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
			try {
				reader.close();
				writer.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	public String isCompleted(String inputString){
		BigInteger inputInteger = new BigInteger(inputString);
		
		if(inputString.equals("0")){
			System.out.println("INSOMNIA");
			return "INSOMNIA";
		}
		
		/*
		 * Digits marker with binary number, the lowest position means 0, highest is 9.
		 * If any number has been found, than set the corresponding position as 1
		 */
		short digitsMarker = 0b00_0000_0000; 
//		System.out.println(Integer.toBinaryString(digitsMarker|1));
		
		//Check whether the beginning number has already included all digits
		short currentDigitsContent = inputInteger.getDigitsContent();
		digitsMarker |= currentDigitsContent;
		if(digitsMarker == 0b11_1111_1111){
			System.out.println("ALready Found");
			return inputString;
		} else {
			System.out.println(Integer.toBinaryString(digitsMarker));
		}
		
		//loop for the times of N. For safety, only 1000 times is allowed
		int times = 0;
		BigInteger currentNumber = new BigInteger(inputString);
		for(times = 0;times<1000;times++){
			currentNumber.add(inputInteger);
			currentDigitsContent = currentNumber.getDigitsContent();
			digitsMarker |= currentDigitsContent;
			if(digitsMarker == 0b11_1111_1111){
				System.out.println("Found: " + currentNumber.toString());
				return currentNumber.toString();
			}
			System.out.println(currentNumber.toString());
		}
		System.out.println("INSOMNIA");
		return "INSOMNIA";
	}
	
	public static void main(String []args){
		CountingSheep test = new CountingSheep();
		test.loadDataFromFile("A-small-attempt0.in");
//		test.isCompleted("0");
	}
}
