import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class TicTacToeTomek {
	BufferedReader reader = null;
	BufferedWriter writer = null;
	
	
	public void loadDataFromFile(String fileName){
		File file = new File(fileName);

		
		try {
			reader = new BufferedReader(new FileReader(file));
			
			//Define file writer
			writer = new BufferedWriter(new FileWriter("A-large.out"));
			
			String line = reader.readLine();
			int T = Integer.parseInt(line);
			
			for(int i=0;i<T;i++){
				/*
				 * X=1, O=-1, T=0, .=20 
				 */
				int [][]data = new int[4][4];
//				char [][]data = new char[4][4];
				for(int j=0;j<4;j++){
					String board = reader.readLine();
					for(int k = 0;k<board.length();k++){
						switch (board.charAt(k)){
						case 'X': data[j][k] = 1;break;
						case 'O': data[j][k] = -1;break;
						case 'T': data[j][k] = 0;break;
						case '.': data[j][k] = 20;break;
						default: System.out.println("errror");
						}
					}
				}
				int result = calculate(data);
		
				switch(result){
				case 1: writer.write("Case #" + (i+1) + ": X won \n");break;
				case -1: writer.write("Case #" + (i+1) + ": O won \n");break;
				case 20: writer.write("Case #" + (i+1) + ": Game has not completed \n");break;
				case 0: writer.write("Case #" + (i+1) + ": Draw \n");break;
				default: System.out.println("Errrrrrr");
				}
				
				reader.readLine();
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
			try {
				reader.close();
				writer.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	public int calculate(int [][]data){
		int totalSum = 0;
		for(int i=0;i<4;i++){
			int sum = data[i][0]+data[i][1]+data[i][2]+data[i][3];
			if(sum>=3 && sum<17){
				return 1;
			}
			if(sum<=-3) return -1;
			
			
			sum = data[0][i]+data[1][i]+data[2][i]+data[3][i];
			if(sum>=3 && sum<17){
				return 1;
			}
			if(sum<=-3) return -1;
			
			totalSum+=sum;
		}
		
		int diagol = data[0][0]+data[1][1]+data[2][2]+data[3][3];
		if(diagol>=3 && diagol<17) return 1;
		if(diagol<=-3) return -1;
		
		diagol = data[0][3]+data[1][2]+data[2][1]+data[3][0];
		if(diagol>=3 && diagol<17) return 1;
		if(diagol<=-3) return -1;
		
		//not finisched
		if(totalSum>16) return 20;
		//Draw
		else return 0;
	}
	
	public static void main(String []args){
		TicTacToeTomek test = new TicTacToeTomek();
		test.loadDataFromFile("A-large.in");
	}
}
