
public class OminousOmino {
	
	/* The maximal size of the length and width of the Omino, which has longest perimeter (evil element). Saved with grade-1
	 * please note: the evil element size for 2-Omino is 1, because this omino can reduce it's size during a rotation
	 * 
	 * Evil Element for grade 5
	 * # #
	 *   # #
	 *     #
	 *     
	 * Evil Element for grade 6
	 * # #
	 *   # #
	 *     # #
	 */
	
	private int[] evilElementSize = {1, 1, 2, 3, 3, 4};
	
	//The maximal number of Obtuse angle (270 degree), that a n-Omino can create. Saved with grade-1
	private int[] evilElementObtuse = {0, 0, 1, 2, 3, 4};
	/**
	 * 
	 * @param x
	 * @param row
	 * @param column
	 * @return 0 for RICHARD, 1 for GABRIEL
	 */
	public int findWinner(int x, int row, int column){
		System.out.println(x + " " + row + " " + column);
		int gridArea = row*column;
		
		/*
		 * Gabriel can not win, if X bigger than 6, because the Omino with size bigger than 7 could have a hole inside. 
		 * Richard only need to choose such Omino at beginning.
		 */
		if(x>6){
			return 0;
		}
		
		//no enough place
		if(gridArea<x){
			return 0;
		}
		
		//select evilElement
		if(row<evilElementSize[x-1]||column<evilElementSize[x-1]){
			return 0;
		}
		
		//grid area can't exactly divided by Omino
		if(gridArea%x != 0){
			return 0;
		}
		
		/*
		 * The max number of the obtuse angle decided the minimum number of the n-omino, which must to be used to fill the whole grid.
		 * Take 4-Omino as an example, the minimum grid should be 4*3=12, because if Richard selects the following Omino, 
		 * we need minimum 2 others to fill the whole gird.
		 *    # #
		 *  # # 
		 */
		if(gridArea/x < (evilElementObtuse[x-1]+1)){
			return 0;
		}
		
		return 1;
	}
}
