import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class StandardIO {
	private int TestCount = 0;
	private int[] intResult;
	
	private StandingOvation ovation = new StandingOvation();
	
	public void getInput(String fileName){
		File inputFile = new File(fileName);
		try {
			BufferedReader br = new BufferedReader(new FileReader(inputFile));
			StringBuilder sb = new StringBuilder();
			String line = br.readLine();
			
			this.TestCount = Integer.parseInt(line);
			this.intResult = new int[this.TestCount];
			
			for(int i=0;i<this.TestCount;i++){
				line = br.readLine();
				
				//input for StandingOvation
//				char[] chars = line.toCharArray();
//				//Only for the input S_max smaller than 10
//				int S_max = (int)chars[0] - 48;
////				System.out.println(S_max);

				
				String []subStrings = line.split(" ");
				int S_max = Integer.parseInt(subStrings[0]);
				
				int[] people = new int[S_max+1];
				char[] chars = subStrings[1].toCharArray();
				for(int j=0;j<S_max+1;j++){
//					people[j] = (int)chars[j+2] - 48;
					people[j] = (int)chars[j]-48;
				}
				
				
				intResult[i] = ovation.findMinFriend(S_max, people);
			}
			
			br.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} 
	}
	
	public void createOutPut(String fileName){
		File outputFile = new File(fileName);
		try {
			BufferedWriter bw = new BufferedWriter(new FileWriter(outputFile));
			
			for(int i=0;i<this.intResult.length;i++){
				String str = "Case #" + (i+1) + ": " + this.intResult[i] + "\n";
				bw.write(str);
				bw.newLine();
			}
			
			bw.close();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	public static void main(String []args){
		StandardIO standard = new StandardIO();
		standard.getInput("A-large.in");
		standard.createOutPut("A-large.out");
	}
}
