import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;


public class FairAndSquare {
	BufferedReader reader = null;
	BufferedWriter writer = null;
	
	public void loadDataFromFile(String fileName){
		File file = new File(fileName);

		try {
			//Define file reader
			reader = new BufferedReader(new FileReader(file));
			
			//Define file writer
			writer = new BufferedWriter(new FileWriter("C-small-attempt0.out"));
			
			String line = reader.readLine();
			int T = Integer.parseInt(line);
			
			for(int i=0;i<T;i++){		
				String intervalLine = reader.readLine();
				String []intervalString = intervalLine.split(" ");
				long begin = Long.parseLong(intervalString[0]);
				long end = Long.parseLong(intervalString[1]);
				
			
				int count = checkSmall(begin, end);
				writer.write("Case #" + (i+1) + ": " + count + "\n");
			}
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		} catch (IOException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}finally {
			try {
				reader.close();
				writer.close();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
	}
	
	/*
	 * Interval between 1-1000
	 */
	public int checkSmall(long begin, long end){
		long minPal = (int) Math.ceil(Math.sqrt(begin));
		long maxPal = (int) Math.sqrt(end);
		int counter = 0;
		for(long i=minPal;i<=maxPal;i++){
//			System.out.println(i);
			//original number
			boolean oResult = checkPalindrome(i);
			
			//square
			if(oResult){				
				boolean sResult = checkPalindrome(i*i);
				if(sResult) counter++;
			}
		}
		return counter;
	}
	
	
	public boolean checkPalindrome(long number){
		String s = String.valueOf(number);
		
		for(int i=0;i<(s.length()/2+1);i++){
			if(s.charAt(i) != s.charAt(s.length()-i-1)){
				return false;
			}
		}
		return true;
	}
	
	
	public static void main(String []args){
		FairAndSquare test = new FairAndSquare();
		test.loadDataFromFile("C-small-attempt0.in");
	}
	
	
}
