import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileReader;
import java.io.FileWriter;
import java.util.LinkedList;
import java.util.List;


public class FairAndSquare {

	public static void doStuff(int nr, List<int[]> input, int[] output){
		//for every problem
		for(int i=0; i<nr; i++){
			int res=0;
			int a = 0;
			int aS;
			int b = 0;
			int bS;
			a = input.get(i)[0];
			b = input.get(i)[1];
			//Interval for roots
			aS = (int) Math.ceil(Math.sqrt(a));
			bS = (int) Math.floor(Math.sqrt(b));
			//get all palindroms in the root interval
			List<Integer> allRoots = allPalin(aS,bS);
			//check if sqare of root is plaindrom also
			for(int root:allRoots){
				if(isPalin(root*root)) res++;
			}
			output[i]=res;
		}
	}
	
	//get all palindroms in an intervall from a to b
	public static List<Integer> allPalin(int a, int b) {
		List<Integer> all = new LinkedList<Integer>();
		for (int i = a; i <= b; i++) {
			if(isPalin(i)) all.add(i);
		}
		return all;

	}
	
	//check if an integer is a palindrom
	public static boolean isPalin(int x){
		char[] current = (""+x).toCharArray();
		for(int i=0; i<current.length/2;i++){
			if(current[i] != current[(current.length-(i+1))]){
				return false;
			}
		}
		return true;
	}
	
	public static void main(String[] args) {

		String nameIn = "Input.in.txt";
		String nameOut = "Output.out.txt";
		int nr = 0;
		int[] output = null;
		List<int[]> input = new LinkedList<int[]>();
		
		// save input
		try {
			BufferedReader br = new BufferedReader(new FileReader(nameIn));
			nr = Integer.parseInt(br.readLine());
			output = new int[nr];
			int[] current;
			String currentLine;
			String[] currentNum;
			System.out.println("###Input:###");
			System.out.println(nr);
			// Read File Line By Line
			for(int i = 1; i<=nr; i++){
				currentLine = br.readLine();
				currentNum = currentLine.split(" ");
				current = new int[2];
				current[0] = Integer.parseInt(currentNum[0]);
				current[1] = Integer.parseInt(currentNum[1]);
				System.out.println(current[0] + ";" + current[1]);
				input.add(current);	
			}
			// Close the input stream
			br.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		
		//Call stuff
		doStuff(nr, input, output);
		
		//Save result to file
		try {
			// Get the object of DataInputStream
			BufferedWriter bw = new BufferedWriter(new FileWriter(nameOut));
			System.out.println("###Output:###");
			// Write File Line By Line
			for(int i = 1; i<=nr; i++){
				bw.write("Case #" + i + ": " + output[i-1]);
				bw.newLine();
				System.out.println(output[i-1]);
			}
			// Close the input stream
			bw.close();
		} catch (Exception e) {// Catch exception if any
			System.err.println("Error: " + e.getMessage());
		}
		
		//save output
		

	}

}
