import java.util.*;
import java.io.*;

public class A {

	// List of motes is sorted
	public static int solve(int size, List<Integer> motes) {
		int adds = 0;
		int removes = 0;
		List<Integer> removed = new LinkedList<Integer>();
		// will never be able to eat anything
		if(size == 1){
			return motes.size();
		}
		
		while (!motes.isEmpty()) {
			System.out.println("Current size: " + size);
			// if smaller: Eat
			int current = motes.get(0);
			if (current < size) {
				System.out.println("Eat mote of size: " + current);
				size += current;
				motes.remove(0);
			}
			// nothing can be eaten
			else {
				int dist = current - size + 1;
				if (dist < size) {
					System.out.println("Add mote of size: " + (size-1) + " and eat it");
					size = 2*size -1;
					adds++;
				} else {
					removed.add(current);
					motes.remove(0);
					System.out.println("Remove mote of size: " + current);
					removes++;
				}
			}
		}

		//check if removes can be replaced by lower number of adds
		if(removes>=2){
			int nexttry = solve(2*size-1, removed);
			if (nexttry+1<removes){
				removes = nexttry+1;
			}
		}
		
		// always try to add first, remove when you can't add anymore
		return (adds + removes);
	}

	public static void main(String[] args) throws Exception {
		String nameIn = "Input.in.txt";
		String nameOut = "Output.out.txt";

		int nr = 0;
		int output = 0;
		int moteSize = 0;
		int moteNr = 0;
		List<Integer> motes = null;

		Scanner sc = new Scanner(new FileReader(nameIn));
		PrintWriter pr = new PrintWriter(new FileWriter(nameOut));
		nr = sc.nextInt();
		System.out.println(nr);

		for (int i = 1; i <= nr; i++) {
			moteSize = sc.nextInt();
			moteNr = sc.nextInt();
			System.out.println("Processing Case #" + i
					+ " with a mote of size " + moteSize + " and " + moteNr
					+ " motes");
			motes = new LinkedList<Integer>();
			for (int j = 0; j < moteNr; j++) {
				motes.add(sc.nextInt());
			}
			Collections.sort(motes);
			output = solve(moteSize, motes);
			System.out.println("Case #" + i + ": " + output);
			pr.println("Case #" + i + ": " + output);
		}

		pr.flush();
		pr.close();
		sc.close();

	}

}
