import java.io.FileReader;
import java.io.FileWriter;
import java.io.PrintWriter;
import java.math.BigInteger;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class A_Large {

	// List of motes is sorted
		public static int solve(BigInteger size, List<BigInteger> motes) {
			int adds = 0;
			int removes = 0;
			List<BigInteger> removed = new LinkedList<BigInteger>();
			// will never be able to eat anything
			if(size.compareTo(BigInteger.valueOf(1)) == 0){
				return motes.size();
			}
			
			while (!motes.isEmpty()) {
				//System.out.println("Current size: " + size);
				// if smaller: Eat
				BigInteger current = motes.get(0);
				if (current.compareTo(size) == -1) {
					//System.out.println("Eat mote of size: " + current);
					size.add(current);
					motes.remove(0);
				}
				// nothing can be eaten
				else {
					BigInteger dist = current.subtract(size).add(BigInteger.ONE);
					if (dist.compareTo(size) == -1) {
						//System.out.println("Add mote of size: " + (size.subtract(BigInteger.ONE)) + " and eat it");
						size = size.multiply(BigInteger.valueOf(2)).subtract(BigInteger.ONE);
						adds++;
					} else {
						removed.add(current);
						motes.remove(0);
						//System.out.println("Remove mote of size: " + current);
						removes++;
					}
				}
			}

			//check if removes can be replaced by lower number of adds
			if(removes>=2){
				int nexttry = solve(size.multiply(BigInteger.valueOf(2)).subtract(BigInteger.ONE), removed);
				if (nexttry+1<removes){
					removes = nexttry+1;
				}
			}
			
			// always try to add first, remove when you can't add anymore
			return (adds + removes);
		}

		public static void main(String[] args) throws Exception {
			String nameIn = "Input.in.txt";
			String nameOut = "Output.out.txt";

			int nr = 0;
			int output = 0;
			BigInteger moteSize = BigInteger.ZERO;
			int moteNr = 0;
			List<BigInteger> motes = null;

			Scanner sc = new Scanner(new FileReader(nameIn));
			PrintWriter pr = new PrintWriter(new FileWriter(nameOut));
			nr = sc.nextInt();
			System.out.println(nr);

			for (int i = 1; i <= nr; i++) {
				moteSize = sc.nextBigInteger();
				moteNr = sc.nextInt();
				System.out.println("Processing Case #" + i
						+ " with a mote of size " + moteSize + " and " + moteNr
						+ " motes");
				motes = new LinkedList<BigInteger>();
				for (int j = 0; j < moteNr; j++) {
					motes.add(sc.nextBigInteger());
				}
				Collections.sort(motes);
				output = solve(moteSize, motes);
				System.out.println("Case #" + i + ": " + output);
				pr.println("Case #" + i + ": " + output);
			}

			pr.flush();
			pr.close();
			sc.close();

		}

}
