import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.Arrays;
import java.util.TreeSet;


public class FairAndSquare {
	
	public static boolean isPalindrome(final long num) {
		final String s = Long.toString(num);
		return s.equals(new StringBuffer(s).reverse().toString());
	}
	
	public static int getCount(final long[] map, int tail, long start, long end) {
		int ps = Arrays.binarySearch(map, 0, tail, start);
		if (ps < 0) {
			ps = -ps - 1;
		}
		int pe = Arrays.binarySearch(map, 0, tail, end);
		if (pe < 0) {
			pe = -pe - 2;
		}
		return pe - ps + 1;
	}

	public static void main(String[] args) {
		long[] map = new long[10000000];
		long start = 1;
		long end = (long) Math.sqrt(1000);
		long n = start;
		int count = 0;
		while (n <= end) {
			if (isPalindrome(n) && isPalindrome(n * n)) {
				map[count] = n * n;
				count++;
			}
			n++;
		}
		
		try {
			BufferedReader in = new BufferedReader(new FileReader(args[0]));
			BufferedWriter out = new BufferedWriter(new FileWriter(args[1]));
			int cases = Integer.valueOf(in.readLine());
			String line;
			for (int c = 1; c <= cases; c++) {
				line = in.readLine();
				String[] tmp = line.split(" ");
				long cs = Long.valueOf(tmp[0]);
				long ce = Long.valueOf(tmp[1]);
				int result = getCount(map, count, cs, ce);
				out.write("Case #" + c + ": " + result + "\n");
			}
			in.close();
			out.close();
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
