import java.io.FileInputStream;
import java.io.InputStream;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Scanner;
import java.util.TreeSet;


public class Test {
    static BigInteger gcd(BigInteger a, BigInteger b) {
        if (a.equals(BigInteger.ZERO)) {
            return b;
        }
        if (b.equals(BigInteger.ZERO)) {
            return a;
        }
        return gcd(b, a.mod(b));
    }
    static BigInteger solve(TreeSet<String> tree) {
        BigInteger[] big = new BigInteger[tree.size()];
        int idx = 0;
        for (String x : tree) {
            big[idx++] = new BigInteger(x);
        }
        Arrays.sort(big);
        if (big.length == 1) {
            return BigInteger.ONE;
        }
        if (big.length == 2) {
            return big[1].subtract(big[0]);
        }
        for (int i = 0; i < big.length - 1; ++i) {
            big[i] = big[i + 1].subtract(big[i]);
        }
        BigInteger temp = big[0];
        for (int i = 1; i < big.length - 1; ++i) {
            temp = gcd(temp, big[i]);
        }
        return temp;
    }
    /**
     * @param args
     */
    public static void main(String[] args) throws Exception {
        // TODO Auto-generated method stub
        InputStream input = new FileInputStream("B-large.in");
        Scanner cin = new Scanner(input);
//        Scanner cin = new Scanner(System.in);
        int C = cin.nextInt();
        for (int i = 1; i <= C; ++i) {
            int N = cin.nextInt();
            TreeSet<String> tree = new TreeSet<String>();
            for (int j = 0; j < N; ++j) {
                tree.add(cin.next());
            }
            BigInteger small = new BigInteger(tree.first());
            BigInteger rs = solve(tree);
            small = small.mod(rs);
            if (!small.equals(BigInteger.ZERO)) {
                small = rs.subtract(small);
            }
            System.out.printf("Case #%d: %s\n", i, small);
        }
    }

}
