import java.io.FileInputStream;
import java.io.InputStream;
import java.math.BigInteger;
import java.util.Arrays;
import java.util.Map;
import java.util.Scanner;
import java.util.TreeMap;
import java.util.TreeSet;
import java.util.Map.Entry;


public class Test {
	static public class BIT 
	{
		int n;
		long[] p;
		
		public BIT(int _n) {
			n = _n;
			p = new long[n + 10];
		}

		public void add(int idx, long val) { // idx > 0, so idx always be "x+1"
			for (int x = idx; x <= n; x += (x & -x))
				p[x] += val;
		}

		long cal(int idx) { // idx > 0, so idx always be "x+1"
			long sum = 0;
			for (int x = idx; x > 0; x -= (x & -x))
				sum += p[x];
			return sum;
		}

		public long range(int a, int b) {
			return cal(Math.min(Math.max(b, 0), n))
					- cal(Math.min(Math.max(a - 1, 0), n));
		}
		
		public void clear()
		{
			Arrays.fill(p, 0);
		}
	}
    static int solve(TreeMap<Integer, Integer> tree) {
        int n = tree.size();
        BIT bit = new BIT(10010);
        int ans = 0;
        for (Map.Entry<Integer, Integer> entry : tree.entrySet()) {
        	int b = entry.getValue();
        	ans += bit.range(b + 1, Integer.MAX_VALUE);
        	bit.add(b, 1);
        }
        return ans;
    }
    /**
     * @param args
     */
    public static void main(String[] args) throws Exception {
        // TODO Auto-generated method stub
        InputStream input = new FileInputStream("A-large.in");
        Scanner cin = new Scanner(input);
//        Scanner cin = new Scanner(System.in);
        int C = cin.nextInt();
        for (int i = 1; i <= C; ++i) {
            int N = cin.nextInt();
            TreeMap<Integer, Integer> tree =  new TreeMap<Integer, Integer>();
            for (int j = 0; j < N; ++j) {
            	int a = cin.nextInt();
                int b = cin.nextInt();
                tree.put(a, b);
            }         
            
            int ans = solve(tree);
            System.out.printf("Case #%d: %d\n", i, ans);
        }
    }

}
