// tested with JDK 1.6

import java.util.*;
import java.io.*;
import java.math.*;

public class FairWarning {

	public static void solve(int nTest, ArrayList<BigInteger> lst) {
		BigInteger smallest = lst.get(0);
		for (int i = 1; i < lst.size(); ++i) {
			if (smallest.compareTo(lst.get(i)) > 0) {
				smallest = lst.get(i);
			}
		}
		
		BigInteger gcd = null;
		for (int i = 0; i < lst.size(); ++i) {
			BigInteger crt = lst.get(i);
			if (crt.compareTo(smallest) != 0) {
				BigInteger crtDiff = crt.subtract(smallest);
				if (gcd == null) {
					gcd = crtDiff;
				}
				else {
					gcd = gcd.gcd(crtDiff);
				}
			}
		}
		//System.out.println("gcd=" + gcd.toString());
		BigInteger result = new BigInteger("0");
		BigInteger rmnd = lst.get(0).mod(gcd);
		//System.out.println("gcd=" + gcd.toString() + " result=" + result.toString() + " rmnd=" + rmnd.toString());
		if (!rmnd.equals(result)) {
			result = gcd.subtract(rmnd); 
		}
		System.out.println("Case #" + nTest + ": " + result.toString());
	}

	/**
	 * @param args
	 * @throws IOException 
	 */
	public static void main(String[] args) throws IOException {
		/*{
			ArrayList<BigInteger> lst = new ArrayList<BigInteger>();
			lst.add(new BigInteger("123"));
			lst.add(new BigInteger("72"));
			lst.add(new BigInteger("108"));
			solve(0, lst);
		}

		{
			ArrayList<BigInteger> lst = new ArrayList<BigInteger>();
			lst.add(new BigInteger("26000000"));
			lst.add(new BigInteger("11000000"));
			lst.add(new BigInteger("6000000"));
			solve(1, lst);
		}

		{
			ArrayList<BigInteger> lst = new ArrayList<BigInteger>();
			lst.add(new BigInteger("1"));
			lst.add(new BigInteger("10"));
			lst.add(new BigInteger("11"));
			solve(2, lst);
		}

		{
			ArrayList<BigInteger> lst = new ArrayList<BigInteger>();
			lst.add(new BigInteger("800000000000000000001"));
			lst.add(new BigInteger("900000000000000000001"));
			solve(3, lst);
		}*/
		
		//System.out.println(args[0]);
		FileReader reader = new FileReader(new File(args[0]));
		//BufferedReader input =  new BufferedReader(new FileReader(in));
		Scanner s = new Scanner(new BufferedReader(reader));
		
		int nTests = Integer.decode(s.next());
		for (int i = 0; i < nTests; ++i)
		{
			int nTstSize = Integer.decode(s.next());
			ArrayList<BigInteger> lst = new ArrayList<BigInteger>();
			for (int j = 0; j < nTstSize; ++j)
			{
				lst.add(new BigInteger(s.next()));
			}
			solve(i + 1, lst);
		}
		
		reader.close();
	}

}
