package net.ciobi;

import java.io.*;
import java.math.*;
import java.util.*;

/**
 * Created with IntelliJ IDEA.
 * User: ciobi
 * Date: 2013-04-12
 * Time: 20:23
 * <p/>
 */
public class Gcj {

    static boolean isPalindrome(BigDecimal b) {
        String s = b.toPlainString();
        for (int i = 0; i < (s.length() + 1) / 2; ++i) {
            if (s.charAt(i) != s.charAt(s.length() - 1 - i)) {
                return false;
            }
        }
        return true;
    }

    static BigDecimal checkSquare(String s) {
        if (s.isEmpty()) {
            return null;
        }
        BigDecimal d = new BigDecimal(s);
        BigDecimal sq = d.multiply(d);
        return isPalindrome(sq) ? sq : null;
    }

    static TreeSet<BigDecimal> set = new TreeSet<BigDecimal>();

    static void process(String file) throws Exception {
        //FileInputStream
        FileReader fileReader = new FileReader(file);
        BufferedReader br = new BufferedReader(fileReader);
        int t = Integer.parseInt(br.readLine());
        for (int i = 1; i <= t; ++i) {
            String s = br.readLine();
            String[] a = s.split(" ");
            BigDecimal b1 = new BigDecimal(a[0]);
            BigDecimal b2 = new BigDecimal(a[1]);
            int cnt = 0;
            for (BigDecimal d : set) {
                if (d.compareTo(b1) >= 0 && d.compareTo(b2) <= 0) {
                    ++cnt;
                }
            }
            System.out.printf("Case #%d: %d%n", i, cnt);
        }
    }

    public static void main(String[] args) throws Exception {

        /*{ String s = "1"; BigDecimal d = new BigDecimal(s); System.out.println(s + ": " + isPalindrome(d)); }
        { String s = "10"; BigDecimal d = new BigDecimal(s); System.out.println(s + ": " + isPalindrome(d)); }
        { String s = "131"; BigDecimal d = new BigDecimal(s); System.out.println(s + ": " + isPalindrome(d)); }
        { String s = "3476"; BigDecimal d = new BigDecimal(s); System.out.println(s + ": " + isPalindrome(d)); }
        { String s = "6776"; BigDecimal d = new BigDecimal(s); System.out.println(s + ": " + isPalindrome(d)); }
        { String s = "67876"; BigDecimal d = new BigDecimal(s); System.out.println(s + ": " + isPalindrome(d)); }
        { String s = "678776"; BigDecimal d = new BigDecimal(s); System.out.println(s + ": " + isPalindrome(d)); }
*/



        set.add(new BigDecimal("0"));
        set.add(new BigDecimal("1"));
        set.add(new BigDecimal("4"));
        set.add(new BigDecimal("9"));
        for (int i = 0; i < 20000; ++i) {
            if (i % 10 == 0) {
                continue;
            }
            String a = "" + i;
            String a1 = new StringBuffer(a).reverse().toString();
            String a2 = new StringBuffer(a.substring(1)).reverse().toString();
            String b1 = a1 + a;
            String b2 = a2 + a;
            //System.out.printf("%s %s %s%n", a, b1, b2);
            BigDecimal c1 = checkSquare(b1);
            if (c1 != null) {
                set.add(c1);
            }
            c1 = checkSquare(b2);
            if (c1 != null) {
                set.add(c1);
            }
        }

        for (BigDecimal d : set) {
            //System.out.println(d.toPlainString());
        }

        process(args[0]);
    }
}
