import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;
import java.util.Set;


public class DeceitfulWar {

	//final static String FNAME = "C:\\Codejam2014\\DeceitfulWar";
	final static String FNAME = "C:\\Codejam2014\\D-small-attempt0";
    public static Scanner in;
    public static PrintWriter out;

    static void open() throws IOException {
        Locale.setDefault( Locale.US );
        in = new Scanner( new File( FNAME + ".in" ) );
        out = new PrintWriter( new File( FNAME + ".out" ) );
    }

    static void close() throws IOException {
        out.close();
    }
    
   
    static void printArray(int[][] arr, int p, int q){
    	System.out.println("---------------ARRAY-----------------");
    	for(int m = 0 ; m < p ; m++){
    		for(int n = 0 ; n < q ; n++){
    			System.out.print(arr[m][n] + "	");
    		}
    		System.out.println();
    	}
    	System.out.println("---------------ARRAY END--------------");
    }
    
    static int binSearchJustGreater(List<Double> ken, double naomiBlockPlayed){
    	int index = 0;
    	int start = 0; int end = ken.size() - 1;
    	int mid = (start + end )/2;
    	
    	boolean found = false;
		while(end >= start){
			if(naomiBlockPlayed < ken.get(start)){
				//return the first index of the list since it is the element just greater than naomiBlockPlayed
				return start;
			}else if(naomiBlockPlayed > ken.get(end)){
	    		//No block is present greater than naomiBlockPlayed and we have to use one index so use the least one i.e return index 0
	    		return -1;
	    	}else{
	    		if(naomiBlockPlayed < ken.get(mid)){
	    			end = mid ;
	    		}else{
	    			start  = mid+1;
	    		}
	    	}
			mid = (start + end )/2;
		}
    	
    	return index;
    }
    
    static int  processListToRemoveAllGreater(List<Double> kenDeceit, List<Double> naomiDeceit){
    	
    	int naomiListSize = naomiDeceit.size();
    	int kenListSize   = kenDeceit.size();
    	//Process to remove all Ken elements that are greater than any existing Naomi element
		int kenBlockIndex = binSearchJustGreater(kenDeceit, naomiDeceit.get(naomiListSize-1));
		if(kenBlockIndex == -1){
			//nothing to process
			return 0;
		}
		int numbersInKenGreaterThanAnyNaomi = kenDeceit.size() - kenBlockIndex;
		for(int c = 0 ; c < numbersInKenGreaterThanAnyNaomi ; c++){
			naomiDeceit.remove(0);
			naomiListSize--;
			kenDeceit.remove(kenListSize-1);
			kenListSize--;
		}
		/*System.out.println("Removed number of items : "+numbersInKenGreaterThanAnyNaomi);
		System.out.println("Processed Naomi's List : " + naomiDeceit);
    	System.out.println("Processed Ken's List : " + kenDeceit);*/
    	return numbersInKenGreaterThanAnyNaomi;
    }
    
	public static void main(String[] args)throws IOException {
		open();
        int T = in.nextInt();
        //int T = Integer.parseInt(in.nextLine());
        /*    -------- Main code ----------  */
        
        List<Double> naomi = new ArrayList<Double>();
        List<Double> ken   = new ArrayList<Double>();
        List<Double> naomiDeceit = new ArrayList<Double>();
        List<Double> kenDeceit   = new ArrayList<Double>();
        for(int i = 0 ; i < T ; i++){
        	int fairScore = 0;
            int deceitScore = 0;
        	naomi.clear(); ken.clear();
        	naomiDeceit.clear(); kenDeceit.clear();
        	int numBlocks = in.nextInt();
        	for(int m = 0 ; m < numBlocks ; m++){
        		double d =in.nextDouble(); 
        		naomi.add(d);
        		naomiDeceit.add(d);
        	}
        	for(int m = 0 ; m < numBlocks ; m++){
        		double d =in.nextDouble(); 
        		ken.add(d);
        		kenDeceit.add(d);
        	}
        	Collections.sort(naomi);
        	Collections.sort(ken);
        	Collections.sort(naomiDeceit);
        	Collections.sort(kenDeceit);
        	
        	//System.out.println("Naomi's List : " + naomi);
        	//System.out.println("Ken's List : " + ken);
        	
        	//fair play
        	for(int n = naomi.size() - 1; n >= 0 ; n--){
        		double naomiBlockPlayed = naomi.get(n);
        		int kenBlockIndex = binSearchJustGreater(ken, naomiBlockPlayed);
        		if(kenBlockIndex == -1)
        			kenBlockIndex = 0;
        		double kenBlockPlayed = ken.get(kenBlockIndex);
        		ken.remove(kenBlockIndex);
        		//System.out.println("Naomi Played : "+ naomiBlockPlayed + " ::  Ken Played : "+kenBlockPlayed);
        		if(Double.compare(naomiBlockPlayed, kenBlockPlayed)>0)
        			fairScore++;
        	}
        	
        	//unfair play
        	int naomiListSize = naomiDeceit.size();
        	int kenListSize   = kenDeceit.size();
        	while(naomiListSize > 0){
        		int removedNums = processListToRemoveAllGreater(kenDeceit, naomiDeceit);
        		naomiListSize = naomiListSize - removedNums;
        		kenListSize   = kenListSize - removedNums;
        		if(naomiListSize>0){
        			kenDeceit.remove(kenListSize-1);
            		kenListSize--;
            		naomiDeceit.remove(naomiListSize-1);
            		naomiListSize--;
            		deceitScore++;
        		}
        		
        	}
        	
        	//Print to file        	
	        out.println( "Case #" + (i+1) + ": "+ deceitScore + " " + fairScore);
	        System.out.println( "Case #" + (i+1) + ": "+deceitScore + " " + fairScore);
	     }
        
        close();

	}

}
