package codejam;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.*;


public class Snapper {

	//final static String FNAME = "C:\\CodeJam\\snapper"; 
	final static String FNAME = "C:\\CodeJam\\A-small-attempt1";
    public static Scanner in;
    public static PrintWriter out;

    static class SnapperLink{
    	int id;
    	boolean stateOn;
    	boolean powerIn;
    	boolean transmitting;
    	
    	SnapperLink(int id, boolean stateOn, boolean powerIn,boolean transmitting){
    		this.id = id;
    		this.stateOn = stateOn;
    		this.powerIn = powerIn;
    		this.transmitting = transmitting;
    	}
    	
    }
    
    static void open() throws IOException {
        Locale.setDefault( Locale.US );
        in = new Scanner( new File( FNAME + ".in" ) );
        out = new PrintWriter( new File( FNAME + ".out" ) );
    }

    static void close() throws IOException {
        out.close();
    }

    
    
	public static void main(String[] args) throws IOException{
		open();
        int numTestCases = in.nextInt();
        
        
        /*    -------- Main code ----------  */
        for(int i = 0 ; i < numTestCases ; i++){
           System.out.println("Case ----- "+ i);
        	int N = in.nextInt();//Number of snapper links
        	long k = in.nextInt();//Number of times I snap fingers
        	
        	//Initialize the snapperLinks in an arrayList
        	List<SnapperLink> snapperList = new ArrayList<SnapperLink>();
        	for (int j = 0; j < N; j++) {
				if(j==0)//i.e. first snapperLink hence its power will be In
				{
					snapperList.add(new SnapperLink(j, false, true, false));
					
				}
				else
					snapperList.add(new SnapperLink(j, false, false, false));
			}
        	
        	
        	boolean bulbGlows=true;
        	//Iterate for the finger snaps
        	if(k==0)
        		bulbGlows=false;
        	else{
        		for (long j = 1; j <= k ; j++) {
            		for(int m=0; m < N; m++){
            			SnapperLink snp = snapperList.get(m);
            			//FIrst Link
            			if(snp.id == 0){
            				snp.stateOn = !snp.stateOn;//toggle
            				
            			}
            			else//Rest of the links
            			{ 
            				if(snp.powerIn){
            					snp.stateOn = !snp.stateOn;  
            					
                			}
            				
            				//Set the links power in status as per previous link's toggled state
            				SnapperLink prevSnapLink = snapperList.get(m-1);
            				if(prevSnapLink.stateOn && prevSnapLink.powerIn )
            					snp.powerIn = true;
            				else
            					snp.powerIn = false;
            			}      			
            			
            		}				
    			}
        		//Now find if all snapperLinks are in On state. If so then return true
            	
            	for(int m=0; m<N; m++){
            		if(!(snapperList.get(m).stateOn)){
            			bulbGlows=false;
            			break;
            		}
            			
            	}
        	}
        		
        	
        	
        	
        	        
        //Print to file	
        	if(bulbGlows){
        		out.println( "Case #" + (i+1) + ": "+"ON");
        		//System.out.println("Case #" + (i+1) + ": "+"ON");
        	}
        	else{
        		out.println( "Case #" + (i+1) + ": "+"OFF");
        		//System.out.println("Case #" + (i+1) + ": "+"OFF");
        	}
        }

        /* ---- End ----*/
        close();
	}

}
