package codejam;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;

public class RPI {
	
	final static String FNAME = "C:\\CodeJam\\2011\\A-large";
	//final static String FNAME = "C:\\CodeJam\\2011\\RPI";
	//final static String FNAME = "C:\\CodeJam\\2011\\A-small-attempt0";
	
	
	public static Scanner in;
	public static PrintWriter out;

	public static void open() throws IOException {
		Locale.setDefault(Locale.US);
		in = new Scanner(new File(FNAME + ".in"));
		out = new PrintWriter(new File(FNAME + ".out"));
	}

	public static void close() throws IOException {
		out.close();
	}
	
	public static void main(String[] args) throws IOException{
		open();
		char ONE='1';
		char ZERO='0';
		char NOP='.';
		
		int T = Integer.parseInt(in.nextLine());		
		
		for(int i = 0 ; i < T ; i++){
			out.println( "Case #" + (i+1) + ":");
			int N = Integer.parseInt(in.nextLine());
			char[][] map = new char[N][N];
			double[][] measures = new double[N][3];
			int[][] gamesPlayAndWin = new int[N][2];
			for (int j = 0; j < N; j++) {
				String row = in.nextLine();
				char[] elements = row.toCharArray();
				int gamesPlayed=0;
				int gamesWon=0;
				for(int k = 0 ; k < N ; k++){
					map[j][k] = elements[k];
					if(elements[k]==ONE || elements[k]==ZERO){
						gamesPlayed++;
						if(elements[k]==ONE)
							gamesWon++;
					}
				}
				gamesPlayAndWin[j][0]=gamesPlayed;
				gamesPlayAndWin[j][1]=gamesWon;
				measures[j][0]=(double)gamesWon/(double)gamesPlayed;
			}
			
			for (int j = 0; j < N; j++){
				double owptotal=0;
				int tpa = 0;
				for(int k = 0 ; k < N ; k++){
					if(map[j][k]!=NOP){
						tpa++;
						int gpk = gamesPlayAndWin[k][0]-1;
						int gwk = gamesPlayAndWin[k][1];
						if(map[j][k]==ZERO)
							gwk=gwk-1;
						owptotal = owptotal + (double)gwk/(double)gpk;						
					}
				}
				measures[j][1] = (double)owptotal/(double)tpa;
			}
			for (int j = 0; j < N; j++){
				double oowptotal = 0;
				int tpa = 0;
				for(int k = 0 ; k < N ; k++){
					if(map[j][k]!=NOP){
						tpa++;
						oowptotal = oowptotal + measures[k][1];					
					}
				}
				measures[j][2] = (double)oowptotal/(double)tpa;	
				
				
				
				
				double rpi = 0.25 * measures[j][0] + 0.5*measures[j][1] + 0.25*measures[j][2];
				//System.out.printf("%.12f", rpi);
				//System.out.println();
				out.printf("%.12f", rpi);
				out.println();
			}
			
			
			
			
		}
		
		close();
	}
	
	
	
	
}
