import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.HashSet;
import java.util.Locale;
import java.util.Scanner;
import java.util.Set;


public class TicTacToeTomek {

	//final static String FNAME = "C:\\CodeJam2013\\TicTacToeTotem";
	//final static String FNAME = "C:\\CodeJam2013\\A-small-attempt0";
	final static String FNAME = "C:\\CodeJam2013\\A-large";
    public static Scanner in;
    public static PrintWriter out;

    static void open() throws IOException {
        Locale.setDefault( Locale.US );
        in = new Scanner( new File( FNAME + ".in" ) );
        out = new PrintWriter( new File( FNAME + ".out" ) );
    }

    static void close() throws IOException {
        out.close();
    }

    static void displayBoard(char[][] board){
    	System.out.println();
    	for (int j = 0; j < 4; j++){
    		for (int k = 0; k < 4; k++){
    			System.out.print(board[j][k]);
    		}
    		System.out.println();
    	}
    	System.out.println();
    }
        
	public static void main(String[] args)throws IOException {
		open();
        int T = Integer.parseInt(in.nextLine());
        //int T = Integer.parseInt(in.nextLine());
        /*    -------- Main code ----------  */
        char[][] board = new char[4][4];
        //boolean[][] possibleMow = new boolean[100][100];
        for(int i = 0 ; i < T ; i++){
        	boolean owon = false;
        	boolean xwon = false;
        	boolean incomplete = false;
        	boolean draw = false;
        	int numEmptyCells = 0;
        	int numFilledCells = 0;
        	for (int j = 0; j < 4; j++){
        		String s = in.nextLine();
        		for (int k = 0; k < 4; k++){
        			char c = s.charAt(k);
        			board[j][k]=s.charAt(k);
        			if(c == '.')
        				numEmptyCells++;
        			else
        				numFilledCells++;
        		}
        	}
        	in.nextLine();
        	//displayBoard(board);
        	
        	boolean someoneWon = false;
        	if(numFilledCells == 16)
        		draw = true;
        	
        	//check 1st diagonal
        	int numX = 0; int numO = 0;
        	for (int j = 0; j < 4; j++){        		
    			if(board[j][j]=='X')
        			numX++;
        		else if(board[j][j]=='O')
        			numO++;
        		else if(board[j][j]=='T'){
        			numX++; numO++;
        		}else{
        			break;
        		}
        	}
        	if(numX==4){
				xwon=true;
				someoneWon=true;    				
			}else if(numO == 4){
				owon=true;
				someoneWon=true;
			}
        	
        	//check 2nd diagonal
        	if(!someoneWon){        		
            	numX = 0; numO = 0;
            	for (int j = 0; j < 4; j++){        		
        			if(board[j][4-j-1]=='X')
            			numX++;
            		else if(board[j][4-j-1]=='O')
            			numO++;
            		else if(board[j][4-j-1]=='T'){
            			numX++; numO++;
            		}else{
            			break;
            		}    			
            	}
            	if(numX==4){
    				xwon=true;
    				someoneWon=true;    				
    			}else if(numO == 4){
    				owon=true;
    				someoneWon=true;
    			}
        	}
        	
        	//Check Rows
        	if(!someoneWon){        		
        		for (int j = 0; j < 4; j++){
        			numX = 0; numO = 0;
        			for (int k = 0; k < 4; k++){
        				if(board[j][k]=='X')
                			numX++;
                		else if(board[j][k]=='O')
                			numO++;
                		else if(board[j][k]=='T'){
                			numX++; numO++;
                		}else{
                			break;
                		}
        			}
        			if(numX==4){
        				xwon=true;
        				someoneWon=true; 
        				break;
        			}else if(numO == 4){
        				owon=true;
        				someoneWon=true;
        				break;
        			}
        		}
        	}
        	
        	//Check Cols
        	if(!someoneWon){        		
        		for (int k = 0; k < 4; k++){
        			numX = 0; numO = 0;
        			for (int j = 0; j < 4; j++){
        				if(board[j][k]=='X')
                			numX++;
                		else if(board[j][k]=='O')
                			numO++;
                		else if(board[j][k]=='T'){
                			numX++; numO++;
                		}else{
                			break;
                		}
        			}
        			if(numX==4){
        				xwon=true;
        				someoneWon=true; 
        				break;
        			}else if(numO == 4){
        				owon=true;
        				someoneWon=true;
        				break;
        			}
        		}
        	}
        	
        	
	    	//Print to file	
        	//out.println( "Case #" + (i+1) + ": "+ (lawnPossible?"YES":"NO"));
        	if(owon){
        		out.println( "Case #" + (i+1) + ": "+ "O won");
        		//System.out.println( "Case #" + (i+1) + ": "+ "O won");
        	}else if(xwon){
        		out.println( "Case #" + (i+1) + ": "+ "X won");
        		//System.out.println( "Case #" + (i+1) + ": "+ "X won");
        	}else if(draw){
        		out.println( "Case #" + (i+1) + ": "+ "Draw");
        		//System.out.println( "Case #" + (i+1) + ": "+ "Draw");
        	}else{
        		out.println( "Case #" + (i+1) + ": "+ "Game has not completed");
        		//System.out.println( "Case #" + (i+1) + ": "+ "Game has not completed");
        	}
	        	
        }
        
        close();

	}

}
