package codejam2016;

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;
import java.util.BitSet;
import java.util.Locale;
import java.util.Scanner;

/**
 * Created by sudeepta on 9/4/16.
 */
public class FlippingPancakesSameSide {

	public static Scanner in;
	public static PrintWriter out;

	//final static String FNAME = "/home/sudeepta/Downloads/CodeJam/IO/FlippingPancakesSameSide";
	//final static String FNAME = "/home/sudeepta/Downloads/CodeJam/IO/B-small-attempt0";
	final static String FNAME = "/home/sudeepta/Downloads/CodeJam/IO/B-large";


	public static void open() throws IOException {
		Locale.setDefault(Locale.US);
		in = new Scanner(new File(FNAME + ".in"));
		out = new PrintWriter(new File(FNAME + ".out"));
	}

	public static void close() throws IOException {
		out.close();
	}

	public static void main(String[] args) throws IOException{
		open();

		int T = in.nextInt();
		for (int i = 0; i < T; i++) {
			String inputSeries = in.next();
			//System.out.println("Processing Pancakes ... : "+inputSeries);
			char[] pancakes = inputSeries.toCharArray();
			long attemptCount = 0;
			while(attemptCount < Long.MAX_VALUE){
				int lastIndexWithUnflipped = getLastIndexWithUnFlipped(pancakes.length-1, pancakes);
				if(lastIndexWithUnflipped < 0){
					break;
				}else{
					attemptCount++;
					if(pancakes[0] == '-'){
						//Flip the entire stack
						swapArrayAndFlipVals(0,lastIndexWithUnflipped,pancakes);
					}else{
						int j = 0;
						while ( j < lastIndexWithUnflipped  && (pancakes[j] != '-')){
							j++;
						}
						swapArrayAndFlipVals(0,j-1,pancakes);
					}
				}
				//System.out.println("After Attempt : " +attemptCount + " Pancake orientation "+ Arrays.toString(pancakes));
			}


			//System.out.println("Case #"+(i+1)+": "+attemptCount);
			out.println("Case #"+(i+1)+": "+attemptCount);
		}


		close();

	}

	public static int getLastIndexWithUnFlipped(int endIndex, char[] pancakes){
		for(int i = endIndex ; i >=0 ; i--){
			if(pancakes[i] == '-'){
				return i;
			}
		}
		return -1;//means all the pancakes are flipped
	}

	public static boolean allPancakesFlipped(int startIndex, int endIndex, char[] pancakes){
		for (int i = startIndex; i <= endIndex; i++) {
			if(pancakes[i] == '-'){
				return false;
			}
		}
		return true;
	}

	public static void swapArrayAndFlipVals(int startIndex, int endIndex, char[] pancakes){
		while (startIndex <= endIndex){
			if(startIndex == endIndex){
				flipVal(startIndex, pancakes);
			}else {
				char temp = pancakes[startIndex];
				pancakes[startIndex] = pancakes[endIndex];
				pancakes[endIndex] = temp;
				flipVal(startIndex, pancakes);
				flipVal(endIndex, pancakes);
			}
			startIndex++;
			endIndex-- ;
		}

	}

	public static void flipVal(int index, char[] pancakes){
		pancakes[index] = (pancakes[index]=='+')?'-':'+';
	}
}
