

import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.HashSet;
import java.util.List;
import java.util.Locale;
import java.util.Scanner;
import java.util.Set;
import java.util.Stack;



public class WaterSheds {

	final static String FNAME = "C:\\CodeJam\\B-small-attempt0";    
	//final static String FNAME = "C:\\CodeJam\\watersheds";   
	final static String LABELSTRING = "abcdefghijklmnopqrstuvwxyz";
	final static int MAX = 10000;
    public static Scanner in;
    public static PrintWriter out;
    public static int[][] basinArray = new int[20][20];
    public static char[][] outArray = new char[20][20];
    public static int T , H, W;
    
    static class Cell{
    	int x;
    	int y;
    	char tag;
    	int val;
    	
    	Cell(){}
    	
    	Cell(int a, int b, char t, int v){
    		x = a; y = b ; tag = t; val = v;
    	}
    }
    
    static void open() throws IOException {
        Locale.setDefault( Locale.US );
        in = new Scanner( new File( FNAME + ".in" ) );
        out = new PrintWriter( new File( FNAME + ".out" ) );
    }

    static void close() throws IOException {
    	out.flush();
        out.close();
    }

    public static boolean eql(double a , double b){
        if(Math.abs(a-b) < 0.001)
            return true;
        else
            return false;
    } 
    
    public static void dispArray(int H, int W, int[][] arr){
    	for (int i = 0; i < H; i++) {
    		System.out.println();
			for (int j = 0; j < W; j++) {
				System.out.print(arr[i][j] + " ");
			}
		}
    } 
    
    public static void dispCharArray(int H, int W, char[][] arr){
    	for (int i = 0; i < H; i++) {
    		System.out.println();
			for (int j = 0; j < W; j++) {
				System.out.print(arr[i][j] + " ");
			}
		}
    } 
    
    public static void dispCharArrayToFile(int H, int W, char[][] arr){
    	for (int i = 0; i < H; i++) {
    		out.println();
			for (int j = 0; j < W; j++) {
				out.print(arr[i][j] + " ");
			}
		}
    } 
    
    public static char compareCells(int N, int W, int E, int S){
    	
    	if ((N <= S) && (N <= E) &&(N <= W))
    		return 'n';
    	if ((W <= N) && (W <= E) &&(W <= S))
    		return 'w';
    	if ((E <= N) && (E <= W) &&(E <= S))
    		return 'e';
    	if ((S <= E) && (S <= W) &&(S <= N))
    		return 's';
    	return 'x';
    	
    }
    
    public static char getDirection(Cell cell){
    	char direction = 'x';
    	int k = cell.x;
    	int j = cell.y;
    	//direction = gotoCell(NORTH, WEST, EAST, SOUTH);
			if( k == 0 && j == 0){
				//outArray[k][j] = LABELSTRING.charAt(tagVal++);
				direction = compareCells(MAX, MAX, basinArray[k][j+1], basinArray[k+1][j]);
			}
			else if(k==0 && H == 1){
				if(j == W-1)
					direction = compareCells(MAX, basinArray[k][j-1], MAX, MAX);
				else
					direction = compareCells(MAX, basinArray[k][j-1], basinArray[k][j+1], MAX);
			}
			else if(k==0 && j== W-1){
				direction = compareCells(MAX, basinArray[k][j-1], MAX, basinArray[k+1][j]);
			}
			
			else if(k==0 ){
				direction = compareCells(MAX, basinArray[k][j-1], basinArray[k][j+1], basinArray[k+1][j]);
			}
			
			else if(j == 0 && W ==1){
				if(k == H - 1 )
					direction = compareCells(basinArray[k-1][j] , MAX, MAX, MAX);
				else
					direction = compareCells(basinArray[k-1][j] , MAX, MAX, basinArray[k+1][j]);
			}
			else if( k == H-1 && j == 0){          					
				direction = compareCells(basinArray[k-1][j] , MAX, basinArray[k][j+1], MAX);
			}
			else if(k== H-1 && j== W-1){
				direction = compareCells(basinArray[k-1][j] , basinArray[k][j-1] ,MAX, MAX);
			}
			else if(k== H-1){
				direction = compareCells(basinArray[k-1][j] , basinArray[k][j-1], basinArray[k][j+1], MAX);
			}
			
			
			else if(j == 0){
				direction = compareCells(basinArray[k-1][j] , MAX, basinArray[k][j+1], basinArray[k+1][j]);
			}
			
			else if(j==W-1){
				direction = compareCells(basinArray[k-1][j] , basinArray[k][j-1], MAX , basinArray[k+1][j]);
			}
			else
				direction = compareCells(basinArray[k-1][j] , basinArray[k][j-1], basinArray[k][j+1] , basinArray[k+1][j]);
			return direction;
    }
    
    public static Cell getNextUnmarkedCell(){
    	Cell nextUnmarked = null;
    	for (int k = 0; k < H; k++) {
  			for (int j = 0; j < W; j++) {
  				if(outArray[k][j]=='0'){
  					nextUnmarked = new Cell();
  					nextUnmarked.x = k;
  					nextUnmarked.y = j;
  					nextUnmarked.tag = '0';
  					nextUnmarked.val = basinArray[k][j];
  					return nextUnmarked;
  				}
  			}
    	}
    	return nextUnmarked;
    }
    
	public static void main(String[] args) throws IOException{
		open();
		
        T = in.nextInt(); // num of maps
        H = 0 ;
        W = 0 ;
        for (int i = 0; i < T; i++) {
        	 H = in.nextInt();
             W = in.nextInt();
             int tagVal = 0;
             
             
             for (int k = 0; k < H; k++) {
     			for (int j = 0; j < W; j++) {
     				basinArray[k][j] = in.nextInt();
     				outArray[k][j] = '0';
     			}
     		}
             
             //dispArray(H, W, basinArray);
             //dispCharArray(H, W, outArray);
             
             
             ///process
             //int Nth = 10000, Sth = 10000, Wst = 10000, Est = 10000; 
             
             
             Stack<Cell> myStack;
             while(null != getNextUnmarkedCell()){
            	 myStack = new Stack<Cell>();
            	 char direction = '0';
            	 Cell cell = getNextUnmarkedCell();
            	 char tagToMark = '0';
            	 boolean sinkReached = false;
            	 while (!sinkReached){            		 
            		 myStack.push(cell);
            		 direction = getDirection(cell);
                	 int gotoRow = cell.x ,gotoCol = cell.y;
                	 switch (direction){
	 	   				case 'n': gotoRow = cell.x-1;break; 
	 	   				case 'w': gotoCol = cell.y-1;break;
	 	   				case 'e': gotoCol = cell.y+1;break;
	 	   				case 's': gotoRow = cell.x+1;break;
	 				 }
                	 
                	 if((basinArray[gotoRow][gotoCol] >= basinArray[cell.x][cell.y])){
            			 sinkReached=true;
            			 break;
                	 }
                	 
                	 if (outArray[gotoRow][gotoCol] != '0'){ //ie already marked
                		 tagToMark = outArray[gotoRow][gotoCol];
                		 sinkReached=true;
                		 break;
                	 }
                	 
                	 else{                		 
                		 cell = new Cell(gotoRow, gotoCol, '0', basinArray[gotoRow][gotoCol]);
                		 
                	 }
            	 }
            	 //Pop all cells and mark them
            	 if(tagToMark == '0')
         			tagToMark = LABELSTRING.charAt(tagVal++);
            	 while(!myStack.isEmpty()){
            		Cell popCell = myStack.pop();
            		outArray[popCell.x][popCell.y] = tagToMark;          		
      				
      			 }
      		}
             //System.out.print( "Case #" + (i+1) + ": ");
             //dispCharArray(H, W, outArray); 
             //System.out.println();
             out.print( "Case #" + (i+1) + ": ");
             dispCharArrayToFile(H, W, outArray); 
             out.println();
		}
        close();
	}
	
	


   
	
	
}
