import java.io.BufferedReader;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.math.BigInteger;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.List;
import java.util.StringTokenizer;

public class Solution {

	static InputReader in = new InputReader(System.in);
	static char[] arr;
	static boolean[] isPrime;
	static PrintWriter printWriter;

	public static void main(String[] args) throws FileNotFoundException,
			UnsupportedEncodingException {

		// Gen Prime
		int N = 1000000;
		isPrime = new boolean[N + 1];
		for (int i = 2; i <= N; i++) {
			isPrime[i] = true;
		}
		for (int i = 2; i * i <= N; i++) {
			if (isPrime[i]) {
				for (int j = i; i * j <= N; j++) {
					isPrime[i * j] = false;
				}
			}
		}

		printWriter = new PrintWriter("/home/omar/Desktop/file.txt", "UTF-8");

		int T = in.nextInt();

		for (int i = 1; i <= T; i++) {
			int n = in.nextInt();
			int j = in.nextInt();
			System.out.println("Case #" + i + ":");
			printWriter.write("Case #" + i + ":\n");
			solve(n, j);
		}

		printWriter.close();

	}

	private static void solve(int n, int j) {

		String res = "1";

		while (res.length() + 1 < n) {
			res += "0";
		}
		res += 1;

		long l = Long.parseLong(res, 2);

		List<String> list = new ArrayList<String>();

		while (list.size() < j) {
			
			String binStr = Long.toBinaryString(l);
			
			if (test(binStr)) {
				list.add(binStr);
			}
			l += 2;
		}

		for (String str : list) {
			System.out.print(str + " ");
			printWriter.write(str + " ");
			for (int i = 2; i <= 10; i++) {
				long nbr = Long.parseLong(str, i);
				for (j = 2; j < nbr; j++) {
					if (nbr % j == 0) {
						System.out.print(j + " ");
						printWriter.write(j + " ");
						break;
					}
				}

			}
			System.out.println();
			printWriter.write("\n");
		}
	}

	private static boolean test(String l) {

		for (int i = 2; i <= 10; i++) {
			long nbr = Long.parseLong(l, i);
			if (new BigInteger(nbr + "").isProbablePrime(1))
			//if (isPrime[nbr])
				return false;
		}

		return true;
	}

}

class InputReader {
	private BufferedReader reader;
	private StringTokenizer tokenizer;

	public InputReader(InputStream stream) {
		reader = new BufferedReader(new InputStreamReader(stream), 32768);
		tokenizer = null;
	}

	public String next() {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			try {
				tokenizer = new StringTokenizer(reader.readLine());
			} catch (IOException e) {
				throw new RuntimeException(e);
			}
		}
		return tokenizer.nextToken();
	}

	public String readLine() {
		try {
			return reader.readLine();
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}

	public long nextLong() {
		return Long.parseLong(next());
	}

	public double nextDouble() {
		return Double.parseDouble(next());
	}

	public float nextFloat() {
		return Float.parseFloat(next());
	}

}