import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.io.OutputStream;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.io.Writer;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.HashMap;
import java.util.List;
import java.util.StringTokenizer;

public class Solution {

	static InputReader in = new InputReader(System.in);
	static OutputWriter out = new OutputWriter(System.out);
	static int mod = (int) (1e9 + 9);

	public static void main(String[] args) throws IOException {
		solve();
		out.close();
	}

	static boolean found = false;
	static String[] numbers = new String[] { "ZERO", "ONE", "TWO", "THREE",
			"FOUR", "FIVE", "SIX", "SEVEN", "EIGHT", "NINE" };
	static List<Integer> ans;

	static String res = "";

	private static void solve() throws FileNotFoundException,
			UnsupportedEncodingException {

		int n = in.nextInt();

		PrintWriter writer = new PrintWriter("/home/omar/Desktop/out.txt",
				"UTF-8");

		for (int i = 1; i <= n; i++) {
			String input = in.readLine();

			ans = new ArrayList<Integer>();

			getAns(input);

			Collections.sort(ans);

			StringBuilder sb = new StringBuilder();

			for (Integer inn : ans)
				sb.append(inn);

			ans.clear();
			found=false;
			
			writer.println("Case #" + i + ": " + sb);
			System.out.println("Case #" + i + ": " + sb);

		}
		writer.close();

	}

	public static void getAns(String str) {
		if (str.length() == 0) {
			found = true;
			return;
		}

		for (int i = 0; i < numbers.length; ++i) {
			if (canForm(numbers[i], str)) {
				getAns(res);
				if (found) {
					ans.add(i);
					return;
				}
			}
		}
	}

	private static boolean canForm(String number, String str) {

		int[] left = new int[26];

		for (int j = 0; j < number.length(); j++) {
			left[number.charAt(j) - 'A']++;
		}

		int[] right = new int[26];

		for (int j = 0; j < str.length(); j++) {
			right[str.charAt(j) - 'A']++;
		}

		for (int i = 0; i < 26; i++)
			if (left[i] > right[i])
				return false;

		for (int i = 0; i < 26; i++)
			right[i] -= left[i];

		res = "";

		for (int i = 0; i < 26; i++) {
			while (right[i] > 0) {
				res += (char) ('A' + i);
				right[i]--;
			}
		}

		return true;
	}
}

class CustomComparator implements Comparator<String> {

	@Override
	public int compare(String e1, String e2) {
		return e2.compareTo(e1);
	}
}

class Pair {

	int x;
	int y;

	public Pair(int x, int y) {
		this.x = x;
		this.y = y;
	}

	@Override
	public String toString() {
		return "Pair [x=" + x + ", y=" + y + "]";
	}
}

class Utils {

	OutputWriter out;

	public Utils(OutputWriter out) {
		this.out = out;
	}

	public static void printMatrix(int[][] matrix) {
		for (int[] row : matrix) {
			for (int j : row) {
				System.out.print(j + " ");
			}
			System.out.println();
		}
	}
}

class OutputWriter {
	public PrintWriter writer;

	public OutputWriter(OutputStream outputStream) {
		writer = new PrintWriter(new BufferedWriter(new OutputStreamWriter(
				outputStream)));
	}

	public OutputWriter(Writer writer) {
		this.writer = new PrintWriter(writer);
	}

	public void print(Object... objects) {
		for (int i = 0; i < objects.length; i++) {
			if (i != 0)
				writer.print(' ');
			writer.print(objects[i]);
		}
	}

	public void println(Object... objects) {
		print(objects);
		writer.println();
	}

	public void close() {
		writer.close();
	}
}

class InputReader {
	private BufferedReader reader;
	private StringTokenizer tokenizer;

	public InputReader(InputStream stream) {
		reader = new BufferedReader(new InputStreamReader(stream), 32768);
		tokenizer = null;
	}

	public String next() {
		while (tokenizer == null || !tokenizer.hasMoreTokens()) {
			try {
				tokenizer = new StringTokenizer(reader.readLine());
			} catch (IOException e) {
				throw new RuntimeException(e);
			}
		}
		return tokenizer.nextToken();
	}

	public String readLine() {
		try {
			return reader.readLine();
		} catch (IOException e) {
			throw new RuntimeException(e);
		}
	}

	public int nextInt() {
		return Integer.parseInt(next());
	}

	public long nextLong() {
		return Long.parseLong(next());
	}

	public double nextDouble() {
		return Double.parseDouble(next());
	}

	public float nextFloat() {
		return Float.parseFloat(next());
	}

}