package train;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.util.ArrayList;
import java.util.Hashtable;
import java.util.List;
import java.util.SortedMap;
import java.util.TreeMap;

public class Main {

	public class Time {
		public int start;

		public Time(int start) {
			super();
			this.start = start;
		}
	}

	public Main() {
		Solver s = new Solver();
		s.solve();
		
	}

	public static void main(String[] args) {
		new Main();
	}

	class Solver {
		public static final String pkgDir = "train/";
		public int N, T, NA, NB;
		public int XA, XB;
		File input;
		BufferedReader r;
		FileWriter fw;

		Solver() {}

		void solve() {
			parse();			
			File f = new File(pkgDir + "output.txt");
			try {
				fw = new FileWriter(f);
				for (int index = 0; index < N; index++) {
					parseCase();
					fw.write("Case #" + (index + 1) + ": " + XA + " " + XB + "\n");
				}
				fw.close();
			} catch (IOException e) {
				e.printStackTrace();
			} catch (Exception e) {
				e.printStackTrace();
			}
		}


		public void parse() {
			try {
				input = new File(pkgDir + "B-small.in");
				r = new BufferedReader(new FileReader(input));
				N = Integer.parseInt(r.readLine());
			} catch(Exception e) {
				e.printStackTrace();
			}
		}

		SortedMap<Integer,Integer> 
			mapA = new TreeMap<Integer, Integer>(),
			mapB = new TreeMap<Integer, Integer>();

		public void addTimes(String s, SortedMap<Integer,Integer> depart, SortedMap<Integer,Integer> arrive) {
			System.out.println(s);
			String[] splits = s.split(" |:");
			List<Integer> numbers = new ArrayList<Integer>();
			for(String t : splits) {
				numbers.add(Integer.parseInt(t));
			}
			Integer x;
			int startTime = numbers.get(0)*60+numbers.get(1);
			int finishTime = numbers.get(2)*60+numbers.get(3)+T;

			//+1 for departures, -1 for arrivals
			x = depart.get(startTime);
			if(x == null) x = 0;
			depart.put(startTime, x + 1);

			x = arrive.get(finishTime);
			if(x == null) x = 0;
			arrive.put(finishTime, x - 1);
		}

		public void parseCase() throws Exception, IOException {
			T = Integer.parseInt(r.readLine());
			String s = r.readLine();
			String[] splits = s.split(" ");
			NA = Integer.parseInt(splits[0]);
			NB = Integer.parseInt(splits[1]);
			mapA.clear();
			mapB.clear();
			
			for(int index = 0; index < NA; index++) {
				addTimes(r.readLine(), mapA, mapB);
			}

			for(int index = 0; index < NB; index++) {
				addTimes(r.readLine(), mapB, mapA);
			}

			int trains, maxA, maxB;
			trains = 0;
			maxA = 0;
			for(Integer t : mapA.keySet()) {
				trains += mapA.get(t);
				if(trains > maxA) maxA = trains;
			}
			
			trains = 0;
			maxB = 0;
			for(Integer t : mapB.keySet()) {
				trains += mapB.get(t);
				if(trains > maxB) maxB = trains;				
			}
			XA = maxA;
			XB = maxB;
//			System.out.println(mapA + " " + mapB);
		}

		public void setN(int n) {
			N = n;
		}

		public int getN() {
			return N;
		}
	}

}

