import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;
import java.util.Scanner;


public class ProbC {
	public String answer;
	
	public int rowInt(String row) {
		int ret = 0;
		for(int i = 0; i < row.length(); i++) {
			if(row.charAt(i) == 'x') {
				ret += (1 << i);
			}
		}
		return ret;
	}
	public String solve() {
		int M = scanner.nextInt();
		int N = scanner.nextInt();
		System.out.println("M N:" + M + " " + N);
			String[] seats = new String[M];
		for(int i = 0; i < M; i++) {
			seats[i] = scanner.next();
		}

		int[][] best = new int[M][1 << N];
		
		for(int i = 0; i < M; i++) {
			int r = rowInt(seats[i]);
			//System.out.print(r + ": ");
			for(int j = 0; j < (1 << N); j++) {
				if((j & (j << 1)) != 0 || (j & r) != 0) {
					best[i][j] = -1;
				} else {
					best[i][j] = Integer.bitCount(j);
				}
				//System.out.print(best[i][j] + " ");
			}
			//System.out.println();
		}
		
		int mx = 0, ct = 0;
		for(int i = 1; i < M; i++) {
			//System.out.println();
			for(int j = 0; j < (1 << N); j++) {
				mx = 0;
				if(best[i][j] == -1) continue;
				for(int k = 0; k < (1 << N); k++) {
					if(best[i-1][k] == -1) continue;
					if((k & (j << 1)) != 0 || (j & (k << 1)) != 0) continue;
					//if(M <= 3 && N <= 3) { System.out.println("jk: " + j + k); }
					ct = best[i][j] + best[i-1][k];
					if(ct > mx) {
						mx = ct;
					}
				}
				best[i][j] = mx;
				//System.out.print(best[i][j] + " ");
			}
		}

		//System.out.println();
		mx = 0;
		for(int j = 0; j < (1 << N); j++) {
			if(best[M-1][j] > mx) {
				mx = best[M-1][j];
			}
		}
		return mx + "";
	}
	
	public void writeCase(String answerString) {
		String caseString = "Case #" + ++caseNum + ": ";
		
		try {
			writer.write(caseString + answerString + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


	
	
	
	/*
	 * 
	 * helpers
	 * 
	 * 
	 */
	
	public List<Object> get(String regex, String line, Object... objects) {
		String[] splits = line.split(regex);
		List<Object> ret = new ArrayList<Object>();
		int i = 0;
		for(Object o : objects) {
			if(o instanceof Integer) {
				ret.add(new Integer(splits[i]));
			} else if(o instanceof Double) {
				ret.add(new Double(splits[i]));
			} else if(o instanceof String) {
				ret.add(splits[i]);
			} else {
				
			}
			i++;
		}
		return ret;
	}
	
	private static ProbC INSTANCE = new ProbC();
	private ProbC() {};
	public static ProbC getInstance() { return INSTANCE; }
	public String getProb() { return "C"; }
	
	public String inFileName;
	public String outFileName = getProb() + ".out";
	
	public File inFile;
	public File outFile;
	public BufferedReader reader;
	public FileWriter writer;
	private Scanner scanner;
	
	public static void main(String[] args) {
		ProbC B = ProbC.getInstance();
		B.init(args[0]);
		B.run();
	}

	int N;
	int caseNum = 0;

	public void getN() {
		N = scanner.nextInt();
	}

	public String getLine() {
		String line = "";
		try {
			line = reader.readLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return line;
	}
	
	public void run() {
		getN();
		for(int i = 0; i < N; i++) {
			String s = solve();
			writeCase(s);
		}
		finish();
	}

	/**
	 * @param fileName the test case to open
	 */
	public void init(String fileName) {
		this.inFileName = fileName;
		this.outFileName = getProb() + ".out";
		inFile = new File(inFileName);
		outFile = new File(outFileName);
		try {
			reader = new BufferedReader(new FileReader(inFile));
			writer = new FileWriter(outFile);
			scanner = new Scanner(inFile);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}

	public void finish() {
		try {
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}