import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;


public class ProbD {
	public String answer;

	int factorial(int n) {
		if(n == 1) return 1;
		return factorial(n-1) * n;
	}
	
	int[] perm(int n, int x) {
		int[] ret = new int[n];
		int v,sw;
		for(int i = 0; i < n; i++) {
			ret[i] = i;
		}
		for(int i = 0; i < n-1; i++) {
			v = x % (i+2);
			sw = ret[v]; ret[v] = ret[i+1]; ret[i+1] = sw;
			x = (x-v) / (i+2);
		}
		return ret;
	}
	
	int permute(String s, int[] perm, int n) {
		String sb = "";
		for(int i = 0; i < s.length() / n; i++) {
			for(int j = 0; j < n; j++) {
				sb += s.charAt(i*n+perm[j]);
			}
		}
		int ret = 1;
		for(int i = 1; i < sb.length(); i++) {
			if(sb.charAt(i) != sb.charAt(i-1)) {
				ret++;
			}
		}
		//System.out.print(sb);
		return ret;
	}
	public String solve() {
		int k = Integer.parseInt(getLine());
		String s = getLine();
		int[] perm;
		int min = Integer.MAX_VALUE;
		for(int i = 0; i < factorial(k); i++) {
			perm = perm(k,i);
			for(int j : perm) {
				//System.out.print(j + " ");
			}
			int z = permute(s,perm,k);
			if(z < min) { min = z; }
			//System.out.println(" " + z);
		}
		
		return "" + min;
	}
	
	public void parseCase() {
	}
	
	public void writeCase(String answerString) {
		String caseString = "Case #" + ++caseNum + ": ";
		
		try {
			writer.write(caseString + answerString + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


	
	
	
	/*
	 * 
	 * helpers
	 * 
	 * 
	 */
	
	public List<Object> get(String regex, String line, Object... objects) {
		String[] splits = line.split(regex);
		List<Object> ret = new ArrayList<Object>();
		int i = 0;
		for(Object o : objects) {
			if(o instanceof Integer) {
				ret.add(new Integer(splits[i]));
			} else if(o instanceof Double) {
				ret.add(new Double(splits[i]));
			} else if(o instanceof String) {
				ret.add(splits[i]);
			} else {
				
			}
			i++;
		}
		return ret;
	}
	
	private static ProbD INSTANCE = new ProbD();
	private ProbD() {};
	public static ProbD getInstance() { return INSTANCE; }
	public String getProb() { return "D"; }
	
	public String inFileName;
	public String outFileName = getProb() + ".out";
	
	public File inFile;
	public File outFile;
	public BufferedReader reader;
	public FileWriter writer;
	
	public static void main(String[] args) {
		ProbD D = ProbD.getInstance();
		D.init(args[0]);
		D.run();
	}

	int N;
	int caseNum = 0;

	public void getN() {
		N = Integer.parseInt(getLine());
	}

	public String getLine() {
		String line = "";
		try {
			line = reader.readLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return line;
	}
	
	public void run() {
		getN();
		for(int i = 0; i < N; i++) {
			parseCase();
			String s = solve();
			writeCase(s);
		}
		finish();
	}

	/**
	 * @param fileName the test case to open
	 */
	public void init(String fileName) {
		this.inFileName = fileName;
		this.outFileName = getProb() + ".out";
		inFile = new File(inFileName);
		outFile = new File(outFileName);
		try {
			reader = new BufferedReader(new FileReader(inFile));
			writer = new FileWriter(outFile);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}

	public void finish() {
		try {
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
