import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Scanner;


public class ProbD {

	class Point {
		public Point(int x, int y) {
			X = x; Y = y;
		}
		int X;
		int Y;
		
		@Override
		public boolean equals(Object o) {
			if(!(o instanceof Point)) return false;
			Point p = (Point)o;
			if(p.X == X && p.Y == Y) return true;
			return false;
		}
		
		@Override
		public int hashCode() {
			return 5875*X+2341*Y;
		}
	}

	Map<Point,Boolean> rocks;
	
	public String solve() {
		int H = scanner.nextInt();
		int W = scanner.nextInt();
		int R = scanner.nextInt();
		//System.out.print("HWR:" + H + " " + W + " " + R + ";");
		int X,Y;
		int P = 10007;
		rocks = new HashMap<Point,Boolean>();
		
		for(int i = 0; i < R; i++) {
			X = scanner.nextInt();
			Y = scanner.nextInt();
			rocks.put(new Point(X,Y), true);
		}
		
		int M = (W+H-2)/3; //moves
		int Rt = (W-1)-M; //right
		int Lf = (H-1)-M; //left

		//System.out.println("M Rt Lf:" + M + " " + Rt + " " + Lf);
		
		if(Rt > M || Lf > M) return 0 + "";
		if((W+H-2) % 3 != 0) return 0 + "";
		
		
		int row[][] = new int[2][M+4];
		for(int i = 0; i < 2; i++) {
			for(int j = 0; j < M; j++) {
				row[i][j] = 0;
			}
		}
		row[0][0] = 1;
		
		for(int r = 0; r <= M; r++) {
			for(int c = 0; c <= r+1 && c <= Rt; c++) {
				if(checkRock(r,c)) { //no rock
					row[1][c] = row[0][c] + (c >= 1 ? row[0][c-1] : 0);
					row[1][c] %= 10007;
				} else {
					//System.out.println("Rock!" + " " + r + " " + c);
					row[1][c] = 0;
				}
			}
			for(int c = 0; c <= r; c++) {
				//System.out.print(row[1][c] + " ");
				row[0][c] = row[1][c];
			}
			//System.out.println();
		}
		
		return "" + row[0][Rt];
		       
	}
	
	public boolean checkRock(int r, int c) {
		int x = 1 + 2*r - c;
		int y = 1 + 2*c + (r-c);
		Point q = new Point(x,y);
		if(rocks.containsKey(q)) return false;
		return true;
	}
	
	public void writeCase(String answerString) {
		String caseString = "Case #" + ++caseNum + ": ";
		
		try {
			writer.write(caseString + answerString + "\n");
		} catch (IOException e) {
			e.printStackTrace();
		}
	}


	
	
	
	/*
	 * 
	 * helpers
	 * 
	 * 
	 */
	
	public List<Object> get(String regex, String line, Object... objects) {
		String[] splits = line.split(regex);
		List<Object> ret = new ArrayList<Object>();
		int i = 0;
		for(Object o : objects) {
			if(o instanceof Integer) {
				ret.add(new Integer(splits[i]));
			} else if(o instanceof Double) {
				ret.add(new Double(splits[i]));
			} else if(o instanceof String) {
				ret.add(splits[i]);
			} else {
				
			}
			i++;
		}
		return ret;
	}
	
	private static ProbD INSTANCE = new ProbD();
	private ProbD() {};
	public static ProbD getInstance() { return INSTANCE; }
	public String getProb() { return "D"; }
	
	public String inFileName;
	public String outFileName = getProb() + ".out";
	
	public File inFile;
	public File outFile;
	public BufferedReader reader;
	public FileWriter writer;
	
	public static void main(String[] args) {
		ProbD D = ProbD.getInstance();
		D.init(args[0]);
		D.run();
	}

	int N;
	int caseNum = 0;
	private Scanner scanner;

	public void getN() {
		N = scanner.nextInt(); System.out.println("N:" + N);
	}

	public String getLine() {
		String line = "";
		try {
			line = reader.readLine();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return line;
	}
	
	public void run() {
		getN();
		for(int i = 0; i < N; i++) {
			String s = solve();
			writeCase(s);
		}
		finish();
	}

	/**
	 * @param fileName the test case to open
	 */
	public void init(String fileName) {
		this.inFileName = fileName;
		this.outFileName = getProb() + ".out";
		inFile = new File(inFileName);
		outFile = new File(outFileName);
		try {
			reader = new BufferedReader(new FileReader(inFile));
			writer = new FileWriter(outFile);
			scanner = new Scanner(inFile);
		} catch (Exception e) {
			e.printStackTrace();
		}
		
	}

	public void finish() {
		try {
			writer.close();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}
}
