package org.bolpor.cjbv.gcodejam.c2017r1;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.HashMap;
import java.util.LinkedHashMap;
import java.util.Map;

public class ProblemA {
	//private static String FILE_NAME = "old_magician-small";
	private static String FILE_NAME = "A-small-attempt1";

	public static void main(String[] args) throws Exception {
		new ProblemA(FILE_NAME).run();
	}
	
	public ProblemA(String fileName) throws Exception {
		in = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(fileName + ".in")));
		//out = new PrintStream(new File(fileName + ".out"));
		out = new PrintStream(new File("/Users/cjbolanos/Downloads/" + fileName + ".txt"));
	}

	public void run() throws IOException {
		int T = readInt();
		for ( int i = 1; i <= T; i++ ) {
			String result = processCase(i);
			out.printf("Case #%d: %s\n", i, result);
			System.out.printf("Case #%d:%s\n", i, result);
		}
		out.flush();
		out.close();
	}
	
	public String processCase(int caseN) throws IOException {
		StringBuilder b = new StringBuilder();
		int[] array = readIntArray();
		int R = array[0];
		int C = array[1];
		
		char[][] cake = new char[R][];
		for ( int i = 0; i < R; i++ ) {
			cake[i] = readLine().toCharArray();
		}

		Map<Character, Slice> slices = new LinkedHashMap<>();
		for ( int i = 0; i < R; i ++ ) {
			for ( int j = 0; j < C; j++ ) {
				char c = cake[i][j];
				if ( c == '?' ) continue;
				Slice s = slices.get(c);
				if ( null == s ) {
					s = new Slice();
					s.c = c;
					s.i1 = i;
					s.j1 = j;
					s.i2 = i;
					s.j2 = j;
					slices.put(c, s);
				}
				for ( int i1 = s.i1 + 1; i1 < i; i1++ ) {
					for ( int j1 = s.j1 + 1; j1 < j; j1++ ) {
						if ( cake[i1][j1] != '?' ) {
							System.err.printf("Error on %c\n", c);
							System.exit(1);
						}
					}
				}
				s.i2 = i;
				s.j2 = j;
			}
		}

		for ( Slice s : slices.values() ) {
			int i1 = s.i1;
			int i2 = s.i2;
			int j1 = s.j1;
			int j2 = s.j2;

			// Expand to left
			boolean still = true;
			while ( still ) {
				still = false;
				loop1: for ( int j = j1 - 1; j >= 0; j-- ) {
					for ( int i = i1; i <= i2; i++ ) {
						if ( cake[i][j] != '?') break loop1;
					}
					if ( j < j1 ) j1 = j;
					System.out.printf("Trying 1 with %s...\n", s.c + "," + i1 + ", " + j1 + ", " + i2 + ", " + j2);
					still = true;
				}
				loop2: for ( int j = j2 + 1; j < C; j++ ) {
					for ( int i = i1; i <= i2; i++ ) {
						if ( cake[i][j] != '?') break loop2;
					}
					if ( j > j2 ) j2 = j;
					System.out.printf("Trying 2 with %s...\n", s.c + "," + i1 + ", " + j1 + ", " + i2 + ", " + j2);
					still = true;
				}
				loop3: for ( int i = i1 - 1; i >= 0; i-- ) {
					for ( int j = j1; j <= j2; j++ ) {
						if ( cake[i][j] != '?') break loop3;
					}
					if ( i < i1 ) i1 = i;
					System.out.printf("Trying 3 with %s...\n", s.c + "," + i1 + ", " + j1 + ", " + i2 + ", " + j2);
					still = true;
				}
				loop4: for ( int i = i2 + 1; i < R; i++ ) {
					for ( int j = j1; j <= j2; j++ ) {
						if ( cake[i][j] != '?') break loop4;
					}
					if ( i > i2 ) i2 = i;
					System.out.printf("Trying 4 with %s...\n", s.c + "," + i1 + ", " + j1 + ", " + i2 + ", " + j2);
					still = true;
				}
			}
			
			for ( int i = i1; i <= i2; i++ ) {
				for ( int j = j1; j <= j2; j++ ) {
					char c1 = cake[i][j];
					if ( (c1 != s.c) && (c1 != '?') ) {
						System.err.printf("Oops in %c\n", c1);
						System.exit(1);
					}
					cake[i][j] = s.c;
				}
			}
		}
		
		for ( int i = 0; i < R; i++ ) {
			b.append("\n");
			b.append(String.valueOf(cake[i]));
		}
		return b.toString();
	}

	public int readInt() throws IOException {
		return Integer.valueOf(readLine());
	}

	public int[] readIntArray() throws IOException {
		return readIntArray(" ");
	}

	public int[] readIntArray(String regex) throws IOException {
		String[] tokens = readLine().split(" ");
		int[] array = new int[tokens.length];
		for ( int i = 0; i < array.length; i++ ) {
			array[i] = Integer.valueOf(tokens[i]);
		}
		return array;
	}

	public String readLine() throws IOException {
		return in.readLine();
	}

	static class Slice {
		Character c;
		int i1, i2;
		int j1, j2;
		
		public String toString() {
			return c + "," + i1 + ", " + j1 + ", " + i2 + ", " + j2;
		}
	}

	BufferedReader in;
	PrintStream out;
}
