package org.bolpor.cjbv.gcodejam.c2017;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.LinkedList;

public class ProblemC_Analysis2 {
	//private static String FILE_NAME = "old_magician-small";
	private static String FILE_NAME = "C-small-1-attempt1";
	//private static String FILE_NAME = "ProblemC-Sample";

	public static void main(String[] args) throws Exception {
		new ProblemC_Analysis2(FILE_NAME).run();
	}
	
	public ProblemC_Analysis2(String fileName) throws Exception {
		in = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(fileName + ".in")));
		//out = new PrintStream(new File(fileName + ".out"));
		out = new PrintStream(new File("/Users/cjbolanos/Downloads/" + fileName + ".txt"));
	}

	public void run() throws IOException {
		int T = readInt();
		for ( int i = 1; i <= T; i++ ) {
			String result = processCase(i);
			out.printf("Case #%d: %s\n", i, result);
			System.out.printf("Case #%d: %s\n", i, result);
		}
		out.flush();
		out.close();
	}
	
	static BigInteger TWO = BigInteger.valueOf(2);
	public String processCase(int caseN) throws IOException {
		int[] array = readIntArray();
		int N = array[0];
		int K = array[1];
		
		int[] stalls = createArray(N + 2, -1);
		stalls[0] = 0;
		stalls[N + 1] = N + 1;

		int stall_I = -1;
		int leftS_I = -1;
		int rightS_I = -1;
		for ( int i = 0; i < K; i++ ) {
			int stall = -1;

			int[] lefts = createArray(N + 2, -1); 
			int[] rights = createArray(N + 2, -1);
			int[] mins = createArray(N + 2, -1); 
			int[] maxs = createArray(N + 2, -1);

			int maxMin = -1;
			for ( int j = 0; j < N + 2; j++ ) {
				if ( stalls[j] >= 0 ) continue;
				
				int left = j - 1;
				while ( (left >= 0) && (stalls[left] < 0 ) )
					left --;

				int right = j + 1;
				while ( (right < N + 2) && (stalls[right] < 0 ) )
					right++;
				
				lefts[j] = j - left - 1;
				rights[j] = right - j - 1;

				mins[j] = Math.min(lefts[j], rights[j]);
				maxs[j] = Math.max(lefts[j], rights[j]);
				if ( mins[j] > maxMin ) {
					maxMin = mins[j];
				}
			}

			int maxMinCount = 0;
			int firstMaxMin = -1;
			for ( int j = 0; j < N + 2; j ++ ) {
				if ( mins[j] == maxMin ) {
					maxMinCount++;
					if ( firstMaxMin < 0 ) {
						firstMaxMin = j;
					}
				}
			}

			if ( maxMinCount > 1 ) {
				int maxMax = -1;
				int maxMaxCount = -1;
				int firstMaxMax = -1;
				for ( int j = firstMaxMin; j < N + 2; j++ ) {
					if ( mins[j] != maxMin ) continue;
					if ( maxs[j] > maxMax ) {
						maxMax = maxs[j];
						firstMaxMax = j;
						maxMaxCount = 1;
					} else if ( maxMax == maxs[j] ) {
						maxMaxCount ++;
					}
				}
				
				if ( maxMaxCount == 1 ) {
					stall = firstMaxMax;
				} else {
					stall = firstMaxMax;
				}
			} else {
				stall = firstMaxMin;
			}

			stall_I = stall;
			leftS_I = lefts[stall];
			rightS_I = rights[stall];
			stalls[stall] = i;
			//System.out.printf("[%5d] Stall: %5d, leftS: %5d, rightS: %5d\n", i, stall_I, leftS_I, rightS_I);
		}
		
		return Math.max(rightS_I, leftS_I) + " " + Math.min(rightS_I, leftS_I); 
	}

	public String[] createArray(int size, String val) {
		String[] a = new String[size];
		for ( int i = 0; i < a.length; i++ )
			a[i] = val;
		return a;
	}

	public char[] createArray(int size, char val) {
		char[] a = new char[size];
		for ( int i = 0; i < a.length; i++ )
			a[i] = val;
		return a;
	}

	public int[] createArray(int size, int val) {
		int[] a = new int[size];
		for ( int i = 0; i < a.length; i++ )
			a[i] = val;
		return a;
	}

	public int readInt() throws IOException {
		return Integer.valueOf(readLine());
	}

	public int[] readIntArray() throws IOException {
		return readIntArray(" ");
	}

	public int[] readIntArray(String regex) throws IOException {
		String[] tokens = readLine().split(" ");
		int[] array = new int[tokens.length];
		for ( int i = 0; i < array.length; i++ ) {
			array[i] = Integer.valueOf(tokens[i]);
		}
		return array;
	}

	public BigInteger[] readBigIntegerArray() throws IOException {
		return readBigIntegerArray(" ");
	}

	public BigInteger[] readBigIntegerArray(String regex) throws IOException {
		String[] tokens = readLine().split(" ");
		BigInteger[] array = new BigInteger[tokens.length];
		for ( int i = 0; i < array.length; i++ ) {
			array[i] = new BigInteger(tokens[i]);
		}
		return array;
	}

	public String[] readStringArray() throws IOException {
		return readLine().split(" ");
	}

	public String[] readStringArray(String regex) throws IOException {
		return readLine().split(regex);
	}

	public String readLine() throws IOException {
		return in.readLine();
	}

	public void print(PrintStream out, int[] a, String format) {
		for ( int i = 0; i < a.length; i++ ) {
			if ( i > 0 ) out.print(" ");
			out.printf(format, a[i]);
		}
		out.println();
	}

	BufferedReader in;
	PrintStream out;
}
