/*
Lawnmower
Problem

Alice and Bob have a lawn in front of their house, shaped as a rectangle of N by M metres. Each year, they try to cut the lawn in some interesting pattern. So far, they had to do it with shears, which was very time-consuming, but now they have a new automatic lawnmower with multiple settings, and they want to try it out.

The new lawnmower has a height setting - you can set it to any height h between 1 and 100 millimetres, and it will cut all the grass higher than h it encounters to height h. You run it by entering the lawn at any part of the edge of the lawn, and the lawnmower goes in a straight line, perpendicular to the edge of the lawn it entered, cutting grass in a swath 1m wide, until it exits the lawn on the other side.

Alice and Bob have a number of various patterns of grass that they could have on their lawn. For each of those, they want to know whether it's possible to cut the grass into this pattern with their new lawnmower. Each pattern is described by specifying the height of the grass on each 1m x 1m square of the lawn.

The grass is 100mm high on the whole lawn initially.

Input

The first line of the input gives the number of test cases, T. T test cases follow. Each test case begins with a line containing two numbers: N and M. Next follow N lines, with the ith line containing M numbers ai,j each, the number ai,j describing the desired height of the grass in the jth square of the ith row.

Output

For each test case, output one line containing "Case #x: y", where x is the case number (starting from 1) and y is either the word "YES" if it's possible to get the x-th pattern using the lawnmower, or "NO", if it's impossible (quotes for clarity only).

Limits

1 ≤ T ≤ 100.

Small dataset

1 ≤ N, M ≤ 10.
1 ≤ ai,j ≤ 2.
Large dataset

1 ≤ N, M ≤ 100.
1 ≤ ai,j ≤ 100.
Sample


Input 
 	
Output 
 
3
3 3
2 1 2
1 1 1
2 1 2
5 5
2 2 2 2 2
2 1 1 1 2
2 1 2 1 2
2 1 1 1 2
2 2 2 2 2
1 3
1 2 1
Case #1: YES
Case #2: NO
Case #3: YES

*/
package test.bolpor.topcoding.google.jam.cjbv.y2013.r1;

import test.bolpor.topcoding.google.jam.base.ProblemSolver;

public class B extends ProblemSolver
{
	public static void main(String[] args) throws java.io.IOException
	{
		B processor;

		processor = new B();
		processor.setFilePrefix("B-small-attempt0");
		processor.start();
	}
	
	@Override
	public String processCase(int caseNumber) throws java.io.IOException
	{
		N = nextInteger();
		M = nextInteger();
		lawn = nextIntegers(N, M);

		int[] rowMins = new int[N];
		for ( int i = 0; i < N; i++ )
			for ( int j = 0; j < M; j++ )
				if ( lawn[i][j] > rowMins[i] )
					rowMins[i] = lawn[i][j];

		int[] colMins = new int[M];
		for ( int j = 0; j < M; j++ )
			for ( int i = 0; i < N; i++ )
				if ( lawn[i][j] > colMins[j] )
					colMins[j] = lawn[i][j];

		for ( int i = 0; i < N; i++ )
			for ( int j = 0; j < M; j++ )
			{
				if ( lawn[i][j] >= colMins[j] )
					continue;
				if ( lawn[i][j] >= rowMins[i] )
					continue;
				return "NO";
			}
				
		return "YES";
	}
	
	int M;
	int N;
	int[][] lawn;
}
