package org.bolpor.cjbv.gcodejam.c2017r1b;

import java.io.BufferedReader;
import java.io.File;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;
import java.util.LinkedHashMap;
import java.util.Map;

public class ProblemA {
	//private static String FILE_NAME = "old_magician-small";
	private static String FILE_NAME = "A-small-attempt0";

	public static void main(String[] args) throws Exception {
		new ProblemA(FILE_NAME).run();
	}
	
	public ProblemA(String fileName) throws Exception {
		in = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(fileName + ".in")));
		//out = new PrintStream(new File(fileName + ".out"));
		out = new PrintStream(new File("/Users/cjbolanos/Downloads/" + fileName + ".txt"));
	}

	public void run() throws IOException {
		int T = readInt();
		for ( int i = 1; i <= T; i++ ) {
			String result = processCase(i);
			out.printf("Case #%d: %s\n", i, result);
			System.out.printf("Case #%d:%s\n", i, result);
		}
		out.flush();
		out.close();
	}
	
	public String processCase(int caseN) throws IOException {
		long[] array1 = readLongArray();
		long D = array1[0];
		int N = (int) array1[1];
		
		long[][] horses = new long[N][];
		for ( int i = 0; i < N; i++ ) {
			horses[i] = readLongArray();
		}

		double[] times = new double[N];
		double maxTime = 0.0;
		for ( int i = 0; i < N; i ++ ) {
			times[i] = ((double) D - horses[i][0]) / (1.0 * horses[i][1]);
			if ( times[i] > maxTime )
				maxTime = times[i];
		}

		double maxSpeed = ((double) D) / maxTime;
		
		return String.valueOf(maxSpeed);
	}

	public int readInt() throws IOException {
		return Integer.valueOf(readLine());
	}

	public int[] readIntArray() throws IOException {
		return readIntArray(" ");
	}

	public long[] readLongArray() throws IOException {
		return readLongArray(" ");
	}

	public int[] readIntArray(String regex) throws IOException {
		String[] tokens = readLine().split(" ");
		int[] array = new int[tokens.length];
		for ( int i = 0; i < array.length; i++ ) {
			array[i] = Integer.valueOf(tokens[i]);
		}
		return array;
	}

	public long[] readLongArray(String regex) throws IOException {
		String[] tokens = readLine().split(" ");
		long[] array = new long[tokens.length];
		for ( int i = 0; i < array.length; i++ ) {
			array[i] = Long.valueOf(tokens[i]);
		}
		return array;
	}

	public String readLine() throws IOException {
		return in.readLine();
	}

	static class Slice {
		Character c;
		int i1, i2;
		int j1, j2;
		
		public String toString() {
			return c + "," + i1 + ", " + j1 + ", " + i2 + ", " + j2;
		}
	}

	BufferedReader in;
	PrintStream out;
}
