package org.bolpor.cjbv.gcodejam.c2017;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintStream;

public class ProblemA1 {
	//private static String FILE_NAME = "old_magician-small";
	private static String FILE_NAME = "A-small-attempt0";

	public static void main(String[] args) throws Exception {
		new ProblemA1(FILE_NAME).run();
	}
	
	public ProblemA1(String fileName) throws Exception {
		in = new BufferedReader(new InputStreamReader(getClass().getResourceAsStream(fileName + ".in")));
		//out = new PrintStream(new File(fileName + ".out"));
		out = new PrintStream(new File("/Users/cjbolanos/Downloads/" + fileName + ".txt"));
	}

	public void run() throws IOException {
		int T = readInt();
		for ( int i = 1; i <= T; i++ ) {
			String result = processCase(i);
			out.printf("Case #%d: %s\n", i, result);
			System.out.printf("Case #%d: %s\n", i, result);
		}
		out.flush();
		out.close();
	}
	
	public String processCase(int caseN) throws IOException {
		String[] line = readStringArray();
		String pancakes = line[0];
		int flipSize = Integer.valueOf(line[1]);

		int flips = 0;
		char[] s = pancakes.toCharArray();
		int i = 0;
		while ( true ) {
			//System.out.printf("%s %d %d\n", String.valueOf(s), i, flips);
			while ( (i < s.length) && (s[i] == '+') )
				i++;
			if ( i >= s.length )
				return String.valueOf(flips);
			if ( i + flipSize > s.length )
				return "IMPOSSIBLE";
			for ( int j = 0; j < flipSize; j++ ) {
				s[i + j] = (s[i+j] == '+') ? '-' : '+';
			}
			flips++;
		}
	}

	public int readInt() throws IOException {
		return Integer.valueOf(readLine());
	}

	public String[] readStringArray() throws IOException {
		return readLine().split(" ");
	}

	public int[] readIntArray() throws IOException {
		return readIntArray(" ");
	}

	public int[] readIntArray(String regex) throws IOException {
		String[] tokens = readLine().split(" ");
		int[] array = new int[tokens.length];
		for ( int i = 0; i < array.length; i++ ) {
			array[i] = Integer.valueOf(tokens[i]);
		}
		return array;
	}

	public String[] readStringArray(String regex) throws IOException {
		return readLine().split(regex);
	}

	public String readLine() throws IOException {
		return in.readLine();
	}

	BufferedReader in;
	PrintStream out;
}
