import java.io.*;
import java.util.*;

// Solves 2nd small input

class Interval implements Comparable<Interval> {
   long start, len;
   Interval(long start, long len) {
      this.start = start;
      this.len   = len;
   }
   public int compareTo(Interval rhs) {
      if (len != rhs.len)
         return len > rhs.len ? -1 : 1;
      if (start != rhs.start)
         return start < rhs.start ? -1 : 1;
      return 0;
   }
}

public class BathroomStalls {
   public static void solve(int tc, long N, long K) {
      PriorityQueue<Interval> pq = new PriorityQueue<Interval>();
      pq.offer(new Interval(1L, N));
      for (int k = 0; k < K-1; ++k) {
         Interval x = pq.poll();
         if ((x.len % 2) == 0) {
            long mid = x.start + (x.len-1)/2;
            if ((x.len-1)/2 > 0)
               pq.offer(new Interval(x.start, (x.len-1)/2));
            if (x.len/2 > 0)
               pq.offer(new Interval(mid+1, x.len/2));
         }
         else {
            long mid = x.start + x.len/2;
            if (x.len/2 > 0) {
               pq.offer(new Interval(x.start, x.len/2));
               pq.offer(new Interval(mid+1, x.len/2));
            }
         }
      }
      
      Interval last = pq.poll();
      if ((last.len % 2) == 0)
         System.out.printf("Case #%d: %d %d\n", tc, last.len/2, (last.len-1)/2);
      else
         System.out.printf("Case #%d: %d %d\n", tc, last.len/2, last.len/2);
   }

   public static void main (String[] args) throws IOException {
      BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
      int TC = Integer.parseInt(in.readLine());
      for (int tc = 1; tc <= TC; ++tc) {
         String[] tok = in.readLine().split(" ");
         long N = Long.parseLong(tok[0]);
         long K = Long.parseLong(tok[1]);
         solve(tc, N, K);
      }
   }
   
}

