import java.io.File;
import java.io.PrintWriter;
import java.util.Scanner;

public class A {
    enum RESULT {
        X_WON("X won"),
        O_WON("O won"),
        DRAW("Draw"),
        UNFINISHED("Game has not completed");
        private String value;
        RESULT(final String value) {
            this.value = value;
        }
        public String getValue() {
            return this.value;
        }
    }

    public static boolean checkCell(final char cell, final char competitor) {
        return cell == competitor || cell == 'T';
    }

    public static boolean checkWinner(final char[][] board, final char competitor) {
        // check rows
        for (int i = 0; i < 4; i++) {
            if (checkCell(board[i][0], competitor) && checkCell(board[i][1], competitor) &&
                    checkCell(board[i][2], competitor) && checkCell(board[i][3], competitor)) {
                return true;
            }
        }
        //check columns
        for (int i = 0; i < 4; i++) {
            if (checkCell(board[0][i], competitor) && checkCell(board[1][i], competitor) &&
                    checkCell(board[2][i], competitor) && checkCell(board[3][i], competitor)) {
                return true;
            }
        }
        //check diagonals
        if (checkCell(board[0][0], competitor) && checkCell(board[1][1], competitor) &&
                    checkCell(board[2][2], competitor) && checkCell(board[3][3], competitor)) {
                return true;
        }
        if (checkCell(board[0][3], competitor) && checkCell(board[1][2], competitor) &&
                    checkCell(board[2][1], competitor) && checkCell(board[3][0], competitor)) {
                return true;
        }
        return false;
    }

    public static boolean checkIfNotComplete(final char[][] board) {
        for (int i = 0; i < 4; i++) {
            for (int j = 0; j < 4; j++) {
                if (board[i][j] == '.') {
                    return true;
                }
            }
        }
        return false;
    }

    public static void main(String[] args) throws Exception{
        Scanner read = new Scanner(new File("A-small-attempt0.in"));
        PrintWriter out = new PrintWriter("A-small.out");
        final int numOfTests = read.nextInt();
        for (int l = 0; l < numOfTests; l++) {
            read.nextLine();
            final char[][] board = new char[4][4];
            for (int i = 0; i < 4; i++) {
                final String line = read.nextLine();
                for (int j = 0; j < 4; j++) {
                    board[i][j] = line.charAt(j);
                }
            }
            if (checkWinner(board, 'X')) {
                out.println(String.format("Case #%d: %s", l + 1, RESULT.X_WON.getValue()));
            } else if (checkWinner(board, 'O')) {
                out.println(String.format("Case #%d: %s", l + 1, RESULT.O_WON.getValue()));
            } else if (checkIfNotComplete(board)) {
                out.println(String.format("Case #%d: %s", l + 1, RESULT.UNFINISHED.getValue()));
            } else {
                out.println(String.format("Case #%d: %s", l + 1, RESULT.DRAW.getValue()));
            }
        }
        out.close();

    }
}
