import java.awt.Container;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JTextArea;


public class Tongues extends JFrame
{
	private final int WIDTH = 800;
	private final int HEIGHT = 400;
	private Container pane; 
	
	private String[] unformatted;
	private String[] formatted;
	private char[][] formattedCharArray;
	
	private int numberOfLines;
	
	private JTextArea input, output;
	private JButton newMapping;
	
	
	
	private Scanner scanner;
	private PrintWriter out;
	
	
	public Tongues() throws IOException
	{
		pane = new Container();
		pane = getContentPane();
		
		scanner = new Scanner(new File("input.in"));
		out = new PrintWriter(new FileWriter("c:/users/Christopher/Desktop/output.out")); 
		
		numberOfLines = Integer.parseInt(scanner.nextLine());
		
		
		unformatted = new String[numberOfLines];
		formatted = new String[numberOfLines];
		formattedCharArray = new char[numberOfLines][];
		
		
		
		input = new JTextArea(100, numberOfLines);
		input.setSize(300,200);
		input.setLocation (10, 10);
		
		output = new JTextArea(120, numberOfLines);
		output.setSize(300,200);
		output.setLocation(410, 10);
		
		pane.setLayout(null);
		pane.add(input);
		pane.add(output);
		
		
		
		for (int i = 0; i < numberOfLines; i++)
		{
			unformatted[i] = scanner.nextLine();
			input.append(unformatted[i] + "\n");
			
			formattedCharArray[i] = unformatted[i].toCharArray();
			
			for (int j = 0; j < formattedCharArray[i].length; j++)
			{
				formattedCharArray[i][j] = charConversion(unformatted[i].charAt(j));
			}
		}
		
		
		
		
		for (int i = 0; i < numberOfLines; i++)
		{
			formatted[i] = new String(formattedCharArray[i]);
			formatted[i] = "Case #" + (i + 1) + ": " + formatted[i];
			output.append(formatted[i] + "\n");
			out.println(formatted[i]);
		}
		
		scanner.close();
		out.close();
		
		setVisible(true);
		setSize(WIDTH, HEIGHT);
		setTitle("Tongues");
		setDefaultCloseOperation(EXIT_ON_CLOSE);
		
		
	}
	
	public static void main(String args[]) throws IOException
	{
		Tongues awesome = new Tongues();
	}
	
	char charConversion(char a)
	{
		if (a == 'a')
			return 'y';
		else if (a == 'b')
			return 'h';
		else if (a == 'c')
			return 'e';
		else if (a == 'd')
			return 's';
		else if (a == 'e')
			return 'o';
		else if (a == 'f')
			return 'c';
		else if (a == 'g')
			return 'v';
		else if (a == 'h')
			return 'x';
		else if (a == 'i')
			return 'd';
		else if (a == 'j')
			return 'u';
		else if (a == 'k')
			return 'i';
		else if (a == 'l')
			return 'g';
		else if (a == 'm')
			return 'l';
		else if (a == 'n')
			return 'b';
		else if (a == 'o')
			return 'k';
		else if (a == 'p')
			return 'r';
		else if (a == 'q')
			return 'z';
		else if (a == 'r')
			return 't';
		else if (a == 's')
			return 'n';
		else if (a == 't')
			return 'w';
		else if (a == 'u')
			return 'j';
		else if (a == 'v')
			return 'p';
		else if (a == 'w')
			return 'f';
		else if (a == 'x')
			return 'm';
		else if (a == 'y')
			return 'a';
		else if (a == 'z')
			return 'q';
		else if (a == ' ')
			return ' ';
		return ' ';
	}
}
