import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.math.BigDecimal;
import java.math.BigInteger;
import java.util.Scanner;


public class PalindromeSolver {
	
		public static void main(String[] args) throws IOException
		{
			
			Scanner a = new Scanner(System.in);
			String fileName = a.next();
			
			SquareRootOfBigIntegerExample rootFinder = new SquareRootOfBigIntegerExample();
	
			FileReader fr = new FileReader(fileName);
			FileWriter fw = new FileWriter("c:/users/chris/desktop/palOutput.txt");
			
			
			Scanner b = new Scanner(fr);
			
			int testCases = b.nextInt();

			
			for (int i = 0; i < testCases; i++)
			{
				BigInteger start = new BigInteger(b.next());
				BigInteger end = new BigInteger(b.next());
				BigInteger count = BigInteger.ZERO;
				
				for (BigInteger bi = start; bi.compareTo(end) <= 0; bi = bi.add(BigInteger.ONE))
				{
					String s = bi.toString();
					
					if (isPalindrome(s))
					{
						String itsSquare = rootFinder.getRoot(bi);
						BigDecimal bd = new BigDecimal(itsSquare);
						BigDecimal remainder = bd.remainder(BigDecimal.ONE);

						if (remainder.compareTo(new BigDecimal("0")) != 0)
						{
							continue;
						}
						else
						{
							int goodPart = itsSquare.indexOf('.');
							String choppedSquare = itsSquare.substring(0, goodPart);
							
							//System.out.println("Big Int = " + bi.toString() + "\r\nChopped Square = " + choppedSquare);
							
							if (isPalindrome(choppedSquare))
							{
								//System.out.println("Found one! BigInt = " + bi.toString());
								count = count.add(BigInteger.ONE);
							}
						}
					}
				}
				
				String writeMe = String.format("Case #%d: %d", i, count);
				fw.write(writeMe);
				fw.write("\r\n");
			
			}
			
			fw.close();
		}
		
		public static boolean isPalindrome(String s)
		{
			
			for (int i = 0; i < (s.length() / 2); i++)
			{	
				if (s.charAt(0 + i) != s.charAt((s.length() - 1) - i))
				{
					return false;
				}
			}
			
			return true;
		}
}
