import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.Scanner;


public class IHOP {

	public static void main(String[] args) throws FileNotFoundException {
		Scanner s = new Scanner(new FileReader("test.txt"));
		
		int testCases = s.nextInt();
		String ingore = s.nextLine();
		
		for (int i = 0 ; i < testCases; i++) {
			ingore = s.nextLine();
			List<Integer> dinerList = new LinkedList<Integer>();
			String[] dinerString = s.nextLine().split(" ");
			for (String str : dinerString) {
				dinerList.add(Integer.parseInt(str));
			}
			
			Collections.sort(dinerList, Collections.reverseOrder());
			
			System.out.println("Case #" + (i + 1) + ": " + solveList(dinerList));
		}
	}
	
	private static String solveList(List<Integer> dinerList) {
		List<Integer> times = new LinkedList<Integer>();
		times.add(findTimeLeft(0, dinerList));
		
//		System.out.println("Flip # 0");
//		for (Integer integ: dinerList) {
//			System.out.print(integ +", ");
//		}
//		System.out.println("");
//		System.out.println("Timeleft = " + times.get(0));
		
		
		int greatest = dinerList.get(0);
		int numberOfFlips = logBase2(greatest);
		
		for (int i = 1; i <= numberOfFlips; i++) {
			greatest = dinerList.get(0);
			dinerList.remove(0);
			dinerList.add(greatest / 2);
			dinerList.add((greatest + 1) / 2);
			Collections.sort(dinerList, Collections.reverseOrder());
			int timeLeft = findTimeLeft(i, dinerList);
			
//			System.out.println("Flip #" + i);
//			System.out.print("Diners = ");
//			for (Integer integ: dinerList) {
//				System.out.print(integ +", ");
//			}
//			System.out.println("");
//			System.out.println("Timeleft = " + timeLeft);
			
			times.add(timeLeft);
			
		}
		
		Collections.sort(times);
		return Integer.toString(times.get(0));
	}
	
	private static int logBase2(int i) {
		int counter = 0;
		while (i / 2 > 0) {
			i = i / 2;
			counter++;
		}
		return counter;
	}
	
	private static int findTimeLeft(int flip, List<Integer> dinerList) {
		return dinerList.get(0) + flip;
	}
}
