package com.google.codejam;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

public class StandingOvation {

    private static final String INPUT = "/home/ckaratza/Downloads/A-large.in";
    private static final String OUTPUT = "/home/ckaratza/Downloads/A-large.out";

    private static int calculateDummyAudience(int maxNeedsToStand, String ovationDistribution) {
        int currentStanding = 0;
        int dummies = 0;
        for (int i = 0; i < ovationDistribution.length(); i++) {
            int candidatesToStand = Integer.valueOf(ovationDistribution.charAt(i) + "");
            if (i <= currentStanding) {
                currentStanding += candidatesToStand;
            } else {
                int addedDummies = i - currentStanding;
                dummies += addedDummies;
                currentStanding += addedDummies + candidatesToStand;
            }
            if (currentStanding >= maxNeedsToStand) {
                break;
            }
        }
        return dummies;
    }

    public static void main(String[] args) throws Exception {
        System.setIn(new FileInputStream(INPUT));
        System.setOut(new PrintStream(new FileOutputStream(OUTPUT)));
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            int maxNeedsToStand = in.nextInt();
            String ovationDistribution = in.next();
            System.out.printf("Case #%d: %d%n", caseNum, calculateDummyAudience(maxNeedsToStand, ovationDistribution));
        }
    }
}
