package com.google.contest;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.BitSet;
import java.util.Scanner;

public class CountingSheep {

    private static final String INPUT = "/home/ckaratza/codejam2016/countingSheep/test-min.in";
    private static final String OUTPUT = "/home/ckaratza/codejam2016/countingSheep/test-min.out";

    public static void main(String[] args) throws FileNotFoundException {
        System.setIn(new FileInputStream(INPUT));
        System.setOut(new PrintStream(new FileOutputStream(OUTPUT)));
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        BitSet digits = new BitSet(10);
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            int N = in.nextInt();
            digits.clear();
            System.out.printf("Case #%d: %s\n", caseNum, CountingSheep.LastNumber(digits, N));
        }
    }

    public static String LastNumber(BitSet digits, int N) {
        if (N == 0) {
            return "INSOMNIA";
        }
        int iteration = 1, multiplied = N, digitsEncountered = 0;
        while (digitsEncountered < 10) {
            multiplied = iteration++ * N;
            char[] digitChars = Integer.toString(multiplied).toCharArray();
            for (char digit : digitChars) {
                if (!digits.get(digit)) {
                    digits.set(digit);
                    digitsEncountered++;
                }
            }
        }
        return multiplied + "";
    }
}
