package com.google.contest;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

public class Fractiles {

    private static final String INPUT = "/home/ckaratza/codejam2016/fractiles/test-min.in";
    private static final String OUTPUT = "/home/ckaratza/codejam2016/fractiles/test-min.out";

    public static void main(String[] args) throws FileNotFoundException {
        System.setIn(new FileInputStream(INPUT));
        System.setOut(new PrintStream(new FileOutputStream(OUTPUT)));
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            int tiles = in.nextInt();
            int complexity = in.nextInt();
            int tilesToClean = in.nextInt();
            String positions = findStemPositions(tiles, complexity, tilesToClean);
            System.out.printf("Case #%d: %s\n", caseNum, positions);
        }
    }

    private static String findStemPositions(int tiles, int complexity, int tilesToClean) {
        if (complexity == 1) {
            if (tilesToClean < tiles) {
                return "IMPOSSIBLE";
            }
        }
        if (tilesToClean < tiles) {
            return "IMPOSSIBLE";
        }
        StringBuilder sb = new StringBuilder();
        if (complexity == 1) {
            for (int i = 1; i <= tiles; i++) {
                sb.append(i).append(" ");
            }
            return sb.toString();
        }
        int until = tilesToClean;
        for (int i = tiles; i <= tiles * tiles; i += tiles, until--) {
            if (until == 0) {
                break;
            }
            sb.append(i).append(" ");
        }
        return sb.toString();
    }
}
