package com.google.contest;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.math.BigInteger;
import java.util.Scanner;

public class CoinJam {

    private static final String INPUT = "/home/ckaratza/codejam2016/coinJam/test-min.in";
    private static final String OUTPUT = "/home/ckaratza/codejam2016/coinJam/test-min.out";

    public static void main(String[] args) throws FileNotFoundException {
        System.setIn(new FileInputStream(INPUT));
        System.setOut(new PrintStream(new FileOutputStream(OUTPUT)));
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            int coinSize = in.nextInt();
            int coinsToConstruct = in.nextInt();
            int coinsFound = 0;
            String[][] resultMatrix = new String[coinsToConstruct][10];
            long from = ((Double) Math.pow(2, coinSize - 1)).longValue();
            long to = ((Double) Math.pow(2, coinSize)).longValue();
            for (long x = from; x < to; x++) {
                boolean bit0Set = (x & (1 << 0)) == 1;
                if (bit0Set) {
                    String binaryString = Long.toBinaryString(x);
                    boolean isValidCoinJam = checkIfIsCoinJamAndPopulateResultMatrix(binaryString, resultMatrix, coinsFound);
                    if (isValidCoinJam) {
                        coinsFound++;
                        if (coinsFound == coinsToConstruct) {
                            break;
                        }
                    }
                }
            }
            System.out.printf("Case #%d: \n", caseNum);
            for (int i = 0; i < coinsToConstruct; i++) {
                for (int y = 0; y < 10; y++) {
                    System.out.print(resultMatrix[i][y] + " ");
                }
                System.out.println();
            }
        }
    }

    public static boolean checkIfIsCoinJamAndPopulateResultMatrix(String binaryString, String[][] resultMatrix, int pointer) {
        resultMatrix[pointer][0] = binaryString;
        int writeAt = 1;
        for (int radix = 2; radix <= 10; radix++) {
            BigInteger transformedLong = new BigInteger(binaryString, radix);
            BigInteger possibleDivisor = findPossibleDivisor(transformedLong);
            if (possibleDivisor.equals(BigInteger.ONE)) {
                return false;
            }
            resultMatrix[pointer][writeAt++] = possibleDivisor + "";
        }
        return true;
    }

    public static BigInteger findPossibleDivisor(BigInteger number) {
        if (number.isProbablePrime(5)) {
            return BigInteger.ONE;
        }
        BigInteger two = new BigInteger("2");
        if (!two.equals(number) && BigInteger.ZERO.equals(number.mod(two))) {
            return BigInteger.ONE;
        }
        for (BigInteger i = new BigInteger("3"); i.multiply(i).compareTo(number) < 1; i = i.add(two)) {
            if (BigInteger.ZERO.equals(number.mod(i)))
                return i;
        }
        return BigInteger.ONE;
    }
}
