package com.google.contest;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Scanner;

public class HappyPancakes {

    private static final String INPUT = "/home/ckaratza/codejam2016/happyPancakes/test-min.in";
    private static final String OUTPUT = "/home/ckaratza/codejam2016/happyPancakes/test-min.out";

    public static void main(String[] args) throws FileNotFoundException {
        System.setIn(new FileInputStream(INPUT));
        System.setOut(new PrintStream(new FileOutputStream(OUTPUT)));
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            String stack = in.next();
            boolean[] pancakes = HappyPancakes.constructStack(stack);
            System.out.printf("Case #%d: %d\n", caseNum, HappyPancakes.OptimalFlips(pancakes));
        }
    }

    public static int OptimalFlips(boolean[] pancakes) {
        int flips = 0;
        int stackSize = pancakes.length;
        while (true) {
            int cardinality = cardinality(pancakes);
            if (cardinality == pancakes.length) {
                break;
            }
            if (cardinality == 0) {
                flips++;
                break;
            }
            boolean previous = pancakes[0];
            int flipToIndex = -1;
            for (int i = 1; i < stackSize; i++) {
                if (previous != pancakes[i]) {
                    flipToIndex = i;
                    break;
                }
                previous = pancakes[i];
            }
            if (flipToIndex > -1) {
                flip(pancakes, 0, flipToIndex);
                flips++;
            }
        }
        return flips;
    }

    private static void flip(boolean[] pancakes, int from, int to) {
        for (int i = from; i < to; i++) {
            pancakes[i] = !pancakes[i];
        }
    }

    private static int cardinality(boolean[] pancakes) {
        int happyPancakes = 0;
        for (boolean pancake : pancakes) {
            if (pancake) {
                happyPancakes++;
            }
        }
        return happyPancakes;
    }

    private static boolean[] constructStack(String stack) {
        boolean[] bits = new boolean[stack.length()];
        int i = 0;
        for (char pancake : stack.toCharArray()) {
            bits[i++] = pancake == '+';
        }
        return bits;
    }
}
