package com.google.codejam;

import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.PriorityQueue;
import java.util.Scanner;

public class Pancakes {
    private static final String INPUT = "/home/ckaratza/Downloads/B-small-attempt1.in";
    private static final String OUTPUT = "/home/ckaratza/Downloads/B-small-attempt1.out";

    private static final int REVERSE_QUEUE_ORDERING_TRICK = 1001;

    private static int computePossibleBestCase(int cardinality, int max) {
        if (max == 0) {
            return 0;
        }
        int loops = 0;
        int x = max;
        while (true) {
            x = (int) Math.ceil(((double) x) / 2);
            loops++;
            if (x == 1) {
                break;
            }
        }
        return cardinality * loops;
    }

    private static int findMaximas(PriorityQueue<Integer> queue) {
        int currentMaxInQueue = queue.peek() == null ? 0 : REVERSE_QUEUE_ORDERING_TRICK - queue.peek();
        int allMaxima = 1;
        int pointer = currentMaxInQueue;
        for (int i = 1; i < queue.toArray().length; i++) {
            if (pointer == (REVERSE_QUEUE_ORDERING_TRICK - (Integer) (queue.peek()))) {
                allMaxima++;
            } else {
                break;
            }
        }
        return allMaxima;
    }

    private static int calculateBreakfastRunningTime(PriorityQueue<Integer> queue) {
        int runningTime = 0;
        while (!queue.isEmpty()) {
            int currentMax = REVERSE_QUEUE_ORDERING_TRICK - queue.peek();
            int tryIt = computePossibleBestCase(findMaximas(queue), currentMax);
            if (tryIt >= currentMax) {
                runningTime += currentMax;
                break;
            }
            currentMax = REVERSE_QUEUE_ORDERING_TRICK - queue.poll();
            int newPossibleMax = (int) Math.ceil(((double) currentMax) / 2);
            queue.add(REVERSE_QUEUE_ORDERING_TRICK - newPossibleMax);

            int currentMaxInQueue = queue.peek() == null ? 0 : REVERSE_QUEUE_ORDERING_TRICK - queue.peek();
            if (currentMaxInQueue == 1) {
                runningTime += Math.max(1, currentMaxInQueue) + 1;
                break;
            }
            if (computePossibleBestCase(findMaximas(queue), currentMaxInQueue) >= currentMaxInQueue) {
                runningTime += currentMaxInQueue;
                break;
            }

            runningTime++;
        }
        return runningTime;
    }

    public static void main(String[] args) throws Exception {
        System.setIn(new FileInputStream(INPUT));
        System.setOut(new PrintStream(new FileOutputStream(OUTPUT)));
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            int dinersNum = in.nextInt();
            PriorityQueue<Integer> sortedDinersPancakes = new PriorityQueue();
            for (int i = 0; i < dinersNum; i++) {
                sortedDinersPancakes.add(REVERSE_QUEUE_ORDERING_TRICK - in.nextInt());
            }
            System.out.printf("Case #%d: %d%n", caseNum, calculateBreakfastRunningTime(sortedDinersPancakes));
        }
    }
}
