package com.google.contest1a;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.PrintStream;
import java.util.Arrays;
import java.util.Comparator;
import java.util.Scanner;
import java.util.TreeSet;

public class B {

    private static final String INPUT = "/home/ckaratza/codejam2016/B/test-min.in";
    private static final String OUTPUT = "/home/ckaratza/codejam2016/B/test-min.out";

    public static void main(String[] args) throws FileNotFoundException {
        System.setIn(new FileInputStream(INPUT));
        System.setOut(new PrintStream(new FileOutputStream(OUTPUT)));
        Scanner in = new Scanner(System.in);
        int T = in.nextInt();
        for (int caseNum = 1; caseNum <= T; caseNum++) {
            int N = in.nextInt();
            int[][] input = new int[2 * N - 1][N];
            for (int i = 0; i < 2 * N - 1; i++) {
                for (int j = 0; j < N; j++) {
                    input[i][j] = in.nextInt();
                }
            }
            Arrays.sort(input, new Comparator<int[]>() {
                @Override
                public int compare(int[] o1, int[] o2) {
                    for (int i = 0; i < o1.length; i++) {
                        if (o1[i] != o2[i]) {
                            return o1[i] > o2[i] ? 1 : -1;
                        }
                    }
                    return 0;
                }
            });
            System.out.printf("Case #%d: %s\n", caseNum, produceMissingSequence(input, N));
        }
    }

    public static String produceMissingSequence(int[][] input, int N) {

        StringBuilder sb = new StringBuilder();
        TreeSet<Integer> traversed = new TreeSet<>();
        for (int i = 0; i < input.length; i++) {
            for (int j = i + 1; j < input.length; j++) {
                if (!haveCommonHeights(input[i], input[j])) {
                    traversed.add(i);
                    traversed.add(j);
                    i = j;
                    break;
                }
            }
        }


        Integer last = traversed.last();
        int[] minIncomplete = {};
        for (Integer i = last - 1; i >= 0; i--) {
            if (!traversed.contains(i)) {
                minIncomplete = input[i];
                break;
            }
        }

        for (int x : traversed) {
            sb.append(input[x][N - 1]).append(" ");
        }

        return sb.toString();
    }

    private static boolean haveCommonHeights(int[] ones, int[] twos) {
        int x = 0;
        for (int i : ones) {
            if (i == twos[x++]) {
                return true;
            }
        }
        return false;
    }
}
