import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

public class BathroomStalls {
	public static void main(String[] args) throws IOException {
		int T;
		int N, K;
		String input[];
		String result = "";

		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		T = Integer.parseInt(br.readLine());

		for (int t = 0; t < T; t++) {
			input = br.readLine().split(" ");
			N = Integer.parseInt(input[0]);
			K = Integer.parseInt(input[1]);

			result = MaxMin(N, K);
			System.out.println("Case #" + (t + 1) + ": " + result);
		}
	}

	public static String MaxMin(int N, int K) {
		String result = "";
		long min = 0, max = 0;
		int S[] = new int[N + 2];
		int LS[] = new int[N + 2];
		int RS[] = new int[N + 2];
		int stallIndex = 0, stallValue;

		S[0] = S[N + 1] = 1;

		for (int k = 1; k <= K; k++) {
			LS[0] = -1;
			for (int i = 1; i < N + 2; i++) {
				if (S[i] == 1)
					LS[i] = -1;
				else
					LS[i] = LS[i - 1] + 1;
			}

			RS[N + 1] = -1;
			for (int i = N; i >= 0; i--) {
				if (S[i] == 1)
					RS[i] = -1;
				else
					RS[i] = RS[i + 1] + 1;
			}

			stallIndex = 0;
			stallValue = Math.min(LS[0], RS[0]);
			for (int i = 1; i < N + 2; i++) {
				if (Math.min(LS[i], RS[i]) > stallValue) {
					stallValue = Math.min(LS[i], RS[i]);
					stallIndex = i;
				} else if (Math.min(LS[i], RS[i]) == stallValue) {
					if (Math.max(LS[i], RS[i]) > Math.max(LS[stallIndex], RS[stallIndex])) {
						stallIndex = i;
					} else if (Math.max(LS[i], RS[i]) == Math.max(LS[stallIndex], RS[stallIndex])) {
						// do nothing leftmost index is already chosen
					}
				}
			}
			S[stallIndex] = 1;
			max = Math.max(LS[stallIndex], RS[stallIndex]);
			min = Math.min(LS[stallIndex], RS[stallIndex]);
		}

		result = "" + max + " " + min;
		return result;
	}
}
