import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.Arrays;
import java.util.Comparator;

public class StableNeighbours {
	public static void main(String[] args) throws IOException {
		int T;
		int N, R, O, Y, G, B, V;
		int K[], S[];
		String input[];
		String result;

		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));

		T = Integer.parseInt(br.readLine());

		for (int t = 0; t < T; t++) {
			input = br.readLine().split(" ");
			N = Integer.parseInt(input[0]);
			R = Integer.parseInt(input[1]);
			O = Integer.parseInt(input[2]);
			Y = Integer.parseInt(input[3]);
			G = Integer.parseInt(input[4]);
			B = Integer.parseInt(input[5]);
			V = Integer.parseInt(input[6]);

			result = Arrangement(N, R, O, Y, G, B, V);
			System.out.println("Case #" + (t + 1) + ": " + result);
		}
	}

	public static class Pair {
		int x;
		char ch;

		public Pair(int x, char ch) {
			this.x = x;
			this.ch = ch;
		}
	}

	public static String Arrangement(int N, int R, int O, int Y, int G, int B, int V) {
		String result = "";
		int arr[] = new int[] { R, O, Y, G, B, V };
		char ch[] = new char[] { 'R', 'O', 'Y', 'G', 'B', 'V' };
		int lastIndex = -1;

		Pair pair[] = new Pair[6];

		for (int j = 0; j < 6; j++) {
			pair[j] = new Pair(arr[j], ch[j]);
		}

		Arrays.sort(pair, comparator);

		for (int i = 0; i < N; i++) {
			int max = 0;
			int maxIndex = -1;
			for (int j = 0; j < 6; j++) {
				if (max < pair[j].x && lastIndex != j) {
					max = pair[j].x;
					maxIndex = j;
				}
			}

			if (maxIndex == -1)
				return "IMPOSSIBLE";

			lastIndex = maxIndex;
			pair[maxIndex].x--;

			result += "" + pair[maxIndex].ch;

			if (i == N - 1 && result.charAt(0) == pair[maxIndex].ch) {
				return "IMPOSSIBLE";
			}
		}

		return result;
	}

	public static Comparator<Pair> comparator = new Comparator<Pair>() {
		public int compare(Pair p1, Pair p2) {
			return p2.x - p1.x;
		}
	};
}

// 1 0 2 0 3 0 : BYBRYB BYBYBR

// 474 224 0 4 0 246 0 --- Array index out of bounds