import java.io.PrintStream;
import java.util.*;

public class Main {

    private String solve(Scanner scanner) {
        return solveLarge(scanner);
    }

    private String solveLarge(Scanner scanner) {
        int n=scanner.nextInt(), m=scanner.nextInt();
        char[][] origin=new char[n][n];

        while (m-->0) {
            String s=scanner.next();
            int r=scanner.nextInt(), c=scanner.nextInt();
            origin[r-1][c-1]=s.charAt(0);
        }

        if (n==1) {
            String val="2";
            if (origin[0][0]!='o') {
                val+=" 1\no 1 1";
            }
            else val+=" 0";
            return val;
        }

        char[][] board1=calTopBottom(origin, n),
                board2=calLeftRight(origin, n);
        int score1=calScore(new ArrayList<>(), n, board1, origin),
                score2=calScore(new ArrayList<>(), n, board2, origin);

        int score=0;
        ArrayList<String> arrayList=new ArrayList<>();
        if (score1>score2)
            score=calScore(arrayList, n, board1, origin);
        else score=calScore(arrayList, n, board2, origin);
        if (n>1 && score!=3*n-2) System.err.println("ERROR! n="+n);
        arrayList.add(0, score+" "+arrayList.size());
        return String.join("\n", arrayList);
    }

    private char[][] calTopBottom(char[][] origin, int n) {
        char[][] board=copy(origin, n);
        for (int j: new int[] {0, n-1}) {
            for (int i=0;i<n;i++) {
                updatePlus(board, n, i, j);
            }
        }
        return calMulti(board, n);
    }

    private char[][] calLeftRight(char[][] origin, int n) {
        char[][] board=copy(origin, n);
        for (int i: new int[] {0, n-1}) {
            for (int j=0;j<n;j++) {
                updatePlus(board, n, i, j);
            }
        }
        return calMulti(board, n);
    }

    private char[][] copy(char[][] origin, int n)  {
        char[][] board=new char[n][n];
        for (int i=0;i<n;i++)
            for (int j=0;j<n;j++)
                board[i][j]=origin[i][j];
        return board;
    }

    private char[][] calMulti(char[][] board, int n) {
        for (int i=0;i<n;i++) {
            for (int j=0;j<n;j++) {
                if (ableMulti(board, n, i, j)) {
                    if (board[i][j]==0)
                        board[i][j]='x';
                    else if (board[i][j]=='+')
                        board[i][j]='o';
                }
            }
        }
        return board;
    }

    private void updatePlus(char[][] board, int n, int i, int j) {
        if (ablePlus(board, n, i, j)) {
            if (board[i][j]==0)
                board[i][j]='+';
            else if (board[i][j]=='x')
                board[i][j]='o';
        }
    }

    private boolean ablePlus(char[][] board, int n, int r, int c) {
        for (int x: new int[] {-1, 1}) {
            for (int i=-n;i<=n;i++) {
                int nr=r+i, nc=c+x*i;
                if (nr<0 || nr>=n || nc<0 || nc>=n || i==0) continue;
                if (board[nr][nc]=='+' || board[nr][nc]=='o') return false;
            }
        }
        return true;
    }

    private boolean ableMulti(char[][] board, int n, int r, int c) {
        for (int i=0;i<n;i++) {
            if (i!=r && (board[i][c]=='x' || board[i][c]=='o')) return false;
            if (i!=c && (board[r][i]=='x' || board[r][i]=='o')) return false;
        }
        return true;
    }

    private String solveSmall(Scanner scanner) {
        int n=scanner.nextInt(), m=scanner.nextInt();
        char[][] origin=new char[n][n];

        while (m-->0) {
            String s=scanner.next();
            int r=scanner.nextInt(), c=scanner.nextInt();
            origin[r-1][c-1]=s.charAt(0);
        }
        char[][] board=new char[n][n];
        int oindex=-1;
        for (int i=0;i<n;i++) {
            board[0][i]=origin[0][i];
            if (board[0][i]=='x' || board[0][i]=='o'
                    || (i==n-1 && oindex==-1)) {
                board[0][i]='o';
                oindex=i;
            }
            if (board[0][i]==0) board[0][i]='+';
        }
        if (n>1) {
            for (int i=1;i<n-1;i++)
                board[n-1][i]='+';
            for (int i=n-1;i>0;i--) {
                if (oindex==i)
                    board[i][0]='x';
                else board[i][i]='x';
            }

        }
        ArrayList<String> arrayList=new ArrayList<>();
        int score=calScore(arrayList, n, board, origin);
        if (n>1 && score!=3*n-2) System.err.println("ERROR!");
        arrayList.add(0, score+" "+arrayList.size());
        return String.join("\n", arrayList);
    }

    private int calScore(ArrayList<String> arrayList, int n, char[][] board, char[][] origin) {
        int score=0;
        for (int i=0;i<n;i++) {
            for (int j=0;j<n;j++) {
                if (board[i][j]=='+' || board[i][j]=='x') score++;
                if (board[i][j]=='o') score+=2;
                if (board[i][j]!=origin[i][j])
                    arrayList.add(board[i][j]+" "+(i+1)+" "+(j+1));
            }
        }
        return score;
    }


    public static void main(String[] args) throws Exception {
        System.setOut(new PrintStream("output.txt"));
        Scanner scanner=new Scanner(System.in);
        int times=scanner.nextInt();
        long start=System.currentTimeMillis();
        for (int t=1;t<=times;t++) {
            System.out.println(String.format("Case #%d: %s", t, new Main().solve(scanner)));
        }
        long end=System.currentTimeMillis();
        System.err.println(String.format("Time used: %.3fs", (end-start)/1000.0));

    }

}