import java.io.PrintStream;
import java.util.*;

public class Main {

    private String solve(Scanner scanner) {
        int n=scanner.nextInt(), k=scanner.nextInt();
        return solveSmall(n,k);
    }

    private String solveSmall(int n, int k) {
        PriorityQueue<Integer> priorityQueue=new PriorityQueue<>((o1,o2)->o2-o1);
        priorityQueue.offer(n);
        for (int i=1;i<=k;i++) {
            int u=priorityQueue.poll(), a=u/2, b=u-1-a;
            if (i==k) return Math.max(a, b)+" "+Math.min(a, b);
            priorityQueue.offer(a);
            priorityQueue.offer(b);
        }
        return "";
    }


    public static void main(String[] args) throws Exception {
        System.setOut(new PrintStream("output.txt"));
        Scanner scanner=new Scanner(System.in);
        int times=scanner.nextInt();
        long start=System.currentTimeMillis();
        for (int t=1;t<=times;t++) {
            System.out.println(String.format("Case #%d: %s", t, new Main().solve(scanner)));
        }
        long end=System.currentTimeMillis();
        System.err.println(String.format("Time used: %.3fs", (end-start)/1000.0));

    }

}