import java.io.PrintStream;
import java.util.*;

public class Main {

    private String solve(Scanner scanner) {
        return solveSmall(scanner);
    }

    private String solveSmall(Scanner scanner) {
        int n=scanner.nextInt(), m=scanner.nextInt();
        char[][] origin=new char[n][n];

        while (m-->0) {
            String s=scanner.next();
            int r=scanner.nextInt(), c=scanner.nextInt();
            origin[r-1][c-1]=s.charAt(0);
        }
        char[][] board=new char[n][n];
        int oindex=-1;
        for (int i=0;i<n;i++) {
            board[0][i]=origin[0][i];
            if (board[0][i]=='x' || board[0][i]=='o'
                    || (i==n-1 && oindex==-1)) {
                board[0][i]='o';
                oindex=i;
            }
            if (board[0][i]==0) board[0][i]='+';
        }
        if (n>1) {
            for (int i=1;i<n-1;i++)
                board[n-1][i]='+';
            for (int i=n-1;i>0;i--) {
                if (oindex==i)
                    board[i][0]='x';
                else board[i][i]='x';
            }

        }
        int score=0;
        ArrayList<String> arrayList=new ArrayList<>();
        for (int i=0;i<n;i++) {
            for (int j=0;j<n;j++) {
                if (board[i][j]=='+' || board[i][j]=='x') score++;
                if (board[i][j]=='o') score+=2;
                if (board[i][j]!=origin[i][j])
                    arrayList.add(board[i][j]+" "+(i+1)+" "+(j+1));
            }
        }
        if (n>1 && score!=3*n-2) System.err.println("ERROR!");
        arrayList.add(0, score+" "+arrayList.size());
        return String.join("\n", arrayList);
    }


    public static void main(String[] args) throws Exception {
        System.setOut(new PrintStream("output.txt"));
        Scanner scanner=new Scanner(System.in);
        int times=scanner.nextInt();
        long start=System.currentTimeMillis();
        for (int t=1;t<=times;t++) {
            System.out.println(String.format("Case #%d: %s", t, new Main().solve(scanner)));
        }
        long end=System.currentTimeMillis();
        System.err.println(String.format("Time used: %.3fs", (end-start)/1000.0));

    }

}